#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
# pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 5271
#define LARGE_STATE_COUNT 3028
#define SYMBOL_COUNT 134
#define ALIAS_COUNT 1
#define TOKEN_COUNT 79
#define EXTERNAL_TOKEN_COUNT 12
#define FIELD_COUNT 20
#define MAX_ALIAS_SEQUENCE_LENGTH 9
#define PRODUCTION_ID_COUNT 56

enum ts_symbol_identifiers {
  sym_identifier = 1,
  anon_sym_BSLASH = 2,
  anon_sym_function = 3,
  anon_sym_EQ = 4,
  anon_sym_if = 5,
  anon_sym_for = 6,
  anon_sym_in = 7,
  anon_sym_while = 8,
  anon_sym_repeat = 9,
  anon_sym_QMARK = 10,
  anon_sym_TILDE = 11,
  anon_sym_BANG = 12,
  anon_sym_PLUS = 13,
  anon_sym_DASH = 14,
  anon_sym_LT_DASH = 15,
  anon_sym_LT_LT_DASH = 16,
  anon_sym_COLON_EQ = 17,
  anon_sym_DASH_GT = 18,
  anon_sym_DASH_GT_GT = 19,
  anon_sym_PIPE = 20,
  anon_sym_AMP = 21,
  anon_sym_PIPE_PIPE = 22,
  anon_sym_AMP_AMP = 23,
  anon_sym_LT = 24,
  anon_sym_LT_EQ = 25,
  anon_sym_GT = 26,
  anon_sym_GT_EQ = 27,
  anon_sym_EQ_EQ = 28,
  anon_sym_BANG_EQ = 29,
  anon_sym_STAR = 30,
  anon_sym_SLASH = 31,
  anon_sym_STAR_STAR = 32,
  anon_sym_CARET = 33,
  aux_sym_binary_operator_token1 = 34,
  anon_sym_PIPE_GT = 35,
  anon_sym_COLON = 36,
  anon_sym_DOLLAR = 37,
  anon_sym_AT = 38,
  anon_sym_COLON_COLON = 39,
  anon_sym_COLON_COLON_COLON = 40,
  anon_sym_L = 41,
  anon_sym_i = 42,
  aux_sym__hex_literal_token1 = 43,
  sym__number_literal = 44,
  anon_sym_SQUOTE = 45,
  anon_sym_DQUOTE = 46,
  aux_sym__single_quoted_string_content_token1 = 47,
  aux_sym__double_quoted_string_content_token1 = 48,
  sym_escape_sequence = 49,
  sym_return = 50,
  sym_next = 51,
  sym_break = 52,
  sym_true = 53,
  sym_false = 54,
  sym_null = 55,
  sym_inf = 56,
  sym_nan = 57,
  anon_sym_NA = 58,
  anon_sym_NA_integer_ = 59,
  anon_sym_NA_real_ = 60,
  anon_sym_NA_complex_ = 61,
  anon_sym_NA_character_ = 62,
  sym_dots = 63,
  sym_dot_dot_i = 64,
  sym_comment = 65,
  sym_comma = 66,
  sym__newline = 67,
  sym__semicolon = 68,
  sym__raw_string_literal = 69,
  sym__external_else = 70,
  sym__external_open_parenthesis = 71,
  sym__external_close_parenthesis = 72,
  sym__external_open_brace = 73,
  sym__external_close_brace = 74,
  sym__external_open_bracket = 75,
  sym__external_close_bracket = 76,
  sym__external_open_bracket2 = 77,
  sym__external_close_bracket2 = 78,
  sym_program = 79,
  sym_function_definition = 80,
  sym_parameters = 81,
  sym_parameter = 82,
  sym__parameter_with_default = 83,
  sym__parameter_without_default = 84,
  sym_if_statement = 85,
  sym_for_statement = 86,
  sym_while_statement = 87,
  sym_repeat_statement = 88,
  sym_braced_expression = 89,
  sym_parenthesized_expression = 90,
  sym_call = 91,
  sym_subset = 92,
  sym_subset2 = 93,
  sym_call_arguments = 94,
  sym_subset_arguments = 95,
  sym_subset2_arguments = 96,
  sym__argument = 97,
  sym_argument = 98,
  sym__argument_named = 99,
  sym__argument_unnamed = 100,
  sym__argument_value = 101,
  sym_unary_operator = 102,
  sym_binary_operator = 103,
  sym_extract_operator = 104,
  sym_namespace_operator = 105,
  sym_integer = 106,
  sym_complex = 107,
  sym_float = 108,
  sym__hex_literal = 109,
  sym__float_literal = 110,
  sym_string = 111,
  sym__single_quoted_string = 112,
  sym__double_quoted_string = 113,
  aux_sym__single_quoted_string_content = 114,
  aux_sym__double_quoted_string_content = 115,
  sym_na = 116,
  sym__expression = 117,
  sym__string_or_identifier = 118,
  sym__else = 119,
  sym__open_parenthesis = 120,
  sym__close_parenthesis = 121,
  sym__open_brace = 122,
  sym__close_brace = 123,
  sym__open_bracket = 124,
  sym__close_bracket = 125,
  sym__open_bracket2 = 126,
  sym__close_bracket2 = 127,
  aux_sym_program_repeat1 = 128,
  aux_sym_function_definition_repeat1 = 129,
  aux_sym_parameters_repeat1 = 130,
  aux_sym_braced_expression_repeat1 = 131,
  aux_sym_parenthesized_expression_repeat1 = 132,
  aux_sym_call_arguments_repeat1 = 133,
  alias_sym_string_content = 134,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [anon_sym_BSLASH] = "\\",
  [anon_sym_function] = "function",
  [anon_sym_EQ] = "=",
  [anon_sym_if] = "if",
  [anon_sym_for] = "for",
  [anon_sym_in] = "in",
  [anon_sym_while] = "while",
  [anon_sym_repeat] = "repeat",
  [anon_sym_QMARK] = "\?",
  [anon_sym_TILDE] = "~",
  [anon_sym_BANG] = "!",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_LT_DASH] = "<-",
  [anon_sym_LT_LT_DASH] = "<<-",
  [anon_sym_COLON_EQ] = ":=",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_DASH_GT_GT] = "->>",
  [anon_sym_PIPE] = "|",
  [anon_sym_AMP] = "&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_LT] = "<",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_GT] = ">",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_STAR] = "*",
  [anon_sym_SLASH] = "/",
  [anon_sym_STAR_STAR] = "**",
  [anon_sym_CARET] = "^",
  [aux_sym_binary_operator_token1] = "special",
  [anon_sym_PIPE_GT] = "|>",
  [anon_sym_COLON] = ":",
  [anon_sym_DOLLAR] = "$",
  [anon_sym_AT] = "@",
  [anon_sym_COLON_COLON] = "::",
  [anon_sym_COLON_COLON_COLON] = ":::",
  [anon_sym_L] = "L",
  [anon_sym_i] = "i",
  [aux_sym__hex_literal_token1] = "_hex_literal_token1",
  [sym__number_literal] = "_number_literal",
  [anon_sym_SQUOTE] = "'",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym__single_quoted_string_content_token1] = "_single_quoted_string_content_token1",
  [aux_sym__double_quoted_string_content_token1] = "_double_quoted_string_content_token1",
  [sym_escape_sequence] = "escape_sequence",
  [sym_return] = "return",
  [sym_next] = "next",
  [sym_break] = "break",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_null] = "null",
  [sym_inf] = "inf",
  [sym_nan] = "nan",
  [anon_sym_NA] = "NA",
  [anon_sym_NA_integer_] = "NA_integer_",
  [anon_sym_NA_real_] = "NA_real_",
  [anon_sym_NA_complex_] = "NA_complex_",
  [anon_sym_NA_character_] = "NA_character_",
  [sym_dots] = "dots",
  [sym_dot_dot_i] = "dot_dot_i",
  [sym_comment] = "comment",
  [sym_comma] = "comma",
  [sym__newline] = "_newline",
  [sym__semicolon] = "_semicolon",
  [sym__raw_string_literal] = "_raw_string_literal",
  [sym__external_else] = "else",
  [sym__external_open_parenthesis] = "(",
  [sym__external_close_parenthesis] = ")",
  [sym__external_open_brace] = "{",
  [sym__external_close_brace] = "}",
  [sym__external_open_bracket] = "[",
  [sym__external_close_bracket] = "]",
  [sym__external_open_bracket2] = "[[",
  [sym__external_close_bracket2] = "]]",
  [sym_program] = "program",
  [sym_function_definition] = "function_definition",
  [sym_parameters] = "parameters",
  [sym_parameter] = "parameter",
  [sym__parameter_with_default] = "_parameter_with_default",
  [sym__parameter_without_default] = "_parameter_without_default",
  [sym_if_statement] = "if_statement",
  [sym_for_statement] = "for_statement",
  [sym_while_statement] = "while_statement",
  [sym_repeat_statement] = "repeat_statement",
  [sym_braced_expression] = "braced_expression",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_call] = "call",
  [sym_subset] = "subset",
  [sym_subset2] = "subset2",
  [sym_call_arguments] = "arguments",
  [sym_subset_arguments] = "arguments",
  [sym_subset2_arguments] = "arguments",
  [sym__argument] = "_argument",
  [sym_argument] = "argument",
  [sym__argument_named] = "_argument_named",
  [sym__argument_unnamed] = "_argument_unnamed",
  [sym__argument_value] = "_argument_value",
  [sym_unary_operator] = "unary_operator",
  [sym_binary_operator] = "binary_operator",
  [sym_extract_operator] = "extract_operator",
  [sym_namespace_operator] = "namespace_operator",
  [sym_integer] = "integer",
  [sym_complex] = "complex",
  [sym_float] = "float",
  [sym__hex_literal] = "_hex_literal",
  [sym__float_literal] = "_float_literal",
  [sym_string] = "string",
  [sym__single_quoted_string] = "_single_quoted_string",
  [sym__double_quoted_string] = "_double_quoted_string",
  [aux_sym__single_quoted_string_content] = "_single_quoted_string_content",
  [aux_sym__double_quoted_string_content] = "_double_quoted_string_content",
  [sym_na] = "na",
  [sym__expression] = "_expression",
  [sym__string_or_identifier] = "_string_or_identifier",
  [sym__else] = "_else",
  [sym__open_parenthesis] = "_open_parenthesis",
  [sym__close_parenthesis] = "_close_parenthesis",
  [sym__open_brace] = "_open_brace",
  [sym__close_brace] = "_close_brace",
  [sym__open_bracket] = "_open_bracket",
  [sym__close_bracket] = "_close_bracket",
  [sym__open_bracket2] = "_open_bracket2",
  [sym__close_bracket2] = "_close_bracket2",
  [aux_sym_program_repeat1] = "program_repeat1",
  [aux_sym_function_definition_repeat1] = "function_definition_repeat1",
  [aux_sym_parameters_repeat1] = "parameters_repeat1",
  [aux_sym_braced_expression_repeat1] = "braced_expression_repeat1",
  [aux_sym_parenthesized_expression_repeat1] = "parenthesized_expression_repeat1",
  [aux_sym_call_arguments_repeat1] = "call_arguments_repeat1",
  [alias_sym_string_content] = "string_content",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [anon_sym_BSLASH] = anon_sym_BSLASH,
  [anon_sym_function] = anon_sym_function,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_repeat] = anon_sym_repeat,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_LT_DASH] = anon_sym_LT_DASH,
  [anon_sym_LT_LT_DASH] = anon_sym_LT_LT_DASH,
  [anon_sym_COLON_EQ] = anon_sym_COLON_EQ,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [anon_sym_DASH_GT_GT] = anon_sym_DASH_GT_GT,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_STAR_STAR] = anon_sym_STAR_STAR,
  [anon_sym_CARET] = anon_sym_CARET,
  [aux_sym_binary_operator_token1] = aux_sym_binary_operator_token1,
  [anon_sym_PIPE_GT] = anon_sym_PIPE_GT,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_DOLLAR] = anon_sym_DOLLAR,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [anon_sym_COLON_COLON_COLON] = anon_sym_COLON_COLON_COLON,
  [anon_sym_L] = anon_sym_L,
  [anon_sym_i] = anon_sym_i,
  [aux_sym__hex_literal_token1] = aux_sym__hex_literal_token1,
  [sym__number_literal] = sym__number_literal,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [aux_sym__single_quoted_string_content_token1] = aux_sym__single_quoted_string_content_token1,
  [aux_sym__double_quoted_string_content_token1] = aux_sym__double_quoted_string_content_token1,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym_return] = sym_return,
  [sym_next] = sym_next,
  [sym_break] = sym_break,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [sym_null] = sym_null,
  [sym_inf] = sym_inf,
  [sym_nan] = sym_nan,
  [anon_sym_NA] = anon_sym_NA,
  [anon_sym_NA_integer_] = anon_sym_NA_integer_,
  [anon_sym_NA_real_] = anon_sym_NA_real_,
  [anon_sym_NA_complex_] = anon_sym_NA_complex_,
  [anon_sym_NA_character_] = anon_sym_NA_character_,
  [sym_dots] = sym_dots,
  [sym_dot_dot_i] = sym_dot_dot_i,
  [sym_comment] = sym_comment,
  [sym_comma] = sym_comma,
  [sym__newline] = sym__newline,
  [sym__semicolon] = sym__semicolon,
  [sym__raw_string_literal] = sym__raw_string_literal,
  [sym__external_else] = sym__external_else,
  [sym__external_open_parenthesis] = sym__external_open_parenthesis,
  [sym__external_close_parenthesis] = sym__external_close_parenthesis,
  [sym__external_open_brace] = sym__external_open_brace,
  [sym__external_close_brace] = sym__external_close_brace,
  [sym__external_open_bracket] = sym__external_open_bracket,
  [sym__external_close_bracket] = sym__external_close_bracket,
  [sym__external_open_bracket2] = sym__external_open_bracket2,
  [sym__external_close_bracket2] = sym__external_close_bracket2,
  [sym_program] = sym_program,
  [sym_function_definition] = sym_function_definition,
  [sym_parameters] = sym_parameters,
  [sym_parameter] = sym_parameter,
  [sym__parameter_with_default] = sym__parameter_with_default,
  [sym__parameter_without_default] = sym__parameter_without_default,
  [sym_if_statement] = sym_if_statement,
  [sym_for_statement] = sym_for_statement,
  [sym_while_statement] = sym_while_statement,
  [sym_repeat_statement] = sym_repeat_statement,
  [sym_braced_expression] = sym_braced_expression,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_call] = sym_call,
  [sym_subset] = sym_subset,
  [sym_subset2] = sym_subset2,
  [sym_call_arguments] = sym_call_arguments,
  [sym_subset_arguments] = sym_call_arguments,
  [sym_subset2_arguments] = sym_call_arguments,
  [sym__argument] = sym__argument,
  [sym_argument] = sym_argument,
  [sym__argument_named] = sym__argument_named,
  [sym__argument_unnamed] = sym__argument_unnamed,
  [sym__argument_value] = sym__argument_value,
  [sym_unary_operator] = sym_unary_operator,
  [sym_binary_operator] = sym_binary_operator,
  [sym_extract_operator] = sym_extract_operator,
  [sym_namespace_operator] = sym_namespace_operator,
  [sym_integer] = sym_integer,
  [sym_complex] = sym_complex,
  [sym_float] = sym_float,
  [sym__hex_literal] = sym__hex_literal,
  [sym__float_literal] = sym__float_literal,
  [sym_string] = sym_string,
  [sym__single_quoted_string] = sym__single_quoted_string,
  [sym__double_quoted_string] = sym__double_quoted_string,
  [aux_sym__single_quoted_string_content] = aux_sym__single_quoted_string_content,
  [aux_sym__double_quoted_string_content] = aux_sym__double_quoted_string_content,
  [sym_na] = sym_na,
  [sym__expression] = sym__expression,
  [sym__string_or_identifier] = sym__string_or_identifier,
  [sym__else] = sym__else,
  [sym__open_parenthesis] = sym__open_parenthesis,
  [sym__close_parenthesis] = sym__close_parenthesis,
  [sym__open_brace] = sym__open_brace,
  [sym__close_brace] = sym__close_brace,
  [sym__open_bracket] = sym__open_bracket,
  [sym__close_bracket] = sym__close_bracket,
  [sym__open_bracket2] = sym__open_bracket2,
  [sym__close_bracket2] = sym__close_bracket2,
  [aux_sym_program_repeat1] = aux_sym_program_repeat1,
  [aux_sym_function_definition_repeat1] = aux_sym_function_definition_repeat1,
  [aux_sym_parameters_repeat1] = aux_sym_parameters_repeat1,
  [aux_sym_braced_expression_repeat1] = aux_sym_braced_expression_repeat1,
  [aux_sym_parenthesized_expression_repeat1] = aux_sym_parenthesized_expression_repeat1,
  [aux_sym_call_arguments_repeat1] = aux_sym_call_arguments_repeat1,
  [alias_sym_string_content] = alias_sym_string_content,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BSLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_repeat] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_binary_operator_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_L] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_i] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__hex_literal_token1] = {
    .visible = false,
    .named = false,
  },
  [sym__number_literal] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__single_quoted_string_content_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__double_quoted_string_content_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_return] = {
    .visible = true,
    .named = true,
  },
  [sym_next] = {
    .visible = true,
    .named = true,
  },
  [sym_break] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_null] = {
    .visible = true,
    .named = true,
  },
  [sym_inf] = {
    .visible = true,
    .named = true,
  },
  [sym_nan] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_NA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_NA_integer_] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_NA_real_] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_NA_complex_] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_NA_character_] = {
    .visible = true,
    .named = false,
  },
  [sym_dots] = {
    .visible = true,
    .named = true,
  },
  [sym_dot_dot_i] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_comma] = {
    .visible = true,
    .named = true,
  },
  [sym__newline] = {
    .visible = false,
    .named = true,
  },
  [sym__semicolon] = {
    .visible = false,
    .named = true,
  },
  [sym__raw_string_literal] = {
    .visible = false,
    .named = true,
  },
  [sym__external_else] = {
    .visible = true,
    .named = false,
  },
  [sym__external_open_parenthesis] = {
    .visible = true,
    .named = false,
  },
  [sym__external_close_parenthesis] = {
    .visible = true,
    .named = false,
  },
  [sym__external_open_brace] = {
    .visible = true,
    .named = false,
  },
  [sym__external_close_brace] = {
    .visible = true,
    .named = false,
  },
  [sym__external_open_bracket] = {
    .visible = true,
    .named = false,
  },
  [sym__external_close_bracket] = {
    .visible = true,
    .named = false,
  },
  [sym__external_open_bracket2] = {
    .visible = true,
    .named = false,
  },
  [sym__external_close_bracket2] = {
    .visible = true,
    .named = false,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym__parameter_with_default] = {
    .visible = false,
    .named = true,
  },
  [sym__parameter_without_default] = {
    .visible = false,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_repeat_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_braced_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_call] = {
    .visible = true,
    .named = true,
  },
  [sym_subset] = {
    .visible = true,
    .named = true,
  },
  [sym_subset2] = {
    .visible = true,
    .named = true,
  },
  [sym_call_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_subset_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_subset2_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym__argument] = {
    .visible = false,
    .named = true,
  },
  [sym_argument] = {
    .visible = true,
    .named = true,
  },
  [sym__argument_named] = {
    .visible = false,
    .named = true,
  },
  [sym__argument_unnamed] = {
    .visible = false,
    .named = true,
  },
  [sym__argument_value] = {
    .visible = false,
    .named = true,
  },
  [sym_unary_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_extract_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_integer] = {
    .visible = true,
    .named = true,
  },
  [sym_complex] = {
    .visible = true,
    .named = true,
  },
  [sym_float] = {
    .visible = true,
    .named = true,
  },
  [sym__hex_literal] = {
    .visible = false,
    .named = true,
  },
  [sym__float_literal] = {
    .visible = false,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym__single_quoted_string] = {
    .visible = false,
    .named = true,
  },
  [sym__double_quoted_string] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__single_quoted_string_content] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__double_quoted_string_content] = {
    .visible = false,
    .named = false,
  },
  [sym_na] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
  },
  [sym__string_or_identifier] = {
    .visible = false,
    .named = true,
  },
  [sym__else] = {
    .visible = false,
    .named = true,
  },
  [sym__open_parenthesis] = {
    .visible = false,
    .named = true,
  },
  [sym__close_parenthesis] = {
    .visible = false,
    .named = true,
  },
  [sym__open_brace] = {
    .visible = false,
    .named = true,
  },
  [sym__close_brace] = {
    .visible = false,
    .named = true,
  },
  [sym__open_bracket] = {
    .visible = false,
    .named = true,
  },
  [sym__close_bracket] = {
    .visible = false,
    .named = true,
  },
  [sym__open_bracket2] = {
    .visible = false,
    .named = true,
  },
  [sym__close_bracket2] = {
    .visible = false,
    .named = true,
  },
  [aux_sym_program_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_function_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_braced_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parenthesized_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_call_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_string_content] = {
    .visible = true,
    .named = true,
  },
};

enum ts_field_identifiers {
  field_alternative = 1,
  field_argument = 2,
  field_arguments = 3,
  field_body = 4,
  field_close = 5,
  field_condition = 6,
  field_consequence = 7,
  field_content = 8,
  field_default = 9,
  field_function = 10,
  field_lhs = 11,
  field_name = 12,
  field_open = 13,
  field_operator = 14,
  field_parameter = 15,
  field_parameters = 16,
  field_rhs = 17,
  field_sequence = 18,
  field_value = 19,
  field_variable = 20,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alternative] = "alternative",
  [field_argument] = "argument",
  [field_arguments] = "arguments",
  [field_body] = "body",
  [field_close] = "close",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_content] = "content",
  [field_default] = "default",
  [field_function] = "function",
  [field_lhs] = "lhs",
  [field_name] = "name",
  [field_open] = "open",
  [field_operator] = "operator",
  [field_parameter] = "parameter",
  [field_parameters] = "parameters",
  [field_rhs] = "rhs",
  [field_sequence] = "sequence",
  [field_value] = "value",
  [field_variable] = "variable",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 1},
  [2] = {.index = 1, .length = 1},
  [3] = {.index = 2, .length = 2},
  [4] = {.index = 4, .length = 1},
  [5] = {.index = 5, .length = 2},
  [6] = {.index = 7, .length = 2},
  [7] = {.index = 9, .length = 2},
  [8] = {.index = 11, .length = 1},
  [9] = {.index = 12, .length = 2},
  [10] = {.index = 14, .length = 2},
  [11] = {.index = 16, .length = 3},
  [12] = {.index = 19, .length = 1},
  [13] = {.index = 20, .length = 2},
  [14] = {.index = 22, .length = 1},
  [15] = {.index = 23, .length = 1},
  [16] = {.index = 24, .length = 2},
  [17] = {.index = 26, .length = 1},
  [18] = {.index = 27, .length = 3},
  [19] = {.index = 30, .length = 1},
  [20] = {.index = 31, .length = 1},
  [21] = {.index = 32, .length = 1},
  [22] = {.index = 33, .length = 2},
  [23] = {.index = 35, .length = 1},
  [24] = {.index = 36, .length = 3},
  [25] = {.index = 39, .length = 2},
  [26] = {.index = 41, .length = 3},
  [27] = {.index = 44, .length = 3},
  [28] = {.index = 47, .length = 3},
  [29] = {.index = 50, .length = 3},
  [30] = {.index = 53, .length = 3},
  [31] = {.index = 56, .length = 2},
  [32] = {.index = 58, .length = 2},
  [33] = {.index = 60, .length = 1},
  [34] = {.index = 61, .length = 4},
  [35] = {.index = 65, .length = 2},
  [36] = {.index = 67, .length = 4},
  [37] = {.index = 71, .length = 4},
  [38] = {.index = 75, .length = 3},
  [39] = {.index = 78, .length = 2},
  [40] = {.index = 80, .length = 4},
  [41] = {.index = 84, .length = 4},
  [42] = {.index = 88, .length = 4},
  [43] = {.index = 92, .length = 4},
  [44] = {.index = 96, .length = 4},
  [45] = {.index = 100, .length = 5},
  [46] = {.index = 105, .length = 4},
  [47] = {.index = 109, .length = 5},
  [48] = {.index = 114, .length = 4},
  [49] = {.index = 118, .length = 4},
  [50] = {.index = 122, .length = 5},
  [51] = {.index = 127, .length = 5},
  [52] = {.index = 132, .length = 5},
  [53] = {.index = 137, .length = 5},
  [54] = {.index = 142, .length = 5},
  [55] = {.index = 147, .length = 5},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_content, 0, .inherited = true},
  [1] =
    {field_open, 0},
  [2] =
    {field_name, 0},
    {field_parameters, 1},
  [4] =
    {field_body, 1},
  [5] =
    {field_operator, 0},
    {field_rhs, 1},
  [7] =
    {field_lhs, 0},
    {field_operator, 1},
  [9] =
    {field_arguments, 1},
    {field_function, 0},
  [11] =
    {field_body, 0},
  [12] =
    {field_close, 1},
    {field_open, 0},
  [14] =
    {field_body, 1, .inherited = true},
    {field_open, 0},
  [16] =
    {field_body, 2},
    {field_name, 0},
    {field_parameters, 1},
  [19] =
    {field_name, 0},
  [20] =
    {field_default, 0, .inherited = true},
    {field_name, 0, .inherited = true},
  [22] =
    {field_name, 0, .inherited = true},
  [23] =
    {field_body, 2},
  [24] =
    {field_operator, 0},
    {field_rhs, 2},
  [26] =
    {field_content, 1},
  [27] =
    {field_lhs, 0},
    {field_operator, 1},
    {field_rhs, 2},
  [30] =
    {field_value, 0},
  [31] =
    {field_argument, 0, .inherited = true},
  [32] =
    {field_argument, 0},
  [33] =
    {field_name, 0, .inherited = true},
    {field_value, 0, .inherited = true},
  [35] =
    {field_value, 0, .inherited = true},
  [36] =
    {field_body, 1, .inherited = true},
    {field_close, 2},
    {field_open, 0},
  [39] =
    {field_body, 0, .inherited = true},
    {field_body, 1, .inherited = true},
  [41] =
    {field_body, 3},
    {field_name, 0},
    {field_parameters, 1},
  [44] =
    {field_close, 2},
    {field_open, 0},
    {field_parameter, 1},
  [47] =
    {field_close, 3},
    {field_condition, 2},
    {field_open, 1},
  [50] =
    {field_lhs, 0},
    {field_operator, 1},
    {field_rhs, 3},
  [53] =
    {field_argument, 1, .inherited = true},
    {field_close, 2},
    {field_open, 0},
  [56] =
    {field_argument, 0, .inherited = true},
    {field_argument, 1, .inherited = true},
  [58] =
    {field_default, 2},
    {field_name, 0},
  [60] =
    {field_parameter, 1},
  [61] =
    {field_close, 3},
    {field_open, 0},
    {field_parameter, 1},
    {field_parameter, 2, .inherited = true},
  [65] =
    {field_parameter, 0, .inherited = true},
    {field_parameter, 1, .inherited = true},
  [67] =
    {field_close, 3},
    {field_condition, 2},
    {field_consequence, 4},
    {field_open, 1},
  [71] =
    {field_body, 4},
    {field_close, 3},
    {field_condition, 2},
    {field_open, 1},
  [75] =
    {field_close, 4},
    {field_condition, 3},
    {field_open, 2},
  [78] =
    {field_name, 0},
    {field_value, 2, .inherited = true},
  [80] =
    {field_close, 3},
    {field_condition, 2},
    {field_consequence, 5},
    {field_open, 1},
  [84] =
    {field_close, 4},
    {field_condition, 3},
    {field_consequence, 5},
    {field_open, 2},
  [88] =
    {field_close, 5},
    {field_open, 1},
    {field_sequence, 4},
    {field_variable, 2},
  [92] =
    {field_body, 5},
    {field_close, 3},
    {field_condition, 2},
    {field_open, 1},
  [96] =
    {field_body, 5},
    {field_close, 4},
    {field_condition, 3},
    {field_open, 2},
  [100] =
    {field_alternative, 6},
    {field_close, 3},
    {field_condition, 2},
    {field_consequence, 4},
    {field_open, 1},
  [105] =
    {field_close, 4},
    {field_condition, 3},
    {field_consequence, 6},
    {field_open, 2},
  [109] =
    {field_body, 6},
    {field_close, 5},
    {field_open, 1},
    {field_sequence, 4},
    {field_variable, 2},
  [114] =
    {field_close, 6},
    {field_open, 2},
    {field_sequence, 5},
    {field_variable, 3},
  [118] =
    {field_body, 6},
    {field_close, 4},
    {field_condition, 3},
    {field_open, 2},
  [122] =
    {field_alternative, 7},
    {field_close, 3},
    {field_condition, 2},
    {field_consequence, 5},
    {field_open, 1},
  [127] =
    {field_alternative, 7},
    {field_close, 4},
    {field_condition, 3},
    {field_consequence, 5},
    {field_open, 2},
  [132] =
    {field_body, 7},
    {field_close, 5},
    {field_open, 1},
    {field_sequence, 4},
    {field_variable, 2},
  [137] =
    {field_body, 7},
    {field_close, 6},
    {field_open, 2},
    {field_sequence, 5},
    {field_variable, 3},
  [142] =
    {field_alternative, 8},
    {field_close, 4},
    {field_condition, 3},
    {field_consequence, 6},
    {field_open, 2},
  [147] =
    {field_body, 8},
    {field_close, 6},
    {field_open, 2},
    {field_sequence, 5},
    {field_variable, 3},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [17] = {
    [1] = alias_sym_string_content,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  aux_sym__single_quoted_string_content, 2,
    aux_sym__single_quoted_string_content,
    alias_sym_string_content,
  aux_sym__double_quoted_string_content, 2,
    aux_sym__double_quoted_string_content,
    alias_sym_string_content,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 4,
  [5] = 3,
  [6] = 6,
  [7] = 6,
  [8] = 6,
  [9] = 6,
  [10] = 4,
  [11] = 4,
  [12] = 2,
  [13] = 2,
  [14] = 3,
  [15] = 2,
  [16] = 4,
  [17] = 2,
  [18] = 4,
  [19] = 3,
  [20] = 3,
  [21] = 6,
  [22] = 22,
  [23] = 3,
  [24] = 4,
  [25] = 25,
  [26] = 26,
  [27] = 27,
  [28] = 28,
  [29] = 4,
  [30] = 30,
  [31] = 31,
  [32] = 32,
  [33] = 2,
  [34] = 2,
  [35] = 2,
  [36] = 36,
  [37] = 6,
  [38] = 38,
  [39] = 39,
  [40] = 2,
  [41] = 2,
  [42] = 4,
  [43] = 39,
  [44] = 6,
  [45] = 4,
  [46] = 46,
  [47] = 47,
  [48] = 2,
  [49] = 38,
  [50] = 6,
  [51] = 4,
  [52] = 2,
  [53] = 22,
  [54] = 3,
  [55] = 47,
  [56] = 4,
  [57] = 3,
  [58] = 58,
  [59] = 4,
  [60] = 46,
  [61] = 2,
  [62] = 6,
  [63] = 4,
  [64] = 3,
  [65] = 36,
  [66] = 39,
  [67] = 3,
  [68] = 2,
  [69] = 6,
  [70] = 4,
  [71] = 25,
  [72] = 32,
  [73] = 26,
  [74] = 4,
  [75] = 2,
  [76] = 3,
  [77] = 38,
  [78] = 36,
  [79] = 31,
  [80] = 22,
  [81] = 30,
  [82] = 31,
  [83] = 58,
  [84] = 6,
  [85] = 28,
  [86] = 30,
  [87] = 46,
  [88] = 27,
  [89] = 26,
  [90] = 25,
  [91] = 32,
  [92] = 27,
  [93] = 2,
  [94] = 4,
  [95] = 58,
  [96] = 28,
  [97] = 4,
  [98] = 2,
  [99] = 47,
  [100] = 46,
  [101] = 47,
  [102] = 6,
  [103] = 2,
  [104] = 6,
  [105] = 2,
  [106] = 2,
  [107] = 2,
  [108] = 22,
  [109] = 38,
  [110] = 39,
  [111] = 47,
  [112] = 6,
  [113] = 46,
  [114] = 36,
  [115] = 25,
  [116] = 26,
  [117] = 27,
  [118] = 28,
  [119] = 3,
  [120] = 3,
  [121] = 2,
  [122] = 30,
  [123] = 58,
  [124] = 39,
  [125] = 31,
  [126] = 6,
  [127] = 32,
  [128] = 22,
  [129] = 38,
  [130] = 47,
  [131] = 46,
  [132] = 36,
  [133] = 4,
  [134] = 25,
  [135] = 26,
  [136] = 2,
  [137] = 27,
  [138] = 58,
  [139] = 58,
  [140] = 28,
  [141] = 30,
  [142] = 2,
  [143] = 31,
  [144] = 32,
  [145] = 39,
  [146] = 2,
  [147] = 3,
  [148] = 6,
  [149] = 22,
  [150] = 3,
  [151] = 22,
  [152] = 38,
  [153] = 4,
  [154] = 4,
  [155] = 38,
  [156] = 47,
  [157] = 46,
  [158] = 36,
  [159] = 39,
  [160] = 25,
  [161] = 26,
  [162] = 27,
  [163] = 36,
  [164] = 28,
  [165] = 25,
  [166] = 26,
  [167] = 30,
  [168] = 31,
  [169] = 32,
  [170] = 6,
  [171] = 27,
  [172] = 28,
  [173] = 4,
  [174] = 30,
  [175] = 31,
  [176] = 6,
  [177] = 32,
  [178] = 3,
  [179] = 22,
  [180] = 4,
  [181] = 38,
  [182] = 47,
  [183] = 46,
  [184] = 2,
  [185] = 4,
  [186] = 36,
  [187] = 25,
  [188] = 4,
  [189] = 26,
  [190] = 3,
  [191] = 3,
  [192] = 4,
  [193] = 27,
  [194] = 28,
  [195] = 39,
  [196] = 30,
  [197] = 31,
  [198] = 32,
  [199] = 4,
  [200] = 3,
  [201] = 22,
  [202] = 32,
  [203] = 6,
  [204] = 6,
  [205] = 28,
  [206] = 27,
  [207] = 26,
  [208] = 25,
  [209] = 36,
  [210] = 3,
  [211] = 30,
  [212] = 46,
  [213] = 3,
  [214] = 3,
  [215] = 47,
  [216] = 28,
  [217] = 38,
  [218] = 3,
  [219] = 46,
  [220] = 31,
  [221] = 32,
  [222] = 27,
  [223] = 31,
  [224] = 30,
  [225] = 28,
  [226] = 27,
  [227] = 26,
  [228] = 25,
  [229] = 36,
  [230] = 46,
  [231] = 26,
  [232] = 22,
  [233] = 32,
  [234] = 30,
  [235] = 47,
  [236] = 58,
  [237] = 38,
  [238] = 22,
  [239] = 31,
  [240] = 30,
  [241] = 28,
  [242] = 27,
  [243] = 26,
  [244] = 4,
  [245] = 58,
  [246] = 3,
  [247] = 32,
  [248] = 25,
  [249] = 31,
  [250] = 38,
  [251] = 36,
  [252] = 32,
  [253] = 31,
  [254] = 30,
  [255] = 28,
  [256] = 27,
  [257] = 26,
  [258] = 25,
  [259] = 36,
  [260] = 46,
  [261] = 36,
  [262] = 39,
  [263] = 38,
  [264] = 22,
  [265] = 47,
  [266] = 32,
  [267] = 31,
  [268] = 30,
  [269] = 28,
  [270] = 6,
  [271] = 58,
  [272] = 27,
  [273] = 26,
  [274] = 25,
  [275] = 25,
  [276] = 22,
  [277] = 46,
  [278] = 36,
  [279] = 39,
  [280] = 6,
  [281] = 47,
  [282] = 2,
  [283] = 6,
  [284] = 22,
  [285] = 2,
  [286] = 6,
  [287] = 3,
  [288] = 47,
  [289] = 38,
  [290] = 38,
  [291] = 47,
  [292] = 4,
  [293] = 3,
  [294] = 39,
  [295] = 6,
  [296] = 6,
  [297] = 46,
  [298] = 30,
  [299] = 25,
  [300] = 25,
  [301] = 36,
  [302] = 46,
  [303] = 31,
  [304] = 47,
  [305] = 38,
  [306] = 22,
  [307] = 58,
  [308] = 28,
  [309] = 30,
  [310] = 30,
  [311] = 31,
  [312] = 32,
  [313] = 32,
  [314] = 28,
  [315] = 27,
  [316] = 26,
  [317] = 25,
  [318] = 36,
  [319] = 46,
  [320] = 22,
  [321] = 47,
  [322] = 38,
  [323] = 32,
  [324] = 32,
  [325] = 31,
  [326] = 30,
  [327] = 31,
  [328] = 30,
  [329] = 28,
  [330] = 58,
  [331] = 27,
  [332] = 28,
  [333] = 6,
  [334] = 38,
  [335] = 47,
  [336] = 46,
  [337] = 27,
  [338] = 46,
  [339] = 36,
  [340] = 36,
  [341] = 26,
  [342] = 25,
  [343] = 25,
  [344] = 26,
  [345] = 27,
  [346] = 28,
  [347] = 30,
  [348] = 22,
  [349] = 31,
  [350] = 3,
  [351] = 38,
  [352] = 47,
  [353] = 32,
  [354] = 22,
  [355] = 46,
  [356] = 38,
  [357] = 47,
  [358] = 36,
  [359] = 25,
  [360] = 26,
  [361] = 27,
  [362] = 38,
  [363] = 28,
  [364] = 25,
  [365] = 26,
  [366] = 22,
  [367] = 30,
  [368] = 31,
  [369] = 32,
  [370] = 27,
  [371] = 36,
  [372] = 39,
  [373] = 22,
  [374] = 28,
  [375] = 38,
  [376] = 47,
  [377] = 32,
  [378] = 31,
  [379] = 30,
  [380] = 46,
  [381] = 31,
  [382] = 28,
  [383] = 27,
  [384] = 26,
  [385] = 25,
  [386] = 36,
  [387] = 46,
  [388] = 32,
  [389] = 36,
  [390] = 47,
  [391] = 38,
  [392] = 22,
  [393] = 22,
  [394] = 25,
  [395] = 26,
  [396] = 27,
  [397] = 27,
  [398] = 26,
  [399] = 26,
  [400] = 36,
  [401] = 28,
  [402] = 3,
  [403] = 30,
  [404] = 38,
  [405] = 31,
  [406] = 47,
  [407] = 46,
  [408] = 32,
  [409] = 58,
  [410] = 47,
  [411] = 22,
  [412] = 46,
  [413] = 6,
  [414] = 58,
  [415] = 26,
  [416] = 32,
  [417] = 36,
  [418] = 30,
  [419] = 27,
  [420] = 32,
  [421] = 31,
  [422] = 30,
  [423] = 28,
  [424] = 36,
  [425] = 27,
  [426] = 26,
  [427] = 25,
  [428] = 36,
  [429] = 46,
  [430] = 46,
  [431] = 47,
  [432] = 38,
  [433] = 22,
  [434] = 32,
  [435] = 38,
  [436] = 31,
  [437] = 30,
  [438] = 28,
  [439] = 27,
  [440] = 26,
  [441] = 25,
  [442] = 36,
  [443] = 58,
  [444] = 46,
  [445] = 47,
  [446] = 32,
  [447] = 38,
  [448] = 36,
  [449] = 38,
  [450] = 22,
  [451] = 32,
  [452] = 47,
  [453] = 31,
  [454] = 30,
  [455] = 28,
  [456] = 27,
  [457] = 26,
  [458] = 25,
  [459] = 25,
  [460] = 22,
  [461] = 47,
  [462] = 38,
  [463] = 22,
  [464] = 25,
  [465] = 22,
  [466] = 26,
  [467] = 27,
  [468] = 28,
  [469] = 47,
  [470] = 31,
  [471] = 28,
  [472] = 31,
  [473] = 30,
  [474] = 46,
  [475] = 46,
  [476] = 476,
  [477] = 477,
  [478] = 477,
  [479] = 479,
  [480] = 479,
  [481] = 479,
  [482] = 479,
  [483] = 476,
  [484] = 484,
  [485] = 476,
  [486] = 484,
  [487] = 484,
  [488] = 484,
  [489] = 479,
  [490] = 477,
  [491] = 477,
  [492] = 476,
  [493] = 484,
  [494] = 479,
  [495] = 476,
  [496] = 477,
  [497] = 476,
  [498] = 477,
  [499] = 484,
  [500] = 500,
  [501] = 484,
  [502] = 502,
  [503] = 477,
  [504] = 479,
  [505] = 476,
  [506] = 502,
  [507] = 507,
  [508] = 508,
  [509] = 509,
  [510] = 510,
  [511] = 511,
  [512] = 512,
  [513] = 513,
  [514] = 514,
  [515] = 515,
  [516] = 516,
  [517] = 517,
  [518] = 518,
  [519] = 519,
  [520] = 520,
  [521] = 521,
  [522] = 507,
  [523] = 523,
  [524] = 524,
  [525] = 525,
  [526] = 526,
  [527] = 527,
  [528] = 528,
  [529] = 529,
  [530] = 530,
  [531] = 531,
  [532] = 476,
  [533] = 533,
  [534] = 534,
  [535] = 535,
  [536] = 536,
  [537] = 477,
  [538] = 479,
  [539] = 500,
  [540] = 540,
  [541] = 541,
  [542] = 484,
  [543] = 543,
  [544] = 544,
  [545] = 545,
  [546] = 546,
  [547] = 547,
  [548] = 548,
  [549] = 549,
  [550] = 550,
  [551] = 551,
  [552] = 552,
  [553] = 553,
  [554] = 554,
  [555] = 555,
  [556] = 556,
  [557] = 557,
  [558] = 558,
  [559] = 559,
  [560] = 560,
  [561] = 561,
  [562] = 562,
  [563] = 553,
  [564] = 509,
  [565] = 510,
  [566] = 511,
  [567] = 512,
  [568] = 513,
  [569] = 514,
  [570] = 515,
  [571] = 516,
  [572] = 517,
  [573] = 518,
  [574] = 519,
  [575] = 502,
  [576] = 520,
  [577] = 521,
  [578] = 523,
  [579] = 524,
  [580] = 525,
  [581] = 526,
  [582] = 527,
  [583] = 528,
  [584] = 529,
  [585] = 530,
  [586] = 531,
  [587] = 533,
  [588] = 534,
  [589] = 535,
  [590] = 536,
  [591] = 540,
  [592] = 541,
  [593] = 543,
  [594] = 508,
  [595] = 545,
  [596] = 546,
  [597] = 547,
  [598] = 548,
  [599] = 507,
  [600] = 549,
  [601] = 550,
  [602] = 551,
  [603] = 552,
  [604] = 476,
  [605] = 554,
  [606] = 555,
  [607] = 556,
  [608] = 557,
  [609] = 558,
  [610] = 559,
  [611] = 560,
  [612] = 561,
  [613] = 562,
  [614] = 544,
  [615] = 509,
  [616] = 510,
  [617] = 511,
  [618] = 512,
  [619] = 513,
  [620] = 514,
  [621] = 515,
  [622] = 516,
  [623] = 517,
  [624] = 518,
  [625] = 519,
  [626] = 520,
  [627] = 521,
  [628] = 523,
  [629] = 524,
  [630] = 525,
  [631] = 526,
  [632] = 527,
  [633] = 528,
  [634] = 529,
  [635] = 530,
  [636] = 531,
  [637] = 533,
  [638] = 534,
  [639] = 535,
  [640] = 536,
  [641] = 500,
  [642] = 540,
  [643] = 541,
  [644] = 543,
  [645] = 508,
  [646] = 545,
  [647] = 546,
  [648] = 547,
  [649] = 548,
  [650] = 549,
  [651] = 550,
  [652] = 551,
  [653] = 552,
  [654] = 553,
  [655] = 554,
  [656] = 555,
  [657] = 556,
  [658] = 557,
  [659] = 558,
  [660] = 559,
  [661] = 560,
  [662] = 561,
  [663] = 562,
  [664] = 544,
  [665] = 484,
  [666] = 479,
  [667] = 477,
  [668] = 476,
  [669] = 484,
  [670] = 479,
  [671] = 477,
  [672] = 560,
  [673] = 546,
  [674] = 513,
  [675] = 512,
  [676] = 511,
  [677] = 510,
  [678] = 509,
  [679] = 544,
  [680] = 562,
  [681] = 561,
  [682] = 560,
  [683] = 559,
  [684] = 558,
  [685] = 557,
  [686] = 556,
  [687] = 555,
  [688] = 514,
  [689] = 554,
  [690] = 553,
  [691] = 515,
  [692] = 516,
  [693] = 517,
  [694] = 518,
  [695] = 552,
  [696] = 519,
  [697] = 520,
  [698] = 521,
  [699] = 551,
  [700] = 550,
  [701] = 549,
  [702] = 548,
  [703] = 547,
  [704] = 546,
  [705] = 545,
  [706] = 508,
  [707] = 543,
  [708] = 541,
  [709] = 540,
  [710] = 500,
  [711] = 536,
  [712] = 523,
  [713] = 535,
  [714] = 524,
  [715] = 525,
  [716] = 526,
  [717] = 527,
  [718] = 528,
  [719] = 529,
  [720] = 530,
  [721] = 531,
  [722] = 533,
  [723] = 534,
  [724] = 534,
  [725] = 533,
  [726] = 531,
  [727] = 530,
  [728] = 529,
  [729] = 535,
  [730] = 528,
  [731] = 536,
  [732] = 527,
  [733] = 500,
  [734] = 526,
  [735] = 540,
  [736] = 525,
  [737] = 541,
  [738] = 524,
  [739] = 543,
  [740] = 523,
  [741] = 508,
  [742] = 521,
  [743] = 545,
  [744] = 520,
  [745] = 519,
  [746] = 518,
  [747] = 517,
  [748] = 516,
  [749] = 515,
  [750] = 546,
  [751] = 547,
  [752] = 548,
  [753] = 514,
  [754] = 549,
  [755] = 550,
  [756] = 551,
  [757] = 552,
  [758] = 553,
  [759] = 554,
  [760] = 555,
  [761] = 556,
  [762] = 557,
  [763] = 558,
  [764] = 559,
  [765] = 560,
  [766] = 561,
  [767] = 562,
  [768] = 544,
  [769] = 513,
  [770] = 507,
  [771] = 512,
  [772] = 511,
  [773] = 510,
  [774] = 509,
  [775] = 476,
  [776] = 477,
  [777] = 479,
  [778] = 778,
  [779] = 484,
  [780] = 780,
  [781] = 476,
  [782] = 477,
  [783] = 479,
  [784] = 484,
  [785] = 484,
  [786] = 479,
  [787] = 477,
  [788] = 476,
  [789] = 507,
  [790] = 507,
  [791] = 502,
  [792] = 476,
  [793] = 477,
  [794] = 479,
  [795] = 484,
  [796] = 507,
  [797] = 509,
  [798] = 510,
  [799] = 511,
  [800] = 512,
  [801] = 513,
  [802] = 514,
  [803] = 476,
  [804] = 515,
  [805] = 477,
  [806] = 516,
  [807] = 479,
  [808] = 517,
  [809] = 484,
  [810] = 518,
  [811] = 519,
  [812] = 544,
  [813] = 562,
  [814] = 520,
  [815] = 561,
  [816] = 521,
  [817] = 523,
  [818] = 476,
  [819] = 477,
  [820] = 479,
  [821] = 484,
  [822] = 559,
  [823] = 558,
  [824] = 557,
  [825] = 524,
  [826] = 525,
  [827] = 556,
  [828] = 526,
  [829] = 527,
  [830] = 528,
  [831] = 555,
  [832] = 529,
  [833] = 554,
  [834] = 553,
  [835] = 530,
  [836] = 531,
  [837] = 533,
  [838] = 534,
  [839] = 552,
  [840] = 535,
  [841] = 536,
  [842] = 500,
  [843] = 540,
  [844] = 541,
  [845] = 551,
  [846] = 550,
  [847] = 549,
  [848] = 548,
  [849] = 547,
  [850] = 546,
  [851] = 545,
  [852] = 508,
  [853] = 543,
  [854] = 541,
  [855] = 540,
  [856] = 476,
  [857] = 500,
  [858] = 536,
  [859] = 477,
  [860] = 479,
  [861] = 543,
  [862] = 508,
  [863] = 535,
  [864] = 484,
  [865] = 545,
  [866] = 546,
  [867] = 547,
  [868] = 548,
  [869] = 549,
  [870] = 476,
  [871] = 477,
  [872] = 479,
  [873] = 484,
  [874] = 550,
  [875] = 551,
  [876] = 552,
  [877] = 553,
  [878] = 554,
  [879] = 534,
  [880] = 533,
  [881] = 555,
  [882] = 531,
  [883] = 556,
  [884] = 530,
  [885] = 529,
  [886] = 557,
  [887] = 528,
  [888] = 558,
  [889] = 527,
  [890] = 559,
  [891] = 526,
  [892] = 560,
  [893] = 525,
  [894] = 561,
  [895] = 524,
  [896] = 562,
  [897] = 523,
  [898] = 544,
  [899] = 521,
  [900] = 520,
  [901] = 519,
  [902] = 518,
  [903] = 780,
  [904] = 517,
  [905] = 516,
  [906] = 515,
  [907] = 514,
  [908] = 513,
  [909] = 512,
  [910] = 511,
  [911] = 510,
  [912] = 509,
  [913] = 509,
  [914] = 510,
  [915] = 511,
  [916] = 512,
  [917] = 502,
  [918] = 513,
  [919] = 514,
  [920] = 778,
  [921] = 507,
  [922] = 515,
  [923] = 516,
  [924] = 517,
  [925] = 518,
  [926] = 519,
  [927] = 520,
  [928] = 521,
  [929] = 523,
  [930] = 524,
  [931] = 525,
  [932] = 526,
  [933] = 527,
  [934] = 528,
  [935] = 502,
  [936] = 529,
  [937] = 530,
  [938] = 531,
  [939] = 533,
  [940] = 534,
  [941] = 535,
  [942] = 536,
  [943] = 500,
  [944] = 540,
  [945] = 541,
  [946] = 543,
  [947] = 508,
  [948] = 545,
  [949] = 780,
  [950] = 778,
  [951] = 544,
  [952] = 562,
  [953] = 561,
  [954] = 560,
  [955] = 559,
  [956] = 558,
  [957] = 557,
  [958] = 556,
  [959] = 555,
  [960] = 554,
  [961] = 553,
  [962] = 552,
  [963] = 551,
  [964] = 550,
  [965] = 549,
  [966] = 548,
  [967] = 547,
  [968] = 968,
  [969] = 544,
  [970] = 507,
  [971] = 778,
  [972] = 780,
  [973] = 780,
  [974] = 778,
  [975] = 509,
  [976] = 510,
  [977] = 511,
  [978] = 512,
  [979] = 513,
  [980] = 514,
  [981] = 515,
  [982] = 516,
  [983] = 517,
  [984] = 518,
  [985] = 519,
  [986] = 520,
  [987] = 521,
  [988] = 523,
  [989] = 524,
  [990] = 525,
  [991] = 484,
  [992] = 526,
  [993] = 968,
  [994] = 484,
  [995] = 527,
  [996] = 528,
  [997] = 529,
  [998] = 530,
  [999] = 479,
  [1000] = 477,
  [1001] = 479,
  [1002] = 531,
  [1003] = 533,
  [1004] = 477,
  [1005] = 534,
  [1006] = 535,
  [1007] = 536,
  [1008] = 476,
  [1009] = 500,
  [1010] = 540,
  [1011] = 541,
  [1012] = 543,
  [1013] = 508,
  [1014] = 545,
  [1015] = 546,
  [1016] = 547,
  [1017] = 548,
  [1018] = 549,
  [1019] = 550,
  [1020] = 551,
  [1021] = 552,
  [1022] = 553,
  [1023] = 554,
  [1024] = 555,
  [1025] = 556,
  [1026] = 557,
  [1027] = 558,
  [1028] = 559,
  [1029] = 560,
  [1030] = 476,
  [1031] = 561,
  [1032] = 562,
  [1033] = 544,
  [1034] = 509,
  [1035] = 510,
  [1036] = 511,
  [1037] = 512,
  [1038] = 513,
  [1039] = 514,
  [1040] = 515,
  [1041] = 516,
  [1042] = 517,
  [1043] = 518,
  [1044] = 519,
  [1045] = 520,
  [1046] = 521,
  [1047] = 523,
  [1048] = 524,
  [1049] = 525,
  [1050] = 526,
  [1051] = 527,
  [1052] = 528,
  [1053] = 529,
  [1054] = 530,
  [1055] = 531,
  [1056] = 533,
  [1057] = 534,
  [1058] = 535,
  [1059] = 536,
  [1060] = 500,
  [1061] = 780,
  [1062] = 540,
  [1063] = 541,
  [1064] = 543,
  [1065] = 508,
  [1066] = 545,
  [1067] = 546,
  [1068] = 544,
  [1069] = 562,
  [1070] = 561,
  [1071] = 560,
  [1072] = 507,
  [1073] = 547,
  [1074] = 559,
  [1075] = 558,
  [1076] = 557,
  [1077] = 548,
  [1078] = 549,
  [1079] = 556,
  [1080] = 550,
  [1081] = 551,
  [1082] = 552,
  [1083] = 555,
  [1084] = 553,
  [1085] = 554,
  [1086] = 553,
  [1087] = 554,
  [1088] = 555,
  [1089] = 556,
  [1090] = 557,
  [1091] = 558,
  [1092] = 552,
  [1093] = 559,
  [1094] = 560,
  [1095] = 561,
  [1096] = 562,
  [1097] = 544,
  [1098] = 551,
  [1099] = 550,
  [1100] = 549,
  [1101] = 548,
  [1102] = 547,
  [1103] = 546,
  [1104] = 545,
  [1105] = 778,
  [1106] = 508,
  [1107] = 543,
  [1108] = 541,
  [1109] = 540,
  [1110] = 500,
  [1111] = 968,
  [1112] = 536,
  [1113] = 535,
  [1114] = 534,
  [1115] = 533,
  [1116] = 531,
  [1117] = 530,
  [1118] = 529,
  [1119] = 528,
  [1120] = 527,
  [1121] = 526,
  [1122] = 525,
  [1123] = 524,
  [1124] = 523,
  [1125] = 521,
  [1126] = 520,
  [1127] = 519,
  [1128] = 518,
  [1129] = 517,
  [1130] = 516,
  [1131] = 515,
  [1132] = 514,
  [1133] = 502,
  [1134] = 513,
  [1135] = 512,
  [1136] = 511,
  [1137] = 510,
  [1138] = 509,
  [1139] = 502,
  [1140] = 544,
  [1141] = 562,
  [1142] = 561,
  [1143] = 560,
  [1144] = 559,
  [1145] = 484,
  [1146] = 544,
  [1147] = 558,
  [1148] = 557,
  [1149] = 556,
  [1150] = 479,
  [1151] = 477,
  [1152] = 507,
  [1153] = 562,
  [1154] = 561,
  [1155] = 555,
  [1156] = 560,
  [1157] = 554,
  [1158] = 553,
  [1159] = 476,
  [1160] = 559,
  [1161] = 552,
  [1162] = 558,
  [1163] = 557,
  [1164] = 556,
  [1165] = 555,
  [1166] = 551,
  [1167] = 554,
  [1168] = 553,
  [1169] = 550,
  [1170] = 552,
  [1171] = 551,
  [1172] = 550,
  [1173] = 549,
  [1174] = 548,
  [1175] = 547,
  [1176] = 546,
  [1177] = 545,
  [1178] = 508,
  [1179] = 543,
  [1180] = 549,
  [1181] = 548,
  [1182] = 547,
  [1183] = 541,
  [1184] = 540,
  [1185] = 500,
  [1186] = 546,
  [1187] = 536,
  [1188] = 545,
  [1189] = 535,
  [1190] = 508,
  [1191] = 543,
  [1192] = 541,
  [1193] = 540,
  [1194] = 500,
  [1195] = 536,
  [1196] = 535,
  [1197] = 534,
  [1198] = 534,
  [1199] = 533,
  [1200] = 531,
  [1201] = 530,
  [1202] = 529,
  [1203] = 528,
  [1204] = 527,
  [1205] = 526,
  [1206] = 525,
  [1207] = 524,
  [1208] = 523,
  [1209] = 521,
  [1210] = 520,
  [1211] = 519,
  [1212] = 518,
  [1213] = 778,
  [1214] = 517,
  [1215] = 516,
  [1216] = 515,
  [1217] = 533,
  [1218] = 514,
  [1219] = 502,
  [1220] = 531,
  [1221] = 530,
  [1222] = 529,
  [1223] = 513,
  [1224] = 512,
  [1225] = 511,
  [1226] = 528,
  [1227] = 510,
  [1228] = 527,
  [1229] = 509,
  [1230] = 526,
  [1231] = 525,
  [1232] = 524,
  [1233] = 523,
  [1234] = 521,
  [1235] = 520,
  [1236] = 519,
  [1237] = 518,
  [1238] = 517,
  [1239] = 516,
  [1240] = 515,
  [1241] = 514,
  [1242] = 513,
  [1243] = 512,
  [1244] = 511,
  [1245] = 510,
  [1246] = 509,
  [1247] = 509,
  [1248] = 510,
  [1249] = 511,
  [1250] = 512,
  [1251] = 513,
  [1252] = 514,
  [1253] = 515,
  [1254] = 516,
  [1255] = 517,
  [1256] = 518,
  [1257] = 519,
  [1258] = 520,
  [1259] = 521,
  [1260] = 523,
  [1261] = 524,
  [1262] = 525,
  [1263] = 526,
  [1264] = 780,
  [1265] = 484,
  [1266] = 479,
  [1267] = 527,
  [1268] = 477,
  [1269] = 528,
  [1270] = 476,
  [1271] = 529,
  [1272] = 530,
  [1273] = 531,
  [1274] = 533,
  [1275] = 534,
  [1276] = 535,
  [1277] = 536,
  [1278] = 500,
  [1279] = 540,
  [1280] = 476,
  [1281] = 541,
  [1282] = 543,
  [1283] = 484,
  [1284] = 508,
  [1285] = 545,
  [1286] = 479,
  [1287] = 477,
  [1288] = 479,
  [1289] = 477,
  [1290] = 476,
  [1291] = 484,
  [1292] = 546,
  [1293] = 484,
  [1294] = 479,
  [1295] = 477,
  [1296] = 547,
  [1297] = 476,
  [1298] = 548,
  [1299] = 780,
  [1300] = 484,
  [1301] = 479,
  [1302] = 549,
  [1303] = 550,
  [1304] = 551,
  [1305] = 552,
  [1306] = 553,
  [1307] = 554,
  [1308] = 555,
  [1309] = 556,
  [1310] = 557,
  [1311] = 558,
  [1312] = 559,
  [1313] = 562,
  [1314] = 561,
  [1315] = 477,
  [1316] = 476,
  [1317] = 778,
  [1318] = 560,
  [1319] = 554,
  [1320] = 562,
  [1321] = 1321,
  [1322] = 1322,
  [1323] = 1323,
  [1324] = 1323,
  [1325] = 1325,
  [1326] = 1321,
  [1327] = 1327,
  [1328] = 1322,
  [1329] = 1325,
  [1330] = 1327,
  [1331] = 1322,
  [1332] = 1325,
  [1333] = 1333,
  [1334] = 1327,
  [1335] = 1322,
  [1336] = 968,
  [1337] = 514,
  [1338] = 968,
  [1339] = 1333,
  [1340] = 1325,
  [1341] = 509,
  [1342] = 1333,
  [1343] = 510,
  [1344] = 1325,
  [1345] = 511,
  [1346] = 1327,
  [1347] = 512,
  [1348] = 1322,
  [1349] = 513,
  [1350] = 1325,
  [1351] = 1333,
  [1352] = 1327,
  [1353] = 1322,
  [1354] = 502,
  [1355] = 515,
  [1356] = 516,
  [1357] = 1325,
  [1358] = 517,
  [1359] = 1333,
  [1360] = 1327,
  [1361] = 1322,
  [1362] = 1325,
  [1363] = 1333,
  [1364] = 1327,
  [1365] = 1322,
  [1366] = 1325,
  [1367] = 1321,
  [1368] = 1333,
  [1369] = 1323,
  [1370] = 1327,
  [1371] = 1322,
  [1372] = 1325,
  [1373] = 1333,
  [1374] = 1322,
  [1375] = 1333,
  [1376] = 557,
  [1377] = 514,
  [1378] = 1327,
  [1379] = 1322,
  [1380] = 1325,
  [1381] = 515,
  [1382] = 516,
  [1383] = 517,
  [1384] = 518,
  [1385] = 519,
  [1386] = 1323,
  [1387] = 1321,
  [1388] = 520,
  [1389] = 780,
  [1390] = 521,
  [1391] = 518,
  [1392] = 523,
  [1393] = 1333,
  [1394] = 524,
  [1395] = 1327,
  [1396] = 525,
  [1397] = 1322,
  [1398] = 526,
  [1399] = 1325,
  [1400] = 527,
  [1401] = 1333,
  [1402] = 528,
  [1403] = 1323,
  [1404] = 529,
  [1405] = 1321,
  [1406] = 530,
  [1407] = 1327,
  [1408] = 531,
  [1409] = 1322,
  [1410] = 533,
  [1411] = 1325,
  [1412] = 534,
  [1413] = 513,
  [1414] = 1325,
  [1415] = 1327,
  [1416] = 1322,
  [1417] = 1323,
  [1418] = 1321,
  [1419] = 1322,
  [1420] = 1323,
  [1421] = 1321,
  [1422] = 512,
  [1423] = 1325,
  [1424] = 1333,
  [1425] = 1327,
  [1426] = 535,
  [1427] = 778,
  [1428] = 1327,
  [1429] = 536,
  [1430] = 500,
  [1431] = 540,
  [1432] = 541,
  [1433] = 543,
  [1434] = 508,
  [1435] = 545,
  [1436] = 546,
  [1437] = 547,
  [1438] = 548,
  [1439] = 549,
  [1440] = 550,
  [1441] = 551,
  [1442] = 1322,
  [1443] = 1325,
  [1444] = 1333,
  [1445] = 507,
  [1446] = 544,
  [1447] = 1327,
  [1448] = 552,
  [1449] = 562,
  [1450] = 1322,
  [1451] = 561,
  [1452] = 1327,
  [1453] = 1321,
  [1454] = 560,
  [1455] = 553,
  [1456] = 554,
  [1457] = 559,
  [1458] = 555,
  [1459] = 558,
  [1460] = 557,
  [1461] = 1325,
  [1462] = 556,
  [1463] = 1323,
  [1464] = 544,
  [1465] = 557,
  [1466] = 558,
  [1467] = 559,
  [1468] = 556,
  [1469] = 560,
  [1470] = 561,
  [1471] = 562,
  [1472] = 562,
  [1473] = 544,
  [1474] = 555,
  [1475] = 561,
  [1476] = 554,
  [1477] = 553,
  [1478] = 1325,
  [1479] = 552,
  [1480] = 551,
  [1481] = 550,
  [1482] = 549,
  [1483] = 548,
  [1484] = 547,
  [1485] = 560,
  [1486] = 546,
  [1487] = 559,
  [1488] = 1333,
  [1489] = 558,
  [1490] = 1327,
  [1491] = 545,
  [1492] = 1333,
  [1493] = 508,
  [1494] = 1322,
  [1495] = 543,
  [1496] = 1325,
  [1497] = 541,
  [1498] = 540,
  [1499] = 500,
  [1500] = 536,
  [1501] = 514,
  [1502] = 535,
  [1503] = 1323,
  [1504] = 1321,
  [1505] = 1333,
  [1506] = 534,
  [1507] = 533,
  [1508] = 531,
  [1509] = 530,
  [1510] = 529,
  [1511] = 528,
  [1512] = 527,
  [1513] = 526,
  [1514] = 525,
  [1515] = 778,
  [1516] = 524,
  [1517] = 523,
  [1518] = 521,
  [1519] = 1327,
  [1520] = 520,
  [1521] = 502,
  [1522] = 519,
  [1523] = 518,
  [1524] = 517,
  [1525] = 1322,
  [1526] = 516,
  [1527] = 556,
  [1528] = 1325,
  [1529] = 1322,
  [1530] = 515,
  [1531] = 514,
  [1532] = 1333,
  [1533] = 1327,
  [1534] = 1322,
  [1535] = 511,
  [1536] = 1323,
  [1537] = 1325,
  [1538] = 1333,
  [1539] = 1327,
  [1540] = 513,
  [1541] = 1322,
  [1542] = 512,
  [1543] = 1321,
  [1544] = 511,
  [1545] = 1325,
  [1546] = 510,
  [1547] = 1333,
  [1548] = 509,
  [1549] = 1327,
  [1550] = 515,
  [1551] = 1322,
  [1552] = 544,
  [1553] = 510,
  [1554] = 562,
  [1555] = 1325,
  [1556] = 516,
  [1557] = 778,
  [1558] = 561,
  [1559] = 1333,
  [1560] = 560,
  [1561] = 509,
  [1562] = 559,
  [1563] = 968,
  [1564] = 558,
  [1565] = 557,
  [1566] = 780,
  [1567] = 517,
  [1568] = 518,
  [1569] = 1321,
  [1570] = 556,
  [1571] = 1323,
  [1572] = 555,
  [1573] = 554,
  [1574] = 553,
  [1575] = 520,
  [1576] = 552,
  [1577] = 1327,
  [1578] = 551,
  [1579] = 555,
  [1580] = 520,
  [1581] = 780,
  [1582] = 1322,
  [1583] = 1321,
  [1584] = 1325,
  [1585] = 1323,
  [1586] = 968,
  [1587] = 1333,
  [1588] = 1327,
  [1589] = 1322,
  [1590] = 1325,
  [1591] = 1333,
  [1592] = 1327,
  [1593] = 550,
  [1594] = 549,
  [1595] = 548,
  [1596] = 547,
  [1597] = 546,
  [1598] = 1322,
  [1599] = 502,
  [1600] = 553,
  [1601] = 545,
  [1602] = 508,
  [1603] = 1333,
  [1604] = 1327,
  [1605] = 543,
  [1606] = 1325,
  [1607] = 1327,
  [1608] = 541,
  [1609] = 778,
  [1610] = 540,
  [1611] = 500,
  [1612] = 552,
  [1613] = 1327,
  [1614] = 536,
  [1615] = 1322,
  [1616] = 1325,
  [1617] = 521,
  [1618] = 502,
  [1619] = 535,
  [1620] = 1333,
  [1621] = 523,
  [1622] = 1323,
  [1623] = 544,
  [1624] = 562,
  [1625] = 1321,
  [1626] = 524,
  [1627] = 534,
  [1628] = 533,
  [1629] = 531,
  [1630] = 530,
  [1631] = 529,
  [1632] = 528,
  [1633] = 527,
  [1634] = 526,
  [1635] = 525,
  [1636] = 541,
  [1637] = 561,
  [1638] = 524,
  [1639] = 509,
  [1640] = 523,
  [1641] = 510,
  [1642] = 521,
  [1643] = 511,
  [1644] = 520,
  [1645] = 512,
  [1646] = 519,
  [1647] = 513,
  [1648] = 518,
  [1649] = 517,
  [1650] = 516,
  [1651] = 515,
  [1652] = 560,
  [1653] = 521,
  [1654] = 514,
  [1655] = 559,
  [1656] = 558,
  [1657] = 513,
  [1658] = 512,
  [1659] = 511,
  [1660] = 510,
  [1661] = 523,
  [1662] = 509,
  [1663] = 524,
  [1664] = 544,
  [1665] = 562,
  [1666] = 557,
  [1667] = 519,
  [1668] = 561,
  [1669] = 560,
  [1670] = 525,
  [1671] = 559,
  [1672] = 556,
  [1673] = 558,
  [1674] = 557,
  [1675] = 525,
  [1676] = 551,
  [1677] = 556,
  [1678] = 550,
  [1679] = 514,
  [1680] = 549,
  [1681] = 555,
  [1682] = 526,
  [1683] = 515,
  [1684] = 516,
  [1685] = 517,
  [1686] = 518,
  [1687] = 519,
  [1688] = 554,
  [1689] = 553,
  [1690] = 520,
  [1691] = 527,
  [1692] = 521,
  [1693] = 552,
  [1694] = 523,
  [1695] = 551,
  [1696] = 524,
  [1697] = 550,
  [1698] = 525,
  [1699] = 549,
  [1700] = 526,
  [1701] = 548,
  [1702] = 527,
  [1703] = 547,
  [1704] = 528,
  [1705] = 546,
  [1706] = 529,
  [1707] = 545,
  [1708] = 530,
  [1709] = 508,
  [1710] = 531,
  [1711] = 543,
  [1712] = 533,
  [1713] = 541,
  [1714] = 534,
  [1715] = 540,
  [1716] = 500,
  [1717] = 555,
  [1718] = 536,
  [1719] = 528,
  [1720] = 1321,
  [1721] = 535,
  [1722] = 1323,
  [1723] = 1323,
  [1724] = 1321,
  [1725] = 548,
  [1726] = 526,
  [1727] = 547,
  [1728] = 535,
  [1729] = 534,
  [1730] = 546,
  [1731] = 536,
  [1732] = 500,
  [1733] = 540,
  [1734] = 541,
  [1735] = 543,
  [1736] = 508,
  [1737] = 545,
  [1738] = 546,
  [1739] = 547,
  [1740] = 548,
  [1741] = 549,
  [1742] = 550,
  [1743] = 551,
  [1744] = 533,
  [1745] = 531,
  [1746] = 530,
  [1747] = 529,
  [1748] = 528,
  [1749] = 554,
  [1750] = 552,
  [1751] = 545,
  [1752] = 508,
  [1753] = 527,
  [1754] = 553,
  [1755] = 1325,
  [1756] = 543,
  [1757] = 553,
  [1758] = 554,
  [1759] = 540,
  [1760] = 555,
  [1761] = 526,
  [1762] = 525,
  [1763] = 1322,
  [1764] = 556,
  [1765] = 524,
  [1766] = 500,
  [1767] = 557,
  [1768] = 558,
  [1769] = 559,
  [1770] = 523,
  [1771] = 560,
  [1772] = 561,
  [1773] = 536,
  [1774] = 527,
  [1775] = 544,
  [1776] = 521,
  [1777] = 520,
  [1778] = 519,
  [1779] = 518,
  [1780] = 517,
  [1781] = 516,
  [1782] = 515,
  [1783] = 514,
  [1784] = 529,
  [1785] = 528,
  [1786] = 780,
  [1787] = 513,
  [1788] = 512,
  [1789] = 535,
  [1790] = 552,
  [1791] = 511,
  [1792] = 529,
  [1793] = 510,
  [1794] = 1321,
  [1795] = 509,
  [1796] = 1323,
  [1797] = 530,
  [1798] = 551,
  [1799] = 531,
  [1800] = 533,
  [1801] = 534,
  [1802] = 550,
  [1803] = 549,
  [1804] = 1333,
  [1805] = 1321,
  [1806] = 1323,
  [1807] = 535,
  [1808] = 536,
  [1809] = 500,
  [1810] = 540,
  [1811] = 541,
  [1812] = 1323,
  [1813] = 1321,
  [1814] = 548,
  [1815] = 543,
  [1816] = 508,
  [1817] = 778,
  [1818] = 545,
  [1819] = 546,
  [1820] = 547,
  [1821] = 547,
  [1822] = 548,
  [1823] = 546,
  [1824] = 549,
  [1825] = 550,
  [1826] = 551,
  [1827] = 545,
  [1828] = 508,
  [1829] = 1323,
  [1830] = 543,
  [1831] = 541,
  [1832] = 540,
  [1833] = 552,
  [1834] = 500,
  [1835] = 536,
  [1836] = 535,
  [1837] = 519,
  [1838] = 1323,
  [1839] = 1321,
  [1840] = 534,
  [1841] = 533,
  [1842] = 531,
  [1843] = 530,
  [1844] = 529,
  [1845] = 528,
  [1846] = 1333,
  [1847] = 527,
  [1848] = 513,
  [1849] = 526,
  [1850] = 553,
  [1851] = 525,
  [1852] = 554,
  [1853] = 524,
  [1854] = 555,
  [1855] = 523,
  [1856] = 521,
  [1857] = 520,
  [1858] = 519,
  [1859] = 1323,
  [1860] = 518,
  [1861] = 517,
  [1862] = 516,
  [1863] = 1321,
  [1864] = 515,
  [1865] = 512,
  [1866] = 1327,
  [1867] = 556,
  [1868] = 780,
  [1869] = 557,
  [1870] = 558,
  [1871] = 1321,
  [1872] = 559,
  [1873] = 1323,
  [1874] = 561,
  [1875] = 1323,
  [1876] = 1321,
  [1877] = 1321,
  [1878] = 562,
  [1879] = 511,
  [1880] = 560,
  [1881] = 1333,
  [1882] = 514,
  [1883] = 531,
  [1884] = 533,
  [1885] = 778,
  [1886] = 544,
  [1887] = 510,
  [1888] = 1321,
  [1889] = 1323,
  [1890] = 968,
  [1891] = 1321,
  [1892] = 1323,
  [1893] = 513,
  [1894] = 1321,
  [1895] = 1323,
  [1896] = 512,
  [1897] = 511,
  [1898] = 1333,
  [1899] = 510,
  [1900] = 530,
  [1901] = 780,
  [1902] = 509,
  [1903] = 534,
  [1904] = 1321,
  [1905] = 1323,
  [1906] = 1323,
  [1907] = 509,
  [1908] = 1321,
  [1909] = 780,
  [1910] = 525,
  [1911] = 536,
  [1912] = 1912,
  [1913] = 518,
  [1914] = 517,
  [1915] = 516,
  [1916] = 515,
  [1917] = 515,
  [1918] = 526,
  [1919] = 516,
  [1920] = 514,
  [1921] = 518,
  [1922] = 519,
  [1923] = 1923,
  [1924] = 780,
  [1925] = 1925,
  [1926] = 520,
  [1927] = 1927,
  [1928] = 553,
  [1929] = 1929,
  [1930] = 523,
  [1931] = 1931,
  [1932] = 524,
  [1933] = 535,
  [1934] = 1934,
  [1935] = 521,
  [1936] = 513,
  [1937] = 523,
  [1938] = 534,
  [1939] = 524,
  [1940] = 1931,
  [1941] = 514,
  [1942] = 520,
  [1943] = 1943,
  [1944] = 526,
  [1945] = 525,
  [1946] = 560,
  [1947] = 1947,
  [1948] = 528,
  [1949] = 526,
  [1950] = 561,
  [1951] = 527,
  [1952] = 535,
  [1953] = 517,
  [1954] = 529,
  [1955] = 548,
  [1956] = 530,
  [1957] = 531,
  [1958] = 547,
  [1959] = 546,
  [1960] = 512,
  [1961] = 513,
  [1962] = 559,
  [1963] = 512,
  [1964] = 511,
  [1965] = 558,
  [1966] = 778,
  [1967] = 533,
  [1968] = 968,
  [1969] = 502,
  [1970] = 510,
  [1971] = 511,
  [1972] = 534,
  [1973] = 557,
  [1974] = 510,
  [1975] = 545,
  [1976] = 533,
  [1977] = 509,
  [1978] = 531,
  [1979] = 509,
  [1980] = 530,
  [1981] = 1929,
  [1982] = 1927,
  [1983] = 562,
  [1984] = 1925,
  [1985] = 1923,
  [1986] = 508,
  [1987] = 556,
  [1988] = 529,
  [1989] = 534,
  [1990] = 1934,
  [1991] = 543,
  [1992] = 544,
  [1993] = 533,
  [1994] = 534,
  [1995] = 541,
  [1996] = 533,
  [1997] = 531,
  [1998] = 549,
  [1999] = 515,
  [2000] = 535,
  [2001] = 540,
  [2002] = 550,
  [2003] = 530,
  [2004] = 1943,
  [2005] = 500,
  [2006] = 531,
  [2007] = 529,
  [2008] = 1947,
  [2009] = 1929,
  [2010] = 536,
  [2011] = 555,
  [2012] = 517,
  [2013] = 544,
  [2014] = 562,
  [2015] = 780,
  [2016] = 1927,
  [2017] = 561,
  [2018] = 2018,
  [2019] = 560,
  [2020] = 500,
  [2021] = 1925,
  [2022] = 559,
  [2023] = 540,
  [2024] = 558,
  [2025] = 541,
  [2026] = 557,
  [2027] = 1923,
  [2028] = 543,
  [2029] = 508,
  [2030] = 518,
  [2031] = 2031,
  [2032] = 527,
  [2033] = 2033,
  [2034] = 1912,
  [2035] = 546,
  [2036] = 968,
  [2037] = 519,
  [2038] = 1931,
  [2039] = 780,
  [2040] = 547,
  [2041] = 1934,
  [2042] = 556,
  [2043] = 554,
  [2044] = 548,
  [2045] = 549,
  [2046] = 550,
  [2047] = 545,
  [2048] = 778,
  [2049] = 529,
  [2050] = 553,
  [2051] = 555,
  [2052] = 500,
  [2053] = 554,
  [2054] = 520,
  [2055] = 516,
  [2056] = 780,
  [2057] = 780,
  [2058] = 553,
  [2059] = 1943,
  [2060] = 1947,
  [2061] = 552,
  [2062] = 528,
  [2063] = 536,
  [2064] = 778,
  [2065] = 778,
  [2066] = 540,
  [2067] = 552,
  [2068] = 541,
  [2069] = 519,
  [2070] = 543,
  [2071] = 521,
  [2072] = 554,
  [2073] = 508,
  [2074] = 552,
  [2075] = 2031,
  [2076] = 2033,
  [2077] = 551,
  [2078] = 550,
  [2079] = 545,
  [2080] = 549,
  [2081] = 546,
  [2082] = 547,
  [2083] = 548,
  [2084] = 555,
  [2085] = 548,
  [2086] = 556,
  [2087] = 557,
  [2088] = 558,
  [2089] = 547,
  [2090] = 514,
  [2091] = 546,
  [2092] = 521,
  [2093] = 545,
  [2094] = 559,
  [2095] = 508,
  [2096] = 549,
  [2097] = 778,
  [2098] = 968,
  [2099] = 560,
  [2100] = 543,
  [2101] = 541,
  [2102] = 540,
  [2103] = 500,
  [2104] = 536,
  [2105] = 561,
  [2106] = 562,
  [2107] = 544,
  [2108] = 528,
  [2109] = 550,
  [2110] = 551,
  [2111] = 552,
  [2112] = 553,
  [2113] = 1912,
  [2114] = 554,
  [2115] = 2031,
  [2116] = 2033,
  [2117] = 555,
  [2118] = 778,
  [2119] = 528,
  [2120] = 527,
  [2121] = 556,
  [2122] = 551,
  [2123] = 968,
  [2124] = 557,
  [2125] = 525,
  [2126] = 524,
  [2127] = 523,
  [2128] = 521,
  [2129] = 558,
  [2130] = 559,
  [2131] = 778,
  [2132] = 560,
  [2133] = 561,
  [2134] = 562,
  [2135] = 520,
  [2136] = 519,
  [2137] = 518,
  [2138] = 513,
  [2139] = 517,
  [2140] = 512,
  [2141] = 524,
  [2142] = 511,
  [2143] = 968,
  [2144] = 510,
  [2145] = 509,
  [2146] = 780,
  [2147] = 516,
  [2148] = 515,
  [2149] = 514,
  [2150] = 544,
  [2151] = 513,
  [2152] = 525,
  [2153] = 523,
  [2154] = 526,
  [2155] = 780,
  [2156] = 551,
  [2157] = 527,
  [2158] = 512,
  [2159] = 530,
  [2160] = 511,
  [2161] = 968,
  [2162] = 535,
  [2163] = 778,
  [2164] = 510,
  [2165] = 509,
  [2166] = 1927,
  [2167] = 1929,
  [2168] = 968,
  [2169] = 1927,
  [2170] = 2033,
  [2171] = 778,
  [2172] = 2031,
  [2173] = 968,
  [2174] = 2033,
  [2175] = 2031,
  [2176] = 1947,
  [2177] = 1943,
  [2178] = 778,
  [2179] = 778,
  [2180] = 1934,
  [2181] = 1923,
  [2182] = 968,
  [2183] = 1925,
  [2184] = 1929,
  [2185] = 1947,
  [2186] = 1943,
  [2187] = 1934,
  [2188] = 1923,
  [2189] = 1925,
  [2190] = 2033,
  [2191] = 2031,
  [2192] = 1927,
  [2193] = 1929,
  [2194] = 2031,
  [2195] = 2195,
  [2196] = 2195,
  [2197] = 968,
  [2198] = 1943,
  [2199] = 2195,
  [2200] = 1923,
  [2201] = 1934,
  [2202] = 968,
  [2203] = 968,
  [2204] = 1947,
  [2205] = 968,
  [2206] = 1925,
  [2207] = 1947,
  [2208] = 1929,
  [2209] = 1927,
  [2210] = 1925,
  [2211] = 1923,
  [2212] = 1934,
  [2213] = 780,
  [2214] = 780,
  [2215] = 968,
  [2216] = 2031,
  [2217] = 2033,
  [2218] = 1929,
  [2219] = 1927,
  [2220] = 1925,
  [2221] = 1923,
  [2222] = 1934,
  [2223] = 1943,
  [2224] = 1947,
  [2225] = 780,
  [2226] = 780,
  [2227] = 778,
  [2228] = 2033,
  [2229] = 1943,
  [2230] = 2230,
  [2231] = 1927,
  [2232] = 2232,
  [2233] = 1929,
  [2234] = 1927,
  [2235] = 1925,
  [2236] = 1923,
  [2237] = 1934,
  [2238] = 1943,
  [2239] = 1947,
  [2240] = 2240,
  [2241] = 2230,
  [2242] = 2242,
  [2243] = 2243,
  [2244] = 2244,
  [2245] = 2245,
  [2246] = 2246,
  [2247] = 2033,
  [2248] = 2248,
  [2249] = 2249,
  [2250] = 2250,
  [2251] = 968,
  [2252] = 2252,
  [2253] = 2031,
  [2254] = 2232,
  [2255] = 2031,
  [2256] = 2256,
  [2257] = 2257,
  [2258] = 2033,
  [2259] = 2259,
  [2260] = 2260,
  [2261] = 2261,
  [2262] = 1947,
  [2263] = 1943,
  [2264] = 1934,
  [2265] = 1923,
  [2266] = 1925,
  [2267] = 2267,
  [2268] = 2268,
  [2269] = 1929,
  [2270] = 1929,
  [2271] = 1927,
  [2272] = 1925,
  [2273] = 1923,
  [2274] = 1934,
  [2275] = 2275,
  [2276] = 1943,
  [2277] = 1947,
  [2278] = 2031,
  [2279] = 2033,
  [2280] = 2280,
  [2281] = 2195,
  [2282] = 2282,
  [2283] = 2283,
  [2284] = 1927,
  [2285] = 2285,
  [2286] = 1929,
  [2287] = 1927,
  [2288] = 1925,
  [2289] = 1923,
  [2290] = 1934,
  [2291] = 1943,
  [2292] = 1947,
  [2293] = 2232,
  [2294] = 2285,
  [2295] = 2031,
  [2296] = 2033,
  [2297] = 2282,
  [2298] = 2280,
  [2299] = 2033,
  [2300] = 2031,
  [2301] = 2285,
  [2302] = 2195,
  [2303] = 2195,
  [2304] = 2283,
  [2305] = 968,
  [2306] = 1947,
  [2307] = 1943,
  [2308] = 2282,
  [2309] = 1934,
  [2310] = 1923,
  [2311] = 1925,
  [2312] = 1927,
  [2313] = 1929,
  [2314] = 2280,
  [2315] = 2275,
  [2316] = 2268,
  [2317] = 2267,
  [2318] = 2261,
  [2319] = 2260,
  [2320] = 2259,
  [2321] = 2257,
  [2322] = 2256,
  [2323] = 2252,
  [2324] = 2250,
  [2325] = 2249,
  [2326] = 2248,
  [2327] = 2246,
  [2328] = 2245,
  [2329] = 2244,
  [2330] = 2243,
  [2331] = 2242,
  [2332] = 2230,
  [2333] = 2240,
  [2334] = 2033,
  [2335] = 2031,
  [2336] = 2195,
  [2337] = 2275,
  [2338] = 968,
  [2339] = 2268,
  [2340] = 2267,
  [2341] = 2283,
  [2342] = 2261,
  [2343] = 2260,
  [2344] = 1947,
  [2345] = 1943,
  [2346] = 2259,
  [2347] = 2257,
  [2348] = 2256,
  [2349] = 2195,
  [2350] = 2240,
  [2351] = 2242,
  [2352] = 2243,
  [2353] = 968,
  [2354] = 1934,
  [2355] = 1923,
  [2356] = 1925,
  [2357] = 2244,
  [2358] = 2245,
  [2359] = 1929,
  [2360] = 2246,
  [2361] = 2248,
  [2362] = 2249,
  [2363] = 2250,
  [2364] = 2252,
  [2365] = 2267,
  [2366] = 1943,
  [2367] = 1947,
  [2368] = 1943,
  [2369] = 1934,
  [2370] = 1923,
  [2371] = 1925,
  [2372] = 1927,
  [2373] = 1929,
  [2374] = 2283,
  [2375] = 2033,
  [2376] = 2031,
  [2377] = 1929,
  [2378] = 1927,
  [2379] = 2232,
  [2380] = 2261,
  [2381] = 1925,
  [2382] = 1923,
  [2383] = 1934,
  [2384] = 2268,
  [2385] = 2260,
  [2386] = 1943,
  [2387] = 2031,
  [2388] = 2259,
  [2389] = 2033,
  [2390] = 1947,
  [2391] = 2267,
  [2392] = 1929,
  [2393] = 2285,
  [2394] = 2232,
  [2395] = 2031,
  [2396] = 2033,
  [2397] = 1927,
  [2398] = 2195,
  [2399] = 2195,
  [2400] = 2195,
  [2401] = 2261,
  [2402] = 2267,
  [2403] = 2260,
  [2404] = 2259,
  [2405] = 2282,
  [2406] = 2257,
  [2407] = 2268,
  [2408] = 2256,
  [2409] = 2280,
  [2410] = 2232,
  [2411] = 2283,
  [2412] = 1925,
  [2413] = 2280,
  [2414] = 2230,
  [2415] = 2232,
  [2416] = 2257,
  [2417] = 2242,
  [2418] = 2275,
  [2419] = 2240,
  [2420] = 2230,
  [2421] = 2242,
  [2422] = 2243,
  [2423] = 2033,
  [2424] = 2031,
  [2425] = 2232,
  [2426] = 2243,
  [2427] = 2256,
  [2428] = 2033,
  [2429] = 2031,
  [2430] = 1923,
  [2431] = 2285,
  [2432] = 2275,
  [2433] = 1947,
  [2434] = 1943,
  [2435] = 2268,
  [2436] = 2267,
  [2437] = 1934,
  [2438] = 2261,
  [2439] = 2260,
  [2440] = 2259,
  [2441] = 1927,
  [2442] = 1923,
  [2443] = 2257,
  [2444] = 2256,
  [2445] = 1925,
  [2446] = 2285,
  [2447] = 2282,
  [2448] = 1925,
  [2449] = 1929,
  [2450] = 2280,
  [2451] = 2252,
  [2452] = 2250,
  [2453] = 2249,
  [2454] = 2248,
  [2455] = 2246,
  [2456] = 1923,
  [2457] = 2245,
  [2458] = 2244,
  [2459] = 2282,
  [2460] = 2195,
  [2461] = 2282,
  [2462] = 1923,
  [2463] = 2240,
  [2464] = 2230,
  [2465] = 2195,
  [2466] = 1934,
  [2467] = 2242,
  [2468] = 2243,
  [2469] = 2244,
  [2470] = 2245,
  [2471] = 2246,
  [2472] = 2248,
  [2473] = 2243,
  [2474] = 2242,
  [2475] = 2230,
  [2476] = 2240,
  [2477] = 2280,
  [2478] = 1934,
  [2479] = 1947,
  [2480] = 2249,
  [2481] = 1947,
  [2482] = 1943,
  [2483] = 1943,
  [2484] = 1943,
  [2485] = 2250,
  [2486] = 1947,
  [2487] = 2252,
  [2488] = 2244,
  [2489] = 2245,
  [2490] = 2256,
  [2491] = 2246,
  [2492] = 1929,
  [2493] = 2257,
  [2494] = 1934,
  [2495] = 2240,
  [2496] = 2240,
  [2497] = 2033,
  [2498] = 2244,
  [2499] = 2031,
  [2500] = 2230,
  [2501] = 2242,
  [2502] = 2243,
  [2503] = 2195,
  [2504] = 2245,
  [2505] = 2259,
  [2506] = 2246,
  [2507] = 2260,
  [2508] = 2248,
  [2509] = 2261,
  [2510] = 2275,
  [2511] = 2285,
  [2512] = 2249,
  [2513] = 2248,
  [2514] = 1929,
  [2515] = 2244,
  [2516] = 2245,
  [2517] = 2246,
  [2518] = 2268,
  [2519] = 2248,
  [2520] = 2249,
  [2521] = 2250,
  [2522] = 1927,
  [2523] = 1925,
  [2524] = 2249,
  [2525] = 2250,
  [2526] = 2275,
  [2527] = 2252,
  [2528] = 1923,
  [2529] = 1934,
  [2530] = 1927,
  [2531] = 2283,
  [2532] = 1929,
  [2533] = 2250,
  [2534] = 1927,
  [2535] = 2285,
  [2536] = 1925,
  [2537] = 2252,
  [2538] = 1923,
  [2539] = 1934,
  [2540] = 1925,
  [2541] = 1927,
  [2542] = 2280,
  [2543] = 1929,
  [2544] = 1943,
  [2545] = 2275,
  [2546] = 1947,
  [2547] = 2282,
  [2548] = 2033,
  [2549] = 2031,
  [2550] = 2256,
  [2551] = 2257,
  [2552] = 2252,
  [2553] = 2259,
  [2554] = 2260,
  [2555] = 2261,
  [2556] = 2267,
  [2557] = 2268,
  [2558] = 1947,
  [2559] = 2033,
  [2560] = 2031,
  [2561] = 2260,
  [2562] = 1927,
  [2563] = 2033,
  [2564] = 1943,
  [2565] = 2031,
  [2566] = 2033,
  [2567] = 1929,
  [2568] = 2282,
  [2569] = 2275,
  [2570] = 2240,
  [2571] = 2230,
  [2572] = 2242,
  [2573] = 2031,
  [2574] = 2243,
  [2575] = 2283,
  [2576] = 2195,
  [2577] = 2280,
  [2578] = 1925,
  [2579] = 2256,
  [2580] = 2232,
  [2581] = 2257,
  [2582] = 2252,
  [2583] = 2285,
  [2584] = 2250,
  [2585] = 2249,
  [2586] = 2268,
  [2587] = 2248,
  [2588] = 2244,
  [2589] = 2246,
  [2590] = 2245,
  [2591] = 2244,
  [2592] = 2259,
  [2593] = 2267,
  [2594] = 2260,
  [2595] = 2261,
  [2596] = 2245,
  [2597] = 2597,
  [2598] = 2285,
  [2599] = 2240,
  [2600] = 2230,
  [2601] = 2242,
  [2602] = 2246,
  [2603] = 2232,
  [2604] = 2243,
  [2605] = 2249,
  [2606] = 2597,
  [2607] = 2232,
  [2608] = 2243,
  [2609] = 2242,
  [2610] = 2230,
  [2611] = 2240,
  [2612] = 2250,
  [2613] = 2248,
  [2614] = 2275,
  [2615] = 2252,
  [2616] = 1943,
  [2617] = 2195,
  [2618] = 2268,
  [2619] = 2267,
  [2620] = 1934,
  [2621] = 2244,
  [2622] = 2245,
  [2623] = 2246,
  [2624] = 2248,
  [2625] = 2267,
  [2626] = 2249,
  [2627] = 2250,
  [2628] = 2268,
  [2629] = 2252,
  [2630] = 1943,
  [2631] = 1947,
  [2632] = 2240,
  [2633] = 2597,
  [2634] = 2230,
  [2635] = 2242,
  [2636] = 1947,
  [2637] = 2195,
  [2638] = 2261,
  [2639] = 2195,
  [2640] = 2283,
  [2641] = 2275,
  [2642] = 1947,
  [2643] = 2243,
  [2644] = 1943,
  [2645] = 2256,
  [2646] = 2257,
  [2647] = 2260,
  [2648] = 2259,
  [2649] = 1934,
  [2650] = 2259,
  [2651] = 2261,
  [2652] = 2267,
  [2653] = 2268,
  [2654] = 1923,
  [2655] = 2256,
  [2656] = 1925,
  [2657] = 2283,
  [2658] = 2033,
  [2659] = 2257,
  [2660] = 2257,
  [2661] = 2259,
  [2662] = 2275,
  [2663] = 2260,
  [2664] = 1927,
  [2665] = 1929,
  [2666] = 2282,
  [2667] = 1929,
  [2668] = 1929,
  [2669] = 2280,
  [2670] = 2195,
  [2671] = 2261,
  [2672] = 2256,
  [2673] = 1927,
  [2674] = 2280,
  [2675] = 2240,
  [2676] = 2230,
  [2677] = 2242,
  [2678] = 2261,
  [2679] = 2260,
  [2680] = 2195,
  [2681] = 2243,
  [2682] = 2031,
  [2683] = 2259,
  [2684] = 2257,
  [2685] = 2256,
  [2686] = 2267,
  [2687] = 2268,
  [2688] = 2033,
  [2689] = 2285,
  [2690] = 2275,
  [2691] = 2282,
  [2692] = 2244,
  [2693] = 2245,
  [2694] = 2246,
  [2695] = 2248,
  [2696] = 2249,
  [2697] = 2250,
  [2698] = 2252,
  [2699] = 2282,
  [2700] = 1925,
  [2701] = 1923,
  [2702] = 2280,
  [2703] = 2240,
  [2704] = 2230,
  [2705] = 2242,
  [2706] = 2243,
  [2707] = 2244,
  [2708] = 2245,
  [2709] = 2285,
  [2710] = 2282,
  [2711] = 2244,
  [2712] = 2245,
  [2713] = 2246,
  [2714] = 2248,
  [2715] = 2249,
  [2716] = 2250,
  [2717] = 2252,
  [2718] = 1947,
  [2719] = 2280,
  [2720] = 2246,
  [2721] = 2248,
  [2722] = 2195,
  [2723] = 2285,
  [2724] = 2256,
  [2725] = 2249,
  [2726] = 2250,
  [2727] = 2257,
  [2728] = 2282,
  [2729] = 2259,
  [2730] = 2260,
  [2731] = 2261,
  [2732] = 2267,
  [2733] = 2252,
  [2734] = 2268,
  [2735] = 1923,
  [2736] = 2280,
  [2737] = 1934,
  [2738] = 1923,
  [2739] = 1925,
  [2740] = 2275,
  [2741] = 2031,
  [2742] = 2195,
  [2743] = 2285,
  [2744] = 1927,
  [2745] = 1934,
  [2746] = 2250,
  [2747] = 2230,
  [2748] = 2268,
  [2749] = 2246,
  [2750] = 2267,
  [2751] = 2240,
  [2752] = 2249,
  [2753] = 2248,
  [2754] = 2230,
  [2755] = 2246,
  [2756] = 2245,
  [2757] = 2242,
  [2758] = 2243,
  [2759] = 2246,
  [2760] = 2244,
  [2761] = 2275,
  [2762] = 2243,
  [2763] = 2261,
  [2764] = 2260,
  [2765] = 2259,
  [2766] = 2248,
  [2767] = 2245,
  [2768] = 2252,
  [2769] = 2257,
  [2770] = 2246,
  [2771] = 2256,
  [2772] = 2772,
  [2773] = 2282,
  [2774] = 2242,
  [2775] = 2230,
  [2776] = 2240,
  [2777] = 2261,
  [2778] = 2778,
  [2779] = 2260,
  [2780] = 2230,
  [2781] = 2245,
  [2782] = 2250,
  [2783] = 2285,
  [2784] = 2249,
  [2785] = 2244,
  [2786] = 2259,
  [2787] = 2244,
  [2788] = 2248,
  [2789] = 2275,
  [2790] = 2257,
  [2791] = 2249,
  [2792] = 2242,
  [2793] = 2268,
  [2794] = 2240,
  [2795] = 2230,
  [2796] = 2242,
  [2797] = 2260,
  [2798] = 2267,
  [2799] = 2243,
  [2800] = 2280,
  [2801] = 2259,
  [2802] = 2244,
  [2803] = 2245,
  [2804] = 2250,
  [2805] = 2256,
  [2806] = 2268,
  [2807] = 2246,
  [2808] = 2261,
  [2809] = 2244,
  [2810] = 2245,
  [2811] = 2246,
  [2812] = 2248,
  [2813] = 2248,
  [2814] = 2243,
  [2815] = 2249,
  [2816] = 2250,
  [2817] = 2282,
  [2818] = 2252,
  [2819] = 2249,
  [2820] = 2250,
  [2821] = 2275,
  [2822] = 2285,
  [2823] = 2240,
  [2824] = 2252,
  [2825] = 2282,
  [2826] = 2280,
  [2827] = 2240,
  [2828] = 2230,
  [2829] = 2285,
  [2830] = 2248,
  [2831] = 2252,
  [2832] = 2267,
  [2833] = 2242,
  [2834] = 2268,
  [2835] = 2772,
  [2836] = 2242,
  [2837] = 2243,
  [2838] = 2283,
  [2839] = 2242,
  [2840] = 2261,
  [2841] = 2252,
  [2842] = 2283,
  [2843] = 2245,
  [2844] = 2230,
  [2845] = 2261,
  [2846] = 2268,
  [2847] = 2195,
  [2848] = 2285,
  [2849] = 2260,
  [2850] = 2285,
  [2851] = 2245,
  [2852] = 2259,
  [2853] = 2261,
  [2854] = 2260,
  [2855] = 2252,
  [2856] = 2285,
  [2857] = 2250,
  [2858] = 2256,
  [2859] = 2283,
  [2860] = 2249,
  [2861] = 2257,
  [2862] = 2240,
  [2863] = 2248,
  [2864] = 2259,
  [2865] = 2256,
  [2866] = 2195,
  [2867] = 2259,
  [2868] = 2282,
  [2869] = 2260,
  [2870] = 2261,
  [2871] = 2243,
  [2872] = 2267,
  [2873] = 2268,
  [2874] = 2282,
  [2875] = 2240,
  [2876] = 2244,
  [2877] = 2245,
  [2878] = 2246,
  [2879] = 2280,
  [2880] = 2248,
  [2881] = 2195,
  [2882] = 2249,
  [2883] = 2232,
  [2884] = 2280,
  [2885] = 2257,
  [2886] = 2257,
  [2887] = 2280,
  [2888] = 2275,
  [2889] = 2250,
  [2890] = 2257,
  [2891] = 2256,
  [2892] = 2275,
  [2893] = 2893,
  [2894] = 2250,
  [2895] = 2257,
  [2896] = 2256,
  [2897] = 2280,
  [2898] = 2283,
  [2899] = 2246,
  [2900] = 2252,
  [2901] = 2195,
  [2902] = 2275,
  [2903] = 2252,
  [2904] = 2256,
  [2905] = 2282,
  [2906] = 2259,
  [2907] = 2275,
  [2908] = 2256,
  [2909] = 2249,
  [2910] = 2243,
  [2911] = 2282,
  [2912] = 2772,
  [2913] = 2240,
  [2914] = 2230,
  [2915] = 2242,
  [2916] = 2257,
  [2917] = 2275,
  [2918] = 2285,
  [2919] = 2259,
  [2920] = 2260,
  [2921] = 2243,
  [2922] = 2260,
  [2923] = 2261,
  [2924] = 2285,
  [2925] = 2267,
  [2926] = 2280,
  [2927] = 2268,
  [2928] = 2244,
  [2929] = 2280,
  [2930] = 2282,
  [2931] = 2244,
  [2932] = 2267,
  [2933] = 2267,
  [2934] = 2268,
  [2935] = 2267,
  [2936] = 2243,
  [2937] = 2282,
  [2938] = 2938,
  [2939] = 2275,
  [2940] = 2268,
  [2941] = 2261,
  [2942] = 2260,
  [2943] = 2259,
  [2944] = 2257,
  [2945] = 2267,
  [2946] = 2256,
  [2947] = 2285,
  [2948] = 2244,
  [2949] = 2252,
  [2950] = 2250,
  [2951] = 2249,
  [2952] = 2248,
  [2953] = 2246,
  [2954] = 2245,
  [2955] = 2240,
  [2956] = 2282,
  [2957] = 2275,
  [2958] = 2230,
  [2959] = 2938,
  [2960] = 2240,
  [2961] = 2242,
  [2962] = 2243,
  [2963] = 2285,
  [2964] = 2244,
  [2965] = 2245,
  [2966] = 2246,
  [2967] = 2248,
  [2968] = 2249,
  [2969] = 2250,
  [2970] = 2252,
  [2971] = 2268,
  [2972] = 2267,
  [2973] = 2280,
  [2974] = 2256,
  [2975] = 2257,
  [2976] = 2259,
  [2977] = 2260,
  [2978] = 2261,
  [2979] = 2267,
  [2980] = 2268,
  [2981] = 2230,
  [2982] = 2256,
  [2983] = 2275,
  [2984] = 2280,
  [2985] = 2261,
  [2986] = 2260,
  [2987] = 2259,
  [2988] = 2280,
  [2989] = 2240,
  [2990] = 2230,
  [2991] = 2242,
  [2992] = 2280,
  [2993] = 2240,
  [2994] = 2230,
  [2995] = 2243,
  [2996] = 2242,
  [2997] = 2243,
  [2998] = 2282,
  [2999] = 2244,
  [3000] = 2275,
  [3001] = 2245,
  [3002] = 2246,
  [3003] = 2248,
  [3004] = 2249,
  [3005] = 2250,
  [3006] = 2252,
  [3007] = 2282,
  [3008] = 2244,
  [3009] = 2245,
  [3010] = 2246,
  [3011] = 2248,
  [3012] = 2249,
  [3013] = 2250,
  [3014] = 2938,
  [3015] = 2252,
  [3016] = 2285,
  [3017] = 2257,
  [3018] = 2256,
  [3019] = 2242,
  [3020] = 2285,
  [3021] = 2283,
  [3022] = 2257,
  [3023] = 2268,
  [3024] = 2267,
  [3025] = 2259,
  [3026] = 2260,
  [3027] = 2261,
  [3028] = 3028,
  [3029] = 3029,
  [3030] = 3030,
  [3031] = 3031,
  [3032] = 3032,
  [3033] = 3033,
  [3034] = 3030,
  [3035] = 3035,
  [3036] = 3029,
  [3037] = 3037,
  [3038] = 3038,
  [3039] = 3039,
  [3040] = 3040,
  [3041] = 3041,
  [3042] = 3028,
  [3043] = 3043,
  [3044] = 3044,
  [3045] = 3045,
  [3046] = 3046,
  [3047] = 3033,
  [3048] = 3048,
  [3049] = 3049,
  [3050] = 3050,
  [3051] = 3051,
  [3052] = 3052,
  [3053] = 3053,
  [3054] = 3054,
  [3055] = 3055,
  [3056] = 3040,
  [3057] = 3041,
  [3058] = 3052,
  [3059] = 3044,
  [3060] = 3046,
  [3061] = 3061,
  [3062] = 3062,
  [3063] = 3063,
  [3064] = 3064,
  [3065] = 3065,
  [3066] = 3066,
  [3067] = 3067,
  [3068] = 3068,
  [3069] = 3069,
  [3070] = 3070,
  [3071] = 3045,
  [3072] = 3032,
  [3073] = 3035,
  [3074] = 3033,
  [3075] = 3075,
  [3076] = 3037,
  [3077] = 3077,
  [3078] = 3078,
  [3079] = 3069,
  [3080] = 3067,
  [3081] = 3065,
  [3082] = 3063,
  [3083] = 3062,
  [3084] = 3061,
  [3085] = 3050,
  [3086] = 3048,
  [3087] = 3078,
  [3088] = 3037,
  [3089] = 3030,
  [3090] = 3029,
  [3091] = 3077,
  [3092] = 3038,
  [3093] = 3039,
  [3094] = 3049,
  [3095] = 3043,
  [3096] = 3096,
  [3097] = 3046,
  [3098] = 3075,
  [3099] = 3049,
  [3100] = 3055,
  [3101] = 3031,
  [3102] = 3051,
  [3103] = 3070,
  [3104] = 3038,
  [3105] = 3053,
  [3106] = 3068,
  [3107] = 3031,
  [3108] = 3066,
  [3109] = 3049,
  [3110] = 3064,
  [3111] = 3046,
  [3112] = 3054,
  [3113] = 3039,
  [3114] = 3032,
  [3115] = 3038,
  [3116] = 3054,
  [3117] = 3030,
  [3118] = 3048,
  [3119] = 3033,
  [3120] = 3050,
  [3121] = 3032,
  [3122] = 3061,
  [3123] = 3045,
  [3124] = 3062,
  [3125] = 3044,
  [3126] = 3054,
  [3127] = 3028,
  [3128] = 3053,
  [3129] = 3041,
  [3130] = 3052,
  [3131] = 3040,
  [3132] = 3063,
  [3133] = 3051,
  [3134] = 3065,
  [3135] = 3067,
  [3136] = 3069,
  [3137] = 3078,
  [3138] = 3077,
  [3139] = 3037,
  [3140] = 3096,
  [3141] = 3075,
  [3142] = 3070,
  [3143] = 3068,
  [3144] = 3031,
  [3145] = 3035,
  [3146] = 3029,
  [3147] = 3043,
  [3148] = 3055,
  [3149] = 3035,
  [3150] = 3029,
  [3151] = 3043,
  [3152] = 3055,
  [3153] = 3066,
  [3154] = 3064,
  [3155] = 3064,
  [3156] = 3066,
  [3157] = 3045,
  [3158] = 3068,
  [3159] = 3070,
  [3160] = 3054,
  [3161] = 3053,
  [3162] = 3052,
  [3163] = 3051,
  [3164] = 3035,
  [3165] = 3039,
  [3166] = 3029,
  [3167] = 3028,
  [3168] = 3041,
  [3169] = 3043,
  [3170] = 3055,
  [3171] = 3040,
  [3172] = 3035,
  [3173] = 3029,
  [3174] = 3043,
  [3175] = 3031,
  [3176] = 3055,
  [3177] = 3035,
  [3178] = 3029,
  [3179] = 3040,
  [3180] = 3043,
  [3181] = 3041,
  [3182] = 3028,
  [3183] = 3044,
  [3184] = 3045,
  [3185] = 3032,
  [3186] = 3055,
  [3187] = 3033,
  [3188] = 3051,
  [3189] = 3052,
  [3190] = 3053,
  [3191] = 3054,
  [3192] = 3053,
  [3193] = 3035,
  [3194] = 3029,
  [3195] = 3043,
  [3196] = 3075,
  [3197] = 3055,
  [3198] = 3030,
  [3199] = 3096,
  [3200] = 3038,
  [3201] = 3064,
  [3202] = 3039,
  [3203] = 3066,
  [3204] = 3046,
  [3205] = 3068,
  [3206] = 3049,
  [3207] = 3070,
  [3208] = 3035,
  [3209] = 3077,
  [3210] = 3078,
  [3211] = 3043,
  [3212] = 3075,
  [3213] = 3037,
  [3214] = 3077,
  [3215] = 3078,
  [3216] = 3069,
  [3217] = 3067,
  [3218] = 3065,
  [3219] = 3063,
  [3220] = 3062,
  [3221] = 3061,
  [3222] = 3050,
  [3223] = 3048,
  [3224] = 3044,
  [3225] = 3069,
  [3226] = 3067,
  [3227] = 3065,
  [3228] = 3063,
  [3229] = 3062,
  [3230] = 3061,
  [3231] = 3050,
  [3232] = 3040,
  [3233] = 3055,
  [3234] = 3048,
  [3235] = 3041,
  [3236] = 3035,
  [3237] = 3028,
  [3238] = 3044,
  [3239] = 3045,
  [3240] = 3032,
  [3241] = 3033,
  [3242] = 3030,
  [3243] = 3052,
  [3244] = 3031,
  [3245] = 3038,
  [3246] = 3049,
  [3247] = 3039,
  [3248] = 3046,
  [3249] = 3046,
  [3250] = 3039,
  [3251] = 3049,
  [3252] = 3038,
  [3253] = 3048,
  [3254] = 3030,
  [3255] = 3050,
  [3256] = 3033,
  [3257] = 3061,
  [3258] = 3032,
  [3259] = 3062,
  [3260] = 3045,
  [3261] = 3063,
  [3262] = 3044,
  [3263] = 3065,
  [3264] = 3028,
  [3265] = 3067,
  [3266] = 3041,
  [3267] = 3069,
  [3268] = 3040,
  [3269] = 3031,
  [3270] = 3078,
  [3271] = 3029,
  [3272] = 3043,
  [3273] = 3077,
  [3274] = 3055,
  [3275] = 3037,
  [3276] = 3031,
  [3277] = 3048,
  [3278] = 3050,
  [3279] = 3096,
  [3280] = 3061,
  [3281] = 3075,
  [3282] = 3062,
  [3283] = 3063,
  [3284] = 3065,
  [3285] = 3067,
  [3286] = 3070,
  [3287] = 3068,
  [3288] = 3066,
  [3289] = 3064,
  [3290] = 3035,
  [3291] = 3069,
  [3292] = 3078,
  [3293] = 3077,
  [3294] = 3037,
  [3295] = 3096,
  [3296] = 3075,
  [3297] = 3049,
  [3298] = 3046,
  [3299] = 3070,
  [3300] = 3039,
  [3301] = 3061,
  [3302] = 3054,
  [3303] = 3029,
  [3304] = 3068,
  [3305] = 3053,
  [3306] = 3052,
  [3307] = 3038,
  [3308] = 3051,
  [3309] = 3043,
  [3310] = 3055,
  [3311] = 3066,
  [3312] = 3035,
  [3313] = 3029,
  [3314] = 3043,
  [3315] = 3055,
  [3316] = 3035,
  [3317] = 3029,
  [3318] = 3051,
  [3319] = 3052,
  [3320] = 3043,
  [3321] = 3053,
  [3322] = 3054,
  [3323] = 3064,
  [3324] = 3030,
  [3325] = 3051,
  [3326] = 3052,
  [3327] = 3053,
  [3328] = 3054,
  [3329] = 3033,
  [3330] = 3032,
  [3331] = 3055,
  [3332] = 3045,
  [3333] = 3044,
  [3334] = 3028,
  [3335] = 3041,
  [3336] = 3054,
  [3337] = 3053,
  [3338] = 3064,
  [3339] = 3052,
  [3340] = 3066,
  [3341] = 3051,
  [3342] = 3068,
  [3343] = 3066,
  [3344] = 3070,
  [3345] = 3051,
  [3346] = 3040,
  [3347] = 3035,
  [3348] = 3029,
  [3349] = 3075,
  [3350] = 3096,
  [3351] = 3037,
  [3352] = 3077,
  [3353] = 3078,
  [3354] = 3069,
  [3355] = 3067,
  [3356] = 3065,
  [3357] = 3063,
  [3358] = 3062,
  [3359] = 3061,
  [3360] = 3050,
  [3361] = 3048,
  [3362] = 3064,
  [3363] = 3043,
  [3364] = 3055,
  [3365] = 3052,
  [3366] = 3053,
  [3367] = 3054,
  [3368] = 3068,
  [3369] = 3035,
  [3370] = 3029,
  [3371] = 3048,
  [3372] = 3043,
  [3373] = 3055,
  [3374] = 3070,
  [3375] = 3051,
  [3376] = 3064,
  [3377] = 3035,
  [3378] = 3029,
  [3379] = 3043,
  [3380] = 3055,
  [3381] = 3066,
  [3382] = 3031,
  [3383] = 3068,
  [3384] = 3049,
  [3385] = 3040,
  [3386] = 3046,
  [3387] = 3041,
  [3388] = 3039,
  [3389] = 3028,
  [3390] = 3038,
  [3391] = 3044,
  [3392] = 3030,
  [3393] = 3045,
  [3394] = 3033,
  [3395] = 3032,
  [3396] = 3032,
  [3397] = 3033,
  [3398] = 3045,
  [3399] = 3030,
  [3400] = 3044,
  [3401] = 3038,
  [3402] = 3028,
  [3403] = 3039,
  [3404] = 3041,
  [3405] = 3046,
  [3406] = 3040,
  [3407] = 3070,
  [3408] = 3049,
  [3409] = 3075,
  [3410] = 3035,
  [3411] = 3031,
  [3412] = 3040,
  [3413] = 3029,
  [3414] = 3043,
  [3415] = 3055,
  [3416] = 3096,
  [3417] = 3064,
  [3418] = 3075,
  [3419] = 3050,
  [3420] = 3035,
  [3421] = 3029,
  [3422] = 3043,
  [3423] = 3055,
  [3424] = 3096,
  [3425] = 3037,
  [3426] = 3077,
  [3427] = 3078,
  [3428] = 3035,
  [3429] = 3029,
  [3430] = 3043,
  [3431] = 3055,
  [3432] = 3048,
  [3433] = 3069,
  [3434] = 3067,
  [3435] = 3065,
  [3436] = 3063,
  [3437] = 3035,
  [3438] = 3050,
  [3439] = 3062,
  [3440] = 3029,
  [3441] = 3043,
  [3442] = 3063,
  [3443] = 3061,
  [3444] = 3062,
  [3445] = 3065,
  [3446] = 3063,
  [3447] = 3055,
  [3448] = 3062,
  [3449] = 3065,
  [3450] = 3067,
  [3451] = 3069,
  [3452] = 3067,
  [3453] = 3069,
  [3454] = 3078,
  [3455] = 3061,
  [3456] = 3077,
  [3457] = 3037,
  [3458] = 3078,
  [3459] = 3096,
  [3460] = 3075,
  [3461] = 3078,
  [3462] = 3077,
  [3463] = 3051,
  [3464] = 3052,
  [3465] = 3053,
  [3466] = 3054,
  [3467] = 3050,
  [3468] = 3041,
  [3469] = 3048,
  [3470] = 3028,
  [3471] = 3070,
  [3472] = 3037,
  [3473] = 3068,
  [3474] = 3096,
  [3475] = 3066,
  [3476] = 3064,
  [3477] = 3064,
  [3478] = 3066,
  [3479] = 3035,
  [3480] = 3068,
  [3481] = 3029,
  [3482] = 3070,
  [3483] = 3066,
  [3484] = 3043,
  [3485] = 3055,
  [3486] = 3044,
  [3487] = 3075,
  [3488] = 3096,
  [3489] = 3037,
  [3490] = 3077,
  [3491] = 3078,
  [3492] = 3069,
  [3493] = 3067,
  [3494] = 3065,
  [3495] = 3063,
  [3496] = 3062,
  [3497] = 3061,
  [3498] = 3050,
  [3499] = 3048,
  [3500] = 3077,
  [3501] = 3045,
  [3502] = 3078,
  [3503] = 3032,
  [3504] = 3069,
  [3505] = 3033,
  [3506] = 3067,
  [3507] = 3075,
  [3508] = 3030,
  [3509] = 3035,
  [3510] = 3038,
  [3511] = 3029,
  [3512] = 3043,
  [3513] = 3039,
  [3514] = 3054,
  [3515] = 3053,
  [3516] = 3052,
  [3517] = 3051,
  [3518] = 3068,
  [3519] = 3055,
  [3520] = 3031,
  [3521] = 3065,
  [3522] = 3049,
  [3523] = 3070,
  [3524] = 3046,
  [3525] = 3031,
  [3526] = 3039,
  [3527] = 3063,
  [3528] = 3038,
  [3529] = 3062,
  [3530] = 3030,
  [3531] = 3037,
  [3532] = 3033,
  [3533] = 3035,
  [3534] = 3032,
  [3535] = 3029,
  [3536] = 3045,
  [3537] = 3043,
  [3538] = 3044,
  [3539] = 3075,
  [3540] = 3028,
  [3541] = 3096,
  [3542] = 3041,
  [3543] = 3037,
  [3544] = 3040,
  [3545] = 3046,
  [3546] = 3055,
  [3547] = 3050,
  [3548] = 3049,
  [3549] = 3077,
  [3550] = 3048,
  [3551] = 3078,
  [3552] = 3031,
  [3553] = 3035,
  [3554] = 3029,
  [3555] = 3069,
  [3556] = 3043,
  [3557] = 3055,
  [3558] = 3031,
  [3559] = 3049,
  [3560] = 3035,
  [3561] = 3029,
  [3562] = 3043,
  [3563] = 3067,
  [3564] = 3055,
  [3565] = 3065,
  [3566] = 3046,
  [3567] = 3039,
  [3568] = 3038,
  [3569] = 3030,
  [3570] = 3035,
  [3571] = 3029,
  [3572] = 3043,
  [3573] = 3048,
  [3574] = 3050,
  [3575] = 3061,
  [3576] = 3062,
  [3577] = 3063,
  [3578] = 3065,
  [3579] = 3055,
  [3580] = 3070,
  [3581] = 3067,
  [3582] = 3069,
  [3583] = 3040,
  [3584] = 3041,
  [3585] = 3033,
  [3586] = 3032,
  [3587] = 3028,
  [3588] = 3068,
  [3589] = 3044,
  [3590] = 3045,
  [3591] = 3032,
  [3592] = 3033,
  [3593] = 3045,
  [3594] = 3030,
  [3595] = 3038,
  [3596] = 3066,
  [3597] = 3039,
  [3598] = 3046,
  [3599] = 3051,
  [3600] = 3049,
  [3601] = 3051,
  [3602] = 3052,
  [3603] = 3053,
  [3604] = 3054,
  [3605] = 3077,
  [3606] = 3037,
  [3607] = 3075,
  [3608] = 3052,
  [3609] = 3053,
  [3610] = 3064,
  [3611] = 3054,
  [3612] = 3031,
  [3613] = 3049,
  [3614] = 3064,
  [3615] = 3062,
  [3616] = 3066,
  [3617] = 3061,
  [3618] = 3068,
  [3619] = 3070,
  [3620] = 3070,
  [3621] = 3046,
  [3622] = 3068,
  [3623] = 3028,
  [3624] = 3066,
  [3625] = 3075,
  [3626] = 3096,
  [3627] = 3037,
  [3628] = 3077,
  [3629] = 3078,
  [3630] = 3069,
  [3631] = 3067,
  [3632] = 3065,
  [3633] = 3063,
  [3634] = 3062,
  [3635] = 3061,
  [3636] = 3050,
  [3637] = 3048,
  [3638] = 3050,
  [3639] = 3041,
  [3640] = 3064,
  [3641] = 3040,
  [3642] = 3039,
  [3643] = 3051,
  [3644] = 3038,
  [3645] = 3048,
  [3646] = 3030,
  [3647] = 3064,
  [3648] = 3033,
  [3649] = 3066,
  [3650] = 3054,
  [3651] = 3053,
  [3652] = 3052,
  [3653] = 3051,
  [3654] = 3048,
  [3655] = 3052,
  [3656] = 3032,
  [3657] = 3050,
  [3658] = 3031,
  [3659] = 3061,
  [3660] = 3049,
  [3661] = 3062,
  [3662] = 3046,
  [3663] = 3063,
  [3664] = 3039,
  [3665] = 3065,
  [3666] = 3038,
  [3667] = 3067,
  [3668] = 3030,
  [3669] = 3069,
  [3670] = 3033,
  [3671] = 3078,
  [3672] = 3032,
  [3673] = 3077,
  [3674] = 3045,
  [3675] = 3037,
  [3676] = 3044,
  [3677] = 3096,
  [3678] = 3028,
  [3679] = 3075,
  [3680] = 3041,
  [3681] = 3053,
  [3682] = 3040,
  [3683] = 3068,
  [3684] = 3045,
  [3685] = 3070,
  [3686] = 3044,
  [3687] = 3070,
  [3688] = 3054,
  [3689] = 3068,
  [3690] = 3061,
  [3691] = 3041,
  [3692] = 3040,
  [3693] = 3066,
  [3694] = 3040,
  [3695] = 3041,
  [3696] = 3064,
  [3697] = 3075,
  [3698] = 3096,
  [3699] = 3040,
  [3700] = 3028,
  [3701] = 3044,
  [3702] = 3054,
  [3703] = 3054,
  [3704] = 3053,
  [3705] = 3052,
  [3706] = 3051,
  [3707] = 3045,
  [3708] = 3037,
  [3709] = 3077,
  [3710] = 3077,
  [3711] = 3051,
  [3712] = 3052,
  [3713] = 3053,
  [3714] = 3032,
  [3715] = 3064,
  [3716] = 3040,
  [3717] = 3041,
  [3718] = 3041,
  [3719] = 3078,
  [3720] = 3069,
  [3721] = 3054,
  [3722] = 3067,
  [3723] = 3028,
  [3724] = 3065,
  [3725] = 3040,
  [3726] = 3053,
  [3727] = 3052,
  [3728] = 3063,
  [3729] = 3033,
  [3730] = 3061,
  [3731] = 3050,
  [3732] = 3066,
  [3733] = 3041,
  [3734] = 3051,
  [3735] = 3062,
  [3736] = 3068,
  [3737] = 3028,
  [3738] = 3070,
  [3739] = 3051,
  [3740] = 3052,
  [3741] = 3053,
  [3742] = 3054,
  [3743] = 3048,
  [3744] = 3044,
  [3745] = 3045,
  [3746] = 3032,
  [3747] = 3033,
  [3748] = 3063,
  [3749] = 3030,
  [3750] = 3064,
  [3751] = 3038,
  [3752] = 3064,
  [3753] = 3037,
  [3754] = 3066,
  [3755] = 3039,
  [3756] = 3068,
  [3757] = 3077,
  [3758] = 3070,
  [3759] = 3040,
  [3760] = 3041,
  [3761] = 3046,
  [3762] = 3078,
  [3763] = 3075,
  [3764] = 3096,
  [3765] = 3037,
  [3766] = 3077,
  [3767] = 3078,
  [3768] = 3069,
  [3769] = 3067,
  [3770] = 3065,
  [3771] = 3063,
  [3772] = 3062,
  [3773] = 3061,
  [3774] = 3050,
  [3775] = 3048,
  [3776] = 3028,
  [3777] = 3049,
  [3778] = 3069,
  [3779] = 3031,
  [3780] = 3044,
  [3781] = 3067,
  [3782] = 3065,
  [3783] = 3045,
  [3784] = 3032,
  [3785] = 3033,
  [3786] = 3063,
  [3787] = 3062,
  [3788] = 3030,
  [3789] = 3038,
  [3790] = 3039,
  [3791] = 3046,
  [3792] = 3049,
  [3793] = 3031,
  [3794] = 3061,
  [3795] = 3050,
  [3796] = 3031,
  [3797] = 3048,
  [3798] = 3049,
  [3799] = 3048,
  [3800] = 3046,
  [3801] = 3044,
  [3802] = 3039,
  [3803] = 3030,
  [3804] = 3038,
  [3805] = 3050,
  [3806] = 3030,
  [3807] = 3061,
  [3808] = 3033,
  [3809] = 3038,
  [3810] = 3032,
  [3811] = 3062,
  [3812] = 3045,
  [3813] = 3063,
  [3814] = 3044,
  [3815] = 3065,
  [3816] = 3028,
  [3817] = 3067,
  [3818] = 3041,
  [3819] = 3069,
  [3820] = 3040,
  [3821] = 3078,
  [3822] = 3077,
  [3823] = 3037,
  [3824] = 3096,
  [3825] = 3048,
  [3826] = 3075,
  [3827] = 3050,
  [3828] = 3070,
  [3829] = 3068,
  [3830] = 3028,
  [3831] = 3061,
  [3832] = 3066,
  [3833] = 3045,
  [3834] = 3051,
  [3835] = 3063,
  [3836] = 3065,
  [3837] = 3067,
  [3838] = 3069,
  [3839] = 3078,
  [3840] = 3077,
  [3841] = 3037,
  [3842] = 3096,
  [3843] = 3075,
  [3844] = 3033,
  [3845] = 3044,
  [3846] = 3066,
  [3847] = 3054,
  [3848] = 3053,
  [3849] = 3052,
  [3850] = 3051,
  [3851] = 3031,
  [3852] = 3068,
  [3853] = 3070,
  [3854] = 3068,
  [3855] = 3052,
  [3856] = 3066,
  [3857] = 3064,
  [3858] = 3053,
  [3859] = 3039,
  [3860] = 3046,
  [3861] = 3054,
  [3862] = 3035,
  [3863] = 3032,
  [3864] = 3049,
  [3865] = 3049,
  [3866] = 3046,
  [3867] = 3031,
  [3868] = 3039,
  [3869] = 3029,
  [3870] = 3038,
  [3871] = 3054,
  [3872] = 3043,
  [3873] = 3053,
  [3874] = 3052,
  [3875] = 3051,
  [3876] = 3049,
  [3877] = 3051,
  [3878] = 3052,
  [3879] = 3053,
  [3880] = 3054,
  [3881] = 3030,
  [3882] = 3052,
  [3883] = 3055,
  [3884] = 3031,
  [3885] = 3031,
  [3886] = 3048,
  [3887] = 3032,
  [3888] = 3033,
  [3889] = 3035,
  [3890] = 3064,
  [3891] = 3064,
  [3892] = 3066,
  [3893] = 3049,
  [3894] = 3068,
  [3895] = 3066,
  [3896] = 3070,
  [3897] = 3050,
  [3898] = 3068,
  [3899] = 3070,
  [3900] = 3032,
  [3901] = 3075,
  [3902] = 3096,
  [3903] = 3037,
  [3904] = 3077,
  [3905] = 3078,
  [3906] = 3069,
  [3907] = 3067,
  [3908] = 3065,
  [3909] = 3063,
  [3910] = 3062,
  [3911] = 3061,
  [3912] = 3050,
  [3913] = 3048,
  [3914] = 3046,
  [3915] = 3061,
  [3916] = 3070,
  [3917] = 3045,
  [3918] = 3044,
  [3919] = 3028,
  [3920] = 3062,
  [3921] = 3063,
  [3922] = 3041,
  [3923] = 3048,
  [3924] = 3040,
  [3925] = 3050,
  [3926] = 3029,
  [3927] = 3043,
  [3928] = 3045,
  [3929] = 3044,
  [3930] = 3075,
  [3931] = 3075,
  [3932] = 3032,
  [3933] = 3031,
  [3934] = 3061,
  [3935] = 3049,
  [3936] = 3040,
  [3937] = 3046,
  [3938] = 3062,
  [3939] = 3039,
  [3940] = 3040,
  [3941] = 3038,
  [3942] = 3033,
  [3943] = 3030,
  [3944] = 3041,
  [3945] = 3033,
  [3946] = 3030,
  [3947] = 3032,
  [3948] = 3028,
  [3949] = 3045,
  [3950] = 3039,
  [3951] = 3044,
  [3952] = 3063,
  [3953] = 3028,
  [3954] = 3075,
  [3955] = 3041,
  [3956] = 3044,
  [3957] = 3040,
  [3958] = 3096,
  [3959] = 3038,
  [3960] = 3045,
  [3961] = 3038,
  [3962] = 3032,
  [3963] = 3039,
  [3964] = 3033,
  [3965] = 3037,
  [3966] = 3030,
  [3967] = 3046,
  [3968] = 3038,
  [3969] = 3051,
  [3970] = 3039,
  [3971] = 3051,
  [3972] = 3040,
  [3973] = 3041,
  [3974] = 3028,
  [3975] = 3044,
  [3976] = 3045,
  [3977] = 3065,
  [3978] = 3065,
  [3979] = 3077,
  [3980] = 3031,
  [3981] = 3055,
  [3982] = 3067,
  [3983] = 3046,
  [3984] = 3053,
  [3985] = 3049,
  [3986] = 3054,
  [3987] = 3031,
  [3988] = 3028,
  [3989] = 3989,
  [3990] = 3067,
  [3991] = 3064,
  [3992] = 3066,
  [3993] = 3068,
  [3994] = 3070,
  [3995] = 3033,
  [3996] = 3078,
  [3997] = 3052,
  [3998] = 3096,
  [3999] = 3030,
  [4000] = 3037,
  [4001] = 3038,
  [4002] = 3064,
  [4003] = 3039,
  [4004] = 3069,
  [4005] = 3053,
  [4006] = 3054,
  [4007] = 3067,
  [4008] = 3069,
  [4009] = 3040,
  [4010] = 3046,
  [4011] = 3075,
  [4012] = 3051,
  [4013] = 3052,
  [4014] = 3053,
  [4015] = 3054,
  [4016] = 3049,
  [4017] = 3048,
  [4018] = 3031,
  [4019] = 3050,
  [4020] = 3061,
  [4021] = 3062,
  [4022] = 3065,
  [4023] = 3063,
  [4024] = 3065,
  [4025] = 3064,
  [4026] = 3032,
  [4027] = 3066,
  [4028] = 3067,
  [4029] = 3068,
  [4030] = 3041,
  [4031] = 3070,
  [4032] = 3041,
  [4033] = 3030,
  [4034] = 3069,
  [4035] = 3078,
  [4036] = 3075,
  [4037] = 3096,
  [4038] = 3037,
  [4039] = 3077,
  [4040] = 3078,
  [4041] = 3069,
  [4042] = 3067,
  [4043] = 3065,
  [4044] = 3063,
  [4045] = 3062,
  [4046] = 3061,
  [4047] = 3050,
  [4048] = 3048,
  [4049] = 3077,
  [4050] = 3037,
  [4051] = 3096,
  [4052] = 3075,
  [4053] = 3070,
  [4054] = 3096,
  [4055] = 3068,
  [4056] = 3049,
  [4057] = 3028,
  [4058] = 3037,
  [4059] = 3066,
  [4060] = 3044,
  [4061] = 3077,
  [4062] = 3045,
  [4063] = 3064,
  [4064] = 3062,
  [4065] = 3078,
  [4066] = 3078,
  [4067] = 3069,
  [4068] = 3031,
  [4069] = 3033,
  [4070] = 3049,
  [4071] = 3048,
  [4072] = 3046,
  [4073] = 3030,
  [4074] = 3039,
  [4075] = 3050,
  [4076] = 3038,
  [4077] = 3038,
  [4078] = 3030,
  [4079] = 3061,
  [4080] = 3033,
  [4081] = 3039,
  [4082] = 3032,
  [4083] = 3062,
  [4084] = 3045,
  [4085] = 3046,
  [4086] = 3044,
  [4087] = 3063,
  [4088] = 3028,
  [4089] = 4089,
  [4090] = 4090,
  [4091] = 4091,
  [4092] = 4092,
  [4093] = 4091,
  [4094] = 4094,
  [4095] = 4091,
  [4096] = 4094,
  [4097] = 4090,
  [4098] = 4098,
  [4099] = 4099,
  [4100] = 4092,
  [4101] = 4091,
  [4102] = 4094,
  [4103] = 4091,
  [4104] = 4104,
  [4105] = 4094,
  [4106] = 4091,
  [4107] = 4094,
  [4108] = 4091,
  [4109] = 4090,
  [4110] = 4098,
  [4111] = 4094,
  [4112] = 4099,
  [4113] = 4092,
  [4114] = 4114,
  [4115] = 4091,
  [4116] = 4094,
  [4117] = 4091,
  [4118] = 4104,
  [4119] = 4094,
  [4120] = 4091,
  [4121] = 4094,
  [4122] = 4091,
  [4123] = 4094,
  [4124] = 4094,
  [4125] = 4092,
  [4126] = 4089,
  [4127] = 4091,
  [4128] = 4094,
  [4129] = 4091,
  [4130] = 4094,
  [4131] = 4099,
  [4132] = 4098,
  [4133] = 4091,
  [4134] = 4094,
  [4135] = 4092,
  [4136] = 4098,
  [4137] = 4099,
  [4138] = 4099,
  [4139] = 4090,
  [4140] = 4090,
  [4141] = 4092,
  [4142] = 4091,
  [4143] = 4092,
  [4144] = 4092,
  [4145] = 4099,
  [4146] = 4094,
  [4147] = 4091,
  [4148] = 4094,
  [4149] = 4091,
  [4150] = 4094,
  [4151] = 4091,
  [4152] = 4098,
  [4153] = 4094,
  [4154] = 4154,
  [4155] = 4091,
  [4156] = 4094,
  [4157] = 4091,
  [4158] = 4094,
  [4159] = 4090,
  [4160] = 4114,
  [4161] = 4091,
  [4162] = 4104,
  [4163] = 4094,
  [4164] = 4099,
  [4165] = 4090,
  [4166] = 4089,
  [4167] = 4090,
  [4168] = 4098,
  [4169] = 4098,
  [4170] = 4099,
  [4171] = 4091,
  [4172] = 4094,
  [4173] = 4091,
  [4174] = 4092,
  [4175] = 4094,
  [4176] = 4091,
  [4177] = 4094,
  [4178] = 4091,
  [4179] = 4094,
  [4180] = 4090,
  [4181] = 4091,
  [4182] = 4094,
  [4183] = 4091,
  [4184] = 4090,
  [4185] = 4099,
  [4186] = 4098,
  [4187] = 4090,
  [4188] = 4098,
  [4189] = 4099,
  [4190] = 4089,
  [4191] = 4099,
  [4192] = 4104,
  [4193] = 4114,
  [4194] = 4098,
  [4195] = 4114,
  [4196] = 4090,
  [4197] = 4154,
  [4198] = 4092,
  [4199] = 4098,
  [4200] = 4099,
  [4201] = 4099,
  [4202] = 4092,
  [4203] = 4092,
  [4204] = 4099,
  [4205] = 4098,
  [4206] = 4089,
  [4207] = 4092,
  [4208] = 4098,
  [4209] = 4090,
  [4210] = 4090,
  [4211] = 4090,
  [4212] = 4098,
  [4213] = 4104,
  [4214] = 4099,
  [4215] = 4104,
  [4216] = 4114,
  [4217] = 4154,
  [4218] = 4090,
  [4219] = 4090,
  [4220] = 4089,
  [4221] = 4098,
  [4222] = 4104,
  [4223] = 4099,
  [4224] = 4099,
  [4225] = 4114,
  [4226] = 4098,
  [4227] = 4154,
  [4228] = 4089,
  [4229] = 4092,
  [4230] = 4154,
  [4231] = 4092,
  [4232] = 4092,
  [4233] = 4090,
  [4234] = 4104,
  [4235] = 4114,
  [4236] = 4154,
  [4237] = 4099,
  [4238] = 4089,
  [4239] = 4092,
  [4240] = 4098,
  [4241] = 4089,
  [4242] = 4114,
  [4243] = 4154,
  [4244] = 4089,
  [4245] = 4154,
  [4246] = 4104,
  [4247] = 4090,
  [4248] = 4114,
  [4249] = 4091,
  [4250] = 4154,
  [4251] = 4154,
  [4252] = 4099,
  [4253] = 4089,
  [4254] = 4098,
  [4255] = 4092,
  [4256] = 4104,
  [4257] = 4098,
  [4258] = 4114,
  [4259] = 4154,
  [4260] = 4099,
  [4261] = 4094,
  [4262] = 4094,
  [4263] = 4098,
  [4264] = 4104,
  [4265] = 4092,
  [4266] = 4114,
  [4267] = 4154,
  [4268] = 4089,
  [4269] = 4092,
  [4270] = 4104,
  [4271] = 4154,
  [4272] = 4114,
  [4273] = 4114,
  [4274] = 4090,
  [4275] = 4098,
  [4276] = 4099,
  [4277] = 4114,
  [4278] = 4092,
  [4279] = 4104,
  [4280] = 4090,
  [4281] = 4154,
  [4282] = 4089,
  [4283] = 4092,
  [4284] = 4089,
  [4285] = 4092,
  [4286] = 4104,
  [4287] = 4114,
  [4288] = 4089,
  [4289] = 4104,
  [4290] = 4154,
  [4291] = 4089,
  [4292] = 4104,
  [4293] = 4092,
  [4294] = 4114,
  [4295] = 4099,
  [4296] = 4154,
  [4297] = 4098,
  [4298] = 4154,
  [4299] = 4090,
  [4300] = 4089,
  [4301] = 4104,
  [4302] = 4092,
  [4303] = 4099,
  [4304] = 4114,
  [4305] = 4104,
  [4306] = 4104,
  [4307] = 4114,
  [4308] = 4089,
  [4309] = 4089,
  [4310] = 4154,
  [4311] = 4098,
  [4312] = 4114,
  [4313] = 4154,
  [4314] = 4114,
  [4315] = 4154,
  [4316] = 4090,
  [4317] = 4089,
  [4318] = 4104,
  [4319] = 4098,
  [4320] = 4114,
  [4321] = 4090,
  [4322] = 4154,
  [4323] = 4099,
  [4324] = 4089,
  [4325] = 4154,
  [4326] = 4090,
  [4327] = 4092,
  [4328] = 4104,
  [4329] = 4099,
  [4330] = 4098,
  [4331] = 4114,
  [4332] = 4089,
  [4333] = 4104,
  [4334] = 4104,
  [4335] = 4154,
  [4336] = 4089,
  [4337] = 4089,
  [4338] = 4114,
  [4339] = 4154,
  [4340] = 4104,
  [4341] = 4098,
  [4342] = 4114,
  [4343] = 4089,
  [4344] = 4114,
  [4345] = 4099,
  [4346] = 4104,
  [4347] = 4104,
  [4348] = 4114,
  [4349] = 4090,
  [4350] = 4154,
  [4351] = 4090,
  [4352] = 4154,
  [4353] = 4092,
  [4354] = 4154,
  [4355] = 4089,
  [4356] = 4114,
  [4357] = 4092,
  [4358] = 4104,
  [4359] = 4089,
  [4360] = 4099,
  [4361] = 4089,
  [4362] = 4098,
  [4363] = 4154,
  [4364] = 4098,
  [4365] = 4104,
  [4366] = 4099,
  [4367] = 4114,
  [4368] = 4090,
  [4369] = 780,
  [4370] = 778,
  [4371] = 778,
  [4372] = 780,
  [4373] = 968,
  [4374] = 476,
  [4375] = 484,
  [4376] = 479,
  [4377] = 477,
  [4378] = 476,
  [4379] = 968,
  [4380] = 484,
  [4381] = 479,
  [4382] = 477,
  [4383] = 515,
  [4384] = 516,
  [4385] = 525,
  [4386] = 2195,
  [4387] = 520,
  [4388] = 526,
  [4389] = 551,
  [4390] = 519,
  [4391] = 527,
  [4392] = 550,
  [4393] = 549,
  [4394] = 518,
  [4395] = 548,
  [4396] = 517,
  [4397] = 547,
  [4398] = 546,
  [4399] = 545,
  [4400] = 556,
  [4401] = 555,
  [4402] = 543,
  [4403] = 528,
  [4404] = 529,
  [4405] = 530,
  [4406] = 514,
  [4407] = 531,
  [4408] = 521,
  [4409] = 508,
  [4410] = 524,
  [4411] = 544,
  [4412] = 552,
  [4413] = 541,
  [4414] = 562,
  [4415] = 533,
  [4416] = 540,
  [4417] = 500,
  [4418] = 513,
  [4419] = 535,
  [4420] = 512,
  [4421] = 561,
  [4422] = 511,
  [4423] = 510,
  [4424] = 509,
  [4425] = 560,
  [4426] = 559,
  [4427] = 536,
  [4428] = 534,
  [4429] = 558,
  [4430] = 523,
  [4431] = 557,
  [4432] = 553,
  [4433] = 554,
  [4434] = 555,
  [4435] = 528,
  [4436] = 4436,
  [4437] = 4437,
  [4438] = 525,
  [4439] = 4439,
  [4440] = 4440,
  [4441] = 4441,
  [4442] = 523,
  [4443] = 4443,
  [4444] = 524,
  [4445] = 4439,
  [4446] = 529,
  [4447] = 521,
  [4448] = 4437,
  [4449] = 4440,
  [4450] = 4443,
  [4451] = 520,
  [4452] = 519,
  [4453] = 518,
  [4454] = 517,
  [4455] = 4455,
  [4456] = 516,
  [4457] = 515,
  [4458] = 4443,
  [4459] = 4439,
  [4460] = 531,
  [4461] = 4436,
  [4462] = 4441,
  [4463] = 526,
  [4464] = 4439,
  [4465] = 510,
  [4466] = 4436,
  [4467] = 4437,
  [4468] = 4440,
  [4469] = 4443,
  [4470] = 4441,
  [4471] = 4436,
  [4472] = 4441,
  [4473] = 4436,
  [4474] = 4441,
  [4475] = 4436,
  [4476] = 4441,
  [4477] = 4436,
  [4478] = 4440,
  [4479] = 509,
  [4480] = 4437,
  [4481] = 4441,
  [4482] = 4439,
  [4483] = 4436,
  [4484] = 4441,
  [4485] = 511,
  [4486] = 512,
  [4487] = 4436,
  [4488] = 4441,
  [4489] = 4439,
  [4490] = 4436,
  [4491] = 4441,
  [4492] = 4437,
  [4493] = 4440,
  [4494] = 4443,
  [4495] = 4436,
  [4496] = 4441,
  [4497] = 4436,
  [4498] = 4441,
  [4499] = 4436,
  [4500] = 4441,
  [4501] = 4436,
  [4502] = 4441,
  [4503] = 559,
  [4504] = 4436,
  [4505] = 4441,
  [4506] = 4436,
  [4507] = 4441,
  [4508] = 4443,
  [4509] = 4440,
  [4510] = 4437,
  [4511] = 4436,
  [4512] = 4441,
  [4513] = 4436,
  [4514] = 4439,
  [4515] = 4441,
  [4516] = 4436,
  [4517] = 4437,
  [4518] = 4440,
  [4519] = 4443,
  [4520] = 4441,
  [4521] = 4436,
  [4522] = 4441,
  [4523] = 4436,
  [4524] = 4441,
  [4525] = 4439,
  [4526] = 4436,
  [4527] = 4441,
  [4528] = 4436,
  [4529] = 4441,
  [4530] = 4436,
  [4531] = 513,
  [4532] = 4441,
  [4533] = 4436,
  [4534] = 4441,
  [4535] = 4436,
  [4536] = 4441,
  [4537] = 4436,
  [4538] = 4441,
  [4539] = 4439,
  [4540] = 4439,
  [4541] = 4436,
  [4542] = 4437,
  [4543] = 4440,
  [4544] = 4443,
  [4545] = 4437,
  [4546] = 4441,
  [4547] = 4440,
  [4548] = 4443,
  [4549] = 533,
  [4550] = 534,
  [4551] = 4437,
  [4552] = 535,
  [4553] = 514,
  [4554] = 4440,
  [4555] = 4443,
  [4556] = 4440,
  [4557] = 4437,
  [4558] = 4437,
  [4559] = 536,
  [4560] = 4439,
  [4561] = 4443,
  [4562] = 4440,
  [4563] = 4437,
  [4564] = 4439,
  [4565] = 500,
  [4566] = 4439,
  [4567] = 4437,
  [4568] = 4440,
  [4569] = 4443,
  [4570] = 4443,
  [4571] = 540,
  [4572] = 541,
  [4573] = 543,
  [4574] = 4443,
  [4575] = 530,
  [4576] = 4440,
  [4577] = 4437,
  [4578] = 508,
  [4579] = 4439,
  [4580] = 545,
  [4581] = 546,
  [4582] = 547,
  [4583] = 4443,
  [4584] = 4440,
  [4585] = 4437,
  [4586] = 4443,
  [4587] = 4440,
  [4588] = 548,
  [4589] = 4439,
  [4590] = 4437,
  [4591] = 4439,
  [4592] = 4437,
  [4593] = 4440,
  [4594] = 4443,
  [4595] = 4439,
  [4596] = 549,
  [4597] = 550,
  [4598] = 551,
  [4599] = 4443,
  [4600] = 4440,
  [4601] = 4437,
  [4602] = 4439,
  [4603] = 4443,
  [4604] = 544,
  [4605] = 562,
  [4606] = 4439,
  [4607] = 4440,
  [4608] = 4437,
  [4609] = 4439,
  [4610] = 4439,
  [4611] = 4440,
  [4612] = 552,
  [4613] = 4443,
  [4614] = 4439,
  [4615] = 561,
  [4616] = 4440,
  [4617] = 4437,
  [4618] = 4440,
  [4619] = 4443,
  [4620] = 4437,
  [4621] = 4439,
  [4622] = 4437,
  [4623] = 4439,
  [4624] = 4437,
  [4625] = 4440,
  [4626] = 4443,
  [4627] = 4443,
  [4628] = 560,
  [4629] = 4443,
  [4630] = 4440,
  [4631] = 4437,
  [4632] = 553,
  [4633] = 4439,
  [4634] = 2195,
  [4635] = 4443,
  [4636] = 4443,
  [4637] = 4440,
  [4638] = 4440,
  [4639] = 4439,
  [4640] = 558,
  [4641] = 554,
  [4642] = 4437,
  [4643] = 4440,
  [4644] = 4443,
  [4645] = 527,
  [4646] = 4443,
  [4647] = 4440,
  [4648] = 4437,
  [4649] = 4439,
  [4650] = 4437,
  [4651] = 4439,
  [4652] = 556,
  [4653] = 557,
  [4654] = 4654,
  [4655] = 1947,
  [4656] = 4656,
  [4657] = 4657,
  [4658] = 4654,
  [4659] = 4657,
  [4660] = 4660,
  [4661] = 4657,
  [4662] = 4662,
  [4663] = 4663,
  [4664] = 4656,
  [4665] = 4656,
  [4666] = 4660,
  [4667] = 4667,
  [4668] = 2033,
  [4669] = 4654,
  [4670] = 1943,
  [4671] = 4667,
  [4672] = 4660,
  [4673] = 4662,
  [4674] = 1923,
  [4675] = 2031,
  [4676] = 4662,
  [4677] = 4663,
  [4678] = 1934,
  [4679] = 4663,
  [4680] = 1925,
  [4681] = 1927,
  [4682] = 4667,
  [4683] = 1929,
  [4684] = 1923,
  [4685] = 1947,
  [4686] = 2031,
  [4687] = 1929,
  [4688] = 2033,
  [4689] = 1927,
  [4690] = 1925,
  [4691] = 1934,
  [4692] = 1943,
  [4693] = 2195,
  [4694] = 2244,
  [4695] = 2268,
  [4696] = 2245,
  [4697] = 2267,
  [4698] = 2261,
  [4699] = 2248,
  [4700] = 2257,
  [4701] = 2260,
  [4702] = 2249,
  [4703] = 2275,
  [4704] = 2246,
  [4705] = 2250,
  [4706] = 2252,
  [4707] = 2243,
  [4708] = 2259,
  [4709] = 2242,
  [4710] = 2256,
  [4711] = 2240,
  [4712] = 2230,
  [4713] = 2259,
  [4714] = 2252,
  [4715] = 2240,
  [4716] = 2275,
  [4717] = 2267,
  [4718] = 2249,
  [4719] = 2268,
  [4720] = 2244,
  [4721] = 2261,
  [4722] = 2260,
  [4723] = 2230,
  [4724] = 2257,
  [4725] = 2242,
  [4726] = 2245,
  [4727] = 2243,
  [4728] = 2246,
  [4729] = 2250,
  [4730] = 2248,
  [4731] = 2256,
  [4732] = 4732,
  [4733] = 4732,
  [4734] = 4732,
  [4735] = 4732,
  [4736] = 4732,
  [4737] = 4732,
  [4738] = 4732,
  [4739] = 4732,
  [4740] = 4732,
  [4741] = 4732,
  [4742] = 4732,
  [4743] = 4732,
  [4744] = 4732,
  [4745] = 4732,
  [4746] = 4732,
  [4747] = 4732,
  [4748] = 4732,
  [4749] = 4732,
  [4750] = 4732,
  [4751] = 4732,
  [4752] = 4732,
  [4753] = 4732,
  [4754] = 4732,
  [4755] = 4732,
  [4756] = 4732,
  [4757] = 4732,
  [4758] = 4758,
  [4759] = 4759,
  [4760] = 4760,
  [4761] = 4761,
  [4762] = 4762,
  [4763] = 4763,
  [4764] = 4764,
  [4765] = 4765,
  [4766] = 4764,
  [4767] = 4767,
  [4768] = 4763,
  [4769] = 4759,
  [4770] = 4762,
  [4771] = 4759,
  [4772] = 4772,
  [4773] = 4764,
  [4774] = 4761,
  [4775] = 4775,
  [4776] = 4761,
  [4777] = 4762,
  [4778] = 4763,
  [4779] = 4779,
  [4780] = 4761,
  [4781] = 4764,
  [4782] = 4767,
  [4783] = 4775,
  [4784] = 4761,
  [4785] = 4765,
  [4786] = 4764,
  [4787] = 4779,
  [4788] = 4767,
  [4789] = 4759,
  [4790] = 4767,
  [4791] = 4759,
  [4792] = 4772,
  [4793] = 4759,
  [4794] = 4761,
  [4795] = 4775,
  [4796] = 4764,
  [4797] = 4761,
  [4798] = 4765,
  [4799] = 4767,
  [4800] = 4779,
  [4801] = 4762,
  [4802] = 4763,
  [4803] = 4772,
  [4804] = 4759,
  [4805] = 4762,
  [4806] = 4767,
  [4807] = 4765,
  [4808] = 4775,
  [4809] = 4775,
  [4810] = 4760,
  [4811] = 4765,
  [4812] = 4762,
  [4813] = 4763,
  [4814] = 4763,
  [4815] = 4763,
  [4816] = 4762,
  [4817] = 4763,
  [4818] = 4779,
  [4819] = 4764,
  [4820] = 4761,
  [4821] = 4772,
  [4822] = 4762,
  [4823] = 4763,
  [4824] = 4762,
  [4825] = 4763,
  [4826] = 4775,
  [4827] = 4761,
  [4828] = 4764,
  [4829] = 4762,
  [4830] = 4765,
  [4831] = 4779,
  [4832] = 4761,
  [4833] = 4764,
  [4834] = 4772,
  [4835] = 4767,
  [4836] = 4759,
  [4837] = 4759,
  [4838] = 4767,
  [4839] = 4775,
  [4840] = 4767,
  [4841] = 4765,
  [4842] = 4764,
  [4843] = 4761,
  [4844] = 4779,
  [4845] = 4759,
  [4846] = 4846,
  [4847] = 4762,
  [4848] = 4763,
  [4849] = 4764,
  [4850] = 4759,
  [4851] = 4759,
  [4852] = 4767,
  [4853] = 4772,
  [4854] = 4762,
  [4855] = 4775,
  [4856] = 4761,
  [4857] = 4763,
  [4858] = 4767,
  [4859] = 4765,
  [4860] = 4764,
  [4861] = 4761,
  [4862] = 4779,
  [4863] = 4772,
  [4864] = 4762,
  [4865] = 4763,
  [4866] = 4759,
  [4867] = 4763,
  [4868] = 4775,
  [4869] = 4759,
  [4870] = 4762,
  [4871] = 4767,
  [4872] = 4759,
  [4873] = 4765,
  [4874] = 4764,
  [4875] = 4762,
  [4876] = 4779,
  [4877] = 4764,
  [4878] = 4761,
  [4879] = 4772,
  [4880] = 4763,
  [4881] = 4762,
  [4882] = 4763,
  [4883] = 4762,
  [4884] = 4763,
  [4885] = 4775,
  [4886] = 4761,
  [4887] = 4765,
  [4888] = 4761,
  [4889] = 4846,
  [4890] = 4760,
  [4891] = 4764,
  [4892] = 4779,
  [4893] = 4772,
  [4894] = 4759,
  [4895] = 4775,
  [4896] = 4759,
  [4897] = 4761,
  [4898] = 4767,
  [4899] = 4846,
  [4900] = 4760,
  [4901] = 4767,
  [4902] = 4765,
  [4903] = 4779,
  [4904] = 4772,
  [4905] = 4846,
  [4906] = 4760,
  [4907] = 4764,
  [4908] = 4775,
  [4909] = 4762,
  [4910] = 4765,
  [4911] = 4846,
  [4912] = 4760,
  [4913] = 4763,
  [4914] = 4779,
  [4915] = 4761,
  [4916] = 4772,
  [4917] = 4846,
  [4918] = 4760,
  [4919] = 4761,
  [4920] = 4775,
  [4921] = 4764,
  [4922] = 4765,
  [4923] = 4846,
  [4924] = 4760,
  [4925] = 4764,
  [4926] = 4779,
  [4927] = 4759,
  [4928] = 4772,
  [4929] = 4846,
  [4930] = 4760,
  [4931] = 4763,
  [4932] = 4775,
  [4933] = 4762,
  [4934] = 4765,
  [4935] = 4846,
  [4936] = 4760,
  [4937] = 4779,
  [4938] = 4772,
  [4939] = 4775,
  [4940] = 4765,
  [4941] = 4846,
  [4942] = 4760,
  [4943] = 4761,
  [4944] = 4779,
  [4945] = 4764,
  [4946] = 4772,
  [4947] = 4846,
  [4948] = 4760,
  [4949] = 4775,
  [4950] = 4765,
  [4951] = 4759,
  [4952] = 4779,
  [4953] = 4846,
  [4954] = 4760,
  [4955] = 4772,
  [4956] = 4775,
  [4957] = 4767,
  [4958] = 4765,
  [4959] = 4846,
  [4960] = 4760,
  [4961] = 4767,
  [4962] = 4779,
  [4963] = 4763,
  [4964] = 4772,
  [4965] = 4846,
  [4966] = 4760,
  [4967] = 4775,
  [4968] = 4765,
  [4969] = 4764,
  [4970] = 4779,
  [4971] = 4846,
  [4972] = 4760,
  [4973] = 4761,
  [4974] = 4772,
  [4975] = 4775,
  [4976] = 4765,
  [4977] = 4846,
  [4978] = 4760,
  [4979] = 4763,
  [4980] = 4779,
  [4981] = 4762,
  [4982] = 4772,
  [4983] = 4846,
  [4984] = 4760,
  [4985] = 4779,
  [4986] = 4775,
  [4987] = 4767,
  [4988] = 4765,
  [4989] = 4846,
  [4990] = 4760,
  [4991] = 4779,
  [4992] = 4772,
  [4993] = 4761,
  [4994] = 4775,
  [4995] = 4846,
  [4996] = 4760,
  [4997] = 4764,
  [4998] = 4765,
  [4999] = 4779,
  [5000] = 4772,
  [5001] = 4846,
  [5002] = 4760,
  [5003] = 4759,
  [5004] = 4775,
  [5005] = 4762,
  [5006] = 4765,
  [5007] = 4846,
  [5008] = 4760,
  [5009] = 4767,
  [5010] = 4779,
  [5011] = 4763,
  [5012] = 4772,
  [5013] = 4846,
  [5014] = 4775,
  [5015] = 4765,
  [5016] = 4779,
  [5017] = 4767,
  [5018] = 4772,
  [5019] = 4846,
  [5020] = 4760,
  [5021] = 4759,
  [5022] = 4775,
  [5023] = 4763,
  [5024] = 4765,
  [5025] = 4846,
  [5026] = 4760,
  [5027] = 4762,
  [5028] = 4779,
  [5029] = 4767,
  [5030] = 4772,
  [5031] = 4846,
  [5032] = 4760,
  [5033] = 4764,
  [5034] = 4775,
  [5035] = 4765,
  [5036] = 4779,
  [5037] = 4846,
  [5038] = 4760,
  [5039] = 4761,
  [5040] = 4772,
  [5041] = 4764,
  [5042] = 4775,
  [5043] = 4846,
  [5044] = 4760,
  [5045] = 4765,
  [5046] = 4779,
  [5047] = 4759,
  [5048] = 4772,
  [5049] = 4846,
  [5050] = 4760,
  [5051] = 4775,
  [5052] = 4765,
  [5053] = 4767,
  [5054] = 4779,
  [5055] = 4772,
  [5056] = 4767,
  [5057] = 4762,
  [5058] = 4759,
  [5059] = 4775,
  [5060] = 4765,
  [5061] = 4767,
  [5062] = 4779,
  [5063] = 4763,
  [5064] = 4772,
  [5065] = 4763,
  [5066] = 4772,
  [5067] = 4762,
  [5068] = 4763,
  [5069] = 4762,
  [5070] = 4767,
  [5071] = 4762,
  [5072] = 4759,
  [5073] = 4759,
  [5074] = 5074,
  [5075] = 4761,
  [5076] = 5076,
  [5077] = 4764,
  [5078] = 4764,
  [5079] = 4761,
  [5080] = 4761,
  [5081] = 4762,
  [5082] = 4767,
  [5083] = 4759,
  [5084] = 4761,
  [5085] = 4764,
  [5086] = 4763,
  [5087] = 4763,
  [5088] = 4764,
  [5089] = 4762,
  [5090] = 4764,
  [5091] = 4761,
  [5092] = 4767,
  [5093] = 5093,
  [5094] = 5093,
  [5095] = 5093,
  [5096] = 5093,
  [5097] = 5093,
  [5098] = 5093,
  [5099] = 5093,
  [5100] = 5093,
  [5101] = 5093,
  [5102] = 5093,
  [5103] = 5093,
  [5104] = 5093,
  [5105] = 5093,
  [5106] = 5093,
  [5107] = 5093,
  [5108] = 5093,
  [5109] = 5109,
  [5110] = 5110,
  [5111] = 5093,
  [5112] = 5093,
  [5113] = 5093,
  [5114] = 5093,
  [5115] = 5093,
  [5116] = 5093,
  [5117] = 5093,
  [5118] = 5118,
  [5119] = 5093,
  [5120] = 5093,
  [5121] = 2195,
  [5122] = 5093,
  [5123] = 5123,
  [5124] = 5093,
  [5125] = 5093,
  [5126] = 5126,
  [5127] = 5126,
  [5128] = 5126,
  [5129] = 5126,
  [5130] = 5126,
  [5131] = 5126,
  [5132] = 5132,
  [5133] = 5126,
  [5134] = 5126,
  [5135] = 5126,
  [5136] = 5136,
  [5137] = 5126,
  [5138] = 5126,
  [5139] = 5126,
  [5140] = 5126,
  [5141] = 5126,
  [5142] = 5126,
  [5143] = 5126,
  [5144] = 5126,
  [5145] = 5145,
  [5146] = 5146,
  [5147] = 5126,
  [5148] = 5126,
  [5149] = 5126,
  [5150] = 5126,
  [5151] = 5126,
  [5152] = 5126,
  [5153] = 5126,
  [5154] = 5126,
  [5155] = 5126,
  [5156] = 5126,
  [5157] = 5126,
  [5158] = 5158,
  [5159] = 5158,
  [5160] = 5160,
  [5161] = 5161,
  [5162] = 5161,
  [5163] = 5160,
  [5164] = 5161,
  [5165] = 5160,
  [5166] = 5161,
  [5167] = 5160,
  [5168] = 5161,
  [5169] = 5169,
  [5170] = 5160,
  [5171] = 5158,
  [5172] = 5172,
  [5173] = 5158,
  [5174] = 5172,
  [5175] = 5158,
  [5176] = 5172,
  [5177] = 5158,
  [5178] = 5172,
  [5179] = 5158,
  [5180] = 5172,
  [5181] = 5160,
  [5182] = 5172,
  [5183] = 5158,
  [5184] = 5172,
  [5185] = 5161,
  [5186] = 5161,
  [5187] = 5158,
  [5188] = 5172,
  [5189] = 5158,
  [5190] = 5172,
  [5191] = 5158,
  [5192] = 5161,
  [5193] = 5172,
  [5194] = 5158,
  [5195] = 5172,
  [5196] = 5160,
  [5197] = 5158,
  [5198] = 5172,
  [5199] = 5158,
  [5200] = 5172,
  [5201] = 5158,
  [5202] = 5161,
  [5203] = 5172,
  [5204] = 5158,
  [5205] = 5172,
  [5206] = 5160,
  [5207] = 5158,
  [5208] = 5172,
  [5209] = 5158,
  [5210] = 5172,
  [5211] = 5160,
  [5212] = 5158,
  [5213] = 5172,
  [5214] = 5161,
  [5215] = 5160,
  [5216] = 5172,
  [5217] = 5158,
  [5218] = 5160,
  [5219] = 5172,
  [5220] = 5161,
  [5221] = 5158,
  [5222] = 5172,
  [5223] = 5158,
  [5224] = 5172,
  [5225] = 5158,
  [5226] = 5172,
  [5227] = 5158,
  [5228] = 5172,
  [5229] = 5158,
  [5230] = 5172,
  [5231] = 5158,
  [5232] = 5161,
  [5233] = 5172,
  [5234] = 5158,
  [5235] = 5158,
  [5236] = 5172,
  [5237] = 5160,
  [5238] = 5160,
  [5239] = 5161,
  [5240] = 5161,
  [5241] = 5160,
  [5242] = 5160,
  [5243] = 5161,
  [5244] = 5160,
  [5245] = 5161,
  [5246] = 5161,
  [5247] = 5172,
  [5248] = 5160,
  [5249] = 5161,
  [5250] = 5160,
  [5251] = 5161,
  [5252] = 5160,
  [5253] = 5161,
  [5254] = 5160,
  [5255] = 5161,
  [5256] = 5161,
  [5257] = 5160,
  [5258] = 5160,
  [5259] = 5161,
  [5260] = 5160,
  [5261] = 5160,
  [5262] = 5161,
  [5263] = 5161,
  [5264] = 5160,
  [5265] = 5160,
  [5266] = 5161,
  [5267] = 5160,
  [5268] = 5161,
  [5269] = 5161,
  [5270] = 5160,
};

static TSCharacterRange sym_identifier_character_set_1[] = {
  {'.', '.'}, {'A', 'Z'}, {'_', 'z'}, {0xaa, 0xaa}, {0xb5, 0xb5}, {0xba, 0xba}, {0xc0, 0xd6}, {0xd8, 0xf6},
  {0xf8, 0x2c1}, {0x2c6, 0x2d1}, {0x2e0, 0x2e4}, {0x2ec, 0x2ec}, {0x2ee, 0x2ee}, {0x370, 0x374}, {0x376, 0x377}, {0x37b, 0x37d},
  {0x37f, 0x37f}, {0x386, 0x386}, {0x388, 0x38a}, {0x38c, 0x38c}, {0x38e, 0x3a1}, {0x3a3, 0x3f5}, {0x3f7, 0x481}, {0x48a, 0x52f},
  {0x531, 0x556}, {0x559, 0x559}, {0x560, 0x588}, {0x5d0, 0x5ea}, {0x5ef, 0x5f2}, {0x620, 0x64a}, {0x66e, 0x66f}, {0x671, 0x6d3},
  {0x6d5, 0x6d5}, {0x6e5, 0x6e6}, {0x6ee, 0x6ef}, {0x6fa, 0x6fc}, {0x6ff, 0x6ff}, {0x710, 0x710}, {0x712, 0x72f}, {0x74d, 0x7a5},
  {0x7b1, 0x7b1}, {0x7ca, 0x7ea}, {0x7f4, 0x7f5}, {0x7fa, 0x7fa}, {0x800, 0x815}, {0x81a, 0x81a}, {0x824, 0x824}, {0x828, 0x828},
  {0x840, 0x858}, {0x860, 0x86a}, {0x870, 0x887}, {0x889, 0x88e}, {0x8a0, 0x8c9}, {0x904, 0x939}, {0x93d, 0x93d}, {0x950, 0x950},
  {0x958, 0x961}, {0x971, 0x980}, {0x985, 0x98c}, {0x98f, 0x990}, {0x993, 0x9a8}, {0x9aa, 0x9b0}, {0x9b2, 0x9b2}, {0x9b6, 0x9b9},
  {0x9bd, 0x9bd}, {0x9ce, 0x9ce}, {0x9dc, 0x9dd}, {0x9df, 0x9e1}, {0x9f0, 0x9f1}, {0x9fc, 0x9fc}, {0xa05, 0xa0a}, {0xa0f, 0xa10},
  {0xa13, 0xa28}, {0xa2a, 0xa30}, {0xa32, 0xa33}, {0xa35, 0xa36}, {0xa38, 0xa39}, {0xa59, 0xa5c}, {0xa5e, 0xa5e}, {0xa72, 0xa74},
  {0xa85, 0xa8d}, {0xa8f, 0xa91}, {0xa93, 0xaa8}, {0xaaa, 0xab0}, {0xab2, 0xab3}, {0xab5, 0xab9}, {0xabd, 0xabd}, {0xad0, 0xad0},
  {0xae0, 0xae1}, {0xaf9, 0xaf9}, {0xb05, 0xb0c}, {0xb0f, 0xb10}, {0xb13, 0xb28}, {0xb2a, 0xb30}, {0xb32, 0xb33}, {0xb35, 0xb39},
  {0xb3d, 0xb3d}, {0xb5c, 0xb5d}, {0xb5f, 0xb61}, {0xb71, 0xb71}, {0xb83, 0xb83}, {0xb85, 0xb8a}, {0xb8e, 0xb90}, {0xb92, 0xb95},
  {0xb99, 0xb9a}, {0xb9c, 0xb9c}, {0xb9e, 0xb9f}, {0xba3, 0xba4}, {0xba8, 0xbaa}, {0xbae, 0xbb9}, {0xbd0, 0xbd0}, {0xc05, 0xc0c},
  {0xc0e, 0xc10}, {0xc12, 0xc28}, {0xc2a, 0xc39}, {0xc3d, 0xc3d}, {0xc58, 0xc5a}, {0xc5d, 0xc5d}, {0xc60, 0xc61}, {0xc80, 0xc80},
  {0xc85, 0xc8c}, {0xc8e, 0xc90}, {0xc92, 0xca8}, {0xcaa, 0xcb3}, {0xcb5, 0xcb9}, {0xcbd, 0xcbd}, {0xcdd, 0xcde}, {0xce0, 0xce1},
  {0xcf1, 0xcf2}, {0xd04, 0xd0c}, {0xd0e, 0xd10}, {0xd12, 0xd3a}, {0xd3d, 0xd3d}, {0xd4e, 0xd4e}, {0xd54, 0xd56}, {0xd5f, 0xd61},
  {0xd7a, 0xd7f}, {0xd85, 0xd96}, {0xd9a, 0xdb1}, {0xdb3, 0xdbb}, {0xdbd, 0xdbd}, {0xdc0, 0xdc6}, {0xe01, 0xe30}, {0xe32, 0xe32},
  {0xe40, 0xe46}, {0xe81, 0xe82}, {0xe84, 0xe84}, {0xe86, 0xe8a}, {0xe8c, 0xea3}, {0xea5, 0xea5}, {0xea7, 0xeb0}, {0xeb2, 0xeb2},
  {0xebd, 0xebd}, {0xec0, 0xec4}, {0xec6, 0xec6}, {0xedc, 0xedf}, {0xf00, 0xf00}, {0xf40, 0xf47}, {0xf49, 0xf6c}, {0xf88, 0xf8c},
  {0x1000, 0x102a}, {0x103f, 0x103f}, {0x1050, 0x1055}, {0x105a, 0x105d}, {0x1061, 0x1061}, {0x1065, 0x1066}, {0x106e, 0x1070}, {0x1075, 0x1081},
  {0x108e, 0x108e}, {0x10a0, 0x10c5}, {0x10c7, 0x10c7}, {0x10cd, 0x10cd}, {0x10d0, 0x10fa}, {0x10fc, 0x1248}, {0x124a, 0x124d}, {0x1250, 0x1256},
  {0x1258, 0x1258}, {0x125a, 0x125d}, {0x1260, 0x1288}, {0x128a, 0x128d}, {0x1290, 0x12b0}, {0x12b2, 0x12b5}, {0x12b8, 0x12be}, {0x12c0, 0x12c0},
  {0x12c2, 0x12c5}, {0x12c8, 0x12d6}, {0x12d8, 0x1310}, {0x1312, 0x1315}, {0x1318, 0x135a}, {0x1380, 0x138f}, {0x13a0, 0x13f5}, {0x13f8, 0x13fd},
  {0x1401, 0x166c}, {0x166f, 0x167f}, {0x1681, 0x169a}, {0x16a0, 0x16ea}, {0x16ee, 0x16f8}, {0x1700, 0x1711}, {0x171f, 0x1731}, {0x1740, 0x1751},
  {0x1760, 0x176c}, {0x176e, 0x1770}, {0x1780, 0x17b3}, {0x17d7, 0x17d7}, {0x17dc, 0x17dc}, {0x1820, 0x1878}, {0x1880, 0x18a8}, {0x18aa, 0x18aa},
  {0x18b0, 0x18f5}, {0x1900, 0x191e}, {0x1950, 0x196d}, {0x1970, 0x1974}, {0x1980, 0x19ab}, {0x19b0, 0x19c9}, {0x1a00, 0x1a16}, {0x1a20, 0x1a54},
  {0x1aa7, 0x1aa7}, {0x1b05, 0x1b33}, {0x1b45, 0x1b4c}, {0x1b83, 0x1ba0}, {0x1bae, 0x1baf}, {0x1bba, 0x1be5}, {0x1c00, 0x1c23}, {0x1c4d, 0x1c4f},
  {0x1c5a, 0x1c7d}, {0x1c80, 0x1c88}, {0x1c90, 0x1cba}, {0x1cbd, 0x1cbf}, {0x1ce9, 0x1cec}, {0x1cee, 0x1cf3}, {0x1cf5, 0x1cf6}, {0x1cfa, 0x1cfa},
  {0x1d00, 0x1dbf}, {0x1e00, 0x1f15}, {0x1f18, 0x1f1d}, {0x1f20, 0x1f45}, {0x1f48, 0x1f4d}, {0x1f50, 0x1f57}, {0x1f59, 0x1f59}, {0x1f5b, 0x1f5b},
  {0x1f5d, 0x1f5d}, {0x1f5f, 0x1f7d}, {0x1f80, 0x1fb4}, {0x1fb6, 0x1fbc}, {0x1fbe, 0x1fbe}, {0x1fc2, 0x1fc4}, {0x1fc6, 0x1fcc}, {0x1fd0, 0x1fd3},
  {0x1fd6, 0x1fdb}, {0x1fe0, 0x1fec}, {0x1ff2, 0x1ff4}, {0x1ff6, 0x1ffc}, {0x2071, 0x2071}, {0x207f, 0x207f}, {0x2090, 0x209c}, {0x2102, 0x2102},
  {0x2107, 0x2107}, {0x210a, 0x2113}, {0x2115, 0x2115}, {0x2118, 0x211d}, {0x2124, 0x2124}, {0x2126, 0x2126}, {0x2128, 0x2128}, {0x212a, 0x2139},
  {0x213c, 0x213f}, {0x2145, 0x2149}, {0x214e, 0x214e}, {0x2160, 0x2188}, {0x2c00, 0x2ce4}, {0x2ceb, 0x2cee}, {0x2cf2, 0x2cf3}, {0x2d00, 0x2d25},
  {0x2d27, 0x2d27}, {0x2d2d, 0x2d2d}, {0x2d30, 0x2d67}, {0x2d6f, 0x2d6f}, {0x2d80, 0x2d96}, {0x2da0, 0x2da6}, {0x2da8, 0x2dae}, {0x2db0, 0x2db6},
  {0x2db8, 0x2dbe}, {0x2dc0, 0x2dc6}, {0x2dc8, 0x2dce}, {0x2dd0, 0x2dd6}, {0x2dd8, 0x2dde}, {0x3005, 0x3007}, {0x3021, 0x3029}, {0x3031, 0x3035},
  {0x3038, 0x303c}, {0x3041, 0x3096}, {0x309d, 0x309f}, {0x30a1, 0x30fa}, {0x30fc, 0x30ff}, {0x3105, 0x312f}, {0x3131, 0x318e}, {0x31a0, 0x31bf},
  {0x31f0, 0x31ff}, {0x3400, 0x4dbf}, {0x4e00, 0xa48c}, {0xa4d0, 0xa4fd}, {0xa500, 0xa60c}, {0xa610, 0xa61f}, {0xa62a, 0xa62b}, {0xa640, 0xa66e},
  {0xa67f, 0xa69d}, {0xa6a0, 0xa6ef}, {0xa717, 0xa71f}, {0xa722, 0xa788}, {0xa78b, 0xa7ca}, {0xa7d0, 0xa7d1}, {0xa7d3, 0xa7d3}, {0xa7d5, 0xa7d9},
  {0xa7f2, 0xa801}, {0xa803, 0xa805}, {0xa807, 0xa80a}, {0xa80c, 0xa822}, {0xa840, 0xa873}, {0xa882, 0xa8b3}, {0xa8f2, 0xa8f7}, {0xa8fb, 0xa8fb},
  {0xa8fd, 0xa8fe}, {0xa90a, 0xa925}, {0xa930, 0xa946}, {0xa960, 0xa97c}, {0xa984, 0xa9b2}, {0xa9cf, 0xa9cf}, {0xa9e0, 0xa9e4}, {0xa9e6, 0xa9ef},
  {0xa9fa, 0xa9fe}, {0xaa00, 0xaa28}, {0xaa40, 0xaa42}, {0xaa44, 0xaa4b}, {0xaa60, 0xaa76}, {0xaa7a, 0xaa7a}, {0xaa7e, 0xaaaf}, {0xaab1, 0xaab1},
  {0xaab5, 0xaab6}, {0xaab9, 0xaabd}, {0xaac0, 0xaac0}, {0xaac2, 0xaac2}, {0xaadb, 0xaadd}, {0xaae0, 0xaaea}, {0xaaf2, 0xaaf4}, {0xab01, 0xab06},
  {0xab09, 0xab0e}, {0xab11, 0xab16}, {0xab20, 0xab26}, {0xab28, 0xab2e}, {0xab30, 0xab5a}, {0xab5c, 0xab69}, {0xab70, 0xabe2}, {0xac00, 0xd7a3},
  {0xd7b0, 0xd7c6}, {0xd7cb, 0xd7fb}, {0xf900, 0xfa6d}, {0xfa70, 0xfad9}, {0xfb00, 0xfb06}, {0xfb13, 0xfb17}, {0xfb1d, 0xfb1d}, {0xfb1f, 0xfb28},
  {0xfb2a, 0xfb36}, {0xfb38, 0xfb3c}, {0xfb3e, 0xfb3e}, {0xfb40, 0xfb41}, {0xfb43, 0xfb44}, {0xfb46, 0xfbb1}, {0xfbd3, 0xfc5d}, {0xfc64, 0xfd3d},
  {0xfd50, 0xfd8f}, {0xfd92, 0xfdc7}, {0xfdf0, 0xfdf9}, {0xfe71, 0xfe71}, {0xfe73, 0xfe73}, {0xfe77, 0xfe77}, {0xfe79, 0xfe79}, {0xfe7b, 0xfe7b},
  {0xfe7d, 0xfe7d}, {0xfe7f, 0xfefc}, {0xff21, 0xff3a}, {0xff41, 0xff5a}, {0xff66, 0xff9d}, {0xffa0, 0xffbe}, {0xffc2, 0xffc7}, {0xffca, 0xffcf},
  {0xffd2, 0xffd7}, {0xffda, 0xffdc}, {0x10000, 0x1000b}, {0x1000d, 0x10026}, {0x10028, 0x1003a}, {0x1003c, 0x1003d}, {0x1003f, 0x1004d}, {0x10050, 0x1005d},
  {0x10080, 0x100fa}, {0x10140, 0x10174}, {0x10280, 0x1029c}, {0x102a0, 0x102d0}, {0x10300, 0x1031f}, {0x1032d, 0x1034a}, {0x10350, 0x10375}, {0x10380, 0x1039d},
  {0x103a0, 0x103c3}, {0x103c8, 0x103cf}, {0x103d1, 0x103d5}, {0x10400, 0x1049d}, {0x104b0, 0x104d3}, {0x104d8, 0x104fb}, {0x10500, 0x10527}, {0x10530, 0x10563},
  {0x10570, 0x1057a}, {0x1057c, 0x1058a}, {0x1058c, 0x10592}, {0x10594, 0x10595}, {0x10597, 0x105a1}, {0x105a3, 0x105b1}, {0x105b3, 0x105b9}, {0x105bb, 0x105bc},
  {0x10600, 0x10736}, {0x10740, 0x10755}, {0x10760, 0x10767}, {0x10780, 0x10785}, {0x10787, 0x107b0}, {0x107b2, 0x107ba}, {0x10800, 0x10805}, {0x10808, 0x10808},
  {0x1080a, 0x10835}, {0x10837, 0x10838}, {0x1083c, 0x1083c}, {0x1083f, 0x10855}, {0x10860, 0x10876}, {0x10880, 0x1089e}, {0x108e0, 0x108f2}, {0x108f4, 0x108f5},
  {0x10900, 0x10915}, {0x10920, 0x10939}, {0x10980, 0x109b7}, {0x109be, 0x109bf}, {0x10a00, 0x10a00}, {0x10a10, 0x10a13}, {0x10a15, 0x10a17}, {0x10a19, 0x10a35},
  {0x10a60, 0x10a7c}, {0x10a80, 0x10a9c}, {0x10ac0, 0x10ac7}, {0x10ac9, 0x10ae4}, {0x10b00, 0x10b35}, {0x10b40, 0x10b55}, {0x10b60, 0x10b72}, {0x10b80, 0x10b91},
  {0x10c00, 0x10c48}, {0x10c80, 0x10cb2}, {0x10cc0, 0x10cf2}, {0x10d00, 0x10d23}, {0x10e80, 0x10ea9}, {0x10eb0, 0x10eb1}, {0x10f00, 0x10f1c}, {0x10f27, 0x10f27},
  {0x10f30, 0x10f45}, {0x10f70, 0x10f81}, {0x10fb0, 0x10fc4}, {0x10fe0, 0x10ff6}, {0x11003, 0x11037}, {0x11071, 0x11072}, {0x11075, 0x11075}, {0x11083, 0x110af},
  {0x110d0, 0x110e8}, {0x11103, 0x11126}, {0x11144, 0x11144}, {0x11147, 0x11147}, {0x11150, 0x11172}, {0x11176, 0x11176}, {0x11183, 0x111b2}, {0x111c1, 0x111c4},
  {0x111da, 0x111da}, {0x111dc, 0x111dc}, {0x11200, 0x11211}, {0x11213, 0x1122b}, {0x11280, 0x11286}, {0x11288, 0x11288}, {0x1128a, 0x1128d}, {0x1128f, 0x1129d},
  {0x1129f, 0x112a8}, {0x112b0, 0x112de}, {0x11305, 0x1130c}, {0x1130f, 0x11310}, {0x11313, 0x11328}, {0x1132a, 0x11330}, {0x11332, 0x11333}, {0x11335, 0x11339},
  {0x1133d, 0x1133d}, {0x11350, 0x11350}, {0x1135d, 0x11361}, {0x11400, 0x11434}, {0x11447, 0x1144a}, {0x1145f, 0x11461}, {0x11480, 0x114af}, {0x114c4, 0x114c5},
  {0x114c7, 0x114c7}, {0x11580, 0x115ae}, {0x115d8, 0x115db}, {0x11600, 0x1162f}, {0x11644, 0x11644}, {0x11680, 0x116aa}, {0x116b8, 0x116b8}, {0x11700, 0x1171a},
  {0x11740, 0x11746}, {0x11800, 0x1182b}, {0x118a0, 0x118df}, {0x118ff, 0x11906}, {0x11909, 0x11909}, {0x1190c, 0x11913}, {0x11915, 0x11916}, {0x11918, 0x1192f},
  {0x1193f, 0x1193f}, {0x11941, 0x11941}, {0x119a0, 0x119a7}, {0x119aa, 0x119d0}, {0x119e1, 0x119e1}, {0x119e3, 0x119e3}, {0x11a00, 0x11a00}, {0x11a0b, 0x11a32},
  {0x11a3a, 0x11a3a}, {0x11a50, 0x11a50}, {0x11a5c, 0x11a89}, {0x11a9d, 0x11a9d}, {0x11ab0, 0x11af8}, {0x11c00, 0x11c08}, {0x11c0a, 0x11c2e}, {0x11c40, 0x11c40},
  {0x11c72, 0x11c8f}, {0x11d00, 0x11d06}, {0x11d08, 0x11d09}, {0x11d0b, 0x11d30}, {0x11d46, 0x11d46}, {0x11d60, 0x11d65}, {0x11d67, 0x11d68}, {0x11d6a, 0x11d89},
  {0x11d98, 0x11d98}, {0x11ee0, 0x11ef2}, {0x11fb0, 0x11fb0}, {0x12000, 0x12399}, {0x12400, 0x1246e}, {0x12480, 0x12543}, {0x12f90, 0x12ff0}, {0x13000, 0x1342e},
  {0x14400, 0x14646}, {0x16800, 0x16a38}, {0x16a40, 0x16a5e}, {0x16a70, 0x16abe}, {0x16ad0, 0x16aed}, {0x16b00, 0x16b2f}, {0x16b40, 0x16b43}, {0x16b63, 0x16b77},
  {0x16b7d, 0x16b8f}, {0x16e40, 0x16e7f}, {0x16f00, 0x16f4a}, {0x16f50, 0x16f50}, {0x16f93, 0x16f9f}, {0x16fe0, 0x16fe1}, {0x16fe3, 0x16fe3}, {0x17000, 0x187f7},
  {0x18800, 0x18cd5}, {0x18d00, 0x18d08}, {0x1aff0, 0x1aff3}, {0x1aff5, 0x1affb}, {0x1affd, 0x1affe}, {0x1b000, 0x1b122}, {0x1b150, 0x1b152}, {0x1b164, 0x1b167},
  {0x1b170, 0x1b2fb}, {0x1bc00, 0x1bc6a}, {0x1bc70, 0x1bc7c}, {0x1bc80, 0x1bc88}, {0x1bc90, 0x1bc99}, {0x1d400, 0x1d454}, {0x1d456, 0x1d49c}, {0x1d49e, 0x1d49f},
  {0x1d4a2, 0x1d4a2}, {0x1d4a5, 0x1d4a6}, {0x1d4a9, 0x1d4ac}, {0x1d4ae, 0x1d4b9}, {0x1d4bb, 0x1d4bb}, {0x1d4bd, 0x1d4c3}, {0x1d4c5, 0x1d505}, {0x1d507, 0x1d50a},
  {0x1d50d, 0x1d514}, {0x1d516, 0x1d51c}, {0x1d51e, 0x1d539}, {0x1d53b, 0x1d53e}, {0x1d540, 0x1d544}, {0x1d546, 0x1d546}, {0x1d54a, 0x1d550}, {0x1d552, 0x1d6a5},
  {0x1d6a8, 0x1d6c0}, {0x1d6c2, 0x1d6da}, {0x1d6dc, 0x1d6fa}, {0x1d6fc, 0x1d714}, {0x1d716, 0x1d734}, {0x1d736, 0x1d74e}, {0x1d750, 0x1d76e}, {0x1d770, 0x1d788},
  {0x1d78a, 0x1d7a8}, {0x1d7aa, 0x1d7c2}, {0x1d7c4, 0x1d7cb}, {0x1df00, 0x1df1e}, {0x1e100, 0x1e12c}, {0x1e137, 0x1e13d}, {0x1e14e, 0x1e14e}, {0x1e290, 0x1e2ad},
  {0x1e2c0, 0x1e2eb}, {0x1e7e0, 0x1e7e6}, {0x1e7e8, 0x1e7eb}, {0x1e7ed, 0x1e7ee}, {0x1e7f0, 0x1e7fe}, {0x1e800, 0x1e8c4}, {0x1e900, 0x1e943}, {0x1e94b, 0x1e94b},
  {0x1ee00, 0x1ee03}, {0x1ee05, 0x1ee1f}, {0x1ee21, 0x1ee22}, {0x1ee24, 0x1ee24}, {0x1ee27, 0x1ee27}, {0x1ee29, 0x1ee32}, {0x1ee34, 0x1ee37}, {0x1ee39, 0x1ee39},
  {0x1ee3b, 0x1ee3b}, {0x1ee42, 0x1ee42}, {0x1ee47, 0x1ee47}, {0x1ee49, 0x1ee49}, {0x1ee4b, 0x1ee4b}, {0x1ee4d, 0x1ee4f}, {0x1ee51, 0x1ee52}, {0x1ee54, 0x1ee54},
  {0x1ee57, 0x1ee57}, {0x1ee59, 0x1ee59}, {0x1ee5b, 0x1ee5b}, {0x1ee5d, 0x1ee5d}, {0x1ee5f, 0x1ee5f}, {0x1ee61, 0x1ee62}, {0x1ee64, 0x1ee64}, {0x1ee67, 0x1ee6a},
  {0x1ee6c, 0x1ee72}, {0x1ee74, 0x1ee77}, {0x1ee79, 0x1ee7c}, {0x1ee7e, 0x1ee7e}, {0x1ee80, 0x1ee89}, {0x1ee8b, 0x1ee9b}, {0x1eea1, 0x1eea3}, {0x1eea5, 0x1eea9},
  {0x1eeab, 0x1eebb}, {0x20000, 0x2a6df}, {0x2a700, 0x2b738}, {0x2b740, 0x2b81d}, {0x2b820, 0x2cea1}, {0x2ceb0, 0x2ebe0}, {0x2f800, 0x2fa1d}, {0x30000, 0x3134a},
};

static TSCharacterRange sym_identifier_character_set_2[] = {
  {'.', '.'}, {'0', '9'}, {'A', 'Z'}, {'_', '_'}, {'a', 'z'}, {0xaa, 0xaa}, {0xb5, 0xb5}, {0xb7, 0xb7},
  {0xba, 0xba}, {0xc0, 0xd6}, {0xd8, 0xf6}, {0xf8, 0x2c1}, {0x2c6, 0x2d1}, {0x2e0, 0x2e4}, {0x2ec, 0x2ec}, {0x2ee, 0x2ee},
  {0x300, 0x374}, {0x376, 0x377}, {0x37b, 0x37d}, {0x37f, 0x37f}, {0x386, 0x38a}, {0x38c, 0x38c}, {0x38e, 0x3a1}, {0x3a3, 0x3f5},
  {0x3f7, 0x481}, {0x483, 0x487}, {0x48a, 0x52f}, {0x531, 0x556}, {0x559, 0x559}, {0x560, 0x588}, {0x591, 0x5bd}, {0x5bf, 0x5bf},
  {0x5c1, 0x5c2}, {0x5c4, 0x5c5}, {0x5c7, 0x5c7}, {0x5d0, 0x5ea}, {0x5ef, 0x5f2}, {0x610, 0x61a}, {0x620, 0x669}, {0x66e, 0x6d3},
  {0x6d5, 0x6dc}, {0x6df, 0x6e8}, {0x6ea, 0x6fc}, {0x6ff, 0x6ff}, {0x710, 0x74a}, {0x74d, 0x7b1}, {0x7c0, 0x7f5}, {0x7fa, 0x7fa},
  {0x7fd, 0x7fd}, {0x800, 0x82d}, {0x840, 0x85b}, {0x860, 0x86a}, {0x870, 0x887}, {0x889, 0x88e}, {0x898, 0x8e1}, {0x8e3, 0x963},
  {0x966, 0x96f}, {0x971, 0x983}, {0x985, 0x98c}, {0x98f, 0x990}, {0x993, 0x9a8}, {0x9aa, 0x9b0}, {0x9b2, 0x9b2}, {0x9b6, 0x9b9},
  {0x9bc, 0x9c4}, {0x9c7, 0x9c8}, {0x9cb, 0x9ce}, {0x9d7, 0x9d7}, {0x9dc, 0x9dd}, {0x9df, 0x9e3}, {0x9e6, 0x9f1}, {0x9fc, 0x9fc},
  {0x9fe, 0x9fe}, {0xa01, 0xa03}, {0xa05, 0xa0a}, {0xa0f, 0xa10}, {0xa13, 0xa28}, {0xa2a, 0xa30}, {0xa32, 0xa33}, {0xa35, 0xa36},
  {0xa38, 0xa39}, {0xa3c, 0xa3c}, {0xa3e, 0xa42}, {0xa47, 0xa48}, {0xa4b, 0xa4d}, {0xa51, 0xa51}, {0xa59, 0xa5c}, {0xa5e, 0xa5e},
  {0xa66, 0xa75}, {0xa81, 0xa83}, {0xa85, 0xa8d}, {0xa8f, 0xa91}, {0xa93, 0xaa8}, {0xaaa, 0xab0}, {0xab2, 0xab3}, {0xab5, 0xab9},
  {0xabc, 0xac5}, {0xac7, 0xac9}, {0xacb, 0xacd}, {0xad0, 0xad0}, {0xae0, 0xae3}, {0xae6, 0xaef}, {0xaf9, 0xaff}, {0xb01, 0xb03},
  {0xb05, 0xb0c}, {0xb0f, 0xb10}, {0xb13, 0xb28}, {0xb2a, 0xb30}, {0xb32, 0xb33}, {0xb35, 0xb39}, {0xb3c, 0xb44}, {0xb47, 0xb48},
  {0xb4b, 0xb4d}, {0xb55, 0xb57}, {0xb5c, 0xb5d}, {0xb5f, 0xb63}, {0xb66, 0xb6f}, {0xb71, 0xb71}, {0xb82, 0xb83}, {0xb85, 0xb8a},
  {0xb8e, 0xb90}, {0xb92, 0xb95}, {0xb99, 0xb9a}, {0xb9c, 0xb9c}, {0xb9e, 0xb9f}, {0xba3, 0xba4}, {0xba8, 0xbaa}, {0xbae, 0xbb9},
  {0xbbe, 0xbc2}, {0xbc6, 0xbc8}, {0xbca, 0xbcd}, {0xbd0, 0xbd0}, {0xbd7, 0xbd7}, {0xbe6, 0xbef}, {0xc00, 0xc0c}, {0xc0e, 0xc10},
  {0xc12, 0xc28}, {0xc2a, 0xc39}, {0xc3c, 0xc44}, {0xc46, 0xc48}, {0xc4a, 0xc4d}, {0xc55, 0xc56}, {0xc58, 0xc5a}, {0xc5d, 0xc5d},
  {0xc60, 0xc63}, {0xc66, 0xc6f}, {0xc80, 0xc83}, {0xc85, 0xc8c}, {0xc8e, 0xc90}, {0xc92, 0xca8}, {0xcaa, 0xcb3}, {0xcb5, 0xcb9},
  {0xcbc, 0xcc4}, {0xcc6, 0xcc8}, {0xcca, 0xccd}, {0xcd5, 0xcd6}, {0xcdd, 0xcde}, {0xce0, 0xce3}, {0xce6, 0xcef}, {0xcf1, 0xcf2},
  {0xd00, 0xd0c}, {0xd0e, 0xd10}, {0xd12, 0xd44}, {0xd46, 0xd48}, {0xd4a, 0xd4e}, {0xd54, 0xd57}, {0xd5f, 0xd63}, {0xd66, 0xd6f},
  {0xd7a, 0xd7f}, {0xd81, 0xd83}, {0xd85, 0xd96}, {0xd9a, 0xdb1}, {0xdb3, 0xdbb}, {0xdbd, 0xdbd}, {0xdc0, 0xdc6}, {0xdca, 0xdca},
  {0xdcf, 0xdd4}, {0xdd6, 0xdd6}, {0xdd8, 0xddf}, {0xde6, 0xdef}, {0xdf2, 0xdf3}, {0xe01, 0xe3a}, {0xe40, 0xe4e}, {0xe50, 0xe59},
  {0xe81, 0xe82}, {0xe84, 0xe84}, {0xe86, 0xe8a}, {0xe8c, 0xea3}, {0xea5, 0xea5}, {0xea7, 0xebd}, {0xec0, 0xec4}, {0xec6, 0xec6},
  {0xec8, 0xecd}, {0xed0, 0xed9}, {0xedc, 0xedf}, {0xf00, 0xf00}, {0xf18, 0xf19}, {0xf20, 0xf29}, {0xf35, 0xf35}, {0xf37, 0xf37},
  {0xf39, 0xf39}, {0xf3e, 0xf47}, {0xf49, 0xf6c}, {0xf71, 0xf84}, {0xf86, 0xf97}, {0xf99, 0xfbc}, {0xfc6, 0xfc6}, {0x1000, 0x1049},
  {0x1050, 0x109d}, {0x10a0, 0x10c5}, {0x10c7, 0x10c7}, {0x10cd, 0x10cd}, {0x10d0, 0x10fa}, {0x10fc, 0x1248}, {0x124a, 0x124d}, {0x1250, 0x1256},
  {0x1258, 0x1258}, {0x125a, 0x125d}, {0x1260, 0x1288}, {0x128a, 0x128d}, {0x1290, 0x12b0}, {0x12b2, 0x12b5}, {0x12b8, 0x12be}, {0x12c0, 0x12c0},
  {0x12c2, 0x12c5}, {0x12c8, 0x12d6}, {0x12d8, 0x1310}, {0x1312, 0x1315}, {0x1318, 0x135a}, {0x135d, 0x135f}, {0x1369, 0x1371}, {0x1380, 0x138f},
  {0x13a0, 0x13f5}, {0x13f8, 0x13fd}, {0x1401, 0x166c}, {0x166f, 0x167f}, {0x1681, 0x169a}, {0x16a0, 0x16ea}, {0x16ee, 0x16f8}, {0x1700, 0x1715},
  {0x171f, 0x1734}, {0x1740, 0x1753}, {0x1760, 0x176c}, {0x176e, 0x1770}, {0x1772, 0x1773}, {0x1780, 0x17d3}, {0x17d7, 0x17d7}, {0x17dc, 0x17dd},
  {0x17e0, 0x17e9}, {0x180b, 0x180d}, {0x180f, 0x1819}, {0x1820, 0x1878}, {0x1880, 0x18aa}, {0x18b0, 0x18f5}, {0x1900, 0x191e}, {0x1920, 0x192b},
  {0x1930, 0x193b}, {0x1946, 0x196d}, {0x1970, 0x1974}, {0x1980, 0x19ab}, {0x19b0, 0x19c9}, {0x19d0, 0x19da}, {0x1a00, 0x1a1b}, {0x1a20, 0x1a5e},
  {0x1a60, 0x1a7c}, {0x1a7f, 0x1a89}, {0x1a90, 0x1a99}, {0x1aa7, 0x1aa7}, {0x1ab0, 0x1abd}, {0x1abf, 0x1ace}, {0x1b00, 0x1b4c}, {0x1b50, 0x1b59},
  {0x1b6b, 0x1b73}, {0x1b80, 0x1bf3}, {0x1c00, 0x1c37}, {0x1c40, 0x1c49}, {0x1c4d, 0x1c7d}, {0x1c80, 0x1c88}, {0x1c90, 0x1cba}, {0x1cbd, 0x1cbf},
  {0x1cd0, 0x1cd2}, {0x1cd4, 0x1cfa}, {0x1d00, 0x1f15}, {0x1f18, 0x1f1d}, {0x1f20, 0x1f45}, {0x1f48, 0x1f4d}, {0x1f50, 0x1f57}, {0x1f59, 0x1f59},
  {0x1f5b, 0x1f5b}, {0x1f5d, 0x1f5d}, {0x1f5f, 0x1f7d}, {0x1f80, 0x1fb4}, {0x1fb6, 0x1fbc}, {0x1fbe, 0x1fbe}, {0x1fc2, 0x1fc4}, {0x1fc6, 0x1fcc},
  {0x1fd0, 0x1fd3}, {0x1fd6, 0x1fdb}, {0x1fe0, 0x1fec}, {0x1ff2, 0x1ff4}, {0x1ff6, 0x1ffc}, {0x203f, 0x2040}, {0x2054, 0x2054}, {0x2071, 0x2071},
  {0x207f, 0x207f}, {0x2090, 0x209c}, {0x20d0, 0x20dc}, {0x20e1, 0x20e1}, {0x20e5, 0x20f0}, {0x2102, 0x2102}, {0x2107, 0x2107}, {0x210a, 0x2113},
  {0x2115, 0x2115}, {0x2118, 0x211d}, {0x2124, 0x2124}, {0x2126, 0x2126}, {0x2128, 0x2128}, {0x212a, 0x2139}, {0x213c, 0x213f}, {0x2145, 0x2149},
  {0x214e, 0x214e}, {0x2160, 0x2188}, {0x2c00, 0x2ce4}, {0x2ceb, 0x2cf3}, {0x2d00, 0x2d25}, {0x2d27, 0x2d27}, {0x2d2d, 0x2d2d}, {0x2d30, 0x2d67},
  {0x2d6f, 0x2d6f}, {0x2d7f, 0x2d96}, {0x2da0, 0x2da6}, {0x2da8, 0x2dae}, {0x2db0, 0x2db6}, {0x2db8, 0x2dbe}, {0x2dc0, 0x2dc6}, {0x2dc8, 0x2dce},
  {0x2dd0, 0x2dd6}, {0x2dd8, 0x2dde}, {0x2de0, 0x2dff}, {0x3005, 0x3007}, {0x3021, 0x302f}, {0x3031, 0x3035}, {0x3038, 0x303c}, {0x3041, 0x3096},
  {0x3099, 0x309a}, {0x309d, 0x309f}, {0x30a1, 0x30fa}, {0x30fc, 0x30ff}, {0x3105, 0x312f}, {0x3131, 0x318e}, {0x31a0, 0x31bf}, {0x31f0, 0x31ff},
  {0x3400, 0x4dbf}, {0x4e00, 0xa48c}, {0xa4d0, 0xa4fd}, {0xa500, 0xa60c}, {0xa610, 0xa62b}, {0xa640, 0xa66f}, {0xa674, 0xa67d}, {0xa67f, 0xa6f1},
  {0xa717, 0xa71f}, {0xa722, 0xa788}, {0xa78b, 0xa7ca}, {0xa7d0, 0xa7d1}, {0xa7d3, 0xa7d3}, {0xa7d5, 0xa7d9}, {0xa7f2, 0xa827}, {0xa82c, 0xa82c},
  {0xa840, 0xa873}, {0xa880, 0xa8c5}, {0xa8d0, 0xa8d9}, {0xa8e0, 0xa8f7}, {0xa8fb, 0xa8fb}, {0xa8fd, 0xa92d}, {0xa930, 0xa953}, {0xa960, 0xa97c},
  {0xa980, 0xa9c0}, {0xa9cf, 0xa9d9}, {0xa9e0, 0xa9fe}, {0xaa00, 0xaa36}, {0xaa40, 0xaa4d}, {0xaa50, 0xaa59}, {0xaa60, 0xaa76}, {0xaa7a, 0xaac2},
  {0xaadb, 0xaadd}, {0xaae0, 0xaaef}, {0xaaf2, 0xaaf6}, {0xab01, 0xab06}, {0xab09, 0xab0e}, {0xab11, 0xab16}, {0xab20, 0xab26}, {0xab28, 0xab2e},
  {0xab30, 0xab5a}, {0xab5c, 0xab69}, {0xab70, 0xabea}, {0xabec, 0xabed}, {0xabf0, 0xabf9}, {0xac00, 0xd7a3}, {0xd7b0, 0xd7c6}, {0xd7cb, 0xd7fb},
  {0xf900, 0xfa6d}, {0xfa70, 0xfad9}, {0xfb00, 0xfb06}, {0xfb13, 0xfb17}, {0xfb1d, 0xfb28}, {0xfb2a, 0xfb36}, {0xfb38, 0xfb3c}, {0xfb3e, 0xfb3e},
  {0xfb40, 0xfb41}, {0xfb43, 0xfb44}, {0xfb46, 0xfbb1}, {0xfbd3, 0xfc5d}, {0xfc64, 0xfd3d}, {0xfd50, 0xfd8f}, {0xfd92, 0xfdc7}, {0xfdf0, 0xfdf9},
  {0xfe00, 0xfe0f}, {0xfe20, 0xfe2f}, {0xfe33, 0xfe34}, {0xfe4d, 0xfe4f}, {0xfe71, 0xfe71}, {0xfe73, 0xfe73}, {0xfe77, 0xfe77}, {0xfe79, 0xfe79},
  {0xfe7b, 0xfe7b}, {0xfe7d, 0xfe7d}, {0xfe7f, 0xfefc}, {0xff10, 0xff19}, {0xff21, 0xff3a}, {0xff3f, 0xff3f}, {0xff41, 0xff5a}, {0xff66, 0xffbe},
  {0xffc2, 0xffc7}, {0xffca, 0xffcf}, {0xffd2, 0xffd7}, {0xffda, 0xffdc}, {0x10000, 0x1000b}, {0x1000d, 0x10026}, {0x10028, 0x1003a}, {0x1003c, 0x1003d},
  {0x1003f, 0x1004d}, {0x10050, 0x1005d}, {0x10080, 0x100fa}, {0x10140, 0x10174}, {0x101fd, 0x101fd}, {0x10280, 0x1029c}, {0x102a0, 0x102d0}, {0x102e0, 0x102e0},
  {0x10300, 0x1031f}, {0x1032d, 0x1034a}, {0x10350, 0x1037a}, {0x10380, 0x1039d}, {0x103a0, 0x103c3}, {0x103c8, 0x103cf}, {0x103d1, 0x103d5}, {0x10400, 0x1049d},
  {0x104a0, 0x104a9}, {0x104b0, 0x104d3}, {0x104d8, 0x104fb}, {0x10500, 0x10527}, {0x10530, 0x10563}, {0x10570, 0x1057a}, {0x1057c, 0x1058a}, {0x1058c, 0x10592},
  {0x10594, 0x10595}, {0x10597, 0x105a1}, {0x105a3, 0x105b1}, {0x105b3, 0x105b9}, {0x105bb, 0x105bc}, {0x10600, 0x10736}, {0x10740, 0x10755}, {0x10760, 0x10767},
  {0x10780, 0x10785}, {0x10787, 0x107b0}, {0x107b2, 0x107ba}, {0x10800, 0x10805}, {0x10808, 0x10808}, {0x1080a, 0x10835}, {0x10837, 0x10838}, {0x1083c, 0x1083c},
  {0x1083f, 0x10855}, {0x10860, 0x10876}, {0x10880, 0x1089e}, {0x108e0, 0x108f2}, {0x108f4, 0x108f5}, {0x10900, 0x10915}, {0x10920, 0x10939}, {0x10980, 0x109b7},
  {0x109be, 0x109bf}, {0x10a00, 0x10a03}, {0x10a05, 0x10a06}, {0x10a0c, 0x10a13}, {0x10a15, 0x10a17}, {0x10a19, 0x10a35}, {0x10a38, 0x10a3a}, {0x10a3f, 0x10a3f},
  {0x10a60, 0x10a7c}, {0x10a80, 0x10a9c}, {0x10ac0, 0x10ac7}, {0x10ac9, 0x10ae6}, {0x10b00, 0x10b35}, {0x10b40, 0x10b55}, {0x10b60, 0x10b72}, {0x10b80, 0x10b91},
  {0x10c00, 0x10c48}, {0x10c80, 0x10cb2}, {0x10cc0, 0x10cf2}, {0x10d00, 0x10d27}, {0x10d30, 0x10d39}, {0x10e80, 0x10ea9}, {0x10eab, 0x10eac}, {0x10eb0, 0x10eb1},
  {0x10f00, 0x10f1c}, {0x10f27, 0x10f27}, {0x10f30, 0x10f50}, {0x10f70, 0x10f85}, {0x10fb0, 0x10fc4}, {0x10fe0, 0x10ff6}, {0x11000, 0x11046}, {0x11066, 0x11075},
  {0x1107f, 0x110ba}, {0x110c2, 0x110c2}, {0x110d0, 0x110e8}, {0x110f0, 0x110f9}, {0x11100, 0x11134}, {0x11136, 0x1113f}, {0x11144, 0x11147}, {0x11150, 0x11173},
  {0x11176, 0x11176}, {0x11180, 0x111c4}, {0x111c9, 0x111cc}, {0x111ce, 0x111da}, {0x111dc, 0x111dc}, {0x11200, 0x11211}, {0x11213, 0x11237}, {0x1123e, 0x1123e},
  {0x11280, 0x11286}, {0x11288, 0x11288}, {0x1128a, 0x1128d}, {0x1128f, 0x1129d}, {0x1129f, 0x112a8}, {0x112b0, 0x112ea}, {0x112f0, 0x112f9}, {0x11300, 0x11303},
  {0x11305, 0x1130c}, {0x1130f, 0x11310}, {0x11313, 0x11328}, {0x1132a, 0x11330}, {0x11332, 0x11333}, {0x11335, 0x11339}, {0x1133b, 0x11344}, {0x11347, 0x11348},
  {0x1134b, 0x1134d}, {0x11350, 0x11350}, {0x11357, 0x11357}, {0x1135d, 0x11363}, {0x11366, 0x1136c}, {0x11370, 0x11374}, {0x11400, 0x1144a}, {0x11450, 0x11459},
  {0x1145e, 0x11461}, {0x11480, 0x114c5}, {0x114c7, 0x114c7}, {0x114d0, 0x114d9}, {0x11580, 0x115b5}, {0x115b8, 0x115c0}, {0x115d8, 0x115dd}, {0x11600, 0x11640},
  {0x11644, 0x11644}, {0x11650, 0x11659}, {0x11680, 0x116b8}, {0x116c0, 0x116c9}, {0x11700, 0x1171a}, {0x1171d, 0x1172b}, {0x11730, 0x11739}, {0x11740, 0x11746},
  {0x11800, 0x1183a}, {0x118a0, 0x118e9}, {0x118ff, 0x11906}, {0x11909, 0x11909}, {0x1190c, 0x11913}, {0x11915, 0x11916}, {0x11918, 0x11935}, {0x11937, 0x11938},
  {0x1193b, 0x11943}, {0x11950, 0x11959}, {0x119a0, 0x119a7}, {0x119aa, 0x119d7}, {0x119da, 0x119e1}, {0x119e3, 0x119e4}, {0x11a00, 0x11a3e}, {0x11a47, 0x11a47},
  {0x11a50, 0x11a99}, {0x11a9d, 0x11a9d}, {0x11ab0, 0x11af8}, {0x11c00, 0x11c08}, {0x11c0a, 0x11c36}, {0x11c38, 0x11c40}, {0x11c50, 0x11c59}, {0x11c72, 0x11c8f},
  {0x11c92, 0x11ca7}, {0x11ca9, 0x11cb6}, {0x11d00, 0x11d06}, {0x11d08, 0x11d09}, {0x11d0b, 0x11d36}, {0x11d3a, 0x11d3a}, {0x11d3c, 0x11d3d}, {0x11d3f, 0x11d47},
  {0x11d50, 0x11d59}, {0x11d60, 0x11d65}, {0x11d67, 0x11d68}, {0x11d6a, 0x11d8e}, {0x11d90, 0x11d91}, {0x11d93, 0x11d98}, {0x11da0, 0x11da9}, {0x11ee0, 0x11ef6},
  {0x11fb0, 0x11fb0}, {0x12000, 0x12399}, {0x12400, 0x1246e}, {0x12480, 0x12543}, {0x12f90, 0x12ff0}, {0x13000, 0x1342e}, {0x14400, 0x14646}, {0x16800, 0x16a38},
  {0x16a40, 0x16a5e}, {0x16a60, 0x16a69}, {0x16a70, 0x16abe}, {0x16ac0, 0x16ac9}, {0x16ad0, 0x16aed}, {0x16af0, 0x16af4}, {0x16b00, 0x16b36}, {0x16b40, 0x16b43},
  {0x16b50, 0x16b59}, {0x16b63, 0x16b77}, {0x16b7d, 0x16b8f}, {0x16e40, 0x16e7f}, {0x16f00, 0x16f4a}, {0x16f4f, 0x16f87}, {0x16f8f, 0x16f9f}, {0x16fe0, 0x16fe1},
  {0x16fe3, 0x16fe4}, {0x16ff0, 0x16ff1}, {0x17000, 0x187f7}, {0x18800, 0x18cd5}, {0x18d00, 0x18d08}, {0x1aff0, 0x1aff3}, {0x1aff5, 0x1affb}, {0x1affd, 0x1affe},
  {0x1b000, 0x1b122}, {0x1b150, 0x1b152}, {0x1b164, 0x1b167}, {0x1b170, 0x1b2fb}, {0x1bc00, 0x1bc6a}, {0x1bc70, 0x1bc7c}, {0x1bc80, 0x1bc88}, {0x1bc90, 0x1bc99},
  {0x1bc9d, 0x1bc9e}, {0x1cf00, 0x1cf2d}, {0x1cf30, 0x1cf46}, {0x1d165, 0x1d169}, {0x1d16d, 0x1d172}, {0x1d17b, 0x1d182}, {0x1d185, 0x1d18b}, {0x1d1aa, 0x1d1ad},
  {0x1d242, 0x1d244}, {0x1d400, 0x1d454}, {0x1d456, 0x1d49c}, {0x1d49e, 0x1d49f}, {0x1d4a2, 0x1d4a2}, {0x1d4a5, 0x1d4a6}, {0x1d4a9, 0x1d4ac}, {0x1d4ae, 0x1d4b9},
  {0x1d4bb, 0x1d4bb}, {0x1d4bd, 0x1d4c3}, {0x1d4c5, 0x1d505}, {0x1d507, 0x1d50a}, {0x1d50d, 0x1d514}, {0x1d516, 0x1d51c}, {0x1d51e, 0x1d539}, {0x1d53b, 0x1d53e},
  {0x1d540, 0x1d544}, {0x1d546, 0x1d546}, {0x1d54a, 0x1d550}, {0x1d552, 0x1d6a5}, {0x1d6a8, 0x1d6c0}, {0x1d6c2, 0x1d6da}, {0x1d6dc, 0x1d6fa}, {0x1d6fc, 0x1d714},
  {0x1d716, 0x1d734}, {0x1d736, 0x1d74e}, {0x1d750, 0x1d76e}, {0x1d770, 0x1d788}, {0x1d78a, 0x1d7a8}, {0x1d7aa, 0x1d7c2}, {0x1d7c4, 0x1d7cb}, {0x1d7ce, 0x1d7ff},
  {0x1da00, 0x1da36}, {0x1da3b, 0x1da6c}, {0x1da75, 0x1da75}, {0x1da84, 0x1da84}, {0x1da9b, 0x1da9f}, {0x1daa1, 0x1daaf}, {0x1df00, 0x1df1e}, {0x1e000, 0x1e006},
  {0x1e008, 0x1e018}, {0x1e01b, 0x1e021}, {0x1e023, 0x1e024}, {0x1e026, 0x1e02a}, {0x1e100, 0x1e12c}, {0x1e130, 0x1e13d}, {0x1e140, 0x1e149}, {0x1e14e, 0x1e14e},
  {0x1e290, 0x1e2ae}, {0x1e2c0, 0x1e2f9}, {0x1e7e0, 0x1e7e6}, {0x1e7e8, 0x1e7eb}, {0x1e7ed, 0x1e7ee}, {0x1e7f0, 0x1e7fe}, {0x1e800, 0x1e8c4}, {0x1e8d0, 0x1e8d6},
  {0x1e900, 0x1e94b}, {0x1e950, 0x1e959}, {0x1ee00, 0x1ee03}, {0x1ee05, 0x1ee1f}, {0x1ee21, 0x1ee22}, {0x1ee24, 0x1ee24}, {0x1ee27, 0x1ee27}, {0x1ee29, 0x1ee32},
  {0x1ee34, 0x1ee37}, {0x1ee39, 0x1ee39}, {0x1ee3b, 0x1ee3b}, {0x1ee42, 0x1ee42}, {0x1ee47, 0x1ee47}, {0x1ee49, 0x1ee49}, {0x1ee4b, 0x1ee4b}, {0x1ee4d, 0x1ee4f},
  {0x1ee51, 0x1ee52}, {0x1ee54, 0x1ee54}, {0x1ee57, 0x1ee57}, {0x1ee59, 0x1ee59}, {0x1ee5b, 0x1ee5b}, {0x1ee5d, 0x1ee5d}, {0x1ee5f, 0x1ee5f}, {0x1ee61, 0x1ee62},
  {0x1ee64, 0x1ee64}, {0x1ee67, 0x1ee6a}, {0x1ee6c, 0x1ee72}, {0x1ee74, 0x1ee77}, {0x1ee79, 0x1ee7c}, {0x1ee7e, 0x1ee7e}, {0x1ee80, 0x1ee89}, {0x1ee8b, 0x1ee9b},
  {0x1eea1, 0x1eea3}, {0x1eea5, 0x1eea9}, {0x1eeab, 0x1eebb}, {0x1fbf0, 0x1fbf9}, {0x20000, 0x2a6df}, {0x2a700, 0x2b738}, {0x2b740, 0x2b81d}, {0x2b820, 0x2cea1},
  {0x2ceb0, 0x2ebe0}, {0x2f800, 0x2fa1d}, {0x30000, 0x3134a}, {0xe0100, 0xe01ef},
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(25);
      ADVANCE_MAP(
        '!', 30,
        '"', 70,
        '#', 95,
        '$', 56,
        '%', 5,
        '&', 39,
        '\'', 69,
        '*', 48,
        '+', 31,
        ',', 96,
        '-', 32,
        '.', 90,
        '/', 49,
        '0', 61,
        ':', 54,
        '<', 42,
        '=', 27,
        '>', 44,
        '?', 28,
        '@', 57,
        '\\', 26,
        '^', 51,
        '`', 9,
        '|', 38,
        '~', 29,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(0);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(62);
      if (set_contains(sym_identifier_character_set_1, 656, lookahead)) ADVANCE(92);
      END_STATE();
    case 1:
      ADVANCE_MAP(
        '!', 7,
        '"', 70,
        '#', 95,
        '$', 56,
        '%', 5,
        '&', 39,
        '\'', 69,
        '*', 48,
        '+', 31,
        ',', 96,
        '-', 32,
        '/', 49,
        ':', 55,
        '<', 42,
        '=', 27,
        '>', 44,
        '?', 28,
        '@', 57,
        '^', 51,
        '`', 9,
        '|', 38,
        '~', 29,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(1);
      if (set_contains(sym_identifier_character_set_1, 656, lookahead)) ADVANCE(92);
      END_STATE();
    case 2:
      if (lookahead == '"') ADVANCE(70);
      if (lookahead == '#') ADVANCE(74);
      if (lookahead == '\\') ADVANCE(8);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(75);
      if (lookahead != 0) ADVANCE(76);
      END_STATE();
    case 3:
      if (lookahead == '#') ADVANCE(95);
      if (lookahead == '.') ADVANCE(91);
      if (lookahead == '`') ADVANCE(9);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(3);
      if (set_contains(sym_identifier_character_set_1, 656, lookahead)) ADVANCE(92);
      END_STATE();
    case 4:
      if (lookahead == '#') ADVANCE(71);
      if (lookahead == '\'') ADVANCE(69);
      if (lookahead == '\\') ADVANCE(8);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(72);
      if (lookahead != 0) ADVANCE(73);
      END_STATE();
    case 5:
      if (lookahead == '%') ADVANCE(52);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\\') ADVANCE(5);
      END_STATE();
    case 6:
      if (lookahead == '-') ADVANCE(34);
      END_STATE();
    case 7:
      if (lookahead == '=') ADVANCE(47);
      END_STATE();
    case 8:
      if (lookahead == 'U') ADVANCE(10);
      if (lookahead == 'u') ADVANCE(11);
      if (lookahead == 'x') ADVANCE(22);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(79);
      if (lookahead != 0 &&
          (lookahead < '0' || '9' < lookahead)) ADVANCE(77);
      END_STATE();
    case 9:
      if (lookahead == '\\') ADVANCE(24);
      if (lookahead == '`') ADVANCE(87);
      if (lookahead != 0) ADVANCE(9);
      END_STATE();
    case 10:
      if (lookahead == '{') ADVANCE(21);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(86);
      END_STATE();
    case 11:
      if (lookahead == '{') ADVANCE(23);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(82);
      END_STATE();
    case 12:
      if (lookahead == '}') ADVANCE(77);
      END_STATE();
    case 13:
      if (lookahead == '}') ADVANCE(77);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(12);
      END_STATE();
    case 14:
      if (lookahead == '}') ADVANCE(77);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(13);
      END_STATE();
    case 15:
      if (lookahead == '}') ADVANCE(77);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(14);
      END_STATE();
    case 16:
      if (lookahead == '}') ADVANCE(77);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(15);
      END_STATE();
    case 17:
      if (lookahead == '}') ADVANCE(77);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(16);
      END_STATE();
    case 18:
      if (lookahead == '}') ADVANCE(77);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(17);
      END_STATE();
    case 19:
      if (lookahead == '}') ADVANCE(77);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(18);
      END_STATE();
    case 20:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(60);
      END_STATE();
    case 21:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(19);
      END_STATE();
    case 22:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(80);
      END_STATE();
    case 23:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(15);
      END_STATE();
    case 24:
      if (lookahead != 0) ADVANCE(9);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(anon_sym_BSLASH);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(46);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(47);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '>') ADVANCE(36);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_LT_DASH);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_LT_LT_DASH);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_COLON_EQ);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      if (lookahead == '>') ADVANCE(37);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(anon_sym_DASH_GT_GT);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '>') ADVANCE(53);
      if (lookahead == '|') ADVANCE(40);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(41);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '-') ADVANCE(33);
      if (lookahead == '<') ADVANCE(6);
      if (lookahead == '=') ADVANCE(43);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(45);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(50);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_SLASH);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(aux_sym_binary_operator_token1);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_PIPE_GT);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(58);
      if (lookahead == '=') ADVANCE(35);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '=') ADVANCE(35);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      if (lookahead == ':') ADVANCE(59);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_COLON_COLON_COLON);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(aux_sym__hex_literal_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(60);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(sym__number_literal);
      if (lookahead == '.') ADVANCE(65);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(63);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(20);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(62);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(sym__number_literal);
      if (lookahead == '.') ADVANCE(65);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(63);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(62);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(sym__number_literal);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(67);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(67);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(sym__number_literal);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(67);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(68);
      if (set_contains(sym_identifier_character_set_2, 764, lookahead)) ADVANCE(92);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(sym__number_literal);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(63);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(65);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(sym__number_literal);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(64);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(66);
      if (set_contains(sym_identifier_character_set_2, 764, lookahead)) ADVANCE(92);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(sym__number_literal);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(67);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(sym__number_literal);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(68);
      if (set_contains(sym_identifier_character_set_2, 764, lookahead)) ADVANCE(92);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(aux_sym__single_quoted_string_content_token1);
      if (lookahead == '\n') ADVANCE(73);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(71);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(aux_sym__single_quoted_string_content_token1);
      if (lookahead == '#') ADVANCE(71);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(72);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(73);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(aux_sym__single_quoted_string_content_token1);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(73);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(aux_sym__double_quoted_string_content_token1);
      if (lookahead == '\n') ADVANCE(76);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(74);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(aux_sym__double_quoted_string_content_token1);
      if (lookahead == '#') ADVANCE(74);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(75);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          lookahead != '\\') ADVANCE(76);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(aux_sym__double_quoted_string_content_token1);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(76);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(77);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(78);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(77);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(80);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(81);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(82);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(83);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(84);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(85);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(sym_identifier);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(93);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(94);
      if (set_contains(sym_identifier_character_set_2, 764, lookahead)) ADVANCE(92);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(93);
      if (set_contains(sym_identifier_character_set_2, 764, lookahead)) ADVANCE(92);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(88);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(66);
      if (set_contains(sym_identifier_character_set_2, 764, lookahead)) ADVANCE(92);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(89);
      if (set_contains(sym_identifier_character_set_2, 764, lookahead)) ADVANCE(92);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(sym_identifier);
      if (set_contains(sym_identifier_character_set_2, 764, lookahead)) ADVANCE(92);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(sym_dots);
      if (set_contains(sym_identifier_character_set_2, 764, lookahead)) ADVANCE(92);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(sym_dot_dot_i);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(94);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(95);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(sym_comma);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      ADVANCE_MAP(
        'F', 1,
        'I', 2,
        'L', 3,
        'N', 4,
        'T', 5,
        'b', 6,
        'f', 7,
        'i', 8,
        'n', 9,
        'r', 10,
        'w', 11,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(0);
      END_STATE();
    case 1:
      if (lookahead == 'A') ADVANCE(12);
      END_STATE();
    case 2:
      if (lookahead == 'n') ADVANCE(13);
      END_STATE();
    case 3:
      ACCEPT_TOKEN(anon_sym_L);
      END_STATE();
    case 4:
      if (lookahead == 'A') ADVANCE(14);
      if (lookahead == 'U') ADVANCE(15);
      if (lookahead == 'a') ADVANCE(16);
      END_STATE();
    case 5:
      if (lookahead == 'R') ADVANCE(17);
      END_STATE();
    case 6:
      if (lookahead == 'r') ADVANCE(18);
      END_STATE();
    case 7:
      if (lookahead == 'o') ADVANCE(19);
      if (lookahead == 'u') ADVANCE(20);
      END_STATE();
    case 8:
      ACCEPT_TOKEN(anon_sym_i);
      if (lookahead == 'f') ADVANCE(21);
      if (lookahead == 'n') ADVANCE(22);
      END_STATE();
    case 9:
      if (lookahead == 'e') ADVANCE(23);
      END_STATE();
    case 10:
      if (lookahead == 'e') ADVANCE(24);
      END_STATE();
    case 11:
      if (lookahead == 'h') ADVANCE(25);
      END_STATE();
    case 12:
      if (lookahead == 'L') ADVANCE(26);
      END_STATE();
    case 13:
      if (lookahead == 'f') ADVANCE(27);
      END_STATE();
    case 14:
      ACCEPT_TOKEN(anon_sym_NA);
      if (lookahead == '_') ADVANCE(28);
      END_STATE();
    case 15:
      if (lookahead == 'L') ADVANCE(29);
      END_STATE();
    case 16:
      if (lookahead == 'N') ADVANCE(30);
      END_STATE();
    case 17:
      if (lookahead == 'U') ADVANCE(31);
      END_STATE();
    case 18:
      if (lookahead == 'e') ADVANCE(32);
      END_STATE();
    case 19:
      if (lookahead == 'r') ADVANCE(33);
      END_STATE();
    case 20:
      if (lookahead == 'n') ADVANCE(34);
      END_STATE();
    case 21:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 22:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 23:
      if (lookahead == 'x') ADVANCE(35);
      END_STATE();
    case 24:
      if (lookahead == 'p') ADVANCE(36);
      if (lookahead == 't') ADVANCE(37);
      END_STATE();
    case 25:
      if (lookahead == 'i') ADVANCE(38);
      END_STATE();
    case 26:
      if (lookahead == 'S') ADVANCE(39);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(sym_inf);
      END_STATE();
    case 28:
      if (lookahead == 'c') ADVANCE(40);
      if (lookahead == 'i') ADVANCE(41);
      if (lookahead == 'r') ADVANCE(42);
      END_STATE();
    case 29:
      if (lookahead == 'L') ADVANCE(43);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(sym_nan);
      END_STATE();
    case 31:
      if (lookahead == 'E') ADVANCE(44);
      END_STATE();
    case 32:
      if (lookahead == 'a') ADVANCE(45);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 34:
      if (lookahead == 'c') ADVANCE(46);
      END_STATE();
    case 35:
      if (lookahead == 't') ADVANCE(47);
      END_STATE();
    case 36:
      if (lookahead == 'e') ADVANCE(48);
      END_STATE();
    case 37:
      if (lookahead == 'u') ADVANCE(49);
      END_STATE();
    case 38:
      if (lookahead == 'l') ADVANCE(50);
      END_STATE();
    case 39:
      if (lookahead == 'E') ADVANCE(51);
      END_STATE();
    case 40:
      if (lookahead == 'h') ADVANCE(52);
      if (lookahead == 'o') ADVANCE(53);
      END_STATE();
    case 41:
      if (lookahead == 'n') ADVANCE(54);
      END_STATE();
    case 42:
      if (lookahead == 'e') ADVANCE(55);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(sym_null);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 45:
      if (lookahead == 'k') ADVANCE(56);
      END_STATE();
    case 46:
      if (lookahead == 't') ADVANCE(57);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(sym_next);
      END_STATE();
    case 48:
      if (lookahead == 'a') ADVANCE(58);
      END_STATE();
    case 49:
      if (lookahead == 'r') ADVANCE(59);
      END_STATE();
    case 50:
      if (lookahead == 'e') ADVANCE(60);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 52:
      if (lookahead == 'a') ADVANCE(61);
      END_STATE();
    case 53:
      if (lookahead == 'm') ADVANCE(62);
      END_STATE();
    case 54:
      if (lookahead == 't') ADVANCE(63);
      END_STATE();
    case 55:
      if (lookahead == 'a') ADVANCE(64);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(sym_break);
      END_STATE();
    case 57:
      if (lookahead == 'i') ADVANCE(65);
      END_STATE();
    case 58:
      if (lookahead == 't') ADVANCE(66);
      END_STATE();
    case 59:
      if (lookahead == 'n') ADVANCE(67);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 61:
      if (lookahead == 'r') ADVANCE(68);
      END_STATE();
    case 62:
      if (lookahead == 'p') ADVANCE(69);
      END_STATE();
    case 63:
      if (lookahead == 'e') ADVANCE(70);
      END_STATE();
    case 64:
      if (lookahead == 'l') ADVANCE(71);
      END_STATE();
    case 65:
      if (lookahead == 'o') ADVANCE(72);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_repeat);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(sym_return);
      END_STATE();
    case 68:
      if (lookahead == 'a') ADVANCE(73);
      END_STATE();
    case 69:
      if (lookahead == 'l') ADVANCE(74);
      END_STATE();
    case 70:
      if (lookahead == 'g') ADVANCE(75);
      END_STATE();
    case 71:
      if (lookahead == '_') ADVANCE(76);
      END_STATE();
    case 72:
      if (lookahead == 'n') ADVANCE(77);
      END_STATE();
    case 73:
      if (lookahead == 'c') ADVANCE(78);
      END_STATE();
    case 74:
      if (lookahead == 'e') ADVANCE(79);
      END_STATE();
    case 75:
      if (lookahead == 'e') ADVANCE(80);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_NA_real_);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_function);
      END_STATE();
    case 78:
      if (lookahead == 't') ADVANCE(81);
      END_STATE();
    case 79:
      if (lookahead == 'x') ADVANCE(82);
      END_STATE();
    case 80:
      if (lookahead == 'r') ADVANCE(83);
      END_STATE();
    case 81:
      if (lookahead == 'e') ADVANCE(84);
      END_STATE();
    case 82:
      if (lookahead == '_') ADVANCE(85);
      END_STATE();
    case 83:
      if (lookahead == '_') ADVANCE(86);
      END_STATE();
    case 84:
      if (lookahead == 'r') ADVANCE(87);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_NA_complex_);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_NA_integer_);
      END_STATE();
    case 87:
      if (lookahead == '_') ADVANCE(88);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_NA_character_);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 0, .external_lex_state = 2},
  [2] = {.lex_state = 0, .external_lex_state = 3},
  [3] = {.lex_state = 0, .external_lex_state = 4},
  [4] = {.lex_state = 0, .external_lex_state = 3},
  [5] = {.lex_state = 0, .external_lex_state = 5},
  [6] = {.lex_state = 0, .external_lex_state = 5},
  [7] = {.lex_state = 0, .external_lex_state = 4},
  [8] = {.lex_state = 0, .external_lex_state = 4},
  [9] = {.lex_state = 0, .external_lex_state = 5},
  [10] = {.lex_state = 0, .external_lex_state = 4},
  [11] = {.lex_state = 0, .external_lex_state = 4},
  [12] = {.lex_state = 0, .external_lex_state = 4},
  [13] = {.lex_state = 0, .external_lex_state = 5},
  [14] = {.lex_state = 0, .external_lex_state = 5},
  [15] = {.lex_state = 0, .external_lex_state = 4},
  [16] = {.lex_state = 0, .external_lex_state = 5},
  [17] = {.lex_state = 0, .external_lex_state = 5},
  [18] = {.lex_state = 0, .external_lex_state = 5},
  [19] = {.lex_state = 0, .external_lex_state = 3},
  [20] = {.lex_state = 0, .external_lex_state = 4},
  [21] = {.lex_state = 0, .external_lex_state = 3},
  [22] = {.lex_state = 0, .external_lex_state = 3},
  [23] = {.lex_state = 0, .external_lex_state = 6},
  [24] = {.lex_state = 0, .external_lex_state = 7},
  [25] = {.lex_state = 0, .external_lex_state = 3},
  [26] = {.lex_state = 0, .external_lex_state = 3},
  [27] = {.lex_state = 0, .external_lex_state = 3},
  [28] = {.lex_state = 0, .external_lex_state = 3},
  [29] = {.lex_state = 0, .external_lex_state = 8},
  [30] = {.lex_state = 0, .external_lex_state = 3},
  [31] = {.lex_state = 0, .external_lex_state = 3},
  [32] = {.lex_state = 0, .external_lex_state = 3},
  [33] = {.lex_state = 0, .external_lex_state = 3},
  [34] = {.lex_state = 0, .external_lex_state = 9},
  [35] = {.lex_state = 0, .external_lex_state = 8},
  [36] = {.lex_state = 0, .external_lex_state = 3},
  [37] = {.lex_state = 0, .external_lex_state = 3},
  [38] = {.lex_state = 0, .external_lex_state = 4},
  [39] = {.lex_state = 0, .external_lex_state = 5},
  [40] = {.lex_state = 0, .external_lex_state = 10},
  [41] = {.lex_state = 0, .external_lex_state = 9},
  [42] = {.lex_state = 0, .external_lex_state = 8},
  [43] = {.lex_state = 0, .external_lex_state = 4},
  [44] = {.lex_state = 0, .external_lex_state = 10},
  [45] = {.lex_state = 0, .external_lex_state = 9},
  [46] = {.lex_state = 0, .external_lex_state = 3},
  [47] = {.lex_state = 0, .external_lex_state = 3},
  [48] = {.lex_state = 0, .external_lex_state = 8},
  [49] = {.lex_state = 0, .external_lex_state = 3},
  [50] = {.lex_state = 0, .external_lex_state = 6},
  [51] = {.lex_state = 0, .external_lex_state = 3},
  [52] = {.lex_state = 0, .external_lex_state = 3},
  [53] = {.lex_state = 0, .external_lex_state = 4},
  [54] = {.lex_state = 0, .external_lex_state = 10},
  [55] = {.lex_state = 0, .external_lex_state = 4},
  [56] = {.lex_state = 0, .external_lex_state = 10},
  [57] = {.lex_state = 0, .external_lex_state = 6},
  [58] = {.lex_state = 0, .external_lex_state = 3},
  [59] = {.lex_state = 0, .external_lex_state = 6},
  [60] = {.lex_state = 0, .external_lex_state = 4},
  [61] = {.lex_state = 0, .external_lex_state = 6},
  [62] = {.lex_state = 0, .external_lex_state = 10},
  [63] = {.lex_state = 0, .external_lex_state = 9},
  [64] = {.lex_state = 0, .external_lex_state = 3},
  [65] = {.lex_state = 0, .external_lex_state = 4},
  [66] = {.lex_state = 0, .external_lex_state = 3},
  [67] = {.lex_state = 0, .external_lex_state = 7},
  [68] = {.lex_state = 0, .external_lex_state = 7},
  [69] = {.lex_state = 0, .external_lex_state = 6},
  [70] = {.lex_state = 0, .external_lex_state = 6},
  [71] = {.lex_state = 0, .external_lex_state = 4},
  [72] = {.lex_state = 0, .external_lex_state = 5},
  [73] = {.lex_state = 0, .external_lex_state = 4},
  [74] = {.lex_state = 0, .external_lex_state = 10},
  [75] = {.lex_state = 0, .external_lex_state = 3},
  [76] = {.lex_state = 0, .external_lex_state = 10},
  [77] = {.lex_state = 0, .external_lex_state = 5},
  [78] = {.lex_state = 0, .external_lex_state = 5},
  [79] = {.lex_state = 0, .external_lex_state = 5},
  [80] = {.lex_state = 0, .external_lex_state = 5},
  [81] = {.lex_state = 0, .external_lex_state = 5},
  [82] = {.lex_state = 0, .external_lex_state = 4},
  [83] = {.lex_state = 0, .external_lex_state = 4},
  [84] = {.lex_state = 0, .external_lex_state = 7},
  [85] = {.lex_state = 0, .external_lex_state = 5},
  [86] = {.lex_state = 0, .external_lex_state = 4},
  [87] = {.lex_state = 0, .external_lex_state = 5},
  [88] = {.lex_state = 0, .external_lex_state = 5},
  [89] = {.lex_state = 0, .external_lex_state = 5},
  [90] = {.lex_state = 0, .external_lex_state = 5},
  [91] = {.lex_state = 0, .external_lex_state = 4},
  [92] = {.lex_state = 0, .external_lex_state = 4},
  [93] = {.lex_state = 0, .external_lex_state = 6},
  [94] = {.lex_state = 0, .external_lex_state = 3},
  [95] = {.lex_state = 0, .external_lex_state = 5},
  [96] = {.lex_state = 0, .external_lex_state = 4},
  [97] = {.lex_state = 0, .external_lex_state = 3},
  [98] = {.lex_state = 0, .external_lex_state = 10},
  [99] = {.lex_state = 0, .external_lex_state = 5},
  [100] = {.lex_state = 0, .external_lex_state = 7},
  [101] = {.lex_state = 0, .external_lex_state = 9},
  [102] = {.lex_state = 0, .external_lex_state = 11},
  [103] = {.lex_state = 0, .external_lex_state = 12},
  [104] = {.lex_state = 0, .external_lex_state = 13},
  [105] = {.lex_state = 0, .external_lex_state = 14},
  [106] = {.lex_state = 0, .external_lex_state = 15},
  [107] = {.lex_state = 0, .external_lex_state = 7},
  [108] = {.lex_state = 0, .external_lex_state = 6},
  [109] = {.lex_state = 0, .external_lex_state = 6},
  [110] = {.lex_state = 0, .external_lex_state = 6},
  [111] = {.lex_state = 0, .external_lex_state = 6},
  [112] = {.lex_state = 0, .external_lex_state = 16},
  [113] = {.lex_state = 0, .external_lex_state = 6},
  [114] = {.lex_state = 0, .external_lex_state = 6},
  [115] = {.lex_state = 0, .external_lex_state = 6},
  [116] = {.lex_state = 0, .external_lex_state = 6},
  [117] = {.lex_state = 0, .external_lex_state = 6},
  [118] = {.lex_state = 0, .external_lex_state = 6},
  [119] = {.lex_state = 0, .external_lex_state = 16},
  [120] = {.lex_state = 0, .external_lex_state = 11},
  [121] = {.lex_state = 0, .external_lex_state = 12},
  [122] = {.lex_state = 0, .external_lex_state = 6},
  [123] = {.lex_state = 0, .external_lex_state = 6},
  [124] = {.lex_state = 0, .external_lex_state = 10},
  [125] = {.lex_state = 0, .external_lex_state = 6},
  [126] = {.lex_state = 0, .external_lex_state = 7},
  [127] = {.lex_state = 0, .external_lex_state = 6},
  [128] = {.lex_state = 0, .external_lex_state = 10},
  [129] = {.lex_state = 0, .external_lex_state = 10},
  [130] = {.lex_state = 0, .external_lex_state = 10},
  [131] = {.lex_state = 0, .external_lex_state = 10},
  [132] = {.lex_state = 0, .external_lex_state = 10},
  [133] = {.lex_state = 0, .external_lex_state = 14},
  [134] = {.lex_state = 0, .external_lex_state = 10},
  [135] = {.lex_state = 0, .external_lex_state = 10},
  [136] = {.lex_state = 0, .external_lex_state = 15},
  [137] = {.lex_state = 0, .external_lex_state = 10},
  [138] = {.lex_state = 0, .external_lex_state = 10},
  [139] = {.lex_state = 0, .external_lex_state = 7},
  [140] = {.lex_state = 0, .external_lex_state = 10},
  [141] = {.lex_state = 0, .external_lex_state = 10},
  [142] = {.lex_state = 0, .external_lex_state = 7},
  [143] = {.lex_state = 0, .external_lex_state = 10},
  [144] = {.lex_state = 0, .external_lex_state = 10},
  [145] = {.lex_state = 0, .external_lex_state = 7},
  [146] = {.lex_state = 0, .external_lex_state = 7},
  [147] = {.lex_state = 0, .external_lex_state = 11},
  [148] = {.lex_state = 0, .external_lex_state = 13},
  [149] = {.lex_state = 0, .external_lex_state = 7},
  [150] = {.lex_state = 0, .external_lex_state = 13},
  [151] = {.lex_state = 0, .external_lex_state = 9},
  [152] = {.lex_state = 0, .external_lex_state = 9},
  [153] = {.lex_state = 0, .external_lex_state = 7},
  [154] = {.lex_state = 0, .external_lex_state = 7},
  [155] = {.lex_state = 0, .external_lex_state = 7},
  [156] = {.lex_state = 0, .external_lex_state = 7},
  [157] = {.lex_state = 0, .external_lex_state = 9},
  [158] = {.lex_state = 0, .external_lex_state = 9},
  [159] = {.lex_state = 0, .external_lex_state = 8},
  [160] = {.lex_state = 0, .external_lex_state = 9},
  [161] = {.lex_state = 0, .external_lex_state = 9},
  [162] = {.lex_state = 0, .external_lex_state = 9},
  [163] = {.lex_state = 0, .external_lex_state = 7},
  [164] = {.lex_state = 0, .external_lex_state = 9},
  [165] = {.lex_state = 0, .external_lex_state = 7},
  [166] = {.lex_state = 0, .external_lex_state = 7},
  [167] = {.lex_state = 0, .external_lex_state = 9},
  [168] = {.lex_state = 0, .external_lex_state = 9},
  [169] = {.lex_state = 0, .external_lex_state = 9},
  [170] = {.lex_state = 0, .external_lex_state = 11},
  [171] = {.lex_state = 0, .external_lex_state = 7},
  [172] = {.lex_state = 0, .external_lex_state = 7},
  [173] = {.lex_state = 0, .external_lex_state = 7},
  [174] = {.lex_state = 0, .external_lex_state = 7},
  [175] = {.lex_state = 0, .external_lex_state = 7},
  [176] = {.lex_state = 0, .external_lex_state = 16},
  [177] = {.lex_state = 0, .external_lex_state = 7},
  [178] = {.lex_state = 0, .external_lex_state = 7},
  [179] = {.lex_state = 0, .external_lex_state = 8},
  [180] = {.lex_state = 0, .external_lex_state = 12},
  [181] = {.lex_state = 0, .external_lex_state = 8},
  [182] = {.lex_state = 0, .external_lex_state = 8},
  [183] = {.lex_state = 0, .external_lex_state = 8},
  [184] = {.lex_state = 0, .external_lex_state = 14},
  [185] = {.lex_state = 0, .external_lex_state = 15},
  [186] = {.lex_state = 0, .external_lex_state = 8},
  [187] = {.lex_state = 0, .external_lex_state = 8},
  [188] = {.lex_state = 0, .external_lex_state = 15},
  [189] = {.lex_state = 0, .external_lex_state = 8},
  [190] = {.lex_state = 0, .external_lex_state = 13},
  [191] = {.lex_state = 0, .external_lex_state = 16},
  [192] = {.lex_state = 0, .external_lex_state = 12},
  [193] = {.lex_state = 0, .external_lex_state = 8},
  [194] = {.lex_state = 0, .external_lex_state = 8},
  [195] = {.lex_state = 0, .external_lex_state = 9},
  [196] = {.lex_state = 0, .external_lex_state = 8},
  [197] = {.lex_state = 0, .external_lex_state = 8},
  [198] = {.lex_state = 0, .external_lex_state = 8},
  [199] = {.lex_state = 0, .external_lex_state = 14},
  [200] = {.lex_state = 0, .external_lex_state = 17},
  [201] = {.lex_state = 0, .external_lex_state = 15},
  [202] = {.lex_state = 0, .external_lex_state = 14},
  [203] = {.lex_state = 0, .external_lex_state = 18},
  [204] = {.lex_state = 0, .external_lex_state = 19},
  [205] = {.lex_state = 0, .external_lex_state = 14},
  [206] = {.lex_state = 0, .external_lex_state = 14},
  [207] = {.lex_state = 0, .external_lex_state = 14},
  [208] = {.lex_state = 0, .external_lex_state = 14},
  [209] = {.lex_state = 0, .external_lex_state = 14},
  [210] = {.lex_state = 0, .external_lex_state = 18},
  [211] = {.lex_state = 0, .external_lex_state = 15},
  [212] = {.lex_state = 0, .external_lex_state = 14},
  [213] = {.lex_state = 0, .external_lex_state = 19},
  [214] = {.lex_state = 0, .external_lex_state = 19},
  [215] = {.lex_state = 0, .external_lex_state = 14},
  [216] = {.lex_state = 0, .external_lex_state = 15},
  [217] = {.lex_state = 0, .external_lex_state = 14},
  [218] = {.lex_state = 0, .external_lex_state = 18},
  [219] = {.lex_state = 0, .external_lex_state = 11},
  [220] = {.lex_state = 0, .external_lex_state = 15},
  [221] = {.lex_state = 0, .external_lex_state = 16},
  [222] = {.lex_state = 0, .external_lex_state = 15},
  [223] = {.lex_state = 0, .external_lex_state = 16},
  [224] = {.lex_state = 0, .external_lex_state = 16},
  [225] = {.lex_state = 0, .external_lex_state = 16},
  [226] = {.lex_state = 0, .external_lex_state = 16},
  [227] = {.lex_state = 0, .external_lex_state = 16},
  [228] = {.lex_state = 0, .external_lex_state = 16},
  [229] = {.lex_state = 0, .external_lex_state = 16},
  [230] = {.lex_state = 0, .external_lex_state = 16},
  [231] = {.lex_state = 0, .external_lex_state = 15},
  [232] = {.lex_state = 0, .external_lex_state = 14},
  [233] = {.lex_state = 0, .external_lex_state = 13},
  [234] = {.lex_state = 0, .external_lex_state = 14},
  [235] = {.lex_state = 0, .external_lex_state = 16},
  [236] = {.lex_state = 0, .external_lex_state = 11},
  [237] = {.lex_state = 0, .external_lex_state = 16},
  [238] = {.lex_state = 0, .external_lex_state = 16},
  [239] = {.lex_state = 0, .external_lex_state = 13},
  [240] = {.lex_state = 0, .external_lex_state = 13},
  [241] = {.lex_state = 0, .external_lex_state = 13},
  [242] = {.lex_state = 0, .external_lex_state = 13},
  [243] = {.lex_state = 0, .external_lex_state = 13},
  [244] = {.lex_state = 0, .external_lex_state = 20},
  [245] = {.lex_state = 0, .external_lex_state = 13},
  [246] = {.lex_state = 0, .external_lex_state = 21},
  [247] = {.lex_state = 0, .external_lex_state = 15},
  [248] = {.lex_state = 0, .external_lex_state = 15},
  [249] = {.lex_state = 0, .external_lex_state = 14},
  [250] = {.lex_state = 0, .external_lex_state = 13},
  [251] = {.lex_state = 0, .external_lex_state = 13},
  [252] = {.lex_state = 0, .external_lex_state = 11},
  [253] = {.lex_state = 0, .external_lex_state = 11},
  [254] = {.lex_state = 0, .external_lex_state = 11},
  [255] = {.lex_state = 0, .external_lex_state = 11},
  [256] = {.lex_state = 0, .external_lex_state = 11},
  [257] = {.lex_state = 0, .external_lex_state = 11},
  [258] = {.lex_state = 0, .external_lex_state = 11},
  [259] = {.lex_state = 0, .external_lex_state = 11},
  [260] = {.lex_state = 0, .external_lex_state = 13},
  [261] = {.lex_state = 0, .external_lex_state = 15},
  [262] = {.lex_state = 0, .external_lex_state = 15},
  [263] = {.lex_state = 0, .external_lex_state = 11},
  [264] = {.lex_state = 0, .external_lex_state = 11},
  [265] = {.lex_state = 0, .external_lex_state = 13},
  [266] = {.lex_state = 0, .external_lex_state = 12},
  [267] = {.lex_state = 0, .external_lex_state = 12},
  [268] = {.lex_state = 0, .external_lex_state = 12},
  [269] = {.lex_state = 0, .external_lex_state = 12},
  [270] = {.lex_state = 0, .external_lex_state = 21},
  [271] = {.lex_state = 0, .external_lex_state = 16},
  [272] = {.lex_state = 0, .external_lex_state = 12},
  [273] = {.lex_state = 0, .external_lex_state = 12},
  [274] = {.lex_state = 0, .external_lex_state = 13},
  [275] = {.lex_state = 0, .external_lex_state = 12},
  [276] = {.lex_state = 0, .external_lex_state = 13},
  [277] = {.lex_state = 0, .external_lex_state = 15},
  [278] = {.lex_state = 0, .external_lex_state = 12},
  [279] = {.lex_state = 0, .external_lex_state = 14},
  [280] = {.lex_state = 0, .external_lex_state = 18},
  [281] = {.lex_state = 0, .external_lex_state = 11},
  [282] = {.lex_state = 0, .external_lex_state = 20},
  [283] = {.lex_state = 0, .external_lex_state = 17},
  [284] = {.lex_state = 0, .external_lex_state = 12},
  [285] = {.lex_state = 0, .external_lex_state = 20},
  [286] = {.lex_state = 0, .external_lex_state = 17},
  [287] = {.lex_state = 0, .external_lex_state = 17},
  [288] = {.lex_state = 0, .external_lex_state = 15},
  [289] = {.lex_state = 0, .external_lex_state = 15},
  [290] = {.lex_state = 0, .external_lex_state = 12},
  [291] = {.lex_state = 0, .external_lex_state = 12},
  [292] = {.lex_state = 0, .external_lex_state = 20},
  [293] = {.lex_state = 0, .external_lex_state = 21},
  [294] = {.lex_state = 0, .external_lex_state = 12},
  [295] = {.lex_state = 0, .external_lex_state = 19},
  [296] = {.lex_state = 0, .external_lex_state = 21},
  [297] = {.lex_state = 0, .external_lex_state = 12},
  [298] = {.lex_state = 0, .external_lex_state = 21},
  [299] = {.lex_state = 0, .external_lex_state = 19},
  [300] = {.lex_state = 0, .external_lex_state = 17},
  [301] = {.lex_state = 0, .external_lex_state = 17},
  [302] = {.lex_state = 0, .external_lex_state = 17},
  [303] = {.lex_state = 0, .external_lex_state = 22},
  [304] = {.lex_state = 0, .external_lex_state = 17},
  [305] = {.lex_state = 0, .external_lex_state = 17},
  [306] = {.lex_state = 0, .external_lex_state = 17},
  [307] = {.lex_state = 0, .external_lex_state = 19},
  [308] = {.lex_state = 0, .external_lex_state = 19},
  [309] = {.lex_state = 0, .external_lex_state = 22},
  [310] = {.lex_state = 0, .external_lex_state = 19},
  [311] = {.lex_state = 0, .external_lex_state = 19},
  [312] = {.lex_state = 0, .external_lex_state = 20},
  [313] = {.lex_state = 0, .external_lex_state = 19},
  [314] = {.lex_state = 0, .external_lex_state = 22},
  [315] = {.lex_state = 0, .external_lex_state = 22},
  [316] = {.lex_state = 0, .external_lex_state = 22},
  [317] = {.lex_state = 0, .external_lex_state = 22},
  [318] = {.lex_state = 0, .external_lex_state = 22},
  [319] = {.lex_state = 0, .external_lex_state = 22},
  [320] = {.lex_state = 0, .external_lex_state = 23},
  [321] = {.lex_state = 0, .external_lex_state = 22},
  [322] = {.lex_state = 0, .external_lex_state = 22},
  [323] = {.lex_state = 0, .external_lex_state = 22},
  [324] = {.lex_state = 0, .external_lex_state = 17},
  [325] = {.lex_state = 0, .external_lex_state = 20},
  [326] = {.lex_state = 0, .external_lex_state = 20},
  [327] = {.lex_state = 0, .external_lex_state = 17},
  [328] = {.lex_state = 0, .external_lex_state = 17},
  [329] = {.lex_state = 0, .external_lex_state = 17},
  [330] = {.lex_state = 0, .external_lex_state = 17},
  [331] = {.lex_state = 0, .external_lex_state = 17},
  [332] = {.lex_state = 0, .external_lex_state = 20},
  [333] = {.lex_state = 0, .external_lex_state = 24},
  [334] = {.lex_state = 0, .external_lex_state = 23},
  [335] = {.lex_state = 0, .external_lex_state = 23},
  [336] = {.lex_state = 0, .external_lex_state = 21},
  [337] = {.lex_state = 0, .external_lex_state = 20},
  [338] = {.lex_state = 0, .external_lex_state = 23},
  [339] = {.lex_state = 0, .external_lex_state = 21},
  [340] = {.lex_state = 0, .external_lex_state = 23},
  [341] = {.lex_state = 0, .external_lex_state = 20},
  [342] = {.lex_state = 0, .external_lex_state = 23},
  [343] = {.lex_state = 0, .external_lex_state = 20},
  [344] = {.lex_state = 0, .external_lex_state = 23},
  [345] = {.lex_state = 0, .external_lex_state = 23},
  [346] = {.lex_state = 0, .external_lex_state = 23},
  [347] = {.lex_state = 0, .external_lex_state = 23},
  [348] = {.lex_state = 0, .external_lex_state = 18},
  [349] = {.lex_state = 0, .external_lex_state = 23},
  [350] = {.lex_state = 0, .external_lex_state = 24},
  [351] = {.lex_state = 0, .external_lex_state = 18},
  [352] = {.lex_state = 0, .external_lex_state = 18},
  [353] = {.lex_state = 0, .external_lex_state = 23},
  [354] = {.lex_state = 0, .external_lex_state = 22},
  [355] = {.lex_state = 0, .external_lex_state = 18},
  [356] = {.lex_state = 0, .external_lex_state = 19},
  [357] = {.lex_state = 0, .external_lex_state = 21},
  [358] = {.lex_state = 0, .external_lex_state = 18},
  [359] = {.lex_state = 0, .external_lex_state = 18},
  [360] = {.lex_state = 0, .external_lex_state = 18},
  [361] = {.lex_state = 0, .external_lex_state = 18},
  [362] = {.lex_state = 0, .external_lex_state = 21},
  [363] = {.lex_state = 0, .external_lex_state = 18},
  [364] = {.lex_state = 0, .external_lex_state = 21},
  [365] = {.lex_state = 0, .external_lex_state = 21},
  [366] = {.lex_state = 0, .external_lex_state = 25},
  [367] = {.lex_state = 0, .external_lex_state = 18},
  [368] = {.lex_state = 0, .external_lex_state = 18},
  [369] = {.lex_state = 0, .external_lex_state = 18},
  [370] = {.lex_state = 0, .external_lex_state = 21},
  [371] = {.lex_state = 0, .external_lex_state = 20},
  [372] = {.lex_state = 0, .external_lex_state = 20},
  [373] = {.lex_state = 0, .external_lex_state = 21},
  [374] = {.lex_state = 0, .external_lex_state = 21},
  [375] = {.lex_state = 0, .external_lex_state = 25},
  [376] = {.lex_state = 0, .external_lex_state = 25},
  [377] = {.lex_state = 0, .external_lex_state = 17},
  [378] = {.lex_state = 0, .external_lex_state = 17},
  [379] = {.lex_state = 0, .external_lex_state = 17},
  [380] = {.lex_state = 0, .external_lex_state = 25},
  [381] = {.lex_state = 0, .external_lex_state = 21},
  [382] = {.lex_state = 0, .external_lex_state = 17},
  [383] = {.lex_state = 0, .external_lex_state = 17},
  [384] = {.lex_state = 0, .external_lex_state = 17},
  [385] = {.lex_state = 0, .external_lex_state = 17},
  [386] = {.lex_state = 0, .external_lex_state = 17},
  [387] = {.lex_state = 0, .external_lex_state = 17},
  [388] = {.lex_state = 0, .external_lex_state = 21},
  [389] = {.lex_state = 0, .external_lex_state = 25},
  [390] = {.lex_state = 0, .external_lex_state = 17},
  [391] = {.lex_state = 0, .external_lex_state = 17},
  [392] = {.lex_state = 0, .external_lex_state = 20},
  [393] = {.lex_state = 0, .external_lex_state = 17},
  [394] = {.lex_state = 0, .external_lex_state = 25},
  [395] = {.lex_state = 0, .external_lex_state = 25},
  [396] = {.lex_state = 0, .external_lex_state = 19},
  [397] = {.lex_state = 0, .external_lex_state = 25},
  [398] = {.lex_state = 0, .external_lex_state = 19},
  [399] = {.lex_state = 0, .external_lex_state = 17},
  [400] = {.lex_state = 0, .external_lex_state = 19},
  [401] = {.lex_state = 0, .external_lex_state = 25},
  [402] = {.lex_state = 0, .external_lex_state = 24},
  [403] = {.lex_state = 0, .external_lex_state = 25},
  [404] = {.lex_state = 0, .external_lex_state = 20},
  [405] = {.lex_state = 0, .external_lex_state = 25},
  [406] = {.lex_state = 0, .external_lex_state = 20},
  [407] = {.lex_state = 0, .external_lex_state = 19},
  [408] = {.lex_state = 0, .external_lex_state = 25},
  [409] = {.lex_state = 0, .external_lex_state = 18},
  [410] = {.lex_state = 0, .external_lex_state = 19},
  [411] = {.lex_state = 0, .external_lex_state = 19},
  [412] = {.lex_state = 0, .external_lex_state = 20},
  [413] = {.lex_state = 0, .external_lex_state = 24},
  [414] = {.lex_state = 0, .external_lex_state = 21},
  [415] = {.lex_state = 0, .external_lex_state = 24},
  [416] = {.lex_state = 0, .external_lex_state = 26},
  [417] = {.lex_state = 0, .external_lex_state = 26},
  [418] = {.lex_state = 0, .external_lex_state = 24},
  [419] = {.lex_state = 0, .external_lex_state = 24},
  [420] = {.lex_state = 0, .external_lex_state = 27},
  [421] = {.lex_state = 0, .external_lex_state = 27},
  [422] = {.lex_state = 0, .external_lex_state = 27},
  [423] = {.lex_state = 0, .external_lex_state = 27},
  [424] = {.lex_state = 0, .external_lex_state = 24},
  [425] = {.lex_state = 0, .external_lex_state = 27},
  [426] = {.lex_state = 0, .external_lex_state = 27},
  [427] = {.lex_state = 0, .external_lex_state = 27},
  [428] = {.lex_state = 0, .external_lex_state = 27},
  [429] = {.lex_state = 0, .external_lex_state = 24},
  [430] = {.lex_state = 0, .external_lex_state = 27},
  [431] = {.lex_state = 0, .external_lex_state = 27},
  [432] = {.lex_state = 0, .external_lex_state = 27},
  [433] = {.lex_state = 0, .external_lex_state = 27},
  [434] = {.lex_state = 0, .external_lex_state = 28},
  [435] = {.lex_state = 0, .external_lex_state = 26},
  [436] = {.lex_state = 0, .external_lex_state = 28},
  [437] = {.lex_state = 0, .external_lex_state = 28},
  [438] = {.lex_state = 0, .external_lex_state = 28},
  [439] = {.lex_state = 0, .external_lex_state = 28},
  [440] = {.lex_state = 0, .external_lex_state = 28},
  [441] = {.lex_state = 0, .external_lex_state = 28},
  [442] = {.lex_state = 0, .external_lex_state = 28},
  [443] = {.lex_state = 0, .external_lex_state = 24},
  [444] = {.lex_state = 0, .external_lex_state = 28},
  [445] = {.lex_state = 0, .external_lex_state = 28},
  [446] = {.lex_state = 0, .external_lex_state = 24},
  [447] = {.lex_state = 0, .external_lex_state = 28},
  [448] = {.lex_state = 0, .external_lex_state = 24},
  [449] = {.lex_state = 0, .external_lex_state = 24},
  [450] = {.lex_state = 0, .external_lex_state = 28},
  [451] = {.lex_state = 0, .external_lex_state = 24},
  [452] = {.lex_state = 0, .external_lex_state = 26},
  [453] = {.lex_state = 0, .external_lex_state = 24},
  [454] = {.lex_state = 0, .external_lex_state = 24},
  [455] = {.lex_state = 0, .external_lex_state = 24},
  [456] = {.lex_state = 0, .external_lex_state = 24},
  [457] = {.lex_state = 0, .external_lex_state = 24},
  [458] = {.lex_state = 0, .external_lex_state = 24},
  [459] = {.lex_state = 0, .external_lex_state = 24},
  [460] = {.lex_state = 0, .external_lex_state = 26},
  [461] = {.lex_state = 0, .external_lex_state = 24},
  [462] = {.lex_state = 0, .external_lex_state = 24},
  [463] = {.lex_state = 0, .external_lex_state = 24},
  [464] = {.lex_state = 0, .external_lex_state = 26},
  [465] = {.lex_state = 0, .external_lex_state = 24},
  [466] = {.lex_state = 0, .external_lex_state = 26},
  [467] = {.lex_state = 0, .external_lex_state = 26},
  [468] = {.lex_state = 0, .external_lex_state = 24},
  [469] = {.lex_state = 0, .external_lex_state = 24},
  [470] = {.lex_state = 0, .external_lex_state = 26},
  [471] = {.lex_state = 0, .external_lex_state = 26},
  [472] = {.lex_state = 0, .external_lex_state = 24},
  [473] = {.lex_state = 0, .external_lex_state = 26},
  [474] = {.lex_state = 0, .external_lex_state = 24},
  [475] = {.lex_state = 0, .external_lex_state = 26},
  [476] = {.lex_state = 0, .external_lex_state = 5},
  [477] = {.lex_state = 0, .external_lex_state = 4},
  [478] = {.lex_state = 0, .external_lex_state = 5},
  [479] = {.lex_state = 0, .external_lex_state = 3},
  [480] = {.lex_state = 0, .external_lex_state = 4},
  [481] = {.lex_state = 0, .external_lex_state = 5},
  [482] = {.lex_state = 0, .external_lex_state = 4},
  [483] = {.lex_state = 0, .external_lex_state = 4},
  [484] = {.lex_state = 0, .external_lex_state = 5},
  [485] = {.lex_state = 0, .external_lex_state = 4},
  [486] = {.lex_state = 0, .external_lex_state = 4},
  [487] = {.lex_state = 0, .external_lex_state = 3},
  [488] = {.lex_state = 0, .external_lex_state = 3},
  [489] = {.lex_state = 0, .external_lex_state = 3},
  [490] = {.lex_state = 0, .external_lex_state = 4},
  [491] = {.lex_state = 0, .external_lex_state = 5},
  [492] = {.lex_state = 0, .external_lex_state = 3},
  [493] = {.lex_state = 0, .external_lex_state = 5},
  [494] = {.lex_state = 0, .external_lex_state = 5},
  [495] = {.lex_state = 0, .external_lex_state = 3},
  [496] = {.lex_state = 0, .external_lex_state = 3},
  [497] = {.lex_state = 0, .external_lex_state = 5},
  [498] = {.lex_state = 0, .external_lex_state = 3},
  [499] = {.lex_state = 0, .external_lex_state = 4},
  [500] = {.lex_state = 0, .external_lex_state = 4},
  [501] = {.lex_state = 0, .external_lex_state = 8},
  [502] = {.lex_state = 0, .external_lex_state = 5},
  [503] = {.lex_state = 0, .external_lex_state = 8},
  [504] = {.lex_state = 0, .external_lex_state = 8},
  [505] = {.lex_state = 0, .external_lex_state = 8},
  [506] = {.lex_state = 0, .external_lex_state = 4},
  [507] = {.lex_state = 0, .external_lex_state = 5},
  [508] = {.lex_state = 0, .external_lex_state = 3},
  [509] = {.lex_state = 0, .external_lex_state = 3},
  [510] = {.lex_state = 0, .external_lex_state = 3},
  [511] = {.lex_state = 0, .external_lex_state = 3},
  [512] = {.lex_state = 0, .external_lex_state = 3},
  [513] = {.lex_state = 0, .external_lex_state = 3},
  [514] = {.lex_state = 0, .external_lex_state = 3},
  [515] = {.lex_state = 0, .external_lex_state = 3},
  [516] = {.lex_state = 0, .external_lex_state = 3},
  [517] = {.lex_state = 0, .external_lex_state = 3},
  [518] = {.lex_state = 0, .external_lex_state = 3},
  [519] = {.lex_state = 0, .external_lex_state = 3},
  [520] = {.lex_state = 0, .external_lex_state = 3},
  [521] = {.lex_state = 0, .external_lex_state = 3},
  [522] = {.lex_state = 0, .external_lex_state = 4},
  [523] = {.lex_state = 0, .external_lex_state = 3},
  [524] = {.lex_state = 0, .external_lex_state = 3},
  [525] = {.lex_state = 0, .external_lex_state = 3},
  [526] = {.lex_state = 0, .external_lex_state = 3},
  [527] = {.lex_state = 0, .external_lex_state = 3},
  [528] = {.lex_state = 0, .external_lex_state = 3},
  [529] = {.lex_state = 0, .external_lex_state = 3},
  [530] = {.lex_state = 0, .external_lex_state = 3},
  [531] = {.lex_state = 0, .external_lex_state = 3},
  [532] = {.lex_state = 0, .external_lex_state = 9},
  [533] = {.lex_state = 0, .external_lex_state = 3},
  [534] = {.lex_state = 0, .external_lex_state = 3},
  [535] = {.lex_state = 0, .external_lex_state = 3},
  [536] = {.lex_state = 0, .external_lex_state = 3},
  [537] = {.lex_state = 0, .external_lex_state = 9},
  [538] = {.lex_state = 0, .external_lex_state = 9},
  [539] = {.lex_state = 0, .external_lex_state = 3},
  [540] = {.lex_state = 0, .external_lex_state = 3},
  [541] = {.lex_state = 0, .external_lex_state = 3},
  [542] = {.lex_state = 0, .external_lex_state = 9},
  [543] = {.lex_state = 0, .external_lex_state = 3},
  [544] = {.lex_state = 0, .external_lex_state = 3},
  [545] = {.lex_state = 0, .external_lex_state = 3},
  [546] = {.lex_state = 0, .external_lex_state = 3},
  [547] = {.lex_state = 0, .external_lex_state = 3},
  [548] = {.lex_state = 0, .external_lex_state = 3},
  [549] = {.lex_state = 0, .external_lex_state = 3},
  [550] = {.lex_state = 0, .external_lex_state = 3},
  [551] = {.lex_state = 0, .external_lex_state = 3},
  [552] = {.lex_state = 0, .external_lex_state = 3},
  [553] = {.lex_state = 0, .external_lex_state = 3},
  [554] = {.lex_state = 0, .external_lex_state = 3},
  [555] = {.lex_state = 0, .external_lex_state = 3},
  [556] = {.lex_state = 0, .external_lex_state = 3},
  [557] = {.lex_state = 0, .external_lex_state = 3},
  [558] = {.lex_state = 0, .external_lex_state = 3},
  [559] = {.lex_state = 0, .external_lex_state = 3},
  [560] = {.lex_state = 0, .external_lex_state = 3},
  [561] = {.lex_state = 0, .external_lex_state = 3},
  [562] = {.lex_state = 0, .external_lex_state = 3},
  [563] = {.lex_state = 0, .external_lex_state = 4},
  [564] = {.lex_state = 0, .external_lex_state = 4},
  [565] = {.lex_state = 0, .external_lex_state = 4},
  [566] = {.lex_state = 0, .external_lex_state = 4},
  [567] = {.lex_state = 0, .external_lex_state = 4},
  [568] = {.lex_state = 0, .external_lex_state = 4},
  [569] = {.lex_state = 0, .external_lex_state = 4},
  [570] = {.lex_state = 0, .external_lex_state = 4},
  [571] = {.lex_state = 0, .external_lex_state = 4},
  [572] = {.lex_state = 0, .external_lex_state = 4},
  [573] = {.lex_state = 0, .external_lex_state = 4},
  [574] = {.lex_state = 0, .external_lex_state = 4},
  [575] = {.lex_state = 0, .external_lex_state = 3},
  [576] = {.lex_state = 0, .external_lex_state = 4},
  [577] = {.lex_state = 0, .external_lex_state = 4},
  [578] = {.lex_state = 0, .external_lex_state = 4},
  [579] = {.lex_state = 0, .external_lex_state = 4},
  [580] = {.lex_state = 0, .external_lex_state = 4},
  [581] = {.lex_state = 0, .external_lex_state = 4},
  [582] = {.lex_state = 0, .external_lex_state = 4},
  [583] = {.lex_state = 0, .external_lex_state = 4},
  [584] = {.lex_state = 0, .external_lex_state = 4},
  [585] = {.lex_state = 0, .external_lex_state = 4},
  [586] = {.lex_state = 0, .external_lex_state = 4},
  [587] = {.lex_state = 0, .external_lex_state = 4},
  [588] = {.lex_state = 0, .external_lex_state = 4},
  [589] = {.lex_state = 0, .external_lex_state = 4},
  [590] = {.lex_state = 0, .external_lex_state = 4},
  [591] = {.lex_state = 0, .external_lex_state = 4},
  [592] = {.lex_state = 0, .external_lex_state = 4},
  [593] = {.lex_state = 0, .external_lex_state = 4},
  [594] = {.lex_state = 0, .external_lex_state = 4},
  [595] = {.lex_state = 0, .external_lex_state = 4},
  [596] = {.lex_state = 0, .external_lex_state = 4},
  [597] = {.lex_state = 0, .external_lex_state = 4},
  [598] = {.lex_state = 0, .external_lex_state = 4},
  [599] = {.lex_state = 0, .external_lex_state = 3},
  [600] = {.lex_state = 0, .external_lex_state = 4},
  [601] = {.lex_state = 0, .external_lex_state = 4},
  [602] = {.lex_state = 0, .external_lex_state = 4},
  [603] = {.lex_state = 0, .external_lex_state = 4},
  [604] = {.lex_state = 0, .external_lex_state = 8},
  [605] = {.lex_state = 0, .external_lex_state = 4},
  [606] = {.lex_state = 0, .external_lex_state = 4},
  [607] = {.lex_state = 0, .external_lex_state = 4},
  [608] = {.lex_state = 0, .external_lex_state = 4},
  [609] = {.lex_state = 0, .external_lex_state = 4},
  [610] = {.lex_state = 0, .external_lex_state = 4},
  [611] = {.lex_state = 0, .external_lex_state = 4},
  [612] = {.lex_state = 0, .external_lex_state = 4},
  [613] = {.lex_state = 0, .external_lex_state = 4},
  [614] = {.lex_state = 0, .external_lex_state = 4},
  [615] = {.lex_state = 0, .external_lex_state = 5},
  [616] = {.lex_state = 0, .external_lex_state = 5},
  [617] = {.lex_state = 0, .external_lex_state = 5},
  [618] = {.lex_state = 0, .external_lex_state = 5},
  [619] = {.lex_state = 0, .external_lex_state = 5},
  [620] = {.lex_state = 0, .external_lex_state = 5},
  [621] = {.lex_state = 0, .external_lex_state = 5},
  [622] = {.lex_state = 0, .external_lex_state = 5},
  [623] = {.lex_state = 0, .external_lex_state = 5},
  [624] = {.lex_state = 0, .external_lex_state = 5},
  [625] = {.lex_state = 0, .external_lex_state = 5},
  [626] = {.lex_state = 0, .external_lex_state = 5},
  [627] = {.lex_state = 0, .external_lex_state = 5},
  [628] = {.lex_state = 0, .external_lex_state = 5},
  [629] = {.lex_state = 0, .external_lex_state = 5},
  [630] = {.lex_state = 0, .external_lex_state = 5},
  [631] = {.lex_state = 0, .external_lex_state = 5},
  [632] = {.lex_state = 0, .external_lex_state = 5},
  [633] = {.lex_state = 0, .external_lex_state = 5},
  [634] = {.lex_state = 0, .external_lex_state = 5},
  [635] = {.lex_state = 0, .external_lex_state = 5},
  [636] = {.lex_state = 0, .external_lex_state = 5},
  [637] = {.lex_state = 0, .external_lex_state = 5},
  [638] = {.lex_state = 0, .external_lex_state = 5},
  [639] = {.lex_state = 0, .external_lex_state = 5},
  [640] = {.lex_state = 0, .external_lex_state = 5},
  [641] = {.lex_state = 0, .external_lex_state = 5},
  [642] = {.lex_state = 0, .external_lex_state = 5},
  [643] = {.lex_state = 0, .external_lex_state = 5},
  [644] = {.lex_state = 0, .external_lex_state = 5},
  [645] = {.lex_state = 0, .external_lex_state = 5},
  [646] = {.lex_state = 0, .external_lex_state = 5},
  [647] = {.lex_state = 0, .external_lex_state = 5},
  [648] = {.lex_state = 0, .external_lex_state = 5},
  [649] = {.lex_state = 0, .external_lex_state = 5},
  [650] = {.lex_state = 0, .external_lex_state = 5},
  [651] = {.lex_state = 0, .external_lex_state = 5},
  [652] = {.lex_state = 0, .external_lex_state = 5},
  [653] = {.lex_state = 0, .external_lex_state = 5},
  [654] = {.lex_state = 0, .external_lex_state = 5},
  [655] = {.lex_state = 0, .external_lex_state = 5},
  [656] = {.lex_state = 0, .external_lex_state = 5},
  [657] = {.lex_state = 0, .external_lex_state = 5},
  [658] = {.lex_state = 0, .external_lex_state = 5},
  [659] = {.lex_state = 0, .external_lex_state = 5},
  [660] = {.lex_state = 0, .external_lex_state = 5},
  [661] = {.lex_state = 0, .external_lex_state = 5},
  [662] = {.lex_state = 0, .external_lex_state = 5},
  [663] = {.lex_state = 0, .external_lex_state = 5},
  [664] = {.lex_state = 0, .external_lex_state = 5},
  [665] = {.lex_state = 0, .external_lex_state = 9},
  [666] = {.lex_state = 0, .external_lex_state = 9},
  [667] = {.lex_state = 0, .external_lex_state = 9},
  [668] = {.lex_state = 0, .external_lex_state = 9},
  [669] = {.lex_state = 0, .external_lex_state = 8},
  [670] = {.lex_state = 0, .external_lex_state = 8},
  [671] = {.lex_state = 0, .external_lex_state = 8},
  [672] = {.lex_state = 0, .external_lex_state = 7},
  [673] = {.lex_state = 0, .external_lex_state = 8},
  [674] = {.lex_state = 0, .external_lex_state = 10},
  [675] = {.lex_state = 0, .external_lex_state = 10},
  [676] = {.lex_state = 0, .external_lex_state = 10},
  [677] = {.lex_state = 0, .external_lex_state = 10},
  [678] = {.lex_state = 0, .external_lex_state = 10},
  [679] = {.lex_state = 0, .external_lex_state = 6},
  [680] = {.lex_state = 0, .external_lex_state = 6},
  [681] = {.lex_state = 0, .external_lex_state = 6},
  [682] = {.lex_state = 0, .external_lex_state = 6},
  [683] = {.lex_state = 0, .external_lex_state = 6},
  [684] = {.lex_state = 0, .external_lex_state = 6},
  [685] = {.lex_state = 0, .external_lex_state = 6},
  [686] = {.lex_state = 0, .external_lex_state = 6},
  [687] = {.lex_state = 0, .external_lex_state = 6},
  [688] = {.lex_state = 0, .external_lex_state = 10},
  [689] = {.lex_state = 0, .external_lex_state = 6},
  [690] = {.lex_state = 0, .external_lex_state = 6},
  [691] = {.lex_state = 0, .external_lex_state = 10},
  [692] = {.lex_state = 0, .external_lex_state = 10},
  [693] = {.lex_state = 0, .external_lex_state = 10},
  [694] = {.lex_state = 0, .external_lex_state = 10},
  [695] = {.lex_state = 0, .external_lex_state = 6},
  [696] = {.lex_state = 0, .external_lex_state = 10},
  [697] = {.lex_state = 0, .external_lex_state = 10},
  [698] = {.lex_state = 0, .external_lex_state = 10},
  [699] = {.lex_state = 0, .external_lex_state = 6},
  [700] = {.lex_state = 0, .external_lex_state = 6},
  [701] = {.lex_state = 0, .external_lex_state = 6},
  [702] = {.lex_state = 0, .external_lex_state = 6},
  [703] = {.lex_state = 0, .external_lex_state = 6},
  [704] = {.lex_state = 0, .external_lex_state = 6},
  [705] = {.lex_state = 0, .external_lex_state = 6},
  [706] = {.lex_state = 0, .external_lex_state = 6},
  [707] = {.lex_state = 0, .external_lex_state = 6},
  [708] = {.lex_state = 0, .external_lex_state = 6},
  [709] = {.lex_state = 0, .external_lex_state = 6},
  [710] = {.lex_state = 0, .external_lex_state = 6},
  [711] = {.lex_state = 0, .external_lex_state = 6},
  [712] = {.lex_state = 0, .external_lex_state = 10},
  [713] = {.lex_state = 0, .external_lex_state = 6},
  [714] = {.lex_state = 0, .external_lex_state = 10},
  [715] = {.lex_state = 0, .external_lex_state = 10},
  [716] = {.lex_state = 0, .external_lex_state = 10},
  [717] = {.lex_state = 0, .external_lex_state = 10},
  [718] = {.lex_state = 0, .external_lex_state = 10},
  [719] = {.lex_state = 0, .external_lex_state = 10},
  [720] = {.lex_state = 0, .external_lex_state = 10},
  [721] = {.lex_state = 0, .external_lex_state = 10},
  [722] = {.lex_state = 0, .external_lex_state = 10},
  [723] = {.lex_state = 0, .external_lex_state = 6},
  [724] = {.lex_state = 0, .external_lex_state = 10},
  [725] = {.lex_state = 0, .external_lex_state = 6},
  [726] = {.lex_state = 0, .external_lex_state = 6},
  [727] = {.lex_state = 0, .external_lex_state = 6},
  [728] = {.lex_state = 0, .external_lex_state = 6},
  [729] = {.lex_state = 0, .external_lex_state = 10},
  [730] = {.lex_state = 0, .external_lex_state = 6},
  [731] = {.lex_state = 0, .external_lex_state = 10},
  [732] = {.lex_state = 0, .external_lex_state = 6},
  [733] = {.lex_state = 0, .external_lex_state = 10},
  [734] = {.lex_state = 0, .external_lex_state = 6},
  [735] = {.lex_state = 0, .external_lex_state = 10},
  [736] = {.lex_state = 0, .external_lex_state = 6},
  [737] = {.lex_state = 0, .external_lex_state = 10},
  [738] = {.lex_state = 0, .external_lex_state = 6},
  [739] = {.lex_state = 0, .external_lex_state = 10},
  [740] = {.lex_state = 0, .external_lex_state = 6},
  [741] = {.lex_state = 0, .external_lex_state = 10},
  [742] = {.lex_state = 0, .external_lex_state = 6},
  [743] = {.lex_state = 0, .external_lex_state = 10},
  [744] = {.lex_state = 0, .external_lex_state = 6},
  [745] = {.lex_state = 0, .external_lex_state = 6},
  [746] = {.lex_state = 0, .external_lex_state = 6},
  [747] = {.lex_state = 0, .external_lex_state = 6},
  [748] = {.lex_state = 0, .external_lex_state = 6},
  [749] = {.lex_state = 0, .external_lex_state = 6},
  [750] = {.lex_state = 0, .external_lex_state = 10},
  [751] = {.lex_state = 0, .external_lex_state = 10},
  [752] = {.lex_state = 0, .external_lex_state = 10},
  [753] = {.lex_state = 0, .external_lex_state = 6},
  [754] = {.lex_state = 0, .external_lex_state = 10},
  [755] = {.lex_state = 0, .external_lex_state = 10},
  [756] = {.lex_state = 0, .external_lex_state = 10},
  [757] = {.lex_state = 0, .external_lex_state = 10},
  [758] = {.lex_state = 0, .external_lex_state = 10},
  [759] = {.lex_state = 0, .external_lex_state = 10},
  [760] = {.lex_state = 0, .external_lex_state = 10},
  [761] = {.lex_state = 0, .external_lex_state = 10},
  [762] = {.lex_state = 0, .external_lex_state = 10},
  [763] = {.lex_state = 0, .external_lex_state = 10},
  [764] = {.lex_state = 0, .external_lex_state = 10},
  [765] = {.lex_state = 0, .external_lex_state = 10},
  [766] = {.lex_state = 0, .external_lex_state = 10},
  [767] = {.lex_state = 0, .external_lex_state = 10},
  [768] = {.lex_state = 0, .external_lex_state = 10},
  [769] = {.lex_state = 0, .external_lex_state = 6},
  [770] = {.lex_state = 0, .external_lex_state = 6},
  [771] = {.lex_state = 0, .external_lex_state = 6},
  [772] = {.lex_state = 0, .external_lex_state = 6},
  [773] = {.lex_state = 0, .external_lex_state = 6},
  [774] = {.lex_state = 0, .external_lex_state = 6},
  [775] = {.lex_state = 0, .external_lex_state = 13},
  [776] = {.lex_state = 0, .external_lex_state = 13},
  [777] = {.lex_state = 0, .external_lex_state = 13},
  [778] = {.lex_state = 0, .external_lex_state = 3},
  [779] = {.lex_state = 0, .external_lex_state = 13},
  [780] = {.lex_state = 0, .external_lex_state = 3},
  [781] = {.lex_state = 0, .external_lex_state = 16},
  [782] = {.lex_state = 0, .external_lex_state = 16},
  [783] = {.lex_state = 0, .external_lex_state = 16},
  [784] = {.lex_state = 0, .external_lex_state = 16},
  [785] = {.lex_state = 0, .external_lex_state = 14},
  [786] = {.lex_state = 0, .external_lex_state = 14},
  [787] = {.lex_state = 0, .external_lex_state = 14},
  [788] = {.lex_state = 0, .external_lex_state = 14},
  [789] = {.lex_state = 0, .external_lex_state = 8},
  [790] = {.lex_state = 0, .external_lex_state = 7},
  [791] = {.lex_state = 0, .external_lex_state = 7},
  [792] = {.lex_state = 0, .external_lex_state = 11},
  [793] = {.lex_state = 0, .external_lex_state = 11},
  [794] = {.lex_state = 0, .external_lex_state = 11},
  [795] = {.lex_state = 0, .external_lex_state = 11},
  [796] = {.lex_state = 0, .external_lex_state = 9},
  [797] = {.lex_state = 0, .external_lex_state = 9},
  [798] = {.lex_state = 0, .external_lex_state = 9},
  [799] = {.lex_state = 0, .external_lex_state = 9},
  [800] = {.lex_state = 0, .external_lex_state = 9},
  [801] = {.lex_state = 0, .external_lex_state = 9},
  [802] = {.lex_state = 0, .external_lex_state = 9},
  [803] = {.lex_state = 0, .external_lex_state = 16},
  [804] = {.lex_state = 0, .external_lex_state = 9},
  [805] = {.lex_state = 0, .external_lex_state = 16},
  [806] = {.lex_state = 0, .external_lex_state = 9},
  [807] = {.lex_state = 0, .external_lex_state = 16},
  [808] = {.lex_state = 0, .external_lex_state = 9},
  [809] = {.lex_state = 0, .external_lex_state = 16},
  [810] = {.lex_state = 0, .external_lex_state = 9},
  [811] = {.lex_state = 0, .external_lex_state = 9},
  [812] = {.lex_state = 0, .external_lex_state = 7},
  [813] = {.lex_state = 0, .external_lex_state = 7},
  [814] = {.lex_state = 0, .external_lex_state = 9},
  [815] = {.lex_state = 0, .external_lex_state = 7},
  [816] = {.lex_state = 0, .external_lex_state = 9},
  [817] = {.lex_state = 0, .external_lex_state = 9},
  [818] = {.lex_state = 0, .external_lex_state = 11},
  [819] = {.lex_state = 0, .external_lex_state = 11},
  [820] = {.lex_state = 0, .external_lex_state = 11},
  [821] = {.lex_state = 0, .external_lex_state = 11},
  [822] = {.lex_state = 0, .external_lex_state = 7},
  [823] = {.lex_state = 0, .external_lex_state = 7},
  [824] = {.lex_state = 0, .external_lex_state = 7},
  [825] = {.lex_state = 0, .external_lex_state = 9},
  [826] = {.lex_state = 0, .external_lex_state = 9},
  [827] = {.lex_state = 0, .external_lex_state = 7},
  [828] = {.lex_state = 0, .external_lex_state = 9},
  [829] = {.lex_state = 0, .external_lex_state = 9},
  [830] = {.lex_state = 0, .external_lex_state = 9},
  [831] = {.lex_state = 0, .external_lex_state = 7},
  [832] = {.lex_state = 0, .external_lex_state = 9},
  [833] = {.lex_state = 0, .external_lex_state = 7},
  [834] = {.lex_state = 0, .external_lex_state = 7},
  [835] = {.lex_state = 0, .external_lex_state = 9},
  [836] = {.lex_state = 0, .external_lex_state = 9},
  [837] = {.lex_state = 0, .external_lex_state = 9},
  [838] = {.lex_state = 0, .external_lex_state = 9},
  [839] = {.lex_state = 0, .external_lex_state = 7},
  [840] = {.lex_state = 0, .external_lex_state = 9},
  [841] = {.lex_state = 0, .external_lex_state = 9},
  [842] = {.lex_state = 0, .external_lex_state = 9},
  [843] = {.lex_state = 0, .external_lex_state = 9},
  [844] = {.lex_state = 0, .external_lex_state = 9},
  [845] = {.lex_state = 0, .external_lex_state = 7},
  [846] = {.lex_state = 0, .external_lex_state = 7},
  [847] = {.lex_state = 0, .external_lex_state = 7},
  [848] = {.lex_state = 0, .external_lex_state = 7},
  [849] = {.lex_state = 0, .external_lex_state = 7},
  [850] = {.lex_state = 0, .external_lex_state = 7},
  [851] = {.lex_state = 0, .external_lex_state = 7},
  [852] = {.lex_state = 0, .external_lex_state = 7},
  [853] = {.lex_state = 0, .external_lex_state = 7},
  [854] = {.lex_state = 0, .external_lex_state = 7},
  [855] = {.lex_state = 0, .external_lex_state = 7},
  [856] = {.lex_state = 0, .external_lex_state = 14},
  [857] = {.lex_state = 0, .external_lex_state = 7},
  [858] = {.lex_state = 0, .external_lex_state = 7},
  [859] = {.lex_state = 0, .external_lex_state = 14},
  [860] = {.lex_state = 0, .external_lex_state = 14},
  [861] = {.lex_state = 0, .external_lex_state = 9},
  [862] = {.lex_state = 0, .external_lex_state = 9},
  [863] = {.lex_state = 0, .external_lex_state = 7},
  [864] = {.lex_state = 0, .external_lex_state = 14},
  [865] = {.lex_state = 0, .external_lex_state = 9},
  [866] = {.lex_state = 0, .external_lex_state = 9},
  [867] = {.lex_state = 0, .external_lex_state = 9},
  [868] = {.lex_state = 0, .external_lex_state = 9},
  [869] = {.lex_state = 0, .external_lex_state = 9},
  [870] = {.lex_state = 0, .external_lex_state = 13},
  [871] = {.lex_state = 0, .external_lex_state = 13},
  [872] = {.lex_state = 0, .external_lex_state = 13},
  [873] = {.lex_state = 0, .external_lex_state = 13},
  [874] = {.lex_state = 0, .external_lex_state = 9},
  [875] = {.lex_state = 0, .external_lex_state = 9},
  [876] = {.lex_state = 0, .external_lex_state = 9},
  [877] = {.lex_state = 0, .external_lex_state = 9},
  [878] = {.lex_state = 0, .external_lex_state = 9},
  [879] = {.lex_state = 0, .external_lex_state = 7},
  [880] = {.lex_state = 0, .external_lex_state = 7},
  [881] = {.lex_state = 0, .external_lex_state = 9},
  [882] = {.lex_state = 0, .external_lex_state = 7},
  [883] = {.lex_state = 0, .external_lex_state = 9},
  [884] = {.lex_state = 0, .external_lex_state = 7},
  [885] = {.lex_state = 0, .external_lex_state = 7},
  [886] = {.lex_state = 0, .external_lex_state = 9},
  [887] = {.lex_state = 0, .external_lex_state = 7},
  [888] = {.lex_state = 0, .external_lex_state = 9},
  [889] = {.lex_state = 0, .external_lex_state = 7},
  [890] = {.lex_state = 0, .external_lex_state = 9},
  [891] = {.lex_state = 0, .external_lex_state = 7},
  [892] = {.lex_state = 0, .external_lex_state = 9},
  [893] = {.lex_state = 0, .external_lex_state = 7},
  [894] = {.lex_state = 0, .external_lex_state = 9},
  [895] = {.lex_state = 0, .external_lex_state = 7},
  [896] = {.lex_state = 0, .external_lex_state = 9},
  [897] = {.lex_state = 0, .external_lex_state = 7},
  [898] = {.lex_state = 0, .external_lex_state = 9},
  [899] = {.lex_state = 0, .external_lex_state = 7},
  [900] = {.lex_state = 0, .external_lex_state = 7},
  [901] = {.lex_state = 0, .external_lex_state = 7},
  [902] = {.lex_state = 0, .external_lex_state = 7},
  [903] = {.lex_state = 0, .external_lex_state = 5},
  [904] = {.lex_state = 0, .external_lex_state = 7},
  [905] = {.lex_state = 0, .external_lex_state = 7},
  [906] = {.lex_state = 0, .external_lex_state = 7},
  [907] = {.lex_state = 0, .external_lex_state = 7},
  [908] = {.lex_state = 0, .external_lex_state = 7},
  [909] = {.lex_state = 0, .external_lex_state = 7},
  [910] = {.lex_state = 0, .external_lex_state = 7},
  [911] = {.lex_state = 0, .external_lex_state = 7},
  [912] = {.lex_state = 0, .external_lex_state = 7},
  [913] = {.lex_state = 0, .external_lex_state = 8},
  [914] = {.lex_state = 0, .external_lex_state = 8},
  [915] = {.lex_state = 0, .external_lex_state = 8},
  [916] = {.lex_state = 0, .external_lex_state = 8},
  [917] = {.lex_state = 0, .external_lex_state = 6},
  [918] = {.lex_state = 0, .external_lex_state = 8},
  [919] = {.lex_state = 0, .external_lex_state = 8},
  [920] = {.lex_state = 0, .external_lex_state = 5},
  [921] = {.lex_state = 0, .external_lex_state = 10},
  [922] = {.lex_state = 0, .external_lex_state = 8},
  [923] = {.lex_state = 0, .external_lex_state = 8},
  [924] = {.lex_state = 0, .external_lex_state = 8},
  [925] = {.lex_state = 0, .external_lex_state = 8},
  [926] = {.lex_state = 0, .external_lex_state = 8},
  [927] = {.lex_state = 0, .external_lex_state = 8},
  [928] = {.lex_state = 0, .external_lex_state = 8},
  [929] = {.lex_state = 0, .external_lex_state = 8},
  [930] = {.lex_state = 0, .external_lex_state = 8},
  [931] = {.lex_state = 0, .external_lex_state = 8},
  [932] = {.lex_state = 0, .external_lex_state = 8},
  [933] = {.lex_state = 0, .external_lex_state = 8},
  [934] = {.lex_state = 0, .external_lex_state = 8},
  [935] = {.lex_state = 0, .external_lex_state = 10},
  [936] = {.lex_state = 0, .external_lex_state = 8},
  [937] = {.lex_state = 0, .external_lex_state = 8},
  [938] = {.lex_state = 0, .external_lex_state = 8},
  [939] = {.lex_state = 0, .external_lex_state = 8},
  [940] = {.lex_state = 0, .external_lex_state = 8},
  [941] = {.lex_state = 0, .external_lex_state = 8},
  [942] = {.lex_state = 0, .external_lex_state = 8},
  [943] = {.lex_state = 0, .external_lex_state = 8},
  [944] = {.lex_state = 0, .external_lex_state = 8},
  [945] = {.lex_state = 0, .external_lex_state = 8},
  [946] = {.lex_state = 0, .external_lex_state = 8},
  [947] = {.lex_state = 0, .external_lex_state = 8},
  [948] = {.lex_state = 0, .external_lex_state = 8},
  [949] = {.lex_state = 0, .external_lex_state = 4},
  [950] = {.lex_state = 0, .external_lex_state = 4},
  [951] = {.lex_state = 0, .external_lex_state = 8},
  [952] = {.lex_state = 0, .external_lex_state = 8},
  [953] = {.lex_state = 0, .external_lex_state = 8},
  [954] = {.lex_state = 0, .external_lex_state = 8},
  [955] = {.lex_state = 0, .external_lex_state = 8},
  [956] = {.lex_state = 0, .external_lex_state = 8},
  [957] = {.lex_state = 0, .external_lex_state = 8},
  [958] = {.lex_state = 0, .external_lex_state = 8},
  [959] = {.lex_state = 0, .external_lex_state = 8},
  [960] = {.lex_state = 0, .external_lex_state = 8},
  [961] = {.lex_state = 0, .external_lex_state = 8},
  [962] = {.lex_state = 0, .external_lex_state = 8},
  [963] = {.lex_state = 0, .external_lex_state = 8},
  [964] = {.lex_state = 0, .external_lex_state = 8},
  [965] = {.lex_state = 0, .external_lex_state = 8},
  [966] = {.lex_state = 0, .external_lex_state = 8},
  [967] = {.lex_state = 0, .external_lex_state = 8},
  [968] = {.lex_state = 0, .external_lex_state = 3},
  [969] = {.lex_state = 0, .external_lex_state = 11},
  [970] = {.lex_state = 0, .external_lex_state = 12},
  [971] = {.lex_state = 0, .external_lex_state = 10},
  [972] = {.lex_state = 0, .external_lex_state = 6},
  [973] = {.lex_state = 0, .external_lex_state = 10},
  [974] = {.lex_state = 0, .external_lex_state = 6},
  [975] = {.lex_state = 0, .external_lex_state = 13},
  [976] = {.lex_state = 0, .external_lex_state = 13},
  [977] = {.lex_state = 0, .external_lex_state = 13},
  [978] = {.lex_state = 0, .external_lex_state = 13},
  [979] = {.lex_state = 0, .external_lex_state = 13},
  [980] = {.lex_state = 0, .external_lex_state = 13},
  [981] = {.lex_state = 0, .external_lex_state = 13},
  [982] = {.lex_state = 0, .external_lex_state = 13},
  [983] = {.lex_state = 0, .external_lex_state = 13},
  [984] = {.lex_state = 0, .external_lex_state = 13},
  [985] = {.lex_state = 0, .external_lex_state = 13},
  [986] = {.lex_state = 0, .external_lex_state = 13},
  [987] = {.lex_state = 0, .external_lex_state = 13},
  [988] = {.lex_state = 0, .external_lex_state = 13},
  [989] = {.lex_state = 0, .external_lex_state = 13},
  [990] = {.lex_state = 0, .external_lex_state = 13},
  [991] = {.lex_state = 0, .external_lex_state = 25},
  [992] = {.lex_state = 0, .external_lex_state = 13},
  [993] = {.lex_state = 0, .external_lex_state = 4},
  [994] = {.lex_state = 0, .external_lex_state = 22},
  [995] = {.lex_state = 0, .external_lex_state = 13},
  [996] = {.lex_state = 0, .external_lex_state = 13},
  [997] = {.lex_state = 0, .external_lex_state = 13},
  [998] = {.lex_state = 0, .external_lex_state = 13},
  [999] = {.lex_state = 0, .external_lex_state = 22},
  [1000] = {.lex_state = 0, .external_lex_state = 22},
  [1001] = {.lex_state = 0, .external_lex_state = 25},
  [1002] = {.lex_state = 0, .external_lex_state = 13},
  [1003] = {.lex_state = 0, .external_lex_state = 13},
  [1004] = {.lex_state = 0, .external_lex_state = 25},
  [1005] = {.lex_state = 0, .external_lex_state = 13},
  [1006] = {.lex_state = 0, .external_lex_state = 13},
  [1007] = {.lex_state = 0, .external_lex_state = 13},
  [1008] = {.lex_state = 0, .external_lex_state = 22},
  [1009] = {.lex_state = 0, .external_lex_state = 13},
  [1010] = {.lex_state = 0, .external_lex_state = 13},
  [1011] = {.lex_state = 0, .external_lex_state = 13},
  [1012] = {.lex_state = 0, .external_lex_state = 13},
  [1013] = {.lex_state = 0, .external_lex_state = 13},
  [1014] = {.lex_state = 0, .external_lex_state = 13},
  [1015] = {.lex_state = 0, .external_lex_state = 13},
  [1016] = {.lex_state = 0, .external_lex_state = 13},
  [1017] = {.lex_state = 0, .external_lex_state = 13},
  [1018] = {.lex_state = 0, .external_lex_state = 13},
  [1019] = {.lex_state = 0, .external_lex_state = 13},
  [1020] = {.lex_state = 0, .external_lex_state = 13},
  [1021] = {.lex_state = 0, .external_lex_state = 13},
  [1022] = {.lex_state = 0, .external_lex_state = 13},
  [1023] = {.lex_state = 0, .external_lex_state = 13},
  [1024] = {.lex_state = 0, .external_lex_state = 13},
  [1025] = {.lex_state = 0, .external_lex_state = 13},
  [1026] = {.lex_state = 0, .external_lex_state = 13},
  [1027] = {.lex_state = 0, .external_lex_state = 13},
  [1028] = {.lex_state = 0, .external_lex_state = 13},
  [1029] = {.lex_state = 0, .external_lex_state = 13},
  [1030] = {.lex_state = 0, .external_lex_state = 25},
  [1031] = {.lex_state = 0, .external_lex_state = 13},
  [1032] = {.lex_state = 0, .external_lex_state = 13},
  [1033] = {.lex_state = 0, .external_lex_state = 13},
  [1034] = {.lex_state = 0, .external_lex_state = 14},
  [1035] = {.lex_state = 0, .external_lex_state = 14},
  [1036] = {.lex_state = 0, .external_lex_state = 14},
  [1037] = {.lex_state = 0, .external_lex_state = 14},
  [1038] = {.lex_state = 0, .external_lex_state = 14},
  [1039] = {.lex_state = 0, .external_lex_state = 14},
  [1040] = {.lex_state = 0, .external_lex_state = 14},
  [1041] = {.lex_state = 0, .external_lex_state = 14},
  [1042] = {.lex_state = 0, .external_lex_state = 14},
  [1043] = {.lex_state = 0, .external_lex_state = 14},
  [1044] = {.lex_state = 0, .external_lex_state = 14},
  [1045] = {.lex_state = 0, .external_lex_state = 14},
  [1046] = {.lex_state = 0, .external_lex_state = 14},
  [1047] = {.lex_state = 0, .external_lex_state = 14},
  [1048] = {.lex_state = 0, .external_lex_state = 14},
  [1049] = {.lex_state = 0, .external_lex_state = 14},
  [1050] = {.lex_state = 0, .external_lex_state = 14},
  [1051] = {.lex_state = 0, .external_lex_state = 14},
  [1052] = {.lex_state = 0, .external_lex_state = 14},
  [1053] = {.lex_state = 0, .external_lex_state = 14},
  [1054] = {.lex_state = 0, .external_lex_state = 14},
  [1055] = {.lex_state = 0, .external_lex_state = 14},
  [1056] = {.lex_state = 0, .external_lex_state = 14},
  [1057] = {.lex_state = 0, .external_lex_state = 14},
  [1058] = {.lex_state = 0, .external_lex_state = 14},
  [1059] = {.lex_state = 0, .external_lex_state = 14},
  [1060] = {.lex_state = 0, .external_lex_state = 14},
  [1061] = {.lex_state = 0, .external_lex_state = 8},
  [1062] = {.lex_state = 0, .external_lex_state = 14},
  [1063] = {.lex_state = 0, .external_lex_state = 14},
  [1064] = {.lex_state = 0, .external_lex_state = 14},
  [1065] = {.lex_state = 0, .external_lex_state = 14},
  [1066] = {.lex_state = 0, .external_lex_state = 14},
  [1067] = {.lex_state = 0, .external_lex_state = 14},
  [1068] = {.lex_state = 0, .external_lex_state = 15},
  [1069] = {.lex_state = 0, .external_lex_state = 15},
  [1070] = {.lex_state = 0, .external_lex_state = 15},
  [1071] = {.lex_state = 0, .external_lex_state = 15},
  [1072] = {.lex_state = 0, .external_lex_state = 14},
  [1073] = {.lex_state = 0, .external_lex_state = 14},
  [1074] = {.lex_state = 0, .external_lex_state = 15},
  [1075] = {.lex_state = 0, .external_lex_state = 15},
  [1076] = {.lex_state = 0, .external_lex_state = 15},
  [1077] = {.lex_state = 0, .external_lex_state = 14},
  [1078] = {.lex_state = 0, .external_lex_state = 14},
  [1079] = {.lex_state = 0, .external_lex_state = 15},
  [1080] = {.lex_state = 0, .external_lex_state = 14},
  [1081] = {.lex_state = 0, .external_lex_state = 14},
  [1082] = {.lex_state = 0, .external_lex_state = 14},
  [1083] = {.lex_state = 0, .external_lex_state = 15},
  [1084] = {.lex_state = 0, .external_lex_state = 14},
  [1085] = {.lex_state = 0, .external_lex_state = 15},
  [1086] = {.lex_state = 0, .external_lex_state = 15},
  [1087] = {.lex_state = 0, .external_lex_state = 14},
  [1088] = {.lex_state = 0, .external_lex_state = 14},
  [1089] = {.lex_state = 0, .external_lex_state = 14},
  [1090] = {.lex_state = 0, .external_lex_state = 14},
  [1091] = {.lex_state = 0, .external_lex_state = 14},
  [1092] = {.lex_state = 0, .external_lex_state = 15},
  [1093] = {.lex_state = 0, .external_lex_state = 14},
  [1094] = {.lex_state = 0, .external_lex_state = 14},
  [1095] = {.lex_state = 0, .external_lex_state = 14},
  [1096] = {.lex_state = 0, .external_lex_state = 14},
  [1097] = {.lex_state = 0, .external_lex_state = 14},
  [1098] = {.lex_state = 0, .external_lex_state = 15},
  [1099] = {.lex_state = 0, .external_lex_state = 15},
  [1100] = {.lex_state = 0, .external_lex_state = 15},
  [1101] = {.lex_state = 0, .external_lex_state = 15},
  [1102] = {.lex_state = 0, .external_lex_state = 15},
  [1103] = {.lex_state = 0, .external_lex_state = 15},
  [1104] = {.lex_state = 0, .external_lex_state = 15},
  [1105] = {.lex_state = 0, .external_lex_state = 8},
  [1106] = {.lex_state = 0, .external_lex_state = 15},
  [1107] = {.lex_state = 0, .external_lex_state = 15},
  [1108] = {.lex_state = 0, .external_lex_state = 15},
  [1109] = {.lex_state = 0, .external_lex_state = 15},
  [1110] = {.lex_state = 0, .external_lex_state = 15},
  [1111] = {.lex_state = 0, .external_lex_state = 5},
  [1112] = {.lex_state = 0, .external_lex_state = 15},
  [1113] = {.lex_state = 0, .external_lex_state = 15},
  [1114] = {.lex_state = 0, .external_lex_state = 15},
  [1115] = {.lex_state = 0, .external_lex_state = 15},
  [1116] = {.lex_state = 0, .external_lex_state = 15},
  [1117] = {.lex_state = 0, .external_lex_state = 15},
  [1118] = {.lex_state = 0, .external_lex_state = 15},
  [1119] = {.lex_state = 0, .external_lex_state = 15},
  [1120] = {.lex_state = 0, .external_lex_state = 15},
  [1121] = {.lex_state = 0, .external_lex_state = 15},
  [1122] = {.lex_state = 0, .external_lex_state = 15},
  [1123] = {.lex_state = 0, .external_lex_state = 15},
  [1124] = {.lex_state = 0, .external_lex_state = 15},
  [1125] = {.lex_state = 0, .external_lex_state = 15},
  [1126] = {.lex_state = 0, .external_lex_state = 15},
  [1127] = {.lex_state = 0, .external_lex_state = 15},
  [1128] = {.lex_state = 0, .external_lex_state = 15},
  [1129] = {.lex_state = 0, .external_lex_state = 15},
  [1130] = {.lex_state = 0, .external_lex_state = 15},
  [1131] = {.lex_state = 0, .external_lex_state = 15},
  [1132] = {.lex_state = 0, .external_lex_state = 15},
  [1133] = {.lex_state = 0, .external_lex_state = 16},
  [1134] = {.lex_state = 0, .external_lex_state = 15},
  [1135] = {.lex_state = 0, .external_lex_state = 15},
  [1136] = {.lex_state = 0, .external_lex_state = 15},
  [1137] = {.lex_state = 0, .external_lex_state = 15},
  [1138] = {.lex_state = 0, .external_lex_state = 15},
  [1139] = {.lex_state = 0, .external_lex_state = 11},
  [1140] = {.lex_state = 0, .external_lex_state = 16},
  [1141] = {.lex_state = 0, .external_lex_state = 16},
  [1142] = {.lex_state = 0, .external_lex_state = 16},
  [1143] = {.lex_state = 0, .external_lex_state = 16},
  [1144] = {.lex_state = 0, .external_lex_state = 16},
  [1145] = {.lex_state = 0, .external_lex_state = 23},
  [1146] = {.lex_state = 0, .external_lex_state = 12},
  [1147] = {.lex_state = 0, .external_lex_state = 16},
  [1148] = {.lex_state = 0, .external_lex_state = 16},
  [1149] = {.lex_state = 0, .external_lex_state = 16},
  [1150] = {.lex_state = 0, .external_lex_state = 23},
  [1151] = {.lex_state = 0, .external_lex_state = 23},
  [1152] = {.lex_state = 0, .external_lex_state = 15},
  [1153] = {.lex_state = 0, .external_lex_state = 12},
  [1154] = {.lex_state = 0, .external_lex_state = 12},
  [1155] = {.lex_state = 0, .external_lex_state = 16},
  [1156] = {.lex_state = 0, .external_lex_state = 12},
  [1157] = {.lex_state = 0, .external_lex_state = 16},
  [1158] = {.lex_state = 0, .external_lex_state = 16},
  [1159] = {.lex_state = 0, .external_lex_state = 23},
  [1160] = {.lex_state = 0, .external_lex_state = 12},
  [1161] = {.lex_state = 0, .external_lex_state = 16},
  [1162] = {.lex_state = 0, .external_lex_state = 12},
  [1163] = {.lex_state = 0, .external_lex_state = 12},
  [1164] = {.lex_state = 0, .external_lex_state = 12},
  [1165] = {.lex_state = 0, .external_lex_state = 12},
  [1166] = {.lex_state = 0, .external_lex_state = 16},
  [1167] = {.lex_state = 0, .external_lex_state = 12},
  [1168] = {.lex_state = 0, .external_lex_state = 12},
  [1169] = {.lex_state = 0, .external_lex_state = 16},
  [1170] = {.lex_state = 0, .external_lex_state = 12},
  [1171] = {.lex_state = 0, .external_lex_state = 12},
  [1172] = {.lex_state = 0, .external_lex_state = 12},
  [1173] = {.lex_state = 0, .external_lex_state = 16},
  [1174] = {.lex_state = 0, .external_lex_state = 16},
  [1175] = {.lex_state = 0, .external_lex_state = 16},
  [1176] = {.lex_state = 0, .external_lex_state = 16},
  [1177] = {.lex_state = 0, .external_lex_state = 16},
  [1178] = {.lex_state = 0, .external_lex_state = 16},
  [1179] = {.lex_state = 0, .external_lex_state = 16},
  [1180] = {.lex_state = 0, .external_lex_state = 12},
  [1181] = {.lex_state = 0, .external_lex_state = 12},
  [1182] = {.lex_state = 0, .external_lex_state = 12},
  [1183] = {.lex_state = 0, .external_lex_state = 16},
  [1184] = {.lex_state = 0, .external_lex_state = 16},
  [1185] = {.lex_state = 0, .external_lex_state = 16},
  [1186] = {.lex_state = 0, .external_lex_state = 12},
  [1187] = {.lex_state = 0, .external_lex_state = 16},
  [1188] = {.lex_state = 0, .external_lex_state = 12},
  [1189] = {.lex_state = 0, .external_lex_state = 16},
  [1190] = {.lex_state = 0, .external_lex_state = 12},
  [1191] = {.lex_state = 0, .external_lex_state = 12},
  [1192] = {.lex_state = 0, .external_lex_state = 12},
  [1193] = {.lex_state = 0, .external_lex_state = 12},
  [1194] = {.lex_state = 0, .external_lex_state = 12},
  [1195] = {.lex_state = 0, .external_lex_state = 12},
  [1196] = {.lex_state = 0, .external_lex_state = 12},
  [1197] = {.lex_state = 0, .external_lex_state = 12},
  [1198] = {.lex_state = 0, .external_lex_state = 16},
  [1199] = {.lex_state = 0, .external_lex_state = 16},
  [1200] = {.lex_state = 0, .external_lex_state = 16},
  [1201] = {.lex_state = 0, .external_lex_state = 16},
  [1202] = {.lex_state = 0, .external_lex_state = 16},
  [1203] = {.lex_state = 0, .external_lex_state = 16},
  [1204] = {.lex_state = 0, .external_lex_state = 16},
  [1205] = {.lex_state = 0, .external_lex_state = 16},
  [1206] = {.lex_state = 0, .external_lex_state = 16},
  [1207] = {.lex_state = 0, .external_lex_state = 16},
  [1208] = {.lex_state = 0, .external_lex_state = 16},
  [1209] = {.lex_state = 0, .external_lex_state = 16},
  [1210] = {.lex_state = 0, .external_lex_state = 16},
  [1211] = {.lex_state = 0, .external_lex_state = 16},
  [1212] = {.lex_state = 0, .external_lex_state = 16},
  [1213] = {.lex_state = 0, .external_lex_state = 7},
  [1214] = {.lex_state = 0, .external_lex_state = 16},
  [1215] = {.lex_state = 0, .external_lex_state = 16},
  [1216] = {.lex_state = 0, .external_lex_state = 16},
  [1217] = {.lex_state = 0, .external_lex_state = 12},
  [1218] = {.lex_state = 0, .external_lex_state = 16},
  [1219] = {.lex_state = 0, .external_lex_state = 13},
  [1220] = {.lex_state = 0, .external_lex_state = 12},
  [1221] = {.lex_state = 0, .external_lex_state = 12},
  [1222] = {.lex_state = 0, .external_lex_state = 12},
  [1223] = {.lex_state = 0, .external_lex_state = 16},
  [1224] = {.lex_state = 0, .external_lex_state = 16},
  [1225] = {.lex_state = 0, .external_lex_state = 16},
  [1226] = {.lex_state = 0, .external_lex_state = 12},
  [1227] = {.lex_state = 0, .external_lex_state = 16},
  [1228] = {.lex_state = 0, .external_lex_state = 12},
  [1229] = {.lex_state = 0, .external_lex_state = 16},
  [1230] = {.lex_state = 0, .external_lex_state = 12},
  [1231] = {.lex_state = 0, .external_lex_state = 12},
  [1232] = {.lex_state = 0, .external_lex_state = 12},
  [1233] = {.lex_state = 0, .external_lex_state = 12},
  [1234] = {.lex_state = 0, .external_lex_state = 12},
  [1235] = {.lex_state = 0, .external_lex_state = 12},
  [1236] = {.lex_state = 0, .external_lex_state = 12},
  [1237] = {.lex_state = 0, .external_lex_state = 12},
  [1238] = {.lex_state = 0, .external_lex_state = 12},
  [1239] = {.lex_state = 0, .external_lex_state = 12},
  [1240] = {.lex_state = 0, .external_lex_state = 12},
  [1241] = {.lex_state = 0, .external_lex_state = 12},
  [1242] = {.lex_state = 0, .external_lex_state = 12},
  [1243] = {.lex_state = 0, .external_lex_state = 12},
  [1244] = {.lex_state = 0, .external_lex_state = 12},
  [1245] = {.lex_state = 0, .external_lex_state = 12},
  [1246] = {.lex_state = 0, .external_lex_state = 12},
  [1247] = {.lex_state = 0, .external_lex_state = 11},
  [1248] = {.lex_state = 0, .external_lex_state = 11},
  [1249] = {.lex_state = 0, .external_lex_state = 11},
  [1250] = {.lex_state = 0, .external_lex_state = 11},
  [1251] = {.lex_state = 0, .external_lex_state = 11},
  [1252] = {.lex_state = 0, .external_lex_state = 11},
  [1253] = {.lex_state = 0, .external_lex_state = 11},
  [1254] = {.lex_state = 0, .external_lex_state = 11},
  [1255] = {.lex_state = 0, .external_lex_state = 11},
  [1256] = {.lex_state = 0, .external_lex_state = 11},
  [1257] = {.lex_state = 0, .external_lex_state = 11},
  [1258] = {.lex_state = 0, .external_lex_state = 11},
  [1259] = {.lex_state = 0, .external_lex_state = 11},
  [1260] = {.lex_state = 0, .external_lex_state = 11},
  [1261] = {.lex_state = 0, .external_lex_state = 11},
  [1262] = {.lex_state = 0, .external_lex_state = 11},
  [1263] = {.lex_state = 0, .external_lex_state = 11},
  [1264] = {.lex_state = 0, .external_lex_state = 7},
  [1265] = {.lex_state = 0, .external_lex_state = 25},
  [1266] = {.lex_state = 0, .external_lex_state = 25},
  [1267] = {.lex_state = 0, .external_lex_state = 11},
  [1268] = {.lex_state = 0, .external_lex_state = 25},
  [1269] = {.lex_state = 0, .external_lex_state = 11},
  [1270] = {.lex_state = 0, .external_lex_state = 25},
  [1271] = {.lex_state = 0, .external_lex_state = 11},
  [1272] = {.lex_state = 0, .external_lex_state = 11},
  [1273] = {.lex_state = 0, .external_lex_state = 11},
  [1274] = {.lex_state = 0, .external_lex_state = 11},
  [1275] = {.lex_state = 0, .external_lex_state = 11},
  [1276] = {.lex_state = 0, .external_lex_state = 11},
  [1277] = {.lex_state = 0, .external_lex_state = 11},
  [1278] = {.lex_state = 0, .external_lex_state = 11},
  [1279] = {.lex_state = 0, .external_lex_state = 11},
  [1280] = {.lex_state = 0, .external_lex_state = 17},
  [1281] = {.lex_state = 0, .external_lex_state = 11},
  [1282] = {.lex_state = 0, .external_lex_state = 11},
  [1283] = {.lex_state = 0, .external_lex_state = 17},
  [1284] = {.lex_state = 0, .external_lex_state = 11},
  [1285] = {.lex_state = 0, .external_lex_state = 11},
  [1286] = {.lex_state = 0, .external_lex_state = 17},
  [1287] = {.lex_state = 0, .external_lex_state = 17},
  [1288] = {.lex_state = 0, .external_lex_state = 17},
  [1289] = {.lex_state = 0, .external_lex_state = 17},
  [1290] = {.lex_state = 0, .external_lex_state = 17},
  [1291] = {.lex_state = 0, .external_lex_state = 22},
  [1292] = {.lex_state = 0, .external_lex_state = 11},
  [1293] = {.lex_state = 0, .external_lex_state = 17},
  [1294] = {.lex_state = 0, .external_lex_state = 22},
  [1295] = {.lex_state = 0, .external_lex_state = 22},
  [1296] = {.lex_state = 0, .external_lex_state = 11},
  [1297] = {.lex_state = 0, .external_lex_state = 22},
  [1298] = {.lex_state = 0, .external_lex_state = 11},
  [1299] = {.lex_state = 0, .external_lex_state = 9},
  [1300] = {.lex_state = 0, .external_lex_state = 23},
  [1301] = {.lex_state = 0, .external_lex_state = 23},
  [1302] = {.lex_state = 0, .external_lex_state = 11},
  [1303] = {.lex_state = 0, .external_lex_state = 11},
  [1304] = {.lex_state = 0, .external_lex_state = 11},
  [1305] = {.lex_state = 0, .external_lex_state = 11},
  [1306] = {.lex_state = 0, .external_lex_state = 11},
  [1307] = {.lex_state = 0, .external_lex_state = 11},
  [1308] = {.lex_state = 0, .external_lex_state = 11},
  [1309] = {.lex_state = 0, .external_lex_state = 11},
  [1310] = {.lex_state = 0, .external_lex_state = 11},
  [1311] = {.lex_state = 0, .external_lex_state = 11},
  [1312] = {.lex_state = 0, .external_lex_state = 11},
  [1313] = {.lex_state = 0, .external_lex_state = 11},
  [1314] = {.lex_state = 0, .external_lex_state = 11},
  [1315] = {.lex_state = 0, .external_lex_state = 23},
  [1316] = {.lex_state = 0, .external_lex_state = 23},
  [1317] = {.lex_state = 0, .external_lex_state = 9},
  [1318] = {.lex_state = 0, .external_lex_state = 11},
  [1319] = {.lex_state = 0, .external_lex_state = 20},
  [1320] = {.lex_state = 0, .external_lex_state = 18},
  [1321] = {.lex_state = 0, .external_lex_state = 29},
  [1322] = {.lex_state = 0, .external_lex_state = 29},
  [1323] = {.lex_state = 0, .external_lex_state = 30},
  [1324] = {.lex_state = 0, .external_lex_state = 30},
  [1325] = {.lex_state = 0, .external_lex_state = 31},
  [1326] = {.lex_state = 0, .external_lex_state = 29},
  [1327] = {.lex_state = 0, .external_lex_state = 30},
  [1328] = {.lex_state = 0, .external_lex_state = 29},
  [1329] = {.lex_state = 0, .external_lex_state = 31},
  [1330] = {.lex_state = 0, .external_lex_state = 30},
  [1331] = {.lex_state = 0, .external_lex_state = 29},
  [1332] = {.lex_state = 0, .external_lex_state = 31},
  [1333] = {.lex_state = 0, .external_lex_state = 31},
  [1334] = {.lex_state = 0, .external_lex_state = 30},
  [1335] = {.lex_state = 0, .external_lex_state = 29},
  [1336] = {.lex_state = 0, .external_lex_state = 9},
  [1337] = {.lex_state = 0, .external_lex_state = 20},
  [1338] = {.lex_state = 0, .external_lex_state = 10},
  [1339] = {.lex_state = 0, .external_lex_state = 31},
  [1340] = {.lex_state = 0, .external_lex_state = 31},
  [1341] = {.lex_state = 0, .external_lex_state = 19},
  [1342] = {.lex_state = 0, .external_lex_state = 31},
  [1343] = {.lex_state = 0, .external_lex_state = 19},
  [1344] = {.lex_state = 0, .external_lex_state = 31},
  [1345] = {.lex_state = 0, .external_lex_state = 19},
  [1346] = {.lex_state = 0, .external_lex_state = 30},
  [1347] = {.lex_state = 0, .external_lex_state = 19},
  [1348] = {.lex_state = 0, .external_lex_state = 29},
  [1349] = {.lex_state = 0, .external_lex_state = 19},
  [1350] = {.lex_state = 0, .external_lex_state = 31},
  [1351] = {.lex_state = 0, .external_lex_state = 31},
  [1352] = {.lex_state = 0, .external_lex_state = 30},
  [1353] = {.lex_state = 0, .external_lex_state = 29},
  [1354] = {.lex_state = 0, .external_lex_state = 21},
  [1355] = {.lex_state = 0, .external_lex_state = 20},
  [1356] = {.lex_state = 0, .external_lex_state = 20},
  [1357] = {.lex_state = 0, .external_lex_state = 31},
  [1358] = {.lex_state = 0, .external_lex_state = 20},
  [1359] = {.lex_state = 0, .external_lex_state = 31},
  [1360] = {.lex_state = 0, .external_lex_state = 30},
  [1361] = {.lex_state = 0, .external_lex_state = 29},
  [1362] = {.lex_state = 0, .external_lex_state = 31},
  [1363] = {.lex_state = 0, .external_lex_state = 31},
  [1364] = {.lex_state = 0, .external_lex_state = 30},
  [1365] = {.lex_state = 0, .external_lex_state = 29},
  [1366] = {.lex_state = 0, .external_lex_state = 31},
  [1367] = {.lex_state = 0, .external_lex_state = 29},
  [1368] = {.lex_state = 0, .external_lex_state = 31},
  [1369] = {.lex_state = 0, .external_lex_state = 30},
  [1370] = {.lex_state = 0, .external_lex_state = 30},
  [1371] = {.lex_state = 0, .external_lex_state = 29},
  [1372] = {.lex_state = 0, .external_lex_state = 31},
  [1373] = {.lex_state = 0, .external_lex_state = 31},
  [1374] = {.lex_state = 0, .external_lex_state = 29},
  [1375] = {.lex_state = 0, .external_lex_state = 31},
  [1376] = {.lex_state = 0, .external_lex_state = 20},
  [1377] = {.lex_state = 0, .external_lex_state = 19},
  [1378] = {.lex_state = 0, .external_lex_state = 30},
  [1379] = {.lex_state = 0, .external_lex_state = 29},
  [1380] = {.lex_state = 0, .external_lex_state = 31},
  [1381] = {.lex_state = 0, .external_lex_state = 19},
  [1382] = {.lex_state = 0, .external_lex_state = 19},
  [1383] = {.lex_state = 0, .external_lex_state = 19},
  [1384] = {.lex_state = 0, .external_lex_state = 19},
  [1385] = {.lex_state = 0, .external_lex_state = 19},
  [1386] = {.lex_state = 0, .external_lex_state = 30},
  [1387] = {.lex_state = 0, .external_lex_state = 29},
  [1388] = {.lex_state = 0, .external_lex_state = 19},
  [1389] = {.lex_state = 0, .external_lex_state = 11},
  [1390] = {.lex_state = 0, .external_lex_state = 19},
  [1391] = {.lex_state = 0, .external_lex_state = 20},
  [1392] = {.lex_state = 0, .external_lex_state = 19},
  [1393] = {.lex_state = 0, .external_lex_state = 31},
  [1394] = {.lex_state = 0, .external_lex_state = 19},
  [1395] = {.lex_state = 0, .external_lex_state = 30},
  [1396] = {.lex_state = 0, .external_lex_state = 19},
  [1397] = {.lex_state = 0, .external_lex_state = 29},
  [1398] = {.lex_state = 0, .external_lex_state = 19},
  [1399] = {.lex_state = 0, .external_lex_state = 31},
  [1400] = {.lex_state = 0, .external_lex_state = 19},
  [1401] = {.lex_state = 0, .external_lex_state = 31},
  [1402] = {.lex_state = 0, .external_lex_state = 19},
  [1403] = {.lex_state = 0, .external_lex_state = 30},
  [1404] = {.lex_state = 0, .external_lex_state = 19},
  [1405] = {.lex_state = 0, .external_lex_state = 29},
  [1406] = {.lex_state = 0, .external_lex_state = 19},
  [1407] = {.lex_state = 0, .external_lex_state = 30},
  [1408] = {.lex_state = 0, .external_lex_state = 19},
  [1409] = {.lex_state = 0, .external_lex_state = 29},
  [1410] = {.lex_state = 0, .external_lex_state = 19},
  [1411] = {.lex_state = 0, .external_lex_state = 31},
  [1412] = {.lex_state = 0, .external_lex_state = 19},
  [1413] = {.lex_state = 0, .external_lex_state = 21},
  [1414] = {.lex_state = 0, .external_lex_state = 31},
  [1415] = {.lex_state = 0, .external_lex_state = 30},
  [1416] = {.lex_state = 0, .external_lex_state = 29},
  [1417] = {.lex_state = 0, .external_lex_state = 30},
  [1418] = {.lex_state = 0, .external_lex_state = 29},
  [1419] = {.lex_state = 0, .external_lex_state = 29},
  [1420] = {.lex_state = 0, .external_lex_state = 30},
  [1421] = {.lex_state = 0, .external_lex_state = 29},
  [1422] = {.lex_state = 0, .external_lex_state = 21},
  [1423] = {.lex_state = 0, .external_lex_state = 31},
  [1424] = {.lex_state = 0, .external_lex_state = 31},
  [1425] = {.lex_state = 0, .external_lex_state = 30},
  [1426] = {.lex_state = 0, .external_lex_state = 19},
  [1427] = {.lex_state = 0, .external_lex_state = 11},
  [1428] = {.lex_state = 0, .external_lex_state = 30},
  [1429] = {.lex_state = 0, .external_lex_state = 19},
  [1430] = {.lex_state = 0, .external_lex_state = 19},
  [1431] = {.lex_state = 0, .external_lex_state = 19},
  [1432] = {.lex_state = 0, .external_lex_state = 19},
  [1433] = {.lex_state = 0, .external_lex_state = 19},
  [1434] = {.lex_state = 0, .external_lex_state = 19},
  [1435] = {.lex_state = 0, .external_lex_state = 19},
  [1436] = {.lex_state = 0, .external_lex_state = 19},
  [1437] = {.lex_state = 0, .external_lex_state = 19},
  [1438] = {.lex_state = 0, .external_lex_state = 19},
  [1439] = {.lex_state = 0, .external_lex_state = 19},
  [1440] = {.lex_state = 0, .external_lex_state = 19},
  [1441] = {.lex_state = 0, .external_lex_state = 19},
  [1442] = {.lex_state = 0, .external_lex_state = 29},
  [1443] = {.lex_state = 0, .external_lex_state = 31},
  [1444] = {.lex_state = 0, .external_lex_state = 31},
  [1445] = {.lex_state = 0, .external_lex_state = 20},
  [1446] = {.lex_state = 0, .external_lex_state = 23},
  [1447] = {.lex_state = 0, .external_lex_state = 30},
  [1448] = {.lex_state = 0, .external_lex_state = 19},
  [1449] = {.lex_state = 0, .external_lex_state = 23},
  [1450] = {.lex_state = 0, .external_lex_state = 29},
  [1451] = {.lex_state = 0, .external_lex_state = 23},
  [1452] = {.lex_state = 0, .external_lex_state = 30},
  [1453] = {.lex_state = 0, .external_lex_state = 29},
  [1454] = {.lex_state = 0, .external_lex_state = 23},
  [1455] = {.lex_state = 0, .external_lex_state = 19},
  [1456] = {.lex_state = 0, .external_lex_state = 19},
  [1457] = {.lex_state = 0, .external_lex_state = 23},
  [1458] = {.lex_state = 0, .external_lex_state = 19},
  [1459] = {.lex_state = 0, .external_lex_state = 23},
  [1460] = {.lex_state = 0, .external_lex_state = 23},
  [1461] = {.lex_state = 0, .external_lex_state = 31},
  [1462] = {.lex_state = 0, .external_lex_state = 19},
  [1463] = {.lex_state = 0, .external_lex_state = 30},
  [1464] = {.lex_state = 0, .external_lex_state = 20},
  [1465] = {.lex_state = 0, .external_lex_state = 19},
  [1466] = {.lex_state = 0, .external_lex_state = 19},
  [1467] = {.lex_state = 0, .external_lex_state = 19},
  [1468] = {.lex_state = 0, .external_lex_state = 23},
  [1469] = {.lex_state = 0, .external_lex_state = 19},
  [1470] = {.lex_state = 0, .external_lex_state = 19},
  [1471] = {.lex_state = 0, .external_lex_state = 20},
  [1472] = {.lex_state = 0, .external_lex_state = 19},
  [1473] = {.lex_state = 0, .external_lex_state = 19},
  [1474] = {.lex_state = 0, .external_lex_state = 23},
  [1475] = {.lex_state = 0, .external_lex_state = 20},
  [1476] = {.lex_state = 0, .external_lex_state = 23},
  [1477] = {.lex_state = 0, .external_lex_state = 23},
  [1478] = {.lex_state = 0, .external_lex_state = 31},
  [1479] = {.lex_state = 0, .external_lex_state = 23},
  [1480] = {.lex_state = 0, .external_lex_state = 23},
  [1481] = {.lex_state = 0, .external_lex_state = 23},
  [1482] = {.lex_state = 0, .external_lex_state = 23},
  [1483] = {.lex_state = 0, .external_lex_state = 23},
  [1484] = {.lex_state = 0, .external_lex_state = 23},
  [1485] = {.lex_state = 0, .external_lex_state = 20},
  [1486] = {.lex_state = 0, .external_lex_state = 23},
  [1487] = {.lex_state = 0, .external_lex_state = 20},
  [1488] = {.lex_state = 0, .external_lex_state = 31},
  [1489] = {.lex_state = 0, .external_lex_state = 20},
  [1490] = {.lex_state = 0, .external_lex_state = 30},
  [1491] = {.lex_state = 0, .external_lex_state = 23},
  [1492] = {.lex_state = 0, .external_lex_state = 31},
  [1493] = {.lex_state = 0, .external_lex_state = 23},
  [1494] = {.lex_state = 0, .external_lex_state = 29},
  [1495] = {.lex_state = 0, .external_lex_state = 23},
  [1496] = {.lex_state = 0, .external_lex_state = 31},
  [1497] = {.lex_state = 0, .external_lex_state = 23},
  [1498] = {.lex_state = 0, .external_lex_state = 23},
  [1499] = {.lex_state = 0, .external_lex_state = 23},
  [1500] = {.lex_state = 0, .external_lex_state = 23},
  [1501] = {.lex_state = 0, .external_lex_state = 21},
  [1502] = {.lex_state = 0, .external_lex_state = 23},
  [1503] = {.lex_state = 0, .external_lex_state = 30},
  [1504] = {.lex_state = 0, .external_lex_state = 29},
  [1505] = {.lex_state = 0, .external_lex_state = 31},
  [1506] = {.lex_state = 0, .external_lex_state = 23},
  [1507] = {.lex_state = 0, .external_lex_state = 23},
  [1508] = {.lex_state = 0, .external_lex_state = 23},
  [1509] = {.lex_state = 0, .external_lex_state = 23},
  [1510] = {.lex_state = 0, .external_lex_state = 23},
  [1511] = {.lex_state = 0, .external_lex_state = 23},
  [1512] = {.lex_state = 0, .external_lex_state = 23},
  [1513] = {.lex_state = 0, .external_lex_state = 23},
  [1514] = {.lex_state = 0, .external_lex_state = 23},
  [1515] = {.lex_state = 0, .external_lex_state = 12},
  [1516] = {.lex_state = 0, .external_lex_state = 23},
  [1517] = {.lex_state = 0, .external_lex_state = 23},
  [1518] = {.lex_state = 0, .external_lex_state = 23},
  [1519] = {.lex_state = 0, .external_lex_state = 30},
  [1520] = {.lex_state = 0, .external_lex_state = 23},
  [1521] = {.lex_state = 0, .external_lex_state = 17},
  [1522] = {.lex_state = 0, .external_lex_state = 23},
  [1523] = {.lex_state = 0, .external_lex_state = 23},
  [1524] = {.lex_state = 0, .external_lex_state = 23},
  [1525] = {.lex_state = 0, .external_lex_state = 29},
  [1526] = {.lex_state = 0, .external_lex_state = 23},
  [1527] = {.lex_state = 0, .external_lex_state = 20},
  [1528] = {.lex_state = 0, .external_lex_state = 31},
  [1529] = {.lex_state = 0, .external_lex_state = 29},
  [1530] = {.lex_state = 0, .external_lex_state = 23},
  [1531] = {.lex_state = 0, .external_lex_state = 23},
  [1532] = {.lex_state = 0, .external_lex_state = 31},
  [1533] = {.lex_state = 0, .external_lex_state = 30},
  [1534] = {.lex_state = 0, .external_lex_state = 29},
  [1535] = {.lex_state = 0, .external_lex_state = 21},
  [1536] = {.lex_state = 0, .external_lex_state = 30},
  [1537] = {.lex_state = 0, .external_lex_state = 31},
  [1538] = {.lex_state = 0, .external_lex_state = 31},
  [1539] = {.lex_state = 0, .external_lex_state = 30},
  [1540] = {.lex_state = 0, .external_lex_state = 23},
  [1541] = {.lex_state = 0, .external_lex_state = 29},
  [1542] = {.lex_state = 0, .external_lex_state = 23},
  [1543] = {.lex_state = 0, .external_lex_state = 29},
  [1544] = {.lex_state = 0, .external_lex_state = 23},
  [1545] = {.lex_state = 0, .external_lex_state = 31},
  [1546] = {.lex_state = 0, .external_lex_state = 23},
  [1547] = {.lex_state = 0, .external_lex_state = 31},
  [1548] = {.lex_state = 0, .external_lex_state = 23},
  [1549] = {.lex_state = 0, .external_lex_state = 30},
  [1550] = {.lex_state = 0, .external_lex_state = 21},
  [1551] = {.lex_state = 0, .external_lex_state = 29},
  [1552] = {.lex_state = 0, .external_lex_state = 22},
  [1553] = {.lex_state = 0, .external_lex_state = 21},
  [1554] = {.lex_state = 0, .external_lex_state = 22},
  [1555] = {.lex_state = 0, .external_lex_state = 31},
  [1556] = {.lex_state = 0, .external_lex_state = 21},
  [1557] = {.lex_state = 0, .external_lex_state = 16},
  [1558] = {.lex_state = 0, .external_lex_state = 22},
  [1559] = {.lex_state = 0, .external_lex_state = 31},
  [1560] = {.lex_state = 0, .external_lex_state = 22},
  [1561] = {.lex_state = 0, .external_lex_state = 21},
  [1562] = {.lex_state = 0, .external_lex_state = 22},
  [1563] = {.lex_state = 0, .external_lex_state = 7},
  [1564] = {.lex_state = 0, .external_lex_state = 22},
  [1565] = {.lex_state = 0, .external_lex_state = 22},
  [1566] = {.lex_state = 0, .external_lex_state = 12},
  [1567] = {.lex_state = 0, .external_lex_state = 21},
  [1568] = {.lex_state = 0, .external_lex_state = 21},
  [1569] = {.lex_state = 0, .external_lex_state = 29},
  [1570] = {.lex_state = 0, .external_lex_state = 22},
  [1571] = {.lex_state = 0, .external_lex_state = 30},
  [1572] = {.lex_state = 0, .external_lex_state = 22},
  [1573] = {.lex_state = 0, .external_lex_state = 22},
  [1574] = {.lex_state = 0, .external_lex_state = 22},
  [1575] = {.lex_state = 0, .external_lex_state = 21},
  [1576] = {.lex_state = 0, .external_lex_state = 22},
  [1577] = {.lex_state = 0, .external_lex_state = 30},
  [1578] = {.lex_state = 0, .external_lex_state = 22},
  [1579] = {.lex_state = 0, .external_lex_state = 20},
  [1580] = {.lex_state = 0, .external_lex_state = 20},
  [1581] = {.lex_state = 0, .external_lex_state = 16},
  [1582] = {.lex_state = 0, .external_lex_state = 29},
  [1583] = {.lex_state = 0, .external_lex_state = 29},
  [1584] = {.lex_state = 0, .external_lex_state = 31},
  [1585] = {.lex_state = 0, .external_lex_state = 30},
  [1586] = {.lex_state = 0, .external_lex_state = 6},
  [1587] = {.lex_state = 0, .external_lex_state = 31},
  [1588] = {.lex_state = 0, .external_lex_state = 30},
  [1589] = {.lex_state = 0, .external_lex_state = 29},
  [1590] = {.lex_state = 0, .external_lex_state = 31},
  [1591] = {.lex_state = 0, .external_lex_state = 31},
  [1592] = {.lex_state = 0, .external_lex_state = 30},
  [1593] = {.lex_state = 0, .external_lex_state = 22},
  [1594] = {.lex_state = 0, .external_lex_state = 22},
  [1595] = {.lex_state = 0, .external_lex_state = 22},
  [1596] = {.lex_state = 0, .external_lex_state = 22},
  [1597] = {.lex_state = 0, .external_lex_state = 22},
  [1598] = {.lex_state = 0, .external_lex_state = 29},
  [1599] = {.lex_state = 0, .external_lex_state = 18},
  [1600] = {.lex_state = 0, .external_lex_state = 20},
  [1601] = {.lex_state = 0, .external_lex_state = 22},
  [1602] = {.lex_state = 0, .external_lex_state = 22},
  [1603] = {.lex_state = 0, .external_lex_state = 31},
  [1604] = {.lex_state = 0, .external_lex_state = 30},
  [1605] = {.lex_state = 0, .external_lex_state = 22},
  [1606] = {.lex_state = 0, .external_lex_state = 31},
  [1607] = {.lex_state = 0, .external_lex_state = 30},
  [1608] = {.lex_state = 0, .external_lex_state = 22},
  [1609] = {.lex_state = 0, .external_lex_state = 13},
  [1610] = {.lex_state = 0, .external_lex_state = 22},
  [1611] = {.lex_state = 0, .external_lex_state = 22},
  [1612] = {.lex_state = 0, .external_lex_state = 20},
  [1613] = {.lex_state = 0, .external_lex_state = 30},
  [1614] = {.lex_state = 0, .external_lex_state = 22},
  [1615] = {.lex_state = 0, .external_lex_state = 29},
  [1616] = {.lex_state = 0, .external_lex_state = 31},
  [1617] = {.lex_state = 0, .external_lex_state = 20},
  [1618] = {.lex_state = 0, .external_lex_state = 19},
  [1619] = {.lex_state = 0, .external_lex_state = 22},
  [1620] = {.lex_state = 0, .external_lex_state = 31},
  [1621] = {.lex_state = 0, .external_lex_state = 20},
  [1622] = {.lex_state = 0, .external_lex_state = 30},
  [1623] = {.lex_state = 0, .external_lex_state = 25},
  [1624] = {.lex_state = 0, .external_lex_state = 25},
  [1625] = {.lex_state = 0, .external_lex_state = 29},
  [1626] = {.lex_state = 0, .external_lex_state = 20},
  [1627] = {.lex_state = 0, .external_lex_state = 22},
  [1628] = {.lex_state = 0, .external_lex_state = 22},
  [1629] = {.lex_state = 0, .external_lex_state = 22},
  [1630] = {.lex_state = 0, .external_lex_state = 22},
  [1631] = {.lex_state = 0, .external_lex_state = 22},
  [1632] = {.lex_state = 0, .external_lex_state = 22},
  [1633] = {.lex_state = 0, .external_lex_state = 22},
  [1634] = {.lex_state = 0, .external_lex_state = 22},
  [1635] = {.lex_state = 0, .external_lex_state = 22},
  [1636] = {.lex_state = 0, .external_lex_state = 20},
  [1637] = {.lex_state = 0, .external_lex_state = 25},
  [1638] = {.lex_state = 0, .external_lex_state = 22},
  [1639] = {.lex_state = 0, .external_lex_state = 18},
  [1640] = {.lex_state = 0, .external_lex_state = 22},
  [1641] = {.lex_state = 0, .external_lex_state = 18},
  [1642] = {.lex_state = 0, .external_lex_state = 22},
  [1643] = {.lex_state = 0, .external_lex_state = 18},
  [1644] = {.lex_state = 0, .external_lex_state = 22},
  [1645] = {.lex_state = 0, .external_lex_state = 18},
  [1646] = {.lex_state = 0, .external_lex_state = 22},
  [1647] = {.lex_state = 0, .external_lex_state = 18},
  [1648] = {.lex_state = 0, .external_lex_state = 22},
  [1649] = {.lex_state = 0, .external_lex_state = 22},
  [1650] = {.lex_state = 0, .external_lex_state = 22},
  [1651] = {.lex_state = 0, .external_lex_state = 22},
  [1652] = {.lex_state = 0, .external_lex_state = 25},
  [1653] = {.lex_state = 0, .external_lex_state = 21},
  [1654] = {.lex_state = 0, .external_lex_state = 22},
  [1655] = {.lex_state = 0, .external_lex_state = 25},
  [1656] = {.lex_state = 0, .external_lex_state = 25},
  [1657] = {.lex_state = 0, .external_lex_state = 22},
  [1658] = {.lex_state = 0, .external_lex_state = 22},
  [1659] = {.lex_state = 0, .external_lex_state = 22},
  [1660] = {.lex_state = 0, .external_lex_state = 22},
  [1661] = {.lex_state = 0, .external_lex_state = 21},
  [1662] = {.lex_state = 0, .external_lex_state = 22},
  [1663] = {.lex_state = 0, .external_lex_state = 21},
  [1664] = {.lex_state = 0, .external_lex_state = 17},
  [1665] = {.lex_state = 0, .external_lex_state = 17},
  [1666] = {.lex_state = 0, .external_lex_state = 25},
  [1667] = {.lex_state = 0, .external_lex_state = 21},
  [1668] = {.lex_state = 0, .external_lex_state = 17},
  [1669] = {.lex_state = 0, .external_lex_state = 17},
  [1670] = {.lex_state = 0, .external_lex_state = 20},
  [1671] = {.lex_state = 0, .external_lex_state = 17},
  [1672] = {.lex_state = 0, .external_lex_state = 25},
  [1673] = {.lex_state = 0, .external_lex_state = 17},
  [1674] = {.lex_state = 0, .external_lex_state = 17},
  [1675] = {.lex_state = 0, .external_lex_state = 21},
  [1676] = {.lex_state = 0, .external_lex_state = 20},
  [1677] = {.lex_state = 0, .external_lex_state = 17},
  [1678] = {.lex_state = 0, .external_lex_state = 20},
  [1679] = {.lex_state = 0, .external_lex_state = 18},
  [1680] = {.lex_state = 0, .external_lex_state = 20},
  [1681] = {.lex_state = 0, .external_lex_state = 17},
  [1682] = {.lex_state = 0, .external_lex_state = 21},
  [1683] = {.lex_state = 0, .external_lex_state = 18},
  [1684] = {.lex_state = 0, .external_lex_state = 18},
  [1685] = {.lex_state = 0, .external_lex_state = 18},
  [1686] = {.lex_state = 0, .external_lex_state = 18},
  [1687] = {.lex_state = 0, .external_lex_state = 18},
  [1688] = {.lex_state = 0, .external_lex_state = 17},
  [1689] = {.lex_state = 0, .external_lex_state = 17},
  [1690] = {.lex_state = 0, .external_lex_state = 18},
  [1691] = {.lex_state = 0, .external_lex_state = 21},
  [1692] = {.lex_state = 0, .external_lex_state = 18},
  [1693] = {.lex_state = 0, .external_lex_state = 17},
  [1694] = {.lex_state = 0, .external_lex_state = 18},
  [1695] = {.lex_state = 0, .external_lex_state = 17},
  [1696] = {.lex_state = 0, .external_lex_state = 18},
  [1697] = {.lex_state = 0, .external_lex_state = 17},
  [1698] = {.lex_state = 0, .external_lex_state = 18},
  [1699] = {.lex_state = 0, .external_lex_state = 17},
  [1700] = {.lex_state = 0, .external_lex_state = 18},
  [1701] = {.lex_state = 0, .external_lex_state = 17},
  [1702] = {.lex_state = 0, .external_lex_state = 18},
  [1703] = {.lex_state = 0, .external_lex_state = 17},
  [1704] = {.lex_state = 0, .external_lex_state = 18},
  [1705] = {.lex_state = 0, .external_lex_state = 17},
  [1706] = {.lex_state = 0, .external_lex_state = 18},
  [1707] = {.lex_state = 0, .external_lex_state = 17},
  [1708] = {.lex_state = 0, .external_lex_state = 18},
  [1709] = {.lex_state = 0, .external_lex_state = 17},
  [1710] = {.lex_state = 0, .external_lex_state = 18},
  [1711] = {.lex_state = 0, .external_lex_state = 17},
  [1712] = {.lex_state = 0, .external_lex_state = 18},
  [1713] = {.lex_state = 0, .external_lex_state = 17},
  [1714] = {.lex_state = 0, .external_lex_state = 18},
  [1715] = {.lex_state = 0, .external_lex_state = 17},
  [1716] = {.lex_state = 0, .external_lex_state = 17},
  [1717] = {.lex_state = 0, .external_lex_state = 25},
  [1718] = {.lex_state = 0, .external_lex_state = 17},
  [1719] = {.lex_state = 0, .external_lex_state = 21},
  [1720] = {.lex_state = 0, .external_lex_state = 29},
  [1721] = {.lex_state = 0, .external_lex_state = 17},
  [1722] = {.lex_state = 0, .external_lex_state = 30},
  [1723] = {.lex_state = 0, .external_lex_state = 30},
  [1724] = {.lex_state = 0, .external_lex_state = 29},
  [1725] = {.lex_state = 0, .external_lex_state = 20},
  [1726] = {.lex_state = 0, .external_lex_state = 20},
  [1727] = {.lex_state = 0, .external_lex_state = 20},
  [1728] = {.lex_state = 0, .external_lex_state = 18},
  [1729] = {.lex_state = 0, .external_lex_state = 17},
  [1730] = {.lex_state = 0, .external_lex_state = 20},
  [1731] = {.lex_state = 0, .external_lex_state = 18},
  [1732] = {.lex_state = 0, .external_lex_state = 18},
  [1733] = {.lex_state = 0, .external_lex_state = 18},
  [1734] = {.lex_state = 0, .external_lex_state = 18},
  [1735] = {.lex_state = 0, .external_lex_state = 18},
  [1736] = {.lex_state = 0, .external_lex_state = 18},
  [1737] = {.lex_state = 0, .external_lex_state = 18},
  [1738] = {.lex_state = 0, .external_lex_state = 18},
  [1739] = {.lex_state = 0, .external_lex_state = 18},
  [1740] = {.lex_state = 0, .external_lex_state = 18},
  [1741] = {.lex_state = 0, .external_lex_state = 18},
  [1742] = {.lex_state = 0, .external_lex_state = 18},
  [1743] = {.lex_state = 0, .external_lex_state = 18},
  [1744] = {.lex_state = 0, .external_lex_state = 17},
  [1745] = {.lex_state = 0, .external_lex_state = 17},
  [1746] = {.lex_state = 0, .external_lex_state = 17},
  [1747] = {.lex_state = 0, .external_lex_state = 17},
  [1748] = {.lex_state = 0, .external_lex_state = 17},
  [1749] = {.lex_state = 0, .external_lex_state = 25},
  [1750] = {.lex_state = 0, .external_lex_state = 18},
  [1751] = {.lex_state = 0, .external_lex_state = 20},
  [1752] = {.lex_state = 0, .external_lex_state = 20},
  [1753] = {.lex_state = 0, .external_lex_state = 17},
  [1754] = {.lex_state = 0, .external_lex_state = 25},
  [1755] = {.lex_state = 0, .external_lex_state = 31},
  [1756] = {.lex_state = 0, .external_lex_state = 20},
  [1757] = {.lex_state = 0, .external_lex_state = 18},
  [1758] = {.lex_state = 0, .external_lex_state = 18},
  [1759] = {.lex_state = 0, .external_lex_state = 20},
  [1760] = {.lex_state = 0, .external_lex_state = 18},
  [1761] = {.lex_state = 0, .external_lex_state = 17},
  [1762] = {.lex_state = 0, .external_lex_state = 17},
  [1763] = {.lex_state = 0, .external_lex_state = 29},
  [1764] = {.lex_state = 0, .external_lex_state = 18},
  [1765] = {.lex_state = 0, .external_lex_state = 17},
  [1766] = {.lex_state = 0, .external_lex_state = 20},
  [1767] = {.lex_state = 0, .external_lex_state = 18},
  [1768] = {.lex_state = 0, .external_lex_state = 18},
  [1769] = {.lex_state = 0, .external_lex_state = 18},
  [1770] = {.lex_state = 0, .external_lex_state = 17},
  [1771] = {.lex_state = 0, .external_lex_state = 18},
  [1772] = {.lex_state = 0, .external_lex_state = 18},
  [1773] = {.lex_state = 0, .external_lex_state = 20},
  [1774] = {.lex_state = 0, .external_lex_state = 20},
  [1775] = {.lex_state = 0, .external_lex_state = 18},
  [1776] = {.lex_state = 0, .external_lex_state = 17},
  [1777] = {.lex_state = 0, .external_lex_state = 17},
  [1778] = {.lex_state = 0, .external_lex_state = 17},
  [1779] = {.lex_state = 0, .external_lex_state = 17},
  [1780] = {.lex_state = 0, .external_lex_state = 17},
  [1781] = {.lex_state = 0, .external_lex_state = 17},
  [1782] = {.lex_state = 0, .external_lex_state = 17},
  [1783] = {.lex_state = 0, .external_lex_state = 17},
  [1784] = {.lex_state = 0, .external_lex_state = 21},
  [1785] = {.lex_state = 0, .external_lex_state = 20},
  [1786] = {.lex_state = 0, .external_lex_state = 13},
  [1787] = {.lex_state = 0, .external_lex_state = 17},
  [1788] = {.lex_state = 0, .external_lex_state = 17},
  [1789] = {.lex_state = 0, .external_lex_state = 20},
  [1790] = {.lex_state = 0, .external_lex_state = 25},
  [1791] = {.lex_state = 0, .external_lex_state = 17},
  [1792] = {.lex_state = 0, .external_lex_state = 20},
  [1793] = {.lex_state = 0, .external_lex_state = 17},
  [1794] = {.lex_state = 0, .external_lex_state = 29},
  [1795] = {.lex_state = 0, .external_lex_state = 17},
  [1796] = {.lex_state = 0, .external_lex_state = 30},
  [1797] = {.lex_state = 0, .external_lex_state = 21},
  [1798] = {.lex_state = 0, .external_lex_state = 25},
  [1799] = {.lex_state = 0, .external_lex_state = 21},
  [1800] = {.lex_state = 0, .external_lex_state = 21},
  [1801] = {.lex_state = 0, .external_lex_state = 21},
  [1802] = {.lex_state = 0, .external_lex_state = 25},
  [1803] = {.lex_state = 0, .external_lex_state = 25},
  [1804] = {.lex_state = 0, .external_lex_state = 31},
  [1805] = {.lex_state = 0, .external_lex_state = 29},
  [1806] = {.lex_state = 0, .external_lex_state = 30},
  [1807] = {.lex_state = 0, .external_lex_state = 21},
  [1808] = {.lex_state = 0, .external_lex_state = 21},
  [1809] = {.lex_state = 0, .external_lex_state = 21},
  [1810] = {.lex_state = 0, .external_lex_state = 21},
  [1811] = {.lex_state = 0, .external_lex_state = 21},
  [1812] = {.lex_state = 0, .external_lex_state = 30},
  [1813] = {.lex_state = 0, .external_lex_state = 29},
  [1814] = {.lex_state = 0, .external_lex_state = 25},
  [1815] = {.lex_state = 0, .external_lex_state = 21},
  [1816] = {.lex_state = 0, .external_lex_state = 21},
  [1817] = {.lex_state = 0, .external_lex_state = 15},
  [1818] = {.lex_state = 0, .external_lex_state = 21},
  [1819] = {.lex_state = 0, .external_lex_state = 21},
  [1820] = {.lex_state = 0, .external_lex_state = 21},
  [1821] = {.lex_state = 0, .external_lex_state = 25},
  [1822] = {.lex_state = 0, .external_lex_state = 21},
  [1823] = {.lex_state = 0, .external_lex_state = 25},
  [1824] = {.lex_state = 0, .external_lex_state = 21},
  [1825] = {.lex_state = 0, .external_lex_state = 21},
  [1826] = {.lex_state = 0, .external_lex_state = 21},
  [1827] = {.lex_state = 0, .external_lex_state = 25},
  [1828] = {.lex_state = 0, .external_lex_state = 25},
  [1829] = {.lex_state = 0, .external_lex_state = 30},
  [1830] = {.lex_state = 0, .external_lex_state = 25},
  [1831] = {.lex_state = 0, .external_lex_state = 25},
  [1832] = {.lex_state = 0, .external_lex_state = 25},
  [1833] = {.lex_state = 0, .external_lex_state = 21},
  [1834] = {.lex_state = 0, .external_lex_state = 25},
  [1835] = {.lex_state = 0, .external_lex_state = 25},
  [1836] = {.lex_state = 0, .external_lex_state = 25},
  [1837] = {.lex_state = 0, .external_lex_state = 20},
  [1838] = {.lex_state = 0, .external_lex_state = 30},
  [1839] = {.lex_state = 0, .external_lex_state = 29},
  [1840] = {.lex_state = 0, .external_lex_state = 25},
  [1841] = {.lex_state = 0, .external_lex_state = 25},
  [1842] = {.lex_state = 0, .external_lex_state = 25},
  [1843] = {.lex_state = 0, .external_lex_state = 25},
  [1844] = {.lex_state = 0, .external_lex_state = 25},
  [1845] = {.lex_state = 0, .external_lex_state = 25},
  [1846] = {.lex_state = 0, .external_lex_state = 31},
  [1847] = {.lex_state = 0, .external_lex_state = 25},
  [1848] = {.lex_state = 0, .external_lex_state = 20},
  [1849] = {.lex_state = 0, .external_lex_state = 25},
  [1850] = {.lex_state = 0, .external_lex_state = 21},
  [1851] = {.lex_state = 0, .external_lex_state = 25},
  [1852] = {.lex_state = 0, .external_lex_state = 21},
  [1853] = {.lex_state = 0, .external_lex_state = 25},
  [1854] = {.lex_state = 0, .external_lex_state = 21},
  [1855] = {.lex_state = 0, .external_lex_state = 25},
  [1856] = {.lex_state = 0, .external_lex_state = 25},
  [1857] = {.lex_state = 0, .external_lex_state = 25},
  [1858] = {.lex_state = 0, .external_lex_state = 25},
  [1859] = {.lex_state = 0, .external_lex_state = 30},
  [1860] = {.lex_state = 0, .external_lex_state = 25},
  [1861] = {.lex_state = 0, .external_lex_state = 25},
  [1862] = {.lex_state = 0, .external_lex_state = 25},
  [1863] = {.lex_state = 0, .external_lex_state = 29},
  [1864] = {.lex_state = 0, .external_lex_state = 25},
  [1865] = {.lex_state = 0, .external_lex_state = 20},
  [1866] = {.lex_state = 0, .external_lex_state = 30},
  [1867] = {.lex_state = 0, .external_lex_state = 21},
  [1868] = {.lex_state = 0, .external_lex_state = 15},
  [1869] = {.lex_state = 0, .external_lex_state = 21},
  [1870] = {.lex_state = 0, .external_lex_state = 21},
  [1871] = {.lex_state = 0, .external_lex_state = 29},
  [1872] = {.lex_state = 0, .external_lex_state = 21},
  [1873] = {.lex_state = 0, .external_lex_state = 30},
  [1874] = {.lex_state = 0, .external_lex_state = 21},
  [1875] = {.lex_state = 0, .external_lex_state = 30},
  [1876] = {.lex_state = 0, .external_lex_state = 29},
  [1877] = {.lex_state = 0, .external_lex_state = 29},
  [1878] = {.lex_state = 0, .external_lex_state = 21},
  [1879] = {.lex_state = 0, .external_lex_state = 20},
  [1880] = {.lex_state = 0, .external_lex_state = 21},
  [1881] = {.lex_state = 0, .external_lex_state = 31},
  [1882] = {.lex_state = 0, .external_lex_state = 25},
  [1883] = {.lex_state = 0, .external_lex_state = 20},
  [1884] = {.lex_state = 0, .external_lex_state = 20},
  [1885] = {.lex_state = 0, .external_lex_state = 14},
  [1886] = {.lex_state = 0, .external_lex_state = 21},
  [1887] = {.lex_state = 0, .external_lex_state = 20},
  [1888] = {.lex_state = 0, .external_lex_state = 29},
  [1889] = {.lex_state = 0, .external_lex_state = 30},
  [1890] = {.lex_state = 0, .external_lex_state = 8},
  [1891] = {.lex_state = 0, .external_lex_state = 29},
  [1892] = {.lex_state = 0, .external_lex_state = 30},
  [1893] = {.lex_state = 0, .external_lex_state = 25},
  [1894] = {.lex_state = 0, .external_lex_state = 29},
  [1895] = {.lex_state = 0, .external_lex_state = 30},
  [1896] = {.lex_state = 0, .external_lex_state = 25},
  [1897] = {.lex_state = 0, .external_lex_state = 25},
  [1898] = {.lex_state = 0, .external_lex_state = 31},
  [1899] = {.lex_state = 0, .external_lex_state = 25},
  [1900] = {.lex_state = 0, .external_lex_state = 20},
  [1901] = {.lex_state = 0, .external_lex_state = 14},
  [1902] = {.lex_state = 0, .external_lex_state = 25},
  [1903] = {.lex_state = 0, .external_lex_state = 20},
  [1904] = {.lex_state = 0, .external_lex_state = 29},
  [1905] = {.lex_state = 0, .external_lex_state = 30},
  [1906] = {.lex_state = 0, .external_lex_state = 30},
  [1907] = {.lex_state = 0, .external_lex_state = 20},
  [1908] = {.lex_state = 0, .external_lex_state = 29},
  [1909] = {.lex_state = 0, .external_lex_state = 22},
  [1910] = {.lex_state = 0, .external_lex_state = 27},
  [1911] = {.lex_state = 0, .external_lex_state = 24},
  [1912] = {.lex_state = 0, .external_lex_state = 30},
  [1913] = {.lex_state = 0, .external_lex_state = 27},
  [1914] = {.lex_state = 0, .external_lex_state = 27},
  [1915] = {.lex_state = 0, .external_lex_state = 27},
  [1916] = {.lex_state = 0, .external_lex_state = 27},
  [1917] = {.lex_state = 0, .external_lex_state = 28},
  [1918] = {.lex_state = 0, .external_lex_state = 26},
  [1919] = {.lex_state = 0, .external_lex_state = 28},
  [1920] = {.lex_state = 0, .external_lex_state = 27},
  [1921] = {.lex_state = 0, .external_lex_state = 28},
  [1922] = {.lex_state = 0, .external_lex_state = 28},
  [1923] = {.lex_state = 0, .external_lex_state = 5},
  [1924] = {.lex_state = 0, .external_lex_state = 20},
  [1925] = {.lex_state = 0, .external_lex_state = 5},
  [1926] = {.lex_state = 0, .external_lex_state = 28},
  [1927] = {.lex_state = 0, .external_lex_state = 5},
  [1928] = {.lex_state = 0, .external_lex_state = 27},
  [1929] = {.lex_state = 0, .external_lex_state = 5},
  [1930] = {.lex_state = 0, .external_lex_state = 28},
  [1931] = {.lex_state = 0, .external_lex_state = 24},
  [1932] = {.lex_state = 0, .external_lex_state = 28},
  [1933] = {.lex_state = 0, .external_lex_state = 24},
  [1934] = {.lex_state = 0, .external_lex_state = 5},
  [1935] = {.lex_state = 0, .external_lex_state = 27},
  [1936] = {.lex_state = 0, .external_lex_state = 26},
  [1937] = {.lex_state = 0, .external_lex_state = 27},
  [1938] = {.lex_state = 0, .external_lex_state = 26},
  [1939] = {.lex_state = 0, .external_lex_state = 27},
  [1940] = {.lex_state = 0, .external_lex_state = 27},
  [1941] = {.lex_state = 0, .external_lex_state = 28},
  [1942] = {.lex_state = 0, .external_lex_state = 27},
  [1943] = {.lex_state = 0, .external_lex_state = 5},
  [1944] = {.lex_state = 0, .external_lex_state = 27},
  [1945] = {.lex_state = 0, .external_lex_state = 28},
  [1946] = {.lex_state = 0, .external_lex_state = 26},
  [1947] = {.lex_state = 0, .external_lex_state = 5},
  [1948] = {.lex_state = 0, .external_lex_state = 27},
  [1949] = {.lex_state = 0, .external_lex_state = 28},
  [1950] = {.lex_state = 0, .external_lex_state = 26},
  [1951] = {.lex_state = 0, .external_lex_state = 28},
  [1952] = {.lex_state = 0, .external_lex_state = 26},
  [1953] = {.lex_state = 0, .external_lex_state = 28},
  [1954] = {.lex_state = 0, .external_lex_state = 27},
  [1955] = {.lex_state = 0, .external_lex_state = 28},
  [1956] = {.lex_state = 0, .external_lex_state = 27},
  [1957] = {.lex_state = 0, .external_lex_state = 27},
  [1958] = {.lex_state = 0, .external_lex_state = 26},
  [1959] = {.lex_state = 0, .external_lex_state = 26},
  [1960] = {.lex_state = 0, .external_lex_state = 26},
  [1961] = {.lex_state = 0, .external_lex_state = 27},
  [1962] = {.lex_state = 0, .external_lex_state = 26},
  [1963] = {.lex_state = 0, .external_lex_state = 27},
  [1964] = {.lex_state = 0, .external_lex_state = 26},
  [1965] = {.lex_state = 0, .external_lex_state = 26},
  [1966] = {.lex_state = 0, .external_lex_state = 25},
  [1967] = {.lex_state = 0, .external_lex_state = 27},
  [1968] = {.lex_state = 0, .external_lex_state = 14},
  [1969] = {.lex_state = 0, .external_lex_state = 24},
  [1970] = {.lex_state = 0, .external_lex_state = 26},
  [1971] = {.lex_state = 0, .external_lex_state = 27},
  [1972] = {.lex_state = 0, .external_lex_state = 27},
  [1973] = {.lex_state = 0, .external_lex_state = 26},
  [1974] = {.lex_state = 0, .external_lex_state = 27},
  [1975] = {.lex_state = 0, .external_lex_state = 26},
  [1976] = {.lex_state = 0, .external_lex_state = 26},
  [1977] = {.lex_state = 0, .external_lex_state = 26},
  [1978] = {.lex_state = 0, .external_lex_state = 26},
  [1979] = {.lex_state = 0, .external_lex_state = 27},
  [1980] = {.lex_state = 0, .external_lex_state = 26},
  [1981] = {.lex_state = 0, .external_lex_state = 3},
  [1982] = {.lex_state = 0, .external_lex_state = 3},
  [1983] = {.lex_state = 0, .external_lex_state = 26},
  [1984] = {.lex_state = 0, .external_lex_state = 3},
  [1985] = {.lex_state = 0, .external_lex_state = 3},
  [1986] = {.lex_state = 0, .external_lex_state = 26},
  [1987] = {.lex_state = 0, .external_lex_state = 26},
  [1988] = {.lex_state = 0, .external_lex_state = 26},
  [1989] = {.lex_state = 0, .external_lex_state = 28},
  [1990] = {.lex_state = 0, .external_lex_state = 3},
  [1991] = {.lex_state = 0, .external_lex_state = 26},
  [1992] = {.lex_state = 0, .external_lex_state = 26},
  [1993] = {.lex_state = 0, .external_lex_state = 28},
  [1994] = {.lex_state = 0, .external_lex_state = 24},
  [1995] = {.lex_state = 0, .external_lex_state = 26},
  [1996] = {.lex_state = 0, .external_lex_state = 24},
  [1997] = {.lex_state = 0, .external_lex_state = 28},
  [1998] = {.lex_state = 0, .external_lex_state = 26},
  [1999] = {.lex_state = 0, .external_lex_state = 24},
  [2000] = {.lex_state = 0, .external_lex_state = 27},
  [2001] = {.lex_state = 0, .external_lex_state = 26},
  [2002] = {.lex_state = 0, .external_lex_state = 26},
  [2003] = {.lex_state = 0, .external_lex_state = 28},
  [2004] = {.lex_state = 0, .external_lex_state = 3},
  [2005] = {.lex_state = 0, .external_lex_state = 26},
  [2006] = {.lex_state = 0, .external_lex_state = 24},
  [2007] = {.lex_state = 0, .external_lex_state = 28},
  [2008] = {.lex_state = 0, .external_lex_state = 3},
  [2009] = {.lex_state = 0, .external_lex_state = 4},
  [2010] = {.lex_state = 0, .external_lex_state = 27},
  [2011] = {.lex_state = 0, .external_lex_state = 26},
  [2012] = {.lex_state = 0, .external_lex_state = 24},
  [2013] = {.lex_state = 0, .external_lex_state = 28},
  [2014] = {.lex_state = 0, .external_lex_state = 28},
  [2015] = {.lex_state = 0, .external_lex_state = 25},
  [2016] = {.lex_state = 0, .external_lex_state = 4},
  [2017] = {.lex_state = 0, .external_lex_state = 28},
  [2018] = {.lex_state = 0, .external_lex_state = 26},
  [2019] = {.lex_state = 0, .external_lex_state = 28},
  [2020] = {.lex_state = 0, .external_lex_state = 27},
  [2021] = {.lex_state = 0, .external_lex_state = 4},
  [2022] = {.lex_state = 0, .external_lex_state = 28},
  [2023] = {.lex_state = 0, .external_lex_state = 27},
  [2024] = {.lex_state = 0, .external_lex_state = 28},
  [2025] = {.lex_state = 0, .external_lex_state = 27},
  [2026] = {.lex_state = 0, .external_lex_state = 28},
  [2027] = {.lex_state = 0, .external_lex_state = 4},
  [2028] = {.lex_state = 0, .external_lex_state = 27},
  [2029] = {.lex_state = 0, .external_lex_state = 27},
  [2030] = {.lex_state = 0, .external_lex_state = 24},
  [2031] = {.lex_state = 0, .external_lex_state = 3},
  [2032] = {.lex_state = 0, .external_lex_state = 27},
  [2033] = {.lex_state = 0, .external_lex_state = 3},
  [2034] = {.lex_state = 0, .external_lex_state = 29},
  [2035] = {.lex_state = 0, .external_lex_state = 27},
  [2036] = {.lex_state = 0, .external_lex_state = 15},
  [2037] = {.lex_state = 0, .external_lex_state = 24},
  [2038] = {.lex_state = 0, .external_lex_state = 28},
  [2039] = {.lex_state = 0, .external_lex_state = 21},
  [2040] = {.lex_state = 0, .external_lex_state = 27},
  [2041] = {.lex_state = 0, .external_lex_state = 4},
  [2042] = {.lex_state = 0, .external_lex_state = 28},
  [2043] = {.lex_state = 0, .external_lex_state = 26},
  [2044] = {.lex_state = 0, .external_lex_state = 27},
  [2045] = {.lex_state = 0, .external_lex_state = 27},
  [2046] = {.lex_state = 0, .external_lex_state = 27},
  [2047] = {.lex_state = 0, .external_lex_state = 27},
  [2048] = {.lex_state = 0, .external_lex_state = 17},
  [2049] = {.lex_state = 0, .external_lex_state = 24},
  [2050] = {.lex_state = 0, .external_lex_state = 26},
  [2051] = {.lex_state = 0, .external_lex_state = 28},
  [2052] = {.lex_state = 0, .external_lex_state = 24},
  [2053] = {.lex_state = 0, .external_lex_state = 28},
  [2054] = {.lex_state = 0, .external_lex_state = 24},
  [2055] = {.lex_state = 0, .external_lex_state = 24},
  [2056] = {.lex_state = 0, .external_lex_state = 17},
  [2057] = {.lex_state = 0, .external_lex_state = 18},
  [2058] = {.lex_state = 0, .external_lex_state = 28},
  [2059] = {.lex_state = 0, .external_lex_state = 4},
  [2060] = {.lex_state = 0, .external_lex_state = 4},
  [2061] = {.lex_state = 0, .external_lex_state = 27},
  [2062] = {.lex_state = 0, .external_lex_state = 24},
  [2063] = {.lex_state = 0, .external_lex_state = 26},
  [2064] = {.lex_state = 0, .external_lex_state = 18},
  [2065] = {.lex_state = 0, .external_lex_state = 22},
  [2066] = {.lex_state = 0, .external_lex_state = 24},
  [2067] = {.lex_state = 0, .external_lex_state = 28},
  [2068] = {.lex_state = 0, .external_lex_state = 24},
  [2069] = {.lex_state = 0, .external_lex_state = 27},
  [2070] = {.lex_state = 0, .external_lex_state = 24},
  [2071] = {.lex_state = 0, .external_lex_state = 28},
  [2072] = {.lex_state = 0, .external_lex_state = 27},
  [2073] = {.lex_state = 0, .external_lex_state = 24},
  [2074] = {.lex_state = 0, .external_lex_state = 26},
  [2075] = {.lex_state = 0, .external_lex_state = 4},
  [2076] = {.lex_state = 0, .external_lex_state = 4},
  [2077] = {.lex_state = 0, .external_lex_state = 28},
  [2078] = {.lex_state = 0, .external_lex_state = 28},
  [2079] = {.lex_state = 0, .external_lex_state = 24},
  [2080] = {.lex_state = 0, .external_lex_state = 28},
  [2081] = {.lex_state = 0, .external_lex_state = 24},
  [2082] = {.lex_state = 0, .external_lex_state = 24},
  [2083] = {.lex_state = 0, .external_lex_state = 24},
  [2084] = {.lex_state = 0, .external_lex_state = 27},
  [2085] = {.lex_state = 0, .external_lex_state = 26},
  [2086] = {.lex_state = 0, .external_lex_state = 27},
  [2087] = {.lex_state = 0, .external_lex_state = 27},
  [2088] = {.lex_state = 0, .external_lex_state = 27},
  [2089] = {.lex_state = 0, .external_lex_state = 28},
  [2090] = {.lex_state = 0, .external_lex_state = 24},
  [2091] = {.lex_state = 0, .external_lex_state = 28},
  [2092] = {.lex_state = 0, .external_lex_state = 24},
  [2093] = {.lex_state = 0, .external_lex_state = 28},
  [2094] = {.lex_state = 0, .external_lex_state = 27},
  [2095] = {.lex_state = 0, .external_lex_state = 28},
  [2096] = {.lex_state = 0, .external_lex_state = 24},
  [2097] = {.lex_state = 0, .external_lex_state = 19},
  [2098] = {.lex_state = 0, .external_lex_state = 13},
  [2099] = {.lex_state = 0, .external_lex_state = 27},
  [2100] = {.lex_state = 0, .external_lex_state = 28},
  [2101] = {.lex_state = 0, .external_lex_state = 28},
  [2102] = {.lex_state = 0, .external_lex_state = 28},
  [2103] = {.lex_state = 0, .external_lex_state = 28},
  [2104] = {.lex_state = 0, .external_lex_state = 28},
  [2105] = {.lex_state = 0, .external_lex_state = 27},
  [2106] = {.lex_state = 0, .external_lex_state = 27},
  [2107] = {.lex_state = 0, .external_lex_state = 27},
  [2108] = {.lex_state = 0, .external_lex_state = 28},
  [2109] = {.lex_state = 0, .external_lex_state = 24},
  [2110] = {.lex_state = 0, .external_lex_state = 24},
  [2111] = {.lex_state = 0, .external_lex_state = 24},
  [2112] = {.lex_state = 0, .external_lex_state = 24},
  [2113] = {.lex_state = 0, .external_lex_state = 31},
  [2114] = {.lex_state = 0, .external_lex_state = 24},
  [2115] = {.lex_state = 0, .external_lex_state = 5},
  [2116] = {.lex_state = 0, .external_lex_state = 5},
  [2117] = {.lex_state = 0, .external_lex_state = 24},
  [2118] = {.lex_state = 0, .external_lex_state = 20},
  [2119] = {.lex_state = 0, .external_lex_state = 26},
  [2120] = {.lex_state = 0, .external_lex_state = 26},
  [2121] = {.lex_state = 0, .external_lex_state = 24},
  [2122] = {.lex_state = 0, .external_lex_state = 27},
  [2123] = {.lex_state = 0, .external_lex_state = 16},
  [2124] = {.lex_state = 0, .external_lex_state = 24},
  [2125] = {.lex_state = 0, .external_lex_state = 26},
  [2126] = {.lex_state = 0, .external_lex_state = 26},
  [2127] = {.lex_state = 0, .external_lex_state = 26},
  [2128] = {.lex_state = 0, .external_lex_state = 26},
  [2129] = {.lex_state = 0, .external_lex_state = 24},
  [2130] = {.lex_state = 0, .external_lex_state = 24},
  [2131] = {.lex_state = 0, .external_lex_state = 23},
  [2132] = {.lex_state = 0, .external_lex_state = 24},
  [2133] = {.lex_state = 0, .external_lex_state = 24},
  [2134] = {.lex_state = 0, .external_lex_state = 24},
  [2135] = {.lex_state = 0, .external_lex_state = 26},
  [2136] = {.lex_state = 0, .external_lex_state = 26},
  [2137] = {.lex_state = 0, .external_lex_state = 26},
  [2138] = {.lex_state = 0, .external_lex_state = 24},
  [2139] = {.lex_state = 0, .external_lex_state = 26},
  [2140] = {.lex_state = 0, .external_lex_state = 24},
  [2141] = {.lex_state = 0, .external_lex_state = 24},
  [2142] = {.lex_state = 0, .external_lex_state = 24},
  [2143] = {.lex_state = 0, .external_lex_state = 12},
  [2144] = {.lex_state = 0, .external_lex_state = 24},
  [2145] = {.lex_state = 0, .external_lex_state = 24},
  [2146] = {.lex_state = 0, .external_lex_state = 23},
  [2147] = {.lex_state = 0, .external_lex_state = 26},
  [2148] = {.lex_state = 0, .external_lex_state = 26},
  [2149] = {.lex_state = 0, .external_lex_state = 26},
  [2150] = {.lex_state = 0, .external_lex_state = 24},
  [2151] = {.lex_state = 0, .external_lex_state = 28},
  [2152] = {.lex_state = 0, .external_lex_state = 24},
  [2153] = {.lex_state = 0, .external_lex_state = 24},
  [2154] = {.lex_state = 0, .external_lex_state = 24},
  [2155] = {.lex_state = 0, .external_lex_state = 19},
  [2156] = {.lex_state = 0, .external_lex_state = 26},
  [2157] = {.lex_state = 0, .external_lex_state = 24},
  [2158] = {.lex_state = 0, .external_lex_state = 28},
  [2159] = {.lex_state = 0, .external_lex_state = 24},
  [2160] = {.lex_state = 0, .external_lex_state = 28},
  [2161] = {.lex_state = 0, .external_lex_state = 11},
  [2162] = {.lex_state = 0, .external_lex_state = 28},
  [2163] = {.lex_state = 0, .external_lex_state = 21},
  [2164] = {.lex_state = 0, .external_lex_state = 28},
  [2165] = {.lex_state = 0, .external_lex_state = 28},
  [2166] = {.lex_state = 0, .external_lex_state = 9},
  [2167] = {.lex_state = 0, .external_lex_state = 9},
  [2168] = {.lex_state = 0, .external_lex_state = 21},
  [2169] = {.lex_state = 0, .external_lex_state = 7},
  [2170] = {.lex_state = 0, .external_lex_state = 6},
  [2171] = {.lex_state = 0, .external_lex_state = 26},
  [2172] = {.lex_state = 0, .external_lex_state = 6},
  [2173] = {.lex_state = 0, .external_lex_state = 23},
  [2174] = {.lex_state = 0, .external_lex_state = 7},
  [2175] = {.lex_state = 0, .external_lex_state = 7},
  [2176] = {.lex_state = 0, .external_lex_state = 7},
  [2177] = {.lex_state = 0, .external_lex_state = 7},
  [2178] = {.lex_state = 0, .external_lex_state = 28},
  [2179] = {.lex_state = 0, .external_lex_state = 24},
  [2180] = {.lex_state = 0, .external_lex_state = 7},
  [2181] = {.lex_state = 0, .external_lex_state = 7},
  [2182] = {.lex_state = 0, .external_lex_state = 19},
  [2183] = {.lex_state = 0, .external_lex_state = 7},
  [2184] = {.lex_state = 0, .external_lex_state = 7},
  [2185] = {.lex_state = 0, .external_lex_state = 6},
  [2186] = {.lex_state = 0, .external_lex_state = 6},
  [2187] = {.lex_state = 0, .external_lex_state = 6},
  [2188] = {.lex_state = 0, .external_lex_state = 6},
  [2189] = {.lex_state = 0, .external_lex_state = 6},
  [2190] = {.lex_state = 0, .external_lex_state = 10},
  [2191] = {.lex_state = 0, .external_lex_state = 10},
  [2192] = {.lex_state = 0, .external_lex_state = 6},
  [2193] = {.lex_state = 0, .external_lex_state = 6},
  [2194] = {.lex_state = 0, .external_lex_state = 8},
  [2195] = {.lex_state = 0, .external_lex_state = 3},
  [2196] = {.lex_state = 0, .external_lex_state = 5},
  [2197] = {.lex_state = 0, .external_lex_state = 22},
  [2198] = {.lex_state = 0, .external_lex_state = 9},
  [2199] = {.lex_state = 0, .external_lex_state = 4},
  [2200] = {.lex_state = 0, .external_lex_state = 9},
  [2201] = {.lex_state = 0, .external_lex_state = 9},
  [2202] = {.lex_state = 0, .external_lex_state = 18},
  [2203] = {.lex_state = 0, .external_lex_state = 17},
  [2204] = {.lex_state = 0, .external_lex_state = 10},
  [2205] = {.lex_state = 0, .external_lex_state = 20},
  [2206] = {.lex_state = 0, .external_lex_state = 9},
  [2207] = {.lex_state = 0, .external_lex_state = 9},
  [2208] = {.lex_state = 0, .external_lex_state = 8},
  [2209] = {.lex_state = 0, .external_lex_state = 8},
  [2210] = {.lex_state = 0, .external_lex_state = 8},
  [2211] = {.lex_state = 0, .external_lex_state = 8},
  [2212] = {.lex_state = 0, .external_lex_state = 8},
  [2213] = {.lex_state = 0, .external_lex_state = 27},
  [2214] = {.lex_state = 0, .external_lex_state = 24},
  [2215] = {.lex_state = 0, .external_lex_state = 25},
  [2216] = {.lex_state = 0, .external_lex_state = 9},
  [2217] = {.lex_state = 0, .external_lex_state = 9},
  [2218] = {.lex_state = 0, .external_lex_state = 10},
  [2219] = {.lex_state = 0, .external_lex_state = 10},
  [2220] = {.lex_state = 0, .external_lex_state = 10},
  [2221] = {.lex_state = 0, .external_lex_state = 10},
  [2222] = {.lex_state = 0, .external_lex_state = 10},
  [2223] = {.lex_state = 0, .external_lex_state = 8},
  [2224] = {.lex_state = 0, .external_lex_state = 8},
  [2225] = {.lex_state = 0, .external_lex_state = 28},
  [2226] = {.lex_state = 0, .external_lex_state = 26},
  [2227] = {.lex_state = 0, .external_lex_state = 27},
  [2228] = {.lex_state = 0, .external_lex_state = 8},
  [2229] = {.lex_state = 0, .external_lex_state = 10},
  [2230] = {.lex_state = 0, .external_lex_state = 5},
  [2231] = {.lex_state = 0, .external_lex_state = 13},
  [2232] = {.lex_state = 0, .external_lex_state = 4},
  [2233] = {.lex_state = 0, .external_lex_state = 15},
  [2234] = {.lex_state = 0, .external_lex_state = 15},
  [2235] = {.lex_state = 0, .external_lex_state = 15},
  [2236] = {.lex_state = 0, .external_lex_state = 15},
  [2237] = {.lex_state = 0, .external_lex_state = 15},
  [2238] = {.lex_state = 0, .external_lex_state = 15},
  [2239] = {.lex_state = 0, .external_lex_state = 15},
  [2240] = {.lex_state = 0, .external_lex_state = 3},
  [2241] = {.lex_state = 0, .external_lex_state = 3},
  [2242] = {.lex_state = 0, .external_lex_state = 3},
  [2243] = {.lex_state = 0, .external_lex_state = 3},
  [2244] = {.lex_state = 0, .external_lex_state = 3},
  [2245] = {.lex_state = 0, .external_lex_state = 3},
  [2246] = {.lex_state = 0, .external_lex_state = 3},
  [2247] = {.lex_state = 0, .external_lex_state = 12},
  [2248] = {.lex_state = 0, .external_lex_state = 3},
  [2249] = {.lex_state = 0, .external_lex_state = 3},
  [2250] = {.lex_state = 0, .external_lex_state = 3},
  [2251] = {.lex_state = 0, .external_lex_state = 24},
  [2252] = {.lex_state = 0, .external_lex_state = 3},
  [2253] = {.lex_state = 0, .external_lex_state = 12},
  [2254] = {.lex_state = 0, .external_lex_state = 5},
  [2255] = {.lex_state = 0, .external_lex_state = 15},
  [2256] = {.lex_state = 0, .external_lex_state = 3},
  [2257] = {.lex_state = 0, .external_lex_state = 3},
  [2258] = {.lex_state = 0, .external_lex_state = 15},
  [2259] = {.lex_state = 0, .external_lex_state = 3},
  [2260] = {.lex_state = 0, .external_lex_state = 3},
  [2261] = {.lex_state = 0, .external_lex_state = 3},
  [2262] = {.lex_state = 0, .external_lex_state = 12},
  [2263] = {.lex_state = 0, .external_lex_state = 12},
  [2264] = {.lex_state = 0, .external_lex_state = 12},
  [2265] = {.lex_state = 0, .external_lex_state = 12},
  [2266] = {.lex_state = 0, .external_lex_state = 12},
  [2267] = {.lex_state = 0, .external_lex_state = 3},
  [2268] = {.lex_state = 0, .external_lex_state = 3},
  [2269] = {.lex_state = 0, .external_lex_state = 12},
  [2270] = {.lex_state = 0, .external_lex_state = 11},
  [2271] = {.lex_state = 0, .external_lex_state = 11},
  [2272] = {.lex_state = 0, .external_lex_state = 11},
  [2273] = {.lex_state = 0, .external_lex_state = 11},
  [2274] = {.lex_state = 0, .external_lex_state = 11},
  [2275] = {.lex_state = 0, .external_lex_state = 3},
  [2276] = {.lex_state = 0, .external_lex_state = 11},
  [2277] = {.lex_state = 0, .external_lex_state = 11},
  [2278] = {.lex_state = 0, .external_lex_state = 11},
  [2279] = {.lex_state = 0, .external_lex_state = 11},
  [2280] = {.lex_state = 0, .external_lex_state = 3},
  [2281] = {.lex_state = 0, .external_lex_state = 7},
  [2282] = {.lex_state = 0, .external_lex_state = 3},
  [2283] = {.lex_state = 0, .external_lex_state = 3},
  [2284] = {.lex_state = 0, .external_lex_state = 12},
  [2285] = {.lex_state = 0, .external_lex_state = 3},
  [2286] = {.lex_state = 0, .external_lex_state = 16},
  [2287] = {.lex_state = 0, .external_lex_state = 16},
  [2288] = {.lex_state = 0, .external_lex_state = 16},
  [2289] = {.lex_state = 0, .external_lex_state = 16},
  [2290] = {.lex_state = 0, .external_lex_state = 16},
  [2291] = {.lex_state = 0, .external_lex_state = 16},
  [2292] = {.lex_state = 0, .external_lex_state = 16},
  [2293] = {.lex_state = 0, .external_lex_state = 3},
  [2294] = {.lex_state = 0, .external_lex_state = 4},
  [2295] = {.lex_state = 0, .external_lex_state = 16},
  [2296] = {.lex_state = 0, .external_lex_state = 16},
  [2297] = {.lex_state = 0, .external_lex_state = 4},
  [2298] = {.lex_state = 0, .external_lex_state = 4},
  [2299] = {.lex_state = 0, .external_lex_state = 14},
  [2300] = {.lex_state = 0, .external_lex_state = 14},
  [2301] = {.lex_state = 0, .external_lex_state = 5},
  [2302] = {.lex_state = 0, .external_lex_state = 9},
  [2303] = {.lex_state = 0, .external_lex_state = 10},
  [2304] = {.lex_state = 0, .external_lex_state = 4},
  [2305] = {.lex_state = 0, .external_lex_state = 27},
  [2306] = {.lex_state = 0, .external_lex_state = 14},
  [2307] = {.lex_state = 0, .external_lex_state = 14},
  [2308] = {.lex_state = 0, .external_lex_state = 5},
  [2309] = {.lex_state = 0, .external_lex_state = 14},
  [2310] = {.lex_state = 0, .external_lex_state = 14},
  [2311] = {.lex_state = 0, .external_lex_state = 14},
  [2312] = {.lex_state = 0, .external_lex_state = 14},
  [2313] = {.lex_state = 0, .external_lex_state = 14},
  [2314] = {.lex_state = 0, .external_lex_state = 5},
  [2315] = {.lex_state = 0, .external_lex_state = 4},
  [2316] = {.lex_state = 0, .external_lex_state = 4},
  [2317] = {.lex_state = 0, .external_lex_state = 4},
  [2318] = {.lex_state = 0, .external_lex_state = 4},
  [2319] = {.lex_state = 0, .external_lex_state = 4},
  [2320] = {.lex_state = 0, .external_lex_state = 4},
  [2321] = {.lex_state = 0, .external_lex_state = 4},
  [2322] = {.lex_state = 0, .external_lex_state = 4},
  [2323] = {.lex_state = 0, .external_lex_state = 4},
  [2324] = {.lex_state = 0, .external_lex_state = 4},
  [2325] = {.lex_state = 0, .external_lex_state = 4},
  [2326] = {.lex_state = 0, .external_lex_state = 4},
  [2327] = {.lex_state = 0, .external_lex_state = 4},
  [2328] = {.lex_state = 0, .external_lex_state = 4},
  [2329] = {.lex_state = 0, .external_lex_state = 4},
  [2330] = {.lex_state = 0, .external_lex_state = 4},
  [2331] = {.lex_state = 0, .external_lex_state = 4},
  [2332] = {.lex_state = 0, .external_lex_state = 4},
  [2333] = {.lex_state = 0, .external_lex_state = 4},
  [2334] = {.lex_state = 0, .external_lex_state = 13},
  [2335] = {.lex_state = 0, .external_lex_state = 13},
  [2336] = {.lex_state = 0, .external_lex_state = 6},
  [2337] = {.lex_state = 0, .external_lex_state = 5},
  [2338] = {.lex_state = 0, .external_lex_state = 26},
  [2339] = {.lex_state = 0, .external_lex_state = 5},
  [2340] = {.lex_state = 0, .external_lex_state = 5},
  [2341] = {.lex_state = 0, .external_lex_state = 5},
  [2342] = {.lex_state = 0, .external_lex_state = 5},
  [2343] = {.lex_state = 0, .external_lex_state = 5},
  [2344] = {.lex_state = 0, .external_lex_state = 13},
  [2345] = {.lex_state = 0, .external_lex_state = 13},
  [2346] = {.lex_state = 0, .external_lex_state = 5},
  [2347] = {.lex_state = 0, .external_lex_state = 5},
  [2348] = {.lex_state = 0, .external_lex_state = 5},
  [2349] = {.lex_state = 0, .external_lex_state = 8},
  [2350] = {.lex_state = 0, .external_lex_state = 5},
  [2351] = {.lex_state = 0, .external_lex_state = 5},
  [2352] = {.lex_state = 0, .external_lex_state = 5},
  [2353] = {.lex_state = 0, .external_lex_state = 28},
  [2354] = {.lex_state = 0, .external_lex_state = 13},
  [2355] = {.lex_state = 0, .external_lex_state = 13},
  [2356] = {.lex_state = 0, .external_lex_state = 13},
  [2357] = {.lex_state = 0, .external_lex_state = 5},
  [2358] = {.lex_state = 0, .external_lex_state = 5},
  [2359] = {.lex_state = 0, .external_lex_state = 13},
  [2360] = {.lex_state = 0, .external_lex_state = 5},
  [2361] = {.lex_state = 0, .external_lex_state = 5},
  [2362] = {.lex_state = 0, .external_lex_state = 5},
  [2363] = {.lex_state = 0, .external_lex_state = 5},
  [2364] = {.lex_state = 0, .external_lex_state = 5},
  [2365] = {.lex_state = 0, .external_lex_state = 7},
  [2366] = {.lex_state = 0, .external_lex_state = 18},
  [2367] = {.lex_state = 0, .external_lex_state = 17},
  [2368] = {.lex_state = 0, .external_lex_state = 17},
  [2369] = {.lex_state = 0, .external_lex_state = 17},
  [2370] = {.lex_state = 0, .external_lex_state = 17},
  [2371] = {.lex_state = 0, .external_lex_state = 17},
  [2372] = {.lex_state = 0, .external_lex_state = 17},
  [2373] = {.lex_state = 0, .external_lex_state = 17},
  [2374] = {.lex_state = 0, .external_lex_state = 6},
  [2375] = {.lex_state = 0, .external_lex_state = 21},
  [2376] = {.lex_state = 0, .external_lex_state = 21},
  [2377] = {.lex_state = 0, .external_lex_state = 23},
  [2378] = {.lex_state = 0, .external_lex_state = 23},
  [2379] = {.lex_state = 0, .external_lex_state = 10},
  [2380] = {.lex_state = 0, .external_lex_state = 6},
  [2381] = {.lex_state = 0, .external_lex_state = 23},
  [2382] = {.lex_state = 0, .external_lex_state = 23},
  [2383] = {.lex_state = 0, .external_lex_state = 23},
  [2384] = {.lex_state = 0, .external_lex_state = 10},
  [2385] = {.lex_state = 0, .external_lex_state = 6},
  [2386] = {.lex_state = 0, .external_lex_state = 23},
  [2387] = {.lex_state = 0, .external_lex_state = 18},
  [2388] = {.lex_state = 0, .external_lex_state = 6},
  [2389] = {.lex_state = 0, .external_lex_state = 18},
  [2390] = {.lex_state = 0, .external_lex_state = 23},
  [2391] = {.lex_state = 0, .external_lex_state = 10},
  [2392] = {.lex_state = 0, .external_lex_state = 18},
  [2393] = {.lex_state = 0, .external_lex_state = 9},
  [2394] = {.lex_state = 0, .external_lex_state = 8},
  [2395] = {.lex_state = 0, .external_lex_state = 23},
  [2396] = {.lex_state = 0, .external_lex_state = 23},
  [2397] = {.lex_state = 0, .external_lex_state = 18},
  [2398] = {.lex_state = 0, .external_lex_state = 12},
  [2399] = {.lex_state = 0, .external_lex_state = 14},
  [2400] = {.lex_state = 0, .external_lex_state = 15},
  [2401] = {.lex_state = 0, .external_lex_state = 10},
  [2402] = {.lex_state = 0, .external_lex_state = 6},
  [2403] = {.lex_state = 0, .external_lex_state = 10},
  [2404] = {.lex_state = 0, .external_lex_state = 10},
  [2405] = {.lex_state = 0, .external_lex_state = 9},
  [2406] = {.lex_state = 0, .external_lex_state = 10},
  [2407] = {.lex_state = 0, .external_lex_state = 6},
  [2408] = {.lex_state = 0, .external_lex_state = 10},
  [2409] = {.lex_state = 0, .external_lex_state = 9},
  [2410] = {.lex_state = 0, .external_lex_state = 7},
  [2411] = {.lex_state = 0, .external_lex_state = 7},
  [2412] = {.lex_state = 0, .external_lex_state = 18},
  [2413] = {.lex_state = 0, .external_lex_state = 10},
  [2414] = {.lex_state = 0, .external_lex_state = 6},
  [2415] = {.lex_state = 0, .external_lex_state = 6},
  [2416] = {.lex_state = 0, .external_lex_state = 6},
  [2417] = {.lex_state = 0, .external_lex_state = 6},
  [2418] = {.lex_state = 0, .external_lex_state = 6},
  [2419] = {.lex_state = 0, .external_lex_state = 10},
  [2420] = {.lex_state = 0, .external_lex_state = 10},
  [2421] = {.lex_state = 0, .external_lex_state = 10},
  [2422] = {.lex_state = 0, .external_lex_state = 10},
  [2423] = {.lex_state = 0, .external_lex_state = 19},
  [2424] = {.lex_state = 0, .external_lex_state = 19},
  [2425] = {.lex_state = 0, .external_lex_state = 9},
  [2426] = {.lex_state = 0, .external_lex_state = 6},
  [2427] = {.lex_state = 0, .external_lex_state = 6},
  [2428] = {.lex_state = 0, .external_lex_state = 20},
  [2429] = {.lex_state = 0, .external_lex_state = 20},
  [2430] = {.lex_state = 0, .external_lex_state = 18},
  [2431] = {.lex_state = 0, .external_lex_state = 10},
  [2432] = {.lex_state = 0, .external_lex_state = 9},
  [2433] = {.lex_state = 0, .external_lex_state = 19},
  [2434] = {.lex_state = 0, .external_lex_state = 19},
  [2435] = {.lex_state = 0, .external_lex_state = 9},
  [2436] = {.lex_state = 0, .external_lex_state = 9},
  [2437] = {.lex_state = 0, .external_lex_state = 19},
  [2438] = {.lex_state = 0, .external_lex_state = 9},
  [2439] = {.lex_state = 0, .external_lex_state = 9},
  [2440] = {.lex_state = 0, .external_lex_state = 9},
  [2441] = {.lex_state = 0, .external_lex_state = 22},
  [2442] = {.lex_state = 0, .external_lex_state = 19},
  [2443] = {.lex_state = 0, .external_lex_state = 9},
  [2444] = {.lex_state = 0, .external_lex_state = 9},
  [2445] = {.lex_state = 0, .external_lex_state = 19},
  [2446] = {.lex_state = 0, .external_lex_state = 8},
  [2447] = {.lex_state = 0, .external_lex_state = 10},
  [2448] = {.lex_state = 0, .external_lex_state = 22},
  [2449] = {.lex_state = 0, .external_lex_state = 19},
  [2450] = {.lex_state = 0, .external_lex_state = 6},
  [2451] = {.lex_state = 0, .external_lex_state = 9},
  [2452] = {.lex_state = 0, .external_lex_state = 9},
  [2453] = {.lex_state = 0, .external_lex_state = 9},
  [2454] = {.lex_state = 0, .external_lex_state = 9},
  [2455] = {.lex_state = 0, .external_lex_state = 9},
  [2456] = {.lex_state = 0, .external_lex_state = 22},
  [2457] = {.lex_state = 0, .external_lex_state = 9},
  [2458] = {.lex_state = 0, .external_lex_state = 9},
  [2459] = {.lex_state = 0, .external_lex_state = 8},
  [2460] = {.lex_state = 0, .external_lex_state = 16},
  [2461] = {.lex_state = 0, .external_lex_state = 6},
  [2462] = {.lex_state = 0, .external_lex_state = 21},
  [2463] = {.lex_state = 0, .external_lex_state = 7},
  [2464] = {.lex_state = 0, .external_lex_state = 7},
  [2465] = {.lex_state = 0, .external_lex_state = 13},
  [2466] = {.lex_state = 0, .external_lex_state = 18},
  [2467] = {.lex_state = 0, .external_lex_state = 7},
  [2468] = {.lex_state = 0, .external_lex_state = 7},
  [2469] = {.lex_state = 0, .external_lex_state = 7},
  [2470] = {.lex_state = 0, .external_lex_state = 7},
  [2471] = {.lex_state = 0, .external_lex_state = 7},
  [2472] = {.lex_state = 0, .external_lex_state = 7},
  [2473] = {.lex_state = 0, .external_lex_state = 9},
  [2474] = {.lex_state = 0, .external_lex_state = 9},
  [2475] = {.lex_state = 0, .external_lex_state = 9},
  [2476] = {.lex_state = 0, .external_lex_state = 9},
  [2477] = {.lex_state = 0, .external_lex_state = 8},
  [2478] = {.lex_state = 0, .external_lex_state = 22},
  [2479] = {.lex_state = 0, .external_lex_state = 20},
  [2480] = {.lex_state = 0, .external_lex_state = 7},
  [2481] = {.lex_state = 0, .external_lex_state = 21},
  [2482] = {.lex_state = 0, .external_lex_state = 20},
  [2483] = {.lex_state = 0, .external_lex_state = 22},
  [2484] = {.lex_state = 0, .external_lex_state = 21},
  [2485] = {.lex_state = 0, .external_lex_state = 7},
  [2486] = {.lex_state = 0, .external_lex_state = 22},
  [2487] = {.lex_state = 0, .external_lex_state = 7},
  [2488] = {.lex_state = 0, .external_lex_state = 6},
  [2489] = {.lex_state = 0, .external_lex_state = 6},
  [2490] = {.lex_state = 0, .external_lex_state = 7},
  [2491] = {.lex_state = 0, .external_lex_state = 6},
  [2492] = {.lex_state = 0, .external_lex_state = 20},
  [2493] = {.lex_state = 0, .external_lex_state = 7},
  [2494] = {.lex_state = 0, .external_lex_state = 21},
  [2495] = {.lex_state = 0, .external_lex_state = 6},
  [2496] = {.lex_state = 0, .external_lex_state = 8},
  [2497] = {.lex_state = 0, .external_lex_state = 25},
  [2498] = {.lex_state = 0, .external_lex_state = 10},
  [2499] = {.lex_state = 0, .external_lex_state = 25},
  [2500] = {.lex_state = 0, .external_lex_state = 8},
  [2501] = {.lex_state = 0, .external_lex_state = 8},
  [2502] = {.lex_state = 0, .external_lex_state = 8},
  [2503] = {.lex_state = 0, .external_lex_state = 11},
  [2504] = {.lex_state = 0, .external_lex_state = 10},
  [2505] = {.lex_state = 0, .external_lex_state = 7},
  [2506] = {.lex_state = 0, .external_lex_state = 10},
  [2507] = {.lex_state = 0, .external_lex_state = 7},
  [2508] = {.lex_state = 0, .external_lex_state = 10},
  [2509] = {.lex_state = 0, .external_lex_state = 7},
  [2510] = {.lex_state = 0, .external_lex_state = 10},
  [2511] = {.lex_state = 0, .external_lex_state = 6},
  [2512] = {.lex_state = 0, .external_lex_state = 6},
  [2513] = {.lex_state = 0, .external_lex_state = 6},
  [2514] = {.lex_state = 0, .external_lex_state = 22},
  [2515] = {.lex_state = 0, .external_lex_state = 8},
  [2516] = {.lex_state = 0, .external_lex_state = 8},
  [2517] = {.lex_state = 0, .external_lex_state = 8},
  [2518] = {.lex_state = 0, .external_lex_state = 7},
  [2519] = {.lex_state = 0, .external_lex_state = 8},
  [2520] = {.lex_state = 0, .external_lex_state = 10},
  [2521] = {.lex_state = 0, .external_lex_state = 10},
  [2522] = {.lex_state = 0, .external_lex_state = 20},
  [2523] = {.lex_state = 0, .external_lex_state = 20},
  [2524] = {.lex_state = 0, .external_lex_state = 8},
  [2525] = {.lex_state = 0, .external_lex_state = 8},
  [2526] = {.lex_state = 0, .external_lex_state = 7},
  [2527] = {.lex_state = 0, .external_lex_state = 8},
  [2528] = {.lex_state = 0, .external_lex_state = 20},
  [2529] = {.lex_state = 0, .external_lex_state = 20},
  [2530] = {.lex_state = 0, .external_lex_state = 19},
  [2531] = {.lex_state = 0, .external_lex_state = 10},
  [2532] = {.lex_state = 0, .external_lex_state = 25},
  [2533] = {.lex_state = 0, .external_lex_state = 6},
  [2534] = {.lex_state = 0, .external_lex_state = 25},
  [2535] = {.lex_state = 0, .external_lex_state = 7},
  [2536] = {.lex_state = 0, .external_lex_state = 25},
  [2537] = {.lex_state = 0, .external_lex_state = 10},
  [2538] = {.lex_state = 0, .external_lex_state = 25},
  [2539] = {.lex_state = 0, .external_lex_state = 25},
  [2540] = {.lex_state = 0, .external_lex_state = 21},
  [2541] = {.lex_state = 0, .external_lex_state = 21},
  [2542] = {.lex_state = 0, .external_lex_state = 7},
  [2543] = {.lex_state = 0, .external_lex_state = 21},
  [2544] = {.lex_state = 0, .external_lex_state = 25},
  [2545] = {.lex_state = 0, .external_lex_state = 8},
  [2546] = {.lex_state = 0, .external_lex_state = 25},
  [2547] = {.lex_state = 0, .external_lex_state = 7},
  [2548] = {.lex_state = 0, .external_lex_state = 22},
  [2549] = {.lex_state = 0, .external_lex_state = 22},
  [2550] = {.lex_state = 0, .external_lex_state = 8},
  [2551] = {.lex_state = 0, .external_lex_state = 8},
  [2552] = {.lex_state = 0, .external_lex_state = 6},
  [2553] = {.lex_state = 0, .external_lex_state = 8},
  [2554] = {.lex_state = 0, .external_lex_state = 8},
  [2555] = {.lex_state = 0, .external_lex_state = 8},
  [2556] = {.lex_state = 0, .external_lex_state = 8},
  [2557] = {.lex_state = 0, .external_lex_state = 8},
  [2558] = {.lex_state = 0, .external_lex_state = 18},
  [2559] = {.lex_state = 0, .external_lex_state = 17},
  [2560] = {.lex_state = 0, .external_lex_state = 17},
  [2561] = {.lex_state = 0, .external_lex_state = 16},
  [2562] = {.lex_state = 0, .external_lex_state = 26},
  [2563] = {.lex_state = 0, .external_lex_state = 26},
  [2564] = {.lex_state = 0, .external_lex_state = 26},
  [2565] = {.lex_state = 0, .external_lex_state = 26},
  [2566] = {.lex_state = 0, .external_lex_state = 27},
  [2567] = {.lex_state = 0, .external_lex_state = 24},
  [2568] = {.lex_state = 0, .external_lex_state = 11},
  [2569] = {.lex_state = 0, .external_lex_state = 15},
  [2570] = {.lex_state = 0, .external_lex_state = 12},
  [2571] = {.lex_state = 0, .external_lex_state = 12},
  [2572] = {.lex_state = 0, .external_lex_state = 12},
  [2573] = {.lex_state = 0, .external_lex_state = 27},
  [2574] = {.lex_state = 0, .external_lex_state = 12},
  [2575] = {.lex_state = 0, .external_lex_state = 11},
  [2576] = {.lex_state = 0, .external_lex_state = 17},
  [2577] = {.lex_state = 0, .external_lex_state = 11},
  [2578] = {.lex_state = 0, .external_lex_state = 24},
  [2579] = {.lex_state = 0, .external_lex_state = 14},
  [2580] = {.lex_state = 0, .external_lex_state = 15},
  [2581] = {.lex_state = 0, .external_lex_state = 14},
  [2582] = {.lex_state = 0, .external_lex_state = 14},
  [2583] = {.lex_state = 0, .external_lex_state = 15},
  [2584] = {.lex_state = 0, .external_lex_state = 14},
  [2585] = {.lex_state = 0, .external_lex_state = 14},
  [2586] = {.lex_state = 0, .external_lex_state = 15},
  [2587] = {.lex_state = 0, .external_lex_state = 14},
  [2588] = {.lex_state = 0, .external_lex_state = 12},
  [2589] = {.lex_state = 0, .external_lex_state = 14},
  [2590] = {.lex_state = 0, .external_lex_state = 14},
  [2591] = {.lex_state = 0, .external_lex_state = 14},
  [2592] = {.lex_state = 0, .external_lex_state = 14},
  [2593] = {.lex_state = 0, .external_lex_state = 15},
  [2594] = {.lex_state = 0, .external_lex_state = 14},
  [2595] = {.lex_state = 0, .external_lex_state = 14},
  [2596] = {.lex_state = 0, .external_lex_state = 12},
  [2597] = {.lex_state = 0, .external_lex_state = 28},
  [2598] = {.lex_state = 0, .external_lex_state = 11},
  [2599] = {.lex_state = 0, .external_lex_state = 16},
  [2600] = {.lex_state = 0, .external_lex_state = 16},
  [2601] = {.lex_state = 0, .external_lex_state = 16},
  [2602] = {.lex_state = 0, .external_lex_state = 12},
  [2603] = {.lex_state = 0, .external_lex_state = 14},
  [2604] = {.lex_state = 0, .external_lex_state = 16},
  [2605] = {.lex_state = 0, .external_lex_state = 12},
  [2606] = {.lex_state = 0, .external_lex_state = 27},
  [2607] = {.lex_state = 0, .external_lex_state = 12},
  [2608] = {.lex_state = 0, .external_lex_state = 14},
  [2609] = {.lex_state = 0, .external_lex_state = 14},
  [2610] = {.lex_state = 0, .external_lex_state = 14},
  [2611] = {.lex_state = 0, .external_lex_state = 14},
  [2612] = {.lex_state = 0, .external_lex_state = 12},
  [2613] = {.lex_state = 0, .external_lex_state = 12},
  [2614] = {.lex_state = 0, .external_lex_state = 13},
  [2615] = {.lex_state = 0, .external_lex_state = 12},
  [2616] = {.lex_state = 0, .external_lex_state = 28},
  [2617] = {.lex_state = 0, .external_lex_state = 19},
  [2618] = {.lex_state = 0, .external_lex_state = 13},
  [2619] = {.lex_state = 0, .external_lex_state = 13},
  [2620] = {.lex_state = 0, .external_lex_state = 24},
  [2621] = {.lex_state = 0, .external_lex_state = 16},
  [2622] = {.lex_state = 0, .external_lex_state = 16},
  [2623] = {.lex_state = 0, .external_lex_state = 16},
  [2624] = {.lex_state = 0, .external_lex_state = 16},
  [2625] = {.lex_state = 0, .external_lex_state = 14},
  [2626] = {.lex_state = 0, .external_lex_state = 16},
  [2627] = {.lex_state = 0, .external_lex_state = 16},
  [2628] = {.lex_state = 0, .external_lex_state = 14},
  [2629] = {.lex_state = 0, .external_lex_state = 16},
  [2630] = {.lex_state = 0, .external_lex_state = 24},
  [2631] = {.lex_state = 0, .external_lex_state = 24},
  [2632] = {.lex_state = 0, .external_lex_state = 15},
  [2633] = {.lex_state = 0, .external_lex_state = 24},
  [2634] = {.lex_state = 0, .external_lex_state = 15},
  [2635] = {.lex_state = 0, .external_lex_state = 15},
  [2636] = {.lex_state = 0, .external_lex_state = 28},
  [2637] = {.lex_state = 0, .external_lex_state = 18},
  [2638] = {.lex_state = 0, .external_lex_state = 15},
  [2639] = {.lex_state = 0, .external_lex_state = 22},
  [2640] = {.lex_state = 0, .external_lex_state = 13},
  [2641] = {.lex_state = 0, .external_lex_state = 14},
  [2642] = {.lex_state = 0, .external_lex_state = 27},
  [2643] = {.lex_state = 0, .external_lex_state = 13},
  [2644] = {.lex_state = 0, .external_lex_state = 27},
  [2645] = {.lex_state = 0, .external_lex_state = 16},
  [2646] = {.lex_state = 0, .external_lex_state = 16},
  [2647] = {.lex_state = 0, .external_lex_state = 15},
  [2648] = {.lex_state = 0, .external_lex_state = 16},
  [2649] = {.lex_state = 0, .external_lex_state = 27},
  [2650] = {.lex_state = 0, .external_lex_state = 15},
  [2651] = {.lex_state = 0, .external_lex_state = 16},
  [2652] = {.lex_state = 0, .external_lex_state = 16},
  [2653] = {.lex_state = 0, .external_lex_state = 16},
  [2654] = {.lex_state = 0, .external_lex_state = 27},
  [2655] = {.lex_state = 0, .external_lex_state = 12},
  [2656] = {.lex_state = 0, .external_lex_state = 27},
  [2657] = {.lex_state = 0, .external_lex_state = 16},
  [2658] = {.lex_state = 0, .external_lex_state = 28},
  [2659] = {.lex_state = 0, .external_lex_state = 15},
  [2660] = {.lex_state = 0, .external_lex_state = 12},
  [2661] = {.lex_state = 0, .external_lex_state = 12},
  [2662] = {.lex_state = 0, .external_lex_state = 16},
  [2663] = {.lex_state = 0, .external_lex_state = 12},
  [2664] = {.lex_state = 0, .external_lex_state = 28},
  [2665] = {.lex_state = 0, .external_lex_state = 27},
  [2666] = {.lex_state = 0, .external_lex_state = 13},
  [2667] = {.lex_state = 0, .external_lex_state = 26},
  [2668] = {.lex_state = 0, .external_lex_state = 28},
  [2669] = {.lex_state = 0, .external_lex_state = 15},
  [2670] = {.lex_state = 0, .external_lex_state = 21},
  [2671] = {.lex_state = 0, .external_lex_state = 12},
  [2672] = {.lex_state = 0, .external_lex_state = 15},
  [2673] = {.lex_state = 0, .external_lex_state = 24},
  [2674] = {.lex_state = 0, .external_lex_state = 14},
  [2675] = {.lex_state = 0, .external_lex_state = 13},
  [2676] = {.lex_state = 0, .external_lex_state = 13},
  [2677] = {.lex_state = 0, .external_lex_state = 13},
  [2678] = {.lex_state = 0, .external_lex_state = 13},
  [2679] = {.lex_state = 0, .external_lex_state = 13},
  [2680] = {.lex_state = 0, .external_lex_state = 20},
  [2681] = {.lex_state = 0, .external_lex_state = 15},
  [2682] = {.lex_state = 0, .external_lex_state = 24},
  [2683] = {.lex_state = 0, .external_lex_state = 13},
  [2684] = {.lex_state = 0, .external_lex_state = 13},
  [2685] = {.lex_state = 0, .external_lex_state = 13},
  [2686] = {.lex_state = 0, .external_lex_state = 12},
  [2687] = {.lex_state = 0, .external_lex_state = 12},
  [2688] = {.lex_state = 0, .external_lex_state = 24},
  [2689] = {.lex_state = 0, .external_lex_state = 14},
  [2690] = {.lex_state = 0, .external_lex_state = 12},
  [2691] = {.lex_state = 0, .external_lex_state = 14},
  [2692] = {.lex_state = 0, .external_lex_state = 13},
  [2693] = {.lex_state = 0, .external_lex_state = 13},
  [2694] = {.lex_state = 0, .external_lex_state = 13},
  [2695] = {.lex_state = 0, .external_lex_state = 13},
  [2696] = {.lex_state = 0, .external_lex_state = 13},
  [2697] = {.lex_state = 0, .external_lex_state = 13},
  [2698] = {.lex_state = 0, .external_lex_state = 13},
  [2699] = {.lex_state = 0, .external_lex_state = 15},
  [2700] = {.lex_state = 0, .external_lex_state = 28},
  [2701] = {.lex_state = 0, .external_lex_state = 28},
  [2702] = {.lex_state = 0, .external_lex_state = 16},
  [2703] = {.lex_state = 0, .external_lex_state = 11},
  [2704] = {.lex_state = 0, .external_lex_state = 11},
  [2705] = {.lex_state = 0, .external_lex_state = 11},
  [2706] = {.lex_state = 0, .external_lex_state = 11},
  [2707] = {.lex_state = 0, .external_lex_state = 15},
  [2708] = {.lex_state = 0, .external_lex_state = 15},
  [2709] = {.lex_state = 0, .external_lex_state = 12},
  [2710] = {.lex_state = 0, .external_lex_state = 16},
  [2711] = {.lex_state = 0, .external_lex_state = 11},
  [2712] = {.lex_state = 0, .external_lex_state = 11},
  [2713] = {.lex_state = 0, .external_lex_state = 11},
  [2714] = {.lex_state = 0, .external_lex_state = 11},
  [2715] = {.lex_state = 0, .external_lex_state = 11},
  [2716] = {.lex_state = 0, .external_lex_state = 11},
  [2717] = {.lex_state = 0, .external_lex_state = 11},
  [2718] = {.lex_state = 0, .external_lex_state = 26},
  [2719] = {.lex_state = 0, .external_lex_state = 13},
  [2720] = {.lex_state = 0, .external_lex_state = 15},
  [2721] = {.lex_state = 0, .external_lex_state = 15},
  [2722] = {.lex_state = 0, .external_lex_state = 23},
  [2723] = {.lex_state = 0, .external_lex_state = 16},
  [2724] = {.lex_state = 0, .external_lex_state = 11},
  [2725] = {.lex_state = 0, .external_lex_state = 15},
  [2726] = {.lex_state = 0, .external_lex_state = 15},
  [2727] = {.lex_state = 0, .external_lex_state = 11},
  [2728] = {.lex_state = 0, .external_lex_state = 12},
  [2729] = {.lex_state = 0, .external_lex_state = 11},
  [2730] = {.lex_state = 0, .external_lex_state = 11},
  [2731] = {.lex_state = 0, .external_lex_state = 11},
  [2732] = {.lex_state = 0, .external_lex_state = 11},
  [2733] = {.lex_state = 0, .external_lex_state = 15},
  [2734] = {.lex_state = 0, .external_lex_state = 11},
  [2735] = {.lex_state = 0, .external_lex_state = 24},
  [2736] = {.lex_state = 0, .external_lex_state = 12},
  [2737] = {.lex_state = 0, .external_lex_state = 26},
  [2738] = {.lex_state = 0, .external_lex_state = 26},
  [2739] = {.lex_state = 0, .external_lex_state = 26},
  [2740] = {.lex_state = 0, .external_lex_state = 11},
  [2741] = {.lex_state = 0, .external_lex_state = 28},
  [2742] = {.lex_state = 0, .external_lex_state = 25},
  [2743] = {.lex_state = 0, .external_lex_state = 13},
  [2744] = {.lex_state = 0, .external_lex_state = 27},
  [2745] = {.lex_state = 0, .external_lex_state = 28},
  [2746] = {.lex_state = 0, .external_lex_state = 19},
  [2747] = {.lex_state = 0, .external_lex_state = 17},
  [2748] = {.lex_state = 0, .external_lex_state = 21},
  [2749] = {.lex_state = 0, .external_lex_state = 18},
  [2750] = {.lex_state = 0, .external_lex_state = 21},
  [2751] = {.lex_state = 0, .external_lex_state = 25},
  [2752] = {.lex_state = 0, .external_lex_state = 19},
  [2753] = {.lex_state = 0, .external_lex_state = 19},
  [2754] = {.lex_state = 0, .external_lex_state = 25},
  [2755] = {.lex_state = 0, .external_lex_state = 19},
  [2756] = {.lex_state = 0, .external_lex_state = 19},
  [2757] = {.lex_state = 0, .external_lex_state = 18},
  [2758] = {.lex_state = 0, .external_lex_state = 25},
  [2759] = {.lex_state = 0, .external_lex_state = 20},
  [2760] = {.lex_state = 0, .external_lex_state = 19},
  [2761] = {.lex_state = 0, .external_lex_state = 22},
  [2762] = {.lex_state = 0, .external_lex_state = 18},
  [2763] = {.lex_state = 0, .external_lex_state = 19},
  [2764] = {.lex_state = 0, .external_lex_state = 19},
  [2765] = {.lex_state = 0, .external_lex_state = 19},
  [2766] = {.lex_state = 0, .external_lex_state = 17},
  [2767] = {.lex_state = 0, .external_lex_state = 18},
  [2768] = {.lex_state = 0, .external_lex_state = 17},
  [2769] = {.lex_state = 0, .external_lex_state = 19},
  [2770] = {.lex_state = 0, .external_lex_state = 17},
  [2771] = {.lex_state = 0, .external_lex_state = 19},
  [2772] = {.lex_state = 0, .external_lex_state = 31},
  [2773] = {.lex_state = 0, .external_lex_state = 23},
  [2774] = {.lex_state = 0, .external_lex_state = 19},
  [2775] = {.lex_state = 0, .external_lex_state = 19},
  [2776] = {.lex_state = 0, .external_lex_state = 19},
  [2777] = {.lex_state = 0, .external_lex_state = 21},
  [2778] = {.lex_state = 0, .external_lex_state = 2},
  [2779] = {.lex_state = 0, .external_lex_state = 21},
  [2780] = {.lex_state = 0, .external_lex_state = 18},
  [2781] = {.lex_state = 0, .external_lex_state = 17},
  [2782] = {.lex_state = 0, .external_lex_state = 17},
  [2783] = {.lex_state = 0, .external_lex_state = 20},
  [2784] = {.lex_state = 0, .external_lex_state = 17},
  [2785] = {.lex_state = 0, .external_lex_state = 18},
  [2786] = {.lex_state = 0, .external_lex_state = 21},
  [2787] = {.lex_state = 0, .external_lex_state = 17},
  [2788] = {.lex_state = 0, .external_lex_state = 18},
  [2789] = {.lex_state = 0, .external_lex_state = 19},
  [2790] = {.lex_state = 0, .external_lex_state = 21},
  [2791] = {.lex_state = 0, .external_lex_state = 18},
  [2792] = {.lex_state = 0, .external_lex_state = 25},
  [2793] = {.lex_state = 0, .external_lex_state = 19},
  [2794] = {.lex_state = 0, .external_lex_state = 23},
  [2795] = {.lex_state = 0, .external_lex_state = 23},
  [2796] = {.lex_state = 0, .external_lex_state = 23},
  [2797] = {.lex_state = 0, .external_lex_state = 20},
  [2798] = {.lex_state = 0, .external_lex_state = 19},
  [2799] = {.lex_state = 0, .external_lex_state = 23},
  [2800] = {.lex_state = 0, .external_lex_state = 19},
  [2801] = {.lex_state = 0, .external_lex_state = 20},
  [2802] = {.lex_state = 0, .external_lex_state = 25},
  [2803] = {.lex_state = 0, .external_lex_state = 25},
  [2804] = {.lex_state = 0, .external_lex_state = 18},
  [2805] = {.lex_state = 0, .external_lex_state = 20},
  [2806] = {.lex_state = 0, .external_lex_state = 18},
  [2807] = {.lex_state = 0, .external_lex_state = 25},
  [2808] = {.lex_state = 0, .external_lex_state = 18},
  [2809] = {.lex_state = 0, .external_lex_state = 23},
  [2810] = {.lex_state = 0, .external_lex_state = 23},
  [2811] = {.lex_state = 0, .external_lex_state = 23},
  [2812] = {.lex_state = 0, .external_lex_state = 23},
  [2813] = {.lex_state = 0, .external_lex_state = 25},
  [2814] = {.lex_state = 0, .external_lex_state = 17},
  [2815] = {.lex_state = 0, .external_lex_state = 25},
  [2816] = {.lex_state = 0, .external_lex_state = 25},
  [2817] = {.lex_state = 0, .external_lex_state = 25},
  [2818] = {.lex_state = 0, .external_lex_state = 25},
  [2819] = {.lex_state = 0, .external_lex_state = 23},
  [2820] = {.lex_state = 0, .external_lex_state = 23},
  [2821] = {.lex_state = 0, .external_lex_state = 18},
  [2822] = {.lex_state = 0, .external_lex_state = 22},
  [2823] = {.lex_state = 0, .external_lex_state = 18},
  [2824] = {.lex_state = 0, .external_lex_state = 23},
  [2825] = {.lex_state = 0, .external_lex_state = 19},
  [2826] = {.lex_state = 0, .external_lex_state = 21},
  [2827] = {.lex_state = 0, .external_lex_state = 21},
  [2828] = {.lex_state = 0, .external_lex_state = 21},
  [2829] = {.lex_state = 0, .external_lex_state = 25},
  [2830] = {.lex_state = 0, .external_lex_state = 20},
  [2831] = {.lex_state = 0, .external_lex_state = 18},
  [2832] = {.lex_state = 0, .external_lex_state = 20},
  [2833] = {.lex_state = 0, .external_lex_state = 21},
  [2834] = {.lex_state = 0, .external_lex_state = 20},
  [2835] = {.lex_state = 0, .external_lex_state = 29},
  [2836] = {.lex_state = 0, .external_lex_state = 20},
  [2837] = {.lex_state = 0, .external_lex_state = 21},
  [2838] = {.lex_state = 0, .external_lex_state = 17},
  [2839] = {.lex_state = 0, .external_lex_state = 17},
  [2840] = {.lex_state = 0, .external_lex_state = 20},
  [2841] = {.lex_state = 0, .external_lex_state = 19},
  [2842] = {.lex_state = 0, .external_lex_state = 21},
  [2843] = {.lex_state = 0, .external_lex_state = 20},
  [2844] = {.lex_state = 0, .external_lex_state = 20},
  [2845] = {.lex_state = 0, .external_lex_state = 17},
  [2846] = {.lex_state = 0, .external_lex_state = 22},
  [2847] = {.lex_state = 0, .external_lex_state = 27},
  [2848] = {.lex_state = 0, .external_lex_state = 19},
  [2849] = {.lex_state = 0, .external_lex_state = 17},
  [2850] = {.lex_state = 0, .external_lex_state = 18},
  [2851] = {.lex_state = 0, .external_lex_state = 22},
  [2852] = {.lex_state = 0, .external_lex_state = 17},
  [2853] = {.lex_state = 0, .external_lex_state = 22},
  [2854] = {.lex_state = 0, .external_lex_state = 22},
  [2855] = {.lex_state = 0, .external_lex_state = 22},
  [2856] = {.lex_state = 0, .external_lex_state = 21},
  [2857] = {.lex_state = 0, .external_lex_state = 22},
  [2858] = {.lex_state = 0, .external_lex_state = 23},
  [2859] = {.lex_state = 0, .external_lex_state = 18},
  [2860] = {.lex_state = 0, .external_lex_state = 22},
  [2861] = {.lex_state = 0, .external_lex_state = 23},
  [2862] = {.lex_state = 0, .external_lex_state = 20},
  [2863] = {.lex_state = 0, .external_lex_state = 22},
  [2864] = {.lex_state = 0, .external_lex_state = 22},
  [2865] = {.lex_state = 0, .external_lex_state = 25},
  [2866] = {.lex_state = 0, .external_lex_state = 24},
  [2867] = {.lex_state = 0, .external_lex_state = 23},
  [2868] = {.lex_state = 0, .external_lex_state = 22},
  [2869] = {.lex_state = 0, .external_lex_state = 23},
  [2870] = {.lex_state = 0, .external_lex_state = 23},
  [2871] = {.lex_state = 0, .external_lex_state = 19},
  [2872] = {.lex_state = 0, .external_lex_state = 23},
  [2873] = {.lex_state = 0, .external_lex_state = 23},
  [2874] = {.lex_state = 0, .external_lex_state = 21},
  [2875] = {.lex_state = 0, .external_lex_state = 17},
  [2876] = {.lex_state = 0, .external_lex_state = 21},
  [2877] = {.lex_state = 0, .external_lex_state = 21},
  [2878] = {.lex_state = 0, .external_lex_state = 21},
  [2879] = {.lex_state = 0, .external_lex_state = 23},
  [2880] = {.lex_state = 0, .external_lex_state = 21},
  [2881] = {.lex_state = 0, .external_lex_state = 26},
  [2882] = {.lex_state = 0, .external_lex_state = 21},
  [2883] = {.lex_state = 0, .external_lex_state = 20},
  [2884] = {.lex_state = 0, .external_lex_state = 25},
  [2885] = {.lex_state = 0, .external_lex_state = 20},
  [2886] = {.lex_state = 0, .external_lex_state = 25},
  [2887] = {.lex_state = 0, .external_lex_state = 22},
  [2888] = {.lex_state = 0, .external_lex_state = 20},
  [2889] = {.lex_state = 0, .external_lex_state = 21},
  [2890] = {.lex_state = 0, .external_lex_state = 17},
  [2891] = {.lex_state = 0, .external_lex_state = 17},
  [2892] = {.lex_state = 0, .external_lex_state = 23},
  [2893] = {.lex_state = 0, .external_lex_state = 2},
  [2894] = {.lex_state = 0, .external_lex_state = 20},
  [2895] = {.lex_state = 0, .external_lex_state = 22},
  [2896] = {.lex_state = 0, .external_lex_state = 22},
  [2897] = {.lex_state = 0, .external_lex_state = 17},
  [2898] = {.lex_state = 0, .external_lex_state = 19},
  [2899] = {.lex_state = 0, .external_lex_state = 22},
  [2900] = {.lex_state = 0, .external_lex_state = 20},
  [2901] = {.lex_state = 0, .external_lex_state = 28},
  [2902] = {.lex_state = 0, .external_lex_state = 25},
  [2903] = {.lex_state = 0, .external_lex_state = 21},
  [2904] = {.lex_state = 0, .external_lex_state = 21},
  [2905] = {.lex_state = 0, .external_lex_state = 17},
  [2906] = {.lex_state = 0, .external_lex_state = 25},
  [2907] = {.lex_state = 0, .external_lex_state = 21},
  [2908] = {.lex_state = 0, .external_lex_state = 18},
  [2909] = {.lex_state = 0, .external_lex_state = 20},
  [2910] = {.lex_state = 0, .external_lex_state = 20},
  [2911] = {.lex_state = 0, .external_lex_state = 18},
  [2912] = {.lex_state = 0, .external_lex_state = 30},
  [2913] = {.lex_state = 0, .external_lex_state = 22},
  [2914] = {.lex_state = 0, .external_lex_state = 22},
  [2915] = {.lex_state = 0, .external_lex_state = 22},
  [2916] = {.lex_state = 0, .external_lex_state = 18},
  [2917] = {.lex_state = 0, .external_lex_state = 17},
  [2918] = {.lex_state = 0, .external_lex_state = 23},
  [2919] = {.lex_state = 0, .external_lex_state = 18},
  [2920] = {.lex_state = 0, .external_lex_state = 18},
  [2921] = {.lex_state = 0, .external_lex_state = 22},
  [2922] = {.lex_state = 0, .external_lex_state = 25},
  [2923] = {.lex_state = 0, .external_lex_state = 25},
  [2924] = {.lex_state = 0, .external_lex_state = 17},
  [2925] = {.lex_state = 0, .external_lex_state = 18},
  [2926] = {.lex_state = 0, .external_lex_state = 18},
  [2927] = {.lex_state = 0, .external_lex_state = 25},
  [2928] = {.lex_state = 0, .external_lex_state = 20},
  [2929] = {.lex_state = 0, .external_lex_state = 20},
  [2930] = {.lex_state = 0, .external_lex_state = 20},
  [2931] = {.lex_state = 0, .external_lex_state = 22},
  [2932] = {.lex_state = 0, .external_lex_state = 25},
  [2933] = {.lex_state = 0, .external_lex_state = 22},
  [2934] = {.lex_state = 0, .external_lex_state = 17},
  [2935] = {.lex_state = 0, .external_lex_state = 17},
  [2936] = {.lex_state = 0, .external_lex_state = 24},
  [2937] = {.lex_state = 0, .external_lex_state = 24},
  [2938] = {.lex_state = 0, .external_lex_state = 28},
  [2939] = {.lex_state = 0, .external_lex_state = 26},
  [2940] = {.lex_state = 0, .external_lex_state = 24},
  [2941] = {.lex_state = 0, .external_lex_state = 24},
  [2942] = {.lex_state = 0, .external_lex_state = 24},
  [2943] = {.lex_state = 0, .external_lex_state = 24},
  [2944] = {.lex_state = 0, .external_lex_state = 24},
  [2945] = {.lex_state = 0, .external_lex_state = 24},
  [2946] = {.lex_state = 0, .external_lex_state = 24},
  [2947] = {.lex_state = 0, .external_lex_state = 28},
  [2948] = {.lex_state = 0, .external_lex_state = 24},
  [2949] = {.lex_state = 0, .external_lex_state = 24},
  [2950] = {.lex_state = 0, .external_lex_state = 24},
  [2951] = {.lex_state = 0, .external_lex_state = 24},
  [2952] = {.lex_state = 0, .external_lex_state = 24},
  [2953] = {.lex_state = 0, .external_lex_state = 24},
  [2954] = {.lex_state = 0, .external_lex_state = 24},
  [2955] = {.lex_state = 0, .external_lex_state = 24},
  [2956] = {.lex_state = 0, .external_lex_state = 28},
  [2957] = {.lex_state = 0, .external_lex_state = 24},
  [2958] = {.lex_state = 0, .external_lex_state = 27},
  [2959] = {.lex_state = 0, .external_lex_state = 27},
  [2960] = {.lex_state = 0, .external_lex_state = 27},
  [2961] = {.lex_state = 0, .external_lex_state = 27},
  [2962] = {.lex_state = 0, .external_lex_state = 27},
  [2963] = {.lex_state = 0, .external_lex_state = 24},
  [2964] = {.lex_state = 0, .external_lex_state = 27},
  [2965] = {.lex_state = 0, .external_lex_state = 27},
  [2966] = {.lex_state = 0, .external_lex_state = 27},
  [2967] = {.lex_state = 0, .external_lex_state = 27},
  [2968] = {.lex_state = 0, .external_lex_state = 27},
  [2969] = {.lex_state = 0, .external_lex_state = 27},
  [2970] = {.lex_state = 0, .external_lex_state = 27},
  [2971] = {.lex_state = 0, .external_lex_state = 26},
  [2972] = {.lex_state = 0, .external_lex_state = 26},
  [2973] = {.lex_state = 0, .external_lex_state = 24},
  [2974] = {.lex_state = 0, .external_lex_state = 27},
  [2975] = {.lex_state = 0, .external_lex_state = 27},
  [2976] = {.lex_state = 0, .external_lex_state = 27},
  [2977] = {.lex_state = 0, .external_lex_state = 27},
  [2978] = {.lex_state = 0, .external_lex_state = 27},
  [2979] = {.lex_state = 0, .external_lex_state = 27},
  [2980] = {.lex_state = 0, .external_lex_state = 27},
  [2981] = {.lex_state = 0, .external_lex_state = 24},
  [2982] = {.lex_state = 0, .external_lex_state = 26},
  [2983] = {.lex_state = 0, .external_lex_state = 27},
  [2984] = {.lex_state = 0, .external_lex_state = 28},
  [2985] = {.lex_state = 0, .external_lex_state = 26},
  [2986] = {.lex_state = 0, .external_lex_state = 26},
  [2987] = {.lex_state = 0, .external_lex_state = 26},
  [2988] = {.lex_state = 0, .external_lex_state = 27},
  [2989] = {.lex_state = 0, .external_lex_state = 28},
  [2990] = {.lex_state = 0, .external_lex_state = 28},
  [2991] = {.lex_state = 0, .external_lex_state = 28},
  [2992] = {.lex_state = 0, .external_lex_state = 26},
  [2993] = {.lex_state = 0, .external_lex_state = 26},
  [2994] = {.lex_state = 0, .external_lex_state = 26},
  [2995] = {.lex_state = 0, .external_lex_state = 28},
  [2996] = {.lex_state = 0, .external_lex_state = 26},
  [2997] = {.lex_state = 0, .external_lex_state = 26},
  [2998] = {.lex_state = 0, .external_lex_state = 27},
  [2999] = {.lex_state = 0, .external_lex_state = 28},
  [3000] = {.lex_state = 0, .external_lex_state = 28},
  [3001] = {.lex_state = 0, .external_lex_state = 28},
  [3002] = {.lex_state = 0, .external_lex_state = 28},
  [3003] = {.lex_state = 0, .external_lex_state = 28},
  [3004] = {.lex_state = 0, .external_lex_state = 28},
  [3005] = {.lex_state = 0, .external_lex_state = 28},
  [3006] = {.lex_state = 0, .external_lex_state = 28},
  [3007] = {.lex_state = 0, .external_lex_state = 26},
  [3008] = {.lex_state = 0, .external_lex_state = 26},
  [3009] = {.lex_state = 0, .external_lex_state = 26},
  [3010] = {.lex_state = 0, .external_lex_state = 26},
  [3011] = {.lex_state = 0, .external_lex_state = 26},
  [3012] = {.lex_state = 0, .external_lex_state = 26},
  [3013] = {.lex_state = 0, .external_lex_state = 26},
  [3014] = {.lex_state = 0, .external_lex_state = 24},
  [3015] = {.lex_state = 0, .external_lex_state = 26},
  [3016] = {.lex_state = 0, .external_lex_state = 27},
  [3017] = {.lex_state = 0, .external_lex_state = 26},
  [3018] = {.lex_state = 0, .external_lex_state = 28},
  [3019] = {.lex_state = 0, .external_lex_state = 24},
  [3020] = {.lex_state = 0, .external_lex_state = 26},
  [3021] = {.lex_state = 0, .external_lex_state = 24},
  [3022] = {.lex_state = 0, .external_lex_state = 28},
  [3023] = {.lex_state = 0, .external_lex_state = 28},
  [3024] = {.lex_state = 0, .external_lex_state = 28},
  [3025] = {.lex_state = 0, .external_lex_state = 28},
  [3026] = {.lex_state = 0, .external_lex_state = 28},
  [3027] = {.lex_state = 0, .external_lex_state = 28},
  [3028] = {.lex_state = 0, .external_lex_state = 32},
  [3029] = {.lex_state = 0, .external_lex_state = 32},
  [3030] = {.lex_state = 0, .external_lex_state = 32},
  [3031] = {.lex_state = 0, .external_lex_state = 32},
  [3032] = {.lex_state = 0, .external_lex_state = 32},
  [3033] = {.lex_state = 0, .external_lex_state = 32},
  [3034] = {.lex_state = 0, .external_lex_state = 32},
  [3035] = {.lex_state = 0, .external_lex_state = 32},
  [3036] = {.lex_state = 0, .external_lex_state = 32},
  [3037] = {.lex_state = 0, .external_lex_state = 32},
  [3038] = {.lex_state = 0, .external_lex_state = 32},
  [3039] = {.lex_state = 0, .external_lex_state = 32},
  [3040] = {.lex_state = 0, .external_lex_state = 32},
  [3041] = {.lex_state = 0, .external_lex_state = 32},
  [3042] = {.lex_state = 0, .external_lex_state = 32},
  [3043] = {.lex_state = 0, .external_lex_state = 32},
  [3044] = {.lex_state = 0, .external_lex_state = 32},
  [3045] = {.lex_state = 0, .external_lex_state = 32},
  [3046] = {.lex_state = 0, .external_lex_state = 32},
  [3047] = {.lex_state = 0, .external_lex_state = 32},
  [3048] = {.lex_state = 0, .external_lex_state = 32},
  [3049] = {.lex_state = 0, .external_lex_state = 32},
  [3050] = {.lex_state = 0, .external_lex_state = 32},
  [3051] = {.lex_state = 0, .external_lex_state = 32},
  [3052] = {.lex_state = 0, .external_lex_state = 32},
  [3053] = {.lex_state = 0, .external_lex_state = 32},
  [3054] = {.lex_state = 0, .external_lex_state = 32},
  [3055] = {.lex_state = 0, .external_lex_state = 32},
  [3056] = {.lex_state = 0, .external_lex_state = 32},
  [3057] = {.lex_state = 0, .external_lex_state = 32},
  [3058] = {.lex_state = 0, .external_lex_state = 32},
  [3059] = {.lex_state = 0, .external_lex_state = 32},
  [3060] = {.lex_state = 0, .external_lex_state = 32},
  [3061] = {.lex_state = 0, .external_lex_state = 32},
  [3062] = {.lex_state = 0, .external_lex_state = 32},
  [3063] = {.lex_state = 0, .external_lex_state = 32},
  [3064] = {.lex_state = 0, .external_lex_state = 32},
  [3065] = {.lex_state = 0, .external_lex_state = 32},
  [3066] = {.lex_state = 0, .external_lex_state = 32},
  [3067] = {.lex_state = 0, .external_lex_state = 32},
  [3068] = {.lex_state = 0, .external_lex_state = 32},
  [3069] = {.lex_state = 0, .external_lex_state = 32},
  [3070] = {.lex_state = 0, .external_lex_state = 32},
  [3071] = {.lex_state = 0, .external_lex_state = 32},
  [3072] = {.lex_state = 0, .external_lex_state = 32},
  [3073] = {.lex_state = 0, .external_lex_state = 32},
  [3074] = {.lex_state = 0, .external_lex_state = 32},
  [3075] = {.lex_state = 0, .external_lex_state = 32},
  [3076] = {.lex_state = 0, .external_lex_state = 32},
  [3077] = {.lex_state = 0, .external_lex_state = 32},
  [3078] = {.lex_state = 0, .external_lex_state = 32},
  [3079] = {.lex_state = 0, .external_lex_state = 32},
  [3080] = {.lex_state = 0, .external_lex_state = 32},
  [3081] = {.lex_state = 0, .external_lex_state = 32},
  [3082] = {.lex_state = 0, .external_lex_state = 32},
  [3083] = {.lex_state = 0, .external_lex_state = 32},
  [3084] = {.lex_state = 0, .external_lex_state = 32},
  [3085] = {.lex_state = 0, .external_lex_state = 32},
  [3086] = {.lex_state = 0, .external_lex_state = 32},
  [3087] = {.lex_state = 0, .external_lex_state = 32},
  [3088] = {.lex_state = 0, .external_lex_state = 32},
  [3089] = {.lex_state = 0, .external_lex_state = 32},
  [3090] = {.lex_state = 0, .external_lex_state = 32},
  [3091] = {.lex_state = 0, .external_lex_state = 32},
  [3092] = {.lex_state = 0, .external_lex_state = 32},
  [3093] = {.lex_state = 0, .external_lex_state = 32},
  [3094] = {.lex_state = 0, .external_lex_state = 32},
  [3095] = {.lex_state = 0, .external_lex_state = 32},
  [3096] = {.lex_state = 0, .external_lex_state = 32},
  [3097] = {.lex_state = 0, .external_lex_state = 32},
  [3098] = {.lex_state = 0, .external_lex_state = 32},
  [3099] = {.lex_state = 0, .external_lex_state = 32},
  [3100] = {.lex_state = 0, .external_lex_state = 32},
  [3101] = {.lex_state = 0, .external_lex_state = 32},
  [3102] = {.lex_state = 0, .external_lex_state = 32},
  [3103] = {.lex_state = 0, .external_lex_state = 32},
  [3104] = {.lex_state = 0, .external_lex_state = 32},
  [3105] = {.lex_state = 0, .external_lex_state = 32},
  [3106] = {.lex_state = 0, .external_lex_state = 32},
  [3107] = {.lex_state = 0, .external_lex_state = 32},
  [3108] = {.lex_state = 0, .external_lex_state = 32},
  [3109] = {.lex_state = 0, .external_lex_state = 32},
  [3110] = {.lex_state = 0, .external_lex_state = 32},
  [3111] = {.lex_state = 0, .external_lex_state = 32},
  [3112] = {.lex_state = 0, .external_lex_state = 32},
  [3113] = {.lex_state = 0, .external_lex_state = 32},
  [3114] = {.lex_state = 0, .external_lex_state = 32},
  [3115] = {.lex_state = 0, .external_lex_state = 32},
  [3116] = {.lex_state = 0, .external_lex_state = 32},
  [3117] = {.lex_state = 0, .external_lex_state = 32},
  [3118] = {.lex_state = 0, .external_lex_state = 32},
  [3119] = {.lex_state = 0, .external_lex_state = 32},
  [3120] = {.lex_state = 0, .external_lex_state = 32},
  [3121] = {.lex_state = 0, .external_lex_state = 32},
  [3122] = {.lex_state = 0, .external_lex_state = 32},
  [3123] = {.lex_state = 0, .external_lex_state = 32},
  [3124] = {.lex_state = 0, .external_lex_state = 32},
  [3125] = {.lex_state = 0, .external_lex_state = 32},
  [3126] = {.lex_state = 0, .external_lex_state = 32},
  [3127] = {.lex_state = 0, .external_lex_state = 32},
  [3128] = {.lex_state = 0, .external_lex_state = 32},
  [3129] = {.lex_state = 0, .external_lex_state = 32},
  [3130] = {.lex_state = 0, .external_lex_state = 32},
  [3131] = {.lex_state = 0, .external_lex_state = 32},
  [3132] = {.lex_state = 0, .external_lex_state = 32},
  [3133] = {.lex_state = 0, .external_lex_state = 32},
  [3134] = {.lex_state = 0, .external_lex_state = 32},
  [3135] = {.lex_state = 0, .external_lex_state = 32},
  [3136] = {.lex_state = 0, .external_lex_state = 32},
  [3137] = {.lex_state = 0, .external_lex_state = 32},
  [3138] = {.lex_state = 0, .external_lex_state = 32},
  [3139] = {.lex_state = 0, .external_lex_state = 32},
  [3140] = {.lex_state = 0, .external_lex_state = 32},
  [3141] = {.lex_state = 0, .external_lex_state = 32},
  [3142] = {.lex_state = 0, .external_lex_state = 32},
  [3143] = {.lex_state = 0, .external_lex_state = 32},
  [3144] = {.lex_state = 0, .external_lex_state = 32},
  [3145] = {.lex_state = 0, .external_lex_state = 32},
  [3146] = {.lex_state = 0, .external_lex_state = 32},
  [3147] = {.lex_state = 0, .external_lex_state = 32},
  [3148] = {.lex_state = 0, .external_lex_state = 32},
  [3149] = {.lex_state = 0, .external_lex_state = 32},
  [3150] = {.lex_state = 0, .external_lex_state = 32},
  [3151] = {.lex_state = 0, .external_lex_state = 32},
  [3152] = {.lex_state = 0, .external_lex_state = 32},
  [3153] = {.lex_state = 0, .external_lex_state = 32},
  [3154] = {.lex_state = 0, .external_lex_state = 32},
  [3155] = {.lex_state = 0, .external_lex_state = 32},
  [3156] = {.lex_state = 0, .external_lex_state = 32},
  [3157] = {.lex_state = 0, .external_lex_state = 32},
  [3158] = {.lex_state = 0, .external_lex_state = 32},
  [3159] = {.lex_state = 0, .external_lex_state = 32},
  [3160] = {.lex_state = 0, .external_lex_state = 32},
  [3161] = {.lex_state = 0, .external_lex_state = 32},
  [3162] = {.lex_state = 0, .external_lex_state = 32},
  [3163] = {.lex_state = 0, .external_lex_state = 32},
  [3164] = {.lex_state = 0, .external_lex_state = 32},
  [3165] = {.lex_state = 0, .external_lex_state = 32},
  [3166] = {.lex_state = 0, .external_lex_state = 32},
  [3167] = {.lex_state = 0, .external_lex_state = 32},
  [3168] = {.lex_state = 0, .external_lex_state = 32},
  [3169] = {.lex_state = 0, .external_lex_state = 32},
  [3170] = {.lex_state = 0, .external_lex_state = 32},
  [3171] = {.lex_state = 0, .external_lex_state = 32},
  [3172] = {.lex_state = 0, .external_lex_state = 32},
  [3173] = {.lex_state = 0, .external_lex_state = 32},
  [3174] = {.lex_state = 0, .external_lex_state = 32},
  [3175] = {.lex_state = 0, .external_lex_state = 32},
  [3176] = {.lex_state = 0, .external_lex_state = 32},
  [3177] = {.lex_state = 0, .external_lex_state = 32},
  [3178] = {.lex_state = 0, .external_lex_state = 32},
  [3179] = {.lex_state = 0, .external_lex_state = 32},
  [3180] = {.lex_state = 0, .external_lex_state = 32},
  [3181] = {.lex_state = 0, .external_lex_state = 32},
  [3182] = {.lex_state = 0, .external_lex_state = 32},
  [3183] = {.lex_state = 0, .external_lex_state = 32},
  [3184] = {.lex_state = 0, .external_lex_state = 32},
  [3185] = {.lex_state = 0, .external_lex_state = 32},
  [3186] = {.lex_state = 0, .external_lex_state = 32},
  [3187] = {.lex_state = 0, .external_lex_state = 32},
  [3188] = {.lex_state = 0, .external_lex_state = 32},
  [3189] = {.lex_state = 0, .external_lex_state = 32},
  [3190] = {.lex_state = 0, .external_lex_state = 32},
  [3191] = {.lex_state = 0, .external_lex_state = 32},
  [3192] = {.lex_state = 0, .external_lex_state = 32},
  [3193] = {.lex_state = 0, .external_lex_state = 32},
  [3194] = {.lex_state = 0, .external_lex_state = 32},
  [3195] = {.lex_state = 0, .external_lex_state = 32},
  [3196] = {.lex_state = 0, .external_lex_state = 32},
  [3197] = {.lex_state = 0, .external_lex_state = 32},
  [3198] = {.lex_state = 0, .external_lex_state = 32},
  [3199] = {.lex_state = 0, .external_lex_state = 32},
  [3200] = {.lex_state = 0, .external_lex_state = 32},
  [3201] = {.lex_state = 0, .external_lex_state = 32},
  [3202] = {.lex_state = 0, .external_lex_state = 32},
  [3203] = {.lex_state = 0, .external_lex_state = 32},
  [3204] = {.lex_state = 0, .external_lex_state = 32},
  [3205] = {.lex_state = 0, .external_lex_state = 32},
  [3206] = {.lex_state = 0, .external_lex_state = 32},
  [3207] = {.lex_state = 0, .external_lex_state = 32},
  [3208] = {.lex_state = 0, .external_lex_state = 32},
  [3209] = {.lex_state = 0, .external_lex_state = 32},
  [3210] = {.lex_state = 0, .external_lex_state = 32},
  [3211] = {.lex_state = 0, .external_lex_state = 32},
  [3212] = {.lex_state = 0, .external_lex_state = 32},
  [3213] = {.lex_state = 0, .external_lex_state = 32},
  [3214] = {.lex_state = 0, .external_lex_state = 32},
  [3215] = {.lex_state = 0, .external_lex_state = 32},
  [3216] = {.lex_state = 0, .external_lex_state = 32},
  [3217] = {.lex_state = 0, .external_lex_state = 32},
  [3218] = {.lex_state = 0, .external_lex_state = 32},
  [3219] = {.lex_state = 0, .external_lex_state = 32},
  [3220] = {.lex_state = 0, .external_lex_state = 32},
  [3221] = {.lex_state = 0, .external_lex_state = 32},
  [3222] = {.lex_state = 0, .external_lex_state = 32},
  [3223] = {.lex_state = 0, .external_lex_state = 32},
  [3224] = {.lex_state = 0, .external_lex_state = 32},
  [3225] = {.lex_state = 0, .external_lex_state = 32},
  [3226] = {.lex_state = 0, .external_lex_state = 32},
  [3227] = {.lex_state = 0, .external_lex_state = 32},
  [3228] = {.lex_state = 0, .external_lex_state = 32},
  [3229] = {.lex_state = 0, .external_lex_state = 32},
  [3230] = {.lex_state = 0, .external_lex_state = 32},
  [3231] = {.lex_state = 0, .external_lex_state = 32},
  [3232] = {.lex_state = 0, .external_lex_state = 32},
  [3233] = {.lex_state = 0, .external_lex_state = 32},
  [3234] = {.lex_state = 0, .external_lex_state = 32},
  [3235] = {.lex_state = 0, .external_lex_state = 32},
  [3236] = {.lex_state = 0, .external_lex_state = 32},
  [3237] = {.lex_state = 0, .external_lex_state = 32},
  [3238] = {.lex_state = 0, .external_lex_state = 32},
  [3239] = {.lex_state = 0, .external_lex_state = 32},
  [3240] = {.lex_state = 0, .external_lex_state = 32},
  [3241] = {.lex_state = 0, .external_lex_state = 32},
  [3242] = {.lex_state = 0, .external_lex_state = 32},
  [3243] = {.lex_state = 0, .external_lex_state = 32},
  [3244] = {.lex_state = 0, .external_lex_state = 32},
  [3245] = {.lex_state = 0, .external_lex_state = 32},
  [3246] = {.lex_state = 0, .external_lex_state = 32},
  [3247] = {.lex_state = 0, .external_lex_state = 32},
  [3248] = {.lex_state = 0, .external_lex_state = 32},
  [3249] = {.lex_state = 0, .external_lex_state = 32},
  [3250] = {.lex_state = 0, .external_lex_state = 32},
  [3251] = {.lex_state = 0, .external_lex_state = 32},
  [3252] = {.lex_state = 0, .external_lex_state = 32},
  [3253] = {.lex_state = 0, .external_lex_state = 32},
  [3254] = {.lex_state = 0, .external_lex_state = 32},
  [3255] = {.lex_state = 0, .external_lex_state = 32},
  [3256] = {.lex_state = 0, .external_lex_state = 32},
  [3257] = {.lex_state = 0, .external_lex_state = 32},
  [3258] = {.lex_state = 0, .external_lex_state = 32},
  [3259] = {.lex_state = 0, .external_lex_state = 32},
  [3260] = {.lex_state = 0, .external_lex_state = 32},
  [3261] = {.lex_state = 0, .external_lex_state = 32},
  [3262] = {.lex_state = 0, .external_lex_state = 32},
  [3263] = {.lex_state = 0, .external_lex_state = 32},
  [3264] = {.lex_state = 0, .external_lex_state = 32},
  [3265] = {.lex_state = 0, .external_lex_state = 32},
  [3266] = {.lex_state = 0, .external_lex_state = 32},
  [3267] = {.lex_state = 0, .external_lex_state = 32},
  [3268] = {.lex_state = 0, .external_lex_state = 32},
  [3269] = {.lex_state = 0, .external_lex_state = 32},
  [3270] = {.lex_state = 0, .external_lex_state = 32},
  [3271] = {.lex_state = 0, .external_lex_state = 32},
  [3272] = {.lex_state = 0, .external_lex_state = 32},
  [3273] = {.lex_state = 0, .external_lex_state = 32},
  [3274] = {.lex_state = 0, .external_lex_state = 32},
  [3275] = {.lex_state = 0, .external_lex_state = 32},
  [3276] = {.lex_state = 0, .external_lex_state = 32},
  [3277] = {.lex_state = 0, .external_lex_state = 32},
  [3278] = {.lex_state = 0, .external_lex_state = 32},
  [3279] = {.lex_state = 0, .external_lex_state = 32},
  [3280] = {.lex_state = 0, .external_lex_state = 32},
  [3281] = {.lex_state = 0, .external_lex_state = 32},
  [3282] = {.lex_state = 0, .external_lex_state = 32},
  [3283] = {.lex_state = 0, .external_lex_state = 32},
  [3284] = {.lex_state = 0, .external_lex_state = 32},
  [3285] = {.lex_state = 0, .external_lex_state = 32},
  [3286] = {.lex_state = 0, .external_lex_state = 32},
  [3287] = {.lex_state = 0, .external_lex_state = 32},
  [3288] = {.lex_state = 0, .external_lex_state = 32},
  [3289] = {.lex_state = 0, .external_lex_state = 32},
  [3290] = {.lex_state = 0, .external_lex_state = 32},
  [3291] = {.lex_state = 0, .external_lex_state = 32},
  [3292] = {.lex_state = 0, .external_lex_state = 32},
  [3293] = {.lex_state = 0, .external_lex_state = 32},
  [3294] = {.lex_state = 0, .external_lex_state = 32},
  [3295] = {.lex_state = 0, .external_lex_state = 32},
  [3296] = {.lex_state = 0, .external_lex_state = 32},
  [3297] = {.lex_state = 0, .external_lex_state = 32},
  [3298] = {.lex_state = 0, .external_lex_state = 32},
  [3299] = {.lex_state = 0, .external_lex_state = 32},
  [3300] = {.lex_state = 0, .external_lex_state = 32},
  [3301] = {.lex_state = 0, .external_lex_state = 32},
  [3302] = {.lex_state = 0, .external_lex_state = 32},
  [3303] = {.lex_state = 0, .external_lex_state = 32},
  [3304] = {.lex_state = 0, .external_lex_state = 32},
  [3305] = {.lex_state = 0, .external_lex_state = 32},
  [3306] = {.lex_state = 0, .external_lex_state = 32},
  [3307] = {.lex_state = 0, .external_lex_state = 32},
  [3308] = {.lex_state = 0, .external_lex_state = 32},
  [3309] = {.lex_state = 0, .external_lex_state = 32},
  [3310] = {.lex_state = 0, .external_lex_state = 32},
  [3311] = {.lex_state = 0, .external_lex_state = 32},
  [3312] = {.lex_state = 0, .external_lex_state = 32},
  [3313] = {.lex_state = 0, .external_lex_state = 32},
  [3314] = {.lex_state = 0, .external_lex_state = 32},
  [3315] = {.lex_state = 0, .external_lex_state = 32},
  [3316] = {.lex_state = 0, .external_lex_state = 32},
  [3317] = {.lex_state = 0, .external_lex_state = 32},
  [3318] = {.lex_state = 0, .external_lex_state = 32},
  [3319] = {.lex_state = 0, .external_lex_state = 32},
  [3320] = {.lex_state = 0, .external_lex_state = 32},
  [3321] = {.lex_state = 0, .external_lex_state = 32},
  [3322] = {.lex_state = 0, .external_lex_state = 32},
  [3323] = {.lex_state = 0, .external_lex_state = 32},
  [3324] = {.lex_state = 0, .external_lex_state = 32},
  [3325] = {.lex_state = 0, .external_lex_state = 32},
  [3326] = {.lex_state = 0, .external_lex_state = 32},
  [3327] = {.lex_state = 0, .external_lex_state = 32},
  [3328] = {.lex_state = 0, .external_lex_state = 32},
  [3329] = {.lex_state = 0, .external_lex_state = 32},
  [3330] = {.lex_state = 0, .external_lex_state = 32},
  [3331] = {.lex_state = 0, .external_lex_state = 32},
  [3332] = {.lex_state = 0, .external_lex_state = 32},
  [3333] = {.lex_state = 0, .external_lex_state = 32},
  [3334] = {.lex_state = 0, .external_lex_state = 32},
  [3335] = {.lex_state = 0, .external_lex_state = 32},
  [3336] = {.lex_state = 0, .external_lex_state = 32},
  [3337] = {.lex_state = 0, .external_lex_state = 32},
  [3338] = {.lex_state = 0, .external_lex_state = 32},
  [3339] = {.lex_state = 0, .external_lex_state = 32},
  [3340] = {.lex_state = 0, .external_lex_state = 32},
  [3341] = {.lex_state = 0, .external_lex_state = 32},
  [3342] = {.lex_state = 0, .external_lex_state = 32},
  [3343] = {.lex_state = 0, .external_lex_state = 32},
  [3344] = {.lex_state = 0, .external_lex_state = 32},
  [3345] = {.lex_state = 0, .external_lex_state = 32},
  [3346] = {.lex_state = 0, .external_lex_state = 32},
  [3347] = {.lex_state = 0, .external_lex_state = 32},
  [3348] = {.lex_state = 0, .external_lex_state = 32},
  [3349] = {.lex_state = 0, .external_lex_state = 32},
  [3350] = {.lex_state = 0, .external_lex_state = 32},
  [3351] = {.lex_state = 0, .external_lex_state = 32},
  [3352] = {.lex_state = 0, .external_lex_state = 32},
  [3353] = {.lex_state = 0, .external_lex_state = 32},
  [3354] = {.lex_state = 0, .external_lex_state = 32},
  [3355] = {.lex_state = 0, .external_lex_state = 32},
  [3356] = {.lex_state = 0, .external_lex_state = 32},
  [3357] = {.lex_state = 0, .external_lex_state = 32},
  [3358] = {.lex_state = 0, .external_lex_state = 32},
  [3359] = {.lex_state = 0, .external_lex_state = 32},
  [3360] = {.lex_state = 0, .external_lex_state = 32},
  [3361] = {.lex_state = 0, .external_lex_state = 32},
  [3362] = {.lex_state = 0, .external_lex_state = 32},
  [3363] = {.lex_state = 0, .external_lex_state = 32},
  [3364] = {.lex_state = 0, .external_lex_state = 32},
  [3365] = {.lex_state = 0, .external_lex_state = 32},
  [3366] = {.lex_state = 0, .external_lex_state = 32},
  [3367] = {.lex_state = 0, .external_lex_state = 32},
  [3368] = {.lex_state = 0, .external_lex_state = 32},
  [3369] = {.lex_state = 0, .external_lex_state = 32},
  [3370] = {.lex_state = 0, .external_lex_state = 32},
  [3371] = {.lex_state = 0, .external_lex_state = 32},
  [3372] = {.lex_state = 0, .external_lex_state = 32},
  [3373] = {.lex_state = 0, .external_lex_state = 32},
  [3374] = {.lex_state = 0, .external_lex_state = 32},
  [3375] = {.lex_state = 0, .external_lex_state = 32},
  [3376] = {.lex_state = 0, .external_lex_state = 32},
  [3377] = {.lex_state = 0, .external_lex_state = 32},
  [3378] = {.lex_state = 0, .external_lex_state = 32},
  [3379] = {.lex_state = 0, .external_lex_state = 32},
  [3380] = {.lex_state = 0, .external_lex_state = 32},
  [3381] = {.lex_state = 0, .external_lex_state = 32},
  [3382] = {.lex_state = 0, .external_lex_state = 32},
  [3383] = {.lex_state = 0, .external_lex_state = 32},
  [3384] = {.lex_state = 0, .external_lex_state = 32},
  [3385] = {.lex_state = 0, .external_lex_state = 32},
  [3386] = {.lex_state = 0, .external_lex_state = 32},
  [3387] = {.lex_state = 0, .external_lex_state = 32},
  [3388] = {.lex_state = 0, .external_lex_state = 32},
  [3389] = {.lex_state = 0, .external_lex_state = 32},
  [3390] = {.lex_state = 0, .external_lex_state = 32},
  [3391] = {.lex_state = 0, .external_lex_state = 32},
  [3392] = {.lex_state = 0, .external_lex_state = 32},
  [3393] = {.lex_state = 0, .external_lex_state = 32},
  [3394] = {.lex_state = 0, .external_lex_state = 32},
  [3395] = {.lex_state = 0, .external_lex_state = 32},
  [3396] = {.lex_state = 0, .external_lex_state = 32},
  [3397] = {.lex_state = 0, .external_lex_state = 32},
  [3398] = {.lex_state = 0, .external_lex_state = 32},
  [3399] = {.lex_state = 0, .external_lex_state = 32},
  [3400] = {.lex_state = 0, .external_lex_state = 32},
  [3401] = {.lex_state = 0, .external_lex_state = 32},
  [3402] = {.lex_state = 0, .external_lex_state = 32},
  [3403] = {.lex_state = 0, .external_lex_state = 32},
  [3404] = {.lex_state = 0, .external_lex_state = 32},
  [3405] = {.lex_state = 0, .external_lex_state = 32},
  [3406] = {.lex_state = 0, .external_lex_state = 32},
  [3407] = {.lex_state = 0, .external_lex_state = 32},
  [3408] = {.lex_state = 0, .external_lex_state = 32},
  [3409] = {.lex_state = 0, .external_lex_state = 32},
  [3410] = {.lex_state = 0, .external_lex_state = 32},
  [3411] = {.lex_state = 0, .external_lex_state = 32},
  [3412] = {.lex_state = 0, .external_lex_state = 32},
  [3413] = {.lex_state = 0, .external_lex_state = 32},
  [3414] = {.lex_state = 0, .external_lex_state = 32},
  [3415] = {.lex_state = 0, .external_lex_state = 32},
  [3416] = {.lex_state = 0, .external_lex_state = 32},
  [3417] = {.lex_state = 0, .external_lex_state = 32},
  [3418] = {.lex_state = 0, .external_lex_state = 32},
  [3419] = {.lex_state = 0, .external_lex_state = 32},
  [3420] = {.lex_state = 0, .external_lex_state = 32},
  [3421] = {.lex_state = 0, .external_lex_state = 32},
  [3422] = {.lex_state = 0, .external_lex_state = 32},
  [3423] = {.lex_state = 0, .external_lex_state = 32},
  [3424] = {.lex_state = 0, .external_lex_state = 32},
  [3425] = {.lex_state = 0, .external_lex_state = 32},
  [3426] = {.lex_state = 0, .external_lex_state = 32},
  [3427] = {.lex_state = 0, .external_lex_state = 32},
  [3428] = {.lex_state = 0, .external_lex_state = 32},
  [3429] = {.lex_state = 0, .external_lex_state = 32},
  [3430] = {.lex_state = 0, .external_lex_state = 32},
  [3431] = {.lex_state = 0, .external_lex_state = 32},
  [3432] = {.lex_state = 0, .external_lex_state = 32},
  [3433] = {.lex_state = 0, .external_lex_state = 32},
  [3434] = {.lex_state = 0, .external_lex_state = 32},
  [3435] = {.lex_state = 0, .external_lex_state = 32},
  [3436] = {.lex_state = 0, .external_lex_state = 32},
  [3437] = {.lex_state = 0, .external_lex_state = 32},
  [3438] = {.lex_state = 0, .external_lex_state = 32},
  [3439] = {.lex_state = 0, .external_lex_state = 32},
  [3440] = {.lex_state = 0, .external_lex_state = 32},
  [3441] = {.lex_state = 0, .external_lex_state = 32},
  [3442] = {.lex_state = 0, .external_lex_state = 32},
  [3443] = {.lex_state = 0, .external_lex_state = 32},
  [3444] = {.lex_state = 0, .external_lex_state = 32},
  [3445] = {.lex_state = 0, .external_lex_state = 32},
  [3446] = {.lex_state = 0, .external_lex_state = 32},
  [3447] = {.lex_state = 0, .external_lex_state = 32},
  [3448] = {.lex_state = 0, .external_lex_state = 32},
  [3449] = {.lex_state = 0, .external_lex_state = 32},
  [3450] = {.lex_state = 0, .external_lex_state = 32},
  [3451] = {.lex_state = 0, .external_lex_state = 32},
  [3452] = {.lex_state = 0, .external_lex_state = 32},
  [3453] = {.lex_state = 0, .external_lex_state = 32},
  [3454] = {.lex_state = 0, .external_lex_state = 32},
  [3455] = {.lex_state = 0, .external_lex_state = 32},
  [3456] = {.lex_state = 0, .external_lex_state = 32},
  [3457] = {.lex_state = 0, .external_lex_state = 32},
  [3458] = {.lex_state = 0, .external_lex_state = 32},
  [3459] = {.lex_state = 0, .external_lex_state = 32},
  [3460] = {.lex_state = 0, .external_lex_state = 32},
  [3461] = {.lex_state = 0, .external_lex_state = 32},
  [3462] = {.lex_state = 0, .external_lex_state = 32},
  [3463] = {.lex_state = 0, .external_lex_state = 32},
  [3464] = {.lex_state = 0, .external_lex_state = 32},
  [3465] = {.lex_state = 0, .external_lex_state = 32},
  [3466] = {.lex_state = 0, .external_lex_state = 32},
  [3467] = {.lex_state = 0, .external_lex_state = 32},
  [3468] = {.lex_state = 0, .external_lex_state = 32},
  [3469] = {.lex_state = 0, .external_lex_state = 32},
  [3470] = {.lex_state = 0, .external_lex_state = 32},
  [3471] = {.lex_state = 0, .external_lex_state = 32},
  [3472] = {.lex_state = 0, .external_lex_state = 32},
  [3473] = {.lex_state = 0, .external_lex_state = 32},
  [3474] = {.lex_state = 0, .external_lex_state = 32},
  [3475] = {.lex_state = 0, .external_lex_state = 32},
  [3476] = {.lex_state = 0, .external_lex_state = 32},
  [3477] = {.lex_state = 0, .external_lex_state = 32},
  [3478] = {.lex_state = 0, .external_lex_state = 32},
  [3479] = {.lex_state = 0, .external_lex_state = 32},
  [3480] = {.lex_state = 0, .external_lex_state = 32},
  [3481] = {.lex_state = 0, .external_lex_state = 32},
  [3482] = {.lex_state = 0, .external_lex_state = 32},
  [3483] = {.lex_state = 0, .external_lex_state = 32},
  [3484] = {.lex_state = 0, .external_lex_state = 32},
  [3485] = {.lex_state = 0, .external_lex_state = 32},
  [3486] = {.lex_state = 0, .external_lex_state = 32},
  [3487] = {.lex_state = 0, .external_lex_state = 32},
  [3488] = {.lex_state = 0, .external_lex_state = 32},
  [3489] = {.lex_state = 0, .external_lex_state = 32},
  [3490] = {.lex_state = 0, .external_lex_state = 32},
  [3491] = {.lex_state = 0, .external_lex_state = 32},
  [3492] = {.lex_state = 0, .external_lex_state = 32},
  [3493] = {.lex_state = 0, .external_lex_state = 32},
  [3494] = {.lex_state = 0, .external_lex_state = 32},
  [3495] = {.lex_state = 0, .external_lex_state = 32},
  [3496] = {.lex_state = 0, .external_lex_state = 32},
  [3497] = {.lex_state = 0, .external_lex_state = 32},
  [3498] = {.lex_state = 0, .external_lex_state = 32},
  [3499] = {.lex_state = 0, .external_lex_state = 32},
  [3500] = {.lex_state = 0, .external_lex_state = 32},
  [3501] = {.lex_state = 0, .external_lex_state = 32},
  [3502] = {.lex_state = 0, .external_lex_state = 32},
  [3503] = {.lex_state = 0, .external_lex_state = 32},
  [3504] = {.lex_state = 0, .external_lex_state = 32},
  [3505] = {.lex_state = 0, .external_lex_state = 32},
  [3506] = {.lex_state = 0, .external_lex_state = 32},
  [3507] = {.lex_state = 0, .external_lex_state = 32},
  [3508] = {.lex_state = 0, .external_lex_state = 32},
  [3509] = {.lex_state = 0, .external_lex_state = 32},
  [3510] = {.lex_state = 0, .external_lex_state = 32},
  [3511] = {.lex_state = 0, .external_lex_state = 32},
  [3512] = {.lex_state = 0, .external_lex_state = 32},
  [3513] = {.lex_state = 0, .external_lex_state = 32},
  [3514] = {.lex_state = 0, .external_lex_state = 32},
  [3515] = {.lex_state = 0, .external_lex_state = 32},
  [3516] = {.lex_state = 0, .external_lex_state = 32},
  [3517] = {.lex_state = 0, .external_lex_state = 32},
  [3518] = {.lex_state = 0, .external_lex_state = 32},
  [3519] = {.lex_state = 0, .external_lex_state = 32},
  [3520] = {.lex_state = 0, .external_lex_state = 32},
  [3521] = {.lex_state = 0, .external_lex_state = 32},
  [3522] = {.lex_state = 0, .external_lex_state = 32},
  [3523] = {.lex_state = 0, .external_lex_state = 32},
  [3524] = {.lex_state = 0, .external_lex_state = 32},
  [3525] = {.lex_state = 0, .external_lex_state = 32},
  [3526] = {.lex_state = 0, .external_lex_state = 32},
  [3527] = {.lex_state = 0, .external_lex_state = 32},
  [3528] = {.lex_state = 0, .external_lex_state = 32},
  [3529] = {.lex_state = 0, .external_lex_state = 32},
  [3530] = {.lex_state = 0, .external_lex_state = 32},
  [3531] = {.lex_state = 0, .external_lex_state = 32},
  [3532] = {.lex_state = 0, .external_lex_state = 32},
  [3533] = {.lex_state = 0, .external_lex_state = 32},
  [3534] = {.lex_state = 0, .external_lex_state = 32},
  [3535] = {.lex_state = 0, .external_lex_state = 32},
  [3536] = {.lex_state = 0, .external_lex_state = 32},
  [3537] = {.lex_state = 0, .external_lex_state = 32},
  [3538] = {.lex_state = 0, .external_lex_state = 32},
  [3539] = {.lex_state = 0, .external_lex_state = 32},
  [3540] = {.lex_state = 0, .external_lex_state = 32},
  [3541] = {.lex_state = 0, .external_lex_state = 32},
  [3542] = {.lex_state = 0, .external_lex_state = 32},
  [3543] = {.lex_state = 0, .external_lex_state = 32},
  [3544] = {.lex_state = 0, .external_lex_state = 32},
  [3545] = {.lex_state = 0, .external_lex_state = 32},
  [3546] = {.lex_state = 0, .external_lex_state = 32},
  [3547] = {.lex_state = 0, .external_lex_state = 32},
  [3548] = {.lex_state = 0, .external_lex_state = 32},
  [3549] = {.lex_state = 0, .external_lex_state = 32},
  [3550] = {.lex_state = 0, .external_lex_state = 32},
  [3551] = {.lex_state = 0, .external_lex_state = 32},
  [3552] = {.lex_state = 0, .external_lex_state = 32},
  [3553] = {.lex_state = 0, .external_lex_state = 32},
  [3554] = {.lex_state = 0, .external_lex_state = 32},
  [3555] = {.lex_state = 0, .external_lex_state = 32},
  [3556] = {.lex_state = 0, .external_lex_state = 32},
  [3557] = {.lex_state = 0, .external_lex_state = 32},
  [3558] = {.lex_state = 0, .external_lex_state = 32},
  [3559] = {.lex_state = 0, .external_lex_state = 32},
  [3560] = {.lex_state = 0, .external_lex_state = 32},
  [3561] = {.lex_state = 0, .external_lex_state = 32},
  [3562] = {.lex_state = 0, .external_lex_state = 32},
  [3563] = {.lex_state = 0, .external_lex_state = 32},
  [3564] = {.lex_state = 0, .external_lex_state = 32},
  [3565] = {.lex_state = 0, .external_lex_state = 32},
  [3566] = {.lex_state = 0, .external_lex_state = 32},
  [3567] = {.lex_state = 0, .external_lex_state = 32},
  [3568] = {.lex_state = 0, .external_lex_state = 32},
  [3569] = {.lex_state = 0, .external_lex_state = 32},
  [3570] = {.lex_state = 0, .external_lex_state = 32},
  [3571] = {.lex_state = 0, .external_lex_state = 32},
  [3572] = {.lex_state = 0, .external_lex_state = 32},
  [3573] = {.lex_state = 0, .external_lex_state = 32},
  [3574] = {.lex_state = 0, .external_lex_state = 32},
  [3575] = {.lex_state = 0, .external_lex_state = 32},
  [3576] = {.lex_state = 0, .external_lex_state = 32},
  [3577] = {.lex_state = 0, .external_lex_state = 32},
  [3578] = {.lex_state = 0, .external_lex_state = 32},
  [3579] = {.lex_state = 0, .external_lex_state = 32},
  [3580] = {.lex_state = 0, .external_lex_state = 32},
  [3581] = {.lex_state = 0, .external_lex_state = 32},
  [3582] = {.lex_state = 0, .external_lex_state = 32},
  [3583] = {.lex_state = 0, .external_lex_state = 32},
  [3584] = {.lex_state = 0, .external_lex_state = 32},
  [3585] = {.lex_state = 0, .external_lex_state = 32},
  [3586] = {.lex_state = 0, .external_lex_state = 32},
  [3587] = {.lex_state = 0, .external_lex_state = 32},
  [3588] = {.lex_state = 0, .external_lex_state = 32},
  [3589] = {.lex_state = 0, .external_lex_state = 32},
  [3590] = {.lex_state = 0, .external_lex_state = 32},
  [3591] = {.lex_state = 0, .external_lex_state = 32},
  [3592] = {.lex_state = 0, .external_lex_state = 32},
  [3593] = {.lex_state = 0, .external_lex_state = 32},
  [3594] = {.lex_state = 0, .external_lex_state = 32},
  [3595] = {.lex_state = 0, .external_lex_state = 32},
  [3596] = {.lex_state = 0, .external_lex_state = 32},
  [3597] = {.lex_state = 0, .external_lex_state = 32},
  [3598] = {.lex_state = 0, .external_lex_state = 32},
  [3599] = {.lex_state = 0, .external_lex_state = 32},
  [3600] = {.lex_state = 0, .external_lex_state = 32},
  [3601] = {.lex_state = 0, .external_lex_state = 32},
  [3602] = {.lex_state = 0, .external_lex_state = 32},
  [3603] = {.lex_state = 0, .external_lex_state = 32},
  [3604] = {.lex_state = 0, .external_lex_state = 32},
  [3605] = {.lex_state = 0, .external_lex_state = 32},
  [3606] = {.lex_state = 0, .external_lex_state = 32},
  [3607] = {.lex_state = 0, .external_lex_state = 32},
  [3608] = {.lex_state = 0, .external_lex_state = 32},
  [3609] = {.lex_state = 0, .external_lex_state = 32},
  [3610] = {.lex_state = 0, .external_lex_state = 32},
  [3611] = {.lex_state = 0, .external_lex_state = 32},
  [3612] = {.lex_state = 0, .external_lex_state = 32},
  [3613] = {.lex_state = 0, .external_lex_state = 32},
  [3614] = {.lex_state = 0, .external_lex_state = 32},
  [3615] = {.lex_state = 0, .external_lex_state = 32},
  [3616] = {.lex_state = 0, .external_lex_state = 32},
  [3617] = {.lex_state = 0, .external_lex_state = 32},
  [3618] = {.lex_state = 0, .external_lex_state = 32},
  [3619] = {.lex_state = 0, .external_lex_state = 32},
  [3620] = {.lex_state = 0, .external_lex_state = 32},
  [3621] = {.lex_state = 0, .external_lex_state = 32},
  [3622] = {.lex_state = 0, .external_lex_state = 32},
  [3623] = {.lex_state = 0, .external_lex_state = 32},
  [3624] = {.lex_state = 0, .external_lex_state = 32},
  [3625] = {.lex_state = 0, .external_lex_state = 32},
  [3626] = {.lex_state = 0, .external_lex_state = 32},
  [3627] = {.lex_state = 0, .external_lex_state = 32},
  [3628] = {.lex_state = 0, .external_lex_state = 32},
  [3629] = {.lex_state = 0, .external_lex_state = 32},
  [3630] = {.lex_state = 0, .external_lex_state = 32},
  [3631] = {.lex_state = 0, .external_lex_state = 32},
  [3632] = {.lex_state = 0, .external_lex_state = 32},
  [3633] = {.lex_state = 0, .external_lex_state = 32},
  [3634] = {.lex_state = 0, .external_lex_state = 32},
  [3635] = {.lex_state = 0, .external_lex_state = 32},
  [3636] = {.lex_state = 0, .external_lex_state = 32},
  [3637] = {.lex_state = 0, .external_lex_state = 32},
  [3638] = {.lex_state = 0, .external_lex_state = 32},
  [3639] = {.lex_state = 0, .external_lex_state = 32},
  [3640] = {.lex_state = 0, .external_lex_state = 32},
  [3641] = {.lex_state = 0, .external_lex_state = 32},
  [3642] = {.lex_state = 0, .external_lex_state = 32},
  [3643] = {.lex_state = 0, .external_lex_state = 32},
  [3644] = {.lex_state = 0, .external_lex_state = 32},
  [3645] = {.lex_state = 0, .external_lex_state = 32},
  [3646] = {.lex_state = 0, .external_lex_state = 32},
  [3647] = {.lex_state = 0, .external_lex_state = 32},
  [3648] = {.lex_state = 0, .external_lex_state = 32},
  [3649] = {.lex_state = 0, .external_lex_state = 32},
  [3650] = {.lex_state = 0, .external_lex_state = 32},
  [3651] = {.lex_state = 0, .external_lex_state = 32},
  [3652] = {.lex_state = 0, .external_lex_state = 32},
  [3653] = {.lex_state = 0, .external_lex_state = 32},
  [3654] = {.lex_state = 0, .external_lex_state = 32},
  [3655] = {.lex_state = 0, .external_lex_state = 32},
  [3656] = {.lex_state = 0, .external_lex_state = 32},
  [3657] = {.lex_state = 0, .external_lex_state = 32},
  [3658] = {.lex_state = 0, .external_lex_state = 32},
  [3659] = {.lex_state = 0, .external_lex_state = 32},
  [3660] = {.lex_state = 0, .external_lex_state = 32},
  [3661] = {.lex_state = 0, .external_lex_state = 32},
  [3662] = {.lex_state = 0, .external_lex_state = 32},
  [3663] = {.lex_state = 0, .external_lex_state = 32},
  [3664] = {.lex_state = 0, .external_lex_state = 32},
  [3665] = {.lex_state = 0, .external_lex_state = 32},
  [3666] = {.lex_state = 0, .external_lex_state = 32},
  [3667] = {.lex_state = 0, .external_lex_state = 32},
  [3668] = {.lex_state = 0, .external_lex_state = 32},
  [3669] = {.lex_state = 0, .external_lex_state = 32},
  [3670] = {.lex_state = 0, .external_lex_state = 32},
  [3671] = {.lex_state = 0, .external_lex_state = 32},
  [3672] = {.lex_state = 0, .external_lex_state = 32},
  [3673] = {.lex_state = 0, .external_lex_state = 32},
  [3674] = {.lex_state = 0, .external_lex_state = 32},
  [3675] = {.lex_state = 0, .external_lex_state = 32},
  [3676] = {.lex_state = 0, .external_lex_state = 32},
  [3677] = {.lex_state = 0, .external_lex_state = 32},
  [3678] = {.lex_state = 0, .external_lex_state = 32},
  [3679] = {.lex_state = 0, .external_lex_state = 32},
  [3680] = {.lex_state = 0, .external_lex_state = 32},
  [3681] = {.lex_state = 0, .external_lex_state = 32},
  [3682] = {.lex_state = 0, .external_lex_state = 32},
  [3683] = {.lex_state = 0, .external_lex_state = 32},
  [3684] = {.lex_state = 0, .external_lex_state = 32},
  [3685] = {.lex_state = 0, .external_lex_state = 32},
  [3686] = {.lex_state = 0, .external_lex_state = 32},
  [3687] = {.lex_state = 0, .external_lex_state = 32},
  [3688] = {.lex_state = 0, .external_lex_state = 32},
  [3689] = {.lex_state = 0, .external_lex_state = 32},
  [3690] = {.lex_state = 0, .external_lex_state = 32},
  [3691] = {.lex_state = 0, .external_lex_state = 32},
  [3692] = {.lex_state = 0, .external_lex_state = 32},
  [3693] = {.lex_state = 0, .external_lex_state = 32},
  [3694] = {.lex_state = 0, .external_lex_state = 32},
  [3695] = {.lex_state = 0, .external_lex_state = 32},
  [3696] = {.lex_state = 0, .external_lex_state = 32},
  [3697] = {.lex_state = 0, .external_lex_state = 32},
  [3698] = {.lex_state = 0, .external_lex_state = 32},
  [3699] = {.lex_state = 0, .external_lex_state = 32},
  [3700] = {.lex_state = 0, .external_lex_state = 32},
  [3701] = {.lex_state = 0, .external_lex_state = 32},
  [3702] = {.lex_state = 0, .external_lex_state = 32},
  [3703] = {.lex_state = 0, .external_lex_state = 32},
  [3704] = {.lex_state = 0, .external_lex_state = 32},
  [3705] = {.lex_state = 0, .external_lex_state = 32},
  [3706] = {.lex_state = 0, .external_lex_state = 32},
  [3707] = {.lex_state = 0, .external_lex_state = 32},
  [3708] = {.lex_state = 0, .external_lex_state = 32},
  [3709] = {.lex_state = 0, .external_lex_state = 32},
  [3710] = {.lex_state = 0, .external_lex_state = 32},
  [3711] = {.lex_state = 0, .external_lex_state = 32},
  [3712] = {.lex_state = 0, .external_lex_state = 32},
  [3713] = {.lex_state = 0, .external_lex_state = 32},
  [3714] = {.lex_state = 0, .external_lex_state = 32},
  [3715] = {.lex_state = 0, .external_lex_state = 32},
  [3716] = {.lex_state = 0, .external_lex_state = 32},
  [3717] = {.lex_state = 0, .external_lex_state = 32},
  [3718] = {.lex_state = 0, .external_lex_state = 32},
  [3719] = {.lex_state = 0, .external_lex_state = 32},
  [3720] = {.lex_state = 0, .external_lex_state = 32},
  [3721] = {.lex_state = 0, .external_lex_state = 32},
  [3722] = {.lex_state = 0, .external_lex_state = 32},
  [3723] = {.lex_state = 0, .external_lex_state = 32},
  [3724] = {.lex_state = 0, .external_lex_state = 32},
  [3725] = {.lex_state = 0, .external_lex_state = 32},
  [3726] = {.lex_state = 0, .external_lex_state = 32},
  [3727] = {.lex_state = 0, .external_lex_state = 32},
  [3728] = {.lex_state = 0, .external_lex_state = 32},
  [3729] = {.lex_state = 0, .external_lex_state = 32},
  [3730] = {.lex_state = 0, .external_lex_state = 32},
  [3731] = {.lex_state = 0, .external_lex_state = 32},
  [3732] = {.lex_state = 0, .external_lex_state = 32},
  [3733] = {.lex_state = 0, .external_lex_state = 32},
  [3734] = {.lex_state = 0, .external_lex_state = 32},
  [3735] = {.lex_state = 0, .external_lex_state = 32},
  [3736] = {.lex_state = 0, .external_lex_state = 32},
  [3737] = {.lex_state = 0, .external_lex_state = 32},
  [3738] = {.lex_state = 0, .external_lex_state = 32},
  [3739] = {.lex_state = 0, .external_lex_state = 32},
  [3740] = {.lex_state = 0, .external_lex_state = 32},
  [3741] = {.lex_state = 0, .external_lex_state = 32},
  [3742] = {.lex_state = 0, .external_lex_state = 32},
  [3743] = {.lex_state = 0, .external_lex_state = 32},
  [3744] = {.lex_state = 0, .external_lex_state = 32},
  [3745] = {.lex_state = 0, .external_lex_state = 32},
  [3746] = {.lex_state = 0, .external_lex_state = 32},
  [3747] = {.lex_state = 0, .external_lex_state = 32},
  [3748] = {.lex_state = 0, .external_lex_state = 32},
  [3749] = {.lex_state = 0, .external_lex_state = 32},
  [3750] = {.lex_state = 0, .external_lex_state = 32},
  [3751] = {.lex_state = 0, .external_lex_state = 32},
  [3752] = {.lex_state = 0, .external_lex_state = 32},
  [3753] = {.lex_state = 0, .external_lex_state = 32},
  [3754] = {.lex_state = 0, .external_lex_state = 32},
  [3755] = {.lex_state = 0, .external_lex_state = 32},
  [3756] = {.lex_state = 0, .external_lex_state = 32},
  [3757] = {.lex_state = 0, .external_lex_state = 32},
  [3758] = {.lex_state = 0, .external_lex_state = 32},
  [3759] = {.lex_state = 0, .external_lex_state = 32},
  [3760] = {.lex_state = 0, .external_lex_state = 32},
  [3761] = {.lex_state = 0, .external_lex_state = 32},
  [3762] = {.lex_state = 0, .external_lex_state = 32},
  [3763] = {.lex_state = 0, .external_lex_state = 32},
  [3764] = {.lex_state = 0, .external_lex_state = 32},
  [3765] = {.lex_state = 0, .external_lex_state = 32},
  [3766] = {.lex_state = 0, .external_lex_state = 32},
  [3767] = {.lex_state = 0, .external_lex_state = 32},
  [3768] = {.lex_state = 0, .external_lex_state = 32},
  [3769] = {.lex_state = 0, .external_lex_state = 32},
  [3770] = {.lex_state = 0, .external_lex_state = 32},
  [3771] = {.lex_state = 0, .external_lex_state = 32},
  [3772] = {.lex_state = 0, .external_lex_state = 32},
  [3773] = {.lex_state = 0, .external_lex_state = 32},
  [3774] = {.lex_state = 0, .external_lex_state = 32},
  [3775] = {.lex_state = 0, .external_lex_state = 32},
  [3776] = {.lex_state = 0, .external_lex_state = 32},
  [3777] = {.lex_state = 0, .external_lex_state = 32},
  [3778] = {.lex_state = 0, .external_lex_state = 32},
  [3779] = {.lex_state = 0, .external_lex_state = 32},
  [3780] = {.lex_state = 0, .external_lex_state = 32},
  [3781] = {.lex_state = 0, .external_lex_state = 32},
  [3782] = {.lex_state = 0, .external_lex_state = 32},
  [3783] = {.lex_state = 0, .external_lex_state = 32},
  [3784] = {.lex_state = 0, .external_lex_state = 32},
  [3785] = {.lex_state = 0, .external_lex_state = 32},
  [3786] = {.lex_state = 0, .external_lex_state = 32},
  [3787] = {.lex_state = 0, .external_lex_state = 32},
  [3788] = {.lex_state = 0, .external_lex_state = 32},
  [3789] = {.lex_state = 0, .external_lex_state = 32},
  [3790] = {.lex_state = 0, .external_lex_state = 32},
  [3791] = {.lex_state = 0, .external_lex_state = 32},
  [3792] = {.lex_state = 0, .external_lex_state = 32},
  [3793] = {.lex_state = 0, .external_lex_state = 32},
  [3794] = {.lex_state = 0, .external_lex_state = 32},
  [3795] = {.lex_state = 0, .external_lex_state = 32},
  [3796] = {.lex_state = 0, .external_lex_state = 32},
  [3797] = {.lex_state = 0, .external_lex_state = 32},
  [3798] = {.lex_state = 0, .external_lex_state = 32},
  [3799] = {.lex_state = 0, .external_lex_state = 32},
  [3800] = {.lex_state = 0, .external_lex_state = 32},
  [3801] = {.lex_state = 0, .external_lex_state = 32},
  [3802] = {.lex_state = 0, .external_lex_state = 32},
  [3803] = {.lex_state = 0, .external_lex_state = 32},
  [3804] = {.lex_state = 0, .external_lex_state = 32},
  [3805] = {.lex_state = 0, .external_lex_state = 32},
  [3806] = {.lex_state = 0, .external_lex_state = 32},
  [3807] = {.lex_state = 0, .external_lex_state = 32},
  [3808] = {.lex_state = 0, .external_lex_state = 32},
  [3809] = {.lex_state = 0, .external_lex_state = 32},
  [3810] = {.lex_state = 0, .external_lex_state = 32},
  [3811] = {.lex_state = 0, .external_lex_state = 32},
  [3812] = {.lex_state = 0, .external_lex_state = 32},
  [3813] = {.lex_state = 0, .external_lex_state = 32},
  [3814] = {.lex_state = 0, .external_lex_state = 32},
  [3815] = {.lex_state = 0, .external_lex_state = 32},
  [3816] = {.lex_state = 0, .external_lex_state = 32},
  [3817] = {.lex_state = 0, .external_lex_state = 32},
  [3818] = {.lex_state = 0, .external_lex_state = 32},
  [3819] = {.lex_state = 0, .external_lex_state = 32},
  [3820] = {.lex_state = 0, .external_lex_state = 32},
  [3821] = {.lex_state = 0, .external_lex_state = 32},
  [3822] = {.lex_state = 0, .external_lex_state = 32},
  [3823] = {.lex_state = 0, .external_lex_state = 32},
  [3824] = {.lex_state = 0, .external_lex_state = 32},
  [3825] = {.lex_state = 0, .external_lex_state = 32},
  [3826] = {.lex_state = 0, .external_lex_state = 32},
  [3827] = {.lex_state = 0, .external_lex_state = 32},
  [3828] = {.lex_state = 0, .external_lex_state = 32},
  [3829] = {.lex_state = 0, .external_lex_state = 32},
  [3830] = {.lex_state = 0, .external_lex_state = 32},
  [3831] = {.lex_state = 0, .external_lex_state = 32},
  [3832] = {.lex_state = 0, .external_lex_state = 32},
  [3833] = {.lex_state = 0, .external_lex_state = 32},
  [3834] = {.lex_state = 0, .external_lex_state = 32},
  [3835] = {.lex_state = 0, .external_lex_state = 32},
  [3836] = {.lex_state = 0, .external_lex_state = 32},
  [3837] = {.lex_state = 0, .external_lex_state = 32},
  [3838] = {.lex_state = 0, .external_lex_state = 32},
  [3839] = {.lex_state = 0, .external_lex_state = 32},
  [3840] = {.lex_state = 0, .external_lex_state = 32},
  [3841] = {.lex_state = 0, .external_lex_state = 32},
  [3842] = {.lex_state = 0, .external_lex_state = 32},
  [3843] = {.lex_state = 0, .external_lex_state = 32},
  [3844] = {.lex_state = 0, .external_lex_state = 32},
  [3845] = {.lex_state = 0, .external_lex_state = 32},
  [3846] = {.lex_state = 0, .external_lex_state = 32},
  [3847] = {.lex_state = 0, .external_lex_state = 32},
  [3848] = {.lex_state = 0, .external_lex_state = 32},
  [3849] = {.lex_state = 0, .external_lex_state = 32},
  [3850] = {.lex_state = 0, .external_lex_state = 32},
  [3851] = {.lex_state = 0, .external_lex_state = 32},
  [3852] = {.lex_state = 0, .external_lex_state = 32},
  [3853] = {.lex_state = 0, .external_lex_state = 32},
  [3854] = {.lex_state = 0, .external_lex_state = 32},
  [3855] = {.lex_state = 0, .external_lex_state = 32},
  [3856] = {.lex_state = 0, .external_lex_state = 32},
  [3857] = {.lex_state = 0, .external_lex_state = 32},
  [3858] = {.lex_state = 0, .external_lex_state = 32},
  [3859] = {.lex_state = 0, .external_lex_state = 32},
  [3860] = {.lex_state = 0, .external_lex_state = 32},
  [3861] = {.lex_state = 0, .external_lex_state = 32},
  [3862] = {.lex_state = 0, .external_lex_state = 32},
  [3863] = {.lex_state = 0, .external_lex_state = 32},
  [3864] = {.lex_state = 0, .external_lex_state = 32},
  [3865] = {.lex_state = 0, .external_lex_state = 32},
  [3866] = {.lex_state = 0, .external_lex_state = 32},
  [3867] = {.lex_state = 0, .external_lex_state = 32},
  [3868] = {.lex_state = 0, .external_lex_state = 32},
  [3869] = {.lex_state = 0, .external_lex_state = 32},
  [3870] = {.lex_state = 0, .external_lex_state = 32},
  [3871] = {.lex_state = 0, .external_lex_state = 32},
  [3872] = {.lex_state = 0, .external_lex_state = 32},
  [3873] = {.lex_state = 0, .external_lex_state = 32},
  [3874] = {.lex_state = 0, .external_lex_state = 32},
  [3875] = {.lex_state = 0, .external_lex_state = 32},
  [3876] = {.lex_state = 0, .external_lex_state = 32},
  [3877] = {.lex_state = 0, .external_lex_state = 32},
  [3878] = {.lex_state = 0, .external_lex_state = 32},
  [3879] = {.lex_state = 0, .external_lex_state = 32},
  [3880] = {.lex_state = 0, .external_lex_state = 32},
  [3881] = {.lex_state = 0, .external_lex_state = 32},
  [3882] = {.lex_state = 0, .external_lex_state = 32},
  [3883] = {.lex_state = 0, .external_lex_state = 32},
  [3884] = {.lex_state = 0, .external_lex_state = 32},
  [3885] = {.lex_state = 0, .external_lex_state = 32},
  [3886] = {.lex_state = 0, .external_lex_state = 32},
  [3887] = {.lex_state = 0, .external_lex_state = 32},
  [3888] = {.lex_state = 0, .external_lex_state = 32},
  [3889] = {.lex_state = 0, .external_lex_state = 32},
  [3890] = {.lex_state = 0, .external_lex_state = 32},
  [3891] = {.lex_state = 0, .external_lex_state = 32},
  [3892] = {.lex_state = 0, .external_lex_state = 32},
  [3893] = {.lex_state = 0, .external_lex_state = 32},
  [3894] = {.lex_state = 0, .external_lex_state = 32},
  [3895] = {.lex_state = 0, .external_lex_state = 32},
  [3896] = {.lex_state = 0, .external_lex_state = 32},
  [3897] = {.lex_state = 0, .external_lex_state = 32},
  [3898] = {.lex_state = 0, .external_lex_state = 32},
  [3899] = {.lex_state = 0, .external_lex_state = 32},
  [3900] = {.lex_state = 0, .external_lex_state = 32},
  [3901] = {.lex_state = 0, .external_lex_state = 32},
  [3902] = {.lex_state = 0, .external_lex_state = 32},
  [3903] = {.lex_state = 0, .external_lex_state = 32},
  [3904] = {.lex_state = 0, .external_lex_state = 32},
  [3905] = {.lex_state = 0, .external_lex_state = 32},
  [3906] = {.lex_state = 0, .external_lex_state = 32},
  [3907] = {.lex_state = 0, .external_lex_state = 32},
  [3908] = {.lex_state = 0, .external_lex_state = 32},
  [3909] = {.lex_state = 0, .external_lex_state = 32},
  [3910] = {.lex_state = 0, .external_lex_state = 32},
  [3911] = {.lex_state = 0, .external_lex_state = 32},
  [3912] = {.lex_state = 0, .external_lex_state = 32},
  [3913] = {.lex_state = 0, .external_lex_state = 32},
  [3914] = {.lex_state = 0, .external_lex_state = 32},
  [3915] = {.lex_state = 0, .external_lex_state = 32},
  [3916] = {.lex_state = 0, .external_lex_state = 32},
  [3917] = {.lex_state = 0, .external_lex_state = 32},
  [3918] = {.lex_state = 0, .external_lex_state = 32},
  [3919] = {.lex_state = 0, .external_lex_state = 32},
  [3920] = {.lex_state = 0, .external_lex_state = 32},
  [3921] = {.lex_state = 0, .external_lex_state = 32},
  [3922] = {.lex_state = 0, .external_lex_state = 32},
  [3923] = {.lex_state = 0, .external_lex_state = 32},
  [3924] = {.lex_state = 0, .external_lex_state = 32},
  [3925] = {.lex_state = 0, .external_lex_state = 32},
  [3926] = {.lex_state = 0, .external_lex_state = 32},
  [3927] = {.lex_state = 0, .external_lex_state = 32},
  [3928] = {.lex_state = 0, .external_lex_state = 32},
  [3929] = {.lex_state = 0, .external_lex_state = 32},
  [3930] = {.lex_state = 0, .external_lex_state = 32},
  [3931] = {.lex_state = 0, .external_lex_state = 32},
  [3932] = {.lex_state = 0, .external_lex_state = 32},
  [3933] = {.lex_state = 0, .external_lex_state = 32},
  [3934] = {.lex_state = 0, .external_lex_state = 32},
  [3935] = {.lex_state = 0, .external_lex_state = 32},
  [3936] = {.lex_state = 0, .external_lex_state = 32},
  [3937] = {.lex_state = 0, .external_lex_state = 32},
  [3938] = {.lex_state = 0, .external_lex_state = 32},
  [3939] = {.lex_state = 0, .external_lex_state = 32},
  [3940] = {.lex_state = 0, .external_lex_state = 32},
  [3941] = {.lex_state = 0, .external_lex_state = 32},
  [3942] = {.lex_state = 0, .external_lex_state = 32},
  [3943] = {.lex_state = 0, .external_lex_state = 32},
  [3944] = {.lex_state = 0, .external_lex_state = 32},
  [3945] = {.lex_state = 0, .external_lex_state = 32},
  [3946] = {.lex_state = 0, .external_lex_state = 32},
  [3947] = {.lex_state = 0, .external_lex_state = 32},
  [3948] = {.lex_state = 0, .external_lex_state = 32},
  [3949] = {.lex_state = 0, .external_lex_state = 32},
  [3950] = {.lex_state = 0, .external_lex_state = 32},
  [3951] = {.lex_state = 0, .external_lex_state = 32},
  [3952] = {.lex_state = 0, .external_lex_state = 32},
  [3953] = {.lex_state = 0, .external_lex_state = 32},
  [3954] = {.lex_state = 0, .external_lex_state = 32},
  [3955] = {.lex_state = 0, .external_lex_state = 32},
  [3956] = {.lex_state = 0, .external_lex_state = 32},
  [3957] = {.lex_state = 0, .external_lex_state = 32},
  [3958] = {.lex_state = 0, .external_lex_state = 32},
  [3959] = {.lex_state = 0, .external_lex_state = 32},
  [3960] = {.lex_state = 0, .external_lex_state = 32},
  [3961] = {.lex_state = 0, .external_lex_state = 32},
  [3962] = {.lex_state = 0, .external_lex_state = 32},
  [3963] = {.lex_state = 0, .external_lex_state = 32},
  [3964] = {.lex_state = 0, .external_lex_state = 32},
  [3965] = {.lex_state = 0, .external_lex_state = 32},
  [3966] = {.lex_state = 0, .external_lex_state = 32},
  [3967] = {.lex_state = 0, .external_lex_state = 32},
  [3968] = {.lex_state = 0, .external_lex_state = 32},
  [3969] = {.lex_state = 0, .external_lex_state = 32},
  [3970] = {.lex_state = 0, .external_lex_state = 32},
  [3971] = {.lex_state = 0, .external_lex_state = 32},
  [3972] = {.lex_state = 0, .external_lex_state = 32},
  [3973] = {.lex_state = 0, .external_lex_state = 32},
  [3974] = {.lex_state = 0, .external_lex_state = 32},
  [3975] = {.lex_state = 0, .external_lex_state = 32},
  [3976] = {.lex_state = 0, .external_lex_state = 32},
  [3977] = {.lex_state = 0, .external_lex_state = 32},
  [3978] = {.lex_state = 0, .external_lex_state = 32},
  [3979] = {.lex_state = 0, .external_lex_state = 32},
  [3980] = {.lex_state = 0, .external_lex_state = 32},
  [3981] = {.lex_state = 0, .external_lex_state = 32},
  [3982] = {.lex_state = 0, .external_lex_state = 32},
  [3983] = {.lex_state = 0, .external_lex_state = 32},
  [3984] = {.lex_state = 0, .external_lex_state = 32},
  [3985] = {.lex_state = 0, .external_lex_state = 32},
  [3986] = {.lex_state = 0, .external_lex_state = 32},
  [3987] = {.lex_state = 0, .external_lex_state = 32},
  [3988] = {.lex_state = 0, .external_lex_state = 32},
  [3989] = {.lex_state = 0, .external_lex_state = 33},
  [3990] = {.lex_state = 0, .external_lex_state = 32},
  [3991] = {.lex_state = 0, .external_lex_state = 32},
  [3992] = {.lex_state = 0, .external_lex_state = 32},
  [3993] = {.lex_state = 0, .external_lex_state = 32},
  [3994] = {.lex_state = 0, .external_lex_state = 32},
  [3995] = {.lex_state = 0, .external_lex_state = 32},
  [3996] = {.lex_state = 0, .external_lex_state = 32},
  [3997] = {.lex_state = 0, .external_lex_state = 32},
  [3998] = {.lex_state = 0, .external_lex_state = 32},
  [3999] = {.lex_state = 0, .external_lex_state = 32},
  [4000] = {.lex_state = 0, .external_lex_state = 32},
  [4001] = {.lex_state = 0, .external_lex_state = 32},
  [4002] = {.lex_state = 0, .external_lex_state = 32},
  [4003] = {.lex_state = 0, .external_lex_state = 32},
  [4004] = {.lex_state = 0, .external_lex_state = 32},
  [4005] = {.lex_state = 0, .external_lex_state = 32},
  [4006] = {.lex_state = 0, .external_lex_state = 32},
  [4007] = {.lex_state = 0, .external_lex_state = 32},
  [4008] = {.lex_state = 0, .external_lex_state = 32},
  [4009] = {.lex_state = 0, .external_lex_state = 32},
  [4010] = {.lex_state = 0, .external_lex_state = 32},
  [4011] = {.lex_state = 0, .external_lex_state = 32},
  [4012] = {.lex_state = 0, .external_lex_state = 32},
  [4013] = {.lex_state = 0, .external_lex_state = 32},
  [4014] = {.lex_state = 0, .external_lex_state = 32},
  [4015] = {.lex_state = 0, .external_lex_state = 32},
  [4016] = {.lex_state = 0, .external_lex_state = 32},
  [4017] = {.lex_state = 0, .external_lex_state = 32},
  [4018] = {.lex_state = 0, .external_lex_state = 32},
  [4019] = {.lex_state = 0, .external_lex_state = 32},
  [4020] = {.lex_state = 0, .external_lex_state = 32},
  [4021] = {.lex_state = 0, .external_lex_state = 32},
  [4022] = {.lex_state = 0, .external_lex_state = 32},
  [4023] = {.lex_state = 0, .external_lex_state = 32},
  [4024] = {.lex_state = 0, .external_lex_state = 32},
  [4025] = {.lex_state = 0, .external_lex_state = 32},
  [4026] = {.lex_state = 0, .external_lex_state = 32},
  [4027] = {.lex_state = 0, .external_lex_state = 32},
  [4028] = {.lex_state = 0, .external_lex_state = 32},
  [4029] = {.lex_state = 0, .external_lex_state = 32},
  [4030] = {.lex_state = 0, .external_lex_state = 32},
  [4031] = {.lex_state = 0, .external_lex_state = 32},
  [4032] = {.lex_state = 0, .external_lex_state = 32},
  [4033] = {.lex_state = 0, .external_lex_state = 32},
  [4034] = {.lex_state = 0, .external_lex_state = 32},
  [4035] = {.lex_state = 0, .external_lex_state = 32},
  [4036] = {.lex_state = 0, .external_lex_state = 32},
  [4037] = {.lex_state = 0, .external_lex_state = 32},
  [4038] = {.lex_state = 0, .external_lex_state = 32},
  [4039] = {.lex_state = 0, .external_lex_state = 32},
  [4040] = {.lex_state = 0, .external_lex_state = 32},
  [4041] = {.lex_state = 0, .external_lex_state = 32},
  [4042] = {.lex_state = 0, .external_lex_state = 32},
  [4043] = {.lex_state = 0, .external_lex_state = 32},
  [4044] = {.lex_state = 0, .external_lex_state = 32},
  [4045] = {.lex_state = 0, .external_lex_state = 32},
  [4046] = {.lex_state = 0, .external_lex_state = 32},
  [4047] = {.lex_state = 0, .external_lex_state = 32},
  [4048] = {.lex_state = 0, .external_lex_state = 32},
  [4049] = {.lex_state = 0, .external_lex_state = 32},
  [4050] = {.lex_state = 0, .external_lex_state = 32},
  [4051] = {.lex_state = 0, .external_lex_state = 32},
  [4052] = {.lex_state = 0, .external_lex_state = 32},
  [4053] = {.lex_state = 0, .external_lex_state = 32},
  [4054] = {.lex_state = 0, .external_lex_state = 32},
  [4055] = {.lex_state = 0, .external_lex_state = 32},
  [4056] = {.lex_state = 0, .external_lex_state = 32},
  [4057] = {.lex_state = 0, .external_lex_state = 32},
  [4058] = {.lex_state = 0, .external_lex_state = 32},
  [4059] = {.lex_state = 0, .external_lex_state = 32},
  [4060] = {.lex_state = 0, .external_lex_state = 32},
  [4061] = {.lex_state = 0, .external_lex_state = 32},
  [4062] = {.lex_state = 0, .external_lex_state = 32},
  [4063] = {.lex_state = 0, .external_lex_state = 32},
  [4064] = {.lex_state = 0, .external_lex_state = 32},
  [4065] = {.lex_state = 0, .external_lex_state = 32},
  [4066] = {.lex_state = 0, .external_lex_state = 32},
  [4067] = {.lex_state = 0, .external_lex_state = 32},
  [4068] = {.lex_state = 0, .external_lex_state = 32},
  [4069] = {.lex_state = 0, .external_lex_state = 32},
  [4070] = {.lex_state = 0, .external_lex_state = 32},
  [4071] = {.lex_state = 0, .external_lex_state = 32},
  [4072] = {.lex_state = 0, .external_lex_state = 32},
  [4073] = {.lex_state = 0, .external_lex_state = 32},
  [4074] = {.lex_state = 0, .external_lex_state = 32},
  [4075] = {.lex_state = 0, .external_lex_state = 32},
  [4076] = {.lex_state = 0, .external_lex_state = 32},
  [4077] = {.lex_state = 0, .external_lex_state = 32},
  [4078] = {.lex_state = 0, .external_lex_state = 32},
  [4079] = {.lex_state = 0, .external_lex_state = 32},
  [4080] = {.lex_state = 0, .external_lex_state = 32},
  [4081] = {.lex_state = 0, .external_lex_state = 32},
  [4082] = {.lex_state = 0, .external_lex_state = 32},
  [4083] = {.lex_state = 0, .external_lex_state = 32},
  [4084] = {.lex_state = 0, .external_lex_state = 32},
  [4085] = {.lex_state = 0, .external_lex_state = 32},
  [4086] = {.lex_state = 0, .external_lex_state = 32},
  [4087] = {.lex_state = 0, .external_lex_state = 32},
  [4088] = {.lex_state = 0, .external_lex_state = 32},
  [4089] = {.lex_state = 0, .external_lex_state = 34},
  [4090] = {.lex_state = 0, .external_lex_state = 34},
  [4091] = {.lex_state = 0, .external_lex_state = 34},
  [4092] = {.lex_state = 0, .external_lex_state = 34},
  [4093] = {.lex_state = 0, .external_lex_state = 34},
  [4094] = {.lex_state = 0, .external_lex_state = 34},
  [4095] = {.lex_state = 0, .external_lex_state = 34},
  [4096] = {.lex_state = 0, .external_lex_state = 34},
  [4097] = {.lex_state = 0, .external_lex_state = 34},
  [4098] = {.lex_state = 0, .external_lex_state = 34},
  [4099] = {.lex_state = 0, .external_lex_state = 34},
  [4100] = {.lex_state = 0, .external_lex_state = 34},
  [4101] = {.lex_state = 0, .external_lex_state = 34},
  [4102] = {.lex_state = 0, .external_lex_state = 34},
  [4103] = {.lex_state = 0, .external_lex_state = 34},
  [4104] = {.lex_state = 0, .external_lex_state = 34},
  [4105] = {.lex_state = 0, .external_lex_state = 34},
  [4106] = {.lex_state = 0, .external_lex_state = 34},
  [4107] = {.lex_state = 0, .external_lex_state = 34},
  [4108] = {.lex_state = 0, .external_lex_state = 34},
  [4109] = {.lex_state = 0, .external_lex_state = 34},
  [4110] = {.lex_state = 0, .external_lex_state = 34},
  [4111] = {.lex_state = 0, .external_lex_state = 34},
  [4112] = {.lex_state = 0, .external_lex_state = 34},
  [4113] = {.lex_state = 0, .external_lex_state = 34},
  [4114] = {.lex_state = 0, .external_lex_state = 34},
  [4115] = {.lex_state = 0, .external_lex_state = 34},
  [4116] = {.lex_state = 0, .external_lex_state = 34},
  [4117] = {.lex_state = 0, .external_lex_state = 34},
  [4118] = {.lex_state = 0, .external_lex_state = 34},
  [4119] = {.lex_state = 0, .external_lex_state = 34},
  [4120] = {.lex_state = 0, .external_lex_state = 34},
  [4121] = {.lex_state = 0, .external_lex_state = 34},
  [4122] = {.lex_state = 0, .external_lex_state = 34},
  [4123] = {.lex_state = 0, .external_lex_state = 34},
  [4124] = {.lex_state = 0, .external_lex_state = 34},
  [4125] = {.lex_state = 0, .external_lex_state = 34},
  [4126] = {.lex_state = 0, .external_lex_state = 34},
  [4127] = {.lex_state = 0, .external_lex_state = 34},
  [4128] = {.lex_state = 0, .external_lex_state = 34},
  [4129] = {.lex_state = 0, .external_lex_state = 34},
  [4130] = {.lex_state = 0, .external_lex_state = 34},
  [4131] = {.lex_state = 0, .external_lex_state = 34},
  [4132] = {.lex_state = 0, .external_lex_state = 34},
  [4133] = {.lex_state = 0, .external_lex_state = 34},
  [4134] = {.lex_state = 0, .external_lex_state = 34},
  [4135] = {.lex_state = 0, .external_lex_state = 34},
  [4136] = {.lex_state = 0, .external_lex_state = 34},
  [4137] = {.lex_state = 0, .external_lex_state = 34},
  [4138] = {.lex_state = 0, .external_lex_state = 34},
  [4139] = {.lex_state = 0, .external_lex_state = 34},
  [4140] = {.lex_state = 0, .external_lex_state = 34},
  [4141] = {.lex_state = 0, .external_lex_state = 34},
  [4142] = {.lex_state = 0, .external_lex_state = 34},
  [4143] = {.lex_state = 0, .external_lex_state = 34},
  [4144] = {.lex_state = 0, .external_lex_state = 34},
  [4145] = {.lex_state = 0, .external_lex_state = 34},
  [4146] = {.lex_state = 0, .external_lex_state = 34},
  [4147] = {.lex_state = 0, .external_lex_state = 34},
  [4148] = {.lex_state = 0, .external_lex_state = 34},
  [4149] = {.lex_state = 0, .external_lex_state = 34},
  [4150] = {.lex_state = 0, .external_lex_state = 34},
  [4151] = {.lex_state = 0, .external_lex_state = 34},
  [4152] = {.lex_state = 0, .external_lex_state = 34},
  [4153] = {.lex_state = 0, .external_lex_state = 34},
  [4154] = {.lex_state = 0, .external_lex_state = 34},
  [4155] = {.lex_state = 0, .external_lex_state = 34},
  [4156] = {.lex_state = 0, .external_lex_state = 34},
  [4157] = {.lex_state = 0, .external_lex_state = 34},
  [4158] = {.lex_state = 0, .external_lex_state = 34},
  [4159] = {.lex_state = 0, .external_lex_state = 34},
  [4160] = {.lex_state = 0, .external_lex_state = 34},
  [4161] = {.lex_state = 0, .external_lex_state = 34},
  [4162] = {.lex_state = 0, .external_lex_state = 34},
  [4163] = {.lex_state = 0, .external_lex_state = 34},
  [4164] = {.lex_state = 0, .external_lex_state = 34},
  [4165] = {.lex_state = 0, .external_lex_state = 34},
  [4166] = {.lex_state = 0, .external_lex_state = 34},
  [4167] = {.lex_state = 0, .external_lex_state = 34},
  [4168] = {.lex_state = 0, .external_lex_state = 34},
  [4169] = {.lex_state = 0, .external_lex_state = 34},
  [4170] = {.lex_state = 0, .external_lex_state = 34},
  [4171] = {.lex_state = 0, .external_lex_state = 34},
  [4172] = {.lex_state = 0, .external_lex_state = 34},
  [4173] = {.lex_state = 0, .external_lex_state = 34},
  [4174] = {.lex_state = 0, .external_lex_state = 34},
  [4175] = {.lex_state = 0, .external_lex_state = 34},
  [4176] = {.lex_state = 0, .external_lex_state = 34},
  [4177] = {.lex_state = 0, .external_lex_state = 34},
  [4178] = {.lex_state = 0, .external_lex_state = 34},
  [4179] = {.lex_state = 0, .external_lex_state = 34},
  [4180] = {.lex_state = 0, .external_lex_state = 34},
  [4181] = {.lex_state = 0, .external_lex_state = 34},
  [4182] = {.lex_state = 0, .external_lex_state = 34},
  [4183] = {.lex_state = 0, .external_lex_state = 34},
  [4184] = {.lex_state = 0, .external_lex_state = 34},
  [4185] = {.lex_state = 0, .external_lex_state = 34},
  [4186] = {.lex_state = 0, .external_lex_state = 34},
  [4187] = {.lex_state = 0, .external_lex_state = 34},
  [4188] = {.lex_state = 0, .external_lex_state = 34},
  [4189] = {.lex_state = 0, .external_lex_state = 34},
  [4190] = {.lex_state = 0, .external_lex_state = 34},
  [4191] = {.lex_state = 0, .external_lex_state = 34},
  [4192] = {.lex_state = 0, .external_lex_state = 34},
  [4193] = {.lex_state = 0, .external_lex_state = 34},
  [4194] = {.lex_state = 0, .external_lex_state = 34},
  [4195] = {.lex_state = 0, .external_lex_state = 34},
  [4196] = {.lex_state = 0, .external_lex_state = 34},
  [4197] = {.lex_state = 0, .external_lex_state = 34},
  [4198] = {.lex_state = 0, .external_lex_state = 34},
  [4199] = {.lex_state = 0, .external_lex_state = 34},
  [4200] = {.lex_state = 0, .external_lex_state = 34},
  [4201] = {.lex_state = 0, .external_lex_state = 34},
  [4202] = {.lex_state = 0, .external_lex_state = 34},
  [4203] = {.lex_state = 0, .external_lex_state = 34},
  [4204] = {.lex_state = 0, .external_lex_state = 34},
  [4205] = {.lex_state = 0, .external_lex_state = 34},
  [4206] = {.lex_state = 0, .external_lex_state = 34},
  [4207] = {.lex_state = 0, .external_lex_state = 34},
  [4208] = {.lex_state = 0, .external_lex_state = 34},
  [4209] = {.lex_state = 0, .external_lex_state = 34},
  [4210] = {.lex_state = 0, .external_lex_state = 34},
  [4211] = {.lex_state = 0, .external_lex_state = 34},
  [4212] = {.lex_state = 0, .external_lex_state = 34},
  [4213] = {.lex_state = 0, .external_lex_state = 34},
  [4214] = {.lex_state = 0, .external_lex_state = 34},
  [4215] = {.lex_state = 0, .external_lex_state = 34},
  [4216] = {.lex_state = 0, .external_lex_state = 34},
  [4217] = {.lex_state = 0, .external_lex_state = 34},
  [4218] = {.lex_state = 0, .external_lex_state = 34},
  [4219] = {.lex_state = 0, .external_lex_state = 34},
  [4220] = {.lex_state = 0, .external_lex_state = 34},
  [4221] = {.lex_state = 0, .external_lex_state = 34},
  [4222] = {.lex_state = 0, .external_lex_state = 34},
  [4223] = {.lex_state = 0, .external_lex_state = 34},
  [4224] = {.lex_state = 0, .external_lex_state = 34},
  [4225] = {.lex_state = 0, .external_lex_state = 34},
  [4226] = {.lex_state = 0, .external_lex_state = 34},
  [4227] = {.lex_state = 0, .external_lex_state = 34},
  [4228] = {.lex_state = 0, .external_lex_state = 34},
  [4229] = {.lex_state = 0, .external_lex_state = 34},
  [4230] = {.lex_state = 0, .external_lex_state = 34},
  [4231] = {.lex_state = 0, .external_lex_state = 34},
  [4232] = {.lex_state = 0, .external_lex_state = 34},
  [4233] = {.lex_state = 0, .external_lex_state = 34},
  [4234] = {.lex_state = 0, .external_lex_state = 34},
  [4235] = {.lex_state = 0, .external_lex_state = 34},
  [4236] = {.lex_state = 0, .external_lex_state = 34},
  [4237] = {.lex_state = 0, .external_lex_state = 34},
  [4238] = {.lex_state = 0, .external_lex_state = 34},
  [4239] = {.lex_state = 0, .external_lex_state = 34},
  [4240] = {.lex_state = 0, .external_lex_state = 34},
  [4241] = {.lex_state = 0, .external_lex_state = 34},
  [4242] = {.lex_state = 0, .external_lex_state = 34},
  [4243] = {.lex_state = 0, .external_lex_state = 34},
  [4244] = {.lex_state = 0, .external_lex_state = 34},
  [4245] = {.lex_state = 0, .external_lex_state = 34},
  [4246] = {.lex_state = 0, .external_lex_state = 34},
  [4247] = {.lex_state = 0, .external_lex_state = 34},
  [4248] = {.lex_state = 0, .external_lex_state = 34},
  [4249] = {.lex_state = 0, .external_lex_state = 34},
  [4250] = {.lex_state = 0, .external_lex_state = 34},
  [4251] = {.lex_state = 0, .external_lex_state = 34},
  [4252] = {.lex_state = 0, .external_lex_state = 34},
  [4253] = {.lex_state = 0, .external_lex_state = 34},
  [4254] = {.lex_state = 0, .external_lex_state = 34},
  [4255] = {.lex_state = 0, .external_lex_state = 34},
  [4256] = {.lex_state = 0, .external_lex_state = 34},
  [4257] = {.lex_state = 0, .external_lex_state = 34},
  [4258] = {.lex_state = 0, .external_lex_state = 34},
  [4259] = {.lex_state = 0, .external_lex_state = 34},
  [4260] = {.lex_state = 0, .external_lex_state = 34},
  [4261] = {.lex_state = 0, .external_lex_state = 34},
  [4262] = {.lex_state = 0, .external_lex_state = 34},
  [4263] = {.lex_state = 0, .external_lex_state = 34},
  [4264] = {.lex_state = 0, .external_lex_state = 34},
  [4265] = {.lex_state = 0, .external_lex_state = 34},
  [4266] = {.lex_state = 0, .external_lex_state = 34},
  [4267] = {.lex_state = 0, .external_lex_state = 34},
  [4268] = {.lex_state = 0, .external_lex_state = 34},
  [4269] = {.lex_state = 0, .external_lex_state = 34},
  [4270] = {.lex_state = 0, .external_lex_state = 34},
  [4271] = {.lex_state = 0, .external_lex_state = 34},
  [4272] = {.lex_state = 0, .external_lex_state = 34},
  [4273] = {.lex_state = 0, .external_lex_state = 34},
  [4274] = {.lex_state = 0, .external_lex_state = 34},
  [4275] = {.lex_state = 0, .external_lex_state = 34},
  [4276] = {.lex_state = 0, .external_lex_state = 34},
  [4277] = {.lex_state = 0, .external_lex_state = 34},
  [4278] = {.lex_state = 0, .external_lex_state = 34},
  [4279] = {.lex_state = 0, .external_lex_state = 34},
  [4280] = {.lex_state = 0, .external_lex_state = 34},
  [4281] = {.lex_state = 0, .external_lex_state = 34},
  [4282] = {.lex_state = 0, .external_lex_state = 34},
  [4283] = {.lex_state = 0, .external_lex_state = 34},
  [4284] = {.lex_state = 0, .external_lex_state = 34},
  [4285] = {.lex_state = 0, .external_lex_state = 34},
  [4286] = {.lex_state = 0, .external_lex_state = 34},
  [4287] = {.lex_state = 0, .external_lex_state = 34},
  [4288] = {.lex_state = 0, .external_lex_state = 34},
  [4289] = {.lex_state = 0, .external_lex_state = 34},
  [4290] = {.lex_state = 0, .external_lex_state = 34},
  [4291] = {.lex_state = 0, .external_lex_state = 34},
  [4292] = {.lex_state = 0, .external_lex_state = 34},
  [4293] = {.lex_state = 0, .external_lex_state = 34},
  [4294] = {.lex_state = 0, .external_lex_state = 34},
  [4295] = {.lex_state = 0, .external_lex_state = 34},
  [4296] = {.lex_state = 0, .external_lex_state = 34},
  [4297] = {.lex_state = 0, .external_lex_state = 34},
  [4298] = {.lex_state = 0, .external_lex_state = 34},
  [4299] = {.lex_state = 0, .external_lex_state = 34},
  [4300] = {.lex_state = 0, .external_lex_state = 34},
  [4301] = {.lex_state = 0, .external_lex_state = 34},
  [4302] = {.lex_state = 0, .external_lex_state = 34},
  [4303] = {.lex_state = 0, .external_lex_state = 34},
  [4304] = {.lex_state = 0, .external_lex_state = 34},
  [4305] = {.lex_state = 0, .external_lex_state = 34},
  [4306] = {.lex_state = 0, .external_lex_state = 34},
  [4307] = {.lex_state = 0, .external_lex_state = 34},
  [4308] = {.lex_state = 0, .external_lex_state = 34},
  [4309] = {.lex_state = 0, .external_lex_state = 34},
  [4310] = {.lex_state = 0, .external_lex_state = 34},
  [4311] = {.lex_state = 0, .external_lex_state = 34},
  [4312] = {.lex_state = 0, .external_lex_state = 34},
  [4313] = {.lex_state = 0, .external_lex_state = 34},
  [4314] = {.lex_state = 0, .external_lex_state = 34},
  [4315] = {.lex_state = 0, .external_lex_state = 34},
  [4316] = {.lex_state = 0, .external_lex_state = 34},
  [4317] = {.lex_state = 0, .external_lex_state = 34},
  [4318] = {.lex_state = 0, .external_lex_state = 34},
  [4319] = {.lex_state = 0, .external_lex_state = 34},
  [4320] = {.lex_state = 0, .external_lex_state = 34},
  [4321] = {.lex_state = 0, .external_lex_state = 34},
  [4322] = {.lex_state = 0, .external_lex_state = 34},
  [4323] = {.lex_state = 0, .external_lex_state = 34},
  [4324] = {.lex_state = 0, .external_lex_state = 34},
  [4325] = {.lex_state = 0, .external_lex_state = 34},
  [4326] = {.lex_state = 0, .external_lex_state = 34},
  [4327] = {.lex_state = 0, .external_lex_state = 34},
  [4328] = {.lex_state = 0, .external_lex_state = 34},
  [4329] = {.lex_state = 0, .external_lex_state = 34},
  [4330] = {.lex_state = 0, .external_lex_state = 34},
  [4331] = {.lex_state = 0, .external_lex_state = 34},
  [4332] = {.lex_state = 0, .external_lex_state = 34},
  [4333] = {.lex_state = 0, .external_lex_state = 34},
  [4334] = {.lex_state = 0, .external_lex_state = 34},
  [4335] = {.lex_state = 0, .external_lex_state = 34},
  [4336] = {.lex_state = 0, .external_lex_state = 34},
  [4337] = {.lex_state = 0, .external_lex_state = 34},
  [4338] = {.lex_state = 0, .external_lex_state = 34},
  [4339] = {.lex_state = 0, .external_lex_state = 34},
  [4340] = {.lex_state = 0, .external_lex_state = 34},
  [4341] = {.lex_state = 0, .external_lex_state = 34},
  [4342] = {.lex_state = 0, .external_lex_state = 34},
  [4343] = {.lex_state = 0, .external_lex_state = 34},
  [4344] = {.lex_state = 0, .external_lex_state = 34},
  [4345] = {.lex_state = 0, .external_lex_state = 34},
  [4346] = {.lex_state = 0, .external_lex_state = 34},
  [4347] = {.lex_state = 0, .external_lex_state = 34},
  [4348] = {.lex_state = 0, .external_lex_state = 34},
  [4349] = {.lex_state = 0, .external_lex_state = 34},
  [4350] = {.lex_state = 0, .external_lex_state = 34},
  [4351] = {.lex_state = 0, .external_lex_state = 34},
  [4352] = {.lex_state = 0, .external_lex_state = 34},
  [4353] = {.lex_state = 0, .external_lex_state = 34},
  [4354] = {.lex_state = 0, .external_lex_state = 34},
  [4355] = {.lex_state = 0, .external_lex_state = 34},
  [4356] = {.lex_state = 0, .external_lex_state = 34},
  [4357] = {.lex_state = 0, .external_lex_state = 34},
  [4358] = {.lex_state = 0, .external_lex_state = 34},
  [4359] = {.lex_state = 0, .external_lex_state = 34},
  [4360] = {.lex_state = 0, .external_lex_state = 34},
  [4361] = {.lex_state = 0, .external_lex_state = 34},
  [4362] = {.lex_state = 0, .external_lex_state = 34},
  [4363] = {.lex_state = 0, .external_lex_state = 34},
  [4364] = {.lex_state = 0, .external_lex_state = 34},
  [4365] = {.lex_state = 0, .external_lex_state = 34},
  [4366] = {.lex_state = 0, .external_lex_state = 34},
  [4367] = {.lex_state = 0, .external_lex_state = 34},
  [4368] = {.lex_state = 0, .external_lex_state = 34},
  [4369] = {.lex_state = 1, .external_lex_state = 35},
  [4370] = {.lex_state = 1, .external_lex_state = 35},
  [4371] = {.lex_state = 1, .external_lex_state = 36},
  [4372] = {.lex_state = 1, .external_lex_state = 36},
  [4373] = {.lex_state = 1, .external_lex_state = 37},
  [4374] = {.lex_state = 0, .external_lex_state = 38},
  [4375] = {.lex_state = 0, .external_lex_state = 38},
  [4376] = {.lex_state = 0, .external_lex_state = 38},
  [4377] = {.lex_state = 0, .external_lex_state = 38},
  [4378] = {.lex_state = 0, .external_lex_state = 38},
  [4379] = {.lex_state = 1, .external_lex_state = 39},
  [4380] = {.lex_state = 0, .external_lex_state = 38},
  [4381] = {.lex_state = 0, .external_lex_state = 38},
  [4382] = {.lex_state = 0, .external_lex_state = 38},
  [4383] = {.lex_state = 0, .external_lex_state = 38},
  [4384] = {.lex_state = 0, .external_lex_state = 38},
  [4385] = {.lex_state = 0, .external_lex_state = 38},
  [4386] = {.lex_state = 1, .external_lex_state = 35},
  [4387] = {.lex_state = 0, .external_lex_state = 38},
  [4388] = {.lex_state = 0, .external_lex_state = 38},
  [4389] = {.lex_state = 0, .external_lex_state = 38},
  [4390] = {.lex_state = 0, .external_lex_state = 38},
  [4391] = {.lex_state = 0, .external_lex_state = 38},
  [4392] = {.lex_state = 0, .external_lex_state = 38},
  [4393] = {.lex_state = 0, .external_lex_state = 38},
  [4394] = {.lex_state = 0, .external_lex_state = 38},
  [4395] = {.lex_state = 0, .external_lex_state = 38},
  [4396] = {.lex_state = 0, .external_lex_state = 38},
  [4397] = {.lex_state = 0, .external_lex_state = 38},
  [4398] = {.lex_state = 0, .external_lex_state = 38},
  [4399] = {.lex_state = 0, .external_lex_state = 38},
  [4400] = {.lex_state = 0, .external_lex_state = 38},
  [4401] = {.lex_state = 0, .external_lex_state = 38},
  [4402] = {.lex_state = 0, .external_lex_state = 38},
  [4403] = {.lex_state = 0, .external_lex_state = 38},
  [4404] = {.lex_state = 0, .external_lex_state = 38},
  [4405] = {.lex_state = 0, .external_lex_state = 38},
  [4406] = {.lex_state = 0, .external_lex_state = 38},
  [4407] = {.lex_state = 0, .external_lex_state = 38},
  [4408] = {.lex_state = 0, .external_lex_state = 38},
  [4409] = {.lex_state = 0, .external_lex_state = 38},
  [4410] = {.lex_state = 0, .external_lex_state = 38},
  [4411] = {.lex_state = 0, .external_lex_state = 38},
  [4412] = {.lex_state = 0, .external_lex_state = 38},
  [4413] = {.lex_state = 0, .external_lex_state = 38},
  [4414] = {.lex_state = 0, .external_lex_state = 38},
  [4415] = {.lex_state = 0, .external_lex_state = 38},
  [4416] = {.lex_state = 0, .external_lex_state = 38},
  [4417] = {.lex_state = 0, .external_lex_state = 38},
  [4418] = {.lex_state = 0, .external_lex_state = 38},
  [4419] = {.lex_state = 0, .external_lex_state = 38},
  [4420] = {.lex_state = 0, .external_lex_state = 38},
  [4421] = {.lex_state = 0, .external_lex_state = 38},
  [4422] = {.lex_state = 0, .external_lex_state = 38},
  [4423] = {.lex_state = 0, .external_lex_state = 38},
  [4424] = {.lex_state = 0, .external_lex_state = 38},
  [4425] = {.lex_state = 0, .external_lex_state = 38},
  [4426] = {.lex_state = 0, .external_lex_state = 38},
  [4427] = {.lex_state = 0, .external_lex_state = 38},
  [4428] = {.lex_state = 0, .external_lex_state = 38},
  [4429] = {.lex_state = 0, .external_lex_state = 38},
  [4430] = {.lex_state = 0, .external_lex_state = 38},
  [4431] = {.lex_state = 0, .external_lex_state = 38},
  [4432] = {.lex_state = 0, .external_lex_state = 38},
  [4433] = {.lex_state = 0, .external_lex_state = 38},
  [4434] = {.lex_state = 0, .external_lex_state = 40},
  [4435] = {.lex_state = 0, .external_lex_state = 40},
  [4436] = {.lex_state = 0, .external_lex_state = 40},
  [4437] = {.lex_state = 0, .external_lex_state = 40},
  [4438] = {.lex_state = 0, .external_lex_state = 40},
  [4439] = {.lex_state = 0, .external_lex_state = 40},
  [4440] = {.lex_state = 0, .external_lex_state = 40},
  [4441] = {.lex_state = 0, .external_lex_state = 40},
  [4442] = {.lex_state = 0, .external_lex_state = 40},
  [4443] = {.lex_state = 0, .external_lex_state = 40},
  [4444] = {.lex_state = 0, .external_lex_state = 40},
  [4445] = {.lex_state = 0, .external_lex_state = 40},
  [4446] = {.lex_state = 0, .external_lex_state = 40},
  [4447] = {.lex_state = 0, .external_lex_state = 40},
  [4448] = {.lex_state = 0, .external_lex_state = 40},
  [4449] = {.lex_state = 0, .external_lex_state = 40},
  [4450] = {.lex_state = 0, .external_lex_state = 40},
  [4451] = {.lex_state = 0, .external_lex_state = 40},
  [4452] = {.lex_state = 0, .external_lex_state = 40},
  [4453] = {.lex_state = 0, .external_lex_state = 40},
  [4454] = {.lex_state = 0, .external_lex_state = 40},
  [4455] = {.lex_state = 0, .external_lex_state = 40},
  [4456] = {.lex_state = 0, .external_lex_state = 40},
  [4457] = {.lex_state = 0, .external_lex_state = 40},
  [4458] = {.lex_state = 0, .external_lex_state = 40},
  [4459] = {.lex_state = 0, .external_lex_state = 40},
  [4460] = {.lex_state = 0, .external_lex_state = 40},
  [4461] = {.lex_state = 0, .external_lex_state = 40},
  [4462] = {.lex_state = 0, .external_lex_state = 40},
  [4463] = {.lex_state = 0, .external_lex_state = 40},
  [4464] = {.lex_state = 0, .external_lex_state = 40},
  [4465] = {.lex_state = 0, .external_lex_state = 40},
  [4466] = {.lex_state = 0, .external_lex_state = 40},
  [4467] = {.lex_state = 0, .external_lex_state = 40},
  [4468] = {.lex_state = 0, .external_lex_state = 40},
  [4469] = {.lex_state = 0, .external_lex_state = 40},
  [4470] = {.lex_state = 0, .external_lex_state = 40},
  [4471] = {.lex_state = 0, .external_lex_state = 40},
  [4472] = {.lex_state = 0, .external_lex_state = 40},
  [4473] = {.lex_state = 0, .external_lex_state = 40},
  [4474] = {.lex_state = 0, .external_lex_state = 40},
  [4475] = {.lex_state = 0, .external_lex_state = 40},
  [4476] = {.lex_state = 0, .external_lex_state = 40},
  [4477] = {.lex_state = 0, .external_lex_state = 40},
  [4478] = {.lex_state = 0, .external_lex_state = 40},
  [4479] = {.lex_state = 0, .external_lex_state = 40},
  [4480] = {.lex_state = 0, .external_lex_state = 40},
  [4481] = {.lex_state = 0, .external_lex_state = 40},
  [4482] = {.lex_state = 0, .external_lex_state = 40},
  [4483] = {.lex_state = 0, .external_lex_state = 40},
  [4484] = {.lex_state = 0, .external_lex_state = 40},
  [4485] = {.lex_state = 0, .external_lex_state = 40},
  [4486] = {.lex_state = 0, .external_lex_state = 40},
  [4487] = {.lex_state = 0, .external_lex_state = 40},
  [4488] = {.lex_state = 0, .external_lex_state = 40},
  [4489] = {.lex_state = 0, .external_lex_state = 40},
  [4490] = {.lex_state = 0, .external_lex_state = 40},
  [4491] = {.lex_state = 0, .external_lex_state = 40},
  [4492] = {.lex_state = 0, .external_lex_state = 40},
  [4493] = {.lex_state = 0, .external_lex_state = 40},
  [4494] = {.lex_state = 0, .external_lex_state = 40},
  [4495] = {.lex_state = 0, .external_lex_state = 40},
  [4496] = {.lex_state = 0, .external_lex_state = 40},
  [4497] = {.lex_state = 0, .external_lex_state = 40},
  [4498] = {.lex_state = 0, .external_lex_state = 40},
  [4499] = {.lex_state = 0, .external_lex_state = 40},
  [4500] = {.lex_state = 0, .external_lex_state = 40},
  [4501] = {.lex_state = 0, .external_lex_state = 40},
  [4502] = {.lex_state = 0, .external_lex_state = 40},
  [4503] = {.lex_state = 0, .external_lex_state = 40},
  [4504] = {.lex_state = 0, .external_lex_state = 40},
  [4505] = {.lex_state = 0, .external_lex_state = 40},
  [4506] = {.lex_state = 0, .external_lex_state = 40},
  [4507] = {.lex_state = 0, .external_lex_state = 40},
  [4508] = {.lex_state = 0, .external_lex_state = 40},
  [4509] = {.lex_state = 0, .external_lex_state = 40},
  [4510] = {.lex_state = 0, .external_lex_state = 40},
  [4511] = {.lex_state = 0, .external_lex_state = 40},
  [4512] = {.lex_state = 0, .external_lex_state = 40},
  [4513] = {.lex_state = 0, .external_lex_state = 40},
  [4514] = {.lex_state = 0, .external_lex_state = 40},
  [4515] = {.lex_state = 0, .external_lex_state = 40},
  [4516] = {.lex_state = 0, .external_lex_state = 40},
  [4517] = {.lex_state = 0, .external_lex_state = 40},
  [4518] = {.lex_state = 0, .external_lex_state = 40},
  [4519] = {.lex_state = 0, .external_lex_state = 40},
  [4520] = {.lex_state = 0, .external_lex_state = 40},
  [4521] = {.lex_state = 0, .external_lex_state = 40},
  [4522] = {.lex_state = 0, .external_lex_state = 40},
  [4523] = {.lex_state = 0, .external_lex_state = 40},
  [4524] = {.lex_state = 0, .external_lex_state = 40},
  [4525] = {.lex_state = 0, .external_lex_state = 40},
  [4526] = {.lex_state = 0, .external_lex_state = 40},
  [4527] = {.lex_state = 0, .external_lex_state = 40},
  [4528] = {.lex_state = 0, .external_lex_state = 40},
  [4529] = {.lex_state = 0, .external_lex_state = 40},
  [4530] = {.lex_state = 0, .external_lex_state = 40},
  [4531] = {.lex_state = 0, .external_lex_state = 40},
  [4532] = {.lex_state = 0, .external_lex_state = 40},
  [4533] = {.lex_state = 0, .external_lex_state = 40},
  [4534] = {.lex_state = 0, .external_lex_state = 40},
  [4535] = {.lex_state = 0, .external_lex_state = 40},
  [4536] = {.lex_state = 0, .external_lex_state = 40},
  [4537] = {.lex_state = 0, .external_lex_state = 40},
  [4538] = {.lex_state = 0, .external_lex_state = 40},
  [4539] = {.lex_state = 0, .external_lex_state = 40},
  [4540] = {.lex_state = 0, .external_lex_state = 40},
  [4541] = {.lex_state = 0, .external_lex_state = 40},
  [4542] = {.lex_state = 0, .external_lex_state = 40},
  [4543] = {.lex_state = 0, .external_lex_state = 40},
  [4544] = {.lex_state = 0, .external_lex_state = 40},
  [4545] = {.lex_state = 0, .external_lex_state = 40},
  [4546] = {.lex_state = 0, .external_lex_state = 40},
  [4547] = {.lex_state = 0, .external_lex_state = 40},
  [4548] = {.lex_state = 0, .external_lex_state = 40},
  [4549] = {.lex_state = 0, .external_lex_state = 40},
  [4550] = {.lex_state = 0, .external_lex_state = 40},
  [4551] = {.lex_state = 0, .external_lex_state = 40},
  [4552] = {.lex_state = 0, .external_lex_state = 40},
  [4553] = {.lex_state = 0, .external_lex_state = 40},
  [4554] = {.lex_state = 0, .external_lex_state = 40},
  [4555] = {.lex_state = 0, .external_lex_state = 40},
  [4556] = {.lex_state = 0, .external_lex_state = 40},
  [4557] = {.lex_state = 0, .external_lex_state = 40},
  [4558] = {.lex_state = 0, .external_lex_state = 40},
  [4559] = {.lex_state = 0, .external_lex_state = 40},
  [4560] = {.lex_state = 0, .external_lex_state = 40},
  [4561] = {.lex_state = 0, .external_lex_state = 40},
  [4562] = {.lex_state = 0, .external_lex_state = 40},
  [4563] = {.lex_state = 0, .external_lex_state = 40},
  [4564] = {.lex_state = 0, .external_lex_state = 40},
  [4565] = {.lex_state = 0, .external_lex_state = 40},
  [4566] = {.lex_state = 0, .external_lex_state = 40},
  [4567] = {.lex_state = 0, .external_lex_state = 40},
  [4568] = {.lex_state = 0, .external_lex_state = 40},
  [4569] = {.lex_state = 0, .external_lex_state = 40},
  [4570] = {.lex_state = 0, .external_lex_state = 40},
  [4571] = {.lex_state = 0, .external_lex_state = 40},
  [4572] = {.lex_state = 0, .external_lex_state = 40},
  [4573] = {.lex_state = 0, .external_lex_state = 40},
  [4574] = {.lex_state = 0, .external_lex_state = 40},
  [4575] = {.lex_state = 0, .external_lex_state = 40},
  [4576] = {.lex_state = 0, .external_lex_state = 40},
  [4577] = {.lex_state = 0, .external_lex_state = 40},
  [4578] = {.lex_state = 0, .external_lex_state = 40},
  [4579] = {.lex_state = 0, .external_lex_state = 40},
  [4580] = {.lex_state = 0, .external_lex_state = 40},
  [4581] = {.lex_state = 0, .external_lex_state = 40},
  [4582] = {.lex_state = 0, .external_lex_state = 40},
  [4583] = {.lex_state = 0, .external_lex_state = 40},
  [4584] = {.lex_state = 0, .external_lex_state = 40},
  [4585] = {.lex_state = 0, .external_lex_state = 40},
  [4586] = {.lex_state = 0, .external_lex_state = 40},
  [4587] = {.lex_state = 0, .external_lex_state = 40},
  [4588] = {.lex_state = 0, .external_lex_state = 40},
  [4589] = {.lex_state = 0, .external_lex_state = 40},
  [4590] = {.lex_state = 0, .external_lex_state = 40},
  [4591] = {.lex_state = 0, .external_lex_state = 40},
  [4592] = {.lex_state = 0, .external_lex_state = 40},
  [4593] = {.lex_state = 0, .external_lex_state = 40},
  [4594] = {.lex_state = 0, .external_lex_state = 40},
  [4595] = {.lex_state = 0, .external_lex_state = 40},
  [4596] = {.lex_state = 0, .external_lex_state = 40},
  [4597] = {.lex_state = 0, .external_lex_state = 40},
  [4598] = {.lex_state = 0, .external_lex_state = 40},
  [4599] = {.lex_state = 0, .external_lex_state = 40},
  [4600] = {.lex_state = 0, .external_lex_state = 40},
  [4601] = {.lex_state = 0, .external_lex_state = 40},
  [4602] = {.lex_state = 0, .external_lex_state = 40},
  [4603] = {.lex_state = 0, .external_lex_state = 40},
  [4604] = {.lex_state = 0, .external_lex_state = 40},
  [4605] = {.lex_state = 0, .external_lex_state = 40},
  [4606] = {.lex_state = 0, .external_lex_state = 40},
  [4607] = {.lex_state = 0, .external_lex_state = 40},
  [4608] = {.lex_state = 0, .external_lex_state = 40},
  [4609] = {.lex_state = 0, .external_lex_state = 40},
  [4610] = {.lex_state = 0, .external_lex_state = 40},
  [4611] = {.lex_state = 0, .external_lex_state = 40},
  [4612] = {.lex_state = 0, .external_lex_state = 40},
  [4613] = {.lex_state = 0, .external_lex_state = 40},
  [4614] = {.lex_state = 0, .external_lex_state = 40},
  [4615] = {.lex_state = 0, .external_lex_state = 40},
  [4616] = {.lex_state = 0, .external_lex_state = 40},
  [4617] = {.lex_state = 0, .external_lex_state = 40},
  [4618] = {.lex_state = 0, .external_lex_state = 40},
  [4619] = {.lex_state = 0, .external_lex_state = 40},
  [4620] = {.lex_state = 0, .external_lex_state = 40},
  [4621] = {.lex_state = 0, .external_lex_state = 40},
  [4622] = {.lex_state = 0, .external_lex_state = 40},
  [4623] = {.lex_state = 0, .external_lex_state = 40},
  [4624] = {.lex_state = 0, .external_lex_state = 40},
  [4625] = {.lex_state = 0, .external_lex_state = 40},
  [4626] = {.lex_state = 0, .external_lex_state = 40},
  [4627] = {.lex_state = 0, .external_lex_state = 40},
  [4628] = {.lex_state = 0, .external_lex_state = 40},
  [4629] = {.lex_state = 0, .external_lex_state = 40},
  [4630] = {.lex_state = 0, .external_lex_state = 40},
  [4631] = {.lex_state = 0, .external_lex_state = 40},
  [4632] = {.lex_state = 0, .external_lex_state = 40},
  [4633] = {.lex_state = 0, .external_lex_state = 40},
  [4634] = {.lex_state = 1, .external_lex_state = 36},
  [4635] = {.lex_state = 0, .external_lex_state = 40},
  [4636] = {.lex_state = 0, .external_lex_state = 40},
  [4637] = {.lex_state = 0, .external_lex_state = 40},
  [4638] = {.lex_state = 0, .external_lex_state = 40},
  [4639] = {.lex_state = 0, .external_lex_state = 40},
  [4640] = {.lex_state = 0, .external_lex_state = 40},
  [4641] = {.lex_state = 0, .external_lex_state = 40},
  [4642] = {.lex_state = 0, .external_lex_state = 40},
  [4643] = {.lex_state = 0, .external_lex_state = 40},
  [4644] = {.lex_state = 0, .external_lex_state = 40},
  [4645] = {.lex_state = 0, .external_lex_state = 40},
  [4646] = {.lex_state = 0, .external_lex_state = 40},
  [4647] = {.lex_state = 0, .external_lex_state = 40},
  [4648] = {.lex_state = 0, .external_lex_state = 40},
  [4649] = {.lex_state = 0, .external_lex_state = 40},
  [4650] = {.lex_state = 0, .external_lex_state = 40},
  [4651] = {.lex_state = 0, .external_lex_state = 40},
  [4652] = {.lex_state = 0, .external_lex_state = 40},
  [4653] = {.lex_state = 0, .external_lex_state = 40},
  [4654] = {.lex_state = 0, .external_lex_state = 29},
  [4655] = {.lex_state = 0, .external_lex_state = 38},
  [4656] = {.lex_state = 0, .external_lex_state = 31},
  [4657] = {.lex_state = 0, .external_lex_state = 31},
  [4658] = {.lex_state = 0, .external_lex_state = 31},
  [4659] = {.lex_state = 0, .external_lex_state = 29},
  [4660] = {.lex_state = 0, .external_lex_state = 30},
  [4661] = {.lex_state = 0, .external_lex_state = 30},
  [4662] = {.lex_state = 0, .external_lex_state = 31},
  [4663] = {.lex_state = 0, .external_lex_state = 31},
  [4664] = {.lex_state = 0, .external_lex_state = 29},
  [4665] = {.lex_state = 0, .external_lex_state = 30},
  [4666] = {.lex_state = 0, .external_lex_state = 29},
  [4667] = {.lex_state = 0, .external_lex_state = 31},
  [4668] = {.lex_state = 0, .external_lex_state = 38},
  [4669] = {.lex_state = 0, .external_lex_state = 30},
  [4670] = {.lex_state = 0, .external_lex_state = 38},
  [4671] = {.lex_state = 0, .external_lex_state = 30},
  [4672] = {.lex_state = 0, .external_lex_state = 31},
  [4673] = {.lex_state = 0, .external_lex_state = 30},
  [4674] = {.lex_state = 0, .external_lex_state = 38},
  [4675] = {.lex_state = 0, .external_lex_state = 38},
  [4676] = {.lex_state = 0, .external_lex_state = 29},
  [4677] = {.lex_state = 0, .external_lex_state = 29},
  [4678] = {.lex_state = 0, .external_lex_state = 38},
  [4679] = {.lex_state = 0, .external_lex_state = 30},
  [4680] = {.lex_state = 1, .external_lex_state = 38},
  [4681] = {.lex_state = 0, .external_lex_state = 38},
  [4682] = {.lex_state = 0, .external_lex_state = 29},
  [4683] = {.lex_state = 0, .external_lex_state = 38},
  [4684] = {.lex_state = 0, .external_lex_state = 40},
  [4685] = {.lex_state = 0, .external_lex_state = 40},
  [4686] = {.lex_state = 0, .external_lex_state = 40},
  [4687] = {.lex_state = 0, .external_lex_state = 40},
  [4688] = {.lex_state = 0, .external_lex_state = 40},
  [4689] = {.lex_state = 0, .external_lex_state = 40},
  [4690] = {.lex_state = 1, .external_lex_state = 40},
  [4691] = {.lex_state = 0, .external_lex_state = 40},
  [4692] = {.lex_state = 0, .external_lex_state = 40},
  [4693] = {.lex_state = 0, .external_lex_state = 32},
  [4694] = {.lex_state = 0, .external_lex_state = 38},
  [4695] = {.lex_state = 0, .external_lex_state = 38},
  [4696] = {.lex_state = 0, .external_lex_state = 38},
  [4697] = {.lex_state = 0, .external_lex_state = 38},
  [4698] = {.lex_state = 0, .external_lex_state = 38},
  [4699] = {.lex_state = 0, .external_lex_state = 38},
  [4700] = {.lex_state = 0, .external_lex_state = 38},
  [4701] = {.lex_state = 0, .external_lex_state = 38},
  [4702] = {.lex_state = 0, .external_lex_state = 38},
  [4703] = {.lex_state = 0, .external_lex_state = 38},
  [4704] = {.lex_state = 0, .external_lex_state = 38},
  [4705] = {.lex_state = 0, .external_lex_state = 38},
  [4706] = {.lex_state = 0, .external_lex_state = 38},
  [4707] = {.lex_state = 0, .external_lex_state = 38},
  [4708] = {.lex_state = 0, .external_lex_state = 38},
  [4709] = {.lex_state = 0, .external_lex_state = 38},
  [4710] = {.lex_state = 0, .external_lex_state = 38},
  [4711] = {.lex_state = 0, .external_lex_state = 38},
  [4712] = {.lex_state = 0, .external_lex_state = 38},
  [4713] = {.lex_state = 0, .external_lex_state = 40},
  [4714] = {.lex_state = 0, .external_lex_state = 40},
  [4715] = {.lex_state = 0, .external_lex_state = 40},
  [4716] = {.lex_state = 0, .external_lex_state = 40},
  [4717] = {.lex_state = 0, .external_lex_state = 40},
  [4718] = {.lex_state = 0, .external_lex_state = 40},
  [4719] = {.lex_state = 0, .external_lex_state = 40},
  [4720] = {.lex_state = 0, .external_lex_state = 40},
  [4721] = {.lex_state = 0, .external_lex_state = 40},
  [4722] = {.lex_state = 0, .external_lex_state = 40},
  [4723] = {.lex_state = 0, .external_lex_state = 40},
  [4724] = {.lex_state = 0, .external_lex_state = 40},
  [4725] = {.lex_state = 0, .external_lex_state = 40},
  [4726] = {.lex_state = 0, .external_lex_state = 40},
  [4727] = {.lex_state = 0, .external_lex_state = 40},
  [4728] = {.lex_state = 0, .external_lex_state = 40},
  [4729] = {.lex_state = 0, .external_lex_state = 40},
  [4730] = {.lex_state = 0, .external_lex_state = 40},
  [4731] = {.lex_state = 0, .external_lex_state = 40},
  [4732] = {.lex_state = 3, .external_lex_state = 41},
  [4733] = {.lex_state = 3, .external_lex_state = 41},
  [4734] = {.lex_state = 3, .external_lex_state = 41},
  [4735] = {.lex_state = 3, .external_lex_state = 41},
  [4736] = {.lex_state = 3, .external_lex_state = 41},
  [4737] = {.lex_state = 3, .external_lex_state = 41},
  [4738] = {.lex_state = 3, .external_lex_state = 41},
  [4739] = {.lex_state = 3, .external_lex_state = 41},
  [4740] = {.lex_state = 3, .external_lex_state = 41},
  [4741] = {.lex_state = 3, .external_lex_state = 41},
  [4742] = {.lex_state = 3, .external_lex_state = 41},
  [4743] = {.lex_state = 3, .external_lex_state = 41},
  [4744] = {.lex_state = 3, .external_lex_state = 41},
  [4745] = {.lex_state = 3, .external_lex_state = 41},
  [4746] = {.lex_state = 3, .external_lex_state = 41},
  [4747] = {.lex_state = 3, .external_lex_state = 41},
  [4748] = {.lex_state = 3, .external_lex_state = 41},
  [4749] = {.lex_state = 3, .external_lex_state = 41},
  [4750] = {.lex_state = 3, .external_lex_state = 41},
  [4751] = {.lex_state = 3, .external_lex_state = 41},
  [4752] = {.lex_state = 3, .external_lex_state = 41},
  [4753] = {.lex_state = 3, .external_lex_state = 41},
  [4754] = {.lex_state = 3, .external_lex_state = 41},
  [4755] = {.lex_state = 3, .external_lex_state = 41},
  [4756] = {.lex_state = 3, .external_lex_state = 41},
  [4757] = {.lex_state = 3, .external_lex_state = 41},
  [4758] = {.lex_state = 3},
  [4759] = {.lex_state = 0, .external_lex_state = 41},
  [4760] = {.lex_state = 0, .external_lex_state = 42},
  [4761] = {.lex_state = 2},
  [4762] = {.lex_state = 4},
  [4763] = {.lex_state = 2},
  [4764] = {.lex_state = 4},
  [4765] = {.lex_state = 0, .external_lex_state = 42},
  [4766] = {.lex_state = 4},
  [4767] = {.lex_state = 0, .external_lex_state = 41},
  [4768] = {.lex_state = 2},
  [4769] = {.lex_state = 0, .external_lex_state = 41},
  [4770] = {.lex_state = 4},
  [4771] = {.lex_state = 0, .external_lex_state = 41},
  [4772] = {.lex_state = 0, .external_lex_state = 42},
  [4773] = {.lex_state = 4},
  [4774] = {.lex_state = 2},
  [4775] = {.lex_state = 0, .external_lex_state = 42},
  [4776] = {.lex_state = 2},
  [4777] = {.lex_state = 4},
  [4778] = {.lex_state = 2},
  [4779] = {.lex_state = 0, .external_lex_state = 42},
  [4780] = {.lex_state = 2},
  [4781] = {.lex_state = 4},
  [4782] = {.lex_state = 0, .external_lex_state = 41},
  [4783] = {.lex_state = 0, .external_lex_state = 42},
  [4784] = {.lex_state = 2},
  [4785] = {.lex_state = 0, .external_lex_state = 42},
  [4786] = {.lex_state = 4},
  [4787] = {.lex_state = 0, .external_lex_state = 42},
  [4788] = {.lex_state = 0, .external_lex_state = 41},
  [4789] = {.lex_state = 0, .external_lex_state = 41},
  [4790] = {.lex_state = 0, .external_lex_state = 41},
  [4791] = {.lex_state = 0, .external_lex_state = 41},
  [4792] = {.lex_state = 0, .external_lex_state = 42},
  [4793] = {.lex_state = 0, .external_lex_state = 41},
  [4794] = {.lex_state = 2},
  [4795] = {.lex_state = 0, .external_lex_state = 42},
  [4796] = {.lex_state = 4},
  [4797] = {.lex_state = 2},
  [4798] = {.lex_state = 0, .external_lex_state = 42},
  [4799] = {.lex_state = 0, .external_lex_state = 41},
  [4800] = {.lex_state = 0, .external_lex_state = 42},
  [4801] = {.lex_state = 4},
  [4802] = {.lex_state = 2},
  [4803] = {.lex_state = 0, .external_lex_state = 42},
  [4804] = {.lex_state = 0, .external_lex_state = 41},
  [4805] = {.lex_state = 4},
  [4806] = {.lex_state = 0, .external_lex_state = 41},
  [4807] = {.lex_state = 0, .external_lex_state = 42},
  [4808] = {.lex_state = 0, .external_lex_state = 42},
  [4809] = {.lex_state = 0, .external_lex_state = 42},
  [4810] = {.lex_state = 0, .external_lex_state = 42},
  [4811] = {.lex_state = 0, .external_lex_state = 42},
  [4812] = {.lex_state = 4},
  [4813] = {.lex_state = 2},
  [4814] = {.lex_state = 2},
  [4815] = {.lex_state = 2},
  [4816] = {.lex_state = 4},
  [4817] = {.lex_state = 2},
  [4818] = {.lex_state = 0, .external_lex_state = 42},
  [4819] = {.lex_state = 4},
  [4820] = {.lex_state = 2},
  [4821] = {.lex_state = 0, .external_lex_state = 42},
  [4822] = {.lex_state = 4},
  [4823] = {.lex_state = 2},
  [4824] = {.lex_state = 4},
  [4825] = {.lex_state = 2},
  [4826] = {.lex_state = 0, .external_lex_state = 42},
  [4827] = {.lex_state = 2},
  [4828] = {.lex_state = 4},
  [4829] = {.lex_state = 4},
  [4830] = {.lex_state = 0, .external_lex_state = 42},
  [4831] = {.lex_state = 0, .external_lex_state = 42},
  [4832] = {.lex_state = 2},
  [4833] = {.lex_state = 4},
  [4834] = {.lex_state = 0, .external_lex_state = 42},
  [4835] = {.lex_state = 0, .external_lex_state = 41},
  [4836] = {.lex_state = 0, .external_lex_state = 41},
  [4837] = {.lex_state = 0, .external_lex_state = 41},
  [4838] = {.lex_state = 0, .external_lex_state = 41},
  [4839] = {.lex_state = 0, .external_lex_state = 42},
  [4840] = {.lex_state = 0, .external_lex_state = 41},
  [4841] = {.lex_state = 0, .external_lex_state = 42},
  [4842] = {.lex_state = 4},
  [4843] = {.lex_state = 2},
  [4844] = {.lex_state = 0, .external_lex_state = 42},
  [4845] = {.lex_state = 0, .external_lex_state = 41},
  [4846] = {.lex_state = 0, .external_lex_state = 42},
  [4847] = {.lex_state = 4},
  [4848] = {.lex_state = 2},
  [4849] = {.lex_state = 4},
  [4850] = {.lex_state = 0, .external_lex_state = 41},
  [4851] = {.lex_state = 0, .external_lex_state = 41},
  [4852] = {.lex_state = 0, .external_lex_state = 41},
  [4853] = {.lex_state = 0, .external_lex_state = 42},
  [4854] = {.lex_state = 4},
  [4855] = {.lex_state = 0, .external_lex_state = 42},
  [4856] = {.lex_state = 2},
  [4857] = {.lex_state = 2},
  [4858] = {.lex_state = 0, .external_lex_state = 41},
  [4859] = {.lex_state = 0, .external_lex_state = 42},
  [4860] = {.lex_state = 4},
  [4861] = {.lex_state = 2},
  [4862] = {.lex_state = 0, .external_lex_state = 42},
  [4863] = {.lex_state = 0, .external_lex_state = 42},
  [4864] = {.lex_state = 4},
  [4865] = {.lex_state = 2},
  [4866] = {.lex_state = 0, .external_lex_state = 41},
  [4867] = {.lex_state = 2},
  [4868] = {.lex_state = 0, .external_lex_state = 42},
  [4869] = {.lex_state = 0, .external_lex_state = 41},
  [4870] = {.lex_state = 4},
  [4871] = {.lex_state = 0, .external_lex_state = 41},
  [4872] = {.lex_state = 0, .external_lex_state = 41},
  [4873] = {.lex_state = 0, .external_lex_state = 42},
  [4874] = {.lex_state = 4},
  [4875] = {.lex_state = 4},
  [4876] = {.lex_state = 0, .external_lex_state = 42},
  [4877] = {.lex_state = 4},
  [4878] = {.lex_state = 2},
  [4879] = {.lex_state = 0, .external_lex_state = 42},
  [4880] = {.lex_state = 2},
  [4881] = {.lex_state = 4},
  [4882] = {.lex_state = 2},
  [4883] = {.lex_state = 4},
  [4884] = {.lex_state = 2},
  [4885] = {.lex_state = 0, .external_lex_state = 42},
  [4886] = {.lex_state = 2},
  [4887] = {.lex_state = 0, .external_lex_state = 42},
  [4888] = {.lex_state = 2},
  [4889] = {.lex_state = 0, .external_lex_state = 42},
  [4890] = {.lex_state = 0, .external_lex_state = 42},
  [4891] = {.lex_state = 4},
  [4892] = {.lex_state = 0, .external_lex_state = 42},
  [4893] = {.lex_state = 0, .external_lex_state = 42},
  [4894] = {.lex_state = 0, .external_lex_state = 41},
  [4895] = {.lex_state = 0, .external_lex_state = 42},
  [4896] = {.lex_state = 0, .external_lex_state = 41},
  [4897] = {.lex_state = 2},
  [4898] = {.lex_state = 0, .external_lex_state = 41},
  [4899] = {.lex_state = 0, .external_lex_state = 42},
  [4900] = {.lex_state = 0, .external_lex_state = 42},
  [4901] = {.lex_state = 0, .external_lex_state = 41},
  [4902] = {.lex_state = 0, .external_lex_state = 42},
  [4903] = {.lex_state = 0, .external_lex_state = 42},
  [4904] = {.lex_state = 0, .external_lex_state = 42},
  [4905] = {.lex_state = 0, .external_lex_state = 42},
  [4906] = {.lex_state = 0, .external_lex_state = 42},
  [4907] = {.lex_state = 4},
  [4908] = {.lex_state = 0, .external_lex_state = 42},
  [4909] = {.lex_state = 4},
  [4910] = {.lex_state = 0, .external_lex_state = 42},
  [4911] = {.lex_state = 0, .external_lex_state = 42},
  [4912] = {.lex_state = 0, .external_lex_state = 42},
  [4913] = {.lex_state = 2},
  [4914] = {.lex_state = 0, .external_lex_state = 42},
  [4915] = {.lex_state = 2},
  [4916] = {.lex_state = 0, .external_lex_state = 42},
  [4917] = {.lex_state = 0, .external_lex_state = 42},
  [4918] = {.lex_state = 0, .external_lex_state = 42},
  [4919] = {.lex_state = 2},
  [4920] = {.lex_state = 0, .external_lex_state = 42},
  [4921] = {.lex_state = 4},
  [4922] = {.lex_state = 0, .external_lex_state = 42},
  [4923] = {.lex_state = 0, .external_lex_state = 42},
  [4924] = {.lex_state = 0, .external_lex_state = 42},
  [4925] = {.lex_state = 4},
  [4926] = {.lex_state = 0, .external_lex_state = 42},
  [4927] = {.lex_state = 0, .external_lex_state = 41},
  [4928] = {.lex_state = 0, .external_lex_state = 42},
  [4929] = {.lex_state = 0, .external_lex_state = 42},
  [4930] = {.lex_state = 0, .external_lex_state = 42},
  [4931] = {.lex_state = 2},
  [4932] = {.lex_state = 0, .external_lex_state = 42},
  [4933] = {.lex_state = 4},
  [4934] = {.lex_state = 0, .external_lex_state = 42},
  [4935] = {.lex_state = 0, .external_lex_state = 42},
  [4936] = {.lex_state = 0, .external_lex_state = 42},
  [4937] = {.lex_state = 0, .external_lex_state = 42},
  [4938] = {.lex_state = 0, .external_lex_state = 42},
  [4939] = {.lex_state = 0, .external_lex_state = 42},
  [4940] = {.lex_state = 0, .external_lex_state = 42},
  [4941] = {.lex_state = 0, .external_lex_state = 42},
  [4942] = {.lex_state = 0, .external_lex_state = 42},
  [4943] = {.lex_state = 2},
  [4944] = {.lex_state = 0, .external_lex_state = 42},
  [4945] = {.lex_state = 4},
  [4946] = {.lex_state = 0, .external_lex_state = 42},
  [4947] = {.lex_state = 0, .external_lex_state = 42},
  [4948] = {.lex_state = 0, .external_lex_state = 42},
  [4949] = {.lex_state = 0, .external_lex_state = 42},
  [4950] = {.lex_state = 0, .external_lex_state = 42},
  [4951] = {.lex_state = 0, .external_lex_state = 41},
  [4952] = {.lex_state = 0, .external_lex_state = 42},
  [4953] = {.lex_state = 0, .external_lex_state = 42},
  [4954] = {.lex_state = 0, .external_lex_state = 42},
  [4955] = {.lex_state = 0, .external_lex_state = 42},
  [4956] = {.lex_state = 0, .external_lex_state = 42},
  [4957] = {.lex_state = 0, .external_lex_state = 41},
  [4958] = {.lex_state = 0, .external_lex_state = 42},
  [4959] = {.lex_state = 0, .external_lex_state = 42},
  [4960] = {.lex_state = 0, .external_lex_state = 42},
  [4961] = {.lex_state = 0, .external_lex_state = 41},
  [4962] = {.lex_state = 0, .external_lex_state = 42},
  [4963] = {.lex_state = 2},
  [4964] = {.lex_state = 0, .external_lex_state = 42},
  [4965] = {.lex_state = 0, .external_lex_state = 42},
  [4966] = {.lex_state = 0, .external_lex_state = 42},
  [4967] = {.lex_state = 0, .external_lex_state = 42},
  [4968] = {.lex_state = 0, .external_lex_state = 42},
  [4969] = {.lex_state = 4},
  [4970] = {.lex_state = 0, .external_lex_state = 42},
  [4971] = {.lex_state = 0, .external_lex_state = 42},
  [4972] = {.lex_state = 0, .external_lex_state = 42},
  [4973] = {.lex_state = 2},
  [4974] = {.lex_state = 0, .external_lex_state = 42},
  [4975] = {.lex_state = 0, .external_lex_state = 42},
  [4976] = {.lex_state = 0, .external_lex_state = 42},
  [4977] = {.lex_state = 0, .external_lex_state = 42},
  [4978] = {.lex_state = 0, .external_lex_state = 42},
  [4979] = {.lex_state = 2},
  [4980] = {.lex_state = 0, .external_lex_state = 42},
  [4981] = {.lex_state = 4},
  [4982] = {.lex_state = 0, .external_lex_state = 42},
  [4983] = {.lex_state = 0, .external_lex_state = 42},
  [4984] = {.lex_state = 0, .external_lex_state = 42},
  [4985] = {.lex_state = 0, .external_lex_state = 42},
  [4986] = {.lex_state = 0, .external_lex_state = 42},
  [4987] = {.lex_state = 0, .external_lex_state = 41},
  [4988] = {.lex_state = 0, .external_lex_state = 42},
  [4989] = {.lex_state = 0, .external_lex_state = 42},
  [4990] = {.lex_state = 0, .external_lex_state = 42},
  [4991] = {.lex_state = 0, .external_lex_state = 42},
  [4992] = {.lex_state = 0, .external_lex_state = 42},
  [4993] = {.lex_state = 2},
  [4994] = {.lex_state = 0, .external_lex_state = 42},
  [4995] = {.lex_state = 0, .external_lex_state = 42},
  [4996] = {.lex_state = 0, .external_lex_state = 42},
  [4997] = {.lex_state = 4},
  [4998] = {.lex_state = 0, .external_lex_state = 42},
  [4999] = {.lex_state = 0, .external_lex_state = 42},
  [5000] = {.lex_state = 0, .external_lex_state = 42},
  [5001] = {.lex_state = 0, .external_lex_state = 42},
  [5002] = {.lex_state = 0, .external_lex_state = 42},
  [5003] = {.lex_state = 0, .external_lex_state = 41},
  [5004] = {.lex_state = 0, .external_lex_state = 42},
  [5005] = {.lex_state = 4},
  [5006] = {.lex_state = 0, .external_lex_state = 42},
  [5007] = {.lex_state = 0, .external_lex_state = 42},
  [5008] = {.lex_state = 0, .external_lex_state = 42},
  [5009] = {.lex_state = 0, .external_lex_state = 41},
  [5010] = {.lex_state = 0, .external_lex_state = 42},
  [5011] = {.lex_state = 2},
  [5012] = {.lex_state = 0, .external_lex_state = 42},
  [5013] = {.lex_state = 0, .external_lex_state = 42},
  [5014] = {.lex_state = 0, .external_lex_state = 42},
  [5015] = {.lex_state = 0, .external_lex_state = 42},
  [5016] = {.lex_state = 0, .external_lex_state = 42},
  [5017] = {.lex_state = 0, .external_lex_state = 41},
  [5018] = {.lex_state = 0, .external_lex_state = 42},
  [5019] = {.lex_state = 0, .external_lex_state = 42},
  [5020] = {.lex_state = 0, .external_lex_state = 42},
  [5021] = {.lex_state = 0, .external_lex_state = 41},
  [5022] = {.lex_state = 0, .external_lex_state = 42},
  [5023] = {.lex_state = 2},
  [5024] = {.lex_state = 0, .external_lex_state = 42},
  [5025] = {.lex_state = 0, .external_lex_state = 42},
  [5026] = {.lex_state = 0, .external_lex_state = 42},
  [5027] = {.lex_state = 4},
  [5028] = {.lex_state = 0, .external_lex_state = 42},
  [5029] = {.lex_state = 0, .external_lex_state = 41},
  [5030] = {.lex_state = 0, .external_lex_state = 42},
  [5031] = {.lex_state = 0, .external_lex_state = 42},
  [5032] = {.lex_state = 0, .external_lex_state = 42},
  [5033] = {.lex_state = 4},
  [5034] = {.lex_state = 0, .external_lex_state = 42},
  [5035] = {.lex_state = 0, .external_lex_state = 42},
  [5036] = {.lex_state = 0, .external_lex_state = 42},
  [5037] = {.lex_state = 0, .external_lex_state = 42},
  [5038] = {.lex_state = 0, .external_lex_state = 42},
  [5039] = {.lex_state = 2},
  [5040] = {.lex_state = 0, .external_lex_state = 42},
  [5041] = {.lex_state = 4},
  [5042] = {.lex_state = 0, .external_lex_state = 42},
  [5043] = {.lex_state = 0, .external_lex_state = 42},
  [5044] = {.lex_state = 0, .external_lex_state = 42},
  [5045] = {.lex_state = 0, .external_lex_state = 42},
  [5046] = {.lex_state = 0, .external_lex_state = 42},
  [5047] = {.lex_state = 0, .external_lex_state = 41},
  [5048] = {.lex_state = 0, .external_lex_state = 42},
  [5049] = {.lex_state = 0, .external_lex_state = 42},
  [5050] = {.lex_state = 0, .external_lex_state = 42},
  [5051] = {.lex_state = 0, .external_lex_state = 42},
  [5052] = {.lex_state = 0, .external_lex_state = 42},
  [5053] = {.lex_state = 0, .external_lex_state = 41},
  [5054] = {.lex_state = 0, .external_lex_state = 42},
  [5055] = {.lex_state = 0, .external_lex_state = 42},
  [5056] = {.lex_state = 0, .external_lex_state = 41},
  [5057] = {.lex_state = 4},
  [5058] = {.lex_state = 0, .external_lex_state = 41},
  [5059] = {.lex_state = 0, .external_lex_state = 42},
  [5060] = {.lex_state = 0, .external_lex_state = 42},
  [5061] = {.lex_state = 0, .external_lex_state = 41},
  [5062] = {.lex_state = 0, .external_lex_state = 42},
  [5063] = {.lex_state = 2},
  [5064] = {.lex_state = 0, .external_lex_state = 42},
  [5065] = {.lex_state = 2},
  [5066] = {.lex_state = 0, .external_lex_state = 42},
  [5067] = {.lex_state = 4},
  [5068] = {.lex_state = 2},
  [5069] = {.lex_state = 4},
  [5070] = {.lex_state = 0, .external_lex_state = 41},
  [5071] = {.lex_state = 4},
  [5072] = {.lex_state = 0, .external_lex_state = 41},
  [5073] = {.lex_state = 0, .external_lex_state = 41},
  [5074] = {.lex_state = 2},
  [5075] = {.lex_state = 2},
  [5076] = {.lex_state = 4},
  [5077] = {.lex_state = 4},
  [5078] = {.lex_state = 4},
  [5079] = {.lex_state = 2},
  [5080] = {.lex_state = 2},
  [5081] = {.lex_state = 4},
  [5082] = {.lex_state = 0, .external_lex_state = 41},
  [5083] = {.lex_state = 0, .external_lex_state = 41},
  [5084] = {.lex_state = 2},
  [5085] = {.lex_state = 4},
  [5086] = {.lex_state = 2},
  [5087] = {.lex_state = 2},
  [5088] = {.lex_state = 4},
  [5089] = {.lex_state = 4},
  [5090] = {.lex_state = 4},
  [5091] = {.lex_state = 2},
  [5092] = {.lex_state = 0, .external_lex_state = 41},
  [5093] = {.lex_state = 0, .external_lex_state = 43},
  [5094] = {.lex_state = 0, .external_lex_state = 43},
  [5095] = {.lex_state = 0, .external_lex_state = 43},
  [5096] = {.lex_state = 0, .external_lex_state = 43},
  [5097] = {.lex_state = 0, .external_lex_state = 43},
  [5098] = {.lex_state = 0, .external_lex_state = 43},
  [5099] = {.lex_state = 0, .external_lex_state = 43},
  [5100] = {.lex_state = 0, .external_lex_state = 43},
  [5101] = {.lex_state = 0, .external_lex_state = 43},
  [5102] = {.lex_state = 0, .external_lex_state = 43},
  [5103] = {.lex_state = 0, .external_lex_state = 43},
  [5104] = {.lex_state = 0, .external_lex_state = 43},
  [5105] = {.lex_state = 0, .external_lex_state = 43},
  [5106] = {.lex_state = 0, .external_lex_state = 43},
  [5107] = {.lex_state = 0, .external_lex_state = 43},
  [5108] = {.lex_state = 0, .external_lex_state = 43},
  [5109] = {.lex_state = 0, .external_lex_state = 41},
  [5110] = {.lex_state = 0, .external_lex_state = 41},
  [5111] = {.lex_state = 0, .external_lex_state = 43},
  [5112] = {.lex_state = 0, .external_lex_state = 43},
  [5113] = {.lex_state = 0, .external_lex_state = 43},
  [5114] = {.lex_state = 0, .external_lex_state = 43},
  [5115] = {.lex_state = 0, .external_lex_state = 43},
  [5116] = {.lex_state = 0, .external_lex_state = 43},
  [5117] = {.lex_state = 0, .external_lex_state = 43},
  [5118] = {.lex_state = 2},
  [5119] = {.lex_state = 0, .external_lex_state = 43},
  [5120] = {.lex_state = 0, .external_lex_state = 43},
  [5121] = {.lex_state = 0, .external_lex_state = 42},
  [5122] = {.lex_state = 0, .external_lex_state = 43},
  [5123] = {.lex_state = 4},
  [5124] = {.lex_state = 0, .external_lex_state = 43},
  [5125] = {.lex_state = 0, .external_lex_state = 43},
  [5126] = {.lex_state = 0},
  [5127] = {.lex_state = 0},
  [5128] = {.lex_state = 0},
  [5129] = {.lex_state = 0},
  [5130] = {.lex_state = 0},
  [5131] = {.lex_state = 0},
  [5132] = {.lex_state = 0, .external_lex_state = 41},
  [5133] = {.lex_state = 0},
  [5134] = {.lex_state = 0},
  [5135] = {.lex_state = 0},
  [5136] = {.lex_state = 0, .external_lex_state = 41},
  [5137] = {.lex_state = 0},
  [5138] = {.lex_state = 0},
  [5139] = {.lex_state = 0},
  [5140] = {.lex_state = 0},
  [5141] = {.lex_state = 0},
  [5142] = {.lex_state = 0},
  [5143] = {.lex_state = 0},
  [5144] = {.lex_state = 0},
  [5145] = {.lex_state = 0, .external_lex_state = 41},
  [5146] = {.lex_state = 0, .external_lex_state = 41},
  [5147] = {.lex_state = 0},
  [5148] = {.lex_state = 0},
  [5149] = {.lex_state = 0},
  [5150] = {.lex_state = 0},
  [5151] = {.lex_state = 0},
  [5152] = {.lex_state = 0},
  [5153] = {.lex_state = 0},
  [5154] = {.lex_state = 0},
  [5155] = {.lex_state = 0},
  [5156] = {.lex_state = 0},
  [5157] = {.lex_state = 0},
  [5158] = {.lex_state = 1},
  [5159] = {.lex_state = 1},
  [5160] = {.lex_state = 1},
  [5161] = {.lex_state = 1},
  [5162] = {.lex_state = 1},
  [5163] = {.lex_state = 1},
  [5164] = {.lex_state = 1},
  [5165] = {.lex_state = 1},
  [5166] = {.lex_state = 1},
  [5167] = {.lex_state = 1},
  [5168] = {.lex_state = 1},
  [5169] = {.lex_state = 0},
  [5170] = {.lex_state = 1},
  [5171] = {.lex_state = 1},
  [5172] = {.lex_state = 1},
  [5173] = {.lex_state = 1},
  [5174] = {.lex_state = 1},
  [5175] = {.lex_state = 1},
  [5176] = {.lex_state = 1},
  [5177] = {.lex_state = 1},
  [5178] = {.lex_state = 1},
  [5179] = {.lex_state = 1},
  [5180] = {.lex_state = 1},
  [5181] = {.lex_state = 1},
  [5182] = {.lex_state = 1},
  [5183] = {.lex_state = 1},
  [5184] = {.lex_state = 1},
  [5185] = {.lex_state = 1},
  [5186] = {.lex_state = 1},
  [5187] = {.lex_state = 1},
  [5188] = {.lex_state = 1},
  [5189] = {.lex_state = 1},
  [5190] = {.lex_state = 1},
  [5191] = {.lex_state = 1},
  [5192] = {.lex_state = 1},
  [5193] = {.lex_state = 1},
  [5194] = {.lex_state = 1},
  [5195] = {.lex_state = 1},
  [5196] = {.lex_state = 1},
  [5197] = {.lex_state = 1},
  [5198] = {.lex_state = 1},
  [5199] = {.lex_state = 1},
  [5200] = {.lex_state = 1},
  [5201] = {.lex_state = 1},
  [5202] = {.lex_state = 1},
  [5203] = {.lex_state = 1},
  [5204] = {.lex_state = 1},
  [5205] = {.lex_state = 1},
  [5206] = {.lex_state = 1},
  [5207] = {.lex_state = 1},
  [5208] = {.lex_state = 1},
  [5209] = {.lex_state = 1},
  [5210] = {.lex_state = 1},
  [5211] = {.lex_state = 1},
  [5212] = {.lex_state = 1},
  [5213] = {.lex_state = 1},
  [5214] = {.lex_state = 1},
  [5215] = {.lex_state = 1},
  [5216] = {.lex_state = 1},
  [5217] = {.lex_state = 1},
  [5218] = {.lex_state = 1},
  [5219] = {.lex_state = 1},
  [5220] = {.lex_state = 1},
  [5221] = {.lex_state = 1},
  [5222] = {.lex_state = 1},
  [5223] = {.lex_state = 1},
  [5224] = {.lex_state = 1},
  [5225] = {.lex_state = 1},
  [5226] = {.lex_state = 1},
  [5227] = {.lex_state = 1},
  [5228] = {.lex_state = 1},
  [5229] = {.lex_state = 1},
  [5230] = {.lex_state = 1},
  [5231] = {.lex_state = 1},
  [5232] = {.lex_state = 1},
  [5233] = {.lex_state = 1},
  [5234] = {.lex_state = 1},
  [5235] = {.lex_state = 1},
  [5236] = {.lex_state = 1},
  [5237] = {.lex_state = 1},
  [5238] = {.lex_state = 1},
  [5239] = {.lex_state = 1},
  [5240] = {.lex_state = 1},
  [5241] = {.lex_state = 1},
  [5242] = {.lex_state = 1},
  [5243] = {.lex_state = 1},
  [5244] = {.lex_state = 1},
  [5245] = {.lex_state = 1},
  [5246] = {.lex_state = 1},
  [5247] = {.lex_state = 1},
  [5248] = {.lex_state = 1},
  [5249] = {.lex_state = 1},
  [5250] = {.lex_state = 1},
  [5251] = {.lex_state = 1},
  [5252] = {.lex_state = 1},
  [5253] = {.lex_state = 1},
  [5254] = {.lex_state = 1},
  [5255] = {.lex_state = 1},
  [5256] = {.lex_state = 1},
  [5257] = {.lex_state = 1},
  [5258] = {.lex_state = 1},
  [5259] = {.lex_state = 1},
  [5260] = {.lex_state = 1},
  [5261] = {.lex_state = 1},
  [5262] = {.lex_state = 1},
  [5263] = {.lex_state = 1},
  [5264] = {.lex_state = 1},
  [5265] = {.lex_state = 1},
  [5266] = {.lex_state = 1},
  [5267] = {.lex_state = 1},
  [5268] = {.lex_state = 1},
  [5269] = {.lex_state = 1},
  [5270] = {.lex_state = 1},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [anon_sym_BSLASH] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_repeat] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_LT_DASH] = ACTIONS(1),
    [anon_sym_LT_LT_DASH] = ACTIONS(1),
    [anon_sym_COLON_EQ] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_DASH_GT_GT] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_STAR_STAR] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [aux_sym_binary_operator_token1] = ACTIONS(1),
    [anon_sym_PIPE_GT] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_DOLLAR] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1),
    [anon_sym_L] = ACTIONS(1),
    [anon_sym_i] = ACTIONS(1),
    [aux_sym__hex_literal_token1] = ACTIONS(1),
    [sym__number_literal] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [sym_return] = ACTIONS(1),
    [sym_next] = ACTIONS(1),
    [sym_break] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [sym_null] = ACTIONS(1),
    [sym_inf] = ACTIONS(1),
    [sym_nan] = ACTIONS(1),
    [anon_sym_NA] = ACTIONS(1),
    [anon_sym_NA_integer_] = ACTIONS(1),
    [anon_sym_NA_real_] = ACTIONS(1),
    [anon_sym_NA_complex_] = ACTIONS(1),
    [anon_sym_NA_character_] = ACTIONS(1),
    [sym_dots] = ACTIONS(1),
    [sym_dot_dot_i] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1),
    [sym__newline] = ACTIONS(1),
    [sym__semicolon] = ACTIONS(1),
    [sym__raw_string_literal] = ACTIONS(1),
    [sym__external_else] = ACTIONS(1),
    [sym__external_open_parenthesis] = ACTIONS(1),
    [sym__external_close_parenthesis] = ACTIONS(1),
    [sym__external_open_brace] = ACTIONS(1),
    [sym__external_close_brace] = ACTIONS(1),
    [sym__external_open_bracket] = ACTIONS(1),
    [sym__external_close_bracket] = ACTIONS(1),
    [sym__external_open_bracket2] = ACTIONS(1),
    [sym__external_close_bracket2] = ACTIONS(1),
  },
  [1] = {
    [sym_program] = STATE(5169),
    [sym_function_definition] = STATE(2018),
    [sym_if_statement] = STATE(2018),
    [sym_for_statement] = STATE(2018),
    [sym_while_statement] = STATE(2018),
    [sym_repeat_statement] = STATE(2018),
    [sym_braced_expression] = STATE(2018),
    [sym_parenthesized_expression] = STATE(2018),
    [sym_call] = STATE(2018),
    [sym_subset] = STATE(2018),
    [sym_subset2] = STATE(2018),
    [sym_unary_operator] = STATE(2018),
    [sym_binary_operator] = STATE(2018),
    [sym_extract_operator] = STATE(2018),
    [sym_namespace_operator] = STATE(2018),
    [sym_integer] = STATE(2018),
    [sym_complex] = STATE(2018),
    [sym_float] = STATE(2018),
    [sym__hex_literal] = STATE(2739),
    [sym__float_literal] = STATE(2739),
    [sym_string] = STATE(2562),
    [sym__single_quoted_string] = STATE(2738),
    [sym__double_quoted_string] = STATE(2737),
    [sym_na] = STATE(2018),
    [sym__expression] = STATE(2018),
    [sym__string_or_identifier] = STATE(5152),
    [sym__open_parenthesis] = STATE(293),
    [sym__open_brace] = STATE(292),
    [aux_sym_program_repeat1] = STATE(2778),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(9),
    [anon_sym_function] = ACTIONS(11),
    [anon_sym_if] = ACTIONS(13),
    [anon_sym_for] = ACTIONS(15),
    [anon_sym_while] = ACTIONS(17),
    [anon_sym_repeat] = ACTIONS(19),
    [anon_sym_QMARK] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_DASH] = ACTIONS(27),
    [aux_sym__hex_literal_token1] = ACTIONS(29),
    [sym__number_literal] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE] = ACTIONS(35),
    [sym_return] = ACTIONS(37),
    [sym_next] = ACTIONS(37),
    [sym_break] = ACTIONS(37),
    [sym_true] = ACTIONS(37),
    [sym_false] = ACTIONS(37),
    [sym_null] = ACTIONS(37),
    [sym_inf] = ACTIONS(37),
    [sym_nan] = ACTIONS(37),
    [anon_sym_NA] = ACTIONS(39),
    [anon_sym_NA_integer_] = ACTIONS(39),
    [anon_sym_NA_real_] = ACTIONS(39),
    [anon_sym_NA_complex_] = ACTIONS(39),
    [anon_sym_NA_character_] = ACTIONS(39),
    [sym_dots] = ACTIONS(37),
    [sym_dot_dot_i] = ACTIONS(41),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(43),
    [sym__semicolon] = ACTIONS(43),
    [sym__raw_string_literal] = ACTIONS(45),
    [sym__external_open_parenthesis] = ACTIONS(47),
    [sym__external_open_brace] = ACTIONS(49),
  },
  [2] = {
    [sym_function_definition] = STATE(599),
    [sym_if_statement] = STATE(599),
    [sym_for_statement] = STATE(599),
    [sym_while_statement] = STATE(599),
    [sym_repeat_statement] = STATE(599),
    [sym_braced_expression] = STATE(599),
    [sym_parenthesized_expression] = STATE(599),
    [sym_call] = STATE(599),
    [sym_subset] = STATE(599),
    [sym_subset2] = STATE(599),
    [sym_unary_operator] = STATE(599),
    [sym_binary_operator] = STATE(599),
    [sym_extract_operator] = STATE(599),
    [sym_namespace_operator] = STATE(599),
    [sym_integer] = STATE(599),
    [sym_complex] = STATE(599),
    [sym_float] = STATE(599),
    [sym__hex_literal] = STATE(1984),
    [sym__float_literal] = STATE(1984),
    [sym_string] = STATE(1982),
    [sym__single_quoted_string] = STATE(1985),
    [sym__double_quoted_string] = STATE(1990),
    [sym_na] = STATE(599),
    [sym__expression] = STATE(599),
    [sym__string_or_identifier] = STATE(5151),
    [sym__open_parenthesis] = STATE(19),
    [sym__open_brace] = STATE(4),
    [sym__close_brace] = STATE(2244),
    [aux_sym_braced_expression_repeat1] = STATE(66),
    [ts_builtin_sym_end] = ACTIONS(51),
    [sym_identifier] = ACTIONS(53),
    [anon_sym_BSLASH] = ACTIONS(55),
    [anon_sym_function] = ACTIONS(57),
    [anon_sym_EQ] = ACTIONS(59),
    [anon_sym_if] = ACTIONS(61),
    [anon_sym_for] = ACTIONS(63),
    [anon_sym_while] = ACTIONS(65),
    [anon_sym_repeat] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_LT_DASH] = ACTIONS(51),
    [anon_sym_LT_LT_DASH] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(51),
    [anon_sym_DASH_GT] = ACTIONS(59),
    [anon_sym_DASH_GT_GT] = ACTIONS(51),
    [anon_sym_PIPE] = ACTIONS(59),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_AMP_AMP] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(59),
    [anon_sym_LT_EQ] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(59),
    [anon_sym_GT_EQ] = ACTIONS(51),
    [anon_sym_EQ_EQ] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(51),
    [anon_sym_CARET] = ACTIONS(51),
    [aux_sym_binary_operator_token1] = ACTIONS(51),
    [anon_sym_PIPE_GT] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(59),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_AT] = ACTIONS(51),
    [aux_sym__hex_literal_token1] = ACTIONS(79),
    [sym__number_literal] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_return] = ACTIONS(87),
    [sym_next] = ACTIONS(87),
    [sym_break] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_inf] = ACTIONS(87),
    [sym_nan] = ACTIONS(87),
    [anon_sym_NA] = ACTIONS(89),
    [anon_sym_NA_integer_] = ACTIONS(89),
    [anon_sym_NA_real_] = ACTIONS(89),
    [anon_sym_NA_complex_] = ACTIONS(89),
    [anon_sym_NA_character_] = ACTIONS(89),
    [sym_dots] = ACTIONS(87),
    [sym_dot_dot_i] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(51),
    [sym__newline] = ACTIONS(93),
    [sym__semicolon] = ACTIONS(93),
    [sym__raw_string_literal] = ACTIONS(95),
    [sym__external_else] = ACTIONS(51),
    [sym__external_open_parenthesis] = ACTIONS(97),
    [sym__external_close_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(99),
    [sym__external_close_brace] = ACTIONS(101),
    [sym__external_open_bracket] = ACTIONS(51),
    [sym__external_open_bracket2] = ACTIONS(51),
  },
  [3] = {
    [sym_function_definition] = STATE(506),
    [sym_if_statement] = STATE(506),
    [sym_for_statement] = STATE(506),
    [sym_while_statement] = STATE(506),
    [sym_repeat_statement] = STATE(506),
    [sym_braced_expression] = STATE(506),
    [sym_parenthesized_expression] = STATE(506),
    [sym_call] = STATE(506),
    [sym_subset] = STATE(506),
    [sym_subset2] = STATE(506),
    [sym_unary_operator] = STATE(506),
    [sym_binary_operator] = STATE(506),
    [sym_extract_operator] = STATE(506),
    [sym_namespace_operator] = STATE(506),
    [sym_integer] = STATE(506),
    [sym_complex] = STATE(506),
    [sym_float] = STATE(506),
    [sym__hex_literal] = STATE(2021),
    [sym__float_literal] = STATE(2021),
    [sym_string] = STATE(2016),
    [sym__single_quoted_string] = STATE(2027),
    [sym__double_quoted_string] = STATE(2041),
    [sym_na] = STATE(506),
    [sym__expression] = STATE(506),
    [sym__string_or_identifier] = STATE(5131),
    [sym__open_parenthesis] = STATE(20),
    [sym__close_parenthesis] = STATE(2443),
    [sym__open_brace] = STATE(10),
    [aux_sym_parenthesized_expression_repeat1] = STATE(7),
    [sym_identifier] = ACTIONS(103),
    [anon_sym_BSLASH] = ACTIONS(105),
    [anon_sym_function] = ACTIONS(107),
    [anon_sym_EQ] = ACTIONS(109),
    [anon_sym_if] = ACTIONS(111),
    [anon_sym_for] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_repeat] = ACTIONS(117),
    [anon_sym_QMARK] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_BANG] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(125),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_LT_DASH] = ACTIONS(129),
    [anon_sym_LT_LT_DASH] = ACTIONS(129),
    [anon_sym_COLON_EQ] = ACTIONS(129),
    [anon_sym_DASH_GT] = ACTIONS(109),
    [anon_sym_DASH_GT_GT] = ACTIONS(129),
    [anon_sym_PIPE] = ACTIONS(109),
    [anon_sym_AMP] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_STAR_STAR] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [aux_sym_binary_operator_token1] = ACTIONS(129),
    [anon_sym_PIPE_GT] = ACTIONS(129),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(129),
    [anon_sym_AT] = ACTIONS(129),
    [aux_sym__hex_literal_token1] = ACTIONS(131),
    [sym__number_literal] = ACTIONS(133),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(137),
    [sym_return] = ACTIONS(139),
    [sym_next] = ACTIONS(139),
    [sym_break] = ACTIONS(139),
    [sym_true] = ACTIONS(139),
    [sym_false] = ACTIONS(139),
    [sym_null] = ACTIONS(139),
    [sym_inf] = ACTIONS(139),
    [sym_nan] = ACTIONS(139),
    [anon_sym_NA] = ACTIONS(141),
    [anon_sym_NA_integer_] = ACTIONS(141),
    [anon_sym_NA_real_] = ACTIONS(141),
    [anon_sym_NA_complex_] = ACTIONS(141),
    [anon_sym_NA_character_] = ACTIONS(141),
    [sym_dots] = ACTIONS(139),
    [sym_dot_dot_i] = ACTIONS(143),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(129),
    [sym__newline] = ACTIONS(145),
    [sym__semicolon] = ACTIONS(129),
    [sym__raw_string_literal] = ACTIONS(147),
    [sym__external_else] = ACTIONS(129),
    [sym__external_open_parenthesis] = ACTIONS(149),
    [sym__external_close_parenthesis] = ACTIONS(151),
    [sym__external_open_brace] = ACTIONS(153),
    [sym__external_close_brace] = ACTIONS(129),
    [sym__external_open_bracket] = ACTIONS(129),
    [sym__external_close_bracket] = ACTIONS(129),
    [sym__external_open_bracket2] = ACTIONS(129),
  },
  [4] = {
    [sym_function_definition] = STATE(599),
    [sym_if_statement] = STATE(599),
    [sym_for_statement] = STATE(599),
    [sym_while_statement] = STATE(599),
    [sym_repeat_statement] = STATE(599),
    [sym_braced_expression] = STATE(599),
    [sym_parenthesized_expression] = STATE(599),
    [sym_call] = STATE(599),
    [sym_subset] = STATE(599),
    [sym_subset2] = STATE(599),
    [sym_unary_operator] = STATE(599),
    [sym_binary_operator] = STATE(599),
    [sym_extract_operator] = STATE(599),
    [sym_namespace_operator] = STATE(599),
    [sym_integer] = STATE(599),
    [sym_complex] = STATE(599),
    [sym_float] = STATE(599),
    [sym__hex_literal] = STATE(1984),
    [sym__float_literal] = STATE(1984),
    [sym_string] = STATE(1982),
    [sym__single_quoted_string] = STATE(1985),
    [sym__double_quoted_string] = STATE(1990),
    [sym_na] = STATE(599),
    [sym__expression] = STATE(599),
    [sym__string_or_identifier] = STATE(5151),
    [sym__open_parenthesis] = STATE(19),
    [sym__open_brace] = STATE(4),
    [sym__close_brace] = STATE(2256),
    [aux_sym_braced_expression_repeat1] = STATE(2),
    [ts_builtin_sym_end] = ACTIONS(155),
    [sym_identifier] = ACTIONS(53),
    [anon_sym_BSLASH] = ACTIONS(55),
    [anon_sym_function] = ACTIONS(57),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(61),
    [anon_sym_for] = ACTIONS(63),
    [anon_sym_while] = ACTIONS(65),
    [anon_sym_repeat] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_LT_DASH] = ACTIONS(155),
    [anon_sym_LT_LT_DASH] = ACTIONS(155),
    [anon_sym_COLON_EQ] = ACTIONS(155),
    [anon_sym_DASH_GT] = ACTIONS(157),
    [anon_sym_DASH_GT_GT] = ACTIONS(155),
    [anon_sym_PIPE] = ACTIONS(157),
    [anon_sym_AMP] = ACTIONS(157),
    [anon_sym_PIPE_PIPE] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(157),
    [anon_sym_LT_EQ] = ACTIONS(155),
    [anon_sym_GT] = ACTIONS(157),
    [anon_sym_GT_EQ] = ACTIONS(155),
    [anon_sym_EQ_EQ] = ACTIONS(155),
    [anon_sym_BANG_EQ] = ACTIONS(155),
    [anon_sym_STAR] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(155),
    [anon_sym_STAR_STAR] = ACTIONS(155),
    [anon_sym_CARET] = ACTIONS(155),
    [aux_sym_binary_operator_token1] = ACTIONS(155),
    [anon_sym_PIPE_GT] = ACTIONS(155),
    [anon_sym_COLON] = ACTIONS(157),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(155),
    [aux_sym__hex_literal_token1] = ACTIONS(79),
    [sym__number_literal] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_return] = ACTIONS(87),
    [sym_next] = ACTIONS(87),
    [sym_break] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_inf] = ACTIONS(87),
    [sym_nan] = ACTIONS(87),
    [anon_sym_NA] = ACTIONS(89),
    [anon_sym_NA_integer_] = ACTIONS(89),
    [anon_sym_NA_real_] = ACTIONS(89),
    [anon_sym_NA_complex_] = ACTIONS(89),
    [anon_sym_NA_character_] = ACTIONS(89),
    [sym_dots] = ACTIONS(87),
    [sym_dot_dot_i] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(155),
    [sym__newline] = ACTIONS(93),
    [sym__semicolon] = ACTIONS(93),
    [sym__raw_string_literal] = ACTIONS(95),
    [sym__external_else] = ACTIONS(155),
    [sym__external_open_parenthesis] = ACTIONS(97),
    [sym__external_close_parenthesis] = ACTIONS(155),
    [sym__external_open_brace] = ACTIONS(99),
    [sym__external_close_brace] = ACTIONS(159),
    [sym__external_open_bracket] = ACTIONS(155),
    [sym__external_open_bracket2] = ACTIONS(155),
  },
  [5] = {
    [sym_function_definition] = STATE(502),
    [sym_if_statement] = STATE(502),
    [sym_for_statement] = STATE(502),
    [sym_while_statement] = STATE(502),
    [sym_repeat_statement] = STATE(502),
    [sym_braced_expression] = STATE(502),
    [sym_parenthesized_expression] = STATE(502),
    [sym_call] = STATE(502),
    [sym_subset] = STATE(502),
    [sym_subset2] = STATE(502),
    [sym_unary_operator] = STATE(502),
    [sym_binary_operator] = STATE(502),
    [sym_extract_operator] = STATE(502),
    [sym_namespace_operator] = STATE(502),
    [sym_integer] = STATE(502),
    [sym_complex] = STATE(502),
    [sym_float] = STATE(502),
    [sym__hex_literal] = STATE(1925),
    [sym__float_literal] = STATE(1925),
    [sym_string] = STATE(1927),
    [sym__single_quoted_string] = STATE(1923),
    [sym__double_quoted_string] = STATE(1934),
    [sym_na] = STATE(502),
    [sym__expression] = STATE(502),
    [sym__string_or_identifier] = STATE(5137),
    [sym__open_parenthesis] = STATE(14),
    [sym__close_parenthesis] = STATE(2551),
    [sym__open_brace] = STATE(18),
    [aux_sym_parenthesized_expression_repeat1] = STATE(9),
    [sym_identifier] = ACTIONS(161),
    [anon_sym_BSLASH] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(109),
    [anon_sym_if] = ACTIONS(167),
    [anon_sym_for] = ACTIONS(169),
    [anon_sym_while] = ACTIONS(171),
    [anon_sym_repeat] = ACTIONS(173),
    [anon_sym_QMARK] = ACTIONS(175),
    [anon_sym_TILDE] = ACTIONS(177),
    [anon_sym_BANG] = ACTIONS(179),
    [anon_sym_PLUS] = ACTIONS(181),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_LT_DASH] = ACTIONS(129),
    [anon_sym_LT_LT_DASH] = ACTIONS(129),
    [anon_sym_COLON_EQ] = ACTIONS(129),
    [anon_sym_DASH_GT] = ACTIONS(109),
    [anon_sym_DASH_GT_GT] = ACTIONS(129),
    [anon_sym_PIPE] = ACTIONS(109),
    [anon_sym_AMP] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_STAR_STAR] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [aux_sym_binary_operator_token1] = ACTIONS(129),
    [anon_sym_PIPE_GT] = ACTIONS(129),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(129),
    [anon_sym_AT] = ACTIONS(129),
    [aux_sym__hex_literal_token1] = ACTIONS(185),
    [sym__number_literal] = ACTIONS(187),
    [anon_sym_SQUOTE] = ACTIONS(189),
    [anon_sym_DQUOTE] = ACTIONS(191),
    [sym_return] = ACTIONS(193),
    [sym_next] = ACTIONS(193),
    [sym_break] = ACTIONS(193),
    [sym_true] = ACTIONS(193),
    [sym_false] = ACTIONS(193),
    [sym_null] = ACTIONS(193),
    [sym_inf] = ACTIONS(193),
    [sym_nan] = ACTIONS(193),
    [anon_sym_NA] = ACTIONS(195),
    [anon_sym_NA_integer_] = ACTIONS(195),
    [anon_sym_NA_real_] = ACTIONS(195),
    [anon_sym_NA_complex_] = ACTIONS(195),
    [anon_sym_NA_character_] = ACTIONS(195),
    [sym_dots] = ACTIONS(193),
    [sym_dot_dot_i] = ACTIONS(197),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(129),
    [sym__newline] = ACTIONS(199),
    [sym__semicolon] = ACTIONS(129),
    [sym__raw_string_literal] = ACTIONS(201),
    [sym__external_else] = ACTIONS(129),
    [sym__external_open_parenthesis] = ACTIONS(203),
    [sym__external_close_parenthesis] = ACTIONS(205),
    [sym__external_open_brace] = ACTIONS(207),
    [sym__external_close_brace] = ACTIONS(129),
    [sym__external_open_bracket] = ACTIONS(129),
    [sym__external_open_bracket2] = ACTIONS(129),
    [sym__external_close_bracket2] = ACTIONS(129),
  },
  [6] = {
    [sym_function_definition] = STATE(502),
    [sym_if_statement] = STATE(502),
    [sym_for_statement] = STATE(502),
    [sym_while_statement] = STATE(502),
    [sym_repeat_statement] = STATE(502),
    [sym_braced_expression] = STATE(502),
    [sym_parenthesized_expression] = STATE(502),
    [sym_call] = STATE(502),
    [sym_subset] = STATE(502),
    [sym_subset2] = STATE(502),
    [sym_unary_operator] = STATE(502),
    [sym_binary_operator] = STATE(502),
    [sym_extract_operator] = STATE(502),
    [sym_namespace_operator] = STATE(502),
    [sym_integer] = STATE(502),
    [sym_complex] = STATE(502),
    [sym_float] = STATE(502),
    [sym__hex_literal] = STATE(1925),
    [sym__float_literal] = STATE(1925),
    [sym_string] = STATE(1927),
    [sym__single_quoted_string] = STATE(1923),
    [sym__double_quoted_string] = STATE(1934),
    [sym_na] = STATE(502),
    [sym__expression] = STATE(502),
    [sym__string_or_identifier] = STATE(5137),
    [sym__open_parenthesis] = STATE(14),
    [sym__close_parenthesis] = STATE(2358),
    [sym__open_brace] = STATE(18),
    [aux_sym_parenthesized_expression_repeat1] = STATE(95),
    [sym_identifier] = ACTIONS(161),
    [anon_sym_BSLASH] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(167),
    [anon_sym_for] = ACTIONS(169),
    [anon_sym_while] = ACTIONS(171),
    [anon_sym_repeat] = ACTIONS(173),
    [anon_sym_QMARK] = ACTIONS(175),
    [anon_sym_TILDE] = ACTIONS(177),
    [anon_sym_BANG] = ACTIONS(179),
    [anon_sym_PLUS] = ACTIONS(181),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_LT_DASH] = ACTIONS(211),
    [anon_sym_LT_LT_DASH] = ACTIONS(211),
    [anon_sym_COLON_EQ] = ACTIONS(211),
    [anon_sym_DASH_GT] = ACTIONS(209),
    [anon_sym_DASH_GT_GT] = ACTIONS(211),
    [anon_sym_PIPE] = ACTIONS(209),
    [anon_sym_AMP] = ACTIONS(209),
    [anon_sym_PIPE_PIPE] = ACTIONS(211),
    [anon_sym_AMP_AMP] = ACTIONS(211),
    [anon_sym_LT] = ACTIONS(209),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_GT] = ACTIONS(209),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [anon_sym_EQ_EQ] = ACTIONS(211),
    [anon_sym_BANG_EQ] = ACTIONS(211),
    [anon_sym_STAR] = ACTIONS(209),
    [anon_sym_SLASH] = ACTIONS(211),
    [anon_sym_STAR_STAR] = ACTIONS(211),
    [anon_sym_CARET] = ACTIONS(211),
    [aux_sym_binary_operator_token1] = ACTIONS(211),
    [anon_sym_PIPE_GT] = ACTIONS(211),
    [anon_sym_COLON] = ACTIONS(209),
    [anon_sym_DOLLAR] = ACTIONS(211),
    [anon_sym_AT] = ACTIONS(211),
    [aux_sym__hex_literal_token1] = ACTIONS(185),
    [sym__number_literal] = ACTIONS(187),
    [anon_sym_SQUOTE] = ACTIONS(189),
    [anon_sym_DQUOTE] = ACTIONS(191),
    [sym_return] = ACTIONS(193),
    [sym_next] = ACTIONS(193),
    [sym_break] = ACTIONS(193),
    [sym_true] = ACTIONS(193),
    [sym_false] = ACTIONS(193),
    [sym_null] = ACTIONS(193),
    [sym_inf] = ACTIONS(193),
    [sym_nan] = ACTIONS(193),
    [anon_sym_NA] = ACTIONS(195),
    [anon_sym_NA_integer_] = ACTIONS(195),
    [anon_sym_NA_real_] = ACTIONS(195),
    [anon_sym_NA_complex_] = ACTIONS(195),
    [anon_sym_NA_character_] = ACTIONS(195),
    [sym_dots] = ACTIONS(193),
    [sym_dot_dot_i] = ACTIONS(197),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(211),
    [sym__newline] = ACTIONS(199),
    [sym__semicolon] = ACTIONS(211),
    [sym__raw_string_literal] = ACTIONS(201),
    [sym__external_else] = ACTIONS(211),
    [sym__external_open_parenthesis] = ACTIONS(203),
    [sym__external_close_parenthesis] = ACTIONS(213),
    [sym__external_open_brace] = ACTIONS(207),
    [sym__external_close_brace] = ACTIONS(211),
    [sym__external_open_bracket] = ACTIONS(211),
    [sym__external_open_bracket2] = ACTIONS(211),
    [sym__external_close_bracket2] = ACTIONS(211),
  },
  [7] = {
    [sym_function_definition] = STATE(506),
    [sym_if_statement] = STATE(506),
    [sym_for_statement] = STATE(506),
    [sym_while_statement] = STATE(506),
    [sym_repeat_statement] = STATE(506),
    [sym_braced_expression] = STATE(506),
    [sym_parenthesized_expression] = STATE(506),
    [sym_call] = STATE(506),
    [sym_subset] = STATE(506),
    [sym_subset2] = STATE(506),
    [sym_unary_operator] = STATE(506),
    [sym_binary_operator] = STATE(506),
    [sym_extract_operator] = STATE(506),
    [sym_namespace_operator] = STATE(506),
    [sym_integer] = STATE(506),
    [sym_complex] = STATE(506),
    [sym_float] = STATE(506),
    [sym__hex_literal] = STATE(2021),
    [sym__float_literal] = STATE(2021),
    [sym_string] = STATE(2016),
    [sym__single_quoted_string] = STATE(2027),
    [sym__double_quoted_string] = STATE(2041),
    [sym_na] = STATE(506),
    [sym__expression] = STATE(506),
    [sym__string_or_identifier] = STATE(5131),
    [sym__open_parenthesis] = STATE(20),
    [sym__close_parenthesis] = STATE(2457),
    [sym__open_brace] = STATE(10),
    [aux_sym_parenthesized_expression_repeat1] = STATE(83),
    [sym_identifier] = ACTIONS(103),
    [anon_sym_BSLASH] = ACTIONS(105),
    [anon_sym_function] = ACTIONS(107),
    [anon_sym_EQ] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(111),
    [anon_sym_for] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_repeat] = ACTIONS(117),
    [anon_sym_QMARK] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_BANG] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(125),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_LT_DASH] = ACTIONS(211),
    [anon_sym_LT_LT_DASH] = ACTIONS(211),
    [anon_sym_COLON_EQ] = ACTIONS(211),
    [anon_sym_DASH_GT] = ACTIONS(209),
    [anon_sym_DASH_GT_GT] = ACTIONS(211),
    [anon_sym_PIPE] = ACTIONS(209),
    [anon_sym_AMP] = ACTIONS(209),
    [anon_sym_PIPE_PIPE] = ACTIONS(211),
    [anon_sym_AMP_AMP] = ACTIONS(211),
    [anon_sym_LT] = ACTIONS(209),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_GT] = ACTIONS(209),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [anon_sym_EQ_EQ] = ACTIONS(211),
    [anon_sym_BANG_EQ] = ACTIONS(211),
    [anon_sym_STAR] = ACTIONS(209),
    [anon_sym_SLASH] = ACTIONS(211),
    [anon_sym_STAR_STAR] = ACTIONS(211),
    [anon_sym_CARET] = ACTIONS(211),
    [aux_sym_binary_operator_token1] = ACTIONS(211),
    [anon_sym_PIPE_GT] = ACTIONS(211),
    [anon_sym_COLON] = ACTIONS(209),
    [anon_sym_DOLLAR] = ACTIONS(211),
    [anon_sym_AT] = ACTIONS(211),
    [aux_sym__hex_literal_token1] = ACTIONS(131),
    [sym__number_literal] = ACTIONS(133),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(137),
    [sym_return] = ACTIONS(139),
    [sym_next] = ACTIONS(139),
    [sym_break] = ACTIONS(139),
    [sym_true] = ACTIONS(139),
    [sym_false] = ACTIONS(139),
    [sym_null] = ACTIONS(139),
    [sym_inf] = ACTIONS(139),
    [sym_nan] = ACTIONS(139),
    [anon_sym_NA] = ACTIONS(141),
    [anon_sym_NA_integer_] = ACTIONS(141),
    [anon_sym_NA_real_] = ACTIONS(141),
    [anon_sym_NA_complex_] = ACTIONS(141),
    [anon_sym_NA_character_] = ACTIONS(141),
    [sym_dots] = ACTIONS(139),
    [sym_dot_dot_i] = ACTIONS(143),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(211),
    [sym__newline] = ACTIONS(145),
    [sym__semicolon] = ACTIONS(211),
    [sym__raw_string_literal] = ACTIONS(147),
    [sym__external_else] = ACTIONS(211),
    [sym__external_open_parenthesis] = ACTIONS(149),
    [sym__external_close_parenthesis] = ACTIONS(215),
    [sym__external_open_brace] = ACTIONS(153),
    [sym__external_close_brace] = ACTIONS(211),
    [sym__external_open_bracket] = ACTIONS(211),
    [sym__external_close_bracket] = ACTIONS(211),
    [sym__external_open_bracket2] = ACTIONS(211),
  },
  [8] = {
    [sym_function_definition] = STATE(506),
    [sym_if_statement] = STATE(506),
    [sym_for_statement] = STATE(506),
    [sym_while_statement] = STATE(506),
    [sym_repeat_statement] = STATE(506),
    [sym_braced_expression] = STATE(506),
    [sym_parenthesized_expression] = STATE(506),
    [sym_call] = STATE(506),
    [sym_subset] = STATE(506),
    [sym_subset2] = STATE(506),
    [sym_unary_operator] = STATE(506),
    [sym_binary_operator] = STATE(506),
    [sym_extract_operator] = STATE(506),
    [sym_namespace_operator] = STATE(506),
    [sym_integer] = STATE(506),
    [sym_complex] = STATE(506),
    [sym_float] = STATE(506),
    [sym__hex_literal] = STATE(2021),
    [sym__float_literal] = STATE(2021),
    [sym_string] = STATE(2016),
    [sym__single_quoted_string] = STATE(2027),
    [sym__double_quoted_string] = STATE(2041),
    [sym_na] = STATE(506),
    [sym__expression] = STATE(506),
    [sym__string_or_identifier] = STATE(5131),
    [sym__open_parenthesis] = STATE(20),
    [sym__close_parenthesis] = STATE(2328),
    [sym__open_brace] = STATE(10),
    [aux_sym_parenthesized_expression_repeat1] = STATE(83),
    [sym_identifier] = ACTIONS(103),
    [anon_sym_BSLASH] = ACTIONS(105),
    [anon_sym_function] = ACTIONS(107),
    [anon_sym_EQ] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(111),
    [anon_sym_for] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_repeat] = ACTIONS(117),
    [anon_sym_QMARK] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_BANG] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(125),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_LT_DASH] = ACTIONS(211),
    [anon_sym_LT_LT_DASH] = ACTIONS(211),
    [anon_sym_COLON_EQ] = ACTIONS(211),
    [anon_sym_DASH_GT] = ACTIONS(209),
    [anon_sym_DASH_GT_GT] = ACTIONS(211),
    [anon_sym_PIPE] = ACTIONS(209),
    [anon_sym_AMP] = ACTIONS(209),
    [anon_sym_PIPE_PIPE] = ACTIONS(211),
    [anon_sym_AMP_AMP] = ACTIONS(211),
    [anon_sym_LT] = ACTIONS(209),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_GT] = ACTIONS(209),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [anon_sym_EQ_EQ] = ACTIONS(211),
    [anon_sym_BANG_EQ] = ACTIONS(211),
    [anon_sym_STAR] = ACTIONS(209),
    [anon_sym_SLASH] = ACTIONS(211),
    [anon_sym_STAR_STAR] = ACTIONS(211),
    [anon_sym_CARET] = ACTIONS(211),
    [aux_sym_binary_operator_token1] = ACTIONS(211),
    [anon_sym_PIPE_GT] = ACTIONS(211),
    [anon_sym_COLON] = ACTIONS(209),
    [anon_sym_DOLLAR] = ACTIONS(211),
    [anon_sym_AT] = ACTIONS(211),
    [aux_sym__hex_literal_token1] = ACTIONS(131),
    [sym__number_literal] = ACTIONS(133),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(137),
    [sym_return] = ACTIONS(139),
    [sym_next] = ACTIONS(139),
    [sym_break] = ACTIONS(139),
    [sym_true] = ACTIONS(139),
    [sym_false] = ACTIONS(139),
    [sym_null] = ACTIONS(139),
    [sym_inf] = ACTIONS(139),
    [sym_nan] = ACTIONS(139),
    [anon_sym_NA] = ACTIONS(141),
    [anon_sym_NA_integer_] = ACTIONS(141),
    [anon_sym_NA_real_] = ACTIONS(141),
    [anon_sym_NA_complex_] = ACTIONS(141),
    [anon_sym_NA_character_] = ACTIONS(141),
    [sym_dots] = ACTIONS(139),
    [sym_dot_dot_i] = ACTIONS(143),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(211),
    [sym__newline] = ACTIONS(145),
    [sym__semicolon] = ACTIONS(211),
    [sym__raw_string_literal] = ACTIONS(147),
    [sym__external_else] = ACTIONS(211),
    [sym__external_open_parenthesis] = ACTIONS(149),
    [sym__external_close_parenthesis] = ACTIONS(217),
    [sym__external_open_brace] = ACTIONS(153),
    [sym__external_close_brace] = ACTIONS(211),
    [sym__external_open_bracket] = ACTIONS(211),
    [sym__external_close_bracket] = ACTIONS(211),
    [sym__external_open_bracket2] = ACTIONS(211),
  },
  [9] = {
    [sym_function_definition] = STATE(502),
    [sym_if_statement] = STATE(502),
    [sym_for_statement] = STATE(502),
    [sym_while_statement] = STATE(502),
    [sym_repeat_statement] = STATE(502),
    [sym_braced_expression] = STATE(502),
    [sym_parenthesized_expression] = STATE(502),
    [sym_call] = STATE(502),
    [sym_subset] = STATE(502),
    [sym_subset2] = STATE(502),
    [sym_unary_operator] = STATE(502),
    [sym_binary_operator] = STATE(502),
    [sym_extract_operator] = STATE(502),
    [sym_namespace_operator] = STATE(502),
    [sym_integer] = STATE(502),
    [sym_complex] = STATE(502),
    [sym_float] = STATE(502),
    [sym__hex_literal] = STATE(1925),
    [sym__float_literal] = STATE(1925),
    [sym_string] = STATE(1927),
    [sym__single_quoted_string] = STATE(1923),
    [sym__double_quoted_string] = STATE(1934),
    [sym_na] = STATE(502),
    [sym__expression] = STATE(502),
    [sym__string_or_identifier] = STATE(5137),
    [sym__open_parenthesis] = STATE(14),
    [sym__close_parenthesis] = STATE(2516),
    [sym__open_brace] = STATE(18),
    [aux_sym_parenthesized_expression_repeat1] = STATE(95),
    [sym_identifier] = ACTIONS(161),
    [anon_sym_BSLASH] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(167),
    [anon_sym_for] = ACTIONS(169),
    [anon_sym_while] = ACTIONS(171),
    [anon_sym_repeat] = ACTIONS(173),
    [anon_sym_QMARK] = ACTIONS(175),
    [anon_sym_TILDE] = ACTIONS(177),
    [anon_sym_BANG] = ACTIONS(179),
    [anon_sym_PLUS] = ACTIONS(181),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_LT_DASH] = ACTIONS(211),
    [anon_sym_LT_LT_DASH] = ACTIONS(211),
    [anon_sym_COLON_EQ] = ACTIONS(211),
    [anon_sym_DASH_GT] = ACTIONS(209),
    [anon_sym_DASH_GT_GT] = ACTIONS(211),
    [anon_sym_PIPE] = ACTIONS(209),
    [anon_sym_AMP] = ACTIONS(209),
    [anon_sym_PIPE_PIPE] = ACTIONS(211),
    [anon_sym_AMP_AMP] = ACTIONS(211),
    [anon_sym_LT] = ACTIONS(209),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_GT] = ACTIONS(209),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [anon_sym_EQ_EQ] = ACTIONS(211),
    [anon_sym_BANG_EQ] = ACTIONS(211),
    [anon_sym_STAR] = ACTIONS(209),
    [anon_sym_SLASH] = ACTIONS(211),
    [anon_sym_STAR_STAR] = ACTIONS(211),
    [anon_sym_CARET] = ACTIONS(211),
    [aux_sym_binary_operator_token1] = ACTIONS(211),
    [anon_sym_PIPE_GT] = ACTIONS(211),
    [anon_sym_COLON] = ACTIONS(209),
    [anon_sym_DOLLAR] = ACTIONS(211),
    [anon_sym_AT] = ACTIONS(211),
    [aux_sym__hex_literal_token1] = ACTIONS(185),
    [sym__number_literal] = ACTIONS(187),
    [anon_sym_SQUOTE] = ACTIONS(189),
    [anon_sym_DQUOTE] = ACTIONS(191),
    [sym_return] = ACTIONS(193),
    [sym_next] = ACTIONS(193),
    [sym_break] = ACTIONS(193),
    [sym_true] = ACTIONS(193),
    [sym_false] = ACTIONS(193),
    [sym_null] = ACTIONS(193),
    [sym_inf] = ACTIONS(193),
    [sym_nan] = ACTIONS(193),
    [anon_sym_NA] = ACTIONS(195),
    [anon_sym_NA_integer_] = ACTIONS(195),
    [anon_sym_NA_real_] = ACTIONS(195),
    [anon_sym_NA_complex_] = ACTIONS(195),
    [anon_sym_NA_character_] = ACTIONS(195),
    [sym_dots] = ACTIONS(193),
    [sym_dot_dot_i] = ACTIONS(197),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(211),
    [sym__newline] = ACTIONS(199),
    [sym__semicolon] = ACTIONS(211),
    [sym__raw_string_literal] = ACTIONS(201),
    [sym__external_else] = ACTIONS(211),
    [sym__external_open_parenthesis] = ACTIONS(203),
    [sym__external_close_parenthesis] = ACTIONS(219),
    [sym__external_open_brace] = ACTIONS(207),
    [sym__external_close_brace] = ACTIONS(211),
    [sym__external_open_bracket] = ACTIONS(211),
    [sym__external_open_bracket2] = ACTIONS(211),
    [sym__external_close_bracket2] = ACTIONS(211),
  },
  [10] = {
    [sym_function_definition] = STATE(522),
    [sym_if_statement] = STATE(522),
    [sym_for_statement] = STATE(522),
    [sym_while_statement] = STATE(522),
    [sym_repeat_statement] = STATE(522),
    [sym_braced_expression] = STATE(522),
    [sym_parenthesized_expression] = STATE(522),
    [sym_call] = STATE(522),
    [sym_subset] = STATE(522),
    [sym_subset2] = STATE(522),
    [sym_unary_operator] = STATE(522),
    [sym_binary_operator] = STATE(522),
    [sym_extract_operator] = STATE(522),
    [sym_namespace_operator] = STATE(522),
    [sym_integer] = STATE(522),
    [sym_complex] = STATE(522),
    [sym_float] = STATE(522),
    [sym__hex_literal] = STATE(2021),
    [sym__float_literal] = STATE(2021),
    [sym_string] = STATE(2016),
    [sym__single_quoted_string] = STATE(2027),
    [sym__double_quoted_string] = STATE(2041),
    [sym_na] = STATE(522),
    [sym__expression] = STATE(522),
    [sym__string_or_identifier] = STATE(5131),
    [sym__open_parenthesis] = STATE(20),
    [sym__open_brace] = STATE(10),
    [sym__close_brace] = STATE(2322),
    [aux_sym_braced_expression_repeat1] = STATE(15),
    [sym_identifier] = ACTIONS(103),
    [anon_sym_BSLASH] = ACTIONS(105),
    [anon_sym_function] = ACTIONS(107),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(111),
    [anon_sym_for] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_repeat] = ACTIONS(117),
    [anon_sym_QMARK] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_BANG] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(125),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_LT_DASH] = ACTIONS(155),
    [anon_sym_LT_LT_DASH] = ACTIONS(155),
    [anon_sym_COLON_EQ] = ACTIONS(155),
    [anon_sym_DASH_GT] = ACTIONS(157),
    [anon_sym_DASH_GT_GT] = ACTIONS(155),
    [anon_sym_PIPE] = ACTIONS(157),
    [anon_sym_AMP] = ACTIONS(157),
    [anon_sym_PIPE_PIPE] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(157),
    [anon_sym_LT_EQ] = ACTIONS(155),
    [anon_sym_GT] = ACTIONS(157),
    [anon_sym_GT_EQ] = ACTIONS(155),
    [anon_sym_EQ_EQ] = ACTIONS(155),
    [anon_sym_BANG_EQ] = ACTIONS(155),
    [anon_sym_STAR] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(155),
    [anon_sym_STAR_STAR] = ACTIONS(155),
    [anon_sym_CARET] = ACTIONS(155),
    [aux_sym_binary_operator_token1] = ACTIONS(155),
    [anon_sym_PIPE_GT] = ACTIONS(155),
    [anon_sym_COLON] = ACTIONS(157),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(155),
    [aux_sym__hex_literal_token1] = ACTIONS(131),
    [sym__number_literal] = ACTIONS(133),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(137),
    [sym_return] = ACTIONS(221),
    [sym_next] = ACTIONS(221),
    [sym_break] = ACTIONS(221),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [sym_null] = ACTIONS(221),
    [sym_inf] = ACTIONS(221),
    [sym_nan] = ACTIONS(221),
    [anon_sym_NA] = ACTIONS(141),
    [anon_sym_NA_integer_] = ACTIONS(141),
    [anon_sym_NA_real_] = ACTIONS(141),
    [anon_sym_NA_complex_] = ACTIONS(141),
    [anon_sym_NA_character_] = ACTIONS(141),
    [sym_dots] = ACTIONS(221),
    [sym_dot_dot_i] = ACTIONS(223),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(155),
    [sym__newline] = ACTIONS(225),
    [sym__semicolon] = ACTIONS(225),
    [sym__raw_string_literal] = ACTIONS(147),
    [sym__external_else] = ACTIONS(155),
    [sym__external_open_parenthesis] = ACTIONS(149),
    [sym__external_close_parenthesis] = ACTIONS(155),
    [sym__external_open_brace] = ACTIONS(153),
    [sym__external_close_brace] = ACTIONS(227),
    [sym__external_open_bracket] = ACTIONS(155),
    [sym__external_close_bracket] = ACTIONS(155),
    [sym__external_open_bracket2] = ACTIONS(155),
  },
  [11] = {
    [sym_function_definition] = STATE(522),
    [sym_if_statement] = STATE(522),
    [sym_for_statement] = STATE(522),
    [sym_while_statement] = STATE(522),
    [sym_repeat_statement] = STATE(522),
    [sym_braced_expression] = STATE(522),
    [sym_parenthesized_expression] = STATE(522),
    [sym_call] = STATE(522),
    [sym_subset] = STATE(522),
    [sym_subset2] = STATE(522),
    [sym_unary_operator] = STATE(522),
    [sym_binary_operator] = STATE(522),
    [sym_extract_operator] = STATE(522),
    [sym_namespace_operator] = STATE(522),
    [sym_integer] = STATE(522),
    [sym_complex] = STATE(522),
    [sym_float] = STATE(522),
    [sym__hex_literal] = STATE(2021),
    [sym__float_literal] = STATE(2021),
    [sym_string] = STATE(2016),
    [sym__single_quoted_string] = STATE(2027),
    [sym__double_quoted_string] = STATE(2041),
    [sym_na] = STATE(522),
    [sym__expression] = STATE(522),
    [sym__string_or_identifier] = STATE(5131),
    [sym__open_parenthesis] = STATE(20),
    [sym__open_brace] = STATE(10),
    [sym__close_brace] = STATE(2724),
    [aux_sym_braced_expression_repeat1] = STATE(12),
    [sym_identifier] = ACTIONS(103),
    [anon_sym_BSLASH] = ACTIONS(105),
    [anon_sym_function] = ACTIONS(107),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(111),
    [anon_sym_for] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_repeat] = ACTIONS(117),
    [anon_sym_QMARK] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_BANG] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(125),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_LT_DASH] = ACTIONS(155),
    [anon_sym_LT_LT_DASH] = ACTIONS(155),
    [anon_sym_COLON_EQ] = ACTIONS(155),
    [anon_sym_DASH_GT] = ACTIONS(157),
    [anon_sym_DASH_GT_GT] = ACTIONS(155),
    [anon_sym_PIPE] = ACTIONS(157),
    [anon_sym_AMP] = ACTIONS(157),
    [anon_sym_PIPE_PIPE] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(157),
    [anon_sym_LT_EQ] = ACTIONS(155),
    [anon_sym_GT] = ACTIONS(157),
    [anon_sym_GT_EQ] = ACTIONS(155),
    [anon_sym_EQ_EQ] = ACTIONS(155),
    [anon_sym_BANG_EQ] = ACTIONS(155),
    [anon_sym_STAR] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(155),
    [anon_sym_STAR_STAR] = ACTIONS(155),
    [anon_sym_CARET] = ACTIONS(155),
    [aux_sym_binary_operator_token1] = ACTIONS(155),
    [anon_sym_PIPE_GT] = ACTIONS(155),
    [anon_sym_COLON] = ACTIONS(157),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(155),
    [aux_sym__hex_literal_token1] = ACTIONS(131),
    [sym__number_literal] = ACTIONS(133),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(137),
    [sym_return] = ACTIONS(221),
    [sym_next] = ACTIONS(221),
    [sym_break] = ACTIONS(221),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [sym_null] = ACTIONS(221),
    [sym_inf] = ACTIONS(221),
    [sym_nan] = ACTIONS(221),
    [anon_sym_NA] = ACTIONS(141),
    [anon_sym_NA_integer_] = ACTIONS(141),
    [anon_sym_NA_real_] = ACTIONS(141),
    [anon_sym_NA_complex_] = ACTIONS(141),
    [anon_sym_NA_character_] = ACTIONS(141),
    [sym_dots] = ACTIONS(221),
    [sym_dot_dot_i] = ACTIONS(223),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(155),
    [sym__newline] = ACTIONS(225),
    [sym__semicolon] = ACTIONS(225),
    [sym__raw_string_literal] = ACTIONS(147),
    [sym__external_else] = ACTIONS(155),
    [sym__external_open_parenthesis] = ACTIONS(149),
    [sym__external_close_parenthesis] = ACTIONS(155),
    [sym__external_open_brace] = ACTIONS(153),
    [sym__external_close_brace] = ACTIONS(229),
    [sym__external_open_bracket] = ACTIONS(155),
    [sym__external_close_bracket] = ACTIONS(155),
    [sym__external_open_bracket2] = ACTIONS(155),
  },
  [12] = {
    [sym_function_definition] = STATE(522),
    [sym_if_statement] = STATE(522),
    [sym_for_statement] = STATE(522),
    [sym_while_statement] = STATE(522),
    [sym_repeat_statement] = STATE(522),
    [sym_braced_expression] = STATE(522),
    [sym_parenthesized_expression] = STATE(522),
    [sym_call] = STATE(522),
    [sym_subset] = STATE(522),
    [sym_subset2] = STATE(522),
    [sym_unary_operator] = STATE(522),
    [sym_binary_operator] = STATE(522),
    [sym_extract_operator] = STATE(522),
    [sym_namespace_operator] = STATE(522),
    [sym_integer] = STATE(522),
    [sym_complex] = STATE(522),
    [sym_float] = STATE(522),
    [sym__hex_literal] = STATE(2021),
    [sym__float_literal] = STATE(2021),
    [sym_string] = STATE(2016),
    [sym__single_quoted_string] = STATE(2027),
    [sym__double_quoted_string] = STATE(2041),
    [sym_na] = STATE(522),
    [sym__expression] = STATE(522),
    [sym__string_or_identifier] = STATE(5131),
    [sym__open_parenthesis] = STATE(20),
    [sym__open_brace] = STATE(10),
    [sym__close_brace] = STATE(2711),
    [aux_sym_braced_expression_repeat1] = STATE(43),
    [sym_identifier] = ACTIONS(103),
    [anon_sym_BSLASH] = ACTIONS(105),
    [anon_sym_function] = ACTIONS(107),
    [anon_sym_EQ] = ACTIONS(59),
    [anon_sym_if] = ACTIONS(111),
    [anon_sym_for] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_repeat] = ACTIONS(117),
    [anon_sym_QMARK] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_BANG] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(125),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_LT_DASH] = ACTIONS(51),
    [anon_sym_LT_LT_DASH] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(51),
    [anon_sym_DASH_GT] = ACTIONS(59),
    [anon_sym_DASH_GT_GT] = ACTIONS(51),
    [anon_sym_PIPE] = ACTIONS(59),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_AMP_AMP] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(59),
    [anon_sym_LT_EQ] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(59),
    [anon_sym_GT_EQ] = ACTIONS(51),
    [anon_sym_EQ_EQ] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(51),
    [anon_sym_CARET] = ACTIONS(51),
    [aux_sym_binary_operator_token1] = ACTIONS(51),
    [anon_sym_PIPE_GT] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(59),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_AT] = ACTIONS(51),
    [aux_sym__hex_literal_token1] = ACTIONS(131),
    [sym__number_literal] = ACTIONS(133),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(137),
    [sym_return] = ACTIONS(221),
    [sym_next] = ACTIONS(221),
    [sym_break] = ACTIONS(221),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [sym_null] = ACTIONS(221),
    [sym_inf] = ACTIONS(221),
    [sym_nan] = ACTIONS(221),
    [anon_sym_NA] = ACTIONS(141),
    [anon_sym_NA_integer_] = ACTIONS(141),
    [anon_sym_NA_real_] = ACTIONS(141),
    [anon_sym_NA_complex_] = ACTIONS(141),
    [anon_sym_NA_character_] = ACTIONS(141),
    [sym_dots] = ACTIONS(221),
    [sym_dot_dot_i] = ACTIONS(223),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(51),
    [sym__newline] = ACTIONS(225),
    [sym__semicolon] = ACTIONS(225),
    [sym__raw_string_literal] = ACTIONS(147),
    [sym__external_else] = ACTIONS(51),
    [sym__external_open_parenthesis] = ACTIONS(149),
    [sym__external_close_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(153),
    [sym__external_close_brace] = ACTIONS(231),
    [sym__external_open_bracket] = ACTIONS(51),
    [sym__external_close_bracket] = ACTIONS(51),
    [sym__external_open_bracket2] = ACTIONS(51),
  },
  [13] = {
    [sym_function_definition] = STATE(507),
    [sym_if_statement] = STATE(507),
    [sym_for_statement] = STATE(507),
    [sym_while_statement] = STATE(507),
    [sym_repeat_statement] = STATE(507),
    [sym_braced_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_call] = STATE(507),
    [sym_subset] = STATE(507),
    [sym_subset2] = STATE(507),
    [sym_unary_operator] = STATE(507),
    [sym_binary_operator] = STATE(507),
    [sym_extract_operator] = STATE(507),
    [sym_namespace_operator] = STATE(507),
    [sym_integer] = STATE(507),
    [sym_complex] = STATE(507),
    [sym_float] = STATE(507),
    [sym__hex_literal] = STATE(1925),
    [sym__float_literal] = STATE(1925),
    [sym_string] = STATE(1927),
    [sym__single_quoted_string] = STATE(1923),
    [sym__double_quoted_string] = STATE(1934),
    [sym_na] = STATE(507),
    [sym__expression] = STATE(507),
    [sym__string_or_identifier] = STATE(5137),
    [sym__open_parenthesis] = STATE(14),
    [sym__open_brace] = STATE(18),
    [sym__close_brace] = STATE(2621),
    [aux_sym_braced_expression_repeat1] = STATE(39),
    [sym_identifier] = ACTIONS(161),
    [anon_sym_BSLASH] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(59),
    [anon_sym_if] = ACTIONS(167),
    [anon_sym_for] = ACTIONS(169),
    [anon_sym_while] = ACTIONS(171),
    [anon_sym_repeat] = ACTIONS(173),
    [anon_sym_QMARK] = ACTIONS(175),
    [anon_sym_TILDE] = ACTIONS(177),
    [anon_sym_BANG] = ACTIONS(179),
    [anon_sym_PLUS] = ACTIONS(181),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_LT_DASH] = ACTIONS(51),
    [anon_sym_LT_LT_DASH] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(51),
    [anon_sym_DASH_GT] = ACTIONS(59),
    [anon_sym_DASH_GT_GT] = ACTIONS(51),
    [anon_sym_PIPE] = ACTIONS(59),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_AMP_AMP] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(59),
    [anon_sym_LT_EQ] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(59),
    [anon_sym_GT_EQ] = ACTIONS(51),
    [anon_sym_EQ_EQ] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(51),
    [anon_sym_CARET] = ACTIONS(51),
    [aux_sym_binary_operator_token1] = ACTIONS(51),
    [anon_sym_PIPE_GT] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(59),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_AT] = ACTIONS(51),
    [aux_sym__hex_literal_token1] = ACTIONS(185),
    [sym__number_literal] = ACTIONS(187),
    [anon_sym_SQUOTE] = ACTIONS(189),
    [anon_sym_DQUOTE] = ACTIONS(191),
    [sym_return] = ACTIONS(233),
    [sym_next] = ACTIONS(233),
    [sym_break] = ACTIONS(233),
    [sym_true] = ACTIONS(233),
    [sym_false] = ACTIONS(233),
    [sym_null] = ACTIONS(233),
    [sym_inf] = ACTIONS(233),
    [sym_nan] = ACTIONS(233),
    [anon_sym_NA] = ACTIONS(195),
    [anon_sym_NA_integer_] = ACTIONS(195),
    [anon_sym_NA_real_] = ACTIONS(195),
    [anon_sym_NA_complex_] = ACTIONS(195),
    [anon_sym_NA_character_] = ACTIONS(195),
    [sym_dots] = ACTIONS(233),
    [sym_dot_dot_i] = ACTIONS(235),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(51),
    [sym__newline] = ACTIONS(237),
    [sym__semicolon] = ACTIONS(237),
    [sym__raw_string_literal] = ACTIONS(201),
    [sym__external_else] = ACTIONS(51),
    [sym__external_open_parenthesis] = ACTIONS(203),
    [sym__external_close_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(207),
    [sym__external_close_brace] = ACTIONS(239),
    [sym__external_open_bracket] = ACTIONS(51),
    [sym__external_open_bracket2] = ACTIONS(51),
    [sym__external_close_bracket2] = ACTIONS(51),
  },
  [14] = {
    [sym_function_definition] = STATE(502),
    [sym_if_statement] = STATE(502),
    [sym_for_statement] = STATE(502),
    [sym_while_statement] = STATE(502),
    [sym_repeat_statement] = STATE(502),
    [sym_braced_expression] = STATE(502),
    [sym_parenthesized_expression] = STATE(502),
    [sym_call] = STATE(502),
    [sym_subset] = STATE(502),
    [sym_subset2] = STATE(502),
    [sym_unary_operator] = STATE(502),
    [sym_binary_operator] = STATE(502),
    [sym_extract_operator] = STATE(502),
    [sym_namespace_operator] = STATE(502),
    [sym_integer] = STATE(502),
    [sym_complex] = STATE(502),
    [sym_float] = STATE(502),
    [sym__hex_literal] = STATE(1925),
    [sym__float_literal] = STATE(1925),
    [sym_string] = STATE(1927),
    [sym__single_quoted_string] = STATE(1923),
    [sym__double_quoted_string] = STATE(1934),
    [sym_na] = STATE(502),
    [sym__expression] = STATE(502),
    [sym__string_or_identifier] = STATE(5137),
    [sym__open_parenthesis] = STATE(14),
    [sym__close_parenthesis] = STATE(2347),
    [sym__open_brace] = STATE(18),
    [aux_sym_parenthesized_expression_repeat1] = STATE(6),
    [sym_identifier] = ACTIONS(161),
    [anon_sym_BSLASH] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(109),
    [anon_sym_if] = ACTIONS(167),
    [anon_sym_for] = ACTIONS(169),
    [anon_sym_while] = ACTIONS(171),
    [anon_sym_repeat] = ACTIONS(173),
    [anon_sym_QMARK] = ACTIONS(175),
    [anon_sym_TILDE] = ACTIONS(177),
    [anon_sym_BANG] = ACTIONS(179),
    [anon_sym_PLUS] = ACTIONS(181),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_LT_DASH] = ACTIONS(129),
    [anon_sym_LT_LT_DASH] = ACTIONS(129),
    [anon_sym_COLON_EQ] = ACTIONS(129),
    [anon_sym_DASH_GT] = ACTIONS(109),
    [anon_sym_DASH_GT_GT] = ACTIONS(129),
    [anon_sym_PIPE] = ACTIONS(109),
    [anon_sym_AMP] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_STAR_STAR] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [aux_sym_binary_operator_token1] = ACTIONS(129),
    [anon_sym_PIPE_GT] = ACTIONS(129),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(129),
    [anon_sym_AT] = ACTIONS(129),
    [aux_sym__hex_literal_token1] = ACTIONS(185),
    [sym__number_literal] = ACTIONS(187),
    [anon_sym_SQUOTE] = ACTIONS(189),
    [anon_sym_DQUOTE] = ACTIONS(191),
    [sym_return] = ACTIONS(193),
    [sym_next] = ACTIONS(193),
    [sym_break] = ACTIONS(193),
    [sym_true] = ACTIONS(193),
    [sym_false] = ACTIONS(193),
    [sym_null] = ACTIONS(193),
    [sym_inf] = ACTIONS(193),
    [sym_nan] = ACTIONS(193),
    [anon_sym_NA] = ACTIONS(195),
    [anon_sym_NA_integer_] = ACTIONS(195),
    [anon_sym_NA_real_] = ACTIONS(195),
    [anon_sym_NA_complex_] = ACTIONS(195),
    [anon_sym_NA_character_] = ACTIONS(195),
    [sym_dots] = ACTIONS(193),
    [sym_dot_dot_i] = ACTIONS(197),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(129),
    [sym__newline] = ACTIONS(199),
    [sym__semicolon] = ACTIONS(129),
    [sym__raw_string_literal] = ACTIONS(201),
    [sym__external_else] = ACTIONS(129),
    [sym__external_open_parenthesis] = ACTIONS(203),
    [sym__external_close_parenthesis] = ACTIONS(241),
    [sym__external_open_brace] = ACTIONS(207),
    [sym__external_close_brace] = ACTIONS(129),
    [sym__external_open_bracket] = ACTIONS(129),
    [sym__external_open_bracket2] = ACTIONS(129),
    [sym__external_close_bracket2] = ACTIONS(129),
  },
  [15] = {
    [sym_function_definition] = STATE(522),
    [sym_if_statement] = STATE(522),
    [sym_for_statement] = STATE(522),
    [sym_while_statement] = STATE(522),
    [sym_repeat_statement] = STATE(522),
    [sym_braced_expression] = STATE(522),
    [sym_parenthesized_expression] = STATE(522),
    [sym_call] = STATE(522),
    [sym_subset] = STATE(522),
    [sym_subset2] = STATE(522),
    [sym_unary_operator] = STATE(522),
    [sym_binary_operator] = STATE(522),
    [sym_extract_operator] = STATE(522),
    [sym_namespace_operator] = STATE(522),
    [sym_integer] = STATE(522),
    [sym_complex] = STATE(522),
    [sym_float] = STATE(522),
    [sym__hex_literal] = STATE(2021),
    [sym__float_literal] = STATE(2021),
    [sym_string] = STATE(2016),
    [sym__single_quoted_string] = STATE(2027),
    [sym__double_quoted_string] = STATE(2041),
    [sym_na] = STATE(522),
    [sym__expression] = STATE(522),
    [sym__string_or_identifier] = STATE(5131),
    [sym__open_parenthesis] = STATE(20),
    [sym__open_brace] = STATE(10),
    [sym__close_brace] = STATE(2329),
    [aux_sym_braced_expression_repeat1] = STATE(43),
    [sym_identifier] = ACTIONS(103),
    [anon_sym_BSLASH] = ACTIONS(105),
    [anon_sym_function] = ACTIONS(107),
    [anon_sym_EQ] = ACTIONS(59),
    [anon_sym_if] = ACTIONS(111),
    [anon_sym_for] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_repeat] = ACTIONS(117),
    [anon_sym_QMARK] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_BANG] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(125),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_LT_DASH] = ACTIONS(51),
    [anon_sym_LT_LT_DASH] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(51),
    [anon_sym_DASH_GT] = ACTIONS(59),
    [anon_sym_DASH_GT_GT] = ACTIONS(51),
    [anon_sym_PIPE] = ACTIONS(59),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_AMP_AMP] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(59),
    [anon_sym_LT_EQ] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(59),
    [anon_sym_GT_EQ] = ACTIONS(51),
    [anon_sym_EQ_EQ] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(51),
    [anon_sym_CARET] = ACTIONS(51),
    [aux_sym_binary_operator_token1] = ACTIONS(51),
    [anon_sym_PIPE_GT] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(59),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_AT] = ACTIONS(51),
    [aux_sym__hex_literal_token1] = ACTIONS(131),
    [sym__number_literal] = ACTIONS(133),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(137),
    [sym_return] = ACTIONS(221),
    [sym_next] = ACTIONS(221),
    [sym_break] = ACTIONS(221),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [sym_null] = ACTIONS(221),
    [sym_inf] = ACTIONS(221),
    [sym_nan] = ACTIONS(221),
    [anon_sym_NA] = ACTIONS(141),
    [anon_sym_NA_integer_] = ACTIONS(141),
    [anon_sym_NA_real_] = ACTIONS(141),
    [anon_sym_NA_complex_] = ACTIONS(141),
    [anon_sym_NA_character_] = ACTIONS(141),
    [sym_dots] = ACTIONS(221),
    [sym_dot_dot_i] = ACTIONS(223),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(51),
    [sym__newline] = ACTIONS(225),
    [sym__semicolon] = ACTIONS(225),
    [sym__raw_string_literal] = ACTIONS(147),
    [sym__external_else] = ACTIONS(51),
    [sym__external_open_parenthesis] = ACTIONS(149),
    [sym__external_close_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(153),
    [sym__external_close_brace] = ACTIONS(243),
    [sym__external_open_bracket] = ACTIONS(51),
    [sym__external_close_bracket] = ACTIONS(51),
    [sym__external_open_bracket2] = ACTIONS(51),
  },
  [16] = {
    [sym_function_definition] = STATE(507),
    [sym_if_statement] = STATE(507),
    [sym_for_statement] = STATE(507),
    [sym_while_statement] = STATE(507),
    [sym_repeat_statement] = STATE(507),
    [sym_braced_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_call] = STATE(507),
    [sym_subset] = STATE(507),
    [sym_subset2] = STATE(507),
    [sym_unary_operator] = STATE(507),
    [sym_binary_operator] = STATE(507),
    [sym_extract_operator] = STATE(507),
    [sym_namespace_operator] = STATE(507),
    [sym_integer] = STATE(507),
    [sym_complex] = STATE(507),
    [sym_float] = STATE(507),
    [sym__hex_literal] = STATE(1925),
    [sym__float_literal] = STATE(1925),
    [sym_string] = STATE(1927),
    [sym__single_quoted_string] = STATE(1923),
    [sym__double_quoted_string] = STATE(1934),
    [sym_na] = STATE(507),
    [sym__expression] = STATE(507),
    [sym__string_or_identifier] = STATE(5137),
    [sym__open_parenthesis] = STATE(14),
    [sym__open_brace] = STATE(18),
    [sym__close_brace] = STATE(2645),
    [aux_sym_braced_expression_repeat1] = STATE(13),
    [sym_identifier] = ACTIONS(161),
    [anon_sym_BSLASH] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(167),
    [anon_sym_for] = ACTIONS(169),
    [anon_sym_while] = ACTIONS(171),
    [anon_sym_repeat] = ACTIONS(173),
    [anon_sym_QMARK] = ACTIONS(175),
    [anon_sym_TILDE] = ACTIONS(177),
    [anon_sym_BANG] = ACTIONS(179),
    [anon_sym_PLUS] = ACTIONS(181),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_LT_DASH] = ACTIONS(155),
    [anon_sym_LT_LT_DASH] = ACTIONS(155),
    [anon_sym_COLON_EQ] = ACTIONS(155),
    [anon_sym_DASH_GT] = ACTIONS(157),
    [anon_sym_DASH_GT_GT] = ACTIONS(155),
    [anon_sym_PIPE] = ACTIONS(157),
    [anon_sym_AMP] = ACTIONS(157),
    [anon_sym_PIPE_PIPE] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(157),
    [anon_sym_LT_EQ] = ACTIONS(155),
    [anon_sym_GT] = ACTIONS(157),
    [anon_sym_GT_EQ] = ACTIONS(155),
    [anon_sym_EQ_EQ] = ACTIONS(155),
    [anon_sym_BANG_EQ] = ACTIONS(155),
    [anon_sym_STAR] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(155),
    [anon_sym_STAR_STAR] = ACTIONS(155),
    [anon_sym_CARET] = ACTIONS(155),
    [aux_sym_binary_operator_token1] = ACTIONS(155),
    [anon_sym_PIPE_GT] = ACTIONS(155),
    [anon_sym_COLON] = ACTIONS(157),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(155),
    [aux_sym__hex_literal_token1] = ACTIONS(185),
    [sym__number_literal] = ACTIONS(187),
    [anon_sym_SQUOTE] = ACTIONS(189),
    [anon_sym_DQUOTE] = ACTIONS(191),
    [sym_return] = ACTIONS(233),
    [sym_next] = ACTIONS(233),
    [sym_break] = ACTIONS(233),
    [sym_true] = ACTIONS(233),
    [sym_false] = ACTIONS(233),
    [sym_null] = ACTIONS(233),
    [sym_inf] = ACTIONS(233),
    [sym_nan] = ACTIONS(233),
    [anon_sym_NA] = ACTIONS(195),
    [anon_sym_NA_integer_] = ACTIONS(195),
    [anon_sym_NA_real_] = ACTIONS(195),
    [anon_sym_NA_complex_] = ACTIONS(195),
    [anon_sym_NA_character_] = ACTIONS(195),
    [sym_dots] = ACTIONS(233),
    [sym_dot_dot_i] = ACTIONS(235),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(155),
    [sym__newline] = ACTIONS(237),
    [sym__semicolon] = ACTIONS(237),
    [sym__raw_string_literal] = ACTIONS(201),
    [sym__external_else] = ACTIONS(155),
    [sym__external_open_parenthesis] = ACTIONS(203),
    [sym__external_close_parenthesis] = ACTIONS(155),
    [sym__external_open_brace] = ACTIONS(207),
    [sym__external_close_brace] = ACTIONS(245),
    [sym__external_open_bracket] = ACTIONS(155),
    [sym__external_open_bracket2] = ACTIONS(155),
    [sym__external_close_bracket2] = ACTIONS(155),
  },
  [17] = {
    [sym_function_definition] = STATE(507),
    [sym_if_statement] = STATE(507),
    [sym_for_statement] = STATE(507),
    [sym_while_statement] = STATE(507),
    [sym_repeat_statement] = STATE(507),
    [sym_braced_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_call] = STATE(507),
    [sym_subset] = STATE(507),
    [sym_subset2] = STATE(507),
    [sym_unary_operator] = STATE(507),
    [sym_binary_operator] = STATE(507),
    [sym_extract_operator] = STATE(507),
    [sym_namespace_operator] = STATE(507),
    [sym_integer] = STATE(507),
    [sym_complex] = STATE(507),
    [sym_float] = STATE(507),
    [sym__hex_literal] = STATE(1925),
    [sym__float_literal] = STATE(1925),
    [sym_string] = STATE(1927),
    [sym__single_quoted_string] = STATE(1923),
    [sym__double_quoted_string] = STATE(1934),
    [sym_na] = STATE(507),
    [sym__expression] = STATE(507),
    [sym__string_or_identifier] = STATE(5137),
    [sym__open_parenthesis] = STATE(14),
    [sym__open_brace] = STATE(18),
    [sym__close_brace] = STATE(2357),
    [aux_sym_braced_expression_repeat1] = STATE(39),
    [sym_identifier] = ACTIONS(161),
    [anon_sym_BSLASH] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(59),
    [anon_sym_if] = ACTIONS(167),
    [anon_sym_for] = ACTIONS(169),
    [anon_sym_while] = ACTIONS(171),
    [anon_sym_repeat] = ACTIONS(173),
    [anon_sym_QMARK] = ACTIONS(175),
    [anon_sym_TILDE] = ACTIONS(177),
    [anon_sym_BANG] = ACTIONS(179),
    [anon_sym_PLUS] = ACTIONS(181),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_LT_DASH] = ACTIONS(51),
    [anon_sym_LT_LT_DASH] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(51),
    [anon_sym_DASH_GT] = ACTIONS(59),
    [anon_sym_DASH_GT_GT] = ACTIONS(51),
    [anon_sym_PIPE] = ACTIONS(59),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_AMP_AMP] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(59),
    [anon_sym_LT_EQ] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(59),
    [anon_sym_GT_EQ] = ACTIONS(51),
    [anon_sym_EQ_EQ] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(51),
    [anon_sym_CARET] = ACTIONS(51),
    [aux_sym_binary_operator_token1] = ACTIONS(51),
    [anon_sym_PIPE_GT] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(59),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_AT] = ACTIONS(51),
    [aux_sym__hex_literal_token1] = ACTIONS(185),
    [sym__number_literal] = ACTIONS(187),
    [anon_sym_SQUOTE] = ACTIONS(189),
    [anon_sym_DQUOTE] = ACTIONS(191),
    [sym_return] = ACTIONS(233),
    [sym_next] = ACTIONS(233),
    [sym_break] = ACTIONS(233),
    [sym_true] = ACTIONS(233),
    [sym_false] = ACTIONS(233),
    [sym_null] = ACTIONS(233),
    [sym_inf] = ACTIONS(233),
    [sym_nan] = ACTIONS(233),
    [anon_sym_NA] = ACTIONS(195),
    [anon_sym_NA_integer_] = ACTIONS(195),
    [anon_sym_NA_real_] = ACTIONS(195),
    [anon_sym_NA_complex_] = ACTIONS(195),
    [anon_sym_NA_character_] = ACTIONS(195),
    [sym_dots] = ACTIONS(233),
    [sym_dot_dot_i] = ACTIONS(235),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(51),
    [sym__newline] = ACTIONS(237),
    [sym__semicolon] = ACTIONS(237),
    [sym__raw_string_literal] = ACTIONS(201),
    [sym__external_else] = ACTIONS(51),
    [sym__external_open_parenthesis] = ACTIONS(203),
    [sym__external_close_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(207),
    [sym__external_close_brace] = ACTIONS(247),
    [sym__external_open_bracket] = ACTIONS(51),
    [sym__external_open_bracket2] = ACTIONS(51),
    [sym__external_close_bracket2] = ACTIONS(51),
  },
  [18] = {
    [sym_function_definition] = STATE(507),
    [sym_if_statement] = STATE(507),
    [sym_for_statement] = STATE(507),
    [sym_while_statement] = STATE(507),
    [sym_repeat_statement] = STATE(507),
    [sym_braced_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_call] = STATE(507),
    [sym_subset] = STATE(507),
    [sym_subset2] = STATE(507),
    [sym_unary_operator] = STATE(507),
    [sym_binary_operator] = STATE(507),
    [sym_extract_operator] = STATE(507),
    [sym_namespace_operator] = STATE(507),
    [sym_integer] = STATE(507),
    [sym_complex] = STATE(507),
    [sym_float] = STATE(507),
    [sym__hex_literal] = STATE(1925),
    [sym__float_literal] = STATE(1925),
    [sym_string] = STATE(1927),
    [sym__single_quoted_string] = STATE(1923),
    [sym__double_quoted_string] = STATE(1934),
    [sym_na] = STATE(507),
    [sym__expression] = STATE(507),
    [sym__string_or_identifier] = STATE(5137),
    [sym__open_parenthesis] = STATE(14),
    [sym__open_brace] = STATE(18),
    [sym__close_brace] = STATE(2348),
    [aux_sym_braced_expression_repeat1] = STATE(17),
    [sym_identifier] = ACTIONS(161),
    [anon_sym_BSLASH] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(167),
    [anon_sym_for] = ACTIONS(169),
    [anon_sym_while] = ACTIONS(171),
    [anon_sym_repeat] = ACTIONS(173),
    [anon_sym_QMARK] = ACTIONS(175),
    [anon_sym_TILDE] = ACTIONS(177),
    [anon_sym_BANG] = ACTIONS(179),
    [anon_sym_PLUS] = ACTIONS(181),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_LT_DASH] = ACTIONS(155),
    [anon_sym_LT_LT_DASH] = ACTIONS(155),
    [anon_sym_COLON_EQ] = ACTIONS(155),
    [anon_sym_DASH_GT] = ACTIONS(157),
    [anon_sym_DASH_GT_GT] = ACTIONS(155),
    [anon_sym_PIPE] = ACTIONS(157),
    [anon_sym_AMP] = ACTIONS(157),
    [anon_sym_PIPE_PIPE] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(157),
    [anon_sym_LT_EQ] = ACTIONS(155),
    [anon_sym_GT] = ACTIONS(157),
    [anon_sym_GT_EQ] = ACTIONS(155),
    [anon_sym_EQ_EQ] = ACTIONS(155),
    [anon_sym_BANG_EQ] = ACTIONS(155),
    [anon_sym_STAR] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(155),
    [anon_sym_STAR_STAR] = ACTIONS(155),
    [anon_sym_CARET] = ACTIONS(155),
    [aux_sym_binary_operator_token1] = ACTIONS(155),
    [anon_sym_PIPE_GT] = ACTIONS(155),
    [anon_sym_COLON] = ACTIONS(157),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(155),
    [aux_sym__hex_literal_token1] = ACTIONS(185),
    [sym__number_literal] = ACTIONS(187),
    [anon_sym_SQUOTE] = ACTIONS(189),
    [anon_sym_DQUOTE] = ACTIONS(191),
    [sym_return] = ACTIONS(233),
    [sym_next] = ACTIONS(233),
    [sym_break] = ACTIONS(233),
    [sym_true] = ACTIONS(233),
    [sym_false] = ACTIONS(233),
    [sym_null] = ACTIONS(233),
    [sym_inf] = ACTIONS(233),
    [sym_nan] = ACTIONS(233),
    [anon_sym_NA] = ACTIONS(195),
    [anon_sym_NA_integer_] = ACTIONS(195),
    [anon_sym_NA_real_] = ACTIONS(195),
    [anon_sym_NA_complex_] = ACTIONS(195),
    [anon_sym_NA_character_] = ACTIONS(195),
    [sym_dots] = ACTIONS(233),
    [sym_dot_dot_i] = ACTIONS(235),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(155),
    [sym__newline] = ACTIONS(237),
    [sym__semicolon] = ACTIONS(237),
    [sym__raw_string_literal] = ACTIONS(201),
    [sym__external_else] = ACTIONS(155),
    [sym__external_open_parenthesis] = ACTIONS(203),
    [sym__external_close_parenthesis] = ACTIONS(155),
    [sym__external_open_brace] = ACTIONS(207),
    [sym__external_close_brace] = ACTIONS(249),
    [sym__external_open_bracket] = ACTIONS(155),
    [sym__external_open_bracket2] = ACTIONS(155),
    [sym__external_close_bracket2] = ACTIONS(155),
  },
  [19] = {
    [sym_function_definition] = STATE(575),
    [sym_if_statement] = STATE(575),
    [sym_for_statement] = STATE(575),
    [sym_while_statement] = STATE(575),
    [sym_repeat_statement] = STATE(575),
    [sym_braced_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(575),
    [sym_call] = STATE(575),
    [sym_subset] = STATE(575),
    [sym_subset2] = STATE(575),
    [sym_unary_operator] = STATE(575),
    [sym_binary_operator] = STATE(575),
    [sym_extract_operator] = STATE(575),
    [sym_namespace_operator] = STATE(575),
    [sym_integer] = STATE(575),
    [sym_complex] = STATE(575),
    [sym_float] = STATE(575),
    [sym__hex_literal] = STATE(1984),
    [sym__float_literal] = STATE(1984),
    [sym_string] = STATE(1982),
    [sym__single_quoted_string] = STATE(1985),
    [sym__double_quoted_string] = STATE(1990),
    [sym_na] = STATE(575),
    [sym__expression] = STATE(575),
    [sym__string_or_identifier] = STATE(5151),
    [sym__open_parenthesis] = STATE(19),
    [sym__close_parenthesis] = STATE(2257),
    [sym__open_brace] = STATE(4),
    [aux_sym_parenthesized_expression_repeat1] = STATE(21),
    [ts_builtin_sym_end] = ACTIONS(129),
    [sym_identifier] = ACTIONS(53),
    [anon_sym_BSLASH] = ACTIONS(55),
    [anon_sym_function] = ACTIONS(57),
    [anon_sym_EQ] = ACTIONS(109),
    [anon_sym_if] = ACTIONS(61),
    [anon_sym_for] = ACTIONS(63),
    [anon_sym_while] = ACTIONS(65),
    [anon_sym_repeat] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_LT_DASH] = ACTIONS(129),
    [anon_sym_LT_LT_DASH] = ACTIONS(129),
    [anon_sym_COLON_EQ] = ACTIONS(129),
    [anon_sym_DASH_GT] = ACTIONS(109),
    [anon_sym_DASH_GT_GT] = ACTIONS(129),
    [anon_sym_PIPE] = ACTIONS(109),
    [anon_sym_AMP] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_STAR_STAR] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [aux_sym_binary_operator_token1] = ACTIONS(129),
    [anon_sym_PIPE_GT] = ACTIONS(129),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(129),
    [anon_sym_AT] = ACTIONS(129),
    [aux_sym__hex_literal_token1] = ACTIONS(79),
    [sym__number_literal] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_return] = ACTIONS(251),
    [sym_next] = ACTIONS(251),
    [sym_break] = ACTIONS(251),
    [sym_true] = ACTIONS(251),
    [sym_false] = ACTIONS(251),
    [sym_null] = ACTIONS(251),
    [sym_inf] = ACTIONS(251),
    [sym_nan] = ACTIONS(251),
    [anon_sym_NA] = ACTIONS(89),
    [anon_sym_NA_integer_] = ACTIONS(89),
    [anon_sym_NA_real_] = ACTIONS(89),
    [anon_sym_NA_complex_] = ACTIONS(89),
    [anon_sym_NA_character_] = ACTIONS(89),
    [sym_dots] = ACTIONS(251),
    [sym_dot_dot_i] = ACTIONS(253),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(129),
    [sym__newline] = ACTIONS(255),
    [sym__semicolon] = ACTIONS(129),
    [sym__raw_string_literal] = ACTIONS(95),
    [sym__external_else] = ACTIONS(129),
    [sym__external_open_parenthesis] = ACTIONS(97),
    [sym__external_close_parenthesis] = ACTIONS(257),
    [sym__external_open_brace] = ACTIONS(99),
    [sym__external_close_brace] = ACTIONS(129),
    [sym__external_open_bracket] = ACTIONS(129),
    [sym__external_open_bracket2] = ACTIONS(129),
  },
  [20] = {
    [sym_function_definition] = STATE(506),
    [sym_if_statement] = STATE(506),
    [sym_for_statement] = STATE(506),
    [sym_while_statement] = STATE(506),
    [sym_repeat_statement] = STATE(506),
    [sym_braced_expression] = STATE(506),
    [sym_parenthesized_expression] = STATE(506),
    [sym_call] = STATE(506),
    [sym_subset] = STATE(506),
    [sym_subset2] = STATE(506),
    [sym_unary_operator] = STATE(506),
    [sym_binary_operator] = STATE(506),
    [sym_extract_operator] = STATE(506),
    [sym_namespace_operator] = STATE(506),
    [sym_integer] = STATE(506),
    [sym_complex] = STATE(506),
    [sym_float] = STATE(506),
    [sym__hex_literal] = STATE(2021),
    [sym__float_literal] = STATE(2021),
    [sym_string] = STATE(2016),
    [sym__single_quoted_string] = STATE(2027),
    [sym__double_quoted_string] = STATE(2041),
    [sym_na] = STATE(506),
    [sym__expression] = STATE(506),
    [sym__string_or_identifier] = STATE(5131),
    [sym__open_parenthesis] = STATE(20),
    [sym__close_parenthesis] = STATE(2321),
    [sym__open_brace] = STATE(10),
    [aux_sym_parenthesized_expression_repeat1] = STATE(8),
    [sym_identifier] = ACTIONS(103),
    [anon_sym_BSLASH] = ACTIONS(105),
    [anon_sym_function] = ACTIONS(107),
    [anon_sym_EQ] = ACTIONS(109),
    [anon_sym_if] = ACTIONS(111),
    [anon_sym_for] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_repeat] = ACTIONS(117),
    [anon_sym_QMARK] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_BANG] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(125),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_LT_DASH] = ACTIONS(129),
    [anon_sym_LT_LT_DASH] = ACTIONS(129),
    [anon_sym_COLON_EQ] = ACTIONS(129),
    [anon_sym_DASH_GT] = ACTIONS(109),
    [anon_sym_DASH_GT_GT] = ACTIONS(129),
    [anon_sym_PIPE] = ACTIONS(109),
    [anon_sym_AMP] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_STAR_STAR] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [aux_sym_binary_operator_token1] = ACTIONS(129),
    [anon_sym_PIPE_GT] = ACTIONS(129),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(129),
    [anon_sym_AT] = ACTIONS(129),
    [aux_sym__hex_literal_token1] = ACTIONS(131),
    [sym__number_literal] = ACTIONS(133),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(137),
    [sym_return] = ACTIONS(139),
    [sym_next] = ACTIONS(139),
    [sym_break] = ACTIONS(139),
    [sym_true] = ACTIONS(139),
    [sym_false] = ACTIONS(139),
    [sym_null] = ACTIONS(139),
    [sym_inf] = ACTIONS(139),
    [sym_nan] = ACTIONS(139),
    [anon_sym_NA] = ACTIONS(141),
    [anon_sym_NA_integer_] = ACTIONS(141),
    [anon_sym_NA_real_] = ACTIONS(141),
    [anon_sym_NA_complex_] = ACTIONS(141),
    [anon_sym_NA_character_] = ACTIONS(141),
    [sym_dots] = ACTIONS(139),
    [sym_dot_dot_i] = ACTIONS(143),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(129),
    [sym__newline] = ACTIONS(145),
    [sym__semicolon] = ACTIONS(129),
    [sym__raw_string_literal] = ACTIONS(147),
    [sym__external_else] = ACTIONS(129),
    [sym__external_open_parenthesis] = ACTIONS(149),
    [sym__external_close_parenthesis] = ACTIONS(259),
    [sym__external_open_brace] = ACTIONS(153),
    [sym__external_close_brace] = ACTIONS(129),
    [sym__external_open_bracket] = ACTIONS(129),
    [sym__external_close_bracket] = ACTIONS(129),
    [sym__external_open_bracket2] = ACTIONS(129),
  },
  [21] = {
    [sym_function_definition] = STATE(575),
    [sym_if_statement] = STATE(575),
    [sym_for_statement] = STATE(575),
    [sym_while_statement] = STATE(575),
    [sym_repeat_statement] = STATE(575),
    [sym_braced_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(575),
    [sym_call] = STATE(575),
    [sym_subset] = STATE(575),
    [sym_subset2] = STATE(575),
    [sym_unary_operator] = STATE(575),
    [sym_binary_operator] = STATE(575),
    [sym_extract_operator] = STATE(575),
    [sym_namespace_operator] = STATE(575),
    [sym_integer] = STATE(575),
    [sym_complex] = STATE(575),
    [sym_float] = STATE(575),
    [sym__hex_literal] = STATE(1984),
    [sym__float_literal] = STATE(1984),
    [sym_string] = STATE(1982),
    [sym__single_quoted_string] = STATE(1985),
    [sym__double_quoted_string] = STATE(1990),
    [sym_na] = STATE(575),
    [sym__expression] = STATE(575),
    [sym__string_or_identifier] = STATE(5151),
    [sym__open_parenthesis] = STATE(19),
    [sym__close_parenthesis] = STATE(2245),
    [sym__open_brace] = STATE(4),
    [aux_sym_parenthesized_expression_repeat1] = STATE(58),
    [ts_builtin_sym_end] = ACTIONS(211),
    [sym_identifier] = ACTIONS(53),
    [anon_sym_BSLASH] = ACTIONS(55),
    [anon_sym_function] = ACTIONS(57),
    [anon_sym_EQ] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(61),
    [anon_sym_for] = ACTIONS(63),
    [anon_sym_while] = ACTIONS(65),
    [anon_sym_repeat] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_LT_DASH] = ACTIONS(211),
    [anon_sym_LT_LT_DASH] = ACTIONS(211),
    [anon_sym_COLON_EQ] = ACTIONS(211),
    [anon_sym_DASH_GT] = ACTIONS(209),
    [anon_sym_DASH_GT_GT] = ACTIONS(211),
    [anon_sym_PIPE] = ACTIONS(209),
    [anon_sym_AMP] = ACTIONS(209),
    [anon_sym_PIPE_PIPE] = ACTIONS(211),
    [anon_sym_AMP_AMP] = ACTIONS(211),
    [anon_sym_LT] = ACTIONS(209),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_GT] = ACTIONS(209),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [anon_sym_EQ_EQ] = ACTIONS(211),
    [anon_sym_BANG_EQ] = ACTIONS(211),
    [anon_sym_STAR] = ACTIONS(209),
    [anon_sym_SLASH] = ACTIONS(211),
    [anon_sym_STAR_STAR] = ACTIONS(211),
    [anon_sym_CARET] = ACTIONS(211),
    [aux_sym_binary_operator_token1] = ACTIONS(211),
    [anon_sym_PIPE_GT] = ACTIONS(211),
    [anon_sym_COLON] = ACTIONS(209),
    [anon_sym_DOLLAR] = ACTIONS(211),
    [anon_sym_AT] = ACTIONS(211),
    [aux_sym__hex_literal_token1] = ACTIONS(79),
    [sym__number_literal] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_return] = ACTIONS(251),
    [sym_next] = ACTIONS(251),
    [sym_break] = ACTIONS(251),
    [sym_true] = ACTIONS(251),
    [sym_false] = ACTIONS(251),
    [sym_null] = ACTIONS(251),
    [sym_inf] = ACTIONS(251),
    [sym_nan] = ACTIONS(251),
    [anon_sym_NA] = ACTIONS(89),
    [anon_sym_NA_integer_] = ACTIONS(89),
    [anon_sym_NA_real_] = ACTIONS(89),
    [anon_sym_NA_complex_] = ACTIONS(89),
    [anon_sym_NA_character_] = ACTIONS(89),
    [sym_dots] = ACTIONS(251),
    [sym_dot_dot_i] = ACTIONS(253),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(211),
    [sym__newline] = ACTIONS(255),
    [sym__semicolon] = ACTIONS(211),
    [sym__raw_string_literal] = ACTIONS(95),
    [sym__external_else] = ACTIONS(211),
    [sym__external_open_parenthesis] = ACTIONS(97),
    [sym__external_close_parenthesis] = ACTIONS(261),
    [sym__external_open_brace] = ACTIONS(99),
    [sym__external_close_brace] = ACTIONS(211),
    [sym__external_open_bracket] = ACTIONS(211),
    [sym__external_open_bracket2] = ACTIONS(211),
  },
  [22] = {
    [sym_function_definition] = STATE(509),
    [sym_if_statement] = STATE(509),
    [sym_for_statement] = STATE(509),
    [sym_while_statement] = STATE(509),
    [sym_repeat_statement] = STATE(509),
    [sym_braced_expression] = STATE(509),
    [sym_parenthesized_expression] = STATE(509),
    [sym_call] = STATE(509),
    [sym_subset] = STATE(509),
    [sym_subset2] = STATE(509),
    [sym_unary_operator] = STATE(509),
    [sym_binary_operator] = STATE(509),
    [sym_extract_operator] = STATE(509),
    [sym_namespace_operator] = STATE(509),
    [sym_integer] = STATE(509),
    [sym_complex] = STATE(509),
    [sym_float] = STATE(509),
    [sym__hex_literal] = STATE(1984),
    [sym__float_literal] = STATE(1984),
    [sym_string] = STATE(1982),
    [sym__single_quoted_string] = STATE(1985),
    [sym__double_quoted_string] = STATE(1990),
    [sym_na] = STATE(509),
    [sym__expression] = STATE(509),
    [sym__string_or_identifier] = STATE(5151),
    [sym__open_parenthesis] = STATE(19),
    [sym__open_brace] = STATE(4),
    [aux_sym_function_definition_repeat1] = STATE(47),
    [ts_builtin_sym_end] = ACTIONS(263),
    [sym_identifier] = ACTIONS(53),
    [anon_sym_BSLASH] = ACTIONS(55),
    [anon_sym_function] = ACTIONS(57),
    [anon_sym_EQ] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(61),
    [anon_sym_for] = ACTIONS(63),
    [anon_sym_while] = ACTIONS(65),
    [anon_sym_repeat] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_LT_DASH] = ACTIONS(263),
    [anon_sym_LT_LT_DASH] = ACTIONS(263),
    [anon_sym_COLON_EQ] = ACTIONS(263),
    [anon_sym_DASH_GT] = ACTIONS(265),
    [anon_sym_DASH_GT_GT] = ACTIONS(263),
    [anon_sym_PIPE] = ACTIONS(265),
    [anon_sym_AMP] = ACTIONS(265),
    [anon_sym_PIPE_PIPE] = ACTIONS(263),
    [anon_sym_AMP_AMP] = ACTIONS(263),
    [anon_sym_LT] = ACTIONS(265),
    [anon_sym_LT_EQ] = ACTIONS(263),
    [anon_sym_GT] = ACTIONS(265),
    [anon_sym_GT_EQ] = ACTIONS(263),
    [anon_sym_EQ_EQ] = ACTIONS(263),
    [anon_sym_BANG_EQ] = ACTIONS(263),
    [anon_sym_STAR] = ACTIONS(265),
    [anon_sym_SLASH] = ACTIONS(263),
    [anon_sym_STAR_STAR] = ACTIONS(263),
    [anon_sym_CARET] = ACTIONS(263),
    [aux_sym_binary_operator_token1] = ACTIONS(263),
    [anon_sym_PIPE_GT] = ACTIONS(263),
    [anon_sym_COLON] = ACTIONS(265),
    [anon_sym_DOLLAR] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(263),
    [aux_sym__hex_literal_token1] = ACTIONS(79),
    [sym__number_literal] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_return] = ACTIONS(267),
    [sym_next] = ACTIONS(267),
    [sym_break] = ACTIONS(267),
    [sym_true] = ACTIONS(267),
    [sym_false] = ACTIONS(267),
    [sym_null] = ACTIONS(267),
    [sym_inf] = ACTIONS(267),
    [sym_nan] = ACTIONS(267),
    [anon_sym_NA] = ACTIONS(89),
    [anon_sym_NA_integer_] = ACTIONS(89),
    [anon_sym_NA_real_] = ACTIONS(89),
    [anon_sym_NA_complex_] = ACTIONS(89),
    [anon_sym_NA_character_] = ACTIONS(89),
    [sym_dots] = ACTIONS(267),
    [sym_dot_dot_i] = ACTIONS(269),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(263),
    [sym__newline] = ACTIONS(271),
    [sym__semicolon] = ACTIONS(263),
    [sym__raw_string_literal] = ACTIONS(95),
    [sym__external_else] = ACTIONS(263),
    [sym__external_open_parenthesis] = ACTIONS(97),
    [sym__external_close_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(99),
    [sym__external_close_brace] = ACTIONS(263),
    [sym__external_open_bracket] = ACTIONS(263),
    [sym__external_open_bracket2] = ACTIONS(263),
  },
  [23] = {
    [sym_function_definition] = STATE(917),
    [sym_if_statement] = STATE(917),
    [sym_for_statement] = STATE(917),
    [sym_while_statement] = STATE(917),
    [sym_repeat_statement] = STATE(917),
    [sym_braced_expression] = STATE(917),
    [sym_parenthesized_expression] = STATE(917),
    [sym_call] = STATE(917),
    [sym_subset] = STATE(917),
    [sym_subset2] = STATE(917),
    [sym_unary_operator] = STATE(917),
    [sym_binary_operator] = STATE(917),
    [sym_extract_operator] = STATE(917),
    [sym_namespace_operator] = STATE(917),
    [sym_integer] = STATE(917),
    [sym_complex] = STATE(917),
    [sym_float] = STATE(917),
    [sym__hex_literal] = STATE(2189),
    [sym__float_literal] = STATE(2189),
    [sym_string] = STATE(2192),
    [sym__single_quoted_string] = STATE(2188),
    [sym__double_quoted_string] = STATE(2187),
    [sym_na] = STATE(917),
    [sym__expression] = STATE(917),
    [sym__string_or_identifier] = STATE(5139),
    [sym__open_parenthesis] = STATE(57),
    [sym__close_parenthesis] = STATE(2660),
    [sym__open_brace] = STATE(59),
    [aux_sym_parenthesized_expression_repeat1] = STATE(69),
    [sym_identifier] = ACTIONS(273),
    [anon_sym_BSLASH] = ACTIONS(275),
    [anon_sym_function] = ACTIONS(277),
    [anon_sym_EQ] = ACTIONS(109),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_for] = ACTIONS(281),
    [anon_sym_while] = ACTIONS(283),
    [anon_sym_repeat] = ACTIONS(285),
    [anon_sym_QMARK] = ACTIONS(287),
    [anon_sym_TILDE] = ACTIONS(289),
    [anon_sym_BANG] = ACTIONS(291),
    [anon_sym_PLUS] = ACTIONS(293),
    [anon_sym_DASH] = ACTIONS(295),
    [anon_sym_LT_DASH] = ACTIONS(129),
    [anon_sym_LT_LT_DASH] = ACTIONS(129),
    [anon_sym_COLON_EQ] = ACTIONS(129),
    [anon_sym_DASH_GT] = ACTIONS(109),
    [anon_sym_DASH_GT_GT] = ACTIONS(129),
    [anon_sym_PIPE] = ACTIONS(109),
    [anon_sym_AMP] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_STAR_STAR] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [aux_sym_binary_operator_token1] = ACTIONS(129),
    [anon_sym_PIPE_GT] = ACTIONS(129),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(129),
    [anon_sym_AT] = ACTIONS(129),
    [aux_sym__hex_literal_token1] = ACTIONS(297),
    [sym__number_literal] = ACTIONS(299),
    [anon_sym_SQUOTE] = ACTIONS(301),
    [anon_sym_DQUOTE] = ACTIONS(303),
    [sym_return] = ACTIONS(305),
    [sym_next] = ACTIONS(305),
    [sym_break] = ACTIONS(305),
    [sym_true] = ACTIONS(305),
    [sym_false] = ACTIONS(305),
    [sym_null] = ACTIONS(305),
    [sym_inf] = ACTIONS(305),
    [sym_nan] = ACTIONS(305),
    [anon_sym_NA] = ACTIONS(307),
    [anon_sym_NA_integer_] = ACTIONS(307),
    [anon_sym_NA_real_] = ACTIONS(307),
    [anon_sym_NA_complex_] = ACTIONS(307),
    [anon_sym_NA_character_] = ACTIONS(307),
    [sym_dots] = ACTIONS(305),
    [sym_dot_dot_i] = ACTIONS(309),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(129),
    [sym__newline] = ACTIONS(311),
    [sym__semicolon] = ACTIONS(129),
    [sym__raw_string_literal] = ACTIONS(313),
    [sym__external_open_parenthesis] = ACTIONS(315),
    [sym__external_close_parenthesis] = ACTIONS(317),
    [sym__external_open_brace] = ACTIONS(319),
    [sym__external_close_brace] = ACTIONS(129),
    [sym__external_open_bracket] = ACTIONS(129),
    [sym__external_close_bracket] = ACTIONS(129),
    [sym__external_open_bracket2] = ACTIONS(129),
  },
  [24] = {
    [sym_function_definition] = STATE(790),
    [sym_if_statement] = STATE(790),
    [sym_for_statement] = STATE(790),
    [sym_while_statement] = STATE(790),
    [sym_repeat_statement] = STATE(790),
    [sym_braced_expression] = STATE(790),
    [sym_parenthesized_expression] = STATE(790),
    [sym_call] = STATE(790),
    [sym_subset] = STATE(790),
    [sym_subset2] = STATE(790),
    [sym_unary_operator] = STATE(790),
    [sym_binary_operator] = STATE(790),
    [sym_extract_operator] = STATE(790),
    [sym_namespace_operator] = STATE(790),
    [sym_integer] = STATE(790),
    [sym_complex] = STATE(790),
    [sym_float] = STATE(790),
    [sym__hex_literal] = STATE(2183),
    [sym__float_literal] = STATE(2183),
    [sym_string] = STATE(2169),
    [sym__single_quoted_string] = STATE(2181),
    [sym__double_quoted_string] = STATE(2180),
    [sym_na] = STATE(790),
    [sym__expression] = STATE(790),
    [sym__string_or_identifier] = STATE(5149),
    [sym__open_parenthesis] = STATE(67),
    [sym__open_brace] = STATE(24),
    [sym__close_brace] = STATE(2490),
    [aux_sym_braced_expression_repeat1] = STATE(68),
    [ts_builtin_sym_end] = ACTIONS(155),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_BSLASH] = ACTIONS(323),
    [anon_sym_function] = ACTIONS(325),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(327),
    [anon_sym_for] = ACTIONS(329),
    [anon_sym_while] = ACTIONS(331),
    [anon_sym_repeat] = ACTIONS(333),
    [anon_sym_QMARK] = ACTIONS(335),
    [anon_sym_TILDE] = ACTIONS(337),
    [anon_sym_BANG] = ACTIONS(339),
    [anon_sym_PLUS] = ACTIONS(341),
    [anon_sym_DASH] = ACTIONS(343),
    [anon_sym_LT_DASH] = ACTIONS(155),
    [anon_sym_LT_LT_DASH] = ACTIONS(155),
    [anon_sym_COLON_EQ] = ACTIONS(155),
    [anon_sym_DASH_GT] = ACTIONS(157),
    [anon_sym_DASH_GT_GT] = ACTIONS(155),
    [anon_sym_PIPE] = ACTIONS(157),
    [anon_sym_AMP] = ACTIONS(157),
    [anon_sym_PIPE_PIPE] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(157),
    [anon_sym_LT_EQ] = ACTIONS(155),
    [anon_sym_GT] = ACTIONS(157),
    [anon_sym_GT_EQ] = ACTIONS(155),
    [anon_sym_EQ_EQ] = ACTIONS(155),
    [anon_sym_BANG_EQ] = ACTIONS(155),
    [anon_sym_STAR] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(155),
    [anon_sym_STAR_STAR] = ACTIONS(155),
    [anon_sym_CARET] = ACTIONS(155),
    [aux_sym_binary_operator_token1] = ACTIONS(155),
    [anon_sym_PIPE_GT] = ACTIONS(155),
    [anon_sym_COLON] = ACTIONS(157),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(155),
    [aux_sym__hex_literal_token1] = ACTIONS(345),
    [sym__number_literal] = ACTIONS(347),
    [anon_sym_SQUOTE] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(351),
    [sym_return] = ACTIONS(353),
    [sym_next] = ACTIONS(353),
    [sym_break] = ACTIONS(353),
    [sym_true] = ACTIONS(353),
    [sym_false] = ACTIONS(353),
    [sym_null] = ACTIONS(353),
    [sym_inf] = ACTIONS(353),
    [sym_nan] = ACTIONS(353),
    [anon_sym_NA] = ACTIONS(355),
    [anon_sym_NA_integer_] = ACTIONS(355),
    [anon_sym_NA_real_] = ACTIONS(355),
    [anon_sym_NA_complex_] = ACTIONS(355),
    [anon_sym_NA_character_] = ACTIONS(355),
    [sym_dots] = ACTIONS(353),
    [sym_dot_dot_i] = ACTIONS(357),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(155),
    [sym__newline] = ACTIONS(359),
    [sym__semicolon] = ACTIONS(359),
    [sym__raw_string_literal] = ACTIONS(361),
    [sym__external_open_parenthesis] = ACTIONS(363),
    [sym__external_close_parenthesis] = ACTIONS(155),
    [sym__external_open_brace] = ACTIONS(365),
    [sym__external_close_brace] = ACTIONS(367),
    [sym__external_open_bracket] = ACTIONS(155),
    [sym__external_open_bracket2] = ACTIONS(155),
  },
  [25] = {
    [sym_function_definition] = STATE(553),
    [sym_if_statement] = STATE(553),
    [sym_for_statement] = STATE(553),
    [sym_while_statement] = STATE(553),
    [sym_repeat_statement] = STATE(553),
    [sym_braced_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(553),
    [sym_call] = STATE(553),
    [sym_subset] = STATE(553),
    [sym_subset2] = STATE(553),
    [sym_unary_operator] = STATE(553),
    [sym_binary_operator] = STATE(553),
    [sym_extract_operator] = STATE(553),
    [sym_namespace_operator] = STATE(553),
    [sym_integer] = STATE(553),
    [sym_complex] = STATE(553),
    [sym_float] = STATE(553),
    [sym__hex_literal] = STATE(1984),
    [sym__float_literal] = STATE(1984),
    [sym_string] = STATE(1982),
    [sym__single_quoted_string] = STATE(1985),
    [sym__double_quoted_string] = STATE(1990),
    [sym_na] = STATE(553),
    [sym__expression] = STATE(553),
    [sym__string_or_identifier] = STATE(5151),
    [sym__open_parenthesis] = STATE(19),
    [sym__open_brace] = STATE(4),
    [aux_sym_function_definition_repeat1] = STATE(2195),
    [ts_builtin_sym_end] = ACTIONS(369),
    [sym_identifier] = ACTIONS(53),
    [anon_sym_BSLASH] = ACTIONS(55),
    [anon_sym_function] = ACTIONS(57),
    [anon_sym_EQ] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(61),
    [anon_sym_for] = ACTIONS(63),
    [anon_sym_while] = ACTIONS(65),
    [anon_sym_repeat] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_LT_DASH] = ACTIONS(369),
    [anon_sym_LT_LT_DASH] = ACTIONS(369),
    [anon_sym_COLON_EQ] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(371),
    [anon_sym_DASH_GT_GT] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(371),
    [anon_sym_AMP] = ACTIONS(371),
    [anon_sym_PIPE_PIPE] = ACTIONS(369),
    [anon_sym_AMP_AMP] = ACTIONS(369),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_LT_EQ] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_EQ] = ACTIONS(369),
    [anon_sym_EQ_EQ] = ACTIONS(369),
    [anon_sym_BANG_EQ] = ACTIONS(369),
    [anon_sym_STAR] = ACTIONS(371),
    [anon_sym_SLASH] = ACTIONS(369),
    [anon_sym_STAR_STAR] = ACTIONS(369),
    [anon_sym_CARET] = ACTIONS(369),
    [aux_sym_binary_operator_token1] = ACTIONS(369),
    [anon_sym_PIPE_GT] = ACTIONS(369),
    [anon_sym_COLON] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(369),
    [anon_sym_AT] = ACTIONS(369),
    [aux_sym__hex_literal_token1] = ACTIONS(79),
    [sym__number_literal] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(89),
    [anon_sym_NA_integer_] = ACTIONS(89),
    [anon_sym_NA_real_] = ACTIONS(89),
    [anon_sym_NA_complex_] = ACTIONS(89),
    [anon_sym_NA_character_] = ACTIONS(89),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(369),
    [sym__newline] = ACTIONS(369),
    [sym__semicolon] = ACTIONS(369),
    [sym__raw_string_literal] = ACTIONS(95),
    [sym__external_else] = ACTIONS(369),
    [sym__external_open_parenthesis] = ACTIONS(97),
    [sym__external_close_parenthesis] = ACTIONS(369),
    [sym__external_open_brace] = ACTIONS(99),
    [sym__external_close_brace] = ACTIONS(369),
    [sym__external_open_bracket] = ACTIONS(369),
    [sym__external_open_bracket2] = ACTIONS(369),
  },
  [26] = {
    [sym_function_definition] = STATE(554),
    [sym_if_statement] = STATE(554),
    [sym_for_statement] = STATE(554),
    [sym_while_statement] = STATE(554),
    [sym_repeat_statement] = STATE(554),
    [sym_braced_expression] = STATE(554),
    [sym_parenthesized_expression] = STATE(554),
    [sym_call] = STATE(554),
    [sym_subset] = STATE(554),
    [sym_subset2] = STATE(554),
    [sym_unary_operator] = STATE(554),
    [sym_binary_operator] = STATE(554),
    [sym_extract_operator] = STATE(554),
    [sym_namespace_operator] = STATE(554),
    [sym_integer] = STATE(554),
    [sym_complex] = STATE(554),
    [sym_float] = STATE(554),
    [sym__hex_literal] = STATE(1984),
    [sym__float_literal] = STATE(1984),
    [sym_string] = STATE(1982),
    [sym__single_quoted_string] = STATE(1985),
    [sym__double_quoted_string] = STATE(1990),
    [sym_na] = STATE(554),
    [sym__expression] = STATE(554),
    [sym__string_or_identifier] = STATE(5151),
    [sym__open_parenthesis] = STATE(19),
    [sym__open_brace] = STATE(4),
    [aux_sym_function_definition_repeat1] = STATE(28),
    [ts_builtin_sym_end] = ACTIONS(377),
    [sym_identifier] = ACTIONS(53),
    [anon_sym_BSLASH] = ACTIONS(55),
    [anon_sym_function] = ACTIONS(57),
    [anon_sym_EQ] = ACTIONS(379),
    [anon_sym_if] = ACTIONS(61),
    [anon_sym_for] = ACTIONS(63),
    [anon_sym_while] = ACTIONS(65),
    [anon_sym_repeat] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_LT_DASH] = ACTIONS(377),
    [anon_sym_LT_LT_DASH] = ACTIONS(377),
    [anon_sym_COLON_EQ] = ACTIONS(377),
    [anon_sym_DASH_GT] = ACTIONS(379),
    [anon_sym_DASH_GT_GT] = ACTIONS(377),
    [anon_sym_PIPE] = ACTIONS(379),
    [anon_sym_AMP] = ACTIONS(379),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_LT] = ACTIONS(379),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(379),
    [anon_sym_GT_EQ] = ACTIONS(377),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(379),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_STAR_STAR] = ACTIONS(377),
    [anon_sym_CARET] = ACTIONS(377),
    [aux_sym_binary_operator_token1] = ACTIONS(377),
    [anon_sym_PIPE_GT] = ACTIONS(377),
    [anon_sym_COLON] = ACTIONS(379),
    [anon_sym_DOLLAR] = ACTIONS(377),
    [anon_sym_AT] = ACTIONS(377),
    [aux_sym__hex_literal_token1] = ACTIONS(79),
    [sym__number_literal] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(89),
    [anon_sym_NA_integer_] = ACTIONS(89),
    [anon_sym_NA_real_] = ACTIONS(89),
    [anon_sym_NA_complex_] = ACTIONS(89),
    [anon_sym_NA_character_] = ACTIONS(89),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(383),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(377),
    [sym__newline] = ACTIONS(385),
    [sym__semicolon] = ACTIONS(377),
    [sym__raw_string_literal] = ACTIONS(95),
    [sym__external_else] = ACTIONS(377),
    [sym__external_open_parenthesis] = ACTIONS(97),
    [sym__external_close_parenthesis] = ACTIONS(377),
    [sym__external_open_brace] = ACTIONS(99),
    [sym__external_close_brace] = ACTIONS(377),
    [sym__external_open_bracket] = ACTIONS(377),
    [sym__external_open_bracket2] = ACTIONS(377),
  },
  [27] = {
    [sym_function_definition] = STATE(556),
    [sym_if_statement] = STATE(556),
    [sym_for_statement] = STATE(556),
    [sym_while_statement] = STATE(556),
    [sym_repeat_statement] = STATE(556),
    [sym_braced_expression] = STATE(556),
    [sym_parenthesized_expression] = STATE(556),
    [sym_call] = STATE(556),
    [sym_subset] = STATE(556),
    [sym_subset2] = STATE(556),
    [sym_unary_operator] = STATE(556),
    [sym_binary_operator] = STATE(556),
    [sym_extract_operator] = STATE(556),
    [sym_namespace_operator] = STATE(556),
    [sym_integer] = STATE(556),
    [sym_complex] = STATE(556),
    [sym_float] = STATE(556),
    [sym__hex_literal] = STATE(1984),
    [sym__float_literal] = STATE(1984),
    [sym_string] = STATE(1982),
    [sym__single_quoted_string] = STATE(1985),
    [sym__double_quoted_string] = STATE(1990),
    [sym_na] = STATE(556),
    [sym__expression] = STATE(556),
    [sym__string_or_identifier] = STATE(5151),
    [sym__open_parenthesis] = STATE(19),
    [sym__open_brace] = STATE(4),
    [aux_sym_function_definition_repeat1] = STATE(30),
    [ts_builtin_sym_end] = ACTIONS(387),
    [sym_identifier] = ACTIONS(53),
    [anon_sym_BSLASH] = ACTIONS(55),
    [anon_sym_function] = ACTIONS(57),
    [anon_sym_EQ] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(61),
    [anon_sym_for] = ACTIONS(63),
    [anon_sym_while] = ACTIONS(65),
    [anon_sym_repeat] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_LT_DASH] = ACTIONS(387),
    [anon_sym_LT_LT_DASH] = ACTIONS(387),
    [anon_sym_COLON_EQ] = ACTIONS(387),
    [anon_sym_DASH_GT] = ACTIONS(389),
    [anon_sym_DASH_GT_GT] = ACTIONS(387),
    [anon_sym_PIPE] = ACTIONS(389),
    [anon_sym_AMP] = ACTIONS(389),
    [anon_sym_PIPE_PIPE] = ACTIONS(387),
    [anon_sym_AMP_AMP] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(389),
    [anon_sym_LT_EQ] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(389),
    [anon_sym_GT_EQ] = ACTIONS(387),
    [anon_sym_EQ_EQ] = ACTIONS(387),
    [anon_sym_BANG_EQ] = ACTIONS(387),
    [anon_sym_STAR] = ACTIONS(389),
    [anon_sym_SLASH] = ACTIONS(387),
    [anon_sym_STAR_STAR] = ACTIONS(387),
    [anon_sym_CARET] = ACTIONS(387),
    [aux_sym_binary_operator_token1] = ACTIONS(387),
    [anon_sym_PIPE_GT] = ACTIONS(387),
    [anon_sym_COLON] = ACTIONS(389),
    [anon_sym_DOLLAR] = ACTIONS(387),
    [anon_sym_AT] = ACTIONS(387),
    [aux_sym__hex_literal_token1] = ACTIONS(79),
    [sym__number_literal] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_return] = ACTIONS(391),
    [sym_next] = ACTIONS(391),
    [sym_break] = ACTIONS(391),
    [sym_true] = ACTIONS(391),
    [sym_false] = ACTIONS(391),
    [sym_null] = ACTIONS(391),
    [sym_inf] = ACTIONS(391),
    [sym_nan] = ACTIONS(391),
    [anon_sym_NA] = ACTIONS(89),
    [anon_sym_NA_integer_] = ACTIONS(89),
    [anon_sym_NA_real_] = ACTIONS(89),
    [anon_sym_NA_complex_] = ACTIONS(89),
    [anon_sym_NA_character_] = ACTIONS(89),
    [sym_dots] = ACTIONS(391),
    [sym_dot_dot_i] = ACTIONS(393),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(387),
    [sym__newline] = ACTIONS(395),
    [sym__semicolon] = ACTIONS(387),
    [sym__raw_string_literal] = ACTIONS(95),
    [sym__external_else] = ACTIONS(387),
    [sym__external_open_parenthesis] = ACTIONS(97),
    [sym__external_close_parenthesis] = ACTIONS(387),
    [sym__external_open_brace] = ACTIONS(99),
    [sym__external_close_brace] = ACTIONS(387),
    [sym__external_open_bracket] = ACTIONS(387),
    [sym__external_open_bracket2] = ACTIONS(387),
  },
  [28] = {
    [sym_function_definition] = STATE(557),
    [sym_if_statement] = STATE(557),
    [sym_for_statement] = STATE(557),
    [sym_while_statement] = STATE(557),
    [sym_repeat_statement] = STATE(557),
    [sym_braced_expression] = STATE(557),
    [sym_parenthesized_expression] = STATE(557),
    [sym_call] = STATE(557),
    [sym_subset] = STATE(557),
    [sym_subset2] = STATE(557),
    [sym_unary_operator] = STATE(557),
    [sym_binary_operator] = STATE(557),
    [sym_extract_operator] = STATE(557),
    [sym_namespace_operator] = STATE(557),
    [sym_integer] = STATE(557),
    [sym_complex] = STATE(557),
    [sym_float] = STATE(557),
    [sym__hex_literal] = STATE(1984),
    [sym__float_literal] = STATE(1984),
    [sym_string] = STATE(1982),
    [sym__single_quoted_string] = STATE(1985),
    [sym__double_quoted_string] = STATE(1990),
    [sym_na] = STATE(557),
    [sym__expression] = STATE(557),
    [sym__string_or_identifier] = STATE(5151),
    [sym__open_parenthesis] = STATE(19),
    [sym__open_brace] = STATE(4),
    [aux_sym_function_definition_repeat1] = STATE(2195),
    [ts_builtin_sym_end] = ACTIONS(397),
    [sym_identifier] = ACTIONS(53),
    [anon_sym_BSLASH] = ACTIONS(55),
    [anon_sym_function] = ACTIONS(57),
    [anon_sym_EQ] = ACTIONS(399),
    [anon_sym_if] = ACTIONS(61),
    [anon_sym_for] = ACTIONS(63),
    [anon_sym_while] = ACTIONS(65),
    [anon_sym_repeat] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_LT_DASH] = ACTIONS(397),
    [anon_sym_LT_LT_DASH] = ACTIONS(397),
    [anon_sym_COLON_EQ] = ACTIONS(397),
    [anon_sym_DASH_GT] = ACTIONS(399),
    [anon_sym_DASH_GT_GT] = ACTIONS(397),
    [anon_sym_PIPE] = ACTIONS(399),
    [anon_sym_AMP] = ACTIONS(399),
    [anon_sym_PIPE_PIPE] = ACTIONS(397),
    [anon_sym_AMP_AMP] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(399),
    [anon_sym_LT_EQ] = ACTIONS(397),
    [anon_sym_GT] = ACTIONS(399),
    [anon_sym_GT_EQ] = ACTIONS(397),
    [anon_sym_EQ_EQ] = ACTIONS(397),
    [anon_sym_BANG_EQ] = ACTIONS(397),
    [anon_sym_STAR] = ACTIONS(399),
    [anon_sym_SLASH] = ACTIONS(397),
    [anon_sym_STAR_STAR] = ACTIONS(397),
    [anon_sym_CARET] = ACTIONS(397),
    [aux_sym_binary_operator_token1] = ACTIONS(397),
    [anon_sym_PIPE_GT] = ACTIONS(397),
    [anon_sym_COLON] = ACTIONS(399),
    [anon_sym_DOLLAR] = ACTIONS(397),
    [anon_sym_AT] = ACTIONS(397),
    [aux_sym__hex_literal_token1] = ACTIONS(79),
    [sym__number_literal] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_return] = ACTIONS(401),
    [sym_next] = ACTIONS(401),
    [sym_break] = ACTIONS(401),
    [sym_true] = ACTIONS(401),
    [sym_false] = ACTIONS(401),
    [sym_null] = ACTIONS(401),
    [sym_inf] = ACTIONS(401),
    [sym_nan] = ACTIONS(401),
    [anon_sym_NA] = ACTIONS(89),
    [anon_sym_NA_integer_] = ACTIONS(89),
    [anon_sym_NA_real_] = ACTIONS(89),
    [anon_sym_NA_complex_] = ACTIONS(89),
    [anon_sym_NA_character_] = ACTIONS(89),
    [sym_dots] = ACTIONS(401),
    [sym_dot_dot_i] = ACTIONS(403),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(397),
    [sym__newline] = ACTIONS(397),
    [sym__semicolon] = ACTIONS(397),
    [sym__raw_string_literal] = ACTIONS(95),
    [sym__external_else] = ACTIONS(397),
    [sym__external_open_parenthesis] = ACTIONS(97),
    [sym__external_close_parenthesis] = ACTIONS(397),
    [sym__external_open_brace] = ACTIONS(99),
    [sym__external_close_brace] = ACTIONS(397),
    [sym__external_open_bracket] = ACTIONS(397),
    [sym__external_open_bracket2] = ACTIONS(397),
  },
  [29] = {
    [sym_function_definition] = STATE(789),
    [sym_if_statement] = STATE(789),
    [sym_for_statement] = STATE(789),
    [sym_while_statement] = STATE(789),
    [sym_repeat_statement] = STATE(789),
    [sym_braced_expression] = STATE(789),
    [sym_parenthesized_expression] = STATE(789),
    [sym_call] = STATE(789),
    [sym_subset] = STATE(789),
    [sym_subset2] = STATE(789),
    [sym_unary_operator] = STATE(789),
    [sym_binary_operator] = STATE(789),
    [sym_extract_operator] = STATE(789),
    [sym_namespace_operator] = STATE(789),
    [sym_integer] = STATE(789),
    [sym_complex] = STATE(789),
    [sym_float] = STATE(789),
    [sym__hex_literal] = STATE(2210),
    [sym__float_literal] = STATE(2210),
    [sym_string] = STATE(2209),
    [sym__single_quoted_string] = STATE(2211),
    [sym__double_quoted_string] = STATE(2212),
    [sym_na] = STATE(789),
    [sym__expression] = STATE(789),
    [sym__string_or_identifier] = STATE(5127),
    [sym__open_parenthesis] = STATE(5),
    [sym__open_brace] = STATE(42),
    [sym__close_brace] = STATE(2858),
    [aux_sym_braced_expression_repeat1] = STATE(35),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_BSLASH] = ACTIONS(407),
    [anon_sym_function] = ACTIONS(409),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(411),
    [anon_sym_for] = ACTIONS(413),
    [anon_sym_while] = ACTIONS(415),
    [anon_sym_repeat] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_TILDE] = ACTIONS(421),
    [anon_sym_BANG] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(427),
    [anon_sym_LT_DASH] = ACTIONS(155),
    [anon_sym_LT_LT_DASH] = ACTIONS(155),
    [anon_sym_COLON_EQ] = ACTIONS(155),
    [anon_sym_DASH_GT] = ACTIONS(157),
    [anon_sym_DASH_GT_GT] = ACTIONS(155),
    [anon_sym_PIPE] = ACTIONS(157),
    [anon_sym_AMP] = ACTIONS(157),
    [anon_sym_PIPE_PIPE] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(157),
    [anon_sym_LT_EQ] = ACTIONS(155),
    [anon_sym_GT] = ACTIONS(157),
    [anon_sym_GT_EQ] = ACTIONS(155),
    [anon_sym_EQ_EQ] = ACTIONS(155),
    [anon_sym_BANG_EQ] = ACTIONS(155),
    [anon_sym_STAR] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(155),
    [anon_sym_STAR_STAR] = ACTIONS(155),
    [anon_sym_CARET] = ACTIONS(155),
    [aux_sym_binary_operator_token1] = ACTIONS(155),
    [anon_sym_PIPE_GT] = ACTIONS(155),
    [anon_sym_COLON] = ACTIONS(157),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(155),
    [aux_sym__hex_literal_token1] = ACTIONS(429),
    [sym__number_literal] = ACTIONS(431),
    [anon_sym_SQUOTE] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_return] = ACTIONS(437),
    [sym_next] = ACTIONS(437),
    [sym_break] = ACTIONS(437),
    [sym_true] = ACTIONS(437),
    [sym_false] = ACTIONS(437),
    [sym_null] = ACTIONS(437),
    [sym_inf] = ACTIONS(437),
    [sym_nan] = ACTIONS(437),
    [anon_sym_NA] = ACTIONS(439),
    [anon_sym_NA_integer_] = ACTIONS(439),
    [anon_sym_NA_real_] = ACTIONS(439),
    [anon_sym_NA_complex_] = ACTIONS(439),
    [anon_sym_NA_character_] = ACTIONS(439),
    [sym_dots] = ACTIONS(437),
    [sym_dot_dot_i] = ACTIONS(441),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(155),
    [sym__newline] = ACTIONS(443),
    [sym__semicolon] = ACTIONS(443),
    [sym__raw_string_literal] = ACTIONS(445),
    [sym__external_else] = ACTIONS(155),
    [sym__external_open_parenthesis] = ACTIONS(447),
    [sym__external_open_brace] = ACTIONS(449),
    [sym__external_close_brace] = ACTIONS(451),
    [sym__external_open_bracket] = ACTIONS(155),
    [sym__external_open_bracket2] = ACTIONS(155),
    [sym__external_close_bracket2] = ACTIONS(155),
  },
  [30] = {
    [sym_function_definition] = STATE(560),
    [sym_if_statement] = STATE(560),
    [sym_for_statement] = STATE(560),
    [sym_while_statement] = STATE(560),
    [sym_repeat_statement] = STATE(560),
    [sym_braced_expression] = STATE(560),
    [sym_parenthesized_expression] = STATE(560),
    [sym_call] = STATE(560),
    [sym_subset] = STATE(560),
    [sym_subset2] = STATE(560),
    [sym_unary_operator] = STATE(560),
    [sym_binary_operator] = STATE(560),
    [sym_extract_operator] = STATE(560),
    [sym_namespace_operator] = STATE(560),
    [sym_integer] = STATE(560),
    [sym_complex] = STATE(560),
    [sym_float] = STATE(560),
    [sym__hex_literal] = STATE(1984),
    [sym__float_literal] = STATE(1984),
    [sym_string] = STATE(1982),
    [sym__single_quoted_string] = STATE(1985),
    [sym__double_quoted_string] = STATE(1990),
    [sym_na] = STATE(560),
    [sym__expression] = STATE(560),
    [sym__string_or_identifier] = STATE(5151),
    [sym__open_parenthesis] = STATE(19),
    [sym__open_brace] = STATE(4),
    [aux_sym_function_definition_repeat1] = STATE(2195),
    [ts_builtin_sym_end] = ACTIONS(453),
    [sym_identifier] = ACTIONS(53),
    [anon_sym_BSLASH] = ACTIONS(55),
    [anon_sym_function] = ACTIONS(57),
    [anon_sym_EQ] = ACTIONS(455),
    [anon_sym_if] = ACTIONS(61),
    [anon_sym_for] = ACTIONS(63),
    [anon_sym_while] = ACTIONS(65),
    [anon_sym_repeat] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [anon_sym_LT_LT_DASH] = ACTIONS(453),
    [anon_sym_COLON_EQ] = ACTIONS(453),
    [anon_sym_DASH_GT] = ACTIONS(455),
    [anon_sym_DASH_GT_GT] = ACTIONS(453),
    [anon_sym_PIPE] = ACTIONS(455),
    [anon_sym_AMP] = ACTIONS(455),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(455),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_GT] = ACTIONS(455),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(453),
    [anon_sym_STAR] = ACTIONS(455),
    [anon_sym_SLASH] = ACTIONS(453),
    [anon_sym_STAR_STAR] = ACTIONS(453),
    [anon_sym_CARET] = ACTIONS(453),
    [aux_sym_binary_operator_token1] = ACTIONS(453),
    [anon_sym_PIPE_GT] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(455),
    [anon_sym_DOLLAR] = ACTIONS(453),
    [anon_sym_AT] = ACTIONS(453),
    [aux_sym__hex_literal_token1] = ACTIONS(79),
    [sym__number_literal] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_return] = ACTIONS(457),
    [sym_next] = ACTIONS(457),
    [sym_break] = ACTIONS(457),
    [sym_true] = ACTIONS(457),
    [sym_false] = ACTIONS(457),
    [sym_null] = ACTIONS(457),
    [sym_inf] = ACTIONS(457),
    [sym_nan] = ACTIONS(457),
    [anon_sym_NA] = ACTIONS(89),
    [anon_sym_NA_integer_] = ACTIONS(89),
    [anon_sym_NA_real_] = ACTIONS(89),
    [anon_sym_NA_complex_] = ACTIONS(89),
    [anon_sym_NA_character_] = ACTIONS(89),
    [sym_dots] = ACTIONS(457),
    [sym_dot_dot_i] = ACTIONS(459),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(453),
    [sym__newline] = ACTIONS(453),
    [sym__semicolon] = ACTIONS(453),
    [sym__raw_string_literal] = ACTIONS(95),
    [sym__external_else] = ACTIONS(453),
    [sym__external_open_parenthesis] = ACTIONS(97),
    [sym__external_close_parenthesis] = ACTIONS(453),
    [sym__external_open_brace] = ACTIONS(99),
    [sym__external_close_brace] = ACTIONS(453),
    [sym__external_open_bracket] = ACTIONS(453),
    [sym__external_open_bracket2] = ACTIONS(453),
  },
  [31] = {
    [sym_function_definition] = STATE(561),
    [sym_if_statement] = STATE(561),
    [sym_for_statement] = STATE(561),
    [sym_while_statement] = STATE(561),
    [sym_repeat_statement] = STATE(561),
    [sym_braced_expression] = STATE(561),
    [sym_parenthesized_expression] = STATE(561),
    [sym_call] = STATE(561),
    [sym_subset] = STATE(561),
    [sym_subset2] = STATE(561),
    [sym_unary_operator] = STATE(561),
    [sym_binary_operator] = STATE(561),
    [sym_extract_operator] = STATE(561),
    [sym_namespace_operator] = STATE(561),
    [sym_integer] = STATE(561),
    [sym_complex] = STATE(561),
    [sym_float] = STATE(561),
    [sym__hex_literal] = STATE(1984),
    [sym__float_literal] = STATE(1984),
    [sym_string] = STATE(1982),
    [sym__single_quoted_string] = STATE(1985),
    [sym__double_quoted_string] = STATE(1990),
    [sym_na] = STATE(561),
    [sym__expression] = STATE(561),
    [sym__string_or_identifier] = STATE(5151),
    [sym__open_parenthesis] = STATE(19),
    [sym__open_brace] = STATE(4),
    [aux_sym_function_definition_repeat1] = STATE(32),
    [ts_builtin_sym_end] = ACTIONS(461),
    [sym_identifier] = ACTIONS(53),
    [anon_sym_BSLASH] = ACTIONS(55),
    [anon_sym_function] = ACTIONS(57),
    [anon_sym_EQ] = ACTIONS(463),
    [anon_sym_if] = ACTIONS(61),
    [anon_sym_for] = ACTIONS(63),
    [anon_sym_while] = ACTIONS(65),
    [anon_sym_repeat] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_LT_DASH] = ACTIONS(461),
    [anon_sym_LT_LT_DASH] = ACTIONS(461),
    [anon_sym_COLON_EQ] = ACTIONS(461),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_DASH_GT_GT] = ACTIONS(461),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_PIPE_PIPE] = ACTIONS(461),
    [anon_sym_AMP_AMP] = ACTIONS(461),
    [anon_sym_LT] = ACTIONS(463),
    [anon_sym_LT_EQ] = ACTIONS(461),
    [anon_sym_GT] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(461),
    [anon_sym_EQ_EQ] = ACTIONS(461),
    [anon_sym_BANG_EQ] = ACTIONS(461),
    [anon_sym_STAR] = ACTIONS(463),
    [anon_sym_SLASH] = ACTIONS(461),
    [anon_sym_STAR_STAR] = ACTIONS(461),
    [anon_sym_CARET] = ACTIONS(461),
    [aux_sym_binary_operator_token1] = ACTIONS(461),
    [anon_sym_PIPE_GT] = ACTIONS(461),
    [anon_sym_COLON] = ACTIONS(463),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_AT] = ACTIONS(461),
    [aux_sym__hex_literal_token1] = ACTIONS(79),
    [sym__number_literal] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_return] = ACTIONS(465),
    [sym_next] = ACTIONS(465),
    [sym_break] = ACTIONS(465),
    [sym_true] = ACTIONS(465),
    [sym_false] = ACTIONS(465),
    [sym_null] = ACTIONS(465),
    [sym_inf] = ACTIONS(465),
    [sym_nan] = ACTIONS(465),
    [anon_sym_NA] = ACTIONS(89),
    [anon_sym_NA_integer_] = ACTIONS(89),
    [anon_sym_NA_real_] = ACTIONS(89),
    [anon_sym_NA_complex_] = ACTIONS(89),
    [anon_sym_NA_character_] = ACTIONS(89),
    [sym_dots] = ACTIONS(465),
    [sym_dot_dot_i] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(461),
    [sym__newline] = ACTIONS(469),
    [sym__semicolon] = ACTIONS(461),
    [sym__raw_string_literal] = ACTIONS(95),
    [sym__external_else] = ACTIONS(461),
    [sym__external_open_parenthesis] = ACTIONS(97),
    [sym__external_close_parenthesis] = ACTIONS(461),
    [sym__external_open_brace] = ACTIONS(99),
    [sym__external_close_brace] = ACTIONS(461),
    [sym__external_open_bracket] = ACTIONS(461),
    [sym__external_open_bracket2] = ACTIONS(461),
  },
  [32] = {
    [sym_function_definition] = STATE(544),
    [sym_if_statement] = STATE(544),
    [sym_for_statement] = STATE(544),
    [sym_while_statement] = STATE(544),
    [sym_repeat_statement] = STATE(544),
    [sym_braced_expression] = STATE(544),
    [sym_parenthesized_expression] = STATE(544),
    [sym_call] = STATE(544),
    [sym_subset] = STATE(544),
    [sym_subset2] = STATE(544),
    [sym_unary_operator] = STATE(544),
    [sym_binary_operator] = STATE(544),
    [sym_extract_operator] = STATE(544),
    [sym_namespace_operator] = STATE(544),
    [sym_integer] = STATE(544),
    [sym_complex] = STATE(544),
    [sym_float] = STATE(544),
    [sym__hex_literal] = STATE(1984),
    [sym__float_literal] = STATE(1984),
    [sym_string] = STATE(1982),
    [sym__single_quoted_string] = STATE(1985),
    [sym__double_quoted_string] = STATE(1990),
    [sym_na] = STATE(544),
    [sym__expression] = STATE(544),
    [sym__string_or_identifier] = STATE(5151),
    [sym__open_parenthesis] = STATE(19),
    [sym__open_brace] = STATE(4),
    [aux_sym_function_definition_repeat1] = STATE(2195),
    [ts_builtin_sym_end] = ACTIONS(471),
    [sym_identifier] = ACTIONS(53),
    [anon_sym_BSLASH] = ACTIONS(55),
    [anon_sym_function] = ACTIONS(57),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_if] = ACTIONS(61),
    [anon_sym_for] = ACTIONS(63),
    [anon_sym_while] = ACTIONS(65),
    [anon_sym_repeat] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_LT_DASH] = ACTIONS(471),
    [anon_sym_LT_LT_DASH] = ACTIONS(471),
    [anon_sym_COLON_EQ] = ACTIONS(471),
    [anon_sym_DASH_GT] = ACTIONS(473),
    [anon_sym_DASH_GT_GT] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(473),
    [anon_sym_AMP] = ACTIONS(473),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_LT_EQ] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(473),
    [anon_sym_GT_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_STAR] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [aux_sym_binary_operator_token1] = ACTIONS(471),
    [anon_sym_PIPE_GT] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(473),
    [anon_sym_DOLLAR] = ACTIONS(471),
    [anon_sym_AT] = ACTIONS(471),
    [aux_sym__hex_literal_token1] = ACTIONS(79),
    [sym__number_literal] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_return] = ACTIONS(475),
    [sym_next] = ACTIONS(475),
    [sym_break] = ACTIONS(475),
    [sym_true] = ACTIONS(475),
    [sym_false] = ACTIONS(475),
    [sym_null] = ACTIONS(475),
    [sym_inf] = ACTIONS(475),
    [sym_nan] = ACTIONS(475),
    [anon_sym_NA] = ACTIONS(89),
    [anon_sym_NA_integer_] = ACTIONS(89),
    [anon_sym_NA_real_] = ACTIONS(89),
    [anon_sym_NA_complex_] = ACTIONS(89),
    [anon_sym_NA_character_] = ACTIONS(89),
    [sym_dots] = ACTIONS(475),
    [sym_dot_dot_i] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(471),
    [sym__newline] = ACTIONS(471),
    [sym__semicolon] = ACTIONS(471),
    [sym__raw_string_literal] = ACTIONS(95),
    [sym__external_else] = ACTIONS(471),
    [sym__external_open_parenthesis] = ACTIONS(97),
    [sym__external_close_parenthesis] = ACTIONS(471),
    [sym__external_open_brace] = ACTIONS(99),
    [sym__external_close_brace] = ACTIONS(471),
    [sym__external_open_bracket] = ACTIONS(471),
    [sym__external_open_bracket2] = ACTIONS(471),
  },
  [33] = {
    [sym_function_definition] = STATE(599),
    [sym_if_statement] = STATE(599),
    [sym_for_statement] = STATE(599),
    [sym_while_statement] = STATE(599),
    [sym_repeat_statement] = STATE(599),
    [sym_braced_expression] = STATE(599),
    [sym_parenthesized_expression] = STATE(599),
    [sym_call] = STATE(599),
    [sym_subset] = STATE(599),
    [sym_subset2] = STATE(599),
    [sym_unary_operator] = STATE(599),
    [sym_binary_operator] = STATE(599),
    [sym_extract_operator] = STATE(599),
    [sym_namespace_operator] = STATE(599),
    [sym_integer] = STATE(599),
    [sym_complex] = STATE(599),
    [sym_float] = STATE(599),
    [sym__hex_literal] = STATE(1984),
    [sym__float_literal] = STATE(1984),
    [sym_string] = STATE(1982),
    [sym__single_quoted_string] = STATE(1985),
    [sym__double_quoted_string] = STATE(1990),
    [sym_na] = STATE(599),
    [sym__expression] = STATE(599),
    [sym__string_or_identifier] = STATE(5151),
    [sym__open_parenthesis] = STATE(19),
    [sym__open_brace] = STATE(4),
    [sym__close_brace] = STATE(2787),
    [aux_sym_braced_expression_repeat1] = STATE(66),
    [sym_identifier] = ACTIONS(53),
    [anon_sym_BSLASH] = ACTIONS(55),
    [anon_sym_function] = ACTIONS(57),
    [anon_sym_EQ] = ACTIONS(59),
    [anon_sym_if] = ACTIONS(61),
    [anon_sym_for] = ACTIONS(63),
    [anon_sym_while] = ACTIONS(65),
    [anon_sym_repeat] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_LT_DASH] = ACTIONS(51),
    [anon_sym_LT_LT_DASH] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(51),
    [anon_sym_DASH_GT] = ACTIONS(59),
    [anon_sym_DASH_GT_GT] = ACTIONS(51),
    [anon_sym_PIPE] = ACTIONS(59),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_AMP_AMP] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(59),
    [anon_sym_LT_EQ] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(59),
    [anon_sym_GT_EQ] = ACTIONS(51),
    [anon_sym_EQ_EQ] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(51),
    [anon_sym_CARET] = ACTIONS(51),
    [aux_sym_binary_operator_token1] = ACTIONS(51),
    [anon_sym_PIPE_GT] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(59),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_AT] = ACTIONS(51),
    [aux_sym__hex_literal_token1] = ACTIONS(79),
    [sym__number_literal] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_return] = ACTIONS(87),
    [sym_next] = ACTIONS(87),
    [sym_break] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_inf] = ACTIONS(87),
    [sym_nan] = ACTIONS(87),
    [anon_sym_NA] = ACTIONS(89),
    [anon_sym_NA_integer_] = ACTIONS(89),
    [anon_sym_NA_real_] = ACTIONS(89),
    [anon_sym_NA_complex_] = ACTIONS(89),
    [anon_sym_NA_character_] = ACTIONS(89),
    [sym_dots] = ACTIONS(87),
    [sym_dot_dot_i] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(51),
    [sym__newline] = ACTIONS(93),
    [sym__semicolon] = ACTIONS(93),
    [sym__raw_string_literal] = ACTIONS(95),
    [sym__external_else] = ACTIONS(51),
    [sym__external_open_parenthesis] = ACTIONS(97),
    [sym__external_close_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(99),
    [sym__external_close_brace] = ACTIONS(479),
    [sym__external_open_bracket] = ACTIONS(51),
    [sym__external_open_bracket2] = ACTIONS(51),
  },
  [34] = {
    [sym_function_definition] = STATE(796),
    [sym_if_statement] = STATE(796),
    [sym_for_statement] = STATE(796),
    [sym_while_statement] = STATE(796),
    [sym_repeat_statement] = STATE(796),
    [sym_braced_expression] = STATE(796),
    [sym_parenthesized_expression] = STATE(796),
    [sym_call] = STATE(796),
    [sym_subset] = STATE(796),
    [sym_subset2] = STATE(796),
    [sym_unary_operator] = STATE(796),
    [sym_binary_operator] = STATE(796),
    [sym_extract_operator] = STATE(796),
    [sym_namespace_operator] = STATE(796),
    [sym_integer] = STATE(796),
    [sym_complex] = STATE(796),
    [sym_float] = STATE(796),
    [sym__hex_literal] = STATE(2206),
    [sym__float_literal] = STATE(2206),
    [sym_string] = STATE(2166),
    [sym__single_quoted_string] = STATE(2200),
    [sym__double_quoted_string] = STATE(2201),
    [sym_na] = STATE(796),
    [sym__expression] = STATE(796),
    [sym__string_or_identifier] = STATE(5154),
    [sym__open_parenthesis] = STATE(3),
    [sym__open_brace] = STATE(45),
    [sym__close_brace] = STATE(2931),
    [aux_sym_braced_expression_repeat1] = STATE(195),
    [sym_identifier] = ACTIONS(481),
    [anon_sym_BSLASH] = ACTIONS(483),
    [anon_sym_function] = ACTIONS(485),
    [anon_sym_EQ] = ACTIONS(59),
    [anon_sym_if] = ACTIONS(487),
    [anon_sym_for] = ACTIONS(489),
    [anon_sym_while] = ACTIONS(491),
    [anon_sym_repeat] = ACTIONS(493),
    [anon_sym_QMARK] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(503),
    [anon_sym_LT_DASH] = ACTIONS(51),
    [anon_sym_LT_LT_DASH] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(51),
    [anon_sym_DASH_GT] = ACTIONS(59),
    [anon_sym_DASH_GT_GT] = ACTIONS(51),
    [anon_sym_PIPE] = ACTIONS(59),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_AMP_AMP] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(59),
    [anon_sym_LT_EQ] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(59),
    [anon_sym_GT_EQ] = ACTIONS(51),
    [anon_sym_EQ_EQ] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(51),
    [anon_sym_CARET] = ACTIONS(51),
    [aux_sym_binary_operator_token1] = ACTIONS(51),
    [anon_sym_PIPE_GT] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(59),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_AT] = ACTIONS(51),
    [aux_sym__hex_literal_token1] = ACTIONS(505),
    [sym__number_literal] = ACTIONS(507),
    [anon_sym_SQUOTE] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(511),
    [sym_return] = ACTIONS(513),
    [sym_next] = ACTIONS(513),
    [sym_break] = ACTIONS(513),
    [sym_true] = ACTIONS(513),
    [sym_false] = ACTIONS(513),
    [sym_null] = ACTIONS(513),
    [sym_inf] = ACTIONS(513),
    [sym_nan] = ACTIONS(513),
    [anon_sym_NA] = ACTIONS(515),
    [anon_sym_NA_integer_] = ACTIONS(515),
    [anon_sym_NA_real_] = ACTIONS(515),
    [anon_sym_NA_complex_] = ACTIONS(515),
    [anon_sym_NA_character_] = ACTIONS(515),
    [sym_dots] = ACTIONS(513),
    [sym_dot_dot_i] = ACTIONS(517),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(51),
    [sym__newline] = ACTIONS(519),
    [sym__semicolon] = ACTIONS(519),
    [sym__raw_string_literal] = ACTIONS(521),
    [sym__external_else] = ACTIONS(51),
    [sym__external_open_parenthesis] = ACTIONS(523),
    [sym__external_open_brace] = ACTIONS(525),
    [sym__external_close_brace] = ACTIONS(527),
    [sym__external_open_bracket] = ACTIONS(51),
    [sym__external_close_bracket] = ACTIONS(51),
    [sym__external_open_bracket2] = ACTIONS(51),
  },
  [35] = {
    [sym_function_definition] = STATE(789),
    [sym_if_statement] = STATE(789),
    [sym_for_statement] = STATE(789),
    [sym_while_statement] = STATE(789),
    [sym_repeat_statement] = STATE(789),
    [sym_braced_expression] = STATE(789),
    [sym_parenthesized_expression] = STATE(789),
    [sym_call] = STATE(789),
    [sym_subset] = STATE(789),
    [sym_subset2] = STATE(789),
    [sym_unary_operator] = STATE(789),
    [sym_binary_operator] = STATE(789),
    [sym_extract_operator] = STATE(789),
    [sym_namespace_operator] = STATE(789),
    [sym_integer] = STATE(789),
    [sym_complex] = STATE(789),
    [sym_float] = STATE(789),
    [sym__hex_literal] = STATE(2210),
    [sym__float_literal] = STATE(2210),
    [sym_string] = STATE(2209),
    [sym__single_quoted_string] = STATE(2211),
    [sym__double_quoted_string] = STATE(2212),
    [sym_na] = STATE(789),
    [sym__expression] = STATE(789),
    [sym__string_or_identifier] = STATE(5127),
    [sym__open_parenthesis] = STATE(5),
    [sym__open_brace] = STATE(42),
    [sym__close_brace] = STATE(2809),
    [aux_sym_braced_expression_repeat1] = STATE(159),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_BSLASH] = ACTIONS(407),
    [anon_sym_function] = ACTIONS(409),
    [anon_sym_EQ] = ACTIONS(59),
    [anon_sym_if] = ACTIONS(411),
    [anon_sym_for] = ACTIONS(413),
    [anon_sym_while] = ACTIONS(415),
    [anon_sym_repeat] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_TILDE] = ACTIONS(421),
    [anon_sym_BANG] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(427),
    [anon_sym_LT_DASH] = ACTIONS(51),
    [anon_sym_LT_LT_DASH] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(51),
    [anon_sym_DASH_GT] = ACTIONS(59),
    [anon_sym_DASH_GT_GT] = ACTIONS(51),
    [anon_sym_PIPE] = ACTIONS(59),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_AMP_AMP] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(59),
    [anon_sym_LT_EQ] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(59),
    [anon_sym_GT_EQ] = ACTIONS(51),
    [anon_sym_EQ_EQ] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(51),
    [anon_sym_CARET] = ACTIONS(51),
    [aux_sym_binary_operator_token1] = ACTIONS(51),
    [anon_sym_PIPE_GT] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(59),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_AT] = ACTIONS(51),
    [aux_sym__hex_literal_token1] = ACTIONS(429),
    [sym__number_literal] = ACTIONS(431),
    [anon_sym_SQUOTE] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_return] = ACTIONS(437),
    [sym_next] = ACTIONS(437),
    [sym_break] = ACTIONS(437),
    [sym_true] = ACTIONS(437),
    [sym_false] = ACTIONS(437),
    [sym_null] = ACTIONS(437),
    [sym_inf] = ACTIONS(437),
    [sym_nan] = ACTIONS(437),
    [anon_sym_NA] = ACTIONS(439),
    [anon_sym_NA_integer_] = ACTIONS(439),
    [anon_sym_NA_real_] = ACTIONS(439),
    [anon_sym_NA_complex_] = ACTIONS(439),
    [anon_sym_NA_character_] = ACTIONS(439),
    [sym_dots] = ACTIONS(437),
    [sym_dot_dot_i] = ACTIONS(441),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(51),
    [sym__newline] = ACTIONS(443),
    [sym__semicolon] = ACTIONS(443),
    [sym__raw_string_literal] = ACTIONS(445),
    [sym__external_else] = ACTIONS(51),
    [sym__external_open_parenthesis] = ACTIONS(447),
    [sym__external_open_brace] = ACTIONS(449),
    [sym__external_close_brace] = ACTIONS(529),
    [sym__external_open_bracket] = ACTIONS(51),
    [sym__external_open_bracket2] = ACTIONS(51),
    [sym__external_close_bracket2] = ACTIONS(51),
  },
  [36] = {
    [sym_function_definition] = STATE(552),
    [sym_if_statement] = STATE(552),
    [sym_for_statement] = STATE(552),
    [sym_while_statement] = STATE(552),
    [sym_repeat_statement] = STATE(552),
    [sym_braced_expression] = STATE(552),
    [sym_parenthesized_expression] = STATE(552),
    [sym_call] = STATE(552),
    [sym_subset] = STATE(552),
    [sym_subset2] = STATE(552),
    [sym_unary_operator] = STATE(552),
    [sym_binary_operator] = STATE(552),
    [sym_extract_operator] = STATE(552),
    [sym_namespace_operator] = STATE(552),
    [sym_integer] = STATE(552),
    [sym_complex] = STATE(552),
    [sym_float] = STATE(552),
    [sym__hex_literal] = STATE(1984),
    [sym__float_literal] = STATE(1984),
    [sym_string] = STATE(1982),
    [sym__single_quoted_string] = STATE(1985),
    [sym__double_quoted_string] = STATE(1990),
    [sym_na] = STATE(552),
    [sym__expression] = STATE(552),
    [sym__string_or_identifier] = STATE(5151),
    [sym__open_parenthesis] = STATE(19),
    [sym__open_brace] = STATE(4),
    [aux_sym_function_definition_repeat1] = STATE(25),
    [ts_builtin_sym_end] = ACTIONS(531),
    [sym_identifier] = ACTIONS(53),
    [anon_sym_BSLASH] = ACTIONS(55),
    [anon_sym_function] = ACTIONS(57),
    [anon_sym_EQ] = ACTIONS(533),
    [anon_sym_if] = ACTIONS(61),
    [anon_sym_for] = ACTIONS(63),
    [anon_sym_while] = ACTIONS(65),
    [anon_sym_repeat] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_LT_DASH] = ACTIONS(531),
    [anon_sym_LT_LT_DASH] = ACTIONS(531),
    [anon_sym_COLON_EQ] = ACTIONS(531),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_DASH_GT_GT] = ACTIONS(531),
    [anon_sym_PIPE] = ACTIONS(533),
    [anon_sym_AMP] = ACTIONS(533),
    [anon_sym_PIPE_PIPE] = ACTIONS(531),
    [anon_sym_AMP_AMP] = ACTIONS(531),
    [anon_sym_LT] = ACTIONS(533),
    [anon_sym_LT_EQ] = ACTIONS(531),
    [anon_sym_GT] = ACTIONS(533),
    [anon_sym_GT_EQ] = ACTIONS(531),
    [anon_sym_EQ_EQ] = ACTIONS(531),
    [anon_sym_BANG_EQ] = ACTIONS(531),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_SLASH] = ACTIONS(531),
    [anon_sym_STAR_STAR] = ACTIONS(531),
    [anon_sym_CARET] = ACTIONS(531),
    [aux_sym_binary_operator_token1] = ACTIONS(531),
    [anon_sym_PIPE_GT] = ACTIONS(531),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_DOLLAR] = ACTIONS(531),
    [anon_sym_AT] = ACTIONS(531),
    [aux_sym__hex_literal_token1] = ACTIONS(79),
    [sym__number_literal] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_return] = ACTIONS(535),
    [sym_next] = ACTIONS(535),
    [sym_break] = ACTIONS(535),
    [sym_true] = ACTIONS(535),
    [sym_false] = ACTIONS(535),
    [sym_null] = ACTIONS(535),
    [sym_inf] = ACTIONS(535),
    [sym_nan] = ACTIONS(535),
    [anon_sym_NA] = ACTIONS(89),
    [anon_sym_NA_integer_] = ACTIONS(89),
    [anon_sym_NA_real_] = ACTIONS(89),
    [anon_sym_NA_complex_] = ACTIONS(89),
    [anon_sym_NA_character_] = ACTIONS(89),
    [sym_dots] = ACTIONS(535),
    [sym_dot_dot_i] = ACTIONS(537),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(531),
    [sym__newline] = ACTIONS(539),
    [sym__semicolon] = ACTIONS(531),
    [sym__raw_string_literal] = ACTIONS(95),
    [sym__external_else] = ACTIONS(531),
    [sym__external_open_parenthesis] = ACTIONS(97),
    [sym__external_close_parenthesis] = ACTIONS(531),
    [sym__external_open_brace] = ACTIONS(99),
    [sym__external_close_brace] = ACTIONS(531),
    [sym__external_open_bracket] = ACTIONS(531),
    [sym__external_open_bracket2] = ACTIONS(531),
  },
  [37] = {
    [sym_function_definition] = STATE(575),
    [sym_if_statement] = STATE(575),
    [sym_for_statement] = STATE(575),
    [sym_while_statement] = STATE(575),
    [sym_repeat_statement] = STATE(575),
    [sym_braced_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(575),
    [sym_call] = STATE(575),
    [sym_subset] = STATE(575),
    [sym_subset2] = STATE(575),
    [sym_unary_operator] = STATE(575),
    [sym_binary_operator] = STATE(575),
    [sym_extract_operator] = STATE(575),
    [sym_namespace_operator] = STATE(575),
    [sym_integer] = STATE(575),
    [sym_complex] = STATE(575),
    [sym_float] = STATE(575),
    [sym__hex_literal] = STATE(1984),
    [sym__float_literal] = STATE(1984),
    [sym_string] = STATE(1982),
    [sym__single_quoted_string] = STATE(1985),
    [sym__double_quoted_string] = STATE(1990),
    [sym_na] = STATE(575),
    [sym__expression] = STATE(575),
    [sym__string_or_identifier] = STATE(5151),
    [sym__open_parenthesis] = STATE(19),
    [sym__close_parenthesis] = STATE(2590),
    [sym__open_brace] = STATE(4),
    [aux_sym_parenthesized_expression_repeat1] = STATE(58),
    [ts_builtin_sym_end] = ACTIONS(211),
    [sym_identifier] = ACTIONS(53),
    [anon_sym_BSLASH] = ACTIONS(55),
    [anon_sym_function] = ACTIONS(57),
    [anon_sym_EQ] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(61),
    [anon_sym_for] = ACTIONS(63),
    [anon_sym_while] = ACTIONS(65),
    [anon_sym_repeat] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_LT_DASH] = ACTIONS(211),
    [anon_sym_LT_LT_DASH] = ACTIONS(211),
    [anon_sym_COLON_EQ] = ACTIONS(211),
    [anon_sym_DASH_GT] = ACTIONS(209),
    [anon_sym_DASH_GT_GT] = ACTIONS(211),
    [anon_sym_PIPE] = ACTIONS(209),
    [anon_sym_AMP] = ACTIONS(209),
    [anon_sym_PIPE_PIPE] = ACTIONS(211),
    [anon_sym_AMP_AMP] = ACTIONS(211),
    [anon_sym_LT] = ACTIONS(209),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_GT] = ACTIONS(209),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [anon_sym_EQ_EQ] = ACTIONS(211),
    [anon_sym_BANG_EQ] = ACTIONS(211),
    [anon_sym_STAR] = ACTIONS(209),
    [anon_sym_SLASH] = ACTIONS(211),
    [anon_sym_STAR_STAR] = ACTIONS(211),
    [anon_sym_CARET] = ACTIONS(211),
    [aux_sym_binary_operator_token1] = ACTIONS(211),
    [anon_sym_PIPE_GT] = ACTIONS(211),
    [anon_sym_COLON] = ACTIONS(209),
    [anon_sym_DOLLAR] = ACTIONS(211),
    [anon_sym_AT] = ACTIONS(211),
    [aux_sym__hex_literal_token1] = ACTIONS(79),
    [sym__number_literal] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_return] = ACTIONS(251),
    [sym_next] = ACTIONS(251),
    [sym_break] = ACTIONS(251),
    [sym_true] = ACTIONS(251),
    [sym_false] = ACTIONS(251),
    [sym_null] = ACTIONS(251),
    [sym_inf] = ACTIONS(251),
    [sym_nan] = ACTIONS(251),
    [anon_sym_NA] = ACTIONS(89),
    [anon_sym_NA_integer_] = ACTIONS(89),
    [anon_sym_NA_real_] = ACTIONS(89),
    [anon_sym_NA_complex_] = ACTIONS(89),
    [anon_sym_NA_character_] = ACTIONS(89),
    [sym_dots] = ACTIONS(251),
    [sym_dot_dot_i] = ACTIONS(253),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(255),
    [sym__semicolon] = ACTIONS(211),
    [sym__raw_string_literal] = ACTIONS(95),
    [sym__external_else] = ACTIONS(211),
    [sym__external_open_parenthesis] = ACTIONS(97),
    [sym__external_close_parenthesis] = ACTIONS(541),
    [sym__external_open_brace] = ACTIONS(99),
    [sym__external_close_brace] = ACTIONS(211),
    [sym__external_open_bracket] = ACTIONS(211),
    [sym__external_open_bracket2] = ACTIONS(211),
  },
  [38] = {
    [sym_function_definition] = STATE(569),
    [sym_if_statement] = STATE(569),
    [sym_for_statement] = STATE(569),
    [sym_while_statement] = STATE(569),
    [sym_repeat_statement] = STATE(569),
    [sym_braced_expression] = STATE(569),
    [sym_parenthesized_expression] = STATE(569),
    [sym_call] = STATE(569),
    [sym_subset] = STATE(569),
    [sym_subset2] = STATE(569),
    [sym_unary_operator] = STATE(569),
    [sym_binary_operator] = STATE(569),
    [sym_extract_operator] = STATE(569),
    [sym_namespace_operator] = STATE(569),
    [sym_integer] = STATE(569),
    [sym_complex] = STATE(569),
    [sym_float] = STATE(569),
    [sym__hex_literal] = STATE(2021),
    [sym__float_literal] = STATE(2021),
    [sym_string] = STATE(2016),
    [sym__single_quoted_string] = STATE(2027),
    [sym__double_quoted_string] = STATE(2041),
    [sym_na] = STATE(569),
    [sym__expression] = STATE(569),
    [sym__string_or_identifier] = STATE(5131),
    [sym__open_parenthesis] = STATE(20),
    [sym__open_brace] = STATE(10),
    [aux_sym_function_definition_repeat1] = STATE(60),
    [sym_identifier] = ACTIONS(103),
    [anon_sym_BSLASH] = ACTIONS(105),
    [anon_sym_function] = ACTIONS(107),
    [anon_sym_EQ] = ACTIONS(543),
    [anon_sym_if] = ACTIONS(111),
    [anon_sym_for] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_repeat] = ACTIONS(117),
    [anon_sym_QMARK] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_BANG] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(125),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_LT_DASH] = ACTIONS(545),
    [anon_sym_LT_LT_DASH] = ACTIONS(545),
    [anon_sym_COLON_EQ] = ACTIONS(545),
    [anon_sym_DASH_GT] = ACTIONS(543),
    [anon_sym_DASH_GT_GT] = ACTIONS(545),
    [anon_sym_PIPE] = ACTIONS(543),
    [anon_sym_AMP] = ACTIONS(543),
    [anon_sym_PIPE_PIPE] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(543),
    [anon_sym_LT_EQ] = ACTIONS(545),
    [anon_sym_GT] = ACTIONS(543),
    [anon_sym_GT_EQ] = ACTIONS(545),
    [anon_sym_EQ_EQ] = ACTIONS(545),
    [anon_sym_BANG_EQ] = ACTIONS(545),
    [anon_sym_STAR] = ACTIONS(543),
    [anon_sym_SLASH] = ACTIONS(545),
    [anon_sym_STAR_STAR] = ACTIONS(545),
    [anon_sym_CARET] = ACTIONS(545),
    [aux_sym_binary_operator_token1] = ACTIONS(545),
    [anon_sym_PIPE_GT] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(543),
    [anon_sym_DOLLAR] = ACTIONS(545),
    [anon_sym_AT] = ACTIONS(545),
    [aux_sym__hex_literal_token1] = ACTIONS(131),
    [sym__number_literal] = ACTIONS(133),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(137),
    [sym_return] = ACTIONS(547),
    [sym_next] = ACTIONS(547),
    [sym_break] = ACTIONS(547),
    [sym_true] = ACTIONS(547),
    [sym_false] = ACTIONS(547),
    [sym_null] = ACTIONS(547),
    [sym_inf] = ACTIONS(547),
    [sym_nan] = ACTIONS(547),
    [anon_sym_NA] = ACTIONS(141),
    [anon_sym_NA_integer_] = ACTIONS(141),
    [anon_sym_NA_real_] = ACTIONS(141),
    [anon_sym_NA_complex_] = ACTIONS(141),
    [anon_sym_NA_character_] = ACTIONS(141),
    [sym_dots] = ACTIONS(547),
    [sym_dot_dot_i] = ACTIONS(549),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(545),
    [sym__newline] = ACTIONS(551),
    [sym__semicolon] = ACTIONS(545),
    [sym__raw_string_literal] = ACTIONS(147),
    [sym__external_else] = ACTIONS(545),
    [sym__external_open_parenthesis] = ACTIONS(149),
    [sym__external_close_parenthesis] = ACTIONS(545),
    [sym__external_open_brace] = ACTIONS(153),
    [sym__external_close_brace] = ACTIONS(545),
    [sym__external_open_bracket] = ACTIONS(545),
    [sym__external_close_bracket] = ACTIONS(545),
    [sym__external_open_bracket2] = ACTIONS(545),
  },
  [39] = {
    [sym_function_definition] = STATE(507),
    [sym_if_statement] = STATE(507),
    [sym_for_statement] = STATE(507),
    [sym_while_statement] = STATE(507),
    [sym_repeat_statement] = STATE(507),
    [sym_braced_expression] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym_call] = STATE(507),
    [sym_subset] = STATE(507),
    [sym_subset2] = STATE(507),
    [sym_unary_operator] = STATE(507),
    [sym_binary_operator] = STATE(507),
    [sym_extract_operator] = STATE(507),
    [sym_namespace_operator] = STATE(507),
    [sym_integer] = STATE(507),
    [sym_complex] = STATE(507),
    [sym_float] = STATE(507),
    [sym__hex_literal] = STATE(1925),
    [sym__float_literal] = STATE(1925),
    [sym_string] = STATE(1927),
    [sym__single_quoted_string] = STATE(1923),
    [sym__double_quoted_string] = STATE(1934),
    [sym_na] = STATE(507),
    [sym__expression] = STATE(507),
    [sym__string_or_identifier] = STATE(5137),
    [sym__open_parenthesis] = STATE(14),
    [sym__open_brace] = STATE(18),
    [aux_sym_braced_expression_repeat1] = STATE(39),
    [sym_identifier] = ACTIONS(553),
    [anon_sym_BSLASH] = ACTIONS(556),
    [anon_sym_function] = ACTIONS(559),
    [anon_sym_EQ] = ACTIONS(562),
    [anon_sym_if] = ACTIONS(564),
    [anon_sym_for] = ACTIONS(567),
    [anon_sym_while] = ACTIONS(570),
    [anon_sym_repeat] = ACTIONS(573),
    [anon_sym_QMARK] = ACTIONS(576),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(588),
    [anon_sym_LT_DASH] = ACTIONS(591),
    [anon_sym_LT_LT_DASH] = ACTIONS(591),
    [anon_sym_COLON_EQ] = ACTIONS(591),
    [anon_sym_DASH_GT] = ACTIONS(562),
    [anon_sym_DASH_GT_GT] = ACTIONS(591),
    [anon_sym_PIPE] = ACTIONS(562),
    [anon_sym_AMP] = ACTIONS(562),
    [anon_sym_PIPE_PIPE] = ACTIONS(591),
    [anon_sym_AMP_AMP] = ACTIONS(591),
    [anon_sym_LT] = ACTIONS(562),
    [anon_sym_LT_EQ] = ACTIONS(591),
    [anon_sym_GT] = ACTIONS(562),
    [anon_sym_GT_EQ] = ACTIONS(591),
    [anon_sym_EQ_EQ] = ACTIONS(591),
    [anon_sym_BANG_EQ] = ACTIONS(591),
    [anon_sym_STAR] = ACTIONS(562),
    [anon_sym_SLASH] = ACTIONS(591),
    [anon_sym_STAR_STAR] = ACTIONS(591),
    [anon_sym_CARET] = ACTIONS(591),
    [aux_sym_binary_operator_token1] = ACTIONS(591),
    [anon_sym_PIPE_GT] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(562),
    [anon_sym_DOLLAR] = ACTIONS(591),
    [anon_sym_AT] = ACTIONS(591),
    [aux_sym__hex_literal_token1] = ACTIONS(593),
    [sym__number_literal] = ACTIONS(596),
    [anon_sym_SQUOTE] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(602),
    [sym_return] = ACTIONS(605),
    [sym_next] = ACTIONS(605),
    [sym_break] = ACTIONS(605),
    [sym_true] = ACTIONS(605),
    [sym_false] = ACTIONS(605),
    [sym_null] = ACTIONS(605),
    [sym_inf] = ACTIONS(605),
    [sym_nan] = ACTIONS(605),
    [anon_sym_NA] = ACTIONS(608),
    [anon_sym_NA_integer_] = ACTIONS(608),
    [anon_sym_NA_real_] = ACTIONS(608),
    [anon_sym_NA_complex_] = ACTIONS(608),
    [anon_sym_NA_character_] = ACTIONS(608),
    [sym_dots] = ACTIONS(605),
    [sym_dot_dot_i] = ACTIONS(611),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(591),
    [sym__newline] = ACTIONS(614),
    [sym__semicolon] = ACTIONS(614),
    [sym__raw_string_literal] = ACTIONS(617),
    [sym__external_else] = ACTIONS(591),
    [sym__external_open_parenthesis] = ACTIONS(620),
    [sym__external_close_parenthesis] = ACTIONS(591),
    [sym__external_open_brace] = ACTIONS(623),
    [sym__external_close_brace] = ACTIONS(591),
    [sym__external_open_bracket] = ACTIONS(591),
    [sym__external_open_bracket2] = ACTIONS(591),
    [sym__external_close_bracket2] = ACTIONS(591),
  },
  [40] = {
    [sym_function_definition] = STATE(921),
    [sym_if_statement] = STATE(921),
    [sym_for_statement] = STATE(921),
    [sym_while_statement] = STATE(921),
    [sym_repeat_statement] = STATE(921),
    [sym_braced_expression] = STATE(921),
    [sym_parenthesized_expression] = STATE(921),
    [sym_call] = STATE(921),
    [sym_subset] = STATE(921),
    [sym_subset2] = STATE(921),
    [sym_unary_operator] = STATE(921),
    [sym_binary_operator] = STATE(921),
    [sym_extract_operator] = STATE(921),
    [sym_namespace_operator] = STATE(921),
    [sym_integer] = STATE(921),
    [sym_complex] = STATE(921),
    [sym_float] = STATE(921),
    [sym__hex_literal] = STATE(2220),
    [sym__float_literal] = STATE(2220),
    [sym_string] = STATE(2219),
    [sym__single_quoted_string] = STATE(2221),
    [sym__double_quoted_string] = STATE(2222),
    [sym_na] = STATE(921),
    [sym__expression] = STATE(921),
    [sym__string_or_identifier] = STATE(5140),
    [sym__open_parenthesis] = STATE(54),
    [sym__open_brace] = STATE(56),
    [sym__close_brace] = STATE(2785),
    [aux_sym_braced_expression_repeat1] = STATE(124),
    [sym_identifier] = ACTIONS(626),
    [anon_sym_BSLASH] = ACTIONS(628),
    [anon_sym_function] = ACTIONS(630),
    [anon_sym_EQ] = ACTIONS(59),
    [anon_sym_if] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [anon_sym_repeat] = ACTIONS(638),
    [anon_sym_QMARK] = ACTIONS(640),
    [anon_sym_TILDE] = ACTIONS(642),
    [anon_sym_BANG] = ACTIONS(644),
    [anon_sym_PLUS] = ACTIONS(646),
    [anon_sym_DASH] = ACTIONS(648),
    [anon_sym_LT_DASH] = ACTIONS(51),
    [anon_sym_LT_LT_DASH] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(51),
    [anon_sym_DASH_GT] = ACTIONS(59),
    [anon_sym_DASH_GT_GT] = ACTIONS(51),
    [anon_sym_PIPE] = ACTIONS(59),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_AMP_AMP] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(59),
    [anon_sym_LT_EQ] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(59),
    [anon_sym_GT_EQ] = ACTIONS(51),
    [anon_sym_EQ_EQ] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(51),
    [anon_sym_CARET] = ACTIONS(51),
    [aux_sym_binary_operator_token1] = ACTIONS(51),
    [anon_sym_PIPE_GT] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(59),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_AT] = ACTIONS(51),
    [aux_sym__hex_literal_token1] = ACTIONS(650),
    [sym__number_literal] = ACTIONS(652),
    [anon_sym_SQUOTE] = ACTIONS(654),
    [anon_sym_DQUOTE] = ACTIONS(656),
    [sym_return] = ACTIONS(658),
    [sym_next] = ACTIONS(658),
    [sym_break] = ACTIONS(658),
    [sym_true] = ACTIONS(658),
    [sym_false] = ACTIONS(658),
    [sym_null] = ACTIONS(658),
    [sym_inf] = ACTIONS(658),
    [sym_nan] = ACTIONS(658),
    [anon_sym_NA] = ACTIONS(660),
    [anon_sym_NA_integer_] = ACTIONS(660),
    [anon_sym_NA_real_] = ACTIONS(660),
    [anon_sym_NA_complex_] = ACTIONS(660),
    [anon_sym_NA_character_] = ACTIONS(660),
    [sym_dots] = ACTIONS(658),
    [sym_dot_dot_i] = ACTIONS(662),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(51),
    [sym__newline] = ACTIONS(664),
    [sym__semicolon] = ACTIONS(664),
    [sym__raw_string_literal] = ACTIONS(666),
    [sym__external_open_parenthesis] = ACTIONS(668),
    [sym__external_close_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(670),
    [sym__external_close_brace] = ACTIONS(672),
    [sym__external_open_bracket] = ACTIONS(51),
    [sym__external_open_bracket2] = ACTIONS(51),
    [sym__external_close_bracket2] = ACTIONS(51),
  },
  [41] = {
    [sym_function_definition] = STATE(796),
    [sym_if_statement] = STATE(796),
    [sym_for_statement] = STATE(796),
    [sym_while_statement] = STATE(796),
    [sym_repeat_statement] = STATE(796),
    [sym_braced_expression] = STATE(796),
    [sym_parenthesized_expression] = STATE(796),
    [sym_call] = STATE(796),
    [sym_subset] = STATE(796),
    [sym_subset2] = STATE(796),
    [sym_unary_operator] = STATE(796),
    [sym_binary_operator] = STATE(796),
    [sym_extract_operator] = STATE(796),
    [sym_namespace_operator] = STATE(796),
    [sym_integer] = STATE(796),
    [sym_complex] = STATE(796),
    [sym_float] = STATE(796),
    [sym__hex_literal] = STATE(2206),
    [sym__float_literal] = STATE(2206),
    [sym_string] = STATE(2166),
    [sym__single_quoted_string] = STATE(2200),
    [sym__double_quoted_string] = STATE(2201),
    [sym_na] = STATE(796),
    [sym__expression] = STATE(796),
    [sym__string_or_identifier] = STATE(5154),
    [sym__open_parenthesis] = STATE(3),
    [sym__open_brace] = STATE(45),
    [sym__close_brace] = STATE(2458),
    [aux_sym_braced_expression_repeat1] = STATE(195),
    [sym_identifier] = ACTIONS(481),
    [anon_sym_BSLASH] = ACTIONS(483),
    [anon_sym_function] = ACTIONS(485),
    [anon_sym_EQ] = ACTIONS(59),
    [anon_sym_if] = ACTIONS(487),
    [anon_sym_for] = ACTIONS(489),
    [anon_sym_while] = ACTIONS(491),
    [anon_sym_repeat] = ACTIONS(493),
    [anon_sym_QMARK] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(503),
    [anon_sym_LT_DASH] = ACTIONS(51),
    [anon_sym_LT_LT_DASH] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(51),
    [anon_sym_DASH_GT] = ACTIONS(59),
    [anon_sym_DASH_GT_GT] = ACTIONS(51),
    [anon_sym_PIPE] = ACTIONS(59),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_AMP_AMP] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(59),
    [anon_sym_LT_EQ] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(59),
    [anon_sym_GT_EQ] = ACTIONS(51),
    [anon_sym_EQ_EQ] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(51),
    [anon_sym_CARET] = ACTIONS(51),
    [aux_sym_binary_operator_token1] = ACTIONS(51),
    [anon_sym_PIPE_GT] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(59),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_AT] = ACTIONS(51),
    [aux_sym__hex_literal_token1] = ACTIONS(505),
    [sym__number_literal] = ACTIONS(507),
    [anon_sym_SQUOTE] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(511),
    [sym_return] = ACTIONS(513),
    [sym_next] = ACTIONS(513),
    [sym_break] = ACTIONS(513),
    [sym_true] = ACTIONS(513),
    [sym_false] = ACTIONS(513),
    [sym_null] = ACTIONS(513),
    [sym_inf] = ACTIONS(513),
    [sym_nan] = ACTIONS(513),
    [anon_sym_NA] = ACTIONS(515),
    [anon_sym_NA_integer_] = ACTIONS(515),
    [anon_sym_NA_real_] = ACTIONS(515),
    [anon_sym_NA_complex_] = ACTIONS(515),
    [anon_sym_NA_character_] = ACTIONS(515),
    [sym_dots] = ACTIONS(513),
    [sym_dot_dot_i] = ACTIONS(517),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(51),
    [sym__newline] = ACTIONS(519),
    [sym__semicolon] = ACTIONS(519),
    [sym__raw_string_literal] = ACTIONS(521),
    [sym__external_else] = ACTIONS(51),
    [sym__external_open_parenthesis] = ACTIONS(523),
    [sym__external_open_brace] = ACTIONS(525),
    [sym__external_close_brace] = ACTIONS(674),
    [sym__external_open_bracket] = ACTIONS(51),
    [sym__external_close_bracket] = ACTIONS(51),
    [sym__external_open_bracket2] = ACTIONS(51),
  },
  [42] = {
    [sym_function_definition] = STATE(789),
    [sym_if_statement] = STATE(789),
    [sym_for_statement] = STATE(789),
    [sym_while_statement] = STATE(789),
    [sym_repeat_statement] = STATE(789),
    [sym_braced_expression] = STATE(789),
    [sym_parenthesized_expression] = STATE(789),
    [sym_call] = STATE(789),
    [sym_subset] = STATE(789),
    [sym_subset2] = STATE(789),
    [sym_unary_operator] = STATE(789),
    [sym_binary_operator] = STATE(789),
    [sym_extract_operator] = STATE(789),
    [sym_namespace_operator] = STATE(789),
    [sym_integer] = STATE(789),
    [sym_complex] = STATE(789),
    [sym_float] = STATE(789),
    [sym__hex_literal] = STATE(2210),
    [sym__float_literal] = STATE(2210),
    [sym_string] = STATE(2209),
    [sym__single_quoted_string] = STATE(2211),
    [sym__double_quoted_string] = STATE(2212),
    [sym_na] = STATE(789),
    [sym__expression] = STATE(789),
    [sym__string_or_identifier] = STATE(5127),
    [sym__open_parenthesis] = STATE(5),
    [sym__open_brace] = STATE(42),
    [sym__close_brace] = STATE(2550),
    [aux_sym_braced_expression_repeat1] = STATE(48),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_BSLASH] = ACTIONS(407),
    [anon_sym_function] = ACTIONS(409),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(411),
    [anon_sym_for] = ACTIONS(413),
    [anon_sym_while] = ACTIONS(415),
    [anon_sym_repeat] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_TILDE] = ACTIONS(421),
    [anon_sym_BANG] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(427),
    [anon_sym_LT_DASH] = ACTIONS(155),
    [anon_sym_LT_LT_DASH] = ACTIONS(155),
    [anon_sym_COLON_EQ] = ACTIONS(155),
    [anon_sym_DASH_GT] = ACTIONS(157),
    [anon_sym_DASH_GT_GT] = ACTIONS(155),
    [anon_sym_PIPE] = ACTIONS(157),
    [anon_sym_AMP] = ACTIONS(157),
    [anon_sym_PIPE_PIPE] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(157),
    [anon_sym_LT_EQ] = ACTIONS(155),
    [anon_sym_GT] = ACTIONS(157),
    [anon_sym_GT_EQ] = ACTIONS(155),
    [anon_sym_EQ_EQ] = ACTIONS(155),
    [anon_sym_BANG_EQ] = ACTIONS(155),
    [anon_sym_STAR] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(155),
    [anon_sym_STAR_STAR] = ACTIONS(155),
    [anon_sym_CARET] = ACTIONS(155),
    [aux_sym_binary_operator_token1] = ACTIONS(155),
    [anon_sym_PIPE_GT] = ACTIONS(155),
    [anon_sym_COLON] = ACTIONS(157),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(155),
    [aux_sym__hex_literal_token1] = ACTIONS(429),
    [sym__number_literal] = ACTIONS(431),
    [anon_sym_SQUOTE] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_return] = ACTIONS(437),
    [sym_next] = ACTIONS(437),
    [sym_break] = ACTIONS(437),
    [sym_true] = ACTIONS(437),
    [sym_false] = ACTIONS(437),
    [sym_null] = ACTIONS(437),
    [sym_inf] = ACTIONS(437),
    [sym_nan] = ACTIONS(437),
    [anon_sym_NA] = ACTIONS(439),
    [anon_sym_NA_integer_] = ACTIONS(439),
    [anon_sym_NA_real_] = ACTIONS(439),
    [anon_sym_NA_complex_] = ACTIONS(439),
    [anon_sym_NA_character_] = ACTIONS(439),
    [sym_dots] = ACTIONS(437),
    [sym_dot_dot_i] = ACTIONS(441),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(155),
    [sym__newline] = ACTIONS(443),
    [sym__semicolon] = ACTIONS(443),
    [sym__raw_string_literal] = ACTIONS(445),
    [sym__external_else] = ACTIONS(155),
    [sym__external_open_parenthesis] = ACTIONS(447),
    [sym__external_open_brace] = ACTIONS(449),
    [sym__external_close_brace] = ACTIONS(676),
    [sym__external_open_bracket] = ACTIONS(155),
    [sym__external_open_bracket2] = ACTIONS(155),
    [sym__external_close_bracket2] = ACTIONS(155),
  },
  [43] = {
    [sym_function_definition] = STATE(522),
    [sym_if_statement] = STATE(522),
    [sym_for_statement] = STATE(522),
    [sym_while_statement] = STATE(522),
    [sym_repeat_statement] = STATE(522),
    [sym_braced_expression] = STATE(522),
    [sym_parenthesized_expression] = STATE(522),
    [sym_call] = STATE(522),
    [sym_subset] = STATE(522),
    [sym_subset2] = STATE(522),
    [sym_unary_operator] = STATE(522),
    [sym_binary_operator] = STATE(522),
    [sym_extract_operator] = STATE(522),
    [sym_namespace_operator] = STATE(522),
    [sym_integer] = STATE(522),
    [sym_complex] = STATE(522),
    [sym_float] = STATE(522),
    [sym__hex_literal] = STATE(2021),
    [sym__float_literal] = STATE(2021),
    [sym_string] = STATE(2016),
    [sym__single_quoted_string] = STATE(2027),
    [sym__double_quoted_string] = STATE(2041),
    [sym_na] = STATE(522),
    [sym__expression] = STATE(522),
    [sym__string_or_identifier] = STATE(5131),
    [sym__open_parenthesis] = STATE(20),
    [sym__open_brace] = STATE(10),
    [aux_sym_braced_expression_repeat1] = STATE(43),
    [sym_identifier] = ACTIONS(678),
    [anon_sym_BSLASH] = ACTIONS(681),
    [anon_sym_function] = ACTIONS(684),
    [anon_sym_EQ] = ACTIONS(562),
    [anon_sym_if] = ACTIONS(687),
    [anon_sym_for] = ACTIONS(690),
    [anon_sym_while] = ACTIONS(693),
    [anon_sym_repeat] = ACTIONS(696),
    [anon_sym_QMARK] = ACTIONS(699),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_BANG] = ACTIONS(705),
    [anon_sym_PLUS] = ACTIONS(708),
    [anon_sym_DASH] = ACTIONS(711),
    [anon_sym_LT_DASH] = ACTIONS(591),
    [anon_sym_LT_LT_DASH] = ACTIONS(591),
    [anon_sym_COLON_EQ] = ACTIONS(591),
    [anon_sym_DASH_GT] = ACTIONS(562),
    [anon_sym_DASH_GT_GT] = ACTIONS(591),
    [anon_sym_PIPE] = ACTIONS(562),
    [anon_sym_AMP] = ACTIONS(562),
    [anon_sym_PIPE_PIPE] = ACTIONS(591),
    [anon_sym_AMP_AMP] = ACTIONS(591),
    [anon_sym_LT] = ACTIONS(562),
    [anon_sym_LT_EQ] = ACTIONS(591),
    [anon_sym_GT] = ACTIONS(562),
    [anon_sym_GT_EQ] = ACTIONS(591),
    [anon_sym_EQ_EQ] = ACTIONS(591),
    [anon_sym_BANG_EQ] = ACTIONS(591),
    [anon_sym_STAR] = ACTIONS(562),
    [anon_sym_SLASH] = ACTIONS(591),
    [anon_sym_STAR_STAR] = ACTIONS(591),
    [anon_sym_CARET] = ACTIONS(591),
    [aux_sym_binary_operator_token1] = ACTIONS(591),
    [anon_sym_PIPE_GT] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(562),
    [anon_sym_DOLLAR] = ACTIONS(591),
    [anon_sym_AT] = ACTIONS(591),
    [aux_sym__hex_literal_token1] = ACTIONS(714),
    [sym__number_literal] = ACTIONS(717),
    [anon_sym_SQUOTE] = ACTIONS(720),
    [anon_sym_DQUOTE] = ACTIONS(723),
    [sym_return] = ACTIONS(726),
    [sym_next] = ACTIONS(726),
    [sym_break] = ACTIONS(726),
    [sym_true] = ACTIONS(726),
    [sym_false] = ACTIONS(726),
    [sym_null] = ACTIONS(726),
    [sym_inf] = ACTIONS(726),
    [sym_nan] = ACTIONS(726),
    [anon_sym_NA] = ACTIONS(729),
    [anon_sym_NA_integer_] = ACTIONS(729),
    [anon_sym_NA_real_] = ACTIONS(729),
    [anon_sym_NA_complex_] = ACTIONS(729),
    [anon_sym_NA_character_] = ACTIONS(729),
    [sym_dots] = ACTIONS(726),
    [sym_dot_dot_i] = ACTIONS(732),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(591),
    [sym__newline] = ACTIONS(735),
    [sym__semicolon] = ACTIONS(735),
    [sym__raw_string_literal] = ACTIONS(738),
    [sym__external_else] = ACTIONS(591),
    [sym__external_open_parenthesis] = ACTIONS(741),
    [sym__external_close_parenthesis] = ACTIONS(591),
    [sym__external_open_brace] = ACTIONS(744),
    [sym__external_close_brace] = ACTIONS(591),
    [sym__external_open_bracket] = ACTIONS(591),
    [sym__external_close_bracket] = ACTIONS(591),
    [sym__external_open_bracket2] = ACTIONS(591),
  },
  [44] = {
    [sym_function_definition] = STATE(935),
    [sym_if_statement] = STATE(935),
    [sym_for_statement] = STATE(935),
    [sym_while_statement] = STATE(935),
    [sym_repeat_statement] = STATE(935),
    [sym_braced_expression] = STATE(935),
    [sym_parenthesized_expression] = STATE(935),
    [sym_call] = STATE(935),
    [sym_subset] = STATE(935),
    [sym_subset2] = STATE(935),
    [sym_unary_operator] = STATE(935),
    [sym_binary_operator] = STATE(935),
    [sym_extract_operator] = STATE(935),
    [sym_namespace_operator] = STATE(935),
    [sym_integer] = STATE(935),
    [sym_complex] = STATE(935),
    [sym_float] = STATE(935),
    [sym__hex_literal] = STATE(2220),
    [sym__float_literal] = STATE(2220),
    [sym_string] = STATE(2219),
    [sym__single_quoted_string] = STATE(2221),
    [sym__double_quoted_string] = STATE(2222),
    [sym_na] = STATE(935),
    [sym__expression] = STATE(935),
    [sym__string_or_identifier] = STATE(5140),
    [sym__open_parenthesis] = STATE(54),
    [sym__close_parenthesis] = STATE(2504),
    [sym__open_brace] = STATE(56),
    [aux_sym_parenthesized_expression_repeat1] = STATE(138),
    [sym_identifier] = ACTIONS(626),
    [anon_sym_BSLASH] = ACTIONS(628),
    [anon_sym_function] = ACTIONS(630),
    [anon_sym_EQ] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [anon_sym_repeat] = ACTIONS(638),
    [anon_sym_QMARK] = ACTIONS(640),
    [anon_sym_TILDE] = ACTIONS(642),
    [anon_sym_BANG] = ACTIONS(644),
    [anon_sym_PLUS] = ACTIONS(646),
    [anon_sym_DASH] = ACTIONS(648),
    [anon_sym_LT_DASH] = ACTIONS(211),
    [anon_sym_LT_LT_DASH] = ACTIONS(211),
    [anon_sym_COLON_EQ] = ACTIONS(211),
    [anon_sym_DASH_GT] = ACTIONS(209),
    [anon_sym_DASH_GT_GT] = ACTIONS(211),
    [anon_sym_PIPE] = ACTIONS(209),
    [anon_sym_AMP] = ACTIONS(209),
    [anon_sym_PIPE_PIPE] = ACTIONS(211),
    [anon_sym_AMP_AMP] = ACTIONS(211),
    [anon_sym_LT] = ACTIONS(209),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_GT] = ACTIONS(209),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [anon_sym_EQ_EQ] = ACTIONS(211),
    [anon_sym_BANG_EQ] = ACTIONS(211),
    [anon_sym_STAR] = ACTIONS(209),
    [anon_sym_SLASH] = ACTIONS(211),
    [anon_sym_STAR_STAR] = ACTIONS(211),
    [anon_sym_CARET] = ACTIONS(211),
    [aux_sym_binary_operator_token1] = ACTIONS(211),
    [anon_sym_PIPE_GT] = ACTIONS(211),
    [anon_sym_COLON] = ACTIONS(209),
    [anon_sym_DOLLAR] = ACTIONS(211),
    [anon_sym_AT] = ACTIONS(211),
    [aux_sym__hex_literal_token1] = ACTIONS(650),
    [sym__number_literal] = ACTIONS(652),
    [anon_sym_SQUOTE] = ACTIONS(654),
    [anon_sym_DQUOTE] = ACTIONS(656),
    [sym_return] = ACTIONS(747),
    [sym_next] = ACTIONS(747),
    [sym_break] = ACTIONS(747),
    [sym_true] = ACTIONS(747),
    [sym_false] = ACTIONS(747),
    [sym_null] = ACTIONS(747),
    [sym_inf] = ACTIONS(747),
    [sym_nan] = ACTIONS(747),
    [anon_sym_NA] = ACTIONS(660),
    [anon_sym_NA_integer_] = ACTIONS(660),
    [anon_sym_NA_real_] = ACTIONS(660),
    [anon_sym_NA_complex_] = ACTIONS(660),
    [anon_sym_NA_character_] = ACTIONS(660),
    [sym_dots] = ACTIONS(747),
    [sym_dot_dot_i] = ACTIONS(749),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(211),
    [sym__newline] = ACTIONS(751),
    [sym__semicolon] = ACTIONS(211),
    [sym__raw_string_literal] = ACTIONS(666),
    [sym__external_open_parenthesis] = ACTIONS(668),
    [sym__external_close_parenthesis] = ACTIONS(753),
    [sym__external_open_brace] = ACTIONS(670),
    [sym__external_close_brace] = ACTIONS(211),
    [sym__external_open_bracket] = ACTIONS(211),
    [sym__external_open_bracket2] = ACTIONS(211),
    [sym__external_close_bracket2] = ACTIONS(211),
  },
  [45] = {
    [sym_function_definition] = STATE(796),
    [sym_if_statement] = STATE(796),
    [sym_for_statement] = STATE(796),
    [sym_while_statement] = STATE(796),
    [sym_repeat_statement] = STATE(796),
    [sym_braced_expression] = STATE(796),
    [sym_parenthesized_expression] = STATE(796),
    [sym_call] = STATE(796),
    [sym_subset] = STATE(796),
    [sym_subset2] = STATE(796),
    [sym_unary_operator] = STATE(796),
    [sym_binary_operator] = STATE(796),
    [sym_extract_operator] = STATE(796),
    [sym_namespace_operator] = STATE(796),
    [sym_integer] = STATE(796),
    [sym_complex] = STATE(796),
    [sym_float] = STATE(796),
    [sym__hex_literal] = STATE(2206),
    [sym__float_literal] = STATE(2206),
    [sym_string] = STATE(2166),
    [sym__single_quoted_string] = STATE(2200),
    [sym__double_quoted_string] = STATE(2201),
    [sym_na] = STATE(796),
    [sym__expression] = STATE(796),
    [sym__string_or_identifier] = STATE(5154),
    [sym__open_parenthesis] = STATE(3),
    [sym__open_brace] = STATE(45),
    [sym__close_brace] = STATE(2444),
    [aux_sym_braced_expression_repeat1] = STATE(41),
    [sym_identifier] = ACTIONS(481),
    [anon_sym_BSLASH] = ACTIONS(483),
    [anon_sym_function] = ACTIONS(485),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(487),
    [anon_sym_for] = ACTIONS(489),
    [anon_sym_while] = ACTIONS(491),
    [anon_sym_repeat] = ACTIONS(493),
    [anon_sym_QMARK] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(503),
    [anon_sym_LT_DASH] = ACTIONS(155),
    [anon_sym_LT_LT_DASH] = ACTIONS(155),
    [anon_sym_COLON_EQ] = ACTIONS(155),
    [anon_sym_DASH_GT] = ACTIONS(157),
    [anon_sym_DASH_GT_GT] = ACTIONS(155),
    [anon_sym_PIPE] = ACTIONS(157),
    [anon_sym_AMP] = ACTIONS(157),
    [anon_sym_PIPE_PIPE] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(157),
    [anon_sym_LT_EQ] = ACTIONS(155),
    [anon_sym_GT] = ACTIONS(157),
    [anon_sym_GT_EQ] = ACTIONS(155),
    [anon_sym_EQ_EQ] = ACTIONS(155),
    [anon_sym_BANG_EQ] = ACTIONS(155),
    [anon_sym_STAR] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(155),
    [anon_sym_STAR_STAR] = ACTIONS(155),
    [anon_sym_CARET] = ACTIONS(155),
    [aux_sym_binary_operator_token1] = ACTIONS(155),
    [anon_sym_PIPE_GT] = ACTIONS(155),
    [anon_sym_COLON] = ACTIONS(157),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(155),
    [aux_sym__hex_literal_token1] = ACTIONS(505),
    [sym__number_literal] = ACTIONS(507),
    [anon_sym_SQUOTE] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(511),
    [sym_return] = ACTIONS(513),
    [sym_next] = ACTIONS(513),
    [sym_break] = ACTIONS(513),
    [sym_true] = ACTIONS(513),
    [sym_false] = ACTIONS(513),
    [sym_null] = ACTIONS(513),
    [sym_inf] = ACTIONS(513),
    [sym_nan] = ACTIONS(513),
    [anon_sym_NA] = ACTIONS(515),
    [anon_sym_NA_integer_] = ACTIONS(515),
    [anon_sym_NA_real_] = ACTIONS(515),
    [anon_sym_NA_complex_] = ACTIONS(515),
    [anon_sym_NA_character_] = ACTIONS(515),
    [sym_dots] = ACTIONS(513),
    [sym_dot_dot_i] = ACTIONS(517),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(155),
    [sym__newline] = ACTIONS(519),
    [sym__semicolon] = ACTIONS(519),
    [sym__raw_string_literal] = ACTIONS(521),
    [sym__external_else] = ACTIONS(155),
    [sym__external_open_parenthesis] = ACTIONS(523),
    [sym__external_open_brace] = ACTIONS(525),
    [sym__external_close_brace] = ACTIONS(755),
    [sym__external_open_bracket] = ACTIONS(155),
    [sym__external_close_bracket] = ACTIONS(155),
    [sym__external_open_bracket2] = ACTIONS(155),
  },
  [46] = {
    [sym_function_definition] = STATE(535),
    [sym_if_statement] = STATE(535),
    [sym_for_statement] = STATE(535),
    [sym_while_statement] = STATE(535),
    [sym_repeat_statement] = STATE(535),
    [sym_braced_expression] = STATE(535),
    [sym_parenthesized_expression] = STATE(535),
    [sym_call] = STATE(535),
    [sym_subset] = STATE(535),
    [sym_subset2] = STATE(535),
    [sym_unary_operator] = STATE(535),
    [sym_binary_operator] = STATE(535),
    [sym_extract_operator] = STATE(535),
    [sym_namespace_operator] = STATE(535),
    [sym_integer] = STATE(535),
    [sym_complex] = STATE(535),
    [sym_float] = STATE(535),
    [sym__hex_literal] = STATE(1984),
    [sym__float_literal] = STATE(1984),
    [sym_string] = STATE(1982),
    [sym__single_quoted_string] = STATE(1985),
    [sym__double_quoted_string] = STATE(1990),
    [sym_na] = STATE(535),
    [sym__expression] = STATE(535),
    [sym__string_or_identifier] = STATE(5151),
    [sym__open_parenthesis] = STATE(19),
    [sym__open_brace] = STATE(4),
    [aux_sym_function_definition_repeat1] = STATE(2195),
    [ts_builtin_sym_end] = ACTIONS(757),
    [sym_identifier] = ACTIONS(53),
    [anon_sym_BSLASH] = ACTIONS(55),
    [anon_sym_function] = ACTIONS(57),
    [anon_sym_EQ] = ACTIONS(759),
    [anon_sym_if] = ACTIONS(61),
    [anon_sym_for] = ACTIONS(63),
    [anon_sym_while] = ACTIONS(65),
    [anon_sym_repeat] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_LT_DASH] = ACTIONS(757),
    [anon_sym_LT_LT_DASH] = ACTIONS(757),
    [anon_sym_COLON_EQ] = ACTIONS(757),
    [anon_sym_DASH_GT] = ACTIONS(759),
    [anon_sym_DASH_GT_GT] = ACTIONS(757),
    [anon_sym_PIPE] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(759),
    [anon_sym_PIPE_PIPE] = ACTIONS(757),
    [anon_sym_AMP_AMP] = ACTIONS(757),
    [anon_sym_LT] = ACTIONS(759),
    [anon_sym_LT_EQ] = ACTIONS(757),
    [anon_sym_GT] = ACTIONS(759),
    [anon_sym_GT_EQ] = ACTIONS(757),
    [anon_sym_EQ_EQ] = ACTIONS(757),
    [anon_sym_BANG_EQ] = ACTIONS(757),
    [anon_sym_STAR] = ACTIONS(759),
    [anon_sym_SLASH] = ACTIONS(757),
    [anon_sym_STAR_STAR] = ACTIONS(757),
    [anon_sym_CARET] = ACTIONS(757),
    [aux_sym_binary_operator_token1] = ACTIONS(757),
    [anon_sym_PIPE_GT] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(759),
    [anon_sym_DOLLAR] = ACTIONS(757),
    [anon_sym_AT] = ACTIONS(757),
    [aux_sym__hex_literal_token1] = ACTIONS(79),
    [sym__number_literal] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_return] = ACTIONS(761),
    [sym_next] = ACTIONS(761),
    [sym_break] = ACTIONS(761),
    [sym_true] = ACTIONS(761),
    [sym_false] = ACTIONS(761),
    [sym_null] = ACTIONS(761),
    [sym_inf] = ACTIONS(761),
    [sym_nan] = ACTIONS(761),
    [anon_sym_NA] = ACTIONS(89),
    [anon_sym_NA_integer_] = ACTIONS(89),
    [anon_sym_NA_real_] = ACTIONS(89),
    [anon_sym_NA_complex_] = ACTIONS(89),
    [anon_sym_NA_character_] = ACTIONS(89),
    [sym_dots] = ACTIONS(761),
    [sym_dot_dot_i] = ACTIONS(763),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(757),
    [sym__newline] = ACTIONS(757),
    [sym__semicolon] = ACTIONS(757),
    [sym__raw_string_literal] = ACTIONS(95),
    [sym__external_else] = ACTIONS(757),
    [sym__external_open_parenthesis] = ACTIONS(97),
    [sym__external_close_parenthesis] = ACTIONS(757),
    [sym__external_open_brace] = ACTIONS(99),
    [sym__external_close_brace] = ACTIONS(757),
    [sym__external_open_bracket] = ACTIONS(757),
    [sym__external_open_bracket2] = ACTIONS(757),
  },
  [47] = {
    [sym_function_definition] = STATE(515),
    [sym_if_statement] = STATE(515),
    [sym_for_statement] = STATE(515),
    [sym_while_statement] = STATE(515),
    [sym_repeat_statement] = STATE(515),
    [sym_braced_expression] = STATE(515),
    [sym_parenthesized_expression] = STATE(515),
    [sym_call] = STATE(515),
    [sym_subset] = STATE(515),
    [sym_subset2] = STATE(515),
    [sym_unary_operator] = STATE(515),
    [sym_binary_operator] = STATE(515),
    [sym_extract_operator] = STATE(515),
    [sym_namespace_operator] = STATE(515),
    [sym_integer] = STATE(515),
    [sym_complex] = STATE(515),
    [sym_float] = STATE(515),
    [sym__hex_literal] = STATE(1984),
    [sym__float_literal] = STATE(1984),
    [sym_string] = STATE(1982),
    [sym__single_quoted_string] = STATE(1985),
    [sym__double_quoted_string] = STATE(1990),
    [sym_na] = STATE(515),
    [sym__expression] = STATE(515),
    [sym__string_or_identifier] = STATE(5151),
    [sym__open_parenthesis] = STATE(19),
    [sym__open_brace] = STATE(4),
    [aux_sym_function_definition_repeat1] = STATE(2195),
    [ts_builtin_sym_end] = ACTIONS(765),
    [sym_identifier] = ACTIONS(53),
    [anon_sym_BSLASH] = ACTIONS(55),
    [anon_sym_function] = ACTIONS(57),
    [anon_sym_EQ] = ACTIONS(767),
    [anon_sym_if] = ACTIONS(61),
    [anon_sym_for] = ACTIONS(63),
    [anon_sym_while] = ACTIONS(65),
    [anon_sym_repeat] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_LT_DASH] = ACTIONS(765),
    [anon_sym_LT_LT_DASH] = ACTIONS(765),
    [anon_sym_COLON_EQ] = ACTIONS(765),
    [anon_sym_DASH_GT] = ACTIONS(767),
    [anon_sym_DASH_GT_GT] = ACTIONS(765),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_AMP] = ACTIONS(767),
    [anon_sym_PIPE_PIPE] = ACTIONS(765),
    [anon_sym_AMP_AMP] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(767),
    [anon_sym_LT_EQ] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_GT_EQ] = ACTIONS(765),
    [anon_sym_EQ_EQ] = ACTIONS(765),
    [anon_sym_BANG_EQ] = ACTIONS(765),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(765),
    [anon_sym_STAR_STAR] = ACTIONS(765),
    [anon_sym_CARET] = ACTIONS(765),
    [aux_sym_binary_operator_token1] = ACTIONS(765),
    [anon_sym_PIPE_GT] = ACTIONS(765),
    [anon_sym_COLON] = ACTIONS(767),
    [anon_sym_DOLLAR] = ACTIONS(765),
    [anon_sym_AT] = ACTIONS(765),
    [aux_sym__hex_literal_token1] = ACTIONS(79),
    [sym__number_literal] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_return] = ACTIONS(769),
    [sym_next] = ACTIONS(769),
    [sym_break] = ACTIONS(769),
    [sym_true] = ACTIONS(769),
    [sym_false] = ACTIONS(769),
    [sym_null] = ACTIONS(769),
    [sym_inf] = ACTIONS(769),
    [sym_nan] = ACTIONS(769),
    [anon_sym_NA] = ACTIONS(89),
    [anon_sym_NA_integer_] = ACTIONS(89),
    [anon_sym_NA_real_] = ACTIONS(89),
    [anon_sym_NA_complex_] = ACTIONS(89),
    [anon_sym_NA_character_] = ACTIONS(89),
    [sym_dots] = ACTIONS(769),
    [sym_dot_dot_i] = ACTIONS(771),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(765),
    [sym__newline] = ACTIONS(765),
    [sym__semicolon] = ACTIONS(765),
    [sym__raw_string_literal] = ACTIONS(95),
    [sym__external_else] = ACTIONS(765),
    [sym__external_open_parenthesis] = ACTIONS(97),
    [sym__external_close_parenthesis] = ACTIONS(765),
    [sym__external_open_brace] = ACTIONS(99),
    [sym__external_close_brace] = ACTIONS(765),
    [sym__external_open_bracket] = ACTIONS(765),
    [sym__external_open_bracket2] = ACTIONS(765),
  },
  [48] = {
    [sym_function_definition] = STATE(789),
    [sym_if_statement] = STATE(789),
    [sym_for_statement] = STATE(789),
    [sym_while_statement] = STATE(789),
    [sym_repeat_statement] = STATE(789),
    [sym_braced_expression] = STATE(789),
    [sym_parenthesized_expression] = STATE(789),
    [sym_call] = STATE(789),
    [sym_subset] = STATE(789),
    [sym_subset2] = STATE(789),
    [sym_unary_operator] = STATE(789),
    [sym_binary_operator] = STATE(789),
    [sym_extract_operator] = STATE(789),
    [sym_namespace_operator] = STATE(789),
    [sym_integer] = STATE(789),
    [sym_complex] = STATE(789),
    [sym_float] = STATE(789),
    [sym__hex_literal] = STATE(2210),
    [sym__float_literal] = STATE(2210),
    [sym_string] = STATE(2209),
    [sym__single_quoted_string] = STATE(2211),
    [sym__double_quoted_string] = STATE(2212),
    [sym_na] = STATE(789),
    [sym__expression] = STATE(789),
    [sym__string_or_identifier] = STATE(5127),
    [sym__open_parenthesis] = STATE(5),
    [sym__open_brace] = STATE(42),
    [sym__close_brace] = STATE(2515),
    [aux_sym_braced_expression_repeat1] = STATE(159),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_BSLASH] = ACTIONS(407),
    [anon_sym_function] = ACTIONS(409),
    [anon_sym_EQ] = ACTIONS(59),
    [anon_sym_if] = ACTIONS(411),
    [anon_sym_for] = ACTIONS(413),
    [anon_sym_while] = ACTIONS(415),
    [anon_sym_repeat] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_TILDE] = ACTIONS(421),
    [anon_sym_BANG] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(427),
    [anon_sym_LT_DASH] = ACTIONS(51),
    [anon_sym_LT_LT_DASH] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(51),
    [anon_sym_DASH_GT] = ACTIONS(59),
    [anon_sym_DASH_GT_GT] = ACTIONS(51),
    [anon_sym_PIPE] = ACTIONS(59),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_AMP_AMP] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(59),
    [anon_sym_LT_EQ] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(59),
    [anon_sym_GT_EQ] = ACTIONS(51),
    [anon_sym_EQ_EQ] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(51),
    [anon_sym_CARET] = ACTIONS(51),
    [aux_sym_binary_operator_token1] = ACTIONS(51),
    [anon_sym_PIPE_GT] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(59),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_AT] = ACTIONS(51),
    [aux_sym__hex_literal_token1] = ACTIONS(429),
    [sym__number_literal] = ACTIONS(431),
    [anon_sym_SQUOTE] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_return] = ACTIONS(437),
    [sym_next] = ACTIONS(437),
    [sym_break] = ACTIONS(437),
    [sym_true] = ACTIONS(437),
    [sym_false] = ACTIONS(437),
    [sym_null] = ACTIONS(437),
    [sym_inf] = ACTIONS(437),
    [sym_nan] = ACTIONS(437),
    [anon_sym_NA] = ACTIONS(439),
    [anon_sym_NA_integer_] = ACTIONS(439),
    [anon_sym_NA_real_] = ACTIONS(439),
    [anon_sym_NA_complex_] = ACTIONS(439),
    [anon_sym_NA_character_] = ACTIONS(439),
    [sym_dots] = ACTIONS(437),
    [sym_dot_dot_i] = ACTIONS(441),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(51),
    [sym__newline] = ACTIONS(443),
    [sym__semicolon] = ACTIONS(443),
    [sym__raw_string_literal] = ACTIONS(445),
    [sym__external_else] = ACTIONS(51),
    [sym__external_open_parenthesis] = ACTIONS(447),
    [sym__external_open_brace] = ACTIONS(449),
    [sym__external_close_brace] = ACTIONS(773),
    [sym__external_open_bracket] = ACTIONS(51),
    [sym__external_open_bracket2] = ACTIONS(51),
    [sym__external_close_bracket2] = ACTIONS(51),
  },
  [49] = {
    [sym_function_definition] = STATE(514),
    [sym_if_statement] = STATE(514),
    [sym_for_statement] = STATE(514),
    [sym_while_statement] = STATE(514),
    [sym_repeat_statement] = STATE(514),
    [sym_braced_expression] = STATE(514),
    [sym_parenthesized_expression] = STATE(514),
    [sym_call] = STATE(514),
    [sym_subset] = STATE(514),
    [sym_subset2] = STATE(514),
    [sym_unary_operator] = STATE(514),
    [sym_binary_operator] = STATE(514),
    [sym_extract_operator] = STATE(514),
    [sym_namespace_operator] = STATE(514),
    [sym_integer] = STATE(514),
    [sym_complex] = STATE(514),
    [sym_float] = STATE(514),
    [sym__hex_literal] = STATE(1984),
    [sym__float_literal] = STATE(1984),
    [sym_string] = STATE(1982),
    [sym__single_quoted_string] = STATE(1985),
    [sym__double_quoted_string] = STATE(1990),
    [sym_na] = STATE(514),
    [sym__expression] = STATE(514),
    [sym__string_or_identifier] = STATE(5151),
    [sym__open_parenthesis] = STATE(19),
    [sym__open_brace] = STATE(4),
    [aux_sym_function_definition_repeat1] = STATE(46),
    [ts_builtin_sym_end] = ACTIONS(545),
    [sym_identifier] = ACTIONS(53),
    [anon_sym_BSLASH] = ACTIONS(55),
    [anon_sym_function] = ACTIONS(57),
    [anon_sym_EQ] = ACTIONS(543),
    [anon_sym_if] = ACTIONS(61),
    [anon_sym_for] = ACTIONS(63),
    [anon_sym_while] = ACTIONS(65),
    [anon_sym_repeat] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_LT_DASH] = ACTIONS(545),
    [anon_sym_LT_LT_DASH] = ACTIONS(545),
    [anon_sym_COLON_EQ] = ACTIONS(545),
    [anon_sym_DASH_GT] = ACTIONS(543),
    [anon_sym_DASH_GT_GT] = ACTIONS(545),
    [anon_sym_PIPE] = ACTIONS(543),
    [anon_sym_AMP] = ACTIONS(543),
    [anon_sym_PIPE_PIPE] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(543),
    [anon_sym_LT_EQ] = ACTIONS(545),
    [anon_sym_GT] = ACTIONS(543),
    [anon_sym_GT_EQ] = ACTIONS(545),
    [anon_sym_EQ_EQ] = ACTIONS(545),
    [anon_sym_BANG_EQ] = ACTIONS(545),
    [anon_sym_STAR] = ACTIONS(543),
    [anon_sym_SLASH] = ACTIONS(545),
    [anon_sym_STAR_STAR] = ACTIONS(545),
    [anon_sym_CARET] = ACTIONS(545),
    [aux_sym_binary_operator_token1] = ACTIONS(545),
    [anon_sym_PIPE_GT] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(543),
    [anon_sym_DOLLAR] = ACTIONS(545),
    [anon_sym_AT] = ACTIONS(545),
    [aux_sym__hex_literal_token1] = ACTIONS(79),
    [sym__number_literal] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_return] = ACTIONS(775),
    [sym_next] = ACTIONS(775),
    [sym_break] = ACTIONS(775),
    [sym_true] = ACTIONS(775),
    [sym_false] = ACTIONS(775),
    [sym_null] = ACTIONS(775),
    [sym_inf] = ACTIONS(775),
    [sym_nan] = ACTIONS(775),
    [anon_sym_NA] = ACTIONS(89),
    [anon_sym_NA_integer_] = ACTIONS(89),
    [anon_sym_NA_real_] = ACTIONS(89),
    [anon_sym_NA_complex_] = ACTIONS(89),
    [anon_sym_NA_character_] = ACTIONS(89),
    [sym_dots] = ACTIONS(775),
    [sym_dot_dot_i] = ACTIONS(777),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(545),
    [sym__newline] = ACTIONS(779),
    [sym__semicolon] = ACTIONS(545),
    [sym__raw_string_literal] = ACTIONS(95),
    [sym__external_else] = ACTIONS(545),
    [sym__external_open_parenthesis] = ACTIONS(97),
    [sym__external_close_parenthesis] = ACTIONS(545),
    [sym__external_open_brace] = ACTIONS(99),
    [sym__external_close_brace] = ACTIONS(545),
    [sym__external_open_bracket] = ACTIONS(545),
    [sym__external_open_bracket2] = ACTIONS(545),
  },
  [50] = {
    [sym_function_definition] = STATE(917),
    [sym_if_statement] = STATE(917),
    [sym_for_statement] = STATE(917),
    [sym_while_statement] = STATE(917),
    [sym_repeat_statement] = STATE(917),
    [sym_braced_expression] = STATE(917),
    [sym_parenthesized_expression] = STATE(917),
    [sym_call] = STATE(917),
    [sym_subset] = STATE(917),
    [sym_subset2] = STATE(917),
    [sym_unary_operator] = STATE(917),
    [sym_binary_operator] = STATE(917),
    [sym_extract_operator] = STATE(917),
    [sym_namespace_operator] = STATE(917),
    [sym_integer] = STATE(917),
    [sym_complex] = STATE(917),
    [sym_float] = STATE(917),
    [sym__hex_literal] = STATE(2189),
    [sym__float_literal] = STATE(2189),
    [sym_string] = STATE(2192),
    [sym__single_quoted_string] = STATE(2188),
    [sym__double_quoted_string] = STATE(2187),
    [sym_na] = STATE(917),
    [sym__expression] = STATE(917),
    [sym__string_or_identifier] = STATE(5139),
    [sym__open_parenthesis] = STATE(57),
    [sym__close_parenthesis] = STATE(2489),
    [sym__open_brace] = STATE(59),
    [aux_sym_parenthesized_expression_repeat1] = STATE(123),
    [sym_identifier] = ACTIONS(273),
    [anon_sym_BSLASH] = ACTIONS(275),
    [anon_sym_function] = ACTIONS(277),
    [anon_sym_EQ] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_for] = ACTIONS(281),
    [anon_sym_while] = ACTIONS(283),
    [anon_sym_repeat] = ACTIONS(285),
    [anon_sym_QMARK] = ACTIONS(287),
    [anon_sym_TILDE] = ACTIONS(289),
    [anon_sym_BANG] = ACTIONS(291),
    [anon_sym_PLUS] = ACTIONS(293),
    [anon_sym_DASH] = ACTIONS(295),
    [anon_sym_LT_DASH] = ACTIONS(211),
    [anon_sym_LT_LT_DASH] = ACTIONS(211),
    [anon_sym_COLON_EQ] = ACTIONS(211),
    [anon_sym_DASH_GT] = ACTIONS(209),
    [anon_sym_DASH_GT_GT] = ACTIONS(211),
    [anon_sym_PIPE] = ACTIONS(209),
    [anon_sym_AMP] = ACTIONS(209),
    [anon_sym_PIPE_PIPE] = ACTIONS(211),
    [anon_sym_AMP_AMP] = ACTIONS(211),
    [anon_sym_LT] = ACTIONS(209),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_GT] = ACTIONS(209),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [anon_sym_EQ_EQ] = ACTIONS(211),
    [anon_sym_BANG_EQ] = ACTIONS(211),
    [anon_sym_STAR] = ACTIONS(209),
    [anon_sym_SLASH] = ACTIONS(211),
    [anon_sym_STAR_STAR] = ACTIONS(211),
    [anon_sym_CARET] = ACTIONS(211),
    [aux_sym_binary_operator_token1] = ACTIONS(211),
    [anon_sym_PIPE_GT] = ACTIONS(211),
    [anon_sym_COLON] = ACTIONS(209),
    [anon_sym_DOLLAR] = ACTIONS(211),
    [anon_sym_AT] = ACTIONS(211),
    [aux_sym__hex_literal_token1] = ACTIONS(297),
    [sym__number_literal] = ACTIONS(299),
    [anon_sym_SQUOTE] = ACTIONS(301),
    [anon_sym_DQUOTE] = ACTIONS(303),
    [sym_return] = ACTIONS(305),
    [sym_next] = ACTIONS(305),
    [sym_break] = ACTIONS(305),
    [sym_true] = ACTIONS(305),
    [sym_false] = ACTIONS(305),
    [sym_null] = ACTIONS(305),
    [sym_inf] = ACTIONS(305),
    [sym_nan] = ACTIONS(305),
    [anon_sym_NA] = ACTIONS(307),
    [anon_sym_NA_integer_] = ACTIONS(307),
    [anon_sym_NA_real_] = ACTIONS(307),
    [anon_sym_NA_complex_] = ACTIONS(307),
    [anon_sym_NA_character_] = ACTIONS(307),
    [sym_dots] = ACTIONS(305),
    [sym_dot_dot_i] = ACTIONS(309),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(211),
    [sym__newline] = ACTIONS(311),
    [sym__semicolon] = ACTIONS(211),
    [sym__raw_string_literal] = ACTIONS(313),
    [sym__external_open_parenthesis] = ACTIONS(315),
    [sym__external_close_parenthesis] = ACTIONS(781),
    [sym__external_open_brace] = ACTIONS(319),
    [sym__external_close_brace] = ACTIONS(211),
    [sym__external_open_bracket] = ACTIONS(211),
    [sym__external_close_bracket] = ACTIONS(211),
    [sym__external_open_bracket2] = ACTIONS(211),
  },
  [51] = {
    [sym_function_definition] = STATE(599),
    [sym_if_statement] = STATE(599),
    [sym_for_statement] = STATE(599),
    [sym_while_statement] = STATE(599),
    [sym_repeat_statement] = STATE(599),
    [sym_braced_expression] = STATE(599),
    [sym_parenthesized_expression] = STATE(599),
    [sym_call] = STATE(599),
    [sym_subset] = STATE(599),
    [sym_subset2] = STATE(599),
    [sym_unary_operator] = STATE(599),
    [sym_binary_operator] = STATE(599),
    [sym_extract_operator] = STATE(599),
    [sym_namespace_operator] = STATE(599),
    [sym_integer] = STATE(599),
    [sym_complex] = STATE(599),
    [sym_float] = STATE(599),
    [sym__hex_literal] = STATE(1984),
    [sym__float_literal] = STATE(1984),
    [sym_string] = STATE(1982),
    [sym__single_quoted_string] = STATE(1985),
    [sym__double_quoted_string] = STATE(1990),
    [sym_na] = STATE(599),
    [sym__expression] = STATE(599),
    [sym__string_or_identifier] = STATE(5151),
    [sym__open_parenthesis] = STATE(19),
    [sym__open_brace] = STATE(4),
    [sym__close_brace] = STATE(4710),
    [aux_sym_braced_expression_repeat1] = STATE(52),
    [sym_identifier] = ACTIONS(53),
    [anon_sym_BSLASH] = ACTIONS(55),
    [anon_sym_function] = ACTIONS(57),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(61),
    [anon_sym_for] = ACTIONS(63),
    [anon_sym_while] = ACTIONS(65),
    [anon_sym_repeat] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_LT_DASH] = ACTIONS(155),
    [anon_sym_LT_LT_DASH] = ACTIONS(155),
    [anon_sym_COLON_EQ] = ACTIONS(155),
    [anon_sym_DASH_GT] = ACTIONS(157),
    [anon_sym_DASH_GT_GT] = ACTIONS(155),
    [anon_sym_PIPE] = ACTIONS(157),
    [anon_sym_AMP] = ACTIONS(157),
    [anon_sym_PIPE_PIPE] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(157),
    [anon_sym_LT_EQ] = ACTIONS(155),
    [anon_sym_GT] = ACTIONS(157),
    [anon_sym_GT_EQ] = ACTIONS(155),
    [anon_sym_EQ_EQ] = ACTIONS(155),
    [anon_sym_BANG_EQ] = ACTIONS(155),
    [anon_sym_STAR] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(155),
    [anon_sym_STAR_STAR] = ACTIONS(155),
    [anon_sym_CARET] = ACTIONS(155),
    [aux_sym_binary_operator_token1] = ACTIONS(155),
    [anon_sym_PIPE_GT] = ACTIONS(155),
    [anon_sym_COLON] = ACTIONS(157),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(155),
    [aux_sym__hex_literal_token1] = ACTIONS(79),
    [sym__number_literal] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_return] = ACTIONS(87),
    [sym_next] = ACTIONS(87),
    [sym_break] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_inf] = ACTIONS(87),
    [sym_nan] = ACTIONS(87),
    [anon_sym_NA] = ACTIONS(89),
    [anon_sym_NA_integer_] = ACTIONS(89),
    [anon_sym_NA_real_] = ACTIONS(89),
    [anon_sym_NA_complex_] = ACTIONS(89),
    [anon_sym_NA_character_] = ACTIONS(89),
    [sym_dots] = ACTIONS(87),
    [sym_dot_dot_i] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(155),
    [sym__newline] = ACTIONS(93),
    [sym__semicolon] = ACTIONS(93),
    [sym__raw_string_literal] = ACTIONS(95),
    [sym__external_else] = ACTIONS(155),
    [sym__external_open_parenthesis] = ACTIONS(97),
    [sym__external_close_parenthesis] = ACTIONS(155),
    [sym__external_open_brace] = ACTIONS(99),
    [sym__external_close_brace] = ACTIONS(783),
    [sym__external_open_bracket] = ACTIONS(155),
    [sym__external_open_bracket2] = ACTIONS(155),
  },
  [52] = {
    [sym_function_definition] = STATE(599),
    [sym_if_statement] = STATE(599),
    [sym_for_statement] = STATE(599),
    [sym_while_statement] = STATE(599),
    [sym_repeat_statement] = STATE(599),
    [sym_braced_expression] = STATE(599),
    [sym_parenthesized_expression] = STATE(599),
    [sym_call] = STATE(599),
    [sym_subset] = STATE(599),
    [sym_subset2] = STATE(599),
    [sym_unary_operator] = STATE(599),
    [sym_binary_operator] = STATE(599),
    [sym_extract_operator] = STATE(599),
    [sym_namespace_operator] = STATE(599),
    [sym_integer] = STATE(599),
    [sym_complex] = STATE(599),
    [sym_float] = STATE(599),
    [sym__hex_literal] = STATE(1984),
    [sym__float_literal] = STATE(1984),
    [sym_string] = STATE(1982),
    [sym__single_quoted_string] = STATE(1985),
    [sym__double_quoted_string] = STATE(1990),
    [sym_na] = STATE(599),
    [sym__expression] = STATE(599),
    [sym__string_or_identifier] = STATE(5151),
    [sym__open_parenthesis] = STATE(19),
    [sym__open_brace] = STATE(4),
    [sym__close_brace] = STATE(4694),
    [aux_sym_braced_expression_repeat1] = STATE(66),
    [sym_identifier] = ACTIONS(53),
    [anon_sym_BSLASH] = ACTIONS(55),
    [anon_sym_function] = ACTIONS(57),
    [anon_sym_EQ] = ACTIONS(59),
    [anon_sym_if] = ACTIONS(61),
    [anon_sym_for] = ACTIONS(63),
    [anon_sym_while] = ACTIONS(65),
    [anon_sym_repeat] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_LT_DASH] = ACTIONS(51),
    [anon_sym_LT_LT_DASH] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(51),
    [anon_sym_DASH_GT] = ACTIONS(59),
    [anon_sym_DASH_GT_GT] = ACTIONS(51),
    [anon_sym_PIPE] = ACTIONS(59),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_AMP_AMP] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(59),
    [anon_sym_LT_EQ] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(59),
    [anon_sym_GT_EQ] = ACTIONS(51),
    [anon_sym_EQ_EQ] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(51),
    [anon_sym_CARET] = ACTIONS(51),
    [aux_sym_binary_operator_token1] = ACTIONS(51),
    [anon_sym_PIPE_GT] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(59),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_AT] = ACTIONS(51),
    [aux_sym__hex_literal_token1] = ACTIONS(79),
    [sym__number_literal] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_return] = ACTIONS(87),
    [sym_next] = ACTIONS(87),
    [sym_break] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_inf] = ACTIONS(87),
    [sym_nan] = ACTIONS(87),
    [anon_sym_NA] = ACTIONS(89),
    [anon_sym_NA_integer_] = ACTIONS(89),
    [anon_sym_NA_real_] = ACTIONS(89),
    [anon_sym_NA_complex_] = ACTIONS(89),
    [anon_sym_NA_character_] = ACTIONS(89),
    [sym_dots] = ACTIONS(87),
    [sym_dot_dot_i] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(51),
    [sym__newline] = ACTIONS(93),
    [sym__semicolon] = ACTIONS(93),
    [sym__raw_string_literal] = ACTIONS(95),
    [sym__external_else] = ACTIONS(51),
    [sym__external_open_parenthesis] = ACTIONS(97),
    [sym__external_close_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(99),
    [sym__external_close_brace] = ACTIONS(785),
    [sym__external_open_bracket] = ACTIONS(51),
    [sym__external_open_bracket2] = ACTIONS(51),
  },
  [53] = {
    [sym_function_definition] = STATE(564),
    [sym_if_statement] = STATE(564),
    [sym_for_statement] = STATE(564),
    [sym_while_statement] = STATE(564),
    [sym_repeat_statement] = STATE(564),
    [sym_braced_expression] = STATE(564),
    [sym_parenthesized_expression] = STATE(564),
    [sym_call] = STATE(564),
    [sym_subset] = STATE(564),
    [sym_subset2] = STATE(564),
    [sym_unary_operator] = STATE(564),
    [sym_binary_operator] = STATE(564),
    [sym_extract_operator] = STATE(564),
    [sym_namespace_operator] = STATE(564),
    [sym_integer] = STATE(564),
    [sym_complex] = STATE(564),
    [sym_float] = STATE(564),
    [sym__hex_literal] = STATE(2021),
    [sym__float_literal] = STATE(2021),
    [sym_string] = STATE(2016),
    [sym__single_quoted_string] = STATE(2027),
    [sym__double_quoted_string] = STATE(2041),
    [sym_na] = STATE(564),
    [sym__expression] = STATE(564),
    [sym__string_or_identifier] = STATE(5131),
    [sym__open_parenthesis] = STATE(20),
    [sym__open_brace] = STATE(10),
    [aux_sym_function_definition_repeat1] = STATE(55),
    [sym_identifier] = ACTIONS(103),
    [anon_sym_BSLASH] = ACTIONS(105),
    [anon_sym_function] = ACTIONS(107),
    [anon_sym_EQ] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(111),
    [anon_sym_for] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_repeat] = ACTIONS(117),
    [anon_sym_QMARK] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_BANG] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(125),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_LT_DASH] = ACTIONS(263),
    [anon_sym_LT_LT_DASH] = ACTIONS(263),
    [anon_sym_COLON_EQ] = ACTIONS(263),
    [anon_sym_DASH_GT] = ACTIONS(265),
    [anon_sym_DASH_GT_GT] = ACTIONS(263),
    [anon_sym_PIPE] = ACTIONS(265),
    [anon_sym_AMP] = ACTIONS(265),
    [anon_sym_PIPE_PIPE] = ACTIONS(263),
    [anon_sym_AMP_AMP] = ACTIONS(263),
    [anon_sym_LT] = ACTIONS(265),
    [anon_sym_LT_EQ] = ACTIONS(263),
    [anon_sym_GT] = ACTIONS(265),
    [anon_sym_GT_EQ] = ACTIONS(263),
    [anon_sym_EQ_EQ] = ACTIONS(263),
    [anon_sym_BANG_EQ] = ACTIONS(263),
    [anon_sym_STAR] = ACTIONS(265),
    [anon_sym_SLASH] = ACTIONS(263),
    [anon_sym_STAR_STAR] = ACTIONS(263),
    [anon_sym_CARET] = ACTIONS(263),
    [aux_sym_binary_operator_token1] = ACTIONS(263),
    [anon_sym_PIPE_GT] = ACTIONS(263),
    [anon_sym_COLON] = ACTIONS(265),
    [anon_sym_DOLLAR] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(263),
    [aux_sym__hex_literal_token1] = ACTIONS(131),
    [sym__number_literal] = ACTIONS(133),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(137),
    [sym_return] = ACTIONS(787),
    [sym_next] = ACTIONS(787),
    [sym_break] = ACTIONS(787),
    [sym_true] = ACTIONS(787),
    [sym_false] = ACTIONS(787),
    [sym_null] = ACTIONS(787),
    [sym_inf] = ACTIONS(787),
    [sym_nan] = ACTIONS(787),
    [anon_sym_NA] = ACTIONS(141),
    [anon_sym_NA_integer_] = ACTIONS(141),
    [anon_sym_NA_real_] = ACTIONS(141),
    [anon_sym_NA_complex_] = ACTIONS(141),
    [anon_sym_NA_character_] = ACTIONS(141),
    [sym_dots] = ACTIONS(787),
    [sym_dot_dot_i] = ACTIONS(789),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(263),
    [sym__newline] = ACTIONS(791),
    [sym__semicolon] = ACTIONS(263),
    [sym__raw_string_literal] = ACTIONS(147),
    [sym__external_else] = ACTIONS(263),
    [sym__external_open_parenthesis] = ACTIONS(149),
    [sym__external_close_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(153),
    [sym__external_close_brace] = ACTIONS(263),
    [sym__external_open_bracket] = ACTIONS(263),
    [sym__external_close_bracket] = ACTIONS(263),
    [sym__external_open_bracket2] = ACTIONS(263),
  },
  [54] = {
    [sym_function_definition] = STATE(935),
    [sym_if_statement] = STATE(935),
    [sym_for_statement] = STATE(935),
    [sym_while_statement] = STATE(935),
    [sym_repeat_statement] = STATE(935),
    [sym_braced_expression] = STATE(935),
    [sym_parenthesized_expression] = STATE(935),
    [sym_call] = STATE(935),
    [sym_subset] = STATE(935),
    [sym_subset2] = STATE(935),
    [sym_unary_operator] = STATE(935),
    [sym_binary_operator] = STATE(935),
    [sym_extract_operator] = STATE(935),
    [sym_namespace_operator] = STATE(935),
    [sym_integer] = STATE(935),
    [sym_complex] = STATE(935),
    [sym_float] = STATE(935),
    [sym__hex_literal] = STATE(2220),
    [sym__float_literal] = STATE(2220),
    [sym_string] = STATE(2219),
    [sym__single_quoted_string] = STATE(2221),
    [sym__double_quoted_string] = STATE(2222),
    [sym_na] = STATE(935),
    [sym__expression] = STATE(935),
    [sym__string_or_identifier] = STATE(5140),
    [sym__open_parenthesis] = STATE(54),
    [sym__close_parenthesis] = STATE(2406),
    [sym__open_brace] = STATE(56),
    [aux_sym_parenthesized_expression_repeat1] = STATE(44),
    [sym_identifier] = ACTIONS(626),
    [anon_sym_BSLASH] = ACTIONS(628),
    [anon_sym_function] = ACTIONS(630),
    [anon_sym_EQ] = ACTIONS(109),
    [anon_sym_if] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [anon_sym_repeat] = ACTIONS(638),
    [anon_sym_QMARK] = ACTIONS(640),
    [anon_sym_TILDE] = ACTIONS(642),
    [anon_sym_BANG] = ACTIONS(644),
    [anon_sym_PLUS] = ACTIONS(646),
    [anon_sym_DASH] = ACTIONS(648),
    [anon_sym_LT_DASH] = ACTIONS(129),
    [anon_sym_LT_LT_DASH] = ACTIONS(129),
    [anon_sym_COLON_EQ] = ACTIONS(129),
    [anon_sym_DASH_GT] = ACTIONS(109),
    [anon_sym_DASH_GT_GT] = ACTIONS(129),
    [anon_sym_PIPE] = ACTIONS(109),
    [anon_sym_AMP] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_STAR_STAR] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [aux_sym_binary_operator_token1] = ACTIONS(129),
    [anon_sym_PIPE_GT] = ACTIONS(129),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(129),
    [anon_sym_AT] = ACTIONS(129),
    [aux_sym__hex_literal_token1] = ACTIONS(650),
    [sym__number_literal] = ACTIONS(652),
    [anon_sym_SQUOTE] = ACTIONS(654),
    [anon_sym_DQUOTE] = ACTIONS(656),
    [sym_return] = ACTIONS(747),
    [sym_next] = ACTIONS(747),
    [sym_break] = ACTIONS(747),
    [sym_true] = ACTIONS(747),
    [sym_false] = ACTIONS(747),
    [sym_null] = ACTIONS(747),
    [sym_inf] = ACTIONS(747),
    [sym_nan] = ACTIONS(747),
    [anon_sym_NA] = ACTIONS(660),
    [anon_sym_NA_integer_] = ACTIONS(660),
    [anon_sym_NA_real_] = ACTIONS(660),
    [anon_sym_NA_complex_] = ACTIONS(660),
    [anon_sym_NA_character_] = ACTIONS(660),
    [sym_dots] = ACTIONS(747),
    [sym_dot_dot_i] = ACTIONS(749),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(129),
    [sym__newline] = ACTIONS(751),
    [sym__semicolon] = ACTIONS(129),
    [sym__raw_string_literal] = ACTIONS(666),
    [sym__external_open_parenthesis] = ACTIONS(668),
    [sym__external_close_parenthesis] = ACTIONS(793),
    [sym__external_open_brace] = ACTIONS(670),
    [sym__external_close_brace] = ACTIONS(129),
    [sym__external_open_bracket] = ACTIONS(129),
    [sym__external_open_bracket2] = ACTIONS(129),
    [sym__external_close_bracket2] = ACTIONS(129),
  },
  [55] = {
    [sym_function_definition] = STATE(570),
    [sym_if_statement] = STATE(570),
    [sym_for_statement] = STATE(570),
    [sym_while_statement] = STATE(570),
    [sym_repeat_statement] = STATE(570),
    [sym_braced_expression] = STATE(570),
    [sym_parenthesized_expression] = STATE(570),
    [sym_call] = STATE(570),
    [sym_subset] = STATE(570),
    [sym_subset2] = STATE(570),
    [sym_unary_operator] = STATE(570),
    [sym_binary_operator] = STATE(570),
    [sym_extract_operator] = STATE(570),
    [sym_namespace_operator] = STATE(570),
    [sym_integer] = STATE(570),
    [sym_complex] = STATE(570),
    [sym_float] = STATE(570),
    [sym__hex_literal] = STATE(2021),
    [sym__float_literal] = STATE(2021),
    [sym_string] = STATE(2016),
    [sym__single_quoted_string] = STATE(2027),
    [sym__double_quoted_string] = STATE(2041),
    [sym_na] = STATE(570),
    [sym__expression] = STATE(570),
    [sym__string_or_identifier] = STATE(5131),
    [sym__open_parenthesis] = STATE(20),
    [sym__open_brace] = STATE(10),
    [aux_sym_function_definition_repeat1] = STATE(2199),
    [sym_identifier] = ACTIONS(103),
    [anon_sym_BSLASH] = ACTIONS(105),
    [anon_sym_function] = ACTIONS(107),
    [anon_sym_EQ] = ACTIONS(767),
    [anon_sym_if] = ACTIONS(111),
    [anon_sym_for] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_repeat] = ACTIONS(117),
    [anon_sym_QMARK] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_BANG] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(125),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_LT_DASH] = ACTIONS(765),
    [anon_sym_LT_LT_DASH] = ACTIONS(765),
    [anon_sym_COLON_EQ] = ACTIONS(765),
    [anon_sym_DASH_GT] = ACTIONS(767),
    [anon_sym_DASH_GT_GT] = ACTIONS(765),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_AMP] = ACTIONS(767),
    [anon_sym_PIPE_PIPE] = ACTIONS(765),
    [anon_sym_AMP_AMP] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(767),
    [anon_sym_LT_EQ] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_GT_EQ] = ACTIONS(765),
    [anon_sym_EQ_EQ] = ACTIONS(765),
    [anon_sym_BANG_EQ] = ACTIONS(765),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(765),
    [anon_sym_STAR_STAR] = ACTIONS(765),
    [anon_sym_CARET] = ACTIONS(765),
    [aux_sym_binary_operator_token1] = ACTIONS(765),
    [anon_sym_PIPE_GT] = ACTIONS(765),
    [anon_sym_COLON] = ACTIONS(767),
    [anon_sym_DOLLAR] = ACTIONS(765),
    [anon_sym_AT] = ACTIONS(765),
    [aux_sym__hex_literal_token1] = ACTIONS(131),
    [sym__number_literal] = ACTIONS(133),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(137),
    [sym_return] = ACTIONS(795),
    [sym_next] = ACTIONS(795),
    [sym_break] = ACTIONS(795),
    [sym_true] = ACTIONS(795),
    [sym_false] = ACTIONS(795),
    [sym_null] = ACTIONS(795),
    [sym_inf] = ACTIONS(795),
    [sym_nan] = ACTIONS(795),
    [anon_sym_NA] = ACTIONS(141),
    [anon_sym_NA_integer_] = ACTIONS(141),
    [anon_sym_NA_real_] = ACTIONS(141),
    [anon_sym_NA_complex_] = ACTIONS(141),
    [anon_sym_NA_character_] = ACTIONS(141),
    [sym_dots] = ACTIONS(795),
    [sym_dot_dot_i] = ACTIONS(797),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(765),
    [sym__newline] = ACTIONS(765),
    [sym__semicolon] = ACTIONS(765),
    [sym__raw_string_literal] = ACTIONS(147),
    [sym__external_else] = ACTIONS(765),
    [sym__external_open_parenthesis] = ACTIONS(149),
    [sym__external_close_parenthesis] = ACTIONS(765),
    [sym__external_open_brace] = ACTIONS(153),
    [sym__external_close_brace] = ACTIONS(765),
    [sym__external_open_bracket] = ACTIONS(765),
    [sym__external_close_bracket] = ACTIONS(765),
    [sym__external_open_bracket2] = ACTIONS(765),
  },
  [56] = {
    [sym_function_definition] = STATE(921),
    [sym_if_statement] = STATE(921),
    [sym_for_statement] = STATE(921),
    [sym_while_statement] = STATE(921),
    [sym_repeat_statement] = STATE(921),
    [sym_braced_expression] = STATE(921),
    [sym_parenthesized_expression] = STATE(921),
    [sym_call] = STATE(921),
    [sym_subset] = STATE(921),
    [sym_subset2] = STATE(921),
    [sym_unary_operator] = STATE(921),
    [sym_binary_operator] = STATE(921),
    [sym_extract_operator] = STATE(921),
    [sym_namespace_operator] = STATE(921),
    [sym_integer] = STATE(921),
    [sym_complex] = STATE(921),
    [sym_float] = STATE(921),
    [sym__hex_literal] = STATE(2220),
    [sym__float_literal] = STATE(2220),
    [sym_string] = STATE(2219),
    [sym__single_quoted_string] = STATE(2221),
    [sym__double_quoted_string] = STATE(2222),
    [sym_na] = STATE(921),
    [sym__expression] = STATE(921),
    [sym__string_or_identifier] = STATE(5140),
    [sym__open_parenthesis] = STATE(54),
    [sym__open_brace] = STATE(56),
    [sym__close_brace] = STATE(2408),
    [aux_sym_braced_expression_repeat1] = STATE(98),
    [sym_identifier] = ACTIONS(626),
    [anon_sym_BSLASH] = ACTIONS(628),
    [anon_sym_function] = ACTIONS(630),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [anon_sym_repeat] = ACTIONS(638),
    [anon_sym_QMARK] = ACTIONS(640),
    [anon_sym_TILDE] = ACTIONS(642),
    [anon_sym_BANG] = ACTIONS(644),
    [anon_sym_PLUS] = ACTIONS(646),
    [anon_sym_DASH] = ACTIONS(648),
    [anon_sym_LT_DASH] = ACTIONS(155),
    [anon_sym_LT_LT_DASH] = ACTIONS(155),
    [anon_sym_COLON_EQ] = ACTIONS(155),
    [anon_sym_DASH_GT] = ACTIONS(157),
    [anon_sym_DASH_GT_GT] = ACTIONS(155),
    [anon_sym_PIPE] = ACTIONS(157),
    [anon_sym_AMP] = ACTIONS(157),
    [anon_sym_PIPE_PIPE] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(157),
    [anon_sym_LT_EQ] = ACTIONS(155),
    [anon_sym_GT] = ACTIONS(157),
    [anon_sym_GT_EQ] = ACTIONS(155),
    [anon_sym_EQ_EQ] = ACTIONS(155),
    [anon_sym_BANG_EQ] = ACTIONS(155),
    [anon_sym_STAR] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(155),
    [anon_sym_STAR_STAR] = ACTIONS(155),
    [anon_sym_CARET] = ACTIONS(155),
    [aux_sym_binary_operator_token1] = ACTIONS(155),
    [anon_sym_PIPE_GT] = ACTIONS(155),
    [anon_sym_COLON] = ACTIONS(157),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(155),
    [aux_sym__hex_literal_token1] = ACTIONS(650),
    [sym__number_literal] = ACTIONS(652),
    [anon_sym_SQUOTE] = ACTIONS(654),
    [anon_sym_DQUOTE] = ACTIONS(656),
    [sym_return] = ACTIONS(658),
    [sym_next] = ACTIONS(658),
    [sym_break] = ACTIONS(658),
    [sym_true] = ACTIONS(658),
    [sym_false] = ACTIONS(658),
    [sym_null] = ACTIONS(658),
    [sym_inf] = ACTIONS(658),
    [sym_nan] = ACTIONS(658),
    [anon_sym_NA] = ACTIONS(660),
    [anon_sym_NA_integer_] = ACTIONS(660),
    [anon_sym_NA_real_] = ACTIONS(660),
    [anon_sym_NA_complex_] = ACTIONS(660),
    [anon_sym_NA_character_] = ACTIONS(660),
    [sym_dots] = ACTIONS(658),
    [sym_dot_dot_i] = ACTIONS(662),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(155),
    [sym__newline] = ACTIONS(664),
    [sym__semicolon] = ACTIONS(664),
    [sym__raw_string_literal] = ACTIONS(666),
    [sym__external_open_parenthesis] = ACTIONS(668),
    [sym__external_close_parenthesis] = ACTIONS(155),
    [sym__external_open_brace] = ACTIONS(670),
    [sym__external_close_brace] = ACTIONS(799),
    [sym__external_open_bracket] = ACTIONS(155),
    [sym__external_open_bracket2] = ACTIONS(155),
    [sym__external_close_bracket2] = ACTIONS(155),
  },
  [57] = {
    [sym_function_definition] = STATE(917),
    [sym_if_statement] = STATE(917),
    [sym_for_statement] = STATE(917),
    [sym_while_statement] = STATE(917),
    [sym_repeat_statement] = STATE(917),
    [sym_braced_expression] = STATE(917),
    [sym_parenthesized_expression] = STATE(917),
    [sym_call] = STATE(917),
    [sym_subset] = STATE(917),
    [sym_subset2] = STATE(917),
    [sym_unary_operator] = STATE(917),
    [sym_binary_operator] = STATE(917),
    [sym_extract_operator] = STATE(917),
    [sym_namespace_operator] = STATE(917),
    [sym_integer] = STATE(917),
    [sym_complex] = STATE(917),
    [sym_float] = STATE(917),
    [sym__hex_literal] = STATE(2189),
    [sym__float_literal] = STATE(2189),
    [sym_string] = STATE(2192),
    [sym__single_quoted_string] = STATE(2188),
    [sym__double_quoted_string] = STATE(2187),
    [sym_na] = STATE(917),
    [sym__expression] = STATE(917),
    [sym__string_or_identifier] = STATE(5139),
    [sym__open_parenthesis] = STATE(57),
    [sym__close_parenthesis] = STATE(2416),
    [sym__open_brace] = STATE(59),
    [aux_sym_parenthesized_expression_repeat1] = STATE(50),
    [sym_identifier] = ACTIONS(273),
    [anon_sym_BSLASH] = ACTIONS(275),
    [anon_sym_function] = ACTIONS(277),
    [anon_sym_EQ] = ACTIONS(109),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_for] = ACTIONS(281),
    [anon_sym_while] = ACTIONS(283),
    [anon_sym_repeat] = ACTIONS(285),
    [anon_sym_QMARK] = ACTIONS(287),
    [anon_sym_TILDE] = ACTIONS(289),
    [anon_sym_BANG] = ACTIONS(291),
    [anon_sym_PLUS] = ACTIONS(293),
    [anon_sym_DASH] = ACTIONS(295),
    [anon_sym_LT_DASH] = ACTIONS(129),
    [anon_sym_LT_LT_DASH] = ACTIONS(129),
    [anon_sym_COLON_EQ] = ACTIONS(129),
    [anon_sym_DASH_GT] = ACTIONS(109),
    [anon_sym_DASH_GT_GT] = ACTIONS(129),
    [anon_sym_PIPE] = ACTIONS(109),
    [anon_sym_AMP] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_STAR_STAR] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [aux_sym_binary_operator_token1] = ACTIONS(129),
    [anon_sym_PIPE_GT] = ACTIONS(129),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(129),
    [anon_sym_AT] = ACTIONS(129),
    [aux_sym__hex_literal_token1] = ACTIONS(297),
    [sym__number_literal] = ACTIONS(299),
    [anon_sym_SQUOTE] = ACTIONS(301),
    [anon_sym_DQUOTE] = ACTIONS(303),
    [sym_return] = ACTIONS(305),
    [sym_next] = ACTIONS(305),
    [sym_break] = ACTIONS(305),
    [sym_true] = ACTIONS(305),
    [sym_false] = ACTIONS(305),
    [sym_null] = ACTIONS(305),
    [sym_inf] = ACTIONS(305),
    [sym_nan] = ACTIONS(305),
    [anon_sym_NA] = ACTIONS(307),
    [anon_sym_NA_integer_] = ACTIONS(307),
    [anon_sym_NA_real_] = ACTIONS(307),
    [anon_sym_NA_complex_] = ACTIONS(307),
    [anon_sym_NA_character_] = ACTIONS(307),
    [sym_dots] = ACTIONS(305),
    [sym_dot_dot_i] = ACTIONS(309),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(129),
    [sym__newline] = ACTIONS(311),
    [sym__semicolon] = ACTIONS(129),
    [sym__raw_string_literal] = ACTIONS(313),
    [sym__external_open_parenthesis] = ACTIONS(315),
    [sym__external_close_parenthesis] = ACTIONS(801),
    [sym__external_open_brace] = ACTIONS(319),
    [sym__external_close_brace] = ACTIONS(129),
    [sym__external_open_bracket] = ACTIONS(129),
    [sym__external_close_bracket] = ACTIONS(129),
    [sym__external_open_bracket2] = ACTIONS(129),
  },
  [58] = {
    [sym_function_definition] = STATE(575),
    [sym_if_statement] = STATE(575),
    [sym_for_statement] = STATE(575),
    [sym_while_statement] = STATE(575),
    [sym_repeat_statement] = STATE(575),
    [sym_braced_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(575),
    [sym_call] = STATE(575),
    [sym_subset] = STATE(575),
    [sym_subset2] = STATE(575),
    [sym_unary_operator] = STATE(575),
    [sym_binary_operator] = STATE(575),
    [sym_extract_operator] = STATE(575),
    [sym_namespace_operator] = STATE(575),
    [sym_integer] = STATE(575),
    [sym_complex] = STATE(575),
    [sym_float] = STATE(575),
    [sym__hex_literal] = STATE(1984),
    [sym__float_literal] = STATE(1984),
    [sym_string] = STATE(1982),
    [sym__single_quoted_string] = STATE(1985),
    [sym__double_quoted_string] = STATE(1990),
    [sym_na] = STATE(575),
    [sym__expression] = STATE(575),
    [sym__string_or_identifier] = STATE(5151),
    [sym__open_parenthesis] = STATE(19),
    [sym__open_brace] = STATE(4),
    [aux_sym_parenthesized_expression_repeat1] = STATE(58),
    [ts_builtin_sym_end] = ACTIONS(803),
    [sym_identifier] = ACTIONS(805),
    [anon_sym_BSLASH] = ACTIONS(808),
    [anon_sym_function] = ACTIONS(811),
    [anon_sym_EQ] = ACTIONS(814),
    [anon_sym_if] = ACTIONS(816),
    [anon_sym_for] = ACTIONS(819),
    [anon_sym_while] = ACTIONS(822),
    [anon_sym_repeat] = ACTIONS(825),
    [anon_sym_QMARK] = ACTIONS(828),
    [anon_sym_TILDE] = ACTIONS(831),
    [anon_sym_BANG] = ACTIONS(834),
    [anon_sym_PLUS] = ACTIONS(837),
    [anon_sym_DASH] = ACTIONS(840),
    [anon_sym_LT_DASH] = ACTIONS(803),
    [anon_sym_LT_LT_DASH] = ACTIONS(803),
    [anon_sym_COLON_EQ] = ACTIONS(803),
    [anon_sym_DASH_GT] = ACTIONS(814),
    [anon_sym_DASH_GT_GT] = ACTIONS(803),
    [anon_sym_PIPE] = ACTIONS(814),
    [anon_sym_AMP] = ACTIONS(814),
    [anon_sym_PIPE_PIPE] = ACTIONS(803),
    [anon_sym_AMP_AMP] = ACTIONS(803),
    [anon_sym_LT] = ACTIONS(814),
    [anon_sym_LT_EQ] = ACTIONS(803),
    [anon_sym_GT] = ACTIONS(814),
    [anon_sym_GT_EQ] = ACTIONS(803),
    [anon_sym_EQ_EQ] = ACTIONS(803),
    [anon_sym_BANG_EQ] = ACTIONS(803),
    [anon_sym_STAR] = ACTIONS(814),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_STAR_STAR] = ACTIONS(803),
    [anon_sym_CARET] = ACTIONS(803),
    [aux_sym_binary_operator_token1] = ACTIONS(803),
    [anon_sym_PIPE_GT] = ACTIONS(803),
    [anon_sym_COLON] = ACTIONS(814),
    [anon_sym_DOLLAR] = ACTIONS(803),
    [anon_sym_AT] = ACTIONS(803),
    [aux_sym__hex_literal_token1] = ACTIONS(843),
    [sym__number_literal] = ACTIONS(846),
    [anon_sym_SQUOTE] = ACTIONS(849),
    [anon_sym_DQUOTE] = ACTIONS(852),
    [sym_return] = ACTIONS(855),
    [sym_next] = ACTIONS(855),
    [sym_break] = ACTIONS(855),
    [sym_true] = ACTIONS(855),
    [sym_false] = ACTIONS(855),
    [sym_null] = ACTIONS(855),
    [sym_inf] = ACTIONS(855),
    [sym_nan] = ACTIONS(855),
    [anon_sym_NA] = ACTIONS(858),
    [anon_sym_NA_integer_] = ACTIONS(858),
    [anon_sym_NA_real_] = ACTIONS(858),
    [anon_sym_NA_complex_] = ACTIONS(858),
    [anon_sym_NA_character_] = ACTIONS(858),
    [sym_dots] = ACTIONS(855),
    [sym_dot_dot_i] = ACTIONS(861),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(803),
    [sym__newline] = ACTIONS(864),
    [sym__semicolon] = ACTIONS(803),
    [sym__raw_string_literal] = ACTIONS(867),
    [sym__external_else] = ACTIONS(803),
    [sym__external_open_parenthesis] = ACTIONS(870),
    [sym__external_close_parenthesis] = ACTIONS(803),
    [sym__external_open_brace] = ACTIONS(873),
    [sym__external_close_brace] = ACTIONS(803),
    [sym__external_open_bracket] = ACTIONS(803),
    [sym__external_open_bracket2] = ACTIONS(803),
  },
  [59] = {
    [sym_function_definition] = STATE(770),
    [sym_if_statement] = STATE(770),
    [sym_for_statement] = STATE(770),
    [sym_while_statement] = STATE(770),
    [sym_repeat_statement] = STATE(770),
    [sym_braced_expression] = STATE(770),
    [sym_parenthesized_expression] = STATE(770),
    [sym_call] = STATE(770),
    [sym_subset] = STATE(770),
    [sym_subset2] = STATE(770),
    [sym_unary_operator] = STATE(770),
    [sym_binary_operator] = STATE(770),
    [sym_extract_operator] = STATE(770),
    [sym_namespace_operator] = STATE(770),
    [sym_integer] = STATE(770),
    [sym_complex] = STATE(770),
    [sym_float] = STATE(770),
    [sym__hex_literal] = STATE(2189),
    [sym__float_literal] = STATE(2189),
    [sym_string] = STATE(2192),
    [sym__single_quoted_string] = STATE(2188),
    [sym__double_quoted_string] = STATE(2187),
    [sym_na] = STATE(770),
    [sym__expression] = STATE(770),
    [sym__string_or_identifier] = STATE(5139),
    [sym__open_parenthesis] = STATE(57),
    [sym__open_brace] = STATE(59),
    [sym__close_brace] = STATE(2427),
    [aux_sym_braced_expression_repeat1] = STATE(93),
    [sym_identifier] = ACTIONS(273),
    [anon_sym_BSLASH] = ACTIONS(275),
    [anon_sym_function] = ACTIONS(277),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_for] = ACTIONS(281),
    [anon_sym_while] = ACTIONS(283),
    [anon_sym_repeat] = ACTIONS(285),
    [anon_sym_QMARK] = ACTIONS(287),
    [anon_sym_TILDE] = ACTIONS(289),
    [anon_sym_BANG] = ACTIONS(291),
    [anon_sym_PLUS] = ACTIONS(293),
    [anon_sym_DASH] = ACTIONS(295),
    [anon_sym_LT_DASH] = ACTIONS(155),
    [anon_sym_LT_LT_DASH] = ACTIONS(155),
    [anon_sym_COLON_EQ] = ACTIONS(155),
    [anon_sym_DASH_GT] = ACTIONS(157),
    [anon_sym_DASH_GT_GT] = ACTIONS(155),
    [anon_sym_PIPE] = ACTIONS(157),
    [anon_sym_AMP] = ACTIONS(157),
    [anon_sym_PIPE_PIPE] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(157),
    [anon_sym_LT_EQ] = ACTIONS(155),
    [anon_sym_GT] = ACTIONS(157),
    [anon_sym_GT_EQ] = ACTIONS(155),
    [anon_sym_EQ_EQ] = ACTIONS(155),
    [anon_sym_BANG_EQ] = ACTIONS(155),
    [anon_sym_STAR] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(155),
    [anon_sym_STAR_STAR] = ACTIONS(155),
    [anon_sym_CARET] = ACTIONS(155),
    [aux_sym_binary_operator_token1] = ACTIONS(155),
    [anon_sym_PIPE_GT] = ACTIONS(155),
    [anon_sym_COLON] = ACTIONS(157),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(155),
    [aux_sym__hex_literal_token1] = ACTIONS(297),
    [sym__number_literal] = ACTIONS(299),
    [anon_sym_SQUOTE] = ACTIONS(301),
    [anon_sym_DQUOTE] = ACTIONS(303),
    [sym_return] = ACTIONS(876),
    [sym_next] = ACTIONS(876),
    [sym_break] = ACTIONS(876),
    [sym_true] = ACTIONS(876),
    [sym_false] = ACTIONS(876),
    [sym_null] = ACTIONS(876),
    [sym_inf] = ACTIONS(876),
    [sym_nan] = ACTIONS(876),
    [anon_sym_NA] = ACTIONS(307),
    [anon_sym_NA_integer_] = ACTIONS(307),
    [anon_sym_NA_real_] = ACTIONS(307),
    [anon_sym_NA_complex_] = ACTIONS(307),
    [anon_sym_NA_character_] = ACTIONS(307),
    [sym_dots] = ACTIONS(876),
    [sym_dot_dot_i] = ACTIONS(878),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(155),
    [sym__newline] = ACTIONS(880),
    [sym__semicolon] = ACTIONS(880),
    [sym__raw_string_literal] = ACTIONS(313),
    [sym__external_open_parenthesis] = ACTIONS(315),
    [sym__external_close_parenthesis] = ACTIONS(155),
    [sym__external_open_brace] = ACTIONS(319),
    [sym__external_close_brace] = ACTIONS(882),
    [sym__external_open_bracket] = ACTIONS(155),
    [sym__external_close_bracket] = ACTIONS(155),
    [sym__external_open_bracket2] = ACTIONS(155),
  },
  [60] = {
    [sym_function_definition] = STATE(589),
    [sym_if_statement] = STATE(589),
    [sym_for_statement] = STATE(589),
    [sym_while_statement] = STATE(589),
    [sym_repeat_statement] = STATE(589),
    [sym_braced_expression] = STATE(589),
    [sym_parenthesized_expression] = STATE(589),
    [sym_call] = STATE(589),
    [sym_subset] = STATE(589),
    [sym_subset2] = STATE(589),
    [sym_unary_operator] = STATE(589),
    [sym_binary_operator] = STATE(589),
    [sym_extract_operator] = STATE(589),
    [sym_namespace_operator] = STATE(589),
    [sym_integer] = STATE(589),
    [sym_complex] = STATE(589),
    [sym_float] = STATE(589),
    [sym__hex_literal] = STATE(2021),
    [sym__float_literal] = STATE(2021),
    [sym_string] = STATE(2016),
    [sym__single_quoted_string] = STATE(2027),
    [sym__double_quoted_string] = STATE(2041),
    [sym_na] = STATE(589),
    [sym__expression] = STATE(589),
    [sym__string_or_identifier] = STATE(5131),
    [sym__open_parenthesis] = STATE(20),
    [sym__open_brace] = STATE(10),
    [aux_sym_function_definition_repeat1] = STATE(2199),
    [sym_identifier] = ACTIONS(103),
    [anon_sym_BSLASH] = ACTIONS(105),
    [anon_sym_function] = ACTIONS(107),
    [anon_sym_EQ] = ACTIONS(759),
    [anon_sym_if] = ACTIONS(111),
    [anon_sym_for] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_repeat] = ACTIONS(117),
    [anon_sym_QMARK] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_BANG] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(125),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_LT_DASH] = ACTIONS(757),
    [anon_sym_LT_LT_DASH] = ACTIONS(757),
    [anon_sym_COLON_EQ] = ACTIONS(757),
    [anon_sym_DASH_GT] = ACTIONS(759),
    [anon_sym_DASH_GT_GT] = ACTIONS(757),
    [anon_sym_PIPE] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(759),
    [anon_sym_PIPE_PIPE] = ACTIONS(757),
    [anon_sym_AMP_AMP] = ACTIONS(757),
    [anon_sym_LT] = ACTIONS(759),
    [anon_sym_LT_EQ] = ACTIONS(757),
    [anon_sym_GT] = ACTIONS(759),
    [anon_sym_GT_EQ] = ACTIONS(757),
    [anon_sym_EQ_EQ] = ACTIONS(757),
    [anon_sym_BANG_EQ] = ACTIONS(757),
    [anon_sym_STAR] = ACTIONS(759),
    [anon_sym_SLASH] = ACTIONS(757),
    [anon_sym_STAR_STAR] = ACTIONS(757),
    [anon_sym_CARET] = ACTIONS(757),
    [aux_sym_binary_operator_token1] = ACTIONS(757),
    [anon_sym_PIPE_GT] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(759),
    [anon_sym_DOLLAR] = ACTIONS(757),
    [anon_sym_AT] = ACTIONS(757),
    [aux_sym__hex_literal_token1] = ACTIONS(131),
    [sym__number_literal] = ACTIONS(133),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(137),
    [sym_return] = ACTIONS(884),
    [sym_next] = ACTIONS(884),
    [sym_break] = ACTIONS(884),
    [sym_true] = ACTIONS(884),
    [sym_false] = ACTIONS(884),
    [sym_null] = ACTIONS(884),
    [sym_inf] = ACTIONS(884),
    [sym_nan] = ACTIONS(884),
    [anon_sym_NA] = ACTIONS(141),
    [anon_sym_NA_integer_] = ACTIONS(141),
    [anon_sym_NA_real_] = ACTIONS(141),
    [anon_sym_NA_complex_] = ACTIONS(141),
    [anon_sym_NA_character_] = ACTIONS(141),
    [sym_dots] = ACTIONS(884),
    [sym_dot_dot_i] = ACTIONS(886),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(757),
    [sym__newline] = ACTIONS(757),
    [sym__semicolon] = ACTIONS(757),
    [sym__raw_string_literal] = ACTIONS(147),
    [sym__external_else] = ACTIONS(757),
    [sym__external_open_parenthesis] = ACTIONS(149),
    [sym__external_close_parenthesis] = ACTIONS(757),
    [sym__external_open_brace] = ACTIONS(153),
    [sym__external_close_brace] = ACTIONS(757),
    [sym__external_open_bracket] = ACTIONS(757),
    [sym__external_close_bracket] = ACTIONS(757),
    [sym__external_open_bracket2] = ACTIONS(757),
  },
  [61] = {
    [sym_function_definition] = STATE(770),
    [sym_if_statement] = STATE(770),
    [sym_for_statement] = STATE(770),
    [sym_while_statement] = STATE(770),
    [sym_repeat_statement] = STATE(770),
    [sym_braced_expression] = STATE(770),
    [sym_parenthesized_expression] = STATE(770),
    [sym_call] = STATE(770),
    [sym_subset] = STATE(770),
    [sym_subset2] = STATE(770),
    [sym_unary_operator] = STATE(770),
    [sym_binary_operator] = STATE(770),
    [sym_extract_operator] = STATE(770),
    [sym_namespace_operator] = STATE(770),
    [sym_integer] = STATE(770),
    [sym_complex] = STATE(770),
    [sym_float] = STATE(770),
    [sym__hex_literal] = STATE(2189),
    [sym__float_literal] = STATE(2189),
    [sym_string] = STATE(2192),
    [sym__single_quoted_string] = STATE(2188),
    [sym__double_quoted_string] = STATE(2187),
    [sym_na] = STATE(770),
    [sym__expression] = STATE(770),
    [sym__string_or_identifier] = STATE(5139),
    [sym__open_parenthesis] = STATE(57),
    [sym__open_brace] = STATE(59),
    [sym__close_brace] = STATE(2760),
    [aux_sym_braced_expression_repeat1] = STATE(110),
    [sym_identifier] = ACTIONS(273),
    [anon_sym_BSLASH] = ACTIONS(275),
    [anon_sym_function] = ACTIONS(277),
    [anon_sym_EQ] = ACTIONS(59),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_for] = ACTIONS(281),
    [anon_sym_while] = ACTIONS(283),
    [anon_sym_repeat] = ACTIONS(285),
    [anon_sym_QMARK] = ACTIONS(287),
    [anon_sym_TILDE] = ACTIONS(289),
    [anon_sym_BANG] = ACTIONS(291),
    [anon_sym_PLUS] = ACTIONS(293),
    [anon_sym_DASH] = ACTIONS(295),
    [anon_sym_LT_DASH] = ACTIONS(51),
    [anon_sym_LT_LT_DASH] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(51),
    [anon_sym_DASH_GT] = ACTIONS(59),
    [anon_sym_DASH_GT_GT] = ACTIONS(51),
    [anon_sym_PIPE] = ACTIONS(59),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_AMP_AMP] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(59),
    [anon_sym_LT_EQ] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(59),
    [anon_sym_GT_EQ] = ACTIONS(51),
    [anon_sym_EQ_EQ] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(51),
    [anon_sym_CARET] = ACTIONS(51),
    [aux_sym_binary_operator_token1] = ACTIONS(51),
    [anon_sym_PIPE_GT] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(59),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_AT] = ACTIONS(51),
    [aux_sym__hex_literal_token1] = ACTIONS(297),
    [sym__number_literal] = ACTIONS(299),
    [anon_sym_SQUOTE] = ACTIONS(301),
    [anon_sym_DQUOTE] = ACTIONS(303),
    [sym_return] = ACTIONS(876),
    [sym_next] = ACTIONS(876),
    [sym_break] = ACTIONS(876),
    [sym_true] = ACTIONS(876),
    [sym_false] = ACTIONS(876),
    [sym_null] = ACTIONS(876),
    [sym_inf] = ACTIONS(876),
    [sym_nan] = ACTIONS(876),
    [anon_sym_NA] = ACTIONS(307),
    [anon_sym_NA_integer_] = ACTIONS(307),
    [anon_sym_NA_real_] = ACTIONS(307),
    [anon_sym_NA_complex_] = ACTIONS(307),
    [anon_sym_NA_character_] = ACTIONS(307),
    [sym_dots] = ACTIONS(876),
    [sym_dot_dot_i] = ACTIONS(878),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(51),
    [sym__newline] = ACTIONS(880),
    [sym__semicolon] = ACTIONS(880),
    [sym__raw_string_literal] = ACTIONS(313),
    [sym__external_open_parenthesis] = ACTIONS(315),
    [sym__external_close_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(319),
    [sym__external_close_brace] = ACTIONS(888),
    [sym__external_open_bracket] = ACTIONS(51),
    [sym__external_close_bracket] = ACTIONS(51),
    [sym__external_open_bracket2] = ACTIONS(51),
  },
  [62] = {
    [sym_function_definition] = STATE(935),
    [sym_if_statement] = STATE(935),
    [sym_for_statement] = STATE(935),
    [sym_while_statement] = STATE(935),
    [sym_repeat_statement] = STATE(935),
    [sym_braced_expression] = STATE(935),
    [sym_parenthesized_expression] = STATE(935),
    [sym_call] = STATE(935),
    [sym_subset] = STATE(935),
    [sym_subset2] = STATE(935),
    [sym_unary_operator] = STATE(935),
    [sym_binary_operator] = STATE(935),
    [sym_extract_operator] = STATE(935),
    [sym_namespace_operator] = STATE(935),
    [sym_integer] = STATE(935),
    [sym_complex] = STATE(935),
    [sym_float] = STATE(935),
    [sym__hex_literal] = STATE(2220),
    [sym__float_literal] = STATE(2220),
    [sym_string] = STATE(2219),
    [sym__single_quoted_string] = STATE(2221),
    [sym__double_quoted_string] = STATE(2222),
    [sym_na] = STATE(935),
    [sym__expression] = STATE(935),
    [sym__string_or_identifier] = STATE(5140),
    [sym__open_parenthesis] = STATE(54),
    [sym__close_parenthesis] = STATE(2708),
    [sym__open_brace] = STATE(56),
    [aux_sym_parenthesized_expression_repeat1] = STATE(138),
    [sym_identifier] = ACTIONS(626),
    [anon_sym_BSLASH] = ACTIONS(628),
    [anon_sym_function] = ACTIONS(630),
    [anon_sym_EQ] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [anon_sym_repeat] = ACTIONS(638),
    [anon_sym_QMARK] = ACTIONS(640),
    [anon_sym_TILDE] = ACTIONS(642),
    [anon_sym_BANG] = ACTIONS(644),
    [anon_sym_PLUS] = ACTIONS(646),
    [anon_sym_DASH] = ACTIONS(648),
    [anon_sym_LT_DASH] = ACTIONS(211),
    [anon_sym_LT_LT_DASH] = ACTIONS(211),
    [anon_sym_COLON_EQ] = ACTIONS(211),
    [anon_sym_DASH_GT] = ACTIONS(209),
    [anon_sym_DASH_GT_GT] = ACTIONS(211),
    [anon_sym_PIPE] = ACTIONS(209),
    [anon_sym_AMP] = ACTIONS(209),
    [anon_sym_PIPE_PIPE] = ACTIONS(211),
    [anon_sym_AMP_AMP] = ACTIONS(211),
    [anon_sym_LT] = ACTIONS(209),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_GT] = ACTIONS(209),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [anon_sym_EQ_EQ] = ACTIONS(211),
    [anon_sym_BANG_EQ] = ACTIONS(211),
    [anon_sym_STAR] = ACTIONS(209),
    [anon_sym_SLASH] = ACTIONS(211),
    [anon_sym_STAR_STAR] = ACTIONS(211),
    [anon_sym_CARET] = ACTIONS(211),
    [aux_sym_binary_operator_token1] = ACTIONS(211),
    [anon_sym_PIPE_GT] = ACTIONS(211),
    [anon_sym_COLON] = ACTIONS(209),
    [anon_sym_DOLLAR] = ACTIONS(211),
    [anon_sym_AT] = ACTIONS(211),
    [aux_sym__hex_literal_token1] = ACTIONS(650),
    [sym__number_literal] = ACTIONS(652),
    [anon_sym_SQUOTE] = ACTIONS(654),
    [anon_sym_DQUOTE] = ACTIONS(656),
    [sym_return] = ACTIONS(747),
    [sym_next] = ACTIONS(747),
    [sym_break] = ACTIONS(747),
    [sym_true] = ACTIONS(747),
    [sym_false] = ACTIONS(747),
    [sym_null] = ACTIONS(747),
    [sym_inf] = ACTIONS(747),
    [sym_nan] = ACTIONS(747),
    [anon_sym_NA] = ACTIONS(660),
    [anon_sym_NA_integer_] = ACTIONS(660),
    [anon_sym_NA_real_] = ACTIONS(660),
    [anon_sym_NA_complex_] = ACTIONS(660),
    [anon_sym_NA_character_] = ACTIONS(660),
    [sym_dots] = ACTIONS(747),
    [sym_dot_dot_i] = ACTIONS(749),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(211),
    [sym__newline] = ACTIONS(751),
    [sym__semicolon] = ACTIONS(211),
    [sym__raw_string_literal] = ACTIONS(666),
    [sym__external_open_parenthesis] = ACTIONS(668),
    [sym__external_close_parenthesis] = ACTIONS(890),
    [sym__external_open_brace] = ACTIONS(670),
    [sym__external_close_brace] = ACTIONS(211),
    [sym__external_open_bracket] = ACTIONS(211),
    [sym__external_open_bracket2] = ACTIONS(211),
    [sym__external_close_bracket2] = ACTIONS(211),
  },
  [63] = {
    [sym_function_definition] = STATE(796),
    [sym_if_statement] = STATE(796),
    [sym_for_statement] = STATE(796),
    [sym_while_statement] = STATE(796),
    [sym_repeat_statement] = STATE(796),
    [sym_braced_expression] = STATE(796),
    [sym_parenthesized_expression] = STATE(796),
    [sym_call] = STATE(796),
    [sym_subset] = STATE(796),
    [sym_subset2] = STATE(796),
    [sym_unary_operator] = STATE(796),
    [sym_binary_operator] = STATE(796),
    [sym_extract_operator] = STATE(796),
    [sym_namespace_operator] = STATE(796),
    [sym_integer] = STATE(796),
    [sym_complex] = STATE(796),
    [sym_float] = STATE(796),
    [sym__hex_literal] = STATE(2206),
    [sym__float_literal] = STATE(2206),
    [sym_string] = STATE(2166),
    [sym__single_quoted_string] = STATE(2200),
    [sym__double_quoted_string] = STATE(2201),
    [sym_na] = STATE(796),
    [sym__expression] = STATE(796),
    [sym__string_or_identifier] = STATE(5154),
    [sym__open_parenthesis] = STATE(3),
    [sym__open_brace] = STATE(45),
    [sym__close_brace] = STATE(2896),
    [aux_sym_braced_expression_repeat1] = STATE(34),
    [sym_identifier] = ACTIONS(481),
    [anon_sym_BSLASH] = ACTIONS(483),
    [anon_sym_function] = ACTIONS(485),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(487),
    [anon_sym_for] = ACTIONS(489),
    [anon_sym_while] = ACTIONS(491),
    [anon_sym_repeat] = ACTIONS(493),
    [anon_sym_QMARK] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(503),
    [anon_sym_LT_DASH] = ACTIONS(155),
    [anon_sym_LT_LT_DASH] = ACTIONS(155),
    [anon_sym_COLON_EQ] = ACTIONS(155),
    [anon_sym_DASH_GT] = ACTIONS(157),
    [anon_sym_DASH_GT_GT] = ACTIONS(155),
    [anon_sym_PIPE] = ACTIONS(157),
    [anon_sym_AMP] = ACTIONS(157),
    [anon_sym_PIPE_PIPE] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(157),
    [anon_sym_LT_EQ] = ACTIONS(155),
    [anon_sym_GT] = ACTIONS(157),
    [anon_sym_GT_EQ] = ACTIONS(155),
    [anon_sym_EQ_EQ] = ACTIONS(155),
    [anon_sym_BANG_EQ] = ACTIONS(155),
    [anon_sym_STAR] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(155),
    [anon_sym_STAR_STAR] = ACTIONS(155),
    [anon_sym_CARET] = ACTIONS(155),
    [aux_sym_binary_operator_token1] = ACTIONS(155),
    [anon_sym_PIPE_GT] = ACTIONS(155),
    [anon_sym_COLON] = ACTIONS(157),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(155),
    [aux_sym__hex_literal_token1] = ACTIONS(505),
    [sym__number_literal] = ACTIONS(507),
    [anon_sym_SQUOTE] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(511),
    [sym_return] = ACTIONS(513),
    [sym_next] = ACTIONS(513),
    [sym_break] = ACTIONS(513),
    [sym_true] = ACTIONS(513),
    [sym_false] = ACTIONS(513),
    [sym_null] = ACTIONS(513),
    [sym_inf] = ACTIONS(513),
    [sym_nan] = ACTIONS(513),
    [anon_sym_NA] = ACTIONS(515),
    [anon_sym_NA_integer_] = ACTIONS(515),
    [anon_sym_NA_real_] = ACTIONS(515),
    [anon_sym_NA_complex_] = ACTIONS(515),
    [anon_sym_NA_character_] = ACTIONS(515),
    [sym_dots] = ACTIONS(513),
    [sym_dot_dot_i] = ACTIONS(517),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(155),
    [sym__newline] = ACTIONS(519),
    [sym__semicolon] = ACTIONS(519),
    [sym__raw_string_literal] = ACTIONS(521),
    [sym__external_else] = ACTIONS(155),
    [sym__external_open_parenthesis] = ACTIONS(523),
    [sym__external_open_brace] = ACTIONS(525),
    [sym__external_close_brace] = ACTIONS(892),
    [sym__external_open_bracket] = ACTIONS(155),
    [sym__external_close_bracket] = ACTIONS(155),
    [sym__external_open_bracket2] = ACTIONS(155),
  },
  [64] = {
    [sym_function_definition] = STATE(575),
    [sym_if_statement] = STATE(575),
    [sym_for_statement] = STATE(575),
    [sym_while_statement] = STATE(575),
    [sym_repeat_statement] = STATE(575),
    [sym_braced_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(575),
    [sym_call] = STATE(575),
    [sym_subset] = STATE(575),
    [sym_subset2] = STATE(575),
    [sym_unary_operator] = STATE(575),
    [sym_binary_operator] = STATE(575),
    [sym_extract_operator] = STATE(575),
    [sym_namespace_operator] = STATE(575),
    [sym_integer] = STATE(575),
    [sym_complex] = STATE(575),
    [sym_float] = STATE(575),
    [sym__hex_literal] = STATE(1984),
    [sym__float_literal] = STATE(1984),
    [sym_string] = STATE(1982),
    [sym__single_quoted_string] = STATE(1985),
    [sym__double_quoted_string] = STATE(1990),
    [sym_na] = STATE(575),
    [sym__expression] = STATE(575),
    [sym__string_or_identifier] = STATE(5151),
    [sym__open_parenthesis] = STATE(19),
    [sym__close_parenthesis] = STATE(2581),
    [sym__open_brace] = STATE(4),
    [aux_sym_parenthesized_expression_repeat1] = STATE(37),
    [ts_builtin_sym_end] = ACTIONS(129),
    [sym_identifier] = ACTIONS(53),
    [anon_sym_BSLASH] = ACTIONS(55),
    [anon_sym_function] = ACTIONS(57),
    [anon_sym_EQ] = ACTIONS(109),
    [anon_sym_if] = ACTIONS(61),
    [anon_sym_for] = ACTIONS(63),
    [anon_sym_while] = ACTIONS(65),
    [anon_sym_repeat] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_LT_DASH] = ACTIONS(129),
    [anon_sym_LT_LT_DASH] = ACTIONS(129),
    [anon_sym_COLON_EQ] = ACTIONS(129),
    [anon_sym_DASH_GT] = ACTIONS(109),
    [anon_sym_DASH_GT_GT] = ACTIONS(129),
    [anon_sym_PIPE] = ACTIONS(109),
    [anon_sym_AMP] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_STAR_STAR] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [aux_sym_binary_operator_token1] = ACTIONS(129),
    [anon_sym_PIPE_GT] = ACTIONS(129),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(129),
    [anon_sym_AT] = ACTIONS(129),
    [aux_sym__hex_literal_token1] = ACTIONS(79),
    [sym__number_literal] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_return] = ACTIONS(251),
    [sym_next] = ACTIONS(251),
    [sym_break] = ACTIONS(251),
    [sym_true] = ACTIONS(251),
    [sym_false] = ACTIONS(251),
    [sym_null] = ACTIONS(251),
    [sym_inf] = ACTIONS(251),
    [sym_nan] = ACTIONS(251),
    [anon_sym_NA] = ACTIONS(89),
    [anon_sym_NA_integer_] = ACTIONS(89),
    [anon_sym_NA_real_] = ACTIONS(89),
    [anon_sym_NA_complex_] = ACTIONS(89),
    [anon_sym_NA_character_] = ACTIONS(89),
    [sym_dots] = ACTIONS(251),
    [sym_dot_dot_i] = ACTIONS(253),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(255),
    [sym__semicolon] = ACTIONS(129),
    [sym__raw_string_literal] = ACTIONS(95),
    [sym__external_else] = ACTIONS(129),
    [sym__external_open_parenthesis] = ACTIONS(97),
    [sym__external_close_parenthesis] = ACTIONS(894),
    [sym__external_open_brace] = ACTIONS(99),
    [sym__external_close_brace] = ACTIONS(129),
    [sym__external_open_bracket] = ACTIONS(129),
    [sym__external_open_bracket2] = ACTIONS(129),
  },
  [65] = {
    [sym_function_definition] = STATE(603),
    [sym_if_statement] = STATE(603),
    [sym_for_statement] = STATE(603),
    [sym_while_statement] = STATE(603),
    [sym_repeat_statement] = STATE(603),
    [sym_braced_expression] = STATE(603),
    [sym_parenthesized_expression] = STATE(603),
    [sym_call] = STATE(603),
    [sym_subset] = STATE(603),
    [sym_subset2] = STATE(603),
    [sym_unary_operator] = STATE(603),
    [sym_binary_operator] = STATE(603),
    [sym_extract_operator] = STATE(603),
    [sym_namespace_operator] = STATE(603),
    [sym_integer] = STATE(603),
    [sym_complex] = STATE(603),
    [sym_float] = STATE(603),
    [sym__hex_literal] = STATE(2021),
    [sym__float_literal] = STATE(2021),
    [sym_string] = STATE(2016),
    [sym__single_quoted_string] = STATE(2027),
    [sym__double_quoted_string] = STATE(2041),
    [sym_na] = STATE(603),
    [sym__expression] = STATE(603),
    [sym__string_or_identifier] = STATE(5131),
    [sym__open_parenthesis] = STATE(20),
    [sym__open_brace] = STATE(10),
    [aux_sym_function_definition_repeat1] = STATE(71),
    [sym_identifier] = ACTIONS(103),
    [anon_sym_BSLASH] = ACTIONS(105),
    [anon_sym_function] = ACTIONS(107),
    [anon_sym_EQ] = ACTIONS(533),
    [anon_sym_if] = ACTIONS(111),
    [anon_sym_for] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_repeat] = ACTIONS(117),
    [anon_sym_QMARK] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_BANG] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(125),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_LT_DASH] = ACTIONS(531),
    [anon_sym_LT_LT_DASH] = ACTIONS(531),
    [anon_sym_COLON_EQ] = ACTIONS(531),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_DASH_GT_GT] = ACTIONS(531),
    [anon_sym_PIPE] = ACTIONS(533),
    [anon_sym_AMP] = ACTIONS(533),
    [anon_sym_PIPE_PIPE] = ACTIONS(531),
    [anon_sym_AMP_AMP] = ACTIONS(531),
    [anon_sym_LT] = ACTIONS(533),
    [anon_sym_LT_EQ] = ACTIONS(531),
    [anon_sym_GT] = ACTIONS(533),
    [anon_sym_GT_EQ] = ACTIONS(531),
    [anon_sym_EQ_EQ] = ACTIONS(531),
    [anon_sym_BANG_EQ] = ACTIONS(531),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_SLASH] = ACTIONS(531),
    [anon_sym_STAR_STAR] = ACTIONS(531),
    [anon_sym_CARET] = ACTIONS(531),
    [aux_sym_binary_operator_token1] = ACTIONS(531),
    [anon_sym_PIPE_GT] = ACTIONS(531),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_DOLLAR] = ACTIONS(531),
    [anon_sym_AT] = ACTIONS(531),
    [aux_sym__hex_literal_token1] = ACTIONS(131),
    [sym__number_literal] = ACTIONS(133),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(137),
    [sym_return] = ACTIONS(896),
    [sym_next] = ACTIONS(896),
    [sym_break] = ACTIONS(896),
    [sym_true] = ACTIONS(896),
    [sym_false] = ACTIONS(896),
    [sym_null] = ACTIONS(896),
    [sym_inf] = ACTIONS(896),
    [sym_nan] = ACTIONS(896),
    [anon_sym_NA] = ACTIONS(141),
    [anon_sym_NA_integer_] = ACTIONS(141),
    [anon_sym_NA_real_] = ACTIONS(141),
    [anon_sym_NA_complex_] = ACTIONS(141),
    [anon_sym_NA_character_] = ACTIONS(141),
    [sym_dots] = ACTIONS(896),
    [sym_dot_dot_i] = ACTIONS(898),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(531),
    [sym__newline] = ACTIONS(900),
    [sym__semicolon] = ACTIONS(531),
    [sym__raw_string_literal] = ACTIONS(147),
    [sym__external_else] = ACTIONS(531),
    [sym__external_open_parenthesis] = ACTIONS(149),
    [sym__external_close_parenthesis] = ACTIONS(531),
    [sym__external_open_brace] = ACTIONS(153),
    [sym__external_close_brace] = ACTIONS(531),
    [sym__external_open_bracket] = ACTIONS(531),
    [sym__external_close_bracket] = ACTIONS(531),
    [sym__external_open_bracket2] = ACTIONS(531),
  },
  [66] = {
    [sym_function_definition] = STATE(599),
    [sym_if_statement] = STATE(599),
    [sym_for_statement] = STATE(599),
    [sym_while_statement] = STATE(599),
    [sym_repeat_statement] = STATE(599),
    [sym_braced_expression] = STATE(599),
    [sym_parenthesized_expression] = STATE(599),
    [sym_call] = STATE(599),
    [sym_subset] = STATE(599),
    [sym_subset2] = STATE(599),
    [sym_unary_operator] = STATE(599),
    [sym_binary_operator] = STATE(599),
    [sym_extract_operator] = STATE(599),
    [sym_namespace_operator] = STATE(599),
    [sym_integer] = STATE(599),
    [sym_complex] = STATE(599),
    [sym_float] = STATE(599),
    [sym__hex_literal] = STATE(1984),
    [sym__float_literal] = STATE(1984),
    [sym_string] = STATE(1982),
    [sym__single_quoted_string] = STATE(1985),
    [sym__double_quoted_string] = STATE(1990),
    [sym_na] = STATE(599),
    [sym__expression] = STATE(599),
    [sym__string_or_identifier] = STATE(5151),
    [sym__open_parenthesis] = STATE(19),
    [sym__open_brace] = STATE(4),
    [aux_sym_braced_expression_repeat1] = STATE(66),
    [ts_builtin_sym_end] = ACTIONS(591),
    [sym_identifier] = ACTIONS(902),
    [anon_sym_BSLASH] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(908),
    [anon_sym_EQ] = ACTIONS(562),
    [anon_sym_if] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(914),
    [anon_sym_while] = ACTIONS(917),
    [anon_sym_repeat] = ACTIONS(920),
    [anon_sym_QMARK] = ACTIONS(923),
    [anon_sym_TILDE] = ACTIONS(926),
    [anon_sym_BANG] = ACTIONS(929),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_DASH] = ACTIONS(935),
    [anon_sym_LT_DASH] = ACTIONS(591),
    [anon_sym_LT_LT_DASH] = ACTIONS(591),
    [anon_sym_COLON_EQ] = ACTIONS(591),
    [anon_sym_DASH_GT] = ACTIONS(562),
    [anon_sym_DASH_GT_GT] = ACTIONS(591),
    [anon_sym_PIPE] = ACTIONS(562),
    [anon_sym_AMP] = ACTIONS(562),
    [anon_sym_PIPE_PIPE] = ACTIONS(591),
    [anon_sym_AMP_AMP] = ACTIONS(591),
    [anon_sym_LT] = ACTIONS(562),
    [anon_sym_LT_EQ] = ACTIONS(591),
    [anon_sym_GT] = ACTIONS(562),
    [anon_sym_GT_EQ] = ACTIONS(591),
    [anon_sym_EQ_EQ] = ACTIONS(591),
    [anon_sym_BANG_EQ] = ACTIONS(591),
    [anon_sym_STAR] = ACTIONS(562),
    [anon_sym_SLASH] = ACTIONS(591),
    [anon_sym_STAR_STAR] = ACTIONS(591),
    [anon_sym_CARET] = ACTIONS(591),
    [aux_sym_binary_operator_token1] = ACTIONS(591),
    [anon_sym_PIPE_GT] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(562),
    [anon_sym_DOLLAR] = ACTIONS(591),
    [anon_sym_AT] = ACTIONS(591),
    [aux_sym__hex_literal_token1] = ACTIONS(938),
    [sym__number_literal] = ACTIONS(941),
    [anon_sym_SQUOTE] = ACTIONS(944),
    [anon_sym_DQUOTE] = ACTIONS(947),
    [sym_return] = ACTIONS(950),
    [sym_next] = ACTIONS(950),
    [sym_break] = ACTIONS(950),
    [sym_true] = ACTIONS(950),
    [sym_false] = ACTIONS(950),
    [sym_null] = ACTIONS(950),
    [sym_inf] = ACTIONS(950),
    [sym_nan] = ACTIONS(950),
    [anon_sym_NA] = ACTIONS(953),
    [anon_sym_NA_integer_] = ACTIONS(953),
    [anon_sym_NA_real_] = ACTIONS(953),
    [anon_sym_NA_complex_] = ACTIONS(953),
    [anon_sym_NA_character_] = ACTIONS(953),
    [sym_dots] = ACTIONS(950),
    [sym_dot_dot_i] = ACTIONS(956),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(591),
    [sym__newline] = ACTIONS(959),
    [sym__semicolon] = ACTIONS(959),
    [sym__raw_string_literal] = ACTIONS(962),
    [sym__external_else] = ACTIONS(591),
    [sym__external_open_parenthesis] = ACTIONS(965),
    [sym__external_close_parenthesis] = ACTIONS(591),
    [sym__external_open_brace] = ACTIONS(968),
    [sym__external_close_brace] = ACTIONS(591),
    [sym__external_open_bracket] = ACTIONS(591),
    [sym__external_open_bracket2] = ACTIONS(591),
  },
  [67] = {
    [sym_function_definition] = STATE(791),
    [sym_if_statement] = STATE(791),
    [sym_for_statement] = STATE(791),
    [sym_while_statement] = STATE(791),
    [sym_repeat_statement] = STATE(791),
    [sym_braced_expression] = STATE(791),
    [sym_parenthesized_expression] = STATE(791),
    [sym_call] = STATE(791),
    [sym_subset] = STATE(791),
    [sym_subset2] = STATE(791),
    [sym_unary_operator] = STATE(791),
    [sym_binary_operator] = STATE(791),
    [sym_extract_operator] = STATE(791),
    [sym_namespace_operator] = STATE(791),
    [sym_integer] = STATE(791),
    [sym_complex] = STATE(791),
    [sym_float] = STATE(791),
    [sym__hex_literal] = STATE(2183),
    [sym__float_literal] = STATE(2183),
    [sym_string] = STATE(2169),
    [sym__single_quoted_string] = STATE(2181),
    [sym__double_quoted_string] = STATE(2180),
    [sym_na] = STATE(791),
    [sym__expression] = STATE(791),
    [sym__string_or_identifier] = STATE(5149),
    [sym__open_parenthesis] = STATE(67),
    [sym__close_parenthesis] = STATE(2493),
    [sym__open_brace] = STATE(24),
    [aux_sym_parenthesized_expression_repeat1] = STATE(84),
    [ts_builtin_sym_end] = ACTIONS(129),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_BSLASH] = ACTIONS(323),
    [anon_sym_function] = ACTIONS(325),
    [anon_sym_EQ] = ACTIONS(109),
    [anon_sym_if] = ACTIONS(327),
    [anon_sym_for] = ACTIONS(329),
    [anon_sym_while] = ACTIONS(331),
    [anon_sym_repeat] = ACTIONS(333),
    [anon_sym_QMARK] = ACTIONS(335),
    [anon_sym_TILDE] = ACTIONS(337),
    [anon_sym_BANG] = ACTIONS(339),
    [anon_sym_PLUS] = ACTIONS(341),
    [anon_sym_DASH] = ACTIONS(343),
    [anon_sym_LT_DASH] = ACTIONS(129),
    [anon_sym_LT_LT_DASH] = ACTIONS(129),
    [anon_sym_COLON_EQ] = ACTIONS(129),
    [anon_sym_DASH_GT] = ACTIONS(109),
    [anon_sym_DASH_GT_GT] = ACTIONS(129),
    [anon_sym_PIPE] = ACTIONS(109),
    [anon_sym_AMP] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_STAR_STAR] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [aux_sym_binary_operator_token1] = ACTIONS(129),
    [anon_sym_PIPE_GT] = ACTIONS(129),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(129),
    [anon_sym_AT] = ACTIONS(129),
    [aux_sym__hex_literal_token1] = ACTIONS(345),
    [sym__number_literal] = ACTIONS(347),
    [anon_sym_SQUOTE] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(351),
    [sym_return] = ACTIONS(971),
    [sym_next] = ACTIONS(971),
    [sym_break] = ACTIONS(971),
    [sym_true] = ACTIONS(971),
    [sym_false] = ACTIONS(971),
    [sym_null] = ACTIONS(971),
    [sym_inf] = ACTIONS(971),
    [sym_nan] = ACTIONS(971),
    [anon_sym_NA] = ACTIONS(355),
    [anon_sym_NA_integer_] = ACTIONS(355),
    [anon_sym_NA_real_] = ACTIONS(355),
    [anon_sym_NA_complex_] = ACTIONS(355),
    [anon_sym_NA_character_] = ACTIONS(355),
    [sym_dots] = ACTIONS(971),
    [sym_dot_dot_i] = ACTIONS(973),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(129),
    [sym__newline] = ACTIONS(975),
    [sym__semicolon] = ACTIONS(129),
    [sym__raw_string_literal] = ACTIONS(361),
    [sym__external_open_parenthesis] = ACTIONS(363),
    [sym__external_close_parenthesis] = ACTIONS(977),
    [sym__external_open_brace] = ACTIONS(365),
    [sym__external_close_brace] = ACTIONS(129),
    [sym__external_open_bracket] = ACTIONS(129),
    [sym__external_open_bracket2] = ACTIONS(129),
  },
  [68] = {
    [sym_function_definition] = STATE(790),
    [sym_if_statement] = STATE(790),
    [sym_for_statement] = STATE(790),
    [sym_while_statement] = STATE(790),
    [sym_repeat_statement] = STATE(790),
    [sym_braced_expression] = STATE(790),
    [sym_parenthesized_expression] = STATE(790),
    [sym_call] = STATE(790),
    [sym_subset] = STATE(790),
    [sym_subset2] = STATE(790),
    [sym_unary_operator] = STATE(790),
    [sym_binary_operator] = STATE(790),
    [sym_extract_operator] = STATE(790),
    [sym_namespace_operator] = STATE(790),
    [sym_integer] = STATE(790),
    [sym_complex] = STATE(790),
    [sym_float] = STATE(790),
    [sym__hex_literal] = STATE(2183),
    [sym__float_literal] = STATE(2183),
    [sym_string] = STATE(2169),
    [sym__single_quoted_string] = STATE(2181),
    [sym__double_quoted_string] = STATE(2180),
    [sym_na] = STATE(790),
    [sym__expression] = STATE(790),
    [sym__string_or_identifier] = STATE(5149),
    [sym__open_parenthesis] = STATE(67),
    [sym__open_brace] = STATE(24),
    [sym__close_brace] = STATE(2469),
    [aux_sym_braced_expression_repeat1] = STATE(145),
    [ts_builtin_sym_end] = ACTIONS(51),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_BSLASH] = ACTIONS(323),
    [anon_sym_function] = ACTIONS(325),
    [anon_sym_EQ] = ACTIONS(59),
    [anon_sym_if] = ACTIONS(327),
    [anon_sym_for] = ACTIONS(329),
    [anon_sym_while] = ACTIONS(331),
    [anon_sym_repeat] = ACTIONS(333),
    [anon_sym_QMARK] = ACTIONS(335),
    [anon_sym_TILDE] = ACTIONS(337),
    [anon_sym_BANG] = ACTIONS(339),
    [anon_sym_PLUS] = ACTIONS(341),
    [anon_sym_DASH] = ACTIONS(343),
    [anon_sym_LT_DASH] = ACTIONS(51),
    [anon_sym_LT_LT_DASH] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(51),
    [anon_sym_DASH_GT] = ACTIONS(59),
    [anon_sym_DASH_GT_GT] = ACTIONS(51),
    [anon_sym_PIPE] = ACTIONS(59),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_AMP_AMP] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(59),
    [anon_sym_LT_EQ] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(59),
    [anon_sym_GT_EQ] = ACTIONS(51),
    [anon_sym_EQ_EQ] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(51),
    [anon_sym_CARET] = ACTIONS(51),
    [aux_sym_binary_operator_token1] = ACTIONS(51),
    [anon_sym_PIPE_GT] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(59),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_AT] = ACTIONS(51),
    [aux_sym__hex_literal_token1] = ACTIONS(345),
    [sym__number_literal] = ACTIONS(347),
    [anon_sym_SQUOTE] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(351),
    [sym_return] = ACTIONS(353),
    [sym_next] = ACTIONS(353),
    [sym_break] = ACTIONS(353),
    [sym_true] = ACTIONS(353),
    [sym_false] = ACTIONS(353),
    [sym_null] = ACTIONS(353),
    [sym_inf] = ACTIONS(353),
    [sym_nan] = ACTIONS(353),
    [anon_sym_NA] = ACTIONS(355),
    [anon_sym_NA_integer_] = ACTIONS(355),
    [anon_sym_NA_real_] = ACTIONS(355),
    [anon_sym_NA_complex_] = ACTIONS(355),
    [anon_sym_NA_character_] = ACTIONS(355),
    [sym_dots] = ACTIONS(353),
    [sym_dot_dot_i] = ACTIONS(357),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(51),
    [sym__newline] = ACTIONS(359),
    [sym__semicolon] = ACTIONS(359),
    [sym__raw_string_literal] = ACTIONS(361),
    [sym__external_open_parenthesis] = ACTIONS(363),
    [sym__external_close_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(365),
    [sym__external_close_brace] = ACTIONS(979),
    [sym__external_open_bracket] = ACTIONS(51),
    [sym__external_open_bracket2] = ACTIONS(51),
  },
  [69] = {
    [sym_function_definition] = STATE(917),
    [sym_if_statement] = STATE(917),
    [sym_for_statement] = STATE(917),
    [sym_while_statement] = STATE(917),
    [sym_repeat_statement] = STATE(917),
    [sym_braced_expression] = STATE(917),
    [sym_parenthesized_expression] = STATE(917),
    [sym_call] = STATE(917),
    [sym_subset] = STATE(917),
    [sym_subset2] = STATE(917),
    [sym_unary_operator] = STATE(917),
    [sym_binary_operator] = STATE(917),
    [sym_extract_operator] = STATE(917),
    [sym_namespace_operator] = STATE(917),
    [sym_integer] = STATE(917),
    [sym_complex] = STATE(917),
    [sym_float] = STATE(917),
    [sym__hex_literal] = STATE(2189),
    [sym__float_literal] = STATE(2189),
    [sym_string] = STATE(2192),
    [sym__single_quoted_string] = STATE(2188),
    [sym__double_quoted_string] = STATE(2187),
    [sym_na] = STATE(917),
    [sym__expression] = STATE(917),
    [sym__string_or_identifier] = STATE(5139),
    [sym__open_parenthesis] = STATE(57),
    [sym__close_parenthesis] = STATE(2596),
    [sym__open_brace] = STATE(59),
    [aux_sym_parenthesized_expression_repeat1] = STATE(123),
    [sym_identifier] = ACTIONS(273),
    [anon_sym_BSLASH] = ACTIONS(275),
    [anon_sym_function] = ACTIONS(277),
    [anon_sym_EQ] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_for] = ACTIONS(281),
    [anon_sym_while] = ACTIONS(283),
    [anon_sym_repeat] = ACTIONS(285),
    [anon_sym_QMARK] = ACTIONS(287),
    [anon_sym_TILDE] = ACTIONS(289),
    [anon_sym_BANG] = ACTIONS(291),
    [anon_sym_PLUS] = ACTIONS(293),
    [anon_sym_DASH] = ACTIONS(295),
    [anon_sym_LT_DASH] = ACTIONS(211),
    [anon_sym_LT_LT_DASH] = ACTIONS(211),
    [anon_sym_COLON_EQ] = ACTIONS(211),
    [anon_sym_DASH_GT] = ACTIONS(209),
    [anon_sym_DASH_GT_GT] = ACTIONS(211),
    [anon_sym_PIPE] = ACTIONS(209),
    [anon_sym_AMP] = ACTIONS(209),
    [anon_sym_PIPE_PIPE] = ACTIONS(211),
    [anon_sym_AMP_AMP] = ACTIONS(211),
    [anon_sym_LT] = ACTIONS(209),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_GT] = ACTIONS(209),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [anon_sym_EQ_EQ] = ACTIONS(211),
    [anon_sym_BANG_EQ] = ACTIONS(211),
    [anon_sym_STAR] = ACTIONS(209),
    [anon_sym_SLASH] = ACTIONS(211),
    [anon_sym_STAR_STAR] = ACTIONS(211),
    [anon_sym_CARET] = ACTIONS(211),
    [aux_sym_binary_operator_token1] = ACTIONS(211),
    [anon_sym_PIPE_GT] = ACTIONS(211),
    [anon_sym_COLON] = ACTIONS(209),
    [anon_sym_DOLLAR] = ACTIONS(211),
    [anon_sym_AT] = ACTIONS(211),
    [aux_sym__hex_literal_token1] = ACTIONS(297),
    [sym__number_literal] = ACTIONS(299),
    [anon_sym_SQUOTE] = ACTIONS(301),
    [anon_sym_DQUOTE] = ACTIONS(303),
    [sym_return] = ACTIONS(305),
    [sym_next] = ACTIONS(305),
    [sym_break] = ACTIONS(305),
    [sym_true] = ACTIONS(305),
    [sym_false] = ACTIONS(305),
    [sym_null] = ACTIONS(305),
    [sym_inf] = ACTIONS(305),
    [sym_nan] = ACTIONS(305),
    [anon_sym_NA] = ACTIONS(307),
    [anon_sym_NA_integer_] = ACTIONS(307),
    [anon_sym_NA_real_] = ACTIONS(307),
    [anon_sym_NA_complex_] = ACTIONS(307),
    [anon_sym_NA_character_] = ACTIONS(307),
    [sym_dots] = ACTIONS(305),
    [sym_dot_dot_i] = ACTIONS(309),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(211),
    [sym__newline] = ACTIONS(311),
    [sym__semicolon] = ACTIONS(211),
    [sym__raw_string_literal] = ACTIONS(313),
    [sym__external_open_parenthesis] = ACTIONS(315),
    [sym__external_close_parenthesis] = ACTIONS(981),
    [sym__external_open_brace] = ACTIONS(319),
    [sym__external_close_brace] = ACTIONS(211),
    [sym__external_open_bracket] = ACTIONS(211),
    [sym__external_close_bracket] = ACTIONS(211),
    [sym__external_open_bracket2] = ACTIONS(211),
  },
  [70] = {
    [sym_function_definition] = STATE(770),
    [sym_if_statement] = STATE(770),
    [sym_for_statement] = STATE(770),
    [sym_while_statement] = STATE(770),
    [sym_repeat_statement] = STATE(770),
    [sym_braced_expression] = STATE(770),
    [sym_parenthesized_expression] = STATE(770),
    [sym_call] = STATE(770),
    [sym_subset] = STATE(770),
    [sym_subset2] = STATE(770),
    [sym_unary_operator] = STATE(770),
    [sym_binary_operator] = STATE(770),
    [sym_extract_operator] = STATE(770),
    [sym_namespace_operator] = STATE(770),
    [sym_integer] = STATE(770),
    [sym_complex] = STATE(770),
    [sym_float] = STATE(770),
    [sym__hex_literal] = STATE(2189),
    [sym__float_literal] = STATE(2189),
    [sym_string] = STATE(2192),
    [sym__single_quoted_string] = STATE(2188),
    [sym__double_quoted_string] = STATE(2187),
    [sym_na] = STATE(770),
    [sym__expression] = STATE(770),
    [sym__string_or_identifier] = STATE(5139),
    [sym__open_parenthesis] = STATE(57),
    [sym__open_brace] = STATE(59),
    [sym__close_brace] = STATE(2771),
    [aux_sym_braced_expression_repeat1] = STATE(61),
    [sym_identifier] = ACTIONS(273),
    [anon_sym_BSLASH] = ACTIONS(275),
    [anon_sym_function] = ACTIONS(277),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_for] = ACTIONS(281),
    [anon_sym_while] = ACTIONS(283),
    [anon_sym_repeat] = ACTIONS(285),
    [anon_sym_QMARK] = ACTIONS(287),
    [anon_sym_TILDE] = ACTIONS(289),
    [anon_sym_BANG] = ACTIONS(291),
    [anon_sym_PLUS] = ACTIONS(293),
    [anon_sym_DASH] = ACTIONS(295),
    [anon_sym_LT_DASH] = ACTIONS(155),
    [anon_sym_LT_LT_DASH] = ACTIONS(155),
    [anon_sym_COLON_EQ] = ACTIONS(155),
    [anon_sym_DASH_GT] = ACTIONS(157),
    [anon_sym_DASH_GT_GT] = ACTIONS(155),
    [anon_sym_PIPE] = ACTIONS(157),
    [anon_sym_AMP] = ACTIONS(157),
    [anon_sym_PIPE_PIPE] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(157),
    [anon_sym_LT_EQ] = ACTIONS(155),
    [anon_sym_GT] = ACTIONS(157),
    [anon_sym_GT_EQ] = ACTIONS(155),
    [anon_sym_EQ_EQ] = ACTIONS(155),
    [anon_sym_BANG_EQ] = ACTIONS(155),
    [anon_sym_STAR] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(155),
    [anon_sym_STAR_STAR] = ACTIONS(155),
    [anon_sym_CARET] = ACTIONS(155),
    [aux_sym_binary_operator_token1] = ACTIONS(155),
    [anon_sym_PIPE_GT] = ACTIONS(155),
    [anon_sym_COLON] = ACTIONS(157),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(155),
    [aux_sym__hex_literal_token1] = ACTIONS(297),
    [sym__number_literal] = ACTIONS(299),
    [anon_sym_SQUOTE] = ACTIONS(301),
    [anon_sym_DQUOTE] = ACTIONS(303),
    [sym_return] = ACTIONS(876),
    [sym_next] = ACTIONS(876),
    [sym_break] = ACTIONS(876),
    [sym_true] = ACTIONS(876),
    [sym_false] = ACTIONS(876),
    [sym_null] = ACTIONS(876),
    [sym_inf] = ACTIONS(876),
    [sym_nan] = ACTIONS(876),
    [anon_sym_NA] = ACTIONS(307),
    [anon_sym_NA_integer_] = ACTIONS(307),
    [anon_sym_NA_real_] = ACTIONS(307),
    [anon_sym_NA_complex_] = ACTIONS(307),
    [anon_sym_NA_character_] = ACTIONS(307),
    [sym_dots] = ACTIONS(876),
    [sym_dot_dot_i] = ACTIONS(878),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(155),
    [sym__newline] = ACTIONS(880),
    [sym__semicolon] = ACTIONS(880),
    [sym__raw_string_literal] = ACTIONS(313),
    [sym__external_open_parenthesis] = ACTIONS(315),
    [sym__external_close_parenthesis] = ACTIONS(155),
    [sym__external_open_brace] = ACTIONS(319),
    [sym__external_close_brace] = ACTIONS(983),
    [sym__external_open_bracket] = ACTIONS(155),
    [sym__external_close_bracket] = ACTIONS(155),
    [sym__external_open_bracket2] = ACTIONS(155),
  },
  [71] = {
    [sym_function_definition] = STATE(563),
    [sym_if_statement] = STATE(563),
    [sym_for_statement] = STATE(563),
    [sym_while_statement] = STATE(563),
    [sym_repeat_statement] = STATE(563),
    [sym_braced_expression] = STATE(563),
    [sym_parenthesized_expression] = STATE(563),
    [sym_call] = STATE(563),
    [sym_subset] = STATE(563),
    [sym_subset2] = STATE(563),
    [sym_unary_operator] = STATE(563),
    [sym_binary_operator] = STATE(563),
    [sym_extract_operator] = STATE(563),
    [sym_namespace_operator] = STATE(563),
    [sym_integer] = STATE(563),
    [sym_complex] = STATE(563),
    [sym_float] = STATE(563),
    [sym__hex_literal] = STATE(2021),
    [sym__float_literal] = STATE(2021),
    [sym_string] = STATE(2016),
    [sym__single_quoted_string] = STATE(2027),
    [sym__double_quoted_string] = STATE(2041),
    [sym_na] = STATE(563),
    [sym__expression] = STATE(563),
    [sym__string_or_identifier] = STATE(5131),
    [sym__open_parenthesis] = STATE(20),
    [sym__open_brace] = STATE(10),
    [aux_sym_function_definition_repeat1] = STATE(2199),
    [sym_identifier] = ACTIONS(103),
    [anon_sym_BSLASH] = ACTIONS(105),
    [anon_sym_function] = ACTIONS(107),
    [anon_sym_EQ] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(111),
    [anon_sym_for] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_repeat] = ACTIONS(117),
    [anon_sym_QMARK] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_BANG] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(125),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_LT_DASH] = ACTIONS(369),
    [anon_sym_LT_LT_DASH] = ACTIONS(369),
    [anon_sym_COLON_EQ] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(371),
    [anon_sym_DASH_GT_GT] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(371),
    [anon_sym_AMP] = ACTIONS(371),
    [anon_sym_PIPE_PIPE] = ACTIONS(369),
    [anon_sym_AMP_AMP] = ACTIONS(369),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_LT_EQ] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_EQ] = ACTIONS(369),
    [anon_sym_EQ_EQ] = ACTIONS(369),
    [anon_sym_BANG_EQ] = ACTIONS(369),
    [anon_sym_STAR] = ACTIONS(371),
    [anon_sym_SLASH] = ACTIONS(369),
    [anon_sym_STAR_STAR] = ACTIONS(369),
    [anon_sym_CARET] = ACTIONS(369),
    [aux_sym_binary_operator_token1] = ACTIONS(369),
    [anon_sym_PIPE_GT] = ACTIONS(369),
    [anon_sym_COLON] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(369),
    [anon_sym_AT] = ACTIONS(369),
    [aux_sym__hex_literal_token1] = ACTIONS(131),
    [sym__number_literal] = ACTIONS(133),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(137),
    [sym_return] = ACTIONS(985),
    [sym_next] = ACTIONS(985),
    [sym_break] = ACTIONS(985),
    [sym_true] = ACTIONS(985),
    [sym_false] = ACTIONS(985),
    [sym_null] = ACTIONS(985),
    [sym_inf] = ACTIONS(985),
    [sym_nan] = ACTIONS(985),
    [anon_sym_NA] = ACTIONS(141),
    [anon_sym_NA_integer_] = ACTIONS(141),
    [anon_sym_NA_real_] = ACTIONS(141),
    [anon_sym_NA_complex_] = ACTIONS(141),
    [anon_sym_NA_character_] = ACTIONS(141),
    [sym_dots] = ACTIONS(985),
    [sym_dot_dot_i] = ACTIONS(987),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(369),
    [sym__newline] = ACTIONS(369),
    [sym__semicolon] = ACTIONS(369),
    [sym__raw_string_literal] = ACTIONS(147),
    [sym__external_else] = ACTIONS(369),
    [sym__external_open_parenthesis] = ACTIONS(149),
    [sym__external_close_parenthesis] = ACTIONS(369),
    [sym__external_open_brace] = ACTIONS(153),
    [sym__external_close_brace] = ACTIONS(369),
    [sym__external_open_bracket] = ACTIONS(369),
    [sym__external_close_bracket] = ACTIONS(369),
    [sym__external_open_bracket2] = ACTIONS(369),
  },
  [72] = {
    [sym_function_definition] = STATE(664),
    [sym_if_statement] = STATE(664),
    [sym_for_statement] = STATE(664),
    [sym_while_statement] = STATE(664),
    [sym_repeat_statement] = STATE(664),
    [sym_braced_expression] = STATE(664),
    [sym_parenthesized_expression] = STATE(664),
    [sym_call] = STATE(664),
    [sym_subset] = STATE(664),
    [sym_subset2] = STATE(664),
    [sym_unary_operator] = STATE(664),
    [sym_binary_operator] = STATE(664),
    [sym_extract_operator] = STATE(664),
    [sym_namespace_operator] = STATE(664),
    [sym_integer] = STATE(664),
    [sym_complex] = STATE(664),
    [sym_float] = STATE(664),
    [sym__hex_literal] = STATE(1925),
    [sym__float_literal] = STATE(1925),
    [sym_string] = STATE(1927),
    [sym__single_quoted_string] = STATE(1923),
    [sym__double_quoted_string] = STATE(1934),
    [sym_na] = STATE(664),
    [sym__expression] = STATE(664),
    [sym__string_or_identifier] = STATE(5137),
    [sym__open_parenthesis] = STATE(14),
    [sym__open_brace] = STATE(18),
    [aux_sym_function_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(161),
    [anon_sym_BSLASH] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_if] = ACTIONS(167),
    [anon_sym_for] = ACTIONS(169),
    [anon_sym_while] = ACTIONS(171),
    [anon_sym_repeat] = ACTIONS(173),
    [anon_sym_QMARK] = ACTIONS(175),
    [anon_sym_TILDE] = ACTIONS(177),
    [anon_sym_BANG] = ACTIONS(179),
    [anon_sym_PLUS] = ACTIONS(181),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_LT_DASH] = ACTIONS(471),
    [anon_sym_LT_LT_DASH] = ACTIONS(471),
    [anon_sym_COLON_EQ] = ACTIONS(471),
    [anon_sym_DASH_GT] = ACTIONS(473),
    [anon_sym_DASH_GT_GT] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(473),
    [anon_sym_AMP] = ACTIONS(473),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_LT_EQ] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(473),
    [anon_sym_GT_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_STAR] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [aux_sym_binary_operator_token1] = ACTIONS(471),
    [anon_sym_PIPE_GT] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(473),
    [anon_sym_DOLLAR] = ACTIONS(471),
    [anon_sym_AT] = ACTIONS(471),
    [aux_sym__hex_literal_token1] = ACTIONS(185),
    [sym__number_literal] = ACTIONS(187),
    [anon_sym_SQUOTE] = ACTIONS(189),
    [anon_sym_DQUOTE] = ACTIONS(191),
    [sym_return] = ACTIONS(989),
    [sym_next] = ACTIONS(989),
    [sym_break] = ACTIONS(989),
    [sym_true] = ACTIONS(989),
    [sym_false] = ACTIONS(989),
    [sym_null] = ACTIONS(989),
    [sym_inf] = ACTIONS(989),
    [sym_nan] = ACTIONS(989),
    [anon_sym_NA] = ACTIONS(195),
    [anon_sym_NA_integer_] = ACTIONS(195),
    [anon_sym_NA_real_] = ACTIONS(195),
    [anon_sym_NA_complex_] = ACTIONS(195),
    [anon_sym_NA_character_] = ACTIONS(195),
    [sym_dots] = ACTIONS(989),
    [sym_dot_dot_i] = ACTIONS(991),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(471),
    [sym__newline] = ACTIONS(471),
    [sym__semicolon] = ACTIONS(471),
    [sym__raw_string_literal] = ACTIONS(201),
    [sym__external_else] = ACTIONS(471),
    [sym__external_open_parenthesis] = ACTIONS(203),
    [sym__external_close_parenthesis] = ACTIONS(471),
    [sym__external_open_brace] = ACTIONS(207),
    [sym__external_close_brace] = ACTIONS(471),
    [sym__external_open_bracket] = ACTIONS(471),
    [sym__external_open_bracket2] = ACTIONS(471),
    [sym__external_close_bracket2] = ACTIONS(471),
  },
  [73] = {
    [sym_function_definition] = STATE(605),
    [sym_if_statement] = STATE(605),
    [sym_for_statement] = STATE(605),
    [sym_while_statement] = STATE(605),
    [sym_repeat_statement] = STATE(605),
    [sym_braced_expression] = STATE(605),
    [sym_parenthesized_expression] = STATE(605),
    [sym_call] = STATE(605),
    [sym_subset] = STATE(605),
    [sym_subset2] = STATE(605),
    [sym_unary_operator] = STATE(605),
    [sym_binary_operator] = STATE(605),
    [sym_extract_operator] = STATE(605),
    [sym_namespace_operator] = STATE(605),
    [sym_integer] = STATE(605),
    [sym_complex] = STATE(605),
    [sym_float] = STATE(605),
    [sym__hex_literal] = STATE(2021),
    [sym__float_literal] = STATE(2021),
    [sym_string] = STATE(2016),
    [sym__single_quoted_string] = STATE(2027),
    [sym__double_quoted_string] = STATE(2041),
    [sym_na] = STATE(605),
    [sym__expression] = STATE(605),
    [sym__string_or_identifier] = STATE(5131),
    [sym__open_parenthesis] = STATE(20),
    [sym__open_brace] = STATE(10),
    [aux_sym_function_definition_repeat1] = STATE(96),
    [sym_identifier] = ACTIONS(103),
    [anon_sym_BSLASH] = ACTIONS(105),
    [anon_sym_function] = ACTIONS(107),
    [anon_sym_EQ] = ACTIONS(379),
    [anon_sym_if] = ACTIONS(111),
    [anon_sym_for] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_repeat] = ACTIONS(117),
    [anon_sym_QMARK] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_BANG] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(125),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_LT_DASH] = ACTIONS(377),
    [anon_sym_LT_LT_DASH] = ACTIONS(377),
    [anon_sym_COLON_EQ] = ACTIONS(377),
    [anon_sym_DASH_GT] = ACTIONS(379),
    [anon_sym_DASH_GT_GT] = ACTIONS(377),
    [anon_sym_PIPE] = ACTIONS(379),
    [anon_sym_AMP] = ACTIONS(379),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_LT] = ACTIONS(379),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(379),
    [anon_sym_GT_EQ] = ACTIONS(377),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(379),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_STAR_STAR] = ACTIONS(377),
    [anon_sym_CARET] = ACTIONS(377),
    [aux_sym_binary_operator_token1] = ACTIONS(377),
    [anon_sym_PIPE_GT] = ACTIONS(377),
    [anon_sym_COLON] = ACTIONS(379),
    [anon_sym_DOLLAR] = ACTIONS(377),
    [anon_sym_AT] = ACTIONS(377),
    [aux_sym__hex_literal_token1] = ACTIONS(131),
    [sym__number_literal] = ACTIONS(133),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(137),
    [sym_return] = ACTIONS(993),
    [sym_next] = ACTIONS(993),
    [sym_break] = ACTIONS(993),
    [sym_true] = ACTIONS(993),
    [sym_false] = ACTIONS(993),
    [sym_null] = ACTIONS(993),
    [sym_inf] = ACTIONS(993),
    [sym_nan] = ACTIONS(993),
    [anon_sym_NA] = ACTIONS(141),
    [anon_sym_NA_integer_] = ACTIONS(141),
    [anon_sym_NA_real_] = ACTIONS(141),
    [anon_sym_NA_complex_] = ACTIONS(141),
    [anon_sym_NA_character_] = ACTIONS(141),
    [sym_dots] = ACTIONS(993),
    [sym_dot_dot_i] = ACTIONS(995),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(377),
    [sym__newline] = ACTIONS(997),
    [sym__semicolon] = ACTIONS(377),
    [sym__raw_string_literal] = ACTIONS(147),
    [sym__external_else] = ACTIONS(377),
    [sym__external_open_parenthesis] = ACTIONS(149),
    [sym__external_close_parenthesis] = ACTIONS(377),
    [sym__external_open_brace] = ACTIONS(153),
    [sym__external_close_brace] = ACTIONS(377),
    [sym__external_open_bracket] = ACTIONS(377),
    [sym__external_close_bracket] = ACTIONS(377),
    [sym__external_open_bracket2] = ACTIONS(377),
  },
  [74] = {
    [sym_function_definition] = STATE(921),
    [sym_if_statement] = STATE(921),
    [sym_for_statement] = STATE(921),
    [sym_while_statement] = STATE(921),
    [sym_repeat_statement] = STATE(921),
    [sym_braced_expression] = STATE(921),
    [sym_parenthesized_expression] = STATE(921),
    [sym_call] = STATE(921),
    [sym_subset] = STATE(921),
    [sym_subset2] = STATE(921),
    [sym_unary_operator] = STATE(921),
    [sym_binary_operator] = STATE(921),
    [sym_extract_operator] = STATE(921),
    [sym_namespace_operator] = STATE(921),
    [sym_integer] = STATE(921),
    [sym_complex] = STATE(921),
    [sym_float] = STATE(921),
    [sym__hex_literal] = STATE(2220),
    [sym__float_literal] = STATE(2220),
    [sym_string] = STATE(2219),
    [sym__single_quoted_string] = STATE(2221),
    [sym__double_quoted_string] = STATE(2222),
    [sym_na] = STATE(921),
    [sym__expression] = STATE(921),
    [sym__string_or_identifier] = STATE(5140),
    [sym__open_parenthesis] = STATE(54),
    [sym__open_brace] = STATE(56),
    [sym__close_brace] = STATE(2908),
    [aux_sym_braced_expression_repeat1] = STATE(40),
    [sym_identifier] = ACTIONS(626),
    [anon_sym_BSLASH] = ACTIONS(628),
    [anon_sym_function] = ACTIONS(630),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [anon_sym_repeat] = ACTIONS(638),
    [anon_sym_QMARK] = ACTIONS(640),
    [anon_sym_TILDE] = ACTIONS(642),
    [anon_sym_BANG] = ACTIONS(644),
    [anon_sym_PLUS] = ACTIONS(646),
    [anon_sym_DASH] = ACTIONS(648),
    [anon_sym_LT_DASH] = ACTIONS(155),
    [anon_sym_LT_LT_DASH] = ACTIONS(155),
    [anon_sym_COLON_EQ] = ACTIONS(155),
    [anon_sym_DASH_GT] = ACTIONS(157),
    [anon_sym_DASH_GT_GT] = ACTIONS(155),
    [anon_sym_PIPE] = ACTIONS(157),
    [anon_sym_AMP] = ACTIONS(157),
    [anon_sym_PIPE_PIPE] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(157),
    [anon_sym_LT_EQ] = ACTIONS(155),
    [anon_sym_GT] = ACTIONS(157),
    [anon_sym_GT_EQ] = ACTIONS(155),
    [anon_sym_EQ_EQ] = ACTIONS(155),
    [anon_sym_BANG_EQ] = ACTIONS(155),
    [anon_sym_STAR] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(155),
    [anon_sym_STAR_STAR] = ACTIONS(155),
    [anon_sym_CARET] = ACTIONS(155),
    [aux_sym_binary_operator_token1] = ACTIONS(155),
    [anon_sym_PIPE_GT] = ACTIONS(155),
    [anon_sym_COLON] = ACTIONS(157),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(155),
    [aux_sym__hex_literal_token1] = ACTIONS(650),
    [sym__number_literal] = ACTIONS(652),
    [anon_sym_SQUOTE] = ACTIONS(654),
    [anon_sym_DQUOTE] = ACTIONS(656),
    [sym_return] = ACTIONS(658),
    [sym_next] = ACTIONS(658),
    [sym_break] = ACTIONS(658),
    [sym_true] = ACTIONS(658),
    [sym_false] = ACTIONS(658),
    [sym_null] = ACTIONS(658),
    [sym_inf] = ACTIONS(658),
    [sym_nan] = ACTIONS(658),
    [anon_sym_NA] = ACTIONS(660),
    [anon_sym_NA_integer_] = ACTIONS(660),
    [anon_sym_NA_real_] = ACTIONS(660),
    [anon_sym_NA_complex_] = ACTIONS(660),
    [anon_sym_NA_character_] = ACTIONS(660),
    [sym_dots] = ACTIONS(658),
    [sym_dot_dot_i] = ACTIONS(662),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(155),
    [sym__newline] = ACTIONS(664),
    [sym__semicolon] = ACTIONS(664),
    [sym__raw_string_literal] = ACTIONS(666),
    [sym__external_open_parenthesis] = ACTIONS(668),
    [sym__external_close_parenthesis] = ACTIONS(155),
    [sym__external_open_brace] = ACTIONS(670),
    [sym__external_close_brace] = ACTIONS(999),
    [sym__external_open_bracket] = ACTIONS(155),
    [sym__external_open_bracket2] = ACTIONS(155),
    [sym__external_close_bracket2] = ACTIONS(155),
  },
  [75] = {
    [sym_function_definition] = STATE(599),
    [sym_if_statement] = STATE(599),
    [sym_for_statement] = STATE(599),
    [sym_while_statement] = STATE(599),
    [sym_repeat_statement] = STATE(599),
    [sym_braced_expression] = STATE(599),
    [sym_parenthesized_expression] = STATE(599),
    [sym_call] = STATE(599),
    [sym_subset] = STATE(599),
    [sym_subset2] = STATE(599),
    [sym_unary_operator] = STATE(599),
    [sym_binary_operator] = STATE(599),
    [sym_extract_operator] = STATE(599),
    [sym_namespace_operator] = STATE(599),
    [sym_integer] = STATE(599),
    [sym_complex] = STATE(599),
    [sym_float] = STATE(599),
    [sym__hex_literal] = STATE(1984),
    [sym__float_literal] = STATE(1984),
    [sym_string] = STATE(1982),
    [sym__single_quoted_string] = STATE(1985),
    [sym__double_quoted_string] = STATE(1990),
    [sym_na] = STATE(599),
    [sym__expression] = STATE(599),
    [sym__string_or_identifier] = STATE(5151),
    [sym__open_parenthesis] = STATE(19),
    [sym__open_brace] = STATE(4),
    [sym__close_brace] = STATE(2692),
    [aux_sym_braced_expression_repeat1] = STATE(66),
    [ts_builtin_sym_end] = ACTIONS(51),
    [sym_identifier] = ACTIONS(53),
    [anon_sym_BSLASH] = ACTIONS(55),
    [anon_sym_function] = ACTIONS(57),
    [anon_sym_EQ] = ACTIONS(59),
    [anon_sym_if] = ACTIONS(61),
    [anon_sym_for] = ACTIONS(63),
    [anon_sym_while] = ACTIONS(65),
    [anon_sym_repeat] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_LT_DASH] = ACTIONS(51),
    [anon_sym_LT_LT_DASH] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(51),
    [anon_sym_DASH_GT] = ACTIONS(59),
    [anon_sym_DASH_GT_GT] = ACTIONS(51),
    [anon_sym_PIPE] = ACTIONS(59),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_AMP_AMP] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(59),
    [anon_sym_LT_EQ] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(59),
    [anon_sym_GT_EQ] = ACTIONS(51),
    [anon_sym_EQ_EQ] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(51),
    [anon_sym_CARET] = ACTIONS(51),
    [aux_sym_binary_operator_token1] = ACTIONS(51),
    [anon_sym_PIPE_GT] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(59),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_AT] = ACTIONS(51),
    [aux_sym__hex_literal_token1] = ACTIONS(79),
    [sym__number_literal] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_return] = ACTIONS(87),
    [sym_next] = ACTIONS(87),
    [sym_break] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_inf] = ACTIONS(87),
    [sym_nan] = ACTIONS(87),
    [anon_sym_NA] = ACTIONS(89),
    [anon_sym_NA_integer_] = ACTIONS(89),
    [anon_sym_NA_real_] = ACTIONS(89),
    [anon_sym_NA_complex_] = ACTIONS(89),
    [anon_sym_NA_character_] = ACTIONS(89),
    [sym_dots] = ACTIONS(87),
    [sym_dot_dot_i] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(93),
    [sym__semicolon] = ACTIONS(93),
    [sym__raw_string_literal] = ACTIONS(95),
    [sym__external_else] = ACTIONS(51),
    [sym__external_open_parenthesis] = ACTIONS(97),
    [sym__external_close_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(99),
    [sym__external_close_brace] = ACTIONS(1001),
    [sym__external_open_bracket] = ACTIONS(51),
    [sym__external_open_bracket2] = ACTIONS(51),
  },
  [76] = {
    [sym_function_definition] = STATE(935),
    [sym_if_statement] = STATE(935),
    [sym_for_statement] = STATE(935),
    [sym_while_statement] = STATE(935),
    [sym_repeat_statement] = STATE(935),
    [sym_braced_expression] = STATE(935),
    [sym_parenthesized_expression] = STATE(935),
    [sym_call] = STATE(935),
    [sym_subset] = STATE(935),
    [sym_subset2] = STATE(935),
    [sym_unary_operator] = STATE(935),
    [sym_binary_operator] = STATE(935),
    [sym_extract_operator] = STATE(935),
    [sym_namespace_operator] = STATE(935),
    [sym_integer] = STATE(935),
    [sym_complex] = STATE(935),
    [sym_float] = STATE(935),
    [sym__hex_literal] = STATE(2220),
    [sym__float_literal] = STATE(2220),
    [sym_string] = STATE(2219),
    [sym__single_quoted_string] = STATE(2221),
    [sym__double_quoted_string] = STATE(2222),
    [sym_na] = STATE(935),
    [sym__expression] = STATE(935),
    [sym__string_or_identifier] = STATE(5140),
    [sym__open_parenthesis] = STATE(54),
    [sym__close_parenthesis] = STATE(2659),
    [sym__open_brace] = STATE(56),
    [aux_sym_parenthesized_expression_repeat1] = STATE(62),
    [sym_identifier] = ACTIONS(626),
    [anon_sym_BSLASH] = ACTIONS(628),
    [anon_sym_function] = ACTIONS(630),
    [anon_sym_EQ] = ACTIONS(109),
    [anon_sym_if] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [anon_sym_repeat] = ACTIONS(638),
    [anon_sym_QMARK] = ACTIONS(640),
    [anon_sym_TILDE] = ACTIONS(642),
    [anon_sym_BANG] = ACTIONS(644),
    [anon_sym_PLUS] = ACTIONS(646),
    [anon_sym_DASH] = ACTIONS(648),
    [anon_sym_LT_DASH] = ACTIONS(129),
    [anon_sym_LT_LT_DASH] = ACTIONS(129),
    [anon_sym_COLON_EQ] = ACTIONS(129),
    [anon_sym_DASH_GT] = ACTIONS(109),
    [anon_sym_DASH_GT_GT] = ACTIONS(129),
    [anon_sym_PIPE] = ACTIONS(109),
    [anon_sym_AMP] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_STAR_STAR] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [aux_sym_binary_operator_token1] = ACTIONS(129),
    [anon_sym_PIPE_GT] = ACTIONS(129),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(129),
    [anon_sym_AT] = ACTIONS(129),
    [aux_sym__hex_literal_token1] = ACTIONS(650),
    [sym__number_literal] = ACTIONS(652),
    [anon_sym_SQUOTE] = ACTIONS(654),
    [anon_sym_DQUOTE] = ACTIONS(656),
    [sym_return] = ACTIONS(747),
    [sym_next] = ACTIONS(747),
    [sym_break] = ACTIONS(747),
    [sym_true] = ACTIONS(747),
    [sym_false] = ACTIONS(747),
    [sym_null] = ACTIONS(747),
    [sym_inf] = ACTIONS(747),
    [sym_nan] = ACTIONS(747),
    [anon_sym_NA] = ACTIONS(660),
    [anon_sym_NA_integer_] = ACTIONS(660),
    [anon_sym_NA_real_] = ACTIONS(660),
    [anon_sym_NA_complex_] = ACTIONS(660),
    [anon_sym_NA_character_] = ACTIONS(660),
    [sym_dots] = ACTIONS(747),
    [sym_dot_dot_i] = ACTIONS(749),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(129),
    [sym__newline] = ACTIONS(751),
    [sym__semicolon] = ACTIONS(129),
    [sym__raw_string_literal] = ACTIONS(666),
    [sym__external_open_parenthesis] = ACTIONS(668),
    [sym__external_close_parenthesis] = ACTIONS(1003),
    [sym__external_open_brace] = ACTIONS(670),
    [sym__external_close_brace] = ACTIONS(129),
    [sym__external_open_bracket] = ACTIONS(129),
    [sym__external_open_bracket2] = ACTIONS(129),
    [sym__external_close_bracket2] = ACTIONS(129),
  },
  [77] = {
    [sym_function_definition] = STATE(620),
    [sym_if_statement] = STATE(620),
    [sym_for_statement] = STATE(620),
    [sym_while_statement] = STATE(620),
    [sym_repeat_statement] = STATE(620),
    [sym_braced_expression] = STATE(620),
    [sym_parenthesized_expression] = STATE(620),
    [sym_call] = STATE(620),
    [sym_subset] = STATE(620),
    [sym_subset2] = STATE(620),
    [sym_unary_operator] = STATE(620),
    [sym_binary_operator] = STATE(620),
    [sym_extract_operator] = STATE(620),
    [sym_namespace_operator] = STATE(620),
    [sym_integer] = STATE(620),
    [sym_complex] = STATE(620),
    [sym_float] = STATE(620),
    [sym__hex_literal] = STATE(1925),
    [sym__float_literal] = STATE(1925),
    [sym_string] = STATE(1927),
    [sym__single_quoted_string] = STATE(1923),
    [sym__double_quoted_string] = STATE(1934),
    [sym_na] = STATE(620),
    [sym__expression] = STATE(620),
    [sym__string_or_identifier] = STATE(5137),
    [sym__open_parenthesis] = STATE(14),
    [sym__open_brace] = STATE(18),
    [aux_sym_function_definition_repeat1] = STATE(87),
    [sym_identifier] = ACTIONS(161),
    [anon_sym_BSLASH] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(543),
    [anon_sym_if] = ACTIONS(167),
    [anon_sym_for] = ACTIONS(169),
    [anon_sym_while] = ACTIONS(171),
    [anon_sym_repeat] = ACTIONS(173),
    [anon_sym_QMARK] = ACTIONS(175),
    [anon_sym_TILDE] = ACTIONS(177),
    [anon_sym_BANG] = ACTIONS(179),
    [anon_sym_PLUS] = ACTIONS(181),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_LT_DASH] = ACTIONS(545),
    [anon_sym_LT_LT_DASH] = ACTIONS(545),
    [anon_sym_COLON_EQ] = ACTIONS(545),
    [anon_sym_DASH_GT] = ACTIONS(543),
    [anon_sym_DASH_GT_GT] = ACTIONS(545),
    [anon_sym_PIPE] = ACTIONS(543),
    [anon_sym_AMP] = ACTIONS(543),
    [anon_sym_PIPE_PIPE] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(543),
    [anon_sym_LT_EQ] = ACTIONS(545),
    [anon_sym_GT] = ACTIONS(543),
    [anon_sym_GT_EQ] = ACTIONS(545),
    [anon_sym_EQ_EQ] = ACTIONS(545),
    [anon_sym_BANG_EQ] = ACTIONS(545),
    [anon_sym_STAR] = ACTIONS(543),
    [anon_sym_SLASH] = ACTIONS(545),
    [anon_sym_STAR_STAR] = ACTIONS(545),
    [anon_sym_CARET] = ACTIONS(545),
    [aux_sym_binary_operator_token1] = ACTIONS(545),
    [anon_sym_PIPE_GT] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(543),
    [anon_sym_DOLLAR] = ACTIONS(545),
    [anon_sym_AT] = ACTIONS(545),
    [aux_sym__hex_literal_token1] = ACTIONS(185),
    [sym__number_literal] = ACTIONS(187),
    [anon_sym_SQUOTE] = ACTIONS(189),
    [anon_sym_DQUOTE] = ACTIONS(191),
    [sym_return] = ACTIONS(1005),
    [sym_next] = ACTIONS(1005),
    [sym_break] = ACTIONS(1005),
    [sym_true] = ACTIONS(1005),
    [sym_false] = ACTIONS(1005),
    [sym_null] = ACTIONS(1005),
    [sym_inf] = ACTIONS(1005),
    [sym_nan] = ACTIONS(1005),
    [anon_sym_NA] = ACTIONS(195),
    [anon_sym_NA_integer_] = ACTIONS(195),
    [anon_sym_NA_real_] = ACTIONS(195),
    [anon_sym_NA_complex_] = ACTIONS(195),
    [anon_sym_NA_character_] = ACTIONS(195),
    [sym_dots] = ACTIONS(1005),
    [sym_dot_dot_i] = ACTIONS(1007),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(545),
    [sym__newline] = ACTIONS(1009),
    [sym__semicolon] = ACTIONS(545),
    [sym__raw_string_literal] = ACTIONS(201),
    [sym__external_else] = ACTIONS(545),
    [sym__external_open_parenthesis] = ACTIONS(203),
    [sym__external_close_parenthesis] = ACTIONS(545),
    [sym__external_open_brace] = ACTIONS(207),
    [sym__external_close_brace] = ACTIONS(545),
    [sym__external_open_bracket] = ACTIONS(545),
    [sym__external_open_bracket2] = ACTIONS(545),
    [sym__external_close_bracket2] = ACTIONS(545),
  },
  [78] = {
    [sym_function_definition] = STATE(653),
    [sym_if_statement] = STATE(653),
    [sym_for_statement] = STATE(653),
    [sym_while_statement] = STATE(653),
    [sym_repeat_statement] = STATE(653),
    [sym_braced_expression] = STATE(653),
    [sym_parenthesized_expression] = STATE(653),
    [sym_call] = STATE(653),
    [sym_subset] = STATE(653),
    [sym_subset2] = STATE(653),
    [sym_unary_operator] = STATE(653),
    [sym_binary_operator] = STATE(653),
    [sym_extract_operator] = STATE(653),
    [sym_namespace_operator] = STATE(653),
    [sym_integer] = STATE(653),
    [sym_complex] = STATE(653),
    [sym_float] = STATE(653),
    [sym__hex_literal] = STATE(1925),
    [sym__float_literal] = STATE(1925),
    [sym_string] = STATE(1927),
    [sym__single_quoted_string] = STATE(1923),
    [sym__double_quoted_string] = STATE(1934),
    [sym_na] = STATE(653),
    [sym__expression] = STATE(653),
    [sym__string_or_identifier] = STATE(5137),
    [sym__open_parenthesis] = STATE(14),
    [sym__open_brace] = STATE(18),
    [aux_sym_function_definition_repeat1] = STATE(90),
    [sym_identifier] = ACTIONS(161),
    [anon_sym_BSLASH] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(533),
    [anon_sym_if] = ACTIONS(167),
    [anon_sym_for] = ACTIONS(169),
    [anon_sym_while] = ACTIONS(171),
    [anon_sym_repeat] = ACTIONS(173),
    [anon_sym_QMARK] = ACTIONS(175),
    [anon_sym_TILDE] = ACTIONS(177),
    [anon_sym_BANG] = ACTIONS(179),
    [anon_sym_PLUS] = ACTIONS(181),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_LT_DASH] = ACTIONS(531),
    [anon_sym_LT_LT_DASH] = ACTIONS(531),
    [anon_sym_COLON_EQ] = ACTIONS(531),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_DASH_GT_GT] = ACTIONS(531),
    [anon_sym_PIPE] = ACTIONS(533),
    [anon_sym_AMP] = ACTIONS(533),
    [anon_sym_PIPE_PIPE] = ACTIONS(531),
    [anon_sym_AMP_AMP] = ACTIONS(531),
    [anon_sym_LT] = ACTIONS(533),
    [anon_sym_LT_EQ] = ACTIONS(531),
    [anon_sym_GT] = ACTIONS(533),
    [anon_sym_GT_EQ] = ACTIONS(531),
    [anon_sym_EQ_EQ] = ACTIONS(531),
    [anon_sym_BANG_EQ] = ACTIONS(531),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_SLASH] = ACTIONS(531),
    [anon_sym_STAR_STAR] = ACTIONS(531),
    [anon_sym_CARET] = ACTIONS(531),
    [aux_sym_binary_operator_token1] = ACTIONS(531),
    [anon_sym_PIPE_GT] = ACTIONS(531),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_DOLLAR] = ACTIONS(531),
    [anon_sym_AT] = ACTIONS(531),
    [aux_sym__hex_literal_token1] = ACTIONS(185),
    [sym__number_literal] = ACTIONS(187),
    [anon_sym_SQUOTE] = ACTIONS(189),
    [anon_sym_DQUOTE] = ACTIONS(191),
    [sym_return] = ACTIONS(1011),
    [sym_next] = ACTIONS(1011),
    [sym_break] = ACTIONS(1011),
    [sym_true] = ACTIONS(1011),
    [sym_false] = ACTIONS(1011),
    [sym_null] = ACTIONS(1011),
    [sym_inf] = ACTIONS(1011),
    [sym_nan] = ACTIONS(1011),
    [anon_sym_NA] = ACTIONS(195),
    [anon_sym_NA_integer_] = ACTIONS(195),
    [anon_sym_NA_real_] = ACTIONS(195),
    [anon_sym_NA_complex_] = ACTIONS(195),
    [anon_sym_NA_character_] = ACTIONS(195),
    [sym_dots] = ACTIONS(1011),
    [sym_dot_dot_i] = ACTIONS(1013),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(531),
    [sym__newline] = ACTIONS(1015),
    [sym__semicolon] = ACTIONS(531),
    [sym__raw_string_literal] = ACTIONS(201),
    [sym__external_else] = ACTIONS(531),
    [sym__external_open_parenthesis] = ACTIONS(203),
    [sym__external_close_parenthesis] = ACTIONS(531),
    [sym__external_open_brace] = ACTIONS(207),
    [sym__external_close_brace] = ACTIONS(531),
    [sym__external_open_bracket] = ACTIONS(531),
    [sym__external_open_bracket2] = ACTIONS(531),
    [sym__external_close_bracket2] = ACTIONS(531),
  },
  [79] = {
    [sym_function_definition] = STATE(662),
    [sym_if_statement] = STATE(662),
    [sym_for_statement] = STATE(662),
    [sym_while_statement] = STATE(662),
    [sym_repeat_statement] = STATE(662),
    [sym_braced_expression] = STATE(662),
    [sym_parenthesized_expression] = STATE(662),
    [sym_call] = STATE(662),
    [sym_subset] = STATE(662),
    [sym_subset2] = STATE(662),
    [sym_unary_operator] = STATE(662),
    [sym_binary_operator] = STATE(662),
    [sym_extract_operator] = STATE(662),
    [sym_namespace_operator] = STATE(662),
    [sym_integer] = STATE(662),
    [sym_complex] = STATE(662),
    [sym_float] = STATE(662),
    [sym__hex_literal] = STATE(1925),
    [sym__float_literal] = STATE(1925),
    [sym_string] = STATE(1927),
    [sym__single_quoted_string] = STATE(1923),
    [sym__double_quoted_string] = STATE(1934),
    [sym_na] = STATE(662),
    [sym__expression] = STATE(662),
    [sym__string_or_identifier] = STATE(5137),
    [sym__open_parenthesis] = STATE(14),
    [sym__open_brace] = STATE(18),
    [aux_sym_function_definition_repeat1] = STATE(72),
    [sym_identifier] = ACTIONS(161),
    [anon_sym_BSLASH] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(463),
    [anon_sym_if] = ACTIONS(167),
    [anon_sym_for] = ACTIONS(169),
    [anon_sym_while] = ACTIONS(171),
    [anon_sym_repeat] = ACTIONS(173),
    [anon_sym_QMARK] = ACTIONS(175),
    [anon_sym_TILDE] = ACTIONS(177),
    [anon_sym_BANG] = ACTIONS(179),
    [anon_sym_PLUS] = ACTIONS(181),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_LT_DASH] = ACTIONS(461),
    [anon_sym_LT_LT_DASH] = ACTIONS(461),
    [anon_sym_COLON_EQ] = ACTIONS(461),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_DASH_GT_GT] = ACTIONS(461),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_PIPE_PIPE] = ACTIONS(461),
    [anon_sym_AMP_AMP] = ACTIONS(461),
    [anon_sym_LT] = ACTIONS(463),
    [anon_sym_LT_EQ] = ACTIONS(461),
    [anon_sym_GT] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(461),
    [anon_sym_EQ_EQ] = ACTIONS(461),
    [anon_sym_BANG_EQ] = ACTIONS(461),
    [anon_sym_STAR] = ACTIONS(463),
    [anon_sym_SLASH] = ACTIONS(461),
    [anon_sym_STAR_STAR] = ACTIONS(461),
    [anon_sym_CARET] = ACTIONS(461),
    [aux_sym_binary_operator_token1] = ACTIONS(461),
    [anon_sym_PIPE_GT] = ACTIONS(461),
    [anon_sym_COLON] = ACTIONS(463),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_AT] = ACTIONS(461),
    [aux_sym__hex_literal_token1] = ACTIONS(185),
    [sym__number_literal] = ACTIONS(187),
    [anon_sym_SQUOTE] = ACTIONS(189),
    [anon_sym_DQUOTE] = ACTIONS(191),
    [sym_return] = ACTIONS(1017),
    [sym_next] = ACTIONS(1017),
    [sym_break] = ACTIONS(1017),
    [sym_true] = ACTIONS(1017),
    [sym_false] = ACTIONS(1017),
    [sym_null] = ACTIONS(1017),
    [sym_inf] = ACTIONS(1017),
    [sym_nan] = ACTIONS(1017),
    [anon_sym_NA] = ACTIONS(195),
    [anon_sym_NA_integer_] = ACTIONS(195),
    [anon_sym_NA_real_] = ACTIONS(195),
    [anon_sym_NA_complex_] = ACTIONS(195),
    [anon_sym_NA_character_] = ACTIONS(195),
    [sym_dots] = ACTIONS(1017),
    [sym_dot_dot_i] = ACTIONS(1019),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(461),
    [sym__newline] = ACTIONS(1021),
    [sym__semicolon] = ACTIONS(461),
    [sym__raw_string_literal] = ACTIONS(201),
    [sym__external_else] = ACTIONS(461),
    [sym__external_open_parenthesis] = ACTIONS(203),
    [sym__external_close_parenthesis] = ACTIONS(461),
    [sym__external_open_brace] = ACTIONS(207),
    [sym__external_close_brace] = ACTIONS(461),
    [sym__external_open_bracket] = ACTIONS(461),
    [sym__external_open_bracket2] = ACTIONS(461),
    [sym__external_close_bracket2] = ACTIONS(461),
  },
  [80] = {
    [sym_function_definition] = STATE(615),
    [sym_if_statement] = STATE(615),
    [sym_for_statement] = STATE(615),
    [sym_while_statement] = STATE(615),
    [sym_repeat_statement] = STATE(615),
    [sym_braced_expression] = STATE(615),
    [sym_parenthesized_expression] = STATE(615),
    [sym_call] = STATE(615),
    [sym_subset] = STATE(615),
    [sym_subset2] = STATE(615),
    [sym_unary_operator] = STATE(615),
    [sym_binary_operator] = STATE(615),
    [sym_extract_operator] = STATE(615),
    [sym_namespace_operator] = STATE(615),
    [sym_integer] = STATE(615),
    [sym_complex] = STATE(615),
    [sym_float] = STATE(615),
    [sym__hex_literal] = STATE(1925),
    [sym__float_literal] = STATE(1925),
    [sym_string] = STATE(1927),
    [sym__single_quoted_string] = STATE(1923),
    [sym__double_quoted_string] = STATE(1934),
    [sym_na] = STATE(615),
    [sym__expression] = STATE(615),
    [sym__string_or_identifier] = STATE(5137),
    [sym__open_parenthesis] = STATE(14),
    [sym__open_brace] = STATE(18),
    [aux_sym_function_definition_repeat1] = STATE(99),
    [sym_identifier] = ACTIONS(161),
    [anon_sym_BSLASH] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(167),
    [anon_sym_for] = ACTIONS(169),
    [anon_sym_while] = ACTIONS(171),
    [anon_sym_repeat] = ACTIONS(173),
    [anon_sym_QMARK] = ACTIONS(175),
    [anon_sym_TILDE] = ACTIONS(177),
    [anon_sym_BANG] = ACTIONS(179),
    [anon_sym_PLUS] = ACTIONS(181),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_LT_DASH] = ACTIONS(263),
    [anon_sym_LT_LT_DASH] = ACTIONS(263),
    [anon_sym_COLON_EQ] = ACTIONS(263),
    [anon_sym_DASH_GT] = ACTIONS(265),
    [anon_sym_DASH_GT_GT] = ACTIONS(263),
    [anon_sym_PIPE] = ACTIONS(265),
    [anon_sym_AMP] = ACTIONS(265),
    [anon_sym_PIPE_PIPE] = ACTIONS(263),
    [anon_sym_AMP_AMP] = ACTIONS(263),
    [anon_sym_LT] = ACTIONS(265),
    [anon_sym_LT_EQ] = ACTIONS(263),
    [anon_sym_GT] = ACTIONS(265),
    [anon_sym_GT_EQ] = ACTIONS(263),
    [anon_sym_EQ_EQ] = ACTIONS(263),
    [anon_sym_BANG_EQ] = ACTIONS(263),
    [anon_sym_STAR] = ACTIONS(265),
    [anon_sym_SLASH] = ACTIONS(263),
    [anon_sym_STAR_STAR] = ACTIONS(263),
    [anon_sym_CARET] = ACTIONS(263),
    [aux_sym_binary_operator_token1] = ACTIONS(263),
    [anon_sym_PIPE_GT] = ACTIONS(263),
    [anon_sym_COLON] = ACTIONS(265),
    [anon_sym_DOLLAR] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(263),
    [aux_sym__hex_literal_token1] = ACTIONS(185),
    [sym__number_literal] = ACTIONS(187),
    [anon_sym_SQUOTE] = ACTIONS(189),
    [anon_sym_DQUOTE] = ACTIONS(191),
    [sym_return] = ACTIONS(1023),
    [sym_next] = ACTIONS(1023),
    [sym_break] = ACTIONS(1023),
    [sym_true] = ACTIONS(1023),
    [sym_false] = ACTIONS(1023),
    [sym_null] = ACTIONS(1023),
    [sym_inf] = ACTIONS(1023),
    [sym_nan] = ACTIONS(1023),
    [anon_sym_NA] = ACTIONS(195),
    [anon_sym_NA_integer_] = ACTIONS(195),
    [anon_sym_NA_real_] = ACTIONS(195),
    [anon_sym_NA_complex_] = ACTIONS(195),
    [anon_sym_NA_character_] = ACTIONS(195),
    [sym_dots] = ACTIONS(1023),
    [sym_dot_dot_i] = ACTIONS(1025),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(263),
    [sym__newline] = ACTIONS(1027),
    [sym__semicolon] = ACTIONS(263),
    [sym__raw_string_literal] = ACTIONS(201),
    [sym__external_else] = ACTIONS(263),
    [sym__external_open_parenthesis] = ACTIONS(203),
    [sym__external_close_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(207),
    [sym__external_close_brace] = ACTIONS(263),
    [sym__external_open_bracket] = ACTIONS(263),
    [sym__external_open_bracket2] = ACTIONS(263),
    [sym__external_close_bracket2] = ACTIONS(263),
  },
  [81] = {
    [sym_function_definition] = STATE(661),
    [sym_if_statement] = STATE(661),
    [sym_for_statement] = STATE(661),
    [sym_while_statement] = STATE(661),
    [sym_repeat_statement] = STATE(661),
    [sym_braced_expression] = STATE(661),
    [sym_parenthesized_expression] = STATE(661),
    [sym_call] = STATE(661),
    [sym_subset] = STATE(661),
    [sym_subset2] = STATE(661),
    [sym_unary_operator] = STATE(661),
    [sym_binary_operator] = STATE(661),
    [sym_extract_operator] = STATE(661),
    [sym_namespace_operator] = STATE(661),
    [sym_integer] = STATE(661),
    [sym_complex] = STATE(661),
    [sym_float] = STATE(661),
    [sym__hex_literal] = STATE(1925),
    [sym__float_literal] = STATE(1925),
    [sym_string] = STATE(1927),
    [sym__single_quoted_string] = STATE(1923),
    [sym__double_quoted_string] = STATE(1934),
    [sym_na] = STATE(661),
    [sym__expression] = STATE(661),
    [sym__string_or_identifier] = STATE(5137),
    [sym__open_parenthesis] = STATE(14),
    [sym__open_brace] = STATE(18),
    [aux_sym_function_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(161),
    [anon_sym_BSLASH] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(455),
    [anon_sym_if] = ACTIONS(167),
    [anon_sym_for] = ACTIONS(169),
    [anon_sym_while] = ACTIONS(171),
    [anon_sym_repeat] = ACTIONS(173),
    [anon_sym_QMARK] = ACTIONS(175),
    [anon_sym_TILDE] = ACTIONS(177),
    [anon_sym_BANG] = ACTIONS(179),
    [anon_sym_PLUS] = ACTIONS(181),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [anon_sym_LT_LT_DASH] = ACTIONS(453),
    [anon_sym_COLON_EQ] = ACTIONS(453),
    [anon_sym_DASH_GT] = ACTIONS(455),
    [anon_sym_DASH_GT_GT] = ACTIONS(453),
    [anon_sym_PIPE] = ACTIONS(455),
    [anon_sym_AMP] = ACTIONS(455),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(455),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_GT] = ACTIONS(455),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(453),
    [anon_sym_STAR] = ACTIONS(455),
    [anon_sym_SLASH] = ACTIONS(453),
    [anon_sym_STAR_STAR] = ACTIONS(453),
    [anon_sym_CARET] = ACTIONS(453),
    [aux_sym_binary_operator_token1] = ACTIONS(453),
    [anon_sym_PIPE_GT] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(455),
    [anon_sym_DOLLAR] = ACTIONS(453),
    [anon_sym_AT] = ACTIONS(453),
    [aux_sym__hex_literal_token1] = ACTIONS(185),
    [sym__number_literal] = ACTIONS(187),
    [anon_sym_SQUOTE] = ACTIONS(189),
    [anon_sym_DQUOTE] = ACTIONS(191),
    [sym_return] = ACTIONS(1029),
    [sym_next] = ACTIONS(1029),
    [sym_break] = ACTIONS(1029),
    [sym_true] = ACTIONS(1029),
    [sym_false] = ACTIONS(1029),
    [sym_null] = ACTIONS(1029),
    [sym_inf] = ACTIONS(1029),
    [sym_nan] = ACTIONS(1029),
    [anon_sym_NA] = ACTIONS(195),
    [anon_sym_NA_integer_] = ACTIONS(195),
    [anon_sym_NA_real_] = ACTIONS(195),
    [anon_sym_NA_complex_] = ACTIONS(195),
    [anon_sym_NA_character_] = ACTIONS(195),
    [sym_dots] = ACTIONS(1029),
    [sym_dot_dot_i] = ACTIONS(1031),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(453),
    [sym__newline] = ACTIONS(453),
    [sym__semicolon] = ACTIONS(453),
    [sym__raw_string_literal] = ACTIONS(201),
    [sym__external_else] = ACTIONS(453),
    [sym__external_open_parenthesis] = ACTIONS(203),
    [sym__external_close_parenthesis] = ACTIONS(453),
    [sym__external_open_brace] = ACTIONS(207),
    [sym__external_close_brace] = ACTIONS(453),
    [sym__external_open_bracket] = ACTIONS(453),
    [sym__external_open_bracket2] = ACTIONS(453),
    [sym__external_close_bracket2] = ACTIONS(453),
  },
  [82] = {
    [sym_function_definition] = STATE(612),
    [sym_if_statement] = STATE(612),
    [sym_for_statement] = STATE(612),
    [sym_while_statement] = STATE(612),
    [sym_repeat_statement] = STATE(612),
    [sym_braced_expression] = STATE(612),
    [sym_parenthesized_expression] = STATE(612),
    [sym_call] = STATE(612),
    [sym_subset] = STATE(612),
    [sym_subset2] = STATE(612),
    [sym_unary_operator] = STATE(612),
    [sym_binary_operator] = STATE(612),
    [sym_extract_operator] = STATE(612),
    [sym_namespace_operator] = STATE(612),
    [sym_integer] = STATE(612),
    [sym_complex] = STATE(612),
    [sym_float] = STATE(612),
    [sym__hex_literal] = STATE(2021),
    [sym__float_literal] = STATE(2021),
    [sym_string] = STATE(2016),
    [sym__single_quoted_string] = STATE(2027),
    [sym__double_quoted_string] = STATE(2041),
    [sym_na] = STATE(612),
    [sym__expression] = STATE(612),
    [sym__string_or_identifier] = STATE(5131),
    [sym__open_parenthesis] = STATE(20),
    [sym__open_brace] = STATE(10),
    [aux_sym_function_definition_repeat1] = STATE(91),
    [sym_identifier] = ACTIONS(103),
    [anon_sym_BSLASH] = ACTIONS(105),
    [anon_sym_function] = ACTIONS(107),
    [anon_sym_EQ] = ACTIONS(463),
    [anon_sym_if] = ACTIONS(111),
    [anon_sym_for] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_repeat] = ACTIONS(117),
    [anon_sym_QMARK] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_BANG] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(125),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_LT_DASH] = ACTIONS(461),
    [anon_sym_LT_LT_DASH] = ACTIONS(461),
    [anon_sym_COLON_EQ] = ACTIONS(461),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_DASH_GT_GT] = ACTIONS(461),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_PIPE_PIPE] = ACTIONS(461),
    [anon_sym_AMP_AMP] = ACTIONS(461),
    [anon_sym_LT] = ACTIONS(463),
    [anon_sym_LT_EQ] = ACTIONS(461),
    [anon_sym_GT] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(461),
    [anon_sym_EQ_EQ] = ACTIONS(461),
    [anon_sym_BANG_EQ] = ACTIONS(461),
    [anon_sym_STAR] = ACTIONS(463),
    [anon_sym_SLASH] = ACTIONS(461),
    [anon_sym_STAR_STAR] = ACTIONS(461),
    [anon_sym_CARET] = ACTIONS(461),
    [aux_sym_binary_operator_token1] = ACTIONS(461),
    [anon_sym_PIPE_GT] = ACTIONS(461),
    [anon_sym_COLON] = ACTIONS(463),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_AT] = ACTIONS(461),
    [aux_sym__hex_literal_token1] = ACTIONS(131),
    [sym__number_literal] = ACTIONS(133),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(137),
    [sym_return] = ACTIONS(1033),
    [sym_next] = ACTIONS(1033),
    [sym_break] = ACTIONS(1033),
    [sym_true] = ACTIONS(1033),
    [sym_false] = ACTIONS(1033),
    [sym_null] = ACTIONS(1033),
    [sym_inf] = ACTIONS(1033),
    [sym_nan] = ACTIONS(1033),
    [anon_sym_NA] = ACTIONS(141),
    [anon_sym_NA_integer_] = ACTIONS(141),
    [anon_sym_NA_real_] = ACTIONS(141),
    [anon_sym_NA_complex_] = ACTIONS(141),
    [anon_sym_NA_character_] = ACTIONS(141),
    [sym_dots] = ACTIONS(1033),
    [sym_dot_dot_i] = ACTIONS(1035),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(461),
    [sym__newline] = ACTIONS(1037),
    [sym__semicolon] = ACTIONS(461),
    [sym__raw_string_literal] = ACTIONS(147),
    [sym__external_else] = ACTIONS(461),
    [sym__external_open_parenthesis] = ACTIONS(149),
    [sym__external_close_parenthesis] = ACTIONS(461),
    [sym__external_open_brace] = ACTIONS(153),
    [sym__external_close_brace] = ACTIONS(461),
    [sym__external_open_bracket] = ACTIONS(461),
    [sym__external_close_bracket] = ACTIONS(461),
    [sym__external_open_bracket2] = ACTIONS(461),
  },
  [83] = {
    [sym_function_definition] = STATE(506),
    [sym_if_statement] = STATE(506),
    [sym_for_statement] = STATE(506),
    [sym_while_statement] = STATE(506),
    [sym_repeat_statement] = STATE(506),
    [sym_braced_expression] = STATE(506),
    [sym_parenthesized_expression] = STATE(506),
    [sym_call] = STATE(506),
    [sym_subset] = STATE(506),
    [sym_subset2] = STATE(506),
    [sym_unary_operator] = STATE(506),
    [sym_binary_operator] = STATE(506),
    [sym_extract_operator] = STATE(506),
    [sym_namespace_operator] = STATE(506),
    [sym_integer] = STATE(506),
    [sym_complex] = STATE(506),
    [sym_float] = STATE(506),
    [sym__hex_literal] = STATE(2021),
    [sym__float_literal] = STATE(2021),
    [sym_string] = STATE(2016),
    [sym__single_quoted_string] = STATE(2027),
    [sym__double_quoted_string] = STATE(2041),
    [sym_na] = STATE(506),
    [sym__expression] = STATE(506),
    [sym__string_or_identifier] = STATE(5131),
    [sym__open_parenthesis] = STATE(20),
    [sym__open_brace] = STATE(10),
    [aux_sym_parenthesized_expression_repeat1] = STATE(83),
    [sym_identifier] = ACTIONS(1039),
    [anon_sym_BSLASH] = ACTIONS(1042),
    [anon_sym_function] = ACTIONS(1045),
    [anon_sym_EQ] = ACTIONS(814),
    [anon_sym_if] = ACTIONS(1048),
    [anon_sym_for] = ACTIONS(1051),
    [anon_sym_while] = ACTIONS(1054),
    [anon_sym_repeat] = ACTIONS(1057),
    [anon_sym_QMARK] = ACTIONS(1060),
    [anon_sym_TILDE] = ACTIONS(1063),
    [anon_sym_BANG] = ACTIONS(1066),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1072),
    [anon_sym_LT_DASH] = ACTIONS(803),
    [anon_sym_LT_LT_DASH] = ACTIONS(803),
    [anon_sym_COLON_EQ] = ACTIONS(803),
    [anon_sym_DASH_GT] = ACTIONS(814),
    [anon_sym_DASH_GT_GT] = ACTIONS(803),
    [anon_sym_PIPE] = ACTIONS(814),
    [anon_sym_AMP] = ACTIONS(814),
    [anon_sym_PIPE_PIPE] = ACTIONS(803),
    [anon_sym_AMP_AMP] = ACTIONS(803),
    [anon_sym_LT] = ACTIONS(814),
    [anon_sym_LT_EQ] = ACTIONS(803),
    [anon_sym_GT] = ACTIONS(814),
    [anon_sym_GT_EQ] = ACTIONS(803),
    [anon_sym_EQ_EQ] = ACTIONS(803),
    [anon_sym_BANG_EQ] = ACTIONS(803),
    [anon_sym_STAR] = ACTIONS(814),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_STAR_STAR] = ACTIONS(803),
    [anon_sym_CARET] = ACTIONS(803),
    [aux_sym_binary_operator_token1] = ACTIONS(803),
    [anon_sym_PIPE_GT] = ACTIONS(803),
    [anon_sym_COLON] = ACTIONS(814),
    [anon_sym_DOLLAR] = ACTIONS(803),
    [anon_sym_AT] = ACTIONS(803),
    [aux_sym__hex_literal_token1] = ACTIONS(1075),
    [sym__number_literal] = ACTIONS(1078),
    [anon_sym_SQUOTE] = ACTIONS(1081),
    [anon_sym_DQUOTE] = ACTIONS(1084),
    [sym_return] = ACTIONS(1087),
    [sym_next] = ACTIONS(1087),
    [sym_break] = ACTIONS(1087),
    [sym_true] = ACTIONS(1087),
    [sym_false] = ACTIONS(1087),
    [sym_null] = ACTIONS(1087),
    [sym_inf] = ACTIONS(1087),
    [sym_nan] = ACTIONS(1087),
    [anon_sym_NA] = ACTIONS(1090),
    [anon_sym_NA_integer_] = ACTIONS(1090),
    [anon_sym_NA_real_] = ACTIONS(1090),
    [anon_sym_NA_complex_] = ACTIONS(1090),
    [anon_sym_NA_character_] = ACTIONS(1090),
    [sym_dots] = ACTIONS(1087),
    [sym_dot_dot_i] = ACTIONS(1093),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(803),
    [sym__newline] = ACTIONS(1096),
    [sym__semicolon] = ACTIONS(803),
    [sym__raw_string_literal] = ACTIONS(1099),
    [sym__external_else] = ACTIONS(803),
    [sym__external_open_parenthesis] = ACTIONS(1102),
    [sym__external_close_parenthesis] = ACTIONS(803),
    [sym__external_open_brace] = ACTIONS(1105),
    [sym__external_close_brace] = ACTIONS(803),
    [sym__external_open_bracket] = ACTIONS(803),
    [sym__external_close_bracket] = ACTIONS(803),
    [sym__external_open_bracket2] = ACTIONS(803),
  },
  [84] = {
    [sym_function_definition] = STATE(791),
    [sym_if_statement] = STATE(791),
    [sym_for_statement] = STATE(791),
    [sym_while_statement] = STATE(791),
    [sym_repeat_statement] = STATE(791),
    [sym_braced_expression] = STATE(791),
    [sym_parenthesized_expression] = STATE(791),
    [sym_call] = STATE(791),
    [sym_subset] = STATE(791),
    [sym_subset2] = STATE(791),
    [sym_unary_operator] = STATE(791),
    [sym_binary_operator] = STATE(791),
    [sym_extract_operator] = STATE(791),
    [sym_namespace_operator] = STATE(791),
    [sym_integer] = STATE(791),
    [sym_complex] = STATE(791),
    [sym_float] = STATE(791),
    [sym__hex_literal] = STATE(2183),
    [sym__float_literal] = STATE(2183),
    [sym_string] = STATE(2169),
    [sym__single_quoted_string] = STATE(2181),
    [sym__double_quoted_string] = STATE(2180),
    [sym_na] = STATE(791),
    [sym__expression] = STATE(791),
    [sym__string_or_identifier] = STATE(5149),
    [sym__open_parenthesis] = STATE(67),
    [sym__close_parenthesis] = STATE(2470),
    [sym__open_brace] = STATE(24),
    [aux_sym_parenthesized_expression_repeat1] = STATE(139),
    [ts_builtin_sym_end] = ACTIONS(211),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_BSLASH] = ACTIONS(323),
    [anon_sym_function] = ACTIONS(325),
    [anon_sym_EQ] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(327),
    [anon_sym_for] = ACTIONS(329),
    [anon_sym_while] = ACTIONS(331),
    [anon_sym_repeat] = ACTIONS(333),
    [anon_sym_QMARK] = ACTIONS(335),
    [anon_sym_TILDE] = ACTIONS(337),
    [anon_sym_BANG] = ACTIONS(339),
    [anon_sym_PLUS] = ACTIONS(341),
    [anon_sym_DASH] = ACTIONS(343),
    [anon_sym_LT_DASH] = ACTIONS(211),
    [anon_sym_LT_LT_DASH] = ACTIONS(211),
    [anon_sym_COLON_EQ] = ACTIONS(211),
    [anon_sym_DASH_GT] = ACTIONS(209),
    [anon_sym_DASH_GT_GT] = ACTIONS(211),
    [anon_sym_PIPE] = ACTIONS(209),
    [anon_sym_AMP] = ACTIONS(209),
    [anon_sym_PIPE_PIPE] = ACTIONS(211),
    [anon_sym_AMP_AMP] = ACTIONS(211),
    [anon_sym_LT] = ACTIONS(209),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_GT] = ACTIONS(209),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [anon_sym_EQ_EQ] = ACTIONS(211),
    [anon_sym_BANG_EQ] = ACTIONS(211),
    [anon_sym_STAR] = ACTIONS(209),
    [anon_sym_SLASH] = ACTIONS(211),
    [anon_sym_STAR_STAR] = ACTIONS(211),
    [anon_sym_CARET] = ACTIONS(211),
    [aux_sym_binary_operator_token1] = ACTIONS(211),
    [anon_sym_PIPE_GT] = ACTIONS(211),
    [anon_sym_COLON] = ACTIONS(209),
    [anon_sym_DOLLAR] = ACTIONS(211),
    [anon_sym_AT] = ACTIONS(211),
    [aux_sym__hex_literal_token1] = ACTIONS(345),
    [sym__number_literal] = ACTIONS(347),
    [anon_sym_SQUOTE] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(351),
    [sym_return] = ACTIONS(971),
    [sym_next] = ACTIONS(971),
    [sym_break] = ACTIONS(971),
    [sym_true] = ACTIONS(971),
    [sym_false] = ACTIONS(971),
    [sym_null] = ACTIONS(971),
    [sym_inf] = ACTIONS(971),
    [sym_nan] = ACTIONS(971),
    [anon_sym_NA] = ACTIONS(355),
    [anon_sym_NA_integer_] = ACTIONS(355),
    [anon_sym_NA_real_] = ACTIONS(355),
    [anon_sym_NA_complex_] = ACTIONS(355),
    [anon_sym_NA_character_] = ACTIONS(355),
    [sym_dots] = ACTIONS(971),
    [sym_dot_dot_i] = ACTIONS(973),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(211),
    [sym__newline] = ACTIONS(975),
    [sym__semicolon] = ACTIONS(211),
    [sym__raw_string_literal] = ACTIONS(361),
    [sym__external_open_parenthesis] = ACTIONS(363),
    [sym__external_close_parenthesis] = ACTIONS(1108),
    [sym__external_open_brace] = ACTIONS(365),
    [sym__external_close_brace] = ACTIONS(211),
    [sym__external_open_bracket] = ACTIONS(211),
    [sym__external_open_bracket2] = ACTIONS(211),
  },
  [85] = {
    [sym_function_definition] = STATE(658),
    [sym_if_statement] = STATE(658),
    [sym_for_statement] = STATE(658),
    [sym_while_statement] = STATE(658),
    [sym_repeat_statement] = STATE(658),
    [sym_braced_expression] = STATE(658),
    [sym_parenthesized_expression] = STATE(658),
    [sym_call] = STATE(658),
    [sym_subset] = STATE(658),
    [sym_subset2] = STATE(658),
    [sym_unary_operator] = STATE(658),
    [sym_binary_operator] = STATE(658),
    [sym_extract_operator] = STATE(658),
    [sym_namespace_operator] = STATE(658),
    [sym_integer] = STATE(658),
    [sym_complex] = STATE(658),
    [sym_float] = STATE(658),
    [sym__hex_literal] = STATE(1925),
    [sym__float_literal] = STATE(1925),
    [sym_string] = STATE(1927),
    [sym__single_quoted_string] = STATE(1923),
    [sym__double_quoted_string] = STATE(1934),
    [sym_na] = STATE(658),
    [sym__expression] = STATE(658),
    [sym__string_or_identifier] = STATE(5137),
    [sym__open_parenthesis] = STATE(14),
    [sym__open_brace] = STATE(18),
    [aux_sym_function_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(161),
    [anon_sym_BSLASH] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(399),
    [anon_sym_if] = ACTIONS(167),
    [anon_sym_for] = ACTIONS(169),
    [anon_sym_while] = ACTIONS(171),
    [anon_sym_repeat] = ACTIONS(173),
    [anon_sym_QMARK] = ACTIONS(175),
    [anon_sym_TILDE] = ACTIONS(177),
    [anon_sym_BANG] = ACTIONS(179),
    [anon_sym_PLUS] = ACTIONS(181),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_LT_DASH] = ACTIONS(397),
    [anon_sym_LT_LT_DASH] = ACTIONS(397),
    [anon_sym_COLON_EQ] = ACTIONS(397),
    [anon_sym_DASH_GT] = ACTIONS(399),
    [anon_sym_DASH_GT_GT] = ACTIONS(397),
    [anon_sym_PIPE] = ACTIONS(399),
    [anon_sym_AMP] = ACTIONS(399),
    [anon_sym_PIPE_PIPE] = ACTIONS(397),
    [anon_sym_AMP_AMP] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(399),
    [anon_sym_LT_EQ] = ACTIONS(397),
    [anon_sym_GT] = ACTIONS(399),
    [anon_sym_GT_EQ] = ACTIONS(397),
    [anon_sym_EQ_EQ] = ACTIONS(397),
    [anon_sym_BANG_EQ] = ACTIONS(397),
    [anon_sym_STAR] = ACTIONS(399),
    [anon_sym_SLASH] = ACTIONS(397),
    [anon_sym_STAR_STAR] = ACTIONS(397),
    [anon_sym_CARET] = ACTIONS(397),
    [aux_sym_binary_operator_token1] = ACTIONS(397),
    [anon_sym_PIPE_GT] = ACTIONS(397),
    [anon_sym_COLON] = ACTIONS(399),
    [anon_sym_DOLLAR] = ACTIONS(397),
    [anon_sym_AT] = ACTIONS(397),
    [aux_sym__hex_literal_token1] = ACTIONS(185),
    [sym__number_literal] = ACTIONS(187),
    [anon_sym_SQUOTE] = ACTIONS(189),
    [anon_sym_DQUOTE] = ACTIONS(191),
    [sym_return] = ACTIONS(1110),
    [sym_next] = ACTIONS(1110),
    [sym_break] = ACTIONS(1110),
    [sym_true] = ACTIONS(1110),
    [sym_false] = ACTIONS(1110),
    [sym_null] = ACTIONS(1110),
    [sym_inf] = ACTIONS(1110),
    [sym_nan] = ACTIONS(1110),
    [anon_sym_NA] = ACTIONS(195),
    [anon_sym_NA_integer_] = ACTIONS(195),
    [anon_sym_NA_real_] = ACTIONS(195),
    [anon_sym_NA_complex_] = ACTIONS(195),
    [anon_sym_NA_character_] = ACTIONS(195),
    [sym_dots] = ACTIONS(1110),
    [sym_dot_dot_i] = ACTIONS(1112),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(397),
    [sym__newline] = ACTIONS(397),
    [sym__semicolon] = ACTIONS(397),
    [sym__raw_string_literal] = ACTIONS(201),
    [sym__external_else] = ACTIONS(397),
    [sym__external_open_parenthesis] = ACTIONS(203),
    [sym__external_close_parenthesis] = ACTIONS(397),
    [sym__external_open_brace] = ACTIONS(207),
    [sym__external_close_brace] = ACTIONS(397),
    [sym__external_open_bracket] = ACTIONS(397),
    [sym__external_open_bracket2] = ACTIONS(397),
    [sym__external_close_bracket2] = ACTIONS(397),
  },
  [86] = {
    [sym_function_definition] = STATE(611),
    [sym_if_statement] = STATE(611),
    [sym_for_statement] = STATE(611),
    [sym_while_statement] = STATE(611),
    [sym_repeat_statement] = STATE(611),
    [sym_braced_expression] = STATE(611),
    [sym_parenthesized_expression] = STATE(611),
    [sym_call] = STATE(611),
    [sym_subset] = STATE(611),
    [sym_subset2] = STATE(611),
    [sym_unary_operator] = STATE(611),
    [sym_binary_operator] = STATE(611),
    [sym_extract_operator] = STATE(611),
    [sym_namespace_operator] = STATE(611),
    [sym_integer] = STATE(611),
    [sym_complex] = STATE(611),
    [sym_float] = STATE(611),
    [sym__hex_literal] = STATE(2021),
    [sym__float_literal] = STATE(2021),
    [sym_string] = STATE(2016),
    [sym__single_quoted_string] = STATE(2027),
    [sym__double_quoted_string] = STATE(2041),
    [sym_na] = STATE(611),
    [sym__expression] = STATE(611),
    [sym__string_or_identifier] = STATE(5131),
    [sym__open_parenthesis] = STATE(20),
    [sym__open_brace] = STATE(10),
    [aux_sym_function_definition_repeat1] = STATE(2199),
    [sym_identifier] = ACTIONS(103),
    [anon_sym_BSLASH] = ACTIONS(105),
    [anon_sym_function] = ACTIONS(107),
    [anon_sym_EQ] = ACTIONS(455),
    [anon_sym_if] = ACTIONS(111),
    [anon_sym_for] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_repeat] = ACTIONS(117),
    [anon_sym_QMARK] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_BANG] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(125),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [anon_sym_LT_LT_DASH] = ACTIONS(453),
    [anon_sym_COLON_EQ] = ACTIONS(453),
    [anon_sym_DASH_GT] = ACTIONS(455),
    [anon_sym_DASH_GT_GT] = ACTIONS(453),
    [anon_sym_PIPE] = ACTIONS(455),
    [anon_sym_AMP] = ACTIONS(455),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(455),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_GT] = ACTIONS(455),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(453),
    [anon_sym_STAR] = ACTIONS(455),
    [anon_sym_SLASH] = ACTIONS(453),
    [anon_sym_STAR_STAR] = ACTIONS(453),
    [anon_sym_CARET] = ACTIONS(453),
    [aux_sym_binary_operator_token1] = ACTIONS(453),
    [anon_sym_PIPE_GT] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(455),
    [anon_sym_DOLLAR] = ACTIONS(453),
    [anon_sym_AT] = ACTIONS(453),
    [aux_sym__hex_literal_token1] = ACTIONS(131),
    [sym__number_literal] = ACTIONS(133),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(137),
    [sym_return] = ACTIONS(1114),
    [sym_next] = ACTIONS(1114),
    [sym_break] = ACTIONS(1114),
    [sym_true] = ACTIONS(1114),
    [sym_false] = ACTIONS(1114),
    [sym_null] = ACTIONS(1114),
    [sym_inf] = ACTIONS(1114),
    [sym_nan] = ACTIONS(1114),
    [anon_sym_NA] = ACTIONS(141),
    [anon_sym_NA_integer_] = ACTIONS(141),
    [anon_sym_NA_real_] = ACTIONS(141),
    [anon_sym_NA_complex_] = ACTIONS(141),
    [anon_sym_NA_character_] = ACTIONS(141),
    [sym_dots] = ACTIONS(1114),
    [sym_dot_dot_i] = ACTIONS(1116),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(453),
    [sym__newline] = ACTIONS(453),
    [sym__semicolon] = ACTIONS(453),
    [sym__raw_string_literal] = ACTIONS(147),
    [sym__external_else] = ACTIONS(453),
    [sym__external_open_parenthesis] = ACTIONS(149),
    [sym__external_close_parenthesis] = ACTIONS(453),
    [sym__external_open_brace] = ACTIONS(153),
    [sym__external_close_brace] = ACTIONS(453),
    [sym__external_open_bracket] = ACTIONS(453),
    [sym__external_close_bracket] = ACTIONS(453),
    [sym__external_open_bracket2] = ACTIONS(453),
  },
  [87] = {
    [sym_function_definition] = STATE(639),
    [sym_if_statement] = STATE(639),
    [sym_for_statement] = STATE(639),
    [sym_while_statement] = STATE(639),
    [sym_repeat_statement] = STATE(639),
    [sym_braced_expression] = STATE(639),
    [sym_parenthesized_expression] = STATE(639),
    [sym_call] = STATE(639),
    [sym_subset] = STATE(639),
    [sym_subset2] = STATE(639),
    [sym_unary_operator] = STATE(639),
    [sym_binary_operator] = STATE(639),
    [sym_extract_operator] = STATE(639),
    [sym_namespace_operator] = STATE(639),
    [sym_integer] = STATE(639),
    [sym_complex] = STATE(639),
    [sym_float] = STATE(639),
    [sym__hex_literal] = STATE(1925),
    [sym__float_literal] = STATE(1925),
    [sym_string] = STATE(1927),
    [sym__single_quoted_string] = STATE(1923),
    [sym__double_quoted_string] = STATE(1934),
    [sym_na] = STATE(639),
    [sym__expression] = STATE(639),
    [sym__string_or_identifier] = STATE(5137),
    [sym__open_parenthesis] = STATE(14),
    [sym__open_brace] = STATE(18),
    [aux_sym_function_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(161),
    [anon_sym_BSLASH] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(759),
    [anon_sym_if] = ACTIONS(167),
    [anon_sym_for] = ACTIONS(169),
    [anon_sym_while] = ACTIONS(171),
    [anon_sym_repeat] = ACTIONS(173),
    [anon_sym_QMARK] = ACTIONS(175),
    [anon_sym_TILDE] = ACTIONS(177),
    [anon_sym_BANG] = ACTIONS(179),
    [anon_sym_PLUS] = ACTIONS(181),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_LT_DASH] = ACTIONS(757),
    [anon_sym_LT_LT_DASH] = ACTIONS(757),
    [anon_sym_COLON_EQ] = ACTIONS(757),
    [anon_sym_DASH_GT] = ACTIONS(759),
    [anon_sym_DASH_GT_GT] = ACTIONS(757),
    [anon_sym_PIPE] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(759),
    [anon_sym_PIPE_PIPE] = ACTIONS(757),
    [anon_sym_AMP_AMP] = ACTIONS(757),
    [anon_sym_LT] = ACTIONS(759),
    [anon_sym_LT_EQ] = ACTIONS(757),
    [anon_sym_GT] = ACTIONS(759),
    [anon_sym_GT_EQ] = ACTIONS(757),
    [anon_sym_EQ_EQ] = ACTIONS(757),
    [anon_sym_BANG_EQ] = ACTIONS(757),
    [anon_sym_STAR] = ACTIONS(759),
    [anon_sym_SLASH] = ACTIONS(757),
    [anon_sym_STAR_STAR] = ACTIONS(757),
    [anon_sym_CARET] = ACTIONS(757),
    [aux_sym_binary_operator_token1] = ACTIONS(757),
    [anon_sym_PIPE_GT] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(759),
    [anon_sym_DOLLAR] = ACTIONS(757),
    [anon_sym_AT] = ACTIONS(757),
    [aux_sym__hex_literal_token1] = ACTIONS(185),
    [sym__number_literal] = ACTIONS(187),
    [anon_sym_SQUOTE] = ACTIONS(189),
    [anon_sym_DQUOTE] = ACTIONS(191),
    [sym_return] = ACTIONS(1118),
    [sym_next] = ACTIONS(1118),
    [sym_break] = ACTIONS(1118),
    [sym_true] = ACTIONS(1118),
    [sym_false] = ACTIONS(1118),
    [sym_null] = ACTIONS(1118),
    [sym_inf] = ACTIONS(1118),
    [sym_nan] = ACTIONS(1118),
    [anon_sym_NA] = ACTIONS(195),
    [anon_sym_NA_integer_] = ACTIONS(195),
    [anon_sym_NA_real_] = ACTIONS(195),
    [anon_sym_NA_complex_] = ACTIONS(195),
    [anon_sym_NA_character_] = ACTIONS(195),
    [sym_dots] = ACTIONS(1118),
    [sym_dot_dot_i] = ACTIONS(1120),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(757),
    [sym__newline] = ACTIONS(757),
    [sym__semicolon] = ACTIONS(757),
    [sym__raw_string_literal] = ACTIONS(201),
    [sym__external_else] = ACTIONS(757),
    [sym__external_open_parenthesis] = ACTIONS(203),
    [sym__external_close_parenthesis] = ACTIONS(757),
    [sym__external_open_brace] = ACTIONS(207),
    [sym__external_close_brace] = ACTIONS(757),
    [sym__external_open_bracket] = ACTIONS(757),
    [sym__external_open_bracket2] = ACTIONS(757),
    [sym__external_close_bracket2] = ACTIONS(757),
  },
  [88] = {
    [sym_function_definition] = STATE(657),
    [sym_if_statement] = STATE(657),
    [sym_for_statement] = STATE(657),
    [sym_while_statement] = STATE(657),
    [sym_repeat_statement] = STATE(657),
    [sym_braced_expression] = STATE(657),
    [sym_parenthesized_expression] = STATE(657),
    [sym_call] = STATE(657),
    [sym_subset] = STATE(657),
    [sym_subset2] = STATE(657),
    [sym_unary_operator] = STATE(657),
    [sym_binary_operator] = STATE(657),
    [sym_extract_operator] = STATE(657),
    [sym_namespace_operator] = STATE(657),
    [sym_integer] = STATE(657),
    [sym_complex] = STATE(657),
    [sym_float] = STATE(657),
    [sym__hex_literal] = STATE(1925),
    [sym__float_literal] = STATE(1925),
    [sym_string] = STATE(1927),
    [sym__single_quoted_string] = STATE(1923),
    [sym__double_quoted_string] = STATE(1934),
    [sym_na] = STATE(657),
    [sym__expression] = STATE(657),
    [sym__string_or_identifier] = STATE(5137),
    [sym__open_parenthesis] = STATE(14),
    [sym__open_brace] = STATE(18),
    [aux_sym_function_definition_repeat1] = STATE(81),
    [sym_identifier] = ACTIONS(161),
    [anon_sym_BSLASH] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(167),
    [anon_sym_for] = ACTIONS(169),
    [anon_sym_while] = ACTIONS(171),
    [anon_sym_repeat] = ACTIONS(173),
    [anon_sym_QMARK] = ACTIONS(175),
    [anon_sym_TILDE] = ACTIONS(177),
    [anon_sym_BANG] = ACTIONS(179),
    [anon_sym_PLUS] = ACTIONS(181),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_LT_DASH] = ACTIONS(387),
    [anon_sym_LT_LT_DASH] = ACTIONS(387),
    [anon_sym_COLON_EQ] = ACTIONS(387),
    [anon_sym_DASH_GT] = ACTIONS(389),
    [anon_sym_DASH_GT_GT] = ACTIONS(387),
    [anon_sym_PIPE] = ACTIONS(389),
    [anon_sym_AMP] = ACTIONS(389),
    [anon_sym_PIPE_PIPE] = ACTIONS(387),
    [anon_sym_AMP_AMP] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(389),
    [anon_sym_LT_EQ] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(389),
    [anon_sym_GT_EQ] = ACTIONS(387),
    [anon_sym_EQ_EQ] = ACTIONS(387),
    [anon_sym_BANG_EQ] = ACTIONS(387),
    [anon_sym_STAR] = ACTIONS(389),
    [anon_sym_SLASH] = ACTIONS(387),
    [anon_sym_STAR_STAR] = ACTIONS(387),
    [anon_sym_CARET] = ACTIONS(387),
    [aux_sym_binary_operator_token1] = ACTIONS(387),
    [anon_sym_PIPE_GT] = ACTIONS(387),
    [anon_sym_COLON] = ACTIONS(389),
    [anon_sym_DOLLAR] = ACTIONS(387),
    [anon_sym_AT] = ACTIONS(387),
    [aux_sym__hex_literal_token1] = ACTIONS(185),
    [sym__number_literal] = ACTIONS(187),
    [anon_sym_SQUOTE] = ACTIONS(189),
    [anon_sym_DQUOTE] = ACTIONS(191),
    [sym_return] = ACTIONS(1122),
    [sym_next] = ACTIONS(1122),
    [sym_break] = ACTIONS(1122),
    [sym_true] = ACTIONS(1122),
    [sym_false] = ACTIONS(1122),
    [sym_null] = ACTIONS(1122),
    [sym_inf] = ACTIONS(1122),
    [sym_nan] = ACTIONS(1122),
    [anon_sym_NA] = ACTIONS(195),
    [anon_sym_NA_integer_] = ACTIONS(195),
    [anon_sym_NA_real_] = ACTIONS(195),
    [anon_sym_NA_complex_] = ACTIONS(195),
    [anon_sym_NA_character_] = ACTIONS(195),
    [sym_dots] = ACTIONS(1122),
    [sym_dot_dot_i] = ACTIONS(1124),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(387),
    [sym__newline] = ACTIONS(1126),
    [sym__semicolon] = ACTIONS(387),
    [sym__raw_string_literal] = ACTIONS(201),
    [sym__external_else] = ACTIONS(387),
    [sym__external_open_parenthesis] = ACTIONS(203),
    [sym__external_close_parenthesis] = ACTIONS(387),
    [sym__external_open_brace] = ACTIONS(207),
    [sym__external_close_brace] = ACTIONS(387),
    [sym__external_open_bracket] = ACTIONS(387),
    [sym__external_open_bracket2] = ACTIONS(387),
    [sym__external_close_bracket2] = ACTIONS(387),
  },
  [89] = {
    [sym_function_definition] = STATE(655),
    [sym_if_statement] = STATE(655),
    [sym_for_statement] = STATE(655),
    [sym_while_statement] = STATE(655),
    [sym_repeat_statement] = STATE(655),
    [sym_braced_expression] = STATE(655),
    [sym_parenthesized_expression] = STATE(655),
    [sym_call] = STATE(655),
    [sym_subset] = STATE(655),
    [sym_subset2] = STATE(655),
    [sym_unary_operator] = STATE(655),
    [sym_binary_operator] = STATE(655),
    [sym_extract_operator] = STATE(655),
    [sym_namespace_operator] = STATE(655),
    [sym_integer] = STATE(655),
    [sym_complex] = STATE(655),
    [sym_float] = STATE(655),
    [sym__hex_literal] = STATE(1925),
    [sym__float_literal] = STATE(1925),
    [sym_string] = STATE(1927),
    [sym__single_quoted_string] = STATE(1923),
    [sym__double_quoted_string] = STATE(1934),
    [sym_na] = STATE(655),
    [sym__expression] = STATE(655),
    [sym__string_or_identifier] = STATE(5137),
    [sym__open_parenthesis] = STATE(14),
    [sym__open_brace] = STATE(18),
    [aux_sym_function_definition_repeat1] = STATE(85),
    [sym_identifier] = ACTIONS(161),
    [anon_sym_BSLASH] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(379),
    [anon_sym_if] = ACTIONS(167),
    [anon_sym_for] = ACTIONS(169),
    [anon_sym_while] = ACTIONS(171),
    [anon_sym_repeat] = ACTIONS(173),
    [anon_sym_QMARK] = ACTIONS(175),
    [anon_sym_TILDE] = ACTIONS(177),
    [anon_sym_BANG] = ACTIONS(179),
    [anon_sym_PLUS] = ACTIONS(181),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_LT_DASH] = ACTIONS(377),
    [anon_sym_LT_LT_DASH] = ACTIONS(377),
    [anon_sym_COLON_EQ] = ACTIONS(377),
    [anon_sym_DASH_GT] = ACTIONS(379),
    [anon_sym_DASH_GT_GT] = ACTIONS(377),
    [anon_sym_PIPE] = ACTIONS(379),
    [anon_sym_AMP] = ACTIONS(379),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_LT] = ACTIONS(379),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(379),
    [anon_sym_GT_EQ] = ACTIONS(377),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(379),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_STAR_STAR] = ACTIONS(377),
    [anon_sym_CARET] = ACTIONS(377),
    [aux_sym_binary_operator_token1] = ACTIONS(377),
    [anon_sym_PIPE_GT] = ACTIONS(377),
    [anon_sym_COLON] = ACTIONS(379),
    [anon_sym_DOLLAR] = ACTIONS(377),
    [anon_sym_AT] = ACTIONS(377),
    [aux_sym__hex_literal_token1] = ACTIONS(185),
    [sym__number_literal] = ACTIONS(187),
    [anon_sym_SQUOTE] = ACTIONS(189),
    [anon_sym_DQUOTE] = ACTIONS(191),
    [sym_return] = ACTIONS(1128),
    [sym_next] = ACTIONS(1128),
    [sym_break] = ACTIONS(1128),
    [sym_true] = ACTIONS(1128),
    [sym_false] = ACTIONS(1128),
    [sym_null] = ACTIONS(1128),
    [sym_inf] = ACTIONS(1128),
    [sym_nan] = ACTIONS(1128),
    [anon_sym_NA] = ACTIONS(195),
    [anon_sym_NA_integer_] = ACTIONS(195),
    [anon_sym_NA_real_] = ACTIONS(195),
    [anon_sym_NA_complex_] = ACTIONS(195),
    [anon_sym_NA_character_] = ACTIONS(195),
    [sym_dots] = ACTIONS(1128),
    [sym_dot_dot_i] = ACTIONS(1130),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(377),
    [sym__newline] = ACTIONS(1132),
    [sym__semicolon] = ACTIONS(377),
    [sym__raw_string_literal] = ACTIONS(201),
    [sym__external_else] = ACTIONS(377),
    [sym__external_open_parenthesis] = ACTIONS(203),
    [sym__external_close_parenthesis] = ACTIONS(377),
    [sym__external_open_brace] = ACTIONS(207),
    [sym__external_close_brace] = ACTIONS(377),
    [sym__external_open_bracket] = ACTIONS(377),
    [sym__external_open_bracket2] = ACTIONS(377),
    [sym__external_close_bracket2] = ACTIONS(377),
  },
  [90] = {
    [sym_function_definition] = STATE(654),
    [sym_if_statement] = STATE(654),
    [sym_for_statement] = STATE(654),
    [sym_while_statement] = STATE(654),
    [sym_repeat_statement] = STATE(654),
    [sym_braced_expression] = STATE(654),
    [sym_parenthesized_expression] = STATE(654),
    [sym_call] = STATE(654),
    [sym_subset] = STATE(654),
    [sym_subset2] = STATE(654),
    [sym_unary_operator] = STATE(654),
    [sym_binary_operator] = STATE(654),
    [sym_extract_operator] = STATE(654),
    [sym_namespace_operator] = STATE(654),
    [sym_integer] = STATE(654),
    [sym_complex] = STATE(654),
    [sym_float] = STATE(654),
    [sym__hex_literal] = STATE(1925),
    [sym__float_literal] = STATE(1925),
    [sym_string] = STATE(1927),
    [sym__single_quoted_string] = STATE(1923),
    [sym__double_quoted_string] = STATE(1934),
    [sym_na] = STATE(654),
    [sym__expression] = STATE(654),
    [sym__string_or_identifier] = STATE(5137),
    [sym__open_parenthesis] = STATE(14),
    [sym__open_brace] = STATE(18),
    [aux_sym_function_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(161),
    [anon_sym_BSLASH] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(167),
    [anon_sym_for] = ACTIONS(169),
    [anon_sym_while] = ACTIONS(171),
    [anon_sym_repeat] = ACTIONS(173),
    [anon_sym_QMARK] = ACTIONS(175),
    [anon_sym_TILDE] = ACTIONS(177),
    [anon_sym_BANG] = ACTIONS(179),
    [anon_sym_PLUS] = ACTIONS(181),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_LT_DASH] = ACTIONS(369),
    [anon_sym_LT_LT_DASH] = ACTIONS(369),
    [anon_sym_COLON_EQ] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(371),
    [anon_sym_DASH_GT_GT] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(371),
    [anon_sym_AMP] = ACTIONS(371),
    [anon_sym_PIPE_PIPE] = ACTIONS(369),
    [anon_sym_AMP_AMP] = ACTIONS(369),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_LT_EQ] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_EQ] = ACTIONS(369),
    [anon_sym_EQ_EQ] = ACTIONS(369),
    [anon_sym_BANG_EQ] = ACTIONS(369),
    [anon_sym_STAR] = ACTIONS(371),
    [anon_sym_SLASH] = ACTIONS(369),
    [anon_sym_STAR_STAR] = ACTIONS(369),
    [anon_sym_CARET] = ACTIONS(369),
    [aux_sym_binary_operator_token1] = ACTIONS(369),
    [anon_sym_PIPE_GT] = ACTIONS(369),
    [anon_sym_COLON] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(369),
    [anon_sym_AT] = ACTIONS(369),
    [aux_sym__hex_literal_token1] = ACTIONS(185),
    [sym__number_literal] = ACTIONS(187),
    [anon_sym_SQUOTE] = ACTIONS(189),
    [anon_sym_DQUOTE] = ACTIONS(191),
    [sym_return] = ACTIONS(1134),
    [sym_next] = ACTIONS(1134),
    [sym_break] = ACTIONS(1134),
    [sym_true] = ACTIONS(1134),
    [sym_false] = ACTIONS(1134),
    [sym_null] = ACTIONS(1134),
    [sym_inf] = ACTIONS(1134),
    [sym_nan] = ACTIONS(1134),
    [anon_sym_NA] = ACTIONS(195),
    [anon_sym_NA_integer_] = ACTIONS(195),
    [anon_sym_NA_real_] = ACTIONS(195),
    [anon_sym_NA_complex_] = ACTIONS(195),
    [anon_sym_NA_character_] = ACTIONS(195),
    [sym_dots] = ACTIONS(1134),
    [sym_dot_dot_i] = ACTIONS(1136),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(369),
    [sym__newline] = ACTIONS(369),
    [sym__semicolon] = ACTIONS(369),
    [sym__raw_string_literal] = ACTIONS(201),
    [sym__external_else] = ACTIONS(369),
    [sym__external_open_parenthesis] = ACTIONS(203),
    [sym__external_close_parenthesis] = ACTIONS(369),
    [sym__external_open_brace] = ACTIONS(207),
    [sym__external_close_brace] = ACTIONS(369),
    [sym__external_open_bracket] = ACTIONS(369),
    [sym__external_open_bracket2] = ACTIONS(369),
    [sym__external_close_bracket2] = ACTIONS(369),
  },
  [91] = {
    [sym_function_definition] = STATE(614),
    [sym_if_statement] = STATE(614),
    [sym_for_statement] = STATE(614),
    [sym_while_statement] = STATE(614),
    [sym_repeat_statement] = STATE(614),
    [sym_braced_expression] = STATE(614),
    [sym_parenthesized_expression] = STATE(614),
    [sym_call] = STATE(614),
    [sym_subset] = STATE(614),
    [sym_subset2] = STATE(614),
    [sym_unary_operator] = STATE(614),
    [sym_binary_operator] = STATE(614),
    [sym_extract_operator] = STATE(614),
    [sym_namespace_operator] = STATE(614),
    [sym_integer] = STATE(614),
    [sym_complex] = STATE(614),
    [sym_float] = STATE(614),
    [sym__hex_literal] = STATE(2021),
    [sym__float_literal] = STATE(2021),
    [sym_string] = STATE(2016),
    [sym__single_quoted_string] = STATE(2027),
    [sym__double_quoted_string] = STATE(2041),
    [sym_na] = STATE(614),
    [sym__expression] = STATE(614),
    [sym__string_or_identifier] = STATE(5131),
    [sym__open_parenthesis] = STATE(20),
    [sym__open_brace] = STATE(10),
    [aux_sym_function_definition_repeat1] = STATE(2199),
    [sym_identifier] = ACTIONS(103),
    [anon_sym_BSLASH] = ACTIONS(105),
    [anon_sym_function] = ACTIONS(107),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_if] = ACTIONS(111),
    [anon_sym_for] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_repeat] = ACTIONS(117),
    [anon_sym_QMARK] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_BANG] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(125),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_LT_DASH] = ACTIONS(471),
    [anon_sym_LT_LT_DASH] = ACTIONS(471),
    [anon_sym_COLON_EQ] = ACTIONS(471),
    [anon_sym_DASH_GT] = ACTIONS(473),
    [anon_sym_DASH_GT_GT] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(473),
    [anon_sym_AMP] = ACTIONS(473),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_LT_EQ] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(473),
    [anon_sym_GT_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_STAR] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [aux_sym_binary_operator_token1] = ACTIONS(471),
    [anon_sym_PIPE_GT] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(473),
    [anon_sym_DOLLAR] = ACTIONS(471),
    [anon_sym_AT] = ACTIONS(471),
    [aux_sym__hex_literal_token1] = ACTIONS(131),
    [sym__number_literal] = ACTIONS(133),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(137),
    [sym_return] = ACTIONS(1138),
    [sym_next] = ACTIONS(1138),
    [sym_break] = ACTIONS(1138),
    [sym_true] = ACTIONS(1138),
    [sym_false] = ACTIONS(1138),
    [sym_null] = ACTIONS(1138),
    [sym_inf] = ACTIONS(1138),
    [sym_nan] = ACTIONS(1138),
    [anon_sym_NA] = ACTIONS(141),
    [anon_sym_NA_integer_] = ACTIONS(141),
    [anon_sym_NA_real_] = ACTIONS(141),
    [anon_sym_NA_complex_] = ACTIONS(141),
    [anon_sym_NA_character_] = ACTIONS(141),
    [sym_dots] = ACTIONS(1138),
    [sym_dot_dot_i] = ACTIONS(1140),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(471),
    [sym__newline] = ACTIONS(471),
    [sym__semicolon] = ACTIONS(471),
    [sym__raw_string_literal] = ACTIONS(147),
    [sym__external_else] = ACTIONS(471),
    [sym__external_open_parenthesis] = ACTIONS(149),
    [sym__external_close_parenthesis] = ACTIONS(471),
    [sym__external_open_brace] = ACTIONS(153),
    [sym__external_close_brace] = ACTIONS(471),
    [sym__external_open_bracket] = ACTIONS(471),
    [sym__external_close_bracket] = ACTIONS(471),
    [sym__external_open_bracket2] = ACTIONS(471),
  },
  [92] = {
    [sym_function_definition] = STATE(607),
    [sym_if_statement] = STATE(607),
    [sym_for_statement] = STATE(607),
    [sym_while_statement] = STATE(607),
    [sym_repeat_statement] = STATE(607),
    [sym_braced_expression] = STATE(607),
    [sym_parenthesized_expression] = STATE(607),
    [sym_call] = STATE(607),
    [sym_subset] = STATE(607),
    [sym_subset2] = STATE(607),
    [sym_unary_operator] = STATE(607),
    [sym_binary_operator] = STATE(607),
    [sym_extract_operator] = STATE(607),
    [sym_namespace_operator] = STATE(607),
    [sym_integer] = STATE(607),
    [sym_complex] = STATE(607),
    [sym_float] = STATE(607),
    [sym__hex_literal] = STATE(2021),
    [sym__float_literal] = STATE(2021),
    [sym_string] = STATE(2016),
    [sym__single_quoted_string] = STATE(2027),
    [sym__double_quoted_string] = STATE(2041),
    [sym_na] = STATE(607),
    [sym__expression] = STATE(607),
    [sym__string_or_identifier] = STATE(5131),
    [sym__open_parenthesis] = STATE(20),
    [sym__open_brace] = STATE(10),
    [aux_sym_function_definition_repeat1] = STATE(86),
    [sym_identifier] = ACTIONS(103),
    [anon_sym_BSLASH] = ACTIONS(105),
    [anon_sym_function] = ACTIONS(107),
    [anon_sym_EQ] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(111),
    [anon_sym_for] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_repeat] = ACTIONS(117),
    [anon_sym_QMARK] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_BANG] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(125),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_LT_DASH] = ACTIONS(387),
    [anon_sym_LT_LT_DASH] = ACTIONS(387),
    [anon_sym_COLON_EQ] = ACTIONS(387),
    [anon_sym_DASH_GT] = ACTIONS(389),
    [anon_sym_DASH_GT_GT] = ACTIONS(387),
    [anon_sym_PIPE] = ACTIONS(389),
    [anon_sym_AMP] = ACTIONS(389),
    [anon_sym_PIPE_PIPE] = ACTIONS(387),
    [anon_sym_AMP_AMP] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(389),
    [anon_sym_LT_EQ] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(389),
    [anon_sym_GT_EQ] = ACTIONS(387),
    [anon_sym_EQ_EQ] = ACTIONS(387),
    [anon_sym_BANG_EQ] = ACTIONS(387),
    [anon_sym_STAR] = ACTIONS(389),
    [anon_sym_SLASH] = ACTIONS(387),
    [anon_sym_STAR_STAR] = ACTIONS(387),
    [anon_sym_CARET] = ACTIONS(387),
    [aux_sym_binary_operator_token1] = ACTIONS(387),
    [anon_sym_PIPE_GT] = ACTIONS(387),
    [anon_sym_COLON] = ACTIONS(389),
    [anon_sym_DOLLAR] = ACTIONS(387),
    [anon_sym_AT] = ACTIONS(387),
    [aux_sym__hex_literal_token1] = ACTIONS(131),
    [sym__number_literal] = ACTIONS(133),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(137),
    [sym_return] = ACTIONS(1142),
    [sym_next] = ACTIONS(1142),
    [sym_break] = ACTIONS(1142),
    [sym_true] = ACTIONS(1142),
    [sym_false] = ACTIONS(1142),
    [sym_null] = ACTIONS(1142),
    [sym_inf] = ACTIONS(1142),
    [sym_nan] = ACTIONS(1142),
    [anon_sym_NA] = ACTIONS(141),
    [anon_sym_NA_integer_] = ACTIONS(141),
    [anon_sym_NA_real_] = ACTIONS(141),
    [anon_sym_NA_complex_] = ACTIONS(141),
    [anon_sym_NA_character_] = ACTIONS(141),
    [sym_dots] = ACTIONS(1142),
    [sym_dot_dot_i] = ACTIONS(1144),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(387),
    [sym__newline] = ACTIONS(1146),
    [sym__semicolon] = ACTIONS(387),
    [sym__raw_string_literal] = ACTIONS(147),
    [sym__external_else] = ACTIONS(387),
    [sym__external_open_parenthesis] = ACTIONS(149),
    [sym__external_close_parenthesis] = ACTIONS(387),
    [sym__external_open_brace] = ACTIONS(153),
    [sym__external_close_brace] = ACTIONS(387),
    [sym__external_open_bracket] = ACTIONS(387),
    [sym__external_close_bracket] = ACTIONS(387),
    [sym__external_open_bracket2] = ACTIONS(387),
  },
  [93] = {
    [sym_function_definition] = STATE(770),
    [sym_if_statement] = STATE(770),
    [sym_for_statement] = STATE(770),
    [sym_while_statement] = STATE(770),
    [sym_repeat_statement] = STATE(770),
    [sym_braced_expression] = STATE(770),
    [sym_parenthesized_expression] = STATE(770),
    [sym_call] = STATE(770),
    [sym_subset] = STATE(770),
    [sym_subset2] = STATE(770),
    [sym_unary_operator] = STATE(770),
    [sym_binary_operator] = STATE(770),
    [sym_extract_operator] = STATE(770),
    [sym_namespace_operator] = STATE(770),
    [sym_integer] = STATE(770),
    [sym_complex] = STATE(770),
    [sym_float] = STATE(770),
    [sym__hex_literal] = STATE(2189),
    [sym__float_literal] = STATE(2189),
    [sym_string] = STATE(2192),
    [sym__single_quoted_string] = STATE(2188),
    [sym__double_quoted_string] = STATE(2187),
    [sym_na] = STATE(770),
    [sym__expression] = STATE(770),
    [sym__string_or_identifier] = STATE(5139),
    [sym__open_parenthesis] = STATE(57),
    [sym__open_brace] = STATE(59),
    [sym__close_brace] = STATE(2488),
    [aux_sym_braced_expression_repeat1] = STATE(110),
    [sym_identifier] = ACTIONS(273),
    [anon_sym_BSLASH] = ACTIONS(275),
    [anon_sym_function] = ACTIONS(277),
    [anon_sym_EQ] = ACTIONS(59),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_for] = ACTIONS(281),
    [anon_sym_while] = ACTIONS(283),
    [anon_sym_repeat] = ACTIONS(285),
    [anon_sym_QMARK] = ACTIONS(287),
    [anon_sym_TILDE] = ACTIONS(289),
    [anon_sym_BANG] = ACTIONS(291),
    [anon_sym_PLUS] = ACTIONS(293),
    [anon_sym_DASH] = ACTIONS(295),
    [anon_sym_LT_DASH] = ACTIONS(51),
    [anon_sym_LT_LT_DASH] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(51),
    [anon_sym_DASH_GT] = ACTIONS(59),
    [anon_sym_DASH_GT_GT] = ACTIONS(51),
    [anon_sym_PIPE] = ACTIONS(59),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_AMP_AMP] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(59),
    [anon_sym_LT_EQ] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(59),
    [anon_sym_GT_EQ] = ACTIONS(51),
    [anon_sym_EQ_EQ] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(51),
    [anon_sym_CARET] = ACTIONS(51),
    [aux_sym_binary_operator_token1] = ACTIONS(51),
    [anon_sym_PIPE_GT] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(59),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_AT] = ACTIONS(51),
    [aux_sym__hex_literal_token1] = ACTIONS(297),
    [sym__number_literal] = ACTIONS(299),
    [anon_sym_SQUOTE] = ACTIONS(301),
    [anon_sym_DQUOTE] = ACTIONS(303),
    [sym_return] = ACTIONS(876),
    [sym_next] = ACTIONS(876),
    [sym_break] = ACTIONS(876),
    [sym_true] = ACTIONS(876),
    [sym_false] = ACTIONS(876),
    [sym_null] = ACTIONS(876),
    [sym_inf] = ACTIONS(876),
    [sym_nan] = ACTIONS(876),
    [anon_sym_NA] = ACTIONS(307),
    [anon_sym_NA_integer_] = ACTIONS(307),
    [anon_sym_NA_real_] = ACTIONS(307),
    [anon_sym_NA_complex_] = ACTIONS(307),
    [anon_sym_NA_character_] = ACTIONS(307),
    [sym_dots] = ACTIONS(876),
    [sym_dot_dot_i] = ACTIONS(878),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(51),
    [sym__newline] = ACTIONS(880),
    [sym__semicolon] = ACTIONS(880),
    [sym__raw_string_literal] = ACTIONS(313),
    [sym__external_open_parenthesis] = ACTIONS(315),
    [sym__external_close_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(319),
    [sym__external_close_brace] = ACTIONS(1148),
    [sym__external_open_bracket] = ACTIONS(51),
    [sym__external_close_bracket] = ACTIONS(51),
    [sym__external_open_bracket2] = ACTIONS(51),
  },
  [94] = {
    [sym_function_definition] = STATE(599),
    [sym_if_statement] = STATE(599),
    [sym_for_statement] = STATE(599),
    [sym_while_statement] = STATE(599),
    [sym_repeat_statement] = STATE(599),
    [sym_braced_expression] = STATE(599),
    [sym_parenthesized_expression] = STATE(599),
    [sym_call] = STATE(599),
    [sym_subset] = STATE(599),
    [sym_subset2] = STATE(599),
    [sym_unary_operator] = STATE(599),
    [sym_binary_operator] = STATE(599),
    [sym_extract_operator] = STATE(599),
    [sym_namespace_operator] = STATE(599),
    [sym_integer] = STATE(599),
    [sym_complex] = STATE(599),
    [sym_float] = STATE(599),
    [sym__hex_literal] = STATE(1984),
    [sym__float_literal] = STATE(1984),
    [sym_string] = STATE(1982),
    [sym__single_quoted_string] = STATE(1985),
    [sym__double_quoted_string] = STATE(1990),
    [sym_na] = STATE(599),
    [sym__expression] = STATE(599),
    [sym__string_or_identifier] = STATE(5151),
    [sym__open_parenthesis] = STATE(19),
    [sym__open_brace] = STATE(4),
    [sym__close_brace] = STATE(2685),
    [aux_sym_braced_expression_repeat1] = STATE(75),
    [ts_builtin_sym_end] = ACTIONS(155),
    [sym_identifier] = ACTIONS(53),
    [anon_sym_BSLASH] = ACTIONS(55),
    [anon_sym_function] = ACTIONS(57),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(61),
    [anon_sym_for] = ACTIONS(63),
    [anon_sym_while] = ACTIONS(65),
    [anon_sym_repeat] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_LT_DASH] = ACTIONS(155),
    [anon_sym_LT_LT_DASH] = ACTIONS(155),
    [anon_sym_COLON_EQ] = ACTIONS(155),
    [anon_sym_DASH_GT] = ACTIONS(157),
    [anon_sym_DASH_GT_GT] = ACTIONS(155),
    [anon_sym_PIPE] = ACTIONS(157),
    [anon_sym_AMP] = ACTIONS(157),
    [anon_sym_PIPE_PIPE] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(157),
    [anon_sym_LT_EQ] = ACTIONS(155),
    [anon_sym_GT] = ACTIONS(157),
    [anon_sym_GT_EQ] = ACTIONS(155),
    [anon_sym_EQ_EQ] = ACTIONS(155),
    [anon_sym_BANG_EQ] = ACTIONS(155),
    [anon_sym_STAR] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(155),
    [anon_sym_STAR_STAR] = ACTIONS(155),
    [anon_sym_CARET] = ACTIONS(155),
    [aux_sym_binary_operator_token1] = ACTIONS(155),
    [anon_sym_PIPE_GT] = ACTIONS(155),
    [anon_sym_COLON] = ACTIONS(157),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(155),
    [aux_sym__hex_literal_token1] = ACTIONS(79),
    [sym__number_literal] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_return] = ACTIONS(87),
    [sym_next] = ACTIONS(87),
    [sym_break] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_inf] = ACTIONS(87),
    [sym_nan] = ACTIONS(87),
    [anon_sym_NA] = ACTIONS(89),
    [anon_sym_NA_integer_] = ACTIONS(89),
    [anon_sym_NA_real_] = ACTIONS(89),
    [anon_sym_NA_complex_] = ACTIONS(89),
    [anon_sym_NA_character_] = ACTIONS(89),
    [sym_dots] = ACTIONS(87),
    [sym_dot_dot_i] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(93),
    [sym__semicolon] = ACTIONS(93),
    [sym__raw_string_literal] = ACTIONS(95),
    [sym__external_else] = ACTIONS(155),
    [sym__external_open_parenthesis] = ACTIONS(97),
    [sym__external_close_parenthesis] = ACTIONS(155),
    [sym__external_open_brace] = ACTIONS(99),
    [sym__external_close_brace] = ACTIONS(1150),
    [sym__external_open_bracket] = ACTIONS(155),
    [sym__external_open_bracket2] = ACTIONS(155),
  },
  [95] = {
    [sym_function_definition] = STATE(502),
    [sym_if_statement] = STATE(502),
    [sym_for_statement] = STATE(502),
    [sym_while_statement] = STATE(502),
    [sym_repeat_statement] = STATE(502),
    [sym_braced_expression] = STATE(502),
    [sym_parenthesized_expression] = STATE(502),
    [sym_call] = STATE(502),
    [sym_subset] = STATE(502),
    [sym_subset2] = STATE(502),
    [sym_unary_operator] = STATE(502),
    [sym_binary_operator] = STATE(502),
    [sym_extract_operator] = STATE(502),
    [sym_namespace_operator] = STATE(502),
    [sym_integer] = STATE(502),
    [sym_complex] = STATE(502),
    [sym_float] = STATE(502),
    [sym__hex_literal] = STATE(1925),
    [sym__float_literal] = STATE(1925),
    [sym_string] = STATE(1927),
    [sym__single_quoted_string] = STATE(1923),
    [sym__double_quoted_string] = STATE(1934),
    [sym_na] = STATE(502),
    [sym__expression] = STATE(502),
    [sym__string_or_identifier] = STATE(5137),
    [sym__open_parenthesis] = STATE(14),
    [sym__open_brace] = STATE(18),
    [aux_sym_parenthesized_expression_repeat1] = STATE(95),
    [sym_identifier] = ACTIONS(1152),
    [anon_sym_BSLASH] = ACTIONS(1155),
    [anon_sym_function] = ACTIONS(1158),
    [anon_sym_EQ] = ACTIONS(814),
    [anon_sym_if] = ACTIONS(1161),
    [anon_sym_for] = ACTIONS(1164),
    [anon_sym_while] = ACTIONS(1167),
    [anon_sym_repeat] = ACTIONS(1170),
    [anon_sym_QMARK] = ACTIONS(1173),
    [anon_sym_TILDE] = ACTIONS(1176),
    [anon_sym_BANG] = ACTIONS(1179),
    [anon_sym_PLUS] = ACTIONS(1182),
    [anon_sym_DASH] = ACTIONS(1185),
    [anon_sym_LT_DASH] = ACTIONS(803),
    [anon_sym_LT_LT_DASH] = ACTIONS(803),
    [anon_sym_COLON_EQ] = ACTIONS(803),
    [anon_sym_DASH_GT] = ACTIONS(814),
    [anon_sym_DASH_GT_GT] = ACTIONS(803),
    [anon_sym_PIPE] = ACTIONS(814),
    [anon_sym_AMP] = ACTIONS(814),
    [anon_sym_PIPE_PIPE] = ACTIONS(803),
    [anon_sym_AMP_AMP] = ACTIONS(803),
    [anon_sym_LT] = ACTIONS(814),
    [anon_sym_LT_EQ] = ACTIONS(803),
    [anon_sym_GT] = ACTIONS(814),
    [anon_sym_GT_EQ] = ACTIONS(803),
    [anon_sym_EQ_EQ] = ACTIONS(803),
    [anon_sym_BANG_EQ] = ACTIONS(803),
    [anon_sym_STAR] = ACTIONS(814),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_STAR_STAR] = ACTIONS(803),
    [anon_sym_CARET] = ACTIONS(803),
    [aux_sym_binary_operator_token1] = ACTIONS(803),
    [anon_sym_PIPE_GT] = ACTIONS(803),
    [anon_sym_COLON] = ACTIONS(814),
    [anon_sym_DOLLAR] = ACTIONS(803),
    [anon_sym_AT] = ACTIONS(803),
    [aux_sym__hex_literal_token1] = ACTIONS(1188),
    [sym__number_literal] = ACTIONS(1191),
    [anon_sym_SQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE] = ACTIONS(1197),
    [sym_return] = ACTIONS(1200),
    [sym_next] = ACTIONS(1200),
    [sym_break] = ACTIONS(1200),
    [sym_true] = ACTIONS(1200),
    [sym_false] = ACTIONS(1200),
    [sym_null] = ACTIONS(1200),
    [sym_inf] = ACTIONS(1200),
    [sym_nan] = ACTIONS(1200),
    [anon_sym_NA] = ACTIONS(1203),
    [anon_sym_NA_integer_] = ACTIONS(1203),
    [anon_sym_NA_real_] = ACTIONS(1203),
    [anon_sym_NA_complex_] = ACTIONS(1203),
    [anon_sym_NA_character_] = ACTIONS(1203),
    [sym_dots] = ACTIONS(1200),
    [sym_dot_dot_i] = ACTIONS(1206),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(803),
    [sym__newline] = ACTIONS(1209),
    [sym__semicolon] = ACTIONS(803),
    [sym__raw_string_literal] = ACTIONS(1212),
    [sym__external_else] = ACTIONS(803),
    [sym__external_open_parenthesis] = ACTIONS(1215),
    [sym__external_close_parenthesis] = ACTIONS(803),
    [sym__external_open_brace] = ACTIONS(1218),
    [sym__external_close_brace] = ACTIONS(803),
    [sym__external_open_bracket] = ACTIONS(803),
    [sym__external_open_bracket2] = ACTIONS(803),
    [sym__external_close_bracket2] = ACTIONS(803),
  },
  [96] = {
    [sym_function_definition] = STATE(608),
    [sym_if_statement] = STATE(608),
    [sym_for_statement] = STATE(608),
    [sym_while_statement] = STATE(608),
    [sym_repeat_statement] = STATE(608),
    [sym_braced_expression] = STATE(608),
    [sym_parenthesized_expression] = STATE(608),
    [sym_call] = STATE(608),
    [sym_subset] = STATE(608),
    [sym_subset2] = STATE(608),
    [sym_unary_operator] = STATE(608),
    [sym_binary_operator] = STATE(608),
    [sym_extract_operator] = STATE(608),
    [sym_namespace_operator] = STATE(608),
    [sym_integer] = STATE(608),
    [sym_complex] = STATE(608),
    [sym_float] = STATE(608),
    [sym__hex_literal] = STATE(2021),
    [sym__float_literal] = STATE(2021),
    [sym_string] = STATE(2016),
    [sym__single_quoted_string] = STATE(2027),
    [sym__double_quoted_string] = STATE(2041),
    [sym_na] = STATE(608),
    [sym__expression] = STATE(608),
    [sym__string_or_identifier] = STATE(5131),
    [sym__open_parenthesis] = STATE(20),
    [sym__open_brace] = STATE(10),
    [aux_sym_function_definition_repeat1] = STATE(2199),
    [sym_identifier] = ACTIONS(103),
    [anon_sym_BSLASH] = ACTIONS(105),
    [anon_sym_function] = ACTIONS(107),
    [anon_sym_EQ] = ACTIONS(399),
    [anon_sym_if] = ACTIONS(111),
    [anon_sym_for] = ACTIONS(113),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_repeat] = ACTIONS(117),
    [anon_sym_QMARK] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_BANG] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(125),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_LT_DASH] = ACTIONS(397),
    [anon_sym_LT_LT_DASH] = ACTIONS(397),
    [anon_sym_COLON_EQ] = ACTIONS(397),
    [anon_sym_DASH_GT] = ACTIONS(399),
    [anon_sym_DASH_GT_GT] = ACTIONS(397),
    [anon_sym_PIPE] = ACTIONS(399),
    [anon_sym_AMP] = ACTIONS(399),
    [anon_sym_PIPE_PIPE] = ACTIONS(397),
    [anon_sym_AMP_AMP] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(399),
    [anon_sym_LT_EQ] = ACTIONS(397),
    [anon_sym_GT] = ACTIONS(399),
    [anon_sym_GT_EQ] = ACTIONS(397),
    [anon_sym_EQ_EQ] = ACTIONS(397),
    [anon_sym_BANG_EQ] = ACTIONS(397),
    [anon_sym_STAR] = ACTIONS(399),
    [anon_sym_SLASH] = ACTIONS(397),
    [anon_sym_STAR_STAR] = ACTIONS(397),
    [anon_sym_CARET] = ACTIONS(397),
    [aux_sym_binary_operator_token1] = ACTIONS(397),
    [anon_sym_PIPE_GT] = ACTIONS(397),
    [anon_sym_COLON] = ACTIONS(399),
    [anon_sym_DOLLAR] = ACTIONS(397),
    [anon_sym_AT] = ACTIONS(397),
    [aux_sym__hex_literal_token1] = ACTIONS(131),
    [sym__number_literal] = ACTIONS(133),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(137),
    [sym_return] = ACTIONS(1221),
    [sym_next] = ACTIONS(1221),
    [sym_break] = ACTIONS(1221),
    [sym_true] = ACTIONS(1221),
    [sym_false] = ACTIONS(1221),
    [sym_null] = ACTIONS(1221),
    [sym_inf] = ACTIONS(1221),
    [sym_nan] = ACTIONS(1221),
    [anon_sym_NA] = ACTIONS(141),
    [anon_sym_NA_integer_] = ACTIONS(141),
    [anon_sym_NA_real_] = ACTIONS(141),
    [anon_sym_NA_complex_] = ACTIONS(141),
    [anon_sym_NA_character_] = ACTIONS(141),
    [sym_dots] = ACTIONS(1221),
    [sym_dot_dot_i] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(397),
    [sym__newline] = ACTIONS(397),
    [sym__semicolon] = ACTIONS(397),
    [sym__raw_string_literal] = ACTIONS(147),
    [sym__external_else] = ACTIONS(397),
    [sym__external_open_parenthesis] = ACTIONS(149),
    [sym__external_close_parenthesis] = ACTIONS(397),
    [sym__external_open_brace] = ACTIONS(153),
    [sym__external_close_brace] = ACTIONS(397),
    [sym__external_open_bracket] = ACTIONS(397),
    [sym__external_close_bracket] = ACTIONS(397),
    [sym__external_open_bracket2] = ACTIONS(397),
  },
  [97] = {
    [sym_function_definition] = STATE(599),
    [sym_if_statement] = STATE(599),
    [sym_for_statement] = STATE(599),
    [sym_while_statement] = STATE(599),
    [sym_repeat_statement] = STATE(599),
    [sym_braced_expression] = STATE(599),
    [sym_parenthesized_expression] = STATE(599),
    [sym_call] = STATE(599),
    [sym_subset] = STATE(599),
    [sym_subset2] = STATE(599),
    [sym_unary_operator] = STATE(599),
    [sym_binary_operator] = STATE(599),
    [sym_extract_operator] = STATE(599),
    [sym_namespace_operator] = STATE(599),
    [sym_integer] = STATE(599),
    [sym_complex] = STATE(599),
    [sym_float] = STATE(599),
    [sym__hex_literal] = STATE(1984),
    [sym__float_literal] = STATE(1984),
    [sym_string] = STATE(1982),
    [sym__single_quoted_string] = STATE(1985),
    [sym__double_quoted_string] = STATE(1990),
    [sym_na] = STATE(599),
    [sym__expression] = STATE(599),
    [sym__string_or_identifier] = STATE(5151),
    [sym__open_parenthesis] = STATE(19),
    [sym__open_brace] = STATE(4),
    [sym__close_brace] = STATE(2891),
    [aux_sym_braced_expression_repeat1] = STATE(33),
    [sym_identifier] = ACTIONS(53),
    [anon_sym_BSLASH] = ACTIONS(55),
    [anon_sym_function] = ACTIONS(57),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(61),
    [anon_sym_for] = ACTIONS(63),
    [anon_sym_while] = ACTIONS(65),
    [anon_sym_repeat] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_LT_DASH] = ACTIONS(155),
    [anon_sym_LT_LT_DASH] = ACTIONS(155),
    [anon_sym_COLON_EQ] = ACTIONS(155),
    [anon_sym_DASH_GT] = ACTIONS(157),
    [anon_sym_DASH_GT_GT] = ACTIONS(155),
    [anon_sym_PIPE] = ACTIONS(157),
    [anon_sym_AMP] = ACTIONS(157),
    [anon_sym_PIPE_PIPE] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(157),
    [anon_sym_LT_EQ] = ACTIONS(155),
    [anon_sym_GT] = ACTIONS(157),
    [anon_sym_GT_EQ] = ACTIONS(155),
    [anon_sym_EQ_EQ] = ACTIONS(155),
    [anon_sym_BANG_EQ] = ACTIONS(155),
    [anon_sym_STAR] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(155),
    [anon_sym_STAR_STAR] = ACTIONS(155),
    [anon_sym_CARET] = ACTIONS(155),
    [aux_sym_binary_operator_token1] = ACTIONS(155),
    [anon_sym_PIPE_GT] = ACTIONS(155),
    [anon_sym_COLON] = ACTIONS(157),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(155),
    [aux_sym__hex_literal_token1] = ACTIONS(79),
    [sym__number_literal] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_return] = ACTIONS(87),
    [sym_next] = ACTIONS(87),
    [sym_break] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_inf] = ACTIONS(87),
    [sym_nan] = ACTIONS(87),
    [anon_sym_NA] = ACTIONS(89),
    [anon_sym_NA_integer_] = ACTIONS(89),
    [anon_sym_NA_real_] = ACTIONS(89),
    [anon_sym_NA_complex_] = ACTIONS(89),
    [anon_sym_NA_character_] = ACTIONS(89),
    [sym_dots] = ACTIONS(87),
    [sym_dot_dot_i] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(155),
    [sym__newline] = ACTIONS(93),
    [sym__semicolon] = ACTIONS(93),
    [sym__raw_string_literal] = ACTIONS(95),
    [sym__external_else] = ACTIONS(155),
    [sym__external_open_parenthesis] = ACTIONS(97),
    [sym__external_close_parenthesis] = ACTIONS(155),
    [sym__external_open_brace] = ACTIONS(99),
    [sym__external_close_brace] = ACTIONS(1225),
    [sym__external_open_bracket] = ACTIONS(155),
    [sym__external_open_bracket2] = ACTIONS(155),
  },
  [98] = {
    [sym_function_definition] = STATE(921),
    [sym_if_statement] = STATE(921),
    [sym_for_statement] = STATE(921),
    [sym_while_statement] = STATE(921),
    [sym_repeat_statement] = STATE(921),
    [sym_braced_expression] = STATE(921),
    [sym_parenthesized_expression] = STATE(921),
    [sym_call] = STATE(921),
    [sym_subset] = STATE(921),
    [sym_subset2] = STATE(921),
    [sym_unary_operator] = STATE(921),
    [sym_binary_operator] = STATE(921),
    [sym_extract_operator] = STATE(921),
    [sym_namespace_operator] = STATE(921),
    [sym_integer] = STATE(921),
    [sym_complex] = STATE(921),
    [sym_float] = STATE(921),
    [sym__hex_literal] = STATE(2220),
    [sym__float_literal] = STATE(2220),
    [sym_string] = STATE(2219),
    [sym__single_quoted_string] = STATE(2221),
    [sym__double_quoted_string] = STATE(2222),
    [sym_na] = STATE(921),
    [sym__expression] = STATE(921),
    [sym__string_or_identifier] = STATE(5140),
    [sym__open_parenthesis] = STATE(54),
    [sym__open_brace] = STATE(56),
    [sym__close_brace] = STATE(2498),
    [aux_sym_braced_expression_repeat1] = STATE(124),
    [sym_identifier] = ACTIONS(626),
    [anon_sym_BSLASH] = ACTIONS(628),
    [anon_sym_function] = ACTIONS(630),
    [anon_sym_EQ] = ACTIONS(59),
    [anon_sym_if] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [anon_sym_repeat] = ACTIONS(638),
    [anon_sym_QMARK] = ACTIONS(640),
    [anon_sym_TILDE] = ACTIONS(642),
    [anon_sym_BANG] = ACTIONS(644),
    [anon_sym_PLUS] = ACTIONS(646),
    [anon_sym_DASH] = ACTIONS(648),
    [anon_sym_LT_DASH] = ACTIONS(51),
    [anon_sym_LT_LT_DASH] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(51),
    [anon_sym_DASH_GT] = ACTIONS(59),
    [anon_sym_DASH_GT_GT] = ACTIONS(51),
    [anon_sym_PIPE] = ACTIONS(59),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_AMP_AMP] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(59),
    [anon_sym_LT_EQ] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(59),
    [anon_sym_GT_EQ] = ACTIONS(51),
    [anon_sym_EQ_EQ] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(51),
    [anon_sym_CARET] = ACTIONS(51),
    [aux_sym_binary_operator_token1] = ACTIONS(51),
    [anon_sym_PIPE_GT] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(59),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_AT] = ACTIONS(51),
    [aux_sym__hex_literal_token1] = ACTIONS(650),
    [sym__number_literal] = ACTIONS(652),
    [anon_sym_SQUOTE] = ACTIONS(654),
    [anon_sym_DQUOTE] = ACTIONS(656),
    [sym_return] = ACTIONS(658),
    [sym_next] = ACTIONS(658),
    [sym_break] = ACTIONS(658),
    [sym_true] = ACTIONS(658),
    [sym_false] = ACTIONS(658),
    [sym_null] = ACTIONS(658),
    [sym_inf] = ACTIONS(658),
    [sym_nan] = ACTIONS(658),
    [anon_sym_NA] = ACTIONS(660),
    [anon_sym_NA_integer_] = ACTIONS(660),
    [anon_sym_NA_real_] = ACTIONS(660),
    [anon_sym_NA_complex_] = ACTIONS(660),
    [anon_sym_NA_character_] = ACTIONS(660),
    [sym_dots] = ACTIONS(658),
    [sym_dot_dot_i] = ACTIONS(662),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(51),
    [sym__newline] = ACTIONS(664),
    [sym__semicolon] = ACTIONS(664),
    [sym__raw_string_literal] = ACTIONS(666),
    [sym__external_open_parenthesis] = ACTIONS(668),
    [sym__external_close_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(670),
    [sym__external_close_brace] = ACTIONS(1227),
    [sym__external_open_bracket] = ACTIONS(51),
    [sym__external_open_bracket2] = ACTIONS(51),
    [sym__external_close_bracket2] = ACTIONS(51),
  },
  [99] = {
    [sym_function_definition] = STATE(621),
    [sym_if_statement] = STATE(621),
    [sym_for_statement] = STATE(621),
    [sym_while_statement] = STATE(621),
    [sym_repeat_statement] = STATE(621),
    [sym_braced_expression] = STATE(621),
    [sym_parenthesized_expression] = STATE(621),
    [sym_call] = STATE(621),
    [sym_subset] = STATE(621),
    [sym_subset2] = STATE(621),
    [sym_unary_operator] = STATE(621),
    [sym_binary_operator] = STATE(621),
    [sym_extract_operator] = STATE(621),
    [sym_namespace_operator] = STATE(621),
    [sym_integer] = STATE(621),
    [sym_complex] = STATE(621),
    [sym_float] = STATE(621),
    [sym__hex_literal] = STATE(1925),
    [sym__float_literal] = STATE(1925),
    [sym_string] = STATE(1927),
    [sym__single_quoted_string] = STATE(1923),
    [sym__double_quoted_string] = STATE(1934),
    [sym_na] = STATE(621),
    [sym__expression] = STATE(621),
    [sym__string_or_identifier] = STATE(5137),
    [sym__open_parenthesis] = STATE(14),
    [sym__open_brace] = STATE(18),
    [aux_sym_function_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(161),
    [anon_sym_BSLASH] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(767),
    [anon_sym_if] = ACTIONS(167),
    [anon_sym_for] = ACTIONS(169),
    [anon_sym_while] = ACTIONS(171),
    [anon_sym_repeat] = ACTIONS(173),
    [anon_sym_QMARK] = ACTIONS(175),
    [anon_sym_TILDE] = ACTIONS(177),
    [anon_sym_BANG] = ACTIONS(179),
    [anon_sym_PLUS] = ACTIONS(181),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_LT_DASH] = ACTIONS(765),
    [anon_sym_LT_LT_DASH] = ACTIONS(765),
    [anon_sym_COLON_EQ] = ACTIONS(765),
    [anon_sym_DASH_GT] = ACTIONS(767),
    [anon_sym_DASH_GT_GT] = ACTIONS(765),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_AMP] = ACTIONS(767),
    [anon_sym_PIPE_PIPE] = ACTIONS(765),
    [anon_sym_AMP_AMP] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(767),
    [anon_sym_LT_EQ] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_GT_EQ] = ACTIONS(765),
    [anon_sym_EQ_EQ] = ACTIONS(765),
    [anon_sym_BANG_EQ] = ACTIONS(765),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(765),
    [anon_sym_STAR_STAR] = ACTIONS(765),
    [anon_sym_CARET] = ACTIONS(765),
    [aux_sym_binary_operator_token1] = ACTIONS(765),
    [anon_sym_PIPE_GT] = ACTIONS(765),
    [anon_sym_COLON] = ACTIONS(767),
    [anon_sym_DOLLAR] = ACTIONS(765),
    [anon_sym_AT] = ACTIONS(765),
    [aux_sym__hex_literal_token1] = ACTIONS(185),
    [sym__number_literal] = ACTIONS(187),
    [anon_sym_SQUOTE] = ACTIONS(189),
    [anon_sym_DQUOTE] = ACTIONS(191),
    [sym_return] = ACTIONS(1229),
    [sym_next] = ACTIONS(1229),
    [sym_break] = ACTIONS(1229),
    [sym_true] = ACTIONS(1229),
    [sym_false] = ACTIONS(1229),
    [sym_null] = ACTIONS(1229),
    [sym_inf] = ACTIONS(1229),
    [sym_nan] = ACTIONS(1229),
    [anon_sym_NA] = ACTIONS(195),
    [anon_sym_NA_integer_] = ACTIONS(195),
    [anon_sym_NA_real_] = ACTIONS(195),
    [anon_sym_NA_complex_] = ACTIONS(195),
    [anon_sym_NA_character_] = ACTIONS(195),
    [sym_dots] = ACTIONS(1229),
    [sym_dot_dot_i] = ACTIONS(1231),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(765),
    [sym__newline] = ACTIONS(765),
    [sym__semicolon] = ACTIONS(765),
    [sym__raw_string_literal] = ACTIONS(201),
    [sym__external_else] = ACTIONS(765),
    [sym__external_open_parenthesis] = ACTIONS(203),
    [sym__external_close_parenthesis] = ACTIONS(765),
    [sym__external_open_brace] = ACTIONS(207),
    [sym__external_close_brace] = ACTIONS(765),
    [sym__external_open_bracket] = ACTIONS(765),
    [sym__external_open_bracket2] = ACTIONS(765),
    [sym__external_close_bracket2] = ACTIONS(765),
  },
  [100] = {
    [sym_function_definition] = STATE(863),
    [sym_if_statement] = STATE(863),
    [sym_for_statement] = STATE(863),
    [sym_while_statement] = STATE(863),
    [sym_repeat_statement] = STATE(863),
    [sym_braced_expression] = STATE(863),
    [sym_parenthesized_expression] = STATE(863),
    [sym_call] = STATE(863),
    [sym_subset] = STATE(863),
    [sym_subset2] = STATE(863),
    [sym_unary_operator] = STATE(863),
    [sym_binary_operator] = STATE(863),
    [sym_extract_operator] = STATE(863),
    [sym_namespace_operator] = STATE(863),
    [sym_integer] = STATE(863),
    [sym_complex] = STATE(863),
    [sym_float] = STATE(863),
    [sym__hex_literal] = STATE(2183),
    [sym__float_literal] = STATE(2183),
    [sym_string] = STATE(2169),
    [sym__single_quoted_string] = STATE(2181),
    [sym__double_quoted_string] = STATE(2180),
    [sym_na] = STATE(863),
    [sym__expression] = STATE(863),
    [sym__string_or_identifier] = STATE(5149),
    [sym__open_parenthesis] = STATE(67),
    [sym__open_brace] = STATE(24),
    [aux_sym_function_definition_repeat1] = STATE(2281),
    [ts_builtin_sym_end] = ACTIONS(757),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_BSLASH] = ACTIONS(323),
    [anon_sym_function] = ACTIONS(325),
    [anon_sym_EQ] = ACTIONS(759),
    [anon_sym_if] = ACTIONS(327),
    [anon_sym_for] = ACTIONS(329),
    [anon_sym_while] = ACTIONS(331),
    [anon_sym_repeat] = ACTIONS(333),
    [anon_sym_QMARK] = ACTIONS(335),
    [anon_sym_TILDE] = ACTIONS(337),
    [anon_sym_BANG] = ACTIONS(339),
    [anon_sym_PLUS] = ACTIONS(341),
    [anon_sym_DASH] = ACTIONS(343),
    [anon_sym_LT_DASH] = ACTIONS(757),
    [anon_sym_LT_LT_DASH] = ACTIONS(757),
    [anon_sym_COLON_EQ] = ACTIONS(757),
    [anon_sym_DASH_GT] = ACTIONS(759),
    [anon_sym_DASH_GT_GT] = ACTIONS(757),
    [anon_sym_PIPE] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(759),
    [anon_sym_PIPE_PIPE] = ACTIONS(757),
    [anon_sym_AMP_AMP] = ACTIONS(757),
    [anon_sym_LT] = ACTIONS(759),
    [anon_sym_LT_EQ] = ACTIONS(757),
    [anon_sym_GT] = ACTIONS(759),
    [anon_sym_GT_EQ] = ACTIONS(757),
    [anon_sym_EQ_EQ] = ACTIONS(757),
    [anon_sym_BANG_EQ] = ACTIONS(757),
    [anon_sym_STAR] = ACTIONS(759),
    [anon_sym_SLASH] = ACTIONS(757),
    [anon_sym_STAR_STAR] = ACTIONS(757),
    [anon_sym_CARET] = ACTIONS(757),
    [aux_sym_binary_operator_token1] = ACTIONS(757),
    [anon_sym_PIPE_GT] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(759),
    [anon_sym_DOLLAR] = ACTIONS(757),
    [anon_sym_AT] = ACTIONS(757),
    [aux_sym__hex_literal_token1] = ACTIONS(345),
    [sym__number_literal] = ACTIONS(347),
    [anon_sym_SQUOTE] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(351),
    [sym_return] = ACTIONS(1233),
    [sym_next] = ACTIONS(1233),
    [sym_break] = ACTIONS(1233),
    [sym_true] = ACTIONS(1233),
    [sym_false] = ACTIONS(1233),
    [sym_null] = ACTIONS(1233),
    [sym_inf] = ACTIONS(1233),
    [sym_nan] = ACTIONS(1233),
    [anon_sym_NA] = ACTIONS(355),
    [anon_sym_NA_integer_] = ACTIONS(355),
    [anon_sym_NA_real_] = ACTIONS(355),
    [anon_sym_NA_complex_] = ACTIONS(355),
    [anon_sym_NA_character_] = ACTIONS(355),
    [sym_dots] = ACTIONS(1233),
    [sym_dot_dot_i] = ACTIONS(1235),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(757),
    [sym__newline] = ACTIONS(757),
    [sym__semicolon] = ACTIONS(757),
    [sym__raw_string_literal] = ACTIONS(361),
    [sym__external_open_parenthesis] = ACTIONS(363),
    [sym__external_close_parenthesis] = ACTIONS(757),
    [sym__external_open_brace] = ACTIONS(365),
    [sym__external_close_brace] = ACTIONS(757),
    [sym__external_open_bracket] = ACTIONS(757),
    [sym__external_open_bracket2] = ACTIONS(757),
  },
  [101] = {
    [sym_function_definition] = STATE(804),
    [sym_if_statement] = STATE(804),
    [sym_for_statement] = STATE(804),
    [sym_while_statement] = STATE(804),
    [sym_repeat_statement] = STATE(804),
    [sym_braced_expression] = STATE(804),
    [sym_parenthesized_expression] = STATE(804),
    [sym_call] = STATE(804),
    [sym_subset] = STATE(804),
    [sym_subset2] = STATE(804),
    [sym_unary_operator] = STATE(804),
    [sym_binary_operator] = STATE(804),
    [sym_extract_operator] = STATE(804),
    [sym_namespace_operator] = STATE(804),
    [sym_integer] = STATE(804),
    [sym_complex] = STATE(804),
    [sym_float] = STATE(804),
    [sym__hex_literal] = STATE(2206),
    [sym__float_literal] = STATE(2206),
    [sym_string] = STATE(2166),
    [sym__single_quoted_string] = STATE(2200),
    [sym__double_quoted_string] = STATE(2201),
    [sym_na] = STATE(804),
    [sym__expression] = STATE(804),
    [sym__string_or_identifier] = STATE(5154),
    [sym__open_parenthesis] = STATE(3),
    [sym__open_brace] = STATE(45),
    [aux_sym_function_definition_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(481),
    [anon_sym_BSLASH] = ACTIONS(483),
    [anon_sym_function] = ACTIONS(485),
    [anon_sym_EQ] = ACTIONS(767),
    [anon_sym_if] = ACTIONS(487),
    [anon_sym_for] = ACTIONS(489),
    [anon_sym_while] = ACTIONS(491),
    [anon_sym_repeat] = ACTIONS(493),
    [anon_sym_QMARK] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(503),
    [anon_sym_LT_DASH] = ACTIONS(765),
    [anon_sym_LT_LT_DASH] = ACTIONS(765),
    [anon_sym_COLON_EQ] = ACTIONS(765),
    [anon_sym_DASH_GT] = ACTIONS(767),
    [anon_sym_DASH_GT_GT] = ACTIONS(765),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_AMP] = ACTIONS(767),
    [anon_sym_PIPE_PIPE] = ACTIONS(765),
    [anon_sym_AMP_AMP] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(767),
    [anon_sym_LT_EQ] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_GT_EQ] = ACTIONS(765),
    [anon_sym_EQ_EQ] = ACTIONS(765),
    [anon_sym_BANG_EQ] = ACTIONS(765),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(765),
    [anon_sym_STAR_STAR] = ACTIONS(765),
    [anon_sym_CARET] = ACTIONS(765),
    [aux_sym_binary_operator_token1] = ACTIONS(765),
    [anon_sym_PIPE_GT] = ACTIONS(765),
    [anon_sym_COLON] = ACTIONS(767),
    [anon_sym_DOLLAR] = ACTIONS(765),
    [anon_sym_AT] = ACTIONS(765),
    [aux_sym__hex_literal_token1] = ACTIONS(505),
    [sym__number_literal] = ACTIONS(507),
    [anon_sym_SQUOTE] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(511),
    [sym_return] = ACTIONS(1237),
    [sym_next] = ACTIONS(1237),
    [sym_break] = ACTIONS(1237),
    [sym_true] = ACTIONS(1237),
    [sym_false] = ACTIONS(1237),
    [sym_null] = ACTIONS(1237),
    [sym_inf] = ACTIONS(1237),
    [sym_nan] = ACTIONS(1237),
    [anon_sym_NA] = ACTIONS(515),
    [anon_sym_NA_integer_] = ACTIONS(515),
    [anon_sym_NA_real_] = ACTIONS(515),
    [anon_sym_NA_complex_] = ACTIONS(515),
    [anon_sym_NA_character_] = ACTIONS(515),
    [sym_dots] = ACTIONS(1237),
    [sym_dot_dot_i] = ACTIONS(1239),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(765),
    [sym__newline] = ACTIONS(765),
    [sym__semicolon] = ACTIONS(765),
    [sym__raw_string_literal] = ACTIONS(521),
    [sym__external_else] = ACTIONS(765),
    [sym__external_open_parenthesis] = ACTIONS(523),
    [sym__external_open_brace] = ACTIONS(525),
    [sym__external_close_brace] = ACTIONS(765),
    [sym__external_open_bracket] = ACTIONS(765),
    [sym__external_close_bracket] = ACTIONS(765),
    [sym__external_open_bracket2] = ACTIONS(765),
  },
  [102] = {
    [sym_function_definition] = STATE(1139),
    [sym_if_statement] = STATE(1139),
    [sym_for_statement] = STATE(1139),
    [sym_while_statement] = STATE(1139),
    [sym_repeat_statement] = STATE(1139),
    [sym_braced_expression] = STATE(1139),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_call] = STATE(1139),
    [sym_subset] = STATE(1139),
    [sym_subset2] = STATE(1139),
    [sym_unary_operator] = STATE(1139),
    [sym_binary_operator] = STATE(1139),
    [sym_extract_operator] = STATE(1139),
    [sym_namespace_operator] = STATE(1139),
    [sym_integer] = STATE(1139),
    [sym_complex] = STATE(1139),
    [sym_float] = STATE(1139),
    [sym__hex_literal] = STATE(2272),
    [sym__float_literal] = STATE(2272),
    [sym_string] = STATE(2271),
    [sym__single_quoted_string] = STATE(2273),
    [sym__double_quoted_string] = STATE(2274),
    [sym_na] = STATE(1139),
    [sym__expression] = STATE(1139),
    [sym__string_or_identifier] = STATE(5157),
    [sym__open_parenthesis] = STATE(120),
    [sym__close_parenthesis] = STATE(2851),
    [sym__open_brace] = STATE(11),
    [aux_sym_parenthesized_expression_repeat1] = STATE(236),
    [sym_identifier] = ACTIONS(1241),
    [anon_sym_BSLASH] = ACTIONS(1243),
    [anon_sym_function] = ACTIONS(1245),
    [anon_sym_EQ] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(1247),
    [anon_sym_for] = ACTIONS(1249),
    [anon_sym_while] = ACTIONS(1251),
    [anon_sym_repeat] = ACTIONS(1253),
    [anon_sym_QMARK] = ACTIONS(1255),
    [anon_sym_TILDE] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1259),
    [anon_sym_PLUS] = ACTIONS(1261),
    [anon_sym_DASH] = ACTIONS(1263),
    [anon_sym_LT_DASH] = ACTIONS(211),
    [anon_sym_LT_LT_DASH] = ACTIONS(211),
    [anon_sym_COLON_EQ] = ACTIONS(211),
    [anon_sym_DASH_GT] = ACTIONS(209),
    [anon_sym_DASH_GT_GT] = ACTIONS(211),
    [anon_sym_PIPE] = ACTIONS(209),
    [anon_sym_AMP] = ACTIONS(209),
    [anon_sym_PIPE_PIPE] = ACTIONS(211),
    [anon_sym_AMP_AMP] = ACTIONS(211),
    [anon_sym_LT] = ACTIONS(209),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_GT] = ACTIONS(209),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [anon_sym_EQ_EQ] = ACTIONS(211),
    [anon_sym_BANG_EQ] = ACTIONS(211),
    [anon_sym_STAR] = ACTIONS(209),
    [anon_sym_SLASH] = ACTIONS(211),
    [anon_sym_STAR_STAR] = ACTIONS(211),
    [anon_sym_CARET] = ACTIONS(211),
    [aux_sym_binary_operator_token1] = ACTIONS(211),
    [anon_sym_PIPE_GT] = ACTIONS(211),
    [anon_sym_COLON] = ACTIONS(209),
    [anon_sym_DOLLAR] = ACTIONS(211),
    [anon_sym_AT] = ACTIONS(211),
    [aux_sym__hex_literal_token1] = ACTIONS(1265),
    [sym__number_literal] = ACTIONS(1267),
    [anon_sym_SQUOTE] = ACTIONS(1269),
    [anon_sym_DQUOTE] = ACTIONS(1271),
    [sym_return] = ACTIONS(1273),
    [sym_next] = ACTIONS(1273),
    [sym_break] = ACTIONS(1273),
    [sym_true] = ACTIONS(1273),
    [sym_false] = ACTIONS(1273),
    [sym_null] = ACTIONS(1273),
    [sym_inf] = ACTIONS(1273),
    [sym_nan] = ACTIONS(1273),
    [anon_sym_NA] = ACTIONS(1275),
    [anon_sym_NA_integer_] = ACTIONS(1275),
    [anon_sym_NA_real_] = ACTIONS(1275),
    [anon_sym_NA_complex_] = ACTIONS(1275),
    [anon_sym_NA_character_] = ACTIONS(1275),
    [sym_dots] = ACTIONS(1273),
    [sym_dot_dot_i] = ACTIONS(1277),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(211),
    [sym__newline] = ACTIONS(1279),
    [sym__raw_string_literal] = ACTIONS(1281),
    [sym__external_else] = ACTIONS(211),
    [sym__external_open_parenthesis] = ACTIONS(1283),
    [sym__external_close_parenthesis] = ACTIONS(1285),
    [sym__external_open_brace] = ACTIONS(1287),
    [sym__external_open_bracket] = ACTIONS(211),
    [sym__external_close_bracket] = ACTIONS(211),
    [sym__external_open_bracket2] = ACTIONS(211),
  },
  [103] = {
    [sym_function_definition] = STATE(970),
    [sym_if_statement] = STATE(970),
    [sym_for_statement] = STATE(970),
    [sym_while_statement] = STATE(970),
    [sym_repeat_statement] = STATE(970),
    [sym_braced_expression] = STATE(970),
    [sym_parenthesized_expression] = STATE(970),
    [sym_call] = STATE(970),
    [sym_subset] = STATE(970),
    [sym_subset2] = STATE(970),
    [sym_unary_operator] = STATE(970),
    [sym_binary_operator] = STATE(970),
    [sym_extract_operator] = STATE(970),
    [sym_namespace_operator] = STATE(970),
    [sym_integer] = STATE(970),
    [sym_complex] = STATE(970),
    [sym_float] = STATE(970),
    [sym__hex_literal] = STATE(2266),
    [sym__float_literal] = STATE(2266),
    [sym_string] = STATE(2284),
    [sym__single_quoted_string] = STATE(2265),
    [sym__double_quoted_string] = STATE(2264),
    [sym_na] = STATE(970),
    [sym__expression] = STATE(970),
    [sym__string_or_identifier] = STATE(5147),
    [sym__open_parenthesis] = STATE(23),
    [sym__open_brace] = STATE(180),
    [sym__close_brace] = STATE(2588),
    [aux_sym_braced_expression_repeat1] = STATE(294),
    [sym_identifier] = ACTIONS(1289),
    [anon_sym_BSLASH] = ACTIONS(1291),
    [anon_sym_function] = ACTIONS(1293),
    [anon_sym_EQ] = ACTIONS(59),
    [anon_sym_if] = ACTIONS(1295),
    [anon_sym_for] = ACTIONS(1297),
    [anon_sym_while] = ACTIONS(1299),
    [anon_sym_repeat] = ACTIONS(1301),
    [anon_sym_QMARK] = ACTIONS(1303),
    [anon_sym_TILDE] = ACTIONS(1305),
    [anon_sym_BANG] = ACTIONS(1307),
    [anon_sym_PLUS] = ACTIONS(1309),
    [anon_sym_DASH] = ACTIONS(1311),
    [anon_sym_LT_DASH] = ACTIONS(51),
    [anon_sym_LT_LT_DASH] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(51),
    [anon_sym_DASH_GT] = ACTIONS(59),
    [anon_sym_DASH_GT_GT] = ACTIONS(51),
    [anon_sym_PIPE] = ACTIONS(59),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_AMP_AMP] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(59),
    [anon_sym_LT_EQ] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(59),
    [anon_sym_GT_EQ] = ACTIONS(51),
    [anon_sym_EQ_EQ] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(51),
    [anon_sym_CARET] = ACTIONS(51),
    [aux_sym_binary_operator_token1] = ACTIONS(51),
    [anon_sym_PIPE_GT] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(59),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_AT] = ACTIONS(51),
    [aux_sym__hex_literal_token1] = ACTIONS(1313),
    [sym__number_literal] = ACTIONS(1315),
    [anon_sym_SQUOTE] = ACTIONS(1317),
    [anon_sym_DQUOTE] = ACTIONS(1319),
    [sym_return] = ACTIONS(1321),
    [sym_next] = ACTIONS(1321),
    [sym_break] = ACTIONS(1321),
    [sym_true] = ACTIONS(1321),
    [sym_false] = ACTIONS(1321),
    [sym_null] = ACTIONS(1321),
    [sym_inf] = ACTIONS(1321),
    [sym_nan] = ACTIONS(1321),
    [anon_sym_NA] = ACTIONS(1323),
    [anon_sym_NA_integer_] = ACTIONS(1323),
    [anon_sym_NA_real_] = ACTIONS(1323),
    [anon_sym_NA_complex_] = ACTIONS(1323),
    [anon_sym_NA_character_] = ACTIONS(1323),
    [sym_dots] = ACTIONS(1321),
    [sym_dot_dot_i] = ACTIONS(1325),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(51),
    [sym__newline] = ACTIONS(1327),
    [sym__semicolon] = ACTIONS(1327),
    [sym__raw_string_literal] = ACTIONS(1329),
    [sym__external_open_parenthesis] = ACTIONS(1331),
    [sym__external_open_brace] = ACTIONS(1333),
    [sym__external_close_brace] = ACTIONS(1335),
    [sym__external_open_bracket] = ACTIONS(51),
    [sym__external_close_bracket] = ACTIONS(51),
    [sym__external_open_bracket2] = ACTIONS(51),
  },
  [104] = {
    [sym_function_definition] = STATE(1219),
    [sym_if_statement] = STATE(1219),
    [sym_for_statement] = STATE(1219),
    [sym_while_statement] = STATE(1219),
    [sym_repeat_statement] = STATE(1219),
    [sym_braced_expression] = STATE(1219),
    [sym_parenthesized_expression] = STATE(1219),
    [sym_call] = STATE(1219),
    [sym_subset] = STATE(1219),
    [sym_subset2] = STATE(1219),
    [sym_unary_operator] = STATE(1219),
    [sym_binary_operator] = STATE(1219),
    [sym_extract_operator] = STATE(1219),
    [sym_namespace_operator] = STATE(1219),
    [sym_integer] = STATE(1219),
    [sym_complex] = STATE(1219),
    [sym_float] = STATE(1219),
    [sym__hex_literal] = STATE(2356),
    [sym__float_literal] = STATE(2356),
    [sym_string] = STATE(2231),
    [sym__single_quoted_string] = STATE(2355),
    [sym__double_quoted_string] = STATE(2354),
    [sym_na] = STATE(1219),
    [sym__expression] = STATE(1219),
    [sym__string_or_identifier] = STATE(5156),
    [sym__open_parenthesis] = STATE(190),
    [sym__close_parenthesis] = STATE(2803),
    [sym__open_brace] = STATE(94),
    [aux_sym_parenthesized_expression_repeat1] = STATE(245),
    [ts_builtin_sym_end] = ACTIONS(211),
    [sym_identifier] = ACTIONS(1337),
    [anon_sym_BSLASH] = ACTIONS(1339),
    [anon_sym_function] = ACTIONS(1341),
    [anon_sym_EQ] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(1343),
    [anon_sym_for] = ACTIONS(1345),
    [anon_sym_while] = ACTIONS(1347),
    [anon_sym_repeat] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_BANG] = ACTIONS(1355),
    [anon_sym_PLUS] = ACTIONS(1357),
    [anon_sym_DASH] = ACTIONS(1359),
    [anon_sym_LT_DASH] = ACTIONS(211),
    [anon_sym_LT_LT_DASH] = ACTIONS(211),
    [anon_sym_COLON_EQ] = ACTIONS(211),
    [anon_sym_DASH_GT] = ACTIONS(209),
    [anon_sym_DASH_GT_GT] = ACTIONS(211),
    [anon_sym_PIPE] = ACTIONS(209),
    [anon_sym_AMP] = ACTIONS(209),
    [anon_sym_PIPE_PIPE] = ACTIONS(211),
    [anon_sym_AMP_AMP] = ACTIONS(211),
    [anon_sym_LT] = ACTIONS(209),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_GT] = ACTIONS(209),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [anon_sym_EQ_EQ] = ACTIONS(211),
    [anon_sym_BANG_EQ] = ACTIONS(211),
    [anon_sym_STAR] = ACTIONS(209),
    [anon_sym_SLASH] = ACTIONS(211),
    [anon_sym_STAR_STAR] = ACTIONS(211),
    [anon_sym_CARET] = ACTIONS(211),
    [aux_sym_binary_operator_token1] = ACTIONS(211),
    [anon_sym_PIPE_GT] = ACTIONS(211),
    [anon_sym_COLON] = ACTIONS(209),
    [anon_sym_DOLLAR] = ACTIONS(211),
    [anon_sym_AT] = ACTIONS(211),
    [aux_sym__hex_literal_token1] = ACTIONS(1361),
    [sym__number_literal] = ACTIONS(1363),
    [anon_sym_SQUOTE] = ACTIONS(1365),
    [anon_sym_DQUOTE] = ACTIONS(1367),
    [sym_return] = ACTIONS(1369),
    [sym_next] = ACTIONS(1369),
    [sym_break] = ACTIONS(1369),
    [sym_true] = ACTIONS(1369),
    [sym_false] = ACTIONS(1369),
    [sym_null] = ACTIONS(1369),
    [sym_inf] = ACTIONS(1369),
    [sym_nan] = ACTIONS(1369),
    [anon_sym_NA] = ACTIONS(1371),
    [anon_sym_NA_integer_] = ACTIONS(1371),
    [anon_sym_NA_real_] = ACTIONS(1371),
    [anon_sym_NA_complex_] = ACTIONS(1371),
    [anon_sym_NA_character_] = ACTIONS(1371),
    [sym_dots] = ACTIONS(1369),
    [sym_dot_dot_i] = ACTIONS(1373),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1375),
    [sym__semicolon] = ACTIONS(211),
    [sym__raw_string_literal] = ACTIONS(1377),
    [sym__external_else] = ACTIONS(211),
    [sym__external_open_parenthesis] = ACTIONS(1379),
    [sym__external_close_parenthesis] = ACTIONS(1381),
    [sym__external_open_brace] = ACTIONS(1383),
    [sym__external_open_bracket] = ACTIONS(211),
    [sym__external_open_bracket2] = ACTIONS(211),
  },
  [105] = {
    [sym_function_definition] = STATE(1072),
    [sym_if_statement] = STATE(1072),
    [sym_for_statement] = STATE(1072),
    [sym_while_statement] = STATE(1072),
    [sym_repeat_statement] = STATE(1072),
    [sym_braced_expression] = STATE(1072),
    [sym_parenthesized_expression] = STATE(1072),
    [sym_call] = STATE(1072),
    [sym_subset] = STATE(1072),
    [sym_subset2] = STATE(1072),
    [sym_unary_operator] = STATE(1072),
    [sym_binary_operator] = STATE(1072),
    [sym_extract_operator] = STATE(1072),
    [sym_namespace_operator] = STATE(1072),
    [sym_integer] = STATE(1072),
    [sym_complex] = STATE(1072),
    [sym_float] = STATE(1072),
    [sym__hex_literal] = STATE(2311),
    [sym__float_literal] = STATE(2311),
    [sym_string] = STATE(2312),
    [sym__single_quoted_string] = STATE(2310),
    [sym__double_quoted_string] = STATE(2309),
    [sym_na] = STATE(1072),
    [sym__expression] = STATE(1072),
    [sym__string_or_identifier] = STATE(5134),
    [sym__open_parenthesis] = STATE(64),
    [sym__open_brace] = STATE(199),
    [sym__close_brace] = STATE(2802),
    [aux_sym_braced_expression_repeat1] = STATE(279),
    [ts_builtin_sym_end] = ACTIONS(51),
    [sym_identifier] = ACTIONS(1385),
    [anon_sym_BSLASH] = ACTIONS(1387),
    [anon_sym_function] = ACTIONS(1389),
    [anon_sym_EQ] = ACTIONS(59),
    [anon_sym_if] = ACTIONS(1391),
    [anon_sym_for] = ACTIONS(1393),
    [anon_sym_while] = ACTIONS(1395),
    [anon_sym_repeat] = ACTIONS(1397),
    [anon_sym_QMARK] = ACTIONS(1399),
    [anon_sym_TILDE] = ACTIONS(1401),
    [anon_sym_BANG] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1407),
    [anon_sym_LT_DASH] = ACTIONS(51),
    [anon_sym_LT_LT_DASH] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(51),
    [anon_sym_DASH_GT] = ACTIONS(59),
    [anon_sym_DASH_GT_GT] = ACTIONS(51),
    [anon_sym_PIPE] = ACTIONS(59),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_AMP_AMP] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(59),
    [anon_sym_LT_EQ] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(59),
    [anon_sym_GT_EQ] = ACTIONS(51),
    [anon_sym_EQ_EQ] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(51),
    [anon_sym_CARET] = ACTIONS(51),
    [aux_sym_binary_operator_token1] = ACTIONS(51),
    [anon_sym_PIPE_GT] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(59),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_AT] = ACTIONS(51),
    [aux_sym__hex_literal_token1] = ACTIONS(1409),
    [sym__number_literal] = ACTIONS(1411),
    [anon_sym_SQUOTE] = ACTIONS(1413),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [sym_return] = ACTIONS(1417),
    [sym_next] = ACTIONS(1417),
    [sym_break] = ACTIONS(1417),
    [sym_true] = ACTIONS(1417),
    [sym_false] = ACTIONS(1417),
    [sym_null] = ACTIONS(1417),
    [sym_inf] = ACTIONS(1417),
    [sym_nan] = ACTIONS(1417),
    [anon_sym_NA] = ACTIONS(1419),
    [anon_sym_NA_integer_] = ACTIONS(1419),
    [anon_sym_NA_real_] = ACTIONS(1419),
    [anon_sym_NA_complex_] = ACTIONS(1419),
    [anon_sym_NA_character_] = ACTIONS(1419),
    [sym_dots] = ACTIONS(1417),
    [sym_dot_dot_i] = ACTIONS(1421),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1423),
    [sym__semicolon] = ACTIONS(1423),
    [sym__raw_string_literal] = ACTIONS(1425),
    [sym__external_else] = ACTIONS(51),
    [sym__external_open_parenthesis] = ACTIONS(1427),
    [sym__external_open_brace] = ACTIONS(1429),
    [sym__external_close_brace] = ACTIONS(1431),
    [sym__external_open_bracket] = ACTIONS(51),
    [sym__external_open_bracket2] = ACTIONS(51),
  },
  [106] = {
    [sym_function_definition] = STATE(1152),
    [sym_if_statement] = STATE(1152),
    [sym_for_statement] = STATE(1152),
    [sym_while_statement] = STATE(1152),
    [sym_repeat_statement] = STATE(1152),
    [sym_braced_expression] = STATE(1152),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_call] = STATE(1152),
    [sym_subset] = STATE(1152),
    [sym_subset2] = STATE(1152),
    [sym_unary_operator] = STATE(1152),
    [sym_binary_operator] = STATE(1152),
    [sym_extract_operator] = STATE(1152),
    [sym_namespace_operator] = STATE(1152),
    [sym_integer] = STATE(1152),
    [sym_complex] = STATE(1152),
    [sym_float] = STATE(1152),
    [sym__hex_literal] = STATE(2235),
    [sym__float_literal] = STATE(2235),
    [sym_string] = STATE(2234),
    [sym__single_quoted_string] = STATE(2236),
    [sym__double_quoted_string] = STATE(2237),
    [sym_na] = STATE(1152),
    [sym__expression] = STATE(1152),
    [sym__string_or_identifier] = STATE(5150),
    [sym__open_parenthesis] = STATE(76),
    [sym__open_brace] = STATE(188),
    [sym__close_brace] = STATE(2707),
    [aux_sym_braced_expression_repeat1] = STATE(262),
    [sym_identifier] = ACTIONS(1433),
    [anon_sym_BSLASH] = ACTIONS(1435),
    [anon_sym_function] = ACTIONS(1437),
    [anon_sym_EQ] = ACTIONS(59),
    [anon_sym_if] = ACTIONS(1439),
    [anon_sym_for] = ACTIONS(1441),
    [anon_sym_while] = ACTIONS(1443),
    [anon_sym_repeat] = ACTIONS(1445),
    [anon_sym_QMARK] = ACTIONS(1447),
    [anon_sym_TILDE] = ACTIONS(1449),
    [anon_sym_BANG] = ACTIONS(1451),
    [anon_sym_PLUS] = ACTIONS(1453),
    [anon_sym_DASH] = ACTIONS(1455),
    [anon_sym_LT_DASH] = ACTIONS(51),
    [anon_sym_LT_LT_DASH] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(51),
    [anon_sym_DASH_GT] = ACTIONS(59),
    [anon_sym_DASH_GT_GT] = ACTIONS(51),
    [anon_sym_PIPE] = ACTIONS(59),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_AMP_AMP] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(59),
    [anon_sym_LT_EQ] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(59),
    [anon_sym_GT_EQ] = ACTIONS(51),
    [anon_sym_EQ_EQ] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(51),
    [anon_sym_CARET] = ACTIONS(51),
    [aux_sym_binary_operator_token1] = ACTIONS(51),
    [anon_sym_PIPE_GT] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(59),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_AT] = ACTIONS(51),
    [aux_sym__hex_literal_token1] = ACTIONS(1457),
    [sym__number_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [anon_sym_DQUOTE] = ACTIONS(1463),
    [sym_return] = ACTIONS(1465),
    [sym_next] = ACTIONS(1465),
    [sym_break] = ACTIONS(1465),
    [sym_true] = ACTIONS(1465),
    [sym_false] = ACTIONS(1465),
    [sym_null] = ACTIONS(1465),
    [sym_inf] = ACTIONS(1465),
    [sym_nan] = ACTIONS(1465),
    [anon_sym_NA] = ACTIONS(1467),
    [anon_sym_NA_integer_] = ACTIONS(1467),
    [anon_sym_NA_real_] = ACTIONS(1467),
    [anon_sym_NA_complex_] = ACTIONS(1467),
    [anon_sym_NA_character_] = ACTIONS(1467),
    [sym_dots] = ACTIONS(1465),
    [sym_dot_dot_i] = ACTIONS(1469),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(51),
    [sym__newline] = ACTIONS(1471),
    [sym__semicolon] = ACTIONS(1471),
    [sym__raw_string_literal] = ACTIONS(1473),
    [sym__external_open_parenthesis] = ACTIONS(1475),
    [sym__external_open_brace] = ACTIONS(1477),
    [sym__external_close_brace] = ACTIONS(1479),
    [sym__external_open_bracket] = ACTIONS(51),
    [sym__external_open_bracket2] = ACTIONS(51),
    [sym__external_close_bracket2] = ACTIONS(51),
  },
  [107] = {
    [sym_function_definition] = STATE(790),
    [sym_if_statement] = STATE(790),
    [sym_for_statement] = STATE(790),
    [sym_while_statement] = STATE(790),
    [sym_repeat_statement] = STATE(790),
    [sym_braced_expression] = STATE(790),
    [sym_parenthesized_expression] = STATE(790),
    [sym_call] = STATE(790),
    [sym_subset] = STATE(790),
    [sym_subset2] = STATE(790),
    [sym_unary_operator] = STATE(790),
    [sym_binary_operator] = STATE(790),
    [sym_extract_operator] = STATE(790),
    [sym_namespace_operator] = STATE(790),
    [sym_integer] = STATE(790),
    [sym_complex] = STATE(790),
    [sym_float] = STATE(790),
    [sym__hex_literal] = STATE(2183),
    [sym__float_literal] = STATE(2183),
    [sym_string] = STATE(2169),
    [sym__single_quoted_string] = STATE(2181),
    [sym__double_quoted_string] = STATE(2180),
    [sym_na] = STATE(790),
    [sym__expression] = STATE(790),
    [sym__string_or_identifier] = STATE(5149),
    [sym__open_parenthesis] = STATE(67),
    [sym__open_brace] = STATE(24),
    [sym__close_brace] = STATE(2948),
    [aux_sym_braced_expression_repeat1] = STATE(145),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_BSLASH] = ACTIONS(323),
    [anon_sym_function] = ACTIONS(325),
    [anon_sym_EQ] = ACTIONS(59),
    [anon_sym_if] = ACTIONS(327),
    [anon_sym_for] = ACTIONS(329),
    [anon_sym_while] = ACTIONS(331),
    [anon_sym_repeat] = ACTIONS(333),
    [anon_sym_QMARK] = ACTIONS(335),
    [anon_sym_TILDE] = ACTIONS(337),
    [anon_sym_BANG] = ACTIONS(339),
    [anon_sym_PLUS] = ACTIONS(341),
    [anon_sym_DASH] = ACTIONS(343),
    [anon_sym_LT_DASH] = ACTIONS(51),
    [anon_sym_LT_LT_DASH] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(51),
    [anon_sym_DASH_GT] = ACTIONS(59),
    [anon_sym_DASH_GT_GT] = ACTIONS(51),
    [anon_sym_PIPE] = ACTIONS(59),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_AMP_AMP] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(59),
    [anon_sym_LT_EQ] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(59),
    [anon_sym_GT_EQ] = ACTIONS(51),
    [anon_sym_EQ_EQ] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(51),
    [anon_sym_CARET] = ACTIONS(51),
    [aux_sym_binary_operator_token1] = ACTIONS(51),
    [anon_sym_PIPE_GT] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(59),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_AT] = ACTIONS(51),
    [aux_sym__hex_literal_token1] = ACTIONS(345),
    [sym__number_literal] = ACTIONS(347),
    [anon_sym_SQUOTE] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(351),
    [sym_return] = ACTIONS(353),
    [sym_next] = ACTIONS(353),
    [sym_break] = ACTIONS(353),
    [sym_true] = ACTIONS(353),
    [sym_false] = ACTIONS(353),
    [sym_null] = ACTIONS(353),
    [sym_inf] = ACTIONS(353),
    [sym_nan] = ACTIONS(353),
    [anon_sym_NA] = ACTIONS(355),
    [anon_sym_NA_integer_] = ACTIONS(355),
    [anon_sym_NA_real_] = ACTIONS(355),
    [anon_sym_NA_complex_] = ACTIONS(355),
    [anon_sym_NA_character_] = ACTIONS(355),
    [sym_dots] = ACTIONS(353),
    [sym_dot_dot_i] = ACTIONS(357),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(51),
    [sym__newline] = ACTIONS(359),
    [sym__semicolon] = ACTIONS(359),
    [sym__raw_string_literal] = ACTIONS(361),
    [sym__external_open_parenthesis] = ACTIONS(363),
    [sym__external_close_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(365),
    [sym__external_close_brace] = ACTIONS(1481),
    [sym__external_open_bracket] = ACTIONS(51),
    [sym__external_open_bracket2] = ACTIONS(51),
  },
  [108] = {
    [sym_function_definition] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_repeat_statement] = STATE(774),
    [sym_braced_expression] = STATE(774),
    [sym_parenthesized_expression] = STATE(774),
    [sym_call] = STATE(774),
    [sym_subset] = STATE(774),
    [sym_subset2] = STATE(774),
    [sym_unary_operator] = STATE(774),
    [sym_binary_operator] = STATE(774),
    [sym_extract_operator] = STATE(774),
    [sym_namespace_operator] = STATE(774),
    [sym_integer] = STATE(774),
    [sym_complex] = STATE(774),
    [sym_float] = STATE(774),
    [sym__hex_literal] = STATE(2189),
    [sym__float_literal] = STATE(2189),
    [sym_string] = STATE(2192),
    [sym__single_quoted_string] = STATE(2188),
    [sym__double_quoted_string] = STATE(2187),
    [sym_na] = STATE(774),
    [sym__expression] = STATE(774),
    [sym__string_or_identifier] = STATE(5139),
    [sym__open_parenthesis] = STATE(57),
    [sym__open_brace] = STATE(59),
    [aux_sym_function_definition_repeat1] = STATE(111),
    [sym_identifier] = ACTIONS(273),
    [anon_sym_BSLASH] = ACTIONS(275),
    [anon_sym_function] = ACTIONS(277),
    [anon_sym_EQ] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_for] = ACTIONS(281),
    [anon_sym_while] = ACTIONS(283),
    [anon_sym_repeat] = ACTIONS(285),
    [anon_sym_QMARK] = ACTIONS(287),
    [anon_sym_TILDE] = ACTIONS(289),
    [anon_sym_BANG] = ACTIONS(291),
    [anon_sym_PLUS] = ACTIONS(293),
    [anon_sym_DASH] = ACTIONS(295),
    [anon_sym_LT_DASH] = ACTIONS(263),
    [anon_sym_LT_LT_DASH] = ACTIONS(263),
    [anon_sym_COLON_EQ] = ACTIONS(263),
    [anon_sym_DASH_GT] = ACTIONS(265),
    [anon_sym_DASH_GT_GT] = ACTIONS(263),
    [anon_sym_PIPE] = ACTIONS(265),
    [anon_sym_AMP] = ACTIONS(265),
    [anon_sym_PIPE_PIPE] = ACTIONS(263),
    [anon_sym_AMP_AMP] = ACTIONS(263),
    [anon_sym_LT] = ACTIONS(265),
    [anon_sym_LT_EQ] = ACTIONS(263),
    [anon_sym_GT] = ACTIONS(265),
    [anon_sym_GT_EQ] = ACTIONS(263),
    [anon_sym_EQ_EQ] = ACTIONS(263),
    [anon_sym_BANG_EQ] = ACTIONS(263),
    [anon_sym_STAR] = ACTIONS(265),
    [anon_sym_SLASH] = ACTIONS(263),
    [anon_sym_STAR_STAR] = ACTIONS(263),
    [anon_sym_CARET] = ACTIONS(263),
    [aux_sym_binary_operator_token1] = ACTIONS(263),
    [anon_sym_PIPE_GT] = ACTIONS(263),
    [anon_sym_COLON] = ACTIONS(265),
    [anon_sym_DOLLAR] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(263),
    [aux_sym__hex_literal_token1] = ACTIONS(297),
    [sym__number_literal] = ACTIONS(299),
    [anon_sym_SQUOTE] = ACTIONS(301),
    [anon_sym_DQUOTE] = ACTIONS(303),
    [sym_return] = ACTIONS(1483),
    [sym_next] = ACTIONS(1483),
    [sym_break] = ACTIONS(1483),
    [sym_true] = ACTIONS(1483),
    [sym_false] = ACTIONS(1483),
    [sym_null] = ACTIONS(1483),
    [sym_inf] = ACTIONS(1483),
    [sym_nan] = ACTIONS(1483),
    [anon_sym_NA] = ACTIONS(307),
    [anon_sym_NA_integer_] = ACTIONS(307),
    [anon_sym_NA_real_] = ACTIONS(307),
    [anon_sym_NA_complex_] = ACTIONS(307),
    [anon_sym_NA_character_] = ACTIONS(307),
    [sym_dots] = ACTIONS(1483),
    [sym_dot_dot_i] = ACTIONS(1485),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(263),
    [sym__newline] = ACTIONS(1487),
    [sym__semicolon] = ACTIONS(263),
    [sym__raw_string_literal] = ACTIONS(313),
    [sym__external_open_parenthesis] = ACTIONS(315),
    [sym__external_close_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(319),
    [sym__external_close_brace] = ACTIONS(263),
    [sym__external_open_bracket] = ACTIONS(263),
    [sym__external_close_bracket] = ACTIONS(263),
    [sym__external_open_bracket2] = ACTIONS(263),
  },
  [109] = {
    [sym_function_definition] = STATE(753),
    [sym_if_statement] = STATE(753),
    [sym_for_statement] = STATE(753),
    [sym_while_statement] = STATE(753),
    [sym_repeat_statement] = STATE(753),
    [sym_braced_expression] = STATE(753),
    [sym_parenthesized_expression] = STATE(753),
    [sym_call] = STATE(753),
    [sym_subset] = STATE(753),
    [sym_subset2] = STATE(753),
    [sym_unary_operator] = STATE(753),
    [sym_binary_operator] = STATE(753),
    [sym_extract_operator] = STATE(753),
    [sym_namespace_operator] = STATE(753),
    [sym_integer] = STATE(753),
    [sym_complex] = STATE(753),
    [sym_float] = STATE(753),
    [sym__hex_literal] = STATE(2189),
    [sym__float_literal] = STATE(2189),
    [sym_string] = STATE(2192),
    [sym__single_quoted_string] = STATE(2188),
    [sym__double_quoted_string] = STATE(2187),
    [sym_na] = STATE(753),
    [sym__expression] = STATE(753),
    [sym__string_or_identifier] = STATE(5139),
    [sym__open_parenthesis] = STATE(57),
    [sym__open_brace] = STATE(59),
    [aux_sym_function_definition_repeat1] = STATE(113),
    [sym_identifier] = ACTIONS(273),
    [anon_sym_BSLASH] = ACTIONS(275),
    [anon_sym_function] = ACTIONS(277),
    [anon_sym_EQ] = ACTIONS(543),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_for] = ACTIONS(281),
    [anon_sym_while] = ACTIONS(283),
    [anon_sym_repeat] = ACTIONS(285),
    [anon_sym_QMARK] = ACTIONS(287),
    [anon_sym_TILDE] = ACTIONS(289),
    [anon_sym_BANG] = ACTIONS(291),
    [anon_sym_PLUS] = ACTIONS(293),
    [anon_sym_DASH] = ACTIONS(295),
    [anon_sym_LT_DASH] = ACTIONS(545),
    [anon_sym_LT_LT_DASH] = ACTIONS(545),
    [anon_sym_COLON_EQ] = ACTIONS(545),
    [anon_sym_DASH_GT] = ACTIONS(543),
    [anon_sym_DASH_GT_GT] = ACTIONS(545),
    [anon_sym_PIPE] = ACTIONS(543),
    [anon_sym_AMP] = ACTIONS(543),
    [anon_sym_PIPE_PIPE] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(543),
    [anon_sym_LT_EQ] = ACTIONS(545),
    [anon_sym_GT] = ACTIONS(543),
    [anon_sym_GT_EQ] = ACTIONS(545),
    [anon_sym_EQ_EQ] = ACTIONS(545),
    [anon_sym_BANG_EQ] = ACTIONS(545),
    [anon_sym_STAR] = ACTIONS(543),
    [anon_sym_SLASH] = ACTIONS(545),
    [anon_sym_STAR_STAR] = ACTIONS(545),
    [anon_sym_CARET] = ACTIONS(545),
    [aux_sym_binary_operator_token1] = ACTIONS(545),
    [anon_sym_PIPE_GT] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(543),
    [anon_sym_DOLLAR] = ACTIONS(545),
    [anon_sym_AT] = ACTIONS(545),
    [aux_sym__hex_literal_token1] = ACTIONS(297),
    [sym__number_literal] = ACTIONS(299),
    [anon_sym_SQUOTE] = ACTIONS(301),
    [anon_sym_DQUOTE] = ACTIONS(303),
    [sym_return] = ACTIONS(1489),
    [sym_next] = ACTIONS(1489),
    [sym_break] = ACTIONS(1489),
    [sym_true] = ACTIONS(1489),
    [sym_false] = ACTIONS(1489),
    [sym_null] = ACTIONS(1489),
    [sym_inf] = ACTIONS(1489),
    [sym_nan] = ACTIONS(1489),
    [anon_sym_NA] = ACTIONS(307),
    [anon_sym_NA_integer_] = ACTIONS(307),
    [anon_sym_NA_real_] = ACTIONS(307),
    [anon_sym_NA_complex_] = ACTIONS(307),
    [anon_sym_NA_character_] = ACTIONS(307),
    [sym_dots] = ACTIONS(1489),
    [sym_dot_dot_i] = ACTIONS(1491),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(545),
    [sym__newline] = ACTIONS(1493),
    [sym__semicolon] = ACTIONS(545),
    [sym__raw_string_literal] = ACTIONS(313),
    [sym__external_open_parenthesis] = ACTIONS(315),
    [sym__external_close_parenthesis] = ACTIONS(545),
    [sym__external_open_brace] = ACTIONS(319),
    [sym__external_close_brace] = ACTIONS(545),
    [sym__external_open_bracket] = ACTIONS(545),
    [sym__external_close_bracket] = ACTIONS(545),
    [sym__external_open_bracket2] = ACTIONS(545),
  },
  [110] = {
    [sym_function_definition] = STATE(770),
    [sym_if_statement] = STATE(770),
    [sym_for_statement] = STATE(770),
    [sym_while_statement] = STATE(770),
    [sym_repeat_statement] = STATE(770),
    [sym_braced_expression] = STATE(770),
    [sym_parenthesized_expression] = STATE(770),
    [sym_call] = STATE(770),
    [sym_subset] = STATE(770),
    [sym_subset2] = STATE(770),
    [sym_unary_operator] = STATE(770),
    [sym_binary_operator] = STATE(770),
    [sym_extract_operator] = STATE(770),
    [sym_namespace_operator] = STATE(770),
    [sym_integer] = STATE(770),
    [sym_complex] = STATE(770),
    [sym_float] = STATE(770),
    [sym__hex_literal] = STATE(2189),
    [sym__float_literal] = STATE(2189),
    [sym_string] = STATE(2192),
    [sym__single_quoted_string] = STATE(2188),
    [sym__double_quoted_string] = STATE(2187),
    [sym_na] = STATE(770),
    [sym__expression] = STATE(770),
    [sym__string_or_identifier] = STATE(5139),
    [sym__open_parenthesis] = STATE(57),
    [sym__open_brace] = STATE(59),
    [aux_sym_braced_expression_repeat1] = STATE(110),
    [sym_identifier] = ACTIONS(1495),
    [anon_sym_BSLASH] = ACTIONS(1498),
    [anon_sym_function] = ACTIONS(1501),
    [anon_sym_EQ] = ACTIONS(562),
    [anon_sym_if] = ACTIONS(1504),
    [anon_sym_for] = ACTIONS(1507),
    [anon_sym_while] = ACTIONS(1510),
    [anon_sym_repeat] = ACTIONS(1513),
    [anon_sym_QMARK] = ACTIONS(1516),
    [anon_sym_TILDE] = ACTIONS(1519),
    [anon_sym_BANG] = ACTIONS(1522),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1528),
    [anon_sym_LT_DASH] = ACTIONS(591),
    [anon_sym_LT_LT_DASH] = ACTIONS(591),
    [anon_sym_COLON_EQ] = ACTIONS(591),
    [anon_sym_DASH_GT] = ACTIONS(562),
    [anon_sym_DASH_GT_GT] = ACTIONS(591),
    [anon_sym_PIPE] = ACTIONS(562),
    [anon_sym_AMP] = ACTIONS(562),
    [anon_sym_PIPE_PIPE] = ACTIONS(591),
    [anon_sym_AMP_AMP] = ACTIONS(591),
    [anon_sym_LT] = ACTIONS(562),
    [anon_sym_LT_EQ] = ACTIONS(591),
    [anon_sym_GT] = ACTIONS(562),
    [anon_sym_GT_EQ] = ACTIONS(591),
    [anon_sym_EQ_EQ] = ACTIONS(591),
    [anon_sym_BANG_EQ] = ACTIONS(591),
    [anon_sym_STAR] = ACTIONS(562),
    [anon_sym_SLASH] = ACTIONS(591),
    [anon_sym_STAR_STAR] = ACTIONS(591),
    [anon_sym_CARET] = ACTIONS(591),
    [aux_sym_binary_operator_token1] = ACTIONS(591),
    [anon_sym_PIPE_GT] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(562),
    [anon_sym_DOLLAR] = ACTIONS(591),
    [anon_sym_AT] = ACTIONS(591),
    [aux_sym__hex_literal_token1] = ACTIONS(1531),
    [sym__number_literal] = ACTIONS(1534),
    [anon_sym_SQUOTE] = ACTIONS(1537),
    [anon_sym_DQUOTE] = ACTIONS(1540),
    [sym_return] = ACTIONS(1543),
    [sym_next] = ACTIONS(1543),
    [sym_break] = ACTIONS(1543),
    [sym_true] = ACTIONS(1543),
    [sym_false] = ACTIONS(1543),
    [sym_null] = ACTIONS(1543),
    [sym_inf] = ACTIONS(1543),
    [sym_nan] = ACTIONS(1543),
    [anon_sym_NA] = ACTIONS(1546),
    [anon_sym_NA_integer_] = ACTIONS(1546),
    [anon_sym_NA_real_] = ACTIONS(1546),
    [anon_sym_NA_complex_] = ACTIONS(1546),
    [anon_sym_NA_character_] = ACTIONS(1546),
    [sym_dots] = ACTIONS(1543),
    [sym_dot_dot_i] = ACTIONS(1549),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(591),
    [sym__newline] = ACTIONS(1552),
    [sym__semicolon] = ACTIONS(1552),
    [sym__raw_string_literal] = ACTIONS(1555),
    [sym__external_open_parenthesis] = ACTIONS(1558),
    [sym__external_close_parenthesis] = ACTIONS(591),
    [sym__external_open_brace] = ACTIONS(1561),
    [sym__external_close_brace] = ACTIONS(591),
    [sym__external_open_bracket] = ACTIONS(591),
    [sym__external_close_bracket] = ACTIONS(591),
    [sym__external_open_bracket2] = ACTIONS(591),
  },
  [111] = {
    [sym_function_definition] = STATE(749),
    [sym_if_statement] = STATE(749),
    [sym_for_statement] = STATE(749),
    [sym_while_statement] = STATE(749),
    [sym_repeat_statement] = STATE(749),
    [sym_braced_expression] = STATE(749),
    [sym_parenthesized_expression] = STATE(749),
    [sym_call] = STATE(749),
    [sym_subset] = STATE(749),
    [sym_subset2] = STATE(749),
    [sym_unary_operator] = STATE(749),
    [sym_binary_operator] = STATE(749),
    [sym_extract_operator] = STATE(749),
    [sym_namespace_operator] = STATE(749),
    [sym_integer] = STATE(749),
    [sym_complex] = STATE(749),
    [sym_float] = STATE(749),
    [sym__hex_literal] = STATE(2189),
    [sym__float_literal] = STATE(2189),
    [sym_string] = STATE(2192),
    [sym__single_quoted_string] = STATE(2188),
    [sym__double_quoted_string] = STATE(2187),
    [sym_na] = STATE(749),
    [sym__expression] = STATE(749),
    [sym__string_or_identifier] = STATE(5139),
    [sym__open_parenthesis] = STATE(57),
    [sym__open_brace] = STATE(59),
    [aux_sym_function_definition_repeat1] = STATE(2336),
    [sym_identifier] = ACTIONS(273),
    [anon_sym_BSLASH] = ACTIONS(275),
    [anon_sym_function] = ACTIONS(277),
    [anon_sym_EQ] = ACTIONS(767),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_for] = ACTIONS(281),
    [anon_sym_while] = ACTIONS(283),
    [anon_sym_repeat] = ACTIONS(285),
    [anon_sym_QMARK] = ACTIONS(287),
    [anon_sym_TILDE] = ACTIONS(289),
    [anon_sym_BANG] = ACTIONS(291),
    [anon_sym_PLUS] = ACTIONS(293),
    [anon_sym_DASH] = ACTIONS(295),
    [anon_sym_LT_DASH] = ACTIONS(765),
    [anon_sym_LT_LT_DASH] = ACTIONS(765),
    [anon_sym_COLON_EQ] = ACTIONS(765),
    [anon_sym_DASH_GT] = ACTIONS(767),
    [anon_sym_DASH_GT_GT] = ACTIONS(765),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_AMP] = ACTIONS(767),
    [anon_sym_PIPE_PIPE] = ACTIONS(765),
    [anon_sym_AMP_AMP] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(767),
    [anon_sym_LT_EQ] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_GT_EQ] = ACTIONS(765),
    [anon_sym_EQ_EQ] = ACTIONS(765),
    [anon_sym_BANG_EQ] = ACTIONS(765),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(765),
    [anon_sym_STAR_STAR] = ACTIONS(765),
    [anon_sym_CARET] = ACTIONS(765),
    [aux_sym_binary_operator_token1] = ACTIONS(765),
    [anon_sym_PIPE_GT] = ACTIONS(765),
    [anon_sym_COLON] = ACTIONS(767),
    [anon_sym_DOLLAR] = ACTIONS(765),
    [anon_sym_AT] = ACTIONS(765),
    [aux_sym__hex_literal_token1] = ACTIONS(297),
    [sym__number_literal] = ACTIONS(299),
    [anon_sym_SQUOTE] = ACTIONS(301),
    [anon_sym_DQUOTE] = ACTIONS(303),
    [sym_return] = ACTIONS(1564),
    [sym_next] = ACTIONS(1564),
    [sym_break] = ACTIONS(1564),
    [sym_true] = ACTIONS(1564),
    [sym_false] = ACTIONS(1564),
    [sym_null] = ACTIONS(1564),
    [sym_inf] = ACTIONS(1564),
    [sym_nan] = ACTIONS(1564),
    [anon_sym_NA] = ACTIONS(307),
    [anon_sym_NA_integer_] = ACTIONS(307),
    [anon_sym_NA_real_] = ACTIONS(307),
    [anon_sym_NA_complex_] = ACTIONS(307),
    [anon_sym_NA_character_] = ACTIONS(307),
    [sym_dots] = ACTIONS(1564),
    [sym_dot_dot_i] = ACTIONS(1566),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(765),
    [sym__newline] = ACTIONS(765),
    [sym__semicolon] = ACTIONS(765),
    [sym__raw_string_literal] = ACTIONS(313),
    [sym__external_open_parenthesis] = ACTIONS(315),
    [sym__external_close_parenthesis] = ACTIONS(765),
    [sym__external_open_brace] = ACTIONS(319),
    [sym__external_close_brace] = ACTIONS(765),
    [sym__external_open_bracket] = ACTIONS(765),
    [sym__external_close_bracket] = ACTIONS(765),
    [sym__external_open_bracket2] = ACTIONS(765),
  },
  [112] = {
    [sym_function_definition] = STATE(1133),
    [sym_if_statement] = STATE(1133),
    [sym_for_statement] = STATE(1133),
    [sym_while_statement] = STATE(1133),
    [sym_repeat_statement] = STATE(1133),
    [sym_braced_expression] = STATE(1133),
    [sym_parenthesized_expression] = STATE(1133),
    [sym_call] = STATE(1133),
    [sym_subset] = STATE(1133),
    [sym_subset2] = STATE(1133),
    [sym_unary_operator] = STATE(1133),
    [sym_binary_operator] = STATE(1133),
    [sym_extract_operator] = STATE(1133),
    [sym_namespace_operator] = STATE(1133),
    [sym_integer] = STATE(1133),
    [sym_complex] = STATE(1133),
    [sym_float] = STATE(1133),
    [sym__hex_literal] = STATE(2288),
    [sym__float_literal] = STATE(2288),
    [sym_string] = STATE(2287),
    [sym__single_quoted_string] = STATE(2289),
    [sym__double_quoted_string] = STATE(2290),
    [sym_na] = STATE(1133),
    [sym__expression] = STATE(1133),
    [sym__string_or_identifier] = STATE(5144),
    [sym__open_parenthesis] = STATE(119),
    [sym__close_parenthesis] = STATE(2810),
    [sym__open_brace] = STATE(16),
    [aux_sym_parenthesized_expression_repeat1] = STATE(271),
    [sym_identifier] = ACTIONS(1568),
    [anon_sym_BSLASH] = ACTIONS(1570),
    [anon_sym_function] = ACTIONS(1572),
    [anon_sym_EQ] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(1574),
    [anon_sym_for] = ACTIONS(1576),
    [anon_sym_while] = ACTIONS(1578),
    [anon_sym_repeat] = ACTIONS(1580),
    [anon_sym_QMARK] = ACTIONS(1582),
    [anon_sym_TILDE] = ACTIONS(1584),
    [anon_sym_BANG] = ACTIONS(1586),
    [anon_sym_PLUS] = ACTIONS(1588),
    [anon_sym_DASH] = ACTIONS(1590),
    [anon_sym_LT_DASH] = ACTIONS(211),
    [anon_sym_LT_LT_DASH] = ACTIONS(211),
    [anon_sym_COLON_EQ] = ACTIONS(211),
    [anon_sym_DASH_GT] = ACTIONS(209),
    [anon_sym_DASH_GT_GT] = ACTIONS(211),
    [anon_sym_PIPE] = ACTIONS(209),
    [anon_sym_AMP] = ACTIONS(209),
    [anon_sym_PIPE_PIPE] = ACTIONS(211),
    [anon_sym_AMP_AMP] = ACTIONS(211),
    [anon_sym_LT] = ACTIONS(209),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_GT] = ACTIONS(209),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [anon_sym_EQ_EQ] = ACTIONS(211),
    [anon_sym_BANG_EQ] = ACTIONS(211),
    [anon_sym_STAR] = ACTIONS(209),
    [anon_sym_SLASH] = ACTIONS(211),
    [anon_sym_STAR_STAR] = ACTIONS(211),
    [anon_sym_CARET] = ACTIONS(211),
    [aux_sym_binary_operator_token1] = ACTIONS(211),
    [anon_sym_PIPE_GT] = ACTIONS(211),
    [anon_sym_COLON] = ACTIONS(209),
    [anon_sym_DOLLAR] = ACTIONS(211),
    [anon_sym_AT] = ACTIONS(211),
    [aux_sym__hex_literal_token1] = ACTIONS(1592),
    [sym__number_literal] = ACTIONS(1594),
    [anon_sym_SQUOTE] = ACTIONS(1596),
    [anon_sym_DQUOTE] = ACTIONS(1598),
    [sym_return] = ACTIONS(1600),
    [sym_next] = ACTIONS(1600),
    [sym_break] = ACTIONS(1600),
    [sym_true] = ACTIONS(1600),
    [sym_false] = ACTIONS(1600),
    [sym_null] = ACTIONS(1600),
    [sym_inf] = ACTIONS(1600),
    [sym_nan] = ACTIONS(1600),
    [anon_sym_NA] = ACTIONS(1602),
    [anon_sym_NA_integer_] = ACTIONS(1602),
    [anon_sym_NA_real_] = ACTIONS(1602),
    [anon_sym_NA_complex_] = ACTIONS(1602),
    [anon_sym_NA_character_] = ACTIONS(1602),
    [sym_dots] = ACTIONS(1600),
    [sym_dot_dot_i] = ACTIONS(1604),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(211),
    [sym__newline] = ACTIONS(1606),
    [sym__raw_string_literal] = ACTIONS(1608),
    [sym__external_else] = ACTIONS(211),
    [sym__external_open_parenthesis] = ACTIONS(1610),
    [sym__external_close_parenthesis] = ACTIONS(1612),
    [sym__external_open_brace] = ACTIONS(1614),
    [sym__external_open_bracket] = ACTIONS(211),
    [sym__external_open_bracket2] = ACTIONS(211),
    [sym__external_close_bracket2] = ACTIONS(211),
  },
  [113] = {
    [sym_function_definition] = STATE(713),
    [sym_if_statement] = STATE(713),
    [sym_for_statement] = STATE(713),
    [sym_while_statement] = STATE(713),
    [sym_repeat_statement] = STATE(713),
    [sym_braced_expression] = STATE(713),
    [sym_parenthesized_expression] = STATE(713),
    [sym_call] = STATE(713),
    [sym_subset] = STATE(713),
    [sym_subset2] = STATE(713),
    [sym_unary_operator] = STATE(713),
    [sym_binary_operator] = STATE(713),
    [sym_extract_operator] = STATE(713),
    [sym_namespace_operator] = STATE(713),
    [sym_integer] = STATE(713),
    [sym_complex] = STATE(713),
    [sym_float] = STATE(713),
    [sym__hex_literal] = STATE(2189),
    [sym__float_literal] = STATE(2189),
    [sym_string] = STATE(2192),
    [sym__single_quoted_string] = STATE(2188),
    [sym__double_quoted_string] = STATE(2187),
    [sym_na] = STATE(713),
    [sym__expression] = STATE(713),
    [sym__string_or_identifier] = STATE(5139),
    [sym__open_parenthesis] = STATE(57),
    [sym__open_brace] = STATE(59),
    [aux_sym_function_definition_repeat1] = STATE(2336),
    [sym_identifier] = ACTIONS(273),
    [anon_sym_BSLASH] = ACTIONS(275),
    [anon_sym_function] = ACTIONS(277),
    [anon_sym_EQ] = ACTIONS(759),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_for] = ACTIONS(281),
    [anon_sym_while] = ACTIONS(283),
    [anon_sym_repeat] = ACTIONS(285),
    [anon_sym_QMARK] = ACTIONS(287),
    [anon_sym_TILDE] = ACTIONS(289),
    [anon_sym_BANG] = ACTIONS(291),
    [anon_sym_PLUS] = ACTIONS(293),
    [anon_sym_DASH] = ACTIONS(295),
    [anon_sym_LT_DASH] = ACTIONS(757),
    [anon_sym_LT_LT_DASH] = ACTIONS(757),
    [anon_sym_COLON_EQ] = ACTIONS(757),
    [anon_sym_DASH_GT] = ACTIONS(759),
    [anon_sym_DASH_GT_GT] = ACTIONS(757),
    [anon_sym_PIPE] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(759),
    [anon_sym_PIPE_PIPE] = ACTIONS(757),
    [anon_sym_AMP_AMP] = ACTIONS(757),
    [anon_sym_LT] = ACTIONS(759),
    [anon_sym_LT_EQ] = ACTIONS(757),
    [anon_sym_GT] = ACTIONS(759),
    [anon_sym_GT_EQ] = ACTIONS(757),
    [anon_sym_EQ_EQ] = ACTIONS(757),
    [anon_sym_BANG_EQ] = ACTIONS(757),
    [anon_sym_STAR] = ACTIONS(759),
    [anon_sym_SLASH] = ACTIONS(757),
    [anon_sym_STAR_STAR] = ACTIONS(757),
    [anon_sym_CARET] = ACTIONS(757),
    [aux_sym_binary_operator_token1] = ACTIONS(757),
    [anon_sym_PIPE_GT] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(759),
    [anon_sym_DOLLAR] = ACTIONS(757),
    [anon_sym_AT] = ACTIONS(757),
    [aux_sym__hex_literal_token1] = ACTIONS(297),
    [sym__number_literal] = ACTIONS(299),
    [anon_sym_SQUOTE] = ACTIONS(301),
    [anon_sym_DQUOTE] = ACTIONS(303),
    [sym_return] = ACTIONS(1616),
    [sym_next] = ACTIONS(1616),
    [sym_break] = ACTIONS(1616),
    [sym_true] = ACTIONS(1616),
    [sym_false] = ACTIONS(1616),
    [sym_null] = ACTIONS(1616),
    [sym_inf] = ACTIONS(1616),
    [sym_nan] = ACTIONS(1616),
    [anon_sym_NA] = ACTIONS(307),
    [anon_sym_NA_integer_] = ACTIONS(307),
    [anon_sym_NA_real_] = ACTIONS(307),
    [anon_sym_NA_complex_] = ACTIONS(307),
    [anon_sym_NA_character_] = ACTIONS(307),
    [sym_dots] = ACTIONS(1616),
    [sym_dot_dot_i] = ACTIONS(1618),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(757),
    [sym__newline] = ACTIONS(757),
    [sym__semicolon] = ACTIONS(757),
    [sym__raw_string_literal] = ACTIONS(313),
    [sym__external_open_parenthesis] = ACTIONS(315),
    [sym__external_close_parenthesis] = ACTIONS(757),
    [sym__external_open_brace] = ACTIONS(319),
    [sym__external_close_brace] = ACTIONS(757),
    [sym__external_open_bracket] = ACTIONS(757),
    [sym__external_close_bracket] = ACTIONS(757),
    [sym__external_open_bracket2] = ACTIONS(757),
  },
  [114] = {
    [sym_function_definition] = STATE(695),
    [sym_if_statement] = STATE(695),
    [sym_for_statement] = STATE(695),
    [sym_while_statement] = STATE(695),
    [sym_repeat_statement] = STATE(695),
    [sym_braced_expression] = STATE(695),
    [sym_parenthesized_expression] = STATE(695),
    [sym_call] = STATE(695),
    [sym_subset] = STATE(695),
    [sym_subset2] = STATE(695),
    [sym_unary_operator] = STATE(695),
    [sym_binary_operator] = STATE(695),
    [sym_extract_operator] = STATE(695),
    [sym_namespace_operator] = STATE(695),
    [sym_integer] = STATE(695),
    [sym_complex] = STATE(695),
    [sym_float] = STATE(695),
    [sym__hex_literal] = STATE(2189),
    [sym__float_literal] = STATE(2189),
    [sym_string] = STATE(2192),
    [sym__single_quoted_string] = STATE(2188),
    [sym__double_quoted_string] = STATE(2187),
    [sym_na] = STATE(695),
    [sym__expression] = STATE(695),
    [sym__string_or_identifier] = STATE(5139),
    [sym__open_parenthesis] = STATE(57),
    [sym__open_brace] = STATE(59),
    [aux_sym_function_definition_repeat1] = STATE(115),
    [sym_identifier] = ACTIONS(273),
    [anon_sym_BSLASH] = ACTIONS(275),
    [anon_sym_function] = ACTIONS(277),
    [anon_sym_EQ] = ACTIONS(533),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_for] = ACTIONS(281),
    [anon_sym_while] = ACTIONS(283),
    [anon_sym_repeat] = ACTIONS(285),
    [anon_sym_QMARK] = ACTIONS(287),
    [anon_sym_TILDE] = ACTIONS(289),
    [anon_sym_BANG] = ACTIONS(291),
    [anon_sym_PLUS] = ACTIONS(293),
    [anon_sym_DASH] = ACTIONS(295),
    [anon_sym_LT_DASH] = ACTIONS(531),
    [anon_sym_LT_LT_DASH] = ACTIONS(531),
    [anon_sym_COLON_EQ] = ACTIONS(531),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_DASH_GT_GT] = ACTIONS(531),
    [anon_sym_PIPE] = ACTIONS(533),
    [anon_sym_AMP] = ACTIONS(533),
    [anon_sym_PIPE_PIPE] = ACTIONS(531),
    [anon_sym_AMP_AMP] = ACTIONS(531),
    [anon_sym_LT] = ACTIONS(533),
    [anon_sym_LT_EQ] = ACTIONS(531),
    [anon_sym_GT] = ACTIONS(533),
    [anon_sym_GT_EQ] = ACTIONS(531),
    [anon_sym_EQ_EQ] = ACTIONS(531),
    [anon_sym_BANG_EQ] = ACTIONS(531),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_SLASH] = ACTIONS(531),
    [anon_sym_STAR_STAR] = ACTIONS(531),
    [anon_sym_CARET] = ACTIONS(531),
    [aux_sym_binary_operator_token1] = ACTIONS(531),
    [anon_sym_PIPE_GT] = ACTIONS(531),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_DOLLAR] = ACTIONS(531),
    [anon_sym_AT] = ACTIONS(531),
    [aux_sym__hex_literal_token1] = ACTIONS(297),
    [sym__number_literal] = ACTIONS(299),
    [anon_sym_SQUOTE] = ACTIONS(301),
    [anon_sym_DQUOTE] = ACTIONS(303),
    [sym_return] = ACTIONS(1620),
    [sym_next] = ACTIONS(1620),
    [sym_break] = ACTIONS(1620),
    [sym_true] = ACTIONS(1620),
    [sym_false] = ACTIONS(1620),
    [sym_null] = ACTIONS(1620),
    [sym_inf] = ACTIONS(1620),
    [sym_nan] = ACTIONS(1620),
    [anon_sym_NA] = ACTIONS(307),
    [anon_sym_NA_integer_] = ACTIONS(307),
    [anon_sym_NA_real_] = ACTIONS(307),
    [anon_sym_NA_complex_] = ACTIONS(307),
    [anon_sym_NA_character_] = ACTIONS(307),
    [sym_dots] = ACTIONS(1620),
    [sym_dot_dot_i] = ACTIONS(1622),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(531),
    [sym__newline] = ACTIONS(1624),
    [sym__semicolon] = ACTIONS(531),
    [sym__raw_string_literal] = ACTIONS(313),
    [sym__external_open_parenthesis] = ACTIONS(315),
    [sym__external_close_parenthesis] = ACTIONS(531),
    [sym__external_open_brace] = ACTIONS(319),
    [sym__external_close_brace] = ACTIONS(531),
    [sym__external_open_bracket] = ACTIONS(531),
    [sym__external_close_bracket] = ACTIONS(531),
    [sym__external_open_bracket2] = ACTIONS(531),
  },
  [115] = {
    [sym_function_definition] = STATE(690),
    [sym_if_statement] = STATE(690),
    [sym_for_statement] = STATE(690),
    [sym_while_statement] = STATE(690),
    [sym_repeat_statement] = STATE(690),
    [sym_braced_expression] = STATE(690),
    [sym_parenthesized_expression] = STATE(690),
    [sym_call] = STATE(690),
    [sym_subset] = STATE(690),
    [sym_subset2] = STATE(690),
    [sym_unary_operator] = STATE(690),
    [sym_binary_operator] = STATE(690),
    [sym_extract_operator] = STATE(690),
    [sym_namespace_operator] = STATE(690),
    [sym_integer] = STATE(690),
    [sym_complex] = STATE(690),
    [sym_float] = STATE(690),
    [sym__hex_literal] = STATE(2189),
    [sym__float_literal] = STATE(2189),
    [sym_string] = STATE(2192),
    [sym__single_quoted_string] = STATE(2188),
    [sym__double_quoted_string] = STATE(2187),
    [sym_na] = STATE(690),
    [sym__expression] = STATE(690),
    [sym__string_or_identifier] = STATE(5139),
    [sym__open_parenthesis] = STATE(57),
    [sym__open_brace] = STATE(59),
    [aux_sym_function_definition_repeat1] = STATE(2336),
    [sym_identifier] = ACTIONS(273),
    [anon_sym_BSLASH] = ACTIONS(275),
    [anon_sym_function] = ACTIONS(277),
    [anon_sym_EQ] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_for] = ACTIONS(281),
    [anon_sym_while] = ACTIONS(283),
    [anon_sym_repeat] = ACTIONS(285),
    [anon_sym_QMARK] = ACTIONS(287),
    [anon_sym_TILDE] = ACTIONS(289),
    [anon_sym_BANG] = ACTIONS(291),
    [anon_sym_PLUS] = ACTIONS(293),
    [anon_sym_DASH] = ACTIONS(295),
    [anon_sym_LT_DASH] = ACTIONS(369),
    [anon_sym_LT_LT_DASH] = ACTIONS(369),
    [anon_sym_COLON_EQ] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(371),
    [anon_sym_DASH_GT_GT] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(371),
    [anon_sym_AMP] = ACTIONS(371),
    [anon_sym_PIPE_PIPE] = ACTIONS(369),
    [anon_sym_AMP_AMP] = ACTIONS(369),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_LT_EQ] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_EQ] = ACTIONS(369),
    [anon_sym_EQ_EQ] = ACTIONS(369),
    [anon_sym_BANG_EQ] = ACTIONS(369),
    [anon_sym_STAR] = ACTIONS(371),
    [anon_sym_SLASH] = ACTIONS(369),
    [anon_sym_STAR_STAR] = ACTIONS(369),
    [anon_sym_CARET] = ACTIONS(369),
    [aux_sym_binary_operator_token1] = ACTIONS(369),
    [anon_sym_PIPE_GT] = ACTIONS(369),
    [anon_sym_COLON] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(369),
    [anon_sym_AT] = ACTIONS(369),
    [aux_sym__hex_literal_token1] = ACTIONS(297),
    [sym__number_literal] = ACTIONS(299),
    [anon_sym_SQUOTE] = ACTIONS(301),
    [anon_sym_DQUOTE] = ACTIONS(303),
    [sym_return] = ACTIONS(1626),
    [sym_next] = ACTIONS(1626),
    [sym_break] = ACTIONS(1626),
    [sym_true] = ACTIONS(1626),
    [sym_false] = ACTIONS(1626),
    [sym_null] = ACTIONS(1626),
    [sym_inf] = ACTIONS(1626),
    [sym_nan] = ACTIONS(1626),
    [anon_sym_NA] = ACTIONS(307),
    [anon_sym_NA_integer_] = ACTIONS(307),
    [anon_sym_NA_real_] = ACTIONS(307),
    [anon_sym_NA_complex_] = ACTIONS(307),
    [anon_sym_NA_character_] = ACTIONS(307),
    [sym_dots] = ACTIONS(1626),
    [sym_dot_dot_i] = ACTIONS(1628),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(369),
    [sym__newline] = ACTIONS(369),
    [sym__semicolon] = ACTIONS(369),
    [sym__raw_string_literal] = ACTIONS(313),
    [sym__external_open_parenthesis] = ACTIONS(315),
    [sym__external_close_parenthesis] = ACTIONS(369),
    [sym__external_open_brace] = ACTIONS(319),
    [sym__external_close_brace] = ACTIONS(369),
    [sym__external_open_bracket] = ACTIONS(369),
    [sym__external_close_bracket] = ACTIONS(369),
    [sym__external_open_bracket2] = ACTIONS(369),
  },
  [116] = {
    [sym_function_definition] = STATE(689),
    [sym_if_statement] = STATE(689),
    [sym_for_statement] = STATE(689),
    [sym_while_statement] = STATE(689),
    [sym_repeat_statement] = STATE(689),
    [sym_braced_expression] = STATE(689),
    [sym_parenthesized_expression] = STATE(689),
    [sym_call] = STATE(689),
    [sym_subset] = STATE(689),
    [sym_subset2] = STATE(689),
    [sym_unary_operator] = STATE(689),
    [sym_binary_operator] = STATE(689),
    [sym_extract_operator] = STATE(689),
    [sym_namespace_operator] = STATE(689),
    [sym_integer] = STATE(689),
    [sym_complex] = STATE(689),
    [sym_float] = STATE(689),
    [sym__hex_literal] = STATE(2189),
    [sym__float_literal] = STATE(2189),
    [sym_string] = STATE(2192),
    [sym__single_quoted_string] = STATE(2188),
    [sym__double_quoted_string] = STATE(2187),
    [sym_na] = STATE(689),
    [sym__expression] = STATE(689),
    [sym__string_or_identifier] = STATE(5139),
    [sym__open_parenthesis] = STATE(57),
    [sym__open_brace] = STATE(59),
    [aux_sym_function_definition_repeat1] = STATE(118),
    [sym_identifier] = ACTIONS(273),
    [anon_sym_BSLASH] = ACTIONS(275),
    [anon_sym_function] = ACTIONS(277),
    [anon_sym_EQ] = ACTIONS(379),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_for] = ACTIONS(281),
    [anon_sym_while] = ACTIONS(283),
    [anon_sym_repeat] = ACTIONS(285),
    [anon_sym_QMARK] = ACTIONS(287),
    [anon_sym_TILDE] = ACTIONS(289),
    [anon_sym_BANG] = ACTIONS(291),
    [anon_sym_PLUS] = ACTIONS(293),
    [anon_sym_DASH] = ACTIONS(295),
    [anon_sym_LT_DASH] = ACTIONS(377),
    [anon_sym_LT_LT_DASH] = ACTIONS(377),
    [anon_sym_COLON_EQ] = ACTIONS(377),
    [anon_sym_DASH_GT] = ACTIONS(379),
    [anon_sym_DASH_GT_GT] = ACTIONS(377),
    [anon_sym_PIPE] = ACTIONS(379),
    [anon_sym_AMP] = ACTIONS(379),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_LT] = ACTIONS(379),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(379),
    [anon_sym_GT_EQ] = ACTIONS(377),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(379),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_STAR_STAR] = ACTIONS(377),
    [anon_sym_CARET] = ACTIONS(377),
    [aux_sym_binary_operator_token1] = ACTIONS(377),
    [anon_sym_PIPE_GT] = ACTIONS(377),
    [anon_sym_COLON] = ACTIONS(379),
    [anon_sym_DOLLAR] = ACTIONS(377),
    [anon_sym_AT] = ACTIONS(377),
    [aux_sym__hex_literal_token1] = ACTIONS(297),
    [sym__number_literal] = ACTIONS(299),
    [anon_sym_SQUOTE] = ACTIONS(301),
    [anon_sym_DQUOTE] = ACTIONS(303),
    [sym_return] = ACTIONS(1630),
    [sym_next] = ACTIONS(1630),
    [sym_break] = ACTIONS(1630),
    [sym_true] = ACTIONS(1630),
    [sym_false] = ACTIONS(1630),
    [sym_null] = ACTIONS(1630),
    [sym_inf] = ACTIONS(1630),
    [sym_nan] = ACTIONS(1630),
    [anon_sym_NA] = ACTIONS(307),
    [anon_sym_NA_integer_] = ACTIONS(307),
    [anon_sym_NA_real_] = ACTIONS(307),
    [anon_sym_NA_complex_] = ACTIONS(307),
    [anon_sym_NA_character_] = ACTIONS(307),
    [sym_dots] = ACTIONS(1630),
    [sym_dot_dot_i] = ACTIONS(1632),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(377),
    [sym__newline] = ACTIONS(1634),
    [sym__semicolon] = ACTIONS(377),
    [sym__raw_string_literal] = ACTIONS(313),
    [sym__external_open_parenthesis] = ACTIONS(315),
    [sym__external_close_parenthesis] = ACTIONS(377),
    [sym__external_open_brace] = ACTIONS(319),
    [sym__external_close_brace] = ACTIONS(377),
    [sym__external_open_bracket] = ACTIONS(377),
    [sym__external_close_bracket] = ACTIONS(377),
    [sym__external_open_bracket2] = ACTIONS(377),
  },
  [117] = {
    [sym_function_definition] = STATE(686),
    [sym_if_statement] = STATE(686),
    [sym_for_statement] = STATE(686),
    [sym_while_statement] = STATE(686),
    [sym_repeat_statement] = STATE(686),
    [sym_braced_expression] = STATE(686),
    [sym_parenthesized_expression] = STATE(686),
    [sym_call] = STATE(686),
    [sym_subset] = STATE(686),
    [sym_subset2] = STATE(686),
    [sym_unary_operator] = STATE(686),
    [sym_binary_operator] = STATE(686),
    [sym_extract_operator] = STATE(686),
    [sym_namespace_operator] = STATE(686),
    [sym_integer] = STATE(686),
    [sym_complex] = STATE(686),
    [sym_float] = STATE(686),
    [sym__hex_literal] = STATE(2189),
    [sym__float_literal] = STATE(2189),
    [sym_string] = STATE(2192),
    [sym__single_quoted_string] = STATE(2188),
    [sym__double_quoted_string] = STATE(2187),
    [sym_na] = STATE(686),
    [sym__expression] = STATE(686),
    [sym__string_or_identifier] = STATE(5139),
    [sym__open_parenthesis] = STATE(57),
    [sym__open_brace] = STATE(59),
    [aux_sym_function_definition_repeat1] = STATE(122),
    [sym_identifier] = ACTIONS(273),
    [anon_sym_BSLASH] = ACTIONS(275),
    [anon_sym_function] = ACTIONS(277),
    [anon_sym_EQ] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_for] = ACTIONS(281),
    [anon_sym_while] = ACTIONS(283),
    [anon_sym_repeat] = ACTIONS(285),
    [anon_sym_QMARK] = ACTIONS(287),
    [anon_sym_TILDE] = ACTIONS(289),
    [anon_sym_BANG] = ACTIONS(291),
    [anon_sym_PLUS] = ACTIONS(293),
    [anon_sym_DASH] = ACTIONS(295),
    [anon_sym_LT_DASH] = ACTIONS(387),
    [anon_sym_LT_LT_DASH] = ACTIONS(387),
    [anon_sym_COLON_EQ] = ACTIONS(387),
    [anon_sym_DASH_GT] = ACTIONS(389),
    [anon_sym_DASH_GT_GT] = ACTIONS(387),
    [anon_sym_PIPE] = ACTIONS(389),
    [anon_sym_AMP] = ACTIONS(389),
    [anon_sym_PIPE_PIPE] = ACTIONS(387),
    [anon_sym_AMP_AMP] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(389),
    [anon_sym_LT_EQ] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(389),
    [anon_sym_GT_EQ] = ACTIONS(387),
    [anon_sym_EQ_EQ] = ACTIONS(387),
    [anon_sym_BANG_EQ] = ACTIONS(387),
    [anon_sym_STAR] = ACTIONS(389),
    [anon_sym_SLASH] = ACTIONS(387),
    [anon_sym_STAR_STAR] = ACTIONS(387),
    [anon_sym_CARET] = ACTIONS(387),
    [aux_sym_binary_operator_token1] = ACTIONS(387),
    [anon_sym_PIPE_GT] = ACTIONS(387),
    [anon_sym_COLON] = ACTIONS(389),
    [anon_sym_DOLLAR] = ACTIONS(387),
    [anon_sym_AT] = ACTIONS(387),
    [aux_sym__hex_literal_token1] = ACTIONS(297),
    [sym__number_literal] = ACTIONS(299),
    [anon_sym_SQUOTE] = ACTIONS(301),
    [anon_sym_DQUOTE] = ACTIONS(303),
    [sym_return] = ACTIONS(1636),
    [sym_next] = ACTIONS(1636),
    [sym_break] = ACTIONS(1636),
    [sym_true] = ACTIONS(1636),
    [sym_false] = ACTIONS(1636),
    [sym_null] = ACTIONS(1636),
    [sym_inf] = ACTIONS(1636),
    [sym_nan] = ACTIONS(1636),
    [anon_sym_NA] = ACTIONS(307),
    [anon_sym_NA_integer_] = ACTIONS(307),
    [anon_sym_NA_real_] = ACTIONS(307),
    [anon_sym_NA_complex_] = ACTIONS(307),
    [anon_sym_NA_character_] = ACTIONS(307),
    [sym_dots] = ACTIONS(1636),
    [sym_dot_dot_i] = ACTIONS(1638),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(387),
    [sym__newline] = ACTIONS(1640),
    [sym__semicolon] = ACTIONS(387),
    [sym__raw_string_literal] = ACTIONS(313),
    [sym__external_open_parenthesis] = ACTIONS(315),
    [sym__external_close_parenthesis] = ACTIONS(387),
    [sym__external_open_brace] = ACTIONS(319),
    [sym__external_close_brace] = ACTIONS(387),
    [sym__external_open_bracket] = ACTIONS(387),
    [sym__external_close_bracket] = ACTIONS(387),
    [sym__external_open_bracket2] = ACTIONS(387),
  },
  [118] = {
    [sym_function_definition] = STATE(685),
    [sym_if_statement] = STATE(685),
    [sym_for_statement] = STATE(685),
    [sym_while_statement] = STATE(685),
    [sym_repeat_statement] = STATE(685),
    [sym_braced_expression] = STATE(685),
    [sym_parenthesized_expression] = STATE(685),
    [sym_call] = STATE(685),
    [sym_subset] = STATE(685),
    [sym_subset2] = STATE(685),
    [sym_unary_operator] = STATE(685),
    [sym_binary_operator] = STATE(685),
    [sym_extract_operator] = STATE(685),
    [sym_namespace_operator] = STATE(685),
    [sym_integer] = STATE(685),
    [sym_complex] = STATE(685),
    [sym_float] = STATE(685),
    [sym__hex_literal] = STATE(2189),
    [sym__float_literal] = STATE(2189),
    [sym_string] = STATE(2192),
    [sym__single_quoted_string] = STATE(2188),
    [sym__double_quoted_string] = STATE(2187),
    [sym_na] = STATE(685),
    [sym__expression] = STATE(685),
    [sym__string_or_identifier] = STATE(5139),
    [sym__open_parenthesis] = STATE(57),
    [sym__open_brace] = STATE(59),
    [aux_sym_function_definition_repeat1] = STATE(2336),
    [sym_identifier] = ACTIONS(273),
    [anon_sym_BSLASH] = ACTIONS(275),
    [anon_sym_function] = ACTIONS(277),
    [anon_sym_EQ] = ACTIONS(399),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_for] = ACTIONS(281),
    [anon_sym_while] = ACTIONS(283),
    [anon_sym_repeat] = ACTIONS(285),
    [anon_sym_QMARK] = ACTIONS(287),
    [anon_sym_TILDE] = ACTIONS(289),
    [anon_sym_BANG] = ACTIONS(291),
    [anon_sym_PLUS] = ACTIONS(293),
    [anon_sym_DASH] = ACTIONS(295),
    [anon_sym_LT_DASH] = ACTIONS(397),
    [anon_sym_LT_LT_DASH] = ACTIONS(397),
    [anon_sym_COLON_EQ] = ACTIONS(397),
    [anon_sym_DASH_GT] = ACTIONS(399),
    [anon_sym_DASH_GT_GT] = ACTIONS(397),
    [anon_sym_PIPE] = ACTIONS(399),
    [anon_sym_AMP] = ACTIONS(399),
    [anon_sym_PIPE_PIPE] = ACTIONS(397),
    [anon_sym_AMP_AMP] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(399),
    [anon_sym_LT_EQ] = ACTIONS(397),
    [anon_sym_GT] = ACTIONS(399),
    [anon_sym_GT_EQ] = ACTIONS(397),
    [anon_sym_EQ_EQ] = ACTIONS(397),
    [anon_sym_BANG_EQ] = ACTIONS(397),
    [anon_sym_STAR] = ACTIONS(399),
    [anon_sym_SLASH] = ACTIONS(397),
    [anon_sym_STAR_STAR] = ACTIONS(397),
    [anon_sym_CARET] = ACTIONS(397),
    [aux_sym_binary_operator_token1] = ACTIONS(397),
    [anon_sym_PIPE_GT] = ACTIONS(397),
    [anon_sym_COLON] = ACTIONS(399),
    [anon_sym_DOLLAR] = ACTIONS(397),
    [anon_sym_AT] = ACTIONS(397),
    [aux_sym__hex_literal_token1] = ACTIONS(297),
    [sym__number_literal] = ACTIONS(299),
    [anon_sym_SQUOTE] = ACTIONS(301),
    [anon_sym_DQUOTE] = ACTIONS(303),
    [sym_return] = ACTIONS(1642),
    [sym_next] = ACTIONS(1642),
    [sym_break] = ACTIONS(1642),
    [sym_true] = ACTIONS(1642),
    [sym_false] = ACTIONS(1642),
    [sym_null] = ACTIONS(1642),
    [sym_inf] = ACTIONS(1642),
    [sym_nan] = ACTIONS(1642),
    [anon_sym_NA] = ACTIONS(307),
    [anon_sym_NA_integer_] = ACTIONS(307),
    [anon_sym_NA_real_] = ACTIONS(307),
    [anon_sym_NA_complex_] = ACTIONS(307),
    [anon_sym_NA_character_] = ACTIONS(307),
    [sym_dots] = ACTIONS(1642),
    [sym_dot_dot_i] = ACTIONS(1644),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(397),
    [sym__newline] = ACTIONS(397),
    [sym__semicolon] = ACTIONS(397),
    [sym__raw_string_literal] = ACTIONS(313),
    [sym__external_open_parenthesis] = ACTIONS(315),
    [sym__external_close_parenthesis] = ACTIONS(397),
    [sym__external_open_brace] = ACTIONS(319),
    [sym__external_close_brace] = ACTIONS(397),
    [sym__external_open_bracket] = ACTIONS(397),
    [sym__external_close_bracket] = ACTIONS(397),
    [sym__external_open_bracket2] = ACTIONS(397),
  },
  [119] = {
    [sym_function_definition] = STATE(1133),
    [sym_if_statement] = STATE(1133),
    [sym_for_statement] = STATE(1133),
    [sym_while_statement] = STATE(1133),
    [sym_repeat_statement] = STATE(1133),
    [sym_braced_expression] = STATE(1133),
    [sym_parenthesized_expression] = STATE(1133),
    [sym_call] = STATE(1133),
    [sym_subset] = STATE(1133),
    [sym_subset2] = STATE(1133),
    [sym_unary_operator] = STATE(1133),
    [sym_binary_operator] = STATE(1133),
    [sym_extract_operator] = STATE(1133),
    [sym_namespace_operator] = STATE(1133),
    [sym_integer] = STATE(1133),
    [sym_complex] = STATE(1133),
    [sym_float] = STATE(1133),
    [sym__hex_literal] = STATE(2288),
    [sym__float_literal] = STATE(2288),
    [sym_string] = STATE(2287),
    [sym__single_quoted_string] = STATE(2289),
    [sym__double_quoted_string] = STATE(2290),
    [sym_na] = STATE(1133),
    [sym__expression] = STATE(1133),
    [sym__string_or_identifier] = STATE(5144),
    [sym__open_parenthesis] = STATE(119),
    [sym__close_parenthesis] = STATE(2646),
    [sym__open_brace] = STATE(16),
    [aux_sym_parenthesized_expression_repeat1] = STATE(176),
    [sym_identifier] = ACTIONS(1568),
    [anon_sym_BSLASH] = ACTIONS(1570),
    [anon_sym_function] = ACTIONS(1572),
    [anon_sym_EQ] = ACTIONS(109),
    [anon_sym_if] = ACTIONS(1574),
    [anon_sym_for] = ACTIONS(1576),
    [anon_sym_while] = ACTIONS(1578),
    [anon_sym_repeat] = ACTIONS(1580),
    [anon_sym_QMARK] = ACTIONS(1582),
    [anon_sym_TILDE] = ACTIONS(1584),
    [anon_sym_BANG] = ACTIONS(1586),
    [anon_sym_PLUS] = ACTIONS(1588),
    [anon_sym_DASH] = ACTIONS(1590),
    [anon_sym_LT_DASH] = ACTIONS(129),
    [anon_sym_LT_LT_DASH] = ACTIONS(129),
    [anon_sym_COLON_EQ] = ACTIONS(129),
    [anon_sym_DASH_GT] = ACTIONS(109),
    [anon_sym_DASH_GT_GT] = ACTIONS(129),
    [anon_sym_PIPE] = ACTIONS(109),
    [anon_sym_AMP] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_STAR_STAR] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [aux_sym_binary_operator_token1] = ACTIONS(129),
    [anon_sym_PIPE_GT] = ACTIONS(129),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(129),
    [anon_sym_AT] = ACTIONS(129),
    [aux_sym__hex_literal_token1] = ACTIONS(1592),
    [sym__number_literal] = ACTIONS(1594),
    [anon_sym_SQUOTE] = ACTIONS(1596),
    [anon_sym_DQUOTE] = ACTIONS(1598),
    [sym_return] = ACTIONS(1600),
    [sym_next] = ACTIONS(1600),
    [sym_break] = ACTIONS(1600),
    [sym_true] = ACTIONS(1600),
    [sym_false] = ACTIONS(1600),
    [sym_null] = ACTIONS(1600),
    [sym_inf] = ACTIONS(1600),
    [sym_nan] = ACTIONS(1600),
    [anon_sym_NA] = ACTIONS(1602),
    [anon_sym_NA_integer_] = ACTIONS(1602),
    [anon_sym_NA_real_] = ACTIONS(1602),
    [anon_sym_NA_complex_] = ACTIONS(1602),
    [anon_sym_NA_character_] = ACTIONS(1602),
    [sym_dots] = ACTIONS(1600),
    [sym_dot_dot_i] = ACTIONS(1604),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(129),
    [sym__newline] = ACTIONS(1606),
    [sym__raw_string_literal] = ACTIONS(1608),
    [sym__external_else] = ACTIONS(129),
    [sym__external_open_parenthesis] = ACTIONS(1610),
    [sym__external_close_parenthesis] = ACTIONS(1646),
    [sym__external_open_brace] = ACTIONS(1614),
    [sym__external_open_bracket] = ACTIONS(129),
    [sym__external_open_bracket2] = ACTIONS(129),
    [sym__external_close_bracket2] = ACTIONS(129),
  },
  [120] = {
    [sym_function_definition] = STATE(1139),
    [sym_if_statement] = STATE(1139),
    [sym_for_statement] = STATE(1139),
    [sym_while_statement] = STATE(1139),
    [sym_repeat_statement] = STATE(1139),
    [sym_braced_expression] = STATE(1139),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_call] = STATE(1139),
    [sym_subset] = STATE(1139),
    [sym_subset2] = STATE(1139),
    [sym_unary_operator] = STATE(1139),
    [sym_binary_operator] = STATE(1139),
    [sym_extract_operator] = STATE(1139),
    [sym_namespace_operator] = STATE(1139),
    [sym_integer] = STATE(1139),
    [sym_complex] = STATE(1139),
    [sym_float] = STATE(1139),
    [sym__hex_literal] = STATE(2272),
    [sym__float_literal] = STATE(2272),
    [sym_string] = STATE(2271),
    [sym__single_quoted_string] = STATE(2273),
    [sym__double_quoted_string] = STATE(2274),
    [sym_na] = STATE(1139),
    [sym__expression] = STATE(1139),
    [sym__string_or_identifier] = STATE(5157),
    [sym__open_parenthesis] = STATE(120),
    [sym__close_parenthesis] = STATE(2727),
    [sym__open_brace] = STATE(11),
    [aux_sym_parenthesized_expression_repeat1] = STATE(170),
    [sym_identifier] = ACTIONS(1241),
    [anon_sym_BSLASH] = ACTIONS(1243),
    [anon_sym_function] = ACTIONS(1245),
    [anon_sym_EQ] = ACTIONS(109),
    [anon_sym_if] = ACTIONS(1247),
    [anon_sym_for] = ACTIONS(1249),
    [anon_sym_while] = ACTIONS(1251),
    [anon_sym_repeat] = ACTIONS(1253),
    [anon_sym_QMARK] = ACTIONS(1255),
    [anon_sym_TILDE] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1259),
    [anon_sym_PLUS] = ACTIONS(1261),
    [anon_sym_DASH] = ACTIONS(1263),
    [anon_sym_LT_DASH] = ACTIONS(129),
    [anon_sym_LT_LT_DASH] = ACTIONS(129),
    [anon_sym_COLON_EQ] = ACTIONS(129),
    [anon_sym_DASH_GT] = ACTIONS(109),
    [anon_sym_DASH_GT_GT] = ACTIONS(129),
    [anon_sym_PIPE] = ACTIONS(109),
    [anon_sym_AMP] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_STAR_STAR] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [aux_sym_binary_operator_token1] = ACTIONS(129),
    [anon_sym_PIPE_GT] = ACTIONS(129),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(129),
    [anon_sym_AT] = ACTIONS(129),
    [aux_sym__hex_literal_token1] = ACTIONS(1265),
    [sym__number_literal] = ACTIONS(1267),
    [anon_sym_SQUOTE] = ACTIONS(1269),
    [anon_sym_DQUOTE] = ACTIONS(1271),
    [sym_return] = ACTIONS(1273),
    [sym_next] = ACTIONS(1273),
    [sym_break] = ACTIONS(1273),
    [sym_true] = ACTIONS(1273),
    [sym_false] = ACTIONS(1273),
    [sym_null] = ACTIONS(1273),
    [sym_inf] = ACTIONS(1273),
    [sym_nan] = ACTIONS(1273),
    [anon_sym_NA] = ACTIONS(1275),
    [anon_sym_NA_integer_] = ACTIONS(1275),
    [anon_sym_NA_real_] = ACTIONS(1275),
    [anon_sym_NA_complex_] = ACTIONS(1275),
    [anon_sym_NA_character_] = ACTIONS(1275),
    [sym_dots] = ACTIONS(1273),
    [sym_dot_dot_i] = ACTIONS(1277),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(129),
    [sym__newline] = ACTIONS(1279),
    [sym__raw_string_literal] = ACTIONS(1281),
    [sym__external_else] = ACTIONS(129),
    [sym__external_open_parenthesis] = ACTIONS(1283),
    [sym__external_close_parenthesis] = ACTIONS(1648),
    [sym__external_open_brace] = ACTIONS(1287),
    [sym__external_open_bracket] = ACTIONS(129),
    [sym__external_close_bracket] = ACTIONS(129),
    [sym__external_open_bracket2] = ACTIONS(129),
  },
  [121] = {
    [sym_function_definition] = STATE(970),
    [sym_if_statement] = STATE(970),
    [sym_for_statement] = STATE(970),
    [sym_while_statement] = STATE(970),
    [sym_repeat_statement] = STATE(970),
    [sym_braced_expression] = STATE(970),
    [sym_parenthesized_expression] = STATE(970),
    [sym_call] = STATE(970),
    [sym_subset] = STATE(970),
    [sym_subset2] = STATE(970),
    [sym_unary_operator] = STATE(970),
    [sym_binary_operator] = STATE(970),
    [sym_extract_operator] = STATE(970),
    [sym_namespace_operator] = STATE(970),
    [sym_integer] = STATE(970),
    [sym_complex] = STATE(970),
    [sym_float] = STATE(970),
    [sym__hex_literal] = STATE(2266),
    [sym__float_literal] = STATE(2266),
    [sym_string] = STATE(2284),
    [sym__single_quoted_string] = STATE(2265),
    [sym__double_quoted_string] = STATE(2264),
    [sym_na] = STATE(970),
    [sym__expression] = STATE(970),
    [sym__string_or_identifier] = STATE(5147),
    [sym__open_parenthesis] = STATE(23),
    [sym__open_brace] = STATE(180),
    [sym__close_brace] = STATE(2999),
    [aux_sym_braced_expression_repeat1] = STATE(294),
    [sym_identifier] = ACTIONS(1289),
    [anon_sym_BSLASH] = ACTIONS(1291),
    [anon_sym_function] = ACTIONS(1293),
    [anon_sym_EQ] = ACTIONS(59),
    [anon_sym_if] = ACTIONS(1295),
    [anon_sym_for] = ACTIONS(1297),
    [anon_sym_while] = ACTIONS(1299),
    [anon_sym_repeat] = ACTIONS(1301),
    [anon_sym_QMARK] = ACTIONS(1303),
    [anon_sym_TILDE] = ACTIONS(1305),
    [anon_sym_BANG] = ACTIONS(1307),
    [anon_sym_PLUS] = ACTIONS(1309),
    [anon_sym_DASH] = ACTIONS(1311),
    [anon_sym_LT_DASH] = ACTIONS(51),
    [anon_sym_LT_LT_DASH] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(51),
    [anon_sym_DASH_GT] = ACTIONS(59),
    [anon_sym_DASH_GT_GT] = ACTIONS(51),
    [anon_sym_PIPE] = ACTIONS(59),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_AMP_AMP] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(59),
    [anon_sym_LT_EQ] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(59),
    [anon_sym_GT_EQ] = ACTIONS(51),
    [anon_sym_EQ_EQ] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(51),
    [anon_sym_CARET] = ACTIONS(51),
    [aux_sym_binary_operator_token1] = ACTIONS(51),
    [anon_sym_PIPE_GT] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(59),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_AT] = ACTIONS(51),
    [aux_sym__hex_literal_token1] = ACTIONS(1313),
    [sym__number_literal] = ACTIONS(1315),
    [anon_sym_SQUOTE] = ACTIONS(1317),
    [anon_sym_DQUOTE] = ACTIONS(1319),
    [sym_return] = ACTIONS(1321),
    [sym_next] = ACTIONS(1321),
    [sym_break] = ACTIONS(1321),
    [sym_true] = ACTIONS(1321),
    [sym_false] = ACTIONS(1321),
    [sym_null] = ACTIONS(1321),
    [sym_inf] = ACTIONS(1321),
    [sym_nan] = ACTIONS(1321),
    [anon_sym_NA] = ACTIONS(1323),
    [anon_sym_NA_integer_] = ACTIONS(1323),
    [anon_sym_NA_real_] = ACTIONS(1323),
    [anon_sym_NA_complex_] = ACTIONS(1323),
    [anon_sym_NA_character_] = ACTIONS(1323),
    [sym_dots] = ACTIONS(1321),
    [sym_dot_dot_i] = ACTIONS(1325),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(51),
    [sym__newline] = ACTIONS(1327),
    [sym__semicolon] = ACTIONS(1327),
    [sym__raw_string_literal] = ACTIONS(1329),
    [sym__external_open_parenthesis] = ACTIONS(1331),
    [sym__external_open_brace] = ACTIONS(1333),
    [sym__external_close_brace] = ACTIONS(1650),
    [sym__external_open_bracket] = ACTIONS(51),
    [sym__external_close_bracket] = ACTIONS(51),
    [sym__external_open_bracket2] = ACTIONS(51),
  },
  [122] = {
    [sym_function_definition] = STATE(682),
    [sym_if_statement] = STATE(682),
    [sym_for_statement] = STATE(682),
    [sym_while_statement] = STATE(682),
    [sym_repeat_statement] = STATE(682),
    [sym_braced_expression] = STATE(682),
    [sym_parenthesized_expression] = STATE(682),
    [sym_call] = STATE(682),
    [sym_subset] = STATE(682),
    [sym_subset2] = STATE(682),
    [sym_unary_operator] = STATE(682),
    [sym_binary_operator] = STATE(682),
    [sym_extract_operator] = STATE(682),
    [sym_namespace_operator] = STATE(682),
    [sym_integer] = STATE(682),
    [sym_complex] = STATE(682),
    [sym_float] = STATE(682),
    [sym__hex_literal] = STATE(2189),
    [sym__float_literal] = STATE(2189),
    [sym_string] = STATE(2192),
    [sym__single_quoted_string] = STATE(2188),
    [sym__double_quoted_string] = STATE(2187),
    [sym_na] = STATE(682),
    [sym__expression] = STATE(682),
    [sym__string_or_identifier] = STATE(5139),
    [sym__open_parenthesis] = STATE(57),
    [sym__open_brace] = STATE(59),
    [aux_sym_function_definition_repeat1] = STATE(2336),
    [sym_identifier] = ACTIONS(273),
    [anon_sym_BSLASH] = ACTIONS(275),
    [anon_sym_function] = ACTIONS(277),
    [anon_sym_EQ] = ACTIONS(455),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_for] = ACTIONS(281),
    [anon_sym_while] = ACTIONS(283),
    [anon_sym_repeat] = ACTIONS(285),
    [anon_sym_QMARK] = ACTIONS(287),
    [anon_sym_TILDE] = ACTIONS(289),
    [anon_sym_BANG] = ACTIONS(291),
    [anon_sym_PLUS] = ACTIONS(293),
    [anon_sym_DASH] = ACTIONS(295),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [anon_sym_LT_LT_DASH] = ACTIONS(453),
    [anon_sym_COLON_EQ] = ACTIONS(453),
    [anon_sym_DASH_GT] = ACTIONS(455),
    [anon_sym_DASH_GT_GT] = ACTIONS(453),
    [anon_sym_PIPE] = ACTIONS(455),
    [anon_sym_AMP] = ACTIONS(455),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(455),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_GT] = ACTIONS(455),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(453),
    [anon_sym_STAR] = ACTIONS(455),
    [anon_sym_SLASH] = ACTIONS(453),
    [anon_sym_STAR_STAR] = ACTIONS(453),
    [anon_sym_CARET] = ACTIONS(453),
    [aux_sym_binary_operator_token1] = ACTIONS(453),
    [anon_sym_PIPE_GT] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(455),
    [anon_sym_DOLLAR] = ACTIONS(453),
    [anon_sym_AT] = ACTIONS(453),
    [aux_sym__hex_literal_token1] = ACTIONS(297),
    [sym__number_literal] = ACTIONS(299),
    [anon_sym_SQUOTE] = ACTIONS(301),
    [anon_sym_DQUOTE] = ACTIONS(303),
    [sym_return] = ACTIONS(1652),
    [sym_next] = ACTIONS(1652),
    [sym_break] = ACTIONS(1652),
    [sym_true] = ACTIONS(1652),
    [sym_false] = ACTIONS(1652),
    [sym_null] = ACTIONS(1652),
    [sym_inf] = ACTIONS(1652),
    [sym_nan] = ACTIONS(1652),
    [anon_sym_NA] = ACTIONS(307),
    [anon_sym_NA_integer_] = ACTIONS(307),
    [anon_sym_NA_real_] = ACTIONS(307),
    [anon_sym_NA_complex_] = ACTIONS(307),
    [anon_sym_NA_character_] = ACTIONS(307),
    [sym_dots] = ACTIONS(1652),
    [sym_dot_dot_i] = ACTIONS(1654),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(453),
    [sym__newline] = ACTIONS(453),
    [sym__semicolon] = ACTIONS(453),
    [sym__raw_string_literal] = ACTIONS(313),
    [sym__external_open_parenthesis] = ACTIONS(315),
    [sym__external_close_parenthesis] = ACTIONS(453),
    [sym__external_open_brace] = ACTIONS(319),
    [sym__external_close_brace] = ACTIONS(453),
    [sym__external_open_bracket] = ACTIONS(453),
    [sym__external_close_bracket] = ACTIONS(453),
    [sym__external_open_bracket2] = ACTIONS(453),
  },
  [123] = {
    [sym_function_definition] = STATE(917),
    [sym_if_statement] = STATE(917),
    [sym_for_statement] = STATE(917),
    [sym_while_statement] = STATE(917),
    [sym_repeat_statement] = STATE(917),
    [sym_braced_expression] = STATE(917),
    [sym_parenthesized_expression] = STATE(917),
    [sym_call] = STATE(917),
    [sym_subset] = STATE(917),
    [sym_subset2] = STATE(917),
    [sym_unary_operator] = STATE(917),
    [sym_binary_operator] = STATE(917),
    [sym_extract_operator] = STATE(917),
    [sym_namespace_operator] = STATE(917),
    [sym_integer] = STATE(917),
    [sym_complex] = STATE(917),
    [sym_float] = STATE(917),
    [sym__hex_literal] = STATE(2189),
    [sym__float_literal] = STATE(2189),
    [sym_string] = STATE(2192),
    [sym__single_quoted_string] = STATE(2188),
    [sym__double_quoted_string] = STATE(2187),
    [sym_na] = STATE(917),
    [sym__expression] = STATE(917),
    [sym__string_or_identifier] = STATE(5139),
    [sym__open_parenthesis] = STATE(57),
    [sym__open_brace] = STATE(59),
    [aux_sym_parenthesized_expression_repeat1] = STATE(123),
    [sym_identifier] = ACTIONS(1656),
    [anon_sym_BSLASH] = ACTIONS(1659),
    [anon_sym_function] = ACTIONS(1662),
    [anon_sym_EQ] = ACTIONS(814),
    [anon_sym_if] = ACTIONS(1665),
    [anon_sym_for] = ACTIONS(1668),
    [anon_sym_while] = ACTIONS(1671),
    [anon_sym_repeat] = ACTIONS(1674),
    [anon_sym_QMARK] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(1680),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1686),
    [anon_sym_DASH] = ACTIONS(1689),
    [anon_sym_LT_DASH] = ACTIONS(803),
    [anon_sym_LT_LT_DASH] = ACTIONS(803),
    [anon_sym_COLON_EQ] = ACTIONS(803),
    [anon_sym_DASH_GT] = ACTIONS(814),
    [anon_sym_DASH_GT_GT] = ACTIONS(803),
    [anon_sym_PIPE] = ACTIONS(814),
    [anon_sym_AMP] = ACTIONS(814),
    [anon_sym_PIPE_PIPE] = ACTIONS(803),
    [anon_sym_AMP_AMP] = ACTIONS(803),
    [anon_sym_LT] = ACTIONS(814),
    [anon_sym_LT_EQ] = ACTIONS(803),
    [anon_sym_GT] = ACTIONS(814),
    [anon_sym_GT_EQ] = ACTIONS(803),
    [anon_sym_EQ_EQ] = ACTIONS(803),
    [anon_sym_BANG_EQ] = ACTIONS(803),
    [anon_sym_STAR] = ACTIONS(814),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_STAR_STAR] = ACTIONS(803),
    [anon_sym_CARET] = ACTIONS(803),
    [aux_sym_binary_operator_token1] = ACTIONS(803),
    [anon_sym_PIPE_GT] = ACTIONS(803),
    [anon_sym_COLON] = ACTIONS(814),
    [anon_sym_DOLLAR] = ACTIONS(803),
    [anon_sym_AT] = ACTIONS(803),
    [aux_sym__hex_literal_token1] = ACTIONS(1692),
    [sym__number_literal] = ACTIONS(1695),
    [anon_sym_SQUOTE] = ACTIONS(1698),
    [anon_sym_DQUOTE] = ACTIONS(1701),
    [sym_return] = ACTIONS(1704),
    [sym_next] = ACTIONS(1704),
    [sym_break] = ACTIONS(1704),
    [sym_true] = ACTIONS(1704),
    [sym_false] = ACTIONS(1704),
    [sym_null] = ACTIONS(1704),
    [sym_inf] = ACTIONS(1704),
    [sym_nan] = ACTIONS(1704),
    [anon_sym_NA] = ACTIONS(1707),
    [anon_sym_NA_integer_] = ACTIONS(1707),
    [anon_sym_NA_real_] = ACTIONS(1707),
    [anon_sym_NA_complex_] = ACTIONS(1707),
    [anon_sym_NA_character_] = ACTIONS(1707),
    [sym_dots] = ACTIONS(1704),
    [sym_dot_dot_i] = ACTIONS(1710),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(803),
    [sym__newline] = ACTIONS(1713),
    [sym__semicolon] = ACTIONS(803),
    [sym__raw_string_literal] = ACTIONS(1716),
    [sym__external_open_parenthesis] = ACTIONS(1719),
    [sym__external_close_parenthesis] = ACTIONS(803),
    [sym__external_open_brace] = ACTIONS(1722),
    [sym__external_close_brace] = ACTIONS(803),
    [sym__external_open_bracket] = ACTIONS(803),
    [sym__external_close_bracket] = ACTIONS(803),
    [sym__external_open_bracket2] = ACTIONS(803),
  },
  [124] = {
    [sym_function_definition] = STATE(921),
    [sym_if_statement] = STATE(921),
    [sym_for_statement] = STATE(921),
    [sym_while_statement] = STATE(921),
    [sym_repeat_statement] = STATE(921),
    [sym_braced_expression] = STATE(921),
    [sym_parenthesized_expression] = STATE(921),
    [sym_call] = STATE(921),
    [sym_subset] = STATE(921),
    [sym_subset2] = STATE(921),
    [sym_unary_operator] = STATE(921),
    [sym_binary_operator] = STATE(921),
    [sym_extract_operator] = STATE(921),
    [sym_namespace_operator] = STATE(921),
    [sym_integer] = STATE(921),
    [sym_complex] = STATE(921),
    [sym_float] = STATE(921),
    [sym__hex_literal] = STATE(2220),
    [sym__float_literal] = STATE(2220),
    [sym_string] = STATE(2219),
    [sym__single_quoted_string] = STATE(2221),
    [sym__double_quoted_string] = STATE(2222),
    [sym_na] = STATE(921),
    [sym__expression] = STATE(921),
    [sym__string_or_identifier] = STATE(5140),
    [sym__open_parenthesis] = STATE(54),
    [sym__open_brace] = STATE(56),
    [aux_sym_braced_expression_repeat1] = STATE(124),
    [sym_identifier] = ACTIONS(1725),
    [anon_sym_BSLASH] = ACTIONS(1728),
    [anon_sym_function] = ACTIONS(1731),
    [anon_sym_EQ] = ACTIONS(562),
    [anon_sym_if] = ACTIONS(1734),
    [anon_sym_for] = ACTIONS(1737),
    [anon_sym_while] = ACTIONS(1740),
    [anon_sym_repeat] = ACTIONS(1743),
    [anon_sym_QMARK] = ACTIONS(1746),
    [anon_sym_TILDE] = ACTIONS(1749),
    [anon_sym_BANG] = ACTIONS(1752),
    [anon_sym_PLUS] = ACTIONS(1755),
    [anon_sym_DASH] = ACTIONS(1758),
    [anon_sym_LT_DASH] = ACTIONS(591),
    [anon_sym_LT_LT_DASH] = ACTIONS(591),
    [anon_sym_COLON_EQ] = ACTIONS(591),
    [anon_sym_DASH_GT] = ACTIONS(562),
    [anon_sym_DASH_GT_GT] = ACTIONS(591),
    [anon_sym_PIPE] = ACTIONS(562),
    [anon_sym_AMP] = ACTIONS(562),
    [anon_sym_PIPE_PIPE] = ACTIONS(591),
    [anon_sym_AMP_AMP] = ACTIONS(591),
    [anon_sym_LT] = ACTIONS(562),
    [anon_sym_LT_EQ] = ACTIONS(591),
    [anon_sym_GT] = ACTIONS(562),
    [anon_sym_GT_EQ] = ACTIONS(591),
    [anon_sym_EQ_EQ] = ACTIONS(591),
    [anon_sym_BANG_EQ] = ACTIONS(591),
    [anon_sym_STAR] = ACTIONS(562),
    [anon_sym_SLASH] = ACTIONS(591),
    [anon_sym_STAR_STAR] = ACTIONS(591),
    [anon_sym_CARET] = ACTIONS(591),
    [aux_sym_binary_operator_token1] = ACTIONS(591),
    [anon_sym_PIPE_GT] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(562),
    [anon_sym_DOLLAR] = ACTIONS(591),
    [anon_sym_AT] = ACTIONS(591),
    [aux_sym__hex_literal_token1] = ACTIONS(1761),
    [sym__number_literal] = ACTIONS(1764),
    [anon_sym_SQUOTE] = ACTIONS(1767),
    [anon_sym_DQUOTE] = ACTIONS(1770),
    [sym_return] = ACTIONS(1773),
    [sym_next] = ACTIONS(1773),
    [sym_break] = ACTIONS(1773),
    [sym_true] = ACTIONS(1773),
    [sym_false] = ACTIONS(1773),
    [sym_null] = ACTIONS(1773),
    [sym_inf] = ACTIONS(1773),
    [sym_nan] = ACTIONS(1773),
    [anon_sym_NA] = ACTIONS(1776),
    [anon_sym_NA_integer_] = ACTIONS(1776),
    [anon_sym_NA_real_] = ACTIONS(1776),
    [anon_sym_NA_complex_] = ACTIONS(1776),
    [anon_sym_NA_character_] = ACTIONS(1776),
    [sym_dots] = ACTIONS(1773),
    [sym_dot_dot_i] = ACTIONS(1779),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(591),
    [sym__newline] = ACTIONS(1782),
    [sym__semicolon] = ACTIONS(1782),
    [sym__raw_string_literal] = ACTIONS(1785),
    [sym__external_open_parenthesis] = ACTIONS(1788),
    [sym__external_close_parenthesis] = ACTIONS(591),
    [sym__external_open_brace] = ACTIONS(1791),
    [sym__external_close_brace] = ACTIONS(591),
    [sym__external_open_bracket] = ACTIONS(591),
    [sym__external_open_bracket2] = ACTIONS(591),
    [sym__external_close_bracket2] = ACTIONS(591),
  },
  [125] = {
    [sym_function_definition] = STATE(681),
    [sym_if_statement] = STATE(681),
    [sym_for_statement] = STATE(681),
    [sym_while_statement] = STATE(681),
    [sym_repeat_statement] = STATE(681),
    [sym_braced_expression] = STATE(681),
    [sym_parenthesized_expression] = STATE(681),
    [sym_call] = STATE(681),
    [sym_subset] = STATE(681),
    [sym_subset2] = STATE(681),
    [sym_unary_operator] = STATE(681),
    [sym_binary_operator] = STATE(681),
    [sym_extract_operator] = STATE(681),
    [sym_namespace_operator] = STATE(681),
    [sym_integer] = STATE(681),
    [sym_complex] = STATE(681),
    [sym_float] = STATE(681),
    [sym__hex_literal] = STATE(2189),
    [sym__float_literal] = STATE(2189),
    [sym_string] = STATE(2192),
    [sym__single_quoted_string] = STATE(2188),
    [sym__double_quoted_string] = STATE(2187),
    [sym_na] = STATE(681),
    [sym__expression] = STATE(681),
    [sym__string_or_identifier] = STATE(5139),
    [sym__open_parenthesis] = STATE(57),
    [sym__open_brace] = STATE(59),
    [aux_sym_function_definition_repeat1] = STATE(127),
    [sym_identifier] = ACTIONS(273),
    [anon_sym_BSLASH] = ACTIONS(275),
    [anon_sym_function] = ACTIONS(277),
    [anon_sym_EQ] = ACTIONS(463),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_for] = ACTIONS(281),
    [anon_sym_while] = ACTIONS(283),
    [anon_sym_repeat] = ACTIONS(285),
    [anon_sym_QMARK] = ACTIONS(287),
    [anon_sym_TILDE] = ACTIONS(289),
    [anon_sym_BANG] = ACTIONS(291),
    [anon_sym_PLUS] = ACTIONS(293),
    [anon_sym_DASH] = ACTIONS(295),
    [anon_sym_LT_DASH] = ACTIONS(461),
    [anon_sym_LT_LT_DASH] = ACTIONS(461),
    [anon_sym_COLON_EQ] = ACTIONS(461),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_DASH_GT_GT] = ACTIONS(461),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_PIPE_PIPE] = ACTIONS(461),
    [anon_sym_AMP_AMP] = ACTIONS(461),
    [anon_sym_LT] = ACTIONS(463),
    [anon_sym_LT_EQ] = ACTIONS(461),
    [anon_sym_GT] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(461),
    [anon_sym_EQ_EQ] = ACTIONS(461),
    [anon_sym_BANG_EQ] = ACTIONS(461),
    [anon_sym_STAR] = ACTIONS(463),
    [anon_sym_SLASH] = ACTIONS(461),
    [anon_sym_STAR_STAR] = ACTIONS(461),
    [anon_sym_CARET] = ACTIONS(461),
    [aux_sym_binary_operator_token1] = ACTIONS(461),
    [anon_sym_PIPE_GT] = ACTIONS(461),
    [anon_sym_COLON] = ACTIONS(463),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_AT] = ACTIONS(461),
    [aux_sym__hex_literal_token1] = ACTIONS(297),
    [sym__number_literal] = ACTIONS(299),
    [anon_sym_SQUOTE] = ACTIONS(301),
    [anon_sym_DQUOTE] = ACTIONS(303),
    [sym_return] = ACTIONS(1794),
    [sym_next] = ACTIONS(1794),
    [sym_break] = ACTIONS(1794),
    [sym_true] = ACTIONS(1794),
    [sym_false] = ACTIONS(1794),
    [sym_null] = ACTIONS(1794),
    [sym_inf] = ACTIONS(1794),
    [sym_nan] = ACTIONS(1794),
    [anon_sym_NA] = ACTIONS(307),
    [anon_sym_NA_integer_] = ACTIONS(307),
    [anon_sym_NA_real_] = ACTIONS(307),
    [anon_sym_NA_complex_] = ACTIONS(307),
    [anon_sym_NA_character_] = ACTIONS(307),
    [sym_dots] = ACTIONS(1794),
    [sym_dot_dot_i] = ACTIONS(1796),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(461),
    [sym__newline] = ACTIONS(1798),
    [sym__semicolon] = ACTIONS(461),
    [sym__raw_string_literal] = ACTIONS(313),
    [sym__external_open_parenthesis] = ACTIONS(315),
    [sym__external_close_parenthesis] = ACTIONS(461),
    [sym__external_open_brace] = ACTIONS(319),
    [sym__external_close_brace] = ACTIONS(461),
    [sym__external_open_bracket] = ACTIONS(461),
    [sym__external_close_bracket] = ACTIONS(461),
    [sym__external_open_bracket2] = ACTIONS(461),
  },
  [126] = {
    [sym_function_definition] = STATE(791),
    [sym_if_statement] = STATE(791),
    [sym_for_statement] = STATE(791),
    [sym_while_statement] = STATE(791),
    [sym_repeat_statement] = STATE(791),
    [sym_braced_expression] = STATE(791),
    [sym_parenthesized_expression] = STATE(791),
    [sym_call] = STATE(791),
    [sym_subset] = STATE(791),
    [sym_subset2] = STATE(791),
    [sym_unary_operator] = STATE(791),
    [sym_binary_operator] = STATE(791),
    [sym_extract_operator] = STATE(791),
    [sym_namespace_operator] = STATE(791),
    [sym_integer] = STATE(791),
    [sym_complex] = STATE(791),
    [sym_float] = STATE(791),
    [sym__hex_literal] = STATE(2183),
    [sym__float_literal] = STATE(2183),
    [sym_string] = STATE(2169),
    [sym__single_quoted_string] = STATE(2181),
    [sym__double_quoted_string] = STATE(2180),
    [sym_na] = STATE(791),
    [sym__expression] = STATE(791),
    [sym__string_or_identifier] = STATE(5149),
    [sym__open_parenthesis] = STATE(67),
    [sym__close_parenthesis] = STATE(2843),
    [sym__open_brace] = STATE(24),
    [aux_sym_parenthesized_expression_repeat1] = STATE(139),
    [ts_builtin_sym_end] = ACTIONS(211),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_BSLASH] = ACTIONS(323),
    [anon_sym_function] = ACTIONS(325),
    [anon_sym_EQ] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(327),
    [anon_sym_for] = ACTIONS(329),
    [anon_sym_while] = ACTIONS(331),
    [anon_sym_repeat] = ACTIONS(333),
    [anon_sym_QMARK] = ACTIONS(335),
    [anon_sym_TILDE] = ACTIONS(337),
    [anon_sym_BANG] = ACTIONS(339),
    [anon_sym_PLUS] = ACTIONS(341),
    [anon_sym_DASH] = ACTIONS(343),
    [anon_sym_LT_DASH] = ACTIONS(211),
    [anon_sym_LT_LT_DASH] = ACTIONS(211),
    [anon_sym_COLON_EQ] = ACTIONS(211),
    [anon_sym_DASH_GT] = ACTIONS(209),
    [anon_sym_DASH_GT_GT] = ACTIONS(211),
    [anon_sym_PIPE] = ACTIONS(209),
    [anon_sym_AMP] = ACTIONS(209),
    [anon_sym_PIPE_PIPE] = ACTIONS(211),
    [anon_sym_AMP_AMP] = ACTIONS(211),
    [anon_sym_LT] = ACTIONS(209),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_GT] = ACTIONS(209),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [anon_sym_EQ_EQ] = ACTIONS(211),
    [anon_sym_BANG_EQ] = ACTIONS(211),
    [anon_sym_STAR] = ACTIONS(209),
    [anon_sym_SLASH] = ACTIONS(211),
    [anon_sym_STAR_STAR] = ACTIONS(211),
    [anon_sym_CARET] = ACTIONS(211),
    [aux_sym_binary_operator_token1] = ACTIONS(211),
    [anon_sym_PIPE_GT] = ACTIONS(211),
    [anon_sym_COLON] = ACTIONS(209),
    [anon_sym_DOLLAR] = ACTIONS(211),
    [anon_sym_AT] = ACTIONS(211),
    [aux_sym__hex_literal_token1] = ACTIONS(345),
    [sym__number_literal] = ACTIONS(347),
    [anon_sym_SQUOTE] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(351),
    [sym_return] = ACTIONS(971),
    [sym_next] = ACTIONS(971),
    [sym_break] = ACTIONS(971),
    [sym_true] = ACTIONS(971),
    [sym_false] = ACTIONS(971),
    [sym_null] = ACTIONS(971),
    [sym_inf] = ACTIONS(971),
    [sym_nan] = ACTIONS(971),
    [anon_sym_NA] = ACTIONS(355),
    [anon_sym_NA_integer_] = ACTIONS(355),
    [anon_sym_NA_real_] = ACTIONS(355),
    [anon_sym_NA_complex_] = ACTIONS(355),
    [anon_sym_NA_character_] = ACTIONS(355),
    [sym_dots] = ACTIONS(971),
    [sym_dot_dot_i] = ACTIONS(973),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(975),
    [sym__semicolon] = ACTIONS(211),
    [sym__raw_string_literal] = ACTIONS(361),
    [sym__external_open_parenthesis] = ACTIONS(363),
    [sym__external_close_parenthesis] = ACTIONS(1800),
    [sym__external_open_brace] = ACTIONS(365),
    [sym__external_close_brace] = ACTIONS(211),
    [sym__external_open_bracket] = ACTIONS(211),
    [sym__external_open_bracket2] = ACTIONS(211),
  },
  [127] = {
    [sym_function_definition] = STATE(679),
    [sym_if_statement] = STATE(679),
    [sym_for_statement] = STATE(679),
    [sym_while_statement] = STATE(679),
    [sym_repeat_statement] = STATE(679),
    [sym_braced_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(679),
    [sym_call] = STATE(679),
    [sym_subset] = STATE(679),
    [sym_subset2] = STATE(679),
    [sym_unary_operator] = STATE(679),
    [sym_binary_operator] = STATE(679),
    [sym_extract_operator] = STATE(679),
    [sym_namespace_operator] = STATE(679),
    [sym_integer] = STATE(679),
    [sym_complex] = STATE(679),
    [sym_float] = STATE(679),
    [sym__hex_literal] = STATE(2189),
    [sym__float_literal] = STATE(2189),
    [sym_string] = STATE(2192),
    [sym__single_quoted_string] = STATE(2188),
    [sym__double_quoted_string] = STATE(2187),
    [sym_na] = STATE(679),
    [sym__expression] = STATE(679),
    [sym__string_or_identifier] = STATE(5139),
    [sym__open_parenthesis] = STATE(57),
    [sym__open_brace] = STATE(59),
    [aux_sym_function_definition_repeat1] = STATE(2336),
    [sym_identifier] = ACTIONS(273),
    [anon_sym_BSLASH] = ACTIONS(275),
    [anon_sym_function] = ACTIONS(277),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_for] = ACTIONS(281),
    [anon_sym_while] = ACTIONS(283),
    [anon_sym_repeat] = ACTIONS(285),
    [anon_sym_QMARK] = ACTIONS(287),
    [anon_sym_TILDE] = ACTIONS(289),
    [anon_sym_BANG] = ACTIONS(291),
    [anon_sym_PLUS] = ACTIONS(293),
    [anon_sym_DASH] = ACTIONS(295),
    [anon_sym_LT_DASH] = ACTIONS(471),
    [anon_sym_LT_LT_DASH] = ACTIONS(471),
    [anon_sym_COLON_EQ] = ACTIONS(471),
    [anon_sym_DASH_GT] = ACTIONS(473),
    [anon_sym_DASH_GT_GT] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(473),
    [anon_sym_AMP] = ACTIONS(473),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_LT_EQ] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(473),
    [anon_sym_GT_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_STAR] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [aux_sym_binary_operator_token1] = ACTIONS(471),
    [anon_sym_PIPE_GT] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(473),
    [anon_sym_DOLLAR] = ACTIONS(471),
    [anon_sym_AT] = ACTIONS(471),
    [aux_sym__hex_literal_token1] = ACTIONS(297),
    [sym__number_literal] = ACTIONS(299),
    [anon_sym_SQUOTE] = ACTIONS(301),
    [anon_sym_DQUOTE] = ACTIONS(303),
    [sym_return] = ACTIONS(1802),
    [sym_next] = ACTIONS(1802),
    [sym_break] = ACTIONS(1802),
    [sym_true] = ACTIONS(1802),
    [sym_false] = ACTIONS(1802),
    [sym_null] = ACTIONS(1802),
    [sym_inf] = ACTIONS(1802),
    [sym_nan] = ACTIONS(1802),
    [anon_sym_NA] = ACTIONS(307),
    [anon_sym_NA_integer_] = ACTIONS(307),
    [anon_sym_NA_real_] = ACTIONS(307),
    [anon_sym_NA_complex_] = ACTIONS(307),
    [anon_sym_NA_character_] = ACTIONS(307),
    [sym_dots] = ACTIONS(1802),
    [sym_dot_dot_i] = ACTIONS(1804),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(471),
    [sym__newline] = ACTIONS(471),
    [sym__semicolon] = ACTIONS(471),
    [sym__raw_string_literal] = ACTIONS(313),
    [sym__external_open_parenthesis] = ACTIONS(315),
    [sym__external_close_parenthesis] = ACTIONS(471),
    [sym__external_open_brace] = ACTIONS(319),
    [sym__external_close_brace] = ACTIONS(471),
    [sym__external_open_bracket] = ACTIONS(471),
    [sym__external_close_bracket] = ACTIONS(471),
    [sym__external_open_bracket2] = ACTIONS(471),
  },
  [128] = {
    [sym_function_definition] = STATE(678),
    [sym_if_statement] = STATE(678),
    [sym_for_statement] = STATE(678),
    [sym_while_statement] = STATE(678),
    [sym_repeat_statement] = STATE(678),
    [sym_braced_expression] = STATE(678),
    [sym_parenthesized_expression] = STATE(678),
    [sym_call] = STATE(678),
    [sym_subset] = STATE(678),
    [sym_subset2] = STATE(678),
    [sym_unary_operator] = STATE(678),
    [sym_binary_operator] = STATE(678),
    [sym_extract_operator] = STATE(678),
    [sym_namespace_operator] = STATE(678),
    [sym_integer] = STATE(678),
    [sym_complex] = STATE(678),
    [sym_float] = STATE(678),
    [sym__hex_literal] = STATE(2220),
    [sym__float_literal] = STATE(2220),
    [sym_string] = STATE(2219),
    [sym__single_quoted_string] = STATE(2221),
    [sym__double_quoted_string] = STATE(2222),
    [sym_na] = STATE(678),
    [sym__expression] = STATE(678),
    [sym__string_or_identifier] = STATE(5140),
    [sym__open_parenthesis] = STATE(54),
    [sym__open_brace] = STATE(56),
    [aux_sym_function_definition_repeat1] = STATE(130),
    [sym_identifier] = ACTIONS(626),
    [anon_sym_BSLASH] = ACTIONS(628),
    [anon_sym_function] = ACTIONS(630),
    [anon_sym_EQ] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [anon_sym_repeat] = ACTIONS(638),
    [anon_sym_QMARK] = ACTIONS(640),
    [anon_sym_TILDE] = ACTIONS(642),
    [anon_sym_BANG] = ACTIONS(644),
    [anon_sym_PLUS] = ACTIONS(646),
    [anon_sym_DASH] = ACTIONS(648),
    [anon_sym_LT_DASH] = ACTIONS(263),
    [anon_sym_LT_LT_DASH] = ACTIONS(263),
    [anon_sym_COLON_EQ] = ACTIONS(263),
    [anon_sym_DASH_GT] = ACTIONS(265),
    [anon_sym_DASH_GT_GT] = ACTIONS(263),
    [anon_sym_PIPE] = ACTIONS(265),
    [anon_sym_AMP] = ACTIONS(265),
    [anon_sym_PIPE_PIPE] = ACTIONS(263),
    [anon_sym_AMP_AMP] = ACTIONS(263),
    [anon_sym_LT] = ACTIONS(265),
    [anon_sym_LT_EQ] = ACTIONS(263),
    [anon_sym_GT] = ACTIONS(265),
    [anon_sym_GT_EQ] = ACTIONS(263),
    [anon_sym_EQ_EQ] = ACTIONS(263),
    [anon_sym_BANG_EQ] = ACTIONS(263),
    [anon_sym_STAR] = ACTIONS(265),
    [anon_sym_SLASH] = ACTIONS(263),
    [anon_sym_STAR_STAR] = ACTIONS(263),
    [anon_sym_CARET] = ACTIONS(263),
    [aux_sym_binary_operator_token1] = ACTIONS(263),
    [anon_sym_PIPE_GT] = ACTIONS(263),
    [anon_sym_COLON] = ACTIONS(265),
    [anon_sym_DOLLAR] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(263),
    [aux_sym__hex_literal_token1] = ACTIONS(650),
    [sym__number_literal] = ACTIONS(652),
    [anon_sym_SQUOTE] = ACTIONS(654),
    [anon_sym_DQUOTE] = ACTIONS(656),
    [sym_return] = ACTIONS(1806),
    [sym_next] = ACTIONS(1806),
    [sym_break] = ACTIONS(1806),
    [sym_true] = ACTIONS(1806),
    [sym_false] = ACTIONS(1806),
    [sym_null] = ACTIONS(1806),
    [sym_inf] = ACTIONS(1806),
    [sym_nan] = ACTIONS(1806),
    [anon_sym_NA] = ACTIONS(660),
    [anon_sym_NA_integer_] = ACTIONS(660),
    [anon_sym_NA_real_] = ACTIONS(660),
    [anon_sym_NA_complex_] = ACTIONS(660),
    [anon_sym_NA_character_] = ACTIONS(660),
    [sym_dots] = ACTIONS(1806),
    [sym_dot_dot_i] = ACTIONS(1808),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(263),
    [sym__newline] = ACTIONS(1810),
    [sym__semicolon] = ACTIONS(263),
    [sym__raw_string_literal] = ACTIONS(666),
    [sym__external_open_parenthesis] = ACTIONS(668),
    [sym__external_close_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(670),
    [sym__external_close_brace] = ACTIONS(263),
    [sym__external_open_bracket] = ACTIONS(263),
    [sym__external_open_bracket2] = ACTIONS(263),
    [sym__external_close_bracket2] = ACTIONS(263),
  },
  [129] = {
    [sym_function_definition] = STATE(688),
    [sym_if_statement] = STATE(688),
    [sym_for_statement] = STATE(688),
    [sym_while_statement] = STATE(688),
    [sym_repeat_statement] = STATE(688),
    [sym_braced_expression] = STATE(688),
    [sym_parenthesized_expression] = STATE(688),
    [sym_call] = STATE(688),
    [sym_subset] = STATE(688),
    [sym_subset2] = STATE(688),
    [sym_unary_operator] = STATE(688),
    [sym_binary_operator] = STATE(688),
    [sym_extract_operator] = STATE(688),
    [sym_namespace_operator] = STATE(688),
    [sym_integer] = STATE(688),
    [sym_complex] = STATE(688),
    [sym_float] = STATE(688),
    [sym__hex_literal] = STATE(2220),
    [sym__float_literal] = STATE(2220),
    [sym_string] = STATE(2219),
    [sym__single_quoted_string] = STATE(2221),
    [sym__double_quoted_string] = STATE(2222),
    [sym_na] = STATE(688),
    [sym__expression] = STATE(688),
    [sym__string_or_identifier] = STATE(5140),
    [sym__open_parenthesis] = STATE(54),
    [sym__open_brace] = STATE(56),
    [aux_sym_function_definition_repeat1] = STATE(131),
    [sym_identifier] = ACTIONS(626),
    [anon_sym_BSLASH] = ACTIONS(628),
    [anon_sym_function] = ACTIONS(630),
    [anon_sym_EQ] = ACTIONS(543),
    [anon_sym_if] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [anon_sym_repeat] = ACTIONS(638),
    [anon_sym_QMARK] = ACTIONS(640),
    [anon_sym_TILDE] = ACTIONS(642),
    [anon_sym_BANG] = ACTIONS(644),
    [anon_sym_PLUS] = ACTIONS(646),
    [anon_sym_DASH] = ACTIONS(648),
    [anon_sym_LT_DASH] = ACTIONS(545),
    [anon_sym_LT_LT_DASH] = ACTIONS(545),
    [anon_sym_COLON_EQ] = ACTIONS(545),
    [anon_sym_DASH_GT] = ACTIONS(543),
    [anon_sym_DASH_GT_GT] = ACTIONS(545),
    [anon_sym_PIPE] = ACTIONS(543),
    [anon_sym_AMP] = ACTIONS(543),
    [anon_sym_PIPE_PIPE] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(543),
    [anon_sym_LT_EQ] = ACTIONS(545),
    [anon_sym_GT] = ACTIONS(543),
    [anon_sym_GT_EQ] = ACTIONS(545),
    [anon_sym_EQ_EQ] = ACTIONS(545),
    [anon_sym_BANG_EQ] = ACTIONS(545),
    [anon_sym_STAR] = ACTIONS(543),
    [anon_sym_SLASH] = ACTIONS(545),
    [anon_sym_STAR_STAR] = ACTIONS(545),
    [anon_sym_CARET] = ACTIONS(545),
    [aux_sym_binary_operator_token1] = ACTIONS(545),
    [anon_sym_PIPE_GT] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(543),
    [anon_sym_DOLLAR] = ACTIONS(545),
    [anon_sym_AT] = ACTIONS(545),
    [aux_sym__hex_literal_token1] = ACTIONS(650),
    [sym__number_literal] = ACTIONS(652),
    [anon_sym_SQUOTE] = ACTIONS(654),
    [anon_sym_DQUOTE] = ACTIONS(656),
    [sym_return] = ACTIONS(1812),
    [sym_next] = ACTIONS(1812),
    [sym_break] = ACTIONS(1812),
    [sym_true] = ACTIONS(1812),
    [sym_false] = ACTIONS(1812),
    [sym_null] = ACTIONS(1812),
    [sym_inf] = ACTIONS(1812),
    [sym_nan] = ACTIONS(1812),
    [anon_sym_NA] = ACTIONS(660),
    [anon_sym_NA_integer_] = ACTIONS(660),
    [anon_sym_NA_real_] = ACTIONS(660),
    [anon_sym_NA_complex_] = ACTIONS(660),
    [anon_sym_NA_character_] = ACTIONS(660),
    [sym_dots] = ACTIONS(1812),
    [sym_dot_dot_i] = ACTIONS(1814),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(545),
    [sym__newline] = ACTIONS(1816),
    [sym__semicolon] = ACTIONS(545),
    [sym__raw_string_literal] = ACTIONS(666),
    [sym__external_open_parenthesis] = ACTIONS(668),
    [sym__external_close_parenthesis] = ACTIONS(545),
    [sym__external_open_brace] = ACTIONS(670),
    [sym__external_close_brace] = ACTIONS(545),
    [sym__external_open_bracket] = ACTIONS(545),
    [sym__external_open_bracket2] = ACTIONS(545),
    [sym__external_close_bracket2] = ACTIONS(545),
  },
  [130] = {
    [sym_function_definition] = STATE(691),
    [sym_if_statement] = STATE(691),
    [sym_for_statement] = STATE(691),
    [sym_while_statement] = STATE(691),
    [sym_repeat_statement] = STATE(691),
    [sym_braced_expression] = STATE(691),
    [sym_parenthesized_expression] = STATE(691),
    [sym_call] = STATE(691),
    [sym_subset] = STATE(691),
    [sym_subset2] = STATE(691),
    [sym_unary_operator] = STATE(691),
    [sym_binary_operator] = STATE(691),
    [sym_extract_operator] = STATE(691),
    [sym_namespace_operator] = STATE(691),
    [sym_integer] = STATE(691),
    [sym_complex] = STATE(691),
    [sym_float] = STATE(691),
    [sym__hex_literal] = STATE(2220),
    [sym__float_literal] = STATE(2220),
    [sym_string] = STATE(2219),
    [sym__single_quoted_string] = STATE(2221),
    [sym__double_quoted_string] = STATE(2222),
    [sym_na] = STATE(691),
    [sym__expression] = STATE(691),
    [sym__string_or_identifier] = STATE(5140),
    [sym__open_parenthesis] = STATE(54),
    [sym__open_brace] = STATE(56),
    [aux_sym_function_definition_repeat1] = STATE(2303),
    [sym_identifier] = ACTIONS(626),
    [anon_sym_BSLASH] = ACTIONS(628),
    [anon_sym_function] = ACTIONS(630),
    [anon_sym_EQ] = ACTIONS(767),
    [anon_sym_if] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [anon_sym_repeat] = ACTIONS(638),
    [anon_sym_QMARK] = ACTIONS(640),
    [anon_sym_TILDE] = ACTIONS(642),
    [anon_sym_BANG] = ACTIONS(644),
    [anon_sym_PLUS] = ACTIONS(646),
    [anon_sym_DASH] = ACTIONS(648),
    [anon_sym_LT_DASH] = ACTIONS(765),
    [anon_sym_LT_LT_DASH] = ACTIONS(765),
    [anon_sym_COLON_EQ] = ACTIONS(765),
    [anon_sym_DASH_GT] = ACTIONS(767),
    [anon_sym_DASH_GT_GT] = ACTIONS(765),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_AMP] = ACTIONS(767),
    [anon_sym_PIPE_PIPE] = ACTIONS(765),
    [anon_sym_AMP_AMP] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(767),
    [anon_sym_LT_EQ] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_GT_EQ] = ACTIONS(765),
    [anon_sym_EQ_EQ] = ACTIONS(765),
    [anon_sym_BANG_EQ] = ACTIONS(765),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(765),
    [anon_sym_STAR_STAR] = ACTIONS(765),
    [anon_sym_CARET] = ACTIONS(765),
    [aux_sym_binary_operator_token1] = ACTIONS(765),
    [anon_sym_PIPE_GT] = ACTIONS(765),
    [anon_sym_COLON] = ACTIONS(767),
    [anon_sym_DOLLAR] = ACTIONS(765),
    [anon_sym_AT] = ACTIONS(765),
    [aux_sym__hex_literal_token1] = ACTIONS(650),
    [sym__number_literal] = ACTIONS(652),
    [anon_sym_SQUOTE] = ACTIONS(654),
    [anon_sym_DQUOTE] = ACTIONS(656),
    [sym_return] = ACTIONS(1818),
    [sym_next] = ACTIONS(1818),
    [sym_break] = ACTIONS(1818),
    [sym_true] = ACTIONS(1818),
    [sym_false] = ACTIONS(1818),
    [sym_null] = ACTIONS(1818),
    [sym_inf] = ACTIONS(1818),
    [sym_nan] = ACTIONS(1818),
    [anon_sym_NA] = ACTIONS(660),
    [anon_sym_NA_integer_] = ACTIONS(660),
    [anon_sym_NA_real_] = ACTIONS(660),
    [anon_sym_NA_complex_] = ACTIONS(660),
    [anon_sym_NA_character_] = ACTIONS(660),
    [sym_dots] = ACTIONS(1818),
    [sym_dot_dot_i] = ACTIONS(1820),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(765),
    [sym__newline] = ACTIONS(765),
    [sym__semicolon] = ACTIONS(765),
    [sym__raw_string_literal] = ACTIONS(666),
    [sym__external_open_parenthesis] = ACTIONS(668),
    [sym__external_close_parenthesis] = ACTIONS(765),
    [sym__external_open_brace] = ACTIONS(670),
    [sym__external_close_brace] = ACTIONS(765),
    [sym__external_open_bracket] = ACTIONS(765),
    [sym__external_open_bracket2] = ACTIONS(765),
    [sym__external_close_bracket2] = ACTIONS(765),
  },
  [131] = {
    [sym_function_definition] = STATE(729),
    [sym_if_statement] = STATE(729),
    [sym_for_statement] = STATE(729),
    [sym_while_statement] = STATE(729),
    [sym_repeat_statement] = STATE(729),
    [sym_braced_expression] = STATE(729),
    [sym_parenthesized_expression] = STATE(729),
    [sym_call] = STATE(729),
    [sym_subset] = STATE(729),
    [sym_subset2] = STATE(729),
    [sym_unary_operator] = STATE(729),
    [sym_binary_operator] = STATE(729),
    [sym_extract_operator] = STATE(729),
    [sym_namespace_operator] = STATE(729),
    [sym_integer] = STATE(729),
    [sym_complex] = STATE(729),
    [sym_float] = STATE(729),
    [sym__hex_literal] = STATE(2220),
    [sym__float_literal] = STATE(2220),
    [sym_string] = STATE(2219),
    [sym__single_quoted_string] = STATE(2221),
    [sym__double_quoted_string] = STATE(2222),
    [sym_na] = STATE(729),
    [sym__expression] = STATE(729),
    [sym__string_or_identifier] = STATE(5140),
    [sym__open_parenthesis] = STATE(54),
    [sym__open_brace] = STATE(56),
    [aux_sym_function_definition_repeat1] = STATE(2303),
    [sym_identifier] = ACTIONS(626),
    [anon_sym_BSLASH] = ACTIONS(628),
    [anon_sym_function] = ACTIONS(630),
    [anon_sym_EQ] = ACTIONS(759),
    [anon_sym_if] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [anon_sym_repeat] = ACTIONS(638),
    [anon_sym_QMARK] = ACTIONS(640),
    [anon_sym_TILDE] = ACTIONS(642),
    [anon_sym_BANG] = ACTIONS(644),
    [anon_sym_PLUS] = ACTIONS(646),
    [anon_sym_DASH] = ACTIONS(648),
    [anon_sym_LT_DASH] = ACTIONS(757),
    [anon_sym_LT_LT_DASH] = ACTIONS(757),
    [anon_sym_COLON_EQ] = ACTIONS(757),
    [anon_sym_DASH_GT] = ACTIONS(759),
    [anon_sym_DASH_GT_GT] = ACTIONS(757),
    [anon_sym_PIPE] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(759),
    [anon_sym_PIPE_PIPE] = ACTIONS(757),
    [anon_sym_AMP_AMP] = ACTIONS(757),
    [anon_sym_LT] = ACTIONS(759),
    [anon_sym_LT_EQ] = ACTIONS(757),
    [anon_sym_GT] = ACTIONS(759),
    [anon_sym_GT_EQ] = ACTIONS(757),
    [anon_sym_EQ_EQ] = ACTIONS(757),
    [anon_sym_BANG_EQ] = ACTIONS(757),
    [anon_sym_STAR] = ACTIONS(759),
    [anon_sym_SLASH] = ACTIONS(757),
    [anon_sym_STAR_STAR] = ACTIONS(757),
    [anon_sym_CARET] = ACTIONS(757),
    [aux_sym_binary_operator_token1] = ACTIONS(757),
    [anon_sym_PIPE_GT] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(759),
    [anon_sym_DOLLAR] = ACTIONS(757),
    [anon_sym_AT] = ACTIONS(757),
    [aux_sym__hex_literal_token1] = ACTIONS(650),
    [sym__number_literal] = ACTIONS(652),
    [anon_sym_SQUOTE] = ACTIONS(654),
    [anon_sym_DQUOTE] = ACTIONS(656),
    [sym_return] = ACTIONS(1822),
    [sym_next] = ACTIONS(1822),
    [sym_break] = ACTIONS(1822),
    [sym_true] = ACTIONS(1822),
    [sym_false] = ACTIONS(1822),
    [sym_null] = ACTIONS(1822),
    [sym_inf] = ACTIONS(1822),
    [sym_nan] = ACTIONS(1822),
    [anon_sym_NA] = ACTIONS(660),
    [anon_sym_NA_integer_] = ACTIONS(660),
    [anon_sym_NA_real_] = ACTIONS(660),
    [anon_sym_NA_complex_] = ACTIONS(660),
    [anon_sym_NA_character_] = ACTIONS(660),
    [sym_dots] = ACTIONS(1822),
    [sym_dot_dot_i] = ACTIONS(1824),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(757),
    [sym__newline] = ACTIONS(757),
    [sym__semicolon] = ACTIONS(757),
    [sym__raw_string_literal] = ACTIONS(666),
    [sym__external_open_parenthesis] = ACTIONS(668),
    [sym__external_close_parenthesis] = ACTIONS(757),
    [sym__external_open_brace] = ACTIONS(670),
    [sym__external_close_brace] = ACTIONS(757),
    [sym__external_open_bracket] = ACTIONS(757),
    [sym__external_open_bracket2] = ACTIONS(757),
    [sym__external_close_bracket2] = ACTIONS(757),
  },
  [132] = {
    [sym_function_definition] = STATE(757),
    [sym_if_statement] = STATE(757),
    [sym_for_statement] = STATE(757),
    [sym_while_statement] = STATE(757),
    [sym_repeat_statement] = STATE(757),
    [sym_braced_expression] = STATE(757),
    [sym_parenthesized_expression] = STATE(757),
    [sym_call] = STATE(757),
    [sym_subset] = STATE(757),
    [sym_subset2] = STATE(757),
    [sym_unary_operator] = STATE(757),
    [sym_binary_operator] = STATE(757),
    [sym_extract_operator] = STATE(757),
    [sym_namespace_operator] = STATE(757),
    [sym_integer] = STATE(757),
    [sym_complex] = STATE(757),
    [sym_float] = STATE(757),
    [sym__hex_literal] = STATE(2220),
    [sym__float_literal] = STATE(2220),
    [sym_string] = STATE(2219),
    [sym__single_quoted_string] = STATE(2221),
    [sym__double_quoted_string] = STATE(2222),
    [sym_na] = STATE(757),
    [sym__expression] = STATE(757),
    [sym__string_or_identifier] = STATE(5140),
    [sym__open_parenthesis] = STATE(54),
    [sym__open_brace] = STATE(56),
    [aux_sym_function_definition_repeat1] = STATE(134),
    [sym_identifier] = ACTIONS(626),
    [anon_sym_BSLASH] = ACTIONS(628),
    [anon_sym_function] = ACTIONS(630),
    [anon_sym_EQ] = ACTIONS(533),
    [anon_sym_if] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [anon_sym_repeat] = ACTIONS(638),
    [anon_sym_QMARK] = ACTIONS(640),
    [anon_sym_TILDE] = ACTIONS(642),
    [anon_sym_BANG] = ACTIONS(644),
    [anon_sym_PLUS] = ACTIONS(646),
    [anon_sym_DASH] = ACTIONS(648),
    [anon_sym_LT_DASH] = ACTIONS(531),
    [anon_sym_LT_LT_DASH] = ACTIONS(531),
    [anon_sym_COLON_EQ] = ACTIONS(531),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_DASH_GT_GT] = ACTIONS(531),
    [anon_sym_PIPE] = ACTIONS(533),
    [anon_sym_AMP] = ACTIONS(533),
    [anon_sym_PIPE_PIPE] = ACTIONS(531),
    [anon_sym_AMP_AMP] = ACTIONS(531),
    [anon_sym_LT] = ACTIONS(533),
    [anon_sym_LT_EQ] = ACTIONS(531),
    [anon_sym_GT] = ACTIONS(533),
    [anon_sym_GT_EQ] = ACTIONS(531),
    [anon_sym_EQ_EQ] = ACTIONS(531),
    [anon_sym_BANG_EQ] = ACTIONS(531),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_SLASH] = ACTIONS(531),
    [anon_sym_STAR_STAR] = ACTIONS(531),
    [anon_sym_CARET] = ACTIONS(531),
    [aux_sym_binary_operator_token1] = ACTIONS(531),
    [anon_sym_PIPE_GT] = ACTIONS(531),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_DOLLAR] = ACTIONS(531),
    [anon_sym_AT] = ACTIONS(531),
    [aux_sym__hex_literal_token1] = ACTIONS(650),
    [sym__number_literal] = ACTIONS(652),
    [anon_sym_SQUOTE] = ACTIONS(654),
    [anon_sym_DQUOTE] = ACTIONS(656),
    [sym_return] = ACTIONS(1826),
    [sym_next] = ACTIONS(1826),
    [sym_break] = ACTIONS(1826),
    [sym_true] = ACTIONS(1826),
    [sym_false] = ACTIONS(1826),
    [sym_null] = ACTIONS(1826),
    [sym_inf] = ACTIONS(1826),
    [sym_nan] = ACTIONS(1826),
    [anon_sym_NA] = ACTIONS(660),
    [anon_sym_NA_integer_] = ACTIONS(660),
    [anon_sym_NA_real_] = ACTIONS(660),
    [anon_sym_NA_complex_] = ACTIONS(660),
    [anon_sym_NA_character_] = ACTIONS(660),
    [sym_dots] = ACTIONS(1826),
    [sym_dot_dot_i] = ACTIONS(1828),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(531),
    [sym__newline] = ACTIONS(1830),
    [sym__semicolon] = ACTIONS(531),
    [sym__raw_string_literal] = ACTIONS(666),
    [sym__external_open_parenthesis] = ACTIONS(668),
    [sym__external_close_parenthesis] = ACTIONS(531),
    [sym__external_open_brace] = ACTIONS(670),
    [sym__external_close_brace] = ACTIONS(531),
    [sym__external_open_bracket] = ACTIONS(531),
    [sym__external_open_bracket2] = ACTIONS(531),
    [sym__external_close_bracket2] = ACTIONS(531),
  },
  [133] = {
    [sym_function_definition] = STATE(1072),
    [sym_if_statement] = STATE(1072),
    [sym_for_statement] = STATE(1072),
    [sym_while_statement] = STATE(1072),
    [sym_repeat_statement] = STATE(1072),
    [sym_braced_expression] = STATE(1072),
    [sym_parenthesized_expression] = STATE(1072),
    [sym_call] = STATE(1072),
    [sym_subset] = STATE(1072),
    [sym_subset2] = STATE(1072),
    [sym_unary_operator] = STATE(1072),
    [sym_binary_operator] = STATE(1072),
    [sym_extract_operator] = STATE(1072),
    [sym_namespace_operator] = STATE(1072),
    [sym_integer] = STATE(1072),
    [sym_complex] = STATE(1072),
    [sym_float] = STATE(1072),
    [sym__hex_literal] = STATE(2311),
    [sym__float_literal] = STATE(2311),
    [sym_string] = STATE(2312),
    [sym__single_quoted_string] = STATE(2310),
    [sym__double_quoted_string] = STATE(2309),
    [sym_na] = STATE(1072),
    [sym__expression] = STATE(1072),
    [sym__string_or_identifier] = STATE(5134),
    [sym__open_parenthesis] = STATE(64),
    [sym__open_brace] = STATE(199),
    [sym__close_brace] = STATE(2865),
    [aux_sym_braced_expression_repeat1] = STATE(105),
    [ts_builtin_sym_end] = ACTIONS(155),
    [sym_identifier] = ACTIONS(1385),
    [anon_sym_BSLASH] = ACTIONS(1387),
    [anon_sym_function] = ACTIONS(1389),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(1391),
    [anon_sym_for] = ACTIONS(1393),
    [anon_sym_while] = ACTIONS(1395),
    [anon_sym_repeat] = ACTIONS(1397),
    [anon_sym_QMARK] = ACTIONS(1399),
    [anon_sym_TILDE] = ACTIONS(1401),
    [anon_sym_BANG] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1407),
    [anon_sym_LT_DASH] = ACTIONS(155),
    [anon_sym_LT_LT_DASH] = ACTIONS(155),
    [anon_sym_COLON_EQ] = ACTIONS(155),
    [anon_sym_DASH_GT] = ACTIONS(157),
    [anon_sym_DASH_GT_GT] = ACTIONS(155),
    [anon_sym_PIPE] = ACTIONS(157),
    [anon_sym_AMP] = ACTIONS(157),
    [anon_sym_PIPE_PIPE] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(157),
    [anon_sym_LT_EQ] = ACTIONS(155),
    [anon_sym_GT] = ACTIONS(157),
    [anon_sym_GT_EQ] = ACTIONS(155),
    [anon_sym_EQ_EQ] = ACTIONS(155),
    [anon_sym_BANG_EQ] = ACTIONS(155),
    [anon_sym_STAR] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(155),
    [anon_sym_STAR_STAR] = ACTIONS(155),
    [anon_sym_CARET] = ACTIONS(155),
    [aux_sym_binary_operator_token1] = ACTIONS(155),
    [anon_sym_PIPE_GT] = ACTIONS(155),
    [anon_sym_COLON] = ACTIONS(157),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(155),
    [aux_sym__hex_literal_token1] = ACTIONS(1409),
    [sym__number_literal] = ACTIONS(1411),
    [anon_sym_SQUOTE] = ACTIONS(1413),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [sym_return] = ACTIONS(1417),
    [sym_next] = ACTIONS(1417),
    [sym_break] = ACTIONS(1417),
    [sym_true] = ACTIONS(1417),
    [sym_false] = ACTIONS(1417),
    [sym_null] = ACTIONS(1417),
    [sym_inf] = ACTIONS(1417),
    [sym_nan] = ACTIONS(1417),
    [anon_sym_NA] = ACTIONS(1419),
    [anon_sym_NA_integer_] = ACTIONS(1419),
    [anon_sym_NA_real_] = ACTIONS(1419),
    [anon_sym_NA_complex_] = ACTIONS(1419),
    [anon_sym_NA_character_] = ACTIONS(1419),
    [sym_dots] = ACTIONS(1417),
    [sym_dot_dot_i] = ACTIONS(1421),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1423),
    [sym__semicolon] = ACTIONS(1423),
    [sym__raw_string_literal] = ACTIONS(1425),
    [sym__external_else] = ACTIONS(155),
    [sym__external_open_parenthesis] = ACTIONS(1427),
    [sym__external_open_brace] = ACTIONS(1429),
    [sym__external_close_brace] = ACTIONS(1832),
    [sym__external_open_bracket] = ACTIONS(155),
    [sym__external_open_bracket2] = ACTIONS(155),
  },
  [134] = {
    [sym_function_definition] = STATE(758),
    [sym_if_statement] = STATE(758),
    [sym_for_statement] = STATE(758),
    [sym_while_statement] = STATE(758),
    [sym_repeat_statement] = STATE(758),
    [sym_braced_expression] = STATE(758),
    [sym_parenthesized_expression] = STATE(758),
    [sym_call] = STATE(758),
    [sym_subset] = STATE(758),
    [sym_subset2] = STATE(758),
    [sym_unary_operator] = STATE(758),
    [sym_binary_operator] = STATE(758),
    [sym_extract_operator] = STATE(758),
    [sym_namespace_operator] = STATE(758),
    [sym_integer] = STATE(758),
    [sym_complex] = STATE(758),
    [sym_float] = STATE(758),
    [sym__hex_literal] = STATE(2220),
    [sym__float_literal] = STATE(2220),
    [sym_string] = STATE(2219),
    [sym__single_quoted_string] = STATE(2221),
    [sym__double_quoted_string] = STATE(2222),
    [sym_na] = STATE(758),
    [sym__expression] = STATE(758),
    [sym__string_or_identifier] = STATE(5140),
    [sym__open_parenthesis] = STATE(54),
    [sym__open_brace] = STATE(56),
    [aux_sym_function_definition_repeat1] = STATE(2303),
    [sym_identifier] = ACTIONS(626),
    [anon_sym_BSLASH] = ACTIONS(628),
    [anon_sym_function] = ACTIONS(630),
    [anon_sym_EQ] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [anon_sym_repeat] = ACTIONS(638),
    [anon_sym_QMARK] = ACTIONS(640),
    [anon_sym_TILDE] = ACTIONS(642),
    [anon_sym_BANG] = ACTIONS(644),
    [anon_sym_PLUS] = ACTIONS(646),
    [anon_sym_DASH] = ACTIONS(648),
    [anon_sym_LT_DASH] = ACTIONS(369),
    [anon_sym_LT_LT_DASH] = ACTIONS(369),
    [anon_sym_COLON_EQ] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(371),
    [anon_sym_DASH_GT_GT] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(371),
    [anon_sym_AMP] = ACTIONS(371),
    [anon_sym_PIPE_PIPE] = ACTIONS(369),
    [anon_sym_AMP_AMP] = ACTIONS(369),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_LT_EQ] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_EQ] = ACTIONS(369),
    [anon_sym_EQ_EQ] = ACTIONS(369),
    [anon_sym_BANG_EQ] = ACTIONS(369),
    [anon_sym_STAR] = ACTIONS(371),
    [anon_sym_SLASH] = ACTIONS(369),
    [anon_sym_STAR_STAR] = ACTIONS(369),
    [anon_sym_CARET] = ACTIONS(369),
    [aux_sym_binary_operator_token1] = ACTIONS(369),
    [anon_sym_PIPE_GT] = ACTIONS(369),
    [anon_sym_COLON] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(369),
    [anon_sym_AT] = ACTIONS(369),
    [aux_sym__hex_literal_token1] = ACTIONS(650),
    [sym__number_literal] = ACTIONS(652),
    [anon_sym_SQUOTE] = ACTIONS(654),
    [anon_sym_DQUOTE] = ACTIONS(656),
    [sym_return] = ACTIONS(1834),
    [sym_next] = ACTIONS(1834),
    [sym_break] = ACTIONS(1834),
    [sym_true] = ACTIONS(1834),
    [sym_false] = ACTIONS(1834),
    [sym_null] = ACTIONS(1834),
    [sym_inf] = ACTIONS(1834),
    [sym_nan] = ACTIONS(1834),
    [anon_sym_NA] = ACTIONS(660),
    [anon_sym_NA_integer_] = ACTIONS(660),
    [anon_sym_NA_real_] = ACTIONS(660),
    [anon_sym_NA_complex_] = ACTIONS(660),
    [anon_sym_NA_character_] = ACTIONS(660),
    [sym_dots] = ACTIONS(1834),
    [sym_dot_dot_i] = ACTIONS(1836),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(369),
    [sym__newline] = ACTIONS(369),
    [sym__semicolon] = ACTIONS(369),
    [sym__raw_string_literal] = ACTIONS(666),
    [sym__external_open_parenthesis] = ACTIONS(668),
    [sym__external_close_parenthesis] = ACTIONS(369),
    [sym__external_open_brace] = ACTIONS(670),
    [sym__external_close_brace] = ACTIONS(369),
    [sym__external_open_bracket] = ACTIONS(369),
    [sym__external_open_bracket2] = ACTIONS(369),
    [sym__external_close_bracket2] = ACTIONS(369),
  },
  [135] = {
    [sym_function_definition] = STATE(759),
    [sym_if_statement] = STATE(759),
    [sym_for_statement] = STATE(759),
    [sym_while_statement] = STATE(759),
    [sym_repeat_statement] = STATE(759),
    [sym_braced_expression] = STATE(759),
    [sym_parenthesized_expression] = STATE(759),
    [sym_call] = STATE(759),
    [sym_subset] = STATE(759),
    [sym_subset2] = STATE(759),
    [sym_unary_operator] = STATE(759),
    [sym_binary_operator] = STATE(759),
    [sym_extract_operator] = STATE(759),
    [sym_namespace_operator] = STATE(759),
    [sym_integer] = STATE(759),
    [sym_complex] = STATE(759),
    [sym_float] = STATE(759),
    [sym__hex_literal] = STATE(2220),
    [sym__float_literal] = STATE(2220),
    [sym_string] = STATE(2219),
    [sym__single_quoted_string] = STATE(2221),
    [sym__double_quoted_string] = STATE(2222),
    [sym_na] = STATE(759),
    [sym__expression] = STATE(759),
    [sym__string_or_identifier] = STATE(5140),
    [sym__open_parenthesis] = STATE(54),
    [sym__open_brace] = STATE(56),
    [aux_sym_function_definition_repeat1] = STATE(140),
    [sym_identifier] = ACTIONS(626),
    [anon_sym_BSLASH] = ACTIONS(628),
    [anon_sym_function] = ACTIONS(630),
    [anon_sym_EQ] = ACTIONS(379),
    [anon_sym_if] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [anon_sym_repeat] = ACTIONS(638),
    [anon_sym_QMARK] = ACTIONS(640),
    [anon_sym_TILDE] = ACTIONS(642),
    [anon_sym_BANG] = ACTIONS(644),
    [anon_sym_PLUS] = ACTIONS(646),
    [anon_sym_DASH] = ACTIONS(648),
    [anon_sym_LT_DASH] = ACTIONS(377),
    [anon_sym_LT_LT_DASH] = ACTIONS(377),
    [anon_sym_COLON_EQ] = ACTIONS(377),
    [anon_sym_DASH_GT] = ACTIONS(379),
    [anon_sym_DASH_GT_GT] = ACTIONS(377),
    [anon_sym_PIPE] = ACTIONS(379),
    [anon_sym_AMP] = ACTIONS(379),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_LT] = ACTIONS(379),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(379),
    [anon_sym_GT_EQ] = ACTIONS(377),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(379),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_STAR_STAR] = ACTIONS(377),
    [anon_sym_CARET] = ACTIONS(377),
    [aux_sym_binary_operator_token1] = ACTIONS(377),
    [anon_sym_PIPE_GT] = ACTIONS(377),
    [anon_sym_COLON] = ACTIONS(379),
    [anon_sym_DOLLAR] = ACTIONS(377),
    [anon_sym_AT] = ACTIONS(377),
    [aux_sym__hex_literal_token1] = ACTIONS(650),
    [sym__number_literal] = ACTIONS(652),
    [anon_sym_SQUOTE] = ACTIONS(654),
    [anon_sym_DQUOTE] = ACTIONS(656),
    [sym_return] = ACTIONS(1838),
    [sym_next] = ACTIONS(1838),
    [sym_break] = ACTIONS(1838),
    [sym_true] = ACTIONS(1838),
    [sym_false] = ACTIONS(1838),
    [sym_null] = ACTIONS(1838),
    [sym_inf] = ACTIONS(1838),
    [sym_nan] = ACTIONS(1838),
    [anon_sym_NA] = ACTIONS(660),
    [anon_sym_NA_integer_] = ACTIONS(660),
    [anon_sym_NA_real_] = ACTIONS(660),
    [anon_sym_NA_complex_] = ACTIONS(660),
    [anon_sym_NA_character_] = ACTIONS(660),
    [sym_dots] = ACTIONS(1838),
    [sym_dot_dot_i] = ACTIONS(1840),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(377),
    [sym__newline] = ACTIONS(1842),
    [sym__semicolon] = ACTIONS(377),
    [sym__raw_string_literal] = ACTIONS(666),
    [sym__external_open_parenthesis] = ACTIONS(668),
    [sym__external_close_parenthesis] = ACTIONS(377),
    [sym__external_open_brace] = ACTIONS(670),
    [sym__external_close_brace] = ACTIONS(377),
    [sym__external_open_bracket] = ACTIONS(377),
    [sym__external_open_bracket2] = ACTIONS(377),
    [sym__external_close_bracket2] = ACTIONS(377),
  },
  [136] = {
    [sym_function_definition] = STATE(1152),
    [sym_if_statement] = STATE(1152),
    [sym_for_statement] = STATE(1152),
    [sym_while_statement] = STATE(1152),
    [sym_repeat_statement] = STATE(1152),
    [sym_braced_expression] = STATE(1152),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_call] = STATE(1152),
    [sym_subset] = STATE(1152),
    [sym_subset2] = STATE(1152),
    [sym_unary_operator] = STATE(1152),
    [sym_binary_operator] = STATE(1152),
    [sym_extract_operator] = STATE(1152),
    [sym_namespace_operator] = STATE(1152),
    [sym_integer] = STATE(1152),
    [sym_complex] = STATE(1152),
    [sym_float] = STATE(1152),
    [sym__hex_literal] = STATE(2235),
    [sym__float_literal] = STATE(2235),
    [sym_string] = STATE(2234),
    [sym__single_quoted_string] = STATE(2236),
    [sym__double_quoted_string] = STATE(2237),
    [sym_na] = STATE(1152),
    [sym__expression] = STATE(1152),
    [sym__string_or_identifier] = STATE(5150),
    [sym__open_parenthesis] = STATE(76),
    [sym__open_brace] = STATE(188),
    [sym__close_brace] = STATE(2964),
    [aux_sym_braced_expression_repeat1] = STATE(262),
    [sym_identifier] = ACTIONS(1433),
    [anon_sym_BSLASH] = ACTIONS(1435),
    [anon_sym_function] = ACTIONS(1437),
    [anon_sym_EQ] = ACTIONS(59),
    [anon_sym_if] = ACTIONS(1439),
    [anon_sym_for] = ACTIONS(1441),
    [anon_sym_while] = ACTIONS(1443),
    [anon_sym_repeat] = ACTIONS(1445),
    [anon_sym_QMARK] = ACTIONS(1447),
    [anon_sym_TILDE] = ACTIONS(1449),
    [anon_sym_BANG] = ACTIONS(1451),
    [anon_sym_PLUS] = ACTIONS(1453),
    [anon_sym_DASH] = ACTIONS(1455),
    [anon_sym_LT_DASH] = ACTIONS(51),
    [anon_sym_LT_LT_DASH] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(51),
    [anon_sym_DASH_GT] = ACTIONS(59),
    [anon_sym_DASH_GT_GT] = ACTIONS(51),
    [anon_sym_PIPE] = ACTIONS(59),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_AMP_AMP] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(59),
    [anon_sym_LT_EQ] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(59),
    [anon_sym_GT_EQ] = ACTIONS(51),
    [anon_sym_EQ_EQ] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(51),
    [anon_sym_CARET] = ACTIONS(51),
    [aux_sym_binary_operator_token1] = ACTIONS(51),
    [anon_sym_PIPE_GT] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(59),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_AT] = ACTIONS(51),
    [aux_sym__hex_literal_token1] = ACTIONS(1457),
    [sym__number_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [anon_sym_DQUOTE] = ACTIONS(1463),
    [sym_return] = ACTIONS(1465),
    [sym_next] = ACTIONS(1465),
    [sym_break] = ACTIONS(1465),
    [sym_true] = ACTIONS(1465),
    [sym_false] = ACTIONS(1465),
    [sym_null] = ACTIONS(1465),
    [sym_inf] = ACTIONS(1465),
    [sym_nan] = ACTIONS(1465),
    [anon_sym_NA] = ACTIONS(1467),
    [anon_sym_NA_integer_] = ACTIONS(1467),
    [anon_sym_NA_real_] = ACTIONS(1467),
    [anon_sym_NA_complex_] = ACTIONS(1467),
    [anon_sym_NA_character_] = ACTIONS(1467),
    [sym_dots] = ACTIONS(1465),
    [sym_dot_dot_i] = ACTIONS(1469),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(51),
    [sym__newline] = ACTIONS(1471),
    [sym__semicolon] = ACTIONS(1471),
    [sym__raw_string_literal] = ACTIONS(1473),
    [sym__external_open_parenthesis] = ACTIONS(1475),
    [sym__external_open_brace] = ACTIONS(1477),
    [sym__external_close_brace] = ACTIONS(1844),
    [sym__external_open_bracket] = ACTIONS(51),
    [sym__external_open_bracket2] = ACTIONS(51),
    [sym__external_close_bracket2] = ACTIONS(51),
  },
  [137] = {
    [sym_function_definition] = STATE(761),
    [sym_if_statement] = STATE(761),
    [sym_for_statement] = STATE(761),
    [sym_while_statement] = STATE(761),
    [sym_repeat_statement] = STATE(761),
    [sym_braced_expression] = STATE(761),
    [sym_parenthesized_expression] = STATE(761),
    [sym_call] = STATE(761),
    [sym_subset] = STATE(761),
    [sym_subset2] = STATE(761),
    [sym_unary_operator] = STATE(761),
    [sym_binary_operator] = STATE(761),
    [sym_extract_operator] = STATE(761),
    [sym_namespace_operator] = STATE(761),
    [sym_integer] = STATE(761),
    [sym_complex] = STATE(761),
    [sym_float] = STATE(761),
    [sym__hex_literal] = STATE(2220),
    [sym__float_literal] = STATE(2220),
    [sym_string] = STATE(2219),
    [sym__single_quoted_string] = STATE(2221),
    [sym__double_quoted_string] = STATE(2222),
    [sym_na] = STATE(761),
    [sym__expression] = STATE(761),
    [sym__string_or_identifier] = STATE(5140),
    [sym__open_parenthesis] = STATE(54),
    [sym__open_brace] = STATE(56),
    [aux_sym_function_definition_repeat1] = STATE(141),
    [sym_identifier] = ACTIONS(626),
    [anon_sym_BSLASH] = ACTIONS(628),
    [anon_sym_function] = ACTIONS(630),
    [anon_sym_EQ] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [anon_sym_repeat] = ACTIONS(638),
    [anon_sym_QMARK] = ACTIONS(640),
    [anon_sym_TILDE] = ACTIONS(642),
    [anon_sym_BANG] = ACTIONS(644),
    [anon_sym_PLUS] = ACTIONS(646),
    [anon_sym_DASH] = ACTIONS(648),
    [anon_sym_LT_DASH] = ACTIONS(387),
    [anon_sym_LT_LT_DASH] = ACTIONS(387),
    [anon_sym_COLON_EQ] = ACTIONS(387),
    [anon_sym_DASH_GT] = ACTIONS(389),
    [anon_sym_DASH_GT_GT] = ACTIONS(387),
    [anon_sym_PIPE] = ACTIONS(389),
    [anon_sym_AMP] = ACTIONS(389),
    [anon_sym_PIPE_PIPE] = ACTIONS(387),
    [anon_sym_AMP_AMP] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(389),
    [anon_sym_LT_EQ] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(389),
    [anon_sym_GT_EQ] = ACTIONS(387),
    [anon_sym_EQ_EQ] = ACTIONS(387),
    [anon_sym_BANG_EQ] = ACTIONS(387),
    [anon_sym_STAR] = ACTIONS(389),
    [anon_sym_SLASH] = ACTIONS(387),
    [anon_sym_STAR_STAR] = ACTIONS(387),
    [anon_sym_CARET] = ACTIONS(387),
    [aux_sym_binary_operator_token1] = ACTIONS(387),
    [anon_sym_PIPE_GT] = ACTIONS(387),
    [anon_sym_COLON] = ACTIONS(389),
    [anon_sym_DOLLAR] = ACTIONS(387),
    [anon_sym_AT] = ACTIONS(387),
    [aux_sym__hex_literal_token1] = ACTIONS(650),
    [sym__number_literal] = ACTIONS(652),
    [anon_sym_SQUOTE] = ACTIONS(654),
    [anon_sym_DQUOTE] = ACTIONS(656),
    [sym_return] = ACTIONS(1846),
    [sym_next] = ACTIONS(1846),
    [sym_break] = ACTIONS(1846),
    [sym_true] = ACTIONS(1846),
    [sym_false] = ACTIONS(1846),
    [sym_null] = ACTIONS(1846),
    [sym_inf] = ACTIONS(1846),
    [sym_nan] = ACTIONS(1846),
    [anon_sym_NA] = ACTIONS(660),
    [anon_sym_NA_integer_] = ACTIONS(660),
    [anon_sym_NA_real_] = ACTIONS(660),
    [anon_sym_NA_complex_] = ACTIONS(660),
    [anon_sym_NA_character_] = ACTIONS(660),
    [sym_dots] = ACTIONS(1846),
    [sym_dot_dot_i] = ACTIONS(1848),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(387),
    [sym__newline] = ACTIONS(1850),
    [sym__semicolon] = ACTIONS(387),
    [sym__raw_string_literal] = ACTIONS(666),
    [sym__external_open_parenthesis] = ACTIONS(668),
    [sym__external_close_parenthesis] = ACTIONS(387),
    [sym__external_open_brace] = ACTIONS(670),
    [sym__external_close_brace] = ACTIONS(387),
    [sym__external_open_bracket] = ACTIONS(387),
    [sym__external_open_bracket2] = ACTIONS(387),
    [sym__external_close_bracket2] = ACTIONS(387),
  },
  [138] = {
    [sym_function_definition] = STATE(935),
    [sym_if_statement] = STATE(935),
    [sym_for_statement] = STATE(935),
    [sym_while_statement] = STATE(935),
    [sym_repeat_statement] = STATE(935),
    [sym_braced_expression] = STATE(935),
    [sym_parenthesized_expression] = STATE(935),
    [sym_call] = STATE(935),
    [sym_subset] = STATE(935),
    [sym_subset2] = STATE(935),
    [sym_unary_operator] = STATE(935),
    [sym_binary_operator] = STATE(935),
    [sym_extract_operator] = STATE(935),
    [sym_namespace_operator] = STATE(935),
    [sym_integer] = STATE(935),
    [sym_complex] = STATE(935),
    [sym_float] = STATE(935),
    [sym__hex_literal] = STATE(2220),
    [sym__float_literal] = STATE(2220),
    [sym_string] = STATE(2219),
    [sym__single_quoted_string] = STATE(2221),
    [sym__double_quoted_string] = STATE(2222),
    [sym_na] = STATE(935),
    [sym__expression] = STATE(935),
    [sym__string_or_identifier] = STATE(5140),
    [sym__open_parenthesis] = STATE(54),
    [sym__open_brace] = STATE(56),
    [aux_sym_parenthesized_expression_repeat1] = STATE(138),
    [sym_identifier] = ACTIONS(1852),
    [anon_sym_BSLASH] = ACTIONS(1855),
    [anon_sym_function] = ACTIONS(1858),
    [anon_sym_EQ] = ACTIONS(814),
    [anon_sym_if] = ACTIONS(1861),
    [anon_sym_for] = ACTIONS(1864),
    [anon_sym_while] = ACTIONS(1867),
    [anon_sym_repeat] = ACTIONS(1870),
    [anon_sym_QMARK] = ACTIONS(1873),
    [anon_sym_TILDE] = ACTIONS(1876),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_PLUS] = ACTIONS(1882),
    [anon_sym_DASH] = ACTIONS(1885),
    [anon_sym_LT_DASH] = ACTIONS(803),
    [anon_sym_LT_LT_DASH] = ACTIONS(803),
    [anon_sym_COLON_EQ] = ACTIONS(803),
    [anon_sym_DASH_GT] = ACTIONS(814),
    [anon_sym_DASH_GT_GT] = ACTIONS(803),
    [anon_sym_PIPE] = ACTIONS(814),
    [anon_sym_AMP] = ACTIONS(814),
    [anon_sym_PIPE_PIPE] = ACTIONS(803),
    [anon_sym_AMP_AMP] = ACTIONS(803),
    [anon_sym_LT] = ACTIONS(814),
    [anon_sym_LT_EQ] = ACTIONS(803),
    [anon_sym_GT] = ACTIONS(814),
    [anon_sym_GT_EQ] = ACTIONS(803),
    [anon_sym_EQ_EQ] = ACTIONS(803),
    [anon_sym_BANG_EQ] = ACTIONS(803),
    [anon_sym_STAR] = ACTIONS(814),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_STAR_STAR] = ACTIONS(803),
    [anon_sym_CARET] = ACTIONS(803),
    [aux_sym_binary_operator_token1] = ACTIONS(803),
    [anon_sym_PIPE_GT] = ACTIONS(803),
    [anon_sym_COLON] = ACTIONS(814),
    [anon_sym_DOLLAR] = ACTIONS(803),
    [anon_sym_AT] = ACTIONS(803),
    [aux_sym__hex_literal_token1] = ACTIONS(1888),
    [sym__number_literal] = ACTIONS(1891),
    [anon_sym_SQUOTE] = ACTIONS(1894),
    [anon_sym_DQUOTE] = ACTIONS(1897),
    [sym_return] = ACTIONS(1900),
    [sym_next] = ACTIONS(1900),
    [sym_break] = ACTIONS(1900),
    [sym_true] = ACTIONS(1900),
    [sym_false] = ACTIONS(1900),
    [sym_null] = ACTIONS(1900),
    [sym_inf] = ACTIONS(1900),
    [sym_nan] = ACTIONS(1900),
    [anon_sym_NA] = ACTIONS(1903),
    [anon_sym_NA_integer_] = ACTIONS(1903),
    [anon_sym_NA_real_] = ACTIONS(1903),
    [anon_sym_NA_complex_] = ACTIONS(1903),
    [anon_sym_NA_character_] = ACTIONS(1903),
    [sym_dots] = ACTIONS(1900),
    [sym_dot_dot_i] = ACTIONS(1906),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(803),
    [sym__newline] = ACTIONS(1909),
    [sym__semicolon] = ACTIONS(803),
    [sym__raw_string_literal] = ACTIONS(1912),
    [sym__external_open_parenthesis] = ACTIONS(1915),
    [sym__external_close_parenthesis] = ACTIONS(803),
    [sym__external_open_brace] = ACTIONS(1918),
    [sym__external_close_brace] = ACTIONS(803),
    [sym__external_open_bracket] = ACTIONS(803),
    [sym__external_open_bracket2] = ACTIONS(803),
    [sym__external_close_bracket2] = ACTIONS(803),
  },
  [139] = {
    [sym_function_definition] = STATE(791),
    [sym_if_statement] = STATE(791),
    [sym_for_statement] = STATE(791),
    [sym_while_statement] = STATE(791),
    [sym_repeat_statement] = STATE(791),
    [sym_braced_expression] = STATE(791),
    [sym_parenthesized_expression] = STATE(791),
    [sym_call] = STATE(791),
    [sym_subset] = STATE(791),
    [sym_subset2] = STATE(791),
    [sym_unary_operator] = STATE(791),
    [sym_binary_operator] = STATE(791),
    [sym_extract_operator] = STATE(791),
    [sym_namespace_operator] = STATE(791),
    [sym_integer] = STATE(791),
    [sym_complex] = STATE(791),
    [sym_float] = STATE(791),
    [sym__hex_literal] = STATE(2183),
    [sym__float_literal] = STATE(2183),
    [sym_string] = STATE(2169),
    [sym__single_quoted_string] = STATE(2181),
    [sym__double_quoted_string] = STATE(2180),
    [sym_na] = STATE(791),
    [sym__expression] = STATE(791),
    [sym__string_or_identifier] = STATE(5149),
    [sym__open_parenthesis] = STATE(67),
    [sym__open_brace] = STATE(24),
    [aux_sym_parenthesized_expression_repeat1] = STATE(139),
    [ts_builtin_sym_end] = ACTIONS(803),
    [sym_identifier] = ACTIONS(1921),
    [anon_sym_BSLASH] = ACTIONS(1924),
    [anon_sym_function] = ACTIONS(1927),
    [anon_sym_EQ] = ACTIONS(814),
    [anon_sym_if] = ACTIONS(1930),
    [anon_sym_for] = ACTIONS(1933),
    [anon_sym_while] = ACTIONS(1936),
    [anon_sym_repeat] = ACTIONS(1939),
    [anon_sym_QMARK] = ACTIONS(1942),
    [anon_sym_TILDE] = ACTIONS(1945),
    [anon_sym_BANG] = ACTIONS(1948),
    [anon_sym_PLUS] = ACTIONS(1951),
    [anon_sym_DASH] = ACTIONS(1954),
    [anon_sym_LT_DASH] = ACTIONS(803),
    [anon_sym_LT_LT_DASH] = ACTIONS(803),
    [anon_sym_COLON_EQ] = ACTIONS(803),
    [anon_sym_DASH_GT] = ACTIONS(814),
    [anon_sym_DASH_GT_GT] = ACTIONS(803),
    [anon_sym_PIPE] = ACTIONS(814),
    [anon_sym_AMP] = ACTIONS(814),
    [anon_sym_PIPE_PIPE] = ACTIONS(803),
    [anon_sym_AMP_AMP] = ACTIONS(803),
    [anon_sym_LT] = ACTIONS(814),
    [anon_sym_LT_EQ] = ACTIONS(803),
    [anon_sym_GT] = ACTIONS(814),
    [anon_sym_GT_EQ] = ACTIONS(803),
    [anon_sym_EQ_EQ] = ACTIONS(803),
    [anon_sym_BANG_EQ] = ACTIONS(803),
    [anon_sym_STAR] = ACTIONS(814),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_STAR_STAR] = ACTIONS(803),
    [anon_sym_CARET] = ACTIONS(803),
    [aux_sym_binary_operator_token1] = ACTIONS(803),
    [anon_sym_PIPE_GT] = ACTIONS(803),
    [anon_sym_COLON] = ACTIONS(814),
    [anon_sym_DOLLAR] = ACTIONS(803),
    [anon_sym_AT] = ACTIONS(803),
    [aux_sym__hex_literal_token1] = ACTIONS(1957),
    [sym__number_literal] = ACTIONS(1960),
    [anon_sym_SQUOTE] = ACTIONS(1963),
    [anon_sym_DQUOTE] = ACTIONS(1966),
    [sym_return] = ACTIONS(1969),
    [sym_next] = ACTIONS(1969),
    [sym_break] = ACTIONS(1969),
    [sym_true] = ACTIONS(1969),
    [sym_false] = ACTIONS(1969),
    [sym_null] = ACTIONS(1969),
    [sym_inf] = ACTIONS(1969),
    [sym_nan] = ACTIONS(1969),
    [anon_sym_NA] = ACTIONS(1972),
    [anon_sym_NA_integer_] = ACTIONS(1972),
    [anon_sym_NA_real_] = ACTIONS(1972),
    [anon_sym_NA_complex_] = ACTIONS(1972),
    [anon_sym_NA_character_] = ACTIONS(1972),
    [sym_dots] = ACTIONS(1969),
    [sym_dot_dot_i] = ACTIONS(1975),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(803),
    [sym__newline] = ACTIONS(1978),
    [sym__semicolon] = ACTIONS(803),
    [sym__raw_string_literal] = ACTIONS(1981),
    [sym__external_open_parenthesis] = ACTIONS(1984),
    [sym__external_close_parenthesis] = ACTIONS(803),
    [sym__external_open_brace] = ACTIONS(1987),
    [sym__external_close_brace] = ACTIONS(803),
    [sym__external_open_bracket] = ACTIONS(803),
    [sym__external_open_bracket2] = ACTIONS(803),
  },
  [140] = {
    [sym_function_definition] = STATE(762),
    [sym_if_statement] = STATE(762),
    [sym_for_statement] = STATE(762),
    [sym_while_statement] = STATE(762),
    [sym_repeat_statement] = STATE(762),
    [sym_braced_expression] = STATE(762),
    [sym_parenthesized_expression] = STATE(762),
    [sym_call] = STATE(762),
    [sym_subset] = STATE(762),
    [sym_subset2] = STATE(762),
    [sym_unary_operator] = STATE(762),
    [sym_binary_operator] = STATE(762),
    [sym_extract_operator] = STATE(762),
    [sym_namespace_operator] = STATE(762),
    [sym_integer] = STATE(762),
    [sym_complex] = STATE(762),
    [sym_float] = STATE(762),
    [sym__hex_literal] = STATE(2220),
    [sym__float_literal] = STATE(2220),
    [sym_string] = STATE(2219),
    [sym__single_quoted_string] = STATE(2221),
    [sym__double_quoted_string] = STATE(2222),
    [sym_na] = STATE(762),
    [sym__expression] = STATE(762),
    [sym__string_or_identifier] = STATE(5140),
    [sym__open_parenthesis] = STATE(54),
    [sym__open_brace] = STATE(56),
    [aux_sym_function_definition_repeat1] = STATE(2303),
    [sym_identifier] = ACTIONS(626),
    [anon_sym_BSLASH] = ACTIONS(628),
    [anon_sym_function] = ACTIONS(630),
    [anon_sym_EQ] = ACTIONS(399),
    [anon_sym_if] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [anon_sym_repeat] = ACTIONS(638),
    [anon_sym_QMARK] = ACTIONS(640),
    [anon_sym_TILDE] = ACTIONS(642),
    [anon_sym_BANG] = ACTIONS(644),
    [anon_sym_PLUS] = ACTIONS(646),
    [anon_sym_DASH] = ACTIONS(648),
    [anon_sym_LT_DASH] = ACTIONS(397),
    [anon_sym_LT_LT_DASH] = ACTIONS(397),
    [anon_sym_COLON_EQ] = ACTIONS(397),
    [anon_sym_DASH_GT] = ACTIONS(399),
    [anon_sym_DASH_GT_GT] = ACTIONS(397),
    [anon_sym_PIPE] = ACTIONS(399),
    [anon_sym_AMP] = ACTIONS(399),
    [anon_sym_PIPE_PIPE] = ACTIONS(397),
    [anon_sym_AMP_AMP] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(399),
    [anon_sym_LT_EQ] = ACTIONS(397),
    [anon_sym_GT] = ACTIONS(399),
    [anon_sym_GT_EQ] = ACTIONS(397),
    [anon_sym_EQ_EQ] = ACTIONS(397),
    [anon_sym_BANG_EQ] = ACTIONS(397),
    [anon_sym_STAR] = ACTIONS(399),
    [anon_sym_SLASH] = ACTIONS(397),
    [anon_sym_STAR_STAR] = ACTIONS(397),
    [anon_sym_CARET] = ACTIONS(397),
    [aux_sym_binary_operator_token1] = ACTIONS(397),
    [anon_sym_PIPE_GT] = ACTIONS(397),
    [anon_sym_COLON] = ACTIONS(399),
    [anon_sym_DOLLAR] = ACTIONS(397),
    [anon_sym_AT] = ACTIONS(397),
    [aux_sym__hex_literal_token1] = ACTIONS(650),
    [sym__number_literal] = ACTIONS(652),
    [anon_sym_SQUOTE] = ACTIONS(654),
    [anon_sym_DQUOTE] = ACTIONS(656),
    [sym_return] = ACTIONS(1990),
    [sym_next] = ACTIONS(1990),
    [sym_break] = ACTIONS(1990),
    [sym_true] = ACTIONS(1990),
    [sym_false] = ACTIONS(1990),
    [sym_null] = ACTIONS(1990),
    [sym_inf] = ACTIONS(1990),
    [sym_nan] = ACTIONS(1990),
    [anon_sym_NA] = ACTIONS(660),
    [anon_sym_NA_integer_] = ACTIONS(660),
    [anon_sym_NA_real_] = ACTIONS(660),
    [anon_sym_NA_complex_] = ACTIONS(660),
    [anon_sym_NA_character_] = ACTIONS(660),
    [sym_dots] = ACTIONS(1990),
    [sym_dot_dot_i] = ACTIONS(1992),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(397),
    [sym__newline] = ACTIONS(397),
    [sym__semicolon] = ACTIONS(397),
    [sym__raw_string_literal] = ACTIONS(666),
    [sym__external_open_parenthesis] = ACTIONS(668),
    [sym__external_close_parenthesis] = ACTIONS(397),
    [sym__external_open_brace] = ACTIONS(670),
    [sym__external_close_brace] = ACTIONS(397),
    [sym__external_open_bracket] = ACTIONS(397),
    [sym__external_open_bracket2] = ACTIONS(397),
    [sym__external_close_bracket2] = ACTIONS(397),
  },
  [141] = {
    [sym_function_definition] = STATE(765),
    [sym_if_statement] = STATE(765),
    [sym_for_statement] = STATE(765),
    [sym_while_statement] = STATE(765),
    [sym_repeat_statement] = STATE(765),
    [sym_braced_expression] = STATE(765),
    [sym_parenthesized_expression] = STATE(765),
    [sym_call] = STATE(765),
    [sym_subset] = STATE(765),
    [sym_subset2] = STATE(765),
    [sym_unary_operator] = STATE(765),
    [sym_binary_operator] = STATE(765),
    [sym_extract_operator] = STATE(765),
    [sym_namespace_operator] = STATE(765),
    [sym_integer] = STATE(765),
    [sym_complex] = STATE(765),
    [sym_float] = STATE(765),
    [sym__hex_literal] = STATE(2220),
    [sym__float_literal] = STATE(2220),
    [sym_string] = STATE(2219),
    [sym__single_quoted_string] = STATE(2221),
    [sym__double_quoted_string] = STATE(2222),
    [sym_na] = STATE(765),
    [sym__expression] = STATE(765),
    [sym__string_or_identifier] = STATE(5140),
    [sym__open_parenthesis] = STATE(54),
    [sym__open_brace] = STATE(56),
    [aux_sym_function_definition_repeat1] = STATE(2303),
    [sym_identifier] = ACTIONS(626),
    [anon_sym_BSLASH] = ACTIONS(628),
    [anon_sym_function] = ACTIONS(630),
    [anon_sym_EQ] = ACTIONS(455),
    [anon_sym_if] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [anon_sym_repeat] = ACTIONS(638),
    [anon_sym_QMARK] = ACTIONS(640),
    [anon_sym_TILDE] = ACTIONS(642),
    [anon_sym_BANG] = ACTIONS(644),
    [anon_sym_PLUS] = ACTIONS(646),
    [anon_sym_DASH] = ACTIONS(648),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [anon_sym_LT_LT_DASH] = ACTIONS(453),
    [anon_sym_COLON_EQ] = ACTIONS(453),
    [anon_sym_DASH_GT] = ACTIONS(455),
    [anon_sym_DASH_GT_GT] = ACTIONS(453),
    [anon_sym_PIPE] = ACTIONS(455),
    [anon_sym_AMP] = ACTIONS(455),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(455),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_GT] = ACTIONS(455),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(453),
    [anon_sym_STAR] = ACTIONS(455),
    [anon_sym_SLASH] = ACTIONS(453),
    [anon_sym_STAR_STAR] = ACTIONS(453),
    [anon_sym_CARET] = ACTIONS(453),
    [aux_sym_binary_operator_token1] = ACTIONS(453),
    [anon_sym_PIPE_GT] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(455),
    [anon_sym_DOLLAR] = ACTIONS(453),
    [anon_sym_AT] = ACTIONS(453),
    [aux_sym__hex_literal_token1] = ACTIONS(650),
    [sym__number_literal] = ACTIONS(652),
    [anon_sym_SQUOTE] = ACTIONS(654),
    [anon_sym_DQUOTE] = ACTIONS(656),
    [sym_return] = ACTIONS(1994),
    [sym_next] = ACTIONS(1994),
    [sym_break] = ACTIONS(1994),
    [sym_true] = ACTIONS(1994),
    [sym_false] = ACTIONS(1994),
    [sym_null] = ACTIONS(1994),
    [sym_inf] = ACTIONS(1994),
    [sym_nan] = ACTIONS(1994),
    [anon_sym_NA] = ACTIONS(660),
    [anon_sym_NA_integer_] = ACTIONS(660),
    [anon_sym_NA_real_] = ACTIONS(660),
    [anon_sym_NA_complex_] = ACTIONS(660),
    [anon_sym_NA_character_] = ACTIONS(660),
    [sym_dots] = ACTIONS(1994),
    [sym_dot_dot_i] = ACTIONS(1996),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(453),
    [sym__newline] = ACTIONS(453),
    [sym__semicolon] = ACTIONS(453),
    [sym__raw_string_literal] = ACTIONS(666),
    [sym__external_open_parenthesis] = ACTIONS(668),
    [sym__external_close_parenthesis] = ACTIONS(453),
    [sym__external_open_brace] = ACTIONS(670),
    [sym__external_close_brace] = ACTIONS(453),
    [sym__external_open_bracket] = ACTIONS(453),
    [sym__external_open_bracket2] = ACTIONS(453),
    [sym__external_close_bracket2] = ACTIONS(453),
  },
  [142] = {
    [sym_function_definition] = STATE(790),
    [sym_if_statement] = STATE(790),
    [sym_for_statement] = STATE(790),
    [sym_while_statement] = STATE(790),
    [sym_repeat_statement] = STATE(790),
    [sym_braced_expression] = STATE(790),
    [sym_parenthesized_expression] = STATE(790),
    [sym_call] = STATE(790),
    [sym_subset] = STATE(790),
    [sym_subset2] = STATE(790),
    [sym_unary_operator] = STATE(790),
    [sym_binary_operator] = STATE(790),
    [sym_extract_operator] = STATE(790),
    [sym_namespace_operator] = STATE(790),
    [sym_integer] = STATE(790),
    [sym_complex] = STATE(790),
    [sym_float] = STATE(790),
    [sym__hex_literal] = STATE(2183),
    [sym__float_literal] = STATE(2183),
    [sym_string] = STATE(2169),
    [sym__single_quoted_string] = STATE(2181),
    [sym__double_quoted_string] = STATE(2180),
    [sym_na] = STATE(790),
    [sym__expression] = STATE(790),
    [sym__string_or_identifier] = STATE(5149),
    [sym__open_parenthesis] = STATE(67),
    [sym__open_brace] = STATE(24),
    [sym__close_brace] = STATE(4720),
    [aux_sym_braced_expression_repeat1] = STATE(145),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_BSLASH] = ACTIONS(323),
    [anon_sym_function] = ACTIONS(325),
    [anon_sym_EQ] = ACTIONS(59),
    [anon_sym_if] = ACTIONS(327),
    [anon_sym_for] = ACTIONS(329),
    [anon_sym_while] = ACTIONS(331),
    [anon_sym_repeat] = ACTIONS(333),
    [anon_sym_QMARK] = ACTIONS(335),
    [anon_sym_TILDE] = ACTIONS(337),
    [anon_sym_BANG] = ACTIONS(339),
    [anon_sym_PLUS] = ACTIONS(341),
    [anon_sym_DASH] = ACTIONS(343),
    [anon_sym_LT_DASH] = ACTIONS(51),
    [anon_sym_LT_LT_DASH] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(51),
    [anon_sym_DASH_GT] = ACTIONS(59),
    [anon_sym_DASH_GT_GT] = ACTIONS(51),
    [anon_sym_PIPE] = ACTIONS(59),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_AMP_AMP] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(59),
    [anon_sym_LT_EQ] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(59),
    [anon_sym_GT_EQ] = ACTIONS(51),
    [anon_sym_EQ_EQ] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(51),
    [anon_sym_CARET] = ACTIONS(51),
    [aux_sym_binary_operator_token1] = ACTIONS(51),
    [anon_sym_PIPE_GT] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(59),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_AT] = ACTIONS(51),
    [aux_sym__hex_literal_token1] = ACTIONS(345),
    [sym__number_literal] = ACTIONS(347),
    [anon_sym_SQUOTE] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(351),
    [sym_return] = ACTIONS(353),
    [sym_next] = ACTIONS(353),
    [sym_break] = ACTIONS(353),
    [sym_true] = ACTIONS(353),
    [sym_false] = ACTIONS(353),
    [sym_null] = ACTIONS(353),
    [sym_inf] = ACTIONS(353),
    [sym_nan] = ACTIONS(353),
    [anon_sym_NA] = ACTIONS(355),
    [anon_sym_NA_integer_] = ACTIONS(355),
    [anon_sym_NA_real_] = ACTIONS(355),
    [anon_sym_NA_complex_] = ACTIONS(355),
    [anon_sym_NA_character_] = ACTIONS(355),
    [sym_dots] = ACTIONS(353),
    [sym_dot_dot_i] = ACTIONS(357),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(51),
    [sym__newline] = ACTIONS(359),
    [sym__semicolon] = ACTIONS(359),
    [sym__raw_string_literal] = ACTIONS(361),
    [sym__external_open_parenthesis] = ACTIONS(363),
    [sym__external_close_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(365),
    [sym__external_close_brace] = ACTIONS(1998),
    [sym__external_open_bracket] = ACTIONS(51),
    [sym__external_open_bracket2] = ACTIONS(51),
  },
  [143] = {
    [sym_function_definition] = STATE(766),
    [sym_if_statement] = STATE(766),
    [sym_for_statement] = STATE(766),
    [sym_while_statement] = STATE(766),
    [sym_repeat_statement] = STATE(766),
    [sym_braced_expression] = STATE(766),
    [sym_parenthesized_expression] = STATE(766),
    [sym_call] = STATE(766),
    [sym_subset] = STATE(766),
    [sym_subset2] = STATE(766),
    [sym_unary_operator] = STATE(766),
    [sym_binary_operator] = STATE(766),
    [sym_extract_operator] = STATE(766),
    [sym_namespace_operator] = STATE(766),
    [sym_integer] = STATE(766),
    [sym_complex] = STATE(766),
    [sym_float] = STATE(766),
    [sym__hex_literal] = STATE(2220),
    [sym__float_literal] = STATE(2220),
    [sym_string] = STATE(2219),
    [sym__single_quoted_string] = STATE(2221),
    [sym__double_quoted_string] = STATE(2222),
    [sym_na] = STATE(766),
    [sym__expression] = STATE(766),
    [sym__string_or_identifier] = STATE(5140),
    [sym__open_parenthesis] = STATE(54),
    [sym__open_brace] = STATE(56),
    [aux_sym_function_definition_repeat1] = STATE(144),
    [sym_identifier] = ACTIONS(626),
    [anon_sym_BSLASH] = ACTIONS(628),
    [anon_sym_function] = ACTIONS(630),
    [anon_sym_EQ] = ACTIONS(463),
    [anon_sym_if] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [anon_sym_repeat] = ACTIONS(638),
    [anon_sym_QMARK] = ACTIONS(640),
    [anon_sym_TILDE] = ACTIONS(642),
    [anon_sym_BANG] = ACTIONS(644),
    [anon_sym_PLUS] = ACTIONS(646),
    [anon_sym_DASH] = ACTIONS(648),
    [anon_sym_LT_DASH] = ACTIONS(461),
    [anon_sym_LT_LT_DASH] = ACTIONS(461),
    [anon_sym_COLON_EQ] = ACTIONS(461),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_DASH_GT_GT] = ACTIONS(461),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_PIPE_PIPE] = ACTIONS(461),
    [anon_sym_AMP_AMP] = ACTIONS(461),
    [anon_sym_LT] = ACTIONS(463),
    [anon_sym_LT_EQ] = ACTIONS(461),
    [anon_sym_GT] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(461),
    [anon_sym_EQ_EQ] = ACTIONS(461),
    [anon_sym_BANG_EQ] = ACTIONS(461),
    [anon_sym_STAR] = ACTIONS(463),
    [anon_sym_SLASH] = ACTIONS(461),
    [anon_sym_STAR_STAR] = ACTIONS(461),
    [anon_sym_CARET] = ACTIONS(461),
    [aux_sym_binary_operator_token1] = ACTIONS(461),
    [anon_sym_PIPE_GT] = ACTIONS(461),
    [anon_sym_COLON] = ACTIONS(463),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_AT] = ACTIONS(461),
    [aux_sym__hex_literal_token1] = ACTIONS(650),
    [sym__number_literal] = ACTIONS(652),
    [anon_sym_SQUOTE] = ACTIONS(654),
    [anon_sym_DQUOTE] = ACTIONS(656),
    [sym_return] = ACTIONS(2000),
    [sym_next] = ACTIONS(2000),
    [sym_break] = ACTIONS(2000),
    [sym_true] = ACTIONS(2000),
    [sym_false] = ACTIONS(2000),
    [sym_null] = ACTIONS(2000),
    [sym_inf] = ACTIONS(2000),
    [sym_nan] = ACTIONS(2000),
    [anon_sym_NA] = ACTIONS(660),
    [anon_sym_NA_integer_] = ACTIONS(660),
    [anon_sym_NA_real_] = ACTIONS(660),
    [anon_sym_NA_complex_] = ACTIONS(660),
    [anon_sym_NA_character_] = ACTIONS(660),
    [sym_dots] = ACTIONS(2000),
    [sym_dot_dot_i] = ACTIONS(2002),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(461),
    [sym__newline] = ACTIONS(2004),
    [sym__semicolon] = ACTIONS(461),
    [sym__raw_string_literal] = ACTIONS(666),
    [sym__external_open_parenthesis] = ACTIONS(668),
    [sym__external_close_parenthesis] = ACTIONS(461),
    [sym__external_open_brace] = ACTIONS(670),
    [sym__external_close_brace] = ACTIONS(461),
    [sym__external_open_bracket] = ACTIONS(461),
    [sym__external_open_bracket2] = ACTIONS(461),
    [sym__external_close_bracket2] = ACTIONS(461),
  },
  [144] = {
    [sym_function_definition] = STATE(768),
    [sym_if_statement] = STATE(768),
    [sym_for_statement] = STATE(768),
    [sym_while_statement] = STATE(768),
    [sym_repeat_statement] = STATE(768),
    [sym_braced_expression] = STATE(768),
    [sym_parenthesized_expression] = STATE(768),
    [sym_call] = STATE(768),
    [sym_subset] = STATE(768),
    [sym_subset2] = STATE(768),
    [sym_unary_operator] = STATE(768),
    [sym_binary_operator] = STATE(768),
    [sym_extract_operator] = STATE(768),
    [sym_namespace_operator] = STATE(768),
    [sym_integer] = STATE(768),
    [sym_complex] = STATE(768),
    [sym_float] = STATE(768),
    [sym__hex_literal] = STATE(2220),
    [sym__float_literal] = STATE(2220),
    [sym_string] = STATE(2219),
    [sym__single_quoted_string] = STATE(2221),
    [sym__double_quoted_string] = STATE(2222),
    [sym_na] = STATE(768),
    [sym__expression] = STATE(768),
    [sym__string_or_identifier] = STATE(5140),
    [sym__open_parenthesis] = STATE(54),
    [sym__open_brace] = STATE(56),
    [aux_sym_function_definition_repeat1] = STATE(2303),
    [sym_identifier] = ACTIONS(626),
    [anon_sym_BSLASH] = ACTIONS(628),
    [anon_sym_function] = ACTIONS(630),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_if] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [anon_sym_repeat] = ACTIONS(638),
    [anon_sym_QMARK] = ACTIONS(640),
    [anon_sym_TILDE] = ACTIONS(642),
    [anon_sym_BANG] = ACTIONS(644),
    [anon_sym_PLUS] = ACTIONS(646),
    [anon_sym_DASH] = ACTIONS(648),
    [anon_sym_LT_DASH] = ACTIONS(471),
    [anon_sym_LT_LT_DASH] = ACTIONS(471),
    [anon_sym_COLON_EQ] = ACTIONS(471),
    [anon_sym_DASH_GT] = ACTIONS(473),
    [anon_sym_DASH_GT_GT] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(473),
    [anon_sym_AMP] = ACTIONS(473),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_LT_EQ] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(473),
    [anon_sym_GT_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_STAR] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [aux_sym_binary_operator_token1] = ACTIONS(471),
    [anon_sym_PIPE_GT] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(473),
    [anon_sym_DOLLAR] = ACTIONS(471),
    [anon_sym_AT] = ACTIONS(471),
    [aux_sym__hex_literal_token1] = ACTIONS(650),
    [sym__number_literal] = ACTIONS(652),
    [anon_sym_SQUOTE] = ACTIONS(654),
    [anon_sym_DQUOTE] = ACTIONS(656),
    [sym_return] = ACTIONS(2006),
    [sym_next] = ACTIONS(2006),
    [sym_break] = ACTIONS(2006),
    [sym_true] = ACTIONS(2006),
    [sym_false] = ACTIONS(2006),
    [sym_null] = ACTIONS(2006),
    [sym_inf] = ACTIONS(2006),
    [sym_nan] = ACTIONS(2006),
    [anon_sym_NA] = ACTIONS(660),
    [anon_sym_NA_integer_] = ACTIONS(660),
    [anon_sym_NA_real_] = ACTIONS(660),
    [anon_sym_NA_complex_] = ACTIONS(660),
    [anon_sym_NA_character_] = ACTIONS(660),
    [sym_dots] = ACTIONS(2006),
    [sym_dot_dot_i] = ACTIONS(2008),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(471),
    [sym__newline] = ACTIONS(471),
    [sym__semicolon] = ACTIONS(471),
    [sym__raw_string_literal] = ACTIONS(666),
    [sym__external_open_parenthesis] = ACTIONS(668),
    [sym__external_close_parenthesis] = ACTIONS(471),
    [sym__external_open_brace] = ACTIONS(670),
    [sym__external_close_brace] = ACTIONS(471),
    [sym__external_open_bracket] = ACTIONS(471),
    [sym__external_open_bracket2] = ACTIONS(471),
    [sym__external_close_bracket2] = ACTIONS(471),
  },
  [145] = {
    [sym_function_definition] = STATE(790),
    [sym_if_statement] = STATE(790),
    [sym_for_statement] = STATE(790),
    [sym_while_statement] = STATE(790),
    [sym_repeat_statement] = STATE(790),
    [sym_braced_expression] = STATE(790),
    [sym_parenthesized_expression] = STATE(790),
    [sym_call] = STATE(790),
    [sym_subset] = STATE(790),
    [sym_subset2] = STATE(790),
    [sym_unary_operator] = STATE(790),
    [sym_binary_operator] = STATE(790),
    [sym_extract_operator] = STATE(790),
    [sym_namespace_operator] = STATE(790),
    [sym_integer] = STATE(790),
    [sym_complex] = STATE(790),
    [sym_float] = STATE(790),
    [sym__hex_literal] = STATE(2183),
    [sym__float_literal] = STATE(2183),
    [sym_string] = STATE(2169),
    [sym__single_quoted_string] = STATE(2181),
    [sym__double_quoted_string] = STATE(2180),
    [sym_na] = STATE(790),
    [sym__expression] = STATE(790),
    [sym__string_or_identifier] = STATE(5149),
    [sym__open_parenthesis] = STATE(67),
    [sym__open_brace] = STATE(24),
    [aux_sym_braced_expression_repeat1] = STATE(145),
    [ts_builtin_sym_end] = ACTIONS(591),
    [sym_identifier] = ACTIONS(2010),
    [anon_sym_BSLASH] = ACTIONS(2013),
    [anon_sym_function] = ACTIONS(2016),
    [anon_sym_EQ] = ACTIONS(562),
    [anon_sym_if] = ACTIONS(2019),
    [anon_sym_for] = ACTIONS(2022),
    [anon_sym_while] = ACTIONS(2025),
    [anon_sym_repeat] = ACTIONS(2028),
    [anon_sym_QMARK] = ACTIONS(2031),
    [anon_sym_TILDE] = ACTIONS(2034),
    [anon_sym_BANG] = ACTIONS(2037),
    [anon_sym_PLUS] = ACTIONS(2040),
    [anon_sym_DASH] = ACTIONS(2043),
    [anon_sym_LT_DASH] = ACTIONS(591),
    [anon_sym_LT_LT_DASH] = ACTIONS(591),
    [anon_sym_COLON_EQ] = ACTIONS(591),
    [anon_sym_DASH_GT] = ACTIONS(562),
    [anon_sym_DASH_GT_GT] = ACTIONS(591),
    [anon_sym_PIPE] = ACTIONS(562),
    [anon_sym_AMP] = ACTIONS(562),
    [anon_sym_PIPE_PIPE] = ACTIONS(591),
    [anon_sym_AMP_AMP] = ACTIONS(591),
    [anon_sym_LT] = ACTIONS(562),
    [anon_sym_LT_EQ] = ACTIONS(591),
    [anon_sym_GT] = ACTIONS(562),
    [anon_sym_GT_EQ] = ACTIONS(591),
    [anon_sym_EQ_EQ] = ACTIONS(591),
    [anon_sym_BANG_EQ] = ACTIONS(591),
    [anon_sym_STAR] = ACTIONS(562),
    [anon_sym_SLASH] = ACTIONS(591),
    [anon_sym_STAR_STAR] = ACTIONS(591),
    [anon_sym_CARET] = ACTIONS(591),
    [aux_sym_binary_operator_token1] = ACTIONS(591),
    [anon_sym_PIPE_GT] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(562),
    [anon_sym_DOLLAR] = ACTIONS(591),
    [anon_sym_AT] = ACTIONS(591),
    [aux_sym__hex_literal_token1] = ACTIONS(2046),
    [sym__number_literal] = ACTIONS(2049),
    [anon_sym_SQUOTE] = ACTIONS(2052),
    [anon_sym_DQUOTE] = ACTIONS(2055),
    [sym_return] = ACTIONS(2058),
    [sym_next] = ACTIONS(2058),
    [sym_break] = ACTIONS(2058),
    [sym_true] = ACTIONS(2058),
    [sym_false] = ACTIONS(2058),
    [sym_null] = ACTIONS(2058),
    [sym_inf] = ACTIONS(2058),
    [sym_nan] = ACTIONS(2058),
    [anon_sym_NA] = ACTIONS(2061),
    [anon_sym_NA_integer_] = ACTIONS(2061),
    [anon_sym_NA_real_] = ACTIONS(2061),
    [anon_sym_NA_complex_] = ACTIONS(2061),
    [anon_sym_NA_character_] = ACTIONS(2061),
    [sym_dots] = ACTIONS(2058),
    [sym_dot_dot_i] = ACTIONS(2064),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(591),
    [sym__newline] = ACTIONS(2067),
    [sym__semicolon] = ACTIONS(2067),
    [sym__raw_string_literal] = ACTIONS(2070),
    [sym__external_open_parenthesis] = ACTIONS(2073),
    [sym__external_close_parenthesis] = ACTIONS(591),
    [sym__external_open_brace] = ACTIONS(2076),
    [sym__external_close_brace] = ACTIONS(591),
    [sym__external_open_bracket] = ACTIONS(591),
    [sym__external_open_bracket2] = ACTIONS(591),
  },
  [146] = {
    [sym_function_definition] = STATE(790),
    [sym_if_statement] = STATE(790),
    [sym_for_statement] = STATE(790),
    [sym_while_statement] = STATE(790),
    [sym_repeat_statement] = STATE(790),
    [sym_braced_expression] = STATE(790),
    [sym_parenthesized_expression] = STATE(790),
    [sym_call] = STATE(790),
    [sym_subset] = STATE(790),
    [sym_subset2] = STATE(790),
    [sym_unary_operator] = STATE(790),
    [sym_binary_operator] = STATE(790),
    [sym_extract_operator] = STATE(790),
    [sym_namespace_operator] = STATE(790),
    [sym_integer] = STATE(790),
    [sym_complex] = STATE(790),
    [sym_float] = STATE(790),
    [sym__hex_literal] = STATE(2183),
    [sym__float_literal] = STATE(2183),
    [sym_string] = STATE(2169),
    [sym__single_quoted_string] = STATE(2181),
    [sym__double_quoted_string] = STATE(2180),
    [sym_na] = STATE(790),
    [sym__expression] = STATE(790),
    [sym__string_or_identifier] = STATE(5149),
    [sym__open_parenthesis] = STATE(67),
    [sym__open_brace] = STATE(24),
    [sym__close_brace] = STATE(2876),
    [aux_sym_braced_expression_repeat1] = STATE(145),
    [ts_builtin_sym_end] = ACTIONS(51),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_BSLASH] = ACTIONS(323),
    [anon_sym_function] = ACTIONS(325),
    [anon_sym_EQ] = ACTIONS(59),
    [anon_sym_if] = ACTIONS(327),
    [anon_sym_for] = ACTIONS(329),
    [anon_sym_while] = ACTIONS(331),
    [anon_sym_repeat] = ACTIONS(333),
    [anon_sym_QMARK] = ACTIONS(335),
    [anon_sym_TILDE] = ACTIONS(337),
    [anon_sym_BANG] = ACTIONS(339),
    [anon_sym_PLUS] = ACTIONS(341),
    [anon_sym_DASH] = ACTIONS(343),
    [anon_sym_LT_DASH] = ACTIONS(51),
    [anon_sym_LT_LT_DASH] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(51),
    [anon_sym_DASH_GT] = ACTIONS(59),
    [anon_sym_DASH_GT_GT] = ACTIONS(51),
    [anon_sym_PIPE] = ACTIONS(59),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_AMP_AMP] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(59),
    [anon_sym_LT_EQ] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(59),
    [anon_sym_GT_EQ] = ACTIONS(51),
    [anon_sym_EQ_EQ] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(51),
    [anon_sym_CARET] = ACTIONS(51),
    [aux_sym_binary_operator_token1] = ACTIONS(51),
    [anon_sym_PIPE_GT] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(59),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_AT] = ACTIONS(51),
    [aux_sym__hex_literal_token1] = ACTIONS(345),
    [sym__number_literal] = ACTIONS(347),
    [anon_sym_SQUOTE] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(351),
    [sym_return] = ACTIONS(353),
    [sym_next] = ACTIONS(353),
    [sym_break] = ACTIONS(353),
    [sym_true] = ACTIONS(353),
    [sym_false] = ACTIONS(353),
    [sym_null] = ACTIONS(353),
    [sym_inf] = ACTIONS(353),
    [sym_nan] = ACTIONS(353),
    [anon_sym_NA] = ACTIONS(355),
    [anon_sym_NA_integer_] = ACTIONS(355),
    [anon_sym_NA_real_] = ACTIONS(355),
    [anon_sym_NA_complex_] = ACTIONS(355),
    [anon_sym_NA_character_] = ACTIONS(355),
    [sym_dots] = ACTIONS(353),
    [sym_dot_dot_i] = ACTIONS(357),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(359),
    [sym__semicolon] = ACTIONS(359),
    [sym__raw_string_literal] = ACTIONS(361),
    [sym__external_open_parenthesis] = ACTIONS(363),
    [sym__external_close_parenthesis] = ACTIONS(51),
    [sym__external_open_brace] = ACTIONS(365),
    [sym__external_close_brace] = ACTIONS(2079),
    [sym__external_open_bracket] = ACTIONS(51),
    [sym__external_open_bracket2] = ACTIONS(51),
  },
  [147] = {
    [sym_function_definition] = STATE(1139),
    [sym_if_statement] = STATE(1139),
    [sym_for_statement] = STATE(1139),
    [sym_while_statement] = STATE(1139),
    [sym_repeat_statement] = STATE(1139),
    [sym_braced_expression] = STATE(1139),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_call] = STATE(1139),
    [sym_subset] = STATE(1139),
    [sym_subset2] = STATE(1139),
    [sym_unary_operator] = STATE(1139),
    [sym_binary_operator] = STATE(1139),
    [sym_extract_operator] = STATE(1139),
    [sym_namespace_operator] = STATE(1139),
    [sym_integer] = STATE(1139),
    [sym_complex] = STATE(1139),
    [sym_float] = STATE(1139),
    [sym__hex_literal] = STATE(2272),
    [sym__float_literal] = STATE(2272),
    [sym_string] = STATE(2271),
    [sym__single_quoted_string] = STATE(2273),
    [sym__double_quoted_string] = STATE(2274),
    [sym_na] = STATE(1139),
    [sym__expression] = STATE(1139),
    [sym__string_or_identifier] = STATE(5157),
    [sym__open_parenthesis] = STATE(120),
    [sym__close_parenthesis] = STATE(2895),
    [sym__open_brace] = STATE(11),
    [aux_sym_parenthesized_expression_repeat1] = STATE(102),
    [sym_identifier] = ACTIONS(1241),
    [anon_sym_BSLASH] = ACTIONS(1243),
    [anon_sym_function] = ACTIONS(1245),
    [anon_sym_EQ] = ACTIONS(109),
    [anon_sym_if] = ACTIONS(1247),
    [anon_sym_for] = ACTIONS(1249),
    [anon_sym_while] = ACTIONS(1251),
    [anon_sym_repeat] = ACTIONS(1253),
    [anon_sym_QMARK] = ACTIONS(1255),
    [anon_sym_TILDE] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1259),
    [anon_sym_PLUS] = ACTIONS(1261),
    [anon_sym_DASH] = ACTIONS(1263),
    [anon_sym_LT_DASH] = ACTIONS(129),
    [anon_sym_LT_LT_DASH] = ACTIONS(129),
    [anon_sym_COLON_EQ] = ACTIONS(129),
    [anon_sym_DASH_GT] = ACTIONS(109),
    [anon_sym_DASH_GT_GT] = ACTIONS(129),
    [anon_sym_PIPE] = ACTIONS(109),
    [anon_sym_AMP] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_STAR_STAR] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [aux_sym_binary_operator_token1] = ACTIONS(129),
    [anon_sym_PIPE_GT] = ACTIONS(129),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(129),
    [anon_sym_AT] = ACTIONS(129),
    [aux_sym__hex_literal_token1] = ACTIONS(1265),
    [sym__number_literal] = ACTIONS(1267),
    [anon_sym_SQUOTE] = ACTIONS(1269),
    [anon_sym_DQUOTE] = ACTIONS(1271),
    [sym_return] = ACTIONS(1273),
    [sym_next] = ACTIONS(1273),
    [sym_break] = ACTIONS(1273),
    [sym_true] = ACTIONS(1273),
    [sym_false] = ACTIONS(1273),
    [sym_null] = ACTIONS(1273),
    [sym_inf] = ACTIONS(1273),
    [sym_nan] = ACTIONS(1273),
    [anon_sym_NA] = ACTIONS(1275),
    [anon_sym_NA_integer_] = ACTIONS(1275),
    [anon_sym_NA_real_] = ACTIONS(1275),
    [anon_sym_NA_complex_] = ACTIONS(1275),
    [anon_sym_NA_character_] = ACTIONS(1275),
    [sym_dots] = ACTIONS(1273),
    [sym_dot_dot_i] = ACTIONS(1277),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(129),
    [sym__newline] = ACTIONS(1279),
    [sym__raw_string_literal] = ACTIONS(1281),
    [sym__external_else] = ACTIONS(129),
    [sym__external_open_parenthesis] = ACTIONS(1283),
    [sym__external_close_parenthesis] = ACTIONS(2081),
    [sym__external_open_brace] = ACTIONS(1287),
    [sym__external_open_bracket] = ACTIONS(129),
    [sym__external_close_bracket] = ACTIONS(129),
    [sym__external_open_bracket2] = ACTIONS(129),
  },
  [148] = {
    [sym_function_definition] = STATE(1219),
    [sym_if_statement] = STATE(1219),
    [sym_for_statement] = STATE(1219),
    [sym_while_statement] = STATE(1219),
    [sym_repeat_statement] = STATE(1219),
    [sym_braced_expression] = STATE(1219),
    [sym_parenthesized_expression] = STATE(1219),
    [sym_call] = STATE(1219),
    [sym_subset] = STATE(1219),
    [sym_subset2] = STATE(1219),
    [sym_unary_operator] = STATE(1219),
    [sym_binary_operator] = STATE(1219),
    [sym_extract_operator] = STATE(1219),
    [sym_namespace_operator] = STATE(1219),
    [sym_integer] = STATE(1219),
    [sym_complex] = STATE(1219),
    [sym_float] = STATE(1219),
    [sym__hex_literal] = STATE(2356),
    [sym__float_literal] = STATE(2356),
    [sym_string] = STATE(2231),
    [sym__single_quoted_string] = STATE(2355),
    [sym__double_quoted_string] = STATE(2354),
    [sym_na] = STATE(1219),
    [sym__expression] = STATE(1219),
    [sym__string_or_identifier] = STATE(5156),
    [sym__open_parenthesis] = STATE(190),
    [sym__close_parenthesis] = STATE(2693),
    [sym__open_brace] = STATE(94),
    [aux_sym_parenthesized_expression_repeat1] = STATE(245),
    [ts_builtin_sym_end] = ACTIONS(211),
    [sym_identifier] = ACTIONS(1337),
    [anon_sym_BSLASH] = ACTIONS(1339),
    [anon_sym_function] = ACTIONS(1341),
    [anon_sym_EQ] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(1343),
    [anon_sym_for] = ACTIONS(1345),
    [anon_sym_while] = ACTIONS(1347),
    [anon_sym_repeat] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_BANG] = ACTIONS(1355),
    [anon_sym_PLUS] = ACTIONS(1357),
    [anon_sym_DASH] = ACTIONS(1359),
    [anon_sym_LT_DASH] = ACTIONS(211),
    [anon_sym_LT_LT_DASH] = ACTIONS(211),
    [anon_sym_COLON_EQ] = ACTIONS(211),
    [anon_sym_DASH_GT] = ACTIONS(209),
    [anon_sym_DASH_GT_GT] = ACTIONS(211),
    [anon_sym_PIPE] = ACTIONS(209),
    [anon_sym_AMP] = ACTIONS(209),
    [anon_sym_PIPE_PIPE] = ACTIONS(211),
    [anon_sym_AMP_AMP] = ACTIONS(211),
    [anon_sym_LT] = ACTIONS(209),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_GT] = ACTIONS(209),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [anon_sym_EQ_EQ] = ACTIONS(211),
    [anon_sym_BANG_EQ] = ACTIONS(211),
    [anon_sym_STAR] = ACTIONS(209),
    [anon_sym_SLASH] = ACTIONS(211),
    [anon_sym_STAR_STAR] = ACTIONS(211),
    [anon_sym_CARET] = ACTIONS(211),
    [aux_sym_binary_operator_token1] = ACTIONS(211),
    [anon_sym_PIPE_GT] = ACTIONS(211),
    [anon_sym_COLON] = ACTIONS(209),
    [anon_sym_DOLLAR] = ACTIONS(211),
    [anon_sym_AT] = ACTIONS(211),
    [aux_sym__hex_literal_token1] = ACTIONS(1361),
    [sym__number_literal] = ACTIONS(1363),
    [anon_sym_SQUOTE] = ACTIONS(1365),
    [anon_sym_DQUOTE] = ACTIONS(1367),
    [sym_return] = ACTIONS(1369),
    [sym_next] = ACTIONS(1369),
    [sym_break] = ACTIONS(1369),
    [sym_true] = ACTIONS(1369),
    [sym_false] = ACTIONS(1369),
    [sym_null] = ACTIONS(1369),
    [sym_inf] = ACTIONS(1369),
    [sym_nan] = ACTIONS(1369),
    [anon_sym_NA] = ACTIONS(1371),
    [anon_sym_NA_integer_] = ACTIONS(1371),
    [anon_sym_NA_real_] = ACTIONS(1371),
    [anon_sym_NA_complex_] = ACTIONS(1371),
    [anon_sym_NA_character_] = ACTIONS(1371),
    [sym_dots] = ACTIONS(1369),
    [sym_dot_dot_i] = ACTIONS(1373),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1375),
    [sym__semicolon] = ACTIONS(211),
    [sym__raw_string_literal] = ACTIONS(1377),
    [sym__external_else] = ACTIONS(211),
    [sym__external_open_parenthesis] = ACTIONS(1379),
    [sym__external_close_parenthesis] = ACTIONS(2083),
    [sym__external_open_brace] = ACTIONS(1383),
    [sym__external_open_bracket] = ACTIONS(211),
    [sym__external_open_bracket2] = ACTIONS(211),
  },
  [149] = {
    [sym_function_definition] = STATE(912),
    [sym_if_statement] = STATE(912),
    [sym_for_statement] = STATE(912),
    [sym_while_statement] = STATE(912),
    [sym_repeat_statement] = STATE(912),
    [sym_braced_expression] = STATE(912),
    [sym_parenthesized_expression] = STATE(912),
    [sym_call] = STATE(912),
    [sym_subset] = STATE(912),
    [sym_subset2] = STATE(912),
    [sym_unary_operator] = STATE(912),
    [sym_binary_operator] = STATE(912),
    [sym_extract_operator] = STATE(912),
    [sym_namespace_operator] = STATE(912),
    [sym_integer] = STATE(912),
    [sym_complex] = STATE(912),
    [sym_float] = STATE(912),
    [sym__hex_literal] = STATE(2183),
    [sym__float_literal] = STATE(2183),
    [sym_string] = STATE(2169),
    [sym__single_quoted_string] = STATE(2181),
    [sym__double_quoted_string] = STATE(2180),
    [sym_na] = STATE(912),
    [sym__expression] = STATE(912),
    [sym__string_or_identifier] = STATE(5149),
    [sym__open_parenthesis] = STATE(67),
    [sym__open_brace] = STATE(24),
    [aux_sym_function_definition_repeat1] = STATE(156),
    [ts_builtin_sym_end] = ACTIONS(263),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_BSLASH] = ACTIONS(323),
    [anon_sym_function] = ACTIONS(325),
    [anon_sym_EQ] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(327),
    [anon_sym_for] = ACTIONS(329),
    [anon_sym_while] = ACTIONS(331),
    [anon_sym_repeat] = ACTIONS(333),
    [anon_sym_QMARK] = ACTIONS(335),
    [anon_sym_TILDE] = ACTIONS(337),
    [anon_sym_BANG] = ACTIONS(339),
    [anon_sym_PLUS] = ACTIONS(341),
    [anon_sym_DASH] = ACTIONS(343),
    [anon_sym_LT_DASH] = ACTIONS(263),
    [anon_sym_LT_LT_DASH] = ACTIONS(263),
    [anon_sym_COLON_EQ] = ACTIONS(263),
    [anon_sym_DASH_GT] = ACTIONS(265),
    [anon_sym_DASH_GT_GT] = ACTIONS(263),
    [anon_sym_PIPE] = ACTIONS(265),
    [anon_sym_AMP] = ACTIONS(265),
    [anon_sym_PIPE_PIPE] = ACTIONS(263),
    [anon_sym_AMP_AMP] = ACTIONS(263),
    [anon_sym_LT] = ACTIONS(265),
    [anon_sym_LT_EQ] = ACTIONS(263),
    [anon_sym_GT] = ACTIONS(265),
    [anon_sym_GT_EQ] = ACTIONS(263),
    [anon_sym_EQ_EQ] = ACTIONS(263),
    [anon_sym_BANG_EQ] = ACTIONS(263),
    [anon_sym_STAR] = ACTIONS(265),
    [anon_sym_SLASH] = ACTIONS(263),
    [anon_sym_STAR_STAR] = ACTIONS(263),
    [anon_sym_CARET] = ACTIONS(263),
    [aux_sym_binary_operator_token1] = ACTIONS(263),
    [anon_sym_PIPE_GT] = ACTIONS(263),
    [anon_sym_COLON] = ACTIONS(265),
    [anon_sym_DOLLAR] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(263),
    [aux_sym__hex_literal_token1] = ACTIONS(345),
    [sym__number_literal] = ACTIONS(347),
    [anon_sym_SQUOTE] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(351),
    [sym_return] = ACTIONS(2085),
    [sym_next] = ACTIONS(2085),
    [sym_break] = ACTIONS(2085),
    [sym_true] = ACTIONS(2085),
    [sym_false] = ACTIONS(2085),
    [sym_null] = ACTIONS(2085),
    [sym_inf] = ACTIONS(2085),
    [sym_nan] = ACTIONS(2085),
    [anon_sym_NA] = ACTIONS(355),
    [anon_sym_NA_integer_] = ACTIONS(355),
    [anon_sym_NA_real_] = ACTIONS(355),
    [anon_sym_NA_complex_] = ACTIONS(355),
    [anon_sym_NA_character_] = ACTIONS(355),
    [sym_dots] = ACTIONS(2085),
    [sym_dot_dot_i] = ACTIONS(2087),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(263),
    [sym__newline] = ACTIONS(2089),
    [sym__semicolon] = ACTIONS(263),
    [sym__raw_string_literal] = ACTIONS(361),
    [sym__external_open_parenthesis] = ACTIONS(363),
    [sym__external_close_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(365),
    [sym__external_close_brace] = ACTIONS(263),
    [sym__external_open_bracket] = ACTIONS(263),
    [sym__external_open_bracket2] = ACTIONS(263),
  },
  [150] = {
    [sym_function_definition] = STATE(1219),
    [sym_if_statement] = STATE(1219),
    [sym_for_statement] = STATE(1219),
    [sym_while_statement] = STATE(1219),
    [sym_repeat_statement] = STATE(1219),
    [sym_braced_expression] = STATE(1219),
    [sym_parenthesized_expression] = STATE(1219),
    [sym_call] = STATE(1219),
    [sym_subset] = STATE(1219),
    [sym_subset2] = STATE(1219),
    [sym_unary_operator] = STATE(1219),
    [sym_binary_operator] = STATE(1219),
    [sym_extract_operator] = STATE(1219),
    [sym_namespace_operator] = STATE(1219),
    [sym_integer] = STATE(1219),
    [sym_complex] = STATE(1219),
    [sym_float] = STATE(1219),
    [sym__hex_literal] = STATE(2356),
    [sym__float_literal] = STATE(2356),
    [sym_string] = STATE(2231),
    [sym__single_quoted_string] = STATE(2355),
    [sym__double_quoted_string] = STATE(2354),
    [sym_na] = STATE(1219),
    [sym__expression] = STATE(1219),
    [sym__string_or_identifier] = STATE(5156),
    [sym__open_parenthesis] = STATE(190),
    [sym__close_parenthesis] = STATE(2886),
    [sym__open_brace] = STATE(94),
    [aux_sym_parenthesized_expression_repeat1] = STATE(104),
    [ts_builtin_sym_end] = ACTIONS(129),
    [sym_identifier] = ACTIONS(1337),
    [anon_sym_BSLASH] = ACTIONS(1339),
    [anon_sym_function] = ACTIONS(1341),
    [anon_sym_EQ] = ACTIONS(109),
    [anon_sym_if] = ACTIONS(1343),
    [anon_sym_for] = ACTIONS(1345),
    [anon_sym_while] = ACTIONS(1347),
    [anon_sym_repeat] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_BANG] = ACTIONS(1355),
    [anon_sym_PLUS] = ACTIONS(1357),
    [anon_sym_DASH] = ACTIONS(1359),
    [anon_sym_LT_DASH] = ACTIONS(129),
    [anon_sym_LT_LT_DASH] = ACTIONS(129),
    [anon_sym_COLON_EQ] = ACTIONS(129),
    [anon_sym_DASH_GT] = ACTIONS(109),
    [anon_sym_DASH_GT_GT] = ACTIONS(129),
    [anon_sym_PIPE] = ACTIONS(109),
    [anon_sym_AMP] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_STAR_STAR] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [aux_sym_binary_operator_token1] = ACTIONS(129),
    [anon_sym_PIPE_GT] = ACTIONS(129),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(129),
    [anon_sym_AT] = ACTIONS(129),
    [aux_sym__hex_literal_token1] = ACTIONS(1361),
    [sym__number_literal] = ACTIONS(1363),
    [anon_sym_SQUOTE] = ACTIONS(1365),
    [anon_sym_DQUOTE] = ACTIONS(1367),
    [sym_return] = ACTIONS(1369),
    [sym_next] = ACTIONS(1369),
    [sym_break] = ACTIONS(1369),
    [sym_true] = ACTIONS(1369),
    [sym_false] = ACTIONS(1369),
    [sym_null] = ACTIONS(1369),
    [sym_inf] = ACTIONS(1369),
    [sym_nan] = ACTIONS(1369),
    [anon_sym_NA] = ACTIONS(1371),
    [anon_sym_NA_integer_] = ACTIONS(1371),
    [anon_sym_NA_real_] = ACTIONS(1371),
    [anon_sym_NA_complex_] = ACTIONS(1371),
    [anon_sym_NA_character_] = ACTIONS(1371),
    [sym_dots] = ACTIONS(1369),
    [sym_dot_dot_i] = ACTIONS(1373),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1375),
    [sym__semicolon] = ACTIONS(129),
    [sym__raw_string_literal] = ACTIONS(1377),
    [sym__external_else] = ACTIONS(129),
    [sym__external_open_parenthesis] = ACTIONS(1379),
    [sym__external_close_parenthesis] = ACTIONS(2091),
    [sym__external_open_brace] = ACTIONS(1383),
    [sym__external_open_bracket] = ACTIONS(129),
    [sym__external_open_bracket2] = ACTIONS(129),
  },
  [151] = {
    [sym_function_definition] = STATE(797),
    [sym_if_statement] = STATE(797),
    [sym_for_statement] = STATE(797),
    [sym_while_statement] = STATE(797),
    [sym_repeat_statement] = STATE(797),
    [sym_braced_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_call] = STATE(797),
    [sym_subset] = STATE(797),
    [sym_subset2] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_binary_operator] = STATE(797),
    [sym_extract_operator] = STATE(797),
    [sym_namespace_operator] = STATE(797),
    [sym_integer] = STATE(797),
    [sym_complex] = STATE(797),
    [sym_float] = STATE(797),
    [sym__hex_literal] = STATE(2206),
    [sym__float_literal] = STATE(2206),
    [sym_string] = STATE(2166),
    [sym__single_quoted_string] = STATE(2200),
    [sym__double_quoted_string] = STATE(2201),
    [sym_na] = STATE(797),
    [sym__expression] = STATE(797),
    [sym__string_or_identifier] = STATE(5154),
    [sym__open_parenthesis] = STATE(3),
    [sym__open_brace] = STATE(45),
    [aux_sym_function_definition_repeat1] = STATE(101),
    [sym_identifier] = ACTIONS(481),
    [anon_sym_BSLASH] = ACTIONS(483),
    [anon_sym_function] = ACTIONS(485),
    [anon_sym_EQ] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(487),
    [anon_sym_for] = ACTIONS(489),
    [anon_sym_while] = ACTIONS(491),
    [anon_sym_repeat] = ACTIONS(493),
    [anon_sym_QMARK] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(503),
    [anon_sym_LT_DASH] = ACTIONS(263),
    [anon_sym_LT_LT_DASH] = ACTIONS(263),
    [anon_sym_COLON_EQ] = ACTIONS(263),
    [anon_sym_DASH_GT] = ACTIONS(265),
    [anon_sym_DASH_GT_GT] = ACTIONS(263),
    [anon_sym_PIPE] = ACTIONS(265),
    [anon_sym_AMP] = ACTIONS(265),
    [anon_sym_PIPE_PIPE] = ACTIONS(263),
    [anon_sym_AMP_AMP] = ACTIONS(263),
    [anon_sym_LT] = ACTIONS(265),
    [anon_sym_LT_EQ] = ACTIONS(263),
    [anon_sym_GT] = ACTIONS(265),
    [anon_sym_GT_EQ] = ACTIONS(263),
    [anon_sym_EQ_EQ] = ACTIONS(263),
    [anon_sym_BANG_EQ] = ACTIONS(263),
    [anon_sym_STAR] = ACTIONS(265),
    [anon_sym_SLASH] = ACTIONS(263),
    [anon_sym_STAR_STAR] = ACTIONS(263),
    [anon_sym_CARET] = ACTIONS(263),
    [aux_sym_binary_operator_token1] = ACTIONS(263),
    [anon_sym_PIPE_GT] = ACTIONS(263),
    [anon_sym_COLON] = ACTIONS(265),
    [anon_sym_DOLLAR] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(263),
    [aux_sym__hex_literal_token1] = ACTIONS(505),
    [sym__number_literal] = ACTIONS(507),
    [anon_sym_SQUOTE] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(511),
    [sym_return] = ACTIONS(2093),
    [sym_next] = ACTIONS(2093),
    [sym_break] = ACTIONS(2093),
    [sym_true] = ACTIONS(2093),
    [sym_false] = ACTIONS(2093),
    [sym_null] = ACTIONS(2093),
    [sym_inf] = ACTIONS(2093),
    [sym_nan] = ACTIONS(2093),
    [anon_sym_NA] = ACTIONS(515),
    [anon_sym_NA_integer_] = ACTIONS(515),
    [anon_sym_NA_real_] = ACTIONS(515),
    [anon_sym_NA_complex_] = ACTIONS(515),
    [anon_sym_NA_character_] = ACTIONS(515),
    [sym_dots] = ACTIONS(2093),
    [sym_dot_dot_i] = ACTIONS(2095),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(263),
    [sym__newline] = ACTIONS(2097),
    [sym__semicolon] = ACTIONS(263),
    [sym__raw_string_literal] = ACTIONS(521),
    [sym__external_else] = ACTIONS(263),
    [sym__external_open_parenthesis] = ACTIONS(523),
    [sym__external_open_brace] = ACTIONS(525),
    [sym__external_close_brace] = ACTIONS(263),
    [sym__external_open_bracket] = ACTIONS(263),
    [sym__external_close_bracket] = ACTIONS(263),
    [sym__external_open_bracket2] = ACTIONS(263),
  },
  [152] = {
    [sym_function_definition] = STATE(802),
    [sym_if_statement] = STATE(802),
    [sym_for_statement] = STATE(802),
    [sym_while_statement] = STATE(802),
    [sym_repeat_statement] = STATE(802),
    [sym_braced_expression] = STATE(802),
    [sym_parenthesized_expression] = STATE(802),
    [sym_call] = STATE(802),
    [sym_subset] = STATE(802),
    [sym_subset2] = STATE(802),
    [sym_unary_operator] = STATE(802),
    [sym_binary_operator] = STATE(802),
    [sym_extract_operator] = STATE(802),
    [sym_namespace_operator] = STATE(802),
    [sym_integer] = STATE(802),
    [sym_complex] = STATE(802),
    [sym_float] = STATE(802),
    [sym__hex_literal] = STATE(2206),
    [sym__float_literal] = STATE(2206),
    [sym_string] = STATE(2166),
    [sym__single_quoted_string] = STATE(2200),
    [sym__double_quoted_string] = STATE(2201),
    [sym_na] = STATE(802),
    [sym__expression] = STATE(802),
    [sym__string_or_identifier] = STATE(5154),
    [sym__open_parenthesis] = STATE(3),
    [sym__open_brace] = STATE(45),
    [aux_sym_function_definition_repeat1] = STATE(157),
    [sym_identifier] = ACTIONS(481),
    [anon_sym_BSLASH] = ACTIONS(483),
    [anon_sym_function] = ACTIONS(485),
    [anon_sym_EQ] = ACTIONS(543),
    [anon_sym_if] = ACTIONS(487),
    [anon_sym_for] = ACTIONS(489),
    [anon_sym_while] = ACTIONS(491),
    [anon_sym_repeat] = ACTIONS(493),
    [anon_sym_QMARK] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(503),
    [anon_sym_LT_DASH] = ACTIONS(545),
    [anon_sym_LT_LT_DASH] = ACTIONS(545),
    [anon_sym_COLON_EQ] = ACTIONS(545),
    [anon_sym_DASH_GT] = ACTIONS(543),
    [anon_sym_DASH_GT_GT] = ACTIONS(545),
    [anon_sym_PIPE] = ACTIONS(543),
    [anon_sym_AMP] = ACTIONS(543),
    [anon_sym_PIPE_PIPE] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(543),
    [anon_sym_LT_EQ] = ACTIONS(545),
    [anon_sym_GT] = ACTIONS(543),
    [anon_sym_GT_EQ] = ACTIONS(545),
    [anon_sym_EQ_EQ] = ACTIONS(545),
    [anon_sym_BANG_EQ] = ACTIONS(545),
    [anon_sym_STAR] = ACTIONS(543),
    [anon_sym_SLASH] = ACTIONS(545),
    [anon_sym_STAR_STAR] = ACTIONS(545),
    [anon_sym_CARET] = ACTIONS(545),
    [aux_sym_binary_operator_token1] = ACTIONS(545),
    [anon_sym_PIPE_GT] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(543),
    [anon_sym_DOLLAR] = ACTIONS(545),
    [anon_sym_AT] = ACTIONS(545),
    [aux_sym__hex_literal_token1] = ACTIONS(505),
    [sym__number_literal] = ACTIONS(507),
    [anon_sym_SQUOTE] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(511),
    [sym_return] = ACTIONS(2099),
    [sym_next] = ACTIONS(2099),
    [sym_break] = ACTIONS(2099),
    [sym_true] = ACTIONS(2099),
    [sym_false] = ACTIONS(2099),
    [sym_null] = ACTIONS(2099),
    [sym_inf] = ACTIONS(2099),
    [sym_nan] = ACTIONS(2099),
    [anon_sym_NA] = ACTIONS(515),
    [anon_sym_NA_integer_] = ACTIONS(515),
    [anon_sym_NA_real_] = ACTIONS(515),
    [anon_sym_NA_complex_] = ACTIONS(515),
    [anon_sym_NA_character_] = ACTIONS(515),
    [sym_dots] = ACTIONS(2099),
    [sym_dot_dot_i] = ACTIONS(2101),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(545),
    [sym__newline] = ACTIONS(2103),
    [sym__semicolon] = ACTIONS(545),
    [sym__raw_string_literal] = ACTIONS(521),
    [sym__external_else] = ACTIONS(545),
    [sym__external_open_parenthesis] = ACTIONS(523),
    [sym__external_open_brace] = ACTIONS(525),
    [sym__external_close_brace] = ACTIONS(545),
    [sym__external_open_bracket] = ACTIONS(545),
    [sym__external_close_bracket] = ACTIONS(545),
    [sym__external_open_bracket2] = ACTIONS(545),
  },
  [153] = {
    [sym_function_definition] = STATE(790),
    [sym_if_statement] = STATE(790),
    [sym_for_statement] = STATE(790),
    [sym_while_statement] = STATE(790),
    [sym_repeat_statement] = STATE(790),
    [sym_braced_expression] = STATE(790),
    [sym_parenthesized_expression] = STATE(790),
    [sym_call] = STATE(790),
    [sym_subset] = STATE(790),
    [sym_subset2] = STATE(790),
    [sym_unary_operator] = STATE(790),
    [sym_binary_operator] = STATE(790),
    [sym_extract_operator] = STATE(790),
    [sym_namespace_operator] = STATE(790),
    [sym_integer] = STATE(790),
    [sym_complex] = STATE(790),
    [sym_float] = STATE(790),
    [sym__hex_literal] = STATE(2183),
    [sym__float_literal] = STATE(2183),
    [sym_string] = STATE(2169),
    [sym__single_quoted_string] = STATE(2181),
    [sym__double_quoted_string] = STATE(2180),
    [sym_na] = STATE(790),
    [sym__expression] = STATE(790),
    [sym__string_or_identifier] = STATE(5149),
    [sym__open_parenthesis] = STATE(67),
    [sym__open_brace] = STATE(24),
    [sym__close_brace] = STATE(4731),
    [aux_sym_braced_expression_repeat1] = STATE(142),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_BSLASH] = ACTIONS(323),
    [anon_sym_function] = ACTIONS(325),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(327),
    [anon_sym_for] = ACTIONS(329),
    [anon_sym_while] = ACTIONS(331),
    [anon_sym_repeat] = ACTIONS(333),
    [anon_sym_QMARK] = ACTIONS(335),
    [anon_sym_TILDE] = ACTIONS(337),
    [anon_sym_BANG] = ACTIONS(339),
    [anon_sym_PLUS] = ACTIONS(341),
    [anon_sym_DASH] = ACTIONS(343),
    [anon_sym_LT_DASH] = ACTIONS(155),
    [anon_sym_LT_LT_DASH] = ACTIONS(155),
    [anon_sym_COLON_EQ] = ACTIONS(155),
    [anon_sym_DASH_GT] = ACTIONS(157),
    [anon_sym_DASH_GT_GT] = ACTIONS(155),
    [anon_sym_PIPE] = ACTIONS(157),
    [anon_sym_AMP] = ACTIONS(157),
    [anon_sym_PIPE_PIPE] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(157),
    [anon_sym_LT_EQ] = ACTIONS(155),
    [anon_sym_GT] = ACTIONS(157),
    [anon_sym_GT_EQ] = ACTIONS(155),
    [anon_sym_EQ_EQ] = ACTIONS(155),
    [anon_sym_BANG_EQ] = ACTIONS(155),
    [anon_sym_STAR] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(155),
    [anon_sym_STAR_STAR] = ACTIONS(155),
    [anon_sym_CARET] = ACTIONS(155),
    [aux_sym_binary_operator_token1] = ACTIONS(155),
    [anon_sym_PIPE_GT] = ACTIONS(155),
    [anon_sym_COLON] = ACTIONS(157),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(155),
    [aux_sym__hex_literal_token1] = ACTIONS(345),
    [sym__number_literal] = ACTIONS(347),
    [anon_sym_SQUOTE] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(351),
    [sym_return] = ACTIONS(353),
    [sym_next] = ACTIONS(353),
    [sym_break] = ACTIONS(353),
    [sym_true] = ACTIONS(353),
    [sym_false] = ACTIONS(353),
    [sym_null] = ACTIONS(353),
    [sym_inf] = ACTIONS(353),
    [sym_nan] = ACTIONS(353),
    [anon_sym_NA] = ACTIONS(355),
    [anon_sym_NA_integer_] = ACTIONS(355),
    [anon_sym_NA_real_] = ACTIONS(355),
    [anon_sym_NA_complex_] = ACTIONS(355),
    [anon_sym_NA_character_] = ACTIONS(355),
    [sym_dots] = ACTIONS(353),
    [sym_dot_dot_i] = ACTIONS(357),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(155),
    [sym__newline] = ACTIONS(359),
    [sym__semicolon] = ACTIONS(359),
    [sym__raw_string_literal] = ACTIONS(361),
    [sym__external_open_parenthesis] = ACTIONS(363),
    [sym__external_close_parenthesis] = ACTIONS(155),
    [sym__external_open_brace] = ACTIONS(365),
    [sym__external_close_brace] = ACTIONS(2105),
    [sym__external_open_bracket] = ACTIONS(155),
    [sym__external_open_bracket2] = ACTIONS(155),
  },
  [154] = {
    [sym_function_definition] = STATE(790),
    [sym_if_statement] = STATE(790),
    [sym_for_statement] = STATE(790),
    [sym_while_statement] = STATE(790),
    [sym_repeat_statement] = STATE(790),
    [sym_braced_expression] = STATE(790),
    [sym_parenthesized_expression] = STATE(790),
    [sym_call] = STATE(790),
    [sym_subset] = STATE(790),
    [sym_subset2] = STATE(790),
    [sym_unary_operator] = STATE(790),
    [sym_binary_operator] = STATE(790),
    [sym_extract_operator] = STATE(790),
    [sym_namespace_operator] = STATE(790),
    [sym_integer] = STATE(790),
    [sym_complex] = STATE(790),
    [sym_float] = STATE(790),
    [sym__hex_literal] = STATE(2183),
    [sym__float_literal] = STATE(2183),
    [sym_string] = STATE(2169),
    [sym__single_quoted_string] = STATE(2181),
    [sym__double_quoted_string] = STATE(2180),
    [sym_na] = STATE(790),
    [sym__expression] = STATE(790),
    [sym__string_or_identifier] = STATE(5149),
    [sym__open_parenthesis] = STATE(67),
    [sym__open_brace] = STATE(24),
    [sym__close_brace] = STATE(2946),
    [aux_sym_braced_expression_repeat1] = STATE(107),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_BSLASH] = ACTIONS(323),
    [anon_sym_function] = ACTIONS(325),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(327),
    [anon_sym_for] = ACTIONS(329),
    [anon_sym_while] = ACTIONS(331),
    [anon_sym_repeat] = ACTIONS(333),
    [anon_sym_QMARK] = ACTIONS(335),
    [anon_sym_TILDE] = ACTIONS(337),
    [anon_sym_BANG] = ACTIONS(339),
    [anon_sym_PLUS] = ACTIONS(341),
    [anon_sym_DASH] = ACTIONS(343),
    [anon_sym_LT_DASH] = ACTIONS(155),
    [anon_sym_LT_LT_DASH] = ACTIONS(155),
    [anon_sym_COLON_EQ] = ACTIONS(155),
    [anon_sym_DASH_GT] = ACTIONS(157),
    [anon_sym_DASH_GT_GT] = ACTIONS(155),
    [anon_sym_PIPE] = ACTIONS(157),
    [anon_sym_AMP] = ACTIONS(157),
    [anon_sym_PIPE_PIPE] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(157),
    [anon_sym_LT_EQ] = ACTIONS(155),
    [anon_sym_GT] = ACTIONS(157),
    [anon_sym_GT_EQ] = ACTIONS(155),
    [anon_sym_EQ_EQ] = ACTIONS(155),
    [anon_sym_BANG_EQ] = ACTIONS(155),
    [anon_sym_STAR] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(155),
    [anon_sym_STAR_STAR] = ACTIONS(155),
    [anon_sym_CARET] = ACTIONS(155),
    [aux_sym_binary_operator_token1] = ACTIONS(155),
    [anon_sym_PIPE_GT] = ACTIONS(155),
    [anon_sym_COLON] = ACTIONS(157),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(155),
    [aux_sym__hex_literal_token1] = ACTIONS(345),
    [sym__number_literal] = ACTIONS(347),
    [anon_sym_SQUOTE] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(351),
    [sym_return] = ACTIONS(353),
    [sym_next] = ACTIONS(353),
    [sym_break] = ACTIONS(353),
    [sym_true] = ACTIONS(353),
    [sym_false] = ACTIONS(353),
    [sym_null] = ACTIONS(353),
    [sym_inf] = ACTIONS(353),
    [sym_nan] = ACTIONS(353),
    [anon_sym_NA] = ACTIONS(355),
    [anon_sym_NA_integer_] = ACTIONS(355),
    [anon_sym_NA_real_] = ACTIONS(355),
    [anon_sym_NA_complex_] = ACTIONS(355),
    [anon_sym_NA_character_] = ACTIONS(355),
    [sym_dots] = ACTIONS(353),
    [sym_dot_dot_i] = ACTIONS(357),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(155),
    [sym__newline] = ACTIONS(359),
    [sym__semicolon] = ACTIONS(359),
    [sym__raw_string_literal] = ACTIONS(361),
    [sym__external_open_parenthesis] = ACTIONS(363),
    [sym__external_close_parenthesis] = ACTIONS(155),
    [sym__external_open_brace] = ACTIONS(365),
    [sym__external_close_brace] = ACTIONS(2107),
    [sym__external_open_bracket] = ACTIONS(155),
    [sym__external_open_bracket2] = ACTIONS(155),
  },
  [155] = {
    [sym_function_definition] = STATE(907),
    [sym_if_statement] = STATE(907),
    [sym_for_statement] = STATE(907),
    [sym_while_statement] = STATE(907),
    [sym_repeat_statement] = STATE(907),
    [sym_braced_expression] = STATE(907),
    [sym_parenthesized_expression] = STATE(907),
    [sym_call] = STATE(907),
    [sym_subset] = STATE(907),
    [sym_subset2] = STATE(907),
    [sym_unary_operator] = STATE(907),
    [sym_binary_operator] = STATE(907),
    [sym_extract_operator] = STATE(907),
    [sym_namespace_operator] = STATE(907),
    [sym_integer] = STATE(907),
    [sym_complex] = STATE(907),
    [sym_float] = STATE(907),
    [sym__hex_literal] = STATE(2183),
    [sym__float_literal] = STATE(2183),
    [sym_string] = STATE(2169),
    [sym__single_quoted_string] = STATE(2181),
    [sym__double_quoted_string] = STATE(2180),
    [sym_na] = STATE(907),
    [sym__expression] = STATE(907),
    [sym__string_or_identifier] = STATE(5149),
    [sym__open_parenthesis] = STATE(67),
    [sym__open_brace] = STATE(24),
    [aux_sym_function_definition_repeat1] = STATE(100),
    [ts_builtin_sym_end] = ACTIONS(545),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_BSLASH] = ACTIONS(323),
    [anon_sym_function] = ACTIONS(325),
    [anon_sym_EQ] = ACTIONS(543),
    [anon_sym_if] = ACTIONS(327),
    [anon_sym_for] = ACTIONS(329),
    [anon_sym_while] = ACTIONS(331),
    [anon_sym_repeat] = ACTIONS(333),
    [anon_sym_QMARK] = ACTIONS(335),
    [anon_sym_TILDE] = ACTIONS(337),
    [anon_sym_BANG] = ACTIONS(339),
    [anon_sym_PLUS] = ACTIONS(341),
    [anon_sym_DASH] = ACTIONS(343),
    [anon_sym_LT_DASH] = ACTIONS(545),
    [anon_sym_LT_LT_DASH] = ACTIONS(545),
    [anon_sym_COLON_EQ] = ACTIONS(545),
    [anon_sym_DASH_GT] = ACTIONS(543),
    [anon_sym_DASH_GT_GT] = ACTIONS(545),
    [anon_sym_PIPE] = ACTIONS(543),
    [anon_sym_AMP] = ACTIONS(543),
    [anon_sym_PIPE_PIPE] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(543),
    [anon_sym_LT_EQ] = ACTIONS(545),
    [anon_sym_GT] = ACTIONS(543),
    [anon_sym_GT_EQ] = ACTIONS(545),
    [anon_sym_EQ_EQ] = ACTIONS(545),
    [anon_sym_BANG_EQ] = ACTIONS(545),
    [anon_sym_STAR] = ACTIONS(543),
    [anon_sym_SLASH] = ACTIONS(545),
    [anon_sym_STAR_STAR] = ACTIONS(545),
    [anon_sym_CARET] = ACTIONS(545),
    [aux_sym_binary_operator_token1] = ACTIONS(545),
    [anon_sym_PIPE_GT] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(543),
    [anon_sym_DOLLAR] = ACTIONS(545),
    [anon_sym_AT] = ACTIONS(545),
    [aux_sym__hex_literal_token1] = ACTIONS(345),
    [sym__number_literal] = ACTIONS(347),
    [anon_sym_SQUOTE] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(351),
    [sym_return] = ACTIONS(2109),
    [sym_next] = ACTIONS(2109),
    [sym_break] = ACTIONS(2109),
    [sym_true] = ACTIONS(2109),
    [sym_false] = ACTIONS(2109),
    [sym_null] = ACTIONS(2109),
    [sym_inf] = ACTIONS(2109),
    [sym_nan] = ACTIONS(2109),
    [anon_sym_NA] = ACTIONS(355),
    [anon_sym_NA_integer_] = ACTIONS(355),
    [anon_sym_NA_real_] = ACTIONS(355),
    [anon_sym_NA_complex_] = ACTIONS(355),
    [anon_sym_NA_character_] = ACTIONS(355),
    [sym_dots] = ACTIONS(2109),
    [sym_dot_dot_i] = ACTIONS(2111),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(545),
    [sym__newline] = ACTIONS(2113),
    [sym__semicolon] = ACTIONS(545),
    [sym__raw_string_literal] = ACTIONS(361),
    [sym__external_open_parenthesis] = ACTIONS(363),
    [sym__external_close_parenthesis] = ACTIONS(545),
    [sym__external_open_brace] = ACTIONS(365),
    [sym__external_close_brace] = ACTIONS(545),
    [sym__external_open_bracket] = ACTIONS(545),
    [sym__external_open_bracket2] = ACTIONS(545),
  },
  [156] = {
    [sym_function_definition] = STATE(906),
    [sym_if_statement] = STATE(906),
    [sym_for_statement] = STATE(906),
    [sym_while_statement] = STATE(906),
    [sym_repeat_statement] = STATE(906),
    [sym_braced_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(906),
    [sym_call] = STATE(906),
    [sym_subset] = STATE(906),
    [sym_subset2] = STATE(906),
    [sym_unary_operator] = STATE(906),
    [sym_binary_operator] = STATE(906),
    [sym_extract_operator] = STATE(906),
    [sym_namespace_operator] = STATE(906),
    [sym_integer] = STATE(906),
    [sym_complex] = STATE(906),
    [sym_float] = STATE(906),
    [sym__hex_literal] = STATE(2183),
    [sym__float_literal] = STATE(2183),
    [sym_string] = STATE(2169),
    [sym__single_quoted_string] = STATE(2181),
    [sym__double_quoted_string] = STATE(2180),
    [sym_na] = STATE(906),
    [sym__expression] = STATE(906),
    [sym__string_or_identifier] = STATE(5149),
    [sym__open_parenthesis] = STATE(67),
    [sym__open_brace] = STATE(24),
    [aux_sym_function_definition_repeat1] = STATE(2281),
    [ts_builtin_sym_end] = ACTIONS(765),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_BSLASH] = ACTIONS(323),
    [anon_sym_function] = ACTIONS(325),
    [anon_sym_EQ] = ACTIONS(767),
    [anon_sym_if] = ACTIONS(327),
    [anon_sym_for] = ACTIONS(329),
    [anon_sym_while] = ACTIONS(331),
    [anon_sym_repeat] = ACTIONS(333),
    [anon_sym_QMARK] = ACTIONS(335),
    [anon_sym_TILDE] = ACTIONS(337),
    [anon_sym_BANG] = ACTIONS(339),
    [anon_sym_PLUS] = ACTIONS(341),
    [anon_sym_DASH] = ACTIONS(343),
    [anon_sym_LT_DASH] = ACTIONS(765),
    [anon_sym_LT_LT_DASH] = ACTIONS(765),
    [anon_sym_COLON_EQ] = ACTIONS(765),
    [anon_sym_DASH_GT] = ACTIONS(767),
    [anon_sym_DASH_GT_GT] = ACTIONS(765),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_AMP] = ACTIONS(767),
    [anon_sym_PIPE_PIPE] = ACTIONS(765),
    [anon_sym_AMP_AMP] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(767),
    [anon_sym_LT_EQ] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_GT_EQ] = ACTIONS(765),
    [anon_sym_EQ_EQ] = ACTIONS(765),
    [anon_sym_BANG_EQ] = ACTIONS(765),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(765),
    [anon_sym_STAR_STAR] = ACTIONS(765),
    [anon_sym_CARET] = ACTIONS(765),
    [aux_sym_binary_operator_token1] = ACTIONS(765),
    [anon_sym_PIPE_GT] = ACTIONS(765),
    [anon_sym_COLON] = ACTIONS(767),
    [anon_sym_DOLLAR] = ACTIONS(765),
    [anon_sym_AT] = ACTIONS(765),
    [aux_sym__hex_literal_token1] = ACTIONS(345),
    [sym__number_literal] = ACTIONS(347),
    [anon_sym_SQUOTE] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(351),
    [sym_return] = ACTIONS(2115),
    [sym_next] = ACTIONS(2115),
    [sym_break] = ACTIONS(2115),
    [sym_true] = ACTIONS(2115),
    [sym_false] = ACTIONS(2115),
    [sym_null] = ACTIONS(2115),
    [sym_inf] = ACTIONS(2115),
    [sym_nan] = ACTIONS(2115),
    [anon_sym_NA] = ACTIONS(355),
    [anon_sym_NA_integer_] = ACTIONS(355),
    [anon_sym_NA_real_] = ACTIONS(355),
    [anon_sym_NA_complex_] = ACTIONS(355),
    [anon_sym_NA_character_] = ACTIONS(355),
    [sym_dots] = ACTIONS(2115),
    [sym_dot_dot_i] = ACTIONS(2117),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(765),
    [sym__newline] = ACTIONS(765),
    [sym__semicolon] = ACTIONS(765),
    [sym__raw_string_literal] = ACTIONS(361),
    [sym__external_open_parenthesis] = ACTIONS(363),
    [sym__external_close_parenthesis] = ACTIONS(765),
    [sym__external_open_brace] = ACTIONS(365),
    [sym__external_close_brace] = ACTIONS(765),
    [sym__external_open_bracket] = ACTIONS(765),
    [sym__external_open_bracket2] = ACTIONS(765),
  },
  [157] = {
    [sym_function_definition] = STATE(840),
    [sym_if_statement] = STATE(840),
    [sym_for_statement] = STATE(840),
    [sym_while_statement] = STATE(840),
    [sym_repeat_statement] = STATE(840),
    [sym_braced_expression] = STATE(840),
    [sym_parenthesized_expression] = STATE(840),
    [sym_call] = STATE(840),
    [sym_subset] = STATE(840),
    [sym_subset2] = STATE(840),
    [sym_unary_operator] = STATE(840),
    [sym_binary_operator] = STATE(840),
    [sym_extract_operator] = STATE(840),
    [sym_namespace_operator] = STATE(840),
    [sym_integer] = STATE(840),
    [sym_complex] = STATE(840),
    [sym_float] = STATE(840),
    [sym__hex_literal] = STATE(2206),
    [sym__float_literal] = STATE(2206),
    [sym_string] = STATE(2166),
    [sym__single_quoted_string] = STATE(2200),
    [sym__double_quoted_string] = STATE(2201),
    [sym_na] = STATE(840),
    [sym__expression] = STATE(840),
    [sym__string_or_identifier] = STATE(5154),
    [sym__open_parenthesis] = STATE(3),
    [sym__open_brace] = STATE(45),
    [aux_sym_function_definition_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(481),
    [anon_sym_BSLASH] = ACTIONS(483),
    [anon_sym_function] = ACTIONS(485),
    [anon_sym_EQ] = ACTIONS(759),
    [anon_sym_if] = ACTIONS(487),
    [anon_sym_for] = ACTIONS(489),
    [anon_sym_while] = ACTIONS(491),
    [anon_sym_repeat] = ACTIONS(493),
    [anon_sym_QMARK] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(503),
    [anon_sym_LT_DASH] = ACTIONS(757),
    [anon_sym_LT_LT_DASH] = ACTIONS(757),
    [anon_sym_COLON_EQ] = ACTIONS(757),
    [anon_sym_DASH_GT] = ACTIONS(759),
    [anon_sym_DASH_GT_GT] = ACTIONS(757),
    [anon_sym_PIPE] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(759),
    [anon_sym_PIPE_PIPE] = ACTIONS(757),
    [anon_sym_AMP_AMP] = ACTIONS(757),
    [anon_sym_LT] = ACTIONS(759),
    [anon_sym_LT_EQ] = ACTIONS(757),
    [anon_sym_GT] = ACTIONS(759),
    [anon_sym_GT_EQ] = ACTIONS(757),
    [anon_sym_EQ_EQ] = ACTIONS(757),
    [anon_sym_BANG_EQ] = ACTIONS(757),
    [anon_sym_STAR] = ACTIONS(759),
    [anon_sym_SLASH] = ACTIONS(757),
    [anon_sym_STAR_STAR] = ACTIONS(757),
    [anon_sym_CARET] = ACTIONS(757),
    [aux_sym_binary_operator_token1] = ACTIONS(757),
    [anon_sym_PIPE_GT] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(759),
    [anon_sym_DOLLAR] = ACTIONS(757),
    [anon_sym_AT] = ACTIONS(757),
    [aux_sym__hex_literal_token1] = ACTIONS(505),
    [sym__number_literal] = ACTIONS(507),
    [anon_sym_SQUOTE] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(511),
    [sym_return] = ACTIONS(2119),
    [sym_next] = ACTIONS(2119),
    [sym_break] = ACTIONS(2119),
    [sym_true] = ACTIONS(2119),
    [sym_false] = ACTIONS(2119),
    [sym_null] = ACTIONS(2119),
    [sym_inf] = ACTIONS(2119),
    [sym_nan] = ACTIONS(2119),
    [anon_sym_NA] = ACTIONS(515),
    [anon_sym_NA_integer_] = ACTIONS(515),
    [anon_sym_NA_real_] = ACTIONS(515),
    [anon_sym_NA_complex_] = ACTIONS(515),
    [anon_sym_NA_character_] = ACTIONS(515),
    [sym_dots] = ACTIONS(2119),
    [sym_dot_dot_i] = ACTIONS(2121),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(757),
    [sym__newline] = ACTIONS(757),
    [sym__semicolon] = ACTIONS(757),
    [sym__raw_string_literal] = ACTIONS(521),
    [sym__external_else] = ACTIONS(757),
    [sym__external_open_parenthesis] = ACTIONS(523),
    [sym__external_open_brace] = ACTIONS(525),
    [sym__external_close_brace] = ACTIONS(757),
    [sym__external_open_bracket] = ACTIONS(757),
    [sym__external_close_bracket] = ACTIONS(757),
    [sym__external_open_bracket2] = ACTIONS(757),
  },
  [158] = {
    [sym_function_definition] = STATE(876),
    [sym_if_statement] = STATE(876),
    [sym_for_statement] = STATE(876),
    [sym_while_statement] = STATE(876),
    [sym_repeat_statement] = STATE(876),
    [sym_braced_expression] = STATE(876),
    [sym_parenthesized_expression] = STATE(876),
    [sym_call] = STATE(876),
    [sym_subset] = STATE(876),
    [sym_subset2] = STATE(876),
    [sym_unary_operator] = STATE(876),
    [sym_binary_operator] = STATE(876),
    [sym_extract_operator] = STATE(876),
    [sym_namespace_operator] = STATE(876),
    [sym_integer] = STATE(876),
    [sym_complex] = STATE(876),
    [sym_float] = STATE(876),
    [sym__hex_literal] = STATE(2206),
    [sym__float_literal] = STATE(2206),
    [sym_string] = STATE(2166),
    [sym__single_quoted_string] = STATE(2200),
    [sym__double_quoted_string] = STATE(2201),
    [sym_na] = STATE(876),
    [sym__expression] = STATE(876),
    [sym__string_or_identifier] = STATE(5154),
    [sym__open_parenthesis] = STATE(3),
    [sym__open_brace] = STATE(45),
    [aux_sym_function_definition_repeat1] = STATE(160),
    [sym_identifier] = ACTIONS(481),
    [anon_sym_BSLASH] = ACTIONS(483),
    [anon_sym_function] = ACTIONS(485),
    [anon_sym_EQ] = ACTIONS(533),
    [anon_sym_if] = ACTIONS(487),
    [anon_sym_for] = ACTIONS(489),
    [anon_sym_while] = ACTIONS(491),
    [anon_sym_repeat] = ACTIONS(493),
    [anon_sym_QMARK] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(503),
    [anon_sym_LT_DASH] = ACTIONS(531),
    [anon_sym_LT_LT_DASH] = ACTIONS(531),
    [anon_sym_COLON_EQ] = ACTIONS(531),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_DASH_GT_GT] = ACTIONS(531),
    [anon_sym_PIPE] = ACTIONS(533),
    [anon_sym_AMP] = ACTIONS(533),
    [anon_sym_PIPE_PIPE] = ACTIONS(531),
    [anon_sym_AMP_AMP] = ACTIONS(531),
    [anon_sym_LT] = ACTIONS(533),
    [anon_sym_LT_EQ] = ACTIONS(531),
    [anon_sym_GT] = ACTIONS(533),
    [anon_sym_GT_EQ] = ACTIONS(531),
    [anon_sym_EQ_EQ] = ACTIONS(531),
    [anon_sym_BANG_EQ] = ACTIONS(531),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_SLASH] = ACTIONS(531),
    [anon_sym_STAR_STAR] = ACTIONS(531),
    [anon_sym_CARET] = ACTIONS(531),
    [aux_sym_binary_operator_token1] = ACTIONS(531),
    [anon_sym_PIPE_GT] = ACTIONS(531),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_DOLLAR] = ACTIONS(531),
    [anon_sym_AT] = ACTIONS(531),
    [aux_sym__hex_literal_token1] = ACTIONS(505),
    [sym__number_literal] = ACTIONS(507),
    [anon_sym_SQUOTE] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(511),
    [sym_return] = ACTIONS(2123),
    [sym_next] = ACTIONS(2123),
    [sym_break] = ACTIONS(2123),
    [sym_true] = ACTIONS(2123),
    [sym_false] = ACTIONS(2123),
    [sym_null] = ACTIONS(2123),
    [sym_inf] = ACTIONS(2123),
    [sym_nan] = ACTIONS(2123),
    [anon_sym_NA] = ACTIONS(515),
    [anon_sym_NA_integer_] = ACTIONS(515),
    [anon_sym_NA_real_] = ACTIONS(515),
    [anon_sym_NA_complex_] = ACTIONS(515),
    [anon_sym_NA_character_] = ACTIONS(515),
    [sym_dots] = ACTIONS(2123),
    [sym_dot_dot_i] = ACTIONS(2125),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(531),
    [sym__newline] = ACTIONS(2127),
    [sym__semicolon] = ACTIONS(531),
    [sym__raw_string_literal] = ACTIONS(521),
    [sym__external_else] = ACTIONS(531),
    [sym__external_open_parenthesis] = ACTIONS(523),
    [sym__external_open_brace] = ACTIONS(525),
    [sym__external_close_brace] = ACTIONS(531),
    [sym__external_open_bracket] = ACTIONS(531),
    [sym__external_close_bracket] = ACTIONS(531),
    [sym__external_open_bracket2] = ACTIONS(531),
  },
  [159] = {
    [sym_function_definition] = STATE(789),
    [sym_if_statement] = STATE(789),
    [sym_for_statement] = STATE(789),
    [sym_while_statement] = STATE(789),
    [sym_repeat_statement] = STATE(789),
    [sym_braced_expression] = STATE(789),
    [sym_parenthesized_expression] = STATE(789),
    [sym_call] = STATE(789),
    [sym_subset] = STATE(789),
    [sym_subset2] = STATE(789),
    [sym_unary_operator] = STATE(789),
    [sym_binary_operator] = STATE(789),
    [sym_extract_operator] = STATE(789),
    [sym_namespace_operator] = STATE(789),
    [sym_integer] = STATE(789),
    [sym_complex] = STATE(789),
    [sym_float] = STATE(789),
    [sym__hex_literal] = STATE(2210),
    [sym__float_literal] = STATE(2210),
    [sym_string] = STATE(2209),
    [sym__single_quoted_string] = STATE(2211),
    [sym__double_quoted_string] = STATE(2212),
    [sym_na] = STATE(789),
    [sym__expression] = STATE(789),
    [sym__string_or_identifier] = STATE(5127),
    [sym__open_parenthesis] = STATE(5),
    [sym__open_brace] = STATE(42),
    [aux_sym_braced_expression_repeat1] = STATE(159),
    [sym_identifier] = ACTIONS(2129),
    [anon_sym_BSLASH] = ACTIONS(2132),
    [anon_sym_function] = ACTIONS(2135),
    [anon_sym_EQ] = ACTIONS(562),
    [anon_sym_if] = ACTIONS(2138),
    [anon_sym_for] = ACTIONS(2141),
    [anon_sym_while] = ACTIONS(2144),
    [anon_sym_repeat] = ACTIONS(2147),
    [anon_sym_QMARK] = ACTIONS(2150),
    [anon_sym_TILDE] = ACTIONS(2153),
    [anon_sym_BANG] = ACTIONS(2156),
    [anon_sym_PLUS] = ACTIONS(2159),
    [anon_sym_DASH] = ACTIONS(2162),
    [anon_sym_LT_DASH] = ACTIONS(591),
    [anon_sym_LT_LT_DASH] = ACTIONS(591),
    [anon_sym_COLON_EQ] = ACTIONS(591),
    [anon_sym_DASH_GT] = ACTIONS(562),
    [anon_sym_DASH_GT_GT] = ACTIONS(591),
    [anon_sym_PIPE] = ACTIONS(562),
    [anon_sym_AMP] = ACTIONS(562),
    [anon_sym_PIPE_PIPE] = ACTIONS(591),
    [anon_sym_AMP_AMP] = ACTIONS(591),
    [anon_sym_LT] = ACTIONS(562),
    [anon_sym_LT_EQ] = ACTIONS(591),
    [anon_sym_GT] = ACTIONS(562),
    [anon_sym_GT_EQ] = ACTIONS(591),
    [anon_sym_EQ_EQ] = ACTIONS(591),
    [anon_sym_BANG_EQ] = ACTIONS(591),
    [anon_sym_STAR] = ACTIONS(562),
    [anon_sym_SLASH] = ACTIONS(591),
    [anon_sym_STAR_STAR] = ACTIONS(591),
    [anon_sym_CARET] = ACTIONS(591),
    [aux_sym_binary_operator_token1] = ACTIONS(591),
    [anon_sym_PIPE_GT] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(562),
    [anon_sym_DOLLAR] = ACTIONS(591),
    [anon_sym_AT] = ACTIONS(591),
    [aux_sym__hex_literal_token1] = ACTIONS(2165),
    [sym__number_literal] = ACTIONS(2168),
    [anon_sym_SQUOTE] = ACTIONS(2171),
    [anon_sym_DQUOTE] = ACTIONS(2174),
    [sym_return] = ACTIONS(2177),
    [sym_next] = ACTIONS(2177),
    [sym_break] = ACTIONS(2177),
    [sym_true] = ACTIONS(2177),
    [sym_false] = ACTIONS(2177),
    [sym_null] = ACTIONS(2177),
    [sym_inf] = ACTIONS(2177),
    [sym_nan] = ACTIONS(2177),
    [anon_sym_NA] = ACTIONS(2180),
    [anon_sym_NA_integer_] = ACTIONS(2180),
    [anon_sym_NA_real_] = ACTIONS(2180),
    [anon_sym_NA_complex_] = ACTIONS(2180),
    [anon_sym_NA_character_] = ACTIONS(2180),
    [sym_dots] = ACTIONS(2177),
    [sym_dot_dot_i] = ACTIONS(2183),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(591),
    [sym__newline] = ACTIONS(2186),
    [sym__semicolon] = ACTIONS(2186),
    [sym__raw_string_literal] = ACTIONS(2189),
    [sym__external_else] = ACTIONS(591),
    [sym__external_open_parenthesis] = ACTIONS(2192),
    [sym__external_open_brace] = ACTIONS(2195),
    [sym__external_close_brace] = ACTIONS(591),
    [sym__external_open_bracket] = ACTIONS(591),
    [sym__external_open_bracket2] = ACTIONS(591),
    [sym__external_close_bracket2] = ACTIONS(591),
  },
  [160] = {
    [sym_function_definition] = STATE(877),
    [sym_if_statement] = STATE(877),
    [sym_for_statement] = STATE(877),
    [sym_while_statement] = STATE(877),
    [sym_repeat_statement] = STATE(877),
    [sym_braced_expression] = STATE(877),
    [sym_parenthesized_expression] = STATE(877),
    [sym_call] = STATE(877),
    [sym_subset] = STATE(877),
    [sym_subset2] = STATE(877),
    [sym_unary_operator] = STATE(877),
    [sym_binary_operator] = STATE(877),
    [sym_extract_operator] = STATE(877),
    [sym_namespace_operator] = STATE(877),
    [sym_integer] = STATE(877),
    [sym_complex] = STATE(877),
    [sym_float] = STATE(877),
    [sym__hex_literal] = STATE(2206),
    [sym__float_literal] = STATE(2206),
    [sym_string] = STATE(2166),
    [sym__single_quoted_string] = STATE(2200),
    [sym__double_quoted_string] = STATE(2201),
    [sym_na] = STATE(877),
    [sym__expression] = STATE(877),
    [sym__string_or_identifier] = STATE(5154),
    [sym__open_parenthesis] = STATE(3),
    [sym__open_brace] = STATE(45),
    [aux_sym_function_definition_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(481),
    [anon_sym_BSLASH] = ACTIONS(483),
    [anon_sym_function] = ACTIONS(485),
    [anon_sym_EQ] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(487),
    [anon_sym_for] = ACTIONS(489),
    [anon_sym_while] = ACTIONS(491),
    [anon_sym_repeat] = ACTIONS(493),
    [anon_sym_QMARK] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(503),
    [anon_sym_LT_DASH] = ACTIONS(369),
    [anon_sym_LT_LT_DASH] = ACTIONS(369),
    [anon_sym_COLON_EQ] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(371),
    [anon_sym_DASH_GT_GT] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(371),
    [anon_sym_AMP] = ACTIONS(371),
    [anon_sym_PIPE_PIPE] = ACTIONS(369),
    [anon_sym_AMP_AMP] = ACTIONS(369),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_LT_EQ] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_EQ] = ACTIONS(369),
    [anon_sym_EQ_EQ] = ACTIONS(369),
    [anon_sym_BANG_EQ] = ACTIONS(369),
    [anon_sym_STAR] = ACTIONS(371),
    [anon_sym_SLASH] = ACTIONS(369),
    [anon_sym_STAR_STAR] = ACTIONS(369),
    [anon_sym_CARET] = ACTIONS(369),
    [aux_sym_binary_operator_token1] = ACTIONS(369),
    [anon_sym_PIPE_GT] = ACTIONS(369),
    [anon_sym_COLON] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(369),
    [anon_sym_AT] = ACTIONS(369),
    [aux_sym__hex_literal_token1] = ACTIONS(505),
    [sym__number_literal] = ACTIONS(507),
    [anon_sym_SQUOTE] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(511),
    [sym_return] = ACTIONS(2198),
    [sym_next] = ACTIONS(2198),
    [sym_break] = ACTIONS(2198),
    [sym_true] = ACTIONS(2198),
    [sym_false] = ACTIONS(2198),
    [sym_null] = ACTIONS(2198),
    [sym_inf] = ACTIONS(2198),
    [sym_nan] = ACTIONS(2198),
    [anon_sym_NA] = ACTIONS(515),
    [anon_sym_NA_integer_] = ACTIONS(515),
    [anon_sym_NA_real_] = ACTIONS(515),
    [anon_sym_NA_complex_] = ACTIONS(515),
    [anon_sym_NA_character_] = ACTIONS(515),
    [sym_dots] = ACTIONS(2198),
    [sym_dot_dot_i] = ACTIONS(2200),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(369),
    [sym__newline] = ACTIONS(369),
    [sym__semicolon] = ACTIONS(369),
    [sym__raw_string_literal] = ACTIONS(521),
    [sym__external_else] = ACTIONS(369),
    [sym__external_open_parenthesis] = ACTIONS(523),
    [sym__external_open_brace] = ACTIONS(525),
    [sym__external_close_brace] = ACTIONS(369),
    [sym__external_open_bracket] = ACTIONS(369),
    [sym__external_close_bracket] = ACTIONS(369),
    [sym__external_open_bracket2] = ACTIONS(369),
  },
  [161] = {
    [sym_function_definition] = STATE(878),
    [sym_if_statement] = STATE(878),
    [sym_for_statement] = STATE(878),
    [sym_while_statement] = STATE(878),
    [sym_repeat_statement] = STATE(878),
    [sym_braced_expression] = STATE(878),
    [sym_parenthesized_expression] = STATE(878),
    [sym_call] = STATE(878),
    [sym_subset] = STATE(878),
    [sym_subset2] = STATE(878),
    [sym_unary_operator] = STATE(878),
    [sym_binary_operator] = STATE(878),
    [sym_extract_operator] = STATE(878),
    [sym_namespace_operator] = STATE(878),
    [sym_integer] = STATE(878),
    [sym_complex] = STATE(878),
    [sym_float] = STATE(878),
    [sym__hex_literal] = STATE(2206),
    [sym__float_literal] = STATE(2206),
    [sym_string] = STATE(2166),
    [sym__single_quoted_string] = STATE(2200),
    [sym__double_quoted_string] = STATE(2201),
    [sym_na] = STATE(878),
    [sym__expression] = STATE(878),
    [sym__string_or_identifier] = STATE(5154),
    [sym__open_parenthesis] = STATE(3),
    [sym__open_brace] = STATE(45),
    [aux_sym_function_definition_repeat1] = STATE(164),
    [sym_identifier] = ACTIONS(481),
    [anon_sym_BSLASH] = ACTIONS(483),
    [anon_sym_function] = ACTIONS(485),
    [anon_sym_EQ] = ACTIONS(379),
    [anon_sym_if] = ACTIONS(487),
    [anon_sym_for] = ACTIONS(489),
    [anon_sym_while] = ACTIONS(491),
    [anon_sym_repeat] = ACTIONS(493),
    [anon_sym_QMARK] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(503),
    [anon_sym_LT_DASH] = ACTIONS(377),
    [anon_sym_LT_LT_DASH] = ACTIONS(377),
    [anon_sym_COLON_EQ] = ACTIONS(377),
    [anon_sym_DASH_GT] = ACTIONS(379),
    [anon_sym_DASH_GT_GT] = ACTIONS(377),
    [anon_sym_PIPE] = ACTIONS(379),
    [anon_sym_AMP] = ACTIONS(379),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_LT] = ACTIONS(379),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(379),
    [anon_sym_GT_EQ] = ACTIONS(377),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(379),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_STAR_STAR] = ACTIONS(377),
    [anon_sym_CARET] = ACTIONS(377),
    [aux_sym_binary_operator_token1] = ACTIONS(377),
    [anon_sym_PIPE_GT] = ACTIONS(377),
    [anon_sym_COLON] = ACTIONS(379),
    [anon_sym_DOLLAR] = ACTIONS(377),
    [anon_sym_AT] = ACTIONS(377),
    [aux_sym__hex_literal_token1] = ACTIONS(505),
    [sym__number_literal] = ACTIONS(507),
    [anon_sym_SQUOTE] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(511),
    [sym_return] = ACTIONS(2202),
    [sym_next] = ACTIONS(2202),
    [sym_break] = ACTIONS(2202),
    [sym_true] = ACTIONS(2202),
    [sym_false] = ACTIONS(2202),
    [sym_null] = ACTIONS(2202),
    [sym_inf] = ACTIONS(2202),
    [sym_nan] = ACTIONS(2202),
    [anon_sym_NA] = ACTIONS(515),
    [anon_sym_NA_integer_] = ACTIONS(515),
    [anon_sym_NA_real_] = ACTIONS(515),
    [anon_sym_NA_complex_] = ACTIONS(515),
    [anon_sym_NA_character_] = ACTIONS(515),
    [sym_dots] = ACTIONS(2202),
    [sym_dot_dot_i] = ACTIONS(2204),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(377),
    [sym__newline] = ACTIONS(2206),
    [sym__semicolon] = ACTIONS(377),
    [sym__raw_string_literal] = ACTIONS(521),
    [sym__external_else] = ACTIONS(377),
    [sym__external_open_parenthesis] = ACTIONS(523),
    [sym__external_open_brace] = ACTIONS(525),
    [sym__external_close_brace] = ACTIONS(377),
    [sym__external_open_bracket] = ACTIONS(377),
    [sym__external_close_bracket] = ACTIONS(377),
    [sym__external_open_bracket2] = ACTIONS(377),
  },
  [162] = {
    [sym_function_definition] = STATE(883),
    [sym_if_statement] = STATE(883),
    [sym_for_statement] = STATE(883),
    [sym_while_statement] = STATE(883),
    [sym_repeat_statement] = STATE(883),
    [sym_braced_expression] = STATE(883),
    [sym_parenthesized_expression] = STATE(883),
    [sym_call] = STATE(883),
    [sym_subset] = STATE(883),
    [sym_subset2] = STATE(883),
    [sym_unary_operator] = STATE(883),
    [sym_binary_operator] = STATE(883),
    [sym_extract_operator] = STATE(883),
    [sym_namespace_operator] = STATE(883),
    [sym_integer] = STATE(883),
    [sym_complex] = STATE(883),
    [sym_float] = STATE(883),
    [sym__hex_literal] = STATE(2206),
    [sym__float_literal] = STATE(2206),
    [sym_string] = STATE(2166),
    [sym__single_quoted_string] = STATE(2200),
    [sym__double_quoted_string] = STATE(2201),
    [sym_na] = STATE(883),
    [sym__expression] = STATE(883),
    [sym__string_or_identifier] = STATE(5154),
    [sym__open_parenthesis] = STATE(3),
    [sym__open_brace] = STATE(45),
    [aux_sym_function_definition_repeat1] = STATE(167),
    [sym_identifier] = ACTIONS(481),
    [anon_sym_BSLASH] = ACTIONS(483),
    [anon_sym_function] = ACTIONS(485),
    [anon_sym_EQ] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(487),
    [anon_sym_for] = ACTIONS(489),
    [anon_sym_while] = ACTIONS(491),
    [anon_sym_repeat] = ACTIONS(493),
    [anon_sym_QMARK] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(503),
    [anon_sym_LT_DASH] = ACTIONS(387),
    [anon_sym_LT_LT_DASH] = ACTIONS(387),
    [anon_sym_COLON_EQ] = ACTIONS(387),
    [anon_sym_DASH_GT] = ACTIONS(389),
    [anon_sym_DASH_GT_GT] = ACTIONS(387),
    [anon_sym_PIPE] = ACTIONS(389),
    [anon_sym_AMP] = ACTIONS(389),
    [anon_sym_PIPE_PIPE] = ACTIONS(387),
    [anon_sym_AMP_AMP] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(389),
    [anon_sym_LT_EQ] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(389),
    [anon_sym_GT_EQ] = ACTIONS(387),
    [anon_sym_EQ_EQ] = ACTIONS(387),
    [anon_sym_BANG_EQ] = ACTIONS(387),
    [anon_sym_STAR] = ACTIONS(389),
    [anon_sym_SLASH] = ACTIONS(387),
    [anon_sym_STAR_STAR] = ACTIONS(387),
    [anon_sym_CARET] = ACTIONS(387),
    [aux_sym_binary_operator_token1] = ACTIONS(387),
    [anon_sym_PIPE_GT] = ACTIONS(387),
    [anon_sym_COLON] = ACTIONS(389),
    [anon_sym_DOLLAR] = ACTIONS(387),
    [anon_sym_AT] = ACTIONS(387),
    [aux_sym__hex_literal_token1] = ACTIONS(505),
    [sym__number_literal] = ACTIONS(507),
    [anon_sym_SQUOTE] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(511),
    [sym_return] = ACTIONS(2208),
    [sym_next] = ACTIONS(2208),
    [sym_break] = ACTIONS(2208),
    [sym_true] = ACTIONS(2208),
    [sym_false] = ACTIONS(2208),
    [sym_null] = ACTIONS(2208),
    [sym_inf] = ACTIONS(2208),
    [sym_nan] = ACTIONS(2208),
    [anon_sym_NA] = ACTIONS(515),
    [anon_sym_NA_integer_] = ACTIONS(515),
    [anon_sym_NA_real_] = ACTIONS(515),
    [anon_sym_NA_complex_] = ACTIONS(515),
    [anon_sym_NA_character_] = ACTIONS(515),
    [sym_dots] = ACTIONS(2208),
    [sym_dot_dot_i] = ACTIONS(2210),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(387),
    [sym__newline] = ACTIONS(2212),
    [sym__semicolon] = ACTIONS(387),
    [sym__raw_string_literal] = ACTIONS(521),
    [sym__external_else] = ACTIONS(387),
    [sym__external_open_parenthesis] = ACTIONS(523),
    [sym__external_open_brace] = ACTIONS(525),
    [sym__external_close_brace] = ACTIONS(387),
    [sym__external_open_bracket] = ACTIONS(387),
    [sym__external_close_bracket] = ACTIONS(387),
    [sym__external_open_bracket2] = ACTIONS(387),
  },
  [163] = {
    [sym_function_definition] = STATE(839),
    [sym_if_statement] = STATE(839),
    [sym_for_statement] = STATE(839),
    [sym_while_statement] = STATE(839),
    [sym_repeat_statement] = STATE(839),
    [sym_braced_expression] = STATE(839),
    [sym_parenthesized_expression] = STATE(839),
    [sym_call] = STATE(839),
    [sym_subset] = STATE(839),
    [sym_subset2] = STATE(839),
    [sym_unary_operator] = STATE(839),
    [sym_binary_operator] = STATE(839),
    [sym_extract_operator] = STATE(839),
    [sym_namespace_operator] = STATE(839),
    [sym_integer] = STATE(839),
    [sym_complex] = STATE(839),
    [sym_float] = STATE(839),
    [sym__hex_literal] = STATE(2183),
    [sym__float_literal] = STATE(2183),
    [sym_string] = STATE(2169),
    [sym__single_quoted_string] = STATE(2181),
    [sym__double_quoted_string] = STATE(2180),
    [sym_na] = STATE(839),
    [sym__expression] = STATE(839),
    [sym__string_or_identifier] = STATE(5149),
    [sym__open_parenthesis] = STATE(67),
    [sym__open_brace] = STATE(24),
    [aux_sym_function_definition_repeat1] = STATE(165),
    [ts_builtin_sym_end] = ACTIONS(531),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_BSLASH] = ACTIONS(323),
    [anon_sym_function] = ACTIONS(325),
    [anon_sym_EQ] = ACTIONS(533),
    [anon_sym_if] = ACTIONS(327),
    [anon_sym_for] = ACTIONS(329),
    [anon_sym_while] = ACTIONS(331),
    [anon_sym_repeat] = ACTIONS(333),
    [anon_sym_QMARK] = ACTIONS(335),
    [anon_sym_TILDE] = ACTIONS(337),
    [anon_sym_BANG] = ACTIONS(339),
    [anon_sym_PLUS] = ACTIONS(341),
    [anon_sym_DASH] = ACTIONS(343),
    [anon_sym_LT_DASH] = ACTIONS(531),
    [anon_sym_LT_LT_DASH] = ACTIONS(531),
    [anon_sym_COLON_EQ] = ACTIONS(531),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_DASH_GT_GT] = ACTIONS(531),
    [anon_sym_PIPE] = ACTIONS(533),
    [anon_sym_AMP] = ACTIONS(533),
    [anon_sym_PIPE_PIPE] = ACTIONS(531),
    [anon_sym_AMP_AMP] = ACTIONS(531),
    [anon_sym_LT] = ACTIONS(533),
    [anon_sym_LT_EQ] = ACTIONS(531),
    [anon_sym_GT] = ACTIONS(533),
    [anon_sym_GT_EQ] = ACTIONS(531),
    [anon_sym_EQ_EQ] = ACTIONS(531),
    [anon_sym_BANG_EQ] = ACTIONS(531),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_SLASH] = ACTIONS(531),
    [anon_sym_STAR_STAR] = ACTIONS(531),
    [anon_sym_CARET] = ACTIONS(531),
    [aux_sym_binary_operator_token1] = ACTIONS(531),
    [anon_sym_PIPE_GT] = ACTIONS(531),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_DOLLAR] = ACTIONS(531),
    [anon_sym_AT] = ACTIONS(531),
    [aux_sym__hex_literal_token1] = ACTIONS(345),
    [sym__number_literal] = ACTIONS(347),
    [anon_sym_SQUOTE] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(351),
    [sym_return] = ACTIONS(2214),
    [sym_next] = ACTIONS(2214),
    [sym_break] = ACTIONS(2214),
    [sym_true] = ACTIONS(2214),
    [sym_false] = ACTIONS(2214),
    [sym_null] = ACTIONS(2214),
    [sym_inf] = ACTIONS(2214),
    [sym_nan] = ACTIONS(2214),
    [anon_sym_NA] = ACTIONS(355),
    [anon_sym_NA_integer_] = ACTIONS(355),
    [anon_sym_NA_real_] = ACTIONS(355),
    [anon_sym_NA_complex_] = ACTIONS(355),
    [anon_sym_NA_character_] = ACTIONS(355),
    [sym_dots] = ACTIONS(2214),
    [sym_dot_dot_i] = ACTIONS(2216),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(531),
    [sym__newline] = ACTIONS(2218),
    [sym__semicolon] = ACTIONS(531),
    [sym__raw_string_literal] = ACTIONS(361),
    [sym__external_open_parenthesis] = ACTIONS(363),
    [sym__external_close_parenthesis] = ACTIONS(531),
    [sym__external_open_brace] = ACTIONS(365),
    [sym__external_close_brace] = ACTIONS(531),
    [sym__external_open_bracket] = ACTIONS(531),
    [sym__external_open_bracket2] = ACTIONS(531),
  },
  [164] = {
    [sym_function_definition] = STATE(886),
    [sym_if_statement] = STATE(886),
    [sym_for_statement] = STATE(886),
    [sym_while_statement] = STATE(886),
    [sym_repeat_statement] = STATE(886),
    [sym_braced_expression] = STATE(886),
    [sym_parenthesized_expression] = STATE(886),
    [sym_call] = STATE(886),
    [sym_subset] = STATE(886),
    [sym_subset2] = STATE(886),
    [sym_unary_operator] = STATE(886),
    [sym_binary_operator] = STATE(886),
    [sym_extract_operator] = STATE(886),
    [sym_namespace_operator] = STATE(886),
    [sym_integer] = STATE(886),
    [sym_complex] = STATE(886),
    [sym_float] = STATE(886),
    [sym__hex_literal] = STATE(2206),
    [sym__float_literal] = STATE(2206),
    [sym_string] = STATE(2166),
    [sym__single_quoted_string] = STATE(2200),
    [sym__double_quoted_string] = STATE(2201),
    [sym_na] = STATE(886),
    [sym__expression] = STATE(886),
    [sym__string_or_identifier] = STATE(5154),
    [sym__open_parenthesis] = STATE(3),
    [sym__open_brace] = STATE(45),
    [aux_sym_function_definition_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(481),
    [anon_sym_BSLASH] = ACTIONS(483),
    [anon_sym_function] = ACTIONS(485),
    [anon_sym_EQ] = ACTIONS(399),
    [anon_sym_if] = ACTIONS(487),
    [anon_sym_for] = ACTIONS(489),
    [anon_sym_while] = ACTIONS(491),
    [anon_sym_repeat] = ACTIONS(493),
    [anon_sym_QMARK] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(503),
    [anon_sym_LT_DASH] = ACTIONS(397),
    [anon_sym_LT_LT_DASH] = ACTIONS(397),
    [anon_sym_COLON_EQ] = ACTIONS(397),
    [anon_sym_DASH_GT] = ACTIONS(399),
    [anon_sym_DASH_GT_GT] = ACTIONS(397),
    [anon_sym_PIPE] = ACTIONS(399),
    [anon_sym_AMP] = ACTIONS(399),
    [anon_sym_PIPE_PIPE] = ACTIONS(397),
    [anon_sym_AMP_AMP] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(399),
    [anon_sym_LT_EQ] = ACTIONS(397),
    [anon_sym_GT] = ACTIONS(399),
    [anon_sym_GT_EQ] = ACTIONS(397),
    [anon_sym_EQ_EQ] = ACTIONS(397),
    [anon_sym_BANG_EQ] = ACTIONS(397),
    [anon_sym_STAR] = ACTIONS(399),
    [anon_sym_SLASH] = ACTIONS(397),
    [anon_sym_STAR_STAR] = ACTIONS(397),
    [anon_sym_CARET] = ACTIONS(397),
    [aux_sym_binary_operator_token1] = ACTIONS(397),
    [anon_sym_PIPE_GT] = ACTIONS(397),
    [anon_sym_COLON] = ACTIONS(399),
    [anon_sym_DOLLAR] = ACTIONS(397),
    [anon_sym_AT] = ACTIONS(397),
    [aux_sym__hex_literal_token1] = ACTIONS(505),
    [sym__number_literal] = ACTIONS(507),
    [anon_sym_SQUOTE] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(511),
    [sym_return] = ACTIONS(2220),
    [sym_next] = ACTIONS(2220),
    [sym_break] = ACTIONS(2220),
    [sym_true] = ACTIONS(2220),
    [sym_false] = ACTIONS(2220),
    [sym_null] = ACTIONS(2220),
    [sym_inf] = ACTIONS(2220),
    [sym_nan] = ACTIONS(2220),
    [anon_sym_NA] = ACTIONS(515),
    [anon_sym_NA_integer_] = ACTIONS(515),
    [anon_sym_NA_real_] = ACTIONS(515),
    [anon_sym_NA_complex_] = ACTIONS(515),
    [anon_sym_NA_character_] = ACTIONS(515),
    [sym_dots] = ACTIONS(2220),
    [sym_dot_dot_i] = ACTIONS(2222),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(397),
    [sym__newline] = ACTIONS(397),
    [sym__semicolon] = ACTIONS(397),
    [sym__raw_string_literal] = ACTIONS(521),
    [sym__external_else] = ACTIONS(397),
    [sym__external_open_parenthesis] = ACTIONS(523),
    [sym__external_open_brace] = ACTIONS(525),
    [sym__external_close_brace] = ACTIONS(397),
    [sym__external_open_bracket] = ACTIONS(397),
    [sym__external_close_bracket] = ACTIONS(397),
    [sym__external_open_bracket2] = ACTIONS(397),
  },
  [165] = {
    [sym_function_definition] = STATE(834),
    [sym_if_statement] = STATE(834),
    [sym_for_statement] = STATE(834),
    [sym_while_statement] = STATE(834),
    [sym_repeat_statement] = STATE(834),
    [sym_braced_expression] = STATE(834),
    [sym_parenthesized_expression] = STATE(834),
    [sym_call] = STATE(834),
    [sym_subset] = STATE(834),
    [sym_subset2] = STATE(834),
    [sym_unary_operator] = STATE(834),
    [sym_binary_operator] = STATE(834),
    [sym_extract_operator] = STATE(834),
    [sym_namespace_operator] = STATE(834),
    [sym_integer] = STATE(834),
    [sym_complex] = STATE(834),
    [sym_float] = STATE(834),
    [sym__hex_literal] = STATE(2183),
    [sym__float_literal] = STATE(2183),
    [sym_string] = STATE(2169),
    [sym__single_quoted_string] = STATE(2181),
    [sym__double_quoted_string] = STATE(2180),
    [sym_na] = STATE(834),
    [sym__expression] = STATE(834),
    [sym__string_or_identifier] = STATE(5149),
    [sym__open_parenthesis] = STATE(67),
    [sym__open_brace] = STATE(24),
    [aux_sym_function_definition_repeat1] = STATE(2281),
    [ts_builtin_sym_end] = ACTIONS(369),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_BSLASH] = ACTIONS(323),
    [anon_sym_function] = ACTIONS(325),
    [anon_sym_EQ] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(327),
    [anon_sym_for] = ACTIONS(329),
    [anon_sym_while] = ACTIONS(331),
    [anon_sym_repeat] = ACTIONS(333),
    [anon_sym_QMARK] = ACTIONS(335),
    [anon_sym_TILDE] = ACTIONS(337),
    [anon_sym_BANG] = ACTIONS(339),
    [anon_sym_PLUS] = ACTIONS(341),
    [anon_sym_DASH] = ACTIONS(343),
    [anon_sym_LT_DASH] = ACTIONS(369),
    [anon_sym_LT_LT_DASH] = ACTIONS(369),
    [anon_sym_COLON_EQ] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(371),
    [anon_sym_DASH_GT_GT] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(371),
    [anon_sym_AMP] = ACTIONS(371),
    [anon_sym_PIPE_PIPE] = ACTIONS(369),
    [anon_sym_AMP_AMP] = ACTIONS(369),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_LT_EQ] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_EQ] = ACTIONS(369),
    [anon_sym_EQ_EQ] = ACTIONS(369),
    [anon_sym_BANG_EQ] = ACTIONS(369),
    [anon_sym_STAR] = ACTIONS(371),
    [anon_sym_SLASH] = ACTIONS(369),
    [anon_sym_STAR_STAR] = ACTIONS(369),
    [anon_sym_CARET] = ACTIONS(369),
    [aux_sym_binary_operator_token1] = ACTIONS(369),
    [anon_sym_PIPE_GT] = ACTIONS(369),
    [anon_sym_COLON] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(369),
    [anon_sym_AT] = ACTIONS(369),
    [aux_sym__hex_literal_token1] = ACTIONS(345),
    [sym__number_literal] = ACTIONS(347),
    [anon_sym_SQUOTE] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(351),
    [sym_return] = ACTIONS(2224),
    [sym_next] = ACTIONS(2224),
    [sym_break] = ACTIONS(2224),
    [sym_true] = ACTIONS(2224),
    [sym_false] = ACTIONS(2224),
    [sym_null] = ACTIONS(2224),
    [sym_inf] = ACTIONS(2224),
    [sym_nan] = ACTIONS(2224),
    [anon_sym_NA] = ACTIONS(355),
    [anon_sym_NA_integer_] = ACTIONS(355),
    [anon_sym_NA_real_] = ACTIONS(355),
    [anon_sym_NA_complex_] = ACTIONS(355),
    [anon_sym_NA_character_] = ACTIONS(355),
    [sym_dots] = ACTIONS(2224),
    [sym_dot_dot_i] = ACTIONS(2226),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(369),
    [sym__newline] = ACTIONS(369),
    [sym__semicolon] = ACTIONS(369),
    [sym__raw_string_literal] = ACTIONS(361),
    [sym__external_open_parenthesis] = ACTIONS(363),
    [sym__external_close_parenthesis] = ACTIONS(369),
    [sym__external_open_brace] = ACTIONS(365),
    [sym__external_close_brace] = ACTIONS(369),
    [sym__external_open_bracket] = ACTIONS(369),
    [sym__external_open_bracket2] = ACTIONS(369),
  },
  [166] = {
    [sym_function_definition] = STATE(833),
    [sym_if_statement] = STATE(833),
    [sym_for_statement] = STATE(833),
    [sym_while_statement] = STATE(833),
    [sym_repeat_statement] = STATE(833),
    [sym_braced_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_call] = STATE(833),
    [sym_subset] = STATE(833),
    [sym_subset2] = STATE(833),
    [sym_unary_operator] = STATE(833),
    [sym_binary_operator] = STATE(833),
    [sym_extract_operator] = STATE(833),
    [sym_namespace_operator] = STATE(833),
    [sym_integer] = STATE(833),
    [sym_complex] = STATE(833),
    [sym_float] = STATE(833),
    [sym__hex_literal] = STATE(2183),
    [sym__float_literal] = STATE(2183),
    [sym_string] = STATE(2169),
    [sym__single_quoted_string] = STATE(2181),
    [sym__double_quoted_string] = STATE(2180),
    [sym_na] = STATE(833),
    [sym__expression] = STATE(833),
    [sym__string_or_identifier] = STATE(5149),
    [sym__open_parenthesis] = STATE(67),
    [sym__open_brace] = STATE(24),
    [aux_sym_function_definition_repeat1] = STATE(172),
    [ts_builtin_sym_end] = ACTIONS(377),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_BSLASH] = ACTIONS(323),
    [anon_sym_function] = ACTIONS(325),
    [anon_sym_EQ] = ACTIONS(379),
    [anon_sym_if] = ACTIONS(327),
    [anon_sym_for] = ACTIONS(329),
    [anon_sym_while] = ACTIONS(331),
    [anon_sym_repeat] = ACTIONS(333),
    [anon_sym_QMARK] = ACTIONS(335),
    [anon_sym_TILDE] = ACTIONS(337),
    [anon_sym_BANG] = ACTIONS(339),
    [anon_sym_PLUS] = ACTIONS(341),
    [anon_sym_DASH] = ACTIONS(343),
    [anon_sym_LT_DASH] = ACTIONS(377),
    [anon_sym_LT_LT_DASH] = ACTIONS(377),
    [anon_sym_COLON_EQ] = ACTIONS(377),
    [anon_sym_DASH_GT] = ACTIONS(379),
    [anon_sym_DASH_GT_GT] = ACTIONS(377),
    [anon_sym_PIPE] = ACTIONS(379),
    [anon_sym_AMP] = ACTIONS(379),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_LT] = ACTIONS(379),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(379),
    [anon_sym_GT_EQ] = ACTIONS(377),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(379),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_STAR_STAR] = ACTIONS(377),
    [anon_sym_CARET] = ACTIONS(377),
    [aux_sym_binary_operator_token1] = ACTIONS(377),
    [anon_sym_PIPE_GT] = ACTIONS(377),
    [anon_sym_COLON] = ACTIONS(379),
    [anon_sym_DOLLAR] = ACTIONS(377),
    [anon_sym_AT] = ACTIONS(377),
    [aux_sym__hex_literal_token1] = ACTIONS(345),
    [sym__number_literal] = ACTIONS(347),
    [anon_sym_SQUOTE] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(351),
    [sym_return] = ACTIONS(2228),
    [sym_next] = ACTIONS(2228),
    [sym_break] = ACTIONS(2228),
    [sym_true] = ACTIONS(2228),
    [sym_false] = ACTIONS(2228),
    [sym_null] = ACTIONS(2228),
    [sym_inf] = ACTIONS(2228),
    [sym_nan] = ACTIONS(2228),
    [anon_sym_NA] = ACTIONS(355),
    [anon_sym_NA_integer_] = ACTIONS(355),
    [anon_sym_NA_real_] = ACTIONS(355),
    [anon_sym_NA_complex_] = ACTIONS(355),
    [anon_sym_NA_character_] = ACTIONS(355),
    [sym_dots] = ACTIONS(2228),
    [sym_dot_dot_i] = ACTIONS(2230),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(377),
    [sym__newline] = ACTIONS(2232),
    [sym__semicolon] = ACTIONS(377),
    [sym__raw_string_literal] = ACTIONS(361),
    [sym__external_open_parenthesis] = ACTIONS(363),
    [sym__external_close_parenthesis] = ACTIONS(377),
    [sym__external_open_brace] = ACTIONS(365),
    [sym__external_close_brace] = ACTIONS(377),
    [sym__external_open_bracket] = ACTIONS(377),
    [sym__external_open_bracket2] = ACTIONS(377),
  },
  [167] = {
    [sym_function_definition] = STATE(892),
    [sym_if_statement] = STATE(892),
    [sym_for_statement] = STATE(892),
    [sym_while_statement] = STATE(892),
    [sym_repeat_statement] = STATE(892),
    [sym_braced_expression] = STATE(892),
    [sym_parenthesized_expression] = STATE(892),
    [sym_call] = STATE(892),
    [sym_subset] = STATE(892),
    [sym_subset2] = STATE(892),
    [sym_unary_operator] = STATE(892),
    [sym_binary_operator] = STATE(892),
    [sym_extract_operator] = STATE(892),
    [sym_namespace_operator] = STATE(892),
    [sym_integer] = STATE(892),
    [sym_complex] = STATE(892),
    [sym_float] = STATE(892),
    [sym__hex_literal] = STATE(2206),
    [sym__float_literal] = STATE(2206),
    [sym_string] = STATE(2166),
    [sym__single_quoted_string] = STATE(2200),
    [sym__double_quoted_string] = STATE(2201),
    [sym_na] = STATE(892),
    [sym__expression] = STATE(892),
    [sym__string_or_identifier] = STATE(5154),
    [sym__open_parenthesis] = STATE(3),
    [sym__open_brace] = STATE(45),
    [aux_sym_function_definition_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(481),
    [anon_sym_BSLASH] = ACTIONS(483),
    [anon_sym_function] = ACTIONS(485),
    [anon_sym_EQ] = ACTIONS(455),
    [anon_sym_if] = ACTIONS(487),
    [anon_sym_for] = ACTIONS(489),
    [anon_sym_while] = ACTIONS(491),
    [anon_sym_repeat] = ACTIONS(493),
    [anon_sym_QMARK] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(503),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [anon_sym_LT_LT_DASH] = ACTIONS(453),
    [anon_sym_COLON_EQ] = ACTIONS(453),
    [anon_sym_DASH_GT] = ACTIONS(455),
    [anon_sym_DASH_GT_GT] = ACTIONS(453),
    [anon_sym_PIPE] = ACTIONS(455),
    [anon_sym_AMP] = ACTIONS(455),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(455),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_GT] = ACTIONS(455),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(453),
    [anon_sym_STAR] = ACTIONS(455),
    [anon_sym_SLASH] = ACTIONS(453),
    [anon_sym_STAR_STAR] = ACTIONS(453),
    [anon_sym_CARET] = ACTIONS(453),
    [aux_sym_binary_operator_token1] = ACTIONS(453),
    [anon_sym_PIPE_GT] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(455),
    [anon_sym_DOLLAR] = ACTIONS(453),
    [anon_sym_AT] = ACTIONS(453),
    [aux_sym__hex_literal_token1] = ACTIONS(505),
    [sym__number_literal] = ACTIONS(507),
    [anon_sym_SQUOTE] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(511),
    [sym_return] = ACTIONS(2234),
    [sym_next] = ACTIONS(2234),
    [sym_break] = ACTIONS(2234),
    [sym_true] = ACTIONS(2234),
    [sym_false] = ACTIONS(2234),
    [sym_null] = ACTIONS(2234),
    [sym_inf] = ACTIONS(2234),
    [sym_nan] = ACTIONS(2234),
    [anon_sym_NA] = ACTIONS(515),
    [anon_sym_NA_integer_] = ACTIONS(515),
    [anon_sym_NA_real_] = ACTIONS(515),
    [anon_sym_NA_complex_] = ACTIONS(515),
    [anon_sym_NA_character_] = ACTIONS(515),
    [sym_dots] = ACTIONS(2234),
    [sym_dot_dot_i] = ACTIONS(2236),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(453),
    [sym__newline] = ACTIONS(453),
    [sym__semicolon] = ACTIONS(453),
    [sym__raw_string_literal] = ACTIONS(521),
    [sym__external_else] = ACTIONS(453),
    [sym__external_open_parenthesis] = ACTIONS(523),
    [sym__external_open_brace] = ACTIONS(525),
    [sym__external_close_brace] = ACTIONS(453),
    [sym__external_open_bracket] = ACTIONS(453),
    [sym__external_close_bracket] = ACTIONS(453),
    [sym__external_open_bracket2] = ACTIONS(453),
  },
  [168] = {
    [sym_function_definition] = STATE(894),
    [sym_if_statement] = STATE(894),
    [sym_for_statement] = STATE(894),
    [sym_while_statement] = STATE(894),
    [sym_repeat_statement] = STATE(894),
    [sym_braced_expression] = STATE(894),
    [sym_parenthesized_expression] = STATE(894),
    [sym_call] = STATE(894),
    [sym_subset] = STATE(894),
    [sym_subset2] = STATE(894),
    [sym_unary_operator] = STATE(894),
    [sym_binary_operator] = STATE(894),
    [sym_extract_operator] = STATE(894),
    [sym_namespace_operator] = STATE(894),
    [sym_integer] = STATE(894),
    [sym_complex] = STATE(894),
    [sym_float] = STATE(894),
    [sym__hex_literal] = STATE(2206),
    [sym__float_literal] = STATE(2206),
    [sym_string] = STATE(2166),
    [sym__single_quoted_string] = STATE(2200),
    [sym__double_quoted_string] = STATE(2201),
    [sym_na] = STATE(894),
    [sym__expression] = STATE(894),
    [sym__string_or_identifier] = STATE(5154),
    [sym__open_parenthesis] = STATE(3),
    [sym__open_brace] = STATE(45),
    [aux_sym_function_definition_repeat1] = STATE(169),
    [sym_identifier] = ACTIONS(481),
    [anon_sym_BSLASH] = ACTIONS(483),
    [anon_sym_function] = ACTIONS(485),
    [anon_sym_EQ] = ACTIONS(463),
    [anon_sym_if] = ACTIONS(487),
    [anon_sym_for] = ACTIONS(489),
    [anon_sym_while] = ACTIONS(491),
    [anon_sym_repeat] = ACTIONS(493),
    [anon_sym_QMARK] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(503),
    [anon_sym_LT_DASH] = ACTIONS(461),
    [anon_sym_LT_LT_DASH] = ACTIONS(461),
    [anon_sym_COLON_EQ] = ACTIONS(461),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_DASH_GT_GT] = ACTIONS(461),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_PIPE_PIPE] = ACTIONS(461),
    [anon_sym_AMP_AMP] = ACTIONS(461),
    [anon_sym_LT] = ACTIONS(463),
    [anon_sym_LT_EQ] = ACTIONS(461),
    [anon_sym_GT] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(461),
    [anon_sym_EQ_EQ] = ACTIONS(461),
    [anon_sym_BANG_EQ] = ACTIONS(461),
    [anon_sym_STAR] = ACTIONS(463),
    [anon_sym_SLASH] = ACTIONS(461),
    [anon_sym_STAR_STAR] = ACTIONS(461),
    [anon_sym_CARET] = ACTIONS(461),
    [aux_sym_binary_operator_token1] = ACTIONS(461),
    [anon_sym_PIPE_GT] = ACTIONS(461),
    [anon_sym_COLON] = ACTIONS(463),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_AT] = ACTIONS(461),
    [aux_sym__hex_literal_token1] = ACTIONS(505),
    [sym__number_literal] = ACTIONS(507),
    [anon_sym_SQUOTE] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(511),
    [sym_return] = ACTIONS(2238),
    [sym_next] = ACTIONS(2238),
    [sym_break] = ACTIONS(2238),
    [sym_true] = ACTIONS(2238),
    [sym_false] = ACTIONS(2238),
    [sym_null] = ACTIONS(2238),
    [sym_inf] = ACTIONS(2238),
    [sym_nan] = ACTIONS(2238),
    [anon_sym_NA] = ACTIONS(515),
    [anon_sym_NA_integer_] = ACTIONS(515),
    [anon_sym_NA_real_] = ACTIONS(515),
    [anon_sym_NA_complex_] = ACTIONS(515),
    [anon_sym_NA_character_] = ACTIONS(515),
    [sym_dots] = ACTIONS(2238),
    [sym_dot_dot_i] = ACTIONS(2240),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(461),
    [sym__newline] = ACTIONS(2242),
    [sym__semicolon] = ACTIONS(461),
    [sym__raw_string_literal] = ACTIONS(521),
    [sym__external_else] = ACTIONS(461),
    [sym__external_open_parenthesis] = ACTIONS(523),
    [sym__external_open_brace] = ACTIONS(525),
    [sym__external_close_brace] = ACTIONS(461),
    [sym__external_open_bracket] = ACTIONS(461),
    [sym__external_close_bracket] = ACTIONS(461),
    [sym__external_open_bracket2] = ACTIONS(461),
  },
  [169] = {
    [sym_function_definition] = STATE(898),
    [sym_if_statement] = STATE(898),
    [sym_for_statement] = STATE(898),
    [sym_while_statement] = STATE(898),
    [sym_repeat_statement] = STATE(898),
    [sym_braced_expression] = STATE(898),
    [sym_parenthesized_expression] = STATE(898),
    [sym_call] = STATE(898),
    [sym_subset] = STATE(898),
    [sym_subset2] = STATE(898),
    [sym_unary_operator] = STATE(898),
    [sym_binary_operator] = STATE(898),
    [sym_extract_operator] = STATE(898),
    [sym_namespace_operator] = STATE(898),
    [sym_integer] = STATE(898),
    [sym_complex] = STATE(898),
    [sym_float] = STATE(898),
    [sym__hex_literal] = STATE(2206),
    [sym__float_literal] = STATE(2206),
    [sym_string] = STATE(2166),
    [sym__single_quoted_string] = STATE(2200),
    [sym__double_quoted_string] = STATE(2201),
    [sym_na] = STATE(898),
    [sym__expression] = STATE(898),
    [sym__string_or_identifier] = STATE(5154),
    [sym__open_parenthesis] = STATE(3),
    [sym__open_brace] = STATE(45),
    [aux_sym_function_definition_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(481),
    [anon_sym_BSLASH] = ACTIONS(483),
    [anon_sym_function] = ACTIONS(485),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_if] = ACTIONS(487),
    [anon_sym_for] = ACTIONS(489),
    [anon_sym_while] = ACTIONS(491),
    [anon_sym_repeat] = ACTIONS(493),
    [anon_sym_QMARK] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(503),
    [anon_sym_LT_DASH] = ACTIONS(471),
    [anon_sym_LT_LT_DASH] = ACTIONS(471),
    [anon_sym_COLON_EQ] = ACTIONS(471),
    [anon_sym_DASH_GT] = ACTIONS(473),
    [anon_sym_DASH_GT_GT] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(473),
    [anon_sym_AMP] = ACTIONS(473),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_LT_EQ] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(473),
    [anon_sym_GT_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_STAR] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [aux_sym_binary_operator_token1] = ACTIONS(471),
    [anon_sym_PIPE_GT] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(473),
    [anon_sym_DOLLAR] = ACTIONS(471),
    [anon_sym_AT] = ACTIONS(471),
    [aux_sym__hex_literal_token1] = ACTIONS(505),
    [sym__number_literal] = ACTIONS(507),
    [anon_sym_SQUOTE] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(511),
    [sym_return] = ACTIONS(2244),
    [sym_next] = ACTIONS(2244),
    [sym_break] = ACTIONS(2244),
    [sym_true] = ACTIONS(2244),
    [sym_false] = ACTIONS(2244),
    [sym_null] = ACTIONS(2244),
    [sym_inf] = ACTIONS(2244),
    [sym_nan] = ACTIONS(2244),
    [anon_sym_NA] = ACTIONS(515),
    [anon_sym_NA_integer_] = ACTIONS(515),
    [anon_sym_NA_real_] = ACTIONS(515),
    [anon_sym_NA_complex_] = ACTIONS(515),
    [anon_sym_NA_character_] = ACTIONS(515),
    [sym_dots] = ACTIONS(2244),
    [sym_dot_dot_i] = ACTIONS(2246),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(471),
    [sym__newline] = ACTIONS(471),
    [sym__semicolon] = ACTIONS(471),
    [sym__raw_string_literal] = ACTIONS(521),
    [sym__external_else] = ACTIONS(471),
    [sym__external_open_parenthesis] = ACTIONS(523),
    [sym__external_open_brace] = ACTIONS(525),
    [sym__external_close_brace] = ACTIONS(471),
    [sym__external_open_bracket] = ACTIONS(471),
    [sym__external_close_bracket] = ACTIONS(471),
    [sym__external_open_bracket2] = ACTIONS(471),
  },
  [170] = {
    [sym_function_definition] = STATE(1139),
    [sym_if_statement] = STATE(1139),
    [sym_for_statement] = STATE(1139),
    [sym_while_statement] = STATE(1139),
    [sym_repeat_statement] = STATE(1139),
    [sym_braced_expression] = STATE(1139),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_call] = STATE(1139),
    [sym_subset] = STATE(1139),
    [sym_subset2] = STATE(1139),
    [sym_unary_operator] = STATE(1139),
    [sym_binary_operator] = STATE(1139),
    [sym_extract_operator] = STATE(1139),
    [sym_namespace_operator] = STATE(1139),
    [sym_integer] = STATE(1139),
    [sym_complex] = STATE(1139),
    [sym_float] = STATE(1139),
    [sym__hex_literal] = STATE(2272),
    [sym__float_literal] = STATE(2272),
    [sym_string] = STATE(2271),
    [sym__single_quoted_string] = STATE(2273),
    [sym__double_quoted_string] = STATE(2274),
    [sym_na] = STATE(1139),
    [sym__expression] = STATE(1139),
    [sym__string_or_identifier] = STATE(5157),
    [sym__open_parenthesis] = STATE(120),
    [sym__close_parenthesis] = STATE(2712),
    [sym__open_brace] = STATE(11),
    [aux_sym_parenthesized_expression_repeat1] = STATE(236),
    [sym_identifier] = ACTIONS(1241),
    [anon_sym_BSLASH] = ACTIONS(1243),
    [anon_sym_function] = ACTIONS(1245),
    [anon_sym_EQ] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(1247),
    [anon_sym_for] = ACTIONS(1249),
    [anon_sym_while] = ACTIONS(1251),
    [anon_sym_repeat] = ACTIONS(1253),
    [anon_sym_QMARK] = ACTIONS(1255),
    [anon_sym_TILDE] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1259),
    [anon_sym_PLUS] = ACTIONS(1261),
    [anon_sym_DASH] = ACTIONS(1263),
    [anon_sym_LT_DASH] = ACTIONS(211),
    [anon_sym_LT_LT_DASH] = ACTIONS(211),
    [anon_sym_COLON_EQ] = ACTIONS(211),
    [anon_sym_DASH_GT] = ACTIONS(209),
    [anon_sym_DASH_GT_GT] = ACTIONS(211),
    [anon_sym_PIPE] = ACTIONS(209),
    [anon_sym_AMP] = ACTIONS(209),
    [anon_sym_PIPE_PIPE] = ACTIONS(211),
    [anon_sym_AMP_AMP] = ACTIONS(211),
    [anon_sym_LT] = ACTIONS(209),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_GT] = ACTIONS(209),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [anon_sym_EQ_EQ] = ACTIONS(211),
    [anon_sym_BANG_EQ] = ACTIONS(211),
    [anon_sym_STAR] = ACTIONS(209),
    [anon_sym_SLASH] = ACTIONS(211),
    [anon_sym_STAR_STAR] = ACTIONS(211),
    [anon_sym_CARET] = ACTIONS(211),
    [aux_sym_binary_operator_token1] = ACTIONS(211),
    [anon_sym_PIPE_GT] = ACTIONS(211),
    [anon_sym_COLON] = ACTIONS(209),
    [anon_sym_DOLLAR] = ACTIONS(211),
    [anon_sym_AT] = ACTIONS(211),
    [aux_sym__hex_literal_token1] = ACTIONS(1265),
    [sym__number_literal] = ACTIONS(1267),
    [anon_sym_SQUOTE] = ACTIONS(1269),
    [anon_sym_DQUOTE] = ACTIONS(1271),
    [sym_return] = ACTIONS(1273),
    [sym_next] = ACTIONS(1273),
    [sym_break] = ACTIONS(1273),
    [sym_true] = ACTIONS(1273),
    [sym_false] = ACTIONS(1273),
    [sym_null] = ACTIONS(1273),
    [sym_inf] = ACTIONS(1273),
    [sym_nan] = ACTIONS(1273),
    [anon_sym_NA] = ACTIONS(1275),
    [anon_sym_NA_integer_] = ACTIONS(1275),
    [anon_sym_NA_real_] = ACTIONS(1275),
    [anon_sym_NA_complex_] = ACTIONS(1275),
    [anon_sym_NA_character_] = ACTIONS(1275),
    [sym_dots] = ACTIONS(1273),
    [sym_dot_dot_i] = ACTIONS(1277),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(211),
    [sym__newline] = ACTIONS(1279),
    [sym__raw_string_literal] = ACTIONS(1281),
    [sym__external_else] = ACTIONS(211),
    [sym__external_open_parenthesis] = ACTIONS(1283),
    [sym__external_close_parenthesis] = ACTIONS(2248),
    [sym__external_open_brace] = ACTIONS(1287),
    [sym__external_open_bracket] = ACTIONS(211),
    [sym__external_close_bracket] = ACTIONS(211),
    [sym__external_open_bracket2] = ACTIONS(211),
  },
  [171] = {
    [sym_function_definition] = STATE(827),
    [sym_if_statement] = STATE(827),
    [sym_for_statement] = STATE(827),
    [sym_while_statement] = STATE(827),
    [sym_repeat_statement] = STATE(827),
    [sym_braced_expression] = STATE(827),
    [sym_parenthesized_expression] = STATE(827),
    [sym_call] = STATE(827),
    [sym_subset] = STATE(827),
    [sym_subset2] = STATE(827),
    [sym_unary_operator] = STATE(827),
    [sym_binary_operator] = STATE(827),
    [sym_extract_operator] = STATE(827),
    [sym_namespace_operator] = STATE(827),
    [sym_integer] = STATE(827),
    [sym_complex] = STATE(827),
    [sym_float] = STATE(827),
    [sym__hex_literal] = STATE(2183),
    [sym__float_literal] = STATE(2183),
    [sym_string] = STATE(2169),
    [sym__single_quoted_string] = STATE(2181),
    [sym__double_quoted_string] = STATE(2180),
    [sym_na] = STATE(827),
    [sym__expression] = STATE(827),
    [sym__string_or_identifier] = STATE(5149),
    [sym__open_parenthesis] = STATE(67),
    [sym__open_brace] = STATE(24),
    [aux_sym_function_definition_repeat1] = STATE(174),
    [ts_builtin_sym_end] = ACTIONS(387),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_BSLASH] = ACTIONS(323),
    [anon_sym_function] = ACTIONS(325),
    [anon_sym_EQ] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(327),
    [anon_sym_for] = ACTIONS(329),
    [anon_sym_while] = ACTIONS(331),
    [anon_sym_repeat] = ACTIONS(333),
    [anon_sym_QMARK] = ACTIONS(335),
    [anon_sym_TILDE] = ACTIONS(337),
    [anon_sym_BANG] = ACTIONS(339),
    [anon_sym_PLUS] = ACTIONS(341),
    [anon_sym_DASH] = ACTIONS(343),
    [anon_sym_LT_DASH] = ACTIONS(387),
    [anon_sym_LT_LT_DASH] = ACTIONS(387),
    [anon_sym_COLON_EQ] = ACTIONS(387),
    [anon_sym_DASH_GT] = ACTIONS(389),
    [anon_sym_DASH_GT_GT] = ACTIONS(387),
    [anon_sym_PIPE] = ACTIONS(389),
    [anon_sym_AMP] = ACTIONS(389),
    [anon_sym_PIPE_PIPE] = ACTIONS(387),
    [anon_sym_AMP_AMP] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(389),
    [anon_sym_LT_EQ] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(389),
    [anon_sym_GT_EQ] = ACTIONS(387),
    [anon_sym_EQ_EQ] = ACTIONS(387),
    [anon_sym_BANG_EQ] = ACTIONS(387),
    [anon_sym_STAR] = ACTIONS(389),
    [anon_sym_SLASH] = ACTIONS(387),
    [anon_sym_STAR_STAR] = ACTIONS(387),
    [anon_sym_CARET] = ACTIONS(387),
    [aux_sym_binary_operator_token1] = ACTIONS(387),
    [anon_sym_PIPE_GT] = ACTIONS(387),
    [anon_sym_COLON] = ACTIONS(389),
    [anon_sym_DOLLAR] = ACTIONS(387),
    [anon_sym_AT] = ACTIONS(387),
    [aux_sym__hex_literal_token1] = ACTIONS(345),
    [sym__number_literal] = ACTIONS(347),
    [anon_sym_SQUOTE] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(351),
    [sym_return] = ACTIONS(2250),
    [sym_next] = ACTIONS(2250),
    [sym_break] = ACTIONS(2250),
    [sym_true] = ACTIONS(2250),
    [sym_false] = ACTIONS(2250),
    [sym_null] = ACTIONS(2250),
    [sym_inf] = ACTIONS(2250),
    [sym_nan] = ACTIONS(2250),
    [anon_sym_NA] = ACTIONS(355),
    [anon_sym_NA_integer_] = ACTIONS(355),
    [anon_sym_NA_real_] = ACTIONS(355),
    [anon_sym_NA_complex_] = ACTIONS(355),
    [anon_sym_NA_character_] = ACTIONS(355),
    [sym_dots] = ACTIONS(2250),
    [sym_dot_dot_i] = ACTIONS(2252),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(387),
    [sym__newline] = ACTIONS(2254),
    [sym__semicolon] = ACTIONS(387),
    [sym__raw_string_literal] = ACTIONS(361),
    [sym__external_open_parenthesis] = ACTIONS(363),
    [sym__external_close_parenthesis] = ACTIONS(387),
    [sym__external_open_brace] = ACTIONS(365),
    [sym__external_close_brace] = ACTIONS(387),
    [sym__external_open_bracket] = ACTIONS(387),
    [sym__external_open_bracket2] = ACTIONS(387),
  },
  [172] = {
    [sym_function_definition] = STATE(824),
    [sym_if_statement] = STATE(824),
    [sym_for_statement] = STATE(824),
    [sym_while_statement] = STATE(824),
    [sym_repeat_statement] = STATE(824),
    [sym_braced_expression] = STATE(824),
    [sym_parenthesized_expression] = STATE(824),
    [sym_call] = STATE(824),
    [sym_subset] = STATE(824),
    [sym_subset2] = STATE(824),
    [sym_unary_operator] = STATE(824),
    [sym_binary_operator] = STATE(824),
    [sym_extract_operator] = STATE(824),
    [sym_namespace_operator] = STATE(824),
    [sym_integer] = STATE(824),
    [sym_complex] = STATE(824),
    [sym_float] = STATE(824),
    [sym__hex_literal] = STATE(2183),
    [sym__float_literal] = STATE(2183),
    [sym_string] = STATE(2169),
    [sym__single_quoted_string] = STATE(2181),
    [sym__double_quoted_string] = STATE(2180),
    [sym_na] = STATE(824),
    [sym__expression] = STATE(824),
    [sym__string_or_identifier] = STATE(5149),
    [sym__open_parenthesis] = STATE(67),
    [sym__open_brace] = STATE(24),
    [aux_sym_function_definition_repeat1] = STATE(2281),
    [ts_builtin_sym_end] = ACTIONS(397),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_BSLASH] = ACTIONS(323),
    [anon_sym_function] = ACTIONS(325),
    [anon_sym_EQ] = ACTIONS(399),
    [anon_sym_if] = ACTIONS(327),
    [anon_sym_for] = ACTIONS(329),
    [anon_sym_while] = ACTIONS(331),
    [anon_sym_repeat] = ACTIONS(333),
    [anon_sym_QMARK] = ACTIONS(335),
    [anon_sym_TILDE] = ACTIONS(337),
    [anon_sym_BANG] = ACTIONS(339),
    [anon_sym_PLUS] = ACTIONS(341),
    [anon_sym_DASH] = ACTIONS(343),
    [anon_sym_LT_DASH] = ACTIONS(397),
    [anon_sym_LT_LT_DASH] = ACTIONS(397),
    [anon_sym_COLON_EQ] = ACTIONS(397),
    [anon_sym_DASH_GT] = ACTIONS(399),
    [anon_sym_DASH_GT_GT] = ACTIONS(397),
    [anon_sym_PIPE] = ACTIONS(399),
    [anon_sym_AMP] = ACTIONS(399),
    [anon_sym_PIPE_PIPE] = ACTIONS(397),
    [anon_sym_AMP_AMP] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(399),
    [anon_sym_LT_EQ] = ACTIONS(397),
    [anon_sym_GT] = ACTIONS(399),
    [anon_sym_GT_EQ] = ACTIONS(397),
    [anon_sym_EQ_EQ] = ACTIONS(397),
    [anon_sym_BANG_EQ] = ACTIONS(397),
    [anon_sym_STAR] = ACTIONS(399),
    [anon_sym_SLASH] = ACTIONS(397),
    [anon_sym_STAR_STAR] = ACTIONS(397),
    [anon_sym_CARET] = ACTIONS(397),
    [aux_sym_binary_operator_token1] = ACTIONS(397),
    [anon_sym_PIPE_GT] = ACTIONS(397),
    [anon_sym_COLON] = ACTIONS(399),
    [anon_sym_DOLLAR] = ACTIONS(397),
    [anon_sym_AT] = ACTIONS(397),
    [aux_sym__hex_literal_token1] = ACTIONS(345),
    [sym__number_literal] = ACTIONS(347),
    [anon_sym_SQUOTE] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(351),
    [sym_return] = ACTIONS(2256),
    [sym_next] = ACTIONS(2256),
    [sym_break] = ACTIONS(2256),
    [sym_true] = ACTIONS(2256),
    [sym_false] = ACTIONS(2256),
    [sym_null] = ACTIONS(2256),
    [sym_inf] = ACTIONS(2256),
    [sym_nan] = ACTIONS(2256),
    [anon_sym_NA] = ACTIONS(355),
    [anon_sym_NA_integer_] = ACTIONS(355),
    [anon_sym_NA_real_] = ACTIONS(355),
    [anon_sym_NA_complex_] = ACTIONS(355),
    [anon_sym_NA_character_] = ACTIONS(355),
    [sym_dots] = ACTIONS(2256),
    [sym_dot_dot_i] = ACTIONS(2258),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(397),
    [sym__newline] = ACTIONS(397),
    [sym__semicolon] = ACTIONS(397),
    [sym__raw_string_literal] = ACTIONS(361),
    [sym__external_open_parenthesis] = ACTIONS(363),
    [sym__external_close_parenthesis] = ACTIONS(397),
    [sym__external_open_brace] = ACTIONS(365),
    [sym__external_close_brace] = ACTIONS(397),
    [sym__external_open_bracket] = ACTIONS(397),
    [sym__external_open_bracket2] = ACTIONS(397),
  },
  [173] = {
    [sym_function_definition] = STATE(790),
    [sym_if_statement] = STATE(790),
    [sym_for_statement] = STATE(790),
    [sym_while_statement] = STATE(790),
    [sym_repeat_statement] = STATE(790),
    [sym_braced_expression] = STATE(790),
    [sym_parenthesized_expression] = STATE(790),
    [sym_call] = STATE(790),
    [sym_subset] = STATE(790),
    [sym_subset2] = STATE(790),
    [sym_unary_operator] = STATE(790),
    [sym_binary_operator] = STATE(790),
    [sym_extract_operator] = STATE(790),
    [sym_namespace_operator] = STATE(790),
    [sym_integer] = STATE(790),
    [sym_complex] = STATE(790),
    [sym_float] = STATE(790),
    [sym__hex_literal] = STATE(2183),
    [sym__float_literal] = STATE(2183),
    [sym_string] = STATE(2169),
    [sym__single_quoted_string] = STATE(2181),
    [sym__double_quoted_string] = STATE(2180),
    [sym_na] = STATE(790),
    [sym__expression] = STATE(790),
    [sym__string_or_identifier] = STATE(5149),
    [sym__open_parenthesis] = STATE(67),
    [sym__open_brace] = STATE(24),
    [sym__close_brace] = STATE(2904),
    [aux_sym_braced_expression_repeat1] = STATE(146),
    [ts_builtin_sym_end] = ACTIONS(155),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_BSLASH] = ACTIONS(323),
    [anon_sym_function] = ACTIONS(325),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(327),
    [anon_sym_for] = ACTIONS(329),
    [anon_sym_while] = ACTIONS(331),
    [anon_sym_repeat] = ACTIONS(333),
    [anon_sym_QMARK] = ACTIONS(335),
    [anon_sym_TILDE] = ACTIONS(337),
    [anon_sym_BANG] = ACTIONS(339),
    [anon_sym_PLUS] = ACTIONS(341),
    [anon_sym_DASH] = ACTIONS(343),
    [anon_sym_LT_DASH] = ACTIONS(155),
    [anon_sym_LT_LT_DASH] = ACTIONS(155),
    [anon_sym_COLON_EQ] = ACTIONS(155),
    [anon_sym_DASH_GT] = ACTIONS(157),
    [anon_sym_DASH_GT_GT] = ACTIONS(155),
    [anon_sym_PIPE] = ACTIONS(157),
    [anon_sym_AMP] = ACTIONS(157),
    [anon_sym_PIPE_PIPE] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(157),
    [anon_sym_LT_EQ] = ACTIONS(155),
    [anon_sym_GT] = ACTIONS(157),
    [anon_sym_GT_EQ] = ACTIONS(155),
    [anon_sym_EQ_EQ] = ACTIONS(155),
    [anon_sym_BANG_EQ] = ACTIONS(155),
    [anon_sym_STAR] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(155),
    [anon_sym_STAR_STAR] = ACTIONS(155),
    [anon_sym_CARET] = ACTIONS(155),
    [aux_sym_binary_operator_token1] = ACTIONS(155),
    [anon_sym_PIPE_GT] = ACTIONS(155),
    [anon_sym_COLON] = ACTIONS(157),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(155),
    [aux_sym__hex_literal_token1] = ACTIONS(345),
    [sym__number_literal] = ACTIONS(347),
    [anon_sym_SQUOTE] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(351),
    [sym_return] = ACTIONS(353),
    [sym_next] = ACTIONS(353),
    [sym_break] = ACTIONS(353),
    [sym_true] = ACTIONS(353),
    [sym_false] = ACTIONS(353),
    [sym_null] = ACTIONS(353),
    [sym_inf] = ACTIONS(353),
    [sym_nan] = ACTIONS(353),
    [anon_sym_NA] = ACTIONS(355),
    [anon_sym_NA_integer_] = ACTIONS(355),
    [anon_sym_NA_real_] = ACTIONS(355),
    [anon_sym_NA_complex_] = ACTIONS(355),
    [anon_sym_NA_character_] = ACTIONS(355),
    [sym_dots] = ACTIONS(353),
    [sym_dot_dot_i] = ACTIONS(357),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(359),
    [sym__semicolon] = ACTIONS(359),
    [sym__raw_string_literal] = ACTIONS(361),
    [sym__external_open_parenthesis] = ACTIONS(363),
    [sym__external_close_parenthesis] = ACTIONS(155),
    [sym__external_open_brace] = ACTIONS(365),
    [sym__external_close_brace] = ACTIONS(2260),
    [sym__external_open_bracket] = ACTIONS(155),
    [sym__external_open_bracket2] = ACTIONS(155),
  },
  [174] = {
    [sym_function_definition] = STATE(672),
    [sym_if_statement] = STATE(672),
    [sym_for_statement] = STATE(672),
    [sym_while_statement] = STATE(672),
    [sym_repeat_statement] = STATE(672),
    [sym_braced_expression] = STATE(672),
    [sym_parenthesized_expression] = STATE(672),
    [sym_call] = STATE(672),
    [sym_subset] = STATE(672),
    [sym_subset2] = STATE(672),
    [sym_unary_operator] = STATE(672),
    [sym_binary_operator] = STATE(672),
    [sym_extract_operator] = STATE(672),
    [sym_namespace_operator] = STATE(672),
    [sym_integer] = STATE(672),
    [sym_complex] = STATE(672),
    [sym_float] = STATE(672),
    [sym__hex_literal] = STATE(2183),
    [sym__float_literal] = STATE(2183),
    [sym_string] = STATE(2169),
    [sym__single_quoted_string] = STATE(2181),
    [sym__double_quoted_string] = STATE(2180),
    [sym_na] = STATE(672),
    [sym__expression] = STATE(672),
    [sym__string_or_identifier] = STATE(5149),
    [sym__open_parenthesis] = STATE(67),
    [sym__open_brace] = STATE(24),
    [aux_sym_function_definition_repeat1] = STATE(2281),
    [ts_builtin_sym_end] = ACTIONS(453),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_BSLASH] = ACTIONS(323),
    [anon_sym_function] = ACTIONS(325),
    [anon_sym_EQ] = ACTIONS(455),
    [anon_sym_if] = ACTIONS(327),
    [anon_sym_for] = ACTIONS(329),
    [anon_sym_while] = ACTIONS(331),
    [anon_sym_repeat] = ACTIONS(333),
    [anon_sym_QMARK] = ACTIONS(335),
    [anon_sym_TILDE] = ACTIONS(337),
    [anon_sym_BANG] = ACTIONS(339),
    [anon_sym_PLUS] = ACTIONS(341),
    [anon_sym_DASH] = ACTIONS(343),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [anon_sym_LT_LT_DASH] = ACTIONS(453),
    [anon_sym_COLON_EQ] = ACTIONS(453),
    [anon_sym_DASH_GT] = ACTIONS(455),
    [anon_sym_DASH_GT_GT] = ACTIONS(453),
    [anon_sym_PIPE] = ACTIONS(455),
    [anon_sym_AMP] = ACTIONS(455),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(455),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_GT] = ACTIONS(455),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(453),
    [anon_sym_STAR] = ACTIONS(455),
    [anon_sym_SLASH] = ACTIONS(453),
    [anon_sym_STAR_STAR] = ACTIONS(453),
    [anon_sym_CARET] = ACTIONS(453),
    [aux_sym_binary_operator_token1] = ACTIONS(453),
    [anon_sym_PIPE_GT] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(455),
    [anon_sym_DOLLAR] = ACTIONS(453),
    [anon_sym_AT] = ACTIONS(453),
    [aux_sym__hex_literal_token1] = ACTIONS(345),
    [sym__number_literal] = ACTIONS(347),
    [anon_sym_SQUOTE] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(351),
    [sym_return] = ACTIONS(2262),
    [sym_next] = ACTIONS(2262),
    [sym_break] = ACTIONS(2262),
    [sym_true] = ACTIONS(2262),
    [sym_false] = ACTIONS(2262),
    [sym_null] = ACTIONS(2262),
    [sym_inf] = ACTIONS(2262),
    [sym_nan] = ACTIONS(2262),
    [anon_sym_NA] = ACTIONS(355),
    [anon_sym_NA_integer_] = ACTIONS(355),
    [anon_sym_NA_real_] = ACTIONS(355),
    [anon_sym_NA_complex_] = ACTIONS(355),
    [anon_sym_NA_character_] = ACTIONS(355),
    [sym_dots] = ACTIONS(2262),
    [sym_dot_dot_i] = ACTIONS(2264),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(453),
    [sym__newline] = ACTIONS(453),
    [sym__semicolon] = ACTIONS(453),
    [sym__raw_string_literal] = ACTIONS(361),
    [sym__external_open_parenthesis] = ACTIONS(363),
    [sym__external_close_parenthesis] = ACTIONS(453),
    [sym__external_open_brace] = ACTIONS(365),
    [sym__external_close_brace] = ACTIONS(453),
    [sym__external_open_bracket] = ACTIONS(453),
    [sym__external_open_bracket2] = ACTIONS(453),
  },
  [175] = {
    [sym_function_definition] = STATE(815),
    [sym_if_statement] = STATE(815),
    [sym_for_statement] = STATE(815),
    [sym_while_statement] = STATE(815),
    [sym_repeat_statement] = STATE(815),
    [sym_braced_expression] = STATE(815),
    [sym_parenthesized_expression] = STATE(815),
    [sym_call] = STATE(815),
    [sym_subset] = STATE(815),
    [sym_subset2] = STATE(815),
    [sym_unary_operator] = STATE(815),
    [sym_binary_operator] = STATE(815),
    [sym_extract_operator] = STATE(815),
    [sym_namespace_operator] = STATE(815),
    [sym_integer] = STATE(815),
    [sym_complex] = STATE(815),
    [sym_float] = STATE(815),
    [sym__hex_literal] = STATE(2183),
    [sym__float_literal] = STATE(2183),
    [sym_string] = STATE(2169),
    [sym__single_quoted_string] = STATE(2181),
    [sym__double_quoted_string] = STATE(2180),
    [sym_na] = STATE(815),
    [sym__expression] = STATE(815),
    [sym__string_or_identifier] = STATE(5149),
    [sym__open_parenthesis] = STATE(67),
    [sym__open_brace] = STATE(24),
    [aux_sym_function_definition_repeat1] = STATE(177),
    [ts_builtin_sym_end] = ACTIONS(461),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_BSLASH] = ACTIONS(323),
    [anon_sym_function] = ACTIONS(325),
    [anon_sym_EQ] = ACTIONS(463),
    [anon_sym_if] = ACTIONS(327),
    [anon_sym_for] = ACTIONS(329),
    [anon_sym_while] = ACTIONS(331),
    [anon_sym_repeat] = ACTIONS(333),
    [anon_sym_QMARK] = ACTIONS(335),
    [anon_sym_TILDE] = ACTIONS(337),
    [anon_sym_BANG] = ACTIONS(339),
    [anon_sym_PLUS] = ACTIONS(341),
    [anon_sym_DASH] = ACTIONS(343),
    [anon_sym_LT_DASH] = ACTIONS(461),
    [anon_sym_LT_LT_DASH] = ACTIONS(461),
    [anon_sym_COLON_EQ] = ACTIONS(461),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_DASH_GT_GT] = ACTIONS(461),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_PIPE_PIPE] = ACTIONS(461),
    [anon_sym_AMP_AMP] = ACTIONS(461),
    [anon_sym_LT] = ACTIONS(463),
    [anon_sym_LT_EQ] = ACTIONS(461),
    [anon_sym_GT] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(461),
    [anon_sym_EQ_EQ] = ACTIONS(461),
    [anon_sym_BANG_EQ] = ACTIONS(461),
    [anon_sym_STAR] = ACTIONS(463),
    [anon_sym_SLASH] = ACTIONS(461),
    [anon_sym_STAR_STAR] = ACTIONS(461),
    [anon_sym_CARET] = ACTIONS(461),
    [aux_sym_binary_operator_token1] = ACTIONS(461),
    [anon_sym_PIPE_GT] = ACTIONS(461),
    [anon_sym_COLON] = ACTIONS(463),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_AT] = ACTIONS(461),
    [aux_sym__hex_literal_token1] = ACTIONS(345),
    [sym__number_literal] = ACTIONS(347),
    [anon_sym_SQUOTE] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(351),
    [sym_return] = ACTIONS(2266),
    [sym_next] = ACTIONS(2266),
    [sym_break] = ACTIONS(2266),
    [sym_true] = ACTIONS(2266),
    [sym_false] = ACTIONS(2266),
    [sym_null] = ACTIONS(2266),
    [sym_inf] = ACTIONS(2266),
    [sym_nan] = ACTIONS(2266),
    [anon_sym_NA] = ACTIONS(355),
    [anon_sym_NA_integer_] = ACTIONS(355),
    [anon_sym_NA_real_] = ACTIONS(355),
    [anon_sym_NA_complex_] = ACTIONS(355),
    [anon_sym_NA_character_] = ACTIONS(355),
    [sym_dots] = ACTIONS(2266),
    [sym_dot_dot_i] = ACTIONS(2268),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(461),
    [sym__newline] = ACTIONS(2270),
    [sym__semicolon] = ACTIONS(461),
    [sym__raw_string_literal] = ACTIONS(361),
    [sym__external_open_parenthesis] = ACTIONS(363),
    [sym__external_close_parenthesis] = ACTIONS(461),
    [sym__external_open_brace] = ACTIONS(365),
    [sym__external_close_brace] = ACTIONS(461),
    [sym__external_open_bracket] = ACTIONS(461),
    [sym__external_open_bracket2] = ACTIONS(461),
  },
  [176] = {
    [sym_function_definition] = STATE(1133),
    [sym_if_statement] = STATE(1133),
    [sym_for_statement] = STATE(1133),
    [sym_while_statement] = STATE(1133),
    [sym_repeat_statement] = STATE(1133),
    [sym_braced_expression] = STATE(1133),
    [sym_parenthesized_expression] = STATE(1133),
    [sym_call] = STATE(1133),
    [sym_subset] = STATE(1133),
    [sym_subset2] = STATE(1133),
    [sym_unary_operator] = STATE(1133),
    [sym_binary_operator] = STATE(1133),
    [sym_extract_operator] = STATE(1133),
    [sym_namespace_operator] = STATE(1133),
    [sym_integer] = STATE(1133),
    [sym_complex] = STATE(1133),
    [sym_float] = STATE(1133),
    [sym__hex_literal] = STATE(2288),
    [sym__float_literal] = STATE(2288),
    [sym_string] = STATE(2287),
    [sym__single_quoted_string] = STATE(2289),
    [sym__double_quoted_string] = STATE(2290),
    [sym_na] = STATE(1133),
    [sym__expression] = STATE(1133),
    [sym__string_or_identifier] = STATE(5144),
    [sym__open_parenthesis] = STATE(119),
    [sym__close_parenthesis] = STATE(2622),
    [sym__open_brace] = STATE(16),
    [aux_sym_parenthesized_expression_repeat1] = STATE(271),
    [sym_identifier] = ACTIONS(1568),
    [anon_sym_BSLASH] = ACTIONS(1570),
    [anon_sym_function] = ACTIONS(1572),
    [anon_sym_EQ] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(1574),
    [anon_sym_for] = ACTIONS(1576),
    [anon_sym_while] = ACTIONS(1578),
    [anon_sym_repeat] = ACTIONS(1580),
    [anon_sym_QMARK] = ACTIONS(1582),
    [anon_sym_TILDE] = ACTIONS(1584),
    [anon_sym_BANG] = ACTIONS(1586),
    [anon_sym_PLUS] = ACTIONS(1588),
    [anon_sym_DASH] = ACTIONS(1590),
    [anon_sym_LT_DASH] = ACTIONS(211),
    [anon_sym_LT_LT_DASH] = ACTIONS(211),
    [anon_sym_COLON_EQ] = ACTIONS(211),
    [anon_sym_DASH_GT] = ACTIONS(209),
    [anon_sym_DASH_GT_GT] = ACTIONS(211),
    [anon_sym_PIPE] = ACTIONS(209),
    [anon_sym_AMP] = ACTIONS(209),
    [anon_sym_PIPE_PIPE] = ACTIONS(211),
    [anon_sym_AMP_AMP] = ACTIONS(211),
    [anon_sym_LT] = ACTIONS(209),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_GT] = ACTIONS(209),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [anon_sym_EQ_EQ] = ACTIONS(211),
    [anon_sym_BANG_EQ] = ACTIONS(211),
    [anon_sym_STAR] = ACTIONS(209),
    [anon_sym_SLASH] = ACTIONS(211),
    [anon_sym_STAR_STAR] = ACTIONS(211),
    [anon_sym_CARET] = ACTIONS(211),
    [aux_sym_binary_operator_token1] = ACTIONS(211),
    [anon_sym_PIPE_GT] = ACTIONS(211),
    [anon_sym_COLON] = ACTIONS(209),
    [anon_sym_DOLLAR] = ACTIONS(211),
    [anon_sym_AT] = ACTIONS(211),
    [aux_sym__hex_literal_token1] = ACTIONS(1592),
    [sym__number_literal] = ACTIONS(1594),
    [anon_sym_SQUOTE] = ACTIONS(1596),
    [anon_sym_DQUOTE] = ACTIONS(1598),
    [sym_return] = ACTIONS(1600),
    [sym_next] = ACTIONS(1600),
    [sym_break] = ACTIONS(1600),
    [sym_true] = ACTIONS(1600),
    [sym_false] = ACTIONS(1600),
    [sym_null] = ACTIONS(1600),
    [sym_inf] = ACTIONS(1600),
    [sym_nan] = ACTIONS(1600),
    [anon_sym_NA] = ACTIONS(1602),
    [anon_sym_NA_integer_] = ACTIONS(1602),
    [anon_sym_NA_real_] = ACTIONS(1602),
    [anon_sym_NA_complex_] = ACTIONS(1602),
    [anon_sym_NA_character_] = ACTIONS(1602),
    [sym_dots] = ACTIONS(1600),
    [sym_dot_dot_i] = ACTIONS(1604),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(211),
    [sym__newline] = ACTIONS(1606),
    [sym__raw_string_literal] = ACTIONS(1608),
    [sym__external_else] = ACTIONS(211),
    [sym__external_open_parenthesis] = ACTIONS(1610),
    [sym__external_close_parenthesis] = ACTIONS(2272),
    [sym__external_open_brace] = ACTIONS(1614),
    [sym__external_open_bracket] = ACTIONS(211),
    [sym__external_open_bracket2] = ACTIONS(211),
    [sym__external_close_bracket2] = ACTIONS(211),
  },
  [177] = {
    [sym_function_definition] = STATE(812),
    [sym_if_statement] = STATE(812),
    [sym_for_statement] = STATE(812),
    [sym_while_statement] = STATE(812),
    [sym_repeat_statement] = STATE(812),
    [sym_braced_expression] = STATE(812),
    [sym_parenthesized_expression] = STATE(812),
    [sym_call] = STATE(812),
    [sym_subset] = STATE(812),
    [sym_subset2] = STATE(812),
    [sym_unary_operator] = STATE(812),
    [sym_binary_operator] = STATE(812),
    [sym_extract_operator] = STATE(812),
    [sym_namespace_operator] = STATE(812),
    [sym_integer] = STATE(812),
    [sym_complex] = STATE(812),
    [sym_float] = STATE(812),
    [sym__hex_literal] = STATE(2183),
    [sym__float_literal] = STATE(2183),
    [sym_string] = STATE(2169),
    [sym__single_quoted_string] = STATE(2181),
    [sym__double_quoted_string] = STATE(2180),
    [sym_na] = STATE(812),
    [sym__expression] = STATE(812),
    [sym__string_or_identifier] = STATE(5149),
    [sym__open_parenthesis] = STATE(67),
    [sym__open_brace] = STATE(24),
    [aux_sym_function_definition_repeat1] = STATE(2281),
    [ts_builtin_sym_end] = ACTIONS(471),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_BSLASH] = ACTIONS(323),
    [anon_sym_function] = ACTIONS(325),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_if] = ACTIONS(327),
    [anon_sym_for] = ACTIONS(329),
    [anon_sym_while] = ACTIONS(331),
    [anon_sym_repeat] = ACTIONS(333),
    [anon_sym_QMARK] = ACTIONS(335),
    [anon_sym_TILDE] = ACTIONS(337),
    [anon_sym_BANG] = ACTIONS(339),
    [anon_sym_PLUS] = ACTIONS(341),
    [anon_sym_DASH] = ACTIONS(343),
    [anon_sym_LT_DASH] = ACTIONS(471),
    [anon_sym_LT_LT_DASH] = ACTIONS(471),
    [anon_sym_COLON_EQ] = ACTIONS(471),
    [anon_sym_DASH_GT] = ACTIONS(473),
    [anon_sym_DASH_GT_GT] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(473),
    [anon_sym_AMP] = ACTIONS(473),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_LT_EQ] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(473),
    [anon_sym_GT_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_STAR] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [aux_sym_binary_operator_token1] = ACTIONS(471),
    [anon_sym_PIPE_GT] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(473),
    [anon_sym_DOLLAR] = ACTIONS(471),
    [anon_sym_AT] = ACTIONS(471),
    [aux_sym__hex_literal_token1] = ACTIONS(345),
    [sym__number_literal] = ACTIONS(347),
    [anon_sym_SQUOTE] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(351),
    [sym_return] = ACTIONS(2274),
    [sym_next] = ACTIONS(2274),
    [sym_break] = ACTIONS(2274),
    [sym_true] = ACTIONS(2274),
    [sym_false] = ACTIONS(2274),
    [sym_null] = ACTIONS(2274),
    [sym_inf] = ACTIONS(2274),
    [sym_nan] = ACTIONS(2274),
    [anon_sym_NA] = ACTIONS(355),
    [anon_sym_NA_integer_] = ACTIONS(355),
    [anon_sym_NA_real_] = ACTIONS(355),
    [anon_sym_NA_complex_] = ACTIONS(355),
    [anon_sym_NA_character_] = ACTIONS(355),
    [sym_dots] = ACTIONS(2274),
    [sym_dot_dot_i] = ACTIONS(2276),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(471),
    [sym__newline] = ACTIONS(471),
    [sym__semicolon] = ACTIONS(471),
    [sym__raw_string_literal] = ACTIONS(361),
    [sym__external_open_parenthesis] = ACTIONS(363),
    [sym__external_close_parenthesis] = ACTIONS(471),
    [sym__external_open_brace] = ACTIONS(365),
    [sym__external_close_brace] = ACTIONS(471),
    [sym__external_open_bracket] = ACTIONS(471),
    [sym__external_open_bracket2] = ACTIONS(471),
  },
  [178] = {
    [sym_function_definition] = STATE(791),
    [sym_if_statement] = STATE(791),
    [sym_for_statement] = STATE(791),
    [sym_while_statement] = STATE(791),
    [sym_repeat_statement] = STATE(791),
    [sym_braced_expression] = STATE(791),
    [sym_parenthesized_expression] = STATE(791),
    [sym_call] = STATE(791),
    [sym_subset] = STATE(791),
    [sym_subset2] = STATE(791),
    [sym_unary_operator] = STATE(791),
    [sym_binary_operator] = STATE(791),
    [sym_extract_operator] = STATE(791),
    [sym_namespace_operator] = STATE(791),
    [sym_integer] = STATE(791),
    [sym_complex] = STATE(791),
    [sym_float] = STATE(791),
    [sym__hex_literal] = STATE(2183),
    [sym__float_literal] = STATE(2183),
    [sym_string] = STATE(2169),
    [sym__single_quoted_string] = STATE(2181),
    [sym__double_quoted_string] = STATE(2180),
    [sym_na] = STATE(791),
    [sym__expression] = STATE(791),
    [sym__string_or_identifier] = STATE(5149),
    [sym__open_parenthesis] = STATE(67),
    [sym__close_parenthesis] = STATE(2885),
    [sym__open_brace] = STATE(24),
    [aux_sym_parenthesized_expression_repeat1] = STATE(126),
    [ts_builtin_sym_end] = ACTIONS(129),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_BSLASH] = ACTIONS(323),
    [anon_sym_function] = ACTIONS(325),
    [anon_sym_EQ] = ACTIONS(109),
    [anon_sym_if] = ACTIONS(327),
    [anon_sym_for] = ACTIONS(329),
    [anon_sym_while] = ACTIONS(331),
    [anon_sym_repeat] = ACTIONS(333),
    [anon_sym_QMARK] = ACTIONS(335),
    [anon_sym_TILDE] = ACTIONS(337),
    [anon_sym_BANG] = ACTIONS(339),
    [anon_sym_PLUS] = ACTIONS(341),
    [anon_sym_DASH] = ACTIONS(343),
    [anon_sym_LT_DASH] = ACTIONS(129),
    [anon_sym_LT_LT_DASH] = ACTIONS(129),
    [anon_sym_COLON_EQ] = ACTIONS(129),
    [anon_sym_DASH_GT] = ACTIONS(109),
    [anon_sym_DASH_GT_GT] = ACTIONS(129),
    [anon_sym_PIPE] = ACTIONS(109),
    [anon_sym_AMP] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_STAR_STAR] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [aux_sym_binary_operator_token1] = ACTIONS(129),
    [anon_sym_PIPE_GT] = ACTIONS(129),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(129),
    [anon_sym_AT] = ACTIONS(129),
    [aux_sym__hex_literal_token1] = ACTIONS(345),
    [sym__number_literal] = ACTIONS(347),
    [anon_sym_SQUOTE] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(351),
    [sym_return] = ACTIONS(971),
    [sym_next] = ACTIONS(971),
    [sym_break] = ACTIONS(971),
    [sym_true] = ACTIONS(971),
    [sym_false] = ACTIONS(971),
    [sym_null] = ACTIONS(971),
    [sym_inf] = ACTIONS(971),
    [sym_nan] = ACTIONS(971),
    [anon_sym_NA] = ACTIONS(355),
    [anon_sym_NA_integer_] = ACTIONS(355),
    [anon_sym_NA_real_] = ACTIONS(355),
    [anon_sym_NA_complex_] = ACTIONS(355),
    [anon_sym_NA_character_] = ACTIONS(355),
    [sym_dots] = ACTIONS(971),
    [sym_dot_dot_i] = ACTIONS(973),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(975),
    [sym__semicolon] = ACTIONS(129),
    [sym__raw_string_literal] = ACTIONS(361),
    [sym__external_open_parenthesis] = ACTIONS(363),
    [sym__external_close_parenthesis] = ACTIONS(2278),
    [sym__external_open_brace] = ACTIONS(365),
    [sym__external_close_brace] = ACTIONS(129),
    [sym__external_open_bracket] = ACTIONS(129),
    [sym__external_open_bracket2] = ACTIONS(129),
  },
  [179] = {
    [sym_function_definition] = STATE(913),
    [sym_if_statement] = STATE(913),
    [sym_for_statement] = STATE(913),
    [sym_while_statement] = STATE(913),
    [sym_repeat_statement] = STATE(913),
    [sym_braced_expression] = STATE(913),
    [sym_parenthesized_expression] = STATE(913),
    [sym_call] = STATE(913),
    [sym_subset] = STATE(913),
    [sym_subset2] = STATE(913),
    [sym_unary_operator] = STATE(913),
    [sym_binary_operator] = STATE(913),
    [sym_extract_operator] = STATE(913),
    [sym_namespace_operator] = STATE(913),
    [sym_integer] = STATE(913),
    [sym_complex] = STATE(913),
    [sym_float] = STATE(913),
    [sym__hex_literal] = STATE(2210),
    [sym__float_literal] = STATE(2210),
    [sym_string] = STATE(2209),
    [sym__single_quoted_string] = STATE(2211),
    [sym__double_quoted_string] = STATE(2212),
    [sym_na] = STATE(913),
    [sym__expression] = STATE(913),
    [sym__string_or_identifier] = STATE(5127),
    [sym__open_parenthesis] = STATE(5),
    [sym__open_brace] = STATE(42),
    [aux_sym_function_definition_repeat1] = STATE(182),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_BSLASH] = ACTIONS(407),
    [anon_sym_function] = ACTIONS(409),
    [anon_sym_EQ] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(411),
    [anon_sym_for] = ACTIONS(413),
    [anon_sym_while] = ACTIONS(415),
    [anon_sym_repeat] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_TILDE] = ACTIONS(421),
    [anon_sym_BANG] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(427),
    [anon_sym_LT_DASH] = ACTIONS(263),
    [anon_sym_LT_LT_DASH] = ACTIONS(263),
    [anon_sym_COLON_EQ] = ACTIONS(263),
    [anon_sym_DASH_GT] = ACTIONS(265),
    [anon_sym_DASH_GT_GT] = ACTIONS(263),
    [anon_sym_PIPE] = ACTIONS(265),
    [anon_sym_AMP] = ACTIONS(265),
    [anon_sym_PIPE_PIPE] = ACTIONS(263),
    [anon_sym_AMP_AMP] = ACTIONS(263),
    [anon_sym_LT] = ACTIONS(265),
    [anon_sym_LT_EQ] = ACTIONS(263),
    [anon_sym_GT] = ACTIONS(265),
    [anon_sym_GT_EQ] = ACTIONS(263),
    [anon_sym_EQ_EQ] = ACTIONS(263),
    [anon_sym_BANG_EQ] = ACTIONS(263),
    [anon_sym_STAR] = ACTIONS(265),
    [anon_sym_SLASH] = ACTIONS(263),
    [anon_sym_STAR_STAR] = ACTIONS(263),
    [anon_sym_CARET] = ACTIONS(263),
    [aux_sym_binary_operator_token1] = ACTIONS(263),
    [anon_sym_PIPE_GT] = ACTIONS(263),
    [anon_sym_COLON] = ACTIONS(265),
    [anon_sym_DOLLAR] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(263),
    [aux_sym__hex_literal_token1] = ACTIONS(429),
    [sym__number_literal] = ACTIONS(431),
    [anon_sym_SQUOTE] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_return] = ACTIONS(2280),
    [sym_next] = ACTIONS(2280),
    [sym_break] = ACTIONS(2280),
    [sym_true] = ACTIONS(2280),
    [sym_false] = ACTIONS(2280),
    [sym_null] = ACTIONS(2280),
    [sym_inf] = ACTIONS(2280),
    [sym_nan] = ACTIONS(2280),
    [anon_sym_NA] = ACTIONS(439),
    [anon_sym_NA_integer_] = ACTIONS(439),
    [anon_sym_NA_real_] = ACTIONS(439),
    [anon_sym_NA_complex_] = ACTIONS(439),
    [anon_sym_NA_character_] = ACTIONS(439),
    [sym_dots] = ACTIONS(2280),
    [sym_dot_dot_i] = ACTIONS(2282),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(263),
    [sym__newline] = ACTIONS(2284),
    [sym__semicolon] = ACTIONS(263),
    [sym__raw_string_literal] = ACTIONS(445),
    [sym__external_else] = ACTIONS(263),
    [sym__external_open_parenthesis] = ACTIONS(447),
    [sym__external_open_brace] = ACTIONS(449),
    [sym__external_close_brace] = ACTIONS(263),
    [sym__external_open_bracket] = ACTIONS(263),
    [sym__external_open_bracket2] = ACTIONS(263),
    [sym__external_close_bracket2] = ACTIONS(263),
  },
  [180] = {
    [sym_function_definition] = STATE(970),
    [sym_if_statement] = STATE(970),
    [sym_for_statement] = STATE(970),
    [sym_while_statement] = STATE(970),
    [sym_repeat_statement] = STATE(970),
    [sym_braced_expression] = STATE(970),
    [sym_parenthesized_expression] = STATE(970),
    [sym_call] = STATE(970),
    [sym_subset] = STATE(970),
    [sym_subset2] = STATE(970),
    [sym_unary_operator] = STATE(970),
    [sym_binary_operator] = STATE(970),
    [sym_extract_operator] = STATE(970),
    [sym_namespace_operator] = STATE(970),
    [sym_integer] = STATE(970),
    [sym_complex] = STATE(970),
    [sym_float] = STATE(970),
    [sym__hex_literal] = STATE(2266),
    [sym__float_literal] = STATE(2266),
    [sym_string] = STATE(2284),
    [sym__single_quoted_string] = STATE(2265),
    [sym__double_quoted_string] = STATE(2264),
    [sym_na] = STATE(970),
    [sym__expression] = STATE(970),
    [sym__string_or_identifier] = STATE(5147),
    [sym__open_parenthesis] = STATE(23),
    [sym__open_brace] = STATE(180),
    [sym__close_brace] = STATE(2655),
    [aux_sym_braced_expression_repeat1] = STATE(103),
    [sym_identifier] = ACTIONS(1289),
    [anon_sym_BSLASH] = ACTIONS(1291),
    [anon_sym_function] = ACTIONS(1293),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(1295),
    [anon_sym_for] = ACTIONS(1297),
    [anon_sym_while] = ACTIONS(1299),
    [anon_sym_repeat] = ACTIONS(1301),
    [anon_sym_QMARK] = ACTIONS(1303),
    [anon_sym_TILDE] = ACTIONS(1305),
    [anon_sym_BANG] = ACTIONS(1307),
    [anon_sym_PLUS] = ACTIONS(1309),
    [anon_sym_DASH] = ACTIONS(1311),
    [anon_sym_LT_DASH] = ACTIONS(155),
    [anon_sym_LT_LT_DASH] = ACTIONS(155),
    [anon_sym_COLON_EQ] = ACTIONS(155),
    [anon_sym_DASH_GT] = ACTIONS(157),
    [anon_sym_DASH_GT_GT] = ACTIONS(155),
    [anon_sym_PIPE] = ACTIONS(157),
    [anon_sym_AMP] = ACTIONS(157),
    [anon_sym_PIPE_PIPE] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(157),
    [anon_sym_LT_EQ] = ACTIONS(155),
    [anon_sym_GT] = ACTIONS(157),
    [anon_sym_GT_EQ] = ACTIONS(155),
    [anon_sym_EQ_EQ] = ACTIONS(155),
    [anon_sym_BANG_EQ] = ACTIONS(155),
    [anon_sym_STAR] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(155),
    [anon_sym_STAR_STAR] = ACTIONS(155),
    [anon_sym_CARET] = ACTIONS(155),
    [aux_sym_binary_operator_token1] = ACTIONS(155),
    [anon_sym_PIPE_GT] = ACTIONS(155),
    [anon_sym_COLON] = ACTIONS(157),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(155),
    [aux_sym__hex_literal_token1] = ACTIONS(1313),
    [sym__number_literal] = ACTIONS(1315),
    [anon_sym_SQUOTE] = ACTIONS(1317),
    [anon_sym_DQUOTE] = ACTIONS(1319),
    [sym_return] = ACTIONS(1321),
    [sym_next] = ACTIONS(1321),
    [sym_break] = ACTIONS(1321),
    [sym_true] = ACTIONS(1321),
    [sym_false] = ACTIONS(1321),
    [sym_null] = ACTIONS(1321),
    [sym_inf] = ACTIONS(1321),
    [sym_nan] = ACTIONS(1321),
    [anon_sym_NA] = ACTIONS(1323),
    [anon_sym_NA_integer_] = ACTIONS(1323),
    [anon_sym_NA_real_] = ACTIONS(1323),
    [anon_sym_NA_complex_] = ACTIONS(1323),
    [anon_sym_NA_character_] = ACTIONS(1323),
    [sym_dots] = ACTIONS(1321),
    [sym_dot_dot_i] = ACTIONS(1325),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(155),
    [sym__newline] = ACTIONS(1327),
    [sym__semicolon] = ACTIONS(1327),
    [sym__raw_string_literal] = ACTIONS(1329),
    [sym__external_open_parenthesis] = ACTIONS(1331),
    [sym__external_open_brace] = ACTIONS(1333),
    [sym__external_close_brace] = ACTIONS(2286),
    [sym__external_open_bracket] = ACTIONS(155),
    [sym__external_close_bracket] = ACTIONS(155),
    [sym__external_open_bracket2] = ACTIONS(155),
  },
  [181] = {
    [sym_function_definition] = STATE(919),
    [sym_if_statement] = STATE(919),
    [sym_for_statement] = STATE(919),
    [sym_while_statement] = STATE(919),
    [sym_repeat_statement] = STATE(919),
    [sym_braced_expression] = STATE(919),
    [sym_parenthesized_expression] = STATE(919),
    [sym_call] = STATE(919),
    [sym_subset] = STATE(919),
    [sym_subset2] = STATE(919),
    [sym_unary_operator] = STATE(919),
    [sym_binary_operator] = STATE(919),
    [sym_extract_operator] = STATE(919),
    [sym_namespace_operator] = STATE(919),
    [sym_integer] = STATE(919),
    [sym_complex] = STATE(919),
    [sym_float] = STATE(919),
    [sym__hex_literal] = STATE(2210),
    [sym__float_literal] = STATE(2210),
    [sym_string] = STATE(2209),
    [sym__single_quoted_string] = STATE(2211),
    [sym__double_quoted_string] = STATE(2212),
    [sym_na] = STATE(919),
    [sym__expression] = STATE(919),
    [sym__string_or_identifier] = STATE(5127),
    [sym__open_parenthesis] = STATE(5),
    [sym__open_brace] = STATE(42),
    [aux_sym_function_definition_repeat1] = STATE(183),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_BSLASH] = ACTIONS(407),
    [anon_sym_function] = ACTIONS(409),
    [anon_sym_EQ] = ACTIONS(543),
    [anon_sym_if] = ACTIONS(411),
    [anon_sym_for] = ACTIONS(413),
    [anon_sym_while] = ACTIONS(415),
    [anon_sym_repeat] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_TILDE] = ACTIONS(421),
    [anon_sym_BANG] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(427),
    [anon_sym_LT_DASH] = ACTIONS(545),
    [anon_sym_LT_LT_DASH] = ACTIONS(545),
    [anon_sym_COLON_EQ] = ACTIONS(545),
    [anon_sym_DASH_GT] = ACTIONS(543),
    [anon_sym_DASH_GT_GT] = ACTIONS(545),
    [anon_sym_PIPE] = ACTIONS(543),
    [anon_sym_AMP] = ACTIONS(543),
    [anon_sym_PIPE_PIPE] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(543),
    [anon_sym_LT_EQ] = ACTIONS(545),
    [anon_sym_GT] = ACTIONS(543),
    [anon_sym_GT_EQ] = ACTIONS(545),
    [anon_sym_EQ_EQ] = ACTIONS(545),
    [anon_sym_BANG_EQ] = ACTIONS(545),
    [anon_sym_STAR] = ACTIONS(543),
    [anon_sym_SLASH] = ACTIONS(545),
    [anon_sym_STAR_STAR] = ACTIONS(545),
    [anon_sym_CARET] = ACTIONS(545),
    [aux_sym_binary_operator_token1] = ACTIONS(545),
    [anon_sym_PIPE_GT] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(543),
    [anon_sym_DOLLAR] = ACTIONS(545),
    [anon_sym_AT] = ACTIONS(545),
    [aux_sym__hex_literal_token1] = ACTIONS(429),
    [sym__number_literal] = ACTIONS(431),
    [anon_sym_SQUOTE] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_return] = ACTIONS(2288),
    [sym_next] = ACTIONS(2288),
    [sym_break] = ACTIONS(2288),
    [sym_true] = ACTIONS(2288),
    [sym_false] = ACTIONS(2288),
    [sym_null] = ACTIONS(2288),
    [sym_inf] = ACTIONS(2288),
    [sym_nan] = ACTIONS(2288),
    [anon_sym_NA] = ACTIONS(439),
    [anon_sym_NA_integer_] = ACTIONS(439),
    [anon_sym_NA_real_] = ACTIONS(439),
    [anon_sym_NA_complex_] = ACTIONS(439),
    [anon_sym_NA_character_] = ACTIONS(439),
    [sym_dots] = ACTIONS(2288),
    [sym_dot_dot_i] = ACTIONS(2290),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(545),
    [sym__newline] = ACTIONS(2292),
    [sym__semicolon] = ACTIONS(545),
    [sym__raw_string_literal] = ACTIONS(445),
    [sym__external_else] = ACTIONS(545),
    [sym__external_open_parenthesis] = ACTIONS(447),
    [sym__external_open_brace] = ACTIONS(449),
    [sym__external_close_brace] = ACTIONS(545),
    [sym__external_open_bracket] = ACTIONS(545),
    [sym__external_open_bracket2] = ACTIONS(545),
    [sym__external_close_bracket2] = ACTIONS(545),
  },
  [182] = {
    [sym_function_definition] = STATE(922),
    [sym_if_statement] = STATE(922),
    [sym_for_statement] = STATE(922),
    [sym_while_statement] = STATE(922),
    [sym_repeat_statement] = STATE(922),
    [sym_braced_expression] = STATE(922),
    [sym_parenthesized_expression] = STATE(922),
    [sym_call] = STATE(922),
    [sym_subset] = STATE(922),
    [sym_subset2] = STATE(922),
    [sym_unary_operator] = STATE(922),
    [sym_binary_operator] = STATE(922),
    [sym_extract_operator] = STATE(922),
    [sym_namespace_operator] = STATE(922),
    [sym_integer] = STATE(922),
    [sym_complex] = STATE(922),
    [sym_float] = STATE(922),
    [sym__hex_literal] = STATE(2210),
    [sym__float_literal] = STATE(2210),
    [sym_string] = STATE(2209),
    [sym__single_quoted_string] = STATE(2211),
    [sym__double_quoted_string] = STATE(2212),
    [sym_na] = STATE(922),
    [sym__expression] = STATE(922),
    [sym__string_or_identifier] = STATE(5127),
    [sym__open_parenthesis] = STATE(5),
    [sym__open_brace] = STATE(42),
    [aux_sym_function_definition_repeat1] = STATE(2349),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_BSLASH] = ACTIONS(407),
    [anon_sym_function] = ACTIONS(409),
    [anon_sym_EQ] = ACTIONS(767),
    [anon_sym_if] = ACTIONS(411),
    [anon_sym_for] = ACTIONS(413),
    [anon_sym_while] = ACTIONS(415),
    [anon_sym_repeat] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_TILDE] = ACTIONS(421),
    [anon_sym_BANG] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(427),
    [anon_sym_LT_DASH] = ACTIONS(765),
    [anon_sym_LT_LT_DASH] = ACTIONS(765),
    [anon_sym_COLON_EQ] = ACTIONS(765),
    [anon_sym_DASH_GT] = ACTIONS(767),
    [anon_sym_DASH_GT_GT] = ACTIONS(765),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_AMP] = ACTIONS(767),
    [anon_sym_PIPE_PIPE] = ACTIONS(765),
    [anon_sym_AMP_AMP] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(767),
    [anon_sym_LT_EQ] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_GT_EQ] = ACTIONS(765),
    [anon_sym_EQ_EQ] = ACTIONS(765),
    [anon_sym_BANG_EQ] = ACTIONS(765),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(765),
    [anon_sym_STAR_STAR] = ACTIONS(765),
    [anon_sym_CARET] = ACTIONS(765),
    [aux_sym_binary_operator_token1] = ACTIONS(765),
    [anon_sym_PIPE_GT] = ACTIONS(765),
    [anon_sym_COLON] = ACTIONS(767),
    [anon_sym_DOLLAR] = ACTIONS(765),
    [anon_sym_AT] = ACTIONS(765),
    [aux_sym__hex_literal_token1] = ACTIONS(429),
    [sym__number_literal] = ACTIONS(431),
    [anon_sym_SQUOTE] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_return] = ACTIONS(2294),
    [sym_next] = ACTIONS(2294),
    [sym_break] = ACTIONS(2294),
    [sym_true] = ACTIONS(2294),
    [sym_false] = ACTIONS(2294),
    [sym_null] = ACTIONS(2294),
    [sym_inf] = ACTIONS(2294),
    [sym_nan] = ACTIONS(2294),
    [anon_sym_NA] = ACTIONS(439),
    [anon_sym_NA_integer_] = ACTIONS(439),
    [anon_sym_NA_real_] = ACTIONS(439),
    [anon_sym_NA_complex_] = ACTIONS(439),
    [anon_sym_NA_character_] = ACTIONS(439),
    [sym_dots] = ACTIONS(2294),
    [sym_dot_dot_i] = ACTIONS(2296),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(765),
    [sym__newline] = ACTIONS(765),
    [sym__semicolon] = ACTIONS(765),
    [sym__raw_string_literal] = ACTIONS(445),
    [sym__external_else] = ACTIONS(765),
    [sym__external_open_parenthesis] = ACTIONS(447),
    [sym__external_open_brace] = ACTIONS(449),
    [sym__external_close_brace] = ACTIONS(765),
    [sym__external_open_bracket] = ACTIONS(765),
    [sym__external_open_bracket2] = ACTIONS(765),
    [sym__external_close_bracket2] = ACTIONS(765),
  },
  [183] = {
    [sym_function_definition] = STATE(941),
    [sym_if_statement] = STATE(941),
    [sym_for_statement] = STATE(941),
    [sym_while_statement] = STATE(941),
    [sym_repeat_statement] = STATE(941),
    [sym_braced_expression] = STATE(941),
    [sym_parenthesized_expression] = STATE(941),
    [sym_call] = STATE(941),
    [sym_subset] = STATE(941),
    [sym_subset2] = STATE(941),
    [sym_unary_operator] = STATE(941),
    [sym_binary_operator] = STATE(941),
    [sym_extract_operator] = STATE(941),
    [sym_namespace_operator] = STATE(941),
    [sym_integer] = STATE(941),
    [sym_complex] = STATE(941),
    [sym_float] = STATE(941),
    [sym__hex_literal] = STATE(2210),
    [sym__float_literal] = STATE(2210),
    [sym_string] = STATE(2209),
    [sym__single_quoted_string] = STATE(2211),
    [sym__double_quoted_string] = STATE(2212),
    [sym_na] = STATE(941),
    [sym__expression] = STATE(941),
    [sym__string_or_identifier] = STATE(5127),
    [sym__open_parenthesis] = STATE(5),
    [sym__open_brace] = STATE(42),
    [aux_sym_function_definition_repeat1] = STATE(2349),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_BSLASH] = ACTIONS(407),
    [anon_sym_function] = ACTIONS(409),
    [anon_sym_EQ] = ACTIONS(759),
    [anon_sym_if] = ACTIONS(411),
    [anon_sym_for] = ACTIONS(413),
    [anon_sym_while] = ACTIONS(415),
    [anon_sym_repeat] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_TILDE] = ACTIONS(421),
    [anon_sym_BANG] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(427),
    [anon_sym_LT_DASH] = ACTIONS(757),
    [anon_sym_LT_LT_DASH] = ACTIONS(757),
    [anon_sym_COLON_EQ] = ACTIONS(757),
    [anon_sym_DASH_GT] = ACTIONS(759),
    [anon_sym_DASH_GT_GT] = ACTIONS(757),
    [anon_sym_PIPE] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(759),
    [anon_sym_PIPE_PIPE] = ACTIONS(757),
    [anon_sym_AMP_AMP] = ACTIONS(757),
    [anon_sym_LT] = ACTIONS(759),
    [anon_sym_LT_EQ] = ACTIONS(757),
    [anon_sym_GT] = ACTIONS(759),
    [anon_sym_GT_EQ] = ACTIONS(757),
    [anon_sym_EQ_EQ] = ACTIONS(757),
    [anon_sym_BANG_EQ] = ACTIONS(757),
    [anon_sym_STAR] = ACTIONS(759),
    [anon_sym_SLASH] = ACTIONS(757),
    [anon_sym_STAR_STAR] = ACTIONS(757),
    [anon_sym_CARET] = ACTIONS(757),
    [aux_sym_binary_operator_token1] = ACTIONS(757),
    [anon_sym_PIPE_GT] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(759),
    [anon_sym_DOLLAR] = ACTIONS(757),
    [anon_sym_AT] = ACTIONS(757),
    [aux_sym__hex_literal_token1] = ACTIONS(429),
    [sym__number_literal] = ACTIONS(431),
    [anon_sym_SQUOTE] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_return] = ACTIONS(2298),
    [sym_next] = ACTIONS(2298),
    [sym_break] = ACTIONS(2298),
    [sym_true] = ACTIONS(2298),
    [sym_false] = ACTIONS(2298),
    [sym_null] = ACTIONS(2298),
    [sym_inf] = ACTIONS(2298),
    [sym_nan] = ACTIONS(2298),
    [anon_sym_NA] = ACTIONS(439),
    [anon_sym_NA_integer_] = ACTIONS(439),
    [anon_sym_NA_real_] = ACTIONS(439),
    [anon_sym_NA_complex_] = ACTIONS(439),
    [anon_sym_NA_character_] = ACTIONS(439),
    [sym_dots] = ACTIONS(2298),
    [sym_dot_dot_i] = ACTIONS(2300),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(757),
    [sym__newline] = ACTIONS(757),
    [sym__semicolon] = ACTIONS(757),
    [sym__raw_string_literal] = ACTIONS(445),
    [sym__external_else] = ACTIONS(757),
    [sym__external_open_parenthesis] = ACTIONS(447),
    [sym__external_open_brace] = ACTIONS(449),
    [sym__external_close_brace] = ACTIONS(757),
    [sym__external_open_bracket] = ACTIONS(757),
    [sym__external_open_bracket2] = ACTIONS(757),
    [sym__external_close_bracket2] = ACTIONS(757),
  },
  [184] = {
    [sym_function_definition] = STATE(1072),
    [sym_if_statement] = STATE(1072),
    [sym_for_statement] = STATE(1072),
    [sym_while_statement] = STATE(1072),
    [sym_repeat_statement] = STATE(1072),
    [sym_braced_expression] = STATE(1072),
    [sym_parenthesized_expression] = STATE(1072),
    [sym_call] = STATE(1072),
    [sym_subset] = STATE(1072),
    [sym_subset2] = STATE(1072),
    [sym_unary_operator] = STATE(1072),
    [sym_binary_operator] = STATE(1072),
    [sym_extract_operator] = STATE(1072),
    [sym_namespace_operator] = STATE(1072),
    [sym_integer] = STATE(1072),
    [sym_complex] = STATE(1072),
    [sym_float] = STATE(1072),
    [sym__hex_literal] = STATE(2311),
    [sym__float_literal] = STATE(2311),
    [sym_string] = STATE(2312),
    [sym__single_quoted_string] = STATE(2310),
    [sym__double_quoted_string] = STATE(2309),
    [sym_na] = STATE(1072),
    [sym__expression] = STATE(1072),
    [sym__string_or_identifier] = STATE(5134),
    [sym__open_parenthesis] = STATE(64),
    [sym__open_brace] = STATE(199),
    [sym__close_brace] = STATE(2591),
    [aux_sym_braced_expression_repeat1] = STATE(279),
    [ts_builtin_sym_end] = ACTIONS(51),
    [sym_identifier] = ACTIONS(1385),
    [anon_sym_BSLASH] = ACTIONS(1387),
    [anon_sym_function] = ACTIONS(1389),
    [anon_sym_EQ] = ACTIONS(59),
    [anon_sym_if] = ACTIONS(1391),
    [anon_sym_for] = ACTIONS(1393),
    [anon_sym_while] = ACTIONS(1395),
    [anon_sym_repeat] = ACTIONS(1397),
    [anon_sym_QMARK] = ACTIONS(1399),
    [anon_sym_TILDE] = ACTIONS(1401),
    [anon_sym_BANG] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1407),
    [anon_sym_LT_DASH] = ACTIONS(51),
    [anon_sym_LT_LT_DASH] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(51),
    [anon_sym_DASH_GT] = ACTIONS(59),
    [anon_sym_DASH_GT_GT] = ACTIONS(51),
    [anon_sym_PIPE] = ACTIONS(59),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_AMP_AMP] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(59),
    [anon_sym_LT_EQ] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(59),
    [anon_sym_GT_EQ] = ACTIONS(51),
    [anon_sym_EQ_EQ] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(51),
    [anon_sym_CARET] = ACTIONS(51),
    [aux_sym_binary_operator_token1] = ACTIONS(51),
    [anon_sym_PIPE_GT] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(59),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_AT] = ACTIONS(51),
    [aux_sym__hex_literal_token1] = ACTIONS(1409),
    [sym__number_literal] = ACTIONS(1411),
    [anon_sym_SQUOTE] = ACTIONS(1413),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [sym_return] = ACTIONS(1417),
    [sym_next] = ACTIONS(1417),
    [sym_break] = ACTIONS(1417),
    [sym_true] = ACTIONS(1417),
    [sym_false] = ACTIONS(1417),
    [sym_null] = ACTIONS(1417),
    [sym_inf] = ACTIONS(1417),
    [sym_nan] = ACTIONS(1417),
    [anon_sym_NA] = ACTIONS(1419),
    [anon_sym_NA_integer_] = ACTIONS(1419),
    [anon_sym_NA_real_] = ACTIONS(1419),
    [anon_sym_NA_complex_] = ACTIONS(1419),
    [anon_sym_NA_character_] = ACTIONS(1419),
    [sym_dots] = ACTIONS(1417),
    [sym_dot_dot_i] = ACTIONS(1421),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1423),
    [sym__semicolon] = ACTIONS(1423),
    [sym__raw_string_literal] = ACTIONS(1425),
    [sym__external_else] = ACTIONS(51),
    [sym__external_open_parenthesis] = ACTIONS(1427),
    [sym__external_open_brace] = ACTIONS(1429),
    [sym__external_close_brace] = ACTIONS(2302),
    [sym__external_open_bracket] = ACTIONS(51),
    [sym__external_open_bracket2] = ACTIONS(51),
  },
  [185] = {
    [sym_function_definition] = STATE(1152),
    [sym_if_statement] = STATE(1152),
    [sym_for_statement] = STATE(1152),
    [sym_while_statement] = STATE(1152),
    [sym_repeat_statement] = STATE(1152),
    [sym_braced_expression] = STATE(1152),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_call] = STATE(1152),
    [sym_subset] = STATE(1152),
    [sym_subset2] = STATE(1152),
    [sym_unary_operator] = STATE(1152),
    [sym_binary_operator] = STATE(1152),
    [sym_extract_operator] = STATE(1152),
    [sym_namespace_operator] = STATE(1152),
    [sym_integer] = STATE(1152),
    [sym_complex] = STATE(1152),
    [sym_float] = STATE(1152),
    [sym__hex_literal] = STATE(2235),
    [sym__float_literal] = STATE(2235),
    [sym_string] = STATE(2234),
    [sym__single_quoted_string] = STATE(2236),
    [sym__double_quoted_string] = STATE(2237),
    [sym_na] = STATE(1152),
    [sym__expression] = STATE(1152),
    [sym__string_or_identifier] = STATE(5150),
    [sym__open_parenthesis] = STATE(76),
    [sym__open_brace] = STATE(188),
    [sym__close_brace] = STATE(2974),
    [aux_sym_braced_expression_repeat1] = STATE(136),
    [sym_identifier] = ACTIONS(1433),
    [anon_sym_BSLASH] = ACTIONS(1435),
    [anon_sym_function] = ACTIONS(1437),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(1439),
    [anon_sym_for] = ACTIONS(1441),
    [anon_sym_while] = ACTIONS(1443),
    [anon_sym_repeat] = ACTIONS(1445),
    [anon_sym_QMARK] = ACTIONS(1447),
    [anon_sym_TILDE] = ACTIONS(1449),
    [anon_sym_BANG] = ACTIONS(1451),
    [anon_sym_PLUS] = ACTIONS(1453),
    [anon_sym_DASH] = ACTIONS(1455),
    [anon_sym_LT_DASH] = ACTIONS(155),
    [anon_sym_LT_LT_DASH] = ACTIONS(155),
    [anon_sym_COLON_EQ] = ACTIONS(155),
    [anon_sym_DASH_GT] = ACTIONS(157),
    [anon_sym_DASH_GT_GT] = ACTIONS(155),
    [anon_sym_PIPE] = ACTIONS(157),
    [anon_sym_AMP] = ACTIONS(157),
    [anon_sym_PIPE_PIPE] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(157),
    [anon_sym_LT_EQ] = ACTIONS(155),
    [anon_sym_GT] = ACTIONS(157),
    [anon_sym_GT_EQ] = ACTIONS(155),
    [anon_sym_EQ_EQ] = ACTIONS(155),
    [anon_sym_BANG_EQ] = ACTIONS(155),
    [anon_sym_STAR] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(155),
    [anon_sym_STAR_STAR] = ACTIONS(155),
    [anon_sym_CARET] = ACTIONS(155),
    [aux_sym_binary_operator_token1] = ACTIONS(155),
    [anon_sym_PIPE_GT] = ACTIONS(155),
    [anon_sym_COLON] = ACTIONS(157),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(155),
    [aux_sym__hex_literal_token1] = ACTIONS(1457),
    [sym__number_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [anon_sym_DQUOTE] = ACTIONS(1463),
    [sym_return] = ACTIONS(1465),
    [sym_next] = ACTIONS(1465),
    [sym_break] = ACTIONS(1465),
    [sym_true] = ACTIONS(1465),
    [sym_false] = ACTIONS(1465),
    [sym_null] = ACTIONS(1465),
    [sym_inf] = ACTIONS(1465),
    [sym_nan] = ACTIONS(1465),
    [anon_sym_NA] = ACTIONS(1467),
    [anon_sym_NA_integer_] = ACTIONS(1467),
    [anon_sym_NA_real_] = ACTIONS(1467),
    [anon_sym_NA_complex_] = ACTIONS(1467),
    [anon_sym_NA_character_] = ACTIONS(1467),
    [sym_dots] = ACTIONS(1465),
    [sym_dot_dot_i] = ACTIONS(1469),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(155),
    [sym__newline] = ACTIONS(1471),
    [sym__semicolon] = ACTIONS(1471),
    [sym__raw_string_literal] = ACTIONS(1473),
    [sym__external_open_parenthesis] = ACTIONS(1475),
    [sym__external_open_brace] = ACTIONS(1477),
    [sym__external_close_brace] = ACTIONS(2304),
    [sym__external_open_bracket] = ACTIONS(155),
    [sym__external_open_bracket2] = ACTIONS(155),
    [sym__external_close_bracket2] = ACTIONS(155),
  },
  [186] = {
    [sym_function_definition] = STATE(962),
    [sym_if_statement] = STATE(962),
    [sym_for_statement] = STATE(962),
    [sym_while_statement] = STATE(962),
    [sym_repeat_statement] = STATE(962),
    [sym_braced_expression] = STATE(962),
    [sym_parenthesized_expression] = STATE(962),
    [sym_call] = STATE(962),
    [sym_subset] = STATE(962),
    [sym_subset2] = STATE(962),
    [sym_unary_operator] = STATE(962),
    [sym_binary_operator] = STATE(962),
    [sym_extract_operator] = STATE(962),
    [sym_namespace_operator] = STATE(962),
    [sym_integer] = STATE(962),
    [sym_complex] = STATE(962),
    [sym_float] = STATE(962),
    [sym__hex_literal] = STATE(2210),
    [sym__float_literal] = STATE(2210),
    [sym_string] = STATE(2209),
    [sym__single_quoted_string] = STATE(2211),
    [sym__double_quoted_string] = STATE(2212),
    [sym_na] = STATE(962),
    [sym__expression] = STATE(962),
    [sym__string_or_identifier] = STATE(5127),
    [sym__open_parenthesis] = STATE(5),
    [sym__open_brace] = STATE(42),
    [aux_sym_function_definition_repeat1] = STATE(187),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_BSLASH] = ACTIONS(407),
    [anon_sym_function] = ACTIONS(409),
    [anon_sym_EQ] = ACTIONS(533),
    [anon_sym_if] = ACTIONS(411),
    [anon_sym_for] = ACTIONS(413),
    [anon_sym_while] = ACTIONS(415),
    [anon_sym_repeat] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_TILDE] = ACTIONS(421),
    [anon_sym_BANG] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(427),
    [anon_sym_LT_DASH] = ACTIONS(531),
    [anon_sym_LT_LT_DASH] = ACTIONS(531),
    [anon_sym_COLON_EQ] = ACTIONS(531),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_DASH_GT_GT] = ACTIONS(531),
    [anon_sym_PIPE] = ACTIONS(533),
    [anon_sym_AMP] = ACTIONS(533),
    [anon_sym_PIPE_PIPE] = ACTIONS(531),
    [anon_sym_AMP_AMP] = ACTIONS(531),
    [anon_sym_LT] = ACTIONS(533),
    [anon_sym_LT_EQ] = ACTIONS(531),
    [anon_sym_GT] = ACTIONS(533),
    [anon_sym_GT_EQ] = ACTIONS(531),
    [anon_sym_EQ_EQ] = ACTIONS(531),
    [anon_sym_BANG_EQ] = ACTIONS(531),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_SLASH] = ACTIONS(531),
    [anon_sym_STAR_STAR] = ACTIONS(531),
    [anon_sym_CARET] = ACTIONS(531),
    [aux_sym_binary_operator_token1] = ACTIONS(531),
    [anon_sym_PIPE_GT] = ACTIONS(531),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_DOLLAR] = ACTIONS(531),
    [anon_sym_AT] = ACTIONS(531),
    [aux_sym__hex_literal_token1] = ACTIONS(429),
    [sym__number_literal] = ACTIONS(431),
    [anon_sym_SQUOTE] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_return] = ACTIONS(2306),
    [sym_next] = ACTIONS(2306),
    [sym_break] = ACTIONS(2306),
    [sym_true] = ACTIONS(2306),
    [sym_false] = ACTIONS(2306),
    [sym_null] = ACTIONS(2306),
    [sym_inf] = ACTIONS(2306),
    [sym_nan] = ACTIONS(2306),
    [anon_sym_NA] = ACTIONS(439),
    [anon_sym_NA_integer_] = ACTIONS(439),
    [anon_sym_NA_real_] = ACTIONS(439),
    [anon_sym_NA_complex_] = ACTIONS(439),
    [anon_sym_NA_character_] = ACTIONS(439),
    [sym_dots] = ACTIONS(2306),
    [sym_dot_dot_i] = ACTIONS(2308),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(531),
    [sym__newline] = ACTIONS(2310),
    [sym__semicolon] = ACTIONS(531),
    [sym__raw_string_literal] = ACTIONS(445),
    [sym__external_else] = ACTIONS(531),
    [sym__external_open_parenthesis] = ACTIONS(447),
    [sym__external_open_brace] = ACTIONS(449),
    [sym__external_close_brace] = ACTIONS(531),
    [sym__external_open_bracket] = ACTIONS(531),
    [sym__external_open_bracket2] = ACTIONS(531),
    [sym__external_close_bracket2] = ACTIONS(531),
  },
  [187] = {
    [sym_function_definition] = STATE(961),
    [sym_if_statement] = STATE(961),
    [sym_for_statement] = STATE(961),
    [sym_while_statement] = STATE(961),
    [sym_repeat_statement] = STATE(961),
    [sym_braced_expression] = STATE(961),
    [sym_parenthesized_expression] = STATE(961),
    [sym_call] = STATE(961),
    [sym_subset] = STATE(961),
    [sym_subset2] = STATE(961),
    [sym_unary_operator] = STATE(961),
    [sym_binary_operator] = STATE(961),
    [sym_extract_operator] = STATE(961),
    [sym_namespace_operator] = STATE(961),
    [sym_integer] = STATE(961),
    [sym_complex] = STATE(961),
    [sym_float] = STATE(961),
    [sym__hex_literal] = STATE(2210),
    [sym__float_literal] = STATE(2210),
    [sym_string] = STATE(2209),
    [sym__single_quoted_string] = STATE(2211),
    [sym__double_quoted_string] = STATE(2212),
    [sym_na] = STATE(961),
    [sym__expression] = STATE(961),
    [sym__string_or_identifier] = STATE(5127),
    [sym__open_parenthesis] = STATE(5),
    [sym__open_brace] = STATE(42),
    [aux_sym_function_definition_repeat1] = STATE(2349),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_BSLASH] = ACTIONS(407),
    [anon_sym_function] = ACTIONS(409),
    [anon_sym_EQ] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(411),
    [anon_sym_for] = ACTIONS(413),
    [anon_sym_while] = ACTIONS(415),
    [anon_sym_repeat] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_TILDE] = ACTIONS(421),
    [anon_sym_BANG] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(427),
    [anon_sym_LT_DASH] = ACTIONS(369),
    [anon_sym_LT_LT_DASH] = ACTIONS(369),
    [anon_sym_COLON_EQ] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(371),
    [anon_sym_DASH_GT_GT] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(371),
    [anon_sym_AMP] = ACTIONS(371),
    [anon_sym_PIPE_PIPE] = ACTIONS(369),
    [anon_sym_AMP_AMP] = ACTIONS(369),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_LT_EQ] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_EQ] = ACTIONS(369),
    [anon_sym_EQ_EQ] = ACTIONS(369),
    [anon_sym_BANG_EQ] = ACTIONS(369),
    [anon_sym_STAR] = ACTIONS(371),
    [anon_sym_SLASH] = ACTIONS(369),
    [anon_sym_STAR_STAR] = ACTIONS(369),
    [anon_sym_CARET] = ACTIONS(369),
    [aux_sym_binary_operator_token1] = ACTIONS(369),
    [anon_sym_PIPE_GT] = ACTIONS(369),
    [anon_sym_COLON] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(369),
    [anon_sym_AT] = ACTIONS(369),
    [aux_sym__hex_literal_token1] = ACTIONS(429),
    [sym__number_literal] = ACTIONS(431),
    [anon_sym_SQUOTE] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_return] = ACTIONS(2312),
    [sym_next] = ACTIONS(2312),
    [sym_break] = ACTIONS(2312),
    [sym_true] = ACTIONS(2312),
    [sym_false] = ACTIONS(2312),
    [sym_null] = ACTIONS(2312),
    [sym_inf] = ACTIONS(2312),
    [sym_nan] = ACTIONS(2312),
    [anon_sym_NA] = ACTIONS(439),
    [anon_sym_NA_integer_] = ACTIONS(439),
    [anon_sym_NA_real_] = ACTIONS(439),
    [anon_sym_NA_complex_] = ACTIONS(439),
    [anon_sym_NA_character_] = ACTIONS(439),
    [sym_dots] = ACTIONS(2312),
    [sym_dot_dot_i] = ACTIONS(2314),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(369),
    [sym__newline] = ACTIONS(369),
    [sym__semicolon] = ACTIONS(369),
    [sym__raw_string_literal] = ACTIONS(445),
    [sym__external_else] = ACTIONS(369),
    [sym__external_open_parenthesis] = ACTIONS(447),
    [sym__external_open_brace] = ACTIONS(449),
    [sym__external_close_brace] = ACTIONS(369),
    [sym__external_open_bracket] = ACTIONS(369),
    [sym__external_open_bracket2] = ACTIONS(369),
    [sym__external_close_bracket2] = ACTIONS(369),
  },
  [188] = {
    [sym_function_definition] = STATE(1152),
    [sym_if_statement] = STATE(1152),
    [sym_for_statement] = STATE(1152),
    [sym_while_statement] = STATE(1152),
    [sym_repeat_statement] = STATE(1152),
    [sym_braced_expression] = STATE(1152),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_call] = STATE(1152),
    [sym_subset] = STATE(1152),
    [sym_subset2] = STATE(1152),
    [sym_unary_operator] = STATE(1152),
    [sym_binary_operator] = STATE(1152),
    [sym_extract_operator] = STATE(1152),
    [sym_namespace_operator] = STATE(1152),
    [sym_integer] = STATE(1152),
    [sym_complex] = STATE(1152),
    [sym_float] = STATE(1152),
    [sym__hex_literal] = STATE(2235),
    [sym__float_literal] = STATE(2235),
    [sym_string] = STATE(2234),
    [sym__single_quoted_string] = STATE(2236),
    [sym__double_quoted_string] = STATE(2237),
    [sym_na] = STATE(1152),
    [sym__expression] = STATE(1152),
    [sym__string_or_identifier] = STATE(5150),
    [sym__open_parenthesis] = STATE(76),
    [sym__open_brace] = STATE(188),
    [sym__close_brace] = STATE(2672),
    [aux_sym_braced_expression_repeat1] = STATE(106),
    [sym_identifier] = ACTIONS(1433),
    [anon_sym_BSLASH] = ACTIONS(1435),
    [anon_sym_function] = ACTIONS(1437),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(1439),
    [anon_sym_for] = ACTIONS(1441),
    [anon_sym_while] = ACTIONS(1443),
    [anon_sym_repeat] = ACTIONS(1445),
    [anon_sym_QMARK] = ACTIONS(1447),
    [anon_sym_TILDE] = ACTIONS(1449),
    [anon_sym_BANG] = ACTIONS(1451),
    [anon_sym_PLUS] = ACTIONS(1453),
    [anon_sym_DASH] = ACTIONS(1455),
    [anon_sym_LT_DASH] = ACTIONS(155),
    [anon_sym_LT_LT_DASH] = ACTIONS(155),
    [anon_sym_COLON_EQ] = ACTIONS(155),
    [anon_sym_DASH_GT] = ACTIONS(157),
    [anon_sym_DASH_GT_GT] = ACTIONS(155),
    [anon_sym_PIPE] = ACTIONS(157),
    [anon_sym_AMP] = ACTIONS(157),
    [anon_sym_PIPE_PIPE] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(157),
    [anon_sym_LT_EQ] = ACTIONS(155),
    [anon_sym_GT] = ACTIONS(157),
    [anon_sym_GT_EQ] = ACTIONS(155),
    [anon_sym_EQ_EQ] = ACTIONS(155),
    [anon_sym_BANG_EQ] = ACTIONS(155),
    [anon_sym_STAR] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(155),
    [anon_sym_STAR_STAR] = ACTIONS(155),
    [anon_sym_CARET] = ACTIONS(155),
    [aux_sym_binary_operator_token1] = ACTIONS(155),
    [anon_sym_PIPE_GT] = ACTIONS(155),
    [anon_sym_COLON] = ACTIONS(157),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(155),
    [aux_sym__hex_literal_token1] = ACTIONS(1457),
    [sym__number_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [anon_sym_DQUOTE] = ACTIONS(1463),
    [sym_return] = ACTIONS(1465),
    [sym_next] = ACTIONS(1465),
    [sym_break] = ACTIONS(1465),
    [sym_true] = ACTIONS(1465),
    [sym_false] = ACTIONS(1465),
    [sym_null] = ACTIONS(1465),
    [sym_inf] = ACTIONS(1465),
    [sym_nan] = ACTIONS(1465),
    [anon_sym_NA] = ACTIONS(1467),
    [anon_sym_NA_integer_] = ACTIONS(1467),
    [anon_sym_NA_real_] = ACTIONS(1467),
    [anon_sym_NA_complex_] = ACTIONS(1467),
    [anon_sym_NA_character_] = ACTIONS(1467),
    [sym_dots] = ACTIONS(1465),
    [sym_dot_dot_i] = ACTIONS(1469),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(155),
    [sym__newline] = ACTIONS(1471),
    [sym__semicolon] = ACTIONS(1471),
    [sym__raw_string_literal] = ACTIONS(1473),
    [sym__external_open_parenthesis] = ACTIONS(1475),
    [sym__external_open_brace] = ACTIONS(1477),
    [sym__external_close_brace] = ACTIONS(2316),
    [sym__external_open_bracket] = ACTIONS(155),
    [sym__external_open_bracket2] = ACTIONS(155),
    [sym__external_close_bracket2] = ACTIONS(155),
  },
  [189] = {
    [sym_function_definition] = STATE(960),
    [sym_if_statement] = STATE(960),
    [sym_for_statement] = STATE(960),
    [sym_while_statement] = STATE(960),
    [sym_repeat_statement] = STATE(960),
    [sym_braced_expression] = STATE(960),
    [sym_parenthesized_expression] = STATE(960),
    [sym_call] = STATE(960),
    [sym_subset] = STATE(960),
    [sym_subset2] = STATE(960),
    [sym_unary_operator] = STATE(960),
    [sym_binary_operator] = STATE(960),
    [sym_extract_operator] = STATE(960),
    [sym_namespace_operator] = STATE(960),
    [sym_integer] = STATE(960),
    [sym_complex] = STATE(960),
    [sym_float] = STATE(960),
    [sym__hex_literal] = STATE(2210),
    [sym__float_literal] = STATE(2210),
    [sym_string] = STATE(2209),
    [sym__single_quoted_string] = STATE(2211),
    [sym__double_quoted_string] = STATE(2212),
    [sym_na] = STATE(960),
    [sym__expression] = STATE(960),
    [sym__string_or_identifier] = STATE(5127),
    [sym__open_parenthesis] = STATE(5),
    [sym__open_brace] = STATE(42),
    [aux_sym_function_definition_repeat1] = STATE(194),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_BSLASH] = ACTIONS(407),
    [anon_sym_function] = ACTIONS(409),
    [anon_sym_EQ] = ACTIONS(379),
    [anon_sym_if] = ACTIONS(411),
    [anon_sym_for] = ACTIONS(413),
    [anon_sym_while] = ACTIONS(415),
    [anon_sym_repeat] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_TILDE] = ACTIONS(421),
    [anon_sym_BANG] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(427),
    [anon_sym_LT_DASH] = ACTIONS(377),
    [anon_sym_LT_LT_DASH] = ACTIONS(377),
    [anon_sym_COLON_EQ] = ACTIONS(377),
    [anon_sym_DASH_GT] = ACTIONS(379),
    [anon_sym_DASH_GT_GT] = ACTIONS(377),
    [anon_sym_PIPE] = ACTIONS(379),
    [anon_sym_AMP] = ACTIONS(379),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_LT] = ACTIONS(379),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(379),
    [anon_sym_GT_EQ] = ACTIONS(377),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(379),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_STAR_STAR] = ACTIONS(377),
    [anon_sym_CARET] = ACTIONS(377),
    [aux_sym_binary_operator_token1] = ACTIONS(377),
    [anon_sym_PIPE_GT] = ACTIONS(377),
    [anon_sym_COLON] = ACTIONS(379),
    [anon_sym_DOLLAR] = ACTIONS(377),
    [anon_sym_AT] = ACTIONS(377),
    [aux_sym__hex_literal_token1] = ACTIONS(429),
    [sym__number_literal] = ACTIONS(431),
    [anon_sym_SQUOTE] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_return] = ACTIONS(2318),
    [sym_next] = ACTIONS(2318),
    [sym_break] = ACTIONS(2318),
    [sym_true] = ACTIONS(2318),
    [sym_false] = ACTIONS(2318),
    [sym_null] = ACTIONS(2318),
    [sym_inf] = ACTIONS(2318),
    [sym_nan] = ACTIONS(2318),
    [anon_sym_NA] = ACTIONS(439),
    [anon_sym_NA_integer_] = ACTIONS(439),
    [anon_sym_NA_real_] = ACTIONS(439),
    [anon_sym_NA_complex_] = ACTIONS(439),
    [anon_sym_NA_character_] = ACTIONS(439),
    [sym_dots] = ACTIONS(2318),
    [sym_dot_dot_i] = ACTIONS(2320),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(377),
    [sym__newline] = ACTIONS(2322),
    [sym__semicolon] = ACTIONS(377),
    [sym__raw_string_literal] = ACTIONS(445),
    [sym__external_else] = ACTIONS(377),
    [sym__external_open_parenthesis] = ACTIONS(447),
    [sym__external_open_brace] = ACTIONS(449),
    [sym__external_close_brace] = ACTIONS(377),
    [sym__external_open_bracket] = ACTIONS(377),
    [sym__external_open_bracket2] = ACTIONS(377),
    [sym__external_close_bracket2] = ACTIONS(377),
  },
  [190] = {
    [sym_function_definition] = STATE(1219),
    [sym_if_statement] = STATE(1219),
    [sym_for_statement] = STATE(1219),
    [sym_while_statement] = STATE(1219),
    [sym_repeat_statement] = STATE(1219),
    [sym_braced_expression] = STATE(1219),
    [sym_parenthesized_expression] = STATE(1219),
    [sym_call] = STATE(1219),
    [sym_subset] = STATE(1219),
    [sym_subset2] = STATE(1219),
    [sym_unary_operator] = STATE(1219),
    [sym_binary_operator] = STATE(1219),
    [sym_extract_operator] = STATE(1219),
    [sym_namespace_operator] = STATE(1219),
    [sym_integer] = STATE(1219),
    [sym_complex] = STATE(1219),
    [sym_float] = STATE(1219),
    [sym__hex_literal] = STATE(2356),
    [sym__float_literal] = STATE(2356),
    [sym_string] = STATE(2231),
    [sym__single_quoted_string] = STATE(2355),
    [sym__double_quoted_string] = STATE(2354),
    [sym_na] = STATE(1219),
    [sym__expression] = STATE(1219),
    [sym__string_or_identifier] = STATE(5156),
    [sym__open_parenthesis] = STATE(190),
    [sym__close_parenthesis] = STATE(2684),
    [sym__open_brace] = STATE(94),
    [aux_sym_parenthesized_expression_repeat1] = STATE(148),
    [ts_builtin_sym_end] = ACTIONS(129),
    [sym_identifier] = ACTIONS(1337),
    [anon_sym_BSLASH] = ACTIONS(1339),
    [anon_sym_function] = ACTIONS(1341),
    [anon_sym_EQ] = ACTIONS(109),
    [anon_sym_if] = ACTIONS(1343),
    [anon_sym_for] = ACTIONS(1345),
    [anon_sym_while] = ACTIONS(1347),
    [anon_sym_repeat] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_BANG] = ACTIONS(1355),
    [anon_sym_PLUS] = ACTIONS(1357),
    [anon_sym_DASH] = ACTIONS(1359),
    [anon_sym_LT_DASH] = ACTIONS(129),
    [anon_sym_LT_LT_DASH] = ACTIONS(129),
    [anon_sym_COLON_EQ] = ACTIONS(129),
    [anon_sym_DASH_GT] = ACTIONS(109),
    [anon_sym_DASH_GT_GT] = ACTIONS(129),
    [anon_sym_PIPE] = ACTIONS(109),
    [anon_sym_AMP] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_STAR_STAR] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [aux_sym_binary_operator_token1] = ACTIONS(129),
    [anon_sym_PIPE_GT] = ACTIONS(129),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(129),
    [anon_sym_AT] = ACTIONS(129),
    [aux_sym__hex_literal_token1] = ACTIONS(1361),
    [sym__number_literal] = ACTIONS(1363),
    [anon_sym_SQUOTE] = ACTIONS(1365),
    [anon_sym_DQUOTE] = ACTIONS(1367),
    [sym_return] = ACTIONS(1369),
    [sym_next] = ACTIONS(1369),
    [sym_break] = ACTIONS(1369),
    [sym_true] = ACTIONS(1369),
    [sym_false] = ACTIONS(1369),
    [sym_null] = ACTIONS(1369),
    [sym_inf] = ACTIONS(1369),
    [sym_nan] = ACTIONS(1369),
    [anon_sym_NA] = ACTIONS(1371),
    [anon_sym_NA_integer_] = ACTIONS(1371),
    [anon_sym_NA_real_] = ACTIONS(1371),
    [anon_sym_NA_complex_] = ACTIONS(1371),
    [anon_sym_NA_character_] = ACTIONS(1371),
    [sym_dots] = ACTIONS(1369),
    [sym_dot_dot_i] = ACTIONS(1373),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1375),
    [sym__semicolon] = ACTIONS(129),
    [sym__raw_string_literal] = ACTIONS(1377),
    [sym__external_else] = ACTIONS(129),
    [sym__external_open_parenthesis] = ACTIONS(1379),
    [sym__external_close_parenthesis] = ACTIONS(2324),
    [sym__external_open_brace] = ACTIONS(1383),
    [sym__external_open_bracket] = ACTIONS(129),
    [sym__external_open_bracket2] = ACTIONS(129),
  },
  [191] = {
    [sym_function_definition] = STATE(1133),
    [sym_if_statement] = STATE(1133),
    [sym_for_statement] = STATE(1133),
    [sym_while_statement] = STATE(1133),
    [sym_repeat_statement] = STATE(1133),
    [sym_braced_expression] = STATE(1133),
    [sym_parenthesized_expression] = STATE(1133),
    [sym_call] = STATE(1133),
    [sym_subset] = STATE(1133),
    [sym_subset2] = STATE(1133),
    [sym_unary_operator] = STATE(1133),
    [sym_binary_operator] = STATE(1133),
    [sym_extract_operator] = STATE(1133),
    [sym_namespace_operator] = STATE(1133),
    [sym_integer] = STATE(1133),
    [sym_complex] = STATE(1133),
    [sym_float] = STATE(1133),
    [sym__hex_literal] = STATE(2288),
    [sym__float_literal] = STATE(2288),
    [sym_string] = STATE(2287),
    [sym__single_quoted_string] = STATE(2289),
    [sym__double_quoted_string] = STATE(2290),
    [sym_na] = STATE(1133),
    [sym__expression] = STATE(1133),
    [sym__string_or_identifier] = STATE(5144),
    [sym__open_parenthesis] = STATE(119),
    [sym__close_parenthesis] = STATE(2861),
    [sym__open_brace] = STATE(16),
    [aux_sym_parenthesized_expression_repeat1] = STATE(112),
    [sym_identifier] = ACTIONS(1568),
    [anon_sym_BSLASH] = ACTIONS(1570),
    [anon_sym_function] = ACTIONS(1572),
    [anon_sym_EQ] = ACTIONS(109),
    [anon_sym_if] = ACTIONS(1574),
    [anon_sym_for] = ACTIONS(1576),
    [anon_sym_while] = ACTIONS(1578),
    [anon_sym_repeat] = ACTIONS(1580),
    [anon_sym_QMARK] = ACTIONS(1582),
    [anon_sym_TILDE] = ACTIONS(1584),
    [anon_sym_BANG] = ACTIONS(1586),
    [anon_sym_PLUS] = ACTIONS(1588),
    [anon_sym_DASH] = ACTIONS(1590),
    [anon_sym_LT_DASH] = ACTIONS(129),
    [anon_sym_LT_LT_DASH] = ACTIONS(129),
    [anon_sym_COLON_EQ] = ACTIONS(129),
    [anon_sym_DASH_GT] = ACTIONS(109),
    [anon_sym_DASH_GT_GT] = ACTIONS(129),
    [anon_sym_PIPE] = ACTIONS(109),
    [anon_sym_AMP] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_STAR_STAR] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [aux_sym_binary_operator_token1] = ACTIONS(129),
    [anon_sym_PIPE_GT] = ACTIONS(129),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(129),
    [anon_sym_AT] = ACTIONS(129),
    [aux_sym__hex_literal_token1] = ACTIONS(1592),
    [sym__number_literal] = ACTIONS(1594),
    [anon_sym_SQUOTE] = ACTIONS(1596),
    [anon_sym_DQUOTE] = ACTIONS(1598),
    [sym_return] = ACTIONS(1600),
    [sym_next] = ACTIONS(1600),
    [sym_break] = ACTIONS(1600),
    [sym_true] = ACTIONS(1600),
    [sym_false] = ACTIONS(1600),
    [sym_null] = ACTIONS(1600),
    [sym_inf] = ACTIONS(1600),
    [sym_nan] = ACTIONS(1600),
    [anon_sym_NA] = ACTIONS(1602),
    [anon_sym_NA_integer_] = ACTIONS(1602),
    [anon_sym_NA_real_] = ACTIONS(1602),
    [anon_sym_NA_complex_] = ACTIONS(1602),
    [anon_sym_NA_character_] = ACTIONS(1602),
    [sym_dots] = ACTIONS(1600),
    [sym_dot_dot_i] = ACTIONS(1604),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(129),
    [sym__newline] = ACTIONS(1606),
    [sym__raw_string_literal] = ACTIONS(1608),
    [sym__external_else] = ACTIONS(129),
    [sym__external_open_parenthesis] = ACTIONS(1610),
    [sym__external_close_parenthesis] = ACTIONS(2326),
    [sym__external_open_brace] = ACTIONS(1614),
    [sym__external_open_bracket] = ACTIONS(129),
    [sym__external_open_bracket2] = ACTIONS(129),
    [sym__external_close_bracket2] = ACTIONS(129),
  },
  [192] = {
    [sym_function_definition] = STATE(970),
    [sym_if_statement] = STATE(970),
    [sym_for_statement] = STATE(970),
    [sym_while_statement] = STATE(970),
    [sym_repeat_statement] = STATE(970),
    [sym_braced_expression] = STATE(970),
    [sym_parenthesized_expression] = STATE(970),
    [sym_call] = STATE(970),
    [sym_subset] = STATE(970),
    [sym_subset2] = STATE(970),
    [sym_unary_operator] = STATE(970),
    [sym_binary_operator] = STATE(970),
    [sym_extract_operator] = STATE(970),
    [sym_namespace_operator] = STATE(970),
    [sym_integer] = STATE(970),
    [sym_complex] = STATE(970),
    [sym_float] = STATE(970),
    [sym__hex_literal] = STATE(2266),
    [sym__float_literal] = STATE(2266),
    [sym_string] = STATE(2284),
    [sym__single_quoted_string] = STATE(2265),
    [sym__double_quoted_string] = STATE(2264),
    [sym_na] = STATE(970),
    [sym__expression] = STATE(970),
    [sym__string_or_identifier] = STATE(5147),
    [sym__open_parenthesis] = STATE(23),
    [sym__open_brace] = STATE(180),
    [sym__close_brace] = STATE(3018),
    [aux_sym_braced_expression_repeat1] = STATE(121),
    [sym_identifier] = ACTIONS(1289),
    [anon_sym_BSLASH] = ACTIONS(1291),
    [anon_sym_function] = ACTIONS(1293),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(1295),
    [anon_sym_for] = ACTIONS(1297),
    [anon_sym_while] = ACTIONS(1299),
    [anon_sym_repeat] = ACTIONS(1301),
    [anon_sym_QMARK] = ACTIONS(1303),
    [anon_sym_TILDE] = ACTIONS(1305),
    [anon_sym_BANG] = ACTIONS(1307),
    [anon_sym_PLUS] = ACTIONS(1309),
    [anon_sym_DASH] = ACTIONS(1311),
    [anon_sym_LT_DASH] = ACTIONS(155),
    [anon_sym_LT_LT_DASH] = ACTIONS(155),
    [anon_sym_COLON_EQ] = ACTIONS(155),
    [anon_sym_DASH_GT] = ACTIONS(157),
    [anon_sym_DASH_GT_GT] = ACTIONS(155),
    [anon_sym_PIPE] = ACTIONS(157),
    [anon_sym_AMP] = ACTIONS(157),
    [anon_sym_PIPE_PIPE] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(157),
    [anon_sym_LT_EQ] = ACTIONS(155),
    [anon_sym_GT] = ACTIONS(157),
    [anon_sym_GT_EQ] = ACTIONS(155),
    [anon_sym_EQ_EQ] = ACTIONS(155),
    [anon_sym_BANG_EQ] = ACTIONS(155),
    [anon_sym_STAR] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(155),
    [anon_sym_STAR_STAR] = ACTIONS(155),
    [anon_sym_CARET] = ACTIONS(155),
    [aux_sym_binary_operator_token1] = ACTIONS(155),
    [anon_sym_PIPE_GT] = ACTIONS(155),
    [anon_sym_COLON] = ACTIONS(157),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(155),
    [aux_sym__hex_literal_token1] = ACTIONS(1313),
    [sym__number_literal] = ACTIONS(1315),
    [anon_sym_SQUOTE] = ACTIONS(1317),
    [anon_sym_DQUOTE] = ACTIONS(1319),
    [sym_return] = ACTIONS(1321),
    [sym_next] = ACTIONS(1321),
    [sym_break] = ACTIONS(1321),
    [sym_true] = ACTIONS(1321),
    [sym_false] = ACTIONS(1321),
    [sym_null] = ACTIONS(1321),
    [sym_inf] = ACTIONS(1321),
    [sym_nan] = ACTIONS(1321),
    [anon_sym_NA] = ACTIONS(1323),
    [anon_sym_NA_integer_] = ACTIONS(1323),
    [anon_sym_NA_real_] = ACTIONS(1323),
    [anon_sym_NA_complex_] = ACTIONS(1323),
    [anon_sym_NA_character_] = ACTIONS(1323),
    [sym_dots] = ACTIONS(1321),
    [sym_dot_dot_i] = ACTIONS(1325),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(155),
    [sym__newline] = ACTIONS(1327),
    [sym__semicolon] = ACTIONS(1327),
    [sym__raw_string_literal] = ACTIONS(1329),
    [sym__external_open_parenthesis] = ACTIONS(1331),
    [sym__external_open_brace] = ACTIONS(1333),
    [sym__external_close_brace] = ACTIONS(2328),
    [sym__external_open_bracket] = ACTIONS(155),
    [sym__external_close_bracket] = ACTIONS(155),
    [sym__external_open_bracket2] = ACTIONS(155),
  },
  [193] = {
    [sym_function_definition] = STATE(958),
    [sym_if_statement] = STATE(958),
    [sym_for_statement] = STATE(958),
    [sym_while_statement] = STATE(958),
    [sym_repeat_statement] = STATE(958),
    [sym_braced_expression] = STATE(958),
    [sym_parenthesized_expression] = STATE(958),
    [sym_call] = STATE(958),
    [sym_subset] = STATE(958),
    [sym_subset2] = STATE(958),
    [sym_unary_operator] = STATE(958),
    [sym_binary_operator] = STATE(958),
    [sym_extract_operator] = STATE(958),
    [sym_namespace_operator] = STATE(958),
    [sym_integer] = STATE(958),
    [sym_complex] = STATE(958),
    [sym_float] = STATE(958),
    [sym__hex_literal] = STATE(2210),
    [sym__float_literal] = STATE(2210),
    [sym_string] = STATE(2209),
    [sym__single_quoted_string] = STATE(2211),
    [sym__double_quoted_string] = STATE(2212),
    [sym_na] = STATE(958),
    [sym__expression] = STATE(958),
    [sym__string_or_identifier] = STATE(5127),
    [sym__open_parenthesis] = STATE(5),
    [sym__open_brace] = STATE(42),
    [aux_sym_function_definition_repeat1] = STATE(196),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_BSLASH] = ACTIONS(407),
    [anon_sym_function] = ACTIONS(409),
    [anon_sym_EQ] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(411),
    [anon_sym_for] = ACTIONS(413),
    [anon_sym_while] = ACTIONS(415),
    [anon_sym_repeat] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_TILDE] = ACTIONS(421),
    [anon_sym_BANG] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(427),
    [anon_sym_LT_DASH] = ACTIONS(387),
    [anon_sym_LT_LT_DASH] = ACTIONS(387),
    [anon_sym_COLON_EQ] = ACTIONS(387),
    [anon_sym_DASH_GT] = ACTIONS(389),
    [anon_sym_DASH_GT_GT] = ACTIONS(387),
    [anon_sym_PIPE] = ACTIONS(389),
    [anon_sym_AMP] = ACTIONS(389),
    [anon_sym_PIPE_PIPE] = ACTIONS(387),
    [anon_sym_AMP_AMP] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(389),
    [anon_sym_LT_EQ] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(389),
    [anon_sym_GT_EQ] = ACTIONS(387),
    [anon_sym_EQ_EQ] = ACTIONS(387),
    [anon_sym_BANG_EQ] = ACTIONS(387),
    [anon_sym_STAR] = ACTIONS(389),
    [anon_sym_SLASH] = ACTIONS(387),
    [anon_sym_STAR_STAR] = ACTIONS(387),
    [anon_sym_CARET] = ACTIONS(387),
    [aux_sym_binary_operator_token1] = ACTIONS(387),
    [anon_sym_PIPE_GT] = ACTIONS(387),
    [anon_sym_COLON] = ACTIONS(389),
    [anon_sym_DOLLAR] = ACTIONS(387),
    [anon_sym_AT] = ACTIONS(387),
    [aux_sym__hex_literal_token1] = ACTIONS(429),
    [sym__number_literal] = ACTIONS(431),
    [anon_sym_SQUOTE] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_return] = ACTIONS(2330),
    [sym_next] = ACTIONS(2330),
    [sym_break] = ACTIONS(2330),
    [sym_true] = ACTIONS(2330),
    [sym_false] = ACTIONS(2330),
    [sym_null] = ACTIONS(2330),
    [sym_inf] = ACTIONS(2330),
    [sym_nan] = ACTIONS(2330),
    [anon_sym_NA] = ACTIONS(439),
    [anon_sym_NA_integer_] = ACTIONS(439),
    [anon_sym_NA_real_] = ACTIONS(439),
    [anon_sym_NA_complex_] = ACTIONS(439),
    [anon_sym_NA_character_] = ACTIONS(439),
    [sym_dots] = ACTIONS(2330),
    [sym_dot_dot_i] = ACTIONS(2332),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(387),
    [sym__newline] = ACTIONS(2334),
    [sym__semicolon] = ACTIONS(387),
    [sym__raw_string_literal] = ACTIONS(445),
    [sym__external_else] = ACTIONS(387),
    [sym__external_open_parenthesis] = ACTIONS(447),
    [sym__external_open_brace] = ACTIONS(449),
    [sym__external_close_brace] = ACTIONS(387),
    [sym__external_open_bracket] = ACTIONS(387),
    [sym__external_open_bracket2] = ACTIONS(387),
    [sym__external_close_bracket2] = ACTIONS(387),
  },
  [194] = {
    [sym_function_definition] = STATE(957),
    [sym_if_statement] = STATE(957),
    [sym_for_statement] = STATE(957),
    [sym_while_statement] = STATE(957),
    [sym_repeat_statement] = STATE(957),
    [sym_braced_expression] = STATE(957),
    [sym_parenthesized_expression] = STATE(957),
    [sym_call] = STATE(957),
    [sym_subset] = STATE(957),
    [sym_subset2] = STATE(957),
    [sym_unary_operator] = STATE(957),
    [sym_binary_operator] = STATE(957),
    [sym_extract_operator] = STATE(957),
    [sym_namespace_operator] = STATE(957),
    [sym_integer] = STATE(957),
    [sym_complex] = STATE(957),
    [sym_float] = STATE(957),
    [sym__hex_literal] = STATE(2210),
    [sym__float_literal] = STATE(2210),
    [sym_string] = STATE(2209),
    [sym__single_quoted_string] = STATE(2211),
    [sym__double_quoted_string] = STATE(2212),
    [sym_na] = STATE(957),
    [sym__expression] = STATE(957),
    [sym__string_or_identifier] = STATE(5127),
    [sym__open_parenthesis] = STATE(5),
    [sym__open_brace] = STATE(42),
    [aux_sym_function_definition_repeat1] = STATE(2349),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_BSLASH] = ACTIONS(407),
    [anon_sym_function] = ACTIONS(409),
    [anon_sym_EQ] = ACTIONS(399),
    [anon_sym_if] = ACTIONS(411),
    [anon_sym_for] = ACTIONS(413),
    [anon_sym_while] = ACTIONS(415),
    [anon_sym_repeat] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_TILDE] = ACTIONS(421),
    [anon_sym_BANG] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(427),
    [anon_sym_LT_DASH] = ACTIONS(397),
    [anon_sym_LT_LT_DASH] = ACTIONS(397),
    [anon_sym_COLON_EQ] = ACTIONS(397),
    [anon_sym_DASH_GT] = ACTIONS(399),
    [anon_sym_DASH_GT_GT] = ACTIONS(397),
    [anon_sym_PIPE] = ACTIONS(399),
    [anon_sym_AMP] = ACTIONS(399),
    [anon_sym_PIPE_PIPE] = ACTIONS(397),
    [anon_sym_AMP_AMP] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(399),
    [anon_sym_LT_EQ] = ACTIONS(397),
    [anon_sym_GT] = ACTIONS(399),
    [anon_sym_GT_EQ] = ACTIONS(397),
    [anon_sym_EQ_EQ] = ACTIONS(397),
    [anon_sym_BANG_EQ] = ACTIONS(397),
    [anon_sym_STAR] = ACTIONS(399),
    [anon_sym_SLASH] = ACTIONS(397),
    [anon_sym_STAR_STAR] = ACTIONS(397),
    [anon_sym_CARET] = ACTIONS(397),
    [aux_sym_binary_operator_token1] = ACTIONS(397),
    [anon_sym_PIPE_GT] = ACTIONS(397),
    [anon_sym_COLON] = ACTIONS(399),
    [anon_sym_DOLLAR] = ACTIONS(397),
    [anon_sym_AT] = ACTIONS(397),
    [aux_sym__hex_literal_token1] = ACTIONS(429),
    [sym__number_literal] = ACTIONS(431),
    [anon_sym_SQUOTE] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_return] = ACTIONS(2336),
    [sym_next] = ACTIONS(2336),
    [sym_break] = ACTIONS(2336),
    [sym_true] = ACTIONS(2336),
    [sym_false] = ACTIONS(2336),
    [sym_null] = ACTIONS(2336),
    [sym_inf] = ACTIONS(2336),
    [sym_nan] = ACTIONS(2336),
    [anon_sym_NA] = ACTIONS(439),
    [anon_sym_NA_integer_] = ACTIONS(439),
    [anon_sym_NA_real_] = ACTIONS(439),
    [anon_sym_NA_complex_] = ACTIONS(439),
    [anon_sym_NA_character_] = ACTIONS(439),
    [sym_dots] = ACTIONS(2336),
    [sym_dot_dot_i] = ACTIONS(2338),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(397),
    [sym__newline] = ACTIONS(397),
    [sym__semicolon] = ACTIONS(397),
    [sym__raw_string_literal] = ACTIONS(445),
    [sym__external_else] = ACTIONS(397),
    [sym__external_open_parenthesis] = ACTIONS(447),
    [sym__external_open_brace] = ACTIONS(449),
    [sym__external_close_brace] = ACTIONS(397),
    [sym__external_open_bracket] = ACTIONS(397),
    [sym__external_open_bracket2] = ACTIONS(397),
    [sym__external_close_bracket2] = ACTIONS(397),
  },
  [195] = {
    [sym_function_definition] = STATE(796),
    [sym_if_statement] = STATE(796),
    [sym_for_statement] = STATE(796),
    [sym_while_statement] = STATE(796),
    [sym_repeat_statement] = STATE(796),
    [sym_braced_expression] = STATE(796),
    [sym_parenthesized_expression] = STATE(796),
    [sym_call] = STATE(796),
    [sym_subset] = STATE(796),
    [sym_subset2] = STATE(796),
    [sym_unary_operator] = STATE(796),
    [sym_binary_operator] = STATE(796),
    [sym_extract_operator] = STATE(796),
    [sym_namespace_operator] = STATE(796),
    [sym_integer] = STATE(796),
    [sym_complex] = STATE(796),
    [sym_float] = STATE(796),
    [sym__hex_literal] = STATE(2206),
    [sym__float_literal] = STATE(2206),
    [sym_string] = STATE(2166),
    [sym__single_quoted_string] = STATE(2200),
    [sym__double_quoted_string] = STATE(2201),
    [sym_na] = STATE(796),
    [sym__expression] = STATE(796),
    [sym__string_or_identifier] = STATE(5154),
    [sym__open_parenthesis] = STATE(3),
    [sym__open_brace] = STATE(45),
    [aux_sym_braced_expression_repeat1] = STATE(195),
    [sym_identifier] = ACTIONS(2340),
    [anon_sym_BSLASH] = ACTIONS(2343),
    [anon_sym_function] = ACTIONS(2346),
    [anon_sym_EQ] = ACTIONS(562),
    [anon_sym_if] = ACTIONS(2349),
    [anon_sym_for] = ACTIONS(2352),
    [anon_sym_while] = ACTIONS(2355),
    [anon_sym_repeat] = ACTIONS(2358),
    [anon_sym_QMARK] = ACTIONS(2361),
    [anon_sym_TILDE] = ACTIONS(2364),
    [anon_sym_BANG] = ACTIONS(2367),
    [anon_sym_PLUS] = ACTIONS(2370),
    [anon_sym_DASH] = ACTIONS(2373),
    [anon_sym_LT_DASH] = ACTIONS(591),
    [anon_sym_LT_LT_DASH] = ACTIONS(591),
    [anon_sym_COLON_EQ] = ACTIONS(591),
    [anon_sym_DASH_GT] = ACTIONS(562),
    [anon_sym_DASH_GT_GT] = ACTIONS(591),
    [anon_sym_PIPE] = ACTIONS(562),
    [anon_sym_AMP] = ACTIONS(562),
    [anon_sym_PIPE_PIPE] = ACTIONS(591),
    [anon_sym_AMP_AMP] = ACTIONS(591),
    [anon_sym_LT] = ACTIONS(562),
    [anon_sym_LT_EQ] = ACTIONS(591),
    [anon_sym_GT] = ACTIONS(562),
    [anon_sym_GT_EQ] = ACTIONS(591),
    [anon_sym_EQ_EQ] = ACTIONS(591),
    [anon_sym_BANG_EQ] = ACTIONS(591),
    [anon_sym_STAR] = ACTIONS(562),
    [anon_sym_SLASH] = ACTIONS(591),
    [anon_sym_STAR_STAR] = ACTIONS(591),
    [anon_sym_CARET] = ACTIONS(591),
    [aux_sym_binary_operator_token1] = ACTIONS(591),
    [anon_sym_PIPE_GT] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(562),
    [anon_sym_DOLLAR] = ACTIONS(591),
    [anon_sym_AT] = ACTIONS(591),
    [aux_sym__hex_literal_token1] = ACTIONS(2376),
    [sym__number_literal] = ACTIONS(2379),
    [anon_sym_SQUOTE] = ACTIONS(2382),
    [anon_sym_DQUOTE] = ACTIONS(2385),
    [sym_return] = ACTIONS(2388),
    [sym_next] = ACTIONS(2388),
    [sym_break] = ACTIONS(2388),
    [sym_true] = ACTIONS(2388),
    [sym_false] = ACTIONS(2388),
    [sym_null] = ACTIONS(2388),
    [sym_inf] = ACTIONS(2388),
    [sym_nan] = ACTIONS(2388),
    [anon_sym_NA] = ACTIONS(2391),
    [anon_sym_NA_integer_] = ACTIONS(2391),
    [anon_sym_NA_real_] = ACTIONS(2391),
    [anon_sym_NA_complex_] = ACTIONS(2391),
    [anon_sym_NA_character_] = ACTIONS(2391),
    [sym_dots] = ACTIONS(2388),
    [sym_dot_dot_i] = ACTIONS(2394),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(591),
    [sym__newline] = ACTIONS(2397),
    [sym__semicolon] = ACTIONS(2397),
    [sym__raw_string_literal] = ACTIONS(2400),
    [sym__external_else] = ACTIONS(591),
    [sym__external_open_parenthesis] = ACTIONS(2403),
    [sym__external_open_brace] = ACTIONS(2406),
    [sym__external_close_brace] = ACTIONS(591),
    [sym__external_open_bracket] = ACTIONS(591),
    [sym__external_close_bracket] = ACTIONS(591),
    [sym__external_open_bracket2] = ACTIONS(591),
  },
  [196] = {
    [sym_function_definition] = STATE(954),
    [sym_if_statement] = STATE(954),
    [sym_for_statement] = STATE(954),
    [sym_while_statement] = STATE(954),
    [sym_repeat_statement] = STATE(954),
    [sym_braced_expression] = STATE(954),
    [sym_parenthesized_expression] = STATE(954),
    [sym_call] = STATE(954),
    [sym_subset] = STATE(954),
    [sym_subset2] = STATE(954),
    [sym_unary_operator] = STATE(954),
    [sym_binary_operator] = STATE(954),
    [sym_extract_operator] = STATE(954),
    [sym_namespace_operator] = STATE(954),
    [sym_integer] = STATE(954),
    [sym_complex] = STATE(954),
    [sym_float] = STATE(954),
    [sym__hex_literal] = STATE(2210),
    [sym__float_literal] = STATE(2210),
    [sym_string] = STATE(2209),
    [sym__single_quoted_string] = STATE(2211),
    [sym__double_quoted_string] = STATE(2212),
    [sym_na] = STATE(954),
    [sym__expression] = STATE(954),
    [sym__string_or_identifier] = STATE(5127),
    [sym__open_parenthesis] = STATE(5),
    [sym__open_brace] = STATE(42),
    [aux_sym_function_definition_repeat1] = STATE(2349),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_BSLASH] = ACTIONS(407),
    [anon_sym_function] = ACTIONS(409),
    [anon_sym_EQ] = ACTIONS(455),
    [anon_sym_if] = ACTIONS(411),
    [anon_sym_for] = ACTIONS(413),
    [anon_sym_while] = ACTIONS(415),
    [anon_sym_repeat] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_TILDE] = ACTIONS(421),
    [anon_sym_BANG] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(427),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [anon_sym_LT_LT_DASH] = ACTIONS(453),
    [anon_sym_COLON_EQ] = ACTIONS(453),
    [anon_sym_DASH_GT] = ACTIONS(455),
    [anon_sym_DASH_GT_GT] = ACTIONS(453),
    [anon_sym_PIPE] = ACTIONS(455),
    [anon_sym_AMP] = ACTIONS(455),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(455),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_GT] = ACTIONS(455),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(453),
    [anon_sym_STAR] = ACTIONS(455),
    [anon_sym_SLASH] = ACTIONS(453),
    [anon_sym_STAR_STAR] = ACTIONS(453),
    [anon_sym_CARET] = ACTIONS(453),
    [aux_sym_binary_operator_token1] = ACTIONS(453),
    [anon_sym_PIPE_GT] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(455),
    [anon_sym_DOLLAR] = ACTIONS(453),
    [anon_sym_AT] = ACTIONS(453),
    [aux_sym__hex_literal_token1] = ACTIONS(429),
    [sym__number_literal] = ACTIONS(431),
    [anon_sym_SQUOTE] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_return] = ACTIONS(2409),
    [sym_next] = ACTIONS(2409),
    [sym_break] = ACTIONS(2409),
    [sym_true] = ACTIONS(2409),
    [sym_false] = ACTIONS(2409),
    [sym_null] = ACTIONS(2409),
    [sym_inf] = ACTIONS(2409),
    [sym_nan] = ACTIONS(2409),
    [anon_sym_NA] = ACTIONS(439),
    [anon_sym_NA_integer_] = ACTIONS(439),
    [anon_sym_NA_real_] = ACTIONS(439),
    [anon_sym_NA_complex_] = ACTIONS(439),
    [anon_sym_NA_character_] = ACTIONS(439),
    [sym_dots] = ACTIONS(2409),
    [sym_dot_dot_i] = ACTIONS(2411),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(453),
    [sym__newline] = ACTIONS(453),
    [sym__semicolon] = ACTIONS(453),
    [sym__raw_string_literal] = ACTIONS(445),
    [sym__external_else] = ACTIONS(453),
    [sym__external_open_parenthesis] = ACTIONS(447),
    [sym__external_open_brace] = ACTIONS(449),
    [sym__external_close_brace] = ACTIONS(453),
    [sym__external_open_bracket] = ACTIONS(453),
    [sym__external_open_bracket2] = ACTIONS(453),
    [sym__external_close_bracket2] = ACTIONS(453),
  },
  [197] = {
    [sym_function_definition] = STATE(953),
    [sym_if_statement] = STATE(953),
    [sym_for_statement] = STATE(953),
    [sym_while_statement] = STATE(953),
    [sym_repeat_statement] = STATE(953),
    [sym_braced_expression] = STATE(953),
    [sym_parenthesized_expression] = STATE(953),
    [sym_call] = STATE(953),
    [sym_subset] = STATE(953),
    [sym_subset2] = STATE(953),
    [sym_unary_operator] = STATE(953),
    [sym_binary_operator] = STATE(953),
    [sym_extract_operator] = STATE(953),
    [sym_namespace_operator] = STATE(953),
    [sym_integer] = STATE(953),
    [sym_complex] = STATE(953),
    [sym_float] = STATE(953),
    [sym__hex_literal] = STATE(2210),
    [sym__float_literal] = STATE(2210),
    [sym_string] = STATE(2209),
    [sym__single_quoted_string] = STATE(2211),
    [sym__double_quoted_string] = STATE(2212),
    [sym_na] = STATE(953),
    [sym__expression] = STATE(953),
    [sym__string_or_identifier] = STATE(5127),
    [sym__open_parenthesis] = STATE(5),
    [sym__open_brace] = STATE(42),
    [aux_sym_function_definition_repeat1] = STATE(198),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_BSLASH] = ACTIONS(407),
    [anon_sym_function] = ACTIONS(409),
    [anon_sym_EQ] = ACTIONS(463),
    [anon_sym_if] = ACTIONS(411),
    [anon_sym_for] = ACTIONS(413),
    [anon_sym_while] = ACTIONS(415),
    [anon_sym_repeat] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_TILDE] = ACTIONS(421),
    [anon_sym_BANG] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(427),
    [anon_sym_LT_DASH] = ACTIONS(461),
    [anon_sym_LT_LT_DASH] = ACTIONS(461),
    [anon_sym_COLON_EQ] = ACTIONS(461),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_DASH_GT_GT] = ACTIONS(461),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_PIPE_PIPE] = ACTIONS(461),
    [anon_sym_AMP_AMP] = ACTIONS(461),
    [anon_sym_LT] = ACTIONS(463),
    [anon_sym_LT_EQ] = ACTIONS(461),
    [anon_sym_GT] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(461),
    [anon_sym_EQ_EQ] = ACTIONS(461),
    [anon_sym_BANG_EQ] = ACTIONS(461),
    [anon_sym_STAR] = ACTIONS(463),
    [anon_sym_SLASH] = ACTIONS(461),
    [anon_sym_STAR_STAR] = ACTIONS(461),
    [anon_sym_CARET] = ACTIONS(461),
    [aux_sym_binary_operator_token1] = ACTIONS(461),
    [anon_sym_PIPE_GT] = ACTIONS(461),
    [anon_sym_COLON] = ACTIONS(463),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_AT] = ACTIONS(461),
    [aux_sym__hex_literal_token1] = ACTIONS(429),
    [sym__number_literal] = ACTIONS(431),
    [anon_sym_SQUOTE] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_return] = ACTIONS(2413),
    [sym_next] = ACTIONS(2413),
    [sym_break] = ACTIONS(2413),
    [sym_true] = ACTIONS(2413),
    [sym_false] = ACTIONS(2413),
    [sym_null] = ACTIONS(2413),
    [sym_inf] = ACTIONS(2413),
    [sym_nan] = ACTIONS(2413),
    [anon_sym_NA] = ACTIONS(439),
    [anon_sym_NA_integer_] = ACTIONS(439),
    [anon_sym_NA_real_] = ACTIONS(439),
    [anon_sym_NA_complex_] = ACTIONS(439),
    [anon_sym_NA_character_] = ACTIONS(439),
    [sym_dots] = ACTIONS(2413),
    [sym_dot_dot_i] = ACTIONS(2415),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(461),
    [sym__newline] = ACTIONS(2417),
    [sym__semicolon] = ACTIONS(461),
    [sym__raw_string_literal] = ACTIONS(445),
    [sym__external_else] = ACTIONS(461),
    [sym__external_open_parenthesis] = ACTIONS(447),
    [sym__external_open_brace] = ACTIONS(449),
    [sym__external_close_brace] = ACTIONS(461),
    [sym__external_open_bracket] = ACTIONS(461),
    [sym__external_open_bracket2] = ACTIONS(461),
    [sym__external_close_bracket2] = ACTIONS(461),
  },
  [198] = {
    [sym_function_definition] = STATE(951),
    [sym_if_statement] = STATE(951),
    [sym_for_statement] = STATE(951),
    [sym_while_statement] = STATE(951),
    [sym_repeat_statement] = STATE(951),
    [sym_braced_expression] = STATE(951),
    [sym_parenthesized_expression] = STATE(951),
    [sym_call] = STATE(951),
    [sym_subset] = STATE(951),
    [sym_subset2] = STATE(951),
    [sym_unary_operator] = STATE(951),
    [sym_binary_operator] = STATE(951),
    [sym_extract_operator] = STATE(951),
    [sym_namespace_operator] = STATE(951),
    [sym_integer] = STATE(951),
    [sym_complex] = STATE(951),
    [sym_float] = STATE(951),
    [sym__hex_literal] = STATE(2210),
    [sym__float_literal] = STATE(2210),
    [sym_string] = STATE(2209),
    [sym__single_quoted_string] = STATE(2211),
    [sym__double_quoted_string] = STATE(2212),
    [sym_na] = STATE(951),
    [sym__expression] = STATE(951),
    [sym__string_or_identifier] = STATE(5127),
    [sym__open_parenthesis] = STATE(5),
    [sym__open_brace] = STATE(42),
    [aux_sym_function_definition_repeat1] = STATE(2349),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_BSLASH] = ACTIONS(407),
    [anon_sym_function] = ACTIONS(409),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_if] = ACTIONS(411),
    [anon_sym_for] = ACTIONS(413),
    [anon_sym_while] = ACTIONS(415),
    [anon_sym_repeat] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_TILDE] = ACTIONS(421),
    [anon_sym_BANG] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(427),
    [anon_sym_LT_DASH] = ACTIONS(471),
    [anon_sym_LT_LT_DASH] = ACTIONS(471),
    [anon_sym_COLON_EQ] = ACTIONS(471),
    [anon_sym_DASH_GT] = ACTIONS(473),
    [anon_sym_DASH_GT_GT] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(473),
    [anon_sym_AMP] = ACTIONS(473),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_LT_EQ] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(473),
    [anon_sym_GT_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_STAR] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [aux_sym_binary_operator_token1] = ACTIONS(471),
    [anon_sym_PIPE_GT] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(473),
    [anon_sym_DOLLAR] = ACTIONS(471),
    [anon_sym_AT] = ACTIONS(471),
    [aux_sym__hex_literal_token1] = ACTIONS(429),
    [sym__number_literal] = ACTIONS(431),
    [anon_sym_SQUOTE] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_return] = ACTIONS(2419),
    [sym_next] = ACTIONS(2419),
    [sym_break] = ACTIONS(2419),
    [sym_true] = ACTIONS(2419),
    [sym_false] = ACTIONS(2419),
    [sym_null] = ACTIONS(2419),
    [sym_inf] = ACTIONS(2419),
    [sym_nan] = ACTIONS(2419),
    [anon_sym_NA] = ACTIONS(439),
    [anon_sym_NA_integer_] = ACTIONS(439),
    [anon_sym_NA_real_] = ACTIONS(439),
    [anon_sym_NA_complex_] = ACTIONS(439),
    [anon_sym_NA_character_] = ACTIONS(439),
    [sym_dots] = ACTIONS(2419),
    [sym_dot_dot_i] = ACTIONS(2421),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(471),
    [sym__newline] = ACTIONS(471),
    [sym__semicolon] = ACTIONS(471),
    [sym__raw_string_literal] = ACTIONS(445),
    [sym__external_else] = ACTIONS(471),
    [sym__external_open_parenthesis] = ACTIONS(447),
    [sym__external_open_brace] = ACTIONS(449),
    [sym__external_close_brace] = ACTIONS(471),
    [sym__external_open_bracket] = ACTIONS(471),
    [sym__external_open_bracket2] = ACTIONS(471),
    [sym__external_close_bracket2] = ACTIONS(471),
  },
  [199] = {
    [sym_function_definition] = STATE(1072),
    [sym_if_statement] = STATE(1072),
    [sym_for_statement] = STATE(1072),
    [sym_while_statement] = STATE(1072),
    [sym_repeat_statement] = STATE(1072),
    [sym_braced_expression] = STATE(1072),
    [sym_parenthesized_expression] = STATE(1072),
    [sym_call] = STATE(1072),
    [sym_subset] = STATE(1072),
    [sym_subset2] = STATE(1072),
    [sym_unary_operator] = STATE(1072),
    [sym_binary_operator] = STATE(1072),
    [sym_extract_operator] = STATE(1072),
    [sym_namespace_operator] = STATE(1072),
    [sym_integer] = STATE(1072),
    [sym_complex] = STATE(1072),
    [sym_float] = STATE(1072),
    [sym__hex_literal] = STATE(2311),
    [sym__float_literal] = STATE(2311),
    [sym_string] = STATE(2312),
    [sym__single_quoted_string] = STATE(2310),
    [sym__double_quoted_string] = STATE(2309),
    [sym_na] = STATE(1072),
    [sym__expression] = STATE(1072),
    [sym__string_or_identifier] = STATE(5134),
    [sym__open_parenthesis] = STATE(64),
    [sym__open_brace] = STATE(199),
    [sym__close_brace] = STATE(2579),
    [aux_sym_braced_expression_repeat1] = STATE(184),
    [ts_builtin_sym_end] = ACTIONS(155),
    [sym_identifier] = ACTIONS(1385),
    [anon_sym_BSLASH] = ACTIONS(1387),
    [anon_sym_function] = ACTIONS(1389),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(1391),
    [anon_sym_for] = ACTIONS(1393),
    [anon_sym_while] = ACTIONS(1395),
    [anon_sym_repeat] = ACTIONS(1397),
    [anon_sym_QMARK] = ACTIONS(1399),
    [anon_sym_TILDE] = ACTIONS(1401),
    [anon_sym_BANG] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1407),
    [anon_sym_LT_DASH] = ACTIONS(155),
    [anon_sym_LT_LT_DASH] = ACTIONS(155),
    [anon_sym_COLON_EQ] = ACTIONS(155),
    [anon_sym_DASH_GT] = ACTIONS(157),
    [anon_sym_DASH_GT_GT] = ACTIONS(155),
    [anon_sym_PIPE] = ACTIONS(157),
    [anon_sym_AMP] = ACTIONS(157),
    [anon_sym_PIPE_PIPE] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(157),
    [anon_sym_LT_EQ] = ACTIONS(155),
    [anon_sym_GT] = ACTIONS(157),
    [anon_sym_GT_EQ] = ACTIONS(155),
    [anon_sym_EQ_EQ] = ACTIONS(155),
    [anon_sym_BANG_EQ] = ACTIONS(155),
    [anon_sym_STAR] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(155),
    [anon_sym_STAR_STAR] = ACTIONS(155),
    [anon_sym_CARET] = ACTIONS(155),
    [aux_sym_binary_operator_token1] = ACTIONS(155),
    [anon_sym_PIPE_GT] = ACTIONS(155),
    [anon_sym_COLON] = ACTIONS(157),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(155),
    [aux_sym__hex_literal_token1] = ACTIONS(1409),
    [sym__number_literal] = ACTIONS(1411),
    [anon_sym_SQUOTE] = ACTIONS(1413),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [sym_return] = ACTIONS(1417),
    [sym_next] = ACTIONS(1417),
    [sym_break] = ACTIONS(1417),
    [sym_true] = ACTIONS(1417),
    [sym_false] = ACTIONS(1417),
    [sym_null] = ACTIONS(1417),
    [sym_inf] = ACTIONS(1417),
    [sym_nan] = ACTIONS(1417),
    [anon_sym_NA] = ACTIONS(1419),
    [anon_sym_NA_integer_] = ACTIONS(1419),
    [anon_sym_NA_real_] = ACTIONS(1419),
    [anon_sym_NA_complex_] = ACTIONS(1419),
    [anon_sym_NA_character_] = ACTIONS(1419),
    [sym_dots] = ACTIONS(1417),
    [sym_dot_dot_i] = ACTIONS(1421),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1423),
    [sym__semicolon] = ACTIONS(1423),
    [sym__raw_string_literal] = ACTIONS(1425),
    [sym__external_else] = ACTIONS(155),
    [sym__external_open_parenthesis] = ACTIONS(1427),
    [sym__external_open_brace] = ACTIONS(1429),
    [sym__external_close_brace] = ACTIONS(2423),
    [sym__external_open_bracket] = ACTIONS(155),
    [sym__external_open_bracket2] = ACTIONS(155),
  },
  [200] = {
    [sym_function_definition] = STATE(1521),
    [sym_if_statement] = STATE(1521),
    [sym_for_statement] = STATE(1521),
    [sym_while_statement] = STATE(1521),
    [sym_repeat_statement] = STATE(1521),
    [sym_braced_expression] = STATE(1521),
    [sym_parenthesized_expression] = STATE(1521),
    [sym_call] = STATE(1521),
    [sym_subset] = STATE(1521),
    [sym_subset2] = STATE(1521),
    [sym_unary_operator] = STATE(1521),
    [sym_binary_operator] = STATE(1521),
    [sym_extract_operator] = STATE(1521),
    [sym_namespace_operator] = STATE(1521),
    [sym_integer] = STATE(1521),
    [sym_complex] = STATE(1521),
    [sym_float] = STATE(1521),
    [sym__hex_literal] = STATE(2371),
    [sym__float_literal] = STATE(2371),
    [sym_string] = STATE(2372),
    [sym__single_quoted_string] = STATE(2370),
    [sym__double_quoted_string] = STATE(2369),
    [sym_na] = STATE(1521),
    [sym__expression] = STATE(1521),
    [sym__string_or_identifier] = STATE(5138),
    [sym__open_parenthesis] = STATE(200),
    [sym__close_parenthesis] = STATE(2890),
    [sym__open_brace] = STATE(97),
    [aux_sym_parenthesized_expression_repeat1] = STATE(283),
    [sym_identifier] = ACTIONS(2425),
    [anon_sym_BSLASH] = ACTIONS(2427),
    [anon_sym_function] = ACTIONS(2429),
    [anon_sym_EQ] = ACTIONS(109),
    [anon_sym_if] = ACTIONS(2431),
    [anon_sym_for] = ACTIONS(2433),
    [anon_sym_while] = ACTIONS(2435),
    [anon_sym_repeat] = ACTIONS(2437),
    [anon_sym_QMARK] = ACTIONS(2439),
    [anon_sym_TILDE] = ACTIONS(2441),
    [anon_sym_BANG] = ACTIONS(2443),
    [anon_sym_PLUS] = ACTIONS(2445),
    [anon_sym_DASH] = ACTIONS(2447),
    [anon_sym_LT_DASH] = ACTIONS(129),
    [anon_sym_LT_LT_DASH] = ACTIONS(129),
    [anon_sym_COLON_EQ] = ACTIONS(129),
    [anon_sym_DASH_GT] = ACTIONS(109),
    [anon_sym_DASH_GT_GT] = ACTIONS(129),
    [anon_sym_PIPE] = ACTIONS(109),
    [anon_sym_AMP] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_STAR_STAR] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [aux_sym_binary_operator_token1] = ACTIONS(129),
    [anon_sym_PIPE_GT] = ACTIONS(129),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(129),
    [anon_sym_AT] = ACTIONS(129),
    [aux_sym__hex_literal_token1] = ACTIONS(2449),
    [sym__number_literal] = ACTIONS(2451),
    [anon_sym_SQUOTE] = ACTIONS(2453),
    [anon_sym_DQUOTE] = ACTIONS(2455),
    [sym_return] = ACTIONS(2457),
    [sym_next] = ACTIONS(2457),
    [sym_break] = ACTIONS(2457),
    [sym_true] = ACTIONS(2457),
    [sym_false] = ACTIONS(2457),
    [sym_null] = ACTIONS(2457),
    [sym_inf] = ACTIONS(2457),
    [sym_nan] = ACTIONS(2457),
    [anon_sym_NA] = ACTIONS(2459),
    [anon_sym_NA_integer_] = ACTIONS(2459),
    [anon_sym_NA_real_] = ACTIONS(2459),
    [anon_sym_NA_complex_] = ACTIONS(2459),
    [anon_sym_NA_character_] = ACTIONS(2459),
    [sym_dots] = ACTIONS(2457),
    [sym_dot_dot_i] = ACTIONS(2461),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(129),
    [sym__newline] = ACTIONS(2463),
    [sym__raw_string_literal] = ACTIONS(2465),
    [sym__external_else] = ACTIONS(129),
    [sym__external_open_parenthesis] = ACTIONS(2467),
    [sym__external_close_parenthesis] = ACTIONS(2469),
    [sym__external_open_brace] = ACTIONS(2471),
    [sym__external_open_bracket] = ACTIONS(129),
    [sym__external_open_bracket2] = ACTIONS(129),
  },
  [201] = {
    [sym_function_definition] = STATE(1138),
    [sym_if_statement] = STATE(1138),
    [sym_for_statement] = STATE(1138),
    [sym_while_statement] = STATE(1138),
    [sym_repeat_statement] = STATE(1138),
    [sym_braced_expression] = STATE(1138),
    [sym_parenthesized_expression] = STATE(1138),
    [sym_call] = STATE(1138),
    [sym_subset] = STATE(1138),
    [sym_subset2] = STATE(1138),
    [sym_unary_operator] = STATE(1138),
    [sym_binary_operator] = STATE(1138),
    [sym_extract_operator] = STATE(1138),
    [sym_namespace_operator] = STATE(1138),
    [sym_integer] = STATE(1138),
    [sym_complex] = STATE(1138),
    [sym_float] = STATE(1138),
    [sym__hex_literal] = STATE(2235),
    [sym__float_literal] = STATE(2235),
    [sym_string] = STATE(2234),
    [sym__single_quoted_string] = STATE(2236),
    [sym__double_quoted_string] = STATE(2237),
    [sym_na] = STATE(1138),
    [sym__expression] = STATE(1138),
    [sym__string_or_identifier] = STATE(5150),
    [sym__open_parenthesis] = STATE(76),
    [sym__open_brace] = STATE(188),
    [aux_sym_function_definition_repeat1] = STATE(288),
    [sym_identifier] = ACTIONS(1433),
    [anon_sym_BSLASH] = ACTIONS(1435),
    [anon_sym_function] = ACTIONS(1437),
    [anon_sym_EQ] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(1439),
    [anon_sym_for] = ACTIONS(1441),
    [anon_sym_while] = ACTIONS(1443),
    [anon_sym_repeat] = ACTIONS(1445),
    [anon_sym_QMARK] = ACTIONS(1447),
    [anon_sym_TILDE] = ACTIONS(1449),
    [anon_sym_BANG] = ACTIONS(1451),
    [anon_sym_PLUS] = ACTIONS(1453),
    [anon_sym_DASH] = ACTIONS(1455),
    [anon_sym_LT_DASH] = ACTIONS(263),
    [anon_sym_LT_LT_DASH] = ACTIONS(263),
    [anon_sym_COLON_EQ] = ACTIONS(263),
    [anon_sym_DASH_GT] = ACTIONS(265),
    [anon_sym_DASH_GT_GT] = ACTIONS(263),
    [anon_sym_PIPE] = ACTIONS(265),
    [anon_sym_AMP] = ACTIONS(265),
    [anon_sym_PIPE_PIPE] = ACTIONS(263),
    [anon_sym_AMP_AMP] = ACTIONS(263),
    [anon_sym_LT] = ACTIONS(265),
    [anon_sym_LT_EQ] = ACTIONS(263),
    [anon_sym_GT] = ACTIONS(265),
    [anon_sym_GT_EQ] = ACTIONS(263),
    [anon_sym_EQ_EQ] = ACTIONS(263),
    [anon_sym_BANG_EQ] = ACTIONS(263),
    [anon_sym_STAR] = ACTIONS(265),
    [anon_sym_SLASH] = ACTIONS(263),
    [anon_sym_STAR_STAR] = ACTIONS(263),
    [anon_sym_CARET] = ACTIONS(263),
    [aux_sym_binary_operator_token1] = ACTIONS(263),
    [anon_sym_PIPE_GT] = ACTIONS(263),
    [anon_sym_COLON] = ACTIONS(265),
    [anon_sym_DOLLAR] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(263),
    [aux_sym__hex_literal_token1] = ACTIONS(1457),
    [sym__number_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [anon_sym_DQUOTE] = ACTIONS(1463),
    [sym_return] = ACTIONS(2473),
    [sym_next] = ACTIONS(2473),
    [sym_break] = ACTIONS(2473),
    [sym_true] = ACTIONS(2473),
    [sym_false] = ACTIONS(2473),
    [sym_null] = ACTIONS(2473),
    [sym_inf] = ACTIONS(2473),
    [sym_nan] = ACTIONS(2473),
    [anon_sym_NA] = ACTIONS(1467),
    [anon_sym_NA_integer_] = ACTIONS(1467),
    [anon_sym_NA_real_] = ACTIONS(1467),
    [anon_sym_NA_complex_] = ACTIONS(1467),
    [anon_sym_NA_character_] = ACTIONS(1467),
    [sym_dots] = ACTIONS(2473),
    [sym_dot_dot_i] = ACTIONS(2475),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(263),
    [sym__newline] = ACTIONS(2477),
    [sym__semicolon] = ACTIONS(263),
    [sym__raw_string_literal] = ACTIONS(1473),
    [sym__external_open_parenthesis] = ACTIONS(1475),
    [sym__external_open_brace] = ACTIONS(1477),
    [sym__external_close_brace] = ACTIONS(263),
    [sym__external_open_bracket] = ACTIONS(263),
    [sym__external_open_bracket2] = ACTIONS(263),
    [sym__external_close_bracket2] = ACTIONS(263),
  },
  [202] = {
    [sym_function_definition] = STATE(1097),
    [sym_if_statement] = STATE(1097),
    [sym_for_statement] = STATE(1097),
    [sym_while_statement] = STATE(1097),
    [sym_repeat_statement] = STATE(1097),
    [sym_braced_expression] = STATE(1097),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_call] = STATE(1097),
    [sym_subset] = STATE(1097),
    [sym_subset2] = STATE(1097),
    [sym_unary_operator] = STATE(1097),
    [sym_binary_operator] = STATE(1097),
    [sym_extract_operator] = STATE(1097),
    [sym_namespace_operator] = STATE(1097),
    [sym_integer] = STATE(1097),
    [sym_complex] = STATE(1097),
    [sym_float] = STATE(1097),
    [sym__hex_literal] = STATE(2311),
    [sym__float_literal] = STATE(2311),
    [sym_string] = STATE(2312),
    [sym__single_quoted_string] = STATE(2310),
    [sym__double_quoted_string] = STATE(2309),
    [sym_na] = STATE(1097),
    [sym__expression] = STATE(1097),
    [sym__string_or_identifier] = STATE(5134),
    [sym__open_parenthesis] = STATE(64),
    [sym__open_brace] = STATE(199),
    [aux_sym_function_definition_repeat1] = STATE(2399),
    [ts_builtin_sym_end] = ACTIONS(471),
    [sym_identifier] = ACTIONS(1385),
    [anon_sym_BSLASH] = ACTIONS(1387),
    [anon_sym_function] = ACTIONS(1389),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_if] = ACTIONS(1391),
    [anon_sym_for] = ACTIONS(1393),
    [anon_sym_while] = ACTIONS(1395),
    [anon_sym_repeat] = ACTIONS(1397),
    [anon_sym_QMARK] = ACTIONS(1399),
    [anon_sym_TILDE] = ACTIONS(1401),
    [anon_sym_BANG] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1407),
    [anon_sym_LT_DASH] = ACTIONS(471),
    [anon_sym_LT_LT_DASH] = ACTIONS(471),
    [anon_sym_COLON_EQ] = ACTIONS(471),
    [anon_sym_DASH_GT] = ACTIONS(473),
    [anon_sym_DASH_GT_GT] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(473),
    [anon_sym_AMP] = ACTIONS(473),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_LT_EQ] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(473),
    [anon_sym_GT_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_STAR] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [aux_sym_binary_operator_token1] = ACTIONS(471),
    [anon_sym_PIPE_GT] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(473),
    [anon_sym_DOLLAR] = ACTIONS(471),
    [anon_sym_AT] = ACTIONS(471),
    [aux_sym__hex_literal_token1] = ACTIONS(1409),
    [sym__number_literal] = ACTIONS(1411),
    [anon_sym_SQUOTE] = ACTIONS(1413),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [sym_return] = ACTIONS(2479),
    [sym_next] = ACTIONS(2479),
    [sym_break] = ACTIONS(2479),
    [sym_true] = ACTIONS(2479),
    [sym_false] = ACTIONS(2479),
    [sym_null] = ACTIONS(2479),
    [sym_inf] = ACTIONS(2479),
    [sym_nan] = ACTIONS(2479),
    [anon_sym_NA] = ACTIONS(1419),
    [anon_sym_NA_integer_] = ACTIONS(1419),
    [anon_sym_NA_real_] = ACTIONS(1419),
    [anon_sym_NA_complex_] = ACTIONS(1419),
    [anon_sym_NA_character_] = ACTIONS(1419),
    [sym_dots] = ACTIONS(2479),
    [sym_dot_dot_i] = ACTIONS(2481),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(471),
    [sym__semicolon] = ACTIONS(471),
    [sym__raw_string_literal] = ACTIONS(1425),
    [sym__external_else] = ACTIONS(471),
    [sym__external_open_parenthesis] = ACTIONS(1427),
    [sym__external_open_brace] = ACTIONS(1429),
    [sym__external_close_brace] = ACTIONS(471),
    [sym__external_open_bracket] = ACTIONS(471),
    [sym__external_open_bracket2] = ACTIONS(471),
  },
  [203] = {
    [sym_function_definition] = STATE(1599),
    [sym_if_statement] = STATE(1599),
    [sym_for_statement] = STATE(1599),
    [sym_while_statement] = STATE(1599),
    [sym_repeat_statement] = STATE(1599),
    [sym_braced_expression] = STATE(1599),
    [sym_parenthesized_expression] = STATE(1599),
    [sym_call] = STATE(1599),
    [sym_subset] = STATE(1599),
    [sym_subset2] = STATE(1599),
    [sym_unary_operator] = STATE(1599),
    [sym_binary_operator] = STATE(1599),
    [sym_extract_operator] = STATE(1599),
    [sym_namespace_operator] = STATE(1599),
    [sym_integer] = STATE(1599),
    [sym_complex] = STATE(1599),
    [sym_float] = STATE(1599),
    [sym__hex_literal] = STATE(2412),
    [sym__float_literal] = STATE(2412),
    [sym_string] = STATE(2397),
    [sym__single_quoted_string] = STATE(2430),
    [sym__double_quoted_string] = STATE(2466),
    [sym_na] = STATE(1599),
    [sym__expression] = STATE(1599),
    [sym__string_or_identifier] = STATE(5142),
    [sym__open_parenthesis] = STATE(210),
    [sym__close_parenthesis] = STATE(2767),
    [sym__open_brace] = STATE(74),
    [aux_sym_parenthesized_expression_repeat1] = STATE(409),
    [sym_identifier] = ACTIONS(2483),
    [anon_sym_BSLASH] = ACTIONS(2485),
    [anon_sym_function] = ACTIONS(2487),
    [anon_sym_EQ] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(2489),
    [anon_sym_for] = ACTIONS(2491),
    [anon_sym_while] = ACTIONS(2493),
    [anon_sym_repeat] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(2497),
    [anon_sym_TILDE] = ACTIONS(2499),
    [anon_sym_BANG] = ACTIONS(2501),
    [anon_sym_PLUS] = ACTIONS(2503),
    [anon_sym_DASH] = ACTIONS(2505),
    [anon_sym_LT_DASH] = ACTIONS(211),
    [anon_sym_LT_LT_DASH] = ACTIONS(211),
    [anon_sym_COLON_EQ] = ACTIONS(211),
    [anon_sym_DASH_GT] = ACTIONS(209),
    [anon_sym_DASH_GT_GT] = ACTIONS(211),
    [anon_sym_PIPE] = ACTIONS(209),
    [anon_sym_AMP] = ACTIONS(209),
    [anon_sym_PIPE_PIPE] = ACTIONS(211),
    [anon_sym_AMP_AMP] = ACTIONS(211),
    [anon_sym_LT] = ACTIONS(209),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_GT] = ACTIONS(209),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [anon_sym_EQ_EQ] = ACTIONS(211),
    [anon_sym_BANG_EQ] = ACTIONS(211),
    [anon_sym_STAR] = ACTIONS(209),
    [anon_sym_SLASH] = ACTIONS(211),
    [anon_sym_STAR_STAR] = ACTIONS(211),
    [anon_sym_CARET] = ACTIONS(211),
    [aux_sym_binary_operator_token1] = ACTIONS(211),
    [anon_sym_PIPE_GT] = ACTIONS(211),
    [anon_sym_COLON] = ACTIONS(209),
    [anon_sym_DOLLAR] = ACTIONS(211),
    [anon_sym_AT] = ACTIONS(211),
    [aux_sym__hex_literal_token1] = ACTIONS(2507),
    [sym__number_literal] = ACTIONS(2509),
    [anon_sym_SQUOTE] = ACTIONS(2511),
    [anon_sym_DQUOTE] = ACTIONS(2513),
    [sym_return] = ACTIONS(2515),
    [sym_next] = ACTIONS(2515),
    [sym_break] = ACTIONS(2515),
    [sym_true] = ACTIONS(2515),
    [sym_false] = ACTIONS(2515),
    [sym_null] = ACTIONS(2515),
    [sym_inf] = ACTIONS(2515),
    [sym_nan] = ACTIONS(2515),
    [anon_sym_NA] = ACTIONS(2517),
    [anon_sym_NA_integer_] = ACTIONS(2517),
    [anon_sym_NA_real_] = ACTIONS(2517),
    [anon_sym_NA_complex_] = ACTIONS(2517),
    [anon_sym_NA_character_] = ACTIONS(2517),
    [sym_dots] = ACTIONS(2515),
    [sym_dot_dot_i] = ACTIONS(2519),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(211),
    [sym__newline] = ACTIONS(2521),
    [sym__raw_string_literal] = ACTIONS(2523),
    [sym__external_open_parenthesis] = ACTIONS(2525),
    [sym__external_close_parenthesis] = ACTIONS(2527),
    [sym__external_open_brace] = ACTIONS(2529),
    [sym__external_open_bracket] = ACTIONS(211),
    [sym__external_open_bracket2] = ACTIONS(211),
    [sym__external_close_bracket2] = ACTIONS(211),
  },
  [204] = {
    [sym_function_definition] = STATE(1618),
    [sym_if_statement] = STATE(1618),
    [sym_for_statement] = STATE(1618),
    [sym_while_statement] = STATE(1618),
    [sym_repeat_statement] = STATE(1618),
    [sym_braced_expression] = STATE(1618),
    [sym_parenthesized_expression] = STATE(1618),
    [sym_call] = STATE(1618),
    [sym_subset] = STATE(1618),
    [sym_subset2] = STATE(1618),
    [sym_unary_operator] = STATE(1618),
    [sym_binary_operator] = STATE(1618),
    [sym_extract_operator] = STATE(1618),
    [sym_namespace_operator] = STATE(1618),
    [sym_integer] = STATE(1618),
    [sym_complex] = STATE(1618),
    [sym_float] = STATE(1618),
    [sym__hex_literal] = STATE(2445),
    [sym__float_literal] = STATE(2445),
    [sym_string] = STATE(2530),
    [sym__single_quoted_string] = STATE(2442),
    [sym__double_quoted_string] = STATE(2437),
    [sym_na] = STATE(1618),
    [sym__expression] = STATE(1618),
    [sym__string_or_identifier] = STATE(5133),
    [sym__open_parenthesis] = STATE(213),
    [sym__close_parenthesis] = STATE(2756),
    [sym__open_brace] = STATE(70),
    [aux_sym_parenthesized_expression_repeat1] = STATE(307),
    [sym_identifier] = ACTIONS(2531),
    [anon_sym_BSLASH] = ACTIONS(2533),
    [anon_sym_function] = ACTIONS(2535),
    [anon_sym_EQ] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(2537),
    [anon_sym_for] = ACTIONS(2539),
    [anon_sym_while] = ACTIONS(2541),
    [anon_sym_repeat] = ACTIONS(2543),
    [anon_sym_QMARK] = ACTIONS(2545),
    [anon_sym_TILDE] = ACTIONS(2547),
    [anon_sym_BANG] = ACTIONS(2549),
    [anon_sym_PLUS] = ACTIONS(2551),
    [anon_sym_DASH] = ACTIONS(2553),
    [anon_sym_LT_DASH] = ACTIONS(211),
    [anon_sym_LT_LT_DASH] = ACTIONS(211),
    [anon_sym_COLON_EQ] = ACTIONS(211),
    [anon_sym_DASH_GT] = ACTIONS(209),
    [anon_sym_DASH_GT_GT] = ACTIONS(211),
    [anon_sym_PIPE] = ACTIONS(209),
    [anon_sym_AMP] = ACTIONS(209),
    [anon_sym_PIPE_PIPE] = ACTIONS(211),
    [anon_sym_AMP_AMP] = ACTIONS(211),
    [anon_sym_LT] = ACTIONS(209),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_GT] = ACTIONS(209),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [anon_sym_EQ_EQ] = ACTIONS(211),
    [anon_sym_BANG_EQ] = ACTIONS(211),
    [anon_sym_STAR] = ACTIONS(209),
    [anon_sym_SLASH] = ACTIONS(211),
    [anon_sym_STAR_STAR] = ACTIONS(211),
    [anon_sym_CARET] = ACTIONS(211),
    [aux_sym_binary_operator_token1] = ACTIONS(211),
    [anon_sym_PIPE_GT] = ACTIONS(211),
    [anon_sym_COLON] = ACTIONS(209),
    [anon_sym_DOLLAR] = ACTIONS(211),
    [anon_sym_AT] = ACTIONS(211),
    [aux_sym__hex_literal_token1] = ACTIONS(2555),
    [sym__number_literal] = ACTIONS(2557),
    [anon_sym_SQUOTE] = ACTIONS(2559),
    [anon_sym_DQUOTE] = ACTIONS(2561),
    [sym_return] = ACTIONS(2563),
    [sym_next] = ACTIONS(2563),
    [sym_break] = ACTIONS(2563),
    [sym_true] = ACTIONS(2563),
    [sym_false] = ACTIONS(2563),
    [sym_null] = ACTIONS(2563),
    [sym_inf] = ACTIONS(2563),
    [sym_nan] = ACTIONS(2563),
    [anon_sym_NA] = ACTIONS(2565),
    [anon_sym_NA_integer_] = ACTIONS(2565),
    [anon_sym_NA_real_] = ACTIONS(2565),
    [anon_sym_NA_complex_] = ACTIONS(2565),
    [anon_sym_NA_character_] = ACTIONS(2565),
    [sym_dots] = ACTIONS(2563),
    [sym_dot_dot_i] = ACTIONS(2567),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(211),
    [sym__newline] = ACTIONS(2569),
    [sym__raw_string_literal] = ACTIONS(2571),
    [sym__external_open_parenthesis] = ACTIONS(2573),
    [sym__external_close_parenthesis] = ACTIONS(2575),
    [sym__external_open_brace] = ACTIONS(2577),
    [sym__external_open_bracket] = ACTIONS(211),
    [sym__external_close_bracket] = ACTIONS(211),
    [sym__external_open_bracket2] = ACTIONS(211),
  },
  [205] = {
    [sym_function_definition] = STATE(1090),
    [sym_if_statement] = STATE(1090),
    [sym_for_statement] = STATE(1090),
    [sym_while_statement] = STATE(1090),
    [sym_repeat_statement] = STATE(1090),
    [sym_braced_expression] = STATE(1090),
    [sym_parenthesized_expression] = STATE(1090),
    [sym_call] = STATE(1090),
    [sym_subset] = STATE(1090),
    [sym_subset2] = STATE(1090),
    [sym_unary_operator] = STATE(1090),
    [sym_binary_operator] = STATE(1090),
    [sym_extract_operator] = STATE(1090),
    [sym_namespace_operator] = STATE(1090),
    [sym_integer] = STATE(1090),
    [sym_complex] = STATE(1090),
    [sym_float] = STATE(1090),
    [sym__hex_literal] = STATE(2311),
    [sym__float_literal] = STATE(2311),
    [sym_string] = STATE(2312),
    [sym__single_quoted_string] = STATE(2310),
    [sym__double_quoted_string] = STATE(2309),
    [sym_na] = STATE(1090),
    [sym__expression] = STATE(1090),
    [sym__string_or_identifier] = STATE(5134),
    [sym__open_parenthesis] = STATE(64),
    [sym__open_brace] = STATE(199),
    [aux_sym_function_definition_repeat1] = STATE(2399),
    [ts_builtin_sym_end] = ACTIONS(397),
    [sym_identifier] = ACTIONS(1385),
    [anon_sym_BSLASH] = ACTIONS(1387),
    [anon_sym_function] = ACTIONS(1389),
    [anon_sym_EQ] = ACTIONS(399),
    [anon_sym_if] = ACTIONS(1391),
    [anon_sym_for] = ACTIONS(1393),
    [anon_sym_while] = ACTIONS(1395),
    [anon_sym_repeat] = ACTIONS(1397),
    [anon_sym_QMARK] = ACTIONS(1399),
    [anon_sym_TILDE] = ACTIONS(1401),
    [anon_sym_BANG] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1407),
    [anon_sym_LT_DASH] = ACTIONS(397),
    [anon_sym_LT_LT_DASH] = ACTIONS(397),
    [anon_sym_COLON_EQ] = ACTIONS(397),
    [anon_sym_DASH_GT] = ACTIONS(399),
    [anon_sym_DASH_GT_GT] = ACTIONS(397),
    [anon_sym_PIPE] = ACTIONS(399),
    [anon_sym_AMP] = ACTIONS(399),
    [anon_sym_PIPE_PIPE] = ACTIONS(397),
    [anon_sym_AMP_AMP] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(399),
    [anon_sym_LT_EQ] = ACTIONS(397),
    [anon_sym_GT] = ACTIONS(399),
    [anon_sym_GT_EQ] = ACTIONS(397),
    [anon_sym_EQ_EQ] = ACTIONS(397),
    [anon_sym_BANG_EQ] = ACTIONS(397),
    [anon_sym_STAR] = ACTIONS(399),
    [anon_sym_SLASH] = ACTIONS(397),
    [anon_sym_STAR_STAR] = ACTIONS(397),
    [anon_sym_CARET] = ACTIONS(397),
    [aux_sym_binary_operator_token1] = ACTIONS(397),
    [anon_sym_PIPE_GT] = ACTIONS(397),
    [anon_sym_COLON] = ACTIONS(399),
    [anon_sym_DOLLAR] = ACTIONS(397),
    [anon_sym_AT] = ACTIONS(397),
    [aux_sym__hex_literal_token1] = ACTIONS(1409),
    [sym__number_literal] = ACTIONS(1411),
    [anon_sym_SQUOTE] = ACTIONS(1413),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [sym_return] = ACTIONS(2579),
    [sym_next] = ACTIONS(2579),
    [sym_break] = ACTIONS(2579),
    [sym_true] = ACTIONS(2579),
    [sym_false] = ACTIONS(2579),
    [sym_null] = ACTIONS(2579),
    [sym_inf] = ACTIONS(2579),
    [sym_nan] = ACTIONS(2579),
    [anon_sym_NA] = ACTIONS(1419),
    [anon_sym_NA_integer_] = ACTIONS(1419),
    [anon_sym_NA_real_] = ACTIONS(1419),
    [anon_sym_NA_complex_] = ACTIONS(1419),
    [anon_sym_NA_character_] = ACTIONS(1419),
    [sym_dots] = ACTIONS(2579),
    [sym_dot_dot_i] = ACTIONS(2581),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(397),
    [sym__semicolon] = ACTIONS(397),
    [sym__raw_string_literal] = ACTIONS(1425),
    [sym__external_else] = ACTIONS(397),
    [sym__external_open_parenthesis] = ACTIONS(1427),
    [sym__external_open_brace] = ACTIONS(1429),
    [sym__external_close_brace] = ACTIONS(397),
    [sym__external_open_bracket] = ACTIONS(397),
    [sym__external_open_bracket2] = ACTIONS(397),
  },
  [206] = {
    [sym_function_definition] = STATE(1089),
    [sym_if_statement] = STATE(1089),
    [sym_for_statement] = STATE(1089),
    [sym_while_statement] = STATE(1089),
    [sym_repeat_statement] = STATE(1089),
    [sym_braced_expression] = STATE(1089),
    [sym_parenthesized_expression] = STATE(1089),
    [sym_call] = STATE(1089),
    [sym_subset] = STATE(1089),
    [sym_subset2] = STATE(1089),
    [sym_unary_operator] = STATE(1089),
    [sym_binary_operator] = STATE(1089),
    [sym_extract_operator] = STATE(1089),
    [sym_namespace_operator] = STATE(1089),
    [sym_integer] = STATE(1089),
    [sym_complex] = STATE(1089),
    [sym_float] = STATE(1089),
    [sym__hex_literal] = STATE(2311),
    [sym__float_literal] = STATE(2311),
    [sym_string] = STATE(2312),
    [sym__single_quoted_string] = STATE(2310),
    [sym__double_quoted_string] = STATE(2309),
    [sym_na] = STATE(1089),
    [sym__expression] = STATE(1089),
    [sym__string_or_identifier] = STATE(5134),
    [sym__open_parenthesis] = STATE(64),
    [sym__open_brace] = STATE(199),
    [aux_sym_function_definition_repeat1] = STATE(234),
    [ts_builtin_sym_end] = ACTIONS(387),
    [sym_identifier] = ACTIONS(1385),
    [anon_sym_BSLASH] = ACTIONS(1387),
    [anon_sym_function] = ACTIONS(1389),
    [anon_sym_EQ] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(1391),
    [anon_sym_for] = ACTIONS(1393),
    [anon_sym_while] = ACTIONS(1395),
    [anon_sym_repeat] = ACTIONS(1397),
    [anon_sym_QMARK] = ACTIONS(1399),
    [anon_sym_TILDE] = ACTIONS(1401),
    [anon_sym_BANG] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1407),
    [anon_sym_LT_DASH] = ACTIONS(387),
    [anon_sym_LT_LT_DASH] = ACTIONS(387),
    [anon_sym_COLON_EQ] = ACTIONS(387),
    [anon_sym_DASH_GT] = ACTIONS(389),
    [anon_sym_DASH_GT_GT] = ACTIONS(387),
    [anon_sym_PIPE] = ACTIONS(389),
    [anon_sym_AMP] = ACTIONS(389),
    [anon_sym_PIPE_PIPE] = ACTIONS(387),
    [anon_sym_AMP_AMP] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(389),
    [anon_sym_LT_EQ] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(389),
    [anon_sym_GT_EQ] = ACTIONS(387),
    [anon_sym_EQ_EQ] = ACTIONS(387),
    [anon_sym_BANG_EQ] = ACTIONS(387),
    [anon_sym_STAR] = ACTIONS(389),
    [anon_sym_SLASH] = ACTIONS(387),
    [anon_sym_STAR_STAR] = ACTIONS(387),
    [anon_sym_CARET] = ACTIONS(387),
    [aux_sym_binary_operator_token1] = ACTIONS(387),
    [anon_sym_PIPE_GT] = ACTIONS(387),
    [anon_sym_COLON] = ACTIONS(389),
    [anon_sym_DOLLAR] = ACTIONS(387),
    [anon_sym_AT] = ACTIONS(387),
    [aux_sym__hex_literal_token1] = ACTIONS(1409),
    [sym__number_literal] = ACTIONS(1411),
    [anon_sym_SQUOTE] = ACTIONS(1413),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [sym_return] = ACTIONS(2583),
    [sym_next] = ACTIONS(2583),
    [sym_break] = ACTIONS(2583),
    [sym_true] = ACTIONS(2583),
    [sym_false] = ACTIONS(2583),
    [sym_null] = ACTIONS(2583),
    [sym_inf] = ACTIONS(2583),
    [sym_nan] = ACTIONS(2583),
    [anon_sym_NA] = ACTIONS(1419),
    [anon_sym_NA_integer_] = ACTIONS(1419),
    [anon_sym_NA_real_] = ACTIONS(1419),
    [anon_sym_NA_complex_] = ACTIONS(1419),
    [anon_sym_NA_character_] = ACTIONS(1419),
    [sym_dots] = ACTIONS(2583),
    [sym_dot_dot_i] = ACTIONS(2585),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(2587),
    [sym__semicolon] = ACTIONS(387),
    [sym__raw_string_literal] = ACTIONS(1425),
    [sym__external_else] = ACTIONS(387),
    [sym__external_open_parenthesis] = ACTIONS(1427),
    [sym__external_open_brace] = ACTIONS(1429),
    [sym__external_close_brace] = ACTIONS(387),
    [sym__external_open_bracket] = ACTIONS(387),
    [sym__external_open_bracket2] = ACTIONS(387),
  },
  [207] = {
    [sym_function_definition] = STATE(1087),
    [sym_if_statement] = STATE(1087),
    [sym_for_statement] = STATE(1087),
    [sym_while_statement] = STATE(1087),
    [sym_repeat_statement] = STATE(1087),
    [sym_braced_expression] = STATE(1087),
    [sym_parenthesized_expression] = STATE(1087),
    [sym_call] = STATE(1087),
    [sym_subset] = STATE(1087),
    [sym_subset2] = STATE(1087),
    [sym_unary_operator] = STATE(1087),
    [sym_binary_operator] = STATE(1087),
    [sym_extract_operator] = STATE(1087),
    [sym_namespace_operator] = STATE(1087),
    [sym_integer] = STATE(1087),
    [sym_complex] = STATE(1087),
    [sym_float] = STATE(1087),
    [sym__hex_literal] = STATE(2311),
    [sym__float_literal] = STATE(2311),
    [sym_string] = STATE(2312),
    [sym__single_quoted_string] = STATE(2310),
    [sym__double_quoted_string] = STATE(2309),
    [sym_na] = STATE(1087),
    [sym__expression] = STATE(1087),
    [sym__string_or_identifier] = STATE(5134),
    [sym__open_parenthesis] = STATE(64),
    [sym__open_brace] = STATE(199),
    [aux_sym_function_definition_repeat1] = STATE(205),
    [ts_builtin_sym_end] = ACTIONS(377),
    [sym_identifier] = ACTIONS(1385),
    [anon_sym_BSLASH] = ACTIONS(1387),
    [anon_sym_function] = ACTIONS(1389),
    [anon_sym_EQ] = ACTIONS(379),
    [anon_sym_if] = ACTIONS(1391),
    [anon_sym_for] = ACTIONS(1393),
    [anon_sym_while] = ACTIONS(1395),
    [anon_sym_repeat] = ACTIONS(1397),
    [anon_sym_QMARK] = ACTIONS(1399),
    [anon_sym_TILDE] = ACTIONS(1401),
    [anon_sym_BANG] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1407),
    [anon_sym_LT_DASH] = ACTIONS(377),
    [anon_sym_LT_LT_DASH] = ACTIONS(377),
    [anon_sym_COLON_EQ] = ACTIONS(377),
    [anon_sym_DASH_GT] = ACTIONS(379),
    [anon_sym_DASH_GT_GT] = ACTIONS(377),
    [anon_sym_PIPE] = ACTIONS(379),
    [anon_sym_AMP] = ACTIONS(379),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_LT] = ACTIONS(379),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(379),
    [anon_sym_GT_EQ] = ACTIONS(377),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(379),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_STAR_STAR] = ACTIONS(377),
    [anon_sym_CARET] = ACTIONS(377),
    [aux_sym_binary_operator_token1] = ACTIONS(377),
    [anon_sym_PIPE_GT] = ACTIONS(377),
    [anon_sym_COLON] = ACTIONS(379),
    [anon_sym_DOLLAR] = ACTIONS(377),
    [anon_sym_AT] = ACTIONS(377),
    [aux_sym__hex_literal_token1] = ACTIONS(1409),
    [sym__number_literal] = ACTIONS(1411),
    [anon_sym_SQUOTE] = ACTIONS(1413),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [sym_return] = ACTIONS(2589),
    [sym_next] = ACTIONS(2589),
    [sym_break] = ACTIONS(2589),
    [sym_true] = ACTIONS(2589),
    [sym_false] = ACTIONS(2589),
    [sym_null] = ACTIONS(2589),
    [sym_inf] = ACTIONS(2589),
    [sym_nan] = ACTIONS(2589),
    [anon_sym_NA] = ACTIONS(1419),
    [anon_sym_NA_integer_] = ACTIONS(1419),
    [anon_sym_NA_real_] = ACTIONS(1419),
    [anon_sym_NA_complex_] = ACTIONS(1419),
    [anon_sym_NA_character_] = ACTIONS(1419),
    [sym_dots] = ACTIONS(2589),
    [sym_dot_dot_i] = ACTIONS(2591),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(2593),
    [sym__semicolon] = ACTIONS(377),
    [sym__raw_string_literal] = ACTIONS(1425),
    [sym__external_else] = ACTIONS(377),
    [sym__external_open_parenthesis] = ACTIONS(1427),
    [sym__external_open_brace] = ACTIONS(1429),
    [sym__external_close_brace] = ACTIONS(377),
    [sym__external_open_bracket] = ACTIONS(377),
    [sym__external_open_bracket2] = ACTIONS(377),
  },
  [208] = {
    [sym_function_definition] = STATE(1084),
    [sym_if_statement] = STATE(1084),
    [sym_for_statement] = STATE(1084),
    [sym_while_statement] = STATE(1084),
    [sym_repeat_statement] = STATE(1084),
    [sym_braced_expression] = STATE(1084),
    [sym_parenthesized_expression] = STATE(1084),
    [sym_call] = STATE(1084),
    [sym_subset] = STATE(1084),
    [sym_subset2] = STATE(1084),
    [sym_unary_operator] = STATE(1084),
    [sym_binary_operator] = STATE(1084),
    [sym_extract_operator] = STATE(1084),
    [sym_namespace_operator] = STATE(1084),
    [sym_integer] = STATE(1084),
    [sym_complex] = STATE(1084),
    [sym_float] = STATE(1084),
    [sym__hex_literal] = STATE(2311),
    [sym__float_literal] = STATE(2311),
    [sym_string] = STATE(2312),
    [sym__single_quoted_string] = STATE(2310),
    [sym__double_quoted_string] = STATE(2309),
    [sym_na] = STATE(1084),
    [sym__expression] = STATE(1084),
    [sym__string_or_identifier] = STATE(5134),
    [sym__open_parenthesis] = STATE(64),
    [sym__open_brace] = STATE(199),
    [aux_sym_function_definition_repeat1] = STATE(2399),
    [ts_builtin_sym_end] = ACTIONS(369),
    [sym_identifier] = ACTIONS(1385),
    [anon_sym_BSLASH] = ACTIONS(1387),
    [anon_sym_function] = ACTIONS(1389),
    [anon_sym_EQ] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(1391),
    [anon_sym_for] = ACTIONS(1393),
    [anon_sym_while] = ACTIONS(1395),
    [anon_sym_repeat] = ACTIONS(1397),
    [anon_sym_QMARK] = ACTIONS(1399),
    [anon_sym_TILDE] = ACTIONS(1401),
    [anon_sym_BANG] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1407),
    [anon_sym_LT_DASH] = ACTIONS(369),
    [anon_sym_LT_LT_DASH] = ACTIONS(369),
    [anon_sym_COLON_EQ] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(371),
    [anon_sym_DASH_GT_GT] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(371),
    [anon_sym_AMP] = ACTIONS(371),
    [anon_sym_PIPE_PIPE] = ACTIONS(369),
    [anon_sym_AMP_AMP] = ACTIONS(369),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_LT_EQ] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_EQ] = ACTIONS(369),
    [anon_sym_EQ_EQ] = ACTIONS(369),
    [anon_sym_BANG_EQ] = ACTIONS(369),
    [anon_sym_STAR] = ACTIONS(371),
    [anon_sym_SLASH] = ACTIONS(369),
    [anon_sym_STAR_STAR] = ACTIONS(369),
    [anon_sym_CARET] = ACTIONS(369),
    [aux_sym_binary_operator_token1] = ACTIONS(369),
    [anon_sym_PIPE_GT] = ACTIONS(369),
    [anon_sym_COLON] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(369),
    [anon_sym_AT] = ACTIONS(369),
    [aux_sym__hex_literal_token1] = ACTIONS(1409),
    [sym__number_literal] = ACTIONS(1411),
    [anon_sym_SQUOTE] = ACTIONS(1413),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [sym_return] = ACTIONS(2595),
    [sym_next] = ACTIONS(2595),
    [sym_break] = ACTIONS(2595),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [sym_null] = ACTIONS(2595),
    [sym_inf] = ACTIONS(2595),
    [sym_nan] = ACTIONS(2595),
    [anon_sym_NA] = ACTIONS(1419),
    [anon_sym_NA_integer_] = ACTIONS(1419),
    [anon_sym_NA_real_] = ACTIONS(1419),
    [anon_sym_NA_complex_] = ACTIONS(1419),
    [anon_sym_NA_character_] = ACTIONS(1419),
    [sym_dots] = ACTIONS(2595),
    [sym_dot_dot_i] = ACTIONS(2597),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(369),
    [sym__semicolon] = ACTIONS(369),
    [sym__raw_string_literal] = ACTIONS(1425),
    [sym__external_else] = ACTIONS(369),
    [sym__external_open_parenthesis] = ACTIONS(1427),
    [sym__external_open_brace] = ACTIONS(1429),
    [sym__external_close_brace] = ACTIONS(369),
    [sym__external_open_bracket] = ACTIONS(369),
    [sym__external_open_bracket2] = ACTIONS(369),
  },
  [209] = {
    [sym_function_definition] = STATE(1082),
    [sym_if_statement] = STATE(1082),
    [sym_for_statement] = STATE(1082),
    [sym_while_statement] = STATE(1082),
    [sym_repeat_statement] = STATE(1082),
    [sym_braced_expression] = STATE(1082),
    [sym_parenthesized_expression] = STATE(1082),
    [sym_call] = STATE(1082),
    [sym_subset] = STATE(1082),
    [sym_subset2] = STATE(1082),
    [sym_unary_operator] = STATE(1082),
    [sym_binary_operator] = STATE(1082),
    [sym_extract_operator] = STATE(1082),
    [sym_namespace_operator] = STATE(1082),
    [sym_integer] = STATE(1082),
    [sym_complex] = STATE(1082),
    [sym_float] = STATE(1082),
    [sym__hex_literal] = STATE(2311),
    [sym__float_literal] = STATE(2311),
    [sym_string] = STATE(2312),
    [sym__single_quoted_string] = STATE(2310),
    [sym__double_quoted_string] = STATE(2309),
    [sym_na] = STATE(1082),
    [sym__expression] = STATE(1082),
    [sym__string_or_identifier] = STATE(5134),
    [sym__open_parenthesis] = STATE(64),
    [sym__open_brace] = STATE(199),
    [aux_sym_function_definition_repeat1] = STATE(208),
    [ts_builtin_sym_end] = ACTIONS(531),
    [sym_identifier] = ACTIONS(1385),
    [anon_sym_BSLASH] = ACTIONS(1387),
    [anon_sym_function] = ACTIONS(1389),
    [anon_sym_EQ] = ACTIONS(533),
    [anon_sym_if] = ACTIONS(1391),
    [anon_sym_for] = ACTIONS(1393),
    [anon_sym_while] = ACTIONS(1395),
    [anon_sym_repeat] = ACTIONS(1397),
    [anon_sym_QMARK] = ACTIONS(1399),
    [anon_sym_TILDE] = ACTIONS(1401),
    [anon_sym_BANG] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1407),
    [anon_sym_LT_DASH] = ACTIONS(531),
    [anon_sym_LT_LT_DASH] = ACTIONS(531),
    [anon_sym_COLON_EQ] = ACTIONS(531),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_DASH_GT_GT] = ACTIONS(531),
    [anon_sym_PIPE] = ACTIONS(533),
    [anon_sym_AMP] = ACTIONS(533),
    [anon_sym_PIPE_PIPE] = ACTIONS(531),
    [anon_sym_AMP_AMP] = ACTIONS(531),
    [anon_sym_LT] = ACTIONS(533),
    [anon_sym_LT_EQ] = ACTIONS(531),
    [anon_sym_GT] = ACTIONS(533),
    [anon_sym_GT_EQ] = ACTIONS(531),
    [anon_sym_EQ_EQ] = ACTIONS(531),
    [anon_sym_BANG_EQ] = ACTIONS(531),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_SLASH] = ACTIONS(531),
    [anon_sym_STAR_STAR] = ACTIONS(531),
    [anon_sym_CARET] = ACTIONS(531),
    [aux_sym_binary_operator_token1] = ACTIONS(531),
    [anon_sym_PIPE_GT] = ACTIONS(531),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_DOLLAR] = ACTIONS(531),
    [anon_sym_AT] = ACTIONS(531),
    [aux_sym__hex_literal_token1] = ACTIONS(1409),
    [sym__number_literal] = ACTIONS(1411),
    [anon_sym_SQUOTE] = ACTIONS(1413),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [sym_return] = ACTIONS(2599),
    [sym_next] = ACTIONS(2599),
    [sym_break] = ACTIONS(2599),
    [sym_true] = ACTIONS(2599),
    [sym_false] = ACTIONS(2599),
    [sym_null] = ACTIONS(2599),
    [sym_inf] = ACTIONS(2599),
    [sym_nan] = ACTIONS(2599),
    [anon_sym_NA] = ACTIONS(1419),
    [anon_sym_NA_integer_] = ACTIONS(1419),
    [anon_sym_NA_real_] = ACTIONS(1419),
    [anon_sym_NA_complex_] = ACTIONS(1419),
    [anon_sym_NA_character_] = ACTIONS(1419),
    [sym_dots] = ACTIONS(2599),
    [sym_dot_dot_i] = ACTIONS(2601),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(2603),
    [sym__semicolon] = ACTIONS(531),
    [sym__raw_string_literal] = ACTIONS(1425),
    [sym__external_else] = ACTIONS(531),
    [sym__external_open_parenthesis] = ACTIONS(1427),
    [sym__external_open_brace] = ACTIONS(1429),
    [sym__external_close_brace] = ACTIONS(531),
    [sym__external_open_bracket] = ACTIONS(531),
    [sym__external_open_bracket2] = ACTIONS(531),
  },
  [210] = {
    [sym_function_definition] = STATE(1599),
    [sym_if_statement] = STATE(1599),
    [sym_for_statement] = STATE(1599),
    [sym_while_statement] = STATE(1599),
    [sym_repeat_statement] = STATE(1599),
    [sym_braced_expression] = STATE(1599),
    [sym_parenthesized_expression] = STATE(1599),
    [sym_call] = STATE(1599),
    [sym_subset] = STATE(1599),
    [sym_subset2] = STATE(1599),
    [sym_unary_operator] = STATE(1599),
    [sym_binary_operator] = STATE(1599),
    [sym_extract_operator] = STATE(1599),
    [sym_namespace_operator] = STATE(1599),
    [sym_integer] = STATE(1599),
    [sym_complex] = STATE(1599),
    [sym_float] = STATE(1599),
    [sym__hex_literal] = STATE(2412),
    [sym__float_literal] = STATE(2412),
    [sym_string] = STATE(2397),
    [sym__single_quoted_string] = STATE(2430),
    [sym__double_quoted_string] = STATE(2466),
    [sym_na] = STATE(1599),
    [sym__expression] = STATE(1599),
    [sym__string_or_identifier] = STATE(5142),
    [sym__open_parenthesis] = STATE(210),
    [sym__close_parenthesis] = STATE(2916),
    [sym__open_brace] = STATE(74),
    [aux_sym_parenthesized_expression_repeat1] = STATE(203),
    [sym_identifier] = ACTIONS(2483),
    [anon_sym_BSLASH] = ACTIONS(2485),
    [anon_sym_function] = ACTIONS(2487),
    [anon_sym_EQ] = ACTIONS(109),
    [anon_sym_if] = ACTIONS(2489),
    [anon_sym_for] = ACTIONS(2491),
    [anon_sym_while] = ACTIONS(2493),
    [anon_sym_repeat] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(2497),
    [anon_sym_TILDE] = ACTIONS(2499),
    [anon_sym_BANG] = ACTIONS(2501),
    [anon_sym_PLUS] = ACTIONS(2503),
    [anon_sym_DASH] = ACTIONS(2505),
    [anon_sym_LT_DASH] = ACTIONS(129),
    [anon_sym_LT_LT_DASH] = ACTIONS(129),
    [anon_sym_COLON_EQ] = ACTIONS(129),
    [anon_sym_DASH_GT] = ACTIONS(109),
    [anon_sym_DASH_GT_GT] = ACTIONS(129),
    [anon_sym_PIPE] = ACTIONS(109),
    [anon_sym_AMP] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_STAR_STAR] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [aux_sym_binary_operator_token1] = ACTIONS(129),
    [anon_sym_PIPE_GT] = ACTIONS(129),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(129),
    [anon_sym_AT] = ACTIONS(129),
    [aux_sym__hex_literal_token1] = ACTIONS(2507),
    [sym__number_literal] = ACTIONS(2509),
    [anon_sym_SQUOTE] = ACTIONS(2511),
    [anon_sym_DQUOTE] = ACTIONS(2513),
    [sym_return] = ACTIONS(2515),
    [sym_next] = ACTIONS(2515),
    [sym_break] = ACTIONS(2515),
    [sym_true] = ACTIONS(2515),
    [sym_false] = ACTIONS(2515),
    [sym_null] = ACTIONS(2515),
    [sym_inf] = ACTIONS(2515),
    [sym_nan] = ACTIONS(2515),
    [anon_sym_NA] = ACTIONS(2517),
    [anon_sym_NA_integer_] = ACTIONS(2517),
    [anon_sym_NA_real_] = ACTIONS(2517),
    [anon_sym_NA_complex_] = ACTIONS(2517),
    [anon_sym_NA_character_] = ACTIONS(2517),
    [sym_dots] = ACTIONS(2515),
    [sym_dot_dot_i] = ACTIONS(2519),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(129),
    [sym__newline] = ACTIONS(2521),
    [sym__raw_string_literal] = ACTIONS(2523),
    [sym__external_open_parenthesis] = ACTIONS(2525),
    [sym__external_close_parenthesis] = ACTIONS(2605),
    [sym__external_open_brace] = ACTIONS(2529),
    [sym__external_open_bracket] = ACTIONS(129),
    [sym__external_open_bracket2] = ACTIONS(129),
    [sym__external_close_bracket2] = ACTIONS(129),
  },
  [211] = {
    [sym_function_definition] = STATE(1071),
    [sym_if_statement] = STATE(1071),
    [sym_for_statement] = STATE(1071),
    [sym_while_statement] = STATE(1071),
    [sym_repeat_statement] = STATE(1071),
    [sym_braced_expression] = STATE(1071),
    [sym_parenthesized_expression] = STATE(1071),
    [sym_call] = STATE(1071),
    [sym_subset] = STATE(1071),
    [sym_subset2] = STATE(1071),
    [sym_unary_operator] = STATE(1071),
    [sym_binary_operator] = STATE(1071),
    [sym_extract_operator] = STATE(1071),
    [sym_namespace_operator] = STATE(1071),
    [sym_integer] = STATE(1071),
    [sym_complex] = STATE(1071),
    [sym_float] = STATE(1071),
    [sym__hex_literal] = STATE(2235),
    [sym__float_literal] = STATE(2235),
    [sym_string] = STATE(2234),
    [sym__single_quoted_string] = STATE(2236),
    [sym__double_quoted_string] = STATE(2237),
    [sym_na] = STATE(1071),
    [sym__expression] = STATE(1071),
    [sym__string_or_identifier] = STATE(5150),
    [sym__open_parenthesis] = STATE(76),
    [sym__open_brace] = STATE(188),
    [aux_sym_function_definition_repeat1] = STATE(2400),
    [sym_identifier] = ACTIONS(1433),
    [anon_sym_BSLASH] = ACTIONS(1435),
    [anon_sym_function] = ACTIONS(1437),
    [anon_sym_EQ] = ACTIONS(455),
    [anon_sym_if] = ACTIONS(1439),
    [anon_sym_for] = ACTIONS(1441),
    [anon_sym_while] = ACTIONS(1443),
    [anon_sym_repeat] = ACTIONS(1445),
    [anon_sym_QMARK] = ACTIONS(1447),
    [anon_sym_TILDE] = ACTIONS(1449),
    [anon_sym_BANG] = ACTIONS(1451),
    [anon_sym_PLUS] = ACTIONS(1453),
    [anon_sym_DASH] = ACTIONS(1455),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [anon_sym_LT_LT_DASH] = ACTIONS(453),
    [anon_sym_COLON_EQ] = ACTIONS(453),
    [anon_sym_DASH_GT] = ACTIONS(455),
    [anon_sym_DASH_GT_GT] = ACTIONS(453),
    [anon_sym_PIPE] = ACTIONS(455),
    [anon_sym_AMP] = ACTIONS(455),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(455),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_GT] = ACTIONS(455),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(453),
    [anon_sym_STAR] = ACTIONS(455),
    [anon_sym_SLASH] = ACTIONS(453),
    [anon_sym_STAR_STAR] = ACTIONS(453),
    [anon_sym_CARET] = ACTIONS(453),
    [aux_sym_binary_operator_token1] = ACTIONS(453),
    [anon_sym_PIPE_GT] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(455),
    [anon_sym_DOLLAR] = ACTIONS(453),
    [anon_sym_AT] = ACTIONS(453),
    [aux_sym__hex_literal_token1] = ACTIONS(1457),
    [sym__number_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [anon_sym_DQUOTE] = ACTIONS(1463),
    [sym_return] = ACTIONS(2607),
    [sym_next] = ACTIONS(2607),
    [sym_break] = ACTIONS(2607),
    [sym_true] = ACTIONS(2607),
    [sym_false] = ACTIONS(2607),
    [sym_null] = ACTIONS(2607),
    [sym_inf] = ACTIONS(2607),
    [sym_nan] = ACTIONS(2607),
    [anon_sym_NA] = ACTIONS(1467),
    [anon_sym_NA_integer_] = ACTIONS(1467),
    [anon_sym_NA_real_] = ACTIONS(1467),
    [anon_sym_NA_complex_] = ACTIONS(1467),
    [anon_sym_NA_character_] = ACTIONS(1467),
    [sym_dots] = ACTIONS(2607),
    [sym_dot_dot_i] = ACTIONS(2609),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(453),
    [sym__newline] = ACTIONS(453),
    [sym__semicolon] = ACTIONS(453),
    [sym__raw_string_literal] = ACTIONS(1473),
    [sym__external_open_parenthesis] = ACTIONS(1475),
    [sym__external_open_brace] = ACTIONS(1477),
    [sym__external_close_brace] = ACTIONS(453),
    [sym__external_open_bracket] = ACTIONS(453),
    [sym__external_open_bracket2] = ACTIONS(453),
    [sym__external_close_bracket2] = ACTIONS(453),
  },
  [212] = {
    [sym_function_definition] = STATE(1058),
    [sym_if_statement] = STATE(1058),
    [sym_for_statement] = STATE(1058),
    [sym_while_statement] = STATE(1058),
    [sym_repeat_statement] = STATE(1058),
    [sym_braced_expression] = STATE(1058),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_call] = STATE(1058),
    [sym_subset] = STATE(1058),
    [sym_subset2] = STATE(1058),
    [sym_unary_operator] = STATE(1058),
    [sym_binary_operator] = STATE(1058),
    [sym_extract_operator] = STATE(1058),
    [sym_namespace_operator] = STATE(1058),
    [sym_integer] = STATE(1058),
    [sym_complex] = STATE(1058),
    [sym_float] = STATE(1058),
    [sym__hex_literal] = STATE(2311),
    [sym__float_literal] = STATE(2311),
    [sym_string] = STATE(2312),
    [sym__single_quoted_string] = STATE(2310),
    [sym__double_quoted_string] = STATE(2309),
    [sym_na] = STATE(1058),
    [sym__expression] = STATE(1058),
    [sym__string_or_identifier] = STATE(5134),
    [sym__open_parenthesis] = STATE(64),
    [sym__open_brace] = STATE(199),
    [aux_sym_function_definition_repeat1] = STATE(2399),
    [ts_builtin_sym_end] = ACTIONS(757),
    [sym_identifier] = ACTIONS(1385),
    [anon_sym_BSLASH] = ACTIONS(1387),
    [anon_sym_function] = ACTIONS(1389),
    [anon_sym_EQ] = ACTIONS(759),
    [anon_sym_if] = ACTIONS(1391),
    [anon_sym_for] = ACTIONS(1393),
    [anon_sym_while] = ACTIONS(1395),
    [anon_sym_repeat] = ACTIONS(1397),
    [anon_sym_QMARK] = ACTIONS(1399),
    [anon_sym_TILDE] = ACTIONS(1401),
    [anon_sym_BANG] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1407),
    [anon_sym_LT_DASH] = ACTIONS(757),
    [anon_sym_LT_LT_DASH] = ACTIONS(757),
    [anon_sym_COLON_EQ] = ACTIONS(757),
    [anon_sym_DASH_GT] = ACTIONS(759),
    [anon_sym_DASH_GT_GT] = ACTIONS(757),
    [anon_sym_PIPE] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(759),
    [anon_sym_PIPE_PIPE] = ACTIONS(757),
    [anon_sym_AMP_AMP] = ACTIONS(757),
    [anon_sym_LT] = ACTIONS(759),
    [anon_sym_LT_EQ] = ACTIONS(757),
    [anon_sym_GT] = ACTIONS(759),
    [anon_sym_GT_EQ] = ACTIONS(757),
    [anon_sym_EQ_EQ] = ACTIONS(757),
    [anon_sym_BANG_EQ] = ACTIONS(757),
    [anon_sym_STAR] = ACTIONS(759),
    [anon_sym_SLASH] = ACTIONS(757),
    [anon_sym_STAR_STAR] = ACTIONS(757),
    [anon_sym_CARET] = ACTIONS(757),
    [aux_sym_binary_operator_token1] = ACTIONS(757),
    [anon_sym_PIPE_GT] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(759),
    [anon_sym_DOLLAR] = ACTIONS(757),
    [anon_sym_AT] = ACTIONS(757),
    [aux_sym__hex_literal_token1] = ACTIONS(1409),
    [sym__number_literal] = ACTIONS(1411),
    [anon_sym_SQUOTE] = ACTIONS(1413),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [sym_return] = ACTIONS(2611),
    [sym_next] = ACTIONS(2611),
    [sym_break] = ACTIONS(2611),
    [sym_true] = ACTIONS(2611),
    [sym_false] = ACTIONS(2611),
    [sym_null] = ACTIONS(2611),
    [sym_inf] = ACTIONS(2611),
    [sym_nan] = ACTIONS(2611),
    [anon_sym_NA] = ACTIONS(1419),
    [anon_sym_NA_integer_] = ACTIONS(1419),
    [anon_sym_NA_real_] = ACTIONS(1419),
    [anon_sym_NA_complex_] = ACTIONS(1419),
    [anon_sym_NA_character_] = ACTIONS(1419),
    [sym_dots] = ACTIONS(2611),
    [sym_dot_dot_i] = ACTIONS(2613),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(757),
    [sym__semicolon] = ACTIONS(757),
    [sym__raw_string_literal] = ACTIONS(1425),
    [sym__external_else] = ACTIONS(757),
    [sym__external_open_parenthesis] = ACTIONS(1427),
    [sym__external_open_brace] = ACTIONS(1429),
    [sym__external_close_brace] = ACTIONS(757),
    [sym__external_open_bracket] = ACTIONS(757),
    [sym__external_open_bracket2] = ACTIONS(757),
  },
  [213] = {
    [sym_function_definition] = STATE(1618),
    [sym_if_statement] = STATE(1618),
    [sym_for_statement] = STATE(1618),
    [sym_while_statement] = STATE(1618),
    [sym_repeat_statement] = STATE(1618),
    [sym_braced_expression] = STATE(1618),
    [sym_parenthesized_expression] = STATE(1618),
    [sym_call] = STATE(1618),
    [sym_subset] = STATE(1618),
    [sym_subset2] = STATE(1618),
    [sym_unary_operator] = STATE(1618),
    [sym_binary_operator] = STATE(1618),
    [sym_extract_operator] = STATE(1618),
    [sym_namespace_operator] = STATE(1618),
    [sym_integer] = STATE(1618),
    [sym_complex] = STATE(1618),
    [sym_float] = STATE(1618),
    [sym__hex_literal] = STATE(2445),
    [sym__float_literal] = STATE(2445),
    [sym_string] = STATE(2530),
    [sym__single_quoted_string] = STATE(2442),
    [sym__double_quoted_string] = STATE(2437),
    [sym_na] = STATE(1618),
    [sym__expression] = STATE(1618),
    [sym__string_or_identifier] = STATE(5133),
    [sym__open_parenthesis] = STATE(213),
    [sym__close_parenthesis] = STATE(2769),
    [sym__open_brace] = STATE(70),
    [aux_sym_parenthesized_expression_repeat1] = STATE(204),
    [sym_identifier] = ACTIONS(2531),
    [anon_sym_BSLASH] = ACTIONS(2533),
    [anon_sym_function] = ACTIONS(2535),
    [anon_sym_EQ] = ACTIONS(109),
    [anon_sym_if] = ACTIONS(2537),
    [anon_sym_for] = ACTIONS(2539),
    [anon_sym_while] = ACTIONS(2541),
    [anon_sym_repeat] = ACTIONS(2543),
    [anon_sym_QMARK] = ACTIONS(2545),
    [anon_sym_TILDE] = ACTIONS(2547),
    [anon_sym_BANG] = ACTIONS(2549),
    [anon_sym_PLUS] = ACTIONS(2551),
    [anon_sym_DASH] = ACTIONS(2553),
    [anon_sym_LT_DASH] = ACTIONS(129),
    [anon_sym_LT_LT_DASH] = ACTIONS(129),
    [anon_sym_COLON_EQ] = ACTIONS(129),
    [anon_sym_DASH_GT] = ACTIONS(109),
    [anon_sym_DASH_GT_GT] = ACTIONS(129),
    [anon_sym_PIPE] = ACTIONS(109),
    [anon_sym_AMP] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_STAR_STAR] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [aux_sym_binary_operator_token1] = ACTIONS(129),
    [anon_sym_PIPE_GT] = ACTIONS(129),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(129),
    [anon_sym_AT] = ACTIONS(129),
    [aux_sym__hex_literal_token1] = ACTIONS(2555),
    [sym__number_literal] = ACTIONS(2557),
    [anon_sym_SQUOTE] = ACTIONS(2559),
    [anon_sym_DQUOTE] = ACTIONS(2561),
    [sym_return] = ACTIONS(2563),
    [sym_next] = ACTIONS(2563),
    [sym_break] = ACTIONS(2563),
    [sym_true] = ACTIONS(2563),
    [sym_false] = ACTIONS(2563),
    [sym_null] = ACTIONS(2563),
    [sym_inf] = ACTIONS(2563),
    [sym_nan] = ACTIONS(2563),
    [anon_sym_NA] = ACTIONS(2565),
    [anon_sym_NA_integer_] = ACTIONS(2565),
    [anon_sym_NA_real_] = ACTIONS(2565),
    [anon_sym_NA_complex_] = ACTIONS(2565),
    [anon_sym_NA_character_] = ACTIONS(2565),
    [sym_dots] = ACTIONS(2563),
    [sym_dot_dot_i] = ACTIONS(2567),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(129),
    [sym__newline] = ACTIONS(2569),
    [sym__raw_string_literal] = ACTIONS(2571),
    [sym__external_open_parenthesis] = ACTIONS(2573),
    [sym__external_close_parenthesis] = ACTIONS(2615),
    [sym__external_open_brace] = ACTIONS(2577),
    [sym__external_open_bracket] = ACTIONS(129),
    [sym__external_close_bracket] = ACTIONS(129),
    [sym__external_open_bracket2] = ACTIONS(129),
  },
  [214] = {
    [sym_function_definition] = STATE(1618),
    [sym_if_statement] = STATE(1618),
    [sym_for_statement] = STATE(1618),
    [sym_while_statement] = STATE(1618),
    [sym_repeat_statement] = STATE(1618),
    [sym_braced_expression] = STATE(1618),
    [sym_parenthesized_expression] = STATE(1618),
    [sym_call] = STATE(1618),
    [sym_subset] = STATE(1618),
    [sym_subset2] = STATE(1618),
    [sym_unary_operator] = STATE(1618),
    [sym_binary_operator] = STATE(1618),
    [sym_extract_operator] = STATE(1618),
    [sym_namespace_operator] = STATE(1618),
    [sym_integer] = STATE(1618),
    [sym_complex] = STATE(1618),
    [sym_float] = STATE(1618),
    [sym__hex_literal] = STATE(2445),
    [sym__float_literal] = STATE(2445),
    [sym_string] = STATE(2530),
    [sym__single_quoted_string] = STATE(2442),
    [sym__double_quoted_string] = STATE(2437),
    [sym_na] = STATE(1618),
    [sym__expression] = STATE(1618),
    [sym__string_or_identifier] = STATE(5133),
    [sym__open_parenthesis] = STATE(213),
    [sym__close_parenthesis] = STATE(3022),
    [sym__open_brace] = STATE(70),
    [aux_sym_parenthesized_expression_repeat1] = STATE(295),
    [sym_identifier] = ACTIONS(2531),
    [anon_sym_BSLASH] = ACTIONS(2533),
    [anon_sym_function] = ACTIONS(2535),
    [anon_sym_EQ] = ACTIONS(109),
    [anon_sym_if] = ACTIONS(2537),
    [anon_sym_for] = ACTIONS(2539),
    [anon_sym_while] = ACTIONS(2541),
    [anon_sym_repeat] = ACTIONS(2543),
    [anon_sym_QMARK] = ACTIONS(2545),
    [anon_sym_TILDE] = ACTIONS(2547),
    [anon_sym_BANG] = ACTIONS(2549),
    [anon_sym_PLUS] = ACTIONS(2551),
    [anon_sym_DASH] = ACTIONS(2553),
    [anon_sym_LT_DASH] = ACTIONS(129),
    [anon_sym_LT_LT_DASH] = ACTIONS(129),
    [anon_sym_COLON_EQ] = ACTIONS(129),
    [anon_sym_DASH_GT] = ACTIONS(109),
    [anon_sym_DASH_GT_GT] = ACTIONS(129),
    [anon_sym_PIPE] = ACTIONS(109),
    [anon_sym_AMP] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_STAR_STAR] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [aux_sym_binary_operator_token1] = ACTIONS(129),
    [anon_sym_PIPE_GT] = ACTIONS(129),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(129),
    [anon_sym_AT] = ACTIONS(129),
    [aux_sym__hex_literal_token1] = ACTIONS(2555),
    [sym__number_literal] = ACTIONS(2557),
    [anon_sym_SQUOTE] = ACTIONS(2559),
    [anon_sym_DQUOTE] = ACTIONS(2561),
    [sym_return] = ACTIONS(2563),
    [sym_next] = ACTIONS(2563),
    [sym_break] = ACTIONS(2563),
    [sym_true] = ACTIONS(2563),
    [sym_false] = ACTIONS(2563),
    [sym_null] = ACTIONS(2563),
    [sym_inf] = ACTIONS(2563),
    [sym_nan] = ACTIONS(2563),
    [anon_sym_NA] = ACTIONS(2565),
    [anon_sym_NA_integer_] = ACTIONS(2565),
    [anon_sym_NA_real_] = ACTIONS(2565),
    [anon_sym_NA_complex_] = ACTIONS(2565),
    [anon_sym_NA_character_] = ACTIONS(2565),
    [sym_dots] = ACTIONS(2563),
    [sym_dot_dot_i] = ACTIONS(2567),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(129),
    [sym__newline] = ACTIONS(2569),
    [sym__raw_string_literal] = ACTIONS(2571),
    [sym__external_open_parenthesis] = ACTIONS(2573),
    [sym__external_close_parenthesis] = ACTIONS(2617),
    [sym__external_open_brace] = ACTIONS(2577),
    [sym__external_open_bracket] = ACTIONS(129),
    [sym__external_close_bracket] = ACTIONS(129),
    [sym__external_open_bracket2] = ACTIONS(129),
  },
  [215] = {
    [sym_function_definition] = STATE(1040),
    [sym_if_statement] = STATE(1040),
    [sym_for_statement] = STATE(1040),
    [sym_while_statement] = STATE(1040),
    [sym_repeat_statement] = STATE(1040),
    [sym_braced_expression] = STATE(1040),
    [sym_parenthesized_expression] = STATE(1040),
    [sym_call] = STATE(1040),
    [sym_subset] = STATE(1040),
    [sym_subset2] = STATE(1040),
    [sym_unary_operator] = STATE(1040),
    [sym_binary_operator] = STATE(1040),
    [sym_extract_operator] = STATE(1040),
    [sym_namespace_operator] = STATE(1040),
    [sym_integer] = STATE(1040),
    [sym_complex] = STATE(1040),
    [sym_float] = STATE(1040),
    [sym__hex_literal] = STATE(2311),
    [sym__float_literal] = STATE(2311),
    [sym_string] = STATE(2312),
    [sym__single_quoted_string] = STATE(2310),
    [sym__double_quoted_string] = STATE(2309),
    [sym_na] = STATE(1040),
    [sym__expression] = STATE(1040),
    [sym__string_or_identifier] = STATE(5134),
    [sym__open_parenthesis] = STATE(64),
    [sym__open_brace] = STATE(199),
    [aux_sym_function_definition_repeat1] = STATE(2399),
    [ts_builtin_sym_end] = ACTIONS(765),
    [sym_identifier] = ACTIONS(1385),
    [anon_sym_BSLASH] = ACTIONS(1387),
    [anon_sym_function] = ACTIONS(1389),
    [anon_sym_EQ] = ACTIONS(767),
    [anon_sym_if] = ACTIONS(1391),
    [anon_sym_for] = ACTIONS(1393),
    [anon_sym_while] = ACTIONS(1395),
    [anon_sym_repeat] = ACTIONS(1397),
    [anon_sym_QMARK] = ACTIONS(1399),
    [anon_sym_TILDE] = ACTIONS(1401),
    [anon_sym_BANG] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1407),
    [anon_sym_LT_DASH] = ACTIONS(765),
    [anon_sym_LT_LT_DASH] = ACTIONS(765),
    [anon_sym_COLON_EQ] = ACTIONS(765),
    [anon_sym_DASH_GT] = ACTIONS(767),
    [anon_sym_DASH_GT_GT] = ACTIONS(765),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_AMP] = ACTIONS(767),
    [anon_sym_PIPE_PIPE] = ACTIONS(765),
    [anon_sym_AMP_AMP] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(767),
    [anon_sym_LT_EQ] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_GT_EQ] = ACTIONS(765),
    [anon_sym_EQ_EQ] = ACTIONS(765),
    [anon_sym_BANG_EQ] = ACTIONS(765),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(765),
    [anon_sym_STAR_STAR] = ACTIONS(765),
    [anon_sym_CARET] = ACTIONS(765),
    [aux_sym_binary_operator_token1] = ACTIONS(765),
    [anon_sym_PIPE_GT] = ACTIONS(765),
    [anon_sym_COLON] = ACTIONS(767),
    [anon_sym_DOLLAR] = ACTIONS(765),
    [anon_sym_AT] = ACTIONS(765),
    [aux_sym__hex_literal_token1] = ACTIONS(1409),
    [sym__number_literal] = ACTIONS(1411),
    [anon_sym_SQUOTE] = ACTIONS(1413),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [sym_return] = ACTIONS(2619),
    [sym_next] = ACTIONS(2619),
    [sym_break] = ACTIONS(2619),
    [sym_true] = ACTIONS(2619),
    [sym_false] = ACTIONS(2619),
    [sym_null] = ACTIONS(2619),
    [sym_inf] = ACTIONS(2619),
    [sym_nan] = ACTIONS(2619),
    [anon_sym_NA] = ACTIONS(1419),
    [anon_sym_NA_integer_] = ACTIONS(1419),
    [anon_sym_NA_real_] = ACTIONS(1419),
    [anon_sym_NA_complex_] = ACTIONS(1419),
    [anon_sym_NA_character_] = ACTIONS(1419),
    [sym_dots] = ACTIONS(2619),
    [sym_dot_dot_i] = ACTIONS(2621),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(765),
    [sym__semicolon] = ACTIONS(765),
    [sym__raw_string_literal] = ACTIONS(1425),
    [sym__external_else] = ACTIONS(765),
    [sym__external_open_parenthesis] = ACTIONS(1427),
    [sym__external_open_brace] = ACTIONS(1429),
    [sym__external_close_brace] = ACTIONS(765),
    [sym__external_open_bracket] = ACTIONS(765),
    [sym__external_open_bracket2] = ACTIONS(765),
  },
  [216] = {
    [sym_function_definition] = STATE(1076),
    [sym_if_statement] = STATE(1076),
    [sym_for_statement] = STATE(1076),
    [sym_while_statement] = STATE(1076),
    [sym_repeat_statement] = STATE(1076),
    [sym_braced_expression] = STATE(1076),
    [sym_parenthesized_expression] = STATE(1076),
    [sym_call] = STATE(1076),
    [sym_subset] = STATE(1076),
    [sym_subset2] = STATE(1076),
    [sym_unary_operator] = STATE(1076),
    [sym_binary_operator] = STATE(1076),
    [sym_extract_operator] = STATE(1076),
    [sym_namespace_operator] = STATE(1076),
    [sym_integer] = STATE(1076),
    [sym_complex] = STATE(1076),
    [sym_float] = STATE(1076),
    [sym__hex_literal] = STATE(2235),
    [sym__float_literal] = STATE(2235),
    [sym_string] = STATE(2234),
    [sym__single_quoted_string] = STATE(2236),
    [sym__double_quoted_string] = STATE(2237),
    [sym_na] = STATE(1076),
    [sym__expression] = STATE(1076),
    [sym__string_or_identifier] = STATE(5150),
    [sym__open_parenthesis] = STATE(76),
    [sym__open_brace] = STATE(188),
    [aux_sym_function_definition_repeat1] = STATE(2400),
    [sym_identifier] = ACTIONS(1433),
    [anon_sym_BSLASH] = ACTIONS(1435),
    [anon_sym_function] = ACTIONS(1437),
    [anon_sym_EQ] = ACTIONS(399),
    [anon_sym_if] = ACTIONS(1439),
    [anon_sym_for] = ACTIONS(1441),
    [anon_sym_while] = ACTIONS(1443),
    [anon_sym_repeat] = ACTIONS(1445),
    [anon_sym_QMARK] = ACTIONS(1447),
    [anon_sym_TILDE] = ACTIONS(1449),
    [anon_sym_BANG] = ACTIONS(1451),
    [anon_sym_PLUS] = ACTIONS(1453),
    [anon_sym_DASH] = ACTIONS(1455),
    [anon_sym_LT_DASH] = ACTIONS(397),
    [anon_sym_LT_LT_DASH] = ACTIONS(397),
    [anon_sym_COLON_EQ] = ACTIONS(397),
    [anon_sym_DASH_GT] = ACTIONS(399),
    [anon_sym_DASH_GT_GT] = ACTIONS(397),
    [anon_sym_PIPE] = ACTIONS(399),
    [anon_sym_AMP] = ACTIONS(399),
    [anon_sym_PIPE_PIPE] = ACTIONS(397),
    [anon_sym_AMP_AMP] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(399),
    [anon_sym_LT_EQ] = ACTIONS(397),
    [anon_sym_GT] = ACTIONS(399),
    [anon_sym_GT_EQ] = ACTIONS(397),
    [anon_sym_EQ_EQ] = ACTIONS(397),
    [anon_sym_BANG_EQ] = ACTIONS(397),
    [anon_sym_STAR] = ACTIONS(399),
    [anon_sym_SLASH] = ACTIONS(397),
    [anon_sym_STAR_STAR] = ACTIONS(397),
    [anon_sym_CARET] = ACTIONS(397),
    [aux_sym_binary_operator_token1] = ACTIONS(397),
    [anon_sym_PIPE_GT] = ACTIONS(397),
    [anon_sym_COLON] = ACTIONS(399),
    [anon_sym_DOLLAR] = ACTIONS(397),
    [anon_sym_AT] = ACTIONS(397),
    [aux_sym__hex_literal_token1] = ACTIONS(1457),
    [sym__number_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [anon_sym_DQUOTE] = ACTIONS(1463),
    [sym_return] = ACTIONS(2623),
    [sym_next] = ACTIONS(2623),
    [sym_break] = ACTIONS(2623),
    [sym_true] = ACTIONS(2623),
    [sym_false] = ACTIONS(2623),
    [sym_null] = ACTIONS(2623),
    [sym_inf] = ACTIONS(2623),
    [sym_nan] = ACTIONS(2623),
    [anon_sym_NA] = ACTIONS(1467),
    [anon_sym_NA_integer_] = ACTIONS(1467),
    [anon_sym_NA_real_] = ACTIONS(1467),
    [anon_sym_NA_complex_] = ACTIONS(1467),
    [anon_sym_NA_character_] = ACTIONS(1467),
    [sym_dots] = ACTIONS(2623),
    [sym_dot_dot_i] = ACTIONS(2625),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(397),
    [sym__newline] = ACTIONS(397),
    [sym__semicolon] = ACTIONS(397),
    [sym__raw_string_literal] = ACTIONS(1473),
    [sym__external_open_parenthesis] = ACTIONS(1475),
    [sym__external_open_brace] = ACTIONS(1477),
    [sym__external_close_brace] = ACTIONS(397),
    [sym__external_open_bracket] = ACTIONS(397),
    [sym__external_open_bracket2] = ACTIONS(397),
    [sym__external_close_bracket2] = ACTIONS(397),
  },
  [217] = {
    [sym_function_definition] = STATE(1039),
    [sym_if_statement] = STATE(1039),
    [sym_for_statement] = STATE(1039),
    [sym_while_statement] = STATE(1039),
    [sym_repeat_statement] = STATE(1039),
    [sym_braced_expression] = STATE(1039),
    [sym_parenthesized_expression] = STATE(1039),
    [sym_call] = STATE(1039),
    [sym_subset] = STATE(1039),
    [sym_subset2] = STATE(1039),
    [sym_unary_operator] = STATE(1039),
    [sym_binary_operator] = STATE(1039),
    [sym_extract_operator] = STATE(1039),
    [sym_namespace_operator] = STATE(1039),
    [sym_integer] = STATE(1039),
    [sym_complex] = STATE(1039),
    [sym_float] = STATE(1039),
    [sym__hex_literal] = STATE(2311),
    [sym__float_literal] = STATE(2311),
    [sym_string] = STATE(2312),
    [sym__single_quoted_string] = STATE(2310),
    [sym__double_quoted_string] = STATE(2309),
    [sym_na] = STATE(1039),
    [sym__expression] = STATE(1039),
    [sym__string_or_identifier] = STATE(5134),
    [sym__open_parenthesis] = STATE(64),
    [sym__open_brace] = STATE(199),
    [aux_sym_function_definition_repeat1] = STATE(212),
    [ts_builtin_sym_end] = ACTIONS(545),
    [sym_identifier] = ACTIONS(1385),
    [anon_sym_BSLASH] = ACTIONS(1387),
    [anon_sym_function] = ACTIONS(1389),
    [anon_sym_EQ] = ACTIONS(543),
    [anon_sym_if] = ACTIONS(1391),
    [anon_sym_for] = ACTIONS(1393),
    [anon_sym_while] = ACTIONS(1395),
    [anon_sym_repeat] = ACTIONS(1397),
    [anon_sym_QMARK] = ACTIONS(1399),
    [anon_sym_TILDE] = ACTIONS(1401),
    [anon_sym_BANG] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1407),
    [anon_sym_LT_DASH] = ACTIONS(545),
    [anon_sym_LT_LT_DASH] = ACTIONS(545),
    [anon_sym_COLON_EQ] = ACTIONS(545),
    [anon_sym_DASH_GT] = ACTIONS(543),
    [anon_sym_DASH_GT_GT] = ACTIONS(545),
    [anon_sym_PIPE] = ACTIONS(543),
    [anon_sym_AMP] = ACTIONS(543),
    [anon_sym_PIPE_PIPE] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(543),
    [anon_sym_LT_EQ] = ACTIONS(545),
    [anon_sym_GT] = ACTIONS(543),
    [anon_sym_GT_EQ] = ACTIONS(545),
    [anon_sym_EQ_EQ] = ACTIONS(545),
    [anon_sym_BANG_EQ] = ACTIONS(545),
    [anon_sym_STAR] = ACTIONS(543),
    [anon_sym_SLASH] = ACTIONS(545),
    [anon_sym_STAR_STAR] = ACTIONS(545),
    [anon_sym_CARET] = ACTIONS(545),
    [aux_sym_binary_operator_token1] = ACTIONS(545),
    [anon_sym_PIPE_GT] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(543),
    [anon_sym_DOLLAR] = ACTIONS(545),
    [anon_sym_AT] = ACTIONS(545),
    [aux_sym__hex_literal_token1] = ACTIONS(1409),
    [sym__number_literal] = ACTIONS(1411),
    [anon_sym_SQUOTE] = ACTIONS(1413),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [sym_return] = ACTIONS(2627),
    [sym_next] = ACTIONS(2627),
    [sym_break] = ACTIONS(2627),
    [sym_true] = ACTIONS(2627),
    [sym_false] = ACTIONS(2627),
    [sym_null] = ACTIONS(2627),
    [sym_inf] = ACTIONS(2627),
    [sym_nan] = ACTIONS(2627),
    [anon_sym_NA] = ACTIONS(1419),
    [anon_sym_NA_integer_] = ACTIONS(1419),
    [anon_sym_NA_real_] = ACTIONS(1419),
    [anon_sym_NA_complex_] = ACTIONS(1419),
    [anon_sym_NA_character_] = ACTIONS(1419),
    [sym_dots] = ACTIONS(2627),
    [sym_dot_dot_i] = ACTIONS(2629),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(2631),
    [sym__semicolon] = ACTIONS(545),
    [sym__raw_string_literal] = ACTIONS(1425),
    [sym__external_else] = ACTIONS(545),
    [sym__external_open_parenthesis] = ACTIONS(1427),
    [sym__external_open_brace] = ACTIONS(1429),
    [sym__external_close_brace] = ACTIONS(545),
    [sym__external_open_bracket] = ACTIONS(545),
    [sym__external_open_bracket2] = ACTIONS(545),
  },
  [218] = {
    [sym_function_definition] = STATE(1599),
    [sym_if_statement] = STATE(1599),
    [sym_for_statement] = STATE(1599),
    [sym_while_statement] = STATE(1599),
    [sym_repeat_statement] = STATE(1599),
    [sym_braced_expression] = STATE(1599),
    [sym_parenthesized_expression] = STATE(1599),
    [sym_call] = STATE(1599),
    [sym_subset] = STATE(1599),
    [sym_subset2] = STATE(1599),
    [sym_unary_operator] = STATE(1599),
    [sym_binary_operator] = STATE(1599),
    [sym_extract_operator] = STATE(1599),
    [sym_namespace_operator] = STATE(1599),
    [sym_integer] = STATE(1599),
    [sym_complex] = STATE(1599),
    [sym_float] = STATE(1599),
    [sym__hex_literal] = STATE(2412),
    [sym__float_literal] = STATE(2412),
    [sym_string] = STATE(2397),
    [sym__single_quoted_string] = STATE(2430),
    [sym__double_quoted_string] = STATE(2466),
    [sym_na] = STATE(1599),
    [sym__expression] = STATE(1599),
    [sym__string_or_identifier] = STATE(5142),
    [sym__open_parenthesis] = STATE(210),
    [sym__close_parenthesis] = STATE(2975),
    [sym__open_brace] = STATE(74),
    [aux_sym_parenthesized_expression_repeat1] = STATE(280),
    [sym_identifier] = ACTIONS(2483),
    [anon_sym_BSLASH] = ACTIONS(2485),
    [anon_sym_function] = ACTIONS(2487),
    [anon_sym_EQ] = ACTIONS(109),
    [anon_sym_if] = ACTIONS(2489),
    [anon_sym_for] = ACTIONS(2491),
    [anon_sym_while] = ACTIONS(2493),
    [anon_sym_repeat] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(2497),
    [anon_sym_TILDE] = ACTIONS(2499),
    [anon_sym_BANG] = ACTIONS(2501),
    [anon_sym_PLUS] = ACTIONS(2503),
    [anon_sym_DASH] = ACTIONS(2505),
    [anon_sym_LT_DASH] = ACTIONS(129),
    [anon_sym_LT_LT_DASH] = ACTIONS(129),
    [anon_sym_COLON_EQ] = ACTIONS(129),
    [anon_sym_DASH_GT] = ACTIONS(109),
    [anon_sym_DASH_GT_GT] = ACTIONS(129),
    [anon_sym_PIPE] = ACTIONS(109),
    [anon_sym_AMP] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_STAR_STAR] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [aux_sym_binary_operator_token1] = ACTIONS(129),
    [anon_sym_PIPE_GT] = ACTIONS(129),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(129),
    [anon_sym_AT] = ACTIONS(129),
    [aux_sym__hex_literal_token1] = ACTIONS(2507),
    [sym__number_literal] = ACTIONS(2509),
    [anon_sym_SQUOTE] = ACTIONS(2511),
    [anon_sym_DQUOTE] = ACTIONS(2513),
    [sym_return] = ACTIONS(2515),
    [sym_next] = ACTIONS(2515),
    [sym_break] = ACTIONS(2515),
    [sym_true] = ACTIONS(2515),
    [sym_false] = ACTIONS(2515),
    [sym_null] = ACTIONS(2515),
    [sym_inf] = ACTIONS(2515),
    [sym_nan] = ACTIONS(2515),
    [anon_sym_NA] = ACTIONS(2517),
    [anon_sym_NA_integer_] = ACTIONS(2517),
    [anon_sym_NA_real_] = ACTIONS(2517),
    [anon_sym_NA_complex_] = ACTIONS(2517),
    [anon_sym_NA_character_] = ACTIONS(2517),
    [sym_dots] = ACTIONS(2515),
    [sym_dot_dot_i] = ACTIONS(2519),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(129),
    [sym__newline] = ACTIONS(2521),
    [sym__raw_string_literal] = ACTIONS(2523),
    [sym__external_open_parenthesis] = ACTIONS(2525),
    [sym__external_close_parenthesis] = ACTIONS(2633),
    [sym__external_open_brace] = ACTIONS(2529),
    [sym__external_open_bracket] = ACTIONS(129),
    [sym__external_open_bracket2] = ACTIONS(129),
    [sym__external_close_bracket2] = ACTIONS(129),
  },
  [219] = {
    [sym_function_definition] = STATE(1276),
    [sym_if_statement] = STATE(1276),
    [sym_for_statement] = STATE(1276),
    [sym_while_statement] = STATE(1276),
    [sym_repeat_statement] = STATE(1276),
    [sym_braced_expression] = STATE(1276),
    [sym_parenthesized_expression] = STATE(1276),
    [sym_call] = STATE(1276),
    [sym_subset] = STATE(1276),
    [sym_subset2] = STATE(1276),
    [sym_unary_operator] = STATE(1276),
    [sym_binary_operator] = STATE(1276),
    [sym_extract_operator] = STATE(1276),
    [sym_namespace_operator] = STATE(1276),
    [sym_integer] = STATE(1276),
    [sym_complex] = STATE(1276),
    [sym_float] = STATE(1276),
    [sym__hex_literal] = STATE(2272),
    [sym__float_literal] = STATE(2272),
    [sym_string] = STATE(2271),
    [sym__single_quoted_string] = STATE(2273),
    [sym__double_quoted_string] = STATE(2274),
    [sym_na] = STATE(1276),
    [sym__expression] = STATE(1276),
    [sym__string_or_identifier] = STATE(5157),
    [sym__open_parenthesis] = STATE(120),
    [sym__open_brace] = STATE(11),
    [aux_sym_function_definition_repeat1] = STATE(2503),
    [sym_identifier] = ACTIONS(1241),
    [anon_sym_BSLASH] = ACTIONS(1243),
    [anon_sym_function] = ACTIONS(1245),
    [anon_sym_EQ] = ACTIONS(759),
    [anon_sym_if] = ACTIONS(1247),
    [anon_sym_for] = ACTIONS(1249),
    [anon_sym_while] = ACTIONS(1251),
    [anon_sym_repeat] = ACTIONS(1253),
    [anon_sym_QMARK] = ACTIONS(1255),
    [anon_sym_TILDE] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1259),
    [anon_sym_PLUS] = ACTIONS(1261),
    [anon_sym_DASH] = ACTIONS(1263),
    [anon_sym_LT_DASH] = ACTIONS(757),
    [anon_sym_LT_LT_DASH] = ACTIONS(757),
    [anon_sym_COLON_EQ] = ACTIONS(757),
    [anon_sym_DASH_GT] = ACTIONS(759),
    [anon_sym_DASH_GT_GT] = ACTIONS(757),
    [anon_sym_PIPE] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(759),
    [anon_sym_PIPE_PIPE] = ACTIONS(757),
    [anon_sym_AMP_AMP] = ACTIONS(757),
    [anon_sym_LT] = ACTIONS(759),
    [anon_sym_LT_EQ] = ACTIONS(757),
    [anon_sym_GT] = ACTIONS(759),
    [anon_sym_GT_EQ] = ACTIONS(757),
    [anon_sym_EQ_EQ] = ACTIONS(757),
    [anon_sym_BANG_EQ] = ACTIONS(757),
    [anon_sym_STAR] = ACTIONS(759),
    [anon_sym_SLASH] = ACTIONS(757),
    [anon_sym_STAR_STAR] = ACTIONS(757),
    [anon_sym_CARET] = ACTIONS(757),
    [aux_sym_binary_operator_token1] = ACTIONS(757),
    [anon_sym_PIPE_GT] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(759),
    [anon_sym_DOLLAR] = ACTIONS(757),
    [anon_sym_AT] = ACTIONS(757),
    [aux_sym__hex_literal_token1] = ACTIONS(1265),
    [sym__number_literal] = ACTIONS(1267),
    [anon_sym_SQUOTE] = ACTIONS(1269),
    [anon_sym_DQUOTE] = ACTIONS(1271),
    [sym_return] = ACTIONS(2635),
    [sym_next] = ACTIONS(2635),
    [sym_break] = ACTIONS(2635),
    [sym_true] = ACTIONS(2635),
    [sym_false] = ACTIONS(2635),
    [sym_null] = ACTIONS(2635),
    [sym_inf] = ACTIONS(2635),
    [sym_nan] = ACTIONS(2635),
    [anon_sym_NA] = ACTIONS(1275),
    [anon_sym_NA_integer_] = ACTIONS(1275),
    [anon_sym_NA_real_] = ACTIONS(1275),
    [anon_sym_NA_complex_] = ACTIONS(1275),
    [anon_sym_NA_character_] = ACTIONS(1275),
    [sym_dots] = ACTIONS(2635),
    [sym_dot_dot_i] = ACTIONS(2637),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(757),
    [sym__newline] = ACTIONS(757),
    [sym__raw_string_literal] = ACTIONS(1281),
    [sym__external_else] = ACTIONS(757),
    [sym__external_open_parenthesis] = ACTIONS(1283),
    [sym__external_close_parenthesis] = ACTIONS(757),
    [sym__external_open_brace] = ACTIONS(1287),
    [sym__external_open_bracket] = ACTIONS(757),
    [sym__external_close_bracket] = ACTIONS(757),
    [sym__external_open_bracket2] = ACTIONS(757),
  },
  [220] = {
    [sym_function_definition] = STATE(1070),
    [sym_if_statement] = STATE(1070),
    [sym_for_statement] = STATE(1070),
    [sym_while_statement] = STATE(1070),
    [sym_repeat_statement] = STATE(1070),
    [sym_braced_expression] = STATE(1070),
    [sym_parenthesized_expression] = STATE(1070),
    [sym_call] = STATE(1070),
    [sym_subset] = STATE(1070),
    [sym_subset2] = STATE(1070),
    [sym_unary_operator] = STATE(1070),
    [sym_binary_operator] = STATE(1070),
    [sym_extract_operator] = STATE(1070),
    [sym_namespace_operator] = STATE(1070),
    [sym_integer] = STATE(1070),
    [sym_complex] = STATE(1070),
    [sym_float] = STATE(1070),
    [sym__hex_literal] = STATE(2235),
    [sym__float_literal] = STATE(2235),
    [sym_string] = STATE(2234),
    [sym__single_quoted_string] = STATE(2236),
    [sym__double_quoted_string] = STATE(2237),
    [sym_na] = STATE(1070),
    [sym__expression] = STATE(1070),
    [sym__string_or_identifier] = STATE(5150),
    [sym__open_parenthesis] = STATE(76),
    [sym__open_brace] = STATE(188),
    [aux_sym_function_definition_repeat1] = STATE(247),
    [sym_identifier] = ACTIONS(1433),
    [anon_sym_BSLASH] = ACTIONS(1435),
    [anon_sym_function] = ACTIONS(1437),
    [anon_sym_EQ] = ACTIONS(463),
    [anon_sym_if] = ACTIONS(1439),
    [anon_sym_for] = ACTIONS(1441),
    [anon_sym_while] = ACTIONS(1443),
    [anon_sym_repeat] = ACTIONS(1445),
    [anon_sym_QMARK] = ACTIONS(1447),
    [anon_sym_TILDE] = ACTIONS(1449),
    [anon_sym_BANG] = ACTIONS(1451),
    [anon_sym_PLUS] = ACTIONS(1453),
    [anon_sym_DASH] = ACTIONS(1455),
    [anon_sym_LT_DASH] = ACTIONS(461),
    [anon_sym_LT_LT_DASH] = ACTIONS(461),
    [anon_sym_COLON_EQ] = ACTIONS(461),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_DASH_GT_GT] = ACTIONS(461),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_PIPE_PIPE] = ACTIONS(461),
    [anon_sym_AMP_AMP] = ACTIONS(461),
    [anon_sym_LT] = ACTIONS(463),
    [anon_sym_LT_EQ] = ACTIONS(461),
    [anon_sym_GT] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(461),
    [anon_sym_EQ_EQ] = ACTIONS(461),
    [anon_sym_BANG_EQ] = ACTIONS(461),
    [anon_sym_STAR] = ACTIONS(463),
    [anon_sym_SLASH] = ACTIONS(461),
    [anon_sym_STAR_STAR] = ACTIONS(461),
    [anon_sym_CARET] = ACTIONS(461),
    [aux_sym_binary_operator_token1] = ACTIONS(461),
    [anon_sym_PIPE_GT] = ACTIONS(461),
    [anon_sym_COLON] = ACTIONS(463),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_AT] = ACTIONS(461),
    [aux_sym__hex_literal_token1] = ACTIONS(1457),
    [sym__number_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [anon_sym_DQUOTE] = ACTIONS(1463),
    [sym_return] = ACTIONS(2639),
    [sym_next] = ACTIONS(2639),
    [sym_break] = ACTIONS(2639),
    [sym_true] = ACTIONS(2639),
    [sym_false] = ACTIONS(2639),
    [sym_null] = ACTIONS(2639),
    [sym_inf] = ACTIONS(2639),
    [sym_nan] = ACTIONS(2639),
    [anon_sym_NA] = ACTIONS(1467),
    [anon_sym_NA_integer_] = ACTIONS(1467),
    [anon_sym_NA_real_] = ACTIONS(1467),
    [anon_sym_NA_complex_] = ACTIONS(1467),
    [anon_sym_NA_character_] = ACTIONS(1467),
    [sym_dots] = ACTIONS(2639),
    [sym_dot_dot_i] = ACTIONS(2641),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(461),
    [sym__newline] = ACTIONS(2643),
    [sym__semicolon] = ACTIONS(461),
    [sym__raw_string_literal] = ACTIONS(1473),
    [sym__external_open_parenthesis] = ACTIONS(1475),
    [sym__external_open_brace] = ACTIONS(1477),
    [sym__external_close_brace] = ACTIONS(461),
    [sym__external_open_bracket] = ACTIONS(461),
    [sym__external_open_bracket2] = ACTIONS(461),
    [sym__external_close_bracket2] = ACTIONS(461),
  },
  [221] = {
    [sym_function_definition] = STATE(1140),
    [sym_if_statement] = STATE(1140),
    [sym_for_statement] = STATE(1140),
    [sym_while_statement] = STATE(1140),
    [sym_repeat_statement] = STATE(1140),
    [sym_braced_expression] = STATE(1140),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_call] = STATE(1140),
    [sym_subset] = STATE(1140),
    [sym_subset2] = STATE(1140),
    [sym_unary_operator] = STATE(1140),
    [sym_binary_operator] = STATE(1140),
    [sym_extract_operator] = STATE(1140),
    [sym_namespace_operator] = STATE(1140),
    [sym_integer] = STATE(1140),
    [sym_complex] = STATE(1140),
    [sym_float] = STATE(1140),
    [sym__hex_literal] = STATE(2288),
    [sym__float_literal] = STATE(2288),
    [sym_string] = STATE(2287),
    [sym__single_quoted_string] = STATE(2289),
    [sym__double_quoted_string] = STATE(2290),
    [sym_na] = STATE(1140),
    [sym__expression] = STATE(1140),
    [sym__string_or_identifier] = STATE(5144),
    [sym__open_parenthesis] = STATE(119),
    [sym__open_brace] = STATE(16),
    [aux_sym_function_definition_repeat1] = STATE(2460),
    [sym_identifier] = ACTIONS(1568),
    [anon_sym_BSLASH] = ACTIONS(1570),
    [anon_sym_function] = ACTIONS(1572),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_if] = ACTIONS(1574),
    [anon_sym_for] = ACTIONS(1576),
    [anon_sym_while] = ACTIONS(1578),
    [anon_sym_repeat] = ACTIONS(1580),
    [anon_sym_QMARK] = ACTIONS(1582),
    [anon_sym_TILDE] = ACTIONS(1584),
    [anon_sym_BANG] = ACTIONS(1586),
    [anon_sym_PLUS] = ACTIONS(1588),
    [anon_sym_DASH] = ACTIONS(1590),
    [anon_sym_LT_DASH] = ACTIONS(471),
    [anon_sym_LT_LT_DASH] = ACTIONS(471),
    [anon_sym_COLON_EQ] = ACTIONS(471),
    [anon_sym_DASH_GT] = ACTIONS(473),
    [anon_sym_DASH_GT_GT] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(473),
    [anon_sym_AMP] = ACTIONS(473),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_LT_EQ] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(473),
    [anon_sym_GT_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_STAR] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [aux_sym_binary_operator_token1] = ACTIONS(471),
    [anon_sym_PIPE_GT] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(473),
    [anon_sym_DOLLAR] = ACTIONS(471),
    [anon_sym_AT] = ACTIONS(471),
    [aux_sym__hex_literal_token1] = ACTIONS(1592),
    [sym__number_literal] = ACTIONS(1594),
    [anon_sym_SQUOTE] = ACTIONS(1596),
    [anon_sym_DQUOTE] = ACTIONS(1598),
    [sym_return] = ACTIONS(2645),
    [sym_next] = ACTIONS(2645),
    [sym_break] = ACTIONS(2645),
    [sym_true] = ACTIONS(2645),
    [sym_false] = ACTIONS(2645),
    [sym_null] = ACTIONS(2645),
    [sym_inf] = ACTIONS(2645),
    [sym_nan] = ACTIONS(2645),
    [anon_sym_NA] = ACTIONS(1602),
    [anon_sym_NA_integer_] = ACTIONS(1602),
    [anon_sym_NA_real_] = ACTIONS(1602),
    [anon_sym_NA_complex_] = ACTIONS(1602),
    [anon_sym_NA_character_] = ACTIONS(1602),
    [sym_dots] = ACTIONS(2645),
    [sym_dot_dot_i] = ACTIONS(2647),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(471),
    [sym__newline] = ACTIONS(471),
    [sym__raw_string_literal] = ACTIONS(1608),
    [sym__external_else] = ACTIONS(471),
    [sym__external_open_parenthesis] = ACTIONS(1610),
    [sym__external_close_parenthesis] = ACTIONS(471),
    [sym__external_open_brace] = ACTIONS(1614),
    [sym__external_open_bracket] = ACTIONS(471),
    [sym__external_open_bracket2] = ACTIONS(471),
    [sym__external_close_bracket2] = ACTIONS(471),
  },
  [222] = {
    [sym_function_definition] = STATE(1079),
    [sym_if_statement] = STATE(1079),
    [sym_for_statement] = STATE(1079),
    [sym_while_statement] = STATE(1079),
    [sym_repeat_statement] = STATE(1079),
    [sym_braced_expression] = STATE(1079),
    [sym_parenthesized_expression] = STATE(1079),
    [sym_call] = STATE(1079),
    [sym_subset] = STATE(1079),
    [sym_subset2] = STATE(1079),
    [sym_unary_operator] = STATE(1079),
    [sym_binary_operator] = STATE(1079),
    [sym_extract_operator] = STATE(1079),
    [sym_namespace_operator] = STATE(1079),
    [sym_integer] = STATE(1079),
    [sym_complex] = STATE(1079),
    [sym_float] = STATE(1079),
    [sym__hex_literal] = STATE(2235),
    [sym__float_literal] = STATE(2235),
    [sym_string] = STATE(2234),
    [sym__single_quoted_string] = STATE(2236),
    [sym__double_quoted_string] = STATE(2237),
    [sym_na] = STATE(1079),
    [sym__expression] = STATE(1079),
    [sym__string_or_identifier] = STATE(5150),
    [sym__open_parenthesis] = STATE(76),
    [sym__open_brace] = STATE(188),
    [aux_sym_function_definition_repeat1] = STATE(211),
    [sym_identifier] = ACTIONS(1433),
    [anon_sym_BSLASH] = ACTIONS(1435),
    [anon_sym_function] = ACTIONS(1437),
    [anon_sym_EQ] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(1439),
    [anon_sym_for] = ACTIONS(1441),
    [anon_sym_while] = ACTIONS(1443),
    [anon_sym_repeat] = ACTIONS(1445),
    [anon_sym_QMARK] = ACTIONS(1447),
    [anon_sym_TILDE] = ACTIONS(1449),
    [anon_sym_BANG] = ACTIONS(1451),
    [anon_sym_PLUS] = ACTIONS(1453),
    [anon_sym_DASH] = ACTIONS(1455),
    [anon_sym_LT_DASH] = ACTIONS(387),
    [anon_sym_LT_LT_DASH] = ACTIONS(387),
    [anon_sym_COLON_EQ] = ACTIONS(387),
    [anon_sym_DASH_GT] = ACTIONS(389),
    [anon_sym_DASH_GT_GT] = ACTIONS(387),
    [anon_sym_PIPE] = ACTIONS(389),
    [anon_sym_AMP] = ACTIONS(389),
    [anon_sym_PIPE_PIPE] = ACTIONS(387),
    [anon_sym_AMP_AMP] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(389),
    [anon_sym_LT_EQ] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(389),
    [anon_sym_GT_EQ] = ACTIONS(387),
    [anon_sym_EQ_EQ] = ACTIONS(387),
    [anon_sym_BANG_EQ] = ACTIONS(387),
    [anon_sym_STAR] = ACTIONS(389),
    [anon_sym_SLASH] = ACTIONS(387),
    [anon_sym_STAR_STAR] = ACTIONS(387),
    [anon_sym_CARET] = ACTIONS(387),
    [aux_sym_binary_operator_token1] = ACTIONS(387),
    [anon_sym_PIPE_GT] = ACTIONS(387),
    [anon_sym_COLON] = ACTIONS(389),
    [anon_sym_DOLLAR] = ACTIONS(387),
    [anon_sym_AT] = ACTIONS(387),
    [aux_sym__hex_literal_token1] = ACTIONS(1457),
    [sym__number_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [anon_sym_DQUOTE] = ACTIONS(1463),
    [sym_return] = ACTIONS(2649),
    [sym_next] = ACTIONS(2649),
    [sym_break] = ACTIONS(2649),
    [sym_true] = ACTIONS(2649),
    [sym_false] = ACTIONS(2649),
    [sym_null] = ACTIONS(2649),
    [sym_inf] = ACTIONS(2649),
    [sym_nan] = ACTIONS(2649),
    [anon_sym_NA] = ACTIONS(1467),
    [anon_sym_NA_integer_] = ACTIONS(1467),
    [anon_sym_NA_real_] = ACTIONS(1467),
    [anon_sym_NA_complex_] = ACTIONS(1467),
    [anon_sym_NA_character_] = ACTIONS(1467),
    [sym_dots] = ACTIONS(2649),
    [sym_dot_dot_i] = ACTIONS(2651),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(387),
    [sym__newline] = ACTIONS(2653),
    [sym__semicolon] = ACTIONS(387),
    [sym__raw_string_literal] = ACTIONS(1473),
    [sym__external_open_parenthesis] = ACTIONS(1475),
    [sym__external_open_brace] = ACTIONS(1477),
    [sym__external_close_brace] = ACTIONS(387),
    [sym__external_open_bracket] = ACTIONS(387),
    [sym__external_open_bracket2] = ACTIONS(387),
    [sym__external_close_bracket2] = ACTIONS(387),
  },
  [223] = {
    [sym_function_definition] = STATE(1142),
    [sym_if_statement] = STATE(1142),
    [sym_for_statement] = STATE(1142),
    [sym_while_statement] = STATE(1142),
    [sym_repeat_statement] = STATE(1142),
    [sym_braced_expression] = STATE(1142),
    [sym_parenthesized_expression] = STATE(1142),
    [sym_call] = STATE(1142),
    [sym_subset] = STATE(1142),
    [sym_subset2] = STATE(1142),
    [sym_unary_operator] = STATE(1142),
    [sym_binary_operator] = STATE(1142),
    [sym_extract_operator] = STATE(1142),
    [sym_namespace_operator] = STATE(1142),
    [sym_integer] = STATE(1142),
    [sym_complex] = STATE(1142),
    [sym_float] = STATE(1142),
    [sym__hex_literal] = STATE(2288),
    [sym__float_literal] = STATE(2288),
    [sym_string] = STATE(2287),
    [sym__single_quoted_string] = STATE(2289),
    [sym__double_quoted_string] = STATE(2290),
    [sym_na] = STATE(1142),
    [sym__expression] = STATE(1142),
    [sym__string_or_identifier] = STATE(5144),
    [sym__open_parenthesis] = STATE(119),
    [sym__open_brace] = STATE(16),
    [aux_sym_function_definition_repeat1] = STATE(221),
    [sym_identifier] = ACTIONS(1568),
    [anon_sym_BSLASH] = ACTIONS(1570),
    [anon_sym_function] = ACTIONS(1572),
    [anon_sym_EQ] = ACTIONS(463),
    [anon_sym_if] = ACTIONS(1574),
    [anon_sym_for] = ACTIONS(1576),
    [anon_sym_while] = ACTIONS(1578),
    [anon_sym_repeat] = ACTIONS(1580),
    [anon_sym_QMARK] = ACTIONS(1582),
    [anon_sym_TILDE] = ACTIONS(1584),
    [anon_sym_BANG] = ACTIONS(1586),
    [anon_sym_PLUS] = ACTIONS(1588),
    [anon_sym_DASH] = ACTIONS(1590),
    [anon_sym_LT_DASH] = ACTIONS(461),
    [anon_sym_LT_LT_DASH] = ACTIONS(461),
    [anon_sym_COLON_EQ] = ACTIONS(461),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_DASH_GT_GT] = ACTIONS(461),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_PIPE_PIPE] = ACTIONS(461),
    [anon_sym_AMP_AMP] = ACTIONS(461),
    [anon_sym_LT] = ACTIONS(463),
    [anon_sym_LT_EQ] = ACTIONS(461),
    [anon_sym_GT] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(461),
    [anon_sym_EQ_EQ] = ACTIONS(461),
    [anon_sym_BANG_EQ] = ACTIONS(461),
    [anon_sym_STAR] = ACTIONS(463),
    [anon_sym_SLASH] = ACTIONS(461),
    [anon_sym_STAR_STAR] = ACTIONS(461),
    [anon_sym_CARET] = ACTIONS(461),
    [aux_sym_binary_operator_token1] = ACTIONS(461),
    [anon_sym_PIPE_GT] = ACTIONS(461),
    [anon_sym_COLON] = ACTIONS(463),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_AT] = ACTIONS(461),
    [aux_sym__hex_literal_token1] = ACTIONS(1592),
    [sym__number_literal] = ACTIONS(1594),
    [anon_sym_SQUOTE] = ACTIONS(1596),
    [anon_sym_DQUOTE] = ACTIONS(1598),
    [sym_return] = ACTIONS(2655),
    [sym_next] = ACTIONS(2655),
    [sym_break] = ACTIONS(2655),
    [sym_true] = ACTIONS(2655),
    [sym_false] = ACTIONS(2655),
    [sym_null] = ACTIONS(2655),
    [sym_inf] = ACTIONS(2655),
    [sym_nan] = ACTIONS(2655),
    [anon_sym_NA] = ACTIONS(1602),
    [anon_sym_NA_integer_] = ACTIONS(1602),
    [anon_sym_NA_real_] = ACTIONS(1602),
    [anon_sym_NA_complex_] = ACTIONS(1602),
    [anon_sym_NA_character_] = ACTIONS(1602),
    [sym_dots] = ACTIONS(2655),
    [sym_dot_dot_i] = ACTIONS(2657),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(461),
    [sym__newline] = ACTIONS(2659),
    [sym__raw_string_literal] = ACTIONS(1608),
    [sym__external_else] = ACTIONS(461),
    [sym__external_open_parenthesis] = ACTIONS(1610),
    [sym__external_close_parenthesis] = ACTIONS(461),
    [sym__external_open_brace] = ACTIONS(1614),
    [sym__external_open_bracket] = ACTIONS(461),
    [sym__external_open_bracket2] = ACTIONS(461),
    [sym__external_close_bracket2] = ACTIONS(461),
  },
  [224] = {
    [sym_function_definition] = STATE(1143),
    [sym_if_statement] = STATE(1143),
    [sym_for_statement] = STATE(1143),
    [sym_while_statement] = STATE(1143),
    [sym_repeat_statement] = STATE(1143),
    [sym_braced_expression] = STATE(1143),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_call] = STATE(1143),
    [sym_subset] = STATE(1143),
    [sym_subset2] = STATE(1143),
    [sym_unary_operator] = STATE(1143),
    [sym_binary_operator] = STATE(1143),
    [sym_extract_operator] = STATE(1143),
    [sym_namespace_operator] = STATE(1143),
    [sym_integer] = STATE(1143),
    [sym_complex] = STATE(1143),
    [sym_float] = STATE(1143),
    [sym__hex_literal] = STATE(2288),
    [sym__float_literal] = STATE(2288),
    [sym_string] = STATE(2287),
    [sym__single_quoted_string] = STATE(2289),
    [sym__double_quoted_string] = STATE(2290),
    [sym_na] = STATE(1143),
    [sym__expression] = STATE(1143),
    [sym__string_or_identifier] = STATE(5144),
    [sym__open_parenthesis] = STATE(119),
    [sym__open_brace] = STATE(16),
    [aux_sym_function_definition_repeat1] = STATE(2460),
    [sym_identifier] = ACTIONS(1568),
    [anon_sym_BSLASH] = ACTIONS(1570),
    [anon_sym_function] = ACTIONS(1572),
    [anon_sym_EQ] = ACTIONS(455),
    [anon_sym_if] = ACTIONS(1574),
    [anon_sym_for] = ACTIONS(1576),
    [anon_sym_while] = ACTIONS(1578),
    [anon_sym_repeat] = ACTIONS(1580),
    [anon_sym_QMARK] = ACTIONS(1582),
    [anon_sym_TILDE] = ACTIONS(1584),
    [anon_sym_BANG] = ACTIONS(1586),
    [anon_sym_PLUS] = ACTIONS(1588),
    [anon_sym_DASH] = ACTIONS(1590),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [anon_sym_LT_LT_DASH] = ACTIONS(453),
    [anon_sym_COLON_EQ] = ACTIONS(453),
    [anon_sym_DASH_GT] = ACTIONS(455),
    [anon_sym_DASH_GT_GT] = ACTIONS(453),
    [anon_sym_PIPE] = ACTIONS(455),
    [anon_sym_AMP] = ACTIONS(455),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(455),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_GT] = ACTIONS(455),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(453),
    [anon_sym_STAR] = ACTIONS(455),
    [anon_sym_SLASH] = ACTIONS(453),
    [anon_sym_STAR_STAR] = ACTIONS(453),
    [anon_sym_CARET] = ACTIONS(453),
    [aux_sym_binary_operator_token1] = ACTIONS(453),
    [anon_sym_PIPE_GT] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(455),
    [anon_sym_DOLLAR] = ACTIONS(453),
    [anon_sym_AT] = ACTIONS(453),
    [aux_sym__hex_literal_token1] = ACTIONS(1592),
    [sym__number_literal] = ACTIONS(1594),
    [anon_sym_SQUOTE] = ACTIONS(1596),
    [anon_sym_DQUOTE] = ACTIONS(1598),
    [sym_return] = ACTIONS(2661),
    [sym_next] = ACTIONS(2661),
    [sym_break] = ACTIONS(2661),
    [sym_true] = ACTIONS(2661),
    [sym_false] = ACTIONS(2661),
    [sym_null] = ACTIONS(2661),
    [sym_inf] = ACTIONS(2661),
    [sym_nan] = ACTIONS(2661),
    [anon_sym_NA] = ACTIONS(1602),
    [anon_sym_NA_integer_] = ACTIONS(1602),
    [anon_sym_NA_real_] = ACTIONS(1602),
    [anon_sym_NA_complex_] = ACTIONS(1602),
    [anon_sym_NA_character_] = ACTIONS(1602),
    [sym_dots] = ACTIONS(2661),
    [sym_dot_dot_i] = ACTIONS(2663),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(453),
    [sym__newline] = ACTIONS(453),
    [sym__raw_string_literal] = ACTIONS(1608),
    [sym__external_else] = ACTIONS(453),
    [sym__external_open_parenthesis] = ACTIONS(1610),
    [sym__external_close_parenthesis] = ACTIONS(453),
    [sym__external_open_brace] = ACTIONS(1614),
    [sym__external_open_bracket] = ACTIONS(453),
    [sym__external_open_bracket2] = ACTIONS(453),
    [sym__external_close_bracket2] = ACTIONS(453),
  },
  [225] = {
    [sym_function_definition] = STATE(1148),
    [sym_if_statement] = STATE(1148),
    [sym_for_statement] = STATE(1148),
    [sym_while_statement] = STATE(1148),
    [sym_repeat_statement] = STATE(1148),
    [sym_braced_expression] = STATE(1148),
    [sym_parenthesized_expression] = STATE(1148),
    [sym_call] = STATE(1148),
    [sym_subset] = STATE(1148),
    [sym_subset2] = STATE(1148),
    [sym_unary_operator] = STATE(1148),
    [sym_binary_operator] = STATE(1148),
    [sym_extract_operator] = STATE(1148),
    [sym_namespace_operator] = STATE(1148),
    [sym_integer] = STATE(1148),
    [sym_complex] = STATE(1148),
    [sym_float] = STATE(1148),
    [sym__hex_literal] = STATE(2288),
    [sym__float_literal] = STATE(2288),
    [sym_string] = STATE(2287),
    [sym__single_quoted_string] = STATE(2289),
    [sym__double_quoted_string] = STATE(2290),
    [sym_na] = STATE(1148),
    [sym__expression] = STATE(1148),
    [sym__string_or_identifier] = STATE(5144),
    [sym__open_parenthesis] = STATE(119),
    [sym__open_brace] = STATE(16),
    [aux_sym_function_definition_repeat1] = STATE(2460),
    [sym_identifier] = ACTIONS(1568),
    [anon_sym_BSLASH] = ACTIONS(1570),
    [anon_sym_function] = ACTIONS(1572),
    [anon_sym_EQ] = ACTIONS(399),
    [anon_sym_if] = ACTIONS(1574),
    [anon_sym_for] = ACTIONS(1576),
    [anon_sym_while] = ACTIONS(1578),
    [anon_sym_repeat] = ACTIONS(1580),
    [anon_sym_QMARK] = ACTIONS(1582),
    [anon_sym_TILDE] = ACTIONS(1584),
    [anon_sym_BANG] = ACTIONS(1586),
    [anon_sym_PLUS] = ACTIONS(1588),
    [anon_sym_DASH] = ACTIONS(1590),
    [anon_sym_LT_DASH] = ACTIONS(397),
    [anon_sym_LT_LT_DASH] = ACTIONS(397),
    [anon_sym_COLON_EQ] = ACTIONS(397),
    [anon_sym_DASH_GT] = ACTIONS(399),
    [anon_sym_DASH_GT_GT] = ACTIONS(397),
    [anon_sym_PIPE] = ACTIONS(399),
    [anon_sym_AMP] = ACTIONS(399),
    [anon_sym_PIPE_PIPE] = ACTIONS(397),
    [anon_sym_AMP_AMP] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(399),
    [anon_sym_LT_EQ] = ACTIONS(397),
    [anon_sym_GT] = ACTIONS(399),
    [anon_sym_GT_EQ] = ACTIONS(397),
    [anon_sym_EQ_EQ] = ACTIONS(397),
    [anon_sym_BANG_EQ] = ACTIONS(397),
    [anon_sym_STAR] = ACTIONS(399),
    [anon_sym_SLASH] = ACTIONS(397),
    [anon_sym_STAR_STAR] = ACTIONS(397),
    [anon_sym_CARET] = ACTIONS(397),
    [aux_sym_binary_operator_token1] = ACTIONS(397),
    [anon_sym_PIPE_GT] = ACTIONS(397),
    [anon_sym_COLON] = ACTIONS(399),
    [anon_sym_DOLLAR] = ACTIONS(397),
    [anon_sym_AT] = ACTIONS(397),
    [aux_sym__hex_literal_token1] = ACTIONS(1592),
    [sym__number_literal] = ACTIONS(1594),
    [anon_sym_SQUOTE] = ACTIONS(1596),
    [anon_sym_DQUOTE] = ACTIONS(1598),
    [sym_return] = ACTIONS(2665),
    [sym_next] = ACTIONS(2665),
    [sym_break] = ACTIONS(2665),
    [sym_true] = ACTIONS(2665),
    [sym_false] = ACTIONS(2665),
    [sym_null] = ACTIONS(2665),
    [sym_inf] = ACTIONS(2665),
    [sym_nan] = ACTIONS(2665),
    [anon_sym_NA] = ACTIONS(1602),
    [anon_sym_NA_integer_] = ACTIONS(1602),
    [anon_sym_NA_real_] = ACTIONS(1602),
    [anon_sym_NA_complex_] = ACTIONS(1602),
    [anon_sym_NA_character_] = ACTIONS(1602),
    [sym_dots] = ACTIONS(2665),
    [sym_dot_dot_i] = ACTIONS(2667),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(397),
    [sym__newline] = ACTIONS(397),
    [sym__raw_string_literal] = ACTIONS(1608),
    [sym__external_else] = ACTIONS(397),
    [sym__external_open_parenthesis] = ACTIONS(1610),
    [sym__external_close_parenthesis] = ACTIONS(397),
    [sym__external_open_brace] = ACTIONS(1614),
    [sym__external_open_bracket] = ACTIONS(397),
    [sym__external_open_bracket2] = ACTIONS(397),
    [sym__external_close_bracket2] = ACTIONS(397),
  },
  [226] = {
    [sym_function_definition] = STATE(1149),
    [sym_if_statement] = STATE(1149),
    [sym_for_statement] = STATE(1149),
    [sym_while_statement] = STATE(1149),
    [sym_repeat_statement] = STATE(1149),
    [sym_braced_expression] = STATE(1149),
    [sym_parenthesized_expression] = STATE(1149),
    [sym_call] = STATE(1149),
    [sym_subset] = STATE(1149),
    [sym_subset2] = STATE(1149),
    [sym_unary_operator] = STATE(1149),
    [sym_binary_operator] = STATE(1149),
    [sym_extract_operator] = STATE(1149),
    [sym_namespace_operator] = STATE(1149),
    [sym_integer] = STATE(1149),
    [sym_complex] = STATE(1149),
    [sym_float] = STATE(1149),
    [sym__hex_literal] = STATE(2288),
    [sym__float_literal] = STATE(2288),
    [sym_string] = STATE(2287),
    [sym__single_quoted_string] = STATE(2289),
    [sym__double_quoted_string] = STATE(2290),
    [sym_na] = STATE(1149),
    [sym__expression] = STATE(1149),
    [sym__string_or_identifier] = STATE(5144),
    [sym__open_parenthesis] = STATE(119),
    [sym__open_brace] = STATE(16),
    [aux_sym_function_definition_repeat1] = STATE(224),
    [sym_identifier] = ACTIONS(1568),
    [anon_sym_BSLASH] = ACTIONS(1570),
    [anon_sym_function] = ACTIONS(1572),
    [anon_sym_EQ] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(1574),
    [anon_sym_for] = ACTIONS(1576),
    [anon_sym_while] = ACTIONS(1578),
    [anon_sym_repeat] = ACTIONS(1580),
    [anon_sym_QMARK] = ACTIONS(1582),
    [anon_sym_TILDE] = ACTIONS(1584),
    [anon_sym_BANG] = ACTIONS(1586),
    [anon_sym_PLUS] = ACTIONS(1588),
    [anon_sym_DASH] = ACTIONS(1590),
    [anon_sym_LT_DASH] = ACTIONS(387),
    [anon_sym_LT_LT_DASH] = ACTIONS(387),
    [anon_sym_COLON_EQ] = ACTIONS(387),
    [anon_sym_DASH_GT] = ACTIONS(389),
    [anon_sym_DASH_GT_GT] = ACTIONS(387),
    [anon_sym_PIPE] = ACTIONS(389),
    [anon_sym_AMP] = ACTIONS(389),
    [anon_sym_PIPE_PIPE] = ACTIONS(387),
    [anon_sym_AMP_AMP] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(389),
    [anon_sym_LT_EQ] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(389),
    [anon_sym_GT_EQ] = ACTIONS(387),
    [anon_sym_EQ_EQ] = ACTIONS(387),
    [anon_sym_BANG_EQ] = ACTIONS(387),
    [anon_sym_STAR] = ACTIONS(389),
    [anon_sym_SLASH] = ACTIONS(387),
    [anon_sym_STAR_STAR] = ACTIONS(387),
    [anon_sym_CARET] = ACTIONS(387),
    [aux_sym_binary_operator_token1] = ACTIONS(387),
    [anon_sym_PIPE_GT] = ACTIONS(387),
    [anon_sym_COLON] = ACTIONS(389),
    [anon_sym_DOLLAR] = ACTIONS(387),
    [anon_sym_AT] = ACTIONS(387),
    [aux_sym__hex_literal_token1] = ACTIONS(1592),
    [sym__number_literal] = ACTIONS(1594),
    [anon_sym_SQUOTE] = ACTIONS(1596),
    [anon_sym_DQUOTE] = ACTIONS(1598),
    [sym_return] = ACTIONS(2669),
    [sym_next] = ACTIONS(2669),
    [sym_break] = ACTIONS(2669),
    [sym_true] = ACTIONS(2669),
    [sym_false] = ACTIONS(2669),
    [sym_null] = ACTIONS(2669),
    [sym_inf] = ACTIONS(2669),
    [sym_nan] = ACTIONS(2669),
    [anon_sym_NA] = ACTIONS(1602),
    [anon_sym_NA_integer_] = ACTIONS(1602),
    [anon_sym_NA_real_] = ACTIONS(1602),
    [anon_sym_NA_complex_] = ACTIONS(1602),
    [anon_sym_NA_character_] = ACTIONS(1602),
    [sym_dots] = ACTIONS(2669),
    [sym_dot_dot_i] = ACTIONS(2671),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(387),
    [sym__newline] = ACTIONS(2673),
    [sym__raw_string_literal] = ACTIONS(1608),
    [sym__external_else] = ACTIONS(387),
    [sym__external_open_parenthesis] = ACTIONS(1610),
    [sym__external_close_parenthesis] = ACTIONS(387),
    [sym__external_open_brace] = ACTIONS(1614),
    [sym__external_open_bracket] = ACTIONS(387),
    [sym__external_open_bracket2] = ACTIONS(387),
    [sym__external_close_bracket2] = ACTIONS(387),
  },
  [227] = {
    [sym_function_definition] = STATE(1157),
    [sym_if_statement] = STATE(1157),
    [sym_for_statement] = STATE(1157),
    [sym_while_statement] = STATE(1157),
    [sym_repeat_statement] = STATE(1157),
    [sym_braced_expression] = STATE(1157),
    [sym_parenthesized_expression] = STATE(1157),
    [sym_call] = STATE(1157),
    [sym_subset] = STATE(1157),
    [sym_subset2] = STATE(1157),
    [sym_unary_operator] = STATE(1157),
    [sym_binary_operator] = STATE(1157),
    [sym_extract_operator] = STATE(1157),
    [sym_namespace_operator] = STATE(1157),
    [sym_integer] = STATE(1157),
    [sym_complex] = STATE(1157),
    [sym_float] = STATE(1157),
    [sym__hex_literal] = STATE(2288),
    [sym__float_literal] = STATE(2288),
    [sym_string] = STATE(2287),
    [sym__single_quoted_string] = STATE(2289),
    [sym__double_quoted_string] = STATE(2290),
    [sym_na] = STATE(1157),
    [sym__expression] = STATE(1157),
    [sym__string_or_identifier] = STATE(5144),
    [sym__open_parenthesis] = STATE(119),
    [sym__open_brace] = STATE(16),
    [aux_sym_function_definition_repeat1] = STATE(225),
    [sym_identifier] = ACTIONS(1568),
    [anon_sym_BSLASH] = ACTIONS(1570),
    [anon_sym_function] = ACTIONS(1572),
    [anon_sym_EQ] = ACTIONS(379),
    [anon_sym_if] = ACTIONS(1574),
    [anon_sym_for] = ACTIONS(1576),
    [anon_sym_while] = ACTIONS(1578),
    [anon_sym_repeat] = ACTIONS(1580),
    [anon_sym_QMARK] = ACTIONS(1582),
    [anon_sym_TILDE] = ACTIONS(1584),
    [anon_sym_BANG] = ACTIONS(1586),
    [anon_sym_PLUS] = ACTIONS(1588),
    [anon_sym_DASH] = ACTIONS(1590),
    [anon_sym_LT_DASH] = ACTIONS(377),
    [anon_sym_LT_LT_DASH] = ACTIONS(377),
    [anon_sym_COLON_EQ] = ACTIONS(377),
    [anon_sym_DASH_GT] = ACTIONS(379),
    [anon_sym_DASH_GT_GT] = ACTIONS(377),
    [anon_sym_PIPE] = ACTIONS(379),
    [anon_sym_AMP] = ACTIONS(379),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_LT] = ACTIONS(379),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(379),
    [anon_sym_GT_EQ] = ACTIONS(377),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(379),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_STAR_STAR] = ACTIONS(377),
    [anon_sym_CARET] = ACTIONS(377),
    [aux_sym_binary_operator_token1] = ACTIONS(377),
    [anon_sym_PIPE_GT] = ACTIONS(377),
    [anon_sym_COLON] = ACTIONS(379),
    [anon_sym_DOLLAR] = ACTIONS(377),
    [anon_sym_AT] = ACTIONS(377),
    [aux_sym__hex_literal_token1] = ACTIONS(1592),
    [sym__number_literal] = ACTIONS(1594),
    [anon_sym_SQUOTE] = ACTIONS(1596),
    [anon_sym_DQUOTE] = ACTIONS(1598),
    [sym_return] = ACTIONS(2675),
    [sym_next] = ACTIONS(2675),
    [sym_break] = ACTIONS(2675),
    [sym_true] = ACTIONS(2675),
    [sym_false] = ACTIONS(2675),
    [sym_null] = ACTIONS(2675),
    [sym_inf] = ACTIONS(2675),
    [sym_nan] = ACTIONS(2675),
    [anon_sym_NA] = ACTIONS(1602),
    [anon_sym_NA_integer_] = ACTIONS(1602),
    [anon_sym_NA_real_] = ACTIONS(1602),
    [anon_sym_NA_complex_] = ACTIONS(1602),
    [anon_sym_NA_character_] = ACTIONS(1602),
    [sym_dots] = ACTIONS(2675),
    [sym_dot_dot_i] = ACTIONS(2677),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(377),
    [sym__newline] = ACTIONS(2679),
    [sym__raw_string_literal] = ACTIONS(1608),
    [sym__external_else] = ACTIONS(377),
    [sym__external_open_parenthesis] = ACTIONS(1610),
    [sym__external_close_parenthesis] = ACTIONS(377),
    [sym__external_open_brace] = ACTIONS(1614),
    [sym__external_open_bracket] = ACTIONS(377),
    [sym__external_open_bracket2] = ACTIONS(377),
    [sym__external_close_bracket2] = ACTIONS(377),
  },
  [228] = {
    [sym_function_definition] = STATE(1158),
    [sym_if_statement] = STATE(1158),
    [sym_for_statement] = STATE(1158),
    [sym_while_statement] = STATE(1158),
    [sym_repeat_statement] = STATE(1158),
    [sym_braced_expression] = STATE(1158),
    [sym_parenthesized_expression] = STATE(1158),
    [sym_call] = STATE(1158),
    [sym_subset] = STATE(1158),
    [sym_subset2] = STATE(1158),
    [sym_unary_operator] = STATE(1158),
    [sym_binary_operator] = STATE(1158),
    [sym_extract_operator] = STATE(1158),
    [sym_namespace_operator] = STATE(1158),
    [sym_integer] = STATE(1158),
    [sym_complex] = STATE(1158),
    [sym_float] = STATE(1158),
    [sym__hex_literal] = STATE(2288),
    [sym__float_literal] = STATE(2288),
    [sym_string] = STATE(2287),
    [sym__single_quoted_string] = STATE(2289),
    [sym__double_quoted_string] = STATE(2290),
    [sym_na] = STATE(1158),
    [sym__expression] = STATE(1158),
    [sym__string_or_identifier] = STATE(5144),
    [sym__open_parenthesis] = STATE(119),
    [sym__open_brace] = STATE(16),
    [aux_sym_function_definition_repeat1] = STATE(2460),
    [sym_identifier] = ACTIONS(1568),
    [anon_sym_BSLASH] = ACTIONS(1570),
    [anon_sym_function] = ACTIONS(1572),
    [anon_sym_EQ] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(1574),
    [anon_sym_for] = ACTIONS(1576),
    [anon_sym_while] = ACTIONS(1578),
    [anon_sym_repeat] = ACTIONS(1580),
    [anon_sym_QMARK] = ACTIONS(1582),
    [anon_sym_TILDE] = ACTIONS(1584),
    [anon_sym_BANG] = ACTIONS(1586),
    [anon_sym_PLUS] = ACTIONS(1588),
    [anon_sym_DASH] = ACTIONS(1590),
    [anon_sym_LT_DASH] = ACTIONS(369),
    [anon_sym_LT_LT_DASH] = ACTIONS(369),
    [anon_sym_COLON_EQ] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(371),
    [anon_sym_DASH_GT_GT] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(371),
    [anon_sym_AMP] = ACTIONS(371),
    [anon_sym_PIPE_PIPE] = ACTIONS(369),
    [anon_sym_AMP_AMP] = ACTIONS(369),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_LT_EQ] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_EQ] = ACTIONS(369),
    [anon_sym_EQ_EQ] = ACTIONS(369),
    [anon_sym_BANG_EQ] = ACTIONS(369),
    [anon_sym_STAR] = ACTIONS(371),
    [anon_sym_SLASH] = ACTIONS(369),
    [anon_sym_STAR_STAR] = ACTIONS(369),
    [anon_sym_CARET] = ACTIONS(369),
    [aux_sym_binary_operator_token1] = ACTIONS(369),
    [anon_sym_PIPE_GT] = ACTIONS(369),
    [anon_sym_COLON] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(369),
    [anon_sym_AT] = ACTIONS(369),
    [aux_sym__hex_literal_token1] = ACTIONS(1592),
    [sym__number_literal] = ACTIONS(1594),
    [anon_sym_SQUOTE] = ACTIONS(1596),
    [anon_sym_DQUOTE] = ACTIONS(1598),
    [sym_return] = ACTIONS(2681),
    [sym_next] = ACTIONS(2681),
    [sym_break] = ACTIONS(2681),
    [sym_true] = ACTIONS(2681),
    [sym_false] = ACTIONS(2681),
    [sym_null] = ACTIONS(2681),
    [sym_inf] = ACTIONS(2681),
    [sym_nan] = ACTIONS(2681),
    [anon_sym_NA] = ACTIONS(1602),
    [anon_sym_NA_integer_] = ACTIONS(1602),
    [anon_sym_NA_real_] = ACTIONS(1602),
    [anon_sym_NA_complex_] = ACTIONS(1602),
    [anon_sym_NA_character_] = ACTIONS(1602),
    [sym_dots] = ACTIONS(2681),
    [sym_dot_dot_i] = ACTIONS(2683),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(369),
    [sym__newline] = ACTIONS(369),
    [sym__raw_string_literal] = ACTIONS(1608),
    [sym__external_else] = ACTIONS(369),
    [sym__external_open_parenthesis] = ACTIONS(1610),
    [sym__external_close_parenthesis] = ACTIONS(369),
    [sym__external_open_brace] = ACTIONS(1614),
    [sym__external_open_bracket] = ACTIONS(369),
    [sym__external_open_bracket2] = ACTIONS(369),
    [sym__external_close_bracket2] = ACTIONS(369),
  },
  [229] = {
    [sym_function_definition] = STATE(1161),
    [sym_if_statement] = STATE(1161),
    [sym_for_statement] = STATE(1161),
    [sym_while_statement] = STATE(1161),
    [sym_repeat_statement] = STATE(1161),
    [sym_braced_expression] = STATE(1161),
    [sym_parenthesized_expression] = STATE(1161),
    [sym_call] = STATE(1161),
    [sym_subset] = STATE(1161),
    [sym_subset2] = STATE(1161),
    [sym_unary_operator] = STATE(1161),
    [sym_binary_operator] = STATE(1161),
    [sym_extract_operator] = STATE(1161),
    [sym_namespace_operator] = STATE(1161),
    [sym_integer] = STATE(1161),
    [sym_complex] = STATE(1161),
    [sym_float] = STATE(1161),
    [sym__hex_literal] = STATE(2288),
    [sym__float_literal] = STATE(2288),
    [sym_string] = STATE(2287),
    [sym__single_quoted_string] = STATE(2289),
    [sym__double_quoted_string] = STATE(2290),
    [sym_na] = STATE(1161),
    [sym__expression] = STATE(1161),
    [sym__string_or_identifier] = STATE(5144),
    [sym__open_parenthesis] = STATE(119),
    [sym__open_brace] = STATE(16),
    [aux_sym_function_definition_repeat1] = STATE(228),
    [sym_identifier] = ACTIONS(1568),
    [anon_sym_BSLASH] = ACTIONS(1570),
    [anon_sym_function] = ACTIONS(1572),
    [anon_sym_EQ] = ACTIONS(533),
    [anon_sym_if] = ACTIONS(1574),
    [anon_sym_for] = ACTIONS(1576),
    [anon_sym_while] = ACTIONS(1578),
    [anon_sym_repeat] = ACTIONS(1580),
    [anon_sym_QMARK] = ACTIONS(1582),
    [anon_sym_TILDE] = ACTIONS(1584),
    [anon_sym_BANG] = ACTIONS(1586),
    [anon_sym_PLUS] = ACTIONS(1588),
    [anon_sym_DASH] = ACTIONS(1590),
    [anon_sym_LT_DASH] = ACTIONS(531),
    [anon_sym_LT_LT_DASH] = ACTIONS(531),
    [anon_sym_COLON_EQ] = ACTIONS(531),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_DASH_GT_GT] = ACTIONS(531),
    [anon_sym_PIPE] = ACTIONS(533),
    [anon_sym_AMP] = ACTIONS(533),
    [anon_sym_PIPE_PIPE] = ACTIONS(531),
    [anon_sym_AMP_AMP] = ACTIONS(531),
    [anon_sym_LT] = ACTIONS(533),
    [anon_sym_LT_EQ] = ACTIONS(531),
    [anon_sym_GT] = ACTIONS(533),
    [anon_sym_GT_EQ] = ACTIONS(531),
    [anon_sym_EQ_EQ] = ACTIONS(531),
    [anon_sym_BANG_EQ] = ACTIONS(531),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_SLASH] = ACTIONS(531),
    [anon_sym_STAR_STAR] = ACTIONS(531),
    [anon_sym_CARET] = ACTIONS(531),
    [aux_sym_binary_operator_token1] = ACTIONS(531),
    [anon_sym_PIPE_GT] = ACTIONS(531),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_DOLLAR] = ACTIONS(531),
    [anon_sym_AT] = ACTIONS(531),
    [aux_sym__hex_literal_token1] = ACTIONS(1592),
    [sym__number_literal] = ACTIONS(1594),
    [anon_sym_SQUOTE] = ACTIONS(1596),
    [anon_sym_DQUOTE] = ACTIONS(1598),
    [sym_return] = ACTIONS(2685),
    [sym_next] = ACTIONS(2685),
    [sym_break] = ACTIONS(2685),
    [sym_true] = ACTIONS(2685),
    [sym_false] = ACTIONS(2685),
    [sym_null] = ACTIONS(2685),
    [sym_inf] = ACTIONS(2685),
    [sym_nan] = ACTIONS(2685),
    [anon_sym_NA] = ACTIONS(1602),
    [anon_sym_NA_integer_] = ACTIONS(1602),
    [anon_sym_NA_real_] = ACTIONS(1602),
    [anon_sym_NA_complex_] = ACTIONS(1602),
    [anon_sym_NA_character_] = ACTIONS(1602),
    [sym_dots] = ACTIONS(2685),
    [sym_dot_dot_i] = ACTIONS(2687),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(531),
    [sym__newline] = ACTIONS(2689),
    [sym__raw_string_literal] = ACTIONS(1608),
    [sym__external_else] = ACTIONS(531),
    [sym__external_open_parenthesis] = ACTIONS(1610),
    [sym__external_close_parenthesis] = ACTIONS(531),
    [sym__external_open_brace] = ACTIONS(1614),
    [sym__external_open_bracket] = ACTIONS(531),
    [sym__external_open_bracket2] = ACTIONS(531),
    [sym__external_close_bracket2] = ACTIONS(531),
  },
  [230] = {
    [sym_function_definition] = STATE(1189),
    [sym_if_statement] = STATE(1189),
    [sym_for_statement] = STATE(1189),
    [sym_while_statement] = STATE(1189),
    [sym_repeat_statement] = STATE(1189),
    [sym_braced_expression] = STATE(1189),
    [sym_parenthesized_expression] = STATE(1189),
    [sym_call] = STATE(1189),
    [sym_subset] = STATE(1189),
    [sym_subset2] = STATE(1189),
    [sym_unary_operator] = STATE(1189),
    [sym_binary_operator] = STATE(1189),
    [sym_extract_operator] = STATE(1189),
    [sym_namespace_operator] = STATE(1189),
    [sym_integer] = STATE(1189),
    [sym_complex] = STATE(1189),
    [sym_float] = STATE(1189),
    [sym__hex_literal] = STATE(2288),
    [sym__float_literal] = STATE(2288),
    [sym_string] = STATE(2287),
    [sym__single_quoted_string] = STATE(2289),
    [sym__double_quoted_string] = STATE(2290),
    [sym_na] = STATE(1189),
    [sym__expression] = STATE(1189),
    [sym__string_or_identifier] = STATE(5144),
    [sym__open_parenthesis] = STATE(119),
    [sym__open_brace] = STATE(16),
    [aux_sym_function_definition_repeat1] = STATE(2460),
    [sym_identifier] = ACTIONS(1568),
    [anon_sym_BSLASH] = ACTIONS(1570),
    [anon_sym_function] = ACTIONS(1572),
    [anon_sym_EQ] = ACTIONS(759),
    [anon_sym_if] = ACTIONS(1574),
    [anon_sym_for] = ACTIONS(1576),
    [anon_sym_while] = ACTIONS(1578),
    [anon_sym_repeat] = ACTIONS(1580),
    [anon_sym_QMARK] = ACTIONS(1582),
    [anon_sym_TILDE] = ACTIONS(1584),
    [anon_sym_BANG] = ACTIONS(1586),
    [anon_sym_PLUS] = ACTIONS(1588),
    [anon_sym_DASH] = ACTIONS(1590),
    [anon_sym_LT_DASH] = ACTIONS(757),
    [anon_sym_LT_LT_DASH] = ACTIONS(757),
    [anon_sym_COLON_EQ] = ACTIONS(757),
    [anon_sym_DASH_GT] = ACTIONS(759),
    [anon_sym_DASH_GT_GT] = ACTIONS(757),
    [anon_sym_PIPE] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(759),
    [anon_sym_PIPE_PIPE] = ACTIONS(757),
    [anon_sym_AMP_AMP] = ACTIONS(757),
    [anon_sym_LT] = ACTIONS(759),
    [anon_sym_LT_EQ] = ACTIONS(757),
    [anon_sym_GT] = ACTIONS(759),
    [anon_sym_GT_EQ] = ACTIONS(757),
    [anon_sym_EQ_EQ] = ACTIONS(757),
    [anon_sym_BANG_EQ] = ACTIONS(757),
    [anon_sym_STAR] = ACTIONS(759),
    [anon_sym_SLASH] = ACTIONS(757),
    [anon_sym_STAR_STAR] = ACTIONS(757),
    [anon_sym_CARET] = ACTIONS(757),
    [aux_sym_binary_operator_token1] = ACTIONS(757),
    [anon_sym_PIPE_GT] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(759),
    [anon_sym_DOLLAR] = ACTIONS(757),
    [anon_sym_AT] = ACTIONS(757),
    [aux_sym__hex_literal_token1] = ACTIONS(1592),
    [sym__number_literal] = ACTIONS(1594),
    [anon_sym_SQUOTE] = ACTIONS(1596),
    [anon_sym_DQUOTE] = ACTIONS(1598),
    [sym_return] = ACTIONS(2691),
    [sym_next] = ACTIONS(2691),
    [sym_break] = ACTIONS(2691),
    [sym_true] = ACTIONS(2691),
    [sym_false] = ACTIONS(2691),
    [sym_null] = ACTIONS(2691),
    [sym_inf] = ACTIONS(2691),
    [sym_nan] = ACTIONS(2691),
    [anon_sym_NA] = ACTIONS(1602),
    [anon_sym_NA_integer_] = ACTIONS(1602),
    [anon_sym_NA_real_] = ACTIONS(1602),
    [anon_sym_NA_complex_] = ACTIONS(1602),
    [anon_sym_NA_character_] = ACTIONS(1602),
    [sym_dots] = ACTIONS(2691),
    [sym_dot_dot_i] = ACTIONS(2693),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(757),
    [sym__newline] = ACTIONS(757),
    [sym__raw_string_literal] = ACTIONS(1608),
    [sym__external_else] = ACTIONS(757),
    [sym__external_open_parenthesis] = ACTIONS(1610),
    [sym__external_close_parenthesis] = ACTIONS(757),
    [sym__external_open_brace] = ACTIONS(1614),
    [sym__external_open_bracket] = ACTIONS(757),
    [sym__external_open_bracket2] = ACTIONS(757),
    [sym__external_close_bracket2] = ACTIONS(757),
  },
  [231] = {
    [sym_function_definition] = STATE(1085),
    [sym_if_statement] = STATE(1085),
    [sym_for_statement] = STATE(1085),
    [sym_while_statement] = STATE(1085),
    [sym_repeat_statement] = STATE(1085),
    [sym_braced_expression] = STATE(1085),
    [sym_parenthesized_expression] = STATE(1085),
    [sym_call] = STATE(1085),
    [sym_subset] = STATE(1085),
    [sym_subset2] = STATE(1085),
    [sym_unary_operator] = STATE(1085),
    [sym_binary_operator] = STATE(1085),
    [sym_extract_operator] = STATE(1085),
    [sym_namespace_operator] = STATE(1085),
    [sym_integer] = STATE(1085),
    [sym_complex] = STATE(1085),
    [sym_float] = STATE(1085),
    [sym__hex_literal] = STATE(2235),
    [sym__float_literal] = STATE(2235),
    [sym_string] = STATE(2234),
    [sym__single_quoted_string] = STATE(2236),
    [sym__double_quoted_string] = STATE(2237),
    [sym_na] = STATE(1085),
    [sym__expression] = STATE(1085),
    [sym__string_or_identifier] = STATE(5150),
    [sym__open_parenthesis] = STATE(76),
    [sym__open_brace] = STATE(188),
    [aux_sym_function_definition_repeat1] = STATE(216),
    [sym_identifier] = ACTIONS(1433),
    [anon_sym_BSLASH] = ACTIONS(1435),
    [anon_sym_function] = ACTIONS(1437),
    [anon_sym_EQ] = ACTIONS(379),
    [anon_sym_if] = ACTIONS(1439),
    [anon_sym_for] = ACTIONS(1441),
    [anon_sym_while] = ACTIONS(1443),
    [anon_sym_repeat] = ACTIONS(1445),
    [anon_sym_QMARK] = ACTIONS(1447),
    [anon_sym_TILDE] = ACTIONS(1449),
    [anon_sym_BANG] = ACTIONS(1451),
    [anon_sym_PLUS] = ACTIONS(1453),
    [anon_sym_DASH] = ACTIONS(1455),
    [anon_sym_LT_DASH] = ACTIONS(377),
    [anon_sym_LT_LT_DASH] = ACTIONS(377),
    [anon_sym_COLON_EQ] = ACTIONS(377),
    [anon_sym_DASH_GT] = ACTIONS(379),
    [anon_sym_DASH_GT_GT] = ACTIONS(377),
    [anon_sym_PIPE] = ACTIONS(379),
    [anon_sym_AMP] = ACTIONS(379),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_LT] = ACTIONS(379),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(379),
    [anon_sym_GT_EQ] = ACTIONS(377),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(379),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_STAR_STAR] = ACTIONS(377),
    [anon_sym_CARET] = ACTIONS(377),
    [aux_sym_binary_operator_token1] = ACTIONS(377),
    [anon_sym_PIPE_GT] = ACTIONS(377),
    [anon_sym_COLON] = ACTIONS(379),
    [anon_sym_DOLLAR] = ACTIONS(377),
    [anon_sym_AT] = ACTIONS(377),
    [aux_sym__hex_literal_token1] = ACTIONS(1457),
    [sym__number_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [anon_sym_DQUOTE] = ACTIONS(1463),
    [sym_return] = ACTIONS(2695),
    [sym_next] = ACTIONS(2695),
    [sym_break] = ACTIONS(2695),
    [sym_true] = ACTIONS(2695),
    [sym_false] = ACTIONS(2695),
    [sym_null] = ACTIONS(2695),
    [sym_inf] = ACTIONS(2695),
    [sym_nan] = ACTIONS(2695),
    [anon_sym_NA] = ACTIONS(1467),
    [anon_sym_NA_integer_] = ACTIONS(1467),
    [anon_sym_NA_real_] = ACTIONS(1467),
    [anon_sym_NA_complex_] = ACTIONS(1467),
    [anon_sym_NA_character_] = ACTIONS(1467),
    [sym_dots] = ACTIONS(2695),
    [sym_dot_dot_i] = ACTIONS(2697),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(377),
    [sym__newline] = ACTIONS(2699),
    [sym__semicolon] = ACTIONS(377),
    [sym__raw_string_literal] = ACTIONS(1473),
    [sym__external_open_parenthesis] = ACTIONS(1475),
    [sym__external_open_brace] = ACTIONS(1477),
    [sym__external_close_brace] = ACTIONS(377),
    [sym__external_open_bracket] = ACTIONS(377),
    [sym__external_open_bracket2] = ACTIONS(377),
    [sym__external_close_bracket2] = ACTIONS(377),
  },
  [232] = {
    [sym_function_definition] = STATE(1034),
    [sym_if_statement] = STATE(1034),
    [sym_for_statement] = STATE(1034),
    [sym_while_statement] = STATE(1034),
    [sym_repeat_statement] = STATE(1034),
    [sym_braced_expression] = STATE(1034),
    [sym_parenthesized_expression] = STATE(1034),
    [sym_call] = STATE(1034),
    [sym_subset] = STATE(1034),
    [sym_subset2] = STATE(1034),
    [sym_unary_operator] = STATE(1034),
    [sym_binary_operator] = STATE(1034),
    [sym_extract_operator] = STATE(1034),
    [sym_namespace_operator] = STATE(1034),
    [sym_integer] = STATE(1034),
    [sym_complex] = STATE(1034),
    [sym_float] = STATE(1034),
    [sym__hex_literal] = STATE(2311),
    [sym__float_literal] = STATE(2311),
    [sym_string] = STATE(2312),
    [sym__single_quoted_string] = STATE(2310),
    [sym__double_quoted_string] = STATE(2309),
    [sym_na] = STATE(1034),
    [sym__expression] = STATE(1034),
    [sym__string_or_identifier] = STATE(5134),
    [sym__open_parenthesis] = STATE(64),
    [sym__open_brace] = STATE(199),
    [aux_sym_function_definition_repeat1] = STATE(215),
    [ts_builtin_sym_end] = ACTIONS(263),
    [sym_identifier] = ACTIONS(1385),
    [anon_sym_BSLASH] = ACTIONS(1387),
    [anon_sym_function] = ACTIONS(1389),
    [anon_sym_EQ] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(1391),
    [anon_sym_for] = ACTIONS(1393),
    [anon_sym_while] = ACTIONS(1395),
    [anon_sym_repeat] = ACTIONS(1397),
    [anon_sym_QMARK] = ACTIONS(1399),
    [anon_sym_TILDE] = ACTIONS(1401),
    [anon_sym_BANG] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1407),
    [anon_sym_LT_DASH] = ACTIONS(263),
    [anon_sym_LT_LT_DASH] = ACTIONS(263),
    [anon_sym_COLON_EQ] = ACTIONS(263),
    [anon_sym_DASH_GT] = ACTIONS(265),
    [anon_sym_DASH_GT_GT] = ACTIONS(263),
    [anon_sym_PIPE] = ACTIONS(265),
    [anon_sym_AMP] = ACTIONS(265),
    [anon_sym_PIPE_PIPE] = ACTIONS(263),
    [anon_sym_AMP_AMP] = ACTIONS(263),
    [anon_sym_LT] = ACTIONS(265),
    [anon_sym_LT_EQ] = ACTIONS(263),
    [anon_sym_GT] = ACTIONS(265),
    [anon_sym_GT_EQ] = ACTIONS(263),
    [anon_sym_EQ_EQ] = ACTIONS(263),
    [anon_sym_BANG_EQ] = ACTIONS(263),
    [anon_sym_STAR] = ACTIONS(265),
    [anon_sym_SLASH] = ACTIONS(263),
    [anon_sym_STAR_STAR] = ACTIONS(263),
    [anon_sym_CARET] = ACTIONS(263),
    [aux_sym_binary_operator_token1] = ACTIONS(263),
    [anon_sym_PIPE_GT] = ACTIONS(263),
    [anon_sym_COLON] = ACTIONS(265),
    [anon_sym_DOLLAR] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(263),
    [aux_sym__hex_literal_token1] = ACTIONS(1409),
    [sym__number_literal] = ACTIONS(1411),
    [anon_sym_SQUOTE] = ACTIONS(1413),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [sym_return] = ACTIONS(2701),
    [sym_next] = ACTIONS(2701),
    [sym_break] = ACTIONS(2701),
    [sym_true] = ACTIONS(2701),
    [sym_false] = ACTIONS(2701),
    [sym_null] = ACTIONS(2701),
    [sym_inf] = ACTIONS(2701),
    [sym_nan] = ACTIONS(2701),
    [anon_sym_NA] = ACTIONS(1419),
    [anon_sym_NA_integer_] = ACTIONS(1419),
    [anon_sym_NA_real_] = ACTIONS(1419),
    [anon_sym_NA_complex_] = ACTIONS(1419),
    [anon_sym_NA_character_] = ACTIONS(1419),
    [sym_dots] = ACTIONS(2701),
    [sym_dot_dot_i] = ACTIONS(2703),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(2705),
    [sym__semicolon] = ACTIONS(263),
    [sym__raw_string_literal] = ACTIONS(1425),
    [sym__external_else] = ACTIONS(263),
    [sym__external_open_parenthesis] = ACTIONS(1427),
    [sym__external_open_brace] = ACTIONS(1429),
    [sym__external_close_brace] = ACTIONS(263),
    [sym__external_open_bracket] = ACTIONS(263),
    [sym__external_open_bracket2] = ACTIONS(263),
  },
  [233] = {
    [sym_function_definition] = STATE(1033),
    [sym_if_statement] = STATE(1033),
    [sym_for_statement] = STATE(1033),
    [sym_while_statement] = STATE(1033),
    [sym_repeat_statement] = STATE(1033),
    [sym_braced_expression] = STATE(1033),
    [sym_parenthesized_expression] = STATE(1033),
    [sym_call] = STATE(1033),
    [sym_subset] = STATE(1033),
    [sym_subset2] = STATE(1033),
    [sym_unary_operator] = STATE(1033),
    [sym_binary_operator] = STATE(1033),
    [sym_extract_operator] = STATE(1033),
    [sym_namespace_operator] = STATE(1033),
    [sym_integer] = STATE(1033),
    [sym_complex] = STATE(1033),
    [sym_float] = STATE(1033),
    [sym__hex_literal] = STATE(2356),
    [sym__float_literal] = STATE(2356),
    [sym_string] = STATE(2231),
    [sym__single_quoted_string] = STATE(2355),
    [sym__double_quoted_string] = STATE(2354),
    [sym_na] = STATE(1033),
    [sym__expression] = STATE(1033),
    [sym__string_or_identifier] = STATE(5156),
    [sym__open_parenthesis] = STATE(190),
    [sym__open_brace] = STATE(94),
    [aux_sym_function_definition_repeat1] = STATE(2465),
    [ts_builtin_sym_end] = ACTIONS(471),
    [sym_identifier] = ACTIONS(1337),
    [anon_sym_BSLASH] = ACTIONS(1339),
    [anon_sym_function] = ACTIONS(1341),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_if] = ACTIONS(1343),
    [anon_sym_for] = ACTIONS(1345),
    [anon_sym_while] = ACTIONS(1347),
    [anon_sym_repeat] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_BANG] = ACTIONS(1355),
    [anon_sym_PLUS] = ACTIONS(1357),
    [anon_sym_DASH] = ACTIONS(1359),
    [anon_sym_LT_DASH] = ACTIONS(471),
    [anon_sym_LT_LT_DASH] = ACTIONS(471),
    [anon_sym_COLON_EQ] = ACTIONS(471),
    [anon_sym_DASH_GT] = ACTIONS(473),
    [anon_sym_DASH_GT_GT] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(473),
    [anon_sym_AMP] = ACTIONS(473),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_LT_EQ] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(473),
    [anon_sym_GT_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_STAR] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [aux_sym_binary_operator_token1] = ACTIONS(471),
    [anon_sym_PIPE_GT] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(473),
    [anon_sym_DOLLAR] = ACTIONS(471),
    [anon_sym_AT] = ACTIONS(471),
    [aux_sym__hex_literal_token1] = ACTIONS(1361),
    [sym__number_literal] = ACTIONS(1363),
    [anon_sym_SQUOTE] = ACTIONS(1365),
    [anon_sym_DQUOTE] = ACTIONS(1367),
    [sym_return] = ACTIONS(2707),
    [sym_next] = ACTIONS(2707),
    [sym_break] = ACTIONS(2707),
    [sym_true] = ACTIONS(2707),
    [sym_false] = ACTIONS(2707),
    [sym_null] = ACTIONS(2707),
    [sym_inf] = ACTIONS(2707),
    [sym_nan] = ACTIONS(2707),
    [anon_sym_NA] = ACTIONS(1371),
    [anon_sym_NA_integer_] = ACTIONS(1371),
    [anon_sym_NA_real_] = ACTIONS(1371),
    [anon_sym_NA_complex_] = ACTIONS(1371),
    [anon_sym_NA_character_] = ACTIONS(1371),
    [sym_dots] = ACTIONS(2707),
    [sym_dot_dot_i] = ACTIONS(2709),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(471),
    [sym__semicolon] = ACTIONS(471),
    [sym__raw_string_literal] = ACTIONS(1377),
    [sym__external_else] = ACTIONS(471),
    [sym__external_open_parenthesis] = ACTIONS(1379),
    [sym__external_close_parenthesis] = ACTIONS(471),
    [sym__external_open_brace] = ACTIONS(1383),
    [sym__external_open_bracket] = ACTIONS(471),
    [sym__external_open_bracket2] = ACTIONS(471),
  },
  [234] = {
    [sym_function_definition] = STATE(1094),
    [sym_if_statement] = STATE(1094),
    [sym_for_statement] = STATE(1094),
    [sym_while_statement] = STATE(1094),
    [sym_repeat_statement] = STATE(1094),
    [sym_braced_expression] = STATE(1094),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_call] = STATE(1094),
    [sym_subset] = STATE(1094),
    [sym_subset2] = STATE(1094),
    [sym_unary_operator] = STATE(1094),
    [sym_binary_operator] = STATE(1094),
    [sym_extract_operator] = STATE(1094),
    [sym_namespace_operator] = STATE(1094),
    [sym_integer] = STATE(1094),
    [sym_complex] = STATE(1094),
    [sym_float] = STATE(1094),
    [sym__hex_literal] = STATE(2311),
    [sym__float_literal] = STATE(2311),
    [sym_string] = STATE(2312),
    [sym__single_quoted_string] = STATE(2310),
    [sym__double_quoted_string] = STATE(2309),
    [sym_na] = STATE(1094),
    [sym__expression] = STATE(1094),
    [sym__string_or_identifier] = STATE(5134),
    [sym__open_parenthesis] = STATE(64),
    [sym__open_brace] = STATE(199),
    [aux_sym_function_definition_repeat1] = STATE(2399),
    [ts_builtin_sym_end] = ACTIONS(453),
    [sym_identifier] = ACTIONS(1385),
    [anon_sym_BSLASH] = ACTIONS(1387),
    [anon_sym_function] = ACTIONS(1389),
    [anon_sym_EQ] = ACTIONS(455),
    [anon_sym_if] = ACTIONS(1391),
    [anon_sym_for] = ACTIONS(1393),
    [anon_sym_while] = ACTIONS(1395),
    [anon_sym_repeat] = ACTIONS(1397),
    [anon_sym_QMARK] = ACTIONS(1399),
    [anon_sym_TILDE] = ACTIONS(1401),
    [anon_sym_BANG] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1407),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [anon_sym_LT_LT_DASH] = ACTIONS(453),
    [anon_sym_COLON_EQ] = ACTIONS(453),
    [anon_sym_DASH_GT] = ACTIONS(455),
    [anon_sym_DASH_GT_GT] = ACTIONS(453),
    [anon_sym_PIPE] = ACTIONS(455),
    [anon_sym_AMP] = ACTIONS(455),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(455),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_GT] = ACTIONS(455),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(453),
    [anon_sym_STAR] = ACTIONS(455),
    [anon_sym_SLASH] = ACTIONS(453),
    [anon_sym_STAR_STAR] = ACTIONS(453),
    [anon_sym_CARET] = ACTIONS(453),
    [aux_sym_binary_operator_token1] = ACTIONS(453),
    [anon_sym_PIPE_GT] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(455),
    [anon_sym_DOLLAR] = ACTIONS(453),
    [anon_sym_AT] = ACTIONS(453),
    [aux_sym__hex_literal_token1] = ACTIONS(1409),
    [sym__number_literal] = ACTIONS(1411),
    [anon_sym_SQUOTE] = ACTIONS(1413),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [sym_return] = ACTIONS(2711),
    [sym_next] = ACTIONS(2711),
    [sym_break] = ACTIONS(2711),
    [sym_true] = ACTIONS(2711),
    [sym_false] = ACTIONS(2711),
    [sym_null] = ACTIONS(2711),
    [sym_inf] = ACTIONS(2711),
    [sym_nan] = ACTIONS(2711),
    [anon_sym_NA] = ACTIONS(1419),
    [anon_sym_NA_integer_] = ACTIONS(1419),
    [anon_sym_NA_real_] = ACTIONS(1419),
    [anon_sym_NA_complex_] = ACTIONS(1419),
    [anon_sym_NA_character_] = ACTIONS(1419),
    [sym_dots] = ACTIONS(2711),
    [sym_dot_dot_i] = ACTIONS(2713),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(453),
    [sym__semicolon] = ACTIONS(453),
    [sym__raw_string_literal] = ACTIONS(1425),
    [sym__external_else] = ACTIONS(453),
    [sym__external_open_parenthesis] = ACTIONS(1427),
    [sym__external_open_brace] = ACTIONS(1429),
    [sym__external_close_brace] = ACTIONS(453),
    [sym__external_open_bracket] = ACTIONS(453),
    [sym__external_open_bracket2] = ACTIONS(453),
  },
  [235] = {
    [sym_function_definition] = STATE(1216),
    [sym_if_statement] = STATE(1216),
    [sym_for_statement] = STATE(1216),
    [sym_while_statement] = STATE(1216),
    [sym_repeat_statement] = STATE(1216),
    [sym_braced_expression] = STATE(1216),
    [sym_parenthesized_expression] = STATE(1216),
    [sym_call] = STATE(1216),
    [sym_subset] = STATE(1216),
    [sym_subset2] = STATE(1216),
    [sym_unary_operator] = STATE(1216),
    [sym_binary_operator] = STATE(1216),
    [sym_extract_operator] = STATE(1216),
    [sym_namespace_operator] = STATE(1216),
    [sym_integer] = STATE(1216),
    [sym_complex] = STATE(1216),
    [sym_float] = STATE(1216),
    [sym__hex_literal] = STATE(2288),
    [sym__float_literal] = STATE(2288),
    [sym_string] = STATE(2287),
    [sym__single_quoted_string] = STATE(2289),
    [sym__double_quoted_string] = STATE(2290),
    [sym_na] = STATE(1216),
    [sym__expression] = STATE(1216),
    [sym__string_or_identifier] = STATE(5144),
    [sym__open_parenthesis] = STATE(119),
    [sym__open_brace] = STATE(16),
    [aux_sym_function_definition_repeat1] = STATE(2460),
    [sym_identifier] = ACTIONS(1568),
    [anon_sym_BSLASH] = ACTIONS(1570),
    [anon_sym_function] = ACTIONS(1572),
    [anon_sym_EQ] = ACTIONS(767),
    [anon_sym_if] = ACTIONS(1574),
    [anon_sym_for] = ACTIONS(1576),
    [anon_sym_while] = ACTIONS(1578),
    [anon_sym_repeat] = ACTIONS(1580),
    [anon_sym_QMARK] = ACTIONS(1582),
    [anon_sym_TILDE] = ACTIONS(1584),
    [anon_sym_BANG] = ACTIONS(1586),
    [anon_sym_PLUS] = ACTIONS(1588),
    [anon_sym_DASH] = ACTIONS(1590),
    [anon_sym_LT_DASH] = ACTIONS(765),
    [anon_sym_LT_LT_DASH] = ACTIONS(765),
    [anon_sym_COLON_EQ] = ACTIONS(765),
    [anon_sym_DASH_GT] = ACTIONS(767),
    [anon_sym_DASH_GT_GT] = ACTIONS(765),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_AMP] = ACTIONS(767),
    [anon_sym_PIPE_PIPE] = ACTIONS(765),
    [anon_sym_AMP_AMP] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(767),
    [anon_sym_LT_EQ] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_GT_EQ] = ACTIONS(765),
    [anon_sym_EQ_EQ] = ACTIONS(765),
    [anon_sym_BANG_EQ] = ACTIONS(765),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(765),
    [anon_sym_STAR_STAR] = ACTIONS(765),
    [anon_sym_CARET] = ACTIONS(765),
    [aux_sym_binary_operator_token1] = ACTIONS(765),
    [anon_sym_PIPE_GT] = ACTIONS(765),
    [anon_sym_COLON] = ACTIONS(767),
    [anon_sym_DOLLAR] = ACTIONS(765),
    [anon_sym_AT] = ACTIONS(765),
    [aux_sym__hex_literal_token1] = ACTIONS(1592),
    [sym__number_literal] = ACTIONS(1594),
    [anon_sym_SQUOTE] = ACTIONS(1596),
    [anon_sym_DQUOTE] = ACTIONS(1598),
    [sym_return] = ACTIONS(2715),
    [sym_next] = ACTIONS(2715),
    [sym_break] = ACTIONS(2715),
    [sym_true] = ACTIONS(2715),
    [sym_false] = ACTIONS(2715),
    [sym_null] = ACTIONS(2715),
    [sym_inf] = ACTIONS(2715),
    [sym_nan] = ACTIONS(2715),
    [anon_sym_NA] = ACTIONS(1602),
    [anon_sym_NA_integer_] = ACTIONS(1602),
    [anon_sym_NA_real_] = ACTIONS(1602),
    [anon_sym_NA_complex_] = ACTIONS(1602),
    [anon_sym_NA_character_] = ACTIONS(1602),
    [sym_dots] = ACTIONS(2715),
    [sym_dot_dot_i] = ACTIONS(2717),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(765),
    [sym__newline] = ACTIONS(765),
    [sym__raw_string_literal] = ACTIONS(1608),
    [sym__external_else] = ACTIONS(765),
    [sym__external_open_parenthesis] = ACTIONS(1610),
    [sym__external_close_parenthesis] = ACTIONS(765),
    [sym__external_open_brace] = ACTIONS(1614),
    [sym__external_open_bracket] = ACTIONS(765),
    [sym__external_open_bracket2] = ACTIONS(765),
    [sym__external_close_bracket2] = ACTIONS(765),
  },
  [236] = {
    [sym_function_definition] = STATE(1139),
    [sym_if_statement] = STATE(1139),
    [sym_for_statement] = STATE(1139),
    [sym_while_statement] = STATE(1139),
    [sym_repeat_statement] = STATE(1139),
    [sym_braced_expression] = STATE(1139),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_call] = STATE(1139),
    [sym_subset] = STATE(1139),
    [sym_subset2] = STATE(1139),
    [sym_unary_operator] = STATE(1139),
    [sym_binary_operator] = STATE(1139),
    [sym_extract_operator] = STATE(1139),
    [sym_namespace_operator] = STATE(1139),
    [sym_integer] = STATE(1139),
    [sym_complex] = STATE(1139),
    [sym_float] = STATE(1139),
    [sym__hex_literal] = STATE(2272),
    [sym__float_literal] = STATE(2272),
    [sym_string] = STATE(2271),
    [sym__single_quoted_string] = STATE(2273),
    [sym__double_quoted_string] = STATE(2274),
    [sym_na] = STATE(1139),
    [sym__expression] = STATE(1139),
    [sym__string_or_identifier] = STATE(5157),
    [sym__open_parenthesis] = STATE(120),
    [sym__open_brace] = STATE(11),
    [aux_sym_parenthesized_expression_repeat1] = STATE(236),
    [sym_identifier] = ACTIONS(2719),
    [anon_sym_BSLASH] = ACTIONS(2722),
    [anon_sym_function] = ACTIONS(2725),
    [anon_sym_EQ] = ACTIONS(814),
    [anon_sym_if] = ACTIONS(2728),
    [anon_sym_for] = ACTIONS(2731),
    [anon_sym_while] = ACTIONS(2734),
    [anon_sym_repeat] = ACTIONS(2737),
    [anon_sym_QMARK] = ACTIONS(2740),
    [anon_sym_TILDE] = ACTIONS(2743),
    [anon_sym_BANG] = ACTIONS(2746),
    [anon_sym_PLUS] = ACTIONS(2749),
    [anon_sym_DASH] = ACTIONS(2752),
    [anon_sym_LT_DASH] = ACTIONS(803),
    [anon_sym_LT_LT_DASH] = ACTIONS(803),
    [anon_sym_COLON_EQ] = ACTIONS(803),
    [anon_sym_DASH_GT] = ACTIONS(814),
    [anon_sym_DASH_GT_GT] = ACTIONS(803),
    [anon_sym_PIPE] = ACTIONS(814),
    [anon_sym_AMP] = ACTIONS(814),
    [anon_sym_PIPE_PIPE] = ACTIONS(803),
    [anon_sym_AMP_AMP] = ACTIONS(803),
    [anon_sym_LT] = ACTIONS(814),
    [anon_sym_LT_EQ] = ACTIONS(803),
    [anon_sym_GT] = ACTIONS(814),
    [anon_sym_GT_EQ] = ACTIONS(803),
    [anon_sym_EQ_EQ] = ACTIONS(803),
    [anon_sym_BANG_EQ] = ACTIONS(803),
    [anon_sym_STAR] = ACTIONS(814),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_STAR_STAR] = ACTIONS(803),
    [anon_sym_CARET] = ACTIONS(803),
    [aux_sym_binary_operator_token1] = ACTIONS(803),
    [anon_sym_PIPE_GT] = ACTIONS(803),
    [anon_sym_COLON] = ACTIONS(814),
    [anon_sym_DOLLAR] = ACTIONS(803),
    [anon_sym_AT] = ACTIONS(803),
    [aux_sym__hex_literal_token1] = ACTIONS(2755),
    [sym__number_literal] = ACTIONS(2758),
    [anon_sym_SQUOTE] = ACTIONS(2761),
    [anon_sym_DQUOTE] = ACTIONS(2764),
    [sym_return] = ACTIONS(2767),
    [sym_next] = ACTIONS(2767),
    [sym_break] = ACTIONS(2767),
    [sym_true] = ACTIONS(2767),
    [sym_false] = ACTIONS(2767),
    [sym_null] = ACTIONS(2767),
    [sym_inf] = ACTIONS(2767),
    [sym_nan] = ACTIONS(2767),
    [anon_sym_NA] = ACTIONS(2770),
    [anon_sym_NA_integer_] = ACTIONS(2770),
    [anon_sym_NA_real_] = ACTIONS(2770),
    [anon_sym_NA_complex_] = ACTIONS(2770),
    [anon_sym_NA_character_] = ACTIONS(2770),
    [sym_dots] = ACTIONS(2767),
    [sym_dot_dot_i] = ACTIONS(2773),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(803),
    [sym__newline] = ACTIONS(2776),
    [sym__raw_string_literal] = ACTIONS(2779),
    [sym__external_else] = ACTIONS(803),
    [sym__external_open_parenthesis] = ACTIONS(2782),
    [sym__external_close_parenthesis] = ACTIONS(803),
    [sym__external_open_brace] = ACTIONS(2785),
    [sym__external_open_bracket] = ACTIONS(803),
    [sym__external_close_bracket] = ACTIONS(803),
    [sym__external_open_bracket2] = ACTIONS(803),
  },
  [237] = {
    [sym_function_definition] = STATE(1218),
    [sym_if_statement] = STATE(1218),
    [sym_for_statement] = STATE(1218),
    [sym_while_statement] = STATE(1218),
    [sym_repeat_statement] = STATE(1218),
    [sym_braced_expression] = STATE(1218),
    [sym_parenthesized_expression] = STATE(1218),
    [sym_call] = STATE(1218),
    [sym_subset] = STATE(1218),
    [sym_subset2] = STATE(1218),
    [sym_unary_operator] = STATE(1218),
    [sym_binary_operator] = STATE(1218),
    [sym_extract_operator] = STATE(1218),
    [sym_namespace_operator] = STATE(1218),
    [sym_integer] = STATE(1218),
    [sym_complex] = STATE(1218),
    [sym_float] = STATE(1218),
    [sym__hex_literal] = STATE(2288),
    [sym__float_literal] = STATE(2288),
    [sym_string] = STATE(2287),
    [sym__single_quoted_string] = STATE(2289),
    [sym__double_quoted_string] = STATE(2290),
    [sym_na] = STATE(1218),
    [sym__expression] = STATE(1218),
    [sym__string_or_identifier] = STATE(5144),
    [sym__open_parenthesis] = STATE(119),
    [sym__open_brace] = STATE(16),
    [aux_sym_function_definition_repeat1] = STATE(230),
    [sym_identifier] = ACTIONS(1568),
    [anon_sym_BSLASH] = ACTIONS(1570),
    [anon_sym_function] = ACTIONS(1572),
    [anon_sym_EQ] = ACTIONS(543),
    [anon_sym_if] = ACTIONS(1574),
    [anon_sym_for] = ACTIONS(1576),
    [anon_sym_while] = ACTIONS(1578),
    [anon_sym_repeat] = ACTIONS(1580),
    [anon_sym_QMARK] = ACTIONS(1582),
    [anon_sym_TILDE] = ACTIONS(1584),
    [anon_sym_BANG] = ACTIONS(1586),
    [anon_sym_PLUS] = ACTIONS(1588),
    [anon_sym_DASH] = ACTIONS(1590),
    [anon_sym_LT_DASH] = ACTIONS(545),
    [anon_sym_LT_LT_DASH] = ACTIONS(545),
    [anon_sym_COLON_EQ] = ACTIONS(545),
    [anon_sym_DASH_GT] = ACTIONS(543),
    [anon_sym_DASH_GT_GT] = ACTIONS(545),
    [anon_sym_PIPE] = ACTIONS(543),
    [anon_sym_AMP] = ACTIONS(543),
    [anon_sym_PIPE_PIPE] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(543),
    [anon_sym_LT_EQ] = ACTIONS(545),
    [anon_sym_GT] = ACTIONS(543),
    [anon_sym_GT_EQ] = ACTIONS(545),
    [anon_sym_EQ_EQ] = ACTIONS(545),
    [anon_sym_BANG_EQ] = ACTIONS(545),
    [anon_sym_STAR] = ACTIONS(543),
    [anon_sym_SLASH] = ACTIONS(545),
    [anon_sym_STAR_STAR] = ACTIONS(545),
    [anon_sym_CARET] = ACTIONS(545),
    [aux_sym_binary_operator_token1] = ACTIONS(545),
    [anon_sym_PIPE_GT] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(543),
    [anon_sym_DOLLAR] = ACTIONS(545),
    [anon_sym_AT] = ACTIONS(545),
    [aux_sym__hex_literal_token1] = ACTIONS(1592),
    [sym__number_literal] = ACTIONS(1594),
    [anon_sym_SQUOTE] = ACTIONS(1596),
    [anon_sym_DQUOTE] = ACTIONS(1598),
    [sym_return] = ACTIONS(2788),
    [sym_next] = ACTIONS(2788),
    [sym_break] = ACTIONS(2788),
    [sym_true] = ACTIONS(2788),
    [sym_false] = ACTIONS(2788),
    [sym_null] = ACTIONS(2788),
    [sym_inf] = ACTIONS(2788),
    [sym_nan] = ACTIONS(2788),
    [anon_sym_NA] = ACTIONS(1602),
    [anon_sym_NA_integer_] = ACTIONS(1602),
    [anon_sym_NA_real_] = ACTIONS(1602),
    [anon_sym_NA_complex_] = ACTIONS(1602),
    [anon_sym_NA_character_] = ACTIONS(1602),
    [sym_dots] = ACTIONS(2788),
    [sym_dot_dot_i] = ACTIONS(2790),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(545),
    [sym__newline] = ACTIONS(2792),
    [sym__raw_string_literal] = ACTIONS(1608),
    [sym__external_else] = ACTIONS(545),
    [sym__external_open_parenthesis] = ACTIONS(1610),
    [sym__external_close_parenthesis] = ACTIONS(545),
    [sym__external_open_brace] = ACTIONS(1614),
    [sym__external_open_bracket] = ACTIONS(545),
    [sym__external_open_bracket2] = ACTIONS(545),
    [sym__external_close_bracket2] = ACTIONS(545),
  },
  [238] = {
    [sym_function_definition] = STATE(1229),
    [sym_if_statement] = STATE(1229),
    [sym_for_statement] = STATE(1229),
    [sym_while_statement] = STATE(1229),
    [sym_repeat_statement] = STATE(1229),
    [sym_braced_expression] = STATE(1229),
    [sym_parenthesized_expression] = STATE(1229),
    [sym_call] = STATE(1229),
    [sym_subset] = STATE(1229),
    [sym_subset2] = STATE(1229),
    [sym_unary_operator] = STATE(1229),
    [sym_binary_operator] = STATE(1229),
    [sym_extract_operator] = STATE(1229),
    [sym_namespace_operator] = STATE(1229),
    [sym_integer] = STATE(1229),
    [sym_complex] = STATE(1229),
    [sym_float] = STATE(1229),
    [sym__hex_literal] = STATE(2288),
    [sym__float_literal] = STATE(2288),
    [sym_string] = STATE(2287),
    [sym__single_quoted_string] = STATE(2289),
    [sym__double_quoted_string] = STATE(2290),
    [sym_na] = STATE(1229),
    [sym__expression] = STATE(1229),
    [sym__string_or_identifier] = STATE(5144),
    [sym__open_parenthesis] = STATE(119),
    [sym__open_brace] = STATE(16),
    [aux_sym_function_definition_repeat1] = STATE(235),
    [sym_identifier] = ACTIONS(1568),
    [anon_sym_BSLASH] = ACTIONS(1570),
    [anon_sym_function] = ACTIONS(1572),
    [anon_sym_EQ] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(1574),
    [anon_sym_for] = ACTIONS(1576),
    [anon_sym_while] = ACTIONS(1578),
    [anon_sym_repeat] = ACTIONS(1580),
    [anon_sym_QMARK] = ACTIONS(1582),
    [anon_sym_TILDE] = ACTIONS(1584),
    [anon_sym_BANG] = ACTIONS(1586),
    [anon_sym_PLUS] = ACTIONS(1588),
    [anon_sym_DASH] = ACTIONS(1590),
    [anon_sym_LT_DASH] = ACTIONS(263),
    [anon_sym_LT_LT_DASH] = ACTIONS(263),
    [anon_sym_COLON_EQ] = ACTIONS(263),
    [anon_sym_DASH_GT] = ACTIONS(265),
    [anon_sym_DASH_GT_GT] = ACTIONS(263),
    [anon_sym_PIPE] = ACTIONS(265),
    [anon_sym_AMP] = ACTIONS(265),
    [anon_sym_PIPE_PIPE] = ACTIONS(263),
    [anon_sym_AMP_AMP] = ACTIONS(263),
    [anon_sym_LT] = ACTIONS(265),
    [anon_sym_LT_EQ] = ACTIONS(263),
    [anon_sym_GT] = ACTIONS(265),
    [anon_sym_GT_EQ] = ACTIONS(263),
    [anon_sym_EQ_EQ] = ACTIONS(263),
    [anon_sym_BANG_EQ] = ACTIONS(263),
    [anon_sym_STAR] = ACTIONS(265),
    [anon_sym_SLASH] = ACTIONS(263),
    [anon_sym_STAR_STAR] = ACTIONS(263),
    [anon_sym_CARET] = ACTIONS(263),
    [aux_sym_binary_operator_token1] = ACTIONS(263),
    [anon_sym_PIPE_GT] = ACTIONS(263),
    [anon_sym_COLON] = ACTIONS(265),
    [anon_sym_DOLLAR] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(263),
    [aux_sym__hex_literal_token1] = ACTIONS(1592),
    [sym__number_literal] = ACTIONS(1594),
    [anon_sym_SQUOTE] = ACTIONS(1596),
    [anon_sym_DQUOTE] = ACTIONS(1598),
    [sym_return] = ACTIONS(2794),
    [sym_next] = ACTIONS(2794),
    [sym_break] = ACTIONS(2794),
    [sym_true] = ACTIONS(2794),
    [sym_false] = ACTIONS(2794),
    [sym_null] = ACTIONS(2794),
    [sym_inf] = ACTIONS(2794),
    [sym_nan] = ACTIONS(2794),
    [anon_sym_NA] = ACTIONS(1602),
    [anon_sym_NA_integer_] = ACTIONS(1602),
    [anon_sym_NA_real_] = ACTIONS(1602),
    [anon_sym_NA_complex_] = ACTIONS(1602),
    [anon_sym_NA_character_] = ACTIONS(1602),
    [sym_dots] = ACTIONS(2794),
    [sym_dot_dot_i] = ACTIONS(2796),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(263),
    [sym__newline] = ACTIONS(2798),
    [sym__raw_string_literal] = ACTIONS(1608),
    [sym__external_else] = ACTIONS(263),
    [sym__external_open_parenthesis] = ACTIONS(1610),
    [sym__external_close_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(1614),
    [sym__external_open_bracket] = ACTIONS(263),
    [sym__external_open_bracket2] = ACTIONS(263),
    [sym__external_close_bracket2] = ACTIONS(263),
  },
  [239] = {
    [sym_function_definition] = STATE(1031),
    [sym_if_statement] = STATE(1031),
    [sym_for_statement] = STATE(1031),
    [sym_while_statement] = STATE(1031),
    [sym_repeat_statement] = STATE(1031),
    [sym_braced_expression] = STATE(1031),
    [sym_parenthesized_expression] = STATE(1031),
    [sym_call] = STATE(1031),
    [sym_subset] = STATE(1031),
    [sym_subset2] = STATE(1031),
    [sym_unary_operator] = STATE(1031),
    [sym_binary_operator] = STATE(1031),
    [sym_extract_operator] = STATE(1031),
    [sym_namespace_operator] = STATE(1031),
    [sym_integer] = STATE(1031),
    [sym_complex] = STATE(1031),
    [sym_float] = STATE(1031),
    [sym__hex_literal] = STATE(2356),
    [sym__float_literal] = STATE(2356),
    [sym_string] = STATE(2231),
    [sym__single_quoted_string] = STATE(2355),
    [sym__double_quoted_string] = STATE(2354),
    [sym_na] = STATE(1031),
    [sym__expression] = STATE(1031),
    [sym__string_or_identifier] = STATE(5156),
    [sym__open_parenthesis] = STATE(190),
    [sym__open_brace] = STATE(94),
    [aux_sym_function_definition_repeat1] = STATE(233),
    [ts_builtin_sym_end] = ACTIONS(461),
    [sym_identifier] = ACTIONS(1337),
    [anon_sym_BSLASH] = ACTIONS(1339),
    [anon_sym_function] = ACTIONS(1341),
    [anon_sym_EQ] = ACTIONS(463),
    [anon_sym_if] = ACTIONS(1343),
    [anon_sym_for] = ACTIONS(1345),
    [anon_sym_while] = ACTIONS(1347),
    [anon_sym_repeat] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_BANG] = ACTIONS(1355),
    [anon_sym_PLUS] = ACTIONS(1357),
    [anon_sym_DASH] = ACTIONS(1359),
    [anon_sym_LT_DASH] = ACTIONS(461),
    [anon_sym_LT_LT_DASH] = ACTIONS(461),
    [anon_sym_COLON_EQ] = ACTIONS(461),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_DASH_GT_GT] = ACTIONS(461),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_PIPE_PIPE] = ACTIONS(461),
    [anon_sym_AMP_AMP] = ACTIONS(461),
    [anon_sym_LT] = ACTIONS(463),
    [anon_sym_LT_EQ] = ACTIONS(461),
    [anon_sym_GT] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(461),
    [anon_sym_EQ_EQ] = ACTIONS(461),
    [anon_sym_BANG_EQ] = ACTIONS(461),
    [anon_sym_STAR] = ACTIONS(463),
    [anon_sym_SLASH] = ACTIONS(461),
    [anon_sym_STAR_STAR] = ACTIONS(461),
    [anon_sym_CARET] = ACTIONS(461),
    [aux_sym_binary_operator_token1] = ACTIONS(461),
    [anon_sym_PIPE_GT] = ACTIONS(461),
    [anon_sym_COLON] = ACTIONS(463),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_AT] = ACTIONS(461),
    [aux_sym__hex_literal_token1] = ACTIONS(1361),
    [sym__number_literal] = ACTIONS(1363),
    [anon_sym_SQUOTE] = ACTIONS(1365),
    [anon_sym_DQUOTE] = ACTIONS(1367),
    [sym_return] = ACTIONS(2800),
    [sym_next] = ACTIONS(2800),
    [sym_break] = ACTIONS(2800),
    [sym_true] = ACTIONS(2800),
    [sym_false] = ACTIONS(2800),
    [sym_null] = ACTIONS(2800),
    [sym_inf] = ACTIONS(2800),
    [sym_nan] = ACTIONS(2800),
    [anon_sym_NA] = ACTIONS(1371),
    [anon_sym_NA_integer_] = ACTIONS(1371),
    [anon_sym_NA_real_] = ACTIONS(1371),
    [anon_sym_NA_complex_] = ACTIONS(1371),
    [anon_sym_NA_character_] = ACTIONS(1371),
    [sym_dots] = ACTIONS(2800),
    [sym_dot_dot_i] = ACTIONS(2802),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(2804),
    [sym__semicolon] = ACTIONS(461),
    [sym__raw_string_literal] = ACTIONS(1377),
    [sym__external_else] = ACTIONS(461),
    [sym__external_open_parenthesis] = ACTIONS(1379),
    [sym__external_close_parenthesis] = ACTIONS(461),
    [sym__external_open_brace] = ACTIONS(1383),
    [sym__external_open_bracket] = ACTIONS(461),
    [sym__external_open_bracket2] = ACTIONS(461),
  },
  [240] = {
    [sym_function_definition] = STATE(1029),
    [sym_if_statement] = STATE(1029),
    [sym_for_statement] = STATE(1029),
    [sym_while_statement] = STATE(1029),
    [sym_repeat_statement] = STATE(1029),
    [sym_braced_expression] = STATE(1029),
    [sym_parenthesized_expression] = STATE(1029),
    [sym_call] = STATE(1029),
    [sym_subset] = STATE(1029),
    [sym_subset2] = STATE(1029),
    [sym_unary_operator] = STATE(1029),
    [sym_binary_operator] = STATE(1029),
    [sym_extract_operator] = STATE(1029),
    [sym_namespace_operator] = STATE(1029),
    [sym_integer] = STATE(1029),
    [sym_complex] = STATE(1029),
    [sym_float] = STATE(1029),
    [sym__hex_literal] = STATE(2356),
    [sym__float_literal] = STATE(2356),
    [sym_string] = STATE(2231),
    [sym__single_quoted_string] = STATE(2355),
    [sym__double_quoted_string] = STATE(2354),
    [sym_na] = STATE(1029),
    [sym__expression] = STATE(1029),
    [sym__string_or_identifier] = STATE(5156),
    [sym__open_parenthesis] = STATE(190),
    [sym__open_brace] = STATE(94),
    [aux_sym_function_definition_repeat1] = STATE(2465),
    [ts_builtin_sym_end] = ACTIONS(453),
    [sym_identifier] = ACTIONS(1337),
    [anon_sym_BSLASH] = ACTIONS(1339),
    [anon_sym_function] = ACTIONS(1341),
    [anon_sym_EQ] = ACTIONS(455),
    [anon_sym_if] = ACTIONS(1343),
    [anon_sym_for] = ACTIONS(1345),
    [anon_sym_while] = ACTIONS(1347),
    [anon_sym_repeat] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_BANG] = ACTIONS(1355),
    [anon_sym_PLUS] = ACTIONS(1357),
    [anon_sym_DASH] = ACTIONS(1359),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [anon_sym_LT_LT_DASH] = ACTIONS(453),
    [anon_sym_COLON_EQ] = ACTIONS(453),
    [anon_sym_DASH_GT] = ACTIONS(455),
    [anon_sym_DASH_GT_GT] = ACTIONS(453),
    [anon_sym_PIPE] = ACTIONS(455),
    [anon_sym_AMP] = ACTIONS(455),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(455),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_GT] = ACTIONS(455),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(453),
    [anon_sym_STAR] = ACTIONS(455),
    [anon_sym_SLASH] = ACTIONS(453),
    [anon_sym_STAR_STAR] = ACTIONS(453),
    [anon_sym_CARET] = ACTIONS(453),
    [aux_sym_binary_operator_token1] = ACTIONS(453),
    [anon_sym_PIPE_GT] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(455),
    [anon_sym_DOLLAR] = ACTIONS(453),
    [anon_sym_AT] = ACTIONS(453),
    [aux_sym__hex_literal_token1] = ACTIONS(1361),
    [sym__number_literal] = ACTIONS(1363),
    [anon_sym_SQUOTE] = ACTIONS(1365),
    [anon_sym_DQUOTE] = ACTIONS(1367),
    [sym_return] = ACTIONS(2806),
    [sym_next] = ACTIONS(2806),
    [sym_break] = ACTIONS(2806),
    [sym_true] = ACTIONS(2806),
    [sym_false] = ACTIONS(2806),
    [sym_null] = ACTIONS(2806),
    [sym_inf] = ACTIONS(2806),
    [sym_nan] = ACTIONS(2806),
    [anon_sym_NA] = ACTIONS(1371),
    [anon_sym_NA_integer_] = ACTIONS(1371),
    [anon_sym_NA_real_] = ACTIONS(1371),
    [anon_sym_NA_complex_] = ACTIONS(1371),
    [anon_sym_NA_character_] = ACTIONS(1371),
    [sym_dots] = ACTIONS(2806),
    [sym_dot_dot_i] = ACTIONS(2808),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(453),
    [sym__semicolon] = ACTIONS(453),
    [sym__raw_string_literal] = ACTIONS(1377),
    [sym__external_else] = ACTIONS(453),
    [sym__external_open_parenthesis] = ACTIONS(1379),
    [sym__external_close_parenthesis] = ACTIONS(453),
    [sym__external_open_brace] = ACTIONS(1383),
    [sym__external_open_bracket] = ACTIONS(453),
    [sym__external_open_bracket2] = ACTIONS(453),
  },
  [241] = {
    [sym_function_definition] = STATE(1026),
    [sym_if_statement] = STATE(1026),
    [sym_for_statement] = STATE(1026),
    [sym_while_statement] = STATE(1026),
    [sym_repeat_statement] = STATE(1026),
    [sym_braced_expression] = STATE(1026),
    [sym_parenthesized_expression] = STATE(1026),
    [sym_call] = STATE(1026),
    [sym_subset] = STATE(1026),
    [sym_subset2] = STATE(1026),
    [sym_unary_operator] = STATE(1026),
    [sym_binary_operator] = STATE(1026),
    [sym_extract_operator] = STATE(1026),
    [sym_namespace_operator] = STATE(1026),
    [sym_integer] = STATE(1026),
    [sym_complex] = STATE(1026),
    [sym_float] = STATE(1026),
    [sym__hex_literal] = STATE(2356),
    [sym__float_literal] = STATE(2356),
    [sym_string] = STATE(2231),
    [sym__single_quoted_string] = STATE(2355),
    [sym__double_quoted_string] = STATE(2354),
    [sym_na] = STATE(1026),
    [sym__expression] = STATE(1026),
    [sym__string_or_identifier] = STATE(5156),
    [sym__open_parenthesis] = STATE(190),
    [sym__open_brace] = STATE(94),
    [aux_sym_function_definition_repeat1] = STATE(2465),
    [ts_builtin_sym_end] = ACTIONS(397),
    [sym_identifier] = ACTIONS(1337),
    [anon_sym_BSLASH] = ACTIONS(1339),
    [anon_sym_function] = ACTIONS(1341),
    [anon_sym_EQ] = ACTIONS(399),
    [anon_sym_if] = ACTIONS(1343),
    [anon_sym_for] = ACTIONS(1345),
    [anon_sym_while] = ACTIONS(1347),
    [anon_sym_repeat] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_BANG] = ACTIONS(1355),
    [anon_sym_PLUS] = ACTIONS(1357),
    [anon_sym_DASH] = ACTIONS(1359),
    [anon_sym_LT_DASH] = ACTIONS(397),
    [anon_sym_LT_LT_DASH] = ACTIONS(397),
    [anon_sym_COLON_EQ] = ACTIONS(397),
    [anon_sym_DASH_GT] = ACTIONS(399),
    [anon_sym_DASH_GT_GT] = ACTIONS(397),
    [anon_sym_PIPE] = ACTIONS(399),
    [anon_sym_AMP] = ACTIONS(399),
    [anon_sym_PIPE_PIPE] = ACTIONS(397),
    [anon_sym_AMP_AMP] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(399),
    [anon_sym_LT_EQ] = ACTIONS(397),
    [anon_sym_GT] = ACTIONS(399),
    [anon_sym_GT_EQ] = ACTIONS(397),
    [anon_sym_EQ_EQ] = ACTIONS(397),
    [anon_sym_BANG_EQ] = ACTIONS(397),
    [anon_sym_STAR] = ACTIONS(399),
    [anon_sym_SLASH] = ACTIONS(397),
    [anon_sym_STAR_STAR] = ACTIONS(397),
    [anon_sym_CARET] = ACTIONS(397),
    [aux_sym_binary_operator_token1] = ACTIONS(397),
    [anon_sym_PIPE_GT] = ACTIONS(397),
    [anon_sym_COLON] = ACTIONS(399),
    [anon_sym_DOLLAR] = ACTIONS(397),
    [anon_sym_AT] = ACTIONS(397),
    [aux_sym__hex_literal_token1] = ACTIONS(1361),
    [sym__number_literal] = ACTIONS(1363),
    [anon_sym_SQUOTE] = ACTIONS(1365),
    [anon_sym_DQUOTE] = ACTIONS(1367),
    [sym_return] = ACTIONS(2810),
    [sym_next] = ACTIONS(2810),
    [sym_break] = ACTIONS(2810),
    [sym_true] = ACTIONS(2810),
    [sym_false] = ACTIONS(2810),
    [sym_null] = ACTIONS(2810),
    [sym_inf] = ACTIONS(2810),
    [sym_nan] = ACTIONS(2810),
    [anon_sym_NA] = ACTIONS(1371),
    [anon_sym_NA_integer_] = ACTIONS(1371),
    [anon_sym_NA_real_] = ACTIONS(1371),
    [anon_sym_NA_complex_] = ACTIONS(1371),
    [anon_sym_NA_character_] = ACTIONS(1371),
    [sym_dots] = ACTIONS(2810),
    [sym_dot_dot_i] = ACTIONS(2812),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(397),
    [sym__semicolon] = ACTIONS(397),
    [sym__raw_string_literal] = ACTIONS(1377),
    [sym__external_else] = ACTIONS(397),
    [sym__external_open_parenthesis] = ACTIONS(1379),
    [sym__external_close_parenthesis] = ACTIONS(397),
    [sym__external_open_brace] = ACTIONS(1383),
    [sym__external_open_bracket] = ACTIONS(397),
    [sym__external_open_bracket2] = ACTIONS(397),
  },
  [242] = {
    [sym_function_definition] = STATE(1025),
    [sym_if_statement] = STATE(1025),
    [sym_for_statement] = STATE(1025),
    [sym_while_statement] = STATE(1025),
    [sym_repeat_statement] = STATE(1025),
    [sym_braced_expression] = STATE(1025),
    [sym_parenthesized_expression] = STATE(1025),
    [sym_call] = STATE(1025),
    [sym_subset] = STATE(1025),
    [sym_subset2] = STATE(1025),
    [sym_unary_operator] = STATE(1025),
    [sym_binary_operator] = STATE(1025),
    [sym_extract_operator] = STATE(1025),
    [sym_namespace_operator] = STATE(1025),
    [sym_integer] = STATE(1025),
    [sym_complex] = STATE(1025),
    [sym_float] = STATE(1025),
    [sym__hex_literal] = STATE(2356),
    [sym__float_literal] = STATE(2356),
    [sym_string] = STATE(2231),
    [sym__single_quoted_string] = STATE(2355),
    [sym__double_quoted_string] = STATE(2354),
    [sym_na] = STATE(1025),
    [sym__expression] = STATE(1025),
    [sym__string_or_identifier] = STATE(5156),
    [sym__open_parenthesis] = STATE(190),
    [sym__open_brace] = STATE(94),
    [aux_sym_function_definition_repeat1] = STATE(240),
    [ts_builtin_sym_end] = ACTIONS(387),
    [sym_identifier] = ACTIONS(1337),
    [anon_sym_BSLASH] = ACTIONS(1339),
    [anon_sym_function] = ACTIONS(1341),
    [anon_sym_EQ] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(1343),
    [anon_sym_for] = ACTIONS(1345),
    [anon_sym_while] = ACTIONS(1347),
    [anon_sym_repeat] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_BANG] = ACTIONS(1355),
    [anon_sym_PLUS] = ACTIONS(1357),
    [anon_sym_DASH] = ACTIONS(1359),
    [anon_sym_LT_DASH] = ACTIONS(387),
    [anon_sym_LT_LT_DASH] = ACTIONS(387),
    [anon_sym_COLON_EQ] = ACTIONS(387),
    [anon_sym_DASH_GT] = ACTIONS(389),
    [anon_sym_DASH_GT_GT] = ACTIONS(387),
    [anon_sym_PIPE] = ACTIONS(389),
    [anon_sym_AMP] = ACTIONS(389),
    [anon_sym_PIPE_PIPE] = ACTIONS(387),
    [anon_sym_AMP_AMP] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(389),
    [anon_sym_LT_EQ] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(389),
    [anon_sym_GT_EQ] = ACTIONS(387),
    [anon_sym_EQ_EQ] = ACTIONS(387),
    [anon_sym_BANG_EQ] = ACTIONS(387),
    [anon_sym_STAR] = ACTIONS(389),
    [anon_sym_SLASH] = ACTIONS(387),
    [anon_sym_STAR_STAR] = ACTIONS(387),
    [anon_sym_CARET] = ACTIONS(387),
    [aux_sym_binary_operator_token1] = ACTIONS(387),
    [anon_sym_PIPE_GT] = ACTIONS(387),
    [anon_sym_COLON] = ACTIONS(389),
    [anon_sym_DOLLAR] = ACTIONS(387),
    [anon_sym_AT] = ACTIONS(387),
    [aux_sym__hex_literal_token1] = ACTIONS(1361),
    [sym__number_literal] = ACTIONS(1363),
    [anon_sym_SQUOTE] = ACTIONS(1365),
    [anon_sym_DQUOTE] = ACTIONS(1367),
    [sym_return] = ACTIONS(2814),
    [sym_next] = ACTIONS(2814),
    [sym_break] = ACTIONS(2814),
    [sym_true] = ACTIONS(2814),
    [sym_false] = ACTIONS(2814),
    [sym_null] = ACTIONS(2814),
    [sym_inf] = ACTIONS(2814),
    [sym_nan] = ACTIONS(2814),
    [anon_sym_NA] = ACTIONS(1371),
    [anon_sym_NA_integer_] = ACTIONS(1371),
    [anon_sym_NA_real_] = ACTIONS(1371),
    [anon_sym_NA_complex_] = ACTIONS(1371),
    [anon_sym_NA_character_] = ACTIONS(1371),
    [sym_dots] = ACTIONS(2814),
    [sym_dot_dot_i] = ACTIONS(2816),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(2818),
    [sym__semicolon] = ACTIONS(387),
    [sym__raw_string_literal] = ACTIONS(1377),
    [sym__external_else] = ACTIONS(387),
    [sym__external_open_parenthesis] = ACTIONS(1379),
    [sym__external_close_parenthesis] = ACTIONS(387),
    [sym__external_open_brace] = ACTIONS(1383),
    [sym__external_open_bracket] = ACTIONS(387),
    [sym__external_open_bracket2] = ACTIONS(387),
  },
  [243] = {
    [sym_function_definition] = STATE(1023),
    [sym_if_statement] = STATE(1023),
    [sym_for_statement] = STATE(1023),
    [sym_while_statement] = STATE(1023),
    [sym_repeat_statement] = STATE(1023),
    [sym_braced_expression] = STATE(1023),
    [sym_parenthesized_expression] = STATE(1023),
    [sym_call] = STATE(1023),
    [sym_subset] = STATE(1023),
    [sym_subset2] = STATE(1023),
    [sym_unary_operator] = STATE(1023),
    [sym_binary_operator] = STATE(1023),
    [sym_extract_operator] = STATE(1023),
    [sym_namespace_operator] = STATE(1023),
    [sym_integer] = STATE(1023),
    [sym_complex] = STATE(1023),
    [sym_float] = STATE(1023),
    [sym__hex_literal] = STATE(2356),
    [sym__float_literal] = STATE(2356),
    [sym_string] = STATE(2231),
    [sym__single_quoted_string] = STATE(2355),
    [sym__double_quoted_string] = STATE(2354),
    [sym_na] = STATE(1023),
    [sym__expression] = STATE(1023),
    [sym__string_or_identifier] = STATE(5156),
    [sym__open_parenthesis] = STATE(190),
    [sym__open_brace] = STATE(94),
    [aux_sym_function_definition_repeat1] = STATE(241),
    [ts_builtin_sym_end] = ACTIONS(377),
    [sym_identifier] = ACTIONS(1337),
    [anon_sym_BSLASH] = ACTIONS(1339),
    [anon_sym_function] = ACTIONS(1341),
    [anon_sym_EQ] = ACTIONS(379),
    [anon_sym_if] = ACTIONS(1343),
    [anon_sym_for] = ACTIONS(1345),
    [anon_sym_while] = ACTIONS(1347),
    [anon_sym_repeat] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_BANG] = ACTIONS(1355),
    [anon_sym_PLUS] = ACTIONS(1357),
    [anon_sym_DASH] = ACTIONS(1359),
    [anon_sym_LT_DASH] = ACTIONS(377),
    [anon_sym_LT_LT_DASH] = ACTIONS(377),
    [anon_sym_COLON_EQ] = ACTIONS(377),
    [anon_sym_DASH_GT] = ACTIONS(379),
    [anon_sym_DASH_GT_GT] = ACTIONS(377),
    [anon_sym_PIPE] = ACTIONS(379),
    [anon_sym_AMP] = ACTIONS(379),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_LT] = ACTIONS(379),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(379),
    [anon_sym_GT_EQ] = ACTIONS(377),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(379),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_STAR_STAR] = ACTIONS(377),
    [anon_sym_CARET] = ACTIONS(377),
    [aux_sym_binary_operator_token1] = ACTIONS(377),
    [anon_sym_PIPE_GT] = ACTIONS(377),
    [anon_sym_COLON] = ACTIONS(379),
    [anon_sym_DOLLAR] = ACTIONS(377),
    [anon_sym_AT] = ACTIONS(377),
    [aux_sym__hex_literal_token1] = ACTIONS(1361),
    [sym__number_literal] = ACTIONS(1363),
    [anon_sym_SQUOTE] = ACTIONS(1365),
    [anon_sym_DQUOTE] = ACTIONS(1367),
    [sym_return] = ACTIONS(2820),
    [sym_next] = ACTIONS(2820),
    [sym_break] = ACTIONS(2820),
    [sym_true] = ACTIONS(2820),
    [sym_false] = ACTIONS(2820),
    [sym_null] = ACTIONS(2820),
    [sym_inf] = ACTIONS(2820),
    [sym_nan] = ACTIONS(2820),
    [anon_sym_NA] = ACTIONS(1371),
    [anon_sym_NA_integer_] = ACTIONS(1371),
    [anon_sym_NA_real_] = ACTIONS(1371),
    [anon_sym_NA_complex_] = ACTIONS(1371),
    [anon_sym_NA_character_] = ACTIONS(1371),
    [sym_dots] = ACTIONS(2820),
    [sym_dot_dot_i] = ACTIONS(2822),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(2824),
    [sym__semicolon] = ACTIONS(377),
    [sym__raw_string_literal] = ACTIONS(1377),
    [sym__external_else] = ACTIONS(377),
    [sym__external_open_parenthesis] = ACTIONS(1379),
    [sym__external_close_parenthesis] = ACTIONS(377),
    [sym__external_open_brace] = ACTIONS(1383),
    [sym__external_open_bracket] = ACTIONS(377),
    [sym__external_open_bracket2] = ACTIONS(377),
  },
  [244] = {
    [sym_function_definition] = STATE(1445),
    [sym_if_statement] = STATE(1445),
    [sym_for_statement] = STATE(1445),
    [sym_while_statement] = STATE(1445),
    [sym_repeat_statement] = STATE(1445),
    [sym_braced_expression] = STATE(1445),
    [sym_parenthesized_expression] = STATE(1445),
    [sym_call] = STATE(1445),
    [sym_subset] = STATE(1445),
    [sym_subset2] = STATE(1445),
    [sym_unary_operator] = STATE(1445),
    [sym_binary_operator] = STATE(1445),
    [sym_extract_operator] = STATE(1445),
    [sym_namespace_operator] = STATE(1445),
    [sym_integer] = STATE(1445),
    [sym_complex] = STATE(1445),
    [sym_float] = STATE(1445),
    [sym__hex_literal] = STATE(2523),
    [sym__float_literal] = STATE(2523),
    [sym_string] = STATE(2522),
    [sym__single_quoted_string] = STATE(2528),
    [sym__double_quoted_string] = STATE(2529),
    [sym_na] = STATE(1445),
    [sym__expression] = STATE(1445),
    [sym__string_or_identifier] = STATE(5126),
    [sym__open_parenthesis] = STATE(178),
    [sym__open_brace] = STATE(244),
    [sym__close_brace] = STATE(2805),
    [aux_sym_braced_expression_repeat1] = STATE(282),
    [ts_builtin_sym_end] = ACTIONS(155),
    [sym_identifier] = ACTIONS(2826),
    [anon_sym_BSLASH] = ACTIONS(2828),
    [anon_sym_function] = ACTIONS(2830),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(2832),
    [anon_sym_for] = ACTIONS(2834),
    [anon_sym_while] = ACTIONS(2836),
    [anon_sym_repeat] = ACTIONS(2838),
    [anon_sym_QMARK] = ACTIONS(2840),
    [anon_sym_TILDE] = ACTIONS(2842),
    [anon_sym_BANG] = ACTIONS(2844),
    [anon_sym_PLUS] = ACTIONS(2846),
    [anon_sym_DASH] = ACTIONS(2848),
    [anon_sym_LT_DASH] = ACTIONS(155),
    [anon_sym_LT_LT_DASH] = ACTIONS(155),
    [anon_sym_COLON_EQ] = ACTIONS(155),
    [anon_sym_DASH_GT] = ACTIONS(157),
    [anon_sym_DASH_GT_GT] = ACTIONS(155),
    [anon_sym_PIPE] = ACTIONS(157),
    [anon_sym_AMP] = ACTIONS(157),
    [anon_sym_PIPE_PIPE] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(157),
    [anon_sym_LT_EQ] = ACTIONS(155),
    [anon_sym_GT] = ACTIONS(157),
    [anon_sym_GT_EQ] = ACTIONS(155),
    [anon_sym_EQ_EQ] = ACTIONS(155),
    [anon_sym_BANG_EQ] = ACTIONS(155),
    [anon_sym_STAR] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(155),
    [anon_sym_STAR_STAR] = ACTIONS(155),
    [anon_sym_CARET] = ACTIONS(155),
    [aux_sym_binary_operator_token1] = ACTIONS(155),
    [anon_sym_PIPE_GT] = ACTIONS(155),
    [anon_sym_COLON] = ACTIONS(157),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(155),
    [aux_sym__hex_literal_token1] = ACTIONS(2850),
    [sym__number_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE] = ACTIONS(2856),
    [sym_return] = ACTIONS(2858),
    [sym_next] = ACTIONS(2858),
    [sym_break] = ACTIONS(2858),
    [sym_true] = ACTIONS(2858),
    [sym_false] = ACTIONS(2858),
    [sym_null] = ACTIONS(2858),
    [sym_inf] = ACTIONS(2858),
    [sym_nan] = ACTIONS(2858),
    [anon_sym_NA] = ACTIONS(2860),
    [anon_sym_NA_integer_] = ACTIONS(2860),
    [anon_sym_NA_real_] = ACTIONS(2860),
    [anon_sym_NA_complex_] = ACTIONS(2860),
    [anon_sym_NA_character_] = ACTIONS(2860),
    [sym_dots] = ACTIONS(2858),
    [sym_dot_dot_i] = ACTIONS(2862),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(2864),
    [sym__semicolon] = ACTIONS(2864),
    [sym__raw_string_literal] = ACTIONS(2866),
    [sym__external_open_parenthesis] = ACTIONS(2868),
    [sym__external_open_brace] = ACTIONS(2870),
    [sym__external_close_brace] = ACTIONS(2872),
    [sym__external_open_bracket] = ACTIONS(155),
    [sym__external_open_bracket2] = ACTIONS(155),
  },
  [245] = {
    [sym_function_definition] = STATE(1219),
    [sym_if_statement] = STATE(1219),
    [sym_for_statement] = STATE(1219),
    [sym_while_statement] = STATE(1219),
    [sym_repeat_statement] = STATE(1219),
    [sym_braced_expression] = STATE(1219),
    [sym_parenthesized_expression] = STATE(1219),
    [sym_call] = STATE(1219),
    [sym_subset] = STATE(1219),
    [sym_subset2] = STATE(1219),
    [sym_unary_operator] = STATE(1219),
    [sym_binary_operator] = STATE(1219),
    [sym_extract_operator] = STATE(1219),
    [sym_namespace_operator] = STATE(1219),
    [sym_integer] = STATE(1219),
    [sym_complex] = STATE(1219),
    [sym_float] = STATE(1219),
    [sym__hex_literal] = STATE(2356),
    [sym__float_literal] = STATE(2356),
    [sym_string] = STATE(2231),
    [sym__single_quoted_string] = STATE(2355),
    [sym__double_quoted_string] = STATE(2354),
    [sym_na] = STATE(1219),
    [sym__expression] = STATE(1219),
    [sym__string_or_identifier] = STATE(5156),
    [sym__open_parenthesis] = STATE(190),
    [sym__open_brace] = STATE(94),
    [aux_sym_parenthesized_expression_repeat1] = STATE(245),
    [ts_builtin_sym_end] = ACTIONS(803),
    [sym_identifier] = ACTIONS(2874),
    [anon_sym_BSLASH] = ACTIONS(2877),
    [anon_sym_function] = ACTIONS(2880),
    [anon_sym_EQ] = ACTIONS(814),
    [anon_sym_if] = ACTIONS(2883),
    [anon_sym_for] = ACTIONS(2886),
    [anon_sym_while] = ACTIONS(2889),
    [anon_sym_repeat] = ACTIONS(2892),
    [anon_sym_QMARK] = ACTIONS(2895),
    [anon_sym_TILDE] = ACTIONS(2898),
    [anon_sym_BANG] = ACTIONS(2901),
    [anon_sym_PLUS] = ACTIONS(2904),
    [anon_sym_DASH] = ACTIONS(2907),
    [anon_sym_LT_DASH] = ACTIONS(803),
    [anon_sym_LT_LT_DASH] = ACTIONS(803),
    [anon_sym_COLON_EQ] = ACTIONS(803),
    [anon_sym_DASH_GT] = ACTIONS(814),
    [anon_sym_DASH_GT_GT] = ACTIONS(803),
    [anon_sym_PIPE] = ACTIONS(814),
    [anon_sym_AMP] = ACTIONS(814),
    [anon_sym_PIPE_PIPE] = ACTIONS(803),
    [anon_sym_AMP_AMP] = ACTIONS(803),
    [anon_sym_LT] = ACTIONS(814),
    [anon_sym_LT_EQ] = ACTIONS(803),
    [anon_sym_GT] = ACTIONS(814),
    [anon_sym_GT_EQ] = ACTIONS(803),
    [anon_sym_EQ_EQ] = ACTIONS(803),
    [anon_sym_BANG_EQ] = ACTIONS(803),
    [anon_sym_STAR] = ACTIONS(814),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_STAR_STAR] = ACTIONS(803),
    [anon_sym_CARET] = ACTIONS(803),
    [aux_sym_binary_operator_token1] = ACTIONS(803),
    [anon_sym_PIPE_GT] = ACTIONS(803),
    [anon_sym_COLON] = ACTIONS(814),
    [anon_sym_DOLLAR] = ACTIONS(803),
    [anon_sym_AT] = ACTIONS(803),
    [aux_sym__hex_literal_token1] = ACTIONS(2910),
    [sym__number_literal] = ACTIONS(2913),
    [anon_sym_SQUOTE] = ACTIONS(2916),
    [anon_sym_DQUOTE] = ACTIONS(2919),
    [sym_return] = ACTIONS(2922),
    [sym_next] = ACTIONS(2922),
    [sym_break] = ACTIONS(2922),
    [sym_true] = ACTIONS(2922),
    [sym_false] = ACTIONS(2922),
    [sym_null] = ACTIONS(2922),
    [sym_inf] = ACTIONS(2922),
    [sym_nan] = ACTIONS(2922),
    [anon_sym_NA] = ACTIONS(2925),
    [anon_sym_NA_integer_] = ACTIONS(2925),
    [anon_sym_NA_real_] = ACTIONS(2925),
    [anon_sym_NA_complex_] = ACTIONS(2925),
    [anon_sym_NA_character_] = ACTIONS(2925),
    [sym_dots] = ACTIONS(2922),
    [sym_dot_dot_i] = ACTIONS(2928),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(2931),
    [sym__semicolon] = ACTIONS(803),
    [sym__raw_string_literal] = ACTIONS(2934),
    [sym__external_else] = ACTIONS(803),
    [sym__external_open_parenthesis] = ACTIONS(2937),
    [sym__external_close_parenthesis] = ACTIONS(803),
    [sym__external_open_brace] = ACTIONS(2940),
    [sym__external_open_bracket] = ACTIONS(803),
    [sym__external_open_bracket2] = ACTIONS(803),
  },
  [246] = {
    [sym_function_definition] = STATE(1354),
    [sym_if_statement] = STATE(1354),
    [sym_for_statement] = STATE(1354),
    [sym_while_statement] = STATE(1354),
    [sym_repeat_statement] = STATE(1354),
    [sym_braced_expression] = STATE(1354),
    [sym_parenthesized_expression] = STATE(1354),
    [sym_call] = STATE(1354),
    [sym_subset] = STATE(1354),
    [sym_subset2] = STATE(1354),
    [sym_unary_operator] = STATE(1354),
    [sym_binary_operator] = STATE(1354),
    [sym_extract_operator] = STATE(1354),
    [sym_namespace_operator] = STATE(1354),
    [sym_integer] = STATE(1354),
    [sym_complex] = STATE(1354),
    [sym_float] = STATE(1354),
    [sym__hex_literal] = STATE(2540),
    [sym__float_literal] = STATE(2540),
    [sym_string] = STATE(2541),
    [sym__single_quoted_string] = STATE(2462),
    [sym__double_quoted_string] = STATE(2494),
    [sym_na] = STATE(1354),
    [sym__expression] = STATE(1354),
    [sym__string_or_identifier] = STATE(5128),
    [sym__open_parenthesis] = STATE(246),
    [sym__close_parenthesis] = STATE(2790),
    [sym__open_brace] = STATE(173),
    [aux_sym_parenthesized_expression_repeat1] = STATE(270),
    [ts_builtin_sym_end] = ACTIONS(129),
    [sym_identifier] = ACTIONS(2943),
    [anon_sym_BSLASH] = ACTIONS(2945),
    [anon_sym_function] = ACTIONS(2947),
    [anon_sym_EQ] = ACTIONS(109),
    [anon_sym_if] = ACTIONS(2949),
    [anon_sym_for] = ACTIONS(2951),
    [anon_sym_while] = ACTIONS(2953),
    [anon_sym_repeat] = ACTIONS(2955),
    [anon_sym_QMARK] = ACTIONS(2957),
    [anon_sym_TILDE] = ACTIONS(2959),
    [anon_sym_BANG] = ACTIONS(2961),
    [anon_sym_PLUS] = ACTIONS(2963),
    [anon_sym_DASH] = ACTIONS(2965),
    [anon_sym_LT_DASH] = ACTIONS(129),
    [anon_sym_LT_LT_DASH] = ACTIONS(129),
    [anon_sym_COLON_EQ] = ACTIONS(129),
    [anon_sym_DASH_GT] = ACTIONS(109),
    [anon_sym_DASH_GT_GT] = ACTIONS(129),
    [anon_sym_PIPE] = ACTIONS(109),
    [anon_sym_AMP] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_STAR_STAR] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [aux_sym_binary_operator_token1] = ACTIONS(129),
    [anon_sym_PIPE_GT] = ACTIONS(129),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(129),
    [anon_sym_AT] = ACTIONS(129),
    [aux_sym__hex_literal_token1] = ACTIONS(2967),
    [sym__number_literal] = ACTIONS(2969),
    [anon_sym_SQUOTE] = ACTIONS(2971),
    [anon_sym_DQUOTE] = ACTIONS(2973),
    [sym_return] = ACTIONS(2975),
    [sym_next] = ACTIONS(2975),
    [sym_break] = ACTIONS(2975),
    [sym_true] = ACTIONS(2975),
    [sym_false] = ACTIONS(2975),
    [sym_null] = ACTIONS(2975),
    [sym_inf] = ACTIONS(2975),
    [sym_nan] = ACTIONS(2975),
    [anon_sym_NA] = ACTIONS(2977),
    [anon_sym_NA_integer_] = ACTIONS(2977),
    [anon_sym_NA_real_] = ACTIONS(2977),
    [anon_sym_NA_complex_] = ACTIONS(2977),
    [anon_sym_NA_character_] = ACTIONS(2977),
    [sym_dots] = ACTIONS(2975),
    [sym_dot_dot_i] = ACTIONS(2979),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(2981),
    [sym__semicolon] = ACTIONS(129),
    [sym__raw_string_literal] = ACTIONS(2983),
    [sym__external_open_parenthesis] = ACTIONS(2985),
    [sym__external_close_parenthesis] = ACTIONS(2987),
    [sym__external_open_brace] = ACTIONS(2989),
    [sym__external_open_bracket] = ACTIONS(129),
    [sym__external_open_bracket2] = ACTIONS(129),
  },
  [247] = {
    [sym_function_definition] = STATE(1068),
    [sym_if_statement] = STATE(1068),
    [sym_for_statement] = STATE(1068),
    [sym_while_statement] = STATE(1068),
    [sym_repeat_statement] = STATE(1068),
    [sym_braced_expression] = STATE(1068),
    [sym_parenthesized_expression] = STATE(1068),
    [sym_call] = STATE(1068),
    [sym_subset] = STATE(1068),
    [sym_subset2] = STATE(1068),
    [sym_unary_operator] = STATE(1068),
    [sym_binary_operator] = STATE(1068),
    [sym_extract_operator] = STATE(1068),
    [sym_namespace_operator] = STATE(1068),
    [sym_integer] = STATE(1068),
    [sym_complex] = STATE(1068),
    [sym_float] = STATE(1068),
    [sym__hex_literal] = STATE(2235),
    [sym__float_literal] = STATE(2235),
    [sym_string] = STATE(2234),
    [sym__single_quoted_string] = STATE(2236),
    [sym__double_quoted_string] = STATE(2237),
    [sym_na] = STATE(1068),
    [sym__expression] = STATE(1068),
    [sym__string_or_identifier] = STATE(5150),
    [sym__open_parenthesis] = STATE(76),
    [sym__open_brace] = STATE(188),
    [aux_sym_function_definition_repeat1] = STATE(2400),
    [sym_identifier] = ACTIONS(1433),
    [anon_sym_BSLASH] = ACTIONS(1435),
    [anon_sym_function] = ACTIONS(1437),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_if] = ACTIONS(1439),
    [anon_sym_for] = ACTIONS(1441),
    [anon_sym_while] = ACTIONS(1443),
    [anon_sym_repeat] = ACTIONS(1445),
    [anon_sym_QMARK] = ACTIONS(1447),
    [anon_sym_TILDE] = ACTIONS(1449),
    [anon_sym_BANG] = ACTIONS(1451),
    [anon_sym_PLUS] = ACTIONS(1453),
    [anon_sym_DASH] = ACTIONS(1455),
    [anon_sym_LT_DASH] = ACTIONS(471),
    [anon_sym_LT_LT_DASH] = ACTIONS(471),
    [anon_sym_COLON_EQ] = ACTIONS(471),
    [anon_sym_DASH_GT] = ACTIONS(473),
    [anon_sym_DASH_GT_GT] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(473),
    [anon_sym_AMP] = ACTIONS(473),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_LT_EQ] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(473),
    [anon_sym_GT_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_STAR] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [aux_sym_binary_operator_token1] = ACTIONS(471),
    [anon_sym_PIPE_GT] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(473),
    [anon_sym_DOLLAR] = ACTIONS(471),
    [anon_sym_AT] = ACTIONS(471),
    [aux_sym__hex_literal_token1] = ACTIONS(1457),
    [sym__number_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [anon_sym_DQUOTE] = ACTIONS(1463),
    [sym_return] = ACTIONS(2991),
    [sym_next] = ACTIONS(2991),
    [sym_break] = ACTIONS(2991),
    [sym_true] = ACTIONS(2991),
    [sym_false] = ACTIONS(2991),
    [sym_null] = ACTIONS(2991),
    [sym_inf] = ACTIONS(2991),
    [sym_nan] = ACTIONS(2991),
    [anon_sym_NA] = ACTIONS(1467),
    [anon_sym_NA_integer_] = ACTIONS(1467),
    [anon_sym_NA_real_] = ACTIONS(1467),
    [anon_sym_NA_complex_] = ACTIONS(1467),
    [anon_sym_NA_character_] = ACTIONS(1467),
    [sym_dots] = ACTIONS(2991),
    [sym_dot_dot_i] = ACTIONS(2993),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(471),
    [sym__newline] = ACTIONS(471),
    [sym__semicolon] = ACTIONS(471),
    [sym__raw_string_literal] = ACTIONS(1473),
    [sym__external_open_parenthesis] = ACTIONS(1475),
    [sym__external_open_brace] = ACTIONS(1477),
    [sym__external_close_brace] = ACTIONS(471),
    [sym__external_open_bracket] = ACTIONS(471),
    [sym__external_open_bracket2] = ACTIONS(471),
    [sym__external_close_bracket2] = ACTIONS(471),
  },
  [248] = {
    [sym_function_definition] = STATE(1086),
    [sym_if_statement] = STATE(1086),
    [sym_for_statement] = STATE(1086),
    [sym_while_statement] = STATE(1086),
    [sym_repeat_statement] = STATE(1086),
    [sym_braced_expression] = STATE(1086),
    [sym_parenthesized_expression] = STATE(1086),
    [sym_call] = STATE(1086),
    [sym_subset] = STATE(1086),
    [sym_subset2] = STATE(1086),
    [sym_unary_operator] = STATE(1086),
    [sym_binary_operator] = STATE(1086),
    [sym_extract_operator] = STATE(1086),
    [sym_namespace_operator] = STATE(1086),
    [sym_integer] = STATE(1086),
    [sym_complex] = STATE(1086),
    [sym_float] = STATE(1086),
    [sym__hex_literal] = STATE(2235),
    [sym__float_literal] = STATE(2235),
    [sym_string] = STATE(2234),
    [sym__single_quoted_string] = STATE(2236),
    [sym__double_quoted_string] = STATE(2237),
    [sym_na] = STATE(1086),
    [sym__expression] = STATE(1086),
    [sym__string_or_identifier] = STATE(5150),
    [sym__open_parenthesis] = STATE(76),
    [sym__open_brace] = STATE(188),
    [aux_sym_function_definition_repeat1] = STATE(2400),
    [sym_identifier] = ACTIONS(1433),
    [anon_sym_BSLASH] = ACTIONS(1435),
    [anon_sym_function] = ACTIONS(1437),
    [anon_sym_EQ] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(1439),
    [anon_sym_for] = ACTIONS(1441),
    [anon_sym_while] = ACTIONS(1443),
    [anon_sym_repeat] = ACTIONS(1445),
    [anon_sym_QMARK] = ACTIONS(1447),
    [anon_sym_TILDE] = ACTIONS(1449),
    [anon_sym_BANG] = ACTIONS(1451),
    [anon_sym_PLUS] = ACTIONS(1453),
    [anon_sym_DASH] = ACTIONS(1455),
    [anon_sym_LT_DASH] = ACTIONS(369),
    [anon_sym_LT_LT_DASH] = ACTIONS(369),
    [anon_sym_COLON_EQ] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(371),
    [anon_sym_DASH_GT_GT] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(371),
    [anon_sym_AMP] = ACTIONS(371),
    [anon_sym_PIPE_PIPE] = ACTIONS(369),
    [anon_sym_AMP_AMP] = ACTIONS(369),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_LT_EQ] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_EQ] = ACTIONS(369),
    [anon_sym_EQ_EQ] = ACTIONS(369),
    [anon_sym_BANG_EQ] = ACTIONS(369),
    [anon_sym_STAR] = ACTIONS(371),
    [anon_sym_SLASH] = ACTIONS(369),
    [anon_sym_STAR_STAR] = ACTIONS(369),
    [anon_sym_CARET] = ACTIONS(369),
    [aux_sym_binary_operator_token1] = ACTIONS(369),
    [anon_sym_PIPE_GT] = ACTIONS(369),
    [anon_sym_COLON] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(369),
    [anon_sym_AT] = ACTIONS(369),
    [aux_sym__hex_literal_token1] = ACTIONS(1457),
    [sym__number_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [anon_sym_DQUOTE] = ACTIONS(1463),
    [sym_return] = ACTIONS(2995),
    [sym_next] = ACTIONS(2995),
    [sym_break] = ACTIONS(2995),
    [sym_true] = ACTIONS(2995),
    [sym_false] = ACTIONS(2995),
    [sym_null] = ACTIONS(2995),
    [sym_inf] = ACTIONS(2995),
    [sym_nan] = ACTIONS(2995),
    [anon_sym_NA] = ACTIONS(1467),
    [anon_sym_NA_integer_] = ACTIONS(1467),
    [anon_sym_NA_real_] = ACTIONS(1467),
    [anon_sym_NA_complex_] = ACTIONS(1467),
    [anon_sym_NA_character_] = ACTIONS(1467),
    [sym_dots] = ACTIONS(2995),
    [sym_dot_dot_i] = ACTIONS(2997),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(369),
    [sym__newline] = ACTIONS(369),
    [sym__semicolon] = ACTIONS(369),
    [sym__raw_string_literal] = ACTIONS(1473),
    [sym__external_open_parenthesis] = ACTIONS(1475),
    [sym__external_open_brace] = ACTIONS(1477),
    [sym__external_close_brace] = ACTIONS(369),
    [sym__external_open_bracket] = ACTIONS(369),
    [sym__external_open_bracket2] = ACTIONS(369),
    [sym__external_close_bracket2] = ACTIONS(369),
  },
  [249] = {
    [sym_function_definition] = STATE(1095),
    [sym_if_statement] = STATE(1095),
    [sym_for_statement] = STATE(1095),
    [sym_while_statement] = STATE(1095),
    [sym_repeat_statement] = STATE(1095),
    [sym_braced_expression] = STATE(1095),
    [sym_parenthesized_expression] = STATE(1095),
    [sym_call] = STATE(1095),
    [sym_subset] = STATE(1095),
    [sym_subset2] = STATE(1095),
    [sym_unary_operator] = STATE(1095),
    [sym_binary_operator] = STATE(1095),
    [sym_extract_operator] = STATE(1095),
    [sym_namespace_operator] = STATE(1095),
    [sym_integer] = STATE(1095),
    [sym_complex] = STATE(1095),
    [sym_float] = STATE(1095),
    [sym__hex_literal] = STATE(2311),
    [sym__float_literal] = STATE(2311),
    [sym_string] = STATE(2312),
    [sym__single_quoted_string] = STATE(2310),
    [sym__double_quoted_string] = STATE(2309),
    [sym_na] = STATE(1095),
    [sym__expression] = STATE(1095),
    [sym__string_or_identifier] = STATE(5134),
    [sym__open_parenthesis] = STATE(64),
    [sym__open_brace] = STATE(199),
    [aux_sym_function_definition_repeat1] = STATE(202),
    [ts_builtin_sym_end] = ACTIONS(461),
    [sym_identifier] = ACTIONS(1385),
    [anon_sym_BSLASH] = ACTIONS(1387),
    [anon_sym_function] = ACTIONS(1389),
    [anon_sym_EQ] = ACTIONS(463),
    [anon_sym_if] = ACTIONS(1391),
    [anon_sym_for] = ACTIONS(1393),
    [anon_sym_while] = ACTIONS(1395),
    [anon_sym_repeat] = ACTIONS(1397),
    [anon_sym_QMARK] = ACTIONS(1399),
    [anon_sym_TILDE] = ACTIONS(1401),
    [anon_sym_BANG] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1407),
    [anon_sym_LT_DASH] = ACTIONS(461),
    [anon_sym_LT_LT_DASH] = ACTIONS(461),
    [anon_sym_COLON_EQ] = ACTIONS(461),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_DASH_GT_GT] = ACTIONS(461),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_PIPE_PIPE] = ACTIONS(461),
    [anon_sym_AMP_AMP] = ACTIONS(461),
    [anon_sym_LT] = ACTIONS(463),
    [anon_sym_LT_EQ] = ACTIONS(461),
    [anon_sym_GT] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(461),
    [anon_sym_EQ_EQ] = ACTIONS(461),
    [anon_sym_BANG_EQ] = ACTIONS(461),
    [anon_sym_STAR] = ACTIONS(463),
    [anon_sym_SLASH] = ACTIONS(461),
    [anon_sym_STAR_STAR] = ACTIONS(461),
    [anon_sym_CARET] = ACTIONS(461),
    [aux_sym_binary_operator_token1] = ACTIONS(461),
    [anon_sym_PIPE_GT] = ACTIONS(461),
    [anon_sym_COLON] = ACTIONS(463),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_AT] = ACTIONS(461),
    [aux_sym__hex_literal_token1] = ACTIONS(1409),
    [sym__number_literal] = ACTIONS(1411),
    [anon_sym_SQUOTE] = ACTIONS(1413),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [sym_return] = ACTIONS(2999),
    [sym_next] = ACTIONS(2999),
    [sym_break] = ACTIONS(2999),
    [sym_true] = ACTIONS(2999),
    [sym_false] = ACTIONS(2999),
    [sym_null] = ACTIONS(2999),
    [sym_inf] = ACTIONS(2999),
    [sym_nan] = ACTIONS(2999),
    [anon_sym_NA] = ACTIONS(1419),
    [anon_sym_NA_integer_] = ACTIONS(1419),
    [anon_sym_NA_real_] = ACTIONS(1419),
    [anon_sym_NA_complex_] = ACTIONS(1419),
    [anon_sym_NA_character_] = ACTIONS(1419),
    [sym_dots] = ACTIONS(2999),
    [sym_dot_dot_i] = ACTIONS(3001),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(3003),
    [sym__semicolon] = ACTIONS(461),
    [sym__raw_string_literal] = ACTIONS(1425),
    [sym__external_else] = ACTIONS(461),
    [sym__external_open_parenthesis] = ACTIONS(1427),
    [sym__external_open_brace] = ACTIONS(1429),
    [sym__external_close_brace] = ACTIONS(461),
    [sym__external_open_bracket] = ACTIONS(461),
    [sym__external_open_bracket2] = ACTIONS(461),
  },
  [250] = {
    [sym_function_definition] = STATE(980),
    [sym_if_statement] = STATE(980),
    [sym_for_statement] = STATE(980),
    [sym_while_statement] = STATE(980),
    [sym_repeat_statement] = STATE(980),
    [sym_braced_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_call] = STATE(980),
    [sym_subset] = STATE(980),
    [sym_subset2] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_binary_operator] = STATE(980),
    [sym_extract_operator] = STATE(980),
    [sym_namespace_operator] = STATE(980),
    [sym_integer] = STATE(980),
    [sym_complex] = STATE(980),
    [sym_float] = STATE(980),
    [sym__hex_literal] = STATE(2356),
    [sym__float_literal] = STATE(2356),
    [sym_string] = STATE(2231),
    [sym__single_quoted_string] = STATE(2355),
    [sym__double_quoted_string] = STATE(2354),
    [sym_na] = STATE(980),
    [sym__expression] = STATE(980),
    [sym__string_or_identifier] = STATE(5156),
    [sym__open_parenthesis] = STATE(190),
    [sym__open_brace] = STATE(94),
    [aux_sym_function_definition_repeat1] = STATE(260),
    [ts_builtin_sym_end] = ACTIONS(545),
    [sym_identifier] = ACTIONS(1337),
    [anon_sym_BSLASH] = ACTIONS(1339),
    [anon_sym_function] = ACTIONS(1341),
    [anon_sym_EQ] = ACTIONS(543),
    [anon_sym_if] = ACTIONS(1343),
    [anon_sym_for] = ACTIONS(1345),
    [anon_sym_while] = ACTIONS(1347),
    [anon_sym_repeat] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_BANG] = ACTIONS(1355),
    [anon_sym_PLUS] = ACTIONS(1357),
    [anon_sym_DASH] = ACTIONS(1359),
    [anon_sym_LT_DASH] = ACTIONS(545),
    [anon_sym_LT_LT_DASH] = ACTIONS(545),
    [anon_sym_COLON_EQ] = ACTIONS(545),
    [anon_sym_DASH_GT] = ACTIONS(543),
    [anon_sym_DASH_GT_GT] = ACTIONS(545),
    [anon_sym_PIPE] = ACTIONS(543),
    [anon_sym_AMP] = ACTIONS(543),
    [anon_sym_PIPE_PIPE] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(543),
    [anon_sym_LT_EQ] = ACTIONS(545),
    [anon_sym_GT] = ACTIONS(543),
    [anon_sym_GT_EQ] = ACTIONS(545),
    [anon_sym_EQ_EQ] = ACTIONS(545),
    [anon_sym_BANG_EQ] = ACTIONS(545),
    [anon_sym_STAR] = ACTIONS(543),
    [anon_sym_SLASH] = ACTIONS(545),
    [anon_sym_STAR_STAR] = ACTIONS(545),
    [anon_sym_CARET] = ACTIONS(545),
    [aux_sym_binary_operator_token1] = ACTIONS(545),
    [anon_sym_PIPE_GT] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(543),
    [anon_sym_DOLLAR] = ACTIONS(545),
    [anon_sym_AT] = ACTIONS(545),
    [aux_sym__hex_literal_token1] = ACTIONS(1361),
    [sym__number_literal] = ACTIONS(1363),
    [anon_sym_SQUOTE] = ACTIONS(1365),
    [anon_sym_DQUOTE] = ACTIONS(1367),
    [sym_return] = ACTIONS(3005),
    [sym_next] = ACTIONS(3005),
    [sym_break] = ACTIONS(3005),
    [sym_true] = ACTIONS(3005),
    [sym_false] = ACTIONS(3005),
    [sym_null] = ACTIONS(3005),
    [sym_inf] = ACTIONS(3005),
    [sym_nan] = ACTIONS(3005),
    [anon_sym_NA] = ACTIONS(1371),
    [anon_sym_NA_integer_] = ACTIONS(1371),
    [anon_sym_NA_real_] = ACTIONS(1371),
    [anon_sym_NA_complex_] = ACTIONS(1371),
    [anon_sym_NA_character_] = ACTIONS(1371),
    [sym_dots] = ACTIONS(3005),
    [sym_dot_dot_i] = ACTIONS(3007),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(3009),
    [sym__semicolon] = ACTIONS(545),
    [sym__raw_string_literal] = ACTIONS(1377),
    [sym__external_else] = ACTIONS(545),
    [sym__external_open_parenthesis] = ACTIONS(1379),
    [sym__external_close_parenthesis] = ACTIONS(545),
    [sym__external_open_brace] = ACTIONS(1383),
    [sym__external_open_bracket] = ACTIONS(545),
    [sym__external_open_bracket2] = ACTIONS(545),
  },
  [251] = {
    [sym_function_definition] = STATE(1021),
    [sym_if_statement] = STATE(1021),
    [sym_for_statement] = STATE(1021),
    [sym_while_statement] = STATE(1021),
    [sym_repeat_statement] = STATE(1021),
    [sym_braced_expression] = STATE(1021),
    [sym_parenthesized_expression] = STATE(1021),
    [sym_call] = STATE(1021),
    [sym_subset] = STATE(1021),
    [sym_subset2] = STATE(1021),
    [sym_unary_operator] = STATE(1021),
    [sym_binary_operator] = STATE(1021),
    [sym_extract_operator] = STATE(1021),
    [sym_namespace_operator] = STATE(1021),
    [sym_integer] = STATE(1021),
    [sym_complex] = STATE(1021),
    [sym_float] = STATE(1021),
    [sym__hex_literal] = STATE(2356),
    [sym__float_literal] = STATE(2356),
    [sym_string] = STATE(2231),
    [sym__single_quoted_string] = STATE(2355),
    [sym__double_quoted_string] = STATE(2354),
    [sym_na] = STATE(1021),
    [sym__expression] = STATE(1021),
    [sym__string_or_identifier] = STATE(5156),
    [sym__open_parenthesis] = STATE(190),
    [sym__open_brace] = STATE(94),
    [aux_sym_function_definition_repeat1] = STATE(274),
    [ts_builtin_sym_end] = ACTIONS(531),
    [sym_identifier] = ACTIONS(1337),
    [anon_sym_BSLASH] = ACTIONS(1339),
    [anon_sym_function] = ACTIONS(1341),
    [anon_sym_EQ] = ACTIONS(533),
    [anon_sym_if] = ACTIONS(1343),
    [anon_sym_for] = ACTIONS(1345),
    [anon_sym_while] = ACTIONS(1347),
    [anon_sym_repeat] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_BANG] = ACTIONS(1355),
    [anon_sym_PLUS] = ACTIONS(1357),
    [anon_sym_DASH] = ACTIONS(1359),
    [anon_sym_LT_DASH] = ACTIONS(531),
    [anon_sym_LT_LT_DASH] = ACTIONS(531),
    [anon_sym_COLON_EQ] = ACTIONS(531),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_DASH_GT_GT] = ACTIONS(531),
    [anon_sym_PIPE] = ACTIONS(533),
    [anon_sym_AMP] = ACTIONS(533),
    [anon_sym_PIPE_PIPE] = ACTIONS(531),
    [anon_sym_AMP_AMP] = ACTIONS(531),
    [anon_sym_LT] = ACTIONS(533),
    [anon_sym_LT_EQ] = ACTIONS(531),
    [anon_sym_GT] = ACTIONS(533),
    [anon_sym_GT_EQ] = ACTIONS(531),
    [anon_sym_EQ_EQ] = ACTIONS(531),
    [anon_sym_BANG_EQ] = ACTIONS(531),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_SLASH] = ACTIONS(531),
    [anon_sym_STAR_STAR] = ACTIONS(531),
    [anon_sym_CARET] = ACTIONS(531),
    [aux_sym_binary_operator_token1] = ACTIONS(531),
    [anon_sym_PIPE_GT] = ACTIONS(531),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_DOLLAR] = ACTIONS(531),
    [anon_sym_AT] = ACTIONS(531),
    [aux_sym__hex_literal_token1] = ACTIONS(1361),
    [sym__number_literal] = ACTIONS(1363),
    [anon_sym_SQUOTE] = ACTIONS(1365),
    [anon_sym_DQUOTE] = ACTIONS(1367),
    [sym_return] = ACTIONS(3011),
    [sym_next] = ACTIONS(3011),
    [sym_break] = ACTIONS(3011),
    [sym_true] = ACTIONS(3011),
    [sym_false] = ACTIONS(3011),
    [sym_null] = ACTIONS(3011),
    [sym_inf] = ACTIONS(3011),
    [sym_nan] = ACTIONS(3011),
    [anon_sym_NA] = ACTIONS(1371),
    [anon_sym_NA_integer_] = ACTIONS(1371),
    [anon_sym_NA_real_] = ACTIONS(1371),
    [anon_sym_NA_complex_] = ACTIONS(1371),
    [anon_sym_NA_character_] = ACTIONS(1371),
    [sym_dots] = ACTIONS(3011),
    [sym_dot_dot_i] = ACTIONS(3013),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(3015),
    [sym__semicolon] = ACTIONS(531),
    [sym__raw_string_literal] = ACTIONS(1377),
    [sym__external_else] = ACTIONS(531),
    [sym__external_open_parenthesis] = ACTIONS(1379),
    [sym__external_close_parenthesis] = ACTIONS(531),
    [sym__external_open_brace] = ACTIONS(1383),
    [sym__external_open_bracket] = ACTIONS(531),
    [sym__external_open_bracket2] = ACTIONS(531),
  },
  [252] = {
    [sym_function_definition] = STATE(969),
    [sym_if_statement] = STATE(969),
    [sym_for_statement] = STATE(969),
    [sym_while_statement] = STATE(969),
    [sym_repeat_statement] = STATE(969),
    [sym_braced_expression] = STATE(969),
    [sym_parenthesized_expression] = STATE(969),
    [sym_call] = STATE(969),
    [sym_subset] = STATE(969),
    [sym_subset2] = STATE(969),
    [sym_unary_operator] = STATE(969),
    [sym_binary_operator] = STATE(969),
    [sym_extract_operator] = STATE(969),
    [sym_namespace_operator] = STATE(969),
    [sym_integer] = STATE(969),
    [sym_complex] = STATE(969),
    [sym_float] = STATE(969),
    [sym__hex_literal] = STATE(2272),
    [sym__float_literal] = STATE(2272),
    [sym_string] = STATE(2271),
    [sym__single_quoted_string] = STATE(2273),
    [sym__double_quoted_string] = STATE(2274),
    [sym_na] = STATE(969),
    [sym__expression] = STATE(969),
    [sym__string_or_identifier] = STATE(5157),
    [sym__open_parenthesis] = STATE(120),
    [sym__open_brace] = STATE(11),
    [aux_sym_function_definition_repeat1] = STATE(2503),
    [sym_identifier] = ACTIONS(1241),
    [anon_sym_BSLASH] = ACTIONS(1243),
    [anon_sym_function] = ACTIONS(1245),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_if] = ACTIONS(1247),
    [anon_sym_for] = ACTIONS(1249),
    [anon_sym_while] = ACTIONS(1251),
    [anon_sym_repeat] = ACTIONS(1253),
    [anon_sym_QMARK] = ACTIONS(1255),
    [anon_sym_TILDE] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1259),
    [anon_sym_PLUS] = ACTIONS(1261),
    [anon_sym_DASH] = ACTIONS(1263),
    [anon_sym_LT_DASH] = ACTIONS(471),
    [anon_sym_LT_LT_DASH] = ACTIONS(471),
    [anon_sym_COLON_EQ] = ACTIONS(471),
    [anon_sym_DASH_GT] = ACTIONS(473),
    [anon_sym_DASH_GT_GT] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(473),
    [anon_sym_AMP] = ACTIONS(473),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_LT_EQ] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(473),
    [anon_sym_GT_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_STAR] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [aux_sym_binary_operator_token1] = ACTIONS(471),
    [anon_sym_PIPE_GT] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(473),
    [anon_sym_DOLLAR] = ACTIONS(471),
    [anon_sym_AT] = ACTIONS(471),
    [aux_sym__hex_literal_token1] = ACTIONS(1265),
    [sym__number_literal] = ACTIONS(1267),
    [anon_sym_SQUOTE] = ACTIONS(1269),
    [anon_sym_DQUOTE] = ACTIONS(1271),
    [sym_return] = ACTIONS(3017),
    [sym_next] = ACTIONS(3017),
    [sym_break] = ACTIONS(3017),
    [sym_true] = ACTIONS(3017),
    [sym_false] = ACTIONS(3017),
    [sym_null] = ACTIONS(3017),
    [sym_inf] = ACTIONS(3017),
    [sym_nan] = ACTIONS(3017),
    [anon_sym_NA] = ACTIONS(1275),
    [anon_sym_NA_integer_] = ACTIONS(1275),
    [anon_sym_NA_real_] = ACTIONS(1275),
    [anon_sym_NA_complex_] = ACTIONS(1275),
    [anon_sym_NA_character_] = ACTIONS(1275),
    [sym_dots] = ACTIONS(3017),
    [sym_dot_dot_i] = ACTIONS(3019),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(471),
    [sym__newline] = ACTIONS(471),
    [sym__raw_string_literal] = ACTIONS(1281),
    [sym__external_else] = ACTIONS(471),
    [sym__external_open_parenthesis] = ACTIONS(1283),
    [sym__external_close_parenthesis] = ACTIONS(471),
    [sym__external_open_brace] = ACTIONS(1287),
    [sym__external_open_bracket] = ACTIONS(471),
    [sym__external_close_bracket] = ACTIONS(471),
    [sym__external_open_bracket2] = ACTIONS(471),
  },
  [253] = {
    [sym_function_definition] = STATE(1314),
    [sym_if_statement] = STATE(1314),
    [sym_for_statement] = STATE(1314),
    [sym_while_statement] = STATE(1314),
    [sym_repeat_statement] = STATE(1314),
    [sym_braced_expression] = STATE(1314),
    [sym_parenthesized_expression] = STATE(1314),
    [sym_call] = STATE(1314),
    [sym_subset] = STATE(1314),
    [sym_subset2] = STATE(1314),
    [sym_unary_operator] = STATE(1314),
    [sym_binary_operator] = STATE(1314),
    [sym_extract_operator] = STATE(1314),
    [sym_namespace_operator] = STATE(1314),
    [sym_integer] = STATE(1314),
    [sym_complex] = STATE(1314),
    [sym_float] = STATE(1314),
    [sym__hex_literal] = STATE(2272),
    [sym__float_literal] = STATE(2272),
    [sym_string] = STATE(2271),
    [sym__single_quoted_string] = STATE(2273),
    [sym__double_quoted_string] = STATE(2274),
    [sym_na] = STATE(1314),
    [sym__expression] = STATE(1314),
    [sym__string_or_identifier] = STATE(5157),
    [sym__open_parenthesis] = STATE(120),
    [sym__open_brace] = STATE(11),
    [aux_sym_function_definition_repeat1] = STATE(252),
    [sym_identifier] = ACTIONS(1241),
    [anon_sym_BSLASH] = ACTIONS(1243),
    [anon_sym_function] = ACTIONS(1245),
    [anon_sym_EQ] = ACTIONS(463),
    [anon_sym_if] = ACTIONS(1247),
    [anon_sym_for] = ACTIONS(1249),
    [anon_sym_while] = ACTIONS(1251),
    [anon_sym_repeat] = ACTIONS(1253),
    [anon_sym_QMARK] = ACTIONS(1255),
    [anon_sym_TILDE] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1259),
    [anon_sym_PLUS] = ACTIONS(1261),
    [anon_sym_DASH] = ACTIONS(1263),
    [anon_sym_LT_DASH] = ACTIONS(461),
    [anon_sym_LT_LT_DASH] = ACTIONS(461),
    [anon_sym_COLON_EQ] = ACTIONS(461),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_DASH_GT_GT] = ACTIONS(461),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_PIPE_PIPE] = ACTIONS(461),
    [anon_sym_AMP_AMP] = ACTIONS(461),
    [anon_sym_LT] = ACTIONS(463),
    [anon_sym_LT_EQ] = ACTIONS(461),
    [anon_sym_GT] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(461),
    [anon_sym_EQ_EQ] = ACTIONS(461),
    [anon_sym_BANG_EQ] = ACTIONS(461),
    [anon_sym_STAR] = ACTIONS(463),
    [anon_sym_SLASH] = ACTIONS(461),
    [anon_sym_STAR_STAR] = ACTIONS(461),
    [anon_sym_CARET] = ACTIONS(461),
    [aux_sym_binary_operator_token1] = ACTIONS(461),
    [anon_sym_PIPE_GT] = ACTIONS(461),
    [anon_sym_COLON] = ACTIONS(463),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_AT] = ACTIONS(461),
    [aux_sym__hex_literal_token1] = ACTIONS(1265),
    [sym__number_literal] = ACTIONS(1267),
    [anon_sym_SQUOTE] = ACTIONS(1269),
    [anon_sym_DQUOTE] = ACTIONS(1271),
    [sym_return] = ACTIONS(3021),
    [sym_next] = ACTIONS(3021),
    [sym_break] = ACTIONS(3021),
    [sym_true] = ACTIONS(3021),
    [sym_false] = ACTIONS(3021),
    [sym_null] = ACTIONS(3021),
    [sym_inf] = ACTIONS(3021),
    [sym_nan] = ACTIONS(3021),
    [anon_sym_NA] = ACTIONS(1275),
    [anon_sym_NA_integer_] = ACTIONS(1275),
    [anon_sym_NA_real_] = ACTIONS(1275),
    [anon_sym_NA_complex_] = ACTIONS(1275),
    [anon_sym_NA_character_] = ACTIONS(1275),
    [sym_dots] = ACTIONS(3021),
    [sym_dot_dot_i] = ACTIONS(3023),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(461),
    [sym__newline] = ACTIONS(3025),
    [sym__raw_string_literal] = ACTIONS(1281),
    [sym__external_else] = ACTIONS(461),
    [sym__external_open_parenthesis] = ACTIONS(1283),
    [sym__external_close_parenthesis] = ACTIONS(461),
    [sym__external_open_brace] = ACTIONS(1287),
    [sym__external_open_bracket] = ACTIONS(461),
    [sym__external_close_bracket] = ACTIONS(461),
    [sym__external_open_bracket2] = ACTIONS(461),
  },
  [254] = {
    [sym_function_definition] = STATE(1318),
    [sym_if_statement] = STATE(1318),
    [sym_for_statement] = STATE(1318),
    [sym_while_statement] = STATE(1318),
    [sym_repeat_statement] = STATE(1318),
    [sym_braced_expression] = STATE(1318),
    [sym_parenthesized_expression] = STATE(1318),
    [sym_call] = STATE(1318),
    [sym_subset] = STATE(1318),
    [sym_subset2] = STATE(1318),
    [sym_unary_operator] = STATE(1318),
    [sym_binary_operator] = STATE(1318),
    [sym_extract_operator] = STATE(1318),
    [sym_namespace_operator] = STATE(1318),
    [sym_integer] = STATE(1318),
    [sym_complex] = STATE(1318),
    [sym_float] = STATE(1318),
    [sym__hex_literal] = STATE(2272),
    [sym__float_literal] = STATE(2272),
    [sym_string] = STATE(2271),
    [sym__single_quoted_string] = STATE(2273),
    [sym__double_quoted_string] = STATE(2274),
    [sym_na] = STATE(1318),
    [sym__expression] = STATE(1318),
    [sym__string_or_identifier] = STATE(5157),
    [sym__open_parenthesis] = STATE(120),
    [sym__open_brace] = STATE(11),
    [aux_sym_function_definition_repeat1] = STATE(2503),
    [sym_identifier] = ACTIONS(1241),
    [anon_sym_BSLASH] = ACTIONS(1243),
    [anon_sym_function] = ACTIONS(1245),
    [anon_sym_EQ] = ACTIONS(455),
    [anon_sym_if] = ACTIONS(1247),
    [anon_sym_for] = ACTIONS(1249),
    [anon_sym_while] = ACTIONS(1251),
    [anon_sym_repeat] = ACTIONS(1253),
    [anon_sym_QMARK] = ACTIONS(1255),
    [anon_sym_TILDE] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1259),
    [anon_sym_PLUS] = ACTIONS(1261),
    [anon_sym_DASH] = ACTIONS(1263),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [anon_sym_LT_LT_DASH] = ACTIONS(453),
    [anon_sym_COLON_EQ] = ACTIONS(453),
    [anon_sym_DASH_GT] = ACTIONS(455),
    [anon_sym_DASH_GT_GT] = ACTIONS(453),
    [anon_sym_PIPE] = ACTIONS(455),
    [anon_sym_AMP] = ACTIONS(455),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(455),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_GT] = ACTIONS(455),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(453),
    [anon_sym_STAR] = ACTIONS(455),
    [anon_sym_SLASH] = ACTIONS(453),
    [anon_sym_STAR_STAR] = ACTIONS(453),
    [anon_sym_CARET] = ACTIONS(453),
    [aux_sym_binary_operator_token1] = ACTIONS(453),
    [anon_sym_PIPE_GT] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(455),
    [anon_sym_DOLLAR] = ACTIONS(453),
    [anon_sym_AT] = ACTIONS(453),
    [aux_sym__hex_literal_token1] = ACTIONS(1265),
    [sym__number_literal] = ACTIONS(1267),
    [anon_sym_SQUOTE] = ACTIONS(1269),
    [anon_sym_DQUOTE] = ACTIONS(1271),
    [sym_return] = ACTIONS(3027),
    [sym_next] = ACTIONS(3027),
    [sym_break] = ACTIONS(3027),
    [sym_true] = ACTIONS(3027),
    [sym_false] = ACTIONS(3027),
    [sym_null] = ACTIONS(3027),
    [sym_inf] = ACTIONS(3027),
    [sym_nan] = ACTIONS(3027),
    [anon_sym_NA] = ACTIONS(1275),
    [anon_sym_NA_integer_] = ACTIONS(1275),
    [anon_sym_NA_real_] = ACTIONS(1275),
    [anon_sym_NA_complex_] = ACTIONS(1275),
    [anon_sym_NA_character_] = ACTIONS(1275),
    [sym_dots] = ACTIONS(3027),
    [sym_dot_dot_i] = ACTIONS(3029),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(453),
    [sym__newline] = ACTIONS(453),
    [sym__raw_string_literal] = ACTIONS(1281),
    [sym__external_else] = ACTIONS(453),
    [sym__external_open_parenthesis] = ACTIONS(1283),
    [sym__external_close_parenthesis] = ACTIONS(453),
    [sym__external_open_brace] = ACTIONS(1287),
    [sym__external_open_bracket] = ACTIONS(453),
    [sym__external_close_bracket] = ACTIONS(453),
    [sym__external_open_bracket2] = ACTIONS(453),
  },
  [255] = {
    [sym_function_definition] = STATE(1310),
    [sym_if_statement] = STATE(1310),
    [sym_for_statement] = STATE(1310),
    [sym_while_statement] = STATE(1310),
    [sym_repeat_statement] = STATE(1310),
    [sym_braced_expression] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1310),
    [sym_call] = STATE(1310),
    [sym_subset] = STATE(1310),
    [sym_subset2] = STATE(1310),
    [sym_unary_operator] = STATE(1310),
    [sym_binary_operator] = STATE(1310),
    [sym_extract_operator] = STATE(1310),
    [sym_namespace_operator] = STATE(1310),
    [sym_integer] = STATE(1310),
    [sym_complex] = STATE(1310),
    [sym_float] = STATE(1310),
    [sym__hex_literal] = STATE(2272),
    [sym__float_literal] = STATE(2272),
    [sym_string] = STATE(2271),
    [sym__single_quoted_string] = STATE(2273),
    [sym__double_quoted_string] = STATE(2274),
    [sym_na] = STATE(1310),
    [sym__expression] = STATE(1310),
    [sym__string_or_identifier] = STATE(5157),
    [sym__open_parenthesis] = STATE(120),
    [sym__open_brace] = STATE(11),
    [aux_sym_function_definition_repeat1] = STATE(2503),
    [sym_identifier] = ACTIONS(1241),
    [anon_sym_BSLASH] = ACTIONS(1243),
    [anon_sym_function] = ACTIONS(1245),
    [anon_sym_EQ] = ACTIONS(399),
    [anon_sym_if] = ACTIONS(1247),
    [anon_sym_for] = ACTIONS(1249),
    [anon_sym_while] = ACTIONS(1251),
    [anon_sym_repeat] = ACTIONS(1253),
    [anon_sym_QMARK] = ACTIONS(1255),
    [anon_sym_TILDE] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1259),
    [anon_sym_PLUS] = ACTIONS(1261),
    [anon_sym_DASH] = ACTIONS(1263),
    [anon_sym_LT_DASH] = ACTIONS(397),
    [anon_sym_LT_LT_DASH] = ACTIONS(397),
    [anon_sym_COLON_EQ] = ACTIONS(397),
    [anon_sym_DASH_GT] = ACTIONS(399),
    [anon_sym_DASH_GT_GT] = ACTIONS(397),
    [anon_sym_PIPE] = ACTIONS(399),
    [anon_sym_AMP] = ACTIONS(399),
    [anon_sym_PIPE_PIPE] = ACTIONS(397),
    [anon_sym_AMP_AMP] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(399),
    [anon_sym_LT_EQ] = ACTIONS(397),
    [anon_sym_GT] = ACTIONS(399),
    [anon_sym_GT_EQ] = ACTIONS(397),
    [anon_sym_EQ_EQ] = ACTIONS(397),
    [anon_sym_BANG_EQ] = ACTIONS(397),
    [anon_sym_STAR] = ACTIONS(399),
    [anon_sym_SLASH] = ACTIONS(397),
    [anon_sym_STAR_STAR] = ACTIONS(397),
    [anon_sym_CARET] = ACTIONS(397),
    [aux_sym_binary_operator_token1] = ACTIONS(397),
    [anon_sym_PIPE_GT] = ACTIONS(397),
    [anon_sym_COLON] = ACTIONS(399),
    [anon_sym_DOLLAR] = ACTIONS(397),
    [anon_sym_AT] = ACTIONS(397),
    [aux_sym__hex_literal_token1] = ACTIONS(1265),
    [sym__number_literal] = ACTIONS(1267),
    [anon_sym_SQUOTE] = ACTIONS(1269),
    [anon_sym_DQUOTE] = ACTIONS(1271),
    [sym_return] = ACTIONS(3031),
    [sym_next] = ACTIONS(3031),
    [sym_break] = ACTIONS(3031),
    [sym_true] = ACTIONS(3031),
    [sym_false] = ACTIONS(3031),
    [sym_null] = ACTIONS(3031),
    [sym_inf] = ACTIONS(3031),
    [sym_nan] = ACTIONS(3031),
    [anon_sym_NA] = ACTIONS(1275),
    [anon_sym_NA_integer_] = ACTIONS(1275),
    [anon_sym_NA_real_] = ACTIONS(1275),
    [anon_sym_NA_complex_] = ACTIONS(1275),
    [anon_sym_NA_character_] = ACTIONS(1275),
    [sym_dots] = ACTIONS(3031),
    [sym_dot_dot_i] = ACTIONS(3033),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(397),
    [sym__newline] = ACTIONS(397),
    [sym__raw_string_literal] = ACTIONS(1281),
    [sym__external_else] = ACTIONS(397),
    [sym__external_open_parenthesis] = ACTIONS(1283),
    [sym__external_close_parenthesis] = ACTIONS(397),
    [sym__external_open_brace] = ACTIONS(1287),
    [sym__external_open_bracket] = ACTIONS(397),
    [sym__external_close_bracket] = ACTIONS(397),
    [sym__external_open_bracket2] = ACTIONS(397),
  },
  [256] = {
    [sym_function_definition] = STATE(1309),
    [sym_if_statement] = STATE(1309),
    [sym_for_statement] = STATE(1309),
    [sym_while_statement] = STATE(1309),
    [sym_repeat_statement] = STATE(1309),
    [sym_braced_expression] = STATE(1309),
    [sym_parenthesized_expression] = STATE(1309),
    [sym_call] = STATE(1309),
    [sym_subset] = STATE(1309),
    [sym_subset2] = STATE(1309),
    [sym_unary_operator] = STATE(1309),
    [sym_binary_operator] = STATE(1309),
    [sym_extract_operator] = STATE(1309),
    [sym_namespace_operator] = STATE(1309),
    [sym_integer] = STATE(1309),
    [sym_complex] = STATE(1309),
    [sym_float] = STATE(1309),
    [sym__hex_literal] = STATE(2272),
    [sym__float_literal] = STATE(2272),
    [sym_string] = STATE(2271),
    [sym__single_quoted_string] = STATE(2273),
    [sym__double_quoted_string] = STATE(2274),
    [sym_na] = STATE(1309),
    [sym__expression] = STATE(1309),
    [sym__string_or_identifier] = STATE(5157),
    [sym__open_parenthesis] = STATE(120),
    [sym__open_brace] = STATE(11),
    [aux_sym_function_definition_repeat1] = STATE(254),
    [sym_identifier] = ACTIONS(1241),
    [anon_sym_BSLASH] = ACTIONS(1243),
    [anon_sym_function] = ACTIONS(1245),
    [anon_sym_EQ] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(1247),
    [anon_sym_for] = ACTIONS(1249),
    [anon_sym_while] = ACTIONS(1251),
    [anon_sym_repeat] = ACTIONS(1253),
    [anon_sym_QMARK] = ACTIONS(1255),
    [anon_sym_TILDE] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1259),
    [anon_sym_PLUS] = ACTIONS(1261),
    [anon_sym_DASH] = ACTIONS(1263),
    [anon_sym_LT_DASH] = ACTIONS(387),
    [anon_sym_LT_LT_DASH] = ACTIONS(387),
    [anon_sym_COLON_EQ] = ACTIONS(387),
    [anon_sym_DASH_GT] = ACTIONS(389),
    [anon_sym_DASH_GT_GT] = ACTIONS(387),
    [anon_sym_PIPE] = ACTIONS(389),
    [anon_sym_AMP] = ACTIONS(389),
    [anon_sym_PIPE_PIPE] = ACTIONS(387),
    [anon_sym_AMP_AMP] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(389),
    [anon_sym_LT_EQ] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(389),
    [anon_sym_GT_EQ] = ACTIONS(387),
    [anon_sym_EQ_EQ] = ACTIONS(387),
    [anon_sym_BANG_EQ] = ACTIONS(387),
    [anon_sym_STAR] = ACTIONS(389),
    [anon_sym_SLASH] = ACTIONS(387),
    [anon_sym_STAR_STAR] = ACTIONS(387),
    [anon_sym_CARET] = ACTIONS(387),
    [aux_sym_binary_operator_token1] = ACTIONS(387),
    [anon_sym_PIPE_GT] = ACTIONS(387),
    [anon_sym_COLON] = ACTIONS(389),
    [anon_sym_DOLLAR] = ACTIONS(387),
    [anon_sym_AT] = ACTIONS(387),
    [aux_sym__hex_literal_token1] = ACTIONS(1265),
    [sym__number_literal] = ACTIONS(1267),
    [anon_sym_SQUOTE] = ACTIONS(1269),
    [anon_sym_DQUOTE] = ACTIONS(1271),
    [sym_return] = ACTIONS(3035),
    [sym_next] = ACTIONS(3035),
    [sym_break] = ACTIONS(3035),
    [sym_true] = ACTIONS(3035),
    [sym_false] = ACTIONS(3035),
    [sym_null] = ACTIONS(3035),
    [sym_inf] = ACTIONS(3035),
    [sym_nan] = ACTIONS(3035),
    [anon_sym_NA] = ACTIONS(1275),
    [anon_sym_NA_integer_] = ACTIONS(1275),
    [anon_sym_NA_real_] = ACTIONS(1275),
    [anon_sym_NA_complex_] = ACTIONS(1275),
    [anon_sym_NA_character_] = ACTIONS(1275),
    [sym_dots] = ACTIONS(3035),
    [sym_dot_dot_i] = ACTIONS(3037),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(387),
    [sym__newline] = ACTIONS(3039),
    [sym__raw_string_literal] = ACTIONS(1281),
    [sym__external_else] = ACTIONS(387),
    [sym__external_open_parenthesis] = ACTIONS(1283),
    [sym__external_close_parenthesis] = ACTIONS(387),
    [sym__external_open_brace] = ACTIONS(1287),
    [sym__external_open_bracket] = ACTIONS(387),
    [sym__external_close_bracket] = ACTIONS(387),
    [sym__external_open_bracket2] = ACTIONS(387),
  },
  [257] = {
    [sym_function_definition] = STATE(1307),
    [sym_if_statement] = STATE(1307),
    [sym_for_statement] = STATE(1307),
    [sym_while_statement] = STATE(1307),
    [sym_repeat_statement] = STATE(1307),
    [sym_braced_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_call] = STATE(1307),
    [sym_subset] = STATE(1307),
    [sym_subset2] = STATE(1307),
    [sym_unary_operator] = STATE(1307),
    [sym_binary_operator] = STATE(1307),
    [sym_extract_operator] = STATE(1307),
    [sym_namespace_operator] = STATE(1307),
    [sym_integer] = STATE(1307),
    [sym_complex] = STATE(1307),
    [sym_float] = STATE(1307),
    [sym__hex_literal] = STATE(2272),
    [sym__float_literal] = STATE(2272),
    [sym_string] = STATE(2271),
    [sym__single_quoted_string] = STATE(2273),
    [sym__double_quoted_string] = STATE(2274),
    [sym_na] = STATE(1307),
    [sym__expression] = STATE(1307),
    [sym__string_or_identifier] = STATE(5157),
    [sym__open_parenthesis] = STATE(120),
    [sym__open_brace] = STATE(11),
    [aux_sym_function_definition_repeat1] = STATE(255),
    [sym_identifier] = ACTIONS(1241),
    [anon_sym_BSLASH] = ACTIONS(1243),
    [anon_sym_function] = ACTIONS(1245),
    [anon_sym_EQ] = ACTIONS(379),
    [anon_sym_if] = ACTIONS(1247),
    [anon_sym_for] = ACTIONS(1249),
    [anon_sym_while] = ACTIONS(1251),
    [anon_sym_repeat] = ACTIONS(1253),
    [anon_sym_QMARK] = ACTIONS(1255),
    [anon_sym_TILDE] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1259),
    [anon_sym_PLUS] = ACTIONS(1261),
    [anon_sym_DASH] = ACTIONS(1263),
    [anon_sym_LT_DASH] = ACTIONS(377),
    [anon_sym_LT_LT_DASH] = ACTIONS(377),
    [anon_sym_COLON_EQ] = ACTIONS(377),
    [anon_sym_DASH_GT] = ACTIONS(379),
    [anon_sym_DASH_GT_GT] = ACTIONS(377),
    [anon_sym_PIPE] = ACTIONS(379),
    [anon_sym_AMP] = ACTIONS(379),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_LT] = ACTIONS(379),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(379),
    [anon_sym_GT_EQ] = ACTIONS(377),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(379),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_STAR_STAR] = ACTIONS(377),
    [anon_sym_CARET] = ACTIONS(377),
    [aux_sym_binary_operator_token1] = ACTIONS(377),
    [anon_sym_PIPE_GT] = ACTIONS(377),
    [anon_sym_COLON] = ACTIONS(379),
    [anon_sym_DOLLAR] = ACTIONS(377),
    [anon_sym_AT] = ACTIONS(377),
    [aux_sym__hex_literal_token1] = ACTIONS(1265),
    [sym__number_literal] = ACTIONS(1267),
    [anon_sym_SQUOTE] = ACTIONS(1269),
    [anon_sym_DQUOTE] = ACTIONS(1271),
    [sym_return] = ACTIONS(3041),
    [sym_next] = ACTIONS(3041),
    [sym_break] = ACTIONS(3041),
    [sym_true] = ACTIONS(3041),
    [sym_false] = ACTIONS(3041),
    [sym_null] = ACTIONS(3041),
    [sym_inf] = ACTIONS(3041),
    [sym_nan] = ACTIONS(3041),
    [anon_sym_NA] = ACTIONS(1275),
    [anon_sym_NA_integer_] = ACTIONS(1275),
    [anon_sym_NA_real_] = ACTIONS(1275),
    [anon_sym_NA_complex_] = ACTIONS(1275),
    [anon_sym_NA_character_] = ACTIONS(1275),
    [sym_dots] = ACTIONS(3041),
    [sym_dot_dot_i] = ACTIONS(3043),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(377),
    [sym__newline] = ACTIONS(3045),
    [sym__raw_string_literal] = ACTIONS(1281),
    [sym__external_else] = ACTIONS(377),
    [sym__external_open_parenthesis] = ACTIONS(1283),
    [sym__external_close_parenthesis] = ACTIONS(377),
    [sym__external_open_brace] = ACTIONS(1287),
    [sym__external_open_bracket] = ACTIONS(377),
    [sym__external_close_bracket] = ACTIONS(377),
    [sym__external_open_bracket2] = ACTIONS(377),
  },
  [258] = {
    [sym_function_definition] = STATE(1306),
    [sym_if_statement] = STATE(1306),
    [sym_for_statement] = STATE(1306),
    [sym_while_statement] = STATE(1306),
    [sym_repeat_statement] = STATE(1306),
    [sym_braced_expression] = STATE(1306),
    [sym_parenthesized_expression] = STATE(1306),
    [sym_call] = STATE(1306),
    [sym_subset] = STATE(1306),
    [sym_subset2] = STATE(1306),
    [sym_unary_operator] = STATE(1306),
    [sym_binary_operator] = STATE(1306),
    [sym_extract_operator] = STATE(1306),
    [sym_namespace_operator] = STATE(1306),
    [sym_integer] = STATE(1306),
    [sym_complex] = STATE(1306),
    [sym_float] = STATE(1306),
    [sym__hex_literal] = STATE(2272),
    [sym__float_literal] = STATE(2272),
    [sym_string] = STATE(2271),
    [sym__single_quoted_string] = STATE(2273),
    [sym__double_quoted_string] = STATE(2274),
    [sym_na] = STATE(1306),
    [sym__expression] = STATE(1306),
    [sym__string_or_identifier] = STATE(5157),
    [sym__open_parenthesis] = STATE(120),
    [sym__open_brace] = STATE(11),
    [aux_sym_function_definition_repeat1] = STATE(2503),
    [sym_identifier] = ACTIONS(1241),
    [anon_sym_BSLASH] = ACTIONS(1243),
    [anon_sym_function] = ACTIONS(1245),
    [anon_sym_EQ] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(1247),
    [anon_sym_for] = ACTIONS(1249),
    [anon_sym_while] = ACTIONS(1251),
    [anon_sym_repeat] = ACTIONS(1253),
    [anon_sym_QMARK] = ACTIONS(1255),
    [anon_sym_TILDE] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1259),
    [anon_sym_PLUS] = ACTIONS(1261),
    [anon_sym_DASH] = ACTIONS(1263),
    [anon_sym_LT_DASH] = ACTIONS(369),
    [anon_sym_LT_LT_DASH] = ACTIONS(369),
    [anon_sym_COLON_EQ] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(371),
    [anon_sym_DASH_GT_GT] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(371),
    [anon_sym_AMP] = ACTIONS(371),
    [anon_sym_PIPE_PIPE] = ACTIONS(369),
    [anon_sym_AMP_AMP] = ACTIONS(369),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_LT_EQ] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_EQ] = ACTIONS(369),
    [anon_sym_EQ_EQ] = ACTIONS(369),
    [anon_sym_BANG_EQ] = ACTIONS(369),
    [anon_sym_STAR] = ACTIONS(371),
    [anon_sym_SLASH] = ACTIONS(369),
    [anon_sym_STAR_STAR] = ACTIONS(369),
    [anon_sym_CARET] = ACTIONS(369),
    [aux_sym_binary_operator_token1] = ACTIONS(369),
    [anon_sym_PIPE_GT] = ACTIONS(369),
    [anon_sym_COLON] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(369),
    [anon_sym_AT] = ACTIONS(369),
    [aux_sym__hex_literal_token1] = ACTIONS(1265),
    [sym__number_literal] = ACTIONS(1267),
    [anon_sym_SQUOTE] = ACTIONS(1269),
    [anon_sym_DQUOTE] = ACTIONS(1271),
    [sym_return] = ACTIONS(3047),
    [sym_next] = ACTIONS(3047),
    [sym_break] = ACTIONS(3047),
    [sym_true] = ACTIONS(3047),
    [sym_false] = ACTIONS(3047),
    [sym_null] = ACTIONS(3047),
    [sym_inf] = ACTIONS(3047),
    [sym_nan] = ACTIONS(3047),
    [anon_sym_NA] = ACTIONS(1275),
    [anon_sym_NA_integer_] = ACTIONS(1275),
    [anon_sym_NA_real_] = ACTIONS(1275),
    [anon_sym_NA_complex_] = ACTIONS(1275),
    [anon_sym_NA_character_] = ACTIONS(1275),
    [sym_dots] = ACTIONS(3047),
    [sym_dot_dot_i] = ACTIONS(3049),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(369),
    [sym__newline] = ACTIONS(369),
    [sym__raw_string_literal] = ACTIONS(1281),
    [sym__external_else] = ACTIONS(369),
    [sym__external_open_parenthesis] = ACTIONS(1283),
    [sym__external_close_parenthesis] = ACTIONS(369),
    [sym__external_open_brace] = ACTIONS(1287),
    [sym__external_open_bracket] = ACTIONS(369),
    [sym__external_close_bracket] = ACTIONS(369),
    [sym__external_open_bracket2] = ACTIONS(369),
  },
  [259] = {
    [sym_function_definition] = STATE(1305),
    [sym_if_statement] = STATE(1305),
    [sym_for_statement] = STATE(1305),
    [sym_while_statement] = STATE(1305),
    [sym_repeat_statement] = STATE(1305),
    [sym_braced_expression] = STATE(1305),
    [sym_parenthesized_expression] = STATE(1305),
    [sym_call] = STATE(1305),
    [sym_subset] = STATE(1305),
    [sym_subset2] = STATE(1305),
    [sym_unary_operator] = STATE(1305),
    [sym_binary_operator] = STATE(1305),
    [sym_extract_operator] = STATE(1305),
    [sym_namespace_operator] = STATE(1305),
    [sym_integer] = STATE(1305),
    [sym_complex] = STATE(1305),
    [sym_float] = STATE(1305),
    [sym__hex_literal] = STATE(2272),
    [sym__float_literal] = STATE(2272),
    [sym_string] = STATE(2271),
    [sym__single_quoted_string] = STATE(2273),
    [sym__double_quoted_string] = STATE(2274),
    [sym_na] = STATE(1305),
    [sym__expression] = STATE(1305),
    [sym__string_or_identifier] = STATE(5157),
    [sym__open_parenthesis] = STATE(120),
    [sym__open_brace] = STATE(11),
    [aux_sym_function_definition_repeat1] = STATE(258),
    [sym_identifier] = ACTIONS(1241),
    [anon_sym_BSLASH] = ACTIONS(1243),
    [anon_sym_function] = ACTIONS(1245),
    [anon_sym_EQ] = ACTIONS(533),
    [anon_sym_if] = ACTIONS(1247),
    [anon_sym_for] = ACTIONS(1249),
    [anon_sym_while] = ACTIONS(1251),
    [anon_sym_repeat] = ACTIONS(1253),
    [anon_sym_QMARK] = ACTIONS(1255),
    [anon_sym_TILDE] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1259),
    [anon_sym_PLUS] = ACTIONS(1261),
    [anon_sym_DASH] = ACTIONS(1263),
    [anon_sym_LT_DASH] = ACTIONS(531),
    [anon_sym_LT_LT_DASH] = ACTIONS(531),
    [anon_sym_COLON_EQ] = ACTIONS(531),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_DASH_GT_GT] = ACTIONS(531),
    [anon_sym_PIPE] = ACTIONS(533),
    [anon_sym_AMP] = ACTIONS(533),
    [anon_sym_PIPE_PIPE] = ACTIONS(531),
    [anon_sym_AMP_AMP] = ACTIONS(531),
    [anon_sym_LT] = ACTIONS(533),
    [anon_sym_LT_EQ] = ACTIONS(531),
    [anon_sym_GT] = ACTIONS(533),
    [anon_sym_GT_EQ] = ACTIONS(531),
    [anon_sym_EQ_EQ] = ACTIONS(531),
    [anon_sym_BANG_EQ] = ACTIONS(531),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_SLASH] = ACTIONS(531),
    [anon_sym_STAR_STAR] = ACTIONS(531),
    [anon_sym_CARET] = ACTIONS(531),
    [aux_sym_binary_operator_token1] = ACTIONS(531),
    [anon_sym_PIPE_GT] = ACTIONS(531),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_DOLLAR] = ACTIONS(531),
    [anon_sym_AT] = ACTIONS(531),
    [aux_sym__hex_literal_token1] = ACTIONS(1265),
    [sym__number_literal] = ACTIONS(1267),
    [anon_sym_SQUOTE] = ACTIONS(1269),
    [anon_sym_DQUOTE] = ACTIONS(1271),
    [sym_return] = ACTIONS(3051),
    [sym_next] = ACTIONS(3051),
    [sym_break] = ACTIONS(3051),
    [sym_true] = ACTIONS(3051),
    [sym_false] = ACTIONS(3051),
    [sym_null] = ACTIONS(3051),
    [sym_inf] = ACTIONS(3051),
    [sym_nan] = ACTIONS(3051),
    [anon_sym_NA] = ACTIONS(1275),
    [anon_sym_NA_integer_] = ACTIONS(1275),
    [anon_sym_NA_real_] = ACTIONS(1275),
    [anon_sym_NA_complex_] = ACTIONS(1275),
    [anon_sym_NA_character_] = ACTIONS(1275),
    [sym_dots] = ACTIONS(3051),
    [sym_dot_dot_i] = ACTIONS(3053),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(531),
    [sym__newline] = ACTIONS(3055),
    [sym__raw_string_literal] = ACTIONS(1281),
    [sym__external_else] = ACTIONS(531),
    [sym__external_open_parenthesis] = ACTIONS(1283),
    [sym__external_close_parenthesis] = ACTIONS(531),
    [sym__external_open_brace] = ACTIONS(1287),
    [sym__external_open_bracket] = ACTIONS(531),
    [sym__external_close_bracket] = ACTIONS(531),
    [sym__external_open_bracket2] = ACTIONS(531),
  },
  [260] = {
    [sym_function_definition] = STATE(1006),
    [sym_if_statement] = STATE(1006),
    [sym_for_statement] = STATE(1006),
    [sym_while_statement] = STATE(1006),
    [sym_repeat_statement] = STATE(1006),
    [sym_braced_expression] = STATE(1006),
    [sym_parenthesized_expression] = STATE(1006),
    [sym_call] = STATE(1006),
    [sym_subset] = STATE(1006),
    [sym_subset2] = STATE(1006),
    [sym_unary_operator] = STATE(1006),
    [sym_binary_operator] = STATE(1006),
    [sym_extract_operator] = STATE(1006),
    [sym_namespace_operator] = STATE(1006),
    [sym_integer] = STATE(1006),
    [sym_complex] = STATE(1006),
    [sym_float] = STATE(1006),
    [sym__hex_literal] = STATE(2356),
    [sym__float_literal] = STATE(2356),
    [sym_string] = STATE(2231),
    [sym__single_quoted_string] = STATE(2355),
    [sym__double_quoted_string] = STATE(2354),
    [sym_na] = STATE(1006),
    [sym__expression] = STATE(1006),
    [sym__string_or_identifier] = STATE(5156),
    [sym__open_parenthesis] = STATE(190),
    [sym__open_brace] = STATE(94),
    [aux_sym_function_definition_repeat1] = STATE(2465),
    [ts_builtin_sym_end] = ACTIONS(757),
    [sym_identifier] = ACTIONS(1337),
    [anon_sym_BSLASH] = ACTIONS(1339),
    [anon_sym_function] = ACTIONS(1341),
    [anon_sym_EQ] = ACTIONS(759),
    [anon_sym_if] = ACTIONS(1343),
    [anon_sym_for] = ACTIONS(1345),
    [anon_sym_while] = ACTIONS(1347),
    [anon_sym_repeat] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_BANG] = ACTIONS(1355),
    [anon_sym_PLUS] = ACTIONS(1357),
    [anon_sym_DASH] = ACTIONS(1359),
    [anon_sym_LT_DASH] = ACTIONS(757),
    [anon_sym_LT_LT_DASH] = ACTIONS(757),
    [anon_sym_COLON_EQ] = ACTIONS(757),
    [anon_sym_DASH_GT] = ACTIONS(759),
    [anon_sym_DASH_GT_GT] = ACTIONS(757),
    [anon_sym_PIPE] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(759),
    [anon_sym_PIPE_PIPE] = ACTIONS(757),
    [anon_sym_AMP_AMP] = ACTIONS(757),
    [anon_sym_LT] = ACTIONS(759),
    [anon_sym_LT_EQ] = ACTIONS(757),
    [anon_sym_GT] = ACTIONS(759),
    [anon_sym_GT_EQ] = ACTIONS(757),
    [anon_sym_EQ_EQ] = ACTIONS(757),
    [anon_sym_BANG_EQ] = ACTIONS(757),
    [anon_sym_STAR] = ACTIONS(759),
    [anon_sym_SLASH] = ACTIONS(757),
    [anon_sym_STAR_STAR] = ACTIONS(757),
    [anon_sym_CARET] = ACTIONS(757),
    [aux_sym_binary_operator_token1] = ACTIONS(757),
    [anon_sym_PIPE_GT] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(759),
    [anon_sym_DOLLAR] = ACTIONS(757),
    [anon_sym_AT] = ACTIONS(757),
    [aux_sym__hex_literal_token1] = ACTIONS(1361),
    [sym__number_literal] = ACTIONS(1363),
    [anon_sym_SQUOTE] = ACTIONS(1365),
    [anon_sym_DQUOTE] = ACTIONS(1367),
    [sym_return] = ACTIONS(3057),
    [sym_next] = ACTIONS(3057),
    [sym_break] = ACTIONS(3057),
    [sym_true] = ACTIONS(3057),
    [sym_false] = ACTIONS(3057),
    [sym_null] = ACTIONS(3057),
    [sym_inf] = ACTIONS(3057),
    [sym_nan] = ACTIONS(3057),
    [anon_sym_NA] = ACTIONS(1371),
    [anon_sym_NA_integer_] = ACTIONS(1371),
    [anon_sym_NA_real_] = ACTIONS(1371),
    [anon_sym_NA_complex_] = ACTIONS(1371),
    [anon_sym_NA_character_] = ACTIONS(1371),
    [sym_dots] = ACTIONS(3057),
    [sym_dot_dot_i] = ACTIONS(3059),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(757),
    [sym__semicolon] = ACTIONS(757),
    [sym__raw_string_literal] = ACTIONS(1377),
    [sym__external_else] = ACTIONS(757),
    [sym__external_open_parenthesis] = ACTIONS(1379),
    [sym__external_close_parenthesis] = ACTIONS(757),
    [sym__external_open_brace] = ACTIONS(1383),
    [sym__external_open_bracket] = ACTIONS(757),
    [sym__external_open_bracket2] = ACTIONS(757),
  },
  [261] = {
    [sym_function_definition] = STATE(1092),
    [sym_if_statement] = STATE(1092),
    [sym_for_statement] = STATE(1092),
    [sym_while_statement] = STATE(1092),
    [sym_repeat_statement] = STATE(1092),
    [sym_braced_expression] = STATE(1092),
    [sym_parenthesized_expression] = STATE(1092),
    [sym_call] = STATE(1092),
    [sym_subset] = STATE(1092),
    [sym_subset2] = STATE(1092),
    [sym_unary_operator] = STATE(1092),
    [sym_binary_operator] = STATE(1092),
    [sym_extract_operator] = STATE(1092),
    [sym_namespace_operator] = STATE(1092),
    [sym_integer] = STATE(1092),
    [sym_complex] = STATE(1092),
    [sym_float] = STATE(1092),
    [sym__hex_literal] = STATE(2235),
    [sym__float_literal] = STATE(2235),
    [sym_string] = STATE(2234),
    [sym__single_quoted_string] = STATE(2236),
    [sym__double_quoted_string] = STATE(2237),
    [sym_na] = STATE(1092),
    [sym__expression] = STATE(1092),
    [sym__string_or_identifier] = STATE(5150),
    [sym__open_parenthesis] = STATE(76),
    [sym__open_brace] = STATE(188),
    [aux_sym_function_definition_repeat1] = STATE(248),
    [sym_identifier] = ACTIONS(1433),
    [anon_sym_BSLASH] = ACTIONS(1435),
    [anon_sym_function] = ACTIONS(1437),
    [anon_sym_EQ] = ACTIONS(533),
    [anon_sym_if] = ACTIONS(1439),
    [anon_sym_for] = ACTIONS(1441),
    [anon_sym_while] = ACTIONS(1443),
    [anon_sym_repeat] = ACTIONS(1445),
    [anon_sym_QMARK] = ACTIONS(1447),
    [anon_sym_TILDE] = ACTIONS(1449),
    [anon_sym_BANG] = ACTIONS(1451),
    [anon_sym_PLUS] = ACTIONS(1453),
    [anon_sym_DASH] = ACTIONS(1455),
    [anon_sym_LT_DASH] = ACTIONS(531),
    [anon_sym_LT_LT_DASH] = ACTIONS(531),
    [anon_sym_COLON_EQ] = ACTIONS(531),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_DASH_GT_GT] = ACTIONS(531),
    [anon_sym_PIPE] = ACTIONS(533),
    [anon_sym_AMP] = ACTIONS(533),
    [anon_sym_PIPE_PIPE] = ACTIONS(531),
    [anon_sym_AMP_AMP] = ACTIONS(531),
    [anon_sym_LT] = ACTIONS(533),
    [anon_sym_LT_EQ] = ACTIONS(531),
    [anon_sym_GT] = ACTIONS(533),
    [anon_sym_GT_EQ] = ACTIONS(531),
    [anon_sym_EQ_EQ] = ACTIONS(531),
    [anon_sym_BANG_EQ] = ACTIONS(531),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_SLASH] = ACTIONS(531),
    [anon_sym_STAR_STAR] = ACTIONS(531),
    [anon_sym_CARET] = ACTIONS(531),
    [aux_sym_binary_operator_token1] = ACTIONS(531),
    [anon_sym_PIPE_GT] = ACTIONS(531),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_DOLLAR] = ACTIONS(531),
    [anon_sym_AT] = ACTIONS(531),
    [aux_sym__hex_literal_token1] = ACTIONS(1457),
    [sym__number_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [anon_sym_DQUOTE] = ACTIONS(1463),
    [sym_return] = ACTIONS(3061),
    [sym_next] = ACTIONS(3061),
    [sym_break] = ACTIONS(3061),
    [sym_true] = ACTIONS(3061),
    [sym_false] = ACTIONS(3061),
    [sym_null] = ACTIONS(3061),
    [sym_inf] = ACTIONS(3061),
    [sym_nan] = ACTIONS(3061),
    [anon_sym_NA] = ACTIONS(1467),
    [anon_sym_NA_integer_] = ACTIONS(1467),
    [anon_sym_NA_real_] = ACTIONS(1467),
    [anon_sym_NA_complex_] = ACTIONS(1467),
    [anon_sym_NA_character_] = ACTIONS(1467),
    [sym_dots] = ACTIONS(3061),
    [sym_dot_dot_i] = ACTIONS(3063),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(531),
    [sym__newline] = ACTIONS(3065),
    [sym__semicolon] = ACTIONS(531),
    [sym__raw_string_literal] = ACTIONS(1473),
    [sym__external_open_parenthesis] = ACTIONS(1475),
    [sym__external_open_brace] = ACTIONS(1477),
    [sym__external_close_brace] = ACTIONS(531),
    [sym__external_open_bracket] = ACTIONS(531),
    [sym__external_open_bracket2] = ACTIONS(531),
    [sym__external_close_bracket2] = ACTIONS(531),
  },
  [262] = {
    [sym_function_definition] = STATE(1152),
    [sym_if_statement] = STATE(1152),
    [sym_for_statement] = STATE(1152),
    [sym_while_statement] = STATE(1152),
    [sym_repeat_statement] = STATE(1152),
    [sym_braced_expression] = STATE(1152),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_call] = STATE(1152),
    [sym_subset] = STATE(1152),
    [sym_subset2] = STATE(1152),
    [sym_unary_operator] = STATE(1152),
    [sym_binary_operator] = STATE(1152),
    [sym_extract_operator] = STATE(1152),
    [sym_namespace_operator] = STATE(1152),
    [sym_integer] = STATE(1152),
    [sym_complex] = STATE(1152),
    [sym_float] = STATE(1152),
    [sym__hex_literal] = STATE(2235),
    [sym__float_literal] = STATE(2235),
    [sym_string] = STATE(2234),
    [sym__single_quoted_string] = STATE(2236),
    [sym__double_quoted_string] = STATE(2237),
    [sym_na] = STATE(1152),
    [sym__expression] = STATE(1152),
    [sym__string_or_identifier] = STATE(5150),
    [sym__open_parenthesis] = STATE(76),
    [sym__open_brace] = STATE(188),
    [aux_sym_braced_expression_repeat1] = STATE(262),
    [sym_identifier] = ACTIONS(3067),
    [anon_sym_BSLASH] = ACTIONS(3070),
    [anon_sym_function] = ACTIONS(3073),
    [anon_sym_EQ] = ACTIONS(562),
    [anon_sym_if] = ACTIONS(3076),
    [anon_sym_for] = ACTIONS(3079),
    [anon_sym_while] = ACTIONS(3082),
    [anon_sym_repeat] = ACTIONS(3085),
    [anon_sym_QMARK] = ACTIONS(3088),
    [anon_sym_TILDE] = ACTIONS(3091),
    [anon_sym_BANG] = ACTIONS(3094),
    [anon_sym_PLUS] = ACTIONS(3097),
    [anon_sym_DASH] = ACTIONS(3100),
    [anon_sym_LT_DASH] = ACTIONS(591),
    [anon_sym_LT_LT_DASH] = ACTIONS(591),
    [anon_sym_COLON_EQ] = ACTIONS(591),
    [anon_sym_DASH_GT] = ACTIONS(562),
    [anon_sym_DASH_GT_GT] = ACTIONS(591),
    [anon_sym_PIPE] = ACTIONS(562),
    [anon_sym_AMP] = ACTIONS(562),
    [anon_sym_PIPE_PIPE] = ACTIONS(591),
    [anon_sym_AMP_AMP] = ACTIONS(591),
    [anon_sym_LT] = ACTIONS(562),
    [anon_sym_LT_EQ] = ACTIONS(591),
    [anon_sym_GT] = ACTIONS(562),
    [anon_sym_GT_EQ] = ACTIONS(591),
    [anon_sym_EQ_EQ] = ACTIONS(591),
    [anon_sym_BANG_EQ] = ACTIONS(591),
    [anon_sym_STAR] = ACTIONS(562),
    [anon_sym_SLASH] = ACTIONS(591),
    [anon_sym_STAR_STAR] = ACTIONS(591),
    [anon_sym_CARET] = ACTIONS(591),
    [aux_sym_binary_operator_token1] = ACTIONS(591),
    [anon_sym_PIPE_GT] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(562),
    [anon_sym_DOLLAR] = ACTIONS(591),
    [anon_sym_AT] = ACTIONS(591),
    [aux_sym__hex_literal_token1] = ACTIONS(3103),
    [sym__number_literal] = ACTIONS(3106),
    [anon_sym_SQUOTE] = ACTIONS(3109),
    [anon_sym_DQUOTE] = ACTIONS(3112),
    [sym_return] = ACTIONS(3115),
    [sym_next] = ACTIONS(3115),
    [sym_break] = ACTIONS(3115),
    [sym_true] = ACTIONS(3115),
    [sym_false] = ACTIONS(3115),
    [sym_null] = ACTIONS(3115),
    [sym_inf] = ACTIONS(3115),
    [sym_nan] = ACTIONS(3115),
    [anon_sym_NA] = ACTIONS(3118),
    [anon_sym_NA_integer_] = ACTIONS(3118),
    [anon_sym_NA_real_] = ACTIONS(3118),
    [anon_sym_NA_complex_] = ACTIONS(3118),
    [anon_sym_NA_character_] = ACTIONS(3118),
    [sym_dots] = ACTIONS(3115),
    [sym_dot_dot_i] = ACTIONS(3121),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(591),
    [sym__newline] = ACTIONS(3124),
    [sym__semicolon] = ACTIONS(3124),
    [sym__raw_string_literal] = ACTIONS(3127),
    [sym__external_open_parenthesis] = ACTIONS(3130),
    [sym__external_open_brace] = ACTIONS(3133),
    [sym__external_close_brace] = ACTIONS(591),
    [sym__external_open_bracket] = ACTIONS(591),
    [sym__external_open_bracket2] = ACTIONS(591),
    [sym__external_close_bracket2] = ACTIONS(591),
  },
  [263] = {
    [sym_function_definition] = STATE(1252),
    [sym_if_statement] = STATE(1252),
    [sym_for_statement] = STATE(1252),
    [sym_while_statement] = STATE(1252),
    [sym_repeat_statement] = STATE(1252),
    [sym_braced_expression] = STATE(1252),
    [sym_parenthesized_expression] = STATE(1252),
    [sym_call] = STATE(1252),
    [sym_subset] = STATE(1252),
    [sym_subset2] = STATE(1252),
    [sym_unary_operator] = STATE(1252),
    [sym_binary_operator] = STATE(1252),
    [sym_extract_operator] = STATE(1252),
    [sym_namespace_operator] = STATE(1252),
    [sym_integer] = STATE(1252),
    [sym_complex] = STATE(1252),
    [sym_float] = STATE(1252),
    [sym__hex_literal] = STATE(2272),
    [sym__float_literal] = STATE(2272),
    [sym_string] = STATE(2271),
    [sym__single_quoted_string] = STATE(2273),
    [sym__double_quoted_string] = STATE(2274),
    [sym_na] = STATE(1252),
    [sym__expression] = STATE(1252),
    [sym__string_or_identifier] = STATE(5157),
    [sym__open_parenthesis] = STATE(120),
    [sym__open_brace] = STATE(11),
    [aux_sym_function_definition_repeat1] = STATE(219),
    [sym_identifier] = ACTIONS(1241),
    [anon_sym_BSLASH] = ACTIONS(1243),
    [anon_sym_function] = ACTIONS(1245),
    [anon_sym_EQ] = ACTIONS(543),
    [anon_sym_if] = ACTIONS(1247),
    [anon_sym_for] = ACTIONS(1249),
    [anon_sym_while] = ACTIONS(1251),
    [anon_sym_repeat] = ACTIONS(1253),
    [anon_sym_QMARK] = ACTIONS(1255),
    [anon_sym_TILDE] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1259),
    [anon_sym_PLUS] = ACTIONS(1261),
    [anon_sym_DASH] = ACTIONS(1263),
    [anon_sym_LT_DASH] = ACTIONS(545),
    [anon_sym_LT_LT_DASH] = ACTIONS(545),
    [anon_sym_COLON_EQ] = ACTIONS(545),
    [anon_sym_DASH_GT] = ACTIONS(543),
    [anon_sym_DASH_GT_GT] = ACTIONS(545),
    [anon_sym_PIPE] = ACTIONS(543),
    [anon_sym_AMP] = ACTIONS(543),
    [anon_sym_PIPE_PIPE] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(543),
    [anon_sym_LT_EQ] = ACTIONS(545),
    [anon_sym_GT] = ACTIONS(543),
    [anon_sym_GT_EQ] = ACTIONS(545),
    [anon_sym_EQ_EQ] = ACTIONS(545),
    [anon_sym_BANG_EQ] = ACTIONS(545),
    [anon_sym_STAR] = ACTIONS(543),
    [anon_sym_SLASH] = ACTIONS(545),
    [anon_sym_STAR_STAR] = ACTIONS(545),
    [anon_sym_CARET] = ACTIONS(545),
    [aux_sym_binary_operator_token1] = ACTIONS(545),
    [anon_sym_PIPE_GT] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(543),
    [anon_sym_DOLLAR] = ACTIONS(545),
    [anon_sym_AT] = ACTIONS(545),
    [aux_sym__hex_literal_token1] = ACTIONS(1265),
    [sym__number_literal] = ACTIONS(1267),
    [anon_sym_SQUOTE] = ACTIONS(1269),
    [anon_sym_DQUOTE] = ACTIONS(1271),
    [sym_return] = ACTIONS(3136),
    [sym_next] = ACTIONS(3136),
    [sym_break] = ACTIONS(3136),
    [sym_true] = ACTIONS(3136),
    [sym_false] = ACTIONS(3136),
    [sym_null] = ACTIONS(3136),
    [sym_inf] = ACTIONS(3136),
    [sym_nan] = ACTIONS(3136),
    [anon_sym_NA] = ACTIONS(1275),
    [anon_sym_NA_integer_] = ACTIONS(1275),
    [anon_sym_NA_real_] = ACTIONS(1275),
    [anon_sym_NA_complex_] = ACTIONS(1275),
    [anon_sym_NA_character_] = ACTIONS(1275),
    [sym_dots] = ACTIONS(3136),
    [sym_dot_dot_i] = ACTIONS(3138),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(545),
    [sym__newline] = ACTIONS(3140),
    [sym__raw_string_literal] = ACTIONS(1281),
    [sym__external_else] = ACTIONS(545),
    [sym__external_open_parenthesis] = ACTIONS(1283),
    [sym__external_close_parenthesis] = ACTIONS(545),
    [sym__external_open_brace] = ACTIONS(1287),
    [sym__external_open_bracket] = ACTIONS(545),
    [sym__external_close_bracket] = ACTIONS(545),
    [sym__external_open_bracket2] = ACTIONS(545),
  },
  [264] = {
    [sym_function_definition] = STATE(1247),
    [sym_if_statement] = STATE(1247),
    [sym_for_statement] = STATE(1247),
    [sym_while_statement] = STATE(1247),
    [sym_repeat_statement] = STATE(1247),
    [sym_braced_expression] = STATE(1247),
    [sym_parenthesized_expression] = STATE(1247),
    [sym_call] = STATE(1247),
    [sym_subset] = STATE(1247),
    [sym_subset2] = STATE(1247),
    [sym_unary_operator] = STATE(1247),
    [sym_binary_operator] = STATE(1247),
    [sym_extract_operator] = STATE(1247),
    [sym_namespace_operator] = STATE(1247),
    [sym_integer] = STATE(1247),
    [sym_complex] = STATE(1247),
    [sym_float] = STATE(1247),
    [sym__hex_literal] = STATE(2272),
    [sym__float_literal] = STATE(2272),
    [sym_string] = STATE(2271),
    [sym__single_quoted_string] = STATE(2273),
    [sym__double_quoted_string] = STATE(2274),
    [sym_na] = STATE(1247),
    [sym__expression] = STATE(1247),
    [sym__string_or_identifier] = STATE(5157),
    [sym__open_parenthesis] = STATE(120),
    [sym__open_brace] = STATE(11),
    [aux_sym_function_definition_repeat1] = STATE(281),
    [sym_identifier] = ACTIONS(1241),
    [anon_sym_BSLASH] = ACTIONS(1243),
    [anon_sym_function] = ACTIONS(1245),
    [anon_sym_EQ] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(1247),
    [anon_sym_for] = ACTIONS(1249),
    [anon_sym_while] = ACTIONS(1251),
    [anon_sym_repeat] = ACTIONS(1253),
    [anon_sym_QMARK] = ACTIONS(1255),
    [anon_sym_TILDE] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1259),
    [anon_sym_PLUS] = ACTIONS(1261),
    [anon_sym_DASH] = ACTIONS(1263),
    [anon_sym_LT_DASH] = ACTIONS(263),
    [anon_sym_LT_LT_DASH] = ACTIONS(263),
    [anon_sym_COLON_EQ] = ACTIONS(263),
    [anon_sym_DASH_GT] = ACTIONS(265),
    [anon_sym_DASH_GT_GT] = ACTIONS(263),
    [anon_sym_PIPE] = ACTIONS(265),
    [anon_sym_AMP] = ACTIONS(265),
    [anon_sym_PIPE_PIPE] = ACTIONS(263),
    [anon_sym_AMP_AMP] = ACTIONS(263),
    [anon_sym_LT] = ACTIONS(265),
    [anon_sym_LT_EQ] = ACTIONS(263),
    [anon_sym_GT] = ACTIONS(265),
    [anon_sym_GT_EQ] = ACTIONS(263),
    [anon_sym_EQ_EQ] = ACTIONS(263),
    [anon_sym_BANG_EQ] = ACTIONS(263),
    [anon_sym_STAR] = ACTIONS(265),
    [anon_sym_SLASH] = ACTIONS(263),
    [anon_sym_STAR_STAR] = ACTIONS(263),
    [anon_sym_CARET] = ACTIONS(263),
    [aux_sym_binary_operator_token1] = ACTIONS(263),
    [anon_sym_PIPE_GT] = ACTIONS(263),
    [anon_sym_COLON] = ACTIONS(265),
    [anon_sym_DOLLAR] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(263),
    [aux_sym__hex_literal_token1] = ACTIONS(1265),
    [sym__number_literal] = ACTIONS(1267),
    [anon_sym_SQUOTE] = ACTIONS(1269),
    [anon_sym_DQUOTE] = ACTIONS(1271),
    [sym_return] = ACTIONS(3142),
    [sym_next] = ACTIONS(3142),
    [sym_break] = ACTIONS(3142),
    [sym_true] = ACTIONS(3142),
    [sym_false] = ACTIONS(3142),
    [sym_null] = ACTIONS(3142),
    [sym_inf] = ACTIONS(3142),
    [sym_nan] = ACTIONS(3142),
    [anon_sym_NA] = ACTIONS(1275),
    [anon_sym_NA_integer_] = ACTIONS(1275),
    [anon_sym_NA_real_] = ACTIONS(1275),
    [anon_sym_NA_complex_] = ACTIONS(1275),
    [anon_sym_NA_character_] = ACTIONS(1275),
    [sym_dots] = ACTIONS(3142),
    [sym_dot_dot_i] = ACTIONS(3144),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(263),
    [sym__newline] = ACTIONS(3146),
    [sym__raw_string_literal] = ACTIONS(1281),
    [sym__external_else] = ACTIONS(263),
    [sym__external_open_parenthesis] = ACTIONS(1283),
    [sym__external_close_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(1287),
    [sym__external_open_bracket] = ACTIONS(263),
    [sym__external_close_bracket] = ACTIONS(263),
    [sym__external_open_bracket2] = ACTIONS(263),
  },
  [265] = {
    [sym_function_definition] = STATE(981),
    [sym_if_statement] = STATE(981),
    [sym_for_statement] = STATE(981),
    [sym_while_statement] = STATE(981),
    [sym_repeat_statement] = STATE(981),
    [sym_braced_expression] = STATE(981),
    [sym_parenthesized_expression] = STATE(981),
    [sym_call] = STATE(981),
    [sym_subset] = STATE(981),
    [sym_subset2] = STATE(981),
    [sym_unary_operator] = STATE(981),
    [sym_binary_operator] = STATE(981),
    [sym_extract_operator] = STATE(981),
    [sym_namespace_operator] = STATE(981),
    [sym_integer] = STATE(981),
    [sym_complex] = STATE(981),
    [sym_float] = STATE(981),
    [sym__hex_literal] = STATE(2356),
    [sym__float_literal] = STATE(2356),
    [sym_string] = STATE(2231),
    [sym__single_quoted_string] = STATE(2355),
    [sym__double_quoted_string] = STATE(2354),
    [sym_na] = STATE(981),
    [sym__expression] = STATE(981),
    [sym__string_or_identifier] = STATE(5156),
    [sym__open_parenthesis] = STATE(190),
    [sym__open_brace] = STATE(94),
    [aux_sym_function_definition_repeat1] = STATE(2465),
    [ts_builtin_sym_end] = ACTIONS(765),
    [sym_identifier] = ACTIONS(1337),
    [anon_sym_BSLASH] = ACTIONS(1339),
    [anon_sym_function] = ACTIONS(1341),
    [anon_sym_EQ] = ACTIONS(767),
    [anon_sym_if] = ACTIONS(1343),
    [anon_sym_for] = ACTIONS(1345),
    [anon_sym_while] = ACTIONS(1347),
    [anon_sym_repeat] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_BANG] = ACTIONS(1355),
    [anon_sym_PLUS] = ACTIONS(1357),
    [anon_sym_DASH] = ACTIONS(1359),
    [anon_sym_LT_DASH] = ACTIONS(765),
    [anon_sym_LT_LT_DASH] = ACTIONS(765),
    [anon_sym_COLON_EQ] = ACTIONS(765),
    [anon_sym_DASH_GT] = ACTIONS(767),
    [anon_sym_DASH_GT_GT] = ACTIONS(765),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_AMP] = ACTIONS(767),
    [anon_sym_PIPE_PIPE] = ACTIONS(765),
    [anon_sym_AMP_AMP] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(767),
    [anon_sym_LT_EQ] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_GT_EQ] = ACTIONS(765),
    [anon_sym_EQ_EQ] = ACTIONS(765),
    [anon_sym_BANG_EQ] = ACTIONS(765),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(765),
    [anon_sym_STAR_STAR] = ACTIONS(765),
    [anon_sym_CARET] = ACTIONS(765),
    [aux_sym_binary_operator_token1] = ACTIONS(765),
    [anon_sym_PIPE_GT] = ACTIONS(765),
    [anon_sym_COLON] = ACTIONS(767),
    [anon_sym_DOLLAR] = ACTIONS(765),
    [anon_sym_AT] = ACTIONS(765),
    [aux_sym__hex_literal_token1] = ACTIONS(1361),
    [sym__number_literal] = ACTIONS(1363),
    [anon_sym_SQUOTE] = ACTIONS(1365),
    [anon_sym_DQUOTE] = ACTIONS(1367),
    [sym_return] = ACTIONS(3148),
    [sym_next] = ACTIONS(3148),
    [sym_break] = ACTIONS(3148),
    [sym_true] = ACTIONS(3148),
    [sym_false] = ACTIONS(3148),
    [sym_null] = ACTIONS(3148),
    [sym_inf] = ACTIONS(3148),
    [sym_nan] = ACTIONS(3148),
    [anon_sym_NA] = ACTIONS(1371),
    [anon_sym_NA_integer_] = ACTIONS(1371),
    [anon_sym_NA_real_] = ACTIONS(1371),
    [anon_sym_NA_complex_] = ACTIONS(1371),
    [anon_sym_NA_character_] = ACTIONS(1371),
    [sym_dots] = ACTIONS(3148),
    [sym_dot_dot_i] = ACTIONS(3150),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(765),
    [sym__semicolon] = ACTIONS(765),
    [sym__raw_string_literal] = ACTIONS(1377),
    [sym__external_else] = ACTIONS(765),
    [sym__external_open_parenthesis] = ACTIONS(1379),
    [sym__external_close_parenthesis] = ACTIONS(765),
    [sym__external_open_brace] = ACTIONS(1383),
    [sym__external_open_bracket] = ACTIONS(765),
    [sym__external_open_bracket2] = ACTIONS(765),
  },
  [266] = {
    [sym_function_definition] = STATE(1146),
    [sym_if_statement] = STATE(1146),
    [sym_for_statement] = STATE(1146),
    [sym_while_statement] = STATE(1146),
    [sym_repeat_statement] = STATE(1146),
    [sym_braced_expression] = STATE(1146),
    [sym_parenthesized_expression] = STATE(1146),
    [sym_call] = STATE(1146),
    [sym_subset] = STATE(1146),
    [sym_subset2] = STATE(1146),
    [sym_unary_operator] = STATE(1146),
    [sym_binary_operator] = STATE(1146),
    [sym_extract_operator] = STATE(1146),
    [sym_namespace_operator] = STATE(1146),
    [sym_integer] = STATE(1146),
    [sym_complex] = STATE(1146),
    [sym_float] = STATE(1146),
    [sym__hex_literal] = STATE(2266),
    [sym__float_literal] = STATE(2266),
    [sym_string] = STATE(2284),
    [sym__single_quoted_string] = STATE(2265),
    [sym__double_quoted_string] = STATE(2264),
    [sym_na] = STATE(1146),
    [sym__expression] = STATE(1146),
    [sym__string_or_identifier] = STATE(5147),
    [sym__open_parenthesis] = STATE(23),
    [sym__open_brace] = STATE(180),
    [aux_sym_function_definition_repeat1] = STATE(2398),
    [sym_identifier] = ACTIONS(1289),
    [anon_sym_BSLASH] = ACTIONS(1291),
    [anon_sym_function] = ACTIONS(1293),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_if] = ACTIONS(1295),
    [anon_sym_for] = ACTIONS(1297),
    [anon_sym_while] = ACTIONS(1299),
    [anon_sym_repeat] = ACTIONS(1301),
    [anon_sym_QMARK] = ACTIONS(1303),
    [anon_sym_TILDE] = ACTIONS(1305),
    [anon_sym_BANG] = ACTIONS(1307),
    [anon_sym_PLUS] = ACTIONS(1309),
    [anon_sym_DASH] = ACTIONS(1311),
    [anon_sym_LT_DASH] = ACTIONS(471),
    [anon_sym_LT_LT_DASH] = ACTIONS(471),
    [anon_sym_COLON_EQ] = ACTIONS(471),
    [anon_sym_DASH_GT] = ACTIONS(473),
    [anon_sym_DASH_GT_GT] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(473),
    [anon_sym_AMP] = ACTIONS(473),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_LT_EQ] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(473),
    [anon_sym_GT_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_STAR] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [aux_sym_binary_operator_token1] = ACTIONS(471),
    [anon_sym_PIPE_GT] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(473),
    [anon_sym_DOLLAR] = ACTIONS(471),
    [anon_sym_AT] = ACTIONS(471),
    [aux_sym__hex_literal_token1] = ACTIONS(1313),
    [sym__number_literal] = ACTIONS(1315),
    [anon_sym_SQUOTE] = ACTIONS(1317),
    [anon_sym_DQUOTE] = ACTIONS(1319),
    [sym_return] = ACTIONS(3152),
    [sym_next] = ACTIONS(3152),
    [sym_break] = ACTIONS(3152),
    [sym_true] = ACTIONS(3152),
    [sym_false] = ACTIONS(3152),
    [sym_null] = ACTIONS(3152),
    [sym_inf] = ACTIONS(3152),
    [sym_nan] = ACTIONS(3152),
    [anon_sym_NA] = ACTIONS(1323),
    [anon_sym_NA_integer_] = ACTIONS(1323),
    [anon_sym_NA_real_] = ACTIONS(1323),
    [anon_sym_NA_complex_] = ACTIONS(1323),
    [anon_sym_NA_character_] = ACTIONS(1323),
    [sym_dots] = ACTIONS(3152),
    [sym_dot_dot_i] = ACTIONS(3154),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(471),
    [sym__newline] = ACTIONS(471),
    [sym__semicolon] = ACTIONS(471),
    [sym__raw_string_literal] = ACTIONS(1329),
    [sym__external_open_parenthesis] = ACTIONS(1331),
    [sym__external_open_brace] = ACTIONS(1333),
    [sym__external_close_brace] = ACTIONS(471),
    [sym__external_open_bracket] = ACTIONS(471),
    [sym__external_close_bracket] = ACTIONS(471),
    [sym__external_open_bracket2] = ACTIONS(471),
  },
  [267] = {
    [sym_function_definition] = STATE(1154),
    [sym_if_statement] = STATE(1154),
    [sym_for_statement] = STATE(1154),
    [sym_while_statement] = STATE(1154),
    [sym_repeat_statement] = STATE(1154),
    [sym_braced_expression] = STATE(1154),
    [sym_parenthesized_expression] = STATE(1154),
    [sym_call] = STATE(1154),
    [sym_subset] = STATE(1154),
    [sym_subset2] = STATE(1154),
    [sym_unary_operator] = STATE(1154),
    [sym_binary_operator] = STATE(1154),
    [sym_extract_operator] = STATE(1154),
    [sym_namespace_operator] = STATE(1154),
    [sym_integer] = STATE(1154),
    [sym_complex] = STATE(1154),
    [sym_float] = STATE(1154),
    [sym__hex_literal] = STATE(2266),
    [sym__float_literal] = STATE(2266),
    [sym_string] = STATE(2284),
    [sym__single_quoted_string] = STATE(2265),
    [sym__double_quoted_string] = STATE(2264),
    [sym_na] = STATE(1154),
    [sym__expression] = STATE(1154),
    [sym__string_or_identifier] = STATE(5147),
    [sym__open_parenthesis] = STATE(23),
    [sym__open_brace] = STATE(180),
    [aux_sym_function_definition_repeat1] = STATE(266),
    [sym_identifier] = ACTIONS(1289),
    [anon_sym_BSLASH] = ACTIONS(1291),
    [anon_sym_function] = ACTIONS(1293),
    [anon_sym_EQ] = ACTIONS(463),
    [anon_sym_if] = ACTIONS(1295),
    [anon_sym_for] = ACTIONS(1297),
    [anon_sym_while] = ACTIONS(1299),
    [anon_sym_repeat] = ACTIONS(1301),
    [anon_sym_QMARK] = ACTIONS(1303),
    [anon_sym_TILDE] = ACTIONS(1305),
    [anon_sym_BANG] = ACTIONS(1307),
    [anon_sym_PLUS] = ACTIONS(1309),
    [anon_sym_DASH] = ACTIONS(1311),
    [anon_sym_LT_DASH] = ACTIONS(461),
    [anon_sym_LT_LT_DASH] = ACTIONS(461),
    [anon_sym_COLON_EQ] = ACTIONS(461),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_DASH_GT_GT] = ACTIONS(461),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_PIPE_PIPE] = ACTIONS(461),
    [anon_sym_AMP_AMP] = ACTIONS(461),
    [anon_sym_LT] = ACTIONS(463),
    [anon_sym_LT_EQ] = ACTIONS(461),
    [anon_sym_GT] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(461),
    [anon_sym_EQ_EQ] = ACTIONS(461),
    [anon_sym_BANG_EQ] = ACTIONS(461),
    [anon_sym_STAR] = ACTIONS(463),
    [anon_sym_SLASH] = ACTIONS(461),
    [anon_sym_STAR_STAR] = ACTIONS(461),
    [anon_sym_CARET] = ACTIONS(461),
    [aux_sym_binary_operator_token1] = ACTIONS(461),
    [anon_sym_PIPE_GT] = ACTIONS(461),
    [anon_sym_COLON] = ACTIONS(463),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_AT] = ACTIONS(461),
    [aux_sym__hex_literal_token1] = ACTIONS(1313),
    [sym__number_literal] = ACTIONS(1315),
    [anon_sym_SQUOTE] = ACTIONS(1317),
    [anon_sym_DQUOTE] = ACTIONS(1319),
    [sym_return] = ACTIONS(3156),
    [sym_next] = ACTIONS(3156),
    [sym_break] = ACTIONS(3156),
    [sym_true] = ACTIONS(3156),
    [sym_false] = ACTIONS(3156),
    [sym_null] = ACTIONS(3156),
    [sym_inf] = ACTIONS(3156),
    [sym_nan] = ACTIONS(3156),
    [anon_sym_NA] = ACTIONS(1323),
    [anon_sym_NA_integer_] = ACTIONS(1323),
    [anon_sym_NA_real_] = ACTIONS(1323),
    [anon_sym_NA_complex_] = ACTIONS(1323),
    [anon_sym_NA_character_] = ACTIONS(1323),
    [sym_dots] = ACTIONS(3156),
    [sym_dot_dot_i] = ACTIONS(3158),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(461),
    [sym__newline] = ACTIONS(3160),
    [sym__semicolon] = ACTIONS(461),
    [sym__raw_string_literal] = ACTIONS(1329),
    [sym__external_open_parenthesis] = ACTIONS(1331),
    [sym__external_open_brace] = ACTIONS(1333),
    [sym__external_close_brace] = ACTIONS(461),
    [sym__external_open_bracket] = ACTIONS(461),
    [sym__external_close_bracket] = ACTIONS(461),
    [sym__external_open_bracket2] = ACTIONS(461),
  },
  [268] = {
    [sym_function_definition] = STATE(1156),
    [sym_if_statement] = STATE(1156),
    [sym_for_statement] = STATE(1156),
    [sym_while_statement] = STATE(1156),
    [sym_repeat_statement] = STATE(1156),
    [sym_braced_expression] = STATE(1156),
    [sym_parenthesized_expression] = STATE(1156),
    [sym_call] = STATE(1156),
    [sym_subset] = STATE(1156),
    [sym_subset2] = STATE(1156),
    [sym_unary_operator] = STATE(1156),
    [sym_binary_operator] = STATE(1156),
    [sym_extract_operator] = STATE(1156),
    [sym_namespace_operator] = STATE(1156),
    [sym_integer] = STATE(1156),
    [sym_complex] = STATE(1156),
    [sym_float] = STATE(1156),
    [sym__hex_literal] = STATE(2266),
    [sym__float_literal] = STATE(2266),
    [sym_string] = STATE(2284),
    [sym__single_quoted_string] = STATE(2265),
    [sym__double_quoted_string] = STATE(2264),
    [sym_na] = STATE(1156),
    [sym__expression] = STATE(1156),
    [sym__string_or_identifier] = STATE(5147),
    [sym__open_parenthesis] = STATE(23),
    [sym__open_brace] = STATE(180),
    [aux_sym_function_definition_repeat1] = STATE(2398),
    [sym_identifier] = ACTIONS(1289),
    [anon_sym_BSLASH] = ACTIONS(1291),
    [anon_sym_function] = ACTIONS(1293),
    [anon_sym_EQ] = ACTIONS(455),
    [anon_sym_if] = ACTIONS(1295),
    [anon_sym_for] = ACTIONS(1297),
    [anon_sym_while] = ACTIONS(1299),
    [anon_sym_repeat] = ACTIONS(1301),
    [anon_sym_QMARK] = ACTIONS(1303),
    [anon_sym_TILDE] = ACTIONS(1305),
    [anon_sym_BANG] = ACTIONS(1307),
    [anon_sym_PLUS] = ACTIONS(1309),
    [anon_sym_DASH] = ACTIONS(1311),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [anon_sym_LT_LT_DASH] = ACTIONS(453),
    [anon_sym_COLON_EQ] = ACTIONS(453),
    [anon_sym_DASH_GT] = ACTIONS(455),
    [anon_sym_DASH_GT_GT] = ACTIONS(453),
    [anon_sym_PIPE] = ACTIONS(455),
    [anon_sym_AMP] = ACTIONS(455),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(455),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_GT] = ACTIONS(455),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(453),
    [anon_sym_STAR] = ACTIONS(455),
    [anon_sym_SLASH] = ACTIONS(453),
    [anon_sym_STAR_STAR] = ACTIONS(453),
    [anon_sym_CARET] = ACTIONS(453),
    [aux_sym_binary_operator_token1] = ACTIONS(453),
    [anon_sym_PIPE_GT] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(455),
    [anon_sym_DOLLAR] = ACTIONS(453),
    [anon_sym_AT] = ACTIONS(453),
    [aux_sym__hex_literal_token1] = ACTIONS(1313),
    [sym__number_literal] = ACTIONS(1315),
    [anon_sym_SQUOTE] = ACTIONS(1317),
    [anon_sym_DQUOTE] = ACTIONS(1319),
    [sym_return] = ACTIONS(3162),
    [sym_next] = ACTIONS(3162),
    [sym_break] = ACTIONS(3162),
    [sym_true] = ACTIONS(3162),
    [sym_false] = ACTIONS(3162),
    [sym_null] = ACTIONS(3162),
    [sym_inf] = ACTIONS(3162),
    [sym_nan] = ACTIONS(3162),
    [anon_sym_NA] = ACTIONS(1323),
    [anon_sym_NA_integer_] = ACTIONS(1323),
    [anon_sym_NA_real_] = ACTIONS(1323),
    [anon_sym_NA_complex_] = ACTIONS(1323),
    [anon_sym_NA_character_] = ACTIONS(1323),
    [sym_dots] = ACTIONS(3162),
    [sym_dot_dot_i] = ACTIONS(3164),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(453),
    [sym__newline] = ACTIONS(453),
    [sym__semicolon] = ACTIONS(453),
    [sym__raw_string_literal] = ACTIONS(1329),
    [sym__external_open_parenthesis] = ACTIONS(1331),
    [sym__external_open_brace] = ACTIONS(1333),
    [sym__external_close_brace] = ACTIONS(453),
    [sym__external_open_bracket] = ACTIONS(453),
    [sym__external_close_bracket] = ACTIONS(453),
    [sym__external_open_bracket2] = ACTIONS(453),
  },
  [269] = {
    [sym_function_definition] = STATE(1163),
    [sym_if_statement] = STATE(1163),
    [sym_for_statement] = STATE(1163),
    [sym_while_statement] = STATE(1163),
    [sym_repeat_statement] = STATE(1163),
    [sym_braced_expression] = STATE(1163),
    [sym_parenthesized_expression] = STATE(1163),
    [sym_call] = STATE(1163),
    [sym_subset] = STATE(1163),
    [sym_subset2] = STATE(1163),
    [sym_unary_operator] = STATE(1163),
    [sym_binary_operator] = STATE(1163),
    [sym_extract_operator] = STATE(1163),
    [sym_namespace_operator] = STATE(1163),
    [sym_integer] = STATE(1163),
    [sym_complex] = STATE(1163),
    [sym_float] = STATE(1163),
    [sym__hex_literal] = STATE(2266),
    [sym__float_literal] = STATE(2266),
    [sym_string] = STATE(2284),
    [sym__single_quoted_string] = STATE(2265),
    [sym__double_quoted_string] = STATE(2264),
    [sym_na] = STATE(1163),
    [sym__expression] = STATE(1163),
    [sym__string_or_identifier] = STATE(5147),
    [sym__open_parenthesis] = STATE(23),
    [sym__open_brace] = STATE(180),
    [aux_sym_function_definition_repeat1] = STATE(2398),
    [sym_identifier] = ACTIONS(1289),
    [anon_sym_BSLASH] = ACTIONS(1291),
    [anon_sym_function] = ACTIONS(1293),
    [anon_sym_EQ] = ACTIONS(399),
    [anon_sym_if] = ACTIONS(1295),
    [anon_sym_for] = ACTIONS(1297),
    [anon_sym_while] = ACTIONS(1299),
    [anon_sym_repeat] = ACTIONS(1301),
    [anon_sym_QMARK] = ACTIONS(1303),
    [anon_sym_TILDE] = ACTIONS(1305),
    [anon_sym_BANG] = ACTIONS(1307),
    [anon_sym_PLUS] = ACTIONS(1309),
    [anon_sym_DASH] = ACTIONS(1311),
    [anon_sym_LT_DASH] = ACTIONS(397),
    [anon_sym_LT_LT_DASH] = ACTIONS(397),
    [anon_sym_COLON_EQ] = ACTIONS(397),
    [anon_sym_DASH_GT] = ACTIONS(399),
    [anon_sym_DASH_GT_GT] = ACTIONS(397),
    [anon_sym_PIPE] = ACTIONS(399),
    [anon_sym_AMP] = ACTIONS(399),
    [anon_sym_PIPE_PIPE] = ACTIONS(397),
    [anon_sym_AMP_AMP] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(399),
    [anon_sym_LT_EQ] = ACTIONS(397),
    [anon_sym_GT] = ACTIONS(399),
    [anon_sym_GT_EQ] = ACTIONS(397),
    [anon_sym_EQ_EQ] = ACTIONS(397),
    [anon_sym_BANG_EQ] = ACTIONS(397),
    [anon_sym_STAR] = ACTIONS(399),
    [anon_sym_SLASH] = ACTIONS(397),
    [anon_sym_STAR_STAR] = ACTIONS(397),
    [anon_sym_CARET] = ACTIONS(397),
    [aux_sym_binary_operator_token1] = ACTIONS(397),
    [anon_sym_PIPE_GT] = ACTIONS(397),
    [anon_sym_COLON] = ACTIONS(399),
    [anon_sym_DOLLAR] = ACTIONS(397),
    [anon_sym_AT] = ACTIONS(397),
    [aux_sym__hex_literal_token1] = ACTIONS(1313),
    [sym__number_literal] = ACTIONS(1315),
    [anon_sym_SQUOTE] = ACTIONS(1317),
    [anon_sym_DQUOTE] = ACTIONS(1319),
    [sym_return] = ACTIONS(3166),
    [sym_next] = ACTIONS(3166),
    [sym_break] = ACTIONS(3166),
    [sym_true] = ACTIONS(3166),
    [sym_false] = ACTIONS(3166),
    [sym_null] = ACTIONS(3166),
    [sym_inf] = ACTIONS(3166),
    [sym_nan] = ACTIONS(3166),
    [anon_sym_NA] = ACTIONS(1323),
    [anon_sym_NA_integer_] = ACTIONS(1323),
    [anon_sym_NA_real_] = ACTIONS(1323),
    [anon_sym_NA_complex_] = ACTIONS(1323),
    [anon_sym_NA_character_] = ACTIONS(1323),
    [sym_dots] = ACTIONS(3166),
    [sym_dot_dot_i] = ACTIONS(3168),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(397),
    [sym__newline] = ACTIONS(397),
    [sym__semicolon] = ACTIONS(397),
    [sym__raw_string_literal] = ACTIONS(1329),
    [sym__external_open_parenthesis] = ACTIONS(1331),
    [sym__external_open_brace] = ACTIONS(1333),
    [sym__external_close_brace] = ACTIONS(397),
    [sym__external_open_bracket] = ACTIONS(397),
    [sym__external_close_bracket] = ACTIONS(397),
    [sym__external_open_bracket2] = ACTIONS(397),
  },
  [270] = {
    [sym_function_definition] = STATE(1354),
    [sym_if_statement] = STATE(1354),
    [sym_for_statement] = STATE(1354),
    [sym_while_statement] = STATE(1354),
    [sym_repeat_statement] = STATE(1354),
    [sym_braced_expression] = STATE(1354),
    [sym_parenthesized_expression] = STATE(1354),
    [sym_call] = STATE(1354),
    [sym_subset] = STATE(1354),
    [sym_subset2] = STATE(1354),
    [sym_unary_operator] = STATE(1354),
    [sym_binary_operator] = STATE(1354),
    [sym_extract_operator] = STATE(1354),
    [sym_namespace_operator] = STATE(1354),
    [sym_integer] = STATE(1354),
    [sym_complex] = STATE(1354),
    [sym_float] = STATE(1354),
    [sym__hex_literal] = STATE(2540),
    [sym__float_literal] = STATE(2540),
    [sym_string] = STATE(2541),
    [sym__single_quoted_string] = STATE(2462),
    [sym__double_quoted_string] = STATE(2494),
    [sym_na] = STATE(1354),
    [sym__expression] = STATE(1354),
    [sym__string_or_identifier] = STATE(5128),
    [sym__open_parenthesis] = STATE(246),
    [sym__close_parenthesis] = STATE(2877),
    [sym__open_brace] = STATE(173),
    [aux_sym_parenthesized_expression_repeat1] = STATE(414),
    [ts_builtin_sym_end] = ACTIONS(211),
    [sym_identifier] = ACTIONS(2943),
    [anon_sym_BSLASH] = ACTIONS(2945),
    [anon_sym_function] = ACTIONS(2947),
    [anon_sym_EQ] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(2949),
    [anon_sym_for] = ACTIONS(2951),
    [anon_sym_while] = ACTIONS(2953),
    [anon_sym_repeat] = ACTIONS(2955),
    [anon_sym_QMARK] = ACTIONS(2957),
    [anon_sym_TILDE] = ACTIONS(2959),
    [anon_sym_BANG] = ACTIONS(2961),
    [anon_sym_PLUS] = ACTIONS(2963),
    [anon_sym_DASH] = ACTIONS(2965),
    [anon_sym_LT_DASH] = ACTIONS(211),
    [anon_sym_LT_LT_DASH] = ACTIONS(211),
    [anon_sym_COLON_EQ] = ACTIONS(211),
    [anon_sym_DASH_GT] = ACTIONS(209),
    [anon_sym_DASH_GT_GT] = ACTIONS(211),
    [anon_sym_PIPE] = ACTIONS(209),
    [anon_sym_AMP] = ACTIONS(209),
    [anon_sym_PIPE_PIPE] = ACTIONS(211),
    [anon_sym_AMP_AMP] = ACTIONS(211),
    [anon_sym_LT] = ACTIONS(209),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_GT] = ACTIONS(209),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [anon_sym_EQ_EQ] = ACTIONS(211),
    [anon_sym_BANG_EQ] = ACTIONS(211),
    [anon_sym_STAR] = ACTIONS(209),
    [anon_sym_SLASH] = ACTIONS(211),
    [anon_sym_STAR_STAR] = ACTIONS(211),
    [anon_sym_CARET] = ACTIONS(211),
    [aux_sym_binary_operator_token1] = ACTIONS(211),
    [anon_sym_PIPE_GT] = ACTIONS(211),
    [anon_sym_COLON] = ACTIONS(209),
    [anon_sym_DOLLAR] = ACTIONS(211),
    [anon_sym_AT] = ACTIONS(211),
    [aux_sym__hex_literal_token1] = ACTIONS(2967),
    [sym__number_literal] = ACTIONS(2969),
    [anon_sym_SQUOTE] = ACTIONS(2971),
    [anon_sym_DQUOTE] = ACTIONS(2973),
    [sym_return] = ACTIONS(2975),
    [sym_next] = ACTIONS(2975),
    [sym_break] = ACTIONS(2975),
    [sym_true] = ACTIONS(2975),
    [sym_false] = ACTIONS(2975),
    [sym_null] = ACTIONS(2975),
    [sym_inf] = ACTIONS(2975),
    [sym_nan] = ACTIONS(2975),
    [anon_sym_NA] = ACTIONS(2977),
    [anon_sym_NA_integer_] = ACTIONS(2977),
    [anon_sym_NA_real_] = ACTIONS(2977),
    [anon_sym_NA_complex_] = ACTIONS(2977),
    [anon_sym_NA_character_] = ACTIONS(2977),
    [sym_dots] = ACTIONS(2975),
    [sym_dot_dot_i] = ACTIONS(2979),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(2981),
    [sym__semicolon] = ACTIONS(211),
    [sym__raw_string_literal] = ACTIONS(2983),
    [sym__external_open_parenthesis] = ACTIONS(2985),
    [sym__external_close_parenthesis] = ACTIONS(3170),
    [sym__external_open_brace] = ACTIONS(2989),
    [sym__external_open_bracket] = ACTIONS(211),
    [sym__external_open_bracket2] = ACTIONS(211),
  },
  [271] = {
    [sym_function_definition] = STATE(1133),
    [sym_if_statement] = STATE(1133),
    [sym_for_statement] = STATE(1133),
    [sym_while_statement] = STATE(1133),
    [sym_repeat_statement] = STATE(1133),
    [sym_braced_expression] = STATE(1133),
    [sym_parenthesized_expression] = STATE(1133),
    [sym_call] = STATE(1133),
    [sym_subset] = STATE(1133),
    [sym_subset2] = STATE(1133),
    [sym_unary_operator] = STATE(1133),
    [sym_binary_operator] = STATE(1133),
    [sym_extract_operator] = STATE(1133),
    [sym_namespace_operator] = STATE(1133),
    [sym_integer] = STATE(1133),
    [sym_complex] = STATE(1133),
    [sym_float] = STATE(1133),
    [sym__hex_literal] = STATE(2288),
    [sym__float_literal] = STATE(2288),
    [sym_string] = STATE(2287),
    [sym__single_quoted_string] = STATE(2289),
    [sym__double_quoted_string] = STATE(2290),
    [sym_na] = STATE(1133),
    [sym__expression] = STATE(1133),
    [sym__string_or_identifier] = STATE(5144),
    [sym__open_parenthesis] = STATE(119),
    [sym__open_brace] = STATE(16),
    [aux_sym_parenthesized_expression_repeat1] = STATE(271),
    [sym_identifier] = ACTIONS(3172),
    [anon_sym_BSLASH] = ACTIONS(3175),
    [anon_sym_function] = ACTIONS(3178),
    [anon_sym_EQ] = ACTIONS(814),
    [anon_sym_if] = ACTIONS(3181),
    [anon_sym_for] = ACTIONS(3184),
    [anon_sym_while] = ACTIONS(3187),
    [anon_sym_repeat] = ACTIONS(3190),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3196),
    [anon_sym_BANG] = ACTIONS(3199),
    [anon_sym_PLUS] = ACTIONS(3202),
    [anon_sym_DASH] = ACTIONS(3205),
    [anon_sym_LT_DASH] = ACTIONS(803),
    [anon_sym_LT_LT_DASH] = ACTIONS(803),
    [anon_sym_COLON_EQ] = ACTIONS(803),
    [anon_sym_DASH_GT] = ACTIONS(814),
    [anon_sym_DASH_GT_GT] = ACTIONS(803),
    [anon_sym_PIPE] = ACTIONS(814),
    [anon_sym_AMP] = ACTIONS(814),
    [anon_sym_PIPE_PIPE] = ACTIONS(803),
    [anon_sym_AMP_AMP] = ACTIONS(803),
    [anon_sym_LT] = ACTIONS(814),
    [anon_sym_LT_EQ] = ACTIONS(803),
    [anon_sym_GT] = ACTIONS(814),
    [anon_sym_GT_EQ] = ACTIONS(803),
    [anon_sym_EQ_EQ] = ACTIONS(803),
    [anon_sym_BANG_EQ] = ACTIONS(803),
    [anon_sym_STAR] = ACTIONS(814),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_STAR_STAR] = ACTIONS(803),
    [anon_sym_CARET] = ACTIONS(803),
    [aux_sym_binary_operator_token1] = ACTIONS(803),
    [anon_sym_PIPE_GT] = ACTIONS(803),
    [anon_sym_COLON] = ACTIONS(814),
    [anon_sym_DOLLAR] = ACTIONS(803),
    [anon_sym_AT] = ACTIONS(803),
    [aux_sym__hex_literal_token1] = ACTIONS(3208),
    [sym__number_literal] = ACTIONS(3211),
    [anon_sym_SQUOTE] = ACTIONS(3214),
    [anon_sym_DQUOTE] = ACTIONS(3217),
    [sym_return] = ACTIONS(3220),
    [sym_next] = ACTIONS(3220),
    [sym_break] = ACTIONS(3220),
    [sym_true] = ACTIONS(3220),
    [sym_false] = ACTIONS(3220),
    [sym_null] = ACTIONS(3220),
    [sym_inf] = ACTIONS(3220),
    [sym_nan] = ACTIONS(3220),
    [anon_sym_NA] = ACTIONS(3223),
    [anon_sym_NA_integer_] = ACTIONS(3223),
    [anon_sym_NA_real_] = ACTIONS(3223),
    [anon_sym_NA_complex_] = ACTIONS(3223),
    [anon_sym_NA_character_] = ACTIONS(3223),
    [sym_dots] = ACTIONS(3220),
    [sym_dot_dot_i] = ACTIONS(3226),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(803),
    [sym__newline] = ACTIONS(3229),
    [sym__raw_string_literal] = ACTIONS(3232),
    [sym__external_else] = ACTIONS(803),
    [sym__external_open_parenthesis] = ACTIONS(3235),
    [sym__external_close_parenthesis] = ACTIONS(803),
    [sym__external_open_brace] = ACTIONS(3238),
    [sym__external_open_bracket] = ACTIONS(803),
    [sym__external_open_bracket2] = ACTIONS(803),
    [sym__external_close_bracket2] = ACTIONS(803),
  },
  [272] = {
    [sym_function_definition] = STATE(1164),
    [sym_if_statement] = STATE(1164),
    [sym_for_statement] = STATE(1164),
    [sym_while_statement] = STATE(1164),
    [sym_repeat_statement] = STATE(1164),
    [sym_braced_expression] = STATE(1164),
    [sym_parenthesized_expression] = STATE(1164),
    [sym_call] = STATE(1164),
    [sym_subset] = STATE(1164),
    [sym_subset2] = STATE(1164),
    [sym_unary_operator] = STATE(1164),
    [sym_binary_operator] = STATE(1164),
    [sym_extract_operator] = STATE(1164),
    [sym_namespace_operator] = STATE(1164),
    [sym_integer] = STATE(1164),
    [sym_complex] = STATE(1164),
    [sym_float] = STATE(1164),
    [sym__hex_literal] = STATE(2266),
    [sym__float_literal] = STATE(2266),
    [sym_string] = STATE(2284),
    [sym__single_quoted_string] = STATE(2265),
    [sym__double_quoted_string] = STATE(2264),
    [sym_na] = STATE(1164),
    [sym__expression] = STATE(1164),
    [sym__string_or_identifier] = STATE(5147),
    [sym__open_parenthesis] = STATE(23),
    [sym__open_brace] = STATE(180),
    [aux_sym_function_definition_repeat1] = STATE(268),
    [sym_identifier] = ACTIONS(1289),
    [anon_sym_BSLASH] = ACTIONS(1291),
    [anon_sym_function] = ACTIONS(1293),
    [anon_sym_EQ] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(1295),
    [anon_sym_for] = ACTIONS(1297),
    [anon_sym_while] = ACTIONS(1299),
    [anon_sym_repeat] = ACTIONS(1301),
    [anon_sym_QMARK] = ACTIONS(1303),
    [anon_sym_TILDE] = ACTIONS(1305),
    [anon_sym_BANG] = ACTIONS(1307),
    [anon_sym_PLUS] = ACTIONS(1309),
    [anon_sym_DASH] = ACTIONS(1311),
    [anon_sym_LT_DASH] = ACTIONS(387),
    [anon_sym_LT_LT_DASH] = ACTIONS(387),
    [anon_sym_COLON_EQ] = ACTIONS(387),
    [anon_sym_DASH_GT] = ACTIONS(389),
    [anon_sym_DASH_GT_GT] = ACTIONS(387),
    [anon_sym_PIPE] = ACTIONS(389),
    [anon_sym_AMP] = ACTIONS(389),
    [anon_sym_PIPE_PIPE] = ACTIONS(387),
    [anon_sym_AMP_AMP] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(389),
    [anon_sym_LT_EQ] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(389),
    [anon_sym_GT_EQ] = ACTIONS(387),
    [anon_sym_EQ_EQ] = ACTIONS(387),
    [anon_sym_BANG_EQ] = ACTIONS(387),
    [anon_sym_STAR] = ACTIONS(389),
    [anon_sym_SLASH] = ACTIONS(387),
    [anon_sym_STAR_STAR] = ACTIONS(387),
    [anon_sym_CARET] = ACTIONS(387),
    [aux_sym_binary_operator_token1] = ACTIONS(387),
    [anon_sym_PIPE_GT] = ACTIONS(387),
    [anon_sym_COLON] = ACTIONS(389),
    [anon_sym_DOLLAR] = ACTIONS(387),
    [anon_sym_AT] = ACTIONS(387),
    [aux_sym__hex_literal_token1] = ACTIONS(1313),
    [sym__number_literal] = ACTIONS(1315),
    [anon_sym_SQUOTE] = ACTIONS(1317),
    [anon_sym_DQUOTE] = ACTIONS(1319),
    [sym_return] = ACTIONS(3241),
    [sym_next] = ACTIONS(3241),
    [sym_break] = ACTIONS(3241),
    [sym_true] = ACTIONS(3241),
    [sym_false] = ACTIONS(3241),
    [sym_null] = ACTIONS(3241),
    [sym_inf] = ACTIONS(3241),
    [sym_nan] = ACTIONS(3241),
    [anon_sym_NA] = ACTIONS(1323),
    [anon_sym_NA_integer_] = ACTIONS(1323),
    [anon_sym_NA_real_] = ACTIONS(1323),
    [anon_sym_NA_complex_] = ACTIONS(1323),
    [anon_sym_NA_character_] = ACTIONS(1323),
    [sym_dots] = ACTIONS(3241),
    [sym_dot_dot_i] = ACTIONS(3243),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(387),
    [sym__newline] = ACTIONS(3245),
    [sym__semicolon] = ACTIONS(387),
    [sym__raw_string_literal] = ACTIONS(1329),
    [sym__external_open_parenthesis] = ACTIONS(1331),
    [sym__external_open_brace] = ACTIONS(1333),
    [sym__external_close_brace] = ACTIONS(387),
    [sym__external_open_bracket] = ACTIONS(387),
    [sym__external_close_bracket] = ACTIONS(387),
    [sym__external_open_bracket2] = ACTIONS(387),
  },
  [273] = {
    [sym_function_definition] = STATE(1167),
    [sym_if_statement] = STATE(1167),
    [sym_for_statement] = STATE(1167),
    [sym_while_statement] = STATE(1167),
    [sym_repeat_statement] = STATE(1167),
    [sym_braced_expression] = STATE(1167),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_call] = STATE(1167),
    [sym_subset] = STATE(1167),
    [sym_subset2] = STATE(1167),
    [sym_unary_operator] = STATE(1167),
    [sym_binary_operator] = STATE(1167),
    [sym_extract_operator] = STATE(1167),
    [sym_namespace_operator] = STATE(1167),
    [sym_integer] = STATE(1167),
    [sym_complex] = STATE(1167),
    [sym_float] = STATE(1167),
    [sym__hex_literal] = STATE(2266),
    [sym__float_literal] = STATE(2266),
    [sym_string] = STATE(2284),
    [sym__single_quoted_string] = STATE(2265),
    [sym__double_quoted_string] = STATE(2264),
    [sym_na] = STATE(1167),
    [sym__expression] = STATE(1167),
    [sym__string_or_identifier] = STATE(5147),
    [sym__open_parenthesis] = STATE(23),
    [sym__open_brace] = STATE(180),
    [aux_sym_function_definition_repeat1] = STATE(269),
    [sym_identifier] = ACTIONS(1289),
    [anon_sym_BSLASH] = ACTIONS(1291),
    [anon_sym_function] = ACTIONS(1293),
    [anon_sym_EQ] = ACTIONS(379),
    [anon_sym_if] = ACTIONS(1295),
    [anon_sym_for] = ACTIONS(1297),
    [anon_sym_while] = ACTIONS(1299),
    [anon_sym_repeat] = ACTIONS(1301),
    [anon_sym_QMARK] = ACTIONS(1303),
    [anon_sym_TILDE] = ACTIONS(1305),
    [anon_sym_BANG] = ACTIONS(1307),
    [anon_sym_PLUS] = ACTIONS(1309),
    [anon_sym_DASH] = ACTIONS(1311),
    [anon_sym_LT_DASH] = ACTIONS(377),
    [anon_sym_LT_LT_DASH] = ACTIONS(377),
    [anon_sym_COLON_EQ] = ACTIONS(377),
    [anon_sym_DASH_GT] = ACTIONS(379),
    [anon_sym_DASH_GT_GT] = ACTIONS(377),
    [anon_sym_PIPE] = ACTIONS(379),
    [anon_sym_AMP] = ACTIONS(379),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_LT] = ACTIONS(379),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(379),
    [anon_sym_GT_EQ] = ACTIONS(377),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(379),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_STAR_STAR] = ACTIONS(377),
    [anon_sym_CARET] = ACTIONS(377),
    [aux_sym_binary_operator_token1] = ACTIONS(377),
    [anon_sym_PIPE_GT] = ACTIONS(377),
    [anon_sym_COLON] = ACTIONS(379),
    [anon_sym_DOLLAR] = ACTIONS(377),
    [anon_sym_AT] = ACTIONS(377),
    [aux_sym__hex_literal_token1] = ACTIONS(1313),
    [sym__number_literal] = ACTIONS(1315),
    [anon_sym_SQUOTE] = ACTIONS(1317),
    [anon_sym_DQUOTE] = ACTIONS(1319),
    [sym_return] = ACTIONS(3247),
    [sym_next] = ACTIONS(3247),
    [sym_break] = ACTIONS(3247),
    [sym_true] = ACTIONS(3247),
    [sym_false] = ACTIONS(3247),
    [sym_null] = ACTIONS(3247),
    [sym_inf] = ACTIONS(3247),
    [sym_nan] = ACTIONS(3247),
    [anon_sym_NA] = ACTIONS(1323),
    [anon_sym_NA_integer_] = ACTIONS(1323),
    [anon_sym_NA_real_] = ACTIONS(1323),
    [anon_sym_NA_complex_] = ACTIONS(1323),
    [anon_sym_NA_character_] = ACTIONS(1323),
    [sym_dots] = ACTIONS(3247),
    [sym_dot_dot_i] = ACTIONS(3249),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(377),
    [sym__newline] = ACTIONS(3251),
    [sym__semicolon] = ACTIONS(377),
    [sym__raw_string_literal] = ACTIONS(1329),
    [sym__external_open_parenthesis] = ACTIONS(1331),
    [sym__external_open_brace] = ACTIONS(1333),
    [sym__external_close_brace] = ACTIONS(377),
    [sym__external_open_bracket] = ACTIONS(377),
    [sym__external_close_bracket] = ACTIONS(377),
    [sym__external_open_bracket2] = ACTIONS(377),
  },
  [274] = {
    [sym_function_definition] = STATE(1022),
    [sym_if_statement] = STATE(1022),
    [sym_for_statement] = STATE(1022),
    [sym_while_statement] = STATE(1022),
    [sym_repeat_statement] = STATE(1022),
    [sym_braced_expression] = STATE(1022),
    [sym_parenthesized_expression] = STATE(1022),
    [sym_call] = STATE(1022),
    [sym_subset] = STATE(1022),
    [sym_subset2] = STATE(1022),
    [sym_unary_operator] = STATE(1022),
    [sym_binary_operator] = STATE(1022),
    [sym_extract_operator] = STATE(1022),
    [sym_namespace_operator] = STATE(1022),
    [sym_integer] = STATE(1022),
    [sym_complex] = STATE(1022),
    [sym_float] = STATE(1022),
    [sym__hex_literal] = STATE(2356),
    [sym__float_literal] = STATE(2356),
    [sym_string] = STATE(2231),
    [sym__single_quoted_string] = STATE(2355),
    [sym__double_quoted_string] = STATE(2354),
    [sym_na] = STATE(1022),
    [sym__expression] = STATE(1022),
    [sym__string_or_identifier] = STATE(5156),
    [sym__open_parenthesis] = STATE(190),
    [sym__open_brace] = STATE(94),
    [aux_sym_function_definition_repeat1] = STATE(2465),
    [ts_builtin_sym_end] = ACTIONS(369),
    [sym_identifier] = ACTIONS(1337),
    [anon_sym_BSLASH] = ACTIONS(1339),
    [anon_sym_function] = ACTIONS(1341),
    [anon_sym_EQ] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(1343),
    [anon_sym_for] = ACTIONS(1345),
    [anon_sym_while] = ACTIONS(1347),
    [anon_sym_repeat] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_BANG] = ACTIONS(1355),
    [anon_sym_PLUS] = ACTIONS(1357),
    [anon_sym_DASH] = ACTIONS(1359),
    [anon_sym_LT_DASH] = ACTIONS(369),
    [anon_sym_LT_LT_DASH] = ACTIONS(369),
    [anon_sym_COLON_EQ] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(371),
    [anon_sym_DASH_GT_GT] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(371),
    [anon_sym_AMP] = ACTIONS(371),
    [anon_sym_PIPE_PIPE] = ACTIONS(369),
    [anon_sym_AMP_AMP] = ACTIONS(369),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_LT_EQ] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_EQ] = ACTIONS(369),
    [anon_sym_EQ_EQ] = ACTIONS(369),
    [anon_sym_BANG_EQ] = ACTIONS(369),
    [anon_sym_STAR] = ACTIONS(371),
    [anon_sym_SLASH] = ACTIONS(369),
    [anon_sym_STAR_STAR] = ACTIONS(369),
    [anon_sym_CARET] = ACTIONS(369),
    [aux_sym_binary_operator_token1] = ACTIONS(369),
    [anon_sym_PIPE_GT] = ACTIONS(369),
    [anon_sym_COLON] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(369),
    [anon_sym_AT] = ACTIONS(369),
    [aux_sym__hex_literal_token1] = ACTIONS(1361),
    [sym__number_literal] = ACTIONS(1363),
    [anon_sym_SQUOTE] = ACTIONS(1365),
    [anon_sym_DQUOTE] = ACTIONS(1367),
    [sym_return] = ACTIONS(3253),
    [sym_next] = ACTIONS(3253),
    [sym_break] = ACTIONS(3253),
    [sym_true] = ACTIONS(3253),
    [sym_false] = ACTIONS(3253),
    [sym_null] = ACTIONS(3253),
    [sym_inf] = ACTIONS(3253),
    [sym_nan] = ACTIONS(3253),
    [anon_sym_NA] = ACTIONS(1371),
    [anon_sym_NA_integer_] = ACTIONS(1371),
    [anon_sym_NA_real_] = ACTIONS(1371),
    [anon_sym_NA_complex_] = ACTIONS(1371),
    [anon_sym_NA_character_] = ACTIONS(1371),
    [sym_dots] = ACTIONS(3253),
    [sym_dot_dot_i] = ACTIONS(3255),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(369),
    [sym__semicolon] = ACTIONS(369),
    [sym__raw_string_literal] = ACTIONS(1377),
    [sym__external_else] = ACTIONS(369),
    [sym__external_open_parenthesis] = ACTIONS(1379),
    [sym__external_close_parenthesis] = ACTIONS(369),
    [sym__external_open_brace] = ACTIONS(1383),
    [sym__external_open_bracket] = ACTIONS(369),
    [sym__external_open_bracket2] = ACTIONS(369),
  },
  [275] = {
    [sym_function_definition] = STATE(1168),
    [sym_if_statement] = STATE(1168),
    [sym_for_statement] = STATE(1168),
    [sym_while_statement] = STATE(1168),
    [sym_repeat_statement] = STATE(1168),
    [sym_braced_expression] = STATE(1168),
    [sym_parenthesized_expression] = STATE(1168),
    [sym_call] = STATE(1168),
    [sym_subset] = STATE(1168),
    [sym_subset2] = STATE(1168),
    [sym_unary_operator] = STATE(1168),
    [sym_binary_operator] = STATE(1168),
    [sym_extract_operator] = STATE(1168),
    [sym_namespace_operator] = STATE(1168),
    [sym_integer] = STATE(1168),
    [sym_complex] = STATE(1168),
    [sym_float] = STATE(1168),
    [sym__hex_literal] = STATE(2266),
    [sym__float_literal] = STATE(2266),
    [sym_string] = STATE(2284),
    [sym__single_quoted_string] = STATE(2265),
    [sym__double_quoted_string] = STATE(2264),
    [sym_na] = STATE(1168),
    [sym__expression] = STATE(1168),
    [sym__string_or_identifier] = STATE(5147),
    [sym__open_parenthesis] = STATE(23),
    [sym__open_brace] = STATE(180),
    [aux_sym_function_definition_repeat1] = STATE(2398),
    [sym_identifier] = ACTIONS(1289),
    [anon_sym_BSLASH] = ACTIONS(1291),
    [anon_sym_function] = ACTIONS(1293),
    [anon_sym_EQ] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(1295),
    [anon_sym_for] = ACTIONS(1297),
    [anon_sym_while] = ACTIONS(1299),
    [anon_sym_repeat] = ACTIONS(1301),
    [anon_sym_QMARK] = ACTIONS(1303),
    [anon_sym_TILDE] = ACTIONS(1305),
    [anon_sym_BANG] = ACTIONS(1307),
    [anon_sym_PLUS] = ACTIONS(1309),
    [anon_sym_DASH] = ACTIONS(1311),
    [anon_sym_LT_DASH] = ACTIONS(369),
    [anon_sym_LT_LT_DASH] = ACTIONS(369),
    [anon_sym_COLON_EQ] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(371),
    [anon_sym_DASH_GT_GT] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(371),
    [anon_sym_AMP] = ACTIONS(371),
    [anon_sym_PIPE_PIPE] = ACTIONS(369),
    [anon_sym_AMP_AMP] = ACTIONS(369),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_LT_EQ] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_EQ] = ACTIONS(369),
    [anon_sym_EQ_EQ] = ACTIONS(369),
    [anon_sym_BANG_EQ] = ACTIONS(369),
    [anon_sym_STAR] = ACTIONS(371),
    [anon_sym_SLASH] = ACTIONS(369),
    [anon_sym_STAR_STAR] = ACTIONS(369),
    [anon_sym_CARET] = ACTIONS(369),
    [aux_sym_binary_operator_token1] = ACTIONS(369),
    [anon_sym_PIPE_GT] = ACTIONS(369),
    [anon_sym_COLON] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(369),
    [anon_sym_AT] = ACTIONS(369),
    [aux_sym__hex_literal_token1] = ACTIONS(1313),
    [sym__number_literal] = ACTIONS(1315),
    [anon_sym_SQUOTE] = ACTIONS(1317),
    [anon_sym_DQUOTE] = ACTIONS(1319),
    [sym_return] = ACTIONS(3257),
    [sym_next] = ACTIONS(3257),
    [sym_break] = ACTIONS(3257),
    [sym_true] = ACTIONS(3257),
    [sym_false] = ACTIONS(3257),
    [sym_null] = ACTIONS(3257),
    [sym_inf] = ACTIONS(3257),
    [sym_nan] = ACTIONS(3257),
    [anon_sym_NA] = ACTIONS(1323),
    [anon_sym_NA_integer_] = ACTIONS(1323),
    [anon_sym_NA_real_] = ACTIONS(1323),
    [anon_sym_NA_complex_] = ACTIONS(1323),
    [anon_sym_NA_character_] = ACTIONS(1323),
    [sym_dots] = ACTIONS(3257),
    [sym_dot_dot_i] = ACTIONS(3259),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(369),
    [sym__newline] = ACTIONS(369),
    [sym__semicolon] = ACTIONS(369),
    [sym__raw_string_literal] = ACTIONS(1329),
    [sym__external_open_parenthesis] = ACTIONS(1331),
    [sym__external_open_brace] = ACTIONS(1333),
    [sym__external_close_brace] = ACTIONS(369),
    [sym__external_open_bracket] = ACTIONS(369),
    [sym__external_close_bracket] = ACTIONS(369),
    [sym__external_open_bracket2] = ACTIONS(369),
  },
  [276] = {
    [sym_function_definition] = STATE(975),
    [sym_if_statement] = STATE(975),
    [sym_for_statement] = STATE(975),
    [sym_while_statement] = STATE(975),
    [sym_repeat_statement] = STATE(975),
    [sym_braced_expression] = STATE(975),
    [sym_parenthesized_expression] = STATE(975),
    [sym_call] = STATE(975),
    [sym_subset] = STATE(975),
    [sym_subset2] = STATE(975),
    [sym_unary_operator] = STATE(975),
    [sym_binary_operator] = STATE(975),
    [sym_extract_operator] = STATE(975),
    [sym_namespace_operator] = STATE(975),
    [sym_integer] = STATE(975),
    [sym_complex] = STATE(975),
    [sym_float] = STATE(975),
    [sym__hex_literal] = STATE(2356),
    [sym__float_literal] = STATE(2356),
    [sym_string] = STATE(2231),
    [sym__single_quoted_string] = STATE(2355),
    [sym__double_quoted_string] = STATE(2354),
    [sym_na] = STATE(975),
    [sym__expression] = STATE(975),
    [sym__string_or_identifier] = STATE(5156),
    [sym__open_parenthesis] = STATE(190),
    [sym__open_brace] = STATE(94),
    [aux_sym_function_definition_repeat1] = STATE(265),
    [ts_builtin_sym_end] = ACTIONS(263),
    [sym_identifier] = ACTIONS(1337),
    [anon_sym_BSLASH] = ACTIONS(1339),
    [anon_sym_function] = ACTIONS(1341),
    [anon_sym_EQ] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(1343),
    [anon_sym_for] = ACTIONS(1345),
    [anon_sym_while] = ACTIONS(1347),
    [anon_sym_repeat] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_BANG] = ACTIONS(1355),
    [anon_sym_PLUS] = ACTIONS(1357),
    [anon_sym_DASH] = ACTIONS(1359),
    [anon_sym_LT_DASH] = ACTIONS(263),
    [anon_sym_LT_LT_DASH] = ACTIONS(263),
    [anon_sym_COLON_EQ] = ACTIONS(263),
    [anon_sym_DASH_GT] = ACTIONS(265),
    [anon_sym_DASH_GT_GT] = ACTIONS(263),
    [anon_sym_PIPE] = ACTIONS(265),
    [anon_sym_AMP] = ACTIONS(265),
    [anon_sym_PIPE_PIPE] = ACTIONS(263),
    [anon_sym_AMP_AMP] = ACTIONS(263),
    [anon_sym_LT] = ACTIONS(265),
    [anon_sym_LT_EQ] = ACTIONS(263),
    [anon_sym_GT] = ACTIONS(265),
    [anon_sym_GT_EQ] = ACTIONS(263),
    [anon_sym_EQ_EQ] = ACTIONS(263),
    [anon_sym_BANG_EQ] = ACTIONS(263),
    [anon_sym_STAR] = ACTIONS(265),
    [anon_sym_SLASH] = ACTIONS(263),
    [anon_sym_STAR_STAR] = ACTIONS(263),
    [anon_sym_CARET] = ACTIONS(263),
    [aux_sym_binary_operator_token1] = ACTIONS(263),
    [anon_sym_PIPE_GT] = ACTIONS(263),
    [anon_sym_COLON] = ACTIONS(265),
    [anon_sym_DOLLAR] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(263),
    [aux_sym__hex_literal_token1] = ACTIONS(1361),
    [sym__number_literal] = ACTIONS(1363),
    [anon_sym_SQUOTE] = ACTIONS(1365),
    [anon_sym_DQUOTE] = ACTIONS(1367),
    [sym_return] = ACTIONS(3261),
    [sym_next] = ACTIONS(3261),
    [sym_break] = ACTIONS(3261),
    [sym_true] = ACTIONS(3261),
    [sym_false] = ACTIONS(3261),
    [sym_null] = ACTIONS(3261),
    [sym_inf] = ACTIONS(3261),
    [sym_nan] = ACTIONS(3261),
    [anon_sym_NA] = ACTIONS(1371),
    [anon_sym_NA_integer_] = ACTIONS(1371),
    [anon_sym_NA_real_] = ACTIONS(1371),
    [anon_sym_NA_complex_] = ACTIONS(1371),
    [anon_sym_NA_character_] = ACTIONS(1371),
    [sym_dots] = ACTIONS(3261),
    [sym_dot_dot_i] = ACTIONS(3263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(3265),
    [sym__semicolon] = ACTIONS(263),
    [sym__raw_string_literal] = ACTIONS(1377),
    [sym__external_else] = ACTIONS(263),
    [sym__external_open_parenthesis] = ACTIONS(1379),
    [sym__external_close_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(1383),
    [sym__external_open_bracket] = ACTIONS(263),
    [sym__external_open_bracket2] = ACTIONS(263),
  },
  [277] = {
    [sym_function_definition] = STATE(1113),
    [sym_if_statement] = STATE(1113),
    [sym_for_statement] = STATE(1113),
    [sym_while_statement] = STATE(1113),
    [sym_repeat_statement] = STATE(1113),
    [sym_braced_expression] = STATE(1113),
    [sym_parenthesized_expression] = STATE(1113),
    [sym_call] = STATE(1113),
    [sym_subset] = STATE(1113),
    [sym_subset2] = STATE(1113),
    [sym_unary_operator] = STATE(1113),
    [sym_binary_operator] = STATE(1113),
    [sym_extract_operator] = STATE(1113),
    [sym_namespace_operator] = STATE(1113),
    [sym_integer] = STATE(1113),
    [sym_complex] = STATE(1113),
    [sym_float] = STATE(1113),
    [sym__hex_literal] = STATE(2235),
    [sym__float_literal] = STATE(2235),
    [sym_string] = STATE(2234),
    [sym__single_quoted_string] = STATE(2236),
    [sym__double_quoted_string] = STATE(2237),
    [sym_na] = STATE(1113),
    [sym__expression] = STATE(1113),
    [sym__string_or_identifier] = STATE(5150),
    [sym__open_parenthesis] = STATE(76),
    [sym__open_brace] = STATE(188),
    [aux_sym_function_definition_repeat1] = STATE(2400),
    [sym_identifier] = ACTIONS(1433),
    [anon_sym_BSLASH] = ACTIONS(1435),
    [anon_sym_function] = ACTIONS(1437),
    [anon_sym_EQ] = ACTIONS(759),
    [anon_sym_if] = ACTIONS(1439),
    [anon_sym_for] = ACTIONS(1441),
    [anon_sym_while] = ACTIONS(1443),
    [anon_sym_repeat] = ACTIONS(1445),
    [anon_sym_QMARK] = ACTIONS(1447),
    [anon_sym_TILDE] = ACTIONS(1449),
    [anon_sym_BANG] = ACTIONS(1451),
    [anon_sym_PLUS] = ACTIONS(1453),
    [anon_sym_DASH] = ACTIONS(1455),
    [anon_sym_LT_DASH] = ACTIONS(757),
    [anon_sym_LT_LT_DASH] = ACTIONS(757),
    [anon_sym_COLON_EQ] = ACTIONS(757),
    [anon_sym_DASH_GT] = ACTIONS(759),
    [anon_sym_DASH_GT_GT] = ACTIONS(757),
    [anon_sym_PIPE] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(759),
    [anon_sym_PIPE_PIPE] = ACTIONS(757),
    [anon_sym_AMP_AMP] = ACTIONS(757),
    [anon_sym_LT] = ACTIONS(759),
    [anon_sym_LT_EQ] = ACTIONS(757),
    [anon_sym_GT] = ACTIONS(759),
    [anon_sym_GT_EQ] = ACTIONS(757),
    [anon_sym_EQ_EQ] = ACTIONS(757),
    [anon_sym_BANG_EQ] = ACTIONS(757),
    [anon_sym_STAR] = ACTIONS(759),
    [anon_sym_SLASH] = ACTIONS(757),
    [anon_sym_STAR_STAR] = ACTIONS(757),
    [anon_sym_CARET] = ACTIONS(757),
    [aux_sym_binary_operator_token1] = ACTIONS(757),
    [anon_sym_PIPE_GT] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(759),
    [anon_sym_DOLLAR] = ACTIONS(757),
    [anon_sym_AT] = ACTIONS(757),
    [aux_sym__hex_literal_token1] = ACTIONS(1457),
    [sym__number_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [anon_sym_DQUOTE] = ACTIONS(1463),
    [sym_return] = ACTIONS(3267),
    [sym_next] = ACTIONS(3267),
    [sym_break] = ACTIONS(3267),
    [sym_true] = ACTIONS(3267),
    [sym_false] = ACTIONS(3267),
    [sym_null] = ACTIONS(3267),
    [sym_inf] = ACTIONS(3267),
    [sym_nan] = ACTIONS(3267),
    [anon_sym_NA] = ACTIONS(1467),
    [anon_sym_NA_integer_] = ACTIONS(1467),
    [anon_sym_NA_real_] = ACTIONS(1467),
    [anon_sym_NA_complex_] = ACTIONS(1467),
    [anon_sym_NA_character_] = ACTIONS(1467),
    [sym_dots] = ACTIONS(3267),
    [sym_dot_dot_i] = ACTIONS(3269),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(757),
    [sym__newline] = ACTIONS(757),
    [sym__semicolon] = ACTIONS(757),
    [sym__raw_string_literal] = ACTIONS(1473),
    [sym__external_open_parenthesis] = ACTIONS(1475),
    [sym__external_open_brace] = ACTIONS(1477),
    [sym__external_close_brace] = ACTIONS(757),
    [sym__external_open_bracket] = ACTIONS(757),
    [sym__external_open_bracket2] = ACTIONS(757),
    [sym__external_close_bracket2] = ACTIONS(757),
  },
  [278] = {
    [sym_function_definition] = STATE(1170),
    [sym_if_statement] = STATE(1170),
    [sym_for_statement] = STATE(1170),
    [sym_while_statement] = STATE(1170),
    [sym_repeat_statement] = STATE(1170),
    [sym_braced_expression] = STATE(1170),
    [sym_parenthesized_expression] = STATE(1170),
    [sym_call] = STATE(1170),
    [sym_subset] = STATE(1170),
    [sym_subset2] = STATE(1170),
    [sym_unary_operator] = STATE(1170),
    [sym_binary_operator] = STATE(1170),
    [sym_extract_operator] = STATE(1170),
    [sym_namespace_operator] = STATE(1170),
    [sym_integer] = STATE(1170),
    [sym_complex] = STATE(1170),
    [sym_float] = STATE(1170),
    [sym__hex_literal] = STATE(2266),
    [sym__float_literal] = STATE(2266),
    [sym_string] = STATE(2284),
    [sym__single_quoted_string] = STATE(2265),
    [sym__double_quoted_string] = STATE(2264),
    [sym_na] = STATE(1170),
    [sym__expression] = STATE(1170),
    [sym__string_or_identifier] = STATE(5147),
    [sym__open_parenthesis] = STATE(23),
    [sym__open_brace] = STATE(180),
    [aux_sym_function_definition_repeat1] = STATE(275),
    [sym_identifier] = ACTIONS(1289),
    [anon_sym_BSLASH] = ACTIONS(1291),
    [anon_sym_function] = ACTIONS(1293),
    [anon_sym_EQ] = ACTIONS(533),
    [anon_sym_if] = ACTIONS(1295),
    [anon_sym_for] = ACTIONS(1297),
    [anon_sym_while] = ACTIONS(1299),
    [anon_sym_repeat] = ACTIONS(1301),
    [anon_sym_QMARK] = ACTIONS(1303),
    [anon_sym_TILDE] = ACTIONS(1305),
    [anon_sym_BANG] = ACTIONS(1307),
    [anon_sym_PLUS] = ACTIONS(1309),
    [anon_sym_DASH] = ACTIONS(1311),
    [anon_sym_LT_DASH] = ACTIONS(531),
    [anon_sym_LT_LT_DASH] = ACTIONS(531),
    [anon_sym_COLON_EQ] = ACTIONS(531),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_DASH_GT_GT] = ACTIONS(531),
    [anon_sym_PIPE] = ACTIONS(533),
    [anon_sym_AMP] = ACTIONS(533),
    [anon_sym_PIPE_PIPE] = ACTIONS(531),
    [anon_sym_AMP_AMP] = ACTIONS(531),
    [anon_sym_LT] = ACTIONS(533),
    [anon_sym_LT_EQ] = ACTIONS(531),
    [anon_sym_GT] = ACTIONS(533),
    [anon_sym_GT_EQ] = ACTIONS(531),
    [anon_sym_EQ_EQ] = ACTIONS(531),
    [anon_sym_BANG_EQ] = ACTIONS(531),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_SLASH] = ACTIONS(531),
    [anon_sym_STAR_STAR] = ACTIONS(531),
    [anon_sym_CARET] = ACTIONS(531),
    [aux_sym_binary_operator_token1] = ACTIONS(531),
    [anon_sym_PIPE_GT] = ACTIONS(531),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_DOLLAR] = ACTIONS(531),
    [anon_sym_AT] = ACTIONS(531),
    [aux_sym__hex_literal_token1] = ACTIONS(1313),
    [sym__number_literal] = ACTIONS(1315),
    [anon_sym_SQUOTE] = ACTIONS(1317),
    [anon_sym_DQUOTE] = ACTIONS(1319),
    [sym_return] = ACTIONS(3271),
    [sym_next] = ACTIONS(3271),
    [sym_break] = ACTIONS(3271),
    [sym_true] = ACTIONS(3271),
    [sym_false] = ACTIONS(3271),
    [sym_null] = ACTIONS(3271),
    [sym_inf] = ACTIONS(3271),
    [sym_nan] = ACTIONS(3271),
    [anon_sym_NA] = ACTIONS(1323),
    [anon_sym_NA_integer_] = ACTIONS(1323),
    [anon_sym_NA_real_] = ACTIONS(1323),
    [anon_sym_NA_complex_] = ACTIONS(1323),
    [anon_sym_NA_character_] = ACTIONS(1323),
    [sym_dots] = ACTIONS(3271),
    [sym_dot_dot_i] = ACTIONS(3273),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(531),
    [sym__newline] = ACTIONS(3275),
    [sym__semicolon] = ACTIONS(531),
    [sym__raw_string_literal] = ACTIONS(1329),
    [sym__external_open_parenthesis] = ACTIONS(1331),
    [sym__external_open_brace] = ACTIONS(1333),
    [sym__external_close_brace] = ACTIONS(531),
    [sym__external_open_bracket] = ACTIONS(531),
    [sym__external_close_bracket] = ACTIONS(531),
    [sym__external_open_bracket2] = ACTIONS(531),
  },
  [279] = {
    [sym_function_definition] = STATE(1072),
    [sym_if_statement] = STATE(1072),
    [sym_for_statement] = STATE(1072),
    [sym_while_statement] = STATE(1072),
    [sym_repeat_statement] = STATE(1072),
    [sym_braced_expression] = STATE(1072),
    [sym_parenthesized_expression] = STATE(1072),
    [sym_call] = STATE(1072),
    [sym_subset] = STATE(1072),
    [sym_subset2] = STATE(1072),
    [sym_unary_operator] = STATE(1072),
    [sym_binary_operator] = STATE(1072),
    [sym_extract_operator] = STATE(1072),
    [sym_namespace_operator] = STATE(1072),
    [sym_integer] = STATE(1072),
    [sym_complex] = STATE(1072),
    [sym_float] = STATE(1072),
    [sym__hex_literal] = STATE(2311),
    [sym__float_literal] = STATE(2311),
    [sym_string] = STATE(2312),
    [sym__single_quoted_string] = STATE(2310),
    [sym__double_quoted_string] = STATE(2309),
    [sym_na] = STATE(1072),
    [sym__expression] = STATE(1072),
    [sym__string_or_identifier] = STATE(5134),
    [sym__open_parenthesis] = STATE(64),
    [sym__open_brace] = STATE(199),
    [aux_sym_braced_expression_repeat1] = STATE(279),
    [ts_builtin_sym_end] = ACTIONS(591),
    [sym_identifier] = ACTIONS(3277),
    [anon_sym_BSLASH] = ACTIONS(3280),
    [anon_sym_function] = ACTIONS(3283),
    [anon_sym_EQ] = ACTIONS(562),
    [anon_sym_if] = ACTIONS(3286),
    [anon_sym_for] = ACTIONS(3289),
    [anon_sym_while] = ACTIONS(3292),
    [anon_sym_repeat] = ACTIONS(3295),
    [anon_sym_QMARK] = ACTIONS(3298),
    [anon_sym_TILDE] = ACTIONS(3301),
    [anon_sym_BANG] = ACTIONS(3304),
    [anon_sym_PLUS] = ACTIONS(3307),
    [anon_sym_DASH] = ACTIONS(3310),
    [anon_sym_LT_DASH] = ACTIONS(591),
    [anon_sym_LT_LT_DASH] = ACTIONS(591),
    [anon_sym_COLON_EQ] = ACTIONS(591),
    [anon_sym_DASH_GT] = ACTIONS(562),
    [anon_sym_DASH_GT_GT] = ACTIONS(591),
    [anon_sym_PIPE] = ACTIONS(562),
    [anon_sym_AMP] = ACTIONS(562),
    [anon_sym_PIPE_PIPE] = ACTIONS(591),
    [anon_sym_AMP_AMP] = ACTIONS(591),
    [anon_sym_LT] = ACTIONS(562),
    [anon_sym_LT_EQ] = ACTIONS(591),
    [anon_sym_GT] = ACTIONS(562),
    [anon_sym_GT_EQ] = ACTIONS(591),
    [anon_sym_EQ_EQ] = ACTIONS(591),
    [anon_sym_BANG_EQ] = ACTIONS(591),
    [anon_sym_STAR] = ACTIONS(562),
    [anon_sym_SLASH] = ACTIONS(591),
    [anon_sym_STAR_STAR] = ACTIONS(591),
    [anon_sym_CARET] = ACTIONS(591),
    [aux_sym_binary_operator_token1] = ACTIONS(591),
    [anon_sym_PIPE_GT] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(562),
    [anon_sym_DOLLAR] = ACTIONS(591),
    [anon_sym_AT] = ACTIONS(591),
    [aux_sym__hex_literal_token1] = ACTIONS(3313),
    [sym__number_literal] = ACTIONS(3316),
    [anon_sym_SQUOTE] = ACTIONS(3319),
    [anon_sym_DQUOTE] = ACTIONS(3322),
    [sym_return] = ACTIONS(3325),
    [sym_next] = ACTIONS(3325),
    [sym_break] = ACTIONS(3325),
    [sym_true] = ACTIONS(3325),
    [sym_false] = ACTIONS(3325),
    [sym_null] = ACTIONS(3325),
    [sym_inf] = ACTIONS(3325),
    [sym_nan] = ACTIONS(3325),
    [anon_sym_NA] = ACTIONS(3328),
    [anon_sym_NA_integer_] = ACTIONS(3328),
    [anon_sym_NA_real_] = ACTIONS(3328),
    [anon_sym_NA_complex_] = ACTIONS(3328),
    [anon_sym_NA_character_] = ACTIONS(3328),
    [sym_dots] = ACTIONS(3325),
    [sym_dot_dot_i] = ACTIONS(3331),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(3334),
    [sym__semicolon] = ACTIONS(3334),
    [sym__raw_string_literal] = ACTIONS(3337),
    [sym__external_else] = ACTIONS(591),
    [sym__external_open_parenthesis] = ACTIONS(3340),
    [sym__external_open_brace] = ACTIONS(3343),
    [sym__external_close_brace] = ACTIONS(591),
    [sym__external_open_bracket] = ACTIONS(591),
    [sym__external_open_bracket2] = ACTIONS(591),
  },
  [280] = {
    [sym_function_definition] = STATE(1599),
    [sym_if_statement] = STATE(1599),
    [sym_for_statement] = STATE(1599),
    [sym_while_statement] = STATE(1599),
    [sym_repeat_statement] = STATE(1599),
    [sym_braced_expression] = STATE(1599),
    [sym_parenthesized_expression] = STATE(1599),
    [sym_call] = STATE(1599),
    [sym_subset] = STATE(1599),
    [sym_subset2] = STATE(1599),
    [sym_unary_operator] = STATE(1599),
    [sym_binary_operator] = STATE(1599),
    [sym_extract_operator] = STATE(1599),
    [sym_namespace_operator] = STATE(1599),
    [sym_integer] = STATE(1599),
    [sym_complex] = STATE(1599),
    [sym_float] = STATE(1599),
    [sym__hex_literal] = STATE(2412),
    [sym__float_literal] = STATE(2412),
    [sym_string] = STATE(2397),
    [sym__single_quoted_string] = STATE(2430),
    [sym__double_quoted_string] = STATE(2466),
    [sym_na] = STATE(1599),
    [sym__expression] = STATE(1599),
    [sym__string_or_identifier] = STATE(5142),
    [sym__open_parenthesis] = STATE(210),
    [sym__close_parenthesis] = STATE(2965),
    [sym__open_brace] = STATE(74),
    [aux_sym_parenthesized_expression_repeat1] = STATE(409),
    [sym_identifier] = ACTIONS(2483),
    [anon_sym_BSLASH] = ACTIONS(2485),
    [anon_sym_function] = ACTIONS(2487),
    [anon_sym_EQ] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(2489),
    [anon_sym_for] = ACTIONS(2491),
    [anon_sym_while] = ACTIONS(2493),
    [anon_sym_repeat] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(2497),
    [anon_sym_TILDE] = ACTIONS(2499),
    [anon_sym_BANG] = ACTIONS(2501),
    [anon_sym_PLUS] = ACTIONS(2503),
    [anon_sym_DASH] = ACTIONS(2505),
    [anon_sym_LT_DASH] = ACTIONS(211),
    [anon_sym_LT_LT_DASH] = ACTIONS(211),
    [anon_sym_COLON_EQ] = ACTIONS(211),
    [anon_sym_DASH_GT] = ACTIONS(209),
    [anon_sym_DASH_GT_GT] = ACTIONS(211),
    [anon_sym_PIPE] = ACTIONS(209),
    [anon_sym_AMP] = ACTIONS(209),
    [anon_sym_PIPE_PIPE] = ACTIONS(211),
    [anon_sym_AMP_AMP] = ACTIONS(211),
    [anon_sym_LT] = ACTIONS(209),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_GT] = ACTIONS(209),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [anon_sym_EQ_EQ] = ACTIONS(211),
    [anon_sym_BANG_EQ] = ACTIONS(211),
    [anon_sym_STAR] = ACTIONS(209),
    [anon_sym_SLASH] = ACTIONS(211),
    [anon_sym_STAR_STAR] = ACTIONS(211),
    [anon_sym_CARET] = ACTIONS(211),
    [aux_sym_binary_operator_token1] = ACTIONS(211),
    [anon_sym_PIPE_GT] = ACTIONS(211),
    [anon_sym_COLON] = ACTIONS(209),
    [anon_sym_DOLLAR] = ACTIONS(211),
    [anon_sym_AT] = ACTIONS(211),
    [aux_sym__hex_literal_token1] = ACTIONS(2507),
    [sym__number_literal] = ACTIONS(2509),
    [anon_sym_SQUOTE] = ACTIONS(2511),
    [anon_sym_DQUOTE] = ACTIONS(2513),
    [sym_return] = ACTIONS(2515),
    [sym_next] = ACTIONS(2515),
    [sym_break] = ACTIONS(2515),
    [sym_true] = ACTIONS(2515),
    [sym_false] = ACTIONS(2515),
    [sym_null] = ACTIONS(2515),
    [sym_inf] = ACTIONS(2515),
    [sym_nan] = ACTIONS(2515),
    [anon_sym_NA] = ACTIONS(2517),
    [anon_sym_NA_integer_] = ACTIONS(2517),
    [anon_sym_NA_real_] = ACTIONS(2517),
    [anon_sym_NA_complex_] = ACTIONS(2517),
    [anon_sym_NA_character_] = ACTIONS(2517),
    [sym_dots] = ACTIONS(2515),
    [sym_dot_dot_i] = ACTIONS(2519),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(211),
    [sym__newline] = ACTIONS(2521),
    [sym__raw_string_literal] = ACTIONS(2523),
    [sym__external_open_parenthesis] = ACTIONS(2525),
    [sym__external_close_parenthesis] = ACTIONS(3346),
    [sym__external_open_brace] = ACTIONS(2529),
    [sym__external_open_bracket] = ACTIONS(211),
    [sym__external_open_bracket2] = ACTIONS(211),
    [sym__external_close_bracket2] = ACTIONS(211),
  },
  [281] = {
    [sym_function_definition] = STATE(1253),
    [sym_if_statement] = STATE(1253),
    [sym_for_statement] = STATE(1253),
    [sym_while_statement] = STATE(1253),
    [sym_repeat_statement] = STATE(1253),
    [sym_braced_expression] = STATE(1253),
    [sym_parenthesized_expression] = STATE(1253),
    [sym_call] = STATE(1253),
    [sym_subset] = STATE(1253),
    [sym_subset2] = STATE(1253),
    [sym_unary_operator] = STATE(1253),
    [sym_binary_operator] = STATE(1253),
    [sym_extract_operator] = STATE(1253),
    [sym_namespace_operator] = STATE(1253),
    [sym_integer] = STATE(1253),
    [sym_complex] = STATE(1253),
    [sym_float] = STATE(1253),
    [sym__hex_literal] = STATE(2272),
    [sym__float_literal] = STATE(2272),
    [sym_string] = STATE(2271),
    [sym__single_quoted_string] = STATE(2273),
    [sym__double_quoted_string] = STATE(2274),
    [sym_na] = STATE(1253),
    [sym__expression] = STATE(1253),
    [sym__string_or_identifier] = STATE(5157),
    [sym__open_parenthesis] = STATE(120),
    [sym__open_brace] = STATE(11),
    [aux_sym_function_definition_repeat1] = STATE(2503),
    [sym_identifier] = ACTIONS(1241),
    [anon_sym_BSLASH] = ACTIONS(1243),
    [anon_sym_function] = ACTIONS(1245),
    [anon_sym_EQ] = ACTIONS(767),
    [anon_sym_if] = ACTIONS(1247),
    [anon_sym_for] = ACTIONS(1249),
    [anon_sym_while] = ACTIONS(1251),
    [anon_sym_repeat] = ACTIONS(1253),
    [anon_sym_QMARK] = ACTIONS(1255),
    [anon_sym_TILDE] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1259),
    [anon_sym_PLUS] = ACTIONS(1261),
    [anon_sym_DASH] = ACTIONS(1263),
    [anon_sym_LT_DASH] = ACTIONS(765),
    [anon_sym_LT_LT_DASH] = ACTIONS(765),
    [anon_sym_COLON_EQ] = ACTIONS(765),
    [anon_sym_DASH_GT] = ACTIONS(767),
    [anon_sym_DASH_GT_GT] = ACTIONS(765),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_AMP] = ACTIONS(767),
    [anon_sym_PIPE_PIPE] = ACTIONS(765),
    [anon_sym_AMP_AMP] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(767),
    [anon_sym_LT_EQ] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_GT_EQ] = ACTIONS(765),
    [anon_sym_EQ_EQ] = ACTIONS(765),
    [anon_sym_BANG_EQ] = ACTIONS(765),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(765),
    [anon_sym_STAR_STAR] = ACTIONS(765),
    [anon_sym_CARET] = ACTIONS(765),
    [aux_sym_binary_operator_token1] = ACTIONS(765),
    [anon_sym_PIPE_GT] = ACTIONS(765),
    [anon_sym_COLON] = ACTIONS(767),
    [anon_sym_DOLLAR] = ACTIONS(765),
    [anon_sym_AT] = ACTIONS(765),
    [aux_sym__hex_literal_token1] = ACTIONS(1265),
    [sym__number_literal] = ACTIONS(1267),
    [anon_sym_SQUOTE] = ACTIONS(1269),
    [anon_sym_DQUOTE] = ACTIONS(1271),
    [sym_return] = ACTIONS(3348),
    [sym_next] = ACTIONS(3348),
    [sym_break] = ACTIONS(3348),
    [sym_true] = ACTIONS(3348),
    [sym_false] = ACTIONS(3348),
    [sym_null] = ACTIONS(3348),
    [sym_inf] = ACTIONS(3348),
    [sym_nan] = ACTIONS(3348),
    [anon_sym_NA] = ACTIONS(1275),
    [anon_sym_NA_integer_] = ACTIONS(1275),
    [anon_sym_NA_real_] = ACTIONS(1275),
    [anon_sym_NA_complex_] = ACTIONS(1275),
    [anon_sym_NA_character_] = ACTIONS(1275),
    [sym_dots] = ACTIONS(3348),
    [sym_dot_dot_i] = ACTIONS(3350),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(765),
    [sym__newline] = ACTIONS(765),
    [sym__raw_string_literal] = ACTIONS(1281),
    [sym__external_else] = ACTIONS(765),
    [sym__external_open_parenthesis] = ACTIONS(1283),
    [sym__external_close_parenthesis] = ACTIONS(765),
    [sym__external_open_brace] = ACTIONS(1287),
    [sym__external_open_bracket] = ACTIONS(765),
    [sym__external_close_bracket] = ACTIONS(765),
    [sym__external_open_bracket2] = ACTIONS(765),
  },
  [282] = {
    [sym_function_definition] = STATE(1445),
    [sym_if_statement] = STATE(1445),
    [sym_for_statement] = STATE(1445),
    [sym_while_statement] = STATE(1445),
    [sym_repeat_statement] = STATE(1445),
    [sym_braced_expression] = STATE(1445),
    [sym_parenthesized_expression] = STATE(1445),
    [sym_call] = STATE(1445),
    [sym_subset] = STATE(1445),
    [sym_subset2] = STATE(1445),
    [sym_unary_operator] = STATE(1445),
    [sym_binary_operator] = STATE(1445),
    [sym_extract_operator] = STATE(1445),
    [sym_namespace_operator] = STATE(1445),
    [sym_integer] = STATE(1445),
    [sym_complex] = STATE(1445),
    [sym_float] = STATE(1445),
    [sym__hex_literal] = STATE(2523),
    [sym__float_literal] = STATE(2523),
    [sym_string] = STATE(2522),
    [sym__single_quoted_string] = STATE(2528),
    [sym__double_quoted_string] = STATE(2529),
    [sym_na] = STATE(1445),
    [sym__expression] = STATE(1445),
    [sym__string_or_identifier] = STATE(5126),
    [sym__open_parenthesis] = STATE(178),
    [sym__open_brace] = STATE(244),
    [sym__close_brace] = STATE(2928),
    [aux_sym_braced_expression_repeat1] = STATE(372),
    [ts_builtin_sym_end] = ACTIONS(51),
    [sym_identifier] = ACTIONS(2826),
    [anon_sym_BSLASH] = ACTIONS(2828),
    [anon_sym_function] = ACTIONS(2830),
    [anon_sym_EQ] = ACTIONS(59),
    [anon_sym_if] = ACTIONS(2832),
    [anon_sym_for] = ACTIONS(2834),
    [anon_sym_while] = ACTIONS(2836),
    [anon_sym_repeat] = ACTIONS(2838),
    [anon_sym_QMARK] = ACTIONS(2840),
    [anon_sym_TILDE] = ACTIONS(2842),
    [anon_sym_BANG] = ACTIONS(2844),
    [anon_sym_PLUS] = ACTIONS(2846),
    [anon_sym_DASH] = ACTIONS(2848),
    [anon_sym_LT_DASH] = ACTIONS(51),
    [anon_sym_LT_LT_DASH] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(51),
    [anon_sym_DASH_GT] = ACTIONS(59),
    [anon_sym_DASH_GT_GT] = ACTIONS(51),
    [anon_sym_PIPE] = ACTIONS(59),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_AMP_AMP] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(59),
    [anon_sym_LT_EQ] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(59),
    [anon_sym_GT_EQ] = ACTIONS(51),
    [anon_sym_EQ_EQ] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(51),
    [anon_sym_CARET] = ACTIONS(51),
    [aux_sym_binary_operator_token1] = ACTIONS(51),
    [anon_sym_PIPE_GT] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(59),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_AT] = ACTIONS(51),
    [aux_sym__hex_literal_token1] = ACTIONS(2850),
    [sym__number_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE] = ACTIONS(2856),
    [sym_return] = ACTIONS(2858),
    [sym_next] = ACTIONS(2858),
    [sym_break] = ACTIONS(2858),
    [sym_true] = ACTIONS(2858),
    [sym_false] = ACTIONS(2858),
    [sym_null] = ACTIONS(2858),
    [sym_inf] = ACTIONS(2858),
    [sym_nan] = ACTIONS(2858),
    [anon_sym_NA] = ACTIONS(2860),
    [anon_sym_NA_integer_] = ACTIONS(2860),
    [anon_sym_NA_real_] = ACTIONS(2860),
    [anon_sym_NA_complex_] = ACTIONS(2860),
    [anon_sym_NA_character_] = ACTIONS(2860),
    [sym_dots] = ACTIONS(2858),
    [sym_dot_dot_i] = ACTIONS(2862),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(2864),
    [sym__semicolon] = ACTIONS(2864),
    [sym__raw_string_literal] = ACTIONS(2866),
    [sym__external_open_parenthesis] = ACTIONS(2868),
    [sym__external_open_brace] = ACTIONS(2870),
    [sym__external_close_brace] = ACTIONS(3352),
    [sym__external_open_bracket] = ACTIONS(51),
    [sym__external_open_bracket2] = ACTIONS(51),
  },
  [283] = {
    [sym_function_definition] = STATE(1521),
    [sym_if_statement] = STATE(1521),
    [sym_for_statement] = STATE(1521),
    [sym_while_statement] = STATE(1521),
    [sym_repeat_statement] = STATE(1521),
    [sym_braced_expression] = STATE(1521),
    [sym_parenthesized_expression] = STATE(1521),
    [sym_call] = STATE(1521),
    [sym_subset] = STATE(1521),
    [sym_subset2] = STATE(1521),
    [sym_unary_operator] = STATE(1521),
    [sym_binary_operator] = STATE(1521),
    [sym_extract_operator] = STATE(1521),
    [sym_namespace_operator] = STATE(1521),
    [sym_integer] = STATE(1521),
    [sym_complex] = STATE(1521),
    [sym_float] = STATE(1521),
    [sym__hex_literal] = STATE(2371),
    [sym__float_literal] = STATE(2371),
    [sym_string] = STATE(2372),
    [sym__single_quoted_string] = STATE(2370),
    [sym__double_quoted_string] = STATE(2369),
    [sym_na] = STATE(1521),
    [sym__expression] = STATE(1521),
    [sym__string_or_identifier] = STATE(5138),
    [sym__open_parenthesis] = STATE(200),
    [sym__close_parenthesis] = STATE(2781),
    [sym__open_brace] = STATE(97),
    [aux_sym_parenthesized_expression_repeat1] = STATE(330),
    [sym_identifier] = ACTIONS(2425),
    [anon_sym_BSLASH] = ACTIONS(2427),
    [anon_sym_function] = ACTIONS(2429),
    [anon_sym_EQ] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(2431),
    [anon_sym_for] = ACTIONS(2433),
    [anon_sym_while] = ACTIONS(2435),
    [anon_sym_repeat] = ACTIONS(2437),
    [anon_sym_QMARK] = ACTIONS(2439),
    [anon_sym_TILDE] = ACTIONS(2441),
    [anon_sym_BANG] = ACTIONS(2443),
    [anon_sym_PLUS] = ACTIONS(2445),
    [anon_sym_DASH] = ACTIONS(2447),
    [anon_sym_LT_DASH] = ACTIONS(211),
    [anon_sym_LT_LT_DASH] = ACTIONS(211),
    [anon_sym_COLON_EQ] = ACTIONS(211),
    [anon_sym_DASH_GT] = ACTIONS(209),
    [anon_sym_DASH_GT_GT] = ACTIONS(211),
    [anon_sym_PIPE] = ACTIONS(209),
    [anon_sym_AMP] = ACTIONS(209),
    [anon_sym_PIPE_PIPE] = ACTIONS(211),
    [anon_sym_AMP_AMP] = ACTIONS(211),
    [anon_sym_LT] = ACTIONS(209),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_GT] = ACTIONS(209),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [anon_sym_EQ_EQ] = ACTIONS(211),
    [anon_sym_BANG_EQ] = ACTIONS(211),
    [anon_sym_STAR] = ACTIONS(209),
    [anon_sym_SLASH] = ACTIONS(211),
    [anon_sym_STAR_STAR] = ACTIONS(211),
    [anon_sym_CARET] = ACTIONS(211),
    [aux_sym_binary_operator_token1] = ACTIONS(211),
    [anon_sym_PIPE_GT] = ACTIONS(211),
    [anon_sym_COLON] = ACTIONS(209),
    [anon_sym_DOLLAR] = ACTIONS(211),
    [anon_sym_AT] = ACTIONS(211),
    [aux_sym__hex_literal_token1] = ACTIONS(2449),
    [sym__number_literal] = ACTIONS(2451),
    [anon_sym_SQUOTE] = ACTIONS(2453),
    [anon_sym_DQUOTE] = ACTIONS(2455),
    [sym_return] = ACTIONS(2457),
    [sym_next] = ACTIONS(2457),
    [sym_break] = ACTIONS(2457),
    [sym_true] = ACTIONS(2457),
    [sym_false] = ACTIONS(2457),
    [sym_null] = ACTIONS(2457),
    [sym_inf] = ACTIONS(2457),
    [sym_nan] = ACTIONS(2457),
    [anon_sym_NA] = ACTIONS(2459),
    [anon_sym_NA_integer_] = ACTIONS(2459),
    [anon_sym_NA_real_] = ACTIONS(2459),
    [anon_sym_NA_complex_] = ACTIONS(2459),
    [anon_sym_NA_character_] = ACTIONS(2459),
    [sym_dots] = ACTIONS(2457),
    [sym_dot_dot_i] = ACTIONS(2461),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(211),
    [sym__newline] = ACTIONS(2463),
    [sym__raw_string_literal] = ACTIONS(2465),
    [sym__external_else] = ACTIONS(211),
    [sym__external_open_parenthesis] = ACTIONS(2467),
    [sym__external_close_parenthesis] = ACTIONS(3354),
    [sym__external_open_brace] = ACTIONS(2471),
    [sym__external_open_bracket] = ACTIONS(211),
    [sym__external_open_bracket2] = ACTIONS(211),
  },
  [284] = {
    [sym_function_definition] = STATE(1246),
    [sym_if_statement] = STATE(1246),
    [sym_for_statement] = STATE(1246),
    [sym_while_statement] = STATE(1246),
    [sym_repeat_statement] = STATE(1246),
    [sym_braced_expression] = STATE(1246),
    [sym_parenthesized_expression] = STATE(1246),
    [sym_call] = STATE(1246),
    [sym_subset] = STATE(1246),
    [sym_subset2] = STATE(1246),
    [sym_unary_operator] = STATE(1246),
    [sym_binary_operator] = STATE(1246),
    [sym_extract_operator] = STATE(1246),
    [sym_namespace_operator] = STATE(1246),
    [sym_integer] = STATE(1246),
    [sym_complex] = STATE(1246),
    [sym_float] = STATE(1246),
    [sym__hex_literal] = STATE(2266),
    [sym__float_literal] = STATE(2266),
    [sym_string] = STATE(2284),
    [sym__single_quoted_string] = STATE(2265),
    [sym__double_quoted_string] = STATE(2264),
    [sym_na] = STATE(1246),
    [sym__expression] = STATE(1246),
    [sym__string_or_identifier] = STATE(5147),
    [sym__open_parenthesis] = STATE(23),
    [sym__open_brace] = STATE(180),
    [aux_sym_function_definition_repeat1] = STATE(291),
    [sym_identifier] = ACTIONS(1289),
    [anon_sym_BSLASH] = ACTIONS(1291),
    [anon_sym_function] = ACTIONS(1293),
    [anon_sym_EQ] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(1295),
    [anon_sym_for] = ACTIONS(1297),
    [anon_sym_while] = ACTIONS(1299),
    [anon_sym_repeat] = ACTIONS(1301),
    [anon_sym_QMARK] = ACTIONS(1303),
    [anon_sym_TILDE] = ACTIONS(1305),
    [anon_sym_BANG] = ACTIONS(1307),
    [anon_sym_PLUS] = ACTIONS(1309),
    [anon_sym_DASH] = ACTIONS(1311),
    [anon_sym_LT_DASH] = ACTIONS(263),
    [anon_sym_LT_LT_DASH] = ACTIONS(263),
    [anon_sym_COLON_EQ] = ACTIONS(263),
    [anon_sym_DASH_GT] = ACTIONS(265),
    [anon_sym_DASH_GT_GT] = ACTIONS(263),
    [anon_sym_PIPE] = ACTIONS(265),
    [anon_sym_AMP] = ACTIONS(265),
    [anon_sym_PIPE_PIPE] = ACTIONS(263),
    [anon_sym_AMP_AMP] = ACTIONS(263),
    [anon_sym_LT] = ACTIONS(265),
    [anon_sym_LT_EQ] = ACTIONS(263),
    [anon_sym_GT] = ACTIONS(265),
    [anon_sym_GT_EQ] = ACTIONS(263),
    [anon_sym_EQ_EQ] = ACTIONS(263),
    [anon_sym_BANG_EQ] = ACTIONS(263),
    [anon_sym_STAR] = ACTIONS(265),
    [anon_sym_SLASH] = ACTIONS(263),
    [anon_sym_STAR_STAR] = ACTIONS(263),
    [anon_sym_CARET] = ACTIONS(263),
    [aux_sym_binary_operator_token1] = ACTIONS(263),
    [anon_sym_PIPE_GT] = ACTIONS(263),
    [anon_sym_COLON] = ACTIONS(265),
    [anon_sym_DOLLAR] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(263),
    [aux_sym__hex_literal_token1] = ACTIONS(1313),
    [sym__number_literal] = ACTIONS(1315),
    [anon_sym_SQUOTE] = ACTIONS(1317),
    [anon_sym_DQUOTE] = ACTIONS(1319),
    [sym_return] = ACTIONS(3356),
    [sym_next] = ACTIONS(3356),
    [sym_break] = ACTIONS(3356),
    [sym_true] = ACTIONS(3356),
    [sym_false] = ACTIONS(3356),
    [sym_null] = ACTIONS(3356),
    [sym_inf] = ACTIONS(3356),
    [sym_nan] = ACTIONS(3356),
    [anon_sym_NA] = ACTIONS(1323),
    [anon_sym_NA_integer_] = ACTIONS(1323),
    [anon_sym_NA_real_] = ACTIONS(1323),
    [anon_sym_NA_complex_] = ACTIONS(1323),
    [anon_sym_NA_character_] = ACTIONS(1323),
    [sym_dots] = ACTIONS(3356),
    [sym_dot_dot_i] = ACTIONS(3358),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(263),
    [sym__newline] = ACTIONS(3360),
    [sym__semicolon] = ACTIONS(263),
    [sym__raw_string_literal] = ACTIONS(1329),
    [sym__external_open_parenthesis] = ACTIONS(1331),
    [sym__external_open_brace] = ACTIONS(1333),
    [sym__external_close_brace] = ACTIONS(263),
    [sym__external_open_bracket] = ACTIONS(263),
    [sym__external_close_bracket] = ACTIONS(263),
    [sym__external_open_bracket2] = ACTIONS(263),
  },
  [285] = {
    [sym_function_definition] = STATE(1445),
    [sym_if_statement] = STATE(1445),
    [sym_for_statement] = STATE(1445),
    [sym_while_statement] = STATE(1445),
    [sym_repeat_statement] = STATE(1445),
    [sym_braced_expression] = STATE(1445),
    [sym_parenthesized_expression] = STATE(1445),
    [sym_call] = STATE(1445),
    [sym_subset] = STATE(1445),
    [sym_subset2] = STATE(1445),
    [sym_unary_operator] = STATE(1445),
    [sym_binary_operator] = STATE(1445),
    [sym_extract_operator] = STATE(1445),
    [sym_namespace_operator] = STATE(1445),
    [sym_integer] = STATE(1445),
    [sym_complex] = STATE(1445),
    [sym_float] = STATE(1445),
    [sym__hex_literal] = STATE(2523),
    [sym__float_literal] = STATE(2523),
    [sym_string] = STATE(2522),
    [sym__single_quoted_string] = STATE(2528),
    [sym__double_quoted_string] = STATE(2529),
    [sym_na] = STATE(1445),
    [sym__expression] = STATE(1445),
    [sym__string_or_identifier] = STATE(5126),
    [sym__open_parenthesis] = STATE(178),
    [sym__open_brace] = STATE(244),
    [sym__close_brace] = STATE(3008),
    [aux_sym_braced_expression_repeat1] = STATE(372),
    [ts_builtin_sym_end] = ACTIONS(51),
    [sym_identifier] = ACTIONS(2826),
    [anon_sym_BSLASH] = ACTIONS(2828),
    [anon_sym_function] = ACTIONS(2830),
    [anon_sym_EQ] = ACTIONS(59),
    [anon_sym_if] = ACTIONS(2832),
    [anon_sym_for] = ACTIONS(2834),
    [anon_sym_while] = ACTIONS(2836),
    [anon_sym_repeat] = ACTIONS(2838),
    [anon_sym_QMARK] = ACTIONS(2840),
    [anon_sym_TILDE] = ACTIONS(2842),
    [anon_sym_BANG] = ACTIONS(2844),
    [anon_sym_PLUS] = ACTIONS(2846),
    [anon_sym_DASH] = ACTIONS(2848),
    [anon_sym_LT_DASH] = ACTIONS(51),
    [anon_sym_LT_LT_DASH] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(51),
    [anon_sym_DASH_GT] = ACTIONS(59),
    [anon_sym_DASH_GT_GT] = ACTIONS(51),
    [anon_sym_PIPE] = ACTIONS(59),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_AMP_AMP] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(59),
    [anon_sym_LT_EQ] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(59),
    [anon_sym_GT_EQ] = ACTIONS(51),
    [anon_sym_EQ_EQ] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(51),
    [anon_sym_CARET] = ACTIONS(51),
    [aux_sym_binary_operator_token1] = ACTIONS(51),
    [anon_sym_PIPE_GT] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(59),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_AT] = ACTIONS(51),
    [aux_sym__hex_literal_token1] = ACTIONS(2850),
    [sym__number_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE] = ACTIONS(2856),
    [sym_return] = ACTIONS(2858),
    [sym_next] = ACTIONS(2858),
    [sym_break] = ACTIONS(2858),
    [sym_true] = ACTIONS(2858),
    [sym_false] = ACTIONS(2858),
    [sym_null] = ACTIONS(2858),
    [sym_inf] = ACTIONS(2858),
    [sym_nan] = ACTIONS(2858),
    [anon_sym_NA] = ACTIONS(2860),
    [anon_sym_NA_integer_] = ACTIONS(2860),
    [anon_sym_NA_real_] = ACTIONS(2860),
    [anon_sym_NA_complex_] = ACTIONS(2860),
    [anon_sym_NA_character_] = ACTIONS(2860),
    [sym_dots] = ACTIONS(2858),
    [sym_dot_dot_i] = ACTIONS(2862),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(2864),
    [sym__semicolon] = ACTIONS(2864),
    [sym__raw_string_literal] = ACTIONS(2866),
    [sym__external_open_parenthesis] = ACTIONS(2868),
    [sym__external_open_brace] = ACTIONS(2870),
    [sym__external_close_brace] = ACTIONS(3362),
    [sym__external_open_bracket] = ACTIONS(51),
    [sym__external_open_bracket2] = ACTIONS(51),
  },
  [286] = {
    [sym_function_definition] = STATE(1521),
    [sym_if_statement] = STATE(1521),
    [sym_for_statement] = STATE(1521),
    [sym_while_statement] = STATE(1521),
    [sym_repeat_statement] = STATE(1521),
    [sym_braced_expression] = STATE(1521),
    [sym_parenthesized_expression] = STATE(1521),
    [sym_call] = STATE(1521),
    [sym_subset] = STATE(1521),
    [sym_subset2] = STATE(1521),
    [sym_unary_operator] = STATE(1521),
    [sym_binary_operator] = STATE(1521),
    [sym_extract_operator] = STATE(1521),
    [sym_namespace_operator] = STATE(1521),
    [sym_integer] = STATE(1521),
    [sym_complex] = STATE(1521),
    [sym_float] = STATE(1521),
    [sym__hex_literal] = STATE(2371),
    [sym__float_literal] = STATE(2371),
    [sym_string] = STATE(2372),
    [sym__single_quoted_string] = STATE(2370),
    [sym__double_quoted_string] = STATE(2369),
    [sym_na] = STATE(1521),
    [sym__expression] = STATE(1521),
    [sym__string_or_identifier] = STATE(5138),
    [sym__open_parenthesis] = STATE(200),
    [sym__close_parenthesis] = STATE(4696),
    [sym__open_brace] = STATE(97),
    [aux_sym_parenthesized_expression_repeat1] = STATE(330),
    [sym_identifier] = ACTIONS(2425),
    [anon_sym_BSLASH] = ACTIONS(2427),
    [anon_sym_function] = ACTIONS(2429),
    [anon_sym_EQ] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(2431),
    [anon_sym_for] = ACTIONS(2433),
    [anon_sym_while] = ACTIONS(2435),
    [anon_sym_repeat] = ACTIONS(2437),
    [anon_sym_QMARK] = ACTIONS(2439),
    [anon_sym_TILDE] = ACTIONS(2441),
    [anon_sym_BANG] = ACTIONS(2443),
    [anon_sym_PLUS] = ACTIONS(2445),
    [anon_sym_DASH] = ACTIONS(2447),
    [anon_sym_LT_DASH] = ACTIONS(211),
    [anon_sym_LT_LT_DASH] = ACTIONS(211),
    [anon_sym_COLON_EQ] = ACTIONS(211),
    [anon_sym_DASH_GT] = ACTIONS(209),
    [anon_sym_DASH_GT_GT] = ACTIONS(211),
    [anon_sym_PIPE] = ACTIONS(209),
    [anon_sym_AMP] = ACTIONS(209),
    [anon_sym_PIPE_PIPE] = ACTIONS(211),
    [anon_sym_AMP_AMP] = ACTIONS(211),
    [anon_sym_LT] = ACTIONS(209),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_GT] = ACTIONS(209),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [anon_sym_EQ_EQ] = ACTIONS(211),
    [anon_sym_BANG_EQ] = ACTIONS(211),
    [anon_sym_STAR] = ACTIONS(209),
    [anon_sym_SLASH] = ACTIONS(211),
    [anon_sym_STAR_STAR] = ACTIONS(211),
    [anon_sym_CARET] = ACTIONS(211),
    [aux_sym_binary_operator_token1] = ACTIONS(211),
    [anon_sym_PIPE_GT] = ACTIONS(211),
    [anon_sym_COLON] = ACTIONS(209),
    [anon_sym_DOLLAR] = ACTIONS(211),
    [anon_sym_AT] = ACTIONS(211),
    [aux_sym__hex_literal_token1] = ACTIONS(2449),
    [sym__number_literal] = ACTIONS(2451),
    [anon_sym_SQUOTE] = ACTIONS(2453),
    [anon_sym_DQUOTE] = ACTIONS(2455),
    [sym_return] = ACTIONS(2457),
    [sym_next] = ACTIONS(2457),
    [sym_break] = ACTIONS(2457),
    [sym_true] = ACTIONS(2457),
    [sym_false] = ACTIONS(2457),
    [sym_null] = ACTIONS(2457),
    [sym_inf] = ACTIONS(2457),
    [sym_nan] = ACTIONS(2457),
    [anon_sym_NA] = ACTIONS(2459),
    [anon_sym_NA_integer_] = ACTIONS(2459),
    [anon_sym_NA_real_] = ACTIONS(2459),
    [anon_sym_NA_complex_] = ACTIONS(2459),
    [anon_sym_NA_character_] = ACTIONS(2459),
    [sym_dots] = ACTIONS(2457),
    [sym_dot_dot_i] = ACTIONS(2461),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(211),
    [sym__newline] = ACTIONS(2463),
    [sym__raw_string_literal] = ACTIONS(2465),
    [sym__external_else] = ACTIONS(211),
    [sym__external_open_parenthesis] = ACTIONS(2467),
    [sym__external_close_parenthesis] = ACTIONS(3364),
    [sym__external_open_brace] = ACTIONS(2471),
    [sym__external_open_bracket] = ACTIONS(211),
    [sym__external_open_bracket2] = ACTIONS(211),
  },
  [287] = {
    [sym_function_definition] = STATE(1521),
    [sym_if_statement] = STATE(1521),
    [sym_for_statement] = STATE(1521),
    [sym_while_statement] = STATE(1521),
    [sym_repeat_statement] = STATE(1521),
    [sym_braced_expression] = STATE(1521),
    [sym_parenthesized_expression] = STATE(1521),
    [sym_call] = STATE(1521),
    [sym_subset] = STATE(1521),
    [sym_subset2] = STATE(1521),
    [sym_unary_operator] = STATE(1521),
    [sym_binary_operator] = STATE(1521),
    [sym_extract_operator] = STATE(1521),
    [sym_namespace_operator] = STATE(1521),
    [sym_integer] = STATE(1521),
    [sym_complex] = STATE(1521),
    [sym_float] = STATE(1521),
    [sym__hex_literal] = STATE(2371),
    [sym__float_literal] = STATE(2371),
    [sym_string] = STATE(2372),
    [sym__single_quoted_string] = STATE(2370),
    [sym__double_quoted_string] = STATE(2369),
    [sym_na] = STATE(1521),
    [sym__expression] = STATE(1521),
    [sym__string_or_identifier] = STATE(5138),
    [sym__open_parenthesis] = STATE(200),
    [sym__close_parenthesis] = STATE(4700),
    [sym__open_brace] = STATE(97),
    [aux_sym_parenthesized_expression_repeat1] = STATE(286),
    [sym_identifier] = ACTIONS(2425),
    [anon_sym_BSLASH] = ACTIONS(2427),
    [anon_sym_function] = ACTIONS(2429),
    [anon_sym_EQ] = ACTIONS(109),
    [anon_sym_if] = ACTIONS(2431),
    [anon_sym_for] = ACTIONS(2433),
    [anon_sym_while] = ACTIONS(2435),
    [anon_sym_repeat] = ACTIONS(2437),
    [anon_sym_QMARK] = ACTIONS(2439),
    [anon_sym_TILDE] = ACTIONS(2441),
    [anon_sym_BANG] = ACTIONS(2443),
    [anon_sym_PLUS] = ACTIONS(2445),
    [anon_sym_DASH] = ACTIONS(2447),
    [anon_sym_LT_DASH] = ACTIONS(129),
    [anon_sym_LT_LT_DASH] = ACTIONS(129),
    [anon_sym_COLON_EQ] = ACTIONS(129),
    [anon_sym_DASH_GT] = ACTIONS(109),
    [anon_sym_DASH_GT_GT] = ACTIONS(129),
    [anon_sym_PIPE] = ACTIONS(109),
    [anon_sym_AMP] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_STAR_STAR] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [aux_sym_binary_operator_token1] = ACTIONS(129),
    [anon_sym_PIPE_GT] = ACTIONS(129),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(129),
    [anon_sym_AT] = ACTIONS(129),
    [aux_sym__hex_literal_token1] = ACTIONS(2449),
    [sym__number_literal] = ACTIONS(2451),
    [anon_sym_SQUOTE] = ACTIONS(2453),
    [anon_sym_DQUOTE] = ACTIONS(2455),
    [sym_return] = ACTIONS(2457),
    [sym_next] = ACTIONS(2457),
    [sym_break] = ACTIONS(2457),
    [sym_true] = ACTIONS(2457),
    [sym_false] = ACTIONS(2457),
    [sym_null] = ACTIONS(2457),
    [sym_inf] = ACTIONS(2457),
    [sym_nan] = ACTIONS(2457),
    [anon_sym_NA] = ACTIONS(2459),
    [anon_sym_NA_integer_] = ACTIONS(2459),
    [anon_sym_NA_real_] = ACTIONS(2459),
    [anon_sym_NA_complex_] = ACTIONS(2459),
    [anon_sym_NA_character_] = ACTIONS(2459),
    [sym_dots] = ACTIONS(2457),
    [sym_dot_dot_i] = ACTIONS(2461),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(129),
    [sym__newline] = ACTIONS(2463),
    [sym__raw_string_literal] = ACTIONS(2465),
    [sym__external_else] = ACTIONS(129),
    [sym__external_open_parenthesis] = ACTIONS(2467),
    [sym__external_close_parenthesis] = ACTIONS(3366),
    [sym__external_open_brace] = ACTIONS(2471),
    [sym__external_open_bracket] = ACTIONS(129),
    [sym__external_open_bracket2] = ACTIONS(129),
  },
  [288] = {
    [sym_function_definition] = STATE(1131),
    [sym_if_statement] = STATE(1131),
    [sym_for_statement] = STATE(1131),
    [sym_while_statement] = STATE(1131),
    [sym_repeat_statement] = STATE(1131),
    [sym_braced_expression] = STATE(1131),
    [sym_parenthesized_expression] = STATE(1131),
    [sym_call] = STATE(1131),
    [sym_subset] = STATE(1131),
    [sym_subset2] = STATE(1131),
    [sym_unary_operator] = STATE(1131),
    [sym_binary_operator] = STATE(1131),
    [sym_extract_operator] = STATE(1131),
    [sym_namespace_operator] = STATE(1131),
    [sym_integer] = STATE(1131),
    [sym_complex] = STATE(1131),
    [sym_float] = STATE(1131),
    [sym__hex_literal] = STATE(2235),
    [sym__float_literal] = STATE(2235),
    [sym_string] = STATE(2234),
    [sym__single_quoted_string] = STATE(2236),
    [sym__double_quoted_string] = STATE(2237),
    [sym_na] = STATE(1131),
    [sym__expression] = STATE(1131),
    [sym__string_or_identifier] = STATE(5150),
    [sym__open_parenthesis] = STATE(76),
    [sym__open_brace] = STATE(188),
    [aux_sym_function_definition_repeat1] = STATE(2400),
    [sym_identifier] = ACTIONS(1433),
    [anon_sym_BSLASH] = ACTIONS(1435),
    [anon_sym_function] = ACTIONS(1437),
    [anon_sym_EQ] = ACTIONS(767),
    [anon_sym_if] = ACTIONS(1439),
    [anon_sym_for] = ACTIONS(1441),
    [anon_sym_while] = ACTIONS(1443),
    [anon_sym_repeat] = ACTIONS(1445),
    [anon_sym_QMARK] = ACTIONS(1447),
    [anon_sym_TILDE] = ACTIONS(1449),
    [anon_sym_BANG] = ACTIONS(1451),
    [anon_sym_PLUS] = ACTIONS(1453),
    [anon_sym_DASH] = ACTIONS(1455),
    [anon_sym_LT_DASH] = ACTIONS(765),
    [anon_sym_LT_LT_DASH] = ACTIONS(765),
    [anon_sym_COLON_EQ] = ACTIONS(765),
    [anon_sym_DASH_GT] = ACTIONS(767),
    [anon_sym_DASH_GT_GT] = ACTIONS(765),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_AMP] = ACTIONS(767),
    [anon_sym_PIPE_PIPE] = ACTIONS(765),
    [anon_sym_AMP_AMP] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(767),
    [anon_sym_LT_EQ] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_GT_EQ] = ACTIONS(765),
    [anon_sym_EQ_EQ] = ACTIONS(765),
    [anon_sym_BANG_EQ] = ACTIONS(765),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(765),
    [anon_sym_STAR_STAR] = ACTIONS(765),
    [anon_sym_CARET] = ACTIONS(765),
    [aux_sym_binary_operator_token1] = ACTIONS(765),
    [anon_sym_PIPE_GT] = ACTIONS(765),
    [anon_sym_COLON] = ACTIONS(767),
    [anon_sym_DOLLAR] = ACTIONS(765),
    [anon_sym_AT] = ACTIONS(765),
    [aux_sym__hex_literal_token1] = ACTIONS(1457),
    [sym__number_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [anon_sym_DQUOTE] = ACTIONS(1463),
    [sym_return] = ACTIONS(3368),
    [sym_next] = ACTIONS(3368),
    [sym_break] = ACTIONS(3368),
    [sym_true] = ACTIONS(3368),
    [sym_false] = ACTIONS(3368),
    [sym_null] = ACTIONS(3368),
    [sym_inf] = ACTIONS(3368),
    [sym_nan] = ACTIONS(3368),
    [anon_sym_NA] = ACTIONS(1467),
    [anon_sym_NA_integer_] = ACTIONS(1467),
    [anon_sym_NA_real_] = ACTIONS(1467),
    [anon_sym_NA_complex_] = ACTIONS(1467),
    [anon_sym_NA_character_] = ACTIONS(1467),
    [sym_dots] = ACTIONS(3368),
    [sym_dot_dot_i] = ACTIONS(3370),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(765),
    [sym__newline] = ACTIONS(765),
    [sym__semicolon] = ACTIONS(765),
    [sym__raw_string_literal] = ACTIONS(1473),
    [sym__external_open_parenthesis] = ACTIONS(1475),
    [sym__external_open_brace] = ACTIONS(1477),
    [sym__external_close_brace] = ACTIONS(765),
    [sym__external_open_bracket] = ACTIONS(765),
    [sym__external_open_bracket2] = ACTIONS(765),
    [sym__external_close_bracket2] = ACTIONS(765),
  },
  [289] = {
    [sym_function_definition] = STATE(1132),
    [sym_if_statement] = STATE(1132),
    [sym_for_statement] = STATE(1132),
    [sym_while_statement] = STATE(1132),
    [sym_repeat_statement] = STATE(1132),
    [sym_braced_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_subset] = STATE(1132),
    [sym_subset2] = STATE(1132),
    [sym_unary_operator] = STATE(1132),
    [sym_binary_operator] = STATE(1132),
    [sym_extract_operator] = STATE(1132),
    [sym_namespace_operator] = STATE(1132),
    [sym_integer] = STATE(1132),
    [sym_complex] = STATE(1132),
    [sym_float] = STATE(1132),
    [sym__hex_literal] = STATE(2235),
    [sym__float_literal] = STATE(2235),
    [sym_string] = STATE(2234),
    [sym__single_quoted_string] = STATE(2236),
    [sym__double_quoted_string] = STATE(2237),
    [sym_na] = STATE(1132),
    [sym__expression] = STATE(1132),
    [sym__string_or_identifier] = STATE(5150),
    [sym__open_parenthesis] = STATE(76),
    [sym__open_brace] = STATE(188),
    [aux_sym_function_definition_repeat1] = STATE(277),
    [sym_identifier] = ACTIONS(1433),
    [anon_sym_BSLASH] = ACTIONS(1435),
    [anon_sym_function] = ACTIONS(1437),
    [anon_sym_EQ] = ACTIONS(543),
    [anon_sym_if] = ACTIONS(1439),
    [anon_sym_for] = ACTIONS(1441),
    [anon_sym_while] = ACTIONS(1443),
    [anon_sym_repeat] = ACTIONS(1445),
    [anon_sym_QMARK] = ACTIONS(1447),
    [anon_sym_TILDE] = ACTIONS(1449),
    [anon_sym_BANG] = ACTIONS(1451),
    [anon_sym_PLUS] = ACTIONS(1453),
    [anon_sym_DASH] = ACTIONS(1455),
    [anon_sym_LT_DASH] = ACTIONS(545),
    [anon_sym_LT_LT_DASH] = ACTIONS(545),
    [anon_sym_COLON_EQ] = ACTIONS(545),
    [anon_sym_DASH_GT] = ACTIONS(543),
    [anon_sym_DASH_GT_GT] = ACTIONS(545),
    [anon_sym_PIPE] = ACTIONS(543),
    [anon_sym_AMP] = ACTIONS(543),
    [anon_sym_PIPE_PIPE] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(543),
    [anon_sym_LT_EQ] = ACTIONS(545),
    [anon_sym_GT] = ACTIONS(543),
    [anon_sym_GT_EQ] = ACTIONS(545),
    [anon_sym_EQ_EQ] = ACTIONS(545),
    [anon_sym_BANG_EQ] = ACTIONS(545),
    [anon_sym_STAR] = ACTIONS(543),
    [anon_sym_SLASH] = ACTIONS(545),
    [anon_sym_STAR_STAR] = ACTIONS(545),
    [anon_sym_CARET] = ACTIONS(545),
    [aux_sym_binary_operator_token1] = ACTIONS(545),
    [anon_sym_PIPE_GT] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(543),
    [anon_sym_DOLLAR] = ACTIONS(545),
    [anon_sym_AT] = ACTIONS(545),
    [aux_sym__hex_literal_token1] = ACTIONS(1457),
    [sym__number_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [anon_sym_DQUOTE] = ACTIONS(1463),
    [sym_return] = ACTIONS(3372),
    [sym_next] = ACTIONS(3372),
    [sym_break] = ACTIONS(3372),
    [sym_true] = ACTIONS(3372),
    [sym_false] = ACTIONS(3372),
    [sym_null] = ACTIONS(3372),
    [sym_inf] = ACTIONS(3372),
    [sym_nan] = ACTIONS(3372),
    [anon_sym_NA] = ACTIONS(1467),
    [anon_sym_NA_integer_] = ACTIONS(1467),
    [anon_sym_NA_real_] = ACTIONS(1467),
    [anon_sym_NA_complex_] = ACTIONS(1467),
    [anon_sym_NA_character_] = ACTIONS(1467),
    [sym_dots] = ACTIONS(3372),
    [sym_dot_dot_i] = ACTIONS(3374),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(545),
    [sym__newline] = ACTIONS(3376),
    [sym__semicolon] = ACTIONS(545),
    [sym__raw_string_literal] = ACTIONS(1473),
    [sym__external_open_parenthesis] = ACTIONS(1475),
    [sym__external_open_brace] = ACTIONS(1477),
    [sym__external_close_brace] = ACTIONS(545),
    [sym__external_open_bracket] = ACTIONS(545),
    [sym__external_open_bracket2] = ACTIONS(545),
    [sym__external_close_bracket2] = ACTIONS(545),
  },
  [290] = {
    [sym_function_definition] = STATE(1241),
    [sym_if_statement] = STATE(1241),
    [sym_for_statement] = STATE(1241),
    [sym_while_statement] = STATE(1241),
    [sym_repeat_statement] = STATE(1241),
    [sym_braced_expression] = STATE(1241),
    [sym_parenthesized_expression] = STATE(1241),
    [sym_call] = STATE(1241),
    [sym_subset] = STATE(1241),
    [sym_subset2] = STATE(1241),
    [sym_unary_operator] = STATE(1241),
    [sym_binary_operator] = STATE(1241),
    [sym_extract_operator] = STATE(1241),
    [sym_namespace_operator] = STATE(1241),
    [sym_integer] = STATE(1241),
    [sym_complex] = STATE(1241),
    [sym_float] = STATE(1241),
    [sym__hex_literal] = STATE(2266),
    [sym__float_literal] = STATE(2266),
    [sym_string] = STATE(2284),
    [sym__single_quoted_string] = STATE(2265),
    [sym__double_quoted_string] = STATE(2264),
    [sym_na] = STATE(1241),
    [sym__expression] = STATE(1241),
    [sym__string_or_identifier] = STATE(5147),
    [sym__open_parenthesis] = STATE(23),
    [sym__open_brace] = STATE(180),
    [aux_sym_function_definition_repeat1] = STATE(297),
    [sym_identifier] = ACTIONS(1289),
    [anon_sym_BSLASH] = ACTIONS(1291),
    [anon_sym_function] = ACTIONS(1293),
    [anon_sym_EQ] = ACTIONS(543),
    [anon_sym_if] = ACTIONS(1295),
    [anon_sym_for] = ACTIONS(1297),
    [anon_sym_while] = ACTIONS(1299),
    [anon_sym_repeat] = ACTIONS(1301),
    [anon_sym_QMARK] = ACTIONS(1303),
    [anon_sym_TILDE] = ACTIONS(1305),
    [anon_sym_BANG] = ACTIONS(1307),
    [anon_sym_PLUS] = ACTIONS(1309),
    [anon_sym_DASH] = ACTIONS(1311),
    [anon_sym_LT_DASH] = ACTIONS(545),
    [anon_sym_LT_LT_DASH] = ACTIONS(545),
    [anon_sym_COLON_EQ] = ACTIONS(545),
    [anon_sym_DASH_GT] = ACTIONS(543),
    [anon_sym_DASH_GT_GT] = ACTIONS(545),
    [anon_sym_PIPE] = ACTIONS(543),
    [anon_sym_AMP] = ACTIONS(543),
    [anon_sym_PIPE_PIPE] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(543),
    [anon_sym_LT_EQ] = ACTIONS(545),
    [anon_sym_GT] = ACTIONS(543),
    [anon_sym_GT_EQ] = ACTIONS(545),
    [anon_sym_EQ_EQ] = ACTIONS(545),
    [anon_sym_BANG_EQ] = ACTIONS(545),
    [anon_sym_STAR] = ACTIONS(543),
    [anon_sym_SLASH] = ACTIONS(545),
    [anon_sym_STAR_STAR] = ACTIONS(545),
    [anon_sym_CARET] = ACTIONS(545),
    [aux_sym_binary_operator_token1] = ACTIONS(545),
    [anon_sym_PIPE_GT] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(543),
    [anon_sym_DOLLAR] = ACTIONS(545),
    [anon_sym_AT] = ACTIONS(545),
    [aux_sym__hex_literal_token1] = ACTIONS(1313),
    [sym__number_literal] = ACTIONS(1315),
    [anon_sym_SQUOTE] = ACTIONS(1317),
    [anon_sym_DQUOTE] = ACTIONS(1319),
    [sym_return] = ACTIONS(3378),
    [sym_next] = ACTIONS(3378),
    [sym_break] = ACTIONS(3378),
    [sym_true] = ACTIONS(3378),
    [sym_false] = ACTIONS(3378),
    [sym_null] = ACTIONS(3378),
    [sym_inf] = ACTIONS(3378),
    [sym_nan] = ACTIONS(3378),
    [anon_sym_NA] = ACTIONS(1323),
    [anon_sym_NA_integer_] = ACTIONS(1323),
    [anon_sym_NA_real_] = ACTIONS(1323),
    [anon_sym_NA_complex_] = ACTIONS(1323),
    [anon_sym_NA_character_] = ACTIONS(1323),
    [sym_dots] = ACTIONS(3378),
    [sym_dot_dot_i] = ACTIONS(3380),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(545),
    [sym__newline] = ACTIONS(3382),
    [sym__semicolon] = ACTIONS(545),
    [sym__raw_string_literal] = ACTIONS(1329),
    [sym__external_open_parenthesis] = ACTIONS(1331),
    [sym__external_open_brace] = ACTIONS(1333),
    [sym__external_close_brace] = ACTIONS(545),
    [sym__external_open_bracket] = ACTIONS(545),
    [sym__external_close_bracket] = ACTIONS(545),
    [sym__external_open_bracket2] = ACTIONS(545),
  },
  [291] = {
    [sym_function_definition] = STATE(1240),
    [sym_if_statement] = STATE(1240),
    [sym_for_statement] = STATE(1240),
    [sym_while_statement] = STATE(1240),
    [sym_repeat_statement] = STATE(1240),
    [sym_braced_expression] = STATE(1240),
    [sym_parenthesized_expression] = STATE(1240),
    [sym_call] = STATE(1240),
    [sym_subset] = STATE(1240),
    [sym_subset2] = STATE(1240),
    [sym_unary_operator] = STATE(1240),
    [sym_binary_operator] = STATE(1240),
    [sym_extract_operator] = STATE(1240),
    [sym_namespace_operator] = STATE(1240),
    [sym_integer] = STATE(1240),
    [sym_complex] = STATE(1240),
    [sym_float] = STATE(1240),
    [sym__hex_literal] = STATE(2266),
    [sym__float_literal] = STATE(2266),
    [sym_string] = STATE(2284),
    [sym__single_quoted_string] = STATE(2265),
    [sym__double_quoted_string] = STATE(2264),
    [sym_na] = STATE(1240),
    [sym__expression] = STATE(1240),
    [sym__string_or_identifier] = STATE(5147),
    [sym__open_parenthesis] = STATE(23),
    [sym__open_brace] = STATE(180),
    [aux_sym_function_definition_repeat1] = STATE(2398),
    [sym_identifier] = ACTIONS(1289),
    [anon_sym_BSLASH] = ACTIONS(1291),
    [anon_sym_function] = ACTIONS(1293),
    [anon_sym_EQ] = ACTIONS(767),
    [anon_sym_if] = ACTIONS(1295),
    [anon_sym_for] = ACTIONS(1297),
    [anon_sym_while] = ACTIONS(1299),
    [anon_sym_repeat] = ACTIONS(1301),
    [anon_sym_QMARK] = ACTIONS(1303),
    [anon_sym_TILDE] = ACTIONS(1305),
    [anon_sym_BANG] = ACTIONS(1307),
    [anon_sym_PLUS] = ACTIONS(1309),
    [anon_sym_DASH] = ACTIONS(1311),
    [anon_sym_LT_DASH] = ACTIONS(765),
    [anon_sym_LT_LT_DASH] = ACTIONS(765),
    [anon_sym_COLON_EQ] = ACTIONS(765),
    [anon_sym_DASH_GT] = ACTIONS(767),
    [anon_sym_DASH_GT_GT] = ACTIONS(765),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_AMP] = ACTIONS(767),
    [anon_sym_PIPE_PIPE] = ACTIONS(765),
    [anon_sym_AMP_AMP] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(767),
    [anon_sym_LT_EQ] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_GT_EQ] = ACTIONS(765),
    [anon_sym_EQ_EQ] = ACTIONS(765),
    [anon_sym_BANG_EQ] = ACTIONS(765),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(765),
    [anon_sym_STAR_STAR] = ACTIONS(765),
    [anon_sym_CARET] = ACTIONS(765),
    [aux_sym_binary_operator_token1] = ACTIONS(765),
    [anon_sym_PIPE_GT] = ACTIONS(765),
    [anon_sym_COLON] = ACTIONS(767),
    [anon_sym_DOLLAR] = ACTIONS(765),
    [anon_sym_AT] = ACTIONS(765),
    [aux_sym__hex_literal_token1] = ACTIONS(1313),
    [sym__number_literal] = ACTIONS(1315),
    [anon_sym_SQUOTE] = ACTIONS(1317),
    [anon_sym_DQUOTE] = ACTIONS(1319),
    [sym_return] = ACTIONS(3384),
    [sym_next] = ACTIONS(3384),
    [sym_break] = ACTIONS(3384),
    [sym_true] = ACTIONS(3384),
    [sym_false] = ACTIONS(3384),
    [sym_null] = ACTIONS(3384),
    [sym_inf] = ACTIONS(3384),
    [sym_nan] = ACTIONS(3384),
    [anon_sym_NA] = ACTIONS(1323),
    [anon_sym_NA_integer_] = ACTIONS(1323),
    [anon_sym_NA_real_] = ACTIONS(1323),
    [anon_sym_NA_complex_] = ACTIONS(1323),
    [anon_sym_NA_character_] = ACTIONS(1323),
    [sym_dots] = ACTIONS(3384),
    [sym_dot_dot_i] = ACTIONS(3386),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(765),
    [sym__newline] = ACTIONS(765),
    [sym__semicolon] = ACTIONS(765),
    [sym__raw_string_literal] = ACTIONS(1329),
    [sym__external_open_parenthesis] = ACTIONS(1331),
    [sym__external_open_brace] = ACTIONS(1333),
    [sym__external_close_brace] = ACTIONS(765),
    [sym__external_open_bracket] = ACTIONS(765),
    [sym__external_close_bracket] = ACTIONS(765),
    [sym__external_open_bracket2] = ACTIONS(765),
  },
  [292] = {
    [sym_function_definition] = STATE(1445),
    [sym_if_statement] = STATE(1445),
    [sym_for_statement] = STATE(1445),
    [sym_while_statement] = STATE(1445),
    [sym_repeat_statement] = STATE(1445),
    [sym_braced_expression] = STATE(1445),
    [sym_parenthesized_expression] = STATE(1445),
    [sym_call] = STATE(1445),
    [sym_subset] = STATE(1445),
    [sym_subset2] = STATE(1445),
    [sym_unary_operator] = STATE(1445),
    [sym_binary_operator] = STATE(1445),
    [sym_extract_operator] = STATE(1445),
    [sym_namespace_operator] = STATE(1445),
    [sym_integer] = STATE(1445),
    [sym_complex] = STATE(1445),
    [sym_float] = STATE(1445),
    [sym__hex_literal] = STATE(2523),
    [sym__float_literal] = STATE(2523),
    [sym_string] = STATE(2522),
    [sym__single_quoted_string] = STATE(2528),
    [sym__double_quoted_string] = STATE(2529),
    [sym_na] = STATE(1445),
    [sym__expression] = STATE(1445),
    [sym__string_or_identifier] = STATE(5126),
    [sym__open_parenthesis] = STATE(178),
    [sym__open_brace] = STATE(244),
    [sym__close_brace] = STATE(2982),
    [aux_sym_braced_expression_repeat1] = STATE(285),
    [ts_builtin_sym_end] = ACTIONS(155),
    [sym_identifier] = ACTIONS(2826),
    [anon_sym_BSLASH] = ACTIONS(2828),
    [anon_sym_function] = ACTIONS(2830),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(2832),
    [anon_sym_for] = ACTIONS(2834),
    [anon_sym_while] = ACTIONS(2836),
    [anon_sym_repeat] = ACTIONS(2838),
    [anon_sym_QMARK] = ACTIONS(2840),
    [anon_sym_TILDE] = ACTIONS(2842),
    [anon_sym_BANG] = ACTIONS(2844),
    [anon_sym_PLUS] = ACTIONS(2846),
    [anon_sym_DASH] = ACTIONS(2848),
    [anon_sym_LT_DASH] = ACTIONS(155),
    [anon_sym_LT_LT_DASH] = ACTIONS(155),
    [anon_sym_COLON_EQ] = ACTIONS(155),
    [anon_sym_DASH_GT] = ACTIONS(157),
    [anon_sym_DASH_GT_GT] = ACTIONS(155),
    [anon_sym_PIPE] = ACTIONS(157),
    [anon_sym_AMP] = ACTIONS(157),
    [anon_sym_PIPE_PIPE] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(157),
    [anon_sym_LT_EQ] = ACTIONS(155),
    [anon_sym_GT] = ACTIONS(157),
    [anon_sym_GT_EQ] = ACTIONS(155),
    [anon_sym_EQ_EQ] = ACTIONS(155),
    [anon_sym_BANG_EQ] = ACTIONS(155),
    [anon_sym_STAR] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(155),
    [anon_sym_STAR_STAR] = ACTIONS(155),
    [anon_sym_CARET] = ACTIONS(155),
    [aux_sym_binary_operator_token1] = ACTIONS(155),
    [anon_sym_PIPE_GT] = ACTIONS(155),
    [anon_sym_COLON] = ACTIONS(157),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(155),
    [aux_sym__hex_literal_token1] = ACTIONS(2850),
    [sym__number_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE] = ACTIONS(2856),
    [sym_return] = ACTIONS(2858),
    [sym_next] = ACTIONS(2858),
    [sym_break] = ACTIONS(2858),
    [sym_true] = ACTIONS(2858),
    [sym_false] = ACTIONS(2858),
    [sym_null] = ACTIONS(2858),
    [sym_inf] = ACTIONS(2858),
    [sym_nan] = ACTIONS(2858),
    [anon_sym_NA] = ACTIONS(2860),
    [anon_sym_NA_integer_] = ACTIONS(2860),
    [anon_sym_NA_real_] = ACTIONS(2860),
    [anon_sym_NA_complex_] = ACTIONS(2860),
    [anon_sym_NA_character_] = ACTIONS(2860),
    [sym_dots] = ACTIONS(2858),
    [sym_dot_dot_i] = ACTIONS(2862),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(2864),
    [sym__semicolon] = ACTIONS(2864),
    [sym__raw_string_literal] = ACTIONS(2866),
    [sym__external_open_parenthesis] = ACTIONS(2868),
    [sym__external_open_brace] = ACTIONS(2870),
    [sym__external_close_brace] = ACTIONS(3388),
    [sym__external_open_bracket] = ACTIONS(155),
    [sym__external_open_bracket2] = ACTIONS(155),
  },
  [293] = {
    [sym_function_definition] = STATE(1354),
    [sym_if_statement] = STATE(1354),
    [sym_for_statement] = STATE(1354),
    [sym_while_statement] = STATE(1354),
    [sym_repeat_statement] = STATE(1354),
    [sym_braced_expression] = STATE(1354),
    [sym_parenthesized_expression] = STATE(1354),
    [sym_call] = STATE(1354),
    [sym_subset] = STATE(1354),
    [sym_subset2] = STATE(1354),
    [sym_unary_operator] = STATE(1354),
    [sym_binary_operator] = STATE(1354),
    [sym_extract_operator] = STATE(1354),
    [sym_namespace_operator] = STATE(1354),
    [sym_integer] = STATE(1354),
    [sym_complex] = STATE(1354),
    [sym_float] = STATE(1354),
    [sym__hex_literal] = STATE(2540),
    [sym__float_literal] = STATE(2540),
    [sym_string] = STATE(2541),
    [sym__single_quoted_string] = STATE(2462),
    [sym__double_quoted_string] = STATE(2494),
    [sym_na] = STATE(1354),
    [sym__expression] = STATE(1354),
    [sym__string_or_identifier] = STATE(5128),
    [sym__open_parenthesis] = STATE(246),
    [sym__close_parenthesis] = STATE(3017),
    [sym__open_brace] = STATE(173),
    [aux_sym_parenthesized_expression_repeat1] = STATE(296),
    [ts_builtin_sym_end] = ACTIONS(129),
    [sym_identifier] = ACTIONS(2943),
    [anon_sym_BSLASH] = ACTIONS(2945),
    [anon_sym_function] = ACTIONS(2947),
    [anon_sym_EQ] = ACTIONS(109),
    [anon_sym_if] = ACTIONS(2949),
    [anon_sym_for] = ACTIONS(2951),
    [anon_sym_while] = ACTIONS(2953),
    [anon_sym_repeat] = ACTIONS(2955),
    [anon_sym_QMARK] = ACTIONS(2957),
    [anon_sym_TILDE] = ACTIONS(2959),
    [anon_sym_BANG] = ACTIONS(2961),
    [anon_sym_PLUS] = ACTIONS(2963),
    [anon_sym_DASH] = ACTIONS(2965),
    [anon_sym_LT_DASH] = ACTIONS(129),
    [anon_sym_LT_LT_DASH] = ACTIONS(129),
    [anon_sym_COLON_EQ] = ACTIONS(129),
    [anon_sym_DASH_GT] = ACTIONS(109),
    [anon_sym_DASH_GT_GT] = ACTIONS(129),
    [anon_sym_PIPE] = ACTIONS(109),
    [anon_sym_AMP] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_STAR_STAR] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [aux_sym_binary_operator_token1] = ACTIONS(129),
    [anon_sym_PIPE_GT] = ACTIONS(129),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(129),
    [anon_sym_AT] = ACTIONS(129),
    [aux_sym__hex_literal_token1] = ACTIONS(2967),
    [sym__number_literal] = ACTIONS(2969),
    [anon_sym_SQUOTE] = ACTIONS(2971),
    [anon_sym_DQUOTE] = ACTIONS(2973),
    [sym_return] = ACTIONS(2975),
    [sym_next] = ACTIONS(2975),
    [sym_break] = ACTIONS(2975),
    [sym_true] = ACTIONS(2975),
    [sym_false] = ACTIONS(2975),
    [sym_null] = ACTIONS(2975),
    [sym_inf] = ACTIONS(2975),
    [sym_nan] = ACTIONS(2975),
    [anon_sym_NA] = ACTIONS(2977),
    [anon_sym_NA_integer_] = ACTIONS(2977),
    [anon_sym_NA_real_] = ACTIONS(2977),
    [anon_sym_NA_complex_] = ACTIONS(2977),
    [anon_sym_NA_character_] = ACTIONS(2977),
    [sym_dots] = ACTIONS(2975),
    [sym_dot_dot_i] = ACTIONS(2979),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(2981),
    [sym__semicolon] = ACTIONS(129),
    [sym__raw_string_literal] = ACTIONS(2983),
    [sym__external_open_parenthesis] = ACTIONS(2985),
    [sym__external_close_parenthesis] = ACTIONS(3390),
    [sym__external_open_brace] = ACTIONS(2989),
    [sym__external_open_bracket] = ACTIONS(129),
    [sym__external_open_bracket2] = ACTIONS(129),
  },
  [294] = {
    [sym_function_definition] = STATE(970),
    [sym_if_statement] = STATE(970),
    [sym_for_statement] = STATE(970),
    [sym_while_statement] = STATE(970),
    [sym_repeat_statement] = STATE(970),
    [sym_braced_expression] = STATE(970),
    [sym_parenthesized_expression] = STATE(970),
    [sym_call] = STATE(970),
    [sym_subset] = STATE(970),
    [sym_subset2] = STATE(970),
    [sym_unary_operator] = STATE(970),
    [sym_binary_operator] = STATE(970),
    [sym_extract_operator] = STATE(970),
    [sym_namespace_operator] = STATE(970),
    [sym_integer] = STATE(970),
    [sym_complex] = STATE(970),
    [sym_float] = STATE(970),
    [sym__hex_literal] = STATE(2266),
    [sym__float_literal] = STATE(2266),
    [sym_string] = STATE(2284),
    [sym__single_quoted_string] = STATE(2265),
    [sym__double_quoted_string] = STATE(2264),
    [sym_na] = STATE(970),
    [sym__expression] = STATE(970),
    [sym__string_or_identifier] = STATE(5147),
    [sym__open_parenthesis] = STATE(23),
    [sym__open_brace] = STATE(180),
    [aux_sym_braced_expression_repeat1] = STATE(294),
    [sym_identifier] = ACTIONS(3392),
    [anon_sym_BSLASH] = ACTIONS(3395),
    [anon_sym_function] = ACTIONS(3398),
    [anon_sym_EQ] = ACTIONS(562),
    [anon_sym_if] = ACTIONS(3401),
    [anon_sym_for] = ACTIONS(3404),
    [anon_sym_while] = ACTIONS(3407),
    [anon_sym_repeat] = ACTIONS(3410),
    [anon_sym_QMARK] = ACTIONS(3413),
    [anon_sym_TILDE] = ACTIONS(3416),
    [anon_sym_BANG] = ACTIONS(3419),
    [anon_sym_PLUS] = ACTIONS(3422),
    [anon_sym_DASH] = ACTIONS(3425),
    [anon_sym_LT_DASH] = ACTIONS(591),
    [anon_sym_LT_LT_DASH] = ACTIONS(591),
    [anon_sym_COLON_EQ] = ACTIONS(591),
    [anon_sym_DASH_GT] = ACTIONS(562),
    [anon_sym_DASH_GT_GT] = ACTIONS(591),
    [anon_sym_PIPE] = ACTIONS(562),
    [anon_sym_AMP] = ACTIONS(562),
    [anon_sym_PIPE_PIPE] = ACTIONS(591),
    [anon_sym_AMP_AMP] = ACTIONS(591),
    [anon_sym_LT] = ACTIONS(562),
    [anon_sym_LT_EQ] = ACTIONS(591),
    [anon_sym_GT] = ACTIONS(562),
    [anon_sym_GT_EQ] = ACTIONS(591),
    [anon_sym_EQ_EQ] = ACTIONS(591),
    [anon_sym_BANG_EQ] = ACTIONS(591),
    [anon_sym_STAR] = ACTIONS(562),
    [anon_sym_SLASH] = ACTIONS(591),
    [anon_sym_STAR_STAR] = ACTIONS(591),
    [anon_sym_CARET] = ACTIONS(591),
    [aux_sym_binary_operator_token1] = ACTIONS(591),
    [anon_sym_PIPE_GT] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(562),
    [anon_sym_DOLLAR] = ACTIONS(591),
    [anon_sym_AT] = ACTIONS(591),
    [aux_sym__hex_literal_token1] = ACTIONS(3428),
    [sym__number_literal] = ACTIONS(3431),
    [anon_sym_SQUOTE] = ACTIONS(3434),
    [anon_sym_DQUOTE] = ACTIONS(3437),
    [sym_return] = ACTIONS(3440),
    [sym_next] = ACTIONS(3440),
    [sym_break] = ACTIONS(3440),
    [sym_true] = ACTIONS(3440),
    [sym_false] = ACTIONS(3440),
    [sym_null] = ACTIONS(3440),
    [sym_inf] = ACTIONS(3440),
    [sym_nan] = ACTIONS(3440),
    [anon_sym_NA] = ACTIONS(3443),
    [anon_sym_NA_integer_] = ACTIONS(3443),
    [anon_sym_NA_real_] = ACTIONS(3443),
    [anon_sym_NA_complex_] = ACTIONS(3443),
    [anon_sym_NA_character_] = ACTIONS(3443),
    [sym_dots] = ACTIONS(3440),
    [sym_dot_dot_i] = ACTIONS(3446),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(591),
    [sym__newline] = ACTIONS(3449),
    [sym__semicolon] = ACTIONS(3449),
    [sym__raw_string_literal] = ACTIONS(3452),
    [sym__external_open_parenthesis] = ACTIONS(3455),
    [sym__external_open_brace] = ACTIONS(3458),
    [sym__external_close_brace] = ACTIONS(591),
    [sym__external_open_bracket] = ACTIONS(591),
    [sym__external_close_bracket] = ACTIONS(591),
    [sym__external_open_bracket2] = ACTIONS(591),
  },
  [295] = {
    [sym_function_definition] = STATE(1618),
    [sym_if_statement] = STATE(1618),
    [sym_for_statement] = STATE(1618),
    [sym_while_statement] = STATE(1618),
    [sym_repeat_statement] = STATE(1618),
    [sym_braced_expression] = STATE(1618),
    [sym_parenthesized_expression] = STATE(1618),
    [sym_call] = STATE(1618),
    [sym_subset] = STATE(1618),
    [sym_subset2] = STATE(1618),
    [sym_unary_operator] = STATE(1618),
    [sym_binary_operator] = STATE(1618),
    [sym_extract_operator] = STATE(1618),
    [sym_namespace_operator] = STATE(1618),
    [sym_integer] = STATE(1618),
    [sym_complex] = STATE(1618),
    [sym_float] = STATE(1618),
    [sym__hex_literal] = STATE(2445),
    [sym__float_literal] = STATE(2445),
    [sym_string] = STATE(2530),
    [sym__single_quoted_string] = STATE(2442),
    [sym__double_quoted_string] = STATE(2437),
    [sym_na] = STATE(1618),
    [sym__expression] = STATE(1618),
    [sym__string_or_identifier] = STATE(5133),
    [sym__open_parenthesis] = STATE(213),
    [sym__close_parenthesis] = STATE(3001),
    [sym__open_brace] = STATE(70),
    [aux_sym_parenthesized_expression_repeat1] = STATE(307),
    [sym_identifier] = ACTIONS(2531),
    [anon_sym_BSLASH] = ACTIONS(2533),
    [anon_sym_function] = ACTIONS(2535),
    [anon_sym_EQ] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(2537),
    [anon_sym_for] = ACTIONS(2539),
    [anon_sym_while] = ACTIONS(2541),
    [anon_sym_repeat] = ACTIONS(2543),
    [anon_sym_QMARK] = ACTIONS(2545),
    [anon_sym_TILDE] = ACTIONS(2547),
    [anon_sym_BANG] = ACTIONS(2549),
    [anon_sym_PLUS] = ACTIONS(2551),
    [anon_sym_DASH] = ACTIONS(2553),
    [anon_sym_LT_DASH] = ACTIONS(211),
    [anon_sym_LT_LT_DASH] = ACTIONS(211),
    [anon_sym_COLON_EQ] = ACTIONS(211),
    [anon_sym_DASH_GT] = ACTIONS(209),
    [anon_sym_DASH_GT_GT] = ACTIONS(211),
    [anon_sym_PIPE] = ACTIONS(209),
    [anon_sym_AMP] = ACTIONS(209),
    [anon_sym_PIPE_PIPE] = ACTIONS(211),
    [anon_sym_AMP_AMP] = ACTIONS(211),
    [anon_sym_LT] = ACTIONS(209),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_GT] = ACTIONS(209),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [anon_sym_EQ_EQ] = ACTIONS(211),
    [anon_sym_BANG_EQ] = ACTIONS(211),
    [anon_sym_STAR] = ACTIONS(209),
    [anon_sym_SLASH] = ACTIONS(211),
    [anon_sym_STAR_STAR] = ACTIONS(211),
    [anon_sym_CARET] = ACTIONS(211),
    [aux_sym_binary_operator_token1] = ACTIONS(211),
    [anon_sym_PIPE_GT] = ACTIONS(211),
    [anon_sym_COLON] = ACTIONS(209),
    [anon_sym_DOLLAR] = ACTIONS(211),
    [anon_sym_AT] = ACTIONS(211),
    [aux_sym__hex_literal_token1] = ACTIONS(2555),
    [sym__number_literal] = ACTIONS(2557),
    [anon_sym_SQUOTE] = ACTIONS(2559),
    [anon_sym_DQUOTE] = ACTIONS(2561),
    [sym_return] = ACTIONS(2563),
    [sym_next] = ACTIONS(2563),
    [sym_break] = ACTIONS(2563),
    [sym_true] = ACTIONS(2563),
    [sym_false] = ACTIONS(2563),
    [sym_null] = ACTIONS(2563),
    [sym_inf] = ACTIONS(2563),
    [sym_nan] = ACTIONS(2563),
    [anon_sym_NA] = ACTIONS(2565),
    [anon_sym_NA_integer_] = ACTIONS(2565),
    [anon_sym_NA_real_] = ACTIONS(2565),
    [anon_sym_NA_complex_] = ACTIONS(2565),
    [anon_sym_NA_character_] = ACTIONS(2565),
    [sym_dots] = ACTIONS(2563),
    [sym_dot_dot_i] = ACTIONS(2567),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(211),
    [sym__newline] = ACTIONS(2569),
    [sym__raw_string_literal] = ACTIONS(2571),
    [sym__external_open_parenthesis] = ACTIONS(2573),
    [sym__external_close_parenthesis] = ACTIONS(3461),
    [sym__external_open_brace] = ACTIONS(2577),
    [sym__external_open_bracket] = ACTIONS(211),
    [sym__external_close_bracket] = ACTIONS(211),
    [sym__external_open_bracket2] = ACTIONS(211),
  },
  [296] = {
    [sym_function_definition] = STATE(1354),
    [sym_if_statement] = STATE(1354),
    [sym_for_statement] = STATE(1354),
    [sym_while_statement] = STATE(1354),
    [sym_repeat_statement] = STATE(1354),
    [sym_braced_expression] = STATE(1354),
    [sym_parenthesized_expression] = STATE(1354),
    [sym_call] = STATE(1354),
    [sym_subset] = STATE(1354),
    [sym_subset2] = STATE(1354),
    [sym_unary_operator] = STATE(1354),
    [sym_binary_operator] = STATE(1354),
    [sym_extract_operator] = STATE(1354),
    [sym_namespace_operator] = STATE(1354),
    [sym_integer] = STATE(1354),
    [sym_complex] = STATE(1354),
    [sym_float] = STATE(1354),
    [sym__hex_literal] = STATE(2540),
    [sym__float_literal] = STATE(2540),
    [sym_string] = STATE(2541),
    [sym__single_quoted_string] = STATE(2462),
    [sym__double_quoted_string] = STATE(2494),
    [sym_na] = STATE(1354),
    [sym__expression] = STATE(1354),
    [sym__string_or_identifier] = STATE(5128),
    [sym__open_parenthesis] = STATE(246),
    [sym__close_parenthesis] = STATE(3009),
    [sym__open_brace] = STATE(173),
    [aux_sym_parenthesized_expression_repeat1] = STATE(414),
    [ts_builtin_sym_end] = ACTIONS(211),
    [sym_identifier] = ACTIONS(2943),
    [anon_sym_BSLASH] = ACTIONS(2945),
    [anon_sym_function] = ACTIONS(2947),
    [anon_sym_EQ] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(2949),
    [anon_sym_for] = ACTIONS(2951),
    [anon_sym_while] = ACTIONS(2953),
    [anon_sym_repeat] = ACTIONS(2955),
    [anon_sym_QMARK] = ACTIONS(2957),
    [anon_sym_TILDE] = ACTIONS(2959),
    [anon_sym_BANG] = ACTIONS(2961),
    [anon_sym_PLUS] = ACTIONS(2963),
    [anon_sym_DASH] = ACTIONS(2965),
    [anon_sym_LT_DASH] = ACTIONS(211),
    [anon_sym_LT_LT_DASH] = ACTIONS(211),
    [anon_sym_COLON_EQ] = ACTIONS(211),
    [anon_sym_DASH_GT] = ACTIONS(209),
    [anon_sym_DASH_GT_GT] = ACTIONS(211),
    [anon_sym_PIPE] = ACTIONS(209),
    [anon_sym_AMP] = ACTIONS(209),
    [anon_sym_PIPE_PIPE] = ACTIONS(211),
    [anon_sym_AMP_AMP] = ACTIONS(211),
    [anon_sym_LT] = ACTIONS(209),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_GT] = ACTIONS(209),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [anon_sym_EQ_EQ] = ACTIONS(211),
    [anon_sym_BANG_EQ] = ACTIONS(211),
    [anon_sym_STAR] = ACTIONS(209),
    [anon_sym_SLASH] = ACTIONS(211),
    [anon_sym_STAR_STAR] = ACTIONS(211),
    [anon_sym_CARET] = ACTIONS(211),
    [aux_sym_binary_operator_token1] = ACTIONS(211),
    [anon_sym_PIPE_GT] = ACTIONS(211),
    [anon_sym_COLON] = ACTIONS(209),
    [anon_sym_DOLLAR] = ACTIONS(211),
    [anon_sym_AT] = ACTIONS(211),
    [aux_sym__hex_literal_token1] = ACTIONS(2967),
    [sym__number_literal] = ACTIONS(2969),
    [anon_sym_SQUOTE] = ACTIONS(2971),
    [anon_sym_DQUOTE] = ACTIONS(2973),
    [sym_return] = ACTIONS(2975),
    [sym_next] = ACTIONS(2975),
    [sym_break] = ACTIONS(2975),
    [sym_true] = ACTIONS(2975),
    [sym_false] = ACTIONS(2975),
    [sym_null] = ACTIONS(2975),
    [sym_inf] = ACTIONS(2975),
    [sym_nan] = ACTIONS(2975),
    [anon_sym_NA] = ACTIONS(2977),
    [anon_sym_NA_integer_] = ACTIONS(2977),
    [anon_sym_NA_real_] = ACTIONS(2977),
    [anon_sym_NA_complex_] = ACTIONS(2977),
    [anon_sym_NA_character_] = ACTIONS(2977),
    [sym_dots] = ACTIONS(2975),
    [sym_dot_dot_i] = ACTIONS(2979),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(2981),
    [sym__semicolon] = ACTIONS(211),
    [sym__raw_string_literal] = ACTIONS(2983),
    [sym__external_open_parenthesis] = ACTIONS(2985),
    [sym__external_close_parenthesis] = ACTIONS(3463),
    [sym__external_open_brace] = ACTIONS(2989),
    [sym__external_open_bracket] = ACTIONS(211),
    [sym__external_open_bracket2] = ACTIONS(211),
  },
  [297] = {
    [sym_function_definition] = STATE(1196),
    [sym_if_statement] = STATE(1196),
    [sym_for_statement] = STATE(1196),
    [sym_while_statement] = STATE(1196),
    [sym_repeat_statement] = STATE(1196),
    [sym_braced_expression] = STATE(1196),
    [sym_parenthesized_expression] = STATE(1196),
    [sym_call] = STATE(1196),
    [sym_subset] = STATE(1196),
    [sym_subset2] = STATE(1196),
    [sym_unary_operator] = STATE(1196),
    [sym_binary_operator] = STATE(1196),
    [sym_extract_operator] = STATE(1196),
    [sym_namespace_operator] = STATE(1196),
    [sym_integer] = STATE(1196),
    [sym_complex] = STATE(1196),
    [sym_float] = STATE(1196),
    [sym__hex_literal] = STATE(2266),
    [sym__float_literal] = STATE(2266),
    [sym_string] = STATE(2284),
    [sym__single_quoted_string] = STATE(2265),
    [sym__double_quoted_string] = STATE(2264),
    [sym_na] = STATE(1196),
    [sym__expression] = STATE(1196),
    [sym__string_or_identifier] = STATE(5147),
    [sym__open_parenthesis] = STATE(23),
    [sym__open_brace] = STATE(180),
    [aux_sym_function_definition_repeat1] = STATE(2398),
    [sym_identifier] = ACTIONS(1289),
    [anon_sym_BSLASH] = ACTIONS(1291),
    [anon_sym_function] = ACTIONS(1293),
    [anon_sym_EQ] = ACTIONS(759),
    [anon_sym_if] = ACTIONS(1295),
    [anon_sym_for] = ACTIONS(1297),
    [anon_sym_while] = ACTIONS(1299),
    [anon_sym_repeat] = ACTIONS(1301),
    [anon_sym_QMARK] = ACTIONS(1303),
    [anon_sym_TILDE] = ACTIONS(1305),
    [anon_sym_BANG] = ACTIONS(1307),
    [anon_sym_PLUS] = ACTIONS(1309),
    [anon_sym_DASH] = ACTIONS(1311),
    [anon_sym_LT_DASH] = ACTIONS(757),
    [anon_sym_LT_LT_DASH] = ACTIONS(757),
    [anon_sym_COLON_EQ] = ACTIONS(757),
    [anon_sym_DASH_GT] = ACTIONS(759),
    [anon_sym_DASH_GT_GT] = ACTIONS(757),
    [anon_sym_PIPE] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(759),
    [anon_sym_PIPE_PIPE] = ACTIONS(757),
    [anon_sym_AMP_AMP] = ACTIONS(757),
    [anon_sym_LT] = ACTIONS(759),
    [anon_sym_LT_EQ] = ACTIONS(757),
    [anon_sym_GT] = ACTIONS(759),
    [anon_sym_GT_EQ] = ACTIONS(757),
    [anon_sym_EQ_EQ] = ACTIONS(757),
    [anon_sym_BANG_EQ] = ACTIONS(757),
    [anon_sym_STAR] = ACTIONS(759),
    [anon_sym_SLASH] = ACTIONS(757),
    [anon_sym_STAR_STAR] = ACTIONS(757),
    [anon_sym_CARET] = ACTIONS(757),
    [aux_sym_binary_operator_token1] = ACTIONS(757),
    [anon_sym_PIPE_GT] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(759),
    [anon_sym_DOLLAR] = ACTIONS(757),
    [anon_sym_AT] = ACTIONS(757),
    [aux_sym__hex_literal_token1] = ACTIONS(1313),
    [sym__number_literal] = ACTIONS(1315),
    [anon_sym_SQUOTE] = ACTIONS(1317),
    [anon_sym_DQUOTE] = ACTIONS(1319),
    [sym_return] = ACTIONS(3465),
    [sym_next] = ACTIONS(3465),
    [sym_break] = ACTIONS(3465),
    [sym_true] = ACTIONS(3465),
    [sym_false] = ACTIONS(3465),
    [sym_null] = ACTIONS(3465),
    [sym_inf] = ACTIONS(3465),
    [sym_nan] = ACTIONS(3465),
    [anon_sym_NA] = ACTIONS(1323),
    [anon_sym_NA_integer_] = ACTIONS(1323),
    [anon_sym_NA_real_] = ACTIONS(1323),
    [anon_sym_NA_complex_] = ACTIONS(1323),
    [anon_sym_NA_character_] = ACTIONS(1323),
    [sym_dots] = ACTIONS(3465),
    [sym_dot_dot_i] = ACTIONS(3467),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(757),
    [sym__newline] = ACTIONS(757),
    [sym__semicolon] = ACTIONS(757),
    [sym__raw_string_literal] = ACTIONS(1329),
    [sym__external_open_parenthesis] = ACTIONS(1331),
    [sym__external_open_brace] = ACTIONS(1333),
    [sym__external_close_brace] = ACTIONS(757),
    [sym__external_open_bracket] = ACTIONS(757),
    [sym__external_close_bracket] = ACTIONS(757),
    [sym__external_open_bracket2] = ACTIONS(757),
  },
  [298] = {
    [sym_function_definition] = STATE(1880),
    [sym_if_statement] = STATE(1880),
    [sym_for_statement] = STATE(1880),
    [sym_while_statement] = STATE(1880),
    [sym_repeat_statement] = STATE(1880),
    [sym_braced_expression] = STATE(1880),
    [sym_parenthesized_expression] = STATE(1880),
    [sym_call] = STATE(1880),
    [sym_subset] = STATE(1880),
    [sym_subset2] = STATE(1880),
    [sym_unary_operator] = STATE(1880),
    [sym_binary_operator] = STATE(1880),
    [sym_extract_operator] = STATE(1880),
    [sym_namespace_operator] = STATE(1880),
    [sym_integer] = STATE(1880),
    [sym_complex] = STATE(1880),
    [sym_float] = STATE(1880),
    [sym__hex_literal] = STATE(2540),
    [sym__float_literal] = STATE(2540),
    [sym_string] = STATE(2541),
    [sym__single_quoted_string] = STATE(2462),
    [sym__double_quoted_string] = STATE(2494),
    [sym_na] = STATE(1880),
    [sym__expression] = STATE(1880),
    [sym__string_or_identifier] = STATE(5128),
    [sym__open_parenthesis] = STATE(246),
    [sym__open_brace] = STATE(173),
    [aux_sym_function_definition_repeat1] = STATE(2670),
    [ts_builtin_sym_end] = ACTIONS(453),
    [sym_identifier] = ACTIONS(2943),
    [anon_sym_BSLASH] = ACTIONS(2945),
    [anon_sym_function] = ACTIONS(2947),
    [anon_sym_EQ] = ACTIONS(455),
    [anon_sym_if] = ACTIONS(2949),
    [anon_sym_for] = ACTIONS(2951),
    [anon_sym_while] = ACTIONS(2953),
    [anon_sym_repeat] = ACTIONS(2955),
    [anon_sym_QMARK] = ACTIONS(2957),
    [anon_sym_TILDE] = ACTIONS(2959),
    [anon_sym_BANG] = ACTIONS(2961),
    [anon_sym_PLUS] = ACTIONS(2963),
    [anon_sym_DASH] = ACTIONS(2965),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [anon_sym_LT_LT_DASH] = ACTIONS(453),
    [anon_sym_COLON_EQ] = ACTIONS(453),
    [anon_sym_DASH_GT] = ACTIONS(455),
    [anon_sym_DASH_GT_GT] = ACTIONS(453),
    [anon_sym_PIPE] = ACTIONS(455),
    [anon_sym_AMP] = ACTIONS(455),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(455),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_GT] = ACTIONS(455),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(453),
    [anon_sym_STAR] = ACTIONS(455),
    [anon_sym_SLASH] = ACTIONS(453),
    [anon_sym_STAR_STAR] = ACTIONS(453),
    [anon_sym_CARET] = ACTIONS(453),
    [aux_sym_binary_operator_token1] = ACTIONS(453),
    [anon_sym_PIPE_GT] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(455),
    [anon_sym_DOLLAR] = ACTIONS(453),
    [anon_sym_AT] = ACTIONS(453),
    [aux_sym__hex_literal_token1] = ACTIONS(2967),
    [sym__number_literal] = ACTIONS(2969),
    [anon_sym_SQUOTE] = ACTIONS(2971),
    [anon_sym_DQUOTE] = ACTIONS(2973),
    [sym_return] = ACTIONS(3469),
    [sym_next] = ACTIONS(3469),
    [sym_break] = ACTIONS(3469),
    [sym_true] = ACTIONS(3469),
    [sym_false] = ACTIONS(3469),
    [sym_null] = ACTIONS(3469),
    [sym_inf] = ACTIONS(3469),
    [sym_nan] = ACTIONS(3469),
    [anon_sym_NA] = ACTIONS(2977),
    [anon_sym_NA_integer_] = ACTIONS(2977),
    [anon_sym_NA_real_] = ACTIONS(2977),
    [anon_sym_NA_complex_] = ACTIONS(2977),
    [anon_sym_NA_character_] = ACTIONS(2977),
    [sym_dots] = ACTIONS(3469),
    [sym_dot_dot_i] = ACTIONS(3471),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(453),
    [sym__semicolon] = ACTIONS(453),
    [sym__raw_string_literal] = ACTIONS(2983),
    [sym__external_open_parenthesis] = ACTIONS(2985),
    [sym__external_close_parenthesis] = ACTIONS(453),
    [sym__external_open_brace] = ACTIONS(2989),
    [sym__external_open_bracket] = ACTIONS(453),
    [sym__external_open_bracket2] = ACTIONS(453),
  },
  [299] = {
    [sym_function_definition] = STATE(1455),
    [sym_if_statement] = STATE(1455),
    [sym_for_statement] = STATE(1455),
    [sym_while_statement] = STATE(1455),
    [sym_repeat_statement] = STATE(1455),
    [sym_braced_expression] = STATE(1455),
    [sym_parenthesized_expression] = STATE(1455),
    [sym_call] = STATE(1455),
    [sym_subset] = STATE(1455),
    [sym_subset2] = STATE(1455),
    [sym_unary_operator] = STATE(1455),
    [sym_binary_operator] = STATE(1455),
    [sym_extract_operator] = STATE(1455),
    [sym_namespace_operator] = STATE(1455),
    [sym_integer] = STATE(1455),
    [sym_complex] = STATE(1455),
    [sym_float] = STATE(1455),
    [sym__hex_literal] = STATE(2445),
    [sym__float_literal] = STATE(2445),
    [sym_string] = STATE(2530),
    [sym__single_quoted_string] = STATE(2442),
    [sym__double_quoted_string] = STATE(2437),
    [sym_na] = STATE(1455),
    [sym__expression] = STATE(1455),
    [sym__string_or_identifier] = STATE(5133),
    [sym__open_parenthesis] = STATE(213),
    [sym__open_brace] = STATE(70),
    [aux_sym_function_definition_repeat1] = STATE(2617),
    [sym_identifier] = ACTIONS(2531),
    [anon_sym_BSLASH] = ACTIONS(2533),
    [anon_sym_function] = ACTIONS(2535),
    [anon_sym_EQ] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(2537),
    [anon_sym_for] = ACTIONS(2539),
    [anon_sym_while] = ACTIONS(2541),
    [anon_sym_repeat] = ACTIONS(2543),
    [anon_sym_QMARK] = ACTIONS(2545),
    [anon_sym_TILDE] = ACTIONS(2547),
    [anon_sym_BANG] = ACTIONS(2549),
    [anon_sym_PLUS] = ACTIONS(2551),
    [anon_sym_DASH] = ACTIONS(2553),
    [anon_sym_LT_DASH] = ACTIONS(369),
    [anon_sym_LT_LT_DASH] = ACTIONS(369),
    [anon_sym_COLON_EQ] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(371),
    [anon_sym_DASH_GT_GT] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(371),
    [anon_sym_AMP] = ACTIONS(371),
    [anon_sym_PIPE_PIPE] = ACTIONS(369),
    [anon_sym_AMP_AMP] = ACTIONS(369),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_LT_EQ] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_EQ] = ACTIONS(369),
    [anon_sym_EQ_EQ] = ACTIONS(369),
    [anon_sym_BANG_EQ] = ACTIONS(369),
    [anon_sym_STAR] = ACTIONS(371),
    [anon_sym_SLASH] = ACTIONS(369),
    [anon_sym_STAR_STAR] = ACTIONS(369),
    [anon_sym_CARET] = ACTIONS(369),
    [aux_sym_binary_operator_token1] = ACTIONS(369),
    [anon_sym_PIPE_GT] = ACTIONS(369),
    [anon_sym_COLON] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(369),
    [anon_sym_AT] = ACTIONS(369),
    [aux_sym__hex_literal_token1] = ACTIONS(2555),
    [sym__number_literal] = ACTIONS(2557),
    [anon_sym_SQUOTE] = ACTIONS(2559),
    [anon_sym_DQUOTE] = ACTIONS(2561),
    [sym_return] = ACTIONS(3473),
    [sym_next] = ACTIONS(3473),
    [sym_break] = ACTIONS(3473),
    [sym_true] = ACTIONS(3473),
    [sym_false] = ACTIONS(3473),
    [sym_null] = ACTIONS(3473),
    [sym_inf] = ACTIONS(3473),
    [sym_nan] = ACTIONS(3473),
    [anon_sym_NA] = ACTIONS(2565),
    [anon_sym_NA_integer_] = ACTIONS(2565),
    [anon_sym_NA_real_] = ACTIONS(2565),
    [anon_sym_NA_complex_] = ACTIONS(2565),
    [anon_sym_NA_character_] = ACTIONS(2565),
    [sym_dots] = ACTIONS(3473),
    [sym_dot_dot_i] = ACTIONS(3475),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(369),
    [sym__newline] = ACTIONS(369),
    [sym__raw_string_literal] = ACTIONS(2571),
    [sym__external_open_parenthesis] = ACTIONS(2573),
    [sym__external_close_parenthesis] = ACTIONS(369),
    [sym__external_open_brace] = ACTIONS(2577),
    [sym__external_open_bracket] = ACTIONS(369),
    [sym__external_close_bracket] = ACTIONS(369),
    [sym__external_open_bracket2] = ACTIONS(369),
  },
  [300] = {
    [sym_function_definition] = STATE(1689),
    [sym_if_statement] = STATE(1689),
    [sym_for_statement] = STATE(1689),
    [sym_while_statement] = STATE(1689),
    [sym_repeat_statement] = STATE(1689),
    [sym_braced_expression] = STATE(1689),
    [sym_parenthesized_expression] = STATE(1689),
    [sym_call] = STATE(1689),
    [sym_subset] = STATE(1689),
    [sym_subset2] = STATE(1689),
    [sym_unary_operator] = STATE(1689),
    [sym_binary_operator] = STATE(1689),
    [sym_extract_operator] = STATE(1689),
    [sym_namespace_operator] = STATE(1689),
    [sym_integer] = STATE(1689),
    [sym_complex] = STATE(1689),
    [sym_float] = STATE(1689),
    [sym__hex_literal] = STATE(2371),
    [sym__float_literal] = STATE(2371),
    [sym_string] = STATE(2372),
    [sym__single_quoted_string] = STATE(2370),
    [sym__double_quoted_string] = STATE(2369),
    [sym_na] = STATE(1689),
    [sym__expression] = STATE(1689),
    [sym__string_or_identifier] = STATE(5138),
    [sym__open_parenthesis] = STATE(200),
    [sym__open_brace] = STATE(97),
    [aux_sym_function_definition_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(2425),
    [anon_sym_BSLASH] = ACTIONS(2427),
    [anon_sym_function] = ACTIONS(2429),
    [anon_sym_EQ] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(2431),
    [anon_sym_for] = ACTIONS(2433),
    [anon_sym_while] = ACTIONS(2435),
    [anon_sym_repeat] = ACTIONS(2437),
    [anon_sym_QMARK] = ACTIONS(2439),
    [anon_sym_TILDE] = ACTIONS(2441),
    [anon_sym_BANG] = ACTIONS(2443),
    [anon_sym_PLUS] = ACTIONS(2445),
    [anon_sym_DASH] = ACTIONS(2447),
    [anon_sym_LT_DASH] = ACTIONS(369),
    [anon_sym_LT_LT_DASH] = ACTIONS(369),
    [anon_sym_COLON_EQ] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(371),
    [anon_sym_DASH_GT_GT] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(371),
    [anon_sym_AMP] = ACTIONS(371),
    [anon_sym_PIPE_PIPE] = ACTIONS(369),
    [anon_sym_AMP_AMP] = ACTIONS(369),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_LT_EQ] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_EQ] = ACTIONS(369),
    [anon_sym_EQ_EQ] = ACTIONS(369),
    [anon_sym_BANG_EQ] = ACTIONS(369),
    [anon_sym_STAR] = ACTIONS(371),
    [anon_sym_SLASH] = ACTIONS(369),
    [anon_sym_STAR_STAR] = ACTIONS(369),
    [anon_sym_CARET] = ACTIONS(369),
    [aux_sym_binary_operator_token1] = ACTIONS(369),
    [anon_sym_PIPE_GT] = ACTIONS(369),
    [anon_sym_COLON] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(369),
    [anon_sym_AT] = ACTIONS(369),
    [aux_sym__hex_literal_token1] = ACTIONS(2449),
    [sym__number_literal] = ACTIONS(2451),
    [anon_sym_SQUOTE] = ACTIONS(2453),
    [anon_sym_DQUOTE] = ACTIONS(2455),
    [sym_return] = ACTIONS(3477),
    [sym_next] = ACTIONS(3477),
    [sym_break] = ACTIONS(3477),
    [sym_true] = ACTIONS(3477),
    [sym_false] = ACTIONS(3477),
    [sym_null] = ACTIONS(3477),
    [sym_inf] = ACTIONS(3477),
    [sym_nan] = ACTIONS(3477),
    [anon_sym_NA] = ACTIONS(2459),
    [anon_sym_NA_integer_] = ACTIONS(2459),
    [anon_sym_NA_real_] = ACTIONS(2459),
    [anon_sym_NA_complex_] = ACTIONS(2459),
    [anon_sym_NA_character_] = ACTIONS(2459),
    [sym_dots] = ACTIONS(3477),
    [sym_dot_dot_i] = ACTIONS(3479),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(369),
    [sym__newline] = ACTIONS(369),
    [sym__raw_string_literal] = ACTIONS(2465),
    [sym__external_else] = ACTIONS(369),
    [sym__external_open_parenthesis] = ACTIONS(2467),
    [sym__external_close_parenthesis] = ACTIONS(369),
    [sym__external_open_brace] = ACTIONS(2471),
    [sym__external_open_bracket] = ACTIONS(369),
    [sym__external_open_bracket2] = ACTIONS(369),
  },
  [301] = {
    [sym_function_definition] = STATE(1693),
    [sym_if_statement] = STATE(1693),
    [sym_for_statement] = STATE(1693),
    [sym_while_statement] = STATE(1693),
    [sym_repeat_statement] = STATE(1693),
    [sym_braced_expression] = STATE(1693),
    [sym_parenthesized_expression] = STATE(1693),
    [sym_call] = STATE(1693),
    [sym_subset] = STATE(1693),
    [sym_subset2] = STATE(1693),
    [sym_unary_operator] = STATE(1693),
    [sym_binary_operator] = STATE(1693),
    [sym_extract_operator] = STATE(1693),
    [sym_namespace_operator] = STATE(1693),
    [sym_integer] = STATE(1693),
    [sym_complex] = STATE(1693),
    [sym_float] = STATE(1693),
    [sym__hex_literal] = STATE(2371),
    [sym__float_literal] = STATE(2371),
    [sym_string] = STATE(2372),
    [sym__single_quoted_string] = STATE(2370),
    [sym__double_quoted_string] = STATE(2369),
    [sym_na] = STATE(1693),
    [sym__expression] = STATE(1693),
    [sym__string_or_identifier] = STATE(5138),
    [sym__open_parenthesis] = STATE(200),
    [sym__open_brace] = STATE(97),
    [aux_sym_function_definition_repeat1] = STATE(300),
    [sym_identifier] = ACTIONS(2425),
    [anon_sym_BSLASH] = ACTIONS(2427),
    [anon_sym_function] = ACTIONS(2429),
    [anon_sym_EQ] = ACTIONS(533),
    [anon_sym_if] = ACTIONS(2431),
    [anon_sym_for] = ACTIONS(2433),
    [anon_sym_while] = ACTIONS(2435),
    [anon_sym_repeat] = ACTIONS(2437),
    [anon_sym_QMARK] = ACTIONS(2439),
    [anon_sym_TILDE] = ACTIONS(2441),
    [anon_sym_BANG] = ACTIONS(2443),
    [anon_sym_PLUS] = ACTIONS(2445),
    [anon_sym_DASH] = ACTIONS(2447),
    [anon_sym_LT_DASH] = ACTIONS(531),
    [anon_sym_LT_LT_DASH] = ACTIONS(531),
    [anon_sym_COLON_EQ] = ACTIONS(531),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_DASH_GT_GT] = ACTIONS(531),
    [anon_sym_PIPE] = ACTIONS(533),
    [anon_sym_AMP] = ACTIONS(533),
    [anon_sym_PIPE_PIPE] = ACTIONS(531),
    [anon_sym_AMP_AMP] = ACTIONS(531),
    [anon_sym_LT] = ACTIONS(533),
    [anon_sym_LT_EQ] = ACTIONS(531),
    [anon_sym_GT] = ACTIONS(533),
    [anon_sym_GT_EQ] = ACTIONS(531),
    [anon_sym_EQ_EQ] = ACTIONS(531),
    [anon_sym_BANG_EQ] = ACTIONS(531),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_SLASH] = ACTIONS(531),
    [anon_sym_STAR_STAR] = ACTIONS(531),
    [anon_sym_CARET] = ACTIONS(531),
    [aux_sym_binary_operator_token1] = ACTIONS(531),
    [anon_sym_PIPE_GT] = ACTIONS(531),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_DOLLAR] = ACTIONS(531),
    [anon_sym_AT] = ACTIONS(531),
    [aux_sym__hex_literal_token1] = ACTIONS(2449),
    [sym__number_literal] = ACTIONS(2451),
    [anon_sym_SQUOTE] = ACTIONS(2453),
    [anon_sym_DQUOTE] = ACTIONS(2455),
    [sym_return] = ACTIONS(3481),
    [sym_next] = ACTIONS(3481),
    [sym_break] = ACTIONS(3481),
    [sym_true] = ACTIONS(3481),
    [sym_false] = ACTIONS(3481),
    [sym_null] = ACTIONS(3481),
    [sym_inf] = ACTIONS(3481),
    [sym_nan] = ACTIONS(3481),
    [anon_sym_NA] = ACTIONS(2459),
    [anon_sym_NA_integer_] = ACTIONS(2459),
    [anon_sym_NA_real_] = ACTIONS(2459),
    [anon_sym_NA_complex_] = ACTIONS(2459),
    [anon_sym_NA_character_] = ACTIONS(2459),
    [sym_dots] = ACTIONS(3481),
    [sym_dot_dot_i] = ACTIONS(3483),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(531),
    [sym__newline] = ACTIONS(3485),
    [sym__raw_string_literal] = ACTIONS(2465),
    [sym__external_else] = ACTIONS(531),
    [sym__external_open_parenthesis] = ACTIONS(2467),
    [sym__external_close_parenthesis] = ACTIONS(531),
    [sym__external_open_brace] = ACTIONS(2471),
    [sym__external_open_bracket] = ACTIONS(531),
    [sym__external_open_bracket2] = ACTIONS(531),
  },
  [302] = {
    [sym_function_definition] = STATE(1721),
    [sym_if_statement] = STATE(1721),
    [sym_for_statement] = STATE(1721),
    [sym_while_statement] = STATE(1721),
    [sym_repeat_statement] = STATE(1721),
    [sym_braced_expression] = STATE(1721),
    [sym_parenthesized_expression] = STATE(1721),
    [sym_call] = STATE(1721),
    [sym_subset] = STATE(1721),
    [sym_subset2] = STATE(1721),
    [sym_unary_operator] = STATE(1721),
    [sym_binary_operator] = STATE(1721),
    [sym_extract_operator] = STATE(1721),
    [sym_namespace_operator] = STATE(1721),
    [sym_integer] = STATE(1721),
    [sym_complex] = STATE(1721),
    [sym_float] = STATE(1721),
    [sym__hex_literal] = STATE(2371),
    [sym__float_literal] = STATE(2371),
    [sym_string] = STATE(2372),
    [sym__single_quoted_string] = STATE(2370),
    [sym__double_quoted_string] = STATE(2369),
    [sym_na] = STATE(1721),
    [sym__expression] = STATE(1721),
    [sym__string_or_identifier] = STATE(5138),
    [sym__open_parenthesis] = STATE(200),
    [sym__open_brace] = STATE(97),
    [aux_sym_function_definition_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(2425),
    [anon_sym_BSLASH] = ACTIONS(2427),
    [anon_sym_function] = ACTIONS(2429),
    [anon_sym_EQ] = ACTIONS(759),
    [anon_sym_if] = ACTIONS(2431),
    [anon_sym_for] = ACTIONS(2433),
    [anon_sym_while] = ACTIONS(2435),
    [anon_sym_repeat] = ACTIONS(2437),
    [anon_sym_QMARK] = ACTIONS(2439),
    [anon_sym_TILDE] = ACTIONS(2441),
    [anon_sym_BANG] = ACTIONS(2443),
    [anon_sym_PLUS] = ACTIONS(2445),
    [anon_sym_DASH] = ACTIONS(2447),
    [anon_sym_LT_DASH] = ACTIONS(757),
    [anon_sym_LT_LT_DASH] = ACTIONS(757),
    [anon_sym_COLON_EQ] = ACTIONS(757),
    [anon_sym_DASH_GT] = ACTIONS(759),
    [anon_sym_DASH_GT_GT] = ACTIONS(757),
    [anon_sym_PIPE] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(759),
    [anon_sym_PIPE_PIPE] = ACTIONS(757),
    [anon_sym_AMP_AMP] = ACTIONS(757),
    [anon_sym_LT] = ACTIONS(759),
    [anon_sym_LT_EQ] = ACTIONS(757),
    [anon_sym_GT] = ACTIONS(759),
    [anon_sym_GT_EQ] = ACTIONS(757),
    [anon_sym_EQ_EQ] = ACTIONS(757),
    [anon_sym_BANG_EQ] = ACTIONS(757),
    [anon_sym_STAR] = ACTIONS(759),
    [anon_sym_SLASH] = ACTIONS(757),
    [anon_sym_STAR_STAR] = ACTIONS(757),
    [anon_sym_CARET] = ACTIONS(757),
    [aux_sym_binary_operator_token1] = ACTIONS(757),
    [anon_sym_PIPE_GT] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(759),
    [anon_sym_DOLLAR] = ACTIONS(757),
    [anon_sym_AT] = ACTIONS(757),
    [aux_sym__hex_literal_token1] = ACTIONS(2449),
    [sym__number_literal] = ACTIONS(2451),
    [anon_sym_SQUOTE] = ACTIONS(2453),
    [anon_sym_DQUOTE] = ACTIONS(2455),
    [sym_return] = ACTIONS(3487),
    [sym_next] = ACTIONS(3487),
    [sym_break] = ACTIONS(3487),
    [sym_true] = ACTIONS(3487),
    [sym_false] = ACTIONS(3487),
    [sym_null] = ACTIONS(3487),
    [sym_inf] = ACTIONS(3487),
    [sym_nan] = ACTIONS(3487),
    [anon_sym_NA] = ACTIONS(2459),
    [anon_sym_NA_integer_] = ACTIONS(2459),
    [anon_sym_NA_real_] = ACTIONS(2459),
    [anon_sym_NA_complex_] = ACTIONS(2459),
    [anon_sym_NA_character_] = ACTIONS(2459),
    [sym_dots] = ACTIONS(3487),
    [sym_dot_dot_i] = ACTIONS(3489),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(757),
    [sym__newline] = ACTIONS(757),
    [sym__raw_string_literal] = ACTIONS(2465),
    [sym__external_else] = ACTIONS(757),
    [sym__external_open_parenthesis] = ACTIONS(2467),
    [sym__external_close_parenthesis] = ACTIONS(757),
    [sym__external_open_brace] = ACTIONS(2471),
    [sym__external_open_bracket] = ACTIONS(757),
    [sym__external_open_bracket2] = ACTIONS(757),
  },
  [303] = {
    [sym_function_definition] = STATE(1558),
    [sym_if_statement] = STATE(1558),
    [sym_for_statement] = STATE(1558),
    [sym_while_statement] = STATE(1558),
    [sym_repeat_statement] = STATE(1558),
    [sym_braced_expression] = STATE(1558),
    [sym_parenthesized_expression] = STATE(1558),
    [sym_call] = STATE(1558),
    [sym_subset] = STATE(1558),
    [sym_subset2] = STATE(1558),
    [sym_unary_operator] = STATE(1558),
    [sym_binary_operator] = STATE(1558),
    [sym_extract_operator] = STATE(1558),
    [sym_namespace_operator] = STATE(1558),
    [sym_integer] = STATE(1558),
    [sym_complex] = STATE(1558),
    [sym_float] = STATE(1558),
    [sym__hex_literal] = STATE(2448),
    [sym__float_literal] = STATE(2448),
    [sym_string] = STATE(2441),
    [sym__single_quoted_string] = STATE(2456),
    [sym__double_quoted_string] = STATE(2478),
    [sym_na] = STATE(1558),
    [sym__expression] = STATE(1558),
    [sym__string_or_identifier] = STATE(5130),
    [sym__open_parenthesis] = STATE(147),
    [sym__open_brace] = STATE(63),
    [aux_sym_function_definition_repeat1] = STATE(323),
    [sym_identifier] = ACTIONS(3491),
    [anon_sym_BSLASH] = ACTIONS(3493),
    [anon_sym_function] = ACTIONS(3495),
    [anon_sym_EQ] = ACTIONS(463),
    [anon_sym_if] = ACTIONS(3497),
    [anon_sym_for] = ACTIONS(3499),
    [anon_sym_while] = ACTIONS(3501),
    [anon_sym_repeat] = ACTIONS(3503),
    [anon_sym_QMARK] = ACTIONS(3505),
    [anon_sym_TILDE] = ACTIONS(3507),
    [anon_sym_BANG] = ACTIONS(3509),
    [anon_sym_PLUS] = ACTIONS(3511),
    [anon_sym_DASH] = ACTIONS(3513),
    [anon_sym_LT_DASH] = ACTIONS(461),
    [anon_sym_LT_LT_DASH] = ACTIONS(461),
    [anon_sym_COLON_EQ] = ACTIONS(461),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_DASH_GT_GT] = ACTIONS(461),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_PIPE_PIPE] = ACTIONS(461),
    [anon_sym_AMP_AMP] = ACTIONS(461),
    [anon_sym_LT] = ACTIONS(463),
    [anon_sym_LT_EQ] = ACTIONS(461),
    [anon_sym_GT] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(461),
    [anon_sym_EQ_EQ] = ACTIONS(461),
    [anon_sym_BANG_EQ] = ACTIONS(461),
    [anon_sym_STAR] = ACTIONS(463),
    [anon_sym_SLASH] = ACTIONS(461),
    [anon_sym_STAR_STAR] = ACTIONS(461),
    [anon_sym_CARET] = ACTIONS(461),
    [aux_sym_binary_operator_token1] = ACTIONS(461),
    [anon_sym_PIPE_GT] = ACTIONS(461),
    [anon_sym_COLON] = ACTIONS(463),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_AT] = ACTIONS(461),
    [aux_sym__hex_literal_token1] = ACTIONS(3515),
    [sym__number_literal] = ACTIONS(3517),
    [anon_sym_SQUOTE] = ACTIONS(3519),
    [anon_sym_DQUOTE] = ACTIONS(3521),
    [sym_return] = ACTIONS(3523),
    [sym_next] = ACTIONS(3523),
    [sym_break] = ACTIONS(3523),
    [sym_true] = ACTIONS(3523),
    [sym_false] = ACTIONS(3523),
    [sym_null] = ACTIONS(3523),
    [sym_inf] = ACTIONS(3523),
    [sym_nan] = ACTIONS(3523),
    [anon_sym_NA] = ACTIONS(3525),
    [anon_sym_NA_integer_] = ACTIONS(3525),
    [anon_sym_NA_real_] = ACTIONS(3525),
    [anon_sym_NA_complex_] = ACTIONS(3525),
    [anon_sym_NA_character_] = ACTIONS(3525),
    [sym_dots] = ACTIONS(3523),
    [sym_dot_dot_i] = ACTIONS(3527),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(461),
    [sym__newline] = ACTIONS(3529),
    [sym__raw_string_literal] = ACTIONS(3531),
    [sym__external_else] = ACTIONS(461),
    [sym__external_open_parenthesis] = ACTIONS(3533),
    [sym__external_open_brace] = ACTIONS(3535),
    [sym__external_open_bracket] = ACTIONS(461),
    [sym__external_close_bracket] = ACTIONS(461),
    [sym__external_open_bracket2] = ACTIONS(461),
  },
  [304] = {
    [sym_function_definition] = STATE(1782),
    [sym_if_statement] = STATE(1782),
    [sym_for_statement] = STATE(1782),
    [sym_while_statement] = STATE(1782),
    [sym_repeat_statement] = STATE(1782),
    [sym_braced_expression] = STATE(1782),
    [sym_parenthesized_expression] = STATE(1782),
    [sym_call] = STATE(1782),
    [sym_subset] = STATE(1782),
    [sym_subset2] = STATE(1782),
    [sym_unary_operator] = STATE(1782),
    [sym_binary_operator] = STATE(1782),
    [sym_extract_operator] = STATE(1782),
    [sym_namespace_operator] = STATE(1782),
    [sym_integer] = STATE(1782),
    [sym_complex] = STATE(1782),
    [sym_float] = STATE(1782),
    [sym__hex_literal] = STATE(2371),
    [sym__float_literal] = STATE(2371),
    [sym_string] = STATE(2372),
    [sym__single_quoted_string] = STATE(2370),
    [sym__double_quoted_string] = STATE(2369),
    [sym_na] = STATE(1782),
    [sym__expression] = STATE(1782),
    [sym__string_or_identifier] = STATE(5138),
    [sym__open_parenthesis] = STATE(200),
    [sym__open_brace] = STATE(97),
    [aux_sym_function_definition_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(2425),
    [anon_sym_BSLASH] = ACTIONS(2427),
    [anon_sym_function] = ACTIONS(2429),
    [anon_sym_EQ] = ACTIONS(767),
    [anon_sym_if] = ACTIONS(2431),
    [anon_sym_for] = ACTIONS(2433),
    [anon_sym_while] = ACTIONS(2435),
    [anon_sym_repeat] = ACTIONS(2437),
    [anon_sym_QMARK] = ACTIONS(2439),
    [anon_sym_TILDE] = ACTIONS(2441),
    [anon_sym_BANG] = ACTIONS(2443),
    [anon_sym_PLUS] = ACTIONS(2445),
    [anon_sym_DASH] = ACTIONS(2447),
    [anon_sym_LT_DASH] = ACTIONS(765),
    [anon_sym_LT_LT_DASH] = ACTIONS(765),
    [anon_sym_COLON_EQ] = ACTIONS(765),
    [anon_sym_DASH_GT] = ACTIONS(767),
    [anon_sym_DASH_GT_GT] = ACTIONS(765),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_AMP] = ACTIONS(767),
    [anon_sym_PIPE_PIPE] = ACTIONS(765),
    [anon_sym_AMP_AMP] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(767),
    [anon_sym_LT_EQ] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_GT_EQ] = ACTIONS(765),
    [anon_sym_EQ_EQ] = ACTIONS(765),
    [anon_sym_BANG_EQ] = ACTIONS(765),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(765),
    [anon_sym_STAR_STAR] = ACTIONS(765),
    [anon_sym_CARET] = ACTIONS(765),
    [aux_sym_binary_operator_token1] = ACTIONS(765),
    [anon_sym_PIPE_GT] = ACTIONS(765),
    [anon_sym_COLON] = ACTIONS(767),
    [anon_sym_DOLLAR] = ACTIONS(765),
    [anon_sym_AT] = ACTIONS(765),
    [aux_sym__hex_literal_token1] = ACTIONS(2449),
    [sym__number_literal] = ACTIONS(2451),
    [anon_sym_SQUOTE] = ACTIONS(2453),
    [anon_sym_DQUOTE] = ACTIONS(2455),
    [sym_return] = ACTIONS(3537),
    [sym_next] = ACTIONS(3537),
    [sym_break] = ACTIONS(3537),
    [sym_true] = ACTIONS(3537),
    [sym_false] = ACTIONS(3537),
    [sym_null] = ACTIONS(3537),
    [sym_inf] = ACTIONS(3537),
    [sym_nan] = ACTIONS(3537),
    [anon_sym_NA] = ACTIONS(2459),
    [anon_sym_NA_integer_] = ACTIONS(2459),
    [anon_sym_NA_real_] = ACTIONS(2459),
    [anon_sym_NA_complex_] = ACTIONS(2459),
    [anon_sym_NA_character_] = ACTIONS(2459),
    [sym_dots] = ACTIONS(3537),
    [sym_dot_dot_i] = ACTIONS(3539),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(765),
    [sym__newline] = ACTIONS(765),
    [sym__raw_string_literal] = ACTIONS(2465),
    [sym__external_else] = ACTIONS(765),
    [sym__external_open_parenthesis] = ACTIONS(2467),
    [sym__external_close_parenthesis] = ACTIONS(765),
    [sym__external_open_brace] = ACTIONS(2471),
    [sym__external_open_bracket] = ACTIONS(765),
    [sym__external_open_bracket2] = ACTIONS(765),
  },
  [305] = {
    [sym_function_definition] = STATE(1783),
    [sym_if_statement] = STATE(1783),
    [sym_for_statement] = STATE(1783),
    [sym_while_statement] = STATE(1783),
    [sym_repeat_statement] = STATE(1783),
    [sym_braced_expression] = STATE(1783),
    [sym_parenthesized_expression] = STATE(1783),
    [sym_call] = STATE(1783),
    [sym_subset] = STATE(1783),
    [sym_subset2] = STATE(1783),
    [sym_unary_operator] = STATE(1783),
    [sym_binary_operator] = STATE(1783),
    [sym_extract_operator] = STATE(1783),
    [sym_namespace_operator] = STATE(1783),
    [sym_integer] = STATE(1783),
    [sym_complex] = STATE(1783),
    [sym_float] = STATE(1783),
    [sym__hex_literal] = STATE(2371),
    [sym__float_literal] = STATE(2371),
    [sym_string] = STATE(2372),
    [sym__single_quoted_string] = STATE(2370),
    [sym__double_quoted_string] = STATE(2369),
    [sym_na] = STATE(1783),
    [sym__expression] = STATE(1783),
    [sym__string_or_identifier] = STATE(5138),
    [sym__open_parenthesis] = STATE(200),
    [sym__open_brace] = STATE(97),
    [aux_sym_function_definition_repeat1] = STATE(302),
    [sym_identifier] = ACTIONS(2425),
    [anon_sym_BSLASH] = ACTIONS(2427),
    [anon_sym_function] = ACTIONS(2429),
    [anon_sym_EQ] = ACTIONS(543),
    [anon_sym_if] = ACTIONS(2431),
    [anon_sym_for] = ACTIONS(2433),
    [anon_sym_while] = ACTIONS(2435),
    [anon_sym_repeat] = ACTIONS(2437),
    [anon_sym_QMARK] = ACTIONS(2439),
    [anon_sym_TILDE] = ACTIONS(2441),
    [anon_sym_BANG] = ACTIONS(2443),
    [anon_sym_PLUS] = ACTIONS(2445),
    [anon_sym_DASH] = ACTIONS(2447),
    [anon_sym_LT_DASH] = ACTIONS(545),
    [anon_sym_LT_LT_DASH] = ACTIONS(545),
    [anon_sym_COLON_EQ] = ACTIONS(545),
    [anon_sym_DASH_GT] = ACTIONS(543),
    [anon_sym_DASH_GT_GT] = ACTIONS(545),
    [anon_sym_PIPE] = ACTIONS(543),
    [anon_sym_AMP] = ACTIONS(543),
    [anon_sym_PIPE_PIPE] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(543),
    [anon_sym_LT_EQ] = ACTIONS(545),
    [anon_sym_GT] = ACTIONS(543),
    [anon_sym_GT_EQ] = ACTIONS(545),
    [anon_sym_EQ_EQ] = ACTIONS(545),
    [anon_sym_BANG_EQ] = ACTIONS(545),
    [anon_sym_STAR] = ACTIONS(543),
    [anon_sym_SLASH] = ACTIONS(545),
    [anon_sym_STAR_STAR] = ACTIONS(545),
    [anon_sym_CARET] = ACTIONS(545),
    [aux_sym_binary_operator_token1] = ACTIONS(545),
    [anon_sym_PIPE_GT] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(543),
    [anon_sym_DOLLAR] = ACTIONS(545),
    [anon_sym_AT] = ACTIONS(545),
    [aux_sym__hex_literal_token1] = ACTIONS(2449),
    [sym__number_literal] = ACTIONS(2451),
    [anon_sym_SQUOTE] = ACTIONS(2453),
    [anon_sym_DQUOTE] = ACTIONS(2455),
    [sym_return] = ACTIONS(3541),
    [sym_next] = ACTIONS(3541),
    [sym_break] = ACTIONS(3541),
    [sym_true] = ACTIONS(3541),
    [sym_false] = ACTIONS(3541),
    [sym_null] = ACTIONS(3541),
    [sym_inf] = ACTIONS(3541),
    [sym_nan] = ACTIONS(3541),
    [anon_sym_NA] = ACTIONS(2459),
    [anon_sym_NA_integer_] = ACTIONS(2459),
    [anon_sym_NA_real_] = ACTIONS(2459),
    [anon_sym_NA_complex_] = ACTIONS(2459),
    [anon_sym_NA_character_] = ACTIONS(2459),
    [sym_dots] = ACTIONS(3541),
    [sym_dot_dot_i] = ACTIONS(3543),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(545),
    [sym__newline] = ACTIONS(3545),
    [sym__raw_string_literal] = ACTIONS(2465),
    [sym__external_else] = ACTIONS(545),
    [sym__external_open_parenthesis] = ACTIONS(2467),
    [sym__external_close_parenthesis] = ACTIONS(545),
    [sym__external_open_brace] = ACTIONS(2471),
    [sym__external_open_bracket] = ACTIONS(545),
    [sym__external_open_bracket2] = ACTIONS(545),
  },
  [306] = {
    [sym_function_definition] = STATE(1795),
    [sym_if_statement] = STATE(1795),
    [sym_for_statement] = STATE(1795),
    [sym_while_statement] = STATE(1795),
    [sym_repeat_statement] = STATE(1795),
    [sym_braced_expression] = STATE(1795),
    [sym_parenthesized_expression] = STATE(1795),
    [sym_call] = STATE(1795),
    [sym_subset] = STATE(1795),
    [sym_subset2] = STATE(1795),
    [sym_unary_operator] = STATE(1795),
    [sym_binary_operator] = STATE(1795),
    [sym_extract_operator] = STATE(1795),
    [sym_namespace_operator] = STATE(1795),
    [sym_integer] = STATE(1795),
    [sym_complex] = STATE(1795),
    [sym_float] = STATE(1795),
    [sym__hex_literal] = STATE(2371),
    [sym__float_literal] = STATE(2371),
    [sym_string] = STATE(2372),
    [sym__single_quoted_string] = STATE(2370),
    [sym__double_quoted_string] = STATE(2369),
    [sym_na] = STATE(1795),
    [sym__expression] = STATE(1795),
    [sym__string_or_identifier] = STATE(5138),
    [sym__open_parenthesis] = STATE(200),
    [sym__open_brace] = STATE(97),
    [aux_sym_function_definition_repeat1] = STATE(304),
    [sym_identifier] = ACTIONS(2425),
    [anon_sym_BSLASH] = ACTIONS(2427),
    [anon_sym_function] = ACTIONS(2429),
    [anon_sym_EQ] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(2431),
    [anon_sym_for] = ACTIONS(2433),
    [anon_sym_while] = ACTIONS(2435),
    [anon_sym_repeat] = ACTIONS(2437),
    [anon_sym_QMARK] = ACTIONS(2439),
    [anon_sym_TILDE] = ACTIONS(2441),
    [anon_sym_BANG] = ACTIONS(2443),
    [anon_sym_PLUS] = ACTIONS(2445),
    [anon_sym_DASH] = ACTIONS(2447),
    [anon_sym_LT_DASH] = ACTIONS(263),
    [anon_sym_LT_LT_DASH] = ACTIONS(263),
    [anon_sym_COLON_EQ] = ACTIONS(263),
    [anon_sym_DASH_GT] = ACTIONS(265),
    [anon_sym_DASH_GT_GT] = ACTIONS(263),
    [anon_sym_PIPE] = ACTIONS(265),
    [anon_sym_AMP] = ACTIONS(265),
    [anon_sym_PIPE_PIPE] = ACTIONS(263),
    [anon_sym_AMP_AMP] = ACTIONS(263),
    [anon_sym_LT] = ACTIONS(265),
    [anon_sym_LT_EQ] = ACTIONS(263),
    [anon_sym_GT] = ACTIONS(265),
    [anon_sym_GT_EQ] = ACTIONS(263),
    [anon_sym_EQ_EQ] = ACTIONS(263),
    [anon_sym_BANG_EQ] = ACTIONS(263),
    [anon_sym_STAR] = ACTIONS(265),
    [anon_sym_SLASH] = ACTIONS(263),
    [anon_sym_STAR_STAR] = ACTIONS(263),
    [anon_sym_CARET] = ACTIONS(263),
    [aux_sym_binary_operator_token1] = ACTIONS(263),
    [anon_sym_PIPE_GT] = ACTIONS(263),
    [anon_sym_COLON] = ACTIONS(265),
    [anon_sym_DOLLAR] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(263),
    [aux_sym__hex_literal_token1] = ACTIONS(2449),
    [sym__number_literal] = ACTIONS(2451),
    [anon_sym_SQUOTE] = ACTIONS(2453),
    [anon_sym_DQUOTE] = ACTIONS(2455),
    [sym_return] = ACTIONS(3547),
    [sym_next] = ACTIONS(3547),
    [sym_break] = ACTIONS(3547),
    [sym_true] = ACTIONS(3547),
    [sym_false] = ACTIONS(3547),
    [sym_null] = ACTIONS(3547),
    [sym_inf] = ACTIONS(3547),
    [sym_nan] = ACTIONS(3547),
    [anon_sym_NA] = ACTIONS(2459),
    [anon_sym_NA_integer_] = ACTIONS(2459),
    [anon_sym_NA_real_] = ACTIONS(2459),
    [anon_sym_NA_complex_] = ACTIONS(2459),
    [anon_sym_NA_character_] = ACTIONS(2459),
    [sym_dots] = ACTIONS(3547),
    [sym_dot_dot_i] = ACTIONS(3549),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(263),
    [sym__newline] = ACTIONS(3551),
    [sym__raw_string_literal] = ACTIONS(2465),
    [sym__external_else] = ACTIONS(263),
    [sym__external_open_parenthesis] = ACTIONS(2467),
    [sym__external_close_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(2471),
    [sym__external_open_bracket] = ACTIONS(263),
    [sym__external_open_bracket2] = ACTIONS(263),
  },
  [307] = {
    [sym_function_definition] = STATE(1618),
    [sym_if_statement] = STATE(1618),
    [sym_for_statement] = STATE(1618),
    [sym_while_statement] = STATE(1618),
    [sym_repeat_statement] = STATE(1618),
    [sym_braced_expression] = STATE(1618),
    [sym_parenthesized_expression] = STATE(1618),
    [sym_call] = STATE(1618),
    [sym_subset] = STATE(1618),
    [sym_subset2] = STATE(1618),
    [sym_unary_operator] = STATE(1618),
    [sym_binary_operator] = STATE(1618),
    [sym_extract_operator] = STATE(1618),
    [sym_namespace_operator] = STATE(1618),
    [sym_integer] = STATE(1618),
    [sym_complex] = STATE(1618),
    [sym_float] = STATE(1618),
    [sym__hex_literal] = STATE(2445),
    [sym__float_literal] = STATE(2445),
    [sym_string] = STATE(2530),
    [sym__single_quoted_string] = STATE(2442),
    [sym__double_quoted_string] = STATE(2437),
    [sym_na] = STATE(1618),
    [sym__expression] = STATE(1618),
    [sym__string_or_identifier] = STATE(5133),
    [sym__open_parenthesis] = STATE(213),
    [sym__open_brace] = STATE(70),
    [aux_sym_parenthesized_expression_repeat1] = STATE(307),
    [sym_identifier] = ACTIONS(3553),
    [anon_sym_BSLASH] = ACTIONS(3556),
    [anon_sym_function] = ACTIONS(3559),
    [anon_sym_EQ] = ACTIONS(814),
    [anon_sym_if] = ACTIONS(3562),
    [anon_sym_for] = ACTIONS(3565),
    [anon_sym_while] = ACTIONS(3568),
    [anon_sym_repeat] = ACTIONS(3571),
    [anon_sym_QMARK] = ACTIONS(3574),
    [anon_sym_TILDE] = ACTIONS(3577),
    [anon_sym_BANG] = ACTIONS(3580),
    [anon_sym_PLUS] = ACTIONS(3583),
    [anon_sym_DASH] = ACTIONS(3586),
    [anon_sym_LT_DASH] = ACTIONS(803),
    [anon_sym_LT_LT_DASH] = ACTIONS(803),
    [anon_sym_COLON_EQ] = ACTIONS(803),
    [anon_sym_DASH_GT] = ACTIONS(814),
    [anon_sym_DASH_GT_GT] = ACTIONS(803),
    [anon_sym_PIPE] = ACTIONS(814),
    [anon_sym_AMP] = ACTIONS(814),
    [anon_sym_PIPE_PIPE] = ACTIONS(803),
    [anon_sym_AMP_AMP] = ACTIONS(803),
    [anon_sym_LT] = ACTIONS(814),
    [anon_sym_LT_EQ] = ACTIONS(803),
    [anon_sym_GT] = ACTIONS(814),
    [anon_sym_GT_EQ] = ACTIONS(803),
    [anon_sym_EQ_EQ] = ACTIONS(803),
    [anon_sym_BANG_EQ] = ACTIONS(803),
    [anon_sym_STAR] = ACTIONS(814),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_STAR_STAR] = ACTIONS(803),
    [anon_sym_CARET] = ACTIONS(803),
    [aux_sym_binary_operator_token1] = ACTIONS(803),
    [anon_sym_PIPE_GT] = ACTIONS(803),
    [anon_sym_COLON] = ACTIONS(814),
    [anon_sym_DOLLAR] = ACTIONS(803),
    [anon_sym_AT] = ACTIONS(803),
    [aux_sym__hex_literal_token1] = ACTIONS(3589),
    [sym__number_literal] = ACTIONS(3592),
    [anon_sym_SQUOTE] = ACTIONS(3595),
    [anon_sym_DQUOTE] = ACTIONS(3598),
    [sym_return] = ACTIONS(3601),
    [sym_next] = ACTIONS(3601),
    [sym_break] = ACTIONS(3601),
    [sym_true] = ACTIONS(3601),
    [sym_false] = ACTIONS(3601),
    [sym_null] = ACTIONS(3601),
    [sym_inf] = ACTIONS(3601),
    [sym_nan] = ACTIONS(3601),
    [anon_sym_NA] = ACTIONS(3604),
    [anon_sym_NA_integer_] = ACTIONS(3604),
    [anon_sym_NA_real_] = ACTIONS(3604),
    [anon_sym_NA_complex_] = ACTIONS(3604),
    [anon_sym_NA_character_] = ACTIONS(3604),
    [sym_dots] = ACTIONS(3601),
    [sym_dot_dot_i] = ACTIONS(3607),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(803),
    [sym__newline] = ACTIONS(3610),
    [sym__raw_string_literal] = ACTIONS(3613),
    [sym__external_open_parenthesis] = ACTIONS(3616),
    [sym__external_close_parenthesis] = ACTIONS(803),
    [sym__external_open_brace] = ACTIONS(3619),
    [sym__external_open_bracket] = ACTIONS(803),
    [sym__external_close_bracket] = ACTIONS(803),
    [sym__external_open_bracket2] = ACTIONS(803),
  },
  [308] = {
    [sym_function_definition] = STATE(1465),
    [sym_if_statement] = STATE(1465),
    [sym_for_statement] = STATE(1465),
    [sym_while_statement] = STATE(1465),
    [sym_repeat_statement] = STATE(1465),
    [sym_braced_expression] = STATE(1465),
    [sym_parenthesized_expression] = STATE(1465),
    [sym_call] = STATE(1465),
    [sym_subset] = STATE(1465),
    [sym_subset2] = STATE(1465),
    [sym_unary_operator] = STATE(1465),
    [sym_binary_operator] = STATE(1465),
    [sym_extract_operator] = STATE(1465),
    [sym_namespace_operator] = STATE(1465),
    [sym_integer] = STATE(1465),
    [sym_complex] = STATE(1465),
    [sym_float] = STATE(1465),
    [sym__hex_literal] = STATE(2445),
    [sym__float_literal] = STATE(2445),
    [sym_string] = STATE(2530),
    [sym__single_quoted_string] = STATE(2442),
    [sym__double_quoted_string] = STATE(2437),
    [sym_na] = STATE(1465),
    [sym__expression] = STATE(1465),
    [sym__string_or_identifier] = STATE(5133),
    [sym__open_parenthesis] = STATE(213),
    [sym__open_brace] = STATE(70),
    [aux_sym_function_definition_repeat1] = STATE(2617),
    [sym_identifier] = ACTIONS(2531),
    [anon_sym_BSLASH] = ACTIONS(2533),
    [anon_sym_function] = ACTIONS(2535),
    [anon_sym_EQ] = ACTIONS(399),
    [anon_sym_if] = ACTIONS(2537),
    [anon_sym_for] = ACTIONS(2539),
    [anon_sym_while] = ACTIONS(2541),
    [anon_sym_repeat] = ACTIONS(2543),
    [anon_sym_QMARK] = ACTIONS(2545),
    [anon_sym_TILDE] = ACTIONS(2547),
    [anon_sym_BANG] = ACTIONS(2549),
    [anon_sym_PLUS] = ACTIONS(2551),
    [anon_sym_DASH] = ACTIONS(2553),
    [anon_sym_LT_DASH] = ACTIONS(397),
    [anon_sym_LT_LT_DASH] = ACTIONS(397),
    [anon_sym_COLON_EQ] = ACTIONS(397),
    [anon_sym_DASH_GT] = ACTIONS(399),
    [anon_sym_DASH_GT_GT] = ACTIONS(397),
    [anon_sym_PIPE] = ACTIONS(399),
    [anon_sym_AMP] = ACTIONS(399),
    [anon_sym_PIPE_PIPE] = ACTIONS(397),
    [anon_sym_AMP_AMP] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(399),
    [anon_sym_LT_EQ] = ACTIONS(397),
    [anon_sym_GT] = ACTIONS(399),
    [anon_sym_GT_EQ] = ACTIONS(397),
    [anon_sym_EQ_EQ] = ACTIONS(397),
    [anon_sym_BANG_EQ] = ACTIONS(397),
    [anon_sym_STAR] = ACTIONS(399),
    [anon_sym_SLASH] = ACTIONS(397),
    [anon_sym_STAR_STAR] = ACTIONS(397),
    [anon_sym_CARET] = ACTIONS(397),
    [aux_sym_binary_operator_token1] = ACTIONS(397),
    [anon_sym_PIPE_GT] = ACTIONS(397),
    [anon_sym_COLON] = ACTIONS(399),
    [anon_sym_DOLLAR] = ACTIONS(397),
    [anon_sym_AT] = ACTIONS(397),
    [aux_sym__hex_literal_token1] = ACTIONS(2555),
    [sym__number_literal] = ACTIONS(2557),
    [anon_sym_SQUOTE] = ACTIONS(2559),
    [anon_sym_DQUOTE] = ACTIONS(2561),
    [sym_return] = ACTIONS(3622),
    [sym_next] = ACTIONS(3622),
    [sym_break] = ACTIONS(3622),
    [sym_true] = ACTIONS(3622),
    [sym_false] = ACTIONS(3622),
    [sym_null] = ACTIONS(3622),
    [sym_inf] = ACTIONS(3622),
    [sym_nan] = ACTIONS(3622),
    [anon_sym_NA] = ACTIONS(2565),
    [anon_sym_NA_integer_] = ACTIONS(2565),
    [anon_sym_NA_real_] = ACTIONS(2565),
    [anon_sym_NA_complex_] = ACTIONS(2565),
    [anon_sym_NA_character_] = ACTIONS(2565),
    [sym_dots] = ACTIONS(3622),
    [sym_dot_dot_i] = ACTIONS(3624),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(397),
    [sym__newline] = ACTIONS(397),
    [sym__raw_string_literal] = ACTIONS(2571),
    [sym__external_open_parenthesis] = ACTIONS(2573),
    [sym__external_close_parenthesis] = ACTIONS(397),
    [sym__external_open_brace] = ACTIONS(2577),
    [sym__external_open_bracket] = ACTIONS(397),
    [sym__external_close_bracket] = ACTIONS(397),
    [sym__external_open_bracket2] = ACTIONS(397),
  },
  [309] = {
    [sym_function_definition] = STATE(1560),
    [sym_if_statement] = STATE(1560),
    [sym_for_statement] = STATE(1560),
    [sym_while_statement] = STATE(1560),
    [sym_repeat_statement] = STATE(1560),
    [sym_braced_expression] = STATE(1560),
    [sym_parenthesized_expression] = STATE(1560),
    [sym_call] = STATE(1560),
    [sym_subset] = STATE(1560),
    [sym_subset2] = STATE(1560),
    [sym_unary_operator] = STATE(1560),
    [sym_binary_operator] = STATE(1560),
    [sym_extract_operator] = STATE(1560),
    [sym_namespace_operator] = STATE(1560),
    [sym_integer] = STATE(1560),
    [sym_complex] = STATE(1560),
    [sym_float] = STATE(1560),
    [sym__hex_literal] = STATE(2448),
    [sym__float_literal] = STATE(2448),
    [sym_string] = STATE(2441),
    [sym__single_quoted_string] = STATE(2456),
    [sym__double_quoted_string] = STATE(2478),
    [sym_na] = STATE(1560),
    [sym__expression] = STATE(1560),
    [sym__string_or_identifier] = STATE(5130),
    [sym__open_parenthesis] = STATE(147),
    [sym__open_brace] = STATE(63),
    [aux_sym_function_definition_repeat1] = STATE(2639),
    [sym_identifier] = ACTIONS(3491),
    [anon_sym_BSLASH] = ACTIONS(3493),
    [anon_sym_function] = ACTIONS(3495),
    [anon_sym_EQ] = ACTIONS(455),
    [anon_sym_if] = ACTIONS(3497),
    [anon_sym_for] = ACTIONS(3499),
    [anon_sym_while] = ACTIONS(3501),
    [anon_sym_repeat] = ACTIONS(3503),
    [anon_sym_QMARK] = ACTIONS(3505),
    [anon_sym_TILDE] = ACTIONS(3507),
    [anon_sym_BANG] = ACTIONS(3509),
    [anon_sym_PLUS] = ACTIONS(3511),
    [anon_sym_DASH] = ACTIONS(3513),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [anon_sym_LT_LT_DASH] = ACTIONS(453),
    [anon_sym_COLON_EQ] = ACTIONS(453),
    [anon_sym_DASH_GT] = ACTIONS(455),
    [anon_sym_DASH_GT_GT] = ACTIONS(453),
    [anon_sym_PIPE] = ACTIONS(455),
    [anon_sym_AMP] = ACTIONS(455),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(455),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_GT] = ACTIONS(455),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(453),
    [anon_sym_STAR] = ACTIONS(455),
    [anon_sym_SLASH] = ACTIONS(453),
    [anon_sym_STAR_STAR] = ACTIONS(453),
    [anon_sym_CARET] = ACTIONS(453),
    [aux_sym_binary_operator_token1] = ACTIONS(453),
    [anon_sym_PIPE_GT] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(455),
    [anon_sym_DOLLAR] = ACTIONS(453),
    [anon_sym_AT] = ACTIONS(453),
    [aux_sym__hex_literal_token1] = ACTIONS(3515),
    [sym__number_literal] = ACTIONS(3517),
    [anon_sym_SQUOTE] = ACTIONS(3519),
    [anon_sym_DQUOTE] = ACTIONS(3521),
    [sym_return] = ACTIONS(3626),
    [sym_next] = ACTIONS(3626),
    [sym_break] = ACTIONS(3626),
    [sym_true] = ACTIONS(3626),
    [sym_false] = ACTIONS(3626),
    [sym_null] = ACTIONS(3626),
    [sym_inf] = ACTIONS(3626),
    [sym_nan] = ACTIONS(3626),
    [anon_sym_NA] = ACTIONS(3525),
    [anon_sym_NA_integer_] = ACTIONS(3525),
    [anon_sym_NA_real_] = ACTIONS(3525),
    [anon_sym_NA_complex_] = ACTIONS(3525),
    [anon_sym_NA_character_] = ACTIONS(3525),
    [sym_dots] = ACTIONS(3626),
    [sym_dot_dot_i] = ACTIONS(3628),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(453),
    [sym__newline] = ACTIONS(453),
    [sym__raw_string_literal] = ACTIONS(3531),
    [sym__external_else] = ACTIONS(453),
    [sym__external_open_parenthesis] = ACTIONS(3533),
    [sym__external_open_brace] = ACTIONS(3535),
    [sym__external_open_bracket] = ACTIONS(453),
    [sym__external_close_bracket] = ACTIONS(453),
    [sym__external_open_bracket2] = ACTIONS(453),
  },
  [310] = {
    [sym_function_definition] = STATE(1469),
    [sym_if_statement] = STATE(1469),
    [sym_for_statement] = STATE(1469),
    [sym_while_statement] = STATE(1469),
    [sym_repeat_statement] = STATE(1469),
    [sym_braced_expression] = STATE(1469),
    [sym_parenthesized_expression] = STATE(1469),
    [sym_call] = STATE(1469),
    [sym_subset] = STATE(1469),
    [sym_subset2] = STATE(1469),
    [sym_unary_operator] = STATE(1469),
    [sym_binary_operator] = STATE(1469),
    [sym_extract_operator] = STATE(1469),
    [sym_namespace_operator] = STATE(1469),
    [sym_integer] = STATE(1469),
    [sym_complex] = STATE(1469),
    [sym_float] = STATE(1469),
    [sym__hex_literal] = STATE(2445),
    [sym__float_literal] = STATE(2445),
    [sym_string] = STATE(2530),
    [sym__single_quoted_string] = STATE(2442),
    [sym__double_quoted_string] = STATE(2437),
    [sym_na] = STATE(1469),
    [sym__expression] = STATE(1469),
    [sym__string_or_identifier] = STATE(5133),
    [sym__open_parenthesis] = STATE(213),
    [sym__open_brace] = STATE(70),
    [aux_sym_function_definition_repeat1] = STATE(2617),
    [sym_identifier] = ACTIONS(2531),
    [anon_sym_BSLASH] = ACTIONS(2533),
    [anon_sym_function] = ACTIONS(2535),
    [anon_sym_EQ] = ACTIONS(455),
    [anon_sym_if] = ACTIONS(2537),
    [anon_sym_for] = ACTIONS(2539),
    [anon_sym_while] = ACTIONS(2541),
    [anon_sym_repeat] = ACTIONS(2543),
    [anon_sym_QMARK] = ACTIONS(2545),
    [anon_sym_TILDE] = ACTIONS(2547),
    [anon_sym_BANG] = ACTIONS(2549),
    [anon_sym_PLUS] = ACTIONS(2551),
    [anon_sym_DASH] = ACTIONS(2553),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [anon_sym_LT_LT_DASH] = ACTIONS(453),
    [anon_sym_COLON_EQ] = ACTIONS(453),
    [anon_sym_DASH_GT] = ACTIONS(455),
    [anon_sym_DASH_GT_GT] = ACTIONS(453),
    [anon_sym_PIPE] = ACTIONS(455),
    [anon_sym_AMP] = ACTIONS(455),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(455),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_GT] = ACTIONS(455),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(453),
    [anon_sym_STAR] = ACTIONS(455),
    [anon_sym_SLASH] = ACTIONS(453),
    [anon_sym_STAR_STAR] = ACTIONS(453),
    [anon_sym_CARET] = ACTIONS(453),
    [aux_sym_binary_operator_token1] = ACTIONS(453),
    [anon_sym_PIPE_GT] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(455),
    [anon_sym_DOLLAR] = ACTIONS(453),
    [anon_sym_AT] = ACTIONS(453),
    [aux_sym__hex_literal_token1] = ACTIONS(2555),
    [sym__number_literal] = ACTIONS(2557),
    [anon_sym_SQUOTE] = ACTIONS(2559),
    [anon_sym_DQUOTE] = ACTIONS(2561),
    [sym_return] = ACTIONS(3630),
    [sym_next] = ACTIONS(3630),
    [sym_break] = ACTIONS(3630),
    [sym_true] = ACTIONS(3630),
    [sym_false] = ACTIONS(3630),
    [sym_null] = ACTIONS(3630),
    [sym_inf] = ACTIONS(3630),
    [sym_nan] = ACTIONS(3630),
    [anon_sym_NA] = ACTIONS(2565),
    [anon_sym_NA_integer_] = ACTIONS(2565),
    [anon_sym_NA_real_] = ACTIONS(2565),
    [anon_sym_NA_complex_] = ACTIONS(2565),
    [anon_sym_NA_character_] = ACTIONS(2565),
    [sym_dots] = ACTIONS(3630),
    [sym_dot_dot_i] = ACTIONS(3632),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(453),
    [sym__newline] = ACTIONS(453),
    [sym__raw_string_literal] = ACTIONS(2571),
    [sym__external_open_parenthesis] = ACTIONS(2573),
    [sym__external_close_parenthesis] = ACTIONS(453),
    [sym__external_open_brace] = ACTIONS(2577),
    [sym__external_open_bracket] = ACTIONS(453),
    [sym__external_close_bracket] = ACTIONS(453),
    [sym__external_open_bracket2] = ACTIONS(453),
  },
  [311] = {
    [sym_function_definition] = STATE(1470),
    [sym_if_statement] = STATE(1470),
    [sym_for_statement] = STATE(1470),
    [sym_while_statement] = STATE(1470),
    [sym_repeat_statement] = STATE(1470),
    [sym_braced_expression] = STATE(1470),
    [sym_parenthesized_expression] = STATE(1470),
    [sym_call] = STATE(1470),
    [sym_subset] = STATE(1470),
    [sym_subset2] = STATE(1470),
    [sym_unary_operator] = STATE(1470),
    [sym_binary_operator] = STATE(1470),
    [sym_extract_operator] = STATE(1470),
    [sym_namespace_operator] = STATE(1470),
    [sym_integer] = STATE(1470),
    [sym_complex] = STATE(1470),
    [sym_float] = STATE(1470),
    [sym__hex_literal] = STATE(2445),
    [sym__float_literal] = STATE(2445),
    [sym_string] = STATE(2530),
    [sym__single_quoted_string] = STATE(2442),
    [sym__double_quoted_string] = STATE(2437),
    [sym_na] = STATE(1470),
    [sym__expression] = STATE(1470),
    [sym__string_or_identifier] = STATE(5133),
    [sym__open_parenthesis] = STATE(213),
    [sym__open_brace] = STATE(70),
    [aux_sym_function_definition_repeat1] = STATE(313),
    [sym_identifier] = ACTIONS(2531),
    [anon_sym_BSLASH] = ACTIONS(2533),
    [anon_sym_function] = ACTIONS(2535),
    [anon_sym_EQ] = ACTIONS(463),
    [anon_sym_if] = ACTIONS(2537),
    [anon_sym_for] = ACTIONS(2539),
    [anon_sym_while] = ACTIONS(2541),
    [anon_sym_repeat] = ACTIONS(2543),
    [anon_sym_QMARK] = ACTIONS(2545),
    [anon_sym_TILDE] = ACTIONS(2547),
    [anon_sym_BANG] = ACTIONS(2549),
    [anon_sym_PLUS] = ACTIONS(2551),
    [anon_sym_DASH] = ACTIONS(2553),
    [anon_sym_LT_DASH] = ACTIONS(461),
    [anon_sym_LT_LT_DASH] = ACTIONS(461),
    [anon_sym_COLON_EQ] = ACTIONS(461),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_DASH_GT_GT] = ACTIONS(461),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_PIPE_PIPE] = ACTIONS(461),
    [anon_sym_AMP_AMP] = ACTIONS(461),
    [anon_sym_LT] = ACTIONS(463),
    [anon_sym_LT_EQ] = ACTIONS(461),
    [anon_sym_GT] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(461),
    [anon_sym_EQ_EQ] = ACTIONS(461),
    [anon_sym_BANG_EQ] = ACTIONS(461),
    [anon_sym_STAR] = ACTIONS(463),
    [anon_sym_SLASH] = ACTIONS(461),
    [anon_sym_STAR_STAR] = ACTIONS(461),
    [anon_sym_CARET] = ACTIONS(461),
    [aux_sym_binary_operator_token1] = ACTIONS(461),
    [anon_sym_PIPE_GT] = ACTIONS(461),
    [anon_sym_COLON] = ACTIONS(463),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_AT] = ACTIONS(461),
    [aux_sym__hex_literal_token1] = ACTIONS(2555),
    [sym__number_literal] = ACTIONS(2557),
    [anon_sym_SQUOTE] = ACTIONS(2559),
    [anon_sym_DQUOTE] = ACTIONS(2561),
    [sym_return] = ACTIONS(3634),
    [sym_next] = ACTIONS(3634),
    [sym_break] = ACTIONS(3634),
    [sym_true] = ACTIONS(3634),
    [sym_false] = ACTIONS(3634),
    [sym_null] = ACTIONS(3634),
    [sym_inf] = ACTIONS(3634),
    [sym_nan] = ACTIONS(3634),
    [anon_sym_NA] = ACTIONS(2565),
    [anon_sym_NA_integer_] = ACTIONS(2565),
    [anon_sym_NA_real_] = ACTIONS(2565),
    [anon_sym_NA_complex_] = ACTIONS(2565),
    [anon_sym_NA_character_] = ACTIONS(2565),
    [sym_dots] = ACTIONS(3634),
    [sym_dot_dot_i] = ACTIONS(3636),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(461),
    [sym__newline] = ACTIONS(3638),
    [sym__raw_string_literal] = ACTIONS(2571),
    [sym__external_open_parenthesis] = ACTIONS(2573),
    [sym__external_close_parenthesis] = ACTIONS(461),
    [sym__external_open_brace] = ACTIONS(2577),
    [sym__external_open_bracket] = ACTIONS(461),
    [sym__external_close_bracket] = ACTIONS(461),
    [sym__external_open_bracket2] = ACTIONS(461),
  },
  [312] = {
    [sym_function_definition] = STATE(1464),
    [sym_if_statement] = STATE(1464),
    [sym_for_statement] = STATE(1464),
    [sym_while_statement] = STATE(1464),
    [sym_repeat_statement] = STATE(1464),
    [sym_braced_expression] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_call] = STATE(1464),
    [sym_subset] = STATE(1464),
    [sym_subset2] = STATE(1464),
    [sym_unary_operator] = STATE(1464),
    [sym_binary_operator] = STATE(1464),
    [sym_extract_operator] = STATE(1464),
    [sym_namespace_operator] = STATE(1464),
    [sym_integer] = STATE(1464),
    [sym_complex] = STATE(1464),
    [sym_float] = STATE(1464),
    [sym__hex_literal] = STATE(2523),
    [sym__float_literal] = STATE(2523),
    [sym_string] = STATE(2522),
    [sym__single_quoted_string] = STATE(2528),
    [sym__double_quoted_string] = STATE(2529),
    [sym_na] = STATE(1464),
    [sym__expression] = STATE(1464),
    [sym__string_or_identifier] = STATE(5126),
    [sym__open_parenthesis] = STATE(178),
    [sym__open_brace] = STATE(244),
    [aux_sym_function_definition_repeat1] = STATE(2680),
    [ts_builtin_sym_end] = ACTIONS(471),
    [sym_identifier] = ACTIONS(2826),
    [anon_sym_BSLASH] = ACTIONS(2828),
    [anon_sym_function] = ACTIONS(2830),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_if] = ACTIONS(2832),
    [anon_sym_for] = ACTIONS(2834),
    [anon_sym_while] = ACTIONS(2836),
    [anon_sym_repeat] = ACTIONS(2838),
    [anon_sym_QMARK] = ACTIONS(2840),
    [anon_sym_TILDE] = ACTIONS(2842),
    [anon_sym_BANG] = ACTIONS(2844),
    [anon_sym_PLUS] = ACTIONS(2846),
    [anon_sym_DASH] = ACTIONS(2848),
    [anon_sym_LT_DASH] = ACTIONS(471),
    [anon_sym_LT_LT_DASH] = ACTIONS(471),
    [anon_sym_COLON_EQ] = ACTIONS(471),
    [anon_sym_DASH_GT] = ACTIONS(473),
    [anon_sym_DASH_GT_GT] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(473),
    [anon_sym_AMP] = ACTIONS(473),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_LT_EQ] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(473),
    [anon_sym_GT_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_STAR] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [aux_sym_binary_operator_token1] = ACTIONS(471),
    [anon_sym_PIPE_GT] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(473),
    [anon_sym_DOLLAR] = ACTIONS(471),
    [anon_sym_AT] = ACTIONS(471),
    [aux_sym__hex_literal_token1] = ACTIONS(2850),
    [sym__number_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE] = ACTIONS(2856),
    [sym_return] = ACTIONS(3640),
    [sym_next] = ACTIONS(3640),
    [sym_break] = ACTIONS(3640),
    [sym_true] = ACTIONS(3640),
    [sym_false] = ACTIONS(3640),
    [sym_null] = ACTIONS(3640),
    [sym_inf] = ACTIONS(3640),
    [sym_nan] = ACTIONS(3640),
    [anon_sym_NA] = ACTIONS(2860),
    [anon_sym_NA_integer_] = ACTIONS(2860),
    [anon_sym_NA_real_] = ACTIONS(2860),
    [anon_sym_NA_complex_] = ACTIONS(2860),
    [anon_sym_NA_character_] = ACTIONS(2860),
    [sym_dots] = ACTIONS(3640),
    [sym_dot_dot_i] = ACTIONS(3642),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(471),
    [sym__semicolon] = ACTIONS(471),
    [sym__raw_string_literal] = ACTIONS(2866),
    [sym__external_open_parenthesis] = ACTIONS(2868),
    [sym__external_open_brace] = ACTIONS(2870),
    [sym__external_close_brace] = ACTIONS(471),
    [sym__external_open_bracket] = ACTIONS(471),
    [sym__external_open_bracket2] = ACTIONS(471),
  },
  [313] = {
    [sym_function_definition] = STATE(1473),
    [sym_if_statement] = STATE(1473),
    [sym_for_statement] = STATE(1473),
    [sym_while_statement] = STATE(1473),
    [sym_repeat_statement] = STATE(1473),
    [sym_braced_expression] = STATE(1473),
    [sym_parenthesized_expression] = STATE(1473),
    [sym_call] = STATE(1473),
    [sym_subset] = STATE(1473),
    [sym_subset2] = STATE(1473),
    [sym_unary_operator] = STATE(1473),
    [sym_binary_operator] = STATE(1473),
    [sym_extract_operator] = STATE(1473),
    [sym_namespace_operator] = STATE(1473),
    [sym_integer] = STATE(1473),
    [sym_complex] = STATE(1473),
    [sym_float] = STATE(1473),
    [sym__hex_literal] = STATE(2445),
    [sym__float_literal] = STATE(2445),
    [sym_string] = STATE(2530),
    [sym__single_quoted_string] = STATE(2442),
    [sym__double_quoted_string] = STATE(2437),
    [sym_na] = STATE(1473),
    [sym__expression] = STATE(1473),
    [sym__string_or_identifier] = STATE(5133),
    [sym__open_parenthesis] = STATE(213),
    [sym__open_brace] = STATE(70),
    [aux_sym_function_definition_repeat1] = STATE(2617),
    [sym_identifier] = ACTIONS(2531),
    [anon_sym_BSLASH] = ACTIONS(2533),
    [anon_sym_function] = ACTIONS(2535),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_if] = ACTIONS(2537),
    [anon_sym_for] = ACTIONS(2539),
    [anon_sym_while] = ACTIONS(2541),
    [anon_sym_repeat] = ACTIONS(2543),
    [anon_sym_QMARK] = ACTIONS(2545),
    [anon_sym_TILDE] = ACTIONS(2547),
    [anon_sym_BANG] = ACTIONS(2549),
    [anon_sym_PLUS] = ACTIONS(2551),
    [anon_sym_DASH] = ACTIONS(2553),
    [anon_sym_LT_DASH] = ACTIONS(471),
    [anon_sym_LT_LT_DASH] = ACTIONS(471),
    [anon_sym_COLON_EQ] = ACTIONS(471),
    [anon_sym_DASH_GT] = ACTIONS(473),
    [anon_sym_DASH_GT_GT] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(473),
    [anon_sym_AMP] = ACTIONS(473),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_LT_EQ] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(473),
    [anon_sym_GT_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_STAR] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [aux_sym_binary_operator_token1] = ACTIONS(471),
    [anon_sym_PIPE_GT] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(473),
    [anon_sym_DOLLAR] = ACTIONS(471),
    [anon_sym_AT] = ACTIONS(471),
    [aux_sym__hex_literal_token1] = ACTIONS(2555),
    [sym__number_literal] = ACTIONS(2557),
    [anon_sym_SQUOTE] = ACTIONS(2559),
    [anon_sym_DQUOTE] = ACTIONS(2561),
    [sym_return] = ACTIONS(3644),
    [sym_next] = ACTIONS(3644),
    [sym_break] = ACTIONS(3644),
    [sym_true] = ACTIONS(3644),
    [sym_false] = ACTIONS(3644),
    [sym_null] = ACTIONS(3644),
    [sym_inf] = ACTIONS(3644),
    [sym_nan] = ACTIONS(3644),
    [anon_sym_NA] = ACTIONS(2565),
    [anon_sym_NA_integer_] = ACTIONS(2565),
    [anon_sym_NA_real_] = ACTIONS(2565),
    [anon_sym_NA_complex_] = ACTIONS(2565),
    [anon_sym_NA_character_] = ACTIONS(2565),
    [sym_dots] = ACTIONS(3644),
    [sym_dot_dot_i] = ACTIONS(3646),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(471),
    [sym__newline] = ACTIONS(471),
    [sym__raw_string_literal] = ACTIONS(2571),
    [sym__external_open_parenthesis] = ACTIONS(2573),
    [sym__external_close_parenthesis] = ACTIONS(471),
    [sym__external_open_brace] = ACTIONS(2577),
    [sym__external_open_bracket] = ACTIONS(471),
    [sym__external_close_bracket] = ACTIONS(471),
    [sym__external_open_bracket2] = ACTIONS(471),
  },
  [314] = {
    [sym_function_definition] = STATE(1565),
    [sym_if_statement] = STATE(1565),
    [sym_for_statement] = STATE(1565),
    [sym_while_statement] = STATE(1565),
    [sym_repeat_statement] = STATE(1565),
    [sym_braced_expression] = STATE(1565),
    [sym_parenthesized_expression] = STATE(1565),
    [sym_call] = STATE(1565),
    [sym_subset] = STATE(1565),
    [sym_subset2] = STATE(1565),
    [sym_unary_operator] = STATE(1565),
    [sym_binary_operator] = STATE(1565),
    [sym_extract_operator] = STATE(1565),
    [sym_namespace_operator] = STATE(1565),
    [sym_integer] = STATE(1565),
    [sym_complex] = STATE(1565),
    [sym_float] = STATE(1565),
    [sym__hex_literal] = STATE(2448),
    [sym__float_literal] = STATE(2448),
    [sym_string] = STATE(2441),
    [sym__single_quoted_string] = STATE(2456),
    [sym__double_quoted_string] = STATE(2478),
    [sym_na] = STATE(1565),
    [sym__expression] = STATE(1565),
    [sym__string_or_identifier] = STATE(5130),
    [sym__open_parenthesis] = STATE(147),
    [sym__open_brace] = STATE(63),
    [aux_sym_function_definition_repeat1] = STATE(2639),
    [sym_identifier] = ACTIONS(3491),
    [anon_sym_BSLASH] = ACTIONS(3493),
    [anon_sym_function] = ACTIONS(3495),
    [anon_sym_EQ] = ACTIONS(399),
    [anon_sym_if] = ACTIONS(3497),
    [anon_sym_for] = ACTIONS(3499),
    [anon_sym_while] = ACTIONS(3501),
    [anon_sym_repeat] = ACTIONS(3503),
    [anon_sym_QMARK] = ACTIONS(3505),
    [anon_sym_TILDE] = ACTIONS(3507),
    [anon_sym_BANG] = ACTIONS(3509),
    [anon_sym_PLUS] = ACTIONS(3511),
    [anon_sym_DASH] = ACTIONS(3513),
    [anon_sym_LT_DASH] = ACTIONS(397),
    [anon_sym_LT_LT_DASH] = ACTIONS(397),
    [anon_sym_COLON_EQ] = ACTIONS(397),
    [anon_sym_DASH_GT] = ACTIONS(399),
    [anon_sym_DASH_GT_GT] = ACTIONS(397),
    [anon_sym_PIPE] = ACTIONS(399),
    [anon_sym_AMP] = ACTIONS(399),
    [anon_sym_PIPE_PIPE] = ACTIONS(397),
    [anon_sym_AMP_AMP] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(399),
    [anon_sym_LT_EQ] = ACTIONS(397),
    [anon_sym_GT] = ACTIONS(399),
    [anon_sym_GT_EQ] = ACTIONS(397),
    [anon_sym_EQ_EQ] = ACTIONS(397),
    [anon_sym_BANG_EQ] = ACTIONS(397),
    [anon_sym_STAR] = ACTIONS(399),
    [anon_sym_SLASH] = ACTIONS(397),
    [anon_sym_STAR_STAR] = ACTIONS(397),
    [anon_sym_CARET] = ACTIONS(397),
    [aux_sym_binary_operator_token1] = ACTIONS(397),
    [anon_sym_PIPE_GT] = ACTIONS(397),
    [anon_sym_COLON] = ACTIONS(399),
    [anon_sym_DOLLAR] = ACTIONS(397),
    [anon_sym_AT] = ACTIONS(397),
    [aux_sym__hex_literal_token1] = ACTIONS(3515),
    [sym__number_literal] = ACTIONS(3517),
    [anon_sym_SQUOTE] = ACTIONS(3519),
    [anon_sym_DQUOTE] = ACTIONS(3521),
    [sym_return] = ACTIONS(3648),
    [sym_next] = ACTIONS(3648),
    [sym_break] = ACTIONS(3648),
    [sym_true] = ACTIONS(3648),
    [sym_false] = ACTIONS(3648),
    [sym_null] = ACTIONS(3648),
    [sym_inf] = ACTIONS(3648),
    [sym_nan] = ACTIONS(3648),
    [anon_sym_NA] = ACTIONS(3525),
    [anon_sym_NA_integer_] = ACTIONS(3525),
    [anon_sym_NA_real_] = ACTIONS(3525),
    [anon_sym_NA_complex_] = ACTIONS(3525),
    [anon_sym_NA_character_] = ACTIONS(3525),
    [sym_dots] = ACTIONS(3648),
    [sym_dot_dot_i] = ACTIONS(3650),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(397),
    [sym__newline] = ACTIONS(397),
    [sym__raw_string_literal] = ACTIONS(3531),
    [sym__external_else] = ACTIONS(397),
    [sym__external_open_parenthesis] = ACTIONS(3533),
    [sym__external_open_brace] = ACTIONS(3535),
    [sym__external_open_bracket] = ACTIONS(397),
    [sym__external_close_bracket] = ACTIONS(397),
    [sym__external_open_bracket2] = ACTIONS(397),
  },
  [315] = {
    [sym_function_definition] = STATE(1570),
    [sym_if_statement] = STATE(1570),
    [sym_for_statement] = STATE(1570),
    [sym_while_statement] = STATE(1570),
    [sym_repeat_statement] = STATE(1570),
    [sym_braced_expression] = STATE(1570),
    [sym_parenthesized_expression] = STATE(1570),
    [sym_call] = STATE(1570),
    [sym_subset] = STATE(1570),
    [sym_subset2] = STATE(1570),
    [sym_unary_operator] = STATE(1570),
    [sym_binary_operator] = STATE(1570),
    [sym_extract_operator] = STATE(1570),
    [sym_namespace_operator] = STATE(1570),
    [sym_integer] = STATE(1570),
    [sym_complex] = STATE(1570),
    [sym_float] = STATE(1570),
    [sym__hex_literal] = STATE(2448),
    [sym__float_literal] = STATE(2448),
    [sym_string] = STATE(2441),
    [sym__single_quoted_string] = STATE(2456),
    [sym__double_quoted_string] = STATE(2478),
    [sym_na] = STATE(1570),
    [sym__expression] = STATE(1570),
    [sym__string_or_identifier] = STATE(5130),
    [sym__open_parenthesis] = STATE(147),
    [sym__open_brace] = STATE(63),
    [aux_sym_function_definition_repeat1] = STATE(309),
    [sym_identifier] = ACTIONS(3491),
    [anon_sym_BSLASH] = ACTIONS(3493),
    [anon_sym_function] = ACTIONS(3495),
    [anon_sym_EQ] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(3497),
    [anon_sym_for] = ACTIONS(3499),
    [anon_sym_while] = ACTIONS(3501),
    [anon_sym_repeat] = ACTIONS(3503),
    [anon_sym_QMARK] = ACTIONS(3505),
    [anon_sym_TILDE] = ACTIONS(3507),
    [anon_sym_BANG] = ACTIONS(3509),
    [anon_sym_PLUS] = ACTIONS(3511),
    [anon_sym_DASH] = ACTIONS(3513),
    [anon_sym_LT_DASH] = ACTIONS(387),
    [anon_sym_LT_LT_DASH] = ACTIONS(387),
    [anon_sym_COLON_EQ] = ACTIONS(387),
    [anon_sym_DASH_GT] = ACTIONS(389),
    [anon_sym_DASH_GT_GT] = ACTIONS(387),
    [anon_sym_PIPE] = ACTIONS(389),
    [anon_sym_AMP] = ACTIONS(389),
    [anon_sym_PIPE_PIPE] = ACTIONS(387),
    [anon_sym_AMP_AMP] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(389),
    [anon_sym_LT_EQ] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(389),
    [anon_sym_GT_EQ] = ACTIONS(387),
    [anon_sym_EQ_EQ] = ACTIONS(387),
    [anon_sym_BANG_EQ] = ACTIONS(387),
    [anon_sym_STAR] = ACTIONS(389),
    [anon_sym_SLASH] = ACTIONS(387),
    [anon_sym_STAR_STAR] = ACTIONS(387),
    [anon_sym_CARET] = ACTIONS(387),
    [aux_sym_binary_operator_token1] = ACTIONS(387),
    [anon_sym_PIPE_GT] = ACTIONS(387),
    [anon_sym_COLON] = ACTIONS(389),
    [anon_sym_DOLLAR] = ACTIONS(387),
    [anon_sym_AT] = ACTIONS(387),
    [aux_sym__hex_literal_token1] = ACTIONS(3515),
    [sym__number_literal] = ACTIONS(3517),
    [anon_sym_SQUOTE] = ACTIONS(3519),
    [anon_sym_DQUOTE] = ACTIONS(3521),
    [sym_return] = ACTIONS(3652),
    [sym_next] = ACTIONS(3652),
    [sym_break] = ACTIONS(3652),
    [sym_true] = ACTIONS(3652),
    [sym_false] = ACTIONS(3652),
    [sym_null] = ACTIONS(3652),
    [sym_inf] = ACTIONS(3652),
    [sym_nan] = ACTIONS(3652),
    [anon_sym_NA] = ACTIONS(3525),
    [anon_sym_NA_integer_] = ACTIONS(3525),
    [anon_sym_NA_real_] = ACTIONS(3525),
    [anon_sym_NA_complex_] = ACTIONS(3525),
    [anon_sym_NA_character_] = ACTIONS(3525),
    [sym_dots] = ACTIONS(3652),
    [sym_dot_dot_i] = ACTIONS(3654),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(387),
    [sym__newline] = ACTIONS(3656),
    [sym__raw_string_literal] = ACTIONS(3531),
    [sym__external_else] = ACTIONS(387),
    [sym__external_open_parenthesis] = ACTIONS(3533),
    [sym__external_open_brace] = ACTIONS(3535),
    [sym__external_open_bracket] = ACTIONS(387),
    [sym__external_close_bracket] = ACTIONS(387),
    [sym__external_open_bracket2] = ACTIONS(387),
  },
  [316] = {
    [sym_function_definition] = STATE(1573),
    [sym_if_statement] = STATE(1573),
    [sym_for_statement] = STATE(1573),
    [sym_while_statement] = STATE(1573),
    [sym_repeat_statement] = STATE(1573),
    [sym_braced_expression] = STATE(1573),
    [sym_parenthesized_expression] = STATE(1573),
    [sym_call] = STATE(1573),
    [sym_subset] = STATE(1573),
    [sym_subset2] = STATE(1573),
    [sym_unary_operator] = STATE(1573),
    [sym_binary_operator] = STATE(1573),
    [sym_extract_operator] = STATE(1573),
    [sym_namespace_operator] = STATE(1573),
    [sym_integer] = STATE(1573),
    [sym_complex] = STATE(1573),
    [sym_float] = STATE(1573),
    [sym__hex_literal] = STATE(2448),
    [sym__float_literal] = STATE(2448),
    [sym_string] = STATE(2441),
    [sym__single_quoted_string] = STATE(2456),
    [sym__double_quoted_string] = STATE(2478),
    [sym_na] = STATE(1573),
    [sym__expression] = STATE(1573),
    [sym__string_or_identifier] = STATE(5130),
    [sym__open_parenthesis] = STATE(147),
    [sym__open_brace] = STATE(63),
    [aux_sym_function_definition_repeat1] = STATE(314),
    [sym_identifier] = ACTIONS(3491),
    [anon_sym_BSLASH] = ACTIONS(3493),
    [anon_sym_function] = ACTIONS(3495),
    [anon_sym_EQ] = ACTIONS(379),
    [anon_sym_if] = ACTIONS(3497),
    [anon_sym_for] = ACTIONS(3499),
    [anon_sym_while] = ACTIONS(3501),
    [anon_sym_repeat] = ACTIONS(3503),
    [anon_sym_QMARK] = ACTIONS(3505),
    [anon_sym_TILDE] = ACTIONS(3507),
    [anon_sym_BANG] = ACTIONS(3509),
    [anon_sym_PLUS] = ACTIONS(3511),
    [anon_sym_DASH] = ACTIONS(3513),
    [anon_sym_LT_DASH] = ACTIONS(377),
    [anon_sym_LT_LT_DASH] = ACTIONS(377),
    [anon_sym_COLON_EQ] = ACTIONS(377),
    [anon_sym_DASH_GT] = ACTIONS(379),
    [anon_sym_DASH_GT_GT] = ACTIONS(377),
    [anon_sym_PIPE] = ACTIONS(379),
    [anon_sym_AMP] = ACTIONS(379),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_LT] = ACTIONS(379),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(379),
    [anon_sym_GT_EQ] = ACTIONS(377),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(379),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_STAR_STAR] = ACTIONS(377),
    [anon_sym_CARET] = ACTIONS(377),
    [aux_sym_binary_operator_token1] = ACTIONS(377),
    [anon_sym_PIPE_GT] = ACTIONS(377),
    [anon_sym_COLON] = ACTIONS(379),
    [anon_sym_DOLLAR] = ACTIONS(377),
    [anon_sym_AT] = ACTIONS(377),
    [aux_sym__hex_literal_token1] = ACTIONS(3515),
    [sym__number_literal] = ACTIONS(3517),
    [anon_sym_SQUOTE] = ACTIONS(3519),
    [anon_sym_DQUOTE] = ACTIONS(3521),
    [sym_return] = ACTIONS(3658),
    [sym_next] = ACTIONS(3658),
    [sym_break] = ACTIONS(3658),
    [sym_true] = ACTIONS(3658),
    [sym_false] = ACTIONS(3658),
    [sym_null] = ACTIONS(3658),
    [sym_inf] = ACTIONS(3658),
    [sym_nan] = ACTIONS(3658),
    [anon_sym_NA] = ACTIONS(3525),
    [anon_sym_NA_integer_] = ACTIONS(3525),
    [anon_sym_NA_real_] = ACTIONS(3525),
    [anon_sym_NA_complex_] = ACTIONS(3525),
    [anon_sym_NA_character_] = ACTIONS(3525),
    [sym_dots] = ACTIONS(3658),
    [sym_dot_dot_i] = ACTIONS(3660),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(377),
    [sym__newline] = ACTIONS(3662),
    [sym__raw_string_literal] = ACTIONS(3531),
    [sym__external_else] = ACTIONS(377),
    [sym__external_open_parenthesis] = ACTIONS(3533),
    [sym__external_open_brace] = ACTIONS(3535),
    [sym__external_open_bracket] = ACTIONS(377),
    [sym__external_close_bracket] = ACTIONS(377),
    [sym__external_open_bracket2] = ACTIONS(377),
  },
  [317] = {
    [sym_function_definition] = STATE(1574),
    [sym_if_statement] = STATE(1574),
    [sym_for_statement] = STATE(1574),
    [sym_while_statement] = STATE(1574),
    [sym_repeat_statement] = STATE(1574),
    [sym_braced_expression] = STATE(1574),
    [sym_parenthesized_expression] = STATE(1574),
    [sym_call] = STATE(1574),
    [sym_subset] = STATE(1574),
    [sym_subset2] = STATE(1574),
    [sym_unary_operator] = STATE(1574),
    [sym_binary_operator] = STATE(1574),
    [sym_extract_operator] = STATE(1574),
    [sym_namespace_operator] = STATE(1574),
    [sym_integer] = STATE(1574),
    [sym_complex] = STATE(1574),
    [sym_float] = STATE(1574),
    [sym__hex_literal] = STATE(2448),
    [sym__float_literal] = STATE(2448),
    [sym_string] = STATE(2441),
    [sym__single_quoted_string] = STATE(2456),
    [sym__double_quoted_string] = STATE(2478),
    [sym_na] = STATE(1574),
    [sym__expression] = STATE(1574),
    [sym__string_or_identifier] = STATE(5130),
    [sym__open_parenthesis] = STATE(147),
    [sym__open_brace] = STATE(63),
    [aux_sym_function_definition_repeat1] = STATE(2639),
    [sym_identifier] = ACTIONS(3491),
    [anon_sym_BSLASH] = ACTIONS(3493),
    [anon_sym_function] = ACTIONS(3495),
    [anon_sym_EQ] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(3497),
    [anon_sym_for] = ACTIONS(3499),
    [anon_sym_while] = ACTIONS(3501),
    [anon_sym_repeat] = ACTIONS(3503),
    [anon_sym_QMARK] = ACTIONS(3505),
    [anon_sym_TILDE] = ACTIONS(3507),
    [anon_sym_BANG] = ACTIONS(3509),
    [anon_sym_PLUS] = ACTIONS(3511),
    [anon_sym_DASH] = ACTIONS(3513),
    [anon_sym_LT_DASH] = ACTIONS(369),
    [anon_sym_LT_LT_DASH] = ACTIONS(369),
    [anon_sym_COLON_EQ] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(371),
    [anon_sym_DASH_GT_GT] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(371),
    [anon_sym_AMP] = ACTIONS(371),
    [anon_sym_PIPE_PIPE] = ACTIONS(369),
    [anon_sym_AMP_AMP] = ACTIONS(369),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_LT_EQ] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_EQ] = ACTIONS(369),
    [anon_sym_EQ_EQ] = ACTIONS(369),
    [anon_sym_BANG_EQ] = ACTIONS(369),
    [anon_sym_STAR] = ACTIONS(371),
    [anon_sym_SLASH] = ACTIONS(369),
    [anon_sym_STAR_STAR] = ACTIONS(369),
    [anon_sym_CARET] = ACTIONS(369),
    [aux_sym_binary_operator_token1] = ACTIONS(369),
    [anon_sym_PIPE_GT] = ACTIONS(369),
    [anon_sym_COLON] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(369),
    [anon_sym_AT] = ACTIONS(369),
    [aux_sym__hex_literal_token1] = ACTIONS(3515),
    [sym__number_literal] = ACTIONS(3517),
    [anon_sym_SQUOTE] = ACTIONS(3519),
    [anon_sym_DQUOTE] = ACTIONS(3521),
    [sym_return] = ACTIONS(3664),
    [sym_next] = ACTIONS(3664),
    [sym_break] = ACTIONS(3664),
    [sym_true] = ACTIONS(3664),
    [sym_false] = ACTIONS(3664),
    [sym_null] = ACTIONS(3664),
    [sym_inf] = ACTIONS(3664),
    [sym_nan] = ACTIONS(3664),
    [anon_sym_NA] = ACTIONS(3525),
    [anon_sym_NA_integer_] = ACTIONS(3525),
    [anon_sym_NA_real_] = ACTIONS(3525),
    [anon_sym_NA_complex_] = ACTIONS(3525),
    [anon_sym_NA_character_] = ACTIONS(3525),
    [sym_dots] = ACTIONS(3664),
    [sym_dot_dot_i] = ACTIONS(3666),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(369),
    [sym__newline] = ACTIONS(369),
    [sym__raw_string_literal] = ACTIONS(3531),
    [sym__external_else] = ACTIONS(369),
    [sym__external_open_parenthesis] = ACTIONS(3533),
    [sym__external_open_brace] = ACTIONS(3535),
    [sym__external_open_bracket] = ACTIONS(369),
    [sym__external_close_bracket] = ACTIONS(369),
    [sym__external_open_bracket2] = ACTIONS(369),
  },
  [318] = {
    [sym_function_definition] = STATE(1576),
    [sym_if_statement] = STATE(1576),
    [sym_for_statement] = STATE(1576),
    [sym_while_statement] = STATE(1576),
    [sym_repeat_statement] = STATE(1576),
    [sym_braced_expression] = STATE(1576),
    [sym_parenthesized_expression] = STATE(1576),
    [sym_call] = STATE(1576),
    [sym_subset] = STATE(1576),
    [sym_subset2] = STATE(1576),
    [sym_unary_operator] = STATE(1576),
    [sym_binary_operator] = STATE(1576),
    [sym_extract_operator] = STATE(1576),
    [sym_namespace_operator] = STATE(1576),
    [sym_integer] = STATE(1576),
    [sym_complex] = STATE(1576),
    [sym_float] = STATE(1576),
    [sym__hex_literal] = STATE(2448),
    [sym__float_literal] = STATE(2448),
    [sym_string] = STATE(2441),
    [sym__single_quoted_string] = STATE(2456),
    [sym__double_quoted_string] = STATE(2478),
    [sym_na] = STATE(1576),
    [sym__expression] = STATE(1576),
    [sym__string_or_identifier] = STATE(5130),
    [sym__open_parenthesis] = STATE(147),
    [sym__open_brace] = STATE(63),
    [aux_sym_function_definition_repeat1] = STATE(317),
    [sym_identifier] = ACTIONS(3491),
    [anon_sym_BSLASH] = ACTIONS(3493),
    [anon_sym_function] = ACTIONS(3495),
    [anon_sym_EQ] = ACTIONS(533),
    [anon_sym_if] = ACTIONS(3497),
    [anon_sym_for] = ACTIONS(3499),
    [anon_sym_while] = ACTIONS(3501),
    [anon_sym_repeat] = ACTIONS(3503),
    [anon_sym_QMARK] = ACTIONS(3505),
    [anon_sym_TILDE] = ACTIONS(3507),
    [anon_sym_BANG] = ACTIONS(3509),
    [anon_sym_PLUS] = ACTIONS(3511),
    [anon_sym_DASH] = ACTIONS(3513),
    [anon_sym_LT_DASH] = ACTIONS(531),
    [anon_sym_LT_LT_DASH] = ACTIONS(531),
    [anon_sym_COLON_EQ] = ACTIONS(531),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_DASH_GT_GT] = ACTIONS(531),
    [anon_sym_PIPE] = ACTIONS(533),
    [anon_sym_AMP] = ACTIONS(533),
    [anon_sym_PIPE_PIPE] = ACTIONS(531),
    [anon_sym_AMP_AMP] = ACTIONS(531),
    [anon_sym_LT] = ACTIONS(533),
    [anon_sym_LT_EQ] = ACTIONS(531),
    [anon_sym_GT] = ACTIONS(533),
    [anon_sym_GT_EQ] = ACTIONS(531),
    [anon_sym_EQ_EQ] = ACTIONS(531),
    [anon_sym_BANG_EQ] = ACTIONS(531),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_SLASH] = ACTIONS(531),
    [anon_sym_STAR_STAR] = ACTIONS(531),
    [anon_sym_CARET] = ACTIONS(531),
    [aux_sym_binary_operator_token1] = ACTIONS(531),
    [anon_sym_PIPE_GT] = ACTIONS(531),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_DOLLAR] = ACTIONS(531),
    [anon_sym_AT] = ACTIONS(531),
    [aux_sym__hex_literal_token1] = ACTIONS(3515),
    [sym__number_literal] = ACTIONS(3517),
    [anon_sym_SQUOTE] = ACTIONS(3519),
    [anon_sym_DQUOTE] = ACTIONS(3521),
    [sym_return] = ACTIONS(3668),
    [sym_next] = ACTIONS(3668),
    [sym_break] = ACTIONS(3668),
    [sym_true] = ACTIONS(3668),
    [sym_false] = ACTIONS(3668),
    [sym_null] = ACTIONS(3668),
    [sym_inf] = ACTIONS(3668),
    [sym_nan] = ACTIONS(3668),
    [anon_sym_NA] = ACTIONS(3525),
    [anon_sym_NA_integer_] = ACTIONS(3525),
    [anon_sym_NA_real_] = ACTIONS(3525),
    [anon_sym_NA_complex_] = ACTIONS(3525),
    [anon_sym_NA_character_] = ACTIONS(3525),
    [sym_dots] = ACTIONS(3668),
    [sym_dot_dot_i] = ACTIONS(3670),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(531),
    [sym__newline] = ACTIONS(3672),
    [sym__raw_string_literal] = ACTIONS(3531),
    [sym__external_else] = ACTIONS(531),
    [sym__external_open_parenthesis] = ACTIONS(3533),
    [sym__external_open_brace] = ACTIONS(3535),
    [sym__external_open_bracket] = ACTIONS(531),
    [sym__external_close_bracket] = ACTIONS(531),
    [sym__external_open_bracket2] = ACTIONS(531),
  },
  [319] = {
    [sym_function_definition] = STATE(1619),
    [sym_if_statement] = STATE(1619),
    [sym_for_statement] = STATE(1619),
    [sym_while_statement] = STATE(1619),
    [sym_repeat_statement] = STATE(1619),
    [sym_braced_expression] = STATE(1619),
    [sym_parenthesized_expression] = STATE(1619),
    [sym_call] = STATE(1619),
    [sym_subset] = STATE(1619),
    [sym_subset2] = STATE(1619),
    [sym_unary_operator] = STATE(1619),
    [sym_binary_operator] = STATE(1619),
    [sym_extract_operator] = STATE(1619),
    [sym_namespace_operator] = STATE(1619),
    [sym_integer] = STATE(1619),
    [sym_complex] = STATE(1619),
    [sym_float] = STATE(1619),
    [sym__hex_literal] = STATE(2448),
    [sym__float_literal] = STATE(2448),
    [sym_string] = STATE(2441),
    [sym__single_quoted_string] = STATE(2456),
    [sym__double_quoted_string] = STATE(2478),
    [sym_na] = STATE(1619),
    [sym__expression] = STATE(1619),
    [sym__string_or_identifier] = STATE(5130),
    [sym__open_parenthesis] = STATE(147),
    [sym__open_brace] = STATE(63),
    [aux_sym_function_definition_repeat1] = STATE(2639),
    [sym_identifier] = ACTIONS(3491),
    [anon_sym_BSLASH] = ACTIONS(3493),
    [anon_sym_function] = ACTIONS(3495),
    [anon_sym_EQ] = ACTIONS(759),
    [anon_sym_if] = ACTIONS(3497),
    [anon_sym_for] = ACTIONS(3499),
    [anon_sym_while] = ACTIONS(3501),
    [anon_sym_repeat] = ACTIONS(3503),
    [anon_sym_QMARK] = ACTIONS(3505),
    [anon_sym_TILDE] = ACTIONS(3507),
    [anon_sym_BANG] = ACTIONS(3509),
    [anon_sym_PLUS] = ACTIONS(3511),
    [anon_sym_DASH] = ACTIONS(3513),
    [anon_sym_LT_DASH] = ACTIONS(757),
    [anon_sym_LT_LT_DASH] = ACTIONS(757),
    [anon_sym_COLON_EQ] = ACTIONS(757),
    [anon_sym_DASH_GT] = ACTIONS(759),
    [anon_sym_DASH_GT_GT] = ACTIONS(757),
    [anon_sym_PIPE] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(759),
    [anon_sym_PIPE_PIPE] = ACTIONS(757),
    [anon_sym_AMP_AMP] = ACTIONS(757),
    [anon_sym_LT] = ACTIONS(759),
    [anon_sym_LT_EQ] = ACTIONS(757),
    [anon_sym_GT] = ACTIONS(759),
    [anon_sym_GT_EQ] = ACTIONS(757),
    [anon_sym_EQ_EQ] = ACTIONS(757),
    [anon_sym_BANG_EQ] = ACTIONS(757),
    [anon_sym_STAR] = ACTIONS(759),
    [anon_sym_SLASH] = ACTIONS(757),
    [anon_sym_STAR_STAR] = ACTIONS(757),
    [anon_sym_CARET] = ACTIONS(757),
    [aux_sym_binary_operator_token1] = ACTIONS(757),
    [anon_sym_PIPE_GT] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(759),
    [anon_sym_DOLLAR] = ACTIONS(757),
    [anon_sym_AT] = ACTIONS(757),
    [aux_sym__hex_literal_token1] = ACTIONS(3515),
    [sym__number_literal] = ACTIONS(3517),
    [anon_sym_SQUOTE] = ACTIONS(3519),
    [anon_sym_DQUOTE] = ACTIONS(3521),
    [sym_return] = ACTIONS(3674),
    [sym_next] = ACTIONS(3674),
    [sym_break] = ACTIONS(3674),
    [sym_true] = ACTIONS(3674),
    [sym_false] = ACTIONS(3674),
    [sym_null] = ACTIONS(3674),
    [sym_inf] = ACTIONS(3674),
    [sym_nan] = ACTIONS(3674),
    [anon_sym_NA] = ACTIONS(3525),
    [anon_sym_NA_integer_] = ACTIONS(3525),
    [anon_sym_NA_real_] = ACTIONS(3525),
    [anon_sym_NA_complex_] = ACTIONS(3525),
    [anon_sym_NA_character_] = ACTIONS(3525),
    [sym_dots] = ACTIONS(3674),
    [sym_dot_dot_i] = ACTIONS(3676),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(757),
    [sym__newline] = ACTIONS(757),
    [sym__raw_string_literal] = ACTIONS(3531),
    [sym__external_else] = ACTIONS(757),
    [sym__external_open_parenthesis] = ACTIONS(3533),
    [sym__external_open_brace] = ACTIONS(3535),
    [sym__external_open_bracket] = ACTIONS(757),
    [sym__external_close_bracket] = ACTIONS(757),
    [sym__external_open_bracket2] = ACTIONS(757),
  },
  [320] = {
    [sym_function_definition] = STATE(1548),
    [sym_if_statement] = STATE(1548),
    [sym_for_statement] = STATE(1548),
    [sym_while_statement] = STATE(1548),
    [sym_repeat_statement] = STATE(1548),
    [sym_braced_expression] = STATE(1548),
    [sym_parenthesized_expression] = STATE(1548),
    [sym_call] = STATE(1548),
    [sym_subset] = STATE(1548),
    [sym_subset2] = STATE(1548),
    [sym_unary_operator] = STATE(1548),
    [sym_binary_operator] = STATE(1548),
    [sym_extract_operator] = STATE(1548),
    [sym_namespace_operator] = STATE(1548),
    [sym_integer] = STATE(1548),
    [sym_complex] = STATE(1548),
    [sym_float] = STATE(1548),
    [sym__hex_literal] = STATE(2381),
    [sym__float_literal] = STATE(2381),
    [sym_string] = STATE(2378),
    [sym__single_quoted_string] = STATE(2382),
    [sym__double_quoted_string] = STATE(2383),
    [sym_na] = STATE(1548),
    [sym__expression] = STATE(1548),
    [sym__string_or_identifier] = STATE(5153),
    [sym__open_parenthesis] = STATE(191),
    [sym__open_brace] = STATE(29),
    [aux_sym_function_definition_repeat1] = STATE(335),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_BSLASH] = ACTIONS(3680),
    [anon_sym_function] = ACTIONS(3682),
    [anon_sym_EQ] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(3684),
    [anon_sym_for] = ACTIONS(3686),
    [anon_sym_while] = ACTIONS(3688),
    [anon_sym_repeat] = ACTIONS(3690),
    [anon_sym_QMARK] = ACTIONS(3692),
    [anon_sym_TILDE] = ACTIONS(3694),
    [anon_sym_BANG] = ACTIONS(3696),
    [anon_sym_PLUS] = ACTIONS(3698),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_LT_DASH] = ACTIONS(263),
    [anon_sym_LT_LT_DASH] = ACTIONS(263),
    [anon_sym_COLON_EQ] = ACTIONS(263),
    [anon_sym_DASH_GT] = ACTIONS(265),
    [anon_sym_DASH_GT_GT] = ACTIONS(263),
    [anon_sym_PIPE] = ACTIONS(265),
    [anon_sym_AMP] = ACTIONS(265),
    [anon_sym_PIPE_PIPE] = ACTIONS(263),
    [anon_sym_AMP_AMP] = ACTIONS(263),
    [anon_sym_LT] = ACTIONS(265),
    [anon_sym_LT_EQ] = ACTIONS(263),
    [anon_sym_GT] = ACTIONS(265),
    [anon_sym_GT_EQ] = ACTIONS(263),
    [anon_sym_EQ_EQ] = ACTIONS(263),
    [anon_sym_BANG_EQ] = ACTIONS(263),
    [anon_sym_STAR] = ACTIONS(265),
    [anon_sym_SLASH] = ACTIONS(263),
    [anon_sym_STAR_STAR] = ACTIONS(263),
    [anon_sym_CARET] = ACTIONS(263),
    [aux_sym_binary_operator_token1] = ACTIONS(263),
    [anon_sym_PIPE_GT] = ACTIONS(263),
    [anon_sym_COLON] = ACTIONS(265),
    [anon_sym_DOLLAR] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(263),
    [aux_sym__hex_literal_token1] = ACTIONS(3702),
    [sym__number_literal] = ACTIONS(3704),
    [anon_sym_SQUOTE] = ACTIONS(3706),
    [anon_sym_DQUOTE] = ACTIONS(3708),
    [sym_return] = ACTIONS(3710),
    [sym_next] = ACTIONS(3710),
    [sym_break] = ACTIONS(3710),
    [sym_true] = ACTIONS(3710),
    [sym_false] = ACTIONS(3710),
    [sym_null] = ACTIONS(3710),
    [sym_inf] = ACTIONS(3710),
    [sym_nan] = ACTIONS(3710),
    [anon_sym_NA] = ACTIONS(3712),
    [anon_sym_NA_integer_] = ACTIONS(3712),
    [anon_sym_NA_real_] = ACTIONS(3712),
    [anon_sym_NA_complex_] = ACTIONS(3712),
    [anon_sym_NA_character_] = ACTIONS(3712),
    [sym_dots] = ACTIONS(3710),
    [sym_dot_dot_i] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(263),
    [sym__newline] = ACTIONS(3716),
    [sym__raw_string_literal] = ACTIONS(3718),
    [sym__external_else] = ACTIONS(263),
    [sym__external_open_parenthesis] = ACTIONS(3720),
    [sym__external_open_brace] = ACTIONS(3722),
    [sym__external_open_bracket] = ACTIONS(263),
    [sym__external_open_bracket2] = ACTIONS(263),
    [sym__external_close_bracket2] = ACTIONS(263),
  },
  [321] = {
    [sym_function_definition] = STATE(1651),
    [sym_if_statement] = STATE(1651),
    [sym_for_statement] = STATE(1651),
    [sym_while_statement] = STATE(1651),
    [sym_repeat_statement] = STATE(1651),
    [sym_braced_expression] = STATE(1651),
    [sym_parenthesized_expression] = STATE(1651),
    [sym_call] = STATE(1651),
    [sym_subset] = STATE(1651),
    [sym_subset2] = STATE(1651),
    [sym_unary_operator] = STATE(1651),
    [sym_binary_operator] = STATE(1651),
    [sym_extract_operator] = STATE(1651),
    [sym_namespace_operator] = STATE(1651),
    [sym_integer] = STATE(1651),
    [sym_complex] = STATE(1651),
    [sym_float] = STATE(1651),
    [sym__hex_literal] = STATE(2448),
    [sym__float_literal] = STATE(2448),
    [sym_string] = STATE(2441),
    [sym__single_quoted_string] = STATE(2456),
    [sym__double_quoted_string] = STATE(2478),
    [sym_na] = STATE(1651),
    [sym__expression] = STATE(1651),
    [sym__string_or_identifier] = STATE(5130),
    [sym__open_parenthesis] = STATE(147),
    [sym__open_brace] = STATE(63),
    [aux_sym_function_definition_repeat1] = STATE(2639),
    [sym_identifier] = ACTIONS(3491),
    [anon_sym_BSLASH] = ACTIONS(3493),
    [anon_sym_function] = ACTIONS(3495),
    [anon_sym_EQ] = ACTIONS(767),
    [anon_sym_if] = ACTIONS(3497),
    [anon_sym_for] = ACTIONS(3499),
    [anon_sym_while] = ACTIONS(3501),
    [anon_sym_repeat] = ACTIONS(3503),
    [anon_sym_QMARK] = ACTIONS(3505),
    [anon_sym_TILDE] = ACTIONS(3507),
    [anon_sym_BANG] = ACTIONS(3509),
    [anon_sym_PLUS] = ACTIONS(3511),
    [anon_sym_DASH] = ACTIONS(3513),
    [anon_sym_LT_DASH] = ACTIONS(765),
    [anon_sym_LT_LT_DASH] = ACTIONS(765),
    [anon_sym_COLON_EQ] = ACTIONS(765),
    [anon_sym_DASH_GT] = ACTIONS(767),
    [anon_sym_DASH_GT_GT] = ACTIONS(765),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_AMP] = ACTIONS(767),
    [anon_sym_PIPE_PIPE] = ACTIONS(765),
    [anon_sym_AMP_AMP] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(767),
    [anon_sym_LT_EQ] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_GT_EQ] = ACTIONS(765),
    [anon_sym_EQ_EQ] = ACTIONS(765),
    [anon_sym_BANG_EQ] = ACTIONS(765),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(765),
    [anon_sym_STAR_STAR] = ACTIONS(765),
    [anon_sym_CARET] = ACTIONS(765),
    [aux_sym_binary_operator_token1] = ACTIONS(765),
    [anon_sym_PIPE_GT] = ACTIONS(765),
    [anon_sym_COLON] = ACTIONS(767),
    [anon_sym_DOLLAR] = ACTIONS(765),
    [anon_sym_AT] = ACTIONS(765),
    [aux_sym__hex_literal_token1] = ACTIONS(3515),
    [sym__number_literal] = ACTIONS(3517),
    [anon_sym_SQUOTE] = ACTIONS(3519),
    [anon_sym_DQUOTE] = ACTIONS(3521),
    [sym_return] = ACTIONS(3724),
    [sym_next] = ACTIONS(3724),
    [sym_break] = ACTIONS(3724),
    [sym_true] = ACTIONS(3724),
    [sym_false] = ACTIONS(3724),
    [sym_null] = ACTIONS(3724),
    [sym_inf] = ACTIONS(3724),
    [sym_nan] = ACTIONS(3724),
    [anon_sym_NA] = ACTIONS(3525),
    [anon_sym_NA_integer_] = ACTIONS(3525),
    [anon_sym_NA_real_] = ACTIONS(3525),
    [anon_sym_NA_complex_] = ACTIONS(3525),
    [anon_sym_NA_character_] = ACTIONS(3525),
    [sym_dots] = ACTIONS(3724),
    [sym_dot_dot_i] = ACTIONS(3726),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(765),
    [sym__newline] = ACTIONS(765),
    [sym__raw_string_literal] = ACTIONS(3531),
    [sym__external_else] = ACTIONS(765),
    [sym__external_open_parenthesis] = ACTIONS(3533),
    [sym__external_open_brace] = ACTIONS(3535),
    [sym__external_open_bracket] = ACTIONS(765),
    [sym__external_close_bracket] = ACTIONS(765),
    [sym__external_open_bracket2] = ACTIONS(765),
  },
  [322] = {
    [sym_function_definition] = STATE(1654),
    [sym_if_statement] = STATE(1654),
    [sym_for_statement] = STATE(1654),
    [sym_while_statement] = STATE(1654),
    [sym_repeat_statement] = STATE(1654),
    [sym_braced_expression] = STATE(1654),
    [sym_parenthesized_expression] = STATE(1654),
    [sym_call] = STATE(1654),
    [sym_subset] = STATE(1654),
    [sym_subset2] = STATE(1654),
    [sym_unary_operator] = STATE(1654),
    [sym_binary_operator] = STATE(1654),
    [sym_extract_operator] = STATE(1654),
    [sym_namespace_operator] = STATE(1654),
    [sym_integer] = STATE(1654),
    [sym_complex] = STATE(1654),
    [sym_float] = STATE(1654),
    [sym__hex_literal] = STATE(2448),
    [sym__float_literal] = STATE(2448),
    [sym_string] = STATE(2441),
    [sym__single_quoted_string] = STATE(2456),
    [sym__double_quoted_string] = STATE(2478),
    [sym_na] = STATE(1654),
    [sym__expression] = STATE(1654),
    [sym__string_or_identifier] = STATE(5130),
    [sym__open_parenthesis] = STATE(147),
    [sym__open_brace] = STATE(63),
    [aux_sym_function_definition_repeat1] = STATE(319),
    [sym_identifier] = ACTIONS(3491),
    [anon_sym_BSLASH] = ACTIONS(3493),
    [anon_sym_function] = ACTIONS(3495),
    [anon_sym_EQ] = ACTIONS(543),
    [anon_sym_if] = ACTIONS(3497),
    [anon_sym_for] = ACTIONS(3499),
    [anon_sym_while] = ACTIONS(3501),
    [anon_sym_repeat] = ACTIONS(3503),
    [anon_sym_QMARK] = ACTIONS(3505),
    [anon_sym_TILDE] = ACTIONS(3507),
    [anon_sym_BANG] = ACTIONS(3509),
    [anon_sym_PLUS] = ACTIONS(3511),
    [anon_sym_DASH] = ACTIONS(3513),
    [anon_sym_LT_DASH] = ACTIONS(545),
    [anon_sym_LT_LT_DASH] = ACTIONS(545),
    [anon_sym_COLON_EQ] = ACTIONS(545),
    [anon_sym_DASH_GT] = ACTIONS(543),
    [anon_sym_DASH_GT_GT] = ACTIONS(545),
    [anon_sym_PIPE] = ACTIONS(543),
    [anon_sym_AMP] = ACTIONS(543),
    [anon_sym_PIPE_PIPE] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(543),
    [anon_sym_LT_EQ] = ACTIONS(545),
    [anon_sym_GT] = ACTIONS(543),
    [anon_sym_GT_EQ] = ACTIONS(545),
    [anon_sym_EQ_EQ] = ACTIONS(545),
    [anon_sym_BANG_EQ] = ACTIONS(545),
    [anon_sym_STAR] = ACTIONS(543),
    [anon_sym_SLASH] = ACTIONS(545),
    [anon_sym_STAR_STAR] = ACTIONS(545),
    [anon_sym_CARET] = ACTIONS(545),
    [aux_sym_binary_operator_token1] = ACTIONS(545),
    [anon_sym_PIPE_GT] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(543),
    [anon_sym_DOLLAR] = ACTIONS(545),
    [anon_sym_AT] = ACTIONS(545),
    [aux_sym__hex_literal_token1] = ACTIONS(3515),
    [sym__number_literal] = ACTIONS(3517),
    [anon_sym_SQUOTE] = ACTIONS(3519),
    [anon_sym_DQUOTE] = ACTIONS(3521),
    [sym_return] = ACTIONS(3728),
    [sym_next] = ACTIONS(3728),
    [sym_break] = ACTIONS(3728),
    [sym_true] = ACTIONS(3728),
    [sym_false] = ACTIONS(3728),
    [sym_null] = ACTIONS(3728),
    [sym_inf] = ACTIONS(3728),
    [sym_nan] = ACTIONS(3728),
    [anon_sym_NA] = ACTIONS(3525),
    [anon_sym_NA_integer_] = ACTIONS(3525),
    [anon_sym_NA_real_] = ACTIONS(3525),
    [anon_sym_NA_complex_] = ACTIONS(3525),
    [anon_sym_NA_character_] = ACTIONS(3525),
    [sym_dots] = ACTIONS(3728),
    [sym_dot_dot_i] = ACTIONS(3730),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(545),
    [sym__newline] = ACTIONS(3732),
    [sym__raw_string_literal] = ACTIONS(3531),
    [sym__external_else] = ACTIONS(545),
    [sym__external_open_parenthesis] = ACTIONS(3533),
    [sym__external_open_brace] = ACTIONS(3535),
    [sym__external_open_bracket] = ACTIONS(545),
    [sym__external_close_bracket] = ACTIONS(545),
    [sym__external_open_bracket2] = ACTIONS(545),
  },
  [323] = {
    [sym_function_definition] = STATE(1552),
    [sym_if_statement] = STATE(1552),
    [sym_for_statement] = STATE(1552),
    [sym_while_statement] = STATE(1552),
    [sym_repeat_statement] = STATE(1552),
    [sym_braced_expression] = STATE(1552),
    [sym_parenthesized_expression] = STATE(1552),
    [sym_call] = STATE(1552),
    [sym_subset] = STATE(1552),
    [sym_subset2] = STATE(1552),
    [sym_unary_operator] = STATE(1552),
    [sym_binary_operator] = STATE(1552),
    [sym_extract_operator] = STATE(1552),
    [sym_namespace_operator] = STATE(1552),
    [sym_integer] = STATE(1552),
    [sym_complex] = STATE(1552),
    [sym_float] = STATE(1552),
    [sym__hex_literal] = STATE(2448),
    [sym__float_literal] = STATE(2448),
    [sym_string] = STATE(2441),
    [sym__single_quoted_string] = STATE(2456),
    [sym__double_quoted_string] = STATE(2478),
    [sym_na] = STATE(1552),
    [sym__expression] = STATE(1552),
    [sym__string_or_identifier] = STATE(5130),
    [sym__open_parenthesis] = STATE(147),
    [sym__open_brace] = STATE(63),
    [aux_sym_function_definition_repeat1] = STATE(2639),
    [sym_identifier] = ACTIONS(3491),
    [anon_sym_BSLASH] = ACTIONS(3493),
    [anon_sym_function] = ACTIONS(3495),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_if] = ACTIONS(3497),
    [anon_sym_for] = ACTIONS(3499),
    [anon_sym_while] = ACTIONS(3501),
    [anon_sym_repeat] = ACTIONS(3503),
    [anon_sym_QMARK] = ACTIONS(3505),
    [anon_sym_TILDE] = ACTIONS(3507),
    [anon_sym_BANG] = ACTIONS(3509),
    [anon_sym_PLUS] = ACTIONS(3511),
    [anon_sym_DASH] = ACTIONS(3513),
    [anon_sym_LT_DASH] = ACTIONS(471),
    [anon_sym_LT_LT_DASH] = ACTIONS(471),
    [anon_sym_COLON_EQ] = ACTIONS(471),
    [anon_sym_DASH_GT] = ACTIONS(473),
    [anon_sym_DASH_GT_GT] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(473),
    [anon_sym_AMP] = ACTIONS(473),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_LT_EQ] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(473),
    [anon_sym_GT_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_STAR] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [aux_sym_binary_operator_token1] = ACTIONS(471),
    [anon_sym_PIPE_GT] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(473),
    [anon_sym_DOLLAR] = ACTIONS(471),
    [anon_sym_AT] = ACTIONS(471),
    [aux_sym__hex_literal_token1] = ACTIONS(3515),
    [sym__number_literal] = ACTIONS(3517),
    [anon_sym_SQUOTE] = ACTIONS(3519),
    [anon_sym_DQUOTE] = ACTIONS(3521),
    [sym_return] = ACTIONS(3734),
    [sym_next] = ACTIONS(3734),
    [sym_break] = ACTIONS(3734),
    [sym_true] = ACTIONS(3734),
    [sym_false] = ACTIONS(3734),
    [sym_null] = ACTIONS(3734),
    [sym_inf] = ACTIONS(3734),
    [sym_nan] = ACTIONS(3734),
    [anon_sym_NA] = ACTIONS(3525),
    [anon_sym_NA_integer_] = ACTIONS(3525),
    [anon_sym_NA_real_] = ACTIONS(3525),
    [anon_sym_NA_complex_] = ACTIONS(3525),
    [anon_sym_NA_character_] = ACTIONS(3525),
    [sym_dots] = ACTIONS(3734),
    [sym_dot_dot_i] = ACTIONS(3736),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(471),
    [sym__newline] = ACTIONS(471),
    [sym__raw_string_literal] = ACTIONS(3531),
    [sym__external_else] = ACTIONS(471),
    [sym__external_open_parenthesis] = ACTIONS(3533),
    [sym__external_open_brace] = ACTIONS(3535),
    [sym__external_open_bracket] = ACTIONS(471),
    [sym__external_close_bracket] = ACTIONS(471),
    [sym__external_open_bracket2] = ACTIONS(471),
  },
  [324] = {
    [sym_function_definition] = STATE(1664),
    [sym_if_statement] = STATE(1664),
    [sym_for_statement] = STATE(1664),
    [sym_while_statement] = STATE(1664),
    [sym_repeat_statement] = STATE(1664),
    [sym_braced_expression] = STATE(1664),
    [sym_parenthesized_expression] = STATE(1664),
    [sym_call] = STATE(1664),
    [sym_subset] = STATE(1664),
    [sym_subset2] = STATE(1664),
    [sym_unary_operator] = STATE(1664),
    [sym_binary_operator] = STATE(1664),
    [sym_extract_operator] = STATE(1664),
    [sym_namespace_operator] = STATE(1664),
    [sym_integer] = STATE(1664),
    [sym_complex] = STATE(1664),
    [sym_float] = STATE(1664),
    [sym__hex_literal] = STATE(2371),
    [sym__float_literal] = STATE(2371),
    [sym_string] = STATE(2372),
    [sym__single_quoted_string] = STATE(2370),
    [sym__double_quoted_string] = STATE(2369),
    [sym_na] = STATE(1664),
    [sym__expression] = STATE(1664),
    [sym__string_or_identifier] = STATE(5138),
    [sym__open_parenthesis] = STATE(200),
    [sym__open_brace] = STATE(97),
    [aux_sym_function_definition_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(2425),
    [anon_sym_BSLASH] = ACTIONS(2427),
    [anon_sym_function] = ACTIONS(2429),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_if] = ACTIONS(2431),
    [anon_sym_for] = ACTIONS(2433),
    [anon_sym_while] = ACTIONS(2435),
    [anon_sym_repeat] = ACTIONS(2437),
    [anon_sym_QMARK] = ACTIONS(2439),
    [anon_sym_TILDE] = ACTIONS(2441),
    [anon_sym_BANG] = ACTIONS(2443),
    [anon_sym_PLUS] = ACTIONS(2445),
    [anon_sym_DASH] = ACTIONS(2447),
    [anon_sym_LT_DASH] = ACTIONS(471),
    [anon_sym_LT_LT_DASH] = ACTIONS(471),
    [anon_sym_COLON_EQ] = ACTIONS(471),
    [anon_sym_DASH_GT] = ACTIONS(473),
    [anon_sym_DASH_GT_GT] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(473),
    [anon_sym_AMP] = ACTIONS(473),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_LT_EQ] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(473),
    [anon_sym_GT_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_STAR] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [aux_sym_binary_operator_token1] = ACTIONS(471),
    [anon_sym_PIPE_GT] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(473),
    [anon_sym_DOLLAR] = ACTIONS(471),
    [anon_sym_AT] = ACTIONS(471),
    [aux_sym__hex_literal_token1] = ACTIONS(2449),
    [sym__number_literal] = ACTIONS(2451),
    [anon_sym_SQUOTE] = ACTIONS(2453),
    [anon_sym_DQUOTE] = ACTIONS(2455),
    [sym_return] = ACTIONS(3738),
    [sym_next] = ACTIONS(3738),
    [sym_break] = ACTIONS(3738),
    [sym_true] = ACTIONS(3738),
    [sym_false] = ACTIONS(3738),
    [sym_null] = ACTIONS(3738),
    [sym_inf] = ACTIONS(3738),
    [sym_nan] = ACTIONS(3738),
    [anon_sym_NA] = ACTIONS(2459),
    [anon_sym_NA_integer_] = ACTIONS(2459),
    [anon_sym_NA_real_] = ACTIONS(2459),
    [anon_sym_NA_complex_] = ACTIONS(2459),
    [anon_sym_NA_character_] = ACTIONS(2459),
    [sym_dots] = ACTIONS(3738),
    [sym_dot_dot_i] = ACTIONS(3740),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(471),
    [sym__newline] = ACTIONS(471),
    [sym__raw_string_literal] = ACTIONS(2465),
    [sym__external_else] = ACTIONS(471),
    [sym__external_open_parenthesis] = ACTIONS(2467),
    [sym__external_close_parenthesis] = ACTIONS(471),
    [sym__external_open_brace] = ACTIONS(2471),
    [sym__external_open_bracket] = ACTIONS(471),
    [sym__external_open_bracket2] = ACTIONS(471),
  },
  [325] = {
    [sym_function_definition] = STATE(1475),
    [sym_if_statement] = STATE(1475),
    [sym_for_statement] = STATE(1475),
    [sym_while_statement] = STATE(1475),
    [sym_repeat_statement] = STATE(1475),
    [sym_braced_expression] = STATE(1475),
    [sym_parenthesized_expression] = STATE(1475),
    [sym_call] = STATE(1475),
    [sym_subset] = STATE(1475),
    [sym_subset2] = STATE(1475),
    [sym_unary_operator] = STATE(1475),
    [sym_binary_operator] = STATE(1475),
    [sym_extract_operator] = STATE(1475),
    [sym_namespace_operator] = STATE(1475),
    [sym_integer] = STATE(1475),
    [sym_complex] = STATE(1475),
    [sym_float] = STATE(1475),
    [sym__hex_literal] = STATE(2523),
    [sym__float_literal] = STATE(2523),
    [sym_string] = STATE(2522),
    [sym__single_quoted_string] = STATE(2528),
    [sym__double_quoted_string] = STATE(2529),
    [sym_na] = STATE(1475),
    [sym__expression] = STATE(1475),
    [sym__string_or_identifier] = STATE(5126),
    [sym__open_parenthesis] = STATE(178),
    [sym__open_brace] = STATE(244),
    [aux_sym_function_definition_repeat1] = STATE(312),
    [ts_builtin_sym_end] = ACTIONS(461),
    [sym_identifier] = ACTIONS(2826),
    [anon_sym_BSLASH] = ACTIONS(2828),
    [anon_sym_function] = ACTIONS(2830),
    [anon_sym_EQ] = ACTIONS(463),
    [anon_sym_if] = ACTIONS(2832),
    [anon_sym_for] = ACTIONS(2834),
    [anon_sym_while] = ACTIONS(2836),
    [anon_sym_repeat] = ACTIONS(2838),
    [anon_sym_QMARK] = ACTIONS(2840),
    [anon_sym_TILDE] = ACTIONS(2842),
    [anon_sym_BANG] = ACTIONS(2844),
    [anon_sym_PLUS] = ACTIONS(2846),
    [anon_sym_DASH] = ACTIONS(2848),
    [anon_sym_LT_DASH] = ACTIONS(461),
    [anon_sym_LT_LT_DASH] = ACTIONS(461),
    [anon_sym_COLON_EQ] = ACTIONS(461),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_DASH_GT_GT] = ACTIONS(461),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_PIPE_PIPE] = ACTIONS(461),
    [anon_sym_AMP_AMP] = ACTIONS(461),
    [anon_sym_LT] = ACTIONS(463),
    [anon_sym_LT_EQ] = ACTIONS(461),
    [anon_sym_GT] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(461),
    [anon_sym_EQ_EQ] = ACTIONS(461),
    [anon_sym_BANG_EQ] = ACTIONS(461),
    [anon_sym_STAR] = ACTIONS(463),
    [anon_sym_SLASH] = ACTIONS(461),
    [anon_sym_STAR_STAR] = ACTIONS(461),
    [anon_sym_CARET] = ACTIONS(461),
    [aux_sym_binary_operator_token1] = ACTIONS(461),
    [anon_sym_PIPE_GT] = ACTIONS(461),
    [anon_sym_COLON] = ACTIONS(463),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_AT] = ACTIONS(461),
    [aux_sym__hex_literal_token1] = ACTIONS(2850),
    [sym__number_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE] = ACTIONS(2856),
    [sym_return] = ACTIONS(3742),
    [sym_next] = ACTIONS(3742),
    [sym_break] = ACTIONS(3742),
    [sym_true] = ACTIONS(3742),
    [sym_false] = ACTIONS(3742),
    [sym_null] = ACTIONS(3742),
    [sym_inf] = ACTIONS(3742),
    [sym_nan] = ACTIONS(3742),
    [anon_sym_NA] = ACTIONS(2860),
    [anon_sym_NA_integer_] = ACTIONS(2860),
    [anon_sym_NA_real_] = ACTIONS(2860),
    [anon_sym_NA_complex_] = ACTIONS(2860),
    [anon_sym_NA_character_] = ACTIONS(2860),
    [sym_dots] = ACTIONS(3742),
    [sym_dot_dot_i] = ACTIONS(3744),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(3746),
    [sym__semicolon] = ACTIONS(461),
    [sym__raw_string_literal] = ACTIONS(2866),
    [sym__external_open_parenthesis] = ACTIONS(2868),
    [sym__external_open_brace] = ACTIONS(2870),
    [sym__external_close_brace] = ACTIONS(461),
    [sym__external_open_bracket] = ACTIONS(461),
    [sym__external_open_bracket2] = ACTIONS(461),
  },
  [326] = {
    [sym_function_definition] = STATE(1485),
    [sym_if_statement] = STATE(1485),
    [sym_for_statement] = STATE(1485),
    [sym_while_statement] = STATE(1485),
    [sym_repeat_statement] = STATE(1485),
    [sym_braced_expression] = STATE(1485),
    [sym_parenthesized_expression] = STATE(1485),
    [sym_call] = STATE(1485),
    [sym_subset] = STATE(1485),
    [sym_subset2] = STATE(1485),
    [sym_unary_operator] = STATE(1485),
    [sym_binary_operator] = STATE(1485),
    [sym_extract_operator] = STATE(1485),
    [sym_namespace_operator] = STATE(1485),
    [sym_integer] = STATE(1485),
    [sym_complex] = STATE(1485),
    [sym_float] = STATE(1485),
    [sym__hex_literal] = STATE(2523),
    [sym__float_literal] = STATE(2523),
    [sym_string] = STATE(2522),
    [sym__single_quoted_string] = STATE(2528),
    [sym__double_quoted_string] = STATE(2529),
    [sym_na] = STATE(1485),
    [sym__expression] = STATE(1485),
    [sym__string_or_identifier] = STATE(5126),
    [sym__open_parenthesis] = STATE(178),
    [sym__open_brace] = STATE(244),
    [aux_sym_function_definition_repeat1] = STATE(2680),
    [ts_builtin_sym_end] = ACTIONS(453),
    [sym_identifier] = ACTIONS(2826),
    [anon_sym_BSLASH] = ACTIONS(2828),
    [anon_sym_function] = ACTIONS(2830),
    [anon_sym_EQ] = ACTIONS(455),
    [anon_sym_if] = ACTIONS(2832),
    [anon_sym_for] = ACTIONS(2834),
    [anon_sym_while] = ACTIONS(2836),
    [anon_sym_repeat] = ACTIONS(2838),
    [anon_sym_QMARK] = ACTIONS(2840),
    [anon_sym_TILDE] = ACTIONS(2842),
    [anon_sym_BANG] = ACTIONS(2844),
    [anon_sym_PLUS] = ACTIONS(2846),
    [anon_sym_DASH] = ACTIONS(2848),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [anon_sym_LT_LT_DASH] = ACTIONS(453),
    [anon_sym_COLON_EQ] = ACTIONS(453),
    [anon_sym_DASH_GT] = ACTIONS(455),
    [anon_sym_DASH_GT_GT] = ACTIONS(453),
    [anon_sym_PIPE] = ACTIONS(455),
    [anon_sym_AMP] = ACTIONS(455),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(455),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_GT] = ACTIONS(455),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(453),
    [anon_sym_STAR] = ACTIONS(455),
    [anon_sym_SLASH] = ACTIONS(453),
    [anon_sym_STAR_STAR] = ACTIONS(453),
    [anon_sym_CARET] = ACTIONS(453),
    [aux_sym_binary_operator_token1] = ACTIONS(453),
    [anon_sym_PIPE_GT] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(455),
    [anon_sym_DOLLAR] = ACTIONS(453),
    [anon_sym_AT] = ACTIONS(453),
    [aux_sym__hex_literal_token1] = ACTIONS(2850),
    [sym__number_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE] = ACTIONS(2856),
    [sym_return] = ACTIONS(3748),
    [sym_next] = ACTIONS(3748),
    [sym_break] = ACTIONS(3748),
    [sym_true] = ACTIONS(3748),
    [sym_false] = ACTIONS(3748),
    [sym_null] = ACTIONS(3748),
    [sym_inf] = ACTIONS(3748),
    [sym_nan] = ACTIONS(3748),
    [anon_sym_NA] = ACTIONS(2860),
    [anon_sym_NA_integer_] = ACTIONS(2860),
    [anon_sym_NA_real_] = ACTIONS(2860),
    [anon_sym_NA_complex_] = ACTIONS(2860),
    [anon_sym_NA_character_] = ACTIONS(2860),
    [sym_dots] = ACTIONS(3748),
    [sym_dot_dot_i] = ACTIONS(3750),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(453),
    [sym__semicolon] = ACTIONS(453),
    [sym__raw_string_literal] = ACTIONS(2866),
    [sym__external_open_parenthesis] = ACTIONS(2868),
    [sym__external_open_brace] = ACTIONS(2870),
    [sym__external_close_brace] = ACTIONS(453),
    [sym__external_open_bracket] = ACTIONS(453),
    [sym__external_open_bracket2] = ACTIONS(453),
  },
  [327] = {
    [sym_function_definition] = STATE(1668),
    [sym_if_statement] = STATE(1668),
    [sym_for_statement] = STATE(1668),
    [sym_while_statement] = STATE(1668),
    [sym_repeat_statement] = STATE(1668),
    [sym_braced_expression] = STATE(1668),
    [sym_parenthesized_expression] = STATE(1668),
    [sym_call] = STATE(1668),
    [sym_subset] = STATE(1668),
    [sym_subset2] = STATE(1668),
    [sym_unary_operator] = STATE(1668),
    [sym_binary_operator] = STATE(1668),
    [sym_extract_operator] = STATE(1668),
    [sym_namespace_operator] = STATE(1668),
    [sym_integer] = STATE(1668),
    [sym_complex] = STATE(1668),
    [sym_float] = STATE(1668),
    [sym__hex_literal] = STATE(2371),
    [sym__float_literal] = STATE(2371),
    [sym_string] = STATE(2372),
    [sym__single_quoted_string] = STATE(2370),
    [sym__double_quoted_string] = STATE(2369),
    [sym_na] = STATE(1668),
    [sym__expression] = STATE(1668),
    [sym__string_or_identifier] = STATE(5138),
    [sym__open_parenthesis] = STATE(200),
    [sym__open_brace] = STATE(97),
    [aux_sym_function_definition_repeat1] = STATE(324),
    [sym_identifier] = ACTIONS(2425),
    [anon_sym_BSLASH] = ACTIONS(2427),
    [anon_sym_function] = ACTIONS(2429),
    [anon_sym_EQ] = ACTIONS(463),
    [anon_sym_if] = ACTIONS(2431),
    [anon_sym_for] = ACTIONS(2433),
    [anon_sym_while] = ACTIONS(2435),
    [anon_sym_repeat] = ACTIONS(2437),
    [anon_sym_QMARK] = ACTIONS(2439),
    [anon_sym_TILDE] = ACTIONS(2441),
    [anon_sym_BANG] = ACTIONS(2443),
    [anon_sym_PLUS] = ACTIONS(2445),
    [anon_sym_DASH] = ACTIONS(2447),
    [anon_sym_LT_DASH] = ACTIONS(461),
    [anon_sym_LT_LT_DASH] = ACTIONS(461),
    [anon_sym_COLON_EQ] = ACTIONS(461),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_DASH_GT_GT] = ACTIONS(461),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_PIPE_PIPE] = ACTIONS(461),
    [anon_sym_AMP_AMP] = ACTIONS(461),
    [anon_sym_LT] = ACTIONS(463),
    [anon_sym_LT_EQ] = ACTIONS(461),
    [anon_sym_GT] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(461),
    [anon_sym_EQ_EQ] = ACTIONS(461),
    [anon_sym_BANG_EQ] = ACTIONS(461),
    [anon_sym_STAR] = ACTIONS(463),
    [anon_sym_SLASH] = ACTIONS(461),
    [anon_sym_STAR_STAR] = ACTIONS(461),
    [anon_sym_CARET] = ACTIONS(461),
    [aux_sym_binary_operator_token1] = ACTIONS(461),
    [anon_sym_PIPE_GT] = ACTIONS(461),
    [anon_sym_COLON] = ACTIONS(463),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_AT] = ACTIONS(461),
    [aux_sym__hex_literal_token1] = ACTIONS(2449),
    [sym__number_literal] = ACTIONS(2451),
    [anon_sym_SQUOTE] = ACTIONS(2453),
    [anon_sym_DQUOTE] = ACTIONS(2455),
    [sym_return] = ACTIONS(3752),
    [sym_next] = ACTIONS(3752),
    [sym_break] = ACTIONS(3752),
    [sym_true] = ACTIONS(3752),
    [sym_false] = ACTIONS(3752),
    [sym_null] = ACTIONS(3752),
    [sym_inf] = ACTIONS(3752),
    [sym_nan] = ACTIONS(3752),
    [anon_sym_NA] = ACTIONS(2459),
    [anon_sym_NA_integer_] = ACTIONS(2459),
    [anon_sym_NA_real_] = ACTIONS(2459),
    [anon_sym_NA_complex_] = ACTIONS(2459),
    [anon_sym_NA_character_] = ACTIONS(2459),
    [sym_dots] = ACTIONS(3752),
    [sym_dot_dot_i] = ACTIONS(3754),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(461),
    [sym__newline] = ACTIONS(3756),
    [sym__raw_string_literal] = ACTIONS(2465),
    [sym__external_else] = ACTIONS(461),
    [sym__external_open_parenthesis] = ACTIONS(2467),
    [sym__external_close_parenthesis] = ACTIONS(461),
    [sym__external_open_brace] = ACTIONS(2471),
    [sym__external_open_bracket] = ACTIONS(461),
    [sym__external_open_bracket2] = ACTIONS(461),
  },
  [328] = {
    [sym_function_definition] = STATE(1669),
    [sym_if_statement] = STATE(1669),
    [sym_for_statement] = STATE(1669),
    [sym_while_statement] = STATE(1669),
    [sym_repeat_statement] = STATE(1669),
    [sym_braced_expression] = STATE(1669),
    [sym_parenthesized_expression] = STATE(1669),
    [sym_call] = STATE(1669),
    [sym_subset] = STATE(1669),
    [sym_subset2] = STATE(1669),
    [sym_unary_operator] = STATE(1669),
    [sym_binary_operator] = STATE(1669),
    [sym_extract_operator] = STATE(1669),
    [sym_namespace_operator] = STATE(1669),
    [sym_integer] = STATE(1669),
    [sym_complex] = STATE(1669),
    [sym_float] = STATE(1669),
    [sym__hex_literal] = STATE(2371),
    [sym__float_literal] = STATE(2371),
    [sym_string] = STATE(2372),
    [sym__single_quoted_string] = STATE(2370),
    [sym__double_quoted_string] = STATE(2369),
    [sym_na] = STATE(1669),
    [sym__expression] = STATE(1669),
    [sym__string_or_identifier] = STATE(5138),
    [sym__open_parenthesis] = STATE(200),
    [sym__open_brace] = STATE(97),
    [aux_sym_function_definition_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(2425),
    [anon_sym_BSLASH] = ACTIONS(2427),
    [anon_sym_function] = ACTIONS(2429),
    [anon_sym_EQ] = ACTIONS(455),
    [anon_sym_if] = ACTIONS(2431),
    [anon_sym_for] = ACTIONS(2433),
    [anon_sym_while] = ACTIONS(2435),
    [anon_sym_repeat] = ACTIONS(2437),
    [anon_sym_QMARK] = ACTIONS(2439),
    [anon_sym_TILDE] = ACTIONS(2441),
    [anon_sym_BANG] = ACTIONS(2443),
    [anon_sym_PLUS] = ACTIONS(2445),
    [anon_sym_DASH] = ACTIONS(2447),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [anon_sym_LT_LT_DASH] = ACTIONS(453),
    [anon_sym_COLON_EQ] = ACTIONS(453),
    [anon_sym_DASH_GT] = ACTIONS(455),
    [anon_sym_DASH_GT_GT] = ACTIONS(453),
    [anon_sym_PIPE] = ACTIONS(455),
    [anon_sym_AMP] = ACTIONS(455),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(455),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_GT] = ACTIONS(455),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(453),
    [anon_sym_STAR] = ACTIONS(455),
    [anon_sym_SLASH] = ACTIONS(453),
    [anon_sym_STAR_STAR] = ACTIONS(453),
    [anon_sym_CARET] = ACTIONS(453),
    [aux_sym_binary_operator_token1] = ACTIONS(453),
    [anon_sym_PIPE_GT] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(455),
    [anon_sym_DOLLAR] = ACTIONS(453),
    [anon_sym_AT] = ACTIONS(453),
    [aux_sym__hex_literal_token1] = ACTIONS(2449),
    [sym__number_literal] = ACTIONS(2451),
    [anon_sym_SQUOTE] = ACTIONS(2453),
    [anon_sym_DQUOTE] = ACTIONS(2455),
    [sym_return] = ACTIONS(3758),
    [sym_next] = ACTIONS(3758),
    [sym_break] = ACTIONS(3758),
    [sym_true] = ACTIONS(3758),
    [sym_false] = ACTIONS(3758),
    [sym_null] = ACTIONS(3758),
    [sym_inf] = ACTIONS(3758),
    [sym_nan] = ACTIONS(3758),
    [anon_sym_NA] = ACTIONS(2459),
    [anon_sym_NA_integer_] = ACTIONS(2459),
    [anon_sym_NA_real_] = ACTIONS(2459),
    [anon_sym_NA_complex_] = ACTIONS(2459),
    [anon_sym_NA_character_] = ACTIONS(2459),
    [sym_dots] = ACTIONS(3758),
    [sym_dot_dot_i] = ACTIONS(3760),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(453),
    [sym__newline] = ACTIONS(453),
    [sym__raw_string_literal] = ACTIONS(2465),
    [sym__external_else] = ACTIONS(453),
    [sym__external_open_parenthesis] = ACTIONS(2467),
    [sym__external_close_parenthesis] = ACTIONS(453),
    [sym__external_open_brace] = ACTIONS(2471),
    [sym__external_open_bracket] = ACTIONS(453),
    [sym__external_open_bracket2] = ACTIONS(453),
  },
  [329] = {
    [sym_function_definition] = STATE(1674),
    [sym_if_statement] = STATE(1674),
    [sym_for_statement] = STATE(1674),
    [sym_while_statement] = STATE(1674),
    [sym_repeat_statement] = STATE(1674),
    [sym_braced_expression] = STATE(1674),
    [sym_parenthesized_expression] = STATE(1674),
    [sym_call] = STATE(1674),
    [sym_subset] = STATE(1674),
    [sym_subset2] = STATE(1674),
    [sym_unary_operator] = STATE(1674),
    [sym_binary_operator] = STATE(1674),
    [sym_extract_operator] = STATE(1674),
    [sym_namespace_operator] = STATE(1674),
    [sym_integer] = STATE(1674),
    [sym_complex] = STATE(1674),
    [sym_float] = STATE(1674),
    [sym__hex_literal] = STATE(2371),
    [sym__float_literal] = STATE(2371),
    [sym_string] = STATE(2372),
    [sym__single_quoted_string] = STATE(2370),
    [sym__double_quoted_string] = STATE(2369),
    [sym_na] = STATE(1674),
    [sym__expression] = STATE(1674),
    [sym__string_or_identifier] = STATE(5138),
    [sym__open_parenthesis] = STATE(200),
    [sym__open_brace] = STATE(97),
    [aux_sym_function_definition_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(2425),
    [anon_sym_BSLASH] = ACTIONS(2427),
    [anon_sym_function] = ACTIONS(2429),
    [anon_sym_EQ] = ACTIONS(399),
    [anon_sym_if] = ACTIONS(2431),
    [anon_sym_for] = ACTIONS(2433),
    [anon_sym_while] = ACTIONS(2435),
    [anon_sym_repeat] = ACTIONS(2437),
    [anon_sym_QMARK] = ACTIONS(2439),
    [anon_sym_TILDE] = ACTIONS(2441),
    [anon_sym_BANG] = ACTIONS(2443),
    [anon_sym_PLUS] = ACTIONS(2445),
    [anon_sym_DASH] = ACTIONS(2447),
    [anon_sym_LT_DASH] = ACTIONS(397),
    [anon_sym_LT_LT_DASH] = ACTIONS(397),
    [anon_sym_COLON_EQ] = ACTIONS(397),
    [anon_sym_DASH_GT] = ACTIONS(399),
    [anon_sym_DASH_GT_GT] = ACTIONS(397),
    [anon_sym_PIPE] = ACTIONS(399),
    [anon_sym_AMP] = ACTIONS(399),
    [anon_sym_PIPE_PIPE] = ACTIONS(397),
    [anon_sym_AMP_AMP] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(399),
    [anon_sym_LT_EQ] = ACTIONS(397),
    [anon_sym_GT] = ACTIONS(399),
    [anon_sym_GT_EQ] = ACTIONS(397),
    [anon_sym_EQ_EQ] = ACTIONS(397),
    [anon_sym_BANG_EQ] = ACTIONS(397),
    [anon_sym_STAR] = ACTIONS(399),
    [anon_sym_SLASH] = ACTIONS(397),
    [anon_sym_STAR_STAR] = ACTIONS(397),
    [anon_sym_CARET] = ACTIONS(397),
    [aux_sym_binary_operator_token1] = ACTIONS(397),
    [anon_sym_PIPE_GT] = ACTIONS(397),
    [anon_sym_COLON] = ACTIONS(399),
    [anon_sym_DOLLAR] = ACTIONS(397),
    [anon_sym_AT] = ACTIONS(397),
    [aux_sym__hex_literal_token1] = ACTIONS(2449),
    [sym__number_literal] = ACTIONS(2451),
    [anon_sym_SQUOTE] = ACTIONS(2453),
    [anon_sym_DQUOTE] = ACTIONS(2455),
    [sym_return] = ACTIONS(3762),
    [sym_next] = ACTIONS(3762),
    [sym_break] = ACTIONS(3762),
    [sym_true] = ACTIONS(3762),
    [sym_false] = ACTIONS(3762),
    [sym_null] = ACTIONS(3762),
    [sym_inf] = ACTIONS(3762),
    [sym_nan] = ACTIONS(3762),
    [anon_sym_NA] = ACTIONS(2459),
    [anon_sym_NA_integer_] = ACTIONS(2459),
    [anon_sym_NA_real_] = ACTIONS(2459),
    [anon_sym_NA_complex_] = ACTIONS(2459),
    [anon_sym_NA_character_] = ACTIONS(2459),
    [sym_dots] = ACTIONS(3762),
    [sym_dot_dot_i] = ACTIONS(3764),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(397),
    [sym__newline] = ACTIONS(397),
    [sym__raw_string_literal] = ACTIONS(2465),
    [sym__external_else] = ACTIONS(397),
    [sym__external_open_parenthesis] = ACTIONS(2467),
    [sym__external_close_parenthesis] = ACTIONS(397),
    [sym__external_open_brace] = ACTIONS(2471),
    [sym__external_open_bracket] = ACTIONS(397),
    [sym__external_open_bracket2] = ACTIONS(397),
  },
  [330] = {
    [sym_function_definition] = STATE(1521),
    [sym_if_statement] = STATE(1521),
    [sym_for_statement] = STATE(1521),
    [sym_while_statement] = STATE(1521),
    [sym_repeat_statement] = STATE(1521),
    [sym_braced_expression] = STATE(1521),
    [sym_parenthesized_expression] = STATE(1521),
    [sym_call] = STATE(1521),
    [sym_subset] = STATE(1521),
    [sym_subset2] = STATE(1521),
    [sym_unary_operator] = STATE(1521),
    [sym_binary_operator] = STATE(1521),
    [sym_extract_operator] = STATE(1521),
    [sym_namespace_operator] = STATE(1521),
    [sym_integer] = STATE(1521),
    [sym_complex] = STATE(1521),
    [sym_float] = STATE(1521),
    [sym__hex_literal] = STATE(2371),
    [sym__float_literal] = STATE(2371),
    [sym_string] = STATE(2372),
    [sym__single_quoted_string] = STATE(2370),
    [sym__double_quoted_string] = STATE(2369),
    [sym_na] = STATE(1521),
    [sym__expression] = STATE(1521),
    [sym__string_or_identifier] = STATE(5138),
    [sym__open_parenthesis] = STATE(200),
    [sym__open_brace] = STATE(97),
    [aux_sym_parenthesized_expression_repeat1] = STATE(330),
    [sym_identifier] = ACTIONS(3766),
    [anon_sym_BSLASH] = ACTIONS(3769),
    [anon_sym_function] = ACTIONS(3772),
    [anon_sym_EQ] = ACTIONS(814),
    [anon_sym_if] = ACTIONS(3775),
    [anon_sym_for] = ACTIONS(3778),
    [anon_sym_while] = ACTIONS(3781),
    [anon_sym_repeat] = ACTIONS(3784),
    [anon_sym_QMARK] = ACTIONS(3787),
    [anon_sym_TILDE] = ACTIONS(3790),
    [anon_sym_BANG] = ACTIONS(3793),
    [anon_sym_PLUS] = ACTIONS(3796),
    [anon_sym_DASH] = ACTIONS(3799),
    [anon_sym_LT_DASH] = ACTIONS(803),
    [anon_sym_LT_LT_DASH] = ACTIONS(803),
    [anon_sym_COLON_EQ] = ACTIONS(803),
    [anon_sym_DASH_GT] = ACTIONS(814),
    [anon_sym_DASH_GT_GT] = ACTIONS(803),
    [anon_sym_PIPE] = ACTIONS(814),
    [anon_sym_AMP] = ACTIONS(814),
    [anon_sym_PIPE_PIPE] = ACTIONS(803),
    [anon_sym_AMP_AMP] = ACTIONS(803),
    [anon_sym_LT] = ACTIONS(814),
    [anon_sym_LT_EQ] = ACTIONS(803),
    [anon_sym_GT] = ACTIONS(814),
    [anon_sym_GT_EQ] = ACTIONS(803),
    [anon_sym_EQ_EQ] = ACTIONS(803),
    [anon_sym_BANG_EQ] = ACTIONS(803),
    [anon_sym_STAR] = ACTIONS(814),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_STAR_STAR] = ACTIONS(803),
    [anon_sym_CARET] = ACTIONS(803),
    [aux_sym_binary_operator_token1] = ACTIONS(803),
    [anon_sym_PIPE_GT] = ACTIONS(803),
    [anon_sym_COLON] = ACTIONS(814),
    [anon_sym_DOLLAR] = ACTIONS(803),
    [anon_sym_AT] = ACTIONS(803),
    [aux_sym__hex_literal_token1] = ACTIONS(3802),
    [sym__number_literal] = ACTIONS(3805),
    [anon_sym_SQUOTE] = ACTIONS(3808),
    [anon_sym_DQUOTE] = ACTIONS(3811),
    [sym_return] = ACTIONS(3814),
    [sym_next] = ACTIONS(3814),
    [sym_break] = ACTIONS(3814),
    [sym_true] = ACTIONS(3814),
    [sym_false] = ACTIONS(3814),
    [sym_null] = ACTIONS(3814),
    [sym_inf] = ACTIONS(3814),
    [sym_nan] = ACTIONS(3814),
    [anon_sym_NA] = ACTIONS(3817),
    [anon_sym_NA_integer_] = ACTIONS(3817),
    [anon_sym_NA_real_] = ACTIONS(3817),
    [anon_sym_NA_complex_] = ACTIONS(3817),
    [anon_sym_NA_character_] = ACTIONS(3817),
    [sym_dots] = ACTIONS(3814),
    [sym_dot_dot_i] = ACTIONS(3820),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(803),
    [sym__newline] = ACTIONS(3823),
    [sym__raw_string_literal] = ACTIONS(3826),
    [sym__external_else] = ACTIONS(803),
    [sym__external_open_parenthesis] = ACTIONS(3829),
    [sym__external_close_parenthesis] = ACTIONS(803),
    [sym__external_open_brace] = ACTIONS(3832),
    [sym__external_open_bracket] = ACTIONS(803),
    [sym__external_open_bracket2] = ACTIONS(803),
  },
  [331] = {
    [sym_function_definition] = STATE(1677),
    [sym_if_statement] = STATE(1677),
    [sym_for_statement] = STATE(1677),
    [sym_while_statement] = STATE(1677),
    [sym_repeat_statement] = STATE(1677),
    [sym_braced_expression] = STATE(1677),
    [sym_parenthesized_expression] = STATE(1677),
    [sym_call] = STATE(1677),
    [sym_subset] = STATE(1677),
    [sym_subset2] = STATE(1677),
    [sym_unary_operator] = STATE(1677),
    [sym_binary_operator] = STATE(1677),
    [sym_extract_operator] = STATE(1677),
    [sym_namespace_operator] = STATE(1677),
    [sym_integer] = STATE(1677),
    [sym_complex] = STATE(1677),
    [sym_float] = STATE(1677),
    [sym__hex_literal] = STATE(2371),
    [sym__float_literal] = STATE(2371),
    [sym_string] = STATE(2372),
    [sym__single_quoted_string] = STATE(2370),
    [sym__double_quoted_string] = STATE(2369),
    [sym_na] = STATE(1677),
    [sym__expression] = STATE(1677),
    [sym__string_or_identifier] = STATE(5138),
    [sym__open_parenthesis] = STATE(200),
    [sym__open_brace] = STATE(97),
    [aux_sym_function_definition_repeat1] = STATE(328),
    [sym_identifier] = ACTIONS(2425),
    [anon_sym_BSLASH] = ACTIONS(2427),
    [anon_sym_function] = ACTIONS(2429),
    [anon_sym_EQ] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(2431),
    [anon_sym_for] = ACTIONS(2433),
    [anon_sym_while] = ACTIONS(2435),
    [anon_sym_repeat] = ACTIONS(2437),
    [anon_sym_QMARK] = ACTIONS(2439),
    [anon_sym_TILDE] = ACTIONS(2441),
    [anon_sym_BANG] = ACTIONS(2443),
    [anon_sym_PLUS] = ACTIONS(2445),
    [anon_sym_DASH] = ACTIONS(2447),
    [anon_sym_LT_DASH] = ACTIONS(387),
    [anon_sym_LT_LT_DASH] = ACTIONS(387),
    [anon_sym_COLON_EQ] = ACTIONS(387),
    [anon_sym_DASH_GT] = ACTIONS(389),
    [anon_sym_DASH_GT_GT] = ACTIONS(387),
    [anon_sym_PIPE] = ACTIONS(389),
    [anon_sym_AMP] = ACTIONS(389),
    [anon_sym_PIPE_PIPE] = ACTIONS(387),
    [anon_sym_AMP_AMP] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(389),
    [anon_sym_LT_EQ] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(389),
    [anon_sym_GT_EQ] = ACTIONS(387),
    [anon_sym_EQ_EQ] = ACTIONS(387),
    [anon_sym_BANG_EQ] = ACTIONS(387),
    [anon_sym_STAR] = ACTIONS(389),
    [anon_sym_SLASH] = ACTIONS(387),
    [anon_sym_STAR_STAR] = ACTIONS(387),
    [anon_sym_CARET] = ACTIONS(387),
    [aux_sym_binary_operator_token1] = ACTIONS(387),
    [anon_sym_PIPE_GT] = ACTIONS(387),
    [anon_sym_COLON] = ACTIONS(389),
    [anon_sym_DOLLAR] = ACTIONS(387),
    [anon_sym_AT] = ACTIONS(387),
    [aux_sym__hex_literal_token1] = ACTIONS(2449),
    [sym__number_literal] = ACTIONS(2451),
    [anon_sym_SQUOTE] = ACTIONS(2453),
    [anon_sym_DQUOTE] = ACTIONS(2455),
    [sym_return] = ACTIONS(3835),
    [sym_next] = ACTIONS(3835),
    [sym_break] = ACTIONS(3835),
    [sym_true] = ACTIONS(3835),
    [sym_false] = ACTIONS(3835),
    [sym_null] = ACTIONS(3835),
    [sym_inf] = ACTIONS(3835),
    [sym_nan] = ACTIONS(3835),
    [anon_sym_NA] = ACTIONS(2459),
    [anon_sym_NA_integer_] = ACTIONS(2459),
    [anon_sym_NA_real_] = ACTIONS(2459),
    [anon_sym_NA_complex_] = ACTIONS(2459),
    [anon_sym_NA_character_] = ACTIONS(2459),
    [sym_dots] = ACTIONS(3835),
    [sym_dot_dot_i] = ACTIONS(3837),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(387),
    [sym__newline] = ACTIONS(3839),
    [sym__raw_string_literal] = ACTIONS(2465),
    [sym__external_else] = ACTIONS(387),
    [sym__external_open_parenthesis] = ACTIONS(2467),
    [sym__external_close_parenthesis] = ACTIONS(387),
    [sym__external_open_brace] = ACTIONS(2471),
    [sym__external_open_bracket] = ACTIONS(387),
    [sym__external_open_bracket2] = ACTIONS(387),
  },
  [332] = {
    [sym_function_definition] = STATE(1376),
    [sym_if_statement] = STATE(1376),
    [sym_for_statement] = STATE(1376),
    [sym_while_statement] = STATE(1376),
    [sym_repeat_statement] = STATE(1376),
    [sym_braced_expression] = STATE(1376),
    [sym_parenthesized_expression] = STATE(1376),
    [sym_call] = STATE(1376),
    [sym_subset] = STATE(1376),
    [sym_subset2] = STATE(1376),
    [sym_unary_operator] = STATE(1376),
    [sym_binary_operator] = STATE(1376),
    [sym_extract_operator] = STATE(1376),
    [sym_namespace_operator] = STATE(1376),
    [sym_integer] = STATE(1376),
    [sym_complex] = STATE(1376),
    [sym_float] = STATE(1376),
    [sym__hex_literal] = STATE(2523),
    [sym__float_literal] = STATE(2523),
    [sym_string] = STATE(2522),
    [sym__single_quoted_string] = STATE(2528),
    [sym__double_quoted_string] = STATE(2529),
    [sym_na] = STATE(1376),
    [sym__expression] = STATE(1376),
    [sym__string_or_identifier] = STATE(5126),
    [sym__open_parenthesis] = STATE(178),
    [sym__open_brace] = STATE(244),
    [aux_sym_function_definition_repeat1] = STATE(2680),
    [ts_builtin_sym_end] = ACTIONS(397),
    [sym_identifier] = ACTIONS(2826),
    [anon_sym_BSLASH] = ACTIONS(2828),
    [anon_sym_function] = ACTIONS(2830),
    [anon_sym_EQ] = ACTIONS(399),
    [anon_sym_if] = ACTIONS(2832),
    [anon_sym_for] = ACTIONS(2834),
    [anon_sym_while] = ACTIONS(2836),
    [anon_sym_repeat] = ACTIONS(2838),
    [anon_sym_QMARK] = ACTIONS(2840),
    [anon_sym_TILDE] = ACTIONS(2842),
    [anon_sym_BANG] = ACTIONS(2844),
    [anon_sym_PLUS] = ACTIONS(2846),
    [anon_sym_DASH] = ACTIONS(2848),
    [anon_sym_LT_DASH] = ACTIONS(397),
    [anon_sym_LT_LT_DASH] = ACTIONS(397),
    [anon_sym_COLON_EQ] = ACTIONS(397),
    [anon_sym_DASH_GT] = ACTIONS(399),
    [anon_sym_DASH_GT_GT] = ACTIONS(397),
    [anon_sym_PIPE] = ACTIONS(399),
    [anon_sym_AMP] = ACTIONS(399),
    [anon_sym_PIPE_PIPE] = ACTIONS(397),
    [anon_sym_AMP_AMP] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(399),
    [anon_sym_LT_EQ] = ACTIONS(397),
    [anon_sym_GT] = ACTIONS(399),
    [anon_sym_GT_EQ] = ACTIONS(397),
    [anon_sym_EQ_EQ] = ACTIONS(397),
    [anon_sym_BANG_EQ] = ACTIONS(397),
    [anon_sym_STAR] = ACTIONS(399),
    [anon_sym_SLASH] = ACTIONS(397),
    [anon_sym_STAR_STAR] = ACTIONS(397),
    [anon_sym_CARET] = ACTIONS(397),
    [aux_sym_binary_operator_token1] = ACTIONS(397),
    [anon_sym_PIPE_GT] = ACTIONS(397),
    [anon_sym_COLON] = ACTIONS(399),
    [anon_sym_DOLLAR] = ACTIONS(397),
    [anon_sym_AT] = ACTIONS(397),
    [aux_sym__hex_literal_token1] = ACTIONS(2850),
    [sym__number_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE] = ACTIONS(2856),
    [sym_return] = ACTIONS(3841),
    [sym_next] = ACTIONS(3841),
    [sym_break] = ACTIONS(3841),
    [sym_true] = ACTIONS(3841),
    [sym_false] = ACTIONS(3841),
    [sym_null] = ACTIONS(3841),
    [sym_inf] = ACTIONS(3841),
    [sym_nan] = ACTIONS(3841),
    [anon_sym_NA] = ACTIONS(2860),
    [anon_sym_NA_integer_] = ACTIONS(2860),
    [anon_sym_NA_real_] = ACTIONS(2860),
    [anon_sym_NA_complex_] = ACTIONS(2860),
    [anon_sym_NA_character_] = ACTIONS(2860),
    [sym_dots] = ACTIONS(3841),
    [sym_dot_dot_i] = ACTIONS(3843),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(397),
    [sym__semicolon] = ACTIONS(397),
    [sym__raw_string_literal] = ACTIONS(2866),
    [sym__external_open_parenthesis] = ACTIONS(2868),
    [sym__external_open_brace] = ACTIONS(2870),
    [sym__external_close_brace] = ACTIONS(397),
    [sym__external_open_bracket] = ACTIONS(397),
    [sym__external_open_bracket2] = ACTIONS(397),
  },
  [333] = {
    [sym_function_definition] = STATE(1969),
    [sym_if_statement] = STATE(1969),
    [sym_for_statement] = STATE(1969),
    [sym_while_statement] = STATE(1969),
    [sym_repeat_statement] = STATE(1969),
    [sym_braced_expression] = STATE(1969),
    [sym_parenthesized_expression] = STATE(1969),
    [sym_call] = STATE(1969),
    [sym_subset] = STATE(1969),
    [sym_subset2] = STATE(1969),
    [sym_unary_operator] = STATE(1969),
    [sym_binary_operator] = STATE(1969),
    [sym_extract_operator] = STATE(1969),
    [sym_namespace_operator] = STATE(1969),
    [sym_integer] = STATE(1969),
    [sym_complex] = STATE(1969),
    [sym_float] = STATE(1969),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2673),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(1969),
    [sym__expression] = STATE(1969),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__close_parenthesis] = STATE(2954),
    [sym__open_brace] = STATE(154),
    [aux_sym_parenthesized_expression_repeat1] = STATE(443),
    [sym_identifier] = ACTIONS(3845),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_EQ] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3867),
    [anon_sym_LT_DASH] = ACTIONS(211),
    [anon_sym_LT_LT_DASH] = ACTIONS(211),
    [anon_sym_COLON_EQ] = ACTIONS(211),
    [anon_sym_DASH_GT] = ACTIONS(209),
    [anon_sym_DASH_GT_GT] = ACTIONS(211),
    [anon_sym_PIPE] = ACTIONS(209),
    [anon_sym_AMP] = ACTIONS(209),
    [anon_sym_PIPE_PIPE] = ACTIONS(211),
    [anon_sym_AMP_AMP] = ACTIONS(211),
    [anon_sym_LT] = ACTIONS(209),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_GT] = ACTIONS(209),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [anon_sym_EQ_EQ] = ACTIONS(211),
    [anon_sym_BANG_EQ] = ACTIONS(211),
    [anon_sym_STAR] = ACTIONS(209),
    [anon_sym_SLASH] = ACTIONS(211),
    [anon_sym_STAR_STAR] = ACTIONS(211),
    [anon_sym_CARET] = ACTIONS(211),
    [aux_sym_binary_operator_token1] = ACTIONS(211),
    [anon_sym_PIPE_GT] = ACTIONS(211),
    [anon_sym_COLON] = ACTIONS(209),
    [anon_sym_DOLLAR] = ACTIONS(211),
    [anon_sym_AT] = ACTIONS(211),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(3877),
    [sym_next] = ACTIONS(3877),
    [sym_break] = ACTIONS(3877),
    [sym_true] = ACTIONS(3877),
    [sym_false] = ACTIONS(3877),
    [sym_null] = ACTIONS(3877),
    [sym_inf] = ACTIONS(3877),
    [sym_nan] = ACTIONS(3877),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(3877),
    [sym_dot_dot_i] = ACTIONS(3881),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(211),
    [sym__newline] = ACTIONS(3883),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(3889),
    [sym__external_open_brace] = ACTIONS(3891),
    [sym__external_open_bracket] = ACTIONS(211),
    [sym__external_open_bracket2] = ACTIONS(211),
  },
  [334] = {
    [sym_function_definition] = STATE(1531),
    [sym_if_statement] = STATE(1531),
    [sym_for_statement] = STATE(1531),
    [sym_while_statement] = STATE(1531),
    [sym_repeat_statement] = STATE(1531),
    [sym_braced_expression] = STATE(1531),
    [sym_parenthesized_expression] = STATE(1531),
    [sym_call] = STATE(1531),
    [sym_subset] = STATE(1531),
    [sym_subset2] = STATE(1531),
    [sym_unary_operator] = STATE(1531),
    [sym_binary_operator] = STATE(1531),
    [sym_extract_operator] = STATE(1531),
    [sym_namespace_operator] = STATE(1531),
    [sym_integer] = STATE(1531),
    [sym_complex] = STATE(1531),
    [sym_float] = STATE(1531),
    [sym__hex_literal] = STATE(2381),
    [sym__float_literal] = STATE(2381),
    [sym_string] = STATE(2378),
    [sym__single_quoted_string] = STATE(2382),
    [sym__double_quoted_string] = STATE(2383),
    [sym_na] = STATE(1531),
    [sym__expression] = STATE(1531),
    [sym__string_or_identifier] = STATE(5153),
    [sym__open_parenthesis] = STATE(191),
    [sym__open_brace] = STATE(29),
    [aux_sym_function_definition_repeat1] = STATE(338),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_BSLASH] = ACTIONS(3680),
    [anon_sym_function] = ACTIONS(3682),
    [anon_sym_EQ] = ACTIONS(543),
    [anon_sym_if] = ACTIONS(3684),
    [anon_sym_for] = ACTIONS(3686),
    [anon_sym_while] = ACTIONS(3688),
    [anon_sym_repeat] = ACTIONS(3690),
    [anon_sym_QMARK] = ACTIONS(3692),
    [anon_sym_TILDE] = ACTIONS(3694),
    [anon_sym_BANG] = ACTIONS(3696),
    [anon_sym_PLUS] = ACTIONS(3698),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_LT_DASH] = ACTIONS(545),
    [anon_sym_LT_LT_DASH] = ACTIONS(545),
    [anon_sym_COLON_EQ] = ACTIONS(545),
    [anon_sym_DASH_GT] = ACTIONS(543),
    [anon_sym_DASH_GT_GT] = ACTIONS(545),
    [anon_sym_PIPE] = ACTIONS(543),
    [anon_sym_AMP] = ACTIONS(543),
    [anon_sym_PIPE_PIPE] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(543),
    [anon_sym_LT_EQ] = ACTIONS(545),
    [anon_sym_GT] = ACTIONS(543),
    [anon_sym_GT_EQ] = ACTIONS(545),
    [anon_sym_EQ_EQ] = ACTIONS(545),
    [anon_sym_BANG_EQ] = ACTIONS(545),
    [anon_sym_STAR] = ACTIONS(543),
    [anon_sym_SLASH] = ACTIONS(545),
    [anon_sym_STAR_STAR] = ACTIONS(545),
    [anon_sym_CARET] = ACTIONS(545),
    [aux_sym_binary_operator_token1] = ACTIONS(545),
    [anon_sym_PIPE_GT] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(543),
    [anon_sym_DOLLAR] = ACTIONS(545),
    [anon_sym_AT] = ACTIONS(545),
    [aux_sym__hex_literal_token1] = ACTIONS(3702),
    [sym__number_literal] = ACTIONS(3704),
    [anon_sym_SQUOTE] = ACTIONS(3706),
    [anon_sym_DQUOTE] = ACTIONS(3708),
    [sym_return] = ACTIONS(3893),
    [sym_next] = ACTIONS(3893),
    [sym_break] = ACTIONS(3893),
    [sym_true] = ACTIONS(3893),
    [sym_false] = ACTIONS(3893),
    [sym_null] = ACTIONS(3893),
    [sym_inf] = ACTIONS(3893),
    [sym_nan] = ACTIONS(3893),
    [anon_sym_NA] = ACTIONS(3712),
    [anon_sym_NA_integer_] = ACTIONS(3712),
    [anon_sym_NA_real_] = ACTIONS(3712),
    [anon_sym_NA_complex_] = ACTIONS(3712),
    [anon_sym_NA_character_] = ACTIONS(3712),
    [sym_dots] = ACTIONS(3893),
    [sym_dot_dot_i] = ACTIONS(3895),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(545),
    [sym__newline] = ACTIONS(3897),
    [sym__raw_string_literal] = ACTIONS(3718),
    [sym__external_else] = ACTIONS(545),
    [sym__external_open_parenthesis] = ACTIONS(3720),
    [sym__external_open_brace] = ACTIONS(3722),
    [sym__external_open_bracket] = ACTIONS(545),
    [sym__external_open_bracket2] = ACTIONS(545),
    [sym__external_close_bracket2] = ACTIONS(545),
  },
  [335] = {
    [sym_function_definition] = STATE(1530),
    [sym_if_statement] = STATE(1530),
    [sym_for_statement] = STATE(1530),
    [sym_while_statement] = STATE(1530),
    [sym_repeat_statement] = STATE(1530),
    [sym_braced_expression] = STATE(1530),
    [sym_parenthesized_expression] = STATE(1530),
    [sym_call] = STATE(1530),
    [sym_subset] = STATE(1530),
    [sym_subset2] = STATE(1530),
    [sym_unary_operator] = STATE(1530),
    [sym_binary_operator] = STATE(1530),
    [sym_extract_operator] = STATE(1530),
    [sym_namespace_operator] = STATE(1530),
    [sym_integer] = STATE(1530),
    [sym_complex] = STATE(1530),
    [sym_float] = STATE(1530),
    [sym__hex_literal] = STATE(2381),
    [sym__float_literal] = STATE(2381),
    [sym_string] = STATE(2378),
    [sym__single_quoted_string] = STATE(2382),
    [sym__double_quoted_string] = STATE(2383),
    [sym_na] = STATE(1530),
    [sym__expression] = STATE(1530),
    [sym__string_or_identifier] = STATE(5153),
    [sym__open_parenthesis] = STATE(191),
    [sym__open_brace] = STATE(29),
    [aux_sym_function_definition_repeat1] = STATE(2722),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_BSLASH] = ACTIONS(3680),
    [anon_sym_function] = ACTIONS(3682),
    [anon_sym_EQ] = ACTIONS(767),
    [anon_sym_if] = ACTIONS(3684),
    [anon_sym_for] = ACTIONS(3686),
    [anon_sym_while] = ACTIONS(3688),
    [anon_sym_repeat] = ACTIONS(3690),
    [anon_sym_QMARK] = ACTIONS(3692),
    [anon_sym_TILDE] = ACTIONS(3694),
    [anon_sym_BANG] = ACTIONS(3696),
    [anon_sym_PLUS] = ACTIONS(3698),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_LT_DASH] = ACTIONS(765),
    [anon_sym_LT_LT_DASH] = ACTIONS(765),
    [anon_sym_COLON_EQ] = ACTIONS(765),
    [anon_sym_DASH_GT] = ACTIONS(767),
    [anon_sym_DASH_GT_GT] = ACTIONS(765),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_AMP] = ACTIONS(767),
    [anon_sym_PIPE_PIPE] = ACTIONS(765),
    [anon_sym_AMP_AMP] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(767),
    [anon_sym_LT_EQ] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_GT_EQ] = ACTIONS(765),
    [anon_sym_EQ_EQ] = ACTIONS(765),
    [anon_sym_BANG_EQ] = ACTIONS(765),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(765),
    [anon_sym_STAR_STAR] = ACTIONS(765),
    [anon_sym_CARET] = ACTIONS(765),
    [aux_sym_binary_operator_token1] = ACTIONS(765),
    [anon_sym_PIPE_GT] = ACTIONS(765),
    [anon_sym_COLON] = ACTIONS(767),
    [anon_sym_DOLLAR] = ACTIONS(765),
    [anon_sym_AT] = ACTIONS(765),
    [aux_sym__hex_literal_token1] = ACTIONS(3702),
    [sym__number_literal] = ACTIONS(3704),
    [anon_sym_SQUOTE] = ACTIONS(3706),
    [anon_sym_DQUOTE] = ACTIONS(3708),
    [sym_return] = ACTIONS(3899),
    [sym_next] = ACTIONS(3899),
    [sym_break] = ACTIONS(3899),
    [sym_true] = ACTIONS(3899),
    [sym_false] = ACTIONS(3899),
    [sym_null] = ACTIONS(3899),
    [sym_inf] = ACTIONS(3899),
    [sym_nan] = ACTIONS(3899),
    [anon_sym_NA] = ACTIONS(3712),
    [anon_sym_NA_integer_] = ACTIONS(3712),
    [anon_sym_NA_real_] = ACTIONS(3712),
    [anon_sym_NA_complex_] = ACTIONS(3712),
    [anon_sym_NA_character_] = ACTIONS(3712),
    [sym_dots] = ACTIONS(3899),
    [sym_dot_dot_i] = ACTIONS(3901),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(765),
    [sym__newline] = ACTIONS(765),
    [sym__raw_string_literal] = ACTIONS(3718),
    [sym__external_else] = ACTIONS(765),
    [sym__external_open_parenthesis] = ACTIONS(3720),
    [sym__external_open_brace] = ACTIONS(3722),
    [sym__external_open_bracket] = ACTIONS(765),
    [sym__external_open_bracket2] = ACTIONS(765),
    [sym__external_close_bracket2] = ACTIONS(765),
  },
  [336] = {
    [sym_function_definition] = STATE(1807),
    [sym_if_statement] = STATE(1807),
    [sym_for_statement] = STATE(1807),
    [sym_while_statement] = STATE(1807),
    [sym_repeat_statement] = STATE(1807),
    [sym_braced_expression] = STATE(1807),
    [sym_parenthesized_expression] = STATE(1807),
    [sym_call] = STATE(1807),
    [sym_subset] = STATE(1807),
    [sym_subset2] = STATE(1807),
    [sym_unary_operator] = STATE(1807),
    [sym_binary_operator] = STATE(1807),
    [sym_extract_operator] = STATE(1807),
    [sym_namespace_operator] = STATE(1807),
    [sym_integer] = STATE(1807),
    [sym_complex] = STATE(1807),
    [sym_float] = STATE(1807),
    [sym__hex_literal] = STATE(2540),
    [sym__float_literal] = STATE(2540),
    [sym_string] = STATE(2541),
    [sym__single_quoted_string] = STATE(2462),
    [sym__double_quoted_string] = STATE(2494),
    [sym_na] = STATE(1807),
    [sym__expression] = STATE(1807),
    [sym__string_or_identifier] = STATE(5128),
    [sym__open_parenthesis] = STATE(246),
    [sym__open_brace] = STATE(173),
    [aux_sym_function_definition_repeat1] = STATE(2670),
    [ts_builtin_sym_end] = ACTIONS(757),
    [sym_identifier] = ACTIONS(2943),
    [anon_sym_BSLASH] = ACTIONS(2945),
    [anon_sym_function] = ACTIONS(2947),
    [anon_sym_EQ] = ACTIONS(759),
    [anon_sym_if] = ACTIONS(2949),
    [anon_sym_for] = ACTIONS(2951),
    [anon_sym_while] = ACTIONS(2953),
    [anon_sym_repeat] = ACTIONS(2955),
    [anon_sym_QMARK] = ACTIONS(2957),
    [anon_sym_TILDE] = ACTIONS(2959),
    [anon_sym_BANG] = ACTIONS(2961),
    [anon_sym_PLUS] = ACTIONS(2963),
    [anon_sym_DASH] = ACTIONS(2965),
    [anon_sym_LT_DASH] = ACTIONS(757),
    [anon_sym_LT_LT_DASH] = ACTIONS(757),
    [anon_sym_COLON_EQ] = ACTIONS(757),
    [anon_sym_DASH_GT] = ACTIONS(759),
    [anon_sym_DASH_GT_GT] = ACTIONS(757),
    [anon_sym_PIPE] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(759),
    [anon_sym_PIPE_PIPE] = ACTIONS(757),
    [anon_sym_AMP_AMP] = ACTIONS(757),
    [anon_sym_LT] = ACTIONS(759),
    [anon_sym_LT_EQ] = ACTIONS(757),
    [anon_sym_GT] = ACTIONS(759),
    [anon_sym_GT_EQ] = ACTIONS(757),
    [anon_sym_EQ_EQ] = ACTIONS(757),
    [anon_sym_BANG_EQ] = ACTIONS(757),
    [anon_sym_STAR] = ACTIONS(759),
    [anon_sym_SLASH] = ACTIONS(757),
    [anon_sym_STAR_STAR] = ACTIONS(757),
    [anon_sym_CARET] = ACTIONS(757),
    [aux_sym_binary_operator_token1] = ACTIONS(757),
    [anon_sym_PIPE_GT] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(759),
    [anon_sym_DOLLAR] = ACTIONS(757),
    [anon_sym_AT] = ACTIONS(757),
    [aux_sym__hex_literal_token1] = ACTIONS(2967),
    [sym__number_literal] = ACTIONS(2969),
    [anon_sym_SQUOTE] = ACTIONS(2971),
    [anon_sym_DQUOTE] = ACTIONS(2973),
    [sym_return] = ACTIONS(3903),
    [sym_next] = ACTIONS(3903),
    [sym_break] = ACTIONS(3903),
    [sym_true] = ACTIONS(3903),
    [sym_false] = ACTIONS(3903),
    [sym_null] = ACTIONS(3903),
    [sym_inf] = ACTIONS(3903),
    [sym_nan] = ACTIONS(3903),
    [anon_sym_NA] = ACTIONS(2977),
    [anon_sym_NA_integer_] = ACTIONS(2977),
    [anon_sym_NA_real_] = ACTIONS(2977),
    [anon_sym_NA_complex_] = ACTIONS(2977),
    [anon_sym_NA_character_] = ACTIONS(2977),
    [sym_dots] = ACTIONS(3903),
    [sym_dot_dot_i] = ACTIONS(3905),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(757),
    [sym__semicolon] = ACTIONS(757),
    [sym__raw_string_literal] = ACTIONS(2983),
    [sym__external_open_parenthesis] = ACTIONS(2985),
    [sym__external_close_parenthesis] = ACTIONS(757),
    [sym__external_open_brace] = ACTIONS(2989),
    [sym__external_open_bracket] = ACTIONS(757),
    [sym__external_open_bracket2] = ACTIONS(757),
  },
  [337] = {
    [sym_function_definition] = STATE(1527),
    [sym_if_statement] = STATE(1527),
    [sym_for_statement] = STATE(1527),
    [sym_while_statement] = STATE(1527),
    [sym_repeat_statement] = STATE(1527),
    [sym_braced_expression] = STATE(1527),
    [sym_parenthesized_expression] = STATE(1527),
    [sym_call] = STATE(1527),
    [sym_subset] = STATE(1527),
    [sym_subset2] = STATE(1527),
    [sym_unary_operator] = STATE(1527),
    [sym_binary_operator] = STATE(1527),
    [sym_extract_operator] = STATE(1527),
    [sym_namespace_operator] = STATE(1527),
    [sym_integer] = STATE(1527),
    [sym_complex] = STATE(1527),
    [sym_float] = STATE(1527),
    [sym__hex_literal] = STATE(2523),
    [sym__float_literal] = STATE(2523),
    [sym_string] = STATE(2522),
    [sym__single_quoted_string] = STATE(2528),
    [sym__double_quoted_string] = STATE(2529),
    [sym_na] = STATE(1527),
    [sym__expression] = STATE(1527),
    [sym__string_or_identifier] = STATE(5126),
    [sym__open_parenthesis] = STATE(178),
    [sym__open_brace] = STATE(244),
    [aux_sym_function_definition_repeat1] = STATE(326),
    [ts_builtin_sym_end] = ACTIONS(387),
    [sym_identifier] = ACTIONS(2826),
    [anon_sym_BSLASH] = ACTIONS(2828),
    [anon_sym_function] = ACTIONS(2830),
    [anon_sym_EQ] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(2832),
    [anon_sym_for] = ACTIONS(2834),
    [anon_sym_while] = ACTIONS(2836),
    [anon_sym_repeat] = ACTIONS(2838),
    [anon_sym_QMARK] = ACTIONS(2840),
    [anon_sym_TILDE] = ACTIONS(2842),
    [anon_sym_BANG] = ACTIONS(2844),
    [anon_sym_PLUS] = ACTIONS(2846),
    [anon_sym_DASH] = ACTIONS(2848),
    [anon_sym_LT_DASH] = ACTIONS(387),
    [anon_sym_LT_LT_DASH] = ACTIONS(387),
    [anon_sym_COLON_EQ] = ACTIONS(387),
    [anon_sym_DASH_GT] = ACTIONS(389),
    [anon_sym_DASH_GT_GT] = ACTIONS(387),
    [anon_sym_PIPE] = ACTIONS(389),
    [anon_sym_AMP] = ACTIONS(389),
    [anon_sym_PIPE_PIPE] = ACTIONS(387),
    [anon_sym_AMP_AMP] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(389),
    [anon_sym_LT_EQ] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(389),
    [anon_sym_GT_EQ] = ACTIONS(387),
    [anon_sym_EQ_EQ] = ACTIONS(387),
    [anon_sym_BANG_EQ] = ACTIONS(387),
    [anon_sym_STAR] = ACTIONS(389),
    [anon_sym_SLASH] = ACTIONS(387),
    [anon_sym_STAR_STAR] = ACTIONS(387),
    [anon_sym_CARET] = ACTIONS(387),
    [aux_sym_binary_operator_token1] = ACTIONS(387),
    [anon_sym_PIPE_GT] = ACTIONS(387),
    [anon_sym_COLON] = ACTIONS(389),
    [anon_sym_DOLLAR] = ACTIONS(387),
    [anon_sym_AT] = ACTIONS(387),
    [aux_sym__hex_literal_token1] = ACTIONS(2850),
    [sym__number_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE] = ACTIONS(2856),
    [sym_return] = ACTIONS(3907),
    [sym_next] = ACTIONS(3907),
    [sym_break] = ACTIONS(3907),
    [sym_true] = ACTIONS(3907),
    [sym_false] = ACTIONS(3907),
    [sym_null] = ACTIONS(3907),
    [sym_inf] = ACTIONS(3907),
    [sym_nan] = ACTIONS(3907),
    [anon_sym_NA] = ACTIONS(2860),
    [anon_sym_NA_integer_] = ACTIONS(2860),
    [anon_sym_NA_real_] = ACTIONS(2860),
    [anon_sym_NA_complex_] = ACTIONS(2860),
    [anon_sym_NA_character_] = ACTIONS(2860),
    [sym_dots] = ACTIONS(3907),
    [sym_dot_dot_i] = ACTIONS(3909),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(3911),
    [sym__semicolon] = ACTIONS(387),
    [sym__raw_string_literal] = ACTIONS(2866),
    [sym__external_open_parenthesis] = ACTIONS(2868),
    [sym__external_open_brace] = ACTIONS(2870),
    [sym__external_close_brace] = ACTIONS(387),
    [sym__external_open_bracket] = ACTIONS(387),
    [sym__external_open_bracket2] = ACTIONS(387),
  },
  [338] = {
    [sym_function_definition] = STATE(1502),
    [sym_if_statement] = STATE(1502),
    [sym_for_statement] = STATE(1502),
    [sym_while_statement] = STATE(1502),
    [sym_repeat_statement] = STATE(1502),
    [sym_braced_expression] = STATE(1502),
    [sym_parenthesized_expression] = STATE(1502),
    [sym_call] = STATE(1502),
    [sym_subset] = STATE(1502),
    [sym_subset2] = STATE(1502),
    [sym_unary_operator] = STATE(1502),
    [sym_binary_operator] = STATE(1502),
    [sym_extract_operator] = STATE(1502),
    [sym_namespace_operator] = STATE(1502),
    [sym_integer] = STATE(1502),
    [sym_complex] = STATE(1502),
    [sym_float] = STATE(1502),
    [sym__hex_literal] = STATE(2381),
    [sym__float_literal] = STATE(2381),
    [sym_string] = STATE(2378),
    [sym__single_quoted_string] = STATE(2382),
    [sym__double_quoted_string] = STATE(2383),
    [sym_na] = STATE(1502),
    [sym__expression] = STATE(1502),
    [sym__string_or_identifier] = STATE(5153),
    [sym__open_parenthesis] = STATE(191),
    [sym__open_brace] = STATE(29),
    [aux_sym_function_definition_repeat1] = STATE(2722),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_BSLASH] = ACTIONS(3680),
    [anon_sym_function] = ACTIONS(3682),
    [anon_sym_EQ] = ACTIONS(759),
    [anon_sym_if] = ACTIONS(3684),
    [anon_sym_for] = ACTIONS(3686),
    [anon_sym_while] = ACTIONS(3688),
    [anon_sym_repeat] = ACTIONS(3690),
    [anon_sym_QMARK] = ACTIONS(3692),
    [anon_sym_TILDE] = ACTIONS(3694),
    [anon_sym_BANG] = ACTIONS(3696),
    [anon_sym_PLUS] = ACTIONS(3698),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_LT_DASH] = ACTIONS(757),
    [anon_sym_LT_LT_DASH] = ACTIONS(757),
    [anon_sym_COLON_EQ] = ACTIONS(757),
    [anon_sym_DASH_GT] = ACTIONS(759),
    [anon_sym_DASH_GT_GT] = ACTIONS(757),
    [anon_sym_PIPE] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(759),
    [anon_sym_PIPE_PIPE] = ACTIONS(757),
    [anon_sym_AMP_AMP] = ACTIONS(757),
    [anon_sym_LT] = ACTIONS(759),
    [anon_sym_LT_EQ] = ACTIONS(757),
    [anon_sym_GT] = ACTIONS(759),
    [anon_sym_GT_EQ] = ACTIONS(757),
    [anon_sym_EQ_EQ] = ACTIONS(757),
    [anon_sym_BANG_EQ] = ACTIONS(757),
    [anon_sym_STAR] = ACTIONS(759),
    [anon_sym_SLASH] = ACTIONS(757),
    [anon_sym_STAR_STAR] = ACTIONS(757),
    [anon_sym_CARET] = ACTIONS(757),
    [aux_sym_binary_operator_token1] = ACTIONS(757),
    [anon_sym_PIPE_GT] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(759),
    [anon_sym_DOLLAR] = ACTIONS(757),
    [anon_sym_AT] = ACTIONS(757),
    [aux_sym__hex_literal_token1] = ACTIONS(3702),
    [sym__number_literal] = ACTIONS(3704),
    [anon_sym_SQUOTE] = ACTIONS(3706),
    [anon_sym_DQUOTE] = ACTIONS(3708),
    [sym_return] = ACTIONS(3913),
    [sym_next] = ACTIONS(3913),
    [sym_break] = ACTIONS(3913),
    [sym_true] = ACTIONS(3913),
    [sym_false] = ACTIONS(3913),
    [sym_null] = ACTIONS(3913),
    [sym_inf] = ACTIONS(3913),
    [sym_nan] = ACTIONS(3913),
    [anon_sym_NA] = ACTIONS(3712),
    [anon_sym_NA_integer_] = ACTIONS(3712),
    [anon_sym_NA_real_] = ACTIONS(3712),
    [anon_sym_NA_complex_] = ACTIONS(3712),
    [anon_sym_NA_character_] = ACTIONS(3712),
    [sym_dots] = ACTIONS(3913),
    [sym_dot_dot_i] = ACTIONS(3915),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(757),
    [sym__newline] = ACTIONS(757),
    [sym__raw_string_literal] = ACTIONS(3718),
    [sym__external_else] = ACTIONS(757),
    [sym__external_open_parenthesis] = ACTIONS(3720),
    [sym__external_open_brace] = ACTIONS(3722),
    [sym__external_open_bracket] = ACTIONS(757),
    [sym__external_open_bracket2] = ACTIONS(757),
    [sym__external_close_bracket2] = ACTIONS(757),
  },
  [339] = {
    [sym_function_definition] = STATE(1833),
    [sym_if_statement] = STATE(1833),
    [sym_for_statement] = STATE(1833),
    [sym_while_statement] = STATE(1833),
    [sym_repeat_statement] = STATE(1833),
    [sym_braced_expression] = STATE(1833),
    [sym_parenthesized_expression] = STATE(1833),
    [sym_call] = STATE(1833),
    [sym_subset] = STATE(1833),
    [sym_subset2] = STATE(1833),
    [sym_unary_operator] = STATE(1833),
    [sym_binary_operator] = STATE(1833),
    [sym_extract_operator] = STATE(1833),
    [sym_namespace_operator] = STATE(1833),
    [sym_integer] = STATE(1833),
    [sym_complex] = STATE(1833),
    [sym_float] = STATE(1833),
    [sym__hex_literal] = STATE(2540),
    [sym__float_literal] = STATE(2540),
    [sym_string] = STATE(2541),
    [sym__single_quoted_string] = STATE(2462),
    [sym__double_quoted_string] = STATE(2494),
    [sym_na] = STATE(1833),
    [sym__expression] = STATE(1833),
    [sym__string_or_identifier] = STATE(5128),
    [sym__open_parenthesis] = STATE(246),
    [sym__open_brace] = STATE(173),
    [aux_sym_function_definition_repeat1] = STATE(364),
    [ts_builtin_sym_end] = ACTIONS(531),
    [sym_identifier] = ACTIONS(2943),
    [anon_sym_BSLASH] = ACTIONS(2945),
    [anon_sym_function] = ACTIONS(2947),
    [anon_sym_EQ] = ACTIONS(533),
    [anon_sym_if] = ACTIONS(2949),
    [anon_sym_for] = ACTIONS(2951),
    [anon_sym_while] = ACTIONS(2953),
    [anon_sym_repeat] = ACTIONS(2955),
    [anon_sym_QMARK] = ACTIONS(2957),
    [anon_sym_TILDE] = ACTIONS(2959),
    [anon_sym_BANG] = ACTIONS(2961),
    [anon_sym_PLUS] = ACTIONS(2963),
    [anon_sym_DASH] = ACTIONS(2965),
    [anon_sym_LT_DASH] = ACTIONS(531),
    [anon_sym_LT_LT_DASH] = ACTIONS(531),
    [anon_sym_COLON_EQ] = ACTIONS(531),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_DASH_GT_GT] = ACTIONS(531),
    [anon_sym_PIPE] = ACTIONS(533),
    [anon_sym_AMP] = ACTIONS(533),
    [anon_sym_PIPE_PIPE] = ACTIONS(531),
    [anon_sym_AMP_AMP] = ACTIONS(531),
    [anon_sym_LT] = ACTIONS(533),
    [anon_sym_LT_EQ] = ACTIONS(531),
    [anon_sym_GT] = ACTIONS(533),
    [anon_sym_GT_EQ] = ACTIONS(531),
    [anon_sym_EQ_EQ] = ACTIONS(531),
    [anon_sym_BANG_EQ] = ACTIONS(531),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_SLASH] = ACTIONS(531),
    [anon_sym_STAR_STAR] = ACTIONS(531),
    [anon_sym_CARET] = ACTIONS(531),
    [aux_sym_binary_operator_token1] = ACTIONS(531),
    [anon_sym_PIPE_GT] = ACTIONS(531),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_DOLLAR] = ACTIONS(531),
    [anon_sym_AT] = ACTIONS(531),
    [aux_sym__hex_literal_token1] = ACTIONS(2967),
    [sym__number_literal] = ACTIONS(2969),
    [anon_sym_SQUOTE] = ACTIONS(2971),
    [anon_sym_DQUOTE] = ACTIONS(2973),
    [sym_return] = ACTIONS(3917),
    [sym_next] = ACTIONS(3917),
    [sym_break] = ACTIONS(3917),
    [sym_true] = ACTIONS(3917),
    [sym_false] = ACTIONS(3917),
    [sym_null] = ACTIONS(3917),
    [sym_inf] = ACTIONS(3917),
    [sym_nan] = ACTIONS(3917),
    [anon_sym_NA] = ACTIONS(2977),
    [anon_sym_NA_integer_] = ACTIONS(2977),
    [anon_sym_NA_real_] = ACTIONS(2977),
    [anon_sym_NA_complex_] = ACTIONS(2977),
    [anon_sym_NA_character_] = ACTIONS(2977),
    [sym_dots] = ACTIONS(3917),
    [sym_dot_dot_i] = ACTIONS(3919),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(3921),
    [sym__semicolon] = ACTIONS(531),
    [sym__raw_string_literal] = ACTIONS(2983),
    [sym__external_open_parenthesis] = ACTIONS(2985),
    [sym__external_close_parenthesis] = ACTIONS(531),
    [sym__external_open_brace] = ACTIONS(2989),
    [sym__external_open_bracket] = ACTIONS(531),
    [sym__external_open_bracket2] = ACTIONS(531),
  },
  [340] = {
    [sym_function_definition] = STATE(1479),
    [sym_if_statement] = STATE(1479),
    [sym_for_statement] = STATE(1479),
    [sym_while_statement] = STATE(1479),
    [sym_repeat_statement] = STATE(1479),
    [sym_braced_expression] = STATE(1479),
    [sym_parenthesized_expression] = STATE(1479),
    [sym_call] = STATE(1479),
    [sym_subset] = STATE(1479),
    [sym_subset2] = STATE(1479),
    [sym_unary_operator] = STATE(1479),
    [sym_binary_operator] = STATE(1479),
    [sym_extract_operator] = STATE(1479),
    [sym_namespace_operator] = STATE(1479),
    [sym_integer] = STATE(1479),
    [sym_complex] = STATE(1479),
    [sym_float] = STATE(1479),
    [sym__hex_literal] = STATE(2381),
    [sym__float_literal] = STATE(2381),
    [sym_string] = STATE(2378),
    [sym__single_quoted_string] = STATE(2382),
    [sym__double_quoted_string] = STATE(2383),
    [sym_na] = STATE(1479),
    [sym__expression] = STATE(1479),
    [sym__string_or_identifier] = STATE(5153),
    [sym__open_parenthesis] = STATE(191),
    [sym__open_brace] = STATE(29),
    [aux_sym_function_definition_repeat1] = STATE(342),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_BSLASH] = ACTIONS(3680),
    [anon_sym_function] = ACTIONS(3682),
    [anon_sym_EQ] = ACTIONS(533),
    [anon_sym_if] = ACTIONS(3684),
    [anon_sym_for] = ACTIONS(3686),
    [anon_sym_while] = ACTIONS(3688),
    [anon_sym_repeat] = ACTIONS(3690),
    [anon_sym_QMARK] = ACTIONS(3692),
    [anon_sym_TILDE] = ACTIONS(3694),
    [anon_sym_BANG] = ACTIONS(3696),
    [anon_sym_PLUS] = ACTIONS(3698),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_LT_DASH] = ACTIONS(531),
    [anon_sym_LT_LT_DASH] = ACTIONS(531),
    [anon_sym_COLON_EQ] = ACTIONS(531),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_DASH_GT_GT] = ACTIONS(531),
    [anon_sym_PIPE] = ACTIONS(533),
    [anon_sym_AMP] = ACTIONS(533),
    [anon_sym_PIPE_PIPE] = ACTIONS(531),
    [anon_sym_AMP_AMP] = ACTIONS(531),
    [anon_sym_LT] = ACTIONS(533),
    [anon_sym_LT_EQ] = ACTIONS(531),
    [anon_sym_GT] = ACTIONS(533),
    [anon_sym_GT_EQ] = ACTIONS(531),
    [anon_sym_EQ_EQ] = ACTIONS(531),
    [anon_sym_BANG_EQ] = ACTIONS(531),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_SLASH] = ACTIONS(531),
    [anon_sym_STAR_STAR] = ACTIONS(531),
    [anon_sym_CARET] = ACTIONS(531),
    [aux_sym_binary_operator_token1] = ACTIONS(531),
    [anon_sym_PIPE_GT] = ACTIONS(531),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_DOLLAR] = ACTIONS(531),
    [anon_sym_AT] = ACTIONS(531),
    [aux_sym__hex_literal_token1] = ACTIONS(3702),
    [sym__number_literal] = ACTIONS(3704),
    [anon_sym_SQUOTE] = ACTIONS(3706),
    [anon_sym_DQUOTE] = ACTIONS(3708),
    [sym_return] = ACTIONS(3923),
    [sym_next] = ACTIONS(3923),
    [sym_break] = ACTIONS(3923),
    [sym_true] = ACTIONS(3923),
    [sym_false] = ACTIONS(3923),
    [sym_null] = ACTIONS(3923),
    [sym_inf] = ACTIONS(3923),
    [sym_nan] = ACTIONS(3923),
    [anon_sym_NA] = ACTIONS(3712),
    [anon_sym_NA_integer_] = ACTIONS(3712),
    [anon_sym_NA_real_] = ACTIONS(3712),
    [anon_sym_NA_complex_] = ACTIONS(3712),
    [anon_sym_NA_character_] = ACTIONS(3712),
    [sym_dots] = ACTIONS(3923),
    [sym_dot_dot_i] = ACTIONS(3925),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(531),
    [sym__newline] = ACTIONS(3927),
    [sym__raw_string_literal] = ACTIONS(3718),
    [sym__external_else] = ACTIONS(531),
    [sym__external_open_parenthesis] = ACTIONS(3720),
    [sym__external_open_brace] = ACTIONS(3722),
    [sym__external_open_bracket] = ACTIONS(531),
    [sym__external_open_bracket2] = ACTIONS(531),
    [sym__external_close_bracket2] = ACTIONS(531),
  },
  [341] = {
    [sym_function_definition] = STATE(1319),
    [sym_if_statement] = STATE(1319),
    [sym_for_statement] = STATE(1319),
    [sym_while_statement] = STATE(1319),
    [sym_repeat_statement] = STATE(1319),
    [sym_braced_expression] = STATE(1319),
    [sym_parenthesized_expression] = STATE(1319),
    [sym_call] = STATE(1319),
    [sym_subset] = STATE(1319),
    [sym_subset2] = STATE(1319),
    [sym_unary_operator] = STATE(1319),
    [sym_binary_operator] = STATE(1319),
    [sym_extract_operator] = STATE(1319),
    [sym_namespace_operator] = STATE(1319),
    [sym_integer] = STATE(1319),
    [sym_complex] = STATE(1319),
    [sym_float] = STATE(1319),
    [sym__hex_literal] = STATE(2523),
    [sym__float_literal] = STATE(2523),
    [sym_string] = STATE(2522),
    [sym__single_quoted_string] = STATE(2528),
    [sym__double_quoted_string] = STATE(2529),
    [sym_na] = STATE(1319),
    [sym__expression] = STATE(1319),
    [sym__string_or_identifier] = STATE(5126),
    [sym__open_parenthesis] = STATE(178),
    [sym__open_brace] = STATE(244),
    [aux_sym_function_definition_repeat1] = STATE(332),
    [ts_builtin_sym_end] = ACTIONS(377),
    [sym_identifier] = ACTIONS(2826),
    [anon_sym_BSLASH] = ACTIONS(2828),
    [anon_sym_function] = ACTIONS(2830),
    [anon_sym_EQ] = ACTIONS(379),
    [anon_sym_if] = ACTIONS(2832),
    [anon_sym_for] = ACTIONS(2834),
    [anon_sym_while] = ACTIONS(2836),
    [anon_sym_repeat] = ACTIONS(2838),
    [anon_sym_QMARK] = ACTIONS(2840),
    [anon_sym_TILDE] = ACTIONS(2842),
    [anon_sym_BANG] = ACTIONS(2844),
    [anon_sym_PLUS] = ACTIONS(2846),
    [anon_sym_DASH] = ACTIONS(2848),
    [anon_sym_LT_DASH] = ACTIONS(377),
    [anon_sym_LT_LT_DASH] = ACTIONS(377),
    [anon_sym_COLON_EQ] = ACTIONS(377),
    [anon_sym_DASH_GT] = ACTIONS(379),
    [anon_sym_DASH_GT_GT] = ACTIONS(377),
    [anon_sym_PIPE] = ACTIONS(379),
    [anon_sym_AMP] = ACTIONS(379),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_LT] = ACTIONS(379),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(379),
    [anon_sym_GT_EQ] = ACTIONS(377),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(379),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_STAR_STAR] = ACTIONS(377),
    [anon_sym_CARET] = ACTIONS(377),
    [aux_sym_binary_operator_token1] = ACTIONS(377),
    [anon_sym_PIPE_GT] = ACTIONS(377),
    [anon_sym_COLON] = ACTIONS(379),
    [anon_sym_DOLLAR] = ACTIONS(377),
    [anon_sym_AT] = ACTIONS(377),
    [aux_sym__hex_literal_token1] = ACTIONS(2850),
    [sym__number_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE] = ACTIONS(2856),
    [sym_return] = ACTIONS(3929),
    [sym_next] = ACTIONS(3929),
    [sym_break] = ACTIONS(3929),
    [sym_true] = ACTIONS(3929),
    [sym_false] = ACTIONS(3929),
    [sym_null] = ACTIONS(3929),
    [sym_inf] = ACTIONS(3929),
    [sym_nan] = ACTIONS(3929),
    [anon_sym_NA] = ACTIONS(2860),
    [anon_sym_NA_integer_] = ACTIONS(2860),
    [anon_sym_NA_real_] = ACTIONS(2860),
    [anon_sym_NA_complex_] = ACTIONS(2860),
    [anon_sym_NA_character_] = ACTIONS(2860),
    [sym_dots] = ACTIONS(3929),
    [sym_dot_dot_i] = ACTIONS(3931),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(3933),
    [sym__semicolon] = ACTIONS(377),
    [sym__raw_string_literal] = ACTIONS(2866),
    [sym__external_open_parenthesis] = ACTIONS(2868),
    [sym__external_open_brace] = ACTIONS(2870),
    [sym__external_close_brace] = ACTIONS(377),
    [sym__external_open_bracket] = ACTIONS(377),
    [sym__external_open_bracket2] = ACTIONS(377),
  },
  [342] = {
    [sym_function_definition] = STATE(1477),
    [sym_if_statement] = STATE(1477),
    [sym_for_statement] = STATE(1477),
    [sym_while_statement] = STATE(1477),
    [sym_repeat_statement] = STATE(1477),
    [sym_braced_expression] = STATE(1477),
    [sym_parenthesized_expression] = STATE(1477),
    [sym_call] = STATE(1477),
    [sym_subset] = STATE(1477),
    [sym_subset2] = STATE(1477),
    [sym_unary_operator] = STATE(1477),
    [sym_binary_operator] = STATE(1477),
    [sym_extract_operator] = STATE(1477),
    [sym_namespace_operator] = STATE(1477),
    [sym_integer] = STATE(1477),
    [sym_complex] = STATE(1477),
    [sym_float] = STATE(1477),
    [sym__hex_literal] = STATE(2381),
    [sym__float_literal] = STATE(2381),
    [sym_string] = STATE(2378),
    [sym__single_quoted_string] = STATE(2382),
    [sym__double_quoted_string] = STATE(2383),
    [sym_na] = STATE(1477),
    [sym__expression] = STATE(1477),
    [sym__string_or_identifier] = STATE(5153),
    [sym__open_parenthesis] = STATE(191),
    [sym__open_brace] = STATE(29),
    [aux_sym_function_definition_repeat1] = STATE(2722),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_BSLASH] = ACTIONS(3680),
    [anon_sym_function] = ACTIONS(3682),
    [anon_sym_EQ] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(3684),
    [anon_sym_for] = ACTIONS(3686),
    [anon_sym_while] = ACTIONS(3688),
    [anon_sym_repeat] = ACTIONS(3690),
    [anon_sym_QMARK] = ACTIONS(3692),
    [anon_sym_TILDE] = ACTIONS(3694),
    [anon_sym_BANG] = ACTIONS(3696),
    [anon_sym_PLUS] = ACTIONS(3698),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_LT_DASH] = ACTIONS(369),
    [anon_sym_LT_LT_DASH] = ACTIONS(369),
    [anon_sym_COLON_EQ] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(371),
    [anon_sym_DASH_GT_GT] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(371),
    [anon_sym_AMP] = ACTIONS(371),
    [anon_sym_PIPE_PIPE] = ACTIONS(369),
    [anon_sym_AMP_AMP] = ACTIONS(369),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_LT_EQ] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_EQ] = ACTIONS(369),
    [anon_sym_EQ_EQ] = ACTIONS(369),
    [anon_sym_BANG_EQ] = ACTIONS(369),
    [anon_sym_STAR] = ACTIONS(371),
    [anon_sym_SLASH] = ACTIONS(369),
    [anon_sym_STAR_STAR] = ACTIONS(369),
    [anon_sym_CARET] = ACTIONS(369),
    [aux_sym_binary_operator_token1] = ACTIONS(369),
    [anon_sym_PIPE_GT] = ACTIONS(369),
    [anon_sym_COLON] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(369),
    [anon_sym_AT] = ACTIONS(369),
    [aux_sym__hex_literal_token1] = ACTIONS(3702),
    [sym__number_literal] = ACTIONS(3704),
    [anon_sym_SQUOTE] = ACTIONS(3706),
    [anon_sym_DQUOTE] = ACTIONS(3708),
    [sym_return] = ACTIONS(3935),
    [sym_next] = ACTIONS(3935),
    [sym_break] = ACTIONS(3935),
    [sym_true] = ACTIONS(3935),
    [sym_false] = ACTIONS(3935),
    [sym_null] = ACTIONS(3935),
    [sym_inf] = ACTIONS(3935),
    [sym_nan] = ACTIONS(3935),
    [anon_sym_NA] = ACTIONS(3712),
    [anon_sym_NA_integer_] = ACTIONS(3712),
    [anon_sym_NA_real_] = ACTIONS(3712),
    [anon_sym_NA_complex_] = ACTIONS(3712),
    [anon_sym_NA_character_] = ACTIONS(3712),
    [sym_dots] = ACTIONS(3935),
    [sym_dot_dot_i] = ACTIONS(3937),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(369),
    [sym__newline] = ACTIONS(369),
    [sym__raw_string_literal] = ACTIONS(3718),
    [sym__external_else] = ACTIONS(369),
    [sym__external_open_parenthesis] = ACTIONS(3720),
    [sym__external_open_brace] = ACTIONS(3722),
    [sym__external_open_bracket] = ACTIONS(369),
    [sym__external_open_bracket2] = ACTIONS(369),
    [sym__external_close_bracket2] = ACTIONS(369),
  },
  [343] = {
    [sym_function_definition] = STATE(1600),
    [sym_if_statement] = STATE(1600),
    [sym_for_statement] = STATE(1600),
    [sym_while_statement] = STATE(1600),
    [sym_repeat_statement] = STATE(1600),
    [sym_braced_expression] = STATE(1600),
    [sym_parenthesized_expression] = STATE(1600),
    [sym_call] = STATE(1600),
    [sym_subset] = STATE(1600),
    [sym_subset2] = STATE(1600),
    [sym_unary_operator] = STATE(1600),
    [sym_binary_operator] = STATE(1600),
    [sym_extract_operator] = STATE(1600),
    [sym_namespace_operator] = STATE(1600),
    [sym_integer] = STATE(1600),
    [sym_complex] = STATE(1600),
    [sym_float] = STATE(1600),
    [sym__hex_literal] = STATE(2523),
    [sym__float_literal] = STATE(2523),
    [sym_string] = STATE(2522),
    [sym__single_quoted_string] = STATE(2528),
    [sym__double_quoted_string] = STATE(2529),
    [sym_na] = STATE(1600),
    [sym__expression] = STATE(1600),
    [sym__string_or_identifier] = STATE(5126),
    [sym__open_parenthesis] = STATE(178),
    [sym__open_brace] = STATE(244),
    [aux_sym_function_definition_repeat1] = STATE(2680),
    [ts_builtin_sym_end] = ACTIONS(369),
    [sym_identifier] = ACTIONS(2826),
    [anon_sym_BSLASH] = ACTIONS(2828),
    [anon_sym_function] = ACTIONS(2830),
    [anon_sym_EQ] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(2832),
    [anon_sym_for] = ACTIONS(2834),
    [anon_sym_while] = ACTIONS(2836),
    [anon_sym_repeat] = ACTIONS(2838),
    [anon_sym_QMARK] = ACTIONS(2840),
    [anon_sym_TILDE] = ACTIONS(2842),
    [anon_sym_BANG] = ACTIONS(2844),
    [anon_sym_PLUS] = ACTIONS(2846),
    [anon_sym_DASH] = ACTIONS(2848),
    [anon_sym_LT_DASH] = ACTIONS(369),
    [anon_sym_LT_LT_DASH] = ACTIONS(369),
    [anon_sym_COLON_EQ] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(371),
    [anon_sym_DASH_GT_GT] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(371),
    [anon_sym_AMP] = ACTIONS(371),
    [anon_sym_PIPE_PIPE] = ACTIONS(369),
    [anon_sym_AMP_AMP] = ACTIONS(369),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_LT_EQ] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_EQ] = ACTIONS(369),
    [anon_sym_EQ_EQ] = ACTIONS(369),
    [anon_sym_BANG_EQ] = ACTIONS(369),
    [anon_sym_STAR] = ACTIONS(371),
    [anon_sym_SLASH] = ACTIONS(369),
    [anon_sym_STAR_STAR] = ACTIONS(369),
    [anon_sym_CARET] = ACTIONS(369),
    [aux_sym_binary_operator_token1] = ACTIONS(369),
    [anon_sym_PIPE_GT] = ACTIONS(369),
    [anon_sym_COLON] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(369),
    [anon_sym_AT] = ACTIONS(369),
    [aux_sym__hex_literal_token1] = ACTIONS(2850),
    [sym__number_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE] = ACTIONS(2856),
    [sym_return] = ACTIONS(3939),
    [sym_next] = ACTIONS(3939),
    [sym_break] = ACTIONS(3939),
    [sym_true] = ACTIONS(3939),
    [sym_false] = ACTIONS(3939),
    [sym_null] = ACTIONS(3939),
    [sym_inf] = ACTIONS(3939),
    [sym_nan] = ACTIONS(3939),
    [anon_sym_NA] = ACTIONS(2860),
    [anon_sym_NA_integer_] = ACTIONS(2860),
    [anon_sym_NA_real_] = ACTIONS(2860),
    [anon_sym_NA_complex_] = ACTIONS(2860),
    [anon_sym_NA_character_] = ACTIONS(2860),
    [sym_dots] = ACTIONS(3939),
    [sym_dot_dot_i] = ACTIONS(3941),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(369),
    [sym__semicolon] = ACTIONS(369),
    [sym__raw_string_literal] = ACTIONS(2866),
    [sym__external_open_parenthesis] = ACTIONS(2868),
    [sym__external_open_brace] = ACTIONS(2870),
    [sym__external_close_brace] = ACTIONS(369),
    [sym__external_open_bracket] = ACTIONS(369),
    [sym__external_open_bracket2] = ACTIONS(369),
  },
  [344] = {
    [sym_function_definition] = STATE(1476),
    [sym_if_statement] = STATE(1476),
    [sym_for_statement] = STATE(1476),
    [sym_while_statement] = STATE(1476),
    [sym_repeat_statement] = STATE(1476),
    [sym_braced_expression] = STATE(1476),
    [sym_parenthesized_expression] = STATE(1476),
    [sym_call] = STATE(1476),
    [sym_subset] = STATE(1476),
    [sym_subset2] = STATE(1476),
    [sym_unary_operator] = STATE(1476),
    [sym_binary_operator] = STATE(1476),
    [sym_extract_operator] = STATE(1476),
    [sym_namespace_operator] = STATE(1476),
    [sym_integer] = STATE(1476),
    [sym_complex] = STATE(1476),
    [sym_float] = STATE(1476),
    [sym__hex_literal] = STATE(2381),
    [sym__float_literal] = STATE(2381),
    [sym_string] = STATE(2378),
    [sym__single_quoted_string] = STATE(2382),
    [sym__double_quoted_string] = STATE(2383),
    [sym_na] = STATE(1476),
    [sym__expression] = STATE(1476),
    [sym__string_or_identifier] = STATE(5153),
    [sym__open_parenthesis] = STATE(191),
    [sym__open_brace] = STATE(29),
    [aux_sym_function_definition_repeat1] = STATE(346),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_BSLASH] = ACTIONS(3680),
    [anon_sym_function] = ACTIONS(3682),
    [anon_sym_EQ] = ACTIONS(379),
    [anon_sym_if] = ACTIONS(3684),
    [anon_sym_for] = ACTIONS(3686),
    [anon_sym_while] = ACTIONS(3688),
    [anon_sym_repeat] = ACTIONS(3690),
    [anon_sym_QMARK] = ACTIONS(3692),
    [anon_sym_TILDE] = ACTIONS(3694),
    [anon_sym_BANG] = ACTIONS(3696),
    [anon_sym_PLUS] = ACTIONS(3698),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_LT_DASH] = ACTIONS(377),
    [anon_sym_LT_LT_DASH] = ACTIONS(377),
    [anon_sym_COLON_EQ] = ACTIONS(377),
    [anon_sym_DASH_GT] = ACTIONS(379),
    [anon_sym_DASH_GT_GT] = ACTIONS(377),
    [anon_sym_PIPE] = ACTIONS(379),
    [anon_sym_AMP] = ACTIONS(379),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_LT] = ACTIONS(379),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(379),
    [anon_sym_GT_EQ] = ACTIONS(377),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(379),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_STAR_STAR] = ACTIONS(377),
    [anon_sym_CARET] = ACTIONS(377),
    [aux_sym_binary_operator_token1] = ACTIONS(377),
    [anon_sym_PIPE_GT] = ACTIONS(377),
    [anon_sym_COLON] = ACTIONS(379),
    [anon_sym_DOLLAR] = ACTIONS(377),
    [anon_sym_AT] = ACTIONS(377),
    [aux_sym__hex_literal_token1] = ACTIONS(3702),
    [sym__number_literal] = ACTIONS(3704),
    [anon_sym_SQUOTE] = ACTIONS(3706),
    [anon_sym_DQUOTE] = ACTIONS(3708),
    [sym_return] = ACTIONS(3943),
    [sym_next] = ACTIONS(3943),
    [sym_break] = ACTIONS(3943),
    [sym_true] = ACTIONS(3943),
    [sym_false] = ACTIONS(3943),
    [sym_null] = ACTIONS(3943),
    [sym_inf] = ACTIONS(3943),
    [sym_nan] = ACTIONS(3943),
    [anon_sym_NA] = ACTIONS(3712),
    [anon_sym_NA_integer_] = ACTIONS(3712),
    [anon_sym_NA_real_] = ACTIONS(3712),
    [anon_sym_NA_complex_] = ACTIONS(3712),
    [anon_sym_NA_character_] = ACTIONS(3712),
    [sym_dots] = ACTIONS(3943),
    [sym_dot_dot_i] = ACTIONS(3945),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(377),
    [sym__newline] = ACTIONS(3947),
    [sym__raw_string_literal] = ACTIONS(3718),
    [sym__external_else] = ACTIONS(377),
    [sym__external_open_parenthesis] = ACTIONS(3720),
    [sym__external_open_brace] = ACTIONS(3722),
    [sym__external_open_bracket] = ACTIONS(377),
    [sym__external_open_bracket2] = ACTIONS(377),
    [sym__external_close_bracket2] = ACTIONS(377),
  },
  [345] = {
    [sym_function_definition] = STATE(1468),
    [sym_if_statement] = STATE(1468),
    [sym_for_statement] = STATE(1468),
    [sym_while_statement] = STATE(1468),
    [sym_repeat_statement] = STATE(1468),
    [sym_braced_expression] = STATE(1468),
    [sym_parenthesized_expression] = STATE(1468),
    [sym_call] = STATE(1468),
    [sym_subset] = STATE(1468),
    [sym_subset2] = STATE(1468),
    [sym_unary_operator] = STATE(1468),
    [sym_binary_operator] = STATE(1468),
    [sym_extract_operator] = STATE(1468),
    [sym_namespace_operator] = STATE(1468),
    [sym_integer] = STATE(1468),
    [sym_complex] = STATE(1468),
    [sym_float] = STATE(1468),
    [sym__hex_literal] = STATE(2381),
    [sym__float_literal] = STATE(2381),
    [sym_string] = STATE(2378),
    [sym__single_quoted_string] = STATE(2382),
    [sym__double_quoted_string] = STATE(2383),
    [sym_na] = STATE(1468),
    [sym__expression] = STATE(1468),
    [sym__string_or_identifier] = STATE(5153),
    [sym__open_parenthesis] = STATE(191),
    [sym__open_brace] = STATE(29),
    [aux_sym_function_definition_repeat1] = STATE(347),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_BSLASH] = ACTIONS(3680),
    [anon_sym_function] = ACTIONS(3682),
    [anon_sym_EQ] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(3684),
    [anon_sym_for] = ACTIONS(3686),
    [anon_sym_while] = ACTIONS(3688),
    [anon_sym_repeat] = ACTIONS(3690),
    [anon_sym_QMARK] = ACTIONS(3692),
    [anon_sym_TILDE] = ACTIONS(3694),
    [anon_sym_BANG] = ACTIONS(3696),
    [anon_sym_PLUS] = ACTIONS(3698),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_LT_DASH] = ACTIONS(387),
    [anon_sym_LT_LT_DASH] = ACTIONS(387),
    [anon_sym_COLON_EQ] = ACTIONS(387),
    [anon_sym_DASH_GT] = ACTIONS(389),
    [anon_sym_DASH_GT_GT] = ACTIONS(387),
    [anon_sym_PIPE] = ACTIONS(389),
    [anon_sym_AMP] = ACTIONS(389),
    [anon_sym_PIPE_PIPE] = ACTIONS(387),
    [anon_sym_AMP_AMP] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(389),
    [anon_sym_LT_EQ] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(389),
    [anon_sym_GT_EQ] = ACTIONS(387),
    [anon_sym_EQ_EQ] = ACTIONS(387),
    [anon_sym_BANG_EQ] = ACTIONS(387),
    [anon_sym_STAR] = ACTIONS(389),
    [anon_sym_SLASH] = ACTIONS(387),
    [anon_sym_STAR_STAR] = ACTIONS(387),
    [anon_sym_CARET] = ACTIONS(387),
    [aux_sym_binary_operator_token1] = ACTIONS(387),
    [anon_sym_PIPE_GT] = ACTIONS(387),
    [anon_sym_COLON] = ACTIONS(389),
    [anon_sym_DOLLAR] = ACTIONS(387),
    [anon_sym_AT] = ACTIONS(387),
    [aux_sym__hex_literal_token1] = ACTIONS(3702),
    [sym__number_literal] = ACTIONS(3704),
    [anon_sym_SQUOTE] = ACTIONS(3706),
    [anon_sym_DQUOTE] = ACTIONS(3708),
    [sym_return] = ACTIONS(3949),
    [sym_next] = ACTIONS(3949),
    [sym_break] = ACTIONS(3949),
    [sym_true] = ACTIONS(3949),
    [sym_false] = ACTIONS(3949),
    [sym_null] = ACTIONS(3949),
    [sym_inf] = ACTIONS(3949),
    [sym_nan] = ACTIONS(3949),
    [anon_sym_NA] = ACTIONS(3712),
    [anon_sym_NA_integer_] = ACTIONS(3712),
    [anon_sym_NA_real_] = ACTIONS(3712),
    [anon_sym_NA_complex_] = ACTIONS(3712),
    [anon_sym_NA_character_] = ACTIONS(3712),
    [sym_dots] = ACTIONS(3949),
    [sym_dot_dot_i] = ACTIONS(3951),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(387),
    [sym__newline] = ACTIONS(3953),
    [sym__raw_string_literal] = ACTIONS(3718),
    [sym__external_else] = ACTIONS(387),
    [sym__external_open_parenthesis] = ACTIONS(3720),
    [sym__external_open_brace] = ACTIONS(3722),
    [sym__external_open_bracket] = ACTIONS(387),
    [sym__external_open_bracket2] = ACTIONS(387),
    [sym__external_close_bracket2] = ACTIONS(387),
  },
  [346] = {
    [sym_function_definition] = STATE(1460),
    [sym_if_statement] = STATE(1460),
    [sym_for_statement] = STATE(1460),
    [sym_while_statement] = STATE(1460),
    [sym_repeat_statement] = STATE(1460),
    [sym_braced_expression] = STATE(1460),
    [sym_parenthesized_expression] = STATE(1460),
    [sym_call] = STATE(1460),
    [sym_subset] = STATE(1460),
    [sym_subset2] = STATE(1460),
    [sym_unary_operator] = STATE(1460),
    [sym_binary_operator] = STATE(1460),
    [sym_extract_operator] = STATE(1460),
    [sym_namespace_operator] = STATE(1460),
    [sym_integer] = STATE(1460),
    [sym_complex] = STATE(1460),
    [sym_float] = STATE(1460),
    [sym__hex_literal] = STATE(2381),
    [sym__float_literal] = STATE(2381),
    [sym_string] = STATE(2378),
    [sym__single_quoted_string] = STATE(2382),
    [sym__double_quoted_string] = STATE(2383),
    [sym_na] = STATE(1460),
    [sym__expression] = STATE(1460),
    [sym__string_or_identifier] = STATE(5153),
    [sym__open_parenthesis] = STATE(191),
    [sym__open_brace] = STATE(29),
    [aux_sym_function_definition_repeat1] = STATE(2722),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_BSLASH] = ACTIONS(3680),
    [anon_sym_function] = ACTIONS(3682),
    [anon_sym_EQ] = ACTIONS(399),
    [anon_sym_if] = ACTIONS(3684),
    [anon_sym_for] = ACTIONS(3686),
    [anon_sym_while] = ACTIONS(3688),
    [anon_sym_repeat] = ACTIONS(3690),
    [anon_sym_QMARK] = ACTIONS(3692),
    [anon_sym_TILDE] = ACTIONS(3694),
    [anon_sym_BANG] = ACTIONS(3696),
    [anon_sym_PLUS] = ACTIONS(3698),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_LT_DASH] = ACTIONS(397),
    [anon_sym_LT_LT_DASH] = ACTIONS(397),
    [anon_sym_COLON_EQ] = ACTIONS(397),
    [anon_sym_DASH_GT] = ACTIONS(399),
    [anon_sym_DASH_GT_GT] = ACTIONS(397),
    [anon_sym_PIPE] = ACTIONS(399),
    [anon_sym_AMP] = ACTIONS(399),
    [anon_sym_PIPE_PIPE] = ACTIONS(397),
    [anon_sym_AMP_AMP] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(399),
    [anon_sym_LT_EQ] = ACTIONS(397),
    [anon_sym_GT] = ACTIONS(399),
    [anon_sym_GT_EQ] = ACTIONS(397),
    [anon_sym_EQ_EQ] = ACTIONS(397),
    [anon_sym_BANG_EQ] = ACTIONS(397),
    [anon_sym_STAR] = ACTIONS(399),
    [anon_sym_SLASH] = ACTIONS(397),
    [anon_sym_STAR_STAR] = ACTIONS(397),
    [anon_sym_CARET] = ACTIONS(397),
    [aux_sym_binary_operator_token1] = ACTIONS(397),
    [anon_sym_PIPE_GT] = ACTIONS(397),
    [anon_sym_COLON] = ACTIONS(399),
    [anon_sym_DOLLAR] = ACTIONS(397),
    [anon_sym_AT] = ACTIONS(397),
    [aux_sym__hex_literal_token1] = ACTIONS(3702),
    [sym__number_literal] = ACTIONS(3704),
    [anon_sym_SQUOTE] = ACTIONS(3706),
    [anon_sym_DQUOTE] = ACTIONS(3708),
    [sym_return] = ACTIONS(3955),
    [sym_next] = ACTIONS(3955),
    [sym_break] = ACTIONS(3955),
    [sym_true] = ACTIONS(3955),
    [sym_false] = ACTIONS(3955),
    [sym_null] = ACTIONS(3955),
    [sym_inf] = ACTIONS(3955),
    [sym_nan] = ACTIONS(3955),
    [anon_sym_NA] = ACTIONS(3712),
    [anon_sym_NA_integer_] = ACTIONS(3712),
    [anon_sym_NA_real_] = ACTIONS(3712),
    [anon_sym_NA_complex_] = ACTIONS(3712),
    [anon_sym_NA_character_] = ACTIONS(3712),
    [sym_dots] = ACTIONS(3955),
    [sym_dot_dot_i] = ACTIONS(3957),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(397),
    [sym__newline] = ACTIONS(397),
    [sym__raw_string_literal] = ACTIONS(3718),
    [sym__external_else] = ACTIONS(397),
    [sym__external_open_parenthesis] = ACTIONS(3720),
    [sym__external_open_brace] = ACTIONS(3722),
    [sym__external_open_bracket] = ACTIONS(397),
    [sym__external_open_bracket2] = ACTIONS(397),
    [sym__external_close_bracket2] = ACTIONS(397),
  },
  [347] = {
    [sym_function_definition] = STATE(1454),
    [sym_if_statement] = STATE(1454),
    [sym_for_statement] = STATE(1454),
    [sym_while_statement] = STATE(1454),
    [sym_repeat_statement] = STATE(1454),
    [sym_braced_expression] = STATE(1454),
    [sym_parenthesized_expression] = STATE(1454),
    [sym_call] = STATE(1454),
    [sym_subset] = STATE(1454),
    [sym_subset2] = STATE(1454),
    [sym_unary_operator] = STATE(1454),
    [sym_binary_operator] = STATE(1454),
    [sym_extract_operator] = STATE(1454),
    [sym_namespace_operator] = STATE(1454),
    [sym_integer] = STATE(1454),
    [sym_complex] = STATE(1454),
    [sym_float] = STATE(1454),
    [sym__hex_literal] = STATE(2381),
    [sym__float_literal] = STATE(2381),
    [sym_string] = STATE(2378),
    [sym__single_quoted_string] = STATE(2382),
    [sym__double_quoted_string] = STATE(2383),
    [sym_na] = STATE(1454),
    [sym__expression] = STATE(1454),
    [sym__string_or_identifier] = STATE(5153),
    [sym__open_parenthesis] = STATE(191),
    [sym__open_brace] = STATE(29),
    [aux_sym_function_definition_repeat1] = STATE(2722),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_BSLASH] = ACTIONS(3680),
    [anon_sym_function] = ACTIONS(3682),
    [anon_sym_EQ] = ACTIONS(455),
    [anon_sym_if] = ACTIONS(3684),
    [anon_sym_for] = ACTIONS(3686),
    [anon_sym_while] = ACTIONS(3688),
    [anon_sym_repeat] = ACTIONS(3690),
    [anon_sym_QMARK] = ACTIONS(3692),
    [anon_sym_TILDE] = ACTIONS(3694),
    [anon_sym_BANG] = ACTIONS(3696),
    [anon_sym_PLUS] = ACTIONS(3698),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [anon_sym_LT_LT_DASH] = ACTIONS(453),
    [anon_sym_COLON_EQ] = ACTIONS(453),
    [anon_sym_DASH_GT] = ACTIONS(455),
    [anon_sym_DASH_GT_GT] = ACTIONS(453),
    [anon_sym_PIPE] = ACTIONS(455),
    [anon_sym_AMP] = ACTIONS(455),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(455),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_GT] = ACTIONS(455),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(453),
    [anon_sym_STAR] = ACTIONS(455),
    [anon_sym_SLASH] = ACTIONS(453),
    [anon_sym_STAR_STAR] = ACTIONS(453),
    [anon_sym_CARET] = ACTIONS(453),
    [aux_sym_binary_operator_token1] = ACTIONS(453),
    [anon_sym_PIPE_GT] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(455),
    [anon_sym_DOLLAR] = ACTIONS(453),
    [anon_sym_AT] = ACTIONS(453),
    [aux_sym__hex_literal_token1] = ACTIONS(3702),
    [sym__number_literal] = ACTIONS(3704),
    [anon_sym_SQUOTE] = ACTIONS(3706),
    [anon_sym_DQUOTE] = ACTIONS(3708),
    [sym_return] = ACTIONS(3959),
    [sym_next] = ACTIONS(3959),
    [sym_break] = ACTIONS(3959),
    [sym_true] = ACTIONS(3959),
    [sym_false] = ACTIONS(3959),
    [sym_null] = ACTIONS(3959),
    [sym_inf] = ACTIONS(3959),
    [sym_nan] = ACTIONS(3959),
    [anon_sym_NA] = ACTIONS(3712),
    [anon_sym_NA_integer_] = ACTIONS(3712),
    [anon_sym_NA_real_] = ACTIONS(3712),
    [anon_sym_NA_complex_] = ACTIONS(3712),
    [anon_sym_NA_character_] = ACTIONS(3712),
    [sym_dots] = ACTIONS(3959),
    [sym_dot_dot_i] = ACTIONS(3961),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(453),
    [sym__newline] = ACTIONS(453),
    [sym__raw_string_literal] = ACTIONS(3718),
    [sym__external_else] = ACTIONS(453),
    [sym__external_open_parenthesis] = ACTIONS(3720),
    [sym__external_open_brace] = ACTIONS(3722),
    [sym__external_open_bracket] = ACTIONS(453),
    [sym__external_open_bracket2] = ACTIONS(453),
    [sym__external_close_bracket2] = ACTIONS(453),
  },
  [348] = {
    [sym_function_definition] = STATE(1639),
    [sym_if_statement] = STATE(1639),
    [sym_for_statement] = STATE(1639),
    [sym_while_statement] = STATE(1639),
    [sym_repeat_statement] = STATE(1639),
    [sym_braced_expression] = STATE(1639),
    [sym_parenthesized_expression] = STATE(1639),
    [sym_call] = STATE(1639),
    [sym_subset] = STATE(1639),
    [sym_subset2] = STATE(1639),
    [sym_unary_operator] = STATE(1639),
    [sym_binary_operator] = STATE(1639),
    [sym_extract_operator] = STATE(1639),
    [sym_namespace_operator] = STATE(1639),
    [sym_integer] = STATE(1639),
    [sym_complex] = STATE(1639),
    [sym_float] = STATE(1639),
    [sym__hex_literal] = STATE(2412),
    [sym__float_literal] = STATE(2412),
    [sym_string] = STATE(2397),
    [sym__single_quoted_string] = STATE(2430),
    [sym__double_quoted_string] = STATE(2466),
    [sym_na] = STATE(1639),
    [sym__expression] = STATE(1639),
    [sym__string_or_identifier] = STATE(5142),
    [sym__open_parenthesis] = STATE(210),
    [sym__open_brace] = STATE(74),
    [aux_sym_function_definition_repeat1] = STATE(352),
    [sym_identifier] = ACTIONS(2483),
    [anon_sym_BSLASH] = ACTIONS(2485),
    [anon_sym_function] = ACTIONS(2487),
    [anon_sym_EQ] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(2489),
    [anon_sym_for] = ACTIONS(2491),
    [anon_sym_while] = ACTIONS(2493),
    [anon_sym_repeat] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(2497),
    [anon_sym_TILDE] = ACTIONS(2499),
    [anon_sym_BANG] = ACTIONS(2501),
    [anon_sym_PLUS] = ACTIONS(2503),
    [anon_sym_DASH] = ACTIONS(2505),
    [anon_sym_LT_DASH] = ACTIONS(263),
    [anon_sym_LT_LT_DASH] = ACTIONS(263),
    [anon_sym_COLON_EQ] = ACTIONS(263),
    [anon_sym_DASH_GT] = ACTIONS(265),
    [anon_sym_DASH_GT_GT] = ACTIONS(263),
    [anon_sym_PIPE] = ACTIONS(265),
    [anon_sym_AMP] = ACTIONS(265),
    [anon_sym_PIPE_PIPE] = ACTIONS(263),
    [anon_sym_AMP_AMP] = ACTIONS(263),
    [anon_sym_LT] = ACTIONS(265),
    [anon_sym_LT_EQ] = ACTIONS(263),
    [anon_sym_GT] = ACTIONS(265),
    [anon_sym_GT_EQ] = ACTIONS(263),
    [anon_sym_EQ_EQ] = ACTIONS(263),
    [anon_sym_BANG_EQ] = ACTIONS(263),
    [anon_sym_STAR] = ACTIONS(265),
    [anon_sym_SLASH] = ACTIONS(263),
    [anon_sym_STAR_STAR] = ACTIONS(263),
    [anon_sym_CARET] = ACTIONS(263),
    [aux_sym_binary_operator_token1] = ACTIONS(263),
    [anon_sym_PIPE_GT] = ACTIONS(263),
    [anon_sym_COLON] = ACTIONS(265),
    [anon_sym_DOLLAR] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(263),
    [aux_sym__hex_literal_token1] = ACTIONS(2507),
    [sym__number_literal] = ACTIONS(2509),
    [anon_sym_SQUOTE] = ACTIONS(2511),
    [anon_sym_DQUOTE] = ACTIONS(2513),
    [sym_return] = ACTIONS(3963),
    [sym_next] = ACTIONS(3963),
    [sym_break] = ACTIONS(3963),
    [sym_true] = ACTIONS(3963),
    [sym_false] = ACTIONS(3963),
    [sym_null] = ACTIONS(3963),
    [sym_inf] = ACTIONS(3963),
    [sym_nan] = ACTIONS(3963),
    [anon_sym_NA] = ACTIONS(2517),
    [anon_sym_NA_integer_] = ACTIONS(2517),
    [anon_sym_NA_real_] = ACTIONS(2517),
    [anon_sym_NA_complex_] = ACTIONS(2517),
    [anon_sym_NA_character_] = ACTIONS(2517),
    [sym_dots] = ACTIONS(3963),
    [sym_dot_dot_i] = ACTIONS(3965),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(263),
    [sym__newline] = ACTIONS(3967),
    [sym__raw_string_literal] = ACTIONS(2523),
    [sym__external_open_parenthesis] = ACTIONS(2525),
    [sym__external_close_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(2529),
    [sym__external_open_bracket] = ACTIONS(263),
    [sym__external_open_bracket2] = ACTIONS(263),
    [sym__external_close_bracket2] = ACTIONS(263),
  },
  [349] = {
    [sym_function_definition] = STATE(1451),
    [sym_if_statement] = STATE(1451),
    [sym_for_statement] = STATE(1451),
    [sym_while_statement] = STATE(1451),
    [sym_repeat_statement] = STATE(1451),
    [sym_braced_expression] = STATE(1451),
    [sym_parenthesized_expression] = STATE(1451),
    [sym_call] = STATE(1451),
    [sym_subset] = STATE(1451),
    [sym_subset2] = STATE(1451),
    [sym_unary_operator] = STATE(1451),
    [sym_binary_operator] = STATE(1451),
    [sym_extract_operator] = STATE(1451),
    [sym_namespace_operator] = STATE(1451),
    [sym_integer] = STATE(1451),
    [sym_complex] = STATE(1451),
    [sym_float] = STATE(1451),
    [sym__hex_literal] = STATE(2381),
    [sym__float_literal] = STATE(2381),
    [sym_string] = STATE(2378),
    [sym__single_quoted_string] = STATE(2382),
    [sym__double_quoted_string] = STATE(2383),
    [sym_na] = STATE(1451),
    [sym__expression] = STATE(1451),
    [sym__string_or_identifier] = STATE(5153),
    [sym__open_parenthesis] = STATE(191),
    [sym__open_brace] = STATE(29),
    [aux_sym_function_definition_repeat1] = STATE(353),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_BSLASH] = ACTIONS(3680),
    [anon_sym_function] = ACTIONS(3682),
    [anon_sym_EQ] = ACTIONS(463),
    [anon_sym_if] = ACTIONS(3684),
    [anon_sym_for] = ACTIONS(3686),
    [anon_sym_while] = ACTIONS(3688),
    [anon_sym_repeat] = ACTIONS(3690),
    [anon_sym_QMARK] = ACTIONS(3692),
    [anon_sym_TILDE] = ACTIONS(3694),
    [anon_sym_BANG] = ACTIONS(3696),
    [anon_sym_PLUS] = ACTIONS(3698),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_LT_DASH] = ACTIONS(461),
    [anon_sym_LT_LT_DASH] = ACTIONS(461),
    [anon_sym_COLON_EQ] = ACTIONS(461),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_DASH_GT_GT] = ACTIONS(461),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_PIPE_PIPE] = ACTIONS(461),
    [anon_sym_AMP_AMP] = ACTIONS(461),
    [anon_sym_LT] = ACTIONS(463),
    [anon_sym_LT_EQ] = ACTIONS(461),
    [anon_sym_GT] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(461),
    [anon_sym_EQ_EQ] = ACTIONS(461),
    [anon_sym_BANG_EQ] = ACTIONS(461),
    [anon_sym_STAR] = ACTIONS(463),
    [anon_sym_SLASH] = ACTIONS(461),
    [anon_sym_STAR_STAR] = ACTIONS(461),
    [anon_sym_CARET] = ACTIONS(461),
    [aux_sym_binary_operator_token1] = ACTIONS(461),
    [anon_sym_PIPE_GT] = ACTIONS(461),
    [anon_sym_COLON] = ACTIONS(463),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_AT] = ACTIONS(461),
    [aux_sym__hex_literal_token1] = ACTIONS(3702),
    [sym__number_literal] = ACTIONS(3704),
    [anon_sym_SQUOTE] = ACTIONS(3706),
    [anon_sym_DQUOTE] = ACTIONS(3708),
    [sym_return] = ACTIONS(3969),
    [sym_next] = ACTIONS(3969),
    [sym_break] = ACTIONS(3969),
    [sym_true] = ACTIONS(3969),
    [sym_false] = ACTIONS(3969),
    [sym_null] = ACTIONS(3969),
    [sym_inf] = ACTIONS(3969),
    [sym_nan] = ACTIONS(3969),
    [anon_sym_NA] = ACTIONS(3712),
    [anon_sym_NA_integer_] = ACTIONS(3712),
    [anon_sym_NA_real_] = ACTIONS(3712),
    [anon_sym_NA_complex_] = ACTIONS(3712),
    [anon_sym_NA_character_] = ACTIONS(3712),
    [sym_dots] = ACTIONS(3969),
    [sym_dot_dot_i] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(461),
    [sym__newline] = ACTIONS(3973),
    [sym__raw_string_literal] = ACTIONS(3718),
    [sym__external_else] = ACTIONS(461),
    [sym__external_open_parenthesis] = ACTIONS(3720),
    [sym__external_open_brace] = ACTIONS(3722),
    [sym__external_open_bracket] = ACTIONS(461),
    [sym__external_open_bracket2] = ACTIONS(461),
    [sym__external_close_bracket2] = ACTIONS(461),
  },
  [350] = {
    [sym_function_definition] = STATE(1969),
    [sym_if_statement] = STATE(1969),
    [sym_for_statement] = STATE(1969),
    [sym_while_statement] = STATE(1969),
    [sym_repeat_statement] = STATE(1969),
    [sym_braced_expression] = STATE(1969),
    [sym_parenthesized_expression] = STATE(1969),
    [sym_call] = STATE(1969),
    [sym_subset] = STATE(1969),
    [sym_subset2] = STATE(1969),
    [sym_unary_operator] = STATE(1969),
    [sym_binary_operator] = STATE(1969),
    [sym_extract_operator] = STATE(1969),
    [sym_namespace_operator] = STATE(1969),
    [sym_integer] = STATE(1969),
    [sym_complex] = STATE(1969),
    [sym_float] = STATE(1969),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2673),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(1969),
    [sym__expression] = STATE(1969),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__close_parenthesis] = STATE(2944),
    [sym__open_brace] = STATE(154),
    [aux_sym_parenthesized_expression_repeat1] = STATE(333),
    [sym_identifier] = ACTIONS(3845),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_EQ] = ACTIONS(109),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3867),
    [anon_sym_LT_DASH] = ACTIONS(129),
    [anon_sym_LT_LT_DASH] = ACTIONS(129),
    [anon_sym_COLON_EQ] = ACTIONS(129),
    [anon_sym_DASH_GT] = ACTIONS(109),
    [anon_sym_DASH_GT_GT] = ACTIONS(129),
    [anon_sym_PIPE] = ACTIONS(109),
    [anon_sym_AMP] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_STAR_STAR] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [aux_sym_binary_operator_token1] = ACTIONS(129),
    [anon_sym_PIPE_GT] = ACTIONS(129),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(129),
    [anon_sym_AT] = ACTIONS(129),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(3877),
    [sym_next] = ACTIONS(3877),
    [sym_break] = ACTIONS(3877),
    [sym_true] = ACTIONS(3877),
    [sym_false] = ACTIONS(3877),
    [sym_null] = ACTIONS(3877),
    [sym_inf] = ACTIONS(3877),
    [sym_nan] = ACTIONS(3877),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(3877),
    [sym_dot_dot_i] = ACTIONS(3881),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(129),
    [sym__newline] = ACTIONS(3883),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(3975),
    [sym__external_open_brace] = ACTIONS(3891),
    [sym__external_open_bracket] = ACTIONS(129),
    [sym__external_open_bracket2] = ACTIONS(129),
  },
  [351] = {
    [sym_function_definition] = STATE(1679),
    [sym_if_statement] = STATE(1679),
    [sym_for_statement] = STATE(1679),
    [sym_while_statement] = STATE(1679),
    [sym_repeat_statement] = STATE(1679),
    [sym_braced_expression] = STATE(1679),
    [sym_parenthesized_expression] = STATE(1679),
    [sym_call] = STATE(1679),
    [sym_subset] = STATE(1679),
    [sym_subset2] = STATE(1679),
    [sym_unary_operator] = STATE(1679),
    [sym_binary_operator] = STATE(1679),
    [sym_extract_operator] = STATE(1679),
    [sym_namespace_operator] = STATE(1679),
    [sym_integer] = STATE(1679),
    [sym_complex] = STATE(1679),
    [sym_float] = STATE(1679),
    [sym__hex_literal] = STATE(2412),
    [sym__float_literal] = STATE(2412),
    [sym_string] = STATE(2397),
    [sym__single_quoted_string] = STATE(2430),
    [sym__double_quoted_string] = STATE(2466),
    [sym_na] = STATE(1679),
    [sym__expression] = STATE(1679),
    [sym__string_or_identifier] = STATE(5142),
    [sym__open_parenthesis] = STATE(210),
    [sym__open_brace] = STATE(74),
    [aux_sym_function_definition_repeat1] = STATE(355),
    [sym_identifier] = ACTIONS(2483),
    [anon_sym_BSLASH] = ACTIONS(2485),
    [anon_sym_function] = ACTIONS(2487),
    [anon_sym_EQ] = ACTIONS(543),
    [anon_sym_if] = ACTIONS(2489),
    [anon_sym_for] = ACTIONS(2491),
    [anon_sym_while] = ACTIONS(2493),
    [anon_sym_repeat] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(2497),
    [anon_sym_TILDE] = ACTIONS(2499),
    [anon_sym_BANG] = ACTIONS(2501),
    [anon_sym_PLUS] = ACTIONS(2503),
    [anon_sym_DASH] = ACTIONS(2505),
    [anon_sym_LT_DASH] = ACTIONS(545),
    [anon_sym_LT_LT_DASH] = ACTIONS(545),
    [anon_sym_COLON_EQ] = ACTIONS(545),
    [anon_sym_DASH_GT] = ACTIONS(543),
    [anon_sym_DASH_GT_GT] = ACTIONS(545),
    [anon_sym_PIPE] = ACTIONS(543),
    [anon_sym_AMP] = ACTIONS(543),
    [anon_sym_PIPE_PIPE] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(543),
    [anon_sym_LT_EQ] = ACTIONS(545),
    [anon_sym_GT] = ACTIONS(543),
    [anon_sym_GT_EQ] = ACTIONS(545),
    [anon_sym_EQ_EQ] = ACTIONS(545),
    [anon_sym_BANG_EQ] = ACTIONS(545),
    [anon_sym_STAR] = ACTIONS(543),
    [anon_sym_SLASH] = ACTIONS(545),
    [anon_sym_STAR_STAR] = ACTIONS(545),
    [anon_sym_CARET] = ACTIONS(545),
    [aux_sym_binary_operator_token1] = ACTIONS(545),
    [anon_sym_PIPE_GT] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(543),
    [anon_sym_DOLLAR] = ACTIONS(545),
    [anon_sym_AT] = ACTIONS(545),
    [aux_sym__hex_literal_token1] = ACTIONS(2507),
    [sym__number_literal] = ACTIONS(2509),
    [anon_sym_SQUOTE] = ACTIONS(2511),
    [anon_sym_DQUOTE] = ACTIONS(2513),
    [sym_return] = ACTIONS(3977),
    [sym_next] = ACTIONS(3977),
    [sym_break] = ACTIONS(3977),
    [sym_true] = ACTIONS(3977),
    [sym_false] = ACTIONS(3977),
    [sym_null] = ACTIONS(3977),
    [sym_inf] = ACTIONS(3977),
    [sym_nan] = ACTIONS(3977),
    [anon_sym_NA] = ACTIONS(2517),
    [anon_sym_NA_integer_] = ACTIONS(2517),
    [anon_sym_NA_real_] = ACTIONS(2517),
    [anon_sym_NA_complex_] = ACTIONS(2517),
    [anon_sym_NA_character_] = ACTIONS(2517),
    [sym_dots] = ACTIONS(3977),
    [sym_dot_dot_i] = ACTIONS(3979),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(545),
    [sym__newline] = ACTIONS(3981),
    [sym__raw_string_literal] = ACTIONS(2523),
    [sym__external_open_parenthesis] = ACTIONS(2525),
    [sym__external_close_parenthesis] = ACTIONS(545),
    [sym__external_open_brace] = ACTIONS(2529),
    [sym__external_open_bracket] = ACTIONS(545),
    [sym__external_open_bracket2] = ACTIONS(545),
    [sym__external_close_bracket2] = ACTIONS(545),
  },
  [352] = {
    [sym_function_definition] = STATE(1683),
    [sym_if_statement] = STATE(1683),
    [sym_for_statement] = STATE(1683),
    [sym_while_statement] = STATE(1683),
    [sym_repeat_statement] = STATE(1683),
    [sym_braced_expression] = STATE(1683),
    [sym_parenthesized_expression] = STATE(1683),
    [sym_call] = STATE(1683),
    [sym_subset] = STATE(1683),
    [sym_subset2] = STATE(1683),
    [sym_unary_operator] = STATE(1683),
    [sym_binary_operator] = STATE(1683),
    [sym_extract_operator] = STATE(1683),
    [sym_namespace_operator] = STATE(1683),
    [sym_integer] = STATE(1683),
    [sym_complex] = STATE(1683),
    [sym_float] = STATE(1683),
    [sym__hex_literal] = STATE(2412),
    [sym__float_literal] = STATE(2412),
    [sym_string] = STATE(2397),
    [sym__single_quoted_string] = STATE(2430),
    [sym__double_quoted_string] = STATE(2466),
    [sym_na] = STATE(1683),
    [sym__expression] = STATE(1683),
    [sym__string_or_identifier] = STATE(5142),
    [sym__open_parenthesis] = STATE(210),
    [sym__open_brace] = STATE(74),
    [aux_sym_function_definition_repeat1] = STATE(2637),
    [sym_identifier] = ACTIONS(2483),
    [anon_sym_BSLASH] = ACTIONS(2485),
    [anon_sym_function] = ACTIONS(2487),
    [anon_sym_EQ] = ACTIONS(767),
    [anon_sym_if] = ACTIONS(2489),
    [anon_sym_for] = ACTIONS(2491),
    [anon_sym_while] = ACTIONS(2493),
    [anon_sym_repeat] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(2497),
    [anon_sym_TILDE] = ACTIONS(2499),
    [anon_sym_BANG] = ACTIONS(2501),
    [anon_sym_PLUS] = ACTIONS(2503),
    [anon_sym_DASH] = ACTIONS(2505),
    [anon_sym_LT_DASH] = ACTIONS(765),
    [anon_sym_LT_LT_DASH] = ACTIONS(765),
    [anon_sym_COLON_EQ] = ACTIONS(765),
    [anon_sym_DASH_GT] = ACTIONS(767),
    [anon_sym_DASH_GT_GT] = ACTIONS(765),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_AMP] = ACTIONS(767),
    [anon_sym_PIPE_PIPE] = ACTIONS(765),
    [anon_sym_AMP_AMP] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(767),
    [anon_sym_LT_EQ] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_GT_EQ] = ACTIONS(765),
    [anon_sym_EQ_EQ] = ACTIONS(765),
    [anon_sym_BANG_EQ] = ACTIONS(765),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(765),
    [anon_sym_STAR_STAR] = ACTIONS(765),
    [anon_sym_CARET] = ACTIONS(765),
    [aux_sym_binary_operator_token1] = ACTIONS(765),
    [anon_sym_PIPE_GT] = ACTIONS(765),
    [anon_sym_COLON] = ACTIONS(767),
    [anon_sym_DOLLAR] = ACTIONS(765),
    [anon_sym_AT] = ACTIONS(765),
    [aux_sym__hex_literal_token1] = ACTIONS(2507),
    [sym__number_literal] = ACTIONS(2509),
    [anon_sym_SQUOTE] = ACTIONS(2511),
    [anon_sym_DQUOTE] = ACTIONS(2513),
    [sym_return] = ACTIONS(3983),
    [sym_next] = ACTIONS(3983),
    [sym_break] = ACTIONS(3983),
    [sym_true] = ACTIONS(3983),
    [sym_false] = ACTIONS(3983),
    [sym_null] = ACTIONS(3983),
    [sym_inf] = ACTIONS(3983),
    [sym_nan] = ACTIONS(3983),
    [anon_sym_NA] = ACTIONS(2517),
    [anon_sym_NA_integer_] = ACTIONS(2517),
    [anon_sym_NA_real_] = ACTIONS(2517),
    [anon_sym_NA_complex_] = ACTIONS(2517),
    [anon_sym_NA_character_] = ACTIONS(2517),
    [sym_dots] = ACTIONS(3983),
    [sym_dot_dot_i] = ACTIONS(3985),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(765),
    [sym__newline] = ACTIONS(765),
    [sym__raw_string_literal] = ACTIONS(2523),
    [sym__external_open_parenthesis] = ACTIONS(2525),
    [sym__external_close_parenthesis] = ACTIONS(765),
    [sym__external_open_brace] = ACTIONS(2529),
    [sym__external_open_bracket] = ACTIONS(765),
    [sym__external_open_bracket2] = ACTIONS(765),
    [sym__external_close_bracket2] = ACTIONS(765),
  },
  [353] = {
    [sym_function_definition] = STATE(1446),
    [sym_if_statement] = STATE(1446),
    [sym_for_statement] = STATE(1446),
    [sym_while_statement] = STATE(1446),
    [sym_repeat_statement] = STATE(1446),
    [sym_braced_expression] = STATE(1446),
    [sym_parenthesized_expression] = STATE(1446),
    [sym_call] = STATE(1446),
    [sym_subset] = STATE(1446),
    [sym_subset2] = STATE(1446),
    [sym_unary_operator] = STATE(1446),
    [sym_binary_operator] = STATE(1446),
    [sym_extract_operator] = STATE(1446),
    [sym_namespace_operator] = STATE(1446),
    [sym_integer] = STATE(1446),
    [sym_complex] = STATE(1446),
    [sym_float] = STATE(1446),
    [sym__hex_literal] = STATE(2381),
    [sym__float_literal] = STATE(2381),
    [sym_string] = STATE(2378),
    [sym__single_quoted_string] = STATE(2382),
    [sym__double_quoted_string] = STATE(2383),
    [sym_na] = STATE(1446),
    [sym__expression] = STATE(1446),
    [sym__string_or_identifier] = STATE(5153),
    [sym__open_parenthesis] = STATE(191),
    [sym__open_brace] = STATE(29),
    [aux_sym_function_definition_repeat1] = STATE(2722),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_BSLASH] = ACTIONS(3680),
    [anon_sym_function] = ACTIONS(3682),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_if] = ACTIONS(3684),
    [anon_sym_for] = ACTIONS(3686),
    [anon_sym_while] = ACTIONS(3688),
    [anon_sym_repeat] = ACTIONS(3690),
    [anon_sym_QMARK] = ACTIONS(3692),
    [anon_sym_TILDE] = ACTIONS(3694),
    [anon_sym_BANG] = ACTIONS(3696),
    [anon_sym_PLUS] = ACTIONS(3698),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_LT_DASH] = ACTIONS(471),
    [anon_sym_LT_LT_DASH] = ACTIONS(471),
    [anon_sym_COLON_EQ] = ACTIONS(471),
    [anon_sym_DASH_GT] = ACTIONS(473),
    [anon_sym_DASH_GT_GT] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(473),
    [anon_sym_AMP] = ACTIONS(473),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_LT_EQ] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(473),
    [anon_sym_GT_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_STAR] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [aux_sym_binary_operator_token1] = ACTIONS(471),
    [anon_sym_PIPE_GT] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(473),
    [anon_sym_DOLLAR] = ACTIONS(471),
    [anon_sym_AT] = ACTIONS(471),
    [aux_sym__hex_literal_token1] = ACTIONS(3702),
    [sym__number_literal] = ACTIONS(3704),
    [anon_sym_SQUOTE] = ACTIONS(3706),
    [anon_sym_DQUOTE] = ACTIONS(3708),
    [sym_return] = ACTIONS(3987),
    [sym_next] = ACTIONS(3987),
    [sym_break] = ACTIONS(3987),
    [sym_true] = ACTIONS(3987),
    [sym_false] = ACTIONS(3987),
    [sym_null] = ACTIONS(3987),
    [sym_inf] = ACTIONS(3987),
    [sym_nan] = ACTIONS(3987),
    [anon_sym_NA] = ACTIONS(3712),
    [anon_sym_NA_integer_] = ACTIONS(3712),
    [anon_sym_NA_real_] = ACTIONS(3712),
    [anon_sym_NA_complex_] = ACTIONS(3712),
    [anon_sym_NA_character_] = ACTIONS(3712),
    [sym_dots] = ACTIONS(3987),
    [sym_dot_dot_i] = ACTIONS(3989),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(471),
    [sym__newline] = ACTIONS(471),
    [sym__raw_string_literal] = ACTIONS(3718),
    [sym__external_else] = ACTIONS(471),
    [sym__external_open_parenthesis] = ACTIONS(3720),
    [sym__external_open_brace] = ACTIONS(3722),
    [sym__external_open_bracket] = ACTIONS(471),
    [sym__external_open_bracket2] = ACTIONS(471),
    [sym__external_close_bracket2] = ACTIONS(471),
  },
  [354] = {
    [sym_function_definition] = STATE(1662),
    [sym_if_statement] = STATE(1662),
    [sym_for_statement] = STATE(1662),
    [sym_while_statement] = STATE(1662),
    [sym_repeat_statement] = STATE(1662),
    [sym_braced_expression] = STATE(1662),
    [sym_parenthesized_expression] = STATE(1662),
    [sym_call] = STATE(1662),
    [sym_subset] = STATE(1662),
    [sym_subset2] = STATE(1662),
    [sym_unary_operator] = STATE(1662),
    [sym_binary_operator] = STATE(1662),
    [sym_extract_operator] = STATE(1662),
    [sym_namespace_operator] = STATE(1662),
    [sym_integer] = STATE(1662),
    [sym_complex] = STATE(1662),
    [sym_float] = STATE(1662),
    [sym__hex_literal] = STATE(2448),
    [sym__float_literal] = STATE(2448),
    [sym_string] = STATE(2441),
    [sym__single_quoted_string] = STATE(2456),
    [sym__double_quoted_string] = STATE(2478),
    [sym_na] = STATE(1662),
    [sym__expression] = STATE(1662),
    [sym__string_or_identifier] = STATE(5130),
    [sym__open_parenthesis] = STATE(147),
    [sym__open_brace] = STATE(63),
    [aux_sym_function_definition_repeat1] = STATE(321),
    [sym_identifier] = ACTIONS(3491),
    [anon_sym_BSLASH] = ACTIONS(3493),
    [anon_sym_function] = ACTIONS(3495),
    [anon_sym_EQ] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(3497),
    [anon_sym_for] = ACTIONS(3499),
    [anon_sym_while] = ACTIONS(3501),
    [anon_sym_repeat] = ACTIONS(3503),
    [anon_sym_QMARK] = ACTIONS(3505),
    [anon_sym_TILDE] = ACTIONS(3507),
    [anon_sym_BANG] = ACTIONS(3509),
    [anon_sym_PLUS] = ACTIONS(3511),
    [anon_sym_DASH] = ACTIONS(3513),
    [anon_sym_LT_DASH] = ACTIONS(263),
    [anon_sym_LT_LT_DASH] = ACTIONS(263),
    [anon_sym_COLON_EQ] = ACTIONS(263),
    [anon_sym_DASH_GT] = ACTIONS(265),
    [anon_sym_DASH_GT_GT] = ACTIONS(263),
    [anon_sym_PIPE] = ACTIONS(265),
    [anon_sym_AMP] = ACTIONS(265),
    [anon_sym_PIPE_PIPE] = ACTIONS(263),
    [anon_sym_AMP_AMP] = ACTIONS(263),
    [anon_sym_LT] = ACTIONS(265),
    [anon_sym_LT_EQ] = ACTIONS(263),
    [anon_sym_GT] = ACTIONS(265),
    [anon_sym_GT_EQ] = ACTIONS(263),
    [anon_sym_EQ_EQ] = ACTIONS(263),
    [anon_sym_BANG_EQ] = ACTIONS(263),
    [anon_sym_STAR] = ACTIONS(265),
    [anon_sym_SLASH] = ACTIONS(263),
    [anon_sym_STAR_STAR] = ACTIONS(263),
    [anon_sym_CARET] = ACTIONS(263),
    [aux_sym_binary_operator_token1] = ACTIONS(263),
    [anon_sym_PIPE_GT] = ACTIONS(263),
    [anon_sym_COLON] = ACTIONS(265),
    [anon_sym_DOLLAR] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(263),
    [aux_sym__hex_literal_token1] = ACTIONS(3515),
    [sym__number_literal] = ACTIONS(3517),
    [anon_sym_SQUOTE] = ACTIONS(3519),
    [anon_sym_DQUOTE] = ACTIONS(3521),
    [sym_return] = ACTIONS(3991),
    [sym_next] = ACTIONS(3991),
    [sym_break] = ACTIONS(3991),
    [sym_true] = ACTIONS(3991),
    [sym_false] = ACTIONS(3991),
    [sym_null] = ACTIONS(3991),
    [sym_inf] = ACTIONS(3991),
    [sym_nan] = ACTIONS(3991),
    [anon_sym_NA] = ACTIONS(3525),
    [anon_sym_NA_integer_] = ACTIONS(3525),
    [anon_sym_NA_real_] = ACTIONS(3525),
    [anon_sym_NA_complex_] = ACTIONS(3525),
    [anon_sym_NA_character_] = ACTIONS(3525),
    [sym_dots] = ACTIONS(3991),
    [sym_dot_dot_i] = ACTIONS(3993),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(263),
    [sym__newline] = ACTIONS(3995),
    [sym__raw_string_literal] = ACTIONS(3531),
    [sym__external_else] = ACTIONS(263),
    [sym__external_open_parenthesis] = ACTIONS(3533),
    [sym__external_open_brace] = ACTIONS(3535),
    [sym__external_open_bracket] = ACTIONS(263),
    [sym__external_close_bracket] = ACTIONS(263),
    [sym__external_open_bracket2] = ACTIONS(263),
  },
  [355] = {
    [sym_function_definition] = STATE(1728),
    [sym_if_statement] = STATE(1728),
    [sym_for_statement] = STATE(1728),
    [sym_while_statement] = STATE(1728),
    [sym_repeat_statement] = STATE(1728),
    [sym_braced_expression] = STATE(1728),
    [sym_parenthesized_expression] = STATE(1728),
    [sym_call] = STATE(1728),
    [sym_subset] = STATE(1728),
    [sym_subset2] = STATE(1728),
    [sym_unary_operator] = STATE(1728),
    [sym_binary_operator] = STATE(1728),
    [sym_extract_operator] = STATE(1728),
    [sym_namespace_operator] = STATE(1728),
    [sym_integer] = STATE(1728),
    [sym_complex] = STATE(1728),
    [sym_float] = STATE(1728),
    [sym__hex_literal] = STATE(2412),
    [sym__float_literal] = STATE(2412),
    [sym_string] = STATE(2397),
    [sym__single_quoted_string] = STATE(2430),
    [sym__double_quoted_string] = STATE(2466),
    [sym_na] = STATE(1728),
    [sym__expression] = STATE(1728),
    [sym__string_or_identifier] = STATE(5142),
    [sym__open_parenthesis] = STATE(210),
    [sym__open_brace] = STATE(74),
    [aux_sym_function_definition_repeat1] = STATE(2637),
    [sym_identifier] = ACTIONS(2483),
    [anon_sym_BSLASH] = ACTIONS(2485),
    [anon_sym_function] = ACTIONS(2487),
    [anon_sym_EQ] = ACTIONS(759),
    [anon_sym_if] = ACTIONS(2489),
    [anon_sym_for] = ACTIONS(2491),
    [anon_sym_while] = ACTIONS(2493),
    [anon_sym_repeat] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(2497),
    [anon_sym_TILDE] = ACTIONS(2499),
    [anon_sym_BANG] = ACTIONS(2501),
    [anon_sym_PLUS] = ACTIONS(2503),
    [anon_sym_DASH] = ACTIONS(2505),
    [anon_sym_LT_DASH] = ACTIONS(757),
    [anon_sym_LT_LT_DASH] = ACTIONS(757),
    [anon_sym_COLON_EQ] = ACTIONS(757),
    [anon_sym_DASH_GT] = ACTIONS(759),
    [anon_sym_DASH_GT_GT] = ACTIONS(757),
    [anon_sym_PIPE] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(759),
    [anon_sym_PIPE_PIPE] = ACTIONS(757),
    [anon_sym_AMP_AMP] = ACTIONS(757),
    [anon_sym_LT] = ACTIONS(759),
    [anon_sym_LT_EQ] = ACTIONS(757),
    [anon_sym_GT] = ACTIONS(759),
    [anon_sym_GT_EQ] = ACTIONS(757),
    [anon_sym_EQ_EQ] = ACTIONS(757),
    [anon_sym_BANG_EQ] = ACTIONS(757),
    [anon_sym_STAR] = ACTIONS(759),
    [anon_sym_SLASH] = ACTIONS(757),
    [anon_sym_STAR_STAR] = ACTIONS(757),
    [anon_sym_CARET] = ACTIONS(757),
    [aux_sym_binary_operator_token1] = ACTIONS(757),
    [anon_sym_PIPE_GT] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(759),
    [anon_sym_DOLLAR] = ACTIONS(757),
    [anon_sym_AT] = ACTIONS(757),
    [aux_sym__hex_literal_token1] = ACTIONS(2507),
    [sym__number_literal] = ACTIONS(2509),
    [anon_sym_SQUOTE] = ACTIONS(2511),
    [anon_sym_DQUOTE] = ACTIONS(2513),
    [sym_return] = ACTIONS(3997),
    [sym_next] = ACTIONS(3997),
    [sym_break] = ACTIONS(3997),
    [sym_true] = ACTIONS(3997),
    [sym_false] = ACTIONS(3997),
    [sym_null] = ACTIONS(3997),
    [sym_inf] = ACTIONS(3997),
    [sym_nan] = ACTIONS(3997),
    [anon_sym_NA] = ACTIONS(2517),
    [anon_sym_NA_integer_] = ACTIONS(2517),
    [anon_sym_NA_real_] = ACTIONS(2517),
    [anon_sym_NA_complex_] = ACTIONS(2517),
    [anon_sym_NA_character_] = ACTIONS(2517),
    [sym_dots] = ACTIONS(3997),
    [sym_dot_dot_i] = ACTIONS(3999),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(757),
    [sym__newline] = ACTIONS(757),
    [sym__raw_string_literal] = ACTIONS(2523),
    [sym__external_open_parenthesis] = ACTIONS(2525),
    [sym__external_close_parenthesis] = ACTIONS(757),
    [sym__external_open_brace] = ACTIONS(2529),
    [sym__external_open_bracket] = ACTIONS(757),
    [sym__external_open_bracket2] = ACTIONS(757),
    [sym__external_close_bracket2] = ACTIONS(757),
  },
  [356] = {
    [sym_function_definition] = STATE(1377),
    [sym_if_statement] = STATE(1377),
    [sym_for_statement] = STATE(1377),
    [sym_while_statement] = STATE(1377),
    [sym_repeat_statement] = STATE(1377),
    [sym_braced_expression] = STATE(1377),
    [sym_parenthesized_expression] = STATE(1377),
    [sym_call] = STATE(1377),
    [sym_subset] = STATE(1377),
    [sym_subset2] = STATE(1377),
    [sym_unary_operator] = STATE(1377),
    [sym_binary_operator] = STATE(1377),
    [sym_extract_operator] = STATE(1377),
    [sym_namespace_operator] = STATE(1377),
    [sym_integer] = STATE(1377),
    [sym_complex] = STATE(1377),
    [sym_float] = STATE(1377),
    [sym__hex_literal] = STATE(2445),
    [sym__float_literal] = STATE(2445),
    [sym_string] = STATE(2530),
    [sym__single_quoted_string] = STATE(2442),
    [sym__double_quoted_string] = STATE(2437),
    [sym_na] = STATE(1377),
    [sym__expression] = STATE(1377),
    [sym__string_or_identifier] = STATE(5133),
    [sym__open_parenthesis] = STATE(213),
    [sym__open_brace] = STATE(70),
    [aux_sym_function_definition_repeat1] = STATE(407),
    [sym_identifier] = ACTIONS(2531),
    [anon_sym_BSLASH] = ACTIONS(2533),
    [anon_sym_function] = ACTIONS(2535),
    [anon_sym_EQ] = ACTIONS(543),
    [anon_sym_if] = ACTIONS(2537),
    [anon_sym_for] = ACTIONS(2539),
    [anon_sym_while] = ACTIONS(2541),
    [anon_sym_repeat] = ACTIONS(2543),
    [anon_sym_QMARK] = ACTIONS(2545),
    [anon_sym_TILDE] = ACTIONS(2547),
    [anon_sym_BANG] = ACTIONS(2549),
    [anon_sym_PLUS] = ACTIONS(2551),
    [anon_sym_DASH] = ACTIONS(2553),
    [anon_sym_LT_DASH] = ACTIONS(545),
    [anon_sym_LT_LT_DASH] = ACTIONS(545),
    [anon_sym_COLON_EQ] = ACTIONS(545),
    [anon_sym_DASH_GT] = ACTIONS(543),
    [anon_sym_DASH_GT_GT] = ACTIONS(545),
    [anon_sym_PIPE] = ACTIONS(543),
    [anon_sym_AMP] = ACTIONS(543),
    [anon_sym_PIPE_PIPE] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(543),
    [anon_sym_LT_EQ] = ACTIONS(545),
    [anon_sym_GT] = ACTIONS(543),
    [anon_sym_GT_EQ] = ACTIONS(545),
    [anon_sym_EQ_EQ] = ACTIONS(545),
    [anon_sym_BANG_EQ] = ACTIONS(545),
    [anon_sym_STAR] = ACTIONS(543),
    [anon_sym_SLASH] = ACTIONS(545),
    [anon_sym_STAR_STAR] = ACTIONS(545),
    [anon_sym_CARET] = ACTIONS(545),
    [aux_sym_binary_operator_token1] = ACTIONS(545),
    [anon_sym_PIPE_GT] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(543),
    [anon_sym_DOLLAR] = ACTIONS(545),
    [anon_sym_AT] = ACTIONS(545),
    [aux_sym__hex_literal_token1] = ACTIONS(2555),
    [sym__number_literal] = ACTIONS(2557),
    [anon_sym_SQUOTE] = ACTIONS(2559),
    [anon_sym_DQUOTE] = ACTIONS(2561),
    [sym_return] = ACTIONS(4001),
    [sym_next] = ACTIONS(4001),
    [sym_break] = ACTIONS(4001),
    [sym_true] = ACTIONS(4001),
    [sym_false] = ACTIONS(4001),
    [sym_null] = ACTIONS(4001),
    [sym_inf] = ACTIONS(4001),
    [sym_nan] = ACTIONS(4001),
    [anon_sym_NA] = ACTIONS(2565),
    [anon_sym_NA_integer_] = ACTIONS(2565),
    [anon_sym_NA_real_] = ACTIONS(2565),
    [anon_sym_NA_complex_] = ACTIONS(2565),
    [anon_sym_NA_character_] = ACTIONS(2565),
    [sym_dots] = ACTIONS(4001),
    [sym_dot_dot_i] = ACTIONS(4003),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(545),
    [sym__newline] = ACTIONS(4005),
    [sym__raw_string_literal] = ACTIONS(2571),
    [sym__external_open_parenthesis] = ACTIONS(2573),
    [sym__external_close_parenthesis] = ACTIONS(545),
    [sym__external_open_brace] = ACTIONS(2577),
    [sym__external_open_bracket] = ACTIONS(545),
    [sym__external_close_bracket] = ACTIONS(545),
    [sym__external_open_bracket2] = ACTIONS(545),
  },
  [357] = {
    [sym_function_definition] = STATE(1550),
    [sym_if_statement] = STATE(1550),
    [sym_for_statement] = STATE(1550),
    [sym_while_statement] = STATE(1550),
    [sym_repeat_statement] = STATE(1550),
    [sym_braced_expression] = STATE(1550),
    [sym_parenthesized_expression] = STATE(1550),
    [sym_call] = STATE(1550),
    [sym_subset] = STATE(1550),
    [sym_subset2] = STATE(1550),
    [sym_unary_operator] = STATE(1550),
    [sym_binary_operator] = STATE(1550),
    [sym_extract_operator] = STATE(1550),
    [sym_namespace_operator] = STATE(1550),
    [sym_integer] = STATE(1550),
    [sym_complex] = STATE(1550),
    [sym_float] = STATE(1550),
    [sym__hex_literal] = STATE(2540),
    [sym__float_literal] = STATE(2540),
    [sym_string] = STATE(2541),
    [sym__single_quoted_string] = STATE(2462),
    [sym__double_quoted_string] = STATE(2494),
    [sym_na] = STATE(1550),
    [sym__expression] = STATE(1550),
    [sym__string_or_identifier] = STATE(5128),
    [sym__open_parenthesis] = STATE(246),
    [sym__open_brace] = STATE(173),
    [aux_sym_function_definition_repeat1] = STATE(2670),
    [ts_builtin_sym_end] = ACTIONS(765),
    [sym_identifier] = ACTIONS(2943),
    [anon_sym_BSLASH] = ACTIONS(2945),
    [anon_sym_function] = ACTIONS(2947),
    [anon_sym_EQ] = ACTIONS(767),
    [anon_sym_if] = ACTIONS(2949),
    [anon_sym_for] = ACTIONS(2951),
    [anon_sym_while] = ACTIONS(2953),
    [anon_sym_repeat] = ACTIONS(2955),
    [anon_sym_QMARK] = ACTIONS(2957),
    [anon_sym_TILDE] = ACTIONS(2959),
    [anon_sym_BANG] = ACTIONS(2961),
    [anon_sym_PLUS] = ACTIONS(2963),
    [anon_sym_DASH] = ACTIONS(2965),
    [anon_sym_LT_DASH] = ACTIONS(765),
    [anon_sym_LT_LT_DASH] = ACTIONS(765),
    [anon_sym_COLON_EQ] = ACTIONS(765),
    [anon_sym_DASH_GT] = ACTIONS(767),
    [anon_sym_DASH_GT_GT] = ACTIONS(765),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_AMP] = ACTIONS(767),
    [anon_sym_PIPE_PIPE] = ACTIONS(765),
    [anon_sym_AMP_AMP] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(767),
    [anon_sym_LT_EQ] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_GT_EQ] = ACTIONS(765),
    [anon_sym_EQ_EQ] = ACTIONS(765),
    [anon_sym_BANG_EQ] = ACTIONS(765),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(765),
    [anon_sym_STAR_STAR] = ACTIONS(765),
    [anon_sym_CARET] = ACTIONS(765),
    [aux_sym_binary_operator_token1] = ACTIONS(765),
    [anon_sym_PIPE_GT] = ACTIONS(765),
    [anon_sym_COLON] = ACTIONS(767),
    [anon_sym_DOLLAR] = ACTIONS(765),
    [anon_sym_AT] = ACTIONS(765),
    [aux_sym__hex_literal_token1] = ACTIONS(2967),
    [sym__number_literal] = ACTIONS(2969),
    [anon_sym_SQUOTE] = ACTIONS(2971),
    [anon_sym_DQUOTE] = ACTIONS(2973),
    [sym_return] = ACTIONS(4007),
    [sym_next] = ACTIONS(4007),
    [sym_break] = ACTIONS(4007),
    [sym_true] = ACTIONS(4007),
    [sym_false] = ACTIONS(4007),
    [sym_null] = ACTIONS(4007),
    [sym_inf] = ACTIONS(4007),
    [sym_nan] = ACTIONS(4007),
    [anon_sym_NA] = ACTIONS(2977),
    [anon_sym_NA_integer_] = ACTIONS(2977),
    [anon_sym_NA_real_] = ACTIONS(2977),
    [anon_sym_NA_complex_] = ACTIONS(2977),
    [anon_sym_NA_character_] = ACTIONS(2977),
    [sym_dots] = ACTIONS(4007),
    [sym_dot_dot_i] = ACTIONS(4009),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(765),
    [sym__semicolon] = ACTIONS(765),
    [sym__raw_string_literal] = ACTIONS(2983),
    [sym__external_open_parenthesis] = ACTIONS(2985),
    [sym__external_close_parenthesis] = ACTIONS(765),
    [sym__external_open_brace] = ACTIONS(2989),
    [sym__external_open_bracket] = ACTIONS(765),
    [sym__external_open_bracket2] = ACTIONS(765),
  },
  [358] = {
    [sym_function_definition] = STATE(1750),
    [sym_if_statement] = STATE(1750),
    [sym_for_statement] = STATE(1750),
    [sym_while_statement] = STATE(1750),
    [sym_repeat_statement] = STATE(1750),
    [sym_braced_expression] = STATE(1750),
    [sym_parenthesized_expression] = STATE(1750),
    [sym_call] = STATE(1750),
    [sym_subset] = STATE(1750),
    [sym_subset2] = STATE(1750),
    [sym_unary_operator] = STATE(1750),
    [sym_binary_operator] = STATE(1750),
    [sym_extract_operator] = STATE(1750),
    [sym_namespace_operator] = STATE(1750),
    [sym_integer] = STATE(1750),
    [sym_complex] = STATE(1750),
    [sym_float] = STATE(1750),
    [sym__hex_literal] = STATE(2412),
    [sym__float_literal] = STATE(2412),
    [sym_string] = STATE(2397),
    [sym__single_quoted_string] = STATE(2430),
    [sym__double_quoted_string] = STATE(2466),
    [sym_na] = STATE(1750),
    [sym__expression] = STATE(1750),
    [sym__string_or_identifier] = STATE(5142),
    [sym__open_parenthesis] = STATE(210),
    [sym__open_brace] = STATE(74),
    [aux_sym_function_definition_repeat1] = STATE(359),
    [sym_identifier] = ACTIONS(2483),
    [anon_sym_BSLASH] = ACTIONS(2485),
    [anon_sym_function] = ACTIONS(2487),
    [anon_sym_EQ] = ACTIONS(533),
    [anon_sym_if] = ACTIONS(2489),
    [anon_sym_for] = ACTIONS(2491),
    [anon_sym_while] = ACTIONS(2493),
    [anon_sym_repeat] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(2497),
    [anon_sym_TILDE] = ACTIONS(2499),
    [anon_sym_BANG] = ACTIONS(2501),
    [anon_sym_PLUS] = ACTIONS(2503),
    [anon_sym_DASH] = ACTIONS(2505),
    [anon_sym_LT_DASH] = ACTIONS(531),
    [anon_sym_LT_LT_DASH] = ACTIONS(531),
    [anon_sym_COLON_EQ] = ACTIONS(531),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_DASH_GT_GT] = ACTIONS(531),
    [anon_sym_PIPE] = ACTIONS(533),
    [anon_sym_AMP] = ACTIONS(533),
    [anon_sym_PIPE_PIPE] = ACTIONS(531),
    [anon_sym_AMP_AMP] = ACTIONS(531),
    [anon_sym_LT] = ACTIONS(533),
    [anon_sym_LT_EQ] = ACTIONS(531),
    [anon_sym_GT] = ACTIONS(533),
    [anon_sym_GT_EQ] = ACTIONS(531),
    [anon_sym_EQ_EQ] = ACTIONS(531),
    [anon_sym_BANG_EQ] = ACTIONS(531),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_SLASH] = ACTIONS(531),
    [anon_sym_STAR_STAR] = ACTIONS(531),
    [anon_sym_CARET] = ACTIONS(531),
    [aux_sym_binary_operator_token1] = ACTIONS(531),
    [anon_sym_PIPE_GT] = ACTIONS(531),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_DOLLAR] = ACTIONS(531),
    [anon_sym_AT] = ACTIONS(531),
    [aux_sym__hex_literal_token1] = ACTIONS(2507),
    [sym__number_literal] = ACTIONS(2509),
    [anon_sym_SQUOTE] = ACTIONS(2511),
    [anon_sym_DQUOTE] = ACTIONS(2513),
    [sym_return] = ACTIONS(4011),
    [sym_next] = ACTIONS(4011),
    [sym_break] = ACTIONS(4011),
    [sym_true] = ACTIONS(4011),
    [sym_false] = ACTIONS(4011),
    [sym_null] = ACTIONS(4011),
    [sym_inf] = ACTIONS(4011),
    [sym_nan] = ACTIONS(4011),
    [anon_sym_NA] = ACTIONS(2517),
    [anon_sym_NA_integer_] = ACTIONS(2517),
    [anon_sym_NA_real_] = ACTIONS(2517),
    [anon_sym_NA_complex_] = ACTIONS(2517),
    [anon_sym_NA_character_] = ACTIONS(2517),
    [sym_dots] = ACTIONS(4011),
    [sym_dot_dot_i] = ACTIONS(4013),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(531),
    [sym__newline] = ACTIONS(4015),
    [sym__raw_string_literal] = ACTIONS(2523),
    [sym__external_open_parenthesis] = ACTIONS(2525),
    [sym__external_close_parenthesis] = ACTIONS(531),
    [sym__external_open_brace] = ACTIONS(2529),
    [sym__external_open_bracket] = ACTIONS(531),
    [sym__external_open_bracket2] = ACTIONS(531),
    [sym__external_close_bracket2] = ACTIONS(531),
  },
  [359] = {
    [sym_function_definition] = STATE(1757),
    [sym_if_statement] = STATE(1757),
    [sym_for_statement] = STATE(1757),
    [sym_while_statement] = STATE(1757),
    [sym_repeat_statement] = STATE(1757),
    [sym_braced_expression] = STATE(1757),
    [sym_parenthesized_expression] = STATE(1757),
    [sym_call] = STATE(1757),
    [sym_subset] = STATE(1757),
    [sym_subset2] = STATE(1757),
    [sym_unary_operator] = STATE(1757),
    [sym_binary_operator] = STATE(1757),
    [sym_extract_operator] = STATE(1757),
    [sym_namespace_operator] = STATE(1757),
    [sym_integer] = STATE(1757),
    [sym_complex] = STATE(1757),
    [sym_float] = STATE(1757),
    [sym__hex_literal] = STATE(2412),
    [sym__float_literal] = STATE(2412),
    [sym_string] = STATE(2397),
    [sym__single_quoted_string] = STATE(2430),
    [sym__double_quoted_string] = STATE(2466),
    [sym_na] = STATE(1757),
    [sym__expression] = STATE(1757),
    [sym__string_or_identifier] = STATE(5142),
    [sym__open_parenthesis] = STATE(210),
    [sym__open_brace] = STATE(74),
    [aux_sym_function_definition_repeat1] = STATE(2637),
    [sym_identifier] = ACTIONS(2483),
    [anon_sym_BSLASH] = ACTIONS(2485),
    [anon_sym_function] = ACTIONS(2487),
    [anon_sym_EQ] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(2489),
    [anon_sym_for] = ACTIONS(2491),
    [anon_sym_while] = ACTIONS(2493),
    [anon_sym_repeat] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(2497),
    [anon_sym_TILDE] = ACTIONS(2499),
    [anon_sym_BANG] = ACTIONS(2501),
    [anon_sym_PLUS] = ACTIONS(2503),
    [anon_sym_DASH] = ACTIONS(2505),
    [anon_sym_LT_DASH] = ACTIONS(369),
    [anon_sym_LT_LT_DASH] = ACTIONS(369),
    [anon_sym_COLON_EQ] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(371),
    [anon_sym_DASH_GT_GT] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(371),
    [anon_sym_AMP] = ACTIONS(371),
    [anon_sym_PIPE_PIPE] = ACTIONS(369),
    [anon_sym_AMP_AMP] = ACTIONS(369),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_LT_EQ] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_EQ] = ACTIONS(369),
    [anon_sym_EQ_EQ] = ACTIONS(369),
    [anon_sym_BANG_EQ] = ACTIONS(369),
    [anon_sym_STAR] = ACTIONS(371),
    [anon_sym_SLASH] = ACTIONS(369),
    [anon_sym_STAR_STAR] = ACTIONS(369),
    [anon_sym_CARET] = ACTIONS(369),
    [aux_sym_binary_operator_token1] = ACTIONS(369),
    [anon_sym_PIPE_GT] = ACTIONS(369),
    [anon_sym_COLON] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(369),
    [anon_sym_AT] = ACTIONS(369),
    [aux_sym__hex_literal_token1] = ACTIONS(2507),
    [sym__number_literal] = ACTIONS(2509),
    [anon_sym_SQUOTE] = ACTIONS(2511),
    [anon_sym_DQUOTE] = ACTIONS(2513),
    [sym_return] = ACTIONS(4017),
    [sym_next] = ACTIONS(4017),
    [sym_break] = ACTIONS(4017),
    [sym_true] = ACTIONS(4017),
    [sym_false] = ACTIONS(4017),
    [sym_null] = ACTIONS(4017),
    [sym_inf] = ACTIONS(4017),
    [sym_nan] = ACTIONS(4017),
    [anon_sym_NA] = ACTIONS(2517),
    [anon_sym_NA_integer_] = ACTIONS(2517),
    [anon_sym_NA_real_] = ACTIONS(2517),
    [anon_sym_NA_complex_] = ACTIONS(2517),
    [anon_sym_NA_character_] = ACTIONS(2517),
    [sym_dots] = ACTIONS(4017),
    [sym_dot_dot_i] = ACTIONS(4019),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(369),
    [sym__newline] = ACTIONS(369),
    [sym__raw_string_literal] = ACTIONS(2523),
    [sym__external_open_parenthesis] = ACTIONS(2525),
    [sym__external_close_parenthesis] = ACTIONS(369),
    [sym__external_open_brace] = ACTIONS(2529),
    [sym__external_open_bracket] = ACTIONS(369),
    [sym__external_open_bracket2] = ACTIONS(369),
    [sym__external_close_bracket2] = ACTIONS(369),
  },
  [360] = {
    [sym_function_definition] = STATE(1758),
    [sym_if_statement] = STATE(1758),
    [sym_for_statement] = STATE(1758),
    [sym_while_statement] = STATE(1758),
    [sym_repeat_statement] = STATE(1758),
    [sym_braced_expression] = STATE(1758),
    [sym_parenthesized_expression] = STATE(1758),
    [sym_call] = STATE(1758),
    [sym_subset] = STATE(1758),
    [sym_subset2] = STATE(1758),
    [sym_unary_operator] = STATE(1758),
    [sym_binary_operator] = STATE(1758),
    [sym_extract_operator] = STATE(1758),
    [sym_namespace_operator] = STATE(1758),
    [sym_integer] = STATE(1758),
    [sym_complex] = STATE(1758),
    [sym_float] = STATE(1758),
    [sym__hex_literal] = STATE(2412),
    [sym__float_literal] = STATE(2412),
    [sym_string] = STATE(2397),
    [sym__single_quoted_string] = STATE(2430),
    [sym__double_quoted_string] = STATE(2466),
    [sym_na] = STATE(1758),
    [sym__expression] = STATE(1758),
    [sym__string_or_identifier] = STATE(5142),
    [sym__open_parenthesis] = STATE(210),
    [sym__open_brace] = STATE(74),
    [aux_sym_function_definition_repeat1] = STATE(363),
    [sym_identifier] = ACTIONS(2483),
    [anon_sym_BSLASH] = ACTIONS(2485),
    [anon_sym_function] = ACTIONS(2487),
    [anon_sym_EQ] = ACTIONS(379),
    [anon_sym_if] = ACTIONS(2489),
    [anon_sym_for] = ACTIONS(2491),
    [anon_sym_while] = ACTIONS(2493),
    [anon_sym_repeat] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(2497),
    [anon_sym_TILDE] = ACTIONS(2499),
    [anon_sym_BANG] = ACTIONS(2501),
    [anon_sym_PLUS] = ACTIONS(2503),
    [anon_sym_DASH] = ACTIONS(2505),
    [anon_sym_LT_DASH] = ACTIONS(377),
    [anon_sym_LT_LT_DASH] = ACTIONS(377),
    [anon_sym_COLON_EQ] = ACTIONS(377),
    [anon_sym_DASH_GT] = ACTIONS(379),
    [anon_sym_DASH_GT_GT] = ACTIONS(377),
    [anon_sym_PIPE] = ACTIONS(379),
    [anon_sym_AMP] = ACTIONS(379),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_LT] = ACTIONS(379),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(379),
    [anon_sym_GT_EQ] = ACTIONS(377),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(379),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_STAR_STAR] = ACTIONS(377),
    [anon_sym_CARET] = ACTIONS(377),
    [aux_sym_binary_operator_token1] = ACTIONS(377),
    [anon_sym_PIPE_GT] = ACTIONS(377),
    [anon_sym_COLON] = ACTIONS(379),
    [anon_sym_DOLLAR] = ACTIONS(377),
    [anon_sym_AT] = ACTIONS(377),
    [aux_sym__hex_literal_token1] = ACTIONS(2507),
    [sym__number_literal] = ACTIONS(2509),
    [anon_sym_SQUOTE] = ACTIONS(2511),
    [anon_sym_DQUOTE] = ACTIONS(2513),
    [sym_return] = ACTIONS(4021),
    [sym_next] = ACTIONS(4021),
    [sym_break] = ACTIONS(4021),
    [sym_true] = ACTIONS(4021),
    [sym_false] = ACTIONS(4021),
    [sym_null] = ACTIONS(4021),
    [sym_inf] = ACTIONS(4021),
    [sym_nan] = ACTIONS(4021),
    [anon_sym_NA] = ACTIONS(2517),
    [anon_sym_NA_integer_] = ACTIONS(2517),
    [anon_sym_NA_real_] = ACTIONS(2517),
    [anon_sym_NA_complex_] = ACTIONS(2517),
    [anon_sym_NA_character_] = ACTIONS(2517),
    [sym_dots] = ACTIONS(4021),
    [sym_dot_dot_i] = ACTIONS(4023),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(377),
    [sym__newline] = ACTIONS(4025),
    [sym__raw_string_literal] = ACTIONS(2523),
    [sym__external_open_parenthesis] = ACTIONS(2525),
    [sym__external_close_parenthesis] = ACTIONS(377),
    [sym__external_open_brace] = ACTIONS(2529),
    [sym__external_open_bracket] = ACTIONS(377),
    [sym__external_open_bracket2] = ACTIONS(377),
    [sym__external_close_bracket2] = ACTIONS(377),
  },
  [361] = {
    [sym_function_definition] = STATE(1764),
    [sym_if_statement] = STATE(1764),
    [sym_for_statement] = STATE(1764),
    [sym_while_statement] = STATE(1764),
    [sym_repeat_statement] = STATE(1764),
    [sym_braced_expression] = STATE(1764),
    [sym_parenthesized_expression] = STATE(1764),
    [sym_call] = STATE(1764),
    [sym_subset] = STATE(1764),
    [sym_subset2] = STATE(1764),
    [sym_unary_operator] = STATE(1764),
    [sym_binary_operator] = STATE(1764),
    [sym_extract_operator] = STATE(1764),
    [sym_namespace_operator] = STATE(1764),
    [sym_integer] = STATE(1764),
    [sym_complex] = STATE(1764),
    [sym_float] = STATE(1764),
    [sym__hex_literal] = STATE(2412),
    [sym__float_literal] = STATE(2412),
    [sym_string] = STATE(2397),
    [sym__single_quoted_string] = STATE(2430),
    [sym__double_quoted_string] = STATE(2466),
    [sym_na] = STATE(1764),
    [sym__expression] = STATE(1764),
    [sym__string_or_identifier] = STATE(5142),
    [sym__open_parenthesis] = STATE(210),
    [sym__open_brace] = STATE(74),
    [aux_sym_function_definition_repeat1] = STATE(367),
    [sym_identifier] = ACTIONS(2483),
    [anon_sym_BSLASH] = ACTIONS(2485),
    [anon_sym_function] = ACTIONS(2487),
    [anon_sym_EQ] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(2489),
    [anon_sym_for] = ACTIONS(2491),
    [anon_sym_while] = ACTIONS(2493),
    [anon_sym_repeat] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(2497),
    [anon_sym_TILDE] = ACTIONS(2499),
    [anon_sym_BANG] = ACTIONS(2501),
    [anon_sym_PLUS] = ACTIONS(2503),
    [anon_sym_DASH] = ACTIONS(2505),
    [anon_sym_LT_DASH] = ACTIONS(387),
    [anon_sym_LT_LT_DASH] = ACTIONS(387),
    [anon_sym_COLON_EQ] = ACTIONS(387),
    [anon_sym_DASH_GT] = ACTIONS(389),
    [anon_sym_DASH_GT_GT] = ACTIONS(387),
    [anon_sym_PIPE] = ACTIONS(389),
    [anon_sym_AMP] = ACTIONS(389),
    [anon_sym_PIPE_PIPE] = ACTIONS(387),
    [anon_sym_AMP_AMP] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(389),
    [anon_sym_LT_EQ] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(389),
    [anon_sym_GT_EQ] = ACTIONS(387),
    [anon_sym_EQ_EQ] = ACTIONS(387),
    [anon_sym_BANG_EQ] = ACTIONS(387),
    [anon_sym_STAR] = ACTIONS(389),
    [anon_sym_SLASH] = ACTIONS(387),
    [anon_sym_STAR_STAR] = ACTIONS(387),
    [anon_sym_CARET] = ACTIONS(387),
    [aux_sym_binary_operator_token1] = ACTIONS(387),
    [anon_sym_PIPE_GT] = ACTIONS(387),
    [anon_sym_COLON] = ACTIONS(389),
    [anon_sym_DOLLAR] = ACTIONS(387),
    [anon_sym_AT] = ACTIONS(387),
    [aux_sym__hex_literal_token1] = ACTIONS(2507),
    [sym__number_literal] = ACTIONS(2509),
    [anon_sym_SQUOTE] = ACTIONS(2511),
    [anon_sym_DQUOTE] = ACTIONS(2513),
    [sym_return] = ACTIONS(4027),
    [sym_next] = ACTIONS(4027),
    [sym_break] = ACTIONS(4027),
    [sym_true] = ACTIONS(4027),
    [sym_false] = ACTIONS(4027),
    [sym_null] = ACTIONS(4027),
    [sym_inf] = ACTIONS(4027),
    [sym_nan] = ACTIONS(4027),
    [anon_sym_NA] = ACTIONS(2517),
    [anon_sym_NA_integer_] = ACTIONS(2517),
    [anon_sym_NA_real_] = ACTIONS(2517),
    [anon_sym_NA_complex_] = ACTIONS(2517),
    [anon_sym_NA_character_] = ACTIONS(2517),
    [sym_dots] = ACTIONS(4027),
    [sym_dot_dot_i] = ACTIONS(4029),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(387),
    [sym__newline] = ACTIONS(4031),
    [sym__raw_string_literal] = ACTIONS(2523),
    [sym__external_open_parenthesis] = ACTIONS(2525),
    [sym__external_close_parenthesis] = ACTIONS(387),
    [sym__external_open_brace] = ACTIONS(2529),
    [sym__external_open_bracket] = ACTIONS(387),
    [sym__external_open_bracket2] = ACTIONS(387),
    [sym__external_close_bracket2] = ACTIONS(387),
  },
  [362] = {
    [sym_function_definition] = STATE(1501),
    [sym_if_statement] = STATE(1501),
    [sym_for_statement] = STATE(1501),
    [sym_while_statement] = STATE(1501),
    [sym_repeat_statement] = STATE(1501),
    [sym_braced_expression] = STATE(1501),
    [sym_parenthesized_expression] = STATE(1501),
    [sym_call] = STATE(1501),
    [sym_subset] = STATE(1501),
    [sym_subset2] = STATE(1501),
    [sym_unary_operator] = STATE(1501),
    [sym_binary_operator] = STATE(1501),
    [sym_extract_operator] = STATE(1501),
    [sym_namespace_operator] = STATE(1501),
    [sym_integer] = STATE(1501),
    [sym_complex] = STATE(1501),
    [sym_float] = STATE(1501),
    [sym__hex_literal] = STATE(2540),
    [sym__float_literal] = STATE(2540),
    [sym_string] = STATE(2541),
    [sym__single_quoted_string] = STATE(2462),
    [sym__double_quoted_string] = STATE(2494),
    [sym_na] = STATE(1501),
    [sym__expression] = STATE(1501),
    [sym__string_or_identifier] = STATE(5128),
    [sym__open_parenthesis] = STATE(246),
    [sym__open_brace] = STATE(173),
    [aux_sym_function_definition_repeat1] = STATE(336),
    [ts_builtin_sym_end] = ACTIONS(545),
    [sym_identifier] = ACTIONS(2943),
    [anon_sym_BSLASH] = ACTIONS(2945),
    [anon_sym_function] = ACTIONS(2947),
    [anon_sym_EQ] = ACTIONS(543),
    [anon_sym_if] = ACTIONS(2949),
    [anon_sym_for] = ACTIONS(2951),
    [anon_sym_while] = ACTIONS(2953),
    [anon_sym_repeat] = ACTIONS(2955),
    [anon_sym_QMARK] = ACTIONS(2957),
    [anon_sym_TILDE] = ACTIONS(2959),
    [anon_sym_BANG] = ACTIONS(2961),
    [anon_sym_PLUS] = ACTIONS(2963),
    [anon_sym_DASH] = ACTIONS(2965),
    [anon_sym_LT_DASH] = ACTIONS(545),
    [anon_sym_LT_LT_DASH] = ACTIONS(545),
    [anon_sym_COLON_EQ] = ACTIONS(545),
    [anon_sym_DASH_GT] = ACTIONS(543),
    [anon_sym_DASH_GT_GT] = ACTIONS(545),
    [anon_sym_PIPE] = ACTIONS(543),
    [anon_sym_AMP] = ACTIONS(543),
    [anon_sym_PIPE_PIPE] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(543),
    [anon_sym_LT_EQ] = ACTIONS(545),
    [anon_sym_GT] = ACTIONS(543),
    [anon_sym_GT_EQ] = ACTIONS(545),
    [anon_sym_EQ_EQ] = ACTIONS(545),
    [anon_sym_BANG_EQ] = ACTIONS(545),
    [anon_sym_STAR] = ACTIONS(543),
    [anon_sym_SLASH] = ACTIONS(545),
    [anon_sym_STAR_STAR] = ACTIONS(545),
    [anon_sym_CARET] = ACTIONS(545),
    [aux_sym_binary_operator_token1] = ACTIONS(545),
    [anon_sym_PIPE_GT] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(543),
    [anon_sym_DOLLAR] = ACTIONS(545),
    [anon_sym_AT] = ACTIONS(545),
    [aux_sym__hex_literal_token1] = ACTIONS(2967),
    [sym__number_literal] = ACTIONS(2969),
    [anon_sym_SQUOTE] = ACTIONS(2971),
    [anon_sym_DQUOTE] = ACTIONS(2973),
    [sym_return] = ACTIONS(4033),
    [sym_next] = ACTIONS(4033),
    [sym_break] = ACTIONS(4033),
    [sym_true] = ACTIONS(4033),
    [sym_false] = ACTIONS(4033),
    [sym_null] = ACTIONS(4033),
    [sym_inf] = ACTIONS(4033),
    [sym_nan] = ACTIONS(4033),
    [anon_sym_NA] = ACTIONS(2977),
    [anon_sym_NA_integer_] = ACTIONS(2977),
    [anon_sym_NA_real_] = ACTIONS(2977),
    [anon_sym_NA_complex_] = ACTIONS(2977),
    [anon_sym_NA_character_] = ACTIONS(2977),
    [sym_dots] = ACTIONS(4033),
    [sym_dot_dot_i] = ACTIONS(4035),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4037),
    [sym__semicolon] = ACTIONS(545),
    [sym__raw_string_literal] = ACTIONS(2983),
    [sym__external_open_parenthesis] = ACTIONS(2985),
    [sym__external_close_parenthesis] = ACTIONS(545),
    [sym__external_open_brace] = ACTIONS(2989),
    [sym__external_open_bracket] = ACTIONS(545),
    [sym__external_open_bracket2] = ACTIONS(545),
  },
  [363] = {
    [sym_function_definition] = STATE(1767),
    [sym_if_statement] = STATE(1767),
    [sym_for_statement] = STATE(1767),
    [sym_while_statement] = STATE(1767),
    [sym_repeat_statement] = STATE(1767),
    [sym_braced_expression] = STATE(1767),
    [sym_parenthesized_expression] = STATE(1767),
    [sym_call] = STATE(1767),
    [sym_subset] = STATE(1767),
    [sym_subset2] = STATE(1767),
    [sym_unary_operator] = STATE(1767),
    [sym_binary_operator] = STATE(1767),
    [sym_extract_operator] = STATE(1767),
    [sym_namespace_operator] = STATE(1767),
    [sym_integer] = STATE(1767),
    [sym_complex] = STATE(1767),
    [sym_float] = STATE(1767),
    [sym__hex_literal] = STATE(2412),
    [sym__float_literal] = STATE(2412),
    [sym_string] = STATE(2397),
    [sym__single_quoted_string] = STATE(2430),
    [sym__double_quoted_string] = STATE(2466),
    [sym_na] = STATE(1767),
    [sym__expression] = STATE(1767),
    [sym__string_or_identifier] = STATE(5142),
    [sym__open_parenthesis] = STATE(210),
    [sym__open_brace] = STATE(74),
    [aux_sym_function_definition_repeat1] = STATE(2637),
    [sym_identifier] = ACTIONS(2483),
    [anon_sym_BSLASH] = ACTIONS(2485),
    [anon_sym_function] = ACTIONS(2487),
    [anon_sym_EQ] = ACTIONS(399),
    [anon_sym_if] = ACTIONS(2489),
    [anon_sym_for] = ACTIONS(2491),
    [anon_sym_while] = ACTIONS(2493),
    [anon_sym_repeat] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(2497),
    [anon_sym_TILDE] = ACTIONS(2499),
    [anon_sym_BANG] = ACTIONS(2501),
    [anon_sym_PLUS] = ACTIONS(2503),
    [anon_sym_DASH] = ACTIONS(2505),
    [anon_sym_LT_DASH] = ACTIONS(397),
    [anon_sym_LT_LT_DASH] = ACTIONS(397),
    [anon_sym_COLON_EQ] = ACTIONS(397),
    [anon_sym_DASH_GT] = ACTIONS(399),
    [anon_sym_DASH_GT_GT] = ACTIONS(397),
    [anon_sym_PIPE] = ACTIONS(399),
    [anon_sym_AMP] = ACTIONS(399),
    [anon_sym_PIPE_PIPE] = ACTIONS(397),
    [anon_sym_AMP_AMP] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(399),
    [anon_sym_LT_EQ] = ACTIONS(397),
    [anon_sym_GT] = ACTIONS(399),
    [anon_sym_GT_EQ] = ACTIONS(397),
    [anon_sym_EQ_EQ] = ACTIONS(397),
    [anon_sym_BANG_EQ] = ACTIONS(397),
    [anon_sym_STAR] = ACTIONS(399),
    [anon_sym_SLASH] = ACTIONS(397),
    [anon_sym_STAR_STAR] = ACTIONS(397),
    [anon_sym_CARET] = ACTIONS(397),
    [aux_sym_binary_operator_token1] = ACTIONS(397),
    [anon_sym_PIPE_GT] = ACTIONS(397),
    [anon_sym_COLON] = ACTIONS(399),
    [anon_sym_DOLLAR] = ACTIONS(397),
    [anon_sym_AT] = ACTIONS(397),
    [aux_sym__hex_literal_token1] = ACTIONS(2507),
    [sym__number_literal] = ACTIONS(2509),
    [anon_sym_SQUOTE] = ACTIONS(2511),
    [anon_sym_DQUOTE] = ACTIONS(2513),
    [sym_return] = ACTIONS(4039),
    [sym_next] = ACTIONS(4039),
    [sym_break] = ACTIONS(4039),
    [sym_true] = ACTIONS(4039),
    [sym_false] = ACTIONS(4039),
    [sym_null] = ACTIONS(4039),
    [sym_inf] = ACTIONS(4039),
    [sym_nan] = ACTIONS(4039),
    [anon_sym_NA] = ACTIONS(2517),
    [anon_sym_NA_integer_] = ACTIONS(2517),
    [anon_sym_NA_real_] = ACTIONS(2517),
    [anon_sym_NA_complex_] = ACTIONS(2517),
    [anon_sym_NA_character_] = ACTIONS(2517),
    [sym_dots] = ACTIONS(4039),
    [sym_dot_dot_i] = ACTIONS(4041),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(397),
    [sym__newline] = ACTIONS(397),
    [sym__raw_string_literal] = ACTIONS(2523),
    [sym__external_open_parenthesis] = ACTIONS(2525),
    [sym__external_close_parenthesis] = ACTIONS(397),
    [sym__external_open_brace] = ACTIONS(2529),
    [sym__external_open_bracket] = ACTIONS(397),
    [sym__external_open_bracket2] = ACTIONS(397),
    [sym__external_close_bracket2] = ACTIONS(397),
  },
  [364] = {
    [sym_function_definition] = STATE(1850),
    [sym_if_statement] = STATE(1850),
    [sym_for_statement] = STATE(1850),
    [sym_while_statement] = STATE(1850),
    [sym_repeat_statement] = STATE(1850),
    [sym_braced_expression] = STATE(1850),
    [sym_parenthesized_expression] = STATE(1850),
    [sym_call] = STATE(1850),
    [sym_subset] = STATE(1850),
    [sym_subset2] = STATE(1850),
    [sym_unary_operator] = STATE(1850),
    [sym_binary_operator] = STATE(1850),
    [sym_extract_operator] = STATE(1850),
    [sym_namespace_operator] = STATE(1850),
    [sym_integer] = STATE(1850),
    [sym_complex] = STATE(1850),
    [sym_float] = STATE(1850),
    [sym__hex_literal] = STATE(2540),
    [sym__float_literal] = STATE(2540),
    [sym_string] = STATE(2541),
    [sym__single_quoted_string] = STATE(2462),
    [sym__double_quoted_string] = STATE(2494),
    [sym_na] = STATE(1850),
    [sym__expression] = STATE(1850),
    [sym__string_or_identifier] = STATE(5128),
    [sym__open_parenthesis] = STATE(246),
    [sym__open_brace] = STATE(173),
    [aux_sym_function_definition_repeat1] = STATE(2670),
    [ts_builtin_sym_end] = ACTIONS(369),
    [sym_identifier] = ACTIONS(2943),
    [anon_sym_BSLASH] = ACTIONS(2945),
    [anon_sym_function] = ACTIONS(2947),
    [anon_sym_EQ] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(2949),
    [anon_sym_for] = ACTIONS(2951),
    [anon_sym_while] = ACTIONS(2953),
    [anon_sym_repeat] = ACTIONS(2955),
    [anon_sym_QMARK] = ACTIONS(2957),
    [anon_sym_TILDE] = ACTIONS(2959),
    [anon_sym_BANG] = ACTIONS(2961),
    [anon_sym_PLUS] = ACTIONS(2963),
    [anon_sym_DASH] = ACTIONS(2965),
    [anon_sym_LT_DASH] = ACTIONS(369),
    [anon_sym_LT_LT_DASH] = ACTIONS(369),
    [anon_sym_COLON_EQ] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(371),
    [anon_sym_DASH_GT_GT] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(371),
    [anon_sym_AMP] = ACTIONS(371),
    [anon_sym_PIPE_PIPE] = ACTIONS(369),
    [anon_sym_AMP_AMP] = ACTIONS(369),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_LT_EQ] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_EQ] = ACTIONS(369),
    [anon_sym_EQ_EQ] = ACTIONS(369),
    [anon_sym_BANG_EQ] = ACTIONS(369),
    [anon_sym_STAR] = ACTIONS(371),
    [anon_sym_SLASH] = ACTIONS(369),
    [anon_sym_STAR_STAR] = ACTIONS(369),
    [anon_sym_CARET] = ACTIONS(369),
    [aux_sym_binary_operator_token1] = ACTIONS(369),
    [anon_sym_PIPE_GT] = ACTIONS(369),
    [anon_sym_COLON] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(369),
    [anon_sym_AT] = ACTIONS(369),
    [aux_sym__hex_literal_token1] = ACTIONS(2967),
    [sym__number_literal] = ACTIONS(2969),
    [anon_sym_SQUOTE] = ACTIONS(2971),
    [anon_sym_DQUOTE] = ACTIONS(2973),
    [sym_return] = ACTIONS(4043),
    [sym_next] = ACTIONS(4043),
    [sym_break] = ACTIONS(4043),
    [sym_true] = ACTIONS(4043),
    [sym_false] = ACTIONS(4043),
    [sym_null] = ACTIONS(4043),
    [sym_inf] = ACTIONS(4043),
    [sym_nan] = ACTIONS(4043),
    [anon_sym_NA] = ACTIONS(2977),
    [anon_sym_NA_integer_] = ACTIONS(2977),
    [anon_sym_NA_real_] = ACTIONS(2977),
    [anon_sym_NA_complex_] = ACTIONS(2977),
    [anon_sym_NA_character_] = ACTIONS(2977),
    [sym_dots] = ACTIONS(4043),
    [sym_dot_dot_i] = ACTIONS(4045),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(369),
    [sym__semicolon] = ACTIONS(369),
    [sym__raw_string_literal] = ACTIONS(2983),
    [sym__external_open_parenthesis] = ACTIONS(2985),
    [sym__external_close_parenthesis] = ACTIONS(369),
    [sym__external_open_brace] = ACTIONS(2989),
    [sym__external_open_bracket] = ACTIONS(369),
    [sym__external_open_bracket2] = ACTIONS(369),
  },
  [365] = {
    [sym_function_definition] = STATE(1852),
    [sym_if_statement] = STATE(1852),
    [sym_for_statement] = STATE(1852),
    [sym_while_statement] = STATE(1852),
    [sym_repeat_statement] = STATE(1852),
    [sym_braced_expression] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1852),
    [sym_call] = STATE(1852),
    [sym_subset] = STATE(1852),
    [sym_subset2] = STATE(1852),
    [sym_unary_operator] = STATE(1852),
    [sym_binary_operator] = STATE(1852),
    [sym_extract_operator] = STATE(1852),
    [sym_namespace_operator] = STATE(1852),
    [sym_integer] = STATE(1852),
    [sym_complex] = STATE(1852),
    [sym_float] = STATE(1852),
    [sym__hex_literal] = STATE(2540),
    [sym__float_literal] = STATE(2540),
    [sym_string] = STATE(2541),
    [sym__single_quoted_string] = STATE(2462),
    [sym__double_quoted_string] = STATE(2494),
    [sym_na] = STATE(1852),
    [sym__expression] = STATE(1852),
    [sym__string_or_identifier] = STATE(5128),
    [sym__open_parenthesis] = STATE(246),
    [sym__open_brace] = STATE(173),
    [aux_sym_function_definition_repeat1] = STATE(374),
    [ts_builtin_sym_end] = ACTIONS(377),
    [sym_identifier] = ACTIONS(2943),
    [anon_sym_BSLASH] = ACTIONS(2945),
    [anon_sym_function] = ACTIONS(2947),
    [anon_sym_EQ] = ACTIONS(379),
    [anon_sym_if] = ACTIONS(2949),
    [anon_sym_for] = ACTIONS(2951),
    [anon_sym_while] = ACTIONS(2953),
    [anon_sym_repeat] = ACTIONS(2955),
    [anon_sym_QMARK] = ACTIONS(2957),
    [anon_sym_TILDE] = ACTIONS(2959),
    [anon_sym_BANG] = ACTIONS(2961),
    [anon_sym_PLUS] = ACTIONS(2963),
    [anon_sym_DASH] = ACTIONS(2965),
    [anon_sym_LT_DASH] = ACTIONS(377),
    [anon_sym_LT_LT_DASH] = ACTIONS(377),
    [anon_sym_COLON_EQ] = ACTIONS(377),
    [anon_sym_DASH_GT] = ACTIONS(379),
    [anon_sym_DASH_GT_GT] = ACTIONS(377),
    [anon_sym_PIPE] = ACTIONS(379),
    [anon_sym_AMP] = ACTIONS(379),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_LT] = ACTIONS(379),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(379),
    [anon_sym_GT_EQ] = ACTIONS(377),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(379),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_STAR_STAR] = ACTIONS(377),
    [anon_sym_CARET] = ACTIONS(377),
    [aux_sym_binary_operator_token1] = ACTIONS(377),
    [anon_sym_PIPE_GT] = ACTIONS(377),
    [anon_sym_COLON] = ACTIONS(379),
    [anon_sym_DOLLAR] = ACTIONS(377),
    [anon_sym_AT] = ACTIONS(377),
    [aux_sym__hex_literal_token1] = ACTIONS(2967),
    [sym__number_literal] = ACTIONS(2969),
    [anon_sym_SQUOTE] = ACTIONS(2971),
    [anon_sym_DQUOTE] = ACTIONS(2973),
    [sym_return] = ACTIONS(4047),
    [sym_next] = ACTIONS(4047),
    [sym_break] = ACTIONS(4047),
    [sym_true] = ACTIONS(4047),
    [sym_false] = ACTIONS(4047),
    [sym_null] = ACTIONS(4047),
    [sym_inf] = ACTIONS(4047),
    [sym_nan] = ACTIONS(4047),
    [anon_sym_NA] = ACTIONS(2977),
    [anon_sym_NA_integer_] = ACTIONS(2977),
    [anon_sym_NA_real_] = ACTIONS(2977),
    [anon_sym_NA_complex_] = ACTIONS(2977),
    [anon_sym_NA_character_] = ACTIONS(2977),
    [sym_dots] = ACTIONS(4047),
    [sym_dot_dot_i] = ACTIONS(4049),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4051),
    [sym__semicolon] = ACTIONS(377),
    [sym__raw_string_literal] = ACTIONS(2983),
    [sym__external_open_parenthesis] = ACTIONS(2985),
    [sym__external_close_parenthesis] = ACTIONS(377),
    [sym__external_open_brace] = ACTIONS(2989),
    [sym__external_open_bracket] = ACTIONS(377),
    [sym__external_open_bracket2] = ACTIONS(377),
  },
  [366] = {
    [sym_function_definition] = STATE(1902),
    [sym_if_statement] = STATE(1902),
    [sym_for_statement] = STATE(1902),
    [sym_while_statement] = STATE(1902),
    [sym_repeat_statement] = STATE(1902),
    [sym_braced_expression] = STATE(1902),
    [sym_parenthesized_expression] = STATE(1902),
    [sym_call] = STATE(1902),
    [sym_subset] = STATE(1902),
    [sym_subset2] = STATE(1902),
    [sym_unary_operator] = STATE(1902),
    [sym_binary_operator] = STATE(1902),
    [sym_extract_operator] = STATE(1902),
    [sym_namespace_operator] = STATE(1902),
    [sym_integer] = STATE(1902),
    [sym_complex] = STATE(1902),
    [sym_float] = STATE(1902),
    [sym__hex_literal] = STATE(2536),
    [sym__float_literal] = STATE(2536),
    [sym_string] = STATE(2534),
    [sym__single_quoted_string] = STATE(2538),
    [sym__double_quoted_string] = STATE(2539),
    [sym_na] = STATE(1902),
    [sym__expression] = STATE(1902),
    [sym__string_or_identifier] = STATE(5143),
    [sym__open_parenthesis] = STATE(150),
    [sym__open_brace] = STATE(133),
    [aux_sym_function_definition_repeat1] = STATE(376),
    [ts_builtin_sym_end] = ACTIONS(263),
    [sym_identifier] = ACTIONS(4053),
    [anon_sym_BSLASH] = ACTIONS(4055),
    [anon_sym_function] = ACTIONS(4057),
    [anon_sym_EQ] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(4059),
    [anon_sym_for] = ACTIONS(4061),
    [anon_sym_while] = ACTIONS(4063),
    [anon_sym_repeat] = ACTIONS(4065),
    [anon_sym_QMARK] = ACTIONS(4067),
    [anon_sym_TILDE] = ACTIONS(4069),
    [anon_sym_BANG] = ACTIONS(4071),
    [anon_sym_PLUS] = ACTIONS(4073),
    [anon_sym_DASH] = ACTIONS(4075),
    [anon_sym_LT_DASH] = ACTIONS(263),
    [anon_sym_LT_LT_DASH] = ACTIONS(263),
    [anon_sym_COLON_EQ] = ACTIONS(263),
    [anon_sym_DASH_GT] = ACTIONS(265),
    [anon_sym_DASH_GT_GT] = ACTIONS(263),
    [anon_sym_PIPE] = ACTIONS(265),
    [anon_sym_AMP] = ACTIONS(265),
    [anon_sym_PIPE_PIPE] = ACTIONS(263),
    [anon_sym_AMP_AMP] = ACTIONS(263),
    [anon_sym_LT] = ACTIONS(265),
    [anon_sym_LT_EQ] = ACTIONS(263),
    [anon_sym_GT] = ACTIONS(265),
    [anon_sym_GT_EQ] = ACTIONS(263),
    [anon_sym_EQ_EQ] = ACTIONS(263),
    [anon_sym_BANG_EQ] = ACTIONS(263),
    [anon_sym_STAR] = ACTIONS(265),
    [anon_sym_SLASH] = ACTIONS(263),
    [anon_sym_STAR_STAR] = ACTIONS(263),
    [anon_sym_CARET] = ACTIONS(263),
    [aux_sym_binary_operator_token1] = ACTIONS(263),
    [anon_sym_PIPE_GT] = ACTIONS(263),
    [anon_sym_COLON] = ACTIONS(265),
    [anon_sym_DOLLAR] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(263),
    [aux_sym__hex_literal_token1] = ACTIONS(4077),
    [sym__number_literal] = ACTIONS(4079),
    [anon_sym_SQUOTE] = ACTIONS(4081),
    [anon_sym_DQUOTE] = ACTIONS(4083),
    [sym_return] = ACTIONS(4085),
    [sym_next] = ACTIONS(4085),
    [sym_break] = ACTIONS(4085),
    [sym_true] = ACTIONS(4085),
    [sym_false] = ACTIONS(4085),
    [sym_null] = ACTIONS(4085),
    [sym_inf] = ACTIONS(4085),
    [sym_nan] = ACTIONS(4085),
    [anon_sym_NA] = ACTIONS(4087),
    [anon_sym_NA_integer_] = ACTIONS(4087),
    [anon_sym_NA_real_] = ACTIONS(4087),
    [anon_sym_NA_complex_] = ACTIONS(4087),
    [anon_sym_NA_character_] = ACTIONS(4087),
    [sym_dots] = ACTIONS(4085),
    [sym_dot_dot_i] = ACTIONS(4089),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4091),
    [sym__semicolon] = ACTIONS(263),
    [sym__raw_string_literal] = ACTIONS(4093),
    [sym__external_else] = ACTIONS(263),
    [sym__external_open_parenthesis] = ACTIONS(4095),
    [sym__external_open_brace] = ACTIONS(4097),
    [sym__external_open_bracket] = ACTIONS(263),
    [sym__external_open_bracket2] = ACTIONS(263),
  },
  [367] = {
    [sym_function_definition] = STATE(1771),
    [sym_if_statement] = STATE(1771),
    [sym_for_statement] = STATE(1771),
    [sym_while_statement] = STATE(1771),
    [sym_repeat_statement] = STATE(1771),
    [sym_braced_expression] = STATE(1771),
    [sym_parenthesized_expression] = STATE(1771),
    [sym_call] = STATE(1771),
    [sym_subset] = STATE(1771),
    [sym_subset2] = STATE(1771),
    [sym_unary_operator] = STATE(1771),
    [sym_binary_operator] = STATE(1771),
    [sym_extract_operator] = STATE(1771),
    [sym_namespace_operator] = STATE(1771),
    [sym_integer] = STATE(1771),
    [sym_complex] = STATE(1771),
    [sym_float] = STATE(1771),
    [sym__hex_literal] = STATE(2412),
    [sym__float_literal] = STATE(2412),
    [sym_string] = STATE(2397),
    [sym__single_quoted_string] = STATE(2430),
    [sym__double_quoted_string] = STATE(2466),
    [sym_na] = STATE(1771),
    [sym__expression] = STATE(1771),
    [sym__string_or_identifier] = STATE(5142),
    [sym__open_parenthesis] = STATE(210),
    [sym__open_brace] = STATE(74),
    [aux_sym_function_definition_repeat1] = STATE(2637),
    [sym_identifier] = ACTIONS(2483),
    [anon_sym_BSLASH] = ACTIONS(2485),
    [anon_sym_function] = ACTIONS(2487),
    [anon_sym_EQ] = ACTIONS(455),
    [anon_sym_if] = ACTIONS(2489),
    [anon_sym_for] = ACTIONS(2491),
    [anon_sym_while] = ACTIONS(2493),
    [anon_sym_repeat] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(2497),
    [anon_sym_TILDE] = ACTIONS(2499),
    [anon_sym_BANG] = ACTIONS(2501),
    [anon_sym_PLUS] = ACTIONS(2503),
    [anon_sym_DASH] = ACTIONS(2505),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [anon_sym_LT_LT_DASH] = ACTIONS(453),
    [anon_sym_COLON_EQ] = ACTIONS(453),
    [anon_sym_DASH_GT] = ACTIONS(455),
    [anon_sym_DASH_GT_GT] = ACTIONS(453),
    [anon_sym_PIPE] = ACTIONS(455),
    [anon_sym_AMP] = ACTIONS(455),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(455),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_GT] = ACTIONS(455),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(453),
    [anon_sym_STAR] = ACTIONS(455),
    [anon_sym_SLASH] = ACTIONS(453),
    [anon_sym_STAR_STAR] = ACTIONS(453),
    [anon_sym_CARET] = ACTIONS(453),
    [aux_sym_binary_operator_token1] = ACTIONS(453),
    [anon_sym_PIPE_GT] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(455),
    [anon_sym_DOLLAR] = ACTIONS(453),
    [anon_sym_AT] = ACTIONS(453),
    [aux_sym__hex_literal_token1] = ACTIONS(2507),
    [sym__number_literal] = ACTIONS(2509),
    [anon_sym_SQUOTE] = ACTIONS(2511),
    [anon_sym_DQUOTE] = ACTIONS(2513),
    [sym_return] = ACTIONS(4099),
    [sym_next] = ACTIONS(4099),
    [sym_break] = ACTIONS(4099),
    [sym_true] = ACTIONS(4099),
    [sym_false] = ACTIONS(4099),
    [sym_null] = ACTIONS(4099),
    [sym_inf] = ACTIONS(4099),
    [sym_nan] = ACTIONS(4099),
    [anon_sym_NA] = ACTIONS(2517),
    [anon_sym_NA_integer_] = ACTIONS(2517),
    [anon_sym_NA_real_] = ACTIONS(2517),
    [anon_sym_NA_complex_] = ACTIONS(2517),
    [anon_sym_NA_character_] = ACTIONS(2517),
    [sym_dots] = ACTIONS(4099),
    [sym_dot_dot_i] = ACTIONS(4101),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(453),
    [sym__newline] = ACTIONS(453),
    [sym__raw_string_literal] = ACTIONS(2523),
    [sym__external_open_parenthesis] = ACTIONS(2525),
    [sym__external_close_parenthesis] = ACTIONS(453),
    [sym__external_open_brace] = ACTIONS(2529),
    [sym__external_open_bracket] = ACTIONS(453),
    [sym__external_open_bracket2] = ACTIONS(453),
    [sym__external_close_bracket2] = ACTIONS(453),
  },
  [368] = {
    [sym_function_definition] = STATE(1772),
    [sym_if_statement] = STATE(1772),
    [sym_for_statement] = STATE(1772),
    [sym_while_statement] = STATE(1772),
    [sym_repeat_statement] = STATE(1772),
    [sym_braced_expression] = STATE(1772),
    [sym_parenthesized_expression] = STATE(1772),
    [sym_call] = STATE(1772),
    [sym_subset] = STATE(1772),
    [sym_subset2] = STATE(1772),
    [sym_unary_operator] = STATE(1772),
    [sym_binary_operator] = STATE(1772),
    [sym_extract_operator] = STATE(1772),
    [sym_namespace_operator] = STATE(1772),
    [sym_integer] = STATE(1772),
    [sym_complex] = STATE(1772),
    [sym_float] = STATE(1772),
    [sym__hex_literal] = STATE(2412),
    [sym__float_literal] = STATE(2412),
    [sym_string] = STATE(2397),
    [sym__single_quoted_string] = STATE(2430),
    [sym__double_quoted_string] = STATE(2466),
    [sym_na] = STATE(1772),
    [sym__expression] = STATE(1772),
    [sym__string_or_identifier] = STATE(5142),
    [sym__open_parenthesis] = STATE(210),
    [sym__open_brace] = STATE(74),
    [aux_sym_function_definition_repeat1] = STATE(369),
    [sym_identifier] = ACTIONS(2483),
    [anon_sym_BSLASH] = ACTIONS(2485),
    [anon_sym_function] = ACTIONS(2487),
    [anon_sym_EQ] = ACTIONS(463),
    [anon_sym_if] = ACTIONS(2489),
    [anon_sym_for] = ACTIONS(2491),
    [anon_sym_while] = ACTIONS(2493),
    [anon_sym_repeat] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(2497),
    [anon_sym_TILDE] = ACTIONS(2499),
    [anon_sym_BANG] = ACTIONS(2501),
    [anon_sym_PLUS] = ACTIONS(2503),
    [anon_sym_DASH] = ACTIONS(2505),
    [anon_sym_LT_DASH] = ACTIONS(461),
    [anon_sym_LT_LT_DASH] = ACTIONS(461),
    [anon_sym_COLON_EQ] = ACTIONS(461),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_DASH_GT_GT] = ACTIONS(461),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_PIPE_PIPE] = ACTIONS(461),
    [anon_sym_AMP_AMP] = ACTIONS(461),
    [anon_sym_LT] = ACTIONS(463),
    [anon_sym_LT_EQ] = ACTIONS(461),
    [anon_sym_GT] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(461),
    [anon_sym_EQ_EQ] = ACTIONS(461),
    [anon_sym_BANG_EQ] = ACTIONS(461),
    [anon_sym_STAR] = ACTIONS(463),
    [anon_sym_SLASH] = ACTIONS(461),
    [anon_sym_STAR_STAR] = ACTIONS(461),
    [anon_sym_CARET] = ACTIONS(461),
    [aux_sym_binary_operator_token1] = ACTIONS(461),
    [anon_sym_PIPE_GT] = ACTIONS(461),
    [anon_sym_COLON] = ACTIONS(463),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_AT] = ACTIONS(461),
    [aux_sym__hex_literal_token1] = ACTIONS(2507),
    [sym__number_literal] = ACTIONS(2509),
    [anon_sym_SQUOTE] = ACTIONS(2511),
    [anon_sym_DQUOTE] = ACTIONS(2513),
    [sym_return] = ACTIONS(4103),
    [sym_next] = ACTIONS(4103),
    [sym_break] = ACTIONS(4103),
    [sym_true] = ACTIONS(4103),
    [sym_false] = ACTIONS(4103),
    [sym_null] = ACTIONS(4103),
    [sym_inf] = ACTIONS(4103),
    [sym_nan] = ACTIONS(4103),
    [anon_sym_NA] = ACTIONS(2517),
    [anon_sym_NA_integer_] = ACTIONS(2517),
    [anon_sym_NA_real_] = ACTIONS(2517),
    [anon_sym_NA_complex_] = ACTIONS(2517),
    [anon_sym_NA_character_] = ACTIONS(2517),
    [sym_dots] = ACTIONS(4103),
    [sym_dot_dot_i] = ACTIONS(4105),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(461),
    [sym__newline] = ACTIONS(4107),
    [sym__raw_string_literal] = ACTIONS(2523),
    [sym__external_open_parenthesis] = ACTIONS(2525),
    [sym__external_close_parenthesis] = ACTIONS(461),
    [sym__external_open_brace] = ACTIONS(2529),
    [sym__external_open_bracket] = ACTIONS(461),
    [sym__external_open_bracket2] = ACTIONS(461),
    [sym__external_close_bracket2] = ACTIONS(461),
  },
  [369] = {
    [sym_function_definition] = STATE(1775),
    [sym_if_statement] = STATE(1775),
    [sym_for_statement] = STATE(1775),
    [sym_while_statement] = STATE(1775),
    [sym_repeat_statement] = STATE(1775),
    [sym_braced_expression] = STATE(1775),
    [sym_parenthesized_expression] = STATE(1775),
    [sym_call] = STATE(1775),
    [sym_subset] = STATE(1775),
    [sym_subset2] = STATE(1775),
    [sym_unary_operator] = STATE(1775),
    [sym_binary_operator] = STATE(1775),
    [sym_extract_operator] = STATE(1775),
    [sym_namespace_operator] = STATE(1775),
    [sym_integer] = STATE(1775),
    [sym_complex] = STATE(1775),
    [sym_float] = STATE(1775),
    [sym__hex_literal] = STATE(2412),
    [sym__float_literal] = STATE(2412),
    [sym_string] = STATE(2397),
    [sym__single_quoted_string] = STATE(2430),
    [sym__double_quoted_string] = STATE(2466),
    [sym_na] = STATE(1775),
    [sym__expression] = STATE(1775),
    [sym__string_or_identifier] = STATE(5142),
    [sym__open_parenthesis] = STATE(210),
    [sym__open_brace] = STATE(74),
    [aux_sym_function_definition_repeat1] = STATE(2637),
    [sym_identifier] = ACTIONS(2483),
    [anon_sym_BSLASH] = ACTIONS(2485),
    [anon_sym_function] = ACTIONS(2487),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_if] = ACTIONS(2489),
    [anon_sym_for] = ACTIONS(2491),
    [anon_sym_while] = ACTIONS(2493),
    [anon_sym_repeat] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(2497),
    [anon_sym_TILDE] = ACTIONS(2499),
    [anon_sym_BANG] = ACTIONS(2501),
    [anon_sym_PLUS] = ACTIONS(2503),
    [anon_sym_DASH] = ACTIONS(2505),
    [anon_sym_LT_DASH] = ACTIONS(471),
    [anon_sym_LT_LT_DASH] = ACTIONS(471),
    [anon_sym_COLON_EQ] = ACTIONS(471),
    [anon_sym_DASH_GT] = ACTIONS(473),
    [anon_sym_DASH_GT_GT] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(473),
    [anon_sym_AMP] = ACTIONS(473),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_LT_EQ] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(473),
    [anon_sym_GT_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_STAR] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [aux_sym_binary_operator_token1] = ACTIONS(471),
    [anon_sym_PIPE_GT] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(473),
    [anon_sym_DOLLAR] = ACTIONS(471),
    [anon_sym_AT] = ACTIONS(471),
    [aux_sym__hex_literal_token1] = ACTIONS(2507),
    [sym__number_literal] = ACTIONS(2509),
    [anon_sym_SQUOTE] = ACTIONS(2511),
    [anon_sym_DQUOTE] = ACTIONS(2513),
    [sym_return] = ACTIONS(4109),
    [sym_next] = ACTIONS(4109),
    [sym_break] = ACTIONS(4109),
    [sym_true] = ACTIONS(4109),
    [sym_false] = ACTIONS(4109),
    [sym_null] = ACTIONS(4109),
    [sym_inf] = ACTIONS(4109),
    [sym_nan] = ACTIONS(4109),
    [anon_sym_NA] = ACTIONS(2517),
    [anon_sym_NA_integer_] = ACTIONS(2517),
    [anon_sym_NA_real_] = ACTIONS(2517),
    [anon_sym_NA_complex_] = ACTIONS(2517),
    [anon_sym_NA_character_] = ACTIONS(2517),
    [sym_dots] = ACTIONS(4109),
    [sym_dot_dot_i] = ACTIONS(4111),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(471),
    [sym__newline] = ACTIONS(471),
    [sym__raw_string_literal] = ACTIONS(2523),
    [sym__external_open_parenthesis] = ACTIONS(2525),
    [sym__external_close_parenthesis] = ACTIONS(471),
    [sym__external_open_brace] = ACTIONS(2529),
    [sym__external_open_bracket] = ACTIONS(471),
    [sym__external_open_bracket2] = ACTIONS(471),
    [sym__external_close_bracket2] = ACTIONS(471),
  },
  [370] = {
    [sym_function_definition] = STATE(1867),
    [sym_if_statement] = STATE(1867),
    [sym_for_statement] = STATE(1867),
    [sym_while_statement] = STATE(1867),
    [sym_repeat_statement] = STATE(1867),
    [sym_braced_expression] = STATE(1867),
    [sym_parenthesized_expression] = STATE(1867),
    [sym_call] = STATE(1867),
    [sym_subset] = STATE(1867),
    [sym_subset2] = STATE(1867),
    [sym_unary_operator] = STATE(1867),
    [sym_binary_operator] = STATE(1867),
    [sym_extract_operator] = STATE(1867),
    [sym_namespace_operator] = STATE(1867),
    [sym_integer] = STATE(1867),
    [sym_complex] = STATE(1867),
    [sym_float] = STATE(1867),
    [sym__hex_literal] = STATE(2540),
    [sym__float_literal] = STATE(2540),
    [sym_string] = STATE(2541),
    [sym__single_quoted_string] = STATE(2462),
    [sym__double_quoted_string] = STATE(2494),
    [sym_na] = STATE(1867),
    [sym__expression] = STATE(1867),
    [sym__string_or_identifier] = STATE(5128),
    [sym__open_parenthesis] = STATE(246),
    [sym__open_brace] = STATE(173),
    [aux_sym_function_definition_repeat1] = STATE(298),
    [ts_builtin_sym_end] = ACTIONS(387),
    [sym_identifier] = ACTIONS(2943),
    [anon_sym_BSLASH] = ACTIONS(2945),
    [anon_sym_function] = ACTIONS(2947),
    [anon_sym_EQ] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(2949),
    [anon_sym_for] = ACTIONS(2951),
    [anon_sym_while] = ACTIONS(2953),
    [anon_sym_repeat] = ACTIONS(2955),
    [anon_sym_QMARK] = ACTIONS(2957),
    [anon_sym_TILDE] = ACTIONS(2959),
    [anon_sym_BANG] = ACTIONS(2961),
    [anon_sym_PLUS] = ACTIONS(2963),
    [anon_sym_DASH] = ACTIONS(2965),
    [anon_sym_LT_DASH] = ACTIONS(387),
    [anon_sym_LT_LT_DASH] = ACTIONS(387),
    [anon_sym_COLON_EQ] = ACTIONS(387),
    [anon_sym_DASH_GT] = ACTIONS(389),
    [anon_sym_DASH_GT_GT] = ACTIONS(387),
    [anon_sym_PIPE] = ACTIONS(389),
    [anon_sym_AMP] = ACTIONS(389),
    [anon_sym_PIPE_PIPE] = ACTIONS(387),
    [anon_sym_AMP_AMP] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(389),
    [anon_sym_LT_EQ] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(389),
    [anon_sym_GT_EQ] = ACTIONS(387),
    [anon_sym_EQ_EQ] = ACTIONS(387),
    [anon_sym_BANG_EQ] = ACTIONS(387),
    [anon_sym_STAR] = ACTIONS(389),
    [anon_sym_SLASH] = ACTIONS(387),
    [anon_sym_STAR_STAR] = ACTIONS(387),
    [anon_sym_CARET] = ACTIONS(387),
    [aux_sym_binary_operator_token1] = ACTIONS(387),
    [anon_sym_PIPE_GT] = ACTIONS(387),
    [anon_sym_COLON] = ACTIONS(389),
    [anon_sym_DOLLAR] = ACTIONS(387),
    [anon_sym_AT] = ACTIONS(387),
    [aux_sym__hex_literal_token1] = ACTIONS(2967),
    [sym__number_literal] = ACTIONS(2969),
    [anon_sym_SQUOTE] = ACTIONS(2971),
    [anon_sym_DQUOTE] = ACTIONS(2973),
    [sym_return] = ACTIONS(4113),
    [sym_next] = ACTIONS(4113),
    [sym_break] = ACTIONS(4113),
    [sym_true] = ACTIONS(4113),
    [sym_false] = ACTIONS(4113),
    [sym_null] = ACTIONS(4113),
    [sym_inf] = ACTIONS(4113),
    [sym_nan] = ACTIONS(4113),
    [anon_sym_NA] = ACTIONS(2977),
    [anon_sym_NA_integer_] = ACTIONS(2977),
    [anon_sym_NA_real_] = ACTIONS(2977),
    [anon_sym_NA_complex_] = ACTIONS(2977),
    [anon_sym_NA_character_] = ACTIONS(2977),
    [sym_dots] = ACTIONS(4113),
    [sym_dot_dot_i] = ACTIONS(4115),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4117),
    [sym__semicolon] = ACTIONS(387),
    [sym__raw_string_literal] = ACTIONS(2983),
    [sym__external_open_parenthesis] = ACTIONS(2985),
    [sym__external_close_parenthesis] = ACTIONS(387),
    [sym__external_open_brace] = ACTIONS(2989),
    [sym__external_open_bracket] = ACTIONS(387),
    [sym__external_open_bracket2] = ACTIONS(387),
  },
  [371] = {
    [sym_function_definition] = STATE(1612),
    [sym_if_statement] = STATE(1612),
    [sym_for_statement] = STATE(1612),
    [sym_while_statement] = STATE(1612),
    [sym_repeat_statement] = STATE(1612),
    [sym_braced_expression] = STATE(1612),
    [sym_parenthesized_expression] = STATE(1612),
    [sym_call] = STATE(1612),
    [sym_subset] = STATE(1612),
    [sym_subset2] = STATE(1612),
    [sym_unary_operator] = STATE(1612),
    [sym_binary_operator] = STATE(1612),
    [sym_extract_operator] = STATE(1612),
    [sym_namespace_operator] = STATE(1612),
    [sym_integer] = STATE(1612),
    [sym_complex] = STATE(1612),
    [sym_float] = STATE(1612),
    [sym__hex_literal] = STATE(2523),
    [sym__float_literal] = STATE(2523),
    [sym_string] = STATE(2522),
    [sym__single_quoted_string] = STATE(2528),
    [sym__double_quoted_string] = STATE(2529),
    [sym_na] = STATE(1612),
    [sym__expression] = STATE(1612),
    [sym__string_or_identifier] = STATE(5126),
    [sym__open_parenthesis] = STATE(178),
    [sym__open_brace] = STATE(244),
    [aux_sym_function_definition_repeat1] = STATE(343),
    [ts_builtin_sym_end] = ACTIONS(531),
    [sym_identifier] = ACTIONS(2826),
    [anon_sym_BSLASH] = ACTIONS(2828),
    [anon_sym_function] = ACTIONS(2830),
    [anon_sym_EQ] = ACTIONS(533),
    [anon_sym_if] = ACTIONS(2832),
    [anon_sym_for] = ACTIONS(2834),
    [anon_sym_while] = ACTIONS(2836),
    [anon_sym_repeat] = ACTIONS(2838),
    [anon_sym_QMARK] = ACTIONS(2840),
    [anon_sym_TILDE] = ACTIONS(2842),
    [anon_sym_BANG] = ACTIONS(2844),
    [anon_sym_PLUS] = ACTIONS(2846),
    [anon_sym_DASH] = ACTIONS(2848),
    [anon_sym_LT_DASH] = ACTIONS(531),
    [anon_sym_LT_LT_DASH] = ACTIONS(531),
    [anon_sym_COLON_EQ] = ACTIONS(531),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_DASH_GT_GT] = ACTIONS(531),
    [anon_sym_PIPE] = ACTIONS(533),
    [anon_sym_AMP] = ACTIONS(533),
    [anon_sym_PIPE_PIPE] = ACTIONS(531),
    [anon_sym_AMP_AMP] = ACTIONS(531),
    [anon_sym_LT] = ACTIONS(533),
    [anon_sym_LT_EQ] = ACTIONS(531),
    [anon_sym_GT] = ACTIONS(533),
    [anon_sym_GT_EQ] = ACTIONS(531),
    [anon_sym_EQ_EQ] = ACTIONS(531),
    [anon_sym_BANG_EQ] = ACTIONS(531),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_SLASH] = ACTIONS(531),
    [anon_sym_STAR_STAR] = ACTIONS(531),
    [anon_sym_CARET] = ACTIONS(531),
    [aux_sym_binary_operator_token1] = ACTIONS(531),
    [anon_sym_PIPE_GT] = ACTIONS(531),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_DOLLAR] = ACTIONS(531),
    [anon_sym_AT] = ACTIONS(531),
    [aux_sym__hex_literal_token1] = ACTIONS(2850),
    [sym__number_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE] = ACTIONS(2856),
    [sym_return] = ACTIONS(4119),
    [sym_next] = ACTIONS(4119),
    [sym_break] = ACTIONS(4119),
    [sym_true] = ACTIONS(4119),
    [sym_false] = ACTIONS(4119),
    [sym_null] = ACTIONS(4119),
    [sym_inf] = ACTIONS(4119),
    [sym_nan] = ACTIONS(4119),
    [anon_sym_NA] = ACTIONS(2860),
    [anon_sym_NA_integer_] = ACTIONS(2860),
    [anon_sym_NA_real_] = ACTIONS(2860),
    [anon_sym_NA_complex_] = ACTIONS(2860),
    [anon_sym_NA_character_] = ACTIONS(2860),
    [sym_dots] = ACTIONS(4119),
    [sym_dot_dot_i] = ACTIONS(4121),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4123),
    [sym__semicolon] = ACTIONS(531),
    [sym__raw_string_literal] = ACTIONS(2866),
    [sym__external_open_parenthesis] = ACTIONS(2868),
    [sym__external_open_brace] = ACTIONS(2870),
    [sym__external_close_brace] = ACTIONS(531),
    [sym__external_open_bracket] = ACTIONS(531),
    [sym__external_open_bracket2] = ACTIONS(531),
  },
  [372] = {
    [sym_function_definition] = STATE(1445),
    [sym_if_statement] = STATE(1445),
    [sym_for_statement] = STATE(1445),
    [sym_while_statement] = STATE(1445),
    [sym_repeat_statement] = STATE(1445),
    [sym_braced_expression] = STATE(1445),
    [sym_parenthesized_expression] = STATE(1445),
    [sym_call] = STATE(1445),
    [sym_subset] = STATE(1445),
    [sym_subset2] = STATE(1445),
    [sym_unary_operator] = STATE(1445),
    [sym_binary_operator] = STATE(1445),
    [sym_extract_operator] = STATE(1445),
    [sym_namespace_operator] = STATE(1445),
    [sym_integer] = STATE(1445),
    [sym_complex] = STATE(1445),
    [sym_float] = STATE(1445),
    [sym__hex_literal] = STATE(2523),
    [sym__float_literal] = STATE(2523),
    [sym_string] = STATE(2522),
    [sym__single_quoted_string] = STATE(2528),
    [sym__double_quoted_string] = STATE(2529),
    [sym_na] = STATE(1445),
    [sym__expression] = STATE(1445),
    [sym__string_or_identifier] = STATE(5126),
    [sym__open_parenthesis] = STATE(178),
    [sym__open_brace] = STATE(244),
    [aux_sym_braced_expression_repeat1] = STATE(372),
    [ts_builtin_sym_end] = ACTIONS(591),
    [sym_identifier] = ACTIONS(4125),
    [anon_sym_BSLASH] = ACTIONS(4128),
    [anon_sym_function] = ACTIONS(4131),
    [anon_sym_EQ] = ACTIONS(562),
    [anon_sym_if] = ACTIONS(4134),
    [anon_sym_for] = ACTIONS(4137),
    [anon_sym_while] = ACTIONS(4140),
    [anon_sym_repeat] = ACTIONS(4143),
    [anon_sym_QMARK] = ACTIONS(4146),
    [anon_sym_TILDE] = ACTIONS(4149),
    [anon_sym_BANG] = ACTIONS(4152),
    [anon_sym_PLUS] = ACTIONS(4155),
    [anon_sym_DASH] = ACTIONS(4158),
    [anon_sym_LT_DASH] = ACTIONS(591),
    [anon_sym_LT_LT_DASH] = ACTIONS(591),
    [anon_sym_COLON_EQ] = ACTIONS(591),
    [anon_sym_DASH_GT] = ACTIONS(562),
    [anon_sym_DASH_GT_GT] = ACTIONS(591),
    [anon_sym_PIPE] = ACTIONS(562),
    [anon_sym_AMP] = ACTIONS(562),
    [anon_sym_PIPE_PIPE] = ACTIONS(591),
    [anon_sym_AMP_AMP] = ACTIONS(591),
    [anon_sym_LT] = ACTIONS(562),
    [anon_sym_LT_EQ] = ACTIONS(591),
    [anon_sym_GT] = ACTIONS(562),
    [anon_sym_GT_EQ] = ACTIONS(591),
    [anon_sym_EQ_EQ] = ACTIONS(591),
    [anon_sym_BANG_EQ] = ACTIONS(591),
    [anon_sym_STAR] = ACTIONS(562),
    [anon_sym_SLASH] = ACTIONS(591),
    [anon_sym_STAR_STAR] = ACTIONS(591),
    [anon_sym_CARET] = ACTIONS(591),
    [aux_sym_binary_operator_token1] = ACTIONS(591),
    [anon_sym_PIPE_GT] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(562),
    [anon_sym_DOLLAR] = ACTIONS(591),
    [anon_sym_AT] = ACTIONS(591),
    [aux_sym__hex_literal_token1] = ACTIONS(4161),
    [sym__number_literal] = ACTIONS(4164),
    [anon_sym_SQUOTE] = ACTIONS(4167),
    [anon_sym_DQUOTE] = ACTIONS(4170),
    [sym_return] = ACTIONS(4173),
    [sym_next] = ACTIONS(4173),
    [sym_break] = ACTIONS(4173),
    [sym_true] = ACTIONS(4173),
    [sym_false] = ACTIONS(4173),
    [sym_null] = ACTIONS(4173),
    [sym_inf] = ACTIONS(4173),
    [sym_nan] = ACTIONS(4173),
    [anon_sym_NA] = ACTIONS(4176),
    [anon_sym_NA_integer_] = ACTIONS(4176),
    [anon_sym_NA_real_] = ACTIONS(4176),
    [anon_sym_NA_complex_] = ACTIONS(4176),
    [anon_sym_NA_character_] = ACTIONS(4176),
    [sym_dots] = ACTIONS(4173),
    [sym_dot_dot_i] = ACTIONS(4179),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4182),
    [sym__semicolon] = ACTIONS(4182),
    [sym__raw_string_literal] = ACTIONS(4185),
    [sym__external_open_parenthesis] = ACTIONS(4188),
    [sym__external_open_brace] = ACTIONS(4191),
    [sym__external_close_brace] = ACTIONS(591),
    [sym__external_open_bracket] = ACTIONS(591),
    [sym__external_open_bracket2] = ACTIONS(591),
  },
  [373] = {
    [sym_function_definition] = STATE(1561),
    [sym_if_statement] = STATE(1561),
    [sym_for_statement] = STATE(1561),
    [sym_while_statement] = STATE(1561),
    [sym_repeat_statement] = STATE(1561),
    [sym_braced_expression] = STATE(1561),
    [sym_parenthesized_expression] = STATE(1561),
    [sym_call] = STATE(1561),
    [sym_subset] = STATE(1561),
    [sym_subset2] = STATE(1561),
    [sym_unary_operator] = STATE(1561),
    [sym_binary_operator] = STATE(1561),
    [sym_extract_operator] = STATE(1561),
    [sym_namespace_operator] = STATE(1561),
    [sym_integer] = STATE(1561),
    [sym_complex] = STATE(1561),
    [sym_float] = STATE(1561),
    [sym__hex_literal] = STATE(2540),
    [sym__float_literal] = STATE(2540),
    [sym_string] = STATE(2541),
    [sym__single_quoted_string] = STATE(2462),
    [sym__double_quoted_string] = STATE(2494),
    [sym_na] = STATE(1561),
    [sym__expression] = STATE(1561),
    [sym__string_or_identifier] = STATE(5128),
    [sym__open_parenthesis] = STATE(246),
    [sym__open_brace] = STATE(173),
    [aux_sym_function_definition_repeat1] = STATE(357),
    [ts_builtin_sym_end] = ACTIONS(263),
    [sym_identifier] = ACTIONS(2943),
    [anon_sym_BSLASH] = ACTIONS(2945),
    [anon_sym_function] = ACTIONS(2947),
    [anon_sym_EQ] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(2949),
    [anon_sym_for] = ACTIONS(2951),
    [anon_sym_while] = ACTIONS(2953),
    [anon_sym_repeat] = ACTIONS(2955),
    [anon_sym_QMARK] = ACTIONS(2957),
    [anon_sym_TILDE] = ACTIONS(2959),
    [anon_sym_BANG] = ACTIONS(2961),
    [anon_sym_PLUS] = ACTIONS(2963),
    [anon_sym_DASH] = ACTIONS(2965),
    [anon_sym_LT_DASH] = ACTIONS(263),
    [anon_sym_LT_LT_DASH] = ACTIONS(263),
    [anon_sym_COLON_EQ] = ACTIONS(263),
    [anon_sym_DASH_GT] = ACTIONS(265),
    [anon_sym_DASH_GT_GT] = ACTIONS(263),
    [anon_sym_PIPE] = ACTIONS(265),
    [anon_sym_AMP] = ACTIONS(265),
    [anon_sym_PIPE_PIPE] = ACTIONS(263),
    [anon_sym_AMP_AMP] = ACTIONS(263),
    [anon_sym_LT] = ACTIONS(265),
    [anon_sym_LT_EQ] = ACTIONS(263),
    [anon_sym_GT] = ACTIONS(265),
    [anon_sym_GT_EQ] = ACTIONS(263),
    [anon_sym_EQ_EQ] = ACTIONS(263),
    [anon_sym_BANG_EQ] = ACTIONS(263),
    [anon_sym_STAR] = ACTIONS(265),
    [anon_sym_SLASH] = ACTIONS(263),
    [anon_sym_STAR_STAR] = ACTIONS(263),
    [anon_sym_CARET] = ACTIONS(263),
    [aux_sym_binary_operator_token1] = ACTIONS(263),
    [anon_sym_PIPE_GT] = ACTIONS(263),
    [anon_sym_COLON] = ACTIONS(265),
    [anon_sym_DOLLAR] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(263),
    [aux_sym__hex_literal_token1] = ACTIONS(2967),
    [sym__number_literal] = ACTIONS(2969),
    [anon_sym_SQUOTE] = ACTIONS(2971),
    [anon_sym_DQUOTE] = ACTIONS(2973),
    [sym_return] = ACTIONS(4194),
    [sym_next] = ACTIONS(4194),
    [sym_break] = ACTIONS(4194),
    [sym_true] = ACTIONS(4194),
    [sym_false] = ACTIONS(4194),
    [sym_null] = ACTIONS(4194),
    [sym_inf] = ACTIONS(4194),
    [sym_nan] = ACTIONS(4194),
    [anon_sym_NA] = ACTIONS(2977),
    [anon_sym_NA_integer_] = ACTIONS(2977),
    [anon_sym_NA_real_] = ACTIONS(2977),
    [anon_sym_NA_complex_] = ACTIONS(2977),
    [anon_sym_NA_character_] = ACTIONS(2977),
    [sym_dots] = ACTIONS(4194),
    [sym_dot_dot_i] = ACTIONS(4196),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4198),
    [sym__semicolon] = ACTIONS(263),
    [sym__raw_string_literal] = ACTIONS(2983),
    [sym__external_open_parenthesis] = ACTIONS(2985),
    [sym__external_close_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(2989),
    [sym__external_open_bracket] = ACTIONS(263),
    [sym__external_open_bracket2] = ACTIONS(263),
  },
  [374] = {
    [sym_function_definition] = STATE(1869),
    [sym_if_statement] = STATE(1869),
    [sym_for_statement] = STATE(1869),
    [sym_while_statement] = STATE(1869),
    [sym_repeat_statement] = STATE(1869),
    [sym_braced_expression] = STATE(1869),
    [sym_parenthesized_expression] = STATE(1869),
    [sym_call] = STATE(1869),
    [sym_subset] = STATE(1869),
    [sym_subset2] = STATE(1869),
    [sym_unary_operator] = STATE(1869),
    [sym_binary_operator] = STATE(1869),
    [sym_extract_operator] = STATE(1869),
    [sym_namespace_operator] = STATE(1869),
    [sym_integer] = STATE(1869),
    [sym_complex] = STATE(1869),
    [sym_float] = STATE(1869),
    [sym__hex_literal] = STATE(2540),
    [sym__float_literal] = STATE(2540),
    [sym_string] = STATE(2541),
    [sym__single_quoted_string] = STATE(2462),
    [sym__double_quoted_string] = STATE(2494),
    [sym_na] = STATE(1869),
    [sym__expression] = STATE(1869),
    [sym__string_or_identifier] = STATE(5128),
    [sym__open_parenthesis] = STATE(246),
    [sym__open_brace] = STATE(173),
    [aux_sym_function_definition_repeat1] = STATE(2670),
    [ts_builtin_sym_end] = ACTIONS(397),
    [sym_identifier] = ACTIONS(2943),
    [anon_sym_BSLASH] = ACTIONS(2945),
    [anon_sym_function] = ACTIONS(2947),
    [anon_sym_EQ] = ACTIONS(399),
    [anon_sym_if] = ACTIONS(2949),
    [anon_sym_for] = ACTIONS(2951),
    [anon_sym_while] = ACTIONS(2953),
    [anon_sym_repeat] = ACTIONS(2955),
    [anon_sym_QMARK] = ACTIONS(2957),
    [anon_sym_TILDE] = ACTIONS(2959),
    [anon_sym_BANG] = ACTIONS(2961),
    [anon_sym_PLUS] = ACTIONS(2963),
    [anon_sym_DASH] = ACTIONS(2965),
    [anon_sym_LT_DASH] = ACTIONS(397),
    [anon_sym_LT_LT_DASH] = ACTIONS(397),
    [anon_sym_COLON_EQ] = ACTIONS(397),
    [anon_sym_DASH_GT] = ACTIONS(399),
    [anon_sym_DASH_GT_GT] = ACTIONS(397),
    [anon_sym_PIPE] = ACTIONS(399),
    [anon_sym_AMP] = ACTIONS(399),
    [anon_sym_PIPE_PIPE] = ACTIONS(397),
    [anon_sym_AMP_AMP] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(399),
    [anon_sym_LT_EQ] = ACTIONS(397),
    [anon_sym_GT] = ACTIONS(399),
    [anon_sym_GT_EQ] = ACTIONS(397),
    [anon_sym_EQ_EQ] = ACTIONS(397),
    [anon_sym_BANG_EQ] = ACTIONS(397),
    [anon_sym_STAR] = ACTIONS(399),
    [anon_sym_SLASH] = ACTIONS(397),
    [anon_sym_STAR_STAR] = ACTIONS(397),
    [anon_sym_CARET] = ACTIONS(397),
    [aux_sym_binary_operator_token1] = ACTIONS(397),
    [anon_sym_PIPE_GT] = ACTIONS(397),
    [anon_sym_COLON] = ACTIONS(399),
    [anon_sym_DOLLAR] = ACTIONS(397),
    [anon_sym_AT] = ACTIONS(397),
    [aux_sym__hex_literal_token1] = ACTIONS(2967),
    [sym__number_literal] = ACTIONS(2969),
    [anon_sym_SQUOTE] = ACTIONS(2971),
    [anon_sym_DQUOTE] = ACTIONS(2973),
    [sym_return] = ACTIONS(4200),
    [sym_next] = ACTIONS(4200),
    [sym_break] = ACTIONS(4200),
    [sym_true] = ACTIONS(4200),
    [sym_false] = ACTIONS(4200),
    [sym_null] = ACTIONS(4200),
    [sym_inf] = ACTIONS(4200),
    [sym_nan] = ACTIONS(4200),
    [anon_sym_NA] = ACTIONS(2977),
    [anon_sym_NA_integer_] = ACTIONS(2977),
    [anon_sym_NA_real_] = ACTIONS(2977),
    [anon_sym_NA_complex_] = ACTIONS(2977),
    [anon_sym_NA_character_] = ACTIONS(2977),
    [sym_dots] = ACTIONS(4200),
    [sym_dot_dot_i] = ACTIONS(4202),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(397),
    [sym__semicolon] = ACTIONS(397),
    [sym__raw_string_literal] = ACTIONS(2983),
    [sym__external_open_parenthesis] = ACTIONS(2985),
    [sym__external_close_parenthesis] = ACTIONS(397),
    [sym__external_open_brace] = ACTIONS(2989),
    [sym__external_open_bracket] = ACTIONS(397),
    [sym__external_open_bracket2] = ACTIONS(397),
  },
  [375] = {
    [sym_function_definition] = STATE(1882),
    [sym_if_statement] = STATE(1882),
    [sym_for_statement] = STATE(1882),
    [sym_while_statement] = STATE(1882),
    [sym_repeat_statement] = STATE(1882),
    [sym_braced_expression] = STATE(1882),
    [sym_parenthesized_expression] = STATE(1882),
    [sym_call] = STATE(1882),
    [sym_subset] = STATE(1882),
    [sym_subset2] = STATE(1882),
    [sym_unary_operator] = STATE(1882),
    [sym_binary_operator] = STATE(1882),
    [sym_extract_operator] = STATE(1882),
    [sym_namespace_operator] = STATE(1882),
    [sym_integer] = STATE(1882),
    [sym_complex] = STATE(1882),
    [sym_float] = STATE(1882),
    [sym__hex_literal] = STATE(2536),
    [sym__float_literal] = STATE(2536),
    [sym_string] = STATE(2534),
    [sym__single_quoted_string] = STATE(2538),
    [sym__double_quoted_string] = STATE(2539),
    [sym_na] = STATE(1882),
    [sym__expression] = STATE(1882),
    [sym__string_or_identifier] = STATE(5143),
    [sym__open_parenthesis] = STATE(150),
    [sym__open_brace] = STATE(133),
    [aux_sym_function_definition_repeat1] = STATE(380),
    [ts_builtin_sym_end] = ACTIONS(545),
    [sym_identifier] = ACTIONS(4053),
    [anon_sym_BSLASH] = ACTIONS(4055),
    [anon_sym_function] = ACTIONS(4057),
    [anon_sym_EQ] = ACTIONS(543),
    [anon_sym_if] = ACTIONS(4059),
    [anon_sym_for] = ACTIONS(4061),
    [anon_sym_while] = ACTIONS(4063),
    [anon_sym_repeat] = ACTIONS(4065),
    [anon_sym_QMARK] = ACTIONS(4067),
    [anon_sym_TILDE] = ACTIONS(4069),
    [anon_sym_BANG] = ACTIONS(4071),
    [anon_sym_PLUS] = ACTIONS(4073),
    [anon_sym_DASH] = ACTIONS(4075),
    [anon_sym_LT_DASH] = ACTIONS(545),
    [anon_sym_LT_LT_DASH] = ACTIONS(545),
    [anon_sym_COLON_EQ] = ACTIONS(545),
    [anon_sym_DASH_GT] = ACTIONS(543),
    [anon_sym_DASH_GT_GT] = ACTIONS(545),
    [anon_sym_PIPE] = ACTIONS(543),
    [anon_sym_AMP] = ACTIONS(543),
    [anon_sym_PIPE_PIPE] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(543),
    [anon_sym_LT_EQ] = ACTIONS(545),
    [anon_sym_GT] = ACTIONS(543),
    [anon_sym_GT_EQ] = ACTIONS(545),
    [anon_sym_EQ_EQ] = ACTIONS(545),
    [anon_sym_BANG_EQ] = ACTIONS(545),
    [anon_sym_STAR] = ACTIONS(543),
    [anon_sym_SLASH] = ACTIONS(545),
    [anon_sym_STAR_STAR] = ACTIONS(545),
    [anon_sym_CARET] = ACTIONS(545),
    [aux_sym_binary_operator_token1] = ACTIONS(545),
    [anon_sym_PIPE_GT] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(543),
    [anon_sym_DOLLAR] = ACTIONS(545),
    [anon_sym_AT] = ACTIONS(545),
    [aux_sym__hex_literal_token1] = ACTIONS(4077),
    [sym__number_literal] = ACTIONS(4079),
    [anon_sym_SQUOTE] = ACTIONS(4081),
    [anon_sym_DQUOTE] = ACTIONS(4083),
    [sym_return] = ACTIONS(4204),
    [sym_next] = ACTIONS(4204),
    [sym_break] = ACTIONS(4204),
    [sym_true] = ACTIONS(4204),
    [sym_false] = ACTIONS(4204),
    [sym_null] = ACTIONS(4204),
    [sym_inf] = ACTIONS(4204),
    [sym_nan] = ACTIONS(4204),
    [anon_sym_NA] = ACTIONS(4087),
    [anon_sym_NA_integer_] = ACTIONS(4087),
    [anon_sym_NA_real_] = ACTIONS(4087),
    [anon_sym_NA_complex_] = ACTIONS(4087),
    [anon_sym_NA_character_] = ACTIONS(4087),
    [sym_dots] = ACTIONS(4204),
    [sym_dot_dot_i] = ACTIONS(4206),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4208),
    [sym__semicolon] = ACTIONS(545),
    [sym__raw_string_literal] = ACTIONS(4093),
    [sym__external_else] = ACTIONS(545),
    [sym__external_open_parenthesis] = ACTIONS(4095),
    [sym__external_open_brace] = ACTIONS(4097),
    [sym__external_open_bracket] = ACTIONS(545),
    [sym__external_open_bracket2] = ACTIONS(545),
  },
  [376] = {
    [sym_function_definition] = STATE(1864),
    [sym_if_statement] = STATE(1864),
    [sym_for_statement] = STATE(1864),
    [sym_while_statement] = STATE(1864),
    [sym_repeat_statement] = STATE(1864),
    [sym_braced_expression] = STATE(1864),
    [sym_parenthesized_expression] = STATE(1864),
    [sym_call] = STATE(1864),
    [sym_subset] = STATE(1864),
    [sym_subset2] = STATE(1864),
    [sym_unary_operator] = STATE(1864),
    [sym_binary_operator] = STATE(1864),
    [sym_extract_operator] = STATE(1864),
    [sym_namespace_operator] = STATE(1864),
    [sym_integer] = STATE(1864),
    [sym_complex] = STATE(1864),
    [sym_float] = STATE(1864),
    [sym__hex_literal] = STATE(2536),
    [sym__float_literal] = STATE(2536),
    [sym_string] = STATE(2534),
    [sym__single_quoted_string] = STATE(2538),
    [sym__double_quoted_string] = STATE(2539),
    [sym_na] = STATE(1864),
    [sym__expression] = STATE(1864),
    [sym__string_or_identifier] = STATE(5143),
    [sym__open_parenthesis] = STATE(150),
    [sym__open_brace] = STATE(133),
    [aux_sym_function_definition_repeat1] = STATE(2742),
    [ts_builtin_sym_end] = ACTIONS(765),
    [sym_identifier] = ACTIONS(4053),
    [anon_sym_BSLASH] = ACTIONS(4055),
    [anon_sym_function] = ACTIONS(4057),
    [anon_sym_EQ] = ACTIONS(767),
    [anon_sym_if] = ACTIONS(4059),
    [anon_sym_for] = ACTIONS(4061),
    [anon_sym_while] = ACTIONS(4063),
    [anon_sym_repeat] = ACTIONS(4065),
    [anon_sym_QMARK] = ACTIONS(4067),
    [anon_sym_TILDE] = ACTIONS(4069),
    [anon_sym_BANG] = ACTIONS(4071),
    [anon_sym_PLUS] = ACTIONS(4073),
    [anon_sym_DASH] = ACTIONS(4075),
    [anon_sym_LT_DASH] = ACTIONS(765),
    [anon_sym_LT_LT_DASH] = ACTIONS(765),
    [anon_sym_COLON_EQ] = ACTIONS(765),
    [anon_sym_DASH_GT] = ACTIONS(767),
    [anon_sym_DASH_GT_GT] = ACTIONS(765),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_AMP] = ACTIONS(767),
    [anon_sym_PIPE_PIPE] = ACTIONS(765),
    [anon_sym_AMP_AMP] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(767),
    [anon_sym_LT_EQ] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_GT_EQ] = ACTIONS(765),
    [anon_sym_EQ_EQ] = ACTIONS(765),
    [anon_sym_BANG_EQ] = ACTIONS(765),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(765),
    [anon_sym_STAR_STAR] = ACTIONS(765),
    [anon_sym_CARET] = ACTIONS(765),
    [aux_sym_binary_operator_token1] = ACTIONS(765),
    [anon_sym_PIPE_GT] = ACTIONS(765),
    [anon_sym_COLON] = ACTIONS(767),
    [anon_sym_DOLLAR] = ACTIONS(765),
    [anon_sym_AT] = ACTIONS(765),
    [aux_sym__hex_literal_token1] = ACTIONS(4077),
    [sym__number_literal] = ACTIONS(4079),
    [anon_sym_SQUOTE] = ACTIONS(4081),
    [anon_sym_DQUOTE] = ACTIONS(4083),
    [sym_return] = ACTIONS(4210),
    [sym_next] = ACTIONS(4210),
    [sym_break] = ACTIONS(4210),
    [sym_true] = ACTIONS(4210),
    [sym_false] = ACTIONS(4210),
    [sym_null] = ACTIONS(4210),
    [sym_inf] = ACTIONS(4210),
    [sym_nan] = ACTIONS(4210),
    [anon_sym_NA] = ACTIONS(4087),
    [anon_sym_NA_integer_] = ACTIONS(4087),
    [anon_sym_NA_real_] = ACTIONS(4087),
    [anon_sym_NA_complex_] = ACTIONS(4087),
    [anon_sym_NA_character_] = ACTIONS(4087),
    [sym_dots] = ACTIONS(4210),
    [sym_dot_dot_i] = ACTIONS(4212),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(765),
    [sym__semicolon] = ACTIONS(765),
    [sym__raw_string_literal] = ACTIONS(4093),
    [sym__external_else] = ACTIONS(765),
    [sym__external_open_parenthesis] = ACTIONS(4095),
    [sym__external_open_brace] = ACTIONS(4097),
    [sym__external_open_bracket] = ACTIONS(765),
    [sym__external_open_bracket2] = ACTIONS(765),
  },
  [377] = {
    [sym_function_definition] = STATE(4411),
    [sym_if_statement] = STATE(4411),
    [sym_for_statement] = STATE(4411),
    [sym_while_statement] = STATE(4411),
    [sym_repeat_statement] = STATE(4411),
    [sym_braced_expression] = STATE(4411),
    [sym_parenthesized_expression] = STATE(4411),
    [sym_call] = STATE(4411),
    [sym_subset] = STATE(4411),
    [sym_subset2] = STATE(4411),
    [sym_unary_operator] = STATE(4411),
    [sym_binary_operator] = STATE(4411),
    [sym_extract_operator] = STATE(4411),
    [sym_namespace_operator] = STATE(4411),
    [sym_integer] = STATE(4411),
    [sym_complex] = STATE(4411),
    [sym_float] = STATE(4411),
    [sym__hex_literal] = STATE(4680),
    [sym__float_literal] = STATE(4680),
    [sym_string] = STATE(4681),
    [sym__single_quoted_string] = STATE(4674),
    [sym__double_quoted_string] = STATE(4678),
    [sym_na] = STATE(4411),
    [sym__expression] = STATE(4411),
    [sym__string_or_identifier] = STATE(5129),
    [sym__open_parenthesis] = STATE(287),
    [sym__open_brace] = STATE(51),
    [aux_sym_function_definition_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(4214),
    [anon_sym_BSLASH] = ACTIONS(4216),
    [anon_sym_function] = ACTIONS(4218),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_if] = ACTIONS(4220),
    [anon_sym_for] = ACTIONS(4222),
    [anon_sym_while] = ACTIONS(4224),
    [anon_sym_repeat] = ACTIONS(4226),
    [anon_sym_QMARK] = ACTIONS(4228),
    [anon_sym_TILDE] = ACTIONS(4230),
    [anon_sym_BANG] = ACTIONS(4232),
    [anon_sym_PLUS] = ACTIONS(4234),
    [anon_sym_DASH] = ACTIONS(4236),
    [anon_sym_LT_DASH] = ACTIONS(471),
    [anon_sym_LT_LT_DASH] = ACTIONS(471),
    [anon_sym_COLON_EQ] = ACTIONS(471),
    [anon_sym_DASH_GT] = ACTIONS(473),
    [anon_sym_DASH_GT_GT] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(473),
    [anon_sym_AMP] = ACTIONS(473),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_LT_EQ] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(473),
    [anon_sym_GT_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_STAR] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [aux_sym_binary_operator_token1] = ACTIONS(471),
    [anon_sym_PIPE_GT] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(473),
    [anon_sym_DOLLAR] = ACTIONS(471),
    [anon_sym_AT] = ACTIONS(471),
    [aux_sym__hex_literal_token1] = ACTIONS(4238),
    [sym__number_literal] = ACTIONS(4240),
    [anon_sym_SQUOTE] = ACTIONS(4242),
    [anon_sym_DQUOTE] = ACTIONS(4244),
    [sym_return] = ACTIONS(4246),
    [sym_next] = ACTIONS(4246),
    [sym_break] = ACTIONS(4246),
    [sym_true] = ACTIONS(4246),
    [sym_false] = ACTIONS(4246),
    [sym_null] = ACTIONS(4246),
    [sym_inf] = ACTIONS(4246),
    [sym_nan] = ACTIONS(4246),
    [anon_sym_NA] = ACTIONS(4248),
    [anon_sym_NA_integer_] = ACTIONS(4248),
    [anon_sym_NA_real_] = ACTIONS(4248),
    [anon_sym_NA_complex_] = ACTIONS(4248),
    [anon_sym_NA_character_] = ACTIONS(4248),
    [sym_dots] = ACTIONS(4246),
    [sym_dot_dot_i] = ACTIONS(4250),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(471),
    [sym__newline] = ACTIONS(4252),
    [sym__raw_string_literal] = ACTIONS(4254),
    [sym__external_else] = ACTIONS(471),
    [sym__external_open_parenthesis] = ACTIONS(4256),
    [sym__external_close_parenthesis] = ACTIONS(471),
    [sym__external_open_brace] = ACTIONS(4258),
    [sym__external_open_bracket] = ACTIONS(471),
    [sym__external_open_bracket2] = ACTIONS(471),
  },
  [378] = {
    [sym_function_definition] = STATE(4421),
    [sym_if_statement] = STATE(4421),
    [sym_for_statement] = STATE(4421),
    [sym_while_statement] = STATE(4421),
    [sym_repeat_statement] = STATE(4421),
    [sym_braced_expression] = STATE(4421),
    [sym_parenthesized_expression] = STATE(4421),
    [sym_call] = STATE(4421),
    [sym_subset] = STATE(4421),
    [sym_subset2] = STATE(4421),
    [sym_unary_operator] = STATE(4421),
    [sym_binary_operator] = STATE(4421),
    [sym_extract_operator] = STATE(4421),
    [sym_namespace_operator] = STATE(4421),
    [sym_integer] = STATE(4421),
    [sym_complex] = STATE(4421),
    [sym_float] = STATE(4421),
    [sym__hex_literal] = STATE(4680),
    [sym__float_literal] = STATE(4680),
    [sym_string] = STATE(4681),
    [sym__single_quoted_string] = STATE(4674),
    [sym__double_quoted_string] = STATE(4678),
    [sym_na] = STATE(4421),
    [sym__expression] = STATE(4421),
    [sym__string_or_identifier] = STATE(5129),
    [sym__open_parenthesis] = STATE(287),
    [sym__open_brace] = STATE(51),
    [aux_sym_function_definition_repeat1] = STATE(377),
    [sym_identifier] = ACTIONS(4214),
    [anon_sym_BSLASH] = ACTIONS(4216),
    [anon_sym_function] = ACTIONS(4218),
    [anon_sym_EQ] = ACTIONS(463),
    [anon_sym_if] = ACTIONS(4220),
    [anon_sym_for] = ACTIONS(4222),
    [anon_sym_while] = ACTIONS(4224),
    [anon_sym_repeat] = ACTIONS(4226),
    [anon_sym_QMARK] = ACTIONS(4228),
    [anon_sym_TILDE] = ACTIONS(4230),
    [anon_sym_BANG] = ACTIONS(4232),
    [anon_sym_PLUS] = ACTIONS(4234),
    [anon_sym_DASH] = ACTIONS(4236),
    [anon_sym_LT_DASH] = ACTIONS(461),
    [anon_sym_LT_LT_DASH] = ACTIONS(461),
    [anon_sym_COLON_EQ] = ACTIONS(461),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_DASH_GT_GT] = ACTIONS(461),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_PIPE_PIPE] = ACTIONS(461),
    [anon_sym_AMP_AMP] = ACTIONS(461),
    [anon_sym_LT] = ACTIONS(463),
    [anon_sym_LT_EQ] = ACTIONS(461),
    [anon_sym_GT] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(461),
    [anon_sym_EQ_EQ] = ACTIONS(461),
    [anon_sym_BANG_EQ] = ACTIONS(461),
    [anon_sym_STAR] = ACTIONS(463),
    [anon_sym_SLASH] = ACTIONS(461),
    [anon_sym_STAR_STAR] = ACTIONS(461),
    [anon_sym_CARET] = ACTIONS(461),
    [aux_sym_binary_operator_token1] = ACTIONS(461),
    [anon_sym_PIPE_GT] = ACTIONS(461),
    [anon_sym_COLON] = ACTIONS(463),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_AT] = ACTIONS(461),
    [aux_sym__hex_literal_token1] = ACTIONS(4238),
    [sym__number_literal] = ACTIONS(4240),
    [anon_sym_SQUOTE] = ACTIONS(4242),
    [anon_sym_DQUOTE] = ACTIONS(4244),
    [sym_return] = ACTIONS(4260),
    [sym_next] = ACTIONS(4260),
    [sym_break] = ACTIONS(4260),
    [sym_true] = ACTIONS(4260),
    [sym_false] = ACTIONS(4260),
    [sym_null] = ACTIONS(4260),
    [sym_inf] = ACTIONS(4260),
    [sym_nan] = ACTIONS(4260),
    [anon_sym_NA] = ACTIONS(4248),
    [anon_sym_NA_integer_] = ACTIONS(4248),
    [anon_sym_NA_real_] = ACTIONS(4248),
    [anon_sym_NA_complex_] = ACTIONS(4248),
    [anon_sym_NA_character_] = ACTIONS(4248),
    [sym_dots] = ACTIONS(4260),
    [sym_dot_dot_i] = ACTIONS(4262),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(461),
    [sym__newline] = ACTIONS(4264),
    [sym__raw_string_literal] = ACTIONS(4254),
    [sym__external_else] = ACTIONS(461),
    [sym__external_open_parenthesis] = ACTIONS(4256),
    [sym__external_close_parenthesis] = ACTIONS(461),
    [sym__external_open_brace] = ACTIONS(4258),
    [sym__external_open_bracket] = ACTIONS(461),
    [sym__external_open_bracket2] = ACTIONS(461),
  },
  [379] = {
    [sym_function_definition] = STATE(4425),
    [sym_if_statement] = STATE(4425),
    [sym_for_statement] = STATE(4425),
    [sym_while_statement] = STATE(4425),
    [sym_repeat_statement] = STATE(4425),
    [sym_braced_expression] = STATE(4425),
    [sym_parenthesized_expression] = STATE(4425),
    [sym_call] = STATE(4425),
    [sym_subset] = STATE(4425),
    [sym_subset2] = STATE(4425),
    [sym_unary_operator] = STATE(4425),
    [sym_binary_operator] = STATE(4425),
    [sym_extract_operator] = STATE(4425),
    [sym_namespace_operator] = STATE(4425),
    [sym_integer] = STATE(4425),
    [sym_complex] = STATE(4425),
    [sym_float] = STATE(4425),
    [sym__hex_literal] = STATE(4680),
    [sym__float_literal] = STATE(4680),
    [sym_string] = STATE(4681),
    [sym__single_quoted_string] = STATE(4674),
    [sym__double_quoted_string] = STATE(4678),
    [sym_na] = STATE(4425),
    [sym__expression] = STATE(4425),
    [sym__string_or_identifier] = STATE(5129),
    [sym__open_parenthesis] = STATE(287),
    [sym__open_brace] = STATE(51),
    [aux_sym_function_definition_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(4214),
    [anon_sym_BSLASH] = ACTIONS(4216),
    [anon_sym_function] = ACTIONS(4218),
    [anon_sym_EQ] = ACTIONS(455),
    [anon_sym_if] = ACTIONS(4220),
    [anon_sym_for] = ACTIONS(4222),
    [anon_sym_while] = ACTIONS(4224),
    [anon_sym_repeat] = ACTIONS(4226),
    [anon_sym_QMARK] = ACTIONS(4228),
    [anon_sym_TILDE] = ACTIONS(4230),
    [anon_sym_BANG] = ACTIONS(4232),
    [anon_sym_PLUS] = ACTIONS(4234),
    [anon_sym_DASH] = ACTIONS(4236),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [anon_sym_LT_LT_DASH] = ACTIONS(453),
    [anon_sym_COLON_EQ] = ACTIONS(453),
    [anon_sym_DASH_GT] = ACTIONS(455),
    [anon_sym_DASH_GT_GT] = ACTIONS(453),
    [anon_sym_PIPE] = ACTIONS(455),
    [anon_sym_AMP] = ACTIONS(455),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(455),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_GT] = ACTIONS(455),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(453),
    [anon_sym_STAR] = ACTIONS(455),
    [anon_sym_SLASH] = ACTIONS(453),
    [anon_sym_STAR_STAR] = ACTIONS(453),
    [anon_sym_CARET] = ACTIONS(453),
    [aux_sym_binary_operator_token1] = ACTIONS(453),
    [anon_sym_PIPE_GT] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(455),
    [anon_sym_DOLLAR] = ACTIONS(453),
    [anon_sym_AT] = ACTIONS(453),
    [aux_sym__hex_literal_token1] = ACTIONS(4238),
    [sym__number_literal] = ACTIONS(4240),
    [anon_sym_SQUOTE] = ACTIONS(4242),
    [anon_sym_DQUOTE] = ACTIONS(4244),
    [sym_return] = ACTIONS(4266),
    [sym_next] = ACTIONS(4266),
    [sym_break] = ACTIONS(4266),
    [sym_true] = ACTIONS(4266),
    [sym_false] = ACTIONS(4266),
    [sym_null] = ACTIONS(4266),
    [sym_inf] = ACTIONS(4266),
    [sym_nan] = ACTIONS(4266),
    [anon_sym_NA] = ACTIONS(4248),
    [anon_sym_NA_integer_] = ACTIONS(4248),
    [anon_sym_NA_real_] = ACTIONS(4248),
    [anon_sym_NA_complex_] = ACTIONS(4248),
    [anon_sym_NA_character_] = ACTIONS(4248),
    [sym_dots] = ACTIONS(4266),
    [sym_dot_dot_i] = ACTIONS(4268),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(453),
    [sym__newline] = ACTIONS(4252),
    [sym__raw_string_literal] = ACTIONS(4254),
    [sym__external_else] = ACTIONS(453),
    [sym__external_open_parenthesis] = ACTIONS(4256),
    [sym__external_close_parenthesis] = ACTIONS(453),
    [sym__external_open_brace] = ACTIONS(4258),
    [sym__external_open_bracket] = ACTIONS(453),
    [sym__external_open_bracket2] = ACTIONS(453),
  },
  [380] = {
    [sym_function_definition] = STATE(1836),
    [sym_if_statement] = STATE(1836),
    [sym_for_statement] = STATE(1836),
    [sym_while_statement] = STATE(1836),
    [sym_repeat_statement] = STATE(1836),
    [sym_braced_expression] = STATE(1836),
    [sym_parenthesized_expression] = STATE(1836),
    [sym_call] = STATE(1836),
    [sym_subset] = STATE(1836),
    [sym_subset2] = STATE(1836),
    [sym_unary_operator] = STATE(1836),
    [sym_binary_operator] = STATE(1836),
    [sym_extract_operator] = STATE(1836),
    [sym_namespace_operator] = STATE(1836),
    [sym_integer] = STATE(1836),
    [sym_complex] = STATE(1836),
    [sym_float] = STATE(1836),
    [sym__hex_literal] = STATE(2536),
    [sym__float_literal] = STATE(2536),
    [sym_string] = STATE(2534),
    [sym__single_quoted_string] = STATE(2538),
    [sym__double_quoted_string] = STATE(2539),
    [sym_na] = STATE(1836),
    [sym__expression] = STATE(1836),
    [sym__string_or_identifier] = STATE(5143),
    [sym__open_parenthesis] = STATE(150),
    [sym__open_brace] = STATE(133),
    [aux_sym_function_definition_repeat1] = STATE(2742),
    [ts_builtin_sym_end] = ACTIONS(757),
    [sym_identifier] = ACTIONS(4053),
    [anon_sym_BSLASH] = ACTIONS(4055),
    [anon_sym_function] = ACTIONS(4057),
    [anon_sym_EQ] = ACTIONS(759),
    [anon_sym_if] = ACTIONS(4059),
    [anon_sym_for] = ACTIONS(4061),
    [anon_sym_while] = ACTIONS(4063),
    [anon_sym_repeat] = ACTIONS(4065),
    [anon_sym_QMARK] = ACTIONS(4067),
    [anon_sym_TILDE] = ACTIONS(4069),
    [anon_sym_BANG] = ACTIONS(4071),
    [anon_sym_PLUS] = ACTIONS(4073),
    [anon_sym_DASH] = ACTIONS(4075),
    [anon_sym_LT_DASH] = ACTIONS(757),
    [anon_sym_LT_LT_DASH] = ACTIONS(757),
    [anon_sym_COLON_EQ] = ACTIONS(757),
    [anon_sym_DASH_GT] = ACTIONS(759),
    [anon_sym_DASH_GT_GT] = ACTIONS(757),
    [anon_sym_PIPE] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(759),
    [anon_sym_PIPE_PIPE] = ACTIONS(757),
    [anon_sym_AMP_AMP] = ACTIONS(757),
    [anon_sym_LT] = ACTIONS(759),
    [anon_sym_LT_EQ] = ACTIONS(757),
    [anon_sym_GT] = ACTIONS(759),
    [anon_sym_GT_EQ] = ACTIONS(757),
    [anon_sym_EQ_EQ] = ACTIONS(757),
    [anon_sym_BANG_EQ] = ACTIONS(757),
    [anon_sym_STAR] = ACTIONS(759),
    [anon_sym_SLASH] = ACTIONS(757),
    [anon_sym_STAR_STAR] = ACTIONS(757),
    [anon_sym_CARET] = ACTIONS(757),
    [aux_sym_binary_operator_token1] = ACTIONS(757),
    [anon_sym_PIPE_GT] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(759),
    [anon_sym_DOLLAR] = ACTIONS(757),
    [anon_sym_AT] = ACTIONS(757),
    [aux_sym__hex_literal_token1] = ACTIONS(4077),
    [sym__number_literal] = ACTIONS(4079),
    [anon_sym_SQUOTE] = ACTIONS(4081),
    [anon_sym_DQUOTE] = ACTIONS(4083),
    [sym_return] = ACTIONS(4270),
    [sym_next] = ACTIONS(4270),
    [sym_break] = ACTIONS(4270),
    [sym_true] = ACTIONS(4270),
    [sym_false] = ACTIONS(4270),
    [sym_null] = ACTIONS(4270),
    [sym_inf] = ACTIONS(4270),
    [sym_nan] = ACTIONS(4270),
    [anon_sym_NA] = ACTIONS(4087),
    [anon_sym_NA_integer_] = ACTIONS(4087),
    [anon_sym_NA_real_] = ACTIONS(4087),
    [anon_sym_NA_complex_] = ACTIONS(4087),
    [anon_sym_NA_character_] = ACTIONS(4087),
    [sym_dots] = ACTIONS(4270),
    [sym_dot_dot_i] = ACTIONS(4272),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(757),
    [sym__semicolon] = ACTIONS(757),
    [sym__raw_string_literal] = ACTIONS(4093),
    [sym__external_else] = ACTIONS(757),
    [sym__external_open_parenthesis] = ACTIONS(4095),
    [sym__external_open_brace] = ACTIONS(4097),
    [sym__external_open_bracket] = ACTIONS(757),
    [sym__external_open_bracket2] = ACTIONS(757),
  },
  [381] = {
    [sym_function_definition] = STATE(1874),
    [sym_if_statement] = STATE(1874),
    [sym_for_statement] = STATE(1874),
    [sym_while_statement] = STATE(1874),
    [sym_repeat_statement] = STATE(1874),
    [sym_braced_expression] = STATE(1874),
    [sym_parenthesized_expression] = STATE(1874),
    [sym_call] = STATE(1874),
    [sym_subset] = STATE(1874),
    [sym_subset2] = STATE(1874),
    [sym_unary_operator] = STATE(1874),
    [sym_binary_operator] = STATE(1874),
    [sym_extract_operator] = STATE(1874),
    [sym_namespace_operator] = STATE(1874),
    [sym_integer] = STATE(1874),
    [sym_complex] = STATE(1874),
    [sym_float] = STATE(1874),
    [sym__hex_literal] = STATE(2540),
    [sym__float_literal] = STATE(2540),
    [sym_string] = STATE(2541),
    [sym__single_quoted_string] = STATE(2462),
    [sym__double_quoted_string] = STATE(2494),
    [sym_na] = STATE(1874),
    [sym__expression] = STATE(1874),
    [sym__string_or_identifier] = STATE(5128),
    [sym__open_parenthesis] = STATE(246),
    [sym__open_brace] = STATE(173),
    [aux_sym_function_definition_repeat1] = STATE(388),
    [ts_builtin_sym_end] = ACTIONS(461),
    [sym_identifier] = ACTIONS(2943),
    [anon_sym_BSLASH] = ACTIONS(2945),
    [anon_sym_function] = ACTIONS(2947),
    [anon_sym_EQ] = ACTIONS(463),
    [anon_sym_if] = ACTIONS(2949),
    [anon_sym_for] = ACTIONS(2951),
    [anon_sym_while] = ACTIONS(2953),
    [anon_sym_repeat] = ACTIONS(2955),
    [anon_sym_QMARK] = ACTIONS(2957),
    [anon_sym_TILDE] = ACTIONS(2959),
    [anon_sym_BANG] = ACTIONS(2961),
    [anon_sym_PLUS] = ACTIONS(2963),
    [anon_sym_DASH] = ACTIONS(2965),
    [anon_sym_LT_DASH] = ACTIONS(461),
    [anon_sym_LT_LT_DASH] = ACTIONS(461),
    [anon_sym_COLON_EQ] = ACTIONS(461),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_DASH_GT_GT] = ACTIONS(461),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_PIPE_PIPE] = ACTIONS(461),
    [anon_sym_AMP_AMP] = ACTIONS(461),
    [anon_sym_LT] = ACTIONS(463),
    [anon_sym_LT_EQ] = ACTIONS(461),
    [anon_sym_GT] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(461),
    [anon_sym_EQ_EQ] = ACTIONS(461),
    [anon_sym_BANG_EQ] = ACTIONS(461),
    [anon_sym_STAR] = ACTIONS(463),
    [anon_sym_SLASH] = ACTIONS(461),
    [anon_sym_STAR_STAR] = ACTIONS(461),
    [anon_sym_CARET] = ACTIONS(461),
    [aux_sym_binary_operator_token1] = ACTIONS(461),
    [anon_sym_PIPE_GT] = ACTIONS(461),
    [anon_sym_COLON] = ACTIONS(463),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_AT] = ACTIONS(461),
    [aux_sym__hex_literal_token1] = ACTIONS(2967),
    [sym__number_literal] = ACTIONS(2969),
    [anon_sym_SQUOTE] = ACTIONS(2971),
    [anon_sym_DQUOTE] = ACTIONS(2973),
    [sym_return] = ACTIONS(4274),
    [sym_next] = ACTIONS(4274),
    [sym_break] = ACTIONS(4274),
    [sym_true] = ACTIONS(4274),
    [sym_false] = ACTIONS(4274),
    [sym_null] = ACTIONS(4274),
    [sym_inf] = ACTIONS(4274),
    [sym_nan] = ACTIONS(4274),
    [anon_sym_NA] = ACTIONS(2977),
    [anon_sym_NA_integer_] = ACTIONS(2977),
    [anon_sym_NA_real_] = ACTIONS(2977),
    [anon_sym_NA_complex_] = ACTIONS(2977),
    [anon_sym_NA_character_] = ACTIONS(2977),
    [sym_dots] = ACTIONS(4274),
    [sym_dot_dot_i] = ACTIONS(4276),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4278),
    [sym__semicolon] = ACTIONS(461),
    [sym__raw_string_literal] = ACTIONS(2983),
    [sym__external_open_parenthesis] = ACTIONS(2985),
    [sym__external_close_parenthesis] = ACTIONS(461),
    [sym__external_open_brace] = ACTIONS(2989),
    [sym__external_open_bracket] = ACTIONS(461),
    [sym__external_open_bracket2] = ACTIONS(461),
  },
  [382] = {
    [sym_function_definition] = STATE(4431),
    [sym_if_statement] = STATE(4431),
    [sym_for_statement] = STATE(4431),
    [sym_while_statement] = STATE(4431),
    [sym_repeat_statement] = STATE(4431),
    [sym_braced_expression] = STATE(4431),
    [sym_parenthesized_expression] = STATE(4431),
    [sym_call] = STATE(4431),
    [sym_subset] = STATE(4431),
    [sym_subset2] = STATE(4431),
    [sym_unary_operator] = STATE(4431),
    [sym_binary_operator] = STATE(4431),
    [sym_extract_operator] = STATE(4431),
    [sym_namespace_operator] = STATE(4431),
    [sym_integer] = STATE(4431),
    [sym_complex] = STATE(4431),
    [sym_float] = STATE(4431),
    [sym__hex_literal] = STATE(4680),
    [sym__float_literal] = STATE(4680),
    [sym_string] = STATE(4681),
    [sym__single_quoted_string] = STATE(4674),
    [sym__double_quoted_string] = STATE(4678),
    [sym_na] = STATE(4431),
    [sym__expression] = STATE(4431),
    [sym__string_or_identifier] = STATE(5129),
    [sym__open_parenthesis] = STATE(287),
    [sym__open_brace] = STATE(51),
    [aux_sym_function_definition_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(4214),
    [anon_sym_BSLASH] = ACTIONS(4216),
    [anon_sym_function] = ACTIONS(4218),
    [anon_sym_EQ] = ACTIONS(399),
    [anon_sym_if] = ACTIONS(4220),
    [anon_sym_for] = ACTIONS(4222),
    [anon_sym_while] = ACTIONS(4224),
    [anon_sym_repeat] = ACTIONS(4226),
    [anon_sym_QMARK] = ACTIONS(4228),
    [anon_sym_TILDE] = ACTIONS(4230),
    [anon_sym_BANG] = ACTIONS(4232),
    [anon_sym_PLUS] = ACTIONS(4234),
    [anon_sym_DASH] = ACTIONS(4236),
    [anon_sym_LT_DASH] = ACTIONS(397),
    [anon_sym_LT_LT_DASH] = ACTIONS(397),
    [anon_sym_COLON_EQ] = ACTIONS(397),
    [anon_sym_DASH_GT] = ACTIONS(399),
    [anon_sym_DASH_GT_GT] = ACTIONS(397),
    [anon_sym_PIPE] = ACTIONS(399),
    [anon_sym_AMP] = ACTIONS(399),
    [anon_sym_PIPE_PIPE] = ACTIONS(397),
    [anon_sym_AMP_AMP] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(399),
    [anon_sym_LT_EQ] = ACTIONS(397),
    [anon_sym_GT] = ACTIONS(399),
    [anon_sym_GT_EQ] = ACTIONS(397),
    [anon_sym_EQ_EQ] = ACTIONS(397),
    [anon_sym_BANG_EQ] = ACTIONS(397),
    [anon_sym_STAR] = ACTIONS(399),
    [anon_sym_SLASH] = ACTIONS(397),
    [anon_sym_STAR_STAR] = ACTIONS(397),
    [anon_sym_CARET] = ACTIONS(397),
    [aux_sym_binary_operator_token1] = ACTIONS(397),
    [anon_sym_PIPE_GT] = ACTIONS(397),
    [anon_sym_COLON] = ACTIONS(399),
    [anon_sym_DOLLAR] = ACTIONS(397),
    [anon_sym_AT] = ACTIONS(397),
    [aux_sym__hex_literal_token1] = ACTIONS(4238),
    [sym__number_literal] = ACTIONS(4240),
    [anon_sym_SQUOTE] = ACTIONS(4242),
    [anon_sym_DQUOTE] = ACTIONS(4244),
    [sym_return] = ACTIONS(4280),
    [sym_next] = ACTIONS(4280),
    [sym_break] = ACTIONS(4280),
    [sym_true] = ACTIONS(4280),
    [sym_false] = ACTIONS(4280),
    [sym_null] = ACTIONS(4280),
    [sym_inf] = ACTIONS(4280),
    [sym_nan] = ACTIONS(4280),
    [anon_sym_NA] = ACTIONS(4248),
    [anon_sym_NA_integer_] = ACTIONS(4248),
    [anon_sym_NA_real_] = ACTIONS(4248),
    [anon_sym_NA_complex_] = ACTIONS(4248),
    [anon_sym_NA_character_] = ACTIONS(4248),
    [sym_dots] = ACTIONS(4280),
    [sym_dot_dot_i] = ACTIONS(4282),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(397),
    [sym__newline] = ACTIONS(4252),
    [sym__raw_string_literal] = ACTIONS(4254),
    [sym__external_else] = ACTIONS(397),
    [sym__external_open_parenthesis] = ACTIONS(4256),
    [sym__external_close_parenthesis] = ACTIONS(397),
    [sym__external_open_brace] = ACTIONS(4258),
    [sym__external_open_bracket] = ACTIONS(397),
    [sym__external_open_bracket2] = ACTIONS(397),
  },
  [383] = {
    [sym_function_definition] = STATE(4400),
    [sym_if_statement] = STATE(4400),
    [sym_for_statement] = STATE(4400),
    [sym_while_statement] = STATE(4400),
    [sym_repeat_statement] = STATE(4400),
    [sym_braced_expression] = STATE(4400),
    [sym_parenthesized_expression] = STATE(4400),
    [sym_call] = STATE(4400),
    [sym_subset] = STATE(4400),
    [sym_subset2] = STATE(4400),
    [sym_unary_operator] = STATE(4400),
    [sym_binary_operator] = STATE(4400),
    [sym_extract_operator] = STATE(4400),
    [sym_namespace_operator] = STATE(4400),
    [sym_integer] = STATE(4400),
    [sym_complex] = STATE(4400),
    [sym_float] = STATE(4400),
    [sym__hex_literal] = STATE(4680),
    [sym__float_literal] = STATE(4680),
    [sym_string] = STATE(4681),
    [sym__single_quoted_string] = STATE(4674),
    [sym__double_quoted_string] = STATE(4678),
    [sym_na] = STATE(4400),
    [sym__expression] = STATE(4400),
    [sym__string_or_identifier] = STATE(5129),
    [sym__open_parenthesis] = STATE(287),
    [sym__open_brace] = STATE(51),
    [aux_sym_function_definition_repeat1] = STATE(379),
    [sym_identifier] = ACTIONS(4214),
    [anon_sym_BSLASH] = ACTIONS(4216),
    [anon_sym_function] = ACTIONS(4218),
    [anon_sym_EQ] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(4220),
    [anon_sym_for] = ACTIONS(4222),
    [anon_sym_while] = ACTIONS(4224),
    [anon_sym_repeat] = ACTIONS(4226),
    [anon_sym_QMARK] = ACTIONS(4228),
    [anon_sym_TILDE] = ACTIONS(4230),
    [anon_sym_BANG] = ACTIONS(4232),
    [anon_sym_PLUS] = ACTIONS(4234),
    [anon_sym_DASH] = ACTIONS(4236),
    [anon_sym_LT_DASH] = ACTIONS(387),
    [anon_sym_LT_LT_DASH] = ACTIONS(387),
    [anon_sym_COLON_EQ] = ACTIONS(387),
    [anon_sym_DASH_GT] = ACTIONS(389),
    [anon_sym_DASH_GT_GT] = ACTIONS(387),
    [anon_sym_PIPE] = ACTIONS(389),
    [anon_sym_AMP] = ACTIONS(389),
    [anon_sym_PIPE_PIPE] = ACTIONS(387),
    [anon_sym_AMP_AMP] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(389),
    [anon_sym_LT_EQ] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(389),
    [anon_sym_GT_EQ] = ACTIONS(387),
    [anon_sym_EQ_EQ] = ACTIONS(387),
    [anon_sym_BANG_EQ] = ACTIONS(387),
    [anon_sym_STAR] = ACTIONS(389),
    [anon_sym_SLASH] = ACTIONS(387),
    [anon_sym_STAR_STAR] = ACTIONS(387),
    [anon_sym_CARET] = ACTIONS(387),
    [aux_sym_binary_operator_token1] = ACTIONS(387),
    [anon_sym_PIPE_GT] = ACTIONS(387),
    [anon_sym_COLON] = ACTIONS(389),
    [anon_sym_DOLLAR] = ACTIONS(387),
    [anon_sym_AT] = ACTIONS(387),
    [aux_sym__hex_literal_token1] = ACTIONS(4238),
    [sym__number_literal] = ACTIONS(4240),
    [anon_sym_SQUOTE] = ACTIONS(4242),
    [anon_sym_DQUOTE] = ACTIONS(4244),
    [sym_return] = ACTIONS(4284),
    [sym_next] = ACTIONS(4284),
    [sym_break] = ACTIONS(4284),
    [sym_true] = ACTIONS(4284),
    [sym_false] = ACTIONS(4284),
    [sym_null] = ACTIONS(4284),
    [sym_inf] = ACTIONS(4284),
    [sym_nan] = ACTIONS(4284),
    [anon_sym_NA] = ACTIONS(4248),
    [anon_sym_NA_integer_] = ACTIONS(4248),
    [anon_sym_NA_real_] = ACTIONS(4248),
    [anon_sym_NA_complex_] = ACTIONS(4248),
    [anon_sym_NA_character_] = ACTIONS(4248),
    [sym_dots] = ACTIONS(4284),
    [sym_dot_dot_i] = ACTIONS(4286),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(387),
    [sym__newline] = ACTIONS(4288),
    [sym__raw_string_literal] = ACTIONS(4254),
    [sym__external_else] = ACTIONS(387),
    [sym__external_open_parenthesis] = ACTIONS(4256),
    [sym__external_close_parenthesis] = ACTIONS(387),
    [sym__external_open_brace] = ACTIONS(4258),
    [sym__external_open_bracket] = ACTIONS(387),
    [sym__external_open_bracket2] = ACTIONS(387),
  },
  [384] = {
    [sym_function_definition] = STATE(4433),
    [sym_if_statement] = STATE(4433),
    [sym_for_statement] = STATE(4433),
    [sym_while_statement] = STATE(4433),
    [sym_repeat_statement] = STATE(4433),
    [sym_braced_expression] = STATE(4433),
    [sym_parenthesized_expression] = STATE(4433),
    [sym_call] = STATE(4433),
    [sym_subset] = STATE(4433),
    [sym_subset2] = STATE(4433),
    [sym_unary_operator] = STATE(4433),
    [sym_binary_operator] = STATE(4433),
    [sym_extract_operator] = STATE(4433),
    [sym_namespace_operator] = STATE(4433),
    [sym_integer] = STATE(4433),
    [sym_complex] = STATE(4433),
    [sym_float] = STATE(4433),
    [sym__hex_literal] = STATE(4680),
    [sym__float_literal] = STATE(4680),
    [sym_string] = STATE(4681),
    [sym__single_quoted_string] = STATE(4674),
    [sym__double_quoted_string] = STATE(4678),
    [sym_na] = STATE(4433),
    [sym__expression] = STATE(4433),
    [sym__string_or_identifier] = STATE(5129),
    [sym__open_parenthesis] = STATE(287),
    [sym__open_brace] = STATE(51),
    [aux_sym_function_definition_repeat1] = STATE(382),
    [sym_identifier] = ACTIONS(4214),
    [anon_sym_BSLASH] = ACTIONS(4216),
    [anon_sym_function] = ACTIONS(4218),
    [anon_sym_EQ] = ACTIONS(379),
    [anon_sym_if] = ACTIONS(4220),
    [anon_sym_for] = ACTIONS(4222),
    [anon_sym_while] = ACTIONS(4224),
    [anon_sym_repeat] = ACTIONS(4226),
    [anon_sym_QMARK] = ACTIONS(4228),
    [anon_sym_TILDE] = ACTIONS(4230),
    [anon_sym_BANG] = ACTIONS(4232),
    [anon_sym_PLUS] = ACTIONS(4234),
    [anon_sym_DASH] = ACTIONS(4236),
    [anon_sym_LT_DASH] = ACTIONS(377),
    [anon_sym_LT_LT_DASH] = ACTIONS(377),
    [anon_sym_COLON_EQ] = ACTIONS(377),
    [anon_sym_DASH_GT] = ACTIONS(379),
    [anon_sym_DASH_GT_GT] = ACTIONS(377),
    [anon_sym_PIPE] = ACTIONS(379),
    [anon_sym_AMP] = ACTIONS(379),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_LT] = ACTIONS(379),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(379),
    [anon_sym_GT_EQ] = ACTIONS(377),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(379),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_STAR_STAR] = ACTIONS(377),
    [anon_sym_CARET] = ACTIONS(377),
    [aux_sym_binary_operator_token1] = ACTIONS(377),
    [anon_sym_PIPE_GT] = ACTIONS(377),
    [anon_sym_COLON] = ACTIONS(379),
    [anon_sym_DOLLAR] = ACTIONS(377),
    [anon_sym_AT] = ACTIONS(377),
    [aux_sym__hex_literal_token1] = ACTIONS(4238),
    [sym__number_literal] = ACTIONS(4240),
    [anon_sym_SQUOTE] = ACTIONS(4242),
    [anon_sym_DQUOTE] = ACTIONS(4244),
    [sym_return] = ACTIONS(4290),
    [sym_next] = ACTIONS(4290),
    [sym_break] = ACTIONS(4290),
    [sym_true] = ACTIONS(4290),
    [sym_false] = ACTIONS(4290),
    [sym_null] = ACTIONS(4290),
    [sym_inf] = ACTIONS(4290),
    [sym_nan] = ACTIONS(4290),
    [anon_sym_NA] = ACTIONS(4248),
    [anon_sym_NA_integer_] = ACTIONS(4248),
    [anon_sym_NA_real_] = ACTIONS(4248),
    [anon_sym_NA_complex_] = ACTIONS(4248),
    [anon_sym_NA_character_] = ACTIONS(4248),
    [sym_dots] = ACTIONS(4290),
    [sym_dot_dot_i] = ACTIONS(4292),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(377),
    [sym__newline] = ACTIONS(4294),
    [sym__raw_string_literal] = ACTIONS(4254),
    [sym__external_else] = ACTIONS(377),
    [sym__external_open_parenthesis] = ACTIONS(4256),
    [sym__external_close_parenthesis] = ACTIONS(377),
    [sym__external_open_brace] = ACTIONS(4258),
    [sym__external_open_bracket] = ACTIONS(377),
    [sym__external_open_bracket2] = ACTIONS(377),
  },
  [385] = {
    [sym_function_definition] = STATE(4432),
    [sym_if_statement] = STATE(4432),
    [sym_for_statement] = STATE(4432),
    [sym_while_statement] = STATE(4432),
    [sym_repeat_statement] = STATE(4432),
    [sym_braced_expression] = STATE(4432),
    [sym_parenthesized_expression] = STATE(4432),
    [sym_call] = STATE(4432),
    [sym_subset] = STATE(4432),
    [sym_subset2] = STATE(4432),
    [sym_unary_operator] = STATE(4432),
    [sym_binary_operator] = STATE(4432),
    [sym_extract_operator] = STATE(4432),
    [sym_namespace_operator] = STATE(4432),
    [sym_integer] = STATE(4432),
    [sym_complex] = STATE(4432),
    [sym_float] = STATE(4432),
    [sym__hex_literal] = STATE(4680),
    [sym__float_literal] = STATE(4680),
    [sym_string] = STATE(4681),
    [sym__single_quoted_string] = STATE(4674),
    [sym__double_quoted_string] = STATE(4678),
    [sym_na] = STATE(4432),
    [sym__expression] = STATE(4432),
    [sym__string_or_identifier] = STATE(5129),
    [sym__open_parenthesis] = STATE(287),
    [sym__open_brace] = STATE(51),
    [aux_sym_function_definition_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(4214),
    [anon_sym_BSLASH] = ACTIONS(4216),
    [anon_sym_function] = ACTIONS(4218),
    [anon_sym_EQ] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(4220),
    [anon_sym_for] = ACTIONS(4222),
    [anon_sym_while] = ACTIONS(4224),
    [anon_sym_repeat] = ACTIONS(4226),
    [anon_sym_QMARK] = ACTIONS(4228),
    [anon_sym_TILDE] = ACTIONS(4230),
    [anon_sym_BANG] = ACTIONS(4232),
    [anon_sym_PLUS] = ACTIONS(4234),
    [anon_sym_DASH] = ACTIONS(4236),
    [anon_sym_LT_DASH] = ACTIONS(369),
    [anon_sym_LT_LT_DASH] = ACTIONS(369),
    [anon_sym_COLON_EQ] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(371),
    [anon_sym_DASH_GT_GT] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(371),
    [anon_sym_AMP] = ACTIONS(371),
    [anon_sym_PIPE_PIPE] = ACTIONS(369),
    [anon_sym_AMP_AMP] = ACTIONS(369),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_LT_EQ] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_EQ] = ACTIONS(369),
    [anon_sym_EQ_EQ] = ACTIONS(369),
    [anon_sym_BANG_EQ] = ACTIONS(369),
    [anon_sym_STAR] = ACTIONS(371),
    [anon_sym_SLASH] = ACTIONS(369),
    [anon_sym_STAR_STAR] = ACTIONS(369),
    [anon_sym_CARET] = ACTIONS(369),
    [aux_sym_binary_operator_token1] = ACTIONS(369),
    [anon_sym_PIPE_GT] = ACTIONS(369),
    [anon_sym_COLON] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(369),
    [anon_sym_AT] = ACTIONS(369),
    [aux_sym__hex_literal_token1] = ACTIONS(4238),
    [sym__number_literal] = ACTIONS(4240),
    [anon_sym_SQUOTE] = ACTIONS(4242),
    [anon_sym_DQUOTE] = ACTIONS(4244),
    [sym_return] = ACTIONS(4296),
    [sym_next] = ACTIONS(4296),
    [sym_break] = ACTIONS(4296),
    [sym_true] = ACTIONS(4296),
    [sym_false] = ACTIONS(4296),
    [sym_null] = ACTIONS(4296),
    [sym_inf] = ACTIONS(4296),
    [sym_nan] = ACTIONS(4296),
    [anon_sym_NA] = ACTIONS(4248),
    [anon_sym_NA_integer_] = ACTIONS(4248),
    [anon_sym_NA_real_] = ACTIONS(4248),
    [anon_sym_NA_complex_] = ACTIONS(4248),
    [anon_sym_NA_character_] = ACTIONS(4248),
    [sym_dots] = ACTIONS(4296),
    [sym_dot_dot_i] = ACTIONS(4298),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(369),
    [sym__newline] = ACTIONS(4252),
    [sym__raw_string_literal] = ACTIONS(4254),
    [sym__external_else] = ACTIONS(369),
    [sym__external_open_parenthesis] = ACTIONS(4256),
    [sym__external_close_parenthesis] = ACTIONS(369),
    [sym__external_open_brace] = ACTIONS(4258),
    [sym__external_open_bracket] = ACTIONS(369),
    [sym__external_open_bracket2] = ACTIONS(369),
  },
  [386] = {
    [sym_function_definition] = STATE(4412),
    [sym_if_statement] = STATE(4412),
    [sym_for_statement] = STATE(4412),
    [sym_while_statement] = STATE(4412),
    [sym_repeat_statement] = STATE(4412),
    [sym_braced_expression] = STATE(4412),
    [sym_parenthesized_expression] = STATE(4412),
    [sym_call] = STATE(4412),
    [sym_subset] = STATE(4412),
    [sym_subset2] = STATE(4412),
    [sym_unary_operator] = STATE(4412),
    [sym_binary_operator] = STATE(4412),
    [sym_extract_operator] = STATE(4412),
    [sym_namespace_operator] = STATE(4412),
    [sym_integer] = STATE(4412),
    [sym_complex] = STATE(4412),
    [sym_float] = STATE(4412),
    [sym__hex_literal] = STATE(4680),
    [sym__float_literal] = STATE(4680),
    [sym_string] = STATE(4681),
    [sym__single_quoted_string] = STATE(4674),
    [sym__double_quoted_string] = STATE(4678),
    [sym_na] = STATE(4412),
    [sym__expression] = STATE(4412),
    [sym__string_or_identifier] = STATE(5129),
    [sym__open_parenthesis] = STATE(287),
    [sym__open_brace] = STATE(51),
    [aux_sym_function_definition_repeat1] = STATE(385),
    [sym_identifier] = ACTIONS(4214),
    [anon_sym_BSLASH] = ACTIONS(4216),
    [anon_sym_function] = ACTIONS(4218),
    [anon_sym_EQ] = ACTIONS(533),
    [anon_sym_if] = ACTIONS(4220),
    [anon_sym_for] = ACTIONS(4222),
    [anon_sym_while] = ACTIONS(4224),
    [anon_sym_repeat] = ACTIONS(4226),
    [anon_sym_QMARK] = ACTIONS(4228),
    [anon_sym_TILDE] = ACTIONS(4230),
    [anon_sym_BANG] = ACTIONS(4232),
    [anon_sym_PLUS] = ACTIONS(4234),
    [anon_sym_DASH] = ACTIONS(4236),
    [anon_sym_LT_DASH] = ACTIONS(531),
    [anon_sym_LT_LT_DASH] = ACTIONS(531),
    [anon_sym_COLON_EQ] = ACTIONS(531),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_DASH_GT_GT] = ACTIONS(531),
    [anon_sym_PIPE] = ACTIONS(533),
    [anon_sym_AMP] = ACTIONS(533),
    [anon_sym_PIPE_PIPE] = ACTIONS(531),
    [anon_sym_AMP_AMP] = ACTIONS(531),
    [anon_sym_LT] = ACTIONS(533),
    [anon_sym_LT_EQ] = ACTIONS(531),
    [anon_sym_GT] = ACTIONS(533),
    [anon_sym_GT_EQ] = ACTIONS(531),
    [anon_sym_EQ_EQ] = ACTIONS(531),
    [anon_sym_BANG_EQ] = ACTIONS(531),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_SLASH] = ACTIONS(531),
    [anon_sym_STAR_STAR] = ACTIONS(531),
    [anon_sym_CARET] = ACTIONS(531),
    [aux_sym_binary_operator_token1] = ACTIONS(531),
    [anon_sym_PIPE_GT] = ACTIONS(531),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_DOLLAR] = ACTIONS(531),
    [anon_sym_AT] = ACTIONS(531),
    [aux_sym__hex_literal_token1] = ACTIONS(4238),
    [sym__number_literal] = ACTIONS(4240),
    [anon_sym_SQUOTE] = ACTIONS(4242),
    [anon_sym_DQUOTE] = ACTIONS(4244),
    [sym_return] = ACTIONS(4300),
    [sym_next] = ACTIONS(4300),
    [sym_break] = ACTIONS(4300),
    [sym_true] = ACTIONS(4300),
    [sym_false] = ACTIONS(4300),
    [sym_null] = ACTIONS(4300),
    [sym_inf] = ACTIONS(4300),
    [sym_nan] = ACTIONS(4300),
    [anon_sym_NA] = ACTIONS(4248),
    [anon_sym_NA_integer_] = ACTIONS(4248),
    [anon_sym_NA_real_] = ACTIONS(4248),
    [anon_sym_NA_complex_] = ACTIONS(4248),
    [anon_sym_NA_character_] = ACTIONS(4248),
    [sym_dots] = ACTIONS(4300),
    [sym_dot_dot_i] = ACTIONS(4302),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(531),
    [sym__newline] = ACTIONS(4304),
    [sym__raw_string_literal] = ACTIONS(4254),
    [sym__external_else] = ACTIONS(531),
    [sym__external_open_parenthesis] = ACTIONS(4256),
    [sym__external_close_parenthesis] = ACTIONS(531),
    [sym__external_open_brace] = ACTIONS(4258),
    [sym__external_open_bracket] = ACTIONS(531),
    [sym__external_open_bracket2] = ACTIONS(531),
  },
  [387] = {
    [sym_function_definition] = STATE(4419),
    [sym_if_statement] = STATE(4419),
    [sym_for_statement] = STATE(4419),
    [sym_while_statement] = STATE(4419),
    [sym_repeat_statement] = STATE(4419),
    [sym_braced_expression] = STATE(4419),
    [sym_parenthesized_expression] = STATE(4419),
    [sym_call] = STATE(4419),
    [sym_subset] = STATE(4419),
    [sym_subset2] = STATE(4419),
    [sym_unary_operator] = STATE(4419),
    [sym_binary_operator] = STATE(4419),
    [sym_extract_operator] = STATE(4419),
    [sym_namespace_operator] = STATE(4419),
    [sym_integer] = STATE(4419),
    [sym_complex] = STATE(4419),
    [sym_float] = STATE(4419),
    [sym__hex_literal] = STATE(4680),
    [sym__float_literal] = STATE(4680),
    [sym_string] = STATE(4681),
    [sym__single_quoted_string] = STATE(4674),
    [sym__double_quoted_string] = STATE(4678),
    [sym_na] = STATE(4419),
    [sym__expression] = STATE(4419),
    [sym__string_or_identifier] = STATE(5129),
    [sym__open_parenthesis] = STATE(287),
    [sym__open_brace] = STATE(51),
    [aux_sym_function_definition_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(4214),
    [anon_sym_BSLASH] = ACTIONS(4216),
    [anon_sym_function] = ACTIONS(4218),
    [anon_sym_EQ] = ACTIONS(759),
    [anon_sym_if] = ACTIONS(4220),
    [anon_sym_for] = ACTIONS(4222),
    [anon_sym_while] = ACTIONS(4224),
    [anon_sym_repeat] = ACTIONS(4226),
    [anon_sym_QMARK] = ACTIONS(4228),
    [anon_sym_TILDE] = ACTIONS(4230),
    [anon_sym_BANG] = ACTIONS(4232),
    [anon_sym_PLUS] = ACTIONS(4234),
    [anon_sym_DASH] = ACTIONS(4236),
    [anon_sym_LT_DASH] = ACTIONS(757),
    [anon_sym_LT_LT_DASH] = ACTIONS(757),
    [anon_sym_COLON_EQ] = ACTIONS(757),
    [anon_sym_DASH_GT] = ACTIONS(759),
    [anon_sym_DASH_GT_GT] = ACTIONS(757),
    [anon_sym_PIPE] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(759),
    [anon_sym_PIPE_PIPE] = ACTIONS(757),
    [anon_sym_AMP_AMP] = ACTIONS(757),
    [anon_sym_LT] = ACTIONS(759),
    [anon_sym_LT_EQ] = ACTIONS(757),
    [anon_sym_GT] = ACTIONS(759),
    [anon_sym_GT_EQ] = ACTIONS(757),
    [anon_sym_EQ_EQ] = ACTIONS(757),
    [anon_sym_BANG_EQ] = ACTIONS(757),
    [anon_sym_STAR] = ACTIONS(759),
    [anon_sym_SLASH] = ACTIONS(757),
    [anon_sym_STAR_STAR] = ACTIONS(757),
    [anon_sym_CARET] = ACTIONS(757),
    [aux_sym_binary_operator_token1] = ACTIONS(757),
    [anon_sym_PIPE_GT] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(759),
    [anon_sym_DOLLAR] = ACTIONS(757),
    [anon_sym_AT] = ACTIONS(757),
    [aux_sym__hex_literal_token1] = ACTIONS(4238),
    [sym__number_literal] = ACTIONS(4240),
    [anon_sym_SQUOTE] = ACTIONS(4242),
    [anon_sym_DQUOTE] = ACTIONS(4244),
    [sym_return] = ACTIONS(4306),
    [sym_next] = ACTIONS(4306),
    [sym_break] = ACTIONS(4306),
    [sym_true] = ACTIONS(4306),
    [sym_false] = ACTIONS(4306),
    [sym_null] = ACTIONS(4306),
    [sym_inf] = ACTIONS(4306),
    [sym_nan] = ACTIONS(4306),
    [anon_sym_NA] = ACTIONS(4248),
    [anon_sym_NA_integer_] = ACTIONS(4248),
    [anon_sym_NA_real_] = ACTIONS(4248),
    [anon_sym_NA_complex_] = ACTIONS(4248),
    [anon_sym_NA_character_] = ACTIONS(4248),
    [sym_dots] = ACTIONS(4306),
    [sym_dot_dot_i] = ACTIONS(4308),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(757),
    [sym__newline] = ACTIONS(4252),
    [sym__raw_string_literal] = ACTIONS(4254),
    [sym__external_else] = ACTIONS(757),
    [sym__external_open_parenthesis] = ACTIONS(4256),
    [sym__external_close_parenthesis] = ACTIONS(757),
    [sym__external_open_brace] = ACTIONS(4258),
    [sym__external_open_bracket] = ACTIONS(757),
    [sym__external_open_bracket2] = ACTIONS(757),
  },
  [388] = {
    [sym_function_definition] = STATE(1886),
    [sym_if_statement] = STATE(1886),
    [sym_for_statement] = STATE(1886),
    [sym_while_statement] = STATE(1886),
    [sym_repeat_statement] = STATE(1886),
    [sym_braced_expression] = STATE(1886),
    [sym_parenthesized_expression] = STATE(1886),
    [sym_call] = STATE(1886),
    [sym_subset] = STATE(1886),
    [sym_subset2] = STATE(1886),
    [sym_unary_operator] = STATE(1886),
    [sym_binary_operator] = STATE(1886),
    [sym_extract_operator] = STATE(1886),
    [sym_namespace_operator] = STATE(1886),
    [sym_integer] = STATE(1886),
    [sym_complex] = STATE(1886),
    [sym_float] = STATE(1886),
    [sym__hex_literal] = STATE(2540),
    [sym__float_literal] = STATE(2540),
    [sym_string] = STATE(2541),
    [sym__single_quoted_string] = STATE(2462),
    [sym__double_quoted_string] = STATE(2494),
    [sym_na] = STATE(1886),
    [sym__expression] = STATE(1886),
    [sym__string_or_identifier] = STATE(5128),
    [sym__open_parenthesis] = STATE(246),
    [sym__open_brace] = STATE(173),
    [aux_sym_function_definition_repeat1] = STATE(2670),
    [ts_builtin_sym_end] = ACTIONS(471),
    [sym_identifier] = ACTIONS(2943),
    [anon_sym_BSLASH] = ACTIONS(2945),
    [anon_sym_function] = ACTIONS(2947),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_if] = ACTIONS(2949),
    [anon_sym_for] = ACTIONS(2951),
    [anon_sym_while] = ACTIONS(2953),
    [anon_sym_repeat] = ACTIONS(2955),
    [anon_sym_QMARK] = ACTIONS(2957),
    [anon_sym_TILDE] = ACTIONS(2959),
    [anon_sym_BANG] = ACTIONS(2961),
    [anon_sym_PLUS] = ACTIONS(2963),
    [anon_sym_DASH] = ACTIONS(2965),
    [anon_sym_LT_DASH] = ACTIONS(471),
    [anon_sym_LT_LT_DASH] = ACTIONS(471),
    [anon_sym_COLON_EQ] = ACTIONS(471),
    [anon_sym_DASH_GT] = ACTIONS(473),
    [anon_sym_DASH_GT_GT] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(473),
    [anon_sym_AMP] = ACTIONS(473),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_LT_EQ] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(473),
    [anon_sym_GT_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_STAR] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [aux_sym_binary_operator_token1] = ACTIONS(471),
    [anon_sym_PIPE_GT] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(473),
    [anon_sym_DOLLAR] = ACTIONS(471),
    [anon_sym_AT] = ACTIONS(471),
    [aux_sym__hex_literal_token1] = ACTIONS(2967),
    [sym__number_literal] = ACTIONS(2969),
    [anon_sym_SQUOTE] = ACTIONS(2971),
    [anon_sym_DQUOTE] = ACTIONS(2973),
    [sym_return] = ACTIONS(4310),
    [sym_next] = ACTIONS(4310),
    [sym_break] = ACTIONS(4310),
    [sym_true] = ACTIONS(4310),
    [sym_false] = ACTIONS(4310),
    [sym_null] = ACTIONS(4310),
    [sym_inf] = ACTIONS(4310),
    [sym_nan] = ACTIONS(4310),
    [anon_sym_NA] = ACTIONS(2977),
    [anon_sym_NA_integer_] = ACTIONS(2977),
    [anon_sym_NA_real_] = ACTIONS(2977),
    [anon_sym_NA_complex_] = ACTIONS(2977),
    [anon_sym_NA_character_] = ACTIONS(2977),
    [sym_dots] = ACTIONS(4310),
    [sym_dot_dot_i] = ACTIONS(4312),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(471),
    [sym__semicolon] = ACTIONS(471),
    [sym__raw_string_literal] = ACTIONS(2983),
    [sym__external_open_parenthesis] = ACTIONS(2985),
    [sym__external_close_parenthesis] = ACTIONS(471),
    [sym__external_open_brace] = ACTIONS(2989),
    [sym__external_open_bracket] = ACTIONS(471),
    [sym__external_open_bracket2] = ACTIONS(471),
  },
  [389] = {
    [sym_function_definition] = STATE(1790),
    [sym_if_statement] = STATE(1790),
    [sym_for_statement] = STATE(1790),
    [sym_while_statement] = STATE(1790),
    [sym_repeat_statement] = STATE(1790),
    [sym_braced_expression] = STATE(1790),
    [sym_parenthesized_expression] = STATE(1790),
    [sym_call] = STATE(1790),
    [sym_subset] = STATE(1790),
    [sym_subset2] = STATE(1790),
    [sym_unary_operator] = STATE(1790),
    [sym_binary_operator] = STATE(1790),
    [sym_extract_operator] = STATE(1790),
    [sym_namespace_operator] = STATE(1790),
    [sym_integer] = STATE(1790),
    [sym_complex] = STATE(1790),
    [sym_float] = STATE(1790),
    [sym__hex_literal] = STATE(2536),
    [sym__float_literal] = STATE(2536),
    [sym_string] = STATE(2534),
    [sym__single_quoted_string] = STATE(2538),
    [sym__double_quoted_string] = STATE(2539),
    [sym_na] = STATE(1790),
    [sym__expression] = STATE(1790),
    [sym__string_or_identifier] = STATE(5143),
    [sym__open_parenthesis] = STATE(150),
    [sym__open_brace] = STATE(133),
    [aux_sym_function_definition_repeat1] = STATE(394),
    [ts_builtin_sym_end] = ACTIONS(531),
    [sym_identifier] = ACTIONS(4053),
    [anon_sym_BSLASH] = ACTIONS(4055),
    [anon_sym_function] = ACTIONS(4057),
    [anon_sym_EQ] = ACTIONS(533),
    [anon_sym_if] = ACTIONS(4059),
    [anon_sym_for] = ACTIONS(4061),
    [anon_sym_while] = ACTIONS(4063),
    [anon_sym_repeat] = ACTIONS(4065),
    [anon_sym_QMARK] = ACTIONS(4067),
    [anon_sym_TILDE] = ACTIONS(4069),
    [anon_sym_BANG] = ACTIONS(4071),
    [anon_sym_PLUS] = ACTIONS(4073),
    [anon_sym_DASH] = ACTIONS(4075),
    [anon_sym_LT_DASH] = ACTIONS(531),
    [anon_sym_LT_LT_DASH] = ACTIONS(531),
    [anon_sym_COLON_EQ] = ACTIONS(531),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_DASH_GT_GT] = ACTIONS(531),
    [anon_sym_PIPE] = ACTIONS(533),
    [anon_sym_AMP] = ACTIONS(533),
    [anon_sym_PIPE_PIPE] = ACTIONS(531),
    [anon_sym_AMP_AMP] = ACTIONS(531),
    [anon_sym_LT] = ACTIONS(533),
    [anon_sym_LT_EQ] = ACTIONS(531),
    [anon_sym_GT] = ACTIONS(533),
    [anon_sym_GT_EQ] = ACTIONS(531),
    [anon_sym_EQ_EQ] = ACTIONS(531),
    [anon_sym_BANG_EQ] = ACTIONS(531),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_SLASH] = ACTIONS(531),
    [anon_sym_STAR_STAR] = ACTIONS(531),
    [anon_sym_CARET] = ACTIONS(531),
    [aux_sym_binary_operator_token1] = ACTIONS(531),
    [anon_sym_PIPE_GT] = ACTIONS(531),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_DOLLAR] = ACTIONS(531),
    [anon_sym_AT] = ACTIONS(531),
    [aux_sym__hex_literal_token1] = ACTIONS(4077),
    [sym__number_literal] = ACTIONS(4079),
    [anon_sym_SQUOTE] = ACTIONS(4081),
    [anon_sym_DQUOTE] = ACTIONS(4083),
    [sym_return] = ACTIONS(4314),
    [sym_next] = ACTIONS(4314),
    [sym_break] = ACTIONS(4314),
    [sym_true] = ACTIONS(4314),
    [sym_false] = ACTIONS(4314),
    [sym_null] = ACTIONS(4314),
    [sym_inf] = ACTIONS(4314),
    [sym_nan] = ACTIONS(4314),
    [anon_sym_NA] = ACTIONS(4087),
    [anon_sym_NA_integer_] = ACTIONS(4087),
    [anon_sym_NA_real_] = ACTIONS(4087),
    [anon_sym_NA_complex_] = ACTIONS(4087),
    [anon_sym_NA_character_] = ACTIONS(4087),
    [sym_dots] = ACTIONS(4314),
    [sym_dot_dot_i] = ACTIONS(4316),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4318),
    [sym__semicolon] = ACTIONS(531),
    [sym__raw_string_literal] = ACTIONS(4093),
    [sym__external_else] = ACTIONS(531),
    [sym__external_open_parenthesis] = ACTIONS(4095),
    [sym__external_open_brace] = ACTIONS(4097),
    [sym__external_open_bracket] = ACTIONS(531),
    [sym__external_open_bracket2] = ACTIONS(531),
  },
  [390] = {
    [sym_function_definition] = STATE(4383),
    [sym_if_statement] = STATE(4383),
    [sym_for_statement] = STATE(4383),
    [sym_while_statement] = STATE(4383),
    [sym_repeat_statement] = STATE(4383),
    [sym_braced_expression] = STATE(4383),
    [sym_parenthesized_expression] = STATE(4383),
    [sym_call] = STATE(4383),
    [sym_subset] = STATE(4383),
    [sym_subset2] = STATE(4383),
    [sym_unary_operator] = STATE(4383),
    [sym_binary_operator] = STATE(4383),
    [sym_extract_operator] = STATE(4383),
    [sym_namespace_operator] = STATE(4383),
    [sym_integer] = STATE(4383),
    [sym_complex] = STATE(4383),
    [sym_float] = STATE(4383),
    [sym__hex_literal] = STATE(4680),
    [sym__float_literal] = STATE(4680),
    [sym_string] = STATE(4681),
    [sym__single_quoted_string] = STATE(4674),
    [sym__double_quoted_string] = STATE(4678),
    [sym_na] = STATE(4383),
    [sym__expression] = STATE(4383),
    [sym__string_or_identifier] = STATE(5129),
    [sym__open_parenthesis] = STATE(287),
    [sym__open_brace] = STATE(51),
    [aux_sym_function_definition_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(4214),
    [anon_sym_BSLASH] = ACTIONS(4216),
    [anon_sym_function] = ACTIONS(4218),
    [anon_sym_EQ] = ACTIONS(767),
    [anon_sym_if] = ACTIONS(4220),
    [anon_sym_for] = ACTIONS(4222),
    [anon_sym_while] = ACTIONS(4224),
    [anon_sym_repeat] = ACTIONS(4226),
    [anon_sym_QMARK] = ACTIONS(4228),
    [anon_sym_TILDE] = ACTIONS(4230),
    [anon_sym_BANG] = ACTIONS(4232),
    [anon_sym_PLUS] = ACTIONS(4234),
    [anon_sym_DASH] = ACTIONS(4236),
    [anon_sym_LT_DASH] = ACTIONS(765),
    [anon_sym_LT_LT_DASH] = ACTIONS(765),
    [anon_sym_COLON_EQ] = ACTIONS(765),
    [anon_sym_DASH_GT] = ACTIONS(767),
    [anon_sym_DASH_GT_GT] = ACTIONS(765),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_AMP] = ACTIONS(767),
    [anon_sym_PIPE_PIPE] = ACTIONS(765),
    [anon_sym_AMP_AMP] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(767),
    [anon_sym_LT_EQ] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_GT_EQ] = ACTIONS(765),
    [anon_sym_EQ_EQ] = ACTIONS(765),
    [anon_sym_BANG_EQ] = ACTIONS(765),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(765),
    [anon_sym_STAR_STAR] = ACTIONS(765),
    [anon_sym_CARET] = ACTIONS(765),
    [aux_sym_binary_operator_token1] = ACTIONS(765),
    [anon_sym_PIPE_GT] = ACTIONS(765),
    [anon_sym_COLON] = ACTIONS(767),
    [anon_sym_DOLLAR] = ACTIONS(765),
    [anon_sym_AT] = ACTIONS(765),
    [aux_sym__hex_literal_token1] = ACTIONS(4238),
    [sym__number_literal] = ACTIONS(4240),
    [anon_sym_SQUOTE] = ACTIONS(4242),
    [anon_sym_DQUOTE] = ACTIONS(4244),
    [sym_return] = ACTIONS(4320),
    [sym_next] = ACTIONS(4320),
    [sym_break] = ACTIONS(4320),
    [sym_true] = ACTIONS(4320),
    [sym_false] = ACTIONS(4320),
    [sym_null] = ACTIONS(4320),
    [sym_inf] = ACTIONS(4320),
    [sym_nan] = ACTIONS(4320),
    [anon_sym_NA] = ACTIONS(4248),
    [anon_sym_NA_integer_] = ACTIONS(4248),
    [anon_sym_NA_real_] = ACTIONS(4248),
    [anon_sym_NA_complex_] = ACTIONS(4248),
    [anon_sym_NA_character_] = ACTIONS(4248),
    [sym_dots] = ACTIONS(4320),
    [sym_dot_dot_i] = ACTIONS(4322),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(765),
    [sym__newline] = ACTIONS(4252),
    [sym__raw_string_literal] = ACTIONS(4254),
    [sym__external_else] = ACTIONS(765),
    [sym__external_open_parenthesis] = ACTIONS(4256),
    [sym__external_close_parenthesis] = ACTIONS(765),
    [sym__external_open_brace] = ACTIONS(4258),
    [sym__external_open_bracket] = ACTIONS(765),
    [sym__external_open_bracket2] = ACTIONS(765),
  },
  [391] = {
    [sym_function_definition] = STATE(4406),
    [sym_if_statement] = STATE(4406),
    [sym_for_statement] = STATE(4406),
    [sym_while_statement] = STATE(4406),
    [sym_repeat_statement] = STATE(4406),
    [sym_braced_expression] = STATE(4406),
    [sym_parenthesized_expression] = STATE(4406),
    [sym_call] = STATE(4406),
    [sym_subset] = STATE(4406),
    [sym_subset2] = STATE(4406),
    [sym_unary_operator] = STATE(4406),
    [sym_binary_operator] = STATE(4406),
    [sym_extract_operator] = STATE(4406),
    [sym_namespace_operator] = STATE(4406),
    [sym_integer] = STATE(4406),
    [sym_complex] = STATE(4406),
    [sym_float] = STATE(4406),
    [sym__hex_literal] = STATE(4680),
    [sym__float_literal] = STATE(4680),
    [sym_string] = STATE(4681),
    [sym__single_quoted_string] = STATE(4674),
    [sym__double_quoted_string] = STATE(4678),
    [sym_na] = STATE(4406),
    [sym__expression] = STATE(4406),
    [sym__string_or_identifier] = STATE(5129),
    [sym__open_parenthesis] = STATE(287),
    [sym__open_brace] = STATE(51),
    [aux_sym_function_definition_repeat1] = STATE(387),
    [sym_identifier] = ACTIONS(4214),
    [anon_sym_BSLASH] = ACTIONS(4216),
    [anon_sym_function] = ACTIONS(4218),
    [anon_sym_EQ] = ACTIONS(543),
    [anon_sym_if] = ACTIONS(4220),
    [anon_sym_for] = ACTIONS(4222),
    [anon_sym_while] = ACTIONS(4224),
    [anon_sym_repeat] = ACTIONS(4226),
    [anon_sym_QMARK] = ACTIONS(4228),
    [anon_sym_TILDE] = ACTIONS(4230),
    [anon_sym_BANG] = ACTIONS(4232),
    [anon_sym_PLUS] = ACTIONS(4234),
    [anon_sym_DASH] = ACTIONS(4236),
    [anon_sym_LT_DASH] = ACTIONS(545),
    [anon_sym_LT_LT_DASH] = ACTIONS(545),
    [anon_sym_COLON_EQ] = ACTIONS(545),
    [anon_sym_DASH_GT] = ACTIONS(543),
    [anon_sym_DASH_GT_GT] = ACTIONS(545),
    [anon_sym_PIPE] = ACTIONS(543),
    [anon_sym_AMP] = ACTIONS(543),
    [anon_sym_PIPE_PIPE] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(543),
    [anon_sym_LT_EQ] = ACTIONS(545),
    [anon_sym_GT] = ACTIONS(543),
    [anon_sym_GT_EQ] = ACTIONS(545),
    [anon_sym_EQ_EQ] = ACTIONS(545),
    [anon_sym_BANG_EQ] = ACTIONS(545),
    [anon_sym_STAR] = ACTIONS(543),
    [anon_sym_SLASH] = ACTIONS(545),
    [anon_sym_STAR_STAR] = ACTIONS(545),
    [anon_sym_CARET] = ACTIONS(545),
    [aux_sym_binary_operator_token1] = ACTIONS(545),
    [anon_sym_PIPE_GT] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(543),
    [anon_sym_DOLLAR] = ACTIONS(545),
    [anon_sym_AT] = ACTIONS(545),
    [aux_sym__hex_literal_token1] = ACTIONS(4238),
    [sym__number_literal] = ACTIONS(4240),
    [anon_sym_SQUOTE] = ACTIONS(4242),
    [anon_sym_DQUOTE] = ACTIONS(4244),
    [sym_return] = ACTIONS(4324),
    [sym_next] = ACTIONS(4324),
    [sym_break] = ACTIONS(4324),
    [sym_true] = ACTIONS(4324),
    [sym_false] = ACTIONS(4324),
    [sym_null] = ACTIONS(4324),
    [sym_inf] = ACTIONS(4324),
    [sym_nan] = ACTIONS(4324),
    [anon_sym_NA] = ACTIONS(4248),
    [anon_sym_NA_integer_] = ACTIONS(4248),
    [anon_sym_NA_real_] = ACTIONS(4248),
    [anon_sym_NA_complex_] = ACTIONS(4248),
    [anon_sym_NA_character_] = ACTIONS(4248),
    [sym_dots] = ACTIONS(4324),
    [sym_dot_dot_i] = ACTIONS(4326),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(545),
    [sym__newline] = ACTIONS(4328),
    [sym__raw_string_literal] = ACTIONS(4254),
    [sym__external_else] = ACTIONS(545),
    [sym__external_open_parenthesis] = ACTIONS(4256),
    [sym__external_close_parenthesis] = ACTIONS(545),
    [sym__external_open_brace] = ACTIONS(4258),
    [sym__external_open_bracket] = ACTIONS(545),
    [sym__external_open_bracket2] = ACTIONS(545),
  },
  [392] = {
    [sym_function_definition] = STATE(1907),
    [sym_if_statement] = STATE(1907),
    [sym_for_statement] = STATE(1907),
    [sym_while_statement] = STATE(1907),
    [sym_repeat_statement] = STATE(1907),
    [sym_braced_expression] = STATE(1907),
    [sym_parenthesized_expression] = STATE(1907),
    [sym_call] = STATE(1907),
    [sym_subset] = STATE(1907),
    [sym_subset2] = STATE(1907),
    [sym_unary_operator] = STATE(1907),
    [sym_binary_operator] = STATE(1907),
    [sym_extract_operator] = STATE(1907),
    [sym_namespace_operator] = STATE(1907),
    [sym_integer] = STATE(1907),
    [sym_complex] = STATE(1907),
    [sym_float] = STATE(1907),
    [sym__hex_literal] = STATE(2523),
    [sym__float_literal] = STATE(2523),
    [sym_string] = STATE(2522),
    [sym__single_quoted_string] = STATE(2528),
    [sym__double_quoted_string] = STATE(2529),
    [sym_na] = STATE(1907),
    [sym__expression] = STATE(1907),
    [sym__string_or_identifier] = STATE(5126),
    [sym__open_parenthesis] = STATE(178),
    [sym__open_brace] = STATE(244),
    [aux_sym_function_definition_repeat1] = STATE(406),
    [ts_builtin_sym_end] = ACTIONS(263),
    [sym_identifier] = ACTIONS(2826),
    [anon_sym_BSLASH] = ACTIONS(2828),
    [anon_sym_function] = ACTIONS(2830),
    [anon_sym_EQ] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(2832),
    [anon_sym_for] = ACTIONS(2834),
    [anon_sym_while] = ACTIONS(2836),
    [anon_sym_repeat] = ACTIONS(2838),
    [anon_sym_QMARK] = ACTIONS(2840),
    [anon_sym_TILDE] = ACTIONS(2842),
    [anon_sym_BANG] = ACTIONS(2844),
    [anon_sym_PLUS] = ACTIONS(2846),
    [anon_sym_DASH] = ACTIONS(2848),
    [anon_sym_LT_DASH] = ACTIONS(263),
    [anon_sym_LT_LT_DASH] = ACTIONS(263),
    [anon_sym_COLON_EQ] = ACTIONS(263),
    [anon_sym_DASH_GT] = ACTIONS(265),
    [anon_sym_DASH_GT_GT] = ACTIONS(263),
    [anon_sym_PIPE] = ACTIONS(265),
    [anon_sym_AMP] = ACTIONS(265),
    [anon_sym_PIPE_PIPE] = ACTIONS(263),
    [anon_sym_AMP_AMP] = ACTIONS(263),
    [anon_sym_LT] = ACTIONS(265),
    [anon_sym_LT_EQ] = ACTIONS(263),
    [anon_sym_GT] = ACTIONS(265),
    [anon_sym_GT_EQ] = ACTIONS(263),
    [anon_sym_EQ_EQ] = ACTIONS(263),
    [anon_sym_BANG_EQ] = ACTIONS(263),
    [anon_sym_STAR] = ACTIONS(265),
    [anon_sym_SLASH] = ACTIONS(263),
    [anon_sym_STAR_STAR] = ACTIONS(263),
    [anon_sym_CARET] = ACTIONS(263),
    [aux_sym_binary_operator_token1] = ACTIONS(263),
    [anon_sym_PIPE_GT] = ACTIONS(263),
    [anon_sym_COLON] = ACTIONS(265),
    [anon_sym_DOLLAR] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(263),
    [aux_sym__hex_literal_token1] = ACTIONS(2850),
    [sym__number_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE] = ACTIONS(2856),
    [sym_return] = ACTIONS(4330),
    [sym_next] = ACTIONS(4330),
    [sym_break] = ACTIONS(4330),
    [sym_true] = ACTIONS(4330),
    [sym_false] = ACTIONS(4330),
    [sym_null] = ACTIONS(4330),
    [sym_inf] = ACTIONS(4330),
    [sym_nan] = ACTIONS(4330),
    [anon_sym_NA] = ACTIONS(2860),
    [anon_sym_NA_integer_] = ACTIONS(2860),
    [anon_sym_NA_real_] = ACTIONS(2860),
    [anon_sym_NA_complex_] = ACTIONS(2860),
    [anon_sym_NA_character_] = ACTIONS(2860),
    [sym_dots] = ACTIONS(4330),
    [sym_dot_dot_i] = ACTIONS(4332),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4334),
    [sym__semicolon] = ACTIONS(263),
    [sym__raw_string_literal] = ACTIONS(2866),
    [sym__external_open_parenthesis] = ACTIONS(2868),
    [sym__external_open_brace] = ACTIONS(2870),
    [sym__external_close_brace] = ACTIONS(263),
    [sym__external_open_bracket] = ACTIONS(263),
    [sym__external_open_bracket2] = ACTIONS(263),
  },
  [393] = {
    [sym_function_definition] = STATE(4424),
    [sym_if_statement] = STATE(4424),
    [sym_for_statement] = STATE(4424),
    [sym_while_statement] = STATE(4424),
    [sym_repeat_statement] = STATE(4424),
    [sym_braced_expression] = STATE(4424),
    [sym_parenthesized_expression] = STATE(4424),
    [sym_call] = STATE(4424),
    [sym_subset] = STATE(4424),
    [sym_subset2] = STATE(4424),
    [sym_unary_operator] = STATE(4424),
    [sym_binary_operator] = STATE(4424),
    [sym_extract_operator] = STATE(4424),
    [sym_namespace_operator] = STATE(4424),
    [sym_integer] = STATE(4424),
    [sym_complex] = STATE(4424),
    [sym_float] = STATE(4424),
    [sym__hex_literal] = STATE(4680),
    [sym__float_literal] = STATE(4680),
    [sym_string] = STATE(4681),
    [sym__single_quoted_string] = STATE(4674),
    [sym__double_quoted_string] = STATE(4678),
    [sym_na] = STATE(4424),
    [sym__expression] = STATE(4424),
    [sym__string_or_identifier] = STATE(5129),
    [sym__open_parenthesis] = STATE(287),
    [sym__open_brace] = STATE(51),
    [aux_sym_function_definition_repeat1] = STATE(390),
    [sym_identifier] = ACTIONS(4214),
    [anon_sym_BSLASH] = ACTIONS(4216),
    [anon_sym_function] = ACTIONS(4218),
    [anon_sym_EQ] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(4220),
    [anon_sym_for] = ACTIONS(4222),
    [anon_sym_while] = ACTIONS(4224),
    [anon_sym_repeat] = ACTIONS(4226),
    [anon_sym_QMARK] = ACTIONS(4228),
    [anon_sym_TILDE] = ACTIONS(4230),
    [anon_sym_BANG] = ACTIONS(4232),
    [anon_sym_PLUS] = ACTIONS(4234),
    [anon_sym_DASH] = ACTIONS(4236),
    [anon_sym_LT_DASH] = ACTIONS(263),
    [anon_sym_LT_LT_DASH] = ACTIONS(263),
    [anon_sym_COLON_EQ] = ACTIONS(263),
    [anon_sym_DASH_GT] = ACTIONS(265),
    [anon_sym_DASH_GT_GT] = ACTIONS(263),
    [anon_sym_PIPE] = ACTIONS(265),
    [anon_sym_AMP] = ACTIONS(265),
    [anon_sym_PIPE_PIPE] = ACTIONS(263),
    [anon_sym_AMP_AMP] = ACTIONS(263),
    [anon_sym_LT] = ACTIONS(265),
    [anon_sym_LT_EQ] = ACTIONS(263),
    [anon_sym_GT] = ACTIONS(265),
    [anon_sym_GT_EQ] = ACTIONS(263),
    [anon_sym_EQ_EQ] = ACTIONS(263),
    [anon_sym_BANG_EQ] = ACTIONS(263),
    [anon_sym_STAR] = ACTIONS(265),
    [anon_sym_SLASH] = ACTIONS(263),
    [anon_sym_STAR_STAR] = ACTIONS(263),
    [anon_sym_CARET] = ACTIONS(263),
    [aux_sym_binary_operator_token1] = ACTIONS(263),
    [anon_sym_PIPE_GT] = ACTIONS(263),
    [anon_sym_COLON] = ACTIONS(265),
    [anon_sym_DOLLAR] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(263),
    [aux_sym__hex_literal_token1] = ACTIONS(4238),
    [sym__number_literal] = ACTIONS(4240),
    [anon_sym_SQUOTE] = ACTIONS(4242),
    [anon_sym_DQUOTE] = ACTIONS(4244),
    [sym_return] = ACTIONS(4336),
    [sym_next] = ACTIONS(4336),
    [sym_break] = ACTIONS(4336),
    [sym_true] = ACTIONS(4336),
    [sym_false] = ACTIONS(4336),
    [sym_null] = ACTIONS(4336),
    [sym_inf] = ACTIONS(4336),
    [sym_nan] = ACTIONS(4336),
    [anon_sym_NA] = ACTIONS(4248),
    [anon_sym_NA_integer_] = ACTIONS(4248),
    [anon_sym_NA_real_] = ACTIONS(4248),
    [anon_sym_NA_complex_] = ACTIONS(4248),
    [anon_sym_NA_character_] = ACTIONS(4248),
    [sym_dots] = ACTIONS(4336),
    [sym_dot_dot_i] = ACTIONS(4338),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(263),
    [sym__newline] = ACTIONS(4340),
    [sym__raw_string_literal] = ACTIONS(4254),
    [sym__external_else] = ACTIONS(263),
    [sym__external_open_parenthesis] = ACTIONS(4256),
    [sym__external_close_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(4258),
    [sym__external_open_bracket] = ACTIONS(263),
    [sym__external_open_bracket2] = ACTIONS(263),
  },
  [394] = {
    [sym_function_definition] = STATE(1754),
    [sym_if_statement] = STATE(1754),
    [sym_for_statement] = STATE(1754),
    [sym_while_statement] = STATE(1754),
    [sym_repeat_statement] = STATE(1754),
    [sym_braced_expression] = STATE(1754),
    [sym_parenthesized_expression] = STATE(1754),
    [sym_call] = STATE(1754),
    [sym_subset] = STATE(1754),
    [sym_subset2] = STATE(1754),
    [sym_unary_operator] = STATE(1754),
    [sym_binary_operator] = STATE(1754),
    [sym_extract_operator] = STATE(1754),
    [sym_namespace_operator] = STATE(1754),
    [sym_integer] = STATE(1754),
    [sym_complex] = STATE(1754),
    [sym_float] = STATE(1754),
    [sym__hex_literal] = STATE(2536),
    [sym__float_literal] = STATE(2536),
    [sym_string] = STATE(2534),
    [sym__single_quoted_string] = STATE(2538),
    [sym__double_quoted_string] = STATE(2539),
    [sym_na] = STATE(1754),
    [sym__expression] = STATE(1754),
    [sym__string_or_identifier] = STATE(5143),
    [sym__open_parenthesis] = STATE(150),
    [sym__open_brace] = STATE(133),
    [aux_sym_function_definition_repeat1] = STATE(2742),
    [ts_builtin_sym_end] = ACTIONS(369),
    [sym_identifier] = ACTIONS(4053),
    [anon_sym_BSLASH] = ACTIONS(4055),
    [anon_sym_function] = ACTIONS(4057),
    [anon_sym_EQ] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(4059),
    [anon_sym_for] = ACTIONS(4061),
    [anon_sym_while] = ACTIONS(4063),
    [anon_sym_repeat] = ACTIONS(4065),
    [anon_sym_QMARK] = ACTIONS(4067),
    [anon_sym_TILDE] = ACTIONS(4069),
    [anon_sym_BANG] = ACTIONS(4071),
    [anon_sym_PLUS] = ACTIONS(4073),
    [anon_sym_DASH] = ACTIONS(4075),
    [anon_sym_LT_DASH] = ACTIONS(369),
    [anon_sym_LT_LT_DASH] = ACTIONS(369),
    [anon_sym_COLON_EQ] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(371),
    [anon_sym_DASH_GT_GT] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(371),
    [anon_sym_AMP] = ACTIONS(371),
    [anon_sym_PIPE_PIPE] = ACTIONS(369),
    [anon_sym_AMP_AMP] = ACTIONS(369),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_LT_EQ] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_EQ] = ACTIONS(369),
    [anon_sym_EQ_EQ] = ACTIONS(369),
    [anon_sym_BANG_EQ] = ACTIONS(369),
    [anon_sym_STAR] = ACTIONS(371),
    [anon_sym_SLASH] = ACTIONS(369),
    [anon_sym_STAR_STAR] = ACTIONS(369),
    [anon_sym_CARET] = ACTIONS(369),
    [aux_sym_binary_operator_token1] = ACTIONS(369),
    [anon_sym_PIPE_GT] = ACTIONS(369),
    [anon_sym_COLON] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(369),
    [anon_sym_AT] = ACTIONS(369),
    [aux_sym__hex_literal_token1] = ACTIONS(4077),
    [sym__number_literal] = ACTIONS(4079),
    [anon_sym_SQUOTE] = ACTIONS(4081),
    [anon_sym_DQUOTE] = ACTIONS(4083),
    [sym_return] = ACTIONS(4342),
    [sym_next] = ACTIONS(4342),
    [sym_break] = ACTIONS(4342),
    [sym_true] = ACTIONS(4342),
    [sym_false] = ACTIONS(4342),
    [sym_null] = ACTIONS(4342),
    [sym_inf] = ACTIONS(4342),
    [sym_nan] = ACTIONS(4342),
    [anon_sym_NA] = ACTIONS(4087),
    [anon_sym_NA_integer_] = ACTIONS(4087),
    [anon_sym_NA_real_] = ACTIONS(4087),
    [anon_sym_NA_complex_] = ACTIONS(4087),
    [anon_sym_NA_character_] = ACTIONS(4087),
    [sym_dots] = ACTIONS(4342),
    [sym_dot_dot_i] = ACTIONS(4344),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(369),
    [sym__semicolon] = ACTIONS(369),
    [sym__raw_string_literal] = ACTIONS(4093),
    [sym__external_else] = ACTIONS(369),
    [sym__external_open_parenthesis] = ACTIONS(4095),
    [sym__external_open_brace] = ACTIONS(4097),
    [sym__external_open_bracket] = ACTIONS(369),
    [sym__external_open_bracket2] = ACTIONS(369),
  },
  [395] = {
    [sym_function_definition] = STATE(1749),
    [sym_if_statement] = STATE(1749),
    [sym_for_statement] = STATE(1749),
    [sym_while_statement] = STATE(1749),
    [sym_repeat_statement] = STATE(1749),
    [sym_braced_expression] = STATE(1749),
    [sym_parenthesized_expression] = STATE(1749),
    [sym_call] = STATE(1749),
    [sym_subset] = STATE(1749),
    [sym_subset2] = STATE(1749),
    [sym_unary_operator] = STATE(1749),
    [sym_binary_operator] = STATE(1749),
    [sym_extract_operator] = STATE(1749),
    [sym_namespace_operator] = STATE(1749),
    [sym_integer] = STATE(1749),
    [sym_complex] = STATE(1749),
    [sym_float] = STATE(1749),
    [sym__hex_literal] = STATE(2536),
    [sym__float_literal] = STATE(2536),
    [sym_string] = STATE(2534),
    [sym__single_quoted_string] = STATE(2538),
    [sym__double_quoted_string] = STATE(2539),
    [sym_na] = STATE(1749),
    [sym__expression] = STATE(1749),
    [sym__string_or_identifier] = STATE(5143),
    [sym__open_parenthesis] = STATE(150),
    [sym__open_brace] = STATE(133),
    [aux_sym_function_definition_repeat1] = STATE(401),
    [ts_builtin_sym_end] = ACTIONS(377),
    [sym_identifier] = ACTIONS(4053),
    [anon_sym_BSLASH] = ACTIONS(4055),
    [anon_sym_function] = ACTIONS(4057),
    [anon_sym_EQ] = ACTIONS(379),
    [anon_sym_if] = ACTIONS(4059),
    [anon_sym_for] = ACTIONS(4061),
    [anon_sym_while] = ACTIONS(4063),
    [anon_sym_repeat] = ACTIONS(4065),
    [anon_sym_QMARK] = ACTIONS(4067),
    [anon_sym_TILDE] = ACTIONS(4069),
    [anon_sym_BANG] = ACTIONS(4071),
    [anon_sym_PLUS] = ACTIONS(4073),
    [anon_sym_DASH] = ACTIONS(4075),
    [anon_sym_LT_DASH] = ACTIONS(377),
    [anon_sym_LT_LT_DASH] = ACTIONS(377),
    [anon_sym_COLON_EQ] = ACTIONS(377),
    [anon_sym_DASH_GT] = ACTIONS(379),
    [anon_sym_DASH_GT_GT] = ACTIONS(377),
    [anon_sym_PIPE] = ACTIONS(379),
    [anon_sym_AMP] = ACTIONS(379),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_LT] = ACTIONS(379),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(379),
    [anon_sym_GT_EQ] = ACTIONS(377),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(379),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_STAR_STAR] = ACTIONS(377),
    [anon_sym_CARET] = ACTIONS(377),
    [aux_sym_binary_operator_token1] = ACTIONS(377),
    [anon_sym_PIPE_GT] = ACTIONS(377),
    [anon_sym_COLON] = ACTIONS(379),
    [anon_sym_DOLLAR] = ACTIONS(377),
    [anon_sym_AT] = ACTIONS(377),
    [aux_sym__hex_literal_token1] = ACTIONS(4077),
    [sym__number_literal] = ACTIONS(4079),
    [anon_sym_SQUOTE] = ACTIONS(4081),
    [anon_sym_DQUOTE] = ACTIONS(4083),
    [sym_return] = ACTIONS(4346),
    [sym_next] = ACTIONS(4346),
    [sym_break] = ACTIONS(4346),
    [sym_true] = ACTIONS(4346),
    [sym_false] = ACTIONS(4346),
    [sym_null] = ACTIONS(4346),
    [sym_inf] = ACTIONS(4346),
    [sym_nan] = ACTIONS(4346),
    [anon_sym_NA] = ACTIONS(4087),
    [anon_sym_NA_integer_] = ACTIONS(4087),
    [anon_sym_NA_real_] = ACTIONS(4087),
    [anon_sym_NA_complex_] = ACTIONS(4087),
    [anon_sym_NA_character_] = ACTIONS(4087),
    [sym_dots] = ACTIONS(4346),
    [sym_dot_dot_i] = ACTIONS(4348),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4350),
    [sym__semicolon] = ACTIONS(377),
    [sym__raw_string_literal] = ACTIONS(4093),
    [sym__external_else] = ACTIONS(377),
    [sym__external_open_parenthesis] = ACTIONS(4095),
    [sym__external_open_brace] = ACTIONS(4097),
    [sym__external_open_bracket] = ACTIONS(377),
    [sym__external_open_bracket2] = ACTIONS(377),
  },
  [396] = {
    [sym_function_definition] = STATE(1462),
    [sym_if_statement] = STATE(1462),
    [sym_for_statement] = STATE(1462),
    [sym_while_statement] = STATE(1462),
    [sym_repeat_statement] = STATE(1462),
    [sym_braced_expression] = STATE(1462),
    [sym_parenthesized_expression] = STATE(1462),
    [sym_call] = STATE(1462),
    [sym_subset] = STATE(1462),
    [sym_subset2] = STATE(1462),
    [sym_unary_operator] = STATE(1462),
    [sym_binary_operator] = STATE(1462),
    [sym_extract_operator] = STATE(1462),
    [sym_namespace_operator] = STATE(1462),
    [sym_integer] = STATE(1462),
    [sym_complex] = STATE(1462),
    [sym_float] = STATE(1462),
    [sym__hex_literal] = STATE(2445),
    [sym__float_literal] = STATE(2445),
    [sym_string] = STATE(2530),
    [sym__single_quoted_string] = STATE(2442),
    [sym__double_quoted_string] = STATE(2437),
    [sym_na] = STATE(1462),
    [sym__expression] = STATE(1462),
    [sym__string_or_identifier] = STATE(5133),
    [sym__open_parenthesis] = STATE(213),
    [sym__open_brace] = STATE(70),
    [aux_sym_function_definition_repeat1] = STATE(310),
    [sym_identifier] = ACTIONS(2531),
    [anon_sym_BSLASH] = ACTIONS(2533),
    [anon_sym_function] = ACTIONS(2535),
    [anon_sym_EQ] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(2537),
    [anon_sym_for] = ACTIONS(2539),
    [anon_sym_while] = ACTIONS(2541),
    [anon_sym_repeat] = ACTIONS(2543),
    [anon_sym_QMARK] = ACTIONS(2545),
    [anon_sym_TILDE] = ACTIONS(2547),
    [anon_sym_BANG] = ACTIONS(2549),
    [anon_sym_PLUS] = ACTIONS(2551),
    [anon_sym_DASH] = ACTIONS(2553),
    [anon_sym_LT_DASH] = ACTIONS(387),
    [anon_sym_LT_LT_DASH] = ACTIONS(387),
    [anon_sym_COLON_EQ] = ACTIONS(387),
    [anon_sym_DASH_GT] = ACTIONS(389),
    [anon_sym_DASH_GT_GT] = ACTIONS(387),
    [anon_sym_PIPE] = ACTIONS(389),
    [anon_sym_AMP] = ACTIONS(389),
    [anon_sym_PIPE_PIPE] = ACTIONS(387),
    [anon_sym_AMP_AMP] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(389),
    [anon_sym_LT_EQ] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(389),
    [anon_sym_GT_EQ] = ACTIONS(387),
    [anon_sym_EQ_EQ] = ACTIONS(387),
    [anon_sym_BANG_EQ] = ACTIONS(387),
    [anon_sym_STAR] = ACTIONS(389),
    [anon_sym_SLASH] = ACTIONS(387),
    [anon_sym_STAR_STAR] = ACTIONS(387),
    [anon_sym_CARET] = ACTIONS(387),
    [aux_sym_binary_operator_token1] = ACTIONS(387),
    [anon_sym_PIPE_GT] = ACTIONS(387),
    [anon_sym_COLON] = ACTIONS(389),
    [anon_sym_DOLLAR] = ACTIONS(387),
    [anon_sym_AT] = ACTIONS(387),
    [aux_sym__hex_literal_token1] = ACTIONS(2555),
    [sym__number_literal] = ACTIONS(2557),
    [anon_sym_SQUOTE] = ACTIONS(2559),
    [anon_sym_DQUOTE] = ACTIONS(2561),
    [sym_return] = ACTIONS(4352),
    [sym_next] = ACTIONS(4352),
    [sym_break] = ACTIONS(4352),
    [sym_true] = ACTIONS(4352),
    [sym_false] = ACTIONS(4352),
    [sym_null] = ACTIONS(4352),
    [sym_inf] = ACTIONS(4352),
    [sym_nan] = ACTIONS(4352),
    [anon_sym_NA] = ACTIONS(2565),
    [anon_sym_NA_integer_] = ACTIONS(2565),
    [anon_sym_NA_real_] = ACTIONS(2565),
    [anon_sym_NA_complex_] = ACTIONS(2565),
    [anon_sym_NA_character_] = ACTIONS(2565),
    [sym_dots] = ACTIONS(4352),
    [sym_dot_dot_i] = ACTIONS(4354),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(387),
    [sym__newline] = ACTIONS(4356),
    [sym__raw_string_literal] = ACTIONS(2571),
    [sym__external_open_parenthesis] = ACTIONS(2573),
    [sym__external_close_parenthesis] = ACTIONS(387),
    [sym__external_open_brace] = ACTIONS(2577),
    [sym__external_open_bracket] = ACTIONS(387),
    [sym__external_close_bracket] = ACTIONS(387),
    [sym__external_open_bracket2] = ACTIONS(387),
  },
  [397] = {
    [sym_function_definition] = STATE(1672),
    [sym_if_statement] = STATE(1672),
    [sym_for_statement] = STATE(1672),
    [sym_while_statement] = STATE(1672),
    [sym_repeat_statement] = STATE(1672),
    [sym_braced_expression] = STATE(1672),
    [sym_parenthesized_expression] = STATE(1672),
    [sym_call] = STATE(1672),
    [sym_subset] = STATE(1672),
    [sym_subset2] = STATE(1672),
    [sym_unary_operator] = STATE(1672),
    [sym_binary_operator] = STATE(1672),
    [sym_extract_operator] = STATE(1672),
    [sym_namespace_operator] = STATE(1672),
    [sym_integer] = STATE(1672),
    [sym_complex] = STATE(1672),
    [sym_float] = STATE(1672),
    [sym__hex_literal] = STATE(2536),
    [sym__float_literal] = STATE(2536),
    [sym_string] = STATE(2534),
    [sym__single_quoted_string] = STATE(2538),
    [sym__double_quoted_string] = STATE(2539),
    [sym_na] = STATE(1672),
    [sym__expression] = STATE(1672),
    [sym__string_or_identifier] = STATE(5143),
    [sym__open_parenthesis] = STATE(150),
    [sym__open_brace] = STATE(133),
    [aux_sym_function_definition_repeat1] = STATE(403),
    [ts_builtin_sym_end] = ACTIONS(387),
    [sym_identifier] = ACTIONS(4053),
    [anon_sym_BSLASH] = ACTIONS(4055),
    [anon_sym_function] = ACTIONS(4057),
    [anon_sym_EQ] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(4059),
    [anon_sym_for] = ACTIONS(4061),
    [anon_sym_while] = ACTIONS(4063),
    [anon_sym_repeat] = ACTIONS(4065),
    [anon_sym_QMARK] = ACTIONS(4067),
    [anon_sym_TILDE] = ACTIONS(4069),
    [anon_sym_BANG] = ACTIONS(4071),
    [anon_sym_PLUS] = ACTIONS(4073),
    [anon_sym_DASH] = ACTIONS(4075),
    [anon_sym_LT_DASH] = ACTIONS(387),
    [anon_sym_LT_LT_DASH] = ACTIONS(387),
    [anon_sym_COLON_EQ] = ACTIONS(387),
    [anon_sym_DASH_GT] = ACTIONS(389),
    [anon_sym_DASH_GT_GT] = ACTIONS(387),
    [anon_sym_PIPE] = ACTIONS(389),
    [anon_sym_AMP] = ACTIONS(389),
    [anon_sym_PIPE_PIPE] = ACTIONS(387),
    [anon_sym_AMP_AMP] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(389),
    [anon_sym_LT_EQ] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(389),
    [anon_sym_GT_EQ] = ACTIONS(387),
    [anon_sym_EQ_EQ] = ACTIONS(387),
    [anon_sym_BANG_EQ] = ACTIONS(387),
    [anon_sym_STAR] = ACTIONS(389),
    [anon_sym_SLASH] = ACTIONS(387),
    [anon_sym_STAR_STAR] = ACTIONS(387),
    [anon_sym_CARET] = ACTIONS(387),
    [aux_sym_binary_operator_token1] = ACTIONS(387),
    [anon_sym_PIPE_GT] = ACTIONS(387),
    [anon_sym_COLON] = ACTIONS(389),
    [anon_sym_DOLLAR] = ACTIONS(387),
    [anon_sym_AT] = ACTIONS(387),
    [aux_sym__hex_literal_token1] = ACTIONS(4077),
    [sym__number_literal] = ACTIONS(4079),
    [anon_sym_SQUOTE] = ACTIONS(4081),
    [anon_sym_DQUOTE] = ACTIONS(4083),
    [sym_return] = ACTIONS(4358),
    [sym_next] = ACTIONS(4358),
    [sym_break] = ACTIONS(4358),
    [sym_true] = ACTIONS(4358),
    [sym_false] = ACTIONS(4358),
    [sym_null] = ACTIONS(4358),
    [sym_inf] = ACTIONS(4358),
    [sym_nan] = ACTIONS(4358),
    [anon_sym_NA] = ACTIONS(4087),
    [anon_sym_NA_integer_] = ACTIONS(4087),
    [anon_sym_NA_real_] = ACTIONS(4087),
    [anon_sym_NA_complex_] = ACTIONS(4087),
    [anon_sym_NA_character_] = ACTIONS(4087),
    [sym_dots] = ACTIONS(4358),
    [sym_dot_dot_i] = ACTIONS(4360),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4362),
    [sym__semicolon] = ACTIONS(387),
    [sym__raw_string_literal] = ACTIONS(4093),
    [sym__external_else] = ACTIONS(387),
    [sym__external_open_parenthesis] = ACTIONS(4095),
    [sym__external_open_brace] = ACTIONS(4097),
    [sym__external_open_bracket] = ACTIONS(387),
    [sym__external_open_bracket2] = ACTIONS(387),
  },
  [398] = {
    [sym_function_definition] = STATE(1456),
    [sym_if_statement] = STATE(1456),
    [sym_for_statement] = STATE(1456),
    [sym_while_statement] = STATE(1456),
    [sym_repeat_statement] = STATE(1456),
    [sym_braced_expression] = STATE(1456),
    [sym_parenthesized_expression] = STATE(1456),
    [sym_call] = STATE(1456),
    [sym_subset] = STATE(1456),
    [sym_subset2] = STATE(1456),
    [sym_unary_operator] = STATE(1456),
    [sym_binary_operator] = STATE(1456),
    [sym_extract_operator] = STATE(1456),
    [sym_namespace_operator] = STATE(1456),
    [sym_integer] = STATE(1456),
    [sym_complex] = STATE(1456),
    [sym_float] = STATE(1456),
    [sym__hex_literal] = STATE(2445),
    [sym__float_literal] = STATE(2445),
    [sym_string] = STATE(2530),
    [sym__single_quoted_string] = STATE(2442),
    [sym__double_quoted_string] = STATE(2437),
    [sym_na] = STATE(1456),
    [sym__expression] = STATE(1456),
    [sym__string_or_identifier] = STATE(5133),
    [sym__open_parenthesis] = STATE(213),
    [sym__open_brace] = STATE(70),
    [aux_sym_function_definition_repeat1] = STATE(308),
    [sym_identifier] = ACTIONS(2531),
    [anon_sym_BSLASH] = ACTIONS(2533),
    [anon_sym_function] = ACTIONS(2535),
    [anon_sym_EQ] = ACTIONS(379),
    [anon_sym_if] = ACTIONS(2537),
    [anon_sym_for] = ACTIONS(2539),
    [anon_sym_while] = ACTIONS(2541),
    [anon_sym_repeat] = ACTIONS(2543),
    [anon_sym_QMARK] = ACTIONS(2545),
    [anon_sym_TILDE] = ACTIONS(2547),
    [anon_sym_BANG] = ACTIONS(2549),
    [anon_sym_PLUS] = ACTIONS(2551),
    [anon_sym_DASH] = ACTIONS(2553),
    [anon_sym_LT_DASH] = ACTIONS(377),
    [anon_sym_LT_LT_DASH] = ACTIONS(377),
    [anon_sym_COLON_EQ] = ACTIONS(377),
    [anon_sym_DASH_GT] = ACTIONS(379),
    [anon_sym_DASH_GT_GT] = ACTIONS(377),
    [anon_sym_PIPE] = ACTIONS(379),
    [anon_sym_AMP] = ACTIONS(379),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_LT] = ACTIONS(379),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(379),
    [anon_sym_GT_EQ] = ACTIONS(377),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(379),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_STAR_STAR] = ACTIONS(377),
    [anon_sym_CARET] = ACTIONS(377),
    [aux_sym_binary_operator_token1] = ACTIONS(377),
    [anon_sym_PIPE_GT] = ACTIONS(377),
    [anon_sym_COLON] = ACTIONS(379),
    [anon_sym_DOLLAR] = ACTIONS(377),
    [anon_sym_AT] = ACTIONS(377),
    [aux_sym__hex_literal_token1] = ACTIONS(2555),
    [sym__number_literal] = ACTIONS(2557),
    [anon_sym_SQUOTE] = ACTIONS(2559),
    [anon_sym_DQUOTE] = ACTIONS(2561),
    [sym_return] = ACTIONS(4364),
    [sym_next] = ACTIONS(4364),
    [sym_break] = ACTIONS(4364),
    [sym_true] = ACTIONS(4364),
    [sym_false] = ACTIONS(4364),
    [sym_null] = ACTIONS(4364),
    [sym_inf] = ACTIONS(4364),
    [sym_nan] = ACTIONS(4364),
    [anon_sym_NA] = ACTIONS(2565),
    [anon_sym_NA_integer_] = ACTIONS(2565),
    [anon_sym_NA_real_] = ACTIONS(2565),
    [anon_sym_NA_complex_] = ACTIONS(2565),
    [anon_sym_NA_character_] = ACTIONS(2565),
    [sym_dots] = ACTIONS(4364),
    [sym_dot_dot_i] = ACTIONS(4366),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(377),
    [sym__newline] = ACTIONS(4368),
    [sym__raw_string_literal] = ACTIONS(2571),
    [sym__external_open_parenthesis] = ACTIONS(2573),
    [sym__external_close_parenthesis] = ACTIONS(377),
    [sym__external_open_brace] = ACTIONS(2577),
    [sym__external_open_bracket] = ACTIONS(377),
    [sym__external_close_bracket] = ACTIONS(377),
    [sym__external_open_bracket2] = ACTIONS(377),
  },
  [399] = {
    [sym_function_definition] = STATE(1688),
    [sym_if_statement] = STATE(1688),
    [sym_for_statement] = STATE(1688),
    [sym_while_statement] = STATE(1688),
    [sym_repeat_statement] = STATE(1688),
    [sym_braced_expression] = STATE(1688),
    [sym_parenthesized_expression] = STATE(1688),
    [sym_call] = STATE(1688),
    [sym_subset] = STATE(1688),
    [sym_subset2] = STATE(1688),
    [sym_unary_operator] = STATE(1688),
    [sym_binary_operator] = STATE(1688),
    [sym_extract_operator] = STATE(1688),
    [sym_namespace_operator] = STATE(1688),
    [sym_integer] = STATE(1688),
    [sym_complex] = STATE(1688),
    [sym_float] = STATE(1688),
    [sym__hex_literal] = STATE(2371),
    [sym__float_literal] = STATE(2371),
    [sym_string] = STATE(2372),
    [sym__single_quoted_string] = STATE(2370),
    [sym__double_quoted_string] = STATE(2369),
    [sym_na] = STATE(1688),
    [sym__expression] = STATE(1688),
    [sym__string_or_identifier] = STATE(5138),
    [sym__open_parenthesis] = STATE(200),
    [sym__open_brace] = STATE(97),
    [aux_sym_function_definition_repeat1] = STATE(329),
    [sym_identifier] = ACTIONS(2425),
    [anon_sym_BSLASH] = ACTIONS(2427),
    [anon_sym_function] = ACTIONS(2429),
    [anon_sym_EQ] = ACTIONS(379),
    [anon_sym_if] = ACTIONS(2431),
    [anon_sym_for] = ACTIONS(2433),
    [anon_sym_while] = ACTIONS(2435),
    [anon_sym_repeat] = ACTIONS(2437),
    [anon_sym_QMARK] = ACTIONS(2439),
    [anon_sym_TILDE] = ACTIONS(2441),
    [anon_sym_BANG] = ACTIONS(2443),
    [anon_sym_PLUS] = ACTIONS(2445),
    [anon_sym_DASH] = ACTIONS(2447),
    [anon_sym_LT_DASH] = ACTIONS(377),
    [anon_sym_LT_LT_DASH] = ACTIONS(377),
    [anon_sym_COLON_EQ] = ACTIONS(377),
    [anon_sym_DASH_GT] = ACTIONS(379),
    [anon_sym_DASH_GT_GT] = ACTIONS(377),
    [anon_sym_PIPE] = ACTIONS(379),
    [anon_sym_AMP] = ACTIONS(379),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_LT] = ACTIONS(379),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(379),
    [anon_sym_GT_EQ] = ACTIONS(377),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(379),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_STAR_STAR] = ACTIONS(377),
    [anon_sym_CARET] = ACTIONS(377),
    [aux_sym_binary_operator_token1] = ACTIONS(377),
    [anon_sym_PIPE_GT] = ACTIONS(377),
    [anon_sym_COLON] = ACTIONS(379),
    [anon_sym_DOLLAR] = ACTIONS(377),
    [anon_sym_AT] = ACTIONS(377),
    [aux_sym__hex_literal_token1] = ACTIONS(2449),
    [sym__number_literal] = ACTIONS(2451),
    [anon_sym_SQUOTE] = ACTIONS(2453),
    [anon_sym_DQUOTE] = ACTIONS(2455),
    [sym_return] = ACTIONS(4370),
    [sym_next] = ACTIONS(4370),
    [sym_break] = ACTIONS(4370),
    [sym_true] = ACTIONS(4370),
    [sym_false] = ACTIONS(4370),
    [sym_null] = ACTIONS(4370),
    [sym_inf] = ACTIONS(4370),
    [sym_nan] = ACTIONS(4370),
    [anon_sym_NA] = ACTIONS(2459),
    [anon_sym_NA_integer_] = ACTIONS(2459),
    [anon_sym_NA_real_] = ACTIONS(2459),
    [anon_sym_NA_complex_] = ACTIONS(2459),
    [anon_sym_NA_character_] = ACTIONS(2459),
    [sym_dots] = ACTIONS(4370),
    [sym_dot_dot_i] = ACTIONS(4372),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(377),
    [sym__newline] = ACTIONS(4374),
    [sym__raw_string_literal] = ACTIONS(2465),
    [sym__external_else] = ACTIONS(377),
    [sym__external_open_parenthesis] = ACTIONS(2467),
    [sym__external_close_parenthesis] = ACTIONS(377),
    [sym__external_open_brace] = ACTIONS(2471),
    [sym__external_open_bracket] = ACTIONS(377),
    [sym__external_open_bracket2] = ACTIONS(377),
  },
  [400] = {
    [sym_function_definition] = STATE(1448),
    [sym_if_statement] = STATE(1448),
    [sym_for_statement] = STATE(1448),
    [sym_while_statement] = STATE(1448),
    [sym_repeat_statement] = STATE(1448),
    [sym_braced_expression] = STATE(1448),
    [sym_parenthesized_expression] = STATE(1448),
    [sym_call] = STATE(1448),
    [sym_subset] = STATE(1448),
    [sym_subset2] = STATE(1448),
    [sym_unary_operator] = STATE(1448),
    [sym_binary_operator] = STATE(1448),
    [sym_extract_operator] = STATE(1448),
    [sym_namespace_operator] = STATE(1448),
    [sym_integer] = STATE(1448),
    [sym_complex] = STATE(1448),
    [sym_float] = STATE(1448),
    [sym__hex_literal] = STATE(2445),
    [sym__float_literal] = STATE(2445),
    [sym_string] = STATE(2530),
    [sym__single_quoted_string] = STATE(2442),
    [sym__double_quoted_string] = STATE(2437),
    [sym_na] = STATE(1448),
    [sym__expression] = STATE(1448),
    [sym__string_or_identifier] = STATE(5133),
    [sym__open_parenthesis] = STATE(213),
    [sym__open_brace] = STATE(70),
    [aux_sym_function_definition_repeat1] = STATE(299),
    [sym_identifier] = ACTIONS(2531),
    [anon_sym_BSLASH] = ACTIONS(2533),
    [anon_sym_function] = ACTIONS(2535),
    [anon_sym_EQ] = ACTIONS(533),
    [anon_sym_if] = ACTIONS(2537),
    [anon_sym_for] = ACTIONS(2539),
    [anon_sym_while] = ACTIONS(2541),
    [anon_sym_repeat] = ACTIONS(2543),
    [anon_sym_QMARK] = ACTIONS(2545),
    [anon_sym_TILDE] = ACTIONS(2547),
    [anon_sym_BANG] = ACTIONS(2549),
    [anon_sym_PLUS] = ACTIONS(2551),
    [anon_sym_DASH] = ACTIONS(2553),
    [anon_sym_LT_DASH] = ACTIONS(531),
    [anon_sym_LT_LT_DASH] = ACTIONS(531),
    [anon_sym_COLON_EQ] = ACTIONS(531),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_DASH_GT_GT] = ACTIONS(531),
    [anon_sym_PIPE] = ACTIONS(533),
    [anon_sym_AMP] = ACTIONS(533),
    [anon_sym_PIPE_PIPE] = ACTIONS(531),
    [anon_sym_AMP_AMP] = ACTIONS(531),
    [anon_sym_LT] = ACTIONS(533),
    [anon_sym_LT_EQ] = ACTIONS(531),
    [anon_sym_GT] = ACTIONS(533),
    [anon_sym_GT_EQ] = ACTIONS(531),
    [anon_sym_EQ_EQ] = ACTIONS(531),
    [anon_sym_BANG_EQ] = ACTIONS(531),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_SLASH] = ACTIONS(531),
    [anon_sym_STAR_STAR] = ACTIONS(531),
    [anon_sym_CARET] = ACTIONS(531),
    [aux_sym_binary_operator_token1] = ACTIONS(531),
    [anon_sym_PIPE_GT] = ACTIONS(531),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_DOLLAR] = ACTIONS(531),
    [anon_sym_AT] = ACTIONS(531),
    [aux_sym__hex_literal_token1] = ACTIONS(2555),
    [sym__number_literal] = ACTIONS(2557),
    [anon_sym_SQUOTE] = ACTIONS(2559),
    [anon_sym_DQUOTE] = ACTIONS(2561),
    [sym_return] = ACTIONS(4376),
    [sym_next] = ACTIONS(4376),
    [sym_break] = ACTIONS(4376),
    [sym_true] = ACTIONS(4376),
    [sym_false] = ACTIONS(4376),
    [sym_null] = ACTIONS(4376),
    [sym_inf] = ACTIONS(4376),
    [sym_nan] = ACTIONS(4376),
    [anon_sym_NA] = ACTIONS(2565),
    [anon_sym_NA_integer_] = ACTIONS(2565),
    [anon_sym_NA_real_] = ACTIONS(2565),
    [anon_sym_NA_complex_] = ACTIONS(2565),
    [anon_sym_NA_character_] = ACTIONS(2565),
    [sym_dots] = ACTIONS(4376),
    [sym_dot_dot_i] = ACTIONS(4378),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(531),
    [sym__newline] = ACTIONS(4380),
    [sym__raw_string_literal] = ACTIONS(2571),
    [sym__external_open_parenthesis] = ACTIONS(2573),
    [sym__external_close_parenthesis] = ACTIONS(531),
    [sym__external_open_brace] = ACTIONS(2577),
    [sym__external_open_bracket] = ACTIONS(531),
    [sym__external_close_bracket] = ACTIONS(531),
    [sym__external_open_bracket2] = ACTIONS(531),
  },
  [401] = {
    [sym_function_definition] = STATE(1666),
    [sym_if_statement] = STATE(1666),
    [sym_for_statement] = STATE(1666),
    [sym_while_statement] = STATE(1666),
    [sym_repeat_statement] = STATE(1666),
    [sym_braced_expression] = STATE(1666),
    [sym_parenthesized_expression] = STATE(1666),
    [sym_call] = STATE(1666),
    [sym_subset] = STATE(1666),
    [sym_subset2] = STATE(1666),
    [sym_unary_operator] = STATE(1666),
    [sym_binary_operator] = STATE(1666),
    [sym_extract_operator] = STATE(1666),
    [sym_namespace_operator] = STATE(1666),
    [sym_integer] = STATE(1666),
    [sym_complex] = STATE(1666),
    [sym_float] = STATE(1666),
    [sym__hex_literal] = STATE(2536),
    [sym__float_literal] = STATE(2536),
    [sym_string] = STATE(2534),
    [sym__single_quoted_string] = STATE(2538),
    [sym__double_quoted_string] = STATE(2539),
    [sym_na] = STATE(1666),
    [sym__expression] = STATE(1666),
    [sym__string_or_identifier] = STATE(5143),
    [sym__open_parenthesis] = STATE(150),
    [sym__open_brace] = STATE(133),
    [aux_sym_function_definition_repeat1] = STATE(2742),
    [ts_builtin_sym_end] = ACTIONS(397),
    [sym_identifier] = ACTIONS(4053),
    [anon_sym_BSLASH] = ACTIONS(4055),
    [anon_sym_function] = ACTIONS(4057),
    [anon_sym_EQ] = ACTIONS(399),
    [anon_sym_if] = ACTIONS(4059),
    [anon_sym_for] = ACTIONS(4061),
    [anon_sym_while] = ACTIONS(4063),
    [anon_sym_repeat] = ACTIONS(4065),
    [anon_sym_QMARK] = ACTIONS(4067),
    [anon_sym_TILDE] = ACTIONS(4069),
    [anon_sym_BANG] = ACTIONS(4071),
    [anon_sym_PLUS] = ACTIONS(4073),
    [anon_sym_DASH] = ACTIONS(4075),
    [anon_sym_LT_DASH] = ACTIONS(397),
    [anon_sym_LT_LT_DASH] = ACTIONS(397),
    [anon_sym_COLON_EQ] = ACTIONS(397),
    [anon_sym_DASH_GT] = ACTIONS(399),
    [anon_sym_DASH_GT_GT] = ACTIONS(397),
    [anon_sym_PIPE] = ACTIONS(399),
    [anon_sym_AMP] = ACTIONS(399),
    [anon_sym_PIPE_PIPE] = ACTIONS(397),
    [anon_sym_AMP_AMP] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(399),
    [anon_sym_LT_EQ] = ACTIONS(397),
    [anon_sym_GT] = ACTIONS(399),
    [anon_sym_GT_EQ] = ACTIONS(397),
    [anon_sym_EQ_EQ] = ACTIONS(397),
    [anon_sym_BANG_EQ] = ACTIONS(397),
    [anon_sym_STAR] = ACTIONS(399),
    [anon_sym_SLASH] = ACTIONS(397),
    [anon_sym_STAR_STAR] = ACTIONS(397),
    [anon_sym_CARET] = ACTIONS(397),
    [aux_sym_binary_operator_token1] = ACTIONS(397),
    [anon_sym_PIPE_GT] = ACTIONS(397),
    [anon_sym_COLON] = ACTIONS(399),
    [anon_sym_DOLLAR] = ACTIONS(397),
    [anon_sym_AT] = ACTIONS(397),
    [aux_sym__hex_literal_token1] = ACTIONS(4077),
    [sym__number_literal] = ACTIONS(4079),
    [anon_sym_SQUOTE] = ACTIONS(4081),
    [anon_sym_DQUOTE] = ACTIONS(4083),
    [sym_return] = ACTIONS(4382),
    [sym_next] = ACTIONS(4382),
    [sym_break] = ACTIONS(4382),
    [sym_true] = ACTIONS(4382),
    [sym_false] = ACTIONS(4382),
    [sym_null] = ACTIONS(4382),
    [sym_inf] = ACTIONS(4382),
    [sym_nan] = ACTIONS(4382),
    [anon_sym_NA] = ACTIONS(4087),
    [anon_sym_NA_integer_] = ACTIONS(4087),
    [anon_sym_NA_real_] = ACTIONS(4087),
    [anon_sym_NA_complex_] = ACTIONS(4087),
    [anon_sym_NA_character_] = ACTIONS(4087),
    [sym_dots] = ACTIONS(4382),
    [sym_dot_dot_i] = ACTIONS(4384),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(397),
    [sym__semicolon] = ACTIONS(397),
    [sym__raw_string_literal] = ACTIONS(4093),
    [sym__external_else] = ACTIONS(397),
    [sym__external_open_parenthesis] = ACTIONS(4095),
    [sym__external_open_brace] = ACTIONS(4097),
    [sym__external_open_bracket] = ACTIONS(397),
    [sym__external_open_bracket2] = ACTIONS(397),
  },
  [402] = {
    [sym_function_definition] = STATE(1969),
    [sym_if_statement] = STATE(1969),
    [sym_for_statement] = STATE(1969),
    [sym_while_statement] = STATE(1969),
    [sym_repeat_statement] = STATE(1969),
    [sym_braced_expression] = STATE(1969),
    [sym_parenthesized_expression] = STATE(1969),
    [sym_call] = STATE(1969),
    [sym_subset] = STATE(1969),
    [sym_subset2] = STATE(1969),
    [sym_unary_operator] = STATE(1969),
    [sym_binary_operator] = STATE(1969),
    [sym_extract_operator] = STATE(1969),
    [sym_namespace_operator] = STATE(1969),
    [sym_integer] = STATE(1969),
    [sym_complex] = STATE(1969),
    [sym_float] = STATE(1969),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2673),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(1969),
    [sym__expression] = STATE(1969),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__close_parenthesis] = STATE(4724),
    [sym__open_brace] = STATE(154),
    [aux_sym_parenthesized_expression_repeat1] = STATE(413),
    [sym_identifier] = ACTIONS(3845),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_EQ] = ACTIONS(109),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3867),
    [anon_sym_LT_DASH] = ACTIONS(129),
    [anon_sym_LT_LT_DASH] = ACTIONS(129),
    [anon_sym_COLON_EQ] = ACTIONS(129),
    [anon_sym_DASH_GT] = ACTIONS(109),
    [anon_sym_DASH_GT_GT] = ACTIONS(129),
    [anon_sym_PIPE] = ACTIONS(109),
    [anon_sym_AMP] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_STAR_STAR] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [aux_sym_binary_operator_token1] = ACTIONS(129),
    [anon_sym_PIPE_GT] = ACTIONS(129),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(129),
    [anon_sym_AT] = ACTIONS(129),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(3877),
    [sym_next] = ACTIONS(3877),
    [sym_break] = ACTIONS(3877),
    [sym_true] = ACTIONS(3877),
    [sym_false] = ACTIONS(3877),
    [sym_null] = ACTIONS(3877),
    [sym_inf] = ACTIONS(3877),
    [sym_nan] = ACTIONS(3877),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(3877),
    [sym_dot_dot_i] = ACTIONS(3881),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(129),
    [sym__newline] = ACTIONS(3883),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(4386),
    [sym__external_open_brace] = ACTIONS(3891),
    [sym__external_open_bracket] = ACTIONS(129),
    [sym__external_open_bracket2] = ACTIONS(129),
  },
  [403] = {
    [sym_function_definition] = STATE(1652),
    [sym_if_statement] = STATE(1652),
    [sym_for_statement] = STATE(1652),
    [sym_while_statement] = STATE(1652),
    [sym_repeat_statement] = STATE(1652),
    [sym_braced_expression] = STATE(1652),
    [sym_parenthesized_expression] = STATE(1652),
    [sym_call] = STATE(1652),
    [sym_subset] = STATE(1652),
    [sym_subset2] = STATE(1652),
    [sym_unary_operator] = STATE(1652),
    [sym_binary_operator] = STATE(1652),
    [sym_extract_operator] = STATE(1652),
    [sym_namespace_operator] = STATE(1652),
    [sym_integer] = STATE(1652),
    [sym_complex] = STATE(1652),
    [sym_float] = STATE(1652),
    [sym__hex_literal] = STATE(2536),
    [sym__float_literal] = STATE(2536),
    [sym_string] = STATE(2534),
    [sym__single_quoted_string] = STATE(2538),
    [sym__double_quoted_string] = STATE(2539),
    [sym_na] = STATE(1652),
    [sym__expression] = STATE(1652),
    [sym__string_or_identifier] = STATE(5143),
    [sym__open_parenthesis] = STATE(150),
    [sym__open_brace] = STATE(133),
    [aux_sym_function_definition_repeat1] = STATE(2742),
    [ts_builtin_sym_end] = ACTIONS(453),
    [sym_identifier] = ACTIONS(4053),
    [anon_sym_BSLASH] = ACTIONS(4055),
    [anon_sym_function] = ACTIONS(4057),
    [anon_sym_EQ] = ACTIONS(455),
    [anon_sym_if] = ACTIONS(4059),
    [anon_sym_for] = ACTIONS(4061),
    [anon_sym_while] = ACTIONS(4063),
    [anon_sym_repeat] = ACTIONS(4065),
    [anon_sym_QMARK] = ACTIONS(4067),
    [anon_sym_TILDE] = ACTIONS(4069),
    [anon_sym_BANG] = ACTIONS(4071),
    [anon_sym_PLUS] = ACTIONS(4073),
    [anon_sym_DASH] = ACTIONS(4075),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [anon_sym_LT_LT_DASH] = ACTIONS(453),
    [anon_sym_COLON_EQ] = ACTIONS(453),
    [anon_sym_DASH_GT] = ACTIONS(455),
    [anon_sym_DASH_GT_GT] = ACTIONS(453),
    [anon_sym_PIPE] = ACTIONS(455),
    [anon_sym_AMP] = ACTIONS(455),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(455),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_GT] = ACTIONS(455),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(453),
    [anon_sym_STAR] = ACTIONS(455),
    [anon_sym_SLASH] = ACTIONS(453),
    [anon_sym_STAR_STAR] = ACTIONS(453),
    [anon_sym_CARET] = ACTIONS(453),
    [aux_sym_binary_operator_token1] = ACTIONS(453),
    [anon_sym_PIPE_GT] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(455),
    [anon_sym_DOLLAR] = ACTIONS(453),
    [anon_sym_AT] = ACTIONS(453),
    [aux_sym__hex_literal_token1] = ACTIONS(4077),
    [sym__number_literal] = ACTIONS(4079),
    [anon_sym_SQUOTE] = ACTIONS(4081),
    [anon_sym_DQUOTE] = ACTIONS(4083),
    [sym_return] = ACTIONS(4388),
    [sym_next] = ACTIONS(4388),
    [sym_break] = ACTIONS(4388),
    [sym_true] = ACTIONS(4388),
    [sym_false] = ACTIONS(4388),
    [sym_null] = ACTIONS(4388),
    [sym_inf] = ACTIONS(4388),
    [sym_nan] = ACTIONS(4388),
    [anon_sym_NA] = ACTIONS(4087),
    [anon_sym_NA_integer_] = ACTIONS(4087),
    [anon_sym_NA_real_] = ACTIONS(4087),
    [anon_sym_NA_complex_] = ACTIONS(4087),
    [anon_sym_NA_character_] = ACTIONS(4087),
    [sym_dots] = ACTIONS(4388),
    [sym_dot_dot_i] = ACTIONS(4390),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(453),
    [sym__semicolon] = ACTIONS(453),
    [sym__raw_string_literal] = ACTIONS(4093),
    [sym__external_else] = ACTIONS(453),
    [sym__external_open_parenthesis] = ACTIONS(4095),
    [sym__external_open_brace] = ACTIONS(4097),
    [sym__external_open_bracket] = ACTIONS(453),
    [sym__external_open_bracket2] = ACTIONS(453),
  },
  [404] = {
    [sym_function_definition] = STATE(1337),
    [sym_if_statement] = STATE(1337),
    [sym_for_statement] = STATE(1337),
    [sym_while_statement] = STATE(1337),
    [sym_repeat_statement] = STATE(1337),
    [sym_braced_expression] = STATE(1337),
    [sym_parenthesized_expression] = STATE(1337),
    [sym_call] = STATE(1337),
    [sym_subset] = STATE(1337),
    [sym_subset2] = STATE(1337),
    [sym_unary_operator] = STATE(1337),
    [sym_binary_operator] = STATE(1337),
    [sym_extract_operator] = STATE(1337),
    [sym_namespace_operator] = STATE(1337),
    [sym_integer] = STATE(1337),
    [sym_complex] = STATE(1337),
    [sym_float] = STATE(1337),
    [sym__hex_literal] = STATE(2523),
    [sym__float_literal] = STATE(2523),
    [sym_string] = STATE(2522),
    [sym__single_quoted_string] = STATE(2528),
    [sym__double_quoted_string] = STATE(2529),
    [sym_na] = STATE(1337),
    [sym__expression] = STATE(1337),
    [sym__string_or_identifier] = STATE(5126),
    [sym__open_parenthesis] = STATE(178),
    [sym__open_brace] = STATE(244),
    [aux_sym_function_definition_repeat1] = STATE(412),
    [ts_builtin_sym_end] = ACTIONS(545),
    [sym_identifier] = ACTIONS(2826),
    [anon_sym_BSLASH] = ACTIONS(2828),
    [anon_sym_function] = ACTIONS(2830),
    [anon_sym_EQ] = ACTIONS(543),
    [anon_sym_if] = ACTIONS(2832),
    [anon_sym_for] = ACTIONS(2834),
    [anon_sym_while] = ACTIONS(2836),
    [anon_sym_repeat] = ACTIONS(2838),
    [anon_sym_QMARK] = ACTIONS(2840),
    [anon_sym_TILDE] = ACTIONS(2842),
    [anon_sym_BANG] = ACTIONS(2844),
    [anon_sym_PLUS] = ACTIONS(2846),
    [anon_sym_DASH] = ACTIONS(2848),
    [anon_sym_LT_DASH] = ACTIONS(545),
    [anon_sym_LT_LT_DASH] = ACTIONS(545),
    [anon_sym_COLON_EQ] = ACTIONS(545),
    [anon_sym_DASH_GT] = ACTIONS(543),
    [anon_sym_DASH_GT_GT] = ACTIONS(545),
    [anon_sym_PIPE] = ACTIONS(543),
    [anon_sym_AMP] = ACTIONS(543),
    [anon_sym_PIPE_PIPE] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(543),
    [anon_sym_LT_EQ] = ACTIONS(545),
    [anon_sym_GT] = ACTIONS(543),
    [anon_sym_GT_EQ] = ACTIONS(545),
    [anon_sym_EQ_EQ] = ACTIONS(545),
    [anon_sym_BANG_EQ] = ACTIONS(545),
    [anon_sym_STAR] = ACTIONS(543),
    [anon_sym_SLASH] = ACTIONS(545),
    [anon_sym_STAR_STAR] = ACTIONS(545),
    [anon_sym_CARET] = ACTIONS(545),
    [aux_sym_binary_operator_token1] = ACTIONS(545),
    [anon_sym_PIPE_GT] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(543),
    [anon_sym_DOLLAR] = ACTIONS(545),
    [anon_sym_AT] = ACTIONS(545),
    [aux_sym__hex_literal_token1] = ACTIONS(2850),
    [sym__number_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE] = ACTIONS(2856),
    [sym_return] = ACTIONS(4392),
    [sym_next] = ACTIONS(4392),
    [sym_break] = ACTIONS(4392),
    [sym_true] = ACTIONS(4392),
    [sym_false] = ACTIONS(4392),
    [sym_null] = ACTIONS(4392),
    [sym_inf] = ACTIONS(4392),
    [sym_nan] = ACTIONS(4392),
    [anon_sym_NA] = ACTIONS(2860),
    [anon_sym_NA_integer_] = ACTIONS(2860),
    [anon_sym_NA_real_] = ACTIONS(2860),
    [anon_sym_NA_complex_] = ACTIONS(2860),
    [anon_sym_NA_character_] = ACTIONS(2860),
    [sym_dots] = ACTIONS(4392),
    [sym_dot_dot_i] = ACTIONS(4394),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4396),
    [sym__semicolon] = ACTIONS(545),
    [sym__raw_string_literal] = ACTIONS(2866),
    [sym__external_open_parenthesis] = ACTIONS(2868),
    [sym__external_open_brace] = ACTIONS(2870),
    [sym__external_close_brace] = ACTIONS(545),
    [sym__external_open_bracket] = ACTIONS(545),
    [sym__external_open_bracket2] = ACTIONS(545),
  },
  [405] = {
    [sym_function_definition] = STATE(1637),
    [sym_if_statement] = STATE(1637),
    [sym_for_statement] = STATE(1637),
    [sym_while_statement] = STATE(1637),
    [sym_repeat_statement] = STATE(1637),
    [sym_braced_expression] = STATE(1637),
    [sym_parenthesized_expression] = STATE(1637),
    [sym_call] = STATE(1637),
    [sym_subset] = STATE(1637),
    [sym_subset2] = STATE(1637),
    [sym_unary_operator] = STATE(1637),
    [sym_binary_operator] = STATE(1637),
    [sym_extract_operator] = STATE(1637),
    [sym_namespace_operator] = STATE(1637),
    [sym_integer] = STATE(1637),
    [sym_complex] = STATE(1637),
    [sym_float] = STATE(1637),
    [sym__hex_literal] = STATE(2536),
    [sym__float_literal] = STATE(2536),
    [sym_string] = STATE(2534),
    [sym__single_quoted_string] = STATE(2538),
    [sym__double_quoted_string] = STATE(2539),
    [sym_na] = STATE(1637),
    [sym__expression] = STATE(1637),
    [sym__string_or_identifier] = STATE(5143),
    [sym__open_parenthesis] = STATE(150),
    [sym__open_brace] = STATE(133),
    [aux_sym_function_definition_repeat1] = STATE(408),
    [ts_builtin_sym_end] = ACTIONS(461),
    [sym_identifier] = ACTIONS(4053),
    [anon_sym_BSLASH] = ACTIONS(4055),
    [anon_sym_function] = ACTIONS(4057),
    [anon_sym_EQ] = ACTIONS(463),
    [anon_sym_if] = ACTIONS(4059),
    [anon_sym_for] = ACTIONS(4061),
    [anon_sym_while] = ACTIONS(4063),
    [anon_sym_repeat] = ACTIONS(4065),
    [anon_sym_QMARK] = ACTIONS(4067),
    [anon_sym_TILDE] = ACTIONS(4069),
    [anon_sym_BANG] = ACTIONS(4071),
    [anon_sym_PLUS] = ACTIONS(4073),
    [anon_sym_DASH] = ACTIONS(4075),
    [anon_sym_LT_DASH] = ACTIONS(461),
    [anon_sym_LT_LT_DASH] = ACTIONS(461),
    [anon_sym_COLON_EQ] = ACTIONS(461),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_DASH_GT_GT] = ACTIONS(461),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_PIPE_PIPE] = ACTIONS(461),
    [anon_sym_AMP_AMP] = ACTIONS(461),
    [anon_sym_LT] = ACTIONS(463),
    [anon_sym_LT_EQ] = ACTIONS(461),
    [anon_sym_GT] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(461),
    [anon_sym_EQ_EQ] = ACTIONS(461),
    [anon_sym_BANG_EQ] = ACTIONS(461),
    [anon_sym_STAR] = ACTIONS(463),
    [anon_sym_SLASH] = ACTIONS(461),
    [anon_sym_STAR_STAR] = ACTIONS(461),
    [anon_sym_CARET] = ACTIONS(461),
    [aux_sym_binary_operator_token1] = ACTIONS(461),
    [anon_sym_PIPE_GT] = ACTIONS(461),
    [anon_sym_COLON] = ACTIONS(463),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_AT] = ACTIONS(461),
    [aux_sym__hex_literal_token1] = ACTIONS(4077),
    [sym__number_literal] = ACTIONS(4079),
    [anon_sym_SQUOTE] = ACTIONS(4081),
    [anon_sym_DQUOTE] = ACTIONS(4083),
    [sym_return] = ACTIONS(4398),
    [sym_next] = ACTIONS(4398),
    [sym_break] = ACTIONS(4398),
    [sym_true] = ACTIONS(4398),
    [sym_false] = ACTIONS(4398),
    [sym_null] = ACTIONS(4398),
    [sym_inf] = ACTIONS(4398),
    [sym_nan] = ACTIONS(4398),
    [anon_sym_NA] = ACTIONS(4087),
    [anon_sym_NA_integer_] = ACTIONS(4087),
    [anon_sym_NA_real_] = ACTIONS(4087),
    [anon_sym_NA_complex_] = ACTIONS(4087),
    [anon_sym_NA_character_] = ACTIONS(4087),
    [sym_dots] = ACTIONS(4398),
    [sym_dot_dot_i] = ACTIONS(4400),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4402),
    [sym__semicolon] = ACTIONS(461),
    [sym__raw_string_literal] = ACTIONS(4093),
    [sym__external_else] = ACTIONS(461),
    [sym__external_open_parenthesis] = ACTIONS(4095),
    [sym__external_open_brace] = ACTIONS(4097),
    [sym__external_open_bracket] = ACTIONS(461),
    [sym__external_open_bracket2] = ACTIONS(461),
  },
  [406] = {
    [sym_function_definition] = STATE(1355),
    [sym_if_statement] = STATE(1355),
    [sym_for_statement] = STATE(1355),
    [sym_while_statement] = STATE(1355),
    [sym_repeat_statement] = STATE(1355),
    [sym_braced_expression] = STATE(1355),
    [sym_parenthesized_expression] = STATE(1355),
    [sym_call] = STATE(1355),
    [sym_subset] = STATE(1355),
    [sym_subset2] = STATE(1355),
    [sym_unary_operator] = STATE(1355),
    [sym_binary_operator] = STATE(1355),
    [sym_extract_operator] = STATE(1355),
    [sym_namespace_operator] = STATE(1355),
    [sym_integer] = STATE(1355),
    [sym_complex] = STATE(1355),
    [sym_float] = STATE(1355),
    [sym__hex_literal] = STATE(2523),
    [sym__float_literal] = STATE(2523),
    [sym_string] = STATE(2522),
    [sym__single_quoted_string] = STATE(2528),
    [sym__double_quoted_string] = STATE(2529),
    [sym_na] = STATE(1355),
    [sym__expression] = STATE(1355),
    [sym__string_or_identifier] = STATE(5126),
    [sym__open_parenthesis] = STATE(178),
    [sym__open_brace] = STATE(244),
    [aux_sym_function_definition_repeat1] = STATE(2680),
    [ts_builtin_sym_end] = ACTIONS(765),
    [sym_identifier] = ACTIONS(2826),
    [anon_sym_BSLASH] = ACTIONS(2828),
    [anon_sym_function] = ACTIONS(2830),
    [anon_sym_EQ] = ACTIONS(767),
    [anon_sym_if] = ACTIONS(2832),
    [anon_sym_for] = ACTIONS(2834),
    [anon_sym_while] = ACTIONS(2836),
    [anon_sym_repeat] = ACTIONS(2838),
    [anon_sym_QMARK] = ACTIONS(2840),
    [anon_sym_TILDE] = ACTIONS(2842),
    [anon_sym_BANG] = ACTIONS(2844),
    [anon_sym_PLUS] = ACTIONS(2846),
    [anon_sym_DASH] = ACTIONS(2848),
    [anon_sym_LT_DASH] = ACTIONS(765),
    [anon_sym_LT_LT_DASH] = ACTIONS(765),
    [anon_sym_COLON_EQ] = ACTIONS(765),
    [anon_sym_DASH_GT] = ACTIONS(767),
    [anon_sym_DASH_GT_GT] = ACTIONS(765),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_AMP] = ACTIONS(767),
    [anon_sym_PIPE_PIPE] = ACTIONS(765),
    [anon_sym_AMP_AMP] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(767),
    [anon_sym_LT_EQ] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_GT_EQ] = ACTIONS(765),
    [anon_sym_EQ_EQ] = ACTIONS(765),
    [anon_sym_BANG_EQ] = ACTIONS(765),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(765),
    [anon_sym_STAR_STAR] = ACTIONS(765),
    [anon_sym_CARET] = ACTIONS(765),
    [aux_sym_binary_operator_token1] = ACTIONS(765),
    [anon_sym_PIPE_GT] = ACTIONS(765),
    [anon_sym_COLON] = ACTIONS(767),
    [anon_sym_DOLLAR] = ACTIONS(765),
    [anon_sym_AT] = ACTIONS(765),
    [aux_sym__hex_literal_token1] = ACTIONS(2850),
    [sym__number_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE] = ACTIONS(2856),
    [sym_return] = ACTIONS(4404),
    [sym_next] = ACTIONS(4404),
    [sym_break] = ACTIONS(4404),
    [sym_true] = ACTIONS(4404),
    [sym_false] = ACTIONS(4404),
    [sym_null] = ACTIONS(4404),
    [sym_inf] = ACTIONS(4404),
    [sym_nan] = ACTIONS(4404),
    [anon_sym_NA] = ACTIONS(2860),
    [anon_sym_NA_integer_] = ACTIONS(2860),
    [anon_sym_NA_real_] = ACTIONS(2860),
    [anon_sym_NA_complex_] = ACTIONS(2860),
    [anon_sym_NA_character_] = ACTIONS(2860),
    [sym_dots] = ACTIONS(4404),
    [sym_dot_dot_i] = ACTIONS(4406),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(765),
    [sym__semicolon] = ACTIONS(765),
    [sym__raw_string_literal] = ACTIONS(2866),
    [sym__external_open_parenthesis] = ACTIONS(2868),
    [sym__external_open_brace] = ACTIONS(2870),
    [sym__external_close_brace] = ACTIONS(765),
    [sym__external_open_bracket] = ACTIONS(765),
    [sym__external_open_bracket2] = ACTIONS(765),
  },
  [407] = {
    [sym_function_definition] = STATE(1426),
    [sym_if_statement] = STATE(1426),
    [sym_for_statement] = STATE(1426),
    [sym_while_statement] = STATE(1426),
    [sym_repeat_statement] = STATE(1426),
    [sym_braced_expression] = STATE(1426),
    [sym_parenthesized_expression] = STATE(1426),
    [sym_call] = STATE(1426),
    [sym_subset] = STATE(1426),
    [sym_subset2] = STATE(1426),
    [sym_unary_operator] = STATE(1426),
    [sym_binary_operator] = STATE(1426),
    [sym_extract_operator] = STATE(1426),
    [sym_namespace_operator] = STATE(1426),
    [sym_integer] = STATE(1426),
    [sym_complex] = STATE(1426),
    [sym_float] = STATE(1426),
    [sym__hex_literal] = STATE(2445),
    [sym__float_literal] = STATE(2445),
    [sym_string] = STATE(2530),
    [sym__single_quoted_string] = STATE(2442),
    [sym__double_quoted_string] = STATE(2437),
    [sym_na] = STATE(1426),
    [sym__expression] = STATE(1426),
    [sym__string_or_identifier] = STATE(5133),
    [sym__open_parenthesis] = STATE(213),
    [sym__open_brace] = STATE(70),
    [aux_sym_function_definition_repeat1] = STATE(2617),
    [sym_identifier] = ACTIONS(2531),
    [anon_sym_BSLASH] = ACTIONS(2533),
    [anon_sym_function] = ACTIONS(2535),
    [anon_sym_EQ] = ACTIONS(759),
    [anon_sym_if] = ACTIONS(2537),
    [anon_sym_for] = ACTIONS(2539),
    [anon_sym_while] = ACTIONS(2541),
    [anon_sym_repeat] = ACTIONS(2543),
    [anon_sym_QMARK] = ACTIONS(2545),
    [anon_sym_TILDE] = ACTIONS(2547),
    [anon_sym_BANG] = ACTIONS(2549),
    [anon_sym_PLUS] = ACTIONS(2551),
    [anon_sym_DASH] = ACTIONS(2553),
    [anon_sym_LT_DASH] = ACTIONS(757),
    [anon_sym_LT_LT_DASH] = ACTIONS(757),
    [anon_sym_COLON_EQ] = ACTIONS(757),
    [anon_sym_DASH_GT] = ACTIONS(759),
    [anon_sym_DASH_GT_GT] = ACTIONS(757),
    [anon_sym_PIPE] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(759),
    [anon_sym_PIPE_PIPE] = ACTIONS(757),
    [anon_sym_AMP_AMP] = ACTIONS(757),
    [anon_sym_LT] = ACTIONS(759),
    [anon_sym_LT_EQ] = ACTIONS(757),
    [anon_sym_GT] = ACTIONS(759),
    [anon_sym_GT_EQ] = ACTIONS(757),
    [anon_sym_EQ_EQ] = ACTIONS(757),
    [anon_sym_BANG_EQ] = ACTIONS(757),
    [anon_sym_STAR] = ACTIONS(759),
    [anon_sym_SLASH] = ACTIONS(757),
    [anon_sym_STAR_STAR] = ACTIONS(757),
    [anon_sym_CARET] = ACTIONS(757),
    [aux_sym_binary_operator_token1] = ACTIONS(757),
    [anon_sym_PIPE_GT] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(759),
    [anon_sym_DOLLAR] = ACTIONS(757),
    [anon_sym_AT] = ACTIONS(757),
    [aux_sym__hex_literal_token1] = ACTIONS(2555),
    [sym__number_literal] = ACTIONS(2557),
    [anon_sym_SQUOTE] = ACTIONS(2559),
    [anon_sym_DQUOTE] = ACTIONS(2561),
    [sym_return] = ACTIONS(4408),
    [sym_next] = ACTIONS(4408),
    [sym_break] = ACTIONS(4408),
    [sym_true] = ACTIONS(4408),
    [sym_false] = ACTIONS(4408),
    [sym_null] = ACTIONS(4408),
    [sym_inf] = ACTIONS(4408),
    [sym_nan] = ACTIONS(4408),
    [anon_sym_NA] = ACTIONS(2565),
    [anon_sym_NA_integer_] = ACTIONS(2565),
    [anon_sym_NA_real_] = ACTIONS(2565),
    [anon_sym_NA_complex_] = ACTIONS(2565),
    [anon_sym_NA_character_] = ACTIONS(2565),
    [sym_dots] = ACTIONS(4408),
    [sym_dot_dot_i] = ACTIONS(4410),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(757),
    [sym__newline] = ACTIONS(757),
    [sym__raw_string_literal] = ACTIONS(2571),
    [sym__external_open_parenthesis] = ACTIONS(2573),
    [sym__external_close_parenthesis] = ACTIONS(757),
    [sym__external_open_brace] = ACTIONS(2577),
    [sym__external_open_bracket] = ACTIONS(757),
    [sym__external_close_bracket] = ACTIONS(757),
    [sym__external_open_bracket2] = ACTIONS(757),
  },
  [408] = {
    [sym_function_definition] = STATE(1623),
    [sym_if_statement] = STATE(1623),
    [sym_for_statement] = STATE(1623),
    [sym_while_statement] = STATE(1623),
    [sym_repeat_statement] = STATE(1623),
    [sym_braced_expression] = STATE(1623),
    [sym_parenthesized_expression] = STATE(1623),
    [sym_call] = STATE(1623),
    [sym_subset] = STATE(1623),
    [sym_subset2] = STATE(1623),
    [sym_unary_operator] = STATE(1623),
    [sym_binary_operator] = STATE(1623),
    [sym_extract_operator] = STATE(1623),
    [sym_namespace_operator] = STATE(1623),
    [sym_integer] = STATE(1623),
    [sym_complex] = STATE(1623),
    [sym_float] = STATE(1623),
    [sym__hex_literal] = STATE(2536),
    [sym__float_literal] = STATE(2536),
    [sym_string] = STATE(2534),
    [sym__single_quoted_string] = STATE(2538),
    [sym__double_quoted_string] = STATE(2539),
    [sym_na] = STATE(1623),
    [sym__expression] = STATE(1623),
    [sym__string_or_identifier] = STATE(5143),
    [sym__open_parenthesis] = STATE(150),
    [sym__open_brace] = STATE(133),
    [aux_sym_function_definition_repeat1] = STATE(2742),
    [ts_builtin_sym_end] = ACTIONS(471),
    [sym_identifier] = ACTIONS(4053),
    [anon_sym_BSLASH] = ACTIONS(4055),
    [anon_sym_function] = ACTIONS(4057),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_if] = ACTIONS(4059),
    [anon_sym_for] = ACTIONS(4061),
    [anon_sym_while] = ACTIONS(4063),
    [anon_sym_repeat] = ACTIONS(4065),
    [anon_sym_QMARK] = ACTIONS(4067),
    [anon_sym_TILDE] = ACTIONS(4069),
    [anon_sym_BANG] = ACTIONS(4071),
    [anon_sym_PLUS] = ACTIONS(4073),
    [anon_sym_DASH] = ACTIONS(4075),
    [anon_sym_LT_DASH] = ACTIONS(471),
    [anon_sym_LT_LT_DASH] = ACTIONS(471),
    [anon_sym_COLON_EQ] = ACTIONS(471),
    [anon_sym_DASH_GT] = ACTIONS(473),
    [anon_sym_DASH_GT_GT] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(473),
    [anon_sym_AMP] = ACTIONS(473),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_LT_EQ] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(473),
    [anon_sym_GT_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_STAR] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [aux_sym_binary_operator_token1] = ACTIONS(471),
    [anon_sym_PIPE_GT] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(473),
    [anon_sym_DOLLAR] = ACTIONS(471),
    [anon_sym_AT] = ACTIONS(471),
    [aux_sym__hex_literal_token1] = ACTIONS(4077),
    [sym__number_literal] = ACTIONS(4079),
    [anon_sym_SQUOTE] = ACTIONS(4081),
    [anon_sym_DQUOTE] = ACTIONS(4083),
    [sym_return] = ACTIONS(4412),
    [sym_next] = ACTIONS(4412),
    [sym_break] = ACTIONS(4412),
    [sym_true] = ACTIONS(4412),
    [sym_false] = ACTIONS(4412),
    [sym_null] = ACTIONS(4412),
    [sym_inf] = ACTIONS(4412),
    [sym_nan] = ACTIONS(4412),
    [anon_sym_NA] = ACTIONS(4087),
    [anon_sym_NA_integer_] = ACTIONS(4087),
    [anon_sym_NA_real_] = ACTIONS(4087),
    [anon_sym_NA_complex_] = ACTIONS(4087),
    [anon_sym_NA_character_] = ACTIONS(4087),
    [sym_dots] = ACTIONS(4412),
    [sym_dot_dot_i] = ACTIONS(4414),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(471),
    [sym__semicolon] = ACTIONS(471),
    [sym__raw_string_literal] = ACTIONS(4093),
    [sym__external_else] = ACTIONS(471),
    [sym__external_open_parenthesis] = ACTIONS(4095),
    [sym__external_open_brace] = ACTIONS(4097),
    [sym__external_open_bracket] = ACTIONS(471),
    [sym__external_open_bracket2] = ACTIONS(471),
  },
  [409] = {
    [sym_function_definition] = STATE(1599),
    [sym_if_statement] = STATE(1599),
    [sym_for_statement] = STATE(1599),
    [sym_while_statement] = STATE(1599),
    [sym_repeat_statement] = STATE(1599),
    [sym_braced_expression] = STATE(1599),
    [sym_parenthesized_expression] = STATE(1599),
    [sym_call] = STATE(1599),
    [sym_subset] = STATE(1599),
    [sym_subset2] = STATE(1599),
    [sym_unary_operator] = STATE(1599),
    [sym_binary_operator] = STATE(1599),
    [sym_extract_operator] = STATE(1599),
    [sym_namespace_operator] = STATE(1599),
    [sym_integer] = STATE(1599),
    [sym_complex] = STATE(1599),
    [sym_float] = STATE(1599),
    [sym__hex_literal] = STATE(2412),
    [sym__float_literal] = STATE(2412),
    [sym_string] = STATE(2397),
    [sym__single_quoted_string] = STATE(2430),
    [sym__double_quoted_string] = STATE(2466),
    [sym_na] = STATE(1599),
    [sym__expression] = STATE(1599),
    [sym__string_or_identifier] = STATE(5142),
    [sym__open_parenthesis] = STATE(210),
    [sym__open_brace] = STATE(74),
    [aux_sym_parenthesized_expression_repeat1] = STATE(409),
    [sym_identifier] = ACTIONS(4416),
    [anon_sym_BSLASH] = ACTIONS(4419),
    [anon_sym_function] = ACTIONS(4422),
    [anon_sym_EQ] = ACTIONS(814),
    [anon_sym_if] = ACTIONS(4425),
    [anon_sym_for] = ACTIONS(4428),
    [anon_sym_while] = ACTIONS(4431),
    [anon_sym_repeat] = ACTIONS(4434),
    [anon_sym_QMARK] = ACTIONS(4437),
    [anon_sym_TILDE] = ACTIONS(4440),
    [anon_sym_BANG] = ACTIONS(4443),
    [anon_sym_PLUS] = ACTIONS(4446),
    [anon_sym_DASH] = ACTIONS(4449),
    [anon_sym_LT_DASH] = ACTIONS(803),
    [anon_sym_LT_LT_DASH] = ACTIONS(803),
    [anon_sym_COLON_EQ] = ACTIONS(803),
    [anon_sym_DASH_GT] = ACTIONS(814),
    [anon_sym_DASH_GT_GT] = ACTIONS(803),
    [anon_sym_PIPE] = ACTIONS(814),
    [anon_sym_AMP] = ACTIONS(814),
    [anon_sym_PIPE_PIPE] = ACTIONS(803),
    [anon_sym_AMP_AMP] = ACTIONS(803),
    [anon_sym_LT] = ACTIONS(814),
    [anon_sym_LT_EQ] = ACTIONS(803),
    [anon_sym_GT] = ACTIONS(814),
    [anon_sym_GT_EQ] = ACTIONS(803),
    [anon_sym_EQ_EQ] = ACTIONS(803),
    [anon_sym_BANG_EQ] = ACTIONS(803),
    [anon_sym_STAR] = ACTIONS(814),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_STAR_STAR] = ACTIONS(803),
    [anon_sym_CARET] = ACTIONS(803),
    [aux_sym_binary_operator_token1] = ACTIONS(803),
    [anon_sym_PIPE_GT] = ACTIONS(803),
    [anon_sym_COLON] = ACTIONS(814),
    [anon_sym_DOLLAR] = ACTIONS(803),
    [anon_sym_AT] = ACTIONS(803),
    [aux_sym__hex_literal_token1] = ACTIONS(4452),
    [sym__number_literal] = ACTIONS(4455),
    [anon_sym_SQUOTE] = ACTIONS(4458),
    [anon_sym_DQUOTE] = ACTIONS(4461),
    [sym_return] = ACTIONS(4464),
    [sym_next] = ACTIONS(4464),
    [sym_break] = ACTIONS(4464),
    [sym_true] = ACTIONS(4464),
    [sym_false] = ACTIONS(4464),
    [sym_null] = ACTIONS(4464),
    [sym_inf] = ACTIONS(4464),
    [sym_nan] = ACTIONS(4464),
    [anon_sym_NA] = ACTIONS(4467),
    [anon_sym_NA_integer_] = ACTIONS(4467),
    [anon_sym_NA_real_] = ACTIONS(4467),
    [anon_sym_NA_complex_] = ACTIONS(4467),
    [anon_sym_NA_character_] = ACTIONS(4467),
    [sym_dots] = ACTIONS(4464),
    [sym_dot_dot_i] = ACTIONS(4470),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(803),
    [sym__newline] = ACTIONS(4473),
    [sym__raw_string_literal] = ACTIONS(4476),
    [sym__external_open_parenthesis] = ACTIONS(4479),
    [sym__external_close_parenthesis] = ACTIONS(803),
    [sym__external_open_brace] = ACTIONS(4482),
    [sym__external_open_bracket] = ACTIONS(803),
    [sym__external_open_bracket2] = ACTIONS(803),
    [sym__external_close_bracket2] = ACTIONS(803),
  },
  [410] = {
    [sym_function_definition] = STATE(1381),
    [sym_if_statement] = STATE(1381),
    [sym_for_statement] = STATE(1381),
    [sym_while_statement] = STATE(1381),
    [sym_repeat_statement] = STATE(1381),
    [sym_braced_expression] = STATE(1381),
    [sym_parenthesized_expression] = STATE(1381),
    [sym_call] = STATE(1381),
    [sym_subset] = STATE(1381),
    [sym_subset2] = STATE(1381),
    [sym_unary_operator] = STATE(1381),
    [sym_binary_operator] = STATE(1381),
    [sym_extract_operator] = STATE(1381),
    [sym_namespace_operator] = STATE(1381),
    [sym_integer] = STATE(1381),
    [sym_complex] = STATE(1381),
    [sym_float] = STATE(1381),
    [sym__hex_literal] = STATE(2445),
    [sym__float_literal] = STATE(2445),
    [sym_string] = STATE(2530),
    [sym__single_quoted_string] = STATE(2442),
    [sym__double_quoted_string] = STATE(2437),
    [sym_na] = STATE(1381),
    [sym__expression] = STATE(1381),
    [sym__string_or_identifier] = STATE(5133),
    [sym__open_parenthesis] = STATE(213),
    [sym__open_brace] = STATE(70),
    [aux_sym_function_definition_repeat1] = STATE(2617),
    [sym_identifier] = ACTIONS(2531),
    [anon_sym_BSLASH] = ACTIONS(2533),
    [anon_sym_function] = ACTIONS(2535),
    [anon_sym_EQ] = ACTIONS(767),
    [anon_sym_if] = ACTIONS(2537),
    [anon_sym_for] = ACTIONS(2539),
    [anon_sym_while] = ACTIONS(2541),
    [anon_sym_repeat] = ACTIONS(2543),
    [anon_sym_QMARK] = ACTIONS(2545),
    [anon_sym_TILDE] = ACTIONS(2547),
    [anon_sym_BANG] = ACTIONS(2549),
    [anon_sym_PLUS] = ACTIONS(2551),
    [anon_sym_DASH] = ACTIONS(2553),
    [anon_sym_LT_DASH] = ACTIONS(765),
    [anon_sym_LT_LT_DASH] = ACTIONS(765),
    [anon_sym_COLON_EQ] = ACTIONS(765),
    [anon_sym_DASH_GT] = ACTIONS(767),
    [anon_sym_DASH_GT_GT] = ACTIONS(765),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_AMP] = ACTIONS(767),
    [anon_sym_PIPE_PIPE] = ACTIONS(765),
    [anon_sym_AMP_AMP] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(767),
    [anon_sym_LT_EQ] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_GT_EQ] = ACTIONS(765),
    [anon_sym_EQ_EQ] = ACTIONS(765),
    [anon_sym_BANG_EQ] = ACTIONS(765),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(765),
    [anon_sym_STAR_STAR] = ACTIONS(765),
    [anon_sym_CARET] = ACTIONS(765),
    [aux_sym_binary_operator_token1] = ACTIONS(765),
    [anon_sym_PIPE_GT] = ACTIONS(765),
    [anon_sym_COLON] = ACTIONS(767),
    [anon_sym_DOLLAR] = ACTIONS(765),
    [anon_sym_AT] = ACTIONS(765),
    [aux_sym__hex_literal_token1] = ACTIONS(2555),
    [sym__number_literal] = ACTIONS(2557),
    [anon_sym_SQUOTE] = ACTIONS(2559),
    [anon_sym_DQUOTE] = ACTIONS(2561),
    [sym_return] = ACTIONS(4485),
    [sym_next] = ACTIONS(4485),
    [sym_break] = ACTIONS(4485),
    [sym_true] = ACTIONS(4485),
    [sym_false] = ACTIONS(4485),
    [sym_null] = ACTIONS(4485),
    [sym_inf] = ACTIONS(4485),
    [sym_nan] = ACTIONS(4485),
    [anon_sym_NA] = ACTIONS(2565),
    [anon_sym_NA_integer_] = ACTIONS(2565),
    [anon_sym_NA_real_] = ACTIONS(2565),
    [anon_sym_NA_complex_] = ACTIONS(2565),
    [anon_sym_NA_character_] = ACTIONS(2565),
    [sym_dots] = ACTIONS(4485),
    [sym_dot_dot_i] = ACTIONS(4487),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(765),
    [sym__newline] = ACTIONS(765),
    [sym__raw_string_literal] = ACTIONS(2571),
    [sym__external_open_parenthesis] = ACTIONS(2573),
    [sym__external_close_parenthesis] = ACTIONS(765),
    [sym__external_open_brace] = ACTIONS(2577),
    [sym__external_open_bracket] = ACTIONS(765),
    [sym__external_close_bracket] = ACTIONS(765),
    [sym__external_open_bracket2] = ACTIONS(765),
  },
  [411] = {
    [sym_function_definition] = STATE(1341),
    [sym_if_statement] = STATE(1341),
    [sym_for_statement] = STATE(1341),
    [sym_while_statement] = STATE(1341),
    [sym_repeat_statement] = STATE(1341),
    [sym_braced_expression] = STATE(1341),
    [sym_parenthesized_expression] = STATE(1341),
    [sym_call] = STATE(1341),
    [sym_subset] = STATE(1341),
    [sym_subset2] = STATE(1341),
    [sym_unary_operator] = STATE(1341),
    [sym_binary_operator] = STATE(1341),
    [sym_extract_operator] = STATE(1341),
    [sym_namespace_operator] = STATE(1341),
    [sym_integer] = STATE(1341),
    [sym_complex] = STATE(1341),
    [sym_float] = STATE(1341),
    [sym__hex_literal] = STATE(2445),
    [sym__float_literal] = STATE(2445),
    [sym_string] = STATE(2530),
    [sym__single_quoted_string] = STATE(2442),
    [sym__double_quoted_string] = STATE(2437),
    [sym_na] = STATE(1341),
    [sym__expression] = STATE(1341),
    [sym__string_or_identifier] = STATE(5133),
    [sym__open_parenthesis] = STATE(213),
    [sym__open_brace] = STATE(70),
    [aux_sym_function_definition_repeat1] = STATE(410),
    [sym_identifier] = ACTIONS(2531),
    [anon_sym_BSLASH] = ACTIONS(2533),
    [anon_sym_function] = ACTIONS(2535),
    [anon_sym_EQ] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(2537),
    [anon_sym_for] = ACTIONS(2539),
    [anon_sym_while] = ACTIONS(2541),
    [anon_sym_repeat] = ACTIONS(2543),
    [anon_sym_QMARK] = ACTIONS(2545),
    [anon_sym_TILDE] = ACTIONS(2547),
    [anon_sym_BANG] = ACTIONS(2549),
    [anon_sym_PLUS] = ACTIONS(2551),
    [anon_sym_DASH] = ACTIONS(2553),
    [anon_sym_LT_DASH] = ACTIONS(263),
    [anon_sym_LT_LT_DASH] = ACTIONS(263),
    [anon_sym_COLON_EQ] = ACTIONS(263),
    [anon_sym_DASH_GT] = ACTIONS(265),
    [anon_sym_DASH_GT_GT] = ACTIONS(263),
    [anon_sym_PIPE] = ACTIONS(265),
    [anon_sym_AMP] = ACTIONS(265),
    [anon_sym_PIPE_PIPE] = ACTIONS(263),
    [anon_sym_AMP_AMP] = ACTIONS(263),
    [anon_sym_LT] = ACTIONS(265),
    [anon_sym_LT_EQ] = ACTIONS(263),
    [anon_sym_GT] = ACTIONS(265),
    [anon_sym_GT_EQ] = ACTIONS(263),
    [anon_sym_EQ_EQ] = ACTIONS(263),
    [anon_sym_BANG_EQ] = ACTIONS(263),
    [anon_sym_STAR] = ACTIONS(265),
    [anon_sym_SLASH] = ACTIONS(263),
    [anon_sym_STAR_STAR] = ACTIONS(263),
    [anon_sym_CARET] = ACTIONS(263),
    [aux_sym_binary_operator_token1] = ACTIONS(263),
    [anon_sym_PIPE_GT] = ACTIONS(263),
    [anon_sym_COLON] = ACTIONS(265),
    [anon_sym_DOLLAR] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(263),
    [aux_sym__hex_literal_token1] = ACTIONS(2555),
    [sym__number_literal] = ACTIONS(2557),
    [anon_sym_SQUOTE] = ACTIONS(2559),
    [anon_sym_DQUOTE] = ACTIONS(2561),
    [sym_return] = ACTIONS(4489),
    [sym_next] = ACTIONS(4489),
    [sym_break] = ACTIONS(4489),
    [sym_true] = ACTIONS(4489),
    [sym_false] = ACTIONS(4489),
    [sym_null] = ACTIONS(4489),
    [sym_inf] = ACTIONS(4489),
    [sym_nan] = ACTIONS(4489),
    [anon_sym_NA] = ACTIONS(2565),
    [anon_sym_NA_integer_] = ACTIONS(2565),
    [anon_sym_NA_real_] = ACTIONS(2565),
    [anon_sym_NA_complex_] = ACTIONS(2565),
    [anon_sym_NA_character_] = ACTIONS(2565),
    [sym_dots] = ACTIONS(4489),
    [sym_dot_dot_i] = ACTIONS(4491),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(263),
    [sym__newline] = ACTIONS(4493),
    [sym__raw_string_literal] = ACTIONS(2571),
    [sym__external_open_parenthesis] = ACTIONS(2573),
    [sym__external_close_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(2577),
    [sym__external_open_bracket] = ACTIONS(263),
    [sym__external_close_bracket] = ACTIONS(263),
    [sym__external_open_bracket2] = ACTIONS(263),
  },
  [412] = {
    [sym_function_definition] = STATE(1789),
    [sym_if_statement] = STATE(1789),
    [sym_for_statement] = STATE(1789),
    [sym_while_statement] = STATE(1789),
    [sym_repeat_statement] = STATE(1789),
    [sym_braced_expression] = STATE(1789),
    [sym_parenthesized_expression] = STATE(1789),
    [sym_call] = STATE(1789),
    [sym_subset] = STATE(1789),
    [sym_subset2] = STATE(1789),
    [sym_unary_operator] = STATE(1789),
    [sym_binary_operator] = STATE(1789),
    [sym_extract_operator] = STATE(1789),
    [sym_namespace_operator] = STATE(1789),
    [sym_integer] = STATE(1789),
    [sym_complex] = STATE(1789),
    [sym_float] = STATE(1789),
    [sym__hex_literal] = STATE(2523),
    [sym__float_literal] = STATE(2523),
    [sym_string] = STATE(2522),
    [sym__single_quoted_string] = STATE(2528),
    [sym__double_quoted_string] = STATE(2529),
    [sym_na] = STATE(1789),
    [sym__expression] = STATE(1789),
    [sym__string_or_identifier] = STATE(5126),
    [sym__open_parenthesis] = STATE(178),
    [sym__open_brace] = STATE(244),
    [aux_sym_function_definition_repeat1] = STATE(2680),
    [ts_builtin_sym_end] = ACTIONS(757),
    [sym_identifier] = ACTIONS(2826),
    [anon_sym_BSLASH] = ACTIONS(2828),
    [anon_sym_function] = ACTIONS(2830),
    [anon_sym_EQ] = ACTIONS(759),
    [anon_sym_if] = ACTIONS(2832),
    [anon_sym_for] = ACTIONS(2834),
    [anon_sym_while] = ACTIONS(2836),
    [anon_sym_repeat] = ACTIONS(2838),
    [anon_sym_QMARK] = ACTIONS(2840),
    [anon_sym_TILDE] = ACTIONS(2842),
    [anon_sym_BANG] = ACTIONS(2844),
    [anon_sym_PLUS] = ACTIONS(2846),
    [anon_sym_DASH] = ACTIONS(2848),
    [anon_sym_LT_DASH] = ACTIONS(757),
    [anon_sym_LT_LT_DASH] = ACTIONS(757),
    [anon_sym_COLON_EQ] = ACTIONS(757),
    [anon_sym_DASH_GT] = ACTIONS(759),
    [anon_sym_DASH_GT_GT] = ACTIONS(757),
    [anon_sym_PIPE] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(759),
    [anon_sym_PIPE_PIPE] = ACTIONS(757),
    [anon_sym_AMP_AMP] = ACTIONS(757),
    [anon_sym_LT] = ACTIONS(759),
    [anon_sym_LT_EQ] = ACTIONS(757),
    [anon_sym_GT] = ACTIONS(759),
    [anon_sym_GT_EQ] = ACTIONS(757),
    [anon_sym_EQ_EQ] = ACTIONS(757),
    [anon_sym_BANG_EQ] = ACTIONS(757),
    [anon_sym_STAR] = ACTIONS(759),
    [anon_sym_SLASH] = ACTIONS(757),
    [anon_sym_STAR_STAR] = ACTIONS(757),
    [anon_sym_CARET] = ACTIONS(757),
    [aux_sym_binary_operator_token1] = ACTIONS(757),
    [anon_sym_PIPE_GT] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(759),
    [anon_sym_DOLLAR] = ACTIONS(757),
    [anon_sym_AT] = ACTIONS(757),
    [aux_sym__hex_literal_token1] = ACTIONS(2850),
    [sym__number_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE] = ACTIONS(2856),
    [sym_return] = ACTIONS(4495),
    [sym_next] = ACTIONS(4495),
    [sym_break] = ACTIONS(4495),
    [sym_true] = ACTIONS(4495),
    [sym_false] = ACTIONS(4495),
    [sym_null] = ACTIONS(4495),
    [sym_inf] = ACTIONS(4495),
    [sym_nan] = ACTIONS(4495),
    [anon_sym_NA] = ACTIONS(2860),
    [anon_sym_NA_integer_] = ACTIONS(2860),
    [anon_sym_NA_real_] = ACTIONS(2860),
    [anon_sym_NA_complex_] = ACTIONS(2860),
    [anon_sym_NA_character_] = ACTIONS(2860),
    [sym_dots] = ACTIONS(4495),
    [sym_dot_dot_i] = ACTIONS(4497),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(757),
    [sym__semicolon] = ACTIONS(757),
    [sym__raw_string_literal] = ACTIONS(2866),
    [sym__external_open_parenthesis] = ACTIONS(2868),
    [sym__external_open_brace] = ACTIONS(2870),
    [sym__external_close_brace] = ACTIONS(757),
    [sym__external_open_bracket] = ACTIONS(757),
    [sym__external_open_bracket2] = ACTIONS(757),
  },
  [413] = {
    [sym_function_definition] = STATE(1969),
    [sym_if_statement] = STATE(1969),
    [sym_for_statement] = STATE(1969),
    [sym_while_statement] = STATE(1969),
    [sym_repeat_statement] = STATE(1969),
    [sym_braced_expression] = STATE(1969),
    [sym_parenthesized_expression] = STATE(1969),
    [sym_call] = STATE(1969),
    [sym_subset] = STATE(1969),
    [sym_subset2] = STATE(1969),
    [sym_unary_operator] = STATE(1969),
    [sym_binary_operator] = STATE(1969),
    [sym_extract_operator] = STATE(1969),
    [sym_namespace_operator] = STATE(1969),
    [sym_integer] = STATE(1969),
    [sym_complex] = STATE(1969),
    [sym_float] = STATE(1969),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2673),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(1969),
    [sym__expression] = STATE(1969),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__close_parenthesis] = STATE(4726),
    [sym__open_brace] = STATE(154),
    [aux_sym_parenthesized_expression_repeat1] = STATE(443),
    [sym_identifier] = ACTIONS(3845),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_EQ] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3867),
    [anon_sym_LT_DASH] = ACTIONS(211),
    [anon_sym_LT_LT_DASH] = ACTIONS(211),
    [anon_sym_COLON_EQ] = ACTIONS(211),
    [anon_sym_DASH_GT] = ACTIONS(209),
    [anon_sym_DASH_GT_GT] = ACTIONS(211),
    [anon_sym_PIPE] = ACTIONS(209),
    [anon_sym_AMP] = ACTIONS(209),
    [anon_sym_PIPE_PIPE] = ACTIONS(211),
    [anon_sym_AMP_AMP] = ACTIONS(211),
    [anon_sym_LT] = ACTIONS(209),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_GT] = ACTIONS(209),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [anon_sym_EQ_EQ] = ACTIONS(211),
    [anon_sym_BANG_EQ] = ACTIONS(211),
    [anon_sym_STAR] = ACTIONS(209),
    [anon_sym_SLASH] = ACTIONS(211),
    [anon_sym_STAR_STAR] = ACTIONS(211),
    [anon_sym_CARET] = ACTIONS(211),
    [aux_sym_binary_operator_token1] = ACTIONS(211),
    [anon_sym_PIPE_GT] = ACTIONS(211),
    [anon_sym_COLON] = ACTIONS(209),
    [anon_sym_DOLLAR] = ACTIONS(211),
    [anon_sym_AT] = ACTIONS(211),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(3877),
    [sym_next] = ACTIONS(3877),
    [sym_break] = ACTIONS(3877),
    [sym_true] = ACTIONS(3877),
    [sym_false] = ACTIONS(3877),
    [sym_null] = ACTIONS(3877),
    [sym_inf] = ACTIONS(3877),
    [sym_nan] = ACTIONS(3877),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(3877),
    [sym_dot_dot_i] = ACTIONS(3881),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(211),
    [sym__newline] = ACTIONS(3883),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(4499),
    [sym__external_open_brace] = ACTIONS(3891),
    [sym__external_open_bracket] = ACTIONS(211),
    [sym__external_open_bracket2] = ACTIONS(211),
  },
  [414] = {
    [sym_function_definition] = STATE(1354),
    [sym_if_statement] = STATE(1354),
    [sym_for_statement] = STATE(1354),
    [sym_while_statement] = STATE(1354),
    [sym_repeat_statement] = STATE(1354),
    [sym_braced_expression] = STATE(1354),
    [sym_parenthesized_expression] = STATE(1354),
    [sym_call] = STATE(1354),
    [sym_subset] = STATE(1354),
    [sym_subset2] = STATE(1354),
    [sym_unary_operator] = STATE(1354),
    [sym_binary_operator] = STATE(1354),
    [sym_extract_operator] = STATE(1354),
    [sym_namespace_operator] = STATE(1354),
    [sym_integer] = STATE(1354),
    [sym_complex] = STATE(1354),
    [sym_float] = STATE(1354),
    [sym__hex_literal] = STATE(2540),
    [sym__float_literal] = STATE(2540),
    [sym_string] = STATE(2541),
    [sym__single_quoted_string] = STATE(2462),
    [sym__double_quoted_string] = STATE(2494),
    [sym_na] = STATE(1354),
    [sym__expression] = STATE(1354),
    [sym__string_or_identifier] = STATE(5128),
    [sym__open_parenthesis] = STATE(246),
    [sym__open_brace] = STATE(173),
    [aux_sym_parenthesized_expression_repeat1] = STATE(414),
    [ts_builtin_sym_end] = ACTIONS(803),
    [sym_identifier] = ACTIONS(4501),
    [anon_sym_BSLASH] = ACTIONS(4504),
    [anon_sym_function] = ACTIONS(4507),
    [anon_sym_EQ] = ACTIONS(814),
    [anon_sym_if] = ACTIONS(4510),
    [anon_sym_for] = ACTIONS(4513),
    [anon_sym_while] = ACTIONS(4516),
    [anon_sym_repeat] = ACTIONS(4519),
    [anon_sym_QMARK] = ACTIONS(4522),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_BANG] = ACTIONS(4528),
    [anon_sym_PLUS] = ACTIONS(4531),
    [anon_sym_DASH] = ACTIONS(4534),
    [anon_sym_LT_DASH] = ACTIONS(803),
    [anon_sym_LT_LT_DASH] = ACTIONS(803),
    [anon_sym_COLON_EQ] = ACTIONS(803),
    [anon_sym_DASH_GT] = ACTIONS(814),
    [anon_sym_DASH_GT_GT] = ACTIONS(803),
    [anon_sym_PIPE] = ACTIONS(814),
    [anon_sym_AMP] = ACTIONS(814),
    [anon_sym_PIPE_PIPE] = ACTIONS(803),
    [anon_sym_AMP_AMP] = ACTIONS(803),
    [anon_sym_LT] = ACTIONS(814),
    [anon_sym_LT_EQ] = ACTIONS(803),
    [anon_sym_GT] = ACTIONS(814),
    [anon_sym_GT_EQ] = ACTIONS(803),
    [anon_sym_EQ_EQ] = ACTIONS(803),
    [anon_sym_BANG_EQ] = ACTIONS(803),
    [anon_sym_STAR] = ACTIONS(814),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_STAR_STAR] = ACTIONS(803),
    [anon_sym_CARET] = ACTIONS(803),
    [aux_sym_binary_operator_token1] = ACTIONS(803),
    [anon_sym_PIPE_GT] = ACTIONS(803),
    [anon_sym_COLON] = ACTIONS(814),
    [anon_sym_DOLLAR] = ACTIONS(803),
    [anon_sym_AT] = ACTIONS(803),
    [aux_sym__hex_literal_token1] = ACTIONS(4537),
    [sym__number_literal] = ACTIONS(4540),
    [anon_sym_SQUOTE] = ACTIONS(4543),
    [anon_sym_DQUOTE] = ACTIONS(4546),
    [sym_return] = ACTIONS(4549),
    [sym_next] = ACTIONS(4549),
    [sym_break] = ACTIONS(4549),
    [sym_true] = ACTIONS(4549),
    [sym_false] = ACTIONS(4549),
    [sym_null] = ACTIONS(4549),
    [sym_inf] = ACTIONS(4549),
    [sym_nan] = ACTIONS(4549),
    [anon_sym_NA] = ACTIONS(4552),
    [anon_sym_NA_integer_] = ACTIONS(4552),
    [anon_sym_NA_real_] = ACTIONS(4552),
    [anon_sym_NA_complex_] = ACTIONS(4552),
    [anon_sym_NA_character_] = ACTIONS(4552),
    [sym_dots] = ACTIONS(4549),
    [sym_dot_dot_i] = ACTIONS(4555),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4558),
    [sym__semicolon] = ACTIONS(803),
    [sym__raw_string_literal] = ACTIONS(4561),
    [sym__external_open_parenthesis] = ACTIONS(4564),
    [sym__external_close_parenthesis] = ACTIONS(803),
    [sym__external_open_brace] = ACTIONS(4567),
    [sym__external_open_bracket] = ACTIONS(803),
    [sym__external_open_bracket2] = ACTIONS(803),
  },
  [415] = {
    [sym_function_definition] = STATE(2114),
    [sym_if_statement] = STATE(2114),
    [sym_for_statement] = STATE(2114),
    [sym_while_statement] = STATE(2114),
    [sym_repeat_statement] = STATE(2114),
    [sym_braced_expression] = STATE(2114),
    [sym_parenthesized_expression] = STATE(2114),
    [sym_call] = STATE(2114),
    [sym_subset] = STATE(2114),
    [sym_subset2] = STATE(2114),
    [sym_unary_operator] = STATE(2114),
    [sym_binary_operator] = STATE(2114),
    [sym_extract_operator] = STATE(2114),
    [sym_namespace_operator] = STATE(2114),
    [sym_integer] = STATE(2114),
    [sym_complex] = STATE(2114),
    [sym_float] = STATE(2114),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2673),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(2114),
    [sym__expression] = STATE(2114),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__open_brace] = STATE(154),
    [aux_sym_function_definition_repeat1] = STATE(455),
    [sym_identifier] = ACTIONS(3845),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_EQ] = ACTIONS(379),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3867),
    [anon_sym_LT_DASH] = ACTIONS(377),
    [anon_sym_LT_LT_DASH] = ACTIONS(377),
    [anon_sym_COLON_EQ] = ACTIONS(377),
    [anon_sym_DASH_GT] = ACTIONS(379),
    [anon_sym_DASH_GT_GT] = ACTIONS(377),
    [anon_sym_PIPE] = ACTIONS(379),
    [anon_sym_AMP] = ACTIONS(379),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_LT] = ACTIONS(379),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(379),
    [anon_sym_GT_EQ] = ACTIONS(377),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(379),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_STAR_STAR] = ACTIONS(377),
    [anon_sym_CARET] = ACTIONS(377),
    [aux_sym_binary_operator_token1] = ACTIONS(377),
    [anon_sym_PIPE_GT] = ACTIONS(377),
    [anon_sym_COLON] = ACTIONS(379),
    [anon_sym_DOLLAR] = ACTIONS(377),
    [anon_sym_AT] = ACTIONS(377),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(4570),
    [sym_next] = ACTIONS(4570),
    [sym_break] = ACTIONS(4570),
    [sym_true] = ACTIONS(4570),
    [sym_false] = ACTIONS(4570),
    [sym_null] = ACTIONS(4570),
    [sym_inf] = ACTIONS(4570),
    [sym_nan] = ACTIONS(4570),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(4570),
    [sym_dot_dot_i] = ACTIONS(4572),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(377),
    [sym__newline] = ACTIONS(4574),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(377),
    [sym__external_open_brace] = ACTIONS(3891),
    [sym__external_open_bracket] = ACTIONS(377),
    [sym__external_open_bracket2] = ACTIONS(377),
  },
  [416] = {
    [sym_function_definition] = STATE(1992),
    [sym_if_statement] = STATE(1992),
    [sym_for_statement] = STATE(1992),
    [sym_while_statement] = STATE(1992),
    [sym_repeat_statement] = STATE(1992),
    [sym_braced_expression] = STATE(1992),
    [sym_parenthesized_expression] = STATE(1992),
    [sym_call] = STATE(1992),
    [sym_subset] = STATE(1992),
    [sym_subset2] = STATE(1992),
    [sym_unary_operator] = STATE(1992),
    [sym_binary_operator] = STATE(1992),
    [sym_extract_operator] = STATE(1992),
    [sym_namespace_operator] = STATE(1992),
    [sym_integer] = STATE(1992),
    [sym_complex] = STATE(1992),
    [sym_float] = STATE(1992),
    [sym__hex_literal] = STATE(2739),
    [sym__float_literal] = STATE(2739),
    [sym_string] = STATE(2562),
    [sym__single_quoted_string] = STATE(2738),
    [sym__double_quoted_string] = STATE(2737),
    [sym_na] = STATE(1992),
    [sym__expression] = STATE(1992),
    [sym__string_or_identifier] = STATE(5152),
    [sym__open_parenthesis] = STATE(293),
    [sym__open_brace] = STATE(292),
    [aux_sym_function_definition_repeat1] = STATE(2881),
    [ts_builtin_sym_end] = ACTIONS(471),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(9),
    [anon_sym_function] = ACTIONS(11),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_if] = ACTIONS(13),
    [anon_sym_for] = ACTIONS(15),
    [anon_sym_while] = ACTIONS(17),
    [anon_sym_repeat] = ACTIONS(19),
    [anon_sym_QMARK] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(4576),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_DASH] = ACTIONS(4578),
    [anon_sym_LT_DASH] = ACTIONS(471),
    [anon_sym_LT_LT_DASH] = ACTIONS(471),
    [anon_sym_COLON_EQ] = ACTIONS(471),
    [anon_sym_DASH_GT] = ACTIONS(473),
    [anon_sym_DASH_GT_GT] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(473),
    [anon_sym_AMP] = ACTIONS(473),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_LT_EQ] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(473),
    [anon_sym_GT_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_STAR] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [aux_sym_binary_operator_token1] = ACTIONS(471),
    [anon_sym_PIPE_GT] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(473),
    [anon_sym_DOLLAR] = ACTIONS(471),
    [anon_sym_AT] = ACTIONS(471),
    [aux_sym__hex_literal_token1] = ACTIONS(29),
    [sym__number_literal] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE] = ACTIONS(35),
    [sym_return] = ACTIONS(4580),
    [sym_next] = ACTIONS(4580),
    [sym_break] = ACTIONS(4580),
    [sym_true] = ACTIONS(4580),
    [sym_false] = ACTIONS(4580),
    [sym_null] = ACTIONS(4580),
    [sym_inf] = ACTIONS(4580),
    [sym_nan] = ACTIONS(4580),
    [anon_sym_NA] = ACTIONS(39),
    [anon_sym_NA_integer_] = ACTIONS(39),
    [anon_sym_NA_real_] = ACTIONS(39),
    [anon_sym_NA_complex_] = ACTIONS(39),
    [anon_sym_NA_character_] = ACTIONS(39),
    [sym_dots] = ACTIONS(4580),
    [sym_dot_dot_i] = ACTIONS(4582),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(471),
    [sym__semicolon] = ACTIONS(471),
    [sym__raw_string_literal] = ACTIONS(45),
    [sym__external_open_parenthesis] = ACTIONS(47),
    [sym__external_open_brace] = ACTIONS(49),
    [sym__external_open_bracket] = ACTIONS(471),
    [sym__external_open_bracket2] = ACTIONS(471),
  },
  [417] = {
    [sym_function_definition] = STATE(2074),
    [sym_if_statement] = STATE(2074),
    [sym_for_statement] = STATE(2074),
    [sym_while_statement] = STATE(2074),
    [sym_repeat_statement] = STATE(2074),
    [sym_braced_expression] = STATE(2074),
    [sym_parenthesized_expression] = STATE(2074),
    [sym_call] = STATE(2074),
    [sym_subset] = STATE(2074),
    [sym_subset2] = STATE(2074),
    [sym_unary_operator] = STATE(2074),
    [sym_binary_operator] = STATE(2074),
    [sym_extract_operator] = STATE(2074),
    [sym_namespace_operator] = STATE(2074),
    [sym_integer] = STATE(2074),
    [sym_complex] = STATE(2074),
    [sym_float] = STATE(2074),
    [sym__hex_literal] = STATE(2739),
    [sym__float_literal] = STATE(2739),
    [sym_string] = STATE(2562),
    [sym__single_quoted_string] = STATE(2738),
    [sym__double_quoted_string] = STATE(2737),
    [sym_na] = STATE(2074),
    [sym__expression] = STATE(2074),
    [sym__string_or_identifier] = STATE(5152),
    [sym__open_parenthesis] = STATE(293),
    [sym__open_brace] = STATE(292),
    [aux_sym_function_definition_repeat1] = STATE(464),
    [ts_builtin_sym_end] = ACTIONS(531),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(9),
    [anon_sym_function] = ACTIONS(11),
    [anon_sym_EQ] = ACTIONS(533),
    [anon_sym_if] = ACTIONS(13),
    [anon_sym_for] = ACTIONS(15),
    [anon_sym_while] = ACTIONS(17),
    [anon_sym_repeat] = ACTIONS(19),
    [anon_sym_QMARK] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(4576),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_DASH] = ACTIONS(4578),
    [anon_sym_LT_DASH] = ACTIONS(531),
    [anon_sym_LT_LT_DASH] = ACTIONS(531),
    [anon_sym_COLON_EQ] = ACTIONS(531),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_DASH_GT_GT] = ACTIONS(531),
    [anon_sym_PIPE] = ACTIONS(533),
    [anon_sym_AMP] = ACTIONS(533),
    [anon_sym_PIPE_PIPE] = ACTIONS(531),
    [anon_sym_AMP_AMP] = ACTIONS(531),
    [anon_sym_LT] = ACTIONS(533),
    [anon_sym_LT_EQ] = ACTIONS(531),
    [anon_sym_GT] = ACTIONS(533),
    [anon_sym_GT_EQ] = ACTIONS(531),
    [anon_sym_EQ_EQ] = ACTIONS(531),
    [anon_sym_BANG_EQ] = ACTIONS(531),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_SLASH] = ACTIONS(531),
    [anon_sym_STAR_STAR] = ACTIONS(531),
    [anon_sym_CARET] = ACTIONS(531),
    [aux_sym_binary_operator_token1] = ACTIONS(531),
    [anon_sym_PIPE_GT] = ACTIONS(531),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_DOLLAR] = ACTIONS(531),
    [anon_sym_AT] = ACTIONS(531),
    [aux_sym__hex_literal_token1] = ACTIONS(29),
    [sym__number_literal] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE] = ACTIONS(35),
    [sym_return] = ACTIONS(4584),
    [sym_next] = ACTIONS(4584),
    [sym_break] = ACTIONS(4584),
    [sym_true] = ACTIONS(4584),
    [sym_false] = ACTIONS(4584),
    [sym_null] = ACTIONS(4584),
    [sym_inf] = ACTIONS(4584),
    [sym_nan] = ACTIONS(4584),
    [anon_sym_NA] = ACTIONS(39),
    [anon_sym_NA_integer_] = ACTIONS(39),
    [anon_sym_NA_real_] = ACTIONS(39),
    [anon_sym_NA_complex_] = ACTIONS(39),
    [anon_sym_NA_character_] = ACTIONS(39),
    [sym_dots] = ACTIONS(4584),
    [sym_dot_dot_i] = ACTIONS(4586),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4588),
    [sym__semicolon] = ACTIONS(531),
    [sym__raw_string_literal] = ACTIONS(45),
    [sym__external_open_parenthesis] = ACTIONS(47),
    [sym__external_open_brace] = ACTIONS(49),
    [sym__external_open_bracket] = ACTIONS(531),
    [sym__external_open_bracket2] = ACTIONS(531),
  },
  [418] = {
    [sym_function_definition] = STATE(4628),
    [sym_if_statement] = STATE(4628),
    [sym_for_statement] = STATE(4628),
    [sym_while_statement] = STATE(4628),
    [sym_repeat_statement] = STATE(4628),
    [sym_braced_expression] = STATE(4628),
    [sym_parenthesized_expression] = STATE(4628),
    [sym_call] = STATE(4628),
    [sym_subset] = STATE(4628),
    [sym_subset2] = STATE(4628),
    [sym_unary_operator] = STATE(4628),
    [sym_binary_operator] = STATE(4628),
    [sym_extract_operator] = STATE(4628),
    [sym_namespace_operator] = STATE(4628),
    [sym_integer] = STATE(4628),
    [sym_complex] = STATE(4628),
    [sym_float] = STATE(4628),
    [sym__hex_literal] = STATE(4690),
    [sym__float_literal] = STATE(4690),
    [sym_string] = STATE(4689),
    [sym__single_quoted_string] = STATE(4684),
    [sym__double_quoted_string] = STATE(4691),
    [sym_na] = STATE(4628),
    [sym__expression] = STATE(4628),
    [sym__string_or_identifier] = STATE(5155),
    [sym__open_parenthesis] = STATE(402),
    [sym__open_brace] = STATE(153),
    [aux_sym_function_definition_repeat1] = STATE(2866),
    [sym_identifier] = ACTIONS(4590),
    [anon_sym_BSLASH] = ACTIONS(4592),
    [anon_sym_function] = ACTIONS(4594),
    [anon_sym_EQ] = ACTIONS(455),
    [anon_sym_if] = ACTIONS(4596),
    [anon_sym_for] = ACTIONS(4598),
    [anon_sym_while] = ACTIONS(4600),
    [anon_sym_repeat] = ACTIONS(4602),
    [anon_sym_QMARK] = ACTIONS(4604),
    [anon_sym_TILDE] = ACTIONS(4606),
    [anon_sym_BANG] = ACTIONS(4608),
    [anon_sym_PLUS] = ACTIONS(4610),
    [anon_sym_DASH] = ACTIONS(4612),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [anon_sym_LT_LT_DASH] = ACTIONS(453),
    [anon_sym_COLON_EQ] = ACTIONS(453),
    [anon_sym_DASH_GT] = ACTIONS(455),
    [anon_sym_DASH_GT_GT] = ACTIONS(453),
    [anon_sym_PIPE] = ACTIONS(455),
    [anon_sym_AMP] = ACTIONS(455),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(455),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_GT] = ACTIONS(455),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(453),
    [anon_sym_STAR] = ACTIONS(455),
    [anon_sym_SLASH] = ACTIONS(453),
    [anon_sym_STAR_STAR] = ACTIONS(453),
    [anon_sym_CARET] = ACTIONS(453),
    [aux_sym_binary_operator_token1] = ACTIONS(453),
    [anon_sym_PIPE_GT] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(455),
    [anon_sym_DOLLAR] = ACTIONS(453),
    [anon_sym_AT] = ACTIONS(453),
    [aux_sym__hex_literal_token1] = ACTIONS(4614),
    [sym__number_literal] = ACTIONS(4616),
    [anon_sym_SQUOTE] = ACTIONS(4618),
    [anon_sym_DQUOTE] = ACTIONS(4620),
    [sym_return] = ACTIONS(4622),
    [sym_next] = ACTIONS(4622),
    [sym_break] = ACTIONS(4622),
    [sym_true] = ACTIONS(4622),
    [sym_false] = ACTIONS(4622),
    [sym_null] = ACTIONS(4622),
    [sym_inf] = ACTIONS(4622),
    [sym_nan] = ACTIONS(4622),
    [anon_sym_NA] = ACTIONS(4624),
    [anon_sym_NA_integer_] = ACTIONS(4624),
    [anon_sym_NA_real_] = ACTIONS(4624),
    [anon_sym_NA_complex_] = ACTIONS(4624),
    [anon_sym_NA_character_] = ACTIONS(4624),
    [sym_dots] = ACTIONS(4622),
    [sym_dot_dot_i] = ACTIONS(4626),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(453),
    [sym__newline] = ACTIONS(4628),
    [sym__raw_string_literal] = ACTIONS(4630),
    [sym__external_open_parenthesis] = ACTIONS(4632),
    [sym__external_close_parenthesis] = ACTIONS(453),
    [sym__external_open_brace] = ACTIONS(4634),
    [sym__external_open_bracket] = ACTIONS(453),
    [sym__external_open_bracket2] = ACTIONS(453),
  },
  [419] = {
    [sym_function_definition] = STATE(4652),
    [sym_if_statement] = STATE(4652),
    [sym_for_statement] = STATE(4652),
    [sym_while_statement] = STATE(4652),
    [sym_repeat_statement] = STATE(4652),
    [sym_braced_expression] = STATE(4652),
    [sym_parenthesized_expression] = STATE(4652),
    [sym_call] = STATE(4652),
    [sym_subset] = STATE(4652),
    [sym_subset2] = STATE(4652),
    [sym_unary_operator] = STATE(4652),
    [sym_binary_operator] = STATE(4652),
    [sym_extract_operator] = STATE(4652),
    [sym_namespace_operator] = STATE(4652),
    [sym_integer] = STATE(4652),
    [sym_complex] = STATE(4652),
    [sym_float] = STATE(4652),
    [sym__hex_literal] = STATE(4690),
    [sym__float_literal] = STATE(4690),
    [sym_string] = STATE(4689),
    [sym__single_quoted_string] = STATE(4684),
    [sym__double_quoted_string] = STATE(4691),
    [sym_na] = STATE(4652),
    [sym__expression] = STATE(4652),
    [sym__string_or_identifier] = STATE(5155),
    [sym__open_parenthesis] = STATE(402),
    [sym__open_brace] = STATE(153),
    [aux_sym_function_definition_repeat1] = STATE(418),
    [sym_identifier] = ACTIONS(4590),
    [anon_sym_BSLASH] = ACTIONS(4592),
    [anon_sym_function] = ACTIONS(4594),
    [anon_sym_EQ] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(4596),
    [anon_sym_for] = ACTIONS(4598),
    [anon_sym_while] = ACTIONS(4600),
    [anon_sym_repeat] = ACTIONS(4602),
    [anon_sym_QMARK] = ACTIONS(4604),
    [anon_sym_TILDE] = ACTIONS(4606),
    [anon_sym_BANG] = ACTIONS(4608),
    [anon_sym_PLUS] = ACTIONS(4610),
    [anon_sym_DASH] = ACTIONS(4612),
    [anon_sym_LT_DASH] = ACTIONS(387),
    [anon_sym_LT_LT_DASH] = ACTIONS(387),
    [anon_sym_COLON_EQ] = ACTIONS(387),
    [anon_sym_DASH_GT] = ACTIONS(389),
    [anon_sym_DASH_GT_GT] = ACTIONS(387),
    [anon_sym_PIPE] = ACTIONS(389),
    [anon_sym_AMP] = ACTIONS(389),
    [anon_sym_PIPE_PIPE] = ACTIONS(387),
    [anon_sym_AMP_AMP] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(389),
    [anon_sym_LT_EQ] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(389),
    [anon_sym_GT_EQ] = ACTIONS(387),
    [anon_sym_EQ_EQ] = ACTIONS(387),
    [anon_sym_BANG_EQ] = ACTIONS(387),
    [anon_sym_STAR] = ACTIONS(389),
    [anon_sym_SLASH] = ACTIONS(387),
    [anon_sym_STAR_STAR] = ACTIONS(387),
    [anon_sym_CARET] = ACTIONS(387),
    [aux_sym_binary_operator_token1] = ACTIONS(387),
    [anon_sym_PIPE_GT] = ACTIONS(387),
    [anon_sym_COLON] = ACTIONS(389),
    [anon_sym_DOLLAR] = ACTIONS(387),
    [anon_sym_AT] = ACTIONS(387),
    [aux_sym__hex_literal_token1] = ACTIONS(4614),
    [sym__number_literal] = ACTIONS(4616),
    [anon_sym_SQUOTE] = ACTIONS(4618),
    [anon_sym_DQUOTE] = ACTIONS(4620),
    [sym_return] = ACTIONS(4636),
    [sym_next] = ACTIONS(4636),
    [sym_break] = ACTIONS(4636),
    [sym_true] = ACTIONS(4636),
    [sym_false] = ACTIONS(4636),
    [sym_null] = ACTIONS(4636),
    [sym_inf] = ACTIONS(4636),
    [sym_nan] = ACTIONS(4636),
    [anon_sym_NA] = ACTIONS(4624),
    [anon_sym_NA_integer_] = ACTIONS(4624),
    [anon_sym_NA_real_] = ACTIONS(4624),
    [anon_sym_NA_complex_] = ACTIONS(4624),
    [anon_sym_NA_character_] = ACTIONS(4624),
    [sym_dots] = ACTIONS(4636),
    [sym_dot_dot_i] = ACTIONS(4638),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(387),
    [sym__newline] = ACTIONS(4640),
    [sym__raw_string_literal] = ACTIONS(4630),
    [sym__external_open_parenthesis] = ACTIONS(4632),
    [sym__external_close_parenthesis] = ACTIONS(387),
    [sym__external_open_brace] = ACTIONS(4634),
    [sym__external_open_bracket] = ACTIONS(387),
    [sym__external_open_bracket2] = ACTIONS(387),
  },
  [420] = {
    [sym_function_definition] = STATE(2107),
    [sym_if_statement] = STATE(2107),
    [sym_for_statement] = STATE(2107),
    [sym_while_statement] = STATE(2107),
    [sym_repeat_statement] = STATE(2107),
    [sym_braced_expression] = STATE(2107),
    [sym_parenthesized_expression] = STATE(2107),
    [sym_call] = STATE(2107),
    [sym_subset] = STATE(2107),
    [sym_subset2] = STATE(2107),
    [sym_unary_operator] = STATE(2107),
    [sym_binary_operator] = STATE(2107),
    [sym_extract_operator] = STATE(2107),
    [sym_namespace_operator] = STATE(2107),
    [sym_integer] = STATE(2107),
    [sym_complex] = STATE(2107),
    [sym_float] = STATE(2107),
    [sym__hex_literal] = STATE(2656),
    [sym__float_literal] = STATE(2656),
    [sym_string] = STATE(2744),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym_na] = STATE(2107),
    [sym__expression] = STATE(2107),
    [sym__string_or_identifier] = STATE(5141),
    [sym__open_parenthesis] = STATE(218),
    [sym__open_brace] = STATE(185),
    [aux_sym_function_definition_repeat1] = STATE(2847),
    [sym_identifier] = ACTIONS(4642),
    [anon_sym_BSLASH] = ACTIONS(4644),
    [anon_sym_function] = ACTIONS(4646),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_if] = ACTIONS(4648),
    [anon_sym_for] = ACTIONS(4650),
    [anon_sym_while] = ACTIONS(4652),
    [anon_sym_repeat] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(4660),
    [anon_sym_PLUS] = ACTIONS(4662),
    [anon_sym_DASH] = ACTIONS(4664),
    [anon_sym_LT_DASH] = ACTIONS(471),
    [anon_sym_LT_LT_DASH] = ACTIONS(471),
    [anon_sym_COLON_EQ] = ACTIONS(471),
    [anon_sym_DASH_GT] = ACTIONS(473),
    [anon_sym_DASH_GT_GT] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(473),
    [anon_sym_AMP] = ACTIONS(473),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_LT_EQ] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(473),
    [anon_sym_GT_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_STAR] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [aux_sym_binary_operator_token1] = ACTIONS(471),
    [anon_sym_PIPE_GT] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(473),
    [anon_sym_DOLLAR] = ACTIONS(471),
    [anon_sym_AT] = ACTIONS(471),
    [aux_sym__hex_literal_token1] = ACTIONS(4666),
    [sym__number_literal] = ACTIONS(4668),
    [anon_sym_SQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4672),
    [sym_return] = ACTIONS(4674),
    [sym_next] = ACTIONS(4674),
    [sym_break] = ACTIONS(4674),
    [sym_true] = ACTIONS(4674),
    [sym_false] = ACTIONS(4674),
    [sym_null] = ACTIONS(4674),
    [sym_inf] = ACTIONS(4674),
    [sym_nan] = ACTIONS(4674),
    [anon_sym_NA] = ACTIONS(4676),
    [anon_sym_NA_integer_] = ACTIONS(4676),
    [anon_sym_NA_real_] = ACTIONS(4676),
    [anon_sym_NA_complex_] = ACTIONS(4676),
    [anon_sym_NA_character_] = ACTIONS(4676),
    [sym_dots] = ACTIONS(4674),
    [sym_dot_dot_i] = ACTIONS(4678),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(471),
    [sym__newline] = ACTIONS(471),
    [sym__raw_string_literal] = ACTIONS(4680),
    [sym__external_open_parenthesis] = ACTIONS(4682),
    [sym__external_open_brace] = ACTIONS(4684),
    [sym__external_open_bracket] = ACTIONS(471),
    [sym__external_open_bracket2] = ACTIONS(471),
    [sym__external_close_bracket2] = ACTIONS(471),
  },
  [421] = {
    [sym_function_definition] = STATE(2105),
    [sym_if_statement] = STATE(2105),
    [sym_for_statement] = STATE(2105),
    [sym_while_statement] = STATE(2105),
    [sym_repeat_statement] = STATE(2105),
    [sym_braced_expression] = STATE(2105),
    [sym_parenthesized_expression] = STATE(2105),
    [sym_call] = STATE(2105),
    [sym_subset] = STATE(2105),
    [sym_subset2] = STATE(2105),
    [sym_unary_operator] = STATE(2105),
    [sym_binary_operator] = STATE(2105),
    [sym_extract_operator] = STATE(2105),
    [sym_namespace_operator] = STATE(2105),
    [sym_integer] = STATE(2105),
    [sym_complex] = STATE(2105),
    [sym_float] = STATE(2105),
    [sym__hex_literal] = STATE(2656),
    [sym__float_literal] = STATE(2656),
    [sym_string] = STATE(2744),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym_na] = STATE(2105),
    [sym__expression] = STATE(2105),
    [sym__string_or_identifier] = STATE(5141),
    [sym__open_parenthesis] = STATE(218),
    [sym__open_brace] = STATE(185),
    [aux_sym_function_definition_repeat1] = STATE(420),
    [sym_identifier] = ACTIONS(4642),
    [anon_sym_BSLASH] = ACTIONS(4644),
    [anon_sym_function] = ACTIONS(4646),
    [anon_sym_EQ] = ACTIONS(463),
    [anon_sym_if] = ACTIONS(4648),
    [anon_sym_for] = ACTIONS(4650),
    [anon_sym_while] = ACTIONS(4652),
    [anon_sym_repeat] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(4660),
    [anon_sym_PLUS] = ACTIONS(4662),
    [anon_sym_DASH] = ACTIONS(4664),
    [anon_sym_LT_DASH] = ACTIONS(461),
    [anon_sym_LT_LT_DASH] = ACTIONS(461),
    [anon_sym_COLON_EQ] = ACTIONS(461),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_DASH_GT_GT] = ACTIONS(461),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_PIPE_PIPE] = ACTIONS(461),
    [anon_sym_AMP_AMP] = ACTIONS(461),
    [anon_sym_LT] = ACTIONS(463),
    [anon_sym_LT_EQ] = ACTIONS(461),
    [anon_sym_GT] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(461),
    [anon_sym_EQ_EQ] = ACTIONS(461),
    [anon_sym_BANG_EQ] = ACTIONS(461),
    [anon_sym_STAR] = ACTIONS(463),
    [anon_sym_SLASH] = ACTIONS(461),
    [anon_sym_STAR_STAR] = ACTIONS(461),
    [anon_sym_CARET] = ACTIONS(461),
    [aux_sym_binary_operator_token1] = ACTIONS(461),
    [anon_sym_PIPE_GT] = ACTIONS(461),
    [anon_sym_COLON] = ACTIONS(463),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_AT] = ACTIONS(461),
    [aux_sym__hex_literal_token1] = ACTIONS(4666),
    [sym__number_literal] = ACTIONS(4668),
    [anon_sym_SQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4672),
    [sym_return] = ACTIONS(4686),
    [sym_next] = ACTIONS(4686),
    [sym_break] = ACTIONS(4686),
    [sym_true] = ACTIONS(4686),
    [sym_false] = ACTIONS(4686),
    [sym_null] = ACTIONS(4686),
    [sym_inf] = ACTIONS(4686),
    [sym_nan] = ACTIONS(4686),
    [anon_sym_NA] = ACTIONS(4676),
    [anon_sym_NA_integer_] = ACTIONS(4676),
    [anon_sym_NA_real_] = ACTIONS(4676),
    [anon_sym_NA_complex_] = ACTIONS(4676),
    [anon_sym_NA_character_] = ACTIONS(4676),
    [sym_dots] = ACTIONS(4686),
    [sym_dot_dot_i] = ACTIONS(4688),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(461),
    [sym__newline] = ACTIONS(4690),
    [sym__raw_string_literal] = ACTIONS(4680),
    [sym__external_open_parenthesis] = ACTIONS(4682),
    [sym__external_open_brace] = ACTIONS(4684),
    [sym__external_open_bracket] = ACTIONS(461),
    [sym__external_open_bracket2] = ACTIONS(461),
    [sym__external_close_bracket2] = ACTIONS(461),
  },
  [422] = {
    [sym_function_definition] = STATE(2099),
    [sym_if_statement] = STATE(2099),
    [sym_for_statement] = STATE(2099),
    [sym_while_statement] = STATE(2099),
    [sym_repeat_statement] = STATE(2099),
    [sym_braced_expression] = STATE(2099),
    [sym_parenthesized_expression] = STATE(2099),
    [sym_call] = STATE(2099),
    [sym_subset] = STATE(2099),
    [sym_subset2] = STATE(2099),
    [sym_unary_operator] = STATE(2099),
    [sym_binary_operator] = STATE(2099),
    [sym_extract_operator] = STATE(2099),
    [sym_namespace_operator] = STATE(2099),
    [sym_integer] = STATE(2099),
    [sym_complex] = STATE(2099),
    [sym_float] = STATE(2099),
    [sym__hex_literal] = STATE(2656),
    [sym__float_literal] = STATE(2656),
    [sym_string] = STATE(2744),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym_na] = STATE(2099),
    [sym__expression] = STATE(2099),
    [sym__string_or_identifier] = STATE(5141),
    [sym__open_parenthesis] = STATE(218),
    [sym__open_brace] = STATE(185),
    [aux_sym_function_definition_repeat1] = STATE(2847),
    [sym_identifier] = ACTIONS(4642),
    [anon_sym_BSLASH] = ACTIONS(4644),
    [anon_sym_function] = ACTIONS(4646),
    [anon_sym_EQ] = ACTIONS(455),
    [anon_sym_if] = ACTIONS(4648),
    [anon_sym_for] = ACTIONS(4650),
    [anon_sym_while] = ACTIONS(4652),
    [anon_sym_repeat] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(4660),
    [anon_sym_PLUS] = ACTIONS(4662),
    [anon_sym_DASH] = ACTIONS(4664),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [anon_sym_LT_LT_DASH] = ACTIONS(453),
    [anon_sym_COLON_EQ] = ACTIONS(453),
    [anon_sym_DASH_GT] = ACTIONS(455),
    [anon_sym_DASH_GT_GT] = ACTIONS(453),
    [anon_sym_PIPE] = ACTIONS(455),
    [anon_sym_AMP] = ACTIONS(455),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(455),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_GT] = ACTIONS(455),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(453),
    [anon_sym_STAR] = ACTIONS(455),
    [anon_sym_SLASH] = ACTIONS(453),
    [anon_sym_STAR_STAR] = ACTIONS(453),
    [anon_sym_CARET] = ACTIONS(453),
    [aux_sym_binary_operator_token1] = ACTIONS(453),
    [anon_sym_PIPE_GT] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(455),
    [anon_sym_DOLLAR] = ACTIONS(453),
    [anon_sym_AT] = ACTIONS(453),
    [aux_sym__hex_literal_token1] = ACTIONS(4666),
    [sym__number_literal] = ACTIONS(4668),
    [anon_sym_SQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4672),
    [sym_return] = ACTIONS(4692),
    [sym_next] = ACTIONS(4692),
    [sym_break] = ACTIONS(4692),
    [sym_true] = ACTIONS(4692),
    [sym_false] = ACTIONS(4692),
    [sym_null] = ACTIONS(4692),
    [sym_inf] = ACTIONS(4692),
    [sym_nan] = ACTIONS(4692),
    [anon_sym_NA] = ACTIONS(4676),
    [anon_sym_NA_integer_] = ACTIONS(4676),
    [anon_sym_NA_real_] = ACTIONS(4676),
    [anon_sym_NA_complex_] = ACTIONS(4676),
    [anon_sym_NA_character_] = ACTIONS(4676),
    [sym_dots] = ACTIONS(4692),
    [sym_dot_dot_i] = ACTIONS(4694),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(453),
    [sym__newline] = ACTIONS(453),
    [sym__raw_string_literal] = ACTIONS(4680),
    [sym__external_open_parenthesis] = ACTIONS(4682),
    [sym__external_open_brace] = ACTIONS(4684),
    [sym__external_open_bracket] = ACTIONS(453),
    [sym__external_open_bracket2] = ACTIONS(453),
    [sym__external_close_bracket2] = ACTIONS(453),
  },
  [423] = {
    [sym_function_definition] = STATE(2087),
    [sym_if_statement] = STATE(2087),
    [sym_for_statement] = STATE(2087),
    [sym_while_statement] = STATE(2087),
    [sym_repeat_statement] = STATE(2087),
    [sym_braced_expression] = STATE(2087),
    [sym_parenthesized_expression] = STATE(2087),
    [sym_call] = STATE(2087),
    [sym_subset] = STATE(2087),
    [sym_subset2] = STATE(2087),
    [sym_unary_operator] = STATE(2087),
    [sym_binary_operator] = STATE(2087),
    [sym_extract_operator] = STATE(2087),
    [sym_namespace_operator] = STATE(2087),
    [sym_integer] = STATE(2087),
    [sym_complex] = STATE(2087),
    [sym_float] = STATE(2087),
    [sym__hex_literal] = STATE(2656),
    [sym__float_literal] = STATE(2656),
    [sym_string] = STATE(2744),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym_na] = STATE(2087),
    [sym__expression] = STATE(2087),
    [sym__string_or_identifier] = STATE(5141),
    [sym__open_parenthesis] = STATE(218),
    [sym__open_brace] = STATE(185),
    [aux_sym_function_definition_repeat1] = STATE(2847),
    [sym_identifier] = ACTIONS(4642),
    [anon_sym_BSLASH] = ACTIONS(4644),
    [anon_sym_function] = ACTIONS(4646),
    [anon_sym_EQ] = ACTIONS(399),
    [anon_sym_if] = ACTIONS(4648),
    [anon_sym_for] = ACTIONS(4650),
    [anon_sym_while] = ACTIONS(4652),
    [anon_sym_repeat] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(4660),
    [anon_sym_PLUS] = ACTIONS(4662),
    [anon_sym_DASH] = ACTIONS(4664),
    [anon_sym_LT_DASH] = ACTIONS(397),
    [anon_sym_LT_LT_DASH] = ACTIONS(397),
    [anon_sym_COLON_EQ] = ACTIONS(397),
    [anon_sym_DASH_GT] = ACTIONS(399),
    [anon_sym_DASH_GT_GT] = ACTIONS(397),
    [anon_sym_PIPE] = ACTIONS(399),
    [anon_sym_AMP] = ACTIONS(399),
    [anon_sym_PIPE_PIPE] = ACTIONS(397),
    [anon_sym_AMP_AMP] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(399),
    [anon_sym_LT_EQ] = ACTIONS(397),
    [anon_sym_GT] = ACTIONS(399),
    [anon_sym_GT_EQ] = ACTIONS(397),
    [anon_sym_EQ_EQ] = ACTIONS(397),
    [anon_sym_BANG_EQ] = ACTIONS(397),
    [anon_sym_STAR] = ACTIONS(399),
    [anon_sym_SLASH] = ACTIONS(397),
    [anon_sym_STAR_STAR] = ACTIONS(397),
    [anon_sym_CARET] = ACTIONS(397),
    [aux_sym_binary_operator_token1] = ACTIONS(397),
    [anon_sym_PIPE_GT] = ACTIONS(397),
    [anon_sym_COLON] = ACTIONS(399),
    [anon_sym_DOLLAR] = ACTIONS(397),
    [anon_sym_AT] = ACTIONS(397),
    [aux_sym__hex_literal_token1] = ACTIONS(4666),
    [sym__number_literal] = ACTIONS(4668),
    [anon_sym_SQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4672),
    [sym_return] = ACTIONS(4696),
    [sym_next] = ACTIONS(4696),
    [sym_break] = ACTIONS(4696),
    [sym_true] = ACTIONS(4696),
    [sym_false] = ACTIONS(4696),
    [sym_null] = ACTIONS(4696),
    [sym_inf] = ACTIONS(4696),
    [sym_nan] = ACTIONS(4696),
    [anon_sym_NA] = ACTIONS(4676),
    [anon_sym_NA_integer_] = ACTIONS(4676),
    [anon_sym_NA_real_] = ACTIONS(4676),
    [anon_sym_NA_complex_] = ACTIONS(4676),
    [anon_sym_NA_character_] = ACTIONS(4676),
    [sym_dots] = ACTIONS(4696),
    [sym_dot_dot_i] = ACTIONS(4698),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(397),
    [sym__newline] = ACTIONS(397),
    [sym__raw_string_literal] = ACTIONS(4680),
    [sym__external_open_parenthesis] = ACTIONS(4682),
    [sym__external_open_brace] = ACTIONS(4684),
    [sym__external_open_bracket] = ACTIONS(397),
    [sym__external_open_bracket2] = ACTIONS(397),
    [sym__external_close_bracket2] = ACTIONS(397),
  },
  [424] = {
    [sym_function_definition] = STATE(4612),
    [sym_if_statement] = STATE(4612),
    [sym_for_statement] = STATE(4612),
    [sym_while_statement] = STATE(4612),
    [sym_repeat_statement] = STATE(4612),
    [sym_braced_expression] = STATE(4612),
    [sym_parenthesized_expression] = STATE(4612),
    [sym_call] = STATE(4612),
    [sym_subset] = STATE(4612),
    [sym_subset2] = STATE(4612),
    [sym_unary_operator] = STATE(4612),
    [sym_binary_operator] = STATE(4612),
    [sym_extract_operator] = STATE(4612),
    [sym_namespace_operator] = STATE(4612),
    [sym_integer] = STATE(4612),
    [sym_complex] = STATE(4612),
    [sym_float] = STATE(4612),
    [sym__hex_literal] = STATE(4690),
    [sym__float_literal] = STATE(4690),
    [sym_string] = STATE(4689),
    [sym__single_quoted_string] = STATE(4684),
    [sym__double_quoted_string] = STATE(4691),
    [sym_na] = STATE(4612),
    [sym__expression] = STATE(4612),
    [sym__string_or_identifier] = STATE(5155),
    [sym__open_parenthesis] = STATE(402),
    [sym__open_brace] = STATE(153),
    [aux_sym_function_definition_repeat1] = STATE(459),
    [sym_identifier] = ACTIONS(4590),
    [anon_sym_BSLASH] = ACTIONS(4592),
    [anon_sym_function] = ACTIONS(4594),
    [anon_sym_EQ] = ACTIONS(533),
    [anon_sym_if] = ACTIONS(4596),
    [anon_sym_for] = ACTIONS(4598),
    [anon_sym_while] = ACTIONS(4600),
    [anon_sym_repeat] = ACTIONS(4602),
    [anon_sym_QMARK] = ACTIONS(4604),
    [anon_sym_TILDE] = ACTIONS(4606),
    [anon_sym_BANG] = ACTIONS(4608),
    [anon_sym_PLUS] = ACTIONS(4610),
    [anon_sym_DASH] = ACTIONS(4612),
    [anon_sym_LT_DASH] = ACTIONS(531),
    [anon_sym_LT_LT_DASH] = ACTIONS(531),
    [anon_sym_COLON_EQ] = ACTIONS(531),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_DASH_GT_GT] = ACTIONS(531),
    [anon_sym_PIPE] = ACTIONS(533),
    [anon_sym_AMP] = ACTIONS(533),
    [anon_sym_PIPE_PIPE] = ACTIONS(531),
    [anon_sym_AMP_AMP] = ACTIONS(531),
    [anon_sym_LT] = ACTIONS(533),
    [anon_sym_LT_EQ] = ACTIONS(531),
    [anon_sym_GT] = ACTIONS(533),
    [anon_sym_GT_EQ] = ACTIONS(531),
    [anon_sym_EQ_EQ] = ACTIONS(531),
    [anon_sym_BANG_EQ] = ACTIONS(531),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_SLASH] = ACTIONS(531),
    [anon_sym_STAR_STAR] = ACTIONS(531),
    [anon_sym_CARET] = ACTIONS(531),
    [aux_sym_binary_operator_token1] = ACTIONS(531),
    [anon_sym_PIPE_GT] = ACTIONS(531),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_DOLLAR] = ACTIONS(531),
    [anon_sym_AT] = ACTIONS(531),
    [aux_sym__hex_literal_token1] = ACTIONS(4614),
    [sym__number_literal] = ACTIONS(4616),
    [anon_sym_SQUOTE] = ACTIONS(4618),
    [anon_sym_DQUOTE] = ACTIONS(4620),
    [sym_return] = ACTIONS(4700),
    [sym_next] = ACTIONS(4700),
    [sym_break] = ACTIONS(4700),
    [sym_true] = ACTIONS(4700),
    [sym_false] = ACTIONS(4700),
    [sym_null] = ACTIONS(4700),
    [sym_inf] = ACTIONS(4700),
    [sym_nan] = ACTIONS(4700),
    [anon_sym_NA] = ACTIONS(4624),
    [anon_sym_NA_integer_] = ACTIONS(4624),
    [anon_sym_NA_real_] = ACTIONS(4624),
    [anon_sym_NA_complex_] = ACTIONS(4624),
    [anon_sym_NA_character_] = ACTIONS(4624),
    [sym_dots] = ACTIONS(4700),
    [sym_dot_dot_i] = ACTIONS(4702),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(531),
    [sym__newline] = ACTIONS(4704),
    [sym__raw_string_literal] = ACTIONS(4630),
    [sym__external_open_parenthesis] = ACTIONS(4632),
    [sym__external_close_parenthesis] = ACTIONS(531),
    [sym__external_open_brace] = ACTIONS(4634),
    [sym__external_open_bracket] = ACTIONS(531),
    [sym__external_open_bracket2] = ACTIONS(531),
  },
  [425] = {
    [sym_function_definition] = STATE(2086),
    [sym_if_statement] = STATE(2086),
    [sym_for_statement] = STATE(2086),
    [sym_while_statement] = STATE(2086),
    [sym_repeat_statement] = STATE(2086),
    [sym_braced_expression] = STATE(2086),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_call] = STATE(2086),
    [sym_subset] = STATE(2086),
    [sym_subset2] = STATE(2086),
    [sym_unary_operator] = STATE(2086),
    [sym_binary_operator] = STATE(2086),
    [sym_extract_operator] = STATE(2086),
    [sym_namespace_operator] = STATE(2086),
    [sym_integer] = STATE(2086),
    [sym_complex] = STATE(2086),
    [sym_float] = STATE(2086),
    [sym__hex_literal] = STATE(2656),
    [sym__float_literal] = STATE(2656),
    [sym_string] = STATE(2744),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym_na] = STATE(2086),
    [sym__expression] = STATE(2086),
    [sym__string_or_identifier] = STATE(5141),
    [sym__open_parenthesis] = STATE(218),
    [sym__open_brace] = STATE(185),
    [aux_sym_function_definition_repeat1] = STATE(422),
    [sym_identifier] = ACTIONS(4642),
    [anon_sym_BSLASH] = ACTIONS(4644),
    [anon_sym_function] = ACTIONS(4646),
    [anon_sym_EQ] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(4648),
    [anon_sym_for] = ACTIONS(4650),
    [anon_sym_while] = ACTIONS(4652),
    [anon_sym_repeat] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(4660),
    [anon_sym_PLUS] = ACTIONS(4662),
    [anon_sym_DASH] = ACTIONS(4664),
    [anon_sym_LT_DASH] = ACTIONS(387),
    [anon_sym_LT_LT_DASH] = ACTIONS(387),
    [anon_sym_COLON_EQ] = ACTIONS(387),
    [anon_sym_DASH_GT] = ACTIONS(389),
    [anon_sym_DASH_GT_GT] = ACTIONS(387),
    [anon_sym_PIPE] = ACTIONS(389),
    [anon_sym_AMP] = ACTIONS(389),
    [anon_sym_PIPE_PIPE] = ACTIONS(387),
    [anon_sym_AMP_AMP] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(389),
    [anon_sym_LT_EQ] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(389),
    [anon_sym_GT_EQ] = ACTIONS(387),
    [anon_sym_EQ_EQ] = ACTIONS(387),
    [anon_sym_BANG_EQ] = ACTIONS(387),
    [anon_sym_STAR] = ACTIONS(389),
    [anon_sym_SLASH] = ACTIONS(387),
    [anon_sym_STAR_STAR] = ACTIONS(387),
    [anon_sym_CARET] = ACTIONS(387),
    [aux_sym_binary_operator_token1] = ACTIONS(387),
    [anon_sym_PIPE_GT] = ACTIONS(387),
    [anon_sym_COLON] = ACTIONS(389),
    [anon_sym_DOLLAR] = ACTIONS(387),
    [anon_sym_AT] = ACTIONS(387),
    [aux_sym__hex_literal_token1] = ACTIONS(4666),
    [sym__number_literal] = ACTIONS(4668),
    [anon_sym_SQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4672),
    [sym_return] = ACTIONS(4706),
    [sym_next] = ACTIONS(4706),
    [sym_break] = ACTIONS(4706),
    [sym_true] = ACTIONS(4706),
    [sym_false] = ACTIONS(4706),
    [sym_null] = ACTIONS(4706),
    [sym_inf] = ACTIONS(4706),
    [sym_nan] = ACTIONS(4706),
    [anon_sym_NA] = ACTIONS(4676),
    [anon_sym_NA_integer_] = ACTIONS(4676),
    [anon_sym_NA_real_] = ACTIONS(4676),
    [anon_sym_NA_complex_] = ACTIONS(4676),
    [anon_sym_NA_character_] = ACTIONS(4676),
    [sym_dots] = ACTIONS(4706),
    [sym_dot_dot_i] = ACTIONS(4708),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(387),
    [sym__newline] = ACTIONS(4710),
    [sym__raw_string_literal] = ACTIONS(4680),
    [sym__external_open_parenthesis] = ACTIONS(4682),
    [sym__external_open_brace] = ACTIONS(4684),
    [sym__external_open_bracket] = ACTIONS(387),
    [sym__external_open_bracket2] = ACTIONS(387),
    [sym__external_close_bracket2] = ACTIONS(387),
  },
  [426] = {
    [sym_function_definition] = STATE(2072),
    [sym_if_statement] = STATE(2072),
    [sym_for_statement] = STATE(2072),
    [sym_while_statement] = STATE(2072),
    [sym_repeat_statement] = STATE(2072),
    [sym_braced_expression] = STATE(2072),
    [sym_parenthesized_expression] = STATE(2072),
    [sym_call] = STATE(2072),
    [sym_subset] = STATE(2072),
    [sym_subset2] = STATE(2072),
    [sym_unary_operator] = STATE(2072),
    [sym_binary_operator] = STATE(2072),
    [sym_extract_operator] = STATE(2072),
    [sym_namespace_operator] = STATE(2072),
    [sym_integer] = STATE(2072),
    [sym_complex] = STATE(2072),
    [sym_float] = STATE(2072),
    [sym__hex_literal] = STATE(2656),
    [sym__float_literal] = STATE(2656),
    [sym_string] = STATE(2744),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym_na] = STATE(2072),
    [sym__expression] = STATE(2072),
    [sym__string_or_identifier] = STATE(5141),
    [sym__open_parenthesis] = STATE(218),
    [sym__open_brace] = STATE(185),
    [aux_sym_function_definition_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(4642),
    [anon_sym_BSLASH] = ACTIONS(4644),
    [anon_sym_function] = ACTIONS(4646),
    [anon_sym_EQ] = ACTIONS(379),
    [anon_sym_if] = ACTIONS(4648),
    [anon_sym_for] = ACTIONS(4650),
    [anon_sym_while] = ACTIONS(4652),
    [anon_sym_repeat] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(4660),
    [anon_sym_PLUS] = ACTIONS(4662),
    [anon_sym_DASH] = ACTIONS(4664),
    [anon_sym_LT_DASH] = ACTIONS(377),
    [anon_sym_LT_LT_DASH] = ACTIONS(377),
    [anon_sym_COLON_EQ] = ACTIONS(377),
    [anon_sym_DASH_GT] = ACTIONS(379),
    [anon_sym_DASH_GT_GT] = ACTIONS(377),
    [anon_sym_PIPE] = ACTIONS(379),
    [anon_sym_AMP] = ACTIONS(379),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_LT] = ACTIONS(379),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(379),
    [anon_sym_GT_EQ] = ACTIONS(377),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(379),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_STAR_STAR] = ACTIONS(377),
    [anon_sym_CARET] = ACTIONS(377),
    [aux_sym_binary_operator_token1] = ACTIONS(377),
    [anon_sym_PIPE_GT] = ACTIONS(377),
    [anon_sym_COLON] = ACTIONS(379),
    [anon_sym_DOLLAR] = ACTIONS(377),
    [anon_sym_AT] = ACTIONS(377),
    [aux_sym__hex_literal_token1] = ACTIONS(4666),
    [sym__number_literal] = ACTIONS(4668),
    [anon_sym_SQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4672),
    [sym_return] = ACTIONS(4712),
    [sym_next] = ACTIONS(4712),
    [sym_break] = ACTIONS(4712),
    [sym_true] = ACTIONS(4712),
    [sym_false] = ACTIONS(4712),
    [sym_null] = ACTIONS(4712),
    [sym_inf] = ACTIONS(4712),
    [sym_nan] = ACTIONS(4712),
    [anon_sym_NA] = ACTIONS(4676),
    [anon_sym_NA_integer_] = ACTIONS(4676),
    [anon_sym_NA_real_] = ACTIONS(4676),
    [anon_sym_NA_complex_] = ACTIONS(4676),
    [anon_sym_NA_character_] = ACTIONS(4676),
    [sym_dots] = ACTIONS(4712),
    [sym_dot_dot_i] = ACTIONS(4714),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(377),
    [sym__newline] = ACTIONS(4716),
    [sym__raw_string_literal] = ACTIONS(4680),
    [sym__external_open_parenthesis] = ACTIONS(4682),
    [sym__external_open_brace] = ACTIONS(4684),
    [sym__external_open_bracket] = ACTIONS(377),
    [sym__external_open_bracket2] = ACTIONS(377),
    [sym__external_close_bracket2] = ACTIONS(377),
  },
  [427] = {
    [sym_function_definition] = STATE(1928),
    [sym_if_statement] = STATE(1928),
    [sym_for_statement] = STATE(1928),
    [sym_while_statement] = STATE(1928),
    [sym_repeat_statement] = STATE(1928),
    [sym_braced_expression] = STATE(1928),
    [sym_parenthesized_expression] = STATE(1928),
    [sym_call] = STATE(1928),
    [sym_subset] = STATE(1928),
    [sym_subset2] = STATE(1928),
    [sym_unary_operator] = STATE(1928),
    [sym_binary_operator] = STATE(1928),
    [sym_extract_operator] = STATE(1928),
    [sym_namespace_operator] = STATE(1928),
    [sym_integer] = STATE(1928),
    [sym_complex] = STATE(1928),
    [sym_float] = STATE(1928),
    [sym__hex_literal] = STATE(2656),
    [sym__float_literal] = STATE(2656),
    [sym_string] = STATE(2744),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym_na] = STATE(1928),
    [sym__expression] = STATE(1928),
    [sym__string_or_identifier] = STATE(5141),
    [sym__open_parenthesis] = STATE(218),
    [sym__open_brace] = STATE(185),
    [aux_sym_function_definition_repeat1] = STATE(2847),
    [sym_identifier] = ACTIONS(4642),
    [anon_sym_BSLASH] = ACTIONS(4644),
    [anon_sym_function] = ACTIONS(4646),
    [anon_sym_EQ] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(4648),
    [anon_sym_for] = ACTIONS(4650),
    [anon_sym_while] = ACTIONS(4652),
    [anon_sym_repeat] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(4660),
    [anon_sym_PLUS] = ACTIONS(4662),
    [anon_sym_DASH] = ACTIONS(4664),
    [anon_sym_LT_DASH] = ACTIONS(369),
    [anon_sym_LT_LT_DASH] = ACTIONS(369),
    [anon_sym_COLON_EQ] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(371),
    [anon_sym_DASH_GT_GT] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(371),
    [anon_sym_AMP] = ACTIONS(371),
    [anon_sym_PIPE_PIPE] = ACTIONS(369),
    [anon_sym_AMP_AMP] = ACTIONS(369),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_LT_EQ] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_EQ] = ACTIONS(369),
    [anon_sym_EQ_EQ] = ACTIONS(369),
    [anon_sym_BANG_EQ] = ACTIONS(369),
    [anon_sym_STAR] = ACTIONS(371),
    [anon_sym_SLASH] = ACTIONS(369),
    [anon_sym_STAR_STAR] = ACTIONS(369),
    [anon_sym_CARET] = ACTIONS(369),
    [aux_sym_binary_operator_token1] = ACTIONS(369),
    [anon_sym_PIPE_GT] = ACTIONS(369),
    [anon_sym_COLON] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(369),
    [anon_sym_AT] = ACTIONS(369),
    [aux_sym__hex_literal_token1] = ACTIONS(4666),
    [sym__number_literal] = ACTIONS(4668),
    [anon_sym_SQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4672),
    [sym_return] = ACTIONS(4718),
    [sym_next] = ACTIONS(4718),
    [sym_break] = ACTIONS(4718),
    [sym_true] = ACTIONS(4718),
    [sym_false] = ACTIONS(4718),
    [sym_null] = ACTIONS(4718),
    [sym_inf] = ACTIONS(4718),
    [sym_nan] = ACTIONS(4718),
    [anon_sym_NA] = ACTIONS(4676),
    [anon_sym_NA_integer_] = ACTIONS(4676),
    [anon_sym_NA_real_] = ACTIONS(4676),
    [anon_sym_NA_complex_] = ACTIONS(4676),
    [anon_sym_NA_character_] = ACTIONS(4676),
    [sym_dots] = ACTIONS(4718),
    [sym_dot_dot_i] = ACTIONS(4720),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(369),
    [sym__newline] = ACTIONS(369),
    [sym__raw_string_literal] = ACTIONS(4680),
    [sym__external_open_parenthesis] = ACTIONS(4682),
    [sym__external_open_brace] = ACTIONS(4684),
    [sym__external_open_bracket] = ACTIONS(369),
    [sym__external_open_bracket2] = ACTIONS(369),
    [sym__external_close_bracket2] = ACTIONS(369),
  },
  [428] = {
    [sym_function_definition] = STATE(2061),
    [sym_if_statement] = STATE(2061),
    [sym_for_statement] = STATE(2061),
    [sym_while_statement] = STATE(2061),
    [sym_repeat_statement] = STATE(2061),
    [sym_braced_expression] = STATE(2061),
    [sym_parenthesized_expression] = STATE(2061),
    [sym_call] = STATE(2061),
    [sym_subset] = STATE(2061),
    [sym_subset2] = STATE(2061),
    [sym_unary_operator] = STATE(2061),
    [sym_binary_operator] = STATE(2061),
    [sym_extract_operator] = STATE(2061),
    [sym_namespace_operator] = STATE(2061),
    [sym_integer] = STATE(2061),
    [sym_complex] = STATE(2061),
    [sym_float] = STATE(2061),
    [sym__hex_literal] = STATE(2656),
    [sym__float_literal] = STATE(2656),
    [sym_string] = STATE(2744),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym_na] = STATE(2061),
    [sym__expression] = STATE(2061),
    [sym__string_or_identifier] = STATE(5141),
    [sym__open_parenthesis] = STATE(218),
    [sym__open_brace] = STATE(185),
    [aux_sym_function_definition_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(4642),
    [anon_sym_BSLASH] = ACTIONS(4644),
    [anon_sym_function] = ACTIONS(4646),
    [anon_sym_EQ] = ACTIONS(533),
    [anon_sym_if] = ACTIONS(4648),
    [anon_sym_for] = ACTIONS(4650),
    [anon_sym_while] = ACTIONS(4652),
    [anon_sym_repeat] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(4660),
    [anon_sym_PLUS] = ACTIONS(4662),
    [anon_sym_DASH] = ACTIONS(4664),
    [anon_sym_LT_DASH] = ACTIONS(531),
    [anon_sym_LT_LT_DASH] = ACTIONS(531),
    [anon_sym_COLON_EQ] = ACTIONS(531),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_DASH_GT_GT] = ACTIONS(531),
    [anon_sym_PIPE] = ACTIONS(533),
    [anon_sym_AMP] = ACTIONS(533),
    [anon_sym_PIPE_PIPE] = ACTIONS(531),
    [anon_sym_AMP_AMP] = ACTIONS(531),
    [anon_sym_LT] = ACTIONS(533),
    [anon_sym_LT_EQ] = ACTIONS(531),
    [anon_sym_GT] = ACTIONS(533),
    [anon_sym_GT_EQ] = ACTIONS(531),
    [anon_sym_EQ_EQ] = ACTIONS(531),
    [anon_sym_BANG_EQ] = ACTIONS(531),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_SLASH] = ACTIONS(531),
    [anon_sym_STAR_STAR] = ACTIONS(531),
    [anon_sym_CARET] = ACTIONS(531),
    [aux_sym_binary_operator_token1] = ACTIONS(531),
    [anon_sym_PIPE_GT] = ACTIONS(531),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_DOLLAR] = ACTIONS(531),
    [anon_sym_AT] = ACTIONS(531),
    [aux_sym__hex_literal_token1] = ACTIONS(4666),
    [sym__number_literal] = ACTIONS(4668),
    [anon_sym_SQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4672),
    [sym_return] = ACTIONS(4722),
    [sym_next] = ACTIONS(4722),
    [sym_break] = ACTIONS(4722),
    [sym_true] = ACTIONS(4722),
    [sym_false] = ACTIONS(4722),
    [sym_null] = ACTIONS(4722),
    [sym_inf] = ACTIONS(4722),
    [sym_nan] = ACTIONS(4722),
    [anon_sym_NA] = ACTIONS(4676),
    [anon_sym_NA_integer_] = ACTIONS(4676),
    [anon_sym_NA_real_] = ACTIONS(4676),
    [anon_sym_NA_complex_] = ACTIONS(4676),
    [anon_sym_NA_character_] = ACTIONS(4676),
    [sym_dots] = ACTIONS(4722),
    [sym_dot_dot_i] = ACTIONS(4724),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(531),
    [sym__newline] = ACTIONS(4726),
    [sym__raw_string_literal] = ACTIONS(4680),
    [sym__external_open_parenthesis] = ACTIONS(4682),
    [sym__external_open_brace] = ACTIONS(4684),
    [sym__external_open_bracket] = ACTIONS(531),
    [sym__external_open_bracket2] = ACTIONS(531),
    [sym__external_close_bracket2] = ACTIONS(531),
  },
  [429] = {
    [sym_function_definition] = STATE(4552),
    [sym_if_statement] = STATE(4552),
    [sym_for_statement] = STATE(4552),
    [sym_while_statement] = STATE(4552),
    [sym_repeat_statement] = STATE(4552),
    [sym_braced_expression] = STATE(4552),
    [sym_parenthesized_expression] = STATE(4552),
    [sym_call] = STATE(4552),
    [sym_subset] = STATE(4552),
    [sym_subset2] = STATE(4552),
    [sym_unary_operator] = STATE(4552),
    [sym_binary_operator] = STATE(4552),
    [sym_extract_operator] = STATE(4552),
    [sym_namespace_operator] = STATE(4552),
    [sym_integer] = STATE(4552),
    [sym_complex] = STATE(4552),
    [sym_float] = STATE(4552),
    [sym__hex_literal] = STATE(4690),
    [sym__float_literal] = STATE(4690),
    [sym_string] = STATE(4689),
    [sym__single_quoted_string] = STATE(4684),
    [sym__double_quoted_string] = STATE(4691),
    [sym_na] = STATE(4552),
    [sym__expression] = STATE(4552),
    [sym__string_or_identifier] = STATE(5155),
    [sym__open_parenthesis] = STATE(402),
    [sym__open_brace] = STATE(153),
    [aux_sym_function_definition_repeat1] = STATE(2866),
    [sym_identifier] = ACTIONS(4590),
    [anon_sym_BSLASH] = ACTIONS(4592),
    [anon_sym_function] = ACTIONS(4594),
    [anon_sym_EQ] = ACTIONS(759),
    [anon_sym_if] = ACTIONS(4596),
    [anon_sym_for] = ACTIONS(4598),
    [anon_sym_while] = ACTIONS(4600),
    [anon_sym_repeat] = ACTIONS(4602),
    [anon_sym_QMARK] = ACTIONS(4604),
    [anon_sym_TILDE] = ACTIONS(4606),
    [anon_sym_BANG] = ACTIONS(4608),
    [anon_sym_PLUS] = ACTIONS(4610),
    [anon_sym_DASH] = ACTIONS(4612),
    [anon_sym_LT_DASH] = ACTIONS(757),
    [anon_sym_LT_LT_DASH] = ACTIONS(757),
    [anon_sym_COLON_EQ] = ACTIONS(757),
    [anon_sym_DASH_GT] = ACTIONS(759),
    [anon_sym_DASH_GT_GT] = ACTIONS(757),
    [anon_sym_PIPE] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(759),
    [anon_sym_PIPE_PIPE] = ACTIONS(757),
    [anon_sym_AMP_AMP] = ACTIONS(757),
    [anon_sym_LT] = ACTIONS(759),
    [anon_sym_LT_EQ] = ACTIONS(757),
    [anon_sym_GT] = ACTIONS(759),
    [anon_sym_GT_EQ] = ACTIONS(757),
    [anon_sym_EQ_EQ] = ACTIONS(757),
    [anon_sym_BANG_EQ] = ACTIONS(757),
    [anon_sym_STAR] = ACTIONS(759),
    [anon_sym_SLASH] = ACTIONS(757),
    [anon_sym_STAR_STAR] = ACTIONS(757),
    [anon_sym_CARET] = ACTIONS(757),
    [aux_sym_binary_operator_token1] = ACTIONS(757),
    [anon_sym_PIPE_GT] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(759),
    [anon_sym_DOLLAR] = ACTIONS(757),
    [anon_sym_AT] = ACTIONS(757),
    [aux_sym__hex_literal_token1] = ACTIONS(4614),
    [sym__number_literal] = ACTIONS(4616),
    [anon_sym_SQUOTE] = ACTIONS(4618),
    [anon_sym_DQUOTE] = ACTIONS(4620),
    [sym_return] = ACTIONS(4728),
    [sym_next] = ACTIONS(4728),
    [sym_break] = ACTIONS(4728),
    [sym_true] = ACTIONS(4728),
    [sym_false] = ACTIONS(4728),
    [sym_null] = ACTIONS(4728),
    [sym_inf] = ACTIONS(4728),
    [sym_nan] = ACTIONS(4728),
    [anon_sym_NA] = ACTIONS(4624),
    [anon_sym_NA_integer_] = ACTIONS(4624),
    [anon_sym_NA_real_] = ACTIONS(4624),
    [anon_sym_NA_complex_] = ACTIONS(4624),
    [anon_sym_NA_character_] = ACTIONS(4624),
    [sym_dots] = ACTIONS(4728),
    [sym_dot_dot_i] = ACTIONS(4730),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(757),
    [sym__newline] = ACTIONS(4628),
    [sym__raw_string_literal] = ACTIONS(4630),
    [sym__external_open_parenthesis] = ACTIONS(4632),
    [sym__external_close_parenthesis] = ACTIONS(757),
    [sym__external_open_brace] = ACTIONS(4634),
    [sym__external_open_bracket] = ACTIONS(757),
    [sym__external_open_bracket2] = ACTIONS(757),
  },
  [430] = {
    [sym_function_definition] = STATE(2000),
    [sym_if_statement] = STATE(2000),
    [sym_for_statement] = STATE(2000),
    [sym_while_statement] = STATE(2000),
    [sym_repeat_statement] = STATE(2000),
    [sym_braced_expression] = STATE(2000),
    [sym_parenthesized_expression] = STATE(2000),
    [sym_call] = STATE(2000),
    [sym_subset] = STATE(2000),
    [sym_subset2] = STATE(2000),
    [sym_unary_operator] = STATE(2000),
    [sym_binary_operator] = STATE(2000),
    [sym_extract_operator] = STATE(2000),
    [sym_namespace_operator] = STATE(2000),
    [sym_integer] = STATE(2000),
    [sym_complex] = STATE(2000),
    [sym_float] = STATE(2000),
    [sym__hex_literal] = STATE(2656),
    [sym__float_literal] = STATE(2656),
    [sym_string] = STATE(2744),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym_na] = STATE(2000),
    [sym__expression] = STATE(2000),
    [sym__string_or_identifier] = STATE(5141),
    [sym__open_parenthesis] = STATE(218),
    [sym__open_brace] = STATE(185),
    [aux_sym_function_definition_repeat1] = STATE(2847),
    [sym_identifier] = ACTIONS(4642),
    [anon_sym_BSLASH] = ACTIONS(4644),
    [anon_sym_function] = ACTIONS(4646),
    [anon_sym_EQ] = ACTIONS(759),
    [anon_sym_if] = ACTIONS(4648),
    [anon_sym_for] = ACTIONS(4650),
    [anon_sym_while] = ACTIONS(4652),
    [anon_sym_repeat] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(4660),
    [anon_sym_PLUS] = ACTIONS(4662),
    [anon_sym_DASH] = ACTIONS(4664),
    [anon_sym_LT_DASH] = ACTIONS(757),
    [anon_sym_LT_LT_DASH] = ACTIONS(757),
    [anon_sym_COLON_EQ] = ACTIONS(757),
    [anon_sym_DASH_GT] = ACTIONS(759),
    [anon_sym_DASH_GT_GT] = ACTIONS(757),
    [anon_sym_PIPE] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(759),
    [anon_sym_PIPE_PIPE] = ACTIONS(757),
    [anon_sym_AMP_AMP] = ACTIONS(757),
    [anon_sym_LT] = ACTIONS(759),
    [anon_sym_LT_EQ] = ACTIONS(757),
    [anon_sym_GT] = ACTIONS(759),
    [anon_sym_GT_EQ] = ACTIONS(757),
    [anon_sym_EQ_EQ] = ACTIONS(757),
    [anon_sym_BANG_EQ] = ACTIONS(757),
    [anon_sym_STAR] = ACTIONS(759),
    [anon_sym_SLASH] = ACTIONS(757),
    [anon_sym_STAR_STAR] = ACTIONS(757),
    [anon_sym_CARET] = ACTIONS(757),
    [aux_sym_binary_operator_token1] = ACTIONS(757),
    [anon_sym_PIPE_GT] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(759),
    [anon_sym_DOLLAR] = ACTIONS(757),
    [anon_sym_AT] = ACTIONS(757),
    [aux_sym__hex_literal_token1] = ACTIONS(4666),
    [sym__number_literal] = ACTIONS(4668),
    [anon_sym_SQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4672),
    [sym_return] = ACTIONS(4732),
    [sym_next] = ACTIONS(4732),
    [sym_break] = ACTIONS(4732),
    [sym_true] = ACTIONS(4732),
    [sym_false] = ACTIONS(4732),
    [sym_null] = ACTIONS(4732),
    [sym_inf] = ACTIONS(4732),
    [sym_nan] = ACTIONS(4732),
    [anon_sym_NA] = ACTIONS(4676),
    [anon_sym_NA_integer_] = ACTIONS(4676),
    [anon_sym_NA_real_] = ACTIONS(4676),
    [anon_sym_NA_complex_] = ACTIONS(4676),
    [anon_sym_NA_character_] = ACTIONS(4676),
    [sym_dots] = ACTIONS(4732),
    [sym_dot_dot_i] = ACTIONS(4734),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(757),
    [sym__newline] = ACTIONS(757),
    [sym__raw_string_literal] = ACTIONS(4680),
    [sym__external_open_parenthesis] = ACTIONS(4682),
    [sym__external_open_brace] = ACTIONS(4684),
    [sym__external_open_bracket] = ACTIONS(757),
    [sym__external_open_bracket2] = ACTIONS(757),
    [sym__external_close_bracket2] = ACTIONS(757),
  },
  [431] = {
    [sym_function_definition] = STATE(1916),
    [sym_if_statement] = STATE(1916),
    [sym_for_statement] = STATE(1916),
    [sym_while_statement] = STATE(1916),
    [sym_repeat_statement] = STATE(1916),
    [sym_braced_expression] = STATE(1916),
    [sym_parenthesized_expression] = STATE(1916),
    [sym_call] = STATE(1916),
    [sym_subset] = STATE(1916),
    [sym_subset2] = STATE(1916),
    [sym_unary_operator] = STATE(1916),
    [sym_binary_operator] = STATE(1916),
    [sym_extract_operator] = STATE(1916),
    [sym_namespace_operator] = STATE(1916),
    [sym_integer] = STATE(1916),
    [sym_complex] = STATE(1916),
    [sym_float] = STATE(1916),
    [sym__hex_literal] = STATE(2656),
    [sym__float_literal] = STATE(2656),
    [sym_string] = STATE(2744),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym_na] = STATE(1916),
    [sym__expression] = STATE(1916),
    [sym__string_or_identifier] = STATE(5141),
    [sym__open_parenthesis] = STATE(218),
    [sym__open_brace] = STATE(185),
    [aux_sym_function_definition_repeat1] = STATE(2847),
    [sym_identifier] = ACTIONS(4642),
    [anon_sym_BSLASH] = ACTIONS(4644),
    [anon_sym_function] = ACTIONS(4646),
    [anon_sym_EQ] = ACTIONS(767),
    [anon_sym_if] = ACTIONS(4648),
    [anon_sym_for] = ACTIONS(4650),
    [anon_sym_while] = ACTIONS(4652),
    [anon_sym_repeat] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(4660),
    [anon_sym_PLUS] = ACTIONS(4662),
    [anon_sym_DASH] = ACTIONS(4664),
    [anon_sym_LT_DASH] = ACTIONS(765),
    [anon_sym_LT_LT_DASH] = ACTIONS(765),
    [anon_sym_COLON_EQ] = ACTIONS(765),
    [anon_sym_DASH_GT] = ACTIONS(767),
    [anon_sym_DASH_GT_GT] = ACTIONS(765),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_AMP] = ACTIONS(767),
    [anon_sym_PIPE_PIPE] = ACTIONS(765),
    [anon_sym_AMP_AMP] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(767),
    [anon_sym_LT_EQ] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_GT_EQ] = ACTIONS(765),
    [anon_sym_EQ_EQ] = ACTIONS(765),
    [anon_sym_BANG_EQ] = ACTIONS(765),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(765),
    [anon_sym_STAR_STAR] = ACTIONS(765),
    [anon_sym_CARET] = ACTIONS(765),
    [aux_sym_binary_operator_token1] = ACTIONS(765),
    [anon_sym_PIPE_GT] = ACTIONS(765),
    [anon_sym_COLON] = ACTIONS(767),
    [anon_sym_DOLLAR] = ACTIONS(765),
    [anon_sym_AT] = ACTIONS(765),
    [aux_sym__hex_literal_token1] = ACTIONS(4666),
    [sym__number_literal] = ACTIONS(4668),
    [anon_sym_SQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4672),
    [sym_return] = ACTIONS(4736),
    [sym_next] = ACTIONS(4736),
    [sym_break] = ACTIONS(4736),
    [sym_true] = ACTIONS(4736),
    [sym_false] = ACTIONS(4736),
    [sym_null] = ACTIONS(4736),
    [sym_inf] = ACTIONS(4736),
    [sym_nan] = ACTIONS(4736),
    [anon_sym_NA] = ACTIONS(4676),
    [anon_sym_NA_integer_] = ACTIONS(4676),
    [anon_sym_NA_real_] = ACTIONS(4676),
    [anon_sym_NA_complex_] = ACTIONS(4676),
    [anon_sym_NA_character_] = ACTIONS(4676),
    [sym_dots] = ACTIONS(4736),
    [sym_dot_dot_i] = ACTIONS(4738),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(765),
    [sym__newline] = ACTIONS(765),
    [sym__raw_string_literal] = ACTIONS(4680),
    [sym__external_open_parenthesis] = ACTIONS(4682),
    [sym__external_open_brace] = ACTIONS(4684),
    [sym__external_open_bracket] = ACTIONS(765),
    [sym__external_open_bracket2] = ACTIONS(765),
    [sym__external_close_bracket2] = ACTIONS(765),
  },
  [432] = {
    [sym_function_definition] = STATE(1920),
    [sym_if_statement] = STATE(1920),
    [sym_for_statement] = STATE(1920),
    [sym_while_statement] = STATE(1920),
    [sym_repeat_statement] = STATE(1920),
    [sym_braced_expression] = STATE(1920),
    [sym_parenthesized_expression] = STATE(1920),
    [sym_call] = STATE(1920),
    [sym_subset] = STATE(1920),
    [sym_subset2] = STATE(1920),
    [sym_unary_operator] = STATE(1920),
    [sym_binary_operator] = STATE(1920),
    [sym_extract_operator] = STATE(1920),
    [sym_namespace_operator] = STATE(1920),
    [sym_integer] = STATE(1920),
    [sym_complex] = STATE(1920),
    [sym_float] = STATE(1920),
    [sym__hex_literal] = STATE(2656),
    [sym__float_literal] = STATE(2656),
    [sym_string] = STATE(2744),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym_na] = STATE(1920),
    [sym__expression] = STATE(1920),
    [sym__string_or_identifier] = STATE(5141),
    [sym__open_parenthesis] = STATE(218),
    [sym__open_brace] = STATE(185),
    [aux_sym_function_definition_repeat1] = STATE(430),
    [sym_identifier] = ACTIONS(4642),
    [anon_sym_BSLASH] = ACTIONS(4644),
    [anon_sym_function] = ACTIONS(4646),
    [anon_sym_EQ] = ACTIONS(543),
    [anon_sym_if] = ACTIONS(4648),
    [anon_sym_for] = ACTIONS(4650),
    [anon_sym_while] = ACTIONS(4652),
    [anon_sym_repeat] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(4660),
    [anon_sym_PLUS] = ACTIONS(4662),
    [anon_sym_DASH] = ACTIONS(4664),
    [anon_sym_LT_DASH] = ACTIONS(545),
    [anon_sym_LT_LT_DASH] = ACTIONS(545),
    [anon_sym_COLON_EQ] = ACTIONS(545),
    [anon_sym_DASH_GT] = ACTIONS(543),
    [anon_sym_DASH_GT_GT] = ACTIONS(545),
    [anon_sym_PIPE] = ACTIONS(543),
    [anon_sym_AMP] = ACTIONS(543),
    [anon_sym_PIPE_PIPE] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(543),
    [anon_sym_LT_EQ] = ACTIONS(545),
    [anon_sym_GT] = ACTIONS(543),
    [anon_sym_GT_EQ] = ACTIONS(545),
    [anon_sym_EQ_EQ] = ACTIONS(545),
    [anon_sym_BANG_EQ] = ACTIONS(545),
    [anon_sym_STAR] = ACTIONS(543),
    [anon_sym_SLASH] = ACTIONS(545),
    [anon_sym_STAR_STAR] = ACTIONS(545),
    [anon_sym_CARET] = ACTIONS(545),
    [aux_sym_binary_operator_token1] = ACTIONS(545),
    [anon_sym_PIPE_GT] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(543),
    [anon_sym_DOLLAR] = ACTIONS(545),
    [anon_sym_AT] = ACTIONS(545),
    [aux_sym__hex_literal_token1] = ACTIONS(4666),
    [sym__number_literal] = ACTIONS(4668),
    [anon_sym_SQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4672),
    [sym_return] = ACTIONS(4740),
    [sym_next] = ACTIONS(4740),
    [sym_break] = ACTIONS(4740),
    [sym_true] = ACTIONS(4740),
    [sym_false] = ACTIONS(4740),
    [sym_null] = ACTIONS(4740),
    [sym_inf] = ACTIONS(4740),
    [sym_nan] = ACTIONS(4740),
    [anon_sym_NA] = ACTIONS(4676),
    [anon_sym_NA_integer_] = ACTIONS(4676),
    [anon_sym_NA_real_] = ACTIONS(4676),
    [anon_sym_NA_complex_] = ACTIONS(4676),
    [anon_sym_NA_character_] = ACTIONS(4676),
    [sym_dots] = ACTIONS(4740),
    [sym_dot_dot_i] = ACTIONS(4742),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(545),
    [sym__newline] = ACTIONS(4744),
    [sym__raw_string_literal] = ACTIONS(4680),
    [sym__external_open_parenthesis] = ACTIONS(4682),
    [sym__external_open_brace] = ACTIONS(4684),
    [sym__external_open_bracket] = ACTIONS(545),
    [sym__external_open_bracket2] = ACTIONS(545),
    [sym__external_close_bracket2] = ACTIONS(545),
  },
  [433] = {
    [sym_function_definition] = STATE(1979),
    [sym_if_statement] = STATE(1979),
    [sym_for_statement] = STATE(1979),
    [sym_while_statement] = STATE(1979),
    [sym_repeat_statement] = STATE(1979),
    [sym_braced_expression] = STATE(1979),
    [sym_parenthesized_expression] = STATE(1979),
    [sym_call] = STATE(1979),
    [sym_subset] = STATE(1979),
    [sym_subset2] = STATE(1979),
    [sym_unary_operator] = STATE(1979),
    [sym_binary_operator] = STATE(1979),
    [sym_extract_operator] = STATE(1979),
    [sym_namespace_operator] = STATE(1979),
    [sym_integer] = STATE(1979),
    [sym_complex] = STATE(1979),
    [sym_float] = STATE(1979),
    [sym__hex_literal] = STATE(2656),
    [sym__float_literal] = STATE(2656),
    [sym_string] = STATE(2744),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym_na] = STATE(1979),
    [sym__expression] = STATE(1979),
    [sym__string_or_identifier] = STATE(5141),
    [sym__open_parenthesis] = STATE(218),
    [sym__open_brace] = STATE(185),
    [aux_sym_function_definition_repeat1] = STATE(431),
    [sym_identifier] = ACTIONS(4642),
    [anon_sym_BSLASH] = ACTIONS(4644),
    [anon_sym_function] = ACTIONS(4646),
    [anon_sym_EQ] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(4648),
    [anon_sym_for] = ACTIONS(4650),
    [anon_sym_while] = ACTIONS(4652),
    [anon_sym_repeat] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(4660),
    [anon_sym_PLUS] = ACTIONS(4662),
    [anon_sym_DASH] = ACTIONS(4664),
    [anon_sym_LT_DASH] = ACTIONS(263),
    [anon_sym_LT_LT_DASH] = ACTIONS(263),
    [anon_sym_COLON_EQ] = ACTIONS(263),
    [anon_sym_DASH_GT] = ACTIONS(265),
    [anon_sym_DASH_GT_GT] = ACTIONS(263),
    [anon_sym_PIPE] = ACTIONS(265),
    [anon_sym_AMP] = ACTIONS(265),
    [anon_sym_PIPE_PIPE] = ACTIONS(263),
    [anon_sym_AMP_AMP] = ACTIONS(263),
    [anon_sym_LT] = ACTIONS(265),
    [anon_sym_LT_EQ] = ACTIONS(263),
    [anon_sym_GT] = ACTIONS(265),
    [anon_sym_GT_EQ] = ACTIONS(263),
    [anon_sym_EQ_EQ] = ACTIONS(263),
    [anon_sym_BANG_EQ] = ACTIONS(263),
    [anon_sym_STAR] = ACTIONS(265),
    [anon_sym_SLASH] = ACTIONS(263),
    [anon_sym_STAR_STAR] = ACTIONS(263),
    [anon_sym_CARET] = ACTIONS(263),
    [aux_sym_binary_operator_token1] = ACTIONS(263),
    [anon_sym_PIPE_GT] = ACTIONS(263),
    [anon_sym_COLON] = ACTIONS(265),
    [anon_sym_DOLLAR] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(263),
    [aux_sym__hex_literal_token1] = ACTIONS(4666),
    [sym__number_literal] = ACTIONS(4668),
    [anon_sym_SQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4672),
    [sym_return] = ACTIONS(4746),
    [sym_next] = ACTIONS(4746),
    [sym_break] = ACTIONS(4746),
    [sym_true] = ACTIONS(4746),
    [sym_false] = ACTIONS(4746),
    [sym_null] = ACTIONS(4746),
    [sym_inf] = ACTIONS(4746),
    [sym_nan] = ACTIONS(4746),
    [anon_sym_NA] = ACTIONS(4676),
    [anon_sym_NA_integer_] = ACTIONS(4676),
    [anon_sym_NA_real_] = ACTIONS(4676),
    [anon_sym_NA_complex_] = ACTIONS(4676),
    [anon_sym_NA_character_] = ACTIONS(4676),
    [sym_dots] = ACTIONS(4746),
    [sym_dot_dot_i] = ACTIONS(4748),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(263),
    [sym__newline] = ACTIONS(4750),
    [sym__raw_string_literal] = ACTIONS(4680),
    [sym__external_open_parenthesis] = ACTIONS(4682),
    [sym__external_open_brace] = ACTIONS(4684),
    [sym__external_open_bracket] = ACTIONS(263),
    [sym__external_open_bracket2] = ACTIONS(263),
    [sym__external_close_bracket2] = ACTIONS(263),
  },
  [434] = {
    [sym_function_definition] = STATE(2013),
    [sym_if_statement] = STATE(2013),
    [sym_for_statement] = STATE(2013),
    [sym_while_statement] = STATE(2013),
    [sym_repeat_statement] = STATE(2013),
    [sym_braced_expression] = STATE(2013),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_call] = STATE(2013),
    [sym_subset] = STATE(2013),
    [sym_subset2] = STATE(2013),
    [sym_unary_operator] = STATE(2013),
    [sym_binary_operator] = STATE(2013),
    [sym_extract_operator] = STATE(2013),
    [sym_namespace_operator] = STATE(2013),
    [sym_integer] = STATE(2013),
    [sym_complex] = STATE(2013),
    [sym_float] = STATE(2013),
    [sym__hex_literal] = STATE(2700),
    [sym__float_literal] = STATE(2700),
    [sym_string] = STATE(2664),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym_na] = STATE(2013),
    [sym__expression] = STATE(2013),
    [sym__string_or_identifier] = STATE(5148),
    [sym__open_parenthesis] = STATE(214),
    [sym__open_brace] = STATE(192),
    [aux_sym_function_definition_repeat1] = STATE(2901),
    [sym_identifier] = ACTIONS(4752),
    [anon_sym_BSLASH] = ACTIONS(4754),
    [anon_sym_function] = ACTIONS(4756),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_if] = ACTIONS(4758),
    [anon_sym_for] = ACTIONS(4760),
    [anon_sym_while] = ACTIONS(4762),
    [anon_sym_repeat] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4766),
    [anon_sym_TILDE] = ACTIONS(4768),
    [anon_sym_BANG] = ACTIONS(4770),
    [anon_sym_PLUS] = ACTIONS(4772),
    [anon_sym_DASH] = ACTIONS(4774),
    [anon_sym_LT_DASH] = ACTIONS(471),
    [anon_sym_LT_LT_DASH] = ACTIONS(471),
    [anon_sym_COLON_EQ] = ACTIONS(471),
    [anon_sym_DASH_GT] = ACTIONS(473),
    [anon_sym_DASH_GT_GT] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(473),
    [anon_sym_AMP] = ACTIONS(473),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_LT_EQ] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(473),
    [anon_sym_GT_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_STAR] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [aux_sym_binary_operator_token1] = ACTIONS(471),
    [anon_sym_PIPE_GT] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(473),
    [anon_sym_DOLLAR] = ACTIONS(471),
    [anon_sym_AT] = ACTIONS(471),
    [aux_sym__hex_literal_token1] = ACTIONS(4776),
    [sym__number_literal] = ACTIONS(4778),
    [anon_sym_SQUOTE] = ACTIONS(4780),
    [anon_sym_DQUOTE] = ACTIONS(4782),
    [sym_return] = ACTIONS(4784),
    [sym_next] = ACTIONS(4784),
    [sym_break] = ACTIONS(4784),
    [sym_true] = ACTIONS(4784),
    [sym_false] = ACTIONS(4784),
    [sym_null] = ACTIONS(4784),
    [sym_inf] = ACTIONS(4784),
    [sym_nan] = ACTIONS(4784),
    [anon_sym_NA] = ACTIONS(4786),
    [anon_sym_NA_integer_] = ACTIONS(4786),
    [anon_sym_NA_real_] = ACTIONS(4786),
    [anon_sym_NA_complex_] = ACTIONS(4786),
    [anon_sym_NA_character_] = ACTIONS(4786),
    [sym_dots] = ACTIONS(4784),
    [sym_dot_dot_i] = ACTIONS(4788),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(471),
    [sym__newline] = ACTIONS(471),
    [sym__raw_string_literal] = ACTIONS(4790),
    [sym__external_open_parenthesis] = ACTIONS(4792),
    [sym__external_open_brace] = ACTIONS(4794),
    [sym__external_open_bracket] = ACTIONS(471),
    [sym__external_close_bracket] = ACTIONS(471),
    [sym__external_open_bracket2] = ACTIONS(471),
  },
  [435] = {
    [sym_function_definition] = STATE(2149),
    [sym_if_statement] = STATE(2149),
    [sym_for_statement] = STATE(2149),
    [sym_while_statement] = STATE(2149),
    [sym_repeat_statement] = STATE(2149),
    [sym_braced_expression] = STATE(2149),
    [sym_parenthesized_expression] = STATE(2149),
    [sym_call] = STATE(2149),
    [sym_subset] = STATE(2149),
    [sym_subset2] = STATE(2149),
    [sym_unary_operator] = STATE(2149),
    [sym_binary_operator] = STATE(2149),
    [sym_extract_operator] = STATE(2149),
    [sym_namespace_operator] = STATE(2149),
    [sym_integer] = STATE(2149),
    [sym_complex] = STATE(2149),
    [sym_float] = STATE(2149),
    [sym__hex_literal] = STATE(2739),
    [sym__float_literal] = STATE(2739),
    [sym_string] = STATE(2562),
    [sym__single_quoted_string] = STATE(2738),
    [sym__double_quoted_string] = STATE(2737),
    [sym_na] = STATE(2149),
    [sym__expression] = STATE(2149),
    [sym__string_or_identifier] = STATE(5152),
    [sym__open_parenthesis] = STATE(293),
    [sym__open_brace] = STATE(292),
    [aux_sym_function_definition_repeat1] = STATE(475),
    [ts_builtin_sym_end] = ACTIONS(545),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(9),
    [anon_sym_function] = ACTIONS(11),
    [anon_sym_EQ] = ACTIONS(543),
    [anon_sym_if] = ACTIONS(13),
    [anon_sym_for] = ACTIONS(15),
    [anon_sym_while] = ACTIONS(17),
    [anon_sym_repeat] = ACTIONS(19),
    [anon_sym_QMARK] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(4576),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_DASH] = ACTIONS(4578),
    [anon_sym_LT_DASH] = ACTIONS(545),
    [anon_sym_LT_LT_DASH] = ACTIONS(545),
    [anon_sym_COLON_EQ] = ACTIONS(545),
    [anon_sym_DASH_GT] = ACTIONS(543),
    [anon_sym_DASH_GT_GT] = ACTIONS(545),
    [anon_sym_PIPE] = ACTIONS(543),
    [anon_sym_AMP] = ACTIONS(543),
    [anon_sym_PIPE_PIPE] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(543),
    [anon_sym_LT_EQ] = ACTIONS(545),
    [anon_sym_GT] = ACTIONS(543),
    [anon_sym_GT_EQ] = ACTIONS(545),
    [anon_sym_EQ_EQ] = ACTIONS(545),
    [anon_sym_BANG_EQ] = ACTIONS(545),
    [anon_sym_STAR] = ACTIONS(543),
    [anon_sym_SLASH] = ACTIONS(545),
    [anon_sym_STAR_STAR] = ACTIONS(545),
    [anon_sym_CARET] = ACTIONS(545),
    [aux_sym_binary_operator_token1] = ACTIONS(545),
    [anon_sym_PIPE_GT] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(543),
    [anon_sym_DOLLAR] = ACTIONS(545),
    [anon_sym_AT] = ACTIONS(545),
    [aux_sym__hex_literal_token1] = ACTIONS(29),
    [sym__number_literal] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE] = ACTIONS(35),
    [sym_return] = ACTIONS(4796),
    [sym_next] = ACTIONS(4796),
    [sym_break] = ACTIONS(4796),
    [sym_true] = ACTIONS(4796),
    [sym_false] = ACTIONS(4796),
    [sym_null] = ACTIONS(4796),
    [sym_inf] = ACTIONS(4796),
    [sym_nan] = ACTIONS(4796),
    [anon_sym_NA] = ACTIONS(39),
    [anon_sym_NA_integer_] = ACTIONS(39),
    [anon_sym_NA_real_] = ACTIONS(39),
    [anon_sym_NA_complex_] = ACTIONS(39),
    [anon_sym_NA_character_] = ACTIONS(39),
    [sym_dots] = ACTIONS(4796),
    [sym_dot_dot_i] = ACTIONS(4798),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4800),
    [sym__semicolon] = ACTIONS(545),
    [sym__raw_string_literal] = ACTIONS(45),
    [sym__external_open_parenthesis] = ACTIONS(47),
    [sym__external_open_brace] = ACTIONS(49),
    [sym__external_open_bracket] = ACTIONS(545),
    [sym__external_open_bracket2] = ACTIONS(545),
  },
  [436] = {
    [sym_function_definition] = STATE(2017),
    [sym_if_statement] = STATE(2017),
    [sym_for_statement] = STATE(2017),
    [sym_while_statement] = STATE(2017),
    [sym_repeat_statement] = STATE(2017),
    [sym_braced_expression] = STATE(2017),
    [sym_parenthesized_expression] = STATE(2017),
    [sym_call] = STATE(2017),
    [sym_subset] = STATE(2017),
    [sym_subset2] = STATE(2017),
    [sym_unary_operator] = STATE(2017),
    [sym_binary_operator] = STATE(2017),
    [sym_extract_operator] = STATE(2017),
    [sym_namespace_operator] = STATE(2017),
    [sym_integer] = STATE(2017),
    [sym_complex] = STATE(2017),
    [sym_float] = STATE(2017),
    [sym__hex_literal] = STATE(2700),
    [sym__float_literal] = STATE(2700),
    [sym_string] = STATE(2664),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym_na] = STATE(2017),
    [sym__expression] = STATE(2017),
    [sym__string_or_identifier] = STATE(5148),
    [sym__open_parenthesis] = STATE(214),
    [sym__open_brace] = STATE(192),
    [aux_sym_function_definition_repeat1] = STATE(434),
    [sym_identifier] = ACTIONS(4752),
    [anon_sym_BSLASH] = ACTIONS(4754),
    [anon_sym_function] = ACTIONS(4756),
    [anon_sym_EQ] = ACTIONS(463),
    [anon_sym_if] = ACTIONS(4758),
    [anon_sym_for] = ACTIONS(4760),
    [anon_sym_while] = ACTIONS(4762),
    [anon_sym_repeat] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4766),
    [anon_sym_TILDE] = ACTIONS(4768),
    [anon_sym_BANG] = ACTIONS(4770),
    [anon_sym_PLUS] = ACTIONS(4772),
    [anon_sym_DASH] = ACTIONS(4774),
    [anon_sym_LT_DASH] = ACTIONS(461),
    [anon_sym_LT_LT_DASH] = ACTIONS(461),
    [anon_sym_COLON_EQ] = ACTIONS(461),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_DASH_GT_GT] = ACTIONS(461),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_PIPE_PIPE] = ACTIONS(461),
    [anon_sym_AMP_AMP] = ACTIONS(461),
    [anon_sym_LT] = ACTIONS(463),
    [anon_sym_LT_EQ] = ACTIONS(461),
    [anon_sym_GT] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(461),
    [anon_sym_EQ_EQ] = ACTIONS(461),
    [anon_sym_BANG_EQ] = ACTIONS(461),
    [anon_sym_STAR] = ACTIONS(463),
    [anon_sym_SLASH] = ACTIONS(461),
    [anon_sym_STAR_STAR] = ACTIONS(461),
    [anon_sym_CARET] = ACTIONS(461),
    [aux_sym_binary_operator_token1] = ACTIONS(461),
    [anon_sym_PIPE_GT] = ACTIONS(461),
    [anon_sym_COLON] = ACTIONS(463),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_AT] = ACTIONS(461),
    [aux_sym__hex_literal_token1] = ACTIONS(4776),
    [sym__number_literal] = ACTIONS(4778),
    [anon_sym_SQUOTE] = ACTIONS(4780),
    [anon_sym_DQUOTE] = ACTIONS(4782),
    [sym_return] = ACTIONS(4802),
    [sym_next] = ACTIONS(4802),
    [sym_break] = ACTIONS(4802),
    [sym_true] = ACTIONS(4802),
    [sym_false] = ACTIONS(4802),
    [sym_null] = ACTIONS(4802),
    [sym_inf] = ACTIONS(4802),
    [sym_nan] = ACTIONS(4802),
    [anon_sym_NA] = ACTIONS(4786),
    [anon_sym_NA_integer_] = ACTIONS(4786),
    [anon_sym_NA_real_] = ACTIONS(4786),
    [anon_sym_NA_complex_] = ACTIONS(4786),
    [anon_sym_NA_character_] = ACTIONS(4786),
    [sym_dots] = ACTIONS(4802),
    [sym_dot_dot_i] = ACTIONS(4804),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(461),
    [sym__newline] = ACTIONS(4806),
    [sym__raw_string_literal] = ACTIONS(4790),
    [sym__external_open_parenthesis] = ACTIONS(4792),
    [sym__external_open_brace] = ACTIONS(4794),
    [sym__external_open_bracket] = ACTIONS(461),
    [sym__external_close_bracket] = ACTIONS(461),
    [sym__external_open_bracket2] = ACTIONS(461),
  },
  [437] = {
    [sym_function_definition] = STATE(2019),
    [sym_if_statement] = STATE(2019),
    [sym_for_statement] = STATE(2019),
    [sym_while_statement] = STATE(2019),
    [sym_repeat_statement] = STATE(2019),
    [sym_braced_expression] = STATE(2019),
    [sym_parenthesized_expression] = STATE(2019),
    [sym_call] = STATE(2019),
    [sym_subset] = STATE(2019),
    [sym_subset2] = STATE(2019),
    [sym_unary_operator] = STATE(2019),
    [sym_binary_operator] = STATE(2019),
    [sym_extract_operator] = STATE(2019),
    [sym_namespace_operator] = STATE(2019),
    [sym_integer] = STATE(2019),
    [sym_complex] = STATE(2019),
    [sym_float] = STATE(2019),
    [sym__hex_literal] = STATE(2700),
    [sym__float_literal] = STATE(2700),
    [sym_string] = STATE(2664),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym_na] = STATE(2019),
    [sym__expression] = STATE(2019),
    [sym__string_or_identifier] = STATE(5148),
    [sym__open_parenthesis] = STATE(214),
    [sym__open_brace] = STATE(192),
    [aux_sym_function_definition_repeat1] = STATE(2901),
    [sym_identifier] = ACTIONS(4752),
    [anon_sym_BSLASH] = ACTIONS(4754),
    [anon_sym_function] = ACTIONS(4756),
    [anon_sym_EQ] = ACTIONS(455),
    [anon_sym_if] = ACTIONS(4758),
    [anon_sym_for] = ACTIONS(4760),
    [anon_sym_while] = ACTIONS(4762),
    [anon_sym_repeat] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4766),
    [anon_sym_TILDE] = ACTIONS(4768),
    [anon_sym_BANG] = ACTIONS(4770),
    [anon_sym_PLUS] = ACTIONS(4772),
    [anon_sym_DASH] = ACTIONS(4774),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [anon_sym_LT_LT_DASH] = ACTIONS(453),
    [anon_sym_COLON_EQ] = ACTIONS(453),
    [anon_sym_DASH_GT] = ACTIONS(455),
    [anon_sym_DASH_GT_GT] = ACTIONS(453),
    [anon_sym_PIPE] = ACTIONS(455),
    [anon_sym_AMP] = ACTIONS(455),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(455),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_GT] = ACTIONS(455),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(453),
    [anon_sym_STAR] = ACTIONS(455),
    [anon_sym_SLASH] = ACTIONS(453),
    [anon_sym_STAR_STAR] = ACTIONS(453),
    [anon_sym_CARET] = ACTIONS(453),
    [aux_sym_binary_operator_token1] = ACTIONS(453),
    [anon_sym_PIPE_GT] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(455),
    [anon_sym_DOLLAR] = ACTIONS(453),
    [anon_sym_AT] = ACTIONS(453),
    [aux_sym__hex_literal_token1] = ACTIONS(4776),
    [sym__number_literal] = ACTIONS(4778),
    [anon_sym_SQUOTE] = ACTIONS(4780),
    [anon_sym_DQUOTE] = ACTIONS(4782),
    [sym_return] = ACTIONS(4808),
    [sym_next] = ACTIONS(4808),
    [sym_break] = ACTIONS(4808),
    [sym_true] = ACTIONS(4808),
    [sym_false] = ACTIONS(4808),
    [sym_null] = ACTIONS(4808),
    [sym_inf] = ACTIONS(4808),
    [sym_nan] = ACTIONS(4808),
    [anon_sym_NA] = ACTIONS(4786),
    [anon_sym_NA_integer_] = ACTIONS(4786),
    [anon_sym_NA_real_] = ACTIONS(4786),
    [anon_sym_NA_complex_] = ACTIONS(4786),
    [anon_sym_NA_character_] = ACTIONS(4786),
    [sym_dots] = ACTIONS(4808),
    [sym_dot_dot_i] = ACTIONS(4810),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(453),
    [sym__newline] = ACTIONS(453),
    [sym__raw_string_literal] = ACTIONS(4790),
    [sym__external_open_parenthesis] = ACTIONS(4792),
    [sym__external_open_brace] = ACTIONS(4794),
    [sym__external_open_bracket] = ACTIONS(453),
    [sym__external_close_bracket] = ACTIONS(453),
    [sym__external_open_bracket2] = ACTIONS(453),
  },
  [438] = {
    [sym_function_definition] = STATE(2026),
    [sym_if_statement] = STATE(2026),
    [sym_for_statement] = STATE(2026),
    [sym_while_statement] = STATE(2026),
    [sym_repeat_statement] = STATE(2026),
    [sym_braced_expression] = STATE(2026),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_call] = STATE(2026),
    [sym_subset] = STATE(2026),
    [sym_subset2] = STATE(2026),
    [sym_unary_operator] = STATE(2026),
    [sym_binary_operator] = STATE(2026),
    [sym_extract_operator] = STATE(2026),
    [sym_namespace_operator] = STATE(2026),
    [sym_integer] = STATE(2026),
    [sym_complex] = STATE(2026),
    [sym_float] = STATE(2026),
    [sym__hex_literal] = STATE(2700),
    [sym__float_literal] = STATE(2700),
    [sym_string] = STATE(2664),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym_na] = STATE(2026),
    [sym__expression] = STATE(2026),
    [sym__string_or_identifier] = STATE(5148),
    [sym__open_parenthesis] = STATE(214),
    [sym__open_brace] = STATE(192),
    [aux_sym_function_definition_repeat1] = STATE(2901),
    [sym_identifier] = ACTIONS(4752),
    [anon_sym_BSLASH] = ACTIONS(4754),
    [anon_sym_function] = ACTIONS(4756),
    [anon_sym_EQ] = ACTIONS(399),
    [anon_sym_if] = ACTIONS(4758),
    [anon_sym_for] = ACTIONS(4760),
    [anon_sym_while] = ACTIONS(4762),
    [anon_sym_repeat] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4766),
    [anon_sym_TILDE] = ACTIONS(4768),
    [anon_sym_BANG] = ACTIONS(4770),
    [anon_sym_PLUS] = ACTIONS(4772),
    [anon_sym_DASH] = ACTIONS(4774),
    [anon_sym_LT_DASH] = ACTIONS(397),
    [anon_sym_LT_LT_DASH] = ACTIONS(397),
    [anon_sym_COLON_EQ] = ACTIONS(397),
    [anon_sym_DASH_GT] = ACTIONS(399),
    [anon_sym_DASH_GT_GT] = ACTIONS(397),
    [anon_sym_PIPE] = ACTIONS(399),
    [anon_sym_AMP] = ACTIONS(399),
    [anon_sym_PIPE_PIPE] = ACTIONS(397),
    [anon_sym_AMP_AMP] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(399),
    [anon_sym_LT_EQ] = ACTIONS(397),
    [anon_sym_GT] = ACTIONS(399),
    [anon_sym_GT_EQ] = ACTIONS(397),
    [anon_sym_EQ_EQ] = ACTIONS(397),
    [anon_sym_BANG_EQ] = ACTIONS(397),
    [anon_sym_STAR] = ACTIONS(399),
    [anon_sym_SLASH] = ACTIONS(397),
    [anon_sym_STAR_STAR] = ACTIONS(397),
    [anon_sym_CARET] = ACTIONS(397),
    [aux_sym_binary_operator_token1] = ACTIONS(397),
    [anon_sym_PIPE_GT] = ACTIONS(397),
    [anon_sym_COLON] = ACTIONS(399),
    [anon_sym_DOLLAR] = ACTIONS(397),
    [anon_sym_AT] = ACTIONS(397),
    [aux_sym__hex_literal_token1] = ACTIONS(4776),
    [sym__number_literal] = ACTIONS(4778),
    [anon_sym_SQUOTE] = ACTIONS(4780),
    [anon_sym_DQUOTE] = ACTIONS(4782),
    [sym_return] = ACTIONS(4812),
    [sym_next] = ACTIONS(4812),
    [sym_break] = ACTIONS(4812),
    [sym_true] = ACTIONS(4812),
    [sym_false] = ACTIONS(4812),
    [sym_null] = ACTIONS(4812),
    [sym_inf] = ACTIONS(4812),
    [sym_nan] = ACTIONS(4812),
    [anon_sym_NA] = ACTIONS(4786),
    [anon_sym_NA_integer_] = ACTIONS(4786),
    [anon_sym_NA_real_] = ACTIONS(4786),
    [anon_sym_NA_complex_] = ACTIONS(4786),
    [anon_sym_NA_character_] = ACTIONS(4786),
    [sym_dots] = ACTIONS(4812),
    [sym_dot_dot_i] = ACTIONS(4814),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(397),
    [sym__newline] = ACTIONS(397),
    [sym__raw_string_literal] = ACTIONS(4790),
    [sym__external_open_parenthesis] = ACTIONS(4792),
    [sym__external_open_brace] = ACTIONS(4794),
    [sym__external_open_bracket] = ACTIONS(397),
    [sym__external_close_bracket] = ACTIONS(397),
    [sym__external_open_bracket2] = ACTIONS(397),
  },
  [439] = {
    [sym_function_definition] = STATE(2042),
    [sym_if_statement] = STATE(2042),
    [sym_for_statement] = STATE(2042),
    [sym_while_statement] = STATE(2042),
    [sym_repeat_statement] = STATE(2042),
    [sym_braced_expression] = STATE(2042),
    [sym_parenthesized_expression] = STATE(2042),
    [sym_call] = STATE(2042),
    [sym_subset] = STATE(2042),
    [sym_subset2] = STATE(2042),
    [sym_unary_operator] = STATE(2042),
    [sym_binary_operator] = STATE(2042),
    [sym_extract_operator] = STATE(2042),
    [sym_namespace_operator] = STATE(2042),
    [sym_integer] = STATE(2042),
    [sym_complex] = STATE(2042),
    [sym_float] = STATE(2042),
    [sym__hex_literal] = STATE(2700),
    [sym__float_literal] = STATE(2700),
    [sym_string] = STATE(2664),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym_na] = STATE(2042),
    [sym__expression] = STATE(2042),
    [sym__string_or_identifier] = STATE(5148),
    [sym__open_parenthesis] = STATE(214),
    [sym__open_brace] = STATE(192),
    [aux_sym_function_definition_repeat1] = STATE(437),
    [sym_identifier] = ACTIONS(4752),
    [anon_sym_BSLASH] = ACTIONS(4754),
    [anon_sym_function] = ACTIONS(4756),
    [anon_sym_EQ] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(4758),
    [anon_sym_for] = ACTIONS(4760),
    [anon_sym_while] = ACTIONS(4762),
    [anon_sym_repeat] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4766),
    [anon_sym_TILDE] = ACTIONS(4768),
    [anon_sym_BANG] = ACTIONS(4770),
    [anon_sym_PLUS] = ACTIONS(4772),
    [anon_sym_DASH] = ACTIONS(4774),
    [anon_sym_LT_DASH] = ACTIONS(387),
    [anon_sym_LT_LT_DASH] = ACTIONS(387),
    [anon_sym_COLON_EQ] = ACTIONS(387),
    [anon_sym_DASH_GT] = ACTIONS(389),
    [anon_sym_DASH_GT_GT] = ACTIONS(387),
    [anon_sym_PIPE] = ACTIONS(389),
    [anon_sym_AMP] = ACTIONS(389),
    [anon_sym_PIPE_PIPE] = ACTIONS(387),
    [anon_sym_AMP_AMP] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(389),
    [anon_sym_LT_EQ] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(389),
    [anon_sym_GT_EQ] = ACTIONS(387),
    [anon_sym_EQ_EQ] = ACTIONS(387),
    [anon_sym_BANG_EQ] = ACTIONS(387),
    [anon_sym_STAR] = ACTIONS(389),
    [anon_sym_SLASH] = ACTIONS(387),
    [anon_sym_STAR_STAR] = ACTIONS(387),
    [anon_sym_CARET] = ACTIONS(387),
    [aux_sym_binary_operator_token1] = ACTIONS(387),
    [anon_sym_PIPE_GT] = ACTIONS(387),
    [anon_sym_COLON] = ACTIONS(389),
    [anon_sym_DOLLAR] = ACTIONS(387),
    [anon_sym_AT] = ACTIONS(387),
    [aux_sym__hex_literal_token1] = ACTIONS(4776),
    [sym__number_literal] = ACTIONS(4778),
    [anon_sym_SQUOTE] = ACTIONS(4780),
    [anon_sym_DQUOTE] = ACTIONS(4782),
    [sym_return] = ACTIONS(4816),
    [sym_next] = ACTIONS(4816),
    [sym_break] = ACTIONS(4816),
    [sym_true] = ACTIONS(4816),
    [sym_false] = ACTIONS(4816),
    [sym_null] = ACTIONS(4816),
    [sym_inf] = ACTIONS(4816),
    [sym_nan] = ACTIONS(4816),
    [anon_sym_NA] = ACTIONS(4786),
    [anon_sym_NA_integer_] = ACTIONS(4786),
    [anon_sym_NA_real_] = ACTIONS(4786),
    [anon_sym_NA_complex_] = ACTIONS(4786),
    [anon_sym_NA_character_] = ACTIONS(4786),
    [sym_dots] = ACTIONS(4816),
    [sym_dot_dot_i] = ACTIONS(4818),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(387),
    [sym__newline] = ACTIONS(4820),
    [sym__raw_string_literal] = ACTIONS(4790),
    [sym__external_open_parenthesis] = ACTIONS(4792),
    [sym__external_open_brace] = ACTIONS(4794),
    [sym__external_open_bracket] = ACTIONS(387),
    [sym__external_close_bracket] = ACTIONS(387),
    [sym__external_open_bracket2] = ACTIONS(387),
  },
  [440] = {
    [sym_function_definition] = STATE(2053),
    [sym_if_statement] = STATE(2053),
    [sym_for_statement] = STATE(2053),
    [sym_while_statement] = STATE(2053),
    [sym_repeat_statement] = STATE(2053),
    [sym_braced_expression] = STATE(2053),
    [sym_parenthesized_expression] = STATE(2053),
    [sym_call] = STATE(2053),
    [sym_subset] = STATE(2053),
    [sym_subset2] = STATE(2053),
    [sym_unary_operator] = STATE(2053),
    [sym_binary_operator] = STATE(2053),
    [sym_extract_operator] = STATE(2053),
    [sym_namespace_operator] = STATE(2053),
    [sym_integer] = STATE(2053),
    [sym_complex] = STATE(2053),
    [sym_float] = STATE(2053),
    [sym__hex_literal] = STATE(2700),
    [sym__float_literal] = STATE(2700),
    [sym_string] = STATE(2664),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym_na] = STATE(2053),
    [sym__expression] = STATE(2053),
    [sym__string_or_identifier] = STATE(5148),
    [sym__open_parenthesis] = STATE(214),
    [sym__open_brace] = STATE(192),
    [aux_sym_function_definition_repeat1] = STATE(438),
    [sym_identifier] = ACTIONS(4752),
    [anon_sym_BSLASH] = ACTIONS(4754),
    [anon_sym_function] = ACTIONS(4756),
    [anon_sym_EQ] = ACTIONS(379),
    [anon_sym_if] = ACTIONS(4758),
    [anon_sym_for] = ACTIONS(4760),
    [anon_sym_while] = ACTIONS(4762),
    [anon_sym_repeat] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4766),
    [anon_sym_TILDE] = ACTIONS(4768),
    [anon_sym_BANG] = ACTIONS(4770),
    [anon_sym_PLUS] = ACTIONS(4772),
    [anon_sym_DASH] = ACTIONS(4774),
    [anon_sym_LT_DASH] = ACTIONS(377),
    [anon_sym_LT_LT_DASH] = ACTIONS(377),
    [anon_sym_COLON_EQ] = ACTIONS(377),
    [anon_sym_DASH_GT] = ACTIONS(379),
    [anon_sym_DASH_GT_GT] = ACTIONS(377),
    [anon_sym_PIPE] = ACTIONS(379),
    [anon_sym_AMP] = ACTIONS(379),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_LT] = ACTIONS(379),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(379),
    [anon_sym_GT_EQ] = ACTIONS(377),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(379),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_STAR_STAR] = ACTIONS(377),
    [anon_sym_CARET] = ACTIONS(377),
    [aux_sym_binary_operator_token1] = ACTIONS(377),
    [anon_sym_PIPE_GT] = ACTIONS(377),
    [anon_sym_COLON] = ACTIONS(379),
    [anon_sym_DOLLAR] = ACTIONS(377),
    [anon_sym_AT] = ACTIONS(377),
    [aux_sym__hex_literal_token1] = ACTIONS(4776),
    [sym__number_literal] = ACTIONS(4778),
    [anon_sym_SQUOTE] = ACTIONS(4780),
    [anon_sym_DQUOTE] = ACTIONS(4782),
    [sym_return] = ACTIONS(4822),
    [sym_next] = ACTIONS(4822),
    [sym_break] = ACTIONS(4822),
    [sym_true] = ACTIONS(4822),
    [sym_false] = ACTIONS(4822),
    [sym_null] = ACTIONS(4822),
    [sym_inf] = ACTIONS(4822),
    [sym_nan] = ACTIONS(4822),
    [anon_sym_NA] = ACTIONS(4786),
    [anon_sym_NA_integer_] = ACTIONS(4786),
    [anon_sym_NA_real_] = ACTIONS(4786),
    [anon_sym_NA_complex_] = ACTIONS(4786),
    [anon_sym_NA_character_] = ACTIONS(4786),
    [sym_dots] = ACTIONS(4822),
    [sym_dot_dot_i] = ACTIONS(4824),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(377),
    [sym__newline] = ACTIONS(4826),
    [sym__raw_string_literal] = ACTIONS(4790),
    [sym__external_open_parenthesis] = ACTIONS(4792),
    [sym__external_open_brace] = ACTIONS(4794),
    [sym__external_open_bracket] = ACTIONS(377),
    [sym__external_close_bracket] = ACTIONS(377),
    [sym__external_open_bracket2] = ACTIONS(377),
  },
  [441] = {
    [sym_function_definition] = STATE(2058),
    [sym_if_statement] = STATE(2058),
    [sym_for_statement] = STATE(2058),
    [sym_while_statement] = STATE(2058),
    [sym_repeat_statement] = STATE(2058),
    [sym_braced_expression] = STATE(2058),
    [sym_parenthesized_expression] = STATE(2058),
    [sym_call] = STATE(2058),
    [sym_subset] = STATE(2058),
    [sym_subset2] = STATE(2058),
    [sym_unary_operator] = STATE(2058),
    [sym_binary_operator] = STATE(2058),
    [sym_extract_operator] = STATE(2058),
    [sym_namespace_operator] = STATE(2058),
    [sym_integer] = STATE(2058),
    [sym_complex] = STATE(2058),
    [sym_float] = STATE(2058),
    [sym__hex_literal] = STATE(2700),
    [sym__float_literal] = STATE(2700),
    [sym_string] = STATE(2664),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym_na] = STATE(2058),
    [sym__expression] = STATE(2058),
    [sym__string_or_identifier] = STATE(5148),
    [sym__open_parenthesis] = STATE(214),
    [sym__open_brace] = STATE(192),
    [aux_sym_function_definition_repeat1] = STATE(2901),
    [sym_identifier] = ACTIONS(4752),
    [anon_sym_BSLASH] = ACTIONS(4754),
    [anon_sym_function] = ACTIONS(4756),
    [anon_sym_EQ] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(4758),
    [anon_sym_for] = ACTIONS(4760),
    [anon_sym_while] = ACTIONS(4762),
    [anon_sym_repeat] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4766),
    [anon_sym_TILDE] = ACTIONS(4768),
    [anon_sym_BANG] = ACTIONS(4770),
    [anon_sym_PLUS] = ACTIONS(4772),
    [anon_sym_DASH] = ACTIONS(4774),
    [anon_sym_LT_DASH] = ACTIONS(369),
    [anon_sym_LT_LT_DASH] = ACTIONS(369),
    [anon_sym_COLON_EQ] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(371),
    [anon_sym_DASH_GT_GT] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(371),
    [anon_sym_AMP] = ACTIONS(371),
    [anon_sym_PIPE_PIPE] = ACTIONS(369),
    [anon_sym_AMP_AMP] = ACTIONS(369),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_LT_EQ] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_EQ] = ACTIONS(369),
    [anon_sym_EQ_EQ] = ACTIONS(369),
    [anon_sym_BANG_EQ] = ACTIONS(369),
    [anon_sym_STAR] = ACTIONS(371),
    [anon_sym_SLASH] = ACTIONS(369),
    [anon_sym_STAR_STAR] = ACTIONS(369),
    [anon_sym_CARET] = ACTIONS(369),
    [aux_sym_binary_operator_token1] = ACTIONS(369),
    [anon_sym_PIPE_GT] = ACTIONS(369),
    [anon_sym_COLON] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(369),
    [anon_sym_AT] = ACTIONS(369),
    [aux_sym__hex_literal_token1] = ACTIONS(4776),
    [sym__number_literal] = ACTIONS(4778),
    [anon_sym_SQUOTE] = ACTIONS(4780),
    [anon_sym_DQUOTE] = ACTIONS(4782),
    [sym_return] = ACTIONS(4828),
    [sym_next] = ACTIONS(4828),
    [sym_break] = ACTIONS(4828),
    [sym_true] = ACTIONS(4828),
    [sym_false] = ACTIONS(4828),
    [sym_null] = ACTIONS(4828),
    [sym_inf] = ACTIONS(4828),
    [sym_nan] = ACTIONS(4828),
    [anon_sym_NA] = ACTIONS(4786),
    [anon_sym_NA_integer_] = ACTIONS(4786),
    [anon_sym_NA_real_] = ACTIONS(4786),
    [anon_sym_NA_complex_] = ACTIONS(4786),
    [anon_sym_NA_character_] = ACTIONS(4786),
    [sym_dots] = ACTIONS(4828),
    [sym_dot_dot_i] = ACTIONS(4830),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(369),
    [sym__newline] = ACTIONS(369),
    [sym__raw_string_literal] = ACTIONS(4790),
    [sym__external_open_parenthesis] = ACTIONS(4792),
    [sym__external_open_brace] = ACTIONS(4794),
    [sym__external_open_bracket] = ACTIONS(369),
    [sym__external_close_bracket] = ACTIONS(369),
    [sym__external_open_bracket2] = ACTIONS(369),
  },
  [442] = {
    [sym_function_definition] = STATE(2067),
    [sym_if_statement] = STATE(2067),
    [sym_for_statement] = STATE(2067),
    [sym_while_statement] = STATE(2067),
    [sym_repeat_statement] = STATE(2067),
    [sym_braced_expression] = STATE(2067),
    [sym_parenthesized_expression] = STATE(2067),
    [sym_call] = STATE(2067),
    [sym_subset] = STATE(2067),
    [sym_subset2] = STATE(2067),
    [sym_unary_operator] = STATE(2067),
    [sym_binary_operator] = STATE(2067),
    [sym_extract_operator] = STATE(2067),
    [sym_namespace_operator] = STATE(2067),
    [sym_integer] = STATE(2067),
    [sym_complex] = STATE(2067),
    [sym_float] = STATE(2067),
    [sym__hex_literal] = STATE(2700),
    [sym__float_literal] = STATE(2700),
    [sym_string] = STATE(2664),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym_na] = STATE(2067),
    [sym__expression] = STATE(2067),
    [sym__string_or_identifier] = STATE(5148),
    [sym__open_parenthesis] = STATE(214),
    [sym__open_brace] = STATE(192),
    [aux_sym_function_definition_repeat1] = STATE(441),
    [sym_identifier] = ACTIONS(4752),
    [anon_sym_BSLASH] = ACTIONS(4754),
    [anon_sym_function] = ACTIONS(4756),
    [anon_sym_EQ] = ACTIONS(533),
    [anon_sym_if] = ACTIONS(4758),
    [anon_sym_for] = ACTIONS(4760),
    [anon_sym_while] = ACTIONS(4762),
    [anon_sym_repeat] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4766),
    [anon_sym_TILDE] = ACTIONS(4768),
    [anon_sym_BANG] = ACTIONS(4770),
    [anon_sym_PLUS] = ACTIONS(4772),
    [anon_sym_DASH] = ACTIONS(4774),
    [anon_sym_LT_DASH] = ACTIONS(531),
    [anon_sym_LT_LT_DASH] = ACTIONS(531),
    [anon_sym_COLON_EQ] = ACTIONS(531),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_DASH_GT_GT] = ACTIONS(531),
    [anon_sym_PIPE] = ACTIONS(533),
    [anon_sym_AMP] = ACTIONS(533),
    [anon_sym_PIPE_PIPE] = ACTIONS(531),
    [anon_sym_AMP_AMP] = ACTIONS(531),
    [anon_sym_LT] = ACTIONS(533),
    [anon_sym_LT_EQ] = ACTIONS(531),
    [anon_sym_GT] = ACTIONS(533),
    [anon_sym_GT_EQ] = ACTIONS(531),
    [anon_sym_EQ_EQ] = ACTIONS(531),
    [anon_sym_BANG_EQ] = ACTIONS(531),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_SLASH] = ACTIONS(531),
    [anon_sym_STAR_STAR] = ACTIONS(531),
    [anon_sym_CARET] = ACTIONS(531),
    [aux_sym_binary_operator_token1] = ACTIONS(531),
    [anon_sym_PIPE_GT] = ACTIONS(531),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_DOLLAR] = ACTIONS(531),
    [anon_sym_AT] = ACTIONS(531),
    [aux_sym__hex_literal_token1] = ACTIONS(4776),
    [sym__number_literal] = ACTIONS(4778),
    [anon_sym_SQUOTE] = ACTIONS(4780),
    [anon_sym_DQUOTE] = ACTIONS(4782),
    [sym_return] = ACTIONS(4832),
    [sym_next] = ACTIONS(4832),
    [sym_break] = ACTIONS(4832),
    [sym_true] = ACTIONS(4832),
    [sym_false] = ACTIONS(4832),
    [sym_null] = ACTIONS(4832),
    [sym_inf] = ACTIONS(4832),
    [sym_nan] = ACTIONS(4832),
    [anon_sym_NA] = ACTIONS(4786),
    [anon_sym_NA_integer_] = ACTIONS(4786),
    [anon_sym_NA_real_] = ACTIONS(4786),
    [anon_sym_NA_complex_] = ACTIONS(4786),
    [anon_sym_NA_character_] = ACTIONS(4786),
    [sym_dots] = ACTIONS(4832),
    [sym_dot_dot_i] = ACTIONS(4834),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(531),
    [sym__newline] = ACTIONS(4836),
    [sym__raw_string_literal] = ACTIONS(4790),
    [sym__external_open_parenthesis] = ACTIONS(4792),
    [sym__external_open_brace] = ACTIONS(4794),
    [sym__external_open_bracket] = ACTIONS(531),
    [sym__external_close_bracket] = ACTIONS(531),
    [sym__external_open_bracket2] = ACTIONS(531),
  },
  [443] = {
    [sym_function_definition] = STATE(1969),
    [sym_if_statement] = STATE(1969),
    [sym_for_statement] = STATE(1969),
    [sym_while_statement] = STATE(1969),
    [sym_repeat_statement] = STATE(1969),
    [sym_braced_expression] = STATE(1969),
    [sym_parenthesized_expression] = STATE(1969),
    [sym_call] = STATE(1969),
    [sym_subset] = STATE(1969),
    [sym_subset2] = STATE(1969),
    [sym_unary_operator] = STATE(1969),
    [sym_binary_operator] = STATE(1969),
    [sym_extract_operator] = STATE(1969),
    [sym_namespace_operator] = STATE(1969),
    [sym_integer] = STATE(1969),
    [sym_complex] = STATE(1969),
    [sym_float] = STATE(1969),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2673),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(1969),
    [sym__expression] = STATE(1969),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__open_brace] = STATE(154),
    [aux_sym_parenthesized_expression_repeat1] = STATE(443),
    [sym_identifier] = ACTIONS(4838),
    [anon_sym_BSLASH] = ACTIONS(4841),
    [anon_sym_function] = ACTIONS(4844),
    [anon_sym_EQ] = ACTIONS(814),
    [anon_sym_if] = ACTIONS(4847),
    [anon_sym_for] = ACTIONS(4850),
    [anon_sym_while] = ACTIONS(4853),
    [anon_sym_repeat] = ACTIONS(4856),
    [anon_sym_QMARK] = ACTIONS(4859),
    [anon_sym_TILDE] = ACTIONS(4862),
    [anon_sym_BANG] = ACTIONS(4865),
    [anon_sym_PLUS] = ACTIONS(4868),
    [anon_sym_DASH] = ACTIONS(4871),
    [anon_sym_LT_DASH] = ACTIONS(803),
    [anon_sym_LT_LT_DASH] = ACTIONS(803),
    [anon_sym_COLON_EQ] = ACTIONS(803),
    [anon_sym_DASH_GT] = ACTIONS(814),
    [anon_sym_DASH_GT_GT] = ACTIONS(803),
    [anon_sym_PIPE] = ACTIONS(814),
    [anon_sym_AMP] = ACTIONS(814),
    [anon_sym_PIPE_PIPE] = ACTIONS(803),
    [anon_sym_AMP_AMP] = ACTIONS(803),
    [anon_sym_LT] = ACTIONS(814),
    [anon_sym_LT_EQ] = ACTIONS(803),
    [anon_sym_GT] = ACTIONS(814),
    [anon_sym_GT_EQ] = ACTIONS(803),
    [anon_sym_EQ_EQ] = ACTIONS(803),
    [anon_sym_BANG_EQ] = ACTIONS(803),
    [anon_sym_STAR] = ACTIONS(814),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_STAR_STAR] = ACTIONS(803),
    [anon_sym_CARET] = ACTIONS(803),
    [aux_sym_binary_operator_token1] = ACTIONS(803),
    [anon_sym_PIPE_GT] = ACTIONS(803),
    [anon_sym_COLON] = ACTIONS(814),
    [anon_sym_DOLLAR] = ACTIONS(803),
    [anon_sym_AT] = ACTIONS(803),
    [aux_sym__hex_literal_token1] = ACTIONS(4874),
    [sym__number_literal] = ACTIONS(4877),
    [anon_sym_SQUOTE] = ACTIONS(4880),
    [anon_sym_DQUOTE] = ACTIONS(4883),
    [sym_return] = ACTIONS(4886),
    [sym_next] = ACTIONS(4886),
    [sym_break] = ACTIONS(4886),
    [sym_true] = ACTIONS(4886),
    [sym_false] = ACTIONS(4886),
    [sym_null] = ACTIONS(4886),
    [sym_inf] = ACTIONS(4886),
    [sym_nan] = ACTIONS(4886),
    [anon_sym_NA] = ACTIONS(4889),
    [anon_sym_NA_integer_] = ACTIONS(4889),
    [anon_sym_NA_real_] = ACTIONS(4889),
    [anon_sym_NA_complex_] = ACTIONS(4889),
    [anon_sym_NA_character_] = ACTIONS(4889),
    [sym_dots] = ACTIONS(4886),
    [sym_dot_dot_i] = ACTIONS(4892),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(803),
    [sym__newline] = ACTIONS(4895),
    [sym__raw_string_literal] = ACTIONS(4898),
    [sym__external_open_parenthesis] = ACTIONS(4901),
    [sym__external_close_parenthesis] = ACTIONS(803),
    [sym__external_open_brace] = ACTIONS(4904),
    [sym__external_open_bracket] = ACTIONS(803),
    [sym__external_open_bracket2] = ACTIONS(803),
  },
  [444] = {
    [sym_function_definition] = STATE(2162),
    [sym_if_statement] = STATE(2162),
    [sym_for_statement] = STATE(2162),
    [sym_while_statement] = STATE(2162),
    [sym_repeat_statement] = STATE(2162),
    [sym_braced_expression] = STATE(2162),
    [sym_parenthesized_expression] = STATE(2162),
    [sym_call] = STATE(2162),
    [sym_subset] = STATE(2162),
    [sym_subset2] = STATE(2162),
    [sym_unary_operator] = STATE(2162),
    [sym_binary_operator] = STATE(2162),
    [sym_extract_operator] = STATE(2162),
    [sym_namespace_operator] = STATE(2162),
    [sym_integer] = STATE(2162),
    [sym_complex] = STATE(2162),
    [sym_float] = STATE(2162),
    [sym__hex_literal] = STATE(2700),
    [sym__float_literal] = STATE(2700),
    [sym_string] = STATE(2664),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym_na] = STATE(2162),
    [sym__expression] = STATE(2162),
    [sym__string_or_identifier] = STATE(5148),
    [sym__open_parenthesis] = STATE(214),
    [sym__open_brace] = STATE(192),
    [aux_sym_function_definition_repeat1] = STATE(2901),
    [sym_identifier] = ACTIONS(4752),
    [anon_sym_BSLASH] = ACTIONS(4754),
    [anon_sym_function] = ACTIONS(4756),
    [anon_sym_EQ] = ACTIONS(759),
    [anon_sym_if] = ACTIONS(4758),
    [anon_sym_for] = ACTIONS(4760),
    [anon_sym_while] = ACTIONS(4762),
    [anon_sym_repeat] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4766),
    [anon_sym_TILDE] = ACTIONS(4768),
    [anon_sym_BANG] = ACTIONS(4770),
    [anon_sym_PLUS] = ACTIONS(4772),
    [anon_sym_DASH] = ACTIONS(4774),
    [anon_sym_LT_DASH] = ACTIONS(757),
    [anon_sym_LT_LT_DASH] = ACTIONS(757),
    [anon_sym_COLON_EQ] = ACTIONS(757),
    [anon_sym_DASH_GT] = ACTIONS(759),
    [anon_sym_DASH_GT_GT] = ACTIONS(757),
    [anon_sym_PIPE] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(759),
    [anon_sym_PIPE_PIPE] = ACTIONS(757),
    [anon_sym_AMP_AMP] = ACTIONS(757),
    [anon_sym_LT] = ACTIONS(759),
    [anon_sym_LT_EQ] = ACTIONS(757),
    [anon_sym_GT] = ACTIONS(759),
    [anon_sym_GT_EQ] = ACTIONS(757),
    [anon_sym_EQ_EQ] = ACTIONS(757),
    [anon_sym_BANG_EQ] = ACTIONS(757),
    [anon_sym_STAR] = ACTIONS(759),
    [anon_sym_SLASH] = ACTIONS(757),
    [anon_sym_STAR_STAR] = ACTIONS(757),
    [anon_sym_CARET] = ACTIONS(757),
    [aux_sym_binary_operator_token1] = ACTIONS(757),
    [anon_sym_PIPE_GT] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(759),
    [anon_sym_DOLLAR] = ACTIONS(757),
    [anon_sym_AT] = ACTIONS(757),
    [aux_sym__hex_literal_token1] = ACTIONS(4776),
    [sym__number_literal] = ACTIONS(4778),
    [anon_sym_SQUOTE] = ACTIONS(4780),
    [anon_sym_DQUOTE] = ACTIONS(4782),
    [sym_return] = ACTIONS(4907),
    [sym_next] = ACTIONS(4907),
    [sym_break] = ACTIONS(4907),
    [sym_true] = ACTIONS(4907),
    [sym_false] = ACTIONS(4907),
    [sym_null] = ACTIONS(4907),
    [sym_inf] = ACTIONS(4907),
    [sym_nan] = ACTIONS(4907),
    [anon_sym_NA] = ACTIONS(4786),
    [anon_sym_NA_integer_] = ACTIONS(4786),
    [anon_sym_NA_real_] = ACTIONS(4786),
    [anon_sym_NA_complex_] = ACTIONS(4786),
    [anon_sym_NA_character_] = ACTIONS(4786),
    [sym_dots] = ACTIONS(4907),
    [sym_dot_dot_i] = ACTIONS(4909),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(757),
    [sym__newline] = ACTIONS(757),
    [sym__raw_string_literal] = ACTIONS(4790),
    [sym__external_open_parenthesis] = ACTIONS(4792),
    [sym__external_open_brace] = ACTIONS(4794),
    [sym__external_open_bracket] = ACTIONS(757),
    [sym__external_close_bracket] = ACTIONS(757),
    [sym__external_open_bracket2] = ACTIONS(757),
  },
  [445] = {
    [sym_function_definition] = STATE(1917),
    [sym_if_statement] = STATE(1917),
    [sym_for_statement] = STATE(1917),
    [sym_while_statement] = STATE(1917),
    [sym_repeat_statement] = STATE(1917),
    [sym_braced_expression] = STATE(1917),
    [sym_parenthesized_expression] = STATE(1917),
    [sym_call] = STATE(1917),
    [sym_subset] = STATE(1917),
    [sym_subset2] = STATE(1917),
    [sym_unary_operator] = STATE(1917),
    [sym_binary_operator] = STATE(1917),
    [sym_extract_operator] = STATE(1917),
    [sym_namespace_operator] = STATE(1917),
    [sym_integer] = STATE(1917),
    [sym_complex] = STATE(1917),
    [sym_float] = STATE(1917),
    [sym__hex_literal] = STATE(2700),
    [sym__float_literal] = STATE(2700),
    [sym_string] = STATE(2664),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym_na] = STATE(1917),
    [sym__expression] = STATE(1917),
    [sym__string_or_identifier] = STATE(5148),
    [sym__open_parenthesis] = STATE(214),
    [sym__open_brace] = STATE(192),
    [aux_sym_function_definition_repeat1] = STATE(2901),
    [sym_identifier] = ACTIONS(4752),
    [anon_sym_BSLASH] = ACTIONS(4754),
    [anon_sym_function] = ACTIONS(4756),
    [anon_sym_EQ] = ACTIONS(767),
    [anon_sym_if] = ACTIONS(4758),
    [anon_sym_for] = ACTIONS(4760),
    [anon_sym_while] = ACTIONS(4762),
    [anon_sym_repeat] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4766),
    [anon_sym_TILDE] = ACTIONS(4768),
    [anon_sym_BANG] = ACTIONS(4770),
    [anon_sym_PLUS] = ACTIONS(4772),
    [anon_sym_DASH] = ACTIONS(4774),
    [anon_sym_LT_DASH] = ACTIONS(765),
    [anon_sym_LT_LT_DASH] = ACTIONS(765),
    [anon_sym_COLON_EQ] = ACTIONS(765),
    [anon_sym_DASH_GT] = ACTIONS(767),
    [anon_sym_DASH_GT_GT] = ACTIONS(765),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_AMP] = ACTIONS(767),
    [anon_sym_PIPE_PIPE] = ACTIONS(765),
    [anon_sym_AMP_AMP] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(767),
    [anon_sym_LT_EQ] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_GT_EQ] = ACTIONS(765),
    [anon_sym_EQ_EQ] = ACTIONS(765),
    [anon_sym_BANG_EQ] = ACTIONS(765),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(765),
    [anon_sym_STAR_STAR] = ACTIONS(765),
    [anon_sym_CARET] = ACTIONS(765),
    [aux_sym_binary_operator_token1] = ACTIONS(765),
    [anon_sym_PIPE_GT] = ACTIONS(765),
    [anon_sym_COLON] = ACTIONS(767),
    [anon_sym_DOLLAR] = ACTIONS(765),
    [anon_sym_AT] = ACTIONS(765),
    [aux_sym__hex_literal_token1] = ACTIONS(4776),
    [sym__number_literal] = ACTIONS(4778),
    [anon_sym_SQUOTE] = ACTIONS(4780),
    [anon_sym_DQUOTE] = ACTIONS(4782),
    [sym_return] = ACTIONS(4911),
    [sym_next] = ACTIONS(4911),
    [sym_break] = ACTIONS(4911),
    [sym_true] = ACTIONS(4911),
    [sym_false] = ACTIONS(4911),
    [sym_null] = ACTIONS(4911),
    [sym_inf] = ACTIONS(4911),
    [sym_nan] = ACTIONS(4911),
    [anon_sym_NA] = ACTIONS(4786),
    [anon_sym_NA_integer_] = ACTIONS(4786),
    [anon_sym_NA_real_] = ACTIONS(4786),
    [anon_sym_NA_complex_] = ACTIONS(4786),
    [anon_sym_NA_character_] = ACTIONS(4786),
    [sym_dots] = ACTIONS(4911),
    [sym_dot_dot_i] = ACTIONS(4913),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(765),
    [sym__newline] = ACTIONS(765),
    [sym__raw_string_literal] = ACTIONS(4790),
    [sym__external_open_parenthesis] = ACTIONS(4792),
    [sym__external_open_brace] = ACTIONS(4794),
    [sym__external_open_bracket] = ACTIONS(765),
    [sym__external_close_bracket] = ACTIONS(765),
    [sym__external_open_bracket2] = ACTIONS(765),
  },
  [446] = {
    [sym_function_definition] = STATE(4604),
    [sym_if_statement] = STATE(4604),
    [sym_for_statement] = STATE(4604),
    [sym_while_statement] = STATE(4604),
    [sym_repeat_statement] = STATE(4604),
    [sym_braced_expression] = STATE(4604),
    [sym_parenthesized_expression] = STATE(4604),
    [sym_call] = STATE(4604),
    [sym_subset] = STATE(4604),
    [sym_subset2] = STATE(4604),
    [sym_unary_operator] = STATE(4604),
    [sym_binary_operator] = STATE(4604),
    [sym_extract_operator] = STATE(4604),
    [sym_namespace_operator] = STATE(4604),
    [sym_integer] = STATE(4604),
    [sym_complex] = STATE(4604),
    [sym_float] = STATE(4604),
    [sym__hex_literal] = STATE(4690),
    [sym__float_literal] = STATE(4690),
    [sym_string] = STATE(4689),
    [sym__single_quoted_string] = STATE(4684),
    [sym__double_quoted_string] = STATE(4691),
    [sym_na] = STATE(4604),
    [sym__expression] = STATE(4604),
    [sym__string_or_identifier] = STATE(5155),
    [sym__open_parenthesis] = STATE(402),
    [sym__open_brace] = STATE(153),
    [aux_sym_function_definition_repeat1] = STATE(2866),
    [sym_identifier] = ACTIONS(4590),
    [anon_sym_BSLASH] = ACTIONS(4592),
    [anon_sym_function] = ACTIONS(4594),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_if] = ACTIONS(4596),
    [anon_sym_for] = ACTIONS(4598),
    [anon_sym_while] = ACTIONS(4600),
    [anon_sym_repeat] = ACTIONS(4602),
    [anon_sym_QMARK] = ACTIONS(4604),
    [anon_sym_TILDE] = ACTIONS(4606),
    [anon_sym_BANG] = ACTIONS(4608),
    [anon_sym_PLUS] = ACTIONS(4610),
    [anon_sym_DASH] = ACTIONS(4612),
    [anon_sym_LT_DASH] = ACTIONS(471),
    [anon_sym_LT_LT_DASH] = ACTIONS(471),
    [anon_sym_COLON_EQ] = ACTIONS(471),
    [anon_sym_DASH_GT] = ACTIONS(473),
    [anon_sym_DASH_GT_GT] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(473),
    [anon_sym_AMP] = ACTIONS(473),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_LT_EQ] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(473),
    [anon_sym_GT_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_STAR] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [aux_sym_binary_operator_token1] = ACTIONS(471),
    [anon_sym_PIPE_GT] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(473),
    [anon_sym_DOLLAR] = ACTIONS(471),
    [anon_sym_AT] = ACTIONS(471),
    [aux_sym__hex_literal_token1] = ACTIONS(4614),
    [sym__number_literal] = ACTIONS(4616),
    [anon_sym_SQUOTE] = ACTIONS(4618),
    [anon_sym_DQUOTE] = ACTIONS(4620),
    [sym_return] = ACTIONS(4915),
    [sym_next] = ACTIONS(4915),
    [sym_break] = ACTIONS(4915),
    [sym_true] = ACTIONS(4915),
    [sym_false] = ACTIONS(4915),
    [sym_null] = ACTIONS(4915),
    [sym_inf] = ACTIONS(4915),
    [sym_nan] = ACTIONS(4915),
    [anon_sym_NA] = ACTIONS(4624),
    [anon_sym_NA_integer_] = ACTIONS(4624),
    [anon_sym_NA_real_] = ACTIONS(4624),
    [anon_sym_NA_complex_] = ACTIONS(4624),
    [anon_sym_NA_character_] = ACTIONS(4624),
    [sym_dots] = ACTIONS(4915),
    [sym_dot_dot_i] = ACTIONS(4917),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(471),
    [sym__newline] = ACTIONS(4628),
    [sym__raw_string_literal] = ACTIONS(4630),
    [sym__external_open_parenthesis] = ACTIONS(4632),
    [sym__external_close_parenthesis] = ACTIONS(471),
    [sym__external_open_brace] = ACTIONS(4634),
    [sym__external_open_bracket] = ACTIONS(471),
    [sym__external_open_bracket2] = ACTIONS(471),
  },
  [447] = {
    [sym_function_definition] = STATE(1941),
    [sym_if_statement] = STATE(1941),
    [sym_for_statement] = STATE(1941),
    [sym_while_statement] = STATE(1941),
    [sym_repeat_statement] = STATE(1941),
    [sym_braced_expression] = STATE(1941),
    [sym_parenthesized_expression] = STATE(1941),
    [sym_call] = STATE(1941),
    [sym_subset] = STATE(1941),
    [sym_subset2] = STATE(1941),
    [sym_unary_operator] = STATE(1941),
    [sym_binary_operator] = STATE(1941),
    [sym_extract_operator] = STATE(1941),
    [sym_namespace_operator] = STATE(1941),
    [sym_integer] = STATE(1941),
    [sym_complex] = STATE(1941),
    [sym_float] = STATE(1941),
    [sym__hex_literal] = STATE(2700),
    [sym__float_literal] = STATE(2700),
    [sym_string] = STATE(2664),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym_na] = STATE(1941),
    [sym__expression] = STATE(1941),
    [sym__string_or_identifier] = STATE(5148),
    [sym__open_parenthesis] = STATE(214),
    [sym__open_brace] = STATE(192),
    [aux_sym_function_definition_repeat1] = STATE(444),
    [sym_identifier] = ACTIONS(4752),
    [anon_sym_BSLASH] = ACTIONS(4754),
    [anon_sym_function] = ACTIONS(4756),
    [anon_sym_EQ] = ACTIONS(543),
    [anon_sym_if] = ACTIONS(4758),
    [anon_sym_for] = ACTIONS(4760),
    [anon_sym_while] = ACTIONS(4762),
    [anon_sym_repeat] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4766),
    [anon_sym_TILDE] = ACTIONS(4768),
    [anon_sym_BANG] = ACTIONS(4770),
    [anon_sym_PLUS] = ACTIONS(4772),
    [anon_sym_DASH] = ACTIONS(4774),
    [anon_sym_LT_DASH] = ACTIONS(545),
    [anon_sym_LT_LT_DASH] = ACTIONS(545),
    [anon_sym_COLON_EQ] = ACTIONS(545),
    [anon_sym_DASH_GT] = ACTIONS(543),
    [anon_sym_DASH_GT_GT] = ACTIONS(545),
    [anon_sym_PIPE] = ACTIONS(543),
    [anon_sym_AMP] = ACTIONS(543),
    [anon_sym_PIPE_PIPE] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(543),
    [anon_sym_LT_EQ] = ACTIONS(545),
    [anon_sym_GT] = ACTIONS(543),
    [anon_sym_GT_EQ] = ACTIONS(545),
    [anon_sym_EQ_EQ] = ACTIONS(545),
    [anon_sym_BANG_EQ] = ACTIONS(545),
    [anon_sym_STAR] = ACTIONS(543),
    [anon_sym_SLASH] = ACTIONS(545),
    [anon_sym_STAR_STAR] = ACTIONS(545),
    [anon_sym_CARET] = ACTIONS(545),
    [aux_sym_binary_operator_token1] = ACTIONS(545),
    [anon_sym_PIPE_GT] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(543),
    [anon_sym_DOLLAR] = ACTIONS(545),
    [anon_sym_AT] = ACTIONS(545),
    [aux_sym__hex_literal_token1] = ACTIONS(4776),
    [sym__number_literal] = ACTIONS(4778),
    [anon_sym_SQUOTE] = ACTIONS(4780),
    [anon_sym_DQUOTE] = ACTIONS(4782),
    [sym_return] = ACTIONS(4919),
    [sym_next] = ACTIONS(4919),
    [sym_break] = ACTIONS(4919),
    [sym_true] = ACTIONS(4919),
    [sym_false] = ACTIONS(4919),
    [sym_null] = ACTIONS(4919),
    [sym_inf] = ACTIONS(4919),
    [sym_nan] = ACTIONS(4919),
    [anon_sym_NA] = ACTIONS(4786),
    [anon_sym_NA_integer_] = ACTIONS(4786),
    [anon_sym_NA_real_] = ACTIONS(4786),
    [anon_sym_NA_complex_] = ACTIONS(4786),
    [anon_sym_NA_character_] = ACTIONS(4786),
    [sym_dots] = ACTIONS(4919),
    [sym_dot_dot_i] = ACTIONS(4921),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(545),
    [sym__newline] = ACTIONS(4923),
    [sym__raw_string_literal] = ACTIONS(4790),
    [sym__external_open_parenthesis] = ACTIONS(4792),
    [sym__external_open_brace] = ACTIONS(4794),
    [sym__external_open_bracket] = ACTIONS(545),
    [sym__external_close_bracket] = ACTIONS(545),
    [sym__external_open_bracket2] = ACTIONS(545),
  },
  [448] = {
    [sym_function_definition] = STATE(2111),
    [sym_if_statement] = STATE(2111),
    [sym_for_statement] = STATE(2111),
    [sym_while_statement] = STATE(2111),
    [sym_repeat_statement] = STATE(2111),
    [sym_braced_expression] = STATE(2111),
    [sym_parenthesized_expression] = STATE(2111),
    [sym_call] = STATE(2111),
    [sym_subset] = STATE(2111),
    [sym_subset2] = STATE(2111),
    [sym_unary_operator] = STATE(2111),
    [sym_binary_operator] = STATE(2111),
    [sym_extract_operator] = STATE(2111),
    [sym_namespace_operator] = STATE(2111),
    [sym_integer] = STATE(2111),
    [sym_complex] = STATE(2111),
    [sym_float] = STATE(2111),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2673),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(2111),
    [sym__expression] = STATE(2111),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__open_brace] = STATE(154),
    [aux_sym_function_definition_repeat1] = STATE(458),
    [sym_identifier] = ACTIONS(3845),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_EQ] = ACTIONS(533),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3867),
    [anon_sym_LT_DASH] = ACTIONS(531),
    [anon_sym_LT_LT_DASH] = ACTIONS(531),
    [anon_sym_COLON_EQ] = ACTIONS(531),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_DASH_GT_GT] = ACTIONS(531),
    [anon_sym_PIPE] = ACTIONS(533),
    [anon_sym_AMP] = ACTIONS(533),
    [anon_sym_PIPE_PIPE] = ACTIONS(531),
    [anon_sym_AMP_AMP] = ACTIONS(531),
    [anon_sym_LT] = ACTIONS(533),
    [anon_sym_LT_EQ] = ACTIONS(531),
    [anon_sym_GT] = ACTIONS(533),
    [anon_sym_GT_EQ] = ACTIONS(531),
    [anon_sym_EQ_EQ] = ACTIONS(531),
    [anon_sym_BANG_EQ] = ACTIONS(531),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_SLASH] = ACTIONS(531),
    [anon_sym_STAR_STAR] = ACTIONS(531),
    [anon_sym_CARET] = ACTIONS(531),
    [aux_sym_binary_operator_token1] = ACTIONS(531),
    [anon_sym_PIPE_GT] = ACTIONS(531),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_DOLLAR] = ACTIONS(531),
    [anon_sym_AT] = ACTIONS(531),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(4925),
    [sym_next] = ACTIONS(4925),
    [sym_break] = ACTIONS(4925),
    [sym_true] = ACTIONS(4925),
    [sym_false] = ACTIONS(4925),
    [sym_null] = ACTIONS(4925),
    [sym_inf] = ACTIONS(4925),
    [sym_nan] = ACTIONS(4925),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(4925),
    [sym_dot_dot_i] = ACTIONS(4927),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(531),
    [sym__newline] = ACTIONS(4929),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(531),
    [sym__external_open_brace] = ACTIONS(3891),
    [sym__external_open_bracket] = ACTIONS(531),
    [sym__external_open_bracket2] = ACTIONS(531),
  },
  [449] = {
    [sym_function_definition] = STATE(2090),
    [sym_if_statement] = STATE(2090),
    [sym_for_statement] = STATE(2090),
    [sym_while_statement] = STATE(2090),
    [sym_repeat_statement] = STATE(2090),
    [sym_braced_expression] = STATE(2090),
    [sym_parenthesized_expression] = STATE(2090),
    [sym_call] = STATE(2090),
    [sym_subset] = STATE(2090),
    [sym_subset2] = STATE(2090),
    [sym_unary_operator] = STATE(2090),
    [sym_binary_operator] = STATE(2090),
    [sym_extract_operator] = STATE(2090),
    [sym_namespace_operator] = STATE(2090),
    [sym_integer] = STATE(2090),
    [sym_complex] = STATE(2090),
    [sym_float] = STATE(2090),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2673),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(2090),
    [sym__expression] = STATE(2090),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__open_brace] = STATE(154),
    [aux_sym_function_definition_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(3845),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_EQ] = ACTIONS(543),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3867),
    [anon_sym_LT_DASH] = ACTIONS(545),
    [anon_sym_LT_LT_DASH] = ACTIONS(545),
    [anon_sym_COLON_EQ] = ACTIONS(545),
    [anon_sym_DASH_GT] = ACTIONS(543),
    [anon_sym_DASH_GT_GT] = ACTIONS(545),
    [anon_sym_PIPE] = ACTIONS(543),
    [anon_sym_AMP] = ACTIONS(543),
    [anon_sym_PIPE_PIPE] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(543),
    [anon_sym_LT_EQ] = ACTIONS(545),
    [anon_sym_GT] = ACTIONS(543),
    [anon_sym_GT_EQ] = ACTIONS(545),
    [anon_sym_EQ_EQ] = ACTIONS(545),
    [anon_sym_BANG_EQ] = ACTIONS(545),
    [anon_sym_STAR] = ACTIONS(543),
    [anon_sym_SLASH] = ACTIONS(545),
    [anon_sym_STAR_STAR] = ACTIONS(545),
    [anon_sym_CARET] = ACTIONS(545),
    [aux_sym_binary_operator_token1] = ACTIONS(545),
    [anon_sym_PIPE_GT] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(543),
    [anon_sym_DOLLAR] = ACTIONS(545),
    [anon_sym_AT] = ACTIONS(545),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(4931),
    [sym_next] = ACTIONS(4931),
    [sym_break] = ACTIONS(4931),
    [sym_true] = ACTIONS(4931),
    [sym_false] = ACTIONS(4931),
    [sym_null] = ACTIONS(4931),
    [sym_inf] = ACTIONS(4931),
    [sym_nan] = ACTIONS(4931),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(4931),
    [sym_dot_dot_i] = ACTIONS(4933),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(545),
    [sym__newline] = ACTIONS(4935),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(545),
    [sym__external_open_brace] = ACTIONS(3891),
    [sym__external_open_bracket] = ACTIONS(545),
    [sym__external_open_bracket2] = ACTIONS(545),
  },
  [450] = {
    [sym_function_definition] = STATE(2165),
    [sym_if_statement] = STATE(2165),
    [sym_for_statement] = STATE(2165),
    [sym_while_statement] = STATE(2165),
    [sym_repeat_statement] = STATE(2165),
    [sym_braced_expression] = STATE(2165),
    [sym_parenthesized_expression] = STATE(2165),
    [sym_call] = STATE(2165),
    [sym_subset] = STATE(2165),
    [sym_subset2] = STATE(2165),
    [sym_unary_operator] = STATE(2165),
    [sym_binary_operator] = STATE(2165),
    [sym_extract_operator] = STATE(2165),
    [sym_namespace_operator] = STATE(2165),
    [sym_integer] = STATE(2165),
    [sym_complex] = STATE(2165),
    [sym_float] = STATE(2165),
    [sym__hex_literal] = STATE(2700),
    [sym__float_literal] = STATE(2700),
    [sym_string] = STATE(2664),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym_na] = STATE(2165),
    [sym__expression] = STATE(2165),
    [sym__string_or_identifier] = STATE(5148),
    [sym__open_parenthesis] = STATE(214),
    [sym__open_brace] = STATE(192),
    [aux_sym_function_definition_repeat1] = STATE(445),
    [sym_identifier] = ACTIONS(4752),
    [anon_sym_BSLASH] = ACTIONS(4754),
    [anon_sym_function] = ACTIONS(4756),
    [anon_sym_EQ] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(4758),
    [anon_sym_for] = ACTIONS(4760),
    [anon_sym_while] = ACTIONS(4762),
    [anon_sym_repeat] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4766),
    [anon_sym_TILDE] = ACTIONS(4768),
    [anon_sym_BANG] = ACTIONS(4770),
    [anon_sym_PLUS] = ACTIONS(4772),
    [anon_sym_DASH] = ACTIONS(4774),
    [anon_sym_LT_DASH] = ACTIONS(263),
    [anon_sym_LT_LT_DASH] = ACTIONS(263),
    [anon_sym_COLON_EQ] = ACTIONS(263),
    [anon_sym_DASH_GT] = ACTIONS(265),
    [anon_sym_DASH_GT_GT] = ACTIONS(263),
    [anon_sym_PIPE] = ACTIONS(265),
    [anon_sym_AMP] = ACTIONS(265),
    [anon_sym_PIPE_PIPE] = ACTIONS(263),
    [anon_sym_AMP_AMP] = ACTIONS(263),
    [anon_sym_LT] = ACTIONS(265),
    [anon_sym_LT_EQ] = ACTIONS(263),
    [anon_sym_GT] = ACTIONS(265),
    [anon_sym_GT_EQ] = ACTIONS(263),
    [anon_sym_EQ_EQ] = ACTIONS(263),
    [anon_sym_BANG_EQ] = ACTIONS(263),
    [anon_sym_STAR] = ACTIONS(265),
    [anon_sym_SLASH] = ACTIONS(263),
    [anon_sym_STAR_STAR] = ACTIONS(263),
    [anon_sym_CARET] = ACTIONS(263),
    [aux_sym_binary_operator_token1] = ACTIONS(263),
    [anon_sym_PIPE_GT] = ACTIONS(263),
    [anon_sym_COLON] = ACTIONS(265),
    [anon_sym_DOLLAR] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(263),
    [aux_sym__hex_literal_token1] = ACTIONS(4776),
    [sym__number_literal] = ACTIONS(4778),
    [anon_sym_SQUOTE] = ACTIONS(4780),
    [anon_sym_DQUOTE] = ACTIONS(4782),
    [sym_return] = ACTIONS(4937),
    [sym_next] = ACTIONS(4937),
    [sym_break] = ACTIONS(4937),
    [sym_true] = ACTIONS(4937),
    [sym_false] = ACTIONS(4937),
    [sym_null] = ACTIONS(4937),
    [sym_inf] = ACTIONS(4937),
    [sym_nan] = ACTIONS(4937),
    [anon_sym_NA] = ACTIONS(4786),
    [anon_sym_NA_integer_] = ACTIONS(4786),
    [anon_sym_NA_real_] = ACTIONS(4786),
    [anon_sym_NA_complex_] = ACTIONS(4786),
    [anon_sym_NA_character_] = ACTIONS(4786),
    [sym_dots] = ACTIONS(4937),
    [sym_dot_dot_i] = ACTIONS(4939),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(263),
    [sym__newline] = ACTIONS(4941),
    [sym__raw_string_literal] = ACTIONS(4790),
    [sym__external_open_parenthesis] = ACTIONS(4792),
    [sym__external_open_brace] = ACTIONS(4794),
    [sym__external_open_bracket] = ACTIONS(263),
    [sym__external_close_bracket] = ACTIONS(263),
    [sym__external_open_bracket2] = ACTIONS(263),
  },
  [451] = {
    [sym_function_definition] = STATE(2150),
    [sym_if_statement] = STATE(2150),
    [sym_for_statement] = STATE(2150),
    [sym_while_statement] = STATE(2150),
    [sym_repeat_statement] = STATE(2150),
    [sym_braced_expression] = STATE(2150),
    [sym_parenthesized_expression] = STATE(2150),
    [sym_call] = STATE(2150),
    [sym_subset] = STATE(2150),
    [sym_subset2] = STATE(2150),
    [sym_unary_operator] = STATE(2150),
    [sym_binary_operator] = STATE(2150),
    [sym_extract_operator] = STATE(2150),
    [sym_namespace_operator] = STATE(2150),
    [sym_integer] = STATE(2150),
    [sym_complex] = STATE(2150),
    [sym_float] = STATE(2150),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2673),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(2150),
    [sym__expression] = STATE(2150),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__open_brace] = STATE(154),
    [aux_sym_function_definition_repeat1] = STATE(2866),
    [sym_identifier] = ACTIONS(3845),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3867),
    [anon_sym_LT_DASH] = ACTIONS(471),
    [anon_sym_LT_LT_DASH] = ACTIONS(471),
    [anon_sym_COLON_EQ] = ACTIONS(471),
    [anon_sym_DASH_GT] = ACTIONS(473),
    [anon_sym_DASH_GT_GT] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(473),
    [anon_sym_AMP] = ACTIONS(473),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_LT_EQ] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(473),
    [anon_sym_GT_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_STAR] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [aux_sym_binary_operator_token1] = ACTIONS(471),
    [anon_sym_PIPE_GT] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(473),
    [anon_sym_DOLLAR] = ACTIONS(471),
    [anon_sym_AT] = ACTIONS(471),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(4943),
    [sym_next] = ACTIONS(4943),
    [sym_break] = ACTIONS(4943),
    [sym_true] = ACTIONS(4943),
    [sym_false] = ACTIONS(4943),
    [sym_null] = ACTIONS(4943),
    [sym_inf] = ACTIONS(4943),
    [sym_nan] = ACTIONS(4943),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(4943),
    [sym_dot_dot_i] = ACTIONS(4945),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(471),
    [sym__newline] = ACTIONS(471),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(471),
    [sym__external_open_brace] = ACTIONS(3891),
    [sym__external_open_bracket] = ACTIONS(471),
    [sym__external_open_bracket2] = ACTIONS(471),
  },
  [452] = {
    [sym_function_definition] = STATE(2148),
    [sym_if_statement] = STATE(2148),
    [sym_for_statement] = STATE(2148),
    [sym_while_statement] = STATE(2148),
    [sym_repeat_statement] = STATE(2148),
    [sym_braced_expression] = STATE(2148),
    [sym_parenthesized_expression] = STATE(2148),
    [sym_call] = STATE(2148),
    [sym_subset] = STATE(2148),
    [sym_subset2] = STATE(2148),
    [sym_unary_operator] = STATE(2148),
    [sym_binary_operator] = STATE(2148),
    [sym_extract_operator] = STATE(2148),
    [sym_namespace_operator] = STATE(2148),
    [sym_integer] = STATE(2148),
    [sym_complex] = STATE(2148),
    [sym_float] = STATE(2148),
    [sym__hex_literal] = STATE(2739),
    [sym__float_literal] = STATE(2739),
    [sym_string] = STATE(2562),
    [sym__single_quoted_string] = STATE(2738),
    [sym__double_quoted_string] = STATE(2737),
    [sym_na] = STATE(2148),
    [sym__expression] = STATE(2148),
    [sym__string_or_identifier] = STATE(5152),
    [sym__open_parenthesis] = STATE(293),
    [sym__open_brace] = STATE(292),
    [aux_sym_function_definition_repeat1] = STATE(2881),
    [ts_builtin_sym_end] = ACTIONS(765),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(9),
    [anon_sym_function] = ACTIONS(11),
    [anon_sym_EQ] = ACTIONS(767),
    [anon_sym_if] = ACTIONS(13),
    [anon_sym_for] = ACTIONS(15),
    [anon_sym_while] = ACTIONS(17),
    [anon_sym_repeat] = ACTIONS(19),
    [anon_sym_QMARK] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(4576),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_DASH] = ACTIONS(4578),
    [anon_sym_LT_DASH] = ACTIONS(765),
    [anon_sym_LT_LT_DASH] = ACTIONS(765),
    [anon_sym_COLON_EQ] = ACTIONS(765),
    [anon_sym_DASH_GT] = ACTIONS(767),
    [anon_sym_DASH_GT_GT] = ACTIONS(765),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_AMP] = ACTIONS(767),
    [anon_sym_PIPE_PIPE] = ACTIONS(765),
    [anon_sym_AMP_AMP] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(767),
    [anon_sym_LT_EQ] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_GT_EQ] = ACTIONS(765),
    [anon_sym_EQ_EQ] = ACTIONS(765),
    [anon_sym_BANG_EQ] = ACTIONS(765),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(765),
    [anon_sym_STAR_STAR] = ACTIONS(765),
    [anon_sym_CARET] = ACTIONS(765),
    [aux_sym_binary_operator_token1] = ACTIONS(765),
    [anon_sym_PIPE_GT] = ACTIONS(765),
    [anon_sym_COLON] = ACTIONS(767),
    [anon_sym_DOLLAR] = ACTIONS(765),
    [anon_sym_AT] = ACTIONS(765),
    [aux_sym__hex_literal_token1] = ACTIONS(29),
    [sym__number_literal] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE] = ACTIONS(35),
    [sym_return] = ACTIONS(4947),
    [sym_next] = ACTIONS(4947),
    [sym_break] = ACTIONS(4947),
    [sym_true] = ACTIONS(4947),
    [sym_false] = ACTIONS(4947),
    [sym_null] = ACTIONS(4947),
    [sym_inf] = ACTIONS(4947),
    [sym_nan] = ACTIONS(4947),
    [anon_sym_NA] = ACTIONS(39),
    [anon_sym_NA_integer_] = ACTIONS(39),
    [anon_sym_NA_real_] = ACTIONS(39),
    [anon_sym_NA_complex_] = ACTIONS(39),
    [anon_sym_NA_character_] = ACTIONS(39),
    [sym_dots] = ACTIONS(4947),
    [sym_dot_dot_i] = ACTIONS(4949),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(765),
    [sym__semicolon] = ACTIONS(765),
    [sym__raw_string_literal] = ACTIONS(45),
    [sym__external_open_parenthesis] = ACTIONS(47),
    [sym__external_open_brace] = ACTIONS(49),
    [sym__external_open_bracket] = ACTIONS(765),
    [sym__external_open_bracket2] = ACTIONS(765),
  },
  [453] = {
    [sym_function_definition] = STATE(2133),
    [sym_if_statement] = STATE(2133),
    [sym_for_statement] = STATE(2133),
    [sym_while_statement] = STATE(2133),
    [sym_repeat_statement] = STATE(2133),
    [sym_braced_expression] = STATE(2133),
    [sym_parenthesized_expression] = STATE(2133),
    [sym_call] = STATE(2133),
    [sym_subset] = STATE(2133),
    [sym_subset2] = STATE(2133),
    [sym_unary_operator] = STATE(2133),
    [sym_binary_operator] = STATE(2133),
    [sym_extract_operator] = STATE(2133),
    [sym_namespace_operator] = STATE(2133),
    [sym_integer] = STATE(2133),
    [sym_complex] = STATE(2133),
    [sym_float] = STATE(2133),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2673),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(2133),
    [sym__expression] = STATE(2133),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__open_brace] = STATE(154),
    [aux_sym_function_definition_repeat1] = STATE(451),
    [sym_identifier] = ACTIONS(3845),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_EQ] = ACTIONS(463),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3867),
    [anon_sym_LT_DASH] = ACTIONS(461),
    [anon_sym_LT_LT_DASH] = ACTIONS(461),
    [anon_sym_COLON_EQ] = ACTIONS(461),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_DASH_GT_GT] = ACTIONS(461),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_PIPE_PIPE] = ACTIONS(461),
    [anon_sym_AMP_AMP] = ACTIONS(461),
    [anon_sym_LT] = ACTIONS(463),
    [anon_sym_LT_EQ] = ACTIONS(461),
    [anon_sym_GT] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(461),
    [anon_sym_EQ_EQ] = ACTIONS(461),
    [anon_sym_BANG_EQ] = ACTIONS(461),
    [anon_sym_STAR] = ACTIONS(463),
    [anon_sym_SLASH] = ACTIONS(461),
    [anon_sym_STAR_STAR] = ACTIONS(461),
    [anon_sym_CARET] = ACTIONS(461),
    [aux_sym_binary_operator_token1] = ACTIONS(461),
    [anon_sym_PIPE_GT] = ACTIONS(461),
    [anon_sym_COLON] = ACTIONS(463),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_AT] = ACTIONS(461),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(4951),
    [sym_next] = ACTIONS(4951),
    [sym_break] = ACTIONS(4951),
    [sym_true] = ACTIONS(4951),
    [sym_false] = ACTIONS(4951),
    [sym_null] = ACTIONS(4951),
    [sym_inf] = ACTIONS(4951),
    [sym_nan] = ACTIONS(4951),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(4951),
    [sym_dot_dot_i] = ACTIONS(4953),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(461),
    [sym__newline] = ACTIONS(4955),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(461),
    [sym__external_open_brace] = ACTIONS(3891),
    [sym__external_open_bracket] = ACTIONS(461),
    [sym__external_open_bracket2] = ACTIONS(461),
  },
  [454] = {
    [sym_function_definition] = STATE(2132),
    [sym_if_statement] = STATE(2132),
    [sym_for_statement] = STATE(2132),
    [sym_while_statement] = STATE(2132),
    [sym_repeat_statement] = STATE(2132),
    [sym_braced_expression] = STATE(2132),
    [sym_parenthesized_expression] = STATE(2132),
    [sym_call] = STATE(2132),
    [sym_subset] = STATE(2132),
    [sym_subset2] = STATE(2132),
    [sym_unary_operator] = STATE(2132),
    [sym_binary_operator] = STATE(2132),
    [sym_extract_operator] = STATE(2132),
    [sym_namespace_operator] = STATE(2132),
    [sym_integer] = STATE(2132),
    [sym_complex] = STATE(2132),
    [sym_float] = STATE(2132),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2673),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(2132),
    [sym__expression] = STATE(2132),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__open_brace] = STATE(154),
    [aux_sym_function_definition_repeat1] = STATE(2866),
    [sym_identifier] = ACTIONS(3845),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_EQ] = ACTIONS(455),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3867),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [anon_sym_LT_LT_DASH] = ACTIONS(453),
    [anon_sym_COLON_EQ] = ACTIONS(453),
    [anon_sym_DASH_GT] = ACTIONS(455),
    [anon_sym_DASH_GT_GT] = ACTIONS(453),
    [anon_sym_PIPE] = ACTIONS(455),
    [anon_sym_AMP] = ACTIONS(455),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(455),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_GT] = ACTIONS(455),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(453),
    [anon_sym_STAR] = ACTIONS(455),
    [anon_sym_SLASH] = ACTIONS(453),
    [anon_sym_STAR_STAR] = ACTIONS(453),
    [anon_sym_CARET] = ACTIONS(453),
    [aux_sym_binary_operator_token1] = ACTIONS(453),
    [anon_sym_PIPE_GT] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(455),
    [anon_sym_DOLLAR] = ACTIONS(453),
    [anon_sym_AT] = ACTIONS(453),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(4957),
    [sym_next] = ACTIONS(4957),
    [sym_break] = ACTIONS(4957),
    [sym_true] = ACTIONS(4957),
    [sym_false] = ACTIONS(4957),
    [sym_null] = ACTIONS(4957),
    [sym_inf] = ACTIONS(4957),
    [sym_nan] = ACTIONS(4957),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(4957),
    [sym_dot_dot_i] = ACTIONS(4959),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(453),
    [sym__newline] = ACTIONS(453),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(453),
    [sym__external_open_brace] = ACTIONS(3891),
    [sym__external_open_bracket] = ACTIONS(453),
    [sym__external_open_bracket2] = ACTIONS(453),
  },
  [455] = {
    [sym_function_definition] = STATE(2124),
    [sym_if_statement] = STATE(2124),
    [sym_for_statement] = STATE(2124),
    [sym_while_statement] = STATE(2124),
    [sym_repeat_statement] = STATE(2124),
    [sym_braced_expression] = STATE(2124),
    [sym_parenthesized_expression] = STATE(2124),
    [sym_call] = STATE(2124),
    [sym_subset] = STATE(2124),
    [sym_subset2] = STATE(2124),
    [sym_unary_operator] = STATE(2124),
    [sym_binary_operator] = STATE(2124),
    [sym_extract_operator] = STATE(2124),
    [sym_namespace_operator] = STATE(2124),
    [sym_integer] = STATE(2124),
    [sym_complex] = STATE(2124),
    [sym_float] = STATE(2124),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2673),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(2124),
    [sym__expression] = STATE(2124),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__open_brace] = STATE(154),
    [aux_sym_function_definition_repeat1] = STATE(2866),
    [sym_identifier] = ACTIONS(3845),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_EQ] = ACTIONS(399),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3867),
    [anon_sym_LT_DASH] = ACTIONS(397),
    [anon_sym_LT_LT_DASH] = ACTIONS(397),
    [anon_sym_COLON_EQ] = ACTIONS(397),
    [anon_sym_DASH_GT] = ACTIONS(399),
    [anon_sym_DASH_GT_GT] = ACTIONS(397),
    [anon_sym_PIPE] = ACTIONS(399),
    [anon_sym_AMP] = ACTIONS(399),
    [anon_sym_PIPE_PIPE] = ACTIONS(397),
    [anon_sym_AMP_AMP] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(399),
    [anon_sym_LT_EQ] = ACTIONS(397),
    [anon_sym_GT] = ACTIONS(399),
    [anon_sym_GT_EQ] = ACTIONS(397),
    [anon_sym_EQ_EQ] = ACTIONS(397),
    [anon_sym_BANG_EQ] = ACTIONS(397),
    [anon_sym_STAR] = ACTIONS(399),
    [anon_sym_SLASH] = ACTIONS(397),
    [anon_sym_STAR_STAR] = ACTIONS(397),
    [anon_sym_CARET] = ACTIONS(397),
    [aux_sym_binary_operator_token1] = ACTIONS(397),
    [anon_sym_PIPE_GT] = ACTIONS(397),
    [anon_sym_COLON] = ACTIONS(399),
    [anon_sym_DOLLAR] = ACTIONS(397),
    [anon_sym_AT] = ACTIONS(397),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(4961),
    [sym_next] = ACTIONS(4961),
    [sym_break] = ACTIONS(4961),
    [sym_true] = ACTIONS(4961),
    [sym_false] = ACTIONS(4961),
    [sym_null] = ACTIONS(4961),
    [sym_inf] = ACTIONS(4961),
    [sym_nan] = ACTIONS(4961),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(4961),
    [sym_dot_dot_i] = ACTIONS(4963),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(397),
    [sym__newline] = ACTIONS(397),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(397),
    [sym__external_open_brace] = ACTIONS(3891),
    [sym__external_open_bracket] = ACTIONS(397),
    [sym__external_open_bracket2] = ACTIONS(397),
  },
  [456] = {
    [sym_function_definition] = STATE(2121),
    [sym_if_statement] = STATE(2121),
    [sym_for_statement] = STATE(2121),
    [sym_while_statement] = STATE(2121),
    [sym_repeat_statement] = STATE(2121),
    [sym_braced_expression] = STATE(2121),
    [sym_parenthesized_expression] = STATE(2121),
    [sym_call] = STATE(2121),
    [sym_subset] = STATE(2121),
    [sym_subset2] = STATE(2121),
    [sym_unary_operator] = STATE(2121),
    [sym_binary_operator] = STATE(2121),
    [sym_extract_operator] = STATE(2121),
    [sym_namespace_operator] = STATE(2121),
    [sym_integer] = STATE(2121),
    [sym_complex] = STATE(2121),
    [sym_float] = STATE(2121),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2673),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(2121),
    [sym__expression] = STATE(2121),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__open_brace] = STATE(154),
    [aux_sym_function_definition_repeat1] = STATE(454),
    [sym_identifier] = ACTIONS(3845),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_EQ] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3867),
    [anon_sym_LT_DASH] = ACTIONS(387),
    [anon_sym_LT_LT_DASH] = ACTIONS(387),
    [anon_sym_COLON_EQ] = ACTIONS(387),
    [anon_sym_DASH_GT] = ACTIONS(389),
    [anon_sym_DASH_GT_GT] = ACTIONS(387),
    [anon_sym_PIPE] = ACTIONS(389),
    [anon_sym_AMP] = ACTIONS(389),
    [anon_sym_PIPE_PIPE] = ACTIONS(387),
    [anon_sym_AMP_AMP] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(389),
    [anon_sym_LT_EQ] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(389),
    [anon_sym_GT_EQ] = ACTIONS(387),
    [anon_sym_EQ_EQ] = ACTIONS(387),
    [anon_sym_BANG_EQ] = ACTIONS(387),
    [anon_sym_STAR] = ACTIONS(389),
    [anon_sym_SLASH] = ACTIONS(387),
    [anon_sym_STAR_STAR] = ACTIONS(387),
    [anon_sym_CARET] = ACTIONS(387),
    [aux_sym_binary_operator_token1] = ACTIONS(387),
    [anon_sym_PIPE_GT] = ACTIONS(387),
    [anon_sym_COLON] = ACTIONS(389),
    [anon_sym_DOLLAR] = ACTIONS(387),
    [anon_sym_AT] = ACTIONS(387),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(4965),
    [sym_next] = ACTIONS(4965),
    [sym_break] = ACTIONS(4965),
    [sym_true] = ACTIONS(4965),
    [sym_false] = ACTIONS(4965),
    [sym_null] = ACTIONS(4965),
    [sym_inf] = ACTIONS(4965),
    [sym_nan] = ACTIONS(4965),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(4965),
    [sym_dot_dot_i] = ACTIONS(4967),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(387),
    [sym__newline] = ACTIONS(4969),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(387),
    [sym__external_open_brace] = ACTIONS(3891),
    [sym__external_open_bracket] = ACTIONS(387),
    [sym__external_open_bracket2] = ACTIONS(387),
  },
  [457] = {
    [sym_function_definition] = STATE(4641),
    [sym_if_statement] = STATE(4641),
    [sym_for_statement] = STATE(4641),
    [sym_while_statement] = STATE(4641),
    [sym_repeat_statement] = STATE(4641),
    [sym_braced_expression] = STATE(4641),
    [sym_parenthesized_expression] = STATE(4641),
    [sym_call] = STATE(4641),
    [sym_subset] = STATE(4641),
    [sym_subset2] = STATE(4641),
    [sym_unary_operator] = STATE(4641),
    [sym_binary_operator] = STATE(4641),
    [sym_extract_operator] = STATE(4641),
    [sym_namespace_operator] = STATE(4641),
    [sym_integer] = STATE(4641),
    [sym_complex] = STATE(4641),
    [sym_float] = STATE(4641),
    [sym__hex_literal] = STATE(4690),
    [sym__float_literal] = STATE(4690),
    [sym_string] = STATE(4689),
    [sym__single_quoted_string] = STATE(4684),
    [sym__double_quoted_string] = STATE(4691),
    [sym_na] = STATE(4641),
    [sym__expression] = STATE(4641),
    [sym__string_or_identifier] = STATE(5155),
    [sym__open_parenthesis] = STATE(402),
    [sym__open_brace] = STATE(153),
    [aux_sym_function_definition_repeat1] = STATE(468),
    [sym_identifier] = ACTIONS(4590),
    [anon_sym_BSLASH] = ACTIONS(4592),
    [anon_sym_function] = ACTIONS(4594),
    [anon_sym_EQ] = ACTIONS(379),
    [anon_sym_if] = ACTIONS(4596),
    [anon_sym_for] = ACTIONS(4598),
    [anon_sym_while] = ACTIONS(4600),
    [anon_sym_repeat] = ACTIONS(4602),
    [anon_sym_QMARK] = ACTIONS(4604),
    [anon_sym_TILDE] = ACTIONS(4606),
    [anon_sym_BANG] = ACTIONS(4608),
    [anon_sym_PLUS] = ACTIONS(4610),
    [anon_sym_DASH] = ACTIONS(4612),
    [anon_sym_LT_DASH] = ACTIONS(377),
    [anon_sym_LT_LT_DASH] = ACTIONS(377),
    [anon_sym_COLON_EQ] = ACTIONS(377),
    [anon_sym_DASH_GT] = ACTIONS(379),
    [anon_sym_DASH_GT_GT] = ACTIONS(377),
    [anon_sym_PIPE] = ACTIONS(379),
    [anon_sym_AMP] = ACTIONS(379),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_LT] = ACTIONS(379),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(379),
    [anon_sym_GT_EQ] = ACTIONS(377),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(379),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_STAR_STAR] = ACTIONS(377),
    [anon_sym_CARET] = ACTIONS(377),
    [aux_sym_binary_operator_token1] = ACTIONS(377),
    [anon_sym_PIPE_GT] = ACTIONS(377),
    [anon_sym_COLON] = ACTIONS(379),
    [anon_sym_DOLLAR] = ACTIONS(377),
    [anon_sym_AT] = ACTIONS(377),
    [aux_sym__hex_literal_token1] = ACTIONS(4614),
    [sym__number_literal] = ACTIONS(4616),
    [anon_sym_SQUOTE] = ACTIONS(4618),
    [anon_sym_DQUOTE] = ACTIONS(4620),
    [sym_return] = ACTIONS(4971),
    [sym_next] = ACTIONS(4971),
    [sym_break] = ACTIONS(4971),
    [sym_true] = ACTIONS(4971),
    [sym_false] = ACTIONS(4971),
    [sym_null] = ACTIONS(4971),
    [sym_inf] = ACTIONS(4971),
    [sym_nan] = ACTIONS(4971),
    [anon_sym_NA] = ACTIONS(4624),
    [anon_sym_NA_integer_] = ACTIONS(4624),
    [anon_sym_NA_real_] = ACTIONS(4624),
    [anon_sym_NA_complex_] = ACTIONS(4624),
    [anon_sym_NA_character_] = ACTIONS(4624),
    [sym_dots] = ACTIONS(4971),
    [sym_dot_dot_i] = ACTIONS(4973),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(377),
    [sym__newline] = ACTIONS(4975),
    [sym__raw_string_literal] = ACTIONS(4630),
    [sym__external_open_parenthesis] = ACTIONS(4632),
    [sym__external_close_parenthesis] = ACTIONS(377),
    [sym__external_open_brace] = ACTIONS(4634),
    [sym__external_open_bracket] = ACTIONS(377),
    [sym__external_open_bracket2] = ACTIONS(377),
  },
  [458] = {
    [sym_function_definition] = STATE(2112),
    [sym_if_statement] = STATE(2112),
    [sym_for_statement] = STATE(2112),
    [sym_while_statement] = STATE(2112),
    [sym_repeat_statement] = STATE(2112),
    [sym_braced_expression] = STATE(2112),
    [sym_parenthesized_expression] = STATE(2112),
    [sym_call] = STATE(2112),
    [sym_subset] = STATE(2112),
    [sym_subset2] = STATE(2112),
    [sym_unary_operator] = STATE(2112),
    [sym_binary_operator] = STATE(2112),
    [sym_extract_operator] = STATE(2112),
    [sym_namespace_operator] = STATE(2112),
    [sym_integer] = STATE(2112),
    [sym_complex] = STATE(2112),
    [sym_float] = STATE(2112),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2673),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(2112),
    [sym__expression] = STATE(2112),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__open_brace] = STATE(154),
    [aux_sym_function_definition_repeat1] = STATE(2866),
    [sym_identifier] = ACTIONS(3845),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_EQ] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3867),
    [anon_sym_LT_DASH] = ACTIONS(369),
    [anon_sym_LT_LT_DASH] = ACTIONS(369),
    [anon_sym_COLON_EQ] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(371),
    [anon_sym_DASH_GT_GT] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(371),
    [anon_sym_AMP] = ACTIONS(371),
    [anon_sym_PIPE_PIPE] = ACTIONS(369),
    [anon_sym_AMP_AMP] = ACTIONS(369),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_LT_EQ] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_EQ] = ACTIONS(369),
    [anon_sym_EQ_EQ] = ACTIONS(369),
    [anon_sym_BANG_EQ] = ACTIONS(369),
    [anon_sym_STAR] = ACTIONS(371),
    [anon_sym_SLASH] = ACTIONS(369),
    [anon_sym_STAR_STAR] = ACTIONS(369),
    [anon_sym_CARET] = ACTIONS(369),
    [aux_sym_binary_operator_token1] = ACTIONS(369),
    [anon_sym_PIPE_GT] = ACTIONS(369),
    [anon_sym_COLON] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(369),
    [anon_sym_AT] = ACTIONS(369),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(4977),
    [sym_next] = ACTIONS(4977),
    [sym_break] = ACTIONS(4977),
    [sym_true] = ACTIONS(4977),
    [sym_false] = ACTIONS(4977),
    [sym_null] = ACTIONS(4977),
    [sym_inf] = ACTIONS(4977),
    [sym_nan] = ACTIONS(4977),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(4977),
    [sym_dot_dot_i] = ACTIONS(4979),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(369),
    [sym__newline] = ACTIONS(369),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(369),
    [sym__external_open_brace] = ACTIONS(3891),
    [sym__external_open_bracket] = ACTIONS(369),
    [sym__external_open_bracket2] = ACTIONS(369),
  },
  [459] = {
    [sym_function_definition] = STATE(4632),
    [sym_if_statement] = STATE(4632),
    [sym_for_statement] = STATE(4632),
    [sym_while_statement] = STATE(4632),
    [sym_repeat_statement] = STATE(4632),
    [sym_braced_expression] = STATE(4632),
    [sym_parenthesized_expression] = STATE(4632),
    [sym_call] = STATE(4632),
    [sym_subset] = STATE(4632),
    [sym_subset2] = STATE(4632),
    [sym_unary_operator] = STATE(4632),
    [sym_binary_operator] = STATE(4632),
    [sym_extract_operator] = STATE(4632),
    [sym_namespace_operator] = STATE(4632),
    [sym_integer] = STATE(4632),
    [sym_complex] = STATE(4632),
    [sym_float] = STATE(4632),
    [sym__hex_literal] = STATE(4690),
    [sym__float_literal] = STATE(4690),
    [sym_string] = STATE(4689),
    [sym__single_quoted_string] = STATE(4684),
    [sym__double_quoted_string] = STATE(4691),
    [sym_na] = STATE(4632),
    [sym__expression] = STATE(4632),
    [sym__string_or_identifier] = STATE(5155),
    [sym__open_parenthesis] = STATE(402),
    [sym__open_brace] = STATE(153),
    [aux_sym_function_definition_repeat1] = STATE(2866),
    [sym_identifier] = ACTIONS(4590),
    [anon_sym_BSLASH] = ACTIONS(4592),
    [anon_sym_function] = ACTIONS(4594),
    [anon_sym_EQ] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(4596),
    [anon_sym_for] = ACTIONS(4598),
    [anon_sym_while] = ACTIONS(4600),
    [anon_sym_repeat] = ACTIONS(4602),
    [anon_sym_QMARK] = ACTIONS(4604),
    [anon_sym_TILDE] = ACTIONS(4606),
    [anon_sym_BANG] = ACTIONS(4608),
    [anon_sym_PLUS] = ACTIONS(4610),
    [anon_sym_DASH] = ACTIONS(4612),
    [anon_sym_LT_DASH] = ACTIONS(369),
    [anon_sym_LT_LT_DASH] = ACTIONS(369),
    [anon_sym_COLON_EQ] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(371),
    [anon_sym_DASH_GT_GT] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(371),
    [anon_sym_AMP] = ACTIONS(371),
    [anon_sym_PIPE_PIPE] = ACTIONS(369),
    [anon_sym_AMP_AMP] = ACTIONS(369),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_LT_EQ] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_EQ] = ACTIONS(369),
    [anon_sym_EQ_EQ] = ACTIONS(369),
    [anon_sym_BANG_EQ] = ACTIONS(369),
    [anon_sym_STAR] = ACTIONS(371),
    [anon_sym_SLASH] = ACTIONS(369),
    [anon_sym_STAR_STAR] = ACTIONS(369),
    [anon_sym_CARET] = ACTIONS(369),
    [aux_sym_binary_operator_token1] = ACTIONS(369),
    [anon_sym_PIPE_GT] = ACTIONS(369),
    [anon_sym_COLON] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(369),
    [anon_sym_AT] = ACTIONS(369),
    [aux_sym__hex_literal_token1] = ACTIONS(4614),
    [sym__number_literal] = ACTIONS(4616),
    [anon_sym_SQUOTE] = ACTIONS(4618),
    [anon_sym_DQUOTE] = ACTIONS(4620),
    [sym_return] = ACTIONS(4981),
    [sym_next] = ACTIONS(4981),
    [sym_break] = ACTIONS(4981),
    [sym_true] = ACTIONS(4981),
    [sym_false] = ACTIONS(4981),
    [sym_null] = ACTIONS(4981),
    [sym_inf] = ACTIONS(4981),
    [sym_nan] = ACTIONS(4981),
    [anon_sym_NA] = ACTIONS(4624),
    [anon_sym_NA_integer_] = ACTIONS(4624),
    [anon_sym_NA_real_] = ACTIONS(4624),
    [anon_sym_NA_complex_] = ACTIONS(4624),
    [anon_sym_NA_character_] = ACTIONS(4624),
    [sym_dots] = ACTIONS(4981),
    [sym_dot_dot_i] = ACTIONS(4983),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(369),
    [sym__newline] = ACTIONS(4628),
    [sym__raw_string_literal] = ACTIONS(4630),
    [sym__external_open_parenthesis] = ACTIONS(4632),
    [sym__external_close_parenthesis] = ACTIONS(369),
    [sym__external_open_brace] = ACTIONS(4634),
    [sym__external_open_bracket] = ACTIONS(369),
    [sym__external_open_bracket2] = ACTIONS(369),
  },
  [460] = {
    [sym_function_definition] = STATE(1977),
    [sym_if_statement] = STATE(1977),
    [sym_for_statement] = STATE(1977),
    [sym_while_statement] = STATE(1977),
    [sym_repeat_statement] = STATE(1977),
    [sym_braced_expression] = STATE(1977),
    [sym_parenthesized_expression] = STATE(1977),
    [sym_call] = STATE(1977),
    [sym_subset] = STATE(1977),
    [sym_subset2] = STATE(1977),
    [sym_unary_operator] = STATE(1977),
    [sym_binary_operator] = STATE(1977),
    [sym_extract_operator] = STATE(1977),
    [sym_namespace_operator] = STATE(1977),
    [sym_integer] = STATE(1977),
    [sym_complex] = STATE(1977),
    [sym_float] = STATE(1977),
    [sym__hex_literal] = STATE(2739),
    [sym__float_literal] = STATE(2739),
    [sym_string] = STATE(2562),
    [sym__single_quoted_string] = STATE(2738),
    [sym__double_quoted_string] = STATE(2737),
    [sym_na] = STATE(1977),
    [sym__expression] = STATE(1977),
    [sym__string_or_identifier] = STATE(5152),
    [sym__open_parenthesis] = STATE(293),
    [sym__open_brace] = STATE(292),
    [aux_sym_function_definition_repeat1] = STATE(452),
    [ts_builtin_sym_end] = ACTIONS(263),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(9),
    [anon_sym_function] = ACTIONS(11),
    [anon_sym_EQ] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(13),
    [anon_sym_for] = ACTIONS(15),
    [anon_sym_while] = ACTIONS(17),
    [anon_sym_repeat] = ACTIONS(19),
    [anon_sym_QMARK] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(4576),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_DASH] = ACTIONS(4578),
    [anon_sym_LT_DASH] = ACTIONS(263),
    [anon_sym_LT_LT_DASH] = ACTIONS(263),
    [anon_sym_COLON_EQ] = ACTIONS(263),
    [anon_sym_DASH_GT] = ACTIONS(265),
    [anon_sym_DASH_GT_GT] = ACTIONS(263),
    [anon_sym_PIPE] = ACTIONS(265),
    [anon_sym_AMP] = ACTIONS(265),
    [anon_sym_PIPE_PIPE] = ACTIONS(263),
    [anon_sym_AMP_AMP] = ACTIONS(263),
    [anon_sym_LT] = ACTIONS(265),
    [anon_sym_LT_EQ] = ACTIONS(263),
    [anon_sym_GT] = ACTIONS(265),
    [anon_sym_GT_EQ] = ACTIONS(263),
    [anon_sym_EQ_EQ] = ACTIONS(263),
    [anon_sym_BANG_EQ] = ACTIONS(263),
    [anon_sym_STAR] = ACTIONS(265),
    [anon_sym_SLASH] = ACTIONS(263),
    [anon_sym_STAR_STAR] = ACTIONS(263),
    [anon_sym_CARET] = ACTIONS(263),
    [aux_sym_binary_operator_token1] = ACTIONS(263),
    [anon_sym_PIPE_GT] = ACTIONS(263),
    [anon_sym_COLON] = ACTIONS(265),
    [anon_sym_DOLLAR] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(263),
    [aux_sym__hex_literal_token1] = ACTIONS(29),
    [sym__number_literal] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE] = ACTIONS(35),
    [sym_return] = ACTIONS(4985),
    [sym_next] = ACTIONS(4985),
    [sym_break] = ACTIONS(4985),
    [sym_true] = ACTIONS(4985),
    [sym_false] = ACTIONS(4985),
    [sym_null] = ACTIONS(4985),
    [sym_inf] = ACTIONS(4985),
    [sym_nan] = ACTIONS(4985),
    [anon_sym_NA] = ACTIONS(39),
    [anon_sym_NA_integer_] = ACTIONS(39),
    [anon_sym_NA_real_] = ACTIONS(39),
    [anon_sym_NA_complex_] = ACTIONS(39),
    [anon_sym_NA_character_] = ACTIONS(39),
    [sym_dots] = ACTIONS(4985),
    [sym_dot_dot_i] = ACTIONS(4987),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4989),
    [sym__semicolon] = ACTIONS(263),
    [sym__raw_string_literal] = ACTIONS(45),
    [sym__external_open_parenthesis] = ACTIONS(47),
    [sym__external_open_brace] = ACTIONS(49),
    [sym__external_open_bracket] = ACTIONS(263),
    [sym__external_open_bracket2] = ACTIONS(263),
  },
  [461] = {
    [sym_function_definition] = STATE(4457),
    [sym_if_statement] = STATE(4457),
    [sym_for_statement] = STATE(4457),
    [sym_while_statement] = STATE(4457),
    [sym_repeat_statement] = STATE(4457),
    [sym_braced_expression] = STATE(4457),
    [sym_parenthesized_expression] = STATE(4457),
    [sym_call] = STATE(4457),
    [sym_subset] = STATE(4457),
    [sym_subset2] = STATE(4457),
    [sym_unary_operator] = STATE(4457),
    [sym_binary_operator] = STATE(4457),
    [sym_extract_operator] = STATE(4457),
    [sym_namespace_operator] = STATE(4457),
    [sym_integer] = STATE(4457),
    [sym_complex] = STATE(4457),
    [sym_float] = STATE(4457),
    [sym__hex_literal] = STATE(4690),
    [sym__float_literal] = STATE(4690),
    [sym_string] = STATE(4689),
    [sym__single_quoted_string] = STATE(4684),
    [sym__double_quoted_string] = STATE(4691),
    [sym_na] = STATE(4457),
    [sym__expression] = STATE(4457),
    [sym__string_or_identifier] = STATE(5155),
    [sym__open_parenthesis] = STATE(402),
    [sym__open_brace] = STATE(153),
    [aux_sym_function_definition_repeat1] = STATE(2866),
    [sym_identifier] = ACTIONS(4590),
    [anon_sym_BSLASH] = ACTIONS(4592),
    [anon_sym_function] = ACTIONS(4594),
    [anon_sym_EQ] = ACTIONS(767),
    [anon_sym_if] = ACTIONS(4596),
    [anon_sym_for] = ACTIONS(4598),
    [anon_sym_while] = ACTIONS(4600),
    [anon_sym_repeat] = ACTIONS(4602),
    [anon_sym_QMARK] = ACTIONS(4604),
    [anon_sym_TILDE] = ACTIONS(4606),
    [anon_sym_BANG] = ACTIONS(4608),
    [anon_sym_PLUS] = ACTIONS(4610),
    [anon_sym_DASH] = ACTIONS(4612),
    [anon_sym_LT_DASH] = ACTIONS(765),
    [anon_sym_LT_LT_DASH] = ACTIONS(765),
    [anon_sym_COLON_EQ] = ACTIONS(765),
    [anon_sym_DASH_GT] = ACTIONS(767),
    [anon_sym_DASH_GT_GT] = ACTIONS(765),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_AMP] = ACTIONS(767),
    [anon_sym_PIPE_PIPE] = ACTIONS(765),
    [anon_sym_AMP_AMP] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(767),
    [anon_sym_LT_EQ] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_GT_EQ] = ACTIONS(765),
    [anon_sym_EQ_EQ] = ACTIONS(765),
    [anon_sym_BANG_EQ] = ACTIONS(765),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(765),
    [anon_sym_STAR_STAR] = ACTIONS(765),
    [anon_sym_CARET] = ACTIONS(765),
    [aux_sym_binary_operator_token1] = ACTIONS(765),
    [anon_sym_PIPE_GT] = ACTIONS(765),
    [anon_sym_COLON] = ACTIONS(767),
    [anon_sym_DOLLAR] = ACTIONS(765),
    [anon_sym_AT] = ACTIONS(765),
    [aux_sym__hex_literal_token1] = ACTIONS(4614),
    [sym__number_literal] = ACTIONS(4616),
    [anon_sym_SQUOTE] = ACTIONS(4618),
    [anon_sym_DQUOTE] = ACTIONS(4620),
    [sym_return] = ACTIONS(4991),
    [sym_next] = ACTIONS(4991),
    [sym_break] = ACTIONS(4991),
    [sym_true] = ACTIONS(4991),
    [sym_false] = ACTIONS(4991),
    [sym_null] = ACTIONS(4991),
    [sym_inf] = ACTIONS(4991),
    [sym_nan] = ACTIONS(4991),
    [anon_sym_NA] = ACTIONS(4624),
    [anon_sym_NA_integer_] = ACTIONS(4624),
    [anon_sym_NA_real_] = ACTIONS(4624),
    [anon_sym_NA_complex_] = ACTIONS(4624),
    [anon_sym_NA_character_] = ACTIONS(4624),
    [sym_dots] = ACTIONS(4991),
    [sym_dot_dot_i] = ACTIONS(4993),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(765),
    [sym__newline] = ACTIONS(4628),
    [sym__raw_string_literal] = ACTIONS(4630),
    [sym__external_open_parenthesis] = ACTIONS(4632),
    [sym__external_close_parenthesis] = ACTIONS(765),
    [sym__external_open_brace] = ACTIONS(4634),
    [sym__external_open_bracket] = ACTIONS(765),
    [sym__external_open_bracket2] = ACTIONS(765),
  },
  [462] = {
    [sym_function_definition] = STATE(4553),
    [sym_if_statement] = STATE(4553),
    [sym_for_statement] = STATE(4553),
    [sym_while_statement] = STATE(4553),
    [sym_repeat_statement] = STATE(4553),
    [sym_braced_expression] = STATE(4553),
    [sym_parenthesized_expression] = STATE(4553),
    [sym_call] = STATE(4553),
    [sym_subset] = STATE(4553),
    [sym_subset2] = STATE(4553),
    [sym_unary_operator] = STATE(4553),
    [sym_binary_operator] = STATE(4553),
    [sym_extract_operator] = STATE(4553),
    [sym_namespace_operator] = STATE(4553),
    [sym_integer] = STATE(4553),
    [sym_complex] = STATE(4553),
    [sym_float] = STATE(4553),
    [sym__hex_literal] = STATE(4690),
    [sym__float_literal] = STATE(4690),
    [sym_string] = STATE(4689),
    [sym__single_quoted_string] = STATE(4684),
    [sym__double_quoted_string] = STATE(4691),
    [sym_na] = STATE(4553),
    [sym__expression] = STATE(4553),
    [sym__string_or_identifier] = STATE(5155),
    [sym__open_parenthesis] = STATE(402),
    [sym__open_brace] = STATE(153),
    [aux_sym_function_definition_repeat1] = STATE(429),
    [sym_identifier] = ACTIONS(4590),
    [anon_sym_BSLASH] = ACTIONS(4592),
    [anon_sym_function] = ACTIONS(4594),
    [anon_sym_EQ] = ACTIONS(543),
    [anon_sym_if] = ACTIONS(4596),
    [anon_sym_for] = ACTIONS(4598),
    [anon_sym_while] = ACTIONS(4600),
    [anon_sym_repeat] = ACTIONS(4602),
    [anon_sym_QMARK] = ACTIONS(4604),
    [anon_sym_TILDE] = ACTIONS(4606),
    [anon_sym_BANG] = ACTIONS(4608),
    [anon_sym_PLUS] = ACTIONS(4610),
    [anon_sym_DASH] = ACTIONS(4612),
    [anon_sym_LT_DASH] = ACTIONS(545),
    [anon_sym_LT_LT_DASH] = ACTIONS(545),
    [anon_sym_COLON_EQ] = ACTIONS(545),
    [anon_sym_DASH_GT] = ACTIONS(543),
    [anon_sym_DASH_GT_GT] = ACTIONS(545),
    [anon_sym_PIPE] = ACTIONS(543),
    [anon_sym_AMP] = ACTIONS(543),
    [anon_sym_PIPE_PIPE] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(543),
    [anon_sym_LT_EQ] = ACTIONS(545),
    [anon_sym_GT] = ACTIONS(543),
    [anon_sym_GT_EQ] = ACTIONS(545),
    [anon_sym_EQ_EQ] = ACTIONS(545),
    [anon_sym_BANG_EQ] = ACTIONS(545),
    [anon_sym_STAR] = ACTIONS(543),
    [anon_sym_SLASH] = ACTIONS(545),
    [anon_sym_STAR_STAR] = ACTIONS(545),
    [anon_sym_CARET] = ACTIONS(545),
    [aux_sym_binary_operator_token1] = ACTIONS(545),
    [anon_sym_PIPE_GT] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(543),
    [anon_sym_DOLLAR] = ACTIONS(545),
    [anon_sym_AT] = ACTIONS(545),
    [aux_sym__hex_literal_token1] = ACTIONS(4614),
    [sym__number_literal] = ACTIONS(4616),
    [anon_sym_SQUOTE] = ACTIONS(4618),
    [anon_sym_DQUOTE] = ACTIONS(4620),
    [sym_return] = ACTIONS(4995),
    [sym_next] = ACTIONS(4995),
    [sym_break] = ACTIONS(4995),
    [sym_true] = ACTIONS(4995),
    [sym_false] = ACTIONS(4995),
    [sym_null] = ACTIONS(4995),
    [sym_inf] = ACTIONS(4995),
    [sym_nan] = ACTIONS(4995),
    [anon_sym_NA] = ACTIONS(4624),
    [anon_sym_NA_integer_] = ACTIONS(4624),
    [anon_sym_NA_real_] = ACTIONS(4624),
    [anon_sym_NA_complex_] = ACTIONS(4624),
    [anon_sym_NA_character_] = ACTIONS(4624),
    [sym_dots] = ACTIONS(4995),
    [sym_dot_dot_i] = ACTIONS(4997),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(545),
    [sym__newline] = ACTIONS(4999),
    [sym__raw_string_literal] = ACTIONS(4630),
    [sym__external_open_parenthesis] = ACTIONS(4632),
    [sym__external_close_parenthesis] = ACTIONS(545),
    [sym__external_open_brace] = ACTIONS(4634),
    [sym__external_open_bracket] = ACTIONS(545),
    [sym__external_open_bracket2] = ACTIONS(545),
  },
  [463] = {
    [sym_function_definition] = STATE(4479),
    [sym_if_statement] = STATE(4479),
    [sym_for_statement] = STATE(4479),
    [sym_while_statement] = STATE(4479),
    [sym_repeat_statement] = STATE(4479),
    [sym_braced_expression] = STATE(4479),
    [sym_parenthesized_expression] = STATE(4479),
    [sym_call] = STATE(4479),
    [sym_subset] = STATE(4479),
    [sym_subset2] = STATE(4479),
    [sym_unary_operator] = STATE(4479),
    [sym_binary_operator] = STATE(4479),
    [sym_extract_operator] = STATE(4479),
    [sym_namespace_operator] = STATE(4479),
    [sym_integer] = STATE(4479),
    [sym_complex] = STATE(4479),
    [sym_float] = STATE(4479),
    [sym__hex_literal] = STATE(4690),
    [sym__float_literal] = STATE(4690),
    [sym_string] = STATE(4689),
    [sym__single_quoted_string] = STATE(4684),
    [sym__double_quoted_string] = STATE(4691),
    [sym_na] = STATE(4479),
    [sym__expression] = STATE(4479),
    [sym__string_or_identifier] = STATE(5155),
    [sym__open_parenthesis] = STATE(402),
    [sym__open_brace] = STATE(153),
    [aux_sym_function_definition_repeat1] = STATE(461),
    [sym_identifier] = ACTIONS(4590),
    [anon_sym_BSLASH] = ACTIONS(4592),
    [anon_sym_function] = ACTIONS(4594),
    [anon_sym_EQ] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(4596),
    [anon_sym_for] = ACTIONS(4598),
    [anon_sym_while] = ACTIONS(4600),
    [anon_sym_repeat] = ACTIONS(4602),
    [anon_sym_QMARK] = ACTIONS(4604),
    [anon_sym_TILDE] = ACTIONS(4606),
    [anon_sym_BANG] = ACTIONS(4608),
    [anon_sym_PLUS] = ACTIONS(4610),
    [anon_sym_DASH] = ACTIONS(4612),
    [anon_sym_LT_DASH] = ACTIONS(263),
    [anon_sym_LT_LT_DASH] = ACTIONS(263),
    [anon_sym_COLON_EQ] = ACTIONS(263),
    [anon_sym_DASH_GT] = ACTIONS(265),
    [anon_sym_DASH_GT_GT] = ACTIONS(263),
    [anon_sym_PIPE] = ACTIONS(265),
    [anon_sym_AMP] = ACTIONS(265),
    [anon_sym_PIPE_PIPE] = ACTIONS(263),
    [anon_sym_AMP_AMP] = ACTIONS(263),
    [anon_sym_LT] = ACTIONS(265),
    [anon_sym_LT_EQ] = ACTIONS(263),
    [anon_sym_GT] = ACTIONS(265),
    [anon_sym_GT_EQ] = ACTIONS(263),
    [anon_sym_EQ_EQ] = ACTIONS(263),
    [anon_sym_BANG_EQ] = ACTIONS(263),
    [anon_sym_STAR] = ACTIONS(265),
    [anon_sym_SLASH] = ACTIONS(263),
    [anon_sym_STAR_STAR] = ACTIONS(263),
    [anon_sym_CARET] = ACTIONS(263),
    [aux_sym_binary_operator_token1] = ACTIONS(263),
    [anon_sym_PIPE_GT] = ACTIONS(263),
    [anon_sym_COLON] = ACTIONS(265),
    [anon_sym_DOLLAR] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(263),
    [aux_sym__hex_literal_token1] = ACTIONS(4614),
    [sym__number_literal] = ACTIONS(4616),
    [anon_sym_SQUOTE] = ACTIONS(4618),
    [anon_sym_DQUOTE] = ACTIONS(4620),
    [sym_return] = ACTIONS(5001),
    [sym_next] = ACTIONS(5001),
    [sym_break] = ACTIONS(5001),
    [sym_true] = ACTIONS(5001),
    [sym_false] = ACTIONS(5001),
    [sym_null] = ACTIONS(5001),
    [sym_inf] = ACTIONS(5001),
    [sym_nan] = ACTIONS(5001),
    [anon_sym_NA] = ACTIONS(4624),
    [anon_sym_NA_integer_] = ACTIONS(4624),
    [anon_sym_NA_real_] = ACTIONS(4624),
    [anon_sym_NA_complex_] = ACTIONS(4624),
    [anon_sym_NA_character_] = ACTIONS(4624),
    [sym_dots] = ACTIONS(5001),
    [sym_dot_dot_i] = ACTIONS(5003),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(263),
    [sym__newline] = ACTIONS(5005),
    [sym__raw_string_literal] = ACTIONS(4630),
    [sym__external_open_parenthesis] = ACTIONS(4632),
    [sym__external_close_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(4634),
    [sym__external_open_bracket] = ACTIONS(263),
    [sym__external_open_bracket2] = ACTIONS(263),
  },
  [464] = {
    [sym_function_definition] = STATE(2050),
    [sym_if_statement] = STATE(2050),
    [sym_for_statement] = STATE(2050),
    [sym_while_statement] = STATE(2050),
    [sym_repeat_statement] = STATE(2050),
    [sym_braced_expression] = STATE(2050),
    [sym_parenthesized_expression] = STATE(2050),
    [sym_call] = STATE(2050),
    [sym_subset] = STATE(2050),
    [sym_subset2] = STATE(2050),
    [sym_unary_operator] = STATE(2050),
    [sym_binary_operator] = STATE(2050),
    [sym_extract_operator] = STATE(2050),
    [sym_namespace_operator] = STATE(2050),
    [sym_integer] = STATE(2050),
    [sym_complex] = STATE(2050),
    [sym_float] = STATE(2050),
    [sym__hex_literal] = STATE(2739),
    [sym__float_literal] = STATE(2739),
    [sym_string] = STATE(2562),
    [sym__single_quoted_string] = STATE(2738),
    [sym__double_quoted_string] = STATE(2737),
    [sym_na] = STATE(2050),
    [sym__expression] = STATE(2050),
    [sym__string_or_identifier] = STATE(5152),
    [sym__open_parenthesis] = STATE(293),
    [sym__open_brace] = STATE(292),
    [aux_sym_function_definition_repeat1] = STATE(2881),
    [ts_builtin_sym_end] = ACTIONS(369),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(9),
    [anon_sym_function] = ACTIONS(11),
    [anon_sym_EQ] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(13),
    [anon_sym_for] = ACTIONS(15),
    [anon_sym_while] = ACTIONS(17),
    [anon_sym_repeat] = ACTIONS(19),
    [anon_sym_QMARK] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(4576),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_DASH] = ACTIONS(4578),
    [anon_sym_LT_DASH] = ACTIONS(369),
    [anon_sym_LT_LT_DASH] = ACTIONS(369),
    [anon_sym_COLON_EQ] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(371),
    [anon_sym_DASH_GT_GT] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(371),
    [anon_sym_AMP] = ACTIONS(371),
    [anon_sym_PIPE_PIPE] = ACTIONS(369),
    [anon_sym_AMP_AMP] = ACTIONS(369),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_LT_EQ] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_EQ] = ACTIONS(369),
    [anon_sym_EQ_EQ] = ACTIONS(369),
    [anon_sym_BANG_EQ] = ACTIONS(369),
    [anon_sym_STAR] = ACTIONS(371),
    [anon_sym_SLASH] = ACTIONS(369),
    [anon_sym_STAR_STAR] = ACTIONS(369),
    [anon_sym_CARET] = ACTIONS(369),
    [aux_sym_binary_operator_token1] = ACTIONS(369),
    [anon_sym_PIPE_GT] = ACTIONS(369),
    [anon_sym_COLON] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(369),
    [anon_sym_AT] = ACTIONS(369),
    [aux_sym__hex_literal_token1] = ACTIONS(29),
    [sym__number_literal] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE] = ACTIONS(35),
    [sym_return] = ACTIONS(5007),
    [sym_next] = ACTIONS(5007),
    [sym_break] = ACTIONS(5007),
    [sym_true] = ACTIONS(5007),
    [sym_false] = ACTIONS(5007),
    [sym_null] = ACTIONS(5007),
    [sym_inf] = ACTIONS(5007),
    [sym_nan] = ACTIONS(5007),
    [anon_sym_NA] = ACTIONS(39),
    [anon_sym_NA_integer_] = ACTIONS(39),
    [anon_sym_NA_real_] = ACTIONS(39),
    [anon_sym_NA_complex_] = ACTIONS(39),
    [anon_sym_NA_character_] = ACTIONS(39),
    [sym_dots] = ACTIONS(5007),
    [sym_dot_dot_i] = ACTIONS(5009),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(369),
    [sym__semicolon] = ACTIONS(369),
    [sym__raw_string_literal] = ACTIONS(45),
    [sym__external_open_parenthesis] = ACTIONS(47),
    [sym__external_open_brace] = ACTIONS(49),
    [sym__external_open_bracket] = ACTIONS(369),
    [sym__external_open_bracket2] = ACTIONS(369),
  },
  [465] = {
    [sym_function_definition] = STATE(2145),
    [sym_if_statement] = STATE(2145),
    [sym_for_statement] = STATE(2145),
    [sym_while_statement] = STATE(2145),
    [sym_repeat_statement] = STATE(2145),
    [sym_braced_expression] = STATE(2145),
    [sym_parenthesized_expression] = STATE(2145),
    [sym_call] = STATE(2145),
    [sym_subset] = STATE(2145),
    [sym_subset2] = STATE(2145),
    [sym_unary_operator] = STATE(2145),
    [sym_binary_operator] = STATE(2145),
    [sym_extract_operator] = STATE(2145),
    [sym_namespace_operator] = STATE(2145),
    [sym_integer] = STATE(2145),
    [sym_complex] = STATE(2145),
    [sym_float] = STATE(2145),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2673),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(2145),
    [sym__expression] = STATE(2145),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__open_brace] = STATE(154),
    [aux_sym_function_definition_repeat1] = STATE(469),
    [sym_identifier] = ACTIONS(3845),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_EQ] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3867),
    [anon_sym_LT_DASH] = ACTIONS(263),
    [anon_sym_LT_LT_DASH] = ACTIONS(263),
    [anon_sym_COLON_EQ] = ACTIONS(263),
    [anon_sym_DASH_GT] = ACTIONS(265),
    [anon_sym_DASH_GT_GT] = ACTIONS(263),
    [anon_sym_PIPE] = ACTIONS(265),
    [anon_sym_AMP] = ACTIONS(265),
    [anon_sym_PIPE_PIPE] = ACTIONS(263),
    [anon_sym_AMP_AMP] = ACTIONS(263),
    [anon_sym_LT] = ACTIONS(265),
    [anon_sym_LT_EQ] = ACTIONS(263),
    [anon_sym_GT] = ACTIONS(265),
    [anon_sym_GT_EQ] = ACTIONS(263),
    [anon_sym_EQ_EQ] = ACTIONS(263),
    [anon_sym_BANG_EQ] = ACTIONS(263),
    [anon_sym_STAR] = ACTIONS(265),
    [anon_sym_SLASH] = ACTIONS(263),
    [anon_sym_STAR_STAR] = ACTIONS(263),
    [anon_sym_CARET] = ACTIONS(263),
    [aux_sym_binary_operator_token1] = ACTIONS(263),
    [anon_sym_PIPE_GT] = ACTIONS(263),
    [anon_sym_COLON] = ACTIONS(265),
    [anon_sym_DOLLAR] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(263),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(5011),
    [sym_next] = ACTIONS(5011),
    [sym_break] = ACTIONS(5011),
    [sym_true] = ACTIONS(5011),
    [sym_false] = ACTIONS(5011),
    [sym_null] = ACTIONS(5011),
    [sym_inf] = ACTIONS(5011),
    [sym_nan] = ACTIONS(5011),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(5011),
    [sym_dot_dot_i] = ACTIONS(5013),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(263),
    [sym__newline] = ACTIONS(5015),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(263),
    [sym__external_open_brace] = ACTIONS(3891),
    [sym__external_open_bracket] = ACTIONS(263),
    [sym__external_open_bracket2] = ACTIONS(263),
  },
  [466] = {
    [sym_function_definition] = STATE(2043),
    [sym_if_statement] = STATE(2043),
    [sym_for_statement] = STATE(2043),
    [sym_while_statement] = STATE(2043),
    [sym_repeat_statement] = STATE(2043),
    [sym_braced_expression] = STATE(2043),
    [sym_parenthesized_expression] = STATE(2043),
    [sym_call] = STATE(2043),
    [sym_subset] = STATE(2043),
    [sym_subset2] = STATE(2043),
    [sym_unary_operator] = STATE(2043),
    [sym_binary_operator] = STATE(2043),
    [sym_extract_operator] = STATE(2043),
    [sym_namespace_operator] = STATE(2043),
    [sym_integer] = STATE(2043),
    [sym_complex] = STATE(2043),
    [sym_float] = STATE(2043),
    [sym__hex_literal] = STATE(2739),
    [sym__float_literal] = STATE(2739),
    [sym_string] = STATE(2562),
    [sym__single_quoted_string] = STATE(2738),
    [sym__double_quoted_string] = STATE(2737),
    [sym_na] = STATE(2043),
    [sym__expression] = STATE(2043),
    [sym__string_or_identifier] = STATE(5152),
    [sym__open_parenthesis] = STATE(293),
    [sym__open_brace] = STATE(292),
    [aux_sym_function_definition_repeat1] = STATE(471),
    [ts_builtin_sym_end] = ACTIONS(377),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(9),
    [anon_sym_function] = ACTIONS(11),
    [anon_sym_EQ] = ACTIONS(379),
    [anon_sym_if] = ACTIONS(13),
    [anon_sym_for] = ACTIONS(15),
    [anon_sym_while] = ACTIONS(17),
    [anon_sym_repeat] = ACTIONS(19),
    [anon_sym_QMARK] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(4576),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_DASH] = ACTIONS(4578),
    [anon_sym_LT_DASH] = ACTIONS(377),
    [anon_sym_LT_LT_DASH] = ACTIONS(377),
    [anon_sym_COLON_EQ] = ACTIONS(377),
    [anon_sym_DASH_GT] = ACTIONS(379),
    [anon_sym_DASH_GT_GT] = ACTIONS(377),
    [anon_sym_PIPE] = ACTIONS(379),
    [anon_sym_AMP] = ACTIONS(379),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_LT] = ACTIONS(379),
    [anon_sym_LT_EQ] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(379),
    [anon_sym_GT_EQ] = ACTIONS(377),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [anon_sym_BANG_EQ] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(379),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_STAR_STAR] = ACTIONS(377),
    [anon_sym_CARET] = ACTIONS(377),
    [aux_sym_binary_operator_token1] = ACTIONS(377),
    [anon_sym_PIPE_GT] = ACTIONS(377),
    [anon_sym_COLON] = ACTIONS(379),
    [anon_sym_DOLLAR] = ACTIONS(377),
    [anon_sym_AT] = ACTIONS(377),
    [aux_sym__hex_literal_token1] = ACTIONS(29),
    [sym__number_literal] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE] = ACTIONS(35),
    [sym_return] = ACTIONS(5017),
    [sym_next] = ACTIONS(5017),
    [sym_break] = ACTIONS(5017),
    [sym_true] = ACTIONS(5017),
    [sym_false] = ACTIONS(5017),
    [sym_null] = ACTIONS(5017),
    [sym_inf] = ACTIONS(5017),
    [sym_nan] = ACTIONS(5017),
    [anon_sym_NA] = ACTIONS(39),
    [anon_sym_NA_integer_] = ACTIONS(39),
    [anon_sym_NA_real_] = ACTIONS(39),
    [anon_sym_NA_complex_] = ACTIONS(39),
    [anon_sym_NA_character_] = ACTIONS(39),
    [sym_dots] = ACTIONS(5017),
    [sym_dot_dot_i] = ACTIONS(5019),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5021),
    [sym__semicolon] = ACTIONS(377),
    [sym__raw_string_literal] = ACTIONS(45),
    [sym__external_open_parenthesis] = ACTIONS(47),
    [sym__external_open_brace] = ACTIONS(49),
    [sym__external_open_bracket] = ACTIONS(377),
    [sym__external_open_bracket2] = ACTIONS(377),
  },
  [467] = {
    [sym_function_definition] = STATE(1987),
    [sym_if_statement] = STATE(1987),
    [sym_for_statement] = STATE(1987),
    [sym_while_statement] = STATE(1987),
    [sym_repeat_statement] = STATE(1987),
    [sym_braced_expression] = STATE(1987),
    [sym_parenthesized_expression] = STATE(1987),
    [sym_call] = STATE(1987),
    [sym_subset] = STATE(1987),
    [sym_subset2] = STATE(1987),
    [sym_unary_operator] = STATE(1987),
    [sym_binary_operator] = STATE(1987),
    [sym_extract_operator] = STATE(1987),
    [sym_namespace_operator] = STATE(1987),
    [sym_integer] = STATE(1987),
    [sym_complex] = STATE(1987),
    [sym_float] = STATE(1987),
    [sym__hex_literal] = STATE(2739),
    [sym__float_literal] = STATE(2739),
    [sym_string] = STATE(2562),
    [sym__single_quoted_string] = STATE(2738),
    [sym__double_quoted_string] = STATE(2737),
    [sym_na] = STATE(1987),
    [sym__expression] = STATE(1987),
    [sym__string_or_identifier] = STATE(5152),
    [sym__open_parenthesis] = STATE(293),
    [sym__open_brace] = STATE(292),
    [aux_sym_function_definition_repeat1] = STATE(473),
    [ts_builtin_sym_end] = ACTIONS(387),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(9),
    [anon_sym_function] = ACTIONS(11),
    [anon_sym_EQ] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(13),
    [anon_sym_for] = ACTIONS(15),
    [anon_sym_while] = ACTIONS(17),
    [anon_sym_repeat] = ACTIONS(19),
    [anon_sym_QMARK] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(4576),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_DASH] = ACTIONS(4578),
    [anon_sym_LT_DASH] = ACTIONS(387),
    [anon_sym_LT_LT_DASH] = ACTIONS(387),
    [anon_sym_COLON_EQ] = ACTIONS(387),
    [anon_sym_DASH_GT] = ACTIONS(389),
    [anon_sym_DASH_GT_GT] = ACTIONS(387),
    [anon_sym_PIPE] = ACTIONS(389),
    [anon_sym_AMP] = ACTIONS(389),
    [anon_sym_PIPE_PIPE] = ACTIONS(387),
    [anon_sym_AMP_AMP] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(389),
    [anon_sym_LT_EQ] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(389),
    [anon_sym_GT_EQ] = ACTIONS(387),
    [anon_sym_EQ_EQ] = ACTIONS(387),
    [anon_sym_BANG_EQ] = ACTIONS(387),
    [anon_sym_STAR] = ACTIONS(389),
    [anon_sym_SLASH] = ACTIONS(387),
    [anon_sym_STAR_STAR] = ACTIONS(387),
    [anon_sym_CARET] = ACTIONS(387),
    [aux_sym_binary_operator_token1] = ACTIONS(387),
    [anon_sym_PIPE_GT] = ACTIONS(387),
    [anon_sym_COLON] = ACTIONS(389),
    [anon_sym_DOLLAR] = ACTIONS(387),
    [anon_sym_AT] = ACTIONS(387),
    [aux_sym__hex_literal_token1] = ACTIONS(29),
    [sym__number_literal] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE] = ACTIONS(35),
    [sym_return] = ACTIONS(5023),
    [sym_next] = ACTIONS(5023),
    [sym_break] = ACTIONS(5023),
    [sym_true] = ACTIONS(5023),
    [sym_false] = ACTIONS(5023),
    [sym_null] = ACTIONS(5023),
    [sym_inf] = ACTIONS(5023),
    [sym_nan] = ACTIONS(5023),
    [anon_sym_NA] = ACTIONS(39),
    [anon_sym_NA_integer_] = ACTIONS(39),
    [anon_sym_NA_real_] = ACTIONS(39),
    [anon_sym_NA_complex_] = ACTIONS(39),
    [anon_sym_NA_character_] = ACTIONS(39),
    [sym_dots] = ACTIONS(5023),
    [sym_dot_dot_i] = ACTIONS(5025),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5027),
    [sym__semicolon] = ACTIONS(387),
    [sym__raw_string_literal] = ACTIONS(45),
    [sym__external_open_parenthesis] = ACTIONS(47),
    [sym__external_open_brace] = ACTIONS(49),
    [sym__external_open_bracket] = ACTIONS(387),
    [sym__external_open_bracket2] = ACTIONS(387),
  },
  [468] = {
    [sym_function_definition] = STATE(4653),
    [sym_if_statement] = STATE(4653),
    [sym_for_statement] = STATE(4653),
    [sym_while_statement] = STATE(4653),
    [sym_repeat_statement] = STATE(4653),
    [sym_braced_expression] = STATE(4653),
    [sym_parenthesized_expression] = STATE(4653),
    [sym_call] = STATE(4653),
    [sym_subset] = STATE(4653),
    [sym_subset2] = STATE(4653),
    [sym_unary_operator] = STATE(4653),
    [sym_binary_operator] = STATE(4653),
    [sym_extract_operator] = STATE(4653),
    [sym_namespace_operator] = STATE(4653),
    [sym_integer] = STATE(4653),
    [sym_complex] = STATE(4653),
    [sym_float] = STATE(4653),
    [sym__hex_literal] = STATE(4690),
    [sym__float_literal] = STATE(4690),
    [sym_string] = STATE(4689),
    [sym__single_quoted_string] = STATE(4684),
    [sym__double_quoted_string] = STATE(4691),
    [sym_na] = STATE(4653),
    [sym__expression] = STATE(4653),
    [sym__string_or_identifier] = STATE(5155),
    [sym__open_parenthesis] = STATE(402),
    [sym__open_brace] = STATE(153),
    [aux_sym_function_definition_repeat1] = STATE(2866),
    [sym_identifier] = ACTIONS(4590),
    [anon_sym_BSLASH] = ACTIONS(4592),
    [anon_sym_function] = ACTIONS(4594),
    [anon_sym_EQ] = ACTIONS(399),
    [anon_sym_if] = ACTIONS(4596),
    [anon_sym_for] = ACTIONS(4598),
    [anon_sym_while] = ACTIONS(4600),
    [anon_sym_repeat] = ACTIONS(4602),
    [anon_sym_QMARK] = ACTIONS(4604),
    [anon_sym_TILDE] = ACTIONS(4606),
    [anon_sym_BANG] = ACTIONS(4608),
    [anon_sym_PLUS] = ACTIONS(4610),
    [anon_sym_DASH] = ACTIONS(4612),
    [anon_sym_LT_DASH] = ACTIONS(397),
    [anon_sym_LT_LT_DASH] = ACTIONS(397),
    [anon_sym_COLON_EQ] = ACTIONS(397),
    [anon_sym_DASH_GT] = ACTIONS(399),
    [anon_sym_DASH_GT_GT] = ACTIONS(397),
    [anon_sym_PIPE] = ACTIONS(399),
    [anon_sym_AMP] = ACTIONS(399),
    [anon_sym_PIPE_PIPE] = ACTIONS(397),
    [anon_sym_AMP_AMP] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(399),
    [anon_sym_LT_EQ] = ACTIONS(397),
    [anon_sym_GT] = ACTIONS(399),
    [anon_sym_GT_EQ] = ACTIONS(397),
    [anon_sym_EQ_EQ] = ACTIONS(397),
    [anon_sym_BANG_EQ] = ACTIONS(397),
    [anon_sym_STAR] = ACTIONS(399),
    [anon_sym_SLASH] = ACTIONS(397),
    [anon_sym_STAR_STAR] = ACTIONS(397),
    [anon_sym_CARET] = ACTIONS(397),
    [aux_sym_binary_operator_token1] = ACTIONS(397),
    [anon_sym_PIPE_GT] = ACTIONS(397),
    [anon_sym_COLON] = ACTIONS(399),
    [anon_sym_DOLLAR] = ACTIONS(397),
    [anon_sym_AT] = ACTIONS(397),
    [aux_sym__hex_literal_token1] = ACTIONS(4614),
    [sym__number_literal] = ACTIONS(4616),
    [anon_sym_SQUOTE] = ACTIONS(4618),
    [anon_sym_DQUOTE] = ACTIONS(4620),
    [sym_return] = ACTIONS(5029),
    [sym_next] = ACTIONS(5029),
    [sym_break] = ACTIONS(5029),
    [sym_true] = ACTIONS(5029),
    [sym_false] = ACTIONS(5029),
    [sym_null] = ACTIONS(5029),
    [sym_inf] = ACTIONS(5029),
    [sym_nan] = ACTIONS(5029),
    [anon_sym_NA] = ACTIONS(4624),
    [anon_sym_NA_integer_] = ACTIONS(4624),
    [anon_sym_NA_real_] = ACTIONS(4624),
    [anon_sym_NA_complex_] = ACTIONS(4624),
    [anon_sym_NA_character_] = ACTIONS(4624),
    [sym_dots] = ACTIONS(5029),
    [sym_dot_dot_i] = ACTIONS(5031),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(397),
    [sym__newline] = ACTIONS(4628),
    [sym__raw_string_literal] = ACTIONS(4630),
    [sym__external_open_parenthesis] = ACTIONS(4632),
    [sym__external_close_parenthesis] = ACTIONS(397),
    [sym__external_open_brace] = ACTIONS(4634),
    [sym__external_open_bracket] = ACTIONS(397),
    [sym__external_open_bracket2] = ACTIONS(397),
  },
  [469] = {
    [sym_function_definition] = STATE(1999),
    [sym_if_statement] = STATE(1999),
    [sym_for_statement] = STATE(1999),
    [sym_while_statement] = STATE(1999),
    [sym_repeat_statement] = STATE(1999),
    [sym_braced_expression] = STATE(1999),
    [sym_parenthesized_expression] = STATE(1999),
    [sym_call] = STATE(1999),
    [sym_subset] = STATE(1999),
    [sym_subset2] = STATE(1999),
    [sym_unary_operator] = STATE(1999),
    [sym_binary_operator] = STATE(1999),
    [sym_extract_operator] = STATE(1999),
    [sym_namespace_operator] = STATE(1999),
    [sym_integer] = STATE(1999),
    [sym_complex] = STATE(1999),
    [sym_float] = STATE(1999),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2673),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(1999),
    [sym__expression] = STATE(1999),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__open_brace] = STATE(154),
    [aux_sym_function_definition_repeat1] = STATE(2866),
    [sym_identifier] = ACTIONS(3845),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_EQ] = ACTIONS(767),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3867),
    [anon_sym_LT_DASH] = ACTIONS(765),
    [anon_sym_LT_LT_DASH] = ACTIONS(765),
    [anon_sym_COLON_EQ] = ACTIONS(765),
    [anon_sym_DASH_GT] = ACTIONS(767),
    [anon_sym_DASH_GT_GT] = ACTIONS(765),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_AMP] = ACTIONS(767),
    [anon_sym_PIPE_PIPE] = ACTIONS(765),
    [anon_sym_AMP_AMP] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(767),
    [anon_sym_LT_EQ] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_GT_EQ] = ACTIONS(765),
    [anon_sym_EQ_EQ] = ACTIONS(765),
    [anon_sym_BANG_EQ] = ACTIONS(765),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(765),
    [anon_sym_STAR_STAR] = ACTIONS(765),
    [anon_sym_CARET] = ACTIONS(765),
    [aux_sym_binary_operator_token1] = ACTIONS(765),
    [anon_sym_PIPE_GT] = ACTIONS(765),
    [anon_sym_COLON] = ACTIONS(767),
    [anon_sym_DOLLAR] = ACTIONS(765),
    [anon_sym_AT] = ACTIONS(765),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(5033),
    [sym_next] = ACTIONS(5033),
    [sym_break] = ACTIONS(5033),
    [sym_true] = ACTIONS(5033),
    [sym_false] = ACTIONS(5033),
    [sym_null] = ACTIONS(5033),
    [sym_inf] = ACTIONS(5033),
    [sym_nan] = ACTIONS(5033),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(5033),
    [sym_dot_dot_i] = ACTIONS(5035),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(765),
    [sym__newline] = ACTIONS(765),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(765),
    [sym__external_open_brace] = ACTIONS(3891),
    [sym__external_open_bracket] = ACTIONS(765),
    [sym__external_open_bracket2] = ACTIONS(765),
  },
  [470] = {
    [sym_function_definition] = STATE(1950),
    [sym_if_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_while_statement] = STATE(1950),
    [sym_repeat_statement] = STATE(1950),
    [sym_braced_expression] = STATE(1950),
    [sym_parenthesized_expression] = STATE(1950),
    [sym_call] = STATE(1950),
    [sym_subset] = STATE(1950),
    [sym_subset2] = STATE(1950),
    [sym_unary_operator] = STATE(1950),
    [sym_binary_operator] = STATE(1950),
    [sym_extract_operator] = STATE(1950),
    [sym_namespace_operator] = STATE(1950),
    [sym_integer] = STATE(1950),
    [sym_complex] = STATE(1950),
    [sym_float] = STATE(1950),
    [sym__hex_literal] = STATE(2739),
    [sym__float_literal] = STATE(2739),
    [sym_string] = STATE(2562),
    [sym__single_quoted_string] = STATE(2738),
    [sym__double_quoted_string] = STATE(2737),
    [sym_na] = STATE(1950),
    [sym__expression] = STATE(1950),
    [sym__string_or_identifier] = STATE(5152),
    [sym__open_parenthesis] = STATE(293),
    [sym__open_brace] = STATE(292),
    [aux_sym_function_definition_repeat1] = STATE(416),
    [ts_builtin_sym_end] = ACTIONS(461),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(9),
    [anon_sym_function] = ACTIONS(11),
    [anon_sym_EQ] = ACTIONS(463),
    [anon_sym_if] = ACTIONS(13),
    [anon_sym_for] = ACTIONS(15),
    [anon_sym_while] = ACTIONS(17),
    [anon_sym_repeat] = ACTIONS(19),
    [anon_sym_QMARK] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(4576),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_DASH] = ACTIONS(4578),
    [anon_sym_LT_DASH] = ACTIONS(461),
    [anon_sym_LT_LT_DASH] = ACTIONS(461),
    [anon_sym_COLON_EQ] = ACTIONS(461),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_DASH_GT_GT] = ACTIONS(461),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_PIPE_PIPE] = ACTIONS(461),
    [anon_sym_AMP_AMP] = ACTIONS(461),
    [anon_sym_LT] = ACTIONS(463),
    [anon_sym_LT_EQ] = ACTIONS(461),
    [anon_sym_GT] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(461),
    [anon_sym_EQ_EQ] = ACTIONS(461),
    [anon_sym_BANG_EQ] = ACTIONS(461),
    [anon_sym_STAR] = ACTIONS(463),
    [anon_sym_SLASH] = ACTIONS(461),
    [anon_sym_STAR_STAR] = ACTIONS(461),
    [anon_sym_CARET] = ACTIONS(461),
    [aux_sym_binary_operator_token1] = ACTIONS(461),
    [anon_sym_PIPE_GT] = ACTIONS(461),
    [anon_sym_COLON] = ACTIONS(463),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_AT] = ACTIONS(461),
    [aux_sym__hex_literal_token1] = ACTIONS(29),
    [sym__number_literal] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE] = ACTIONS(35),
    [sym_return] = ACTIONS(5037),
    [sym_next] = ACTIONS(5037),
    [sym_break] = ACTIONS(5037),
    [sym_true] = ACTIONS(5037),
    [sym_false] = ACTIONS(5037),
    [sym_null] = ACTIONS(5037),
    [sym_inf] = ACTIONS(5037),
    [sym_nan] = ACTIONS(5037),
    [anon_sym_NA] = ACTIONS(39),
    [anon_sym_NA_integer_] = ACTIONS(39),
    [anon_sym_NA_real_] = ACTIONS(39),
    [anon_sym_NA_complex_] = ACTIONS(39),
    [anon_sym_NA_character_] = ACTIONS(39),
    [sym_dots] = ACTIONS(5037),
    [sym_dot_dot_i] = ACTIONS(5039),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5041),
    [sym__semicolon] = ACTIONS(461),
    [sym__raw_string_literal] = ACTIONS(45),
    [sym__external_open_parenthesis] = ACTIONS(47),
    [sym__external_open_brace] = ACTIONS(49),
    [sym__external_open_bracket] = ACTIONS(461),
    [sym__external_open_bracket2] = ACTIONS(461),
  },
  [471] = {
    [sym_function_definition] = STATE(1973),
    [sym_if_statement] = STATE(1973),
    [sym_for_statement] = STATE(1973),
    [sym_while_statement] = STATE(1973),
    [sym_repeat_statement] = STATE(1973),
    [sym_braced_expression] = STATE(1973),
    [sym_parenthesized_expression] = STATE(1973),
    [sym_call] = STATE(1973),
    [sym_subset] = STATE(1973),
    [sym_subset2] = STATE(1973),
    [sym_unary_operator] = STATE(1973),
    [sym_binary_operator] = STATE(1973),
    [sym_extract_operator] = STATE(1973),
    [sym_namespace_operator] = STATE(1973),
    [sym_integer] = STATE(1973),
    [sym_complex] = STATE(1973),
    [sym_float] = STATE(1973),
    [sym__hex_literal] = STATE(2739),
    [sym__float_literal] = STATE(2739),
    [sym_string] = STATE(2562),
    [sym__single_quoted_string] = STATE(2738),
    [sym__double_quoted_string] = STATE(2737),
    [sym_na] = STATE(1973),
    [sym__expression] = STATE(1973),
    [sym__string_or_identifier] = STATE(5152),
    [sym__open_parenthesis] = STATE(293),
    [sym__open_brace] = STATE(292),
    [aux_sym_function_definition_repeat1] = STATE(2881),
    [ts_builtin_sym_end] = ACTIONS(397),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(9),
    [anon_sym_function] = ACTIONS(11),
    [anon_sym_EQ] = ACTIONS(399),
    [anon_sym_if] = ACTIONS(13),
    [anon_sym_for] = ACTIONS(15),
    [anon_sym_while] = ACTIONS(17),
    [anon_sym_repeat] = ACTIONS(19),
    [anon_sym_QMARK] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(4576),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_DASH] = ACTIONS(4578),
    [anon_sym_LT_DASH] = ACTIONS(397),
    [anon_sym_LT_LT_DASH] = ACTIONS(397),
    [anon_sym_COLON_EQ] = ACTIONS(397),
    [anon_sym_DASH_GT] = ACTIONS(399),
    [anon_sym_DASH_GT_GT] = ACTIONS(397),
    [anon_sym_PIPE] = ACTIONS(399),
    [anon_sym_AMP] = ACTIONS(399),
    [anon_sym_PIPE_PIPE] = ACTIONS(397),
    [anon_sym_AMP_AMP] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(399),
    [anon_sym_LT_EQ] = ACTIONS(397),
    [anon_sym_GT] = ACTIONS(399),
    [anon_sym_GT_EQ] = ACTIONS(397),
    [anon_sym_EQ_EQ] = ACTIONS(397),
    [anon_sym_BANG_EQ] = ACTIONS(397),
    [anon_sym_STAR] = ACTIONS(399),
    [anon_sym_SLASH] = ACTIONS(397),
    [anon_sym_STAR_STAR] = ACTIONS(397),
    [anon_sym_CARET] = ACTIONS(397),
    [aux_sym_binary_operator_token1] = ACTIONS(397),
    [anon_sym_PIPE_GT] = ACTIONS(397),
    [anon_sym_COLON] = ACTIONS(399),
    [anon_sym_DOLLAR] = ACTIONS(397),
    [anon_sym_AT] = ACTIONS(397),
    [aux_sym__hex_literal_token1] = ACTIONS(29),
    [sym__number_literal] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE] = ACTIONS(35),
    [sym_return] = ACTIONS(5043),
    [sym_next] = ACTIONS(5043),
    [sym_break] = ACTIONS(5043),
    [sym_true] = ACTIONS(5043),
    [sym_false] = ACTIONS(5043),
    [sym_null] = ACTIONS(5043),
    [sym_inf] = ACTIONS(5043),
    [sym_nan] = ACTIONS(5043),
    [anon_sym_NA] = ACTIONS(39),
    [anon_sym_NA_integer_] = ACTIONS(39),
    [anon_sym_NA_real_] = ACTIONS(39),
    [anon_sym_NA_complex_] = ACTIONS(39),
    [anon_sym_NA_character_] = ACTIONS(39),
    [sym_dots] = ACTIONS(5043),
    [sym_dot_dot_i] = ACTIONS(5045),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(397),
    [sym__semicolon] = ACTIONS(397),
    [sym__raw_string_literal] = ACTIONS(45),
    [sym__external_open_parenthesis] = ACTIONS(47),
    [sym__external_open_brace] = ACTIONS(49),
    [sym__external_open_bracket] = ACTIONS(397),
    [sym__external_open_bracket2] = ACTIONS(397),
  },
  [472] = {
    [sym_function_definition] = STATE(4615),
    [sym_if_statement] = STATE(4615),
    [sym_for_statement] = STATE(4615),
    [sym_while_statement] = STATE(4615),
    [sym_repeat_statement] = STATE(4615),
    [sym_braced_expression] = STATE(4615),
    [sym_parenthesized_expression] = STATE(4615),
    [sym_call] = STATE(4615),
    [sym_subset] = STATE(4615),
    [sym_subset2] = STATE(4615),
    [sym_unary_operator] = STATE(4615),
    [sym_binary_operator] = STATE(4615),
    [sym_extract_operator] = STATE(4615),
    [sym_namespace_operator] = STATE(4615),
    [sym_integer] = STATE(4615),
    [sym_complex] = STATE(4615),
    [sym_float] = STATE(4615),
    [sym__hex_literal] = STATE(4690),
    [sym__float_literal] = STATE(4690),
    [sym_string] = STATE(4689),
    [sym__single_quoted_string] = STATE(4684),
    [sym__double_quoted_string] = STATE(4691),
    [sym_na] = STATE(4615),
    [sym__expression] = STATE(4615),
    [sym__string_or_identifier] = STATE(5155),
    [sym__open_parenthesis] = STATE(402),
    [sym__open_brace] = STATE(153),
    [aux_sym_function_definition_repeat1] = STATE(446),
    [sym_identifier] = ACTIONS(4590),
    [anon_sym_BSLASH] = ACTIONS(4592),
    [anon_sym_function] = ACTIONS(4594),
    [anon_sym_EQ] = ACTIONS(463),
    [anon_sym_if] = ACTIONS(4596),
    [anon_sym_for] = ACTIONS(4598),
    [anon_sym_while] = ACTIONS(4600),
    [anon_sym_repeat] = ACTIONS(4602),
    [anon_sym_QMARK] = ACTIONS(4604),
    [anon_sym_TILDE] = ACTIONS(4606),
    [anon_sym_BANG] = ACTIONS(4608),
    [anon_sym_PLUS] = ACTIONS(4610),
    [anon_sym_DASH] = ACTIONS(4612),
    [anon_sym_LT_DASH] = ACTIONS(461),
    [anon_sym_LT_LT_DASH] = ACTIONS(461),
    [anon_sym_COLON_EQ] = ACTIONS(461),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_DASH_GT_GT] = ACTIONS(461),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_PIPE_PIPE] = ACTIONS(461),
    [anon_sym_AMP_AMP] = ACTIONS(461),
    [anon_sym_LT] = ACTIONS(463),
    [anon_sym_LT_EQ] = ACTIONS(461),
    [anon_sym_GT] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(461),
    [anon_sym_EQ_EQ] = ACTIONS(461),
    [anon_sym_BANG_EQ] = ACTIONS(461),
    [anon_sym_STAR] = ACTIONS(463),
    [anon_sym_SLASH] = ACTIONS(461),
    [anon_sym_STAR_STAR] = ACTIONS(461),
    [anon_sym_CARET] = ACTIONS(461),
    [aux_sym_binary_operator_token1] = ACTIONS(461),
    [anon_sym_PIPE_GT] = ACTIONS(461),
    [anon_sym_COLON] = ACTIONS(463),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_AT] = ACTIONS(461),
    [aux_sym__hex_literal_token1] = ACTIONS(4614),
    [sym__number_literal] = ACTIONS(4616),
    [anon_sym_SQUOTE] = ACTIONS(4618),
    [anon_sym_DQUOTE] = ACTIONS(4620),
    [sym_return] = ACTIONS(5047),
    [sym_next] = ACTIONS(5047),
    [sym_break] = ACTIONS(5047),
    [sym_true] = ACTIONS(5047),
    [sym_false] = ACTIONS(5047),
    [sym_null] = ACTIONS(5047),
    [sym_inf] = ACTIONS(5047),
    [sym_nan] = ACTIONS(5047),
    [anon_sym_NA] = ACTIONS(4624),
    [anon_sym_NA_integer_] = ACTIONS(4624),
    [anon_sym_NA_real_] = ACTIONS(4624),
    [anon_sym_NA_complex_] = ACTIONS(4624),
    [anon_sym_NA_character_] = ACTIONS(4624),
    [sym_dots] = ACTIONS(5047),
    [sym_dot_dot_i] = ACTIONS(5049),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(461),
    [sym__newline] = ACTIONS(5051),
    [sym__raw_string_literal] = ACTIONS(4630),
    [sym__external_open_parenthesis] = ACTIONS(4632),
    [sym__external_close_parenthesis] = ACTIONS(461),
    [sym__external_open_brace] = ACTIONS(4634),
    [sym__external_open_bracket] = ACTIONS(461),
    [sym__external_open_bracket2] = ACTIONS(461),
  },
  [473] = {
    [sym_function_definition] = STATE(1946),
    [sym_if_statement] = STATE(1946),
    [sym_for_statement] = STATE(1946),
    [sym_while_statement] = STATE(1946),
    [sym_repeat_statement] = STATE(1946),
    [sym_braced_expression] = STATE(1946),
    [sym_parenthesized_expression] = STATE(1946),
    [sym_call] = STATE(1946),
    [sym_subset] = STATE(1946),
    [sym_subset2] = STATE(1946),
    [sym_unary_operator] = STATE(1946),
    [sym_binary_operator] = STATE(1946),
    [sym_extract_operator] = STATE(1946),
    [sym_namespace_operator] = STATE(1946),
    [sym_integer] = STATE(1946),
    [sym_complex] = STATE(1946),
    [sym_float] = STATE(1946),
    [sym__hex_literal] = STATE(2739),
    [sym__float_literal] = STATE(2739),
    [sym_string] = STATE(2562),
    [sym__single_quoted_string] = STATE(2738),
    [sym__double_quoted_string] = STATE(2737),
    [sym_na] = STATE(1946),
    [sym__expression] = STATE(1946),
    [sym__string_or_identifier] = STATE(5152),
    [sym__open_parenthesis] = STATE(293),
    [sym__open_brace] = STATE(292),
    [aux_sym_function_definition_repeat1] = STATE(2881),
    [ts_builtin_sym_end] = ACTIONS(453),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(9),
    [anon_sym_function] = ACTIONS(11),
    [anon_sym_EQ] = ACTIONS(455),
    [anon_sym_if] = ACTIONS(13),
    [anon_sym_for] = ACTIONS(15),
    [anon_sym_while] = ACTIONS(17),
    [anon_sym_repeat] = ACTIONS(19),
    [anon_sym_QMARK] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(4576),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_DASH] = ACTIONS(4578),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [anon_sym_LT_LT_DASH] = ACTIONS(453),
    [anon_sym_COLON_EQ] = ACTIONS(453),
    [anon_sym_DASH_GT] = ACTIONS(455),
    [anon_sym_DASH_GT_GT] = ACTIONS(453),
    [anon_sym_PIPE] = ACTIONS(455),
    [anon_sym_AMP] = ACTIONS(455),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(455),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_GT] = ACTIONS(455),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(453),
    [anon_sym_STAR] = ACTIONS(455),
    [anon_sym_SLASH] = ACTIONS(453),
    [anon_sym_STAR_STAR] = ACTIONS(453),
    [anon_sym_CARET] = ACTIONS(453),
    [aux_sym_binary_operator_token1] = ACTIONS(453),
    [anon_sym_PIPE_GT] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(455),
    [anon_sym_DOLLAR] = ACTIONS(453),
    [anon_sym_AT] = ACTIONS(453),
    [aux_sym__hex_literal_token1] = ACTIONS(29),
    [sym__number_literal] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE] = ACTIONS(35),
    [sym_return] = ACTIONS(5053),
    [sym_next] = ACTIONS(5053),
    [sym_break] = ACTIONS(5053),
    [sym_true] = ACTIONS(5053),
    [sym_false] = ACTIONS(5053),
    [sym_null] = ACTIONS(5053),
    [sym_inf] = ACTIONS(5053),
    [sym_nan] = ACTIONS(5053),
    [anon_sym_NA] = ACTIONS(39),
    [anon_sym_NA_integer_] = ACTIONS(39),
    [anon_sym_NA_real_] = ACTIONS(39),
    [anon_sym_NA_complex_] = ACTIONS(39),
    [anon_sym_NA_character_] = ACTIONS(39),
    [sym_dots] = ACTIONS(5053),
    [sym_dot_dot_i] = ACTIONS(5055),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(453),
    [sym__semicolon] = ACTIONS(453),
    [sym__raw_string_literal] = ACTIONS(45),
    [sym__external_open_parenthesis] = ACTIONS(47),
    [sym__external_open_brace] = ACTIONS(49),
    [sym__external_open_bracket] = ACTIONS(453),
    [sym__external_open_bracket2] = ACTIONS(453),
  },
  [474] = {
    [sym_function_definition] = STATE(1933),
    [sym_if_statement] = STATE(1933),
    [sym_for_statement] = STATE(1933),
    [sym_while_statement] = STATE(1933),
    [sym_repeat_statement] = STATE(1933),
    [sym_braced_expression] = STATE(1933),
    [sym_parenthesized_expression] = STATE(1933),
    [sym_call] = STATE(1933),
    [sym_subset] = STATE(1933),
    [sym_subset2] = STATE(1933),
    [sym_unary_operator] = STATE(1933),
    [sym_binary_operator] = STATE(1933),
    [sym_extract_operator] = STATE(1933),
    [sym_namespace_operator] = STATE(1933),
    [sym_integer] = STATE(1933),
    [sym_complex] = STATE(1933),
    [sym_float] = STATE(1933),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2673),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(1933),
    [sym__expression] = STATE(1933),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__open_brace] = STATE(154),
    [aux_sym_function_definition_repeat1] = STATE(2866),
    [sym_identifier] = ACTIONS(3845),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_EQ] = ACTIONS(759),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3867),
    [anon_sym_LT_DASH] = ACTIONS(757),
    [anon_sym_LT_LT_DASH] = ACTIONS(757),
    [anon_sym_COLON_EQ] = ACTIONS(757),
    [anon_sym_DASH_GT] = ACTIONS(759),
    [anon_sym_DASH_GT_GT] = ACTIONS(757),
    [anon_sym_PIPE] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(759),
    [anon_sym_PIPE_PIPE] = ACTIONS(757),
    [anon_sym_AMP_AMP] = ACTIONS(757),
    [anon_sym_LT] = ACTIONS(759),
    [anon_sym_LT_EQ] = ACTIONS(757),
    [anon_sym_GT] = ACTIONS(759),
    [anon_sym_GT_EQ] = ACTIONS(757),
    [anon_sym_EQ_EQ] = ACTIONS(757),
    [anon_sym_BANG_EQ] = ACTIONS(757),
    [anon_sym_STAR] = ACTIONS(759),
    [anon_sym_SLASH] = ACTIONS(757),
    [anon_sym_STAR_STAR] = ACTIONS(757),
    [anon_sym_CARET] = ACTIONS(757),
    [aux_sym_binary_operator_token1] = ACTIONS(757),
    [anon_sym_PIPE_GT] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(759),
    [anon_sym_DOLLAR] = ACTIONS(757),
    [anon_sym_AT] = ACTIONS(757),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(5057),
    [sym_next] = ACTIONS(5057),
    [sym_break] = ACTIONS(5057),
    [sym_true] = ACTIONS(5057),
    [sym_false] = ACTIONS(5057),
    [sym_null] = ACTIONS(5057),
    [sym_inf] = ACTIONS(5057),
    [sym_nan] = ACTIONS(5057),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(5057),
    [sym_dot_dot_i] = ACTIONS(5059),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(757),
    [sym__newline] = ACTIONS(757),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(757),
    [sym__external_open_brace] = ACTIONS(3891),
    [sym__external_open_bracket] = ACTIONS(757),
    [sym__external_open_bracket2] = ACTIONS(757),
  },
  [475] = {
    [sym_function_definition] = STATE(1952),
    [sym_if_statement] = STATE(1952),
    [sym_for_statement] = STATE(1952),
    [sym_while_statement] = STATE(1952),
    [sym_repeat_statement] = STATE(1952),
    [sym_braced_expression] = STATE(1952),
    [sym_parenthesized_expression] = STATE(1952),
    [sym_call] = STATE(1952),
    [sym_subset] = STATE(1952),
    [sym_subset2] = STATE(1952),
    [sym_unary_operator] = STATE(1952),
    [sym_binary_operator] = STATE(1952),
    [sym_extract_operator] = STATE(1952),
    [sym_namespace_operator] = STATE(1952),
    [sym_integer] = STATE(1952),
    [sym_complex] = STATE(1952),
    [sym_float] = STATE(1952),
    [sym__hex_literal] = STATE(2739),
    [sym__float_literal] = STATE(2739),
    [sym_string] = STATE(2562),
    [sym__single_quoted_string] = STATE(2738),
    [sym__double_quoted_string] = STATE(2737),
    [sym_na] = STATE(1952),
    [sym__expression] = STATE(1952),
    [sym__string_or_identifier] = STATE(5152),
    [sym__open_parenthesis] = STATE(293),
    [sym__open_brace] = STATE(292),
    [aux_sym_function_definition_repeat1] = STATE(2881),
    [ts_builtin_sym_end] = ACTIONS(757),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(9),
    [anon_sym_function] = ACTIONS(11),
    [anon_sym_EQ] = ACTIONS(759),
    [anon_sym_if] = ACTIONS(13),
    [anon_sym_for] = ACTIONS(15),
    [anon_sym_while] = ACTIONS(17),
    [anon_sym_repeat] = ACTIONS(19),
    [anon_sym_QMARK] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(4576),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_DASH] = ACTIONS(4578),
    [anon_sym_LT_DASH] = ACTIONS(757),
    [anon_sym_LT_LT_DASH] = ACTIONS(757),
    [anon_sym_COLON_EQ] = ACTIONS(757),
    [anon_sym_DASH_GT] = ACTIONS(759),
    [anon_sym_DASH_GT_GT] = ACTIONS(757),
    [anon_sym_PIPE] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(759),
    [anon_sym_PIPE_PIPE] = ACTIONS(757),
    [anon_sym_AMP_AMP] = ACTIONS(757),
    [anon_sym_LT] = ACTIONS(759),
    [anon_sym_LT_EQ] = ACTIONS(757),
    [anon_sym_GT] = ACTIONS(759),
    [anon_sym_GT_EQ] = ACTIONS(757),
    [anon_sym_EQ_EQ] = ACTIONS(757),
    [anon_sym_BANG_EQ] = ACTIONS(757),
    [anon_sym_STAR] = ACTIONS(759),
    [anon_sym_SLASH] = ACTIONS(757),
    [anon_sym_STAR_STAR] = ACTIONS(757),
    [anon_sym_CARET] = ACTIONS(757),
    [aux_sym_binary_operator_token1] = ACTIONS(757),
    [anon_sym_PIPE_GT] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(759),
    [anon_sym_DOLLAR] = ACTIONS(757),
    [anon_sym_AT] = ACTIONS(757),
    [aux_sym__hex_literal_token1] = ACTIONS(29),
    [sym__number_literal] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE] = ACTIONS(35),
    [sym_return] = ACTIONS(5061),
    [sym_next] = ACTIONS(5061),
    [sym_break] = ACTIONS(5061),
    [sym_true] = ACTIONS(5061),
    [sym_false] = ACTIONS(5061),
    [sym_null] = ACTIONS(5061),
    [sym_inf] = ACTIONS(5061),
    [sym_nan] = ACTIONS(5061),
    [anon_sym_NA] = ACTIONS(39),
    [anon_sym_NA_integer_] = ACTIONS(39),
    [anon_sym_NA_real_] = ACTIONS(39),
    [anon_sym_NA_complex_] = ACTIONS(39),
    [anon_sym_NA_character_] = ACTIONS(39),
    [sym_dots] = ACTIONS(5061),
    [sym_dot_dot_i] = ACTIONS(5063),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(757),
    [sym__semicolon] = ACTIONS(757),
    [sym__raw_string_literal] = ACTIONS(45),
    [sym__external_open_parenthesis] = ACTIONS(47),
    [sym__external_open_brace] = ACTIONS(49),
    [sym__external_open_bracket] = ACTIONS(757),
    [sym__external_open_bracket2] = ACTIONS(757),
  },
  [476] = {
    [sym_call_arguments] = STATE(2342),
    [sym_subset_arguments] = STATE(2343),
    [sym_subset2_arguments] = STATE(2346),
    [sym__else] = STATE(4090),
    [sym__open_parenthesis] = STATE(1325),
    [sym__open_bracket] = STATE(1322),
    [sym__open_bracket2] = STATE(1607),
    [sym_identifier] = ACTIONS(5065),
    [anon_sym_BSLASH] = ACTIONS(5067),
    [anon_sym_function] = ACTIONS(5065),
    [anon_sym_EQ] = ACTIONS(5069),
    [anon_sym_if] = ACTIONS(5065),
    [anon_sym_for] = ACTIONS(5065),
    [anon_sym_while] = ACTIONS(5065),
    [anon_sym_repeat] = ACTIONS(5065),
    [anon_sym_QMARK] = ACTIONS(5067),
    [anon_sym_TILDE] = ACTIONS(5071),
    [anon_sym_BANG] = ACTIONS(5065),
    [anon_sym_PLUS] = ACTIONS(5073),
    [anon_sym_DASH] = ACTIONS(5075),
    [anon_sym_LT_DASH] = ACTIONS(5077),
    [anon_sym_LT_LT_DASH] = ACTIONS(5077),
    [anon_sym_COLON_EQ] = ACTIONS(5077),
    [anon_sym_DASH_GT] = ACTIONS(5079),
    [anon_sym_DASH_GT_GT] = ACTIONS(5081),
    [anon_sym_PIPE] = ACTIONS(5083),
    [anon_sym_AMP] = ACTIONS(5085),
    [anon_sym_PIPE_PIPE] = ACTIONS(5087),
    [anon_sym_AMP_AMP] = ACTIONS(5089),
    [anon_sym_LT] = ACTIONS(5091),
    [anon_sym_LT_EQ] = ACTIONS(5093),
    [anon_sym_GT] = ACTIONS(5091),
    [anon_sym_GT_EQ] = ACTIONS(5093),
    [anon_sym_EQ_EQ] = ACTIONS(5093),
    [anon_sym_BANG_EQ] = ACTIONS(5093),
    [anon_sym_STAR] = ACTIONS(5095),
    [anon_sym_SLASH] = ACTIONS(5097),
    [anon_sym_STAR_STAR] = ACTIONS(5099),
    [anon_sym_CARET] = ACTIONS(5099),
    [aux_sym_binary_operator_token1] = ACTIONS(5101),
    [anon_sym_PIPE_GT] = ACTIONS(5101),
    [anon_sym_COLON] = ACTIONS(5103),
    [anon_sym_DOLLAR] = ACTIONS(5105),
    [anon_sym_AT] = ACTIONS(5105),
    [aux_sym__hex_literal_token1] = ACTIONS(5067),
    [sym__number_literal] = ACTIONS(5065),
    [anon_sym_SQUOTE] = ACTIONS(5067),
    [anon_sym_DQUOTE] = ACTIONS(5067),
    [sym_return] = ACTIONS(5065),
    [sym_next] = ACTIONS(5065),
    [sym_break] = ACTIONS(5065),
    [sym_true] = ACTIONS(5065),
    [sym_false] = ACTIONS(5065),
    [sym_null] = ACTIONS(5065),
    [sym_inf] = ACTIONS(5065),
    [sym_nan] = ACTIONS(5065),
    [anon_sym_NA] = ACTIONS(5065),
    [anon_sym_NA_integer_] = ACTIONS(5065),
    [anon_sym_NA_real_] = ACTIONS(5065),
    [anon_sym_NA_complex_] = ACTIONS(5065),
    [anon_sym_NA_character_] = ACTIONS(5065),
    [sym_dots] = ACTIONS(5065),
    [sym_dot_dot_i] = ACTIONS(5067),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5067),
    [sym__newline] = ACTIONS(5067),
    [sym__semicolon] = ACTIONS(5067),
    [sym__raw_string_literal] = ACTIONS(5067),
    [sym__external_else] = ACTIONS(5107),
    [sym__external_open_parenthesis] = ACTIONS(5109),
    [sym__external_close_parenthesis] = ACTIONS(5067),
    [sym__external_open_brace] = ACTIONS(5067),
    [sym__external_close_brace] = ACTIONS(5067),
    [sym__external_open_bracket] = ACTIONS(5111),
    [sym__external_open_bracket2] = ACTIONS(5113),
    [sym__external_close_bracket2] = ACTIONS(5067),
  },
  [477] = {
    [sym_call_arguments] = STATE(2318),
    [sym_subset_arguments] = STATE(2319),
    [sym_subset2_arguments] = STATE(2320),
    [sym__else] = STATE(4330),
    [sym__open_parenthesis] = STATE(1329),
    [sym__open_bracket] = STATE(1328),
    [sym__open_bracket2] = STATE(1327),
    [sym_identifier] = ACTIONS(5115),
    [anon_sym_BSLASH] = ACTIONS(5117),
    [anon_sym_function] = ACTIONS(5115),
    [anon_sym_EQ] = ACTIONS(5119),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_for] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_repeat] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(5117),
    [anon_sym_TILDE] = ACTIONS(5121),
    [anon_sym_BANG] = ACTIONS(5115),
    [anon_sym_PLUS] = ACTIONS(5123),
    [anon_sym_DASH] = ACTIONS(5125),
    [anon_sym_LT_DASH] = ACTIONS(5127),
    [anon_sym_LT_LT_DASH] = ACTIONS(5127),
    [anon_sym_COLON_EQ] = ACTIONS(5127),
    [anon_sym_DASH_GT] = ACTIONS(5129),
    [anon_sym_DASH_GT_GT] = ACTIONS(5131),
    [anon_sym_PIPE] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5135),
    [anon_sym_PIPE_PIPE] = ACTIONS(5137),
    [anon_sym_AMP_AMP] = ACTIONS(5139),
    [anon_sym_LT] = ACTIONS(5141),
    [anon_sym_LT_EQ] = ACTIONS(5143),
    [anon_sym_GT] = ACTIONS(5141),
    [anon_sym_GT_EQ] = ACTIONS(5143),
    [anon_sym_EQ_EQ] = ACTIONS(5143),
    [anon_sym_BANG_EQ] = ACTIONS(5143),
    [anon_sym_STAR] = ACTIONS(5145),
    [anon_sym_SLASH] = ACTIONS(5147),
    [anon_sym_STAR_STAR] = ACTIONS(5149),
    [anon_sym_CARET] = ACTIONS(5149),
    [aux_sym_binary_operator_token1] = ACTIONS(5151),
    [anon_sym_PIPE_GT] = ACTIONS(5151),
    [anon_sym_COLON] = ACTIONS(5153),
    [anon_sym_DOLLAR] = ACTIONS(5155),
    [anon_sym_AT] = ACTIONS(5155),
    [aux_sym__hex_literal_token1] = ACTIONS(5117),
    [sym__number_literal] = ACTIONS(5115),
    [anon_sym_SQUOTE] = ACTIONS(5117),
    [anon_sym_DQUOTE] = ACTIONS(5117),
    [sym_return] = ACTIONS(5115),
    [sym_next] = ACTIONS(5115),
    [sym_break] = ACTIONS(5115),
    [sym_true] = ACTIONS(5115),
    [sym_false] = ACTIONS(5115),
    [sym_null] = ACTIONS(5115),
    [sym_inf] = ACTIONS(5115),
    [sym_nan] = ACTIONS(5115),
    [anon_sym_NA] = ACTIONS(5115),
    [anon_sym_NA_integer_] = ACTIONS(5115),
    [anon_sym_NA_real_] = ACTIONS(5115),
    [anon_sym_NA_complex_] = ACTIONS(5115),
    [anon_sym_NA_character_] = ACTIONS(5115),
    [sym_dots] = ACTIONS(5115),
    [sym_dot_dot_i] = ACTIONS(5117),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5117),
    [sym__newline] = ACTIONS(5117),
    [sym__semicolon] = ACTIONS(5117),
    [sym__raw_string_literal] = ACTIONS(5117),
    [sym__external_else] = ACTIONS(5157),
    [sym__external_open_parenthesis] = ACTIONS(5159),
    [sym__external_close_parenthesis] = ACTIONS(5117),
    [sym__external_open_brace] = ACTIONS(5117),
    [sym__external_close_brace] = ACTIONS(5117),
    [sym__external_open_bracket] = ACTIONS(5161),
    [sym__external_close_bracket] = ACTIONS(5117),
    [sym__external_open_bracket2] = ACTIONS(5163),
  },
  [478] = {
    [sym_call_arguments] = STATE(2342),
    [sym_subset_arguments] = STATE(2343),
    [sym_subset2_arguments] = STATE(2346),
    [sym__else] = STATE(4132),
    [sym__open_parenthesis] = STATE(1325),
    [sym__open_bracket] = STATE(1322),
    [sym__open_bracket2] = STATE(1607),
    [sym_identifier] = ACTIONS(5115),
    [anon_sym_BSLASH] = ACTIONS(5117),
    [anon_sym_function] = ACTIONS(5115),
    [anon_sym_EQ] = ACTIONS(5069),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_for] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_repeat] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(5117),
    [anon_sym_TILDE] = ACTIONS(5071),
    [anon_sym_BANG] = ACTIONS(5115),
    [anon_sym_PLUS] = ACTIONS(5073),
    [anon_sym_DASH] = ACTIONS(5075),
    [anon_sym_LT_DASH] = ACTIONS(5077),
    [anon_sym_LT_LT_DASH] = ACTIONS(5077),
    [anon_sym_COLON_EQ] = ACTIONS(5077),
    [anon_sym_DASH_GT] = ACTIONS(5079),
    [anon_sym_DASH_GT_GT] = ACTIONS(5081),
    [anon_sym_PIPE] = ACTIONS(5083),
    [anon_sym_AMP] = ACTIONS(5085),
    [anon_sym_PIPE_PIPE] = ACTIONS(5087),
    [anon_sym_AMP_AMP] = ACTIONS(5089),
    [anon_sym_LT] = ACTIONS(5091),
    [anon_sym_LT_EQ] = ACTIONS(5093),
    [anon_sym_GT] = ACTIONS(5091),
    [anon_sym_GT_EQ] = ACTIONS(5093),
    [anon_sym_EQ_EQ] = ACTIONS(5093),
    [anon_sym_BANG_EQ] = ACTIONS(5093),
    [anon_sym_STAR] = ACTIONS(5095),
    [anon_sym_SLASH] = ACTIONS(5097),
    [anon_sym_STAR_STAR] = ACTIONS(5099),
    [anon_sym_CARET] = ACTIONS(5099),
    [aux_sym_binary_operator_token1] = ACTIONS(5101),
    [anon_sym_PIPE_GT] = ACTIONS(5101),
    [anon_sym_COLON] = ACTIONS(5103),
    [anon_sym_DOLLAR] = ACTIONS(5105),
    [anon_sym_AT] = ACTIONS(5105),
    [aux_sym__hex_literal_token1] = ACTIONS(5117),
    [sym__number_literal] = ACTIONS(5115),
    [anon_sym_SQUOTE] = ACTIONS(5117),
    [anon_sym_DQUOTE] = ACTIONS(5117),
    [sym_return] = ACTIONS(5115),
    [sym_next] = ACTIONS(5115),
    [sym_break] = ACTIONS(5115),
    [sym_true] = ACTIONS(5115),
    [sym_false] = ACTIONS(5115),
    [sym_null] = ACTIONS(5115),
    [sym_inf] = ACTIONS(5115),
    [sym_nan] = ACTIONS(5115),
    [anon_sym_NA] = ACTIONS(5115),
    [anon_sym_NA_integer_] = ACTIONS(5115),
    [anon_sym_NA_real_] = ACTIONS(5115),
    [anon_sym_NA_complex_] = ACTIONS(5115),
    [anon_sym_NA_character_] = ACTIONS(5115),
    [sym_dots] = ACTIONS(5115),
    [sym_dot_dot_i] = ACTIONS(5117),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5117),
    [sym__newline] = ACTIONS(5117),
    [sym__semicolon] = ACTIONS(5117),
    [sym__raw_string_literal] = ACTIONS(5117),
    [sym__external_else] = ACTIONS(5165),
    [sym__external_open_parenthesis] = ACTIONS(5109),
    [sym__external_close_parenthesis] = ACTIONS(5117),
    [sym__external_open_brace] = ACTIONS(5117),
    [sym__external_close_brace] = ACTIONS(5117),
    [sym__external_open_bracket] = ACTIONS(5111),
    [sym__external_open_bracket2] = ACTIONS(5113),
    [sym__external_close_bracket2] = ACTIONS(5117),
  },
  [479] = {
    [sym_call_arguments] = STATE(2261),
    [sym_subset_arguments] = STATE(2260),
    [sym_subset2_arguments] = STATE(2259),
    [sym__else] = STATE(4360),
    [sym__open_parenthesis] = STATE(1380),
    [sym__open_bracket] = STATE(1379),
    [sym__open_bracket2] = STATE(1378),
    [ts_builtin_sym_end] = ACTIONS(5167),
    [sym_identifier] = ACTIONS(5169),
    [anon_sym_BSLASH] = ACTIONS(5167),
    [anon_sym_function] = ACTIONS(5169),
    [anon_sym_EQ] = ACTIONS(5171),
    [anon_sym_if] = ACTIONS(5169),
    [anon_sym_for] = ACTIONS(5169),
    [anon_sym_while] = ACTIONS(5169),
    [anon_sym_repeat] = ACTIONS(5169),
    [anon_sym_QMARK] = ACTIONS(5167),
    [anon_sym_TILDE] = ACTIONS(5173),
    [anon_sym_BANG] = ACTIONS(5169),
    [anon_sym_PLUS] = ACTIONS(5175),
    [anon_sym_DASH] = ACTIONS(5177),
    [anon_sym_LT_DASH] = ACTIONS(5179),
    [anon_sym_LT_LT_DASH] = ACTIONS(5179),
    [anon_sym_COLON_EQ] = ACTIONS(5179),
    [anon_sym_DASH_GT] = ACTIONS(5181),
    [anon_sym_DASH_GT_GT] = ACTIONS(5183),
    [anon_sym_PIPE] = ACTIONS(5185),
    [anon_sym_AMP] = ACTIONS(5187),
    [anon_sym_PIPE_PIPE] = ACTIONS(5189),
    [anon_sym_AMP_AMP] = ACTIONS(5191),
    [anon_sym_LT] = ACTIONS(5193),
    [anon_sym_LT_EQ] = ACTIONS(5195),
    [anon_sym_GT] = ACTIONS(5193),
    [anon_sym_GT_EQ] = ACTIONS(5195),
    [anon_sym_EQ_EQ] = ACTIONS(5195),
    [anon_sym_BANG_EQ] = ACTIONS(5195),
    [anon_sym_STAR] = ACTIONS(5197),
    [anon_sym_SLASH] = ACTIONS(5199),
    [anon_sym_STAR_STAR] = ACTIONS(5201),
    [anon_sym_CARET] = ACTIONS(5201),
    [aux_sym_binary_operator_token1] = ACTIONS(5203),
    [anon_sym_PIPE_GT] = ACTIONS(5203),
    [anon_sym_COLON] = ACTIONS(5205),
    [anon_sym_DOLLAR] = ACTIONS(5207),
    [anon_sym_AT] = ACTIONS(5207),
    [aux_sym__hex_literal_token1] = ACTIONS(5167),
    [sym__number_literal] = ACTIONS(5169),
    [anon_sym_SQUOTE] = ACTIONS(5167),
    [anon_sym_DQUOTE] = ACTIONS(5167),
    [sym_return] = ACTIONS(5169),
    [sym_next] = ACTIONS(5169),
    [sym_break] = ACTIONS(5169),
    [sym_true] = ACTIONS(5169),
    [sym_false] = ACTIONS(5169),
    [sym_null] = ACTIONS(5169),
    [sym_inf] = ACTIONS(5169),
    [sym_nan] = ACTIONS(5169),
    [anon_sym_NA] = ACTIONS(5169),
    [anon_sym_NA_integer_] = ACTIONS(5169),
    [anon_sym_NA_real_] = ACTIONS(5169),
    [anon_sym_NA_complex_] = ACTIONS(5169),
    [anon_sym_NA_character_] = ACTIONS(5169),
    [sym_dots] = ACTIONS(5169),
    [sym_dot_dot_i] = ACTIONS(5167),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5167),
    [sym__newline] = ACTIONS(5167),
    [sym__semicolon] = ACTIONS(5167),
    [sym__raw_string_literal] = ACTIONS(5167),
    [sym__external_else] = ACTIONS(5209),
    [sym__external_open_parenthesis] = ACTIONS(5211),
    [sym__external_close_parenthesis] = ACTIONS(5167),
    [sym__external_open_brace] = ACTIONS(5167),
    [sym__external_close_brace] = ACTIONS(5167),
    [sym__external_open_bracket] = ACTIONS(5213),
    [sym__external_open_bracket2] = ACTIONS(5215),
  },
  [480] = {
    [sym_call_arguments] = STATE(2318),
    [sym_subset_arguments] = STATE(2319),
    [sym_subset2_arguments] = STATE(2320),
    [sym__else] = STATE(4329),
    [sym__open_parenthesis] = STATE(1329),
    [sym__open_bracket] = STATE(1328),
    [sym__open_bracket2] = STATE(1327),
    [sym_identifier] = ACTIONS(5169),
    [anon_sym_BSLASH] = ACTIONS(5167),
    [anon_sym_function] = ACTIONS(5169),
    [anon_sym_EQ] = ACTIONS(5119),
    [anon_sym_if] = ACTIONS(5169),
    [anon_sym_for] = ACTIONS(5169),
    [anon_sym_while] = ACTIONS(5169),
    [anon_sym_repeat] = ACTIONS(5169),
    [anon_sym_QMARK] = ACTIONS(5167),
    [anon_sym_TILDE] = ACTIONS(5121),
    [anon_sym_BANG] = ACTIONS(5169),
    [anon_sym_PLUS] = ACTIONS(5123),
    [anon_sym_DASH] = ACTIONS(5125),
    [anon_sym_LT_DASH] = ACTIONS(5127),
    [anon_sym_LT_LT_DASH] = ACTIONS(5127),
    [anon_sym_COLON_EQ] = ACTIONS(5127),
    [anon_sym_DASH_GT] = ACTIONS(5129),
    [anon_sym_DASH_GT_GT] = ACTIONS(5131),
    [anon_sym_PIPE] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5135),
    [anon_sym_PIPE_PIPE] = ACTIONS(5137),
    [anon_sym_AMP_AMP] = ACTIONS(5139),
    [anon_sym_LT] = ACTIONS(5141),
    [anon_sym_LT_EQ] = ACTIONS(5143),
    [anon_sym_GT] = ACTIONS(5141),
    [anon_sym_GT_EQ] = ACTIONS(5143),
    [anon_sym_EQ_EQ] = ACTIONS(5143),
    [anon_sym_BANG_EQ] = ACTIONS(5143),
    [anon_sym_STAR] = ACTIONS(5145),
    [anon_sym_SLASH] = ACTIONS(5147),
    [anon_sym_STAR_STAR] = ACTIONS(5149),
    [anon_sym_CARET] = ACTIONS(5149),
    [aux_sym_binary_operator_token1] = ACTIONS(5151),
    [anon_sym_PIPE_GT] = ACTIONS(5151),
    [anon_sym_COLON] = ACTIONS(5153),
    [anon_sym_DOLLAR] = ACTIONS(5155),
    [anon_sym_AT] = ACTIONS(5155),
    [aux_sym__hex_literal_token1] = ACTIONS(5167),
    [sym__number_literal] = ACTIONS(5169),
    [anon_sym_SQUOTE] = ACTIONS(5167),
    [anon_sym_DQUOTE] = ACTIONS(5167),
    [sym_return] = ACTIONS(5169),
    [sym_next] = ACTIONS(5169),
    [sym_break] = ACTIONS(5169),
    [sym_true] = ACTIONS(5169),
    [sym_false] = ACTIONS(5169),
    [sym_null] = ACTIONS(5169),
    [sym_inf] = ACTIONS(5169),
    [sym_nan] = ACTIONS(5169),
    [anon_sym_NA] = ACTIONS(5169),
    [anon_sym_NA_integer_] = ACTIONS(5169),
    [anon_sym_NA_real_] = ACTIONS(5169),
    [anon_sym_NA_complex_] = ACTIONS(5169),
    [anon_sym_NA_character_] = ACTIONS(5169),
    [sym_dots] = ACTIONS(5169),
    [sym_dot_dot_i] = ACTIONS(5167),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5167),
    [sym__newline] = ACTIONS(5167),
    [sym__semicolon] = ACTIONS(5167),
    [sym__raw_string_literal] = ACTIONS(5167),
    [sym__external_else] = ACTIONS(5217),
    [sym__external_open_parenthesis] = ACTIONS(5159),
    [sym__external_close_parenthesis] = ACTIONS(5167),
    [sym__external_open_brace] = ACTIONS(5167),
    [sym__external_close_brace] = ACTIONS(5167),
    [sym__external_open_bracket] = ACTIONS(5161),
    [sym__external_close_bracket] = ACTIONS(5167),
    [sym__external_open_bracket2] = ACTIONS(5163),
  },
  [481] = {
    [sym_call_arguments] = STATE(2342),
    [sym_subset_arguments] = STATE(2343),
    [sym_subset2_arguments] = STATE(2346),
    [sym__else] = STATE(4131),
    [sym__open_parenthesis] = STATE(1325),
    [sym__open_bracket] = STATE(1322),
    [sym__open_bracket2] = STATE(1607),
    [sym_identifier] = ACTIONS(5169),
    [anon_sym_BSLASH] = ACTIONS(5167),
    [anon_sym_function] = ACTIONS(5169),
    [anon_sym_EQ] = ACTIONS(5069),
    [anon_sym_if] = ACTIONS(5169),
    [anon_sym_for] = ACTIONS(5169),
    [anon_sym_while] = ACTIONS(5169),
    [anon_sym_repeat] = ACTIONS(5169),
    [anon_sym_QMARK] = ACTIONS(5167),
    [anon_sym_TILDE] = ACTIONS(5071),
    [anon_sym_BANG] = ACTIONS(5169),
    [anon_sym_PLUS] = ACTIONS(5073),
    [anon_sym_DASH] = ACTIONS(5075),
    [anon_sym_LT_DASH] = ACTIONS(5077),
    [anon_sym_LT_LT_DASH] = ACTIONS(5077),
    [anon_sym_COLON_EQ] = ACTIONS(5077),
    [anon_sym_DASH_GT] = ACTIONS(5079),
    [anon_sym_DASH_GT_GT] = ACTIONS(5081),
    [anon_sym_PIPE] = ACTIONS(5083),
    [anon_sym_AMP] = ACTIONS(5085),
    [anon_sym_PIPE_PIPE] = ACTIONS(5087),
    [anon_sym_AMP_AMP] = ACTIONS(5089),
    [anon_sym_LT] = ACTIONS(5091),
    [anon_sym_LT_EQ] = ACTIONS(5093),
    [anon_sym_GT] = ACTIONS(5091),
    [anon_sym_GT_EQ] = ACTIONS(5093),
    [anon_sym_EQ_EQ] = ACTIONS(5093),
    [anon_sym_BANG_EQ] = ACTIONS(5093),
    [anon_sym_STAR] = ACTIONS(5095),
    [anon_sym_SLASH] = ACTIONS(5097),
    [anon_sym_STAR_STAR] = ACTIONS(5099),
    [anon_sym_CARET] = ACTIONS(5099),
    [aux_sym_binary_operator_token1] = ACTIONS(5101),
    [anon_sym_PIPE_GT] = ACTIONS(5101),
    [anon_sym_COLON] = ACTIONS(5103),
    [anon_sym_DOLLAR] = ACTIONS(5105),
    [anon_sym_AT] = ACTIONS(5105),
    [aux_sym__hex_literal_token1] = ACTIONS(5167),
    [sym__number_literal] = ACTIONS(5169),
    [anon_sym_SQUOTE] = ACTIONS(5167),
    [anon_sym_DQUOTE] = ACTIONS(5167),
    [sym_return] = ACTIONS(5169),
    [sym_next] = ACTIONS(5169),
    [sym_break] = ACTIONS(5169),
    [sym_true] = ACTIONS(5169),
    [sym_false] = ACTIONS(5169),
    [sym_null] = ACTIONS(5169),
    [sym_inf] = ACTIONS(5169),
    [sym_nan] = ACTIONS(5169),
    [anon_sym_NA] = ACTIONS(5169),
    [anon_sym_NA_integer_] = ACTIONS(5169),
    [anon_sym_NA_real_] = ACTIONS(5169),
    [anon_sym_NA_complex_] = ACTIONS(5169),
    [anon_sym_NA_character_] = ACTIONS(5169),
    [sym_dots] = ACTIONS(5169),
    [sym_dot_dot_i] = ACTIONS(5167),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5167),
    [sym__newline] = ACTIONS(5167),
    [sym__semicolon] = ACTIONS(5167),
    [sym__raw_string_literal] = ACTIONS(5167),
    [sym__external_else] = ACTIONS(5219),
    [sym__external_open_parenthesis] = ACTIONS(5109),
    [sym__external_close_parenthesis] = ACTIONS(5167),
    [sym__external_open_brace] = ACTIONS(5167),
    [sym__external_close_brace] = ACTIONS(5167),
    [sym__external_open_bracket] = ACTIONS(5111),
    [sym__external_open_bracket2] = ACTIONS(5113),
    [sym__external_close_bracket2] = ACTIONS(5167),
  },
  [482] = {
    [sym_call_arguments] = STATE(2318),
    [sym_subset_arguments] = STATE(2319),
    [sym_subset2_arguments] = STATE(2320),
    [sym__else] = STATE(4099),
    [sym__open_parenthesis] = STATE(1329),
    [sym__open_bracket] = STATE(1328),
    [sym__open_bracket2] = STATE(1327),
    [sym_identifier] = ACTIONS(5169),
    [anon_sym_BSLASH] = ACTIONS(5167),
    [anon_sym_function] = ACTIONS(5169),
    [anon_sym_EQ] = ACTIONS(5119),
    [anon_sym_if] = ACTIONS(5169),
    [anon_sym_for] = ACTIONS(5169),
    [anon_sym_while] = ACTIONS(5169),
    [anon_sym_repeat] = ACTIONS(5169),
    [anon_sym_QMARK] = ACTIONS(5167),
    [anon_sym_TILDE] = ACTIONS(5121),
    [anon_sym_BANG] = ACTIONS(5169),
    [anon_sym_PLUS] = ACTIONS(5123),
    [anon_sym_DASH] = ACTIONS(5125),
    [anon_sym_LT_DASH] = ACTIONS(5127),
    [anon_sym_LT_LT_DASH] = ACTIONS(5127),
    [anon_sym_COLON_EQ] = ACTIONS(5127),
    [anon_sym_DASH_GT] = ACTIONS(5129),
    [anon_sym_DASH_GT_GT] = ACTIONS(5131),
    [anon_sym_PIPE] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5135),
    [anon_sym_PIPE_PIPE] = ACTIONS(5137),
    [anon_sym_AMP_AMP] = ACTIONS(5139),
    [anon_sym_LT] = ACTIONS(5141),
    [anon_sym_LT_EQ] = ACTIONS(5143),
    [anon_sym_GT] = ACTIONS(5141),
    [anon_sym_GT_EQ] = ACTIONS(5143),
    [anon_sym_EQ_EQ] = ACTIONS(5143),
    [anon_sym_BANG_EQ] = ACTIONS(5143),
    [anon_sym_STAR] = ACTIONS(5145),
    [anon_sym_SLASH] = ACTIONS(5147),
    [anon_sym_STAR_STAR] = ACTIONS(5149),
    [anon_sym_CARET] = ACTIONS(5149),
    [aux_sym_binary_operator_token1] = ACTIONS(5151),
    [anon_sym_PIPE_GT] = ACTIONS(5151),
    [anon_sym_COLON] = ACTIONS(5153),
    [anon_sym_DOLLAR] = ACTIONS(5155),
    [anon_sym_AT] = ACTIONS(5155),
    [aux_sym__hex_literal_token1] = ACTIONS(5167),
    [sym__number_literal] = ACTIONS(5169),
    [anon_sym_SQUOTE] = ACTIONS(5167),
    [anon_sym_DQUOTE] = ACTIONS(5167),
    [sym_return] = ACTIONS(5169),
    [sym_next] = ACTIONS(5169),
    [sym_break] = ACTIONS(5169),
    [sym_true] = ACTIONS(5169),
    [sym_false] = ACTIONS(5169),
    [sym_null] = ACTIONS(5169),
    [sym_inf] = ACTIONS(5169),
    [sym_nan] = ACTIONS(5169),
    [anon_sym_NA] = ACTIONS(5169),
    [anon_sym_NA_integer_] = ACTIONS(5169),
    [anon_sym_NA_real_] = ACTIONS(5169),
    [anon_sym_NA_complex_] = ACTIONS(5169),
    [anon_sym_NA_character_] = ACTIONS(5169),
    [sym_dots] = ACTIONS(5169),
    [sym_dot_dot_i] = ACTIONS(5167),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5167),
    [sym__newline] = ACTIONS(5167),
    [sym__semicolon] = ACTIONS(5167),
    [sym__raw_string_literal] = ACTIONS(5167),
    [sym__external_else] = ACTIONS(5221),
    [sym__external_open_parenthesis] = ACTIONS(5159),
    [sym__external_close_parenthesis] = ACTIONS(5167),
    [sym__external_open_brace] = ACTIONS(5167),
    [sym__external_close_brace] = ACTIONS(5167),
    [sym__external_open_bracket] = ACTIONS(5161),
    [sym__external_close_bracket] = ACTIONS(5167),
    [sym__external_open_bracket2] = ACTIONS(5163),
  },
  [483] = {
    [sym_call_arguments] = STATE(2318),
    [sym_subset_arguments] = STATE(2319),
    [sym_subset2_arguments] = STATE(2320),
    [sym__else] = STATE(4368),
    [sym__open_parenthesis] = STATE(1329),
    [sym__open_bracket] = STATE(1328),
    [sym__open_bracket2] = STATE(1327),
    [sym_identifier] = ACTIONS(5065),
    [anon_sym_BSLASH] = ACTIONS(5067),
    [anon_sym_function] = ACTIONS(5065),
    [anon_sym_EQ] = ACTIONS(5119),
    [anon_sym_if] = ACTIONS(5065),
    [anon_sym_for] = ACTIONS(5065),
    [anon_sym_while] = ACTIONS(5065),
    [anon_sym_repeat] = ACTIONS(5065),
    [anon_sym_QMARK] = ACTIONS(5067),
    [anon_sym_TILDE] = ACTIONS(5121),
    [anon_sym_BANG] = ACTIONS(5065),
    [anon_sym_PLUS] = ACTIONS(5123),
    [anon_sym_DASH] = ACTIONS(5125),
    [anon_sym_LT_DASH] = ACTIONS(5127),
    [anon_sym_LT_LT_DASH] = ACTIONS(5127),
    [anon_sym_COLON_EQ] = ACTIONS(5127),
    [anon_sym_DASH_GT] = ACTIONS(5129),
    [anon_sym_DASH_GT_GT] = ACTIONS(5131),
    [anon_sym_PIPE] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5135),
    [anon_sym_PIPE_PIPE] = ACTIONS(5137),
    [anon_sym_AMP_AMP] = ACTIONS(5139),
    [anon_sym_LT] = ACTIONS(5141),
    [anon_sym_LT_EQ] = ACTIONS(5143),
    [anon_sym_GT] = ACTIONS(5141),
    [anon_sym_GT_EQ] = ACTIONS(5143),
    [anon_sym_EQ_EQ] = ACTIONS(5143),
    [anon_sym_BANG_EQ] = ACTIONS(5143),
    [anon_sym_STAR] = ACTIONS(5145),
    [anon_sym_SLASH] = ACTIONS(5147),
    [anon_sym_STAR_STAR] = ACTIONS(5149),
    [anon_sym_CARET] = ACTIONS(5149),
    [aux_sym_binary_operator_token1] = ACTIONS(5151),
    [anon_sym_PIPE_GT] = ACTIONS(5151),
    [anon_sym_COLON] = ACTIONS(5153),
    [anon_sym_DOLLAR] = ACTIONS(5155),
    [anon_sym_AT] = ACTIONS(5155),
    [aux_sym__hex_literal_token1] = ACTIONS(5067),
    [sym__number_literal] = ACTIONS(5065),
    [anon_sym_SQUOTE] = ACTIONS(5067),
    [anon_sym_DQUOTE] = ACTIONS(5067),
    [sym_return] = ACTIONS(5065),
    [sym_next] = ACTIONS(5065),
    [sym_break] = ACTIONS(5065),
    [sym_true] = ACTIONS(5065),
    [sym_false] = ACTIONS(5065),
    [sym_null] = ACTIONS(5065),
    [sym_inf] = ACTIONS(5065),
    [sym_nan] = ACTIONS(5065),
    [anon_sym_NA] = ACTIONS(5065),
    [anon_sym_NA_integer_] = ACTIONS(5065),
    [anon_sym_NA_real_] = ACTIONS(5065),
    [anon_sym_NA_complex_] = ACTIONS(5065),
    [anon_sym_NA_character_] = ACTIONS(5065),
    [sym_dots] = ACTIONS(5065),
    [sym_dot_dot_i] = ACTIONS(5067),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5067),
    [sym__newline] = ACTIONS(5067),
    [sym__semicolon] = ACTIONS(5067),
    [sym__raw_string_literal] = ACTIONS(5067),
    [sym__external_else] = ACTIONS(5223),
    [sym__external_open_parenthesis] = ACTIONS(5159),
    [sym__external_close_parenthesis] = ACTIONS(5067),
    [sym__external_open_brace] = ACTIONS(5067),
    [sym__external_close_brace] = ACTIONS(5067),
    [sym__external_open_bracket] = ACTIONS(5161),
    [sym__external_close_bracket] = ACTIONS(5067),
    [sym__external_open_bracket2] = ACTIONS(5163),
  },
  [484] = {
    [sym_call_arguments] = STATE(2342),
    [sym_subset_arguments] = STATE(2343),
    [sym_subset2_arguments] = STATE(2346),
    [sym__else] = STATE(4125),
    [sym__open_parenthesis] = STATE(1325),
    [sym__open_bracket] = STATE(1322),
    [sym__open_bracket2] = STATE(1607),
    [sym_identifier] = ACTIONS(5225),
    [anon_sym_BSLASH] = ACTIONS(5227),
    [anon_sym_function] = ACTIONS(5225),
    [anon_sym_EQ] = ACTIONS(5069),
    [anon_sym_if] = ACTIONS(5225),
    [anon_sym_for] = ACTIONS(5225),
    [anon_sym_while] = ACTIONS(5225),
    [anon_sym_repeat] = ACTIONS(5225),
    [anon_sym_QMARK] = ACTIONS(5227),
    [anon_sym_TILDE] = ACTIONS(5071),
    [anon_sym_BANG] = ACTIONS(5225),
    [anon_sym_PLUS] = ACTIONS(5073),
    [anon_sym_DASH] = ACTIONS(5075),
    [anon_sym_LT_DASH] = ACTIONS(5077),
    [anon_sym_LT_LT_DASH] = ACTIONS(5077),
    [anon_sym_COLON_EQ] = ACTIONS(5077),
    [anon_sym_DASH_GT] = ACTIONS(5079),
    [anon_sym_DASH_GT_GT] = ACTIONS(5081),
    [anon_sym_PIPE] = ACTIONS(5083),
    [anon_sym_AMP] = ACTIONS(5085),
    [anon_sym_PIPE_PIPE] = ACTIONS(5087),
    [anon_sym_AMP_AMP] = ACTIONS(5089),
    [anon_sym_LT] = ACTIONS(5091),
    [anon_sym_LT_EQ] = ACTIONS(5093),
    [anon_sym_GT] = ACTIONS(5091),
    [anon_sym_GT_EQ] = ACTIONS(5093),
    [anon_sym_EQ_EQ] = ACTIONS(5093),
    [anon_sym_BANG_EQ] = ACTIONS(5093),
    [anon_sym_STAR] = ACTIONS(5095),
    [anon_sym_SLASH] = ACTIONS(5097),
    [anon_sym_STAR_STAR] = ACTIONS(5099),
    [anon_sym_CARET] = ACTIONS(5099),
    [aux_sym_binary_operator_token1] = ACTIONS(5101),
    [anon_sym_PIPE_GT] = ACTIONS(5101),
    [anon_sym_COLON] = ACTIONS(5103),
    [anon_sym_DOLLAR] = ACTIONS(5105),
    [anon_sym_AT] = ACTIONS(5105),
    [aux_sym__hex_literal_token1] = ACTIONS(5227),
    [sym__number_literal] = ACTIONS(5225),
    [anon_sym_SQUOTE] = ACTIONS(5227),
    [anon_sym_DQUOTE] = ACTIONS(5227),
    [sym_return] = ACTIONS(5225),
    [sym_next] = ACTIONS(5225),
    [sym_break] = ACTIONS(5225),
    [sym_true] = ACTIONS(5225),
    [sym_false] = ACTIONS(5225),
    [sym_null] = ACTIONS(5225),
    [sym_inf] = ACTIONS(5225),
    [sym_nan] = ACTIONS(5225),
    [anon_sym_NA] = ACTIONS(5225),
    [anon_sym_NA_integer_] = ACTIONS(5225),
    [anon_sym_NA_real_] = ACTIONS(5225),
    [anon_sym_NA_complex_] = ACTIONS(5225),
    [anon_sym_NA_character_] = ACTIONS(5225),
    [sym_dots] = ACTIONS(5225),
    [sym_dot_dot_i] = ACTIONS(5227),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5227),
    [sym__newline] = ACTIONS(5227),
    [sym__semicolon] = ACTIONS(5227),
    [sym__raw_string_literal] = ACTIONS(5227),
    [sym__external_else] = ACTIONS(5229),
    [sym__external_open_parenthesis] = ACTIONS(5109),
    [sym__external_close_parenthesis] = ACTIONS(5227),
    [sym__external_open_brace] = ACTIONS(5227),
    [sym__external_close_brace] = ACTIONS(5227),
    [sym__external_open_bracket] = ACTIONS(5111),
    [sym__external_open_bracket2] = ACTIONS(5113),
    [sym__external_close_bracket2] = ACTIONS(5227),
  },
  [485] = {
    [sym_call_arguments] = STATE(2318),
    [sym_subset_arguments] = STATE(2319),
    [sym_subset2_arguments] = STATE(2320),
    [sym__else] = STATE(4097),
    [sym__open_parenthesis] = STATE(1329),
    [sym__open_bracket] = STATE(1328),
    [sym__open_bracket2] = STATE(1327),
    [sym_identifier] = ACTIONS(5065),
    [anon_sym_BSLASH] = ACTIONS(5067),
    [anon_sym_function] = ACTIONS(5065),
    [anon_sym_EQ] = ACTIONS(5119),
    [anon_sym_if] = ACTIONS(5065),
    [anon_sym_for] = ACTIONS(5065),
    [anon_sym_while] = ACTIONS(5065),
    [anon_sym_repeat] = ACTIONS(5065),
    [anon_sym_QMARK] = ACTIONS(5067),
    [anon_sym_TILDE] = ACTIONS(5121),
    [anon_sym_BANG] = ACTIONS(5065),
    [anon_sym_PLUS] = ACTIONS(5123),
    [anon_sym_DASH] = ACTIONS(5125),
    [anon_sym_LT_DASH] = ACTIONS(5127),
    [anon_sym_LT_LT_DASH] = ACTIONS(5127),
    [anon_sym_COLON_EQ] = ACTIONS(5127),
    [anon_sym_DASH_GT] = ACTIONS(5129),
    [anon_sym_DASH_GT_GT] = ACTIONS(5131),
    [anon_sym_PIPE] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5135),
    [anon_sym_PIPE_PIPE] = ACTIONS(5137),
    [anon_sym_AMP_AMP] = ACTIONS(5139),
    [anon_sym_LT] = ACTIONS(5141),
    [anon_sym_LT_EQ] = ACTIONS(5143),
    [anon_sym_GT] = ACTIONS(5141),
    [anon_sym_GT_EQ] = ACTIONS(5143),
    [anon_sym_EQ_EQ] = ACTIONS(5143),
    [anon_sym_BANG_EQ] = ACTIONS(5143),
    [anon_sym_STAR] = ACTIONS(5145),
    [anon_sym_SLASH] = ACTIONS(5147),
    [anon_sym_STAR_STAR] = ACTIONS(5149),
    [anon_sym_CARET] = ACTIONS(5149),
    [aux_sym_binary_operator_token1] = ACTIONS(5151),
    [anon_sym_PIPE_GT] = ACTIONS(5151),
    [anon_sym_COLON] = ACTIONS(5153),
    [anon_sym_DOLLAR] = ACTIONS(5155),
    [anon_sym_AT] = ACTIONS(5155),
    [aux_sym__hex_literal_token1] = ACTIONS(5067),
    [sym__number_literal] = ACTIONS(5065),
    [anon_sym_SQUOTE] = ACTIONS(5067),
    [anon_sym_DQUOTE] = ACTIONS(5067),
    [sym_return] = ACTIONS(5065),
    [sym_next] = ACTIONS(5065),
    [sym_break] = ACTIONS(5065),
    [sym_true] = ACTIONS(5065),
    [sym_false] = ACTIONS(5065),
    [sym_null] = ACTIONS(5065),
    [sym_inf] = ACTIONS(5065),
    [sym_nan] = ACTIONS(5065),
    [anon_sym_NA] = ACTIONS(5065),
    [anon_sym_NA_integer_] = ACTIONS(5065),
    [anon_sym_NA_real_] = ACTIONS(5065),
    [anon_sym_NA_complex_] = ACTIONS(5065),
    [anon_sym_NA_character_] = ACTIONS(5065),
    [sym_dots] = ACTIONS(5065),
    [sym_dot_dot_i] = ACTIONS(5067),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5067),
    [sym__newline] = ACTIONS(5067),
    [sym__semicolon] = ACTIONS(5067),
    [sym__raw_string_literal] = ACTIONS(5067),
    [sym__external_else] = ACTIONS(5231),
    [sym__external_open_parenthesis] = ACTIONS(5159),
    [sym__external_close_parenthesis] = ACTIONS(5067),
    [sym__external_open_brace] = ACTIONS(5067),
    [sym__external_close_brace] = ACTIONS(5067),
    [sym__external_open_bracket] = ACTIONS(5161),
    [sym__external_close_bracket] = ACTIONS(5067),
    [sym__external_open_bracket2] = ACTIONS(5163),
  },
  [486] = {
    [sym_call_arguments] = STATE(2318),
    [sym_subset_arguments] = STATE(2319),
    [sym_subset2_arguments] = STATE(2320),
    [sym__else] = STATE(4255),
    [sym__open_parenthesis] = STATE(1329),
    [sym__open_bracket] = STATE(1328),
    [sym__open_bracket2] = STATE(1327),
    [sym_identifier] = ACTIONS(5225),
    [anon_sym_BSLASH] = ACTIONS(5227),
    [anon_sym_function] = ACTIONS(5225),
    [anon_sym_EQ] = ACTIONS(5119),
    [anon_sym_if] = ACTIONS(5225),
    [anon_sym_for] = ACTIONS(5225),
    [anon_sym_while] = ACTIONS(5225),
    [anon_sym_repeat] = ACTIONS(5225),
    [anon_sym_QMARK] = ACTIONS(5227),
    [anon_sym_TILDE] = ACTIONS(5121),
    [anon_sym_BANG] = ACTIONS(5225),
    [anon_sym_PLUS] = ACTIONS(5123),
    [anon_sym_DASH] = ACTIONS(5125),
    [anon_sym_LT_DASH] = ACTIONS(5127),
    [anon_sym_LT_LT_DASH] = ACTIONS(5127),
    [anon_sym_COLON_EQ] = ACTIONS(5127),
    [anon_sym_DASH_GT] = ACTIONS(5129),
    [anon_sym_DASH_GT_GT] = ACTIONS(5131),
    [anon_sym_PIPE] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5135),
    [anon_sym_PIPE_PIPE] = ACTIONS(5137),
    [anon_sym_AMP_AMP] = ACTIONS(5139),
    [anon_sym_LT] = ACTIONS(5141),
    [anon_sym_LT_EQ] = ACTIONS(5143),
    [anon_sym_GT] = ACTIONS(5141),
    [anon_sym_GT_EQ] = ACTIONS(5143),
    [anon_sym_EQ_EQ] = ACTIONS(5143),
    [anon_sym_BANG_EQ] = ACTIONS(5143),
    [anon_sym_STAR] = ACTIONS(5145),
    [anon_sym_SLASH] = ACTIONS(5147),
    [anon_sym_STAR_STAR] = ACTIONS(5149),
    [anon_sym_CARET] = ACTIONS(5149),
    [aux_sym_binary_operator_token1] = ACTIONS(5151),
    [anon_sym_PIPE_GT] = ACTIONS(5151),
    [anon_sym_COLON] = ACTIONS(5153),
    [anon_sym_DOLLAR] = ACTIONS(5155),
    [anon_sym_AT] = ACTIONS(5155),
    [aux_sym__hex_literal_token1] = ACTIONS(5227),
    [sym__number_literal] = ACTIONS(5225),
    [anon_sym_SQUOTE] = ACTIONS(5227),
    [anon_sym_DQUOTE] = ACTIONS(5227),
    [sym_return] = ACTIONS(5225),
    [sym_next] = ACTIONS(5225),
    [sym_break] = ACTIONS(5225),
    [sym_true] = ACTIONS(5225),
    [sym_false] = ACTIONS(5225),
    [sym_null] = ACTIONS(5225),
    [sym_inf] = ACTIONS(5225),
    [sym_nan] = ACTIONS(5225),
    [anon_sym_NA] = ACTIONS(5225),
    [anon_sym_NA_integer_] = ACTIONS(5225),
    [anon_sym_NA_real_] = ACTIONS(5225),
    [anon_sym_NA_complex_] = ACTIONS(5225),
    [anon_sym_NA_character_] = ACTIONS(5225),
    [sym_dots] = ACTIONS(5225),
    [sym_dot_dot_i] = ACTIONS(5227),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5227),
    [sym__newline] = ACTIONS(5227),
    [sym__semicolon] = ACTIONS(5227),
    [sym__raw_string_literal] = ACTIONS(5227),
    [sym__external_else] = ACTIONS(5233),
    [sym__external_open_parenthesis] = ACTIONS(5159),
    [sym__external_close_parenthesis] = ACTIONS(5227),
    [sym__external_open_brace] = ACTIONS(5227),
    [sym__external_close_brace] = ACTIONS(5227),
    [sym__external_open_bracket] = ACTIONS(5161),
    [sym__external_close_bracket] = ACTIONS(5227),
    [sym__external_open_bracket2] = ACTIONS(5163),
  },
  [487] = {
    [sym_call_arguments] = STATE(2261),
    [sym_subset_arguments] = STATE(2260),
    [sym_subset2_arguments] = STATE(2259),
    [sym__else] = STATE(4269),
    [sym__open_parenthesis] = STATE(1380),
    [sym__open_bracket] = STATE(1379),
    [sym__open_bracket2] = STATE(1378),
    [ts_builtin_sym_end] = ACTIONS(5227),
    [sym_identifier] = ACTIONS(5225),
    [anon_sym_BSLASH] = ACTIONS(5227),
    [anon_sym_function] = ACTIONS(5225),
    [anon_sym_EQ] = ACTIONS(5171),
    [anon_sym_if] = ACTIONS(5225),
    [anon_sym_for] = ACTIONS(5225),
    [anon_sym_while] = ACTIONS(5225),
    [anon_sym_repeat] = ACTIONS(5225),
    [anon_sym_QMARK] = ACTIONS(5227),
    [anon_sym_TILDE] = ACTIONS(5173),
    [anon_sym_BANG] = ACTIONS(5225),
    [anon_sym_PLUS] = ACTIONS(5175),
    [anon_sym_DASH] = ACTIONS(5177),
    [anon_sym_LT_DASH] = ACTIONS(5179),
    [anon_sym_LT_LT_DASH] = ACTIONS(5179),
    [anon_sym_COLON_EQ] = ACTIONS(5179),
    [anon_sym_DASH_GT] = ACTIONS(5181),
    [anon_sym_DASH_GT_GT] = ACTIONS(5183),
    [anon_sym_PIPE] = ACTIONS(5185),
    [anon_sym_AMP] = ACTIONS(5187),
    [anon_sym_PIPE_PIPE] = ACTIONS(5189),
    [anon_sym_AMP_AMP] = ACTIONS(5191),
    [anon_sym_LT] = ACTIONS(5193),
    [anon_sym_LT_EQ] = ACTIONS(5195),
    [anon_sym_GT] = ACTIONS(5193),
    [anon_sym_GT_EQ] = ACTIONS(5195),
    [anon_sym_EQ_EQ] = ACTIONS(5195),
    [anon_sym_BANG_EQ] = ACTIONS(5195),
    [anon_sym_STAR] = ACTIONS(5197),
    [anon_sym_SLASH] = ACTIONS(5199),
    [anon_sym_STAR_STAR] = ACTIONS(5201),
    [anon_sym_CARET] = ACTIONS(5201),
    [aux_sym_binary_operator_token1] = ACTIONS(5203),
    [anon_sym_PIPE_GT] = ACTIONS(5203),
    [anon_sym_COLON] = ACTIONS(5205),
    [anon_sym_DOLLAR] = ACTIONS(5207),
    [anon_sym_AT] = ACTIONS(5207),
    [aux_sym__hex_literal_token1] = ACTIONS(5227),
    [sym__number_literal] = ACTIONS(5225),
    [anon_sym_SQUOTE] = ACTIONS(5227),
    [anon_sym_DQUOTE] = ACTIONS(5227),
    [sym_return] = ACTIONS(5225),
    [sym_next] = ACTIONS(5225),
    [sym_break] = ACTIONS(5225),
    [sym_true] = ACTIONS(5225),
    [sym_false] = ACTIONS(5225),
    [sym_null] = ACTIONS(5225),
    [sym_inf] = ACTIONS(5225),
    [sym_nan] = ACTIONS(5225),
    [anon_sym_NA] = ACTIONS(5225),
    [anon_sym_NA_integer_] = ACTIONS(5225),
    [anon_sym_NA_real_] = ACTIONS(5225),
    [anon_sym_NA_complex_] = ACTIONS(5225),
    [anon_sym_NA_character_] = ACTIONS(5225),
    [sym_dots] = ACTIONS(5225),
    [sym_dot_dot_i] = ACTIONS(5227),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5227),
    [sym__newline] = ACTIONS(5227),
    [sym__semicolon] = ACTIONS(5227),
    [sym__raw_string_literal] = ACTIONS(5227),
    [sym__external_else] = ACTIONS(5235),
    [sym__external_open_parenthesis] = ACTIONS(5211),
    [sym__external_close_parenthesis] = ACTIONS(5227),
    [sym__external_open_brace] = ACTIONS(5227),
    [sym__external_close_brace] = ACTIONS(5227),
    [sym__external_open_bracket] = ACTIONS(5213),
    [sym__external_open_bracket2] = ACTIONS(5215),
  },
  [488] = {
    [sym_call_arguments] = STATE(2261),
    [sym_subset_arguments] = STATE(2260),
    [sym_subset2_arguments] = STATE(2259),
    [sym__else] = STATE(4357),
    [sym__open_parenthesis] = STATE(1380),
    [sym__open_bracket] = STATE(1379),
    [sym__open_bracket2] = STATE(1378),
    [ts_builtin_sym_end] = ACTIONS(5227),
    [sym_identifier] = ACTIONS(5225),
    [anon_sym_BSLASH] = ACTIONS(5227),
    [anon_sym_function] = ACTIONS(5225),
    [anon_sym_EQ] = ACTIONS(5171),
    [anon_sym_if] = ACTIONS(5225),
    [anon_sym_for] = ACTIONS(5225),
    [anon_sym_while] = ACTIONS(5225),
    [anon_sym_repeat] = ACTIONS(5225),
    [anon_sym_QMARK] = ACTIONS(5227),
    [anon_sym_TILDE] = ACTIONS(5173),
    [anon_sym_BANG] = ACTIONS(5225),
    [anon_sym_PLUS] = ACTIONS(5175),
    [anon_sym_DASH] = ACTIONS(5177),
    [anon_sym_LT_DASH] = ACTIONS(5179),
    [anon_sym_LT_LT_DASH] = ACTIONS(5179),
    [anon_sym_COLON_EQ] = ACTIONS(5179),
    [anon_sym_DASH_GT] = ACTIONS(5181),
    [anon_sym_DASH_GT_GT] = ACTIONS(5183),
    [anon_sym_PIPE] = ACTIONS(5185),
    [anon_sym_AMP] = ACTIONS(5187),
    [anon_sym_PIPE_PIPE] = ACTIONS(5189),
    [anon_sym_AMP_AMP] = ACTIONS(5191),
    [anon_sym_LT] = ACTIONS(5193),
    [anon_sym_LT_EQ] = ACTIONS(5195),
    [anon_sym_GT] = ACTIONS(5193),
    [anon_sym_GT_EQ] = ACTIONS(5195),
    [anon_sym_EQ_EQ] = ACTIONS(5195),
    [anon_sym_BANG_EQ] = ACTIONS(5195),
    [anon_sym_STAR] = ACTIONS(5197),
    [anon_sym_SLASH] = ACTIONS(5199),
    [anon_sym_STAR_STAR] = ACTIONS(5201),
    [anon_sym_CARET] = ACTIONS(5201),
    [aux_sym_binary_operator_token1] = ACTIONS(5203),
    [anon_sym_PIPE_GT] = ACTIONS(5203),
    [anon_sym_COLON] = ACTIONS(5205),
    [anon_sym_DOLLAR] = ACTIONS(5207),
    [anon_sym_AT] = ACTIONS(5207),
    [aux_sym__hex_literal_token1] = ACTIONS(5227),
    [sym__number_literal] = ACTIONS(5225),
    [anon_sym_SQUOTE] = ACTIONS(5227),
    [anon_sym_DQUOTE] = ACTIONS(5227),
    [sym_return] = ACTIONS(5225),
    [sym_next] = ACTIONS(5225),
    [sym_break] = ACTIONS(5225),
    [sym_true] = ACTIONS(5225),
    [sym_false] = ACTIONS(5225),
    [sym_null] = ACTIONS(5225),
    [sym_inf] = ACTIONS(5225),
    [sym_nan] = ACTIONS(5225),
    [anon_sym_NA] = ACTIONS(5225),
    [anon_sym_NA_integer_] = ACTIONS(5225),
    [anon_sym_NA_real_] = ACTIONS(5225),
    [anon_sym_NA_complex_] = ACTIONS(5225),
    [anon_sym_NA_character_] = ACTIONS(5225),
    [sym_dots] = ACTIONS(5225),
    [sym_dot_dot_i] = ACTIONS(5227),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5227),
    [sym__newline] = ACTIONS(5227),
    [sym__semicolon] = ACTIONS(5227),
    [sym__raw_string_literal] = ACTIONS(5227),
    [sym__external_else] = ACTIONS(5237),
    [sym__external_open_parenthesis] = ACTIONS(5211),
    [sym__external_close_parenthesis] = ACTIONS(5227),
    [sym__external_open_brace] = ACTIONS(5227),
    [sym__external_close_brace] = ACTIONS(5227),
    [sym__external_open_bracket] = ACTIONS(5213),
    [sym__external_open_bracket2] = ACTIONS(5215),
  },
  [489] = {
    [sym_call_arguments] = STATE(2261),
    [sym_subset_arguments] = STATE(2260),
    [sym_subset2_arguments] = STATE(2259),
    [sym__else] = STATE(4260),
    [sym__open_parenthesis] = STATE(1380),
    [sym__open_bracket] = STATE(1379),
    [sym__open_bracket2] = STATE(1378),
    [ts_builtin_sym_end] = ACTIONS(5167),
    [sym_identifier] = ACTIONS(5169),
    [anon_sym_BSLASH] = ACTIONS(5167),
    [anon_sym_function] = ACTIONS(5169),
    [anon_sym_EQ] = ACTIONS(5171),
    [anon_sym_if] = ACTIONS(5169),
    [anon_sym_for] = ACTIONS(5169),
    [anon_sym_while] = ACTIONS(5169),
    [anon_sym_repeat] = ACTIONS(5169),
    [anon_sym_QMARK] = ACTIONS(5167),
    [anon_sym_TILDE] = ACTIONS(5173),
    [anon_sym_BANG] = ACTIONS(5169),
    [anon_sym_PLUS] = ACTIONS(5175),
    [anon_sym_DASH] = ACTIONS(5177),
    [anon_sym_LT_DASH] = ACTIONS(5179),
    [anon_sym_LT_LT_DASH] = ACTIONS(5179),
    [anon_sym_COLON_EQ] = ACTIONS(5179),
    [anon_sym_DASH_GT] = ACTIONS(5181),
    [anon_sym_DASH_GT_GT] = ACTIONS(5183),
    [anon_sym_PIPE] = ACTIONS(5185),
    [anon_sym_AMP] = ACTIONS(5187),
    [anon_sym_PIPE_PIPE] = ACTIONS(5189),
    [anon_sym_AMP_AMP] = ACTIONS(5191),
    [anon_sym_LT] = ACTIONS(5193),
    [anon_sym_LT_EQ] = ACTIONS(5195),
    [anon_sym_GT] = ACTIONS(5193),
    [anon_sym_GT_EQ] = ACTIONS(5195),
    [anon_sym_EQ_EQ] = ACTIONS(5195),
    [anon_sym_BANG_EQ] = ACTIONS(5195),
    [anon_sym_STAR] = ACTIONS(5197),
    [anon_sym_SLASH] = ACTIONS(5199),
    [anon_sym_STAR_STAR] = ACTIONS(5201),
    [anon_sym_CARET] = ACTIONS(5201),
    [aux_sym_binary_operator_token1] = ACTIONS(5203),
    [anon_sym_PIPE_GT] = ACTIONS(5203),
    [anon_sym_COLON] = ACTIONS(5205),
    [anon_sym_DOLLAR] = ACTIONS(5207),
    [anon_sym_AT] = ACTIONS(5207),
    [aux_sym__hex_literal_token1] = ACTIONS(5167),
    [sym__number_literal] = ACTIONS(5169),
    [anon_sym_SQUOTE] = ACTIONS(5167),
    [anon_sym_DQUOTE] = ACTIONS(5167),
    [sym_return] = ACTIONS(5169),
    [sym_next] = ACTIONS(5169),
    [sym_break] = ACTIONS(5169),
    [sym_true] = ACTIONS(5169),
    [sym_false] = ACTIONS(5169),
    [sym_null] = ACTIONS(5169),
    [sym_inf] = ACTIONS(5169),
    [sym_nan] = ACTIONS(5169),
    [anon_sym_NA] = ACTIONS(5169),
    [anon_sym_NA_integer_] = ACTIONS(5169),
    [anon_sym_NA_real_] = ACTIONS(5169),
    [anon_sym_NA_complex_] = ACTIONS(5169),
    [anon_sym_NA_character_] = ACTIONS(5169),
    [sym_dots] = ACTIONS(5169),
    [sym_dot_dot_i] = ACTIONS(5167),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5167),
    [sym__newline] = ACTIONS(5167),
    [sym__semicolon] = ACTIONS(5167),
    [sym__raw_string_literal] = ACTIONS(5167),
    [sym__external_else] = ACTIONS(5239),
    [sym__external_open_parenthesis] = ACTIONS(5211),
    [sym__external_close_parenthesis] = ACTIONS(5167),
    [sym__external_open_brace] = ACTIONS(5167),
    [sym__external_close_brace] = ACTIONS(5167),
    [sym__external_open_bracket] = ACTIONS(5213),
    [sym__external_open_bracket2] = ACTIONS(5215),
  },
  [490] = {
    [sym_call_arguments] = STATE(2318),
    [sym_subset_arguments] = STATE(2319),
    [sym_subset2_arguments] = STATE(2320),
    [sym__else] = STATE(4098),
    [sym__open_parenthesis] = STATE(1329),
    [sym__open_bracket] = STATE(1328),
    [sym__open_bracket2] = STATE(1327),
    [sym_identifier] = ACTIONS(5115),
    [anon_sym_BSLASH] = ACTIONS(5117),
    [anon_sym_function] = ACTIONS(5115),
    [anon_sym_EQ] = ACTIONS(5119),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_for] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_repeat] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(5117),
    [anon_sym_TILDE] = ACTIONS(5121),
    [anon_sym_BANG] = ACTIONS(5115),
    [anon_sym_PLUS] = ACTIONS(5123),
    [anon_sym_DASH] = ACTIONS(5125),
    [anon_sym_LT_DASH] = ACTIONS(5127),
    [anon_sym_LT_LT_DASH] = ACTIONS(5127),
    [anon_sym_COLON_EQ] = ACTIONS(5127),
    [anon_sym_DASH_GT] = ACTIONS(5129),
    [anon_sym_DASH_GT_GT] = ACTIONS(5131),
    [anon_sym_PIPE] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5135),
    [anon_sym_PIPE_PIPE] = ACTIONS(5137),
    [anon_sym_AMP_AMP] = ACTIONS(5139),
    [anon_sym_LT] = ACTIONS(5141),
    [anon_sym_LT_EQ] = ACTIONS(5143),
    [anon_sym_GT] = ACTIONS(5141),
    [anon_sym_GT_EQ] = ACTIONS(5143),
    [anon_sym_EQ_EQ] = ACTIONS(5143),
    [anon_sym_BANG_EQ] = ACTIONS(5143),
    [anon_sym_STAR] = ACTIONS(5145),
    [anon_sym_SLASH] = ACTIONS(5147),
    [anon_sym_STAR_STAR] = ACTIONS(5149),
    [anon_sym_CARET] = ACTIONS(5149),
    [aux_sym_binary_operator_token1] = ACTIONS(5151),
    [anon_sym_PIPE_GT] = ACTIONS(5151),
    [anon_sym_COLON] = ACTIONS(5153),
    [anon_sym_DOLLAR] = ACTIONS(5155),
    [anon_sym_AT] = ACTIONS(5155),
    [aux_sym__hex_literal_token1] = ACTIONS(5117),
    [sym__number_literal] = ACTIONS(5115),
    [anon_sym_SQUOTE] = ACTIONS(5117),
    [anon_sym_DQUOTE] = ACTIONS(5117),
    [sym_return] = ACTIONS(5115),
    [sym_next] = ACTIONS(5115),
    [sym_break] = ACTIONS(5115),
    [sym_true] = ACTIONS(5115),
    [sym_false] = ACTIONS(5115),
    [sym_null] = ACTIONS(5115),
    [sym_inf] = ACTIONS(5115),
    [sym_nan] = ACTIONS(5115),
    [anon_sym_NA] = ACTIONS(5115),
    [anon_sym_NA_integer_] = ACTIONS(5115),
    [anon_sym_NA_real_] = ACTIONS(5115),
    [anon_sym_NA_complex_] = ACTIONS(5115),
    [anon_sym_NA_character_] = ACTIONS(5115),
    [sym_dots] = ACTIONS(5115),
    [sym_dot_dot_i] = ACTIONS(5117),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5117),
    [sym__newline] = ACTIONS(5117),
    [sym__semicolon] = ACTIONS(5117),
    [sym__raw_string_literal] = ACTIONS(5117),
    [sym__external_else] = ACTIONS(5241),
    [sym__external_open_parenthesis] = ACTIONS(5159),
    [sym__external_close_parenthesis] = ACTIONS(5117),
    [sym__external_open_brace] = ACTIONS(5117),
    [sym__external_close_brace] = ACTIONS(5117),
    [sym__external_open_bracket] = ACTIONS(5161),
    [sym__external_close_bracket] = ACTIONS(5117),
    [sym__external_open_bracket2] = ACTIONS(5163),
  },
  [491] = {
    [sym_call_arguments] = STATE(2342),
    [sym_subset_arguments] = STATE(2343),
    [sym_subset2_arguments] = STATE(2346),
    [sym__else] = STATE(4136),
    [sym__open_parenthesis] = STATE(1325),
    [sym__open_bracket] = STATE(1322),
    [sym__open_bracket2] = STATE(1607),
    [sym_identifier] = ACTIONS(5115),
    [anon_sym_BSLASH] = ACTIONS(5117),
    [anon_sym_function] = ACTIONS(5115),
    [anon_sym_EQ] = ACTIONS(5069),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_for] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_repeat] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(5117),
    [anon_sym_TILDE] = ACTIONS(5071),
    [anon_sym_BANG] = ACTIONS(5115),
    [anon_sym_PLUS] = ACTIONS(5073),
    [anon_sym_DASH] = ACTIONS(5075),
    [anon_sym_LT_DASH] = ACTIONS(5077),
    [anon_sym_LT_LT_DASH] = ACTIONS(5077),
    [anon_sym_COLON_EQ] = ACTIONS(5077),
    [anon_sym_DASH_GT] = ACTIONS(5079),
    [anon_sym_DASH_GT_GT] = ACTIONS(5081),
    [anon_sym_PIPE] = ACTIONS(5083),
    [anon_sym_AMP] = ACTIONS(5085),
    [anon_sym_PIPE_PIPE] = ACTIONS(5087),
    [anon_sym_AMP_AMP] = ACTIONS(5089),
    [anon_sym_LT] = ACTIONS(5091),
    [anon_sym_LT_EQ] = ACTIONS(5093),
    [anon_sym_GT] = ACTIONS(5091),
    [anon_sym_GT_EQ] = ACTIONS(5093),
    [anon_sym_EQ_EQ] = ACTIONS(5093),
    [anon_sym_BANG_EQ] = ACTIONS(5093),
    [anon_sym_STAR] = ACTIONS(5095),
    [anon_sym_SLASH] = ACTIONS(5097),
    [anon_sym_STAR_STAR] = ACTIONS(5099),
    [anon_sym_CARET] = ACTIONS(5099),
    [aux_sym_binary_operator_token1] = ACTIONS(5101),
    [anon_sym_PIPE_GT] = ACTIONS(5101),
    [anon_sym_COLON] = ACTIONS(5103),
    [anon_sym_DOLLAR] = ACTIONS(5105),
    [anon_sym_AT] = ACTIONS(5105),
    [aux_sym__hex_literal_token1] = ACTIONS(5117),
    [sym__number_literal] = ACTIONS(5115),
    [anon_sym_SQUOTE] = ACTIONS(5117),
    [anon_sym_DQUOTE] = ACTIONS(5117),
    [sym_return] = ACTIONS(5115),
    [sym_next] = ACTIONS(5115),
    [sym_break] = ACTIONS(5115),
    [sym_true] = ACTIONS(5115),
    [sym_false] = ACTIONS(5115),
    [sym_null] = ACTIONS(5115),
    [sym_inf] = ACTIONS(5115),
    [sym_nan] = ACTIONS(5115),
    [anon_sym_NA] = ACTIONS(5115),
    [anon_sym_NA_integer_] = ACTIONS(5115),
    [anon_sym_NA_real_] = ACTIONS(5115),
    [anon_sym_NA_complex_] = ACTIONS(5115),
    [anon_sym_NA_character_] = ACTIONS(5115),
    [sym_dots] = ACTIONS(5115),
    [sym_dot_dot_i] = ACTIONS(5117),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5117),
    [sym__newline] = ACTIONS(5117),
    [sym__semicolon] = ACTIONS(5117),
    [sym__raw_string_literal] = ACTIONS(5117),
    [sym__external_else] = ACTIONS(5243),
    [sym__external_open_parenthesis] = ACTIONS(5109),
    [sym__external_close_parenthesis] = ACTIONS(5117),
    [sym__external_open_brace] = ACTIONS(5117),
    [sym__external_close_brace] = ACTIONS(5117),
    [sym__external_open_bracket] = ACTIONS(5111),
    [sym__external_open_bracket2] = ACTIONS(5113),
    [sym__external_close_bracket2] = ACTIONS(5117),
  },
  [492] = {
    [sym_call_arguments] = STATE(2261),
    [sym_subset_arguments] = STATE(2260),
    [sym_subset2_arguments] = STATE(2259),
    [sym__else] = STATE(4247),
    [sym__open_parenthesis] = STATE(1380),
    [sym__open_bracket] = STATE(1379),
    [sym__open_bracket2] = STATE(1378),
    [ts_builtin_sym_end] = ACTIONS(5067),
    [sym_identifier] = ACTIONS(5065),
    [anon_sym_BSLASH] = ACTIONS(5067),
    [anon_sym_function] = ACTIONS(5065),
    [anon_sym_EQ] = ACTIONS(5171),
    [anon_sym_if] = ACTIONS(5065),
    [anon_sym_for] = ACTIONS(5065),
    [anon_sym_while] = ACTIONS(5065),
    [anon_sym_repeat] = ACTIONS(5065),
    [anon_sym_QMARK] = ACTIONS(5067),
    [anon_sym_TILDE] = ACTIONS(5173),
    [anon_sym_BANG] = ACTIONS(5065),
    [anon_sym_PLUS] = ACTIONS(5175),
    [anon_sym_DASH] = ACTIONS(5177),
    [anon_sym_LT_DASH] = ACTIONS(5179),
    [anon_sym_LT_LT_DASH] = ACTIONS(5179),
    [anon_sym_COLON_EQ] = ACTIONS(5179),
    [anon_sym_DASH_GT] = ACTIONS(5181),
    [anon_sym_DASH_GT_GT] = ACTIONS(5183),
    [anon_sym_PIPE] = ACTIONS(5185),
    [anon_sym_AMP] = ACTIONS(5187),
    [anon_sym_PIPE_PIPE] = ACTIONS(5189),
    [anon_sym_AMP_AMP] = ACTIONS(5191),
    [anon_sym_LT] = ACTIONS(5193),
    [anon_sym_LT_EQ] = ACTIONS(5195),
    [anon_sym_GT] = ACTIONS(5193),
    [anon_sym_GT_EQ] = ACTIONS(5195),
    [anon_sym_EQ_EQ] = ACTIONS(5195),
    [anon_sym_BANG_EQ] = ACTIONS(5195),
    [anon_sym_STAR] = ACTIONS(5197),
    [anon_sym_SLASH] = ACTIONS(5199),
    [anon_sym_STAR_STAR] = ACTIONS(5201),
    [anon_sym_CARET] = ACTIONS(5201),
    [aux_sym_binary_operator_token1] = ACTIONS(5203),
    [anon_sym_PIPE_GT] = ACTIONS(5203),
    [anon_sym_COLON] = ACTIONS(5205),
    [anon_sym_DOLLAR] = ACTIONS(5207),
    [anon_sym_AT] = ACTIONS(5207),
    [aux_sym__hex_literal_token1] = ACTIONS(5067),
    [sym__number_literal] = ACTIONS(5065),
    [anon_sym_SQUOTE] = ACTIONS(5067),
    [anon_sym_DQUOTE] = ACTIONS(5067),
    [sym_return] = ACTIONS(5065),
    [sym_next] = ACTIONS(5065),
    [sym_break] = ACTIONS(5065),
    [sym_true] = ACTIONS(5065),
    [sym_false] = ACTIONS(5065),
    [sym_null] = ACTIONS(5065),
    [sym_inf] = ACTIONS(5065),
    [sym_nan] = ACTIONS(5065),
    [anon_sym_NA] = ACTIONS(5065),
    [anon_sym_NA_integer_] = ACTIONS(5065),
    [anon_sym_NA_real_] = ACTIONS(5065),
    [anon_sym_NA_complex_] = ACTIONS(5065),
    [anon_sym_NA_character_] = ACTIONS(5065),
    [sym_dots] = ACTIONS(5065),
    [sym_dot_dot_i] = ACTIONS(5067),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5067),
    [sym__newline] = ACTIONS(5067),
    [sym__semicolon] = ACTIONS(5067),
    [sym__raw_string_literal] = ACTIONS(5067),
    [sym__external_else] = ACTIONS(5245),
    [sym__external_open_parenthesis] = ACTIONS(5211),
    [sym__external_close_parenthesis] = ACTIONS(5067),
    [sym__external_open_brace] = ACTIONS(5067),
    [sym__external_close_brace] = ACTIONS(5067),
    [sym__external_open_bracket] = ACTIONS(5213),
    [sym__external_open_bracket2] = ACTIONS(5215),
  },
  [493] = {
    [sym_call_arguments] = STATE(2342),
    [sym_subset_arguments] = STATE(2343),
    [sym_subset2_arguments] = STATE(2346),
    [sym__else] = STATE(4143),
    [sym__open_parenthesis] = STATE(1325),
    [sym__open_bracket] = STATE(1322),
    [sym__open_bracket2] = STATE(1607),
    [sym_identifier] = ACTIONS(5225),
    [anon_sym_BSLASH] = ACTIONS(5227),
    [anon_sym_function] = ACTIONS(5225),
    [anon_sym_EQ] = ACTIONS(5069),
    [anon_sym_if] = ACTIONS(5225),
    [anon_sym_for] = ACTIONS(5225),
    [anon_sym_while] = ACTIONS(5225),
    [anon_sym_repeat] = ACTIONS(5225),
    [anon_sym_QMARK] = ACTIONS(5227),
    [anon_sym_TILDE] = ACTIONS(5071),
    [anon_sym_BANG] = ACTIONS(5225),
    [anon_sym_PLUS] = ACTIONS(5073),
    [anon_sym_DASH] = ACTIONS(5075),
    [anon_sym_LT_DASH] = ACTIONS(5077),
    [anon_sym_LT_LT_DASH] = ACTIONS(5077),
    [anon_sym_COLON_EQ] = ACTIONS(5077),
    [anon_sym_DASH_GT] = ACTIONS(5079),
    [anon_sym_DASH_GT_GT] = ACTIONS(5081),
    [anon_sym_PIPE] = ACTIONS(5083),
    [anon_sym_AMP] = ACTIONS(5085),
    [anon_sym_PIPE_PIPE] = ACTIONS(5087),
    [anon_sym_AMP_AMP] = ACTIONS(5089),
    [anon_sym_LT] = ACTIONS(5091),
    [anon_sym_LT_EQ] = ACTIONS(5093),
    [anon_sym_GT] = ACTIONS(5091),
    [anon_sym_GT_EQ] = ACTIONS(5093),
    [anon_sym_EQ_EQ] = ACTIONS(5093),
    [anon_sym_BANG_EQ] = ACTIONS(5093),
    [anon_sym_STAR] = ACTIONS(5095),
    [anon_sym_SLASH] = ACTIONS(5097),
    [anon_sym_STAR_STAR] = ACTIONS(5099),
    [anon_sym_CARET] = ACTIONS(5099),
    [aux_sym_binary_operator_token1] = ACTIONS(5101),
    [anon_sym_PIPE_GT] = ACTIONS(5101),
    [anon_sym_COLON] = ACTIONS(5103),
    [anon_sym_DOLLAR] = ACTIONS(5105),
    [anon_sym_AT] = ACTIONS(5105),
    [aux_sym__hex_literal_token1] = ACTIONS(5227),
    [sym__number_literal] = ACTIONS(5225),
    [anon_sym_SQUOTE] = ACTIONS(5227),
    [anon_sym_DQUOTE] = ACTIONS(5227),
    [sym_return] = ACTIONS(5225),
    [sym_next] = ACTIONS(5225),
    [sym_break] = ACTIONS(5225),
    [sym_true] = ACTIONS(5225),
    [sym_false] = ACTIONS(5225),
    [sym_null] = ACTIONS(5225),
    [sym_inf] = ACTIONS(5225),
    [sym_nan] = ACTIONS(5225),
    [anon_sym_NA] = ACTIONS(5225),
    [anon_sym_NA_integer_] = ACTIONS(5225),
    [anon_sym_NA_real_] = ACTIONS(5225),
    [anon_sym_NA_complex_] = ACTIONS(5225),
    [anon_sym_NA_character_] = ACTIONS(5225),
    [sym_dots] = ACTIONS(5225),
    [sym_dot_dot_i] = ACTIONS(5227),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5227),
    [sym__newline] = ACTIONS(5227),
    [sym__semicolon] = ACTIONS(5227),
    [sym__raw_string_literal] = ACTIONS(5227),
    [sym__external_else] = ACTIONS(5247),
    [sym__external_open_parenthesis] = ACTIONS(5109),
    [sym__external_close_parenthesis] = ACTIONS(5227),
    [sym__external_open_brace] = ACTIONS(5227),
    [sym__external_close_brace] = ACTIONS(5227),
    [sym__external_open_bracket] = ACTIONS(5111),
    [sym__external_open_bracket2] = ACTIONS(5113),
    [sym__external_close_bracket2] = ACTIONS(5227),
  },
  [494] = {
    [sym_call_arguments] = STATE(2342),
    [sym_subset_arguments] = STATE(2343),
    [sym_subset2_arguments] = STATE(2346),
    [sym__else] = STATE(4138),
    [sym__open_parenthesis] = STATE(1325),
    [sym__open_bracket] = STATE(1322),
    [sym__open_bracket2] = STATE(1607),
    [sym_identifier] = ACTIONS(5169),
    [anon_sym_BSLASH] = ACTIONS(5167),
    [anon_sym_function] = ACTIONS(5169),
    [anon_sym_EQ] = ACTIONS(5069),
    [anon_sym_if] = ACTIONS(5169),
    [anon_sym_for] = ACTIONS(5169),
    [anon_sym_while] = ACTIONS(5169),
    [anon_sym_repeat] = ACTIONS(5169),
    [anon_sym_QMARK] = ACTIONS(5167),
    [anon_sym_TILDE] = ACTIONS(5071),
    [anon_sym_BANG] = ACTIONS(5169),
    [anon_sym_PLUS] = ACTIONS(5073),
    [anon_sym_DASH] = ACTIONS(5075),
    [anon_sym_LT_DASH] = ACTIONS(5077),
    [anon_sym_LT_LT_DASH] = ACTIONS(5077),
    [anon_sym_COLON_EQ] = ACTIONS(5077),
    [anon_sym_DASH_GT] = ACTIONS(5079),
    [anon_sym_DASH_GT_GT] = ACTIONS(5081),
    [anon_sym_PIPE] = ACTIONS(5083),
    [anon_sym_AMP] = ACTIONS(5085),
    [anon_sym_PIPE_PIPE] = ACTIONS(5087),
    [anon_sym_AMP_AMP] = ACTIONS(5089),
    [anon_sym_LT] = ACTIONS(5091),
    [anon_sym_LT_EQ] = ACTIONS(5093),
    [anon_sym_GT] = ACTIONS(5091),
    [anon_sym_GT_EQ] = ACTIONS(5093),
    [anon_sym_EQ_EQ] = ACTIONS(5093),
    [anon_sym_BANG_EQ] = ACTIONS(5093),
    [anon_sym_STAR] = ACTIONS(5095),
    [anon_sym_SLASH] = ACTIONS(5097),
    [anon_sym_STAR_STAR] = ACTIONS(5099),
    [anon_sym_CARET] = ACTIONS(5099),
    [aux_sym_binary_operator_token1] = ACTIONS(5101),
    [anon_sym_PIPE_GT] = ACTIONS(5101),
    [anon_sym_COLON] = ACTIONS(5103),
    [anon_sym_DOLLAR] = ACTIONS(5105),
    [anon_sym_AT] = ACTIONS(5105),
    [aux_sym__hex_literal_token1] = ACTIONS(5167),
    [sym__number_literal] = ACTIONS(5169),
    [anon_sym_SQUOTE] = ACTIONS(5167),
    [anon_sym_DQUOTE] = ACTIONS(5167),
    [sym_return] = ACTIONS(5169),
    [sym_next] = ACTIONS(5169),
    [sym_break] = ACTIONS(5169),
    [sym_true] = ACTIONS(5169),
    [sym_false] = ACTIONS(5169),
    [sym_null] = ACTIONS(5169),
    [sym_inf] = ACTIONS(5169),
    [sym_nan] = ACTIONS(5169),
    [anon_sym_NA] = ACTIONS(5169),
    [anon_sym_NA_integer_] = ACTIONS(5169),
    [anon_sym_NA_real_] = ACTIONS(5169),
    [anon_sym_NA_complex_] = ACTIONS(5169),
    [anon_sym_NA_character_] = ACTIONS(5169),
    [sym_dots] = ACTIONS(5169),
    [sym_dot_dot_i] = ACTIONS(5167),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5167),
    [sym__newline] = ACTIONS(5167),
    [sym__semicolon] = ACTIONS(5167),
    [sym__raw_string_literal] = ACTIONS(5167),
    [sym__external_else] = ACTIONS(5249),
    [sym__external_open_parenthesis] = ACTIONS(5109),
    [sym__external_close_parenthesis] = ACTIONS(5167),
    [sym__external_open_brace] = ACTIONS(5167),
    [sym__external_close_brace] = ACTIONS(5167),
    [sym__external_open_bracket] = ACTIONS(5111),
    [sym__external_open_bracket2] = ACTIONS(5113),
    [sym__external_close_bracket2] = ACTIONS(5167),
  },
  [495] = {
    [sym_call_arguments] = STATE(2261),
    [sym_subset_arguments] = STATE(2260),
    [sym_subset2_arguments] = STATE(2259),
    [sym__else] = STATE(4280),
    [sym__open_parenthesis] = STATE(1380),
    [sym__open_bracket] = STATE(1379),
    [sym__open_bracket2] = STATE(1378),
    [ts_builtin_sym_end] = ACTIONS(5067),
    [sym_identifier] = ACTIONS(5065),
    [anon_sym_BSLASH] = ACTIONS(5067),
    [anon_sym_function] = ACTIONS(5065),
    [anon_sym_EQ] = ACTIONS(5171),
    [anon_sym_if] = ACTIONS(5065),
    [anon_sym_for] = ACTIONS(5065),
    [anon_sym_while] = ACTIONS(5065),
    [anon_sym_repeat] = ACTIONS(5065),
    [anon_sym_QMARK] = ACTIONS(5067),
    [anon_sym_TILDE] = ACTIONS(5173),
    [anon_sym_BANG] = ACTIONS(5065),
    [anon_sym_PLUS] = ACTIONS(5175),
    [anon_sym_DASH] = ACTIONS(5177),
    [anon_sym_LT_DASH] = ACTIONS(5179),
    [anon_sym_LT_LT_DASH] = ACTIONS(5179),
    [anon_sym_COLON_EQ] = ACTIONS(5179),
    [anon_sym_DASH_GT] = ACTIONS(5181),
    [anon_sym_DASH_GT_GT] = ACTIONS(5183),
    [anon_sym_PIPE] = ACTIONS(5185),
    [anon_sym_AMP] = ACTIONS(5187),
    [anon_sym_PIPE_PIPE] = ACTIONS(5189),
    [anon_sym_AMP_AMP] = ACTIONS(5191),
    [anon_sym_LT] = ACTIONS(5193),
    [anon_sym_LT_EQ] = ACTIONS(5195),
    [anon_sym_GT] = ACTIONS(5193),
    [anon_sym_GT_EQ] = ACTIONS(5195),
    [anon_sym_EQ_EQ] = ACTIONS(5195),
    [anon_sym_BANG_EQ] = ACTIONS(5195),
    [anon_sym_STAR] = ACTIONS(5197),
    [anon_sym_SLASH] = ACTIONS(5199),
    [anon_sym_STAR_STAR] = ACTIONS(5201),
    [anon_sym_CARET] = ACTIONS(5201),
    [aux_sym_binary_operator_token1] = ACTIONS(5203),
    [anon_sym_PIPE_GT] = ACTIONS(5203),
    [anon_sym_COLON] = ACTIONS(5205),
    [anon_sym_DOLLAR] = ACTIONS(5207),
    [anon_sym_AT] = ACTIONS(5207),
    [aux_sym__hex_literal_token1] = ACTIONS(5067),
    [sym__number_literal] = ACTIONS(5065),
    [anon_sym_SQUOTE] = ACTIONS(5067),
    [anon_sym_DQUOTE] = ACTIONS(5067),
    [sym_return] = ACTIONS(5065),
    [sym_next] = ACTIONS(5065),
    [sym_break] = ACTIONS(5065),
    [sym_true] = ACTIONS(5065),
    [sym_false] = ACTIONS(5065),
    [sym_null] = ACTIONS(5065),
    [sym_inf] = ACTIONS(5065),
    [sym_nan] = ACTIONS(5065),
    [anon_sym_NA] = ACTIONS(5065),
    [anon_sym_NA_integer_] = ACTIONS(5065),
    [anon_sym_NA_real_] = ACTIONS(5065),
    [anon_sym_NA_complex_] = ACTIONS(5065),
    [anon_sym_NA_character_] = ACTIONS(5065),
    [sym_dots] = ACTIONS(5065),
    [sym_dot_dot_i] = ACTIONS(5067),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5067),
    [sym__newline] = ACTIONS(5067),
    [sym__semicolon] = ACTIONS(5067),
    [sym__raw_string_literal] = ACTIONS(5067),
    [sym__external_else] = ACTIONS(5251),
    [sym__external_open_parenthesis] = ACTIONS(5211),
    [sym__external_close_parenthesis] = ACTIONS(5067),
    [sym__external_open_brace] = ACTIONS(5067),
    [sym__external_close_brace] = ACTIONS(5067),
    [sym__external_open_bracket] = ACTIONS(5213),
    [sym__external_open_bracket2] = ACTIONS(5215),
  },
  [496] = {
    [sym_call_arguments] = STATE(2261),
    [sym_subset_arguments] = STATE(2260),
    [sym_subset2_arguments] = STATE(2259),
    [sym__else] = STATE(4257),
    [sym__open_parenthesis] = STATE(1380),
    [sym__open_bracket] = STATE(1379),
    [sym__open_bracket2] = STATE(1378),
    [ts_builtin_sym_end] = ACTIONS(5117),
    [sym_identifier] = ACTIONS(5115),
    [anon_sym_BSLASH] = ACTIONS(5117),
    [anon_sym_function] = ACTIONS(5115),
    [anon_sym_EQ] = ACTIONS(5171),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_for] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_repeat] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(5117),
    [anon_sym_TILDE] = ACTIONS(5173),
    [anon_sym_BANG] = ACTIONS(5115),
    [anon_sym_PLUS] = ACTIONS(5175),
    [anon_sym_DASH] = ACTIONS(5177),
    [anon_sym_LT_DASH] = ACTIONS(5179),
    [anon_sym_LT_LT_DASH] = ACTIONS(5179),
    [anon_sym_COLON_EQ] = ACTIONS(5179),
    [anon_sym_DASH_GT] = ACTIONS(5181),
    [anon_sym_DASH_GT_GT] = ACTIONS(5183),
    [anon_sym_PIPE] = ACTIONS(5185),
    [anon_sym_AMP] = ACTIONS(5187),
    [anon_sym_PIPE_PIPE] = ACTIONS(5189),
    [anon_sym_AMP_AMP] = ACTIONS(5191),
    [anon_sym_LT] = ACTIONS(5193),
    [anon_sym_LT_EQ] = ACTIONS(5195),
    [anon_sym_GT] = ACTIONS(5193),
    [anon_sym_GT_EQ] = ACTIONS(5195),
    [anon_sym_EQ_EQ] = ACTIONS(5195),
    [anon_sym_BANG_EQ] = ACTIONS(5195),
    [anon_sym_STAR] = ACTIONS(5197),
    [anon_sym_SLASH] = ACTIONS(5199),
    [anon_sym_STAR_STAR] = ACTIONS(5201),
    [anon_sym_CARET] = ACTIONS(5201),
    [aux_sym_binary_operator_token1] = ACTIONS(5203),
    [anon_sym_PIPE_GT] = ACTIONS(5203),
    [anon_sym_COLON] = ACTIONS(5205),
    [anon_sym_DOLLAR] = ACTIONS(5207),
    [anon_sym_AT] = ACTIONS(5207),
    [aux_sym__hex_literal_token1] = ACTIONS(5117),
    [sym__number_literal] = ACTIONS(5115),
    [anon_sym_SQUOTE] = ACTIONS(5117),
    [anon_sym_DQUOTE] = ACTIONS(5117),
    [sym_return] = ACTIONS(5115),
    [sym_next] = ACTIONS(5115),
    [sym_break] = ACTIONS(5115),
    [sym_true] = ACTIONS(5115),
    [sym_false] = ACTIONS(5115),
    [sym_null] = ACTIONS(5115),
    [sym_inf] = ACTIONS(5115),
    [sym_nan] = ACTIONS(5115),
    [anon_sym_NA] = ACTIONS(5115),
    [anon_sym_NA_integer_] = ACTIONS(5115),
    [anon_sym_NA_real_] = ACTIONS(5115),
    [anon_sym_NA_complex_] = ACTIONS(5115),
    [anon_sym_NA_character_] = ACTIONS(5115),
    [sym_dots] = ACTIONS(5115),
    [sym_dot_dot_i] = ACTIONS(5117),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5117),
    [sym__newline] = ACTIONS(5117),
    [sym__semicolon] = ACTIONS(5117),
    [sym__raw_string_literal] = ACTIONS(5117),
    [sym__external_else] = ACTIONS(5253),
    [sym__external_open_parenthesis] = ACTIONS(5211),
    [sym__external_close_parenthesis] = ACTIONS(5117),
    [sym__external_open_brace] = ACTIONS(5117),
    [sym__external_close_brace] = ACTIONS(5117),
    [sym__external_open_bracket] = ACTIONS(5213),
    [sym__external_open_bracket2] = ACTIONS(5215),
  },
  [497] = {
    [sym_call_arguments] = STATE(2342),
    [sym_subset_arguments] = STATE(2343),
    [sym_subset2_arguments] = STATE(2346),
    [sym__else] = STATE(4139),
    [sym__open_parenthesis] = STATE(1325),
    [sym__open_bracket] = STATE(1322),
    [sym__open_bracket2] = STATE(1607),
    [sym_identifier] = ACTIONS(5065),
    [anon_sym_BSLASH] = ACTIONS(5067),
    [anon_sym_function] = ACTIONS(5065),
    [anon_sym_EQ] = ACTIONS(5069),
    [anon_sym_if] = ACTIONS(5065),
    [anon_sym_for] = ACTIONS(5065),
    [anon_sym_while] = ACTIONS(5065),
    [anon_sym_repeat] = ACTIONS(5065),
    [anon_sym_QMARK] = ACTIONS(5067),
    [anon_sym_TILDE] = ACTIONS(5071),
    [anon_sym_BANG] = ACTIONS(5065),
    [anon_sym_PLUS] = ACTIONS(5073),
    [anon_sym_DASH] = ACTIONS(5075),
    [anon_sym_LT_DASH] = ACTIONS(5077),
    [anon_sym_LT_LT_DASH] = ACTIONS(5077),
    [anon_sym_COLON_EQ] = ACTIONS(5077),
    [anon_sym_DASH_GT] = ACTIONS(5079),
    [anon_sym_DASH_GT_GT] = ACTIONS(5081),
    [anon_sym_PIPE] = ACTIONS(5083),
    [anon_sym_AMP] = ACTIONS(5085),
    [anon_sym_PIPE_PIPE] = ACTIONS(5087),
    [anon_sym_AMP_AMP] = ACTIONS(5089),
    [anon_sym_LT] = ACTIONS(5091),
    [anon_sym_LT_EQ] = ACTIONS(5093),
    [anon_sym_GT] = ACTIONS(5091),
    [anon_sym_GT_EQ] = ACTIONS(5093),
    [anon_sym_EQ_EQ] = ACTIONS(5093),
    [anon_sym_BANG_EQ] = ACTIONS(5093),
    [anon_sym_STAR] = ACTIONS(5095),
    [anon_sym_SLASH] = ACTIONS(5097),
    [anon_sym_STAR_STAR] = ACTIONS(5099),
    [anon_sym_CARET] = ACTIONS(5099),
    [aux_sym_binary_operator_token1] = ACTIONS(5101),
    [anon_sym_PIPE_GT] = ACTIONS(5101),
    [anon_sym_COLON] = ACTIONS(5103),
    [anon_sym_DOLLAR] = ACTIONS(5105),
    [anon_sym_AT] = ACTIONS(5105),
    [aux_sym__hex_literal_token1] = ACTIONS(5067),
    [sym__number_literal] = ACTIONS(5065),
    [anon_sym_SQUOTE] = ACTIONS(5067),
    [anon_sym_DQUOTE] = ACTIONS(5067),
    [sym_return] = ACTIONS(5065),
    [sym_next] = ACTIONS(5065),
    [sym_break] = ACTIONS(5065),
    [sym_true] = ACTIONS(5065),
    [sym_false] = ACTIONS(5065),
    [sym_null] = ACTIONS(5065),
    [sym_inf] = ACTIONS(5065),
    [sym_nan] = ACTIONS(5065),
    [anon_sym_NA] = ACTIONS(5065),
    [anon_sym_NA_integer_] = ACTIONS(5065),
    [anon_sym_NA_real_] = ACTIONS(5065),
    [anon_sym_NA_complex_] = ACTIONS(5065),
    [anon_sym_NA_character_] = ACTIONS(5065),
    [sym_dots] = ACTIONS(5065),
    [sym_dot_dot_i] = ACTIONS(5067),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5067),
    [sym__newline] = ACTIONS(5067),
    [sym__semicolon] = ACTIONS(5067),
    [sym__raw_string_literal] = ACTIONS(5067),
    [sym__external_else] = ACTIONS(5255),
    [sym__external_open_parenthesis] = ACTIONS(5109),
    [sym__external_close_parenthesis] = ACTIONS(5067),
    [sym__external_open_brace] = ACTIONS(5067),
    [sym__external_close_brace] = ACTIONS(5067),
    [sym__external_open_bracket] = ACTIONS(5111),
    [sym__external_open_bracket2] = ACTIONS(5113),
    [sym__external_close_bracket2] = ACTIONS(5067),
  },
  [498] = {
    [sym_call_arguments] = STATE(2261),
    [sym_subset_arguments] = STATE(2260),
    [sym_subset2_arguments] = STATE(2259),
    [sym__else] = STATE(4362),
    [sym__open_parenthesis] = STATE(1380),
    [sym__open_bracket] = STATE(1379),
    [sym__open_bracket2] = STATE(1378),
    [ts_builtin_sym_end] = ACTIONS(5117),
    [sym_identifier] = ACTIONS(5115),
    [anon_sym_BSLASH] = ACTIONS(5117),
    [anon_sym_function] = ACTIONS(5115),
    [anon_sym_EQ] = ACTIONS(5171),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_for] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_repeat] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(5117),
    [anon_sym_TILDE] = ACTIONS(5173),
    [anon_sym_BANG] = ACTIONS(5115),
    [anon_sym_PLUS] = ACTIONS(5175),
    [anon_sym_DASH] = ACTIONS(5177),
    [anon_sym_LT_DASH] = ACTIONS(5179),
    [anon_sym_LT_LT_DASH] = ACTIONS(5179),
    [anon_sym_COLON_EQ] = ACTIONS(5179),
    [anon_sym_DASH_GT] = ACTIONS(5181),
    [anon_sym_DASH_GT_GT] = ACTIONS(5183),
    [anon_sym_PIPE] = ACTIONS(5185),
    [anon_sym_AMP] = ACTIONS(5187),
    [anon_sym_PIPE_PIPE] = ACTIONS(5189),
    [anon_sym_AMP_AMP] = ACTIONS(5191),
    [anon_sym_LT] = ACTIONS(5193),
    [anon_sym_LT_EQ] = ACTIONS(5195),
    [anon_sym_GT] = ACTIONS(5193),
    [anon_sym_GT_EQ] = ACTIONS(5195),
    [anon_sym_EQ_EQ] = ACTIONS(5195),
    [anon_sym_BANG_EQ] = ACTIONS(5195),
    [anon_sym_STAR] = ACTIONS(5197),
    [anon_sym_SLASH] = ACTIONS(5199),
    [anon_sym_STAR_STAR] = ACTIONS(5201),
    [anon_sym_CARET] = ACTIONS(5201),
    [aux_sym_binary_operator_token1] = ACTIONS(5203),
    [anon_sym_PIPE_GT] = ACTIONS(5203),
    [anon_sym_COLON] = ACTIONS(5205),
    [anon_sym_DOLLAR] = ACTIONS(5207),
    [anon_sym_AT] = ACTIONS(5207),
    [aux_sym__hex_literal_token1] = ACTIONS(5117),
    [sym__number_literal] = ACTIONS(5115),
    [anon_sym_SQUOTE] = ACTIONS(5117),
    [anon_sym_DQUOTE] = ACTIONS(5117),
    [sym_return] = ACTIONS(5115),
    [sym_next] = ACTIONS(5115),
    [sym_break] = ACTIONS(5115),
    [sym_true] = ACTIONS(5115),
    [sym_false] = ACTIONS(5115),
    [sym_null] = ACTIONS(5115),
    [sym_inf] = ACTIONS(5115),
    [sym_nan] = ACTIONS(5115),
    [anon_sym_NA] = ACTIONS(5115),
    [anon_sym_NA_integer_] = ACTIONS(5115),
    [anon_sym_NA_real_] = ACTIONS(5115),
    [anon_sym_NA_complex_] = ACTIONS(5115),
    [anon_sym_NA_character_] = ACTIONS(5115),
    [sym_dots] = ACTIONS(5115),
    [sym_dot_dot_i] = ACTIONS(5117),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5117),
    [sym__newline] = ACTIONS(5117),
    [sym__semicolon] = ACTIONS(5117),
    [sym__raw_string_literal] = ACTIONS(5117),
    [sym__external_else] = ACTIONS(5257),
    [sym__external_open_parenthesis] = ACTIONS(5211),
    [sym__external_close_parenthesis] = ACTIONS(5117),
    [sym__external_open_brace] = ACTIONS(5117),
    [sym__external_close_brace] = ACTIONS(5117),
    [sym__external_open_bracket] = ACTIONS(5213),
    [sym__external_open_bracket2] = ACTIONS(5215),
  },
  [499] = {
    [sym_call_arguments] = STATE(2318),
    [sym_subset_arguments] = STATE(2319),
    [sym_subset2_arguments] = STATE(2320),
    [sym__else] = STATE(4100),
    [sym__open_parenthesis] = STATE(1329),
    [sym__open_bracket] = STATE(1328),
    [sym__open_bracket2] = STATE(1327),
    [sym_identifier] = ACTIONS(5225),
    [anon_sym_BSLASH] = ACTIONS(5227),
    [anon_sym_function] = ACTIONS(5225),
    [anon_sym_EQ] = ACTIONS(5119),
    [anon_sym_if] = ACTIONS(5225),
    [anon_sym_for] = ACTIONS(5225),
    [anon_sym_while] = ACTIONS(5225),
    [anon_sym_repeat] = ACTIONS(5225),
    [anon_sym_QMARK] = ACTIONS(5227),
    [anon_sym_TILDE] = ACTIONS(5121),
    [anon_sym_BANG] = ACTIONS(5225),
    [anon_sym_PLUS] = ACTIONS(5123),
    [anon_sym_DASH] = ACTIONS(5125),
    [anon_sym_LT_DASH] = ACTIONS(5127),
    [anon_sym_LT_LT_DASH] = ACTIONS(5127),
    [anon_sym_COLON_EQ] = ACTIONS(5127),
    [anon_sym_DASH_GT] = ACTIONS(5129),
    [anon_sym_DASH_GT_GT] = ACTIONS(5131),
    [anon_sym_PIPE] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5135),
    [anon_sym_PIPE_PIPE] = ACTIONS(5137),
    [anon_sym_AMP_AMP] = ACTIONS(5139),
    [anon_sym_LT] = ACTIONS(5141),
    [anon_sym_LT_EQ] = ACTIONS(5143),
    [anon_sym_GT] = ACTIONS(5141),
    [anon_sym_GT_EQ] = ACTIONS(5143),
    [anon_sym_EQ_EQ] = ACTIONS(5143),
    [anon_sym_BANG_EQ] = ACTIONS(5143),
    [anon_sym_STAR] = ACTIONS(5145),
    [anon_sym_SLASH] = ACTIONS(5147),
    [anon_sym_STAR_STAR] = ACTIONS(5149),
    [anon_sym_CARET] = ACTIONS(5149),
    [aux_sym_binary_operator_token1] = ACTIONS(5151),
    [anon_sym_PIPE_GT] = ACTIONS(5151),
    [anon_sym_COLON] = ACTIONS(5153),
    [anon_sym_DOLLAR] = ACTIONS(5155),
    [anon_sym_AT] = ACTIONS(5155),
    [aux_sym__hex_literal_token1] = ACTIONS(5227),
    [sym__number_literal] = ACTIONS(5225),
    [anon_sym_SQUOTE] = ACTIONS(5227),
    [anon_sym_DQUOTE] = ACTIONS(5227),
    [sym_return] = ACTIONS(5225),
    [sym_next] = ACTIONS(5225),
    [sym_break] = ACTIONS(5225),
    [sym_true] = ACTIONS(5225),
    [sym_false] = ACTIONS(5225),
    [sym_null] = ACTIONS(5225),
    [sym_inf] = ACTIONS(5225),
    [sym_nan] = ACTIONS(5225),
    [anon_sym_NA] = ACTIONS(5225),
    [anon_sym_NA_integer_] = ACTIONS(5225),
    [anon_sym_NA_real_] = ACTIONS(5225),
    [anon_sym_NA_complex_] = ACTIONS(5225),
    [anon_sym_NA_character_] = ACTIONS(5225),
    [sym_dots] = ACTIONS(5225),
    [sym_dot_dot_i] = ACTIONS(5227),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5227),
    [sym__newline] = ACTIONS(5227),
    [sym__semicolon] = ACTIONS(5227),
    [sym__raw_string_literal] = ACTIONS(5227),
    [sym__external_else] = ACTIONS(5259),
    [sym__external_open_parenthesis] = ACTIONS(5159),
    [sym__external_close_parenthesis] = ACTIONS(5227),
    [sym__external_open_brace] = ACTIONS(5227),
    [sym__external_close_brace] = ACTIONS(5227),
    [sym__external_open_bracket] = ACTIONS(5161),
    [sym__external_close_bracket] = ACTIONS(5227),
    [sym__external_open_bracket2] = ACTIONS(5163),
  },
  [500] = {
    [sym_call_arguments] = STATE(2318),
    [sym_subset_arguments] = STATE(2319),
    [sym_subset2_arguments] = STATE(2320),
    [sym__open_parenthesis] = STATE(1329),
    [sym__open_bracket] = STATE(1328),
    [sym__open_bracket2] = STATE(1327),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5119),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5121),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5123),
    [anon_sym_DASH] = ACTIONS(5125),
    [anon_sym_LT_DASH] = ACTIONS(5127),
    [anon_sym_LT_LT_DASH] = ACTIONS(5127),
    [anon_sym_COLON_EQ] = ACTIONS(5127),
    [anon_sym_DASH_GT] = ACTIONS(5129),
    [anon_sym_DASH_GT_GT] = ACTIONS(5131),
    [anon_sym_PIPE] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5135),
    [anon_sym_PIPE_PIPE] = ACTIONS(5137),
    [anon_sym_AMP_AMP] = ACTIONS(5139),
    [anon_sym_LT] = ACTIONS(5141),
    [anon_sym_LT_EQ] = ACTIONS(5143),
    [anon_sym_GT] = ACTIONS(5141),
    [anon_sym_GT_EQ] = ACTIONS(5143),
    [anon_sym_EQ_EQ] = ACTIONS(5143),
    [anon_sym_BANG_EQ] = ACTIONS(5143),
    [anon_sym_STAR] = ACTIONS(5145),
    [anon_sym_SLASH] = ACTIONS(5147),
    [anon_sym_STAR_STAR] = ACTIONS(5149),
    [anon_sym_CARET] = ACTIONS(5149),
    [aux_sym_binary_operator_token1] = ACTIONS(5151),
    [anon_sym_PIPE_GT] = ACTIONS(5151),
    [anon_sym_COLON] = ACTIONS(5153),
    [anon_sym_DOLLAR] = ACTIONS(5155),
    [anon_sym_AT] = ACTIONS(5155),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5159),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5161),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(5163),
  },
  [501] = {
    [sym_call_arguments] = STATE(2555),
    [sym_subset_arguments] = STATE(2554),
    [sym_subset2_arguments] = STATE(2553),
    [sym__else] = STATE(4231),
    [sym__open_parenthesis] = STATE(1332),
    [sym__open_bracket] = STATE(1331),
    [sym__open_bracket2] = STATE(1330),
    [sym_identifier] = ACTIONS(5225),
    [anon_sym_BSLASH] = ACTIONS(5227),
    [anon_sym_function] = ACTIONS(5225),
    [anon_sym_EQ] = ACTIONS(5265),
    [anon_sym_if] = ACTIONS(5225),
    [anon_sym_for] = ACTIONS(5225),
    [anon_sym_while] = ACTIONS(5225),
    [anon_sym_repeat] = ACTIONS(5225),
    [anon_sym_QMARK] = ACTIONS(5227),
    [anon_sym_TILDE] = ACTIONS(5267),
    [anon_sym_BANG] = ACTIONS(5225),
    [anon_sym_PLUS] = ACTIONS(5269),
    [anon_sym_DASH] = ACTIONS(5271),
    [anon_sym_LT_DASH] = ACTIONS(5273),
    [anon_sym_LT_LT_DASH] = ACTIONS(5273),
    [anon_sym_COLON_EQ] = ACTIONS(5273),
    [anon_sym_DASH_GT] = ACTIONS(5275),
    [anon_sym_DASH_GT_GT] = ACTIONS(5277),
    [anon_sym_PIPE] = ACTIONS(5279),
    [anon_sym_AMP] = ACTIONS(5281),
    [anon_sym_PIPE_PIPE] = ACTIONS(5283),
    [anon_sym_AMP_AMP] = ACTIONS(5285),
    [anon_sym_LT] = ACTIONS(5287),
    [anon_sym_LT_EQ] = ACTIONS(5289),
    [anon_sym_GT] = ACTIONS(5287),
    [anon_sym_GT_EQ] = ACTIONS(5289),
    [anon_sym_EQ_EQ] = ACTIONS(5289),
    [anon_sym_BANG_EQ] = ACTIONS(5289),
    [anon_sym_STAR] = ACTIONS(5291),
    [anon_sym_SLASH] = ACTIONS(5293),
    [anon_sym_STAR_STAR] = ACTIONS(5295),
    [anon_sym_CARET] = ACTIONS(5295),
    [aux_sym_binary_operator_token1] = ACTIONS(5297),
    [anon_sym_PIPE_GT] = ACTIONS(5297),
    [anon_sym_COLON] = ACTIONS(5299),
    [anon_sym_DOLLAR] = ACTIONS(5301),
    [anon_sym_AT] = ACTIONS(5301),
    [aux_sym__hex_literal_token1] = ACTIONS(5227),
    [sym__number_literal] = ACTIONS(5225),
    [anon_sym_SQUOTE] = ACTIONS(5227),
    [anon_sym_DQUOTE] = ACTIONS(5227),
    [sym_return] = ACTIONS(5225),
    [sym_next] = ACTIONS(5225),
    [sym_break] = ACTIONS(5225),
    [sym_true] = ACTIONS(5225),
    [sym_false] = ACTIONS(5225),
    [sym_null] = ACTIONS(5225),
    [sym_inf] = ACTIONS(5225),
    [sym_nan] = ACTIONS(5225),
    [anon_sym_NA] = ACTIONS(5225),
    [anon_sym_NA_integer_] = ACTIONS(5225),
    [anon_sym_NA_real_] = ACTIONS(5225),
    [anon_sym_NA_complex_] = ACTIONS(5225),
    [anon_sym_NA_character_] = ACTIONS(5225),
    [sym_dots] = ACTIONS(5225),
    [sym_dot_dot_i] = ACTIONS(5227),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5227),
    [sym__newline] = ACTIONS(5227),
    [sym__semicolon] = ACTIONS(5227),
    [sym__raw_string_literal] = ACTIONS(5227),
    [sym__external_else] = ACTIONS(5303),
    [sym__external_open_parenthesis] = ACTIONS(5305),
    [sym__external_open_brace] = ACTIONS(5227),
    [sym__external_close_brace] = ACTIONS(5227),
    [sym__external_open_bracket] = ACTIONS(5307),
    [sym__external_open_bracket2] = ACTIONS(5309),
    [sym__external_close_bracket2] = ACTIONS(5227),
  },
  [502] = {
    [sym_call_arguments] = STATE(2342),
    [sym_subset_arguments] = STATE(2343),
    [sym_subset2_arguments] = STATE(2346),
    [sym__open_parenthesis] = STATE(1325),
    [sym__open_bracket] = STATE(1322),
    [sym__open_bracket2] = STATE(1607),
    [sym_identifier] = ACTIONS(5311),
    [anon_sym_BSLASH] = ACTIONS(5313),
    [anon_sym_function] = ACTIONS(5311),
    [anon_sym_EQ] = ACTIONS(5069),
    [anon_sym_if] = ACTIONS(5311),
    [anon_sym_for] = ACTIONS(5311),
    [anon_sym_while] = ACTIONS(5311),
    [anon_sym_repeat] = ACTIONS(5311),
    [anon_sym_QMARK] = ACTIONS(5315),
    [anon_sym_TILDE] = ACTIONS(5071),
    [anon_sym_BANG] = ACTIONS(5311),
    [anon_sym_PLUS] = ACTIONS(5073),
    [anon_sym_DASH] = ACTIONS(5075),
    [anon_sym_LT_DASH] = ACTIONS(5077),
    [anon_sym_LT_LT_DASH] = ACTIONS(5077),
    [anon_sym_COLON_EQ] = ACTIONS(5077),
    [anon_sym_DASH_GT] = ACTIONS(5079),
    [anon_sym_DASH_GT_GT] = ACTIONS(5081),
    [anon_sym_PIPE] = ACTIONS(5083),
    [anon_sym_AMP] = ACTIONS(5085),
    [anon_sym_PIPE_PIPE] = ACTIONS(5087),
    [anon_sym_AMP_AMP] = ACTIONS(5089),
    [anon_sym_LT] = ACTIONS(5091),
    [anon_sym_LT_EQ] = ACTIONS(5093),
    [anon_sym_GT] = ACTIONS(5091),
    [anon_sym_GT_EQ] = ACTIONS(5093),
    [anon_sym_EQ_EQ] = ACTIONS(5093),
    [anon_sym_BANG_EQ] = ACTIONS(5093),
    [anon_sym_STAR] = ACTIONS(5095),
    [anon_sym_SLASH] = ACTIONS(5097),
    [anon_sym_STAR_STAR] = ACTIONS(5099),
    [anon_sym_CARET] = ACTIONS(5099),
    [aux_sym_binary_operator_token1] = ACTIONS(5101),
    [anon_sym_PIPE_GT] = ACTIONS(5101),
    [anon_sym_COLON] = ACTIONS(5103),
    [anon_sym_DOLLAR] = ACTIONS(5105),
    [anon_sym_AT] = ACTIONS(5105),
    [aux_sym__hex_literal_token1] = ACTIONS(5313),
    [sym__number_literal] = ACTIONS(5311),
    [anon_sym_SQUOTE] = ACTIONS(5313),
    [anon_sym_DQUOTE] = ACTIONS(5313),
    [sym_return] = ACTIONS(5311),
    [sym_next] = ACTIONS(5311),
    [sym_break] = ACTIONS(5311),
    [sym_true] = ACTIONS(5311),
    [sym_false] = ACTIONS(5311),
    [sym_null] = ACTIONS(5311),
    [sym_inf] = ACTIONS(5311),
    [sym_nan] = ACTIONS(5311),
    [anon_sym_NA] = ACTIONS(5311),
    [anon_sym_NA_integer_] = ACTIONS(5311),
    [anon_sym_NA_real_] = ACTIONS(5311),
    [anon_sym_NA_complex_] = ACTIONS(5311),
    [anon_sym_NA_character_] = ACTIONS(5311),
    [sym_dots] = ACTIONS(5311),
    [sym_dot_dot_i] = ACTIONS(5313),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5313),
    [sym__newline] = ACTIONS(5313),
    [sym__semicolon] = ACTIONS(5313),
    [sym__raw_string_literal] = ACTIONS(5313),
    [sym__external_else] = ACTIONS(5313),
    [sym__external_open_parenthesis] = ACTIONS(5109),
    [sym__external_close_parenthesis] = ACTIONS(5313),
    [sym__external_open_brace] = ACTIONS(5313),
    [sym__external_close_brace] = ACTIONS(5313),
    [sym__external_open_bracket] = ACTIONS(5111),
    [sym__external_open_bracket2] = ACTIONS(5113),
    [sym__external_close_bracket2] = ACTIONS(5313),
  },
  [503] = {
    [sym_call_arguments] = STATE(2555),
    [sym_subset_arguments] = STATE(2554),
    [sym_subset2_arguments] = STATE(2553),
    [sym__else] = STATE(4212),
    [sym__open_parenthesis] = STATE(1332),
    [sym__open_bracket] = STATE(1331),
    [sym__open_bracket2] = STATE(1330),
    [sym_identifier] = ACTIONS(5115),
    [anon_sym_BSLASH] = ACTIONS(5117),
    [anon_sym_function] = ACTIONS(5115),
    [anon_sym_EQ] = ACTIONS(5265),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_for] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_repeat] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(5117),
    [anon_sym_TILDE] = ACTIONS(5267),
    [anon_sym_BANG] = ACTIONS(5115),
    [anon_sym_PLUS] = ACTIONS(5269),
    [anon_sym_DASH] = ACTIONS(5271),
    [anon_sym_LT_DASH] = ACTIONS(5273),
    [anon_sym_LT_LT_DASH] = ACTIONS(5273),
    [anon_sym_COLON_EQ] = ACTIONS(5273),
    [anon_sym_DASH_GT] = ACTIONS(5275),
    [anon_sym_DASH_GT_GT] = ACTIONS(5277),
    [anon_sym_PIPE] = ACTIONS(5279),
    [anon_sym_AMP] = ACTIONS(5281),
    [anon_sym_PIPE_PIPE] = ACTIONS(5283),
    [anon_sym_AMP_AMP] = ACTIONS(5285),
    [anon_sym_LT] = ACTIONS(5287),
    [anon_sym_LT_EQ] = ACTIONS(5289),
    [anon_sym_GT] = ACTIONS(5287),
    [anon_sym_GT_EQ] = ACTIONS(5289),
    [anon_sym_EQ_EQ] = ACTIONS(5289),
    [anon_sym_BANG_EQ] = ACTIONS(5289),
    [anon_sym_STAR] = ACTIONS(5291),
    [anon_sym_SLASH] = ACTIONS(5293),
    [anon_sym_STAR_STAR] = ACTIONS(5295),
    [anon_sym_CARET] = ACTIONS(5295),
    [aux_sym_binary_operator_token1] = ACTIONS(5297),
    [anon_sym_PIPE_GT] = ACTIONS(5297),
    [anon_sym_COLON] = ACTIONS(5299),
    [anon_sym_DOLLAR] = ACTIONS(5301),
    [anon_sym_AT] = ACTIONS(5301),
    [aux_sym__hex_literal_token1] = ACTIONS(5117),
    [sym__number_literal] = ACTIONS(5115),
    [anon_sym_SQUOTE] = ACTIONS(5117),
    [anon_sym_DQUOTE] = ACTIONS(5117),
    [sym_return] = ACTIONS(5115),
    [sym_next] = ACTIONS(5115),
    [sym_break] = ACTIONS(5115),
    [sym_true] = ACTIONS(5115),
    [sym_false] = ACTIONS(5115),
    [sym_null] = ACTIONS(5115),
    [sym_inf] = ACTIONS(5115),
    [sym_nan] = ACTIONS(5115),
    [anon_sym_NA] = ACTIONS(5115),
    [anon_sym_NA_integer_] = ACTIONS(5115),
    [anon_sym_NA_real_] = ACTIONS(5115),
    [anon_sym_NA_complex_] = ACTIONS(5115),
    [anon_sym_NA_character_] = ACTIONS(5115),
    [sym_dots] = ACTIONS(5115),
    [sym_dot_dot_i] = ACTIONS(5117),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5117),
    [sym__newline] = ACTIONS(5117),
    [sym__semicolon] = ACTIONS(5117),
    [sym__raw_string_literal] = ACTIONS(5117),
    [sym__external_else] = ACTIONS(5317),
    [sym__external_open_parenthesis] = ACTIONS(5305),
    [sym__external_open_brace] = ACTIONS(5117),
    [sym__external_close_brace] = ACTIONS(5117),
    [sym__external_open_bracket] = ACTIONS(5307),
    [sym__external_open_bracket2] = ACTIONS(5309),
    [sym__external_close_bracket2] = ACTIONS(5117),
  },
  [504] = {
    [sym_call_arguments] = STATE(2555),
    [sym_subset_arguments] = STATE(2554),
    [sym_subset2_arguments] = STATE(2553),
    [sym__else] = STATE(4214),
    [sym__open_parenthesis] = STATE(1332),
    [sym__open_bracket] = STATE(1331),
    [sym__open_bracket2] = STATE(1330),
    [sym_identifier] = ACTIONS(5169),
    [anon_sym_BSLASH] = ACTIONS(5167),
    [anon_sym_function] = ACTIONS(5169),
    [anon_sym_EQ] = ACTIONS(5265),
    [anon_sym_if] = ACTIONS(5169),
    [anon_sym_for] = ACTIONS(5169),
    [anon_sym_while] = ACTIONS(5169),
    [anon_sym_repeat] = ACTIONS(5169),
    [anon_sym_QMARK] = ACTIONS(5167),
    [anon_sym_TILDE] = ACTIONS(5267),
    [anon_sym_BANG] = ACTIONS(5169),
    [anon_sym_PLUS] = ACTIONS(5269),
    [anon_sym_DASH] = ACTIONS(5271),
    [anon_sym_LT_DASH] = ACTIONS(5273),
    [anon_sym_LT_LT_DASH] = ACTIONS(5273),
    [anon_sym_COLON_EQ] = ACTIONS(5273),
    [anon_sym_DASH_GT] = ACTIONS(5275),
    [anon_sym_DASH_GT_GT] = ACTIONS(5277),
    [anon_sym_PIPE] = ACTIONS(5279),
    [anon_sym_AMP] = ACTIONS(5281),
    [anon_sym_PIPE_PIPE] = ACTIONS(5283),
    [anon_sym_AMP_AMP] = ACTIONS(5285),
    [anon_sym_LT] = ACTIONS(5287),
    [anon_sym_LT_EQ] = ACTIONS(5289),
    [anon_sym_GT] = ACTIONS(5287),
    [anon_sym_GT_EQ] = ACTIONS(5289),
    [anon_sym_EQ_EQ] = ACTIONS(5289),
    [anon_sym_BANG_EQ] = ACTIONS(5289),
    [anon_sym_STAR] = ACTIONS(5291),
    [anon_sym_SLASH] = ACTIONS(5293),
    [anon_sym_STAR_STAR] = ACTIONS(5295),
    [anon_sym_CARET] = ACTIONS(5295),
    [aux_sym_binary_operator_token1] = ACTIONS(5297),
    [anon_sym_PIPE_GT] = ACTIONS(5297),
    [anon_sym_COLON] = ACTIONS(5299),
    [anon_sym_DOLLAR] = ACTIONS(5301),
    [anon_sym_AT] = ACTIONS(5301),
    [aux_sym__hex_literal_token1] = ACTIONS(5167),
    [sym__number_literal] = ACTIONS(5169),
    [anon_sym_SQUOTE] = ACTIONS(5167),
    [anon_sym_DQUOTE] = ACTIONS(5167),
    [sym_return] = ACTIONS(5169),
    [sym_next] = ACTIONS(5169),
    [sym_break] = ACTIONS(5169),
    [sym_true] = ACTIONS(5169),
    [sym_false] = ACTIONS(5169),
    [sym_null] = ACTIONS(5169),
    [sym_inf] = ACTIONS(5169),
    [sym_nan] = ACTIONS(5169),
    [anon_sym_NA] = ACTIONS(5169),
    [anon_sym_NA_integer_] = ACTIONS(5169),
    [anon_sym_NA_real_] = ACTIONS(5169),
    [anon_sym_NA_complex_] = ACTIONS(5169),
    [anon_sym_NA_character_] = ACTIONS(5169),
    [sym_dots] = ACTIONS(5169),
    [sym_dot_dot_i] = ACTIONS(5167),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5167),
    [sym__newline] = ACTIONS(5167),
    [sym__semicolon] = ACTIONS(5167),
    [sym__raw_string_literal] = ACTIONS(5167),
    [sym__external_else] = ACTIONS(5319),
    [sym__external_open_parenthesis] = ACTIONS(5305),
    [sym__external_open_brace] = ACTIONS(5167),
    [sym__external_close_brace] = ACTIONS(5167),
    [sym__external_open_bracket] = ACTIONS(5307),
    [sym__external_open_bracket2] = ACTIONS(5309),
    [sym__external_close_bracket2] = ACTIONS(5167),
  },
  [505] = {
    [sym_call_arguments] = STATE(2555),
    [sym_subset_arguments] = STATE(2554),
    [sym_subset2_arguments] = STATE(2553),
    [sym__else] = STATE(4210),
    [sym__open_parenthesis] = STATE(1332),
    [sym__open_bracket] = STATE(1331),
    [sym__open_bracket2] = STATE(1330),
    [sym_identifier] = ACTIONS(5065),
    [anon_sym_BSLASH] = ACTIONS(5067),
    [anon_sym_function] = ACTIONS(5065),
    [anon_sym_EQ] = ACTIONS(5265),
    [anon_sym_if] = ACTIONS(5065),
    [anon_sym_for] = ACTIONS(5065),
    [anon_sym_while] = ACTIONS(5065),
    [anon_sym_repeat] = ACTIONS(5065),
    [anon_sym_QMARK] = ACTIONS(5067),
    [anon_sym_TILDE] = ACTIONS(5267),
    [anon_sym_BANG] = ACTIONS(5065),
    [anon_sym_PLUS] = ACTIONS(5269),
    [anon_sym_DASH] = ACTIONS(5271),
    [anon_sym_LT_DASH] = ACTIONS(5273),
    [anon_sym_LT_LT_DASH] = ACTIONS(5273),
    [anon_sym_COLON_EQ] = ACTIONS(5273),
    [anon_sym_DASH_GT] = ACTIONS(5275),
    [anon_sym_DASH_GT_GT] = ACTIONS(5277),
    [anon_sym_PIPE] = ACTIONS(5279),
    [anon_sym_AMP] = ACTIONS(5281),
    [anon_sym_PIPE_PIPE] = ACTIONS(5283),
    [anon_sym_AMP_AMP] = ACTIONS(5285),
    [anon_sym_LT] = ACTIONS(5287),
    [anon_sym_LT_EQ] = ACTIONS(5289),
    [anon_sym_GT] = ACTIONS(5287),
    [anon_sym_GT_EQ] = ACTIONS(5289),
    [anon_sym_EQ_EQ] = ACTIONS(5289),
    [anon_sym_BANG_EQ] = ACTIONS(5289),
    [anon_sym_STAR] = ACTIONS(5291),
    [anon_sym_SLASH] = ACTIONS(5293),
    [anon_sym_STAR_STAR] = ACTIONS(5295),
    [anon_sym_CARET] = ACTIONS(5295),
    [aux_sym_binary_operator_token1] = ACTIONS(5297),
    [anon_sym_PIPE_GT] = ACTIONS(5297),
    [anon_sym_COLON] = ACTIONS(5299),
    [anon_sym_DOLLAR] = ACTIONS(5301),
    [anon_sym_AT] = ACTIONS(5301),
    [aux_sym__hex_literal_token1] = ACTIONS(5067),
    [sym__number_literal] = ACTIONS(5065),
    [anon_sym_SQUOTE] = ACTIONS(5067),
    [anon_sym_DQUOTE] = ACTIONS(5067),
    [sym_return] = ACTIONS(5065),
    [sym_next] = ACTIONS(5065),
    [sym_break] = ACTIONS(5065),
    [sym_true] = ACTIONS(5065),
    [sym_false] = ACTIONS(5065),
    [sym_null] = ACTIONS(5065),
    [sym_inf] = ACTIONS(5065),
    [sym_nan] = ACTIONS(5065),
    [anon_sym_NA] = ACTIONS(5065),
    [anon_sym_NA_integer_] = ACTIONS(5065),
    [anon_sym_NA_real_] = ACTIONS(5065),
    [anon_sym_NA_complex_] = ACTIONS(5065),
    [anon_sym_NA_character_] = ACTIONS(5065),
    [sym_dots] = ACTIONS(5065),
    [sym_dot_dot_i] = ACTIONS(5067),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5067),
    [sym__newline] = ACTIONS(5067),
    [sym__semicolon] = ACTIONS(5067),
    [sym__raw_string_literal] = ACTIONS(5067),
    [sym__external_else] = ACTIONS(5321),
    [sym__external_open_parenthesis] = ACTIONS(5305),
    [sym__external_open_brace] = ACTIONS(5067),
    [sym__external_close_brace] = ACTIONS(5067),
    [sym__external_open_bracket] = ACTIONS(5307),
    [sym__external_open_bracket2] = ACTIONS(5309),
    [sym__external_close_bracket2] = ACTIONS(5067),
  },
  [506] = {
    [sym_call_arguments] = STATE(2318),
    [sym_subset_arguments] = STATE(2319),
    [sym_subset2_arguments] = STATE(2320),
    [sym__open_parenthesis] = STATE(1329),
    [sym__open_bracket] = STATE(1328),
    [sym__open_bracket2] = STATE(1327),
    [sym_identifier] = ACTIONS(5311),
    [anon_sym_BSLASH] = ACTIONS(5313),
    [anon_sym_function] = ACTIONS(5311),
    [anon_sym_EQ] = ACTIONS(5119),
    [anon_sym_if] = ACTIONS(5311),
    [anon_sym_for] = ACTIONS(5311),
    [anon_sym_while] = ACTIONS(5311),
    [anon_sym_repeat] = ACTIONS(5311),
    [anon_sym_QMARK] = ACTIONS(5323),
    [anon_sym_TILDE] = ACTIONS(5121),
    [anon_sym_BANG] = ACTIONS(5311),
    [anon_sym_PLUS] = ACTIONS(5123),
    [anon_sym_DASH] = ACTIONS(5125),
    [anon_sym_LT_DASH] = ACTIONS(5127),
    [anon_sym_LT_LT_DASH] = ACTIONS(5127),
    [anon_sym_COLON_EQ] = ACTIONS(5127),
    [anon_sym_DASH_GT] = ACTIONS(5129),
    [anon_sym_DASH_GT_GT] = ACTIONS(5131),
    [anon_sym_PIPE] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5135),
    [anon_sym_PIPE_PIPE] = ACTIONS(5137),
    [anon_sym_AMP_AMP] = ACTIONS(5139),
    [anon_sym_LT] = ACTIONS(5141),
    [anon_sym_LT_EQ] = ACTIONS(5143),
    [anon_sym_GT] = ACTIONS(5141),
    [anon_sym_GT_EQ] = ACTIONS(5143),
    [anon_sym_EQ_EQ] = ACTIONS(5143),
    [anon_sym_BANG_EQ] = ACTIONS(5143),
    [anon_sym_STAR] = ACTIONS(5145),
    [anon_sym_SLASH] = ACTIONS(5147),
    [anon_sym_STAR_STAR] = ACTIONS(5149),
    [anon_sym_CARET] = ACTIONS(5149),
    [aux_sym_binary_operator_token1] = ACTIONS(5151),
    [anon_sym_PIPE_GT] = ACTIONS(5151),
    [anon_sym_COLON] = ACTIONS(5153),
    [anon_sym_DOLLAR] = ACTIONS(5155),
    [anon_sym_AT] = ACTIONS(5155),
    [aux_sym__hex_literal_token1] = ACTIONS(5313),
    [sym__number_literal] = ACTIONS(5311),
    [anon_sym_SQUOTE] = ACTIONS(5313),
    [anon_sym_DQUOTE] = ACTIONS(5313),
    [sym_return] = ACTIONS(5311),
    [sym_next] = ACTIONS(5311),
    [sym_break] = ACTIONS(5311),
    [sym_true] = ACTIONS(5311),
    [sym_false] = ACTIONS(5311),
    [sym_null] = ACTIONS(5311),
    [sym_inf] = ACTIONS(5311),
    [sym_nan] = ACTIONS(5311),
    [anon_sym_NA] = ACTIONS(5311),
    [anon_sym_NA_integer_] = ACTIONS(5311),
    [anon_sym_NA_real_] = ACTIONS(5311),
    [anon_sym_NA_complex_] = ACTIONS(5311),
    [anon_sym_NA_character_] = ACTIONS(5311),
    [sym_dots] = ACTIONS(5311),
    [sym_dot_dot_i] = ACTIONS(5313),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5313),
    [sym__newline] = ACTIONS(5313),
    [sym__semicolon] = ACTIONS(5313),
    [sym__raw_string_literal] = ACTIONS(5313),
    [sym__external_else] = ACTIONS(5313),
    [sym__external_open_parenthesis] = ACTIONS(5159),
    [sym__external_close_parenthesis] = ACTIONS(5313),
    [sym__external_open_brace] = ACTIONS(5313),
    [sym__external_close_brace] = ACTIONS(5313),
    [sym__external_open_bracket] = ACTIONS(5161),
    [sym__external_close_bracket] = ACTIONS(5313),
    [sym__external_open_bracket2] = ACTIONS(5163),
  },
  [507] = {
    [sym_call_arguments] = STATE(2342),
    [sym_subset_arguments] = STATE(2343),
    [sym_subset2_arguments] = STATE(2346),
    [sym__open_parenthesis] = STATE(1325),
    [sym__open_bracket] = STATE(1322),
    [sym__open_bracket2] = STATE(1607),
    [sym_identifier] = ACTIONS(5325),
    [anon_sym_BSLASH] = ACTIONS(5327),
    [anon_sym_function] = ACTIONS(5325),
    [anon_sym_EQ] = ACTIONS(5069),
    [anon_sym_if] = ACTIONS(5325),
    [anon_sym_for] = ACTIONS(5325),
    [anon_sym_while] = ACTIONS(5325),
    [anon_sym_repeat] = ACTIONS(5325),
    [anon_sym_QMARK] = ACTIONS(5315),
    [anon_sym_TILDE] = ACTIONS(5071),
    [anon_sym_BANG] = ACTIONS(5325),
    [anon_sym_PLUS] = ACTIONS(5073),
    [anon_sym_DASH] = ACTIONS(5075),
    [anon_sym_LT_DASH] = ACTIONS(5077),
    [anon_sym_LT_LT_DASH] = ACTIONS(5077),
    [anon_sym_COLON_EQ] = ACTIONS(5077),
    [anon_sym_DASH_GT] = ACTIONS(5079),
    [anon_sym_DASH_GT_GT] = ACTIONS(5081),
    [anon_sym_PIPE] = ACTIONS(5083),
    [anon_sym_AMP] = ACTIONS(5085),
    [anon_sym_PIPE_PIPE] = ACTIONS(5087),
    [anon_sym_AMP_AMP] = ACTIONS(5089),
    [anon_sym_LT] = ACTIONS(5091),
    [anon_sym_LT_EQ] = ACTIONS(5093),
    [anon_sym_GT] = ACTIONS(5091),
    [anon_sym_GT_EQ] = ACTIONS(5093),
    [anon_sym_EQ_EQ] = ACTIONS(5093),
    [anon_sym_BANG_EQ] = ACTIONS(5093),
    [anon_sym_STAR] = ACTIONS(5095),
    [anon_sym_SLASH] = ACTIONS(5097),
    [anon_sym_STAR_STAR] = ACTIONS(5099),
    [anon_sym_CARET] = ACTIONS(5099),
    [aux_sym_binary_operator_token1] = ACTIONS(5101),
    [anon_sym_PIPE_GT] = ACTIONS(5101),
    [anon_sym_COLON] = ACTIONS(5103),
    [anon_sym_DOLLAR] = ACTIONS(5105),
    [anon_sym_AT] = ACTIONS(5105),
    [aux_sym__hex_literal_token1] = ACTIONS(5327),
    [sym__number_literal] = ACTIONS(5325),
    [anon_sym_SQUOTE] = ACTIONS(5327),
    [anon_sym_DQUOTE] = ACTIONS(5327),
    [sym_return] = ACTIONS(5325),
    [sym_next] = ACTIONS(5325),
    [sym_break] = ACTIONS(5325),
    [sym_true] = ACTIONS(5325),
    [sym_false] = ACTIONS(5325),
    [sym_null] = ACTIONS(5325),
    [sym_inf] = ACTIONS(5325),
    [sym_nan] = ACTIONS(5325),
    [anon_sym_NA] = ACTIONS(5325),
    [anon_sym_NA_integer_] = ACTIONS(5325),
    [anon_sym_NA_real_] = ACTIONS(5325),
    [anon_sym_NA_complex_] = ACTIONS(5325),
    [anon_sym_NA_character_] = ACTIONS(5325),
    [sym_dots] = ACTIONS(5325),
    [sym_dot_dot_i] = ACTIONS(5327),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5327),
    [sym__newline] = ACTIONS(5327),
    [sym__semicolon] = ACTIONS(5327),
    [sym__raw_string_literal] = ACTIONS(5327),
    [sym__external_else] = ACTIONS(5327),
    [sym__external_open_parenthesis] = ACTIONS(5109),
    [sym__external_close_parenthesis] = ACTIONS(5327),
    [sym__external_open_brace] = ACTIONS(5327),
    [sym__external_close_brace] = ACTIONS(5327),
    [sym__external_open_bracket] = ACTIONS(5111),
    [sym__external_open_bracket2] = ACTIONS(5113),
    [sym__external_close_bracket2] = ACTIONS(5327),
  },
  [508] = {
    [sym_call_arguments] = STATE(2261),
    [sym_subset_arguments] = STATE(2260),
    [sym_subset2_arguments] = STATE(2259),
    [sym__open_parenthesis] = STATE(1380),
    [sym__open_bracket] = STATE(1379),
    [sym__open_bracket2] = STATE(1378),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5173),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5175),
    [anon_sym_DASH] = ACTIONS(5177),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5185),
    [anon_sym_AMP] = ACTIONS(5187),
    [anon_sym_PIPE_PIPE] = ACTIONS(5189),
    [anon_sym_AMP_AMP] = ACTIONS(5191),
    [anon_sym_LT] = ACTIONS(5193),
    [anon_sym_LT_EQ] = ACTIONS(5195),
    [anon_sym_GT] = ACTIONS(5193),
    [anon_sym_GT_EQ] = ACTIONS(5195),
    [anon_sym_EQ_EQ] = ACTIONS(5195),
    [anon_sym_BANG_EQ] = ACTIONS(5195),
    [anon_sym_STAR] = ACTIONS(5197),
    [anon_sym_SLASH] = ACTIONS(5199),
    [anon_sym_STAR_STAR] = ACTIONS(5201),
    [anon_sym_CARET] = ACTIONS(5201),
    [aux_sym_binary_operator_token1] = ACTIONS(5203),
    [anon_sym_PIPE_GT] = ACTIONS(5203),
    [anon_sym_COLON] = ACTIONS(5205),
    [anon_sym_DOLLAR] = ACTIONS(5207),
    [anon_sym_AT] = ACTIONS(5207),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5211),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5213),
    [sym__external_open_bracket2] = ACTIONS(5215),
  },
  [509] = {
    [sym_call_arguments] = STATE(2261),
    [sym_subset_arguments] = STATE(2260),
    [sym_subset2_arguments] = STATE(2259),
    [sym__open_parenthesis] = STATE(1380),
    [sym__open_bracket] = STATE(1379),
    [sym__open_bracket2] = STATE(1378),
    [ts_builtin_sym_end] = ACTIONS(5329),
    [sym_identifier] = ACTIONS(5331),
    [anon_sym_BSLASH] = ACTIONS(5329),
    [anon_sym_function] = ACTIONS(5331),
    [anon_sym_EQ] = ACTIONS(5171),
    [anon_sym_if] = ACTIONS(5331),
    [anon_sym_for] = ACTIONS(5331),
    [anon_sym_while] = ACTIONS(5331),
    [anon_sym_repeat] = ACTIONS(5331),
    [anon_sym_QMARK] = ACTIONS(5329),
    [anon_sym_TILDE] = ACTIONS(5173),
    [anon_sym_BANG] = ACTIONS(5331),
    [anon_sym_PLUS] = ACTIONS(5175),
    [anon_sym_DASH] = ACTIONS(5177),
    [anon_sym_LT_DASH] = ACTIONS(5179),
    [anon_sym_LT_LT_DASH] = ACTIONS(5179),
    [anon_sym_COLON_EQ] = ACTIONS(5179),
    [anon_sym_DASH_GT] = ACTIONS(5181),
    [anon_sym_DASH_GT_GT] = ACTIONS(5183),
    [anon_sym_PIPE] = ACTIONS(5185),
    [anon_sym_AMP] = ACTIONS(5187),
    [anon_sym_PIPE_PIPE] = ACTIONS(5189),
    [anon_sym_AMP_AMP] = ACTIONS(5191),
    [anon_sym_LT] = ACTIONS(5193),
    [anon_sym_LT_EQ] = ACTIONS(5195),
    [anon_sym_GT] = ACTIONS(5193),
    [anon_sym_GT_EQ] = ACTIONS(5195),
    [anon_sym_EQ_EQ] = ACTIONS(5195),
    [anon_sym_BANG_EQ] = ACTIONS(5195),
    [anon_sym_STAR] = ACTIONS(5197),
    [anon_sym_SLASH] = ACTIONS(5199),
    [anon_sym_STAR_STAR] = ACTIONS(5201),
    [anon_sym_CARET] = ACTIONS(5201),
    [aux_sym_binary_operator_token1] = ACTIONS(5203),
    [anon_sym_PIPE_GT] = ACTIONS(5203),
    [anon_sym_COLON] = ACTIONS(5205),
    [anon_sym_DOLLAR] = ACTIONS(5207),
    [anon_sym_AT] = ACTIONS(5207),
    [aux_sym__hex_literal_token1] = ACTIONS(5329),
    [sym__number_literal] = ACTIONS(5331),
    [anon_sym_SQUOTE] = ACTIONS(5329),
    [anon_sym_DQUOTE] = ACTIONS(5329),
    [sym_return] = ACTIONS(5331),
    [sym_next] = ACTIONS(5331),
    [sym_break] = ACTIONS(5331),
    [sym_true] = ACTIONS(5331),
    [sym_false] = ACTIONS(5331),
    [sym_null] = ACTIONS(5331),
    [sym_inf] = ACTIONS(5331),
    [sym_nan] = ACTIONS(5331),
    [anon_sym_NA] = ACTIONS(5331),
    [anon_sym_NA_integer_] = ACTIONS(5331),
    [anon_sym_NA_real_] = ACTIONS(5331),
    [anon_sym_NA_complex_] = ACTIONS(5331),
    [anon_sym_NA_character_] = ACTIONS(5331),
    [sym_dots] = ACTIONS(5331),
    [sym_dot_dot_i] = ACTIONS(5329),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5329),
    [sym__newline] = ACTIONS(5329),
    [sym__semicolon] = ACTIONS(5329),
    [sym__raw_string_literal] = ACTIONS(5329),
    [sym__external_else] = ACTIONS(5329),
    [sym__external_open_parenthesis] = ACTIONS(5211),
    [sym__external_close_parenthesis] = ACTIONS(5329),
    [sym__external_open_brace] = ACTIONS(5329),
    [sym__external_close_brace] = ACTIONS(5329),
    [sym__external_open_bracket] = ACTIONS(5213),
    [sym__external_open_bracket2] = ACTIONS(5215),
  },
  [510] = {
    [sym_call_arguments] = STATE(2261),
    [sym_subset_arguments] = STATE(2260),
    [sym_subset2_arguments] = STATE(2259),
    [sym__open_parenthesis] = STATE(1380),
    [sym__open_bracket] = STATE(1379),
    [sym__open_bracket2] = STATE(1378),
    [ts_builtin_sym_end] = ACTIONS(5333),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5171),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5173),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(5175),
    [anon_sym_DASH] = ACTIONS(5177),
    [anon_sym_LT_DASH] = ACTIONS(5179),
    [anon_sym_LT_LT_DASH] = ACTIONS(5179),
    [anon_sym_COLON_EQ] = ACTIONS(5179),
    [anon_sym_DASH_GT] = ACTIONS(5181),
    [anon_sym_DASH_GT_GT] = ACTIONS(5183),
    [anon_sym_PIPE] = ACTIONS(5185),
    [anon_sym_AMP] = ACTIONS(5187),
    [anon_sym_PIPE_PIPE] = ACTIONS(5189),
    [anon_sym_AMP_AMP] = ACTIONS(5191),
    [anon_sym_LT] = ACTIONS(5193),
    [anon_sym_LT_EQ] = ACTIONS(5195),
    [anon_sym_GT] = ACTIONS(5193),
    [anon_sym_GT_EQ] = ACTIONS(5195),
    [anon_sym_EQ_EQ] = ACTIONS(5195),
    [anon_sym_BANG_EQ] = ACTIONS(5195),
    [anon_sym_STAR] = ACTIONS(5197),
    [anon_sym_SLASH] = ACTIONS(5199),
    [anon_sym_STAR_STAR] = ACTIONS(5201),
    [anon_sym_CARET] = ACTIONS(5201),
    [aux_sym_binary_operator_token1] = ACTIONS(5203),
    [anon_sym_PIPE_GT] = ACTIONS(5203),
    [anon_sym_COLON] = ACTIONS(5205),
    [anon_sym_DOLLAR] = ACTIONS(5207),
    [anon_sym_AT] = ACTIONS(5207),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__semicolon] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_else] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(5211),
    [sym__external_close_parenthesis] = ACTIONS(5333),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_close_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(5213),
    [sym__external_open_bracket2] = ACTIONS(5215),
  },
  [511] = {
    [sym_call_arguments] = STATE(2261),
    [sym_subset_arguments] = STATE(2260),
    [sym_subset2_arguments] = STATE(2259),
    [sym__open_parenthesis] = STATE(1380),
    [sym__open_bracket] = STATE(1379),
    [sym__open_bracket2] = STATE(1378),
    [ts_builtin_sym_end] = ACTIONS(5333),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(5175),
    [anon_sym_DASH] = ACTIONS(5177),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5185),
    [anon_sym_AMP] = ACTIONS(5187),
    [anon_sym_PIPE_PIPE] = ACTIONS(5189),
    [anon_sym_AMP_AMP] = ACTIONS(5191),
    [anon_sym_LT] = ACTIONS(5193),
    [anon_sym_LT_EQ] = ACTIONS(5195),
    [anon_sym_GT] = ACTIONS(5193),
    [anon_sym_GT_EQ] = ACTIONS(5195),
    [anon_sym_EQ_EQ] = ACTIONS(5195),
    [anon_sym_BANG_EQ] = ACTIONS(5195),
    [anon_sym_STAR] = ACTIONS(5197),
    [anon_sym_SLASH] = ACTIONS(5199),
    [anon_sym_STAR_STAR] = ACTIONS(5201),
    [anon_sym_CARET] = ACTIONS(5201),
    [aux_sym_binary_operator_token1] = ACTIONS(5203),
    [anon_sym_PIPE_GT] = ACTIONS(5203),
    [anon_sym_COLON] = ACTIONS(5205),
    [anon_sym_DOLLAR] = ACTIONS(5207),
    [anon_sym_AT] = ACTIONS(5207),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__semicolon] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_else] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(5211),
    [sym__external_close_parenthesis] = ACTIONS(5333),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_close_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(5213),
    [sym__external_open_bracket2] = ACTIONS(5215),
  },
  [512] = {
    [sym_call_arguments] = STATE(2261),
    [sym_subset_arguments] = STATE(2260),
    [sym_subset2_arguments] = STATE(2259),
    [sym__open_parenthesis] = STATE(1380),
    [sym__open_bracket] = STATE(1379),
    [sym__open_bracket2] = STATE(1378),
    [ts_builtin_sym_end] = ACTIONS(5333),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(5175),
    [anon_sym_DASH] = ACTIONS(5177),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5335),
    [anon_sym_AMP] = ACTIONS(5335),
    [anon_sym_PIPE_PIPE] = ACTIONS(5333),
    [anon_sym_AMP_AMP] = ACTIONS(5333),
    [anon_sym_LT] = ACTIONS(5193),
    [anon_sym_LT_EQ] = ACTIONS(5195),
    [anon_sym_GT] = ACTIONS(5193),
    [anon_sym_GT_EQ] = ACTIONS(5195),
    [anon_sym_EQ_EQ] = ACTIONS(5195),
    [anon_sym_BANG_EQ] = ACTIONS(5195),
    [anon_sym_STAR] = ACTIONS(5197),
    [anon_sym_SLASH] = ACTIONS(5199),
    [anon_sym_STAR_STAR] = ACTIONS(5201),
    [anon_sym_CARET] = ACTIONS(5201),
    [aux_sym_binary_operator_token1] = ACTIONS(5203),
    [anon_sym_PIPE_GT] = ACTIONS(5203),
    [anon_sym_COLON] = ACTIONS(5205),
    [anon_sym_DOLLAR] = ACTIONS(5207),
    [anon_sym_AT] = ACTIONS(5207),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__semicolon] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_else] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(5211),
    [sym__external_close_parenthesis] = ACTIONS(5333),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_close_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(5213),
    [sym__external_open_bracket2] = ACTIONS(5215),
  },
  [513] = {
    [sym_call_arguments] = STATE(2261),
    [sym_subset_arguments] = STATE(2260),
    [sym_subset2_arguments] = STATE(2259),
    [sym__open_parenthesis] = STATE(1380),
    [sym__open_bracket] = STATE(1379),
    [sym__open_bracket2] = STATE(1378),
    [ts_builtin_sym_end] = ACTIONS(5333),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(5333),
    [anon_sym_DASH] = ACTIONS(5335),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5335),
    [anon_sym_AMP] = ACTIONS(5335),
    [anon_sym_PIPE_PIPE] = ACTIONS(5333),
    [anon_sym_AMP_AMP] = ACTIONS(5333),
    [anon_sym_LT] = ACTIONS(5335),
    [anon_sym_LT_EQ] = ACTIONS(5333),
    [anon_sym_GT] = ACTIONS(5335),
    [anon_sym_GT_EQ] = ACTIONS(5333),
    [anon_sym_EQ_EQ] = ACTIONS(5333),
    [anon_sym_BANG_EQ] = ACTIONS(5333),
    [anon_sym_STAR] = ACTIONS(5335),
    [anon_sym_SLASH] = ACTIONS(5333),
    [anon_sym_STAR_STAR] = ACTIONS(5201),
    [anon_sym_CARET] = ACTIONS(5201),
    [aux_sym_binary_operator_token1] = ACTIONS(5333),
    [anon_sym_PIPE_GT] = ACTIONS(5333),
    [anon_sym_COLON] = ACTIONS(5335),
    [anon_sym_DOLLAR] = ACTIONS(5207),
    [anon_sym_AT] = ACTIONS(5207),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__semicolon] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_else] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(5211),
    [sym__external_close_parenthesis] = ACTIONS(5333),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_close_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(5213),
    [sym__external_open_bracket2] = ACTIONS(5215),
  },
  [514] = {
    [sym_call_arguments] = STATE(2261),
    [sym_subset_arguments] = STATE(2260),
    [sym_subset2_arguments] = STATE(2259),
    [sym__open_parenthesis] = STATE(1380),
    [sym__open_bracket] = STATE(1379),
    [sym__open_bracket2] = STATE(1378),
    [ts_builtin_sym_end] = ACTIONS(5337),
    [sym_identifier] = ACTIONS(5339),
    [anon_sym_BSLASH] = ACTIONS(5337),
    [anon_sym_function] = ACTIONS(5339),
    [anon_sym_EQ] = ACTIONS(5171),
    [anon_sym_if] = ACTIONS(5339),
    [anon_sym_for] = ACTIONS(5339),
    [anon_sym_while] = ACTIONS(5339),
    [anon_sym_repeat] = ACTIONS(5339),
    [anon_sym_QMARK] = ACTIONS(5337),
    [anon_sym_TILDE] = ACTIONS(5173),
    [anon_sym_BANG] = ACTIONS(5339),
    [anon_sym_PLUS] = ACTIONS(5175),
    [anon_sym_DASH] = ACTIONS(5177),
    [anon_sym_LT_DASH] = ACTIONS(5179),
    [anon_sym_LT_LT_DASH] = ACTIONS(5179),
    [anon_sym_COLON_EQ] = ACTIONS(5179),
    [anon_sym_DASH_GT] = ACTIONS(5181),
    [anon_sym_DASH_GT_GT] = ACTIONS(5183),
    [anon_sym_PIPE] = ACTIONS(5185),
    [anon_sym_AMP] = ACTIONS(5187),
    [anon_sym_PIPE_PIPE] = ACTIONS(5189),
    [anon_sym_AMP_AMP] = ACTIONS(5191),
    [anon_sym_LT] = ACTIONS(5193),
    [anon_sym_LT_EQ] = ACTIONS(5195),
    [anon_sym_GT] = ACTIONS(5193),
    [anon_sym_GT_EQ] = ACTIONS(5195),
    [anon_sym_EQ_EQ] = ACTIONS(5195),
    [anon_sym_BANG_EQ] = ACTIONS(5195),
    [anon_sym_STAR] = ACTIONS(5197),
    [anon_sym_SLASH] = ACTIONS(5199),
    [anon_sym_STAR_STAR] = ACTIONS(5201),
    [anon_sym_CARET] = ACTIONS(5201),
    [aux_sym_binary_operator_token1] = ACTIONS(5203),
    [anon_sym_PIPE_GT] = ACTIONS(5203),
    [anon_sym_COLON] = ACTIONS(5205),
    [anon_sym_DOLLAR] = ACTIONS(5207),
    [anon_sym_AT] = ACTIONS(5207),
    [aux_sym__hex_literal_token1] = ACTIONS(5337),
    [sym__number_literal] = ACTIONS(5339),
    [anon_sym_SQUOTE] = ACTIONS(5337),
    [anon_sym_DQUOTE] = ACTIONS(5337),
    [sym_return] = ACTIONS(5339),
    [sym_next] = ACTIONS(5339),
    [sym_break] = ACTIONS(5339),
    [sym_true] = ACTIONS(5339),
    [sym_false] = ACTIONS(5339),
    [sym_null] = ACTIONS(5339),
    [sym_inf] = ACTIONS(5339),
    [sym_nan] = ACTIONS(5339),
    [anon_sym_NA] = ACTIONS(5339),
    [anon_sym_NA_integer_] = ACTIONS(5339),
    [anon_sym_NA_real_] = ACTIONS(5339),
    [anon_sym_NA_complex_] = ACTIONS(5339),
    [anon_sym_NA_character_] = ACTIONS(5339),
    [sym_dots] = ACTIONS(5339),
    [sym_dot_dot_i] = ACTIONS(5337),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5337),
    [sym__newline] = ACTIONS(5337),
    [sym__semicolon] = ACTIONS(5337),
    [sym__raw_string_literal] = ACTIONS(5337),
    [sym__external_else] = ACTIONS(5337),
    [sym__external_open_parenthesis] = ACTIONS(5211),
    [sym__external_close_parenthesis] = ACTIONS(5337),
    [sym__external_open_brace] = ACTIONS(5337),
    [sym__external_close_brace] = ACTIONS(5337),
    [sym__external_open_bracket] = ACTIONS(5213),
    [sym__external_open_bracket2] = ACTIONS(5215),
  },
  [515] = {
    [sym_call_arguments] = STATE(2261),
    [sym_subset_arguments] = STATE(2260),
    [sym_subset2_arguments] = STATE(2259),
    [sym__open_parenthesis] = STATE(1380),
    [sym__open_bracket] = STATE(1379),
    [sym__open_bracket2] = STATE(1378),
    [ts_builtin_sym_end] = ACTIONS(5341),
    [sym_identifier] = ACTIONS(5343),
    [anon_sym_BSLASH] = ACTIONS(5341),
    [anon_sym_function] = ACTIONS(5343),
    [anon_sym_EQ] = ACTIONS(5171),
    [anon_sym_if] = ACTIONS(5343),
    [anon_sym_for] = ACTIONS(5343),
    [anon_sym_while] = ACTIONS(5343),
    [anon_sym_repeat] = ACTIONS(5343),
    [anon_sym_QMARK] = ACTIONS(5341),
    [anon_sym_TILDE] = ACTIONS(5173),
    [anon_sym_BANG] = ACTIONS(5343),
    [anon_sym_PLUS] = ACTIONS(5175),
    [anon_sym_DASH] = ACTIONS(5177),
    [anon_sym_LT_DASH] = ACTIONS(5179),
    [anon_sym_LT_LT_DASH] = ACTIONS(5179),
    [anon_sym_COLON_EQ] = ACTIONS(5179),
    [anon_sym_DASH_GT] = ACTIONS(5181),
    [anon_sym_DASH_GT_GT] = ACTIONS(5183),
    [anon_sym_PIPE] = ACTIONS(5185),
    [anon_sym_AMP] = ACTIONS(5187),
    [anon_sym_PIPE_PIPE] = ACTIONS(5189),
    [anon_sym_AMP_AMP] = ACTIONS(5191),
    [anon_sym_LT] = ACTIONS(5193),
    [anon_sym_LT_EQ] = ACTIONS(5195),
    [anon_sym_GT] = ACTIONS(5193),
    [anon_sym_GT_EQ] = ACTIONS(5195),
    [anon_sym_EQ_EQ] = ACTIONS(5195),
    [anon_sym_BANG_EQ] = ACTIONS(5195),
    [anon_sym_STAR] = ACTIONS(5197),
    [anon_sym_SLASH] = ACTIONS(5199),
    [anon_sym_STAR_STAR] = ACTIONS(5201),
    [anon_sym_CARET] = ACTIONS(5201),
    [aux_sym_binary_operator_token1] = ACTIONS(5203),
    [anon_sym_PIPE_GT] = ACTIONS(5203),
    [anon_sym_COLON] = ACTIONS(5205),
    [anon_sym_DOLLAR] = ACTIONS(5207),
    [anon_sym_AT] = ACTIONS(5207),
    [aux_sym__hex_literal_token1] = ACTIONS(5341),
    [sym__number_literal] = ACTIONS(5343),
    [anon_sym_SQUOTE] = ACTIONS(5341),
    [anon_sym_DQUOTE] = ACTIONS(5341),
    [sym_return] = ACTIONS(5343),
    [sym_next] = ACTIONS(5343),
    [sym_break] = ACTIONS(5343),
    [sym_true] = ACTIONS(5343),
    [sym_false] = ACTIONS(5343),
    [sym_null] = ACTIONS(5343),
    [sym_inf] = ACTIONS(5343),
    [sym_nan] = ACTIONS(5343),
    [anon_sym_NA] = ACTIONS(5343),
    [anon_sym_NA_integer_] = ACTIONS(5343),
    [anon_sym_NA_real_] = ACTIONS(5343),
    [anon_sym_NA_complex_] = ACTIONS(5343),
    [anon_sym_NA_character_] = ACTIONS(5343),
    [sym_dots] = ACTIONS(5343),
    [sym_dot_dot_i] = ACTIONS(5341),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5341),
    [sym__newline] = ACTIONS(5341),
    [sym__semicolon] = ACTIONS(5341),
    [sym__raw_string_literal] = ACTIONS(5341),
    [sym__external_else] = ACTIONS(5341),
    [sym__external_open_parenthesis] = ACTIONS(5211),
    [sym__external_close_parenthesis] = ACTIONS(5341),
    [sym__external_open_brace] = ACTIONS(5341),
    [sym__external_close_brace] = ACTIONS(5341),
    [sym__external_open_bracket] = ACTIONS(5213),
    [sym__external_open_bracket2] = ACTIONS(5215),
  },
  [516] = {
    [sym_call_arguments] = STATE(2261),
    [sym_subset_arguments] = STATE(2260),
    [sym_subset2_arguments] = STATE(2259),
    [sym__open_parenthesis] = STATE(1380),
    [sym__open_bracket] = STATE(1379),
    [sym__open_bracket2] = STATE(1378),
    [ts_builtin_sym_end] = ACTIONS(5345),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5171),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5173),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5175),
    [anon_sym_DASH] = ACTIONS(5177),
    [anon_sym_LT_DASH] = ACTIONS(5179),
    [anon_sym_LT_LT_DASH] = ACTIONS(5179),
    [anon_sym_COLON_EQ] = ACTIONS(5179),
    [anon_sym_DASH_GT] = ACTIONS(5181),
    [anon_sym_DASH_GT_GT] = ACTIONS(5183),
    [anon_sym_PIPE] = ACTIONS(5185),
    [anon_sym_AMP] = ACTIONS(5187),
    [anon_sym_PIPE_PIPE] = ACTIONS(5189),
    [anon_sym_AMP_AMP] = ACTIONS(5191),
    [anon_sym_LT] = ACTIONS(5193),
    [anon_sym_LT_EQ] = ACTIONS(5195),
    [anon_sym_GT] = ACTIONS(5193),
    [anon_sym_GT_EQ] = ACTIONS(5195),
    [anon_sym_EQ_EQ] = ACTIONS(5195),
    [anon_sym_BANG_EQ] = ACTIONS(5195),
    [anon_sym_STAR] = ACTIONS(5197),
    [anon_sym_SLASH] = ACTIONS(5199),
    [anon_sym_STAR_STAR] = ACTIONS(5201),
    [anon_sym_CARET] = ACTIONS(5201),
    [aux_sym_binary_operator_token1] = ACTIONS(5203),
    [anon_sym_PIPE_GT] = ACTIONS(5203),
    [anon_sym_COLON] = ACTIONS(5205),
    [anon_sym_DOLLAR] = ACTIONS(5207),
    [anon_sym_AT] = ACTIONS(5207),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__semicolon] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_else] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(5211),
    [sym__external_close_parenthesis] = ACTIONS(5345),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_close_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(5213),
    [sym__external_open_bracket2] = ACTIONS(5215),
  },
  [517] = {
    [sym_call_arguments] = STATE(2261),
    [sym_subset_arguments] = STATE(2260),
    [sym_subset2_arguments] = STATE(2259),
    [sym__open_parenthesis] = STATE(1380),
    [sym__open_bracket] = STATE(1379),
    [sym__open_bracket2] = STATE(1378),
    [ts_builtin_sym_end] = ACTIONS(5345),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5175),
    [anon_sym_DASH] = ACTIONS(5177),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5185),
    [anon_sym_AMP] = ACTIONS(5187),
    [anon_sym_PIPE_PIPE] = ACTIONS(5189),
    [anon_sym_AMP_AMP] = ACTIONS(5191),
    [anon_sym_LT] = ACTIONS(5193),
    [anon_sym_LT_EQ] = ACTIONS(5195),
    [anon_sym_GT] = ACTIONS(5193),
    [anon_sym_GT_EQ] = ACTIONS(5195),
    [anon_sym_EQ_EQ] = ACTIONS(5195),
    [anon_sym_BANG_EQ] = ACTIONS(5195),
    [anon_sym_STAR] = ACTIONS(5197),
    [anon_sym_SLASH] = ACTIONS(5199),
    [anon_sym_STAR_STAR] = ACTIONS(5201),
    [anon_sym_CARET] = ACTIONS(5201),
    [aux_sym_binary_operator_token1] = ACTIONS(5203),
    [anon_sym_PIPE_GT] = ACTIONS(5203),
    [anon_sym_COLON] = ACTIONS(5205),
    [anon_sym_DOLLAR] = ACTIONS(5207),
    [anon_sym_AT] = ACTIONS(5207),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__semicolon] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_else] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(5211),
    [sym__external_close_parenthesis] = ACTIONS(5345),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_close_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(5213),
    [sym__external_open_bracket2] = ACTIONS(5215),
  },
  [518] = {
    [sym_call_arguments] = STATE(2261),
    [sym_subset_arguments] = STATE(2260),
    [sym_subset2_arguments] = STATE(2259),
    [sym__open_parenthesis] = STATE(1380),
    [sym__open_bracket] = STATE(1379),
    [sym__open_bracket2] = STATE(1378),
    [ts_builtin_sym_end] = ACTIONS(5345),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5175),
    [anon_sym_DASH] = ACTIONS(5177),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5347),
    [anon_sym_AMP] = ACTIONS(5347),
    [anon_sym_PIPE_PIPE] = ACTIONS(5345),
    [anon_sym_AMP_AMP] = ACTIONS(5345),
    [anon_sym_LT] = ACTIONS(5193),
    [anon_sym_LT_EQ] = ACTIONS(5195),
    [anon_sym_GT] = ACTIONS(5193),
    [anon_sym_GT_EQ] = ACTIONS(5195),
    [anon_sym_EQ_EQ] = ACTIONS(5195),
    [anon_sym_BANG_EQ] = ACTIONS(5195),
    [anon_sym_STAR] = ACTIONS(5197),
    [anon_sym_SLASH] = ACTIONS(5199),
    [anon_sym_STAR_STAR] = ACTIONS(5201),
    [anon_sym_CARET] = ACTIONS(5201),
    [aux_sym_binary_operator_token1] = ACTIONS(5203),
    [anon_sym_PIPE_GT] = ACTIONS(5203),
    [anon_sym_COLON] = ACTIONS(5205),
    [anon_sym_DOLLAR] = ACTIONS(5207),
    [anon_sym_AT] = ACTIONS(5207),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__semicolon] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_else] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(5211),
    [sym__external_close_parenthesis] = ACTIONS(5345),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_close_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(5213),
    [sym__external_open_bracket2] = ACTIONS(5215),
  },
  [519] = {
    [sym_call_arguments] = STATE(2261),
    [sym_subset_arguments] = STATE(2260),
    [sym_subset2_arguments] = STATE(2259),
    [sym__open_parenthesis] = STATE(1380),
    [sym__open_bracket] = STATE(1379),
    [sym__open_bracket2] = STATE(1378),
    [ts_builtin_sym_end] = ACTIONS(5345),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5345),
    [anon_sym_DASH] = ACTIONS(5347),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5347),
    [anon_sym_AMP] = ACTIONS(5347),
    [anon_sym_PIPE_PIPE] = ACTIONS(5345),
    [anon_sym_AMP_AMP] = ACTIONS(5345),
    [anon_sym_LT] = ACTIONS(5347),
    [anon_sym_LT_EQ] = ACTIONS(5345),
    [anon_sym_GT] = ACTIONS(5347),
    [anon_sym_GT_EQ] = ACTIONS(5345),
    [anon_sym_EQ_EQ] = ACTIONS(5345),
    [anon_sym_BANG_EQ] = ACTIONS(5345),
    [anon_sym_STAR] = ACTIONS(5347),
    [anon_sym_SLASH] = ACTIONS(5345),
    [anon_sym_STAR_STAR] = ACTIONS(5201),
    [anon_sym_CARET] = ACTIONS(5201),
    [aux_sym_binary_operator_token1] = ACTIONS(5345),
    [anon_sym_PIPE_GT] = ACTIONS(5345),
    [anon_sym_COLON] = ACTIONS(5347),
    [anon_sym_DOLLAR] = ACTIONS(5207),
    [anon_sym_AT] = ACTIONS(5207),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__semicolon] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_else] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(5211),
    [sym__external_close_parenthesis] = ACTIONS(5345),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_close_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(5213),
    [sym__external_open_bracket2] = ACTIONS(5215),
  },
  [520] = {
    [sym_call_arguments] = STATE(2261),
    [sym_subset_arguments] = STATE(2260),
    [sym_subset2_arguments] = STATE(2259),
    [sym__open_parenthesis] = STATE(1380),
    [sym__open_bracket] = STATE(1379),
    [sym__open_bracket2] = STATE(1378),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5171),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5173),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5175),
    [anon_sym_DASH] = ACTIONS(5177),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5181),
    [anon_sym_DASH_GT_GT] = ACTIONS(5183),
    [anon_sym_PIPE] = ACTIONS(5185),
    [anon_sym_AMP] = ACTIONS(5187),
    [anon_sym_PIPE_PIPE] = ACTIONS(5189),
    [anon_sym_AMP_AMP] = ACTIONS(5191),
    [anon_sym_LT] = ACTIONS(5193),
    [anon_sym_LT_EQ] = ACTIONS(5195),
    [anon_sym_GT] = ACTIONS(5193),
    [anon_sym_GT_EQ] = ACTIONS(5195),
    [anon_sym_EQ_EQ] = ACTIONS(5195),
    [anon_sym_BANG_EQ] = ACTIONS(5195),
    [anon_sym_STAR] = ACTIONS(5197),
    [anon_sym_SLASH] = ACTIONS(5199),
    [anon_sym_STAR_STAR] = ACTIONS(5201),
    [anon_sym_CARET] = ACTIONS(5201),
    [aux_sym_binary_operator_token1] = ACTIONS(5203),
    [anon_sym_PIPE_GT] = ACTIONS(5203),
    [anon_sym_COLON] = ACTIONS(5205),
    [anon_sym_DOLLAR] = ACTIONS(5207),
    [anon_sym_AT] = ACTIONS(5207),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5211),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5213),
    [sym__external_open_bracket2] = ACTIONS(5215),
  },
  [521] = {
    [sym_call_arguments] = STATE(2261),
    [sym_subset_arguments] = STATE(2260),
    [sym_subset2_arguments] = STATE(2259),
    [sym__open_parenthesis] = STATE(1380),
    [sym__open_bracket] = STATE(1379),
    [sym__open_bracket2] = STATE(1378),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5171),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5173),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5175),
    [anon_sym_DASH] = ACTIONS(5177),
    [anon_sym_LT_DASH] = ACTIONS(5179),
    [anon_sym_LT_LT_DASH] = ACTIONS(5179),
    [anon_sym_COLON_EQ] = ACTIONS(5179),
    [anon_sym_DASH_GT] = ACTIONS(5181),
    [anon_sym_DASH_GT_GT] = ACTIONS(5183),
    [anon_sym_PIPE] = ACTIONS(5185),
    [anon_sym_AMP] = ACTIONS(5187),
    [anon_sym_PIPE_PIPE] = ACTIONS(5189),
    [anon_sym_AMP_AMP] = ACTIONS(5191),
    [anon_sym_LT] = ACTIONS(5193),
    [anon_sym_LT_EQ] = ACTIONS(5195),
    [anon_sym_GT] = ACTIONS(5193),
    [anon_sym_GT_EQ] = ACTIONS(5195),
    [anon_sym_EQ_EQ] = ACTIONS(5195),
    [anon_sym_BANG_EQ] = ACTIONS(5195),
    [anon_sym_STAR] = ACTIONS(5197),
    [anon_sym_SLASH] = ACTIONS(5199),
    [anon_sym_STAR_STAR] = ACTIONS(5201),
    [anon_sym_CARET] = ACTIONS(5201),
    [aux_sym_binary_operator_token1] = ACTIONS(5203),
    [anon_sym_PIPE_GT] = ACTIONS(5203),
    [anon_sym_COLON] = ACTIONS(5205),
    [anon_sym_DOLLAR] = ACTIONS(5207),
    [anon_sym_AT] = ACTIONS(5207),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5211),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5213),
    [sym__external_open_bracket2] = ACTIONS(5215),
  },
  [522] = {
    [sym_call_arguments] = STATE(2318),
    [sym_subset_arguments] = STATE(2319),
    [sym_subset2_arguments] = STATE(2320),
    [sym__open_parenthesis] = STATE(1329),
    [sym__open_bracket] = STATE(1328),
    [sym__open_bracket2] = STATE(1327),
    [sym_identifier] = ACTIONS(5325),
    [anon_sym_BSLASH] = ACTIONS(5327),
    [anon_sym_function] = ACTIONS(5325),
    [anon_sym_EQ] = ACTIONS(5119),
    [anon_sym_if] = ACTIONS(5325),
    [anon_sym_for] = ACTIONS(5325),
    [anon_sym_while] = ACTIONS(5325),
    [anon_sym_repeat] = ACTIONS(5325),
    [anon_sym_QMARK] = ACTIONS(5323),
    [anon_sym_TILDE] = ACTIONS(5121),
    [anon_sym_BANG] = ACTIONS(5325),
    [anon_sym_PLUS] = ACTIONS(5123),
    [anon_sym_DASH] = ACTIONS(5125),
    [anon_sym_LT_DASH] = ACTIONS(5127),
    [anon_sym_LT_LT_DASH] = ACTIONS(5127),
    [anon_sym_COLON_EQ] = ACTIONS(5127),
    [anon_sym_DASH_GT] = ACTIONS(5129),
    [anon_sym_DASH_GT_GT] = ACTIONS(5131),
    [anon_sym_PIPE] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5135),
    [anon_sym_PIPE_PIPE] = ACTIONS(5137),
    [anon_sym_AMP_AMP] = ACTIONS(5139),
    [anon_sym_LT] = ACTIONS(5141),
    [anon_sym_LT_EQ] = ACTIONS(5143),
    [anon_sym_GT] = ACTIONS(5141),
    [anon_sym_GT_EQ] = ACTIONS(5143),
    [anon_sym_EQ_EQ] = ACTIONS(5143),
    [anon_sym_BANG_EQ] = ACTIONS(5143),
    [anon_sym_STAR] = ACTIONS(5145),
    [anon_sym_SLASH] = ACTIONS(5147),
    [anon_sym_STAR_STAR] = ACTIONS(5149),
    [anon_sym_CARET] = ACTIONS(5149),
    [aux_sym_binary_operator_token1] = ACTIONS(5151),
    [anon_sym_PIPE_GT] = ACTIONS(5151),
    [anon_sym_COLON] = ACTIONS(5153),
    [anon_sym_DOLLAR] = ACTIONS(5155),
    [anon_sym_AT] = ACTIONS(5155),
    [aux_sym__hex_literal_token1] = ACTIONS(5327),
    [sym__number_literal] = ACTIONS(5325),
    [anon_sym_SQUOTE] = ACTIONS(5327),
    [anon_sym_DQUOTE] = ACTIONS(5327),
    [sym_return] = ACTIONS(5325),
    [sym_next] = ACTIONS(5325),
    [sym_break] = ACTIONS(5325),
    [sym_true] = ACTIONS(5325),
    [sym_false] = ACTIONS(5325),
    [sym_null] = ACTIONS(5325),
    [sym_inf] = ACTIONS(5325),
    [sym_nan] = ACTIONS(5325),
    [anon_sym_NA] = ACTIONS(5325),
    [anon_sym_NA_integer_] = ACTIONS(5325),
    [anon_sym_NA_real_] = ACTIONS(5325),
    [anon_sym_NA_complex_] = ACTIONS(5325),
    [anon_sym_NA_character_] = ACTIONS(5325),
    [sym_dots] = ACTIONS(5325),
    [sym_dot_dot_i] = ACTIONS(5327),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5327),
    [sym__newline] = ACTIONS(5327),
    [sym__semicolon] = ACTIONS(5327),
    [sym__raw_string_literal] = ACTIONS(5327),
    [sym__external_else] = ACTIONS(5327),
    [sym__external_open_parenthesis] = ACTIONS(5159),
    [sym__external_close_parenthesis] = ACTIONS(5327),
    [sym__external_open_brace] = ACTIONS(5327),
    [sym__external_close_brace] = ACTIONS(5327),
    [sym__external_open_bracket] = ACTIONS(5161),
    [sym__external_close_bracket] = ACTIONS(5327),
    [sym__external_open_bracket2] = ACTIONS(5163),
  },
  [523] = {
    [sym_call_arguments] = STATE(2261),
    [sym_subset_arguments] = STATE(2260),
    [sym_subset2_arguments] = STATE(2259),
    [sym__open_parenthesis] = STATE(1380),
    [sym__open_bracket] = STATE(1379),
    [sym__open_bracket2] = STATE(1378),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5175),
    [anon_sym_DASH] = ACTIONS(5177),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5185),
    [anon_sym_AMP] = ACTIONS(5187),
    [anon_sym_PIPE_PIPE] = ACTIONS(5189),
    [anon_sym_AMP_AMP] = ACTIONS(5191),
    [anon_sym_LT] = ACTIONS(5193),
    [anon_sym_LT_EQ] = ACTIONS(5195),
    [anon_sym_GT] = ACTIONS(5193),
    [anon_sym_GT_EQ] = ACTIONS(5195),
    [anon_sym_EQ_EQ] = ACTIONS(5195),
    [anon_sym_BANG_EQ] = ACTIONS(5195),
    [anon_sym_STAR] = ACTIONS(5197),
    [anon_sym_SLASH] = ACTIONS(5199),
    [anon_sym_STAR_STAR] = ACTIONS(5201),
    [anon_sym_CARET] = ACTIONS(5201),
    [aux_sym_binary_operator_token1] = ACTIONS(5203),
    [anon_sym_PIPE_GT] = ACTIONS(5203),
    [anon_sym_COLON] = ACTIONS(5205),
    [anon_sym_DOLLAR] = ACTIONS(5207),
    [anon_sym_AT] = ACTIONS(5207),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5211),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5213),
    [sym__external_open_bracket2] = ACTIONS(5215),
  },
  [524] = {
    [sym_call_arguments] = STATE(2261),
    [sym_subset_arguments] = STATE(2260),
    [sym_subset2_arguments] = STATE(2259),
    [sym__open_parenthesis] = STATE(1380),
    [sym__open_bracket] = STATE(1379),
    [sym__open_bracket2] = STATE(1378),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5197),
    [anon_sym_SLASH] = ACTIONS(5199),
    [anon_sym_STAR_STAR] = ACTIONS(5201),
    [anon_sym_CARET] = ACTIONS(5201),
    [aux_sym_binary_operator_token1] = ACTIONS(5203),
    [anon_sym_PIPE_GT] = ACTIONS(5203),
    [anon_sym_COLON] = ACTIONS(5205),
    [anon_sym_DOLLAR] = ACTIONS(5207),
    [anon_sym_AT] = ACTIONS(5207),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5211),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5213),
    [sym__external_open_bracket2] = ACTIONS(5215),
  },
  [525] = {
    [sym_call_arguments] = STATE(2261),
    [sym_subset_arguments] = STATE(2260),
    [sym_subset2_arguments] = STATE(2259),
    [sym__open_parenthesis] = STATE(1380),
    [sym__open_bracket] = STATE(1379),
    [sym__open_bracket2] = STATE(1378),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5171),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5173),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5175),
    [anon_sym_DASH] = ACTIONS(5177),
    [anon_sym_LT_DASH] = ACTIONS(5179),
    [anon_sym_LT_LT_DASH] = ACTIONS(5179),
    [anon_sym_COLON_EQ] = ACTIONS(5179),
    [anon_sym_DASH_GT] = ACTIONS(5181),
    [anon_sym_DASH_GT_GT] = ACTIONS(5183),
    [anon_sym_PIPE] = ACTIONS(5185),
    [anon_sym_AMP] = ACTIONS(5187),
    [anon_sym_PIPE_PIPE] = ACTIONS(5189),
    [anon_sym_AMP_AMP] = ACTIONS(5191),
    [anon_sym_LT] = ACTIONS(5193),
    [anon_sym_LT_EQ] = ACTIONS(5195),
    [anon_sym_GT] = ACTIONS(5193),
    [anon_sym_GT_EQ] = ACTIONS(5195),
    [anon_sym_EQ_EQ] = ACTIONS(5195),
    [anon_sym_BANG_EQ] = ACTIONS(5195),
    [anon_sym_STAR] = ACTIONS(5197),
    [anon_sym_SLASH] = ACTIONS(5199),
    [anon_sym_STAR_STAR] = ACTIONS(5201),
    [anon_sym_CARET] = ACTIONS(5201),
    [aux_sym_binary_operator_token1] = ACTIONS(5203),
    [anon_sym_PIPE_GT] = ACTIONS(5203),
    [anon_sym_COLON] = ACTIONS(5205),
    [anon_sym_DOLLAR] = ACTIONS(5207),
    [anon_sym_AT] = ACTIONS(5207),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5211),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5213),
    [sym__external_open_bracket2] = ACTIONS(5215),
  },
  [526] = {
    [sym_call_arguments] = STATE(2261),
    [sym_subset_arguments] = STATE(2260),
    [sym_subset2_arguments] = STATE(2259),
    [sym__open_parenthesis] = STATE(1380),
    [sym__open_bracket] = STATE(1379),
    [sym__open_bracket2] = STATE(1378),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5173),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5175),
    [anon_sym_DASH] = ACTIONS(5177),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5185),
    [anon_sym_AMP] = ACTIONS(5187),
    [anon_sym_PIPE_PIPE] = ACTIONS(5189),
    [anon_sym_AMP_AMP] = ACTIONS(5191),
    [anon_sym_LT] = ACTIONS(5193),
    [anon_sym_LT_EQ] = ACTIONS(5195),
    [anon_sym_GT] = ACTIONS(5193),
    [anon_sym_GT_EQ] = ACTIONS(5195),
    [anon_sym_EQ_EQ] = ACTIONS(5195),
    [anon_sym_BANG_EQ] = ACTIONS(5195),
    [anon_sym_STAR] = ACTIONS(5197),
    [anon_sym_SLASH] = ACTIONS(5199),
    [anon_sym_STAR_STAR] = ACTIONS(5201),
    [anon_sym_CARET] = ACTIONS(5201),
    [aux_sym_binary_operator_token1] = ACTIONS(5203),
    [anon_sym_PIPE_GT] = ACTIONS(5203),
    [anon_sym_COLON] = ACTIONS(5205),
    [anon_sym_DOLLAR] = ACTIONS(5207),
    [anon_sym_AT] = ACTIONS(5207),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5211),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5213),
    [sym__external_open_bracket2] = ACTIONS(5215),
  },
  [527] = {
    [sym_call_arguments] = STATE(2261),
    [sym_subset_arguments] = STATE(2260),
    [sym_subset2_arguments] = STATE(2259),
    [sym__open_parenthesis] = STATE(1380),
    [sym__open_bracket] = STATE(1379),
    [sym__open_bracket2] = STATE(1378),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5175),
    [anon_sym_DASH] = ACTIONS(5177),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5187),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5191),
    [anon_sym_LT] = ACTIONS(5193),
    [anon_sym_LT_EQ] = ACTIONS(5195),
    [anon_sym_GT] = ACTIONS(5193),
    [anon_sym_GT_EQ] = ACTIONS(5195),
    [anon_sym_EQ_EQ] = ACTIONS(5195),
    [anon_sym_BANG_EQ] = ACTIONS(5195),
    [anon_sym_STAR] = ACTIONS(5197),
    [anon_sym_SLASH] = ACTIONS(5199),
    [anon_sym_STAR_STAR] = ACTIONS(5201),
    [anon_sym_CARET] = ACTIONS(5201),
    [aux_sym_binary_operator_token1] = ACTIONS(5203),
    [anon_sym_PIPE_GT] = ACTIONS(5203),
    [anon_sym_COLON] = ACTIONS(5205),
    [anon_sym_DOLLAR] = ACTIONS(5207),
    [anon_sym_AT] = ACTIONS(5207),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5211),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5213),
    [sym__external_open_bracket2] = ACTIONS(5215),
  },
  [528] = {
    [sym_call_arguments] = STATE(2261),
    [sym_subset_arguments] = STATE(2260),
    [sym_subset2_arguments] = STATE(2259),
    [sym__open_parenthesis] = STATE(1380),
    [sym__open_bracket] = STATE(1379),
    [sym__open_bracket2] = STATE(1378),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5175),
    [anon_sym_DASH] = ACTIONS(5177),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5193),
    [anon_sym_LT_EQ] = ACTIONS(5195),
    [anon_sym_GT] = ACTIONS(5193),
    [anon_sym_GT_EQ] = ACTIONS(5195),
    [anon_sym_EQ_EQ] = ACTIONS(5195),
    [anon_sym_BANG_EQ] = ACTIONS(5195),
    [anon_sym_STAR] = ACTIONS(5197),
    [anon_sym_SLASH] = ACTIONS(5199),
    [anon_sym_STAR_STAR] = ACTIONS(5201),
    [anon_sym_CARET] = ACTIONS(5201),
    [aux_sym_binary_operator_token1] = ACTIONS(5203),
    [anon_sym_PIPE_GT] = ACTIONS(5203),
    [anon_sym_COLON] = ACTIONS(5205),
    [anon_sym_DOLLAR] = ACTIONS(5207),
    [anon_sym_AT] = ACTIONS(5207),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5211),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5213),
    [sym__external_open_bracket2] = ACTIONS(5215),
  },
  [529] = {
    [sym_call_arguments] = STATE(2261),
    [sym_subset_arguments] = STATE(2260),
    [sym_subset2_arguments] = STATE(2259),
    [sym__open_parenthesis] = STATE(1380),
    [sym__open_bracket] = STATE(1379),
    [sym__open_bracket2] = STATE(1378),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5175),
    [anon_sym_DASH] = ACTIONS(5177),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5197),
    [anon_sym_SLASH] = ACTIONS(5199),
    [anon_sym_STAR_STAR] = ACTIONS(5201),
    [anon_sym_CARET] = ACTIONS(5201),
    [aux_sym_binary_operator_token1] = ACTIONS(5203),
    [anon_sym_PIPE_GT] = ACTIONS(5203),
    [anon_sym_COLON] = ACTIONS(5205),
    [anon_sym_DOLLAR] = ACTIONS(5207),
    [anon_sym_AT] = ACTIONS(5207),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5211),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5213),
    [sym__external_open_bracket2] = ACTIONS(5215),
  },
  [530] = {
    [sym_call_arguments] = STATE(2261),
    [sym_subset_arguments] = STATE(2260),
    [sym_subset2_arguments] = STATE(2259),
    [sym__open_parenthesis] = STATE(1380),
    [sym__open_bracket] = STATE(1379),
    [sym__open_bracket2] = STATE(1378),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(5201),
    [anon_sym_CARET] = ACTIONS(5201),
    [aux_sym_binary_operator_token1] = ACTIONS(5203),
    [anon_sym_PIPE_GT] = ACTIONS(5203),
    [anon_sym_COLON] = ACTIONS(5205),
    [anon_sym_DOLLAR] = ACTIONS(5207),
    [anon_sym_AT] = ACTIONS(5207),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5211),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5213),
    [sym__external_open_bracket2] = ACTIONS(5215),
  },
  [531] = {
    [sym_call_arguments] = STATE(2261),
    [sym_subset_arguments] = STATE(2260),
    [sym_subset2_arguments] = STATE(2259),
    [sym__open_parenthesis] = STATE(1380),
    [sym__open_bracket] = STATE(1379),
    [sym__open_bracket2] = STATE(1378),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(5201),
    [anon_sym_CARET] = ACTIONS(5201),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(5351),
    [anon_sym_DOLLAR] = ACTIONS(5207),
    [anon_sym_AT] = ACTIONS(5207),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5211),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5213),
    [sym__external_open_bracket2] = ACTIONS(5215),
  },
  [532] = {
    [sym_call_arguments] = STATE(2438),
    [sym_subset_arguments] = STATE(2439),
    [sym_subset2_arguments] = STATE(2440),
    [sym__else] = STATE(4218),
    [sym__open_parenthesis] = STATE(1350),
    [sym__open_bracket] = STATE(1348),
    [sym__open_bracket2] = STATE(1346),
    [sym_identifier] = ACTIONS(5065),
    [anon_sym_BSLASH] = ACTIONS(5067),
    [anon_sym_function] = ACTIONS(5065),
    [anon_sym_EQ] = ACTIONS(5353),
    [anon_sym_if] = ACTIONS(5065),
    [anon_sym_for] = ACTIONS(5065),
    [anon_sym_while] = ACTIONS(5065),
    [anon_sym_repeat] = ACTIONS(5065),
    [anon_sym_QMARK] = ACTIONS(5067),
    [anon_sym_TILDE] = ACTIONS(5355),
    [anon_sym_BANG] = ACTIONS(5065),
    [anon_sym_PLUS] = ACTIONS(5357),
    [anon_sym_DASH] = ACTIONS(5359),
    [anon_sym_LT_DASH] = ACTIONS(5361),
    [anon_sym_LT_LT_DASH] = ACTIONS(5361),
    [anon_sym_COLON_EQ] = ACTIONS(5361),
    [anon_sym_DASH_GT] = ACTIONS(5363),
    [anon_sym_DASH_GT_GT] = ACTIONS(5365),
    [anon_sym_PIPE] = ACTIONS(5367),
    [anon_sym_AMP] = ACTIONS(5369),
    [anon_sym_PIPE_PIPE] = ACTIONS(5371),
    [anon_sym_AMP_AMP] = ACTIONS(5373),
    [anon_sym_LT] = ACTIONS(5375),
    [anon_sym_LT_EQ] = ACTIONS(5377),
    [anon_sym_GT] = ACTIONS(5375),
    [anon_sym_GT_EQ] = ACTIONS(5377),
    [anon_sym_EQ_EQ] = ACTIONS(5377),
    [anon_sym_BANG_EQ] = ACTIONS(5377),
    [anon_sym_STAR] = ACTIONS(5379),
    [anon_sym_SLASH] = ACTIONS(5381),
    [anon_sym_STAR_STAR] = ACTIONS(5383),
    [anon_sym_CARET] = ACTIONS(5383),
    [aux_sym_binary_operator_token1] = ACTIONS(5385),
    [anon_sym_PIPE_GT] = ACTIONS(5385),
    [anon_sym_COLON] = ACTIONS(5387),
    [anon_sym_DOLLAR] = ACTIONS(5389),
    [anon_sym_AT] = ACTIONS(5389),
    [aux_sym__hex_literal_token1] = ACTIONS(5067),
    [sym__number_literal] = ACTIONS(5065),
    [anon_sym_SQUOTE] = ACTIONS(5067),
    [anon_sym_DQUOTE] = ACTIONS(5067),
    [sym_return] = ACTIONS(5065),
    [sym_next] = ACTIONS(5065),
    [sym_break] = ACTIONS(5065),
    [sym_true] = ACTIONS(5065),
    [sym_false] = ACTIONS(5065),
    [sym_null] = ACTIONS(5065),
    [sym_inf] = ACTIONS(5065),
    [sym_nan] = ACTIONS(5065),
    [anon_sym_NA] = ACTIONS(5065),
    [anon_sym_NA_integer_] = ACTIONS(5065),
    [anon_sym_NA_real_] = ACTIONS(5065),
    [anon_sym_NA_complex_] = ACTIONS(5065),
    [anon_sym_NA_character_] = ACTIONS(5065),
    [sym_dots] = ACTIONS(5065),
    [sym_dot_dot_i] = ACTIONS(5067),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5067),
    [sym__newline] = ACTIONS(5067),
    [sym__semicolon] = ACTIONS(5067),
    [sym__raw_string_literal] = ACTIONS(5067),
    [sym__external_else] = ACTIONS(5391),
    [sym__external_open_parenthesis] = ACTIONS(5393),
    [sym__external_open_brace] = ACTIONS(5067),
    [sym__external_close_brace] = ACTIONS(5067),
    [sym__external_open_bracket] = ACTIONS(5395),
    [sym__external_close_bracket] = ACTIONS(5067),
    [sym__external_open_bracket2] = ACTIONS(5397),
  },
  [533] = {
    [sym_call_arguments] = STATE(2261),
    [sym_subset_arguments] = STATE(2260),
    [sym_subset2_arguments] = STATE(2259),
    [sym__open_parenthesis] = STATE(1380),
    [sym__open_bracket] = STATE(1379),
    [sym__open_bracket2] = STATE(1378),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(5201),
    [anon_sym_CARET] = ACTIONS(5201),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(5205),
    [anon_sym_DOLLAR] = ACTIONS(5207),
    [anon_sym_AT] = ACTIONS(5207),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5211),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5213),
    [sym__external_open_bracket2] = ACTIONS(5215),
  },
  [534] = {
    [sym_call_arguments] = STATE(2261),
    [sym_subset_arguments] = STATE(2260),
    [sym_subset2_arguments] = STATE(2259),
    [sym__open_parenthesis] = STATE(1380),
    [sym__open_bracket] = STATE(1379),
    [sym__open_bracket2] = STATE(1378),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(5201),
    [anon_sym_CARET] = ACTIONS(5201),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(5351),
    [anon_sym_DOLLAR] = ACTIONS(5207),
    [anon_sym_AT] = ACTIONS(5207),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5211),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5213),
    [sym__external_open_bracket2] = ACTIONS(5215),
  },
  [535] = {
    [sym_call_arguments] = STATE(2261),
    [sym_subset_arguments] = STATE(2260),
    [sym_subset2_arguments] = STATE(2259),
    [sym__open_parenthesis] = STATE(1380),
    [sym__open_bracket] = STATE(1379),
    [sym__open_bracket2] = STATE(1378),
    [ts_builtin_sym_end] = ACTIONS(5399),
    [sym_identifier] = ACTIONS(5401),
    [anon_sym_BSLASH] = ACTIONS(5399),
    [anon_sym_function] = ACTIONS(5401),
    [anon_sym_EQ] = ACTIONS(5171),
    [anon_sym_if] = ACTIONS(5401),
    [anon_sym_for] = ACTIONS(5401),
    [anon_sym_while] = ACTIONS(5401),
    [anon_sym_repeat] = ACTIONS(5401),
    [anon_sym_QMARK] = ACTIONS(5399),
    [anon_sym_TILDE] = ACTIONS(5173),
    [anon_sym_BANG] = ACTIONS(5401),
    [anon_sym_PLUS] = ACTIONS(5175),
    [anon_sym_DASH] = ACTIONS(5177),
    [anon_sym_LT_DASH] = ACTIONS(5179),
    [anon_sym_LT_LT_DASH] = ACTIONS(5179),
    [anon_sym_COLON_EQ] = ACTIONS(5179),
    [anon_sym_DASH_GT] = ACTIONS(5181),
    [anon_sym_DASH_GT_GT] = ACTIONS(5183),
    [anon_sym_PIPE] = ACTIONS(5185),
    [anon_sym_AMP] = ACTIONS(5187),
    [anon_sym_PIPE_PIPE] = ACTIONS(5189),
    [anon_sym_AMP_AMP] = ACTIONS(5191),
    [anon_sym_LT] = ACTIONS(5193),
    [anon_sym_LT_EQ] = ACTIONS(5195),
    [anon_sym_GT] = ACTIONS(5193),
    [anon_sym_GT_EQ] = ACTIONS(5195),
    [anon_sym_EQ_EQ] = ACTIONS(5195),
    [anon_sym_BANG_EQ] = ACTIONS(5195),
    [anon_sym_STAR] = ACTIONS(5197),
    [anon_sym_SLASH] = ACTIONS(5199),
    [anon_sym_STAR_STAR] = ACTIONS(5201),
    [anon_sym_CARET] = ACTIONS(5201),
    [aux_sym_binary_operator_token1] = ACTIONS(5203),
    [anon_sym_PIPE_GT] = ACTIONS(5203),
    [anon_sym_COLON] = ACTIONS(5205),
    [anon_sym_DOLLAR] = ACTIONS(5207),
    [anon_sym_AT] = ACTIONS(5207),
    [aux_sym__hex_literal_token1] = ACTIONS(5399),
    [sym__number_literal] = ACTIONS(5401),
    [anon_sym_SQUOTE] = ACTIONS(5399),
    [anon_sym_DQUOTE] = ACTIONS(5399),
    [sym_return] = ACTIONS(5401),
    [sym_next] = ACTIONS(5401),
    [sym_break] = ACTIONS(5401),
    [sym_true] = ACTIONS(5401),
    [sym_false] = ACTIONS(5401),
    [sym_null] = ACTIONS(5401),
    [sym_inf] = ACTIONS(5401),
    [sym_nan] = ACTIONS(5401),
    [anon_sym_NA] = ACTIONS(5401),
    [anon_sym_NA_integer_] = ACTIONS(5401),
    [anon_sym_NA_real_] = ACTIONS(5401),
    [anon_sym_NA_complex_] = ACTIONS(5401),
    [anon_sym_NA_character_] = ACTIONS(5401),
    [sym_dots] = ACTIONS(5401),
    [sym_dot_dot_i] = ACTIONS(5399),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5399),
    [sym__newline] = ACTIONS(5399),
    [sym__semicolon] = ACTIONS(5399),
    [sym__raw_string_literal] = ACTIONS(5399),
    [sym__external_else] = ACTIONS(5399),
    [sym__external_open_parenthesis] = ACTIONS(5211),
    [sym__external_close_parenthesis] = ACTIONS(5399),
    [sym__external_open_brace] = ACTIONS(5399),
    [sym__external_close_brace] = ACTIONS(5399),
    [sym__external_open_bracket] = ACTIONS(5213),
    [sym__external_open_bracket2] = ACTIONS(5215),
  },
  [536] = {
    [sym_call_arguments] = STATE(2261),
    [sym_subset_arguments] = STATE(2260),
    [sym_subset2_arguments] = STATE(2259),
    [sym__open_parenthesis] = STATE(1380),
    [sym__open_bracket] = STATE(1379),
    [sym__open_bracket2] = STATE(1378),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5171),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5173),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5175),
    [anon_sym_DASH] = ACTIONS(5177),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5181),
    [anon_sym_DASH_GT_GT] = ACTIONS(5183),
    [anon_sym_PIPE] = ACTIONS(5185),
    [anon_sym_AMP] = ACTIONS(5187),
    [anon_sym_PIPE_PIPE] = ACTIONS(5189),
    [anon_sym_AMP_AMP] = ACTIONS(5191),
    [anon_sym_LT] = ACTIONS(5193),
    [anon_sym_LT_EQ] = ACTIONS(5195),
    [anon_sym_GT] = ACTIONS(5193),
    [anon_sym_GT_EQ] = ACTIONS(5195),
    [anon_sym_EQ_EQ] = ACTIONS(5195),
    [anon_sym_BANG_EQ] = ACTIONS(5195),
    [anon_sym_STAR] = ACTIONS(5197),
    [anon_sym_SLASH] = ACTIONS(5199),
    [anon_sym_STAR_STAR] = ACTIONS(5201),
    [anon_sym_CARET] = ACTIONS(5201),
    [aux_sym_binary_operator_token1] = ACTIONS(5203),
    [anon_sym_PIPE_GT] = ACTIONS(5203),
    [anon_sym_COLON] = ACTIONS(5205),
    [anon_sym_DOLLAR] = ACTIONS(5207),
    [anon_sym_AT] = ACTIONS(5207),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5211),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5213),
    [sym__external_open_bracket2] = ACTIONS(5215),
  },
  [537] = {
    [sym_call_arguments] = STATE(2438),
    [sym_subset_arguments] = STATE(2439),
    [sym_subset2_arguments] = STATE(2440),
    [sym__else] = STATE(4221),
    [sym__open_parenthesis] = STATE(1350),
    [sym__open_bracket] = STATE(1348),
    [sym__open_bracket2] = STATE(1346),
    [sym_identifier] = ACTIONS(5115),
    [anon_sym_BSLASH] = ACTIONS(5117),
    [anon_sym_function] = ACTIONS(5115),
    [anon_sym_EQ] = ACTIONS(5353),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_for] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_repeat] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(5117),
    [anon_sym_TILDE] = ACTIONS(5355),
    [anon_sym_BANG] = ACTIONS(5115),
    [anon_sym_PLUS] = ACTIONS(5357),
    [anon_sym_DASH] = ACTIONS(5359),
    [anon_sym_LT_DASH] = ACTIONS(5361),
    [anon_sym_LT_LT_DASH] = ACTIONS(5361),
    [anon_sym_COLON_EQ] = ACTIONS(5361),
    [anon_sym_DASH_GT] = ACTIONS(5363),
    [anon_sym_DASH_GT_GT] = ACTIONS(5365),
    [anon_sym_PIPE] = ACTIONS(5367),
    [anon_sym_AMP] = ACTIONS(5369),
    [anon_sym_PIPE_PIPE] = ACTIONS(5371),
    [anon_sym_AMP_AMP] = ACTIONS(5373),
    [anon_sym_LT] = ACTIONS(5375),
    [anon_sym_LT_EQ] = ACTIONS(5377),
    [anon_sym_GT] = ACTIONS(5375),
    [anon_sym_GT_EQ] = ACTIONS(5377),
    [anon_sym_EQ_EQ] = ACTIONS(5377),
    [anon_sym_BANG_EQ] = ACTIONS(5377),
    [anon_sym_STAR] = ACTIONS(5379),
    [anon_sym_SLASH] = ACTIONS(5381),
    [anon_sym_STAR_STAR] = ACTIONS(5383),
    [anon_sym_CARET] = ACTIONS(5383),
    [aux_sym_binary_operator_token1] = ACTIONS(5385),
    [anon_sym_PIPE_GT] = ACTIONS(5385),
    [anon_sym_COLON] = ACTIONS(5387),
    [anon_sym_DOLLAR] = ACTIONS(5389),
    [anon_sym_AT] = ACTIONS(5389),
    [aux_sym__hex_literal_token1] = ACTIONS(5117),
    [sym__number_literal] = ACTIONS(5115),
    [anon_sym_SQUOTE] = ACTIONS(5117),
    [anon_sym_DQUOTE] = ACTIONS(5117),
    [sym_return] = ACTIONS(5115),
    [sym_next] = ACTIONS(5115),
    [sym_break] = ACTIONS(5115),
    [sym_true] = ACTIONS(5115),
    [sym_false] = ACTIONS(5115),
    [sym_null] = ACTIONS(5115),
    [sym_inf] = ACTIONS(5115),
    [sym_nan] = ACTIONS(5115),
    [anon_sym_NA] = ACTIONS(5115),
    [anon_sym_NA_integer_] = ACTIONS(5115),
    [anon_sym_NA_real_] = ACTIONS(5115),
    [anon_sym_NA_complex_] = ACTIONS(5115),
    [anon_sym_NA_character_] = ACTIONS(5115),
    [sym_dots] = ACTIONS(5115),
    [sym_dot_dot_i] = ACTIONS(5117),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5117),
    [sym__newline] = ACTIONS(5117),
    [sym__semicolon] = ACTIONS(5117),
    [sym__raw_string_literal] = ACTIONS(5117),
    [sym__external_else] = ACTIONS(5403),
    [sym__external_open_parenthesis] = ACTIONS(5393),
    [sym__external_open_brace] = ACTIONS(5117),
    [sym__external_close_brace] = ACTIONS(5117),
    [sym__external_open_bracket] = ACTIONS(5395),
    [sym__external_close_bracket] = ACTIONS(5117),
    [sym__external_open_bracket2] = ACTIONS(5397),
  },
  [538] = {
    [sym_call_arguments] = STATE(2438),
    [sym_subset_arguments] = STATE(2439),
    [sym_subset2_arguments] = STATE(2440),
    [sym__else] = STATE(4224),
    [sym__open_parenthesis] = STATE(1350),
    [sym__open_bracket] = STATE(1348),
    [sym__open_bracket2] = STATE(1346),
    [sym_identifier] = ACTIONS(5169),
    [anon_sym_BSLASH] = ACTIONS(5167),
    [anon_sym_function] = ACTIONS(5169),
    [anon_sym_EQ] = ACTIONS(5353),
    [anon_sym_if] = ACTIONS(5169),
    [anon_sym_for] = ACTIONS(5169),
    [anon_sym_while] = ACTIONS(5169),
    [anon_sym_repeat] = ACTIONS(5169),
    [anon_sym_QMARK] = ACTIONS(5167),
    [anon_sym_TILDE] = ACTIONS(5355),
    [anon_sym_BANG] = ACTIONS(5169),
    [anon_sym_PLUS] = ACTIONS(5357),
    [anon_sym_DASH] = ACTIONS(5359),
    [anon_sym_LT_DASH] = ACTIONS(5361),
    [anon_sym_LT_LT_DASH] = ACTIONS(5361),
    [anon_sym_COLON_EQ] = ACTIONS(5361),
    [anon_sym_DASH_GT] = ACTIONS(5363),
    [anon_sym_DASH_GT_GT] = ACTIONS(5365),
    [anon_sym_PIPE] = ACTIONS(5367),
    [anon_sym_AMP] = ACTIONS(5369),
    [anon_sym_PIPE_PIPE] = ACTIONS(5371),
    [anon_sym_AMP_AMP] = ACTIONS(5373),
    [anon_sym_LT] = ACTIONS(5375),
    [anon_sym_LT_EQ] = ACTIONS(5377),
    [anon_sym_GT] = ACTIONS(5375),
    [anon_sym_GT_EQ] = ACTIONS(5377),
    [anon_sym_EQ_EQ] = ACTIONS(5377),
    [anon_sym_BANG_EQ] = ACTIONS(5377),
    [anon_sym_STAR] = ACTIONS(5379),
    [anon_sym_SLASH] = ACTIONS(5381),
    [anon_sym_STAR_STAR] = ACTIONS(5383),
    [anon_sym_CARET] = ACTIONS(5383),
    [aux_sym_binary_operator_token1] = ACTIONS(5385),
    [anon_sym_PIPE_GT] = ACTIONS(5385),
    [anon_sym_COLON] = ACTIONS(5387),
    [anon_sym_DOLLAR] = ACTIONS(5389),
    [anon_sym_AT] = ACTIONS(5389),
    [aux_sym__hex_literal_token1] = ACTIONS(5167),
    [sym__number_literal] = ACTIONS(5169),
    [anon_sym_SQUOTE] = ACTIONS(5167),
    [anon_sym_DQUOTE] = ACTIONS(5167),
    [sym_return] = ACTIONS(5169),
    [sym_next] = ACTIONS(5169),
    [sym_break] = ACTIONS(5169),
    [sym_true] = ACTIONS(5169),
    [sym_false] = ACTIONS(5169),
    [sym_null] = ACTIONS(5169),
    [sym_inf] = ACTIONS(5169),
    [sym_nan] = ACTIONS(5169),
    [anon_sym_NA] = ACTIONS(5169),
    [anon_sym_NA_integer_] = ACTIONS(5169),
    [anon_sym_NA_real_] = ACTIONS(5169),
    [anon_sym_NA_complex_] = ACTIONS(5169),
    [anon_sym_NA_character_] = ACTIONS(5169),
    [sym_dots] = ACTIONS(5169),
    [sym_dot_dot_i] = ACTIONS(5167),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5167),
    [sym__newline] = ACTIONS(5167),
    [sym__semicolon] = ACTIONS(5167),
    [sym__raw_string_literal] = ACTIONS(5167),
    [sym__external_else] = ACTIONS(5405),
    [sym__external_open_parenthesis] = ACTIONS(5393),
    [sym__external_open_brace] = ACTIONS(5167),
    [sym__external_close_brace] = ACTIONS(5167),
    [sym__external_open_bracket] = ACTIONS(5395),
    [sym__external_close_bracket] = ACTIONS(5167),
    [sym__external_open_bracket2] = ACTIONS(5397),
  },
  [539] = {
    [sym_call_arguments] = STATE(2261),
    [sym_subset_arguments] = STATE(2260),
    [sym_subset2_arguments] = STATE(2259),
    [sym__open_parenthesis] = STATE(1380),
    [sym__open_bracket] = STATE(1379),
    [sym__open_bracket2] = STATE(1378),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5171),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5173),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5175),
    [anon_sym_DASH] = ACTIONS(5177),
    [anon_sym_LT_DASH] = ACTIONS(5179),
    [anon_sym_LT_LT_DASH] = ACTIONS(5179),
    [anon_sym_COLON_EQ] = ACTIONS(5179),
    [anon_sym_DASH_GT] = ACTIONS(5181),
    [anon_sym_DASH_GT_GT] = ACTIONS(5183),
    [anon_sym_PIPE] = ACTIONS(5185),
    [anon_sym_AMP] = ACTIONS(5187),
    [anon_sym_PIPE_PIPE] = ACTIONS(5189),
    [anon_sym_AMP_AMP] = ACTIONS(5191),
    [anon_sym_LT] = ACTIONS(5193),
    [anon_sym_LT_EQ] = ACTIONS(5195),
    [anon_sym_GT] = ACTIONS(5193),
    [anon_sym_GT_EQ] = ACTIONS(5195),
    [anon_sym_EQ_EQ] = ACTIONS(5195),
    [anon_sym_BANG_EQ] = ACTIONS(5195),
    [anon_sym_STAR] = ACTIONS(5197),
    [anon_sym_SLASH] = ACTIONS(5199),
    [anon_sym_STAR_STAR] = ACTIONS(5201),
    [anon_sym_CARET] = ACTIONS(5201),
    [aux_sym_binary_operator_token1] = ACTIONS(5203),
    [anon_sym_PIPE_GT] = ACTIONS(5203),
    [anon_sym_COLON] = ACTIONS(5205),
    [anon_sym_DOLLAR] = ACTIONS(5207),
    [anon_sym_AT] = ACTIONS(5207),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5211),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5213),
    [sym__external_open_bracket2] = ACTIONS(5215),
  },
  [540] = {
    [sym_call_arguments] = STATE(2261),
    [sym_subset_arguments] = STATE(2260),
    [sym_subset2_arguments] = STATE(2259),
    [sym__open_parenthesis] = STATE(1380),
    [sym__open_bracket] = STATE(1379),
    [sym__open_bracket2] = STATE(1378),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5175),
    [anon_sym_DASH] = ACTIONS(5177),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5185),
    [anon_sym_AMP] = ACTIONS(5187),
    [anon_sym_PIPE_PIPE] = ACTIONS(5189),
    [anon_sym_AMP_AMP] = ACTIONS(5191),
    [anon_sym_LT] = ACTIONS(5193),
    [anon_sym_LT_EQ] = ACTIONS(5195),
    [anon_sym_GT] = ACTIONS(5193),
    [anon_sym_GT_EQ] = ACTIONS(5195),
    [anon_sym_EQ_EQ] = ACTIONS(5195),
    [anon_sym_BANG_EQ] = ACTIONS(5195),
    [anon_sym_STAR] = ACTIONS(5197),
    [anon_sym_SLASH] = ACTIONS(5199),
    [anon_sym_STAR_STAR] = ACTIONS(5201),
    [anon_sym_CARET] = ACTIONS(5201),
    [aux_sym_binary_operator_token1] = ACTIONS(5203),
    [anon_sym_PIPE_GT] = ACTIONS(5203),
    [anon_sym_COLON] = ACTIONS(5205),
    [anon_sym_DOLLAR] = ACTIONS(5207),
    [anon_sym_AT] = ACTIONS(5207),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5211),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5213),
    [sym__external_open_bracket2] = ACTIONS(5215),
  },
  [541] = {
    [sym_call_arguments] = STATE(2261),
    [sym_subset_arguments] = STATE(2260),
    [sym_subset2_arguments] = STATE(2259),
    [sym__open_parenthesis] = STATE(1380),
    [sym__open_bracket] = STATE(1379),
    [sym__open_bracket2] = STATE(1378),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5197),
    [anon_sym_SLASH] = ACTIONS(5199),
    [anon_sym_STAR_STAR] = ACTIONS(5201),
    [anon_sym_CARET] = ACTIONS(5201),
    [aux_sym_binary_operator_token1] = ACTIONS(5203),
    [anon_sym_PIPE_GT] = ACTIONS(5203),
    [anon_sym_COLON] = ACTIONS(5205),
    [anon_sym_DOLLAR] = ACTIONS(5207),
    [anon_sym_AT] = ACTIONS(5207),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5211),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5213),
    [sym__external_open_bracket2] = ACTIONS(5215),
  },
  [542] = {
    [sym_call_arguments] = STATE(2438),
    [sym_subset_arguments] = STATE(2439),
    [sym_subset2_arguments] = STATE(2440),
    [sym__else] = STATE(4232),
    [sym__open_parenthesis] = STATE(1350),
    [sym__open_bracket] = STATE(1348),
    [sym__open_bracket2] = STATE(1346),
    [sym_identifier] = ACTIONS(5225),
    [anon_sym_BSLASH] = ACTIONS(5227),
    [anon_sym_function] = ACTIONS(5225),
    [anon_sym_EQ] = ACTIONS(5353),
    [anon_sym_if] = ACTIONS(5225),
    [anon_sym_for] = ACTIONS(5225),
    [anon_sym_while] = ACTIONS(5225),
    [anon_sym_repeat] = ACTIONS(5225),
    [anon_sym_QMARK] = ACTIONS(5227),
    [anon_sym_TILDE] = ACTIONS(5355),
    [anon_sym_BANG] = ACTIONS(5225),
    [anon_sym_PLUS] = ACTIONS(5357),
    [anon_sym_DASH] = ACTIONS(5359),
    [anon_sym_LT_DASH] = ACTIONS(5361),
    [anon_sym_LT_LT_DASH] = ACTIONS(5361),
    [anon_sym_COLON_EQ] = ACTIONS(5361),
    [anon_sym_DASH_GT] = ACTIONS(5363),
    [anon_sym_DASH_GT_GT] = ACTIONS(5365),
    [anon_sym_PIPE] = ACTIONS(5367),
    [anon_sym_AMP] = ACTIONS(5369),
    [anon_sym_PIPE_PIPE] = ACTIONS(5371),
    [anon_sym_AMP_AMP] = ACTIONS(5373),
    [anon_sym_LT] = ACTIONS(5375),
    [anon_sym_LT_EQ] = ACTIONS(5377),
    [anon_sym_GT] = ACTIONS(5375),
    [anon_sym_GT_EQ] = ACTIONS(5377),
    [anon_sym_EQ_EQ] = ACTIONS(5377),
    [anon_sym_BANG_EQ] = ACTIONS(5377),
    [anon_sym_STAR] = ACTIONS(5379),
    [anon_sym_SLASH] = ACTIONS(5381),
    [anon_sym_STAR_STAR] = ACTIONS(5383),
    [anon_sym_CARET] = ACTIONS(5383),
    [aux_sym_binary_operator_token1] = ACTIONS(5385),
    [anon_sym_PIPE_GT] = ACTIONS(5385),
    [anon_sym_COLON] = ACTIONS(5387),
    [anon_sym_DOLLAR] = ACTIONS(5389),
    [anon_sym_AT] = ACTIONS(5389),
    [aux_sym__hex_literal_token1] = ACTIONS(5227),
    [sym__number_literal] = ACTIONS(5225),
    [anon_sym_SQUOTE] = ACTIONS(5227),
    [anon_sym_DQUOTE] = ACTIONS(5227),
    [sym_return] = ACTIONS(5225),
    [sym_next] = ACTIONS(5225),
    [sym_break] = ACTIONS(5225),
    [sym_true] = ACTIONS(5225),
    [sym_false] = ACTIONS(5225),
    [sym_null] = ACTIONS(5225),
    [sym_inf] = ACTIONS(5225),
    [sym_nan] = ACTIONS(5225),
    [anon_sym_NA] = ACTIONS(5225),
    [anon_sym_NA_integer_] = ACTIONS(5225),
    [anon_sym_NA_real_] = ACTIONS(5225),
    [anon_sym_NA_complex_] = ACTIONS(5225),
    [anon_sym_NA_character_] = ACTIONS(5225),
    [sym_dots] = ACTIONS(5225),
    [sym_dot_dot_i] = ACTIONS(5227),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5227),
    [sym__newline] = ACTIONS(5227),
    [sym__semicolon] = ACTIONS(5227),
    [sym__raw_string_literal] = ACTIONS(5227),
    [sym__external_else] = ACTIONS(5407),
    [sym__external_open_parenthesis] = ACTIONS(5393),
    [sym__external_open_brace] = ACTIONS(5227),
    [sym__external_close_brace] = ACTIONS(5227),
    [sym__external_open_bracket] = ACTIONS(5395),
    [sym__external_close_bracket] = ACTIONS(5227),
    [sym__external_open_bracket2] = ACTIONS(5397),
  },
  [543] = {
    [sym_call_arguments] = STATE(2261),
    [sym_subset_arguments] = STATE(2260),
    [sym_subset2_arguments] = STATE(2259),
    [sym__open_parenthesis] = STATE(1380),
    [sym__open_bracket] = STATE(1379),
    [sym__open_bracket2] = STATE(1378),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5171),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5173),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5175),
    [anon_sym_DASH] = ACTIONS(5177),
    [anon_sym_LT_DASH] = ACTIONS(5179),
    [anon_sym_LT_LT_DASH] = ACTIONS(5179),
    [anon_sym_COLON_EQ] = ACTIONS(5179),
    [anon_sym_DASH_GT] = ACTIONS(5181),
    [anon_sym_DASH_GT_GT] = ACTIONS(5183),
    [anon_sym_PIPE] = ACTIONS(5185),
    [anon_sym_AMP] = ACTIONS(5187),
    [anon_sym_PIPE_PIPE] = ACTIONS(5189),
    [anon_sym_AMP_AMP] = ACTIONS(5191),
    [anon_sym_LT] = ACTIONS(5193),
    [anon_sym_LT_EQ] = ACTIONS(5195),
    [anon_sym_GT] = ACTIONS(5193),
    [anon_sym_GT_EQ] = ACTIONS(5195),
    [anon_sym_EQ_EQ] = ACTIONS(5195),
    [anon_sym_BANG_EQ] = ACTIONS(5195),
    [anon_sym_STAR] = ACTIONS(5197),
    [anon_sym_SLASH] = ACTIONS(5199),
    [anon_sym_STAR_STAR] = ACTIONS(5201),
    [anon_sym_CARET] = ACTIONS(5201),
    [aux_sym_binary_operator_token1] = ACTIONS(5203),
    [anon_sym_PIPE_GT] = ACTIONS(5203),
    [anon_sym_COLON] = ACTIONS(5205),
    [anon_sym_DOLLAR] = ACTIONS(5207),
    [anon_sym_AT] = ACTIONS(5207),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5211),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5213),
    [sym__external_open_bracket2] = ACTIONS(5215),
  },
  [544] = {
    [sym_call_arguments] = STATE(2261),
    [sym_subset_arguments] = STATE(2260),
    [sym_subset2_arguments] = STATE(2259),
    [sym__open_parenthesis] = STATE(1380),
    [sym__open_bracket] = STATE(1379),
    [sym__open_bracket2] = STATE(1378),
    [ts_builtin_sym_end] = ACTIONS(5409),
    [sym_identifier] = ACTIONS(5411),
    [anon_sym_BSLASH] = ACTIONS(5409),
    [anon_sym_function] = ACTIONS(5411),
    [anon_sym_EQ] = ACTIONS(5171),
    [anon_sym_if] = ACTIONS(5411),
    [anon_sym_for] = ACTIONS(5411),
    [anon_sym_while] = ACTIONS(5411),
    [anon_sym_repeat] = ACTIONS(5411),
    [anon_sym_QMARK] = ACTIONS(5409),
    [anon_sym_TILDE] = ACTIONS(5173),
    [anon_sym_BANG] = ACTIONS(5411),
    [anon_sym_PLUS] = ACTIONS(5175),
    [anon_sym_DASH] = ACTIONS(5177),
    [anon_sym_LT_DASH] = ACTIONS(5179),
    [anon_sym_LT_LT_DASH] = ACTIONS(5179),
    [anon_sym_COLON_EQ] = ACTIONS(5179),
    [anon_sym_DASH_GT] = ACTIONS(5181),
    [anon_sym_DASH_GT_GT] = ACTIONS(5183),
    [anon_sym_PIPE] = ACTIONS(5185),
    [anon_sym_AMP] = ACTIONS(5187),
    [anon_sym_PIPE_PIPE] = ACTIONS(5189),
    [anon_sym_AMP_AMP] = ACTIONS(5191),
    [anon_sym_LT] = ACTIONS(5193),
    [anon_sym_LT_EQ] = ACTIONS(5195),
    [anon_sym_GT] = ACTIONS(5193),
    [anon_sym_GT_EQ] = ACTIONS(5195),
    [anon_sym_EQ_EQ] = ACTIONS(5195),
    [anon_sym_BANG_EQ] = ACTIONS(5195),
    [anon_sym_STAR] = ACTIONS(5197),
    [anon_sym_SLASH] = ACTIONS(5199),
    [anon_sym_STAR_STAR] = ACTIONS(5201),
    [anon_sym_CARET] = ACTIONS(5201),
    [aux_sym_binary_operator_token1] = ACTIONS(5203),
    [anon_sym_PIPE_GT] = ACTIONS(5203),
    [anon_sym_COLON] = ACTIONS(5205),
    [anon_sym_DOLLAR] = ACTIONS(5207),
    [anon_sym_AT] = ACTIONS(5207),
    [aux_sym__hex_literal_token1] = ACTIONS(5409),
    [sym__number_literal] = ACTIONS(5411),
    [anon_sym_SQUOTE] = ACTIONS(5409),
    [anon_sym_DQUOTE] = ACTIONS(5409),
    [sym_return] = ACTIONS(5411),
    [sym_next] = ACTIONS(5411),
    [sym_break] = ACTIONS(5411),
    [sym_true] = ACTIONS(5411),
    [sym_false] = ACTIONS(5411),
    [sym_null] = ACTIONS(5411),
    [sym_inf] = ACTIONS(5411),
    [sym_nan] = ACTIONS(5411),
    [anon_sym_NA] = ACTIONS(5411),
    [anon_sym_NA_integer_] = ACTIONS(5411),
    [anon_sym_NA_real_] = ACTIONS(5411),
    [anon_sym_NA_complex_] = ACTIONS(5411),
    [anon_sym_NA_character_] = ACTIONS(5411),
    [sym_dots] = ACTIONS(5411),
    [sym_dot_dot_i] = ACTIONS(5409),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5409),
    [sym__newline] = ACTIONS(5409),
    [sym__semicolon] = ACTIONS(5409),
    [sym__raw_string_literal] = ACTIONS(5409),
    [sym__external_else] = ACTIONS(5409),
    [sym__external_open_parenthesis] = ACTIONS(5211),
    [sym__external_close_parenthesis] = ACTIONS(5409),
    [sym__external_open_brace] = ACTIONS(5409),
    [sym__external_close_brace] = ACTIONS(5409),
    [sym__external_open_bracket] = ACTIONS(5213),
    [sym__external_open_bracket2] = ACTIONS(5215),
  },
  [545] = {
    [sym_call_arguments] = STATE(2261),
    [sym_subset_arguments] = STATE(2260),
    [sym_subset2_arguments] = STATE(2259),
    [sym__open_parenthesis] = STATE(1380),
    [sym__open_bracket] = STATE(1379),
    [sym__open_bracket2] = STATE(1378),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5175),
    [anon_sym_DASH] = ACTIONS(5177),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5187),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5191),
    [anon_sym_LT] = ACTIONS(5193),
    [anon_sym_LT_EQ] = ACTIONS(5195),
    [anon_sym_GT] = ACTIONS(5193),
    [anon_sym_GT_EQ] = ACTIONS(5195),
    [anon_sym_EQ_EQ] = ACTIONS(5195),
    [anon_sym_BANG_EQ] = ACTIONS(5195),
    [anon_sym_STAR] = ACTIONS(5197),
    [anon_sym_SLASH] = ACTIONS(5199),
    [anon_sym_STAR_STAR] = ACTIONS(5201),
    [anon_sym_CARET] = ACTIONS(5201),
    [aux_sym_binary_operator_token1] = ACTIONS(5203),
    [anon_sym_PIPE_GT] = ACTIONS(5203),
    [anon_sym_COLON] = ACTIONS(5205),
    [anon_sym_DOLLAR] = ACTIONS(5207),
    [anon_sym_AT] = ACTIONS(5207),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5211),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5213),
    [sym__external_open_bracket2] = ACTIONS(5215),
  },
  [546] = {
    [sym_call_arguments] = STATE(2261),
    [sym_subset_arguments] = STATE(2260),
    [sym_subset2_arguments] = STATE(2259),
    [sym__open_parenthesis] = STATE(1380),
    [sym__open_bracket] = STATE(1379),
    [sym__open_bracket2] = STATE(1378),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5175),
    [anon_sym_DASH] = ACTIONS(5177),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5193),
    [anon_sym_LT_EQ] = ACTIONS(5195),
    [anon_sym_GT] = ACTIONS(5193),
    [anon_sym_GT_EQ] = ACTIONS(5195),
    [anon_sym_EQ_EQ] = ACTIONS(5195),
    [anon_sym_BANG_EQ] = ACTIONS(5195),
    [anon_sym_STAR] = ACTIONS(5197),
    [anon_sym_SLASH] = ACTIONS(5199),
    [anon_sym_STAR_STAR] = ACTIONS(5201),
    [anon_sym_CARET] = ACTIONS(5201),
    [aux_sym_binary_operator_token1] = ACTIONS(5203),
    [anon_sym_PIPE_GT] = ACTIONS(5203),
    [anon_sym_COLON] = ACTIONS(5205),
    [anon_sym_DOLLAR] = ACTIONS(5207),
    [anon_sym_AT] = ACTIONS(5207),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5211),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5213),
    [sym__external_open_bracket2] = ACTIONS(5215),
  },
  [547] = {
    [sym_call_arguments] = STATE(2261),
    [sym_subset_arguments] = STATE(2260),
    [sym_subset2_arguments] = STATE(2259),
    [sym__open_parenthesis] = STATE(1380),
    [sym__open_bracket] = STATE(1379),
    [sym__open_bracket2] = STATE(1378),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5175),
    [anon_sym_DASH] = ACTIONS(5177),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5197),
    [anon_sym_SLASH] = ACTIONS(5199),
    [anon_sym_STAR_STAR] = ACTIONS(5201),
    [anon_sym_CARET] = ACTIONS(5201),
    [aux_sym_binary_operator_token1] = ACTIONS(5203),
    [anon_sym_PIPE_GT] = ACTIONS(5203),
    [anon_sym_COLON] = ACTIONS(5205),
    [anon_sym_DOLLAR] = ACTIONS(5207),
    [anon_sym_AT] = ACTIONS(5207),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5211),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5213),
    [sym__external_open_bracket2] = ACTIONS(5215),
  },
  [548] = {
    [sym_call_arguments] = STATE(2261),
    [sym_subset_arguments] = STATE(2260),
    [sym_subset2_arguments] = STATE(2259),
    [sym__open_parenthesis] = STATE(1380),
    [sym__open_bracket] = STATE(1379),
    [sym__open_bracket2] = STATE(1378),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(5201),
    [anon_sym_CARET] = ACTIONS(5201),
    [aux_sym_binary_operator_token1] = ACTIONS(5203),
    [anon_sym_PIPE_GT] = ACTIONS(5203),
    [anon_sym_COLON] = ACTIONS(5205),
    [anon_sym_DOLLAR] = ACTIONS(5207),
    [anon_sym_AT] = ACTIONS(5207),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5211),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5213),
    [sym__external_open_bracket2] = ACTIONS(5215),
  },
  [549] = {
    [sym_call_arguments] = STATE(2261),
    [sym_subset_arguments] = STATE(2260),
    [sym_subset2_arguments] = STATE(2259),
    [sym__open_parenthesis] = STATE(1380),
    [sym__open_bracket] = STATE(1379),
    [sym__open_bracket2] = STATE(1378),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(5201),
    [anon_sym_CARET] = ACTIONS(5201),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(5261),
    [anon_sym_DOLLAR] = ACTIONS(5207),
    [anon_sym_AT] = ACTIONS(5207),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5211),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5213),
    [sym__external_open_bracket2] = ACTIONS(5215),
  },
  [550] = {
    [sym_call_arguments] = STATE(2261),
    [sym_subset_arguments] = STATE(2260),
    [sym_subset2_arguments] = STATE(2259),
    [sym__open_parenthesis] = STATE(1380),
    [sym__open_bracket] = STATE(1379),
    [sym__open_bracket2] = STATE(1378),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(5201),
    [anon_sym_CARET] = ACTIONS(5201),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(5205),
    [anon_sym_DOLLAR] = ACTIONS(5207),
    [anon_sym_AT] = ACTIONS(5207),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5211),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5213),
    [sym__external_open_bracket2] = ACTIONS(5215),
  },
  [551] = {
    [sym_call_arguments] = STATE(2261),
    [sym_subset_arguments] = STATE(2260),
    [sym_subset2_arguments] = STATE(2259),
    [sym__open_parenthesis] = STATE(1380),
    [sym__open_bracket] = STATE(1379),
    [sym__open_bracket2] = STATE(1378),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(5201),
    [anon_sym_CARET] = ACTIONS(5201),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(5261),
    [anon_sym_DOLLAR] = ACTIONS(5207),
    [anon_sym_AT] = ACTIONS(5207),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5211),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5213),
    [sym__external_open_bracket2] = ACTIONS(5215),
  },
  [552] = {
    [sym_call_arguments] = STATE(2261),
    [sym_subset_arguments] = STATE(2260),
    [sym_subset2_arguments] = STATE(2259),
    [sym__open_parenthesis] = STATE(1380),
    [sym__open_bracket] = STATE(1379),
    [sym__open_bracket2] = STATE(1378),
    [ts_builtin_sym_end] = ACTIONS(5413),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_BSLASH] = ACTIONS(5413),
    [anon_sym_function] = ACTIONS(5415),
    [anon_sym_EQ] = ACTIONS(5171),
    [anon_sym_if] = ACTIONS(5415),
    [anon_sym_for] = ACTIONS(5415),
    [anon_sym_while] = ACTIONS(5415),
    [anon_sym_repeat] = ACTIONS(5415),
    [anon_sym_QMARK] = ACTIONS(5413),
    [anon_sym_TILDE] = ACTIONS(5173),
    [anon_sym_BANG] = ACTIONS(5415),
    [anon_sym_PLUS] = ACTIONS(5175),
    [anon_sym_DASH] = ACTIONS(5177),
    [anon_sym_LT_DASH] = ACTIONS(5179),
    [anon_sym_LT_LT_DASH] = ACTIONS(5179),
    [anon_sym_COLON_EQ] = ACTIONS(5179),
    [anon_sym_DASH_GT] = ACTIONS(5181),
    [anon_sym_DASH_GT_GT] = ACTIONS(5183),
    [anon_sym_PIPE] = ACTIONS(5185),
    [anon_sym_AMP] = ACTIONS(5187),
    [anon_sym_PIPE_PIPE] = ACTIONS(5189),
    [anon_sym_AMP_AMP] = ACTIONS(5191),
    [anon_sym_LT] = ACTIONS(5193),
    [anon_sym_LT_EQ] = ACTIONS(5195),
    [anon_sym_GT] = ACTIONS(5193),
    [anon_sym_GT_EQ] = ACTIONS(5195),
    [anon_sym_EQ_EQ] = ACTIONS(5195),
    [anon_sym_BANG_EQ] = ACTIONS(5195),
    [anon_sym_STAR] = ACTIONS(5197),
    [anon_sym_SLASH] = ACTIONS(5199),
    [anon_sym_STAR_STAR] = ACTIONS(5201),
    [anon_sym_CARET] = ACTIONS(5201),
    [aux_sym_binary_operator_token1] = ACTIONS(5203),
    [anon_sym_PIPE_GT] = ACTIONS(5203),
    [anon_sym_COLON] = ACTIONS(5205),
    [anon_sym_DOLLAR] = ACTIONS(5207),
    [anon_sym_AT] = ACTIONS(5207),
    [aux_sym__hex_literal_token1] = ACTIONS(5413),
    [sym__number_literal] = ACTIONS(5415),
    [anon_sym_SQUOTE] = ACTIONS(5413),
    [anon_sym_DQUOTE] = ACTIONS(5413),
    [sym_return] = ACTIONS(5415),
    [sym_next] = ACTIONS(5415),
    [sym_break] = ACTIONS(5415),
    [sym_true] = ACTIONS(5415),
    [sym_false] = ACTIONS(5415),
    [sym_null] = ACTIONS(5415),
    [sym_inf] = ACTIONS(5415),
    [sym_nan] = ACTIONS(5415),
    [anon_sym_NA] = ACTIONS(5415),
    [anon_sym_NA_integer_] = ACTIONS(5415),
    [anon_sym_NA_real_] = ACTIONS(5415),
    [anon_sym_NA_complex_] = ACTIONS(5415),
    [anon_sym_NA_character_] = ACTIONS(5415),
    [sym_dots] = ACTIONS(5415),
    [sym_dot_dot_i] = ACTIONS(5413),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5413),
    [sym__newline] = ACTIONS(5413),
    [sym__semicolon] = ACTIONS(5413),
    [sym__raw_string_literal] = ACTIONS(5413),
    [sym__external_else] = ACTIONS(5413),
    [sym__external_open_parenthesis] = ACTIONS(5211),
    [sym__external_close_parenthesis] = ACTIONS(5413),
    [sym__external_open_brace] = ACTIONS(5413),
    [sym__external_close_brace] = ACTIONS(5413),
    [sym__external_open_bracket] = ACTIONS(5213),
    [sym__external_open_bracket2] = ACTIONS(5215),
  },
  [553] = {
    [sym_call_arguments] = STATE(2261),
    [sym_subset_arguments] = STATE(2260),
    [sym_subset2_arguments] = STATE(2259),
    [sym__open_parenthesis] = STATE(1380),
    [sym__open_bracket] = STATE(1379),
    [sym__open_bracket2] = STATE(1378),
    [ts_builtin_sym_end] = ACTIONS(5417),
    [sym_identifier] = ACTIONS(5419),
    [anon_sym_BSLASH] = ACTIONS(5417),
    [anon_sym_function] = ACTIONS(5419),
    [anon_sym_EQ] = ACTIONS(5171),
    [anon_sym_if] = ACTIONS(5419),
    [anon_sym_for] = ACTIONS(5419),
    [anon_sym_while] = ACTIONS(5419),
    [anon_sym_repeat] = ACTIONS(5419),
    [anon_sym_QMARK] = ACTIONS(5417),
    [anon_sym_TILDE] = ACTIONS(5173),
    [anon_sym_BANG] = ACTIONS(5419),
    [anon_sym_PLUS] = ACTIONS(5175),
    [anon_sym_DASH] = ACTIONS(5177),
    [anon_sym_LT_DASH] = ACTIONS(5179),
    [anon_sym_LT_LT_DASH] = ACTIONS(5179),
    [anon_sym_COLON_EQ] = ACTIONS(5179),
    [anon_sym_DASH_GT] = ACTIONS(5181),
    [anon_sym_DASH_GT_GT] = ACTIONS(5183),
    [anon_sym_PIPE] = ACTIONS(5185),
    [anon_sym_AMP] = ACTIONS(5187),
    [anon_sym_PIPE_PIPE] = ACTIONS(5189),
    [anon_sym_AMP_AMP] = ACTIONS(5191),
    [anon_sym_LT] = ACTIONS(5193),
    [anon_sym_LT_EQ] = ACTIONS(5195),
    [anon_sym_GT] = ACTIONS(5193),
    [anon_sym_GT_EQ] = ACTIONS(5195),
    [anon_sym_EQ_EQ] = ACTIONS(5195),
    [anon_sym_BANG_EQ] = ACTIONS(5195),
    [anon_sym_STAR] = ACTIONS(5197),
    [anon_sym_SLASH] = ACTIONS(5199),
    [anon_sym_STAR_STAR] = ACTIONS(5201),
    [anon_sym_CARET] = ACTIONS(5201),
    [aux_sym_binary_operator_token1] = ACTIONS(5203),
    [anon_sym_PIPE_GT] = ACTIONS(5203),
    [anon_sym_COLON] = ACTIONS(5205),
    [anon_sym_DOLLAR] = ACTIONS(5207),
    [anon_sym_AT] = ACTIONS(5207),
    [aux_sym__hex_literal_token1] = ACTIONS(5417),
    [sym__number_literal] = ACTIONS(5419),
    [anon_sym_SQUOTE] = ACTIONS(5417),
    [anon_sym_DQUOTE] = ACTIONS(5417),
    [sym_return] = ACTIONS(5419),
    [sym_next] = ACTIONS(5419),
    [sym_break] = ACTIONS(5419),
    [sym_true] = ACTIONS(5419),
    [sym_false] = ACTIONS(5419),
    [sym_null] = ACTIONS(5419),
    [sym_inf] = ACTIONS(5419),
    [sym_nan] = ACTIONS(5419),
    [anon_sym_NA] = ACTIONS(5419),
    [anon_sym_NA_integer_] = ACTIONS(5419),
    [anon_sym_NA_real_] = ACTIONS(5419),
    [anon_sym_NA_complex_] = ACTIONS(5419),
    [anon_sym_NA_character_] = ACTIONS(5419),
    [sym_dots] = ACTIONS(5419),
    [sym_dot_dot_i] = ACTIONS(5417),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5417),
    [sym__newline] = ACTIONS(5417),
    [sym__semicolon] = ACTIONS(5417),
    [sym__raw_string_literal] = ACTIONS(5417),
    [sym__external_else] = ACTIONS(5417),
    [sym__external_open_parenthesis] = ACTIONS(5211),
    [sym__external_close_parenthesis] = ACTIONS(5417),
    [sym__external_open_brace] = ACTIONS(5417),
    [sym__external_close_brace] = ACTIONS(5417),
    [sym__external_open_bracket] = ACTIONS(5213),
    [sym__external_open_bracket2] = ACTIONS(5215),
  },
  [554] = {
    [sym_call_arguments] = STATE(2261),
    [sym_subset_arguments] = STATE(2260),
    [sym_subset2_arguments] = STATE(2259),
    [sym__open_parenthesis] = STATE(1380),
    [sym__open_bracket] = STATE(1379),
    [sym__open_bracket2] = STATE(1378),
    [ts_builtin_sym_end] = ACTIONS(5421),
    [sym_identifier] = ACTIONS(5423),
    [anon_sym_BSLASH] = ACTIONS(5421),
    [anon_sym_function] = ACTIONS(5423),
    [anon_sym_EQ] = ACTIONS(5171),
    [anon_sym_if] = ACTIONS(5423),
    [anon_sym_for] = ACTIONS(5423),
    [anon_sym_while] = ACTIONS(5423),
    [anon_sym_repeat] = ACTIONS(5423),
    [anon_sym_QMARK] = ACTIONS(5421),
    [anon_sym_TILDE] = ACTIONS(5173),
    [anon_sym_BANG] = ACTIONS(5423),
    [anon_sym_PLUS] = ACTIONS(5175),
    [anon_sym_DASH] = ACTIONS(5177),
    [anon_sym_LT_DASH] = ACTIONS(5179),
    [anon_sym_LT_LT_DASH] = ACTIONS(5179),
    [anon_sym_COLON_EQ] = ACTIONS(5179),
    [anon_sym_DASH_GT] = ACTIONS(5181),
    [anon_sym_DASH_GT_GT] = ACTIONS(5183),
    [anon_sym_PIPE] = ACTIONS(5185),
    [anon_sym_AMP] = ACTIONS(5187),
    [anon_sym_PIPE_PIPE] = ACTIONS(5189),
    [anon_sym_AMP_AMP] = ACTIONS(5191),
    [anon_sym_LT] = ACTIONS(5193),
    [anon_sym_LT_EQ] = ACTIONS(5195),
    [anon_sym_GT] = ACTIONS(5193),
    [anon_sym_GT_EQ] = ACTIONS(5195),
    [anon_sym_EQ_EQ] = ACTIONS(5195),
    [anon_sym_BANG_EQ] = ACTIONS(5195),
    [anon_sym_STAR] = ACTIONS(5197),
    [anon_sym_SLASH] = ACTIONS(5199),
    [anon_sym_STAR_STAR] = ACTIONS(5201),
    [anon_sym_CARET] = ACTIONS(5201),
    [aux_sym_binary_operator_token1] = ACTIONS(5203),
    [anon_sym_PIPE_GT] = ACTIONS(5203),
    [anon_sym_COLON] = ACTIONS(5205),
    [anon_sym_DOLLAR] = ACTIONS(5207),
    [anon_sym_AT] = ACTIONS(5207),
    [aux_sym__hex_literal_token1] = ACTIONS(5421),
    [sym__number_literal] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5421),
    [anon_sym_DQUOTE] = ACTIONS(5421),
    [sym_return] = ACTIONS(5423),
    [sym_next] = ACTIONS(5423),
    [sym_break] = ACTIONS(5423),
    [sym_true] = ACTIONS(5423),
    [sym_false] = ACTIONS(5423),
    [sym_null] = ACTIONS(5423),
    [sym_inf] = ACTIONS(5423),
    [sym_nan] = ACTIONS(5423),
    [anon_sym_NA] = ACTIONS(5423),
    [anon_sym_NA_integer_] = ACTIONS(5423),
    [anon_sym_NA_real_] = ACTIONS(5423),
    [anon_sym_NA_complex_] = ACTIONS(5423),
    [anon_sym_NA_character_] = ACTIONS(5423),
    [sym_dots] = ACTIONS(5423),
    [sym_dot_dot_i] = ACTIONS(5421),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5421),
    [sym__newline] = ACTIONS(5421),
    [sym__semicolon] = ACTIONS(5421),
    [sym__raw_string_literal] = ACTIONS(5421),
    [sym__external_else] = ACTIONS(5421),
    [sym__external_open_parenthesis] = ACTIONS(5211),
    [sym__external_close_parenthesis] = ACTIONS(5421),
    [sym__external_open_brace] = ACTIONS(5421),
    [sym__external_close_brace] = ACTIONS(5421),
    [sym__external_open_bracket] = ACTIONS(5213),
    [sym__external_open_bracket2] = ACTIONS(5215),
  },
  [555] = {
    [sym_call_arguments] = STATE(2261),
    [sym_subset_arguments] = STATE(2260),
    [sym_subset2_arguments] = STATE(2259),
    [sym__open_parenthesis] = STATE(1380),
    [sym__open_bracket] = STATE(1379),
    [sym__open_bracket2] = STATE(1378),
    [ts_builtin_sym_end] = ACTIONS(5425),
    [sym_identifier] = ACTIONS(5427),
    [anon_sym_BSLASH] = ACTIONS(5425),
    [anon_sym_function] = ACTIONS(5427),
    [anon_sym_EQ] = ACTIONS(5171),
    [anon_sym_if] = ACTIONS(5427),
    [anon_sym_for] = ACTIONS(5427),
    [anon_sym_while] = ACTIONS(5427),
    [anon_sym_repeat] = ACTIONS(5427),
    [anon_sym_QMARK] = ACTIONS(5425),
    [anon_sym_TILDE] = ACTIONS(5173),
    [anon_sym_BANG] = ACTIONS(5427),
    [anon_sym_PLUS] = ACTIONS(5175),
    [anon_sym_DASH] = ACTIONS(5177),
    [anon_sym_LT_DASH] = ACTIONS(5179),
    [anon_sym_LT_LT_DASH] = ACTIONS(5179),
    [anon_sym_COLON_EQ] = ACTIONS(5179),
    [anon_sym_DASH_GT] = ACTIONS(5181),
    [anon_sym_DASH_GT_GT] = ACTIONS(5183),
    [anon_sym_PIPE] = ACTIONS(5185),
    [anon_sym_AMP] = ACTIONS(5187),
    [anon_sym_PIPE_PIPE] = ACTIONS(5189),
    [anon_sym_AMP_AMP] = ACTIONS(5191),
    [anon_sym_LT] = ACTIONS(5193),
    [anon_sym_LT_EQ] = ACTIONS(5195),
    [anon_sym_GT] = ACTIONS(5193),
    [anon_sym_GT_EQ] = ACTIONS(5195),
    [anon_sym_EQ_EQ] = ACTIONS(5195),
    [anon_sym_BANG_EQ] = ACTIONS(5195),
    [anon_sym_STAR] = ACTIONS(5197),
    [anon_sym_SLASH] = ACTIONS(5199),
    [anon_sym_STAR_STAR] = ACTIONS(5201),
    [anon_sym_CARET] = ACTIONS(5201),
    [aux_sym_binary_operator_token1] = ACTIONS(5203),
    [anon_sym_PIPE_GT] = ACTIONS(5203),
    [anon_sym_COLON] = ACTIONS(5205),
    [anon_sym_DOLLAR] = ACTIONS(5207),
    [anon_sym_AT] = ACTIONS(5207),
    [aux_sym__hex_literal_token1] = ACTIONS(5425),
    [sym__number_literal] = ACTIONS(5427),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_DQUOTE] = ACTIONS(5425),
    [sym_return] = ACTIONS(5427),
    [sym_next] = ACTIONS(5427),
    [sym_break] = ACTIONS(5427),
    [sym_true] = ACTIONS(5427),
    [sym_false] = ACTIONS(5427),
    [sym_null] = ACTIONS(5427),
    [sym_inf] = ACTIONS(5427),
    [sym_nan] = ACTIONS(5427),
    [anon_sym_NA] = ACTIONS(5427),
    [anon_sym_NA_integer_] = ACTIONS(5427),
    [anon_sym_NA_real_] = ACTIONS(5427),
    [anon_sym_NA_complex_] = ACTIONS(5427),
    [anon_sym_NA_character_] = ACTIONS(5427),
    [sym_dots] = ACTIONS(5427),
    [sym_dot_dot_i] = ACTIONS(5425),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5425),
    [sym__newline] = ACTIONS(5425),
    [sym__semicolon] = ACTIONS(5425),
    [sym__raw_string_literal] = ACTIONS(5425),
    [sym__external_else] = ACTIONS(5425),
    [sym__external_open_parenthesis] = ACTIONS(5211),
    [sym__external_close_parenthesis] = ACTIONS(5425),
    [sym__external_open_brace] = ACTIONS(5425),
    [sym__external_close_brace] = ACTIONS(5425),
    [sym__external_open_bracket] = ACTIONS(5213),
    [sym__external_open_bracket2] = ACTIONS(5215),
  },
  [556] = {
    [sym_call_arguments] = STATE(2261),
    [sym_subset_arguments] = STATE(2260),
    [sym_subset2_arguments] = STATE(2259),
    [sym__open_parenthesis] = STATE(1380),
    [sym__open_bracket] = STATE(1379),
    [sym__open_bracket2] = STATE(1378),
    [ts_builtin_sym_end] = ACTIONS(5429),
    [sym_identifier] = ACTIONS(5431),
    [anon_sym_BSLASH] = ACTIONS(5429),
    [anon_sym_function] = ACTIONS(5431),
    [anon_sym_EQ] = ACTIONS(5171),
    [anon_sym_if] = ACTIONS(5431),
    [anon_sym_for] = ACTIONS(5431),
    [anon_sym_while] = ACTIONS(5431),
    [anon_sym_repeat] = ACTIONS(5431),
    [anon_sym_QMARK] = ACTIONS(5429),
    [anon_sym_TILDE] = ACTIONS(5173),
    [anon_sym_BANG] = ACTIONS(5431),
    [anon_sym_PLUS] = ACTIONS(5175),
    [anon_sym_DASH] = ACTIONS(5177),
    [anon_sym_LT_DASH] = ACTIONS(5179),
    [anon_sym_LT_LT_DASH] = ACTIONS(5179),
    [anon_sym_COLON_EQ] = ACTIONS(5179),
    [anon_sym_DASH_GT] = ACTIONS(5181),
    [anon_sym_DASH_GT_GT] = ACTIONS(5183),
    [anon_sym_PIPE] = ACTIONS(5185),
    [anon_sym_AMP] = ACTIONS(5187),
    [anon_sym_PIPE_PIPE] = ACTIONS(5189),
    [anon_sym_AMP_AMP] = ACTIONS(5191),
    [anon_sym_LT] = ACTIONS(5193),
    [anon_sym_LT_EQ] = ACTIONS(5195),
    [anon_sym_GT] = ACTIONS(5193),
    [anon_sym_GT_EQ] = ACTIONS(5195),
    [anon_sym_EQ_EQ] = ACTIONS(5195),
    [anon_sym_BANG_EQ] = ACTIONS(5195),
    [anon_sym_STAR] = ACTIONS(5197),
    [anon_sym_SLASH] = ACTIONS(5199),
    [anon_sym_STAR_STAR] = ACTIONS(5201),
    [anon_sym_CARET] = ACTIONS(5201),
    [aux_sym_binary_operator_token1] = ACTIONS(5203),
    [anon_sym_PIPE_GT] = ACTIONS(5203),
    [anon_sym_COLON] = ACTIONS(5205),
    [anon_sym_DOLLAR] = ACTIONS(5207),
    [anon_sym_AT] = ACTIONS(5207),
    [aux_sym__hex_literal_token1] = ACTIONS(5429),
    [sym__number_literal] = ACTIONS(5431),
    [anon_sym_SQUOTE] = ACTIONS(5429),
    [anon_sym_DQUOTE] = ACTIONS(5429),
    [sym_return] = ACTIONS(5431),
    [sym_next] = ACTIONS(5431),
    [sym_break] = ACTIONS(5431),
    [sym_true] = ACTIONS(5431),
    [sym_false] = ACTIONS(5431),
    [sym_null] = ACTIONS(5431),
    [sym_inf] = ACTIONS(5431),
    [sym_nan] = ACTIONS(5431),
    [anon_sym_NA] = ACTIONS(5431),
    [anon_sym_NA_integer_] = ACTIONS(5431),
    [anon_sym_NA_real_] = ACTIONS(5431),
    [anon_sym_NA_complex_] = ACTIONS(5431),
    [anon_sym_NA_character_] = ACTIONS(5431),
    [sym_dots] = ACTIONS(5431),
    [sym_dot_dot_i] = ACTIONS(5429),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5429),
    [sym__newline] = ACTIONS(5429),
    [sym__semicolon] = ACTIONS(5429),
    [sym__raw_string_literal] = ACTIONS(5429),
    [sym__external_else] = ACTIONS(5429),
    [sym__external_open_parenthesis] = ACTIONS(5211),
    [sym__external_close_parenthesis] = ACTIONS(5429),
    [sym__external_open_brace] = ACTIONS(5429),
    [sym__external_close_brace] = ACTIONS(5429),
    [sym__external_open_bracket] = ACTIONS(5213),
    [sym__external_open_bracket2] = ACTIONS(5215),
  },
  [557] = {
    [sym_call_arguments] = STATE(2261),
    [sym_subset_arguments] = STATE(2260),
    [sym_subset2_arguments] = STATE(2259),
    [sym__open_parenthesis] = STATE(1380),
    [sym__open_bracket] = STATE(1379),
    [sym__open_bracket2] = STATE(1378),
    [ts_builtin_sym_end] = ACTIONS(5433),
    [sym_identifier] = ACTIONS(5435),
    [anon_sym_BSLASH] = ACTIONS(5433),
    [anon_sym_function] = ACTIONS(5435),
    [anon_sym_EQ] = ACTIONS(5171),
    [anon_sym_if] = ACTIONS(5435),
    [anon_sym_for] = ACTIONS(5435),
    [anon_sym_while] = ACTIONS(5435),
    [anon_sym_repeat] = ACTIONS(5435),
    [anon_sym_QMARK] = ACTIONS(5433),
    [anon_sym_TILDE] = ACTIONS(5173),
    [anon_sym_BANG] = ACTIONS(5435),
    [anon_sym_PLUS] = ACTIONS(5175),
    [anon_sym_DASH] = ACTIONS(5177),
    [anon_sym_LT_DASH] = ACTIONS(5179),
    [anon_sym_LT_LT_DASH] = ACTIONS(5179),
    [anon_sym_COLON_EQ] = ACTIONS(5179),
    [anon_sym_DASH_GT] = ACTIONS(5181),
    [anon_sym_DASH_GT_GT] = ACTIONS(5183),
    [anon_sym_PIPE] = ACTIONS(5185),
    [anon_sym_AMP] = ACTIONS(5187),
    [anon_sym_PIPE_PIPE] = ACTIONS(5189),
    [anon_sym_AMP_AMP] = ACTIONS(5191),
    [anon_sym_LT] = ACTIONS(5193),
    [anon_sym_LT_EQ] = ACTIONS(5195),
    [anon_sym_GT] = ACTIONS(5193),
    [anon_sym_GT_EQ] = ACTIONS(5195),
    [anon_sym_EQ_EQ] = ACTIONS(5195),
    [anon_sym_BANG_EQ] = ACTIONS(5195),
    [anon_sym_STAR] = ACTIONS(5197),
    [anon_sym_SLASH] = ACTIONS(5199),
    [anon_sym_STAR_STAR] = ACTIONS(5201),
    [anon_sym_CARET] = ACTIONS(5201),
    [aux_sym_binary_operator_token1] = ACTIONS(5203),
    [anon_sym_PIPE_GT] = ACTIONS(5203),
    [anon_sym_COLON] = ACTIONS(5205),
    [anon_sym_DOLLAR] = ACTIONS(5207),
    [anon_sym_AT] = ACTIONS(5207),
    [aux_sym__hex_literal_token1] = ACTIONS(5433),
    [sym__number_literal] = ACTIONS(5435),
    [anon_sym_SQUOTE] = ACTIONS(5433),
    [anon_sym_DQUOTE] = ACTIONS(5433),
    [sym_return] = ACTIONS(5435),
    [sym_next] = ACTIONS(5435),
    [sym_break] = ACTIONS(5435),
    [sym_true] = ACTIONS(5435),
    [sym_false] = ACTIONS(5435),
    [sym_null] = ACTIONS(5435),
    [sym_inf] = ACTIONS(5435),
    [sym_nan] = ACTIONS(5435),
    [anon_sym_NA] = ACTIONS(5435),
    [anon_sym_NA_integer_] = ACTIONS(5435),
    [anon_sym_NA_real_] = ACTIONS(5435),
    [anon_sym_NA_complex_] = ACTIONS(5435),
    [anon_sym_NA_character_] = ACTIONS(5435),
    [sym_dots] = ACTIONS(5435),
    [sym_dot_dot_i] = ACTIONS(5433),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5433),
    [sym__newline] = ACTIONS(5433),
    [sym__semicolon] = ACTIONS(5433),
    [sym__raw_string_literal] = ACTIONS(5433),
    [sym__external_else] = ACTIONS(5433),
    [sym__external_open_parenthesis] = ACTIONS(5211),
    [sym__external_close_parenthesis] = ACTIONS(5433),
    [sym__external_open_brace] = ACTIONS(5433),
    [sym__external_close_brace] = ACTIONS(5433),
    [sym__external_open_bracket] = ACTIONS(5213),
    [sym__external_open_bracket2] = ACTIONS(5215),
  },
  [558] = {
    [sym_call_arguments] = STATE(2261),
    [sym_subset_arguments] = STATE(2260),
    [sym_subset2_arguments] = STATE(2259),
    [sym__open_parenthesis] = STATE(1380),
    [sym__open_bracket] = STATE(1379),
    [sym__open_bracket2] = STATE(1378),
    [ts_builtin_sym_end] = ACTIONS(5437),
    [sym_identifier] = ACTIONS(5439),
    [anon_sym_BSLASH] = ACTIONS(5437),
    [anon_sym_function] = ACTIONS(5439),
    [anon_sym_EQ] = ACTIONS(5171),
    [anon_sym_if] = ACTIONS(5439),
    [anon_sym_for] = ACTIONS(5439),
    [anon_sym_while] = ACTIONS(5439),
    [anon_sym_repeat] = ACTIONS(5439),
    [anon_sym_QMARK] = ACTIONS(5437),
    [anon_sym_TILDE] = ACTIONS(5173),
    [anon_sym_BANG] = ACTIONS(5439),
    [anon_sym_PLUS] = ACTIONS(5175),
    [anon_sym_DASH] = ACTIONS(5177),
    [anon_sym_LT_DASH] = ACTIONS(5179),
    [anon_sym_LT_LT_DASH] = ACTIONS(5179),
    [anon_sym_COLON_EQ] = ACTIONS(5179),
    [anon_sym_DASH_GT] = ACTIONS(5181),
    [anon_sym_DASH_GT_GT] = ACTIONS(5183),
    [anon_sym_PIPE] = ACTIONS(5185),
    [anon_sym_AMP] = ACTIONS(5187),
    [anon_sym_PIPE_PIPE] = ACTIONS(5189),
    [anon_sym_AMP_AMP] = ACTIONS(5191),
    [anon_sym_LT] = ACTIONS(5193),
    [anon_sym_LT_EQ] = ACTIONS(5195),
    [anon_sym_GT] = ACTIONS(5193),
    [anon_sym_GT_EQ] = ACTIONS(5195),
    [anon_sym_EQ_EQ] = ACTIONS(5195),
    [anon_sym_BANG_EQ] = ACTIONS(5195),
    [anon_sym_STAR] = ACTIONS(5197),
    [anon_sym_SLASH] = ACTIONS(5199),
    [anon_sym_STAR_STAR] = ACTIONS(5201),
    [anon_sym_CARET] = ACTIONS(5201),
    [aux_sym_binary_operator_token1] = ACTIONS(5203),
    [anon_sym_PIPE_GT] = ACTIONS(5203),
    [anon_sym_COLON] = ACTIONS(5205),
    [anon_sym_DOLLAR] = ACTIONS(5207),
    [anon_sym_AT] = ACTIONS(5207),
    [aux_sym__hex_literal_token1] = ACTIONS(5437),
    [sym__number_literal] = ACTIONS(5439),
    [anon_sym_SQUOTE] = ACTIONS(5437),
    [anon_sym_DQUOTE] = ACTIONS(5437),
    [sym_return] = ACTIONS(5439),
    [sym_next] = ACTIONS(5439),
    [sym_break] = ACTIONS(5439),
    [sym_true] = ACTIONS(5439),
    [sym_false] = ACTIONS(5439),
    [sym_null] = ACTIONS(5439),
    [sym_inf] = ACTIONS(5439),
    [sym_nan] = ACTIONS(5439),
    [anon_sym_NA] = ACTIONS(5439),
    [anon_sym_NA_integer_] = ACTIONS(5439),
    [anon_sym_NA_real_] = ACTIONS(5439),
    [anon_sym_NA_complex_] = ACTIONS(5439),
    [anon_sym_NA_character_] = ACTIONS(5439),
    [sym_dots] = ACTIONS(5439),
    [sym_dot_dot_i] = ACTIONS(5437),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5437),
    [sym__newline] = ACTIONS(5437),
    [sym__semicolon] = ACTIONS(5437),
    [sym__raw_string_literal] = ACTIONS(5437),
    [sym__external_else] = ACTIONS(5437),
    [sym__external_open_parenthesis] = ACTIONS(5211),
    [sym__external_close_parenthesis] = ACTIONS(5437),
    [sym__external_open_brace] = ACTIONS(5437),
    [sym__external_close_brace] = ACTIONS(5437),
    [sym__external_open_bracket] = ACTIONS(5213),
    [sym__external_open_bracket2] = ACTIONS(5215),
  },
  [559] = {
    [sym_call_arguments] = STATE(2261),
    [sym_subset_arguments] = STATE(2260),
    [sym_subset2_arguments] = STATE(2259),
    [sym__open_parenthesis] = STATE(1380),
    [sym__open_bracket] = STATE(1379),
    [sym__open_bracket2] = STATE(1378),
    [ts_builtin_sym_end] = ACTIONS(5441),
    [sym_identifier] = ACTIONS(5443),
    [anon_sym_BSLASH] = ACTIONS(5441),
    [anon_sym_function] = ACTIONS(5443),
    [anon_sym_EQ] = ACTIONS(5171),
    [anon_sym_if] = ACTIONS(5443),
    [anon_sym_for] = ACTIONS(5443),
    [anon_sym_while] = ACTIONS(5443),
    [anon_sym_repeat] = ACTIONS(5443),
    [anon_sym_QMARK] = ACTIONS(5441),
    [anon_sym_TILDE] = ACTIONS(5173),
    [anon_sym_BANG] = ACTIONS(5443),
    [anon_sym_PLUS] = ACTIONS(5175),
    [anon_sym_DASH] = ACTIONS(5177),
    [anon_sym_LT_DASH] = ACTIONS(5179),
    [anon_sym_LT_LT_DASH] = ACTIONS(5179),
    [anon_sym_COLON_EQ] = ACTIONS(5179),
    [anon_sym_DASH_GT] = ACTIONS(5181),
    [anon_sym_DASH_GT_GT] = ACTIONS(5183),
    [anon_sym_PIPE] = ACTIONS(5185),
    [anon_sym_AMP] = ACTIONS(5187),
    [anon_sym_PIPE_PIPE] = ACTIONS(5189),
    [anon_sym_AMP_AMP] = ACTIONS(5191),
    [anon_sym_LT] = ACTIONS(5193),
    [anon_sym_LT_EQ] = ACTIONS(5195),
    [anon_sym_GT] = ACTIONS(5193),
    [anon_sym_GT_EQ] = ACTIONS(5195),
    [anon_sym_EQ_EQ] = ACTIONS(5195),
    [anon_sym_BANG_EQ] = ACTIONS(5195),
    [anon_sym_STAR] = ACTIONS(5197),
    [anon_sym_SLASH] = ACTIONS(5199),
    [anon_sym_STAR_STAR] = ACTIONS(5201),
    [anon_sym_CARET] = ACTIONS(5201),
    [aux_sym_binary_operator_token1] = ACTIONS(5203),
    [anon_sym_PIPE_GT] = ACTIONS(5203),
    [anon_sym_COLON] = ACTIONS(5205),
    [anon_sym_DOLLAR] = ACTIONS(5207),
    [anon_sym_AT] = ACTIONS(5207),
    [aux_sym__hex_literal_token1] = ACTIONS(5441),
    [sym__number_literal] = ACTIONS(5443),
    [anon_sym_SQUOTE] = ACTIONS(5441),
    [anon_sym_DQUOTE] = ACTIONS(5441),
    [sym_return] = ACTIONS(5443),
    [sym_next] = ACTIONS(5443),
    [sym_break] = ACTIONS(5443),
    [sym_true] = ACTIONS(5443),
    [sym_false] = ACTIONS(5443),
    [sym_null] = ACTIONS(5443),
    [sym_inf] = ACTIONS(5443),
    [sym_nan] = ACTIONS(5443),
    [anon_sym_NA] = ACTIONS(5443),
    [anon_sym_NA_integer_] = ACTIONS(5443),
    [anon_sym_NA_real_] = ACTIONS(5443),
    [anon_sym_NA_complex_] = ACTIONS(5443),
    [anon_sym_NA_character_] = ACTIONS(5443),
    [sym_dots] = ACTIONS(5443),
    [sym_dot_dot_i] = ACTIONS(5441),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5441),
    [sym__newline] = ACTIONS(5441),
    [sym__semicolon] = ACTIONS(5441),
    [sym__raw_string_literal] = ACTIONS(5441),
    [sym__external_else] = ACTIONS(5441),
    [sym__external_open_parenthesis] = ACTIONS(5211),
    [sym__external_close_parenthesis] = ACTIONS(5441),
    [sym__external_open_brace] = ACTIONS(5441),
    [sym__external_close_brace] = ACTIONS(5441),
    [sym__external_open_bracket] = ACTIONS(5213),
    [sym__external_open_bracket2] = ACTIONS(5215),
  },
  [560] = {
    [sym_call_arguments] = STATE(2261),
    [sym_subset_arguments] = STATE(2260),
    [sym_subset2_arguments] = STATE(2259),
    [sym__open_parenthesis] = STATE(1380),
    [sym__open_bracket] = STATE(1379),
    [sym__open_bracket2] = STATE(1378),
    [ts_builtin_sym_end] = ACTIONS(5445),
    [sym_identifier] = ACTIONS(5447),
    [anon_sym_BSLASH] = ACTIONS(5445),
    [anon_sym_function] = ACTIONS(5447),
    [anon_sym_EQ] = ACTIONS(5171),
    [anon_sym_if] = ACTIONS(5447),
    [anon_sym_for] = ACTIONS(5447),
    [anon_sym_while] = ACTIONS(5447),
    [anon_sym_repeat] = ACTIONS(5447),
    [anon_sym_QMARK] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(5173),
    [anon_sym_BANG] = ACTIONS(5447),
    [anon_sym_PLUS] = ACTIONS(5175),
    [anon_sym_DASH] = ACTIONS(5177),
    [anon_sym_LT_DASH] = ACTIONS(5179),
    [anon_sym_LT_LT_DASH] = ACTIONS(5179),
    [anon_sym_COLON_EQ] = ACTIONS(5179),
    [anon_sym_DASH_GT] = ACTIONS(5181),
    [anon_sym_DASH_GT_GT] = ACTIONS(5183),
    [anon_sym_PIPE] = ACTIONS(5185),
    [anon_sym_AMP] = ACTIONS(5187),
    [anon_sym_PIPE_PIPE] = ACTIONS(5189),
    [anon_sym_AMP_AMP] = ACTIONS(5191),
    [anon_sym_LT] = ACTIONS(5193),
    [anon_sym_LT_EQ] = ACTIONS(5195),
    [anon_sym_GT] = ACTIONS(5193),
    [anon_sym_GT_EQ] = ACTIONS(5195),
    [anon_sym_EQ_EQ] = ACTIONS(5195),
    [anon_sym_BANG_EQ] = ACTIONS(5195),
    [anon_sym_STAR] = ACTIONS(5197),
    [anon_sym_SLASH] = ACTIONS(5199),
    [anon_sym_STAR_STAR] = ACTIONS(5201),
    [anon_sym_CARET] = ACTIONS(5201),
    [aux_sym_binary_operator_token1] = ACTIONS(5203),
    [anon_sym_PIPE_GT] = ACTIONS(5203),
    [anon_sym_COLON] = ACTIONS(5205),
    [anon_sym_DOLLAR] = ACTIONS(5207),
    [anon_sym_AT] = ACTIONS(5207),
    [aux_sym__hex_literal_token1] = ACTIONS(5445),
    [sym__number_literal] = ACTIONS(5447),
    [anon_sym_SQUOTE] = ACTIONS(5445),
    [anon_sym_DQUOTE] = ACTIONS(5445),
    [sym_return] = ACTIONS(5447),
    [sym_next] = ACTIONS(5447),
    [sym_break] = ACTIONS(5447),
    [sym_true] = ACTIONS(5447),
    [sym_false] = ACTIONS(5447),
    [sym_null] = ACTIONS(5447),
    [sym_inf] = ACTIONS(5447),
    [sym_nan] = ACTIONS(5447),
    [anon_sym_NA] = ACTIONS(5447),
    [anon_sym_NA_integer_] = ACTIONS(5447),
    [anon_sym_NA_real_] = ACTIONS(5447),
    [anon_sym_NA_complex_] = ACTIONS(5447),
    [anon_sym_NA_character_] = ACTIONS(5447),
    [sym_dots] = ACTIONS(5447),
    [sym_dot_dot_i] = ACTIONS(5445),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5445),
    [sym__newline] = ACTIONS(5445),
    [sym__semicolon] = ACTIONS(5445),
    [sym__raw_string_literal] = ACTIONS(5445),
    [sym__external_else] = ACTIONS(5445),
    [sym__external_open_parenthesis] = ACTIONS(5211),
    [sym__external_close_parenthesis] = ACTIONS(5445),
    [sym__external_open_brace] = ACTIONS(5445),
    [sym__external_close_brace] = ACTIONS(5445),
    [sym__external_open_bracket] = ACTIONS(5213),
    [sym__external_open_bracket2] = ACTIONS(5215),
  },
  [561] = {
    [sym_call_arguments] = STATE(2261),
    [sym_subset_arguments] = STATE(2260),
    [sym_subset2_arguments] = STATE(2259),
    [sym__open_parenthesis] = STATE(1380),
    [sym__open_bracket] = STATE(1379),
    [sym__open_bracket2] = STATE(1378),
    [ts_builtin_sym_end] = ACTIONS(5449),
    [sym_identifier] = ACTIONS(5451),
    [anon_sym_BSLASH] = ACTIONS(5449),
    [anon_sym_function] = ACTIONS(5451),
    [anon_sym_EQ] = ACTIONS(5171),
    [anon_sym_if] = ACTIONS(5451),
    [anon_sym_for] = ACTIONS(5451),
    [anon_sym_while] = ACTIONS(5451),
    [anon_sym_repeat] = ACTIONS(5451),
    [anon_sym_QMARK] = ACTIONS(5449),
    [anon_sym_TILDE] = ACTIONS(5173),
    [anon_sym_BANG] = ACTIONS(5451),
    [anon_sym_PLUS] = ACTIONS(5175),
    [anon_sym_DASH] = ACTIONS(5177),
    [anon_sym_LT_DASH] = ACTIONS(5179),
    [anon_sym_LT_LT_DASH] = ACTIONS(5179),
    [anon_sym_COLON_EQ] = ACTIONS(5179),
    [anon_sym_DASH_GT] = ACTIONS(5181),
    [anon_sym_DASH_GT_GT] = ACTIONS(5183),
    [anon_sym_PIPE] = ACTIONS(5185),
    [anon_sym_AMP] = ACTIONS(5187),
    [anon_sym_PIPE_PIPE] = ACTIONS(5189),
    [anon_sym_AMP_AMP] = ACTIONS(5191),
    [anon_sym_LT] = ACTIONS(5193),
    [anon_sym_LT_EQ] = ACTIONS(5195),
    [anon_sym_GT] = ACTIONS(5193),
    [anon_sym_GT_EQ] = ACTIONS(5195),
    [anon_sym_EQ_EQ] = ACTIONS(5195),
    [anon_sym_BANG_EQ] = ACTIONS(5195),
    [anon_sym_STAR] = ACTIONS(5197),
    [anon_sym_SLASH] = ACTIONS(5199),
    [anon_sym_STAR_STAR] = ACTIONS(5201),
    [anon_sym_CARET] = ACTIONS(5201),
    [aux_sym_binary_operator_token1] = ACTIONS(5203),
    [anon_sym_PIPE_GT] = ACTIONS(5203),
    [anon_sym_COLON] = ACTIONS(5205),
    [anon_sym_DOLLAR] = ACTIONS(5207),
    [anon_sym_AT] = ACTIONS(5207),
    [aux_sym__hex_literal_token1] = ACTIONS(5449),
    [sym__number_literal] = ACTIONS(5451),
    [anon_sym_SQUOTE] = ACTIONS(5449),
    [anon_sym_DQUOTE] = ACTIONS(5449),
    [sym_return] = ACTIONS(5451),
    [sym_next] = ACTIONS(5451),
    [sym_break] = ACTIONS(5451),
    [sym_true] = ACTIONS(5451),
    [sym_false] = ACTIONS(5451),
    [sym_null] = ACTIONS(5451),
    [sym_inf] = ACTIONS(5451),
    [sym_nan] = ACTIONS(5451),
    [anon_sym_NA] = ACTIONS(5451),
    [anon_sym_NA_integer_] = ACTIONS(5451),
    [anon_sym_NA_real_] = ACTIONS(5451),
    [anon_sym_NA_complex_] = ACTIONS(5451),
    [anon_sym_NA_character_] = ACTIONS(5451),
    [sym_dots] = ACTIONS(5451),
    [sym_dot_dot_i] = ACTIONS(5449),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5449),
    [sym__newline] = ACTIONS(5449),
    [sym__semicolon] = ACTIONS(5449),
    [sym__raw_string_literal] = ACTIONS(5449),
    [sym__external_else] = ACTIONS(5449),
    [sym__external_open_parenthesis] = ACTIONS(5211),
    [sym__external_close_parenthesis] = ACTIONS(5449),
    [sym__external_open_brace] = ACTIONS(5449),
    [sym__external_close_brace] = ACTIONS(5449),
    [sym__external_open_bracket] = ACTIONS(5213),
    [sym__external_open_bracket2] = ACTIONS(5215),
  },
  [562] = {
    [sym_call_arguments] = STATE(2261),
    [sym_subset_arguments] = STATE(2260),
    [sym_subset2_arguments] = STATE(2259),
    [sym__open_parenthesis] = STATE(1380),
    [sym__open_bracket] = STATE(1379),
    [sym__open_bracket2] = STATE(1378),
    [ts_builtin_sym_end] = ACTIONS(5453),
    [sym_identifier] = ACTIONS(5455),
    [anon_sym_BSLASH] = ACTIONS(5453),
    [anon_sym_function] = ACTIONS(5455),
    [anon_sym_EQ] = ACTIONS(5171),
    [anon_sym_if] = ACTIONS(5455),
    [anon_sym_for] = ACTIONS(5455),
    [anon_sym_while] = ACTIONS(5455),
    [anon_sym_repeat] = ACTIONS(5455),
    [anon_sym_QMARK] = ACTIONS(5453),
    [anon_sym_TILDE] = ACTIONS(5173),
    [anon_sym_BANG] = ACTIONS(5455),
    [anon_sym_PLUS] = ACTIONS(5175),
    [anon_sym_DASH] = ACTIONS(5177),
    [anon_sym_LT_DASH] = ACTIONS(5179),
    [anon_sym_LT_LT_DASH] = ACTIONS(5179),
    [anon_sym_COLON_EQ] = ACTIONS(5179),
    [anon_sym_DASH_GT] = ACTIONS(5181),
    [anon_sym_DASH_GT_GT] = ACTIONS(5183),
    [anon_sym_PIPE] = ACTIONS(5185),
    [anon_sym_AMP] = ACTIONS(5187),
    [anon_sym_PIPE_PIPE] = ACTIONS(5189),
    [anon_sym_AMP_AMP] = ACTIONS(5191),
    [anon_sym_LT] = ACTIONS(5193),
    [anon_sym_LT_EQ] = ACTIONS(5195),
    [anon_sym_GT] = ACTIONS(5193),
    [anon_sym_GT_EQ] = ACTIONS(5195),
    [anon_sym_EQ_EQ] = ACTIONS(5195),
    [anon_sym_BANG_EQ] = ACTIONS(5195),
    [anon_sym_STAR] = ACTIONS(5197),
    [anon_sym_SLASH] = ACTIONS(5199),
    [anon_sym_STAR_STAR] = ACTIONS(5201),
    [anon_sym_CARET] = ACTIONS(5201),
    [aux_sym_binary_operator_token1] = ACTIONS(5203),
    [anon_sym_PIPE_GT] = ACTIONS(5203),
    [anon_sym_COLON] = ACTIONS(5205),
    [anon_sym_DOLLAR] = ACTIONS(5207),
    [anon_sym_AT] = ACTIONS(5207),
    [aux_sym__hex_literal_token1] = ACTIONS(5453),
    [sym__number_literal] = ACTIONS(5455),
    [anon_sym_SQUOTE] = ACTIONS(5453),
    [anon_sym_DQUOTE] = ACTIONS(5453),
    [sym_return] = ACTIONS(5455),
    [sym_next] = ACTIONS(5455),
    [sym_break] = ACTIONS(5455),
    [sym_true] = ACTIONS(5455),
    [sym_false] = ACTIONS(5455),
    [sym_null] = ACTIONS(5455),
    [sym_inf] = ACTIONS(5455),
    [sym_nan] = ACTIONS(5455),
    [anon_sym_NA] = ACTIONS(5455),
    [anon_sym_NA_integer_] = ACTIONS(5455),
    [anon_sym_NA_real_] = ACTIONS(5455),
    [anon_sym_NA_complex_] = ACTIONS(5455),
    [anon_sym_NA_character_] = ACTIONS(5455),
    [sym_dots] = ACTIONS(5455),
    [sym_dot_dot_i] = ACTIONS(5453),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5453),
    [sym__newline] = ACTIONS(5453),
    [sym__semicolon] = ACTIONS(5453),
    [sym__raw_string_literal] = ACTIONS(5453),
    [sym__external_else] = ACTIONS(5453),
    [sym__external_open_parenthesis] = ACTIONS(5211),
    [sym__external_close_parenthesis] = ACTIONS(5453),
    [sym__external_open_brace] = ACTIONS(5453),
    [sym__external_close_brace] = ACTIONS(5453),
    [sym__external_open_bracket] = ACTIONS(5213),
    [sym__external_open_bracket2] = ACTIONS(5215),
  },
  [563] = {
    [sym_call_arguments] = STATE(2318),
    [sym_subset_arguments] = STATE(2319),
    [sym_subset2_arguments] = STATE(2320),
    [sym__open_parenthesis] = STATE(1329),
    [sym__open_bracket] = STATE(1328),
    [sym__open_bracket2] = STATE(1327),
    [sym_identifier] = ACTIONS(5419),
    [anon_sym_BSLASH] = ACTIONS(5417),
    [anon_sym_function] = ACTIONS(5419),
    [anon_sym_EQ] = ACTIONS(5119),
    [anon_sym_if] = ACTIONS(5419),
    [anon_sym_for] = ACTIONS(5419),
    [anon_sym_while] = ACTIONS(5419),
    [anon_sym_repeat] = ACTIONS(5419),
    [anon_sym_QMARK] = ACTIONS(5417),
    [anon_sym_TILDE] = ACTIONS(5121),
    [anon_sym_BANG] = ACTIONS(5419),
    [anon_sym_PLUS] = ACTIONS(5123),
    [anon_sym_DASH] = ACTIONS(5125),
    [anon_sym_LT_DASH] = ACTIONS(5127),
    [anon_sym_LT_LT_DASH] = ACTIONS(5127),
    [anon_sym_COLON_EQ] = ACTIONS(5127),
    [anon_sym_DASH_GT] = ACTIONS(5129),
    [anon_sym_DASH_GT_GT] = ACTIONS(5131),
    [anon_sym_PIPE] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5135),
    [anon_sym_PIPE_PIPE] = ACTIONS(5137),
    [anon_sym_AMP_AMP] = ACTIONS(5139),
    [anon_sym_LT] = ACTIONS(5141),
    [anon_sym_LT_EQ] = ACTIONS(5143),
    [anon_sym_GT] = ACTIONS(5141),
    [anon_sym_GT_EQ] = ACTIONS(5143),
    [anon_sym_EQ_EQ] = ACTIONS(5143),
    [anon_sym_BANG_EQ] = ACTIONS(5143),
    [anon_sym_STAR] = ACTIONS(5145),
    [anon_sym_SLASH] = ACTIONS(5147),
    [anon_sym_STAR_STAR] = ACTIONS(5149),
    [anon_sym_CARET] = ACTIONS(5149),
    [aux_sym_binary_operator_token1] = ACTIONS(5151),
    [anon_sym_PIPE_GT] = ACTIONS(5151),
    [anon_sym_COLON] = ACTIONS(5153),
    [anon_sym_DOLLAR] = ACTIONS(5155),
    [anon_sym_AT] = ACTIONS(5155),
    [aux_sym__hex_literal_token1] = ACTIONS(5417),
    [sym__number_literal] = ACTIONS(5419),
    [anon_sym_SQUOTE] = ACTIONS(5417),
    [anon_sym_DQUOTE] = ACTIONS(5417),
    [sym_return] = ACTIONS(5419),
    [sym_next] = ACTIONS(5419),
    [sym_break] = ACTIONS(5419),
    [sym_true] = ACTIONS(5419),
    [sym_false] = ACTIONS(5419),
    [sym_null] = ACTIONS(5419),
    [sym_inf] = ACTIONS(5419),
    [sym_nan] = ACTIONS(5419),
    [anon_sym_NA] = ACTIONS(5419),
    [anon_sym_NA_integer_] = ACTIONS(5419),
    [anon_sym_NA_real_] = ACTIONS(5419),
    [anon_sym_NA_complex_] = ACTIONS(5419),
    [anon_sym_NA_character_] = ACTIONS(5419),
    [sym_dots] = ACTIONS(5419),
    [sym_dot_dot_i] = ACTIONS(5417),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5417),
    [sym__newline] = ACTIONS(5417),
    [sym__semicolon] = ACTIONS(5417),
    [sym__raw_string_literal] = ACTIONS(5417),
    [sym__external_else] = ACTIONS(5417),
    [sym__external_open_parenthesis] = ACTIONS(5159),
    [sym__external_close_parenthesis] = ACTIONS(5417),
    [sym__external_open_brace] = ACTIONS(5417),
    [sym__external_close_brace] = ACTIONS(5417),
    [sym__external_open_bracket] = ACTIONS(5161),
    [sym__external_close_bracket] = ACTIONS(5417),
    [sym__external_open_bracket2] = ACTIONS(5163),
  },
  [564] = {
    [sym_call_arguments] = STATE(2318),
    [sym_subset_arguments] = STATE(2319),
    [sym_subset2_arguments] = STATE(2320),
    [sym__open_parenthesis] = STATE(1329),
    [sym__open_bracket] = STATE(1328),
    [sym__open_bracket2] = STATE(1327),
    [sym_identifier] = ACTIONS(5331),
    [anon_sym_BSLASH] = ACTIONS(5329),
    [anon_sym_function] = ACTIONS(5331),
    [anon_sym_EQ] = ACTIONS(5119),
    [anon_sym_if] = ACTIONS(5331),
    [anon_sym_for] = ACTIONS(5331),
    [anon_sym_while] = ACTIONS(5331),
    [anon_sym_repeat] = ACTIONS(5331),
    [anon_sym_QMARK] = ACTIONS(5329),
    [anon_sym_TILDE] = ACTIONS(5121),
    [anon_sym_BANG] = ACTIONS(5331),
    [anon_sym_PLUS] = ACTIONS(5123),
    [anon_sym_DASH] = ACTIONS(5125),
    [anon_sym_LT_DASH] = ACTIONS(5127),
    [anon_sym_LT_LT_DASH] = ACTIONS(5127),
    [anon_sym_COLON_EQ] = ACTIONS(5127),
    [anon_sym_DASH_GT] = ACTIONS(5129),
    [anon_sym_DASH_GT_GT] = ACTIONS(5131),
    [anon_sym_PIPE] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5135),
    [anon_sym_PIPE_PIPE] = ACTIONS(5137),
    [anon_sym_AMP_AMP] = ACTIONS(5139),
    [anon_sym_LT] = ACTIONS(5141),
    [anon_sym_LT_EQ] = ACTIONS(5143),
    [anon_sym_GT] = ACTIONS(5141),
    [anon_sym_GT_EQ] = ACTIONS(5143),
    [anon_sym_EQ_EQ] = ACTIONS(5143),
    [anon_sym_BANG_EQ] = ACTIONS(5143),
    [anon_sym_STAR] = ACTIONS(5145),
    [anon_sym_SLASH] = ACTIONS(5147),
    [anon_sym_STAR_STAR] = ACTIONS(5149),
    [anon_sym_CARET] = ACTIONS(5149),
    [aux_sym_binary_operator_token1] = ACTIONS(5151),
    [anon_sym_PIPE_GT] = ACTIONS(5151),
    [anon_sym_COLON] = ACTIONS(5153),
    [anon_sym_DOLLAR] = ACTIONS(5155),
    [anon_sym_AT] = ACTIONS(5155),
    [aux_sym__hex_literal_token1] = ACTIONS(5329),
    [sym__number_literal] = ACTIONS(5331),
    [anon_sym_SQUOTE] = ACTIONS(5329),
    [anon_sym_DQUOTE] = ACTIONS(5329),
    [sym_return] = ACTIONS(5331),
    [sym_next] = ACTIONS(5331),
    [sym_break] = ACTIONS(5331),
    [sym_true] = ACTIONS(5331),
    [sym_false] = ACTIONS(5331),
    [sym_null] = ACTIONS(5331),
    [sym_inf] = ACTIONS(5331),
    [sym_nan] = ACTIONS(5331),
    [anon_sym_NA] = ACTIONS(5331),
    [anon_sym_NA_integer_] = ACTIONS(5331),
    [anon_sym_NA_real_] = ACTIONS(5331),
    [anon_sym_NA_complex_] = ACTIONS(5331),
    [anon_sym_NA_character_] = ACTIONS(5331),
    [sym_dots] = ACTIONS(5331),
    [sym_dot_dot_i] = ACTIONS(5329),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5329),
    [sym__newline] = ACTIONS(5329),
    [sym__semicolon] = ACTIONS(5329),
    [sym__raw_string_literal] = ACTIONS(5329),
    [sym__external_else] = ACTIONS(5329),
    [sym__external_open_parenthesis] = ACTIONS(5159),
    [sym__external_close_parenthesis] = ACTIONS(5329),
    [sym__external_open_brace] = ACTIONS(5329),
    [sym__external_close_brace] = ACTIONS(5329),
    [sym__external_open_bracket] = ACTIONS(5161),
    [sym__external_close_bracket] = ACTIONS(5329),
    [sym__external_open_bracket2] = ACTIONS(5163),
  },
  [565] = {
    [sym_call_arguments] = STATE(2318),
    [sym_subset_arguments] = STATE(2319),
    [sym_subset2_arguments] = STATE(2320),
    [sym__open_parenthesis] = STATE(1329),
    [sym__open_bracket] = STATE(1328),
    [sym__open_bracket2] = STATE(1327),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5119),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5121),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(5123),
    [anon_sym_DASH] = ACTIONS(5125),
    [anon_sym_LT_DASH] = ACTIONS(5127),
    [anon_sym_LT_LT_DASH] = ACTIONS(5127),
    [anon_sym_COLON_EQ] = ACTIONS(5127),
    [anon_sym_DASH_GT] = ACTIONS(5129),
    [anon_sym_DASH_GT_GT] = ACTIONS(5131),
    [anon_sym_PIPE] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5135),
    [anon_sym_PIPE_PIPE] = ACTIONS(5137),
    [anon_sym_AMP_AMP] = ACTIONS(5139),
    [anon_sym_LT] = ACTIONS(5141),
    [anon_sym_LT_EQ] = ACTIONS(5143),
    [anon_sym_GT] = ACTIONS(5141),
    [anon_sym_GT_EQ] = ACTIONS(5143),
    [anon_sym_EQ_EQ] = ACTIONS(5143),
    [anon_sym_BANG_EQ] = ACTIONS(5143),
    [anon_sym_STAR] = ACTIONS(5145),
    [anon_sym_SLASH] = ACTIONS(5147),
    [anon_sym_STAR_STAR] = ACTIONS(5149),
    [anon_sym_CARET] = ACTIONS(5149),
    [aux_sym_binary_operator_token1] = ACTIONS(5151),
    [anon_sym_PIPE_GT] = ACTIONS(5151),
    [anon_sym_COLON] = ACTIONS(5153),
    [anon_sym_DOLLAR] = ACTIONS(5155),
    [anon_sym_AT] = ACTIONS(5155),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__semicolon] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_else] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(5159),
    [sym__external_close_parenthesis] = ACTIONS(5333),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_close_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(5161),
    [sym__external_close_bracket] = ACTIONS(5333),
    [sym__external_open_bracket2] = ACTIONS(5163),
  },
  [566] = {
    [sym_call_arguments] = STATE(2318),
    [sym_subset_arguments] = STATE(2319),
    [sym_subset2_arguments] = STATE(2320),
    [sym__open_parenthesis] = STATE(1329),
    [sym__open_bracket] = STATE(1328),
    [sym__open_bracket2] = STATE(1327),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(5123),
    [anon_sym_DASH] = ACTIONS(5125),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5135),
    [anon_sym_PIPE_PIPE] = ACTIONS(5137),
    [anon_sym_AMP_AMP] = ACTIONS(5139),
    [anon_sym_LT] = ACTIONS(5141),
    [anon_sym_LT_EQ] = ACTIONS(5143),
    [anon_sym_GT] = ACTIONS(5141),
    [anon_sym_GT_EQ] = ACTIONS(5143),
    [anon_sym_EQ_EQ] = ACTIONS(5143),
    [anon_sym_BANG_EQ] = ACTIONS(5143),
    [anon_sym_STAR] = ACTIONS(5145),
    [anon_sym_SLASH] = ACTIONS(5147),
    [anon_sym_STAR_STAR] = ACTIONS(5149),
    [anon_sym_CARET] = ACTIONS(5149),
    [aux_sym_binary_operator_token1] = ACTIONS(5151),
    [anon_sym_PIPE_GT] = ACTIONS(5151),
    [anon_sym_COLON] = ACTIONS(5153),
    [anon_sym_DOLLAR] = ACTIONS(5155),
    [anon_sym_AT] = ACTIONS(5155),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__semicolon] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_else] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(5159),
    [sym__external_close_parenthesis] = ACTIONS(5333),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_close_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(5161),
    [sym__external_close_bracket] = ACTIONS(5333),
    [sym__external_open_bracket2] = ACTIONS(5163),
  },
  [567] = {
    [sym_call_arguments] = STATE(2318),
    [sym_subset_arguments] = STATE(2319),
    [sym_subset2_arguments] = STATE(2320),
    [sym__open_parenthesis] = STATE(1329),
    [sym__open_bracket] = STATE(1328),
    [sym__open_bracket2] = STATE(1327),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(5123),
    [anon_sym_DASH] = ACTIONS(5125),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5335),
    [anon_sym_AMP] = ACTIONS(5335),
    [anon_sym_PIPE_PIPE] = ACTIONS(5333),
    [anon_sym_AMP_AMP] = ACTIONS(5333),
    [anon_sym_LT] = ACTIONS(5141),
    [anon_sym_LT_EQ] = ACTIONS(5143),
    [anon_sym_GT] = ACTIONS(5141),
    [anon_sym_GT_EQ] = ACTIONS(5143),
    [anon_sym_EQ_EQ] = ACTIONS(5143),
    [anon_sym_BANG_EQ] = ACTIONS(5143),
    [anon_sym_STAR] = ACTIONS(5145),
    [anon_sym_SLASH] = ACTIONS(5147),
    [anon_sym_STAR_STAR] = ACTIONS(5149),
    [anon_sym_CARET] = ACTIONS(5149),
    [aux_sym_binary_operator_token1] = ACTIONS(5151),
    [anon_sym_PIPE_GT] = ACTIONS(5151),
    [anon_sym_COLON] = ACTIONS(5153),
    [anon_sym_DOLLAR] = ACTIONS(5155),
    [anon_sym_AT] = ACTIONS(5155),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__semicolon] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_else] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(5159),
    [sym__external_close_parenthesis] = ACTIONS(5333),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_close_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(5161),
    [sym__external_close_bracket] = ACTIONS(5333),
    [sym__external_open_bracket2] = ACTIONS(5163),
  },
  [568] = {
    [sym_call_arguments] = STATE(2318),
    [sym_subset_arguments] = STATE(2319),
    [sym_subset2_arguments] = STATE(2320),
    [sym__open_parenthesis] = STATE(1329),
    [sym__open_bracket] = STATE(1328),
    [sym__open_bracket2] = STATE(1327),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(5333),
    [anon_sym_DASH] = ACTIONS(5335),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5335),
    [anon_sym_AMP] = ACTIONS(5335),
    [anon_sym_PIPE_PIPE] = ACTIONS(5333),
    [anon_sym_AMP_AMP] = ACTIONS(5333),
    [anon_sym_LT] = ACTIONS(5335),
    [anon_sym_LT_EQ] = ACTIONS(5333),
    [anon_sym_GT] = ACTIONS(5335),
    [anon_sym_GT_EQ] = ACTIONS(5333),
    [anon_sym_EQ_EQ] = ACTIONS(5333),
    [anon_sym_BANG_EQ] = ACTIONS(5333),
    [anon_sym_STAR] = ACTIONS(5335),
    [anon_sym_SLASH] = ACTIONS(5333),
    [anon_sym_STAR_STAR] = ACTIONS(5149),
    [anon_sym_CARET] = ACTIONS(5149),
    [aux_sym_binary_operator_token1] = ACTIONS(5333),
    [anon_sym_PIPE_GT] = ACTIONS(5333),
    [anon_sym_COLON] = ACTIONS(5335),
    [anon_sym_DOLLAR] = ACTIONS(5155),
    [anon_sym_AT] = ACTIONS(5155),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__semicolon] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_else] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(5159),
    [sym__external_close_parenthesis] = ACTIONS(5333),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_close_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(5161),
    [sym__external_close_bracket] = ACTIONS(5333),
    [sym__external_open_bracket2] = ACTIONS(5163),
  },
  [569] = {
    [sym_call_arguments] = STATE(2318),
    [sym_subset_arguments] = STATE(2319),
    [sym_subset2_arguments] = STATE(2320),
    [sym__open_parenthesis] = STATE(1329),
    [sym__open_bracket] = STATE(1328),
    [sym__open_bracket2] = STATE(1327),
    [sym_identifier] = ACTIONS(5339),
    [anon_sym_BSLASH] = ACTIONS(5337),
    [anon_sym_function] = ACTIONS(5339),
    [anon_sym_EQ] = ACTIONS(5119),
    [anon_sym_if] = ACTIONS(5339),
    [anon_sym_for] = ACTIONS(5339),
    [anon_sym_while] = ACTIONS(5339),
    [anon_sym_repeat] = ACTIONS(5339),
    [anon_sym_QMARK] = ACTIONS(5337),
    [anon_sym_TILDE] = ACTIONS(5121),
    [anon_sym_BANG] = ACTIONS(5339),
    [anon_sym_PLUS] = ACTIONS(5123),
    [anon_sym_DASH] = ACTIONS(5125),
    [anon_sym_LT_DASH] = ACTIONS(5127),
    [anon_sym_LT_LT_DASH] = ACTIONS(5127),
    [anon_sym_COLON_EQ] = ACTIONS(5127),
    [anon_sym_DASH_GT] = ACTIONS(5129),
    [anon_sym_DASH_GT_GT] = ACTIONS(5131),
    [anon_sym_PIPE] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5135),
    [anon_sym_PIPE_PIPE] = ACTIONS(5137),
    [anon_sym_AMP_AMP] = ACTIONS(5139),
    [anon_sym_LT] = ACTIONS(5141),
    [anon_sym_LT_EQ] = ACTIONS(5143),
    [anon_sym_GT] = ACTIONS(5141),
    [anon_sym_GT_EQ] = ACTIONS(5143),
    [anon_sym_EQ_EQ] = ACTIONS(5143),
    [anon_sym_BANG_EQ] = ACTIONS(5143),
    [anon_sym_STAR] = ACTIONS(5145),
    [anon_sym_SLASH] = ACTIONS(5147),
    [anon_sym_STAR_STAR] = ACTIONS(5149),
    [anon_sym_CARET] = ACTIONS(5149),
    [aux_sym_binary_operator_token1] = ACTIONS(5151),
    [anon_sym_PIPE_GT] = ACTIONS(5151),
    [anon_sym_COLON] = ACTIONS(5153),
    [anon_sym_DOLLAR] = ACTIONS(5155),
    [anon_sym_AT] = ACTIONS(5155),
    [aux_sym__hex_literal_token1] = ACTIONS(5337),
    [sym__number_literal] = ACTIONS(5339),
    [anon_sym_SQUOTE] = ACTIONS(5337),
    [anon_sym_DQUOTE] = ACTIONS(5337),
    [sym_return] = ACTIONS(5339),
    [sym_next] = ACTIONS(5339),
    [sym_break] = ACTIONS(5339),
    [sym_true] = ACTIONS(5339),
    [sym_false] = ACTIONS(5339),
    [sym_null] = ACTIONS(5339),
    [sym_inf] = ACTIONS(5339),
    [sym_nan] = ACTIONS(5339),
    [anon_sym_NA] = ACTIONS(5339),
    [anon_sym_NA_integer_] = ACTIONS(5339),
    [anon_sym_NA_real_] = ACTIONS(5339),
    [anon_sym_NA_complex_] = ACTIONS(5339),
    [anon_sym_NA_character_] = ACTIONS(5339),
    [sym_dots] = ACTIONS(5339),
    [sym_dot_dot_i] = ACTIONS(5337),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5337),
    [sym__newline] = ACTIONS(5337),
    [sym__semicolon] = ACTIONS(5337),
    [sym__raw_string_literal] = ACTIONS(5337),
    [sym__external_else] = ACTIONS(5337),
    [sym__external_open_parenthesis] = ACTIONS(5159),
    [sym__external_close_parenthesis] = ACTIONS(5337),
    [sym__external_open_brace] = ACTIONS(5337),
    [sym__external_close_brace] = ACTIONS(5337),
    [sym__external_open_bracket] = ACTIONS(5161),
    [sym__external_close_bracket] = ACTIONS(5337),
    [sym__external_open_bracket2] = ACTIONS(5163),
  },
  [570] = {
    [sym_call_arguments] = STATE(2318),
    [sym_subset_arguments] = STATE(2319),
    [sym_subset2_arguments] = STATE(2320),
    [sym__open_parenthesis] = STATE(1329),
    [sym__open_bracket] = STATE(1328),
    [sym__open_bracket2] = STATE(1327),
    [sym_identifier] = ACTIONS(5343),
    [anon_sym_BSLASH] = ACTIONS(5341),
    [anon_sym_function] = ACTIONS(5343),
    [anon_sym_EQ] = ACTIONS(5119),
    [anon_sym_if] = ACTIONS(5343),
    [anon_sym_for] = ACTIONS(5343),
    [anon_sym_while] = ACTIONS(5343),
    [anon_sym_repeat] = ACTIONS(5343),
    [anon_sym_QMARK] = ACTIONS(5341),
    [anon_sym_TILDE] = ACTIONS(5121),
    [anon_sym_BANG] = ACTIONS(5343),
    [anon_sym_PLUS] = ACTIONS(5123),
    [anon_sym_DASH] = ACTIONS(5125),
    [anon_sym_LT_DASH] = ACTIONS(5127),
    [anon_sym_LT_LT_DASH] = ACTIONS(5127),
    [anon_sym_COLON_EQ] = ACTIONS(5127),
    [anon_sym_DASH_GT] = ACTIONS(5129),
    [anon_sym_DASH_GT_GT] = ACTIONS(5131),
    [anon_sym_PIPE] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5135),
    [anon_sym_PIPE_PIPE] = ACTIONS(5137),
    [anon_sym_AMP_AMP] = ACTIONS(5139),
    [anon_sym_LT] = ACTIONS(5141),
    [anon_sym_LT_EQ] = ACTIONS(5143),
    [anon_sym_GT] = ACTIONS(5141),
    [anon_sym_GT_EQ] = ACTIONS(5143),
    [anon_sym_EQ_EQ] = ACTIONS(5143),
    [anon_sym_BANG_EQ] = ACTIONS(5143),
    [anon_sym_STAR] = ACTIONS(5145),
    [anon_sym_SLASH] = ACTIONS(5147),
    [anon_sym_STAR_STAR] = ACTIONS(5149),
    [anon_sym_CARET] = ACTIONS(5149),
    [aux_sym_binary_operator_token1] = ACTIONS(5151),
    [anon_sym_PIPE_GT] = ACTIONS(5151),
    [anon_sym_COLON] = ACTIONS(5153),
    [anon_sym_DOLLAR] = ACTIONS(5155),
    [anon_sym_AT] = ACTIONS(5155),
    [aux_sym__hex_literal_token1] = ACTIONS(5341),
    [sym__number_literal] = ACTIONS(5343),
    [anon_sym_SQUOTE] = ACTIONS(5341),
    [anon_sym_DQUOTE] = ACTIONS(5341),
    [sym_return] = ACTIONS(5343),
    [sym_next] = ACTIONS(5343),
    [sym_break] = ACTIONS(5343),
    [sym_true] = ACTIONS(5343),
    [sym_false] = ACTIONS(5343),
    [sym_null] = ACTIONS(5343),
    [sym_inf] = ACTIONS(5343),
    [sym_nan] = ACTIONS(5343),
    [anon_sym_NA] = ACTIONS(5343),
    [anon_sym_NA_integer_] = ACTIONS(5343),
    [anon_sym_NA_real_] = ACTIONS(5343),
    [anon_sym_NA_complex_] = ACTIONS(5343),
    [anon_sym_NA_character_] = ACTIONS(5343),
    [sym_dots] = ACTIONS(5343),
    [sym_dot_dot_i] = ACTIONS(5341),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5341),
    [sym__newline] = ACTIONS(5341),
    [sym__semicolon] = ACTIONS(5341),
    [sym__raw_string_literal] = ACTIONS(5341),
    [sym__external_else] = ACTIONS(5341),
    [sym__external_open_parenthesis] = ACTIONS(5159),
    [sym__external_close_parenthesis] = ACTIONS(5341),
    [sym__external_open_brace] = ACTIONS(5341),
    [sym__external_close_brace] = ACTIONS(5341),
    [sym__external_open_bracket] = ACTIONS(5161),
    [sym__external_close_bracket] = ACTIONS(5341),
    [sym__external_open_bracket2] = ACTIONS(5163),
  },
  [571] = {
    [sym_call_arguments] = STATE(2318),
    [sym_subset_arguments] = STATE(2319),
    [sym_subset2_arguments] = STATE(2320),
    [sym__open_parenthesis] = STATE(1329),
    [sym__open_bracket] = STATE(1328),
    [sym__open_bracket2] = STATE(1327),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5119),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5121),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5123),
    [anon_sym_DASH] = ACTIONS(5125),
    [anon_sym_LT_DASH] = ACTIONS(5127),
    [anon_sym_LT_LT_DASH] = ACTIONS(5127),
    [anon_sym_COLON_EQ] = ACTIONS(5127),
    [anon_sym_DASH_GT] = ACTIONS(5129),
    [anon_sym_DASH_GT_GT] = ACTIONS(5131),
    [anon_sym_PIPE] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5135),
    [anon_sym_PIPE_PIPE] = ACTIONS(5137),
    [anon_sym_AMP_AMP] = ACTIONS(5139),
    [anon_sym_LT] = ACTIONS(5141),
    [anon_sym_LT_EQ] = ACTIONS(5143),
    [anon_sym_GT] = ACTIONS(5141),
    [anon_sym_GT_EQ] = ACTIONS(5143),
    [anon_sym_EQ_EQ] = ACTIONS(5143),
    [anon_sym_BANG_EQ] = ACTIONS(5143),
    [anon_sym_STAR] = ACTIONS(5145),
    [anon_sym_SLASH] = ACTIONS(5147),
    [anon_sym_STAR_STAR] = ACTIONS(5149),
    [anon_sym_CARET] = ACTIONS(5149),
    [aux_sym_binary_operator_token1] = ACTIONS(5151),
    [anon_sym_PIPE_GT] = ACTIONS(5151),
    [anon_sym_COLON] = ACTIONS(5153),
    [anon_sym_DOLLAR] = ACTIONS(5155),
    [anon_sym_AT] = ACTIONS(5155),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__semicolon] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_else] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(5159),
    [sym__external_close_parenthesis] = ACTIONS(5345),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_close_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(5161),
    [sym__external_close_bracket] = ACTIONS(5345),
    [sym__external_open_bracket2] = ACTIONS(5163),
  },
  [572] = {
    [sym_call_arguments] = STATE(2318),
    [sym_subset_arguments] = STATE(2319),
    [sym_subset2_arguments] = STATE(2320),
    [sym__open_parenthesis] = STATE(1329),
    [sym__open_bracket] = STATE(1328),
    [sym__open_bracket2] = STATE(1327),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5123),
    [anon_sym_DASH] = ACTIONS(5125),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5135),
    [anon_sym_PIPE_PIPE] = ACTIONS(5137),
    [anon_sym_AMP_AMP] = ACTIONS(5139),
    [anon_sym_LT] = ACTIONS(5141),
    [anon_sym_LT_EQ] = ACTIONS(5143),
    [anon_sym_GT] = ACTIONS(5141),
    [anon_sym_GT_EQ] = ACTIONS(5143),
    [anon_sym_EQ_EQ] = ACTIONS(5143),
    [anon_sym_BANG_EQ] = ACTIONS(5143),
    [anon_sym_STAR] = ACTIONS(5145),
    [anon_sym_SLASH] = ACTIONS(5147),
    [anon_sym_STAR_STAR] = ACTIONS(5149),
    [anon_sym_CARET] = ACTIONS(5149),
    [aux_sym_binary_operator_token1] = ACTIONS(5151),
    [anon_sym_PIPE_GT] = ACTIONS(5151),
    [anon_sym_COLON] = ACTIONS(5153),
    [anon_sym_DOLLAR] = ACTIONS(5155),
    [anon_sym_AT] = ACTIONS(5155),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__semicolon] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_else] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(5159),
    [sym__external_close_parenthesis] = ACTIONS(5345),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_close_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(5161),
    [sym__external_close_bracket] = ACTIONS(5345),
    [sym__external_open_bracket2] = ACTIONS(5163),
  },
  [573] = {
    [sym_call_arguments] = STATE(2318),
    [sym_subset_arguments] = STATE(2319),
    [sym_subset2_arguments] = STATE(2320),
    [sym__open_parenthesis] = STATE(1329),
    [sym__open_bracket] = STATE(1328),
    [sym__open_bracket2] = STATE(1327),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5123),
    [anon_sym_DASH] = ACTIONS(5125),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5347),
    [anon_sym_AMP] = ACTIONS(5347),
    [anon_sym_PIPE_PIPE] = ACTIONS(5345),
    [anon_sym_AMP_AMP] = ACTIONS(5345),
    [anon_sym_LT] = ACTIONS(5141),
    [anon_sym_LT_EQ] = ACTIONS(5143),
    [anon_sym_GT] = ACTIONS(5141),
    [anon_sym_GT_EQ] = ACTIONS(5143),
    [anon_sym_EQ_EQ] = ACTIONS(5143),
    [anon_sym_BANG_EQ] = ACTIONS(5143),
    [anon_sym_STAR] = ACTIONS(5145),
    [anon_sym_SLASH] = ACTIONS(5147),
    [anon_sym_STAR_STAR] = ACTIONS(5149),
    [anon_sym_CARET] = ACTIONS(5149),
    [aux_sym_binary_operator_token1] = ACTIONS(5151),
    [anon_sym_PIPE_GT] = ACTIONS(5151),
    [anon_sym_COLON] = ACTIONS(5153),
    [anon_sym_DOLLAR] = ACTIONS(5155),
    [anon_sym_AT] = ACTIONS(5155),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__semicolon] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_else] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(5159),
    [sym__external_close_parenthesis] = ACTIONS(5345),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_close_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(5161),
    [sym__external_close_bracket] = ACTIONS(5345),
    [sym__external_open_bracket2] = ACTIONS(5163),
  },
  [574] = {
    [sym_call_arguments] = STATE(2318),
    [sym_subset_arguments] = STATE(2319),
    [sym_subset2_arguments] = STATE(2320),
    [sym__open_parenthesis] = STATE(1329),
    [sym__open_bracket] = STATE(1328),
    [sym__open_bracket2] = STATE(1327),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5345),
    [anon_sym_DASH] = ACTIONS(5347),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5347),
    [anon_sym_AMP] = ACTIONS(5347),
    [anon_sym_PIPE_PIPE] = ACTIONS(5345),
    [anon_sym_AMP_AMP] = ACTIONS(5345),
    [anon_sym_LT] = ACTIONS(5347),
    [anon_sym_LT_EQ] = ACTIONS(5345),
    [anon_sym_GT] = ACTIONS(5347),
    [anon_sym_GT_EQ] = ACTIONS(5345),
    [anon_sym_EQ_EQ] = ACTIONS(5345),
    [anon_sym_BANG_EQ] = ACTIONS(5345),
    [anon_sym_STAR] = ACTIONS(5347),
    [anon_sym_SLASH] = ACTIONS(5345),
    [anon_sym_STAR_STAR] = ACTIONS(5149),
    [anon_sym_CARET] = ACTIONS(5149),
    [aux_sym_binary_operator_token1] = ACTIONS(5345),
    [anon_sym_PIPE_GT] = ACTIONS(5345),
    [anon_sym_COLON] = ACTIONS(5347),
    [anon_sym_DOLLAR] = ACTIONS(5155),
    [anon_sym_AT] = ACTIONS(5155),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__semicolon] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_else] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(5159),
    [sym__external_close_parenthesis] = ACTIONS(5345),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_close_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(5161),
    [sym__external_close_bracket] = ACTIONS(5345),
    [sym__external_open_bracket2] = ACTIONS(5163),
  },
  [575] = {
    [sym_call_arguments] = STATE(2261),
    [sym_subset_arguments] = STATE(2260),
    [sym_subset2_arguments] = STATE(2259),
    [sym__open_parenthesis] = STATE(1380),
    [sym__open_bracket] = STATE(1379),
    [sym__open_bracket2] = STATE(1378),
    [ts_builtin_sym_end] = ACTIONS(5313),
    [sym_identifier] = ACTIONS(5311),
    [anon_sym_BSLASH] = ACTIONS(5313),
    [anon_sym_function] = ACTIONS(5311),
    [anon_sym_EQ] = ACTIONS(5171),
    [anon_sym_if] = ACTIONS(5311),
    [anon_sym_for] = ACTIONS(5311),
    [anon_sym_while] = ACTIONS(5311),
    [anon_sym_repeat] = ACTIONS(5311),
    [anon_sym_QMARK] = ACTIONS(5457),
    [anon_sym_TILDE] = ACTIONS(5173),
    [anon_sym_BANG] = ACTIONS(5311),
    [anon_sym_PLUS] = ACTIONS(5175),
    [anon_sym_DASH] = ACTIONS(5177),
    [anon_sym_LT_DASH] = ACTIONS(5179),
    [anon_sym_LT_LT_DASH] = ACTIONS(5179),
    [anon_sym_COLON_EQ] = ACTIONS(5179),
    [anon_sym_DASH_GT] = ACTIONS(5181),
    [anon_sym_DASH_GT_GT] = ACTIONS(5183),
    [anon_sym_PIPE] = ACTIONS(5185),
    [anon_sym_AMP] = ACTIONS(5187),
    [anon_sym_PIPE_PIPE] = ACTIONS(5189),
    [anon_sym_AMP_AMP] = ACTIONS(5191),
    [anon_sym_LT] = ACTIONS(5193),
    [anon_sym_LT_EQ] = ACTIONS(5195),
    [anon_sym_GT] = ACTIONS(5193),
    [anon_sym_GT_EQ] = ACTIONS(5195),
    [anon_sym_EQ_EQ] = ACTIONS(5195),
    [anon_sym_BANG_EQ] = ACTIONS(5195),
    [anon_sym_STAR] = ACTIONS(5197),
    [anon_sym_SLASH] = ACTIONS(5199),
    [anon_sym_STAR_STAR] = ACTIONS(5201),
    [anon_sym_CARET] = ACTIONS(5201),
    [aux_sym_binary_operator_token1] = ACTIONS(5203),
    [anon_sym_PIPE_GT] = ACTIONS(5203),
    [anon_sym_COLON] = ACTIONS(5205),
    [anon_sym_DOLLAR] = ACTIONS(5207),
    [anon_sym_AT] = ACTIONS(5207),
    [aux_sym__hex_literal_token1] = ACTIONS(5313),
    [sym__number_literal] = ACTIONS(5311),
    [anon_sym_SQUOTE] = ACTIONS(5313),
    [anon_sym_DQUOTE] = ACTIONS(5313),
    [sym_return] = ACTIONS(5311),
    [sym_next] = ACTIONS(5311),
    [sym_break] = ACTIONS(5311),
    [sym_true] = ACTIONS(5311),
    [sym_false] = ACTIONS(5311),
    [sym_null] = ACTIONS(5311),
    [sym_inf] = ACTIONS(5311),
    [sym_nan] = ACTIONS(5311),
    [anon_sym_NA] = ACTIONS(5311),
    [anon_sym_NA_integer_] = ACTIONS(5311),
    [anon_sym_NA_real_] = ACTIONS(5311),
    [anon_sym_NA_complex_] = ACTIONS(5311),
    [anon_sym_NA_character_] = ACTIONS(5311),
    [sym_dots] = ACTIONS(5311),
    [sym_dot_dot_i] = ACTIONS(5313),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5313),
    [sym__newline] = ACTIONS(5313),
    [sym__semicolon] = ACTIONS(5313),
    [sym__raw_string_literal] = ACTIONS(5313),
    [sym__external_else] = ACTIONS(5313),
    [sym__external_open_parenthesis] = ACTIONS(5211),
    [sym__external_close_parenthesis] = ACTIONS(5313),
    [sym__external_open_brace] = ACTIONS(5313),
    [sym__external_close_brace] = ACTIONS(5313),
    [sym__external_open_bracket] = ACTIONS(5213),
    [sym__external_open_bracket2] = ACTIONS(5215),
  },
  [576] = {
    [sym_call_arguments] = STATE(2318),
    [sym_subset_arguments] = STATE(2319),
    [sym_subset2_arguments] = STATE(2320),
    [sym__open_parenthesis] = STATE(1329),
    [sym__open_bracket] = STATE(1328),
    [sym__open_bracket2] = STATE(1327),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5119),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5121),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5123),
    [anon_sym_DASH] = ACTIONS(5125),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5129),
    [anon_sym_DASH_GT_GT] = ACTIONS(5131),
    [anon_sym_PIPE] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5135),
    [anon_sym_PIPE_PIPE] = ACTIONS(5137),
    [anon_sym_AMP_AMP] = ACTIONS(5139),
    [anon_sym_LT] = ACTIONS(5141),
    [anon_sym_LT_EQ] = ACTIONS(5143),
    [anon_sym_GT] = ACTIONS(5141),
    [anon_sym_GT_EQ] = ACTIONS(5143),
    [anon_sym_EQ_EQ] = ACTIONS(5143),
    [anon_sym_BANG_EQ] = ACTIONS(5143),
    [anon_sym_STAR] = ACTIONS(5145),
    [anon_sym_SLASH] = ACTIONS(5147),
    [anon_sym_STAR_STAR] = ACTIONS(5149),
    [anon_sym_CARET] = ACTIONS(5149),
    [aux_sym_binary_operator_token1] = ACTIONS(5151),
    [anon_sym_PIPE_GT] = ACTIONS(5151),
    [anon_sym_COLON] = ACTIONS(5153),
    [anon_sym_DOLLAR] = ACTIONS(5155),
    [anon_sym_AT] = ACTIONS(5155),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5159),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5161),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(5163),
  },
  [577] = {
    [sym_call_arguments] = STATE(2318),
    [sym_subset_arguments] = STATE(2319),
    [sym_subset2_arguments] = STATE(2320),
    [sym__open_parenthesis] = STATE(1329),
    [sym__open_bracket] = STATE(1328),
    [sym__open_bracket2] = STATE(1327),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5119),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5121),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5123),
    [anon_sym_DASH] = ACTIONS(5125),
    [anon_sym_LT_DASH] = ACTIONS(5127),
    [anon_sym_LT_LT_DASH] = ACTIONS(5127),
    [anon_sym_COLON_EQ] = ACTIONS(5127),
    [anon_sym_DASH_GT] = ACTIONS(5129),
    [anon_sym_DASH_GT_GT] = ACTIONS(5131),
    [anon_sym_PIPE] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5135),
    [anon_sym_PIPE_PIPE] = ACTIONS(5137),
    [anon_sym_AMP_AMP] = ACTIONS(5139),
    [anon_sym_LT] = ACTIONS(5141),
    [anon_sym_LT_EQ] = ACTIONS(5143),
    [anon_sym_GT] = ACTIONS(5141),
    [anon_sym_GT_EQ] = ACTIONS(5143),
    [anon_sym_EQ_EQ] = ACTIONS(5143),
    [anon_sym_BANG_EQ] = ACTIONS(5143),
    [anon_sym_STAR] = ACTIONS(5145),
    [anon_sym_SLASH] = ACTIONS(5147),
    [anon_sym_STAR_STAR] = ACTIONS(5149),
    [anon_sym_CARET] = ACTIONS(5149),
    [aux_sym_binary_operator_token1] = ACTIONS(5151),
    [anon_sym_PIPE_GT] = ACTIONS(5151),
    [anon_sym_COLON] = ACTIONS(5153),
    [anon_sym_DOLLAR] = ACTIONS(5155),
    [anon_sym_AT] = ACTIONS(5155),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5159),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5161),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(5163),
  },
  [578] = {
    [sym_call_arguments] = STATE(2318),
    [sym_subset_arguments] = STATE(2319),
    [sym_subset2_arguments] = STATE(2320),
    [sym__open_parenthesis] = STATE(1329),
    [sym__open_bracket] = STATE(1328),
    [sym__open_bracket2] = STATE(1327),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5123),
    [anon_sym_DASH] = ACTIONS(5125),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5135),
    [anon_sym_PIPE_PIPE] = ACTIONS(5137),
    [anon_sym_AMP_AMP] = ACTIONS(5139),
    [anon_sym_LT] = ACTIONS(5141),
    [anon_sym_LT_EQ] = ACTIONS(5143),
    [anon_sym_GT] = ACTIONS(5141),
    [anon_sym_GT_EQ] = ACTIONS(5143),
    [anon_sym_EQ_EQ] = ACTIONS(5143),
    [anon_sym_BANG_EQ] = ACTIONS(5143),
    [anon_sym_STAR] = ACTIONS(5145),
    [anon_sym_SLASH] = ACTIONS(5147),
    [anon_sym_STAR_STAR] = ACTIONS(5149),
    [anon_sym_CARET] = ACTIONS(5149),
    [aux_sym_binary_operator_token1] = ACTIONS(5151),
    [anon_sym_PIPE_GT] = ACTIONS(5151),
    [anon_sym_COLON] = ACTIONS(5153),
    [anon_sym_DOLLAR] = ACTIONS(5155),
    [anon_sym_AT] = ACTIONS(5155),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5159),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5161),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(5163),
  },
  [579] = {
    [sym_call_arguments] = STATE(2318),
    [sym_subset_arguments] = STATE(2319),
    [sym_subset2_arguments] = STATE(2320),
    [sym__open_parenthesis] = STATE(1329),
    [sym__open_bracket] = STATE(1328),
    [sym__open_bracket2] = STATE(1327),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5145),
    [anon_sym_SLASH] = ACTIONS(5147),
    [anon_sym_STAR_STAR] = ACTIONS(5149),
    [anon_sym_CARET] = ACTIONS(5149),
    [aux_sym_binary_operator_token1] = ACTIONS(5151),
    [anon_sym_PIPE_GT] = ACTIONS(5151),
    [anon_sym_COLON] = ACTIONS(5153),
    [anon_sym_DOLLAR] = ACTIONS(5155),
    [anon_sym_AT] = ACTIONS(5155),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5159),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5161),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(5163),
  },
  [580] = {
    [sym_call_arguments] = STATE(2318),
    [sym_subset_arguments] = STATE(2319),
    [sym_subset2_arguments] = STATE(2320),
    [sym__open_parenthesis] = STATE(1329),
    [sym__open_bracket] = STATE(1328),
    [sym__open_bracket2] = STATE(1327),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5119),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5121),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5123),
    [anon_sym_DASH] = ACTIONS(5125),
    [anon_sym_LT_DASH] = ACTIONS(5127),
    [anon_sym_LT_LT_DASH] = ACTIONS(5127),
    [anon_sym_COLON_EQ] = ACTIONS(5127),
    [anon_sym_DASH_GT] = ACTIONS(5129),
    [anon_sym_DASH_GT_GT] = ACTIONS(5131),
    [anon_sym_PIPE] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5135),
    [anon_sym_PIPE_PIPE] = ACTIONS(5137),
    [anon_sym_AMP_AMP] = ACTIONS(5139),
    [anon_sym_LT] = ACTIONS(5141),
    [anon_sym_LT_EQ] = ACTIONS(5143),
    [anon_sym_GT] = ACTIONS(5141),
    [anon_sym_GT_EQ] = ACTIONS(5143),
    [anon_sym_EQ_EQ] = ACTIONS(5143),
    [anon_sym_BANG_EQ] = ACTIONS(5143),
    [anon_sym_STAR] = ACTIONS(5145),
    [anon_sym_SLASH] = ACTIONS(5147),
    [anon_sym_STAR_STAR] = ACTIONS(5149),
    [anon_sym_CARET] = ACTIONS(5149),
    [aux_sym_binary_operator_token1] = ACTIONS(5151),
    [anon_sym_PIPE_GT] = ACTIONS(5151),
    [anon_sym_COLON] = ACTIONS(5153),
    [anon_sym_DOLLAR] = ACTIONS(5155),
    [anon_sym_AT] = ACTIONS(5155),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5159),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5161),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(5163),
  },
  [581] = {
    [sym_call_arguments] = STATE(2318),
    [sym_subset_arguments] = STATE(2319),
    [sym_subset2_arguments] = STATE(2320),
    [sym__open_parenthesis] = STATE(1329),
    [sym__open_bracket] = STATE(1328),
    [sym__open_bracket2] = STATE(1327),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5121),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5123),
    [anon_sym_DASH] = ACTIONS(5125),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5135),
    [anon_sym_PIPE_PIPE] = ACTIONS(5137),
    [anon_sym_AMP_AMP] = ACTIONS(5139),
    [anon_sym_LT] = ACTIONS(5141),
    [anon_sym_LT_EQ] = ACTIONS(5143),
    [anon_sym_GT] = ACTIONS(5141),
    [anon_sym_GT_EQ] = ACTIONS(5143),
    [anon_sym_EQ_EQ] = ACTIONS(5143),
    [anon_sym_BANG_EQ] = ACTIONS(5143),
    [anon_sym_STAR] = ACTIONS(5145),
    [anon_sym_SLASH] = ACTIONS(5147),
    [anon_sym_STAR_STAR] = ACTIONS(5149),
    [anon_sym_CARET] = ACTIONS(5149),
    [aux_sym_binary_operator_token1] = ACTIONS(5151),
    [anon_sym_PIPE_GT] = ACTIONS(5151),
    [anon_sym_COLON] = ACTIONS(5153),
    [anon_sym_DOLLAR] = ACTIONS(5155),
    [anon_sym_AT] = ACTIONS(5155),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5159),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5161),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(5163),
  },
  [582] = {
    [sym_call_arguments] = STATE(2318),
    [sym_subset_arguments] = STATE(2319),
    [sym_subset2_arguments] = STATE(2320),
    [sym__open_parenthesis] = STATE(1329),
    [sym__open_bracket] = STATE(1328),
    [sym__open_bracket2] = STATE(1327),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5123),
    [anon_sym_DASH] = ACTIONS(5125),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5135),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5139),
    [anon_sym_LT] = ACTIONS(5141),
    [anon_sym_LT_EQ] = ACTIONS(5143),
    [anon_sym_GT] = ACTIONS(5141),
    [anon_sym_GT_EQ] = ACTIONS(5143),
    [anon_sym_EQ_EQ] = ACTIONS(5143),
    [anon_sym_BANG_EQ] = ACTIONS(5143),
    [anon_sym_STAR] = ACTIONS(5145),
    [anon_sym_SLASH] = ACTIONS(5147),
    [anon_sym_STAR_STAR] = ACTIONS(5149),
    [anon_sym_CARET] = ACTIONS(5149),
    [aux_sym_binary_operator_token1] = ACTIONS(5151),
    [anon_sym_PIPE_GT] = ACTIONS(5151),
    [anon_sym_COLON] = ACTIONS(5153),
    [anon_sym_DOLLAR] = ACTIONS(5155),
    [anon_sym_AT] = ACTIONS(5155),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5159),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5161),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(5163),
  },
  [583] = {
    [sym_call_arguments] = STATE(2318),
    [sym_subset_arguments] = STATE(2319),
    [sym_subset2_arguments] = STATE(2320),
    [sym__open_parenthesis] = STATE(1329),
    [sym__open_bracket] = STATE(1328),
    [sym__open_bracket2] = STATE(1327),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5123),
    [anon_sym_DASH] = ACTIONS(5125),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5141),
    [anon_sym_LT_EQ] = ACTIONS(5143),
    [anon_sym_GT] = ACTIONS(5141),
    [anon_sym_GT_EQ] = ACTIONS(5143),
    [anon_sym_EQ_EQ] = ACTIONS(5143),
    [anon_sym_BANG_EQ] = ACTIONS(5143),
    [anon_sym_STAR] = ACTIONS(5145),
    [anon_sym_SLASH] = ACTIONS(5147),
    [anon_sym_STAR_STAR] = ACTIONS(5149),
    [anon_sym_CARET] = ACTIONS(5149),
    [aux_sym_binary_operator_token1] = ACTIONS(5151),
    [anon_sym_PIPE_GT] = ACTIONS(5151),
    [anon_sym_COLON] = ACTIONS(5153),
    [anon_sym_DOLLAR] = ACTIONS(5155),
    [anon_sym_AT] = ACTIONS(5155),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5159),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5161),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(5163),
  },
  [584] = {
    [sym_call_arguments] = STATE(2318),
    [sym_subset_arguments] = STATE(2319),
    [sym_subset2_arguments] = STATE(2320),
    [sym__open_parenthesis] = STATE(1329),
    [sym__open_bracket] = STATE(1328),
    [sym__open_bracket2] = STATE(1327),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5123),
    [anon_sym_DASH] = ACTIONS(5125),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5145),
    [anon_sym_SLASH] = ACTIONS(5147),
    [anon_sym_STAR_STAR] = ACTIONS(5149),
    [anon_sym_CARET] = ACTIONS(5149),
    [aux_sym_binary_operator_token1] = ACTIONS(5151),
    [anon_sym_PIPE_GT] = ACTIONS(5151),
    [anon_sym_COLON] = ACTIONS(5153),
    [anon_sym_DOLLAR] = ACTIONS(5155),
    [anon_sym_AT] = ACTIONS(5155),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5159),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5161),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(5163),
  },
  [585] = {
    [sym_call_arguments] = STATE(2318),
    [sym_subset_arguments] = STATE(2319),
    [sym_subset2_arguments] = STATE(2320),
    [sym__open_parenthesis] = STATE(1329),
    [sym__open_bracket] = STATE(1328),
    [sym__open_bracket2] = STATE(1327),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(5149),
    [anon_sym_CARET] = ACTIONS(5149),
    [aux_sym_binary_operator_token1] = ACTIONS(5151),
    [anon_sym_PIPE_GT] = ACTIONS(5151),
    [anon_sym_COLON] = ACTIONS(5153),
    [anon_sym_DOLLAR] = ACTIONS(5155),
    [anon_sym_AT] = ACTIONS(5155),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5159),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5161),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(5163),
  },
  [586] = {
    [sym_call_arguments] = STATE(2318),
    [sym_subset_arguments] = STATE(2319),
    [sym_subset2_arguments] = STATE(2320),
    [sym__open_parenthesis] = STATE(1329),
    [sym__open_bracket] = STATE(1328),
    [sym__open_bracket2] = STATE(1327),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(5149),
    [anon_sym_CARET] = ACTIONS(5149),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(5351),
    [anon_sym_DOLLAR] = ACTIONS(5155),
    [anon_sym_AT] = ACTIONS(5155),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5159),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5161),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(5163),
  },
  [587] = {
    [sym_call_arguments] = STATE(2318),
    [sym_subset_arguments] = STATE(2319),
    [sym_subset2_arguments] = STATE(2320),
    [sym__open_parenthesis] = STATE(1329),
    [sym__open_bracket] = STATE(1328),
    [sym__open_bracket2] = STATE(1327),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(5149),
    [anon_sym_CARET] = ACTIONS(5149),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(5153),
    [anon_sym_DOLLAR] = ACTIONS(5155),
    [anon_sym_AT] = ACTIONS(5155),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5159),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5161),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(5163),
  },
  [588] = {
    [sym_call_arguments] = STATE(2318),
    [sym_subset_arguments] = STATE(2319),
    [sym_subset2_arguments] = STATE(2320),
    [sym__open_parenthesis] = STATE(1329),
    [sym__open_bracket] = STATE(1328),
    [sym__open_bracket2] = STATE(1327),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(5149),
    [anon_sym_CARET] = ACTIONS(5149),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(5351),
    [anon_sym_DOLLAR] = ACTIONS(5155),
    [anon_sym_AT] = ACTIONS(5155),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5159),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5161),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(5163),
  },
  [589] = {
    [sym_call_arguments] = STATE(2318),
    [sym_subset_arguments] = STATE(2319),
    [sym_subset2_arguments] = STATE(2320),
    [sym__open_parenthesis] = STATE(1329),
    [sym__open_bracket] = STATE(1328),
    [sym__open_bracket2] = STATE(1327),
    [sym_identifier] = ACTIONS(5401),
    [anon_sym_BSLASH] = ACTIONS(5399),
    [anon_sym_function] = ACTIONS(5401),
    [anon_sym_EQ] = ACTIONS(5119),
    [anon_sym_if] = ACTIONS(5401),
    [anon_sym_for] = ACTIONS(5401),
    [anon_sym_while] = ACTIONS(5401),
    [anon_sym_repeat] = ACTIONS(5401),
    [anon_sym_QMARK] = ACTIONS(5399),
    [anon_sym_TILDE] = ACTIONS(5121),
    [anon_sym_BANG] = ACTIONS(5401),
    [anon_sym_PLUS] = ACTIONS(5123),
    [anon_sym_DASH] = ACTIONS(5125),
    [anon_sym_LT_DASH] = ACTIONS(5127),
    [anon_sym_LT_LT_DASH] = ACTIONS(5127),
    [anon_sym_COLON_EQ] = ACTIONS(5127),
    [anon_sym_DASH_GT] = ACTIONS(5129),
    [anon_sym_DASH_GT_GT] = ACTIONS(5131),
    [anon_sym_PIPE] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5135),
    [anon_sym_PIPE_PIPE] = ACTIONS(5137),
    [anon_sym_AMP_AMP] = ACTIONS(5139),
    [anon_sym_LT] = ACTIONS(5141),
    [anon_sym_LT_EQ] = ACTIONS(5143),
    [anon_sym_GT] = ACTIONS(5141),
    [anon_sym_GT_EQ] = ACTIONS(5143),
    [anon_sym_EQ_EQ] = ACTIONS(5143),
    [anon_sym_BANG_EQ] = ACTIONS(5143),
    [anon_sym_STAR] = ACTIONS(5145),
    [anon_sym_SLASH] = ACTIONS(5147),
    [anon_sym_STAR_STAR] = ACTIONS(5149),
    [anon_sym_CARET] = ACTIONS(5149),
    [aux_sym_binary_operator_token1] = ACTIONS(5151),
    [anon_sym_PIPE_GT] = ACTIONS(5151),
    [anon_sym_COLON] = ACTIONS(5153),
    [anon_sym_DOLLAR] = ACTIONS(5155),
    [anon_sym_AT] = ACTIONS(5155),
    [aux_sym__hex_literal_token1] = ACTIONS(5399),
    [sym__number_literal] = ACTIONS(5401),
    [anon_sym_SQUOTE] = ACTIONS(5399),
    [anon_sym_DQUOTE] = ACTIONS(5399),
    [sym_return] = ACTIONS(5401),
    [sym_next] = ACTIONS(5401),
    [sym_break] = ACTIONS(5401),
    [sym_true] = ACTIONS(5401),
    [sym_false] = ACTIONS(5401),
    [sym_null] = ACTIONS(5401),
    [sym_inf] = ACTIONS(5401),
    [sym_nan] = ACTIONS(5401),
    [anon_sym_NA] = ACTIONS(5401),
    [anon_sym_NA_integer_] = ACTIONS(5401),
    [anon_sym_NA_real_] = ACTIONS(5401),
    [anon_sym_NA_complex_] = ACTIONS(5401),
    [anon_sym_NA_character_] = ACTIONS(5401),
    [sym_dots] = ACTIONS(5401),
    [sym_dot_dot_i] = ACTIONS(5399),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5399),
    [sym__newline] = ACTIONS(5399),
    [sym__semicolon] = ACTIONS(5399),
    [sym__raw_string_literal] = ACTIONS(5399),
    [sym__external_else] = ACTIONS(5399),
    [sym__external_open_parenthesis] = ACTIONS(5159),
    [sym__external_close_parenthesis] = ACTIONS(5399),
    [sym__external_open_brace] = ACTIONS(5399),
    [sym__external_close_brace] = ACTIONS(5399),
    [sym__external_open_bracket] = ACTIONS(5161),
    [sym__external_close_bracket] = ACTIONS(5399),
    [sym__external_open_bracket2] = ACTIONS(5163),
  },
  [590] = {
    [sym_call_arguments] = STATE(2318),
    [sym_subset_arguments] = STATE(2319),
    [sym_subset2_arguments] = STATE(2320),
    [sym__open_parenthesis] = STATE(1329),
    [sym__open_bracket] = STATE(1328),
    [sym__open_bracket2] = STATE(1327),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5119),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5121),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5123),
    [anon_sym_DASH] = ACTIONS(5125),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5129),
    [anon_sym_DASH_GT_GT] = ACTIONS(5131),
    [anon_sym_PIPE] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5135),
    [anon_sym_PIPE_PIPE] = ACTIONS(5137),
    [anon_sym_AMP_AMP] = ACTIONS(5139),
    [anon_sym_LT] = ACTIONS(5141),
    [anon_sym_LT_EQ] = ACTIONS(5143),
    [anon_sym_GT] = ACTIONS(5141),
    [anon_sym_GT_EQ] = ACTIONS(5143),
    [anon_sym_EQ_EQ] = ACTIONS(5143),
    [anon_sym_BANG_EQ] = ACTIONS(5143),
    [anon_sym_STAR] = ACTIONS(5145),
    [anon_sym_SLASH] = ACTIONS(5147),
    [anon_sym_STAR_STAR] = ACTIONS(5149),
    [anon_sym_CARET] = ACTIONS(5149),
    [aux_sym_binary_operator_token1] = ACTIONS(5151),
    [anon_sym_PIPE_GT] = ACTIONS(5151),
    [anon_sym_COLON] = ACTIONS(5153),
    [anon_sym_DOLLAR] = ACTIONS(5155),
    [anon_sym_AT] = ACTIONS(5155),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5159),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5161),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(5163),
  },
  [591] = {
    [sym_call_arguments] = STATE(2318),
    [sym_subset_arguments] = STATE(2319),
    [sym_subset2_arguments] = STATE(2320),
    [sym__open_parenthesis] = STATE(1329),
    [sym__open_bracket] = STATE(1328),
    [sym__open_bracket2] = STATE(1327),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5123),
    [anon_sym_DASH] = ACTIONS(5125),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5135),
    [anon_sym_PIPE_PIPE] = ACTIONS(5137),
    [anon_sym_AMP_AMP] = ACTIONS(5139),
    [anon_sym_LT] = ACTIONS(5141),
    [anon_sym_LT_EQ] = ACTIONS(5143),
    [anon_sym_GT] = ACTIONS(5141),
    [anon_sym_GT_EQ] = ACTIONS(5143),
    [anon_sym_EQ_EQ] = ACTIONS(5143),
    [anon_sym_BANG_EQ] = ACTIONS(5143),
    [anon_sym_STAR] = ACTIONS(5145),
    [anon_sym_SLASH] = ACTIONS(5147),
    [anon_sym_STAR_STAR] = ACTIONS(5149),
    [anon_sym_CARET] = ACTIONS(5149),
    [aux_sym_binary_operator_token1] = ACTIONS(5151),
    [anon_sym_PIPE_GT] = ACTIONS(5151),
    [anon_sym_COLON] = ACTIONS(5153),
    [anon_sym_DOLLAR] = ACTIONS(5155),
    [anon_sym_AT] = ACTIONS(5155),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5159),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5161),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(5163),
  },
  [592] = {
    [sym_call_arguments] = STATE(2318),
    [sym_subset_arguments] = STATE(2319),
    [sym_subset2_arguments] = STATE(2320),
    [sym__open_parenthesis] = STATE(1329),
    [sym__open_bracket] = STATE(1328),
    [sym__open_bracket2] = STATE(1327),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5145),
    [anon_sym_SLASH] = ACTIONS(5147),
    [anon_sym_STAR_STAR] = ACTIONS(5149),
    [anon_sym_CARET] = ACTIONS(5149),
    [aux_sym_binary_operator_token1] = ACTIONS(5151),
    [anon_sym_PIPE_GT] = ACTIONS(5151),
    [anon_sym_COLON] = ACTIONS(5153),
    [anon_sym_DOLLAR] = ACTIONS(5155),
    [anon_sym_AT] = ACTIONS(5155),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5159),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5161),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(5163),
  },
  [593] = {
    [sym_call_arguments] = STATE(2318),
    [sym_subset_arguments] = STATE(2319),
    [sym_subset2_arguments] = STATE(2320),
    [sym__open_parenthesis] = STATE(1329),
    [sym__open_bracket] = STATE(1328),
    [sym__open_bracket2] = STATE(1327),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5119),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5121),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5123),
    [anon_sym_DASH] = ACTIONS(5125),
    [anon_sym_LT_DASH] = ACTIONS(5127),
    [anon_sym_LT_LT_DASH] = ACTIONS(5127),
    [anon_sym_COLON_EQ] = ACTIONS(5127),
    [anon_sym_DASH_GT] = ACTIONS(5129),
    [anon_sym_DASH_GT_GT] = ACTIONS(5131),
    [anon_sym_PIPE] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5135),
    [anon_sym_PIPE_PIPE] = ACTIONS(5137),
    [anon_sym_AMP_AMP] = ACTIONS(5139),
    [anon_sym_LT] = ACTIONS(5141),
    [anon_sym_LT_EQ] = ACTIONS(5143),
    [anon_sym_GT] = ACTIONS(5141),
    [anon_sym_GT_EQ] = ACTIONS(5143),
    [anon_sym_EQ_EQ] = ACTIONS(5143),
    [anon_sym_BANG_EQ] = ACTIONS(5143),
    [anon_sym_STAR] = ACTIONS(5145),
    [anon_sym_SLASH] = ACTIONS(5147),
    [anon_sym_STAR_STAR] = ACTIONS(5149),
    [anon_sym_CARET] = ACTIONS(5149),
    [aux_sym_binary_operator_token1] = ACTIONS(5151),
    [anon_sym_PIPE_GT] = ACTIONS(5151),
    [anon_sym_COLON] = ACTIONS(5153),
    [anon_sym_DOLLAR] = ACTIONS(5155),
    [anon_sym_AT] = ACTIONS(5155),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5159),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5161),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(5163),
  },
  [594] = {
    [sym_call_arguments] = STATE(2318),
    [sym_subset_arguments] = STATE(2319),
    [sym_subset2_arguments] = STATE(2320),
    [sym__open_parenthesis] = STATE(1329),
    [sym__open_bracket] = STATE(1328),
    [sym__open_bracket2] = STATE(1327),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5121),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5123),
    [anon_sym_DASH] = ACTIONS(5125),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5135),
    [anon_sym_PIPE_PIPE] = ACTIONS(5137),
    [anon_sym_AMP_AMP] = ACTIONS(5139),
    [anon_sym_LT] = ACTIONS(5141),
    [anon_sym_LT_EQ] = ACTIONS(5143),
    [anon_sym_GT] = ACTIONS(5141),
    [anon_sym_GT_EQ] = ACTIONS(5143),
    [anon_sym_EQ_EQ] = ACTIONS(5143),
    [anon_sym_BANG_EQ] = ACTIONS(5143),
    [anon_sym_STAR] = ACTIONS(5145),
    [anon_sym_SLASH] = ACTIONS(5147),
    [anon_sym_STAR_STAR] = ACTIONS(5149),
    [anon_sym_CARET] = ACTIONS(5149),
    [aux_sym_binary_operator_token1] = ACTIONS(5151),
    [anon_sym_PIPE_GT] = ACTIONS(5151),
    [anon_sym_COLON] = ACTIONS(5153),
    [anon_sym_DOLLAR] = ACTIONS(5155),
    [anon_sym_AT] = ACTIONS(5155),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5159),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5161),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(5163),
  },
  [595] = {
    [sym_call_arguments] = STATE(2318),
    [sym_subset_arguments] = STATE(2319),
    [sym_subset2_arguments] = STATE(2320),
    [sym__open_parenthesis] = STATE(1329),
    [sym__open_bracket] = STATE(1328),
    [sym__open_bracket2] = STATE(1327),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5123),
    [anon_sym_DASH] = ACTIONS(5125),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5135),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5139),
    [anon_sym_LT] = ACTIONS(5141),
    [anon_sym_LT_EQ] = ACTIONS(5143),
    [anon_sym_GT] = ACTIONS(5141),
    [anon_sym_GT_EQ] = ACTIONS(5143),
    [anon_sym_EQ_EQ] = ACTIONS(5143),
    [anon_sym_BANG_EQ] = ACTIONS(5143),
    [anon_sym_STAR] = ACTIONS(5145),
    [anon_sym_SLASH] = ACTIONS(5147),
    [anon_sym_STAR_STAR] = ACTIONS(5149),
    [anon_sym_CARET] = ACTIONS(5149),
    [aux_sym_binary_operator_token1] = ACTIONS(5151),
    [anon_sym_PIPE_GT] = ACTIONS(5151),
    [anon_sym_COLON] = ACTIONS(5153),
    [anon_sym_DOLLAR] = ACTIONS(5155),
    [anon_sym_AT] = ACTIONS(5155),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5159),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5161),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(5163),
  },
  [596] = {
    [sym_call_arguments] = STATE(2318),
    [sym_subset_arguments] = STATE(2319),
    [sym_subset2_arguments] = STATE(2320),
    [sym__open_parenthesis] = STATE(1329),
    [sym__open_bracket] = STATE(1328),
    [sym__open_bracket2] = STATE(1327),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5123),
    [anon_sym_DASH] = ACTIONS(5125),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5141),
    [anon_sym_LT_EQ] = ACTIONS(5143),
    [anon_sym_GT] = ACTIONS(5141),
    [anon_sym_GT_EQ] = ACTIONS(5143),
    [anon_sym_EQ_EQ] = ACTIONS(5143),
    [anon_sym_BANG_EQ] = ACTIONS(5143),
    [anon_sym_STAR] = ACTIONS(5145),
    [anon_sym_SLASH] = ACTIONS(5147),
    [anon_sym_STAR_STAR] = ACTIONS(5149),
    [anon_sym_CARET] = ACTIONS(5149),
    [aux_sym_binary_operator_token1] = ACTIONS(5151),
    [anon_sym_PIPE_GT] = ACTIONS(5151),
    [anon_sym_COLON] = ACTIONS(5153),
    [anon_sym_DOLLAR] = ACTIONS(5155),
    [anon_sym_AT] = ACTIONS(5155),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5159),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5161),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(5163),
  },
  [597] = {
    [sym_call_arguments] = STATE(2318),
    [sym_subset_arguments] = STATE(2319),
    [sym_subset2_arguments] = STATE(2320),
    [sym__open_parenthesis] = STATE(1329),
    [sym__open_bracket] = STATE(1328),
    [sym__open_bracket2] = STATE(1327),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5123),
    [anon_sym_DASH] = ACTIONS(5125),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5145),
    [anon_sym_SLASH] = ACTIONS(5147),
    [anon_sym_STAR_STAR] = ACTIONS(5149),
    [anon_sym_CARET] = ACTIONS(5149),
    [aux_sym_binary_operator_token1] = ACTIONS(5151),
    [anon_sym_PIPE_GT] = ACTIONS(5151),
    [anon_sym_COLON] = ACTIONS(5153),
    [anon_sym_DOLLAR] = ACTIONS(5155),
    [anon_sym_AT] = ACTIONS(5155),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5159),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5161),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(5163),
  },
  [598] = {
    [sym_call_arguments] = STATE(2318),
    [sym_subset_arguments] = STATE(2319),
    [sym_subset2_arguments] = STATE(2320),
    [sym__open_parenthesis] = STATE(1329),
    [sym__open_bracket] = STATE(1328),
    [sym__open_bracket2] = STATE(1327),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(5149),
    [anon_sym_CARET] = ACTIONS(5149),
    [aux_sym_binary_operator_token1] = ACTIONS(5151),
    [anon_sym_PIPE_GT] = ACTIONS(5151),
    [anon_sym_COLON] = ACTIONS(5153),
    [anon_sym_DOLLAR] = ACTIONS(5155),
    [anon_sym_AT] = ACTIONS(5155),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5159),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5161),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(5163),
  },
  [599] = {
    [sym_call_arguments] = STATE(2261),
    [sym_subset_arguments] = STATE(2260),
    [sym_subset2_arguments] = STATE(2259),
    [sym__open_parenthesis] = STATE(1380),
    [sym__open_bracket] = STATE(1379),
    [sym__open_bracket2] = STATE(1378),
    [ts_builtin_sym_end] = ACTIONS(5327),
    [sym_identifier] = ACTIONS(5325),
    [anon_sym_BSLASH] = ACTIONS(5327),
    [anon_sym_function] = ACTIONS(5325),
    [anon_sym_EQ] = ACTIONS(5171),
    [anon_sym_if] = ACTIONS(5325),
    [anon_sym_for] = ACTIONS(5325),
    [anon_sym_while] = ACTIONS(5325),
    [anon_sym_repeat] = ACTIONS(5325),
    [anon_sym_QMARK] = ACTIONS(5457),
    [anon_sym_TILDE] = ACTIONS(5173),
    [anon_sym_BANG] = ACTIONS(5325),
    [anon_sym_PLUS] = ACTIONS(5175),
    [anon_sym_DASH] = ACTIONS(5177),
    [anon_sym_LT_DASH] = ACTIONS(5179),
    [anon_sym_LT_LT_DASH] = ACTIONS(5179),
    [anon_sym_COLON_EQ] = ACTIONS(5179),
    [anon_sym_DASH_GT] = ACTIONS(5181),
    [anon_sym_DASH_GT_GT] = ACTIONS(5183),
    [anon_sym_PIPE] = ACTIONS(5185),
    [anon_sym_AMP] = ACTIONS(5187),
    [anon_sym_PIPE_PIPE] = ACTIONS(5189),
    [anon_sym_AMP_AMP] = ACTIONS(5191),
    [anon_sym_LT] = ACTIONS(5193),
    [anon_sym_LT_EQ] = ACTIONS(5195),
    [anon_sym_GT] = ACTIONS(5193),
    [anon_sym_GT_EQ] = ACTIONS(5195),
    [anon_sym_EQ_EQ] = ACTIONS(5195),
    [anon_sym_BANG_EQ] = ACTIONS(5195),
    [anon_sym_STAR] = ACTIONS(5197),
    [anon_sym_SLASH] = ACTIONS(5199),
    [anon_sym_STAR_STAR] = ACTIONS(5201),
    [anon_sym_CARET] = ACTIONS(5201),
    [aux_sym_binary_operator_token1] = ACTIONS(5203),
    [anon_sym_PIPE_GT] = ACTIONS(5203),
    [anon_sym_COLON] = ACTIONS(5205),
    [anon_sym_DOLLAR] = ACTIONS(5207),
    [anon_sym_AT] = ACTIONS(5207),
    [aux_sym__hex_literal_token1] = ACTIONS(5327),
    [sym__number_literal] = ACTIONS(5325),
    [anon_sym_SQUOTE] = ACTIONS(5327),
    [anon_sym_DQUOTE] = ACTIONS(5327),
    [sym_return] = ACTIONS(5325),
    [sym_next] = ACTIONS(5325),
    [sym_break] = ACTIONS(5325),
    [sym_true] = ACTIONS(5325),
    [sym_false] = ACTIONS(5325),
    [sym_null] = ACTIONS(5325),
    [sym_inf] = ACTIONS(5325),
    [sym_nan] = ACTIONS(5325),
    [anon_sym_NA] = ACTIONS(5325),
    [anon_sym_NA_integer_] = ACTIONS(5325),
    [anon_sym_NA_real_] = ACTIONS(5325),
    [anon_sym_NA_complex_] = ACTIONS(5325),
    [anon_sym_NA_character_] = ACTIONS(5325),
    [sym_dots] = ACTIONS(5325),
    [sym_dot_dot_i] = ACTIONS(5327),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5327),
    [sym__newline] = ACTIONS(5327),
    [sym__semicolon] = ACTIONS(5327),
    [sym__raw_string_literal] = ACTIONS(5327),
    [sym__external_else] = ACTIONS(5327),
    [sym__external_open_parenthesis] = ACTIONS(5211),
    [sym__external_close_parenthesis] = ACTIONS(5327),
    [sym__external_open_brace] = ACTIONS(5327),
    [sym__external_close_brace] = ACTIONS(5327),
    [sym__external_open_bracket] = ACTIONS(5213),
    [sym__external_open_bracket2] = ACTIONS(5215),
  },
  [600] = {
    [sym_call_arguments] = STATE(2318),
    [sym_subset_arguments] = STATE(2319),
    [sym_subset2_arguments] = STATE(2320),
    [sym__open_parenthesis] = STATE(1329),
    [sym__open_bracket] = STATE(1328),
    [sym__open_bracket2] = STATE(1327),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(5149),
    [anon_sym_CARET] = ACTIONS(5149),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(5261),
    [anon_sym_DOLLAR] = ACTIONS(5155),
    [anon_sym_AT] = ACTIONS(5155),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5159),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5161),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(5163),
  },
  [601] = {
    [sym_call_arguments] = STATE(2318),
    [sym_subset_arguments] = STATE(2319),
    [sym_subset2_arguments] = STATE(2320),
    [sym__open_parenthesis] = STATE(1329),
    [sym__open_bracket] = STATE(1328),
    [sym__open_bracket2] = STATE(1327),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(5149),
    [anon_sym_CARET] = ACTIONS(5149),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(5153),
    [anon_sym_DOLLAR] = ACTIONS(5155),
    [anon_sym_AT] = ACTIONS(5155),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5159),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5161),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(5163),
  },
  [602] = {
    [sym_call_arguments] = STATE(2318),
    [sym_subset_arguments] = STATE(2319),
    [sym_subset2_arguments] = STATE(2320),
    [sym__open_parenthesis] = STATE(1329),
    [sym__open_bracket] = STATE(1328),
    [sym__open_bracket2] = STATE(1327),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(5149),
    [anon_sym_CARET] = ACTIONS(5149),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(5261),
    [anon_sym_DOLLAR] = ACTIONS(5155),
    [anon_sym_AT] = ACTIONS(5155),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5159),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5161),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(5163),
  },
  [603] = {
    [sym_call_arguments] = STATE(2318),
    [sym_subset_arguments] = STATE(2319),
    [sym_subset2_arguments] = STATE(2320),
    [sym__open_parenthesis] = STATE(1329),
    [sym__open_bracket] = STATE(1328),
    [sym__open_bracket2] = STATE(1327),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_BSLASH] = ACTIONS(5413),
    [anon_sym_function] = ACTIONS(5415),
    [anon_sym_EQ] = ACTIONS(5119),
    [anon_sym_if] = ACTIONS(5415),
    [anon_sym_for] = ACTIONS(5415),
    [anon_sym_while] = ACTIONS(5415),
    [anon_sym_repeat] = ACTIONS(5415),
    [anon_sym_QMARK] = ACTIONS(5413),
    [anon_sym_TILDE] = ACTIONS(5121),
    [anon_sym_BANG] = ACTIONS(5415),
    [anon_sym_PLUS] = ACTIONS(5123),
    [anon_sym_DASH] = ACTIONS(5125),
    [anon_sym_LT_DASH] = ACTIONS(5127),
    [anon_sym_LT_LT_DASH] = ACTIONS(5127),
    [anon_sym_COLON_EQ] = ACTIONS(5127),
    [anon_sym_DASH_GT] = ACTIONS(5129),
    [anon_sym_DASH_GT_GT] = ACTIONS(5131),
    [anon_sym_PIPE] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5135),
    [anon_sym_PIPE_PIPE] = ACTIONS(5137),
    [anon_sym_AMP_AMP] = ACTIONS(5139),
    [anon_sym_LT] = ACTIONS(5141),
    [anon_sym_LT_EQ] = ACTIONS(5143),
    [anon_sym_GT] = ACTIONS(5141),
    [anon_sym_GT_EQ] = ACTIONS(5143),
    [anon_sym_EQ_EQ] = ACTIONS(5143),
    [anon_sym_BANG_EQ] = ACTIONS(5143),
    [anon_sym_STAR] = ACTIONS(5145),
    [anon_sym_SLASH] = ACTIONS(5147),
    [anon_sym_STAR_STAR] = ACTIONS(5149),
    [anon_sym_CARET] = ACTIONS(5149),
    [aux_sym_binary_operator_token1] = ACTIONS(5151),
    [anon_sym_PIPE_GT] = ACTIONS(5151),
    [anon_sym_COLON] = ACTIONS(5153),
    [anon_sym_DOLLAR] = ACTIONS(5155),
    [anon_sym_AT] = ACTIONS(5155),
    [aux_sym__hex_literal_token1] = ACTIONS(5413),
    [sym__number_literal] = ACTIONS(5415),
    [anon_sym_SQUOTE] = ACTIONS(5413),
    [anon_sym_DQUOTE] = ACTIONS(5413),
    [sym_return] = ACTIONS(5415),
    [sym_next] = ACTIONS(5415),
    [sym_break] = ACTIONS(5415),
    [sym_true] = ACTIONS(5415),
    [sym_false] = ACTIONS(5415),
    [sym_null] = ACTIONS(5415),
    [sym_inf] = ACTIONS(5415),
    [sym_nan] = ACTIONS(5415),
    [anon_sym_NA] = ACTIONS(5415),
    [anon_sym_NA_integer_] = ACTIONS(5415),
    [anon_sym_NA_real_] = ACTIONS(5415),
    [anon_sym_NA_complex_] = ACTIONS(5415),
    [anon_sym_NA_character_] = ACTIONS(5415),
    [sym_dots] = ACTIONS(5415),
    [sym_dot_dot_i] = ACTIONS(5413),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5413),
    [sym__newline] = ACTIONS(5413),
    [sym__semicolon] = ACTIONS(5413),
    [sym__raw_string_literal] = ACTIONS(5413),
    [sym__external_else] = ACTIONS(5413),
    [sym__external_open_parenthesis] = ACTIONS(5159),
    [sym__external_close_parenthesis] = ACTIONS(5413),
    [sym__external_open_brace] = ACTIONS(5413),
    [sym__external_close_brace] = ACTIONS(5413),
    [sym__external_open_bracket] = ACTIONS(5161),
    [sym__external_close_bracket] = ACTIONS(5413),
    [sym__external_open_bracket2] = ACTIONS(5163),
  },
  [604] = {
    [sym_call_arguments] = STATE(2555),
    [sym_subset_arguments] = STATE(2554),
    [sym_subset2_arguments] = STATE(2553),
    [sym__else] = STATE(4165),
    [sym__open_parenthesis] = STATE(1332),
    [sym__open_bracket] = STATE(1331),
    [sym__open_bracket2] = STATE(1330),
    [sym_identifier] = ACTIONS(5065),
    [anon_sym_BSLASH] = ACTIONS(5067),
    [anon_sym_function] = ACTIONS(5065),
    [anon_sym_EQ] = ACTIONS(5265),
    [anon_sym_if] = ACTIONS(5065),
    [anon_sym_for] = ACTIONS(5065),
    [anon_sym_while] = ACTIONS(5065),
    [anon_sym_repeat] = ACTIONS(5065),
    [anon_sym_QMARK] = ACTIONS(5067),
    [anon_sym_TILDE] = ACTIONS(5267),
    [anon_sym_BANG] = ACTIONS(5065),
    [anon_sym_PLUS] = ACTIONS(5269),
    [anon_sym_DASH] = ACTIONS(5271),
    [anon_sym_LT_DASH] = ACTIONS(5273),
    [anon_sym_LT_LT_DASH] = ACTIONS(5273),
    [anon_sym_COLON_EQ] = ACTIONS(5273),
    [anon_sym_DASH_GT] = ACTIONS(5275),
    [anon_sym_DASH_GT_GT] = ACTIONS(5277),
    [anon_sym_PIPE] = ACTIONS(5279),
    [anon_sym_AMP] = ACTIONS(5281),
    [anon_sym_PIPE_PIPE] = ACTIONS(5283),
    [anon_sym_AMP_AMP] = ACTIONS(5285),
    [anon_sym_LT] = ACTIONS(5287),
    [anon_sym_LT_EQ] = ACTIONS(5289),
    [anon_sym_GT] = ACTIONS(5287),
    [anon_sym_GT_EQ] = ACTIONS(5289),
    [anon_sym_EQ_EQ] = ACTIONS(5289),
    [anon_sym_BANG_EQ] = ACTIONS(5289),
    [anon_sym_STAR] = ACTIONS(5291),
    [anon_sym_SLASH] = ACTIONS(5293),
    [anon_sym_STAR_STAR] = ACTIONS(5295),
    [anon_sym_CARET] = ACTIONS(5295),
    [aux_sym_binary_operator_token1] = ACTIONS(5297),
    [anon_sym_PIPE_GT] = ACTIONS(5297),
    [anon_sym_COLON] = ACTIONS(5299),
    [anon_sym_DOLLAR] = ACTIONS(5301),
    [anon_sym_AT] = ACTIONS(5301),
    [aux_sym__hex_literal_token1] = ACTIONS(5067),
    [sym__number_literal] = ACTIONS(5065),
    [anon_sym_SQUOTE] = ACTIONS(5067),
    [anon_sym_DQUOTE] = ACTIONS(5067),
    [sym_return] = ACTIONS(5065),
    [sym_next] = ACTIONS(5065),
    [sym_break] = ACTIONS(5065),
    [sym_true] = ACTIONS(5065),
    [sym_false] = ACTIONS(5065),
    [sym_null] = ACTIONS(5065),
    [sym_inf] = ACTIONS(5065),
    [sym_nan] = ACTIONS(5065),
    [anon_sym_NA] = ACTIONS(5065),
    [anon_sym_NA_integer_] = ACTIONS(5065),
    [anon_sym_NA_real_] = ACTIONS(5065),
    [anon_sym_NA_complex_] = ACTIONS(5065),
    [anon_sym_NA_character_] = ACTIONS(5065),
    [sym_dots] = ACTIONS(5065),
    [sym_dot_dot_i] = ACTIONS(5067),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5067),
    [sym__newline] = ACTIONS(5067),
    [sym__semicolon] = ACTIONS(5067),
    [sym__raw_string_literal] = ACTIONS(5067),
    [sym__external_else] = ACTIONS(5459),
    [sym__external_open_parenthesis] = ACTIONS(5305),
    [sym__external_open_brace] = ACTIONS(5067),
    [sym__external_close_brace] = ACTIONS(5067),
    [sym__external_open_bracket] = ACTIONS(5307),
    [sym__external_open_bracket2] = ACTIONS(5309),
    [sym__external_close_bracket2] = ACTIONS(5067),
  },
  [605] = {
    [sym_call_arguments] = STATE(2318),
    [sym_subset_arguments] = STATE(2319),
    [sym_subset2_arguments] = STATE(2320),
    [sym__open_parenthesis] = STATE(1329),
    [sym__open_bracket] = STATE(1328),
    [sym__open_bracket2] = STATE(1327),
    [sym_identifier] = ACTIONS(5423),
    [anon_sym_BSLASH] = ACTIONS(5421),
    [anon_sym_function] = ACTIONS(5423),
    [anon_sym_EQ] = ACTIONS(5119),
    [anon_sym_if] = ACTIONS(5423),
    [anon_sym_for] = ACTIONS(5423),
    [anon_sym_while] = ACTIONS(5423),
    [anon_sym_repeat] = ACTIONS(5423),
    [anon_sym_QMARK] = ACTIONS(5421),
    [anon_sym_TILDE] = ACTIONS(5121),
    [anon_sym_BANG] = ACTIONS(5423),
    [anon_sym_PLUS] = ACTIONS(5123),
    [anon_sym_DASH] = ACTIONS(5125),
    [anon_sym_LT_DASH] = ACTIONS(5127),
    [anon_sym_LT_LT_DASH] = ACTIONS(5127),
    [anon_sym_COLON_EQ] = ACTIONS(5127),
    [anon_sym_DASH_GT] = ACTIONS(5129),
    [anon_sym_DASH_GT_GT] = ACTIONS(5131),
    [anon_sym_PIPE] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5135),
    [anon_sym_PIPE_PIPE] = ACTIONS(5137),
    [anon_sym_AMP_AMP] = ACTIONS(5139),
    [anon_sym_LT] = ACTIONS(5141),
    [anon_sym_LT_EQ] = ACTIONS(5143),
    [anon_sym_GT] = ACTIONS(5141),
    [anon_sym_GT_EQ] = ACTIONS(5143),
    [anon_sym_EQ_EQ] = ACTIONS(5143),
    [anon_sym_BANG_EQ] = ACTIONS(5143),
    [anon_sym_STAR] = ACTIONS(5145),
    [anon_sym_SLASH] = ACTIONS(5147),
    [anon_sym_STAR_STAR] = ACTIONS(5149),
    [anon_sym_CARET] = ACTIONS(5149),
    [aux_sym_binary_operator_token1] = ACTIONS(5151),
    [anon_sym_PIPE_GT] = ACTIONS(5151),
    [anon_sym_COLON] = ACTIONS(5153),
    [anon_sym_DOLLAR] = ACTIONS(5155),
    [anon_sym_AT] = ACTIONS(5155),
    [aux_sym__hex_literal_token1] = ACTIONS(5421),
    [sym__number_literal] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5421),
    [anon_sym_DQUOTE] = ACTIONS(5421),
    [sym_return] = ACTIONS(5423),
    [sym_next] = ACTIONS(5423),
    [sym_break] = ACTIONS(5423),
    [sym_true] = ACTIONS(5423),
    [sym_false] = ACTIONS(5423),
    [sym_null] = ACTIONS(5423),
    [sym_inf] = ACTIONS(5423),
    [sym_nan] = ACTIONS(5423),
    [anon_sym_NA] = ACTIONS(5423),
    [anon_sym_NA_integer_] = ACTIONS(5423),
    [anon_sym_NA_real_] = ACTIONS(5423),
    [anon_sym_NA_complex_] = ACTIONS(5423),
    [anon_sym_NA_character_] = ACTIONS(5423),
    [sym_dots] = ACTIONS(5423),
    [sym_dot_dot_i] = ACTIONS(5421),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5421),
    [sym__newline] = ACTIONS(5421),
    [sym__semicolon] = ACTIONS(5421),
    [sym__raw_string_literal] = ACTIONS(5421),
    [sym__external_else] = ACTIONS(5421),
    [sym__external_open_parenthesis] = ACTIONS(5159),
    [sym__external_close_parenthesis] = ACTIONS(5421),
    [sym__external_open_brace] = ACTIONS(5421),
    [sym__external_close_brace] = ACTIONS(5421),
    [sym__external_open_bracket] = ACTIONS(5161),
    [sym__external_close_bracket] = ACTIONS(5421),
    [sym__external_open_bracket2] = ACTIONS(5163),
  },
  [606] = {
    [sym_call_arguments] = STATE(2318),
    [sym_subset_arguments] = STATE(2319),
    [sym_subset2_arguments] = STATE(2320),
    [sym__open_parenthesis] = STATE(1329),
    [sym__open_bracket] = STATE(1328),
    [sym__open_bracket2] = STATE(1327),
    [sym_identifier] = ACTIONS(5427),
    [anon_sym_BSLASH] = ACTIONS(5425),
    [anon_sym_function] = ACTIONS(5427),
    [anon_sym_EQ] = ACTIONS(5119),
    [anon_sym_if] = ACTIONS(5427),
    [anon_sym_for] = ACTIONS(5427),
    [anon_sym_while] = ACTIONS(5427),
    [anon_sym_repeat] = ACTIONS(5427),
    [anon_sym_QMARK] = ACTIONS(5425),
    [anon_sym_TILDE] = ACTIONS(5121),
    [anon_sym_BANG] = ACTIONS(5427),
    [anon_sym_PLUS] = ACTIONS(5123),
    [anon_sym_DASH] = ACTIONS(5125),
    [anon_sym_LT_DASH] = ACTIONS(5127),
    [anon_sym_LT_LT_DASH] = ACTIONS(5127),
    [anon_sym_COLON_EQ] = ACTIONS(5127),
    [anon_sym_DASH_GT] = ACTIONS(5129),
    [anon_sym_DASH_GT_GT] = ACTIONS(5131),
    [anon_sym_PIPE] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5135),
    [anon_sym_PIPE_PIPE] = ACTIONS(5137),
    [anon_sym_AMP_AMP] = ACTIONS(5139),
    [anon_sym_LT] = ACTIONS(5141),
    [anon_sym_LT_EQ] = ACTIONS(5143),
    [anon_sym_GT] = ACTIONS(5141),
    [anon_sym_GT_EQ] = ACTIONS(5143),
    [anon_sym_EQ_EQ] = ACTIONS(5143),
    [anon_sym_BANG_EQ] = ACTIONS(5143),
    [anon_sym_STAR] = ACTIONS(5145),
    [anon_sym_SLASH] = ACTIONS(5147),
    [anon_sym_STAR_STAR] = ACTIONS(5149),
    [anon_sym_CARET] = ACTIONS(5149),
    [aux_sym_binary_operator_token1] = ACTIONS(5151),
    [anon_sym_PIPE_GT] = ACTIONS(5151),
    [anon_sym_COLON] = ACTIONS(5153),
    [anon_sym_DOLLAR] = ACTIONS(5155),
    [anon_sym_AT] = ACTIONS(5155),
    [aux_sym__hex_literal_token1] = ACTIONS(5425),
    [sym__number_literal] = ACTIONS(5427),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_DQUOTE] = ACTIONS(5425),
    [sym_return] = ACTIONS(5427),
    [sym_next] = ACTIONS(5427),
    [sym_break] = ACTIONS(5427),
    [sym_true] = ACTIONS(5427),
    [sym_false] = ACTIONS(5427),
    [sym_null] = ACTIONS(5427),
    [sym_inf] = ACTIONS(5427),
    [sym_nan] = ACTIONS(5427),
    [anon_sym_NA] = ACTIONS(5427),
    [anon_sym_NA_integer_] = ACTIONS(5427),
    [anon_sym_NA_real_] = ACTIONS(5427),
    [anon_sym_NA_complex_] = ACTIONS(5427),
    [anon_sym_NA_character_] = ACTIONS(5427),
    [sym_dots] = ACTIONS(5427),
    [sym_dot_dot_i] = ACTIONS(5425),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5425),
    [sym__newline] = ACTIONS(5425),
    [sym__semicolon] = ACTIONS(5425),
    [sym__raw_string_literal] = ACTIONS(5425),
    [sym__external_else] = ACTIONS(5425),
    [sym__external_open_parenthesis] = ACTIONS(5159),
    [sym__external_close_parenthesis] = ACTIONS(5425),
    [sym__external_open_brace] = ACTIONS(5425),
    [sym__external_close_brace] = ACTIONS(5425),
    [sym__external_open_bracket] = ACTIONS(5161),
    [sym__external_close_bracket] = ACTIONS(5425),
    [sym__external_open_bracket2] = ACTIONS(5163),
  },
  [607] = {
    [sym_call_arguments] = STATE(2318),
    [sym_subset_arguments] = STATE(2319),
    [sym_subset2_arguments] = STATE(2320),
    [sym__open_parenthesis] = STATE(1329),
    [sym__open_bracket] = STATE(1328),
    [sym__open_bracket2] = STATE(1327),
    [sym_identifier] = ACTIONS(5431),
    [anon_sym_BSLASH] = ACTIONS(5429),
    [anon_sym_function] = ACTIONS(5431),
    [anon_sym_EQ] = ACTIONS(5119),
    [anon_sym_if] = ACTIONS(5431),
    [anon_sym_for] = ACTIONS(5431),
    [anon_sym_while] = ACTIONS(5431),
    [anon_sym_repeat] = ACTIONS(5431),
    [anon_sym_QMARK] = ACTIONS(5429),
    [anon_sym_TILDE] = ACTIONS(5121),
    [anon_sym_BANG] = ACTIONS(5431),
    [anon_sym_PLUS] = ACTIONS(5123),
    [anon_sym_DASH] = ACTIONS(5125),
    [anon_sym_LT_DASH] = ACTIONS(5127),
    [anon_sym_LT_LT_DASH] = ACTIONS(5127),
    [anon_sym_COLON_EQ] = ACTIONS(5127),
    [anon_sym_DASH_GT] = ACTIONS(5129),
    [anon_sym_DASH_GT_GT] = ACTIONS(5131),
    [anon_sym_PIPE] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5135),
    [anon_sym_PIPE_PIPE] = ACTIONS(5137),
    [anon_sym_AMP_AMP] = ACTIONS(5139),
    [anon_sym_LT] = ACTIONS(5141),
    [anon_sym_LT_EQ] = ACTIONS(5143),
    [anon_sym_GT] = ACTIONS(5141),
    [anon_sym_GT_EQ] = ACTIONS(5143),
    [anon_sym_EQ_EQ] = ACTIONS(5143),
    [anon_sym_BANG_EQ] = ACTIONS(5143),
    [anon_sym_STAR] = ACTIONS(5145),
    [anon_sym_SLASH] = ACTIONS(5147),
    [anon_sym_STAR_STAR] = ACTIONS(5149),
    [anon_sym_CARET] = ACTIONS(5149),
    [aux_sym_binary_operator_token1] = ACTIONS(5151),
    [anon_sym_PIPE_GT] = ACTIONS(5151),
    [anon_sym_COLON] = ACTIONS(5153),
    [anon_sym_DOLLAR] = ACTIONS(5155),
    [anon_sym_AT] = ACTIONS(5155),
    [aux_sym__hex_literal_token1] = ACTIONS(5429),
    [sym__number_literal] = ACTIONS(5431),
    [anon_sym_SQUOTE] = ACTIONS(5429),
    [anon_sym_DQUOTE] = ACTIONS(5429),
    [sym_return] = ACTIONS(5431),
    [sym_next] = ACTIONS(5431),
    [sym_break] = ACTIONS(5431),
    [sym_true] = ACTIONS(5431),
    [sym_false] = ACTIONS(5431),
    [sym_null] = ACTIONS(5431),
    [sym_inf] = ACTIONS(5431),
    [sym_nan] = ACTIONS(5431),
    [anon_sym_NA] = ACTIONS(5431),
    [anon_sym_NA_integer_] = ACTIONS(5431),
    [anon_sym_NA_real_] = ACTIONS(5431),
    [anon_sym_NA_complex_] = ACTIONS(5431),
    [anon_sym_NA_character_] = ACTIONS(5431),
    [sym_dots] = ACTIONS(5431),
    [sym_dot_dot_i] = ACTIONS(5429),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5429),
    [sym__newline] = ACTIONS(5429),
    [sym__semicolon] = ACTIONS(5429),
    [sym__raw_string_literal] = ACTIONS(5429),
    [sym__external_else] = ACTIONS(5429),
    [sym__external_open_parenthesis] = ACTIONS(5159),
    [sym__external_close_parenthesis] = ACTIONS(5429),
    [sym__external_open_brace] = ACTIONS(5429),
    [sym__external_close_brace] = ACTIONS(5429),
    [sym__external_open_bracket] = ACTIONS(5161),
    [sym__external_close_bracket] = ACTIONS(5429),
    [sym__external_open_bracket2] = ACTIONS(5163),
  },
  [608] = {
    [sym_call_arguments] = STATE(2318),
    [sym_subset_arguments] = STATE(2319),
    [sym_subset2_arguments] = STATE(2320),
    [sym__open_parenthesis] = STATE(1329),
    [sym__open_bracket] = STATE(1328),
    [sym__open_bracket2] = STATE(1327),
    [sym_identifier] = ACTIONS(5435),
    [anon_sym_BSLASH] = ACTIONS(5433),
    [anon_sym_function] = ACTIONS(5435),
    [anon_sym_EQ] = ACTIONS(5119),
    [anon_sym_if] = ACTIONS(5435),
    [anon_sym_for] = ACTIONS(5435),
    [anon_sym_while] = ACTIONS(5435),
    [anon_sym_repeat] = ACTIONS(5435),
    [anon_sym_QMARK] = ACTIONS(5433),
    [anon_sym_TILDE] = ACTIONS(5121),
    [anon_sym_BANG] = ACTIONS(5435),
    [anon_sym_PLUS] = ACTIONS(5123),
    [anon_sym_DASH] = ACTIONS(5125),
    [anon_sym_LT_DASH] = ACTIONS(5127),
    [anon_sym_LT_LT_DASH] = ACTIONS(5127),
    [anon_sym_COLON_EQ] = ACTIONS(5127),
    [anon_sym_DASH_GT] = ACTIONS(5129),
    [anon_sym_DASH_GT_GT] = ACTIONS(5131),
    [anon_sym_PIPE] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5135),
    [anon_sym_PIPE_PIPE] = ACTIONS(5137),
    [anon_sym_AMP_AMP] = ACTIONS(5139),
    [anon_sym_LT] = ACTIONS(5141),
    [anon_sym_LT_EQ] = ACTIONS(5143),
    [anon_sym_GT] = ACTIONS(5141),
    [anon_sym_GT_EQ] = ACTIONS(5143),
    [anon_sym_EQ_EQ] = ACTIONS(5143),
    [anon_sym_BANG_EQ] = ACTIONS(5143),
    [anon_sym_STAR] = ACTIONS(5145),
    [anon_sym_SLASH] = ACTIONS(5147),
    [anon_sym_STAR_STAR] = ACTIONS(5149),
    [anon_sym_CARET] = ACTIONS(5149),
    [aux_sym_binary_operator_token1] = ACTIONS(5151),
    [anon_sym_PIPE_GT] = ACTIONS(5151),
    [anon_sym_COLON] = ACTIONS(5153),
    [anon_sym_DOLLAR] = ACTIONS(5155),
    [anon_sym_AT] = ACTIONS(5155),
    [aux_sym__hex_literal_token1] = ACTIONS(5433),
    [sym__number_literal] = ACTIONS(5435),
    [anon_sym_SQUOTE] = ACTIONS(5433),
    [anon_sym_DQUOTE] = ACTIONS(5433),
    [sym_return] = ACTIONS(5435),
    [sym_next] = ACTIONS(5435),
    [sym_break] = ACTIONS(5435),
    [sym_true] = ACTIONS(5435),
    [sym_false] = ACTIONS(5435),
    [sym_null] = ACTIONS(5435),
    [sym_inf] = ACTIONS(5435),
    [sym_nan] = ACTIONS(5435),
    [anon_sym_NA] = ACTIONS(5435),
    [anon_sym_NA_integer_] = ACTIONS(5435),
    [anon_sym_NA_real_] = ACTIONS(5435),
    [anon_sym_NA_complex_] = ACTIONS(5435),
    [anon_sym_NA_character_] = ACTIONS(5435),
    [sym_dots] = ACTIONS(5435),
    [sym_dot_dot_i] = ACTIONS(5433),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5433),
    [sym__newline] = ACTIONS(5433),
    [sym__semicolon] = ACTIONS(5433),
    [sym__raw_string_literal] = ACTIONS(5433),
    [sym__external_else] = ACTIONS(5433),
    [sym__external_open_parenthesis] = ACTIONS(5159),
    [sym__external_close_parenthesis] = ACTIONS(5433),
    [sym__external_open_brace] = ACTIONS(5433),
    [sym__external_close_brace] = ACTIONS(5433),
    [sym__external_open_bracket] = ACTIONS(5161),
    [sym__external_close_bracket] = ACTIONS(5433),
    [sym__external_open_bracket2] = ACTIONS(5163),
  },
  [609] = {
    [sym_call_arguments] = STATE(2318),
    [sym_subset_arguments] = STATE(2319),
    [sym_subset2_arguments] = STATE(2320),
    [sym__open_parenthesis] = STATE(1329),
    [sym__open_bracket] = STATE(1328),
    [sym__open_bracket2] = STATE(1327),
    [sym_identifier] = ACTIONS(5439),
    [anon_sym_BSLASH] = ACTIONS(5437),
    [anon_sym_function] = ACTIONS(5439),
    [anon_sym_EQ] = ACTIONS(5119),
    [anon_sym_if] = ACTIONS(5439),
    [anon_sym_for] = ACTIONS(5439),
    [anon_sym_while] = ACTIONS(5439),
    [anon_sym_repeat] = ACTIONS(5439),
    [anon_sym_QMARK] = ACTIONS(5437),
    [anon_sym_TILDE] = ACTIONS(5121),
    [anon_sym_BANG] = ACTIONS(5439),
    [anon_sym_PLUS] = ACTIONS(5123),
    [anon_sym_DASH] = ACTIONS(5125),
    [anon_sym_LT_DASH] = ACTIONS(5127),
    [anon_sym_LT_LT_DASH] = ACTIONS(5127),
    [anon_sym_COLON_EQ] = ACTIONS(5127),
    [anon_sym_DASH_GT] = ACTIONS(5129),
    [anon_sym_DASH_GT_GT] = ACTIONS(5131),
    [anon_sym_PIPE] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5135),
    [anon_sym_PIPE_PIPE] = ACTIONS(5137),
    [anon_sym_AMP_AMP] = ACTIONS(5139),
    [anon_sym_LT] = ACTIONS(5141),
    [anon_sym_LT_EQ] = ACTIONS(5143),
    [anon_sym_GT] = ACTIONS(5141),
    [anon_sym_GT_EQ] = ACTIONS(5143),
    [anon_sym_EQ_EQ] = ACTIONS(5143),
    [anon_sym_BANG_EQ] = ACTIONS(5143),
    [anon_sym_STAR] = ACTIONS(5145),
    [anon_sym_SLASH] = ACTIONS(5147),
    [anon_sym_STAR_STAR] = ACTIONS(5149),
    [anon_sym_CARET] = ACTIONS(5149),
    [aux_sym_binary_operator_token1] = ACTIONS(5151),
    [anon_sym_PIPE_GT] = ACTIONS(5151),
    [anon_sym_COLON] = ACTIONS(5153),
    [anon_sym_DOLLAR] = ACTIONS(5155),
    [anon_sym_AT] = ACTIONS(5155),
    [aux_sym__hex_literal_token1] = ACTIONS(5437),
    [sym__number_literal] = ACTIONS(5439),
    [anon_sym_SQUOTE] = ACTIONS(5437),
    [anon_sym_DQUOTE] = ACTIONS(5437),
    [sym_return] = ACTIONS(5439),
    [sym_next] = ACTIONS(5439),
    [sym_break] = ACTIONS(5439),
    [sym_true] = ACTIONS(5439),
    [sym_false] = ACTIONS(5439),
    [sym_null] = ACTIONS(5439),
    [sym_inf] = ACTIONS(5439),
    [sym_nan] = ACTIONS(5439),
    [anon_sym_NA] = ACTIONS(5439),
    [anon_sym_NA_integer_] = ACTIONS(5439),
    [anon_sym_NA_real_] = ACTIONS(5439),
    [anon_sym_NA_complex_] = ACTIONS(5439),
    [anon_sym_NA_character_] = ACTIONS(5439),
    [sym_dots] = ACTIONS(5439),
    [sym_dot_dot_i] = ACTIONS(5437),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5437),
    [sym__newline] = ACTIONS(5437),
    [sym__semicolon] = ACTIONS(5437),
    [sym__raw_string_literal] = ACTIONS(5437),
    [sym__external_else] = ACTIONS(5437),
    [sym__external_open_parenthesis] = ACTIONS(5159),
    [sym__external_close_parenthesis] = ACTIONS(5437),
    [sym__external_open_brace] = ACTIONS(5437),
    [sym__external_close_brace] = ACTIONS(5437),
    [sym__external_open_bracket] = ACTIONS(5161),
    [sym__external_close_bracket] = ACTIONS(5437),
    [sym__external_open_bracket2] = ACTIONS(5163),
  },
  [610] = {
    [sym_call_arguments] = STATE(2318),
    [sym_subset_arguments] = STATE(2319),
    [sym_subset2_arguments] = STATE(2320),
    [sym__open_parenthesis] = STATE(1329),
    [sym__open_bracket] = STATE(1328),
    [sym__open_bracket2] = STATE(1327),
    [sym_identifier] = ACTIONS(5443),
    [anon_sym_BSLASH] = ACTIONS(5441),
    [anon_sym_function] = ACTIONS(5443),
    [anon_sym_EQ] = ACTIONS(5119),
    [anon_sym_if] = ACTIONS(5443),
    [anon_sym_for] = ACTIONS(5443),
    [anon_sym_while] = ACTIONS(5443),
    [anon_sym_repeat] = ACTIONS(5443),
    [anon_sym_QMARK] = ACTIONS(5441),
    [anon_sym_TILDE] = ACTIONS(5121),
    [anon_sym_BANG] = ACTIONS(5443),
    [anon_sym_PLUS] = ACTIONS(5123),
    [anon_sym_DASH] = ACTIONS(5125),
    [anon_sym_LT_DASH] = ACTIONS(5127),
    [anon_sym_LT_LT_DASH] = ACTIONS(5127),
    [anon_sym_COLON_EQ] = ACTIONS(5127),
    [anon_sym_DASH_GT] = ACTIONS(5129),
    [anon_sym_DASH_GT_GT] = ACTIONS(5131),
    [anon_sym_PIPE] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5135),
    [anon_sym_PIPE_PIPE] = ACTIONS(5137),
    [anon_sym_AMP_AMP] = ACTIONS(5139),
    [anon_sym_LT] = ACTIONS(5141),
    [anon_sym_LT_EQ] = ACTIONS(5143),
    [anon_sym_GT] = ACTIONS(5141),
    [anon_sym_GT_EQ] = ACTIONS(5143),
    [anon_sym_EQ_EQ] = ACTIONS(5143),
    [anon_sym_BANG_EQ] = ACTIONS(5143),
    [anon_sym_STAR] = ACTIONS(5145),
    [anon_sym_SLASH] = ACTIONS(5147),
    [anon_sym_STAR_STAR] = ACTIONS(5149),
    [anon_sym_CARET] = ACTIONS(5149),
    [aux_sym_binary_operator_token1] = ACTIONS(5151),
    [anon_sym_PIPE_GT] = ACTIONS(5151),
    [anon_sym_COLON] = ACTIONS(5153),
    [anon_sym_DOLLAR] = ACTIONS(5155),
    [anon_sym_AT] = ACTIONS(5155),
    [aux_sym__hex_literal_token1] = ACTIONS(5441),
    [sym__number_literal] = ACTIONS(5443),
    [anon_sym_SQUOTE] = ACTIONS(5441),
    [anon_sym_DQUOTE] = ACTIONS(5441),
    [sym_return] = ACTIONS(5443),
    [sym_next] = ACTIONS(5443),
    [sym_break] = ACTIONS(5443),
    [sym_true] = ACTIONS(5443),
    [sym_false] = ACTIONS(5443),
    [sym_null] = ACTIONS(5443),
    [sym_inf] = ACTIONS(5443),
    [sym_nan] = ACTIONS(5443),
    [anon_sym_NA] = ACTIONS(5443),
    [anon_sym_NA_integer_] = ACTIONS(5443),
    [anon_sym_NA_real_] = ACTIONS(5443),
    [anon_sym_NA_complex_] = ACTIONS(5443),
    [anon_sym_NA_character_] = ACTIONS(5443),
    [sym_dots] = ACTIONS(5443),
    [sym_dot_dot_i] = ACTIONS(5441),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5441),
    [sym__newline] = ACTIONS(5441),
    [sym__semicolon] = ACTIONS(5441),
    [sym__raw_string_literal] = ACTIONS(5441),
    [sym__external_else] = ACTIONS(5441),
    [sym__external_open_parenthesis] = ACTIONS(5159),
    [sym__external_close_parenthesis] = ACTIONS(5441),
    [sym__external_open_brace] = ACTIONS(5441),
    [sym__external_close_brace] = ACTIONS(5441),
    [sym__external_open_bracket] = ACTIONS(5161),
    [sym__external_close_bracket] = ACTIONS(5441),
    [sym__external_open_bracket2] = ACTIONS(5163),
  },
  [611] = {
    [sym_call_arguments] = STATE(2318),
    [sym_subset_arguments] = STATE(2319),
    [sym_subset2_arguments] = STATE(2320),
    [sym__open_parenthesis] = STATE(1329),
    [sym__open_bracket] = STATE(1328),
    [sym__open_bracket2] = STATE(1327),
    [sym_identifier] = ACTIONS(5447),
    [anon_sym_BSLASH] = ACTIONS(5445),
    [anon_sym_function] = ACTIONS(5447),
    [anon_sym_EQ] = ACTIONS(5119),
    [anon_sym_if] = ACTIONS(5447),
    [anon_sym_for] = ACTIONS(5447),
    [anon_sym_while] = ACTIONS(5447),
    [anon_sym_repeat] = ACTIONS(5447),
    [anon_sym_QMARK] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(5121),
    [anon_sym_BANG] = ACTIONS(5447),
    [anon_sym_PLUS] = ACTIONS(5123),
    [anon_sym_DASH] = ACTIONS(5125),
    [anon_sym_LT_DASH] = ACTIONS(5127),
    [anon_sym_LT_LT_DASH] = ACTIONS(5127),
    [anon_sym_COLON_EQ] = ACTIONS(5127),
    [anon_sym_DASH_GT] = ACTIONS(5129),
    [anon_sym_DASH_GT_GT] = ACTIONS(5131),
    [anon_sym_PIPE] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5135),
    [anon_sym_PIPE_PIPE] = ACTIONS(5137),
    [anon_sym_AMP_AMP] = ACTIONS(5139),
    [anon_sym_LT] = ACTIONS(5141),
    [anon_sym_LT_EQ] = ACTIONS(5143),
    [anon_sym_GT] = ACTIONS(5141),
    [anon_sym_GT_EQ] = ACTIONS(5143),
    [anon_sym_EQ_EQ] = ACTIONS(5143),
    [anon_sym_BANG_EQ] = ACTIONS(5143),
    [anon_sym_STAR] = ACTIONS(5145),
    [anon_sym_SLASH] = ACTIONS(5147),
    [anon_sym_STAR_STAR] = ACTIONS(5149),
    [anon_sym_CARET] = ACTIONS(5149),
    [aux_sym_binary_operator_token1] = ACTIONS(5151),
    [anon_sym_PIPE_GT] = ACTIONS(5151),
    [anon_sym_COLON] = ACTIONS(5153),
    [anon_sym_DOLLAR] = ACTIONS(5155),
    [anon_sym_AT] = ACTIONS(5155),
    [aux_sym__hex_literal_token1] = ACTIONS(5445),
    [sym__number_literal] = ACTIONS(5447),
    [anon_sym_SQUOTE] = ACTIONS(5445),
    [anon_sym_DQUOTE] = ACTIONS(5445),
    [sym_return] = ACTIONS(5447),
    [sym_next] = ACTIONS(5447),
    [sym_break] = ACTIONS(5447),
    [sym_true] = ACTIONS(5447),
    [sym_false] = ACTIONS(5447),
    [sym_null] = ACTIONS(5447),
    [sym_inf] = ACTIONS(5447),
    [sym_nan] = ACTIONS(5447),
    [anon_sym_NA] = ACTIONS(5447),
    [anon_sym_NA_integer_] = ACTIONS(5447),
    [anon_sym_NA_real_] = ACTIONS(5447),
    [anon_sym_NA_complex_] = ACTIONS(5447),
    [anon_sym_NA_character_] = ACTIONS(5447),
    [sym_dots] = ACTIONS(5447),
    [sym_dot_dot_i] = ACTIONS(5445),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5445),
    [sym__newline] = ACTIONS(5445),
    [sym__semicolon] = ACTIONS(5445),
    [sym__raw_string_literal] = ACTIONS(5445),
    [sym__external_else] = ACTIONS(5445),
    [sym__external_open_parenthesis] = ACTIONS(5159),
    [sym__external_close_parenthesis] = ACTIONS(5445),
    [sym__external_open_brace] = ACTIONS(5445),
    [sym__external_close_brace] = ACTIONS(5445),
    [sym__external_open_bracket] = ACTIONS(5161),
    [sym__external_close_bracket] = ACTIONS(5445),
    [sym__external_open_bracket2] = ACTIONS(5163),
  },
  [612] = {
    [sym_call_arguments] = STATE(2318),
    [sym_subset_arguments] = STATE(2319),
    [sym_subset2_arguments] = STATE(2320),
    [sym__open_parenthesis] = STATE(1329),
    [sym__open_bracket] = STATE(1328),
    [sym__open_bracket2] = STATE(1327),
    [sym_identifier] = ACTIONS(5451),
    [anon_sym_BSLASH] = ACTIONS(5449),
    [anon_sym_function] = ACTIONS(5451),
    [anon_sym_EQ] = ACTIONS(5119),
    [anon_sym_if] = ACTIONS(5451),
    [anon_sym_for] = ACTIONS(5451),
    [anon_sym_while] = ACTIONS(5451),
    [anon_sym_repeat] = ACTIONS(5451),
    [anon_sym_QMARK] = ACTIONS(5449),
    [anon_sym_TILDE] = ACTIONS(5121),
    [anon_sym_BANG] = ACTIONS(5451),
    [anon_sym_PLUS] = ACTIONS(5123),
    [anon_sym_DASH] = ACTIONS(5125),
    [anon_sym_LT_DASH] = ACTIONS(5127),
    [anon_sym_LT_LT_DASH] = ACTIONS(5127),
    [anon_sym_COLON_EQ] = ACTIONS(5127),
    [anon_sym_DASH_GT] = ACTIONS(5129),
    [anon_sym_DASH_GT_GT] = ACTIONS(5131),
    [anon_sym_PIPE] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5135),
    [anon_sym_PIPE_PIPE] = ACTIONS(5137),
    [anon_sym_AMP_AMP] = ACTIONS(5139),
    [anon_sym_LT] = ACTIONS(5141),
    [anon_sym_LT_EQ] = ACTIONS(5143),
    [anon_sym_GT] = ACTIONS(5141),
    [anon_sym_GT_EQ] = ACTIONS(5143),
    [anon_sym_EQ_EQ] = ACTIONS(5143),
    [anon_sym_BANG_EQ] = ACTIONS(5143),
    [anon_sym_STAR] = ACTIONS(5145),
    [anon_sym_SLASH] = ACTIONS(5147),
    [anon_sym_STAR_STAR] = ACTIONS(5149),
    [anon_sym_CARET] = ACTIONS(5149),
    [aux_sym_binary_operator_token1] = ACTIONS(5151),
    [anon_sym_PIPE_GT] = ACTIONS(5151),
    [anon_sym_COLON] = ACTIONS(5153),
    [anon_sym_DOLLAR] = ACTIONS(5155),
    [anon_sym_AT] = ACTIONS(5155),
    [aux_sym__hex_literal_token1] = ACTIONS(5449),
    [sym__number_literal] = ACTIONS(5451),
    [anon_sym_SQUOTE] = ACTIONS(5449),
    [anon_sym_DQUOTE] = ACTIONS(5449),
    [sym_return] = ACTIONS(5451),
    [sym_next] = ACTIONS(5451),
    [sym_break] = ACTIONS(5451),
    [sym_true] = ACTIONS(5451),
    [sym_false] = ACTIONS(5451),
    [sym_null] = ACTIONS(5451),
    [sym_inf] = ACTIONS(5451),
    [sym_nan] = ACTIONS(5451),
    [anon_sym_NA] = ACTIONS(5451),
    [anon_sym_NA_integer_] = ACTIONS(5451),
    [anon_sym_NA_real_] = ACTIONS(5451),
    [anon_sym_NA_complex_] = ACTIONS(5451),
    [anon_sym_NA_character_] = ACTIONS(5451),
    [sym_dots] = ACTIONS(5451),
    [sym_dot_dot_i] = ACTIONS(5449),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5449),
    [sym__newline] = ACTIONS(5449),
    [sym__semicolon] = ACTIONS(5449),
    [sym__raw_string_literal] = ACTIONS(5449),
    [sym__external_else] = ACTIONS(5449),
    [sym__external_open_parenthesis] = ACTIONS(5159),
    [sym__external_close_parenthesis] = ACTIONS(5449),
    [sym__external_open_brace] = ACTIONS(5449),
    [sym__external_close_brace] = ACTIONS(5449),
    [sym__external_open_bracket] = ACTIONS(5161),
    [sym__external_close_bracket] = ACTIONS(5449),
    [sym__external_open_bracket2] = ACTIONS(5163),
  },
  [613] = {
    [sym_call_arguments] = STATE(2318),
    [sym_subset_arguments] = STATE(2319),
    [sym_subset2_arguments] = STATE(2320),
    [sym__open_parenthesis] = STATE(1329),
    [sym__open_bracket] = STATE(1328),
    [sym__open_bracket2] = STATE(1327),
    [sym_identifier] = ACTIONS(5455),
    [anon_sym_BSLASH] = ACTIONS(5453),
    [anon_sym_function] = ACTIONS(5455),
    [anon_sym_EQ] = ACTIONS(5119),
    [anon_sym_if] = ACTIONS(5455),
    [anon_sym_for] = ACTIONS(5455),
    [anon_sym_while] = ACTIONS(5455),
    [anon_sym_repeat] = ACTIONS(5455),
    [anon_sym_QMARK] = ACTIONS(5453),
    [anon_sym_TILDE] = ACTIONS(5121),
    [anon_sym_BANG] = ACTIONS(5455),
    [anon_sym_PLUS] = ACTIONS(5123),
    [anon_sym_DASH] = ACTIONS(5125),
    [anon_sym_LT_DASH] = ACTIONS(5127),
    [anon_sym_LT_LT_DASH] = ACTIONS(5127),
    [anon_sym_COLON_EQ] = ACTIONS(5127),
    [anon_sym_DASH_GT] = ACTIONS(5129),
    [anon_sym_DASH_GT_GT] = ACTIONS(5131),
    [anon_sym_PIPE] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5135),
    [anon_sym_PIPE_PIPE] = ACTIONS(5137),
    [anon_sym_AMP_AMP] = ACTIONS(5139),
    [anon_sym_LT] = ACTIONS(5141),
    [anon_sym_LT_EQ] = ACTIONS(5143),
    [anon_sym_GT] = ACTIONS(5141),
    [anon_sym_GT_EQ] = ACTIONS(5143),
    [anon_sym_EQ_EQ] = ACTIONS(5143),
    [anon_sym_BANG_EQ] = ACTIONS(5143),
    [anon_sym_STAR] = ACTIONS(5145),
    [anon_sym_SLASH] = ACTIONS(5147),
    [anon_sym_STAR_STAR] = ACTIONS(5149),
    [anon_sym_CARET] = ACTIONS(5149),
    [aux_sym_binary_operator_token1] = ACTIONS(5151),
    [anon_sym_PIPE_GT] = ACTIONS(5151),
    [anon_sym_COLON] = ACTIONS(5153),
    [anon_sym_DOLLAR] = ACTIONS(5155),
    [anon_sym_AT] = ACTIONS(5155),
    [aux_sym__hex_literal_token1] = ACTIONS(5453),
    [sym__number_literal] = ACTIONS(5455),
    [anon_sym_SQUOTE] = ACTIONS(5453),
    [anon_sym_DQUOTE] = ACTIONS(5453),
    [sym_return] = ACTIONS(5455),
    [sym_next] = ACTIONS(5455),
    [sym_break] = ACTIONS(5455),
    [sym_true] = ACTIONS(5455),
    [sym_false] = ACTIONS(5455),
    [sym_null] = ACTIONS(5455),
    [sym_inf] = ACTIONS(5455),
    [sym_nan] = ACTIONS(5455),
    [anon_sym_NA] = ACTIONS(5455),
    [anon_sym_NA_integer_] = ACTIONS(5455),
    [anon_sym_NA_real_] = ACTIONS(5455),
    [anon_sym_NA_complex_] = ACTIONS(5455),
    [anon_sym_NA_character_] = ACTIONS(5455),
    [sym_dots] = ACTIONS(5455),
    [sym_dot_dot_i] = ACTIONS(5453),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5453),
    [sym__newline] = ACTIONS(5453),
    [sym__semicolon] = ACTIONS(5453),
    [sym__raw_string_literal] = ACTIONS(5453),
    [sym__external_else] = ACTIONS(5453),
    [sym__external_open_parenthesis] = ACTIONS(5159),
    [sym__external_close_parenthesis] = ACTIONS(5453),
    [sym__external_open_brace] = ACTIONS(5453),
    [sym__external_close_brace] = ACTIONS(5453),
    [sym__external_open_bracket] = ACTIONS(5161),
    [sym__external_close_bracket] = ACTIONS(5453),
    [sym__external_open_bracket2] = ACTIONS(5163),
  },
  [614] = {
    [sym_call_arguments] = STATE(2318),
    [sym_subset_arguments] = STATE(2319),
    [sym_subset2_arguments] = STATE(2320),
    [sym__open_parenthesis] = STATE(1329),
    [sym__open_bracket] = STATE(1328),
    [sym__open_bracket2] = STATE(1327),
    [sym_identifier] = ACTIONS(5411),
    [anon_sym_BSLASH] = ACTIONS(5409),
    [anon_sym_function] = ACTIONS(5411),
    [anon_sym_EQ] = ACTIONS(5119),
    [anon_sym_if] = ACTIONS(5411),
    [anon_sym_for] = ACTIONS(5411),
    [anon_sym_while] = ACTIONS(5411),
    [anon_sym_repeat] = ACTIONS(5411),
    [anon_sym_QMARK] = ACTIONS(5409),
    [anon_sym_TILDE] = ACTIONS(5121),
    [anon_sym_BANG] = ACTIONS(5411),
    [anon_sym_PLUS] = ACTIONS(5123),
    [anon_sym_DASH] = ACTIONS(5125),
    [anon_sym_LT_DASH] = ACTIONS(5127),
    [anon_sym_LT_LT_DASH] = ACTIONS(5127),
    [anon_sym_COLON_EQ] = ACTIONS(5127),
    [anon_sym_DASH_GT] = ACTIONS(5129),
    [anon_sym_DASH_GT_GT] = ACTIONS(5131),
    [anon_sym_PIPE] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5135),
    [anon_sym_PIPE_PIPE] = ACTIONS(5137),
    [anon_sym_AMP_AMP] = ACTIONS(5139),
    [anon_sym_LT] = ACTIONS(5141),
    [anon_sym_LT_EQ] = ACTIONS(5143),
    [anon_sym_GT] = ACTIONS(5141),
    [anon_sym_GT_EQ] = ACTIONS(5143),
    [anon_sym_EQ_EQ] = ACTIONS(5143),
    [anon_sym_BANG_EQ] = ACTIONS(5143),
    [anon_sym_STAR] = ACTIONS(5145),
    [anon_sym_SLASH] = ACTIONS(5147),
    [anon_sym_STAR_STAR] = ACTIONS(5149),
    [anon_sym_CARET] = ACTIONS(5149),
    [aux_sym_binary_operator_token1] = ACTIONS(5151),
    [anon_sym_PIPE_GT] = ACTIONS(5151),
    [anon_sym_COLON] = ACTIONS(5153),
    [anon_sym_DOLLAR] = ACTIONS(5155),
    [anon_sym_AT] = ACTIONS(5155),
    [aux_sym__hex_literal_token1] = ACTIONS(5409),
    [sym__number_literal] = ACTIONS(5411),
    [anon_sym_SQUOTE] = ACTIONS(5409),
    [anon_sym_DQUOTE] = ACTIONS(5409),
    [sym_return] = ACTIONS(5411),
    [sym_next] = ACTIONS(5411),
    [sym_break] = ACTIONS(5411),
    [sym_true] = ACTIONS(5411),
    [sym_false] = ACTIONS(5411),
    [sym_null] = ACTIONS(5411),
    [sym_inf] = ACTIONS(5411),
    [sym_nan] = ACTIONS(5411),
    [anon_sym_NA] = ACTIONS(5411),
    [anon_sym_NA_integer_] = ACTIONS(5411),
    [anon_sym_NA_real_] = ACTIONS(5411),
    [anon_sym_NA_complex_] = ACTIONS(5411),
    [anon_sym_NA_character_] = ACTIONS(5411),
    [sym_dots] = ACTIONS(5411),
    [sym_dot_dot_i] = ACTIONS(5409),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5409),
    [sym__newline] = ACTIONS(5409),
    [sym__semicolon] = ACTIONS(5409),
    [sym__raw_string_literal] = ACTIONS(5409),
    [sym__external_else] = ACTIONS(5409),
    [sym__external_open_parenthesis] = ACTIONS(5159),
    [sym__external_close_parenthesis] = ACTIONS(5409),
    [sym__external_open_brace] = ACTIONS(5409),
    [sym__external_close_brace] = ACTIONS(5409),
    [sym__external_open_bracket] = ACTIONS(5161),
    [sym__external_close_bracket] = ACTIONS(5409),
    [sym__external_open_bracket2] = ACTIONS(5163),
  },
  [615] = {
    [sym_call_arguments] = STATE(2342),
    [sym_subset_arguments] = STATE(2343),
    [sym_subset2_arguments] = STATE(2346),
    [sym__open_parenthesis] = STATE(1325),
    [sym__open_bracket] = STATE(1322),
    [sym__open_bracket2] = STATE(1607),
    [sym_identifier] = ACTIONS(5331),
    [anon_sym_BSLASH] = ACTIONS(5329),
    [anon_sym_function] = ACTIONS(5331),
    [anon_sym_EQ] = ACTIONS(5069),
    [anon_sym_if] = ACTIONS(5331),
    [anon_sym_for] = ACTIONS(5331),
    [anon_sym_while] = ACTIONS(5331),
    [anon_sym_repeat] = ACTIONS(5331),
    [anon_sym_QMARK] = ACTIONS(5329),
    [anon_sym_TILDE] = ACTIONS(5071),
    [anon_sym_BANG] = ACTIONS(5331),
    [anon_sym_PLUS] = ACTIONS(5073),
    [anon_sym_DASH] = ACTIONS(5075),
    [anon_sym_LT_DASH] = ACTIONS(5077),
    [anon_sym_LT_LT_DASH] = ACTIONS(5077),
    [anon_sym_COLON_EQ] = ACTIONS(5077),
    [anon_sym_DASH_GT] = ACTIONS(5079),
    [anon_sym_DASH_GT_GT] = ACTIONS(5081),
    [anon_sym_PIPE] = ACTIONS(5083),
    [anon_sym_AMP] = ACTIONS(5085),
    [anon_sym_PIPE_PIPE] = ACTIONS(5087),
    [anon_sym_AMP_AMP] = ACTIONS(5089),
    [anon_sym_LT] = ACTIONS(5091),
    [anon_sym_LT_EQ] = ACTIONS(5093),
    [anon_sym_GT] = ACTIONS(5091),
    [anon_sym_GT_EQ] = ACTIONS(5093),
    [anon_sym_EQ_EQ] = ACTIONS(5093),
    [anon_sym_BANG_EQ] = ACTIONS(5093),
    [anon_sym_STAR] = ACTIONS(5095),
    [anon_sym_SLASH] = ACTIONS(5097),
    [anon_sym_STAR_STAR] = ACTIONS(5099),
    [anon_sym_CARET] = ACTIONS(5099),
    [aux_sym_binary_operator_token1] = ACTIONS(5101),
    [anon_sym_PIPE_GT] = ACTIONS(5101),
    [anon_sym_COLON] = ACTIONS(5103),
    [anon_sym_DOLLAR] = ACTIONS(5105),
    [anon_sym_AT] = ACTIONS(5105),
    [aux_sym__hex_literal_token1] = ACTIONS(5329),
    [sym__number_literal] = ACTIONS(5331),
    [anon_sym_SQUOTE] = ACTIONS(5329),
    [anon_sym_DQUOTE] = ACTIONS(5329),
    [sym_return] = ACTIONS(5331),
    [sym_next] = ACTIONS(5331),
    [sym_break] = ACTIONS(5331),
    [sym_true] = ACTIONS(5331),
    [sym_false] = ACTIONS(5331),
    [sym_null] = ACTIONS(5331),
    [sym_inf] = ACTIONS(5331),
    [sym_nan] = ACTIONS(5331),
    [anon_sym_NA] = ACTIONS(5331),
    [anon_sym_NA_integer_] = ACTIONS(5331),
    [anon_sym_NA_real_] = ACTIONS(5331),
    [anon_sym_NA_complex_] = ACTIONS(5331),
    [anon_sym_NA_character_] = ACTIONS(5331),
    [sym_dots] = ACTIONS(5331),
    [sym_dot_dot_i] = ACTIONS(5329),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5329),
    [sym__newline] = ACTIONS(5329),
    [sym__semicolon] = ACTIONS(5329),
    [sym__raw_string_literal] = ACTIONS(5329),
    [sym__external_else] = ACTIONS(5329),
    [sym__external_open_parenthesis] = ACTIONS(5109),
    [sym__external_close_parenthesis] = ACTIONS(5329),
    [sym__external_open_brace] = ACTIONS(5329),
    [sym__external_close_brace] = ACTIONS(5329),
    [sym__external_open_bracket] = ACTIONS(5111),
    [sym__external_open_bracket2] = ACTIONS(5113),
    [sym__external_close_bracket2] = ACTIONS(5329),
  },
  [616] = {
    [sym_call_arguments] = STATE(2342),
    [sym_subset_arguments] = STATE(2343),
    [sym_subset2_arguments] = STATE(2346),
    [sym__open_parenthesis] = STATE(1325),
    [sym__open_bracket] = STATE(1322),
    [sym__open_bracket2] = STATE(1607),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5069),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5071),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(5073),
    [anon_sym_DASH] = ACTIONS(5075),
    [anon_sym_LT_DASH] = ACTIONS(5077),
    [anon_sym_LT_LT_DASH] = ACTIONS(5077),
    [anon_sym_COLON_EQ] = ACTIONS(5077),
    [anon_sym_DASH_GT] = ACTIONS(5079),
    [anon_sym_DASH_GT_GT] = ACTIONS(5081),
    [anon_sym_PIPE] = ACTIONS(5083),
    [anon_sym_AMP] = ACTIONS(5085),
    [anon_sym_PIPE_PIPE] = ACTIONS(5087),
    [anon_sym_AMP_AMP] = ACTIONS(5089),
    [anon_sym_LT] = ACTIONS(5091),
    [anon_sym_LT_EQ] = ACTIONS(5093),
    [anon_sym_GT] = ACTIONS(5091),
    [anon_sym_GT_EQ] = ACTIONS(5093),
    [anon_sym_EQ_EQ] = ACTIONS(5093),
    [anon_sym_BANG_EQ] = ACTIONS(5093),
    [anon_sym_STAR] = ACTIONS(5095),
    [anon_sym_SLASH] = ACTIONS(5097),
    [anon_sym_STAR_STAR] = ACTIONS(5099),
    [anon_sym_CARET] = ACTIONS(5099),
    [aux_sym_binary_operator_token1] = ACTIONS(5101),
    [anon_sym_PIPE_GT] = ACTIONS(5101),
    [anon_sym_COLON] = ACTIONS(5103),
    [anon_sym_DOLLAR] = ACTIONS(5105),
    [anon_sym_AT] = ACTIONS(5105),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__semicolon] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_else] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(5109),
    [sym__external_close_parenthesis] = ACTIONS(5333),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_close_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(5111),
    [sym__external_open_bracket2] = ACTIONS(5113),
    [sym__external_close_bracket2] = ACTIONS(5333),
  },
  [617] = {
    [sym_call_arguments] = STATE(2342),
    [sym_subset_arguments] = STATE(2343),
    [sym_subset2_arguments] = STATE(2346),
    [sym__open_parenthesis] = STATE(1325),
    [sym__open_bracket] = STATE(1322),
    [sym__open_bracket2] = STATE(1607),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(5073),
    [anon_sym_DASH] = ACTIONS(5075),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5083),
    [anon_sym_AMP] = ACTIONS(5085),
    [anon_sym_PIPE_PIPE] = ACTIONS(5087),
    [anon_sym_AMP_AMP] = ACTIONS(5089),
    [anon_sym_LT] = ACTIONS(5091),
    [anon_sym_LT_EQ] = ACTIONS(5093),
    [anon_sym_GT] = ACTIONS(5091),
    [anon_sym_GT_EQ] = ACTIONS(5093),
    [anon_sym_EQ_EQ] = ACTIONS(5093),
    [anon_sym_BANG_EQ] = ACTIONS(5093),
    [anon_sym_STAR] = ACTIONS(5095),
    [anon_sym_SLASH] = ACTIONS(5097),
    [anon_sym_STAR_STAR] = ACTIONS(5099),
    [anon_sym_CARET] = ACTIONS(5099),
    [aux_sym_binary_operator_token1] = ACTIONS(5101),
    [anon_sym_PIPE_GT] = ACTIONS(5101),
    [anon_sym_COLON] = ACTIONS(5103),
    [anon_sym_DOLLAR] = ACTIONS(5105),
    [anon_sym_AT] = ACTIONS(5105),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__semicolon] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_else] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(5109),
    [sym__external_close_parenthesis] = ACTIONS(5333),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_close_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(5111),
    [sym__external_open_bracket2] = ACTIONS(5113),
    [sym__external_close_bracket2] = ACTIONS(5333),
  },
  [618] = {
    [sym_call_arguments] = STATE(2342),
    [sym_subset_arguments] = STATE(2343),
    [sym_subset2_arguments] = STATE(2346),
    [sym__open_parenthesis] = STATE(1325),
    [sym__open_bracket] = STATE(1322),
    [sym__open_bracket2] = STATE(1607),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(5073),
    [anon_sym_DASH] = ACTIONS(5075),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5335),
    [anon_sym_AMP] = ACTIONS(5335),
    [anon_sym_PIPE_PIPE] = ACTIONS(5333),
    [anon_sym_AMP_AMP] = ACTIONS(5333),
    [anon_sym_LT] = ACTIONS(5091),
    [anon_sym_LT_EQ] = ACTIONS(5093),
    [anon_sym_GT] = ACTIONS(5091),
    [anon_sym_GT_EQ] = ACTIONS(5093),
    [anon_sym_EQ_EQ] = ACTIONS(5093),
    [anon_sym_BANG_EQ] = ACTIONS(5093),
    [anon_sym_STAR] = ACTIONS(5095),
    [anon_sym_SLASH] = ACTIONS(5097),
    [anon_sym_STAR_STAR] = ACTIONS(5099),
    [anon_sym_CARET] = ACTIONS(5099),
    [aux_sym_binary_operator_token1] = ACTIONS(5101),
    [anon_sym_PIPE_GT] = ACTIONS(5101),
    [anon_sym_COLON] = ACTIONS(5103),
    [anon_sym_DOLLAR] = ACTIONS(5105),
    [anon_sym_AT] = ACTIONS(5105),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__semicolon] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_else] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(5109),
    [sym__external_close_parenthesis] = ACTIONS(5333),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_close_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(5111),
    [sym__external_open_bracket2] = ACTIONS(5113),
    [sym__external_close_bracket2] = ACTIONS(5333),
  },
  [619] = {
    [sym_call_arguments] = STATE(2342),
    [sym_subset_arguments] = STATE(2343),
    [sym_subset2_arguments] = STATE(2346),
    [sym__open_parenthesis] = STATE(1325),
    [sym__open_bracket] = STATE(1322),
    [sym__open_bracket2] = STATE(1607),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(5333),
    [anon_sym_DASH] = ACTIONS(5335),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5335),
    [anon_sym_AMP] = ACTIONS(5335),
    [anon_sym_PIPE_PIPE] = ACTIONS(5333),
    [anon_sym_AMP_AMP] = ACTIONS(5333),
    [anon_sym_LT] = ACTIONS(5335),
    [anon_sym_LT_EQ] = ACTIONS(5333),
    [anon_sym_GT] = ACTIONS(5335),
    [anon_sym_GT_EQ] = ACTIONS(5333),
    [anon_sym_EQ_EQ] = ACTIONS(5333),
    [anon_sym_BANG_EQ] = ACTIONS(5333),
    [anon_sym_STAR] = ACTIONS(5335),
    [anon_sym_SLASH] = ACTIONS(5333),
    [anon_sym_STAR_STAR] = ACTIONS(5099),
    [anon_sym_CARET] = ACTIONS(5099),
    [aux_sym_binary_operator_token1] = ACTIONS(5333),
    [anon_sym_PIPE_GT] = ACTIONS(5333),
    [anon_sym_COLON] = ACTIONS(5335),
    [anon_sym_DOLLAR] = ACTIONS(5105),
    [anon_sym_AT] = ACTIONS(5105),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__semicolon] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_else] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(5109),
    [sym__external_close_parenthesis] = ACTIONS(5333),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_close_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(5111),
    [sym__external_open_bracket2] = ACTIONS(5113),
    [sym__external_close_bracket2] = ACTIONS(5333),
  },
  [620] = {
    [sym_call_arguments] = STATE(2342),
    [sym_subset_arguments] = STATE(2343),
    [sym_subset2_arguments] = STATE(2346),
    [sym__open_parenthesis] = STATE(1325),
    [sym__open_bracket] = STATE(1322),
    [sym__open_bracket2] = STATE(1607),
    [sym_identifier] = ACTIONS(5339),
    [anon_sym_BSLASH] = ACTIONS(5337),
    [anon_sym_function] = ACTIONS(5339),
    [anon_sym_EQ] = ACTIONS(5069),
    [anon_sym_if] = ACTIONS(5339),
    [anon_sym_for] = ACTIONS(5339),
    [anon_sym_while] = ACTIONS(5339),
    [anon_sym_repeat] = ACTIONS(5339),
    [anon_sym_QMARK] = ACTIONS(5337),
    [anon_sym_TILDE] = ACTIONS(5071),
    [anon_sym_BANG] = ACTIONS(5339),
    [anon_sym_PLUS] = ACTIONS(5073),
    [anon_sym_DASH] = ACTIONS(5075),
    [anon_sym_LT_DASH] = ACTIONS(5077),
    [anon_sym_LT_LT_DASH] = ACTIONS(5077),
    [anon_sym_COLON_EQ] = ACTIONS(5077),
    [anon_sym_DASH_GT] = ACTIONS(5079),
    [anon_sym_DASH_GT_GT] = ACTIONS(5081),
    [anon_sym_PIPE] = ACTIONS(5083),
    [anon_sym_AMP] = ACTIONS(5085),
    [anon_sym_PIPE_PIPE] = ACTIONS(5087),
    [anon_sym_AMP_AMP] = ACTIONS(5089),
    [anon_sym_LT] = ACTIONS(5091),
    [anon_sym_LT_EQ] = ACTIONS(5093),
    [anon_sym_GT] = ACTIONS(5091),
    [anon_sym_GT_EQ] = ACTIONS(5093),
    [anon_sym_EQ_EQ] = ACTIONS(5093),
    [anon_sym_BANG_EQ] = ACTIONS(5093),
    [anon_sym_STAR] = ACTIONS(5095),
    [anon_sym_SLASH] = ACTIONS(5097),
    [anon_sym_STAR_STAR] = ACTIONS(5099),
    [anon_sym_CARET] = ACTIONS(5099),
    [aux_sym_binary_operator_token1] = ACTIONS(5101),
    [anon_sym_PIPE_GT] = ACTIONS(5101),
    [anon_sym_COLON] = ACTIONS(5103),
    [anon_sym_DOLLAR] = ACTIONS(5105),
    [anon_sym_AT] = ACTIONS(5105),
    [aux_sym__hex_literal_token1] = ACTIONS(5337),
    [sym__number_literal] = ACTIONS(5339),
    [anon_sym_SQUOTE] = ACTIONS(5337),
    [anon_sym_DQUOTE] = ACTIONS(5337),
    [sym_return] = ACTIONS(5339),
    [sym_next] = ACTIONS(5339),
    [sym_break] = ACTIONS(5339),
    [sym_true] = ACTIONS(5339),
    [sym_false] = ACTIONS(5339),
    [sym_null] = ACTIONS(5339),
    [sym_inf] = ACTIONS(5339),
    [sym_nan] = ACTIONS(5339),
    [anon_sym_NA] = ACTIONS(5339),
    [anon_sym_NA_integer_] = ACTIONS(5339),
    [anon_sym_NA_real_] = ACTIONS(5339),
    [anon_sym_NA_complex_] = ACTIONS(5339),
    [anon_sym_NA_character_] = ACTIONS(5339),
    [sym_dots] = ACTIONS(5339),
    [sym_dot_dot_i] = ACTIONS(5337),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5337),
    [sym__newline] = ACTIONS(5337),
    [sym__semicolon] = ACTIONS(5337),
    [sym__raw_string_literal] = ACTIONS(5337),
    [sym__external_else] = ACTIONS(5337),
    [sym__external_open_parenthesis] = ACTIONS(5109),
    [sym__external_close_parenthesis] = ACTIONS(5337),
    [sym__external_open_brace] = ACTIONS(5337),
    [sym__external_close_brace] = ACTIONS(5337),
    [sym__external_open_bracket] = ACTIONS(5111),
    [sym__external_open_bracket2] = ACTIONS(5113),
    [sym__external_close_bracket2] = ACTIONS(5337),
  },
  [621] = {
    [sym_call_arguments] = STATE(2342),
    [sym_subset_arguments] = STATE(2343),
    [sym_subset2_arguments] = STATE(2346),
    [sym__open_parenthesis] = STATE(1325),
    [sym__open_bracket] = STATE(1322),
    [sym__open_bracket2] = STATE(1607),
    [sym_identifier] = ACTIONS(5343),
    [anon_sym_BSLASH] = ACTIONS(5341),
    [anon_sym_function] = ACTIONS(5343),
    [anon_sym_EQ] = ACTIONS(5069),
    [anon_sym_if] = ACTIONS(5343),
    [anon_sym_for] = ACTIONS(5343),
    [anon_sym_while] = ACTIONS(5343),
    [anon_sym_repeat] = ACTIONS(5343),
    [anon_sym_QMARK] = ACTIONS(5341),
    [anon_sym_TILDE] = ACTIONS(5071),
    [anon_sym_BANG] = ACTIONS(5343),
    [anon_sym_PLUS] = ACTIONS(5073),
    [anon_sym_DASH] = ACTIONS(5075),
    [anon_sym_LT_DASH] = ACTIONS(5077),
    [anon_sym_LT_LT_DASH] = ACTIONS(5077),
    [anon_sym_COLON_EQ] = ACTIONS(5077),
    [anon_sym_DASH_GT] = ACTIONS(5079),
    [anon_sym_DASH_GT_GT] = ACTIONS(5081),
    [anon_sym_PIPE] = ACTIONS(5083),
    [anon_sym_AMP] = ACTIONS(5085),
    [anon_sym_PIPE_PIPE] = ACTIONS(5087),
    [anon_sym_AMP_AMP] = ACTIONS(5089),
    [anon_sym_LT] = ACTIONS(5091),
    [anon_sym_LT_EQ] = ACTIONS(5093),
    [anon_sym_GT] = ACTIONS(5091),
    [anon_sym_GT_EQ] = ACTIONS(5093),
    [anon_sym_EQ_EQ] = ACTIONS(5093),
    [anon_sym_BANG_EQ] = ACTIONS(5093),
    [anon_sym_STAR] = ACTIONS(5095),
    [anon_sym_SLASH] = ACTIONS(5097),
    [anon_sym_STAR_STAR] = ACTIONS(5099),
    [anon_sym_CARET] = ACTIONS(5099),
    [aux_sym_binary_operator_token1] = ACTIONS(5101),
    [anon_sym_PIPE_GT] = ACTIONS(5101),
    [anon_sym_COLON] = ACTIONS(5103),
    [anon_sym_DOLLAR] = ACTIONS(5105),
    [anon_sym_AT] = ACTIONS(5105),
    [aux_sym__hex_literal_token1] = ACTIONS(5341),
    [sym__number_literal] = ACTIONS(5343),
    [anon_sym_SQUOTE] = ACTIONS(5341),
    [anon_sym_DQUOTE] = ACTIONS(5341),
    [sym_return] = ACTIONS(5343),
    [sym_next] = ACTIONS(5343),
    [sym_break] = ACTIONS(5343),
    [sym_true] = ACTIONS(5343),
    [sym_false] = ACTIONS(5343),
    [sym_null] = ACTIONS(5343),
    [sym_inf] = ACTIONS(5343),
    [sym_nan] = ACTIONS(5343),
    [anon_sym_NA] = ACTIONS(5343),
    [anon_sym_NA_integer_] = ACTIONS(5343),
    [anon_sym_NA_real_] = ACTIONS(5343),
    [anon_sym_NA_complex_] = ACTIONS(5343),
    [anon_sym_NA_character_] = ACTIONS(5343),
    [sym_dots] = ACTIONS(5343),
    [sym_dot_dot_i] = ACTIONS(5341),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5341),
    [sym__newline] = ACTIONS(5341),
    [sym__semicolon] = ACTIONS(5341),
    [sym__raw_string_literal] = ACTIONS(5341),
    [sym__external_else] = ACTIONS(5341),
    [sym__external_open_parenthesis] = ACTIONS(5109),
    [sym__external_close_parenthesis] = ACTIONS(5341),
    [sym__external_open_brace] = ACTIONS(5341),
    [sym__external_close_brace] = ACTIONS(5341),
    [sym__external_open_bracket] = ACTIONS(5111),
    [sym__external_open_bracket2] = ACTIONS(5113),
    [sym__external_close_bracket2] = ACTIONS(5341),
  },
  [622] = {
    [sym_call_arguments] = STATE(2342),
    [sym_subset_arguments] = STATE(2343),
    [sym_subset2_arguments] = STATE(2346),
    [sym__open_parenthesis] = STATE(1325),
    [sym__open_bracket] = STATE(1322),
    [sym__open_bracket2] = STATE(1607),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5069),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5071),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5073),
    [anon_sym_DASH] = ACTIONS(5075),
    [anon_sym_LT_DASH] = ACTIONS(5077),
    [anon_sym_LT_LT_DASH] = ACTIONS(5077),
    [anon_sym_COLON_EQ] = ACTIONS(5077),
    [anon_sym_DASH_GT] = ACTIONS(5079),
    [anon_sym_DASH_GT_GT] = ACTIONS(5081),
    [anon_sym_PIPE] = ACTIONS(5083),
    [anon_sym_AMP] = ACTIONS(5085),
    [anon_sym_PIPE_PIPE] = ACTIONS(5087),
    [anon_sym_AMP_AMP] = ACTIONS(5089),
    [anon_sym_LT] = ACTIONS(5091),
    [anon_sym_LT_EQ] = ACTIONS(5093),
    [anon_sym_GT] = ACTIONS(5091),
    [anon_sym_GT_EQ] = ACTIONS(5093),
    [anon_sym_EQ_EQ] = ACTIONS(5093),
    [anon_sym_BANG_EQ] = ACTIONS(5093),
    [anon_sym_STAR] = ACTIONS(5095),
    [anon_sym_SLASH] = ACTIONS(5097),
    [anon_sym_STAR_STAR] = ACTIONS(5099),
    [anon_sym_CARET] = ACTIONS(5099),
    [aux_sym_binary_operator_token1] = ACTIONS(5101),
    [anon_sym_PIPE_GT] = ACTIONS(5101),
    [anon_sym_COLON] = ACTIONS(5103),
    [anon_sym_DOLLAR] = ACTIONS(5105),
    [anon_sym_AT] = ACTIONS(5105),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__semicolon] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_else] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(5109),
    [sym__external_close_parenthesis] = ACTIONS(5345),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_close_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(5111),
    [sym__external_open_bracket2] = ACTIONS(5113),
    [sym__external_close_bracket2] = ACTIONS(5345),
  },
  [623] = {
    [sym_call_arguments] = STATE(2342),
    [sym_subset_arguments] = STATE(2343),
    [sym_subset2_arguments] = STATE(2346),
    [sym__open_parenthesis] = STATE(1325),
    [sym__open_bracket] = STATE(1322),
    [sym__open_bracket2] = STATE(1607),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5073),
    [anon_sym_DASH] = ACTIONS(5075),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5083),
    [anon_sym_AMP] = ACTIONS(5085),
    [anon_sym_PIPE_PIPE] = ACTIONS(5087),
    [anon_sym_AMP_AMP] = ACTIONS(5089),
    [anon_sym_LT] = ACTIONS(5091),
    [anon_sym_LT_EQ] = ACTIONS(5093),
    [anon_sym_GT] = ACTIONS(5091),
    [anon_sym_GT_EQ] = ACTIONS(5093),
    [anon_sym_EQ_EQ] = ACTIONS(5093),
    [anon_sym_BANG_EQ] = ACTIONS(5093),
    [anon_sym_STAR] = ACTIONS(5095),
    [anon_sym_SLASH] = ACTIONS(5097),
    [anon_sym_STAR_STAR] = ACTIONS(5099),
    [anon_sym_CARET] = ACTIONS(5099),
    [aux_sym_binary_operator_token1] = ACTIONS(5101),
    [anon_sym_PIPE_GT] = ACTIONS(5101),
    [anon_sym_COLON] = ACTIONS(5103),
    [anon_sym_DOLLAR] = ACTIONS(5105),
    [anon_sym_AT] = ACTIONS(5105),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__semicolon] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_else] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(5109),
    [sym__external_close_parenthesis] = ACTIONS(5345),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_close_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(5111),
    [sym__external_open_bracket2] = ACTIONS(5113),
    [sym__external_close_bracket2] = ACTIONS(5345),
  },
  [624] = {
    [sym_call_arguments] = STATE(2342),
    [sym_subset_arguments] = STATE(2343),
    [sym_subset2_arguments] = STATE(2346),
    [sym__open_parenthesis] = STATE(1325),
    [sym__open_bracket] = STATE(1322),
    [sym__open_bracket2] = STATE(1607),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5073),
    [anon_sym_DASH] = ACTIONS(5075),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5347),
    [anon_sym_AMP] = ACTIONS(5347),
    [anon_sym_PIPE_PIPE] = ACTIONS(5345),
    [anon_sym_AMP_AMP] = ACTIONS(5345),
    [anon_sym_LT] = ACTIONS(5091),
    [anon_sym_LT_EQ] = ACTIONS(5093),
    [anon_sym_GT] = ACTIONS(5091),
    [anon_sym_GT_EQ] = ACTIONS(5093),
    [anon_sym_EQ_EQ] = ACTIONS(5093),
    [anon_sym_BANG_EQ] = ACTIONS(5093),
    [anon_sym_STAR] = ACTIONS(5095),
    [anon_sym_SLASH] = ACTIONS(5097),
    [anon_sym_STAR_STAR] = ACTIONS(5099),
    [anon_sym_CARET] = ACTIONS(5099),
    [aux_sym_binary_operator_token1] = ACTIONS(5101),
    [anon_sym_PIPE_GT] = ACTIONS(5101),
    [anon_sym_COLON] = ACTIONS(5103),
    [anon_sym_DOLLAR] = ACTIONS(5105),
    [anon_sym_AT] = ACTIONS(5105),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__semicolon] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_else] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(5109),
    [sym__external_close_parenthesis] = ACTIONS(5345),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_close_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(5111),
    [sym__external_open_bracket2] = ACTIONS(5113),
    [sym__external_close_bracket2] = ACTIONS(5345),
  },
  [625] = {
    [sym_call_arguments] = STATE(2342),
    [sym_subset_arguments] = STATE(2343),
    [sym_subset2_arguments] = STATE(2346),
    [sym__open_parenthesis] = STATE(1325),
    [sym__open_bracket] = STATE(1322),
    [sym__open_bracket2] = STATE(1607),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5345),
    [anon_sym_DASH] = ACTIONS(5347),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5347),
    [anon_sym_AMP] = ACTIONS(5347),
    [anon_sym_PIPE_PIPE] = ACTIONS(5345),
    [anon_sym_AMP_AMP] = ACTIONS(5345),
    [anon_sym_LT] = ACTIONS(5347),
    [anon_sym_LT_EQ] = ACTIONS(5345),
    [anon_sym_GT] = ACTIONS(5347),
    [anon_sym_GT_EQ] = ACTIONS(5345),
    [anon_sym_EQ_EQ] = ACTIONS(5345),
    [anon_sym_BANG_EQ] = ACTIONS(5345),
    [anon_sym_STAR] = ACTIONS(5347),
    [anon_sym_SLASH] = ACTIONS(5345),
    [anon_sym_STAR_STAR] = ACTIONS(5099),
    [anon_sym_CARET] = ACTIONS(5099),
    [aux_sym_binary_operator_token1] = ACTIONS(5345),
    [anon_sym_PIPE_GT] = ACTIONS(5345),
    [anon_sym_COLON] = ACTIONS(5347),
    [anon_sym_DOLLAR] = ACTIONS(5105),
    [anon_sym_AT] = ACTIONS(5105),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__semicolon] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_else] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(5109),
    [sym__external_close_parenthesis] = ACTIONS(5345),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_close_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(5111),
    [sym__external_open_bracket2] = ACTIONS(5113),
    [sym__external_close_bracket2] = ACTIONS(5345),
  },
  [626] = {
    [sym_call_arguments] = STATE(2342),
    [sym_subset_arguments] = STATE(2343),
    [sym_subset2_arguments] = STATE(2346),
    [sym__open_parenthesis] = STATE(1325),
    [sym__open_bracket] = STATE(1322),
    [sym__open_bracket2] = STATE(1607),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5069),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5071),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5073),
    [anon_sym_DASH] = ACTIONS(5075),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5079),
    [anon_sym_DASH_GT_GT] = ACTIONS(5081),
    [anon_sym_PIPE] = ACTIONS(5083),
    [anon_sym_AMP] = ACTIONS(5085),
    [anon_sym_PIPE_PIPE] = ACTIONS(5087),
    [anon_sym_AMP_AMP] = ACTIONS(5089),
    [anon_sym_LT] = ACTIONS(5091),
    [anon_sym_LT_EQ] = ACTIONS(5093),
    [anon_sym_GT] = ACTIONS(5091),
    [anon_sym_GT_EQ] = ACTIONS(5093),
    [anon_sym_EQ_EQ] = ACTIONS(5093),
    [anon_sym_BANG_EQ] = ACTIONS(5093),
    [anon_sym_STAR] = ACTIONS(5095),
    [anon_sym_SLASH] = ACTIONS(5097),
    [anon_sym_STAR_STAR] = ACTIONS(5099),
    [anon_sym_CARET] = ACTIONS(5099),
    [aux_sym_binary_operator_token1] = ACTIONS(5101),
    [anon_sym_PIPE_GT] = ACTIONS(5101),
    [anon_sym_COLON] = ACTIONS(5103),
    [anon_sym_DOLLAR] = ACTIONS(5105),
    [anon_sym_AT] = ACTIONS(5105),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5109),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5111),
    [sym__external_open_bracket2] = ACTIONS(5113),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [627] = {
    [sym_call_arguments] = STATE(2342),
    [sym_subset_arguments] = STATE(2343),
    [sym_subset2_arguments] = STATE(2346),
    [sym__open_parenthesis] = STATE(1325),
    [sym__open_bracket] = STATE(1322),
    [sym__open_bracket2] = STATE(1607),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5069),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5071),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5073),
    [anon_sym_DASH] = ACTIONS(5075),
    [anon_sym_LT_DASH] = ACTIONS(5077),
    [anon_sym_LT_LT_DASH] = ACTIONS(5077),
    [anon_sym_COLON_EQ] = ACTIONS(5077),
    [anon_sym_DASH_GT] = ACTIONS(5079),
    [anon_sym_DASH_GT_GT] = ACTIONS(5081),
    [anon_sym_PIPE] = ACTIONS(5083),
    [anon_sym_AMP] = ACTIONS(5085),
    [anon_sym_PIPE_PIPE] = ACTIONS(5087),
    [anon_sym_AMP_AMP] = ACTIONS(5089),
    [anon_sym_LT] = ACTIONS(5091),
    [anon_sym_LT_EQ] = ACTIONS(5093),
    [anon_sym_GT] = ACTIONS(5091),
    [anon_sym_GT_EQ] = ACTIONS(5093),
    [anon_sym_EQ_EQ] = ACTIONS(5093),
    [anon_sym_BANG_EQ] = ACTIONS(5093),
    [anon_sym_STAR] = ACTIONS(5095),
    [anon_sym_SLASH] = ACTIONS(5097),
    [anon_sym_STAR_STAR] = ACTIONS(5099),
    [anon_sym_CARET] = ACTIONS(5099),
    [aux_sym_binary_operator_token1] = ACTIONS(5101),
    [anon_sym_PIPE_GT] = ACTIONS(5101),
    [anon_sym_COLON] = ACTIONS(5103),
    [anon_sym_DOLLAR] = ACTIONS(5105),
    [anon_sym_AT] = ACTIONS(5105),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5109),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5111),
    [sym__external_open_bracket2] = ACTIONS(5113),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [628] = {
    [sym_call_arguments] = STATE(2342),
    [sym_subset_arguments] = STATE(2343),
    [sym_subset2_arguments] = STATE(2346),
    [sym__open_parenthesis] = STATE(1325),
    [sym__open_bracket] = STATE(1322),
    [sym__open_bracket2] = STATE(1607),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5073),
    [anon_sym_DASH] = ACTIONS(5075),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5083),
    [anon_sym_AMP] = ACTIONS(5085),
    [anon_sym_PIPE_PIPE] = ACTIONS(5087),
    [anon_sym_AMP_AMP] = ACTIONS(5089),
    [anon_sym_LT] = ACTIONS(5091),
    [anon_sym_LT_EQ] = ACTIONS(5093),
    [anon_sym_GT] = ACTIONS(5091),
    [anon_sym_GT_EQ] = ACTIONS(5093),
    [anon_sym_EQ_EQ] = ACTIONS(5093),
    [anon_sym_BANG_EQ] = ACTIONS(5093),
    [anon_sym_STAR] = ACTIONS(5095),
    [anon_sym_SLASH] = ACTIONS(5097),
    [anon_sym_STAR_STAR] = ACTIONS(5099),
    [anon_sym_CARET] = ACTIONS(5099),
    [aux_sym_binary_operator_token1] = ACTIONS(5101),
    [anon_sym_PIPE_GT] = ACTIONS(5101),
    [anon_sym_COLON] = ACTIONS(5103),
    [anon_sym_DOLLAR] = ACTIONS(5105),
    [anon_sym_AT] = ACTIONS(5105),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5109),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5111),
    [sym__external_open_bracket2] = ACTIONS(5113),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [629] = {
    [sym_call_arguments] = STATE(2342),
    [sym_subset_arguments] = STATE(2343),
    [sym_subset2_arguments] = STATE(2346),
    [sym__open_parenthesis] = STATE(1325),
    [sym__open_bracket] = STATE(1322),
    [sym__open_bracket2] = STATE(1607),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5095),
    [anon_sym_SLASH] = ACTIONS(5097),
    [anon_sym_STAR_STAR] = ACTIONS(5099),
    [anon_sym_CARET] = ACTIONS(5099),
    [aux_sym_binary_operator_token1] = ACTIONS(5101),
    [anon_sym_PIPE_GT] = ACTIONS(5101),
    [anon_sym_COLON] = ACTIONS(5103),
    [anon_sym_DOLLAR] = ACTIONS(5105),
    [anon_sym_AT] = ACTIONS(5105),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5109),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5111),
    [sym__external_open_bracket2] = ACTIONS(5113),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [630] = {
    [sym_call_arguments] = STATE(2342),
    [sym_subset_arguments] = STATE(2343),
    [sym_subset2_arguments] = STATE(2346),
    [sym__open_parenthesis] = STATE(1325),
    [sym__open_bracket] = STATE(1322),
    [sym__open_bracket2] = STATE(1607),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5069),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5071),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5073),
    [anon_sym_DASH] = ACTIONS(5075),
    [anon_sym_LT_DASH] = ACTIONS(5077),
    [anon_sym_LT_LT_DASH] = ACTIONS(5077),
    [anon_sym_COLON_EQ] = ACTIONS(5077),
    [anon_sym_DASH_GT] = ACTIONS(5079),
    [anon_sym_DASH_GT_GT] = ACTIONS(5081),
    [anon_sym_PIPE] = ACTIONS(5083),
    [anon_sym_AMP] = ACTIONS(5085),
    [anon_sym_PIPE_PIPE] = ACTIONS(5087),
    [anon_sym_AMP_AMP] = ACTIONS(5089),
    [anon_sym_LT] = ACTIONS(5091),
    [anon_sym_LT_EQ] = ACTIONS(5093),
    [anon_sym_GT] = ACTIONS(5091),
    [anon_sym_GT_EQ] = ACTIONS(5093),
    [anon_sym_EQ_EQ] = ACTIONS(5093),
    [anon_sym_BANG_EQ] = ACTIONS(5093),
    [anon_sym_STAR] = ACTIONS(5095),
    [anon_sym_SLASH] = ACTIONS(5097),
    [anon_sym_STAR_STAR] = ACTIONS(5099),
    [anon_sym_CARET] = ACTIONS(5099),
    [aux_sym_binary_operator_token1] = ACTIONS(5101),
    [anon_sym_PIPE_GT] = ACTIONS(5101),
    [anon_sym_COLON] = ACTIONS(5103),
    [anon_sym_DOLLAR] = ACTIONS(5105),
    [anon_sym_AT] = ACTIONS(5105),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5109),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5111),
    [sym__external_open_bracket2] = ACTIONS(5113),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [631] = {
    [sym_call_arguments] = STATE(2342),
    [sym_subset_arguments] = STATE(2343),
    [sym_subset2_arguments] = STATE(2346),
    [sym__open_parenthesis] = STATE(1325),
    [sym__open_bracket] = STATE(1322),
    [sym__open_bracket2] = STATE(1607),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5071),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5073),
    [anon_sym_DASH] = ACTIONS(5075),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5083),
    [anon_sym_AMP] = ACTIONS(5085),
    [anon_sym_PIPE_PIPE] = ACTIONS(5087),
    [anon_sym_AMP_AMP] = ACTIONS(5089),
    [anon_sym_LT] = ACTIONS(5091),
    [anon_sym_LT_EQ] = ACTIONS(5093),
    [anon_sym_GT] = ACTIONS(5091),
    [anon_sym_GT_EQ] = ACTIONS(5093),
    [anon_sym_EQ_EQ] = ACTIONS(5093),
    [anon_sym_BANG_EQ] = ACTIONS(5093),
    [anon_sym_STAR] = ACTIONS(5095),
    [anon_sym_SLASH] = ACTIONS(5097),
    [anon_sym_STAR_STAR] = ACTIONS(5099),
    [anon_sym_CARET] = ACTIONS(5099),
    [aux_sym_binary_operator_token1] = ACTIONS(5101),
    [anon_sym_PIPE_GT] = ACTIONS(5101),
    [anon_sym_COLON] = ACTIONS(5103),
    [anon_sym_DOLLAR] = ACTIONS(5105),
    [anon_sym_AT] = ACTIONS(5105),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5109),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5111),
    [sym__external_open_bracket2] = ACTIONS(5113),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [632] = {
    [sym_call_arguments] = STATE(2342),
    [sym_subset_arguments] = STATE(2343),
    [sym_subset2_arguments] = STATE(2346),
    [sym__open_parenthesis] = STATE(1325),
    [sym__open_bracket] = STATE(1322),
    [sym__open_bracket2] = STATE(1607),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5073),
    [anon_sym_DASH] = ACTIONS(5075),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5085),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5089),
    [anon_sym_LT] = ACTIONS(5091),
    [anon_sym_LT_EQ] = ACTIONS(5093),
    [anon_sym_GT] = ACTIONS(5091),
    [anon_sym_GT_EQ] = ACTIONS(5093),
    [anon_sym_EQ_EQ] = ACTIONS(5093),
    [anon_sym_BANG_EQ] = ACTIONS(5093),
    [anon_sym_STAR] = ACTIONS(5095),
    [anon_sym_SLASH] = ACTIONS(5097),
    [anon_sym_STAR_STAR] = ACTIONS(5099),
    [anon_sym_CARET] = ACTIONS(5099),
    [aux_sym_binary_operator_token1] = ACTIONS(5101),
    [anon_sym_PIPE_GT] = ACTIONS(5101),
    [anon_sym_COLON] = ACTIONS(5103),
    [anon_sym_DOLLAR] = ACTIONS(5105),
    [anon_sym_AT] = ACTIONS(5105),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5109),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5111),
    [sym__external_open_bracket2] = ACTIONS(5113),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [633] = {
    [sym_call_arguments] = STATE(2342),
    [sym_subset_arguments] = STATE(2343),
    [sym_subset2_arguments] = STATE(2346),
    [sym__open_parenthesis] = STATE(1325),
    [sym__open_bracket] = STATE(1322),
    [sym__open_bracket2] = STATE(1607),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5073),
    [anon_sym_DASH] = ACTIONS(5075),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5091),
    [anon_sym_LT_EQ] = ACTIONS(5093),
    [anon_sym_GT] = ACTIONS(5091),
    [anon_sym_GT_EQ] = ACTIONS(5093),
    [anon_sym_EQ_EQ] = ACTIONS(5093),
    [anon_sym_BANG_EQ] = ACTIONS(5093),
    [anon_sym_STAR] = ACTIONS(5095),
    [anon_sym_SLASH] = ACTIONS(5097),
    [anon_sym_STAR_STAR] = ACTIONS(5099),
    [anon_sym_CARET] = ACTIONS(5099),
    [aux_sym_binary_operator_token1] = ACTIONS(5101),
    [anon_sym_PIPE_GT] = ACTIONS(5101),
    [anon_sym_COLON] = ACTIONS(5103),
    [anon_sym_DOLLAR] = ACTIONS(5105),
    [anon_sym_AT] = ACTIONS(5105),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5109),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5111),
    [sym__external_open_bracket2] = ACTIONS(5113),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [634] = {
    [sym_call_arguments] = STATE(2342),
    [sym_subset_arguments] = STATE(2343),
    [sym_subset2_arguments] = STATE(2346),
    [sym__open_parenthesis] = STATE(1325),
    [sym__open_bracket] = STATE(1322),
    [sym__open_bracket2] = STATE(1607),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5073),
    [anon_sym_DASH] = ACTIONS(5075),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5095),
    [anon_sym_SLASH] = ACTIONS(5097),
    [anon_sym_STAR_STAR] = ACTIONS(5099),
    [anon_sym_CARET] = ACTIONS(5099),
    [aux_sym_binary_operator_token1] = ACTIONS(5101),
    [anon_sym_PIPE_GT] = ACTIONS(5101),
    [anon_sym_COLON] = ACTIONS(5103),
    [anon_sym_DOLLAR] = ACTIONS(5105),
    [anon_sym_AT] = ACTIONS(5105),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5109),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5111),
    [sym__external_open_bracket2] = ACTIONS(5113),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [635] = {
    [sym_call_arguments] = STATE(2342),
    [sym_subset_arguments] = STATE(2343),
    [sym_subset2_arguments] = STATE(2346),
    [sym__open_parenthesis] = STATE(1325),
    [sym__open_bracket] = STATE(1322),
    [sym__open_bracket2] = STATE(1607),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(5099),
    [anon_sym_CARET] = ACTIONS(5099),
    [aux_sym_binary_operator_token1] = ACTIONS(5101),
    [anon_sym_PIPE_GT] = ACTIONS(5101),
    [anon_sym_COLON] = ACTIONS(5103),
    [anon_sym_DOLLAR] = ACTIONS(5105),
    [anon_sym_AT] = ACTIONS(5105),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5109),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5111),
    [sym__external_open_bracket2] = ACTIONS(5113),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [636] = {
    [sym_call_arguments] = STATE(2342),
    [sym_subset_arguments] = STATE(2343),
    [sym_subset2_arguments] = STATE(2346),
    [sym__open_parenthesis] = STATE(1325),
    [sym__open_bracket] = STATE(1322),
    [sym__open_bracket2] = STATE(1607),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(5099),
    [anon_sym_CARET] = ACTIONS(5099),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(5351),
    [anon_sym_DOLLAR] = ACTIONS(5105),
    [anon_sym_AT] = ACTIONS(5105),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5109),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5111),
    [sym__external_open_bracket2] = ACTIONS(5113),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [637] = {
    [sym_call_arguments] = STATE(2342),
    [sym_subset_arguments] = STATE(2343),
    [sym_subset2_arguments] = STATE(2346),
    [sym__open_parenthesis] = STATE(1325),
    [sym__open_bracket] = STATE(1322),
    [sym__open_bracket2] = STATE(1607),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(5099),
    [anon_sym_CARET] = ACTIONS(5099),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(5103),
    [anon_sym_DOLLAR] = ACTIONS(5105),
    [anon_sym_AT] = ACTIONS(5105),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5109),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5111),
    [sym__external_open_bracket2] = ACTIONS(5113),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [638] = {
    [sym_call_arguments] = STATE(2342),
    [sym_subset_arguments] = STATE(2343),
    [sym_subset2_arguments] = STATE(2346),
    [sym__open_parenthesis] = STATE(1325),
    [sym__open_bracket] = STATE(1322),
    [sym__open_bracket2] = STATE(1607),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(5099),
    [anon_sym_CARET] = ACTIONS(5099),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(5351),
    [anon_sym_DOLLAR] = ACTIONS(5105),
    [anon_sym_AT] = ACTIONS(5105),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5109),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5111),
    [sym__external_open_bracket2] = ACTIONS(5113),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [639] = {
    [sym_call_arguments] = STATE(2342),
    [sym_subset_arguments] = STATE(2343),
    [sym_subset2_arguments] = STATE(2346),
    [sym__open_parenthesis] = STATE(1325),
    [sym__open_bracket] = STATE(1322),
    [sym__open_bracket2] = STATE(1607),
    [sym_identifier] = ACTIONS(5401),
    [anon_sym_BSLASH] = ACTIONS(5399),
    [anon_sym_function] = ACTIONS(5401),
    [anon_sym_EQ] = ACTIONS(5069),
    [anon_sym_if] = ACTIONS(5401),
    [anon_sym_for] = ACTIONS(5401),
    [anon_sym_while] = ACTIONS(5401),
    [anon_sym_repeat] = ACTIONS(5401),
    [anon_sym_QMARK] = ACTIONS(5399),
    [anon_sym_TILDE] = ACTIONS(5071),
    [anon_sym_BANG] = ACTIONS(5401),
    [anon_sym_PLUS] = ACTIONS(5073),
    [anon_sym_DASH] = ACTIONS(5075),
    [anon_sym_LT_DASH] = ACTIONS(5077),
    [anon_sym_LT_LT_DASH] = ACTIONS(5077),
    [anon_sym_COLON_EQ] = ACTIONS(5077),
    [anon_sym_DASH_GT] = ACTIONS(5079),
    [anon_sym_DASH_GT_GT] = ACTIONS(5081),
    [anon_sym_PIPE] = ACTIONS(5083),
    [anon_sym_AMP] = ACTIONS(5085),
    [anon_sym_PIPE_PIPE] = ACTIONS(5087),
    [anon_sym_AMP_AMP] = ACTIONS(5089),
    [anon_sym_LT] = ACTIONS(5091),
    [anon_sym_LT_EQ] = ACTIONS(5093),
    [anon_sym_GT] = ACTIONS(5091),
    [anon_sym_GT_EQ] = ACTIONS(5093),
    [anon_sym_EQ_EQ] = ACTIONS(5093),
    [anon_sym_BANG_EQ] = ACTIONS(5093),
    [anon_sym_STAR] = ACTIONS(5095),
    [anon_sym_SLASH] = ACTIONS(5097),
    [anon_sym_STAR_STAR] = ACTIONS(5099),
    [anon_sym_CARET] = ACTIONS(5099),
    [aux_sym_binary_operator_token1] = ACTIONS(5101),
    [anon_sym_PIPE_GT] = ACTIONS(5101),
    [anon_sym_COLON] = ACTIONS(5103),
    [anon_sym_DOLLAR] = ACTIONS(5105),
    [anon_sym_AT] = ACTIONS(5105),
    [aux_sym__hex_literal_token1] = ACTIONS(5399),
    [sym__number_literal] = ACTIONS(5401),
    [anon_sym_SQUOTE] = ACTIONS(5399),
    [anon_sym_DQUOTE] = ACTIONS(5399),
    [sym_return] = ACTIONS(5401),
    [sym_next] = ACTIONS(5401),
    [sym_break] = ACTIONS(5401),
    [sym_true] = ACTIONS(5401),
    [sym_false] = ACTIONS(5401),
    [sym_null] = ACTIONS(5401),
    [sym_inf] = ACTIONS(5401),
    [sym_nan] = ACTIONS(5401),
    [anon_sym_NA] = ACTIONS(5401),
    [anon_sym_NA_integer_] = ACTIONS(5401),
    [anon_sym_NA_real_] = ACTIONS(5401),
    [anon_sym_NA_complex_] = ACTIONS(5401),
    [anon_sym_NA_character_] = ACTIONS(5401),
    [sym_dots] = ACTIONS(5401),
    [sym_dot_dot_i] = ACTIONS(5399),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5399),
    [sym__newline] = ACTIONS(5399),
    [sym__semicolon] = ACTIONS(5399),
    [sym__raw_string_literal] = ACTIONS(5399),
    [sym__external_else] = ACTIONS(5399),
    [sym__external_open_parenthesis] = ACTIONS(5109),
    [sym__external_close_parenthesis] = ACTIONS(5399),
    [sym__external_open_brace] = ACTIONS(5399),
    [sym__external_close_brace] = ACTIONS(5399),
    [sym__external_open_bracket] = ACTIONS(5111),
    [sym__external_open_bracket2] = ACTIONS(5113),
    [sym__external_close_bracket2] = ACTIONS(5399),
  },
  [640] = {
    [sym_call_arguments] = STATE(2342),
    [sym_subset_arguments] = STATE(2343),
    [sym_subset2_arguments] = STATE(2346),
    [sym__open_parenthesis] = STATE(1325),
    [sym__open_bracket] = STATE(1322),
    [sym__open_bracket2] = STATE(1607),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5069),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5071),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5073),
    [anon_sym_DASH] = ACTIONS(5075),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5079),
    [anon_sym_DASH_GT_GT] = ACTIONS(5081),
    [anon_sym_PIPE] = ACTIONS(5083),
    [anon_sym_AMP] = ACTIONS(5085),
    [anon_sym_PIPE_PIPE] = ACTIONS(5087),
    [anon_sym_AMP_AMP] = ACTIONS(5089),
    [anon_sym_LT] = ACTIONS(5091),
    [anon_sym_LT_EQ] = ACTIONS(5093),
    [anon_sym_GT] = ACTIONS(5091),
    [anon_sym_GT_EQ] = ACTIONS(5093),
    [anon_sym_EQ_EQ] = ACTIONS(5093),
    [anon_sym_BANG_EQ] = ACTIONS(5093),
    [anon_sym_STAR] = ACTIONS(5095),
    [anon_sym_SLASH] = ACTIONS(5097),
    [anon_sym_STAR_STAR] = ACTIONS(5099),
    [anon_sym_CARET] = ACTIONS(5099),
    [aux_sym_binary_operator_token1] = ACTIONS(5101),
    [anon_sym_PIPE_GT] = ACTIONS(5101),
    [anon_sym_COLON] = ACTIONS(5103),
    [anon_sym_DOLLAR] = ACTIONS(5105),
    [anon_sym_AT] = ACTIONS(5105),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5109),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5111),
    [sym__external_open_bracket2] = ACTIONS(5113),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [641] = {
    [sym_call_arguments] = STATE(2342),
    [sym_subset_arguments] = STATE(2343),
    [sym_subset2_arguments] = STATE(2346),
    [sym__open_parenthesis] = STATE(1325),
    [sym__open_bracket] = STATE(1322),
    [sym__open_bracket2] = STATE(1607),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5069),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5071),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5073),
    [anon_sym_DASH] = ACTIONS(5075),
    [anon_sym_LT_DASH] = ACTIONS(5077),
    [anon_sym_LT_LT_DASH] = ACTIONS(5077),
    [anon_sym_COLON_EQ] = ACTIONS(5077),
    [anon_sym_DASH_GT] = ACTIONS(5079),
    [anon_sym_DASH_GT_GT] = ACTIONS(5081),
    [anon_sym_PIPE] = ACTIONS(5083),
    [anon_sym_AMP] = ACTIONS(5085),
    [anon_sym_PIPE_PIPE] = ACTIONS(5087),
    [anon_sym_AMP_AMP] = ACTIONS(5089),
    [anon_sym_LT] = ACTIONS(5091),
    [anon_sym_LT_EQ] = ACTIONS(5093),
    [anon_sym_GT] = ACTIONS(5091),
    [anon_sym_GT_EQ] = ACTIONS(5093),
    [anon_sym_EQ_EQ] = ACTIONS(5093),
    [anon_sym_BANG_EQ] = ACTIONS(5093),
    [anon_sym_STAR] = ACTIONS(5095),
    [anon_sym_SLASH] = ACTIONS(5097),
    [anon_sym_STAR_STAR] = ACTIONS(5099),
    [anon_sym_CARET] = ACTIONS(5099),
    [aux_sym_binary_operator_token1] = ACTIONS(5101),
    [anon_sym_PIPE_GT] = ACTIONS(5101),
    [anon_sym_COLON] = ACTIONS(5103),
    [anon_sym_DOLLAR] = ACTIONS(5105),
    [anon_sym_AT] = ACTIONS(5105),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5109),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5111),
    [sym__external_open_bracket2] = ACTIONS(5113),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [642] = {
    [sym_call_arguments] = STATE(2342),
    [sym_subset_arguments] = STATE(2343),
    [sym_subset2_arguments] = STATE(2346),
    [sym__open_parenthesis] = STATE(1325),
    [sym__open_bracket] = STATE(1322),
    [sym__open_bracket2] = STATE(1607),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5073),
    [anon_sym_DASH] = ACTIONS(5075),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5083),
    [anon_sym_AMP] = ACTIONS(5085),
    [anon_sym_PIPE_PIPE] = ACTIONS(5087),
    [anon_sym_AMP_AMP] = ACTIONS(5089),
    [anon_sym_LT] = ACTIONS(5091),
    [anon_sym_LT_EQ] = ACTIONS(5093),
    [anon_sym_GT] = ACTIONS(5091),
    [anon_sym_GT_EQ] = ACTIONS(5093),
    [anon_sym_EQ_EQ] = ACTIONS(5093),
    [anon_sym_BANG_EQ] = ACTIONS(5093),
    [anon_sym_STAR] = ACTIONS(5095),
    [anon_sym_SLASH] = ACTIONS(5097),
    [anon_sym_STAR_STAR] = ACTIONS(5099),
    [anon_sym_CARET] = ACTIONS(5099),
    [aux_sym_binary_operator_token1] = ACTIONS(5101),
    [anon_sym_PIPE_GT] = ACTIONS(5101),
    [anon_sym_COLON] = ACTIONS(5103),
    [anon_sym_DOLLAR] = ACTIONS(5105),
    [anon_sym_AT] = ACTIONS(5105),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5109),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5111),
    [sym__external_open_bracket2] = ACTIONS(5113),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [643] = {
    [sym_call_arguments] = STATE(2342),
    [sym_subset_arguments] = STATE(2343),
    [sym_subset2_arguments] = STATE(2346),
    [sym__open_parenthesis] = STATE(1325),
    [sym__open_bracket] = STATE(1322),
    [sym__open_bracket2] = STATE(1607),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5095),
    [anon_sym_SLASH] = ACTIONS(5097),
    [anon_sym_STAR_STAR] = ACTIONS(5099),
    [anon_sym_CARET] = ACTIONS(5099),
    [aux_sym_binary_operator_token1] = ACTIONS(5101),
    [anon_sym_PIPE_GT] = ACTIONS(5101),
    [anon_sym_COLON] = ACTIONS(5103),
    [anon_sym_DOLLAR] = ACTIONS(5105),
    [anon_sym_AT] = ACTIONS(5105),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5109),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5111),
    [sym__external_open_bracket2] = ACTIONS(5113),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [644] = {
    [sym_call_arguments] = STATE(2342),
    [sym_subset_arguments] = STATE(2343),
    [sym_subset2_arguments] = STATE(2346),
    [sym__open_parenthesis] = STATE(1325),
    [sym__open_bracket] = STATE(1322),
    [sym__open_bracket2] = STATE(1607),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5069),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5071),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5073),
    [anon_sym_DASH] = ACTIONS(5075),
    [anon_sym_LT_DASH] = ACTIONS(5077),
    [anon_sym_LT_LT_DASH] = ACTIONS(5077),
    [anon_sym_COLON_EQ] = ACTIONS(5077),
    [anon_sym_DASH_GT] = ACTIONS(5079),
    [anon_sym_DASH_GT_GT] = ACTIONS(5081),
    [anon_sym_PIPE] = ACTIONS(5083),
    [anon_sym_AMP] = ACTIONS(5085),
    [anon_sym_PIPE_PIPE] = ACTIONS(5087),
    [anon_sym_AMP_AMP] = ACTIONS(5089),
    [anon_sym_LT] = ACTIONS(5091),
    [anon_sym_LT_EQ] = ACTIONS(5093),
    [anon_sym_GT] = ACTIONS(5091),
    [anon_sym_GT_EQ] = ACTIONS(5093),
    [anon_sym_EQ_EQ] = ACTIONS(5093),
    [anon_sym_BANG_EQ] = ACTIONS(5093),
    [anon_sym_STAR] = ACTIONS(5095),
    [anon_sym_SLASH] = ACTIONS(5097),
    [anon_sym_STAR_STAR] = ACTIONS(5099),
    [anon_sym_CARET] = ACTIONS(5099),
    [aux_sym_binary_operator_token1] = ACTIONS(5101),
    [anon_sym_PIPE_GT] = ACTIONS(5101),
    [anon_sym_COLON] = ACTIONS(5103),
    [anon_sym_DOLLAR] = ACTIONS(5105),
    [anon_sym_AT] = ACTIONS(5105),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5109),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5111),
    [sym__external_open_bracket2] = ACTIONS(5113),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [645] = {
    [sym_call_arguments] = STATE(2342),
    [sym_subset_arguments] = STATE(2343),
    [sym_subset2_arguments] = STATE(2346),
    [sym__open_parenthesis] = STATE(1325),
    [sym__open_bracket] = STATE(1322),
    [sym__open_bracket2] = STATE(1607),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5071),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5073),
    [anon_sym_DASH] = ACTIONS(5075),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5083),
    [anon_sym_AMP] = ACTIONS(5085),
    [anon_sym_PIPE_PIPE] = ACTIONS(5087),
    [anon_sym_AMP_AMP] = ACTIONS(5089),
    [anon_sym_LT] = ACTIONS(5091),
    [anon_sym_LT_EQ] = ACTIONS(5093),
    [anon_sym_GT] = ACTIONS(5091),
    [anon_sym_GT_EQ] = ACTIONS(5093),
    [anon_sym_EQ_EQ] = ACTIONS(5093),
    [anon_sym_BANG_EQ] = ACTIONS(5093),
    [anon_sym_STAR] = ACTIONS(5095),
    [anon_sym_SLASH] = ACTIONS(5097),
    [anon_sym_STAR_STAR] = ACTIONS(5099),
    [anon_sym_CARET] = ACTIONS(5099),
    [aux_sym_binary_operator_token1] = ACTIONS(5101),
    [anon_sym_PIPE_GT] = ACTIONS(5101),
    [anon_sym_COLON] = ACTIONS(5103),
    [anon_sym_DOLLAR] = ACTIONS(5105),
    [anon_sym_AT] = ACTIONS(5105),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5109),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5111),
    [sym__external_open_bracket2] = ACTIONS(5113),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [646] = {
    [sym_call_arguments] = STATE(2342),
    [sym_subset_arguments] = STATE(2343),
    [sym_subset2_arguments] = STATE(2346),
    [sym__open_parenthesis] = STATE(1325),
    [sym__open_bracket] = STATE(1322),
    [sym__open_bracket2] = STATE(1607),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5073),
    [anon_sym_DASH] = ACTIONS(5075),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5085),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5089),
    [anon_sym_LT] = ACTIONS(5091),
    [anon_sym_LT_EQ] = ACTIONS(5093),
    [anon_sym_GT] = ACTIONS(5091),
    [anon_sym_GT_EQ] = ACTIONS(5093),
    [anon_sym_EQ_EQ] = ACTIONS(5093),
    [anon_sym_BANG_EQ] = ACTIONS(5093),
    [anon_sym_STAR] = ACTIONS(5095),
    [anon_sym_SLASH] = ACTIONS(5097),
    [anon_sym_STAR_STAR] = ACTIONS(5099),
    [anon_sym_CARET] = ACTIONS(5099),
    [aux_sym_binary_operator_token1] = ACTIONS(5101),
    [anon_sym_PIPE_GT] = ACTIONS(5101),
    [anon_sym_COLON] = ACTIONS(5103),
    [anon_sym_DOLLAR] = ACTIONS(5105),
    [anon_sym_AT] = ACTIONS(5105),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5109),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5111),
    [sym__external_open_bracket2] = ACTIONS(5113),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [647] = {
    [sym_call_arguments] = STATE(2342),
    [sym_subset_arguments] = STATE(2343),
    [sym_subset2_arguments] = STATE(2346),
    [sym__open_parenthesis] = STATE(1325),
    [sym__open_bracket] = STATE(1322),
    [sym__open_bracket2] = STATE(1607),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5073),
    [anon_sym_DASH] = ACTIONS(5075),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5091),
    [anon_sym_LT_EQ] = ACTIONS(5093),
    [anon_sym_GT] = ACTIONS(5091),
    [anon_sym_GT_EQ] = ACTIONS(5093),
    [anon_sym_EQ_EQ] = ACTIONS(5093),
    [anon_sym_BANG_EQ] = ACTIONS(5093),
    [anon_sym_STAR] = ACTIONS(5095),
    [anon_sym_SLASH] = ACTIONS(5097),
    [anon_sym_STAR_STAR] = ACTIONS(5099),
    [anon_sym_CARET] = ACTIONS(5099),
    [aux_sym_binary_operator_token1] = ACTIONS(5101),
    [anon_sym_PIPE_GT] = ACTIONS(5101),
    [anon_sym_COLON] = ACTIONS(5103),
    [anon_sym_DOLLAR] = ACTIONS(5105),
    [anon_sym_AT] = ACTIONS(5105),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5109),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5111),
    [sym__external_open_bracket2] = ACTIONS(5113),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [648] = {
    [sym_call_arguments] = STATE(2342),
    [sym_subset_arguments] = STATE(2343),
    [sym_subset2_arguments] = STATE(2346),
    [sym__open_parenthesis] = STATE(1325),
    [sym__open_bracket] = STATE(1322),
    [sym__open_bracket2] = STATE(1607),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5073),
    [anon_sym_DASH] = ACTIONS(5075),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5095),
    [anon_sym_SLASH] = ACTIONS(5097),
    [anon_sym_STAR_STAR] = ACTIONS(5099),
    [anon_sym_CARET] = ACTIONS(5099),
    [aux_sym_binary_operator_token1] = ACTIONS(5101),
    [anon_sym_PIPE_GT] = ACTIONS(5101),
    [anon_sym_COLON] = ACTIONS(5103),
    [anon_sym_DOLLAR] = ACTIONS(5105),
    [anon_sym_AT] = ACTIONS(5105),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5109),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5111),
    [sym__external_open_bracket2] = ACTIONS(5113),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [649] = {
    [sym_call_arguments] = STATE(2342),
    [sym_subset_arguments] = STATE(2343),
    [sym_subset2_arguments] = STATE(2346),
    [sym__open_parenthesis] = STATE(1325),
    [sym__open_bracket] = STATE(1322),
    [sym__open_bracket2] = STATE(1607),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(5099),
    [anon_sym_CARET] = ACTIONS(5099),
    [aux_sym_binary_operator_token1] = ACTIONS(5101),
    [anon_sym_PIPE_GT] = ACTIONS(5101),
    [anon_sym_COLON] = ACTIONS(5103),
    [anon_sym_DOLLAR] = ACTIONS(5105),
    [anon_sym_AT] = ACTIONS(5105),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5109),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5111),
    [sym__external_open_bracket2] = ACTIONS(5113),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [650] = {
    [sym_call_arguments] = STATE(2342),
    [sym_subset_arguments] = STATE(2343),
    [sym_subset2_arguments] = STATE(2346),
    [sym__open_parenthesis] = STATE(1325),
    [sym__open_bracket] = STATE(1322),
    [sym__open_bracket2] = STATE(1607),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(5099),
    [anon_sym_CARET] = ACTIONS(5099),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(5261),
    [anon_sym_DOLLAR] = ACTIONS(5105),
    [anon_sym_AT] = ACTIONS(5105),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5109),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5111),
    [sym__external_open_bracket2] = ACTIONS(5113),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [651] = {
    [sym_call_arguments] = STATE(2342),
    [sym_subset_arguments] = STATE(2343),
    [sym_subset2_arguments] = STATE(2346),
    [sym__open_parenthesis] = STATE(1325),
    [sym__open_bracket] = STATE(1322),
    [sym__open_bracket2] = STATE(1607),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(5099),
    [anon_sym_CARET] = ACTIONS(5099),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(5103),
    [anon_sym_DOLLAR] = ACTIONS(5105),
    [anon_sym_AT] = ACTIONS(5105),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5109),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5111),
    [sym__external_open_bracket2] = ACTIONS(5113),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [652] = {
    [sym_call_arguments] = STATE(2342),
    [sym_subset_arguments] = STATE(2343),
    [sym_subset2_arguments] = STATE(2346),
    [sym__open_parenthesis] = STATE(1325),
    [sym__open_bracket] = STATE(1322),
    [sym__open_bracket2] = STATE(1607),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(5099),
    [anon_sym_CARET] = ACTIONS(5099),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(5261),
    [anon_sym_DOLLAR] = ACTIONS(5105),
    [anon_sym_AT] = ACTIONS(5105),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5109),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5111),
    [sym__external_open_bracket2] = ACTIONS(5113),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [653] = {
    [sym_call_arguments] = STATE(2342),
    [sym_subset_arguments] = STATE(2343),
    [sym_subset2_arguments] = STATE(2346),
    [sym__open_parenthesis] = STATE(1325),
    [sym__open_bracket] = STATE(1322),
    [sym__open_bracket2] = STATE(1607),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_BSLASH] = ACTIONS(5413),
    [anon_sym_function] = ACTIONS(5415),
    [anon_sym_EQ] = ACTIONS(5069),
    [anon_sym_if] = ACTIONS(5415),
    [anon_sym_for] = ACTIONS(5415),
    [anon_sym_while] = ACTIONS(5415),
    [anon_sym_repeat] = ACTIONS(5415),
    [anon_sym_QMARK] = ACTIONS(5413),
    [anon_sym_TILDE] = ACTIONS(5071),
    [anon_sym_BANG] = ACTIONS(5415),
    [anon_sym_PLUS] = ACTIONS(5073),
    [anon_sym_DASH] = ACTIONS(5075),
    [anon_sym_LT_DASH] = ACTIONS(5077),
    [anon_sym_LT_LT_DASH] = ACTIONS(5077),
    [anon_sym_COLON_EQ] = ACTIONS(5077),
    [anon_sym_DASH_GT] = ACTIONS(5079),
    [anon_sym_DASH_GT_GT] = ACTIONS(5081),
    [anon_sym_PIPE] = ACTIONS(5083),
    [anon_sym_AMP] = ACTIONS(5085),
    [anon_sym_PIPE_PIPE] = ACTIONS(5087),
    [anon_sym_AMP_AMP] = ACTIONS(5089),
    [anon_sym_LT] = ACTIONS(5091),
    [anon_sym_LT_EQ] = ACTIONS(5093),
    [anon_sym_GT] = ACTIONS(5091),
    [anon_sym_GT_EQ] = ACTIONS(5093),
    [anon_sym_EQ_EQ] = ACTIONS(5093),
    [anon_sym_BANG_EQ] = ACTIONS(5093),
    [anon_sym_STAR] = ACTIONS(5095),
    [anon_sym_SLASH] = ACTIONS(5097),
    [anon_sym_STAR_STAR] = ACTIONS(5099),
    [anon_sym_CARET] = ACTIONS(5099),
    [aux_sym_binary_operator_token1] = ACTIONS(5101),
    [anon_sym_PIPE_GT] = ACTIONS(5101),
    [anon_sym_COLON] = ACTIONS(5103),
    [anon_sym_DOLLAR] = ACTIONS(5105),
    [anon_sym_AT] = ACTIONS(5105),
    [aux_sym__hex_literal_token1] = ACTIONS(5413),
    [sym__number_literal] = ACTIONS(5415),
    [anon_sym_SQUOTE] = ACTIONS(5413),
    [anon_sym_DQUOTE] = ACTIONS(5413),
    [sym_return] = ACTIONS(5415),
    [sym_next] = ACTIONS(5415),
    [sym_break] = ACTIONS(5415),
    [sym_true] = ACTIONS(5415),
    [sym_false] = ACTIONS(5415),
    [sym_null] = ACTIONS(5415),
    [sym_inf] = ACTIONS(5415),
    [sym_nan] = ACTIONS(5415),
    [anon_sym_NA] = ACTIONS(5415),
    [anon_sym_NA_integer_] = ACTIONS(5415),
    [anon_sym_NA_real_] = ACTIONS(5415),
    [anon_sym_NA_complex_] = ACTIONS(5415),
    [anon_sym_NA_character_] = ACTIONS(5415),
    [sym_dots] = ACTIONS(5415),
    [sym_dot_dot_i] = ACTIONS(5413),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5413),
    [sym__newline] = ACTIONS(5413),
    [sym__semicolon] = ACTIONS(5413),
    [sym__raw_string_literal] = ACTIONS(5413),
    [sym__external_else] = ACTIONS(5413),
    [sym__external_open_parenthesis] = ACTIONS(5109),
    [sym__external_close_parenthesis] = ACTIONS(5413),
    [sym__external_open_brace] = ACTIONS(5413),
    [sym__external_close_brace] = ACTIONS(5413),
    [sym__external_open_bracket] = ACTIONS(5111),
    [sym__external_open_bracket2] = ACTIONS(5113),
    [sym__external_close_bracket2] = ACTIONS(5413),
  },
  [654] = {
    [sym_call_arguments] = STATE(2342),
    [sym_subset_arguments] = STATE(2343),
    [sym_subset2_arguments] = STATE(2346),
    [sym__open_parenthesis] = STATE(1325),
    [sym__open_bracket] = STATE(1322),
    [sym__open_bracket2] = STATE(1607),
    [sym_identifier] = ACTIONS(5419),
    [anon_sym_BSLASH] = ACTIONS(5417),
    [anon_sym_function] = ACTIONS(5419),
    [anon_sym_EQ] = ACTIONS(5069),
    [anon_sym_if] = ACTIONS(5419),
    [anon_sym_for] = ACTIONS(5419),
    [anon_sym_while] = ACTIONS(5419),
    [anon_sym_repeat] = ACTIONS(5419),
    [anon_sym_QMARK] = ACTIONS(5417),
    [anon_sym_TILDE] = ACTIONS(5071),
    [anon_sym_BANG] = ACTIONS(5419),
    [anon_sym_PLUS] = ACTIONS(5073),
    [anon_sym_DASH] = ACTIONS(5075),
    [anon_sym_LT_DASH] = ACTIONS(5077),
    [anon_sym_LT_LT_DASH] = ACTIONS(5077),
    [anon_sym_COLON_EQ] = ACTIONS(5077),
    [anon_sym_DASH_GT] = ACTIONS(5079),
    [anon_sym_DASH_GT_GT] = ACTIONS(5081),
    [anon_sym_PIPE] = ACTIONS(5083),
    [anon_sym_AMP] = ACTIONS(5085),
    [anon_sym_PIPE_PIPE] = ACTIONS(5087),
    [anon_sym_AMP_AMP] = ACTIONS(5089),
    [anon_sym_LT] = ACTIONS(5091),
    [anon_sym_LT_EQ] = ACTIONS(5093),
    [anon_sym_GT] = ACTIONS(5091),
    [anon_sym_GT_EQ] = ACTIONS(5093),
    [anon_sym_EQ_EQ] = ACTIONS(5093),
    [anon_sym_BANG_EQ] = ACTIONS(5093),
    [anon_sym_STAR] = ACTIONS(5095),
    [anon_sym_SLASH] = ACTIONS(5097),
    [anon_sym_STAR_STAR] = ACTIONS(5099),
    [anon_sym_CARET] = ACTIONS(5099),
    [aux_sym_binary_operator_token1] = ACTIONS(5101),
    [anon_sym_PIPE_GT] = ACTIONS(5101),
    [anon_sym_COLON] = ACTIONS(5103),
    [anon_sym_DOLLAR] = ACTIONS(5105),
    [anon_sym_AT] = ACTIONS(5105),
    [aux_sym__hex_literal_token1] = ACTIONS(5417),
    [sym__number_literal] = ACTIONS(5419),
    [anon_sym_SQUOTE] = ACTIONS(5417),
    [anon_sym_DQUOTE] = ACTIONS(5417),
    [sym_return] = ACTIONS(5419),
    [sym_next] = ACTIONS(5419),
    [sym_break] = ACTIONS(5419),
    [sym_true] = ACTIONS(5419),
    [sym_false] = ACTIONS(5419),
    [sym_null] = ACTIONS(5419),
    [sym_inf] = ACTIONS(5419),
    [sym_nan] = ACTIONS(5419),
    [anon_sym_NA] = ACTIONS(5419),
    [anon_sym_NA_integer_] = ACTIONS(5419),
    [anon_sym_NA_real_] = ACTIONS(5419),
    [anon_sym_NA_complex_] = ACTIONS(5419),
    [anon_sym_NA_character_] = ACTIONS(5419),
    [sym_dots] = ACTIONS(5419),
    [sym_dot_dot_i] = ACTIONS(5417),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5417),
    [sym__newline] = ACTIONS(5417),
    [sym__semicolon] = ACTIONS(5417),
    [sym__raw_string_literal] = ACTIONS(5417),
    [sym__external_else] = ACTIONS(5417),
    [sym__external_open_parenthesis] = ACTIONS(5109),
    [sym__external_close_parenthesis] = ACTIONS(5417),
    [sym__external_open_brace] = ACTIONS(5417),
    [sym__external_close_brace] = ACTIONS(5417),
    [sym__external_open_bracket] = ACTIONS(5111),
    [sym__external_open_bracket2] = ACTIONS(5113),
    [sym__external_close_bracket2] = ACTIONS(5417),
  },
  [655] = {
    [sym_call_arguments] = STATE(2342),
    [sym_subset_arguments] = STATE(2343),
    [sym_subset2_arguments] = STATE(2346),
    [sym__open_parenthesis] = STATE(1325),
    [sym__open_bracket] = STATE(1322),
    [sym__open_bracket2] = STATE(1607),
    [sym_identifier] = ACTIONS(5423),
    [anon_sym_BSLASH] = ACTIONS(5421),
    [anon_sym_function] = ACTIONS(5423),
    [anon_sym_EQ] = ACTIONS(5069),
    [anon_sym_if] = ACTIONS(5423),
    [anon_sym_for] = ACTIONS(5423),
    [anon_sym_while] = ACTIONS(5423),
    [anon_sym_repeat] = ACTIONS(5423),
    [anon_sym_QMARK] = ACTIONS(5421),
    [anon_sym_TILDE] = ACTIONS(5071),
    [anon_sym_BANG] = ACTIONS(5423),
    [anon_sym_PLUS] = ACTIONS(5073),
    [anon_sym_DASH] = ACTIONS(5075),
    [anon_sym_LT_DASH] = ACTIONS(5077),
    [anon_sym_LT_LT_DASH] = ACTIONS(5077),
    [anon_sym_COLON_EQ] = ACTIONS(5077),
    [anon_sym_DASH_GT] = ACTIONS(5079),
    [anon_sym_DASH_GT_GT] = ACTIONS(5081),
    [anon_sym_PIPE] = ACTIONS(5083),
    [anon_sym_AMP] = ACTIONS(5085),
    [anon_sym_PIPE_PIPE] = ACTIONS(5087),
    [anon_sym_AMP_AMP] = ACTIONS(5089),
    [anon_sym_LT] = ACTIONS(5091),
    [anon_sym_LT_EQ] = ACTIONS(5093),
    [anon_sym_GT] = ACTIONS(5091),
    [anon_sym_GT_EQ] = ACTIONS(5093),
    [anon_sym_EQ_EQ] = ACTIONS(5093),
    [anon_sym_BANG_EQ] = ACTIONS(5093),
    [anon_sym_STAR] = ACTIONS(5095),
    [anon_sym_SLASH] = ACTIONS(5097),
    [anon_sym_STAR_STAR] = ACTIONS(5099),
    [anon_sym_CARET] = ACTIONS(5099),
    [aux_sym_binary_operator_token1] = ACTIONS(5101),
    [anon_sym_PIPE_GT] = ACTIONS(5101),
    [anon_sym_COLON] = ACTIONS(5103),
    [anon_sym_DOLLAR] = ACTIONS(5105),
    [anon_sym_AT] = ACTIONS(5105),
    [aux_sym__hex_literal_token1] = ACTIONS(5421),
    [sym__number_literal] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5421),
    [anon_sym_DQUOTE] = ACTIONS(5421),
    [sym_return] = ACTIONS(5423),
    [sym_next] = ACTIONS(5423),
    [sym_break] = ACTIONS(5423),
    [sym_true] = ACTIONS(5423),
    [sym_false] = ACTIONS(5423),
    [sym_null] = ACTIONS(5423),
    [sym_inf] = ACTIONS(5423),
    [sym_nan] = ACTIONS(5423),
    [anon_sym_NA] = ACTIONS(5423),
    [anon_sym_NA_integer_] = ACTIONS(5423),
    [anon_sym_NA_real_] = ACTIONS(5423),
    [anon_sym_NA_complex_] = ACTIONS(5423),
    [anon_sym_NA_character_] = ACTIONS(5423),
    [sym_dots] = ACTIONS(5423),
    [sym_dot_dot_i] = ACTIONS(5421),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5421),
    [sym__newline] = ACTIONS(5421),
    [sym__semicolon] = ACTIONS(5421),
    [sym__raw_string_literal] = ACTIONS(5421),
    [sym__external_else] = ACTIONS(5421),
    [sym__external_open_parenthesis] = ACTIONS(5109),
    [sym__external_close_parenthesis] = ACTIONS(5421),
    [sym__external_open_brace] = ACTIONS(5421),
    [sym__external_close_brace] = ACTIONS(5421),
    [sym__external_open_bracket] = ACTIONS(5111),
    [sym__external_open_bracket2] = ACTIONS(5113),
    [sym__external_close_bracket2] = ACTIONS(5421),
  },
  [656] = {
    [sym_call_arguments] = STATE(2342),
    [sym_subset_arguments] = STATE(2343),
    [sym_subset2_arguments] = STATE(2346),
    [sym__open_parenthesis] = STATE(1325),
    [sym__open_bracket] = STATE(1322),
    [sym__open_bracket2] = STATE(1607),
    [sym_identifier] = ACTIONS(5427),
    [anon_sym_BSLASH] = ACTIONS(5425),
    [anon_sym_function] = ACTIONS(5427),
    [anon_sym_EQ] = ACTIONS(5069),
    [anon_sym_if] = ACTIONS(5427),
    [anon_sym_for] = ACTIONS(5427),
    [anon_sym_while] = ACTIONS(5427),
    [anon_sym_repeat] = ACTIONS(5427),
    [anon_sym_QMARK] = ACTIONS(5425),
    [anon_sym_TILDE] = ACTIONS(5071),
    [anon_sym_BANG] = ACTIONS(5427),
    [anon_sym_PLUS] = ACTIONS(5073),
    [anon_sym_DASH] = ACTIONS(5075),
    [anon_sym_LT_DASH] = ACTIONS(5077),
    [anon_sym_LT_LT_DASH] = ACTIONS(5077),
    [anon_sym_COLON_EQ] = ACTIONS(5077),
    [anon_sym_DASH_GT] = ACTIONS(5079),
    [anon_sym_DASH_GT_GT] = ACTIONS(5081),
    [anon_sym_PIPE] = ACTIONS(5083),
    [anon_sym_AMP] = ACTIONS(5085),
    [anon_sym_PIPE_PIPE] = ACTIONS(5087),
    [anon_sym_AMP_AMP] = ACTIONS(5089),
    [anon_sym_LT] = ACTIONS(5091),
    [anon_sym_LT_EQ] = ACTIONS(5093),
    [anon_sym_GT] = ACTIONS(5091),
    [anon_sym_GT_EQ] = ACTIONS(5093),
    [anon_sym_EQ_EQ] = ACTIONS(5093),
    [anon_sym_BANG_EQ] = ACTIONS(5093),
    [anon_sym_STAR] = ACTIONS(5095),
    [anon_sym_SLASH] = ACTIONS(5097),
    [anon_sym_STAR_STAR] = ACTIONS(5099),
    [anon_sym_CARET] = ACTIONS(5099),
    [aux_sym_binary_operator_token1] = ACTIONS(5101),
    [anon_sym_PIPE_GT] = ACTIONS(5101),
    [anon_sym_COLON] = ACTIONS(5103),
    [anon_sym_DOLLAR] = ACTIONS(5105),
    [anon_sym_AT] = ACTIONS(5105),
    [aux_sym__hex_literal_token1] = ACTIONS(5425),
    [sym__number_literal] = ACTIONS(5427),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_DQUOTE] = ACTIONS(5425),
    [sym_return] = ACTIONS(5427),
    [sym_next] = ACTIONS(5427),
    [sym_break] = ACTIONS(5427),
    [sym_true] = ACTIONS(5427),
    [sym_false] = ACTIONS(5427),
    [sym_null] = ACTIONS(5427),
    [sym_inf] = ACTIONS(5427),
    [sym_nan] = ACTIONS(5427),
    [anon_sym_NA] = ACTIONS(5427),
    [anon_sym_NA_integer_] = ACTIONS(5427),
    [anon_sym_NA_real_] = ACTIONS(5427),
    [anon_sym_NA_complex_] = ACTIONS(5427),
    [anon_sym_NA_character_] = ACTIONS(5427),
    [sym_dots] = ACTIONS(5427),
    [sym_dot_dot_i] = ACTIONS(5425),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5425),
    [sym__newline] = ACTIONS(5425),
    [sym__semicolon] = ACTIONS(5425),
    [sym__raw_string_literal] = ACTIONS(5425),
    [sym__external_else] = ACTIONS(5425),
    [sym__external_open_parenthesis] = ACTIONS(5109),
    [sym__external_close_parenthesis] = ACTIONS(5425),
    [sym__external_open_brace] = ACTIONS(5425),
    [sym__external_close_brace] = ACTIONS(5425),
    [sym__external_open_bracket] = ACTIONS(5111),
    [sym__external_open_bracket2] = ACTIONS(5113),
    [sym__external_close_bracket2] = ACTIONS(5425),
  },
  [657] = {
    [sym_call_arguments] = STATE(2342),
    [sym_subset_arguments] = STATE(2343),
    [sym_subset2_arguments] = STATE(2346),
    [sym__open_parenthesis] = STATE(1325),
    [sym__open_bracket] = STATE(1322),
    [sym__open_bracket2] = STATE(1607),
    [sym_identifier] = ACTIONS(5431),
    [anon_sym_BSLASH] = ACTIONS(5429),
    [anon_sym_function] = ACTIONS(5431),
    [anon_sym_EQ] = ACTIONS(5069),
    [anon_sym_if] = ACTIONS(5431),
    [anon_sym_for] = ACTIONS(5431),
    [anon_sym_while] = ACTIONS(5431),
    [anon_sym_repeat] = ACTIONS(5431),
    [anon_sym_QMARK] = ACTIONS(5429),
    [anon_sym_TILDE] = ACTIONS(5071),
    [anon_sym_BANG] = ACTIONS(5431),
    [anon_sym_PLUS] = ACTIONS(5073),
    [anon_sym_DASH] = ACTIONS(5075),
    [anon_sym_LT_DASH] = ACTIONS(5077),
    [anon_sym_LT_LT_DASH] = ACTIONS(5077),
    [anon_sym_COLON_EQ] = ACTIONS(5077),
    [anon_sym_DASH_GT] = ACTIONS(5079),
    [anon_sym_DASH_GT_GT] = ACTIONS(5081),
    [anon_sym_PIPE] = ACTIONS(5083),
    [anon_sym_AMP] = ACTIONS(5085),
    [anon_sym_PIPE_PIPE] = ACTIONS(5087),
    [anon_sym_AMP_AMP] = ACTIONS(5089),
    [anon_sym_LT] = ACTIONS(5091),
    [anon_sym_LT_EQ] = ACTIONS(5093),
    [anon_sym_GT] = ACTIONS(5091),
    [anon_sym_GT_EQ] = ACTIONS(5093),
    [anon_sym_EQ_EQ] = ACTIONS(5093),
    [anon_sym_BANG_EQ] = ACTIONS(5093),
    [anon_sym_STAR] = ACTIONS(5095),
    [anon_sym_SLASH] = ACTIONS(5097),
    [anon_sym_STAR_STAR] = ACTIONS(5099),
    [anon_sym_CARET] = ACTIONS(5099),
    [aux_sym_binary_operator_token1] = ACTIONS(5101),
    [anon_sym_PIPE_GT] = ACTIONS(5101),
    [anon_sym_COLON] = ACTIONS(5103),
    [anon_sym_DOLLAR] = ACTIONS(5105),
    [anon_sym_AT] = ACTIONS(5105),
    [aux_sym__hex_literal_token1] = ACTIONS(5429),
    [sym__number_literal] = ACTIONS(5431),
    [anon_sym_SQUOTE] = ACTIONS(5429),
    [anon_sym_DQUOTE] = ACTIONS(5429),
    [sym_return] = ACTIONS(5431),
    [sym_next] = ACTIONS(5431),
    [sym_break] = ACTIONS(5431),
    [sym_true] = ACTIONS(5431),
    [sym_false] = ACTIONS(5431),
    [sym_null] = ACTIONS(5431),
    [sym_inf] = ACTIONS(5431),
    [sym_nan] = ACTIONS(5431),
    [anon_sym_NA] = ACTIONS(5431),
    [anon_sym_NA_integer_] = ACTIONS(5431),
    [anon_sym_NA_real_] = ACTIONS(5431),
    [anon_sym_NA_complex_] = ACTIONS(5431),
    [anon_sym_NA_character_] = ACTIONS(5431),
    [sym_dots] = ACTIONS(5431),
    [sym_dot_dot_i] = ACTIONS(5429),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5429),
    [sym__newline] = ACTIONS(5429),
    [sym__semicolon] = ACTIONS(5429),
    [sym__raw_string_literal] = ACTIONS(5429),
    [sym__external_else] = ACTIONS(5429),
    [sym__external_open_parenthesis] = ACTIONS(5109),
    [sym__external_close_parenthesis] = ACTIONS(5429),
    [sym__external_open_brace] = ACTIONS(5429),
    [sym__external_close_brace] = ACTIONS(5429),
    [sym__external_open_bracket] = ACTIONS(5111),
    [sym__external_open_bracket2] = ACTIONS(5113),
    [sym__external_close_bracket2] = ACTIONS(5429),
  },
  [658] = {
    [sym_call_arguments] = STATE(2342),
    [sym_subset_arguments] = STATE(2343),
    [sym_subset2_arguments] = STATE(2346),
    [sym__open_parenthesis] = STATE(1325),
    [sym__open_bracket] = STATE(1322),
    [sym__open_bracket2] = STATE(1607),
    [sym_identifier] = ACTIONS(5435),
    [anon_sym_BSLASH] = ACTIONS(5433),
    [anon_sym_function] = ACTIONS(5435),
    [anon_sym_EQ] = ACTIONS(5069),
    [anon_sym_if] = ACTIONS(5435),
    [anon_sym_for] = ACTIONS(5435),
    [anon_sym_while] = ACTIONS(5435),
    [anon_sym_repeat] = ACTIONS(5435),
    [anon_sym_QMARK] = ACTIONS(5433),
    [anon_sym_TILDE] = ACTIONS(5071),
    [anon_sym_BANG] = ACTIONS(5435),
    [anon_sym_PLUS] = ACTIONS(5073),
    [anon_sym_DASH] = ACTIONS(5075),
    [anon_sym_LT_DASH] = ACTIONS(5077),
    [anon_sym_LT_LT_DASH] = ACTIONS(5077),
    [anon_sym_COLON_EQ] = ACTIONS(5077),
    [anon_sym_DASH_GT] = ACTIONS(5079),
    [anon_sym_DASH_GT_GT] = ACTIONS(5081),
    [anon_sym_PIPE] = ACTIONS(5083),
    [anon_sym_AMP] = ACTIONS(5085),
    [anon_sym_PIPE_PIPE] = ACTIONS(5087),
    [anon_sym_AMP_AMP] = ACTIONS(5089),
    [anon_sym_LT] = ACTIONS(5091),
    [anon_sym_LT_EQ] = ACTIONS(5093),
    [anon_sym_GT] = ACTIONS(5091),
    [anon_sym_GT_EQ] = ACTIONS(5093),
    [anon_sym_EQ_EQ] = ACTIONS(5093),
    [anon_sym_BANG_EQ] = ACTIONS(5093),
    [anon_sym_STAR] = ACTIONS(5095),
    [anon_sym_SLASH] = ACTIONS(5097),
    [anon_sym_STAR_STAR] = ACTIONS(5099),
    [anon_sym_CARET] = ACTIONS(5099),
    [aux_sym_binary_operator_token1] = ACTIONS(5101),
    [anon_sym_PIPE_GT] = ACTIONS(5101),
    [anon_sym_COLON] = ACTIONS(5103),
    [anon_sym_DOLLAR] = ACTIONS(5105),
    [anon_sym_AT] = ACTIONS(5105),
    [aux_sym__hex_literal_token1] = ACTIONS(5433),
    [sym__number_literal] = ACTIONS(5435),
    [anon_sym_SQUOTE] = ACTIONS(5433),
    [anon_sym_DQUOTE] = ACTIONS(5433),
    [sym_return] = ACTIONS(5435),
    [sym_next] = ACTIONS(5435),
    [sym_break] = ACTIONS(5435),
    [sym_true] = ACTIONS(5435),
    [sym_false] = ACTIONS(5435),
    [sym_null] = ACTIONS(5435),
    [sym_inf] = ACTIONS(5435),
    [sym_nan] = ACTIONS(5435),
    [anon_sym_NA] = ACTIONS(5435),
    [anon_sym_NA_integer_] = ACTIONS(5435),
    [anon_sym_NA_real_] = ACTIONS(5435),
    [anon_sym_NA_complex_] = ACTIONS(5435),
    [anon_sym_NA_character_] = ACTIONS(5435),
    [sym_dots] = ACTIONS(5435),
    [sym_dot_dot_i] = ACTIONS(5433),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5433),
    [sym__newline] = ACTIONS(5433),
    [sym__semicolon] = ACTIONS(5433),
    [sym__raw_string_literal] = ACTIONS(5433),
    [sym__external_else] = ACTIONS(5433),
    [sym__external_open_parenthesis] = ACTIONS(5109),
    [sym__external_close_parenthesis] = ACTIONS(5433),
    [sym__external_open_brace] = ACTIONS(5433),
    [sym__external_close_brace] = ACTIONS(5433),
    [sym__external_open_bracket] = ACTIONS(5111),
    [sym__external_open_bracket2] = ACTIONS(5113),
    [sym__external_close_bracket2] = ACTIONS(5433),
  },
  [659] = {
    [sym_call_arguments] = STATE(2342),
    [sym_subset_arguments] = STATE(2343),
    [sym_subset2_arguments] = STATE(2346),
    [sym__open_parenthesis] = STATE(1325),
    [sym__open_bracket] = STATE(1322),
    [sym__open_bracket2] = STATE(1607),
    [sym_identifier] = ACTIONS(5439),
    [anon_sym_BSLASH] = ACTIONS(5437),
    [anon_sym_function] = ACTIONS(5439),
    [anon_sym_EQ] = ACTIONS(5069),
    [anon_sym_if] = ACTIONS(5439),
    [anon_sym_for] = ACTIONS(5439),
    [anon_sym_while] = ACTIONS(5439),
    [anon_sym_repeat] = ACTIONS(5439),
    [anon_sym_QMARK] = ACTIONS(5437),
    [anon_sym_TILDE] = ACTIONS(5071),
    [anon_sym_BANG] = ACTIONS(5439),
    [anon_sym_PLUS] = ACTIONS(5073),
    [anon_sym_DASH] = ACTIONS(5075),
    [anon_sym_LT_DASH] = ACTIONS(5077),
    [anon_sym_LT_LT_DASH] = ACTIONS(5077),
    [anon_sym_COLON_EQ] = ACTIONS(5077),
    [anon_sym_DASH_GT] = ACTIONS(5079),
    [anon_sym_DASH_GT_GT] = ACTIONS(5081),
    [anon_sym_PIPE] = ACTIONS(5083),
    [anon_sym_AMP] = ACTIONS(5085),
    [anon_sym_PIPE_PIPE] = ACTIONS(5087),
    [anon_sym_AMP_AMP] = ACTIONS(5089),
    [anon_sym_LT] = ACTIONS(5091),
    [anon_sym_LT_EQ] = ACTIONS(5093),
    [anon_sym_GT] = ACTIONS(5091),
    [anon_sym_GT_EQ] = ACTIONS(5093),
    [anon_sym_EQ_EQ] = ACTIONS(5093),
    [anon_sym_BANG_EQ] = ACTIONS(5093),
    [anon_sym_STAR] = ACTIONS(5095),
    [anon_sym_SLASH] = ACTIONS(5097),
    [anon_sym_STAR_STAR] = ACTIONS(5099),
    [anon_sym_CARET] = ACTIONS(5099),
    [aux_sym_binary_operator_token1] = ACTIONS(5101),
    [anon_sym_PIPE_GT] = ACTIONS(5101),
    [anon_sym_COLON] = ACTIONS(5103),
    [anon_sym_DOLLAR] = ACTIONS(5105),
    [anon_sym_AT] = ACTIONS(5105),
    [aux_sym__hex_literal_token1] = ACTIONS(5437),
    [sym__number_literal] = ACTIONS(5439),
    [anon_sym_SQUOTE] = ACTIONS(5437),
    [anon_sym_DQUOTE] = ACTIONS(5437),
    [sym_return] = ACTIONS(5439),
    [sym_next] = ACTIONS(5439),
    [sym_break] = ACTIONS(5439),
    [sym_true] = ACTIONS(5439),
    [sym_false] = ACTIONS(5439),
    [sym_null] = ACTIONS(5439),
    [sym_inf] = ACTIONS(5439),
    [sym_nan] = ACTIONS(5439),
    [anon_sym_NA] = ACTIONS(5439),
    [anon_sym_NA_integer_] = ACTIONS(5439),
    [anon_sym_NA_real_] = ACTIONS(5439),
    [anon_sym_NA_complex_] = ACTIONS(5439),
    [anon_sym_NA_character_] = ACTIONS(5439),
    [sym_dots] = ACTIONS(5439),
    [sym_dot_dot_i] = ACTIONS(5437),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5437),
    [sym__newline] = ACTIONS(5437),
    [sym__semicolon] = ACTIONS(5437),
    [sym__raw_string_literal] = ACTIONS(5437),
    [sym__external_else] = ACTIONS(5437),
    [sym__external_open_parenthesis] = ACTIONS(5109),
    [sym__external_close_parenthesis] = ACTIONS(5437),
    [sym__external_open_brace] = ACTIONS(5437),
    [sym__external_close_brace] = ACTIONS(5437),
    [sym__external_open_bracket] = ACTIONS(5111),
    [sym__external_open_bracket2] = ACTIONS(5113),
    [sym__external_close_bracket2] = ACTIONS(5437),
  },
  [660] = {
    [sym_call_arguments] = STATE(2342),
    [sym_subset_arguments] = STATE(2343),
    [sym_subset2_arguments] = STATE(2346),
    [sym__open_parenthesis] = STATE(1325),
    [sym__open_bracket] = STATE(1322),
    [sym__open_bracket2] = STATE(1607),
    [sym_identifier] = ACTIONS(5443),
    [anon_sym_BSLASH] = ACTIONS(5441),
    [anon_sym_function] = ACTIONS(5443),
    [anon_sym_EQ] = ACTIONS(5069),
    [anon_sym_if] = ACTIONS(5443),
    [anon_sym_for] = ACTIONS(5443),
    [anon_sym_while] = ACTIONS(5443),
    [anon_sym_repeat] = ACTIONS(5443),
    [anon_sym_QMARK] = ACTIONS(5441),
    [anon_sym_TILDE] = ACTIONS(5071),
    [anon_sym_BANG] = ACTIONS(5443),
    [anon_sym_PLUS] = ACTIONS(5073),
    [anon_sym_DASH] = ACTIONS(5075),
    [anon_sym_LT_DASH] = ACTIONS(5077),
    [anon_sym_LT_LT_DASH] = ACTIONS(5077),
    [anon_sym_COLON_EQ] = ACTIONS(5077),
    [anon_sym_DASH_GT] = ACTIONS(5079),
    [anon_sym_DASH_GT_GT] = ACTIONS(5081),
    [anon_sym_PIPE] = ACTIONS(5083),
    [anon_sym_AMP] = ACTIONS(5085),
    [anon_sym_PIPE_PIPE] = ACTIONS(5087),
    [anon_sym_AMP_AMP] = ACTIONS(5089),
    [anon_sym_LT] = ACTIONS(5091),
    [anon_sym_LT_EQ] = ACTIONS(5093),
    [anon_sym_GT] = ACTIONS(5091),
    [anon_sym_GT_EQ] = ACTIONS(5093),
    [anon_sym_EQ_EQ] = ACTIONS(5093),
    [anon_sym_BANG_EQ] = ACTIONS(5093),
    [anon_sym_STAR] = ACTIONS(5095),
    [anon_sym_SLASH] = ACTIONS(5097),
    [anon_sym_STAR_STAR] = ACTIONS(5099),
    [anon_sym_CARET] = ACTIONS(5099),
    [aux_sym_binary_operator_token1] = ACTIONS(5101),
    [anon_sym_PIPE_GT] = ACTIONS(5101),
    [anon_sym_COLON] = ACTIONS(5103),
    [anon_sym_DOLLAR] = ACTIONS(5105),
    [anon_sym_AT] = ACTIONS(5105),
    [aux_sym__hex_literal_token1] = ACTIONS(5441),
    [sym__number_literal] = ACTIONS(5443),
    [anon_sym_SQUOTE] = ACTIONS(5441),
    [anon_sym_DQUOTE] = ACTIONS(5441),
    [sym_return] = ACTIONS(5443),
    [sym_next] = ACTIONS(5443),
    [sym_break] = ACTIONS(5443),
    [sym_true] = ACTIONS(5443),
    [sym_false] = ACTIONS(5443),
    [sym_null] = ACTIONS(5443),
    [sym_inf] = ACTIONS(5443),
    [sym_nan] = ACTIONS(5443),
    [anon_sym_NA] = ACTIONS(5443),
    [anon_sym_NA_integer_] = ACTIONS(5443),
    [anon_sym_NA_real_] = ACTIONS(5443),
    [anon_sym_NA_complex_] = ACTIONS(5443),
    [anon_sym_NA_character_] = ACTIONS(5443),
    [sym_dots] = ACTIONS(5443),
    [sym_dot_dot_i] = ACTIONS(5441),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5441),
    [sym__newline] = ACTIONS(5441),
    [sym__semicolon] = ACTIONS(5441),
    [sym__raw_string_literal] = ACTIONS(5441),
    [sym__external_else] = ACTIONS(5441),
    [sym__external_open_parenthesis] = ACTIONS(5109),
    [sym__external_close_parenthesis] = ACTIONS(5441),
    [sym__external_open_brace] = ACTIONS(5441),
    [sym__external_close_brace] = ACTIONS(5441),
    [sym__external_open_bracket] = ACTIONS(5111),
    [sym__external_open_bracket2] = ACTIONS(5113),
    [sym__external_close_bracket2] = ACTIONS(5441),
  },
  [661] = {
    [sym_call_arguments] = STATE(2342),
    [sym_subset_arguments] = STATE(2343),
    [sym_subset2_arguments] = STATE(2346),
    [sym__open_parenthesis] = STATE(1325),
    [sym__open_bracket] = STATE(1322),
    [sym__open_bracket2] = STATE(1607),
    [sym_identifier] = ACTIONS(5447),
    [anon_sym_BSLASH] = ACTIONS(5445),
    [anon_sym_function] = ACTIONS(5447),
    [anon_sym_EQ] = ACTIONS(5069),
    [anon_sym_if] = ACTIONS(5447),
    [anon_sym_for] = ACTIONS(5447),
    [anon_sym_while] = ACTIONS(5447),
    [anon_sym_repeat] = ACTIONS(5447),
    [anon_sym_QMARK] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(5071),
    [anon_sym_BANG] = ACTIONS(5447),
    [anon_sym_PLUS] = ACTIONS(5073),
    [anon_sym_DASH] = ACTIONS(5075),
    [anon_sym_LT_DASH] = ACTIONS(5077),
    [anon_sym_LT_LT_DASH] = ACTIONS(5077),
    [anon_sym_COLON_EQ] = ACTIONS(5077),
    [anon_sym_DASH_GT] = ACTIONS(5079),
    [anon_sym_DASH_GT_GT] = ACTIONS(5081),
    [anon_sym_PIPE] = ACTIONS(5083),
    [anon_sym_AMP] = ACTIONS(5085),
    [anon_sym_PIPE_PIPE] = ACTIONS(5087),
    [anon_sym_AMP_AMP] = ACTIONS(5089),
    [anon_sym_LT] = ACTIONS(5091),
    [anon_sym_LT_EQ] = ACTIONS(5093),
    [anon_sym_GT] = ACTIONS(5091),
    [anon_sym_GT_EQ] = ACTIONS(5093),
    [anon_sym_EQ_EQ] = ACTIONS(5093),
    [anon_sym_BANG_EQ] = ACTIONS(5093),
    [anon_sym_STAR] = ACTIONS(5095),
    [anon_sym_SLASH] = ACTIONS(5097),
    [anon_sym_STAR_STAR] = ACTIONS(5099),
    [anon_sym_CARET] = ACTIONS(5099),
    [aux_sym_binary_operator_token1] = ACTIONS(5101),
    [anon_sym_PIPE_GT] = ACTIONS(5101),
    [anon_sym_COLON] = ACTIONS(5103),
    [anon_sym_DOLLAR] = ACTIONS(5105),
    [anon_sym_AT] = ACTIONS(5105),
    [aux_sym__hex_literal_token1] = ACTIONS(5445),
    [sym__number_literal] = ACTIONS(5447),
    [anon_sym_SQUOTE] = ACTIONS(5445),
    [anon_sym_DQUOTE] = ACTIONS(5445),
    [sym_return] = ACTIONS(5447),
    [sym_next] = ACTIONS(5447),
    [sym_break] = ACTIONS(5447),
    [sym_true] = ACTIONS(5447),
    [sym_false] = ACTIONS(5447),
    [sym_null] = ACTIONS(5447),
    [sym_inf] = ACTIONS(5447),
    [sym_nan] = ACTIONS(5447),
    [anon_sym_NA] = ACTIONS(5447),
    [anon_sym_NA_integer_] = ACTIONS(5447),
    [anon_sym_NA_real_] = ACTIONS(5447),
    [anon_sym_NA_complex_] = ACTIONS(5447),
    [anon_sym_NA_character_] = ACTIONS(5447),
    [sym_dots] = ACTIONS(5447),
    [sym_dot_dot_i] = ACTIONS(5445),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5445),
    [sym__newline] = ACTIONS(5445),
    [sym__semicolon] = ACTIONS(5445),
    [sym__raw_string_literal] = ACTIONS(5445),
    [sym__external_else] = ACTIONS(5445),
    [sym__external_open_parenthesis] = ACTIONS(5109),
    [sym__external_close_parenthesis] = ACTIONS(5445),
    [sym__external_open_brace] = ACTIONS(5445),
    [sym__external_close_brace] = ACTIONS(5445),
    [sym__external_open_bracket] = ACTIONS(5111),
    [sym__external_open_bracket2] = ACTIONS(5113),
    [sym__external_close_bracket2] = ACTIONS(5445),
  },
  [662] = {
    [sym_call_arguments] = STATE(2342),
    [sym_subset_arguments] = STATE(2343),
    [sym_subset2_arguments] = STATE(2346),
    [sym__open_parenthesis] = STATE(1325),
    [sym__open_bracket] = STATE(1322),
    [sym__open_bracket2] = STATE(1607),
    [sym_identifier] = ACTIONS(5451),
    [anon_sym_BSLASH] = ACTIONS(5449),
    [anon_sym_function] = ACTIONS(5451),
    [anon_sym_EQ] = ACTIONS(5069),
    [anon_sym_if] = ACTIONS(5451),
    [anon_sym_for] = ACTIONS(5451),
    [anon_sym_while] = ACTIONS(5451),
    [anon_sym_repeat] = ACTIONS(5451),
    [anon_sym_QMARK] = ACTIONS(5449),
    [anon_sym_TILDE] = ACTIONS(5071),
    [anon_sym_BANG] = ACTIONS(5451),
    [anon_sym_PLUS] = ACTIONS(5073),
    [anon_sym_DASH] = ACTIONS(5075),
    [anon_sym_LT_DASH] = ACTIONS(5077),
    [anon_sym_LT_LT_DASH] = ACTIONS(5077),
    [anon_sym_COLON_EQ] = ACTIONS(5077),
    [anon_sym_DASH_GT] = ACTIONS(5079),
    [anon_sym_DASH_GT_GT] = ACTIONS(5081),
    [anon_sym_PIPE] = ACTIONS(5083),
    [anon_sym_AMP] = ACTIONS(5085),
    [anon_sym_PIPE_PIPE] = ACTIONS(5087),
    [anon_sym_AMP_AMP] = ACTIONS(5089),
    [anon_sym_LT] = ACTIONS(5091),
    [anon_sym_LT_EQ] = ACTIONS(5093),
    [anon_sym_GT] = ACTIONS(5091),
    [anon_sym_GT_EQ] = ACTIONS(5093),
    [anon_sym_EQ_EQ] = ACTIONS(5093),
    [anon_sym_BANG_EQ] = ACTIONS(5093),
    [anon_sym_STAR] = ACTIONS(5095),
    [anon_sym_SLASH] = ACTIONS(5097),
    [anon_sym_STAR_STAR] = ACTIONS(5099),
    [anon_sym_CARET] = ACTIONS(5099),
    [aux_sym_binary_operator_token1] = ACTIONS(5101),
    [anon_sym_PIPE_GT] = ACTIONS(5101),
    [anon_sym_COLON] = ACTIONS(5103),
    [anon_sym_DOLLAR] = ACTIONS(5105),
    [anon_sym_AT] = ACTIONS(5105),
    [aux_sym__hex_literal_token1] = ACTIONS(5449),
    [sym__number_literal] = ACTIONS(5451),
    [anon_sym_SQUOTE] = ACTIONS(5449),
    [anon_sym_DQUOTE] = ACTIONS(5449),
    [sym_return] = ACTIONS(5451),
    [sym_next] = ACTIONS(5451),
    [sym_break] = ACTIONS(5451),
    [sym_true] = ACTIONS(5451),
    [sym_false] = ACTIONS(5451),
    [sym_null] = ACTIONS(5451),
    [sym_inf] = ACTIONS(5451),
    [sym_nan] = ACTIONS(5451),
    [anon_sym_NA] = ACTIONS(5451),
    [anon_sym_NA_integer_] = ACTIONS(5451),
    [anon_sym_NA_real_] = ACTIONS(5451),
    [anon_sym_NA_complex_] = ACTIONS(5451),
    [anon_sym_NA_character_] = ACTIONS(5451),
    [sym_dots] = ACTIONS(5451),
    [sym_dot_dot_i] = ACTIONS(5449),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5449),
    [sym__newline] = ACTIONS(5449),
    [sym__semicolon] = ACTIONS(5449),
    [sym__raw_string_literal] = ACTIONS(5449),
    [sym__external_else] = ACTIONS(5449),
    [sym__external_open_parenthesis] = ACTIONS(5109),
    [sym__external_close_parenthesis] = ACTIONS(5449),
    [sym__external_open_brace] = ACTIONS(5449),
    [sym__external_close_brace] = ACTIONS(5449),
    [sym__external_open_bracket] = ACTIONS(5111),
    [sym__external_open_bracket2] = ACTIONS(5113),
    [sym__external_close_bracket2] = ACTIONS(5449),
  },
  [663] = {
    [sym_call_arguments] = STATE(2342),
    [sym_subset_arguments] = STATE(2343),
    [sym_subset2_arguments] = STATE(2346),
    [sym__open_parenthesis] = STATE(1325),
    [sym__open_bracket] = STATE(1322),
    [sym__open_bracket2] = STATE(1607),
    [sym_identifier] = ACTIONS(5455),
    [anon_sym_BSLASH] = ACTIONS(5453),
    [anon_sym_function] = ACTIONS(5455),
    [anon_sym_EQ] = ACTIONS(5069),
    [anon_sym_if] = ACTIONS(5455),
    [anon_sym_for] = ACTIONS(5455),
    [anon_sym_while] = ACTIONS(5455),
    [anon_sym_repeat] = ACTIONS(5455),
    [anon_sym_QMARK] = ACTIONS(5453),
    [anon_sym_TILDE] = ACTIONS(5071),
    [anon_sym_BANG] = ACTIONS(5455),
    [anon_sym_PLUS] = ACTIONS(5073),
    [anon_sym_DASH] = ACTIONS(5075),
    [anon_sym_LT_DASH] = ACTIONS(5077),
    [anon_sym_LT_LT_DASH] = ACTIONS(5077),
    [anon_sym_COLON_EQ] = ACTIONS(5077),
    [anon_sym_DASH_GT] = ACTIONS(5079),
    [anon_sym_DASH_GT_GT] = ACTIONS(5081),
    [anon_sym_PIPE] = ACTIONS(5083),
    [anon_sym_AMP] = ACTIONS(5085),
    [anon_sym_PIPE_PIPE] = ACTIONS(5087),
    [anon_sym_AMP_AMP] = ACTIONS(5089),
    [anon_sym_LT] = ACTIONS(5091),
    [anon_sym_LT_EQ] = ACTIONS(5093),
    [anon_sym_GT] = ACTIONS(5091),
    [anon_sym_GT_EQ] = ACTIONS(5093),
    [anon_sym_EQ_EQ] = ACTIONS(5093),
    [anon_sym_BANG_EQ] = ACTIONS(5093),
    [anon_sym_STAR] = ACTIONS(5095),
    [anon_sym_SLASH] = ACTIONS(5097),
    [anon_sym_STAR_STAR] = ACTIONS(5099),
    [anon_sym_CARET] = ACTIONS(5099),
    [aux_sym_binary_operator_token1] = ACTIONS(5101),
    [anon_sym_PIPE_GT] = ACTIONS(5101),
    [anon_sym_COLON] = ACTIONS(5103),
    [anon_sym_DOLLAR] = ACTIONS(5105),
    [anon_sym_AT] = ACTIONS(5105),
    [aux_sym__hex_literal_token1] = ACTIONS(5453),
    [sym__number_literal] = ACTIONS(5455),
    [anon_sym_SQUOTE] = ACTIONS(5453),
    [anon_sym_DQUOTE] = ACTIONS(5453),
    [sym_return] = ACTIONS(5455),
    [sym_next] = ACTIONS(5455),
    [sym_break] = ACTIONS(5455),
    [sym_true] = ACTIONS(5455),
    [sym_false] = ACTIONS(5455),
    [sym_null] = ACTIONS(5455),
    [sym_inf] = ACTIONS(5455),
    [sym_nan] = ACTIONS(5455),
    [anon_sym_NA] = ACTIONS(5455),
    [anon_sym_NA_integer_] = ACTIONS(5455),
    [anon_sym_NA_real_] = ACTIONS(5455),
    [anon_sym_NA_complex_] = ACTIONS(5455),
    [anon_sym_NA_character_] = ACTIONS(5455),
    [sym_dots] = ACTIONS(5455),
    [sym_dot_dot_i] = ACTIONS(5453),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5453),
    [sym__newline] = ACTIONS(5453),
    [sym__semicolon] = ACTIONS(5453),
    [sym__raw_string_literal] = ACTIONS(5453),
    [sym__external_else] = ACTIONS(5453),
    [sym__external_open_parenthesis] = ACTIONS(5109),
    [sym__external_close_parenthesis] = ACTIONS(5453),
    [sym__external_open_brace] = ACTIONS(5453),
    [sym__external_close_brace] = ACTIONS(5453),
    [sym__external_open_bracket] = ACTIONS(5111),
    [sym__external_open_bracket2] = ACTIONS(5113),
    [sym__external_close_bracket2] = ACTIONS(5453),
  },
  [664] = {
    [sym_call_arguments] = STATE(2342),
    [sym_subset_arguments] = STATE(2343),
    [sym_subset2_arguments] = STATE(2346),
    [sym__open_parenthesis] = STATE(1325),
    [sym__open_bracket] = STATE(1322),
    [sym__open_bracket2] = STATE(1607),
    [sym_identifier] = ACTIONS(5411),
    [anon_sym_BSLASH] = ACTIONS(5409),
    [anon_sym_function] = ACTIONS(5411),
    [anon_sym_EQ] = ACTIONS(5069),
    [anon_sym_if] = ACTIONS(5411),
    [anon_sym_for] = ACTIONS(5411),
    [anon_sym_while] = ACTIONS(5411),
    [anon_sym_repeat] = ACTIONS(5411),
    [anon_sym_QMARK] = ACTIONS(5409),
    [anon_sym_TILDE] = ACTIONS(5071),
    [anon_sym_BANG] = ACTIONS(5411),
    [anon_sym_PLUS] = ACTIONS(5073),
    [anon_sym_DASH] = ACTIONS(5075),
    [anon_sym_LT_DASH] = ACTIONS(5077),
    [anon_sym_LT_LT_DASH] = ACTIONS(5077),
    [anon_sym_COLON_EQ] = ACTIONS(5077),
    [anon_sym_DASH_GT] = ACTIONS(5079),
    [anon_sym_DASH_GT_GT] = ACTIONS(5081),
    [anon_sym_PIPE] = ACTIONS(5083),
    [anon_sym_AMP] = ACTIONS(5085),
    [anon_sym_PIPE_PIPE] = ACTIONS(5087),
    [anon_sym_AMP_AMP] = ACTIONS(5089),
    [anon_sym_LT] = ACTIONS(5091),
    [anon_sym_LT_EQ] = ACTIONS(5093),
    [anon_sym_GT] = ACTIONS(5091),
    [anon_sym_GT_EQ] = ACTIONS(5093),
    [anon_sym_EQ_EQ] = ACTIONS(5093),
    [anon_sym_BANG_EQ] = ACTIONS(5093),
    [anon_sym_STAR] = ACTIONS(5095),
    [anon_sym_SLASH] = ACTIONS(5097),
    [anon_sym_STAR_STAR] = ACTIONS(5099),
    [anon_sym_CARET] = ACTIONS(5099),
    [aux_sym_binary_operator_token1] = ACTIONS(5101),
    [anon_sym_PIPE_GT] = ACTIONS(5101),
    [anon_sym_COLON] = ACTIONS(5103),
    [anon_sym_DOLLAR] = ACTIONS(5105),
    [anon_sym_AT] = ACTIONS(5105),
    [aux_sym__hex_literal_token1] = ACTIONS(5409),
    [sym__number_literal] = ACTIONS(5411),
    [anon_sym_SQUOTE] = ACTIONS(5409),
    [anon_sym_DQUOTE] = ACTIONS(5409),
    [sym_return] = ACTIONS(5411),
    [sym_next] = ACTIONS(5411),
    [sym_break] = ACTIONS(5411),
    [sym_true] = ACTIONS(5411),
    [sym_false] = ACTIONS(5411),
    [sym_null] = ACTIONS(5411),
    [sym_inf] = ACTIONS(5411),
    [sym_nan] = ACTIONS(5411),
    [anon_sym_NA] = ACTIONS(5411),
    [anon_sym_NA_integer_] = ACTIONS(5411),
    [anon_sym_NA_real_] = ACTIONS(5411),
    [anon_sym_NA_complex_] = ACTIONS(5411),
    [anon_sym_NA_character_] = ACTIONS(5411),
    [sym_dots] = ACTIONS(5411),
    [sym_dot_dot_i] = ACTIONS(5409),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5409),
    [sym__newline] = ACTIONS(5409),
    [sym__semicolon] = ACTIONS(5409),
    [sym__raw_string_literal] = ACTIONS(5409),
    [sym__external_else] = ACTIONS(5409),
    [sym__external_open_parenthesis] = ACTIONS(5109),
    [sym__external_close_parenthesis] = ACTIONS(5409),
    [sym__external_open_brace] = ACTIONS(5409),
    [sym__external_close_brace] = ACTIONS(5409),
    [sym__external_open_bracket] = ACTIONS(5111),
    [sym__external_open_bracket2] = ACTIONS(5113),
    [sym__external_close_bracket2] = ACTIONS(5409),
  },
  [665] = {
    [sym_call_arguments] = STATE(2438),
    [sym_subset_arguments] = STATE(2439),
    [sym_subset2_arguments] = STATE(2440),
    [sym__else] = STATE(4278),
    [sym__open_parenthesis] = STATE(1350),
    [sym__open_bracket] = STATE(1348),
    [sym__open_bracket2] = STATE(1346),
    [sym_identifier] = ACTIONS(5225),
    [anon_sym_BSLASH] = ACTIONS(5227),
    [anon_sym_function] = ACTIONS(5225),
    [anon_sym_EQ] = ACTIONS(5353),
    [anon_sym_if] = ACTIONS(5225),
    [anon_sym_for] = ACTIONS(5225),
    [anon_sym_while] = ACTIONS(5225),
    [anon_sym_repeat] = ACTIONS(5225),
    [anon_sym_QMARK] = ACTIONS(5227),
    [anon_sym_TILDE] = ACTIONS(5355),
    [anon_sym_BANG] = ACTIONS(5225),
    [anon_sym_PLUS] = ACTIONS(5357),
    [anon_sym_DASH] = ACTIONS(5359),
    [anon_sym_LT_DASH] = ACTIONS(5361),
    [anon_sym_LT_LT_DASH] = ACTIONS(5361),
    [anon_sym_COLON_EQ] = ACTIONS(5361),
    [anon_sym_DASH_GT] = ACTIONS(5363),
    [anon_sym_DASH_GT_GT] = ACTIONS(5365),
    [anon_sym_PIPE] = ACTIONS(5367),
    [anon_sym_AMP] = ACTIONS(5369),
    [anon_sym_PIPE_PIPE] = ACTIONS(5371),
    [anon_sym_AMP_AMP] = ACTIONS(5373),
    [anon_sym_LT] = ACTIONS(5375),
    [anon_sym_LT_EQ] = ACTIONS(5377),
    [anon_sym_GT] = ACTIONS(5375),
    [anon_sym_GT_EQ] = ACTIONS(5377),
    [anon_sym_EQ_EQ] = ACTIONS(5377),
    [anon_sym_BANG_EQ] = ACTIONS(5377),
    [anon_sym_STAR] = ACTIONS(5379),
    [anon_sym_SLASH] = ACTIONS(5381),
    [anon_sym_STAR_STAR] = ACTIONS(5383),
    [anon_sym_CARET] = ACTIONS(5383),
    [aux_sym_binary_operator_token1] = ACTIONS(5385),
    [anon_sym_PIPE_GT] = ACTIONS(5385),
    [anon_sym_COLON] = ACTIONS(5387),
    [anon_sym_DOLLAR] = ACTIONS(5389),
    [anon_sym_AT] = ACTIONS(5389),
    [aux_sym__hex_literal_token1] = ACTIONS(5227),
    [sym__number_literal] = ACTIONS(5225),
    [anon_sym_SQUOTE] = ACTIONS(5227),
    [anon_sym_DQUOTE] = ACTIONS(5227),
    [sym_return] = ACTIONS(5225),
    [sym_next] = ACTIONS(5225),
    [sym_break] = ACTIONS(5225),
    [sym_true] = ACTIONS(5225),
    [sym_false] = ACTIONS(5225),
    [sym_null] = ACTIONS(5225),
    [sym_inf] = ACTIONS(5225),
    [sym_nan] = ACTIONS(5225),
    [anon_sym_NA] = ACTIONS(5225),
    [anon_sym_NA_integer_] = ACTIONS(5225),
    [anon_sym_NA_real_] = ACTIONS(5225),
    [anon_sym_NA_complex_] = ACTIONS(5225),
    [anon_sym_NA_character_] = ACTIONS(5225),
    [sym_dots] = ACTIONS(5225),
    [sym_dot_dot_i] = ACTIONS(5227),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5227),
    [sym__newline] = ACTIONS(5227),
    [sym__semicolon] = ACTIONS(5227),
    [sym__raw_string_literal] = ACTIONS(5227),
    [sym__external_else] = ACTIONS(5461),
    [sym__external_open_parenthesis] = ACTIONS(5393),
    [sym__external_open_brace] = ACTIONS(5227),
    [sym__external_close_brace] = ACTIONS(5227),
    [sym__external_open_bracket] = ACTIONS(5395),
    [sym__external_close_bracket] = ACTIONS(5227),
    [sym__external_open_bracket2] = ACTIONS(5397),
  },
  [666] = {
    [sym_call_arguments] = STATE(2438),
    [sym_subset_arguments] = STATE(2439),
    [sym_subset2_arguments] = STATE(2440),
    [sym__else] = STATE(4276),
    [sym__open_parenthesis] = STATE(1350),
    [sym__open_bracket] = STATE(1348),
    [sym__open_bracket2] = STATE(1346),
    [sym_identifier] = ACTIONS(5169),
    [anon_sym_BSLASH] = ACTIONS(5167),
    [anon_sym_function] = ACTIONS(5169),
    [anon_sym_EQ] = ACTIONS(5353),
    [anon_sym_if] = ACTIONS(5169),
    [anon_sym_for] = ACTIONS(5169),
    [anon_sym_while] = ACTIONS(5169),
    [anon_sym_repeat] = ACTIONS(5169),
    [anon_sym_QMARK] = ACTIONS(5167),
    [anon_sym_TILDE] = ACTIONS(5355),
    [anon_sym_BANG] = ACTIONS(5169),
    [anon_sym_PLUS] = ACTIONS(5357),
    [anon_sym_DASH] = ACTIONS(5359),
    [anon_sym_LT_DASH] = ACTIONS(5361),
    [anon_sym_LT_LT_DASH] = ACTIONS(5361),
    [anon_sym_COLON_EQ] = ACTIONS(5361),
    [anon_sym_DASH_GT] = ACTIONS(5363),
    [anon_sym_DASH_GT_GT] = ACTIONS(5365),
    [anon_sym_PIPE] = ACTIONS(5367),
    [anon_sym_AMP] = ACTIONS(5369),
    [anon_sym_PIPE_PIPE] = ACTIONS(5371),
    [anon_sym_AMP_AMP] = ACTIONS(5373),
    [anon_sym_LT] = ACTIONS(5375),
    [anon_sym_LT_EQ] = ACTIONS(5377),
    [anon_sym_GT] = ACTIONS(5375),
    [anon_sym_GT_EQ] = ACTIONS(5377),
    [anon_sym_EQ_EQ] = ACTIONS(5377),
    [anon_sym_BANG_EQ] = ACTIONS(5377),
    [anon_sym_STAR] = ACTIONS(5379),
    [anon_sym_SLASH] = ACTIONS(5381),
    [anon_sym_STAR_STAR] = ACTIONS(5383),
    [anon_sym_CARET] = ACTIONS(5383),
    [aux_sym_binary_operator_token1] = ACTIONS(5385),
    [anon_sym_PIPE_GT] = ACTIONS(5385),
    [anon_sym_COLON] = ACTIONS(5387),
    [anon_sym_DOLLAR] = ACTIONS(5389),
    [anon_sym_AT] = ACTIONS(5389),
    [aux_sym__hex_literal_token1] = ACTIONS(5167),
    [sym__number_literal] = ACTIONS(5169),
    [anon_sym_SQUOTE] = ACTIONS(5167),
    [anon_sym_DQUOTE] = ACTIONS(5167),
    [sym_return] = ACTIONS(5169),
    [sym_next] = ACTIONS(5169),
    [sym_break] = ACTIONS(5169),
    [sym_true] = ACTIONS(5169),
    [sym_false] = ACTIONS(5169),
    [sym_null] = ACTIONS(5169),
    [sym_inf] = ACTIONS(5169),
    [sym_nan] = ACTIONS(5169),
    [anon_sym_NA] = ACTIONS(5169),
    [anon_sym_NA_integer_] = ACTIONS(5169),
    [anon_sym_NA_real_] = ACTIONS(5169),
    [anon_sym_NA_complex_] = ACTIONS(5169),
    [anon_sym_NA_character_] = ACTIONS(5169),
    [sym_dots] = ACTIONS(5169),
    [sym_dot_dot_i] = ACTIONS(5167),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5167),
    [sym__newline] = ACTIONS(5167),
    [sym__semicolon] = ACTIONS(5167),
    [sym__raw_string_literal] = ACTIONS(5167),
    [sym__external_else] = ACTIONS(5463),
    [sym__external_open_parenthesis] = ACTIONS(5393),
    [sym__external_open_brace] = ACTIONS(5167),
    [sym__external_close_brace] = ACTIONS(5167),
    [sym__external_open_bracket] = ACTIONS(5395),
    [sym__external_close_bracket] = ACTIONS(5167),
    [sym__external_open_bracket2] = ACTIONS(5397),
  },
  [667] = {
    [sym_call_arguments] = STATE(2438),
    [sym_subset_arguments] = STATE(2439),
    [sym_subset2_arguments] = STATE(2440),
    [sym__else] = STATE(4275),
    [sym__open_parenthesis] = STATE(1350),
    [sym__open_bracket] = STATE(1348),
    [sym__open_bracket2] = STATE(1346),
    [sym_identifier] = ACTIONS(5115),
    [anon_sym_BSLASH] = ACTIONS(5117),
    [anon_sym_function] = ACTIONS(5115),
    [anon_sym_EQ] = ACTIONS(5353),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_for] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_repeat] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(5117),
    [anon_sym_TILDE] = ACTIONS(5355),
    [anon_sym_BANG] = ACTIONS(5115),
    [anon_sym_PLUS] = ACTIONS(5357),
    [anon_sym_DASH] = ACTIONS(5359),
    [anon_sym_LT_DASH] = ACTIONS(5361),
    [anon_sym_LT_LT_DASH] = ACTIONS(5361),
    [anon_sym_COLON_EQ] = ACTIONS(5361),
    [anon_sym_DASH_GT] = ACTIONS(5363),
    [anon_sym_DASH_GT_GT] = ACTIONS(5365),
    [anon_sym_PIPE] = ACTIONS(5367),
    [anon_sym_AMP] = ACTIONS(5369),
    [anon_sym_PIPE_PIPE] = ACTIONS(5371),
    [anon_sym_AMP_AMP] = ACTIONS(5373),
    [anon_sym_LT] = ACTIONS(5375),
    [anon_sym_LT_EQ] = ACTIONS(5377),
    [anon_sym_GT] = ACTIONS(5375),
    [anon_sym_GT_EQ] = ACTIONS(5377),
    [anon_sym_EQ_EQ] = ACTIONS(5377),
    [anon_sym_BANG_EQ] = ACTIONS(5377),
    [anon_sym_STAR] = ACTIONS(5379),
    [anon_sym_SLASH] = ACTIONS(5381),
    [anon_sym_STAR_STAR] = ACTIONS(5383),
    [anon_sym_CARET] = ACTIONS(5383),
    [aux_sym_binary_operator_token1] = ACTIONS(5385),
    [anon_sym_PIPE_GT] = ACTIONS(5385),
    [anon_sym_COLON] = ACTIONS(5387),
    [anon_sym_DOLLAR] = ACTIONS(5389),
    [anon_sym_AT] = ACTIONS(5389),
    [aux_sym__hex_literal_token1] = ACTIONS(5117),
    [sym__number_literal] = ACTIONS(5115),
    [anon_sym_SQUOTE] = ACTIONS(5117),
    [anon_sym_DQUOTE] = ACTIONS(5117),
    [sym_return] = ACTIONS(5115),
    [sym_next] = ACTIONS(5115),
    [sym_break] = ACTIONS(5115),
    [sym_true] = ACTIONS(5115),
    [sym_false] = ACTIONS(5115),
    [sym_null] = ACTIONS(5115),
    [sym_inf] = ACTIONS(5115),
    [sym_nan] = ACTIONS(5115),
    [anon_sym_NA] = ACTIONS(5115),
    [anon_sym_NA_integer_] = ACTIONS(5115),
    [anon_sym_NA_real_] = ACTIONS(5115),
    [anon_sym_NA_complex_] = ACTIONS(5115),
    [anon_sym_NA_character_] = ACTIONS(5115),
    [sym_dots] = ACTIONS(5115),
    [sym_dot_dot_i] = ACTIONS(5117),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5117),
    [sym__newline] = ACTIONS(5117),
    [sym__semicolon] = ACTIONS(5117),
    [sym__raw_string_literal] = ACTIONS(5117),
    [sym__external_else] = ACTIONS(5465),
    [sym__external_open_parenthesis] = ACTIONS(5393),
    [sym__external_open_brace] = ACTIONS(5117),
    [sym__external_close_brace] = ACTIONS(5117),
    [sym__external_open_bracket] = ACTIONS(5395),
    [sym__external_close_bracket] = ACTIONS(5117),
    [sym__external_open_bracket2] = ACTIONS(5397),
  },
  [668] = {
    [sym_call_arguments] = STATE(2438),
    [sym_subset_arguments] = STATE(2439),
    [sym_subset2_arguments] = STATE(2440),
    [sym__else] = STATE(4274),
    [sym__open_parenthesis] = STATE(1350),
    [sym__open_bracket] = STATE(1348),
    [sym__open_bracket2] = STATE(1346),
    [sym_identifier] = ACTIONS(5065),
    [anon_sym_BSLASH] = ACTIONS(5067),
    [anon_sym_function] = ACTIONS(5065),
    [anon_sym_EQ] = ACTIONS(5353),
    [anon_sym_if] = ACTIONS(5065),
    [anon_sym_for] = ACTIONS(5065),
    [anon_sym_while] = ACTIONS(5065),
    [anon_sym_repeat] = ACTIONS(5065),
    [anon_sym_QMARK] = ACTIONS(5067),
    [anon_sym_TILDE] = ACTIONS(5355),
    [anon_sym_BANG] = ACTIONS(5065),
    [anon_sym_PLUS] = ACTIONS(5357),
    [anon_sym_DASH] = ACTIONS(5359),
    [anon_sym_LT_DASH] = ACTIONS(5361),
    [anon_sym_LT_LT_DASH] = ACTIONS(5361),
    [anon_sym_COLON_EQ] = ACTIONS(5361),
    [anon_sym_DASH_GT] = ACTIONS(5363),
    [anon_sym_DASH_GT_GT] = ACTIONS(5365),
    [anon_sym_PIPE] = ACTIONS(5367),
    [anon_sym_AMP] = ACTIONS(5369),
    [anon_sym_PIPE_PIPE] = ACTIONS(5371),
    [anon_sym_AMP_AMP] = ACTIONS(5373),
    [anon_sym_LT] = ACTIONS(5375),
    [anon_sym_LT_EQ] = ACTIONS(5377),
    [anon_sym_GT] = ACTIONS(5375),
    [anon_sym_GT_EQ] = ACTIONS(5377),
    [anon_sym_EQ_EQ] = ACTIONS(5377),
    [anon_sym_BANG_EQ] = ACTIONS(5377),
    [anon_sym_STAR] = ACTIONS(5379),
    [anon_sym_SLASH] = ACTIONS(5381),
    [anon_sym_STAR_STAR] = ACTIONS(5383),
    [anon_sym_CARET] = ACTIONS(5383),
    [aux_sym_binary_operator_token1] = ACTIONS(5385),
    [anon_sym_PIPE_GT] = ACTIONS(5385),
    [anon_sym_COLON] = ACTIONS(5387),
    [anon_sym_DOLLAR] = ACTIONS(5389),
    [anon_sym_AT] = ACTIONS(5389),
    [aux_sym__hex_literal_token1] = ACTIONS(5067),
    [sym__number_literal] = ACTIONS(5065),
    [anon_sym_SQUOTE] = ACTIONS(5067),
    [anon_sym_DQUOTE] = ACTIONS(5067),
    [sym_return] = ACTIONS(5065),
    [sym_next] = ACTIONS(5065),
    [sym_break] = ACTIONS(5065),
    [sym_true] = ACTIONS(5065),
    [sym_false] = ACTIONS(5065),
    [sym_null] = ACTIONS(5065),
    [sym_inf] = ACTIONS(5065),
    [sym_nan] = ACTIONS(5065),
    [anon_sym_NA] = ACTIONS(5065),
    [anon_sym_NA_integer_] = ACTIONS(5065),
    [anon_sym_NA_real_] = ACTIONS(5065),
    [anon_sym_NA_complex_] = ACTIONS(5065),
    [anon_sym_NA_character_] = ACTIONS(5065),
    [sym_dots] = ACTIONS(5065),
    [sym_dot_dot_i] = ACTIONS(5067),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5067),
    [sym__newline] = ACTIONS(5067),
    [sym__semicolon] = ACTIONS(5067),
    [sym__raw_string_literal] = ACTIONS(5067),
    [sym__external_else] = ACTIONS(5467),
    [sym__external_open_parenthesis] = ACTIONS(5393),
    [sym__external_open_brace] = ACTIONS(5067),
    [sym__external_close_brace] = ACTIONS(5067),
    [sym__external_open_bracket] = ACTIONS(5395),
    [sym__external_close_bracket] = ACTIONS(5067),
    [sym__external_open_bracket2] = ACTIONS(5397),
  },
  [669] = {
    [sym_call_arguments] = STATE(2555),
    [sym_subset_arguments] = STATE(2554),
    [sym_subset2_arguments] = STATE(2553),
    [sym__else] = STATE(4174),
    [sym__open_parenthesis] = STATE(1332),
    [sym__open_bracket] = STATE(1331),
    [sym__open_bracket2] = STATE(1330),
    [sym_identifier] = ACTIONS(5225),
    [anon_sym_BSLASH] = ACTIONS(5227),
    [anon_sym_function] = ACTIONS(5225),
    [anon_sym_EQ] = ACTIONS(5265),
    [anon_sym_if] = ACTIONS(5225),
    [anon_sym_for] = ACTIONS(5225),
    [anon_sym_while] = ACTIONS(5225),
    [anon_sym_repeat] = ACTIONS(5225),
    [anon_sym_QMARK] = ACTIONS(5227),
    [anon_sym_TILDE] = ACTIONS(5267),
    [anon_sym_BANG] = ACTIONS(5225),
    [anon_sym_PLUS] = ACTIONS(5269),
    [anon_sym_DASH] = ACTIONS(5271),
    [anon_sym_LT_DASH] = ACTIONS(5273),
    [anon_sym_LT_LT_DASH] = ACTIONS(5273),
    [anon_sym_COLON_EQ] = ACTIONS(5273),
    [anon_sym_DASH_GT] = ACTIONS(5275),
    [anon_sym_DASH_GT_GT] = ACTIONS(5277),
    [anon_sym_PIPE] = ACTIONS(5279),
    [anon_sym_AMP] = ACTIONS(5281),
    [anon_sym_PIPE_PIPE] = ACTIONS(5283),
    [anon_sym_AMP_AMP] = ACTIONS(5285),
    [anon_sym_LT] = ACTIONS(5287),
    [anon_sym_LT_EQ] = ACTIONS(5289),
    [anon_sym_GT] = ACTIONS(5287),
    [anon_sym_GT_EQ] = ACTIONS(5289),
    [anon_sym_EQ_EQ] = ACTIONS(5289),
    [anon_sym_BANG_EQ] = ACTIONS(5289),
    [anon_sym_STAR] = ACTIONS(5291),
    [anon_sym_SLASH] = ACTIONS(5293),
    [anon_sym_STAR_STAR] = ACTIONS(5295),
    [anon_sym_CARET] = ACTIONS(5295),
    [aux_sym_binary_operator_token1] = ACTIONS(5297),
    [anon_sym_PIPE_GT] = ACTIONS(5297),
    [anon_sym_COLON] = ACTIONS(5299),
    [anon_sym_DOLLAR] = ACTIONS(5301),
    [anon_sym_AT] = ACTIONS(5301),
    [aux_sym__hex_literal_token1] = ACTIONS(5227),
    [sym__number_literal] = ACTIONS(5225),
    [anon_sym_SQUOTE] = ACTIONS(5227),
    [anon_sym_DQUOTE] = ACTIONS(5227),
    [sym_return] = ACTIONS(5225),
    [sym_next] = ACTIONS(5225),
    [sym_break] = ACTIONS(5225),
    [sym_true] = ACTIONS(5225),
    [sym_false] = ACTIONS(5225),
    [sym_null] = ACTIONS(5225),
    [sym_inf] = ACTIONS(5225),
    [sym_nan] = ACTIONS(5225),
    [anon_sym_NA] = ACTIONS(5225),
    [anon_sym_NA_integer_] = ACTIONS(5225),
    [anon_sym_NA_real_] = ACTIONS(5225),
    [anon_sym_NA_complex_] = ACTIONS(5225),
    [anon_sym_NA_character_] = ACTIONS(5225),
    [sym_dots] = ACTIONS(5225),
    [sym_dot_dot_i] = ACTIONS(5227),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5227),
    [sym__newline] = ACTIONS(5227),
    [sym__semicolon] = ACTIONS(5227),
    [sym__raw_string_literal] = ACTIONS(5227),
    [sym__external_else] = ACTIONS(5469),
    [sym__external_open_parenthesis] = ACTIONS(5305),
    [sym__external_open_brace] = ACTIONS(5227),
    [sym__external_close_brace] = ACTIONS(5227),
    [sym__external_open_bracket] = ACTIONS(5307),
    [sym__external_open_bracket2] = ACTIONS(5309),
    [sym__external_close_bracket2] = ACTIONS(5227),
  },
  [670] = {
    [sym_call_arguments] = STATE(2555),
    [sym_subset_arguments] = STATE(2554),
    [sym_subset2_arguments] = STATE(2553),
    [sym__else] = STATE(4170),
    [sym__open_parenthesis] = STATE(1332),
    [sym__open_bracket] = STATE(1331),
    [sym__open_bracket2] = STATE(1330),
    [sym_identifier] = ACTIONS(5169),
    [anon_sym_BSLASH] = ACTIONS(5167),
    [anon_sym_function] = ACTIONS(5169),
    [anon_sym_EQ] = ACTIONS(5265),
    [anon_sym_if] = ACTIONS(5169),
    [anon_sym_for] = ACTIONS(5169),
    [anon_sym_while] = ACTIONS(5169),
    [anon_sym_repeat] = ACTIONS(5169),
    [anon_sym_QMARK] = ACTIONS(5167),
    [anon_sym_TILDE] = ACTIONS(5267),
    [anon_sym_BANG] = ACTIONS(5169),
    [anon_sym_PLUS] = ACTIONS(5269),
    [anon_sym_DASH] = ACTIONS(5271),
    [anon_sym_LT_DASH] = ACTIONS(5273),
    [anon_sym_LT_LT_DASH] = ACTIONS(5273),
    [anon_sym_COLON_EQ] = ACTIONS(5273),
    [anon_sym_DASH_GT] = ACTIONS(5275),
    [anon_sym_DASH_GT_GT] = ACTIONS(5277),
    [anon_sym_PIPE] = ACTIONS(5279),
    [anon_sym_AMP] = ACTIONS(5281),
    [anon_sym_PIPE_PIPE] = ACTIONS(5283),
    [anon_sym_AMP_AMP] = ACTIONS(5285),
    [anon_sym_LT] = ACTIONS(5287),
    [anon_sym_LT_EQ] = ACTIONS(5289),
    [anon_sym_GT] = ACTIONS(5287),
    [anon_sym_GT_EQ] = ACTIONS(5289),
    [anon_sym_EQ_EQ] = ACTIONS(5289),
    [anon_sym_BANG_EQ] = ACTIONS(5289),
    [anon_sym_STAR] = ACTIONS(5291),
    [anon_sym_SLASH] = ACTIONS(5293),
    [anon_sym_STAR_STAR] = ACTIONS(5295),
    [anon_sym_CARET] = ACTIONS(5295),
    [aux_sym_binary_operator_token1] = ACTIONS(5297),
    [anon_sym_PIPE_GT] = ACTIONS(5297),
    [anon_sym_COLON] = ACTIONS(5299),
    [anon_sym_DOLLAR] = ACTIONS(5301),
    [anon_sym_AT] = ACTIONS(5301),
    [aux_sym__hex_literal_token1] = ACTIONS(5167),
    [sym__number_literal] = ACTIONS(5169),
    [anon_sym_SQUOTE] = ACTIONS(5167),
    [anon_sym_DQUOTE] = ACTIONS(5167),
    [sym_return] = ACTIONS(5169),
    [sym_next] = ACTIONS(5169),
    [sym_break] = ACTIONS(5169),
    [sym_true] = ACTIONS(5169),
    [sym_false] = ACTIONS(5169),
    [sym_null] = ACTIONS(5169),
    [sym_inf] = ACTIONS(5169),
    [sym_nan] = ACTIONS(5169),
    [anon_sym_NA] = ACTIONS(5169),
    [anon_sym_NA_integer_] = ACTIONS(5169),
    [anon_sym_NA_real_] = ACTIONS(5169),
    [anon_sym_NA_complex_] = ACTIONS(5169),
    [anon_sym_NA_character_] = ACTIONS(5169),
    [sym_dots] = ACTIONS(5169),
    [sym_dot_dot_i] = ACTIONS(5167),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5167),
    [sym__newline] = ACTIONS(5167),
    [sym__semicolon] = ACTIONS(5167),
    [sym__raw_string_literal] = ACTIONS(5167),
    [sym__external_else] = ACTIONS(5471),
    [sym__external_open_parenthesis] = ACTIONS(5305),
    [sym__external_open_brace] = ACTIONS(5167),
    [sym__external_close_brace] = ACTIONS(5167),
    [sym__external_open_bracket] = ACTIONS(5307),
    [sym__external_open_bracket2] = ACTIONS(5309),
    [sym__external_close_bracket2] = ACTIONS(5167),
  },
  [671] = {
    [sym_call_arguments] = STATE(2555),
    [sym_subset_arguments] = STATE(2554),
    [sym_subset2_arguments] = STATE(2553),
    [sym__else] = STATE(4169),
    [sym__open_parenthesis] = STATE(1332),
    [sym__open_bracket] = STATE(1331),
    [sym__open_bracket2] = STATE(1330),
    [sym_identifier] = ACTIONS(5115),
    [anon_sym_BSLASH] = ACTIONS(5117),
    [anon_sym_function] = ACTIONS(5115),
    [anon_sym_EQ] = ACTIONS(5265),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_for] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_repeat] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(5117),
    [anon_sym_TILDE] = ACTIONS(5267),
    [anon_sym_BANG] = ACTIONS(5115),
    [anon_sym_PLUS] = ACTIONS(5269),
    [anon_sym_DASH] = ACTIONS(5271),
    [anon_sym_LT_DASH] = ACTIONS(5273),
    [anon_sym_LT_LT_DASH] = ACTIONS(5273),
    [anon_sym_COLON_EQ] = ACTIONS(5273),
    [anon_sym_DASH_GT] = ACTIONS(5275),
    [anon_sym_DASH_GT_GT] = ACTIONS(5277),
    [anon_sym_PIPE] = ACTIONS(5279),
    [anon_sym_AMP] = ACTIONS(5281),
    [anon_sym_PIPE_PIPE] = ACTIONS(5283),
    [anon_sym_AMP_AMP] = ACTIONS(5285),
    [anon_sym_LT] = ACTIONS(5287),
    [anon_sym_LT_EQ] = ACTIONS(5289),
    [anon_sym_GT] = ACTIONS(5287),
    [anon_sym_GT_EQ] = ACTIONS(5289),
    [anon_sym_EQ_EQ] = ACTIONS(5289),
    [anon_sym_BANG_EQ] = ACTIONS(5289),
    [anon_sym_STAR] = ACTIONS(5291),
    [anon_sym_SLASH] = ACTIONS(5293),
    [anon_sym_STAR_STAR] = ACTIONS(5295),
    [anon_sym_CARET] = ACTIONS(5295),
    [aux_sym_binary_operator_token1] = ACTIONS(5297),
    [anon_sym_PIPE_GT] = ACTIONS(5297),
    [anon_sym_COLON] = ACTIONS(5299),
    [anon_sym_DOLLAR] = ACTIONS(5301),
    [anon_sym_AT] = ACTIONS(5301),
    [aux_sym__hex_literal_token1] = ACTIONS(5117),
    [sym__number_literal] = ACTIONS(5115),
    [anon_sym_SQUOTE] = ACTIONS(5117),
    [anon_sym_DQUOTE] = ACTIONS(5117),
    [sym_return] = ACTIONS(5115),
    [sym_next] = ACTIONS(5115),
    [sym_break] = ACTIONS(5115),
    [sym_true] = ACTIONS(5115),
    [sym_false] = ACTIONS(5115),
    [sym_null] = ACTIONS(5115),
    [sym_inf] = ACTIONS(5115),
    [sym_nan] = ACTIONS(5115),
    [anon_sym_NA] = ACTIONS(5115),
    [anon_sym_NA_integer_] = ACTIONS(5115),
    [anon_sym_NA_real_] = ACTIONS(5115),
    [anon_sym_NA_complex_] = ACTIONS(5115),
    [anon_sym_NA_character_] = ACTIONS(5115),
    [sym_dots] = ACTIONS(5115),
    [sym_dot_dot_i] = ACTIONS(5117),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5117),
    [sym__newline] = ACTIONS(5117),
    [sym__semicolon] = ACTIONS(5117),
    [sym__raw_string_literal] = ACTIONS(5117),
    [sym__external_else] = ACTIONS(5473),
    [sym__external_open_parenthesis] = ACTIONS(5305),
    [sym__external_open_brace] = ACTIONS(5117),
    [sym__external_close_brace] = ACTIONS(5117),
    [sym__external_open_bracket] = ACTIONS(5307),
    [sym__external_open_bracket2] = ACTIONS(5309),
    [sym__external_close_bracket2] = ACTIONS(5117),
  },
  [672] = {
    [sym_call_arguments] = STATE(2509),
    [sym_subset_arguments] = STATE(2507),
    [sym_subset2_arguments] = STATE(2505),
    [sym__open_parenthesis] = STATE(1590),
    [sym__open_bracket] = STATE(1589),
    [sym__open_bracket2] = STATE(1588),
    [ts_builtin_sym_end] = ACTIONS(5445),
    [sym_identifier] = ACTIONS(5447),
    [anon_sym_BSLASH] = ACTIONS(5445),
    [anon_sym_function] = ACTIONS(5447),
    [anon_sym_EQ] = ACTIONS(5475),
    [anon_sym_if] = ACTIONS(5447),
    [anon_sym_for] = ACTIONS(5447),
    [anon_sym_while] = ACTIONS(5447),
    [anon_sym_repeat] = ACTIONS(5447),
    [anon_sym_QMARK] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(5477),
    [anon_sym_BANG] = ACTIONS(5447),
    [anon_sym_PLUS] = ACTIONS(5479),
    [anon_sym_DASH] = ACTIONS(5481),
    [anon_sym_LT_DASH] = ACTIONS(5483),
    [anon_sym_LT_LT_DASH] = ACTIONS(5483),
    [anon_sym_COLON_EQ] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5485),
    [anon_sym_DASH_GT_GT] = ACTIONS(5487),
    [anon_sym_PIPE] = ACTIONS(5489),
    [anon_sym_AMP] = ACTIONS(5491),
    [anon_sym_PIPE_PIPE] = ACTIONS(5493),
    [anon_sym_AMP_AMP] = ACTIONS(5495),
    [anon_sym_LT] = ACTIONS(5497),
    [anon_sym_LT_EQ] = ACTIONS(5499),
    [anon_sym_GT] = ACTIONS(5497),
    [anon_sym_GT_EQ] = ACTIONS(5499),
    [anon_sym_EQ_EQ] = ACTIONS(5499),
    [anon_sym_BANG_EQ] = ACTIONS(5499),
    [anon_sym_STAR] = ACTIONS(5501),
    [anon_sym_SLASH] = ACTIONS(5503),
    [anon_sym_STAR_STAR] = ACTIONS(5505),
    [anon_sym_CARET] = ACTIONS(5505),
    [aux_sym_binary_operator_token1] = ACTIONS(5507),
    [anon_sym_PIPE_GT] = ACTIONS(5507),
    [anon_sym_COLON] = ACTIONS(5509),
    [anon_sym_DOLLAR] = ACTIONS(5511),
    [anon_sym_AT] = ACTIONS(5511),
    [aux_sym__hex_literal_token1] = ACTIONS(5445),
    [sym__number_literal] = ACTIONS(5447),
    [anon_sym_SQUOTE] = ACTIONS(5445),
    [anon_sym_DQUOTE] = ACTIONS(5445),
    [sym_return] = ACTIONS(5447),
    [sym_next] = ACTIONS(5447),
    [sym_break] = ACTIONS(5447),
    [sym_true] = ACTIONS(5447),
    [sym_false] = ACTIONS(5447),
    [sym_null] = ACTIONS(5447),
    [sym_inf] = ACTIONS(5447),
    [sym_nan] = ACTIONS(5447),
    [anon_sym_NA] = ACTIONS(5447),
    [anon_sym_NA_integer_] = ACTIONS(5447),
    [anon_sym_NA_real_] = ACTIONS(5447),
    [anon_sym_NA_complex_] = ACTIONS(5447),
    [anon_sym_NA_character_] = ACTIONS(5447),
    [sym_dots] = ACTIONS(5447),
    [sym_dot_dot_i] = ACTIONS(5445),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5445),
    [sym__newline] = ACTIONS(5445),
    [sym__semicolon] = ACTIONS(5445),
    [sym__raw_string_literal] = ACTIONS(5445),
    [sym__external_open_parenthesis] = ACTIONS(5513),
    [sym__external_close_parenthesis] = ACTIONS(5445),
    [sym__external_open_brace] = ACTIONS(5445),
    [sym__external_close_brace] = ACTIONS(5445),
    [sym__external_open_bracket] = ACTIONS(5515),
    [sym__external_open_bracket2] = ACTIONS(5517),
  },
  [673] = {
    [sym_call_arguments] = STATE(2555),
    [sym_subset_arguments] = STATE(2554),
    [sym_subset2_arguments] = STATE(2553),
    [sym__open_parenthesis] = STATE(1332),
    [sym__open_bracket] = STATE(1331),
    [sym__open_bracket2] = STATE(1330),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5269),
    [anon_sym_DASH] = ACTIONS(5271),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5287),
    [anon_sym_LT_EQ] = ACTIONS(5289),
    [anon_sym_GT] = ACTIONS(5287),
    [anon_sym_GT_EQ] = ACTIONS(5289),
    [anon_sym_EQ_EQ] = ACTIONS(5289),
    [anon_sym_BANG_EQ] = ACTIONS(5289),
    [anon_sym_STAR] = ACTIONS(5291),
    [anon_sym_SLASH] = ACTIONS(5293),
    [anon_sym_STAR_STAR] = ACTIONS(5295),
    [anon_sym_CARET] = ACTIONS(5295),
    [aux_sym_binary_operator_token1] = ACTIONS(5297),
    [anon_sym_PIPE_GT] = ACTIONS(5297),
    [anon_sym_COLON] = ACTIONS(5299),
    [anon_sym_DOLLAR] = ACTIONS(5301),
    [anon_sym_AT] = ACTIONS(5301),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5305),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5307),
    [sym__external_open_bracket2] = ACTIONS(5309),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [674] = {
    [sym_call_arguments] = STATE(2401),
    [sym_subset_arguments] = STATE(2403),
    [sym_subset2_arguments] = STATE(2404),
    [sym__open_parenthesis] = STATE(1461),
    [sym__open_bracket] = STATE(1450),
    [sym__open_bracket2] = STATE(1447),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(5333),
    [anon_sym_DASH] = ACTIONS(5335),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5335),
    [anon_sym_AMP] = ACTIONS(5335),
    [anon_sym_PIPE_PIPE] = ACTIONS(5333),
    [anon_sym_AMP_AMP] = ACTIONS(5333),
    [anon_sym_LT] = ACTIONS(5335),
    [anon_sym_LT_EQ] = ACTIONS(5333),
    [anon_sym_GT] = ACTIONS(5335),
    [anon_sym_GT_EQ] = ACTIONS(5333),
    [anon_sym_EQ_EQ] = ACTIONS(5333),
    [anon_sym_BANG_EQ] = ACTIONS(5333),
    [anon_sym_STAR] = ACTIONS(5335),
    [anon_sym_SLASH] = ACTIONS(5333),
    [anon_sym_STAR_STAR] = ACTIONS(5519),
    [anon_sym_CARET] = ACTIONS(5519),
    [aux_sym_binary_operator_token1] = ACTIONS(5333),
    [anon_sym_PIPE_GT] = ACTIONS(5333),
    [anon_sym_COLON] = ACTIONS(5335),
    [anon_sym_DOLLAR] = ACTIONS(5521),
    [anon_sym_AT] = ACTIONS(5521),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__semicolon] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(5523),
    [sym__external_close_parenthesis] = ACTIONS(5333),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_close_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(5525),
    [sym__external_open_bracket2] = ACTIONS(5527),
    [sym__external_close_bracket2] = ACTIONS(5333),
  },
  [675] = {
    [sym_call_arguments] = STATE(2401),
    [sym_subset_arguments] = STATE(2403),
    [sym_subset2_arguments] = STATE(2404),
    [sym__open_parenthesis] = STATE(1461),
    [sym__open_bracket] = STATE(1450),
    [sym__open_bracket2] = STATE(1447),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(5529),
    [anon_sym_DASH] = ACTIONS(5531),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5335),
    [anon_sym_AMP] = ACTIONS(5335),
    [anon_sym_PIPE_PIPE] = ACTIONS(5333),
    [anon_sym_AMP_AMP] = ACTIONS(5333),
    [anon_sym_LT] = ACTIONS(5533),
    [anon_sym_LT_EQ] = ACTIONS(5535),
    [anon_sym_GT] = ACTIONS(5533),
    [anon_sym_GT_EQ] = ACTIONS(5535),
    [anon_sym_EQ_EQ] = ACTIONS(5535),
    [anon_sym_BANG_EQ] = ACTIONS(5535),
    [anon_sym_STAR] = ACTIONS(5537),
    [anon_sym_SLASH] = ACTIONS(5539),
    [anon_sym_STAR_STAR] = ACTIONS(5519),
    [anon_sym_CARET] = ACTIONS(5519),
    [aux_sym_binary_operator_token1] = ACTIONS(5541),
    [anon_sym_PIPE_GT] = ACTIONS(5541),
    [anon_sym_COLON] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5521),
    [anon_sym_AT] = ACTIONS(5521),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__semicolon] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(5523),
    [sym__external_close_parenthesis] = ACTIONS(5333),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_close_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(5525),
    [sym__external_open_bracket2] = ACTIONS(5527),
    [sym__external_close_bracket2] = ACTIONS(5333),
  },
  [676] = {
    [sym_call_arguments] = STATE(2401),
    [sym_subset_arguments] = STATE(2403),
    [sym_subset2_arguments] = STATE(2404),
    [sym__open_parenthesis] = STATE(1461),
    [sym__open_bracket] = STATE(1450),
    [sym__open_bracket2] = STATE(1447),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(5529),
    [anon_sym_DASH] = ACTIONS(5531),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5545),
    [anon_sym_AMP] = ACTIONS(5547),
    [anon_sym_PIPE_PIPE] = ACTIONS(5549),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_LT] = ACTIONS(5533),
    [anon_sym_LT_EQ] = ACTIONS(5535),
    [anon_sym_GT] = ACTIONS(5533),
    [anon_sym_GT_EQ] = ACTIONS(5535),
    [anon_sym_EQ_EQ] = ACTIONS(5535),
    [anon_sym_BANG_EQ] = ACTIONS(5535),
    [anon_sym_STAR] = ACTIONS(5537),
    [anon_sym_SLASH] = ACTIONS(5539),
    [anon_sym_STAR_STAR] = ACTIONS(5519),
    [anon_sym_CARET] = ACTIONS(5519),
    [aux_sym_binary_operator_token1] = ACTIONS(5541),
    [anon_sym_PIPE_GT] = ACTIONS(5541),
    [anon_sym_COLON] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5521),
    [anon_sym_AT] = ACTIONS(5521),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__semicolon] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(5523),
    [sym__external_close_parenthesis] = ACTIONS(5333),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_close_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(5525),
    [sym__external_open_bracket2] = ACTIONS(5527),
    [sym__external_close_bracket2] = ACTIONS(5333),
  },
  [677] = {
    [sym_call_arguments] = STATE(2401),
    [sym_subset_arguments] = STATE(2403),
    [sym_subset2_arguments] = STATE(2404),
    [sym__open_parenthesis] = STATE(1461),
    [sym__open_bracket] = STATE(1450),
    [sym__open_bracket2] = STATE(1447),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5553),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5555),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(5529),
    [anon_sym_DASH] = ACTIONS(5531),
    [anon_sym_LT_DASH] = ACTIONS(5557),
    [anon_sym_LT_LT_DASH] = ACTIONS(5557),
    [anon_sym_COLON_EQ] = ACTIONS(5557),
    [anon_sym_DASH_GT] = ACTIONS(5559),
    [anon_sym_DASH_GT_GT] = ACTIONS(5561),
    [anon_sym_PIPE] = ACTIONS(5545),
    [anon_sym_AMP] = ACTIONS(5547),
    [anon_sym_PIPE_PIPE] = ACTIONS(5549),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_LT] = ACTIONS(5533),
    [anon_sym_LT_EQ] = ACTIONS(5535),
    [anon_sym_GT] = ACTIONS(5533),
    [anon_sym_GT_EQ] = ACTIONS(5535),
    [anon_sym_EQ_EQ] = ACTIONS(5535),
    [anon_sym_BANG_EQ] = ACTIONS(5535),
    [anon_sym_STAR] = ACTIONS(5537),
    [anon_sym_SLASH] = ACTIONS(5539),
    [anon_sym_STAR_STAR] = ACTIONS(5519),
    [anon_sym_CARET] = ACTIONS(5519),
    [aux_sym_binary_operator_token1] = ACTIONS(5541),
    [anon_sym_PIPE_GT] = ACTIONS(5541),
    [anon_sym_COLON] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5521),
    [anon_sym_AT] = ACTIONS(5521),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__semicolon] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(5523),
    [sym__external_close_parenthesis] = ACTIONS(5333),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_close_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(5525),
    [sym__external_open_bracket2] = ACTIONS(5527),
    [sym__external_close_bracket2] = ACTIONS(5333),
  },
  [678] = {
    [sym_call_arguments] = STATE(2401),
    [sym_subset_arguments] = STATE(2403),
    [sym_subset2_arguments] = STATE(2404),
    [sym__open_parenthesis] = STATE(1461),
    [sym__open_bracket] = STATE(1450),
    [sym__open_bracket2] = STATE(1447),
    [sym_identifier] = ACTIONS(5331),
    [anon_sym_BSLASH] = ACTIONS(5329),
    [anon_sym_function] = ACTIONS(5331),
    [anon_sym_EQ] = ACTIONS(5553),
    [anon_sym_if] = ACTIONS(5331),
    [anon_sym_for] = ACTIONS(5331),
    [anon_sym_while] = ACTIONS(5331),
    [anon_sym_repeat] = ACTIONS(5331),
    [anon_sym_QMARK] = ACTIONS(5329),
    [anon_sym_TILDE] = ACTIONS(5555),
    [anon_sym_BANG] = ACTIONS(5331),
    [anon_sym_PLUS] = ACTIONS(5529),
    [anon_sym_DASH] = ACTIONS(5531),
    [anon_sym_LT_DASH] = ACTIONS(5557),
    [anon_sym_LT_LT_DASH] = ACTIONS(5557),
    [anon_sym_COLON_EQ] = ACTIONS(5557),
    [anon_sym_DASH_GT] = ACTIONS(5559),
    [anon_sym_DASH_GT_GT] = ACTIONS(5561),
    [anon_sym_PIPE] = ACTIONS(5545),
    [anon_sym_AMP] = ACTIONS(5547),
    [anon_sym_PIPE_PIPE] = ACTIONS(5549),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_LT] = ACTIONS(5533),
    [anon_sym_LT_EQ] = ACTIONS(5535),
    [anon_sym_GT] = ACTIONS(5533),
    [anon_sym_GT_EQ] = ACTIONS(5535),
    [anon_sym_EQ_EQ] = ACTIONS(5535),
    [anon_sym_BANG_EQ] = ACTIONS(5535),
    [anon_sym_STAR] = ACTIONS(5537),
    [anon_sym_SLASH] = ACTIONS(5539),
    [anon_sym_STAR_STAR] = ACTIONS(5519),
    [anon_sym_CARET] = ACTIONS(5519),
    [aux_sym_binary_operator_token1] = ACTIONS(5541),
    [anon_sym_PIPE_GT] = ACTIONS(5541),
    [anon_sym_COLON] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5521),
    [anon_sym_AT] = ACTIONS(5521),
    [aux_sym__hex_literal_token1] = ACTIONS(5329),
    [sym__number_literal] = ACTIONS(5331),
    [anon_sym_SQUOTE] = ACTIONS(5329),
    [anon_sym_DQUOTE] = ACTIONS(5329),
    [sym_return] = ACTIONS(5331),
    [sym_next] = ACTIONS(5331),
    [sym_break] = ACTIONS(5331),
    [sym_true] = ACTIONS(5331),
    [sym_false] = ACTIONS(5331),
    [sym_null] = ACTIONS(5331),
    [sym_inf] = ACTIONS(5331),
    [sym_nan] = ACTIONS(5331),
    [anon_sym_NA] = ACTIONS(5331),
    [anon_sym_NA_integer_] = ACTIONS(5331),
    [anon_sym_NA_real_] = ACTIONS(5331),
    [anon_sym_NA_complex_] = ACTIONS(5331),
    [anon_sym_NA_character_] = ACTIONS(5331),
    [sym_dots] = ACTIONS(5331),
    [sym_dot_dot_i] = ACTIONS(5329),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5329),
    [sym__newline] = ACTIONS(5329),
    [sym__semicolon] = ACTIONS(5329),
    [sym__raw_string_literal] = ACTIONS(5329),
    [sym__external_open_parenthesis] = ACTIONS(5523),
    [sym__external_close_parenthesis] = ACTIONS(5329),
    [sym__external_open_brace] = ACTIONS(5329),
    [sym__external_close_brace] = ACTIONS(5329),
    [sym__external_open_bracket] = ACTIONS(5525),
    [sym__external_open_bracket2] = ACTIONS(5527),
    [sym__external_close_bracket2] = ACTIONS(5329),
  },
  [679] = {
    [sym_call_arguments] = STATE(2380),
    [sym_subset_arguments] = STATE(2385),
    [sym_subset2_arguments] = STATE(2388),
    [sym__open_parenthesis] = STATE(1496),
    [sym__open_bracket] = STATE(1494),
    [sym__open_bracket2] = STATE(1490),
    [sym_identifier] = ACTIONS(5411),
    [anon_sym_BSLASH] = ACTIONS(5409),
    [anon_sym_function] = ACTIONS(5411),
    [anon_sym_EQ] = ACTIONS(5563),
    [anon_sym_if] = ACTIONS(5411),
    [anon_sym_for] = ACTIONS(5411),
    [anon_sym_while] = ACTIONS(5411),
    [anon_sym_repeat] = ACTIONS(5411),
    [anon_sym_QMARK] = ACTIONS(5409),
    [anon_sym_TILDE] = ACTIONS(5565),
    [anon_sym_BANG] = ACTIONS(5411),
    [anon_sym_PLUS] = ACTIONS(5567),
    [anon_sym_DASH] = ACTIONS(5569),
    [anon_sym_LT_DASH] = ACTIONS(5571),
    [anon_sym_LT_LT_DASH] = ACTIONS(5571),
    [anon_sym_COLON_EQ] = ACTIONS(5571),
    [anon_sym_DASH_GT] = ACTIONS(5573),
    [anon_sym_DASH_GT_GT] = ACTIONS(5575),
    [anon_sym_PIPE] = ACTIONS(5577),
    [anon_sym_AMP] = ACTIONS(5579),
    [anon_sym_PIPE_PIPE] = ACTIONS(5581),
    [anon_sym_AMP_AMP] = ACTIONS(5583),
    [anon_sym_LT] = ACTIONS(5585),
    [anon_sym_LT_EQ] = ACTIONS(5587),
    [anon_sym_GT] = ACTIONS(5585),
    [anon_sym_GT_EQ] = ACTIONS(5587),
    [anon_sym_EQ_EQ] = ACTIONS(5587),
    [anon_sym_BANG_EQ] = ACTIONS(5587),
    [anon_sym_STAR] = ACTIONS(5589),
    [anon_sym_SLASH] = ACTIONS(5591),
    [anon_sym_STAR_STAR] = ACTIONS(5593),
    [anon_sym_CARET] = ACTIONS(5593),
    [aux_sym_binary_operator_token1] = ACTIONS(5595),
    [anon_sym_PIPE_GT] = ACTIONS(5595),
    [anon_sym_COLON] = ACTIONS(5597),
    [anon_sym_DOLLAR] = ACTIONS(5599),
    [anon_sym_AT] = ACTIONS(5599),
    [aux_sym__hex_literal_token1] = ACTIONS(5409),
    [sym__number_literal] = ACTIONS(5411),
    [anon_sym_SQUOTE] = ACTIONS(5409),
    [anon_sym_DQUOTE] = ACTIONS(5409),
    [sym_return] = ACTIONS(5411),
    [sym_next] = ACTIONS(5411),
    [sym_break] = ACTIONS(5411),
    [sym_true] = ACTIONS(5411),
    [sym_false] = ACTIONS(5411),
    [sym_null] = ACTIONS(5411),
    [sym_inf] = ACTIONS(5411),
    [sym_nan] = ACTIONS(5411),
    [anon_sym_NA] = ACTIONS(5411),
    [anon_sym_NA_integer_] = ACTIONS(5411),
    [anon_sym_NA_real_] = ACTIONS(5411),
    [anon_sym_NA_complex_] = ACTIONS(5411),
    [anon_sym_NA_character_] = ACTIONS(5411),
    [sym_dots] = ACTIONS(5411),
    [sym_dot_dot_i] = ACTIONS(5409),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5409),
    [sym__newline] = ACTIONS(5409),
    [sym__semicolon] = ACTIONS(5409),
    [sym__raw_string_literal] = ACTIONS(5409),
    [sym__external_open_parenthesis] = ACTIONS(5601),
    [sym__external_close_parenthesis] = ACTIONS(5409),
    [sym__external_open_brace] = ACTIONS(5409),
    [sym__external_close_brace] = ACTIONS(5409),
    [sym__external_open_bracket] = ACTIONS(5603),
    [sym__external_close_bracket] = ACTIONS(5409),
    [sym__external_open_bracket2] = ACTIONS(5605),
  },
  [680] = {
    [sym_call_arguments] = STATE(2380),
    [sym_subset_arguments] = STATE(2385),
    [sym_subset2_arguments] = STATE(2388),
    [sym__open_parenthesis] = STATE(1496),
    [sym__open_bracket] = STATE(1494),
    [sym__open_bracket2] = STATE(1490),
    [sym_identifier] = ACTIONS(5455),
    [anon_sym_BSLASH] = ACTIONS(5453),
    [anon_sym_function] = ACTIONS(5455),
    [anon_sym_EQ] = ACTIONS(5563),
    [anon_sym_if] = ACTIONS(5455),
    [anon_sym_for] = ACTIONS(5455),
    [anon_sym_while] = ACTIONS(5455),
    [anon_sym_repeat] = ACTIONS(5455),
    [anon_sym_QMARK] = ACTIONS(5453),
    [anon_sym_TILDE] = ACTIONS(5565),
    [anon_sym_BANG] = ACTIONS(5455),
    [anon_sym_PLUS] = ACTIONS(5567),
    [anon_sym_DASH] = ACTIONS(5569),
    [anon_sym_LT_DASH] = ACTIONS(5571),
    [anon_sym_LT_LT_DASH] = ACTIONS(5571),
    [anon_sym_COLON_EQ] = ACTIONS(5571),
    [anon_sym_DASH_GT] = ACTIONS(5573),
    [anon_sym_DASH_GT_GT] = ACTIONS(5575),
    [anon_sym_PIPE] = ACTIONS(5577),
    [anon_sym_AMP] = ACTIONS(5579),
    [anon_sym_PIPE_PIPE] = ACTIONS(5581),
    [anon_sym_AMP_AMP] = ACTIONS(5583),
    [anon_sym_LT] = ACTIONS(5585),
    [anon_sym_LT_EQ] = ACTIONS(5587),
    [anon_sym_GT] = ACTIONS(5585),
    [anon_sym_GT_EQ] = ACTIONS(5587),
    [anon_sym_EQ_EQ] = ACTIONS(5587),
    [anon_sym_BANG_EQ] = ACTIONS(5587),
    [anon_sym_STAR] = ACTIONS(5589),
    [anon_sym_SLASH] = ACTIONS(5591),
    [anon_sym_STAR_STAR] = ACTIONS(5593),
    [anon_sym_CARET] = ACTIONS(5593),
    [aux_sym_binary_operator_token1] = ACTIONS(5595),
    [anon_sym_PIPE_GT] = ACTIONS(5595),
    [anon_sym_COLON] = ACTIONS(5597),
    [anon_sym_DOLLAR] = ACTIONS(5599),
    [anon_sym_AT] = ACTIONS(5599),
    [aux_sym__hex_literal_token1] = ACTIONS(5453),
    [sym__number_literal] = ACTIONS(5455),
    [anon_sym_SQUOTE] = ACTIONS(5453),
    [anon_sym_DQUOTE] = ACTIONS(5453),
    [sym_return] = ACTIONS(5455),
    [sym_next] = ACTIONS(5455),
    [sym_break] = ACTIONS(5455),
    [sym_true] = ACTIONS(5455),
    [sym_false] = ACTIONS(5455),
    [sym_null] = ACTIONS(5455),
    [sym_inf] = ACTIONS(5455),
    [sym_nan] = ACTIONS(5455),
    [anon_sym_NA] = ACTIONS(5455),
    [anon_sym_NA_integer_] = ACTIONS(5455),
    [anon_sym_NA_real_] = ACTIONS(5455),
    [anon_sym_NA_complex_] = ACTIONS(5455),
    [anon_sym_NA_character_] = ACTIONS(5455),
    [sym_dots] = ACTIONS(5455),
    [sym_dot_dot_i] = ACTIONS(5453),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5453),
    [sym__newline] = ACTIONS(5453),
    [sym__semicolon] = ACTIONS(5453),
    [sym__raw_string_literal] = ACTIONS(5453),
    [sym__external_open_parenthesis] = ACTIONS(5601),
    [sym__external_close_parenthesis] = ACTIONS(5453),
    [sym__external_open_brace] = ACTIONS(5453),
    [sym__external_close_brace] = ACTIONS(5453),
    [sym__external_open_bracket] = ACTIONS(5603),
    [sym__external_close_bracket] = ACTIONS(5453),
    [sym__external_open_bracket2] = ACTIONS(5605),
  },
  [681] = {
    [sym_call_arguments] = STATE(2380),
    [sym_subset_arguments] = STATE(2385),
    [sym_subset2_arguments] = STATE(2388),
    [sym__open_parenthesis] = STATE(1496),
    [sym__open_bracket] = STATE(1494),
    [sym__open_bracket2] = STATE(1490),
    [sym_identifier] = ACTIONS(5451),
    [anon_sym_BSLASH] = ACTIONS(5449),
    [anon_sym_function] = ACTIONS(5451),
    [anon_sym_EQ] = ACTIONS(5563),
    [anon_sym_if] = ACTIONS(5451),
    [anon_sym_for] = ACTIONS(5451),
    [anon_sym_while] = ACTIONS(5451),
    [anon_sym_repeat] = ACTIONS(5451),
    [anon_sym_QMARK] = ACTIONS(5449),
    [anon_sym_TILDE] = ACTIONS(5565),
    [anon_sym_BANG] = ACTIONS(5451),
    [anon_sym_PLUS] = ACTIONS(5567),
    [anon_sym_DASH] = ACTIONS(5569),
    [anon_sym_LT_DASH] = ACTIONS(5571),
    [anon_sym_LT_LT_DASH] = ACTIONS(5571),
    [anon_sym_COLON_EQ] = ACTIONS(5571),
    [anon_sym_DASH_GT] = ACTIONS(5573),
    [anon_sym_DASH_GT_GT] = ACTIONS(5575),
    [anon_sym_PIPE] = ACTIONS(5577),
    [anon_sym_AMP] = ACTIONS(5579),
    [anon_sym_PIPE_PIPE] = ACTIONS(5581),
    [anon_sym_AMP_AMP] = ACTIONS(5583),
    [anon_sym_LT] = ACTIONS(5585),
    [anon_sym_LT_EQ] = ACTIONS(5587),
    [anon_sym_GT] = ACTIONS(5585),
    [anon_sym_GT_EQ] = ACTIONS(5587),
    [anon_sym_EQ_EQ] = ACTIONS(5587),
    [anon_sym_BANG_EQ] = ACTIONS(5587),
    [anon_sym_STAR] = ACTIONS(5589),
    [anon_sym_SLASH] = ACTIONS(5591),
    [anon_sym_STAR_STAR] = ACTIONS(5593),
    [anon_sym_CARET] = ACTIONS(5593),
    [aux_sym_binary_operator_token1] = ACTIONS(5595),
    [anon_sym_PIPE_GT] = ACTIONS(5595),
    [anon_sym_COLON] = ACTIONS(5597),
    [anon_sym_DOLLAR] = ACTIONS(5599),
    [anon_sym_AT] = ACTIONS(5599),
    [aux_sym__hex_literal_token1] = ACTIONS(5449),
    [sym__number_literal] = ACTIONS(5451),
    [anon_sym_SQUOTE] = ACTIONS(5449),
    [anon_sym_DQUOTE] = ACTIONS(5449),
    [sym_return] = ACTIONS(5451),
    [sym_next] = ACTIONS(5451),
    [sym_break] = ACTIONS(5451),
    [sym_true] = ACTIONS(5451),
    [sym_false] = ACTIONS(5451),
    [sym_null] = ACTIONS(5451),
    [sym_inf] = ACTIONS(5451),
    [sym_nan] = ACTIONS(5451),
    [anon_sym_NA] = ACTIONS(5451),
    [anon_sym_NA_integer_] = ACTIONS(5451),
    [anon_sym_NA_real_] = ACTIONS(5451),
    [anon_sym_NA_complex_] = ACTIONS(5451),
    [anon_sym_NA_character_] = ACTIONS(5451),
    [sym_dots] = ACTIONS(5451),
    [sym_dot_dot_i] = ACTIONS(5449),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5449),
    [sym__newline] = ACTIONS(5449),
    [sym__semicolon] = ACTIONS(5449),
    [sym__raw_string_literal] = ACTIONS(5449),
    [sym__external_open_parenthesis] = ACTIONS(5601),
    [sym__external_close_parenthesis] = ACTIONS(5449),
    [sym__external_open_brace] = ACTIONS(5449),
    [sym__external_close_brace] = ACTIONS(5449),
    [sym__external_open_bracket] = ACTIONS(5603),
    [sym__external_close_bracket] = ACTIONS(5449),
    [sym__external_open_bracket2] = ACTIONS(5605),
  },
  [682] = {
    [sym_call_arguments] = STATE(2380),
    [sym_subset_arguments] = STATE(2385),
    [sym_subset2_arguments] = STATE(2388),
    [sym__open_parenthesis] = STATE(1496),
    [sym__open_bracket] = STATE(1494),
    [sym__open_bracket2] = STATE(1490),
    [sym_identifier] = ACTIONS(5447),
    [anon_sym_BSLASH] = ACTIONS(5445),
    [anon_sym_function] = ACTIONS(5447),
    [anon_sym_EQ] = ACTIONS(5563),
    [anon_sym_if] = ACTIONS(5447),
    [anon_sym_for] = ACTIONS(5447),
    [anon_sym_while] = ACTIONS(5447),
    [anon_sym_repeat] = ACTIONS(5447),
    [anon_sym_QMARK] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(5565),
    [anon_sym_BANG] = ACTIONS(5447),
    [anon_sym_PLUS] = ACTIONS(5567),
    [anon_sym_DASH] = ACTIONS(5569),
    [anon_sym_LT_DASH] = ACTIONS(5571),
    [anon_sym_LT_LT_DASH] = ACTIONS(5571),
    [anon_sym_COLON_EQ] = ACTIONS(5571),
    [anon_sym_DASH_GT] = ACTIONS(5573),
    [anon_sym_DASH_GT_GT] = ACTIONS(5575),
    [anon_sym_PIPE] = ACTIONS(5577),
    [anon_sym_AMP] = ACTIONS(5579),
    [anon_sym_PIPE_PIPE] = ACTIONS(5581),
    [anon_sym_AMP_AMP] = ACTIONS(5583),
    [anon_sym_LT] = ACTIONS(5585),
    [anon_sym_LT_EQ] = ACTIONS(5587),
    [anon_sym_GT] = ACTIONS(5585),
    [anon_sym_GT_EQ] = ACTIONS(5587),
    [anon_sym_EQ_EQ] = ACTIONS(5587),
    [anon_sym_BANG_EQ] = ACTIONS(5587),
    [anon_sym_STAR] = ACTIONS(5589),
    [anon_sym_SLASH] = ACTIONS(5591),
    [anon_sym_STAR_STAR] = ACTIONS(5593),
    [anon_sym_CARET] = ACTIONS(5593),
    [aux_sym_binary_operator_token1] = ACTIONS(5595),
    [anon_sym_PIPE_GT] = ACTIONS(5595),
    [anon_sym_COLON] = ACTIONS(5597),
    [anon_sym_DOLLAR] = ACTIONS(5599),
    [anon_sym_AT] = ACTIONS(5599),
    [aux_sym__hex_literal_token1] = ACTIONS(5445),
    [sym__number_literal] = ACTIONS(5447),
    [anon_sym_SQUOTE] = ACTIONS(5445),
    [anon_sym_DQUOTE] = ACTIONS(5445),
    [sym_return] = ACTIONS(5447),
    [sym_next] = ACTIONS(5447),
    [sym_break] = ACTIONS(5447),
    [sym_true] = ACTIONS(5447),
    [sym_false] = ACTIONS(5447),
    [sym_null] = ACTIONS(5447),
    [sym_inf] = ACTIONS(5447),
    [sym_nan] = ACTIONS(5447),
    [anon_sym_NA] = ACTIONS(5447),
    [anon_sym_NA_integer_] = ACTIONS(5447),
    [anon_sym_NA_real_] = ACTIONS(5447),
    [anon_sym_NA_complex_] = ACTIONS(5447),
    [anon_sym_NA_character_] = ACTIONS(5447),
    [sym_dots] = ACTIONS(5447),
    [sym_dot_dot_i] = ACTIONS(5445),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5445),
    [sym__newline] = ACTIONS(5445),
    [sym__semicolon] = ACTIONS(5445),
    [sym__raw_string_literal] = ACTIONS(5445),
    [sym__external_open_parenthesis] = ACTIONS(5601),
    [sym__external_close_parenthesis] = ACTIONS(5445),
    [sym__external_open_brace] = ACTIONS(5445),
    [sym__external_close_brace] = ACTIONS(5445),
    [sym__external_open_bracket] = ACTIONS(5603),
    [sym__external_close_bracket] = ACTIONS(5445),
    [sym__external_open_bracket2] = ACTIONS(5605),
  },
  [683] = {
    [sym_call_arguments] = STATE(2380),
    [sym_subset_arguments] = STATE(2385),
    [sym_subset2_arguments] = STATE(2388),
    [sym__open_parenthesis] = STATE(1496),
    [sym__open_bracket] = STATE(1494),
    [sym__open_bracket2] = STATE(1490),
    [sym_identifier] = ACTIONS(5443),
    [anon_sym_BSLASH] = ACTIONS(5441),
    [anon_sym_function] = ACTIONS(5443),
    [anon_sym_EQ] = ACTIONS(5563),
    [anon_sym_if] = ACTIONS(5443),
    [anon_sym_for] = ACTIONS(5443),
    [anon_sym_while] = ACTIONS(5443),
    [anon_sym_repeat] = ACTIONS(5443),
    [anon_sym_QMARK] = ACTIONS(5441),
    [anon_sym_TILDE] = ACTIONS(5565),
    [anon_sym_BANG] = ACTIONS(5443),
    [anon_sym_PLUS] = ACTIONS(5567),
    [anon_sym_DASH] = ACTIONS(5569),
    [anon_sym_LT_DASH] = ACTIONS(5571),
    [anon_sym_LT_LT_DASH] = ACTIONS(5571),
    [anon_sym_COLON_EQ] = ACTIONS(5571),
    [anon_sym_DASH_GT] = ACTIONS(5573),
    [anon_sym_DASH_GT_GT] = ACTIONS(5575),
    [anon_sym_PIPE] = ACTIONS(5577),
    [anon_sym_AMP] = ACTIONS(5579),
    [anon_sym_PIPE_PIPE] = ACTIONS(5581),
    [anon_sym_AMP_AMP] = ACTIONS(5583),
    [anon_sym_LT] = ACTIONS(5585),
    [anon_sym_LT_EQ] = ACTIONS(5587),
    [anon_sym_GT] = ACTIONS(5585),
    [anon_sym_GT_EQ] = ACTIONS(5587),
    [anon_sym_EQ_EQ] = ACTIONS(5587),
    [anon_sym_BANG_EQ] = ACTIONS(5587),
    [anon_sym_STAR] = ACTIONS(5589),
    [anon_sym_SLASH] = ACTIONS(5591),
    [anon_sym_STAR_STAR] = ACTIONS(5593),
    [anon_sym_CARET] = ACTIONS(5593),
    [aux_sym_binary_operator_token1] = ACTIONS(5595),
    [anon_sym_PIPE_GT] = ACTIONS(5595),
    [anon_sym_COLON] = ACTIONS(5597),
    [anon_sym_DOLLAR] = ACTIONS(5599),
    [anon_sym_AT] = ACTIONS(5599),
    [aux_sym__hex_literal_token1] = ACTIONS(5441),
    [sym__number_literal] = ACTIONS(5443),
    [anon_sym_SQUOTE] = ACTIONS(5441),
    [anon_sym_DQUOTE] = ACTIONS(5441),
    [sym_return] = ACTIONS(5443),
    [sym_next] = ACTIONS(5443),
    [sym_break] = ACTIONS(5443),
    [sym_true] = ACTIONS(5443),
    [sym_false] = ACTIONS(5443),
    [sym_null] = ACTIONS(5443),
    [sym_inf] = ACTIONS(5443),
    [sym_nan] = ACTIONS(5443),
    [anon_sym_NA] = ACTIONS(5443),
    [anon_sym_NA_integer_] = ACTIONS(5443),
    [anon_sym_NA_real_] = ACTIONS(5443),
    [anon_sym_NA_complex_] = ACTIONS(5443),
    [anon_sym_NA_character_] = ACTIONS(5443),
    [sym_dots] = ACTIONS(5443),
    [sym_dot_dot_i] = ACTIONS(5441),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5441),
    [sym__newline] = ACTIONS(5441),
    [sym__semicolon] = ACTIONS(5441),
    [sym__raw_string_literal] = ACTIONS(5441),
    [sym__external_open_parenthesis] = ACTIONS(5601),
    [sym__external_close_parenthesis] = ACTIONS(5441),
    [sym__external_open_brace] = ACTIONS(5441),
    [sym__external_close_brace] = ACTIONS(5441),
    [sym__external_open_bracket] = ACTIONS(5603),
    [sym__external_close_bracket] = ACTIONS(5441),
    [sym__external_open_bracket2] = ACTIONS(5605),
  },
  [684] = {
    [sym_call_arguments] = STATE(2380),
    [sym_subset_arguments] = STATE(2385),
    [sym_subset2_arguments] = STATE(2388),
    [sym__open_parenthesis] = STATE(1496),
    [sym__open_bracket] = STATE(1494),
    [sym__open_bracket2] = STATE(1490),
    [sym_identifier] = ACTIONS(5439),
    [anon_sym_BSLASH] = ACTIONS(5437),
    [anon_sym_function] = ACTIONS(5439),
    [anon_sym_EQ] = ACTIONS(5563),
    [anon_sym_if] = ACTIONS(5439),
    [anon_sym_for] = ACTIONS(5439),
    [anon_sym_while] = ACTIONS(5439),
    [anon_sym_repeat] = ACTIONS(5439),
    [anon_sym_QMARK] = ACTIONS(5437),
    [anon_sym_TILDE] = ACTIONS(5565),
    [anon_sym_BANG] = ACTIONS(5439),
    [anon_sym_PLUS] = ACTIONS(5567),
    [anon_sym_DASH] = ACTIONS(5569),
    [anon_sym_LT_DASH] = ACTIONS(5571),
    [anon_sym_LT_LT_DASH] = ACTIONS(5571),
    [anon_sym_COLON_EQ] = ACTIONS(5571),
    [anon_sym_DASH_GT] = ACTIONS(5573),
    [anon_sym_DASH_GT_GT] = ACTIONS(5575),
    [anon_sym_PIPE] = ACTIONS(5577),
    [anon_sym_AMP] = ACTIONS(5579),
    [anon_sym_PIPE_PIPE] = ACTIONS(5581),
    [anon_sym_AMP_AMP] = ACTIONS(5583),
    [anon_sym_LT] = ACTIONS(5585),
    [anon_sym_LT_EQ] = ACTIONS(5587),
    [anon_sym_GT] = ACTIONS(5585),
    [anon_sym_GT_EQ] = ACTIONS(5587),
    [anon_sym_EQ_EQ] = ACTIONS(5587),
    [anon_sym_BANG_EQ] = ACTIONS(5587),
    [anon_sym_STAR] = ACTIONS(5589),
    [anon_sym_SLASH] = ACTIONS(5591),
    [anon_sym_STAR_STAR] = ACTIONS(5593),
    [anon_sym_CARET] = ACTIONS(5593),
    [aux_sym_binary_operator_token1] = ACTIONS(5595),
    [anon_sym_PIPE_GT] = ACTIONS(5595),
    [anon_sym_COLON] = ACTIONS(5597),
    [anon_sym_DOLLAR] = ACTIONS(5599),
    [anon_sym_AT] = ACTIONS(5599),
    [aux_sym__hex_literal_token1] = ACTIONS(5437),
    [sym__number_literal] = ACTIONS(5439),
    [anon_sym_SQUOTE] = ACTIONS(5437),
    [anon_sym_DQUOTE] = ACTIONS(5437),
    [sym_return] = ACTIONS(5439),
    [sym_next] = ACTIONS(5439),
    [sym_break] = ACTIONS(5439),
    [sym_true] = ACTIONS(5439),
    [sym_false] = ACTIONS(5439),
    [sym_null] = ACTIONS(5439),
    [sym_inf] = ACTIONS(5439),
    [sym_nan] = ACTIONS(5439),
    [anon_sym_NA] = ACTIONS(5439),
    [anon_sym_NA_integer_] = ACTIONS(5439),
    [anon_sym_NA_real_] = ACTIONS(5439),
    [anon_sym_NA_complex_] = ACTIONS(5439),
    [anon_sym_NA_character_] = ACTIONS(5439),
    [sym_dots] = ACTIONS(5439),
    [sym_dot_dot_i] = ACTIONS(5437),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5437),
    [sym__newline] = ACTIONS(5437),
    [sym__semicolon] = ACTIONS(5437),
    [sym__raw_string_literal] = ACTIONS(5437),
    [sym__external_open_parenthesis] = ACTIONS(5601),
    [sym__external_close_parenthesis] = ACTIONS(5437),
    [sym__external_open_brace] = ACTIONS(5437),
    [sym__external_close_brace] = ACTIONS(5437),
    [sym__external_open_bracket] = ACTIONS(5603),
    [sym__external_close_bracket] = ACTIONS(5437),
    [sym__external_open_bracket2] = ACTIONS(5605),
  },
  [685] = {
    [sym_call_arguments] = STATE(2380),
    [sym_subset_arguments] = STATE(2385),
    [sym_subset2_arguments] = STATE(2388),
    [sym__open_parenthesis] = STATE(1496),
    [sym__open_bracket] = STATE(1494),
    [sym__open_bracket2] = STATE(1490),
    [sym_identifier] = ACTIONS(5435),
    [anon_sym_BSLASH] = ACTIONS(5433),
    [anon_sym_function] = ACTIONS(5435),
    [anon_sym_EQ] = ACTIONS(5563),
    [anon_sym_if] = ACTIONS(5435),
    [anon_sym_for] = ACTIONS(5435),
    [anon_sym_while] = ACTIONS(5435),
    [anon_sym_repeat] = ACTIONS(5435),
    [anon_sym_QMARK] = ACTIONS(5433),
    [anon_sym_TILDE] = ACTIONS(5565),
    [anon_sym_BANG] = ACTIONS(5435),
    [anon_sym_PLUS] = ACTIONS(5567),
    [anon_sym_DASH] = ACTIONS(5569),
    [anon_sym_LT_DASH] = ACTIONS(5571),
    [anon_sym_LT_LT_DASH] = ACTIONS(5571),
    [anon_sym_COLON_EQ] = ACTIONS(5571),
    [anon_sym_DASH_GT] = ACTIONS(5573),
    [anon_sym_DASH_GT_GT] = ACTIONS(5575),
    [anon_sym_PIPE] = ACTIONS(5577),
    [anon_sym_AMP] = ACTIONS(5579),
    [anon_sym_PIPE_PIPE] = ACTIONS(5581),
    [anon_sym_AMP_AMP] = ACTIONS(5583),
    [anon_sym_LT] = ACTIONS(5585),
    [anon_sym_LT_EQ] = ACTIONS(5587),
    [anon_sym_GT] = ACTIONS(5585),
    [anon_sym_GT_EQ] = ACTIONS(5587),
    [anon_sym_EQ_EQ] = ACTIONS(5587),
    [anon_sym_BANG_EQ] = ACTIONS(5587),
    [anon_sym_STAR] = ACTIONS(5589),
    [anon_sym_SLASH] = ACTIONS(5591),
    [anon_sym_STAR_STAR] = ACTIONS(5593),
    [anon_sym_CARET] = ACTIONS(5593),
    [aux_sym_binary_operator_token1] = ACTIONS(5595),
    [anon_sym_PIPE_GT] = ACTIONS(5595),
    [anon_sym_COLON] = ACTIONS(5597),
    [anon_sym_DOLLAR] = ACTIONS(5599),
    [anon_sym_AT] = ACTIONS(5599),
    [aux_sym__hex_literal_token1] = ACTIONS(5433),
    [sym__number_literal] = ACTIONS(5435),
    [anon_sym_SQUOTE] = ACTIONS(5433),
    [anon_sym_DQUOTE] = ACTIONS(5433),
    [sym_return] = ACTIONS(5435),
    [sym_next] = ACTIONS(5435),
    [sym_break] = ACTIONS(5435),
    [sym_true] = ACTIONS(5435),
    [sym_false] = ACTIONS(5435),
    [sym_null] = ACTIONS(5435),
    [sym_inf] = ACTIONS(5435),
    [sym_nan] = ACTIONS(5435),
    [anon_sym_NA] = ACTIONS(5435),
    [anon_sym_NA_integer_] = ACTIONS(5435),
    [anon_sym_NA_real_] = ACTIONS(5435),
    [anon_sym_NA_complex_] = ACTIONS(5435),
    [anon_sym_NA_character_] = ACTIONS(5435),
    [sym_dots] = ACTIONS(5435),
    [sym_dot_dot_i] = ACTIONS(5433),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5433),
    [sym__newline] = ACTIONS(5433),
    [sym__semicolon] = ACTIONS(5433),
    [sym__raw_string_literal] = ACTIONS(5433),
    [sym__external_open_parenthesis] = ACTIONS(5601),
    [sym__external_close_parenthesis] = ACTIONS(5433),
    [sym__external_open_brace] = ACTIONS(5433),
    [sym__external_close_brace] = ACTIONS(5433),
    [sym__external_open_bracket] = ACTIONS(5603),
    [sym__external_close_bracket] = ACTIONS(5433),
    [sym__external_open_bracket2] = ACTIONS(5605),
  },
  [686] = {
    [sym_call_arguments] = STATE(2380),
    [sym_subset_arguments] = STATE(2385),
    [sym_subset2_arguments] = STATE(2388),
    [sym__open_parenthesis] = STATE(1496),
    [sym__open_bracket] = STATE(1494),
    [sym__open_bracket2] = STATE(1490),
    [sym_identifier] = ACTIONS(5431),
    [anon_sym_BSLASH] = ACTIONS(5429),
    [anon_sym_function] = ACTIONS(5431),
    [anon_sym_EQ] = ACTIONS(5563),
    [anon_sym_if] = ACTIONS(5431),
    [anon_sym_for] = ACTIONS(5431),
    [anon_sym_while] = ACTIONS(5431),
    [anon_sym_repeat] = ACTIONS(5431),
    [anon_sym_QMARK] = ACTIONS(5429),
    [anon_sym_TILDE] = ACTIONS(5565),
    [anon_sym_BANG] = ACTIONS(5431),
    [anon_sym_PLUS] = ACTIONS(5567),
    [anon_sym_DASH] = ACTIONS(5569),
    [anon_sym_LT_DASH] = ACTIONS(5571),
    [anon_sym_LT_LT_DASH] = ACTIONS(5571),
    [anon_sym_COLON_EQ] = ACTIONS(5571),
    [anon_sym_DASH_GT] = ACTIONS(5573),
    [anon_sym_DASH_GT_GT] = ACTIONS(5575),
    [anon_sym_PIPE] = ACTIONS(5577),
    [anon_sym_AMP] = ACTIONS(5579),
    [anon_sym_PIPE_PIPE] = ACTIONS(5581),
    [anon_sym_AMP_AMP] = ACTIONS(5583),
    [anon_sym_LT] = ACTIONS(5585),
    [anon_sym_LT_EQ] = ACTIONS(5587),
    [anon_sym_GT] = ACTIONS(5585),
    [anon_sym_GT_EQ] = ACTIONS(5587),
    [anon_sym_EQ_EQ] = ACTIONS(5587),
    [anon_sym_BANG_EQ] = ACTIONS(5587),
    [anon_sym_STAR] = ACTIONS(5589),
    [anon_sym_SLASH] = ACTIONS(5591),
    [anon_sym_STAR_STAR] = ACTIONS(5593),
    [anon_sym_CARET] = ACTIONS(5593),
    [aux_sym_binary_operator_token1] = ACTIONS(5595),
    [anon_sym_PIPE_GT] = ACTIONS(5595),
    [anon_sym_COLON] = ACTIONS(5597),
    [anon_sym_DOLLAR] = ACTIONS(5599),
    [anon_sym_AT] = ACTIONS(5599),
    [aux_sym__hex_literal_token1] = ACTIONS(5429),
    [sym__number_literal] = ACTIONS(5431),
    [anon_sym_SQUOTE] = ACTIONS(5429),
    [anon_sym_DQUOTE] = ACTIONS(5429),
    [sym_return] = ACTIONS(5431),
    [sym_next] = ACTIONS(5431),
    [sym_break] = ACTIONS(5431),
    [sym_true] = ACTIONS(5431),
    [sym_false] = ACTIONS(5431),
    [sym_null] = ACTIONS(5431),
    [sym_inf] = ACTIONS(5431),
    [sym_nan] = ACTIONS(5431),
    [anon_sym_NA] = ACTIONS(5431),
    [anon_sym_NA_integer_] = ACTIONS(5431),
    [anon_sym_NA_real_] = ACTIONS(5431),
    [anon_sym_NA_complex_] = ACTIONS(5431),
    [anon_sym_NA_character_] = ACTIONS(5431),
    [sym_dots] = ACTIONS(5431),
    [sym_dot_dot_i] = ACTIONS(5429),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5429),
    [sym__newline] = ACTIONS(5429),
    [sym__semicolon] = ACTIONS(5429),
    [sym__raw_string_literal] = ACTIONS(5429),
    [sym__external_open_parenthesis] = ACTIONS(5601),
    [sym__external_close_parenthesis] = ACTIONS(5429),
    [sym__external_open_brace] = ACTIONS(5429),
    [sym__external_close_brace] = ACTIONS(5429),
    [sym__external_open_bracket] = ACTIONS(5603),
    [sym__external_close_bracket] = ACTIONS(5429),
    [sym__external_open_bracket2] = ACTIONS(5605),
  },
  [687] = {
    [sym_call_arguments] = STATE(2380),
    [sym_subset_arguments] = STATE(2385),
    [sym_subset2_arguments] = STATE(2388),
    [sym__open_parenthesis] = STATE(1496),
    [sym__open_bracket] = STATE(1494),
    [sym__open_bracket2] = STATE(1490),
    [sym_identifier] = ACTIONS(5427),
    [anon_sym_BSLASH] = ACTIONS(5425),
    [anon_sym_function] = ACTIONS(5427),
    [anon_sym_EQ] = ACTIONS(5563),
    [anon_sym_if] = ACTIONS(5427),
    [anon_sym_for] = ACTIONS(5427),
    [anon_sym_while] = ACTIONS(5427),
    [anon_sym_repeat] = ACTIONS(5427),
    [anon_sym_QMARK] = ACTIONS(5425),
    [anon_sym_TILDE] = ACTIONS(5565),
    [anon_sym_BANG] = ACTIONS(5427),
    [anon_sym_PLUS] = ACTIONS(5567),
    [anon_sym_DASH] = ACTIONS(5569),
    [anon_sym_LT_DASH] = ACTIONS(5571),
    [anon_sym_LT_LT_DASH] = ACTIONS(5571),
    [anon_sym_COLON_EQ] = ACTIONS(5571),
    [anon_sym_DASH_GT] = ACTIONS(5573),
    [anon_sym_DASH_GT_GT] = ACTIONS(5575),
    [anon_sym_PIPE] = ACTIONS(5577),
    [anon_sym_AMP] = ACTIONS(5579),
    [anon_sym_PIPE_PIPE] = ACTIONS(5581),
    [anon_sym_AMP_AMP] = ACTIONS(5583),
    [anon_sym_LT] = ACTIONS(5585),
    [anon_sym_LT_EQ] = ACTIONS(5587),
    [anon_sym_GT] = ACTIONS(5585),
    [anon_sym_GT_EQ] = ACTIONS(5587),
    [anon_sym_EQ_EQ] = ACTIONS(5587),
    [anon_sym_BANG_EQ] = ACTIONS(5587),
    [anon_sym_STAR] = ACTIONS(5589),
    [anon_sym_SLASH] = ACTIONS(5591),
    [anon_sym_STAR_STAR] = ACTIONS(5593),
    [anon_sym_CARET] = ACTIONS(5593),
    [aux_sym_binary_operator_token1] = ACTIONS(5595),
    [anon_sym_PIPE_GT] = ACTIONS(5595),
    [anon_sym_COLON] = ACTIONS(5597),
    [anon_sym_DOLLAR] = ACTIONS(5599),
    [anon_sym_AT] = ACTIONS(5599),
    [aux_sym__hex_literal_token1] = ACTIONS(5425),
    [sym__number_literal] = ACTIONS(5427),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_DQUOTE] = ACTIONS(5425),
    [sym_return] = ACTIONS(5427),
    [sym_next] = ACTIONS(5427),
    [sym_break] = ACTIONS(5427),
    [sym_true] = ACTIONS(5427),
    [sym_false] = ACTIONS(5427),
    [sym_null] = ACTIONS(5427),
    [sym_inf] = ACTIONS(5427),
    [sym_nan] = ACTIONS(5427),
    [anon_sym_NA] = ACTIONS(5427),
    [anon_sym_NA_integer_] = ACTIONS(5427),
    [anon_sym_NA_real_] = ACTIONS(5427),
    [anon_sym_NA_complex_] = ACTIONS(5427),
    [anon_sym_NA_character_] = ACTIONS(5427),
    [sym_dots] = ACTIONS(5427),
    [sym_dot_dot_i] = ACTIONS(5425),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5425),
    [sym__newline] = ACTIONS(5425),
    [sym__semicolon] = ACTIONS(5425),
    [sym__raw_string_literal] = ACTIONS(5425),
    [sym__external_open_parenthesis] = ACTIONS(5601),
    [sym__external_close_parenthesis] = ACTIONS(5425),
    [sym__external_open_brace] = ACTIONS(5425),
    [sym__external_close_brace] = ACTIONS(5425),
    [sym__external_open_bracket] = ACTIONS(5603),
    [sym__external_close_bracket] = ACTIONS(5425),
    [sym__external_open_bracket2] = ACTIONS(5605),
  },
  [688] = {
    [sym_call_arguments] = STATE(2401),
    [sym_subset_arguments] = STATE(2403),
    [sym_subset2_arguments] = STATE(2404),
    [sym__open_parenthesis] = STATE(1461),
    [sym__open_bracket] = STATE(1450),
    [sym__open_bracket2] = STATE(1447),
    [sym_identifier] = ACTIONS(5339),
    [anon_sym_BSLASH] = ACTIONS(5337),
    [anon_sym_function] = ACTIONS(5339),
    [anon_sym_EQ] = ACTIONS(5553),
    [anon_sym_if] = ACTIONS(5339),
    [anon_sym_for] = ACTIONS(5339),
    [anon_sym_while] = ACTIONS(5339),
    [anon_sym_repeat] = ACTIONS(5339),
    [anon_sym_QMARK] = ACTIONS(5337),
    [anon_sym_TILDE] = ACTIONS(5555),
    [anon_sym_BANG] = ACTIONS(5339),
    [anon_sym_PLUS] = ACTIONS(5529),
    [anon_sym_DASH] = ACTIONS(5531),
    [anon_sym_LT_DASH] = ACTIONS(5557),
    [anon_sym_LT_LT_DASH] = ACTIONS(5557),
    [anon_sym_COLON_EQ] = ACTIONS(5557),
    [anon_sym_DASH_GT] = ACTIONS(5559),
    [anon_sym_DASH_GT_GT] = ACTIONS(5561),
    [anon_sym_PIPE] = ACTIONS(5545),
    [anon_sym_AMP] = ACTIONS(5547),
    [anon_sym_PIPE_PIPE] = ACTIONS(5549),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_LT] = ACTIONS(5533),
    [anon_sym_LT_EQ] = ACTIONS(5535),
    [anon_sym_GT] = ACTIONS(5533),
    [anon_sym_GT_EQ] = ACTIONS(5535),
    [anon_sym_EQ_EQ] = ACTIONS(5535),
    [anon_sym_BANG_EQ] = ACTIONS(5535),
    [anon_sym_STAR] = ACTIONS(5537),
    [anon_sym_SLASH] = ACTIONS(5539),
    [anon_sym_STAR_STAR] = ACTIONS(5519),
    [anon_sym_CARET] = ACTIONS(5519),
    [aux_sym_binary_operator_token1] = ACTIONS(5541),
    [anon_sym_PIPE_GT] = ACTIONS(5541),
    [anon_sym_COLON] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5521),
    [anon_sym_AT] = ACTIONS(5521),
    [aux_sym__hex_literal_token1] = ACTIONS(5337),
    [sym__number_literal] = ACTIONS(5339),
    [anon_sym_SQUOTE] = ACTIONS(5337),
    [anon_sym_DQUOTE] = ACTIONS(5337),
    [sym_return] = ACTIONS(5339),
    [sym_next] = ACTIONS(5339),
    [sym_break] = ACTIONS(5339),
    [sym_true] = ACTIONS(5339),
    [sym_false] = ACTIONS(5339),
    [sym_null] = ACTIONS(5339),
    [sym_inf] = ACTIONS(5339),
    [sym_nan] = ACTIONS(5339),
    [anon_sym_NA] = ACTIONS(5339),
    [anon_sym_NA_integer_] = ACTIONS(5339),
    [anon_sym_NA_real_] = ACTIONS(5339),
    [anon_sym_NA_complex_] = ACTIONS(5339),
    [anon_sym_NA_character_] = ACTIONS(5339),
    [sym_dots] = ACTIONS(5339),
    [sym_dot_dot_i] = ACTIONS(5337),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5337),
    [sym__newline] = ACTIONS(5337),
    [sym__semicolon] = ACTIONS(5337),
    [sym__raw_string_literal] = ACTIONS(5337),
    [sym__external_open_parenthesis] = ACTIONS(5523),
    [sym__external_close_parenthesis] = ACTIONS(5337),
    [sym__external_open_brace] = ACTIONS(5337),
    [sym__external_close_brace] = ACTIONS(5337),
    [sym__external_open_bracket] = ACTIONS(5525),
    [sym__external_open_bracket2] = ACTIONS(5527),
    [sym__external_close_bracket2] = ACTIONS(5337),
  },
  [689] = {
    [sym_call_arguments] = STATE(2380),
    [sym_subset_arguments] = STATE(2385),
    [sym_subset2_arguments] = STATE(2388),
    [sym__open_parenthesis] = STATE(1496),
    [sym__open_bracket] = STATE(1494),
    [sym__open_bracket2] = STATE(1490),
    [sym_identifier] = ACTIONS(5423),
    [anon_sym_BSLASH] = ACTIONS(5421),
    [anon_sym_function] = ACTIONS(5423),
    [anon_sym_EQ] = ACTIONS(5563),
    [anon_sym_if] = ACTIONS(5423),
    [anon_sym_for] = ACTIONS(5423),
    [anon_sym_while] = ACTIONS(5423),
    [anon_sym_repeat] = ACTIONS(5423),
    [anon_sym_QMARK] = ACTIONS(5421),
    [anon_sym_TILDE] = ACTIONS(5565),
    [anon_sym_BANG] = ACTIONS(5423),
    [anon_sym_PLUS] = ACTIONS(5567),
    [anon_sym_DASH] = ACTIONS(5569),
    [anon_sym_LT_DASH] = ACTIONS(5571),
    [anon_sym_LT_LT_DASH] = ACTIONS(5571),
    [anon_sym_COLON_EQ] = ACTIONS(5571),
    [anon_sym_DASH_GT] = ACTIONS(5573),
    [anon_sym_DASH_GT_GT] = ACTIONS(5575),
    [anon_sym_PIPE] = ACTIONS(5577),
    [anon_sym_AMP] = ACTIONS(5579),
    [anon_sym_PIPE_PIPE] = ACTIONS(5581),
    [anon_sym_AMP_AMP] = ACTIONS(5583),
    [anon_sym_LT] = ACTIONS(5585),
    [anon_sym_LT_EQ] = ACTIONS(5587),
    [anon_sym_GT] = ACTIONS(5585),
    [anon_sym_GT_EQ] = ACTIONS(5587),
    [anon_sym_EQ_EQ] = ACTIONS(5587),
    [anon_sym_BANG_EQ] = ACTIONS(5587),
    [anon_sym_STAR] = ACTIONS(5589),
    [anon_sym_SLASH] = ACTIONS(5591),
    [anon_sym_STAR_STAR] = ACTIONS(5593),
    [anon_sym_CARET] = ACTIONS(5593),
    [aux_sym_binary_operator_token1] = ACTIONS(5595),
    [anon_sym_PIPE_GT] = ACTIONS(5595),
    [anon_sym_COLON] = ACTIONS(5597),
    [anon_sym_DOLLAR] = ACTIONS(5599),
    [anon_sym_AT] = ACTIONS(5599),
    [aux_sym__hex_literal_token1] = ACTIONS(5421),
    [sym__number_literal] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5421),
    [anon_sym_DQUOTE] = ACTIONS(5421),
    [sym_return] = ACTIONS(5423),
    [sym_next] = ACTIONS(5423),
    [sym_break] = ACTIONS(5423),
    [sym_true] = ACTIONS(5423),
    [sym_false] = ACTIONS(5423),
    [sym_null] = ACTIONS(5423),
    [sym_inf] = ACTIONS(5423),
    [sym_nan] = ACTIONS(5423),
    [anon_sym_NA] = ACTIONS(5423),
    [anon_sym_NA_integer_] = ACTIONS(5423),
    [anon_sym_NA_real_] = ACTIONS(5423),
    [anon_sym_NA_complex_] = ACTIONS(5423),
    [anon_sym_NA_character_] = ACTIONS(5423),
    [sym_dots] = ACTIONS(5423),
    [sym_dot_dot_i] = ACTIONS(5421),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5421),
    [sym__newline] = ACTIONS(5421),
    [sym__semicolon] = ACTIONS(5421),
    [sym__raw_string_literal] = ACTIONS(5421),
    [sym__external_open_parenthesis] = ACTIONS(5601),
    [sym__external_close_parenthesis] = ACTIONS(5421),
    [sym__external_open_brace] = ACTIONS(5421),
    [sym__external_close_brace] = ACTIONS(5421),
    [sym__external_open_bracket] = ACTIONS(5603),
    [sym__external_close_bracket] = ACTIONS(5421),
    [sym__external_open_bracket2] = ACTIONS(5605),
  },
  [690] = {
    [sym_call_arguments] = STATE(2380),
    [sym_subset_arguments] = STATE(2385),
    [sym_subset2_arguments] = STATE(2388),
    [sym__open_parenthesis] = STATE(1496),
    [sym__open_bracket] = STATE(1494),
    [sym__open_bracket2] = STATE(1490),
    [sym_identifier] = ACTIONS(5419),
    [anon_sym_BSLASH] = ACTIONS(5417),
    [anon_sym_function] = ACTIONS(5419),
    [anon_sym_EQ] = ACTIONS(5563),
    [anon_sym_if] = ACTIONS(5419),
    [anon_sym_for] = ACTIONS(5419),
    [anon_sym_while] = ACTIONS(5419),
    [anon_sym_repeat] = ACTIONS(5419),
    [anon_sym_QMARK] = ACTIONS(5417),
    [anon_sym_TILDE] = ACTIONS(5565),
    [anon_sym_BANG] = ACTIONS(5419),
    [anon_sym_PLUS] = ACTIONS(5567),
    [anon_sym_DASH] = ACTIONS(5569),
    [anon_sym_LT_DASH] = ACTIONS(5571),
    [anon_sym_LT_LT_DASH] = ACTIONS(5571),
    [anon_sym_COLON_EQ] = ACTIONS(5571),
    [anon_sym_DASH_GT] = ACTIONS(5573),
    [anon_sym_DASH_GT_GT] = ACTIONS(5575),
    [anon_sym_PIPE] = ACTIONS(5577),
    [anon_sym_AMP] = ACTIONS(5579),
    [anon_sym_PIPE_PIPE] = ACTIONS(5581),
    [anon_sym_AMP_AMP] = ACTIONS(5583),
    [anon_sym_LT] = ACTIONS(5585),
    [anon_sym_LT_EQ] = ACTIONS(5587),
    [anon_sym_GT] = ACTIONS(5585),
    [anon_sym_GT_EQ] = ACTIONS(5587),
    [anon_sym_EQ_EQ] = ACTIONS(5587),
    [anon_sym_BANG_EQ] = ACTIONS(5587),
    [anon_sym_STAR] = ACTIONS(5589),
    [anon_sym_SLASH] = ACTIONS(5591),
    [anon_sym_STAR_STAR] = ACTIONS(5593),
    [anon_sym_CARET] = ACTIONS(5593),
    [aux_sym_binary_operator_token1] = ACTIONS(5595),
    [anon_sym_PIPE_GT] = ACTIONS(5595),
    [anon_sym_COLON] = ACTIONS(5597),
    [anon_sym_DOLLAR] = ACTIONS(5599),
    [anon_sym_AT] = ACTIONS(5599),
    [aux_sym__hex_literal_token1] = ACTIONS(5417),
    [sym__number_literal] = ACTIONS(5419),
    [anon_sym_SQUOTE] = ACTIONS(5417),
    [anon_sym_DQUOTE] = ACTIONS(5417),
    [sym_return] = ACTIONS(5419),
    [sym_next] = ACTIONS(5419),
    [sym_break] = ACTIONS(5419),
    [sym_true] = ACTIONS(5419),
    [sym_false] = ACTIONS(5419),
    [sym_null] = ACTIONS(5419),
    [sym_inf] = ACTIONS(5419),
    [sym_nan] = ACTIONS(5419),
    [anon_sym_NA] = ACTIONS(5419),
    [anon_sym_NA_integer_] = ACTIONS(5419),
    [anon_sym_NA_real_] = ACTIONS(5419),
    [anon_sym_NA_complex_] = ACTIONS(5419),
    [anon_sym_NA_character_] = ACTIONS(5419),
    [sym_dots] = ACTIONS(5419),
    [sym_dot_dot_i] = ACTIONS(5417),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5417),
    [sym__newline] = ACTIONS(5417),
    [sym__semicolon] = ACTIONS(5417),
    [sym__raw_string_literal] = ACTIONS(5417),
    [sym__external_open_parenthesis] = ACTIONS(5601),
    [sym__external_close_parenthesis] = ACTIONS(5417),
    [sym__external_open_brace] = ACTIONS(5417),
    [sym__external_close_brace] = ACTIONS(5417),
    [sym__external_open_bracket] = ACTIONS(5603),
    [sym__external_close_bracket] = ACTIONS(5417),
    [sym__external_open_bracket2] = ACTIONS(5605),
  },
  [691] = {
    [sym_call_arguments] = STATE(2401),
    [sym_subset_arguments] = STATE(2403),
    [sym_subset2_arguments] = STATE(2404),
    [sym__open_parenthesis] = STATE(1461),
    [sym__open_bracket] = STATE(1450),
    [sym__open_bracket2] = STATE(1447),
    [sym_identifier] = ACTIONS(5343),
    [anon_sym_BSLASH] = ACTIONS(5341),
    [anon_sym_function] = ACTIONS(5343),
    [anon_sym_EQ] = ACTIONS(5553),
    [anon_sym_if] = ACTIONS(5343),
    [anon_sym_for] = ACTIONS(5343),
    [anon_sym_while] = ACTIONS(5343),
    [anon_sym_repeat] = ACTIONS(5343),
    [anon_sym_QMARK] = ACTIONS(5341),
    [anon_sym_TILDE] = ACTIONS(5555),
    [anon_sym_BANG] = ACTIONS(5343),
    [anon_sym_PLUS] = ACTIONS(5529),
    [anon_sym_DASH] = ACTIONS(5531),
    [anon_sym_LT_DASH] = ACTIONS(5557),
    [anon_sym_LT_LT_DASH] = ACTIONS(5557),
    [anon_sym_COLON_EQ] = ACTIONS(5557),
    [anon_sym_DASH_GT] = ACTIONS(5559),
    [anon_sym_DASH_GT_GT] = ACTIONS(5561),
    [anon_sym_PIPE] = ACTIONS(5545),
    [anon_sym_AMP] = ACTIONS(5547),
    [anon_sym_PIPE_PIPE] = ACTIONS(5549),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_LT] = ACTIONS(5533),
    [anon_sym_LT_EQ] = ACTIONS(5535),
    [anon_sym_GT] = ACTIONS(5533),
    [anon_sym_GT_EQ] = ACTIONS(5535),
    [anon_sym_EQ_EQ] = ACTIONS(5535),
    [anon_sym_BANG_EQ] = ACTIONS(5535),
    [anon_sym_STAR] = ACTIONS(5537),
    [anon_sym_SLASH] = ACTIONS(5539),
    [anon_sym_STAR_STAR] = ACTIONS(5519),
    [anon_sym_CARET] = ACTIONS(5519),
    [aux_sym_binary_operator_token1] = ACTIONS(5541),
    [anon_sym_PIPE_GT] = ACTIONS(5541),
    [anon_sym_COLON] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5521),
    [anon_sym_AT] = ACTIONS(5521),
    [aux_sym__hex_literal_token1] = ACTIONS(5341),
    [sym__number_literal] = ACTIONS(5343),
    [anon_sym_SQUOTE] = ACTIONS(5341),
    [anon_sym_DQUOTE] = ACTIONS(5341),
    [sym_return] = ACTIONS(5343),
    [sym_next] = ACTIONS(5343),
    [sym_break] = ACTIONS(5343),
    [sym_true] = ACTIONS(5343),
    [sym_false] = ACTIONS(5343),
    [sym_null] = ACTIONS(5343),
    [sym_inf] = ACTIONS(5343),
    [sym_nan] = ACTIONS(5343),
    [anon_sym_NA] = ACTIONS(5343),
    [anon_sym_NA_integer_] = ACTIONS(5343),
    [anon_sym_NA_real_] = ACTIONS(5343),
    [anon_sym_NA_complex_] = ACTIONS(5343),
    [anon_sym_NA_character_] = ACTIONS(5343),
    [sym_dots] = ACTIONS(5343),
    [sym_dot_dot_i] = ACTIONS(5341),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5341),
    [sym__newline] = ACTIONS(5341),
    [sym__semicolon] = ACTIONS(5341),
    [sym__raw_string_literal] = ACTIONS(5341),
    [sym__external_open_parenthesis] = ACTIONS(5523),
    [sym__external_close_parenthesis] = ACTIONS(5341),
    [sym__external_open_brace] = ACTIONS(5341),
    [sym__external_close_brace] = ACTIONS(5341),
    [sym__external_open_bracket] = ACTIONS(5525),
    [sym__external_open_bracket2] = ACTIONS(5527),
    [sym__external_close_bracket2] = ACTIONS(5341),
  },
  [692] = {
    [sym_call_arguments] = STATE(2401),
    [sym_subset_arguments] = STATE(2403),
    [sym_subset2_arguments] = STATE(2404),
    [sym__open_parenthesis] = STATE(1461),
    [sym__open_bracket] = STATE(1450),
    [sym__open_bracket2] = STATE(1447),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5553),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5555),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5529),
    [anon_sym_DASH] = ACTIONS(5531),
    [anon_sym_LT_DASH] = ACTIONS(5557),
    [anon_sym_LT_LT_DASH] = ACTIONS(5557),
    [anon_sym_COLON_EQ] = ACTIONS(5557),
    [anon_sym_DASH_GT] = ACTIONS(5559),
    [anon_sym_DASH_GT_GT] = ACTIONS(5561),
    [anon_sym_PIPE] = ACTIONS(5545),
    [anon_sym_AMP] = ACTIONS(5547),
    [anon_sym_PIPE_PIPE] = ACTIONS(5549),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_LT] = ACTIONS(5533),
    [anon_sym_LT_EQ] = ACTIONS(5535),
    [anon_sym_GT] = ACTIONS(5533),
    [anon_sym_GT_EQ] = ACTIONS(5535),
    [anon_sym_EQ_EQ] = ACTIONS(5535),
    [anon_sym_BANG_EQ] = ACTIONS(5535),
    [anon_sym_STAR] = ACTIONS(5537),
    [anon_sym_SLASH] = ACTIONS(5539),
    [anon_sym_STAR_STAR] = ACTIONS(5519),
    [anon_sym_CARET] = ACTIONS(5519),
    [aux_sym_binary_operator_token1] = ACTIONS(5541),
    [anon_sym_PIPE_GT] = ACTIONS(5541),
    [anon_sym_COLON] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5521),
    [anon_sym_AT] = ACTIONS(5521),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__semicolon] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(5523),
    [sym__external_close_parenthesis] = ACTIONS(5345),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_close_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(5525),
    [sym__external_open_bracket2] = ACTIONS(5527),
    [sym__external_close_bracket2] = ACTIONS(5345),
  },
  [693] = {
    [sym_call_arguments] = STATE(2401),
    [sym_subset_arguments] = STATE(2403),
    [sym_subset2_arguments] = STATE(2404),
    [sym__open_parenthesis] = STATE(1461),
    [sym__open_bracket] = STATE(1450),
    [sym__open_bracket2] = STATE(1447),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5529),
    [anon_sym_DASH] = ACTIONS(5531),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5545),
    [anon_sym_AMP] = ACTIONS(5547),
    [anon_sym_PIPE_PIPE] = ACTIONS(5549),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_LT] = ACTIONS(5533),
    [anon_sym_LT_EQ] = ACTIONS(5535),
    [anon_sym_GT] = ACTIONS(5533),
    [anon_sym_GT_EQ] = ACTIONS(5535),
    [anon_sym_EQ_EQ] = ACTIONS(5535),
    [anon_sym_BANG_EQ] = ACTIONS(5535),
    [anon_sym_STAR] = ACTIONS(5537),
    [anon_sym_SLASH] = ACTIONS(5539),
    [anon_sym_STAR_STAR] = ACTIONS(5519),
    [anon_sym_CARET] = ACTIONS(5519),
    [aux_sym_binary_operator_token1] = ACTIONS(5541),
    [anon_sym_PIPE_GT] = ACTIONS(5541),
    [anon_sym_COLON] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5521),
    [anon_sym_AT] = ACTIONS(5521),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__semicolon] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(5523),
    [sym__external_close_parenthesis] = ACTIONS(5345),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_close_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(5525),
    [sym__external_open_bracket2] = ACTIONS(5527),
    [sym__external_close_bracket2] = ACTIONS(5345),
  },
  [694] = {
    [sym_call_arguments] = STATE(2401),
    [sym_subset_arguments] = STATE(2403),
    [sym_subset2_arguments] = STATE(2404),
    [sym__open_parenthesis] = STATE(1461),
    [sym__open_bracket] = STATE(1450),
    [sym__open_bracket2] = STATE(1447),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5529),
    [anon_sym_DASH] = ACTIONS(5531),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5347),
    [anon_sym_AMP] = ACTIONS(5347),
    [anon_sym_PIPE_PIPE] = ACTIONS(5345),
    [anon_sym_AMP_AMP] = ACTIONS(5345),
    [anon_sym_LT] = ACTIONS(5533),
    [anon_sym_LT_EQ] = ACTIONS(5535),
    [anon_sym_GT] = ACTIONS(5533),
    [anon_sym_GT_EQ] = ACTIONS(5535),
    [anon_sym_EQ_EQ] = ACTIONS(5535),
    [anon_sym_BANG_EQ] = ACTIONS(5535),
    [anon_sym_STAR] = ACTIONS(5537),
    [anon_sym_SLASH] = ACTIONS(5539),
    [anon_sym_STAR_STAR] = ACTIONS(5519),
    [anon_sym_CARET] = ACTIONS(5519),
    [aux_sym_binary_operator_token1] = ACTIONS(5541),
    [anon_sym_PIPE_GT] = ACTIONS(5541),
    [anon_sym_COLON] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5521),
    [anon_sym_AT] = ACTIONS(5521),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__semicolon] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(5523),
    [sym__external_close_parenthesis] = ACTIONS(5345),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_close_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(5525),
    [sym__external_open_bracket2] = ACTIONS(5527),
    [sym__external_close_bracket2] = ACTIONS(5345),
  },
  [695] = {
    [sym_call_arguments] = STATE(2380),
    [sym_subset_arguments] = STATE(2385),
    [sym_subset2_arguments] = STATE(2388),
    [sym__open_parenthesis] = STATE(1496),
    [sym__open_bracket] = STATE(1494),
    [sym__open_bracket2] = STATE(1490),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_BSLASH] = ACTIONS(5413),
    [anon_sym_function] = ACTIONS(5415),
    [anon_sym_EQ] = ACTIONS(5563),
    [anon_sym_if] = ACTIONS(5415),
    [anon_sym_for] = ACTIONS(5415),
    [anon_sym_while] = ACTIONS(5415),
    [anon_sym_repeat] = ACTIONS(5415),
    [anon_sym_QMARK] = ACTIONS(5413),
    [anon_sym_TILDE] = ACTIONS(5565),
    [anon_sym_BANG] = ACTIONS(5415),
    [anon_sym_PLUS] = ACTIONS(5567),
    [anon_sym_DASH] = ACTIONS(5569),
    [anon_sym_LT_DASH] = ACTIONS(5571),
    [anon_sym_LT_LT_DASH] = ACTIONS(5571),
    [anon_sym_COLON_EQ] = ACTIONS(5571),
    [anon_sym_DASH_GT] = ACTIONS(5573),
    [anon_sym_DASH_GT_GT] = ACTIONS(5575),
    [anon_sym_PIPE] = ACTIONS(5577),
    [anon_sym_AMP] = ACTIONS(5579),
    [anon_sym_PIPE_PIPE] = ACTIONS(5581),
    [anon_sym_AMP_AMP] = ACTIONS(5583),
    [anon_sym_LT] = ACTIONS(5585),
    [anon_sym_LT_EQ] = ACTIONS(5587),
    [anon_sym_GT] = ACTIONS(5585),
    [anon_sym_GT_EQ] = ACTIONS(5587),
    [anon_sym_EQ_EQ] = ACTIONS(5587),
    [anon_sym_BANG_EQ] = ACTIONS(5587),
    [anon_sym_STAR] = ACTIONS(5589),
    [anon_sym_SLASH] = ACTIONS(5591),
    [anon_sym_STAR_STAR] = ACTIONS(5593),
    [anon_sym_CARET] = ACTIONS(5593),
    [aux_sym_binary_operator_token1] = ACTIONS(5595),
    [anon_sym_PIPE_GT] = ACTIONS(5595),
    [anon_sym_COLON] = ACTIONS(5597),
    [anon_sym_DOLLAR] = ACTIONS(5599),
    [anon_sym_AT] = ACTIONS(5599),
    [aux_sym__hex_literal_token1] = ACTIONS(5413),
    [sym__number_literal] = ACTIONS(5415),
    [anon_sym_SQUOTE] = ACTIONS(5413),
    [anon_sym_DQUOTE] = ACTIONS(5413),
    [sym_return] = ACTIONS(5415),
    [sym_next] = ACTIONS(5415),
    [sym_break] = ACTIONS(5415),
    [sym_true] = ACTIONS(5415),
    [sym_false] = ACTIONS(5415),
    [sym_null] = ACTIONS(5415),
    [sym_inf] = ACTIONS(5415),
    [sym_nan] = ACTIONS(5415),
    [anon_sym_NA] = ACTIONS(5415),
    [anon_sym_NA_integer_] = ACTIONS(5415),
    [anon_sym_NA_real_] = ACTIONS(5415),
    [anon_sym_NA_complex_] = ACTIONS(5415),
    [anon_sym_NA_character_] = ACTIONS(5415),
    [sym_dots] = ACTIONS(5415),
    [sym_dot_dot_i] = ACTIONS(5413),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5413),
    [sym__newline] = ACTIONS(5413),
    [sym__semicolon] = ACTIONS(5413),
    [sym__raw_string_literal] = ACTIONS(5413),
    [sym__external_open_parenthesis] = ACTIONS(5601),
    [sym__external_close_parenthesis] = ACTIONS(5413),
    [sym__external_open_brace] = ACTIONS(5413),
    [sym__external_close_brace] = ACTIONS(5413),
    [sym__external_open_bracket] = ACTIONS(5603),
    [sym__external_close_bracket] = ACTIONS(5413),
    [sym__external_open_bracket2] = ACTIONS(5605),
  },
  [696] = {
    [sym_call_arguments] = STATE(2401),
    [sym_subset_arguments] = STATE(2403),
    [sym_subset2_arguments] = STATE(2404),
    [sym__open_parenthesis] = STATE(1461),
    [sym__open_bracket] = STATE(1450),
    [sym__open_bracket2] = STATE(1447),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5345),
    [anon_sym_DASH] = ACTIONS(5347),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5347),
    [anon_sym_AMP] = ACTIONS(5347),
    [anon_sym_PIPE_PIPE] = ACTIONS(5345),
    [anon_sym_AMP_AMP] = ACTIONS(5345),
    [anon_sym_LT] = ACTIONS(5347),
    [anon_sym_LT_EQ] = ACTIONS(5345),
    [anon_sym_GT] = ACTIONS(5347),
    [anon_sym_GT_EQ] = ACTIONS(5345),
    [anon_sym_EQ_EQ] = ACTIONS(5345),
    [anon_sym_BANG_EQ] = ACTIONS(5345),
    [anon_sym_STAR] = ACTIONS(5347),
    [anon_sym_SLASH] = ACTIONS(5345),
    [anon_sym_STAR_STAR] = ACTIONS(5519),
    [anon_sym_CARET] = ACTIONS(5519),
    [aux_sym_binary_operator_token1] = ACTIONS(5345),
    [anon_sym_PIPE_GT] = ACTIONS(5345),
    [anon_sym_COLON] = ACTIONS(5347),
    [anon_sym_DOLLAR] = ACTIONS(5521),
    [anon_sym_AT] = ACTIONS(5521),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__semicolon] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(5523),
    [sym__external_close_parenthesis] = ACTIONS(5345),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_close_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(5525),
    [sym__external_open_bracket2] = ACTIONS(5527),
    [sym__external_close_bracket2] = ACTIONS(5345),
  },
  [697] = {
    [sym_call_arguments] = STATE(2401),
    [sym_subset_arguments] = STATE(2403),
    [sym_subset2_arguments] = STATE(2404),
    [sym__open_parenthesis] = STATE(1461),
    [sym__open_bracket] = STATE(1450),
    [sym__open_bracket2] = STATE(1447),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5553),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5555),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5529),
    [anon_sym_DASH] = ACTIONS(5531),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5559),
    [anon_sym_DASH_GT_GT] = ACTIONS(5561),
    [anon_sym_PIPE] = ACTIONS(5545),
    [anon_sym_AMP] = ACTIONS(5547),
    [anon_sym_PIPE_PIPE] = ACTIONS(5549),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_LT] = ACTIONS(5533),
    [anon_sym_LT_EQ] = ACTIONS(5535),
    [anon_sym_GT] = ACTIONS(5533),
    [anon_sym_GT_EQ] = ACTIONS(5535),
    [anon_sym_EQ_EQ] = ACTIONS(5535),
    [anon_sym_BANG_EQ] = ACTIONS(5535),
    [anon_sym_STAR] = ACTIONS(5537),
    [anon_sym_SLASH] = ACTIONS(5539),
    [anon_sym_STAR_STAR] = ACTIONS(5519),
    [anon_sym_CARET] = ACTIONS(5519),
    [aux_sym_binary_operator_token1] = ACTIONS(5541),
    [anon_sym_PIPE_GT] = ACTIONS(5541),
    [anon_sym_COLON] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5521),
    [anon_sym_AT] = ACTIONS(5521),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5523),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5525),
    [sym__external_open_bracket2] = ACTIONS(5527),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [698] = {
    [sym_call_arguments] = STATE(2401),
    [sym_subset_arguments] = STATE(2403),
    [sym_subset2_arguments] = STATE(2404),
    [sym__open_parenthesis] = STATE(1461),
    [sym__open_bracket] = STATE(1450),
    [sym__open_bracket2] = STATE(1447),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5553),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5555),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5529),
    [anon_sym_DASH] = ACTIONS(5531),
    [anon_sym_LT_DASH] = ACTIONS(5557),
    [anon_sym_LT_LT_DASH] = ACTIONS(5557),
    [anon_sym_COLON_EQ] = ACTIONS(5557),
    [anon_sym_DASH_GT] = ACTIONS(5559),
    [anon_sym_DASH_GT_GT] = ACTIONS(5561),
    [anon_sym_PIPE] = ACTIONS(5545),
    [anon_sym_AMP] = ACTIONS(5547),
    [anon_sym_PIPE_PIPE] = ACTIONS(5549),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_LT] = ACTIONS(5533),
    [anon_sym_LT_EQ] = ACTIONS(5535),
    [anon_sym_GT] = ACTIONS(5533),
    [anon_sym_GT_EQ] = ACTIONS(5535),
    [anon_sym_EQ_EQ] = ACTIONS(5535),
    [anon_sym_BANG_EQ] = ACTIONS(5535),
    [anon_sym_STAR] = ACTIONS(5537),
    [anon_sym_SLASH] = ACTIONS(5539),
    [anon_sym_STAR_STAR] = ACTIONS(5519),
    [anon_sym_CARET] = ACTIONS(5519),
    [aux_sym_binary_operator_token1] = ACTIONS(5541),
    [anon_sym_PIPE_GT] = ACTIONS(5541),
    [anon_sym_COLON] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5521),
    [anon_sym_AT] = ACTIONS(5521),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5523),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5525),
    [sym__external_open_bracket2] = ACTIONS(5527),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [699] = {
    [sym_call_arguments] = STATE(2380),
    [sym_subset_arguments] = STATE(2385),
    [sym_subset2_arguments] = STATE(2388),
    [sym__open_parenthesis] = STATE(1496),
    [sym__open_bracket] = STATE(1494),
    [sym__open_bracket2] = STATE(1490),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(5593),
    [anon_sym_CARET] = ACTIONS(5593),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(5261),
    [anon_sym_DOLLAR] = ACTIONS(5599),
    [anon_sym_AT] = ACTIONS(5599),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5601),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5603),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(5605),
  },
  [700] = {
    [sym_call_arguments] = STATE(2380),
    [sym_subset_arguments] = STATE(2385),
    [sym_subset2_arguments] = STATE(2388),
    [sym__open_parenthesis] = STATE(1496),
    [sym__open_bracket] = STATE(1494),
    [sym__open_bracket2] = STATE(1490),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(5593),
    [anon_sym_CARET] = ACTIONS(5593),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(5597),
    [anon_sym_DOLLAR] = ACTIONS(5599),
    [anon_sym_AT] = ACTIONS(5599),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5601),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5603),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(5605),
  },
  [701] = {
    [sym_call_arguments] = STATE(2380),
    [sym_subset_arguments] = STATE(2385),
    [sym_subset2_arguments] = STATE(2388),
    [sym__open_parenthesis] = STATE(1496),
    [sym__open_bracket] = STATE(1494),
    [sym__open_bracket2] = STATE(1490),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(5593),
    [anon_sym_CARET] = ACTIONS(5593),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(5261),
    [anon_sym_DOLLAR] = ACTIONS(5599),
    [anon_sym_AT] = ACTIONS(5599),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5601),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5603),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(5605),
  },
  [702] = {
    [sym_call_arguments] = STATE(2380),
    [sym_subset_arguments] = STATE(2385),
    [sym_subset2_arguments] = STATE(2388),
    [sym__open_parenthesis] = STATE(1496),
    [sym__open_bracket] = STATE(1494),
    [sym__open_bracket2] = STATE(1490),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(5593),
    [anon_sym_CARET] = ACTIONS(5593),
    [aux_sym_binary_operator_token1] = ACTIONS(5595),
    [anon_sym_PIPE_GT] = ACTIONS(5595),
    [anon_sym_COLON] = ACTIONS(5597),
    [anon_sym_DOLLAR] = ACTIONS(5599),
    [anon_sym_AT] = ACTIONS(5599),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5601),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5603),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(5605),
  },
  [703] = {
    [sym_call_arguments] = STATE(2380),
    [sym_subset_arguments] = STATE(2385),
    [sym_subset2_arguments] = STATE(2388),
    [sym__open_parenthesis] = STATE(1496),
    [sym__open_bracket] = STATE(1494),
    [sym__open_bracket2] = STATE(1490),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5567),
    [anon_sym_DASH] = ACTIONS(5569),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5589),
    [anon_sym_SLASH] = ACTIONS(5591),
    [anon_sym_STAR_STAR] = ACTIONS(5593),
    [anon_sym_CARET] = ACTIONS(5593),
    [aux_sym_binary_operator_token1] = ACTIONS(5595),
    [anon_sym_PIPE_GT] = ACTIONS(5595),
    [anon_sym_COLON] = ACTIONS(5597),
    [anon_sym_DOLLAR] = ACTIONS(5599),
    [anon_sym_AT] = ACTIONS(5599),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5601),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5603),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(5605),
  },
  [704] = {
    [sym_call_arguments] = STATE(2380),
    [sym_subset_arguments] = STATE(2385),
    [sym_subset2_arguments] = STATE(2388),
    [sym__open_parenthesis] = STATE(1496),
    [sym__open_bracket] = STATE(1494),
    [sym__open_bracket2] = STATE(1490),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5567),
    [anon_sym_DASH] = ACTIONS(5569),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5585),
    [anon_sym_LT_EQ] = ACTIONS(5587),
    [anon_sym_GT] = ACTIONS(5585),
    [anon_sym_GT_EQ] = ACTIONS(5587),
    [anon_sym_EQ_EQ] = ACTIONS(5587),
    [anon_sym_BANG_EQ] = ACTIONS(5587),
    [anon_sym_STAR] = ACTIONS(5589),
    [anon_sym_SLASH] = ACTIONS(5591),
    [anon_sym_STAR_STAR] = ACTIONS(5593),
    [anon_sym_CARET] = ACTIONS(5593),
    [aux_sym_binary_operator_token1] = ACTIONS(5595),
    [anon_sym_PIPE_GT] = ACTIONS(5595),
    [anon_sym_COLON] = ACTIONS(5597),
    [anon_sym_DOLLAR] = ACTIONS(5599),
    [anon_sym_AT] = ACTIONS(5599),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5601),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5603),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(5605),
  },
  [705] = {
    [sym_call_arguments] = STATE(2380),
    [sym_subset_arguments] = STATE(2385),
    [sym_subset2_arguments] = STATE(2388),
    [sym__open_parenthesis] = STATE(1496),
    [sym__open_bracket] = STATE(1494),
    [sym__open_bracket2] = STATE(1490),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5567),
    [anon_sym_DASH] = ACTIONS(5569),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5579),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5583),
    [anon_sym_LT] = ACTIONS(5585),
    [anon_sym_LT_EQ] = ACTIONS(5587),
    [anon_sym_GT] = ACTIONS(5585),
    [anon_sym_GT_EQ] = ACTIONS(5587),
    [anon_sym_EQ_EQ] = ACTIONS(5587),
    [anon_sym_BANG_EQ] = ACTIONS(5587),
    [anon_sym_STAR] = ACTIONS(5589),
    [anon_sym_SLASH] = ACTIONS(5591),
    [anon_sym_STAR_STAR] = ACTIONS(5593),
    [anon_sym_CARET] = ACTIONS(5593),
    [aux_sym_binary_operator_token1] = ACTIONS(5595),
    [anon_sym_PIPE_GT] = ACTIONS(5595),
    [anon_sym_COLON] = ACTIONS(5597),
    [anon_sym_DOLLAR] = ACTIONS(5599),
    [anon_sym_AT] = ACTIONS(5599),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5601),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5603),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(5605),
  },
  [706] = {
    [sym_call_arguments] = STATE(2380),
    [sym_subset_arguments] = STATE(2385),
    [sym_subset2_arguments] = STATE(2388),
    [sym__open_parenthesis] = STATE(1496),
    [sym__open_bracket] = STATE(1494),
    [sym__open_bracket2] = STATE(1490),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5565),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5567),
    [anon_sym_DASH] = ACTIONS(5569),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5577),
    [anon_sym_AMP] = ACTIONS(5579),
    [anon_sym_PIPE_PIPE] = ACTIONS(5581),
    [anon_sym_AMP_AMP] = ACTIONS(5583),
    [anon_sym_LT] = ACTIONS(5585),
    [anon_sym_LT_EQ] = ACTIONS(5587),
    [anon_sym_GT] = ACTIONS(5585),
    [anon_sym_GT_EQ] = ACTIONS(5587),
    [anon_sym_EQ_EQ] = ACTIONS(5587),
    [anon_sym_BANG_EQ] = ACTIONS(5587),
    [anon_sym_STAR] = ACTIONS(5589),
    [anon_sym_SLASH] = ACTIONS(5591),
    [anon_sym_STAR_STAR] = ACTIONS(5593),
    [anon_sym_CARET] = ACTIONS(5593),
    [aux_sym_binary_operator_token1] = ACTIONS(5595),
    [anon_sym_PIPE_GT] = ACTIONS(5595),
    [anon_sym_COLON] = ACTIONS(5597),
    [anon_sym_DOLLAR] = ACTIONS(5599),
    [anon_sym_AT] = ACTIONS(5599),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5601),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5603),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(5605),
  },
  [707] = {
    [sym_call_arguments] = STATE(2380),
    [sym_subset_arguments] = STATE(2385),
    [sym_subset2_arguments] = STATE(2388),
    [sym__open_parenthesis] = STATE(1496),
    [sym__open_bracket] = STATE(1494),
    [sym__open_bracket2] = STATE(1490),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5563),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5565),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5567),
    [anon_sym_DASH] = ACTIONS(5569),
    [anon_sym_LT_DASH] = ACTIONS(5571),
    [anon_sym_LT_LT_DASH] = ACTIONS(5571),
    [anon_sym_COLON_EQ] = ACTIONS(5571),
    [anon_sym_DASH_GT] = ACTIONS(5573),
    [anon_sym_DASH_GT_GT] = ACTIONS(5575),
    [anon_sym_PIPE] = ACTIONS(5577),
    [anon_sym_AMP] = ACTIONS(5579),
    [anon_sym_PIPE_PIPE] = ACTIONS(5581),
    [anon_sym_AMP_AMP] = ACTIONS(5583),
    [anon_sym_LT] = ACTIONS(5585),
    [anon_sym_LT_EQ] = ACTIONS(5587),
    [anon_sym_GT] = ACTIONS(5585),
    [anon_sym_GT_EQ] = ACTIONS(5587),
    [anon_sym_EQ_EQ] = ACTIONS(5587),
    [anon_sym_BANG_EQ] = ACTIONS(5587),
    [anon_sym_STAR] = ACTIONS(5589),
    [anon_sym_SLASH] = ACTIONS(5591),
    [anon_sym_STAR_STAR] = ACTIONS(5593),
    [anon_sym_CARET] = ACTIONS(5593),
    [aux_sym_binary_operator_token1] = ACTIONS(5595),
    [anon_sym_PIPE_GT] = ACTIONS(5595),
    [anon_sym_COLON] = ACTIONS(5597),
    [anon_sym_DOLLAR] = ACTIONS(5599),
    [anon_sym_AT] = ACTIONS(5599),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5601),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5603),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(5605),
  },
  [708] = {
    [sym_call_arguments] = STATE(2380),
    [sym_subset_arguments] = STATE(2385),
    [sym_subset2_arguments] = STATE(2388),
    [sym__open_parenthesis] = STATE(1496),
    [sym__open_bracket] = STATE(1494),
    [sym__open_bracket2] = STATE(1490),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5589),
    [anon_sym_SLASH] = ACTIONS(5591),
    [anon_sym_STAR_STAR] = ACTIONS(5593),
    [anon_sym_CARET] = ACTIONS(5593),
    [aux_sym_binary_operator_token1] = ACTIONS(5595),
    [anon_sym_PIPE_GT] = ACTIONS(5595),
    [anon_sym_COLON] = ACTIONS(5597),
    [anon_sym_DOLLAR] = ACTIONS(5599),
    [anon_sym_AT] = ACTIONS(5599),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5601),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5603),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(5605),
  },
  [709] = {
    [sym_call_arguments] = STATE(2380),
    [sym_subset_arguments] = STATE(2385),
    [sym_subset2_arguments] = STATE(2388),
    [sym__open_parenthesis] = STATE(1496),
    [sym__open_bracket] = STATE(1494),
    [sym__open_bracket2] = STATE(1490),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5567),
    [anon_sym_DASH] = ACTIONS(5569),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5577),
    [anon_sym_AMP] = ACTIONS(5579),
    [anon_sym_PIPE_PIPE] = ACTIONS(5581),
    [anon_sym_AMP_AMP] = ACTIONS(5583),
    [anon_sym_LT] = ACTIONS(5585),
    [anon_sym_LT_EQ] = ACTIONS(5587),
    [anon_sym_GT] = ACTIONS(5585),
    [anon_sym_GT_EQ] = ACTIONS(5587),
    [anon_sym_EQ_EQ] = ACTIONS(5587),
    [anon_sym_BANG_EQ] = ACTIONS(5587),
    [anon_sym_STAR] = ACTIONS(5589),
    [anon_sym_SLASH] = ACTIONS(5591),
    [anon_sym_STAR_STAR] = ACTIONS(5593),
    [anon_sym_CARET] = ACTIONS(5593),
    [aux_sym_binary_operator_token1] = ACTIONS(5595),
    [anon_sym_PIPE_GT] = ACTIONS(5595),
    [anon_sym_COLON] = ACTIONS(5597),
    [anon_sym_DOLLAR] = ACTIONS(5599),
    [anon_sym_AT] = ACTIONS(5599),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5601),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5603),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(5605),
  },
  [710] = {
    [sym_call_arguments] = STATE(2380),
    [sym_subset_arguments] = STATE(2385),
    [sym_subset2_arguments] = STATE(2388),
    [sym__open_parenthesis] = STATE(1496),
    [sym__open_bracket] = STATE(1494),
    [sym__open_bracket2] = STATE(1490),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5563),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5565),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5567),
    [anon_sym_DASH] = ACTIONS(5569),
    [anon_sym_LT_DASH] = ACTIONS(5571),
    [anon_sym_LT_LT_DASH] = ACTIONS(5571),
    [anon_sym_COLON_EQ] = ACTIONS(5571),
    [anon_sym_DASH_GT] = ACTIONS(5573),
    [anon_sym_DASH_GT_GT] = ACTIONS(5575),
    [anon_sym_PIPE] = ACTIONS(5577),
    [anon_sym_AMP] = ACTIONS(5579),
    [anon_sym_PIPE_PIPE] = ACTIONS(5581),
    [anon_sym_AMP_AMP] = ACTIONS(5583),
    [anon_sym_LT] = ACTIONS(5585),
    [anon_sym_LT_EQ] = ACTIONS(5587),
    [anon_sym_GT] = ACTIONS(5585),
    [anon_sym_GT_EQ] = ACTIONS(5587),
    [anon_sym_EQ_EQ] = ACTIONS(5587),
    [anon_sym_BANG_EQ] = ACTIONS(5587),
    [anon_sym_STAR] = ACTIONS(5589),
    [anon_sym_SLASH] = ACTIONS(5591),
    [anon_sym_STAR_STAR] = ACTIONS(5593),
    [anon_sym_CARET] = ACTIONS(5593),
    [aux_sym_binary_operator_token1] = ACTIONS(5595),
    [anon_sym_PIPE_GT] = ACTIONS(5595),
    [anon_sym_COLON] = ACTIONS(5597),
    [anon_sym_DOLLAR] = ACTIONS(5599),
    [anon_sym_AT] = ACTIONS(5599),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5601),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5603),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(5605),
  },
  [711] = {
    [sym_call_arguments] = STATE(2380),
    [sym_subset_arguments] = STATE(2385),
    [sym_subset2_arguments] = STATE(2388),
    [sym__open_parenthesis] = STATE(1496),
    [sym__open_bracket] = STATE(1494),
    [sym__open_bracket2] = STATE(1490),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5563),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5565),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5567),
    [anon_sym_DASH] = ACTIONS(5569),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5573),
    [anon_sym_DASH_GT_GT] = ACTIONS(5575),
    [anon_sym_PIPE] = ACTIONS(5577),
    [anon_sym_AMP] = ACTIONS(5579),
    [anon_sym_PIPE_PIPE] = ACTIONS(5581),
    [anon_sym_AMP_AMP] = ACTIONS(5583),
    [anon_sym_LT] = ACTIONS(5585),
    [anon_sym_LT_EQ] = ACTIONS(5587),
    [anon_sym_GT] = ACTIONS(5585),
    [anon_sym_GT_EQ] = ACTIONS(5587),
    [anon_sym_EQ_EQ] = ACTIONS(5587),
    [anon_sym_BANG_EQ] = ACTIONS(5587),
    [anon_sym_STAR] = ACTIONS(5589),
    [anon_sym_SLASH] = ACTIONS(5591),
    [anon_sym_STAR_STAR] = ACTIONS(5593),
    [anon_sym_CARET] = ACTIONS(5593),
    [aux_sym_binary_operator_token1] = ACTIONS(5595),
    [anon_sym_PIPE_GT] = ACTIONS(5595),
    [anon_sym_COLON] = ACTIONS(5597),
    [anon_sym_DOLLAR] = ACTIONS(5599),
    [anon_sym_AT] = ACTIONS(5599),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5601),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5603),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(5605),
  },
  [712] = {
    [sym_call_arguments] = STATE(2401),
    [sym_subset_arguments] = STATE(2403),
    [sym_subset2_arguments] = STATE(2404),
    [sym__open_parenthesis] = STATE(1461),
    [sym__open_bracket] = STATE(1450),
    [sym__open_bracket2] = STATE(1447),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5529),
    [anon_sym_DASH] = ACTIONS(5531),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5545),
    [anon_sym_AMP] = ACTIONS(5547),
    [anon_sym_PIPE_PIPE] = ACTIONS(5549),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_LT] = ACTIONS(5533),
    [anon_sym_LT_EQ] = ACTIONS(5535),
    [anon_sym_GT] = ACTIONS(5533),
    [anon_sym_GT_EQ] = ACTIONS(5535),
    [anon_sym_EQ_EQ] = ACTIONS(5535),
    [anon_sym_BANG_EQ] = ACTIONS(5535),
    [anon_sym_STAR] = ACTIONS(5537),
    [anon_sym_SLASH] = ACTIONS(5539),
    [anon_sym_STAR_STAR] = ACTIONS(5519),
    [anon_sym_CARET] = ACTIONS(5519),
    [aux_sym_binary_operator_token1] = ACTIONS(5541),
    [anon_sym_PIPE_GT] = ACTIONS(5541),
    [anon_sym_COLON] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5521),
    [anon_sym_AT] = ACTIONS(5521),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5523),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5525),
    [sym__external_open_bracket2] = ACTIONS(5527),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [713] = {
    [sym_call_arguments] = STATE(2380),
    [sym_subset_arguments] = STATE(2385),
    [sym_subset2_arguments] = STATE(2388),
    [sym__open_parenthesis] = STATE(1496),
    [sym__open_bracket] = STATE(1494),
    [sym__open_bracket2] = STATE(1490),
    [sym_identifier] = ACTIONS(5401),
    [anon_sym_BSLASH] = ACTIONS(5399),
    [anon_sym_function] = ACTIONS(5401),
    [anon_sym_EQ] = ACTIONS(5563),
    [anon_sym_if] = ACTIONS(5401),
    [anon_sym_for] = ACTIONS(5401),
    [anon_sym_while] = ACTIONS(5401),
    [anon_sym_repeat] = ACTIONS(5401),
    [anon_sym_QMARK] = ACTIONS(5399),
    [anon_sym_TILDE] = ACTIONS(5565),
    [anon_sym_BANG] = ACTIONS(5401),
    [anon_sym_PLUS] = ACTIONS(5567),
    [anon_sym_DASH] = ACTIONS(5569),
    [anon_sym_LT_DASH] = ACTIONS(5571),
    [anon_sym_LT_LT_DASH] = ACTIONS(5571),
    [anon_sym_COLON_EQ] = ACTIONS(5571),
    [anon_sym_DASH_GT] = ACTIONS(5573),
    [anon_sym_DASH_GT_GT] = ACTIONS(5575),
    [anon_sym_PIPE] = ACTIONS(5577),
    [anon_sym_AMP] = ACTIONS(5579),
    [anon_sym_PIPE_PIPE] = ACTIONS(5581),
    [anon_sym_AMP_AMP] = ACTIONS(5583),
    [anon_sym_LT] = ACTIONS(5585),
    [anon_sym_LT_EQ] = ACTIONS(5587),
    [anon_sym_GT] = ACTIONS(5585),
    [anon_sym_GT_EQ] = ACTIONS(5587),
    [anon_sym_EQ_EQ] = ACTIONS(5587),
    [anon_sym_BANG_EQ] = ACTIONS(5587),
    [anon_sym_STAR] = ACTIONS(5589),
    [anon_sym_SLASH] = ACTIONS(5591),
    [anon_sym_STAR_STAR] = ACTIONS(5593),
    [anon_sym_CARET] = ACTIONS(5593),
    [aux_sym_binary_operator_token1] = ACTIONS(5595),
    [anon_sym_PIPE_GT] = ACTIONS(5595),
    [anon_sym_COLON] = ACTIONS(5597),
    [anon_sym_DOLLAR] = ACTIONS(5599),
    [anon_sym_AT] = ACTIONS(5599),
    [aux_sym__hex_literal_token1] = ACTIONS(5399),
    [sym__number_literal] = ACTIONS(5401),
    [anon_sym_SQUOTE] = ACTIONS(5399),
    [anon_sym_DQUOTE] = ACTIONS(5399),
    [sym_return] = ACTIONS(5401),
    [sym_next] = ACTIONS(5401),
    [sym_break] = ACTIONS(5401),
    [sym_true] = ACTIONS(5401),
    [sym_false] = ACTIONS(5401),
    [sym_null] = ACTIONS(5401),
    [sym_inf] = ACTIONS(5401),
    [sym_nan] = ACTIONS(5401),
    [anon_sym_NA] = ACTIONS(5401),
    [anon_sym_NA_integer_] = ACTIONS(5401),
    [anon_sym_NA_real_] = ACTIONS(5401),
    [anon_sym_NA_complex_] = ACTIONS(5401),
    [anon_sym_NA_character_] = ACTIONS(5401),
    [sym_dots] = ACTIONS(5401),
    [sym_dot_dot_i] = ACTIONS(5399),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5399),
    [sym__newline] = ACTIONS(5399),
    [sym__semicolon] = ACTIONS(5399),
    [sym__raw_string_literal] = ACTIONS(5399),
    [sym__external_open_parenthesis] = ACTIONS(5601),
    [sym__external_close_parenthesis] = ACTIONS(5399),
    [sym__external_open_brace] = ACTIONS(5399),
    [sym__external_close_brace] = ACTIONS(5399),
    [sym__external_open_bracket] = ACTIONS(5603),
    [sym__external_close_bracket] = ACTIONS(5399),
    [sym__external_open_bracket2] = ACTIONS(5605),
  },
  [714] = {
    [sym_call_arguments] = STATE(2401),
    [sym_subset_arguments] = STATE(2403),
    [sym_subset2_arguments] = STATE(2404),
    [sym__open_parenthesis] = STATE(1461),
    [sym__open_bracket] = STATE(1450),
    [sym__open_bracket2] = STATE(1447),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5537),
    [anon_sym_SLASH] = ACTIONS(5539),
    [anon_sym_STAR_STAR] = ACTIONS(5519),
    [anon_sym_CARET] = ACTIONS(5519),
    [aux_sym_binary_operator_token1] = ACTIONS(5541),
    [anon_sym_PIPE_GT] = ACTIONS(5541),
    [anon_sym_COLON] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5521),
    [anon_sym_AT] = ACTIONS(5521),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5523),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5525),
    [sym__external_open_bracket2] = ACTIONS(5527),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [715] = {
    [sym_call_arguments] = STATE(2401),
    [sym_subset_arguments] = STATE(2403),
    [sym_subset2_arguments] = STATE(2404),
    [sym__open_parenthesis] = STATE(1461),
    [sym__open_bracket] = STATE(1450),
    [sym__open_bracket2] = STATE(1447),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5553),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5555),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5529),
    [anon_sym_DASH] = ACTIONS(5531),
    [anon_sym_LT_DASH] = ACTIONS(5557),
    [anon_sym_LT_LT_DASH] = ACTIONS(5557),
    [anon_sym_COLON_EQ] = ACTIONS(5557),
    [anon_sym_DASH_GT] = ACTIONS(5559),
    [anon_sym_DASH_GT_GT] = ACTIONS(5561),
    [anon_sym_PIPE] = ACTIONS(5545),
    [anon_sym_AMP] = ACTIONS(5547),
    [anon_sym_PIPE_PIPE] = ACTIONS(5549),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_LT] = ACTIONS(5533),
    [anon_sym_LT_EQ] = ACTIONS(5535),
    [anon_sym_GT] = ACTIONS(5533),
    [anon_sym_GT_EQ] = ACTIONS(5535),
    [anon_sym_EQ_EQ] = ACTIONS(5535),
    [anon_sym_BANG_EQ] = ACTIONS(5535),
    [anon_sym_STAR] = ACTIONS(5537),
    [anon_sym_SLASH] = ACTIONS(5539),
    [anon_sym_STAR_STAR] = ACTIONS(5519),
    [anon_sym_CARET] = ACTIONS(5519),
    [aux_sym_binary_operator_token1] = ACTIONS(5541),
    [anon_sym_PIPE_GT] = ACTIONS(5541),
    [anon_sym_COLON] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5521),
    [anon_sym_AT] = ACTIONS(5521),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5523),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5525),
    [sym__external_open_bracket2] = ACTIONS(5527),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [716] = {
    [sym_call_arguments] = STATE(2401),
    [sym_subset_arguments] = STATE(2403),
    [sym_subset2_arguments] = STATE(2404),
    [sym__open_parenthesis] = STATE(1461),
    [sym__open_bracket] = STATE(1450),
    [sym__open_bracket2] = STATE(1447),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5555),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5529),
    [anon_sym_DASH] = ACTIONS(5531),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5545),
    [anon_sym_AMP] = ACTIONS(5547),
    [anon_sym_PIPE_PIPE] = ACTIONS(5549),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_LT] = ACTIONS(5533),
    [anon_sym_LT_EQ] = ACTIONS(5535),
    [anon_sym_GT] = ACTIONS(5533),
    [anon_sym_GT_EQ] = ACTIONS(5535),
    [anon_sym_EQ_EQ] = ACTIONS(5535),
    [anon_sym_BANG_EQ] = ACTIONS(5535),
    [anon_sym_STAR] = ACTIONS(5537),
    [anon_sym_SLASH] = ACTIONS(5539),
    [anon_sym_STAR_STAR] = ACTIONS(5519),
    [anon_sym_CARET] = ACTIONS(5519),
    [aux_sym_binary_operator_token1] = ACTIONS(5541),
    [anon_sym_PIPE_GT] = ACTIONS(5541),
    [anon_sym_COLON] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5521),
    [anon_sym_AT] = ACTIONS(5521),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5523),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5525),
    [sym__external_open_bracket2] = ACTIONS(5527),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [717] = {
    [sym_call_arguments] = STATE(2401),
    [sym_subset_arguments] = STATE(2403),
    [sym_subset2_arguments] = STATE(2404),
    [sym__open_parenthesis] = STATE(1461),
    [sym__open_bracket] = STATE(1450),
    [sym__open_bracket2] = STATE(1447),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5529),
    [anon_sym_DASH] = ACTIONS(5531),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5547),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_LT] = ACTIONS(5533),
    [anon_sym_LT_EQ] = ACTIONS(5535),
    [anon_sym_GT] = ACTIONS(5533),
    [anon_sym_GT_EQ] = ACTIONS(5535),
    [anon_sym_EQ_EQ] = ACTIONS(5535),
    [anon_sym_BANG_EQ] = ACTIONS(5535),
    [anon_sym_STAR] = ACTIONS(5537),
    [anon_sym_SLASH] = ACTIONS(5539),
    [anon_sym_STAR_STAR] = ACTIONS(5519),
    [anon_sym_CARET] = ACTIONS(5519),
    [aux_sym_binary_operator_token1] = ACTIONS(5541),
    [anon_sym_PIPE_GT] = ACTIONS(5541),
    [anon_sym_COLON] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5521),
    [anon_sym_AT] = ACTIONS(5521),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5523),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5525),
    [sym__external_open_bracket2] = ACTIONS(5527),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [718] = {
    [sym_call_arguments] = STATE(2401),
    [sym_subset_arguments] = STATE(2403),
    [sym_subset2_arguments] = STATE(2404),
    [sym__open_parenthesis] = STATE(1461),
    [sym__open_bracket] = STATE(1450),
    [sym__open_bracket2] = STATE(1447),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5529),
    [anon_sym_DASH] = ACTIONS(5531),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5533),
    [anon_sym_LT_EQ] = ACTIONS(5535),
    [anon_sym_GT] = ACTIONS(5533),
    [anon_sym_GT_EQ] = ACTIONS(5535),
    [anon_sym_EQ_EQ] = ACTIONS(5535),
    [anon_sym_BANG_EQ] = ACTIONS(5535),
    [anon_sym_STAR] = ACTIONS(5537),
    [anon_sym_SLASH] = ACTIONS(5539),
    [anon_sym_STAR_STAR] = ACTIONS(5519),
    [anon_sym_CARET] = ACTIONS(5519),
    [aux_sym_binary_operator_token1] = ACTIONS(5541),
    [anon_sym_PIPE_GT] = ACTIONS(5541),
    [anon_sym_COLON] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5521),
    [anon_sym_AT] = ACTIONS(5521),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5523),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5525),
    [sym__external_open_bracket2] = ACTIONS(5527),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [719] = {
    [sym_call_arguments] = STATE(2401),
    [sym_subset_arguments] = STATE(2403),
    [sym_subset2_arguments] = STATE(2404),
    [sym__open_parenthesis] = STATE(1461),
    [sym__open_bracket] = STATE(1450),
    [sym__open_bracket2] = STATE(1447),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5529),
    [anon_sym_DASH] = ACTIONS(5531),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5537),
    [anon_sym_SLASH] = ACTIONS(5539),
    [anon_sym_STAR_STAR] = ACTIONS(5519),
    [anon_sym_CARET] = ACTIONS(5519),
    [aux_sym_binary_operator_token1] = ACTIONS(5541),
    [anon_sym_PIPE_GT] = ACTIONS(5541),
    [anon_sym_COLON] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5521),
    [anon_sym_AT] = ACTIONS(5521),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5523),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5525),
    [sym__external_open_bracket2] = ACTIONS(5527),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [720] = {
    [sym_call_arguments] = STATE(2401),
    [sym_subset_arguments] = STATE(2403),
    [sym_subset2_arguments] = STATE(2404),
    [sym__open_parenthesis] = STATE(1461),
    [sym__open_bracket] = STATE(1450),
    [sym__open_bracket2] = STATE(1447),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(5519),
    [anon_sym_CARET] = ACTIONS(5519),
    [aux_sym_binary_operator_token1] = ACTIONS(5541),
    [anon_sym_PIPE_GT] = ACTIONS(5541),
    [anon_sym_COLON] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5521),
    [anon_sym_AT] = ACTIONS(5521),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5523),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5525),
    [sym__external_open_bracket2] = ACTIONS(5527),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [721] = {
    [sym_call_arguments] = STATE(2401),
    [sym_subset_arguments] = STATE(2403),
    [sym_subset2_arguments] = STATE(2404),
    [sym__open_parenthesis] = STATE(1461),
    [sym__open_bracket] = STATE(1450),
    [sym__open_bracket2] = STATE(1447),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(5519),
    [anon_sym_CARET] = ACTIONS(5519),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(5351),
    [anon_sym_DOLLAR] = ACTIONS(5521),
    [anon_sym_AT] = ACTIONS(5521),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5523),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5525),
    [sym__external_open_bracket2] = ACTIONS(5527),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [722] = {
    [sym_call_arguments] = STATE(2401),
    [sym_subset_arguments] = STATE(2403),
    [sym_subset2_arguments] = STATE(2404),
    [sym__open_parenthesis] = STATE(1461),
    [sym__open_bracket] = STATE(1450),
    [sym__open_bracket2] = STATE(1447),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(5519),
    [anon_sym_CARET] = ACTIONS(5519),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5521),
    [anon_sym_AT] = ACTIONS(5521),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5523),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5525),
    [sym__external_open_bracket2] = ACTIONS(5527),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [723] = {
    [sym_call_arguments] = STATE(2380),
    [sym_subset_arguments] = STATE(2385),
    [sym_subset2_arguments] = STATE(2388),
    [sym__open_parenthesis] = STATE(1496),
    [sym__open_bracket] = STATE(1494),
    [sym__open_bracket2] = STATE(1490),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(5593),
    [anon_sym_CARET] = ACTIONS(5593),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(5351),
    [anon_sym_DOLLAR] = ACTIONS(5599),
    [anon_sym_AT] = ACTIONS(5599),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5601),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5603),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(5605),
  },
  [724] = {
    [sym_call_arguments] = STATE(2401),
    [sym_subset_arguments] = STATE(2403),
    [sym_subset2_arguments] = STATE(2404),
    [sym__open_parenthesis] = STATE(1461),
    [sym__open_bracket] = STATE(1450),
    [sym__open_bracket2] = STATE(1447),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(5519),
    [anon_sym_CARET] = ACTIONS(5519),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(5351),
    [anon_sym_DOLLAR] = ACTIONS(5521),
    [anon_sym_AT] = ACTIONS(5521),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5523),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5525),
    [sym__external_open_bracket2] = ACTIONS(5527),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [725] = {
    [sym_call_arguments] = STATE(2380),
    [sym_subset_arguments] = STATE(2385),
    [sym_subset2_arguments] = STATE(2388),
    [sym__open_parenthesis] = STATE(1496),
    [sym__open_bracket] = STATE(1494),
    [sym__open_bracket2] = STATE(1490),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(5593),
    [anon_sym_CARET] = ACTIONS(5593),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(5597),
    [anon_sym_DOLLAR] = ACTIONS(5599),
    [anon_sym_AT] = ACTIONS(5599),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5601),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5603),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(5605),
  },
  [726] = {
    [sym_call_arguments] = STATE(2380),
    [sym_subset_arguments] = STATE(2385),
    [sym_subset2_arguments] = STATE(2388),
    [sym__open_parenthesis] = STATE(1496),
    [sym__open_bracket] = STATE(1494),
    [sym__open_bracket2] = STATE(1490),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(5593),
    [anon_sym_CARET] = ACTIONS(5593),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(5351),
    [anon_sym_DOLLAR] = ACTIONS(5599),
    [anon_sym_AT] = ACTIONS(5599),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5601),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5603),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(5605),
  },
  [727] = {
    [sym_call_arguments] = STATE(2380),
    [sym_subset_arguments] = STATE(2385),
    [sym_subset2_arguments] = STATE(2388),
    [sym__open_parenthesis] = STATE(1496),
    [sym__open_bracket] = STATE(1494),
    [sym__open_bracket2] = STATE(1490),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(5593),
    [anon_sym_CARET] = ACTIONS(5593),
    [aux_sym_binary_operator_token1] = ACTIONS(5595),
    [anon_sym_PIPE_GT] = ACTIONS(5595),
    [anon_sym_COLON] = ACTIONS(5597),
    [anon_sym_DOLLAR] = ACTIONS(5599),
    [anon_sym_AT] = ACTIONS(5599),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5601),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5603),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(5605),
  },
  [728] = {
    [sym_call_arguments] = STATE(2380),
    [sym_subset_arguments] = STATE(2385),
    [sym_subset2_arguments] = STATE(2388),
    [sym__open_parenthesis] = STATE(1496),
    [sym__open_bracket] = STATE(1494),
    [sym__open_bracket2] = STATE(1490),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5567),
    [anon_sym_DASH] = ACTIONS(5569),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5589),
    [anon_sym_SLASH] = ACTIONS(5591),
    [anon_sym_STAR_STAR] = ACTIONS(5593),
    [anon_sym_CARET] = ACTIONS(5593),
    [aux_sym_binary_operator_token1] = ACTIONS(5595),
    [anon_sym_PIPE_GT] = ACTIONS(5595),
    [anon_sym_COLON] = ACTIONS(5597),
    [anon_sym_DOLLAR] = ACTIONS(5599),
    [anon_sym_AT] = ACTIONS(5599),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5601),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5603),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(5605),
  },
  [729] = {
    [sym_call_arguments] = STATE(2401),
    [sym_subset_arguments] = STATE(2403),
    [sym_subset2_arguments] = STATE(2404),
    [sym__open_parenthesis] = STATE(1461),
    [sym__open_bracket] = STATE(1450),
    [sym__open_bracket2] = STATE(1447),
    [sym_identifier] = ACTIONS(5401),
    [anon_sym_BSLASH] = ACTIONS(5399),
    [anon_sym_function] = ACTIONS(5401),
    [anon_sym_EQ] = ACTIONS(5553),
    [anon_sym_if] = ACTIONS(5401),
    [anon_sym_for] = ACTIONS(5401),
    [anon_sym_while] = ACTIONS(5401),
    [anon_sym_repeat] = ACTIONS(5401),
    [anon_sym_QMARK] = ACTIONS(5399),
    [anon_sym_TILDE] = ACTIONS(5555),
    [anon_sym_BANG] = ACTIONS(5401),
    [anon_sym_PLUS] = ACTIONS(5529),
    [anon_sym_DASH] = ACTIONS(5531),
    [anon_sym_LT_DASH] = ACTIONS(5557),
    [anon_sym_LT_LT_DASH] = ACTIONS(5557),
    [anon_sym_COLON_EQ] = ACTIONS(5557),
    [anon_sym_DASH_GT] = ACTIONS(5559),
    [anon_sym_DASH_GT_GT] = ACTIONS(5561),
    [anon_sym_PIPE] = ACTIONS(5545),
    [anon_sym_AMP] = ACTIONS(5547),
    [anon_sym_PIPE_PIPE] = ACTIONS(5549),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_LT] = ACTIONS(5533),
    [anon_sym_LT_EQ] = ACTIONS(5535),
    [anon_sym_GT] = ACTIONS(5533),
    [anon_sym_GT_EQ] = ACTIONS(5535),
    [anon_sym_EQ_EQ] = ACTIONS(5535),
    [anon_sym_BANG_EQ] = ACTIONS(5535),
    [anon_sym_STAR] = ACTIONS(5537),
    [anon_sym_SLASH] = ACTIONS(5539),
    [anon_sym_STAR_STAR] = ACTIONS(5519),
    [anon_sym_CARET] = ACTIONS(5519),
    [aux_sym_binary_operator_token1] = ACTIONS(5541),
    [anon_sym_PIPE_GT] = ACTIONS(5541),
    [anon_sym_COLON] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5521),
    [anon_sym_AT] = ACTIONS(5521),
    [aux_sym__hex_literal_token1] = ACTIONS(5399),
    [sym__number_literal] = ACTIONS(5401),
    [anon_sym_SQUOTE] = ACTIONS(5399),
    [anon_sym_DQUOTE] = ACTIONS(5399),
    [sym_return] = ACTIONS(5401),
    [sym_next] = ACTIONS(5401),
    [sym_break] = ACTIONS(5401),
    [sym_true] = ACTIONS(5401),
    [sym_false] = ACTIONS(5401),
    [sym_null] = ACTIONS(5401),
    [sym_inf] = ACTIONS(5401),
    [sym_nan] = ACTIONS(5401),
    [anon_sym_NA] = ACTIONS(5401),
    [anon_sym_NA_integer_] = ACTIONS(5401),
    [anon_sym_NA_real_] = ACTIONS(5401),
    [anon_sym_NA_complex_] = ACTIONS(5401),
    [anon_sym_NA_character_] = ACTIONS(5401),
    [sym_dots] = ACTIONS(5401),
    [sym_dot_dot_i] = ACTIONS(5399),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5399),
    [sym__newline] = ACTIONS(5399),
    [sym__semicolon] = ACTIONS(5399),
    [sym__raw_string_literal] = ACTIONS(5399),
    [sym__external_open_parenthesis] = ACTIONS(5523),
    [sym__external_close_parenthesis] = ACTIONS(5399),
    [sym__external_open_brace] = ACTIONS(5399),
    [sym__external_close_brace] = ACTIONS(5399),
    [sym__external_open_bracket] = ACTIONS(5525),
    [sym__external_open_bracket2] = ACTIONS(5527),
    [sym__external_close_bracket2] = ACTIONS(5399),
  },
  [730] = {
    [sym_call_arguments] = STATE(2380),
    [sym_subset_arguments] = STATE(2385),
    [sym_subset2_arguments] = STATE(2388),
    [sym__open_parenthesis] = STATE(1496),
    [sym__open_bracket] = STATE(1494),
    [sym__open_bracket2] = STATE(1490),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5567),
    [anon_sym_DASH] = ACTIONS(5569),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5585),
    [anon_sym_LT_EQ] = ACTIONS(5587),
    [anon_sym_GT] = ACTIONS(5585),
    [anon_sym_GT_EQ] = ACTIONS(5587),
    [anon_sym_EQ_EQ] = ACTIONS(5587),
    [anon_sym_BANG_EQ] = ACTIONS(5587),
    [anon_sym_STAR] = ACTIONS(5589),
    [anon_sym_SLASH] = ACTIONS(5591),
    [anon_sym_STAR_STAR] = ACTIONS(5593),
    [anon_sym_CARET] = ACTIONS(5593),
    [aux_sym_binary_operator_token1] = ACTIONS(5595),
    [anon_sym_PIPE_GT] = ACTIONS(5595),
    [anon_sym_COLON] = ACTIONS(5597),
    [anon_sym_DOLLAR] = ACTIONS(5599),
    [anon_sym_AT] = ACTIONS(5599),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5601),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5603),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(5605),
  },
  [731] = {
    [sym_call_arguments] = STATE(2401),
    [sym_subset_arguments] = STATE(2403),
    [sym_subset2_arguments] = STATE(2404),
    [sym__open_parenthesis] = STATE(1461),
    [sym__open_bracket] = STATE(1450),
    [sym__open_bracket2] = STATE(1447),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5553),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5555),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5529),
    [anon_sym_DASH] = ACTIONS(5531),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5559),
    [anon_sym_DASH_GT_GT] = ACTIONS(5561),
    [anon_sym_PIPE] = ACTIONS(5545),
    [anon_sym_AMP] = ACTIONS(5547),
    [anon_sym_PIPE_PIPE] = ACTIONS(5549),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_LT] = ACTIONS(5533),
    [anon_sym_LT_EQ] = ACTIONS(5535),
    [anon_sym_GT] = ACTIONS(5533),
    [anon_sym_GT_EQ] = ACTIONS(5535),
    [anon_sym_EQ_EQ] = ACTIONS(5535),
    [anon_sym_BANG_EQ] = ACTIONS(5535),
    [anon_sym_STAR] = ACTIONS(5537),
    [anon_sym_SLASH] = ACTIONS(5539),
    [anon_sym_STAR_STAR] = ACTIONS(5519),
    [anon_sym_CARET] = ACTIONS(5519),
    [aux_sym_binary_operator_token1] = ACTIONS(5541),
    [anon_sym_PIPE_GT] = ACTIONS(5541),
    [anon_sym_COLON] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5521),
    [anon_sym_AT] = ACTIONS(5521),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5523),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5525),
    [sym__external_open_bracket2] = ACTIONS(5527),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [732] = {
    [sym_call_arguments] = STATE(2380),
    [sym_subset_arguments] = STATE(2385),
    [sym_subset2_arguments] = STATE(2388),
    [sym__open_parenthesis] = STATE(1496),
    [sym__open_bracket] = STATE(1494),
    [sym__open_bracket2] = STATE(1490),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5567),
    [anon_sym_DASH] = ACTIONS(5569),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5579),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5583),
    [anon_sym_LT] = ACTIONS(5585),
    [anon_sym_LT_EQ] = ACTIONS(5587),
    [anon_sym_GT] = ACTIONS(5585),
    [anon_sym_GT_EQ] = ACTIONS(5587),
    [anon_sym_EQ_EQ] = ACTIONS(5587),
    [anon_sym_BANG_EQ] = ACTIONS(5587),
    [anon_sym_STAR] = ACTIONS(5589),
    [anon_sym_SLASH] = ACTIONS(5591),
    [anon_sym_STAR_STAR] = ACTIONS(5593),
    [anon_sym_CARET] = ACTIONS(5593),
    [aux_sym_binary_operator_token1] = ACTIONS(5595),
    [anon_sym_PIPE_GT] = ACTIONS(5595),
    [anon_sym_COLON] = ACTIONS(5597),
    [anon_sym_DOLLAR] = ACTIONS(5599),
    [anon_sym_AT] = ACTIONS(5599),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5601),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5603),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(5605),
  },
  [733] = {
    [sym_call_arguments] = STATE(2401),
    [sym_subset_arguments] = STATE(2403),
    [sym_subset2_arguments] = STATE(2404),
    [sym__open_parenthesis] = STATE(1461),
    [sym__open_bracket] = STATE(1450),
    [sym__open_bracket2] = STATE(1447),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5553),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5555),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5529),
    [anon_sym_DASH] = ACTIONS(5531),
    [anon_sym_LT_DASH] = ACTIONS(5557),
    [anon_sym_LT_LT_DASH] = ACTIONS(5557),
    [anon_sym_COLON_EQ] = ACTIONS(5557),
    [anon_sym_DASH_GT] = ACTIONS(5559),
    [anon_sym_DASH_GT_GT] = ACTIONS(5561),
    [anon_sym_PIPE] = ACTIONS(5545),
    [anon_sym_AMP] = ACTIONS(5547),
    [anon_sym_PIPE_PIPE] = ACTIONS(5549),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_LT] = ACTIONS(5533),
    [anon_sym_LT_EQ] = ACTIONS(5535),
    [anon_sym_GT] = ACTIONS(5533),
    [anon_sym_GT_EQ] = ACTIONS(5535),
    [anon_sym_EQ_EQ] = ACTIONS(5535),
    [anon_sym_BANG_EQ] = ACTIONS(5535),
    [anon_sym_STAR] = ACTIONS(5537),
    [anon_sym_SLASH] = ACTIONS(5539),
    [anon_sym_STAR_STAR] = ACTIONS(5519),
    [anon_sym_CARET] = ACTIONS(5519),
    [aux_sym_binary_operator_token1] = ACTIONS(5541),
    [anon_sym_PIPE_GT] = ACTIONS(5541),
    [anon_sym_COLON] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5521),
    [anon_sym_AT] = ACTIONS(5521),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5523),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5525),
    [sym__external_open_bracket2] = ACTIONS(5527),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [734] = {
    [sym_call_arguments] = STATE(2380),
    [sym_subset_arguments] = STATE(2385),
    [sym_subset2_arguments] = STATE(2388),
    [sym__open_parenthesis] = STATE(1496),
    [sym__open_bracket] = STATE(1494),
    [sym__open_bracket2] = STATE(1490),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5565),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5567),
    [anon_sym_DASH] = ACTIONS(5569),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5577),
    [anon_sym_AMP] = ACTIONS(5579),
    [anon_sym_PIPE_PIPE] = ACTIONS(5581),
    [anon_sym_AMP_AMP] = ACTIONS(5583),
    [anon_sym_LT] = ACTIONS(5585),
    [anon_sym_LT_EQ] = ACTIONS(5587),
    [anon_sym_GT] = ACTIONS(5585),
    [anon_sym_GT_EQ] = ACTIONS(5587),
    [anon_sym_EQ_EQ] = ACTIONS(5587),
    [anon_sym_BANG_EQ] = ACTIONS(5587),
    [anon_sym_STAR] = ACTIONS(5589),
    [anon_sym_SLASH] = ACTIONS(5591),
    [anon_sym_STAR_STAR] = ACTIONS(5593),
    [anon_sym_CARET] = ACTIONS(5593),
    [aux_sym_binary_operator_token1] = ACTIONS(5595),
    [anon_sym_PIPE_GT] = ACTIONS(5595),
    [anon_sym_COLON] = ACTIONS(5597),
    [anon_sym_DOLLAR] = ACTIONS(5599),
    [anon_sym_AT] = ACTIONS(5599),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5601),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5603),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(5605),
  },
  [735] = {
    [sym_call_arguments] = STATE(2401),
    [sym_subset_arguments] = STATE(2403),
    [sym_subset2_arguments] = STATE(2404),
    [sym__open_parenthesis] = STATE(1461),
    [sym__open_bracket] = STATE(1450),
    [sym__open_bracket2] = STATE(1447),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5529),
    [anon_sym_DASH] = ACTIONS(5531),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5545),
    [anon_sym_AMP] = ACTIONS(5547),
    [anon_sym_PIPE_PIPE] = ACTIONS(5549),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_LT] = ACTIONS(5533),
    [anon_sym_LT_EQ] = ACTIONS(5535),
    [anon_sym_GT] = ACTIONS(5533),
    [anon_sym_GT_EQ] = ACTIONS(5535),
    [anon_sym_EQ_EQ] = ACTIONS(5535),
    [anon_sym_BANG_EQ] = ACTIONS(5535),
    [anon_sym_STAR] = ACTIONS(5537),
    [anon_sym_SLASH] = ACTIONS(5539),
    [anon_sym_STAR_STAR] = ACTIONS(5519),
    [anon_sym_CARET] = ACTIONS(5519),
    [aux_sym_binary_operator_token1] = ACTIONS(5541),
    [anon_sym_PIPE_GT] = ACTIONS(5541),
    [anon_sym_COLON] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5521),
    [anon_sym_AT] = ACTIONS(5521),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5523),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5525),
    [sym__external_open_bracket2] = ACTIONS(5527),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [736] = {
    [sym_call_arguments] = STATE(2380),
    [sym_subset_arguments] = STATE(2385),
    [sym_subset2_arguments] = STATE(2388),
    [sym__open_parenthesis] = STATE(1496),
    [sym__open_bracket] = STATE(1494),
    [sym__open_bracket2] = STATE(1490),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5563),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5565),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5567),
    [anon_sym_DASH] = ACTIONS(5569),
    [anon_sym_LT_DASH] = ACTIONS(5571),
    [anon_sym_LT_LT_DASH] = ACTIONS(5571),
    [anon_sym_COLON_EQ] = ACTIONS(5571),
    [anon_sym_DASH_GT] = ACTIONS(5573),
    [anon_sym_DASH_GT_GT] = ACTIONS(5575),
    [anon_sym_PIPE] = ACTIONS(5577),
    [anon_sym_AMP] = ACTIONS(5579),
    [anon_sym_PIPE_PIPE] = ACTIONS(5581),
    [anon_sym_AMP_AMP] = ACTIONS(5583),
    [anon_sym_LT] = ACTIONS(5585),
    [anon_sym_LT_EQ] = ACTIONS(5587),
    [anon_sym_GT] = ACTIONS(5585),
    [anon_sym_GT_EQ] = ACTIONS(5587),
    [anon_sym_EQ_EQ] = ACTIONS(5587),
    [anon_sym_BANG_EQ] = ACTIONS(5587),
    [anon_sym_STAR] = ACTIONS(5589),
    [anon_sym_SLASH] = ACTIONS(5591),
    [anon_sym_STAR_STAR] = ACTIONS(5593),
    [anon_sym_CARET] = ACTIONS(5593),
    [aux_sym_binary_operator_token1] = ACTIONS(5595),
    [anon_sym_PIPE_GT] = ACTIONS(5595),
    [anon_sym_COLON] = ACTIONS(5597),
    [anon_sym_DOLLAR] = ACTIONS(5599),
    [anon_sym_AT] = ACTIONS(5599),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5601),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5603),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(5605),
  },
  [737] = {
    [sym_call_arguments] = STATE(2401),
    [sym_subset_arguments] = STATE(2403),
    [sym_subset2_arguments] = STATE(2404),
    [sym__open_parenthesis] = STATE(1461),
    [sym__open_bracket] = STATE(1450),
    [sym__open_bracket2] = STATE(1447),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5537),
    [anon_sym_SLASH] = ACTIONS(5539),
    [anon_sym_STAR_STAR] = ACTIONS(5519),
    [anon_sym_CARET] = ACTIONS(5519),
    [aux_sym_binary_operator_token1] = ACTIONS(5541),
    [anon_sym_PIPE_GT] = ACTIONS(5541),
    [anon_sym_COLON] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5521),
    [anon_sym_AT] = ACTIONS(5521),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5523),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5525),
    [sym__external_open_bracket2] = ACTIONS(5527),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [738] = {
    [sym_call_arguments] = STATE(2380),
    [sym_subset_arguments] = STATE(2385),
    [sym_subset2_arguments] = STATE(2388),
    [sym__open_parenthesis] = STATE(1496),
    [sym__open_bracket] = STATE(1494),
    [sym__open_bracket2] = STATE(1490),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5589),
    [anon_sym_SLASH] = ACTIONS(5591),
    [anon_sym_STAR_STAR] = ACTIONS(5593),
    [anon_sym_CARET] = ACTIONS(5593),
    [aux_sym_binary_operator_token1] = ACTIONS(5595),
    [anon_sym_PIPE_GT] = ACTIONS(5595),
    [anon_sym_COLON] = ACTIONS(5597),
    [anon_sym_DOLLAR] = ACTIONS(5599),
    [anon_sym_AT] = ACTIONS(5599),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5601),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5603),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(5605),
  },
  [739] = {
    [sym_call_arguments] = STATE(2401),
    [sym_subset_arguments] = STATE(2403),
    [sym_subset2_arguments] = STATE(2404),
    [sym__open_parenthesis] = STATE(1461),
    [sym__open_bracket] = STATE(1450),
    [sym__open_bracket2] = STATE(1447),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5553),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5555),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5529),
    [anon_sym_DASH] = ACTIONS(5531),
    [anon_sym_LT_DASH] = ACTIONS(5557),
    [anon_sym_LT_LT_DASH] = ACTIONS(5557),
    [anon_sym_COLON_EQ] = ACTIONS(5557),
    [anon_sym_DASH_GT] = ACTIONS(5559),
    [anon_sym_DASH_GT_GT] = ACTIONS(5561),
    [anon_sym_PIPE] = ACTIONS(5545),
    [anon_sym_AMP] = ACTIONS(5547),
    [anon_sym_PIPE_PIPE] = ACTIONS(5549),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_LT] = ACTIONS(5533),
    [anon_sym_LT_EQ] = ACTIONS(5535),
    [anon_sym_GT] = ACTIONS(5533),
    [anon_sym_GT_EQ] = ACTIONS(5535),
    [anon_sym_EQ_EQ] = ACTIONS(5535),
    [anon_sym_BANG_EQ] = ACTIONS(5535),
    [anon_sym_STAR] = ACTIONS(5537),
    [anon_sym_SLASH] = ACTIONS(5539),
    [anon_sym_STAR_STAR] = ACTIONS(5519),
    [anon_sym_CARET] = ACTIONS(5519),
    [aux_sym_binary_operator_token1] = ACTIONS(5541),
    [anon_sym_PIPE_GT] = ACTIONS(5541),
    [anon_sym_COLON] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5521),
    [anon_sym_AT] = ACTIONS(5521),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5523),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5525),
    [sym__external_open_bracket2] = ACTIONS(5527),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [740] = {
    [sym_call_arguments] = STATE(2380),
    [sym_subset_arguments] = STATE(2385),
    [sym_subset2_arguments] = STATE(2388),
    [sym__open_parenthesis] = STATE(1496),
    [sym__open_bracket] = STATE(1494),
    [sym__open_bracket2] = STATE(1490),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5567),
    [anon_sym_DASH] = ACTIONS(5569),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5577),
    [anon_sym_AMP] = ACTIONS(5579),
    [anon_sym_PIPE_PIPE] = ACTIONS(5581),
    [anon_sym_AMP_AMP] = ACTIONS(5583),
    [anon_sym_LT] = ACTIONS(5585),
    [anon_sym_LT_EQ] = ACTIONS(5587),
    [anon_sym_GT] = ACTIONS(5585),
    [anon_sym_GT_EQ] = ACTIONS(5587),
    [anon_sym_EQ_EQ] = ACTIONS(5587),
    [anon_sym_BANG_EQ] = ACTIONS(5587),
    [anon_sym_STAR] = ACTIONS(5589),
    [anon_sym_SLASH] = ACTIONS(5591),
    [anon_sym_STAR_STAR] = ACTIONS(5593),
    [anon_sym_CARET] = ACTIONS(5593),
    [aux_sym_binary_operator_token1] = ACTIONS(5595),
    [anon_sym_PIPE_GT] = ACTIONS(5595),
    [anon_sym_COLON] = ACTIONS(5597),
    [anon_sym_DOLLAR] = ACTIONS(5599),
    [anon_sym_AT] = ACTIONS(5599),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5601),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5603),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(5605),
  },
  [741] = {
    [sym_call_arguments] = STATE(2401),
    [sym_subset_arguments] = STATE(2403),
    [sym_subset2_arguments] = STATE(2404),
    [sym__open_parenthesis] = STATE(1461),
    [sym__open_bracket] = STATE(1450),
    [sym__open_bracket2] = STATE(1447),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5555),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5529),
    [anon_sym_DASH] = ACTIONS(5531),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5545),
    [anon_sym_AMP] = ACTIONS(5547),
    [anon_sym_PIPE_PIPE] = ACTIONS(5549),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_LT] = ACTIONS(5533),
    [anon_sym_LT_EQ] = ACTIONS(5535),
    [anon_sym_GT] = ACTIONS(5533),
    [anon_sym_GT_EQ] = ACTIONS(5535),
    [anon_sym_EQ_EQ] = ACTIONS(5535),
    [anon_sym_BANG_EQ] = ACTIONS(5535),
    [anon_sym_STAR] = ACTIONS(5537),
    [anon_sym_SLASH] = ACTIONS(5539),
    [anon_sym_STAR_STAR] = ACTIONS(5519),
    [anon_sym_CARET] = ACTIONS(5519),
    [aux_sym_binary_operator_token1] = ACTIONS(5541),
    [anon_sym_PIPE_GT] = ACTIONS(5541),
    [anon_sym_COLON] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5521),
    [anon_sym_AT] = ACTIONS(5521),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5523),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5525),
    [sym__external_open_bracket2] = ACTIONS(5527),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [742] = {
    [sym_call_arguments] = STATE(2380),
    [sym_subset_arguments] = STATE(2385),
    [sym_subset2_arguments] = STATE(2388),
    [sym__open_parenthesis] = STATE(1496),
    [sym__open_bracket] = STATE(1494),
    [sym__open_bracket2] = STATE(1490),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5563),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5565),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5567),
    [anon_sym_DASH] = ACTIONS(5569),
    [anon_sym_LT_DASH] = ACTIONS(5571),
    [anon_sym_LT_LT_DASH] = ACTIONS(5571),
    [anon_sym_COLON_EQ] = ACTIONS(5571),
    [anon_sym_DASH_GT] = ACTIONS(5573),
    [anon_sym_DASH_GT_GT] = ACTIONS(5575),
    [anon_sym_PIPE] = ACTIONS(5577),
    [anon_sym_AMP] = ACTIONS(5579),
    [anon_sym_PIPE_PIPE] = ACTIONS(5581),
    [anon_sym_AMP_AMP] = ACTIONS(5583),
    [anon_sym_LT] = ACTIONS(5585),
    [anon_sym_LT_EQ] = ACTIONS(5587),
    [anon_sym_GT] = ACTIONS(5585),
    [anon_sym_GT_EQ] = ACTIONS(5587),
    [anon_sym_EQ_EQ] = ACTIONS(5587),
    [anon_sym_BANG_EQ] = ACTIONS(5587),
    [anon_sym_STAR] = ACTIONS(5589),
    [anon_sym_SLASH] = ACTIONS(5591),
    [anon_sym_STAR_STAR] = ACTIONS(5593),
    [anon_sym_CARET] = ACTIONS(5593),
    [aux_sym_binary_operator_token1] = ACTIONS(5595),
    [anon_sym_PIPE_GT] = ACTIONS(5595),
    [anon_sym_COLON] = ACTIONS(5597),
    [anon_sym_DOLLAR] = ACTIONS(5599),
    [anon_sym_AT] = ACTIONS(5599),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5601),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5603),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(5605),
  },
  [743] = {
    [sym_call_arguments] = STATE(2401),
    [sym_subset_arguments] = STATE(2403),
    [sym_subset2_arguments] = STATE(2404),
    [sym__open_parenthesis] = STATE(1461),
    [sym__open_bracket] = STATE(1450),
    [sym__open_bracket2] = STATE(1447),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5529),
    [anon_sym_DASH] = ACTIONS(5531),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5547),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_LT] = ACTIONS(5533),
    [anon_sym_LT_EQ] = ACTIONS(5535),
    [anon_sym_GT] = ACTIONS(5533),
    [anon_sym_GT_EQ] = ACTIONS(5535),
    [anon_sym_EQ_EQ] = ACTIONS(5535),
    [anon_sym_BANG_EQ] = ACTIONS(5535),
    [anon_sym_STAR] = ACTIONS(5537),
    [anon_sym_SLASH] = ACTIONS(5539),
    [anon_sym_STAR_STAR] = ACTIONS(5519),
    [anon_sym_CARET] = ACTIONS(5519),
    [aux_sym_binary_operator_token1] = ACTIONS(5541),
    [anon_sym_PIPE_GT] = ACTIONS(5541),
    [anon_sym_COLON] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5521),
    [anon_sym_AT] = ACTIONS(5521),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5523),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5525),
    [sym__external_open_bracket2] = ACTIONS(5527),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [744] = {
    [sym_call_arguments] = STATE(2380),
    [sym_subset_arguments] = STATE(2385),
    [sym_subset2_arguments] = STATE(2388),
    [sym__open_parenthesis] = STATE(1496),
    [sym__open_bracket] = STATE(1494),
    [sym__open_bracket2] = STATE(1490),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5563),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5565),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5567),
    [anon_sym_DASH] = ACTIONS(5569),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5573),
    [anon_sym_DASH_GT_GT] = ACTIONS(5575),
    [anon_sym_PIPE] = ACTIONS(5577),
    [anon_sym_AMP] = ACTIONS(5579),
    [anon_sym_PIPE_PIPE] = ACTIONS(5581),
    [anon_sym_AMP_AMP] = ACTIONS(5583),
    [anon_sym_LT] = ACTIONS(5585),
    [anon_sym_LT_EQ] = ACTIONS(5587),
    [anon_sym_GT] = ACTIONS(5585),
    [anon_sym_GT_EQ] = ACTIONS(5587),
    [anon_sym_EQ_EQ] = ACTIONS(5587),
    [anon_sym_BANG_EQ] = ACTIONS(5587),
    [anon_sym_STAR] = ACTIONS(5589),
    [anon_sym_SLASH] = ACTIONS(5591),
    [anon_sym_STAR_STAR] = ACTIONS(5593),
    [anon_sym_CARET] = ACTIONS(5593),
    [aux_sym_binary_operator_token1] = ACTIONS(5595),
    [anon_sym_PIPE_GT] = ACTIONS(5595),
    [anon_sym_COLON] = ACTIONS(5597),
    [anon_sym_DOLLAR] = ACTIONS(5599),
    [anon_sym_AT] = ACTIONS(5599),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5601),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5603),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(5605),
  },
  [745] = {
    [sym_call_arguments] = STATE(2380),
    [sym_subset_arguments] = STATE(2385),
    [sym_subset2_arguments] = STATE(2388),
    [sym__open_parenthesis] = STATE(1496),
    [sym__open_bracket] = STATE(1494),
    [sym__open_bracket2] = STATE(1490),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5345),
    [anon_sym_DASH] = ACTIONS(5347),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5347),
    [anon_sym_AMP] = ACTIONS(5347),
    [anon_sym_PIPE_PIPE] = ACTIONS(5345),
    [anon_sym_AMP_AMP] = ACTIONS(5345),
    [anon_sym_LT] = ACTIONS(5347),
    [anon_sym_LT_EQ] = ACTIONS(5345),
    [anon_sym_GT] = ACTIONS(5347),
    [anon_sym_GT_EQ] = ACTIONS(5345),
    [anon_sym_EQ_EQ] = ACTIONS(5345),
    [anon_sym_BANG_EQ] = ACTIONS(5345),
    [anon_sym_STAR] = ACTIONS(5347),
    [anon_sym_SLASH] = ACTIONS(5345),
    [anon_sym_STAR_STAR] = ACTIONS(5593),
    [anon_sym_CARET] = ACTIONS(5593),
    [aux_sym_binary_operator_token1] = ACTIONS(5345),
    [anon_sym_PIPE_GT] = ACTIONS(5345),
    [anon_sym_COLON] = ACTIONS(5347),
    [anon_sym_DOLLAR] = ACTIONS(5599),
    [anon_sym_AT] = ACTIONS(5599),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__semicolon] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(5601),
    [sym__external_close_parenthesis] = ACTIONS(5345),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_close_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(5603),
    [sym__external_close_bracket] = ACTIONS(5345),
    [sym__external_open_bracket2] = ACTIONS(5605),
  },
  [746] = {
    [sym_call_arguments] = STATE(2380),
    [sym_subset_arguments] = STATE(2385),
    [sym_subset2_arguments] = STATE(2388),
    [sym__open_parenthesis] = STATE(1496),
    [sym__open_bracket] = STATE(1494),
    [sym__open_bracket2] = STATE(1490),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5567),
    [anon_sym_DASH] = ACTIONS(5569),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5347),
    [anon_sym_AMP] = ACTIONS(5347),
    [anon_sym_PIPE_PIPE] = ACTIONS(5345),
    [anon_sym_AMP_AMP] = ACTIONS(5345),
    [anon_sym_LT] = ACTIONS(5585),
    [anon_sym_LT_EQ] = ACTIONS(5587),
    [anon_sym_GT] = ACTIONS(5585),
    [anon_sym_GT_EQ] = ACTIONS(5587),
    [anon_sym_EQ_EQ] = ACTIONS(5587),
    [anon_sym_BANG_EQ] = ACTIONS(5587),
    [anon_sym_STAR] = ACTIONS(5589),
    [anon_sym_SLASH] = ACTIONS(5591),
    [anon_sym_STAR_STAR] = ACTIONS(5593),
    [anon_sym_CARET] = ACTIONS(5593),
    [aux_sym_binary_operator_token1] = ACTIONS(5595),
    [anon_sym_PIPE_GT] = ACTIONS(5595),
    [anon_sym_COLON] = ACTIONS(5597),
    [anon_sym_DOLLAR] = ACTIONS(5599),
    [anon_sym_AT] = ACTIONS(5599),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__semicolon] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(5601),
    [sym__external_close_parenthesis] = ACTIONS(5345),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_close_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(5603),
    [sym__external_close_bracket] = ACTIONS(5345),
    [sym__external_open_bracket2] = ACTIONS(5605),
  },
  [747] = {
    [sym_call_arguments] = STATE(2380),
    [sym_subset_arguments] = STATE(2385),
    [sym_subset2_arguments] = STATE(2388),
    [sym__open_parenthesis] = STATE(1496),
    [sym__open_bracket] = STATE(1494),
    [sym__open_bracket2] = STATE(1490),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5567),
    [anon_sym_DASH] = ACTIONS(5569),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5577),
    [anon_sym_AMP] = ACTIONS(5579),
    [anon_sym_PIPE_PIPE] = ACTIONS(5581),
    [anon_sym_AMP_AMP] = ACTIONS(5583),
    [anon_sym_LT] = ACTIONS(5585),
    [anon_sym_LT_EQ] = ACTIONS(5587),
    [anon_sym_GT] = ACTIONS(5585),
    [anon_sym_GT_EQ] = ACTIONS(5587),
    [anon_sym_EQ_EQ] = ACTIONS(5587),
    [anon_sym_BANG_EQ] = ACTIONS(5587),
    [anon_sym_STAR] = ACTIONS(5589),
    [anon_sym_SLASH] = ACTIONS(5591),
    [anon_sym_STAR_STAR] = ACTIONS(5593),
    [anon_sym_CARET] = ACTIONS(5593),
    [aux_sym_binary_operator_token1] = ACTIONS(5595),
    [anon_sym_PIPE_GT] = ACTIONS(5595),
    [anon_sym_COLON] = ACTIONS(5597),
    [anon_sym_DOLLAR] = ACTIONS(5599),
    [anon_sym_AT] = ACTIONS(5599),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__semicolon] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(5601),
    [sym__external_close_parenthesis] = ACTIONS(5345),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_close_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(5603),
    [sym__external_close_bracket] = ACTIONS(5345),
    [sym__external_open_bracket2] = ACTIONS(5605),
  },
  [748] = {
    [sym_call_arguments] = STATE(2380),
    [sym_subset_arguments] = STATE(2385),
    [sym_subset2_arguments] = STATE(2388),
    [sym__open_parenthesis] = STATE(1496),
    [sym__open_bracket] = STATE(1494),
    [sym__open_bracket2] = STATE(1490),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5563),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5565),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5567),
    [anon_sym_DASH] = ACTIONS(5569),
    [anon_sym_LT_DASH] = ACTIONS(5571),
    [anon_sym_LT_LT_DASH] = ACTIONS(5571),
    [anon_sym_COLON_EQ] = ACTIONS(5571),
    [anon_sym_DASH_GT] = ACTIONS(5573),
    [anon_sym_DASH_GT_GT] = ACTIONS(5575),
    [anon_sym_PIPE] = ACTIONS(5577),
    [anon_sym_AMP] = ACTIONS(5579),
    [anon_sym_PIPE_PIPE] = ACTIONS(5581),
    [anon_sym_AMP_AMP] = ACTIONS(5583),
    [anon_sym_LT] = ACTIONS(5585),
    [anon_sym_LT_EQ] = ACTIONS(5587),
    [anon_sym_GT] = ACTIONS(5585),
    [anon_sym_GT_EQ] = ACTIONS(5587),
    [anon_sym_EQ_EQ] = ACTIONS(5587),
    [anon_sym_BANG_EQ] = ACTIONS(5587),
    [anon_sym_STAR] = ACTIONS(5589),
    [anon_sym_SLASH] = ACTIONS(5591),
    [anon_sym_STAR_STAR] = ACTIONS(5593),
    [anon_sym_CARET] = ACTIONS(5593),
    [aux_sym_binary_operator_token1] = ACTIONS(5595),
    [anon_sym_PIPE_GT] = ACTIONS(5595),
    [anon_sym_COLON] = ACTIONS(5597),
    [anon_sym_DOLLAR] = ACTIONS(5599),
    [anon_sym_AT] = ACTIONS(5599),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__semicolon] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(5601),
    [sym__external_close_parenthesis] = ACTIONS(5345),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_close_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(5603),
    [sym__external_close_bracket] = ACTIONS(5345),
    [sym__external_open_bracket2] = ACTIONS(5605),
  },
  [749] = {
    [sym_call_arguments] = STATE(2380),
    [sym_subset_arguments] = STATE(2385),
    [sym_subset2_arguments] = STATE(2388),
    [sym__open_parenthesis] = STATE(1496),
    [sym__open_bracket] = STATE(1494),
    [sym__open_bracket2] = STATE(1490),
    [sym_identifier] = ACTIONS(5343),
    [anon_sym_BSLASH] = ACTIONS(5341),
    [anon_sym_function] = ACTIONS(5343),
    [anon_sym_EQ] = ACTIONS(5563),
    [anon_sym_if] = ACTIONS(5343),
    [anon_sym_for] = ACTIONS(5343),
    [anon_sym_while] = ACTIONS(5343),
    [anon_sym_repeat] = ACTIONS(5343),
    [anon_sym_QMARK] = ACTIONS(5341),
    [anon_sym_TILDE] = ACTIONS(5565),
    [anon_sym_BANG] = ACTIONS(5343),
    [anon_sym_PLUS] = ACTIONS(5567),
    [anon_sym_DASH] = ACTIONS(5569),
    [anon_sym_LT_DASH] = ACTIONS(5571),
    [anon_sym_LT_LT_DASH] = ACTIONS(5571),
    [anon_sym_COLON_EQ] = ACTIONS(5571),
    [anon_sym_DASH_GT] = ACTIONS(5573),
    [anon_sym_DASH_GT_GT] = ACTIONS(5575),
    [anon_sym_PIPE] = ACTIONS(5577),
    [anon_sym_AMP] = ACTIONS(5579),
    [anon_sym_PIPE_PIPE] = ACTIONS(5581),
    [anon_sym_AMP_AMP] = ACTIONS(5583),
    [anon_sym_LT] = ACTIONS(5585),
    [anon_sym_LT_EQ] = ACTIONS(5587),
    [anon_sym_GT] = ACTIONS(5585),
    [anon_sym_GT_EQ] = ACTIONS(5587),
    [anon_sym_EQ_EQ] = ACTIONS(5587),
    [anon_sym_BANG_EQ] = ACTIONS(5587),
    [anon_sym_STAR] = ACTIONS(5589),
    [anon_sym_SLASH] = ACTIONS(5591),
    [anon_sym_STAR_STAR] = ACTIONS(5593),
    [anon_sym_CARET] = ACTIONS(5593),
    [aux_sym_binary_operator_token1] = ACTIONS(5595),
    [anon_sym_PIPE_GT] = ACTIONS(5595),
    [anon_sym_COLON] = ACTIONS(5597),
    [anon_sym_DOLLAR] = ACTIONS(5599),
    [anon_sym_AT] = ACTIONS(5599),
    [aux_sym__hex_literal_token1] = ACTIONS(5341),
    [sym__number_literal] = ACTIONS(5343),
    [anon_sym_SQUOTE] = ACTIONS(5341),
    [anon_sym_DQUOTE] = ACTIONS(5341),
    [sym_return] = ACTIONS(5343),
    [sym_next] = ACTIONS(5343),
    [sym_break] = ACTIONS(5343),
    [sym_true] = ACTIONS(5343),
    [sym_false] = ACTIONS(5343),
    [sym_null] = ACTIONS(5343),
    [sym_inf] = ACTIONS(5343),
    [sym_nan] = ACTIONS(5343),
    [anon_sym_NA] = ACTIONS(5343),
    [anon_sym_NA_integer_] = ACTIONS(5343),
    [anon_sym_NA_real_] = ACTIONS(5343),
    [anon_sym_NA_complex_] = ACTIONS(5343),
    [anon_sym_NA_character_] = ACTIONS(5343),
    [sym_dots] = ACTIONS(5343),
    [sym_dot_dot_i] = ACTIONS(5341),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5341),
    [sym__newline] = ACTIONS(5341),
    [sym__semicolon] = ACTIONS(5341),
    [sym__raw_string_literal] = ACTIONS(5341),
    [sym__external_open_parenthesis] = ACTIONS(5601),
    [sym__external_close_parenthesis] = ACTIONS(5341),
    [sym__external_open_brace] = ACTIONS(5341),
    [sym__external_close_brace] = ACTIONS(5341),
    [sym__external_open_bracket] = ACTIONS(5603),
    [sym__external_close_bracket] = ACTIONS(5341),
    [sym__external_open_bracket2] = ACTIONS(5605),
  },
  [750] = {
    [sym_call_arguments] = STATE(2401),
    [sym_subset_arguments] = STATE(2403),
    [sym_subset2_arguments] = STATE(2404),
    [sym__open_parenthesis] = STATE(1461),
    [sym__open_bracket] = STATE(1450),
    [sym__open_bracket2] = STATE(1447),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5529),
    [anon_sym_DASH] = ACTIONS(5531),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5533),
    [anon_sym_LT_EQ] = ACTIONS(5535),
    [anon_sym_GT] = ACTIONS(5533),
    [anon_sym_GT_EQ] = ACTIONS(5535),
    [anon_sym_EQ_EQ] = ACTIONS(5535),
    [anon_sym_BANG_EQ] = ACTIONS(5535),
    [anon_sym_STAR] = ACTIONS(5537),
    [anon_sym_SLASH] = ACTIONS(5539),
    [anon_sym_STAR_STAR] = ACTIONS(5519),
    [anon_sym_CARET] = ACTIONS(5519),
    [aux_sym_binary_operator_token1] = ACTIONS(5541),
    [anon_sym_PIPE_GT] = ACTIONS(5541),
    [anon_sym_COLON] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5521),
    [anon_sym_AT] = ACTIONS(5521),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5523),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5525),
    [sym__external_open_bracket2] = ACTIONS(5527),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [751] = {
    [sym_call_arguments] = STATE(2401),
    [sym_subset_arguments] = STATE(2403),
    [sym_subset2_arguments] = STATE(2404),
    [sym__open_parenthesis] = STATE(1461),
    [sym__open_bracket] = STATE(1450),
    [sym__open_bracket2] = STATE(1447),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5529),
    [anon_sym_DASH] = ACTIONS(5531),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5537),
    [anon_sym_SLASH] = ACTIONS(5539),
    [anon_sym_STAR_STAR] = ACTIONS(5519),
    [anon_sym_CARET] = ACTIONS(5519),
    [aux_sym_binary_operator_token1] = ACTIONS(5541),
    [anon_sym_PIPE_GT] = ACTIONS(5541),
    [anon_sym_COLON] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5521),
    [anon_sym_AT] = ACTIONS(5521),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5523),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5525),
    [sym__external_open_bracket2] = ACTIONS(5527),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [752] = {
    [sym_call_arguments] = STATE(2401),
    [sym_subset_arguments] = STATE(2403),
    [sym_subset2_arguments] = STATE(2404),
    [sym__open_parenthesis] = STATE(1461),
    [sym__open_bracket] = STATE(1450),
    [sym__open_bracket2] = STATE(1447),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(5519),
    [anon_sym_CARET] = ACTIONS(5519),
    [aux_sym_binary_operator_token1] = ACTIONS(5541),
    [anon_sym_PIPE_GT] = ACTIONS(5541),
    [anon_sym_COLON] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5521),
    [anon_sym_AT] = ACTIONS(5521),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5523),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5525),
    [sym__external_open_bracket2] = ACTIONS(5527),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [753] = {
    [sym_call_arguments] = STATE(2380),
    [sym_subset_arguments] = STATE(2385),
    [sym_subset2_arguments] = STATE(2388),
    [sym__open_parenthesis] = STATE(1496),
    [sym__open_bracket] = STATE(1494),
    [sym__open_bracket2] = STATE(1490),
    [sym_identifier] = ACTIONS(5339),
    [anon_sym_BSLASH] = ACTIONS(5337),
    [anon_sym_function] = ACTIONS(5339),
    [anon_sym_EQ] = ACTIONS(5563),
    [anon_sym_if] = ACTIONS(5339),
    [anon_sym_for] = ACTIONS(5339),
    [anon_sym_while] = ACTIONS(5339),
    [anon_sym_repeat] = ACTIONS(5339),
    [anon_sym_QMARK] = ACTIONS(5337),
    [anon_sym_TILDE] = ACTIONS(5565),
    [anon_sym_BANG] = ACTIONS(5339),
    [anon_sym_PLUS] = ACTIONS(5567),
    [anon_sym_DASH] = ACTIONS(5569),
    [anon_sym_LT_DASH] = ACTIONS(5571),
    [anon_sym_LT_LT_DASH] = ACTIONS(5571),
    [anon_sym_COLON_EQ] = ACTIONS(5571),
    [anon_sym_DASH_GT] = ACTIONS(5573),
    [anon_sym_DASH_GT_GT] = ACTIONS(5575),
    [anon_sym_PIPE] = ACTIONS(5577),
    [anon_sym_AMP] = ACTIONS(5579),
    [anon_sym_PIPE_PIPE] = ACTIONS(5581),
    [anon_sym_AMP_AMP] = ACTIONS(5583),
    [anon_sym_LT] = ACTIONS(5585),
    [anon_sym_LT_EQ] = ACTIONS(5587),
    [anon_sym_GT] = ACTIONS(5585),
    [anon_sym_GT_EQ] = ACTIONS(5587),
    [anon_sym_EQ_EQ] = ACTIONS(5587),
    [anon_sym_BANG_EQ] = ACTIONS(5587),
    [anon_sym_STAR] = ACTIONS(5589),
    [anon_sym_SLASH] = ACTIONS(5591),
    [anon_sym_STAR_STAR] = ACTIONS(5593),
    [anon_sym_CARET] = ACTIONS(5593),
    [aux_sym_binary_operator_token1] = ACTIONS(5595),
    [anon_sym_PIPE_GT] = ACTIONS(5595),
    [anon_sym_COLON] = ACTIONS(5597),
    [anon_sym_DOLLAR] = ACTIONS(5599),
    [anon_sym_AT] = ACTIONS(5599),
    [aux_sym__hex_literal_token1] = ACTIONS(5337),
    [sym__number_literal] = ACTIONS(5339),
    [anon_sym_SQUOTE] = ACTIONS(5337),
    [anon_sym_DQUOTE] = ACTIONS(5337),
    [sym_return] = ACTIONS(5339),
    [sym_next] = ACTIONS(5339),
    [sym_break] = ACTIONS(5339),
    [sym_true] = ACTIONS(5339),
    [sym_false] = ACTIONS(5339),
    [sym_null] = ACTIONS(5339),
    [sym_inf] = ACTIONS(5339),
    [sym_nan] = ACTIONS(5339),
    [anon_sym_NA] = ACTIONS(5339),
    [anon_sym_NA_integer_] = ACTIONS(5339),
    [anon_sym_NA_real_] = ACTIONS(5339),
    [anon_sym_NA_complex_] = ACTIONS(5339),
    [anon_sym_NA_character_] = ACTIONS(5339),
    [sym_dots] = ACTIONS(5339),
    [sym_dot_dot_i] = ACTIONS(5337),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5337),
    [sym__newline] = ACTIONS(5337),
    [sym__semicolon] = ACTIONS(5337),
    [sym__raw_string_literal] = ACTIONS(5337),
    [sym__external_open_parenthesis] = ACTIONS(5601),
    [sym__external_close_parenthesis] = ACTIONS(5337),
    [sym__external_open_brace] = ACTIONS(5337),
    [sym__external_close_brace] = ACTIONS(5337),
    [sym__external_open_bracket] = ACTIONS(5603),
    [sym__external_close_bracket] = ACTIONS(5337),
    [sym__external_open_bracket2] = ACTIONS(5605),
  },
  [754] = {
    [sym_call_arguments] = STATE(2401),
    [sym_subset_arguments] = STATE(2403),
    [sym_subset2_arguments] = STATE(2404),
    [sym__open_parenthesis] = STATE(1461),
    [sym__open_bracket] = STATE(1450),
    [sym__open_bracket2] = STATE(1447),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(5519),
    [anon_sym_CARET] = ACTIONS(5519),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(5261),
    [anon_sym_DOLLAR] = ACTIONS(5521),
    [anon_sym_AT] = ACTIONS(5521),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5523),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5525),
    [sym__external_open_bracket2] = ACTIONS(5527),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [755] = {
    [sym_call_arguments] = STATE(2401),
    [sym_subset_arguments] = STATE(2403),
    [sym_subset2_arguments] = STATE(2404),
    [sym__open_parenthesis] = STATE(1461),
    [sym__open_bracket] = STATE(1450),
    [sym__open_bracket2] = STATE(1447),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(5519),
    [anon_sym_CARET] = ACTIONS(5519),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5521),
    [anon_sym_AT] = ACTIONS(5521),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5523),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5525),
    [sym__external_open_bracket2] = ACTIONS(5527),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [756] = {
    [sym_call_arguments] = STATE(2401),
    [sym_subset_arguments] = STATE(2403),
    [sym_subset2_arguments] = STATE(2404),
    [sym__open_parenthesis] = STATE(1461),
    [sym__open_bracket] = STATE(1450),
    [sym__open_bracket2] = STATE(1447),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(5519),
    [anon_sym_CARET] = ACTIONS(5519),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(5261),
    [anon_sym_DOLLAR] = ACTIONS(5521),
    [anon_sym_AT] = ACTIONS(5521),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5523),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5525),
    [sym__external_open_bracket2] = ACTIONS(5527),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [757] = {
    [sym_call_arguments] = STATE(2401),
    [sym_subset_arguments] = STATE(2403),
    [sym_subset2_arguments] = STATE(2404),
    [sym__open_parenthesis] = STATE(1461),
    [sym__open_bracket] = STATE(1450),
    [sym__open_bracket2] = STATE(1447),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_BSLASH] = ACTIONS(5413),
    [anon_sym_function] = ACTIONS(5415),
    [anon_sym_EQ] = ACTIONS(5553),
    [anon_sym_if] = ACTIONS(5415),
    [anon_sym_for] = ACTIONS(5415),
    [anon_sym_while] = ACTIONS(5415),
    [anon_sym_repeat] = ACTIONS(5415),
    [anon_sym_QMARK] = ACTIONS(5413),
    [anon_sym_TILDE] = ACTIONS(5555),
    [anon_sym_BANG] = ACTIONS(5415),
    [anon_sym_PLUS] = ACTIONS(5529),
    [anon_sym_DASH] = ACTIONS(5531),
    [anon_sym_LT_DASH] = ACTIONS(5557),
    [anon_sym_LT_LT_DASH] = ACTIONS(5557),
    [anon_sym_COLON_EQ] = ACTIONS(5557),
    [anon_sym_DASH_GT] = ACTIONS(5559),
    [anon_sym_DASH_GT_GT] = ACTIONS(5561),
    [anon_sym_PIPE] = ACTIONS(5545),
    [anon_sym_AMP] = ACTIONS(5547),
    [anon_sym_PIPE_PIPE] = ACTIONS(5549),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_LT] = ACTIONS(5533),
    [anon_sym_LT_EQ] = ACTIONS(5535),
    [anon_sym_GT] = ACTIONS(5533),
    [anon_sym_GT_EQ] = ACTIONS(5535),
    [anon_sym_EQ_EQ] = ACTIONS(5535),
    [anon_sym_BANG_EQ] = ACTIONS(5535),
    [anon_sym_STAR] = ACTIONS(5537),
    [anon_sym_SLASH] = ACTIONS(5539),
    [anon_sym_STAR_STAR] = ACTIONS(5519),
    [anon_sym_CARET] = ACTIONS(5519),
    [aux_sym_binary_operator_token1] = ACTIONS(5541),
    [anon_sym_PIPE_GT] = ACTIONS(5541),
    [anon_sym_COLON] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5521),
    [anon_sym_AT] = ACTIONS(5521),
    [aux_sym__hex_literal_token1] = ACTIONS(5413),
    [sym__number_literal] = ACTIONS(5415),
    [anon_sym_SQUOTE] = ACTIONS(5413),
    [anon_sym_DQUOTE] = ACTIONS(5413),
    [sym_return] = ACTIONS(5415),
    [sym_next] = ACTIONS(5415),
    [sym_break] = ACTIONS(5415),
    [sym_true] = ACTIONS(5415),
    [sym_false] = ACTIONS(5415),
    [sym_null] = ACTIONS(5415),
    [sym_inf] = ACTIONS(5415),
    [sym_nan] = ACTIONS(5415),
    [anon_sym_NA] = ACTIONS(5415),
    [anon_sym_NA_integer_] = ACTIONS(5415),
    [anon_sym_NA_real_] = ACTIONS(5415),
    [anon_sym_NA_complex_] = ACTIONS(5415),
    [anon_sym_NA_character_] = ACTIONS(5415),
    [sym_dots] = ACTIONS(5415),
    [sym_dot_dot_i] = ACTIONS(5413),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5413),
    [sym__newline] = ACTIONS(5413),
    [sym__semicolon] = ACTIONS(5413),
    [sym__raw_string_literal] = ACTIONS(5413),
    [sym__external_open_parenthesis] = ACTIONS(5523),
    [sym__external_close_parenthesis] = ACTIONS(5413),
    [sym__external_open_brace] = ACTIONS(5413),
    [sym__external_close_brace] = ACTIONS(5413),
    [sym__external_open_bracket] = ACTIONS(5525),
    [sym__external_open_bracket2] = ACTIONS(5527),
    [sym__external_close_bracket2] = ACTIONS(5413),
  },
  [758] = {
    [sym_call_arguments] = STATE(2401),
    [sym_subset_arguments] = STATE(2403),
    [sym_subset2_arguments] = STATE(2404),
    [sym__open_parenthesis] = STATE(1461),
    [sym__open_bracket] = STATE(1450),
    [sym__open_bracket2] = STATE(1447),
    [sym_identifier] = ACTIONS(5419),
    [anon_sym_BSLASH] = ACTIONS(5417),
    [anon_sym_function] = ACTIONS(5419),
    [anon_sym_EQ] = ACTIONS(5553),
    [anon_sym_if] = ACTIONS(5419),
    [anon_sym_for] = ACTIONS(5419),
    [anon_sym_while] = ACTIONS(5419),
    [anon_sym_repeat] = ACTIONS(5419),
    [anon_sym_QMARK] = ACTIONS(5417),
    [anon_sym_TILDE] = ACTIONS(5555),
    [anon_sym_BANG] = ACTIONS(5419),
    [anon_sym_PLUS] = ACTIONS(5529),
    [anon_sym_DASH] = ACTIONS(5531),
    [anon_sym_LT_DASH] = ACTIONS(5557),
    [anon_sym_LT_LT_DASH] = ACTIONS(5557),
    [anon_sym_COLON_EQ] = ACTIONS(5557),
    [anon_sym_DASH_GT] = ACTIONS(5559),
    [anon_sym_DASH_GT_GT] = ACTIONS(5561),
    [anon_sym_PIPE] = ACTIONS(5545),
    [anon_sym_AMP] = ACTIONS(5547),
    [anon_sym_PIPE_PIPE] = ACTIONS(5549),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_LT] = ACTIONS(5533),
    [anon_sym_LT_EQ] = ACTIONS(5535),
    [anon_sym_GT] = ACTIONS(5533),
    [anon_sym_GT_EQ] = ACTIONS(5535),
    [anon_sym_EQ_EQ] = ACTIONS(5535),
    [anon_sym_BANG_EQ] = ACTIONS(5535),
    [anon_sym_STAR] = ACTIONS(5537),
    [anon_sym_SLASH] = ACTIONS(5539),
    [anon_sym_STAR_STAR] = ACTIONS(5519),
    [anon_sym_CARET] = ACTIONS(5519),
    [aux_sym_binary_operator_token1] = ACTIONS(5541),
    [anon_sym_PIPE_GT] = ACTIONS(5541),
    [anon_sym_COLON] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5521),
    [anon_sym_AT] = ACTIONS(5521),
    [aux_sym__hex_literal_token1] = ACTIONS(5417),
    [sym__number_literal] = ACTIONS(5419),
    [anon_sym_SQUOTE] = ACTIONS(5417),
    [anon_sym_DQUOTE] = ACTIONS(5417),
    [sym_return] = ACTIONS(5419),
    [sym_next] = ACTIONS(5419),
    [sym_break] = ACTIONS(5419),
    [sym_true] = ACTIONS(5419),
    [sym_false] = ACTIONS(5419),
    [sym_null] = ACTIONS(5419),
    [sym_inf] = ACTIONS(5419),
    [sym_nan] = ACTIONS(5419),
    [anon_sym_NA] = ACTIONS(5419),
    [anon_sym_NA_integer_] = ACTIONS(5419),
    [anon_sym_NA_real_] = ACTIONS(5419),
    [anon_sym_NA_complex_] = ACTIONS(5419),
    [anon_sym_NA_character_] = ACTIONS(5419),
    [sym_dots] = ACTIONS(5419),
    [sym_dot_dot_i] = ACTIONS(5417),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5417),
    [sym__newline] = ACTIONS(5417),
    [sym__semicolon] = ACTIONS(5417),
    [sym__raw_string_literal] = ACTIONS(5417),
    [sym__external_open_parenthesis] = ACTIONS(5523),
    [sym__external_close_parenthesis] = ACTIONS(5417),
    [sym__external_open_brace] = ACTIONS(5417),
    [sym__external_close_brace] = ACTIONS(5417),
    [sym__external_open_bracket] = ACTIONS(5525),
    [sym__external_open_bracket2] = ACTIONS(5527),
    [sym__external_close_bracket2] = ACTIONS(5417),
  },
  [759] = {
    [sym_call_arguments] = STATE(2401),
    [sym_subset_arguments] = STATE(2403),
    [sym_subset2_arguments] = STATE(2404),
    [sym__open_parenthesis] = STATE(1461),
    [sym__open_bracket] = STATE(1450),
    [sym__open_bracket2] = STATE(1447),
    [sym_identifier] = ACTIONS(5423),
    [anon_sym_BSLASH] = ACTIONS(5421),
    [anon_sym_function] = ACTIONS(5423),
    [anon_sym_EQ] = ACTIONS(5553),
    [anon_sym_if] = ACTIONS(5423),
    [anon_sym_for] = ACTIONS(5423),
    [anon_sym_while] = ACTIONS(5423),
    [anon_sym_repeat] = ACTIONS(5423),
    [anon_sym_QMARK] = ACTIONS(5421),
    [anon_sym_TILDE] = ACTIONS(5555),
    [anon_sym_BANG] = ACTIONS(5423),
    [anon_sym_PLUS] = ACTIONS(5529),
    [anon_sym_DASH] = ACTIONS(5531),
    [anon_sym_LT_DASH] = ACTIONS(5557),
    [anon_sym_LT_LT_DASH] = ACTIONS(5557),
    [anon_sym_COLON_EQ] = ACTIONS(5557),
    [anon_sym_DASH_GT] = ACTIONS(5559),
    [anon_sym_DASH_GT_GT] = ACTIONS(5561),
    [anon_sym_PIPE] = ACTIONS(5545),
    [anon_sym_AMP] = ACTIONS(5547),
    [anon_sym_PIPE_PIPE] = ACTIONS(5549),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_LT] = ACTIONS(5533),
    [anon_sym_LT_EQ] = ACTIONS(5535),
    [anon_sym_GT] = ACTIONS(5533),
    [anon_sym_GT_EQ] = ACTIONS(5535),
    [anon_sym_EQ_EQ] = ACTIONS(5535),
    [anon_sym_BANG_EQ] = ACTIONS(5535),
    [anon_sym_STAR] = ACTIONS(5537),
    [anon_sym_SLASH] = ACTIONS(5539),
    [anon_sym_STAR_STAR] = ACTIONS(5519),
    [anon_sym_CARET] = ACTIONS(5519),
    [aux_sym_binary_operator_token1] = ACTIONS(5541),
    [anon_sym_PIPE_GT] = ACTIONS(5541),
    [anon_sym_COLON] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5521),
    [anon_sym_AT] = ACTIONS(5521),
    [aux_sym__hex_literal_token1] = ACTIONS(5421),
    [sym__number_literal] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5421),
    [anon_sym_DQUOTE] = ACTIONS(5421),
    [sym_return] = ACTIONS(5423),
    [sym_next] = ACTIONS(5423),
    [sym_break] = ACTIONS(5423),
    [sym_true] = ACTIONS(5423),
    [sym_false] = ACTIONS(5423),
    [sym_null] = ACTIONS(5423),
    [sym_inf] = ACTIONS(5423),
    [sym_nan] = ACTIONS(5423),
    [anon_sym_NA] = ACTIONS(5423),
    [anon_sym_NA_integer_] = ACTIONS(5423),
    [anon_sym_NA_real_] = ACTIONS(5423),
    [anon_sym_NA_complex_] = ACTIONS(5423),
    [anon_sym_NA_character_] = ACTIONS(5423),
    [sym_dots] = ACTIONS(5423),
    [sym_dot_dot_i] = ACTIONS(5421),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5421),
    [sym__newline] = ACTIONS(5421),
    [sym__semicolon] = ACTIONS(5421),
    [sym__raw_string_literal] = ACTIONS(5421),
    [sym__external_open_parenthesis] = ACTIONS(5523),
    [sym__external_close_parenthesis] = ACTIONS(5421),
    [sym__external_open_brace] = ACTIONS(5421),
    [sym__external_close_brace] = ACTIONS(5421),
    [sym__external_open_bracket] = ACTIONS(5525),
    [sym__external_open_bracket2] = ACTIONS(5527),
    [sym__external_close_bracket2] = ACTIONS(5421),
  },
  [760] = {
    [sym_call_arguments] = STATE(2401),
    [sym_subset_arguments] = STATE(2403),
    [sym_subset2_arguments] = STATE(2404),
    [sym__open_parenthesis] = STATE(1461),
    [sym__open_bracket] = STATE(1450),
    [sym__open_bracket2] = STATE(1447),
    [sym_identifier] = ACTIONS(5427),
    [anon_sym_BSLASH] = ACTIONS(5425),
    [anon_sym_function] = ACTIONS(5427),
    [anon_sym_EQ] = ACTIONS(5553),
    [anon_sym_if] = ACTIONS(5427),
    [anon_sym_for] = ACTIONS(5427),
    [anon_sym_while] = ACTIONS(5427),
    [anon_sym_repeat] = ACTIONS(5427),
    [anon_sym_QMARK] = ACTIONS(5425),
    [anon_sym_TILDE] = ACTIONS(5555),
    [anon_sym_BANG] = ACTIONS(5427),
    [anon_sym_PLUS] = ACTIONS(5529),
    [anon_sym_DASH] = ACTIONS(5531),
    [anon_sym_LT_DASH] = ACTIONS(5557),
    [anon_sym_LT_LT_DASH] = ACTIONS(5557),
    [anon_sym_COLON_EQ] = ACTIONS(5557),
    [anon_sym_DASH_GT] = ACTIONS(5559),
    [anon_sym_DASH_GT_GT] = ACTIONS(5561),
    [anon_sym_PIPE] = ACTIONS(5545),
    [anon_sym_AMP] = ACTIONS(5547),
    [anon_sym_PIPE_PIPE] = ACTIONS(5549),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_LT] = ACTIONS(5533),
    [anon_sym_LT_EQ] = ACTIONS(5535),
    [anon_sym_GT] = ACTIONS(5533),
    [anon_sym_GT_EQ] = ACTIONS(5535),
    [anon_sym_EQ_EQ] = ACTIONS(5535),
    [anon_sym_BANG_EQ] = ACTIONS(5535),
    [anon_sym_STAR] = ACTIONS(5537),
    [anon_sym_SLASH] = ACTIONS(5539),
    [anon_sym_STAR_STAR] = ACTIONS(5519),
    [anon_sym_CARET] = ACTIONS(5519),
    [aux_sym_binary_operator_token1] = ACTIONS(5541),
    [anon_sym_PIPE_GT] = ACTIONS(5541),
    [anon_sym_COLON] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5521),
    [anon_sym_AT] = ACTIONS(5521),
    [aux_sym__hex_literal_token1] = ACTIONS(5425),
    [sym__number_literal] = ACTIONS(5427),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_DQUOTE] = ACTIONS(5425),
    [sym_return] = ACTIONS(5427),
    [sym_next] = ACTIONS(5427),
    [sym_break] = ACTIONS(5427),
    [sym_true] = ACTIONS(5427),
    [sym_false] = ACTIONS(5427),
    [sym_null] = ACTIONS(5427),
    [sym_inf] = ACTIONS(5427),
    [sym_nan] = ACTIONS(5427),
    [anon_sym_NA] = ACTIONS(5427),
    [anon_sym_NA_integer_] = ACTIONS(5427),
    [anon_sym_NA_real_] = ACTIONS(5427),
    [anon_sym_NA_complex_] = ACTIONS(5427),
    [anon_sym_NA_character_] = ACTIONS(5427),
    [sym_dots] = ACTIONS(5427),
    [sym_dot_dot_i] = ACTIONS(5425),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5425),
    [sym__newline] = ACTIONS(5425),
    [sym__semicolon] = ACTIONS(5425),
    [sym__raw_string_literal] = ACTIONS(5425),
    [sym__external_open_parenthesis] = ACTIONS(5523),
    [sym__external_close_parenthesis] = ACTIONS(5425),
    [sym__external_open_brace] = ACTIONS(5425),
    [sym__external_close_brace] = ACTIONS(5425),
    [sym__external_open_bracket] = ACTIONS(5525),
    [sym__external_open_bracket2] = ACTIONS(5527),
    [sym__external_close_bracket2] = ACTIONS(5425),
  },
  [761] = {
    [sym_call_arguments] = STATE(2401),
    [sym_subset_arguments] = STATE(2403),
    [sym_subset2_arguments] = STATE(2404),
    [sym__open_parenthesis] = STATE(1461),
    [sym__open_bracket] = STATE(1450),
    [sym__open_bracket2] = STATE(1447),
    [sym_identifier] = ACTIONS(5431),
    [anon_sym_BSLASH] = ACTIONS(5429),
    [anon_sym_function] = ACTIONS(5431),
    [anon_sym_EQ] = ACTIONS(5553),
    [anon_sym_if] = ACTIONS(5431),
    [anon_sym_for] = ACTIONS(5431),
    [anon_sym_while] = ACTIONS(5431),
    [anon_sym_repeat] = ACTIONS(5431),
    [anon_sym_QMARK] = ACTIONS(5429),
    [anon_sym_TILDE] = ACTIONS(5555),
    [anon_sym_BANG] = ACTIONS(5431),
    [anon_sym_PLUS] = ACTIONS(5529),
    [anon_sym_DASH] = ACTIONS(5531),
    [anon_sym_LT_DASH] = ACTIONS(5557),
    [anon_sym_LT_LT_DASH] = ACTIONS(5557),
    [anon_sym_COLON_EQ] = ACTIONS(5557),
    [anon_sym_DASH_GT] = ACTIONS(5559),
    [anon_sym_DASH_GT_GT] = ACTIONS(5561),
    [anon_sym_PIPE] = ACTIONS(5545),
    [anon_sym_AMP] = ACTIONS(5547),
    [anon_sym_PIPE_PIPE] = ACTIONS(5549),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_LT] = ACTIONS(5533),
    [anon_sym_LT_EQ] = ACTIONS(5535),
    [anon_sym_GT] = ACTIONS(5533),
    [anon_sym_GT_EQ] = ACTIONS(5535),
    [anon_sym_EQ_EQ] = ACTIONS(5535),
    [anon_sym_BANG_EQ] = ACTIONS(5535),
    [anon_sym_STAR] = ACTIONS(5537),
    [anon_sym_SLASH] = ACTIONS(5539),
    [anon_sym_STAR_STAR] = ACTIONS(5519),
    [anon_sym_CARET] = ACTIONS(5519),
    [aux_sym_binary_operator_token1] = ACTIONS(5541),
    [anon_sym_PIPE_GT] = ACTIONS(5541),
    [anon_sym_COLON] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5521),
    [anon_sym_AT] = ACTIONS(5521),
    [aux_sym__hex_literal_token1] = ACTIONS(5429),
    [sym__number_literal] = ACTIONS(5431),
    [anon_sym_SQUOTE] = ACTIONS(5429),
    [anon_sym_DQUOTE] = ACTIONS(5429),
    [sym_return] = ACTIONS(5431),
    [sym_next] = ACTIONS(5431),
    [sym_break] = ACTIONS(5431),
    [sym_true] = ACTIONS(5431),
    [sym_false] = ACTIONS(5431),
    [sym_null] = ACTIONS(5431),
    [sym_inf] = ACTIONS(5431),
    [sym_nan] = ACTIONS(5431),
    [anon_sym_NA] = ACTIONS(5431),
    [anon_sym_NA_integer_] = ACTIONS(5431),
    [anon_sym_NA_real_] = ACTIONS(5431),
    [anon_sym_NA_complex_] = ACTIONS(5431),
    [anon_sym_NA_character_] = ACTIONS(5431),
    [sym_dots] = ACTIONS(5431),
    [sym_dot_dot_i] = ACTIONS(5429),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5429),
    [sym__newline] = ACTIONS(5429),
    [sym__semicolon] = ACTIONS(5429),
    [sym__raw_string_literal] = ACTIONS(5429),
    [sym__external_open_parenthesis] = ACTIONS(5523),
    [sym__external_close_parenthesis] = ACTIONS(5429),
    [sym__external_open_brace] = ACTIONS(5429),
    [sym__external_close_brace] = ACTIONS(5429),
    [sym__external_open_bracket] = ACTIONS(5525),
    [sym__external_open_bracket2] = ACTIONS(5527),
    [sym__external_close_bracket2] = ACTIONS(5429),
  },
  [762] = {
    [sym_call_arguments] = STATE(2401),
    [sym_subset_arguments] = STATE(2403),
    [sym_subset2_arguments] = STATE(2404),
    [sym__open_parenthesis] = STATE(1461),
    [sym__open_bracket] = STATE(1450),
    [sym__open_bracket2] = STATE(1447),
    [sym_identifier] = ACTIONS(5435),
    [anon_sym_BSLASH] = ACTIONS(5433),
    [anon_sym_function] = ACTIONS(5435),
    [anon_sym_EQ] = ACTIONS(5553),
    [anon_sym_if] = ACTIONS(5435),
    [anon_sym_for] = ACTIONS(5435),
    [anon_sym_while] = ACTIONS(5435),
    [anon_sym_repeat] = ACTIONS(5435),
    [anon_sym_QMARK] = ACTIONS(5433),
    [anon_sym_TILDE] = ACTIONS(5555),
    [anon_sym_BANG] = ACTIONS(5435),
    [anon_sym_PLUS] = ACTIONS(5529),
    [anon_sym_DASH] = ACTIONS(5531),
    [anon_sym_LT_DASH] = ACTIONS(5557),
    [anon_sym_LT_LT_DASH] = ACTIONS(5557),
    [anon_sym_COLON_EQ] = ACTIONS(5557),
    [anon_sym_DASH_GT] = ACTIONS(5559),
    [anon_sym_DASH_GT_GT] = ACTIONS(5561),
    [anon_sym_PIPE] = ACTIONS(5545),
    [anon_sym_AMP] = ACTIONS(5547),
    [anon_sym_PIPE_PIPE] = ACTIONS(5549),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_LT] = ACTIONS(5533),
    [anon_sym_LT_EQ] = ACTIONS(5535),
    [anon_sym_GT] = ACTIONS(5533),
    [anon_sym_GT_EQ] = ACTIONS(5535),
    [anon_sym_EQ_EQ] = ACTIONS(5535),
    [anon_sym_BANG_EQ] = ACTIONS(5535),
    [anon_sym_STAR] = ACTIONS(5537),
    [anon_sym_SLASH] = ACTIONS(5539),
    [anon_sym_STAR_STAR] = ACTIONS(5519),
    [anon_sym_CARET] = ACTIONS(5519),
    [aux_sym_binary_operator_token1] = ACTIONS(5541),
    [anon_sym_PIPE_GT] = ACTIONS(5541),
    [anon_sym_COLON] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5521),
    [anon_sym_AT] = ACTIONS(5521),
    [aux_sym__hex_literal_token1] = ACTIONS(5433),
    [sym__number_literal] = ACTIONS(5435),
    [anon_sym_SQUOTE] = ACTIONS(5433),
    [anon_sym_DQUOTE] = ACTIONS(5433),
    [sym_return] = ACTIONS(5435),
    [sym_next] = ACTIONS(5435),
    [sym_break] = ACTIONS(5435),
    [sym_true] = ACTIONS(5435),
    [sym_false] = ACTIONS(5435),
    [sym_null] = ACTIONS(5435),
    [sym_inf] = ACTIONS(5435),
    [sym_nan] = ACTIONS(5435),
    [anon_sym_NA] = ACTIONS(5435),
    [anon_sym_NA_integer_] = ACTIONS(5435),
    [anon_sym_NA_real_] = ACTIONS(5435),
    [anon_sym_NA_complex_] = ACTIONS(5435),
    [anon_sym_NA_character_] = ACTIONS(5435),
    [sym_dots] = ACTIONS(5435),
    [sym_dot_dot_i] = ACTIONS(5433),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5433),
    [sym__newline] = ACTIONS(5433),
    [sym__semicolon] = ACTIONS(5433),
    [sym__raw_string_literal] = ACTIONS(5433),
    [sym__external_open_parenthesis] = ACTIONS(5523),
    [sym__external_close_parenthesis] = ACTIONS(5433),
    [sym__external_open_brace] = ACTIONS(5433),
    [sym__external_close_brace] = ACTIONS(5433),
    [sym__external_open_bracket] = ACTIONS(5525),
    [sym__external_open_bracket2] = ACTIONS(5527),
    [sym__external_close_bracket2] = ACTIONS(5433),
  },
  [763] = {
    [sym_call_arguments] = STATE(2401),
    [sym_subset_arguments] = STATE(2403),
    [sym_subset2_arguments] = STATE(2404),
    [sym__open_parenthesis] = STATE(1461),
    [sym__open_bracket] = STATE(1450),
    [sym__open_bracket2] = STATE(1447),
    [sym_identifier] = ACTIONS(5439),
    [anon_sym_BSLASH] = ACTIONS(5437),
    [anon_sym_function] = ACTIONS(5439),
    [anon_sym_EQ] = ACTIONS(5553),
    [anon_sym_if] = ACTIONS(5439),
    [anon_sym_for] = ACTIONS(5439),
    [anon_sym_while] = ACTIONS(5439),
    [anon_sym_repeat] = ACTIONS(5439),
    [anon_sym_QMARK] = ACTIONS(5437),
    [anon_sym_TILDE] = ACTIONS(5555),
    [anon_sym_BANG] = ACTIONS(5439),
    [anon_sym_PLUS] = ACTIONS(5529),
    [anon_sym_DASH] = ACTIONS(5531),
    [anon_sym_LT_DASH] = ACTIONS(5557),
    [anon_sym_LT_LT_DASH] = ACTIONS(5557),
    [anon_sym_COLON_EQ] = ACTIONS(5557),
    [anon_sym_DASH_GT] = ACTIONS(5559),
    [anon_sym_DASH_GT_GT] = ACTIONS(5561),
    [anon_sym_PIPE] = ACTIONS(5545),
    [anon_sym_AMP] = ACTIONS(5547),
    [anon_sym_PIPE_PIPE] = ACTIONS(5549),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_LT] = ACTIONS(5533),
    [anon_sym_LT_EQ] = ACTIONS(5535),
    [anon_sym_GT] = ACTIONS(5533),
    [anon_sym_GT_EQ] = ACTIONS(5535),
    [anon_sym_EQ_EQ] = ACTIONS(5535),
    [anon_sym_BANG_EQ] = ACTIONS(5535),
    [anon_sym_STAR] = ACTIONS(5537),
    [anon_sym_SLASH] = ACTIONS(5539),
    [anon_sym_STAR_STAR] = ACTIONS(5519),
    [anon_sym_CARET] = ACTIONS(5519),
    [aux_sym_binary_operator_token1] = ACTIONS(5541),
    [anon_sym_PIPE_GT] = ACTIONS(5541),
    [anon_sym_COLON] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5521),
    [anon_sym_AT] = ACTIONS(5521),
    [aux_sym__hex_literal_token1] = ACTIONS(5437),
    [sym__number_literal] = ACTIONS(5439),
    [anon_sym_SQUOTE] = ACTIONS(5437),
    [anon_sym_DQUOTE] = ACTIONS(5437),
    [sym_return] = ACTIONS(5439),
    [sym_next] = ACTIONS(5439),
    [sym_break] = ACTIONS(5439),
    [sym_true] = ACTIONS(5439),
    [sym_false] = ACTIONS(5439),
    [sym_null] = ACTIONS(5439),
    [sym_inf] = ACTIONS(5439),
    [sym_nan] = ACTIONS(5439),
    [anon_sym_NA] = ACTIONS(5439),
    [anon_sym_NA_integer_] = ACTIONS(5439),
    [anon_sym_NA_real_] = ACTIONS(5439),
    [anon_sym_NA_complex_] = ACTIONS(5439),
    [anon_sym_NA_character_] = ACTIONS(5439),
    [sym_dots] = ACTIONS(5439),
    [sym_dot_dot_i] = ACTIONS(5437),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5437),
    [sym__newline] = ACTIONS(5437),
    [sym__semicolon] = ACTIONS(5437),
    [sym__raw_string_literal] = ACTIONS(5437),
    [sym__external_open_parenthesis] = ACTIONS(5523),
    [sym__external_close_parenthesis] = ACTIONS(5437),
    [sym__external_open_brace] = ACTIONS(5437),
    [sym__external_close_brace] = ACTIONS(5437),
    [sym__external_open_bracket] = ACTIONS(5525),
    [sym__external_open_bracket2] = ACTIONS(5527),
    [sym__external_close_bracket2] = ACTIONS(5437),
  },
  [764] = {
    [sym_call_arguments] = STATE(2401),
    [sym_subset_arguments] = STATE(2403),
    [sym_subset2_arguments] = STATE(2404),
    [sym__open_parenthesis] = STATE(1461),
    [sym__open_bracket] = STATE(1450),
    [sym__open_bracket2] = STATE(1447),
    [sym_identifier] = ACTIONS(5443),
    [anon_sym_BSLASH] = ACTIONS(5441),
    [anon_sym_function] = ACTIONS(5443),
    [anon_sym_EQ] = ACTIONS(5553),
    [anon_sym_if] = ACTIONS(5443),
    [anon_sym_for] = ACTIONS(5443),
    [anon_sym_while] = ACTIONS(5443),
    [anon_sym_repeat] = ACTIONS(5443),
    [anon_sym_QMARK] = ACTIONS(5441),
    [anon_sym_TILDE] = ACTIONS(5555),
    [anon_sym_BANG] = ACTIONS(5443),
    [anon_sym_PLUS] = ACTIONS(5529),
    [anon_sym_DASH] = ACTIONS(5531),
    [anon_sym_LT_DASH] = ACTIONS(5557),
    [anon_sym_LT_LT_DASH] = ACTIONS(5557),
    [anon_sym_COLON_EQ] = ACTIONS(5557),
    [anon_sym_DASH_GT] = ACTIONS(5559),
    [anon_sym_DASH_GT_GT] = ACTIONS(5561),
    [anon_sym_PIPE] = ACTIONS(5545),
    [anon_sym_AMP] = ACTIONS(5547),
    [anon_sym_PIPE_PIPE] = ACTIONS(5549),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_LT] = ACTIONS(5533),
    [anon_sym_LT_EQ] = ACTIONS(5535),
    [anon_sym_GT] = ACTIONS(5533),
    [anon_sym_GT_EQ] = ACTIONS(5535),
    [anon_sym_EQ_EQ] = ACTIONS(5535),
    [anon_sym_BANG_EQ] = ACTIONS(5535),
    [anon_sym_STAR] = ACTIONS(5537),
    [anon_sym_SLASH] = ACTIONS(5539),
    [anon_sym_STAR_STAR] = ACTIONS(5519),
    [anon_sym_CARET] = ACTIONS(5519),
    [aux_sym_binary_operator_token1] = ACTIONS(5541),
    [anon_sym_PIPE_GT] = ACTIONS(5541),
    [anon_sym_COLON] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5521),
    [anon_sym_AT] = ACTIONS(5521),
    [aux_sym__hex_literal_token1] = ACTIONS(5441),
    [sym__number_literal] = ACTIONS(5443),
    [anon_sym_SQUOTE] = ACTIONS(5441),
    [anon_sym_DQUOTE] = ACTIONS(5441),
    [sym_return] = ACTIONS(5443),
    [sym_next] = ACTIONS(5443),
    [sym_break] = ACTIONS(5443),
    [sym_true] = ACTIONS(5443),
    [sym_false] = ACTIONS(5443),
    [sym_null] = ACTIONS(5443),
    [sym_inf] = ACTIONS(5443),
    [sym_nan] = ACTIONS(5443),
    [anon_sym_NA] = ACTIONS(5443),
    [anon_sym_NA_integer_] = ACTIONS(5443),
    [anon_sym_NA_real_] = ACTIONS(5443),
    [anon_sym_NA_complex_] = ACTIONS(5443),
    [anon_sym_NA_character_] = ACTIONS(5443),
    [sym_dots] = ACTIONS(5443),
    [sym_dot_dot_i] = ACTIONS(5441),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5441),
    [sym__newline] = ACTIONS(5441),
    [sym__semicolon] = ACTIONS(5441),
    [sym__raw_string_literal] = ACTIONS(5441),
    [sym__external_open_parenthesis] = ACTIONS(5523),
    [sym__external_close_parenthesis] = ACTIONS(5441),
    [sym__external_open_brace] = ACTIONS(5441),
    [sym__external_close_brace] = ACTIONS(5441),
    [sym__external_open_bracket] = ACTIONS(5525),
    [sym__external_open_bracket2] = ACTIONS(5527),
    [sym__external_close_bracket2] = ACTIONS(5441),
  },
  [765] = {
    [sym_call_arguments] = STATE(2401),
    [sym_subset_arguments] = STATE(2403),
    [sym_subset2_arguments] = STATE(2404),
    [sym__open_parenthesis] = STATE(1461),
    [sym__open_bracket] = STATE(1450),
    [sym__open_bracket2] = STATE(1447),
    [sym_identifier] = ACTIONS(5447),
    [anon_sym_BSLASH] = ACTIONS(5445),
    [anon_sym_function] = ACTIONS(5447),
    [anon_sym_EQ] = ACTIONS(5553),
    [anon_sym_if] = ACTIONS(5447),
    [anon_sym_for] = ACTIONS(5447),
    [anon_sym_while] = ACTIONS(5447),
    [anon_sym_repeat] = ACTIONS(5447),
    [anon_sym_QMARK] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(5555),
    [anon_sym_BANG] = ACTIONS(5447),
    [anon_sym_PLUS] = ACTIONS(5529),
    [anon_sym_DASH] = ACTIONS(5531),
    [anon_sym_LT_DASH] = ACTIONS(5557),
    [anon_sym_LT_LT_DASH] = ACTIONS(5557),
    [anon_sym_COLON_EQ] = ACTIONS(5557),
    [anon_sym_DASH_GT] = ACTIONS(5559),
    [anon_sym_DASH_GT_GT] = ACTIONS(5561),
    [anon_sym_PIPE] = ACTIONS(5545),
    [anon_sym_AMP] = ACTIONS(5547),
    [anon_sym_PIPE_PIPE] = ACTIONS(5549),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_LT] = ACTIONS(5533),
    [anon_sym_LT_EQ] = ACTIONS(5535),
    [anon_sym_GT] = ACTIONS(5533),
    [anon_sym_GT_EQ] = ACTIONS(5535),
    [anon_sym_EQ_EQ] = ACTIONS(5535),
    [anon_sym_BANG_EQ] = ACTIONS(5535),
    [anon_sym_STAR] = ACTIONS(5537),
    [anon_sym_SLASH] = ACTIONS(5539),
    [anon_sym_STAR_STAR] = ACTIONS(5519),
    [anon_sym_CARET] = ACTIONS(5519),
    [aux_sym_binary_operator_token1] = ACTIONS(5541),
    [anon_sym_PIPE_GT] = ACTIONS(5541),
    [anon_sym_COLON] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5521),
    [anon_sym_AT] = ACTIONS(5521),
    [aux_sym__hex_literal_token1] = ACTIONS(5445),
    [sym__number_literal] = ACTIONS(5447),
    [anon_sym_SQUOTE] = ACTIONS(5445),
    [anon_sym_DQUOTE] = ACTIONS(5445),
    [sym_return] = ACTIONS(5447),
    [sym_next] = ACTIONS(5447),
    [sym_break] = ACTIONS(5447),
    [sym_true] = ACTIONS(5447),
    [sym_false] = ACTIONS(5447),
    [sym_null] = ACTIONS(5447),
    [sym_inf] = ACTIONS(5447),
    [sym_nan] = ACTIONS(5447),
    [anon_sym_NA] = ACTIONS(5447),
    [anon_sym_NA_integer_] = ACTIONS(5447),
    [anon_sym_NA_real_] = ACTIONS(5447),
    [anon_sym_NA_complex_] = ACTIONS(5447),
    [anon_sym_NA_character_] = ACTIONS(5447),
    [sym_dots] = ACTIONS(5447),
    [sym_dot_dot_i] = ACTIONS(5445),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5445),
    [sym__newline] = ACTIONS(5445),
    [sym__semicolon] = ACTIONS(5445),
    [sym__raw_string_literal] = ACTIONS(5445),
    [sym__external_open_parenthesis] = ACTIONS(5523),
    [sym__external_close_parenthesis] = ACTIONS(5445),
    [sym__external_open_brace] = ACTIONS(5445),
    [sym__external_close_brace] = ACTIONS(5445),
    [sym__external_open_bracket] = ACTIONS(5525),
    [sym__external_open_bracket2] = ACTIONS(5527),
    [sym__external_close_bracket2] = ACTIONS(5445),
  },
  [766] = {
    [sym_call_arguments] = STATE(2401),
    [sym_subset_arguments] = STATE(2403),
    [sym_subset2_arguments] = STATE(2404),
    [sym__open_parenthesis] = STATE(1461),
    [sym__open_bracket] = STATE(1450),
    [sym__open_bracket2] = STATE(1447),
    [sym_identifier] = ACTIONS(5451),
    [anon_sym_BSLASH] = ACTIONS(5449),
    [anon_sym_function] = ACTIONS(5451),
    [anon_sym_EQ] = ACTIONS(5553),
    [anon_sym_if] = ACTIONS(5451),
    [anon_sym_for] = ACTIONS(5451),
    [anon_sym_while] = ACTIONS(5451),
    [anon_sym_repeat] = ACTIONS(5451),
    [anon_sym_QMARK] = ACTIONS(5449),
    [anon_sym_TILDE] = ACTIONS(5555),
    [anon_sym_BANG] = ACTIONS(5451),
    [anon_sym_PLUS] = ACTIONS(5529),
    [anon_sym_DASH] = ACTIONS(5531),
    [anon_sym_LT_DASH] = ACTIONS(5557),
    [anon_sym_LT_LT_DASH] = ACTIONS(5557),
    [anon_sym_COLON_EQ] = ACTIONS(5557),
    [anon_sym_DASH_GT] = ACTIONS(5559),
    [anon_sym_DASH_GT_GT] = ACTIONS(5561),
    [anon_sym_PIPE] = ACTIONS(5545),
    [anon_sym_AMP] = ACTIONS(5547),
    [anon_sym_PIPE_PIPE] = ACTIONS(5549),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_LT] = ACTIONS(5533),
    [anon_sym_LT_EQ] = ACTIONS(5535),
    [anon_sym_GT] = ACTIONS(5533),
    [anon_sym_GT_EQ] = ACTIONS(5535),
    [anon_sym_EQ_EQ] = ACTIONS(5535),
    [anon_sym_BANG_EQ] = ACTIONS(5535),
    [anon_sym_STAR] = ACTIONS(5537),
    [anon_sym_SLASH] = ACTIONS(5539),
    [anon_sym_STAR_STAR] = ACTIONS(5519),
    [anon_sym_CARET] = ACTIONS(5519),
    [aux_sym_binary_operator_token1] = ACTIONS(5541),
    [anon_sym_PIPE_GT] = ACTIONS(5541),
    [anon_sym_COLON] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5521),
    [anon_sym_AT] = ACTIONS(5521),
    [aux_sym__hex_literal_token1] = ACTIONS(5449),
    [sym__number_literal] = ACTIONS(5451),
    [anon_sym_SQUOTE] = ACTIONS(5449),
    [anon_sym_DQUOTE] = ACTIONS(5449),
    [sym_return] = ACTIONS(5451),
    [sym_next] = ACTIONS(5451),
    [sym_break] = ACTIONS(5451),
    [sym_true] = ACTIONS(5451),
    [sym_false] = ACTIONS(5451),
    [sym_null] = ACTIONS(5451),
    [sym_inf] = ACTIONS(5451),
    [sym_nan] = ACTIONS(5451),
    [anon_sym_NA] = ACTIONS(5451),
    [anon_sym_NA_integer_] = ACTIONS(5451),
    [anon_sym_NA_real_] = ACTIONS(5451),
    [anon_sym_NA_complex_] = ACTIONS(5451),
    [anon_sym_NA_character_] = ACTIONS(5451),
    [sym_dots] = ACTIONS(5451),
    [sym_dot_dot_i] = ACTIONS(5449),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5449),
    [sym__newline] = ACTIONS(5449),
    [sym__semicolon] = ACTIONS(5449),
    [sym__raw_string_literal] = ACTIONS(5449),
    [sym__external_open_parenthesis] = ACTIONS(5523),
    [sym__external_close_parenthesis] = ACTIONS(5449),
    [sym__external_open_brace] = ACTIONS(5449),
    [sym__external_close_brace] = ACTIONS(5449),
    [sym__external_open_bracket] = ACTIONS(5525),
    [sym__external_open_bracket2] = ACTIONS(5527),
    [sym__external_close_bracket2] = ACTIONS(5449),
  },
  [767] = {
    [sym_call_arguments] = STATE(2401),
    [sym_subset_arguments] = STATE(2403),
    [sym_subset2_arguments] = STATE(2404),
    [sym__open_parenthesis] = STATE(1461),
    [sym__open_bracket] = STATE(1450),
    [sym__open_bracket2] = STATE(1447),
    [sym_identifier] = ACTIONS(5455),
    [anon_sym_BSLASH] = ACTIONS(5453),
    [anon_sym_function] = ACTIONS(5455),
    [anon_sym_EQ] = ACTIONS(5553),
    [anon_sym_if] = ACTIONS(5455),
    [anon_sym_for] = ACTIONS(5455),
    [anon_sym_while] = ACTIONS(5455),
    [anon_sym_repeat] = ACTIONS(5455),
    [anon_sym_QMARK] = ACTIONS(5453),
    [anon_sym_TILDE] = ACTIONS(5555),
    [anon_sym_BANG] = ACTIONS(5455),
    [anon_sym_PLUS] = ACTIONS(5529),
    [anon_sym_DASH] = ACTIONS(5531),
    [anon_sym_LT_DASH] = ACTIONS(5557),
    [anon_sym_LT_LT_DASH] = ACTIONS(5557),
    [anon_sym_COLON_EQ] = ACTIONS(5557),
    [anon_sym_DASH_GT] = ACTIONS(5559),
    [anon_sym_DASH_GT_GT] = ACTIONS(5561),
    [anon_sym_PIPE] = ACTIONS(5545),
    [anon_sym_AMP] = ACTIONS(5547),
    [anon_sym_PIPE_PIPE] = ACTIONS(5549),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_LT] = ACTIONS(5533),
    [anon_sym_LT_EQ] = ACTIONS(5535),
    [anon_sym_GT] = ACTIONS(5533),
    [anon_sym_GT_EQ] = ACTIONS(5535),
    [anon_sym_EQ_EQ] = ACTIONS(5535),
    [anon_sym_BANG_EQ] = ACTIONS(5535),
    [anon_sym_STAR] = ACTIONS(5537),
    [anon_sym_SLASH] = ACTIONS(5539),
    [anon_sym_STAR_STAR] = ACTIONS(5519),
    [anon_sym_CARET] = ACTIONS(5519),
    [aux_sym_binary_operator_token1] = ACTIONS(5541),
    [anon_sym_PIPE_GT] = ACTIONS(5541),
    [anon_sym_COLON] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5521),
    [anon_sym_AT] = ACTIONS(5521),
    [aux_sym__hex_literal_token1] = ACTIONS(5453),
    [sym__number_literal] = ACTIONS(5455),
    [anon_sym_SQUOTE] = ACTIONS(5453),
    [anon_sym_DQUOTE] = ACTIONS(5453),
    [sym_return] = ACTIONS(5455),
    [sym_next] = ACTIONS(5455),
    [sym_break] = ACTIONS(5455),
    [sym_true] = ACTIONS(5455),
    [sym_false] = ACTIONS(5455),
    [sym_null] = ACTIONS(5455),
    [sym_inf] = ACTIONS(5455),
    [sym_nan] = ACTIONS(5455),
    [anon_sym_NA] = ACTIONS(5455),
    [anon_sym_NA_integer_] = ACTIONS(5455),
    [anon_sym_NA_real_] = ACTIONS(5455),
    [anon_sym_NA_complex_] = ACTIONS(5455),
    [anon_sym_NA_character_] = ACTIONS(5455),
    [sym_dots] = ACTIONS(5455),
    [sym_dot_dot_i] = ACTIONS(5453),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5453),
    [sym__newline] = ACTIONS(5453),
    [sym__semicolon] = ACTIONS(5453),
    [sym__raw_string_literal] = ACTIONS(5453),
    [sym__external_open_parenthesis] = ACTIONS(5523),
    [sym__external_close_parenthesis] = ACTIONS(5453),
    [sym__external_open_brace] = ACTIONS(5453),
    [sym__external_close_brace] = ACTIONS(5453),
    [sym__external_open_bracket] = ACTIONS(5525),
    [sym__external_open_bracket2] = ACTIONS(5527),
    [sym__external_close_bracket2] = ACTIONS(5453),
  },
  [768] = {
    [sym_call_arguments] = STATE(2401),
    [sym_subset_arguments] = STATE(2403),
    [sym_subset2_arguments] = STATE(2404),
    [sym__open_parenthesis] = STATE(1461),
    [sym__open_bracket] = STATE(1450),
    [sym__open_bracket2] = STATE(1447),
    [sym_identifier] = ACTIONS(5411),
    [anon_sym_BSLASH] = ACTIONS(5409),
    [anon_sym_function] = ACTIONS(5411),
    [anon_sym_EQ] = ACTIONS(5553),
    [anon_sym_if] = ACTIONS(5411),
    [anon_sym_for] = ACTIONS(5411),
    [anon_sym_while] = ACTIONS(5411),
    [anon_sym_repeat] = ACTIONS(5411),
    [anon_sym_QMARK] = ACTIONS(5409),
    [anon_sym_TILDE] = ACTIONS(5555),
    [anon_sym_BANG] = ACTIONS(5411),
    [anon_sym_PLUS] = ACTIONS(5529),
    [anon_sym_DASH] = ACTIONS(5531),
    [anon_sym_LT_DASH] = ACTIONS(5557),
    [anon_sym_LT_LT_DASH] = ACTIONS(5557),
    [anon_sym_COLON_EQ] = ACTIONS(5557),
    [anon_sym_DASH_GT] = ACTIONS(5559),
    [anon_sym_DASH_GT_GT] = ACTIONS(5561),
    [anon_sym_PIPE] = ACTIONS(5545),
    [anon_sym_AMP] = ACTIONS(5547),
    [anon_sym_PIPE_PIPE] = ACTIONS(5549),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_LT] = ACTIONS(5533),
    [anon_sym_LT_EQ] = ACTIONS(5535),
    [anon_sym_GT] = ACTIONS(5533),
    [anon_sym_GT_EQ] = ACTIONS(5535),
    [anon_sym_EQ_EQ] = ACTIONS(5535),
    [anon_sym_BANG_EQ] = ACTIONS(5535),
    [anon_sym_STAR] = ACTIONS(5537),
    [anon_sym_SLASH] = ACTIONS(5539),
    [anon_sym_STAR_STAR] = ACTIONS(5519),
    [anon_sym_CARET] = ACTIONS(5519),
    [aux_sym_binary_operator_token1] = ACTIONS(5541),
    [anon_sym_PIPE_GT] = ACTIONS(5541),
    [anon_sym_COLON] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5521),
    [anon_sym_AT] = ACTIONS(5521),
    [aux_sym__hex_literal_token1] = ACTIONS(5409),
    [sym__number_literal] = ACTIONS(5411),
    [anon_sym_SQUOTE] = ACTIONS(5409),
    [anon_sym_DQUOTE] = ACTIONS(5409),
    [sym_return] = ACTIONS(5411),
    [sym_next] = ACTIONS(5411),
    [sym_break] = ACTIONS(5411),
    [sym_true] = ACTIONS(5411),
    [sym_false] = ACTIONS(5411),
    [sym_null] = ACTIONS(5411),
    [sym_inf] = ACTIONS(5411),
    [sym_nan] = ACTIONS(5411),
    [anon_sym_NA] = ACTIONS(5411),
    [anon_sym_NA_integer_] = ACTIONS(5411),
    [anon_sym_NA_real_] = ACTIONS(5411),
    [anon_sym_NA_complex_] = ACTIONS(5411),
    [anon_sym_NA_character_] = ACTIONS(5411),
    [sym_dots] = ACTIONS(5411),
    [sym_dot_dot_i] = ACTIONS(5409),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5409),
    [sym__newline] = ACTIONS(5409),
    [sym__semicolon] = ACTIONS(5409),
    [sym__raw_string_literal] = ACTIONS(5409),
    [sym__external_open_parenthesis] = ACTIONS(5523),
    [sym__external_close_parenthesis] = ACTIONS(5409),
    [sym__external_open_brace] = ACTIONS(5409),
    [sym__external_close_brace] = ACTIONS(5409),
    [sym__external_open_bracket] = ACTIONS(5525),
    [sym__external_open_bracket2] = ACTIONS(5527),
    [sym__external_close_bracket2] = ACTIONS(5409),
  },
  [769] = {
    [sym_call_arguments] = STATE(2380),
    [sym_subset_arguments] = STATE(2385),
    [sym_subset2_arguments] = STATE(2388),
    [sym__open_parenthesis] = STATE(1496),
    [sym__open_bracket] = STATE(1494),
    [sym__open_bracket2] = STATE(1490),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(5333),
    [anon_sym_DASH] = ACTIONS(5335),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5335),
    [anon_sym_AMP] = ACTIONS(5335),
    [anon_sym_PIPE_PIPE] = ACTIONS(5333),
    [anon_sym_AMP_AMP] = ACTIONS(5333),
    [anon_sym_LT] = ACTIONS(5335),
    [anon_sym_LT_EQ] = ACTIONS(5333),
    [anon_sym_GT] = ACTIONS(5335),
    [anon_sym_GT_EQ] = ACTIONS(5333),
    [anon_sym_EQ_EQ] = ACTIONS(5333),
    [anon_sym_BANG_EQ] = ACTIONS(5333),
    [anon_sym_STAR] = ACTIONS(5335),
    [anon_sym_SLASH] = ACTIONS(5333),
    [anon_sym_STAR_STAR] = ACTIONS(5593),
    [anon_sym_CARET] = ACTIONS(5593),
    [aux_sym_binary_operator_token1] = ACTIONS(5333),
    [anon_sym_PIPE_GT] = ACTIONS(5333),
    [anon_sym_COLON] = ACTIONS(5335),
    [anon_sym_DOLLAR] = ACTIONS(5599),
    [anon_sym_AT] = ACTIONS(5599),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__semicolon] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(5601),
    [sym__external_close_parenthesis] = ACTIONS(5333),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_close_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(5603),
    [sym__external_close_bracket] = ACTIONS(5333),
    [sym__external_open_bracket2] = ACTIONS(5605),
  },
  [770] = {
    [sym_call_arguments] = STATE(2380),
    [sym_subset_arguments] = STATE(2385),
    [sym_subset2_arguments] = STATE(2388),
    [sym__open_parenthesis] = STATE(1496),
    [sym__open_bracket] = STATE(1494),
    [sym__open_bracket2] = STATE(1490),
    [sym_identifier] = ACTIONS(5325),
    [anon_sym_BSLASH] = ACTIONS(5327),
    [anon_sym_function] = ACTIONS(5325),
    [anon_sym_EQ] = ACTIONS(5563),
    [anon_sym_if] = ACTIONS(5325),
    [anon_sym_for] = ACTIONS(5325),
    [anon_sym_while] = ACTIONS(5325),
    [anon_sym_repeat] = ACTIONS(5325),
    [anon_sym_QMARK] = ACTIONS(5607),
    [anon_sym_TILDE] = ACTIONS(5565),
    [anon_sym_BANG] = ACTIONS(5325),
    [anon_sym_PLUS] = ACTIONS(5567),
    [anon_sym_DASH] = ACTIONS(5569),
    [anon_sym_LT_DASH] = ACTIONS(5571),
    [anon_sym_LT_LT_DASH] = ACTIONS(5571),
    [anon_sym_COLON_EQ] = ACTIONS(5571),
    [anon_sym_DASH_GT] = ACTIONS(5573),
    [anon_sym_DASH_GT_GT] = ACTIONS(5575),
    [anon_sym_PIPE] = ACTIONS(5577),
    [anon_sym_AMP] = ACTIONS(5579),
    [anon_sym_PIPE_PIPE] = ACTIONS(5581),
    [anon_sym_AMP_AMP] = ACTIONS(5583),
    [anon_sym_LT] = ACTIONS(5585),
    [anon_sym_LT_EQ] = ACTIONS(5587),
    [anon_sym_GT] = ACTIONS(5585),
    [anon_sym_GT_EQ] = ACTIONS(5587),
    [anon_sym_EQ_EQ] = ACTIONS(5587),
    [anon_sym_BANG_EQ] = ACTIONS(5587),
    [anon_sym_STAR] = ACTIONS(5589),
    [anon_sym_SLASH] = ACTIONS(5591),
    [anon_sym_STAR_STAR] = ACTIONS(5593),
    [anon_sym_CARET] = ACTIONS(5593),
    [aux_sym_binary_operator_token1] = ACTIONS(5595),
    [anon_sym_PIPE_GT] = ACTIONS(5595),
    [anon_sym_COLON] = ACTIONS(5597),
    [anon_sym_DOLLAR] = ACTIONS(5599),
    [anon_sym_AT] = ACTIONS(5599),
    [aux_sym__hex_literal_token1] = ACTIONS(5327),
    [sym__number_literal] = ACTIONS(5325),
    [anon_sym_SQUOTE] = ACTIONS(5327),
    [anon_sym_DQUOTE] = ACTIONS(5327),
    [sym_return] = ACTIONS(5325),
    [sym_next] = ACTIONS(5325),
    [sym_break] = ACTIONS(5325),
    [sym_true] = ACTIONS(5325),
    [sym_false] = ACTIONS(5325),
    [sym_null] = ACTIONS(5325),
    [sym_inf] = ACTIONS(5325),
    [sym_nan] = ACTIONS(5325),
    [anon_sym_NA] = ACTIONS(5325),
    [anon_sym_NA_integer_] = ACTIONS(5325),
    [anon_sym_NA_real_] = ACTIONS(5325),
    [anon_sym_NA_complex_] = ACTIONS(5325),
    [anon_sym_NA_character_] = ACTIONS(5325),
    [sym_dots] = ACTIONS(5325),
    [sym_dot_dot_i] = ACTIONS(5327),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5327),
    [sym__newline] = ACTIONS(5327),
    [sym__semicolon] = ACTIONS(5327),
    [sym__raw_string_literal] = ACTIONS(5327),
    [sym__external_open_parenthesis] = ACTIONS(5601),
    [sym__external_close_parenthesis] = ACTIONS(5327),
    [sym__external_open_brace] = ACTIONS(5327),
    [sym__external_close_brace] = ACTIONS(5327),
    [sym__external_open_bracket] = ACTIONS(5603),
    [sym__external_close_bracket] = ACTIONS(5327),
    [sym__external_open_bracket2] = ACTIONS(5605),
  },
  [771] = {
    [sym_call_arguments] = STATE(2380),
    [sym_subset_arguments] = STATE(2385),
    [sym_subset2_arguments] = STATE(2388),
    [sym__open_parenthesis] = STATE(1496),
    [sym__open_bracket] = STATE(1494),
    [sym__open_bracket2] = STATE(1490),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(5567),
    [anon_sym_DASH] = ACTIONS(5569),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5335),
    [anon_sym_AMP] = ACTIONS(5335),
    [anon_sym_PIPE_PIPE] = ACTIONS(5333),
    [anon_sym_AMP_AMP] = ACTIONS(5333),
    [anon_sym_LT] = ACTIONS(5585),
    [anon_sym_LT_EQ] = ACTIONS(5587),
    [anon_sym_GT] = ACTIONS(5585),
    [anon_sym_GT_EQ] = ACTIONS(5587),
    [anon_sym_EQ_EQ] = ACTIONS(5587),
    [anon_sym_BANG_EQ] = ACTIONS(5587),
    [anon_sym_STAR] = ACTIONS(5589),
    [anon_sym_SLASH] = ACTIONS(5591),
    [anon_sym_STAR_STAR] = ACTIONS(5593),
    [anon_sym_CARET] = ACTIONS(5593),
    [aux_sym_binary_operator_token1] = ACTIONS(5595),
    [anon_sym_PIPE_GT] = ACTIONS(5595),
    [anon_sym_COLON] = ACTIONS(5597),
    [anon_sym_DOLLAR] = ACTIONS(5599),
    [anon_sym_AT] = ACTIONS(5599),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__semicolon] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(5601),
    [sym__external_close_parenthesis] = ACTIONS(5333),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_close_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(5603),
    [sym__external_close_bracket] = ACTIONS(5333),
    [sym__external_open_bracket2] = ACTIONS(5605),
  },
  [772] = {
    [sym_call_arguments] = STATE(2380),
    [sym_subset_arguments] = STATE(2385),
    [sym_subset2_arguments] = STATE(2388),
    [sym__open_parenthesis] = STATE(1496),
    [sym__open_bracket] = STATE(1494),
    [sym__open_bracket2] = STATE(1490),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(5567),
    [anon_sym_DASH] = ACTIONS(5569),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5577),
    [anon_sym_AMP] = ACTIONS(5579),
    [anon_sym_PIPE_PIPE] = ACTIONS(5581),
    [anon_sym_AMP_AMP] = ACTIONS(5583),
    [anon_sym_LT] = ACTIONS(5585),
    [anon_sym_LT_EQ] = ACTIONS(5587),
    [anon_sym_GT] = ACTIONS(5585),
    [anon_sym_GT_EQ] = ACTIONS(5587),
    [anon_sym_EQ_EQ] = ACTIONS(5587),
    [anon_sym_BANG_EQ] = ACTIONS(5587),
    [anon_sym_STAR] = ACTIONS(5589),
    [anon_sym_SLASH] = ACTIONS(5591),
    [anon_sym_STAR_STAR] = ACTIONS(5593),
    [anon_sym_CARET] = ACTIONS(5593),
    [aux_sym_binary_operator_token1] = ACTIONS(5595),
    [anon_sym_PIPE_GT] = ACTIONS(5595),
    [anon_sym_COLON] = ACTIONS(5597),
    [anon_sym_DOLLAR] = ACTIONS(5599),
    [anon_sym_AT] = ACTIONS(5599),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__semicolon] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(5601),
    [sym__external_close_parenthesis] = ACTIONS(5333),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_close_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(5603),
    [sym__external_close_bracket] = ACTIONS(5333),
    [sym__external_open_bracket2] = ACTIONS(5605),
  },
  [773] = {
    [sym_call_arguments] = STATE(2380),
    [sym_subset_arguments] = STATE(2385),
    [sym_subset2_arguments] = STATE(2388),
    [sym__open_parenthesis] = STATE(1496),
    [sym__open_bracket] = STATE(1494),
    [sym__open_bracket2] = STATE(1490),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5563),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5565),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(5567),
    [anon_sym_DASH] = ACTIONS(5569),
    [anon_sym_LT_DASH] = ACTIONS(5571),
    [anon_sym_LT_LT_DASH] = ACTIONS(5571),
    [anon_sym_COLON_EQ] = ACTIONS(5571),
    [anon_sym_DASH_GT] = ACTIONS(5573),
    [anon_sym_DASH_GT_GT] = ACTIONS(5575),
    [anon_sym_PIPE] = ACTIONS(5577),
    [anon_sym_AMP] = ACTIONS(5579),
    [anon_sym_PIPE_PIPE] = ACTIONS(5581),
    [anon_sym_AMP_AMP] = ACTIONS(5583),
    [anon_sym_LT] = ACTIONS(5585),
    [anon_sym_LT_EQ] = ACTIONS(5587),
    [anon_sym_GT] = ACTIONS(5585),
    [anon_sym_GT_EQ] = ACTIONS(5587),
    [anon_sym_EQ_EQ] = ACTIONS(5587),
    [anon_sym_BANG_EQ] = ACTIONS(5587),
    [anon_sym_STAR] = ACTIONS(5589),
    [anon_sym_SLASH] = ACTIONS(5591),
    [anon_sym_STAR_STAR] = ACTIONS(5593),
    [anon_sym_CARET] = ACTIONS(5593),
    [aux_sym_binary_operator_token1] = ACTIONS(5595),
    [anon_sym_PIPE_GT] = ACTIONS(5595),
    [anon_sym_COLON] = ACTIONS(5597),
    [anon_sym_DOLLAR] = ACTIONS(5599),
    [anon_sym_AT] = ACTIONS(5599),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__semicolon] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(5601),
    [sym__external_close_parenthesis] = ACTIONS(5333),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_close_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(5603),
    [sym__external_close_bracket] = ACTIONS(5333),
    [sym__external_open_bracket2] = ACTIONS(5605),
  },
  [774] = {
    [sym_call_arguments] = STATE(2380),
    [sym_subset_arguments] = STATE(2385),
    [sym_subset2_arguments] = STATE(2388),
    [sym__open_parenthesis] = STATE(1496),
    [sym__open_bracket] = STATE(1494),
    [sym__open_bracket2] = STATE(1490),
    [sym_identifier] = ACTIONS(5331),
    [anon_sym_BSLASH] = ACTIONS(5329),
    [anon_sym_function] = ACTIONS(5331),
    [anon_sym_EQ] = ACTIONS(5563),
    [anon_sym_if] = ACTIONS(5331),
    [anon_sym_for] = ACTIONS(5331),
    [anon_sym_while] = ACTIONS(5331),
    [anon_sym_repeat] = ACTIONS(5331),
    [anon_sym_QMARK] = ACTIONS(5329),
    [anon_sym_TILDE] = ACTIONS(5565),
    [anon_sym_BANG] = ACTIONS(5331),
    [anon_sym_PLUS] = ACTIONS(5567),
    [anon_sym_DASH] = ACTIONS(5569),
    [anon_sym_LT_DASH] = ACTIONS(5571),
    [anon_sym_LT_LT_DASH] = ACTIONS(5571),
    [anon_sym_COLON_EQ] = ACTIONS(5571),
    [anon_sym_DASH_GT] = ACTIONS(5573),
    [anon_sym_DASH_GT_GT] = ACTIONS(5575),
    [anon_sym_PIPE] = ACTIONS(5577),
    [anon_sym_AMP] = ACTIONS(5579),
    [anon_sym_PIPE_PIPE] = ACTIONS(5581),
    [anon_sym_AMP_AMP] = ACTIONS(5583),
    [anon_sym_LT] = ACTIONS(5585),
    [anon_sym_LT_EQ] = ACTIONS(5587),
    [anon_sym_GT] = ACTIONS(5585),
    [anon_sym_GT_EQ] = ACTIONS(5587),
    [anon_sym_EQ_EQ] = ACTIONS(5587),
    [anon_sym_BANG_EQ] = ACTIONS(5587),
    [anon_sym_STAR] = ACTIONS(5589),
    [anon_sym_SLASH] = ACTIONS(5591),
    [anon_sym_STAR_STAR] = ACTIONS(5593),
    [anon_sym_CARET] = ACTIONS(5593),
    [aux_sym_binary_operator_token1] = ACTIONS(5595),
    [anon_sym_PIPE_GT] = ACTIONS(5595),
    [anon_sym_COLON] = ACTIONS(5597),
    [anon_sym_DOLLAR] = ACTIONS(5599),
    [anon_sym_AT] = ACTIONS(5599),
    [aux_sym__hex_literal_token1] = ACTIONS(5329),
    [sym__number_literal] = ACTIONS(5331),
    [anon_sym_SQUOTE] = ACTIONS(5329),
    [anon_sym_DQUOTE] = ACTIONS(5329),
    [sym_return] = ACTIONS(5331),
    [sym_next] = ACTIONS(5331),
    [sym_break] = ACTIONS(5331),
    [sym_true] = ACTIONS(5331),
    [sym_false] = ACTIONS(5331),
    [sym_null] = ACTIONS(5331),
    [sym_inf] = ACTIONS(5331),
    [sym_nan] = ACTIONS(5331),
    [anon_sym_NA] = ACTIONS(5331),
    [anon_sym_NA_integer_] = ACTIONS(5331),
    [anon_sym_NA_real_] = ACTIONS(5331),
    [anon_sym_NA_complex_] = ACTIONS(5331),
    [anon_sym_NA_character_] = ACTIONS(5331),
    [sym_dots] = ACTIONS(5331),
    [sym_dot_dot_i] = ACTIONS(5329),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5329),
    [sym__newline] = ACTIONS(5329),
    [sym__semicolon] = ACTIONS(5329),
    [sym__raw_string_literal] = ACTIONS(5329),
    [sym__external_open_parenthesis] = ACTIONS(5601),
    [sym__external_close_parenthesis] = ACTIONS(5329),
    [sym__external_open_brace] = ACTIONS(5329),
    [sym__external_close_brace] = ACTIONS(5329),
    [sym__external_open_bracket] = ACTIONS(5603),
    [sym__external_close_bracket] = ACTIONS(5329),
    [sym__external_open_bracket2] = ACTIONS(5605),
  },
  [775] = {
    [sym_call_arguments] = STATE(2678),
    [sym_subset_arguments] = STATE(2679),
    [sym_subset2_arguments] = STATE(2683),
    [sym__else] = STATE(4351),
    [sym__open_parenthesis] = STATE(1443),
    [sym__open_bracket] = STATE(1442),
    [sym__open_bracket2] = STATE(1425),
    [ts_builtin_sym_end] = ACTIONS(5067),
    [sym_identifier] = ACTIONS(5065),
    [anon_sym_BSLASH] = ACTIONS(5067),
    [anon_sym_function] = ACTIONS(5065),
    [anon_sym_EQ] = ACTIONS(5609),
    [anon_sym_if] = ACTIONS(5065),
    [anon_sym_for] = ACTIONS(5065),
    [anon_sym_while] = ACTIONS(5065),
    [anon_sym_repeat] = ACTIONS(5065),
    [anon_sym_QMARK] = ACTIONS(5067),
    [anon_sym_TILDE] = ACTIONS(5611),
    [anon_sym_BANG] = ACTIONS(5065),
    [anon_sym_PLUS] = ACTIONS(5613),
    [anon_sym_DASH] = ACTIONS(5615),
    [anon_sym_LT_DASH] = ACTIONS(5617),
    [anon_sym_LT_LT_DASH] = ACTIONS(5617),
    [anon_sym_COLON_EQ] = ACTIONS(5617),
    [anon_sym_DASH_GT] = ACTIONS(5619),
    [anon_sym_DASH_GT_GT] = ACTIONS(5621),
    [anon_sym_PIPE] = ACTIONS(5623),
    [anon_sym_AMP] = ACTIONS(5625),
    [anon_sym_PIPE_PIPE] = ACTIONS(5627),
    [anon_sym_AMP_AMP] = ACTIONS(5629),
    [anon_sym_LT] = ACTIONS(5631),
    [anon_sym_LT_EQ] = ACTIONS(5633),
    [anon_sym_GT] = ACTIONS(5631),
    [anon_sym_GT_EQ] = ACTIONS(5633),
    [anon_sym_EQ_EQ] = ACTIONS(5633),
    [anon_sym_BANG_EQ] = ACTIONS(5633),
    [anon_sym_STAR] = ACTIONS(5635),
    [anon_sym_SLASH] = ACTIONS(5637),
    [anon_sym_STAR_STAR] = ACTIONS(5639),
    [anon_sym_CARET] = ACTIONS(5639),
    [aux_sym_binary_operator_token1] = ACTIONS(5641),
    [anon_sym_PIPE_GT] = ACTIONS(5641),
    [anon_sym_COLON] = ACTIONS(5643),
    [anon_sym_DOLLAR] = ACTIONS(5645),
    [anon_sym_AT] = ACTIONS(5645),
    [aux_sym__hex_literal_token1] = ACTIONS(5067),
    [sym__number_literal] = ACTIONS(5065),
    [anon_sym_SQUOTE] = ACTIONS(5067),
    [anon_sym_DQUOTE] = ACTIONS(5067),
    [sym_return] = ACTIONS(5065),
    [sym_next] = ACTIONS(5065),
    [sym_break] = ACTIONS(5065),
    [sym_true] = ACTIONS(5065),
    [sym_false] = ACTIONS(5065),
    [sym_null] = ACTIONS(5065),
    [sym_inf] = ACTIONS(5065),
    [sym_nan] = ACTIONS(5065),
    [anon_sym_NA] = ACTIONS(5065),
    [anon_sym_NA_integer_] = ACTIONS(5065),
    [anon_sym_NA_real_] = ACTIONS(5065),
    [anon_sym_NA_complex_] = ACTIONS(5065),
    [anon_sym_NA_character_] = ACTIONS(5065),
    [sym_dots] = ACTIONS(5065),
    [sym_dot_dot_i] = ACTIONS(5067),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5067),
    [sym__semicolon] = ACTIONS(5067),
    [sym__raw_string_literal] = ACTIONS(5067),
    [sym__external_else] = ACTIONS(5647),
    [sym__external_open_parenthesis] = ACTIONS(5649),
    [sym__external_close_parenthesis] = ACTIONS(5067),
    [sym__external_open_brace] = ACTIONS(5067),
    [sym__external_open_bracket] = ACTIONS(5651),
    [sym__external_open_bracket2] = ACTIONS(5653),
  },
  [776] = {
    [sym_call_arguments] = STATE(2678),
    [sym_subset_arguments] = STATE(2679),
    [sym_subset2_arguments] = STATE(2683),
    [sym__else] = STATE(4341),
    [sym__open_parenthesis] = STATE(1443),
    [sym__open_bracket] = STATE(1442),
    [sym__open_bracket2] = STATE(1425),
    [ts_builtin_sym_end] = ACTIONS(5117),
    [sym_identifier] = ACTIONS(5115),
    [anon_sym_BSLASH] = ACTIONS(5117),
    [anon_sym_function] = ACTIONS(5115),
    [anon_sym_EQ] = ACTIONS(5609),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_for] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_repeat] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(5117),
    [anon_sym_TILDE] = ACTIONS(5611),
    [anon_sym_BANG] = ACTIONS(5115),
    [anon_sym_PLUS] = ACTIONS(5613),
    [anon_sym_DASH] = ACTIONS(5615),
    [anon_sym_LT_DASH] = ACTIONS(5617),
    [anon_sym_LT_LT_DASH] = ACTIONS(5617),
    [anon_sym_COLON_EQ] = ACTIONS(5617),
    [anon_sym_DASH_GT] = ACTIONS(5619),
    [anon_sym_DASH_GT_GT] = ACTIONS(5621),
    [anon_sym_PIPE] = ACTIONS(5623),
    [anon_sym_AMP] = ACTIONS(5625),
    [anon_sym_PIPE_PIPE] = ACTIONS(5627),
    [anon_sym_AMP_AMP] = ACTIONS(5629),
    [anon_sym_LT] = ACTIONS(5631),
    [anon_sym_LT_EQ] = ACTIONS(5633),
    [anon_sym_GT] = ACTIONS(5631),
    [anon_sym_GT_EQ] = ACTIONS(5633),
    [anon_sym_EQ_EQ] = ACTIONS(5633),
    [anon_sym_BANG_EQ] = ACTIONS(5633),
    [anon_sym_STAR] = ACTIONS(5635),
    [anon_sym_SLASH] = ACTIONS(5637),
    [anon_sym_STAR_STAR] = ACTIONS(5639),
    [anon_sym_CARET] = ACTIONS(5639),
    [aux_sym_binary_operator_token1] = ACTIONS(5641),
    [anon_sym_PIPE_GT] = ACTIONS(5641),
    [anon_sym_COLON] = ACTIONS(5643),
    [anon_sym_DOLLAR] = ACTIONS(5645),
    [anon_sym_AT] = ACTIONS(5645),
    [aux_sym__hex_literal_token1] = ACTIONS(5117),
    [sym__number_literal] = ACTIONS(5115),
    [anon_sym_SQUOTE] = ACTIONS(5117),
    [anon_sym_DQUOTE] = ACTIONS(5117),
    [sym_return] = ACTIONS(5115),
    [sym_next] = ACTIONS(5115),
    [sym_break] = ACTIONS(5115),
    [sym_true] = ACTIONS(5115),
    [sym_false] = ACTIONS(5115),
    [sym_null] = ACTIONS(5115),
    [sym_inf] = ACTIONS(5115),
    [sym_nan] = ACTIONS(5115),
    [anon_sym_NA] = ACTIONS(5115),
    [anon_sym_NA_integer_] = ACTIONS(5115),
    [anon_sym_NA_real_] = ACTIONS(5115),
    [anon_sym_NA_complex_] = ACTIONS(5115),
    [anon_sym_NA_character_] = ACTIONS(5115),
    [sym_dots] = ACTIONS(5115),
    [sym_dot_dot_i] = ACTIONS(5117),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5117),
    [sym__semicolon] = ACTIONS(5117),
    [sym__raw_string_literal] = ACTIONS(5117),
    [sym__external_else] = ACTIONS(5655),
    [sym__external_open_parenthesis] = ACTIONS(5649),
    [sym__external_close_parenthesis] = ACTIONS(5117),
    [sym__external_open_brace] = ACTIONS(5117),
    [sym__external_open_bracket] = ACTIONS(5651),
    [sym__external_open_bracket2] = ACTIONS(5653),
  },
  [777] = {
    [sym_call_arguments] = STATE(2678),
    [sym_subset_arguments] = STATE(2679),
    [sym_subset2_arguments] = STATE(2683),
    [sym__else] = STATE(4345),
    [sym__open_parenthesis] = STATE(1443),
    [sym__open_bracket] = STATE(1442),
    [sym__open_bracket2] = STATE(1425),
    [ts_builtin_sym_end] = ACTIONS(5167),
    [sym_identifier] = ACTIONS(5169),
    [anon_sym_BSLASH] = ACTIONS(5167),
    [anon_sym_function] = ACTIONS(5169),
    [anon_sym_EQ] = ACTIONS(5609),
    [anon_sym_if] = ACTIONS(5169),
    [anon_sym_for] = ACTIONS(5169),
    [anon_sym_while] = ACTIONS(5169),
    [anon_sym_repeat] = ACTIONS(5169),
    [anon_sym_QMARK] = ACTIONS(5167),
    [anon_sym_TILDE] = ACTIONS(5611),
    [anon_sym_BANG] = ACTIONS(5169),
    [anon_sym_PLUS] = ACTIONS(5613),
    [anon_sym_DASH] = ACTIONS(5615),
    [anon_sym_LT_DASH] = ACTIONS(5617),
    [anon_sym_LT_LT_DASH] = ACTIONS(5617),
    [anon_sym_COLON_EQ] = ACTIONS(5617),
    [anon_sym_DASH_GT] = ACTIONS(5619),
    [anon_sym_DASH_GT_GT] = ACTIONS(5621),
    [anon_sym_PIPE] = ACTIONS(5623),
    [anon_sym_AMP] = ACTIONS(5625),
    [anon_sym_PIPE_PIPE] = ACTIONS(5627),
    [anon_sym_AMP_AMP] = ACTIONS(5629),
    [anon_sym_LT] = ACTIONS(5631),
    [anon_sym_LT_EQ] = ACTIONS(5633),
    [anon_sym_GT] = ACTIONS(5631),
    [anon_sym_GT_EQ] = ACTIONS(5633),
    [anon_sym_EQ_EQ] = ACTIONS(5633),
    [anon_sym_BANG_EQ] = ACTIONS(5633),
    [anon_sym_STAR] = ACTIONS(5635),
    [anon_sym_SLASH] = ACTIONS(5637),
    [anon_sym_STAR_STAR] = ACTIONS(5639),
    [anon_sym_CARET] = ACTIONS(5639),
    [aux_sym_binary_operator_token1] = ACTIONS(5641),
    [anon_sym_PIPE_GT] = ACTIONS(5641),
    [anon_sym_COLON] = ACTIONS(5643),
    [anon_sym_DOLLAR] = ACTIONS(5645),
    [anon_sym_AT] = ACTIONS(5645),
    [aux_sym__hex_literal_token1] = ACTIONS(5167),
    [sym__number_literal] = ACTIONS(5169),
    [anon_sym_SQUOTE] = ACTIONS(5167),
    [anon_sym_DQUOTE] = ACTIONS(5167),
    [sym_return] = ACTIONS(5169),
    [sym_next] = ACTIONS(5169),
    [sym_break] = ACTIONS(5169),
    [sym_true] = ACTIONS(5169),
    [sym_false] = ACTIONS(5169),
    [sym_null] = ACTIONS(5169),
    [sym_inf] = ACTIONS(5169),
    [sym_nan] = ACTIONS(5169),
    [anon_sym_NA] = ACTIONS(5169),
    [anon_sym_NA_integer_] = ACTIONS(5169),
    [anon_sym_NA_real_] = ACTIONS(5169),
    [anon_sym_NA_complex_] = ACTIONS(5169),
    [anon_sym_NA_character_] = ACTIONS(5169),
    [sym_dots] = ACTIONS(5169),
    [sym_dot_dot_i] = ACTIONS(5167),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5167),
    [sym__semicolon] = ACTIONS(5167),
    [sym__raw_string_literal] = ACTIONS(5167),
    [sym__external_else] = ACTIONS(5657),
    [sym__external_open_parenthesis] = ACTIONS(5649),
    [sym__external_close_parenthesis] = ACTIONS(5167),
    [sym__external_open_brace] = ACTIONS(5167),
    [sym__external_open_bracket] = ACTIONS(5651),
    [sym__external_open_bracket2] = ACTIONS(5653),
  },
  [778] = {
    [sym_string] = STATE(2252),
    [sym__single_quoted_string] = STATE(1985),
    [sym__double_quoted_string] = STATE(1990),
    [sym__string_or_identifier] = STATE(2252),
    [aux_sym_function_definition_repeat1] = STATE(780),
    [ts_builtin_sym_end] = ACTIONS(5659),
    [sym_identifier] = ACTIONS(5661),
    [anon_sym_BSLASH] = ACTIONS(5659),
    [anon_sym_function] = ACTIONS(5663),
    [anon_sym_EQ] = ACTIONS(5663),
    [anon_sym_if] = ACTIONS(5663),
    [anon_sym_for] = ACTIONS(5663),
    [anon_sym_while] = ACTIONS(5663),
    [anon_sym_repeat] = ACTIONS(5663),
    [anon_sym_QMARK] = ACTIONS(5659),
    [anon_sym_TILDE] = ACTIONS(5659),
    [anon_sym_BANG] = ACTIONS(5663),
    [anon_sym_PLUS] = ACTIONS(5659),
    [anon_sym_DASH] = ACTIONS(5663),
    [anon_sym_LT_DASH] = ACTIONS(5659),
    [anon_sym_LT_LT_DASH] = ACTIONS(5659),
    [anon_sym_COLON_EQ] = ACTIONS(5659),
    [anon_sym_DASH_GT] = ACTIONS(5663),
    [anon_sym_DASH_GT_GT] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(5663),
    [anon_sym_AMP] = ACTIONS(5663),
    [anon_sym_PIPE_PIPE] = ACTIONS(5659),
    [anon_sym_AMP_AMP] = ACTIONS(5659),
    [anon_sym_LT] = ACTIONS(5663),
    [anon_sym_LT_EQ] = ACTIONS(5659),
    [anon_sym_GT] = ACTIONS(5663),
    [anon_sym_GT_EQ] = ACTIONS(5659),
    [anon_sym_EQ_EQ] = ACTIONS(5659),
    [anon_sym_BANG_EQ] = ACTIONS(5659),
    [anon_sym_STAR] = ACTIONS(5663),
    [anon_sym_SLASH] = ACTIONS(5659),
    [anon_sym_STAR_STAR] = ACTIONS(5659),
    [anon_sym_CARET] = ACTIONS(5659),
    [aux_sym_binary_operator_token1] = ACTIONS(5659),
    [anon_sym_PIPE_GT] = ACTIONS(5659),
    [anon_sym_COLON] = ACTIONS(5663),
    [anon_sym_DOLLAR] = ACTIONS(5659),
    [anon_sym_AT] = ACTIONS(5659),
    [aux_sym__hex_literal_token1] = ACTIONS(5659),
    [sym__number_literal] = ACTIONS(5663),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_return] = ACTIONS(5663),
    [sym_next] = ACTIONS(5663),
    [sym_break] = ACTIONS(5663),
    [sym_true] = ACTIONS(5663),
    [sym_false] = ACTIONS(5663),
    [sym_null] = ACTIONS(5663),
    [sym_inf] = ACTIONS(5663),
    [sym_nan] = ACTIONS(5663),
    [anon_sym_NA] = ACTIONS(5663),
    [anon_sym_NA_integer_] = ACTIONS(5663),
    [anon_sym_NA_real_] = ACTIONS(5663),
    [anon_sym_NA_complex_] = ACTIONS(5663),
    [anon_sym_NA_character_] = ACTIONS(5663),
    [sym_dots] = ACTIONS(5663),
    [sym_dot_dot_i] = ACTIONS(5659),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5659),
    [sym__newline] = ACTIONS(5665),
    [sym__semicolon] = ACTIONS(5659),
    [sym__raw_string_literal] = ACTIONS(95),
    [sym__external_else] = ACTIONS(5659),
    [sym__external_open_parenthesis] = ACTIONS(5659),
    [sym__external_close_parenthesis] = ACTIONS(5659),
    [sym__external_open_brace] = ACTIONS(5659),
    [sym__external_close_brace] = ACTIONS(5659),
    [sym__external_open_bracket] = ACTIONS(5659),
    [sym__external_open_bracket2] = ACTIONS(5659),
  },
  [779] = {
    [sym_call_arguments] = STATE(2678),
    [sym_subset_arguments] = STATE(2679),
    [sym_subset2_arguments] = STATE(2683),
    [sym__else] = STATE(4293),
    [sym__open_parenthesis] = STATE(1443),
    [sym__open_bracket] = STATE(1442),
    [sym__open_bracket2] = STATE(1425),
    [ts_builtin_sym_end] = ACTIONS(5227),
    [sym_identifier] = ACTIONS(5225),
    [anon_sym_BSLASH] = ACTIONS(5227),
    [anon_sym_function] = ACTIONS(5225),
    [anon_sym_EQ] = ACTIONS(5609),
    [anon_sym_if] = ACTIONS(5225),
    [anon_sym_for] = ACTIONS(5225),
    [anon_sym_while] = ACTIONS(5225),
    [anon_sym_repeat] = ACTIONS(5225),
    [anon_sym_QMARK] = ACTIONS(5227),
    [anon_sym_TILDE] = ACTIONS(5611),
    [anon_sym_BANG] = ACTIONS(5225),
    [anon_sym_PLUS] = ACTIONS(5613),
    [anon_sym_DASH] = ACTIONS(5615),
    [anon_sym_LT_DASH] = ACTIONS(5617),
    [anon_sym_LT_LT_DASH] = ACTIONS(5617),
    [anon_sym_COLON_EQ] = ACTIONS(5617),
    [anon_sym_DASH_GT] = ACTIONS(5619),
    [anon_sym_DASH_GT_GT] = ACTIONS(5621),
    [anon_sym_PIPE] = ACTIONS(5623),
    [anon_sym_AMP] = ACTIONS(5625),
    [anon_sym_PIPE_PIPE] = ACTIONS(5627),
    [anon_sym_AMP_AMP] = ACTIONS(5629),
    [anon_sym_LT] = ACTIONS(5631),
    [anon_sym_LT_EQ] = ACTIONS(5633),
    [anon_sym_GT] = ACTIONS(5631),
    [anon_sym_GT_EQ] = ACTIONS(5633),
    [anon_sym_EQ_EQ] = ACTIONS(5633),
    [anon_sym_BANG_EQ] = ACTIONS(5633),
    [anon_sym_STAR] = ACTIONS(5635),
    [anon_sym_SLASH] = ACTIONS(5637),
    [anon_sym_STAR_STAR] = ACTIONS(5639),
    [anon_sym_CARET] = ACTIONS(5639),
    [aux_sym_binary_operator_token1] = ACTIONS(5641),
    [anon_sym_PIPE_GT] = ACTIONS(5641),
    [anon_sym_COLON] = ACTIONS(5643),
    [anon_sym_DOLLAR] = ACTIONS(5645),
    [anon_sym_AT] = ACTIONS(5645),
    [aux_sym__hex_literal_token1] = ACTIONS(5227),
    [sym__number_literal] = ACTIONS(5225),
    [anon_sym_SQUOTE] = ACTIONS(5227),
    [anon_sym_DQUOTE] = ACTIONS(5227),
    [sym_return] = ACTIONS(5225),
    [sym_next] = ACTIONS(5225),
    [sym_break] = ACTIONS(5225),
    [sym_true] = ACTIONS(5225),
    [sym_false] = ACTIONS(5225),
    [sym_null] = ACTIONS(5225),
    [sym_inf] = ACTIONS(5225),
    [sym_nan] = ACTIONS(5225),
    [anon_sym_NA] = ACTIONS(5225),
    [anon_sym_NA_integer_] = ACTIONS(5225),
    [anon_sym_NA_real_] = ACTIONS(5225),
    [anon_sym_NA_complex_] = ACTIONS(5225),
    [anon_sym_NA_character_] = ACTIONS(5225),
    [sym_dots] = ACTIONS(5225),
    [sym_dot_dot_i] = ACTIONS(5227),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5227),
    [sym__semicolon] = ACTIONS(5227),
    [sym__raw_string_literal] = ACTIONS(5227),
    [sym__external_else] = ACTIONS(5667),
    [sym__external_open_parenthesis] = ACTIONS(5649),
    [sym__external_close_parenthesis] = ACTIONS(5227),
    [sym__external_open_brace] = ACTIONS(5227),
    [sym__external_open_bracket] = ACTIONS(5651),
    [sym__external_open_bracket2] = ACTIONS(5653),
  },
  [780] = {
    [sym_string] = STATE(2243),
    [sym__single_quoted_string] = STATE(1985),
    [sym__double_quoted_string] = STATE(1990),
    [sym__string_or_identifier] = STATE(2243),
    [aux_sym_function_definition_repeat1] = STATE(2195),
    [ts_builtin_sym_end] = ACTIONS(5669),
    [sym_identifier] = ACTIONS(5671),
    [anon_sym_BSLASH] = ACTIONS(5669),
    [anon_sym_function] = ACTIONS(5673),
    [anon_sym_EQ] = ACTIONS(5673),
    [anon_sym_if] = ACTIONS(5673),
    [anon_sym_for] = ACTIONS(5673),
    [anon_sym_while] = ACTIONS(5673),
    [anon_sym_repeat] = ACTIONS(5673),
    [anon_sym_QMARK] = ACTIONS(5669),
    [anon_sym_TILDE] = ACTIONS(5669),
    [anon_sym_BANG] = ACTIONS(5673),
    [anon_sym_PLUS] = ACTIONS(5669),
    [anon_sym_DASH] = ACTIONS(5673),
    [anon_sym_LT_DASH] = ACTIONS(5669),
    [anon_sym_LT_LT_DASH] = ACTIONS(5669),
    [anon_sym_COLON_EQ] = ACTIONS(5669),
    [anon_sym_DASH_GT] = ACTIONS(5673),
    [anon_sym_DASH_GT_GT] = ACTIONS(5669),
    [anon_sym_PIPE] = ACTIONS(5673),
    [anon_sym_AMP] = ACTIONS(5673),
    [anon_sym_PIPE_PIPE] = ACTIONS(5669),
    [anon_sym_AMP_AMP] = ACTIONS(5669),
    [anon_sym_LT] = ACTIONS(5673),
    [anon_sym_LT_EQ] = ACTIONS(5669),
    [anon_sym_GT] = ACTIONS(5673),
    [anon_sym_GT_EQ] = ACTIONS(5669),
    [anon_sym_EQ_EQ] = ACTIONS(5669),
    [anon_sym_BANG_EQ] = ACTIONS(5669),
    [anon_sym_STAR] = ACTIONS(5673),
    [anon_sym_SLASH] = ACTIONS(5669),
    [anon_sym_STAR_STAR] = ACTIONS(5669),
    [anon_sym_CARET] = ACTIONS(5669),
    [aux_sym_binary_operator_token1] = ACTIONS(5669),
    [anon_sym_PIPE_GT] = ACTIONS(5669),
    [anon_sym_COLON] = ACTIONS(5673),
    [anon_sym_DOLLAR] = ACTIONS(5669),
    [anon_sym_AT] = ACTIONS(5669),
    [aux_sym__hex_literal_token1] = ACTIONS(5669),
    [sym__number_literal] = ACTIONS(5673),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_return] = ACTIONS(5673),
    [sym_next] = ACTIONS(5673),
    [sym_break] = ACTIONS(5673),
    [sym_true] = ACTIONS(5673),
    [sym_false] = ACTIONS(5673),
    [sym_null] = ACTIONS(5673),
    [sym_inf] = ACTIONS(5673),
    [sym_nan] = ACTIONS(5673),
    [anon_sym_NA] = ACTIONS(5673),
    [anon_sym_NA_integer_] = ACTIONS(5673),
    [anon_sym_NA_real_] = ACTIONS(5673),
    [anon_sym_NA_complex_] = ACTIONS(5673),
    [anon_sym_NA_character_] = ACTIONS(5673),
    [sym_dots] = ACTIONS(5673),
    [sym_dot_dot_i] = ACTIONS(5669),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5669),
    [sym__newline] = ACTIONS(5669),
    [sym__semicolon] = ACTIONS(5669),
    [sym__raw_string_literal] = ACTIONS(95),
    [sym__external_else] = ACTIONS(5669),
    [sym__external_open_parenthesis] = ACTIONS(5669),
    [sym__external_close_parenthesis] = ACTIONS(5669),
    [sym__external_open_brace] = ACTIONS(5669),
    [sym__external_close_brace] = ACTIONS(5669),
    [sym__external_open_bracket] = ACTIONS(5669),
    [sym__external_open_bracket2] = ACTIONS(5669),
  },
  [781] = {
    [sym_call_arguments] = STATE(2651),
    [sym_subset_arguments] = STATE(2561),
    [sym_subset2_arguments] = STATE(2648),
    [sym__else] = STATE(4211),
    [sym__open_parenthesis] = STATE(1340),
    [sym__open_bracket] = STATE(1335),
    [sym__open_bracket2] = STATE(1334),
    [sym_identifier] = ACTIONS(5065),
    [anon_sym_BSLASH] = ACTIONS(5067),
    [anon_sym_function] = ACTIONS(5065),
    [anon_sym_EQ] = ACTIONS(5675),
    [anon_sym_if] = ACTIONS(5065),
    [anon_sym_for] = ACTIONS(5065),
    [anon_sym_while] = ACTIONS(5065),
    [anon_sym_repeat] = ACTIONS(5065),
    [anon_sym_QMARK] = ACTIONS(5067),
    [anon_sym_TILDE] = ACTIONS(5677),
    [anon_sym_BANG] = ACTIONS(5065),
    [anon_sym_PLUS] = ACTIONS(5679),
    [anon_sym_DASH] = ACTIONS(5681),
    [anon_sym_LT_DASH] = ACTIONS(5683),
    [anon_sym_LT_LT_DASH] = ACTIONS(5683),
    [anon_sym_COLON_EQ] = ACTIONS(5683),
    [anon_sym_DASH_GT] = ACTIONS(5685),
    [anon_sym_DASH_GT_GT] = ACTIONS(5687),
    [anon_sym_PIPE] = ACTIONS(5689),
    [anon_sym_AMP] = ACTIONS(5691),
    [anon_sym_PIPE_PIPE] = ACTIONS(5693),
    [anon_sym_AMP_AMP] = ACTIONS(5695),
    [anon_sym_LT] = ACTIONS(5697),
    [anon_sym_LT_EQ] = ACTIONS(5699),
    [anon_sym_GT] = ACTIONS(5697),
    [anon_sym_GT_EQ] = ACTIONS(5699),
    [anon_sym_EQ_EQ] = ACTIONS(5699),
    [anon_sym_BANG_EQ] = ACTIONS(5699),
    [anon_sym_STAR] = ACTIONS(5701),
    [anon_sym_SLASH] = ACTIONS(5703),
    [anon_sym_STAR_STAR] = ACTIONS(5705),
    [anon_sym_CARET] = ACTIONS(5705),
    [aux_sym_binary_operator_token1] = ACTIONS(5707),
    [anon_sym_PIPE_GT] = ACTIONS(5707),
    [anon_sym_COLON] = ACTIONS(5709),
    [anon_sym_DOLLAR] = ACTIONS(5711),
    [anon_sym_AT] = ACTIONS(5711),
    [aux_sym__hex_literal_token1] = ACTIONS(5067),
    [sym__number_literal] = ACTIONS(5065),
    [anon_sym_SQUOTE] = ACTIONS(5067),
    [anon_sym_DQUOTE] = ACTIONS(5067),
    [sym_return] = ACTIONS(5065),
    [sym_next] = ACTIONS(5065),
    [sym_break] = ACTIONS(5065),
    [sym_true] = ACTIONS(5065),
    [sym_false] = ACTIONS(5065),
    [sym_null] = ACTIONS(5065),
    [sym_inf] = ACTIONS(5065),
    [sym_nan] = ACTIONS(5065),
    [anon_sym_NA] = ACTIONS(5065),
    [anon_sym_NA_integer_] = ACTIONS(5065),
    [anon_sym_NA_real_] = ACTIONS(5065),
    [anon_sym_NA_complex_] = ACTIONS(5065),
    [anon_sym_NA_character_] = ACTIONS(5065),
    [sym_dots] = ACTIONS(5065),
    [sym_dot_dot_i] = ACTIONS(5067),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5067),
    [sym__newline] = ACTIONS(5067),
    [sym__raw_string_literal] = ACTIONS(5067),
    [sym__external_else] = ACTIONS(5713),
    [sym__external_open_parenthesis] = ACTIONS(5715),
    [sym__external_close_parenthesis] = ACTIONS(5067),
    [sym__external_open_brace] = ACTIONS(5067),
    [sym__external_open_bracket] = ACTIONS(5717),
    [sym__external_open_bracket2] = ACTIONS(5719),
    [sym__external_close_bracket2] = ACTIONS(5067),
  },
  [782] = {
    [sym_call_arguments] = STATE(2651),
    [sym_subset_arguments] = STATE(2561),
    [sym_subset2_arguments] = STATE(2648),
    [sym__else] = STATE(4208),
    [sym__open_parenthesis] = STATE(1340),
    [sym__open_bracket] = STATE(1335),
    [sym__open_bracket2] = STATE(1334),
    [sym_identifier] = ACTIONS(5115),
    [anon_sym_BSLASH] = ACTIONS(5117),
    [anon_sym_function] = ACTIONS(5115),
    [anon_sym_EQ] = ACTIONS(5675),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_for] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_repeat] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(5117),
    [anon_sym_TILDE] = ACTIONS(5677),
    [anon_sym_BANG] = ACTIONS(5115),
    [anon_sym_PLUS] = ACTIONS(5679),
    [anon_sym_DASH] = ACTIONS(5681),
    [anon_sym_LT_DASH] = ACTIONS(5683),
    [anon_sym_LT_LT_DASH] = ACTIONS(5683),
    [anon_sym_COLON_EQ] = ACTIONS(5683),
    [anon_sym_DASH_GT] = ACTIONS(5685),
    [anon_sym_DASH_GT_GT] = ACTIONS(5687),
    [anon_sym_PIPE] = ACTIONS(5689),
    [anon_sym_AMP] = ACTIONS(5691),
    [anon_sym_PIPE_PIPE] = ACTIONS(5693),
    [anon_sym_AMP_AMP] = ACTIONS(5695),
    [anon_sym_LT] = ACTIONS(5697),
    [anon_sym_LT_EQ] = ACTIONS(5699),
    [anon_sym_GT] = ACTIONS(5697),
    [anon_sym_GT_EQ] = ACTIONS(5699),
    [anon_sym_EQ_EQ] = ACTIONS(5699),
    [anon_sym_BANG_EQ] = ACTIONS(5699),
    [anon_sym_STAR] = ACTIONS(5701),
    [anon_sym_SLASH] = ACTIONS(5703),
    [anon_sym_STAR_STAR] = ACTIONS(5705),
    [anon_sym_CARET] = ACTIONS(5705),
    [aux_sym_binary_operator_token1] = ACTIONS(5707),
    [anon_sym_PIPE_GT] = ACTIONS(5707),
    [anon_sym_COLON] = ACTIONS(5709),
    [anon_sym_DOLLAR] = ACTIONS(5711),
    [anon_sym_AT] = ACTIONS(5711),
    [aux_sym__hex_literal_token1] = ACTIONS(5117),
    [sym__number_literal] = ACTIONS(5115),
    [anon_sym_SQUOTE] = ACTIONS(5117),
    [anon_sym_DQUOTE] = ACTIONS(5117),
    [sym_return] = ACTIONS(5115),
    [sym_next] = ACTIONS(5115),
    [sym_break] = ACTIONS(5115),
    [sym_true] = ACTIONS(5115),
    [sym_false] = ACTIONS(5115),
    [sym_null] = ACTIONS(5115),
    [sym_inf] = ACTIONS(5115),
    [sym_nan] = ACTIONS(5115),
    [anon_sym_NA] = ACTIONS(5115),
    [anon_sym_NA_integer_] = ACTIONS(5115),
    [anon_sym_NA_real_] = ACTIONS(5115),
    [anon_sym_NA_complex_] = ACTIONS(5115),
    [anon_sym_NA_character_] = ACTIONS(5115),
    [sym_dots] = ACTIONS(5115),
    [sym_dot_dot_i] = ACTIONS(5117),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5117),
    [sym__newline] = ACTIONS(5117),
    [sym__raw_string_literal] = ACTIONS(5117),
    [sym__external_else] = ACTIONS(5721),
    [sym__external_open_parenthesis] = ACTIONS(5715),
    [sym__external_close_parenthesis] = ACTIONS(5117),
    [sym__external_open_brace] = ACTIONS(5117),
    [sym__external_open_bracket] = ACTIONS(5717),
    [sym__external_open_bracket2] = ACTIONS(5719),
    [sym__external_close_bracket2] = ACTIONS(5117),
  },
  [783] = {
    [sym_call_arguments] = STATE(2651),
    [sym_subset_arguments] = STATE(2561),
    [sym_subset2_arguments] = STATE(2648),
    [sym__else] = STATE(4189),
    [sym__open_parenthesis] = STATE(1340),
    [sym__open_bracket] = STATE(1335),
    [sym__open_bracket2] = STATE(1334),
    [sym_identifier] = ACTIONS(5169),
    [anon_sym_BSLASH] = ACTIONS(5167),
    [anon_sym_function] = ACTIONS(5169),
    [anon_sym_EQ] = ACTIONS(5675),
    [anon_sym_if] = ACTIONS(5169),
    [anon_sym_for] = ACTIONS(5169),
    [anon_sym_while] = ACTIONS(5169),
    [anon_sym_repeat] = ACTIONS(5169),
    [anon_sym_QMARK] = ACTIONS(5167),
    [anon_sym_TILDE] = ACTIONS(5677),
    [anon_sym_BANG] = ACTIONS(5169),
    [anon_sym_PLUS] = ACTIONS(5679),
    [anon_sym_DASH] = ACTIONS(5681),
    [anon_sym_LT_DASH] = ACTIONS(5683),
    [anon_sym_LT_LT_DASH] = ACTIONS(5683),
    [anon_sym_COLON_EQ] = ACTIONS(5683),
    [anon_sym_DASH_GT] = ACTIONS(5685),
    [anon_sym_DASH_GT_GT] = ACTIONS(5687),
    [anon_sym_PIPE] = ACTIONS(5689),
    [anon_sym_AMP] = ACTIONS(5691),
    [anon_sym_PIPE_PIPE] = ACTIONS(5693),
    [anon_sym_AMP_AMP] = ACTIONS(5695),
    [anon_sym_LT] = ACTIONS(5697),
    [anon_sym_LT_EQ] = ACTIONS(5699),
    [anon_sym_GT] = ACTIONS(5697),
    [anon_sym_GT_EQ] = ACTIONS(5699),
    [anon_sym_EQ_EQ] = ACTIONS(5699),
    [anon_sym_BANG_EQ] = ACTIONS(5699),
    [anon_sym_STAR] = ACTIONS(5701),
    [anon_sym_SLASH] = ACTIONS(5703),
    [anon_sym_STAR_STAR] = ACTIONS(5705),
    [anon_sym_CARET] = ACTIONS(5705),
    [aux_sym_binary_operator_token1] = ACTIONS(5707),
    [anon_sym_PIPE_GT] = ACTIONS(5707),
    [anon_sym_COLON] = ACTIONS(5709),
    [anon_sym_DOLLAR] = ACTIONS(5711),
    [anon_sym_AT] = ACTIONS(5711),
    [aux_sym__hex_literal_token1] = ACTIONS(5167),
    [sym__number_literal] = ACTIONS(5169),
    [anon_sym_SQUOTE] = ACTIONS(5167),
    [anon_sym_DQUOTE] = ACTIONS(5167),
    [sym_return] = ACTIONS(5169),
    [sym_next] = ACTIONS(5169),
    [sym_break] = ACTIONS(5169),
    [sym_true] = ACTIONS(5169),
    [sym_false] = ACTIONS(5169),
    [sym_null] = ACTIONS(5169),
    [sym_inf] = ACTIONS(5169),
    [sym_nan] = ACTIONS(5169),
    [anon_sym_NA] = ACTIONS(5169),
    [anon_sym_NA_integer_] = ACTIONS(5169),
    [anon_sym_NA_real_] = ACTIONS(5169),
    [anon_sym_NA_complex_] = ACTIONS(5169),
    [anon_sym_NA_character_] = ACTIONS(5169),
    [sym_dots] = ACTIONS(5169),
    [sym_dot_dot_i] = ACTIONS(5167),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5167),
    [sym__newline] = ACTIONS(5167),
    [sym__raw_string_literal] = ACTIONS(5167),
    [sym__external_else] = ACTIONS(5723),
    [sym__external_open_parenthesis] = ACTIONS(5715),
    [sym__external_close_parenthesis] = ACTIONS(5167),
    [sym__external_open_brace] = ACTIONS(5167),
    [sym__external_open_bracket] = ACTIONS(5717),
    [sym__external_open_bracket2] = ACTIONS(5719),
    [sym__external_close_bracket2] = ACTIONS(5167),
  },
  [784] = {
    [sym_call_arguments] = STATE(2651),
    [sym_subset_arguments] = STATE(2561),
    [sym_subset2_arguments] = STATE(2648),
    [sym__else] = STATE(4202),
    [sym__open_parenthesis] = STATE(1340),
    [sym__open_bracket] = STATE(1335),
    [sym__open_bracket2] = STATE(1334),
    [sym_identifier] = ACTIONS(5225),
    [anon_sym_BSLASH] = ACTIONS(5227),
    [anon_sym_function] = ACTIONS(5225),
    [anon_sym_EQ] = ACTIONS(5675),
    [anon_sym_if] = ACTIONS(5225),
    [anon_sym_for] = ACTIONS(5225),
    [anon_sym_while] = ACTIONS(5225),
    [anon_sym_repeat] = ACTIONS(5225),
    [anon_sym_QMARK] = ACTIONS(5227),
    [anon_sym_TILDE] = ACTIONS(5677),
    [anon_sym_BANG] = ACTIONS(5225),
    [anon_sym_PLUS] = ACTIONS(5679),
    [anon_sym_DASH] = ACTIONS(5681),
    [anon_sym_LT_DASH] = ACTIONS(5683),
    [anon_sym_LT_LT_DASH] = ACTIONS(5683),
    [anon_sym_COLON_EQ] = ACTIONS(5683),
    [anon_sym_DASH_GT] = ACTIONS(5685),
    [anon_sym_DASH_GT_GT] = ACTIONS(5687),
    [anon_sym_PIPE] = ACTIONS(5689),
    [anon_sym_AMP] = ACTIONS(5691),
    [anon_sym_PIPE_PIPE] = ACTIONS(5693),
    [anon_sym_AMP_AMP] = ACTIONS(5695),
    [anon_sym_LT] = ACTIONS(5697),
    [anon_sym_LT_EQ] = ACTIONS(5699),
    [anon_sym_GT] = ACTIONS(5697),
    [anon_sym_GT_EQ] = ACTIONS(5699),
    [anon_sym_EQ_EQ] = ACTIONS(5699),
    [anon_sym_BANG_EQ] = ACTIONS(5699),
    [anon_sym_STAR] = ACTIONS(5701),
    [anon_sym_SLASH] = ACTIONS(5703),
    [anon_sym_STAR_STAR] = ACTIONS(5705),
    [anon_sym_CARET] = ACTIONS(5705),
    [aux_sym_binary_operator_token1] = ACTIONS(5707),
    [anon_sym_PIPE_GT] = ACTIONS(5707),
    [anon_sym_COLON] = ACTIONS(5709),
    [anon_sym_DOLLAR] = ACTIONS(5711),
    [anon_sym_AT] = ACTIONS(5711),
    [aux_sym__hex_literal_token1] = ACTIONS(5227),
    [sym__number_literal] = ACTIONS(5225),
    [anon_sym_SQUOTE] = ACTIONS(5227),
    [anon_sym_DQUOTE] = ACTIONS(5227),
    [sym_return] = ACTIONS(5225),
    [sym_next] = ACTIONS(5225),
    [sym_break] = ACTIONS(5225),
    [sym_true] = ACTIONS(5225),
    [sym_false] = ACTIONS(5225),
    [sym_null] = ACTIONS(5225),
    [sym_inf] = ACTIONS(5225),
    [sym_nan] = ACTIONS(5225),
    [anon_sym_NA] = ACTIONS(5225),
    [anon_sym_NA_integer_] = ACTIONS(5225),
    [anon_sym_NA_real_] = ACTIONS(5225),
    [anon_sym_NA_complex_] = ACTIONS(5225),
    [anon_sym_NA_character_] = ACTIONS(5225),
    [sym_dots] = ACTIONS(5225),
    [sym_dot_dot_i] = ACTIONS(5227),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5227),
    [sym__newline] = ACTIONS(5227),
    [sym__raw_string_literal] = ACTIONS(5227),
    [sym__external_else] = ACTIONS(5725),
    [sym__external_open_parenthesis] = ACTIONS(5715),
    [sym__external_close_parenthesis] = ACTIONS(5227),
    [sym__external_open_brace] = ACTIONS(5227),
    [sym__external_open_bracket] = ACTIONS(5717),
    [sym__external_open_bracket2] = ACTIONS(5719),
    [sym__external_close_bracket2] = ACTIONS(5227),
  },
  [785] = {
    [sym_call_arguments] = STATE(2595),
    [sym_subset_arguments] = STATE(2594),
    [sym_subset2_arguments] = STATE(2592),
    [sym__else] = STATE(4229),
    [sym__open_parenthesis] = STATE(1423),
    [sym__open_bracket] = STATE(1419),
    [sym__open_bracket2] = STATE(1415),
    [ts_builtin_sym_end] = ACTIONS(5227),
    [sym_identifier] = ACTIONS(5225),
    [anon_sym_BSLASH] = ACTIONS(5227),
    [anon_sym_function] = ACTIONS(5225),
    [anon_sym_EQ] = ACTIONS(5727),
    [anon_sym_if] = ACTIONS(5225),
    [anon_sym_for] = ACTIONS(5225),
    [anon_sym_while] = ACTIONS(5225),
    [anon_sym_repeat] = ACTIONS(5225),
    [anon_sym_QMARK] = ACTIONS(5227),
    [anon_sym_TILDE] = ACTIONS(5729),
    [anon_sym_BANG] = ACTIONS(5225),
    [anon_sym_PLUS] = ACTIONS(5731),
    [anon_sym_DASH] = ACTIONS(5733),
    [anon_sym_LT_DASH] = ACTIONS(5735),
    [anon_sym_LT_LT_DASH] = ACTIONS(5735),
    [anon_sym_COLON_EQ] = ACTIONS(5735),
    [anon_sym_DASH_GT] = ACTIONS(5737),
    [anon_sym_DASH_GT_GT] = ACTIONS(5739),
    [anon_sym_PIPE] = ACTIONS(5741),
    [anon_sym_AMP] = ACTIONS(5743),
    [anon_sym_PIPE_PIPE] = ACTIONS(5745),
    [anon_sym_AMP_AMP] = ACTIONS(5747),
    [anon_sym_LT] = ACTIONS(5749),
    [anon_sym_LT_EQ] = ACTIONS(5751),
    [anon_sym_GT] = ACTIONS(5749),
    [anon_sym_GT_EQ] = ACTIONS(5751),
    [anon_sym_EQ_EQ] = ACTIONS(5751),
    [anon_sym_BANG_EQ] = ACTIONS(5751),
    [anon_sym_STAR] = ACTIONS(5753),
    [anon_sym_SLASH] = ACTIONS(5755),
    [anon_sym_STAR_STAR] = ACTIONS(5757),
    [anon_sym_CARET] = ACTIONS(5757),
    [aux_sym_binary_operator_token1] = ACTIONS(5759),
    [anon_sym_PIPE_GT] = ACTIONS(5759),
    [anon_sym_COLON] = ACTIONS(5761),
    [anon_sym_DOLLAR] = ACTIONS(5763),
    [anon_sym_AT] = ACTIONS(5763),
    [aux_sym__hex_literal_token1] = ACTIONS(5227),
    [sym__number_literal] = ACTIONS(5225),
    [anon_sym_SQUOTE] = ACTIONS(5227),
    [anon_sym_DQUOTE] = ACTIONS(5227),
    [sym_return] = ACTIONS(5225),
    [sym_next] = ACTIONS(5225),
    [sym_break] = ACTIONS(5225),
    [sym_true] = ACTIONS(5225),
    [sym_false] = ACTIONS(5225),
    [sym_null] = ACTIONS(5225),
    [sym_inf] = ACTIONS(5225),
    [sym_nan] = ACTIONS(5225),
    [anon_sym_NA] = ACTIONS(5225),
    [anon_sym_NA_integer_] = ACTIONS(5225),
    [anon_sym_NA_real_] = ACTIONS(5225),
    [anon_sym_NA_complex_] = ACTIONS(5225),
    [anon_sym_NA_character_] = ACTIONS(5225),
    [sym_dots] = ACTIONS(5225),
    [sym_dot_dot_i] = ACTIONS(5227),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5227),
    [sym__semicolon] = ACTIONS(5227),
    [sym__raw_string_literal] = ACTIONS(5227),
    [sym__external_else] = ACTIONS(5765),
    [sym__external_open_parenthesis] = ACTIONS(5767),
    [sym__external_open_brace] = ACTIONS(5227),
    [sym__external_close_brace] = ACTIONS(5227),
    [sym__external_open_bracket] = ACTIONS(5769),
    [sym__external_open_bracket2] = ACTIONS(5771),
  },
  [786] = {
    [sym_call_arguments] = STATE(2595),
    [sym_subset_arguments] = STATE(2594),
    [sym_subset2_arguments] = STATE(2592),
    [sym__else] = STATE(4237),
    [sym__open_parenthesis] = STATE(1423),
    [sym__open_bracket] = STATE(1419),
    [sym__open_bracket2] = STATE(1415),
    [ts_builtin_sym_end] = ACTIONS(5167),
    [sym_identifier] = ACTIONS(5169),
    [anon_sym_BSLASH] = ACTIONS(5167),
    [anon_sym_function] = ACTIONS(5169),
    [anon_sym_EQ] = ACTIONS(5727),
    [anon_sym_if] = ACTIONS(5169),
    [anon_sym_for] = ACTIONS(5169),
    [anon_sym_while] = ACTIONS(5169),
    [anon_sym_repeat] = ACTIONS(5169),
    [anon_sym_QMARK] = ACTIONS(5167),
    [anon_sym_TILDE] = ACTIONS(5729),
    [anon_sym_BANG] = ACTIONS(5169),
    [anon_sym_PLUS] = ACTIONS(5731),
    [anon_sym_DASH] = ACTIONS(5733),
    [anon_sym_LT_DASH] = ACTIONS(5735),
    [anon_sym_LT_LT_DASH] = ACTIONS(5735),
    [anon_sym_COLON_EQ] = ACTIONS(5735),
    [anon_sym_DASH_GT] = ACTIONS(5737),
    [anon_sym_DASH_GT_GT] = ACTIONS(5739),
    [anon_sym_PIPE] = ACTIONS(5741),
    [anon_sym_AMP] = ACTIONS(5743),
    [anon_sym_PIPE_PIPE] = ACTIONS(5745),
    [anon_sym_AMP_AMP] = ACTIONS(5747),
    [anon_sym_LT] = ACTIONS(5749),
    [anon_sym_LT_EQ] = ACTIONS(5751),
    [anon_sym_GT] = ACTIONS(5749),
    [anon_sym_GT_EQ] = ACTIONS(5751),
    [anon_sym_EQ_EQ] = ACTIONS(5751),
    [anon_sym_BANG_EQ] = ACTIONS(5751),
    [anon_sym_STAR] = ACTIONS(5753),
    [anon_sym_SLASH] = ACTIONS(5755),
    [anon_sym_STAR_STAR] = ACTIONS(5757),
    [anon_sym_CARET] = ACTIONS(5757),
    [aux_sym_binary_operator_token1] = ACTIONS(5759),
    [anon_sym_PIPE_GT] = ACTIONS(5759),
    [anon_sym_COLON] = ACTIONS(5761),
    [anon_sym_DOLLAR] = ACTIONS(5763),
    [anon_sym_AT] = ACTIONS(5763),
    [aux_sym__hex_literal_token1] = ACTIONS(5167),
    [sym__number_literal] = ACTIONS(5169),
    [anon_sym_SQUOTE] = ACTIONS(5167),
    [anon_sym_DQUOTE] = ACTIONS(5167),
    [sym_return] = ACTIONS(5169),
    [sym_next] = ACTIONS(5169),
    [sym_break] = ACTIONS(5169),
    [sym_true] = ACTIONS(5169),
    [sym_false] = ACTIONS(5169),
    [sym_null] = ACTIONS(5169),
    [sym_inf] = ACTIONS(5169),
    [sym_nan] = ACTIONS(5169),
    [anon_sym_NA] = ACTIONS(5169),
    [anon_sym_NA_integer_] = ACTIONS(5169),
    [anon_sym_NA_real_] = ACTIONS(5169),
    [anon_sym_NA_complex_] = ACTIONS(5169),
    [anon_sym_NA_character_] = ACTIONS(5169),
    [sym_dots] = ACTIONS(5169),
    [sym_dot_dot_i] = ACTIONS(5167),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5167),
    [sym__semicolon] = ACTIONS(5167),
    [sym__raw_string_literal] = ACTIONS(5167),
    [sym__external_else] = ACTIONS(5773),
    [sym__external_open_parenthesis] = ACTIONS(5767),
    [sym__external_open_brace] = ACTIONS(5167),
    [sym__external_close_brace] = ACTIONS(5167),
    [sym__external_open_bracket] = ACTIONS(5769),
    [sym__external_open_bracket2] = ACTIONS(5771),
  },
  [787] = {
    [sym_call_arguments] = STATE(2595),
    [sym_subset_arguments] = STATE(2594),
    [sym_subset2_arguments] = STATE(2592),
    [sym__else] = STATE(4240),
    [sym__open_parenthesis] = STATE(1423),
    [sym__open_bracket] = STATE(1419),
    [sym__open_bracket2] = STATE(1415),
    [ts_builtin_sym_end] = ACTIONS(5117),
    [sym_identifier] = ACTIONS(5115),
    [anon_sym_BSLASH] = ACTIONS(5117),
    [anon_sym_function] = ACTIONS(5115),
    [anon_sym_EQ] = ACTIONS(5727),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_for] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_repeat] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(5117),
    [anon_sym_TILDE] = ACTIONS(5729),
    [anon_sym_BANG] = ACTIONS(5115),
    [anon_sym_PLUS] = ACTIONS(5731),
    [anon_sym_DASH] = ACTIONS(5733),
    [anon_sym_LT_DASH] = ACTIONS(5735),
    [anon_sym_LT_LT_DASH] = ACTIONS(5735),
    [anon_sym_COLON_EQ] = ACTIONS(5735),
    [anon_sym_DASH_GT] = ACTIONS(5737),
    [anon_sym_DASH_GT_GT] = ACTIONS(5739),
    [anon_sym_PIPE] = ACTIONS(5741),
    [anon_sym_AMP] = ACTIONS(5743),
    [anon_sym_PIPE_PIPE] = ACTIONS(5745),
    [anon_sym_AMP_AMP] = ACTIONS(5747),
    [anon_sym_LT] = ACTIONS(5749),
    [anon_sym_LT_EQ] = ACTIONS(5751),
    [anon_sym_GT] = ACTIONS(5749),
    [anon_sym_GT_EQ] = ACTIONS(5751),
    [anon_sym_EQ_EQ] = ACTIONS(5751),
    [anon_sym_BANG_EQ] = ACTIONS(5751),
    [anon_sym_STAR] = ACTIONS(5753),
    [anon_sym_SLASH] = ACTIONS(5755),
    [anon_sym_STAR_STAR] = ACTIONS(5757),
    [anon_sym_CARET] = ACTIONS(5757),
    [aux_sym_binary_operator_token1] = ACTIONS(5759),
    [anon_sym_PIPE_GT] = ACTIONS(5759),
    [anon_sym_COLON] = ACTIONS(5761),
    [anon_sym_DOLLAR] = ACTIONS(5763),
    [anon_sym_AT] = ACTIONS(5763),
    [aux_sym__hex_literal_token1] = ACTIONS(5117),
    [sym__number_literal] = ACTIONS(5115),
    [anon_sym_SQUOTE] = ACTIONS(5117),
    [anon_sym_DQUOTE] = ACTIONS(5117),
    [sym_return] = ACTIONS(5115),
    [sym_next] = ACTIONS(5115),
    [sym_break] = ACTIONS(5115),
    [sym_true] = ACTIONS(5115),
    [sym_false] = ACTIONS(5115),
    [sym_null] = ACTIONS(5115),
    [sym_inf] = ACTIONS(5115),
    [sym_nan] = ACTIONS(5115),
    [anon_sym_NA] = ACTIONS(5115),
    [anon_sym_NA_integer_] = ACTIONS(5115),
    [anon_sym_NA_real_] = ACTIONS(5115),
    [anon_sym_NA_complex_] = ACTIONS(5115),
    [anon_sym_NA_character_] = ACTIONS(5115),
    [sym_dots] = ACTIONS(5115),
    [sym_dot_dot_i] = ACTIONS(5117),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5117),
    [sym__semicolon] = ACTIONS(5117),
    [sym__raw_string_literal] = ACTIONS(5117),
    [sym__external_else] = ACTIONS(5775),
    [sym__external_open_parenthesis] = ACTIONS(5767),
    [sym__external_open_brace] = ACTIONS(5117),
    [sym__external_close_brace] = ACTIONS(5117),
    [sym__external_open_bracket] = ACTIONS(5769),
    [sym__external_open_bracket2] = ACTIONS(5771),
  },
  [788] = {
    [sym_call_arguments] = STATE(2595),
    [sym_subset_arguments] = STATE(2594),
    [sym_subset2_arguments] = STATE(2592),
    [sym__else] = STATE(4299),
    [sym__open_parenthesis] = STATE(1423),
    [sym__open_bracket] = STATE(1419),
    [sym__open_bracket2] = STATE(1415),
    [ts_builtin_sym_end] = ACTIONS(5067),
    [sym_identifier] = ACTIONS(5065),
    [anon_sym_BSLASH] = ACTIONS(5067),
    [anon_sym_function] = ACTIONS(5065),
    [anon_sym_EQ] = ACTIONS(5727),
    [anon_sym_if] = ACTIONS(5065),
    [anon_sym_for] = ACTIONS(5065),
    [anon_sym_while] = ACTIONS(5065),
    [anon_sym_repeat] = ACTIONS(5065),
    [anon_sym_QMARK] = ACTIONS(5067),
    [anon_sym_TILDE] = ACTIONS(5729),
    [anon_sym_BANG] = ACTIONS(5065),
    [anon_sym_PLUS] = ACTIONS(5731),
    [anon_sym_DASH] = ACTIONS(5733),
    [anon_sym_LT_DASH] = ACTIONS(5735),
    [anon_sym_LT_LT_DASH] = ACTIONS(5735),
    [anon_sym_COLON_EQ] = ACTIONS(5735),
    [anon_sym_DASH_GT] = ACTIONS(5737),
    [anon_sym_DASH_GT_GT] = ACTIONS(5739),
    [anon_sym_PIPE] = ACTIONS(5741),
    [anon_sym_AMP] = ACTIONS(5743),
    [anon_sym_PIPE_PIPE] = ACTIONS(5745),
    [anon_sym_AMP_AMP] = ACTIONS(5747),
    [anon_sym_LT] = ACTIONS(5749),
    [anon_sym_LT_EQ] = ACTIONS(5751),
    [anon_sym_GT] = ACTIONS(5749),
    [anon_sym_GT_EQ] = ACTIONS(5751),
    [anon_sym_EQ_EQ] = ACTIONS(5751),
    [anon_sym_BANG_EQ] = ACTIONS(5751),
    [anon_sym_STAR] = ACTIONS(5753),
    [anon_sym_SLASH] = ACTIONS(5755),
    [anon_sym_STAR_STAR] = ACTIONS(5757),
    [anon_sym_CARET] = ACTIONS(5757),
    [aux_sym_binary_operator_token1] = ACTIONS(5759),
    [anon_sym_PIPE_GT] = ACTIONS(5759),
    [anon_sym_COLON] = ACTIONS(5761),
    [anon_sym_DOLLAR] = ACTIONS(5763),
    [anon_sym_AT] = ACTIONS(5763),
    [aux_sym__hex_literal_token1] = ACTIONS(5067),
    [sym__number_literal] = ACTIONS(5065),
    [anon_sym_SQUOTE] = ACTIONS(5067),
    [anon_sym_DQUOTE] = ACTIONS(5067),
    [sym_return] = ACTIONS(5065),
    [sym_next] = ACTIONS(5065),
    [sym_break] = ACTIONS(5065),
    [sym_true] = ACTIONS(5065),
    [sym_false] = ACTIONS(5065),
    [sym_null] = ACTIONS(5065),
    [sym_inf] = ACTIONS(5065),
    [sym_nan] = ACTIONS(5065),
    [anon_sym_NA] = ACTIONS(5065),
    [anon_sym_NA_integer_] = ACTIONS(5065),
    [anon_sym_NA_real_] = ACTIONS(5065),
    [anon_sym_NA_complex_] = ACTIONS(5065),
    [anon_sym_NA_character_] = ACTIONS(5065),
    [sym_dots] = ACTIONS(5065),
    [sym_dot_dot_i] = ACTIONS(5067),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5067),
    [sym__semicolon] = ACTIONS(5067),
    [sym__raw_string_literal] = ACTIONS(5067),
    [sym__external_else] = ACTIONS(5777),
    [sym__external_open_parenthesis] = ACTIONS(5767),
    [sym__external_open_brace] = ACTIONS(5067),
    [sym__external_close_brace] = ACTIONS(5067),
    [sym__external_open_bracket] = ACTIONS(5769),
    [sym__external_open_bracket2] = ACTIONS(5771),
  },
  [789] = {
    [sym_call_arguments] = STATE(2555),
    [sym_subset_arguments] = STATE(2554),
    [sym_subset2_arguments] = STATE(2553),
    [sym__open_parenthesis] = STATE(1332),
    [sym__open_bracket] = STATE(1331),
    [sym__open_bracket2] = STATE(1330),
    [sym_identifier] = ACTIONS(5325),
    [anon_sym_BSLASH] = ACTIONS(5327),
    [anon_sym_function] = ACTIONS(5325),
    [anon_sym_EQ] = ACTIONS(5265),
    [anon_sym_if] = ACTIONS(5325),
    [anon_sym_for] = ACTIONS(5325),
    [anon_sym_while] = ACTIONS(5325),
    [anon_sym_repeat] = ACTIONS(5325),
    [anon_sym_QMARK] = ACTIONS(5779),
    [anon_sym_TILDE] = ACTIONS(5267),
    [anon_sym_BANG] = ACTIONS(5325),
    [anon_sym_PLUS] = ACTIONS(5269),
    [anon_sym_DASH] = ACTIONS(5271),
    [anon_sym_LT_DASH] = ACTIONS(5273),
    [anon_sym_LT_LT_DASH] = ACTIONS(5273),
    [anon_sym_COLON_EQ] = ACTIONS(5273),
    [anon_sym_DASH_GT] = ACTIONS(5275),
    [anon_sym_DASH_GT_GT] = ACTIONS(5277),
    [anon_sym_PIPE] = ACTIONS(5279),
    [anon_sym_AMP] = ACTIONS(5281),
    [anon_sym_PIPE_PIPE] = ACTIONS(5283),
    [anon_sym_AMP_AMP] = ACTIONS(5285),
    [anon_sym_LT] = ACTIONS(5287),
    [anon_sym_LT_EQ] = ACTIONS(5289),
    [anon_sym_GT] = ACTIONS(5287),
    [anon_sym_GT_EQ] = ACTIONS(5289),
    [anon_sym_EQ_EQ] = ACTIONS(5289),
    [anon_sym_BANG_EQ] = ACTIONS(5289),
    [anon_sym_STAR] = ACTIONS(5291),
    [anon_sym_SLASH] = ACTIONS(5293),
    [anon_sym_STAR_STAR] = ACTIONS(5295),
    [anon_sym_CARET] = ACTIONS(5295),
    [aux_sym_binary_operator_token1] = ACTIONS(5297),
    [anon_sym_PIPE_GT] = ACTIONS(5297),
    [anon_sym_COLON] = ACTIONS(5299),
    [anon_sym_DOLLAR] = ACTIONS(5301),
    [anon_sym_AT] = ACTIONS(5301),
    [aux_sym__hex_literal_token1] = ACTIONS(5327),
    [sym__number_literal] = ACTIONS(5325),
    [anon_sym_SQUOTE] = ACTIONS(5327),
    [anon_sym_DQUOTE] = ACTIONS(5327),
    [sym_return] = ACTIONS(5325),
    [sym_next] = ACTIONS(5325),
    [sym_break] = ACTIONS(5325),
    [sym_true] = ACTIONS(5325),
    [sym_false] = ACTIONS(5325),
    [sym_null] = ACTIONS(5325),
    [sym_inf] = ACTIONS(5325),
    [sym_nan] = ACTIONS(5325),
    [anon_sym_NA] = ACTIONS(5325),
    [anon_sym_NA_integer_] = ACTIONS(5325),
    [anon_sym_NA_real_] = ACTIONS(5325),
    [anon_sym_NA_complex_] = ACTIONS(5325),
    [anon_sym_NA_character_] = ACTIONS(5325),
    [sym_dots] = ACTIONS(5325),
    [sym_dot_dot_i] = ACTIONS(5327),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5327),
    [sym__newline] = ACTIONS(5327),
    [sym__semicolon] = ACTIONS(5327),
    [sym__raw_string_literal] = ACTIONS(5327),
    [sym__external_else] = ACTIONS(5327),
    [sym__external_open_parenthesis] = ACTIONS(5305),
    [sym__external_open_brace] = ACTIONS(5327),
    [sym__external_close_brace] = ACTIONS(5327),
    [sym__external_open_bracket] = ACTIONS(5307),
    [sym__external_open_bracket2] = ACTIONS(5309),
    [sym__external_close_bracket2] = ACTIONS(5327),
  },
  [790] = {
    [sym_call_arguments] = STATE(2509),
    [sym_subset_arguments] = STATE(2507),
    [sym_subset2_arguments] = STATE(2505),
    [sym__open_parenthesis] = STATE(1590),
    [sym__open_bracket] = STATE(1589),
    [sym__open_bracket2] = STATE(1588),
    [ts_builtin_sym_end] = ACTIONS(5327),
    [sym_identifier] = ACTIONS(5325),
    [anon_sym_BSLASH] = ACTIONS(5327),
    [anon_sym_function] = ACTIONS(5325),
    [anon_sym_EQ] = ACTIONS(5475),
    [anon_sym_if] = ACTIONS(5325),
    [anon_sym_for] = ACTIONS(5325),
    [anon_sym_while] = ACTIONS(5325),
    [anon_sym_repeat] = ACTIONS(5325),
    [anon_sym_QMARK] = ACTIONS(5781),
    [anon_sym_TILDE] = ACTIONS(5477),
    [anon_sym_BANG] = ACTIONS(5325),
    [anon_sym_PLUS] = ACTIONS(5479),
    [anon_sym_DASH] = ACTIONS(5481),
    [anon_sym_LT_DASH] = ACTIONS(5483),
    [anon_sym_LT_LT_DASH] = ACTIONS(5483),
    [anon_sym_COLON_EQ] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5485),
    [anon_sym_DASH_GT_GT] = ACTIONS(5487),
    [anon_sym_PIPE] = ACTIONS(5489),
    [anon_sym_AMP] = ACTIONS(5491),
    [anon_sym_PIPE_PIPE] = ACTIONS(5493),
    [anon_sym_AMP_AMP] = ACTIONS(5495),
    [anon_sym_LT] = ACTIONS(5497),
    [anon_sym_LT_EQ] = ACTIONS(5499),
    [anon_sym_GT] = ACTIONS(5497),
    [anon_sym_GT_EQ] = ACTIONS(5499),
    [anon_sym_EQ_EQ] = ACTIONS(5499),
    [anon_sym_BANG_EQ] = ACTIONS(5499),
    [anon_sym_STAR] = ACTIONS(5501),
    [anon_sym_SLASH] = ACTIONS(5503),
    [anon_sym_STAR_STAR] = ACTIONS(5505),
    [anon_sym_CARET] = ACTIONS(5505),
    [aux_sym_binary_operator_token1] = ACTIONS(5507),
    [anon_sym_PIPE_GT] = ACTIONS(5507),
    [anon_sym_COLON] = ACTIONS(5509),
    [anon_sym_DOLLAR] = ACTIONS(5511),
    [anon_sym_AT] = ACTIONS(5511),
    [aux_sym__hex_literal_token1] = ACTIONS(5327),
    [sym__number_literal] = ACTIONS(5325),
    [anon_sym_SQUOTE] = ACTIONS(5327),
    [anon_sym_DQUOTE] = ACTIONS(5327),
    [sym_return] = ACTIONS(5325),
    [sym_next] = ACTIONS(5325),
    [sym_break] = ACTIONS(5325),
    [sym_true] = ACTIONS(5325),
    [sym_false] = ACTIONS(5325),
    [sym_null] = ACTIONS(5325),
    [sym_inf] = ACTIONS(5325),
    [sym_nan] = ACTIONS(5325),
    [anon_sym_NA] = ACTIONS(5325),
    [anon_sym_NA_integer_] = ACTIONS(5325),
    [anon_sym_NA_real_] = ACTIONS(5325),
    [anon_sym_NA_complex_] = ACTIONS(5325),
    [anon_sym_NA_character_] = ACTIONS(5325),
    [sym_dots] = ACTIONS(5325),
    [sym_dot_dot_i] = ACTIONS(5327),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5327),
    [sym__newline] = ACTIONS(5327),
    [sym__semicolon] = ACTIONS(5327),
    [sym__raw_string_literal] = ACTIONS(5327),
    [sym__external_open_parenthesis] = ACTIONS(5513),
    [sym__external_close_parenthesis] = ACTIONS(5327),
    [sym__external_open_brace] = ACTIONS(5327),
    [sym__external_close_brace] = ACTIONS(5327),
    [sym__external_open_bracket] = ACTIONS(5515),
    [sym__external_open_bracket2] = ACTIONS(5517),
  },
  [791] = {
    [sym_call_arguments] = STATE(2509),
    [sym_subset_arguments] = STATE(2507),
    [sym_subset2_arguments] = STATE(2505),
    [sym__open_parenthesis] = STATE(1590),
    [sym__open_bracket] = STATE(1589),
    [sym__open_bracket2] = STATE(1588),
    [ts_builtin_sym_end] = ACTIONS(5313),
    [sym_identifier] = ACTIONS(5311),
    [anon_sym_BSLASH] = ACTIONS(5313),
    [anon_sym_function] = ACTIONS(5311),
    [anon_sym_EQ] = ACTIONS(5475),
    [anon_sym_if] = ACTIONS(5311),
    [anon_sym_for] = ACTIONS(5311),
    [anon_sym_while] = ACTIONS(5311),
    [anon_sym_repeat] = ACTIONS(5311),
    [anon_sym_QMARK] = ACTIONS(5781),
    [anon_sym_TILDE] = ACTIONS(5477),
    [anon_sym_BANG] = ACTIONS(5311),
    [anon_sym_PLUS] = ACTIONS(5479),
    [anon_sym_DASH] = ACTIONS(5481),
    [anon_sym_LT_DASH] = ACTIONS(5483),
    [anon_sym_LT_LT_DASH] = ACTIONS(5483),
    [anon_sym_COLON_EQ] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5485),
    [anon_sym_DASH_GT_GT] = ACTIONS(5487),
    [anon_sym_PIPE] = ACTIONS(5489),
    [anon_sym_AMP] = ACTIONS(5491),
    [anon_sym_PIPE_PIPE] = ACTIONS(5493),
    [anon_sym_AMP_AMP] = ACTIONS(5495),
    [anon_sym_LT] = ACTIONS(5497),
    [anon_sym_LT_EQ] = ACTIONS(5499),
    [anon_sym_GT] = ACTIONS(5497),
    [anon_sym_GT_EQ] = ACTIONS(5499),
    [anon_sym_EQ_EQ] = ACTIONS(5499),
    [anon_sym_BANG_EQ] = ACTIONS(5499),
    [anon_sym_STAR] = ACTIONS(5501),
    [anon_sym_SLASH] = ACTIONS(5503),
    [anon_sym_STAR_STAR] = ACTIONS(5505),
    [anon_sym_CARET] = ACTIONS(5505),
    [aux_sym_binary_operator_token1] = ACTIONS(5507),
    [anon_sym_PIPE_GT] = ACTIONS(5507),
    [anon_sym_COLON] = ACTIONS(5509),
    [anon_sym_DOLLAR] = ACTIONS(5511),
    [anon_sym_AT] = ACTIONS(5511),
    [aux_sym__hex_literal_token1] = ACTIONS(5313),
    [sym__number_literal] = ACTIONS(5311),
    [anon_sym_SQUOTE] = ACTIONS(5313),
    [anon_sym_DQUOTE] = ACTIONS(5313),
    [sym_return] = ACTIONS(5311),
    [sym_next] = ACTIONS(5311),
    [sym_break] = ACTIONS(5311),
    [sym_true] = ACTIONS(5311),
    [sym_false] = ACTIONS(5311),
    [sym_null] = ACTIONS(5311),
    [sym_inf] = ACTIONS(5311),
    [sym_nan] = ACTIONS(5311),
    [anon_sym_NA] = ACTIONS(5311),
    [anon_sym_NA_integer_] = ACTIONS(5311),
    [anon_sym_NA_real_] = ACTIONS(5311),
    [anon_sym_NA_complex_] = ACTIONS(5311),
    [anon_sym_NA_character_] = ACTIONS(5311),
    [sym_dots] = ACTIONS(5311),
    [sym_dot_dot_i] = ACTIONS(5313),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5313),
    [sym__newline] = ACTIONS(5313),
    [sym__semicolon] = ACTIONS(5313),
    [sym__raw_string_literal] = ACTIONS(5313),
    [sym__external_open_parenthesis] = ACTIONS(5513),
    [sym__external_close_parenthesis] = ACTIONS(5313),
    [sym__external_open_brace] = ACTIONS(5313),
    [sym__external_close_brace] = ACTIONS(5313),
    [sym__external_open_bracket] = ACTIONS(5515),
    [sym__external_open_bracket2] = ACTIONS(5517),
  },
  [792] = {
    [sym_call_arguments] = STATE(2731),
    [sym_subset_arguments] = STATE(2730),
    [sym_subset2_arguments] = STATE(2729),
    [sym__else] = STATE(4316),
    [sym__open_parenthesis] = STATE(1357),
    [sym__open_bracket] = STATE(1353),
    [sym__open_bracket2] = STATE(1352),
    [sym_identifier] = ACTIONS(5065),
    [anon_sym_BSLASH] = ACTIONS(5067),
    [anon_sym_function] = ACTIONS(5065),
    [anon_sym_EQ] = ACTIONS(5783),
    [anon_sym_if] = ACTIONS(5065),
    [anon_sym_for] = ACTIONS(5065),
    [anon_sym_while] = ACTIONS(5065),
    [anon_sym_repeat] = ACTIONS(5065),
    [anon_sym_QMARK] = ACTIONS(5067),
    [anon_sym_TILDE] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(5065),
    [anon_sym_PLUS] = ACTIONS(5787),
    [anon_sym_DASH] = ACTIONS(5789),
    [anon_sym_LT_DASH] = ACTIONS(5791),
    [anon_sym_LT_LT_DASH] = ACTIONS(5791),
    [anon_sym_COLON_EQ] = ACTIONS(5791),
    [anon_sym_DASH_GT] = ACTIONS(5793),
    [anon_sym_DASH_GT_GT] = ACTIONS(5795),
    [anon_sym_PIPE] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5799),
    [anon_sym_PIPE_PIPE] = ACTIONS(5801),
    [anon_sym_AMP_AMP] = ACTIONS(5803),
    [anon_sym_LT] = ACTIONS(5805),
    [anon_sym_LT_EQ] = ACTIONS(5807),
    [anon_sym_GT] = ACTIONS(5805),
    [anon_sym_GT_EQ] = ACTIONS(5807),
    [anon_sym_EQ_EQ] = ACTIONS(5807),
    [anon_sym_BANG_EQ] = ACTIONS(5807),
    [anon_sym_STAR] = ACTIONS(5809),
    [anon_sym_SLASH] = ACTIONS(5811),
    [anon_sym_STAR_STAR] = ACTIONS(5813),
    [anon_sym_CARET] = ACTIONS(5813),
    [aux_sym_binary_operator_token1] = ACTIONS(5815),
    [anon_sym_PIPE_GT] = ACTIONS(5815),
    [anon_sym_COLON] = ACTIONS(5817),
    [anon_sym_DOLLAR] = ACTIONS(5819),
    [anon_sym_AT] = ACTIONS(5819),
    [aux_sym__hex_literal_token1] = ACTIONS(5067),
    [sym__number_literal] = ACTIONS(5065),
    [anon_sym_SQUOTE] = ACTIONS(5067),
    [anon_sym_DQUOTE] = ACTIONS(5067),
    [sym_return] = ACTIONS(5065),
    [sym_next] = ACTIONS(5065),
    [sym_break] = ACTIONS(5065),
    [sym_true] = ACTIONS(5065),
    [sym_false] = ACTIONS(5065),
    [sym_null] = ACTIONS(5065),
    [sym_inf] = ACTIONS(5065),
    [sym_nan] = ACTIONS(5065),
    [anon_sym_NA] = ACTIONS(5065),
    [anon_sym_NA_integer_] = ACTIONS(5065),
    [anon_sym_NA_real_] = ACTIONS(5065),
    [anon_sym_NA_complex_] = ACTIONS(5065),
    [anon_sym_NA_character_] = ACTIONS(5065),
    [sym_dots] = ACTIONS(5065),
    [sym_dot_dot_i] = ACTIONS(5067),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5067),
    [sym__newline] = ACTIONS(5067),
    [sym__raw_string_literal] = ACTIONS(5067),
    [sym__external_else] = ACTIONS(5821),
    [sym__external_open_parenthesis] = ACTIONS(5823),
    [sym__external_close_parenthesis] = ACTIONS(5067),
    [sym__external_open_brace] = ACTIONS(5067),
    [sym__external_open_bracket] = ACTIONS(5825),
    [sym__external_close_bracket] = ACTIONS(5067),
    [sym__external_open_bracket2] = ACTIONS(5827),
  },
  [793] = {
    [sym_call_arguments] = STATE(2731),
    [sym_subset_arguments] = STATE(2730),
    [sym_subset2_arguments] = STATE(2729),
    [sym__else] = STATE(4319),
    [sym__open_parenthesis] = STATE(1357),
    [sym__open_bracket] = STATE(1353),
    [sym__open_bracket2] = STATE(1352),
    [sym_identifier] = ACTIONS(5115),
    [anon_sym_BSLASH] = ACTIONS(5117),
    [anon_sym_function] = ACTIONS(5115),
    [anon_sym_EQ] = ACTIONS(5783),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_for] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_repeat] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(5117),
    [anon_sym_TILDE] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(5115),
    [anon_sym_PLUS] = ACTIONS(5787),
    [anon_sym_DASH] = ACTIONS(5789),
    [anon_sym_LT_DASH] = ACTIONS(5791),
    [anon_sym_LT_LT_DASH] = ACTIONS(5791),
    [anon_sym_COLON_EQ] = ACTIONS(5791),
    [anon_sym_DASH_GT] = ACTIONS(5793),
    [anon_sym_DASH_GT_GT] = ACTIONS(5795),
    [anon_sym_PIPE] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5799),
    [anon_sym_PIPE_PIPE] = ACTIONS(5801),
    [anon_sym_AMP_AMP] = ACTIONS(5803),
    [anon_sym_LT] = ACTIONS(5805),
    [anon_sym_LT_EQ] = ACTIONS(5807),
    [anon_sym_GT] = ACTIONS(5805),
    [anon_sym_GT_EQ] = ACTIONS(5807),
    [anon_sym_EQ_EQ] = ACTIONS(5807),
    [anon_sym_BANG_EQ] = ACTIONS(5807),
    [anon_sym_STAR] = ACTIONS(5809),
    [anon_sym_SLASH] = ACTIONS(5811),
    [anon_sym_STAR_STAR] = ACTIONS(5813),
    [anon_sym_CARET] = ACTIONS(5813),
    [aux_sym_binary_operator_token1] = ACTIONS(5815),
    [anon_sym_PIPE_GT] = ACTIONS(5815),
    [anon_sym_COLON] = ACTIONS(5817),
    [anon_sym_DOLLAR] = ACTIONS(5819),
    [anon_sym_AT] = ACTIONS(5819),
    [aux_sym__hex_literal_token1] = ACTIONS(5117),
    [sym__number_literal] = ACTIONS(5115),
    [anon_sym_SQUOTE] = ACTIONS(5117),
    [anon_sym_DQUOTE] = ACTIONS(5117),
    [sym_return] = ACTIONS(5115),
    [sym_next] = ACTIONS(5115),
    [sym_break] = ACTIONS(5115),
    [sym_true] = ACTIONS(5115),
    [sym_false] = ACTIONS(5115),
    [sym_null] = ACTIONS(5115),
    [sym_inf] = ACTIONS(5115),
    [sym_nan] = ACTIONS(5115),
    [anon_sym_NA] = ACTIONS(5115),
    [anon_sym_NA_integer_] = ACTIONS(5115),
    [anon_sym_NA_real_] = ACTIONS(5115),
    [anon_sym_NA_complex_] = ACTIONS(5115),
    [anon_sym_NA_character_] = ACTIONS(5115),
    [sym_dots] = ACTIONS(5115),
    [sym_dot_dot_i] = ACTIONS(5117),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5117),
    [sym__newline] = ACTIONS(5117),
    [sym__raw_string_literal] = ACTIONS(5117),
    [sym__external_else] = ACTIONS(5829),
    [sym__external_open_parenthesis] = ACTIONS(5823),
    [sym__external_close_parenthesis] = ACTIONS(5117),
    [sym__external_open_brace] = ACTIONS(5117),
    [sym__external_open_bracket] = ACTIONS(5825),
    [sym__external_close_bracket] = ACTIONS(5117),
    [sym__external_open_bracket2] = ACTIONS(5827),
  },
  [794] = {
    [sym_call_arguments] = STATE(2731),
    [sym_subset_arguments] = STATE(2730),
    [sym_subset2_arguments] = STATE(2729),
    [sym__else] = STATE(4323),
    [sym__open_parenthesis] = STATE(1357),
    [sym__open_bracket] = STATE(1353),
    [sym__open_bracket2] = STATE(1352),
    [sym_identifier] = ACTIONS(5169),
    [anon_sym_BSLASH] = ACTIONS(5167),
    [anon_sym_function] = ACTIONS(5169),
    [anon_sym_EQ] = ACTIONS(5783),
    [anon_sym_if] = ACTIONS(5169),
    [anon_sym_for] = ACTIONS(5169),
    [anon_sym_while] = ACTIONS(5169),
    [anon_sym_repeat] = ACTIONS(5169),
    [anon_sym_QMARK] = ACTIONS(5167),
    [anon_sym_TILDE] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(5169),
    [anon_sym_PLUS] = ACTIONS(5787),
    [anon_sym_DASH] = ACTIONS(5789),
    [anon_sym_LT_DASH] = ACTIONS(5791),
    [anon_sym_LT_LT_DASH] = ACTIONS(5791),
    [anon_sym_COLON_EQ] = ACTIONS(5791),
    [anon_sym_DASH_GT] = ACTIONS(5793),
    [anon_sym_DASH_GT_GT] = ACTIONS(5795),
    [anon_sym_PIPE] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5799),
    [anon_sym_PIPE_PIPE] = ACTIONS(5801),
    [anon_sym_AMP_AMP] = ACTIONS(5803),
    [anon_sym_LT] = ACTIONS(5805),
    [anon_sym_LT_EQ] = ACTIONS(5807),
    [anon_sym_GT] = ACTIONS(5805),
    [anon_sym_GT_EQ] = ACTIONS(5807),
    [anon_sym_EQ_EQ] = ACTIONS(5807),
    [anon_sym_BANG_EQ] = ACTIONS(5807),
    [anon_sym_STAR] = ACTIONS(5809),
    [anon_sym_SLASH] = ACTIONS(5811),
    [anon_sym_STAR_STAR] = ACTIONS(5813),
    [anon_sym_CARET] = ACTIONS(5813),
    [aux_sym_binary_operator_token1] = ACTIONS(5815),
    [anon_sym_PIPE_GT] = ACTIONS(5815),
    [anon_sym_COLON] = ACTIONS(5817),
    [anon_sym_DOLLAR] = ACTIONS(5819),
    [anon_sym_AT] = ACTIONS(5819),
    [aux_sym__hex_literal_token1] = ACTIONS(5167),
    [sym__number_literal] = ACTIONS(5169),
    [anon_sym_SQUOTE] = ACTIONS(5167),
    [anon_sym_DQUOTE] = ACTIONS(5167),
    [sym_return] = ACTIONS(5169),
    [sym_next] = ACTIONS(5169),
    [sym_break] = ACTIONS(5169),
    [sym_true] = ACTIONS(5169),
    [sym_false] = ACTIONS(5169),
    [sym_null] = ACTIONS(5169),
    [sym_inf] = ACTIONS(5169),
    [sym_nan] = ACTIONS(5169),
    [anon_sym_NA] = ACTIONS(5169),
    [anon_sym_NA_integer_] = ACTIONS(5169),
    [anon_sym_NA_real_] = ACTIONS(5169),
    [anon_sym_NA_complex_] = ACTIONS(5169),
    [anon_sym_NA_character_] = ACTIONS(5169),
    [sym_dots] = ACTIONS(5169),
    [sym_dot_dot_i] = ACTIONS(5167),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5167),
    [sym__newline] = ACTIONS(5167),
    [sym__raw_string_literal] = ACTIONS(5167),
    [sym__external_else] = ACTIONS(5831),
    [sym__external_open_parenthesis] = ACTIONS(5823),
    [sym__external_close_parenthesis] = ACTIONS(5167),
    [sym__external_open_brace] = ACTIONS(5167),
    [sym__external_open_bracket] = ACTIONS(5825),
    [sym__external_close_bracket] = ACTIONS(5167),
    [sym__external_open_bracket2] = ACTIONS(5827),
  },
  [795] = {
    [sym_call_arguments] = STATE(2731),
    [sym_subset_arguments] = STATE(2730),
    [sym_subset2_arguments] = STATE(2729),
    [sym__else] = STATE(4327),
    [sym__open_parenthesis] = STATE(1357),
    [sym__open_bracket] = STATE(1353),
    [sym__open_bracket2] = STATE(1352),
    [sym_identifier] = ACTIONS(5225),
    [anon_sym_BSLASH] = ACTIONS(5227),
    [anon_sym_function] = ACTIONS(5225),
    [anon_sym_EQ] = ACTIONS(5783),
    [anon_sym_if] = ACTIONS(5225),
    [anon_sym_for] = ACTIONS(5225),
    [anon_sym_while] = ACTIONS(5225),
    [anon_sym_repeat] = ACTIONS(5225),
    [anon_sym_QMARK] = ACTIONS(5227),
    [anon_sym_TILDE] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(5225),
    [anon_sym_PLUS] = ACTIONS(5787),
    [anon_sym_DASH] = ACTIONS(5789),
    [anon_sym_LT_DASH] = ACTIONS(5791),
    [anon_sym_LT_LT_DASH] = ACTIONS(5791),
    [anon_sym_COLON_EQ] = ACTIONS(5791),
    [anon_sym_DASH_GT] = ACTIONS(5793),
    [anon_sym_DASH_GT_GT] = ACTIONS(5795),
    [anon_sym_PIPE] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5799),
    [anon_sym_PIPE_PIPE] = ACTIONS(5801),
    [anon_sym_AMP_AMP] = ACTIONS(5803),
    [anon_sym_LT] = ACTIONS(5805),
    [anon_sym_LT_EQ] = ACTIONS(5807),
    [anon_sym_GT] = ACTIONS(5805),
    [anon_sym_GT_EQ] = ACTIONS(5807),
    [anon_sym_EQ_EQ] = ACTIONS(5807),
    [anon_sym_BANG_EQ] = ACTIONS(5807),
    [anon_sym_STAR] = ACTIONS(5809),
    [anon_sym_SLASH] = ACTIONS(5811),
    [anon_sym_STAR_STAR] = ACTIONS(5813),
    [anon_sym_CARET] = ACTIONS(5813),
    [aux_sym_binary_operator_token1] = ACTIONS(5815),
    [anon_sym_PIPE_GT] = ACTIONS(5815),
    [anon_sym_COLON] = ACTIONS(5817),
    [anon_sym_DOLLAR] = ACTIONS(5819),
    [anon_sym_AT] = ACTIONS(5819),
    [aux_sym__hex_literal_token1] = ACTIONS(5227),
    [sym__number_literal] = ACTIONS(5225),
    [anon_sym_SQUOTE] = ACTIONS(5227),
    [anon_sym_DQUOTE] = ACTIONS(5227),
    [sym_return] = ACTIONS(5225),
    [sym_next] = ACTIONS(5225),
    [sym_break] = ACTIONS(5225),
    [sym_true] = ACTIONS(5225),
    [sym_false] = ACTIONS(5225),
    [sym_null] = ACTIONS(5225),
    [sym_inf] = ACTIONS(5225),
    [sym_nan] = ACTIONS(5225),
    [anon_sym_NA] = ACTIONS(5225),
    [anon_sym_NA_integer_] = ACTIONS(5225),
    [anon_sym_NA_real_] = ACTIONS(5225),
    [anon_sym_NA_complex_] = ACTIONS(5225),
    [anon_sym_NA_character_] = ACTIONS(5225),
    [sym_dots] = ACTIONS(5225),
    [sym_dot_dot_i] = ACTIONS(5227),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5227),
    [sym__newline] = ACTIONS(5227),
    [sym__raw_string_literal] = ACTIONS(5227),
    [sym__external_else] = ACTIONS(5833),
    [sym__external_open_parenthesis] = ACTIONS(5823),
    [sym__external_close_parenthesis] = ACTIONS(5227),
    [sym__external_open_brace] = ACTIONS(5227),
    [sym__external_open_bracket] = ACTIONS(5825),
    [sym__external_close_bracket] = ACTIONS(5227),
    [sym__external_open_bracket2] = ACTIONS(5827),
  },
  [796] = {
    [sym_call_arguments] = STATE(2438),
    [sym_subset_arguments] = STATE(2439),
    [sym_subset2_arguments] = STATE(2440),
    [sym__open_parenthesis] = STATE(1350),
    [sym__open_bracket] = STATE(1348),
    [sym__open_bracket2] = STATE(1346),
    [sym_identifier] = ACTIONS(5325),
    [anon_sym_BSLASH] = ACTIONS(5327),
    [anon_sym_function] = ACTIONS(5325),
    [anon_sym_EQ] = ACTIONS(5353),
    [anon_sym_if] = ACTIONS(5325),
    [anon_sym_for] = ACTIONS(5325),
    [anon_sym_while] = ACTIONS(5325),
    [anon_sym_repeat] = ACTIONS(5325),
    [anon_sym_QMARK] = ACTIONS(5835),
    [anon_sym_TILDE] = ACTIONS(5355),
    [anon_sym_BANG] = ACTIONS(5325),
    [anon_sym_PLUS] = ACTIONS(5357),
    [anon_sym_DASH] = ACTIONS(5359),
    [anon_sym_LT_DASH] = ACTIONS(5361),
    [anon_sym_LT_LT_DASH] = ACTIONS(5361),
    [anon_sym_COLON_EQ] = ACTIONS(5361),
    [anon_sym_DASH_GT] = ACTIONS(5363),
    [anon_sym_DASH_GT_GT] = ACTIONS(5365),
    [anon_sym_PIPE] = ACTIONS(5367),
    [anon_sym_AMP] = ACTIONS(5369),
    [anon_sym_PIPE_PIPE] = ACTIONS(5371),
    [anon_sym_AMP_AMP] = ACTIONS(5373),
    [anon_sym_LT] = ACTIONS(5375),
    [anon_sym_LT_EQ] = ACTIONS(5377),
    [anon_sym_GT] = ACTIONS(5375),
    [anon_sym_GT_EQ] = ACTIONS(5377),
    [anon_sym_EQ_EQ] = ACTIONS(5377),
    [anon_sym_BANG_EQ] = ACTIONS(5377),
    [anon_sym_STAR] = ACTIONS(5379),
    [anon_sym_SLASH] = ACTIONS(5381),
    [anon_sym_STAR_STAR] = ACTIONS(5383),
    [anon_sym_CARET] = ACTIONS(5383),
    [aux_sym_binary_operator_token1] = ACTIONS(5385),
    [anon_sym_PIPE_GT] = ACTIONS(5385),
    [anon_sym_COLON] = ACTIONS(5387),
    [anon_sym_DOLLAR] = ACTIONS(5389),
    [anon_sym_AT] = ACTIONS(5389),
    [aux_sym__hex_literal_token1] = ACTIONS(5327),
    [sym__number_literal] = ACTIONS(5325),
    [anon_sym_SQUOTE] = ACTIONS(5327),
    [anon_sym_DQUOTE] = ACTIONS(5327),
    [sym_return] = ACTIONS(5325),
    [sym_next] = ACTIONS(5325),
    [sym_break] = ACTIONS(5325),
    [sym_true] = ACTIONS(5325),
    [sym_false] = ACTIONS(5325),
    [sym_null] = ACTIONS(5325),
    [sym_inf] = ACTIONS(5325),
    [sym_nan] = ACTIONS(5325),
    [anon_sym_NA] = ACTIONS(5325),
    [anon_sym_NA_integer_] = ACTIONS(5325),
    [anon_sym_NA_real_] = ACTIONS(5325),
    [anon_sym_NA_complex_] = ACTIONS(5325),
    [anon_sym_NA_character_] = ACTIONS(5325),
    [sym_dots] = ACTIONS(5325),
    [sym_dot_dot_i] = ACTIONS(5327),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5327),
    [sym__newline] = ACTIONS(5327),
    [sym__semicolon] = ACTIONS(5327),
    [sym__raw_string_literal] = ACTIONS(5327),
    [sym__external_else] = ACTIONS(5327),
    [sym__external_open_parenthesis] = ACTIONS(5393),
    [sym__external_open_brace] = ACTIONS(5327),
    [sym__external_close_brace] = ACTIONS(5327),
    [sym__external_open_bracket] = ACTIONS(5395),
    [sym__external_close_bracket] = ACTIONS(5327),
    [sym__external_open_bracket2] = ACTIONS(5397),
  },
  [797] = {
    [sym_call_arguments] = STATE(2438),
    [sym_subset_arguments] = STATE(2439),
    [sym_subset2_arguments] = STATE(2440),
    [sym__open_parenthesis] = STATE(1350),
    [sym__open_bracket] = STATE(1348),
    [sym__open_bracket2] = STATE(1346),
    [sym_identifier] = ACTIONS(5331),
    [anon_sym_BSLASH] = ACTIONS(5329),
    [anon_sym_function] = ACTIONS(5331),
    [anon_sym_EQ] = ACTIONS(5353),
    [anon_sym_if] = ACTIONS(5331),
    [anon_sym_for] = ACTIONS(5331),
    [anon_sym_while] = ACTIONS(5331),
    [anon_sym_repeat] = ACTIONS(5331),
    [anon_sym_QMARK] = ACTIONS(5329),
    [anon_sym_TILDE] = ACTIONS(5355),
    [anon_sym_BANG] = ACTIONS(5331),
    [anon_sym_PLUS] = ACTIONS(5357),
    [anon_sym_DASH] = ACTIONS(5359),
    [anon_sym_LT_DASH] = ACTIONS(5361),
    [anon_sym_LT_LT_DASH] = ACTIONS(5361),
    [anon_sym_COLON_EQ] = ACTIONS(5361),
    [anon_sym_DASH_GT] = ACTIONS(5363),
    [anon_sym_DASH_GT_GT] = ACTIONS(5365),
    [anon_sym_PIPE] = ACTIONS(5367),
    [anon_sym_AMP] = ACTIONS(5369),
    [anon_sym_PIPE_PIPE] = ACTIONS(5371),
    [anon_sym_AMP_AMP] = ACTIONS(5373),
    [anon_sym_LT] = ACTIONS(5375),
    [anon_sym_LT_EQ] = ACTIONS(5377),
    [anon_sym_GT] = ACTIONS(5375),
    [anon_sym_GT_EQ] = ACTIONS(5377),
    [anon_sym_EQ_EQ] = ACTIONS(5377),
    [anon_sym_BANG_EQ] = ACTIONS(5377),
    [anon_sym_STAR] = ACTIONS(5379),
    [anon_sym_SLASH] = ACTIONS(5381),
    [anon_sym_STAR_STAR] = ACTIONS(5383),
    [anon_sym_CARET] = ACTIONS(5383),
    [aux_sym_binary_operator_token1] = ACTIONS(5385),
    [anon_sym_PIPE_GT] = ACTIONS(5385),
    [anon_sym_COLON] = ACTIONS(5387),
    [anon_sym_DOLLAR] = ACTIONS(5389),
    [anon_sym_AT] = ACTIONS(5389),
    [aux_sym__hex_literal_token1] = ACTIONS(5329),
    [sym__number_literal] = ACTIONS(5331),
    [anon_sym_SQUOTE] = ACTIONS(5329),
    [anon_sym_DQUOTE] = ACTIONS(5329),
    [sym_return] = ACTIONS(5331),
    [sym_next] = ACTIONS(5331),
    [sym_break] = ACTIONS(5331),
    [sym_true] = ACTIONS(5331),
    [sym_false] = ACTIONS(5331),
    [sym_null] = ACTIONS(5331),
    [sym_inf] = ACTIONS(5331),
    [sym_nan] = ACTIONS(5331),
    [anon_sym_NA] = ACTIONS(5331),
    [anon_sym_NA_integer_] = ACTIONS(5331),
    [anon_sym_NA_real_] = ACTIONS(5331),
    [anon_sym_NA_complex_] = ACTIONS(5331),
    [anon_sym_NA_character_] = ACTIONS(5331),
    [sym_dots] = ACTIONS(5331),
    [sym_dot_dot_i] = ACTIONS(5329),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5329),
    [sym__newline] = ACTIONS(5329),
    [sym__semicolon] = ACTIONS(5329),
    [sym__raw_string_literal] = ACTIONS(5329),
    [sym__external_else] = ACTIONS(5329),
    [sym__external_open_parenthesis] = ACTIONS(5393),
    [sym__external_open_brace] = ACTIONS(5329),
    [sym__external_close_brace] = ACTIONS(5329),
    [sym__external_open_bracket] = ACTIONS(5395),
    [sym__external_close_bracket] = ACTIONS(5329),
    [sym__external_open_bracket2] = ACTIONS(5397),
  },
  [798] = {
    [sym_call_arguments] = STATE(2438),
    [sym_subset_arguments] = STATE(2439),
    [sym_subset2_arguments] = STATE(2440),
    [sym__open_parenthesis] = STATE(1350),
    [sym__open_bracket] = STATE(1348),
    [sym__open_bracket2] = STATE(1346),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5353),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5355),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(5357),
    [anon_sym_DASH] = ACTIONS(5359),
    [anon_sym_LT_DASH] = ACTIONS(5361),
    [anon_sym_LT_LT_DASH] = ACTIONS(5361),
    [anon_sym_COLON_EQ] = ACTIONS(5361),
    [anon_sym_DASH_GT] = ACTIONS(5363),
    [anon_sym_DASH_GT_GT] = ACTIONS(5365),
    [anon_sym_PIPE] = ACTIONS(5367),
    [anon_sym_AMP] = ACTIONS(5369),
    [anon_sym_PIPE_PIPE] = ACTIONS(5371),
    [anon_sym_AMP_AMP] = ACTIONS(5373),
    [anon_sym_LT] = ACTIONS(5375),
    [anon_sym_LT_EQ] = ACTIONS(5377),
    [anon_sym_GT] = ACTIONS(5375),
    [anon_sym_GT_EQ] = ACTIONS(5377),
    [anon_sym_EQ_EQ] = ACTIONS(5377),
    [anon_sym_BANG_EQ] = ACTIONS(5377),
    [anon_sym_STAR] = ACTIONS(5379),
    [anon_sym_SLASH] = ACTIONS(5381),
    [anon_sym_STAR_STAR] = ACTIONS(5383),
    [anon_sym_CARET] = ACTIONS(5383),
    [aux_sym_binary_operator_token1] = ACTIONS(5385),
    [anon_sym_PIPE_GT] = ACTIONS(5385),
    [anon_sym_COLON] = ACTIONS(5387),
    [anon_sym_DOLLAR] = ACTIONS(5389),
    [anon_sym_AT] = ACTIONS(5389),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__semicolon] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_else] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(5393),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_close_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(5395),
    [sym__external_close_bracket] = ACTIONS(5333),
    [sym__external_open_bracket2] = ACTIONS(5397),
  },
  [799] = {
    [sym_call_arguments] = STATE(2438),
    [sym_subset_arguments] = STATE(2439),
    [sym_subset2_arguments] = STATE(2440),
    [sym__open_parenthesis] = STATE(1350),
    [sym__open_bracket] = STATE(1348),
    [sym__open_bracket2] = STATE(1346),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(5357),
    [anon_sym_DASH] = ACTIONS(5359),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5367),
    [anon_sym_AMP] = ACTIONS(5369),
    [anon_sym_PIPE_PIPE] = ACTIONS(5371),
    [anon_sym_AMP_AMP] = ACTIONS(5373),
    [anon_sym_LT] = ACTIONS(5375),
    [anon_sym_LT_EQ] = ACTIONS(5377),
    [anon_sym_GT] = ACTIONS(5375),
    [anon_sym_GT_EQ] = ACTIONS(5377),
    [anon_sym_EQ_EQ] = ACTIONS(5377),
    [anon_sym_BANG_EQ] = ACTIONS(5377),
    [anon_sym_STAR] = ACTIONS(5379),
    [anon_sym_SLASH] = ACTIONS(5381),
    [anon_sym_STAR_STAR] = ACTIONS(5383),
    [anon_sym_CARET] = ACTIONS(5383),
    [aux_sym_binary_operator_token1] = ACTIONS(5385),
    [anon_sym_PIPE_GT] = ACTIONS(5385),
    [anon_sym_COLON] = ACTIONS(5387),
    [anon_sym_DOLLAR] = ACTIONS(5389),
    [anon_sym_AT] = ACTIONS(5389),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__semicolon] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_else] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(5393),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_close_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(5395),
    [sym__external_close_bracket] = ACTIONS(5333),
    [sym__external_open_bracket2] = ACTIONS(5397),
  },
  [800] = {
    [sym_call_arguments] = STATE(2438),
    [sym_subset_arguments] = STATE(2439),
    [sym_subset2_arguments] = STATE(2440),
    [sym__open_parenthesis] = STATE(1350),
    [sym__open_bracket] = STATE(1348),
    [sym__open_bracket2] = STATE(1346),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(5357),
    [anon_sym_DASH] = ACTIONS(5359),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5335),
    [anon_sym_AMP] = ACTIONS(5335),
    [anon_sym_PIPE_PIPE] = ACTIONS(5333),
    [anon_sym_AMP_AMP] = ACTIONS(5333),
    [anon_sym_LT] = ACTIONS(5375),
    [anon_sym_LT_EQ] = ACTIONS(5377),
    [anon_sym_GT] = ACTIONS(5375),
    [anon_sym_GT_EQ] = ACTIONS(5377),
    [anon_sym_EQ_EQ] = ACTIONS(5377),
    [anon_sym_BANG_EQ] = ACTIONS(5377),
    [anon_sym_STAR] = ACTIONS(5379),
    [anon_sym_SLASH] = ACTIONS(5381),
    [anon_sym_STAR_STAR] = ACTIONS(5383),
    [anon_sym_CARET] = ACTIONS(5383),
    [aux_sym_binary_operator_token1] = ACTIONS(5385),
    [anon_sym_PIPE_GT] = ACTIONS(5385),
    [anon_sym_COLON] = ACTIONS(5387),
    [anon_sym_DOLLAR] = ACTIONS(5389),
    [anon_sym_AT] = ACTIONS(5389),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__semicolon] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_else] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(5393),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_close_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(5395),
    [sym__external_close_bracket] = ACTIONS(5333),
    [sym__external_open_bracket2] = ACTIONS(5397),
  },
  [801] = {
    [sym_call_arguments] = STATE(2438),
    [sym_subset_arguments] = STATE(2439),
    [sym_subset2_arguments] = STATE(2440),
    [sym__open_parenthesis] = STATE(1350),
    [sym__open_bracket] = STATE(1348),
    [sym__open_bracket2] = STATE(1346),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(5333),
    [anon_sym_DASH] = ACTIONS(5335),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5335),
    [anon_sym_AMP] = ACTIONS(5335),
    [anon_sym_PIPE_PIPE] = ACTIONS(5333),
    [anon_sym_AMP_AMP] = ACTIONS(5333),
    [anon_sym_LT] = ACTIONS(5335),
    [anon_sym_LT_EQ] = ACTIONS(5333),
    [anon_sym_GT] = ACTIONS(5335),
    [anon_sym_GT_EQ] = ACTIONS(5333),
    [anon_sym_EQ_EQ] = ACTIONS(5333),
    [anon_sym_BANG_EQ] = ACTIONS(5333),
    [anon_sym_STAR] = ACTIONS(5335),
    [anon_sym_SLASH] = ACTIONS(5333),
    [anon_sym_STAR_STAR] = ACTIONS(5383),
    [anon_sym_CARET] = ACTIONS(5383),
    [aux_sym_binary_operator_token1] = ACTIONS(5333),
    [anon_sym_PIPE_GT] = ACTIONS(5333),
    [anon_sym_COLON] = ACTIONS(5335),
    [anon_sym_DOLLAR] = ACTIONS(5389),
    [anon_sym_AT] = ACTIONS(5389),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__semicolon] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_else] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(5393),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_close_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(5395),
    [sym__external_close_bracket] = ACTIONS(5333),
    [sym__external_open_bracket2] = ACTIONS(5397),
  },
  [802] = {
    [sym_call_arguments] = STATE(2438),
    [sym_subset_arguments] = STATE(2439),
    [sym_subset2_arguments] = STATE(2440),
    [sym__open_parenthesis] = STATE(1350),
    [sym__open_bracket] = STATE(1348),
    [sym__open_bracket2] = STATE(1346),
    [sym_identifier] = ACTIONS(5339),
    [anon_sym_BSLASH] = ACTIONS(5337),
    [anon_sym_function] = ACTIONS(5339),
    [anon_sym_EQ] = ACTIONS(5353),
    [anon_sym_if] = ACTIONS(5339),
    [anon_sym_for] = ACTIONS(5339),
    [anon_sym_while] = ACTIONS(5339),
    [anon_sym_repeat] = ACTIONS(5339),
    [anon_sym_QMARK] = ACTIONS(5337),
    [anon_sym_TILDE] = ACTIONS(5355),
    [anon_sym_BANG] = ACTIONS(5339),
    [anon_sym_PLUS] = ACTIONS(5357),
    [anon_sym_DASH] = ACTIONS(5359),
    [anon_sym_LT_DASH] = ACTIONS(5361),
    [anon_sym_LT_LT_DASH] = ACTIONS(5361),
    [anon_sym_COLON_EQ] = ACTIONS(5361),
    [anon_sym_DASH_GT] = ACTIONS(5363),
    [anon_sym_DASH_GT_GT] = ACTIONS(5365),
    [anon_sym_PIPE] = ACTIONS(5367),
    [anon_sym_AMP] = ACTIONS(5369),
    [anon_sym_PIPE_PIPE] = ACTIONS(5371),
    [anon_sym_AMP_AMP] = ACTIONS(5373),
    [anon_sym_LT] = ACTIONS(5375),
    [anon_sym_LT_EQ] = ACTIONS(5377),
    [anon_sym_GT] = ACTIONS(5375),
    [anon_sym_GT_EQ] = ACTIONS(5377),
    [anon_sym_EQ_EQ] = ACTIONS(5377),
    [anon_sym_BANG_EQ] = ACTIONS(5377),
    [anon_sym_STAR] = ACTIONS(5379),
    [anon_sym_SLASH] = ACTIONS(5381),
    [anon_sym_STAR_STAR] = ACTIONS(5383),
    [anon_sym_CARET] = ACTIONS(5383),
    [aux_sym_binary_operator_token1] = ACTIONS(5385),
    [anon_sym_PIPE_GT] = ACTIONS(5385),
    [anon_sym_COLON] = ACTIONS(5387),
    [anon_sym_DOLLAR] = ACTIONS(5389),
    [anon_sym_AT] = ACTIONS(5389),
    [aux_sym__hex_literal_token1] = ACTIONS(5337),
    [sym__number_literal] = ACTIONS(5339),
    [anon_sym_SQUOTE] = ACTIONS(5337),
    [anon_sym_DQUOTE] = ACTIONS(5337),
    [sym_return] = ACTIONS(5339),
    [sym_next] = ACTIONS(5339),
    [sym_break] = ACTIONS(5339),
    [sym_true] = ACTIONS(5339),
    [sym_false] = ACTIONS(5339),
    [sym_null] = ACTIONS(5339),
    [sym_inf] = ACTIONS(5339),
    [sym_nan] = ACTIONS(5339),
    [anon_sym_NA] = ACTIONS(5339),
    [anon_sym_NA_integer_] = ACTIONS(5339),
    [anon_sym_NA_real_] = ACTIONS(5339),
    [anon_sym_NA_complex_] = ACTIONS(5339),
    [anon_sym_NA_character_] = ACTIONS(5339),
    [sym_dots] = ACTIONS(5339),
    [sym_dot_dot_i] = ACTIONS(5337),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5337),
    [sym__newline] = ACTIONS(5337),
    [sym__semicolon] = ACTIONS(5337),
    [sym__raw_string_literal] = ACTIONS(5337),
    [sym__external_else] = ACTIONS(5337),
    [sym__external_open_parenthesis] = ACTIONS(5393),
    [sym__external_open_brace] = ACTIONS(5337),
    [sym__external_close_brace] = ACTIONS(5337),
    [sym__external_open_bracket] = ACTIONS(5395),
    [sym__external_close_bracket] = ACTIONS(5337),
    [sym__external_open_bracket2] = ACTIONS(5397),
  },
  [803] = {
    [sym_call_arguments] = STATE(2651),
    [sym_subset_arguments] = STATE(2561),
    [sym_subset2_arguments] = STATE(2648),
    [sym__else] = STATE(4184),
    [sym__open_parenthesis] = STATE(1340),
    [sym__open_bracket] = STATE(1335),
    [sym__open_bracket2] = STATE(1334),
    [sym_identifier] = ACTIONS(5065),
    [anon_sym_BSLASH] = ACTIONS(5067),
    [anon_sym_function] = ACTIONS(5065),
    [anon_sym_EQ] = ACTIONS(5675),
    [anon_sym_if] = ACTIONS(5065),
    [anon_sym_for] = ACTIONS(5065),
    [anon_sym_while] = ACTIONS(5065),
    [anon_sym_repeat] = ACTIONS(5065),
    [anon_sym_QMARK] = ACTIONS(5067),
    [anon_sym_TILDE] = ACTIONS(5677),
    [anon_sym_BANG] = ACTIONS(5065),
    [anon_sym_PLUS] = ACTIONS(5679),
    [anon_sym_DASH] = ACTIONS(5681),
    [anon_sym_LT_DASH] = ACTIONS(5683),
    [anon_sym_LT_LT_DASH] = ACTIONS(5683),
    [anon_sym_COLON_EQ] = ACTIONS(5683),
    [anon_sym_DASH_GT] = ACTIONS(5685),
    [anon_sym_DASH_GT_GT] = ACTIONS(5687),
    [anon_sym_PIPE] = ACTIONS(5689),
    [anon_sym_AMP] = ACTIONS(5691),
    [anon_sym_PIPE_PIPE] = ACTIONS(5693),
    [anon_sym_AMP_AMP] = ACTIONS(5695),
    [anon_sym_LT] = ACTIONS(5697),
    [anon_sym_LT_EQ] = ACTIONS(5699),
    [anon_sym_GT] = ACTIONS(5697),
    [anon_sym_GT_EQ] = ACTIONS(5699),
    [anon_sym_EQ_EQ] = ACTIONS(5699),
    [anon_sym_BANG_EQ] = ACTIONS(5699),
    [anon_sym_STAR] = ACTIONS(5701),
    [anon_sym_SLASH] = ACTIONS(5703),
    [anon_sym_STAR_STAR] = ACTIONS(5705),
    [anon_sym_CARET] = ACTIONS(5705),
    [aux_sym_binary_operator_token1] = ACTIONS(5707),
    [anon_sym_PIPE_GT] = ACTIONS(5707),
    [anon_sym_COLON] = ACTIONS(5709),
    [anon_sym_DOLLAR] = ACTIONS(5711),
    [anon_sym_AT] = ACTIONS(5711),
    [aux_sym__hex_literal_token1] = ACTIONS(5067),
    [sym__number_literal] = ACTIONS(5065),
    [anon_sym_SQUOTE] = ACTIONS(5067),
    [anon_sym_DQUOTE] = ACTIONS(5067),
    [sym_return] = ACTIONS(5065),
    [sym_next] = ACTIONS(5065),
    [sym_break] = ACTIONS(5065),
    [sym_true] = ACTIONS(5065),
    [sym_false] = ACTIONS(5065),
    [sym_null] = ACTIONS(5065),
    [sym_inf] = ACTIONS(5065),
    [sym_nan] = ACTIONS(5065),
    [anon_sym_NA] = ACTIONS(5065),
    [anon_sym_NA_integer_] = ACTIONS(5065),
    [anon_sym_NA_real_] = ACTIONS(5065),
    [anon_sym_NA_complex_] = ACTIONS(5065),
    [anon_sym_NA_character_] = ACTIONS(5065),
    [sym_dots] = ACTIONS(5065),
    [sym_dot_dot_i] = ACTIONS(5067),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5067),
    [sym__newline] = ACTIONS(5067),
    [sym__raw_string_literal] = ACTIONS(5067),
    [sym__external_else] = ACTIONS(5837),
    [sym__external_open_parenthesis] = ACTIONS(5715),
    [sym__external_close_parenthesis] = ACTIONS(5067),
    [sym__external_open_brace] = ACTIONS(5067),
    [sym__external_open_bracket] = ACTIONS(5717),
    [sym__external_open_bracket2] = ACTIONS(5719),
    [sym__external_close_bracket2] = ACTIONS(5067),
  },
  [804] = {
    [sym_call_arguments] = STATE(2438),
    [sym_subset_arguments] = STATE(2439),
    [sym_subset2_arguments] = STATE(2440),
    [sym__open_parenthesis] = STATE(1350),
    [sym__open_bracket] = STATE(1348),
    [sym__open_bracket2] = STATE(1346),
    [sym_identifier] = ACTIONS(5343),
    [anon_sym_BSLASH] = ACTIONS(5341),
    [anon_sym_function] = ACTIONS(5343),
    [anon_sym_EQ] = ACTIONS(5353),
    [anon_sym_if] = ACTIONS(5343),
    [anon_sym_for] = ACTIONS(5343),
    [anon_sym_while] = ACTIONS(5343),
    [anon_sym_repeat] = ACTIONS(5343),
    [anon_sym_QMARK] = ACTIONS(5341),
    [anon_sym_TILDE] = ACTIONS(5355),
    [anon_sym_BANG] = ACTIONS(5343),
    [anon_sym_PLUS] = ACTIONS(5357),
    [anon_sym_DASH] = ACTIONS(5359),
    [anon_sym_LT_DASH] = ACTIONS(5361),
    [anon_sym_LT_LT_DASH] = ACTIONS(5361),
    [anon_sym_COLON_EQ] = ACTIONS(5361),
    [anon_sym_DASH_GT] = ACTIONS(5363),
    [anon_sym_DASH_GT_GT] = ACTIONS(5365),
    [anon_sym_PIPE] = ACTIONS(5367),
    [anon_sym_AMP] = ACTIONS(5369),
    [anon_sym_PIPE_PIPE] = ACTIONS(5371),
    [anon_sym_AMP_AMP] = ACTIONS(5373),
    [anon_sym_LT] = ACTIONS(5375),
    [anon_sym_LT_EQ] = ACTIONS(5377),
    [anon_sym_GT] = ACTIONS(5375),
    [anon_sym_GT_EQ] = ACTIONS(5377),
    [anon_sym_EQ_EQ] = ACTIONS(5377),
    [anon_sym_BANG_EQ] = ACTIONS(5377),
    [anon_sym_STAR] = ACTIONS(5379),
    [anon_sym_SLASH] = ACTIONS(5381),
    [anon_sym_STAR_STAR] = ACTIONS(5383),
    [anon_sym_CARET] = ACTIONS(5383),
    [aux_sym_binary_operator_token1] = ACTIONS(5385),
    [anon_sym_PIPE_GT] = ACTIONS(5385),
    [anon_sym_COLON] = ACTIONS(5387),
    [anon_sym_DOLLAR] = ACTIONS(5389),
    [anon_sym_AT] = ACTIONS(5389),
    [aux_sym__hex_literal_token1] = ACTIONS(5341),
    [sym__number_literal] = ACTIONS(5343),
    [anon_sym_SQUOTE] = ACTIONS(5341),
    [anon_sym_DQUOTE] = ACTIONS(5341),
    [sym_return] = ACTIONS(5343),
    [sym_next] = ACTIONS(5343),
    [sym_break] = ACTIONS(5343),
    [sym_true] = ACTIONS(5343),
    [sym_false] = ACTIONS(5343),
    [sym_null] = ACTIONS(5343),
    [sym_inf] = ACTIONS(5343),
    [sym_nan] = ACTIONS(5343),
    [anon_sym_NA] = ACTIONS(5343),
    [anon_sym_NA_integer_] = ACTIONS(5343),
    [anon_sym_NA_real_] = ACTIONS(5343),
    [anon_sym_NA_complex_] = ACTIONS(5343),
    [anon_sym_NA_character_] = ACTIONS(5343),
    [sym_dots] = ACTIONS(5343),
    [sym_dot_dot_i] = ACTIONS(5341),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5341),
    [sym__newline] = ACTIONS(5341),
    [sym__semicolon] = ACTIONS(5341),
    [sym__raw_string_literal] = ACTIONS(5341),
    [sym__external_else] = ACTIONS(5341),
    [sym__external_open_parenthesis] = ACTIONS(5393),
    [sym__external_open_brace] = ACTIONS(5341),
    [sym__external_close_brace] = ACTIONS(5341),
    [sym__external_open_bracket] = ACTIONS(5395),
    [sym__external_close_bracket] = ACTIONS(5341),
    [sym__external_open_bracket2] = ACTIONS(5397),
  },
  [805] = {
    [sym_call_arguments] = STATE(2651),
    [sym_subset_arguments] = STATE(2561),
    [sym_subset2_arguments] = STATE(2648),
    [sym__else] = STATE(4199),
    [sym__open_parenthesis] = STATE(1340),
    [sym__open_bracket] = STATE(1335),
    [sym__open_bracket2] = STATE(1334),
    [sym_identifier] = ACTIONS(5115),
    [anon_sym_BSLASH] = ACTIONS(5117),
    [anon_sym_function] = ACTIONS(5115),
    [anon_sym_EQ] = ACTIONS(5675),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_for] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_repeat] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(5117),
    [anon_sym_TILDE] = ACTIONS(5677),
    [anon_sym_BANG] = ACTIONS(5115),
    [anon_sym_PLUS] = ACTIONS(5679),
    [anon_sym_DASH] = ACTIONS(5681),
    [anon_sym_LT_DASH] = ACTIONS(5683),
    [anon_sym_LT_LT_DASH] = ACTIONS(5683),
    [anon_sym_COLON_EQ] = ACTIONS(5683),
    [anon_sym_DASH_GT] = ACTIONS(5685),
    [anon_sym_DASH_GT_GT] = ACTIONS(5687),
    [anon_sym_PIPE] = ACTIONS(5689),
    [anon_sym_AMP] = ACTIONS(5691),
    [anon_sym_PIPE_PIPE] = ACTIONS(5693),
    [anon_sym_AMP_AMP] = ACTIONS(5695),
    [anon_sym_LT] = ACTIONS(5697),
    [anon_sym_LT_EQ] = ACTIONS(5699),
    [anon_sym_GT] = ACTIONS(5697),
    [anon_sym_GT_EQ] = ACTIONS(5699),
    [anon_sym_EQ_EQ] = ACTIONS(5699),
    [anon_sym_BANG_EQ] = ACTIONS(5699),
    [anon_sym_STAR] = ACTIONS(5701),
    [anon_sym_SLASH] = ACTIONS(5703),
    [anon_sym_STAR_STAR] = ACTIONS(5705),
    [anon_sym_CARET] = ACTIONS(5705),
    [aux_sym_binary_operator_token1] = ACTIONS(5707),
    [anon_sym_PIPE_GT] = ACTIONS(5707),
    [anon_sym_COLON] = ACTIONS(5709),
    [anon_sym_DOLLAR] = ACTIONS(5711),
    [anon_sym_AT] = ACTIONS(5711),
    [aux_sym__hex_literal_token1] = ACTIONS(5117),
    [sym__number_literal] = ACTIONS(5115),
    [anon_sym_SQUOTE] = ACTIONS(5117),
    [anon_sym_DQUOTE] = ACTIONS(5117),
    [sym_return] = ACTIONS(5115),
    [sym_next] = ACTIONS(5115),
    [sym_break] = ACTIONS(5115),
    [sym_true] = ACTIONS(5115),
    [sym_false] = ACTIONS(5115),
    [sym_null] = ACTIONS(5115),
    [sym_inf] = ACTIONS(5115),
    [sym_nan] = ACTIONS(5115),
    [anon_sym_NA] = ACTIONS(5115),
    [anon_sym_NA_integer_] = ACTIONS(5115),
    [anon_sym_NA_real_] = ACTIONS(5115),
    [anon_sym_NA_complex_] = ACTIONS(5115),
    [anon_sym_NA_character_] = ACTIONS(5115),
    [sym_dots] = ACTIONS(5115),
    [sym_dot_dot_i] = ACTIONS(5117),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5117),
    [sym__newline] = ACTIONS(5117),
    [sym__raw_string_literal] = ACTIONS(5117),
    [sym__external_else] = ACTIONS(5839),
    [sym__external_open_parenthesis] = ACTIONS(5715),
    [sym__external_close_parenthesis] = ACTIONS(5117),
    [sym__external_open_brace] = ACTIONS(5117),
    [sym__external_open_bracket] = ACTIONS(5717),
    [sym__external_open_bracket2] = ACTIONS(5719),
    [sym__external_close_bracket2] = ACTIONS(5117),
  },
  [806] = {
    [sym_call_arguments] = STATE(2438),
    [sym_subset_arguments] = STATE(2439),
    [sym_subset2_arguments] = STATE(2440),
    [sym__open_parenthesis] = STATE(1350),
    [sym__open_bracket] = STATE(1348),
    [sym__open_bracket2] = STATE(1346),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5353),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5355),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5357),
    [anon_sym_DASH] = ACTIONS(5359),
    [anon_sym_LT_DASH] = ACTIONS(5361),
    [anon_sym_LT_LT_DASH] = ACTIONS(5361),
    [anon_sym_COLON_EQ] = ACTIONS(5361),
    [anon_sym_DASH_GT] = ACTIONS(5363),
    [anon_sym_DASH_GT_GT] = ACTIONS(5365),
    [anon_sym_PIPE] = ACTIONS(5367),
    [anon_sym_AMP] = ACTIONS(5369),
    [anon_sym_PIPE_PIPE] = ACTIONS(5371),
    [anon_sym_AMP_AMP] = ACTIONS(5373),
    [anon_sym_LT] = ACTIONS(5375),
    [anon_sym_LT_EQ] = ACTIONS(5377),
    [anon_sym_GT] = ACTIONS(5375),
    [anon_sym_GT_EQ] = ACTIONS(5377),
    [anon_sym_EQ_EQ] = ACTIONS(5377),
    [anon_sym_BANG_EQ] = ACTIONS(5377),
    [anon_sym_STAR] = ACTIONS(5379),
    [anon_sym_SLASH] = ACTIONS(5381),
    [anon_sym_STAR_STAR] = ACTIONS(5383),
    [anon_sym_CARET] = ACTIONS(5383),
    [aux_sym_binary_operator_token1] = ACTIONS(5385),
    [anon_sym_PIPE_GT] = ACTIONS(5385),
    [anon_sym_COLON] = ACTIONS(5387),
    [anon_sym_DOLLAR] = ACTIONS(5389),
    [anon_sym_AT] = ACTIONS(5389),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__semicolon] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_else] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(5393),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_close_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(5395),
    [sym__external_close_bracket] = ACTIONS(5345),
    [sym__external_open_bracket2] = ACTIONS(5397),
  },
  [807] = {
    [sym_call_arguments] = STATE(2651),
    [sym_subset_arguments] = STATE(2561),
    [sym_subset2_arguments] = STATE(2648),
    [sym__else] = STATE(4201),
    [sym__open_parenthesis] = STATE(1340),
    [sym__open_bracket] = STATE(1335),
    [sym__open_bracket2] = STATE(1334),
    [sym_identifier] = ACTIONS(5169),
    [anon_sym_BSLASH] = ACTIONS(5167),
    [anon_sym_function] = ACTIONS(5169),
    [anon_sym_EQ] = ACTIONS(5675),
    [anon_sym_if] = ACTIONS(5169),
    [anon_sym_for] = ACTIONS(5169),
    [anon_sym_while] = ACTIONS(5169),
    [anon_sym_repeat] = ACTIONS(5169),
    [anon_sym_QMARK] = ACTIONS(5167),
    [anon_sym_TILDE] = ACTIONS(5677),
    [anon_sym_BANG] = ACTIONS(5169),
    [anon_sym_PLUS] = ACTIONS(5679),
    [anon_sym_DASH] = ACTIONS(5681),
    [anon_sym_LT_DASH] = ACTIONS(5683),
    [anon_sym_LT_LT_DASH] = ACTIONS(5683),
    [anon_sym_COLON_EQ] = ACTIONS(5683),
    [anon_sym_DASH_GT] = ACTIONS(5685),
    [anon_sym_DASH_GT_GT] = ACTIONS(5687),
    [anon_sym_PIPE] = ACTIONS(5689),
    [anon_sym_AMP] = ACTIONS(5691),
    [anon_sym_PIPE_PIPE] = ACTIONS(5693),
    [anon_sym_AMP_AMP] = ACTIONS(5695),
    [anon_sym_LT] = ACTIONS(5697),
    [anon_sym_LT_EQ] = ACTIONS(5699),
    [anon_sym_GT] = ACTIONS(5697),
    [anon_sym_GT_EQ] = ACTIONS(5699),
    [anon_sym_EQ_EQ] = ACTIONS(5699),
    [anon_sym_BANG_EQ] = ACTIONS(5699),
    [anon_sym_STAR] = ACTIONS(5701),
    [anon_sym_SLASH] = ACTIONS(5703),
    [anon_sym_STAR_STAR] = ACTIONS(5705),
    [anon_sym_CARET] = ACTIONS(5705),
    [aux_sym_binary_operator_token1] = ACTIONS(5707),
    [anon_sym_PIPE_GT] = ACTIONS(5707),
    [anon_sym_COLON] = ACTIONS(5709),
    [anon_sym_DOLLAR] = ACTIONS(5711),
    [anon_sym_AT] = ACTIONS(5711),
    [aux_sym__hex_literal_token1] = ACTIONS(5167),
    [sym__number_literal] = ACTIONS(5169),
    [anon_sym_SQUOTE] = ACTIONS(5167),
    [anon_sym_DQUOTE] = ACTIONS(5167),
    [sym_return] = ACTIONS(5169),
    [sym_next] = ACTIONS(5169),
    [sym_break] = ACTIONS(5169),
    [sym_true] = ACTIONS(5169),
    [sym_false] = ACTIONS(5169),
    [sym_null] = ACTIONS(5169),
    [sym_inf] = ACTIONS(5169),
    [sym_nan] = ACTIONS(5169),
    [anon_sym_NA] = ACTIONS(5169),
    [anon_sym_NA_integer_] = ACTIONS(5169),
    [anon_sym_NA_real_] = ACTIONS(5169),
    [anon_sym_NA_complex_] = ACTIONS(5169),
    [anon_sym_NA_character_] = ACTIONS(5169),
    [sym_dots] = ACTIONS(5169),
    [sym_dot_dot_i] = ACTIONS(5167),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5167),
    [sym__newline] = ACTIONS(5167),
    [sym__raw_string_literal] = ACTIONS(5167),
    [sym__external_else] = ACTIONS(5841),
    [sym__external_open_parenthesis] = ACTIONS(5715),
    [sym__external_close_parenthesis] = ACTIONS(5167),
    [sym__external_open_brace] = ACTIONS(5167),
    [sym__external_open_bracket] = ACTIONS(5717),
    [sym__external_open_bracket2] = ACTIONS(5719),
    [sym__external_close_bracket2] = ACTIONS(5167),
  },
  [808] = {
    [sym_call_arguments] = STATE(2438),
    [sym_subset_arguments] = STATE(2439),
    [sym_subset2_arguments] = STATE(2440),
    [sym__open_parenthesis] = STATE(1350),
    [sym__open_bracket] = STATE(1348),
    [sym__open_bracket2] = STATE(1346),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5357),
    [anon_sym_DASH] = ACTIONS(5359),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5367),
    [anon_sym_AMP] = ACTIONS(5369),
    [anon_sym_PIPE_PIPE] = ACTIONS(5371),
    [anon_sym_AMP_AMP] = ACTIONS(5373),
    [anon_sym_LT] = ACTIONS(5375),
    [anon_sym_LT_EQ] = ACTIONS(5377),
    [anon_sym_GT] = ACTIONS(5375),
    [anon_sym_GT_EQ] = ACTIONS(5377),
    [anon_sym_EQ_EQ] = ACTIONS(5377),
    [anon_sym_BANG_EQ] = ACTIONS(5377),
    [anon_sym_STAR] = ACTIONS(5379),
    [anon_sym_SLASH] = ACTIONS(5381),
    [anon_sym_STAR_STAR] = ACTIONS(5383),
    [anon_sym_CARET] = ACTIONS(5383),
    [aux_sym_binary_operator_token1] = ACTIONS(5385),
    [anon_sym_PIPE_GT] = ACTIONS(5385),
    [anon_sym_COLON] = ACTIONS(5387),
    [anon_sym_DOLLAR] = ACTIONS(5389),
    [anon_sym_AT] = ACTIONS(5389),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__semicolon] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_else] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(5393),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_close_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(5395),
    [sym__external_close_bracket] = ACTIONS(5345),
    [sym__external_open_bracket2] = ACTIONS(5397),
  },
  [809] = {
    [sym_call_arguments] = STATE(2651),
    [sym_subset_arguments] = STATE(2561),
    [sym_subset2_arguments] = STATE(2648),
    [sym__else] = STATE(4207),
    [sym__open_parenthesis] = STATE(1340),
    [sym__open_bracket] = STATE(1335),
    [sym__open_bracket2] = STATE(1334),
    [sym_identifier] = ACTIONS(5225),
    [anon_sym_BSLASH] = ACTIONS(5227),
    [anon_sym_function] = ACTIONS(5225),
    [anon_sym_EQ] = ACTIONS(5675),
    [anon_sym_if] = ACTIONS(5225),
    [anon_sym_for] = ACTIONS(5225),
    [anon_sym_while] = ACTIONS(5225),
    [anon_sym_repeat] = ACTIONS(5225),
    [anon_sym_QMARK] = ACTIONS(5227),
    [anon_sym_TILDE] = ACTIONS(5677),
    [anon_sym_BANG] = ACTIONS(5225),
    [anon_sym_PLUS] = ACTIONS(5679),
    [anon_sym_DASH] = ACTIONS(5681),
    [anon_sym_LT_DASH] = ACTIONS(5683),
    [anon_sym_LT_LT_DASH] = ACTIONS(5683),
    [anon_sym_COLON_EQ] = ACTIONS(5683),
    [anon_sym_DASH_GT] = ACTIONS(5685),
    [anon_sym_DASH_GT_GT] = ACTIONS(5687),
    [anon_sym_PIPE] = ACTIONS(5689),
    [anon_sym_AMP] = ACTIONS(5691),
    [anon_sym_PIPE_PIPE] = ACTIONS(5693),
    [anon_sym_AMP_AMP] = ACTIONS(5695),
    [anon_sym_LT] = ACTIONS(5697),
    [anon_sym_LT_EQ] = ACTIONS(5699),
    [anon_sym_GT] = ACTIONS(5697),
    [anon_sym_GT_EQ] = ACTIONS(5699),
    [anon_sym_EQ_EQ] = ACTIONS(5699),
    [anon_sym_BANG_EQ] = ACTIONS(5699),
    [anon_sym_STAR] = ACTIONS(5701),
    [anon_sym_SLASH] = ACTIONS(5703),
    [anon_sym_STAR_STAR] = ACTIONS(5705),
    [anon_sym_CARET] = ACTIONS(5705),
    [aux_sym_binary_operator_token1] = ACTIONS(5707),
    [anon_sym_PIPE_GT] = ACTIONS(5707),
    [anon_sym_COLON] = ACTIONS(5709),
    [anon_sym_DOLLAR] = ACTIONS(5711),
    [anon_sym_AT] = ACTIONS(5711),
    [aux_sym__hex_literal_token1] = ACTIONS(5227),
    [sym__number_literal] = ACTIONS(5225),
    [anon_sym_SQUOTE] = ACTIONS(5227),
    [anon_sym_DQUOTE] = ACTIONS(5227),
    [sym_return] = ACTIONS(5225),
    [sym_next] = ACTIONS(5225),
    [sym_break] = ACTIONS(5225),
    [sym_true] = ACTIONS(5225),
    [sym_false] = ACTIONS(5225),
    [sym_null] = ACTIONS(5225),
    [sym_inf] = ACTIONS(5225),
    [sym_nan] = ACTIONS(5225),
    [anon_sym_NA] = ACTIONS(5225),
    [anon_sym_NA_integer_] = ACTIONS(5225),
    [anon_sym_NA_real_] = ACTIONS(5225),
    [anon_sym_NA_complex_] = ACTIONS(5225),
    [anon_sym_NA_character_] = ACTIONS(5225),
    [sym_dots] = ACTIONS(5225),
    [sym_dot_dot_i] = ACTIONS(5227),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5227),
    [sym__newline] = ACTIONS(5227),
    [sym__raw_string_literal] = ACTIONS(5227),
    [sym__external_else] = ACTIONS(5843),
    [sym__external_open_parenthesis] = ACTIONS(5715),
    [sym__external_close_parenthesis] = ACTIONS(5227),
    [sym__external_open_brace] = ACTIONS(5227),
    [sym__external_open_bracket] = ACTIONS(5717),
    [sym__external_open_bracket2] = ACTIONS(5719),
    [sym__external_close_bracket2] = ACTIONS(5227),
  },
  [810] = {
    [sym_call_arguments] = STATE(2438),
    [sym_subset_arguments] = STATE(2439),
    [sym_subset2_arguments] = STATE(2440),
    [sym__open_parenthesis] = STATE(1350),
    [sym__open_bracket] = STATE(1348),
    [sym__open_bracket2] = STATE(1346),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5357),
    [anon_sym_DASH] = ACTIONS(5359),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5347),
    [anon_sym_AMP] = ACTIONS(5347),
    [anon_sym_PIPE_PIPE] = ACTIONS(5345),
    [anon_sym_AMP_AMP] = ACTIONS(5345),
    [anon_sym_LT] = ACTIONS(5375),
    [anon_sym_LT_EQ] = ACTIONS(5377),
    [anon_sym_GT] = ACTIONS(5375),
    [anon_sym_GT_EQ] = ACTIONS(5377),
    [anon_sym_EQ_EQ] = ACTIONS(5377),
    [anon_sym_BANG_EQ] = ACTIONS(5377),
    [anon_sym_STAR] = ACTIONS(5379),
    [anon_sym_SLASH] = ACTIONS(5381),
    [anon_sym_STAR_STAR] = ACTIONS(5383),
    [anon_sym_CARET] = ACTIONS(5383),
    [aux_sym_binary_operator_token1] = ACTIONS(5385),
    [anon_sym_PIPE_GT] = ACTIONS(5385),
    [anon_sym_COLON] = ACTIONS(5387),
    [anon_sym_DOLLAR] = ACTIONS(5389),
    [anon_sym_AT] = ACTIONS(5389),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__semicolon] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_else] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(5393),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_close_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(5395),
    [sym__external_close_bracket] = ACTIONS(5345),
    [sym__external_open_bracket2] = ACTIONS(5397),
  },
  [811] = {
    [sym_call_arguments] = STATE(2438),
    [sym_subset_arguments] = STATE(2439),
    [sym_subset2_arguments] = STATE(2440),
    [sym__open_parenthesis] = STATE(1350),
    [sym__open_bracket] = STATE(1348),
    [sym__open_bracket2] = STATE(1346),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5345),
    [anon_sym_DASH] = ACTIONS(5347),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5347),
    [anon_sym_AMP] = ACTIONS(5347),
    [anon_sym_PIPE_PIPE] = ACTIONS(5345),
    [anon_sym_AMP_AMP] = ACTIONS(5345),
    [anon_sym_LT] = ACTIONS(5347),
    [anon_sym_LT_EQ] = ACTIONS(5345),
    [anon_sym_GT] = ACTIONS(5347),
    [anon_sym_GT_EQ] = ACTIONS(5345),
    [anon_sym_EQ_EQ] = ACTIONS(5345),
    [anon_sym_BANG_EQ] = ACTIONS(5345),
    [anon_sym_STAR] = ACTIONS(5347),
    [anon_sym_SLASH] = ACTIONS(5345),
    [anon_sym_STAR_STAR] = ACTIONS(5383),
    [anon_sym_CARET] = ACTIONS(5383),
    [aux_sym_binary_operator_token1] = ACTIONS(5345),
    [anon_sym_PIPE_GT] = ACTIONS(5345),
    [anon_sym_COLON] = ACTIONS(5347),
    [anon_sym_DOLLAR] = ACTIONS(5389),
    [anon_sym_AT] = ACTIONS(5389),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__semicolon] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_else] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(5393),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_close_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(5395),
    [sym__external_close_bracket] = ACTIONS(5345),
    [sym__external_open_bracket2] = ACTIONS(5397),
  },
  [812] = {
    [sym_call_arguments] = STATE(2509),
    [sym_subset_arguments] = STATE(2507),
    [sym_subset2_arguments] = STATE(2505),
    [sym__open_parenthesis] = STATE(1590),
    [sym__open_bracket] = STATE(1589),
    [sym__open_bracket2] = STATE(1588),
    [ts_builtin_sym_end] = ACTIONS(5409),
    [sym_identifier] = ACTIONS(5411),
    [anon_sym_BSLASH] = ACTIONS(5409),
    [anon_sym_function] = ACTIONS(5411),
    [anon_sym_EQ] = ACTIONS(5475),
    [anon_sym_if] = ACTIONS(5411),
    [anon_sym_for] = ACTIONS(5411),
    [anon_sym_while] = ACTIONS(5411),
    [anon_sym_repeat] = ACTIONS(5411),
    [anon_sym_QMARK] = ACTIONS(5409),
    [anon_sym_TILDE] = ACTIONS(5477),
    [anon_sym_BANG] = ACTIONS(5411),
    [anon_sym_PLUS] = ACTIONS(5479),
    [anon_sym_DASH] = ACTIONS(5481),
    [anon_sym_LT_DASH] = ACTIONS(5483),
    [anon_sym_LT_LT_DASH] = ACTIONS(5483),
    [anon_sym_COLON_EQ] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5485),
    [anon_sym_DASH_GT_GT] = ACTIONS(5487),
    [anon_sym_PIPE] = ACTIONS(5489),
    [anon_sym_AMP] = ACTIONS(5491),
    [anon_sym_PIPE_PIPE] = ACTIONS(5493),
    [anon_sym_AMP_AMP] = ACTIONS(5495),
    [anon_sym_LT] = ACTIONS(5497),
    [anon_sym_LT_EQ] = ACTIONS(5499),
    [anon_sym_GT] = ACTIONS(5497),
    [anon_sym_GT_EQ] = ACTIONS(5499),
    [anon_sym_EQ_EQ] = ACTIONS(5499),
    [anon_sym_BANG_EQ] = ACTIONS(5499),
    [anon_sym_STAR] = ACTIONS(5501),
    [anon_sym_SLASH] = ACTIONS(5503),
    [anon_sym_STAR_STAR] = ACTIONS(5505),
    [anon_sym_CARET] = ACTIONS(5505),
    [aux_sym_binary_operator_token1] = ACTIONS(5507),
    [anon_sym_PIPE_GT] = ACTIONS(5507),
    [anon_sym_COLON] = ACTIONS(5509),
    [anon_sym_DOLLAR] = ACTIONS(5511),
    [anon_sym_AT] = ACTIONS(5511),
    [aux_sym__hex_literal_token1] = ACTIONS(5409),
    [sym__number_literal] = ACTIONS(5411),
    [anon_sym_SQUOTE] = ACTIONS(5409),
    [anon_sym_DQUOTE] = ACTIONS(5409),
    [sym_return] = ACTIONS(5411),
    [sym_next] = ACTIONS(5411),
    [sym_break] = ACTIONS(5411),
    [sym_true] = ACTIONS(5411),
    [sym_false] = ACTIONS(5411),
    [sym_null] = ACTIONS(5411),
    [sym_inf] = ACTIONS(5411),
    [sym_nan] = ACTIONS(5411),
    [anon_sym_NA] = ACTIONS(5411),
    [anon_sym_NA_integer_] = ACTIONS(5411),
    [anon_sym_NA_real_] = ACTIONS(5411),
    [anon_sym_NA_complex_] = ACTIONS(5411),
    [anon_sym_NA_character_] = ACTIONS(5411),
    [sym_dots] = ACTIONS(5411),
    [sym_dot_dot_i] = ACTIONS(5409),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5409),
    [sym__newline] = ACTIONS(5409),
    [sym__semicolon] = ACTIONS(5409),
    [sym__raw_string_literal] = ACTIONS(5409),
    [sym__external_open_parenthesis] = ACTIONS(5513),
    [sym__external_close_parenthesis] = ACTIONS(5409),
    [sym__external_open_brace] = ACTIONS(5409),
    [sym__external_close_brace] = ACTIONS(5409),
    [sym__external_open_bracket] = ACTIONS(5515),
    [sym__external_open_bracket2] = ACTIONS(5517),
  },
  [813] = {
    [sym_call_arguments] = STATE(2509),
    [sym_subset_arguments] = STATE(2507),
    [sym_subset2_arguments] = STATE(2505),
    [sym__open_parenthesis] = STATE(1590),
    [sym__open_bracket] = STATE(1589),
    [sym__open_bracket2] = STATE(1588),
    [ts_builtin_sym_end] = ACTIONS(5453),
    [sym_identifier] = ACTIONS(5455),
    [anon_sym_BSLASH] = ACTIONS(5453),
    [anon_sym_function] = ACTIONS(5455),
    [anon_sym_EQ] = ACTIONS(5475),
    [anon_sym_if] = ACTIONS(5455),
    [anon_sym_for] = ACTIONS(5455),
    [anon_sym_while] = ACTIONS(5455),
    [anon_sym_repeat] = ACTIONS(5455),
    [anon_sym_QMARK] = ACTIONS(5453),
    [anon_sym_TILDE] = ACTIONS(5477),
    [anon_sym_BANG] = ACTIONS(5455),
    [anon_sym_PLUS] = ACTIONS(5479),
    [anon_sym_DASH] = ACTIONS(5481),
    [anon_sym_LT_DASH] = ACTIONS(5483),
    [anon_sym_LT_LT_DASH] = ACTIONS(5483),
    [anon_sym_COLON_EQ] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5485),
    [anon_sym_DASH_GT_GT] = ACTIONS(5487),
    [anon_sym_PIPE] = ACTIONS(5489),
    [anon_sym_AMP] = ACTIONS(5491),
    [anon_sym_PIPE_PIPE] = ACTIONS(5493),
    [anon_sym_AMP_AMP] = ACTIONS(5495),
    [anon_sym_LT] = ACTIONS(5497),
    [anon_sym_LT_EQ] = ACTIONS(5499),
    [anon_sym_GT] = ACTIONS(5497),
    [anon_sym_GT_EQ] = ACTIONS(5499),
    [anon_sym_EQ_EQ] = ACTIONS(5499),
    [anon_sym_BANG_EQ] = ACTIONS(5499),
    [anon_sym_STAR] = ACTIONS(5501),
    [anon_sym_SLASH] = ACTIONS(5503),
    [anon_sym_STAR_STAR] = ACTIONS(5505),
    [anon_sym_CARET] = ACTIONS(5505),
    [aux_sym_binary_operator_token1] = ACTIONS(5507),
    [anon_sym_PIPE_GT] = ACTIONS(5507),
    [anon_sym_COLON] = ACTIONS(5509),
    [anon_sym_DOLLAR] = ACTIONS(5511),
    [anon_sym_AT] = ACTIONS(5511),
    [aux_sym__hex_literal_token1] = ACTIONS(5453),
    [sym__number_literal] = ACTIONS(5455),
    [anon_sym_SQUOTE] = ACTIONS(5453),
    [anon_sym_DQUOTE] = ACTIONS(5453),
    [sym_return] = ACTIONS(5455),
    [sym_next] = ACTIONS(5455),
    [sym_break] = ACTIONS(5455),
    [sym_true] = ACTIONS(5455),
    [sym_false] = ACTIONS(5455),
    [sym_null] = ACTIONS(5455),
    [sym_inf] = ACTIONS(5455),
    [sym_nan] = ACTIONS(5455),
    [anon_sym_NA] = ACTIONS(5455),
    [anon_sym_NA_integer_] = ACTIONS(5455),
    [anon_sym_NA_real_] = ACTIONS(5455),
    [anon_sym_NA_complex_] = ACTIONS(5455),
    [anon_sym_NA_character_] = ACTIONS(5455),
    [sym_dots] = ACTIONS(5455),
    [sym_dot_dot_i] = ACTIONS(5453),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5453),
    [sym__newline] = ACTIONS(5453),
    [sym__semicolon] = ACTIONS(5453),
    [sym__raw_string_literal] = ACTIONS(5453),
    [sym__external_open_parenthesis] = ACTIONS(5513),
    [sym__external_close_parenthesis] = ACTIONS(5453),
    [sym__external_open_brace] = ACTIONS(5453),
    [sym__external_close_brace] = ACTIONS(5453),
    [sym__external_open_bracket] = ACTIONS(5515),
    [sym__external_open_bracket2] = ACTIONS(5517),
  },
  [814] = {
    [sym_call_arguments] = STATE(2438),
    [sym_subset_arguments] = STATE(2439),
    [sym_subset2_arguments] = STATE(2440),
    [sym__open_parenthesis] = STATE(1350),
    [sym__open_bracket] = STATE(1348),
    [sym__open_bracket2] = STATE(1346),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5353),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5355),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5357),
    [anon_sym_DASH] = ACTIONS(5359),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5363),
    [anon_sym_DASH_GT_GT] = ACTIONS(5365),
    [anon_sym_PIPE] = ACTIONS(5367),
    [anon_sym_AMP] = ACTIONS(5369),
    [anon_sym_PIPE_PIPE] = ACTIONS(5371),
    [anon_sym_AMP_AMP] = ACTIONS(5373),
    [anon_sym_LT] = ACTIONS(5375),
    [anon_sym_LT_EQ] = ACTIONS(5377),
    [anon_sym_GT] = ACTIONS(5375),
    [anon_sym_GT_EQ] = ACTIONS(5377),
    [anon_sym_EQ_EQ] = ACTIONS(5377),
    [anon_sym_BANG_EQ] = ACTIONS(5377),
    [anon_sym_STAR] = ACTIONS(5379),
    [anon_sym_SLASH] = ACTIONS(5381),
    [anon_sym_STAR_STAR] = ACTIONS(5383),
    [anon_sym_CARET] = ACTIONS(5383),
    [aux_sym_binary_operator_token1] = ACTIONS(5385),
    [anon_sym_PIPE_GT] = ACTIONS(5385),
    [anon_sym_COLON] = ACTIONS(5387),
    [anon_sym_DOLLAR] = ACTIONS(5389),
    [anon_sym_AT] = ACTIONS(5389),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5393),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5395),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(5397),
  },
  [815] = {
    [sym_call_arguments] = STATE(2509),
    [sym_subset_arguments] = STATE(2507),
    [sym_subset2_arguments] = STATE(2505),
    [sym__open_parenthesis] = STATE(1590),
    [sym__open_bracket] = STATE(1589),
    [sym__open_bracket2] = STATE(1588),
    [ts_builtin_sym_end] = ACTIONS(5449),
    [sym_identifier] = ACTIONS(5451),
    [anon_sym_BSLASH] = ACTIONS(5449),
    [anon_sym_function] = ACTIONS(5451),
    [anon_sym_EQ] = ACTIONS(5475),
    [anon_sym_if] = ACTIONS(5451),
    [anon_sym_for] = ACTIONS(5451),
    [anon_sym_while] = ACTIONS(5451),
    [anon_sym_repeat] = ACTIONS(5451),
    [anon_sym_QMARK] = ACTIONS(5449),
    [anon_sym_TILDE] = ACTIONS(5477),
    [anon_sym_BANG] = ACTIONS(5451),
    [anon_sym_PLUS] = ACTIONS(5479),
    [anon_sym_DASH] = ACTIONS(5481),
    [anon_sym_LT_DASH] = ACTIONS(5483),
    [anon_sym_LT_LT_DASH] = ACTIONS(5483),
    [anon_sym_COLON_EQ] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5485),
    [anon_sym_DASH_GT_GT] = ACTIONS(5487),
    [anon_sym_PIPE] = ACTIONS(5489),
    [anon_sym_AMP] = ACTIONS(5491),
    [anon_sym_PIPE_PIPE] = ACTIONS(5493),
    [anon_sym_AMP_AMP] = ACTIONS(5495),
    [anon_sym_LT] = ACTIONS(5497),
    [anon_sym_LT_EQ] = ACTIONS(5499),
    [anon_sym_GT] = ACTIONS(5497),
    [anon_sym_GT_EQ] = ACTIONS(5499),
    [anon_sym_EQ_EQ] = ACTIONS(5499),
    [anon_sym_BANG_EQ] = ACTIONS(5499),
    [anon_sym_STAR] = ACTIONS(5501),
    [anon_sym_SLASH] = ACTIONS(5503),
    [anon_sym_STAR_STAR] = ACTIONS(5505),
    [anon_sym_CARET] = ACTIONS(5505),
    [aux_sym_binary_operator_token1] = ACTIONS(5507),
    [anon_sym_PIPE_GT] = ACTIONS(5507),
    [anon_sym_COLON] = ACTIONS(5509),
    [anon_sym_DOLLAR] = ACTIONS(5511),
    [anon_sym_AT] = ACTIONS(5511),
    [aux_sym__hex_literal_token1] = ACTIONS(5449),
    [sym__number_literal] = ACTIONS(5451),
    [anon_sym_SQUOTE] = ACTIONS(5449),
    [anon_sym_DQUOTE] = ACTIONS(5449),
    [sym_return] = ACTIONS(5451),
    [sym_next] = ACTIONS(5451),
    [sym_break] = ACTIONS(5451),
    [sym_true] = ACTIONS(5451),
    [sym_false] = ACTIONS(5451),
    [sym_null] = ACTIONS(5451),
    [sym_inf] = ACTIONS(5451),
    [sym_nan] = ACTIONS(5451),
    [anon_sym_NA] = ACTIONS(5451),
    [anon_sym_NA_integer_] = ACTIONS(5451),
    [anon_sym_NA_real_] = ACTIONS(5451),
    [anon_sym_NA_complex_] = ACTIONS(5451),
    [anon_sym_NA_character_] = ACTIONS(5451),
    [sym_dots] = ACTIONS(5451),
    [sym_dot_dot_i] = ACTIONS(5449),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5449),
    [sym__newline] = ACTIONS(5449),
    [sym__semicolon] = ACTIONS(5449),
    [sym__raw_string_literal] = ACTIONS(5449),
    [sym__external_open_parenthesis] = ACTIONS(5513),
    [sym__external_close_parenthesis] = ACTIONS(5449),
    [sym__external_open_brace] = ACTIONS(5449),
    [sym__external_close_brace] = ACTIONS(5449),
    [sym__external_open_bracket] = ACTIONS(5515),
    [sym__external_open_bracket2] = ACTIONS(5517),
  },
  [816] = {
    [sym_call_arguments] = STATE(2438),
    [sym_subset_arguments] = STATE(2439),
    [sym_subset2_arguments] = STATE(2440),
    [sym__open_parenthesis] = STATE(1350),
    [sym__open_bracket] = STATE(1348),
    [sym__open_bracket2] = STATE(1346),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5353),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5355),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5357),
    [anon_sym_DASH] = ACTIONS(5359),
    [anon_sym_LT_DASH] = ACTIONS(5361),
    [anon_sym_LT_LT_DASH] = ACTIONS(5361),
    [anon_sym_COLON_EQ] = ACTIONS(5361),
    [anon_sym_DASH_GT] = ACTIONS(5363),
    [anon_sym_DASH_GT_GT] = ACTIONS(5365),
    [anon_sym_PIPE] = ACTIONS(5367),
    [anon_sym_AMP] = ACTIONS(5369),
    [anon_sym_PIPE_PIPE] = ACTIONS(5371),
    [anon_sym_AMP_AMP] = ACTIONS(5373),
    [anon_sym_LT] = ACTIONS(5375),
    [anon_sym_LT_EQ] = ACTIONS(5377),
    [anon_sym_GT] = ACTIONS(5375),
    [anon_sym_GT_EQ] = ACTIONS(5377),
    [anon_sym_EQ_EQ] = ACTIONS(5377),
    [anon_sym_BANG_EQ] = ACTIONS(5377),
    [anon_sym_STAR] = ACTIONS(5379),
    [anon_sym_SLASH] = ACTIONS(5381),
    [anon_sym_STAR_STAR] = ACTIONS(5383),
    [anon_sym_CARET] = ACTIONS(5383),
    [aux_sym_binary_operator_token1] = ACTIONS(5385),
    [anon_sym_PIPE_GT] = ACTIONS(5385),
    [anon_sym_COLON] = ACTIONS(5387),
    [anon_sym_DOLLAR] = ACTIONS(5389),
    [anon_sym_AT] = ACTIONS(5389),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5393),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5395),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(5397),
  },
  [817] = {
    [sym_call_arguments] = STATE(2438),
    [sym_subset_arguments] = STATE(2439),
    [sym_subset2_arguments] = STATE(2440),
    [sym__open_parenthesis] = STATE(1350),
    [sym__open_bracket] = STATE(1348),
    [sym__open_bracket2] = STATE(1346),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5357),
    [anon_sym_DASH] = ACTIONS(5359),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5367),
    [anon_sym_AMP] = ACTIONS(5369),
    [anon_sym_PIPE_PIPE] = ACTIONS(5371),
    [anon_sym_AMP_AMP] = ACTIONS(5373),
    [anon_sym_LT] = ACTIONS(5375),
    [anon_sym_LT_EQ] = ACTIONS(5377),
    [anon_sym_GT] = ACTIONS(5375),
    [anon_sym_GT_EQ] = ACTIONS(5377),
    [anon_sym_EQ_EQ] = ACTIONS(5377),
    [anon_sym_BANG_EQ] = ACTIONS(5377),
    [anon_sym_STAR] = ACTIONS(5379),
    [anon_sym_SLASH] = ACTIONS(5381),
    [anon_sym_STAR_STAR] = ACTIONS(5383),
    [anon_sym_CARET] = ACTIONS(5383),
    [aux_sym_binary_operator_token1] = ACTIONS(5385),
    [anon_sym_PIPE_GT] = ACTIONS(5385),
    [anon_sym_COLON] = ACTIONS(5387),
    [anon_sym_DOLLAR] = ACTIONS(5389),
    [anon_sym_AT] = ACTIONS(5389),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5393),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5395),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(5397),
  },
  [818] = {
    [sym_call_arguments] = STATE(2731),
    [sym_subset_arguments] = STATE(2730),
    [sym_subset2_arguments] = STATE(2729),
    [sym__else] = STATE(4196),
    [sym__open_parenthesis] = STATE(1357),
    [sym__open_bracket] = STATE(1353),
    [sym__open_bracket2] = STATE(1352),
    [sym_identifier] = ACTIONS(5065),
    [anon_sym_BSLASH] = ACTIONS(5067),
    [anon_sym_function] = ACTIONS(5065),
    [anon_sym_EQ] = ACTIONS(5783),
    [anon_sym_if] = ACTIONS(5065),
    [anon_sym_for] = ACTIONS(5065),
    [anon_sym_while] = ACTIONS(5065),
    [anon_sym_repeat] = ACTIONS(5065),
    [anon_sym_QMARK] = ACTIONS(5067),
    [anon_sym_TILDE] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(5065),
    [anon_sym_PLUS] = ACTIONS(5787),
    [anon_sym_DASH] = ACTIONS(5789),
    [anon_sym_LT_DASH] = ACTIONS(5791),
    [anon_sym_LT_LT_DASH] = ACTIONS(5791),
    [anon_sym_COLON_EQ] = ACTIONS(5791),
    [anon_sym_DASH_GT] = ACTIONS(5793),
    [anon_sym_DASH_GT_GT] = ACTIONS(5795),
    [anon_sym_PIPE] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5799),
    [anon_sym_PIPE_PIPE] = ACTIONS(5801),
    [anon_sym_AMP_AMP] = ACTIONS(5803),
    [anon_sym_LT] = ACTIONS(5805),
    [anon_sym_LT_EQ] = ACTIONS(5807),
    [anon_sym_GT] = ACTIONS(5805),
    [anon_sym_GT_EQ] = ACTIONS(5807),
    [anon_sym_EQ_EQ] = ACTIONS(5807),
    [anon_sym_BANG_EQ] = ACTIONS(5807),
    [anon_sym_STAR] = ACTIONS(5809),
    [anon_sym_SLASH] = ACTIONS(5811),
    [anon_sym_STAR_STAR] = ACTIONS(5813),
    [anon_sym_CARET] = ACTIONS(5813),
    [aux_sym_binary_operator_token1] = ACTIONS(5815),
    [anon_sym_PIPE_GT] = ACTIONS(5815),
    [anon_sym_COLON] = ACTIONS(5817),
    [anon_sym_DOLLAR] = ACTIONS(5819),
    [anon_sym_AT] = ACTIONS(5819),
    [aux_sym__hex_literal_token1] = ACTIONS(5067),
    [sym__number_literal] = ACTIONS(5065),
    [anon_sym_SQUOTE] = ACTIONS(5067),
    [anon_sym_DQUOTE] = ACTIONS(5067),
    [sym_return] = ACTIONS(5065),
    [sym_next] = ACTIONS(5065),
    [sym_break] = ACTIONS(5065),
    [sym_true] = ACTIONS(5065),
    [sym_false] = ACTIONS(5065),
    [sym_null] = ACTIONS(5065),
    [sym_inf] = ACTIONS(5065),
    [sym_nan] = ACTIONS(5065),
    [anon_sym_NA] = ACTIONS(5065),
    [anon_sym_NA_integer_] = ACTIONS(5065),
    [anon_sym_NA_real_] = ACTIONS(5065),
    [anon_sym_NA_complex_] = ACTIONS(5065),
    [anon_sym_NA_character_] = ACTIONS(5065),
    [sym_dots] = ACTIONS(5065),
    [sym_dot_dot_i] = ACTIONS(5067),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5067),
    [sym__newline] = ACTIONS(5067),
    [sym__raw_string_literal] = ACTIONS(5067),
    [sym__external_else] = ACTIONS(5845),
    [sym__external_open_parenthesis] = ACTIONS(5823),
    [sym__external_close_parenthesis] = ACTIONS(5067),
    [sym__external_open_brace] = ACTIONS(5067),
    [sym__external_open_bracket] = ACTIONS(5825),
    [sym__external_close_bracket] = ACTIONS(5067),
    [sym__external_open_bracket2] = ACTIONS(5827),
  },
  [819] = {
    [sym_call_arguments] = STATE(2731),
    [sym_subset_arguments] = STATE(2730),
    [sym_subset2_arguments] = STATE(2729),
    [sym__else] = STATE(4194),
    [sym__open_parenthesis] = STATE(1357),
    [sym__open_bracket] = STATE(1353),
    [sym__open_bracket2] = STATE(1352),
    [sym_identifier] = ACTIONS(5115),
    [anon_sym_BSLASH] = ACTIONS(5117),
    [anon_sym_function] = ACTIONS(5115),
    [anon_sym_EQ] = ACTIONS(5783),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_for] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_repeat] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(5117),
    [anon_sym_TILDE] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(5115),
    [anon_sym_PLUS] = ACTIONS(5787),
    [anon_sym_DASH] = ACTIONS(5789),
    [anon_sym_LT_DASH] = ACTIONS(5791),
    [anon_sym_LT_LT_DASH] = ACTIONS(5791),
    [anon_sym_COLON_EQ] = ACTIONS(5791),
    [anon_sym_DASH_GT] = ACTIONS(5793),
    [anon_sym_DASH_GT_GT] = ACTIONS(5795),
    [anon_sym_PIPE] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5799),
    [anon_sym_PIPE_PIPE] = ACTIONS(5801),
    [anon_sym_AMP_AMP] = ACTIONS(5803),
    [anon_sym_LT] = ACTIONS(5805),
    [anon_sym_LT_EQ] = ACTIONS(5807),
    [anon_sym_GT] = ACTIONS(5805),
    [anon_sym_GT_EQ] = ACTIONS(5807),
    [anon_sym_EQ_EQ] = ACTIONS(5807),
    [anon_sym_BANG_EQ] = ACTIONS(5807),
    [anon_sym_STAR] = ACTIONS(5809),
    [anon_sym_SLASH] = ACTIONS(5811),
    [anon_sym_STAR_STAR] = ACTIONS(5813),
    [anon_sym_CARET] = ACTIONS(5813),
    [aux_sym_binary_operator_token1] = ACTIONS(5815),
    [anon_sym_PIPE_GT] = ACTIONS(5815),
    [anon_sym_COLON] = ACTIONS(5817),
    [anon_sym_DOLLAR] = ACTIONS(5819),
    [anon_sym_AT] = ACTIONS(5819),
    [aux_sym__hex_literal_token1] = ACTIONS(5117),
    [sym__number_literal] = ACTIONS(5115),
    [anon_sym_SQUOTE] = ACTIONS(5117),
    [anon_sym_DQUOTE] = ACTIONS(5117),
    [sym_return] = ACTIONS(5115),
    [sym_next] = ACTIONS(5115),
    [sym_break] = ACTIONS(5115),
    [sym_true] = ACTIONS(5115),
    [sym_false] = ACTIONS(5115),
    [sym_null] = ACTIONS(5115),
    [sym_inf] = ACTIONS(5115),
    [sym_nan] = ACTIONS(5115),
    [anon_sym_NA] = ACTIONS(5115),
    [anon_sym_NA_integer_] = ACTIONS(5115),
    [anon_sym_NA_real_] = ACTIONS(5115),
    [anon_sym_NA_complex_] = ACTIONS(5115),
    [anon_sym_NA_character_] = ACTIONS(5115),
    [sym_dots] = ACTIONS(5115),
    [sym_dot_dot_i] = ACTIONS(5117),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5117),
    [sym__newline] = ACTIONS(5117),
    [sym__raw_string_literal] = ACTIONS(5117),
    [sym__external_else] = ACTIONS(5847),
    [sym__external_open_parenthesis] = ACTIONS(5823),
    [sym__external_close_parenthesis] = ACTIONS(5117),
    [sym__external_open_brace] = ACTIONS(5117),
    [sym__external_open_bracket] = ACTIONS(5825),
    [sym__external_close_bracket] = ACTIONS(5117),
    [sym__external_open_bracket2] = ACTIONS(5827),
  },
  [820] = {
    [sym_call_arguments] = STATE(2731),
    [sym_subset_arguments] = STATE(2730),
    [sym_subset2_arguments] = STATE(2729),
    [sym__else] = STATE(4191),
    [sym__open_parenthesis] = STATE(1357),
    [sym__open_bracket] = STATE(1353),
    [sym__open_bracket2] = STATE(1352),
    [sym_identifier] = ACTIONS(5169),
    [anon_sym_BSLASH] = ACTIONS(5167),
    [anon_sym_function] = ACTIONS(5169),
    [anon_sym_EQ] = ACTIONS(5783),
    [anon_sym_if] = ACTIONS(5169),
    [anon_sym_for] = ACTIONS(5169),
    [anon_sym_while] = ACTIONS(5169),
    [anon_sym_repeat] = ACTIONS(5169),
    [anon_sym_QMARK] = ACTIONS(5167),
    [anon_sym_TILDE] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(5169),
    [anon_sym_PLUS] = ACTIONS(5787),
    [anon_sym_DASH] = ACTIONS(5789),
    [anon_sym_LT_DASH] = ACTIONS(5791),
    [anon_sym_LT_LT_DASH] = ACTIONS(5791),
    [anon_sym_COLON_EQ] = ACTIONS(5791),
    [anon_sym_DASH_GT] = ACTIONS(5793),
    [anon_sym_DASH_GT_GT] = ACTIONS(5795),
    [anon_sym_PIPE] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5799),
    [anon_sym_PIPE_PIPE] = ACTIONS(5801),
    [anon_sym_AMP_AMP] = ACTIONS(5803),
    [anon_sym_LT] = ACTIONS(5805),
    [anon_sym_LT_EQ] = ACTIONS(5807),
    [anon_sym_GT] = ACTIONS(5805),
    [anon_sym_GT_EQ] = ACTIONS(5807),
    [anon_sym_EQ_EQ] = ACTIONS(5807),
    [anon_sym_BANG_EQ] = ACTIONS(5807),
    [anon_sym_STAR] = ACTIONS(5809),
    [anon_sym_SLASH] = ACTIONS(5811),
    [anon_sym_STAR_STAR] = ACTIONS(5813),
    [anon_sym_CARET] = ACTIONS(5813),
    [aux_sym_binary_operator_token1] = ACTIONS(5815),
    [anon_sym_PIPE_GT] = ACTIONS(5815),
    [anon_sym_COLON] = ACTIONS(5817),
    [anon_sym_DOLLAR] = ACTIONS(5819),
    [anon_sym_AT] = ACTIONS(5819),
    [aux_sym__hex_literal_token1] = ACTIONS(5167),
    [sym__number_literal] = ACTIONS(5169),
    [anon_sym_SQUOTE] = ACTIONS(5167),
    [anon_sym_DQUOTE] = ACTIONS(5167),
    [sym_return] = ACTIONS(5169),
    [sym_next] = ACTIONS(5169),
    [sym_break] = ACTIONS(5169),
    [sym_true] = ACTIONS(5169),
    [sym_false] = ACTIONS(5169),
    [sym_null] = ACTIONS(5169),
    [sym_inf] = ACTIONS(5169),
    [sym_nan] = ACTIONS(5169),
    [anon_sym_NA] = ACTIONS(5169),
    [anon_sym_NA_integer_] = ACTIONS(5169),
    [anon_sym_NA_real_] = ACTIONS(5169),
    [anon_sym_NA_complex_] = ACTIONS(5169),
    [anon_sym_NA_character_] = ACTIONS(5169),
    [sym_dots] = ACTIONS(5169),
    [sym_dot_dot_i] = ACTIONS(5167),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5167),
    [sym__newline] = ACTIONS(5167),
    [sym__raw_string_literal] = ACTIONS(5167),
    [sym__external_else] = ACTIONS(5849),
    [sym__external_open_parenthesis] = ACTIONS(5823),
    [sym__external_close_parenthesis] = ACTIONS(5167),
    [sym__external_open_brace] = ACTIONS(5167),
    [sym__external_open_bracket] = ACTIONS(5825),
    [sym__external_close_bracket] = ACTIONS(5167),
    [sym__external_open_bracket2] = ACTIONS(5827),
  },
  [821] = {
    [sym_call_arguments] = STATE(2731),
    [sym_subset_arguments] = STATE(2730),
    [sym_subset2_arguments] = STATE(2729),
    [sym__else] = STATE(4092),
    [sym__open_parenthesis] = STATE(1357),
    [sym__open_bracket] = STATE(1353),
    [sym__open_bracket2] = STATE(1352),
    [sym_identifier] = ACTIONS(5225),
    [anon_sym_BSLASH] = ACTIONS(5227),
    [anon_sym_function] = ACTIONS(5225),
    [anon_sym_EQ] = ACTIONS(5783),
    [anon_sym_if] = ACTIONS(5225),
    [anon_sym_for] = ACTIONS(5225),
    [anon_sym_while] = ACTIONS(5225),
    [anon_sym_repeat] = ACTIONS(5225),
    [anon_sym_QMARK] = ACTIONS(5227),
    [anon_sym_TILDE] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(5225),
    [anon_sym_PLUS] = ACTIONS(5787),
    [anon_sym_DASH] = ACTIONS(5789),
    [anon_sym_LT_DASH] = ACTIONS(5791),
    [anon_sym_LT_LT_DASH] = ACTIONS(5791),
    [anon_sym_COLON_EQ] = ACTIONS(5791),
    [anon_sym_DASH_GT] = ACTIONS(5793),
    [anon_sym_DASH_GT_GT] = ACTIONS(5795),
    [anon_sym_PIPE] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5799),
    [anon_sym_PIPE_PIPE] = ACTIONS(5801),
    [anon_sym_AMP_AMP] = ACTIONS(5803),
    [anon_sym_LT] = ACTIONS(5805),
    [anon_sym_LT_EQ] = ACTIONS(5807),
    [anon_sym_GT] = ACTIONS(5805),
    [anon_sym_GT_EQ] = ACTIONS(5807),
    [anon_sym_EQ_EQ] = ACTIONS(5807),
    [anon_sym_BANG_EQ] = ACTIONS(5807),
    [anon_sym_STAR] = ACTIONS(5809),
    [anon_sym_SLASH] = ACTIONS(5811),
    [anon_sym_STAR_STAR] = ACTIONS(5813),
    [anon_sym_CARET] = ACTIONS(5813),
    [aux_sym_binary_operator_token1] = ACTIONS(5815),
    [anon_sym_PIPE_GT] = ACTIONS(5815),
    [anon_sym_COLON] = ACTIONS(5817),
    [anon_sym_DOLLAR] = ACTIONS(5819),
    [anon_sym_AT] = ACTIONS(5819),
    [aux_sym__hex_literal_token1] = ACTIONS(5227),
    [sym__number_literal] = ACTIONS(5225),
    [anon_sym_SQUOTE] = ACTIONS(5227),
    [anon_sym_DQUOTE] = ACTIONS(5227),
    [sym_return] = ACTIONS(5225),
    [sym_next] = ACTIONS(5225),
    [sym_break] = ACTIONS(5225),
    [sym_true] = ACTIONS(5225),
    [sym_false] = ACTIONS(5225),
    [sym_null] = ACTIONS(5225),
    [sym_inf] = ACTIONS(5225),
    [sym_nan] = ACTIONS(5225),
    [anon_sym_NA] = ACTIONS(5225),
    [anon_sym_NA_integer_] = ACTIONS(5225),
    [anon_sym_NA_real_] = ACTIONS(5225),
    [anon_sym_NA_complex_] = ACTIONS(5225),
    [anon_sym_NA_character_] = ACTIONS(5225),
    [sym_dots] = ACTIONS(5225),
    [sym_dot_dot_i] = ACTIONS(5227),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5227),
    [sym__newline] = ACTIONS(5227),
    [sym__raw_string_literal] = ACTIONS(5227),
    [sym__external_else] = ACTIONS(5851),
    [sym__external_open_parenthesis] = ACTIONS(5823),
    [sym__external_close_parenthesis] = ACTIONS(5227),
    [sym__external_open_brace] = ACTIONS(5227),
    [sym__external_open_bracket] = ACTIONS(5825),
    [sym__external_close_bracket] = ACTIONS(5227),
    [sym__external_open_bracket2] = ACTIONS(5827),
  },
  [822] = {
    [sym_call_arguments] = STATE(2509),
    [sym_subset_arguments] = STATE(2507),
    [sym_subset2_arguments] = STATE(2505),
    [sym__open_parenthesis] = STATE(1590),
    [sym__open_bracket] = STATE(1589),
    [sym__open_bracket2] = STATE(1588),
    [ts_builtin_sym_end] = ACTIONS(5441),
    [sym_identifier] = ACTIONS(5443),
    [anon_sym_BSLASH] = ACTIONS(5441),
    [anon_sym_function] = ACTIONS(5443),
    [anon_sym_EQ] = ACTIONS(5475),
    [anon_sym_if] = ACTIONS(5443),
    [anon_sym_for] = ACTIONS(5443),
    [anon_sym_while] = ACTIONS(5443),
    [anon_sym_repeat] = ACTIONS(5443),
    [anon_sym_QMARK] = ACTIONS(5441),
    [anon_sym_TILDE] = ACTIONS(5477),
    [anon_sym_BANG] = ACTIONS(5443),
    [anon_sym_PLUS] = ACTIONS(5479),
    [anon_sym_DASH] = ACTIONS(5481),
    [anon_sym_LT_DASH] = ACTIONS(5483),
    [anon_sym_LT_LT_DASH] = ACTIONS(5483),
    [anon_sym_COLON_EQ] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5485),
    [anon_sym_DASH_GT_GT] = ACTIONS(5487),
    [anon_sym_PIPE] = ACTIONS(5489),
    [anon_sym_AMP] = ACTIONS(5491),
    [anon_sym_PIPE_PIPE] = ACTIONS(5493),
    [anon_sym_AMP_AMP] = ACTIONS(5495),
    [anon_sym_LT] = ACTIONS(5497),
    [anon_sym_LT_EQ] = ACTIONS(5499),
    [anon_sym_GT] = ACTIONS(5497),
    [anon_sym_GT_EQ] = ACTIONS(5499),
    [anon_sym_EQ_EQ] = ACTIONS(5499),
    [anon_sym_BANG_EQ] = ACTIONS(5499),
    [anon_sym_STAR] = ACTIONS(5501),
    [anon_sym_SLASH] = ACTIONS(5503),
    [anon_sym_STAR_STAR] = ACTIONS(5505),
    [anon_sym_CARET] = ACTIONS(5505),
    [aux_sym_binary_operator_token1] = ACTIONS(5507),
    [anon_sym_PIPE_GT] = ACTIONS(5507),
    [anon_sym_COLON] = ACTIONS(5509),
    [anon_sym_DOLLAR] = ACTIONS(5511),
    [anon_sym_AT] = ACTIONS(5511),
    [aux_sym__hex_literal_token1] = ACTIONS(5441),
    [sym__number_literal] = ACTIONS(5443),
    [anon_sym_SQUOTE] = ACTIONS(5441),
    [anon_sym_DQUOTE] = ACTIONS(5441),
    [sym_return] = ACTIONS(5443),
    [sym_next] = ACTIONS(5443),
    [sym_break] = ACTIONS(5443),
    [sym_true] = ACTIONS(5443),
    [sym_false] = ACTIONS(5443),
    [sym_null] = ACTIONS(5443),
    [sym_inf] = ACTIONS(5443),
    [sym_nan] = ACTIONS(5443),
    [anon_sym_NA] = ACTIONS(5443),
    [anon_sym_NA_integer_] = ACTIONS(5443),
    [anon_sym_NA_real_] = ACTIONS(5443),
    [anon_sym_NA_complex_] = ACTIONS(5443),
    [anon_sym_NA_character_] = ACTIONS(5443),
    [sym_dots] = ACTIONS(5443),
    [sym_dot_dot_i] = ACTIONS(5441),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5441),
    [sym__newline] = ACTIONS(5441),
    [sym__semicolon] = ACTIONS(5441),
    [sym__raw_string_literal] = ACTIONS(5441),
    [sym__external_open_parenthesis] = ACTIONS(5513),
    [sym__external_close_parenthesis] = ACTIONS(5441),
    [sym__external_open_brace] = ACTIONS(5441),
    [sym__external_close_brace] = ACTIONS(5441),
    [sym__external_open_bracket] = ACTIONS(5515),
    [sym__external_open_bracket2] = ACTIONS(5517),
  },
  [823] = {
    [sym_call_arguments] = STATE(2509),
    [sym_subset_arguments] = STATE(2507),
    [sym_subset2_arguments] = STATE(2505),
    [sym__open_parenthesis] = STATE(1590),
    [sym__open_bracket] = STATE(1589),
    [sym__open_bracket2] = STATE(1588),
    [ts_builtin_sym_end] = ACTIONS(5437),
    [sym_identifier] = ACTIONS(5439),
    [anon_sym_BSLASH] = ACTIONS(5437),
    [anon_sym_function] = ACTIONS(5439),
    [anon_sym_EQ] = ACTIONS(5475),
    [anon_sym_if] = ACTIONS(5439),
    [anon_sym_for] = ACTIONS(5439),
    [anon_sym_while] = ACTIONS(5439),
    [anon_sym_repeat] = ACTIONS(5439),
    [anon_sym_QMARK] = ACTIONS(5437),
    [anon_sym_TILDE] = ACTIONS(5477),
    [anon_sym_BANG] = ACTIONS(5439),
    [anon_sym_PLUS] = ACTIONS(5479),
    [anon_sym_DASH] = ACTIONS(5481),
    [anon_sym_LT_DASH] = ACTIONS(5483),
    [anon_sym_LT_LT_DASH] = ACTIONS(5483),
    [anon_sym_COLON_EQ] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5485),
    [anon_sym_DASH_GT_GT] = ACTIONS(5487),
    [anon_sym_PIPE] = ACTIONS(5489),
    [anon_sym_AMP] = ACTIONS(5491),
    [anon_sym_PIPE_PIPE] = ACTIONS(5493),
    [anon_sym_AMP_AMP] = ACTIONS(5495),
    [anon_sym_LT] = ACTIONS(5497),
    [anon_sym_LT_EQ] = ACTIONS(5499),
    [anon_sym_GT] = ACTIONS(5497),
    [anon_sym_GT_EQ] = ACTIONS(5499),
    [anon_sym_EQ_EQ] = ACTIONS(5499),
    [anon_sym_BANG_EQ] = ACTIONS(5499),
    [anon_sym_STAR] = ACTIONS(5501),
    [anon_sym_SLASH] = ACTIONS(5503),
    [anon_sym_STAR_STAR] = ACTIONS(5505),
    [anon_sym_CARET] = ACTIONS(5505),
    [aux_sym_binary_operator_token1] = ACTIONS(5507),
    [anon_sym_PIPE_GT] = ACTIONS(5507),
    [anon_sym_COLON] = ACTIONS(5509),
    [anon_sym_DOLLAR] = ACTIONS(5511),
    [anon_sym_AT] = ACTIONS(5511),
    [aux_sym__hex_literal_token1] = ACTIONS(5437),
    [sym__number_literal] = ACTIONS(5439),
    [anon_sym_SQUOTE] = ACTIONS(5437),
    [anon_sym_DQUOTE] = ACTIONS(5437),
    [sym_return] = ACTIONS(5439),
    [sym_next] = ACTIONS(5439),
    [sym_break] = ACTIONS(5439),
    [sym_true] = ACTIONS(5439),
    [sym_false] = ACTIONS(5439),
    [sym_null] = ACTIONS(5439),
    [sym_inf] = ACTIONS(5439),
    [sym_nan] = ACTIONS(5439),
    [anon_sym_NA] = ACTIONS(5439),
    [anon_sym_NA_integer_] = ACTIONS(5439),
    [anon_sym_NA_real_] = ACTIONS(5439),
    [anon_sym_NA_complex_] = ACTIONS(5439),
    [anon_sym_NA_character_] = ACTIONS(5439),
    [sym_dots] = ACTIONS(5439),
    [sym_dot_dot_i] = ACTIONS(5437),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5437),
    [sym__newline] = ACTIONS(5437),
    [sym__semicolon] = ACTIONS(5437),
    [sym__raw_string_literal] = ACTIONS(5437),
    [sym__external_open_parenthesis] = ACTIONS(5513),
    [sym__external_close_parenthesis] = ACTIONS(5437),
    [sym__external_open_brace] = ACTIONS(5437),
    [sym__external_close_brace] = ACTIONS(5437),
    [sym__external_open_bracket] = ACTIONS(5515),
    [sym__external_open_bracket2] = ACTIONS(5517),
  },
  [824] = {
    [sym_call_arguments] = STATE(2509),
    [sym_subset_arguments] = STATE(2507),
    [sym_subset2_arguments] = STATE(2505),
    [sym__open_parenthesis] = STATE(1590),
    [sym__open_bracket] = STATE(1589),
    [sym__open_bracket2] = STATE(1588),
    [ts_builtin_sym_end] = ACTIONS(5433),
    [sym_identifier] = ACTIONS(5435),
    [anon_sym_BSLASH] = ACTIONS(5433),
    [anon_sym_function] = ACTIONS(5435),
    [anon_sym_EQ] = ACTIONS(5475),
    [anon_sym_if] = ACTIONS(5435),
    [anon_sym_for] = ACTIONS(5435),
    [anon_sym_while] = ACTIONS(5435),
    [anon_sym_repeat] = ACTIONS(5435),
    [anon_sym_QMARK] = ACTIONS(5433),
    [anon_sym_TILDE] = ACTIONS(5477),
    [anon_sym_BANG] = ACTIONS(5435),
    [anon_sym_PLUS] = ACTIONS(5479),
    [anon_sym_DASH] = ACTIONS(5481),
    [anon_sym_LT_DASH] = ACTIONS(5483),
    [anon_sym_LT_LT_DASH] = ACTIONS(5483),
    [anon_sym_COLON_EQ] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5485),
    [anon_sym_DASH_GT_GT] = ACTIONS(5487),
    [anon_sym_PIPE] = ACTIONS(5489),
    [anon_sym_AMP] = ACTIONS(5491),
    [anon_sym_PIPE_PIPE] = ACTIONS(5493),
    [anon_sym_AMP_AMP] = ACTIONS(5495),
    [anon_sym_LT] = ACTIONS(5497),
    [anon_sym_LT_EQ] = ACTIONS(5499),
    [anon_sym_GT] = ACTIONS(5497),
    [anon_sym_GT_EQ] = ACTIONS(5499),
    [anon_sym_EQ_EQ] = ACTIONS(5499),
    [anon_sym_BANG_EQ] = ACTIONS(5499),
    [anon_sym_STAR] = ACTIONS(5501),
    [anon_sym_SLASH] = ACTIONS(5503),
    [anon_sym_STAR_STAR] = ACTIONS(5505),
    [anon_sym_CARET] = ACTIONS(5505),
    [aux_sym_binary_operator_token1] = ACTIONS(5507),
    [anon_sym_PIPE_GT] = ACTIONS(5507),
    [anon_sym_COLON] = ACTIONS(5509),
    [anon_sym_DOLLAR] = ACTIONS(5511),
    [anon_sym_AT] = ACTIONS(5511),
    [aux_sym__hex_literal_token1] = ACTIONS(5433),
    [sym__number_literal] = ACTIONS(5435),
    [anon_sym_SQUOTE] = ACTIONS(5433),
    [anon_sym_DQUOTE] = ACTIONS(5433),
    [sym_return] = ACTIONS(5435),
    [sym_next] = ACTIONS(5435),
    [sym_break] = ACTIONS(5435),
    [sym_true] = ACTIONS(5435),
    [sym_false] = ACTIONS(5435),
    [sym_null] = ACTIONS(5435),
    [sym_inf] = ACTIONS(5435),
    [sym_nan] = ACTIONS(5435),
    [anon_sym_NA] = ACTIONS(5435),
    [anon_sym_NA_integer_] = ACTIONS(5435),
    [anon_sym_NA_real_] = ACTIONS(5435),
    [anon_sym_NA_complex_] = ACTIONS(5435),
    [anon_sym_NA_character_] = ACTIONS(5435),
    [sym_dots] = ACTIONS(5435),
    [sym_dot_dot_i] = ACTIONS(5433),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5433),
    [sym__newline] = ACTIONS(5433),
    [sym__semicolon] = ACTIONS(5433),
    [sym__raw_string_literal] = ACTIONS(5433),
    [sym__external_open_parenthesis] = ACTIONS(5513),
    [sym__external_close_parenthesis] = ACTIONS(5433),
    [sym__external_open_brace] = ACTIONS(5433),
    [sym__external_close_brace] = ACTIONS(5433),
    [sym__external_open_bracket] = ACTIONS(5515),
    [sym__external_open_bracket2] = ACTIONS(5517),
  },
  [825] = {
    [sym_call_arguments] = STATE(2438),
    [sym_subset_arguments] = STATE(2439),
    [sym_subset2_arguments] = STATE(2440),
    [sym__open_parenthesis] = STATE(1350),
    [sym__open_bracket] = STATE(1348),
    [sym__open_bracket2] = STATE(1346),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5379),
    [anon_sym_SLASH] = ACTIONS(5381),
    [anon_sym_STAR_STAR] = ACTIONS(5383),
    [anon_sym_CARET] = ACTIONS(5383),
    [aux_sym_binary_operator_token1] = ACTIONS(5385),
    [anon_sym_PIPE_GT] = ACTIONS(5385),
    [anon_sym_COLON] = ACTIONS(5387),
    [anon_sym_DOLLAR] = ACTIONS(5389),
    [anon_sym_AT] = ACTIONS(5389),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5393),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5395),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(5397),
  },
  [826] = {
    [sym_call_arguments] = STATE(2438),
    [sym_subset_arguments] = STATE(2439),
    [sym_subset2_arguments] = STATE(2440),
    [sym__open_parenthesis] = STATE(1350),
    [sym__open_bracket] = STATE(1348),
    [sym__open_bracket2] = STATE(1346),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5353),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5355),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5357),
    [anon_sym_DASH] = ACTIONS(5359),
    [anon_sym_LT_DASH] = ACTIONS(5361),
    [anon_sym_LT_LT_DASH] = ACTIONS(5361),
    [anon_sym_COLON_EQ] = ACTIONS(5361),
    [anon_sym_DASH_GT] = ACTIONS(5363),
    [anon_sym_DASH_GT_GT] = ACTIONS(5365),
    [anon_sym_PIPE] = ACTIONS(5367),
    [anon_sym_AMP] = ACTIONS(5369),
    [anon_sym_PIPE_PIPE] = ACTIONS(5371),
    [anon_sym_AMP_AMP] = ACTIONS(5373),
    [anon_sym_LT] = ACTIONS(5375),
    [anon_sym_LT_EQ] = ACTIONS(5377),
    [anon_sym_GT] = ACTIONS(5375),
    [anon_sym_GT_EQ] = ACTIONS(5377),
    [anon_sym_EQ_EQ] = ACTIONS(5377),
    [anon_sym_BANG_EQ] = ACTIONS(5377),
    [anon_sym_STAR] = ACTIONS(5379),
    [anon_sym_SLASH] = ACTIONS(5381),
    [anon_sym_STAR_STAR] = ACTIONS(5383),
    [anon_sym_CARET] = ACTIONS(5383),
    [aux_sym_binary_operator_token1] = ACTIONS(5385),
    [anon_sym_PIPE_GT] = ACTIONS(5385),
    [anon_sym_COLON] = ACTIONS(5387),
    [anon_sym_DOLLAR] = ACTIONS(5389),
    [anon_sym_AT] = ACTIONS(5389),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5393),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5395),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(5397),
  },
  [827] = {
    [sym_call_arguments] = STATE(2509),
    [sym_subset_arguments] = STATE(2507),
    [sym_subset2_arguments] = STATE(2505),
    [sym__open_parenthesis] = STATE(1590),
    [sym__open_bracket] = STATE(1589),
    [sym__open_bracket2] = STATE(1588),
    [ts_builtin_sym_end] = ACTIONS(5429),
    [sym_identifier] = ACTIONS(5431),
    [anon_sym_BSLASH] = ACTIONS(5429),
    [anon_sym_function] = ACTIONS(5431),
    [anon_sym_EQ] = ACTIONS(5475),
    [anon_sym_if] = ACTIONS(5431),
    [anon_sym_for] = ACTIONS(5431),
    [anon_sym_while] = ACTIONS(5431),
    [anon_sym_repeat] = ACTIONS(5431),
    [anon_sym_QMARK] = ACTIONS(5429),
    [anon_sym_TILDE] = ACTIONS(5477),
    [anon_sym_BANG] = ACTIONS(5431),
    [anon_sym_PLUS] = ACTIONS(5479),
    [anon_sym_DASH] = ACTIONS(5481),
    [anon_sym_LT_DASH] = ACTIONS(5483),
    [anon_sym_LT_LT_DASH] = ACTIONS(5483),
    [anon_sym_COLON_EQ] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5485),
    [anon_sym_DASH_GT_GT] = ACTIONS(5487),
    [anon_sym_PIPE] = ACTIONS(5489),
    [anon_sym_AMP] = ACTIONS(5491),
    [anon_sym_PIPE_PIPE] = ACTIONS(5493),
    [anon_sym_AMP_AMP] = ACTIONS(5495),
    [anon_sym_LT] = ACTIONS(5497),
    [anon_sym_LT_EQ] = ACTIONS(5499),
    [anon_sym_GT] = ACTIONS(5497),
    [anon_sym_GT_EQ] = ACTIONS(5499),
    [anon_sym_EQ_EQ] = ACTIONS(5499),
    [anon_sym_BANG_EQ] = ACTIONS(5499),
    [anon_sym_STAR] = ACTIONS(5501),
    [anon_sym_SLASH] = ACTIONS(5503),
    [anon_sym_STAR_STAR] = ACTIONS(5505),
    [anon_sym_CARET] = ACTIONS(5505),
    [aux_sym_binary_operator_token1] = ACTIONS(5507),
    [anon_sym_PIPE_GT] = ACTIONS(5507),
    [anon_sym_COLON] = ACTIONS(5509),
    [anon_sym_DOLLAR] = ACTIONS(5511),
    [anon_sym_AT] = ACTIONS(5511),
    [aux_sym__hex_literal_token1] = ACTIONS(5429),
    [sym__number_literal] = ACTIONS(5431),
    [anon_sym_SQUOTE] = ACTIONS(5429),
    [anon_sym_DQUOTE] = ACTIONS(5429),
    [sym_return] = ACTIONS(5431),
    [sym_next] = ACTIONS(5431),
    [sym_break] = ACTIONS(5431),
    [sym_true] = ACTIONS(5431),
    [sym_false] = ACTIONS(5431),
    [sym_null] = ACTIONS(5431),
    [sym_inf] = ACTIONS(5431),
    [sym_nan] = ACTIONS(5431),
    [anon_sym_NA] = ACTIONS(5431),
    [anon_sym_NA_integer_] = ACTIONS(5431),
    [anon_sym_NA_real_] = ACTIONS(5431),
    [anon_sym_NA_complex_] = ACTIONS(5431),
    [anon_sym_NA_character_] = ACTIONS(5431),
    [sym_dots] = ACTIONS(5431),
    [sym_dot_dot_i] = ACTIONS(5429),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5429),
    [sym__newline] = ACTIONS(5429),
    [sym__semicolon] = ACTIONS(5429),
    [sym__raw_string_literal] = ACTIONS(5429),
    [sym__external_open_parenthesis] = ACTIONS(5513),
    [sym__external_close_parenthesis] = ACTIONS(5429),
    [sym__external_open_brace] = ACTIONS(5429),
    [sym__external_close_brace] = ACTIONS(5429),
    [sym__external_open_bracket] = ACTIONS(5515),
    [sym__external_open_bracket2] = ACTIONS(5517),
  },
  [828] = {
    [sym_call_arguments] = STATE(2438),
    [sym_subset_arguments] = STATE(2439),
    [sym_subset2_arguments] = STATE(2440),
    [sym__open_parenthesis] = STATE(1350),
    [sym__open_bracket] = STATE(1348),
    [sym__open_bracket2] = STATE(1346),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5355),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5357),
    [anon_sym_DASH] = ACTIONS(5359),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5367),
    [anon_sym_AMP] = ACTIONS(5369),
    [anon_sym_PIPE_PIPE] = ACTIONS(5371),
    [anon_sym_AMP_AMP] = ACTIONS(5373),
    [anon_sym_LT] = ACTIONS(5375),
    [anon_sym_LT_EQ] = ACTIONS(5377),
    [anon_sym_GT] = ACTIONS(5375),
    [anon_sym_GT_EQ] = ACTIONS(5377),
    [anon_sym_EQ_EQ] = ACTIONS(5377),
    [anon_sym_BANG_EQ] = ACTIONS(5377),
    [anon_sym_STAR] = ACTIONS(5379),
    [anon_sym_SLASH] = ACTIONS(5381),
    [anon_sym_STAR_STAR] = ACTIONS(5383),
    [anon_sym_CARET] = ACTIONS(5383),
    [aux_sym_binary_operator_token1] = ACTIONS(5385),
    [anon_sym_PIPE_GT] = ACTIONS(5385),
    [anon_sym_COLON] = ACTIONS(5387),
    [anon_sym_DOLLAR] = ACTIONS(5389),
    [anon_sym_AT] = ACTIONS(5389),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5393),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5395),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(5397),
  },
  [829] = {
    [sym_call_arguments] = STATE(2438),
    [sym_subset_arguments] = STATE(2439),
    [sym_subset2_arguments] = STATE(2440),
    [sym__open_parenthesis] = STATE(1350),
    [sym__open_bracket] = STATE(1348),
    [sym__open_bracket2] = STATE(1346),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5357),
    [anon_sym_DASH] = ACTIONS(5359),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5369),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5373),
    [anon_sym_LT] = ACTIONS(5375),
    [anon_sym_LT_EQ] = ACTIONS(5377),
    [anon_sym_GT] = ACTIONS(5375),
    [anon_sym_GT_EQ] = ACTIONS(5377),
    [anon_sym_EQ_EQ] = ACTIONS(5377),
    [anon_sym_BANG_EQ] = ACTIONS(5377),
    [anon_sym_STAR] = ACTIONS(5379),
    [anon_sym_SLASH] = ACTIONS(5381),
    [anon_sym_STAR_STAR] = ACTIONS(5383),
    [anon_sym_CARET] = ACTIONS(5383),
    [aux_sym_binary_operator_token1] = ACTIONS(5385),
    [anon_sym_PIPE_GT] = ACTIONS(5385),
    [anon_sym_COLON] = ACTIONS(5387),
    [anon_sym_DOLLAR] = ACTIONS(5389),
    [anon_sym_AT] = ACTIONS(5389),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5393),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5395),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(5397),
  },
  [830] = {
    [sym_call_arguments] = STATE(2438),
    [sym_subset_arguments] = STATE(2439),
    [sym_subset2_arguments] = STATE(2440),
    [sym__open_parenthesis] = STATE(1350),
    [sym__open_bracket] = STATE(1348),
    [sym__open_bracket2] = STATE(1346),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5357),
    [anon_sym_DASH] = ACTIONS(5359),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5375),
    [anon_sym_LT_EQ] = ACTIONS(5377),
    [anon_sym_GT] = ACTIONS(5375),
    [anon_sym_GT_EQ] = ACTIONS(5377),
    [anon_sym_EQ_EQ] = ACTIONS(5377),
    [anon_sym_BANG_EQ] = ACTIONS(5377),
    [anon_sym_STAR] = ACTIONS(5379),
    [anon_sym_SLASH] = ACTIONS(5381),
    [anon_sym_STAR_STAR] = ACTIONS(5383),
    [anon_sym_CARET] = ACTIONS(5383),
    [aux_sym_binary_operator_token1] = ACTIONS(5385),
    [anon_sym_PIPE_GT] = ACTIONS(5385),
    [anon_sym_COLON] = ACTIONS(5387),
    [anon_sym_DOLLAR] = ACTIONS(5389),
    [anon_sym_AT] = ACTIONS(5389),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5393),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5395),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(5397),
  },
  [831] = {
    [sym_call_arguments] = STATE(2509),
    [sym_subset_arguments] = STATE(2507),
    [sym_subset2_arguments] = STATE(2505),
    [sym__open_parenthesis] = STATE(1590),
    [sym__open_bracket] = STATE(1589),
    [sym__open_bracket2] = STATE(1588),
    [ts_builtin_sym_end] = ACTIONS(5425),
    [sym_identifier] = ACTIONS(5427),
    [anon_sym_BSLASH] = ACTIONS(5425),
    [anon_sym_function] = ACTIONS(5427),
    [anon_sym_EQ] = ACTIONS(5475),
    [anon_sym_if] = ACTIONS(5427),
    [anon_sym_for] = ACTIONS(5427),
    [anon_sym_while] = ACTIONS(5427),
    [anon_sym_repeat] = ACTIONS(5427),
    [anon_sym_QMARK] = ACTIONS(5425),
    [anon_sym_TILDE] = ACTIONS(5477),
    [anon_sym_BANG] = ACTIONS(5427),
    [anon_sym_PLUS] = ACTIONS(5479),
    [anon_sym_DASH] = ACTIONS(5481),
    [anon_sym_LT_DASH] = ACTIONS(5483),
    [anon_sym_LT_LT_DASH] = ACTIONS(5483),
    [anon_sym_COLON_EQ] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5485),
    [anon_sym_DASH_GT_GT] = ACTIONS(5487),
    [anon_sym_PIPE] = ACTIONS(5489),
    [anon_sym_AMP] = ACTIONS(5491),
    [anon_sym_PIPE_PIPE] = ACTIONS(5493),
    [anon_sym_AMP_AMP] = ACTIONS(5495),
    [anon_sym_LT] = ACTIONS(5497),
    [anon_sym_LT_EQ] = ACTIONS(5499),
    [anon_sym_GT] = ACTIONS(5497),
    [anon_sym_GT_EQ] = ACTIONS(5499),
    [anon_sym_EQ_EQ] = ACTIONS(5499),
    [anon_sym_BANG_EQ] = ACTIONS(5499),
    [anon_sym_STAR] = ACTIONS(5501),
    [anon_sym_SLASH] = ACTIONS(5503),
    [anon_sym_STAR_STAR] = ACTIONS(5505),
    [anon_sym_CARET] = ACTIONS(5505),
    [aux_sym_binary_operator_token1] = ACTIONS(5507),
    [anon_sym_PIPE_GT] = ACTIONS(5507),
    [anon_sym_COLON] = ACTIONS(5509),
    [anon_sym_DOLLAR] = ACTIONS(5511),
    [anon_sym_AT] = ACTIONS(5511),
    [aux_sym__hex_literal_token1] = ACTIONS(5425),
    [sym__number_literal] = ACTIONS(5427),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_DQUOTE] = ACTIONS(5425),
    [sym_return] = ACTIONS(5427),
    [sym_next] = ACTIONS(5427),
    [sym_break] = ACTIONS(5427),
    [sym_true] = ACTIONS(5427),
    [sym_false] = ACTIONS(5427),
    [sym_null] = ACTIONS(5427),
    [sym_inf] = ACTIONS(5427),
    [sym_nan] = ACTIONS(5427),
    [anon_sym_NA] = ACTIONS(5427),
    [anon_sym_NA_integer_] = ACTIONS(5427),
    [anon_sym_NA_real_] = ACTIONS(5427),
    [anon_sym_NA_complex_] = ACTIONS(5427),
    [anon_sym_NA_character_] = ACTIONS(5427),
    [sym_dots] = ACTIONS(5427),
    [sym_dot_dot_i] = ACTIONS(5425),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5425),
    [sym__newline] = ACTIONS(5425),
    [sym__semicolon] = ACTIONS(5425),
    [sym__raw_string_literal] = ACTIONS(5425),
    [sym__external_open_parenthesis] = ACTIONS(5513),
    [sym__external_close_parenthesis] = ACTIONS(5425),
    [sym__external_open_brace] = ACTIONS(5425),
    [sym__external_close_brace] = ACTIONS(5425),
    [sym__external_open_bracket] = ACTIONS(5515),
    [sym__external_open_bracket2] = ACTIONS(5517),
  },
  [832] = {
    [sym_call_arguments] = STATE(2438),
    [sym_subset_arguments] = STATE(2439),
    [sym_subset2_arguments] = STATE(2440),
    [sym__open_parenthesis] = STATE(1350),
    [sym__open_bracket] = STATE(1348),
    [sym__open_bracket2] = STATE(1346),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5357),
    [anon_sym_DASH] = ACTIONS(5359),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5379),
    [anon_sym_SLASH] = ACTIONS(5381),
    [anon_sym_STAR_STAR] = ACTIONS(5383),
    [anon_sym_CARET] = ACTIONS(5383),
    [aux_sym_binary_operator_token1] = ACTIONS(5385),
    [anon_sym_PIPE_GT] = ACTIONS(5385),
    [anon_sym_COLON] = ACTIONS(5387),
    [anon_sym_DOLLAR] = ACTIONS(5389),
    [anon_sym_AT] = ACTIONS(5389),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5393),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5395),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(5397),
  },
  [833] = {
    [sym_call_arguments] = STATE(2509),
    [sym_subset_arguments] = STATE(2507),
    [sym_subset2_arguments] = STATE(2505),
    [sym__open_parenthesis] = STATE(1590),
    [sym__open_bracket] = STATE(1589),
    [sym__open_bracket2] = STATE(1588),
    [ts_builtin_sym_end] = ACTIONS(5421),
    [sym_identifier] = ACTIONS(5423),
    [anon_sym_BSLASH] = ACTIONS(5421),
    [anon_sym_function] = ACTIONS(5423),
    [anon_sym_EQ] = ACTIONS(5475),
    [anon_sym_if] = ACTIONS(5423),
    [anon_sym_for] = ACTIONS(5423),
    [anon_sym_while] = ACTIONS(5423),
    [anon_sym_repeat] = ACTIONS(5423),
    [anon_sym_QMARK] = ACTIONS(5421),
    [anon_sym_TILDE] = ACTIONS(5477),
    [anon_sym_BANG] = ACTIONS(5423),
    [anon_sym_PLUS] = ACTIONS(5479),
    [anon_sym_DASH] = ACTIONS(5481),
    [anon_sym_LT_DASH] = ACTIONS(5483),
    [anon_sym_LT_LT_DASH] = ACTIONS(5483),
    [anon_sym_COLON_EQ] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5485),
    [anon_sym_DASH_GT_GT] = ACTIONS(5487),
    [anon_sym_PIPE] = ACTIONS(5489),
    [anon_sym_AMP] = ACTIONS(5491),
    [anon_sym_PIPE_PIPE] = ACTIONS(5493),
    [anon_sym_AMP_AMP] = ACTIONS(5495),
    [anon_sym_LT] = ACTIONS(5497),
    [anon_sym_LT_EQ] = ACTIONS(5499),
    [anon_sym_GT] = ACTIONS(5497),
    [anon_sym_GT_EQ] = ACTIONS(5499),
    [anon_sym_EQ_EQ] = ACTIONS(5499),
    [anon_sym_BANG_EQ] = ACTIONS(5499),
    [anon_sym_STAR] = ACTIONS(5501),
    [anon_sym_SLASH] = ACTIONS(5503),
    [anon_sym_STAR_STAR] = ACTIONS(5505),
    [anon_sym_CARET] = ACTIONS(5505),
    [aux_sym_binary_operator_token1] = ACTIONS(5507),
    [anon_sym_PIPE_GT] = ACTIONS(5507),
    [anon_sym_COLON] = ACTIONS(5509),
    [anon_sym_DOLLAR] = ACTIONS(5511),
    [anon_sym_AT] = ACTIONS(5511),
    [aux_sym__hex_literal_token1] = ACTIONS(5421),
    [sym__number_literal] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5421),
    [anon_sym_DQUOTE] = ACTIONS(5421),
    [sym_return] = ACTIONS(5423),
    [sym_next] = ACTIONS(5423),
    [sym_break] = ACTIONS(5423),
    [sym_true] = ACTIONS(5423),
    [sym_false] = ACTIONS(5423),
    [sym_null] = ACTIONS(5423),
    [sym_inf] = ACTIONS(5423),
    [sym_nan] = ACTIONS(5423),
    [anon_sym_NA] = ACTIONS(5423),
    [anon_sym_NA_integer_] = ACTIONS(5423),
    [anon_sym_NA_real_] = ACTIONS(5423),
    [anon_sym_NA_complex_] = ACTIONS(5423),
    [anon_sym_NA_character_] = ACTIONS(5423),
    [sym_dots] = ACTIONS(5423),
    [sym_dot_dot_i] = ACTIONS(5421),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5421),
    [sym__newline] = ACTIONS(5421),
    [sym__semicolon] = ACTIONS(5421),
    [sym__raw_string_literal] = ACTIONS(5421),
    [sym__external_open_parenthesis] = ACTIONS(5513),
    [sym__external_close_parenthesis] = ACTIONS(5421),
    [sym__external_open_brace] = ACTIONS(5421),
    [sym__external_close_brace] = ACTIONS(5421),
    [sym__external_open_bracket] = ACTIONS(5515),
    [sym__external_open_bracket2] = ACTIONS(5517),
  },
  [834] = {
    [sym_call_arguments] = STATE(2509),
    [sym_subset_arguments] = STATE(2507),
    [sym_subset2_arguments] = STATE(2505),
    [sym__open_parenthesis] = STATE(1590),
    [sym__open_bracket] = STATE(1589),
    [sym__open_bracket2] = STATE(1588),
    [ts_builtin_sym_end] = ACTIONS(5417),
    [sym_identifier] = ACTIONS(5419),
    [anon_sym_BSLASH] = ACTIONS(5417),
    [anon_sym_function] = ACTIONS(5419),
    [anon_sym_EQ] = ACTIONS(5475),
    [anon_sym_if] = ACTIONS(5419),
    [anon_sym_for] = ACTIONS(5419),
    [anon_sym_while] = ACTIONS(5419),
    [anon_sym_repeat] = ACTIONS(5419),
    [anon_sym_QMARK] = ACTIONS(5417),
    [anon_sym_TILDE] = ACTIONS(5477),
    [anon_sym_BANG] = ACTIONS(5419),
    [anon_sym_PLUS] = ACTIONS(5479),
    [anon_sym_DASH] = ACTIONS(5481),
    [anon_sym_LT_DASH] = ACTIONS(5483),
    [anon_sym_LT_LT_DASH] = ACTIONS(5483),
    [anon_sym_COLON_EQ] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5485),
    [anon_sym_DASH_GT_GT] = ACTIONS(5487),
    [anon_sym_PIPE] = ACTIONS(5489),
    [anon_sym_AMP] = ACTIONS(5491),
    [anon_sym_PIPE_PIPE] = ACTIONS(5493),
    [anon_sym_AMP_AMP] = ACTIONS(5495),
    [anon_sym_LT] = ACTIONS(5497),
    [anon_sym_LT_EQ] = ACTIONS(5499),
    [anon_sym_GT] = ACTIONS(5497),
    [anon_sym_GT_EQ] = ACTIONS(5499),
    [anon_sym_EQ_EQ] = ACTIONS(5499),
    [anon_sym_BANG_EQ] = ACTIONS(5499),
    [anon_sym_STAR] = ACTIONS(5501),
    [anon_sym_SLASH] = ACTIONS(5503),
    [anon_sym_STAR_STAR] = ACTIONS(5505),
    [anon_sym_CARET] = ACTIONS(5505),
    [aux_sym_binary_operator_token1] = ACTIONS(5507),
    [anon_sym_PIPE_GT] = ACTIONS(5507),
    [anon_sym_COLON] = ACTIONS(5509),
    [anon_sym_DOLLAR] = ACTIONS(5511),
    [anon_sym_AT] = ACTIONS(5511),
    [aux_sym__hex_literal_token1] = ACTIONS(5417),
    [sym__number_literal] = ACTIONS(5419),
    [anon_sym_SQUOTE] = ACTIONS(5417),
    [anon_sym_DQUOTE] = ACTIONS(5417),
    [sym_return] = ACTIONS(5419),
    [sym_next] = ACTIONS(5419),
    [sym_break] = ACTIONS(5419),
    [sym_true] = ACTIONS(5419),
    [sym_false] = ACTIONS(5419),
    [sym_null] = ACTIONS(5419),
    [sym_inf] = ACTIONS(5419),
    [sym_nan] = ACTIONS(5419),
    [anon_sym_NA] = ACTIONS(5419),
    [anon_sym_NA_integer_] = ACTIONS(5419),
    [anon_sym_NA_real_] = ACTIONS(5419),
    [anon_sym_NA_complex_] = ACTIONS(5419),
    [anon_sym_NA_character_] = ACTIONS(5419),
    [sym_dots] = ACTIONS(5419),
    [sym_dot_dot_i] = ACTIONS(5417),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5417),
    [sym__newline] = ACTIONS(5417),
    [sym__semicolon] = ACTIONS(5417),
    [sym__raw_string_literal] = ACTIONS(5417),
    [sym__external_open_parenthesis] = ACTIONS(5513),
    [sym__external_close_parenthesis] = ACTIONS(5417),
    [sym__external_open_brace] = ACTIONS(5417),
    [sym__external_close_brace] = ACTIONS(5417),
    [sym__external_open_bracket] = ACTIONS(5515),
    [sym__external_open_bracket2] = ACTIONS(5517),
  },
  [835] = {
    [sym_call_arguments] = STATE(2438),
    [sym_subset_arguments] = STATE(2439),
    [sym_subset2_arguments] = STATE(2440),
    [sym__open_parenthesis] = STATE(1350),
    [sym__open_bracket] = STATE(1348),
    [sym__open_bracket2] = STATE(1346),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(5383),
    [anon_sym_CARET] = ACTIONS(5383),
    [aux_sym_binary_operator_token1] = ACTIONS(5385),
    [anon_sym_PIPE_GT] = ACTIONS(5385),
    [anon_sym_COLON] = ACTIONS(5387),
    [anon_sym_DOLLAR] = ACTIONS(5389),
    [anon_sym_AT] = ACTIONS(5389),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5393),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5395),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(5397),
  },
  [836] = {
    [sym_call_arguments] = STATE(2438),
    [sym_subset_arguments] = STATE(2439),
    [sym_subset2_arguments] = STATE(2440),
    [sym__open_parenthesis] = STATE(1350),
    [sym__open_bracket] = STATE(1348),
    [sym__open_bracket2] = STATE(1346),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(5383),
    [anon_sym_CARET] = ACTIONS(5383),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(5351),
    [anon_sym_DOLLAR] = ACTIONS(5389),
    [anon_sym_AT] = ACTIONS(5389),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5393),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5395),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(5397),
  },
  [837] = {
    [sym_call_arguments] = STATE(2438),
    [sym_subset_arguments] = STATE(2439),
    [sym_subset2_arguments] = STATE(2440),
    [sym__open_parenthesis] = STATE(1350),
    [sym__open_bracket] = STATE(1348),
    [sym__open_bracket2] = STATE(1346),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(5383),
    [anon_sym_CARET] = ACTIONS(5383),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(5387),
    [anon_sym_DOLLAR] = ACTIONS(5389),
    [anon_sym_AT] = ACTIONS(5389),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5393),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5395),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(5397),
  },
  [838] = {
    [sym_call_arguments] = STATE(2438),
    [sym_subset_arguments] = STATE(2439),
    [sym_subset2_arguments] = STATE(2440),
    [sym__open_parenthesis] = STATE(1350),
    [sym__open_bracket] = STATE(1348),
    [sym__open_bracket2] = STATE(1346),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(5383),
    [anon_sym_CARET] = ACTIONS(5383),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(5351),
    [anon_sym_DOLLAR] = ACTIONS(5389),
    [anon_sym_AT] = ACTIONS(5389),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5393),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5395),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(5397),
  },
  [839] = {
    [sym_call_arguments] = STATE(2509),
    [sym_subset_arguments] = STATE(2507),
    [sym_subset2_arguments] = STATE(2505),
    [sym__open_parenthesis] = STATE(1590),
    [sym__open_bracket] = STATE(1589),
    [sym__open_bracket2] = STATE(1588),
    [ts_builtin_sym_end] = ACTIONS(5413),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_BSLASH] = ACTIONS(5413),
    [anon_sym_function] = ACTIONS(5415),
    [anon_sym_EQ] = ACTIONS(5475),
    [anon_sym_if] = ACTIONS(5415),
    [anon_sym_for] = ACTIONS(5415),
    [anon_sym_while] = ACTIONS(5415),
    [anon_sym_repeat] = ACTIONS(5415),
    [anon_sym_QMARK] = ACTIONS(5413),
    [anon_sym_TILDE] = ACTIONS(5477),
    [anon_sym_BANG] = ACTIONS(5415),
    [anon_sym_PLUS] = ACTIONS(5479),
    [anon_sym_DASH] = ACTIONS(5481),
    [anon_sym_LT_DASH] = ACTIONS(5483),
    [anon_sym_LT_LT_DASH] = ACTIONS(5483),
    [anon_sym_COLON_EQ] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5485),
    [anon_sym_DASH_GT_GT] = ACTIONS(5487),
    [anon_sym_PIPE] = ACTIONS(5489),
    [anon_sym_AMP] = ACTIONS(5491),
    [anon_sym_PIPE_PIPE] = ACTIONS(5493),
    [anon_sym_AMP_AMP] = ACTIONS(5495),
    [anon_sym_LT] = ACTIONS(5497),
    [anon_sym_LT_EQ] = ACTIONS(5499),
    [anon_sym_GT] = ACTIONS(5497),
    [anon_sym_GT_EQ] = ACTIONS(5499),
    [anon_sym_EQ_EQ] = ACTIONS(5499),
    [anon_sym_BANG_EQ] = ACTIONS(5499),
    [anon_sym_STAR] = ACTIONS(5501),
    [anon_sym_SLASH] = ACTIONS(5503),
    [anon_sym_STAR_STAR] = ACTIONS(5505),
    [anon_sym_CARET] = ACTIONS(5505),
    [aux_sym_binary_operator_token1] = ACTIONS(5507),
    [anon_sym_PIPE_GT] = ACTIONS(5507),
    [anon_sym_COLON] = ACTIONS(5509),
    [anon_sym_DOLLAR] = ACTIONS(5511),
    [anon_sym_AT] = ACTIONS(5511),
    [aux_sym__hex_literal_token1] = ACTIONS(5413),
    [sym__number_literal] = ACTIONS(5415),
    [anon_sym_SQUOTE] = ACTIONS(5413),
    [anon_sym_DQUOTE] = ACTIONS(5413),
    [sym_return] = ACTIONS(5415),
    [sym_next] = ACTIONS(5415),
    [sym_break] = ACTIONS(5415),
    [sym_true] = ACTIONS(5415),
    [sym_false] = ACTIONS(5415),
    [sym_null] = ACTIONS(5415),
    [sym_inf] = ACTIONS(5415),
    [sym_nan] = ACTIONS(5415),
    [anon_sym_NA] = ACTIONS(5415),
    [anon_sym_NA_integer_] = ACTIONS(5415),
    [anon_sym_NA_real_] = ACTIONS(5415),
    [anon_sym_NA_complex_] = ACTIONS(5415),
    [anon_sym_NA_character_] = ACTIONS(5415),
    [sym_dots] = ACTIONS(5415),
    [sym_dot_dot_i] = ACTIONS(5413),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5413),
    [sym__newline] = ACTIONS(5413),
    [sym__semicolon] = ACTIONS(5413),
    [sym__raw_string_literal] = ACTIONS(5413),
    [sym__external_open_parenthesis] = ACTIONS(5513),
    [sym__external_close_parenthesis] = ACTIONS(5413),
    [sym__external_open_brace] = ACTIONS(5413),
    [sym__external_close_brace] = ACTIONS(5413),
    [sym__external_open_bracket] = ACTIONS(5515),
    [sym__external_open_bracket2] = ACTIONS(5517),
  },
  [840] = {
    [sym_call_arguments] = STATE(2438),
    [sym_subset_arguments] = STATE(2439),
    [sym_subset2_arguments] = STATE(2440),
    [sym__open_parenthesis] = STATE(1350),
    [sym__open_bracket] = STATE(1348),
    [sym__open_bracket2] = STATE(1346),
    [sym_identifier] = ACTIONS(5401),
    [anon_sym_BSLASH] = ACTIONS(5399),
    [anon_sym_function] = ACTIONS(5401),
    [anon_sym_EQ] = ACTIONS(5353),
    [anon_sym_if] = ACTIONS(5401),
    [anon_sym_for] = ACTIONS(5401),
    [anon_sym_while] = ACTIONS(5401),
    [anon_sym_repeat] = ACTIONS(5401),
    [anon_sym_QMARK] = ACTIONS(5399),
    [anon_sym_TILDE] = ACTIONS(5355),
    [anon_sym_BANG] = ACTIONS(5401),
    [anon_sym_PLUS] = ACTIONS(5357),
    [anon_sym_DASH] = ACTIONS(5359),
    [anon_sym_LT_DASH] = ACTIONS(5361),
    [anon_sym_LT_LT_DASH] = ACTIONS(5361),
    [anon_sym_COLON_EQ] = ACTIONS(5361),
    [anon_sym_DASH_GT] = ACTIONS(5363),
    [anon_sym_DASH_GT_GT] = ACTIONS(5365),
    [anon_sym_PIPE] = ACTIONS(5367),
    [anon_sym_AMP] = ACTIONS(5369),
    [anon_sym_PIPE_PIPE] = ACTIONS(5371),
    [anon_sym_AMP_AMP] = ACTIONS(5373),
    [anon_sym_LT] = ACTIONS(5375),
    [anon_sym_LT_EQ] = ACTIONS(5377),
    [anon_sym_GT] = ACTIONS(5375),
    [anon_sym_GT_EQ] = ACTIONS(5377),
    [anon_sym_EQ_EQ] = ACTIONS(5377),
    [anon_sym_BANG_EQ] = ACTIONS(5377),
    [anon_sym_STAR] = ACTIONS(5379),
    [anon_sym_SLASH] = ACTIONS(5381),
    [anon_sym_STAR_STAR] = ACTIONS(5383),
    [anon_sym_CARET] = ACTIONS(5383),
    [aux_sym_binary_operator_token1] = ACTIONS(5385),
    [anon_sym_PIPE_GT] = ACTIONS(5385),
    [anon_sym_COLON] = ACTIONS(5387),
    [anon_sym_DOLLAR] = ACTIONS(5389),
    [anon_sym_AT] = ACTIONS(5389),
    [aux_sym__hex_literal_token1] = ACTIONS(5399),
    [sym__number_literal] = ACTIONS(5401),
    [anon_sym_SQUOTE] = ACTIONS(5399),
    [anon_sym_DQUOTE] = ACTIONS(5399),
    [sym_return] = ACTIONS(5401),
    [sym_next] = ACTIONS(5401),
    [sym_break] = ACTIONS(5401),
    [sym_true] = ACTIONS(5401),
    [sym_false] = ACTIONS(5401),
    [sym_null] = ACTIONS(5401),
    [sym_inf] = ACTIONS(5401),
    [sym_nan] = ACTIONS(5401),
    [anon_sym_NA] = ACTIONS(5401),
    [anon_sym_NA_integer_] = ACTIONS(5401),
    [anon_sym_NA_real_] = ACTIONS(5401),
    [anon_sym_NA_complex_] = ACTIONS(5401),
    [anon_sym_NA_character_] = ACTIONS(5401),
    [sym_dots] = ACTIONS(5401),
    [sym_dot_dot_i] = ACTIONS(5399),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5399),
    [sym__newline] = ACTIONS(5399),
    [sym__semicolon] = ACTIONS(5399),
    [sym__raw_string_literal] = ACTIONS(5399),
    [sym__external_else] = ACTIONS(5399),
    [sym__external_open_parenthesis] = ACTIONS(5393),
    [sym__external_open_brace] = ACTIONS(5399),
    [sym__external_close_brace] = ACTIONS(5399),
    [sym__external_open_bracket] = ACTIONS(5395),
    [sym__external_close_bracket] = ACTIONS(5399),
    [sym__external_open_bracket2] = ACTIONS(5397),
  },
  [841] = {
    [sym_call_arguments] = STATE(2438),
    [sym_subset_arguments] = STATE(2439),
    [sym_subset2_arguments] = STATE(2440),
    [sym__open_parenthesis] = STATE(1350),
    [sym__open_bracket] = STATE(1348),
    [sym__open_bracket2] = STATE(1346),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5353),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5355),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5357),
    [anon_sym_DASH] = ACTIONS(5359),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5363),
    [anon_sym_DASH_GT_GT] = ACTIONS(5365),
    [anon_sym_PIPE] = ACTIONS(5367),
    [anon_sym_AMP] = ACTIONS(5369),
    [anon_sym_PIPE_PIPE] = ACTIONS(5371),
    [anon_sym_AMP_AMP] = ACTIONS(5373),
    [anon_sym_LT] = ACTIONS(5375),
    [anon_sym_LT_EQ] = ACTIONS(5377),
    [anon_sym_GT] = ACTIONS(5375),
    [anon_sym_GT_EQ] = ACTIONS(5377),
    [anon_sym_EQ_EQ] = ACTIONS(5377),
    [anon_sym_BANG_EQ] = ACTIONS(5377),
    [anon_sym_STAR] = ACTIONS(5379),
    [anon_sym_SLASH] = ACTIONS(5381),
    [anon_sym_STAR_STAR] = ACTIONS(5383),
    [anon_sym_CARET] = ACTIONS(5383),
    [aux_sym_binary_operator_token1] = ACTIONS(5385),
    [anon_sym_PIPE_GT] = ACTIONS(5385),
    [anon_sym_COLON] = ACTIONS(5387),
    [anon_sym_DOLLAR] = ACTIONS(5389),
    [anon_sym_AT] = ACTIONS(5389),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5393),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5395),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(5397),
  },
  [842] = {
    [sym_call_arguments] = STATE(2438),
    [sym_subset_arguments] = STATE(2439),
    [sym_subset2_arguments] = STATE(2440),
    [sym__open_parenthesis] = STATE(1350),
    [sym__open_bracket] = STATE(1348),
    [sym__open_bracket2] = STATE(1346),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5353),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5355),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5357),
    [anon_sym_DASH] = ACTIONS(5359),
    [anon_sym_LT_DASH] = ACTIONS(5361),
    [anon_sym_LT_LT_DASH] = ACTIONS(5361),
    [anon_sym_COLON_EQ] = ACTIONS(5361),
    [anon_sym_DASH_GT] = ACTIONS(5363),
    [anon_sym_DASH_GT_GT] = ACTIONS(5365),
    [anon_sym_PIPE] = ACTIONS(5367),
    [anon_sym_AMP] = ACTIONS(5369),
    [anon_sym_PIPE_PIPE] = ACTIONS(5371),
    [anon_sym_AMP_AMP] = ACTIONS(5373),
    [anon_sym_LT] = ACTIONS(5375),
    [anon_sym_LT_EQ] = ACTIONS(5377),
    [anon_sym_GT] = ACTIONS(5375),
    [anon_sym_GT_EQ] = ACTIONS(5377),
    [anon_sym_EQ_EQ] = ACTIONS(5377),
    [anon_sym_BANG_EQ] = ACTIONS(5377),
    [anon_sym_STAR] = ACTIONS(5379),
    [anon_sym_SLASH] = ACTIONS(5381),
    [anon_sym_STAR_STAR] = ACTIONS(5383),
    [anon_sym_CARET] = ACTIONS(5383),
    [aux_sym_binary_operator_token1] = ACTIONS(5385),
    [anon_sym_PIPE_GT] = ACTIONS(5385),
    [anon_sym_COLON] = ACTIONS(5387),
    [anon_sym_DOLLAR] = ACTIONS(5389),
    [anon_sym_AT] = ACTIONS(5389),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5393),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5395),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(5397),
  },
  [843] = {
    [sym_call_arguments] = STATE(2438),
    [sym_subset_arguments] = STATE(2439),
    [sym_subset2_arguments] = STATE(2440),
    [sym__open_parenthesis] = STATE(1350),
    [sym__open_bracket] = STATE(1348),
    [sym__open_bracket2] = STATE(1346),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5357),
    [anon_sym_DASH] = ACTIONS(5359),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5367),
    [anon_sym_AMP] = ACTIONS(5369),
    [anon_sym_PIPE_PIPE] = ACTIONS(5371),
    [anon_sym_AMP_AMP] = ACTIONS(5373),
    [anon_sym_LT] = ACTIONS(5375),
    [anon_sym_LT_EQ] = ACTIONS(5377),
    [anon_sym_GT] = ACTIONS(5375),
    [anon_sym_GT_EQ] = ACTIONS(5377),
    [anon_sym_EQ_EQ] = ACTIONS(5377),
    [anon_sym_BANG_EQ] = ACTIONS(5377),
    [anon_sym_STAR] = ACTIONS(5379),
    [anon_sym_SLASH] = ACTIONS(5381),
    [anon_sym_STAR_STAR] = ACTIONS(5383),
    [anon_sym_CARET] = ACTIONS(5383),
    [aux_sym_binary_operator_token1] = ACTIONS(5385),
    [anon_sym_PIPE_GT] = ACTIONS(5385),
    [anon_sym_COLON] = ACTIONS(5387),
    [anon_sym_DOLLAR] = ACTIONS(5389),
    [anon_sym_AT] = ACTIONS(5389),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5393),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5395),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(5397),
  },
  [844] = {
    [sym_call_arguments] = STATE(2438),
    [sym_subset_arguments] = STATE(2439),
    [sym_subset2_arguments] = STATE(2440),
    [sym__open_parenthesis] = STATE(1350),
    [sym__open_bracket] = STATE(1348),
    [sym__open_bracket2] = STATE(1346),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5379),
    [anon_sym_SLASH] = ACTIONS(5381),
    [anon_sym_STAR_STAR] = ACTIONS(5383),
    [anon_sym_CARET] = ACTIONS(5383),
    [aux_sym_binary_operator_token1] = ACTIONS(5385),
    [anon_sym_PIPE_GT] = ACTIONS(5385),
    [anon_sym_COLON] = ACTIONS(5387),
    [anon_sym_DOLLAR] = ACTIONS(5389),
    [anon_sym_AT] = ACTIONS(5389),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5393),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5395),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(5397),
  },
  [845] = {
    [sym_call_arguments] = STATE(2509),
    [sym_subset_arguments] = STATE(2507),
    [sym_subset2_arguments] = STATE(2505),
    [sym__open_parenthesis] = STATE(1590),
    [sym__open_bracket] = STATE(1589),
    [sym__open_bracket2] = STATE(1588),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(5505),
    [anon_sym_CARET] = ACTIONS(5505),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(5261),
    [anon_sym_DOLLAR] = ACTIONS(5511),
    [anon_sym_AT] = ACTIONS(5511),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5513),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5515),
    [sym__external_open_bracket2] = ACTIONS(5517),
  },
  [846] = {
    [sym_call_arguments] = STATE(2509),
    [sym_subset_arguments] = STATE(2507),
    [sym_subset2_arguments] = STATE(2505),
    [sym__open_parenthesis] = STATE(1590),
    [sym__open_bracket] = STATE(1589),
    [sym__open_bracket2] = STATE(1588),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(5505),
    [anon_sym_CARET] = ACTIONS(5505),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(5509),
    [anon_sym_DOLLAR] = ACTIONS(5511),
    [anon_sym_AT] = ACTIONS(5511),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5513),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5515),
    [sym__external_open_bracket2] = ACTIONS(5517),
  },
  [847] = {
    [sym_call_arguments] = STATE(2509),
    [sym_subset_arguments] = STATE(2507),
    [sym_subset2_arguments] = STATE(2505),
    [sym__open_parenthesis] = STATE(1590),
    [sym__open_bracket] = STATE(1589),
    [sym__open_bracket2] = STATE(1588),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(5505),
    [anon_sym_CARET] = ACTIONS(5505),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(5261),
    [anon_sym_DOLLAR] = ACTIONS(5511),
    [anon_sym_AT] = ACTIONS(5511),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5513),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5515),
    [sym__external_open_bracket2] = ACTIONS(5517),
  },
  [848] = {
    [sym_call_arguments] = STATE(2509),
    [sym_subset_arguments] = STATE(2507),
    [sym_subset2_arguments] = STATE(2505),
    [sym__open_parenthesis] = STATE(1590),
    [sym__open_bracket] = STATE(1589),
    [sym__open_bracket2] = STATE(1588),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(5505),
    [anon_sym_CARET] = ACTIONS(5505),
    [aux_sym_binary_operator_token1] = ACTIONS(5507),
    [anon_sym_PIPE_GT] = ACTIONS(5507),
    [anon_sym_COLON] = ACTIONS(5509),
    [anon_sym_DOLLAR] = ACTIONS(5511),
    [anon_sym_AT] = ACTIONS(5511),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5513),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5515),
    [sym__external_open_bracket2] = ACTIONS(5517),
  },
  [849] = {
    [sym_call_arguments] = STATE(2509),
    [sym_subset_arguments] = STATE(2507),
    [sym_subset2_arguments] = STATE(2505),
    [sym__open_parenthesis] = STATE(1590),
    [sym__open_bracket] = STATE(1589),
    [sym__open_bracket2] = STATE(1588),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5479),
    [anon_sym_DASH] = ACTIONS(5481),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5501),
    [anon_sym_SLASH] = ACTIONS(5503),
    [anon_sym_STAR_STAR] = ACTIONS(5505),
    [anon_sym_CARET] = ACTIONS(5505),
    [aux_sym_binary_operator_token1] = ACTIONS(5507),
    [anon_sym_PIPE_GT] = ACTIONS(5507),
    [anon_sym_COLON] = ACTIONS(5509),
    [anon_sym_DOLLAR] = ACTIONS(5511),
    [anon_sym_AT] = ACTIONS(5511),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5513),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5515),
    [sym__external_open_bracket2] = ACTIONS(5517),
  },
  [850] = {
    [sym_call_arguments] = STATE(2509),
    [sym_subset_arguments] = STATE(2507),
    [sym_subset2_arguments] = STATE(2505),
    [sym__open_parenthesis] = STATE(1590),
    [sym__open_bracket] = STATE(1589),
    [sym__open_bracket2] = STATE(1588),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5479),
    [anon_sym_DASH] = ACTIONS(5481),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5497),
    [anon_sym_LT_EQ] = ACTIONS(5499),
    [anon_sym_GT] = ACTIONS(5497),
    [anon_sym_GT_EQ] = ACTIONS(5499),
    [anon_sym_EQ_EQ] = ACTIONS(5499),
    [anon_sym_BANG_EQ] = ACTIONS(5499),
    [anon_sym_STAR] = ACTIONS(5501),
    [anon_sym_SLASH] = ACTIONS(5503),
    [anon_sym_STAR_STAR] = ACTIONS(5505),
    [anon_sym_CARET] = ACTIONS(5505),
    [aux_sym_binary_operator_token1] = ACTIONS(5507),
    [anon_sym_PIPE_GT] = ACTIONS(5507),
    [anon_sym_COLON] = ACTIONS(5509),
    [anon_sym_DOLLAR] = ACTIONS(5511),
    [anon_sym_AT] = ACTIONS(5511),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5513),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5515),
    [sym__external_open_bracket2] = ACTIONS(5517),
  },
  [851] = {
    [sym_call_arguments] = STATE(2509),
    [sym_subset_arguments] = STATE(2507),
    [sym_subset2_arguments] = STATE(2505),
    [sym__open_parenthesis] = STATE(1590),
    [sym__open_bracket] = STATE(1589),
    [sym__open_bracket2] = STATE(1588),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5479),
    [anon_sym_DASH] = ACTIONS(5481),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5491),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5495),
    [anon_sym_LT] = ACTIONS(5497),
    [anon_sym_LT_EQ] = ACTIONS(5499),
    [anon_sym_GT] = ACTIONS(5497),
    [anon_sym_GT_EQ] = ACTIONS(5499),
    [anon_sym_EQ_EQ] = ACTIONS(5499),
    [anon_sym_BANG_EQ] = ACTIONS(5499),
    [anon_sym_STAR] = ACTIONS(5501),
    [anon_sym_SLASH] = ACTIONS(5503),
    [anon_sym_STAR_STAR] = ACTIONS(5505),
    [anon_sym_CARET] = ACTIONS(5505),
    [aux_sym_binary_operator_token1] = ACTIONS(5507),
    [anon_sym_PIPE_GT] = ACTIONS(5507),
    [anon_sym_COLON] = ACTIONS(5509),
    [anon_sym_DOLLAR] = ACTIONS(5511),
    [anon_sym_AT] = ACTIONS(5511),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5513),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5515),
    [sym__external_open_bracket2] = ACTIONS(5517),
  },
  [852] = {
    [sym_call_arguments] = STATE(2509),
    [sym_subset_arguments] = STATE(2507),
    [sym_subset2_arguments] = STATE(2505),
    [sym__open_parenthesis] = STATE(1590),
    [sym__open_bracket] = STATE(1589),
    [sym__open_bracket2] = STATE(1588),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5477),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5479),
    [anon_sym_DASH] = ACTIONS(5481),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5489),
    [anon_sym_AMP] = ACTIONS(5491),
    [anon_sym_PIPE_PIPE] = ACTIONS(5493),
    [anon_sym_AMP_AMP] = ACTIONS(5495),
    [anon_sym_LT] = ACTIONS(5497),
    [anon_sym_LT_EQ] = ACTIONS(5499),
    [anon_sym_GT] = ACTIONS(5497),
    [anon_sym_GT_EQ] = ACTIONS(5499),
    [anon_sym_EQ_EQ] = ACTIONS(5499),
    [anon_sym_BANG_EQ] = ACTIONS(5499),
    [anon_sym_STAR] = ACTIONS(5501),
    [anon_sym_SLASH] = ACTIONS(5503),
    [anon_sym_STAR_STAR] = ACTIONS(5505),
    [anon_sym_CARET] = ACTIONS(5505),
    [aux_sym_binary_operator_token1] = ACTIONS(5507),
    [anon_sym_PIPE_GT] = ACTIONS(5507),
    [anon_sym_COLON] = ACTIONS(5509),
    [anon_sym_DOLLAR] = ACTIONS(5511),
    [anon_sym_AT] = ACTIONS(5511),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5513),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5515),
    [sym__external_open_bracket2] = ACTIONS(5517),
  },
  [853] = {
    [sym_call_arguments] = STATE(2509),
    [sym_subset_arguments] = STATE(2507),
    [sym_subset2_arguments] = STATE(2505),
    [sym__open_parenthesis] = STATE(1590),
    [sym__open_bracket] = STATE(1589),
    [sym__open_bracket2] = STATE(1588),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5475),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5477),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5479),
    [anon_sym_DASH] = ACTIONS(5481),
    [anon_sym_LT_DASH] = ACTIONS(5483),
    [anon_sym_LT_LT_DASH] = ACTIONS(5483),
    [anon_sym_COLON_EQ] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5485),
    [anon_sym_DASH_GT_GT] = ACTIONS(5487),
    [anon_sym_PIPE] = ACTIONS(5489),
    [anon_sym_AMP] = ACTIONS(5491),
    [anon_sym_PIPE_PIPE] = ACTIONS(5493),
    [anon_sym_AMP_AMP] = ACTIONS(5495),
    [anon_sym_LT] = ACTIONS(5497),
    [anon_sym_LT_EQ] = ACTIONS(5499),
    [anon_sym_GT] = ACTIONS(5497),
    [anon_sym_GT_EQ] = ACTIONS(5499),
    [anon_sym_EQ_EQ] = ACTIONS(5499),
    [anon_sym_BANG_EQ] = ACTIONS(5499),
    [anon_sym_STAR] = ACTIONS(5501),
    [anon_sym_SLASH] = ACTIONS(5503),
    [anon_sym_STAR_STAR] = ACTIONS(5505),
    [anon_sym_CARET] = ACTIONS(5505),
    [aux_sym_binary_operator_token1] = ACTIONS(5507),
    [anon_sym_PIPE_GT] = ACTIONS(5507),
    [anon_sym_COLON] = ACTIONS(5509),
    [anon_sym_DOLLAR] = ACTIONS(5511),
    [anon_sym_AT] = ACTIONS(5511),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5513),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5515),
    [sym__external_open_bracket2] = ACTIONS(5517),
  },
  [854] = {
    [sym_call_arguments] = STATE(2509),
    [sym_subset_arguments] = STATE(2507),
    [sym_subset2_arguments] = STATE(2505),
    [sym__open_parenthesis] = STATE(1590),
    [sym__open_bracket] = STATE(1589),
    [sym__open_bracket2] = STATE(1588),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5501),
    [anon_sym_SLASH] = ACTIONS(5503),
    [anon_sym_STAR_STAR] = ACTIONS(5505),
    [anon_sym_CARET] = ACTIONS(5505),
    [aux_sym_binary_operator_token1] = ACTIONS(5507),
    [anon_sym_PIPE_GT] = ACTIONS(5507),
    [anon_sym_COLON] = ACTIONS(5509),
    [anon_sym_DOLLAR] = ACTIONS(5511),
    [anon_sym_AT] = ACTIONS(5511),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5513),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5515),
    [sym__external_open_bracket2] = ACTIONS(5517),
  },
  [855] = {
    [sym_call_arguments] = STATE(2509),
    [sym_subset_arguments] = STATE(2507),
    [sym_subset2_arguments] = STATE(2505),
    [sym__open_parenthesis] = STATE(1590),
    [sym__open_bracket] = STATE(1589),
    [sym__open_bracket2] = STATE(1588),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5479),
    [anon_sym_DASH] = ACTIONS(5481),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5489),
    [anon_sym_AMP] = ACTIONS(5491),
    [anon_sym_PIPE_PIPE] = ACTIONS(5493),
    [anon_sym_AMP_AMP] = ACTIONS(5495),
    [anon_sym_LT] = ACTIONS(5497),
    [anon_sym_LT_EQ] = ACTIONS(5499),
    [anon_sym_GT] = ACTIONS(5497),
    [anon_sym_GT_EQ] = ACTIONS(5499),
    [anon_sym_EQ_EQ] = ACTIONS(5499),
    [anon_sym_BANG_EQ] = ACTIONS(5499),
    [anon_sym_STAR] = ACTIONS(5501),
    [anon_sym_SLASH] = ACTIONS(5503),
    [anon_sym_STAR_STAR] = ACTIONS(5505),
    [anon_sym_CARET] = ACTIONS(5505),
    [aux_sym_binary_operator_token1] = ACTIONS(5507),
    [anon_sym_PIPE_GT] = ACTIONS(5507),
    [anon_sym_COLON] = ACTIONS(5509),
    [anon_sym_DOLLAR] = ACTIONS(5511),
    [anon_sym_AT] = ACTIONS(5511),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5513),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5515),
    [sym__external_open_bracket2] = ACTIONS(5517),
  },
  [856] = {
    [sym_call_arguments] = STATE(2595),
    [sym_subset_arguments] = STATE(2594),
    [sym_subset2_arguments] = STATE(2592),
    [sym__else] = STATE(4233),
    [sym__open_parenthesis] = STATE(1423),
    [sym__open_bracket] = STATE(1419),
    [sym__open_bracket2] = STATE(1415),
    [ts_builtin_sym_end] = ACTIONS(5067),
    [sym_identifier] = ACTIONS(5065),
    [anon_sym_BSLASH] = ACTIONS(5067),
    [anon_sym_function] = ACTIONS(5065),
    [anon_sym_EQ] = ACTIONS(5727),
    [anon_sym_if] = ACTIONS(5065),
    [anon_sym_for] = ACTIONS(5065),
    [anon_sym_while] = ACTIONS(5065),
    [anon_sym_repeat] = ACTIONS(5065),
    [anon_sym_QMARK] = ACTIONS(5067),
    [anon_sym_TILDE] = ACTIONS(5729),
    [anon_sym_BANG] = ACTIONS(5065),
    [anon_sym_PLUS] = ACTIONS(5731),
    [anon_sym_DASH] = ACTIONS(5733),
    [anon_sym_LT_DASH] = ACTIONS(5735),
    [anon_sym_LT_LT_DASH] = ACTIONS(5735),
    [anon_sym_COLON_EQ] = ACTIONS(5735),
    [anon_sym_DASH_GT] = ACTIONS(5737),
    [anon_sym_DASH_GT_GT] = ACTIONS(5739),
    [anon_sym_PIPE] = ACTIONS(5741),
    [anon_sym_AMP] = ACTIONS(5743),
    [anon_sym_PIPE_PIPE] = ACTIONS(5745),
    [anon_sym_AMP_AMP] = ACTIONS(5747),
    [anon_sym_LT] = ACTIONS(5749),
    [anon_sym_LT_EQ] = ACTIONS(5751),
    [anon_sym_GT] = ACTIONS(5749),
    [anon_sym_GT_EQ] = ACTIONS(5751),
    [anon_sym_EQ_EQ] = ACTIONS(5751),
    [anon_sym_BANG_EQ] = ACTIONS(5751),
    [anon_sym_STAR] = ACTIONS(5753),
    [anon_sym_SLASH] = ACTIONS(5755),
    [anon_sym_STAR_STAR] = ACTIONS(5757),
    [anon_sym_CARET] = ACTIONS(5757),
    [aux_sym_binary_operator_token1] = ACTIONS(5759),
    [anon_sym_PIPE_GT] = ACTIONS(5759),
    [anon_sym_COLON] = ACTIONS(5761),
    [anon_sym_DOLLAR] = ACTIONS(5763),
    [anon_sym_AT] = ACTIONS(5763),
    [aux_sym__hex_literal_token1] = ACTIONS(5067),
    [sym__number_literal] = ACTIONS(5065),
    [anon_sym_SQUOTE] = ACTIONS(5067),
    [anon_sym_DQUOTE] = ACTIONS(5067),
    [sym_return] = ACTIONS(5065),
    [sym_next] = ACTIONS(5065),
    [sym_break] = ACTIONS(5065),
    [sym_true] = ACTIONS(5065),
    [sym_false] = ACTIONS(5065),
    [sym_null] = ACTIONS(5065),
    [sym_inf] = ACTIONS(5065),
    [sym_nan] = ACTIONS(5065),
    [anon_sym_NA] = ACTIONS(5065),
    [anon_sym_NA_integer_] = ACTIONS(5065),
    [anon_sym_NA_real_] = ACTIONS(5065),
    [anon_sym_NA_complex_] = ACTIONS(5065),
    [anon_sym_NA_character_] = ACTIONS(5065),
    [sym_dots] = ACTIONS(5065),
    [sym_dot_dot_i] = ACTIONS(5067),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5067),
    [sym__semicolon] = ACTIONS(5067),
    [sym__raw_string_literal] = ACTIONS(5067),
    [sym__external_else] = ACTIONS(5853),
    [sym__external_open_parenthesis] = ACTIONS(5767),
    [sym__external_open_brace] = ACTIONS(5067),
    [sym__external_close_brace] = ACTIONS(5067),
    [sym__external_open_bracket] = ACTIONS(5769),
    [sym__external_open_bracket2] = ACTIONS(5771),
  },
  [857] = {
    [sym_call_arguments] = STATE(2509),
    [sym_subset_arguments] = STATE(2507),
    [sym_subset2_arguments] = STATE(2505),
    [sym__open_parenthesis] = STATE(1590),
    [sym__open_bracket] = STATE(1589),
    [sym__open_bracket2] = STATE(1588),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5475),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5477),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5479),
    [anon_sym_DASH] = ACTIONS(5481),
    [anon_sym_LT_DASH] = ACTIONS(5483),
    [anon_sym_LT_LT_DASH] = ACTIONS(5483),
    [anon_sym_COLON_EQ] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5485),
    [anon_sym_DASH_GT_GT] = ACTIONS(5487),
    [anon_sym_PIPE] = ACTIONS(5489),
    [anon_sym_AMP] = ACTIONS(5491),
    [anon_sym_PIPE_PIPE] = ACTIONS(5493),
    [anon_sym_AMP_AMP] = ACTIONS(5495),
    [anon_sym_LT] = ACTIONS(5497),
    [anon_sym_LT_EQ] = ACTIONS(5499),
    [anon_sym_GT] = ACTIONS(5497),
    [anon_sym_GT_EQ] = ACTIONS(5499),
    [anon_sym_EQ_EQ] = ACTIONS(5499),
    [anon_sym_BANG_EQ] = ACTIONS(5499),
    [anon_sym_STAR] = ACTIONS(5501),
    [anon_sym_SLASH] = ACTIONS(5503),
    [anon_sym_STAR_STAR] = ACTIONS(5505),
    [anon_sym_CARET] = ACTIONS(5505),
    [aux_sym_binary_operator_token1] = ACTIONS(5507),
    [anon_sym_PIPE_GT] = ACTIONS(5507),
    [anon_sym_COLON] = ACTIONS(5509),
    [anon_sym_DOLLAR] = ACTIONS(5511),
    [anon_sym_AT] = ACTIONS(5511),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5513),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5515),
    [sym__external_open_bracket2] = ACTIONS(5517),
  },
  [858] = {
    [sym_call_arguments] = STATE(2509),
    [sym_subset_arguments] = STATE(2507),
    [sym_subset2_arguments] = STATE(2505),
    [sym__open_parenthesis] = STATE(1590),
    [sym__open_bracket] = STATE(1589),
    [sym__open_bracket2] = STATE(1588),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5475),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5477),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5479),
    [anon_sym_DASH] = ACTIONS(5481),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5485),
    [anon_sym_DASH_GT_GT] = ACTIONS(5487),
    [anon_sym_PIPE] = ACTIONS(5489),
    [anon_sym_AMP] = ACTIONS(5491),
    [anon_sym_PIPE_PIPE] = ACTIONS(5493),
    [anon_sym_AMP_AMP] = ACTIONS(5495),
    [anon_sym_LT] = ACTIONS(5497),
    [anon_sym_LT_EQ] = ACTIONS(5499),
    [anon_sym_GT] = ACTIONS(5497),
    [anon_sym_GT_EQ] = ACTIONS(5499),
    [anon_sym_EQ_EQ] = ACTIONS(5499),
    [anon_sym_BANG_EQ] = ACTIONS(5499),
    [anon_sym_STAR] = ACTIONS(5501),
    [anon_sym_SLASH] = ACTIONS(5503),
    [anon_sym_STAR_STAR] = ACTIONS(5505),
    [anon_sym_CARET] = ACTIONS(5505),
    [aux_sym_binary_operator_token1] = ACTIONS(5507),
    [anon_sym_PIPE_GT] = ACTIONS(5507),
    [anon_sym_COLON] = ACTIONS(5509),
    [anon_sym_DOLLAR] = ACTIONS(5511),
    [anon_sym_AT] = ACTIONS(5511),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5513),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5515),
    [sym__external_open_bracket2] = ACTIONS(5517),
  },
  [859] = {
    [sym_call_arguments] = STATE(2595),
    [sym_subset_arguments] = STATE(2594),
    [sym_subset2_arguments] = STATE(2592),
    [sym__else] = STATE(4226),
    [sym__open_parenthesis] = STATE(1423),
    [sym__open_bracket] = STATE(1419),
    [sym__open_bracket2] = STATE(1415),
    [ts_builtin_sym_end] = ACTIONS(5117),
    [sym_identifier] = ACTIONS(5115),
    [anon_sym_BSLASH] = ACTIONS(5117),
    [anon_sym_function] = ACTIONS(5115),
    [anon_sym_EQ] = ACTIONS(5727),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_for] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_repeat] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(5117),
    [anon_sym_TILDE] = ACTIONS(5729),
    [anon_sym_BANG] = ACTIONS(5115),
    [anon_sym_PLUS] = ACTIONS(5731),
    [anon_sym_DASH] = ACTIONS(5733),
    [anon_sym_LT_DASH] = ACTIONS(5735),
    [anon_sym_LT_LT_DASH] = ACTIONS(5735),
    [anon_sym_COLON_EQ] = ACTIONS(5735),
    [anon_sym_DASH_GT] = ACTIONS(5737),
    [anon_sym_DASH_GT_GT] = ACTIONS(5739),
    [anon_sym_PIPE] = ACTIONS(5741),
    [anon_sym_AMP] = ACTIONS(5743),
    [anon_sym_PIPE_PIPE] = ACTIONS(5745),
    [anon_sym_AMP_AMP] = ACTIONS(5747),
    [anon_sym_LT] = ACTIONS(5749),
    [anon_sym_LT_EQ] = ACTIONS(5751),
    [anon_sym_GT] = ACTIONS(5749),
    [anon_sym_GT_EQ] = ACTIONS(5751),
    [anon_sym_EQ_EQ] = ACTIONS(5751),
    [anon_sym_BANG_EQ] = ACTIONS(5751),
    [anon_sym_STAR] = ACTIONS(5753),
    [anon_sym_SLASH] = ACTIONS(5755),
    [anon_sym_STAR_STAR] = ACTIONS(5757),
    [anon_sym_CARET] = ACTIONS(5757),
    [aux_sym_binary_operator_token1] = ACTIONS(5759),
    [anon_sym_PIPE_GT] = ACTIONS(5759),
    [anon_sym_COLON] = ACTIONS(5761),
    [anon_sym_DOLLAR] = ACTIONS(5763),
    [anon_sym_AT] = ACTIONS(5763),
    [aux_sym__hex_literal_token1] = ACTIONS(5117),
    [sym__number_literal] = ACTIONS(5115),
    [anon_sym_SQUOTE] = ACTIONS(5117),
    [anon_sym_DQUOTE] = ACTIONS(5117),
    [sym_return] = ACTIONS(5115),
    [sym_next] = ACTIONS(5115),
    [sym_break] = ACTIONS(5115),
    [sym_true] = ACTIONS(5115),
    [sym_false] = ACTIONS(5115),
    [sym_null] = ACTIONS(5115),
    [sym_inf] = ACTIONS(5115),
    [sym_nan] = ACTIONS(5115),
    [anon_sym_NA] = ACTIONS(5115),
    [anon_sym_NA_integer_] = ACTIONS(5115),
    [anon_sym_NA_real_] = ACTIONS(5115),
    [anon_sym_NA_complex_] = ACTIONS(5115),
    [anon_sym_NA_character_] = ACTIONS(5115),
    [sym_dots] = ACTIONS(5115),
    [sym_dot_dot_i] = ACTIONS(5117),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5117),
    [sym__semicolon] = ACTIONS(5117),
    [sym__raw_string_literal] = ACTIONS(5117),
    [sym__external_else] = ACTIONS(5855),
    [sym__external_open_parenthesis] = ACTIONS(5767),
    [sym__external_open_brace] = ACTIONS(5117),
    [sym__external_close_brace] = ACTIONS(5117),
    [sym__external_open_bracket] = ACTIONS(5769),
    [sym__external_open_bracket2] = ACTIONS(5771),
  },
  [860] = {
    [sym_call_arguments] = STATE(2595),
    [sym_subset_arguments] = STATE(2594),
    [sym_subset2_arguments] = STATE(2592),
    [sym__else] = STATE(4223),
    [sym__open_parenthesis] = STATE(1423),
    [sym__open_bracket] = STATE(1419),
    [sym__open_bracket2] = STATE(1415),
    [ts_builtin_sym_end] = ACTIONS(5167),
    [sym_identifier] = ACTIONS(5169),
    [anon_sym_BSLASH] = ACTIONS(5167),
    [anon_sym_function] = ACTIONS(5169),
    [anon_sym_EQ] = ACTIONS(5727),
    [anon_sym_if] = ACTIONS(5169),
    [anon_sym_for] = ACTIONS(5169),
    [anon_sym_while] = ACTIONS(5169),
    [anon_sym_repeat] = ACTIONS(5169),
    [anon_sym_QMARK] = ACTIONS(5167),
    [anon_sym_TILDE] = ACTIONS(5729),
    [anon_sym_BANG] = ACTIONS(5169),
    [anon_sym_PLUS] = ACTIONS(5731),
    [anon_sym_DASH] = ACTIONS(5733),
    [anon_sym_LT_DASH] = ACTIONS(5735),
    [anon_sym_LT_LT_DASH] = ACTIONS(5735),
    [anon_sym_COLON_EQ] = ACTIONS(5735),
    [anon_sym_DASH_GT] = ACTIONS(5737),
    [anon_sym_DASH_GT_GT] = ACTIONS(5739),
    [anon_sym_PIPE] = ACTIONS(5741),
    [anon_sym_AMP] = ACTIONS(5743),
    [anon_sym_PIPE_PIPE] = ACTIONS(5745),
    [anon_sym_AMP_AMP] = ACTIONS(5747),
    [anon_sym_LT] = ACTIONS(5749),
    [anon_sym_LT_EQ] = ACTIONS(5751),
    [anon_sym_GT] = ACTIONS(5749),
    [anon_sym_GT_EQ] = ACTIONS(5751),
    [anon_sym_EQ_EQ] = ACTIONS(5751),
    [anon_sym_BANG_EQ] = ACTIONS(5751),
    [anon_sym_STAR] = ACTIONS(5753),
    [anon_sym_SLASH] = ACTIONS(5755),
    [anon_sym_STAR_STAR] = ACTIONS(5757),
    [anon_sym_CARET] = ACTIONS(5757),
    [aux_sym_binary_operator_token1] = ACTIONS(5759),
    [anon_sym_PIPE_GT] = ACTIONS(5759),
    [anon_sym_COLON] = ACTIONS(5761),
    [anon_sym_DOLLAR] = ACTIONS(5763),
    [anon_sym_AT] = ACTIONS(5763),
    [aux_sym__hex_literal_token1] = ACTIONS(5167),
    [sym__number_literal] = ACTIONS(5169),
    [anon_sym_SQUOTE] = ACTIONS(5167),
    [anon_sym_DQUOTE] = ACTIONS(5167),
    [sym_return] = ACTIONS(5169),
    [sym_next] = ACTIONS(5169),
    [sym_break] = ACTIONS(5169),
    [sym_true] = ACTIONS(5169),
    [sym_false] = ACTIONS(5169),
    [sym_null] = ACTIONS(5169),
    [sym_inf] = ACTIONS(5169),
    [sym_nan] = ACTIONS(5169),
    [anon_sym_NA] = ACTIONS(5169),
    [anon_sym_NA_integer_] = ACTIONS(5169),
    [anon_sym_NA_real_] = ACTIONS(5169),
    [anon_sym_NA_complex_] = ACTIONS(5169),
    [anon_sym_NA_character_] = ACTIONS(5169),
    [sym_dots] = ACTIONS(5169),
    [sym_dot_dot_i] = ACTIONS(5167),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5167),
    [sym__semicolon] = ACTIONS(5167),
    [sym__raw_string_literal] = ACTIONS(5167),
    [sym__external_else] = ACTIONS(5857),
    [sym__external_open_parenthesis] = ACTIONS(5767),
    [sym__external_open_brace] = ACTIONS(5167),
    [sym__external_close_brace] = ACTIONS(5167),
    [sym__external_open_bracket] = ACTIONS(5769),
    [sym__external_open_bracket2] = ACTIONS(5771),
  },
  [861] = {
    [sym_call_arguments] = STATE(2438),
    [sym_subset_arguments] = STATE(2439),
    [sym_subset2_arguments] = STATE(2440),
    [sym__open_parenthesis] = STATE(1350),
    [sym__open_bracket] = STATE(1348),
    [sym__open_bracket2] = STATE(1346),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5353),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5355),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5357),
    [anon_sym_DASH] = ACTIONS(5359),
    [anon_sym_LT_DASH] = ACTIONS(5361),
    [anon_sym_LT_LT_DASH] = ACTIONS(5361),
    [anon_sym_COLON_EQ] = ACTIONS(5361),
    [anon_sym_DASH_GT] = ACTIONS(5363),
    [anon_sym_DASH_GT_GT] = ACTIONS(5365),
    [anon_sym_PIPE] = ACTIONS(5367),
    [anon_sym_AMP] = ACTIONS(5369),
    [anon_sym_PIPE_PIPE] = ACTIONS(5371),
    [anon_sym_AMP_AMP] = ACTIONS(5373),
    [anon_sym_LT] = ACTIONS(5375),
    [anon_sym_LT_EQ] = ACTIONS(5377),
    [anon_sym_GT] = ACTIONS(5375),
    [anon_sym_GT_EQ] = ACTIONS(5377),
    [anon_sym_EQ_EQ] = ACTIONS(5377),
    [anon_sym_BANG_EQ] = ACTIONS(5377),
    [anon_sym_STAR] = ACTIONS(5379),
    [anon_sym_SLASH] = ACTIONS(5381),
    [anon_sym_STAR_STAR] = ACTIONS(5383),
    [anon_sym_CARET] = ACTIONS(5383),
    [aux_sym_binary_operator_token1] = ACTIONS(5385),
    [anon_sym_PIPE_GT] = ACTIONS(5385),
    [anon_sym_COLON] = ACTIONS(5387),
    [anon_sym_DOLLAR] = ACTIONS(5389),
    [anon_sym_AT] = ACTIONS(5389),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5393),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5395),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(5397),
  },
  [862] = {
    [sym_call_arguments] = STATE(2438),
    [sym_subset_arguments] = STATE(2439),
    [sym_subset2_arguments] = STATE(2440),
    [sym__open_parenthesis] = STATE(1350),
    [sym__open_bracket] = STATE(1348),
    [sym__open_bracket2] = STATE(1346),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5355),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5357),
    [anon_sym_DASH] = ACTIONS(5359),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5367),
    [anon_sym_AMP] = ACTIONS(5369),
    [anon_sym_PIPE_PIPE] = ACTIONS(5371),
    [anon_sym_AMP_AMP] = ACTIONS(5373),
    [anon_sym_LT] = ACTIONS(5375),
    [anon_sym_LT_EQ] = ACTIONS(5377),
    [anon_sym_GT] = ACTIONS(5375),
    [anon_sym_GT_EQ] = ACTIONS(5377),
    [anon_sym_EQ_EQ] = ACTIONS(5377),
    [anon_sym_BANG_EQ] = ACTIONS(5377),
    [anon_sym_STAR] = ACTIONS(5379),
    [anon_sym_SLASH] = ACTIONS(5381),
    [anon_sym_STAR_STAR] = ACTIONS(5383),
    [anon_sym_CARET] = ACTIONS(5383),
    [aux_sym_binary_operator_token1] = ACTIONS(5385),
    [anon_sym_PIPE_GT] = ACTIONS(5385),
    [anon_sym_COLON] = ACTIONS(5387),
    [anon_sym_DOLLAR] = ACTIONS(5389),
    [anon_sym_AT] = ACTIONS(5389),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5393),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5395),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(5397),
  },
  [863] = {
    [sym_call_arguments] = STATE(2509),
    [sym_subset_arguments] = STATE(2507),
    [sym_subset2_arguments] = STATE(2505),
    [sym__open_parenthesis] = STATE(1590),
    [sym__open_bracket] = STATE(1589),
    [sym__open_bracket2] = STATE(1588),
    [ts_builtin_sym_end] = ACTIONS(5399),
    [sym_identifier] = ACTIONS(5401),
    [anon_sym_BSLASH] = ACTIONS(5399),
    [anon_sym_function] = ACTIONS(5401),
    [anon_sym_EQ] = ACTIONS(5475),
    [anon_sym_if] = ACTIONS(5401),
    [anon_sym_for] = ACTIONS(5401),
    [anon_sym_while] = ACTIONS(5401),
    [anon_sym_repeat] = ACTIONS(5401),
    [anon_sym_QMARK] = ACTIONS(5399),
    [anon_sym_TILDE] = ACTIONS(5477),
    [anon_sym_BANG] = ACTIONS(5401),
    [anon_sym_PLUS] = ACTIONS(5479),
    [anon_sym_DASH] = ACTIONS(5481),
    [anon_sym_LT_DASH] = ACTIONS(5483),
    [anon_sym_LT_LT_DASH] = ACTIONS(5483),
    [anon_sym_COLON_EQ] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5485),
    [anon_sym_DASH_GT_GT] = ACTIONS(5487),
    [anon_sym_PIPE] = ACTIONS(5489),
    [anon_sym_AMP] = ACTIONS(5491),
    [anon_sym_PIPE_PIPE] = ACTIONS(5493),
    [anon_sym_AMP_AMP] = ACTIONS(5495),
    [anon_sym_LT] = ACTIONS(5497),
    [anon_sym_LT_EQ] = ACTIONS(5499),
    [anon_sym_GT] = ACTIONS(5497),
    [anon_sym_GT_EQ] = ACTIONS(5499),
    [anon_sym_EQ_EQ] = ACTIONS(5499),
    [anon_sym_BANG_EQ] = ACTIONS(5499),
    [anon_sym_STAR] = ACTIONS(5501),
    [anon_sym_SLASH] = ACTIONS(5503),
    [anon_sym_STAR_STAR] = ACTIONS(5505),
    [anon_sym_CARET] = ACTIONS(5505),
    [aux_sym_binary_operator_token1] = ACTIONS(5507),
    [anon_sym_PIPE_GT] = ACTIONS(5507),
    [anon_sym_COLON] = ACTIONS(5509),
    [anon_sym_DOLLAR] = ACTIONS(5511),
    [anon_sym_AT] = ACTIONS(5511),
    [aux_sym__hex_literal_token1] = ACTIONS(5399),
    [sym__number_literal] = ACTIONS(5401),
    [anon_sym_SQUOTE] = ACTIONS(5399),
    [anon_sym_DQUOTE] = ACTIONS(5399),
    [sym_return] = ACTIONS(5401),
    [sym_next] = ACTIONS(5401),
    [sym_break] = ACTIONS(5401),
    [sym_true] = ACTIONS(5401),
    [sym_false] = ACTIONS(5401),
    [sym_null] = ACTIONS(5401),
    [sym_inf] = ACTIONS(5401),
    [sym_nan] = ACTIONS(5401),
    [anon_sym_NA] = ACTIONS(5401),
    [anon_sym_NA_integer_] = ACTIONS(5401),
    [anon_sym_NA_real_] = ACTIONS(5401),
    [anon_sym_NA_complex_] = ACTIONS(5401),
    [anon_sym_NA_character_] = ACTIONS(5401),
    [sym_dots] = ACTIONS(5401),
    [sym_dot_dot_i] = ACTIONS(5399),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5399),
    [sym__newline] = ACTIONS(5399),
    [sym__semicolon] = ACTIONS(5399),
    [sym__raw_string_literal] = ACTIONS(5399),
    [sym__external_open_parenthesis] = ACTIONS(5513),
    [sym__external_close_parenthesis] = ACTIONS(5399),
    [sym__external_open_brace] = ACTIONS(5399),
    [sym__external_close_brace] = ACTIONS(5399),
    [sym__external_open_bracket] = ACTIONS(5515),
    [sym__external_open_bracket2] = ACTIONS(5517),
  },
  [864] = {
    [sym_call_arguments] = STATE(2595),
    [sym_subset_arguments] = STATE(2594),
    [sym_subset2_arguments] = STATE(2592),
    [sym__else] = STATE(4265),
    [sym__open_parenthesis] = STATE(1423),
    [sym__open_bracket] = STATE(1419),
    [sym__open_bracket2] = STATE(1415),
    [ts_builtin_sym_end] = ACTIONS(5227),
    [sym_identifier] = ACTIONS(5225),
    [anon_sym_BSLASH] = ACTIONS(5227),
    [anon_sym_function] = ACTIONS(5225),
    [anon_sym_EQ] = ACTIONS(5727),
    [anon_sym_if] = ACTIONS(5225),
    [anon_sym_for] = ACTIONS(5225),
    [anon_sym_while] = ACTIONS(5225),
    [anon_sym_repeat] = ACTIONS(5225),
    [anon_sym_QMARK] = ACTIONS(5227),
    [anon_sym_TILDE] = ACTIONS(5729),
    [anon_sym_BANG] = ACTIONS(5225),
    [anon_sym_PLUS] = ACTIONS(5731),
    [anon_sym_DASH] = ACTIONS(5733),
    [anon_sym_LT_DASH] = ACTIONS(5735),
    [anon_sym_LT_LT_DASH] = ACTIONS(5735),
    [anon_sym_COLON_EQ] = ACTIONS(5735),
    [anon_sym_DASH_GT] = ACTIONS(5737),
    [anon_sym_DASH_GT_GT] = ACTIONS(5739),
    [anon_sym_PIPE] = ACTIONS(5741),
    [anon_sym_AMP] = ACTIONS(5743),
    [anon_sym_PIPE_PIPE] = ACTIONS(5745),
    [anon_sym_AMP_AMP] = ACTIONS(5747),
    [anon_sym_LT] = ACTIONS(5749),
    [anon_sym_LT_EQ] = ACTIONS(5751),
    [anon_sym_GT] = ACTIONS(5749),
    [anon_sym_GT_EQ] = ACTIONS(5751),
    [anon_sym_EQ_EQ] = ACTIONS(5751),
    [anon_sym_BANG_EQ] = ACTIONS(5751),
    [anon_sym_STAR] = ACTIONS(5753),
    [anon_sym_SLASH] = ACTIONS(5755),
    [anon_sym_STAR_STAR] = ACTIONS(5757),
    [anon_sym_CARET] = ACTIONS(5757),
    [aux_sym_binary_operator_token1] = ACTIONS(5759),
    [anon_sym_PIPE_GT] = ACTIONS(5759),
    [anon_sym_COLON] = ACTIONS(5761),
    [anon_sym_DOLLAR] = ACTIONS(5763),
    [anon_sym_AT] = ACTIONS(5763),
    [aux_sym__hex_literal_token1] = ACTIONS(5227),
    [sym__number_literal] = ACTIONS(5225),
    [anon_sym_SQUOTE] = ACTIONS(5227),
    [anon_sym_DQUOTE] = ACTIONS(5227),
    [sym_return] = ACTIONS(5225),
    [sym_next] = ACTIONS(5225),
    [sym_break] = ACTIONS(5225),
    [sym_true] = ACTIONS(5225),
    [sym_false] = ACTIONS(5225),
    [sym_null] = ACTIONS(5225),
    [sym_inf] = ACTIONS(5225),
    [sym_nan] = ACTIONS(5225),
    [anon_sym_NA] = ACTIONS(5225),
    [anon_sym_NA_integer_] = ACTIONS(5225),
    [anon_sym_NA_real_] = ACTIONS(5225),
    [anon_sym_NA_complex_] = ACTIONS(5225),
    [anon_sym_NA_character_] = ACTIONS(5225),
    [sym_dots] = ACTIONS(5225),
    [sym_dot_dot_i] = ACTIONS(5227),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5227),
    [sym__semicolon] = ACTIONS(5227),
    [sym__raw_string_literal] = ACTIONS(5227),
    [sym__external_else] = ACTIONS(5859),
    [sym__external_open_parenthesis] = ACTIONS(5767),
    [sym__external_open_brace] = ACTIONS(5227),
    [sym__external_close_brace] = ACTIONS(5227),
    [sym__external_open_bracket] = ACTIONS(5769),
    [sym__external_open_bracket2] = ACTIONS(5771),
  },
  [865] = {
    [sym_call_arguments] = STATE(2438),
    [sym_subset_arguments] = STATE(2439),
    [sym_subset2_arguments] = STATE(2440),
    [sym__open_parenthesis] = STATE(1350),
    [sym__open_bracket] = STATE(1348),
    [sym__open_bracket2] = STATE(1346),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5357),
    [anon_sym_DASH] = ACTIONS(5359),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5369),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5373),
    [anon_sym_LT] = ACTIONS(5375),
    [anon_sym_LT_EQ] = ACTIONS(5377),
    [anon_sym_GT] = ACTIONS(5375),
    [anon_sym_GT_EQ] = ACTIONS(5377),
    [anon_sym_EQ_EQ] = ACTIONS(5377),
    [anon_sym_BANG_EQ] = ACTIONS(5377),
    [anon_sym_STAR] = ACTIONS(5379),
    [anon_sym_SLASH] = ACTIONS(5381),
    [anon_sym_STAR_STAR] = ACTIONS(5383),
    [anon_sym_CARET] = ACTIONS(5383),
    [aux_sym_binary_operator_token1] = ACTIONS(5385),
    [anon_sym_PIPE_GT] = ACTIONS(5385),
    [anon_sym_COLON] = ACTIONS(5387),
    [anon_sym_DOLLAR] = ACTIONS(5389),
    [anon_sym_AT] = ACTIONS(5389),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5393),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5395),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(5397),
  },
  [866] = {
    [sym_call_arguments] = STATE(2438),
    [sym_subset_arguments] = STATE(2439),
    [sym_subset2_arguments] = STATE(2440),
    [sym__open_parenthesis] = STATE(1350),
    [sym__open_bracket] = STATE(1348),
    [sym__open_bracket2] = STATE(1346),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5357),
    [anon_sym_DASH] = ACTIONS(5359),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5375),
    [anon_sym_LT_EQ] = ACTIONS(5377),
    [anon_sym_GT] = ACTIONS(5375),
    [anon_sym_GT_EQ] = ACTIONS(5377),
    [anon_sym_EQ_EQ] = ACTIONS(5377),
    [anon_sym_BANG_EQ] = ACTIONS(5377),
    [anon_sym_STAR] = ACTIONS(5379),
    [anon_sym_SLASH] = ACTIONS(5381),
    [anon_sym_STAR_STAR] = ACTIONS(5383),
    [anon_sym_CARET] = ACTIONS(5383),
    [aux_sym_binary_operator_token1] = ACTIONS(5385),
    [anon_sym_PIPE_GT] = ACTIONS(5385),
    [anon_sym_COLON] = ACTIONS(5387),
    [anon_sym_DOLLAR] = ACTIONS(5389),
    [anon_sym_AT] = ACTIONS(5389),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5393),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5395),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(5397),
  },
  [867] = {
    [sym_call_arguments] = STATE(2438),
    [sym_subset_arguments] = STATE(2439),
    [sym_subset2_arguments] = STATE(2440),
    [sym__open_parenthesis] = STATE(1350),
    [sym__open_bracket] = STATE(1348),
    [sym__open_bracket2] = STATE(1346),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5357),
    [anon_sym_DASH] = ACTIONS(5359),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5379),
    [anon_sym_SLASH] = ACTIONS(5381),
    [anon_sym_STAR_STAR] = ACTIONS(5383),
    [anon_sym_CARET] = ACTIONS(5383),
    [aux_sym_binary_operator_token1] = ACTIONS(5385),
    [anon_sym_PIPE_GT] = ACTIONS(5385),
    [anon_sym_COLON] = ACTIONS(5387),
    [anon_sym_DOLLAR] = ACTIONS(5389),
    [anon_sym_AT] = ACTIONS(5389),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5393),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5395),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(5397),
  },
  [868] = {
    [sym_call_arguments] = STATE(2438),
    [sym_subset_arguments] = STATE(2439),
    [sym_subset2_arguments] = STATE(2440),
    [sym__open_parenthesis] = STATE(1350),
    [sym__open_bracket] = STATE(1348),
    [sym__open_bracket2] = STATE(1346),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(5383),
    [anon_sym_CARET] = ACTIONS(5383),
    [aux_sym_binary_operator_token1] = ACTIONS(5385),
    [anon_sym_PIPE_GT] = ACTIONS(5385),
    [anon_sym_COLON] = ACTIONS(5387),
    [anon_sym_DOLLAR] = ACTIONS(5389),
    [anon_sym_AT] = ACTIONS(5389),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5393),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5395),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(5397),
  },
  [869] = {
    [sym_call_arguments] = STATE(2438),
    [sym_subset_arguments] = STATE(2439),
    [sym_subset2_arguments] = STATE(2440),
    [sym__open_parenthesis] = STATE(1350),
    [sym__open_bracket] = STATE(1348),
    [sym__open_bracket2] = STATE(1346),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(5383),
    [anon_sym_CARET] = ACTIONS(5383),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(5261),
    [anon_sym_DOLLAR] = ACTIONS(5389),
    [anon_sym_AT] = ACTIONS(5389),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5393),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5395),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(5397),
  },
  [870] = {
    [sym_call_arguments] = STATE(2678),
    [sym_subset_arguments] = STATE(2679),
    [sym_subset2_arguments] = STATE(2683),
    [sym__else] = STATE(4167),
    [sym__open_parenthesis] = STATE(1443),
    [sym__open_bracket] = STATE(1442),
    [sym__open_bracket2] = STATE(1425),
    [ts_builtin_sym_end] = ACTIONS(5067),
    [sym_identifier] = ACTIONS(5065),
    [anon_sym_BSLASH] = ACTIONS(5067),
    [anon_sym_function] = ACTIONS(5065),
    [anon_sym_EQ] = ACTIONS(5609),
    [anon_sym_if] = ACTIONS(5065),
    [anon_sym_for] = ACTIONS(5065),
    [anon_sym_while] = ACTIONS(5065),
    [anon_sym_repeat] = ACTIONS(5065),
    [anon_sym_QMARK] = ACTIONS(5067),
    [anon_sym_TILDE] = ACTIONS(5611),
    [anon_sym_BANG] = ACTIONS(5065),
    [anon_sym_PLUS] = ACTIONS(5613),
    [anon_sym_DASH] = ACTIONS(5615),
    [anon_sym_LT_DASH] = ACTIONS(5617),
    [anon_sym_LT_LT_DASH] = ACTIONS(5617),
    [anon_sym_COLON_EQ] = ACTIONS(5617),
    [anon_sym_DASH_GT] = ACTIONS(5619),
    [anon_sym_DASH_GT_GT] = ACTIONS(5621),
    [anon_sym_PIPE] = ACTIONS(5623),
    [anon_sym_AMP] = ACTIONS(5625),
    [anon_sym_PIPE_PIPE] = ACTIONS(5627),
    [anon_sym_AMP_AMP] = ACTIONS(5629),
    [anon_sym_LT] = ACTIONS(5631),
    [anon_sym_LT_EQ] = ACTIONS(5633),
    [anon_sym_GT] = ACTIONS(5631),
    [anon_sym_GT_EQ] = ACTIONS(5633),
    [anon_sym_EQ_EQ] = ACTIONS(5633),
    [anon_sym_BANG_EQ] = ACTIONS(5633),
    [anon_sym_STAR] = ACTIONS(5635),
    [anon_sym_SLASH] = ACTIONS(5637),
    [anon_sym_STAR_STAR] = ACTIONS(5639),
    [anon_sym_CARET] = ACTIONS(5639),
    [aux_sym_binary_operator_token1] = ACTIONS(5641),
    [anon_sym_PIPE_GT] = ACTIONS(5641),
    [anon_sym_COLON] = ACTIONS(5643),
    [anon_sym_DOLLAR] = ACTIONS(5645),
    [anon_sym_AT] = ACTIONS(5645),
    [aux_sym__hex_literal_token1] = ACTIONS(5067),
    [sym__number_literal] = ACTIONS(5065),
    [anon_sym_SQUOTE] = ACTIONS(5067),
    [anon_sym_DQUOTE] = ACTIONS(5067),
    [sym_return] = ACTIONS(5065),
    [sym_next] = ACTIONS(5065),
    [sym_break] = ACTIONS(5065),
    [sym_true] = ACTIONS(5065),
    [sym_false] = ACTIONS(5065),
    [sym_null] = ACTIONS(5065),
    [sym_inf] = ACTIONS(5065),
    [sym_nan] = ACTIONS(5065),
    [anon_sym_NA] = ACTIONS(5065),
    [anon_sym_NA_integer_] = ACTIONS(5065),
    [anon_sym_NA_real_] = ACTIONS(5065),
    [anon_sym_NA_complex_] = ACTIONS(5065),
    [anon_sym_NA_character_] = ACTIONS(5065),
    [sym_dots] = ACTIONS(5065),
    [sym_dot_dot_i] = ACTIONS(5067),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5067),
    [sym__semicolon] = ACTIONS(5067),
    [sym__raw_string_literal] = ACTIONS(5067),
    [sym__external_else] = ACTIONS(5861),
    [sym__external_open_parenthesis] = ACTIONS(5649),
    [sym__external_close_parenthesis] = ACTIONS(5067),
    [sym__external_open_brace] = ACTIONS(5067),
    [sym__external_open_bracket] = ACTIONS(5651),
    [sym__external_open_bracket2] = ACTIONS(5653),
  },
  [871] = {
    [sym_call_arguments] = STATE(2678),
    [sym_subset_arguments] = STATE(2679),
    [sym_subset2_arguments] = STATE(2683),
    [sym__else] = STATE(4263),
    [sym__open_parenthesis] = STATE(1443),
    [sym__open_bracket] = STATE(1442),
    [sym__open_bracket2] = STATE(1425),
    [ts_builtin_sym_end] = ACTIONS(5117),
    [sym_identifier] = ACTIONS(5115),
    [anon_sym_BSLASH] = ACTIONS(5117),
    [anon_sym_function] = ACTIONS(5115),
    [anon_sym_EQ] = ACTIONS(5609),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_for] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_repeat] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(5117),
    [anon_sym_TILDE] = ACTIONS(5611),
    [anon_sym_BANG] = ACTIONS(5115),
    [anon_sym_PLUS] = ACTIONS(5613),
    [anon_sym_DASH] = ACTIONS(5615),
    [anon_sym_LT_DASH] = ACTIONS(5617),
    [anon_sym_LT_LT_DASH] = ACTIONS(5617),
    [anon_sym_COLON_EQ] = ACTIONS(5617),
    [anon_sym_DASH_GT] = ACTIONS(5619),
    [anon_sym_DASH_GT_GT] = ACTIONS(5621),
    [anon_sym_PIPE] = ACTIONS(5623),
    [anon_sym_AMP] = ACTIONS(5625),
    [anon_sym_PIPE_PIPE] = ACTIONS(5627),
    [anon_sym_AMP_AMP] = ACTIONS(5629),
    [anon_sym_LT] = ACTIONS(5631),
    [anon_sym_LT_EQ] = ACTIONS(5633),
    [anon_sym_GT] = ACTIONS(5631),
    [anon_sym_GT_EQ] = ACTIONS(5633),
    [anon_sym_EQ_EQ] = ACTIONS(5633),
    [anon_sym_BANG_EQ] = ACTIONS(5633),
    [anon_sym_STAR] = ACTIONS(5635),
    [anon_sym_SLASH] = ACTIONS(5637),
    [anon_sym_STAR_STAR] = ACTIONS(5639),
    [anon_sym_CARET] = ACTIONS(5639),
    [aux_sym_binary_operator_token1] = ACTIONS(5641),
    [anon_sym_PIPE_GT] = ACTIONS(5641),
    [anon_sym_COLON] = ACTIONS(5643),
    [anon_sym_DOLLAR] = ACTIONS(5645),
    [anon_sym_AT] = ACTIONS(5645),
    [aux_sym__hex_literal_token1] = ACTIONS(5117),
    [sym__number_literal] = ACTIONS(5115),
    [anon_sym_SQUOTE] = ACTIONS(5117),
    [anon_sym_DQUOTE] = ACTIONS(5117),
    [sym_return] = ACTIONS(5115),
    [sym_next] = ACTIONS(5115),
    [sym_break] = ACTIONS(5115),
    [sym_true] = ACTIONS(5115),
    [sym_false] = ACTIONS(5115),
    [sym_null] = ACTIONS(5115),
    [sym_inf] = ACTIONS(5115),
    [sym_nan] = ACTIONS(5115),
    [anon_sym_NA] = ACTIONS(5115),
    [anon_sym_NA_integer_] = ACTIONS(5115),
    [anon_sym_NA_real_] = ACTIONS(5115),
    [anon_sym_NA_complex_] = ACTIONS(5115),
    [anon_sym_NA_character_] = ACTIONS(5115),
    [sym_dots] = ACTIONS(5115),
    [sym_dot_dot_i] = ACTIONS(5117),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5117),
    [sym__semicolon] = ACTIONS(5117),
    [sym__raw_string_literal] = ACTIONS(5117),
    [sym__external_else] = ACTIONS(5863),
    [sym__external_open_parenthesis] = ACTIONS(5649),
    [sym__external_close_parenthesis] = ACTIONS(5117),
    [sym__external_open_brace] = ACTIONS(5117),
    [sym__external_open_bracket] = ACTIONS(5651),
    [sym__external_open_bracket2] = ACTIONS(5653),
  },
  [872] = {
    [sym_call_arguments] = STATE(2678),
    [sym_subset_arguments] = STATE(2679),
    [sym_subset2_arguments] = STATE(2683),
    [sym__else] = STATE(4137),
    [sym__open_parenthesis] = STATE(1443),
    [sym__open_bracket] = STATE(1442),
    [sym__open_bracket2] = STATE(1425),
    [ts_builtin_sym_end] = ACTIONS(5167),
    [sym_identifier] = ACTIONS(5169),
    [anon_sym_BSLASH] = ACTIONS(5167),
    [anon_sym_function] = ACTIONS(5169),
    [anon_sym_EQ] = ACTIONS(5609),
    [anon_sym_if] = ACTIONS(5169),
    [anon_sym_for] = ACTIONS(5169),
    [anon_sym_while] = ACTIONS(5169),
    [anon_sym_repeat] = ACTIONS(5169),
    [anon_sym_QMARK] = ACTIONS(5167),
    [anon_sym_TILDE] = ACTIONS(5611),
    [anon_sym_BANG] = ACTIONS(5169),
    [anon_sym_PLUS] = ACTIONS(5613),
    [anon_sym_DASH] = ACTIONS(5615),
    [anon_sym_LT_DASH] = ACTIONS(5617),
    [anon_sym_LT_LT_DASH] = ACTIONS(5617),
    [anon_sym_COLON_EQ] = ACTIONS(5617),
    [anon_sym_DASH_GT] = ACTIONS(5619),
    [anon_sym_DASH_GT_GT] = ACTIONS(5621),
    [anon_sym_PIPE] = ACTIONS(5623),
    [anon_sym_AMP] = ACTIONS(5625),
    [anon_sym_PIPE_PIPE] = ACTIONS(5627),
    [anon_sym_AMP_AMP] = ACTIONS(5629),
    [anon_sym_LT] = ACTIONS(5631),
    [anon_sym_LT_EQ] = ACTIONS(5633),
    [anon_sym_GT] = ACTIONS(5631),
    [anon_sym_GT_EQ] = ACTIONS(5633),
    [anon_sym_EQ_EQ] = ACTIONS(5633),
    [anon_sym_BANG_EQ] = ACTIONS(5633),
    [anon_sym_STAR] = ACTIONS(5635),
    [anon_sym_SLASH] = ACTIONS(5637),
    [anon_sym_STAR_STAR] = ACTIONS(5639),
    [anon_sym_CARET] = ACTIONS(5639),
    [aux_sym_binary_operator_token1] = ACTIONS(5641),
    [anon_sym_PIPE_GT] = ACTIONS(5641),
    [anon_sym_COLON] = ACTIONS(5643),
    [anon_sym_DOLLAR] = ACTIONS(5645),
    [anon_sym_AT] = ACTIONS(5645),
    [aux_sym__hex_literal_token1] = ACTIONS(5167),
    [sym__number_literal] = ACTIONS(5169),
    [anon_sym_SQUOTE] = ACTIONS(5167),
    [anon_sym_DQUOTE] = ACTIONS(5167),
    [sym_return] = ACTIONS(5169),
    [sym_next] = ACTIONS(5169),
    [sym_break] = ACTIONS(5169),
    [sym_true] = ACTIONS(5169),
    [sym_false] = ACTIONS(5169),
    [sym_null] = ACTIONS(5169),
    [sym_inf] = ACTIONS(5169),
    [sym_nan] = ACTIONS(5169),
    [anon_sym_NA] = ACTIONS(5169),
    [anon_sym_NA_integer_] = ACTIONS(5169),
    [anon_sym_NA_real_] = ACTIONS(5169),
    [anon_sym_NA_complex_] = ACTIONS(5169),
    [anon_sym_NA_character_] = ACTIONS(5169),
    [sym_dots] = ACTIONS(5169),
    [sym_dot_dot_i] = ACTIONS(5167),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5167),
    [sym__semicolon] = ACTIONS(5167),
    [sym__raw_string_literal] = ACTIONS(5167),
    [sym__external_else] = ACTIONS(5865),
    [sym__external_open_parenthesis] = ACTIONS(5649),
    [sym__external_close_parenthesis] = ACTIONS(5167),
    [sym__external_open_brace] = ACTIONS(5167),
    [sym__external_open_bracket] = ACTIONS(5651),
    [sym__external_open_bracket2] = ACTIONS(5653),
  },
  [873] = {
    [sym_call_arguments] = STATE(2678),
    [sym_subset_arguments] = STATE(2679),
    [sym_subset2_arguments] = STATE(2683),
    [sym__else] = STATE(4135),
    [sym__open_parenthesis] = STATE(1443),
    [sym__open_bracket] = STATE(1442),
    [sym__open_bracket2] = STATE(1425),
    [ts_builtin_sym_end] = ACTIONS(5227),
    [sym_identifier] = ACTIONS(5225),
    [anon_sym_BSLASH] = ACTIONS(5227),
    [anon_sym_function] = ACTIONS(5225),
    [anon_sym_EQ] = ACTIONS(5609),
    [anon_sym_if] = ACTIONS(5225),
    [anon_sym_for] = ACTIONS(5225),
    [anon_sym_while] = ACTIONS(5225),
    [anon_sym_repeat] = ACTIONS(5225),
    [anon_sym_QMARK] = ACTIONS(5227),
    [anon_sym_TILDE] = ACTIONS(5611),
    [anon_sym_BANG] = ACTIONS(5225),
    [anon_sym_PLUS] = ACTIONS(5613),
    [anon_sym_DASH] = ACTIONS(5615),
    [anon_sym_LT_DASH] = ACTIONS(5617),
    [anon_sym_LT_LT_DASH] = ACTIONS(5617),
    [anon_sym_COLON_EQ] = ACTIONS(5617),
    [anon_sym_DASH_GT] = ACTIONS(5619),
    [anon_sym_DASH_GT_GT] = ACTIONS(5621),
    [anon_sym_PIPE] = ACTIONS(5623),
    [anon_sym_AMP] = ACTIONS(5625),
    [anon_sym_PIPE_PIPE] = ACTIONS(5627),
    [anon_sym_AMP_AMP] = ACTIONS(5629),
    [anon_sym_LT] = ACTIONS(5631),
    [anon_sym_LT_EQ] = ACTIONS(5633),
    [anon_sym_GT] = ACTIONS(5631),
    [anon_sym_GT_EQ] = ACTIONS(5633),
    [anon_sym_EQ_EQ] = ACTIONS(5633),
    [anon_sym_BANG_EQ] = ACTIONS(5633),
    [anon_sym_STAR] = ACTIONS(5635),
    [anon_sym_SLASH] = ACTIONS(5637),
    [anon_sym_STAR_STAR] = ACTIONS(5639),
    [anon_sym_CARET] = ACTIONS(5639),
    [aux_sym_binary_operator_token1] = ACTIONS(5641),
    [anon_sym_PIPE_GT] = ACTIONS(5641),
    [anon_sym_COLON] = ACTIONS(5643),
    [anon_sym_DOLLAR] = ACTIONS(5645),
    [anon_sym_AT] = ACTIONS(5645),
    [aux_sym__hex_literal_token1] = ACTIONS(5227),
    [sym__number_literal] = ACTIONS(5225),
    [anon_sym_SQUOTE] = ACTIONS(5227),
    [anon_sym_DQUOTE] = ACTIONS(5227),
    [sym_return] = ACTIONS(5225),
    [sym_next] = ACTIONS(5225),
    [sym_break] = ACTIONS(5225),
    [sym_true] = ACTIONS(5225),
    [sym_false] = ACTIONS(5225),
    [sym_null] = ACTIONS(5225),
    [sym_inf] = ACTIONS(5225),
    [sym_nan] = ACTIONS(5225),
    [anon_sym_NA] = ACTIONS(5225),
    [anon_sym_NA_integer_] = ACTIONS(5225),
    [anon_sym_NA_real_] = ACTIONS(5225),
    [anon_sym_NA_complex_] = ACTIONS(5225),
    [anon_sym_NA_character_] = ACTIONS(5225),
    [sym_dots] = ACTIONS(5225),
    [sym_dot_dot_i] = ACTIONS(5227),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5227),
    [sym__semicolon] = ACTIONS(5227),
    [sym__raw_string_literal] = ACTIONS(5227),
    [sym__external_else] = ACTIONS(5867),
    [sym__external_open_parenthesis] = ACTIONS(5649),
    [sym__external_close_parenthesis] = ACTIONS(5227),
    [sym__external_open_brace] = ACTIONS(5227),
    [sym__external_open_bracket] = ACTIONS(5651),
    [sym__external_open_bracket2] = ACTIONS(5653),
  },
  [874] = {
    [sym_call_arguments] = STATE(2438),
    [sym_subset_arguments] = STATE(2439),
    [sym_subset2_arguments] = STATE(2440),
    [sym__open_parenthesis] = STATE(1350),
    [sym__open_bracket] = STATE(1348),
    [sym__open_bracket2] = STATE(1346),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(5383),
    [anon_sym_CARET] = ACTIONS(5383),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(5387),
    [anon_sym_DOLLAR] = ACTIONS(5389),
    [anon_sym_AT] = ACTIONS(5389),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5393),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5395),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(5397),
  },
  [875] = {
    [sym_call_arguments] = STATE(2438),
    [sym_subset_arguments] = STATE(2439),
    [sym_subset2_arguments] = STATE(2440),
    [sym__open_parenthesis] = STATE(1350),
    [sym__open_bracket] = STATE(1348),
    [sym__open_bracket2] = STATE(1346),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(5383),
    [anon_sym_CARET] = ACTIONS(5383),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(5261),
    [anon_sym_DOLLAR] = ACTIONS(5389),
    [anon_sym_AT] = ACTIONS(5389),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5393),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5395),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(5397),
  },
  [876] = {
    [sym_call_arguments] = STATE(2438),
    [sym_subset_arguments] = STATE(2439),
    [sym_subset2_arguments] = STATE(2440),
    [sym__open_parenthesis] = STATE(1350),
    [sym__open_bracket] = STATE(1348),
    [sym__open_bracket2] = STATE(1346),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_BSLASH] = ACTIONS(5413),
    [anon_sym_function] = ACTIONS(5415),
    [anon_sym_EQ] = ACTIONS(5353),
    [anon_sym_if] = ACTIONS(5415),
    [anon_sym_for] = ACTIONS(5415),
    [anon_sym_while] = ACTIONS(5415),
    [anon_sym_repeat] = ACTIONS(5415),
    [anon_sym_QMARK] = ACTIONS(5413),
    [anon_sym_TILDE] = ACTIONS(5355),
    [anon_sym_BANG] = ACTIONS(5415),
    [anon_sym_PLUS] = ACTIONS(5357),
    [anon_sym_DASH] = ACTIONS(5359),
    [anon_sym_LT_DASH] = ACTIONS(5361),
    [anon_sym_LT_LT_DASH] = ACTIONS(5361),
    [anon_sym_COLON_EQ] = ACTIONS(5361),
    [anon_sym_DASH_GT] = ACTIONS(5363),
    [anon_sym_DASH_GT_GT] = ACTIONS(5365),
    [anon_sym_PIPE] = ACTIONS(5367),
    [anon_sym_AMP] = ACTIONS(5369),
    [anon_sym_PIPE_PIPE] = ACTIONS(5371),
    [anon_sym_AMP_AMP] = ACTIONS(5373),
    [anon_sym_LT] = ACTIONS(5375),
    [anon_sym_LT_EQ] = ACTIONS(5377),
    [anon_sym_GT] = ACTIONS(5375),
    [anon_sym_GT_EQ] = ACTIONS(5377),
    [anon_sym_EQ_EQ] = ACTIONS(5377),
    [anon_sym_BANG_EQ] = ACTIONS(5377),
    [anon_sym_STAR] = ACTIONS(5379),
    [anon_sym_SLASH] = ACTIONS(5381),
    [anon_sym_STAR_STAR] = ACTIONS(5383),
    [anon_sym_CARET] = ACTIONS(5383),
    [aux_sym_binary_operator_token1] = ACTIONS(5385),
    [anon_sym_PIPE_GT] = ACTIONS(5385),
    [anon_sym_COLON] = ACTIONS(5387),
    [anon_sym_DOLLAR] = ACTIONS(5389),
    [anon_sym_AT] = ACTIONS(5389),
    [aux_sym__hex_literal_token1] = ACTIONS(5413),
    [sym__number_literal] = ACTIONS(5415),
    [anon_sym_SQUOTE] = ACTIONS(5413),
    [anon_sym_DQUOTE] = ACTIONS(5413),
    [sym_return] = ACTIONS(5415),
    [sym_next] = ACTIONS(5415),
    [sym_break] = ACTIONS(5415),
    [sym_true] = ACTIONS(5415),
    [sym_false] = ACTIONS(5415),
    [sym_null] = ACTIONS(5415),
    [sym_inf] = ACTIONS(5415),
    [sym_nan] = ACTIONS(5415),
    [anon_sym_NA] = ACTIONS(5415),
    [anon_sym_NA_integer_] = ACTIONS(5415),
    [anon_sym_NA_real_] = ACTIONS(5415),
    [anon_sym_NA_complex_] = ACTIONS(5415),
    [anon_sym_NA_character_] = ACTIONS(5415),
    [sym_dots] = ACTIONS(5415),
    [sym_dot_dot_i] = ACTIONS(5413),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5413),
    [sym__newline] = ACTIONS(5413),
    [sym__semicolon] = ACTIONS(5413),
    [sym__raw_string_literal] = ACTIONS(5413),
    [sym__external_else] = ACTIONS(5413),
    [sym__external_open_parenthesis] = ACTIONS(5393),
    [sym__external_open_brace] = ACTIONS(5413),
    [sym__external_close_brace] = ACTIONS(5413),
    [sym__external_open_bracket] = ACTIONS(5395),
    [sym__external_close_bracket] = ACTIONS(5413),
    [sym__external_open_bracket2] = ACTIONS(5397),
  },
  [877] = {
    [sym_call_arguments] = STATE(2438),
    [sym_subset_arguments] = STATE(2439),
    [sym_subset2_arguments] = STATE(2440),
    [sym__open_parenthesis] = STATE(1350),
    [sym__open_bracket] = STATE(1348),
    [sym__open_bracket2] = STATE(1346),
    [sym_identifier] = ACTIONS(5419),
    [anon_sym_BSLASH] = ACTIONS(5417),
    [anon_sym_function] = ACTIONS(5419),
    [anon_sym_EQ] = ACTIONS(5353),
    [anon_sym_if] = ACTIONS(5419),
    [anon_sym_for] = ACTIONS(5419),
    [anon_sym_while] = ACTIONS(5419),
    [anon_sym_repeat] = ACTIONS(5419),
    [anon_sym_QMARK] = ACTIONS(5417),
    [anon_sym_TILDE] = ACTIONS(5355),
    [anon_sym_BANG] = ACTIONS(5419),
    [anon_sym_PLUS] = ACTIONS(5357),
    [anon_sym_DASH] = ACTIONS(5359),
    [anon_sym_LT_DASH] = ACTIONS(5361),
    [anon_sym_LT_LT_DASH] = ACTIONS(5361),
    [anon_sym_COLON_EQ] = ACTIONS(5361),
    [anon_sym_DASH_GT] = ACTIONS(5363),
    [anon_sym_DASH_GT_GT] = ACTIONS(5365),
    [anon_sym_PIPE] = ACTIONS(5367),
    [anon_sym_AMP] = ACTIONS(5369),
    [anon_sym_PIPE_PIPE] = ACTIONS(5371),
    [anon_sym_AMP_AMP] = ACTIONS(5373),
    [anon_sym_LT] = ACTIONS(5375),
    [anon_sym_LT_EQ] = ACTIONS(5377),
    [anon_sym_GT] = ACTIONS(5375),
    [anon_sym_GT_EQ] = ACTIONS(5377),
    [anon_sym_EQ_EQ] = ACTIONS(5377),
    [anon_sym_BANG_EQ] = ACTIONS(5377),
    [anon_sym_STAR] = ACTIONS(5379),
    [anon_sym_SLASH] = ACTIONS(5381),
    [anon_sym_STAR_STAR] = ACTIONS(5383),
    [anon_sym_CARET] = ACTIONS(5383),
    [aux_sym_binary_operator_token1] = ACTIONS(5385),
    [anon_sym_PIPE_GT] = ACTIONS(5385),
    [anon_sym_COLON] = ACTIONS(5387),
    [anon_sym_DOLLAR] = ACTIONS(5389),
    [anon_sym_AT] = ACTIONS(5389),
    [aux_sym__hex_literal_token1] = ACTIONS(5417),
    [sym__number_literal] = ACTIONS(5419),
    [anon_sym_SQUOTE] = ACTIONS(5417),
    [anon_sym_DQUOTE] = ACTIONS(5417),
    [sym_return] = ACTIONS(5419),
    [sym_next] = ACTIONS(5419),
    [sym_break] = ACTIONS(5419),
    [sym_true] = ACTIONS(5419),
    [sym_false] = ACTIONS(5419),
    [sym_null] = ACTIONS(5419),
    [sym_inf] = ACTIONS(5419),
    [sym_nan] = ACTIONS(5419),
    [anon_sym_NA] = ACTIONS(5419),
    [anon_sym_NA_integer_] = ACTIONS(5419),
    [anon_sym_NA_real_] = ACTIONS(5419),
    [anon_sym_NA_complex_] = ACTIONS(5419),
    [anon_sym_NA_character_] = ACTIONS(5419),
    [sym_dots] = ACTIONS(5419),
    [sym_dot_dot_i] = ACTIONS(5417),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5417),
    [sym__newline] = ACTIONS(5417),
    [sym__semicolon] = ACTIONS(5417),
    [sym__raw_string_literal] = ACTIONS(5417),
    [sym__external_else] = ACTIONS(5417),
    [sym__external_open_parenthesis] = ACTIONS(5393),
    [sym__external_open_brace] = ACTIONS(5417),
    [sym__external_close_brace] = ACTIONS(5417),
    [sym__external_open_bracket] = ACTIONS(5395),
    [sym__external_close_bracket] = ACTIONS(5417),
    [sym__external_open_bracket2] = ACTIONS(5397),
  },
  [878] = {
    [sym_call_arguments] = STATE(2438),
    [sym_subset_arguments] = STATE(2439),
    [sym_subset2_arguments] = STATE(2440),
    [sym__open_parenthesis] = STATE(1350),
    [sym__open_bracket] = STATE(1348),
    [sym__open_bracket2] = STATE(1346),
    [sym_identifier] = ACTIONS(5423),
    [anon_sym_BSLASH] = ACTIONS(5421),
    [anon_sym_function] = ACTIONS(5423),
    [anon_sym_EQ] = ACTIONS(5353),
    [anon_sym_if] = ACTIONS(5423),
    [anon_sym_for] = ACTIONS(5423),
    [anon_sym_while] = ACTIONS(5423),
    [anon_sym_repeat] = ACTIONS(5423),
    [anon_sym_QMARK] = ACTIONS(5421),
    [anon_sym_TILDE] = ACTIONS(5355),
    [anon_sym_BANG] = ACTIONS(5423),
    [anon_sym_PLUS] = ACTIONS(5357),
    [anon_sym_DASH] = ACTIONS(5359),
    [anon_sym_LT_DASH] = ACTIONS(5361),
    [anon_sym_LT_LT_DASH] = ACTIONS(5361),
    [anon_sym_COLON_EQ] = ACTIONS(5361),
    [anon_sym_DASH_GT] = ACTIONS(5363),
    [anon_sym_DASH_GT_GT] = ACTIONS(5365),
    [anon_sym_PIPE] = ACTIONS(5367),
    [anon_sym_AMP] = ACTIONS(5369),
    [anon_sym_PIPE_PIPE] = ACTIONS(5371),
    [anon_sym_AMP_AMP] = ACTIONS(5373),
    [anon_sym_LT] = ACTIONS(5375),
    [anon_sym_LT_EQ] = ACTIONS(5377),
    [anon_sym_GT] = ACTIONS(5375),
    [anon_sym_GT_EQ] = ACTIONS(5377),
    [anon_sym_EQ_EQ] = ACTIONS(5377),
    [anon_sym_BANG_EQ] = ACTIONS(5377),
    [anon_sym_STAR] = ACTIONS(5379),
    [anon_sym_SLASH] = ACTIONS(5381),
    [anon_sym_STAR_STAR] = ACTIONS(5383),
    [anon_sym_CARET] = ACTIONS(5383),
    [aux_sym_binary_operator_token1] = ACTIONS(5385),
    [anon_sym_PIPE_GT] = ACTIONS(5385),
    [anon_sym_COLON] = ACTIONS(5387),
    [anon_sym_DOLLAR] = ACTIONS(5389),
    [anon_sym_AT] = ACTIONS(5389),
    [aux_sym__hex_literal_token1] = ACTIONS(5421),
    [sym__number_literal] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5421),
    [anon_sym_DQUOTE] = ACTIONS(5421),
    [sym_return] = ACTIONS(5423),
    [sym_next] = ACTIONS(5423),
    [sym_break] = ACTIONS(5423),
    [sym_true] = ACTIONS(5423),
    [sym_false] = ACTIONS(5423),
    [sym_null] = ACTIONS(5423),
    [sym_inf] = ACTIONS(5423),
    [sym_nan] = ACTIONS(5423),
    [anon_sym_NA] = ACTIONS(5423),
    [anon_sym_NA_integer_] = ACTIONS(5423),
    [anon_sym_NA_real_] = ACTIONS(5423),
    [anon_sym_NA_complex_] = ACTIONS(5423),
    [anon_sym_NA_character_] = ACTIONS(5423),
    [sym_dots] = ACTIONS(5423),
    [sym_dot_dot_i] = ACTIONS(5421),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5421),
    [sym__newline] = ACTIONS(5421),
    [sym__semicolon] = ACTIONS(5421),
    [sym__raw_string_literal] = ACTIONS(5421),
    [sym__external_else] = ACTIONS(5421),
    [sym__external_open_parenthesis] = ACTIONS(5393),
    [sym__external_open_brace] = ACTIONS(5421),
    [sym__external_close_brace] = ACTIONS(5421),
    [sym__external_open_bracket] = ACTIONS(5395),
    [sym__external_close_bracket] = ACTIONS(5421),
    [sym__external_open_bracket2] = ACTIONS(5397),
  },
  [879] = {
    [sym_call_arguments] = STATE(2509),
    [sym_subset_arguments] = STATE(2507),
    [sym_subset2_arguments] = STATE(2505),
    [sym__open_parenthesis] = STATE(1590),
    [sym__open_bracket] = STATE(1589),
    [sym__open_bracket2] = STATE(1588),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(5505),
    [anon_sym_CARET] = ACTIONS(5505),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(5351),
    [anon_sym_DOLLAR] = ACTIONS(5511),
    [anon_sym_AT] = ACTIONS(5511),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5513),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5515),
    [sym__external_open_bracket2] = ACTIONS(5517),
  },
  [880] = {
    [sym_call_arguments] = STATE(2509),
    [sym_subset_arguments] = STATE(2507),
    [sym_subset2_arguments] = STATE(2505),
    [sym__open_parenthesis] = STATE(1590),
    [sym__open_bracket] = STATE(1589),
    [sym__open_bracket2] = STATE(1588),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(5505),
    [anon_sym_CARET] = ACTIONS(5505),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(5509),
    [anon_sym_DOLLAR] = ACTIONS(5511),
    [anon_sym_AT] = ACTIONS(5511),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5513),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5515),
    [sym__external_open_bracket2] = ACTIONS(5517),
  },
  [881] = {
    [sym_call_arguments] = STATE(2438),
    [sym_subset_arguments] = STATE(2439),
    [sym_subset2_arguments] = STATE(2440),
    [sym__open_parenthesis] = STATE(1350),
    [sym__open_bracket] = STATE(1348),
    [sym__open_bracket2] = STATE(1346),
    [sym_identifier] = ACTIONS(5427),
    [anon_sym_BSLASH] = ACTIONS(5425),
    [anon_sym_function] = ACTIONS(5427),
    [anon_sym_EQ] = ACTIONS(5353),
    [anon_sym_if] = ACTIONS(5427),
    [anon_sym_for] = ACTIONS(5427),
    [anon_sym_while] = ACTIONS(5427),
    [anon_sym_repeat] = ACTIONS(5427),
    [anon_sym_QMARK] = ACTIONS(5425),
    [anon_sym_TILDE] = ACTIONS(5355),
    [anon_sym_BANG] = ACTIONS(5427),
    [anon_sym_PLUS] = ACTIONS(5357),
    [anon_sym_DASH] = ACTIONS(5359),
    [anon_sym_LT_DASH] = ACTIONS(5361),
    [anon_sym_LT_LT_DASH] = ACTIONS(5361),
    [anon_sym_COLON_EQ] = ACTIONS(5361),
    [anon_sym_DASH_GT] = ACTIONS(5363),
    [anon_sym_DASH_GT_GT] = ACTIONS(5365),
    [anon_sym_PIPE] = ACTIONS(5367),
    [anon_sym_AMP] = ACTIONS(5369),
    [anon_sym_PIPE_PIPE] = ACTIONS(5371),
    [anon_sym_AMP_AMP] = ACTIONS(5373),
    [anon_sym_LT] = ACTIONS(5375),
    [anon_sym_LT_EQ] = ACTIONS(5377),
    [anon_sym_GT] = ACTIONS(5375),
    [anon_sym_GT_EQ] = ACTIONS(5377),
    [anon_sym_EQ_EQ] = ACTIONS(5377),
    [anon_sym_BANG_EQ] = ACTIONS(5377),
    [anon_sym_STAR] = ACTIONS(5379),
    [anon_sym_SLASH] = ACTIONS(5381),
    [anon_sym_STAR_STAR] = ACTIONS(5383),
    [anon_sym_CARET] = ACTIONS(5383),
    [aux_sym_binary_operator_token1] = ACTIONS(5385),
    [anon_sym_PIPE_GT] = ACTIONS(5385),
    [anon_sym_COLON] = ACTIONS(5387),
    [anon_sym_DOLLAR] = ACTIONS(5389),
    [anon_sym_AT] = ACTIONS(5389),
    [aux_sym__hex_literal_token1] = ACTIONS(5425),
    [sym__number_literal] = ACTIONS(5427),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_DQUOTE] = ACTIONS(5425),
    [sym_return] = ACTIONS(5427),
    [sym_next] = ACTIONS(5427),
    [sym_break] = ACTIONS(5427),
    [sym_true] = ACTIONS(5427),
    [sym_false] = ACTIONS(5427),
    [sym_null] = ACTIONS(5427),
    [sym_inf] = ACTIONS(5427),
    [sym_nan] = ACTIONS(5427),
    [anon_sym_NA] = ACTIONS(5427),
    [anon_sym_NA_integer_] = ACTIONS(5427),
    [anon_sym_NA_real_] = ACTIONS(5427),
    [anon_sym_NA_complex_] = ACTIONS(5427),
    [anon_sym_NA_character_] = ACTIONS(5427),
    [sym_dots] = ACTIONS(5427),
    [sym_dot_dot_i] = ACTIONS(5425),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5425),
    [sym__newline] = ACTIONS(5425),
    [sym__semicolon] = ACTIONS(5425),
    [sym__raw_string_literal] = ACTIONS(5425),
    [sym__external_else] = ACTIONS(5425),
    [sym__external_open_parenthesis] = ACTIONS(5393),
    [sym__external_open_brace] = ACTIONS(5425),
    [sym__external_close_brace] = ACTIONS(5425),
    [sym__external_open_bracket] = ACTIONS(5395),
    [sym__external_close_bracket] = ACTIONS(5425),
    [sym__external_open_bracket2] = ACTIONS(5397),
  },
  [882] = {
    [sym_call_arguments] = STATE(2509),
    [sym_subset_arguments] = STATE(2507),
    [sym_subset2_arguments] = STATE(2505),
    [sym__open_parenthesis] = STATE(1590),
    [sym__open_bracket] = STATE(1589),
    [sym__open_bracket2] = STATE(1588),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(5505),
    [anon_sym_CARET] = ACTIONS(5505),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(5351),
    [anon_sym_DOLLAR] = ACTIONS(5511),
    [anon_sym_AT] = ACTIONS(5511),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5513),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5515),
    [sym__external_open_bracket2] = ACTIONS(5517),
  },
  [883] = {
    [sym_call_arguments] = STATE(2438),
    [sym_subset_arguments] = STATE(2439),
    [sym_subset2_arguments] = STATE(2440),
    [sym__open_parenthesis] = STATE(1350),
    [sym__open_bracket] = STATE(1348),
    [sym__open_bracket2] = STATE(1346),
    [sym_identifier] = ACTIONS(5431),
    [anon_sym_BSLASH] = ACTIONS(5429),
    [anon_sym_function] = ACTIONS(5431),
    [anon_sym_EQ] = ACTIONS(5353),
    [anon_sym_if] = ACTIONS(5431),
    [anon_sym_for] = ACTIONS(5431),
    [anon_sym_while] = ACTIONS(5431),
    [anon_sym_repeat] = ACTIONS(5431),
    [anon_sym_QMARK] = ACTIONS(5429),
    [anon_sym_TILDE] = ACTIONS(5355),
    [anon_sym_BANG] = ACTIONS(5431),
    [anon_sym_PLUS] = ACTIONS(5357),
    [anon_sym_DASH] = ACTIONS(5359),
    [anon_sym_LT_DASH] = ACTIONS(5361),
    [anon_sym_LT_LT_DASH] = ACTIONS(5361),
    [anon_sym_COLON_EQ] = ACTIONS(5361),
    [anon_sym_DASH_GT] = ACTIONS(5363),
    [anon_sym_DASH_GT_GT] = ACTIONS(5365),
    [anon_sym_PIPE] = ACTIONS(5367),
    [anon_sym_AMP] = ACTIONS(5369),
    [anon_sym_PIPE_PIPE] = ACTIONS(5371),
    [anon_sym_AMP_AMP] = ACTIONS(5373),
    [anon_sym_LT] = ACTIONS(5375),
    [anon_sym_LT_EQ] = ACTIONS(5377),
    [anon_sym_GT] = ACTIONS(5375),
    [anon_sym_GT_EQ] = ACTIONS(5377),
    [anon_sym_EQ_EQ] = ACTIONS(5377),
    [anon_sym_BANG_EQ] = ACTIONS(5377),
    [anon_sym_STAR] = ACTIONS(5379),
    [anon_sym_SLASH] = ACTIONS(5381),
    [anon_sym_STAR_STAR] = ACTIONS(5383),
    [anon_sym_CARET] = ACTIONS(5383),
    [aux_sym_binary_operator_token1] = ACTIONS(5385),
    [anon_sym_PIPE_GT] = ACTIONS(5385),
    [anon_sym_COLON] = ACTIONS(5387),
    [anon_sym_DOLLAR] = ACTIONS(5389),
    [anon_sym_AT] = ACTIONS(5389),
    [aux_sym__hex_literal_token1] = ACTIONS(5429),
    [sym__number_literal] = ACTIONS(5431),
    [anon_sym_SQUOTE] = ACTIONS(5429),
    [anon_sym_DQUOTE] = ACTIONS(5429),
    [sym_return] = ACTIONS(5431),
    [sym_next] = ACTIONS(5431),
    [sym_break] = ACTIONS(5431),
    [sym_true] = ACTIONS(5431),
    [sym_false] = ACTIONS(5431),
    [sym_null] = ACTIONS(5431),
    [sym_inf] = ACTIONS(5431),
    [sym_nan] = ACTIONS(5431),
    [anon_sym_NA] = ACTIONS(5431),
    [anon_sym_NA_integer_] = ACTIONS(5431),
    [anon_sym_NA_real_] = ACTIONS(5431),
    [anon_sym_NA_complex_] = ACTIONS(5431),
    [anon_sym_NA_character_] = ACTIONS(5431),
    [sym_dots] = ACTIONS(5431),
    [sym_dot_dot_i] = ACTIONS(5429),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5429),
    [sym__newline] = ACTIONS(5429),
    [sym__semicolon] = ACTIONS(5429),
    [sym__raw_string_literal] = ACTIONS(5429),
    [sym__external_else] = ACTIONS(5429),
    [sym__external_open_parenthesis] = ACTIONS(5393),
    [sym__external_open_brace] = ACTIONS(5429),
    [sym__external_close_brace] = ACTIONS(5429),
    [sym__external_open_bracket] = ACTIONS(5395),
    [sym__external_close_bracket] = ACTIONS(5429),
    [sym__external_open_bracket2] = ACTIONS(5397),
  },
  [884] = {
    [sym_call_arguments] = STATE(2509),
    [sym_subset_arguments] = STATE(2507),
    [sym_subset2_arguments] = STATE(2505),
    [sym__open_parenthesis] = STATE(1590),
    [sym__open_bracket] = STATE(1589),
    [sym__open_bracket2] = STATE(1588),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(5505),
    [anon_sym_CARET] = ACTIONS(5505),
    [aux_sym_binary_operator_token1] = ACTIONS(5507),
    [anon_sym_PIPE_GT] = ACTIONS(5507),
    [anon_sym_COLON] = ACTIONS(5509),
    [anon_sym_DOLLAR] = ACTIONS(5511),
    [anon_sym_AT] = ACTIONS(5511),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5513),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5515),
    [sym__external_open_bracket2] = ACTIONS(5517),
  },
  [885] = {
    [sym_call_arguments] = STATE(2509),
    [sym_subset_arguments] = STATE(2507),
    [sym_subset2_arguments] = STATE(2505),
    [sym__open_parenthesis] = STATE(1590),
    [sym__open_bracket] = STATE(1589),
    [sym__open_bracket2] = STATE(1588),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5479),
    [anon_sym_DASH] = ACTIONS(5481),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5501),
    [anon_sym_SLASH] = ACTIONS(5503),
    [anon_sym_STAR_STAR] = ACTIONS(5505),
    [anon_sym_CARET] = ACTIONS(5505),
    [aux_sym_binary_operator_token1] = ACTIONS(5507),
    [anon_sym_PIPE_GT] = ACTIONS(5507),
    [anon_sym_COLON] = ACTIONS(5509),
    [anon_sym_DOLLAR] = ACTIONS(5511),
    [anon_sym_AT] = ACTIONS(5511),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5513),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5515),
    [sym__external_open_bracket2] = ACTIONS(5517),
  },
  [886] = {
    [sym_call_arguments] = STATE(2438),
    [sym_subset_arguments] = STATE(2439),
    [sym_subset2_arguments] = STATE(2440),
    [sym__open_parenthesis] = STATE(1350),
    [sym__open_bracket] = STATE(1348),
    [sym__open_bracket2] = STATE(1346),
    [sym_identifier] = ACTIONS(5435),
    [anon_sym_BSLASH] = ACTIONS(5433),
    [anon_sym_function] = ACTIONS(5435),
    [anon_sym_EQ] = ACTIONS(5353),
    [anon_sym_if] = ACTIONS(5435),
    [anon_sym_for] = ACTIONS(5435),
    [anon_sym_while] = ACTIONS(5435),
    [anon_sym_repeat] = ACTIONS(5435),
    [anon_sym_QMARK] = ACTIONS(5433),
    [anon_sym_TILDE] = ACTIONS(5355),
    [anon_sym_BANG] = ACTIONS(5435),
    [anon_sym_PLUS] = ACTIONS(5357),
    [anon_sym_DASH] = ACTIONS(5359),
    [anon_sym_LT_DASH] = ACTIONS(5361),
    [anon_sym_LT_LT_DASH] = ACTIONS(5361),
    [anon_sym_COLON_EQ] = ACTIONS(5361),
    [anon_sym_DASH_GT] = ACTIONS(5363),
    [anon_sym_DASH_GT_GT] = ACTIONS(5365),
    [anon_sym_PIPE] = ACTIONS(5367),
    [anon_sym_AMP] = ACTIONS(5369),
    [anon_sym_PIPE_PIPE] = ACTIONS(5371),
    [anon_sym_AMP_AMP] = ACTIONS(5373),
    [anon_sym_LT] = ACTIONS(5375),
    [anon_sym_LT_EQ] = ACTIONS(5377),
    [anon_sym_GT] = ACTIONS(5375),
    [anon_sym_GT_EQ] = ACTIONS(5377),
    [anon_sym_EQ_EQ] = ACTIONS(5377),
    [anon_sym_BANG_EQ] = ACTIONS(5377),
    [anon_sym_STAR] = ACTIONS(5379),
    [anon_sym_SLASH] = ACTIONS(5381),
    [anon_sym_STAR_STAR] = ACTIONS(5383),
    [anon_sym_CARET] = ACTIONS(5383),
    [aux_sym_binary_operator_token1] = ACTIONS(5385),
    [anon_sym_PIPE_GT] = ACTIONS(5385),
    [anon_sym_COLON] = ACTIONS(5387),
    [anon_sym_DOLLAR] = ACTIONS(5389),
    [anon_sym_AT] = ACTIONS(5389),
    [aux_sym__hex_literal_token1] = ACTIONS(5433),
    [sym__number_literal] = ACTIONS(5435),
    [anon_sym_SQUOTE] = ACTIONS(5433),
    [anon_sym_DQUOTE] = ACTIONS(5433),
    [sym_return] = ACTIONS(5435),
    [sym_next] = ACTIONS(5435),
    [sym_break] = ACTIONS(5435),
    [sym_true] = ACTIONS(5435),
    [sym_false] = ACTIONS(5435),
    [sym_null] = ACTIONS(5435),
    [sym_inf] = ACTIONS(5435),
    [sym_nan] = ACTIONS(5435),
    [anon_sym_NA] = ACTIONS(5435),
    [anon_sym_NA_integer_] = ACTIONS(5435),
    [anon_sym_NA_real_] = ACTIONS(5435),
    [anon_sym_NA_complex_] = ACTIONS(5435),
    [anon_sym_NA_character_] = ACTIONS(5435),
    [sym_dots] = ACTIONS(5435),
    [sym_dot_dot_i] = ACTIONS(5433),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5433),
    [sym__newline] = ACTIONS(5433),
    [sym__semicolon] = ACTIONS(5433),
    [sym__raw_string_literal] = ACTIONS(5433),
    [sym__external_else] = ACTIONS(5433),
    [sym__external_open_parenthesis] = ACTIONS(5393),
    [sym__external_open_brace] = ACTIONS(5433),
    [sym__external_close_brace] = ACTIONS(5433),
    [sym__external_open_bracket] = ACTIONS(5395),
    [sym__external_close_bracket] = ACTIONS(5433),
    [sym__external_open_bracket2] = ACTIONS(5397),
  },
  [887] = {
    [sym_call_arguments] = STATE(2509),
    [sym_subset_arguments] = STATE(2507),
    [sym_subset2_arguments] = STATE(2505),
    [sym__open_parenthesis] = STATE(1590),
    [sym__open_bracket] = STATE(1589),
    [sym__open_bracket2] = STATE(1588),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5479),
    [anon_sym_DASH] = ACTIONS(5481),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5497),
    [anon_sym_LT_EQ] = ACTIONS(5499),
    [anon_sym_GT] = ACTIONS(5497),
    [anon_sym_GT_EQ] = ACTIONS(5499),
    [anon_sym_EQ_EQ] = ACTIONS(5499),
    [anon_sym_BANG_EQ] = ACTIONS(5499),
    [anon_sym_STAR] = ACTIONS(5501),
    [anon_sym_SLASH] = ACTIONS(5503),
    [anon_sym_STAR_STAR] = ACTIONS(5505),
    [anon_sym_CARET] = ACTIONS(5505),
    [aux_sym_binary_operator_token1] = ACTIONS(5507),
    [anon_sym_PIPE_GT] = ACTIONS(5507),
    [anon_sym_COLON] = ACTIONS(5509),
    [anon_sym_DOLLAR] = ACTIONS(5511),
    [anon_sym_AT] = ACTIONS(5511),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5513),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5515),
    [sym__external_open_bracket2] = ACTIONS(5517),
  },
  [888] = {
    [sym_call_arguments] = STATE(2438),
    [sym_subset_arguments] = STATE(2439),
    [sym_subset2_arguments] = STATE(2440),
    [sym__open_parenthesis] = STATE(1350),
    [sym__open_bracket] = STATE(1348),
    [sym__open_bracket2] = STATE(1346),
    [sym_identifier] = ACTIONS(5439),
    [anon_sym_BSLASH] = ACTIONS(5437),
    [anon_sym_function] = ACTIONS(5439),
    [anon_sym_EQ] = ACTIONS(5353),
    [anon_sym_if] = ACTIONS(5439),
    [anon_sym_for] = ACTIONS(5439),
    [anon_sym_while] = ACTIONS(5439),
    [anon_sym_repeat] = ACTIONS(5439),
    [anon_sym_QMARK] = ACTIONS(5437),
    [anon_sym_TILDE] = ACTIONS(5355),
    [anon_sym_BANG] = ACTIONS(5439),
    [anon_sym_PLUS] = ACTIONS(5357),
    [anon_sym_DASH] = ACTIONS(5359),
    [anon_sym_LT_DASH] = ACTIONS(5361),
    [anon_sym_LT_LT_DASH] = ACTIONS(5361),
    [anon_sym_COLON_EQ] = ACTIONS(5361),
    [anon_sym_DASH_GT] = ACTIONS(5363),
    [anon_sym_DASH_GT_GT] = ACTIONS(5365),
    [anon_sym_PIPE] = ACTIONS(5367),
    [anon_sym_AMP] = ACTIONS(5369),
    [anon_sym_PIPE_PIPE] = ACTIONS(5371),
    [anon_sym_AMP_AMP] = ACTIONS(5373),
    [anon_sym_LT] = ACTIONS(5375),
    [anon_sym_LT_EQ] = ACTIONS(5377),
    [anon_sym_GT] = ACTIONS(5375),
    [anon_sym_GT_EQ] = ACTIONS(5377),
    [anon_sym_EQ_EQ] = ACTIONS(5377),
    [anon_sym_BANG_EQ] = ACTIONS(5377),
    [anon_sym_STAR] = ACTIONS(5379),
    [anon_sym_SLASH] = ACTIONS(5381),
    [anon_sym_STAR_STAR] = ACTIONS(5383),
    [anon_sym_CARET] = ACTIONS(5383),
    [aux_sym_binary_operator_token1] = ACTIONS(5385),
    [anon_sym_PIPE_GT] = ACTIONS(5385),
    [anon_sym_COLON] = ACTIONS(5387),
    [anon_sym_DOLLAR] = ACTIONS(5389),
    [anon_sym_AT] = ACTIONS(5389),
    [aux_sym__hex_literal_token1] = ACTIONS(5437),
    [sym__number_literal] = ACTIONS(5439),
    [anon_sym_SQUOTE] = ACTIONS(5437),
    [anon_sym_DQUOTE] = ACTIONS(5437),
    [sym_return] = ACTIONS(5439),
    [sym_next] = ACTIONS(5439),
    [sym_break] = ACTIONS(5439),
    [sym_true] = ACTIONS(5439),
    [sym_false] = ACTIONS(5439),
    [sym_null] = ACTIONS(5439),
    [sym_inf] = ACTIONS(5439),
    [sym_nan] = ACTIONS(5439),
    [anon_sym_NA] = ACTIONS(5439),
    [anon_sym_NA_integer_] = ACTIONS(5439),
    [anon_sym_NA_real_] = ACTIONS(5439),
    [anon_sym_NA_complex_] = ACTIONS(5439),
    [anon_sym_NA_character_] = ACTIONS(5439),
    [sym_dots] = ACTIONS(5439),
    [sym_dot_dot_i] = ACTIONS(5437),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5437),
    [sym__newline] = ACTIONS(5437),
    [sym__semicolon] = ACTIONS(5437),
    [sym__raw_string_literal] = ACTIONS(5437),
    [sym__external_else] = ACTIONS(5437),
    [sym__external_open_parenthesis] = ACTIONS(5393),
    [sym__external_open_brace] = ACTIONS(5437),
    [sym__external_close_brace] = ACTIONS(5437),
    [sym__external_open_bracket] = ACTIONS(5395),
    [sym__external_close_bracket] = ACTIONS(5437),
    [sym__external_open_bracket2] = ACTIONS(5397),
  },
  [889] = {
    [sym_call_arguments] = STATE(2509),
    [sym_subset_arguments] = STATE(2507),
    [sym_subset2_arguments] = STATE(2505),
    [sym__open_parenthesis] = STATE(1590),
    [sym__open_bracket] = STATE(1589),
    [sym__open_bracket2] = STATE(1588),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5479),
    [anon_sym_DASH] = ACTIONS(5481),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5491),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5495),
    [anon_sym_LT] = ACTIONS(5497),
    [anon_sym_LT_EQ] = ACTIONS(5499),
    [anon_sym_GT] = ACTIONS(5497),
    [anon_sym_GT_EQ] = ACTIONS(5499),
    [anon_sym_EQ_EQ] = ACTIONS(5499),
    [anon_sym_BANG_EQ] = ACTIONS(5499),
    [anon_sym_STAR] = ACTIONS(5501),
    [anon_sym_SLASH] = ACTIONS(5503),
    [anon_sym_STAR_STAR] = ACTIONS(5505),
    [anon_sym_CARET] = ACTIONS(5505),
    [aux_sym_binary_operator_token1] = ACTIONS(5507),
    [anon_sym_PIPE_GT] = ACTIONS(5507),
    [anon_sym_COLON] = ACTIONS(5509),
    [anon_sym_DOLLAR] = ACTIONS(5511),
    [anon_sym_AT] = ACTIONS(5511),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5513),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5515),
    [sym__external_open_bracket2] = ACTIONS(5517),
  },
  [890] = {
    [sym_call_arguments] = STATE(2438),
    [sym_subset_arguments] = STATE(2439),
    [sym_subset2_arguments] = STATE(2440),
    [sym__open_parenthesis] = STATE(1350),
    [sym__open_bracket] = STATE(1348),
    [sym__open_bracket2] = STATE(1346),
    [sym_identifier] = ACTIONS(5443),
    [anon_sym_BSLASH] = ACTIONS(5441),
    [anon_sym_function] = ACTIONS(5443),
    [anon_sym_EQ] = ACTIONS(5353),
    [anon_sym_if] = ACTIONS(5443),
    [anon_sym_for] = ACTIONS(5443),
    [anon_sym_while] = ACTIONS(5443),
    [anon_sym_repeat] = ACTIONS(5443),
    [anon_sym_QMARK] = ACTIONS(5441),
    [anon_sym_TILDE] = ACTIONS(5355),
    [anon_sym_BANG] = ACTIONS(5443),
    [anon_sym_PLUS] = ACTIONS(5357),
    [anon_sym_DASH] = ACTIONS(5359),
    [anon_sym_LT_DASH] = ACTIONS(5361),
    [anon_sym_LT_LT_DASH] = ACTIONS(5361),
    [anon_sym_COLON_EQ] = ACTIONS(5361),
    [anon_sym_DASH_GT] = ACTIONS(5363),
    [anon_sym_DASH_GT_GT] = ACTIONS(5365),
    [anon_sym_PIPE] = ACTIONS(5367),
    [anon_sym_AMP] = ACTIONS(5369),
    [anon_sym_PIPE_PIPE] = ACTIONS(5371),
    [anon_sym_AMP_AMP] = ACTIONS(5373),
    [anon_sym_LT] = ACTIONS(5375),
    [anon_sym_LT_EQ] = ACTIONS(5377),
    [anon_sym_GT] = ACTIONS(5375),
    [anon_sym_GT_EQ] = ACTIONS(5377),
    [anon_sym_EQ_EQ] = ACTIONS(5377),
    [anon_sym_BANG_EQ] = ACTIONS(5377),
    [anon_sym_STAR] = ACTIONS(5379),
    [anon_sym_SLASH] = ACTIONS(5381),
    [anon_sym_STAR_STAR] = ACTIONS(5383),
    [anon_sym_CARET] = ACTIONS(5383),
    [aux_sym_binary_operator_token1] = ACTIONS(5385),
    [anon_sym_PIPE_GT] = ACTIONS(5385),
    [anon_sym_COLON] = ACTIONS(5387),
    [anon_sym_DOLLAR] = ACTIONS(5389),
    [anon_sym_AT] = ACTIONS(5389),
    [aux_sym__hex_literal_token1] = ACTIONS(5441),
    [sym__number_literal] = ACTIONS(5443),
    [anon_sym_SQUOTE] = ACTIONS(5441),
    [anon_sym_DQUOTE] = ACTIONS(5441),
    [sym_return] = ACTIONS(5443),
    [sym_next] = ACTIONS(5443),
    [sym_break] = ACTIONS(5443),
    [sym_true] = ACTIONS(5443),
    [sym_false] = ACTIONS(5443),
    [sym_null] = ACTIONS(5443),
    [sym_inf] = ACTIONS(5443),
    [sym_nan] = ACTIONS(5443),
    [anon_sym_NA] = ACTIONS(5443),
    [anon_sym_NA_integer_] = ACTIONS(5443),
    [anon_sym_NA_real_] = ACTIONS(5443),
    [anon_sym_NA_complex_] = ACTIONS(5443),
    [anon_sym_NA_character_] = ACTIONS(5443),
    [sym_dots] = ACTIONS(5443),
    [sym_dot_dot_i] = ACTIONS(5441),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5441),
    [sym__newline] = ACTIONS(5441),
    [sym__semicolon] = ACTIONS(5441),
    [sym__raw_string_literal] = ACTIONS(5441),
    [sym__external_else] = ACTIONS(5441),
    [sym__external_open_parenthesis] = ACTIONS(5393),
    [sym__external_open_brace] = ACTIONS(5441),
    [sym__external_close_brace] = ACTIONS(5441),
    [sym__external_open_bracket] = ACTIONS(5395),
    [sym__external_close_bracket] = ACTIONS(5441),
    [sym__external_open_bracket2] = ACTIONS(5397),
  },
  [891] = {
    [sym_call_arguments] = STATE(2509),
    [sym_subset_arguments] = STATE(2507),
    [sym_subset2_arguments] = STATE(2505),
    [sym__open_parenthesis] = STATE(1590),
    [sym__open_bracket] = STATE(1589),
    [sym__open_bracket2] = STATE(1588),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5477),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5479),
    [anon_sym_DASH] = ACTIONS(5481),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5489),
    [anon_sym_AMP] = ACTIONS(5491),
    [anon_sym_PIPE_PIPE] = ACTIONS(5493),
    [anon_sym_AMP_AMP] = ACTIONS(5495),
    [anon_sym_LT] = ACTIONS(5497),
    [anon_sym_LT_EQ] = ACTIONS(5499),
    [anon_sym_GT] = ACTIONS(5497),
    [anon_sym_GT_EQ] = ACTIONS(5499),
    [anon_sym_EQ_EQ] = ACTIONS(5499),
    [anon_sym_BANG_EQ] = ACTIONS(5499),
    [anon_sym_STAR] = ACTIONS(5501),
    [anon_sym_SLASH] = ACTIONS(5503),
    [anon_sym_STAR_STAR] = ACTIONS(5505),
    [anon_sym_CARET] = ACTIONS(5505),
    [aux_sym_binary_operator_token1] = ACTIONS(5507),
    [anon_sym_PIPE_GT] = ACTIONS(5507),
    [anon_sym_COLON] = ACTIONS(5509),
    [anon_sym_DOLLAR] = ACTIONS(5511),
    [anon_sym_AT] = ACTIONS(5511),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5513),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5515),
    [sym__external_open_bracket2] = ACTIONS(5517),
  },
  [892] = {
    [sym_call_arguments] = STATE(2438),
    [sym_subset_arguments] = STATE(2439),
    [sym_subset2_arguments] = STATE(2440),
    [sym__open_parenthesis] = STATE(1350),
    [sym__open_bracket] = STATE(1348),
    [sym__open_bracket2] = STATE(1346),
    [sym_identifier] = ACTIONS(5447),
    [anon_sym_BSLASH] = ACTIONS(5445),
    [anon_sym_function] = ACTIONS(5447),
    [anon_sym_EQ] = ACTIONS(5353),
    [anon_sym_if] = ACTIONS(5447),
    [anon_sym_for] = ACTIONS(5447),
    [anon_sym_while] = ACTIONS(5447),
    [anon_sym_repeat] = ACTIONS(5447),
    [anon_sym_QMARK] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(5355),
    [anon_sym_BANG] = ACTIONS(5447),
    [anon_sym_PLUS] = ACTIONS(5357),
    [anon_sym_DASH] = ACTIONS(5359),
    [anon_sym_LT_DASH] = ACTIONS(5361),
    [anon_sym_LT_LT_DASH] = ACTIONS(5361),
    [anon_sym_COLON_EQ] = ACTIONS(5361),
    [anon_sym_DASH_GT] = ACTIONS(5363),
    [anon_sym_DASH_GT_GT] = ACTIONS(5365),
    [anon_sym_PIPE] = ACTIONS(5367),
    [anon_sym_AMP] = ACTIONS(5369),
    [anon_sym_PIPE_PIPE] = ACTIONS(5371),
    [anon_sym_AMP_AMP] = ACTIONS(5373),
    [anon_sym_LT] = ACTIONS(5375),
    [anon_sym_LT_EQ] = ACTIONS(5377),
    [anon_sym_GT] = ACTIONS(5375),
    [anon_sym_GT_EQ] = ACTIONS(5377),
    [anon_sym_EQ_EQ] = ACTIONS(5377),
    [anon_sym_BANG_EQ] = ACTIONS(5377),
    [anon_sym_STAR] = ACTIONS(5379),
    [anon_sym_SLASH] = ACTIONS(5381),
    [anon_sym_STAR_STAR] = ACTIONS(5383),
    [anon_sym_CARET] = ACTIONS(5383),
    [aux_sym_binary_operator_token1] = ACTIONS(5385),
    [anon_sym_PIPE_GT] = ACTIONS(5385),
    [anon_sym_COLON] = ACTIONS(5387),
    [anon_sym_DOLLAR] = ACTIONS(5389),
    [anon_sym_AT] = ACTIONS(5389),
    [aux_sym__hex_literal_token1] = ACTIONS(5445),
    [sym__number_literal] = ACTIONS(5447),
    [anon_sym_SQUOTE] = ACTIONS(5445),
    [anon_sym_DQUOTE] = ACTIONS(5445),
    [sym_return] = ACTIONS(5447),
    [sym_next] = ACTIONS(5447),
    [sym_break] = ACTIONS(5447),
    [sym_true] = ACTIONS(5447),
    [sym_false] = ACTIONS(5447),
    [sym_null] = ACTIONS(5447),
    [sym_inf] = ACTIONS(5447),
    [sym_nan] = ACTIONS(5447),
    [anon_sym_NA] = ACTIONS(5447),
    [anon_sym_NA_integer_] = ACTIONS(5447),
    [anon_sym_NA_real_] = ACTIONS(5447),
    [anon_sym_NA_complex_] = ACTIONS(5447),
    [anon_sym_NA_character_] = ACTIONS(5447),
    [sym_dots] = ACTIONS(5447),
    [sym_dot_dot_i] = ACTIONS(5445),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5445),
    [sym__newline] = ACTIONS(5445),
    [sym__semicolon] = ACTIONS(5445),
    [sym__raw_string_literal] = ACTIONS(5445),
    [sym__external_else] = ACTIONS(5445),
    [sym__external_open_parenthesis] = ACTIONS(5393),
    [sym__external_open_brace] = ACTIONS(5445),
    [sym__external_close_brace] = ACTIONS(5445),
    [sym__external_open_bracket] = ACTIONS(5395),
    [sym__external_close_bracket] = ACTIONS(5445),
    [sym__external_open_bracket2] = ACTIONS(5397),
  },
  [893] = {
    [sym_call_arguments] = STATE(2509),
    [sym_subset_arguments] = STATE(2507),
    [sym_subset2_arguments] = STATE(2505),
    [sym__open_parenthesis] = STATE(1590),
    [sym__open_bracket] = STATE(1589),
    [sym__open_bracket2] = STATE(1588),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5475),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5477),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5479),
    [anon_sym_DASH] = ACTIONS(5481),
    [anon_sym_LT_DASH] = ACTIONS(5483),
    [anon_sym_LT_LT_DASH] = ACTIONS(5483),
    [anon_sym_COLON_EQ] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5485),
    [anon_sym_DASH_GT_GT] = ACTIONS(5487),
    [anon_sym_PIPE] = ACTIONS(5489),
    [anon_sym_AMP] = ACTIONS(5491),
    [anon_sym_PIPE_PIPE] = ACTIONS(5493),
    [anon_sym_AMP_AMP] = ACTIONS(5495),
    [anon_sym_LT] = ACTIONS(5497),
    [anon_sym_LT_EQ] = ACTIONS(5499),
    [anon_sym_GT] = ACTIONS(5497),
    [anon_sym_GT_EQ] = ACTIONS(5499),
    [anon_sym_EQ_EQ] = ACTIONS(5499),
    [anon_sym_BANG_EQ] = ACTIONS(5499),
    [anon_sym_STAR] = ACTIONS(5501),
    [anon_sym_SLASH] = ACTIONS(5503),
    [anon_sym_STAR_STAR] = ACTIONS(5505),
    [anon_sym_CARET] = ACTIONS(5505),
    [aux_sym_binary_operator_token1] = ACTIONS(5507),
    [anon_sym_PIPE_GT] = ACTIONS(5507),
    [anon_sym_COLON] = ACTIONS(5509),
    [anon_sym_DOLLAR] = ACTIONS(5511),
    [anon_sym_AT] = ACTIONS(5511),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5513),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5515),
    [sym__external_open_bracket2] = ACTIONS(5517),
  },
  [894] = {
    [sym_call_arguments] = STATE(2438),
    [sym_subset_arguments] = STATE(2439),
    [sym_subset2_arguments] = STATE(2440),
    [sym__open_parenthesis] = STATE(1350),
    [sym__open_bracket] = STATE(1348),
    [sym__open_bracket2] = STATE(1346),
    [sym_identifier] = ACTIONS(5451),
    [anon_sym_BSLASH] = ACTIONS(5449),
    [anon_sym_function] = ACTIONS(5451),
    [anon_sym_EQ] = ACTIONS(5353),
    [anon_sym_if] = ACTIONS(5451),
    [anon_sym_for] = ACTIONS(5451),
    [anon_sym_while] = ACTIONS(5451),
    [anon_sym_repeat] = ACTIONS(5451),
    [anon_sym_QMARK] = ACTIONS(5449),
    [anon_sym_TILDE] = ACTIONS(5355),
    [anon_sym_BANG] = ACTIONS(5451),
    [anon_sym_PLUS] = ACTIONS(5357),
    [anon_sym_DASH] = ACTIONS(5359),
    [anon_sym_LT_DASH] = ACTIONS(5361),
    [anon_sym_LT_LT_DASH] = ACTIONS(5361),
    [anon_sym_COLON_EQ] = ACTIONS(5361),
    [anon_sym_DASH_GT] = ACTIONS(5363),
    [anon_sym_DASH_GT_GT] = ACTIONS(5365),
    [anon_sym_PIPE] = ACTIONS(5367),
    [anon_sym_AMP] = ACTIONS(5369),
    [anon_sym_PIPE_PIPE] = ACTIONS(5371),
    [anon_sym_AMP_AMP] = ACTIONS(5373),
    [anon_sym_LT] = ACTIONS(5375),
    [anon_sym_LT_EQ] = ACTIONS(5377),
    [anon_sym_GT] = ACTIONS(5375),
    [anon_sym_GT_EQ] = ACTIONS(5377),
    [anon_sym_EQ_EQ] = ACTIONS(5377),
    [anon_sym_BANG_EQ] = ACTIONS(5377),
    [anon_sym_STAR] = ACTIONS(5379),
    [anon_sym_SLASH] = ACTIONS(5381),
    [anon_sym_STAR_STAR] = ACTIONS(5383),
    [anon_sym_CARET] = ACTIONS(5383),
    [aux_sym_binary_operator_token1] = ACTIONS(5385),
    [anon_sym_PIPE_GT] = ACTIONS(5385),
    [anon_sym_COLON] = ACTIONS(5387),
    [anon_sym_DOLLAR] = ACTIONS(5389),
    [anon_sym_AT] = ACTIONS(5389),
    [aux_sym__hex_literal_token1] = ACTIONS(5449),
    [sym__number_literal] = ACTIONS(5451),
    [anon_sym_SQUOTE] = ACTIONS(5449),
    [anon_sym_DQUOTE] = ACTIONS(5449),
    [sym_return] = ACTIONS(5451),
    [sym_next] = ACTIONS(5451),
    [sym_break] = ACTIONS(5451),
    [sym_true] = ACTIONS(5451),
    [sym_false] = ACTIONS(5451),
    [sym_null] = ACTIONS(5451),
    [sym_inf] = ACTIONS(5451),
    [sym_nan] = ACTIONS(5451),
    [anon_sym_NA] = ACTIONS(5451),
    [anon_sym_NA_integer_] = ACTIONS(5451),
    [anon_sym_NA_real_] = ACTIONS(5451),
    [anon_sym_NA_complex_] = ACTIONS(5451),
    [anon_sym_NA_character_] = ACTIONS(5451),
    [sym_dots] = ACTIONS(5451),
    [sym_dot_dot_i] = ACTIONS(5449),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5449),
    [sym__newline] = ACTIONS(5449),
    [sym__semicolon] = ACTIONS(5449),
    [sym__raw_string_literal] = ACTIONS(5449),
    [sym__external_else] = ACTIONS(5449),
    [sym__external_open_parenthesis] = ACTIONS(5393),
    [sym__external_open_brace] = ACTIONS(5449),
    [sym__external_close_brace] = ACTIONS(5449),
    [sym__external_open_bracket] = ACTIONS(5395),
    [sym__external_close_bracket] = ACTIONS(5449),
    [sym__external_open_bracket2] = ACTIONS(5397),
  },
  [895] = {
    [sym_call_arguments] = STATE(2509),
    [sym_subset_arguments] = STATE(2507),
    [sym_subset2_arguments] = STATE(2505),
    [sym__open_parenthesis] = STATE(1590),
    [sym__open_bracket] = STATE(1589),
    [sym__open_bracket2] = STATE(1588),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5501),
    [anon_sym_SLASH] = ACTIONS(5503),
    [anon_sym_STAR_STAR] = ACTIONS(5505),
    [anon_sym_CARET] = ACTIONS(5505),
    [aux_sym_binary_operator_token1] = ACTIONS(5507),
    [anon_sym_PIPE_GT] = ACTIONS(5507),
    [anon_sym_COLON] = ACTIONS(5509),
    [anon_sym_DOLLAR] = ACTIONS(5511),
    [anon_sym_AT] = ACTIONS(5511),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5513),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5515),
    [sym__external_open_bracket2] = ACTIONS(5517),
  },
  [896] = {
    [sym_call_arguments] = STATE(2438),
    [sym_subset_arguments] = STATE(2439),
    [sym_subset2_arguments] = STATE(2440),
    [sym__open_parenthesis] = STATE(1350),
    [sym__open_bracket] = STATE(1348),
    [sym__open_bracket2] = STATE(1346),
    [sym_identifier] = ACTIONS(5455),
    [anon_sym_BSLASH] = ACTIONS(5453),
    [anon_sym_function] = ACTIONS(5455),
    [anon_sym_EQ] = ACTIONS(5353),
    [anon_sym_if] = ACTIONS(5455),
    [anon_sym_for] = ACTIONS(5455),
    [anon_sym_while] = ACTIONS(5455),
    [anon_sym_repeat] = ACTIONS(5455),
    [anon_sym_QMARK] = ACTIONS(5453),
    [anon_sym_TILDE] = ACTIONS(5355),
    [anon_sym_BANG] = ACTIONS(5455),
    [anon_sym_PLUS] = ACTIONS(5357),
    [anon_sym_DASH] = ACTIONS(5359),
    [anon_sym_LT_DASH] = ACTIONS(5361),
    [anon_sym_LT_LT_DASH] = ACTIONS(5361),
    [anon_sym_COLON_EQ] = ACTIONS(5361),
    [anon_sym_DASH_GT] = ACTIONS(5363),
    [anon_sym_DASH_GT_GT] = ACTIONS(5365),
    [anon_sym_PIPE] = ACTIONS(5367),
    [anon_sym_AMP] = ACTIONS(5369),
    [anon_sym_PIPE_PIPE] = ACTIONS(5371),
    [anon_sym_AMP_AMP] = ACTIONS(5373),
    [anon_sym_LT] = ACTIONS(5375),
    [anon_sym_LT_EQ] = ACTIONS(5377),
    [anon_sym_GT] = ACTIONS(5375),
    [anon_sym_GT_EQ] = ACTIONS(5377),
    [anon_sym_EQ_EQ] = ACTIONS(5377),
    [anon_sym_BANG_EQ] = ACTIONS(5377),
    [anon_sym_STAR] = ACTIONS(5379),
    [anon_sym_SLASH] = ACTIONS(5381),
    [anon_sym_STAR_STAR] = ACTIONS(5383),
    [anon_sym_CARET] = ACTIONS(5383),
    [aux_sym_binary_operator_token1] = ACTIONS(5385),
    [anon_sym_PIPE_GT] = ACTIONS(5385),
    [anon_sym_COLON] = ACTIONS(5387),
    [anon_sym_DOLLAR] = ACTIONS(5389),
    [anon_sym_AT] = ACTIONS(5389),
    [aux_sym__hex_literal_token1] = ACTIONS(5453),
    [sym__number_literal] = ACTIONS(5455),
    [anon_sym_SQUOTE] = ACTIONS(5453),
    [anon_sym_DQUOTE] = ACTIONS(5453),
    [sym_return] = ACTIONS(5455),
    [sym_next] = ACTIONS(5455),
    [sym_break] = ACTIONS(5455),
    [sym_true] = ACTIONS(5455),
    [sym_false] = ACTIONS(5455),
    [sym_null] = ACTIONS(5455),
    [sym_inf] = ACTIONS(5455),
    [sym_nan] = ACTIONS(5455),
    [anon_sym_NA] = ACTIONS(5455),
    [anon_sym_NA_integer_] = ACTIONS(5455),
    [anon_sym_NA_real_] = ACTIONS(5455),
    [anon_sym_NA_complex_] = ACTIONS(5455),
    [anon_sym_NA_character_] = ACTIONS(5455),
    [sym_dots] = ACTIONS(5455),
    [sym_dot_dot_i] = ACTIONS(5453),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5453),
    [sym__newline] = ACTIONS(5453),
    [sym__semicolon] = ACTIONS(5453),
    [sym__raw_string_literal] = ACTIONS(5453),
    [sym__external_else] = ACTIONS(5453),
    [sym__external_open_parenthesis] = ACTIONS(5393),
    [sym__external_open_brace] = ACTIONS(5453),
    [sym__external_close_brace] = ACTIONS(5453),
    [sym__external_open_bracket] = ACTIONS(5395),
    [sym__external_close_bracket] = ACTIONS(5453),
    [sym__external_open_bracket2] = ACTIONS(5397),
  },
  [897] = {
    [sym_call_arguments] = STATE(2509),
    [sym_subset_arguments] = STATE(2507),
    [sym_subset2_arguments] = STATE(2505),
    [sym__open_parenthesis] = STATE(1590),
    [sym__open_bracket] = STATE(1589),
    [sym__open_bracket2] = STATE(1588),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5479),
    [anon_sym_DASH] = ACTIONS(5481),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5489),
    [anon_sym_AMP] = ACTIONS(5491),
    [anon_sym_PIPE_PIPE] = ACTIONS(5493),
    [anon_sym_AMP_AMP] = ACTIONS(5495),
    [anon_sym_LT] = ACTIONS(5497),
    [anon_sym_LT_EQ] = ACTIONS(5499),
    [anon_sym_GT] = ACTIONS(5497),
    [anon_sym_GT_EQ] = ACTIONS(5499),
    [anon_sym_EQ_EQ] = ACTIONS(5499),
    [anon_sym_BANG_EQ] = ACTIONS(5499),
    [anon_sym_STAR] = ACTIONS(5501),
    [anon_sym_SLASH] = ACTIONS(5503),
    [anon_sym_STAR_STAR] = ACTIONS(5505),
    [anon_sym_CARET] = ACTIONS(5505),
    [aux_sym_binary_operator_token1] = ACTIONS(5507),
    [anon_sym_PIPE_GT] = ACTIONS(5507),
    [anon_sym_COLON] = ACTIONS(5509),
    [anon_sym_DOLLAR] = ACTIONS(5511),
    [anon_sym_AT] = ACTIONS(5511),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5513),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5515),
    [sym__external_open_bracket2] = ACTIONS(5517),
  },
  [898] = {
    [sym_call_arguments] = STATE(2438),
    [sym_subset_arguments] = STATE(2439),
    [sym_subset2_arguments] = STATE(2440),
    [sym__open_parenthesis] = STATE(1350),
    [sym__open_bracket] = STATE(1348),
    [sym__open_bracket2] = STATE(1346),
    [sym_identifier] = ACTIONS(5411),
    [anon_sym_BSLASH] = ACTIONS(5409),
    [anon_sym_function] = ACTIONS(5411),
    [anon_sym_EQ] = ACTIONS(5353),
    [anon_sym_if] = ACTIONS(5411),
    [anon_sym_for] = ACTIONS(5411),
    [anon_sym_while] = ACTIONS(5411),
    [anon_sym_repeat] = ACTIONS(5411),
    [anon_sym_QMARK] = ACTIONS(5409),
    [anon_sym_TILDE] = ACTIONS(5355),
    [anon_sym_BANG] = ACTIONS(5411),
    [anon_sym_PLUS] = ACTIONS(5357),
    [anon_sym_DASH] = ACTIONS(5359),
    [anon_sym_LT_DASH] = ACTIONS(5361),
    [anon_sym_LT_LT_DASH] = ACTIONS(5361),
    [anon_sym_COLON_EQ] = ACTIONS(5361),
    [anon_sym_DASH_GT] = ACTIONS(5363),
    [anon_sym_DASH_GT_GT] = ACTIONS(5365),
    [anon_sym_PIPE] = ACTIONS(5367),
    [anon_sym_AMP] = ACTIONS(5369),
    [anon_sym_PIPE_PIPE] = ACTIONS(5371),
    [anon_sym_AMP_AMP] = ACTIONS(5373),
    [anon_sym_LT] = ACTIONS(5375),
    [anon_sym_LT_EQ] = ACTIONS(5377),
    [anon_sym_GT] = ACTIONS(5375),
    [anon_sym_GT_EQ] = ACTIONS(5377),
    [anon_sym_EQ_EQ] = ACTIONS(5377),
    [anon_sym_BANG_EQ] = ACTIONS(5377),
    [anon_sym_STAR] = ACTIONS(5379),
    [anon_sym_SLASH] = ACTIONS(5381),
    [anon_sym_STAR_STAR] = ACTIONS(5383),
    [anon_sym_CARET] = ACTIONS(5383),
    [aux_sym_binary_operator_token1] = ACTIONS(5385),
    [anon_sym_PIPE_GT] = ACTIONS(5385),
    [anon_sym_COLON] = ACTIONS(5387),
    [anon_sym_DOLLAR] = ACTIONS(5389),
    [anon_sym_AT] = ACTIONS(5389),
    [aux_sym__hex_literal_token1] = ACTIONS(5409),
    [sym__number_literal] = ACTIONS(5411),
    [anon_sym_SQUOTE] = ACTIONS(5409),
    [anon_sym_DQUOTE] = ACTIONS(5409),
    [sym_return] = ACTIONS(5411),
    [sym_next] = ACTIONS(5411),
    [sym_break] = ACTIONS(5411),
    [sym_true] = ACTIONS(5411),
    [sym_false] = ACTIONS(5411),
    [sym_null] = ACTIONS(5411),
    [sym_inf] = ACTIONS(5411),
    [sym_nan] = ACTIONS(5411),
    [anon_sym_NA] = ACTIONS(5411),
    [anon_sym_NA_integer_] = ACTIONS(5411),
    [anon_sym_NA_real_] = ACTIONS(5411),
    [anon_sym_NA_complex_] = ACTIONS(5411),
    [anon_sym_NA_character_] = ACTIONS(5411),
    [sym_dots] = ACTIONS(5411),
    [sym_dot_dot_i] = ACTIONS(5409),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5409),
    [sym__newline] = ACTIONS(5409),
    [sym__semicolon] = ACTIONS(5409),
    [sym__raw_string_literal] = ACTIONS(5409),
    [sym__external_else] = ACTIONS(5409),
    [sym__external_open_parenthesis] = ACTIONS(5393),
    [sym__external_open_brace] = ACTIONS(5409),
    [sym__external_close_brace] = ACTIONS(5409),
    [sym__external_open_bracket] = ACTIONS(5395),
    [sym__external_close_bracket] = ACTIONS(5409),
    [sym__external_open_bracket2] = ACTIONS(5397),
  },
  [899] = {
    [sym_call_arguments] = STATE(2509),
    [sym_subset_arguments] = STATE(2507),
    [sym_subset2_arguments] = STATE(2505),
    [sym__open_parenthesis] = STATE(1590),
    [sym__open_bracket] = STATE(1589),
    [sym__open_bracket2] = STATE(1588),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5475),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5477),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5479),
    [anon_sym_DASH] = ACTIONS(5481),
    [anon_sym_LT_DASH] = ACTIONS(5483),
    [anon_sym_LT_LT_DASH] = ACTIONS(5483),
    [anon_sym_COLON_EQ] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5485),
    [anon_sym_DASH_GT_GT] = ACTIONS(5487),
    [anon_sym_PIPE] = ACTIONS(5489),
    [anon_sym_AMP] = ACTIONS(5491),
    [anon_sym_PIPE_PIPE] = ACTIONS(5493),
    [anon_sym_AMP_AMP] = ACTIONS(5495),
    [anon_sym_LT] = ACTIONS(5497),
    [anon_sym_LT_EQ] = ACTIONS(5499),
    [anon_sym_GT] = ACTIONS(5497),
    [anon_sym_GT_EQ] = ACTIONS(5499),
    [anon_sym_EQ_EQ] = ACTIONS(5499),
    [anon_sym_BANG_EQ] = ACTIONS(5499),
    [anon_sym_STAR] = ACTIONS(5501),
    [anon_sym_SLASH] = ACTIONS(5503),
    [anon_sym_STAR_STAR] = ACTIONS(5505),
    [anon_sym_CARET] = ACTIONS(5505),
    [aux_sym_binary_operator_token1] = ACTIONS(5507),
    [anon_sym_PIPE_GT] = ACTIONS(5507),
    [anon_sym_COLON] = ACTIONS(5509),
    [anon_sym_DOLLAR] = ACTIONS(5511),
    [anon_sym_AT] = ACTIONS(5511),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5513),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5515),
    [sym__external_open_bracket2] = ACTIONS(5517),
  },
  [900] = {
    [sym_call_arguments] = STATE(2509),
    [sym_subset_arguments] = STATE(2507),
    [sym_subset2_arguments] = STATE(2505),
    [sym__open_parenthesis] = STATE(1590),
    [sym__open_bracket] = STATE(1589),
    [sym__open_bracket2] = STATE(1588),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5475),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5477),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5479),
    [anon_sym_DASH] = ACTIONS(5481),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5485),
    [anon_sym_DASH_GT_GT] = ACTIONS(5487),
    [anon_sym_PIPE] = ACTIONS(5489),
    [anon_sym_AMP] = ACTIONS(5491),
    [anon_sym_PIPE_PIPE] = ACTIONS(5493),
    [anon_sym_AMP_AMP] = ACTIONS(5495),
    [anon_sym_LT] = ACTIONS(5497),
    [anon_sym_LT_EQ] = ACTIONS(5499),
    [anon_sym_GT] = ACTIONS(5497),
    [anon_sym_GT_EQ] = ACTIONS(5499),
    [anon_sym_EQ_EQ] = ACTIONS(5499),
    [anon_sym_BANG_EQ] = ACTIONS(5499),
    [anon_sym_STAR] = ACTIONS(5501),
    [anon_sym_SLASH] = ACTIONS(5503),
    [anon_sym_STAR_STAR] = ACTIONS(5505),
    [anon_sym_CARET] = ACTIONS(5505),
    [aux_sym_binary_operator_token1] = ACTIONS(5507),
    [anon_sym_PIPE_GT] = ACTIONS(5507),
    [anon_sym_COLON] = ACTIONS(5509),
    [anon_sym_DOLLAR] = ACTIONS(5511),
    [anon_sym_AT] = ACTIONS(5511),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5513),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5515),
    [sym__external_open_bracket2] = ACTIONS(5517),
  },
  [901] = {
    [sym_call_arguments] = STATE(2509),
    [sym_subset_arguments] = STATE(2507),
    [sym_subset2_arguments] = STATE(2505),
    [sym__open_parenthesis] = STATE(1590),
    [sym__open_bracket] = STATE(1589),
    [sym__open_bracket2] = STATE(1588),
    [ts_builtin_sym_end] = ACTIONS(5345),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5345),
    [anon_sym_DASH] = ACTIONS(5347),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5347),
    [anon_sym_AMP] = ACTIONS(5347),
    [anon_sym_PIPE_PIPE] = ACTIONS(5345),
    [anon_sym_AMP_AMP] = ACTIONS(5345),
    [anon_sym_LT] = ACTIONS(5347),
    [anon_sym_LT_EQ] = ACTIONS(5345),
    [anon_sym_GT] = ACTIONS(5347),
    [anon_sym_GT_EQ] = ACTIONS(5345),
    [anon_sym_EQ_EQ] = ACTIONS(5345),
    [anon_sym_BANG_EQ] = ACTIONS(5345),
    [anon_sym_STAR] = ACTIONS(5347),
    [anon_sym_SLASH] = ACTIONS(5345),
    [anon_sym_STAR_STAR] = ACTIONS(5505),
    [anon_sym_CARET] = ACTIONS(5505),
    [aux_sym_binary_operator_token1] = ACTIONS(5345),
    [anon_sym_PIPE_GT] = ACTIONS(5345),
    [anon_sym_COLON] = ACTIONS(5347),
    [anon_sym_DOLLAR] = ACTIONS(5511),
    [anon_sym_AT] = ACTIONS(5511),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__semicolon] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(5513),
    [sym__external_close_parenthesis] = ACTIONS(5345),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_close_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(5515),
    [sym__external_open_bracket2] = ACTIONS(5517),
  },
  [902] = {
    [sym_call_arguments] = STATE(2509),
    [sym_subset_arguments] = STATE(2507),
    [sym_subset2_arguments] = STATE(2505),
    [sym__open_parenthesis] = STATE(1590),
    [sym__open_bracket] = STATE(1589),
    [sym__open_bracket2] = STATE(1588),
    [ts_builtin_sym_end] = ACTIONS(5345),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5479),
    [anon_sym_DASH] = ACTIONS(5481),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5347),
    [anon_sym_AMP] = ACTIONS(5347),
    [anon_sym_PIPE_PIPE] = ACTIONS(5345),
    [anon_sym_AMP_AMP] = ACTIONS(5345),
    [anon_sym_LT] = ACTIONS(5497),
    [anon_sym_LT_EQ] = ACTIONS(5499),
    [anon_sym_GT] = ACTIONS(5497),
    [anon_sym_GT_EQ] = ACTIONS(5499),
    [anon_sym_EQ_EQ] = ACTIONS(5499),
    [anon_sym_BANG_EQ] = ACTIONS(5499),
    [anon_sym_STAR] = ACTIONS(5501),
    [anon_sym_SLASH] = ACTIONS(5503),
    [anon_sym_STAR_STAR] = ACTIONS(5505),
    [anon_sym_CARET] = ACTIONS(5505),
    [aux_sym_binary_operator_token1] = ACTIONS(5507),
    [anon_sym_PIPE_GT] = ACTIONS(5507),
    [anon_sym_COLON] = ACTIONS(5509),
    [anon_sym_DOLLAR] = ACTIONS(5511),
    [anon_sym_AT] = ACTIONS(5511),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__semicolon] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(5513),
    [sym__external_close_parenthesis] = ACTIONS(5345),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_close_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(5515),
    [sym__external_open_bracket2] = ACTIONS(5517),
  },
  [903] = {
    [sym_string] = STATE(2352),
    [sym__single_quoted_string] = STATE(1923),
    [sym__double_quoted_string] = STATE(1934),
    [sym__string_or_identifier] = STATE(2352),
    [aux_sym_function_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(5869),
    [anon_sym_BSLASH] = ACTIONS(5669),
    [anon_sym_function] = ACTIONS(5673),
    [anon_sym_EQ] = ACTIONS(5673),
    [anon_sym_if] = ACTIONS(5673),
    [anon_sym_for] = ACTIONS(5673),
    [anon_sym_while] = ACTIONS(5673),
    [anon_sym_repeat] = ACTIONS(5673),
    [anon_sym_QMARK] = ACTIONS(5669),
    [anon_sym_TILDE] = ACTIONS(5669),
    [anon_sym_BANG] = ACTIONS(5673),
    [anon_sym_PLUS] = ACTIONS(5669),
    [anon_sym_DASH] = ACTIONS(5673),
    [anon_sym_LT_DASH] = ACTIONS(5669),
    [anon_sym_LT_LT_DASH] = ACTIONS(5669),
    [anon_sym_COLON_EQ] = ACTIONS(5669),
    [anon_sym_DASH_GT] = ACTIONS(5673),
    [anon_sym_DASH_GT_GT] = ACTIONS(5669),
    [anon_sym_PIPE] = ACTIONS(5673),
    [anon_sym_AMP] = ACTIONS(5673),
    [anon_sym_PIPE_PIPE] = ACTIONS(5669),
    [anon_sym_AMP_AMP] = ACTIONS(5669),
    [anon_sym_LT] = ACTIONS(5673),
    [anon_sym_LT_EQ] = ACTIONS(5669),
    [anon_sym_GT] = ACTIONS(5673),
    [anon_sym_GT_EQ] = ACTIONS(5669),
    [anon_sym_EQ_EQ] = ACTIONS(5669),
    [anon_sym_BANG_EQ] = ACTIONS(5669),
    [anon_sym_STAR] = ACTIONS(5673),
    [anon_sym_SLASH] = ACTIONS(5669),
    [anon_sym_STAR_STAR] = ACTIONS(5669),
    [anon_sym_CARET] = ACTIONS(5669),
    [aux_sym_binary_operator_token1] = ACTIONS(5669),
    [anon_sym_PIPE_GT] = ACTIONS(5669),
    [anon_sym_COLON] = ACTIONS(5673),
    [anon_sym_DOLLAR] = ACTIONS(5669),
    [anon_sym_AT] = ACTIONS(5669),
    [aux_sym__hex_literal_token1] = ACTIONS(5669),
    [sym__number_literal] = ACTIONS(5673),
    [anon_sym_SQUOTE] = ACTIONS(189),
    [anon_sym_DQUOTE] = ACTIONS(191),
    [sym_return] = ACTIONS(5673),
    [sym_next] = ACTIONS(5673),
    [sym_break] = ACTIONS(5673),
    [sym_true] = ACTIONS(5673),
    [sym_false] = ACTIONS(5673),
    [sym_null] = ACTIONS(5673),
    [sym_inf] = ACTIONS(5673),
    [sym_nan] = ACTIONS(5673),
    [anon_sym_NA] = ACTIONS(5673),
    [anon_sym_NA_integer_] = ACTIONS(5673),
    [anon_sym_NA_real_] = ACTIONS(5673),
    [anon_sym_NA_complex_] = ACTIONS(5673),
    [anon_sym_NA_character_] = ACTIONS(5673),
    [sym_dots] = ACTIONS(5673),
    [sym_dot_dot_i] = ACTIONS(5669),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5669),
    [sym__newline] = ACTIONS(5669),
    [sym__semicolon] = ACTIONS(5669),
    [sym__raw_string_literal] = ACTIONS(201),
    [sym__external_else] = ACTIONS(5669),
    [sym__external_open_parenthesis] = ACTIONS(5669),
    [sym__external_close_parenthesis] = ACTIONS(5669),
    [sym__external_open_brace] = ACTIONS(5669),
    [sym__external_close_brace] = ACTIONS(5669),
    [sym__external_open_bracket] = ACTIONS(5669),
    [sym__external_open_bracket2] = ACTIONS(5669),
    [sym__external_close_bracket2] = ACTIONS(5669),
  },
  [904] = {
    [sym_call_arguments] = STATE(2509),
    [sym_subset_arguments] = STATE(2507),
    [sym_subset2_arguments] = STATE(2505),
    [sym__open_parenthesis] = STATE(1590),
    [sym__open_bracket] = STATE(1589),
    [sym__open_bracket2] = STATE(1588),
    [ts_builtin_sym_end] = ACTIONS(5345),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5479),
    [anon_sym_DASH] = ACTIONS(5481),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5489),
    [anon_sym_AMP] = ACTIONS(5491),
    [anon_sym_PIPE_PIPE] = ACTIONS(5493),
    [anon_sym_AMP_AMP] = ACTIONS(5495),
    [anon_sym_LT] = ACTIONS(5497),
    [anon_sym_LT_EQ] = ACTIONS(5499),
    [anon_sym_GT] = ACTIONS(5497),
    [anon_sym_GT_EQ] = ACTIONS(5499),
    [anon_sym_EQ_EQ] = ACTIONS(5499),
    [anon_sym_BANG_EQ] = ACTIONS(5499),
    [anon_sym_STAR] = ACTIONS(5501),
    [anon_sym_SLASH] = ACTIONS(5503),
    [anon_sym_STAR_STAR] = ACTIONS(5505),
    [anon_sym_CARET] = ACTIONS(5505),
    [aux_sym_binary_operator_token1] = ACTIONS(5507),
    [anon_sym_PIPE_GT] = ACTIONS(5507),
    [anon_sym_COLON] = ACTIONS(5509),
    [anon_sym_DOLLAR] = ACTIONS(5511),
    [anon_sym_AT] = ACTIONS(5511),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__semicolon] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(5513),
    [sym__external_close_parenthesis] = ACTIONS(5345),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_close_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(5515),
    [sym__external_open_bracket2] = ACTIONS(5517),
  },
  [905] = {
    [sym_call_arguments] = STATE(2509),
    [sym_subset_arguments] = STATE(2507),
    [sym_subset2_arguments] = STATE(2505),
    [sym__open_parenthesis] = STATE(1590),
    [sym__open_bracket] = STATE(1589),
    [sym__open_bracket2] = STATE(1588),
    [ts_builtin_sym_end] = ACTIONS(5345),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5475),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5477),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5479),
    [anon_sym_DASH] = ACTIONS(5481),
    [anon_sym_LT_DASH] = ACTIONS(5483),
    [anon_sym_LT_LT_DASH] = ACTIONS(5483),
    [anon_sym_COLON_EQ] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5485),
    [anon_sym_DASH_GT_GT] = ACTIONS(5487),
    [anon_sym_PIPE] = ACTIONS(5489),
    [anon_sym_AMP] = ACTIONS(5491),
    [anon_sym_PIPE_PIPE] = ACTIONS(5493),
    [anon_sym_AMP_AMP] = ACTIONS(5495),
    [anon_sym_LT] = ACTIONS(5497),
    [anon_sym_LT_EQ] = ACTIONS(5499),
    [anon_sym_GT] = ACTIONS(5497),
    [anon_sym_GT_EQ] = ACTIONS(5499),
    [anon_sym_EQ_EQ] = ACTIONS(5499),
    [anon_sym_BANG_EQ] = ACTIONS(5499),
    [anon_sym_STAR] = ACTIONS(5501),
    [anon_sym_SLASH] = ACTIONS(5503),
    [anon_sym_STAR_STAR] = ACTIONS(5505),
    [anon_sym_CARET] = ACTIONS(5505),
    [aux_sym_binary_operator_token1] = ACTIONS(5507),
    [anon_sym_PIPE_GT] = ACTIONS(5507),
    [anon_sym_COLON] = ACTIONS(5509),
    [anon_sym_DOLLAR] = ACTIONS(5511),
    [anon_sym_AT] = ACTIONS(5511),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__semicolon] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(5513),
    [sym__external_close_parenthesis] = ACTIONS(5345),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_close_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(5515),
    [sym__external_open_bracket2] = ACTIONS(5517),
  },
  [906] = {
    [sym_call_arguments] = STATE(2509),
    [sym_subset_arguments] = STATE(2507),
    [sym_subset2_arguments] = STATE(2505),
    [sym__open_parenthesis] = STATE(1590),
    [sym__open_bracket] = STATE(1589),
    [sym__open_bracket2] = STATE(1588),
    [ts_builtin_sym_end] = ACTIONS(5341),
    [sym_identifier] = ACTIONS(5343),
    [anon_sym_BSLASH] = ACTIONS(5341),
    [anon_sym_function] = ACTIONS(5343),
    [anon_sym_EQ] = ACTIONS(5475),
    [anon_sym_if] = ACTIONS(5343),
    [anon_sym_for] = ACTIONS(5343),
    [anon_sym_while] = ACTIONS(5343),
    [anon_sym_repeat] = ACTIONS(5343),
    [anon_sym_QMARK] = ACTIONS(5341),
    [anon_sym_TILDE] = ACTIONS(5477),
    [anon_sym_BANG] = ACTIONS(5343),
    [anon_sym_PLUS] = ACTIONS(5479),
    [anon_sym_DASH] = ACTIONS(5481),
    [anon_sym_LT_DASH] = ACTIONS(5483),
    [anon_sym_LT_LT_DASH] = ACTIONS(5483),
    [anon_sym_COLON_EQ] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5485),
    [anon_sym_DASH_GT_GT] = ACTIONS(5487),
    [anon_sym_PIPE] = ACTIONS(5489),
    [anon_sym_AMP] = ACTIONS(5491),
    [anon_sym_PIPE_PIPE] = ACTIONS(5493),
    [anon_sym_AMP_AMP] = ACTIONS(5495),
    [anon_sym_LT] = ACTIONS(5497),
    [anon_sym_LT_EQ] = ACTIONS(5499),
    [anon_sym_GT] = ACTIONS(5497),
    [anon_sym_GT_EQ] = ACTIONS(5499),
    [anon_sym_EQ_EQ] = ACTIONS(5499),
    [anon_sym_BANG_EQ] = ACTIONS(5499),
    [anon_sym_STAR] = ACTIONS(5501),
    [anon_sym_SLASH] = ACTIONS(5503),
    [anon_sym_STAR_STAR] = ACTIONS(5505),
    [anon_sym_CARET] = ACTIONS(5505),
    [aux_sym_binary_operator_token1] = ACTIONS(5507),
    [anon_sym_PIPE_GT] = ACTIONS(5507),
    [anon_sym_COLON] = ACTIONS(5509),
    [anon_sym_DOLLAR] = ACTIONS(5511),
    [anon_sym_AT] = ACTIONS(5511),
    [aux_sym__hex_literal_token1] = ACTIONS(5341),
    [sym__number_literal] = ACTIONS(5343),
    [anon_sym_SQUOTE] = ACTIONS(5341),
    [anon_sym_DQUOTE] = ACTIONS(5341),
    [sym_return] = ACTIONS(5343),
    [sym_next] = ACTIONS(5343),
    [sym_break] = ACTIONS(5343),
    [sym_true] = ACTIONS(5343),
    [sym_false] = ACTIONS(5343),
    [sym_null] = ACTIONS(5343),
    [sym_inf] = ACTIONS(5343),
    [sym_nan] = ACTIONS(5343),
    [anon_sym_NA] = ACTIONS(5343),
    [anon_sym_NA_integer_] = ACTIONS(5343),
    [anon_sym_NA_real_] = ACTIONS(5343),
    [anon_sym_NA_complex_] = ACTIONS(5343),
    [anon_sym_NA_character_] = ACTIONS(5343),
    [sym_dots] = ACTIONS(5343),
    [sym_dot_dot_i] = ACTIONS(5341),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5341),
    [sym__newline] = ACTIONS(5341),
    [sym__semicolon] = ACTIONS(5341),
    [sym__raw_string_literal] = ACTIONS(5341),
    [sym__external_open_parenthesis] = ACTIONS(5513),
    [sym__external_close_parenthesis] = ACTIONS(5341),
    [sym__external_open_brace] = ACTIONS(5341),
    [sym__external_close_brace] = ACTIONS(5341),
    [sym__external_open_bracket] = ACTIONS(5515),
    [sym__external_open_bracket2] = ACTIONS(5517),
  },
  [907] = {
    [sym_call_arguments] = STATE(2509),
    [sym_subset_arguments] = STATE(2507),
    [sym_subset2_arguments] = STATE(2505),
    [sym__open_parenthesis] = STATE(1590),
    [sym__open_bracket] = STATE(1589),
    [sym__open_bracket2] = STATE(1588),
    [ts_builtin_sym_end] = ACTIONS(5337),
    [sym_identifier] = ACTIONS(5339),
    [anon_sym_BSLASH] = ACTIONS(5337),
    [anon_sym_function] = ACTIONS(5339),
    [anon_sym_EQ] = ACTIONS(5475),
    [anon_sym_if] = ACTIONS(5339),
    [anon_sym_for] = ACTIONS(5339),
    [anon_sym_while] = ACTIONS(5339),
    [anon_sym_repeat] = ACTIONS(5339),
    [anon_sym_QMARK] = ACTIONS(5337),
    [anon_sym_TILDE] = ACTIONS(5477),
    [anon_sym_BANG] = ACTIONS(5339),
    [anon_sym_PLUS] = ACTIONS(5479),
    [anon_sym_DASH] = ACTIONS(5481),
    [anon_sym_LT_DASH] = ACTIONS(5483),
    [anon_sym_LT_LT_DASH] = ACTIONS(5483),
    [anon_sym_COLON_EQ] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5485),
    [anon_sym_DASH_GT_GT] = ACTIONS(5487),
    [anon_sym_PIPE] = ACTIONS(5489),
    [anon_sym_AMP] = ACTIONS(5491),
    [anon_sym_PIPE_PIPE] = ACTIONS(5493),
    [anon_sym_AMP_AMP] = ACTIONS(5495),
    [anon_sym_LT] = ACTIONS(5497),
    [anon_sym_LT_EQ] = ACTIONS(5499),
    [anon_sym_GT] = ACTIONS(5497),
    [anon_sym_GT_EQ] = ACTIONS(5499),
    [anon_sym_EQ_EQ] = ACTIONS(5499),
    [anon_sym_BANG_EQ] = ACTIONS(5499),
    [anon_sym_STAR] = ACTIONS(5501),
    [anon_sym_SLASH] = ACTIONS(5503),
    [anon_sym_STAR_STAR] = ACTIONS(5505),
    [anon_sym_CARET] = ACTIONS(5505),
    [aux_sym_binary_operator_token1] = ACTIONS(5507),
    [anon_sym_PIPE_GT] = ACTIONS(5507),
    [anon_sym_COLON] = ACTIONS(5509),
    [anon_sym_DOLLAR] = ACTIONS(5511),
    [anon_sym_AT] = ACTIONS(5511),
    [aux_sym__hex_literal_token1] = ACTIONS(5337),
    [sym__number_literal] = ACTIONS(5339),
    [anon_sym_SQUOTE] = ACTIONS(5337),
    [anon_sym_DQUOTE] = ACTIONS(5337),
    [sym_return] = ACTIONS(5339),
    [sym_next] = ACTIONS(5339),
    [sym_break] = ACTIONS(5339),
    [sym_true] = ACTIONS(5339),
    [sym_false] = ACTIONS(5339),
    [sym_null] = ACTIONS(5339),
    [sym_inf] = ACTIONS(5339),
    [sym_nan] = ACTIONS(5339),
    [anon_sym_NA] = ACTIONS(5339),
    [anon_sym_NA_integer_] = ACTIONS(5339),
    [anon_sym_NA_real_] = ACTIONS(5339),
    [anon_sym_NA_complex_] = ACTIONS(5339),
    [anon_sym_NA_character_] = ACTIONS(5339),
    [sym_dots] = ACTIONS(5339),
    [sym_dot_dot_i] = ACTIONS(5337),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5337),
    [sym__newline] = ACTIONS(5337),
    [sym__semicolon] = ACTIONS(5337),
    [sym__raw_string_literal] = ACTIONS(5337),
    [sym__external_open_parenthesis] = ACTIONS(5513),
    [sym__external_close_parenthesis] = ACTIONS(5337),
    [sym__external_open_brace] = ACTIONS(5337),
    [sym__external_close_brace] = ACTIONS(5337),
    [sym__external_open_bracket] = ACTIONS(5515),
    [sym__external_open_bracket2] = ACTIONS(5517),
  },
  [908] = {
    [sym_call_arguments] = STATE(2509),
    [sym_subset_arguments] = STATE(2507),
    [sym_subset2_arguments] = STATE(2505),
    [sym__open_parenthesis] = STATE(1590),
    [sym__open_bracket] = STATE(1589),
    [sym__open_bracket2] = STATE(1588),
    [ts_builtin_sym_end] = ACTIONS(5333),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(5333),
    [anon_sym_DASH] = ACTIONS(5335),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5335),
    [anon_sym_AMP] = ACTIONS(5335),
    [anon_sym_PIPE_PIPE] = ACTIONS(5333),
    [anon_sym_AMP_AMP] = ACTIONS(5333),
    [anon_sym_LT] = ACTIONS(5335),
    [anon_sym_LT_EQ] = ACTIONS(5333),
    [anon_sym_GT] = ACTIONS(5335),
    [anon_sym_GT_EQ] = ACTIONS(5333),
    [anon_sym_EQ_EQ] = ACTIONS(5333),
    [anon_sym_BANG_EQ] = ACTIONS(5333),
    [anon_sym_STAR] = ACTIONS(5335),
    [anon_sym_SLASH] = ACTIONS(5333),
    [anon_sym_STAR_STAR] = ACTIONS(5505),
    [anon_sym_CARET] = ACTIONS(5505),
    [aux_sym_binary_operator_token1] = ACTIONS(5333),
    [anon_sym_PIPE_GT] = ACTIONS(5333),
    [anon_sym_COLON] = ACTIONS(5335),
    [anon_sym_DOLLAR] = ACTIONS(5511),
    [anon_sym_AT] = ACTIONS(5511),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__semicolon] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(5513),
    [sym__external_close_parenthesis] = ACTIONS(5333),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_close_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(5515),
    [sym__external_open_bracket2] = ACTIONS(5517),
  },
  [909] = {
    [sym_call_arguments] = STATE(2509),
    [sym_subset_arguments] = STATE(2507),
    [sym_subset2_arguments] = STATE(2505),
    [sym__open_parenthesis] = STATE(1590),
    [sym__open_bracket] = STATE(1589),
    [sym__open_bracket2] = STATE(1588),
    [ts_builtin_sym_end] = ACTIONS(5333),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(5479),
    [anon_sym_DASH] = ACTIONS(5481),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5335),
    [anon_sym_AMP] = ACTIONS(5335),
    [anon_sym_PIPE_PIPE] = ACTIONS(5333),
    [anon_sym_AMP_AMP] = ACTIONS(5333),
    [anon_sym_LT] = ACTIONS(5497),
    [anon_sym_LT_EQ] = ACTIONS(5499),
    [anon_sym_GT] = ACTIONS(5497),
    [anon_sym_GT_EQ] = ACTIONS(5499),
    [anon_sym_EQ_EQ] = ACTIONS(5499),
    [anon_sym_BANG_EQ] = ACTIONS(5499),
    [anon_sym_STAR] = ACTIONS(5501),
    [anon_sym_SLASH] = ACTIONS(5503),
    [anon_sym_STAR_STAR] = ACTIONS(5505),
    [anon_sym_CARET] = ACTIONS(5505),
    [aux_sym_binary_operator_token1] = ACTIONS(5507),
    [anon_sym_PIPE_GT] = ACTIONS(5507),
    [anon_sym_COLON] = ACTIONS(5509),
    [anon_sym_DOLLAR] = ACTIONS(5511),
    [anon_sym_AT] = ACTIONS(5511),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__semicolon] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(5513),
    [sym__external_close_parenthesis] = ACTIONS(5333),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_close_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(5515),
    [sym__external_open_bracket2] = ACTIONS(5517),
  },
  [910] = {
    [sym_call_arguments] = STATE(2509),
    [sym_subset_arguments] = STATE(2507),
    [sym_subset2_arguments] = STATE(2505),
    [sym__open_parenthesis] = STATE(1590),
    [sym__open_bracket] = STATE(1589),
    [sym__open_bracket2] = STATE(1588),
    [ts_builtin_sym_end] = ACTIONS(5333),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(5479),
    [anon_sym_DASH] = ACTIONS(5481),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5489),
    [anon_sym_AMP] = ACTIONS(5491),
    [anon_sym_PIPE_PIPE] = ACTIONS(5493),
    [anon_sym_AMP_AMP] = ACTIONS(5495),
    [anon_sym_LT] = ACTIONS(5497),
    [anon_sym_LT_EQ] = ACTIONS(5499),
    [anon_sym_GT] = ACTIONS(5497),
    [anon_sym_GT_EQ] = ACTIONS(5499),
    [anon_sym_EQ_EQ] = ACTIONS(5499),
    [anon_sym_BANG_EQ] = ACTIONS(5499),
    [anon_sym_STAR] = ACTIONS(5501),
    [anon_sym_SLASH] = ACTIONS(5503),
    [anon_sym_STAR_STAR] = ACTIONS(5505),
    [anon_sym_CARET] = ACTIONS(5505),
    [aux_sym_binary_operator_token1] = ACTIONS(5507),
    [anon_sym_PIPE_GT] = ACTIONS(5507),
    [anon_sym_COLON] = ACTIONS(5509),
    [anon_sym_DOLLAR] = ACTIONS(5511),
    [anon_sym_AT] = ACTIONS(5511),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__semicolon] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(5513),
    [sym__external_close_parenthesis] = ACTIONS(5333),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_close_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(5515),
    [sym__external_open_bracket2] = ACTIONS(5517),
  },
  [911] = {
    [sym_call_arguments] = STATE(2509),
    [sym_subset_arguments] = STATE(2507),
    [sym_subset2_arguments] = STATE(2505),
    [sym__open_parenthesis] = STATE(1590),
    [sym__open_bracket] = STATE(1589),
    [sym__open_bracket2] = STATE(1588),
    [ts_builtin_sym_end] = ACTIONS(5333),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5475),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5477),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(5479),
    [anon_sym_DASH] = ACTIONS(5481),
    [anon_sym_LT_DASH] = ACTIONS(5483),
    [anon_sym_LT_LT_DASH] = ACTIONS(5483),
    [anon_sym_COLON_EQ] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5485),
    [anon_sym_DASH_GT_GT] = ACTIONS(5487),
    [anon_sym_PIPE] = ACTIONS(5489),
    [anon_sym_AMP] = ACTIONS(5491),
    [anon_sym_PIPE_PIPE] = ACTIONS(5493),
    [anon_sym_AMP_AMP] = ACTIONS(5495),
    [anon_sym_LT] = ACTIONS(5497),
    [anon_sym_LT_EQ] = ACTIONS(5499),
    [anon_sym_GT] = ACTIONS(5497),
    [anon_sym_GT_EQ] = ACTIONS(5499),
    [anon_sym_EQ_EQ] = ACTIONS(5499),
    [anon_sym_BANG_EQ] = ACTIONS(5499),
    [anon_sym_STAR] = ACTIONS(5501),
    [anon_sym_SLASH] = ACTIONS(5503),
    [anon_sym_STAR_STAR] = ACTIONS(5505),
    [anon_sym_CARET] = ACTIONS(5505),
    [aux_sym_binary_operator_token1] = ACTIONS(5507),
    [anon_sym_PIPE_GT] = ACTIONS(5507),
    [anon_sym_COLON] = ACTIONS(5509),
    [anon_sym_DOLLAR] = ACTIONS(5511),
    [anon_sym_AT] = ACTIONS(5511),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__semicolon] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(5513),
    [sym__external_close_parenthesis] = ACTIONS(5333),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_close_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(5515),
    [sym__external_open_bracket2] = ACTIONS(5517),
  },
  [912] = {
    [sym_call_arguments] = STATE(2509),
    [sym_subset_arguments] = STATE(2507),
    [sym_subset2_arguments] = STATE(2505),
    [sym__open_parenthesis] = STATE(1590),
    [sym__open_bracket] = STATE(1589),
    [sym__open_bracket2] = STATE(1588),
    [ts_builtin_sym_end] = ACTIONS(5329),
    [sym_identifier] = ACTIONS(5331),
    [anon_sym_BSLASH] = ACTIONS(5329),
    [anon_sym_function] = ACTIONS(5331),
    [anon_sym_EQ] = ACTIONS(5475),
    [anon_sym_if] = ACTIONS(5331),
    [anon_sym_for] = ACTIONS(5331),
    [anon_sym_while] = ACTIONS(5331),
    [anon_sym_repeat] = ACTIONS(5331),
    [anon_sym_QMARK] = ACTIONS(5329),
    [anon_sym_TILDE] = ACTIONS(5477),
    [anon_sym_BANG] = ACTIONS(5331),
    [anon_sym_PLUS] = ACTIONS(5479),
    [anon_sym_DASH] = ACTIONS(5481),
    [anon_sym_LT_DASH] = ACTIONS(5483),
    [anon_sym_LT_LT_DASH] = ACTIONS(5483),
    [anon_sym_COLON_EQ] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5485),
    [anon_sym_DASH_GT_GT] = ACTIONS(5487),
    [anon_sym_PIPE] = ACTIONS(5489),
    [anon_sym_AMP] = ACTIONS(5491),
    [anon_sym_PIPE_PIPE] = ACTIONS(5493),
    [anon_sym_AMP_AMP] = ACTIONS(5495),
    [anon_sym_LT] = ACTIONS(5497),
    [anon_sym_LT_EQ] = ACTIONS(5499),
    [anon_sym_GT] = ACTIONS(5497),
    [anon_sym_GT_EQ] = ACTIONS(5499),
    [anon_sym_EQ_EQ] = ACTIONS(5499),
    [anon_sym_BANG_EQ] = ACTIONS(5499),
    [anon_sym_STAR] = ACTIONS(5501),
    [anon_sym_SLASH] = ACTIONS(5503),
    [anon_sym_STAR_STAR] = ACTIONS(5505),
    [anon_sym_CARET] = ACTIONS(5505),
    [aux_sym_binary_operator_token1] = ACTIONS(5507),
    [anon_sym_PIPE_GT] = ACTIONS(5507),
    [anon_sym_COLON] = ACTIONS(5509),
    [anon_sym_DOLLAR] = ACTIONS(5511),
    [anon_sym_AT] = ACTIONS(5511),
    [aux_sym__hex_literal_token1] = ACTIONS(5329),
    [sym__number_literal] = ACTIONS(5331),
    [anon_sym_SQUOTE] = ACTIONS(5329),
    [anon_sym_DQUOTE] = ACTIONS(5329),
    [sym_return] = ACTIONS(5331),
    [sym_next] = ACTIONS(5331),
    [sym_break] = ACTIONS(5331),
    [sym_true] = ACTIONS(5331),
    [sym_false] = ACTIONS(5331),
    [sym_null] = ACTIONS(5331),
    [sym_inf] = ACTIONS(5331),
    [sym_nan] = ACTIONS(5331),
    [anon_sym_NA] = ACTIONS(5331),
    [anon_sym_NA_integer_] = ACTIONS(5331),
    [anon_sym_NA_real_] = ACTIONS(5331),
    [anon_sym_NA_complex_] = ACTIONS(5331),
    [anon_sym_NA_character_] = ACTIONS(5331),
    [sym_dots] = ACTIONS(5331),
    [sym_dot_dot_i] = ACTIONS(5329),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5329),
    [sym__newline] = ACTIONS(5329),
    [sym__semicolon] = ACTIONS(5329),
    [sym__raw_string_literal] = ACTIONS(5329),
    [sym__external_open_parenthesis] = ACTIONS(5513),
    [sym__external_close_parenthesis] = ACTIONS(5329),
    [sym__external_open_brace] = ACTIONS(5329),
    [sym__external_close_brace] = ACTIONS(5329),
    [sym__external_open_bracket] = ACTIONS(5515),
    [sym__external_open_bracket2] = ACTIONS(5517),
  },
  [913] = {
    [sym_call_arguments] = STATE(2555),
    [sym_subset_arguments] = STATE(2554),
    [sym_subset2_arguments] = STATE(2553),
    [sym__open_parenthesis] = STATE(1332),
    [sym__open_bracket] = STATE(1331),
    [sym__open_bracket2] = STATE(1330),
    [sym_identifier] = ACTIONS(5331),
    [anon_sym_BSLASH] = ACTIONS(5329),
    [anon_sym_function] = ACTIONS(5331),
    [anon_sym_EQ] = ACTIONS(5265),
    [anon_sym_if] = ACTIONS(5331),
    [anon_sym_for] = ACTIONS(5331),
    [anon_sym_while] = ACTIONS(5331),
    [anon_sym_repeat] = ACTIONS(5331),
    [anon_sym_QMARK] = ACTIONS(5329),
    [anon_sym_TILDE] = ACTIONS(5267),
    [anon_sym_BANG] = ACTIONS(5331),
    [anon_sym_PLUS] = ACTIONS(5269),
    [anon_sym_DASH] = ACTIONS(5271),
    [anon_sym_LT_DASH] = ACTIONS(5273),
    [anon_sym_LT_LT_DASH] = ACTIONS(5273),
    [anon_sym_COLON_EQ] = ACTIONS(5273),
    [anon_sym_DASH_GT] = ACTIONS(5275),
    [anon_sym_DASH_GT_GT] = ACTIONS(5277),
    [anon_sym_PIPE] = ACTIONS(5279),
    [anon_sym_AMP] = ACTIONS(5281),
    [anon_sym_PIPE_PIPE] = ACTIONS(5283),
    [anon_sym_AMP_AMP] = ACTIONS(5285),
    [anon_sym_LT] = ACTIONS(5287),
    [anon_sym_LT_EQ] = ACTIONS(5289),
    [anon_sym_GT] = ACTIONS(5287),
    [anon_sym_GT_EQ] = ACTIONS(5289),
    [anon_sym_EQ_EQ] = ACTIONS(5289),
    [anon_sym_BANG_EQ] = ACTIONS(5289),
    [anon_sym_STAR] = ACTIONS(5291),
    [anon_sym_SLASH] = ACTIONS(5293),
    [anon_sym_STAR_STAR] = ACTIONS(5295),
    [anon_sym_CARET] = ACTIONS(5295),
    [aux_sym_binary_operator_token1] = ACTIONS(5297),
    [anon_sym_PIPE_GT] = ACTIONS(5297),
    [anon_sym_COLON] = ACTIONS(5299),
    [anon_sym_DOLLAR] = ACTIONS(5301),
    [anon_sym_AT] = ACTIONS(5301),
    [aux_sym__hex_literal_token1] = ACTIONS(5329),
    [sym__number_literal] = ACTIONS(5331),
    [anon_sym_SQUOTE] = ACTIONS(5329),
    [anon_sym_DQUOTE] = ACTIONS(5329),
    [sym_return] = ACTIONS(5331),
    [sym_next] = ACTIONS(5331),
    [sym_break] = ACTIONS(5331),
    [sym_true] = ACTIONS(5331),
    [sym_false] = ACTIONS(5331),
    [sym_null] = ACTIONS(5331),
    [sym_inf] = ACTIONS(5331),
    [sym_nan] = ACTIONS(5331),
    [anon_sym_NA] = ACTIONS(5331),
    [anon_sym_NA_integer_] = ACTIONS(5331),
    [anon_sym_NA_real_] = ACTIONS(5331),
    [anon_sym_NA_complex_] = ACTIONS(5331),
    [anon_sym_NA_character_] = ACTIONS(5331),
    [sym_dots] = ACTIONS(5331),
    [sym_dot_dot_i] = ACTIONS(5329),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5329),
    [sym__newline] = ACTIONS(5329),
    [sym__semicolon] = ACTIONS(5329),
    [sym__raw_string_literal] = ACTIONS(5329),
    [sym__external_else] = ACTIONS(5329),
    [sym__external_open_parenthesis] = ACTIONS(5305),
    [sym__external_open_brace] = ACTIONS(5329),
    [sym__external_close_brace] = ACTIONS(5329),
    [sym__external_open_bracket] = ACTIONS(5307),
    [sym__external_open_bracket2] = ACTIONS(5309),
    [sym__external_close_bracket2] = ACTIONS(5329),
  },
  [914] = {
    [sym_call_arguments] = STATE(2555),
    [sym_subset_arguments] = STATE(2554),
    [sym_subset2_arguments] = STATE(2553),
    [sym__open_parenthesis] = STATE(1332),
    [sym__open_bracket] = STATE(1331),
    [sym__open_bracket2] = STATE(1330),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5265),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5267),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(5269),
    [anon_sym_DASH] = ACTIONS(5271),
    [anon_sym_LT_DASH] = ACTIONS(5273),
    [anon_sym_LT_LT_DASH] = ACTIONS(5273),
    [anon_sym_COLON_EQ] = ACTIONS(5273),
    [anon_sym_DASH_GT] = ACTIONS(5275),
    [anon_sym_DASH_GT_GT] = ACTIONS(5277),
    [anon_sym_PIPE] = ACTIONS(5279),
    [anon_sym_AMP] = ACTIONS(5281),
    [anon_sym_PIPE_PIPE] = ACTIONS(5283),
    [anon_sym_AMP_AMP] = ACTIONS(5285),
    [anon_sym_LT] = ACTIONS(5287),
    [anon_sym_LT_EQ] = ACTIONS(5289),
    [anon_sym_GT] = ACTIONS(5287),
    [anon_sym_GT_EQ] = ACTIONS(5289),
    [anon_sym_EQ_EQ] = ACTIONS(5289),
    [anon_sym_BANG_EQ] = ACTIONS(5289),
    [anon_sym_STAR] = ACTIONS(5291),
    [anon_sym_SLASH] = ACTIONS(5293),
    [anon_sym_STAR_STAR] = ACTIONS(5295),
    [anon_sym_CARET] = ACTIONS(5295),
    [aux_sym_binary_operator_token1] = ACTIONS(5297),
    [anon_sym_PIPE_GT] = ACTIONS(5297),
    [anon_sym_COLON] = ACTIONS(5299),
    [anon_sym_DOLLAR] = ACTIONS(5301),
    [anon_sym_AT] = ACTIONS(5301),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__semicolon] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_else] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(5305),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_close_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(5307),
    [sym__external_open_bracket2] = ACTIONS(5309),
    [sym__external_close_bracket2] = ACTIONS(5333),
  },
  [915] = {
    [sym_call_arguments] = STATE(2555),
    [sym_subset_arguments] = STATE(2554),
    [sym_subset2_arguments] = STATE(2553),
    [sym__open_parenthesis] = STATE(1332),
    [sym__open_bracket] = STATE(1331),
    [sym__open_bracket2] = STATE(1330),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(5269),
    [anon_sym_DASH] = ACTIONS(5271),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5279),
    [anon_sym_AMP] = ACTIONS(5281),
    [anon_sym_PIPE_PIPE] = ACTIONS(5283),
    [anon_sym_AMP_AMP] = ACTIONS(5285),
    [anon_sym_LT] = ACTIONS(5287),
    [anon_sym_LT_EQ] = ACTIONS(5289),
    [anon_sym_GT] = ACTIONS(5287),
    [anon_sym_GT_EQ] = ACTIONS(5289),
    [anon_sym_EQ_EQ] = ACTIONS(5289),
    [anon_sym_BANG_EQ] = ACTIONS(5289),
    [anon_sym_STAR] = ACTIONS(5291),
    [anon_sym_SLASH] = ACTIONS(5293),
    [anon_sym_STAR_STAR] = ACTIONS(5295),
    [anon_sym_CARET] = ACTIONS(5295),
    [aux_sym_binary_operator_token1] = ACTIONS(5297),
    [anon_sym_PIPE_GT] = ACTIONS(5297),
    [anon_sym_COLON] = ACTIONS(5299),
    [anon_sym_DOLLAR] = ACTIONS(5301),
    [anon_sym_AT] = ACTIONS(5301),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__semicolon] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_else] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(5305),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_close_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(5307),
    [sym__external_open_bracket2] = ACTIONS(5309),
    [sym__external_close_bracket2] = ACTIONS(5333),
  },
  [916] = {
    [sym_call_arguments] = STATE(2555),
    [sym_subset_arguments] = STATE(2554),
    [sym_subset2_arguments] = STATE(2553),
    [sym__open_parenthesis] = STATE(1332),
    [sym__open_bracket] = STATE(1331),
    [sym__open_bracket2] = STATE(1330),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(5269),
    [anon_sym_DASH] = ACTIONS(5271),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5335),
    [anon_sym_AMP] = ACTIONS(5335),
    [anon_sym_PIPE_PIPE] = ACTIONS(5333),
    [anon_sym_AMP_AMP] = ACTIONS(5333),
    [anon_sym_LT] = ACTIONS(5287),
    [anon_sym_LT_EQ] = ACTIONS(5289),
    [anon_sym_GT] = ACTIONS(5287),
    [anon_sym_GT_EQ] = ACTIONS(5289),
    [anon_sym_EQ_EQ] = ACTIONS(5289),
    [anon_sym_BANG_EQ] = ACTIONS(5289),
    [anon_sym_STAR] = ACTIONS(5291),
    [anon_sym_SLASH] = ACTIONS(5293),
    [anon_sym_STAR_STAR] = ACTIONS(5295),
    [anon_sym_CARET] = ACTIONS(5295),
    [aux_sym_binary_operator_token1] = ACTIONS(5297),
    [anon_sym_PIPE_GT] = ACTIONS(5297),
    [anon_sym_COLON] = ACTIONS(5299),
    [anon_sym_DOLLAR] = ACTIONS(5301),
    [anon_sym_AT] = ACTIONS(5301),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__semicolon] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_else] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(5305),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_close_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(5307),
    [sym__external_open_bracket2] = ACTIONS(5309),
    [sym__external_close_bracket2] = ACTIONS(5333),
  },
  [917] = {
    [sym_call_arguments] = STATE(2380),
    [sym_subset_arguments] = STATE(2385),
    [sym_subset2_arguments] = STATE(2388),
    [sym__open_parenthesis] = STATE(1496),
    [sym__open_bracket] = STATE(1494),
    [sym__open_bracket2] = STATE(1490),
    [sym_identifier] = ACTIONS(5311),
    [anon_sym_BSLASH] = ACTIONS(5313),
    [anon_sym_function] = ACTIONS(5311),
    [anon_sym_EQ] = ACTIONS(5563),
    [anon_sym_if] = ACTIONS(5311),
    [anon_sym_for] = ACTIONS(5311),
    [anon_sym_while] = ACTIONS(5311),
    [anon_sym_repeat] = ACTIONS(5311),
    [anon_sym_QMARK] = ACTIONS(5607),
    [anon_sym_TILDE] = ACTIONS(5565),
    [anon_sym_BANG] = ACTIONS(5311),
    [anon_sym_PLUS] = ACTIONS(5567),
    [anon_sym_DASH] = ACTIONS(5569),
    [anon_sym_LT_DASH] = ACTIONS(5571),
    [anon_sym_LT_LT_DASH] = ACTIONS(5571),
    [anon_sym_COLON_EQ] = ACTIONS(5571),
    [anon_sym_DASH_GT] = ACTIONS(5573),
    [anon_sym_DASH_GT_GT] = ACTIONS(5575),
    [anon_sym_PIPE] = ACTIONS(5577),
    [anon_sym_AMP] = ACTIONS(5579),
    [anon_sym_PIPE_PIPE] = ACTIONS(5581),
    [anon_sym_AMP_AMP] = ACTIONS(5583),
    [anon_sym_LT] = ACTIONS(5585),
    [anon_sym_LT_EQ] = ACTIONS(5587),
    [anon_sym_GT] = ACTIONS(5585),
    [anon_sym_GT_EQ] = ACTIONS(5587),
    [anon_sym_EQ_EQ] = ACTIONS(5587),
    [anon_sym_BANG_EQ] = ACTIONS(5587),
    [anon_sym_STAR] = ACTIONS(5589),
    [anon_sym_SLASH] = ACTIONS(5591),
    [anon_sym_STAR_STAR] = ACTIONS(5593),
    [anon_sym_CARET] = ACTIONS(5593),
    [aux_sym_binary_operator_token1] = ACTIONS(5595),
    [anon_sym_PIPE_GT] = ACTIONS(5595),
    [anon_sym_COLON] = ACTIONS(5597),
    [anon_sym_DOLLAR] = ACTIONS(5599),
    [anon_sym_AT] = ACTIONS(5599),
    [aux_sym__hex_literal_token1] = ACTIONS(5313),
    [sym__number_literal] = ACTIONS(5311),
    [anon_sym_SQUOTE] = ACTIONS(5313),
    [anon_sym_DQUOTE] = ACTIONS(5313),
    [sym_return] = ACTIONS(5311),
    [sym_next] = ACTIONS(5311),
    [sym_break] = ACTIONS(5311),
    [sym_true] = ACTIONS(5311),
    [sym_false] = ACTIONS(5311),
    [sym_null] = ACTIONS(5311),
    [sym_inf] = ACTIONS(5311),
    [sym_nan] = ACTIONS(5311),
    [anon_sym_NA] = ACTIONS(5311),
    [anon_sym_NA_integer_] = ACTIONS(5311),
    [anon_sym_NA_real_] = ACTIONS(5311),
    [anon_sym_NA_complex_] = ACTIONS(5311),
    [anon_sym_NA_character_] = ACTIONS(5311),
    [sym_dots] = ACTIONS(5311),
    [sym_dot_dot_i] = ACTIONS(5313),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5313),
    [sym__newline] = ACTIONS(5313),
    [sym__semicolon] = ACTIONS(5313),
    [sym__raw_string_literal] = ACTIONS(5313),
    [sym__external_open_parenthesis] = ACTIONS(5601),
    [sym__external_close_parenthesis] = ACTIONS(5313),
    [sym__external_open_brace] = ACTIONS(5313),
    [sym__external_close_brace] = ACTIONS(5313),
    [sym__external_open_bracket] = ACTIONS(5603),
    [sym__external_close_bracket] = ACTIONS(5313),
    [sym__external_open_bracket2] = ACTIONS(5605),
  },
  [918] = {
    [sym_call_arguments] = STATE(2555),
    [sym_subset_arguments] = STATE(2554),
    [sym_subset2_arguments] = STATE(2553),
    [sym__open_parenthesis] = STATE(1332),
    [sym__open_bracket] = STATE(1331),
    [sym__open_bracket2] = STATE(1330),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(5333),
    [anon_sym_DASH] = ACTIONS(5335),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5335),
    [anon_sym_AMP] = ACTIONS(5335),
    [anon_sym_PIPE_PIPE] = ACTIONS(5333),
    [anon_sym_AMP_AMP] = ACTIONS(5333),
    [anon_sym_LT] = ACTIONS(5335),
    [anon_sym_LT_EQ] = ACTIONS(5333),
    [anon_sym_GT] = ACTIONS(5335),
    [anon_sym_GT_EQ] = ACTIONS(5333),
    [anon_sym_EQ_EQ] = ACTIONS(5333),
    [anon_sym_BANG_EQ] = ACTIONS(5333),
    [anon_sym_STAR] = ACTIONS(5335),
    [anon_sym_SLASH] = ACTIONS(5333),
    [anon_sym_STAR_STAR] = ACTIONS(5295),
    [anon_sym_CARET] = ACTIONS(5295),
    [aux_sym_binary_operator_token1] = ACTIONS(5333),
    [anon_sym_PIPE_GT] = ACTIONS(5333),
    [anon_sym_COLON] = ACTIONS(5335),
    [anon_sym_DOLLAR] = ACTIONS(5301),
    [anon_sym_AT] = ACTIONS(5301),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__semicolon] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_else] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(5305),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_close_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(5307),
    [sym__external_open_bracket2] = ACTIONS(5309),
    [sym__external_close_bracket2] = ACTIONS(5333),
  },
  [919] = {
    [sym_call_arguments] = STATE(2555),
    [sym_subset_arguments] = STATE(2554),
    [sym_subset2_arguments] = STATE(2553),
    [sym__open_parenthesis] = STATE(1332),
    [sym__open_bracket] = STATE(1331),
    [sym__open_bracket2] = STATE(1330),
    [sym_identifier] = ACTIONS(5339),
    [anon_sym_BSLASH] = ACTIONS(5337),
    [anon_sym_function] = ACTIONS(5339),
    [anon_sym_EQ] = ACTIONS(5265),
    [anon_sym_if] = ACTIONS(5339),
    [anon_sym_for] = ACTIONS(5339),
    [anon_sym_while] = ACTIONS(5339),
    [anon_sym_repeat] = ACTIONS(5339),
    [anon_sym_QMARK] = ACTIONS(5337),
    [anon_sym_TILDE] = ACTIONS(5267),
    [anon_sym_BANG] = ACTIONS(5339),
    [anon_sym_PLUS] = ACTIONS(5269),
    [anon_sym_DASH] = ACTIONS(5271),
    [anon_sym_LT_DASH] = ACTIONS(5273),
    [anon_sym_LT_LT_DASH] = ACTIONS(5273),
    [anon_sym_COLON_EQ] = ACTIONS(5273),
    [anon_sym_DASH_GT] = ACTIONS(5275),
    [anon_sym_DASH_GT_GT] = ACTIONS(5277),
    [anon_sym_PIPE] = ACTIONS(5279),
    [anon_sym_AMP] = ACTIONS(5281),
    [anon_sym_PIPE_PIPE] = ACTIONS(5283),
    [anon_sym_AMP_AMP] = ACTIONS(5285),
    [anon_sym_LT] = ACTIONS(5287),
    [anon_sym_LT_EQ] = ACTIONS(5289),
    [anon_sym_GT] = ACTIONS(5287),
    [anon_sym_GT_EQ] = ACTIONS(5289),
    [anon_sym_EQ_EQ] = ACTIONS(5289),
    [anon_sym_BANG_EQ] = ACTIONS(5289),
    [anon_sym_STAR] = ACTIONS(5291),
    [anon_sym_SLASH] = ACTIONS(5293),
    [anon_sym_STAR_STAR] = ACTIONS(5295),
    [anon_sym_CARET] = ACTIONS(5295),
    [aux_sym_binary_operator_token1] = ACTIONS(5297),
    [anon_sym_PIPE_GT] = ACTIONS(5297),
    [anon_sym_COLON] = ACTIONS(5299),
    [anon_sym_DOLLAR] = ACTIONS(5301),
    [anon_sym_AT] = ACTIONS(5301),
    [aux_sym__hex_literal_token1] = ACTIONS(5337),
    [sym__number_literal] = ACTIONS(5339),
    [anon_sym_SQUOTE] = ACTIONS(5337),
    [anon_sym_DQUOTE] = ACTIONS(5337),
    [sym_return] = ACTIONS(5339),
    [sym_next] = ACTIONS(5339),
    [sym_break] = ACTIONS(5339),
    [sym_true] = ACTIONS(5339),
    [sym_false] = ACTIONS(5339),
    [sym_null] = ACTIONS(5339),
    [sym_inf] = ACTIONS(5339),
    [sym_nan] = ACTIONS(5339),
    [anon_sym_NA] = ACTIONS(5339),
    [anon_sym_NA_integer_] = ACTIONS(5339),
    [anon_sym_NA_real_] = ACTIONS(5339),
    [anon_sym_NA_complex_] = ACTIONS(5339),
    [anon_sym_NA_character_] = ACTIONS(5339),
    [sym_dots] = ACTIONS(5339),
    [sym_dot_dot_i] = ACTIONS(5337),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5337),
    [sym__newline] = ACTIONS(5337),
    [sym__semicolon] = ACTIONS(5337),
    [sym__raw_string_literal] = ACTIONS(5337),
    [sym__external_else] = ACTIONS(5337),
    [sym__external_open_parenthesis] = ACTIONS(5305),
    [sym__external_open_brace] = ACTIONS(5337),
    [sym__external_close_brace] = ACTIONS(5337),
    [sym__external_open_bracket] = ACTIONS(5307),
    [sym__external_open_bracket2] = ACTIONS(5309),
    [sym__external_close_bracket2] = ACTIONS(5337),
  },
  [920] = {
    [sym_string] = STATE(2364),
    [sym__single_quoted_string] = STATE(1923),
    [sym__double_quoted_string] = STATE(1934),
    [sym__string_or_identifier] = STATE(2364),
    [aux_sym_function_definition_repeat1] = STATE(903),
    [sym_identifier] = ACTIONS(5871),
    [anon_sym_BSLASH] = ACTIONS(5659),
    [anon_sym_function] = ACTIONS(5663),
    [anon_sym_EQ] = ACTIONS(5663),
    [anon_sym_if] = ACTIONS(5663),
    [anon_sym_for] = ACTIONS(5663),
    [anon_sym_while] = ACTIONS(5663),
    [anon_sym_repeat] = ACTIONS(5663),
    [anon_sym_QMARK] = ACTIONS(5659),
    [anon_sym_TILDE] = ACTIONS(5659),
    [anon_sym_BANG] = ACTIONS(5663),
    [anon_sym_PLUS] = ACTIONS(5659),
    [anon_sym_DASH] = ACTIONS(5663),
    [anon_sym_LT_DASH] = ACTIONS(5659),
    [anon_sym_LT_LT_DASH] = ACTIONS(5659),
    [anon_sym_COLON_EQ] = ACTIONS(5659),
    [anon_sym_DASH_GT] = ACTIONS(5663),
    [anon_sym_DASH_GT_GT] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(5663),
    [anon_sym_AMP] = ACTIONS(5663),
    [anon_sym_PIPE_PIPE] = ACTIONS(5659),
    [anon_sym_AMP_AMP] = ACTIONS(5659),
    [anon_sym_LT] = ACTIONS(5663),
    [anon_sym_LT_EQ] = ACTIONS(5659),
    [anon_sym_GT] = ACTIONS(5663),
    [anon_sym_GT_EQ] = ACTIONS(5659),
    [anon_sym_EQ_EQ] = ACTIONS(5659),
    [anon_sym_BANG_EQ] = ACTIONS(5659),
    [anon_sym_STAR] = ACTIONS(5663),
    [anon_sym_SLASH] = ACTIONS(5659),
    [anon_sym_STAR_STAR] = ACTIONS(5659),
    [anon_sym_CARET] = ACTIONS(5659),
    [aux_sym_binary_operator_token1] = ACTIONS(5659),
    [anon_sym_PIPE_GT] = ACTIONS(5659),
    [anon_sym_COLON] = ACTIONS(5663),
    [anon_sym_DOLLAR] = ACTIONS(5659),
    [anon_sym_AT] = ACTIONS(5659),
    [aux_sym__hex_literal_token1] = ACTIONS(5659),
    [sym__number_literal] = ACTIONS(5663),
    [anon_sym_SQUOTE] = ACTIONS(189),
    [anon_sym_DQUOTE] = ACTIONS(191),
    [sym_return] = ACTIONS(5663),
    [sym_next] = ACTIONS(5663),
    [sym_break] = ACTIONS(5663),
    [sym_true] = ACTIONS(5663),
    [sym_false] = ACTIONS(5663),
    [sym_null] = ACTIONS(5663),
    [sym_inf] = ACTIONS(5663),
    [sym_nan] = ACTIONS(5663),
    [anon_sym_NA] = ACTIONS(5663),
    [anon_sym_NA_integer_] = ACTIONS(5663),
    [anon_sym_NA_real_] = ACTIONS(5663),
    [anon_sym_NA_complex_] = ACTIONS(5663),
    [anon_sym_NA_character_] = ACTIONS(5663),
    [sym_dots] = ACTIONS(5663),
    [sym_dot_dot_i] = ACTIONS(5659),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5659),
    [sym__newline] = ACTIONS(5873),
    [sym__semicolon] = ACTIONS(5659),
    [sym__raw_string_literal] = ACTIONS(201),
    [sym__external_else] = ACTIONS(5659),
    [sym__external_open_parenthesis] = ACTIONS(5659),
    [sym__external_close_parenthesis] = ACTIONS(5659),
    [sym__external_open_brace] = ACTIONS(5659),
    [sym__external_close_brace] = ACTIONS(5659),
    [sym__external_open_bracket] = ACTIONS(5659),
    [sym__external_open_bracket2] = ACTIONS(5659),
    [sym__external_close_bracket2] = ACTIONS(5659),
  },
  [921] = {
    [sym_call_arguments] = STATE(2401),
    [sym_subset_arguments] = STATE(2403),
    [sym_subset2_arguments] = STATE(2404),
    [sym__open_parenthesis] = STATE(1461),
    [sym__open_bracket] = STATE(1450),
    [sym__open_bracket2] = STATE(1447),
    [sym_identifier] = ACTIONS(5325),
    [anon_sym_BSLASH] = ACTIONS(5327),
    [anon_sym_function] = ACTIONS(5325),
    [anon_sym_EQ] = ACTIONS(5553),
    [anon_sym_if] = ACTIONS(5325),
    [anon_sym_for] = ACTIONS(5325),
    [anon_sym_while] = ACTIONS(5325),
    [anon_sym_repeat] = ACTIONS(5325),
    [anon_sym_QMARK] = ACTIONS(5875),
    [anon_sym_TILDE] = ACTIONS(5555),
    [anon_sym_BANG] = ACTIONS(5325),
    [anon_sym_PLUS] = ACTIONS(5529),
    [anon_sym_DASH] = ACTIONS(5531),
    [anon_sym_LT_DASH] = ACTIONS(5557),
    [anon_sym_LT_LT_DASH] = ACTIONS(5557),
    [anon_sym_COLON_EQ] = ACTIONS(5557),
    [anon_sym_DASH_GT] = ACTIONS(5559),
    [anon_sym_DASH_GT_GT] = ACTIONS(5561),
    [anon_sym_PIPE] = ACTIONS(5545),
    [anon_sym_AMP] = ACTIONS(5547),
    [anon_sym_PIPE_PIPE] = ACTIONS(5549),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_LT] = ACTIONS(5533),
    [anon_sym_LT_EQ] = ACTIONS(5535),
    [anon_sym_GT] = ACTIONS(5533),
    [anon_sym_GT_EQ] = ACTIONS(5535),
    [anon_sym_EQ_EQ] = ACTIONS(5535),
    [anon_sym_BANG_EQ] = ACTIONS(5535),
    [anon_sym_STAR] = ACTIONS(5537),
    [anon_sym_SLASH] = ACTIONS(5539),
    [anon_sym_STAR_STAR] = ACTIONS(5519),
    [anon_sym_CARET] = ACTIONS(5519),
    [aux_sym_binary_operator_token1] = ACTIONS(5541),
    [anon_sym_PIPE_GT] = ACTIONS(5541),
    [anon_sym_COLON] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5521),
    [anon_sym_AT] = ACTIONS(5521),
    [aux_sym__hex_literal_token1] = ACTIONS(5327),
    [sym__number_literal] = ACTIONS(5325),
    [anon_sym_SQUOTE] = ACTIONS(5327),
    [anon_sym_DQUOTE] = ACTIONS(5327),
    [sym_return] = ACTIONS(5325),
    [sym_next] = ACTIONS(5325),
    [sym_break] = ACTIONS(5325),
    [sym_true] = ACTIONS(5325),
    [sym_false] = ACTIONS(5325),
    [sym_null] = ACTIONS(5325),
    [sym_inf] = ACTIONS(5325),
    [sym_nan] = ACTIONS(5325),
    [anon_sym_NA] = ACTIONS(5325),
    [anon_sym_NA_integer_] = ACTIONS(5325),
    [anon_sym_NA_real_] = ACTIONS(5325),
    [anon_sym_NA_complex_] = ACTIONS(5325),
    [anon_sym_NA_character_] = ACTIONS(5325),
    [sym_dots] = ACTIONS(5325),
    [sym_dot_dot_i] = ACTIONS(5327),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5327),
    [sym__newline] = ACTIONS(5327),
    [sym__semicolon] = ACTIONS(5327),
    [sym__raw_string_literal] = ACTIONS(5327),
    [sym__external_open_parenthesis] = ACTIONS(5523),
    [sym__external_close_parenthesis] = ACTIONS(5327),
    [sym__external_open_brace] = ACTIONS(5327),
    [sym__external_close_brace] = ACTIONS(5327),
    [sym__external_open_bracket] = ACTIONS(5525),
    [sym__external_open_bracket2] = ACTIONS(5527),
    [sym__external_close_bracket2] = ACTIONS(5327),
  },
  [922] = {
    [sym_call_arguments] = STATE(2555),
    [sym_subset_arguments] = STATE(2554),
    [sym_subset2_arguments] = STATE(2553),
    [sym__open_parenthesis] = STATE(1332),
    [sym__open_bracket] = STATE(1331),
    [sym__open_bracket2] = STATE(1330),
    [sym_identifier] = ACTIONS(5343),
    [anon_sym_BSLASH] = ACTIONS(5341),
    [anon_sym_function] = ACTIONS(5343),
    [anon_sym_EQ] = ACTIONS(5265),
    [anon_sym_if] = ACTIONS(5343),
    [anon_sym_for] = ACTIONS(5343),
    [anon_sym_while] = ACTIONS(5343),
    [anon_sym_repeat] = ACTIONS(5343),
    [anon_sym_QMARK] = ACTIONS(5341),
    [anon_sym_TILDE] = ACTIONS(5267),
    [anon_sym_BANG] = ACTIONS(5343),
    [anon_sym_PLUS] = ACTIONS(5269),
    [anon_sym_DASH] = ACTIONS(5271),
    [anon_sym_LT_DASH] = ACTIONS(5273),
    [anon_sym_LT_LT_DASH] = ACTIONS(5273),
    [anon_sym_COLON_EQ] = ACTIONS(5273),
    [anon_sym_DASH_GT] = ACTIONS(5275),
    [anon_sym_DASH_GT_GT] = ACTIONS(5277),
    [anon_sym_PIPE] = ACTIONS(5279),
    [anon_sym_AMP] = ACTIONS(5281),
    [anon_sym_PIPE_PIPE] = ACTIONS(5283),
    [anon_sym_AMP_AMP] = ACTIONS(5285),
    [anon_sym_LT] = ACTIONS(5287),
    [anon_sym_LT_EQ] = ACTIONS(5289),
    [anon_sym_GT] = ACTIONS(5287),
    [anon_sym_GT_EQ] = ACTIONS(5289),
    [anon_sym_EQ_EQ] = ACTIONS(5289),
    [anon_sym_BANG_EQ] = ACTIONS(5289),
    [anon_sym_STAR] = ACTIONS(5291),
    [anon_sym_SLASH] = ACTIONS(5293),
    [anon_sym_STAR_STAR] = ACTIONS(5295),
    [anon_sym_CARET] = ACTIONS(5295),
    [aux_sym_binary_operator_token1] = ACTIONS(5297),
    [anon_sym_PIPE_GT] = ACTIONS(5297),
    [anon_sym_COLON] = ACTIONS(5299),
    [anon_sym_DOLLAR] = ACTIONS(5301),
    [anon_sym_AT] = ACTIONS(5301),
    [aux_sym__hex_literal_token1] = ACTIONS(5341),
    [sym__number_literal] = ACTIONS(5343),
    [anon_sym_SQUOTE] = ACTIONS(5341),
    [anon_sym_DQUOTE] = ACTIONS(5341),
    [sym_return] = ACTIONS(5343),
    [sym_next] = ACTIONS(5343),
    [sym_break] = ACTIONS(5343),
    [sym_true] = ACTIONS(5343),
    [sym_false] = ACTIONS(5343),
    [sym_null] = ACTIONS(5343),
    [sym_inf] = ACTIONS(5343),
    [sym_nan] = ACTIONS(5343),
    [anon_sym_NA] = ACTIONS(5343),
    [anon_sym_NA_integer_] = ACTIONS(5343),
    [anon_sym_NA_real_] = ACTIONS(5343),
    [anon_sym_NA_complex_] = ACTIONS(5343),
    [anon_sym_NA_character_] = ACTIONS(5343),
    [sym_dots] = ACTIONS(5343),
    [sym_dot_dot_i] = ACTIONS(5341),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5341),
    [sym__newline] = ACTIONS(5341),
    [sym__semicolon] = ACTIONS(5341),
    [sym__raw_string_literal] = ACTIONS(5341),
    [sym__external_else] = ACTIONS(5341),
    [sym__external_open_parenthesis] = ACTIONS(5305),
    [sym__external_open_brace] = ACTIONS(5341),
    [sym__external_close_brace] = ACTIONS(5341),
    [sym__external_open_bracket] = ACTIONS(5307),
    [sym__external_open_bracket2] = ACTIONS(5309),
    [sym__external_close_bracket2] = ACTIONS(5341),
  },
  [923] = {
    [sym_call_arguments] = STATE(2555),
    [sym_subset_arguments] = STATE(2554),
    [sym_subset2_arguments] = STATE(2553),
    [sym__open_parenthesis] = STATE(1332),
    [sym__open_bracket] = STATE(1331),
    [sym__open_bracket2] = STATE(1330),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5265),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5267),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5269),
    [anon_sym_DASH] = ACTIONS(5271),
    [anon_sym_LT_DASH] = ACTIONS(5273),
    [anon_sym_LT_LT_DASH] = ACTIONS(5273),
    [anon_sym_COLON_EQ] = ACTIONS(5273),
    [anon_sym_DASH_GT] = ACTIONS(5275),
    [anon_sym_DASH_GT_GT] = ACTIONS(5277),
    [anon_sym_PIPE] = ACTIONS(5279),
    [anon_sym_AMP] = ACTIONS(5281),
    [anon_sym_PIPE_PIPE] = ACTIONS(5283),
    [anon_sym_AMP_AMP] = ACTIONS(5285),
    [anon_sym_LT] = ACTIONS(5287),
    [anon_sym_LT_EQ] = ACTIONS(5289),
    [anon_sym_GT] = ACTIONS(5287),
    [anon_sym_GT_EQ] = ACTIONS(5289),
    [anon_sym_EQ_EQ] = ACTIONS(5289),
    [anon_sym_BANG_EQ] = ACTIONS(5289),
    [anon_sym_STAR] = ACTIONS(5291),
    [anon_sym_SLASH] = ACTIONS(5293),
    [anon_sym_STAR_STAR] = ACTIONS(5295),
    [anon_sym_CARET] = ACTIONS(5295),
    [aux_sym_binary_operator_token1] = ACTIONS(5297),
    [anon_sym_PIPE_GT] = ACTIONS(5297),
    [anon_sym_COLON] = ACTIONS(5299),
    [anon_sym_DOLLAR] = ACTIONS(5301),
    [anon_sym_AT] = ACTIONS(5301),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__semicolon] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_else] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(5305),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_close_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(5307),
    [sym__external_open_bracket2] = ACTIONS(5309),
    [sym__external_close_bracket2] = ACTIONS(5345),
  },
  [924] = {
    [sym_call_arguments] = STATE(2555),
    [sym_subset_arguments] = STATE(2554),
    [sym_subset2_arguments] = STATE(2553),
    [sym__open_parenthesis] = STATE(1332),
    [sym__open_bracket] = STATE(1331),
    [sym__open_bracket2] = STATE(1330),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5269),
    [anon_sym_DASH] = ACTIONS(5271),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5279),
    [anon_sym_AMP] = ACTIONS(5281),
    [anon_sym_PIPE_PIPE] = ACTIONS(5283),
    [anon_sym_AMP_AMP] = ACTIONS(5285),
    [anon_sym_LT] = ACTIONS(5287),
    [anon_sym_LT_EQ] = ACTIONS(5289),
    [anon_sym_GT] = ACTIONS(5287),
    [anon_sym_GT_EQ] = ACTIONS(5289),
    [anon_sym_EQ_EQ] = ACTIONS(5289),
    [anon_sym_BANG_EQ] = ACTIONS(5289),
    [anon_sym_STAR] = ACTIONS(5291),
    [anon_sym_SLASH] = ACTIONS(5293),
    [anon_sym_STAR_STAR] = ACTIONS(5295),
    [anon_sym_CARET] = ACTIONS(5295),
    [aux_sym_binary_operator_token1] = ACTIONS(5297),
    [anon_sym_PIPE_GT] = ACTIONS(5297),
    [anon_sym_COLON] = ACTIONS(5299),
    [anon_sym_DOLLAR] = ACTIONS(5301),
    [anon_sym_AT] = ACTIONS(5301),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__semicolon] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_else] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(5305),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_close_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(5307),
    [sym__external_open_bracket2] = ACTIONS(5309),
    [sym__external_close_bracket2] = ACTIONS(5345),
  },
  [925] = {
    [sym_call_arguments] = STATE(2555),
    [sym_subset_arguments] = STATE(2554),
    [sym_subset2_arguments] = STATE(2553),
    [sym__open_parenthesis] = STATE(1332),
    [sym__open_bracket] = STATE(1331),
    [sym__open_bracket2] = STATE(1330),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5269),
    [anon_sym_DASH] = ACTIONS(5271),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5347),
    [anon_sym_AMP] = ACTIONS(5347),
    [anon_sym_PIPE_PIPE] = ACTIONS(5345),
    [anon_sym_AMP_AMP] = ACTIONS(5345),
    [anon_sym_LT] = ACTIONS(5287),
    [anon_sym_LT_EQ] = ACTIONS(5289),
    [anon_sym_GT] = ACTIONS(5287),
    [anon_sym_GT_EQ] = ACTIONS(5289),
    [anon_sym_EQ_EQ] = ACTIONS(5289),
    [anon_sym_BANG_EQ] = ACTIONS(5289),
    [anon_sym_STAR] = ACTIONS(5291),
    [anon_sym_SLASH] = ACTIONS(5293),
    [anon_sym_STAR_STAR] = ACTIONS(5295),
    [anon_sym_CARET] = ACTIONS(5295),
    [aux_sym_binary_operator_token1] = ACTIONS(5297),
    [anon_sym_PIPE_GT] = ACTIONS(5297),
    [anon_sym_COLON] = ACTIONS(5299),
    [anon_sym_DOLLAR] = ACTIONS(5301),
    [anon_sym_AT] = ACTIONS(5301),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__semicolon] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_else] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(5305),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_close_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(5307),
    [sym__external_open_bracket2] = ACTIONS(5309),
    [sym__external_close_bracket2] = ACTIONS(5345),
  },
  [926] = {
    [sym_call_arguments] = STATE(2555),
    [sym_subset_arguments] = STATE(2554),
    [sym_subset2_arguments] = STATE(2553),
    [sym__open_parenthesis] = STATE(1332),
    [sym__open_bracket] = STATE(1331),
    [sym__open_bracket2] = STATE(1330),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5345),
    [anon_sym_DASH] = ACTIONS(5347),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5347),
    [anon_sym_AMP] = ACTIONS(5347),
    [anon_sym_PIPE_PIPE] = ACTIONS(5345),
    [anon_sym_AMP_AMP] = ACTIONS(5345),
    [anon_sym_LT] = ACTIONS(5347),
    [anon_sym_LT_EQ] = ACTIONS(5345),
    [anon_sym_GT] = ACTIONS(5347),
    [anon_sym_GT_EQ] = ACTIONS(5345),
    [anon_sym_EQ_EQ] = ACTIONS(5345),
    [anon_sym_BANG_EQ] = ACTIONS(5345),
    [anon_sym_STAR] = ACTIONS(5347),
    [anon_sym_SLASH] = ACTIONS(5345),
    [anon_sym_STAR_STAR] = ACTIONS(5295),
    [anon_sym_CARET] = ACTIONS(5295),
    [aux_sym_binary_operator_token1] = ACTIONS(5345),
    [anon_sym_PIPE_GT] = ACTIONS(5345),
    [anon_sym_COLON] = ACTIONS(5347),
    [anon_sym_DOLLAR] = ACTIONS(5301),
    [anon_sym_AT] = ACTIONS(5301),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__semicolon] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_else] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(5305),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_close_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(5307),
    [sym__external_open_bracket2] = ACTIONS(5309),
    [sym__external_close_bracket2] = ACTIONS(5345),
  },
  [927] = {
    [sym_call_arguments] = STATE(2555),
    [sym_subset_arguments] = STATE(2554),
    [sym_subset2_arguments] = STATE(2553),
    [sym__open_parenthesis] = STATE(1332),
    [sym__open_bracket] = STATE(1331),
    [sym__open_bracket2] = STATE(1330),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5265),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5267),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5269),
    [anon_sym_DASH] = ACTIONS(5271),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5275),
    [anon_sym_DASH_GT_GT] = ACTIONS(5277),
    [anon_sym_PIPE] = ACTIONS(5279),
    [anon_sym_AMP] = ACTIONS(5281),
    [anon_sym_PIPE_PIPE] = ACTIONS(5283),
    [anon_sym_AMP_AMP] = ACTIONS(5285),
    [anon_sym_LT] = ACTIONS(5287),
    [anon_sym_LT_EQ] = ACTIONS(5289),
    [anon_sym_GT] = ACTIONS(5287),
    [anon_sym_GT_EQ] = ACTIONS(5289),
    [anon_sym_EQ_EQ] = ACTIONS(5289),
    [anon_sym_BANG_EQ] = ACTIONS(5289),
    [anon_sym_STAR] = ACTIONS(5291),
    [anon_sym_SLASH] = ACTIONS(5293),
    [anon_sym_STAR_STAR] = ACTIONS(5295),
    [anon_sym_CARET] = ACTIONS(5295),
    [aux_sym_binary_operator_token1] = ACTIONS(5297),
    [anon_sym_PIPE_GT] = ACTIONS(5297),
    [anon_sym_COLON] = ACTIONS(5299),
    [anon_sym_DOLLAR] = ACTIONS(5301),
    [anon_sym_AT] = ACTIONS(5301),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5305),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5307),
    [sym__external_open_bracket2] = ACTIONS(5309),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [928] = {
    [sym_call_arguments] = STATE(2555),
    [sym_subset_arguments] = STATE(2554),
    [sym_subset2_arguments] = STATE(2553),
    [sym__open_parenthesis] = STATE(1332),
    [sym__open_bracket] = STATE(1331),
    [sym__open_bracket2] = STATE(1330),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5265),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5267),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5269),
    [anon_sym_DASH] = ACTIONS(5271),
    [anon_sym_LT_DASH] = ACTIONS(5273),
    [anon_sym_LT_LT_DASH] = ACTIONS(5273),
    [anon_sym_COLON_EQ] = ACTIONS(5273),
    [anon_sym_DASH_GT] = ACTIONS(5275),
    [anon_sym_DASH_GT_GT] = ACTIONS(5277),
    [anon_sym_PIPE] = ACTIONS(5279),
    [anon_sym_AMP] = ACTIONS(5281),
    [anon_sym_PIPE_PIPE] = ACTIONS(5283),
    [anon_sym_AMP_AMP] = ACTIONS(5285),
    [anon_sym_LT] = ACTIONS(5287),
    [anon_sym_LT_EQ] = ACTIONS(5289),
    [anon_sym_GT] = ACTIONS(5287),
    [anon_sym_GT_EQ] = ACTIONS(5289),
    [anon_sym_EQ_EQ] = ACTIONS(5289),
    [anon_sym_BANG_EQ] = ACTIONS(5289),
    [anon_sym_STAR] = ACTIONS(5291),
    [anon_sym_SLASH] = ACTIONS(5293),
    [anon_sym_STAR_STAR] = ACTIONS(5295),
    [anon_sym_CARET] = ACTIONS(5295),
    [aux_sym_binary_operator_token1] = ACTIONS(5297),
    [anon_sym_PIPE_GT] = ACTIONS(5297),
    [anon_sym_COLON] = ACTIONS(5299),
    [anon_sym_DOLLAR] = ACTIONS(5301),
    [anon_sym_AT] = ACTIONS(5301),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5305),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5307),
    [sym__external_open_bracket2] = ACTIONS(5309),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [929] = {
    [sym_call_arguments] = STATE(2555),
    [sym_subset_arguments] = STATE(2554),
    [sym_subset2_arguments] = STATE(2553),
    [sym__open_parenthesis] = STATE(1332),
    [sym__open_bracket] = STATE(1331),
    [sym__open_bracket2] = STATE(1330),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5269),
    [anon_sym_DASH] = ACTIONS(5271),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5279),
    [anon_sym_AMP] = ACTIONS(5281),
    [anon_sym_PIPE_PIPE] = ACTIONS(5283),
    [anon_sym_AMP_AMP] = ACTIONS(5285),
    [anon_sym_LT] = ACTIONS(5287),
    [anon_sym_LT_EQ] = ACTIONS(5289),
    [anon_sym_GT] = ACTIONS(5287),
    [anon_sym_GT_EQ] = ACTIONS(5289),
    [anon_sym_EQ_EQ] = ACTIONS(5289),
    [anon_sym_BANG_EQ] = ACTIONS(5289),
    [anon_sym_STAR] = ACTIONS(5291),
    [anon_sym_SLASH] = ACTIONS(5293),
    [anon_sym_STAR_STAR] = ACTIONS(5295),
    [anon_sym_CARET] = ACTIONS(5295),
    [aux_sym_binary_operator_token1] = ACTIONS(5297),
    [anon_sym_PIPE_GT] = ACTIONS(5297),
    [anon_sym_COLON] = ACTIONS(5299),
    [anon_sym_DOLLAR] = ACTIONS(5301),
    [anon_sym_AT] = ACTIONS(5301),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5305),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5307),
    [sym__external_open_bracket2] = ACTIONS(5309),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [930] = {
    [sym_call_arguments] = STATE(2555),
    [sym_subset_arguments] = STATE(2554),
    [sym_subset2_arguments] = STATE(2553),
    [sym__open_parenthesis] = STATE(1332),
    [sym__open_bracket] = STATE(1331),
    [sym__open_bracket2] = STATE(1330),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5291),
    [anon_sym_SLASH] = ACTIONS(5293),
    [anon_sym_STAR_STAR] = ACTIONS(5295),
    [anon_sym_CARET] = ACTIONS(5295),
    [aux_sym_binary_operator_token1] = ACTIONS(5297),
    [anon_sym_PIPE_GT] = ACTIONS(5297),
    [anon_sym_COLON] = ACTIONS(5299),
    [anon_sym_DOLLAR] = ACTIONS(5301),
    [anon_sym_AT] = ACTIONS(5301),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5305),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5307),
    [sym__external_open_bracket2] = ACTIONS(5309),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [931] = {
    [sym_call_arguments] = STATE(2555),
    [sym_subset_arguments] = STATE(2554),
    [sym_subset2_arguments] = STATE(2553),
    [sym__open_parenthesis] = STATE(1332),
    [sym__open_bracket] = STATE(1331),
    [sym__open_bracket2] = STATE(1330),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5265),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5267),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5269),
    [anon_sym_DASH] = ACTIONS(5271),
    [anon_sym_LT_DASH] = ACTIONS(5273),
    [anon_sym_LT_LT_DASH] = ACTIONS(5273),
    [anon_sym_COLON_EQ] = ACTIONS(5273),
    [anon_sym_DASH_GT] = ACTIONS(5275),
    [anon_sym_DASH_GT_GT] = ACTIONS(5277),
    [anon_sym_PIPE] = ACTIONS(5279),
    [anon_sym_AMP] = ACTIONS(5281),
    [anon_sym_PIPE_PIPE] = ACTIONS(5283),
    [anon_sym_AMP_AMP] = ACTIONS(5285),
    [anon_sym_LT] = ACTIONS(5287),
    [anon_sym_LT_EQ] = ACTIONS(5289),
    [anon_sym_GT] = ACTIONS(5287),
    [anon_sym_GT_EQ] = ACTIONS(5289),
    [anon_sym_EQ_EQ] = ACTIONS(5289),
    [anon_sym_BANG_EQ] = ACTIONS(5289),
    [anon_sym_STAR] = ACTIONS(5291),
    [anon_sym_SLASH] = ACTIONS(5293),
    [anon_sym_STAR_STAR] = ACTIONS(5295),
    [anon_sym_CARET] = ACTIONS(5295),
    [aux_sym_binary_operator_token1] = ACTIONS(5297),
    [anon_sym_PIPE_GT] = ACTIONS(5297),
    [anon_sym_COLON] = ACTIONS(5299),
    [anon_sym_DOLLAR] = ACTIONS(5301),
    [anon_sym_AT] = ACTIONS(5301),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5305),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5307),
    [sym__external_open_bracket2] = ACTIONS(5309),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [932] = {
    [sym_call_arguments] = STATE(2555),
    [sym_subset_arguments] = STATE(2554),
    [sym_subset2_arguments] = STATE(2553),
    [sym__open_parenthesis] = STATE(1332),
    [sym__open_bracket] = STATE(1331),
    [sym__open_bracket2] = STATE(1330),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5267),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5269),
    [anon_sym_DASH] = ACTIONS(5271),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5279),
    [anon_sym_AMP] = ACTIONS(5281),
    [anon_sym_PIPE_PIPE] = ACTIONS(5283),
    [anon_sym_AMP_AMP] = ACTIONS(5285),
    [anon_sym_LT] = ACTIONS(5287),
    [anon_sym_LT_EQ] = ACTIONS(5289),
    [anon_sym_GT] = ACTIONS(5287),
    [anon_sym_GT_EQ] = ACTIONS(5289),
    [anon_sym_EQ_EQ] = ACTIONS(5289),
    [anon_sym_BANG_EQ] = ACTIONS(5289),
    [anon_sym_STAR] = ACTIONS(5291),
    [anon_sym_SLASH] = ACTIONS(5293),
    [anon_sym_STAR_STAR] = ACTIONS(5295),
    [anon_sym_CARET] = ACTIONS(5295),
    [aux_sym_binary_operator_token1] = ACTIONS(5297),
    [anon_sym_PIPE_GT] = ACTIONS(5297),
    [anon_sym_COLON] = ACTIONS(5299),
    [anon_sym_DOLLAR] = ACTIONS(5301),
    [anon_sym_AT] = ACTIONS(5301),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5305),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5307),
    [sym__external_open_bracket2] = ACTIONS(5309),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [933] = {
    [sym_call_arguments] = STATE(2555),
    [sym_subset_arguments] = STATE(2554),
    [sym_subset2_arguments] = STATE(2553),
    [sym__open_parenthesis] = STATE(1332),
    [sym__open_bracket] = STATE(1331),
    [sym__open_bracket2] = STATE(1330),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5269),
    [anon_sym_DASH] = ACTIONS(5271),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5281),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5285),
    [anon_sym_LT] = ACTIONS(5287),
    [anon_sym_LT_EQ] = ACTIONS(5289),
    [anon_sym_GT] = ACTIONS(5287),
    [anon_sym_GT_EQ] = ACTIONS(5289),
    [anon_sym_EQ_EQ] = ACTIONS(5289),
    [anon_sym_BANG_EQ] = ACTIONS(5289),
    [anon_sym_STAR] = ACTIONS(5291),
    [anon_sym_SLASH] = ACTIONS(5293),
    [anon_sym_STAR_STAR] = ACTIONS(5295),
    [anon_sym_CARET] = ACTIONS(5295),
    [aux_sym_binary_operator_token1] = ACTIONS(5297),
    [anon_sym_PIPE_GT] = ACTIONS(5297),
    [anon_sym_COLON] = ACTIONS(5299),
    [anon_sym_DOLLAR] = ACTIONS(5301),
    [anon_sym_AT] = ACTIONS(5301),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5305),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5307),
    [sym__external_open_bracket2] = ACTIONS(5309),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [934] = {
    [sym_call_arguments] = STATE(2555),
    [sym_subset_arguments] = STATE(2554),
    [sym_subset2_arguments] = STATE(2553),
    [sym__open_parenthesis] = STATE(1332),
    [sym__open_bracket] = STATE(1331),
    [sym__open_bracket2] = STATE(1330),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5269),
    [anon_sym_DASH] = ACTIONS(5271),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5287),
    [anon_sym_LT_EQ] = ACTIONS(5289),
    [anon_sym_GT] = ACTIONS(5287),
    [anon_sym_GT_EQ] = ACTIONS(5289),
    [anon_sym_EQ_EQ] = ACTIONS(5289),
    [anon_sym_BANG_EQ] = ACTIONS(5289),
    [anon_sym_STAR] = ACTIONS(5291),
    [anon_sym_SLASH] = ACTIONS(5293),
    [anon_sym_STAR_STAR] = ACTIONS(5295),
    [anon_sym_CARET] = ACTIONS(5295),
    [aux_sym_binary_operator_token1] = ACTIONS(5297),
    [anon_sym_PIPE_GT] = ACTIONS(5297),
    [anon_sym_COLON] = ACTIONS(5299),
    [anon_sym_DOLLAR] = ACTIONS(5301),
    [anon_sym_AT] = ACTIONS(5301),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5305),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5307),
    [sym__external_open_bracket2] = ACTIONS(5309),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [935] = {
    [sym_call_arguments] = STATE(2401),
    [sym_subset_arguments] = STATE(2403),
    [sym_subset2_arguments] = STATE(2404),
    [sym__open_parenthesis] = STATE(1461),
    [sym__open_bracket] = STATE(1450),
    [sym__open_bracket2] = STATE(1447),
    [sym_identifier] = ACTIONS(5311),
    [anon_sym_BSLASH] = ACTIONS(5313),
    [anon_sym_function] = ACTIONS(5311),
    [anon_sym_EQ] = ACTIONS(5553),
    [anon_sym_if] = ACTIONS(5311),
    [anon_sym_for] = ACTIONS(5311),
    [anon_sym_while] = ACTIONS(5311),
    [anon_sym_repeat] = ACTIONS(5311),
    [anon_sym_QMARK] = ACTIONS(5875),
    [anon_sym_TILDE] = ACTIONS(5555),
    [anon_sym_BANG] = ACTIONS(5311),
    [anon_sym_PLUS] = ACTIONS(5529),
    [anon_sym_DASH] = ACTIONS(5531),
    [anon_sym_LT_DASH] = ACTIONS(5557),
    [anon_sym_LT_LT_DASH] = ACTIONS(5557),
    [anon_sym_COLON_EQ] = ACTIONS(5557),
    [anon_sym_DASH_GT] = ACTIONS(5559),
    [anon_sym_DASH_GT_GT] = ACTIONS(5561),
    [anon_sym_PIPE] = ACTIONS(5545),
    [anon_sym_AMP] = ACTIONS(5547),
    [anon_sym_PIPE_PIPE] = ACTIONS(5549),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_LT] = ACTIONS(5533),
    [anon_sym_LT_EQ] = ACTIONS(5535),
    [anon_sym_GT] = ACTIONS(5533),
    [anon_sym_GT_EQ] = ACTIONS(5535),
    [anon_sym_EQ_EQ] = ACTIONS(5535),
    [anon_sym_BANG_EQ] = ACTIONS(5535),
    [anon_sym_STAR] = ACTIONS(5537),
    [anon_sym_SLASH] = ACTIONS(5539),
    [anon_sym_STAR_STAR] = ACTIONS(5519),
    [anon_sym_CARET] = ACTIONS(5519),
    [aux_sym_binary_operator_token1] = ACTIONS(5541),
    [anon_sym_PIPE_GT] = ACTIONS(5541),
    [anon_sym_COLON] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5521),
    [anon_sym_AT] = ACTIONS(5521),
    [aux_sym__hex_literal_token1] = ACTIONS(5313),
    [sym__number_literal] = ACTIONS(5311),
    [anon_sym_SQUOTE] = ACTIONS(5313),
    [anon_sym_DQUOTE] = ACTIONS(5313),
    [sym_return] = ACTIONS(5311),
    [sym_next] = ACTIONS(5311),
    [sym_break] = ACTIONS(5311),
    [sym_true] = ACTIONS(5311),
    [sym_false] = ACTIONS(5311),
    [sym_null] = ACTIONS(5311),
    [sym_inf] = ACTIONS(5311),
    [sym_nan] = ACTIONS(5311),
    [anon_sym_NA] = ACTIONS(5311),
    [anon_sym_NA_integer_] = ACTIONS(5311),
    [anon_sym_NA_real_] = ACTIONS(5311),
    [anon_sym_NA_complex_] = ACTIONS(5311),
    [anon_sym_NA_character_] = ACTIONS(5311),
    [sym_dots] = ACTIONS(5311),
    [sym_dot_dot_i] = ACTIONS(5313),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5313),
    [sym__newline] = ACTIONS(5313),
    [sym__semicolon] = ACTIONS(5313),
    [sym__raw_string_literal] = ACTIONS(5313),
    [sym__external_open_parenthesis] = ACTIONS(5523),
    [sym__external_close_parenthesis] = ACTIONS(5313),
    [sym__external_open_brace] = ACTIONS(5313),
    [sym__external_close_brace] = ACTIONS(5313),
    [sym__external_open_bracket] = ACTIONS(5525),
    [sym__external_open_bracket2] = ACTIONS(5527),
    [sym__external_close_bracket2] = ACTIONS(5313),
  },
  [936] = {
    [sym_call_arguments] = STATE(2555),
    [sym_subset_arguments] = STATE(2554),
    [sym_subset2_arguments] = STATE(2553),
    [sym__open_parenthesis] = STATE(1332),
    [sym__open_bracket] = STATE(1331),
    [sym__open_bracket2] = STATE(1330),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5269),
    [anon_sym_DASH] = ACTIONS(5271),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5291),
    [anon_sym_SLASH] = ACTIONS(5293),
    [anon_sym_STAR_STAR] = ACTIONS(5295),
    [anon_sym_CARET] = ACTIONS(5295),
    [aux_sym_binary_operator_token1] = ACTIONS(5297),
    [anon_sym_PIPE_GT] = ACTIONS(5297),
    [anon_sym_COLON] = ACTIONS(5299),
    [anon_sym_DOLLAR] = ACTIONS(5301),
    [anon_sym_AT] = ACTIONS(5301),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5305),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5307),
    [sym__external_open_bracket2] = ACTIONS(5309),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [937] = {
    [sym_call_arguments] = STATE(2555),
    [sym_subset_arguments] = STATE(2554),
    [sym_subset2_arguments] = STATE(2553),
    [sym__open_parenthesis] = STATE(1332),
    [sym__open_bracket] = STATE(1331),
    [sym__open_bracket2] = STATE(1330),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(5295),
    [anon_sym_CARET] = ACTIONS(5295),
    [aux_sym_binary_operator_token1] = ACTIONS(5297),
    [anon_sym_PIPE_GT] = ACTIONS(5297),
    [anon_sym_COLON] = ACTIONS(5299),
    [anon_sym_DOLLAR] = ACTIONS(5301),
    [anon_sym_AT] = ACTIONS(5301),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5305),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5307),
    [sym__external_open_bracket2] = ACTIONS(5309),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [938] = {
    [sym_call_arguments] = STATE(2555),
    [sym_subset_arguments] = STATE(2554),
    [sym_subset2_arguments] = STATE(2553),
    [sym__open_parenthesis] = STATE(1332),
    [sym__open_bracket] = STATE(1331),
    [sym__open_bracket2] = STATE(1330),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(5295),
    [anon_sym_CARET] = ACTIONS(5295),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(5351),
    [anon_sym_DOLLAR] = ACTIONS(5301),
    [anon_sym_AT] = ACTIONS(5301),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5305),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5307),
    [sym__external_open_bracket2] = ACTIONS(5309),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [939] = {
    [sym_call_arguments] = STATE(2555),
    [sym_subset_arguments] = STATE(2554),
    [sym_subset2_arguments] = STATE(2553),
    [sym__open_parenthesis] = STATE(1332),
    [sym__open_bracket] = STATE(1331),
    [sym__open_bracket2] = STATE(1330),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(5295),
    [anon_sym_CARET] = ACTIONS(5295),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(5299),
    [anon_sym_DOLLAR] = ACTIONS(5301),
    [anon_sym_AT] = ACTIONS(5301),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5305),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5307),
    [sym__external_open_bracket2] = ACTIONS(5309),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [940] = {
    [sym_call_arguments] = STATE(2555),
    [sym_subset_arguments] = STATE(2554),
    [sym_subset2_arguments] = STATE(2553),
    [sym__open_parenthesis] = STATE(1332),
    [sym__open_bracket] = STATE(1331),
    [sym__open_bracket2] = STATE(1330),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(5295),
    [anon_sym_CARET] = ACTIONS(5295),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(5351),
    [anon_sym_DOLLAR] = ACTIONS(5301),
    [anon_sym_AT] = ACTIONS(5301),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5305),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5307),
    [sym__external_open_bracket2] = ACTIONS(5309),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [941] = {
    [sym_call_arguments] = STATE(2555),
    [sym_subset_arguments] = STATE(2554),
    [sym_subset2_arguments] = STATE(2553),
    [sym__open_parenthesis] = STATE(1332),
    [sym__open_bracket] = STATE(1331),
    [sym__open_bracket2] = STATE(1330),
    [sym_identifier] = ACTIONS(5401),
    [anon_sym_BSLASH] = ACTIONS(5399),
    [anon_sym_function] = ACTIONS(5401),
    [anon_sym_EQ] = ACTIONS(5265),
    [anon_sym_if] = ACTIONS(5401),
    [anon_sym_for] = ACTIONS(5401),
    [anon_sym_while] = ACTIONS(5401),
    [anon_sym_repeat] = ACTIONS(5401),
    [anon_sym_QMARK] = ACTIONS(5399),
    [anon_sym_TILDE] = ACTIONS(5267),
    [anon_sym_BANG] = ACTIONS(5401),
    [anon_sym_PLUS] = ACTIONS(5269),
    [anon_sym_DASH] = ACTIONS(5271),
    [anon_sym_LT_DASH] = ACTIONS(5273),
    [anon_sym_LT_LT_DASH] = ACTIONS(5273),
    [anon_sym_COLON_EQ] = ACTIONS(5273),
    [anon_sym_DASH_GT] = ACTIONS(5275),
    [anon_sym_DASH_GT_GT] = ACTIONS(5277),
    [anon_sym_PIPE] = ACTIONS(5279),
    [anon_sym_AMP] = ACTIONS(5281),
    [anon_sym_PIPE_PIPE] = ACTIONS(5283),
    [anon_sym_AMP_AMP] = ACTIONS(5285),
    [anon_sym_LT] = ACTIONS(5287),
    [anon_sym_LT_EQ] = ACTIONS(5289),
    [anon_sym_GT] = ACTIONS(5287),
    [anon_sym_GT_EQ] = ACTIONS(5289),
    [anon_sym_EQ_EQ] = ACTIONS(5289),
    [anon_sym_BANG_EQ] = ACTIONS(5289),
    [anon_sym_STAR] = ACTIONS(5291),
    [anon_sym_SLASH] = ACTIONS(5293),
    [anon_sym_STAR_STAR] = ACTIONS(5295),
    [anon_sym_CARET] = ACTIONS(5295),
    [aux_sym_binary_operator_token1] = ACTIONS(5297),
    [anon_sym_PIPE_GT] = ACTIONS(5297),
    [anon_sym_COLON] = ACTIONS(5299),
    [anon_sym_DOLLAR] = ACTIONS(5301),
    [anon_sym_AT] = ACTIONS(5301),
    [aux_sym__hex_literal_token1] = ACTIONS(5399),
    [sym__number_literal] = ACTIONS(5401),
    [anon_sym_SQUOTE] = ACTIONS(5399),
    [anon_sym_DQUOTE] = ACTIONS(5399),
    [sym_return] = ACTIONS(5401),
    [sym_next] = ACTIONS(5401),
    [sym_break] = ACTIONS(5401),
    [sym_true] = ACTIONS(5401),
    [sym_false] = ACTIONS(5401),
    [sym_null] = ACTIONS(5401),
    [sym_inf] = ACTIONS(5401),
    [sym_nan] = ACTIONS(5401),
    [anon_sym_NA] = ACTIONS(5401),
    [anon_sym_NA_integer_] = ACTIONS(5401),
    [anon_sym_NA_real_] = ACTIONS(5401),
    [anon_sym_NA_complex_] = ACTIONS(5401),
    [anon_sym_NA_character_] = ACTIONS(5401),
    [sym_dots] = ACTIONS(5401),
    [sym_dot_dot_i] = ACTIONS(5399),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5399),
    [sym__newline] = ACTIONS(5399),
    [sym__semicolon] = ACTIONS(5399),
    [sym__raw_string_literal] = ACTIONS(5399),
    [sym__external_else] = ACTIONS(5399),
    [sym__external_open_parenthesis] = ACTIONS(5305),
    [sym__external_open_brace] = ACTIONS(5399),
    [sym__external_close_brace] = ACTIONS(5399),
    [sym__external_open_bracket] = ACTIONS(5307),
    [sym__external_open_bracket2] = ACTIONS(5309),
    [sym__external_close_bracket2] = ACTIONS(5399),
  },
  [942] = {
    [sym_call_arguments] = STATE(2555),
    [sym_subset_arguments] = STATE(2554),
    [sym_subset2_arguments] = STATE(2553),
    [sym__open_parenthesis] = STATE(1332),
    [sym__open_bracket] = STATE(1331),
    [sym__open_bracket2] = STATE(1330),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5265),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5267),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5269),
    [anon_sym_DASH] = ACTIONS(5271),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5275),
    [anon_sym_DASH_GT_GT] = ACTIONS(5277),
    [anon_sym_PIPE] = ACTIONS(5279),
    [anon_sym_AMP] = ACTIONS(5281),
    [anon_sym_PIPE_PIPE] = ACTIONS(5283),
    [anon_sym_AMP_AMP] = ACTIONS(5285),
    [anon_sym_LT] = ACTIONS(5287),
    [anon_sym_LT_EQ] = ACTIONS(5289),
    [anon_sym_GT] = ACTIONS(5287),
    [anon_sym_GT_EQ] = ACTIONS(5289),
    [anon_sym_EQ_EQ] = ACTIONS(5289),
    [anon_sym_BANG_EQ] = ACTIONS(5289),
    [anon_sym_STAR] = ACTIONS(5291),
    [anon_sym_SLASH] = ACTIONS(5293),
    [anon_sym_STAR_STAR] = ACTIONS(5295),
    [anon_sym_CARET] = ACTIONS(5295),
    [aux_sym_binary_operator_token1] = ACTIONS(5297),
    [anon_sym_PIPE_GT] = ACTIONS(5297),
    [anon_sym_COLON] = ACTIONS(5299),
    [anon_sym_DOLLAR] = ACTIONS(5301),
    [anon_sym_AT] = ACTIONS(5301),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5305),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5307),
    [sym__external_open_bracket2] = ACTIONS(5309),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [943] = {
    [sym_call_arguments] = STATE(2555),
    [sym_subset_arguments] = STATE(2554),
    [sym_subset2_arguments] = STATE(2553),
    [sym__open_parenthesis] = STATE(1332),
    [sym__open_bracket] = STATE(1331),
    [sym__open_bracket2] = STATE(1330),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5265),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5267),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5269),
    [anon_sym_DASH] = ACTIONS(5271),
    [anon_sym_LT_DASH] = ACTIONS(5273),
    [anon_sym_LT_LT_DASH] = ACTIONS(5273),
    [anon_sym_COLON_EQ] = ACTIONS(5273),
    [anon_sym_DASH_GT] = ACTIONS(5275),
    [anon_sym_DASH_GT_GT] = ACTIONS(5277),
    [anon_sym_PIPE] = ACTIONS(5279),
    [anon_sym_AMP] = ACTIONS(5281),
    [anon_sym_PIPE_PIPE] = ACTIONS(5283),
    [anon_sym_AMP_AMP] = ACTIONS(5285),
    [anon_sym_LT] = ACTIONS(5287),
    [anon_sym_LT_EQ] = ACTIONS(5289),
    [anon_sym_GT] = ACTIONS(5287),
    [anon_sym_GT_EQ] = ACTIONS(5289),
    [anon_sym_EQ_EQ] = ACTIONS(5289),
    [anon_sym_BANG_EQ] = ACTIONS(5289),
    [anon_sym_STAR] = ACTIONS(5291),
    [anon_sym_SLASH] = ACTIONS(5293),
    [anon_sym_STAR_STAR] = ACTIONS(5295),
    [anon_sym_CARET] = ACTIONS(5295),
    [aux_sym_binary_operator_token1] = ACTIONS(5297),
    [anon_sym_PIPE_GT] = ACTIONS(5297),
    [anon_sym_COLON] = ACTIONS(5299),
    [anon_sym_DOLLAR] = ACTIONS(5301),
    [anon_sym_AT] = ACTIONS(5301),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5305),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5307),
    [sym__external_open_bracket2] = ACTIONS(5309),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [944] = {
    [sym_call_arguments] = STATE(2555),
    [sym_subset_arguments] = STATE(2554),
    [sym_subset2_arguments] = STATE(2553),
    [sym__open_parenthesis] = STATE(1332),
    [sym__open_bracket] = STATE(1331),
    [sym__open_bracket2] = STATE(1330),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5269),
    [anon_sym_DASH] = ACTIONS(5271),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5279),
    [anon_sym_AMP] = ACTIONS(5281),
    [anon_sym_PIPE_PIPE] = ACTIONS(5283),
    [anon_sym_AMP_AMP] = ACTIONS(5285),
    [anon_sym_LT] = ACTIONS(5287),
    [anon_sym_LT_EQ] = ACTIONS(5289),
    [anon_sym_GT] = ACTIONS(5287),
    [anon_sym_GT_EQ] = ACTIONS(5289),
    [anon_sym_EQ_EQ] = ACTIONS(5289),
    [anon_sym_BANG_EQ] = ACTIONS(5289),
    [anon_sym_STAR] = ACTIONS(5291),
    [anon_sym_SLASH] = ACTIONS(5293),
    [anon_sym_STAR_STAR] = ACTIONS(5295),
    [anon_sym_CARET] = ACTIONS(5295),
    [aux_sym_binary_operator_token1] = ACTIONS(5297),
    [anon_sym_PIPE_GT] = ACTIONS(5297),
    [anon_sym_COLON] = ACTIONS(5299),
    [anon_sym_DOLLAR] = ACTIONS(5301),
    [anon_sym_AT] = ACTIONS(5301),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5305),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5307),
    [sym__external_open_bracket2] = ACTIONS(5309),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [945] = {
    [sym_call_arguments] = STATE(2555),
    [sym_subset_arguments] = STATE(2554),
    [sym_subset2_arguments] = STATE(2553),
    [sym__open_parenthesis] = STATE(1332),
    [sym__open_bracket] = STATE(1331),
    [sym__open_bracket2] = STATE(1330),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5291),
    [anon_sym_SLASH] = ACTIONS(5293),
    [anon_sym_STAR_STAR] = ACTIONS(5295),
    [anon_sym_CARET] = ACTIONS(5295),
    [aux_sym_binary_operator_token1] = ACTIONS(5297),
    [anon_sym_PIPE_GT] = ACTIONS(5297),
    [anon_sym_COLON] = ACTIONS(5299),
    [anon_sym_DOLLAR] = ACTIONS(5301),
    [anon_sym_AT] = ACTIONS(5301),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5305),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5307),
    [sym__external_open_bracket2] = ACTIONS(5309),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [946] = {
    [sym_call_arguments] = STATE(2555),
    [sym_subset_arguments] = STATE(2554),
    [sym_subset2_arguments] = STATE(2553),
    [sym__open_parenthesis] = STATE(1332),
    [sym__open_bracket] = STATE(1331),
    [sym__open_bracket2] = STATE(1330),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5265),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5267),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5269),
    [anon_sym_DASH] = ACTIONS(5271),
    [anon_sym_LT_DASH] = ACTIONS(5273),
    [anon_sym_LT_LT_DASH] = ACTIONS(5273),
    [anon_sym_COLON_EQ] = ACTIONS(5273),
    [anon_sym_DASH_GT] = ACTIONS(5275),
    [anon_sym_DASH_GT_GT] = ACTIONS(5277),
    [anon_sym_PIPE] = ACTIONS(5279),
    [anon_sym_AMP] = ACTIONS(5281),
    [anon_sym_PIPE_PIPE] = ACTIONS(5283),
    [anon_sym_AMP_AMP] = ACTIONS(5285),
    [anon_sym_LT] = ACTIONS(5287),
    [anon_sym_LT_EQ] = ACTIONS(5289),
    [anon_sym_GT] = ACTIONS(5287),
    [anon_sym_GT_EQ] = ACTIONS(5289),
    [anon_sym_EQ_EQ] = ACTIONS(5289),
    [anon_sym_BANG_EQ] = ACTIONS(5289),
    [anon_sym_STAR] = ACTIONS(5291),
    [anon_sym_SLASH] = ACTIONS(5293),
    [anon_sym_STAR_STAR] = ACTIONS(5295),
    [anon_sym_CARET] = ACTIONS(5295),
    [aux_sym_binary_operator_token1] = ACTIONS(5297),
    [anon_sym_PIPE_GT] = ACTIONS(5297),
    [anon_sym_COLON] = ACTIONS(5299),
    [anon_sym_DOLLAR] = ACTIONS(5301),
    [anon_sym_AT] = ACTIONS(5301),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5305),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5307),
    [sym__external_open_bracket2] = ACTIONS(5309),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [947] = {
    [sym_call_arguments] = STATE(2555),
    [sym_subset_arguments] = STATE(2554),
    [sym_subset2_arguments] = STATE(2553),
    [sym__open_parenthesis] = STATE(1332),
    [sym__open_bracket] = STATE(1331),
    [sym__open_bracket2] = STATE(1330),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5267),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5269),
    [anon_sym_DASH] = ACTIONS(5271),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5279),
    [anon_sym_AMP] = ACTIONS(5281),
    [anon_sym_PIPE_PIPE] = ACTIONS(5283),
    [anon_sym_AMP_AMP] = ACTIONS(5285),
    [anon_sym_LT] = ACTIONS(5287),
    [anon_sym_LT_EQ] = ACTIONS(5289),
    [anon_sym_GT] = ACTIONS(5287),
    [anon_sym_GT_EQ] = ACTIONS(5289),
    [anon_sym_EQ_EQ] = ACTIONS(5289),
    [anon_sym_BANG_EQ] = ACTIONS(5289),
    [anon_sym_STAR] = ACTIONS(5291),
    [anon_sym_SLASH] = ACTIONS(5293),
    [anon_sym_STAR_STAR] = ACTIONS(5295),
    [anon_sym_CARET] = ACTIONS(5295),
    [aux_sym_binary_operator_token1] = ACTIONS(5297),
    [anon_sym_PIPE_GT] = ACTIONS(5297),
    [anon_sym_COLON] = ACTIONS(5299),
    [anon_sym_DOLLAR] = ACTIONS(5301),
    [anon_sym_AT] = ACTIONS(5301),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5305),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5307),
    [sym__external_open_bracket2] = ACTIONS(5309),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [948] = {
    [sym_call_arguments] = STATE(2555),
    [sym_subset_arguments] = STATE(2554),
    [sym_subset2_arguments] = STATE(2553),
    [sym__open_parenthesis] = STATE(1332),
    [sym__open_bracket] = STATE(1331),
    [sym__open_bracket2] = STATE(1330),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5269),
    [anon_sym_DASH] = ACTIONS(5271),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5281),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5285),
    [anon_sym_LT] = ACTIONS(5287),
    [anon_sym_LT_EQ] = ACTIONS(5289),
    [anon_sym_GT] = ACTIONS(5287),
    [anon_sym_GT_EQ] = ACTIONS(5289),
    [anon_sym_EQ_EQ] = ACTIONS(5289),
    [anon_sym_BANG_EQ] = ACTIONS(5289),
    [anon_sym_STAR] = ACTIONS(5291),
    [anon_sym_SLASH] = ACTIONS(5293),
    [anon_sym_STAR_STAR] = ACTIONS(5295),
    [anon_sym_CARET] = ACTIONS(5295),
    [aux_sym_binary_operator_token1] = ACTIONS(5297),
    [anon_sym_PIPE_GT] = ACTIONS(5297),
    [anon_sym_COLON] = ACTIONS(5299),
    [anon_sym_DOLLAR] = ACTIONS(5301),
    [anon_sym_AT] = ACTIONS(5301),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5305),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5307),
    [sym__external_open_bracket2] = ACTIONS(5309),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [949] = {
    [sym_string] = STATE(2330),
    [sym__single_quoted_string] = STATE(2027),
    [sym__double_quoted_string] = STATE(2041),
    [sym__string_or_identifier] = STATE(2330),
    [aux_sym_function_definition_repeat1] = STATE(2199),
    [sym_identifier] = ACTIONS(5877),
    [anon_sym_BSLASH] = ACTIONS(5669),
    [anon_sym_function] = ACTIONS(5673),
    [anon_sym_EQ] = ACTIONS(5673),
    [anon_sym_if] = ACTIONS(5673),
    [anon_sym_for] = ACTIONS(5673),
    [anon_sym_while] = ACTIONS(5673),
    [anon_sym_repeat] = ACTIONS(5673),
    [anon_sym_QMARK] = ACTIONS(5669),
    [anon_sym_TILDE] = ACTIONS(5669),
    [anon_sym_BANG] = ACTIONS(5673),
    [anon_sym_PLUS] = ACTIONS(5669),
    [anon_sym_DASH] = ACTIONS(5673),
    [anon_sym_LT_DASH] = ACTIONS(5669),
    [anon_sym_LT_LT_DASH] = ACTIONS(5669),
    [anon_sym_COLON_EQ] = ACTIONS(5669),
    [anon_sym_DASH_GT] = ACTIONS(5673),
    [anon_sym_DASH_GT_GT] = ACTIONS(5669),
    [anon_sym_PIPE] = ACTIONS(5673),
    [anon_sym_AMP] = ACTIONS(5673),
    [anon_sym_PIPE_PIPE] = ACTIONS(5669),
    [anon_sym_AMP_AMP] = ACTIONS(5669),
    [anon_sym_LT] = ACTIONS(5673),
    [anon_sym_LT_EQ] = ACTIONS(5669),
    [anon_sym_GT] = ACTIONS(5673),
    [anon_sym_GT_EQ] = ACTIONS(5669),
    [anon_sym_EQ_EQ] = ACTIONS(5669),
    [anon_sym_BANG_EQ] = ACTIONS(5669),
    [anon_sym_STAR] = ACTIONS(5673),
    [anon_sym_SLASH] = ACTIONS(5669),
    [anon_sym_STAR_STAR] = ACTIONS(5669),
    [anon_sym_CARET] = ACTIONS(5669),
    [aux_sym_binary_operator_token1] = ACTIONS(5669),
    [anon_sym_PIPE_GT] = ACTIONS(5669),
    [anon_sym_COLON] = ACTIONS(5673),
    [anon_sym_DOLLAR] = ACTIONS(5669),
    [anon_sym_AT] = ACTIONS(5669),
    [aux_sym__hex_literal_token1] = ACTIONS(5669),
    [sym__number_literal] = ACTIONS(5673),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(137),
    [sym_return] = ACTIONS(5673),
    [sym_next] = ACTIONS(5673),
    [sym_break] = ACTIONS(5673),
    [sym_true] = ACTIONS(5673),
    [sym_false] = ACTIONS(5673),
    [sym_null] = ACTIONS(5673),
    [sym_inf] = ACTIONS(5673),
    [sym_nan] = ACTIONS(5673),
    [anon_sym_NA] = ACTIONS(5673),
    [anon_sym_NA_integer_] = ACTIONS(5673),
    [anon_sym_NA_real_] = ACTIONS(5673),
    [anon_sym_NA_complex_] = ACTIONS(5673),
    [anon_sym_NA_character_] = ACTIONS(5673),
    [sym_dots] = ACTIONS(5673),
    [sym_dot_dot_i] = ACTIONS(5669),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5669),
    [sym__newline] = ACTIONS(5669),
    [sym__semicolon] = ACTIONS(5669),
    [sym__raw_string_literal] = ACTIONS(147),
    [sym__external_else] = ACTIONS(5669),
    [sym__external_open_parenthesis] = ACTIONS(5669),
    [sym__external_close_parenthesis] = ACTIONS(5669),
    [sym__external_open_brace] = ACTIONS(5669),
    [sym__external_close_brace] = ACTIONS(5669),
    [sym__external_open_bracket] = ACTIONS(5669),
    [sym__external_close_bracket] = ACTIONS(5669),
    [sym__external_open_bracket2] = ACTIONS(5669),
  },
  [950] = {
    [sym_string] = STATE(2323),
    [sym__single_quoted_string] = STATE(2027),
    [sym__double_quoted_string] = STATE(2041),
    [sym__string_or_identifier] = STATE(2323),
    [aux_sym_function_definition_repeat1] = STATE(949),
    [sym_identifier] = ACTIONS(5879),
    [anon_sym_BSLASH] = ACTIONS(5659),
    [anon_sym_function] = ACTIONS(5663),
    [anon_sym_EQ] = ACTIONS(5663),
    [anon_sym_if] = ACTIONS(5663),
    [anon_sym_for] = ACTIONS(5663),
    [anon_sym_while] = ACTIONS(5663),
    [anon_sym_repeat] = ACTIONS(5663),
    [anon_sym_QMARK] = ACTIONS(5659),
    [anon_sym_TILDE] = ACTIONS(5659),
    [anon_sym_BANG] = ACTIONS(5663),
    [anon_sym_PLUS] = ACTIONS(5659),
    [anon_sym_DASH] = ACTIONS(5663),
    [anon_sym_LT_DASH] = ACTIONS(5659),
    [anon_sym_LT_LT_DASH] = ACTIONS(5659),
    [anon_sym_COLON_EQ] = ACTIONS(5659),
    [anon_sym_DASH_GT] = ACTIONS(5663),
    [anon_sym_DASH_GT_GT] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(5663),
    [anon_sym_AMP] = ACTIONS(5663),
    [anon_sym_PIPE_PIPE] = ACTIONS(5659),
    [anon_sym_AMP_AMP] = ACTIONS(5659),
    [anon_sym_LT] = ACTIONS(5663),
    [anon_sym_LT_EQ] = ACTIONS(5659),
    [anon_sym_GT] = ACTIONS(5663),
    [anon_sym_GT_EQ] = ACTIONS(5659),
    [anon_sym_EQ_EQ] = ACTIONS(5659),
    [anon_sym_BANG_EQ] = ACTIONS(5659),
    [anon_sym_STAR] = ACTIONS(5663),
    [anon_sym_SLASH] = ACTIONS(5659),
    [anon_sym_STAR_STAR] = ACTIONS(5659),
    [anon_sym_CARET] = ACTIONS(5659),
    [aux_sym_binary_operator_token1] = ACTIONS(5659),
    [anon_sym_PIPE_GT] = ACTIONS(5659),
    [anon_sym_COLON] = ACTIONS(5663),
    [anon_sym_DOLLAR] = ACTIONS(5659),
    [anon_sym_AT] = ACTIONS(5659),
    [aux_sym__hex_literal_token1] = ACTIONS(5659),
    [sym__number_literal] = ACTIONS(5663),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(137),
    [sym_return] = ACTIONS(5663),
    [sym_next] = ACTIONS(5663),
    [sym_break] = ACTIONS(5663),
    [sym_true] = ACTIONS(5663),
    [sym_false] = ACTIONS(5663),
    [sym_null] = ACTIONS(5663),
    [sym_inf] = ACTIONS(5663),
    [sym_nan] = ACTIONS(5663),
    [anon_sym_NA] = ACTIONS(5663),
    [anon_sym_NA_integer_] = ACTIONS(5663),
    [anon_sym_NA_real_] = ACTIONS(5663),
    [anon_sym_NA_complex_] = ACTIONS(5663),
    [anon_sym_NA_character_] = ACTIONS(5663),
    [sym_dots] = ACTIONS(5663),
    [sym_dot_dot_i] = ACTIONS(5659),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5659),
    [sym__newline] = ACTIONS(5881),
    [sym__semicolon] = ACTIONS(5659),
    [sym__raw_string_literal] = ACTIONS(147),
    [sym__external_else] = ACTIONS(5659),
    [sym__external_open_parenthesis] = ACTIONS(5659),
    [sym__external_close_parenthesis] = ACTIONS(5659),
    [sym__external_open_brace] = ACTIONS(5659),
    [sym__external_close_brace] = ACTIONS(5659),
    [sym__external_open_bracket] = ACTIONS(5659),
    [sym__external_close_bracket] = ACTIONS(5659),
    [sym__external_open_bracket2] = ACTIONS(5659),
  },
  [951] = {
    [sym_call_arguments] = STATE(2555),
    [sym_subset_arguments] = STATE(2554),
    [sym_subset2_arguments] = STATE(2553),
    [sym__open_parenthesis] = STATE(1332),
    [sym__open_bracket] = STATE(1331),
    [sym__open_bracket2] = STATE(1330),
    [sym_identifier] = ACTIONS(5411),
    [anon_sym_BSLASH] = ACTIONS(5409),
    [anon_sym_function] = ACTIONS(5411),
    [anon_sym_EQ] = ACTIONS(5265),
    [anon_sym_if] = ACTIONS(5411),
    [anon_sym_for] = ACTIONS(5411),
    [anon_sym_while] = ACTIONS(5411),
    [anon_sym_repeat] = ACTIONS(5411),
    [anon_sym_QMARK] = ACTIONS(5409),
    [anon_sym_TILDE] = ACTIONS(5267),
    [anon_sym_BANG] = ACTIONS(5411),
    [anon_sym_PLUS] = ACTIONS(5269),
    [anon_sym_DASH] = ACTIONS(5271),
    [anon_sym_LT_DASH] = ACTIONS(5273),
    [anon_sym_LT_LT_DASH] = ACTIONS(5273),
    [anon_sym_COLON_EQ] = ACTIONS(5273),
    [anon_sym_DASH_GT] = ACTIONS(5275),
    [anon_sym_DASH_GT_GT] = ACTIONS(5277),
    [anon_sym_PIPE] = ACTIONS(5279),
    [anon_sym_AMP] = ACTIONS(5281),
    [anon_sym_PIPE_PIPE] = ACTIONS(5283),
    [anon_sym_AMP_AMP] = ACTIONS(5285),
    [anon_sym_LT] = ACTIONS(5287),
    [anon_sym_LT_EQ] = ACTIONS(5289),
    [anon_sym_GT] = ACTIONS(5287),
    [anon_sym_GT_EQ] = ACTIONS(5289),
    [anon_sym_EQ_EQ] = ACTIONS(5289),
    [anon_sym_BANG_EQ] = ACTIONS(5289),
    [anon_sym_STAR] = ACTIONS(5291),
    [anon_sym_SLASH] = ACTIONS(5293),
    [anon_sym_STAR_STAR] = ACTIONS(5295),
    [anon_sym_CARET] = ACTIONS(5295),
    [aux_sym_binary_operator_token1] = ACTIONS(5297),
    [anon_sym_PIPE_GT] = ACTIONS(5297),
    [anon_sym_COLON] = ACTIONS(5299),
    [anon_sym_DOLLAR] = ACTIONS(5301),
    [anon_sym_AT] = ACTIONS(5301),
    [aux_sym__hex_literal_token1] = ACTIONS(5409),
    [sym__number_literal] = ACTIONS(5411),
    [anon_sym_SQUOTE] = ACTIONS(5409),
    [anon_sym_DQUOTE] = ACTIONS(5409),
    [sym_return] = ACTIONS(5411),
    [sym_next] = ACTIONS(5411),
    [sym_break] = ACTIONS(5411),
    [sym_true] = ACTIONS(5411),
    [sym_false] = ACTIONS(5411),
    [sym_null] = ACTIONS(5411),
    [sym_inf] = ACTIONS(5411),
    [sym_nan] = ACTIONS(5411),
    [anon_sym_NA] = ACTIONS(5411),
    [anon_sym_NA_integer_] = ACTIONS(5411),
    [anon_sym_NA_real_] = ACTIONS(5411),
    [anon_sym_NA_complex_] = ACTIONS(5411),
    [anon_sym_NA_character_] = ACTIONS(5411),
    [sym_dots] = ACTIONS(5411),
    [sym_dot_dot_i] = ACTIONS(5409),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5409),
    [sym__newline] = ACTIONS(5409),
    [sym__semicolon] = ACTIONS(5409),
    [sym__raw_string_literal] = ACTIONS(5409),
    [sym__external_else] = ACTIONS(5409),
    [sym__external_open_parenthesis] = ACTIONS(5305),
    [sym__external_open_brace] = ACTIONS(5409),
    [sym__external_close_brace] = ACTIONS(5409),
    [sym__external_open_bracket] = ACTIONS(5307),
    [sym__external_open_bracket2] = ACTIONS(5309),
    [sym__external_close_bracket2] = ACTIONS(5409),
  },
  [952] = {
    [sym_call_arguments] = STATE(2555),
    [sym_subset_arguments] = STATE(2554),
    [sym_subset2_arguments] = STATE(2553),
    [sym__open_parenthesis] = STATE(1332),
    [sym__open_bracket] = STATE(1331),
    [sym__open_bracket2] = STATE(1330),
    [sym_identifier] = ACTIONS(5455),
    [anon_sym_BSLASH] = ACTIONS(5453),
    [anon_sym_function] = ACTIONS(5455),
    [anon_sym_EQ] = ACTIONS(5265),
    [anon_sym_if] = ACTIONS(5455),
    [anon_sym_for] = ACTIONS(5455),
    [anon_sym_while] = ACTIONS(5455),
    [anon_sym_repeat] = ACTIONS(5455),
    [anon_sym_QMARK] = ACTIONS(5453),
    [anon_sym_TILDE] = ACTIONS(5267),
    [anon_sym_BANG] = ACTIONS(5455),
    [anon_sym_PLUS] = ACTIONS(5269),
    [anon_sym_DASH] = ACTIONS(5271),
    [anon_sym_LT_DASH] = ACTIONS(5273),
    [anon_sym_LT_LT_DASH] = ACTIONS(5273),
    [anon_sym_COLON_EQ] = ACTIONS(5273),
    [anon_sym_DASH_GT] = ACTIONS(5275),
    [anon_sym_DASH_GT_GT] = ACTIONS(5277),
    [anon_sym_PIPE] = ACTIONS(5279),
    [anon_sym_AMP] = ACTIONS(5281),
    [anon_sym_PIPE_PIPE] = ACTIONS(5283),
    [anon_sym_AMP_AMP] = ACTIONS(5285),
    [anon_sym_LT] = ACTIONS(5287),
    [anon_sym_LT_EQ] = ACTIONS(5289),
    [anon_sym_GT] = ACTIONS(5287),
    [anon_sym_GT_EQ] = ACTIONS(5289),
    [anon_sym_EQ_EQ] = ACTIONS(5289),
    [anon_sym_BANG_EQ] = ACTIONS(5289),
    [anon_sym_STAR] = ACTIONS(5291),
    [anon_sym_SLASH] = ACTIONS(5293),
    [anon_sym_STAR_STAR] = ACTIONS(5295),
    [anon_sym_CARET] = ACTIONS(5295),
    [aux_sym_binary_operator_token1] = ACTIONS(5297),
    [anon_sym_PIPE_GT] = ACTIONS(5297),
    [anon_sym_COLON] = ACTIONS(5299),
    [anon_sym_DOLLAR] = ACTIONS(5301),
    [anon_sym_AT] = ACTIONS(5301),
    [aux_sym__hex_literal_token1] = ACTIONS(5453),
    [sym__number_literal] = ACTIONS(5455),
    [anon_sym_SQUOTE] = ACTIONS(5453),
    [anon_sym_DQUOTE] = ACTIONS(5453),
    [sym_return] = ACTIONS(5455),
    [sym_next] = ACTIONS(5455),
    [sym_break] = ACTIONS(5455),
    [sym_true] = ACTIONS(5455),
    [sym_false] = ACTIONS(5455),
    [sym_null] = ACTIONS(5455),
    [sym_inf] = ACTIONS(5455),
    [sym_nan] = ACTIONS(5455),
    [anon_sym_NA] = ACTIONS(5455),
    [anon_sym_NA_integer_] = ACTIONS(5455),
    [anon_sym_NA_real_] = ACTIONS(5455),
    [anon_sym_NA_complex_] = ACTIONS(5455),
    [anon_sym_NA_character_] = ACTIONS(5455),
    [sym_dots] = ACTIONS(5455),
    [sym_dot_dot_i] = ACTIONS(5453),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5453),
    [sym__newline] = ACTIONS(5453),
    [sym__semicolon] = ACTIONS(5453),
    [sym__raw_string_literal] = ACTIONS(5453),
    [sym__external_else] = ACTIONS(5453),
    [sym__external_open_parenthesis] = ACTIONS(5305),
    [sym__external_open_brace] = ACTIONS(5453),
    [sym__external_close_brace] = ACTIONS(5453),
    [sym__external_open_bracket] = ACTIONS(5307),
    [sym__external_open_bracket2] = ACTIONS(5309),
    [sym__external_close_bracket2] = ACTIONS(5453),
  },
  [953] = {
    [sym_call_arguments] = STATE(2555),
    [sym_subset_arguments] = STATE(2554),
    [sym_subset2_arguments] = STATE(2553),
    [sym__open_parenthesis] = STATE(1332),
    [sym__open_bracket] = STATE(1331),
    [sym__open_bracket2] = STATE(1330),
    [sym_identifier] = ACTIONS(5451),
    [anon_sym_BSLASH] = ACTIONS(5449),
    [anon_sym_function] = ACTIONS(5451),
    [anon_sym_EQ] = ACTIONS(5265),
    [anon_sym_if] = ACTIONS(5451),
    [anon_sym_for] = ACTIONS(5451),
    [anon_sym_while] = ACTIONS(5451),
    [anon_sym_repeat] = ACTIONS(5451),
    [anon_sym_QMARK] = ACTIONS(5449),
    [anon_sym_TILDE] = ACTIONS(5267),
    [anon_sym_BANG] = ACTIONS(5451),
    [anon_sym_PLUS] = ACTIONS(5269),
    [anon_sym_DASH] = ACTIONS(5271),
    [anon_sym_LT_DASH] = ACTIONS(5273),
    [anon_sym_LT_LT_DASH] = ACTIONS(5273),
    [anon_sym_COLON_EQ] = ACTIONS(5273),
    [anon_sym_DASH_GT] = ACTIONS(5275),
    [anon_sym_DASH_GT_GT] = ACTIONS(5277),
    [anon_sym_PIPE] = ACTIONS(5279),
    [anon_sym_AMP] = ACTIONS(5281),
    [anon_sym_PIPE_PIPE] = ACTIONS(5283),
    [anon_sym_AMP_AMP] = ACTIONS(5285),
    [anon_sym_LT] = ACTIONS(5287),
    [anon_sym_LT_EQ] = ACTIONS(5289),
    [anon_sym_GT] = ACTIONS(5287),
    [anon_sym_GT_EQ] = ACTIONS(5289),
    [anon_sym_EQ_EQ] = ACTIONS(5289),
    [anon_sym_BANG_EQ] = ACTIONS(5289),
    [anon_sym_STAR] = ACTIONS(5291),
    [anon_sym_SLASH] = ACTIONS(5293),
    [anon_sym_STAR_STAR] = ACTIONS(5295),
    [anon_sym_CARET] = ACTIONS(5295),
    [aux_sym_binary_operator_token1] = ACTIONS(5297),
    [anon_sym_PIPE_GT] = ACTIONS(5297),
    [anon_sym_COLON] = ACTIONS(5299),
    [anon_sym_DOLLAR] = ACTIONS(5301),
    [anon_sym_AT] = ACTIONS(5301),
    [aux_sym__hex_literal_token1] = ACTIONS(5449),
    [sym__number_literal] = ACTIONS(5451),
    [anon_sym_SQUOTE] = ACTIONS(5449),
    [anon_sym_DQUOTE] = ACTIONS(5449),
    [sym_return] = ACTIONS(5451),
    [sym_next] = ACTIONS(5451),
    [sym_break] = ACTIONS(5451),
    [sym_true] = ACTIONS(5451),
    [sym_false] = ACTIONS(5451),
    [sym_null] = ACTIONS(5451),
    [sym_inf] = ACTIONS(5451),
    [sym_nan] = ACTIONS(5451),
    [anon_sym_NA] = ACTIONS(5451),
    [anon_sym_NA_integer_] = ACTIONS(5451),
    [anon_sym_NA_real_] = ACTIONS(5451),
    [anon_sym_NA_complex_] = ACTIONS(5451),
    [anon_sym_NA_character_] = ACTIONS(5451),
    [sym_dots] = ACTIONS(5451),
    [sym_dot_dot_i] = ACTIONS(5449),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5449),
    [sym__newline] = ACTIONS(5449),
    [sym__semicolon] = ACTIONS(5449),
    [sym__raw_string_literal] = ACTIONS(5449),
    [sym__external_else] = ACTIONS(5449),
    [sym__external_open_parenthesis] = ACTIONS(5305),
    [sym__external_open_brace] = ACTIONS(5449),
    [sym__external_close_brace] = ACTIONS(5449),
    [sym__external_open_bracket] = ACTIONS(5307),
    [sym__external_open_bracket2] = ACTIONS(5309),
    [sym__external_close_bracket2] = ACTIONS(5449),
  },
  [954] = {
    [sym_call_arguments] = STATE(2555),
    [sym_subset_arguments] = STATE(2554),
    [sym_subset2_arguments] = STATE(2553),
    [sym__open_parenthesis] = STATE(1332),
    [sym__open_bracket] = STATE(1331),
    [sym__open_bracket2] = STATE(1330),
    [sym_identifier] = ACTIONS(5447),
    [anon_sym_BSLASH] = ACTIONS(5445),
    [anon_sym_function] = ACTIONS(5447),
    [anon_sym_EQ] = ACTIONS(5265),
    [anon_sym_if] = ACTIONS(5447),
    [anon_sym_for] = ACTIONS(5447),
    [anon_sym_while] = ACTIONS(5447),
    [anon_sym_repeat] = ACTIONS(5447),
    [anon_sym_QMARK] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(5267),
    [anon_sym_BANG] = ACTIONS(5447),
    [anon_sym_PLUS] = ACTIONS(5269),
    [anon_sym_DASH] = ACTIONS(5271),
    [anon_sym_LT_DASH] = ACTIONS(5273),
    [anon_sym_LT_LT_DASH] = ACTIONS(5273),
    [anon_sym_COLON_EQ] = ACTIONS(5273),
    [anon_sym_DASH_GT] = ACTIONS(5275),
    [anon_sym_DASH_GT_GT] = ACTIONS(5277),
    [anon_sym_PIPE] = ACTIONS(5279),
    [anon_sym_AMP] = ACTIONS(5281),
    [anon_sym_PIPE_PIPE] = ACTIONS(5283),
    [anon_sym_AMP_AMP] = ACTIONS(5285),
    [anon_sym_LT] = ACTIONS(5287),
    [anon_sym_LT_EQ] = ACTIONS(5289),
    [anon_sym_GT] = ACTIONS(5287),
    [anon_sym_GT_EQ] = ACTIONS(5289),
    [anon_sym_EQ_EQ] = ACTIONS(5289),
    [anon_sym_BANG_EQ] = ACTIONS(5289),
    [anon_sym_STAR] = ACTIONS(5291),
    [anon_sym_SLASH] = ACTIONS(5293),
    [anon_sym_STAR_STAR] = ACTIONS(5295),
    [anon_sym_CARET] = ACTIONS(5295),
    [aux_sym_binary_operator_token1] = ACTIONS(5297),
    [anon_sym_PIPE_GT] = ACTIONS(5297),
    [anon_sym_COLON] = ACTIONS(5299),
    [anon_sym_DOLLAR] = ACTIONS(5301),
    [anon_sym_AT] = ACTIONS(5301),
    [aux_sym__hex_literal_token1] = ACTIONS(5445),
    [sym__number_literal] = ACTIONS(5447),
    [anon_sym_SQUOTE] = ACTIONS(5445),
    [anon_sym_DQUOTE] = ACTIONS(5445),
    [sym_return] = ACTIONS(5447),
    [sym_next] = ACTIONS(5447),
    [sym_break] = ACTIONS(5447),
    [sym_true] = ACTIONS(5447),
    [sym_false] = ACTIONS(5447),
    [sym_null] = ACTIONS(5447),
    [sym_inf] = ACTIONS(5447),
    [sym_nan] = ACTIONS(5447),
    [anon_sym_NA] = ACTIONS(5447),
    [anon_sym_NA_integer_] = ACTIONS(5447),
    [anon_sym_NA_real_] = ACTIONS(5447),
    [anon_sym_NA_complex_] = ACTIONS(5447),
    [anon_sym_NA_character_] = ACTIONS(5447),
    [sym_dots] = ACTIONS(5447),
    [sym_dot_dot_i] = ACTIONS(5445),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5445),
    [sym__newline] = ACTIONS(5445),
    [sym__semicolon] = ACTIONS(5445),
    [sym__raw_string_literal] = ACTIONS(5445),
    [sym__external_else] = ACTIONS(5445),
    [sym__external_open_parenthesis] = ACTIONS(5305),
    [sym__external_open_brace] = ACTIONS(5445),
    [sym__external_close_brace] = ACTIONS(5445),
    [sym__external_open_bracket] = ACTIONS(5307),
    [sym__external_open_bracket2] = ACTIONS(5309),
    [sym__external_close_bracket2] = ACTIONS(5445),
  },
  [955] = {
    [sym_call_arguments] = STATE(2555),
    [sym_subset_arguments] = STATE(2554),
    [sym_subset2_arguments] = STATE(2553),
    [sym__open_parenthesis] = STATE(1332),
    [sym__open_bracket] = STATE(1331),
    [sym__open_bracket2] = STATE(1330),
    [sym_identifier] = ACTIONS(5443),
    [anon_sym_BSLASH] = ACTIONS(5441),
    [anon_sym_function] = ACTIONS(5443),
    [anon_sym_EQ] = ACTIONS(5265),
    [anon_sym_if] = ACTIONS(5443),
    [anon_sym_for] = ACTIONS(5443),
    [anon_sym_while] = ACTIONS(5443),
    [anon_sym_repeat] = ACTIONS(5443),
    [anon_sym_QMARK] = ACTIONS(5441),
    [anon_sym_TILDE] = ACTIONS(5267),
    [anon_sym_BANG] = ACTIONS(5443),
    [anon_sym_PLUS] = ACTIONS(5269),
    [anon_sym_DASH] = ACTIONS(5271),
    [anon_sym_LT_DASH] = ACTIONS(5273),
    [anon_sym_LT_LT_DASH] = ACTIONS(5273),
    [anon_sym_COLON_EQ] = ACTIONS(5273),
    [anon_sym_DASH_GT] = ACTIONS(5275),
    [anon_sym_DASH_GT_GT] = ACTIONS(5277),
    [anon_sym_PIPE] = ACTIONS(5279),
    [anon_sym_AMP] = ACTIONS(5281),
    [anon_sym_PIPE_PIPE] = ACTIONS(5283),
    [anon_sym_AMP_AMP] = ACTIONS(5285),
    [anon_sym_LT] = ACTIONS(5287),
    [anon_sym_LT_EQ] = ACTIONS(5289),
    [anon_sym_GT] = ACTIONS(5287),
    [anon_sym_GT_EQ] = ACTIONS(5289),
    [anon_sym_EQ_EQ] = ACTIONS(5289),
    [anon_sym_BANG_EQ] = ACTIONS(5289),
    [anon_sym_STAR] = ACTIONS(5291),
    [anon_sym_SLASH] = ACTIONS(5293),
    [anon_sym_STAR_STAR] = ACTIONS(5295),
    [anon_sym_CARET] = ACTIONS(5295),
    [aux_sym_binary_operator_token1] = ACTIONS(5297),
    [anon_sym_PIPE_GT] = ACTIONS(5297),
    [anon_sym_COLON] = ACTIONS(5299),
    [anon_sym_DOLLAR] = ACTIONS(5301),
    [anon_sym_AT] = ACTIONS(5301),
    [aux_sym__hex_literal_token1] = ACTIONS(5441),
    [sym__number_literal] = ACTIONS(5443),
    [anon_sym_SQUOTE] = ACTIONS(5441),
    [anon_sym_DQUOTE] = ACTIONS(5441),
    [sym_return] = ACTIONS(5443),
    [sym_next] = ACTIONS(5443),
    [sym_break] = ACTIONS(5443),
    [sym_true] = ACTIONS(5443),
    [sym_false] = ACTIONS(5443),
    [sym_null] = ACTIONS(5443),
    [sym_inf] = ACTIONS(5443),
    [sym_nan] = ACTIONS(5443),
    [anon_sym_NA] = ACTIONS(5443),
    [anon_sym_NA_integer_] = ACTIONS(5443),
    [anon_sym_NA_real_] = ACTIONS(5443),
    [anon_sym_NA_complex_] = ACTIONS(5443),
    [anon_sym_NA_character_] = ACTIONS(5443),
    [sym_dots] = ACTIONS(5443),
    [sym_dot_dot_i] = ACTIONS(5441),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5441),
    [sym__newline] = ACTIONS(5441),
    [sym__semicolon] = ACTIONS(5441),
    [sym__raw_string_literal] = ACTIONS(5441),
    [sym__external_else] = ACTIONS(5441),
    [sym__external_open_parenthesis] = ACTIONS(5305),
    [sym__external_open_brace] = ACTIONS(5441),
    [sym__external_close_brace] = ACTIONS(5441),
    [sym__external_open_bracket] = ACTIONS(5307),
    [sym__external_open_bracket2] = ACTIONS(5309),
    [sym__external_close_bracket2] = ACTIONS(5441),
  },
  [956] = {
    [sym_call_arguments] = STATE(2555),
    [sym_subset_arguments] = STATE(2554),
    [sym_subset2_arguments] = STATE(2553),
    [sym__open_parenthesis] = STATE(1332),
    [sym__open_bracket] = STATE(1331),
    [sym__open_bracket2] = STATE(1330),
    [sym_identifier] = ACTIONS(5439),
    [anon_sym_BSLASH] = ACTIONS(5437),
    [anon_sym_function] = ACTIONS(5439),
    [anon_sym_EQ] = ACTIONS(5265),
    [anon_sym_if] = ACTIONS(5439),
    [anon_sym_for] = ACTIONS(5439),
    [anon_sym_while] = ACTIONS(5439),
    [anon_sym_repeat] = ACTIONS(5439),
    [anon_sym_QMARK] = ACTIONS(5437),
    [anon_sym_TILDE] = ACTIONS(5267),
    [anon_sym_BANG] = ACTIONS(5439),
    [anon_sym_PLUS] = ACTIONS(5269),
    [anon_sym_DASH] = ACTIONS(5271),
    [anon_sym_LT_DASH] = ACTIONS(5273),
    [anon_sym_LT_LT_DASH] = ACTIONS(5273),
    [anon_sym_COLON_EQ] = ACTIONS(5273),
    [anon_sym_DASH_GT] = ACTIONS(5275),
    [anon_sym_DASH_GT_GT] = ACTIONS(5277),
    [anon_sym_PIPE] = ACTIONS(5279),
    [anon_sym_AMP] = ACTIONS(5281),
    [anon_sym_PIPE_PIPE] = ACTIONS(5283),
    [anon_sym_AMP_AMP] = ACTIONS(5285),
    [anon_sym_LT] = ACTIONS(5287),
    [anon_sym_LT_EQ] = ACTIONS(5289),
    [anon_sym_GT] = ACTIONS(5287),
    [anon_sym_GT_EQ] = ACTIONS(5289),
    [anon_sym_EQ_EQ] = ACTIONS(5289),
    [anon_sym_BANG_EQ] = ACTIONS(5289),
    [anon_sym_STAR] = ACTIONS(5291),
    [anon_sym_SLASH] = ACTIONS(5293),
    [anon_sym_STAR_STAR] = ACTIONS(5295),
    [anon_sym_CARET] = ACTIONS(5295),
    [aux_sym_binary_operator_token1] = ACTIONS(5297),
    [anon_sym_PIPE_GT] = ACTIONS(5297),
    [anon_sym_COLON] = ACTIONS(5299),
    [anon_sym_DOLLAR] = ACTIONS(5301),
    [anon_sym_AT] = ACTIONS(5301),
    [aux_sym__hex_literal_token1] = ACTIONS(5437),
    [sym__number_literal] = ACTIONS(5439),
    [anon_sym_SQUOTE] = ACTIONS(5437),
    [anon_sym_DQUOTE] = ACTIONS(5437),
    [sym_return] = ACTIONS(5439),
    [sym_next] = ACTIONS(5439),
    [sym_break] = ACTIONS(5439),
    [sym_true] = ACTIONS(5439),
    [sym_false] = ACTIONS(5439),
    [sym_null] = ACTIONS(5439),
    [sym_inf] = ACTIONS(5439),
    [sym_nan] = ACTIONS(5439),
    [anon_sym_NA] = ACTIONS(5439),
    [anon_sym_NA_integer_] = ACTIONS(5439),
    [anon_sym_NA_real_] = ACTIONS(5439),
    [anon_sym_NA_complex_] = ACTIONS(5439),
    [anon_sym_NA_character_] = ACTIONS(5439),
    [sym_dots] = ACTIONS(5439),
    [sym_dot_dot_i] = ACTIONS(5437),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5437),
    [sym__newline] = ACTIONS(5437),
    [sym__semicolon] = ACTIONS(5437),
    [sym__raw_string_literal] = ACTIONS(5437),
    [sym__external_else] = ACTIONS(5437),
    [sym__external_open_parenthesis] = ACTIONS(5305),
    [sym__external_open_brace] = ACTIONS(5437),
    [sym__external_close_brace] = ACTIONS(5437),
    [sym__external_open_bracket] = ACTIONS(5307),
    [sym__external_open_bracket2] = ACTIONS(5309),
    [sym__external_close_bracket2] = ACTIONS(5437),
  },
  [957] = {
    [sym_call_arguments] = STATE(2555),
    [sym_subset_arguments] = STATE(2554),
    [sym_subset2_arguments] = STATE(2553),
    [sym__open_parenthesis] = STATE(1332),
    [sym__open_bracket] = STATE(1331),
    [sym__open_bracket2] = STATE(1330),
    [sym_identifier] = ACTIONS(5435),
    [anon_sym_BSLASH] = ACTIONS(5433),
    [anon_sym_function] = ACTIONS(5435),
    [anon_sym_EQ] = ACTIONS(5265),
    [anon_sym_if] = ACTIONS(5435),
    [anon_sym_for] = ACTIONS(5435),
    [anon_sym_while] = ACTIONS(5435),
    [anon_sym_repeat] = ACTIONS(5435),
    [anon_sym_QMARK] = ACTIONS(5433),
    [anon_sym_TILDE] = ACTIONS(5267),
    [anon_sym_BANG] = ACTIONS(5435),
    [anon_sym_PLUS] = ACTIONS(5269),
    [anon_sym_DASH] = ACTIONS(5271),
    [anon_sym_LT_DASH] = ACTIONS(5273),
    [anon_sym_LT_LT_DASH] = ACTIONS(5273),
    [anon_sym_COLON_EQ] = ACTIONS(5273),
    [anon_sym_DASH_GT] = ACTIONS(5275),
    [anon_sym_DASH_GT_GT] = ACTIONS(5277),
    [anon_sym_PIPE] = ACTIONS(5279),
    [anon_sym_AMP] = ACTIONS(5281),
    [anon_sym_PIPE_PIPE] = ACTIONS(5283),
    [anon_sym_AMP_AMP] = ACTIONS(5285),
    [anon_sym_LT] = ACTIONS(5287),
    [anon_sym_LT_EQ] = ACTIONS(5289),
    [anon_sym_GT] = ACTIONS(5287),
    [anon_sym_GT_EQ] = ACTIONS(5289),
    [anon_sym_EQ_EQ] = ACTIONS(5289),
    [anon_sym_BANG_EQ] = ACTIONS(5289),
    [anon_sym_STAR] = ACTIONS(5291),
    [anon_sym_SLASH] = ACTIONS(5293),
    [anon_sym_STAR_STAR] = ACTIONS(5295),
    [anon_sym_CARET] = ACTIONS(5295),
    [aux_sym_binary_operator_token1] = ACTIONS(5297),
    [anon_sym_PIPE_GT] = ACTIONS(5297),
    [anon_sym_COLON] = ACTIONS(5299),
    [anon_sym_DOLLAR] = ACTIONS(5301),
    [anon_sym_AT] = ACTIONS(5301),
    [aux_sym__hex_literal_token1] = ACTIONS(5433),
    [sym__number_literal] = ACTIONS(5435),
    [anon_sym_SQUOTE] = ACTIONS(5433),
    [anon_sym_DQUOTE] = ACTIONS(5433),
    [sym_return] = ACTIONS(5435),
    [sym_next] = ACTIONS(5435),
    [sym_break] = ACTIONS(5435),
    [sym_true] = ACTIONS(5435),
    [sym_false] = ACTIONS(5435),
    [sym_null] = ACTIONS(5435),
    [sym_inf] = ACTIONS(5435),
    [sym_nan] = ACTIONS(5435),
    [anon_sym_NA] = ACTIONS(5435),
    [anon_sym_NA_integer_] = ACTIONS(5435),
    [anon_sym_NA_real_] = ACTIONS(5435),
    [anon_sym_NA_complex_] = ACTIONS(5435),
    [anon_sym_NA_character_] = ACTIONS(5435),
    [sym_dots] = ACTIONS(5435),
    [sym_dot_dot_i] = ACTIONS(5433),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5433),
    [sym__newline] = ACTIONS(5433),
    [sym__semicolon] = ACTIONS(5433),
    [sym__raw_string_literal] = ACTIONS(5433),
    [sym__external_else] = ACTIONS(5433),
    [sym__external_open_parenthesis] = ACTIONS(5305),
    [sym__external_open_brace] = ACTIONS(5433),
    [sym__external_close_brace] = ACTIONS(5433),
    [sym__external_open_bracket] = ACTIONS(5307),
    [sym__external_open_bracket2] = ACTIONS(5309),
    [sym__external_close_bracket2] = ACTIONS(5433),
  },
  [958] = {
    [sym_call_arguments] = STATE(2555),
    [sym_subset_arguments] = STATE(2554),
    [sym_subset2_arguments] = STATE(2553),
    [sym__open_parenthesis] = STATE(1332),
    [sym__open_bracket] = STATE(1331),
    [sym__open_bracket2] = STATE(1330),
    [sym_identifier] = ACTIONS(5431),
    [anon_sym_BSLASH] = ACTIONS(5429),
    [anon_sym_function] = ACTIONS(5431),
    [anon_sym_EQ] = ACTIONS(5265),
    [anon_sym_if] = ACTIONS(5431),
    [anon_sym_for] = ACTIONS(5431),
    [anon_sym_while] = ACTIONS(5431),
    [anon_sym_repeat] = ACTIONS(5431),
    [anon_sym_QMARK] = ACTIONS(5429),
    [anon_sym_TILDE] = ACTIONS(5267),
    [anon_sym_BANG] = ACTIONS(5431),
    [anon_sym_PLUS] = ACTIONS(5269),
    [anon_sym_DASH] = ACTIONS(5271),
    [anon_sym_LT_DASH] = ACTIONS(5273),
    [anon_sym_LT_LT_DASH] = ACTIONS(5273),
    [anon_sym_COLON_EQ] = ACTIONS(5273),
    [anon_sym_DASH_GT] = ACTIONS(5275),
    [anon_sym_DASH_GT_GT] = ACTIONS(5277),
    [anon_sym_PIPE] = ACTIONS(5279),
    [anon_sym_AMP] = ACTIONS(5281),
    [anon_sym_PIPE_PIPE] = ACTIONS(5283),
    [anon_sym_AMP_AMP] = ACTIONS(5285),
    [anon_sym_LT] = ACTIONS(5287),
    [anon_sym_LT_EQ] = ACTIONS(5289),
    [anon_sym_GT] = ACTIONS(5287),
    [anon_sym_GT_EQ] = ACTIONS(5289),
    [anon_sym_EQ_EQ] = ACTIONS(5289),
    [anon_sym_BANG_EQ] = ACTIONS(5289),
    [anon_sym_STAR] = ACTIONS(5291),
    [anon_sym_SLASH] = ACTIONS(5293),
    [anon_sym_STAR_STAR] = ACTIONS(5295),
    [anon_sym_CARET] = ACTIONS(5295),
    [aux_sym_binary_operator_token1] = ACTIONS(5297),
    [anon_sym_PIPE_GT] = ACTIONS(5297),
    [anon_sym_COLON] = ACTIONS(5299),
    [anon_sym_DOLLAR] = ACTIONS(5301),
    [anon_sym_AT] = ACTIONS(5301),
    [aux_sym__hex_literal_token1] = ACTIONS(5429),
    [sym__number_literal] = ACTIONS(5431),
    [anon_sym_SQUOTE] = ACTIONS(5429),
    [anon_sym_DQUOTE] = ACTIONS(5429),
    [sym_return] = ACTIONS(5431),
    [sym_next] = ACTIONS(5431),
    [sym_break] = ACTIONS(5431),
    [sym_true] = ACTIONS(5431),
    [sym_false] = ACTIONS(5431),
    [sym_null] = ACTIONS(5431),
    [sym_inf] = ACTIONS(5431),
    [sym_nan] = ACTIONS(5431),
    [anon_sym_NA] = ACTIONS(5431),
    [anon_sym_NA_integer_] = ACTIONS(5431),
    [anon_sym_NA_real_] = ACTIONS(5431),
    [anon_sym_NA_complex_] = ACTIONS(5431),
    [anon_sym_NA_character_] = ACTIONS(5431),
    [sym_dots] = ACTIONS(5431),
    [sym_dot_dot_i] = ACTIONS(5429),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5429),
    [sym__newline] = ACTIONS(5429),
    [sym__semicolon] = ACTIONS(5429),
    [sym__raw_string_literal] = ACTIONS(5429),
    [sym__external_else] = ACTIONS(5429),
    [sym__external_open_parenthesis] = ACTIONS(5305),
    [sym__external_open_brace] = ACTIONS(5429),
    [sym__external_close_brace] = ACTIONS(5429),
    [sym__external_open_bracket] = ACTIONS(5307),
    [sym__external_open_bracket2] = ACTIONS(5309),
    [sym__external_close_bracket2] = ACTIONS(5429),
  },
  [959] = {
    [sym_call_arguments] = STATE(2555),
    [sym_subset_arguments] = STATE(2554),
    [sym_subset2_arguments] = STATE(2553),
    [sym__open_parenthesis] = STATE(1332),
    [sym__open_bracket] = STATE(1331),
    [sym__open_bracket2] = STATE(1330),
    [sym_identifier] = ACTIONS(5427),
    [anon_sym_BSLASH] = ACTIONS(5425),
    [anon_sym_function] = ACTIONS(5427),
    [anon_sym_EQ] = ACTIONS(5265),
    [anon_sym_if] = ACTIONS(5427),
    [anon_sym_for] = ACTIONS(5427),
    [anon_sym_while] = ACTIONS(5427),
    [anon_sym_repeat] = ACTIONS(5427),
    [anon_sym_QMARK] = ACTIONS(5425),
    [anon_sym_TILDE] = ACTIONS(5267),
    [anon_sym_BANG] = ACTIONS(5427),
    [anon_sym_PLUS] = ACTIONS(5269),
    [anon_sym_DASH] = ACTIONS(5271),
    [anon_sym_LT_DASH] = ACTIONS(5273),
    [anon_sym_LT_LT_DASH] = ACTIONS(5273),
    [anon_sym_COLON_EQ] = ACTIONS(5273),
    [anon_sym_DASH_GT] = ACTIONS(5275),
    [anon_sym_DASH_GT_GT] = ACTIONS(5277),
    [anon_sym_PIPE] = ACTIONS(5279),
    [anon_sym_AMP] = ACTIONS(5281),
    [anon_sym_PIPE_PIPE] = ACTIONS(5283),
    [anon_sym_AMP_AMP] = ACTIONS(5285),
    [anon_sym_LT] = ACTIONS(5287),
    [anon_sym_LT_EQ] = ACTIONS(5289),
    [anon_sym_GT] = ACTIONS(5287),
    [anon_sym_GT_EQ] = ACTIONS(5289),
    [anon_sym_EQ_EQ] = ACTIONS(5289),
    [anon_sym_BANG_EQ] = ACTIONS(5289),
    [anon_sym_STAR] = ACTIONS(5291),
    [anon_sym_SLASH] = ACTIONS(5293),
    [anon_sym_STAR_STAR] = ACTIONS(5295),
    [anon_sym_CARET] = ACTIONS(5295),
    [aux_sym_binary_operator_token1] = ACTIONS(5297),
    [anon_sym_PIPE_GT] = ACTIONS(5297),
    [anon_sym_COLON] = ACTIONS(5299),
    [anon_sym_DOLLAR] = ACTIONS(5301),
    [anon_sym_AT] = ACTIONS(5301),
    [aux_sym__hex_literal_token1] = ACTIONS(5425),
    [sym__number_literal] = ACTIONS(5427),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_DQUOTE] = ACTIONS(5425),
    [sym_return] = ACTIONS(5427),
    [sym_next] = ACTIONS(5427),
    [sym_break] = ACTIONS(5427),
    [sym_true] = ACTIONS(5427),
    [sym_false] = ACTIONS(5427),
    [sym_null] = ACTIONS(5427),
    [sym_inf] = ACTIONS(5427),
    [sym_nan] = ACTIONS(5427),
    [anon_sym_NA] = ACTIONS(5427),
    [anon_sym_NA_integer_] = ACTIONS(5427),
    [anon_sym_NA_real_] = ACTIONS(5427),
    [anon_sym_NA_complex_] = ACTIONS(5427),
    [anon_sym_NA_character_] = ACTIONS(5427),
    [sym_dots] = ACTIONS(5427),
    [sym_dot_dot_i] = ACTIONS(5425),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5425),
    [sym__newline] = ACTIONS(5425),
    [sym__semicolon] = ACTIONS(5425),
    [sym__raw_string_literal] = ACTIONS(5425),
    [sym__external_else] = ACTIONS(5425),
    [sym__external_open_parenthesis] = ACTIONS(5305),
    [sym__external_open_brace] = ACTIONS(5425),
    [sym__external_close_brace] = ACTIONS(5425),
    [sym__external_open_bracket] = ACTIONS(5307),
    [sym__external_open_bracket2] = ACTIONS(5309),
    [sym__external_close_bracket2] = ACTIONS(5425),
  },
  [960] = {
    [sym_call_arguments] = STATE(2555),
    [sym_subset_arguments] = STATE(2554),
    [sym_subset2_arguments] = STATE(2553),
    [sym__open_parenthesis] = STATE(1332),
    [sym__open_bracket] = STATE(1331),
    [sym__open_bracket2] = STATE(1330),
    [sym_identifier] = ACTIONS(5423),
    [anon_sym_BSLASH] = ACTIONS(5421),
    [anon_sym_function] = ACTIONS(5423),
    [anon_sym_EQ] = ACTIONS(5265),
    [anon_sym_if] = ACTIONS(5423),
    [anon_sym_for] = ACTIONS(5423),
    [anon_sym_while] = ACTIONS(5423),
    [anon_sym_repeat] = ACTIONS(5423),
    [anon_sym_QMARK] = ACTIONS(5421),
    [anon_sym_TILDE] = ACTIONS(5267),
    [anon_sym_BANG] = ACTIONS(5423),
    [anon_sym_PLUS] = ACTIONS(5269),
    [anon_sym_DASH] = ACTIONS(5271),
    [anon_sym_LT_DASH] = ACTIONS(5273),
    [anon_sym_LT_LT_DASH] = ACTIONS(5273),
    [anon_sym_COLON_EQ] = ACTIONS(5273),
    [anon_sym_DASH_GT] = ACTIONS(5275),
    [anon_sym_DASH_GT_GT] = ACTIONS(5277),
    [anon_sym_PIPE] = ACTIONS(5279),
    [anon_sym_AMP] = ACTIONS(5281),
    [anon_sym_PIPE_PIPE] = ACTIONS(5283),
    [anon_sym_AMP_AMP] = ACTIONS(5285),
    [anon_sym_LT] = ACTIONS(5287),
    [anon_sym_LT_EQ] = ACTIONS(5289),
    [anon_sym_GT] = ACTIONS(5287),
    [anon_sym_GT_EQ] = ACTIONS(5289),
    [anon_sym_EQ_EQ] = ACTIONS(5289),
    [anon_sym_BANG_EQ] = ACTIONS(5289),
    [anon_sym_STAR] = ACTIONS(5291),
    [anon_sym_SLASH] = ACTIONS(5293),
    [anon_sym_STAR_STAR] = ACTIONS(5295),
    [anon_sym_CARET] = ACTIONS(5295),
    [aux_sym_binary_operator_token1] = ACTIONS(5297),
    [anon_sym_PIPE_GT] = ACTIONS(5297),
    [anon_sym_COLON] = ACTIONS(5299),
    [anon_sym_DOLLAR] = ACTIONS(5301),
    [anon_sym_AT] = ACTIONS(5301),
    [aux_sym__hex_literal_token1] = ACTIONS(5421),
    [sym__number_literal] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5421),
    [anon_sym_DQUOTE] = ACTIONS(5421),
    [sym_return] = ACTIONS(5423),
    [sym_next] = ACTIONS(5423),
    [sym_break] = ACTIONS(5423),
    [sym_true] = ACTIONS(5423),
    [sym_false] = ACTIONS(5423),
    [sym_null] = ACTIONS(5423),
    [sym_inf] = ACTIONS(5423),
    [sym_nan] = ACTIONS(5423),
    [anon_sym_NA] = ACTIONS(5423),
    [anon_sym_NA_integer_] = ACTIONS(5423),
    [anon_sym_NA_real_] = ACTIONS(5423),
    [anon_sym_NA_complex_] = ACTIONS(5423),
    [anon_sym_NA_character_] = ACTIONS(5423),
    [sym_dots] = ACTIONS(5423),
    [sym_dot_dot_i] = ACTIONS(5421),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5421),
    [sym__newline] = ACTIONS(5421),
    [sym__semicolon] = ACTIONS(5421),
    [sym__raw_string_literal] = ACTIONS(5421),
    [sym__external_else] = ACTIONS(5421),
    [sym__external_open_parenthesis] = ACTIONS(5305),
    [sym__external_open_brace] = ACTIONS(5421),
    [sym__external_close_brace] = ACTIONS(5421),
    [sym__external_open_bracket] = ACTIONS(5307),
    [sym__external_open_bracket2] = ACTIONS(5309),
    [sym__external_close_bracket2] = ACTIONS(5421),
  },
  [961] = {
    [sym_call_arguments] = STATE(2555),
    [sym_subset_arguments] = STATE(2554),
    [sym_subset2_arguments] = STATE(2553),
    [sym__open_parenthesis] = STATE(1332),
    [sym__open_bracket] = STATE(1331),
    [sym__open_bracket2] = STATE(1330),
    [sym_identifier] = ACTIONS(5419),
    [anon_sym_BSLASH] = ACTIONS(5417),
    [anon_sym_function] = ACTIONS(5419),
    [anon_sym_EQ] = ACTIONS(5265),
    [anon_sym_if] = ACTIONS(5419),
    [anon_sym_for] = ACTIONS(5419),
    [anon_sym_while] = ACTIONS(5419),
    [anon_sym_repeat] = ACTIONS(5419),
    [anon_sym_QMARK] = ACTIONS(5417),
    [anon_sym_TILDE] = ACTIONS(5267),
    [anon_sym_BANG] = ACTIONS(5419),
    [anon_sym_PLUS] = ACTIONS(5269),
    [anon_sym_DASH] = ACTIONS(5271),
    [anon_sym_LT_DASH] = ACTIONS(5273),
    [anon_sym_LT_LT_DASH] = ACTIONS(5273),
    [anon_sym_COLON_EQ] = ACTIONS(5273),
    [anon_sym_DASH_GT] = ACTIONS(5275),
    [anon_sym_DASH_GT_GT] = ACTIONS(5277),
    [anon_sym_PIPE] = ACTIONS(5279),
    [anon_sym_AMP] = ACTIONS(5281),
    [anon_sym_PIPE_PIPE] = ACTIONS(5283),
    [anon_sym_AMP_AMP] = ACTIONS(5285),
    [anon_sym_LT] = ACTIONS(5287),
    [anon_sym_LT_EQ] = ACTIONS(5289),
    [anon_sym_GT] = ACTIONS(5287),
    [anon_sym_GT_EQ] = ACTIONS(5289),
    [anon_sym_EQ_EQ] = ACTIONS(5289),
    [anon_sym_BANG_EQ] = ACTIONS(5289),
    [anon_sym_STAR] = ACTIONS(5291),
    [anon_sym_SLASH] = ACTIONS(5293),
    [anon_sym_STAR_STAR] = ACTIONS(5295),
    [anon_sym_CARET] = ACTIONS(5295),
    [aux_sym_binary_operator_token1] = ACTIONS(5297),
    [anon_sym_PIPE_GT] = ACTIONS(5297),
    [anon_sym_COLON] = ACTIONS(5299),
    [anon_sym_DOLLAR] = ACTIONS(5301),
    [anon_sym_AT] = ACTIONS(5301),
    [aux_sym__hex_literal_token1] = ACTIONS(5417),
    [sym__number_literal] = ACTIONS(5419),
    [anon_sym_SQUOTE] = ACTIONS(5417),
    [anon_sym_DQUOTE] = ACTIONS(5417),
    [sym_return] = ACTIONS(5419),
    [sym_next] = ACTIONS(5419),
    [sym_break] = ACTIONS(5419),
    [sym_true] = ACTIONS(5419),
    [sym_false] = ACTIONS(5419),
    [sym_null] = ACTIONS(5419),
    [sym_inf] = ACTIONS(5419),
    [sym_nan] = ACTIONS(5419),
    [anon_sym_NA] = ACTIONS(5419),
    [anon_sym_NA_integer_] = ACTIONS(5419),
    [anon_sym_NA_real_] = ACTIONS(5419),
    [anon_sym_NA_complex_] = ACTIONS(5419),
    [anon_sym_NA_character_] = ACTIONS(5419),
    [sym_dots] = ACTIONS(5419),
    [sym_dot_dot_i] = ACTIONS(5417),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5417),
    [sym__newline] = ACTIONS(5417),
    [sym__semicolon] = ACTIONS(5417),
    [sym__raw_string_literal] = ACTIONS(5417),
    [sym__external_else] = ACTIONS(5417),
    [sym__external_open_parenthesis] = ACTIONS(5305),
    [sym__external_open_brace] = ACTIONS(5417),
    [sym__external_close_brace] = ACTIONS(5417),
    [sym__external_open_bracket] = ACTIONS(5307),
    [sym__external_open_bracket2] = ACTIONS(5309),
    [sym__external_close_bracket2] = ACTIONS(5417),
  },
  [962] = {
    [sym_call_arguments] = STATE(2555),
    [sym_subset_arguments] = STATE(2554),
    [sym_subset2_arguments] = STATE(2553),
    [sym__open_parenthesis] = STATE(1332),
    [sym__open_bracket] = STATE(1331),
    [sym__open_bracket2] = STATE(1330),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_BSLASH] = ACTIONS(5413),
    [anon_sym_function] = ACTIONS(5415),
    [anon_sym_EQ] = ACTIONS(5265),
    [anon_sym_if] = ACTIONS(5415),
    [anon_sym_for] = ACTIONS(5415),
    [anon_sym_while] = ACTIONS(5415),
    [anon_sym_repeat] = ACTIONS(5415),
    [anon_sym_QMARK] = ACTIONS(5413),
    [anon_sym_TILDE] = ACTIONS(5267),
    [anon_sym_BANG] = ACTIONS(5415),
    [anon_sym_PLUS] = ACTIONS(5269),
    [anon_sym_DASH] = ACTIONS(5271),
    [anon_sym_LT_DASH] = ACTIONS(5273),
    [anon_sym_LT_LT_DASH] = ACTIONS(5273),
    [anon_sym_COLON_EQ] = ACTIONS(5273),
    [anon_sym_DASH_GT] = ACTIONS(5275),
    [anon_sym_DASH_GT_GT] = ACTIONS(5277),
    [anon_sym_PIPE] = ACTIONS(5279),
    [anon_sym_AMP] = ACTIONS(5281),
    [anon_sym_PIPE_PIPE] = ACTIONS(5283),
    [anon_sym_AMP_AMP] = ACTIONS(5285),
    [anon_sym_LT] = ACTIONS(5287),
    [anon_sym_LT_EQ] = ACTIONS(5289),
    [anon_sym_GT] = ACTIONS(5287),
    [anon_sym_GT_EQ] = ACTIONS(5289),
    [anon_sym_EQ_EQ] = ACTIONS(5289),
    [anon_sym_BANG_EQ] = ACTIONS(5289),
    [anon_sym_STAR] = ACTIONS(5291),
    [anon_sym_SLASH] = ACTIONS(5293),
    [anon_sym_STAR_STAR] = ACTIONS(5295),
    [anon_sym_CARET] = ACTIONS(5295),
    [aux_sym_binary_operator_token1] = ACTIONS(5297),
    [anon_sym_PIPE_GT] = ACTIONS(5297),
    [anon_sym_COLON] = ACTIONS(5299),
    [anon_sym_DOLLAR] = ACTIONS(5301),
    [anon_sym_AT] = ACTIONS(5301),
    [aux_sym__hex_literal_token1] = ACTIONS(5413),
    [sym__number_literal] = ACTIONS(5415),
    [anon_sym_SQUOTE] = ACTIONS(5413),
    [anon_sym_DQUOTE] = ACTIONS(5413),
    [sym_return] = ACTIONS(5415),
    [sym_next] = ACTIONS(5415),
    [sym_break] = ACTIONS(5415),
    [sym_true] = ACTIONS(5415),
    [sym_false] = ACTIONS(5415),
    [sym_null] = ACTIONS(5415),
    [sym_inf] = ACTIONS(5415),
    [sym_nan] = ACTIONS(5415),
    [anon_sym_NA] = ACTIONS(5415),
    [anon_sym_NA_integer_] = ACTIONS(5415),
    [anon_sym_NA_real_] = ACTIONS(5415),
    [anon_sym_NA_complex_] = ACTIONS(5415),
    [anon_sym_NA_character_] = ACTIONS(5415),
    [sym_dots] = ACTIONS(5415),
    [sym_dot_dot_i] = ACTIONS(5413),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5413),
    [sym__newline] = ACTIONS(5413),
    [sym__semicolon] = ACTIONS(5413),
    [sym__raw_string_literal] = ACTIONS(5413),
    [sym__external_else] = ACTIONS(5413),
    [sym__external_open_parenthesis] = ACTIONS(5305),
    [sym__external_open_brace] = ACTIONS(5413),
    [sym__external_close_brace] = ACTIONS(5413),
    [sym__external_open_bracket] = ACTIONS(5307),
    [sym__external_open_bracket2] = ACTIONS(5309),
    [sym__external_close_bracket2] = ACTIONS(5413),
  },
  [963] = {
    [sym_call_arguments] = STATE(2555),
    [sym_subset_arguments] = STATE(2554),
    [sym_subset2_arguments] = STATE(2553),
    [sym__open_parenthesis] = STATE(1332),
    [sym__open_bracket] = STATE(1331),
    [sym__open_bracket2] = STATE(1330),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(5295),
    [anon_sym_CARET] = ACTIONS(5295),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(5261),
    [anon_sym_DOLLAR] = ACTIONS(5301),
    [anon_sym_AT] = ACTIONS(5301),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5305),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5307),
    [sym__external_open_bracket2] = ACTIONS(5309),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [964] = {
    [sym_call_arguments] = STATE(2555),
    [sym_subset_arguments] = STATE(2554),
    [sym_subset2_arguments] = STATE(2553),
    [sym__open_parenthesis] = STATE(1332),
    [sym__open_bracket] = STATE(1331),
    [sym__open_bracket2] = STATE(1330),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(5295),
    [anon_sym_CARET] = ACTIONS(5295),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(5299),
    [anon_sym_DOLLAR] = ACTIONS(5301),
    [anon_sym_AT] = ACTIONS(5301),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5305),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5307),
    [sym__external_open_bracket2] = ACTIONS(5309),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [965] = {
    [sym_call_arguments] = STATE(2555),
    [sym_subset_arguments] = STATE(2554),
    [sym_subset2_arguments] = STATE(2553),
    [sym__open_parenthesis] = STATE(1332),
    [sym__open_bracket] = STATE(1331),
    [sym__open_bracket2] = STATE(1330),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(5295),
    [anon_sym_CARET] = ACTIONS(5295),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(5261),
    [anon_sym_DOLLAR] = ACTIONS(5301),
    [anon_sym_AT] = ACTIONS(5301),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5305),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5307),
    [sym__external_open_bracket2] = ACTIONS(5309),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [966] = {
    [sym_call_arguments] = STATE(2555),
    [sym_subset_arguments] = STATE(2554),
    [sym_subset2_arguments] = STATE(2553),
    [sym__open_parenthesis] = STATE(1332),
    [sym__open_bracket] = STATE(1331),
    [sym__open_bracket2] = STATE(1330),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(5295),
    [anon_sym_CARET] = ACTIONS(5295),
    [aux_sym_binary_operator_token1] = ACTIONS(5297),
    [anon_sym_PIPE_GT] = ACTIONS(5297),
    [anon_sym_COLON] = ACTIONS(5299),
    [anon_sym_DOLLAR] = ACTIONS(5301),
    [anon_sym_AT] = ACTIONS(5301),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5305),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5307),
    [sym__external_open_bracket2] = ACTIONS(5309),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [967] = {
    [sym_call_arguments] = STATE(2555),
    [sym_subset_arguments] = STATE(2554),
    [sym_subset2_arguments] = STATE(2553),
    [sym__open_parenthesis] = STATE(1332),
    [sym__open_bracket] = STATE(1331),
    [sym__open_bracket2] = STATE(1330),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5269),
    [anon_sym_DASH] = ACTIONS(5271),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5291),
    [anon_sym_SLASH] = ACTIONS(5293),
    [anon_sym_STAR_STAR] = ACTIONS(5295),
    [anon_sym_CARET] = ACTIONS(5295),
    [aux_sym_binary_operator_token1] = ACTIONS(5297),
    [anon_sym_PIPE_GT] = ACTIONS(5297),
    [anon_sym_COLON] = ACTIONS(5299),
    [anon_sym_DOLLAR] = ACTIONS(5301),
    [anon_sym_AT] = ACTIONS(5301),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5305),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5307),
    [sym__external_open_bracket2] = ACTIONS(5309),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [968] = {
    [sym_string] = STATE(2246),
    [sym__single_quoted_string] = STATE(1985),
    [sym__double_quoted_string] = STATE(1990),
    [sym__string_or_identifier] = STATE(2246),
    [ts_builtin_sym_end] = ACTIONS(5883),
    [sym_identifier] = ACTIONS(5885),
    [anon_sym_BSLASH] = ACTIONS(5883),
    [anon_sym_function] = ACTIONS(5887),
    [anon_sym_EQ] = ACTIONS(5887),
    [anon_sym_if] = ACTIONS(5887),
    [anon_sym_for] = ACTIONS(5887),
    [anon_sym_while] = ACTIONS(5887),
    [anon_sym_repeat] = ACTIONS(5887),
    [anon_sym_QMARK] = ACTIONS(5883),
    [anon_sym_TILDE] = ACTIONS(5883),
    [anon_sym_BANG] = ACTIONS(5887),
    [anon_sym_PLUS] = ACTIONS(5883),
    [anon_sym_DASH] = ACTIONS(5887),
    [anon_sym_LT_DASH] = ACTIONS(5883),
    [anon_sym_LT_LT_DASH] = ACTIONS(5883),
    [anon_sym_COLON_EQ] = ACTIONS(5883),
    [anon_sym_DASH_GT] = ACTIONS(5887),
    [anon_sym_DASH_GT_GT] = ACTIONS(5883),
    [anon_sym_PIPE] = ACTIONS(5887),
    [anon_sym_AMP] = ACTIONS(5887),
    [anon_sym_PIPE_PIPE] = ACTIONS(5883),
    [anon_sym_AMP_AMP] = ACTIONS(5883),
    [anon_sym_LT] = ACTIONS(5887),
    [anon_sym_LT_EQ] = ACTIONS(5883),
    [anon_sym_GT] = ACTIONS(5887),
    [anon_sym_GT_EQ] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5883),
    [anon_sym_BANG_EQ] = ACTIONS(5883),
    [anon_sym_STAR] = ACTIONS(5887),
    [anon_sym_SLASH] = ACTIONS(5883),
    [anon_sym_STAR_STAR] = ACTIONS(5883),
    [anon_sym_CARET] = ACTIONS(5883),
    [aux_sym_binary_operator_token1] = ACTIONS(5883),
    [anon_sym_PIPE_GT] = ACTIONS(5883),
    [anon_sym_COLON] = ACTIONS(5887),
    [anon_sym_DOLLAR] = ACTIONS(5883),
    [anon_sym_AT] = ACTIONS(5883),
    [aux_sym__hex_literal_token1] = ACTIONS(5883),
    [sym__number_literal] = ACTIONS(5887),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_return] = ACTIONS(5887),
    [sym_next] = ACTIONS(5887),
    [sym_break] = ACTIONS(5887),
    [sym_true] = ACTIONS(5887),
    [sym_false] = ACTIONS(5887),
    [sym_null] = ACTIONS(5887),
    [sym_inf] = ACTIONS(5887),
    [sym_nan] = ACTIONS(5887),
    [anon_sym_NA] = ACTIONS(5887),
    [anon_sym_NA_integer_] = ACTIONS(5887),
    [anon_sym_NA_real_] = ACTIONS(5887),
    [anon_sym_NA_complex_] = ACTIONS(5887),
    [anon_sym_NA_character_] = ACTIONS(5887),
    [sym_dots] = ACTIONS(5887),
    [sym_dot_dot_i] = ACTIONS(5883),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5883),
    [sym__newline] = ACTIONS(5883),
    [sym__semicolon] = ACTIONS(5883),
    [sym__raw_string_literal] = ACTIONS(95),
    [sym__external_else] = ACTIONS(5883),
    [sym__external_open_parenthesis] = ACTIONS(5883),
    [sym__external_close_parenthesis] = ACTIONS(5883),
    [sym__external_open_brace] = ACTIONS(5883),
    [sym__external_close_brace] = ACTIONS(5883),
    [sym__external_open_bracket] = ACTIONS(5883),
    [sym__external_open_bracket2] = ACTIONS(5883),
  },
  [969] = {
    [sym_call_arguments] = STATE(2731),
    [sym_subset_arguments] = STATE(2730),
    [sym_subset2_arguments] = STATE(2729),
    [sym__open_parenthesis] = STATE(1357),
    [sym__open_bracket] = STATE(1353),
    [sym__open_bracket2] = STATE(1352),
    [sym_identifier] = ACTIONS(5411),
    [anon_sym_BSLASH] = ACTIONS(5409),
    [anon_sym_function] = ACTIONS(5411),
    [anon_sym_EQ] = ACTIONS(5783),
    [anon_sym_if] = ACTIONS(5411),
    [anon_sym_for] = ACTIONS(5411),
    [anon_sym_while] = ACTIONS(5411),
    [anon_sym_repeat] = ACTIONS(5411),
    [anon_sym_QMARK] = ACTIONS(5409),
    [anon_sym_TILDE] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(5411),
    [anon_sym_PLUS] = ACTIONS(5787),
    [anon_sym_DASH] = ACTIONS(5789),
    [anon_sym_LT_DASH] = ACTIONS(5791),
    [anon_sym_LT_LT_DASH] = ACTIONS(5791),
    [anon_sym_COLON_EQ] = ACTIONS(5791),
    [anon_sym_DASH_GT] = ACTIONS(5793),
    [anon_sym_DASH_GT_GT] = ACTIONS(5795),
    [anon_sym_PIPE] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5799),
    [anon_sym_PIPE_PIPE] = ACTIONS(5801),
    [anon_sym_AMP_AMP] = ACTIONS(5803),
    [anon_sym_LT] = ACTIONS(5805),
    [anon_sym_LT_EQ] = ACTIONS(5807),
    [anon_sym_GT] = ACTIONS(5805),
    [anon_sym_GT_EQ] = ACTIONS(5807),
    [anon_sym_EQ_EQ] = ACTIONS(5807),
    [anon_sym_BANG_EQ] = ACTIONS(5807),
    [anon_sym_STAR] = ACTIONS(5809),
    [anon_sym_SLASH] = ACTIONS(5811),
    [anon_sym_STAR_STAR] = ACTIONS(5813),
    [anon_sym_CARET] = ACTIONS(5813),
    [aux_sym_binary_operator_token1] = ACTIONS(5815),
    [anon_sym_PIPE_GT] = ACTIONS(5815),
    [anon_sym_COLON] = ACTIONS(5817),
    [anon_sym_DOLLAR] = ACTIONS(5819),
    [anon_sym_AT] = ACTIONS(5819),
    [aux_sym__hex_literal_token1] = ACTIONS(5409),
    [sym__number_literal] = ACTIONS(5411),
    [anon_sym_SQUOTE] = ACTIONS(5409),
    [anon_sym_DQUOTE] = ACTIONS(5409),
    [sym_return] = ACTIONS(5411),
    [sym_next] = ACTIONS(5411),
    [sym_break] = ACTIONS(5411),
    [sym_true] = ACTIONS(5411),
    [sym_false] = ACTIONS(5411),
    [sym_null] = ACTIONS(5411),
    [sym_inf] = ACTIONS(5411),
    [sym_nan] = ACTIONS(5411),
    [anon_sym_NA] = ACTIONS(5411),
    [anon_sym_NA_integer_] = ACTIONS(5411),
    [anon_sym_NA_real_] = ACTIONS(5411),
    [anon_sym_NA_complex_] = ACTIONS(5411),
    [anon_sym_NA_character_] = ACTIONS(5411),
    [sym_dots] = ACTIONS(5411),
    [sym_dot_dot_i] = ACTIONS(5409),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5409),
    [sym__newline] = ACTIONS(5409),
    [sym__raw_string_literal] = ACTIONS(5409),
    [sym__external_else] = ACTIONS(5409),
    [sym__external_open_parenthesis] = ACTIONS(5823),
    [sym__external_close_parenthesis] = ACTIONS(5409),
    [sym__external_open_brace] = ACTIONS(5409),
    [sym__external_open_bracket] = ACTIONS(5825),
    [sym__external_close_bracket] = ACTIONS(5409),
    [sym__external_open_bracket2] = ACTIONS(5827),
  },
  [970] = {
    [sym_call_arguments] = STATE(2671),
    [sym_subset_arguments] = STATE(2663),
    [sym_subset2_arguments] = STATE(2661),
    [sym__open_parenthesis] = STATE(1555),
    [sym__open_bracket] = STATE(1551),
    [sym__open_bracket2] = STATE(1549),
    [sym_identifier] = ACTIONS(5325),
    [anon_sym_BSLASH] = ACTIONS(5327),
    [anon_sym_function] = ACTIONS(5325),
    [anon_sym_EQ] = ACTIONS(5889),
    [anon_sym_if] = ACTIONS(5325),
    [anon_sym_for] = ACTIONS(5325),
    [anon_sym_while] = ACTIONS(5325),
    [anon_sym_repeat] = ACTIONS(5325),
    [anon_sym_QMARK] = ACTIONS(5891),
    [anon_sym_TILDE] = ACTIONS(5893),
    [anon_sym_BANG] = ACTIONS(5325),
    [anon_sym_PLUS] = ACTIONS(5895),
    [anon_sym_DASH] = ACTIONS(5897),
    [anon_sym_LT_DASH] = ACTIONS(5899),
    [anon_sym_LT_LT_DASH] = ACTIONS(5899),
    [anon_sym_COLON_EQ] = ACTIONS(5899),
    [anon_sym_DASH_GT] = ACTIONS(5901),
    [anon_sym_DASH_GT_GT] = ACTIONS(5903),
    [anon_sym_PIPE] = ACTIONS(5905),
    [anon_sym_AMP] = ACTIONS(5907),
    [anon_sym_PIPE_PIPE] = ACTIONS(5909),
    [anon_sym_AMP_AMP] = ACTIONS(5911),
    [anon_sym_LT] = ACTIONS(5913),
    [anon_sym_LT_EQ] = ACTIONS(5915),
    [anon_sym_GT] = ACTIONS(5913),
    [anon_sym_GT_EQ] = ACTIONS(5915),
    [anon_sym_EQ_EQ] = ACTIONS(5915),
    [anon_sym_BANG_EQ] = ACTIONS(5915),
    [anon_sym_STAR] = ACTIONS(5917),
    [anon_sym_SLASH] = ACTIONS(5919),
    [anon_sym_STAR_STAR] = ACTIONS(5921),
    [anon_sym_CARET] = ACTIONS(5921),
    [aux_sym_binary_operator_token1] = ACTIONS(5923),
    [anon_sym_PIPE_GT] = ACTIONS(5923),
    [anon_sym_COLON] = ACTIONS(5925),
    [anon_sym_DOLLAR] = ACTIONS(5927),
    [anon_sym_AT] = ACTIONS(5927),
    [aux_sym__hex_literal_token1] = ACTIONS(5327),
    [sym__number_literal] = ACTIONS(5325),
    [anon_sym_SQUOTE] = ACTIONS(5327),
    [anon_sym_DQUOTE] = ACTIONS(5327),
    [sym_return] = ACTIONS(5325),
    [sym_next] = ACTIONS(5325),
    [sym_break] = ACTIONS(5325),
    [sym_true] = ACTIONS(5325),
    [sym_false] = ACTIONS(5325),
    [sym_null] = ACTIONS(5325),
    [sym_inf] = ACTIONS(5325),
    [sym_nan] = ACTIONS(5325),
    [anon_sym_NA] = ACTIONS(5325),
    [anon_sym_NA_integer_] = ACTIONS(5325),
    [anon_sym_NA_real_] = ACTIONS(5325),
    [anon_sym_NA_complex_] = ACTIONS(5325),
    [anon_sym_NA_character_] = ACTIONS(5325),
    [sym_dots] = ACTIONS(5325),
    [sym_dot_dot_i] = ACTIONS(5327),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5327),
    [sym__newline] = ACTIONS(5327),
    [sym__semicolon] = ACTIONS(5327),
    [sym__raw_string_literal] = ACTIONS(5327),
    [sym__external_open_parenthesis] = ACTIONS(5929),
    [sym__external_open_brace] = ACTIONS(5327),
    [sym__external_close_brace] = ACTIONS(5327),
    [sym__external_open_bracket] = ACTIONS(5931),
    [sym__external_close_bracket] = ACTIONS(5327),
    [sym__external_open_bracket2] = ACTIONS(5933),
  },
  [971] = {
    [sym_string] = STATE(2537),
    [sym__single_quoted_string] = STATE(2221),
    [sym__double_quoted_string] = STATE(2222),
    [sym__string_or_identifier] = STATE(2537),
    [aux_sym_function_definition_repeat1] = STATE(973),
    [sym_identifier] = ACTIONS(5935),
    [anon_sym_BSLASH] = ACTIONS(5659),
    [anon_sym_function] = ACTIONS(5663),
    [anon_sym_EQ] = ACTIONS(5663),
    [anon_sym_if] = ACTIONS(5663),
    [anon_sym_for] = ACTIONS(5663),
    [anon_sym_while] = ACTIONS(5663),
    [anon_sym_repeat] = ACTIONS(5663),
    [anon_sym_QMARK] = ACTIONS(5659),
    [anon_sym_TILDE] = ACTIONS(5659),
    [anon_sym_BANG] = ACTIONS(5663),
    [anon_sym_PLUS] = ACTIONS(5659),
    [anon_sym_DASH] = ACTIONS(5663),
    [anon_sym_LT_DASH] = ACTIONS(5659),
    [anon_sym_LT_LT_DASH] = ACTIONS(5659),
    [anon_sym_COLON_EQ] = ACTIONS(5659),
    [anon_sym_DASH_GT] = ACTIONS(5663),
    [anon_sym_DASH_GT_GT] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(5663),
    [anon_sym_AMP] = ACTIONS(5663),
    [anon_sym_PIPE_PIPE] = ACTIONS(5659),
    [anon_sym_AMP_AMP] = ACTIONS(5659),
    [anon_sym_LT] = ACTIONS(5663),
    [anon_sym_LT_EQ] = ACTIONS(5659),
    [anon_sym_GT] = ACTIONS(5663),
    [anon_sym_GT_EQ] = ACTIONS(5659),
    [anon_sym_EQ_EQ] = ACTIONS(5659),
    [anon_sym_BANG_EQ] = ACTIONS(5659),
    [anon_sym_STAR] = ACTIONS(5663),
    [anon_sym_SLASH] = ACTIONS(5659),
    [anon_sym_STAR_STAR] = ACTIONS(5659),
    [anon_sym_CARET] = ACTIONS(5659),
    [aux_sym_binary_operator_token1] = ACTIONS(5659),
    [anon_sym_PIPE_GT] = ACTIONS(5659),
    [anon_sym_COLON] = ACTIONS(5663),
    [anon_sym_DOLLAR] = ACTIONS(5659),
    [anon_sym_AT] = ACTIONS(5659),
    [aux_sym__hex_literal_token1] = ACTIONS(5659),
    [sym__number_literal] = ACTIONS(5663),
    [anon_sym_SQUOTE] = ACTIONS(654),
    [anon_sym_DQUOTE] = ACTIONS(656),
    [sym_return] = ACTIONS(5663),
    [sym_next] = ACTIONS(5663),
    [sym_break] = ACTIONS(5663),
    [sym_true] = ACTIONS(5663),
    [sym_false] = ACTIONS(5663),
    [sym_null] = ACTIONS(5663),
    [sym_inf] = ACTIONS(5663),
    [sym_nan] = ACTIONS(5663),
    [anon_sym_NA] = ACTIONS(5663),
    [anon_sym_NA_integer_] = ACTIONS(5663),
    [anon_sym_NA_real_] = ACTIONS(5663),
    [anon_sym_NA_complex_] = ACTIONS(5663),
    [anon_sym_NA_character_] = ACTIONS(5663),
    [sym_dots] = ACTIONS(5663),
    [sym_dot_dot_i] = ACTIONS(5659),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5659),
    [sym__newline] = ACTIONS(5937),
    [sym__semicolon] = ACTIONS(5659),
    [sym__raw_string_literal] = ACTIONS(666),
    [sym__external_open_parenthesis] = ACTIONS(5659),
    [sym__external_close_parenthesis] = ACTIONS(5659),
    [sym__external_open_brace] = ACTIONS(5659),
    [sym__external_close_brace] = ACTIONS(5659),
    [sym__external_open_bracket] = ACTIONS(5659),
    [sym__external_open_bracket2] = ACTIONS(5659),
    [sym__external_close_bracket2] = ACTIONS(5659),
  },
  [972] = {
    [sym_string] = STATE(2426),
    [sym__single_quoted_string] = STATE(2188),
    [sym__double_quoted_string] = STATE(2187),
    [sym__string_or_identifier] = STATE(2426),
    [aux_sym_function_definition_repeat1] = STATE(2336),
    [sym_identifier] = ACTIONS(5939),
    [anon_sym_BSLASH] = ACTIONS(5669),
    [anon_sym_function] = ACTIONS(5673),
    [anon_sym_EQ] = ACTIONS(5673),
    [anon_sym_if] = ACTIONS(5673),
    [anon_sym_for] = ACTIONS(5673),
    [anon_sym_while] = ACTIONS(5673),
    [anon_sym_repeat] = ACTIONS(5673),
    [anon_sym_QMARK] = ACTIONS(5669),
    [anon_sym_TILDE] = ACTIONS(5669),
    [anon_sym_BANG] = ACTIONS(5673),
    [anon_sym_PLUS] = ACTIONS(5669),
    [anon_sym_DASH] = ACTIONS(5673),
    [anon_sym_LT_DASH] = ACTIONS(5669),
    [anon_sym_LT_LT_DASH] = ACTIONS(5669),
    [anon_sym_COLON_EQ] = ACTIONS(5669),
    [anon_sym_DASH_GT] = ACTIONS(5673),
    [anon_sym_DASH_GT_GT] = ACTIONS(5669),
    [anon_sym_PIPE] = ACTIONS(5673),
    [anon_sym_AMP] = ACTIONS(5673),
    [anon_sym_PIPE_PIPE] = ACTIONS(5669),
    [anon_sym_AMP_AMP] = ACTIONS(5669),
    [anon_sym_LT] = ACTIONS(5673),
    [anon_sym_LT_EQ] = ACTIONS(5669),
    [anon_sym_GT] = ACTIONS(5673),
    [anon_sym_GT_EQ] = ACTIONS(5669),
    [anon_sym_EQ_EQ] = ACTIONS(5669),
    [anon_sym_BANG_EQ] = ACTIONS(5669),
    [anon_sym_STAR] = ACTIONS(5673),
    [anon_sym_SLASH] = ACTIONS(5669),
    [anon_sym_STAR_STAR] = ACTIONS(5669),
    [anon_sym_CARET] = ACTIONS(5669),
    [aux_sym_binary_operator_token1] = ACTIONS(5669),
    [anon_sym_PIPE_GT] = ACTIONS(5669),
    [anon_sym_COLON] = ACTIONS(5673),
    [anon_sym_DOLLAR] = ACTIONS(5669),
    [anon_sym_AT] = ACTIONS(5669),
    [aux_sym__hex_literal_token1] = ACTIONS(5669),
    [sym__number_literal] = ACTIONS(5673),
    [anon_sym_SQUOTE] = ACTIONS(301),
    [anon_sym_DQUOTE] = ACTIONS(303),
    [sym_return] = ACTIONS(5673),
    [sym_next] = ACTIONS(5673),
    [sym_break] = ACTIONS(5673),
    [sym_true] = ACTIONS(5673),
    [sym_false] = ACTIONS(5673),
    [sym_null] = ACTIONS(5673),
    [sym_inf] = ACTIONS(5673),
    [sym_nan] = ACTIONS(5673),
    [anon_sym_NA] = ACTIONS(5673),
    [anon_sym_NA_integer_] = ACTIONS(5673),
    [anon_sym_NA_real_] = ACTIONS(5673),
    [anon_sym_NA_complex_] = ACTIONS(5673),
    [anon_sym_NA_character_] = ACTIONS(5673),
    [sym_dots] = ACTIONS(5673),
    [sym_dot_dot_i] = ACTIONS(5669),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5669),
    [sym__newline] = ACTIONS(5669),
    [sym__semicolon] = ACTIONS(5669),
    [sym__raw_string_literal] = ACTIONS(313),
    [sym__external_open_parenthesis] = ACTIONS(5669),
    [sym__external_close_parenthesis] = ACTIONS(5669),
    [sym__external_open_brace] = ACTIONS(5669),
    [sym__external_close_brace] = ACTIONS(5669),
    [sym__external_open_bracket] = ACTIONS(5669),
    [sym__external_close_bracket] = ACTIONS(5669),
    [sym__external_open_bracket2] = ACTIONS(5669),
  },
  [973] = {
    [sym_string] = STATE(2422),
    [sym__single_quoted_string] = STATE(2221),
    [sym__double_quoted_string] = STATE(2222),
    [sym__string_or_identifier] = STATE(2422),
    [aux_sym_function_definition_repeat1] = STATE(2303),
    [sym_identifier] = ACTIONS(5941),
    [anon_sym_BSLASH] = ACTIONS(5669),
    [anon_sym_function] = ACTIONS(5673),
    [anon_sym_EQ] = ACTIONS(5673),
    [anon_sym_if] = ACTIONS(5673),
    [anon_sym_for] = ACTIONS(5673),
    [anon_sym_while] = ACTIONS(5673),
    [anon_sym_repeat] = ACTIONS(5673),
    [anon_sym_QMARK] = ACTIONS(5669),
    [anon_sym_TILDE] = ACTIONS(5669),
    [anon_sym_BANG] = ACTIONS(5673),
    [anon_sym_PLUS] = ACTIONS(5669),
    [anon_sym_DASH] = ACTIONS(5673),
    [anon_sym_LT_DASH] = ACTIONS(5669),
    [anon_sym_LT_LT_DASH] = ACTIONS(5669),
    [anon_sym_COLON_EQ] = ACTIONS(5669),
    [anon_sym_DASH_GT] = ACTIONS(5673),
    [anon_sym_DASH_GT_GT] = ACTIONS(5669),
    [anon_sym_PIPE] = ACTIONS(5673),
    [anon_sym_AMP] = ACTIONS(5673),
    [anon_sym_PIPE_PIPE] = ACTIONS(5669),
    [anon_sym_AMP_AMP] = ACTIONS(5669),
    [anon_sym_LT] = ACTIONS(5673),
    [anon_sym_LT_EQ] = ACTIONS(5669),
    [anon_sym_GT] = ACTIONS(5673),
    [anon_sym_GT_EQ] = ACTIONS(5669),
    [anon_sym_EQ_EQ] = ACTIONS(5669),
    [anon_sym_BANG_EQ] = ACTIONS(5669),
    [anon_sym_STAR] = ACTIONS(5673),
    [anon_sym_SLASH] = ACTIONS(5669),
    [anon_sym_STAR_STAR] = ACTIONS(5669),
    [anon_sym_CARET] = ACTIONS(5669),
    [aux_sym_binary_operator_token1] = ACTIONS(5669),
    [anon_sym_PIPE_GT] = ACTIONS(5669),
    [anon_sym_COLON] = ACTIONS(5673),
    [anon_sym_DOLLAR] = ACTIONS(5669),
    [anon_sym_AT] = ACTIONS(5669),
    [aux_sym__hex_literal_token1] = ACTIONS(5669),
    [sym__number_literal] = ACTIONS(5673),
    [anon_sym_SQUOTE] = ACTIONS(654),
    [anon_sym_DQUOTE] = ACTIONS(656),
    [sym_return] = ACTIONS(5673),
    [sym_next] = ACTIONS(5673),
    [sym_break] = ACTIONS(5673),
    [sym_true] = ACTIONS(5673),
    [sym_false] = ACTIONS(5673),
    [sym_null] = ACTIONS(5673),
    [sym_inf] = ACTIONS(5673),
    [sym_nan] = ACTIONS(5673),
    [anon_sym_NA] = ACTIONS(5673),
    [anon_sym_NA_integer_] = ACTIONS(5673),
    [anon_sym_NA_real_] = ACTIONS(5673),
    [anon_sym_NA_complex_] = ACTIONS(5673),
    [anon_sym_NA_character_] = ACTIONS(5673),
    [sym_dots] = ACTIONS(5673),
    [sym_dot_dot_i] = ACTIONS(5669),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5669),
    [sym__newline] = ACTIONS(5669),
    [sym__semicolon] = ACTIONS(5669),
    [sym__raw_string_literal] = ACTIONS(666),
    [sym__external_open_parenthesis] = ACTIONS(5669),
    [sym__external_close_parenthesis] = ACTIONS(5669),
    [sym__external_open_brace] = ACTIONS(5669),
    [sym__external_close_brace] = ACTIONS(5669),
    [sym__external_open_bracket] = ACTIONS(5669),
    [sym__external_open_bracket2] = ACTIONS(5669),
    [sym__external_close_bracket2] = ACTIONS(5669),
  },
  [974] = {
    [sym_string] = STATE(2552),
    [sym__single_quoted_string] = STATE(2188),
    [sym__double_quoted_string] = STATE(2187),
    [sym__string_or_identifier] = STATE(2552),
    [aux_sym_function_definition_repeat1] = STATE(972),
    [sym_identifier] = ACTIONS(5943),
    [anon_sym_BSLASH] = ACTIONS(5659),
    [anon_sym_function] = ACTIONS(5663),
    [anon_sym_EQ] = ACTIONS(5663),
    [anon_sym_if] = ACTIONS(5663),
    [anon_sym_for] = ACTIONS(5663),
    [anon_sym_while] = ACTIONS(5663),
    [anon_sym_repeat] = ACTIONS(5663),
    [anon_sym_QMARK] = ACTIONS(5659),
    [anon_sym_TILDE] = ACTIONS(5659),
    [anon_sym_BANG] = ACTIONS(5663),
    [anon_sym_PLUS] = ACTIONS(5659),
    [anon_sym_DASH] = ACTIONS(5663),
    [anon_sym_LT_DASH] = ACTIONS(5659),
    [anon_sym_LT_LT_DASH] = ACTIONS(5659),
    [anon_sym_COLON_EQ] = ACTIONS(5659),
    [anon_sym_DASH_GT] = ACTIONS(5663),
    [anon_sym_DASH_GT_GT] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(5663),
    [anon_sym_AMP] = ACTIONS(5663),
    [anon_sym_PIPE_PIPE] = ACTIONS(5659),
    [anon_sym_AMP_AMP] = ACTIONS(5659),
    [anon_sym_LT] = ACTIONS(5663),
    [anon_sym_LT_EQ] = ACTIONS(5659),
    [anon_sym_GT] = ACTIONS(5663),
    [anon_sym_GT_EQ] = ACTIONS(5659),
    [anon_sym_EQ_EQ] = ACTIONS(5659),
    [anon_sym_BANG_EQ] = ACTIONS(5659),
    [anon_sym_STAR] = ACTIONS(5663),
    [anon_sym_SLASH] = ACTIONS(5659),
    [anon_sym_STAR_STAR] = ACTIONS(5659),
    [anon_sym_CARET] = ACTIONS(5659),
    [aux_sym_binary_operator_token1] = ACTIONS(5659),
    [anon_sym_PIPE_GT] = ACTIONS(5659),
    [anon_sym_COLON] = ACTIONS(5663),
    [anon_sym_DOLLAR] = ACTIONS(5659),
    [anon_sym_AT] = ACTIONS(5659),
    [aux_sym__hex_literal_token1] = ACTIONS(5659),
    [sym__number_literal] = ACTIONS(5663),
    [anon_sym_SQUOTE] = ACTIONS(301),
    [anon_sym_DQUOTE] = ACTIONS(303),
    [sym_return] = ACTIONS(5663),
    [sym_next] = ACTIONS(5663),
    [sym_break] = ACTIONS(5663),
    [sym_true] = ACTIONS(5663),
    [sym_false] = ACTIONS(5663),
    [sym_null] = ACTIONS(5663),
    [sym_inf] = ACTIONS(5663),
    [sym_nan] = ACTIONS(5663),
    [anon_sym_NA] = ACTIONS(5663),
    [anon_sym_NA_integer_] = ACTIONS(5663),
    [anon_sym_NA_real_] = ACTIONS(5663),
    [anon_sym_NA_complex_] = ACTIONS(5663),
    [anon_sym_NA_character_] = ACTIONS(5663),
    [sym_dots] = ACTIONS(5663),
    [sym_dot_dot_i] = ACTIONS(5659),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5659),
    [sym__newline] = ACTIONS(5945),
    [sym__semicolon] = ACTIONS(5659),
    [sym__raw_string_literal] = ACTIONS(313),
    [sym__external_open_parenthesis] = ACTIONS(5659),
    [sym__external_close_parenthesis] = ACTIONS(5659),
    [sym__external_open_brace] = ACTIONS(5659),
    [sym__external_close_brace] = ACTIONS(5659),
    [sym__external_open_bracket] = ACTIONS(5659),
    [sym__external_close_bracket] = ACTIONS(5659),
    [sym__external_open_bracket2] = ACTIONS(5659),
  },
  [975] = {
    [sym_call_arguments] = STATE(2678),
    [sym_subset_arguments] = STATE(2679),
    [sym_subset2_arguments] = STATE(2683),
    [sym__open_parenthesis] = STATE(1443),
    [sym__open_bracket] = STATE(1442),
    [sym__open_bracket2] = STATE(1425),
    [ts_builtin_sym_end] = ACTIONS(5329),
    [sym_identifier] = ACTIONS(5331),
    [anon_sym_BSLASH] = ACTIONS(5329),
    [anon_sym_function] = ACTIONS(5331),
    [anon_sym_EQ] = ACTIONS(5609),
    [anon_sym_if] = ACTIONS(5331),
    [anon_sym_for] = ACTIONS(5331),
    [anon_sym_while] = ACTIONS(5331),
    [anon_sym_repeat] = ACTIONS(5331),
    [anon_sym_QMARK] = ACTIONS(5329),
    [anon_sym_TILDE] = ACTIONS(5611),
    [anon_sym_BANG] = ACTIONS(5331),
    [anon_sym_PLUS] = ACTIONS(5613),
    [anon_sym_DASH] = ACTIONS(5615),
    [anon_sym_LT_DASH] = ACTIONS(5617),
    [anon_sym_LT_LT_DASH] = ACTIONS(5617),
    [anon_sym_COLON_EQ] = ACTIONS(5617),
    [anon_sym_DASH_GT] = ACTIONS(5619),
    [anon_sym_DASH_GT_GT] = ACTIONS(5621),
    [anon_sym_PIPE] = ACTIONS(5623),
    [anon_sym_AMP] = ACTIONS(5625),
    [anon_sym_PIPE_PIPE] = ACTIONS(5627),
    [anon_sym_AMP_AMP] = ACTIONS(5629),
    [anon_sym_LT] = ACTIONS(5631),
    [anon_sym_LT_EQ] = ACTIONS(5633),
    [anon_sym_GT] = ACTIONS(5631),
    [anon_sym_GT_EQ] = ACTIONS(5633),
    [anon_sym_EQ_EQ] = ACTIONS(5633),
    [anon_sym_BANG_EQ] = ACTIONS(5633),
    [anon_sym_STAR] = ACTIONS(5635),
    [anon_sym_SLASH] = ACTIONS(5637),
    [anon_sym_STAR_STAR] = ACTIONS(5639),
    [anon_sym_CARET] = ACTIONS(5639),
    [aux_sym_binary_operator_token1] = ACTIONS(5641),
    [anon_sym_PIPE_GT] = ACTIONS(5641),
    [anon_sym_COLON] = ACTIONS(5643),
    [anon_sym_DOLLAR] = ACTIONS(5645),
    [anon_sym_AT] = ACTIONS(5645),
    [aux_sym__hex_literal_token1] = ACTIONS(5329),
    [sym__number_literal] = ACTIONS(5331),
    [anon_sym_SQUOTE] = ACTIONS(5329),
    [anon_sym_DQUOTE] = ACTIONS(5329),
    [sym_return] = ACTIONS(5331),
    [sym_next] = ACTIONS(5331),
    [sym_break] = ACTIONS(5331),
    [sym_true] = ACTIONS(5331),
    [sym_false] = ACTIONS(5331),
    [sym_null] = ACTIONS(5331),
    [sym_inf] = ACTIONS(5331),
    [sym_nan] = ACTIONS(5331),
    [anon_sym_NA] = ACTIONS(5331),
    [anon_sym_NA_integer_] = ACTIONS(5331),
    [anon_sym_NA_real_] = ACTIONS(5331),
    [anon_sym_NA_complex_] = ACTIONS(5331),
    [anon_sym_NA_character_] = ACTIONS(5331),
    [sym_dots] = ACTIONS(5331),
    [sym_dot_dot_i] = ACTIONS(5329),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5329),
    [sym__semicolon] = ACTIONS(5329),
    [sym__raw_string_literal] = ACTIONS(5329),
    [sym__external_else] = ACTIONS(5329),
    [sym__external_open_parenthesis] = ACTIONS(5649),
    [sym__external_close_parenthesis] = ACTIONS(5329),
    [sym__external_open_brace] = ACTIONS(5329),
    [sym__external_open_bracket] = ACTIONS(5651),
    [sym__external_open_bracket2] = ACTIONS(5653),
  },
  [976] = {
    [sym_call_arguments] = STATE(2678),
    [sym_subset_arguments] = STATE(2679),
    [sym_subset2_arguments] = STATE(2683),
    [sym__open_parenthesis] = STATE(1443),
    [sym__open_bracket] = STATE(1442),
    [sym__open_bracket2] = STATE(1425),
    [ts_builtin_sym_end] = ACTIONS(5333),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5609),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5611),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(5613),
    [anon_sym_DASH] = ACTIONS(5615),
    [anon_sym_LT_DASH] = ACTIONS(5617),
    [anon_sym_LT_LT_DASH] = ACTIONS(5617),
    [anon_sym_COLON_EQ] = ACTIONS(5617),
    [anon_sym_DASH_GT] = ACTIONS(5619),
    [anon_sym_DASH_GT_GT] = ACTIONS(5621),
    [anon_sym_PIPE] = ACTIONS(5623),
    [anon_sym_AMP] = ACTIONS(5625),
    [anon_sym_PIPE_PIPE] = ACTIONS(5627),
    [anon_sym_AMP_AMP] = ACTIONS(5629),
    [anon_sym_LT] = ACTIONS(5631),
    [anon_sym_LT_EQ] = ACTIONS(5633),
    [anon_sym_GT] = ACTIONS(5631),
    [anon_sym_GT_EQ] = ACTIONS(5633),
    [anon_sym_EQ_EQ] = ACTIONS(5633),
    [anon_sym_BANG_EQ] = ACTIONS(5633),
    [anon_sym_STAR] = ACTIONS(5635),
    [anon_sym_SLASH] = ACTIONS(5637),
    [anon_sym_STAR_STAR] = ACTIONS(5639),
    [anon_sym_CARET] = ACTIONS(5639),
    [aux_sym_binary_operator_token1] = ACTIONS(5641),
    [anon_sym_PIPE_GT] = ACTIONS(5641),
    [anon_sym_COLON] = ACTIONS(5643),
    [anon_sym_DOLLAR] = ACTIONS(5645),
    [anon_sym_AT] = ACTIONS(5645),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5333),
    [sym__semicolon] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_else] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(5649),
    [sym__external_close_parenthesis] = ACTIONS(5333),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(5651),
    [sym__external_open_bracket2] = ACTIONS(5653),
  },
  [977] = {
    [sym_call_arguments] = STATE(2678),
    [sym_subset_arguments] = STATE(2679),
    [sym_subset2_arguments] = STATE(2683),
    [sym__open_parenthesis] = STATE(1443),
    [sym__open_bracket] = STATE(1442),
    [sym__open_bracket2] = STATE(1425),
    [ts_builtin_sym_end] = ACTIONS(5333),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(5613),
    [anon_sym_DASH] = ACTIONS(5615),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5623),
    [anon_sym_AMP] = ACTIONS(5625),
    [anon_sym_PIPE_PIPE] = ACTIONS(5627),
    [anon_sym_AMP_AMP] = ACTIONS(5629),
    [anon_sym_LT] = ACTIONS(5631),
    [anon_sym_LT_EQ] = ACTIONS(5633),
    [anon_sym_GT] = ACTIONS(5631),
    [anon_sym_GT_EQ] = ACTIONS(5633),
    [anon_sym_EQ_EQ] = ACTIONS(5633),
    [anon_sym_BANG_EQ] = ACTIONS(5633),
    [anon_sym_STAR] = ACTIONS(5635),
    [anon_sym_SLASH] = ACTIONS(5637),
    [anon_sym_STAR_STAR] = ACTIONS(5639),
    [anon_sym_CARET] = ACTIONS(5639),
    [aux_sym_binary_operator_token1] = ACTIONS(5641),
    [anon_sym_PIPE_GT] = ACTIONS(5641),
    [anon_sym_COLON] = ACTIONS(5643),
    [anon_sym_DOLLAR] = ACTIONS(5645),
    [anon_sym_AT] = ACTIONS(5645),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5333),
    [sym__semicolon] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_else] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(5649),
    [sym__external_close_parenthesis] = ACTIONS(5333),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(5651),
    [sym__external_open_bracket2] = ACTIONS(5653),
  },
  [978] = {
    [sym_call_arguments] = STATE(2678),
    [sym_subset_arguments] = STATE(2679),
    [sym_subset2_arguments] = STATE(2683),
    [sym__open_parenthesis] = STATE(1443),
    [sym__open_bracket] = STATE(1442),
    [sym__open_bracket2] = STATE(1425),
    [ts_builtin_sym_end] = ACTIONS(5333),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(5613),
    [anon_sym_DASH] = ACTIONS(5615),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5335),
    [anon_sym_AMP] = ACTIONS(5335),
    [anon_sym_PIPE_PIPE] = ACTIONS(5333),
    [anon_sym_AMP_AMP] = ACTIONS(5333),
    [anon_sym_LT] = ACTIONS(5631),
    [anon_sym_LT_EQ] = ACTIONS(5633),
    [anon_sym_GT] = ACTIONS(5631),
    [anon_sym_GT_EQ] = ACTIONS(5633),
    [anon_sym_EQ_EQ] = ACTIONS(5633),
    [anon_sym_BANG_EQ] = ACTIONS(5633),
    [anon_sym_STAR] = ACTIONS(5635),
    [anon_sym_SLASH] = ACTIONS(5637),
    [anon_sym_STAR_STAR] = ACTIONS(5639),
    [anon_sym_CARET] = ACTIONS(5639),
    [aux_sym_binary_operator_token1] = ACTIONS(5641),
    [anon_sym_PIPE_GT] = ACTIONS(5641),
    [anon_sym_COLON] = ACTIONS(5643),
    [anon_sym_DOLLAR] = ACTIONS(5645),
    [anon_sym_AT] = ACTIONS(5645),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5333),
    [sym__semicolon] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_else] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(5649),
    [sym__external_close_parenthesis] = ACTIONS(5333),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(5651),
    [sym__external_open_bracket2] = ACTIONS(5653),
  },
  [979] = {
    [sym_call_arguments] = STATE(2678),
    [sym_subset_arguments] = STATE(2679),
    [sym_subset2_arguments] = STATE(2683),
    [sym__open_parenthesis] = STATE(1443),
    [sym__open_bracket] = STATE(1442),
    [sym__open_bracket2] = STATE(1425),
    [ts_builtin_sym_end] = ACTIONS(5333),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(5333),
    [anon_sym_DASH] = ACTIONS(5335),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5335),
    [anon_sym_AMP] = ACTIONS(5335),
    [anon_sym_PIPE_PIPE] = ACTIONS(5333),
    [anon_sym_AMP_AMP] = ACTIONS(5333),
    [anon_sym_LT] = ACTIONS(5335),
    [anon_sym_LT_EQ] = ACTIONS(5333),
    [anon_sym_GT] = ACTIONS(5335),
    [anon_sym_GT_EQ] = ACTIONS(5333),
    [anon_sym_EQ_EQ] = ACTIONS(5333),
    [anon_sym_BANG_EQ] = ACTIONS(5333),
    [anon_sym_STAR] = ACTIONS(5335),
    [anon_sym_SLASH] = ACTIONS(5333),
    [anon_sym_STAR_STAR] = ACTIONS(5639),
    [anon_sym_CARET] = ACTIONS(5639),
    [aux_sym_binary_operator_token1] = ACTIONS(5333),
    [anon_sym_PIPE_GT] = ACTIONS(5333),
    [anon_sym_COLON] = ACTIONS(5335),
    [anon_sym_DOLLAR] = ACTIONS(5645),
    [anon_sym_AT] = ACTIONS(5645),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5333),
    [sym__semicolon] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_else] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(5649),
    [sym__external_close_parenthesis] = ACTIONS(5333),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(5651),
    [sym__external_open_bracket2] = ACTIONS(5653),
  },
  [980] = {
    [sym_call_arguments] = STATE(2678),
    [sym_subset_arguments] = STATE(2679),
    [sym_subset2_arguments] = STATE(2683),
    [sym__open_parenthesis] = STATE(1443),
    [sym__open_bracket] = STATE(1442),
    [sym__open_bracket2] = STATE(1425),
    [ts_builtin_sym_end] = ACTIONS(5337),
    [sym_identifier] = ACTIONS(5339),
    [anon_sym_BSLASH] = ACTIONS(5337),
    [anon_sym_function] = ACTIONS(5339),
    [anon_sym_EQ] = ACTIONS(5609),
    [anon_sym_if] = ACTIONS(5339),
    [anon_sym_for] = ACTIONS(5339),
    [anon_sym_while] = ACTIONS(5339),
    [anon_sym_repeat] = ACTIONS(5339),
    [anon_sym_QMARK] = ACTIONS(5337),
    [anon_sym_TILDE] = ACTIONS(5611),
    [anon_sym_BANG] = ACTIONS(5339),
    [anon_sym_PLUS] = ACTIONS(5613),
    [anon_sym_DASH] = ACTIONS(5615),
    [anon_sym_LT_DASH] = ACTIONS(5617),
    [anon_sym_LT_LT_DASH] = ACTIONS(5617),
    [anon_sym_COLON_EQ] = ACTIONS(5617),
    [anon_sym_DASH_GT] = ACTIONS(5619),
    [anon_sym_DASH_GT_GT] = ACTIONS(5621),
    [anon_sym_PIPE] = ACTIONS(5623),
    [anon_sym_AMP] = ACTIONS(5625),
    [anon_sym_PIPE_PIPE] = ACTIONS(5627),
    [anon_sym_AMP_AMP] = ACTIONS(5629),
    [anon_sym_LT] = ACTIONS(5631),
    [anon_sym_LT_EQ] = ACTIONS(5633),
    [anon_sym_GT] = ACTIONS(5631),
    [anon_sym_GT_EQ] = ACTIONS(5633),
    [anon_sym_EQ_EQ] = ACTIONS(5633),
    [anon_sym_BANG_EQ] = ACTIONS(5633),
    [anon_sym_STAR] = ACTIONS(5635),
    [anon_sym_SLASH] = ACTIONS(5637),
    [anon_sym_STAR_STAR] = ACTIONS(5639),
    [anon_sym_CARET] = ACTIONS(5639),
    [aux_sym_binary_operator_token1] = ACTIONS(5641),
    [anon_sym_PIPE_GT] = ACTIONS(5641),
    [anon_sym_COLON] = ACTIONS(5643),
    [anon_sym_DOLLAR] = ACTIONS(5645),
    [anon_sym_AT] = ACTIONS(5645),
    [aux_sym__hex_literal_token1] = ACTIONS(5337),
    [sym__number_literal] = ACTIONS(5339),
    [anon_sym_SQUOTE] = ACTIONS(5337),
    [anon_sym_DQUOTE] = ACTIONS(5337),
    [sym_return] = ACTIONS(5339),
    [sym_next] = ACTIONS(5339),
    [sym_break] = ACTIONS(5339),
    [sym_true] = ACTIONS(5339),
    [sym_false] = ACTIONS(5339),
    [sym_null] = ACTIONS(5339),
    [sym_inf] = ACTIONS(5339),
    [sym_nan] = ACTIONS(5339),
    [anon_sym_NA] = ACTIONS(5339),
    [anon_sym_NA_integer_] = ACTIONS(5339),
    [anon_sym_NA_real_] = ACTIONS(5339),
    [anon_sym_NA_complex_] = ACTIONS(5339),
    [anon_sym_NA_character_] = ACTIONS(5339),
    [sym_dots] = ACTIONS(5339),
    [sym_dot_dot_i] = ACTIONS(5337),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5337),
    [sym__semicolon] = ACTIONS(5337),
    [sym__raw_string_literal] = ACTIONS(5337),
    [sym__external_else] = ACTIONS(5337),
    [sym__external_open_parenthesis] = ACTIONS(5649),
    [sym__external_close_parenthesis] = ACTIONS(5337),
    [sym__external_open_brace] = ACTIONS(5337),
    [sym__external_open_bracket] = ACTIONS(5651),
    [sym__external_open_bracket2] = ACTIONS(5653),
  },
  [981] = {
    [sym_call_arguments] = STATE(2678),
    [sym_subset_arguments] = STATE(2679),
    [sym_subset2_arguments] = STATE(2683),
    [sym__open_parenthesis] = STATE(1443),
    [sym__open_bracket] = STATE(1442),
    [sym__open_bracket2] = STATE(1425),
    [ts_builtin_sym_end] = ACTIONS(5341),
    [sym_identifier] = ACTIONS(5343),
    [anon_sym_BSLASH] = ACTIONS(5341),
    [anon_sym_function] = ACTIONS(5343),
    [anon_sym_EQ] = ACTIONS(5609),
    [anon_sym_if] = ACTIONS(5343),
    [anon_sym_for] = ACTIONS(5343),
    [anon_sym_while] = ACTIONS(5343),
    [anon_sym_repeat] = ACTIONS(5343),
    [anon_sym_QMARK] = ACTIONS(5341),
    [anon_sym_TILDE] = ACTIONS(5611),
    [anon_sym_BANG] = ACTIONS(5343),
    [anon_sym_PLUS] = ACTIONS(5613),
    [anon_sym_DASH] = ACTIONS(5615),
    [anon_sym_LT_DASH] = ACTIONS(5617),
    [anon_sym_LT_LT_DASH] = ACTIONS(5617),
    [anon_sym_COLON_EQ] = ACTIONS(5617),
    [anon_sym_DASH_GT] = ACTIONS(5619),
    [anon_sym_DASH_GT_GT] = ACTIONS(5621),
    [anon_sym_PIPE] = ACTIONS(5623),
    [anon_sym_AMP] = ACTIONS(5625),
    [anon_sym_PIPE_PIPE] = ACTIONS(5627),
    [anon_sym_AMP_AMP] = ACTIONS(5629),
    [anon_sym_LT] = ACTIONS(5631),
    [anon_sym_LT_EQ] = ACTIONS(5633),
    [anon_sym_GT] = ACTIONS(5631),
    [anon_sym_GT_EQ] = ACTIONS(5633),
    [anon_sym_EQ_EQ] = ACTIONS(5633),
    [anon_sym_BANG_EQ] = ACTIONS(5633),
    [anon_sym_STAR] = ACTIONS(5635),
    [anon_sym_SLASH] = ACTIONS(5637),
    [anon_sym_STAR_STAR] = ACTIONS(5639),
    [anon_sym_CARET] = ACTIONS(5639),
    [aux_sym_binary_operator_token1] = ACTIONS(5641),
    [anon_sym_PIPE_GT] = ACTIONS(5641),
    [anon_sym_COLON] = ACTIONS(5643),
    [anon_sym_DOLLAR] = ACTIONS(5645),
    [anon_sym_AT] = ACTIONS(5645),
    [aux_sym__hex_literal_token1] = ACTIONS(5341),
    [sym__number_literal] = ACTIONS(5343),
    [anon_sym_SQUOTE] = ACTIONS(5341),
    [anon_sym_DQUOTE] = ACTIONS(5341),
    [sym_return] = ACTIONS(5343),
    [sym_next] = ACTIONS(5343),
    [sym_break] = ACTIONS(5343),
    [sym_true] = ACTIONS(5343),
    [sym_false] = ACTIONS(5343),
    [sym_null] = ACTIONS(5343),
    [sym_inf] = ACTIONS(5343),
    [sym_nan] = ACTIONS(5343),
    [anon_sym_NA] = ACTIONS(5343),
    [anon_sym_NA_integer_] = ACTIONS(5343),
    [anon_sym_NA_real_] = ACTIONS(5343),
    [anon_sym_NA_complex_] = ACTIONS(5343),
    [anon_sym_NA_character_] = ACTIONS(5343),
    [sym_dots] = ACTIONS(5343),
    [sym_dot_dot_i] = ACTIONS(5341),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5341),
    [sym__semicolon] = ACTIONS(5341),
    [sym__raw_string_literal] = ACTIONS(5341),
    [sym__external_else] = ACTIONS(5341),
    [sym__external_open_parenthesis] = ACTIONS(5649),
    [sym__external_close_parenthesis] = ACTIONS(5341),
    [sym__external_open_brace] = ACTIONS(5341),
    [sym__external_open_bracket] = ACTIONS(5651),
    [sym__external_open_bracket2] = ACTIONS(5653),
  },
  [982] = {
    [sym_call_arguments] = STATE(2678),
    [sym_subset_arguments] = STATE(2679),
    [sym_subset2_arguments] = STATE(2683),
    [sym__open_parenthesis] = STATE(1443),
    [sym__open_bracket] = STATE(1442),
    [sym__open_bracket2] = STATE(1425),
    [ts_builtin_sym_end] = ACTIONS(5345),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5609),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5611),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5613),
    [anon_sym_DASH] = ACTIONS(5615),
    [anon_sym_LT_DASH] = ACTIONS(5617),
    [anon_sym_LT_LT_DASH] = ACTIONS(5617),
    [anon_sym_COLON_EQ] = ACTIONS(5617),
    [anon_sym_DASH_GT] = ACTIONS(5619),
    [anon_sym_DASH_GT_GT] = ACTIONS(5621),
    [anon_sym_PIPE] = ACTIONS(5623),
    [anon_sym_AMP] = ACTIONS(5625),
    [anon_sym_PIPE_PIPE] = ACTIONS(5627),
    [anon_sym_AMP_AMP] = ACTIONS(5629),
    [anon_sym_LT] = ACTIONS(5631),
    [anon_sym_LT_EQ] = ACTIONS(5633),
    [anon_sym_GT] = ACTIONS(5631),
    [anon_sym_GT_EQ] = ACTIONS(5633),
    [anon_sym_EQ_EQ] = ACTIONS(5633),
    [anon_sym_BANG_EQ] = ACTIONS(5633),
    [anon_sym_STAR] = ACTIONS(5635),
    [anon_sym_SLASH] = ACTIONS(5637),
    [anon_sym_STAR_STAR] = ACTIONS(5639),
    [anon_sym_CARET] = ACTIONS(5639),
    [aux_sym_binary_operator_token1] = ACTIONS(5641),
    [anon_sym_PIPE_GT] = ACTIONS(5641),
    [anon_sym_COLON] = ACTIONS(5643),
    [anon_sym_DOLLAR] = ACTIONS(5645),
    [anon_sym_AT] = ACTIONS(5645),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5345),
    [sym__semicolon] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_else] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(5649),
    [sym__external_close_parenthesis] = ACTIONS(5345),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(5651),
    [sym__external_open_bracket2] = ACTIONS(5653),
  },
  [983] = {
    [sym_call_arguments] = STATE(2678),
    [sym_subset_arguments] = STATE(2679),
    [sym_subset2_arguments] = STATE(2683),
    [sym__open_parenthesis] = STATE(1443),
    [sym__open_bracket] = STATE(1442),
    [sym__open_bracket2] = STATE(1425),
    [ts_builtin_sym_end] = ACTIONS(5345),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5613),
    [anon_sym_DASH] = ACTIONS(5615),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5623),
    [anon_sym_AMP] = ACTIONS(5625),
    [anon_sym_PIPE_PIPE] = ACTIONS(5627),
    [anon_sym_AMP_AMP] = ACTIONS(5629),
    [anon_sym_LT] = ACTIONS(5631),
    [anon_sym_LT_EQ] = ACTIONS(5633),
    [anon_sym_GT] = ACTIONS(5631),
    [anon_sym_GT_EQ] = ACTIONS(5633),
    [anon_sym_EQ_EQ] = ACTIONS(5633),
    [anon_sym_BANG_EQ] = ACTIONS(5633),
    [anon_sym_STAR] = ACTIONS(5635),
    [anon_sym_SLASH] = ACTIONS(5637),
    [anon_sym_STAR_STAR] = ACTIONS(5639),
    [anon_sym_CARET] = ACTIONS(5639),
    [aux_sym_binary_operator_token1] = ACTIONS(5641),
    [anon_sym_PIPE_GT] = ACTIONS(5641),
    [anon_sym_COLON] = ACTIONS(5643),
    [anon_sym_DOLLAR] = ACTIONS(5645),
    [anon_sym_AT] = ACTIONS(5645),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5345),
    [sym__semicolon] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_else] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(5649),
    [sym__external_close_parenthesis] = ACTIONS(5345),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(5651),
    [sym__external_open_bracket2] = ACTIONS(5653),
  },
  [984] = {
    [sym_call_arguments] = STATE(2678),
    [sym_subset_arguments] = STATE(2679),
    [sym_subset2_arguments] = STATE(2683),
    [sym__open_parenthesis] = STATE(1443),
    [sym__open_bracket] = STATE(1442),
    [sym__open_bracket2] = STATE(1425),
    [ts_builtin_sym_end] = ACTIONS(5345),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5613),
    [anon_sym_DASH] = ACTIONS(5615),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5347),
    [anon_sym_AMP] = ACTIONS(5347),
    [anon_sym_PIPE_PIPE] = ACTIONS(5345),
    [anon_sym_AMP_AMP] = ACTIONS(5345),
    [anon_sym_LT] = ACTIONS(5631),
    [anon_sym_LT_EQ] = ACTIONS(5633),
    [anon_sym_GT] = ACTIONS(5631),
    [anon_sym_GT_EQ] = ACTIONS(5633),
    [anon_sym_EQ_EQ] = ACTIONS(5633),
    [anon_sym_BANG_EQ] = ACTIONS(5633),
    [anon_sym_STAR] = ACTIONS(5635),
    [anon_sym_SLASH] = ACTIONS(5637),
    [anon_sym_STAR_STAR] = ACTIONS(5639),
    [anon_sym_CARET] = ACTIONS(5639),
    [aux_sym_binary_operator_token1] = ACTIONS(5641),
    [anon_sym_PIPE_GT] = ACTIONS(5641),
    [anon_sym_COLON] = ACTIONS(5643),
    [anon_sym_DOLLAR] = ACTIONS(5645),
    [anon_sym_AT] = ACTIONS(5645),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5345),
    [sym__semicolon] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_else] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(5649),
    [sym__external_close_parenthesis] = ACTIONS(5345),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(5651),
    [sym__external_open_bracket2] = ACTIONS(5653),
  },
  [985] = {
    [sym_call_arguments] = STATE(2678),
    [sym_subset_arguments] = STATE(2679),
    [sym_subset2_arguments] = STATE(2683),
    [sym__open_parenthesis] = STATE(1443),
    [sym__open_bracket] = STATE(1442),
    [sym__open_bracket2] = STATE(1425),
    [ts_builtin_sym_end] = ACTIONS(5345),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5345),
    [anon_sym_DASH] = ACTIONS(5347),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5347),
    [anon_sym_AMP] = ACTIONS(5347),
    [anon_sym_PIPE_PIPE] = ACTIONS(5345),
    [anon_sym_AMP_AMP] = ACTIONS(5345),
    [anon_sym_LT] = ACTIONS(5347),
    [anon_sym_LT_EQ] = ACTIONS(5345),
    [anon_sym_GT] = ACTIONS(5347),
    [anon_sym_GT_EQ] = ACTIONS(5345),
    [anon_sym_EQ_EQ] = ACTIONS(5345),
    [anon_sym_BANG_EQ] = ACTIONS(5345),
    [anon_sym_STAR] = ACTIONS(5347),
    [anon_sym_SLASH] = ACTIONS(5345),
    [anon_sym_STAR_STAR] = ACTIONS(5639),
    [anon_sym_CARET] = ACTIONS(5639),
    [aux_sym_binary_operator_token1] = ACTIONS(5345),
    [anon_sym_PIPE_GT] = ACTIONS(5345),
    [anon_sym_COLON] = ACTIONS(5347),
    [anon_sym_DOLLAR] = ACTIONS(5645),
    [anon_sym_AT] = ACTIONS(5645),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5345),
    [sym__semicolon] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_else] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(5649),
    [sym__external_close_parenthesis] = ACTIONS(5345),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(5651),
    [sym__external_open_bracket2] = ACTIONS(5653),
  },
  [986] = {
    [sym_call_arguments] = STATE(2678),
    [sym_subset_arguments] = STATE(2679),
    [sym_subset2_arguments] = STATE(2683),
    [sym__open_parenthesis] = STATE(1443),
    [sym__open_bracket] = STATE(1442),
    [sym__open_bracket2] = STATE(1425),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5609),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5611),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5613),
    [anon_sym_DASH] = ACTIONS(5615),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5619),
    [anon_sym_DASH_GT_GT] = ACTIONS(5621),
    [anon_sym_PIPE] = ACTIONS(5623),
    [anon_sym_AMP] = ACTIONS(5625),
    [anon_sym_PIPE_PIPE] = ACTIONS(5627),
    [anon_sym_AMP_AMP] = ACTIONS(5629),
    [anon_sym_LT] = ACTIONS(5631),
    [anon_sym_LT_EQ] = ACTIONS(5633),
    [anon_sym_GT] = ACTIONS(5631),
    [anon_sym_GT_EQ] = ACTIONS(5633),
    [anon_sym_EQ_EQ] = ACTIONS(5633),
    [anon_sym_BANG_EQ] = ACTIONS(5633),
    [anon_sym_STAR] = ACTIONS(5635),
    [anon_sym_SLASH] = ACTIONS(5637),
    [anon_sym_STAR_STAR] = ACTIONS(5639),
    [anon_sym_CARET] = ACTIONS(5639),
    [aux_sym_binary_operator_token1] = ACTIONS(5641),
    [anon_sym_PIPE_GT] = ACTIONS(5641),
    [anon_sym_COLON] = ACTIONS(5643),
    [anon_sym_DOLLAR] = ACTIONS(5645),
    [anon_sym_AT] = ACTIONS(5645),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5649),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5651),
    [sym__external_open_bracket2] = ACTIONS(5653),
  },
  [987] = {
    [sym_call_arguments] = STATE(2678),
    [sym_subset_arguments] = STATE(2679),
    [sym_subset2_arguments] = STATE(2683),
    [sym__open_parenthesis] = STATE(1443),
    [sym__open_bracket] = STATE(1442),
    [sym__open_bracket2] = STATE(1425),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5609),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5611),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5613),
    [anon_sym_DASH] = ACTIONS(5615),
    [anon_sym_LT_DASH] = ACTIONS(5617),
    [anon_sym_LT_LT_DASH] = ACTIONS(5617),
    [anon_sym_COLON_EQ] = ACTIONS(5617),
    [anon_sym_DASH_GT] = ACTIONS(5619),
    [anon_sym_DASH_GT_GT] = ACTIONS(5621),
    [anon_sym_PIPE] = ACTIONS(5623),
    [anon_sym_AMP] = ACTIONS(5625),
    [anon_sym_PIPE_PIPE] = ACTIONS(5627),
    [anon_sym_AMP_AMP] = ACTIONS(5629),
    [anon_sym_LT] = ACTIONS(5631),
    [anon_sym_LT_EQ] = ACTIONS(5633),
    [anon_sym_GT] = ACTIONS(5631),
    [anon_sym_GT_EQ] = ACTIONS(5633),
    [anon_sym_EQ_EQ] = ACTIONS(5633),
    [anon_sym_BANG_EQ] = ACTIONS(5633),
    [anon_sym_STAR] = ACTIONS(5635),
    [anon_sym_SLASH] = ACTIONS(5637),
    [anon_sym_STAR_STAR] = ACTIONS(5639),
    [anon_sym_CARET] = ACTIONS(5639),
    [aux_sym_binary_operator_token1] = ACTIONS(5641),
    [anon_sym_PIPE_GT] = ACTIONS(5641),
    [anon_sym_COLON] = ACTIONS(5643),
    [anon_sym_DOLLAR] = ACTIONS(5645),
    [anon_sym_AT] = ACTIONS(5645),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5649),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5651),
    [sym__external_open_bracket2] = ACTIONS(5653),
  },
  [988] = {
    [sym_call_arguments] = STATE(2678),
    [sym_subset_arguments] = STATE(2679),
    [sym_subset2_arguments] = STATE(2683),
    [sym__open_parenthesis] = STATE(1443),
    [sym__open_bracket] = STATE(1442),
    [sym__open_bracket2] = STATE(1425),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5613),
    [anon_sym_DASH] = ACTIONS(5615),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5623),
    [anon_sym_AMP] = ACTIONS(5625),
    [anon_sym_PIPE_PIPE] = ACTIONS(5627),
    [anon_sym_AMP_AMP] = ACTIONS(5629),
    [anon_sym_LT] = ACTIONS(5631),
    [anon_sym_LT_EQ] = ACTIONS(5633),
    [anon_sym_GT] = ACTIONS(5631),
    [anon_sym_GT_EQ] = ACTIONS(5633),
    [anon_sym_EQ_EQ] = ACTIONS(5633),
    [anon_sym_BANG_EQ] = ACTIONS(5633),
    [anon_sym_STAR] = ACTIONS(5635),
    [anon_sym_SLASH] = ACTIONS(5637),
    [anon_sym_STAR_STAR] = ACTIONS(5639),
    [anon_sym_CARET] = ACTIONS(5639),
    [aux_sym_binary_operator_token1] = ACTIONS(5641),
    [anon_sym_PIPE_GT] = ACTIONS(5641),
    [anon_sym_COLON] = ACTIONS(5643),
    [anon_sym_DOLLAR] = ACTIONS(5645),
    [anon_sym_AT] = ACTIONS(5645),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5649),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5651),
    [sym__external_open_bracket2] = ACTIONS(5653),
  },
  [989] = {
    [sym_call_arguments] = STATE(2678),
    [sym_subset_arguments] = STATE(2679),
    [sym_subset2_arguments] = STATE(2683),
    [sym__open_parenthesis] = STATE(1443),
    [sym__open_bracket] = STATE(1442),
    [sym__open_bracket2] = STATE(1425),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5635),
    [anon_sym_SLASH] = ACTIONS(5637),
    [anon_sym_STAR_STAR] = ACTIONS(5639),
    [anon_sym_CARET] = ACTIONS(5639),
    [aux_sym_binary_operator_token1] = ACTIONS(5641),
    [anon_sym_PIPE_GT] = ACTIONS(5641),
    [anon_sym_COLON] = ACTIONS(5643),
    [anon_sym_DOLLAR] = ACTIONS(5645),
    [anon_sym_AT] = ACTIONS(5645),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5649),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5651),
    [sym__external_open_bracket2] = ACTIONS(5653),
  },
  [990] = {
    [sym_call_arguments] = STATE(2678),
    [sym_subset_arguments] = STATE(2679),
    [sym_subset2_arguments] = STATE(2683),
    [sym__open_parenthesis] = STATE(1443),
    [sym__open_bracket] = STATE(1442),
    [sym__open_bracket2] = STATE(1425),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5609),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5611),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5613),
    [anon_sym_DASH] = ACTIONS(5615),
    [anon_sym_LT_DASH] = ACTIONS(5617),
    [anon_sym_LT_LT_DASH] = ACTIONS(5617),
    [anon_sym_COLON_EQ] = ACTIONS(5617),
    [anon_sym_DASH_GT] = ACTIONS(5619),
    [anon_sym_DASH_GT_GT] = ACTIONS(5621),
    [anon_sym_PIPE] = ACTIONS(5623),
    [anon_sym_AMP] = ACTIONS(5625),
    [anon_sym_PIPE_PIPE] = ACTIONS(5627),
    [anon_sym_AMP_AMP] = ACTIONS(5629),
    [anon_sym_LT] = ACTIONS(5631),
    [anon_sym_LT_EQ] = ACTIONS(5633),
    [anon_sym_GT] = ACTIONS(5631),
    [anon_sym_GT_EQ] = ACTIONS(5633),
    [anon_sym_EQ_EQ] = ACTIONS(5633),
    [anon_sym_BANG_EQ] = ACTIONS(5633),
    [anon_sym_STAR] = ACTIONS(5635),
    [anon_sym_SLASH] = ACTIONS(5637),
    [anon_sym_STAR_STAR] = ACTIONS(5639),
    [anon_sym_CARET] = ACTIONS(5639),
    [aux_sym_binary_operator_token1] = ACTIONS(5641),
    [anon_sym_PIPE_GT] = ACTIONS(5641),
    [anon_sym_COLON] = ACTIONS(5643),
    [anon_sym_DOLLAR] = ACTIONS(5645),
    [anon_sym_AT] = ACTIONS(5645),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5649),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5651),
    [sym__external_open_bracket2] = ACTIONS(5653),
  },
  [991] = {
    [sym_call_arguments] = STATE(2923),
    [sym_subset_arguments] = STATE(2922),
    [sym_subset2_arguments] = STATE(2906),
    [sym__else] = STATE(4144),
    [sym__open_parenthesis] = STATE(1528),
    [sym__open_bracket] = STATE(1525),
    [sym__open_bracket2] = STATE(1519),
    [ts_builtin_sym_end] = ACTIONS(5227),
    [sym_identifier] = ACTIONS(5225),
    [anon_sym_BSLASH] = ACTIONS(5227),
    [anon_sym_function] = ACTIONS(5225),
    [anon_sym_EQ] = ACTIONS(5947),
    [anon_sym_if] = ACTIONS(5225),
    [anon_sym_for] = ACTIONS(5225),
    [anon_sym_while] = ACTIONS(5225),
    [anon_sym_repeat] = ACTIONS(5225),
    [anon_sym_QMARK] = ACTIONS(5227),
    [anon_sym_TILDE] = ACTIONS(5949),
    [anon_sym_BANG] = ACTIONS(5225),
    [anon_sym_PLUS] = ACTIONS(5951),
    [anon_sym_DASH] = ACTIONS(5953),
    [anon_sym_LT_DASH] = ACTIONS(5955),
    [anon_sym_LT_LT_DASH] = ACTIONS(5955),
    [anon_sym_COLON_EQ] = ACTIONS(5955),
    [anon_sym_DASH_GT] = ACTIONS(5957),
    [anon_sym_DASH_GT_GT] = ACTIONS(5959),
    [anon_sym_PIPE] = ACTIONS(5961),
    [anon_sym_AMP] = ACTIONS(5963),
    [anon_sym_PIPE_PIPE] = ACTIONS(5965),
    [anon_sym_AMP_AMP] = ACTIONS(5967),
    [anon_sym_LT] = ACTIONS(5969),
    [anon_sym_LT_EQ] = ACTIONS(5971),
    [anon_sym_GT] = ACTIONS(5969),
    [anon_sym_GT_EQ] = ACTIONS(5971),
    [anon_sym_EQ_EQ] = ACTIONS(5971),
    [anon_sym_BANG_EQ] = ACTIONS(5971),
    [anon_sym_STAR] = ACTIONS(5973),
    [anon_sym_SLASH] = ACTIONS(5975),
    [anon_sym_STAR_STAR] = ACTIONS(5977),
    [anon_sym_CARET] = ACTIONS(5977),
    [aux_sym_binary_operator_token1] = ACTIONS(5979),
    [anon_sym_PIPE_GT] = ACTIONS(5979),
    [anon_sym_COLON] = ACTIONS(5981),
    [anon_sym_DOLLAR] = ACTIONS(5983),
    [anon_sym_AT] = ACTIONS(5983),
    [aux_sym__hex_literal_token1] = ACTIONS(5227),
    [sym__number_literal] = ACTIONS(5225),
    [anon_sym_SQUOTE] = ACTIONS(5227),
    [anon_sym_DQUOTE] = ACTIONS(5227),
    [sym_return] = ACTIONS(5225),
    [sym_next] = ACTIONS(5225),
    [sym_break] = ACTIONS(5225),
    [sym_true] = ACTIONS(5225),
    [sym_false] = ACTIONS(5225),
    [sym_null] = ACTIONS(5225),
    [sym_inf] = ACTIONS(5225),
    [sym_nan] = ACTIONS(5225),
    [anon_sym_NA] = ACTIONS(5225),
    [anon_sym_NA_integer_] = ACTIONS(5225),
    [anon_sym_NA_real_] = ACTIONS(5225),
    [anon_sym_NA_complex_] = ACTIONS(5225),
    [anon_sym_NA_character_] = ACTIONS(5225),
    [sym_dots] = ACTIONS(5225),
    [sym_dot_dot_i] = ACTIONS(5227),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5227),
    [sym__semicolon] = ACTIONS(5227),
    [sym__raw_string_literal] = ACTIONS(5227),
    [sym__external_else] = ACTIONS(5985),
    [sym__external_open_parenthesis] = ACTIONS(5987),
    [sym__external_open_brace] = ACTIONS(5227),
    [sym__external_open_bracket] = ACTIONS(5989),
    [sym__external_open_bracket2] = ACTIONS(5991),
  },
  [992] = {
    [sym_call_arguments] = STATE(2678),
    [sym_subset_arguments] = STATE(2679),
    [sym_subset2_arguments] = STATE(2683),
    [sym__open_parenthesis] = STATE(1443),
    [sym__open_bracket] = STATE(1442),
    [sym__open_bracket2] = STATE(1425),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5611),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5613),
    [anon_sym_DASH] = ACTIONS(5615),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5623),
    [anon_sym_AMP] = ACTIONS(5625),
    [anon_sym_PIPE_PIPE] = ACTIONS(5627),
    [anon_sym_AMP_AMP] = ACTIONS(5629),
    [anon_sym_LT] = ACTIONS(5631),
    [anon_sym_LT_EQ] = ACTIONS(5633),
    [anon_sym_GT] = ACTIONS(5631),
    [anon_sym_GT_EQ] = ACTIONS(5633),
    [anon_sym_EQ_EQ] = ACTIONS(5633),
    [anon_sym_BANG_EQ] = ACTIONS(5633),
    [anon_sym_STAR] = ACTIONS(5635),
    [anon_sym_SLASH] = ACTIONS(5637),
    [anon_sym_STAR_STAR] = ACTIONS(5639),
    [anon_sym_CARET] = ACTIONS(5639),
    [aux_sym_binary_operator_token1] = ACTIONS(5641),
    [anon_sym_PIPE_GT] = ACTIONS(5641),
    [anon_sym_COLON] = ACTIONS(5643),
    [anon_sym_DOLLAR] = ACTIONS(5645),
    [anon_sym_AT] = ACTIONS(5645),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5649),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5651),
    [sym__external_open_bracket2] = ACTIONS(5653),
  },
  [993] = {
    [sym_string] = STATE(2327),
    [sym__single_quoted_string] = STATE(2027),
    [sym__double_quoted_string] = STATE(2041),
    [sym__string_or_identifier] = STATE(2327),
    [sym_identifier] = ACTIONS(5993),
    [anon_sym_BSLASH] = ACTIONS(5883),
    [anon_sym_function] = ACTIONS(5887),
    [anon_sym_EQ] = ACTIONS(5887),
    [anon_sym_if] = ACTIONS(5887),
    [anon_sym_for] = ACTIONS(5887),
    [anon_sym_while] = ACTIONS(5887),
    [anon_sym_repeat] = ACTIONS(5887),
    [anon_sym_QMARK] = ACTIONS(5883),
    [anon_sym_TILDE] = ACTIONS(5883),
    [anon_sym_BANG] = ACTIONS(5887),
    [anon_sym_PLUS] = ACTIONS(5883),
    [anon_sym_DASH] = ACTIONS(5887),
    [anon_sym_LT_DASH] = ACTIONS(5883),
    [anon_sym_LT_LT_DASH] = ACTIONS(5883),
    [anon_sym_COLON_EQ] = ACTIONS(5883),
    [anon_sym_DASH_GT] = ACTIONS(5887),
    [anon_sym_DASH_GT_GT] = ACTIONS(5883),
    [anon_sym_PIPE] = ACTIONS(5887),
    [anon_sym_AMP] = ACTIONS(5887),
    [anon_sym_PIPE_PIPE] = ACTIONS(5883),
    [anon_sym_AMP_AMP] = ACTIONS(5883),
    [anon_sym_LT] = ACTIONS(5887),
    [anon_sym_LT_EQ] = ACTIONS(5883),
    [anon_sym_GT] = ACTIONS(5887),
    [anon_sym_GT_EQ] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5883),
    [anon_sym_BANG_EQ] = ACTIONS(5883),
    [anon_sym_STAR] = ACTIONS(5887),
    [anon_sym_SLASH] = ACTIONS(5883),
    [anon_sym_STAR_STAR] = ACTIONS(5883),
    [anon_sym_CARET] = ACTIONS(5883),
    [aux_sym_binary_operator_token1] = ACTIONS(5883),
    [anon_sym_PIPE_GT] = ACTIONS(5883),
    [anon_sym_COLON] = ACTIONS(5887),
    [anon_sym_DOLLAR] = ACTIONS(5883),
    [anon_sym_AT] = ACTIONS(5883),
    [aux_sym__hex_literal_token1] = ACTIONS(5883),
    [sym__number_literal] = ACTIONS(5887),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(137),
    [sym_return] = ACTIONS(5887),
    [sym_next] = ACTIONS(5887),
    [sym_break] = ACTIONS(5887),
    [sym_true] = ACTIONS(5887),
    [sym_false] = ACTIONS(5887),
    [sym_null] = ACTIONS(5887),
    [sym_inf] = ACTIONS(5887),
    [sym_nan] = ACTIONS(5887),
    [anon_sym_NA] = ACTIONS(5887),
    [anon_sym_NA_integer_] = ACTIONS(5887),
    [anon_sym_NA_real_] = ACTIONS(5887),
    [anon_sym_NA_complex_] = ACTIONS(5887),
    [anon_sym_NA_character_] = ACTIONS(5887),
    [sym_dots] = ACTIONS(5887),
    [sym_dot_dot_i] = ACTIONS(5883),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5883),
    [sym__newline] = ACTIONS(5883),
    [sym__semicolon] = ACTIONS(5883),
    [sym__raw_string_literal] = ACTIONS(147),
    [sym__external_else] = ACTIONS(5883),
    [sym__external_open_parenthesis] = ACTIONS(5883),
    [sym__external_close_parenthesis] = ACTIONS(5883),
    [sym__external_open_brace] = ACTIONS(5883),
    [sym__external_close_brace] = ACTIONS(5883),
    [sym__external_open_bracket] = ACTIONS(5883),
    [sym__external_close_bracket] = ACTIONS(5883),
    [sym__external_open_bracket2] = ACTIONS(5883),
  },
  [994] = {
    [sym_call_arguments] = STATE(2853),
    [sym_subset_arguments] = STATE(2854),
    [sym_subset2_arguments] = STATE(2864),
    [sym__else] = STATE(4141),
    [sym__open_parenthesis] = STATE(1366),
    [sym__open_bracket] = STATE(1365),
    [sym__open_bracket2] = STATE(1364),
    [sym_identifier] = ACTIONS(5225),
    [anon_sym_BSLASH] = ACTIONS(5227),
    [anon_sym_function] = ACTIONS(5225),
    [anon_sym_EQ] = ACTIONS(5995),
    [anon_sym_if] = ACTIONS(5225),
    [anon_sym_for] = ACTIONS(5225),
    [anon_sym_while] = ACTIONS(5225),
    [anon_sym_repeat] = ACTIONS(5225),
    [anon_sym_QMARK] = ACTIONS(5227),
    [anon_sym_TILDE] = ACTIONS(5997),
    [anon_sym_BANG] = ACTIONS(5225),
    [anon_sym_PLUS] = ACTIONS(5999),
    [anon_sym_DASH] = ACTIONS(6001),
    [anon_sym_LT_DASH] = ACTIONS(6003),
    [anon_sym_LT_LT_DASH] = ACTIONS(6003),
    [anon_sym_COLON_EQ] = ACTIONS(6003),
    [anon_sym_DASH_GT] = ACTIONS(6005),
    [anon_sym_DASH_GT_GT] = ACTIONS(6007),
    [anon_sym_PIPE] = ACTIONS(6009),
    [anon_sym_AMP] = ACTIONS(6011),
    [anon_sym_PIPE_PIPE] = ACTIONS(6013),
    [anon_sym_AMP_AMP] = ACTIONS(6015),
    [anon_sym_LT] = ACTIONS(6017),
    [anon_sym_LT_EQ] = ACTIONS(6019),
    [anon_sym_GT] = ACTIONS(6017),
    [anon_sym_GT_EQ] = ACTIONS(6019),
    [anon_sym_EQ_EQ] = ACTIONS(6019),
    [anon_sym_BANG_EQ] = ACTIONS(6019),
    [anon_sym_STAR] = ACTIONS(6021),
    [anon_sym_SLASH] = ACTIONS(6023),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_CARET] = ACTIONS(6025),
    [aux_sym_binary_operator_token1] = ACTIONS(6027),
    [anon_sym_PIPE_GT] = ACTIONS(6027),
    [anon_sym_COLON] = ACTIONS(6029),
    [anon_sym_DOLLAR] = ACTIONS(6031),
    [anon_sym_AT] = ACTIONS(6031),
    [aux_sym__hex_literal_token1] = ACTIONS(5227),
    [sym__number_literal] = ACTIONS(5225),
    [anon_sym_SQUOTE] = ACTIONS(5227),
    [anon_sym_DQUOTE] = ACTIONS(5227),
    [sym_return] = ACTIONS(5225),
    [sym_next] = ACTIONS(5225),
    [sym_break] = ACTIONS(5225),
    [sym_true] = ACTIONS(5225),
    [sym_false] = ACTIONS(5225),
    [sym_null] = ACTIONS(5225),
    [sym_inf] = ACTIONS(5225),
    [sym_nan] = ACTIONS(5225),
    [anon_sym_NA] = ACTIONS(5225),
    [anon_sym_NA_integer_] = ACTIONS(5225),
    [anon_sym_NA_real_] = ACTIONS(5225),
    [anon_sym_NA_complex_] = ACTIONS(5225),
    [anon_sym_NA_character_] = ACTIONS(5225),
    [sym_dots] = ACTIONS(5225),
    [sym_dot_dot_i] = ACTIONS(5227),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5227),
    [sym__newline] = ACTIONS(5227),
    [sym__raw_string_literal] = ACTIONS(5227),
    [sym__external_else] = ACTIONS(6033),
    [sym__external_open_parenthesis] = ACTIONS(6035),
    [sym__external_open_brace] = ACTIONS(5227),
    [sym__external_open_bracket] = ACTIONS(6037),
    [sym__external_close_bracket] = ACTIONS(5227),
    [sym__external_open_bracket2] = ACTIONS(6039),
  },
  [995] = {
    [sym_call_arguments] = STATE(2678),
    [sym_subset_arguments] = STATE(2679),
    [sym_subset2_arguments] = STATE(2683),
    [sym__open_parenthesis] = STATE(1443),
    [sym__open_bracket] = STATE(1442),
    [sym__open_bracket2] = STATE(1425),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5613),
    [anon_sym_DASH] = ACTIONS(5615),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5625),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5629),
    [anon_sym_LT] = ACTIONS(5631),
    [anon_sym_LT_EQ] = ACTIONS(5633),
    [anon_sym_GT] = ACTIONS(5631),
    [anon_sym_GT_EQ] = ACTIONS(5633),
    [anon_sym_EQ_EQ] = ACTIONS(5633),
    [anon_sym_BANG_EQ] = ACTIONS(5633),
    [anon_sym_STAR] = ACTIONS(5635),
    [anon_sym_SLASH] = ACTIONS(5637),
    [anon_sym_STAR_STAR] = ACTIONS(5639),
    [anon_sym_CARET] = ACTIONS(5639),
    [aux_sym_binary_operator_token1] = ACTIONS(5641),
    [anon_sym_PIPE_GT] = ACTIONS(5641),
    [anon_sym_COLON] = ACTIONS(5643),
    [anon_sym_DOLLAR] = ACTIONS(5645),
    [anon_sym_AT] = ACTIONS(5645),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5649),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5651),
    [sym__external_open_bracket2] = ACTIONS(5653),
  },
  [996] = {
    [sym_call_arguments] = STATE(2678),
    [sym_subset_arguments] = STATE(2679),
    [sym_subset2_arguments] = STATE(2683),
    [sym__open_parenthesis] = STATE(1443),
    [sym__open_bracket] = STATE(1442),
    [sym__open_bracket2] = STATE(1425),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5613),
    [anon_sym_DASH] = ACTIONS(5615),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5631),
    [anon_sym_LT_EQ] = ACTIONS(5633),
    [anon_sym_GT] = ACTIONS(5631),
    [anon_sym_GT_EQ] = ACTIONS(5633),
    [anon_sym_EQ_EQ] = ACTIONS(5633),
    [anon_sym_BANG_EQ] = ACTIONS(5633),
    [anon_sym_STAR] = ACTIONS(5635),
    [anon_sym_SLASH] = ACTIONS(5637),
    [anon_sym_STAR_STAR] = ACTIONS(5639),
    [anon_sym_CARET] = ACTIONS(5639),
    [aux_sym_binary_operator_token1] = ACTIONS(5641),
    [anon_sym_PIPE_GT] = ACTIONS(5641),
    [anon_sym_COLON] = ACTIONS(5643),
    [anon_sym_DOLLAR] = ACTIONS(5645),
    [anon_sym_AT] = ACTIONS(5645),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5649),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5651),
    [sym__external_open_bracket2] = ACTIONS(5653),
  },
  [997] = {
    [sym_call_arguments] = STATE(2678),
    [sym_subset_arguments] = STATE(2679),
    [sym_subset2_arguments] = STATE(2683),
    [sym__open_parenthesis] = STATE(1443),
    [sym__open_bracket] = STATE(1442),
    [sym__open_bracket2] = STATE(1425),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5613),
    [anon_sym_DASH] = ACTIONS(5615),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5635),
    [anon_sym_SLASH] = ACTIONS(5637),
    [anon_sym_STAR_STAR] = ACTIONS(5639),
    [anon_sym_CARET] = ACTIONS(5639),
    [aux_sym_binary_operator_token1] = ACTIONS(5641),
    [anon_sym_PIPE_GT] = ACTIONS(5641),
    [anon_sym_COLON] = ACTIONS(5643),
    [anon_sym_DOLLAR] = ACTIONS(5645),
    [anon_sym_AT] = ACTIONS(5645),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5649),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5651),
    [sym__external_open_bracket2] = ACTIONS(5653),
  },
  [998] = {
    [sym_call_arguments] = STATE(2678),
    [sym_subset_arguments] = STATE(2679),
    [sym_subset2_arguments] = STATE(2683),
    [sym__open_parenthesis] = STATE(1443),
    [sym__open_bracket] = STATE(1442),
    [sym__open_bracket2] = STATE(1425),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(5639),
    [anon_sym_CARET] = ACTIONS(5639),
    [aux_sym_binary_operator_token1] = ACTIONS(5641),
    [anon_sym_PIPE_GT] = ACTIONS(5641),
    [anon_sym_COLON] = ACTIONS(5643),
    [anon_sym_DOLLAR] = ACTIONS(5645),
    [anon_sym_AT] = ACTIONS(5645),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5649),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5651),
    [sym__external_open_bracket2] = ACTIONS(5653),
  },
  [999] = {
    [sym_call_arguments] = STATE(2853),
    [sym_subset_arguments] = STATE(2854),
    [sym_subset2_arguments] = STATE(2864),
    [sym__else] = STATE(4145),
    [sym__open_parenthesis] = STATE(1366),
    [sym__open_bracket] = STATE(1365),
    [sym__open_bracket2] = STATE(1364),
    [sym_identifier] = ACTIONS(5169),
    [anon_sym_BSLASH] = ACTIONS(5167),
    [anon_sym_function] = ACTIONS(5169),
    [anon_sym_EQ] = ACTIONS(5995),
    [anon_sym_if] = ACTIONS(5169),
    [anon_sym_for] = ACTIONS(5169),
    [anon_sym_while] = ACTIONS(5169),
    [anon_sym_repeat] = ACTIONS(5169),
    [anon_sym_QMARK] = ACTIONS(5167),
    [anon_sym_TILDE] = ACTIONS(5997),
    [anon_sym_BANG] = ACTIONS(5169),
    [anon_sym_PLUS] = ACTIONS(5999),
    [anon_sym_DASH] = ACTIONS(6001),
    [anon_sym_LT_DASH] = ACTIONS(6003),
    [anon_sym_LT_LT_DASH] = ACTIONS(6003),
    [anon_sym_COLON_EQ] = ACTIONS(6003),
    [anon_sym_DASH_GT] = ACTIONS(6005),
    [anon_sym_DASH_GT_GT] = ACTIONS(6007),
    [anon_sym_PIPE] = ACTIONS(6009),
    [anon_sym_AMP] = ACTIONS(6011),
    [anon_sym_PIPE_PIPE] = ACTIONS(6013),
    [anon_sym_AMP_AMP] = ACTIONS(6015),
    [anon_sym_LT] = ACTIONS(6017),
    [anon_sym_LT_EQ] = ACTIONS(6019),
    [anon_sym_GT] = ACTIONS(6017),
    [anon_sym_GT_EQ] = ACTIONS(6019),
    [anon_sym_EQ_EQ] = ACTIONS(6019),
    [anon_sym_BANG_EQ] = ACTIONS(6019),
    [anon_sym_STAR] = ACTIONS(6021),
    [anon_sym_SLASH] = ACTIONS(6023),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_CARET] = ACTIONS(6025),
    [aux_sym_binary_operator_token1] = ACTIONS(6027),
    [anon_sym_PIPE_GT] = ACTIONS(6027),
    [anon_sym_COLON] = ACTIONS(6029),
    [anon_sym_DOLLAR] = ACTIONS(6031),
    [anon_sym_AT] = ACTIONS(6031),
    [aux_sym__hex_literal_token1] = ACTIONS(5167),
    [sym__number_literal] = ACTIONS(5169),
    [anon_sym_SQUOTE] = ACTIONS(5167),
    [anon_sym_DQUOTE] = ACTIONS(5167),
    [sym_return] = ACTIONS(5169),
    [sym_next] = ACTIONS(5169),
    [sym_break] = ACTIONS(5169),
    [sym_true] = ACTIONS(5169),
    [sym_false] = ACTIONS(5169),
    [sym_null] = ACTIONS(5169),
    [sym_inf] = ACTIONS(5169),
    [sym_nan] = ACTIONS(5169),
    [anon_sym_NA] = ACTIONS(5169),
    [anon_sym_NA_integer_] = ACTIONS(5169),
    [anon_sym_NA_real_] = ACTIONS(5169),
    [anon_sym_NA_complex_] = ACTIONS(5169),
    [anon_sym_NA_character_] = ACTIONS(5169),
    [sym_dots] = ACTIONS(5169),
    [sym_dot_dot_i] = ACTIONS(5167),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5167),
    [sym__newline] = ACTIONS(5167),
    [sym__raw_string_literal] = ACTIONS(5167),
    [sym__external_else] = ACTIONS(6041),
    [sym__external_open_parenthesis] = ACTIONS(6035),
    [sym__external_open_brace] = ACTIONS(5167),
    [sym__external_open_bracket] = ACTIONS(6037),
    [sym__external_close_bracket] = ACTIONS(5167),
    [sym__external_open_bracket2] = ACTIONS(6039),
  },
  [1000] = {
    [sym_call_arguments] = STATE(2853),
    [sym_subset_arguments] = STATE(2854),
    [sym_subset2_arguments] = STATE(2864),
    [sym__else] = STATE(4152),
    [sym__open_parenthesis] = STATE(1366),
    [sym__open_bracket] = STATE(1365),
    [sym__open_bracket2] = STATE(1364),
    [sym_identifier] = ACTIONS(5115),
    [anon_sym_BSLASH] = ACTIONS(5117),
    [anon_sym_function] = ACTIONS(5115),
    [anon_sym_EQ] = ACTIONS(5995),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_for] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_repeat] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(5117),
    [anon_sym_TILDE] = ACTIONS(5997),
    [anon_sym_BANG] = ACTIONS(5115),
    [anon_sym_PLUS] = ACTIONS(5999),
    [anon_sym_DASH] = ACTIONS(6001),
    [anon_sym_LT_DASH] = ACTIONS(6003),
    [anon_sym_LT_LT_DASH] = ACTIONS(6003),
    [anon_sym_COLON_EQ] = ACTIONS(6003),
    [anon_sym_DASH_GT] = ACTIONS(6005),
    [anon_sym_DASH_GT_GT] = ACTIONS(6007),
    [anon_sym_PIPE] = ACTIONS(6009),
    [anon_sym_AMP] = ACTIONS(6011),
    [anon_sym_PIPE_PIPE] = ACTIONS(6013),
    [anon_sym_AMP_AMP] = ACTIONS(6015),
    [anon_sym_LT] = ACTIONS(6017),
    [anon_sym_LT_EQ] = ACTIONS(6019),
    [anon_sym_GT] = ACTIONS(6017),
    [anon_sym_GT_EQ] = ACTIONS(6019),
    [anon_sym_EQ_EQ] = ACTIONS(6019),
    [anon_sym_BANG_EQ] = ACTIONS(6019),
    [anon_sym_STAR] = ACTIONS(6021),
    [anon_sym_SLASH] = ACTIONS(6023),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_CARET] = ACTIONS(6025),
    [aux_sym_binary_operator_token1] = ACTIONS(6027),
    [anon_sym_PIPE_GT] = ACTIONS(6027),
    [anon_sym_COLON] = ACTIONS(6029),
    [anon_sym_DOLLAR] = ACTIONS(6031),
    [anon_sym_AT] = ACTIONS(6031),
    [aux_sym__hex_literal_token1] = ACTIONS(5117),
    [sym__number_literal] = ACTIONS(5115),
    [anon_sym_SQUOTE] = ACTIONS(5117),
    [anon_sym_DQUOTE] = ACTIONS(5117),
    [sym_return] = ACTIONS(5115),
    [sym_next] = ACTIONS(5115),
    [sym_break] = ACTIONS(5115),
    [sym_true] = ACTIONS(5115),
    [sym_false] = ACTIONS(5115),
    [sym_null] = ACTIONS(5115),
    [sym_inf] = ACTIONS(5115),
    [sym_nan] = ACTIONS(5115),
    [anon_sym_NA] = ACTIONS(5115),
    [anon_sym_NA_integer_] = ACTIONS(5115),
    [anon_sym_NA_real_] = ACTIONS(5115),
    [anon_sym_NA_complex_] = ACTIONS(5115),
    [anon_sym_NA_character_] = ACTIONS(5115),
    [sym_dots] = ACTIONS(5115),
    [sym_dot_dot_i] = ACTIONS(5117),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5117),
    [sym__newline] = ACTIONS(5117),
    [sym__raw_string_literal] = ACTIONS(5117),
    [sym__external_else] = ACTIONS(6043),
    [sym__external_open_parenthesis] = ACTIONS(6035),
    [sym__external_open_brace] = ACTIONS(5117),
    [sym__external_open_bracket] = ACTIONS(6037),
    [sym__external_close_bracket] = ACTIONS(5117),
    [sym__external_open_bracket2] = ACTIONS(6039),
  },
  [1001] = {
    [sym_call_arguments] = STATE(2923),
    [sym_subset_arguments] = STATE(2922),
    [sym_subset2_arguments] = STATE(2906),
    [sym__else] = STATE(4164),
    [sym__open_parenthesis] = STATE(1528),
    [sym__open_bracket] = STATE(1525),
    [sym__open_bracket2] = STATE(1519),
    [ts_builtin_sym_end] = ACTIONS(5167),
    [sym_identifier] = ACTIONS(5169),
    [anon_sym_BSLASH] = ACTIONS(5167),
    [anon_sym_function] = ACTIONS(5169),
    [anon_sym_EQ] = ACTIONS(5947),
    [anon_sym_if] = ACTIONS(5169),
    [anon_sym_for] = ACTIONS(5169),
    [anon_sym_while] = ACTIONS(5169),
    [anon_sym_repeat] = ACTIONS(5169),
    [anon_sym_QMARK] = ACTIONS(5167),
    [anon_sym_TILDE] = ACTIONS(5949),
    [anon_sym_BANG] = ACTIONS(5169),
    [anon_sym_PLUS] = ACTIONS(5951),
    [anon_sym_DASH] = ACTIONS(5953),
    [anon_sym_LT_DASH] = ACTIONS(5955),
    [anon_sym_LT_LT_DASH] = ACTIONS(5955),
    [anon_sym_COLON_EQ] = ACTIONS(5955),
    [anon_sym_DASH_GT] = ACTIONS(5957),
    [anon_sym_DASH_GT_GT] = ACTIONS(5959),
    [anon_sym_PIPE] = ACTIONS(5961),
    [anon_sym_AMP] = ACTIONS(5963),
    [anon_sym_PIPE_PIPE] = ACTIONS(5965),
    [anon_sym_AMP_AMP] = ACTIONS(5967),
    [anon_sym_LT] = ACTIONS(5969),
    [anon_sym_LT_EQ] = ACTIONS(5971),
    [anon_sym_GT] = ACTIONS(5969),
    [anon_sym_GT_EQ] = ACTIONS(5971),
    [anon_sym_EQ_EQ] = ACTIONS(5971),
    [anon_sym_BANG_EQ] = ACTIONS(5971),
    [anon_sym_STAR] = ACTIONS(5973),
    [anon_sym_SLASH] = ACTIONS(5975),
    [anon_sym_STAR_STAR] = ACTIONS(5977),
    [anon_sym_CARET] = ACTIONS(5977),
    [aux_sym_binary_operator_token1] = ACTIONS(5979),
    [anon_sym_PIPE_GT] = ACTIONS(5979),
    [anon_sym_COLON] = ACTIONS(5981),
    [anon_sym_DOLLAR] = ACTIONS(5983),
    [anon_sym_AT] = ACTIONS(5983),
    [aux_sym__hex_literal_token1] = ACTIONS(5167),
    [sym__number_literal] = ACTIONS(5169),
    [anon_sym_SQUOTE] = ACTIONS(5167),
    [anon_sym_DQUOTE] = ACTIONS(5167),
    [sym_return] = ACTIONS(5169),
    [sym_next] = ACTIONS(5169),
    [sym_break] = ACTIONS(5169),
    [sym_true] = ACTIONS(5169),
    [sym_false] = ACTIONS(5169),
    [sym_null] = ACTIONS(5169),
    [sym_inf] = ACTIONS(5169),
    [sym_nan] = ACTIONS(5169),
    [anon_sym_NA] = ACTIONS(5169),
    [anon_sym_NA_integer_] = ACTIONS(5169),
    [anon_sym_NA_real_] = ACTIONS(5169),
    [anon_sym_NA_complex_] = ACTIONS(5169),
    [anon_sym_NA_character_] = ACTIONS(5169),
    [sym_dots] = ACTIONS(5169),
    [sym_dot_dot_i] = ACTIONS(5167),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5167),
    [sym__semicolon] = ACTIONS(5167),
    [sym__raw_string_literal] = ACTIONS(5167),
    [sym__external_else] = ACTIONS(6045),
    [sym__external_open_parenthesis] = ACTIONS(5987),
    [sym__external_open_brace] = ACTIONS(5167),
    [sym__external_open_bracket] = ACTIONS(5989),
    [sym__external_open_bracket2] = ACTIONS(5991),
  },
  [1002] = {
    [sym_call_arguments] = STATE(2678),
    [sym_subset_arguments] = STATE(2679),
    [sym_subset2_arguments] = STATE(2683),
    [sym__open_parenthesis] = STATE(1443),
    [sym__open_bracket] = STATE(1442),
    [sym__open_bracket2] = STATE(1425),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(5639),
    [anon_sym_CARET] = ACTIONS(5639),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(5351),
    [anon_sym_DOLLAR] = ACTIONS(5645),
    [anon_sym_AT] = ACTIONS(5645),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5649),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5651),
    [sym__external_open_bracket2] = ACTIONS(5653),
  },
  [1003] = {
    [sym_call_arguments] = STATE(2678),
    [sym_subset_arguments] = STATE(2679),
    [sym_subset2_arguments] = STATE(2683),
    [sym__open_parenthesis] = STATE(1443),
    [sym__open_bracket] = STATE(1442),
    [sym__open_bracket2] = STATE(1425),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(5639),
    [anon_sym_CARET] = ACTIONS(5639),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(5643),
    [anon_sym_DOLLAR] = ACTIONS(5645),
    [anon_sym_AT] = ACTIONS(5645),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5649),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5651),
    [sym__external_open_bracket2] = ACTIONS(5653),
  },
  [1004] = {
    [sym_call_arguments] = STATE(2923),
    [sym_subset_arguments] = STATE(2922),
    [sym_subset2_arguments] = STATE(2906),
    [sym__else] = STATE(4168),
    [sym__open_parenthesis] = STATE(1528),
    [sym__open_bracket] = STATE(1525),
    [sym__open_bracket2] = STATE(1519),
    [ts_builtin_sym_end] = ACTIONS(5117),
    [sym_identifier] = ACTIONS(5115),
    [anon_sym_BSLASH] = ACTIONS(5117),
    [anon_sym_function] = ACTIONS(5115),
    [anon_sym_EQ] = ACTIONS(5947),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_for] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_repeat] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(5117),
    [anon_sym_TILDE] = ACTIONS(5949),
    [anon_sym_BANG] = ACTIONS(5115),
    [anon_sym_PLUS] = ACTIONS(5951),
    [anon_sym_DASH] = ACTIONS(5953),
    [anon_sym_LT_DASH] = ACTIONS(5955),
    [anon_sym_LT_LT_DASH] = ACTIONS(5955),
    [anon_sym_COLON_EQ] = ACTIONS(5955),
    [anon_sym_DASH_GT] = ACTIONS(5957),
    [anon_sym_DASH_GT_GT] = ACTIONS(5959),
    [anon_sym_PIPE] = ACTIONS(5961),
    [anon_sym_AMP] = ACTIONS(5963),
    [anon_sym_PIPE_PIPE] = ACTIONS(5965),
    [anon_sym_AMP_AMP] = ACTIONS(5967),
    [anon_sym_LT] = ACTIONS(5969),
    [anon_sym_LT_EQ] = ACTIONS(5971),
    [anon_sym_GT] = ACTIONS(5969),
    [anon_sym_GT_EQ] = ACTIONS(5971),
    [anon_sym_EQ_EQ] = ACTIONS(5971),
    [anon_sym_BANG_EQ] = ACTIONS(5971),
    [anon_sym_STAR] = ACTIONS(5973),
    [anon_sym_SLASH] = ACTIONS(5975),
    [anon_sym_STAR_STAR] = ACTIONS(5977),
    [anon_sym_CARET] = ACTIONS(5977),
    [aux_sym_binary_operator_token1] = ACTIONS(5979),
    [anon_sym_PIPE_GT] = ACTIONS(5979),
    [anon_sym_COLON] = ACTIONS(5981),
    [anon_sym_DOLLAR] = ACTIONS(5983),
    [anon_sym_AT] = ACTIONS(5983),
    [aux_sym__hex_literal_token1] = ACTIONS(5117),
    [sym__number_literal] = ACTIONS(5115),
    [anon_sym_SQUOTE] = ACTIONS(5117),
    [anon_sym_DQUOTE] = ACTIONS(5117),
    [sym_return] = ACTIONS(5115),
    [sym_next] = ACTIONS(5115),
    [sym_break] = ACTIONS(5115),
    [sym_true] = ACTIONS(5115),
    [sym_false] = ACTIONS(5115),
    [sym_null] = ACTIONS(5115),
    [sym_inf] = ACTIONS(5115),
    [sym_nan] = ACTIONS(5115),
    [anon_sym_NA] = ACTIONS(5115),
    [anon_sym_NA_integer_] = ACTIONS(5115),
    [anon_sym_NA_real_] = ACTIONS(5115),
    [anon_sym_NA_complex_] = ACTIONS(5115),
    [anon_sym_NA_character_] = ACTIONS(5115),
    [sym_dots] = ACTIONS(5115),
    [sym_dot_dot_i] = ACTIONS(5117),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5117),
    [sym__semicolon] = ACTIONS(5117),
    [sym__raw_string_literal] = ACTIONS(5117),
    [sym__external_else] = ACTIONS(6047),
    [sym__external_open_parenthesis] = ACTIONS(5987),
    [sym__external_open_brace] = ACTIONS(5117),
    [sym__external_open_bracket] = ACTIONS(5989),
    [sym__external_open_bracket2] = ACTIONS(5991),
  },
  [1005] = {
    [sym_call_arguments] = STATE(2678),
    [sym_subset_arguments] = STATE(2679),
    [sym_subset2_arguments] = STATE(2683),
    [sym__open_parenthesis] = STATE(1443),
    [sym__open_bracket] = STATE(1442),
    [sym__open_bracket2] = STATE(1425),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(5639),
    [anon_sym_CARET] = ACTIONS(5639),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(5351),
    [anon_sym_DOLLAR] = ACTIONS(5645),
    [anon_sym_AT] = ACTIONS(5645),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5649),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5651),
    [sym__external_open_bracket2] = ACTIONS(5653),
  },
  [1006] = {
    [sym_call_arguments] = STATE(2678),
    [sym_subset_arguments] = STATE(2679),
    [sym_subset2_arguments] = STATE(2683),
    [sym__open_parenthesis] = STATE(1443),
    [sym__open_bracket] = STATE(1442),
    [sym__open_bracket2] = STATE(1425),
    [ts_builtin_sym_end] = ACTIONS(5399),
    [sym_identifier] = ACTIONS(5401),
    [anon_sym_BSLASH] = ACTIONS(5399),
    [anon_sym_function] = ACTIONS(5401),
    [anon_sym_EQ] = ACTIONS(5609),
    [anon_sym_if] = ACTIONS(5401),
    [anon_sym_for] = ACTIONS(5401),
    [anon_sym_while] = ACTIONS(5401),
    [anon_sym_repeat] = ACTIONS(5401),
    [anon_sym_QMARK] = ACTIONS(5399),
    [anon_sym_TILDE] = ACTIONS(5611),
    [anon_sym_BANG] = ACTIONS(5401),
    [anon_sym_PLUS] = ACTIONS(5613),
    [anon_sym_DASH] = ACTIONS(5615),
    [anon_sym_LT_DASH] = ACTIONS(5617),
    [anon_sym_LT_LT_DASH] = ACTIONS(5617),
    [anon_sym_COLON_EQ] = ACTIONS(5617),
    [anon_sym_DASH_GT] = ACTIONS(5619),
    [anon_sym_DASH_GT_GT] = ACTIONS(5621),
    [anon_sym_PIPE] = ACTIONS(5623),
    [anon_sym_AMP] = ACTIONS(5625),
    [anon_sym_PIPE_PIPE] = ACTIONS(5627),
    [anon_sym_AMP_AMP] = ACTIONS(5629),
    [anon_sym_LT] = ACTIONS(5631),
    [anon_sym_LT_EQ] = ACTIONS(5633),
    [anon_sym_GT] = ACTIONS(5631),
    [anon_sym_GT_EQ] = ACTIONS(5633),
    [anon_sym_EQ_EQ] = ACTIONS(5633),
    [anon_sym_BANG_EQ] = ACTIONS(5633),
    [anon_sym_STAR] = ACTIONS(5635),
    [anon_sym_SLASH] = ACTIONS(5637),
    [anon_sym_STAR_STAR] = ACTIONS(5639),
    [anon_sym_CARET] = ACTIONS(5639),
    [aux_sym_binary_operator_token1] = ACTIONS(5641),
    [anon_sym_PIPE_GT] = ACTIONS(5641),
    [anon_sym_COLON] = ACTIONS(5643),
    [anon_sym_DOLLAR] = ACTIONS(5645),
    [anon_sym_AT] = ACTIONS(5645),
    [aux_sym__hex_literal_token1] = ACTIONS(5399),
    [sym__number_literal] = ACTIONS(5401),
    [anon_sym_SQUOTE] = ACTIONS(5399),
    [anon_sym_DQUOTE] = ACTIONS(5399),
    [sym_return] = ACTIONS(5401),
    [sym_next] = ACTIONS(5401),
    [sym_break] = ACTIONS(5401),
    [sym_true] = ACTIONS(5401),
    [sym_false] = ACTIONS(5401),
    [sym_null] = ACTIONS(5401),
    [sym_inf] = ACTIONS(5401),
    [sym_nan] = ACTIONS(5401),
    [anon_sym_NA] = ACTIONS(5401),
    [anon_sym_NA_integer_] = ACTIONS(5401),
    [anon_sym_NA_real_] = ACTIONS(5401),
    [anon_sym_NA_complex_] = ACTIONS(5401),
    [anon_sym_NA_character_] = ACTIONS(5401),
    [sym_dots] = ACTIONS(5401),
    [sym_dot_dot_i] = ACTIONS(5399),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5399),
    [sym__semicolon] = ACTIONS(5399),
    [sym__raw_string_literal] = ACTIONS(5399),
    [sym__external_else] = ACTIONS(5399),
    [sym__external_open_parenthesis] = ACTIONS(5649),
    [sym__external_close_parenthesis] = ACTIONS(5399),
    [sym__external_open_brace] = ACTIONS(5399),
    [sym__external_open_bracket] = ACTIONS(5651),
    [sym__external_open_bracket2] = ACTIONS(5653),
  },
  [1007] = {
    [sym_call_arguments] = STATE(2678),
    [sym_subset_arguments] = STATE(2679),
    [sym_subset2_arguments] = STATE(2683),
    [sym__open_parenthesis] = STATE(1443),
    [sym__open_bracket] = STATE(1442),
    [sym__open_bracket2] = STATE(1425),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5609),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5611),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5613),
    [anon_sym_DASH] = ACTIONS(5615),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5619),
    [anon_sym_DASH_GT_GT] = ACTIONS(5621),
    [anon_sym_PIPE] = ACTIONS(5623),
    [anon_sym_AMP] = ACTIONS(5625),
    [anon_sym_PIPE_PIPE] = ACTIONS(5627),
    [anon_sym_AMP_AMP] = ACTIONS(5629),
    [anon_sym_LT] = ACTIONS(5631),
    [anon_sym_LT_EQ] = ACTIONS(5633),
    [anon_sym_GT] = ACTIONS(5631),
    [anon_sym_GT_EQ] = ACTIONS(5633),
    [anon_sym_EQ_EQ] = ACTIONS(5633),
    [anon_sym_BANG_EQ] = ACTIONS(5633),
    [anon_sym_STAR] = ACTIONS(5635),
    [anon_sym_SLASH] = ACTIONS(5637),
    [anon_sym_STAR_STAR] = ACTIONS(5639),
    [anon_sym_CARET] = ACTIONS(5639),
    [aux_sym_binary_operator_token1] = ACTIONS(5641),
    [anon_sym_PIPE_GT] = ACTIONS(5641),
    [anon_sym_COLON] = ACTIONS(5643),
    [anon_sym_DOLLAR] = ACTIONS(5645),
    [anon_sym_AT] = ACTIONS(5645),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5649),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5651),
    [sym__external_open_bracket2] = ACTIONS(5653),
  },
  [1008] = {
    [sym_call_arguments] = STATE(2853),
    [sym_subset_arguments] = STATE(2854),
    [sym_subset2_arguments] = STATE(2864),
    [sym__else] = STATE(4159),
    [sym__open_parenthesis] = STATE(1366),
    [sym__open_bracket] = STATE(1365),
    [sym__open_bracket2] = STATE(1364),
    [sym_identifier] = ACTIONS(5065),
    [anon_sym_BSLASH] = ACTIONS(5067),
    [anon_sym_function] = ACTIONS(5065),
    [anon_sym_EQ] = ACTIONS(5995),
    [anon_sym_if] = ACTIONS(5065),
    [anon_sym_for] = ACTIONS(5065),
    [anon_sym_while] = ACTIONS(5065),
    [anon_sym_repeat] = ACTIONS(5065),
    [anon_sym_QMARK] = ACTIONS(5067),
    [anon_sym_TILDE] = ACTIONS(5997),
    [anon_sym_BANG] = ACTIONS(5065),
    [anon_sym_PLUS] = ACTIONS(5999),
    [anon_sym_DASH] = ACTIONS(6001),
    [anon_sym_LT_DASH] = ACTIONS(6003),
    [anon_sym_LT_LT_DASH] = ACTIONS(6003),
    [anon_sym_COLON_EQ] = ACTIONS(6003),
    [anon_sym_DASH_GT] = ACTIONS(6005),
    [anon_sym_DASH_GT_GT] = ACTIONS(6007),
    [anon_sym_PIPE] = ACTIONS(6009),
    [anon_sym_AMP] = ACTIONS(6011),
    [anon_sym_PIPE_PIPE] = ACTIONS(6013),
    [anon_sym_AMP_AMP] = ACTIONS(6015),
    [anon_sym_LT] = ACTIONS(6017),
    [anon_sym_LT_EQ] = ACTIONS(6019),
    [anon_sym_GT] = ACTIONS(6017),
    [anon_sym_GT_EQ] = ACTIONS(6019),
    [anon_sym_EQ_EQ] = ACTIONS(6019),
    [anon_sym_BANG_EQ] = ACTIONS(6019),
    [anon_sym_STAR] = ACTIONS(6021),
    [anon_sym_SLASH] = ACTIONS(6023),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_CARET] = ACTIONS(6025),
    [aux_sym_binary_operator_token1] = ACTIONS(6027),
    [anon_sym_PIPE_GT] = ACTIONS(6027),
    [anon_sym_COLON] = ACTIONS(6029),
    [anon_sym_DOLLAR] = ACTIONS(6031),
    [anon_sym_AT] = ACTIONS(6031),
    [aux_sym__hex_literal_token1] = ACTIONS(5067),
    [sym__number_literal] = ACTIONS(5065),
    [anon_sym_SQUOTE] = ACTIONS(5067),
    [anon_sym_DQUOTE] = ACTIONS(5067),
    [sym_return] = ACTIONS(5065),
    [sym_next] = ACTIONS(5065),
    [sym_break] = ACTIONS(5065),
    [sym_true] = ACTIONS(5065),
    [sym_false] = ACTIONS(5065),
    [sym_null] = ACTIONS(5065),
    [sym_inf] = ACTIONS(5065),
    [sym_nan] = ACTIONS(5065),
    [anon_sym_NA] = ACTIONS(5065),
    [anon_sym_NA_integer_] = ACTIONS(5065),
    [anon_sym_NA_real_] = ACTIONS(5065),
    [anon_sym_NA_complex_] = ACTIONS(5065),
    [anon_sym_NA_character_] = ACTIONS(5065),
    [sym_dots] = ACTIONS(5065),
    [sym_dot_dot_i] = ACTIONS(5067),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5067),
    [sym__newline] = ACTIONS(5067),
    [sym__raw_string_literal] = ACTIONS(5067),
    [sym__external_else] = ACTIONS(6049),
    [sym__external_open_parenthesis] = ACTIONS(6035),
    [sym__external_open_brace] = ACTIONS(5067),
    [sym__external_open_bracket] = ACTIONS(6037),
    [sym__external_close_bracket] = ACTIONS(5067),
    [sym__external_open_bracket2] = ACTIONS(6039),
  },
  [1009] = {
    [sym_call_arguments] = STATE(2678),
    [sym_subset_arguments] = STATE(2679),
    [sym_subset2_arguments] = STATE(2683),
    [sym__open_parenthesis] = STATE(1443),
    [sym__open_bracket] = STATE(1442),
    [sym__open_bracket2] = STATE(1425),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5609),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5611),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5613),
    [anon_sym_DASH] = ACTIONS(5615),
    [anon_sym_LT_DASH] = ACTIONS(5617),
    [anon_sym_LT_LT_DASH] = ACTIONS(5617),
    [anon_sym_COLON_EQ] = ACTIONS(5617),
    [anon_sym_DASH_GT] = ACTIONS(5619),
    [anon_sym_DASH_GT_GT] = ACTIONS(5621),
    [anon_sym_PIPE] = ACTIONS(5623),
    [anon_sym_AMP] = ACTIONS(5625),
    [anon_sym_PIPE_PIPE] = ACTIONS(5627),
    [anon_sym_AMP_AMP] = ACTIONS(5629),
    [anon_sym_LT] = ACTIONS(5631),
    [anon_sym_LT_EQ] = ACTIONS(5633),
    [anon_sym_GT] = ACTIONS(5631),
    [anon_sym_GT_EQ] = ACTIONS(5633),
    [anon_sym_EQ_EQ] = ACTIONS(5633),
    [anon_sym_BANG_EQ] = ACTIONS(5633),
    [anon_sym_STAR] = ACTIONS(5635),
    [anon_sym_SLASH] = ACTIONS(5637),
    [anon_sym_STAR_STAR] = ACTIONS(5639),
    [anon_sym_CARET] = ACTIONS(5639),
    [aux_sym_binary_operator_token1] = ACTIONS(5641),
    [anon_sym_PIPE_GT] = ACTIONS(5641),
    [anon_sym_COLON] = ACTIONS(5643),
    [anon_sym_DOLLAR] = ACTIONS(5645),
    [anon_sym_AT] = ACTIONS(5645),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5649),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5651),
    [sym__external_open_bracket2] = ACTIONS(5653),
  },
  [1010] = {
    [sym_call_arguments] = STATE(2678),
    [sym_subset_arguments] = STATE(2679),
    [sym_subset2_arguments] = STATE(2683),
    [sym__open_parenthesis] = STATE(1443),
    [sym__open_bracket] = STATE(1442),
    [sym__open_bracket2] = STATE(1425),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5613),
    [anon_sym_DASH] = ACTIONS(5615),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5623),
    [anon_sym_AMP] = ACTIONS(5625),
    [anon_sym_PIPE_PIPE] = ACTIONS(5627),
    [anon_sym_AMP_AMP] = ACTIONS(5629),
    [anon_sym_LT] = ACTIONS(5631),
    [anon_sym_LT_EQ] = ACTIONS(5633),
    [anon_sym_GT] = ACTIONS(5631),
    [anon_sym_GT_EQ] = ACTIONS(5633),
    [anon_sym_EQ_EQ] = ACTIONS(5633),
    [anon_sym_BANG_EQ] = ACTIONS(5633),
    [anon_sym_STAR] = ACTIONS(5635),
    [anon_sym_SLASH] = ACTIONS(5637),
    [anon_sym_STAR_STAR] = ACTIONS(5639),
    [anon_sym_CARET] = ACTIONS(5639),
    [aux_sym_binary_operator_token1] = ACTIONS(5641),
    [anon_sym_PIPE_GT] = ACTIONS(5641),
    [anon_sym_COLON] = ACTIONS(5643),
    [anon_sym_DOLLAR] = ACTIONS(5645),
    [anon_sym_AT] = ACTIONS(5645),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5649),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5651),
    [sym__external_open_bracket2] = ACTIONS(5653),
  },
  [1011] = {
    [sym_call_arguments] = STATE(2678),
    [sym_subset_arguments] = STATE(2679),
    [sym_subset2_arguments] = STATE(2683),
    [sym__open_parenthesis] = STATE(1443),
    [sym__open_bracket] = STATE(1442),
    [sym__open_bracket2] = STATE(1425),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5635),
    [anon_sym_SLASH] = ACTIONS(5637),
    [anon_sym_STAR_STAR] = ACTIONS(5639),
    [anon_sym_CARET] = ACTIONS(5639),
    [aux_sym_binary_operator_token1] = ACTIONS(5641),
    [anon_sym_PIPE_GT] = ACTIONS(5641),
    [anon_sym_COLON] = ACTIONS(5643),
    [anon_sym_DOLLAR] = ACTIONS(5645),
    [anon_sym_AT] = ACTIONS(5645),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5649),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5651),
    [sym__external_open_bracket2] = ACTIONS(5653),
  },
  [1012] = {
    [sym_call_arguments] = STATE(2678),
    [sym_subset_arguments] = STATE(2679),
    [sym_subset2_arguments] = STATE(2683),
    [sym__open_parenthesis] = STATE(1443),
    [sym__open_bracket] = STATE(1442),
    [sym__open_bracket2] = STATE(1425),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5609),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5611),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5613),
    [anon_sym_DASH] = ACTIONS(5615),
    [anon_sym_LT_DASH] = ACTIONS(5617),
    [anon_sym_LT_LT_DASH] = ACTIONS(5617),
    [anon_sym_COLON_EQ] = ACTIONS(5617),
    [anon_sym_DASH_GT] = ACTIONS(5619),
    [anon_sym_DASH_GT_GT] = ACTIONS(5621),
    [anon_sym_PIPE] = ACTIONS(5623),
    [anon_sym_AMP] = ACTIONS(5625),
    [anon_sym_PIPE_PIPE] = ACTIONS(5627),
    [anon_sym_AMP_AMP] = ACTIONS(5629),
    [anon_sym_LT] = ACTIONS(5631),
    [anon_sym_LT_EQ] = ACTIONS(5633),
    [anon_sym_GT] = ACTIONS(5631),
    [anon_sym_GT_EQ] = ACTIONS(5633),
    [anon_sym_EQ_EQ] = ACTIONS(5633),
    [anon_sym_BANG_EQ] = ACTIONS(5633),
    [anon_sym_STAR] = ACTIONS(5635),
    [anon_sym_SLASH] = ACTIONS(5637),
    [anon_sym_STAR_STAR] = ACTIONS(5639),
    [anon_sym_CARET] = ACTIONS(5639),
    [aux_sym_binary_operator_token1] = ACTIONS(5641),
    [anon_sym_PIPE_GT] = ACTIONS(5641),
    [anon_sym_COLON] = ACTIONS(5643),
    [anon_sym_DOLLAR] = ACTIONS(5645),
    [anon_sym_AT] = ACTIONS(5645),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5649),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5651),
    [sym__external_open_bracket2] = ACTIONS(5653),
  },
  [1013] = {
    [sym_call_arguments] = STATE(2678),
    [sym_subset_arguments] = STATE(2679),
    [sym_subset2_arguments] = STATE(2683),
    [sym__open_parenthesis] = STATE(1443),
    [sym__open_bracket] = STATE(1442),
    [sym__open_bracket2] = STATE(1425),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5611),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5613),
    [anon_sym_DASH] = ACTIONS(5615),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5623),
    [anon_sym_AMP] = ACTIONS(5625),
    [anon_sym_PIPE_PIPE] = ACTIONS(5627),
    [anon_sym_AMP_AMP] = ACTIONS(5629),
    [anon_sym_LT] = ACTIONS(5631),
    [anon_sym_LT_EQ] = ACTIONS(5633),
    [anon_sym_GT] = ACTIONS(5631),
    [anon_sym_GT_EQ] = ACTIONS(5633),
    [anon_sym_EQ_EQ] = ACTIONS(5633),
    [anon_sym_BANG_EQ] = ACTIONS(5633),
    [anon_sym_STAR] = ACTIONS(5635),
    [anon_sym_SLASH] = ACTIONS(5637),
    [anon_sym_STAR_STAR] = ACTIONS(5639),
    [anon_sym_CARET] = ACTIONS(5639),
    [aux_sym_binary_operator_token1] = ACTIONS(5641),
    [anon_sym_PIPE_GT] = ACTIONS(5641),
    [anon_sym_COLON] = ACTIONS(5643),
    [anon_sym_DOLLAR] = ACTIONS(5645),
    [anon_sym_AT] = ACTIONS(5645),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5649),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5651),
    [sym__external_open_bracket2] = ACTIONS(5653),
  },
  [1014] = {
    [sym_call_arguments] = STATE(2678),
    [sym_subset_arguments] = STATE(2679),
    [sym_subset2_arguments] = STATE(2683),
    [sym__open_parenthesis] = STATE(1443),
    [sym__open_bracket] = STATE(1442),
    [sym__open_bracket2] = STATE(1425),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5613),
    [anon_sym_DASH] = ACTIONS(5615),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5625),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5629),
    [anon_sym_LT] = ACTIONS(5631),
    [anon_sym_LT_EQ] = ACTIONS(5633),
    [anon_sym_GT] = ACTIONS(5631),
    [anon_sym_GT_EQ] = ACTIONS(5633),
    [anon_sym_EQ_EQ] = ACTIONS(5633),
    [anon_sym_BANG_EQ] = ACTIONS(5633),
    [anon_sym_STAR] = ACTIONS(5635),
    [anon_sym_SLASH] = ACTIONS(5637),
    [anon_sym_STAR_STAR] = ACTIONS(5639),
    [anon_sym_CARET] = ACTIONS(5639),
    [aux_sym_binary_operator_token1] = ACTIONS(5641),
    [anon_sym_PIPE_GT] = ACTIONS(5641),
    [anon_sym_COLON] = ACTIONS(5643),
    [anon_sym_DOLLAR] = ACTIONS(5645),
    [anon_sym_AT] = ACTIONS(5645),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5649),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5651),
    [sym__external_open_bracket2] = ACTIONS(5653),
  },
  [1015] = {
    [sym_call_arguments] = STATE(2678),
    [sym_subset_arguments] = STATE(2679),
    [sym_subset2_arguments] = STATE(2683),
    [sym__open_parenthesis] = STATE(1443),
    [sym__open_bracket] = STATE(1442),
    [sym__open_bracket2] = STATE(1425),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5613),
    [anon_sym_DASH] = ACTIONS(5615),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5631),
    [anon_sym_LT_EQ] = ACTIONS(5633),
    [anon_sym_GT] = ACTIONS(5631),
    [anon_sym_GT_EQ] = ACTIONS(5633),
    [anon_sym_EQ_EQ] = ACTIONS(5633),
    [anon_sym_BANG_EQ] = ACTIONS(5633),
    [anon_sym_STAR] = ACTIONS(5635),
    [anon_sym_SLASH] = ACTIONS(5637),
    [anon_sym_STAR_STAR] = ACTIONS(5639),
    [anon_sym_CARET] = ACTIONS(5639),
    [aux_sym_binary_operator_token1] = ACTIONS(5641),
    [anon_sym_PIPE_GT] = ACTIONS(5641),
    [anon_sym_COLON] = ACTIONS(5643),
    [anon_sym_DOLLAR] = ACTIONS(5645),
    [anon_sym_AT] = ACTIONS(5645),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5649),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5651),
    [sym__external_open_bracket2] = ACTIONS(5653),
  },
  [1016] = {
    [sym_call_arguments] = STATE(2678),
    [sym_subset_arguments] = STATE(2679),
    [sym_subset2_arguments] = STATE(2683),
    [sym__open_parenthesis] = STATE(1443),
    [sym__open_bracket] = STATE(1442),
    [sym__open_bracket2] = STATE(1425),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5613),
    [anon_sym_DASH] = ACTIONS(5615),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5635),
    [anon_sym_SLASH] = ACTIONS(5637),
    [anon_sym_STAR_STAR] = ACTIONS(5639),
    [anon_sym_CARET] = ACTIONS(5639),
    [aux_sym_binary_operator_token1] = ACTIONS(5641),
    [anon_sym_PIPE_GT] = ACTIONS(5641),
    [anon_sym_COLON] = ACTIONS(5643),
    [anon_sym_DOLLAR] = ACTIONS(5645),
    [anon_sym_AT] = ACTIONS(5645),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5649),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5651),
    [sym__external_open_bracket2] = ACTIONS(5653),
  },
  [1017] = {
    [sym_call_arguments] = STATE(2678),
    [sym_subset_arguments] = STATE(2679),
    [sym_subset2_arguments] = STATE(2683),
    [sym__open_parenthesis] = STATE(1443),
    [sym__open_bracket] = STATE(1442),
    [sym__open_bracket2] = STATE(1425),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(5639),
    [anon_sym_CARET] = ACTIONS(5639),
    [aux_sym_binary_operator_token1] = ACTIONS(5641),
    [anon_sym_PIPE_GT] = ACTIONS(5641),
    [anon_sym_COLON] = ACTIONS(5643),
    [anon_sym_DOLLAR] = ACTIONS(5645),
    [anon_sym_AT] = ACTIONS(5645),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5649),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5651),
    [sym__external_open_bracket2] = ACTIONS(5653),
  },
  [1018] = {
    [sym_call_arguments] = STATE(2678),
    [sym_subset_arguments] = STATE(2679),
    [sym_subset2_arguments] = STATE(2683),
    [sym__open_parenthesis] = STATE(1443),
    [sym__open_bracket] = STATE(1442),
    [sym__open_bracket2] = STATE(1425),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(5639),
    [anon_sym_CARET] = ACTIONS(5639),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(5261),
    [anon_sym_DOLLAR] = ACTIONS(5645),
    [anon_sym_AT] = ACTIONS(5645),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5649),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5651),
    [sym__external_open_bracket2] = ACTIONS(5653),
  },
  [1019] = {
    [sym_call_arguments] = STATE(2678),
    [sym_subset_arguments] = STATE(2679),
    [sym_subset2_arguments] = STATE(2683),
    [sym__open_parenthesis] = STATE(1443),
    [sym__open_bracket] = STATE(1442),
    [sym__open_bracket2] = STATE(1425),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(5639),
    [anon_sym_CARET] = ACTIONS(5639),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(5643),
    [anon_sym_DOLLAR] = ACTIONS(5645),
    [anon_sym_AT] = ACTIONS(5645),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5649),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5651),
    [sym__external_open_bracket2] = ACTIONS(5653),
  },
  [1020] = {
    [sym_call_arguments] = STATE(2678),
    [sym_subset_arguments] = STATE(2679),
    [sym_subset2_arguments] = STATE(2683),
    [sym__open_parenthesis] = STATE(1443),
    [sym__open_bracket] = STATE(1442),
    [sym__open_bracket2] = STATE(1425),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(5639),
    [anon_sym_CARET] = ACTIONS(5639),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(5261),
    [anon_sym_DOLLAR] = ACTIONS(5645),
    [anon_sym_AT] = ACTIONS(5645),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5649),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5651),
    [sym__external_open_bracket2] = ACTIONS(5653),
  },
  [1021] = {
    [sym_call_arguments] = STATE(2678),
    [sym_subset_arguments] = STATE(2679),
    [sym_subset2_arguments] = STATE(2683),
    [sym__open_parenthesis] = STATE(1443),
    [sym__open_bracket] = STATE(1442),
    [sym__open_bracket2] = STATE(1425),
    [ts_builtin_sym_end] = ACTIONS(5413),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_BSLASH] = ACTIONS(5413),
    [anon_sym_function] = ACTIONS(5415),
    [anon_sym_EQ] = ACTIONS(5609),
    [anon_sym_if] = ACTIONS(5415),
    [anon_sym_for] = ACTIONS(5415),
    [anon_sym_while] = ACTIONS(5415),
    [anon_sym_repeat] = ACTIONS(5415),
    [anon_sym_QMARK] = ACTIONS(5413),
    [anon_sym_TILDE] = ACTIONS(5611),
    [anon_sym_BANG] = ACTIONS(5415),
    [anon_sym_PLUS] = ACTIONS(5613),
    [anon_sym_DASH] = ACTIONS(5615),
    [anon_sym_LT_DASH] = ACTIONS(5617),
    [anon_sym_LT_LT_DASH] = ACTIONS(5617),
    [anon_sym_COLON_EQ] = ACTIONS(5617),
    [anon_sym_DASH_GT] = ACTIONS(5619),
    [anon_sym_DASH_GT_GT] = ACTIONS(5621),
    [anon_sym_PIPE] = ACTIONS(5623),
    [anon_sym_AMP] = ACTIONS(5625),
    [anon_sym_PIPE_PIPE] = ACTIONS(5627),
    [anon_sym_AMP_AMP] = ACTIONS(5629),
    [anon_sym_LT] = ACTIONS(5631),
    [anon_sym_LT_EQ] = ACTIONS(5633),
    [anon_sym_GT] = ACTIONS(5631),
    [anon_sym_GT_EQ] = ACTIONS(5633),
    [anon_sym_EQ_EQ] = ACTIONS(5633),
    [anon_sym_BANG_EQ] = ACTIONS(5633),
    [anon_sym_STAR] = ACTIONS(5635),
    [anon_sym_SLASH] = ACTIONS(5637),
    [anon_sym_STAR_STAR] = ACTIONS(5639),
    [anon_sym_CARET] = ACTIONS(5639),
    [aux_sym_binary_operator_token1] = ACTIONS(5641),
    [anon_sym_PIPE_GT] = ACTIONS(5641),
    [anon_sym_COLON] = ACTIONS(5643),
    [anon_sym_DOLLAR] = ACTIONS(5645),
    [anon_sym_AT] = ACTIONS(5645),
    [aux_sym__hex_literal_token1] = ACTIONS(5413),
    [sym__number_literal] = ACTIONS(5415),
    [anon_sym_SQUOTE] = ACTIONS(5413),
    [anon_sym_DQUOTE] = ACTIONS(5413),
    [sym_return] = ACTIONS(5415),
    [sym_next] = ACTIONS(5415),
    [sym_break] = ACTIONS(5415),
    [sym_true] = ACTIONS(5415),
    [sym_false] = ACTIONS(5415),
    [sym_null] = ACTIONS(5415),
    [sym_inf] = ACTIONS(5415),
    [sym_nan] = ACTIONS(5415),
    [anon_sym_NA] = ACTIONS(5415),
    [anon_sym_NA_integer_] = ACTIONS(5415),
    [anon_sym_NA_real_] = ACTIONS(5415),
    [anon_sym_NA_complex_] = ACTIONS(5415),
    [anon_sym_NA_character_] = ACTIONS(5415),
    [sym_dots] = ACTIONS(5415),
    [sym_dot_dot_i] = ACTIONS(5413),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5413),
    [sym__semicolon] = ACTIONS(5413),
    [sym__raw_string_literal] = ACTIONS(5413),
    [sym__external_else] = ACTIONS(5413),
    [sym__external_open_parenthesis] = ACTIONS(5649),
    [sym__external_close_parenthesis] = ACTIONS(5413),
    [sym__external_open_brace] = ACTIONS(5413),
    [sym__external_open_bracket] = ACTIONS(5651),
    [sym__external_open_bracket2] = ACTIONS(5653),
  },
  [1022] = {
    [sym_call_arguments] = STATE(2678),
    [sym_subset_arguments] = STATE(2679),
    [sym_subset2_arguments] = STATE(2683),
    [sym__open_parenthesis] = STATE(1443),
    [sym__open_bracket] = STATE(1442),
    [sym__open_bracket2] = STATE(1425),
    [ts_builtin_sym_end] = ACTIONS(5417),
    [sym_identifier] = ACTIONS(5419),
    [anon_sym_BSLASH] = ACTIONS(5417),
    [anon_sym_function] = ACTIONS(5419),
    [anon_sym_EQ] = ACTIONS(5609),
    [anon_sym_if] = ACTIONS(5419),
    [anon_sym_for] = ACTIONS(5419),
    [anon_sym_while] = ACTIONS(5419),
    [anon_sym_repeat] = ACTIONS(5419),
    [anon_sym_QMARK] = ACTIONS(5417),
    [anon_sym_TILDE] = ACTIONS(5611),
    [anon_sym_BANG] = ACTIONS(5419),
    [anon_sym_PLUS] = ACTIONS(5613),
    [anon_sym_DASH] = ACTIONS(5615),
    [anon_sym_LT_DASH] = ACTIONS(5617),
    [anon_sym_LT_LT_DASH] = ACTIONS(5617),
    [anon_sym_COLON_EQ] = ACTIONS(5617),
    [anon_sym_DASH_GT] = ACTIONS(5619),
    [anon_sym_DASH_GT_GT] = ACTIONS(5621),
    [anon_sym_PIPE] = ACTIONS(5623),
    [anon_sym_AMP] = ACTIONS(5625),
    [anon_sym_PIPE_PIPE] = ACTIONS(5627),
    [anon_sym_AMP_AMP] = ACTIONS(5629),
    [anon_sym_LT] = ACTIONS(5631),
    [anon_sym_LT_EQ] = ACTIONS(5633),
    [anon_sym_GT] = ACTIONS(5631),
    [anon_sym_GT_EQ] = ACTIONS(5633),
    [anon_sym_EQ_EQ] = ACTIONS(5633),
    [anon_sym_BANG_EQ] = ACTIONS(5633),
    [anon_sym_STAR] = ACTIONS(5635),
    [anon_sym_SLASH] = ACTIONS(5637),
    [anon_sym_STAR_STAR] = ACTIONS(5639),
    [anon_sym_CARET] = ACTIONS(5639),
    [aux_sym_binary_operator_token1] = ACTIONS(5641),
    [anon_sym_PIPE_GT] = ACTIONS(5641),
    [anon_sym_COLON] = ACTIONS(5643),
    [anon_sym_DOLLAR] = ACTIONS(5645),
    [anon_sym_AT] = ACTIONS(5645),
    [aux_sym__hex_literal_token1] = ACTIONS(5417),
    [sym__number_literal] = ACTIONS(5419),
    [anon_sym_SQUOTE] = ACTIONS(5417),
    [anon_sym_DQUOTE] = ACTIONS(5417),
    [sym_return] = ACTIONS(5419),
    [sym_next] = ACTIONS(5419),
    [sym_break] = ACTIONS(5419),
    [sym_true] = ACTIONS(5419),
    [sym_false] = ACTIONS(5419),
    [sym_null] = ACTIONS(5419),
    [sym_inf] = ACTIONS(5419),
    [sym_nan] = ACTIONS(5419),
    [anon_sym_NA] = ACTIONS(5419),
    [anon_sym_NA_integer_] = ACTIONS(5419),
    [anon_sym_NA_real_] = ACTIONS(5419),
    [anon_sym_NA_complex_] = ACTIONS(5419),
    [anon_sym_NA_character_] = ACTIONS(5419),
    [sym_dots] = ACTIONS(5419),
    [sym_dot_dot_i] = ACTIONS(5417),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5417),
    [sym__semicolon] = ACTIONS(5417),
    [sym__raw_string_literal] = ACTIONS(5417),
    [sym__external_else] = ACTIONS(5417),
    [sym__external_open_parenthesis] = ACTIONS(5649),
    [sym__external_close_parenthesis] = ACTIONS(5417),
    [sym__external_open_brace] = ACTIONS(5417),
    [sym__external_open_bracket] = ACTIONS(5651),
    [sym__external_open_bracket2] = ACTIONS(5653),
  },
  [1023] = {
    [sym_call_arguments] = STATE(2678),
    [sym_subset_arguments] = STATE(2679),
    [sym_subset2_arguments] = STATE(2683),
    [sym__open_parenthesis] = STATE(1443),
    [sym__open_bracket] = STATE(1442),
    [sym__open_bracket2] = STATE(1425),
    [ts_builtin_sym_end] = ACTIONS(5421),
    [sym_identifier] = ACTIONS(5423),
    [anon_sym_BSLASH] = ACTIONS(5421),
    [anon_sym_function] = ACTIONS(5423),
    [anon_sym_EQ] = ACTIONS(5609),
    [anon_sym_if] = ACTIONS(5423),
    [anon_sym_for] = ACTIONS(5423),
    [anon_sym_while] = ACTIONS(5423),
    [anon_sym_repeat] = ACTIONS(5423),
    [anon_sym_QMARK] = ACTIONS(5421),
    [anon_sym_TILDE] = ACTIONS(5611),
    [anon_sym_BANG] = ACTIONS(5423),
    [anon_sym_PLUS] = ACTIONS(5613),
    [anon_sym_DASH] = ACTIONS(5615),
    [anon_sym_LT_DASH] = ACTIONS(5617),
    [anon_sym_LT_LT_DASH] = ACTIONS(5617),
    [anon_sym_COLON_EQ] = ACTIONS(5617),
    [anon_sym_DASH_GT] = ACTIONS(5619),
    [anon_sym_DASH_GT_GT] = ACTIONS(5621),
    [anon_sym_PIPE] = ACTIONS(5623),
    [anon_sym_AMP] = ACTIONS(5625),
    [anon_sym_PIPE_PIPE] = ACTIONS(5627),
    [anon_sym_AMP_AMP] = ACTIONS(5629),
    [anon_sym_LT] = ACTIONS(5631),
    [anon_sym_LT_EQ] = ACTIONS(5633),
    [anon_sym_GT] = ACTIONS(5631),
    [anon_sym_GT_EQ] = ACTIONS(5633),
    [anon_sym_EQ_EQ] = ACTIONS(5633),
    [anon_sym_BANG_EQ] = ACTIONS(5633),
    [anon_sym_STAR] = ACTIONS(5635),
    [anon_sym_SLASH] = ACTIONS(5637),
    [anon_sym_STAR_STAR] = ACTIONS(5639),
    [anon_sym_CARET] = ACTIONS(5639),
    [aux_sym_binary_operator_token1] = ACTIONS(5641),
    [anon_sym_PIPE_GT] = ACTIONS(5641),
    [anon_sym_COLON] = ACTIONS(5643),
    [anon_sym_DOLLAR] = ACTIONS(5645),
    [anon_sym_AT] = ACTIONS(5645),
    [aux_sym__hex_literal_token1] = ACTIONS(5421),
    [sym__number_literal] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5421),
    [anon_sym_DQUOTE] = ACTIONS(5421),
    [sym_return] = ACTIONS(5423),
    [sym_next] = ACTIONS(5423),
    [sym_break] = ACTIONS(5423),
    [sym_true] = ACTIONS(5423),
    [sym_false] = ACTIONS(5423),
    [sym_null] = ACTIONS(5423),
    [sym_inf] = ACTIONS(5423),
    [sym_nan] = ACTIONS(5423),
    [anon_sym_NA] = ACTIONS(5423),
    [anon_sym_NA_integer_] = ACTIONS(5423),
    [anon_sym_NA_real_] = ACTIONS(5423),
    [anon_sym_NA_complex_] = ACTIONS(5423),
    [anon_sym_NA_character_] = ACTIONS(5423),
    [sym_dots] = ACTIONS(5423),
    [sym_dot_dot_i] = ACTIONS(5421),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5421),
    [sym__semicolon] = ACTIONS(5421),
    [sym__raw_string_literal] = ACTIONS(5421),
    [sym__external_else] = ACTIONS(5421),
    [sym__external_open_parenthesis] = ACTIONS(5649),
    [sym__external_close_parenthesis] = ACTIONS(5421),
    [sym__external_open_brace] = ACTIONS(5421),
    [sym__external_open_bracket] = ACTIONS(5651),
    [sym__external_open_bracket2] = ACTIONS(5653),
  },
  [1024] = {
    [sym_call_arguments] = STATE(2678),
    [sym_subset_arguments] = STATE(2679),
    [sym_subset2_arguments] = STATE(2683),
    [sym__open_parenthesis] = STATE(1443),
    [sym__open_bracket] = STATE(1442),
    [sym__open_bracket2] = STATE(1425),
    [ts_builtin_sym_end] = ACTIONS(5425),
    [sym_identifier] = ACTIONS(5427),
    [anon_sym_BSLASH] = ACTIONS(5425),
    [anon_sym_function] = ACTIONS(5427),
    [anon_sym_EQ] = ACTIONS(5609),
    [anon_sym_if] = ACTIONS(5427),
    [anon_sym_for] = ACTIONS(5427),
    [anon_sym_while] = ACTIONS(5427),
    [anon_sym_repeat] = ACTIONS(5427),
    [anon_sym_QMARK] = ACTIONS(5425),
    [anon_sym_TILDE] = ACTIONS(5611),
    [anon_sym_BANG] = ACTIONS(5427),
    [anon_sym_PLUS] = ACTIONS(5613),
    [anon_sym_DASH] = ACTIONS(5615),
    [anon_sym_LT_DASH] = ACTIONS(5617),
    [anon_sym_LT_LT_DASH] = ACTIONS(5617),
    [anon_sym_COLON_EQ] = ACTIONS(5617),
    [anon_sym_DASH_GT] = ACTIONS(5619),
    [anon_sym_DASH_GT_GT] = ACTIONS(5621),
    [anon_sym_PIPE] = ACTIONS(5623),
    [anon_sym_AMP] = ACTIONS(5625),
    [anon_sym_PIPE_PIPE] = ACTIONS(5627),
    [anon_sym_AMP_AMP] = ACTIONS(5629),
    [anon_sym_LT] = ACTIONS(5631),
    [anon_sym_LT_EQ] = ACTIONS(5633),
    [anon_sym_GT] = ACTIONS(5631),
    [anon_sym_GT_EQ] = ACTIONS(5633),
    [anon_sym_EQ_EQ] = ACTIONS(5633),
    [anon_sym_BANG_EQ] = ACTIONS(5633),
    [anon_sym_STAR] = ACTIONS(5635),
    [anon_sym_SLASH] = ACTIONS(5637),
    [anon_sym_STAR_STAR] = ACTIONS(5639),
    [anon_sym_CARET] = ACTIONS(5639),
    [aux_sym_binary_operator_token1] = ACTIONS(5641),
    [anon_sym_PIPE_GT] = ACTIONS(5641),
    [anon_sym_COLON] = ACTIONS(5643),
    [anon_sym_DOLLAR] = ACTIONS(5645),
    [anon_sym_AT] = ACTIONS(5645),
    [aux_sym__hex_literal_token1] = ACTIONS(5425),
    [sym__number_literal] = ACTIONS(5427),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_DQUOTE] = ACTIONS(5425),
    [sym_return] = ACTIONS(5427),
    [sym_next] = ACTIONS(5427),
    [sym_break] = ACTIONS(5427),
    [sym_true] = ACTIONS(5427),
    [sym_false] = ACTIONS(5427),
    [sym_null] = ACTIONS(5427),
    [sym_inf] = ACTIONS(5427),
    [sym_nan] = ACTIONS(5427),
    [anon_sym_NA] = ACTIONS(5427),
    [anon_sym_NA_integer_] = ACTIONS(5427),
    [anon_sym_NA_real_] = ACTIONS(5427),
    [anon_sym_NA_complex_] = ACTIONS(5427),
    [anon_sym_NA_character_] = ACTIONS(5427),
    [sym_dots] = ACTIONS(5427),
    [sym_dot_dot_i] = ACTIONS(5425),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5425),
    [sym__semicolon] = ACTIONS(5425),
    [sym__raw_string_literal] = ACTIONS(5425),
    [sym__external_else] = ACTIONS(5425),
    [sym__external_open_parenthesis] = ACTIONS(5649),
    [sym__external_close_parenthesis] = ACTIONS(5425),
    [sym__external_open_brace] = ACTIONS(5425),
    [sym__external_open_bracket] = ACTIONS(5651),
    [sym__external_open_bracket2] = ACTIONS(5653),
  },
  [1025] = {
    [sym_call_arguments] = STATE(2678),
    [sym_subset_arguments] = STATE(2679),
    [sym_subset2_arguments] = STATE(2683),
    [sym__open_parenthesis] = STATE(1443),
    [sym__open_bracket] = STATE(1442),
    [sym__open_bracket2] = STATE(1425),
    [ts_builtin_sym_end] = ACTIONS(5429),
    [sym_identifier] = ACTIONS(5431),
    [anon_sym_BSLASH] = ACTIONS(5429),
    [anon_sym_function] = ACTIONS(5431),
    [anon_sym_EQ] = ACTIONS(5609),
    [anon_sym_if] = ACTIONS(5431),
    [anon_sym_for] = ACTIONS(5431),
    [anon_sym_while] = ACTIONS(5431),
    [anon_sym_repeat] = ACTIONS(5431),
    [anon_sym_QMARK] = ACTIONS(5429),
    [anon_sym_TILDE] = ACTIONS(5611),
    [anon_sym_BANG] = ACTIONS(5431),
    [anon_sym_PLUS] = ACTIONS(5613),
    [anon_sym_DASH] = ACTIONS(5615),
    [anon_sym_LT_DASH] = ACTIONS(5617),
    [anon_sym_LT_LT_DASH] = ACTIONS(5617),
    [anon_sym_COLON_EQ] = ACTIONS(5617),
    [anon_sym_DASH_GT] = ACTIONS(5619),
    [anon_sym_DASH_GT_GT] = ACTIONS(5621),
    [anon_sym_PIPE] = ACTIONS(5623),
    [anon_sym_AMP] = ACTIONS(5625),
    [anon_sym_PIPE_PIPE] = ACTIONS(5627),
    [anon_sym_AMP_AMP] = ACTIONS(5629),
    [anon_sym_LT] = ACTIONS(5631),
    [anon_sym_LT_EQ] = ACTIONS(5633),
    [anon_sym_GT] = ACTIONS(5631),
    [anon_sym_GT_EQ] = ACTIONS(5633),
    [anon_sym_EQ_EQ] = ACTIONS(5633),
    [anon_sym_BANG_EQ] = ACTIONS(5633),
    [anon_sym_STAR] = ACTIONS(5635),
    [anon_sym_SLASH] = ACTIONS(5637),
    [anon_sym_STAR_STAR] = ACTIONS(5639),
    [anon_sym_CARET] = ACTIONS(5639),
    [aux_sym_binary_operator_token1] = ACTIONS(5641),
    [anon_sym_PIPE_GT] = ACTIONS(5641),
    [anon_sym_COLON] = ACTIONS(5643),
    [anon_sym_DOLLAR] = ACTIONS(5645),
    [anon_sym_AT] = ACTIONS(5645),
    [aux_sym__hex_literal_token1] = ACTIONS(5429),
    [sym__number_literal] = ACTIONS(5431),
    [anon_sym_SQUOTE] = ACTIONS(5429),
    [anon_sym_DQUOTE] = ACTIONS(5429),
    [sym_return] = ACTIONS(5431),
    [sym_next] = ACTIONS(5431),
    [sym_break] = ACTIONS(5431),
    [sym_true] = ACTIONS(5431),
    [sym_false] = ACTIONS(5431),
    [sym_null] = ACTIONS(5431),
    [sym_inf] = ACTIONS(5431),
    [sym_nan] = ACTIONS(5431),
    [anon_sym_NA] = ACTIONS(5431),
    [anon_sym_NA_integer_] = ACTIONS(5431),
    [anon_sym_NA_real_] = ACTIONS(5431),
    [anon_sym_NA_complex_] = ACTIONS(5431),
    [anon_sym_NA_character_] = ACTIONS(5431),
    [sym_dots] = ACTIONS(5431),
    [sym_dot_dot_i] = ACTIONS(5429),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5429),
    [sym__semicolon] = ACTIONS(5429),
    [sym__raw_string_literal] = ACTIONS(5429),
    [sym__external_else] = ACTIONS(5429),
    [sym__external_open_parenthesis] = ACTIONS(5649),
    [sym__external_close_parenthesis] = ACTIONS(5429),
    [sym__external_open_brace] = ACTIONS(5429),
    [sym__external_open_bracket] = ACTIONS(5651),
    [sym__external_open_bracket2] = ACTIONS(5653),
  },
  [1026] = {
    [sym_call_arguments] = STATE(2678),
    [sym_subset_arguments] = STATE(2679),
    [sym_subset2_arguments] = STATE(2683),
    [sym__open_parenthesis] = STATE(1443),
    [sym__open_bracket] = STATE(1442),
    [sym__open_bracket2] = STATE(1425),
    [ts_builtin_sym_end] = ACTIONS(5433),
    [sym_identifier] = ACTIONS(5435),
    [anon_sym_BSLASH] = ACTIONS(5433),
    [anon_sym_function] = ACTIONS(5435),
    [anon_sym_EQ] = ACTIONS(5609),
    [anon_sym_if] = ACTIONS(5435),
    [anon_sym_for] = ACTIONS(5435),
    [anon_sym_while] = ACTIONS(5435),
    [anon_sym_repeat] = ACTIONS(5435),
    [anon_sym_QMARK] = ACTIONS(5433),
    [anon_sym_TILDE] = ACTIONS(5611),
    [anon_sym_BANG] = ACTIONS(5435),
    [anon_sym_PLUS] = ACTIONS(5613),
    [anon_sym_DASH] = ACTIONS(5615),
    [anon_sym_LT_DASH] = ACTIONS(5617),
    [anon_sym_LT_LT_DASH] = ACTIONS(5617),
    [anon_sym_COLON_EQ] = ACTIONS(5617),
    [anon_sym_DASH_GT] = ACTIONS(5619),
    [anon_sym_DASH_GT_GT] = ACTIONS(5621),
    [anon_sym_PIPE] = ACTIONS(5623),
    [anon_sym_AMP] = ACTIONS(5625),
    [anon_sym_PIPE_PIPE] = ACTIONS(5627),
    [anon_sym_AMP_AMP] = ACTIONS(5629),
    [anon_sym_LT] = ACTIONS(5631),
    [anon_sym_LT_EQ] = ACTIONS(5633),
    [anon_sym_GT] = ACTIONS(5631),
    [anon_sym_GT_EQ] = ACTIONS(5633),
    [anon_sym_EQ_EQ] = ACTIONS(5633),
    [anon_sym_BANG_EQ] = ACTIONS(5633),
    [anon_sym_STAR] = ACTIONS(5635),
    [anon_sym_SLASH] = ACTIONS(5637),
    [anon_sym_STAR_STAR] = ACTIONS(5639),
    [anon_sym_CARET] = ACTIONS(5639),
    [aux_sym_binary_operator_token1] = ACTIONS(5641),
    [anon_sym_PIPE_GT] = ACTIONS(5641),
    [anon_sym_COLON] = ACTIONS(5643),
    [anon_sym_DOLLAR] = ACTIONS(5645),
    [anon_sym_AT] = ACTIONS(5645),
    [aux_sym__hex_literal_token1] = ACTIONS(5433),
    [sym__number_literal] = ACTIONS(5435),
    [anon_sym_SQUOTE] = ACTIONS(5433),
    [anon_sym_DQUOTE] = ACTIONS(5433),
    [sym_return] = ACTIONS(5435),
    [sym_next] = ACTIONS(5435),
    [sym_break] = ACTIONS(5435),
    [sym_true] = ACTIONS(5435),
    [sym_false] = ACTIONS(5435),
    [sym_null] = ACTIONS(5435),
    [sym_inf] = ACTIONS(5435),
    [sym_nan] = ACTIONS(5435),
    [anon_sym_NA] = ACTIONS(5435),
    [anon_sym_NA_integer_] = ACTIONS(5435),
    [anon_sym_NA_real_] = ACTIONS(5435),
    [anon_sym_NA_complex_] = ACTIONS(5435),
    [anon_sym_NA_character_] = ACTIONS(5435),
    [sym_dots] = ACTIONS(5435),
    [sym_dot_dot_i] = ACTIONS(5433),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5433),
    [sym__semicolon] = ACTIONS(5433),
    [sym__raw_string_literal] = ACTIONS(5433),
    [sym__external_else] = ACTIONS(5433),
    [sym__external_open_parenthesis] = ACTIONS(5649),
    [sym__external_close_parenthesis] = ACTIONS(5433),
    [sym__external_open_brace] = ACTIONS(5433),
    [sym__external_open_bracket] = ACTIONS(5651),
    [sym__external_open_bracket2] = ACTIONS(5653),
  },
  [1027] = {
    [sym_call_arguments] = STATE(2678),
    [sym_subset_arguments] = STATE(2679),
    [sym_subset2_arguments] = STATE(2683),
    [sym__open_parenthesis] = STATE(1443),
    [sym__open_bracket] = STATE(1442),
    [sym__open_bracket2] = STATE(1425),
    [ts_builtin_sym_end] = ACTIONS(5437),
    [sym_identifier] = ACTIONS(5439),
    [anon_sym_BSLASH] = ACTIONS(5437),
    [anon_sym_function] = ACTIONS(5439),
    [anon_sym_EQ] = ACTIONS(5609),
    [anon_sym_if] = ACTIONS(5439),
    [anon_sym_for] = ACTIONS(5439),
    [anon_sym_while] = ACTIONS(5439),
    [anon_sym_repeat] = ACTIONS(5439),
    [anon_sym_QMARK] = ACTIONS(5437),
    [anon_sym_TILDE] = ACTIONS(5611),
    [anon_sym_BANG] = ACTIONS(5439),
    [anon_sym_PLUS] = ACTIONS(5613),
    [anon_sym_DASH] = ACTIONS(5615),
    [anon_sym_LT_DASH] = ACTIONS(5617),
    [anon_sym_LT_LT_DASH] = ACTIONS(5617),
    [anon_sym_COLON_EQ] = ACTIONS(5617),
    [anon_sym_DASH_GT] = ACTIONS(5619),
    [anon_sym_DASH_GT_GT] = ACTIONS(5621),
    [anon_sym_PIPE] = ACTIONS(5623),
    [anon_sym_AMP] = ACTIONS(5625),
    [anon_sym_PIPE_PIPE] = ACTIONS(5627),
    [anon_sym_AMP_AMP] = ACTIONS(5629),
    [anon_sym_LT] = ACTIONS(5631),
    [anon_sym_LT_EQ] = ACTIONS(5633),
    [anon_sym_GT] = ACTIONS(5631),
    [anon_sym_GT_EQ] = ACTIONS(5633),
    [anon_sym_EQ_EQ] = ACTIONS(5633),
    [anon_sym_BANG_EQ] = ACTIONS(5633),
    [anon_sym_STAR] = ACTIONS(5635),
    [anon_sym_SLASH] = ACTIONS(5637),
    [anon_sym_STAR_STAR] = ACTIONS(5639),
    [anon_sym_CARET] = ACTIONS(5639),
    [aux_sym_binary_operator_token1] = ACTIONS(5641),
    [anon_sym_PIPE_GT] = ACTIONS(5641),
    [anon_sym_COLON] = ACTIONS(5643),
    [anon_sym_DOLLAR] = ACTIONS(5645),
    [anon_sym_AT] = ACTIONS(5645),
    [aux_sym__hex_literal_token1] = ACTIONS(5437),
    [sym__number_literal] = ACTIONS(5439),
    [anon_sym_SQUOTE] = ACTIONS(5437),
    [anon_sym_DQUOTE] = ACTIONS(5437),
    [sym_return] = ACTIONS(5439),
    [sym_next] = ACTIONS(5439),
    [sym_break] = ACTIONS(5439),
    [sym_true] = ACTIONS(5439),
    [sym_false] = ACTIONS(5439),
    [sym_null] = ACTIONS(5439),
    [sym_inf] = ACTIONS(5439),
    [sym_nan] = ACTIONS(5439),
    [anon_sym_NA] = ACTIONS(5439),
    [anon_sym_NA_integer_] = ACTIONS(5439),
    [anon_sym_NA_real_] = ACTIONS(5439),
    [anon_sym_NA_complex_] = ACTIONS(5439),
    [anon_sym_NA_character_] = ACTIONS(5439),
    [sym_dots] = ACTIONS(5439),
    [sym_dot_dot_i] = ACTIONS(5437),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5437),
    [sym__semicolon] = ACTIONS(5437),
    [sym__raw_string_literal] = ACTIONS(5437),
    [sym__external_else] = ACTIONS(5437),
    [sym__external_open_parenthesis] = ACTIONS(5649),
    [sym__external_close_parenthesis] = ACTIONS(5437),
    [sym__external_open_brace] = ACTIONS(5437),
    [sym__external_open_bracket] = ACTIONS(5651),
    [sym__external_open_bracket2] = ACTIONS(5653),
  },
  [1028] = {
    [sym_call_arguments] = STATE(2678),
    [sym_subset_arguments] = STATE(2679),
    [sym_subset2_arguments] = STATE(2683),
    [sym__open_parenthesis] = STATE(1443),
    [sym__open_bracket] = STATE(1442),
    [sym__open_bracket2] = STATE(1425),
    [ts_builtin_sym_end] = ACTIONS(5441),
    [sym_identifier] = ACTIONS(5443),
    [anon_sym_BSLASH] = ACTIONS(5441),
    [anon_sym_function] = ACTIONS(5443),
    [anon_sym_EQ] = ACTIONS(5609),
    [anon_sym_if] = ACTIONS(5443),
    [anon_sym_for] = ACTIONS(5443),
    [anon_sym_while] = ACTIONS(5443),
    [anon_sym_repeat] = ACTIONS(5443),
    [anon_sym_QMARK] = ACTIONS(5441),
    [anon_sym_TILDE] = ACTIONS(5611),
    [anon_sym_BANG] = ACTIONS(5443),
    [anon_sym_PLUS] = ACTIONS(5613),
    [anon_sym_DASH] = ACTIONS(5615),
    [anon_sym_LT_DASH] = ACTIONS(5617),
    [anon_sym_LT_LT_DASH] = ACTIONS(5617),
    [anon_sym_COLON_EQ] = ACTIONS(5617),
    [anon_sym_DASH_GT] = ACTIONS(5619),
    [anon_sym_DASH_GT_GT] = ACTIONS(5621),
    [anon_sym_PIPE] = ACTIONS(5623),
    [anon_sym_AMP] = ACTIONS(5625),
    [anon_sym_PIPE_PIPE] = ACTIONS(5627),
    [anon_sym_AMP_AMP] = ACTIONS(5629),
    [anon_sym_LT] = ACTIONS(5631),
    [anon_sym_LT_EQ] = ACTIONS(5633),
    [anon_sym_GT] = ACTIONS(5631),
    [anon_sym_GT_EQ] = ACTIONS(5633),
    [anon_sym_EQ_EQ] = ACTIONS(5633),
    [anon_sym_BANG_EQ] = ACTIONS(5633),
    [anon_sym_STAR] = ACTIONS(5635),
    [anon_sym_SLASH] = ACTIONS(5637),
    [anon_sym_STAR_STAR] = ACTIONS(5639),
    [anon_sym_CARET] = ACTIONS(5639),
    [aux_sym_binary_operator_token1] = ACTIONS(5641),
    [anon_sym_PIPE_GT] = ACTIONS(5641),
    [anon_sym_COLON] = ACTIONS(5643),
    [anon_sym_DOLLAR] = ACTIONS(5645),
    [anon_sym_AT] = ACTIONS(5645),
    [aux_sym__hex_literal_token1] = ACTIONS(5441),
    [sym__number_literal] = ACTIONS(5443),
    [anon_sym_SQUOTE] = ACTIONS(5441),
    [anon_sym_DQUOTE] = ACTIONS(5441),
    [sym_return] = ACTIONS(5443),
    [sym_next] = ACTIONS(5443),
    [sym_break] = ACTIONS(5443),
    [sym_true] = ACTIONS(5443),
    [sym_false] = ACTIONS(5443),
    [sym_null] = ACTIONS(5443),
    [sym_inf] = ACTIONS(5443),
    [sym_nan] = ACTIONS(5443),
    [anon_sym_NA] = ACTIONS(5443),
    [anon_sym_NA_integer_] = ACTIONS(5443),
    [anon_sym_NA_real_] = ACTIONS(5443),
    [anon_sym_NA_complex_] = ACTIONS(5443),
    [anon_sym_NA_character_] = ACTIONS(5443),
    [sym_dots] = ACTIONS(5443),
    [sym_dot_dot_i] = ACTIONS(5441),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5441),
    [sym__semicolon] = ACTIONS(5441),
    [sym__raw_string_literal] = ACTIONS(5441),
    [sym__external_else] = ACTIONS(5441),
    [sym__external_open_parenthesis] = ACTIONS(5649),
    [sym__external_close_parenthesis] = ACTIONS(5441),
    [sym__external_open_brace] = ACTIONS(5441),
    [sym__external_open_bracket] = ACTIONS(5651),
    [sym__external_open_bracket2] = ACTIONS(5653),
  },
  [1029] = {
    [sym_call_arguments] = STATE(2678),
    [sym_subset_arguments] = STATE(2679),
    [sym_subset2_arguments] = STATE(2683),
    [sym__open_parenthesis] = STATE(1443),
    [sym__open_bracket] = STATE(1442),
    [sym__open_bracket2] = STATE(1425),
    [ts_builtin_sym_end] = ACTIONS(5445),
    [sym_identifier] = ACTIONS(5447),
    [anon_sym_BSLASH] = ACTIONS(5445),
    [anon_sym_function] = ACTIONS(5447),
    [anon_sym_EQ] = ACTIONS(5609),
    [anon_sym_if] = ACTIONS(5447),
    [anon_sym_for] = ACTIONS(5447),
    [anon_sym_while] = ACTIONS(5447),
    [anon_sym_repeat] = ACTIONS(5447),
    [anon_sym_QMARK] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(5611),
    [anon_sym_BANG] = ACTIONS(5447),
    [anon_sym_PLUS] = ACTIONS(5613),
    [anon_sym_DASH] = ACTIONS(5615),
    [anon_sym_LT_DASH] = ACTIONS(5617),
    [anon_sym_LT_LT_DASH] = ACTIONS(5617),
    [anon_sym_COLON_EQ] = ACTIONS(5617),
    [anon_sym_DASH_GT] = ACTIONS(5619),
    [anon_sym_DASH_GT_GT] = ACTIONS(5621),
    [anon_sym_PIPE] = ACTIONS(5623),
    [anon_sym_AMP] = ACTIONS(5625),
    [anon_sym_PIPE_PIPE] = ACTIONS(5627),
    [anon_sym_AMP_AMP] = ACTIONS(5629),
    [anon_sym_LT] = ACTIONS(5631),
    [anon_sym_LT_EQ] = ACTIONS(5633),
    [anon_sym_GT] = ACTIONS(5631),
    [anon_sym_GT_EQ] = ACTIONS(5633),
    [anon_sym_EQ_EQ] = ACTIONS(5633),
    [anon_sym_BANG_EQ] = ACTIONS(5633),
    [anon_sym_STAR] = ACTIONS(5635),
    [anon_sym_SLASH] = ACTIONS(5637),
    [anon_sym_STAR_STAR] = ACTIONS(5639),
    [anon_sym_CARET] = ACTIONS(5639),
    [aux_sym_binary_operator_token1] = ACTIONS(5641),
    [anon_sym_PIPE_GT] = ACTIONS(5641),
    [anon_sym_COLON] = ACTIONS(5643),
    [anon_sym_DOLLAR] = ACTIONS(5645),
    [anon_sym_AT] = ACTIONS(5645),
    [aux_sym__hex_literal_token1] = ACTIONS(5445),
    [sym__number_literal] = ACTIONS(5447),
    [anon_sym_SQUOTE] = ACTIONS(5445),
    [anon_sym_DQUOTE] = ACTIONS(5445),
    [sym_return] = ACTIONS(5447),
    [sym_next] = ACTIONS(5447),
    [sym_break] = ACTIONS(5447),
    [sym_true] = ACTIONS(5447),
    [sym_false] = ACTIONS(5447),
    [sym_null] = ACTIONS(5447),
    [sym_inf] = ACTIONS(5447),
    [sym_nan] = ACTIONS(5447),
    [anon_sym_NA] = ACTIONS(5447),
    [anon_sym_NA_integer_] = ACTIONS(5447),
    [anon_sym_NA_real_] = ACTIONS(5447),
    [anon_sym_NA_complex_] = ACTIONS(5447),
    [anon_sym_NA_character_] = ACTIONS(5447),
    [sym_dots] = ACTIONS(5447),
    [sym_dot_dot_i] = ACTIONS(5445),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5445),
    [sym__semicolon] = ACTIONS(5445),
    [sym__raw_string_literal] = ACTIONS(5445),
    [sym__external_else] = ACTIONS(5445),
    [sym__external_open_parenthesis] = ACTIONS(5649),
    [sym__external_close_parenthesis] = ACTIONS(5445),
    [sym__external_open_brace] = ACTIONS(5445),
    [sym__external_open_bracket] = ACTIONS(5651),
    [sym__external_open_bracket2] = ACTIONS(5653),
  },
  [1030] = {
    [sym_call_arguments] = STATE(2923),
    [sym_subset_arguments] = STATE(2922),
    [sym_subset2_arguments] = STATE(2906),
    [sym__else] = STATE(4219),
    [sym__open_parenthesis] = STATE(1528),
    [sym__open_bracket] = STATE(1525),
    [sym__open_bracket2] = STATE(1519),
    [ts_builtin_sym_end] = ACTIONS(5067),
    [sym_identifier] = ACTIONS(5065),
    [anon_sym_BSLASH] = ACTIONS(5067),
    [anon_sym_function] = ACTIONS(5065),
    [anon_sym_EQ] = ACTIONS(5947),
    [anon_sym_if] = ACTIONS(5065),
    [anon_sym_for] = ACTIONS(5065),
    [anon_sym_while] = ACTIONS(5065),
    [anon_sym_repeat] = ACTIONS(5065),
    [anon_sym_QMARK] = ACTIONS(5067),
    [anon_sym_TILDE] = ACTIONS(5949),
    [anon_sym_BANG] = ACTIONS(5065),
    [anon_sym_PLUS] = ACTIONS(5951),
    [anon_sym_DASH] = ACTIONS(5953),
    [anon_sym_LT_DASH] = ACTIONS(5955),
    [anon_sym_LT_LT_DASH] = ACTIONS(5955),
    [anon_sym_COLON_EQ] = ACTIONS(5955),
    [anon_sym_DASH_GT] = ACTIONS(5957),
    [anon_sym_DASH_GT_GT] = ACTIONS(5959),
    [anon_sym_PIPE] = ACTIONS(5961),
    [anon_sym_AMP] = ACTIONS(5963),
    [anon_sym_PIPE_PIPE] = ACTIONS(5965),
    [anon_sym_AMP_AMP] = ACTIONS(5967),
    [anon_sym_LT] = ACTIONS(5969),
    [anon_sym_LT_EQ] = ACTIONS(5971),
    [anon_sym_GT] = ACTIONS(5969),
    [anon_sym_GT_EQ] = ACTIONS(5971),
    [anon_sym_EQ_EQ] = ACTIONS(5971),
    [anon_sym_BANG_EQ] = ACTIONS(5971),
    [anon_sym_STAR] = ACTIONS(5973),
    [anon_sym_SLASH] = ACTIONS(5975),
    [anon_sym_STAR_STAR] = ACTIONS(5977),
    [anon_sym_CARET] = ACTIONS(5977),
    [aux_sym_binary_operator_token1] = ACTIONS(5979),
    [anon_sym_PIPE_GT] = ACTIONS(5979),
    [anon_sym_COLON] = ACTIONS(5981),
    [anon_sym_DOLLAR] = ACTIONS(5983),
    [anon_sym_AT] = ACTIONS(5983),
    [aux_sym__hex_literal_token1] = ACTIONS(5067),
    [sym__number_literal] = ACTIONS(5065),
    [anon_sym_SQUOTE] = ACTIONS(5067),
    [anon_sym_DQUOTE] = ACTIONS(5067),
    [sym_return] = ACTIONS(5065),
    [sym_next] = ACTIONS(5065),
    [sym_break] = ACTIONS(5065),
    [sym_true] = ACTIONS(5065),
    [sym_false] = ACTIONS(5065),
    [sym_null] = ACTIONS(5065),
    [sym_inf] = ACTIONS(5065),
    [sym_nan] = ACTIONS(5065),
    [anon_sym_NA] = ACTIONS(5065),
    [anon_sym_NA_integer_] = ACTIONS(5065),
    [anon_sym_NA_real_] = ACTIONS(5065),
    [anon_sym_NA_complex_] = ACTIONS(5065),
    [anon_sym_NA_character_] = ACTIONS(5065),
    [sym_dots] = ACTIONS(5065),
    [sym_dot_dot_i] = ACTIONS(5067),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5067),
    [sym__semicolon] = ACTIONS(5067),
    [sym__raw_string_literal] = ACTIONS(5067),
    [sym__external_else] = ACTIONS(6051),
    [sym__external_open_parenthesis] = ACTIONS(5987),
    [sym__external_open_brace] = ACTIONS(5067),
    [sym__external_open_bracket] = ACTIONS(5989),
    [sym__external_open_bracket2] = ACTIONS(5991),
  },
  [1031] = {
    [sym_call_arguments] = STATE(2678),
    [sym_subset_arguments] = STATE(2679),
    [sym_subset2_arguments] = STATE(2683),
    [sym__open_parenthesis] = STATE(1443),
    [sym__open_bracket] = STATE(1442),
    [sym__open_bracket2] = STATE(1425),
    [ts_builtin_sym_end] = ACTIONS(5449),
    [sym_identifier] = ACTIONS(5451),
    [anon_sym_BSLASH] = ACTIONS(5449),
    [anon_sym_function] = ACTIONS(5451),
    [anon_sym_EQ] = ACTIONS(5609),
    [anon_sym_if] = ACTIONS(5451),
    [anon_sym_for] = ACTIONS(5451),
    [anon_sym_while] = ACTIONS(5451),
    [anon_sym_repeat] = ACTIONS(5451),
    [anon_sym_QMARK] = ACTIONS(5449),
    [anon_sym_TILDE] = ACTIONS(5611),
    [anon_sym_BANG] = ACTIONS(5451),
    [anon_sym_PLUS] = ACTIONS(5613),
    [anon_sym_DASH] = ACTIONS(5615),
    [anon_sym_LT_DASH] = ACTIONS(5617),
    [anon_sym_LT_LT_DASH] = ACTIONS(5617),
    [anon_sym_COLON_EQ] = ACTIONS(5617),
    [anon_sym_DASH_GT] = ACTIONS(5619),
    [anon_sym_DASH_GT_GT] = ACTIONS(5621),
    [anon_sym_PIPE] = ACTIONS(5623),
    [anon_sym_AMP] = ACTIONS(5625),
    [anon_sym_PIPE_PIPE] = ACTIONS(5627),
    [anon_sym_AMP_AMP] = ACTIONS(5629),
    [anon_sym_LT] = ACTIONS(5631),
    [anon_sym_LT_EQ] = ACTIONS(5633),
    [anon_sym_GT] = ACTIONS(5631),
    [anon_sym_GT_EQ] = ACTIONS(5633),
    [anon_sym_EQ_EQ] = ACTIONS(5633),
    [anon_sym_BANG_EQ] = ACTIONS(5633),
    [anon_sym_STAR] = ACTIONS(5635),
    [anon_sym_SLASH] = ACTIONS(5637),
    [anon_sym_STAR_STAR] = ACTIONS(5639),
    [anon_sym_CARET] = ACTIONS(5639),
    [aux_sym_binary_operator_token1] = ACTIONS(5641),
    [anon_sym_PIPE_GT] = ACTIONS(5641),
    [anon_sym_COLON] = ACTIONS(5643),
    [anon_sym_DOLLAR] = ACTIONS(5645),
    [anon_sym_AT] = ACTIONS(5645),
    [aux_sym__hex_literal_token1] = ACTIONS(5449),
    [sym__number_literal] = ACTIONS(5451),
    [anon_sym_SQUOTE] = ACTIONS(5449),
    [anon_sym_DQUOTE] = ACTIONS(5449),
    [sym_return] = ACTIONS(5451),
    [sym_next] = ACTIONS(5451),
    [sym_break] = ACTIONS(5451),
    [sym_true] = ACTIONS(5451),
    [sym_false] = ACTIONS(5451),
    [sym_null] = ACTIONS(5451),
    [sym_inf] = ACTIONS(5451),
    [sym_nan] = ACTIONS(5451),
    [anon_sym_NA] = ACTIONS(5451),
    [anon_sym_NA_integer_] = ACTIONS(5451),
    [anon_sym_NA_real_] = ACTIONS(5451),
    [anon_sym_NA_complex_] = ACTIONS(5451),
    [anon_sym_NA_character_] = ACTIONS(5451),
    [sym_dots] = ACTIONS(5451),
    [sym_dot_dot_i] = ACTIONS(5449),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5449),
    [sym__semicolon] = ACTIONS(5449),
    [sym__raw_string_literal] = ACTIONS(5449),
    [sym__external_else] = ACTIONS(5449),
    [sym__external_open_parenthesis] = ACTIONS(5649),
    [sym__external_close_parenthesis] = ACTIONS(5449),
    [sym__external_open_brace] = ACTIONS(5449),
    [sym__external_open_bracket] = ACTIONS(5651),
    [sym__external_open_bracket2] = ACTIONS(5653),
  },
  [1032] = {
    [sym_call_arguments] = STATE(2678),
    [sym_subset_arguments] = STATE(2679),
    [sym_subset2_arguments] = STATE(2683),
    [sym__open_parenthesis] = STATE(1443),
    [sym__open_bracket] = STATE(1442),
    [sym__open_bracket2] = STATE(1425),
    [ts_builtin_sym_end] = ACTIONS(5453),
    [sym_identifier] = ACTIONS(5455),
    [anon_sym_BSLASH] = ACTIONS(5453),
    [anon_sym_function] = ACTIONS(5455),
    [anon_sym_EQ] = ACTIONS(5609),
    [anon_sym_if] = ACTIONS(5455),
    [anon_sym_for] = ACTIONS(5455),
    [anon_sym_while] = ACTIONS(5455),
    [anon_sym_repeat] = ACTIONS(5455),
    [anon_sym_QMARK] = ACTIONS(5453),
    [anon_sym_TILDE] = ACTIONS(5611),
    [anon_sym_BANG] = ACTIONS(5455),
    [anon_sym_PLUS] = ACTIONS(5613),
    [anon_sym_DASH] = ACTIONS(5615),
    [anon_sym_LT_DASH] = ACTIONS(5617),
    [anon_sym_LT_LT_DASH] = ACTIONS(5617),
    [anon_sym_COLON_EQ] = ACTIONS(5617),
    [anon_sym_DASH_GT] = ACTIONS(5619),
    [anon_sym_DASH_GT_GT] = ACTIONS(5621),
    [anon_sym_PIPE] = ACTIONS(5623),
    [anon_sym_AMP] = ACTIONS(5625),
    [anon_sym_PIPE_PIPE] = ACTIONS(5627),
    [anon_sym_AMP_AMP] = ACTIONS(5629),
    [anon_sym_LT] = ACTIONS(5631),
    [anon_sym_LT_EQ] = ACTIONS(5633),
    [anon_sym_GT] = ACTIONS(5631),
    [anon_sym_GT_EQ] = ACTIONS(5633),
    [anon_sym_EQ_EQ] = ACTIONS(5633),
    [anon_sym_BANG_EQ] = ACTIONS(5633),
    [anon_sym_STAR] = ACTIONS(5635),
    [anon_sym_SLASH] = ACTIONS(5637),
    [anon_sym_STAR_STAR] = ACTIONS(5639),
    [anon_sym_CARET] = ACTIONS(5639),
    [aux_sym_binary_operator_token1] = ACTIONS(5641),
    [anon_sym_PIPE_GT] = ACTIONS(5641),
    [anon_sym_COLON] = ACTIONS(5643),
    [anon_sym_DOLLAR] = ACTIONS(5645),
    [anon_sym_AT] = ACTIONS(5645),
    [aux_sym__hex_literal_token1] = ACTIONS(5453),
    [sym__number_literal] = ACTIONS(5455),
    [anon_sym_SQUOTE] = ACTIONS(5453),
    [anon_sym_DQUOTE] = ACTIONS(5453),
    [sym_return] = ACTIONS(5455),
    [sym_next] = ACTIONS(5455),
    [sym_break] = ACTIONS(5455),
    [sym_true] = ACTIONS(5455),
    [sym_false] = ACTIONS(5455),
    [sym_null] = ACTIONS(5455),
    [sym_inf] = ACTIONS(5455),
    [sym_nan] = ACTIONS(5455),
    [anon_sym_NA] = ACTIONS(5455),
    [anon_sym_NA_integer_] = ACTIONS(5455),
    [anon_sym_NA_real_] = ACTIONS(5455),
    [anon_sym_NA_complex_] = ACTIONS(5455),
    [anon_sym_NA_character_] = ACTIONS(5455),
    [sym_dots] = ACTIONS(5455),
    [sym_dot_dot_i] = ACTIONS(5453),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5453),
    [sym__semicolon] = ACTIONS(5453),
    [sym__raw_string_literal] = ACTIONS(5453),
    [sym__external_else] = ACTIONS(5453),
    [sym__external_open_parenthesis] = ACTIONS(5649),
    [sym__external_close_parenthesis] = ACTIONS(5453),
    [sym__external_open_brace] = ACTIONS(5453),
    [sym__external_open_bracket] = ACTIONS(5651),
    [sym__external_open_bracket2] = ACTIONS(5653),
  },
  [1033] = {
    [sym_call_arguments] = STATE(2678),
    [sym_subset_arguments] = STATE(2679),
    [sym_subset2_arguments] = STATE(2683),
    [sym__open_parenthesis] = STATE(1443),
    [sym__open_bracket] = STATE(1442),
    [sym__open_bracket2] = STATE(1425),
    [ts_builtin_sym_end] = ACTIONS(5409),
    [sym_identifier] = ACTIONS(5411),
    [anon_sym_BSLASH] = ACTIONS(5409),
    [anon_sym_function] = ACTIONS(5411),
    [anon_sym_EQ] = ACTIONS(5609),
    [anon_sym_if] = ACTIONS(5411),
    [anon_sym_for] = ACTIONS(5411),
    [anon_sym_while] = ACTIONS(5411),
    [anon_sym_repeat] = ACTIONS(5411),
    [anon_sym_QMARK] = ACTIONS(5409),
    [anon_sym_TILDE] = ACTIONS(5611),
    [anon_sym_BANG] = ACTIONS(5411),
    [anon_sym_PLUS] = ACTIONS(5613),
    [anon_sym_DASH] = ACTIONS(5615),
    [anon_sym_LT_DASH] = ACTIONS(5617),
    [anon_sym_LT_LT_DASH] = ACTIONS(5617),
    [anon_sym_COLON_EQ] = ACTIONS(5617),
    [anon_sym_DASH_GT] = ACTIONS(5619),
    [anon_sym_DASH_GT_GT] = ACTIONS(5621),
    [anon_sym_PIPE] = ACTIONS(5623),
    [anon_sym_AMP] = ACTIONS(5625),
    [anon_sym_PIPE_PIPE] = ACTIONS(5627),
    [anon_sym_AMP_AMP] = ACTIONS(5629),
    [anon_sym_LT] = ACTIONS(5631),
    [anon_sym_LT_EQ] = ACTIONS(5633),
    [anon_sym_GT] = ACTIONS(5631),
    [anon_sym_GT_EQ] = ACTIONS(5633),
    [anon_sym_EQ_EQ] = ACTIONS(5633),
    [anon_sym_BANG_EQ] = ACTIONS(5633),
    [anon_sym_STAR] = ACTIONS(5635),
    [anon_sym_SLASH] = ACTIONS(5637),
    [anon_sym_STAR_STAR] = ACTIONS(5639),
    [anon_sym_CARET] = ACTIONS(5639),
    [aux_sym_binary_operator_token1] = ACTIONS(5641),
    [anon_sym_PIPE_GT] = ACTIONS(5641),
    [anon_sym_COLON] = ACTIONS(5643),
    [anon_sym_DOLLAR] = ACTIONS(5645),
    [anon_sym_AT] = ACTIONS(5645),
    [aux_sym__hex_literal_token1] = ACTIONS(5409),
    [sym__number_literal] = ACTIONS(5411),
    [anon_sym_SQUOTE] = ACTIONS(5409),
    [anon_sym_DQUOTE] = ACTIONS(5409),
    [sym_return] = ACTIONS(5411),
    [sym_next] = ACTIONS(5411),
    [sym_break] = ACTIONS(5411),
    [sym_true] = ACTIONS(5411),
    [sym_false] = ACTIONS(5411),
    [sym_null] = ACTIONS(5411),
    [sym_inf] = ACTIONS(5411),
    [sym_nan] = ACTIONS(5411),
    [anon_sym_NA] = ACTIONS(5411),
    [anon_sym_NA_integer_] = ACTIONS(5411),
    [anon_sym_NA_real_] = ACTIONS(5411),
    [anon_sym_NA_complex_] = ACTIONS(5411),
    [anon_sym_NA_character_] = ACTIONS(5411),
    [sym_dots] = ACTIONS(5411),
    [sym_dot_dot_i] = ACTIONS(5409),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5409),
    [sym__semicolon] = ACTIONS(5409),
    [sym__raw_string_literal] = ACTIONS(5409),
    [sym__external_else] = ACTIONS(5409),
    [sym__external_open_parenthesis] = ACTIONS(5649),
    [sym__external_close_parenthesis] = ACTIONS(5409),
    [sym__external_open_brace] = ACTIONS(5409),
    [sym__external_open_bracket] = ACTIONS(5651),
    [sym__external_open_bracket2] = ACTIONS(5653),
  },
  [1034] = {
    [sym_call_arguments] = STATE(2595),
    [sym_subset_arguments] = STATE(2594),
    [sym_subset2_arguments] = STATE(2592),
    [sym__open_parenthesis] = STATE(1423),
    [sym__open_bracket] = STATE(1419),
    [sym__open_bracket2] = STATE(1415),
    [ts_builtin_sym_end] = ACTIONS(5329),
    [sym_identifier] = ACTIONS(5331),
    [anon_sym_BSLASH] = ACTIONS(5329),
    [anon_sym_function] = ACTIONS(5331),
    [anon_sym_EQ] = ACTIONS(5727),
    [anon_sym_if] = ACTIONS(5331),
    [anon_sym_for] = ACTIONS(5331),
    [anon_sym_while] = ACTIONS(5331),
    [anon_sym_repeat] = ACTIONS(5331),
    [anon_sym_QMARK] = ACTIONS(5329),
    [anon_sym_TILDE] = ACTIONS(5729),
    [anon_sym_BANG] = ACTIONS(5331),
    [anon_sym_PLUS] = ACTIONS(5731),
    [anon_sym_DASH] = ACTIONS(5733),
    [anon_sym_LT_DASH] = ACTIONS(5735),
    [anon_sym_LT_LT_DASH] = ACTIONS(5735),
    [anon_sym_COLON_EQ] = ACTIONS(5735),
    [anon_sym_DASH_GT] = ACTIONS(5737),
    [anon_sym_DASH_GT_GT] = ACTIONS(5739),
    [anon_sym_PIPE] = ACTIONS(5741),
    [anon_sym_AMP] = ACTIONS(5743),
    [anon_sym_PIPE_PIPE] = ACTIONS(5745),
    [anon_sym_AMP_AMP] = ACTIONS(5747),
    [anon_sym_LT] = ACTIONS(5749),
    [anon_sym_LT_EQ] = ACTIONS(5751),
    [anon_sym_GT] = ACTIONS(5749),
    [anon_sym_GT_EQ] = ACTIONS(5751),
    [anon_sym_EQ_EQ] = ACTIONS(5751),
    [anon_sym_BANG_EQ] = ACTIONS(5751),
    [anon_sym_STAR] = ACTIONS(5753),
    [anon_sym_SLASH] = ACTIONS(5755),
    [anon_sym_STAR_STAR] = ACTIONS(5757),
    [anon_sym_CARET] = ACTIONS(5757),
    [aux_sym_binary_operator_token1] = ACTIONS(5759),
    [anon_sym_PIPE_GT] = ACTIONS(5759),
    [anon_sym_COLON] = ACTIONS(5761),
    [anon_sym_DOLLAR] = ACTIONS(5763),
    [anon_sym_AT] = ACTIONS(5763),
    [aux_sym__hex_literal_token1] = ACTIONS(5329),
    [sym__number_literal] = ACTIONS(5331),
    [anon_sym_SQUOTE] = ACTIONS(5329),
    [anon_sym_DQUOTE] = ACTIONS(5329),
    [sym_return] = ACTIONS(5331),
    [sym_next] = ACTIONS(5331),
    [sym_break] = ACTIONS(5331),
    [sym_true] = ACTIONS(5331),
    [sym_false] = ACTIONS(5331),
    [sym_null] = ACTIONS(5331),
    [sym_inf] = ACTIONS(5331),
    [sym_nan] = ACTIONS(5331),
    [anon_sym_NA] = ACTIONS(5331),
    [anon_sym_NA_integer_] = ACTIONS(5331),
    [anon_sym_NA_real_] = ACTIONS(5331),
    [anon_sym_NA_complex_] = ACTIONS(5331),
    [anon_sym_NA_character_] = ACTIONS(5331),
    [sym_dots] = ACTIONS(5331),
    [sym_dot_dot_i] = ACTIONS(5329),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5329),
    [sym__semicolon] = ACTIONS(5329),
    [sym__raw_string_literal] = ACTIONS(5329),
    [sym__external_else] = ACTIONS(5329),
    [sym__external_open_parenthesis] = ACTIONS(5767),
    [sym__external_open_brace] = ACTIONS(5329),
    [sym__external_close_brace] = ACTIONS(5329),
    [sym__external_open_bracket] = ACTIONS(5769),
    [sym__external_open_bracket2] = ACTIONS(5771),
  },
  [1035] = {
    [sym_call_arguments] = STATE(2595),
    [sym_subset_arguments] = STATE(2594),
    [sym_subset2_arguments] = STATE(2592),
    [sym__open_parenthesis] = STATE(1423),
    [sym__open_bracket] = STATE(1419),
    [sym__open_bracket2] = STATE(1415),
    [ts_builtin_sym_end] = ACTIONS(5333),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5727),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5729),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(5731),
    [anon_sym_DASH] = ACTIONS(5733),
    [anon_sym_LT_DASH] = ACTIONS(5735),
    [anon_sym_LT_LT_DASH] = ACTIONS(5735),
    [anon_sym_COLON_EQ] = ACTIONS(5735),
    [anon_sym_DASH_GT] = ACTIONS(5737),
    [anon_sym_DASH_GT_GT] = ACTIONS(5739),
    [anon_sym_PIPE] = ACTIONS(5741),
    [anon_sym_AMP] = ACTIONS(5743),
    [anon_sym_PIPE_PIPE] = ACTIONS(5745),
    [anon_sym_AMP_AMP] = ACTIONS(5747),
    [anon_sym_LT] = ACTIONS(5749),
    [anon_sym_LT_EQ] = ACTIONS(5751),
    [anon_sym_GT] = ACTIONS(5749),
    [anon_sym_GT_EQ] = ACTIONS(5751),
    [anon_sym_EQ_EQ] = ACTIONS(5751),
    [anon_sym_BANG_EQ] = ACTIONS(5751),
    [anon_sym_STAR] = ACTIONS(5753),
    [anon_sym_SLASH] = ACTIONS(5755),
    [anon_sym_STAR_STAR] = ACTIONS(5757),
    [anon_sym_CARET] = ACTIONS(5757),
    [aux_sym_binary_operator_token1] = ACTIONS(5759),
    [anon_sym_PIPE_GT] = ACTIONS(5759),
    [anon_sym_COLON] = ACTIONS(5761),
    [anon_sym_DOLLAR] = ACTIONS(5763),
    [anon_sym_AT] = ACTIONS(5763),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5333),
    [sym__semicolon] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_else] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(5767),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_close_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(5769),
    [sym__external_open_bracket2] = ACTIONS(5771),
  },
  [1036] = {
    [sym_call_arguments] = STATE(2595),
    [sym_subset_arguments] = STATE(2594),
    [sym_subset2_arguments] = STATE(2592),
    [sym__open_parenthesis] = STATE(1423),
    [sym__open_bracket] = STATE(1419),
    [sym__open_bracket2] = STATE(1415),
    [ts_builtin_sym_end] = ACTIONS(5333),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(5731),
    [anon_sym_DASH] = ACTIONS(5733),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5741),
    [anon_sym_AMP] = ACTIONS(5743),
    [anon_sym_PIPE_PIPE] = ACTIONS(5745),
    [anon_sym_AMP_AMP] = ACTIONS(5747),
    [anon_sym_LT] = ACTIONS(5749),
    [anon_sym_LT_EQ] = ACTIONS(5751),
    [anon_sym_GT] = ACTIONS(5749),
    [anon_sym_GT_EQ] = ACTIONS(5751),
    [anon_sym_EQ_EQ] = ACTIONS(5751),
    [anon_sym_BANG_EQ] = ACTIONS(5751),
    [anon_sym_STAR] = ACTIONS(5753),
    [anon_sym_SLASH] = ACTIONS(5755),
    [anon_sym_STAR_STAR] = ACTIONS(5757),
    [anon_sym_CARET] = ACTIONS(5757),
    [aux_sym_binary_operator_token1] = ACTIONS(5759),
    [anon_sym_PIPE_GT] = ACTIONS(5759),
    [anon_sym_COLON] = ACTIONS(5761),
    [anon_sym_DOLLAR] = ACTIONS(5763),
    [anon_sym_AT] = ACTIONS(5763),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5333),
    [sym__semicolon] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_else] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(5767),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_close_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(5769),
    [sym__external_open_bracket2] = ACTIONS(5771),
  },
  [1037] = {
    [sym_call_arguments] = STATE(2595),
    [sym_subset_arguments] = STATE(2594),
    [sym_subset2_arguments] = STATE(2592),
    [sym__open_parenthesis] = STATE(1423),
    [sym__open_bracket] = STATE(1419),
    [sym__open_bracket2] = STATE(1415),
    [ts_builtin_sym_end] = ACTIONS(5333),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(5731),
    [anon_sym_DASH] = ACTIONS(5733),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5335),
    [anon_sym_AMP] = ACTIONS(5335),
    [anon_sym_PIPE_PIPE] = ACTIONS(5333),
    [anon_sym_AMP_AMP] = ACTIONS(5333),
    [anon_sym_LT] = ACTIONS(5749),
    [anon_sym_LT_EQ] = ACTIONS(5751),
    [anon_sym_GT] = ACTIONS(5749),
    [anon_sym_GT_EQ] = ACTIONS(5751),
    [anon_sym_EQ_EQ] = ACTIONS(5751),
    [anon_sym_BANG_EQ] = ACTIONS(5751),
    [anon_sym_STAR] = ACTIONS(5753),
    [anon_sym_SLASH] = ACTIONS(5755),
    [anon_sym_STAR_STAR] = ACTIONS(5757),
    [anon_sym_CARET] = ACTIONS(5757),
    [aux_sym_binary_operator_token1] = ACTIONS(5759),
    [anon_sym_PIPE_GT] = ACTIONS(5759),
    [anon_sym_COLON] = ACTIONS(5761),
    [anon_sym_DOLLAR] = ACTIONS(5763),
    [anon_sym_AT] = ACTIONS(5763),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5333),
    [sym__semicolon] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_else] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(5767),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_close_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(5769),
    [sym__external_open_bracket2] = ACTIONS(5771),
  },
  [1038] = {
    [sym_call_arguments] = STATE(2595),
    [sym_subset_arguments] = STATE(2594),
    [sym_subset2_arguments] = STATE(2592),
    [sym__open_parenthesis] = STATE(1423),
    [sym__open_bracket] = STATE(1419),
    [sym__open_bracket2] = STATE(1415),
    [ts_builtin_sym_end] = ACTIONS(5333),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(5333),
    [anon_sym_DASH] = ACTIONS(5335),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5335),
    [anon_sym_AMP] = ACTIONS(5335),
    [anon_sym_PIPE_PIPE] = ACTIONS(5333),
    [anon_sym_AMP_AMP] = ACTIONS(5333),
    [anon_sym_LT] = ACTIONS(5335),
    [anon_sym_LT_EQ] = ACTIONS(5333),
    [anon_sym_GT] = ACTIONS(5335),
    [anon_sym_GT_EQ] = ACTIONS(5333),
    [anon_sym_EQ_EQ] = ACTIONS(5333),
    [anon_sym_BANG_EQ] = ACTIONS(5333),
    [anon_sym_STAR] = ACTIONS(5335),
    [anon_sym_SLASH] = ACTIONS(5333),
    [anon_sym_STAR_STAR] = ACTIONS(5757),
    [anon_sym_CARET] = ACTIONS(5757),
    [aux_sym_binary_operator_token1] = ACTIONS(5333),
    [anon_sym_PIPE_GT] = ACTIONS(5333),
    [anon_sym_COLON] = ACTIONS(5335),
    [anon_sym_DOLLAR] = ACTIONS(5763),
    [anon_sym_AT] = ACTIONS(5763),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5333),
    [sym__semicolon] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_else] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(5767),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_close_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(5769),
    [sym__external_open_bracket2] = ACTIONS(5771),
  },
  [1039] = {
    [sym_call_arguments] = STATE(2595),
    [sym_subset_arguments] = STATE(2594),
    [sym_subset2_arguments] = STATE(2592),
    [sym__open_parenthesis] = STATE(1423),
    [sym__open_bracket] = STATE(1419),
    [sym__open_bracket2] = STATE(1415),
    [ts_builtin_sym_end] = ACTIONS(5337),
    [sym_identifier] = ACTIONS(5339),
    [anon_sym_BSLASH] = ACTIONS(5337),
    [anon_sym_function] = ACTIONS(5339),
    [anon_sym_EQ] = ACTIONS(5727),
    [anon_sym_if] = ACTIONS(5339),
    [anon_sym_for] = ACTIONS(5339),
    [anon_sym_while] = ACTIONS(5339),
    [anon_sym_repeat] = ACTIONS(5339),
    [anon_sym_QMARK] = ACTIONS(5337),
    [anon_sym_TILDE] = ACTIONS(5729),
    [anon_sym_BANG] = ACTIONS(5339),
    [anon_sym_PLUS] = ACTIONS(5731),
    [anon_sym_DASH] = ACTIONS(5733),
    [anon_sym_LT_DASH] = ACTIONS(5735),
    [anon_sym_LT_LT_DASH] = ACTIONS(5735),
    [anon_sym_COLON_EQ] = ACTIONS(5735),
    [anon_sym_DASH_GT] = ACTIONS(5737),
    [anon_sym_DASH_GT_GT] = ACTIONS(5739),
    [anon_sym_PIPE] = ACTIONS(5741),
    [anon_sym_AMP] = ACTIONS(5743),
    [anon_sym_PIPE_PIPE] = ACTIONS(5745),
    [anon_sym_AMP_AMP] = ACTIONS(5747),
    [anon_sym_LT] = ACTIONS(5749),
    [anon_sym_LT_EQ] = ACTIONS(5751),
    [anon_sym_GT] = ACTIONS(5749),
    [anon_sym_GT_EQ] = ACTIONS(5751),
    [anon_sym_EQ_EQ] = ACTIONS(5751),
    [anon_sym_BANG_EQ] = ACTIONS(5751),
    [anon_sym_STAR] = ACTIONS(5753),
    [anon_sym_SLASH] = ACTIONS(5755),
    [anon_sym_STAR_STAR] = ACTIONS(5757),
    [anon_sym_CARET] = ACTIONS(5757),
    [aux_sym_binary_operator_token1] = ACTIONS(5759),
    [anon_sym_PIPE_GT] = ACTIONS(5759),
    [anon_sym_COLON] = ACTIONS(5761),
    [anon_sym_DOLLAR] = ACTIONS(5763),
    [anon_sym_AT] = ACTIONS(5763),
    [aux_sym__hex_literal_token1] = ACTIONS(5337),
    [sym__number_literal] = ACTIONS(5339),
    [anon_sym_SQUOTE] = ACTIONS(5337),
    [anon_sym_DQUOTE] = ACTIONS(5337),
    [sym_return] = ACTIONS(5339),
    [sym_next] = ACTIONS(5339),
    [sym_break] = ACTIONS(5339),
    [sym_true] = ACTIONS(5339),
    [sym_false] = ACTIONS(5339),
    [sym_null] = ACTIONS(5339),
    [sym_inf] = ACTIONS(5339),
    [sym_nan] = ACTIONS(5339),
    [anon_sym_NA] = ACTIONS(5339),
    [anon_sym_NA_integer_] = ACTIONS(5339),
    [anon_sym_NA_real_] = ACTIONS(5339),
    [anon_sym_NA_complex_] = ACTIONS(5339),
    [anon_sym_NA_character_] = ACTIONS(5339),
    [sym_dots] = ACTIONS(5339),
    [sym_dot_dot_i] = ACTIONS(5337),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5337),
    [sym__semicolon] = ACTIONS(5337),
    [sym__raw_string_literal] = ACTIONS(5337),
    [sym__external_else] = ACTIONS(5337),
    [sym__external_open_parenthesis] = ACTIONS(5767),
    [sym__external_open_brace] = ACTIONS(5337),
    [sym__external_close_brace] = ACTIONS(5337),
    [sym__external_open_bracket] = ACTIONS(5769),
    [sym__external_open_bracket2] = ACTIONS(5771),
  },
  [1040] = {
    [sym_call_arguments] = STATE(2595),
    [sym_subset_arguments] = STATE(2594),
    [sym_subset2_arguments] = STATE(2592),
    [sym__open_parenthesis] = STATE(1423),
    [sym__open_bracket] = STATE(1419),
    [sym__open_bracket2] = STATE(1415),
    [ts_builtin_sym_end] = ACTIONS(5341),
    [sym_identifier] = ACTIONS(5343),
    [anon_sym_BSLASH] = ACTIONS(5341),
    [anon_sym_function] = ACTIONS(5343),
    [anon_sym_EQ] = ACTIONS(5727),
    [anon_sym_if] = ACTIONS(5343),
    [anon_sym_for] = ACTIONS(5343),
    [anon_sym_while] = ACTIONS(5343),
    [anon_sym_repeat] = ACTIONS(5343),
    [anon_sym_QMARK] = ACTIONS(5341),
    [anon_sym_TILDE] = ACTIONS(5729),
    [anon_sym_BANG] = ACTIONS(5343),
    [anon_sym_PLUS] = ACTIONS(5731),
    [anon_sym_DASH] = ACTIONS(5733),
    [anon_sym_LT_DASH] = ACTIONS(5735),
    [anon_sym_LT_LT_DASH] = ACTIONS(5735),
    [anon_sym_COLON_EQ] = ACTIONS(5735),
    [anon_sym_DASH_GT] = ACTIONS(5737),
    [anon_sym_DASH_GT_GT] = ACTIONS(5739),
    [anon_sym_PIPE] = ACTIONS(5741),
    [anon_sym_AMP] = ACTIONS(5743),
    [anon_sym_PIPE_PIPE] = ACTIONS(5745),
    [anon_sym_AMP_AMP] = ACTIONS(5747),
    [anon_sym_LT] = ACTIONS(5749),
    [anon_sym_LT_EQ] = ACTIONS(5751),
    [anon_sym_GT] = ACTIONS(5749),
    [anon_sym_GT_EQ] = ACTIONS(5751),
    [anon_sym_EQ_EQ] = ACTIONS(5751),
    [anon_sym_BANG_EQ] = ACTIONS(5751),
    [anon_sym_STAR] = ACTIONS(5753),
    [anon_sym_SLASH] = ACTIONS(5755),
    [anon_sym_STAR_STAR] = ACTIONS(5757),
    [anon_sym_CARET] = ACTIONS(5757),
    [aux_sym_binary_operator_token1] = ACTIONS(5759),
    [anon_sym_PIPE_GT] = ACTIONS(5759),
    [anon_sym_COLON] = ACTIONS(5761),
    [anon_sym_DOLLAR] = ACTIONS(5763),
    [anon_sym_AT] = ACTIONS(5763),
    [aux_sym__hex_literal_token1] = ACTIONS(5341),
    [sym__number_literal] = ACTIONS(5343),
    [anon_sym_SQUOTE] = ACTIONS(5341),
    [anon_sym_DQUOTE] = ACTIONS(5341),
    [sym_return] = ACTIONS(5343),
    [sym_next] = ACTIONS(5343),
    [sym_break] = ACTIONS(5343),
    [sym_true] = ACTIONS(5343),
    [sym_false] = ACTIONS(5343),
    [sym_null] = ACTIONS(5343),
    [sym_inf] = ACTIONS(5343),
    [sym_nan] = ACTIONS(5343),
    [anon_sym_NA] = ACTIONS(5343),
    [anon_sym_NA_integer_] = ACTIONS(5343),
    [anon_sym_NA_real_] = ACTIONS(5343),
    [anon_sym_NA_complex_] = ACTIONS(5343),
    [anon_sym_NA_character_] = ACTIONS(5343),
    [sym_dots] = ACTIONS(5343),
    [sym_dot_dot_i] = ACTIONS(5341),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5341),
    [sym__semicolon] = ACTIONS(5341),
    [sym__raw_string_literal] = ACTIONS(5341),
    [sym__external_else] = ACTIONS(5341),
    [sym__external_open_parenthesis] = ACTIONS(5767),
    [sym__external_open_brace] = ACTIONS(5341),
    [sym__external_close_brace] = ACTIONS(5341),
    [sym__external_open_bracket] = ACTIONS(5769),
    [sym__external_open_bracket2] = ACTIONS(5771),
  },
  [1041] = {
    [sym_call_arguments] = STATE(2595),
    [sym_subset_arguments] = STATE(2594),
    [sym_subset2_arguments] = STATE(2592),
    [sym__open_parenthesis] = STATE(1423),
    [sym__open_bracket] = STATE(1419),
    [sym__open_bracket2] = STATE(1415),
    [ts_builtin_sym_end] = ACTIONS(5345),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5727),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5729),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5731),
    [anon_sym_DASH] = ACTIONS(5733),
    [anon_sym_LT_DASH] = ACTIONS(5735),
    [anon_sym_LT_LT_DASH] = ACTIONS(5735),
    [anon_sym_COLON_EQ] = ACTIONS(5735),
    [anon_sym_DASH_GT] = ACTIONS(5737),
    [anon_sym_DASH_GT_GT] = ACTIONS(5739),
    [anon_sym_PIPE] = ACTIONS(5741),
    [anon_sym_AMP] = ACTIONS(5743),
    [anon_sym_PIPE_PIPE] = ACTIONS(5745),
    [anon_sym_AMP_AMP] = ACTIONS(5747),
    [anon_sym_LT] = ACTIONS(5749),
    [anon_sym_LT_EQ] = ACTIONS(5751),
    [anon_sym_GT] = ACTIONS(5749),
    [anon_sym_GT_EQ] = ACTIONS(5751),
    [anon_sym_EQ_EQ] = ACTIONS(5751),
    [anon_sym_BANG_EQ] = ACTIONS(5751),
    [anon_sym_STAR] = ACTIONS(5753),
    [anon_sym_SLASH] = ACTIONS(5755),
    [anon_sym_STAR_STAR] = ACTIONS(5757),
    [anon_sym_CARET] = ACTIONS(5757),
    [aux_sym_binary_operator_token1] = ACTIONS(5759),
    [anon_sym_PIPE_GT] = ACTIONS(5759),
    [anon_sym_COLON] = ACTIONS(5761),
    [anon_sym_DOLLAR] = ACTIONS(5763),
    [anon_sym_AT] = ACTIONS(5763),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5345),
    [sym__semicolon] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_else] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(5767),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_close_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(5769),
    [sym__external_open_bracket2] = ACTIONS(5771),
  },
  [1042] = {
    [sym_call_arguments] = STATE(2595),
    [sym_subset_arguments] = STATE(2594),
    [sym_subset2_arguments] = STATE(2592),
    [sym__open_parenthesis] = STATE(1423),
    [sym__open_bracket] = STATE(1419),
    [sym__open_bracket2] = STATE(1415),
    [ts_builtin_sym_end] = ACTIONS(5345),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5731),
    [anon_sym_DASH] = ACTIONS(5733),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5741),
    [anon_sym_AMP] = ACTIONS(5743),
    [anon_sym_PIPE_PIPE] = ACTIONS(5745),
    [anon_sym_AMP_AMP] = ACTIONS(5747),
    [anon_sym_LT] = ACTIONS(5749),
    [anon_sym_LT_EQ] = ACTIONS(5751),
    [anon_sym_GT] = ACTIONS(5749),
    [anon_sym_GT_EQ] = ACTIONS(5751),
    [anon_sym_EQ_EQ] = ACTIONS(5751),
    [anon_sym_BANG_EQ] = ACTIONS(5751),
    [anon_sym_STAR] = ACTIONS(5753),
    [anon_sym_SLASH] = ACTIONS(5755),
    [anon_sym_STAR_STAR] = ACTIONS(5757),
    [anon_sym_CARET] = ACTIONS(5757),
    [aux_sym_binary_operator_token1] = ACTIONS(5759),
    [anon_sym_PIPE_GT] = ACTIONS(5759),
    [anon_sym_COLON] = ACTIONS(5761),
    [anon_sym_DOLLAR] = ACTIONS(5763),
    [anon_sym_AT] = ACTIONS(5763),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5345),
    [sym__semicolon] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_else] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(5767),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_close_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(5769),
    [sym__external_open_bracket2] = ACTIONS(5771),
  },
  [1043] = {
    [sym_call_arguments] = STATE(2595),
    [sym_subset_arguments] = STATE(2594),
    [sym_subset2_arguments] = STATE(2592),
    [sym__open_parenthesis] = STATE(1423),
    [sym__open_bracket] = STATE(1419),
    [sym__open_bracket2] = STATE(1415),
    [ts_builtin_sym_end] = ACTIONS(5345),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5731),
    [anon_sym_DASH] = ACTIONS(5733),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5347),
    [anon_sym_AMP] = ACTIONS(5347),
    [anon_sym_PIPE_PIPE] = ACTIONS(5345),
    [anon_sym_AMP_AMP] = ACTIONS(5345),
    [anon_sym_LT] = ACTIONS(5749),
    [anon_sym_LT_EQ] = ACTIONS(5751),
    [anon_sym_GT] = ACTIONS(5749),
    [anon_sym_GT_EQ] = ACTIONS(5751),
    [anon_sym_EQ_EQ] = ACTIONS(5751),
    [anon_sym_BANG_EQ] = ACTIONS(5751),
    [anon_sym_STAR] = ACTIONS(5753),
    [anon_sym_SLASH] = ACTIONS(5755),
    [anon_sym_STAR_STAR] = ACTIONS(5757),
    [anon_sym_CARET] = ACTIONS(5757),
    [aux_sym_binary_operator_token1] = ACTIONS(5759),
    [anon_sym_PIPE_GT] = ACTIONS(5759),
    [anon_sym_COLON] = ACTIONS(5761),
    [anon_sym_DOLLAR] = ACTIONS(5763),
    [anon_sym_AT] = ACTIONS(5763),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5345),
    [sym__semicolon] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_else] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(5767),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_close_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(5769),
    [sym__external_open_bracket2] = ACTIONS(5771),
  },
  [1044] = {
    [sym_call_arguments] = STATE(2595),
    [sym_subset_arguments] = STATE(2594),
    [sym_subset2_arguments] = STATE(2592),
    [sym__open_parenthesis] = STATE(1423),
    [sym__open_bracket] = STATE(1419),
    [sym__open_bracket2] = STATE(1415),
    [ts_builtin_sym_end] = ACTIONS(5345),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5345),
    [anon_sym_DASH] = ACTIONS(5347),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5347),
    [anon_sym_AMP] = ACTIONS(5347),
    [anon_sym_PIPE_PIPE] = ACTIONS(5345),
    [anon_sym_AMP_AMP] = ACTIONS(5345),
    [anon_sym_LT] = ACTIONS(5347),
    [anon_sym_LT_EQ] = ACTIONS(5345),
    [anon_sym_GT] = ACTIONS(5347),
    [anon_sym_GT_EQ] = ACTIONS(5345),
    [anon_sym_EQ_EQ] = ACTIONS(5345),
    [anon_sym_BANG_EQ] = ACTIONS(5345),
    [anon_sym_STAR] = ACTIONS(5347),
    [anon_sym_SLASH] = ACTIONS(5345),
    [anon_sym_STAR_STAR] = ACTIONS(5757),
    [anon_sym_CARET] = ACTIONS(5757),
    [aux_sym_binary_operator_token1] = ACTIONS(5345),
    [anon_sym_PIPE_GT] = ACTIONS(5345),
    [anon_sym_COLON] = ACTIONS(5347),
    [anon_sym_DOLLAR] = ACTIONS(5763),
    [anon_sym_AT] = ACTIONS(5763),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5345),
    [sym__semicolon] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_else] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(5767),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_close_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(5769),
    [sym__external_open_bracket2] = ACTIONS(5771),
  },
  [1045] = {
    [sym_call_arguments] = STATE(2595),
    [sym_subset_arguments] = STATE(2594),
    [sym_subset2_arguments] = STATE(2592),
    [sym__open_parenthesis] = STATE(1423),
    [sym__open_bracket] = STATE(1419),
    [sym__open_bracket2] = STATE(1415),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5727),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5729),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5731),
    [anon_sym_DASH] = ACTIONS(5733),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5737),
    [anon_sym_DASH_GT_GT] = ACTIONS(5739),
    [anon_sym_PIPE] = ACTIONS(5741),
    [anon_sym_AMP] = ACTIONS(5743),
    [anon_sym_PIPE_PIPE] = ACTIONS(5745),
    [anon_sym_AMP_AMP] = ACTIONS(5747),
    [anon_sym_LT] = ACTIONS(5749),
    [anon_sym_LT_EQ] = ACTIONS(5751),
    [anon_sym_GT] = ACTIONS(5749),
    [anon_sym_GT_EQ] = ACTIONS(5751),
    [anon_sym_EQ_EQ] = ACTIONS(5751),
    [anon_sym_BANG_EQ] = ACTIONS(5751),
    [anon_sym_STAR] = ACTIONS(5753),
    [anon_sym_SLASH] = ACTIONS(5755),
    [anon_sym_STAR_STAR] = ACTIONS(5757),
    [anon_sym_CARET] = ACTIONS(5757),
    [aux_sym_binary_operator_token1] = ACTIONS(5759),
    [anon_sym_PIPE_GT] = ACTIONS(5759),
    [anon_sym_COLON] = ACTIONS(5761),
    [anon_sym_DOLLAR] = ACTIONS(5763),
    [anon_sym_AT] = ACTIONS(5763),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5767),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5769),
    [sym__external_open_bracket2] = ACTIONS(5771),
  },
  [1046] = {
    [sym_call_arguments] = STATE(2595),
    [sym_subset_arguments] = STATE(2594),
    [sym_subset2_arguments] = STATE(2592),
    [sym__open_parenthesis] = STATE(1423),
    [sym__open_bracket] = STATE(1419),
    [sym__open_bracket2] = STATE(1415),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5727),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5729),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5731),
    [anon_sym_DASH] = ACTIONS(5733),
    [anon_sym_LT_DASH] = ACTIONS(5735),
    [anon_sym_LT_LT_DASH] = ACTIONS(5735),
    [anon_sym_COLON_EQ] = ACTIONS(5735),
    [anon_sym_DASH_GT] = ACTIONS(5737),
    [anon_sym_DASH_GT_GT] = ACTIONS(5739),
    [anon_sym_PIPE] = ACTIONS(5741),
    [anon_sym_AMP] = ACTIONS(5743),
    [anon_sym_PIPE_PIPE] = ACTIONS(5745),
    [anon_sym_AMP_AMP] = ACTIONS(5747),
    [anon_sym_LT] = ACTIONS(5749),
    [anon_sym_LT_EQ] = ACTIONS(5751),
    [anon_sym_GT] = ACTIONS(5749),
    [anon_sym_GT_EQ] = ACTIONS(5751),
    [anon_sym_EQ_EQ] = ACTIONS(5751),
    [anon_sym_BANG_EQ] = ACTIONS(5751),
    [anon_sym_STAR] = ACTIONS(5753),
    [anon_sym_SLASH] = ACTIONS(5755),
    [anon_sym_STAR_STAR] = ACTIONS(5757),
    [anon_sym_CARET] = ACTIONS(5757),
    [aux_sym_binary_operator_token1] = ACTIONS(5759),
    [anon_sym_PIPE_GT] = ACTIONS(5759),
    [anon_sym_COLON] = ACTIONS(5761),
    [anon_sym_DOLLAR] = ACTIONS(5763),
    [anon_sym_AT] = ACTIONS(5763),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5767),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5769),
    [sym__external_open_bracket2] = ACTIONS(5771),
  },
  [1047] = {
    [sym_call_arguments] = STATE(2595),
    [sym_subset_arguments] = STATE(2594),
    [sym_subset2_arguments] = STATE(2592),
    [sym__open_parenthesis] = STATE(1423),
    [sym__open_bracket] = STATE(1419),
    [sym__open_bracket2] = STATE(1415),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5731),
    [anon_sym_DASH] = ACTIONS(5733),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5741),
    [anon_sym_AMP] = ACTIONS(5743),
    [anon_sym_PIPE_PIPE] = ACTIONS(5745),
    [anon_sym_AMP_AMP] = ACTIONS(5747),
    [anon_sym_LT] = ACTIONS(5749),
    [anon_sym_LT_EQ] = ACTIONS(5751),
    [anon_sym_GT] = ACTIONS(5749),
    [anon_sym_GT_EQ] = ACTIONS(5751),
    [anon_sym_EQ_EQ] = ACTIONS(5751),
    [anon_sym_BANG_EQ] = ACTIONS(5751),
    [anon_sym_STAR] = ACTIONS(5753),
    [anon_sym_SLASH] = ACTIONS(5755),
    [anon_sym_STAR_STAR] = ACTIONS(5757),
    [anon_sym_CARET] = ACTIONS(5757),
    [aux_sym_binary_operator_token1] = ACTIONS(5759),
    [anon_sym_PIPE_GT] = ACTIONS(5759),
    [anon_sym_COLON] = ACTIONS(5761),
    [anon_sym_DOLLAR] = ACTIONS(5763),
    [anon_sym_AT] = ACTIONS(5763),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5767),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5769),
    [sym__external_open_bracket2] = ACTIONS(5771),
  },
  [1048] = {
    [sym_call_arguments] = STATE(2595),
    [sym_subset_arguments] = STATE(2594),
    [sym_subset2_arguments] = STATE(2592),
    [sym__open_parenthesis] = STATE(1423),
    [sym__open_bracket] = STATE(1419),
    [sym__open_bracket2] = STATE(1415),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5753),
    [anon_sym_SLASH] = ACTIONS(5755),
    [anon_sym_STAR_STAR] = ACTIONS(5757),
    [anon_sym_CARET] = ACTIONS(5757),
    [aux_sym_binary_operator_token1] = ACTIONS(5759),
    [anon_sym_PIPE_GT] = ACTIONS(5759),
    [anon_sym_COLON] = ACTIONS(5761),
    [anon_sym_DOLLAR] = ACTIONS(5763),
    [anon_sym_AT] = ACTIONS(5763),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5767),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5769),
    [sym__external_open_bracket2] = ACTIONS(5771),
  },
  [1049] = {
    [sym_call_arguments] = STATE(2595),
    [sym_subset_arguments] = STATE(2594),
    [sym_subset2_arguments] = STATE(2592),
    [sym__open_parenthesis] = STATE(1423),
    [sym__open_bracket] = STATE(1419),
    [sym__open_bracket2] = STATE(1415),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5727),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5729),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5731),
    [anon_sym_DASH] = ACTIONS(5733),
    [anon_sym_LT_DASH] = ACTIONS(5735),
    [anon_sym_LT_LT_DASH] = ACTIONS(5735),
    [anon_sym_COLON_EQ] = ACTIONS(5735),
    [anon_sym_DASH_GT] = ACTIONS(5737),
    [anon_sym_DASH_GT_GT] = ACTIONS(5739),
    [anon_sym_PIPE] = ACTIONS(5741),
    [anon_sym_AMP] = ACTIONS(5743),
    [anon_sym_PIPE_PIPE] = ACTIONS(5745),
    [anon_sym_AMP_AMP] = ACTIONS(5747),
    [anon_sym_LT] = ACTIONS(5749),
    [anon_sym_LT_EQ] = ACTIONS(5751),
    [anon_sym_GT] = ACTIONS(5749),
    [anon_sym_GT_EQ] = ACTIONS(5751),
    [anon_sym_EQ_EQ] = ACTIONS(5751),
    [anon_sym_BANG_EQ] = ACTIONS(5751),
    [anon_sym_STAR] = ACTIONS(5753),
    [anon_sym_SLASH] = ACTIONS(5755),
    [anon_sym_STAR_STAR] = ACTIONS(5757),
    [anon_sym_CARET] = ACTIONS(5757),
    [aux_sym_binary_operator_token1] = ACTIONS(5759),
    [anon_sym_PIPE_GT] = ACTIONS(5759),
    [anon_sym_COLON] = ACTIONS(5761),
    [anon_sym_DOLLAR] = ACTIONS(5763),
    [anon_sym_AT] = ACTIONS(5763),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5767),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5769),
    [sym__external_open_bracket2] = ACTIONS(5771),
  },
  [1050] = {
    [sym_call_arguments] = STATE(2595),
    [sym_subset_arguments] = STATE(2594),
    [sym_subset2_arguments] = STATE(2592),
    [sym__open_parenthesis] = STATE(1423),
    [sym__open_bracket] = STATE(1419),
    [sym__open_bracket2] = STATE(1415),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5729),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5731),
    [anon_sym_DASH] = ACTIONS(5733),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5741),
    [anon_sym_AMP] = ACTIONS(5743),
    [anon_sym_PIPE_PIPE] = ACTIONS(5745),
    [anon_sym_AMP_AMP] = ACTIONS(5747),
    [anon_sym_LT] = ACTIONS(5749),
    [anon_sym_LT_EQ] = ACTIONS(5751),
    [anon_sym_GT] = ACTIONS(5749),
    [anon_sym_GT_EQ] = ACTIONS(5751),
    [anon_sym_EQ_EQ] = ACTIONS(5751),
    [anon_sym_BANG_EQ] = ACTIONS(5751),
    [anon_sym_STAR] = ACTIONS(5753),
    [anon_sym_SLASH] = ACTIONS(5755),
    [anon_sym_STAR_STAR] = ACTIONS(5757),
    [anon_sym_CARET] = ACTIONS(5757),
    [aux_sym_binary_operator_token1] = ACTIONS(5759),
    [anon_sym_PIPE_GT] = ACTIONS(5759),
    [anon_sym_COLON] = ACTIONS(5761),
    [anon_sym_DOLLAR] = ACTIONS(5763),
    [anon_sym_AT] = ACTIONS(5763),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5767),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5769),
    [sym__external_open_bracket2] = ACTIONS(5771),
  },
  [1051] = {
    [sym_call_arguments] = STATE(2595),
    [sym_subset_arguments] = STATE(2594),
    [sym_subset2_arguments] = STATE(2592),
    [sym__open_parenthesis] = STATE(1423),
    [sym__open_bracket] = STATE(1419),
    [sym__open_bracket2] = STATE(1415),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5731),
    [anon_sym_DASH] = ACTIONS(5733),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5743),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5747),
    [anon_sym_LT] = ACTIONS(5749),
    [anon_sym_LT_EQ] = ACTIONS(5751),
    [anon_sym_GT] = ACTIONS(5749),
    [anon_sym_GT_EQ] = ACTIONS(5751),
    [anon_sym_EQ_EQ] = ACTIONS(5751),
    [anon_sym_BANG_EQ] = ACTIONS(5751),
    [anon_sym_STAR] = ACTIONS(5753),
    [anon_sym_SLASH] = ACTIONS(5755),
    [anon_sym_STAR_STAR] = ACTIONS(5757),
    [anon_sym_CARET] = ACTIONS(5757),
    [aux_sym_binary_operator_token1] = ACTIONS(5759),
    [anon_sym_PIPE_GT] = ACTIONS(5759),
    [anon_sym_COLON] = ACTIONS(5761),
    [anon_sym_DOLLAR] = ACTIONS(5763),
    [anon_sym_AT] = ACTIONS(5763),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5767),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5769),
    [sym__external_open_bracket2] = ACTIONS(5771),
  },
  [1052] = {
    [sym_call_arguments] = STATE(2595),
    [sym_subset_arguments] = STATE(2594),
    [sym_subset2_arguments] = STATE(2592),
    [sym__open_parenthesis] = STATE(1423),
    [sym__open_bracket] = STATE(1419),
    [sym__open_bracket2] = STATE(1415),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5731),
    [anon_sym_DASH] = ACTIONS(5733),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5749),
    [anon_sym_LT_EQ] = ACTIONS(5751),
    [anon_sym_GT] = ACTIONS(5749),
    [anon_sym_GT_EQ] = ACTIONS(5751),
    [anon_sym_EQ_EQ] = ACTIONS(5751),
    [anon_sym_BANG_EQ] = ACTIONS(5751),
    [anon_sym_STAR] = ACTIONS(5753),
    [anon_sym_SLASH] = ACTIONS(5755),
    [anon_sym_STAR_STAR] = ACTIONS(5757),
    [anon_sym_CARET] = ACTIONS(5757),
    [aux_sym_binary_operator_token1] = ACTIONS(5759),
    [anon_sym_PIPE_GT] = ACTIONS(5759),
    [anon_sym_COLON] = ACTIONS(5761),
    [anon_sym_DOLLAR] = ACTIONS(5763),
    [anon_sym_AT] = ACTIONS(5763),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5767),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5769),
    [sym__external_open_bracket2] = ACTIONS(5771),
  },
  [1053] = {
    [sym_call_arguments] = STATE(2595),
    [sym_subset_arguments] = STATE(2594),
    [sym_subset2_arguments] = STATE(2592),
    [sym__open_parenthesis] = STATE(1423),
    [sym__open_bracket] = STATE(1419),
    [sym__open_bracket2] = STATE(1415),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5731),
    [anon_sym_DASH] = ACTIONS(5733),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5753),
    [anon_sym_SLASH] = ACTIONS(5755),
    [anon_sym_STAR_STAR] = ACTIONS(5757),
    [anon_sym_CARET] = ACTIONS(5757),
    [aux_sym_binary_operator_token1] = ACTIONS(5759),
    [anon_sym_PIPE_GT] = ACTIONS(5759),
    [anon_sym_COLON] = ACTIONS(5761),
    [anon_sym_DOLLAR] = ACTIONS(5763),
    [anon_sym_AT] = ACTIONS(5763),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5767),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5769),
    [sym__external_open_bracket2] = ACTIONS(5771),
  },
  [1054] = {
    [sym_call_arguments] = STATE(2595),
    [sym_subset_arguments] = STATE(2594),
    [sym_subset2_arguments] = STATE(2592),
    [sym__open_parenthesis] = STATE(1423),
    [sym__open_bracket] = STATE(1419),
    [sym__open_bracket2] = STATE(1415),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(5757),
    [anon_sym_CARET] = ACTIONS(5757),
    [aux_sym_binary_operator_token1] = ACTIONS(5759),
    [anon_sym_PIPE_GT] = ACTIONS(5759),
    [anon_sym_COLON] = ACTIONS(5761),
    [anon_sym_DOLLAR] = ACTIONS(5763),
    [anon_sym_AT] = ACTIONS(5763),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5767),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5769),
    [sym__external_open_bracket2] = ACTIONS(5771),
  },
  [1055] = {
    [sym_call_arguments] = STATE(2595),
    [sym_subset_arguments] = STATE(2594),
    [sym_subset2_arguments] = STATE(2592),
    [sym__open_parenthesis] = STATE(1423),
    [sym__open_bracket] = STATE(1419),
    [sym__open_bracket2] = STATE(1415),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(5757),
    [anon_sym_CARET] = ACTIONS(5757),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(5351),
    [anon_sym_DOLLAR] = ACTIONS(5763),
    [anon_sym_AT] = ACTIONS(5763),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5767),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5769),
    [sym__external_open_bracket2] = ACTIONS(5771),
  },
  [1056] = {
    [sym_call_arguments] = STATE(2595),
    [sym_subset_arguments] = STATE(2594),
    [sym_subset2_arguments] = STATE(2592),
    [sym__open_parenthesis] = STATE(1423),
    [sym__open_bracket] = STATE(1419),
    [sym__open_bracket2] = STATE(1415),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(5757),
    [anon_sym_CARET] = ACTIONS(5757),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(5761),
    [anon_sym_DOLLAR] = ACTIONS(5763),
    [anon_sym_AT] = ACTIONS(5763),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5767),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5769),
    [sym__external_open_bracket2] = ACTIONS(5771),
  },
  [1057] = {
    [sym_call_arguments] = STATE(2595),
    [sym_subset_arguments] = STATE(2594),
    [sym_subset2_arguments] = STATE(2592),
    [sym__open_parenthesis] = STATE(1423),
    [sym__open_bracket] = STATE(1419),
    [sym__open_bracket2] = STATE(1415),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(5757),
    [anon_sym_CARET] = ACTIONS(5757),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(5351),
    [anon_sym_DOLLAR] = ACTIONS(5763),
    [anon_sym_AT] = ACTIONS(5763),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5767),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5769),
    [sym__external_open_bracket2] = ACTIONS(5771),
  },
  [1058] = {
    [sym_call_arguments] = STATE(2595),
    [sym_subset_arguments] = STATE(2594),
    [sym_subset2_arguments] = STATE(2592),
    [sym__open_parenthesis] = STATE(1423),
    [sym__open_bracket] = STATE(1419),
    [sym__open_bracket2] = STATE(1415),
    [ts_builtin_sym_end] = ACTIONS(5399),
    [sym_identifier] = ACTIONS(5401),
    [anon_sym_BSLASH] = ACTIONS(5399),
    [anon_sym_function] = ACTIONS(5401),
    [anon_sym_EQ] = ACTIONS(5727),
    [anon_sym_if] = ACTIONS(5401),
    [anon_sym_for] = ACTIONS(5401),
    [anon_sym_while] = ACTIONS(5401),
    [anon_sym_repeat] = ACTIONS(5401),
    [anon_sym_QMARK] = ACTIONS(5399),
    [anon_sym_TILDE] = ACTIONS(5729),
    [anon_sym_BANG] = ACTIONS(5401),
    [anon_sym_PLUS] = ACTIONS(5731),
    [anon_sym_DASH] = ACTIONS(5733),
    [anon_sym_LT_DASH] = ACTIONS(5735),
    [anon_sym_LT_LT_DASH] = ACTIONS(5735),
    [anon_sym_COLON_EQ] = ACTIONS(5735),
    [anon_sym_DASH_GT] = ACTIONS(5737),
    [anon_sym_DASH_GT_GT] = ACTIONS(5739),
    [anon_sym_PIPE] = ACTIONS(5741),
    [anon_sym_AMP] = ACTIONS(5743),
    [anon_sym_PIPE_PIPE] = ACTIONS(5745),
    [anon_sym_AMP_AMP] = ACTIONS(5747),
    [anon_sym_LT] = ACTIONS(5749),
    [anon_sym_LT_EQ] = ACTIONS(5751),
    [anon_sym_GT] = ACTIONS(5749),
    [anon_sym_GT_EQ] = ACTIONS(5751),
    [anon_sym_EQ_EQ] = ACTIONS(5751),
    [anon_sym_BANG_EQ] = ACTIONS(5751),
    [anon_sym_STAR] = ACTIONS(5753),
    [anon_sym_SLASH] = ACTIONS(5755),
    [anon_sym_STAR_STAR] = ACTIONS(5757),
    [anon_sym_CARET] = ACTIONS(5757),
    [aux_sym_binary_operator_token1] = ACTIONS(5759),
    [anon_sym_PIPE_GT] = ACTIONS(5759),
    [anon_sym_COLON] = ACTIONS(5761),
    [anon_sym_DOLLAR] = ACTIONS(5763),
    [anon_sym_AT] = ACTIONS(5763),
    [aux_sym__hex_literal_token1] = ACTIONS(5399),
    [sym__number_literal] = ACTIONS(5401),
    [anon_sym_SQUOTE] = ACTIONS(5399),
    [anon_sym_DQUOTE] = ACTIONS(5399),
    [sym_return] = ACTIONS(5401),
    [sym_next] = ACTIONS(5401),
    [sym_break] = ACTIONS(5401),
    [sym_true] = ACTIONS(5401),
    [sym_false] = ACTIONS(5401),
    [sym_null] = ACTIONS(5401),
    [sym_inf] = ACTIONS(5401),
    [sym_nan] = ACTIONS(5401),
    [anon_sym_NA] = ACTIONS(5401),
    [anon_sym_NA_integer_] = ACTIONS(5401),
    [anon_sym_NA_real_] = ACTIONS(5401),
    [anon_sym_NA_complex_] = ACTIONS(5401),
    [anon_sym_NA_character_] = ACTIONS(5401),
    [sym_dots] = ACTIONS(5401),
    [sym_dot_dot_i] = ACTIONS(5399),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5399),
    [sym__semicolon] = ACTIONS(5399),
    [sym__raw_string_literal] = ACTIONS(5399),
    [sym__external_else] = ACTIONS(5399),
    [sym__external_open_parenthesis] = ACTIONS(5767),
    [sym__external_open_brace] = ACTIONS(5399),
    [sym__external_close_brace] = ACTIONS(5399),
    [sym__external_open_bracket] = ACTIONS(5769),
    [sym__external_open_bracket2] = ACTIONS(5771),
  },
  [1059] = {
    [sym_call_arguments] = STATE(2595),
    [sym_subset_arguments] = STATE(2594),
    [sym_subset2_arguments] = STATE(2592),
    [sym__open_parenthesis] = STATE(1423),
    [sym__open_bracket] = STATE(1419),
    [sym__open_bracket2] = STATE(1415),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5727),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5729),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5731),
    [anon_sym_DASH] = ACTIONS(5733),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5737),
    [anon_sym_DASH_GT_GT] = ACTIONS(5739),
    [anon_sym_PIPE] = ACTIONS(5741),
    [anon_sym_AMP] = ACTIONS(5743),
    [anon_sym_PIPE_PIPE] = ACTIONS(5745),
    [anon_sym_AMP_AMP] = ACTIONS(5747),
    [anon_sym_LT] = ACTIONS(5749),
    [anon_sym_LT_EQ] = ACTIONS(5751),
    [anon_sym_GT] = ACTIONS(5749),
    [anon_sym_GT_EQ] = ACTIONS(5751),
    [anon_sym_EQ_EQ] = ACTIONS(5751),
    [anon_sym_BANG_EQ] = ACTIONS(5751),
    [anon_sym_STAR] = ACTIONS(5753),
    [anon_sym_SLASH] = ACTIONS(5755),
    [anon_sym_STAR_STAR] = ACTIONS(5757),
    [anon_sym_CARET] = ACTIONS(5757),
    [aux_sym_binary_operator_token1] = ACTIONS(5759),
    [anon_sym_PIPE_GT] = ACTIONS(5759),
    [anon_sym_COLON] = ACTIONS(5761),
    [anon_sym_DOLLAR] = ACTIONS(5763),
    [anon_sym_AT] = ACTIONS(5763),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5767),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5769),
    [sym__external_open_bracket2] = ACTIONS(5771),
  },
  [1060] = {
    [sym_call_arguments] = STATE(2595),
    [sym_subset_arguments] = STATE(2594),
    [sym_subset2_arguments] = STATE(2592),
    [sym__open_parenthesis] = STATE(1423),
    [sym__open_bracket] = STATE(1419),
    [sym__open_bracket2] = STATE(1415),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5727),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5729),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5731),
    [anon_sym_DASH] = ACTIONS(5733),
    [anon_sym_LT_DASH] = ACTIONS(5735),
    [anon_sym_LT_LT_DASH] = ACTIONS(5735),
    [anon_sym_COLON_EQ] = ACTIONS(5735),
    [anon_sym_DASH_GT] = ACTIONS(5737),
    [anon_sym_DASH_GT_GT] = ACTIONS(5739),
    [anon_sym_PIPE] = ACTIONS(5741),
    [anon_sym_AMP] = ACTIONS(5743),
    [anon_sym_PIPE_PIPE] = ACTIONS(5745),
    [anon_sym_AMP_AMP] = ACTIONS(5747),
    [anon_sym_LT] = ACTIONS(5749),
    [anon_sym_LT_EQ] = ACTIONS(5751),
    [anon_sym_GT] = ACTIONS(5749),
    [anon_sym_GT_EQ] = ACTIONS(5751),
    [anon_sym_EQ_EQ] = ACTIONS(5751),
    [anon_sym_BANG_EQ] = ACTIONS(5751),
    [anon_sym_STAR] = ACTIONS(5753),
    [anon_sym_SLASH] = ACTIONS(5755),
    [anon_sym_STAR_STAR] = ACTIONS(5757),
    [anon_sym_CARET] = ACTIONS(5757),
    [aux_sym_binary_operator_token1] = ACTIONS(5759),
    [anon_sym_PIPE_GT] = ACTIONS(5759),
    [anon_sym_COLON] = ACTIONS(5761),
    [anon_sym_DOLLAR] = ACTIONS(5763),
    [anon_sym_AT] = ACTIONS(5763),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5767),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5769),
    [sym__external_open_bracket2] = ACTIONS(5771),
  },
  [1061] = {
    [sym_string] = STATE(2502),
    [sym__single_quoted_string] = STATE(2211),
    [sym__double_quoted_string] = STATE(2212),
    [sym__string_or_identifier] = STATE(2502),
    [aux_sym_function_definition_repeat1] = STATE(2349),
    [sym_identifier] = ACTIONS(6053),
    [anon_sym_BSLASH] = ACTIONS(5669),
    [anon_sym_function] = ACTIONS(5673),
    [anon_sym_EQ] = ACTIONS(5673),
    [anon_sym_if] = ACTIONS(5673),
    [anon_sym_for] = ACTIONS(5673),
    [anon_sym_while] = ACTIONS(5673),
    [anon_sym_repeat] = ACTIONS(5673),
    [anon_sym_QMARK] = ACTIONS(5669),
    [anon_sym_TILDE] = ACTIONS(5669),
    [anon_sym_BANG] = ACTIONS(5673),
    [anon_sym_PLUS] = ACTIONS(5669),
    [anon_sym_DASH] = ACTIONS(5673),
    [anon_sym_LT_DASH] = ACTIONS(5669),
    [anon_sym_LT_LT_DASH] = ACTIONS(5669),
    [anon_sym_COLON_EQ] = ACTIONS(5669),
    [anon_sym_DASH_GT] = ACTIONS(5673),
    [anon_sym_DASH_GT_GT] = ACTIONS(5669),
    [anon_sym_PIPE] = ACTIONS(5673),
    [anon_sym_AMP] = ACTIONS(5673),
    [anon_sym_PIPE_PIPE] = ACTIONS(5669),
    [anon_sym_AMP_AMP] = ACTIONS(5669),
    [anon_sym_LT] = ACTIONS(5673),
    [anon_sym_LT_EQ] = ACTIONS(5669),
    [anon_sym_GT] = ACTIONS(5673),
    [anon_sym_GT_EQ] = ACTIONS(5669),
    [anon_sym_EQ_EQ] = ACTIONS(5669),
    [anon_sym_BANG_EQ] = ACTIONS(5669),
    [anon_sym_STAR] = ACTIONS(5673),
    [anon_sym_SLASH] = ACTIONS(5669),
    [anon_sym_STAR_STAR] = ACTIONS(5669),
    [anon_sym_CARET] = ACTIONS(5669),
    [aux_sym_binary_operator_token1] = ACTIONS(5669),
    [anon_sym_PIPE_GT] = ACTIONS(5669),
    [anon_sym_COLON] = ACTIONS(5673),
    [anon_sym_DOLLAR] = ACTIONS(5669),
    [anon_sym_AT] = ACTIONS(5669),
    [aux_sym__hex_literal_token1] = ACTIONS(5669),
    [sym__number_literal] = ACTIONS(5673),
    [anon_sym_SQUOTE] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_return] = ACTIONS(5673),
    [sym_next] = ACTIONS(5673),
    [sym_break] = ACTIONS(5673),
    [sym_true] = ACTIONS(5673),
    [sym_false] = ACTIONS(5673),
    [sym_null] = ACTIONS(5673),
    [sym_inf] = ACTIONS(5673),
    [sym_nan] = ACTIONS(5673),
    [anon_sym_NA] = ACTIONS(5673),
    [anon_sym_NA_integer_] = ACTIONS(5673),
    [anon_sym_NA_real_] = ACTIONS(5673),
    [anon_sym_NA_complex_] = ACTIONS(5673),
    [anon_sym_NA_character_] = ACTIONS(5673),
    [sym_dots] = ACTIONS(5673),
    [sym_dot_dot_i] = ACTIONS(5669),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5669),
    [sym__newline] = ACTIONS(5669),
    [sym__semicolon] = ACTIONS(5669),
    [sym__raw_string_literal] = ACTIONS(445),
    [sym__external_else] = ACTIONS(5669),
    [sym__external_open_parenthesis] = ACTIONS(5669),
    [sym__external_open_brace] = ACTIONS(5669),
    [sym__external_close_brace] = ACTIONS(5669),
    [sym__external_open_bracket] = ACTIONS(5669),
    [sym__external_open_bracket2] = ACTIONS(5669),
    [sym__external_close_bracket2] = ACTIONS(5669),
  },
  [1062] = {
    [sym_call_arguments] = STATE(2595),
    [sym_subset_arguments] = STATE(2594),
    [sym_subset2_arguments] = STATE(2592),
    [sym__open_parenthesis] = STATE(1423),
    [sym__open_bracket] = STATE(1419),
    [sym__open_bracket2] = STATE(1415),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5731),
    [anon_sym_DASH] = ACTIONS(5733),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5741),
    [anon_sym_AMP] = ACTIONS(5743),
    [anon_sym_PIPE_PIPE] = ACTIONS(5745),
    [anon_sym_AMP_AMP] = ACTIONS(5747),
    [anon_sym_LT] = ACTIONS(5749),
    [anon_sym_LT_EQ] = ACTIONS(5751),
    [anon_sym_GT] = ACTIONS(5749),
    [anon_sym_GT_EQ] = ACTIONS(5751),
    [anon_sym_EQ_EQ] = ACTIONS(5751),
    [anon_sym_BANG_EQ] = ACTIONS(5751),
    [anon_sym_STAR] = ACTIONS(5753),
    [anon_sym_SLASH] = ACTIONS(5755),
    [anon_sym_STAR_STAR] = ACTIONS(5757),
    [anon_sym_CARET] = ACTIONS(5757),
    [aux_sym_binary_operator_token1] = ACTIONS(5759),
    [anon_sym_PIPE_GT] = ACTIONS(5759),
    [anon_sym_COLON] = ACTIONS(5761),
    [anon_sym_DOLLAR] = ACTIONS(5763),
    [anon_sym_AT] = ACTIONS(5763),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5767),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5769),
    [sym__external_open_bracket2] = ACTIONS(5771),
  },
  [1063] = {
    [sym_call_arguments] = STATE(2595),
    [sym_subset_arguments] = STATE(2594),
    [sym_subset2_arguments] = STATE(2592),
    [sym__open_parenthesis] = STATE(1423),
    [sym__open_bracket] = STATE(1419),
    [sym__open_bracket2] = STATE(1415),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5753),
    [anon_sym_SLASH] = ACTIONS(5755),
    [anon_sym_STAR_STAR] = ACTIONS(5757),
    [anon_sym_CARET] = ACTIONS(5757),
    [aux_sym_binary_operator_token1] = ACTIONS(5759),
    [anon_sym_PIPE_GT] = ACTIONS(5759),
    [anon_sym_COLON] = ACTIONS(5761),
    [anon_sym_DOLLAR] = ACTIONS(5763),
    [anon_sym_AT] = ACTIONS(5763),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5767),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5769),
    [sym__external_open_bracket2] = ACTIONS(5771),
  },
  [1064] = {
    [sym_call_arguments] = STATE(2595),
    [sym_subset_arguments] = STATE(2594),
    [sym_subset2_arguments] = STATE(2592),
    [sym__open_parenthesis] = STATE(1423),
    [sym__open_bracket] = STATE(1419),
    [sym__open_bracket2] = STATE(1415),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5727),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5729),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5731),
    [anon_sym_DASH] = ACTIONS(5733),
    [anon_sym_LT_DASH] = ACTIONS(5735),
    [anon_sym_LT_LT_DASH] = ACTIONS(5735),
    [anon_sym_COLON_EQ] = ACTIONS(5735),
    [anon_sym_DASH_GT] = ACTIONS(5737),
    [anon_sym_DASH_GT_GT] = ACTIONS(5739),
    [anon_sym_PIPE] = ACTIONS(5741),
    [anon_sym_AMP] = ACTIONS(5743),
    [anon_sym_PIPE_PIPE] = ACTIONS(5745),
    [anon_sym_AMP_AMP] = ACTIONS(5747),
    [anon_sym_LT] = ACTIONS(5749),
    [anon_sym_LT_EQ] = ACTIONS(5751),
    [anon_sym_GT] = ACTIONS(5749),
    [anon_sym_GT_EQ] = ACTIONS(5751),
    [anon_sym_EQ_EQ] = ACTIONS(5751),
    [anon_sym_BANG_EQ] = ACTIONS(5751),
    [anon_sym_STAR] = ACTIONS(5753),
    [anon_sym_SLASH] = ACTIONS(5755),
    [anon_sym_STAR_STAR] = ACTIONS(5757),
    [anon_sym_CARET] = ACTIONS(5757),
    [aux_sym_binary_operator_token1] = ACTIONS(5759),
    [anon_sym_PIPE_GT] = ACTIONS(5759),
    [anon_sym_COLON] = ACTIONS(5761),
    [anon_sym_DOLLAR] = ACTIONS(5763),
    [anon_sym_AT] = ACTIONS(5763),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5767),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5769),
    [sym__external_open_bracket2] = ACTIONS(5771),
  },
  [1065] = {
    [sym_call_arguments] = STATE(2595),
    [sym_subset_arguments] = STATE(2594),
    [sym_subset2_arguments] = STATE(2592),
    [sym__open_parenthesis] = STATE(1423),
    [sym__open_bracket] = STATE(1419),
    [sym__open_bracket2] = STATE(1415),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5729),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5731),
    [anon_sym_DASH] = ACTIONS(5733),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5741),
    [anon_sym_AMP] = ACTIONS(5743),
    [anon_sym_PIPE_PIPE] = ACTIONS(5745),
    [anon_sym_AMP_AMP] = ACTIONS(5747),
    [anon_sym_LT] = ACTIONS(5749),
    [anon_sym_LT_EQ] = ACTIONS(5751),
    [anon_sym_GT] = ACTIONS(5749),
    [anon_sym_GT_EQ] = ACTIONS(5751),
    [anon_sym_EQ_EQ] = ACTIONS(5751),
    [anon_sym_BANG_EQ] = ACTIONS(5751),
    [anon_sym_STAR] = ACTIONS(5753),
    [anon_sym_SLASH] = ACTIONS(5755),
    [anon_sym_STAR_STAR] = ACTIONS(5757),
    [anon_sym_CARET] = ACTIONS(5757),
    [aux_sym_binary_operator_token1] = ACTIONS(5759),
    [anon_sym_PIPE_GT] = ACTIONS(5759),
    [anon_sym_COLON] = ACTIONS(5761),
    [anon_sym_DOLLAR] = ACTIONS(5763),
    [anon_sym_AT] = ACTIONS(5763),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5767),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5769),
    [sym__external_open_bracket2] = ACTIONS(5771),
  },
  [1066] = {
    [sym_call_arguments] = STATE(2595),
    [sym_subset_arguments] = STATE(2594),
    [sym_subset2_arguments] = STATE(2592),
    [sym__open_parenthesis] = STATE(1423),
    [sym__open_bracket] = STATE(1419),
    [sym__open_bracket2] = STATE(1415),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5731),
    [anon_sym_DASH] = ACTIONS(5733),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5743),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5747),
    [anon_sym_LT] = ACTIONS(5749),
    [anon_sym_LT_EQ] = ACTIONS(5751),
    [anon_sym_GT] = ACTIONS(5749),
    [anon_sym_GT_EQ] = ACTIONS(5751),
    [anon_sym_EQ_EQ] = ACTIONS(5751),
    [anon_sym_BANG_EQ] = ACTIONS(5751),
    [anon_sym_STAR] = ACTIONS(5753),
    [anon_sym_SLASH] = ACTIONS(5755),
    [anon_sym_STAR_STAR] = ACTIONS(5757),
    [anon_sym_CARET] = ACTIONS(5757),
    [aux_sym_binary_operator_token1] = ACTIONS(5759),
    [anon_sym_PIPE_GT] = ACTIONS(5759),
    [anon_sym_COLON] = ACTIONS(5761),
    [anon_sym_DOLLAR] = ACTIONS(5763),
    [anon_sym_AT] = ACTIONS(5763),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5767),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5769),
    [sym__external_open_bracket2] = ACTIONS(5771),
  },
  [1067] = {
    [sym_call_arguments] = STATE(2595),
    [sym_subset_arguments] = STATE(2594),
    [sym_subset2_arguments] = STATE(2592),
    [sym__open_parenthesis] = STATE(1423),
    [sym__open_bracket] = STATE(1419),
    [sym__open_bracket2] = STATE(1415),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5731),
    [anon_sym_DASH] = ACTIONS(5733),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5749),
    [anon_sym_LT_EQ] = ACTIONS(5751),
    [anon_sym_GT] = ACTIONS(5749),
    [anon_sym_GT_EQ] = ACTIONS(5751),
    [anon_sym_EQ_EQ] = ACTIONS(5751),
    [anon_sym_BANG_EQ] = ACTIONS(5751),
    [anon_sym_STAR] = ACTIONS(5753),
    [anon_sym_SLASH] = ACTIONS(5755),
    [anon_sym_STAR_STAR] = ACTIONS(5757),
    [anon_sym_CARET] = ACTIONS(5757),
    [aux_sym_binary_operator_token1] = ACTIONS(5759),
    [anon_sym_PIPE_GT] = ACTIONS(5759),
    [anon_sym_COLON] = ACTIONS(5761),
    [anon_sym_DOLLAR] = ACTIONS(5763),
    [anon_sym_AT] = ACTIONS(5763),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5767),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5769),
    [sym__external_open_bracket2] = ACTIONS(5771),
  },
  [1068] = {
    [sym_call_arguments] = STATE(2638),
    [sym_subset_arguments] = STATE(2647),
    [sym_subset2_arguments] = STATE(2650),
    [sym__open_parenthesis] = STATE(1537),
    [sym__open_bracket] = STATE(1534),
    [sym__open_bracket2] = STATE(1533),
    [sym_identifier] = ACTIONS(5411),
    [anon_sym_BSLASH] = ACTIONS(5409),
    [anon_sym_function] = ACTIONS(5411),
    [anon_sym_EQ] = ACTIONS(6055),
    [anon_sym_if] = ACTIONS(5411),
    [anon_sym_for] = ACTIONS(5411),
    [anon_sym_while] = ACTIONS(5411),
    [anon_sym_repeat] = ACTIONS(5411),
    [anon_sym_QMARK] = ACTIONS(5409),
    [anon_sym_TILDE] = ACTIONS(6057),
    [anon_sym_BANG] = ACTIONS(5411),
    [anon_sym_PLUS] = ACTIONS(6059),
    [anon_sym_DASH] = ACTIONS(6061),
    [anon_sym_LT_DASH] = ACTIONS(6063),
    [anon_sym_LT_LT_DASH] = ACTIONS(6063),
    [anon_sym_COLON_EQ] = ACTIONS(6063),
    [anon_sym_DASH_GT] = ACTIONS(6065),
    [anon_sym_DASH_GT_GT] = ACTIONS(6067),
    [anon_sym_PIPE] = ACTIONS(6069),
    [anon_sym_AMP] = ACTIONS(6071),
    [anon_sym_PIPE_PIPE] = ACTIONS(6073),
    [anon_sym_AMP_AMP] = ACTIONS(6075),
    [anon_sym_LT] = ACTIONS(6077),
    [anon_sym_LT_EQ] = ACTIONS(6079),
    [anon_sym_GT] = ACTIONS(6077),
    [anon_sym_GT_EQ] = ACTIONS(6079),
    [anon_sym_EQ_EQ] = ACTIONS(6079),
    [anon_sym_BANG_EQ] = ACTIONS(6079),
    [anon_sym_STAR] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6083),
    [anon_sym_STAR_STAR] = ACTIONS(6085),
    [anon_sym_CARET] = ACTIONS(6085),
    [aux_sym_binary_operator_token1] = ACTIONS(6087),
    [anon_sym_PIPE_GT] = ACTIONS(6087),
    [anon_sym_COLON] = ACTIONS(6089),
    [anon_sym_DOLLAR] = ACTIONS(6091),
    [anon_sym_AT] = ACTIONS(6091),
    [aux_sym__hex_literal_token1] = ACTIONS(5409),
    [sym__number_literal] = ACTIONS(5411),
    [anon_sym_SQUOTE] = ACTIONS(5409),
    [anon_sym_DQUOTE] = ACTIONS(5409),
    [sym_return] = ACTIONS(5411),
    [sym_next] = ACTIONS(5411),
    [sym_break] = ACTIONS(5411),
    [sym_true] = ACTIONS(5411),
    [sym_false] = ACTIONS(5411),
    [sym_null] = ACTIONS(5411),
    [sym_inf] = ACTIONS(5411),
    [sym_nan] = ACTIONS(5411),
    [anon_sym_NA] = ACTIONS(5411),
    [anon_sym_NA_integer_] = ACTIONS(5411),
    [anon_sym_NA_real_] = ACTIONS(5411),
    [anon_sym_NA_complex_] = ACTIONS(5411),
    [anon_sym_NA_character_] = ACTIONS(5411),
    [sym_dots] = ACTIONS(5411),
    [sym_dot_dot_i] = ACTIONS(5409),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5409),
    [sym__newline] = ACTIONS(5409),
    [sym__semicolon] = ACTIONS(5409),
    [sym__raw_string_literal] = ACTIONS(5409),
    [sym__external_open_parenthesis] = ACTIONS(6093),
    [sym__external_open_brace] = ACTIONS(5409),
    [sym__external_close_brace] = ACTIONS(5409),
    [sym__external_open_bracket] = ACTIONS(6095),
    [sym__external_open_bracket2] = ACTIONS(6097),
    [sym__external_close_bracket2] = ACTIONS(5409),
  },
  [1069] = {
    [sym_call_arguments] = STATE(2638),
    [sym_subset_arguments] = STATE(2647),
    [sym_subset2_arguments] = STATE(2650),
    [sym__open_parenthesis] = STATE(1537),
    [sym__open_bracket] = STATE(1534),
    [sym__open_bracket2] = STATE(1533),
    [sym_identifier] = ACTIONS(5455),
    [anon_sym_BSLASH] = ACTIONS(5453),
    [anon_sym_function] = ACTIONS(5455),
    [anon_sym_EQ] = ACTIONS(6055),
    [anon_sym_if] = ACTIONS(5455),
    [anon_sym_for] = ACTIONS(5455),
    [anon_sym_while] = ACTIONS(5455),
    [anon_sym_repeat] = ACTIONS(5455),
    [anon_sym_QMARK] = ACTIONS(5453),
    [anon_sym_TILDE] = ACTIONS(6057),
    [anon_sym_BANG] = ACTIONS(5455),
    [anon_sym_PLUS] = ACTIONS(6059),
    [anon_sym_DASH] = ACTIONS(6061),
    [anon_sym_LT_DASH] = ACTIONS(6063),
    [anon_sym_LT_LT_DASH] = ACTIONS(6063),
    [anon_sym_COLON_EQ] = ACTIONS(6063),
    [anon_sym_DASH_GT] = ACTIONS(6065),
    [anon_sym_DASH_GT_GT] = ACTIONS(6067),
    [anon_sym_PIPE] = ACTIONS(6069),
    [anon_sym_AMP] = ACTIONS(6071),
    [anon_sym_PIPE_PIPE] = ACTIONS(6073),
    [anon_sym_AMP_AMP] = ACTIONS(6075),
    [anon_sym_LT] = ACTIONS(6077),
    [anon_sym_LT_EQ] = ACTIONS(6079),
    [anon_sym_GT] = ACTIONS(6077),
    [anon_sym_GT_EQ] = ACTIONS(6079),
    [anon_sym_EQ_EQ] = ACTIONS(6079),
    [anon_sym_BANG_EQ] = ACTIONS(6079),
    [anon_sym_STAR] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6083),
    [anon_sym_STAR_STAR] = ACTIONS(6085),
    [anon_sym_CARET] = ACTIONS(6085),
    [aux_sym_binary_operator_token1] = ACTIONS(6087),
    [anon_sym_PIPE_GT] = ACTIONS(6087),
    [anon_sym_COLON] = ACTIONS(6089),
    [anon_sym_DOLLAR] = ACTIONS(6091),
    [anon_sym_AT] = ACTIONS(6091),
    [aux_sym__hex_literal_token1] = ACTIONS(5453),
    [sym__number_literal] = ACTIONS(5455),
    [anon_sym_SQUOTE] = ACTIONS(5453),
    [anon_sym_DQUOTE] = ACTIONS(5453),
    [sym_return] = ACTIONS(5455),
    [sym_next] = ACTIONS(5455),
    [sym_break] = ACTIONS(5455),
    [sym_true] = ACTIONS(5455),
    [sym_false] = ACTIONS(5455),
    [sym_null] = ACTIONS(5455),
    [sym_inf] = ACTIONS(5455),
    [sym_nan] = ACTIONS(5455),
    [anon_sym_NA] = ACTIONS(5455),
    [anon_sym_NA_integer_] = ACTIONS(5455),
    [anon_sym_NA_real_] = ACTIONS(5455),
    [anon_sym_NA_complex_] = ACTIONS(5455),
    [anon_sym_NA_character_] = ACTIONS(5455),
    [sym_dots] = ACTIONS(5455),
    [sym_dot_dot_i] = ACTIONS(5453),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5453),
    [sym__newline] = ACTIONS(5453),
    [sym__semicolon] = ACTIONS(5453),
    [sym__raw_string_literal] = ACTIONS(5453),
    [sym__external_open_parenthesis] = ACTIONS(6093),
    [sym__external_open_brace] = ACTIONS(5453),
    [sym__external_close_brace] = ACTIONS(5453),
    [sym__external_open_bracket] = ACTIONS(6095),
    [sym__external_open_bracket2] = ACTIONS(6097),
    [sym__external_close_bracket2] = ACTIONS(5453),
  },
  [1070] = {
    [sym_call_arguments] = STATE(2638),
    [sym_subset_arguments] = STATE(2647),
    [sym_subset2_arguments] = STATE(2650),
    [sym__open_parenthesis] = STATE(1537),
    [sym__open_bracket] = STATE(1534),
    [sym__open_bracket2] = STATE(1533),
    [sym_identifier] = ACTIONS(5451),
    [anon_sym_BSLASH] = ACTIONS(5449),
    [anon_sym_function] = ACTIONS(5451),
    [anon_sym_EQ] = ACTIONS(6055),
    [anon_sym_if] = ACTIONS(5451),
    [anon_sym_for] = ACTIONS(5451),
    [anon_sym_while] = ACTIONS(5451),
    [anon_sym_repeat] = ACTIONS(5451),
    [anon_sym_QMARK] = ACTIONS(5449),
    [anon_sym_TILDE] = ACTIONS(6057),
    [anon_sym_BANG] = ACTIONS(5451),
    [anon_sym_PLUS] = ACTIONS(6059),
    [anon_sym_DASH] = ACTIONS(6061),
    [anon_sym_LT_DASH] = ACTIONS(6063),
    [anon_sym_LT_LT_DASH] = ACTIONS(6063),
    [anon_sym_COLON_EQ] = ACTIONS(6063),
    [anon_sym_DASH_GT] = ACTIONS(6065),
    [anon_sym_DASH_GT_GT] = ACTIONS(6067),
    [anon_sym_PIPE] = ACTIONS(6069),
    [anon_sym_AMP] = ACTIONS(6071),
    [anon_sym_PIPE_PIPE] = ACTIONS(6073),
    [anon_sym_AMP_AMP] = ACTIONS(6075),
    [anon_sym_LT] = ACTIONS(6077),
    [anon_sym_LT_EQ] = ACTIONS(6079),
    [anon_sym_GT] = ACTIONS(6077),
    [anon_sym_GT_EQ] = ACTIONS(6079),
    [anon_sym_EQ_EQ] = ACTIONS(6079),
    [anon_sym_BANG_EQ] = ACTIONS(6079),
    [anon_sym_STAR] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6083),
    [anon_sym_STAR_STAR] = ACTIONS(6085),
    [anon_sym_CARET] = ACTIONS(6085),
    [aux_sym_binary_operator_token1] = ACTIONS(6087),
    [anon_sym_PIPE_GT] = ACTIONS(6087),
    [anon_sym_COLON] = ACTIONS(6089),
    [anon_sym_DOLLAR] = ACTIONS(6091),
    [anon_sym_AT] = ACTIONS(6091),
    [aux_sym__hex_literal_token1] = ACTIONS(5449),
    [sym__number_literal] = ACTIONS(5451),
    [anon_sym_SQUOTE] = ACTIONS(5449),
    [anon_sym_DQUOTE] = ACTIONS(5449),
    [sym_return] = ACTIONS(5451),
    [sym_next] = ACTIONS(5451),
    [sym_break] = ACTIONS(5451),
    [sym_true] = ACTIONS(5451),
    [sym_false] = ACTIONS(5451),
    [sym_null] = ACTIONS(5451),
    [sym_inf] = ACTIONS(5451),
    [sym_nan] = ACTIONS(5451),
    [anon_sym_NA] = ACTIONS(5451),
    [anon_sym_NA_integer_] = ACTIONS(5451),
    [anon_sym_NA_real_] = ACTIONS(5451),
    [anon_sym_NA_complex_] = ACTIONS(5451),
    [anon_sym_NA_character_] = ACTIONS(5451),
    [sym_dots] = ACTIONS(5451),
    [sym_dot_dot_i] = ACTIONS(5449),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5449),
    [sym__newline] = ACTIONS(5449),
    [sym__semicolon] = ACTIONS(5449),
    [sym__raw_string_literal] = ACTIONS(5449),
    [sym__external_open_parenthesis] = ACTIONS(6093),
    [sym__external_open_brace] = ACTIONS(5449),
    [sym__external_close_brace] = ACTIONS(5449),
    [sym__external_open_bracket] = ACTIONS(6095),
    [sym__external_open_bracket2] = ACTIONS(6097),
    [sym__external_close_bracket2] = ACTIONS(5449),
  },
  [1071] = {
    [sym_call_arguments] = STATE(2638),
    [sym_subset_arguments] = STATE(2647),
    [sym_subset2_arguments] = STATE(2650),
    [sym__open_parenthesis] = STATE(1537),
    [sym__open_bracket] = STATE(1534),
    [sym__open_bracket2] = STATE(1533),
    [sym_identifier] = ACTIONS(5447),
    [anon_sym_BSLASH] = ACTIONS(5445),
    [anon_sym_function] = ACTIONS(5447),
    [anon_sym_EQ] = ACTIONS(6055),
    [anon_sym_if] = ACTIONS(5447),
    [anon_sym_for] = ACTIONS(5447),
    [anon_sym_while] = ACTIONS(5447),
    [anon_sym_repeat] = ACTIONS(5447),
    [anon_sym_QMARK] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(6057),
    [anon_sym_BANG] = ACTIONS(5447),
    [anon_sym_PLUS] = ACTIONS(6059),
    [anon_sym_DASH] = ACTIONS(6061),
    [anon_sym_LT_DASH] = ACTIONS(6063),
    [anon_sym_LT_LT_DASH] = ACTIONS(6063),
    [anon_sym_COLON_EQ] = ACTIONS(6063),
    [anon_sym_DASH_GT] = ACTIONS(6065),
    [anon_sym_DASH_GT_GT] = ACTIONS(6067),
    [anon_sym_PIPE] = ACTIONS(6069),
    [anon_sym_AMP] = ACTIONS(6071),
    [anon_sym_PIPE_PIPE] = ACTIONS(6073),
    [anon_sym_AMP_AMP] = ACTIONS(6075),
    [anon_sym_LT] = ACTIONS(6077),
    [anon_sym_LT_EQ] = ACTIONS(6079),
    [anon_sym_GT] = ACTIONS(6077),
    [anon_sym_GT_EQ] = ACTIONS(6079),
    [anon_sym_EQ_EQ] = ACTIONS(6079),
    [anon_sym_BANG_EQ] = ACTIONS(6079),
    [anon_sym_STAR] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6083),
    [anon_sym_STAR_STAR] = ACTIONS(6085),
    [anon_sym_CARET] = ACTIONS(6085),
    [aux_sym_binary_operator_token1] = ACTIONS(6087),
    [anon_sym_PIPE_GT] = ACTIONS(6087),
    [anon_sym_COLON] = ACTIONS(6089),
    [anon_sym_DOLLAR] = ACTIONS(6091),
    [anon_sym_AT] = ACTIONS(6091),
    [aux_sym__hex_literal_token1] = ACTIONS(5445),
    [sym__number_literal] = ACTIONS(5447),
    [anon_sym_SQUOTE] = ACTIONS(5445),
    [anon_sym_DQUOTE] = ACTIONS(5445),
    [sym_return] = ACTIONS(5447),
    [sym_next] = ACTIONS(5447),
    [sym_break] = ACTIONS(5447),
    [sym_true] = ACTIONS(5447),
    [sym_false] = ACTIONS(5447),
    [sym_null] = ACTIONS(5447),
    [sym_inf] = ACTIONS(5447),
    [sym_nan] = ACTIONS(5447),
    [anon_sym_NA] = ACTIONS(5447),
    [anon_sym_NA_integer_] = ACTIONS(5447),
    [anon_sym_NA_real_] = ACTIONS(5447),
    [anon_sym_NA_complex_] = ACTIONS(5447),
    [anon_sym_NA_character_] = ACTIONS(5447),
    [sym_dots] = ACTIONS(5447),
    [sym_dot_dot_i] = ACTIONS(5445),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5445),
    [sym__newline] = ACTIONS(5445),
    [sym__semicolon] = ACTIONS(5445),
    [sym__raw_string_literal] = ACTIONS(5445),
    [sym__external_open_parenthesis] = ACTIONS(6093),
    [sym__external_open_brace] = ACTIONS(5445),
    [sym__external_close_brace] = ACTIONS(5445),
    [sym__external_open_bracket] = ACTIONS(6095),
    [sym__external_open_bracket2] = ACTIONS(6097),
    [sym__external_close_bracket2] = ACTIONS(5445),
  },
  [1072] = {
    [sym_call_arguments] = STATE(2595),
    [sym_subset_arguments] = STATE(2594),
    [sym_subset2_arguments] = STATE(2592),
    [sym__open_parenthesis] = STATE(1423),
    [sym__open_bracket] = STATE(1419),
    [sym__open_bracket2] = STATE(1415),
    [ts_builtin_sym_end] = ACTIONS(5327),
    [sym_identifier] = ACTIONS(5325),
    [anon_sym_BSLASH] = ACTIONS(5327),
    [anon_sym_function] = ACTIONS(5325),
    [anon_sym_EQ] = ACTIONS(5727),
    [anon_sym_if] = ACTIONS(5325),
    [anon_sym_for] = ACTIONS(5325),
    [anon_sym_while] = ACTIONS(5325),
    [anon_sym_repeat] = ACTIONS(5325),
    [anon_sym_QMARK] = ACTIONS(6099),
    [anon_sym_TILDE] = ACTIONS(5729),
    [anon_sym_BANG] = ACTIONS(5325),
    [anon_sym_PLUS] = ACTIONS(5731),
    [anon_sym_DASH] = ACTIONS(5733),
    [anon_sym_LT_DASH] = ACTIONS(5735),
    [anon_sym_LT_LT_DASH] = ACTIONS(5735),
    [anon_sym_COLON_EQ] = ACTIONS(5735),
    [anon_sym_DASH_GT] = ACTIONS(5737),
    [anon_sym_DASH_GT_GT] = ACTIONS(5739),
    [anon_sym_PIPE] = ACTIONS(5741),
    [anon_sym_AMP] = ACTIONS(5743),
    [anon_sym_PIPE_PIPE] = ACTIONS(5745),
    [anon_sym_AMP_AMP] = ACTIONS(5747),
    [anon_sym_LT] = ACTIONS(5749),
    [anon_sym_LT_EQ] = ACTIONS(5751),
    [anon_sym_GT] = ACTIONS(5749),
    [anon_sym_GT_EQ] = ACTIONS(5751),
    [anon_sym_EQ_EQ] = ACTIONS(5751),
    [anon_sym_BANG_EQ] = ACTIONS(5751),
    [anon_sym_STAR] = ACTIONS(5753),
    [anon_sym_SLASH] = ACTIONS(5755),
    [anon_sym_STAR_STAR] = ACTIONS(5757),
    [anon_sym_CARET] = ACTIONS(5757),
    [aux_sym_binary_operator_token1] = ACTIONS(5759),
    [anon_sym_PIPE_GT] = ACTIONS(5759),
    [anon_sym_COLON] = ACTIONS(5761),
    [anon_sym_DOLLAR] = ACTIONS(5763),
    [anon_sym_AT] = ACTIONS(5763),
    [aux_sym__hex_literal_token1] = ACTIONS(5327),
    [sym__number_literal] = ACTIONS(5325),
    [anon_sym_SQUOTE] = ACTIONS(5327),
    [anon_sym_DQUOTE] = ACTIONS(5327),
    [sym_return] = ACTIONS(5325),
    [sym_next] = ACTIONS(5325),
    [sym_break] = ACTIONS(5325),
    [sym_true] = ACTIONS(5325),
    [sym_false] = ACTIONS(5325),
    [sym_null] = ACTIONS(5325),
    [sym_inf] = ACTIONS(5325),
    [sym_nan] = ACTIONS(5325),
    [anon_sym_NA] = ACTIONS(5325),
    [anon_sym_NA_integer_] = ACTIONS(5325),
    [anon_sym_NA_real_] = ACTIONS(5325),
    [anon_sym_NA_complex_] = ACTIONS(5325),
    [anon_sym_NA_character_] = ACTIONS(5325),
    [sym_dots] = ACTIONS(5325),
    [sym_dot_dot_i] = ACTIONS(5327),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5327),
    [sym__semicolon] = ACTIONS(5327),
    [sym__raw_string_literal] = ACTIONS(5327),
    [sym__external_else] = ACTIONS(5327),
    [sym__external_open_parenthesis] = ACTIONS(5767),
    [sym__external_open_brace] = ACTIONS(5327),
    [sym__external_close_brace] = ACTIONS(5327),
    [sym__external_open_bracket] = ACTIONS(5769),
    [sym__external_open_bracket2] = ACTIONS(5771),
  },
  [1073] = {
    [sym_call_arguments] = STATE(2595),
    [sym_subset_arguments] = STATE(2594),
    [sym_subset2_arguments] = STATE(2592),
    [sym__open_parenthesis] = STATE(1423),
    [sym__open_bracket] = STATE(1419),
    [sym__open_bracket2] = STATE(1415),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5731),
    [anon_sym_DASH] = ACTIONS(5733),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5753),
    [anon_sym_SLASH] = ACTIONS(5755),
    [anon_sym_STAR_STAR] = ACTIONS(5757),
    [anon_sym_CARET] = ACTIONS(5757),
    [aux_sym_binary_operator_token1] = ACTIONS(5759),
    [anon_sym_PIPE_GT] = ACTIONS(5759),
    [anon_sym_COLON] = ACTIONS(5761),
    [anon_sym_DOLLAR] = ACTIONS(5763),
    [anon_sym_AT] = ACTIONS(5763),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5767),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5769),
    [sym__external_open_bracket2] = ACTIONS(5771),
  },
  [1074] = {
    [sym_call_arguments] = STATE(2638),
    [sym_subset_arguments] = STATE(2647),
    [sym_subset2_arguments] = STATE(2650),
    [sym__open_parenthesis] = STATE(1537),
    [sym__open_bracket] = STATE(1534),
    [sym__open_bracket2] = STATE(1533),
    [sym_identifier] = ACTIONS(5443),
    [anon_sym_BSLASH] = ACTIONS(5441),
    [anon_sym_function] = ACTIONS(5443),
    [anon_sym_EQ] = ACTIONS(6055),
    [anon_sym_if] = ACTIONS(5443),
    [anon_sym_for] = ACTIONS(5443),
    [anon_sym_while] = ACTIONS(5443),
    [anon_sym_repeat] = ACTIONS(5443),
    [anon_sym_QMARK] = ACTIONS(5441),
    [anon_sym_TILDE] = ACTIONS(6057),
    [anon_sym_BANG] = ACTIONS(5443),
    [anon_sym_PLUS] = ACTIONS(6059),
    [anon_sym_DASH] = ACTIONS(6061),
    [anon_sym_LT_DASH] = ACTIONS(6063),
    [anon_sym_LT_LT_DASH] = ACTIONS(6063),
    [anon_sym_COLON_EQ] = ACTIONS(6063),
    [anon_sym_DASH_GT] = ACTIONS(6065),
    [anon_sym_DASH_GT_GT] = ACTIONS(6067),
    [anon_sym_PIPE] = ACTIONS(6069),
    [anon_sym_AMP] = ACTIONS(6071),
    [anon_sym_PIPE_PIPE] = ACTIONS(6073),
    [anon_sym_AMP_AMP] = ACTIONS(6075),
    [anon_sym_LT] = ACTIONS(6077),
    [anon_sym_LT_EQ] = ACTIONS(6079),
    [anon_sym_GT] = ACTIONS(6077),
    [anon_sym_GT_EQ] = ACTIONS(6079),
    [anon_sym_EQ_EQ] = ACTIONS(6079),
    [anon_sym_BANG_EQ] = ACTIONS(6079),
    [anon_sym_STAR] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6083),
    [anon_sym_STAR_STAR] = ACTIONS(6085),
    [anon_sym_CARET] = ACTIONS(6085),
    [aux_sym_binary_operator_token1] = ACTIONS(6087),
    [anon_sym_PIPE_GT] = ACTIONS(6087),
    [anon_sym_COLON] = ACTIONS(6089),
    [anon_sym_DOLLAR] = ACTIONS(6091),
    [anon_sym_AT] = ACTIONS(6091),
    [aux_sym__hex_literal_token1] = ACTIONS(5441),
    [sym__number_literal] = ACTIONS(5443),
    [anon_sym_SQUOTE] = ACTIONS(5441),
    [anon_sym_DQUOTE] = ACTIONS(5441),
    [sym_return] = ACTIONS(5443),
    [sym_next] = ACTIONS(5443),
    [sym_break] = ACTIONS(5443),
    [sym_true] = ACTIONS(5443),
    [sym_false] = ACTIONS(5443),
    [sym_null] = ACTIONS(5443),
    [sym_inf] = ACTIONS(5443),
    [sym_nan] = ACTIONS(5443),
    [anon_sym_NA] = ACTIONS(5443),
    [anon_sym_NA_integer_] = ACTIONS(5443),
    [anon_sym_NA_real_] = ACTIONS(5443),
    [anon_sym_NA_complex_] = ACTIONS(5443),
    [anon_sym_NA_character_] = ACTIONS(5443),
    [sym_dots] = ACTIONS(5443),
    [sym_dot_dot_i] = ACTIONS(5441),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5441),
    [sym__newline] = ACTIONS(5441),
    [sym__semicolon] = ACTIONS(5441),
    [sym__raw_string_literal] = ACTIONS(5441),
    [sym__external_open_parenthesis] = ACTIONS(6093),
    [sym__external_open_brace] = ACTIONS(5441),
    [sym__external_close_brace] = ACTIONS(5441),
    [sym__external_open_bracket] = ACTIONS(6095),
    [sym__external_open_bracket2] = ACTIONS(6097),
    [sym__external_close_bracket2] = ACTIONS(5441),
  },
  [1075] = {
    [sym_call_arguments] = STATE(2638),
    [sym_subset_arguments] = STATE(2647),
    [sym_subset2_arguments] = STATE(2650),
    [sym__open_parenthesis] = STATE(1537),
    [sym__open_bracket] = STATE(1534),
    [sym__open_bracket2] = STATE(1533),
    [sym_identifier] = ACTIONS(5439),
    [anon_sym_BSLASH] = ACTIONS(5437),
    [anon_sym_function] = ACTIONS(5439),
    [anon_sym_EQ] = ACTIONS(6055),
    [anon_sym_if] = ACTIONS(5439),
    [anon_sym_for] = ACTIONS(5439),
    [anon_sym_while] = ACTIONS(5439),
    [anon_sym_repeat] = ACTIONS(5439),
    [anon_sym_QMARK] = ACTIONS(5437),
    [anon_sym_TILDE] = ACTIONS(6057),
    [anon_sym_BANG] = ACTIONS(5439),
    [anon_sym_PLUS] = ACTIONS(6059),
    [anon_sym_DASH] = ACTIONS(6061),
    [anon_sym_LT_DASH] = ACTIONS(6063),
    [anon_sym_LT_LT_DASH] = ACTIONS(6063),
    [anon_sym_COLON_EQ] = ACTIONS(6063),
    [anon_sym_DASH_GT] = ACTIONS(6065),
    [anon_sym_DASH_GT_GT] = ACTIONS(6067),
    [anon_sym_PIPE] = ACTIONS(6069),
    [anon_sym_AMP] = ACTIONS(6071),
    [anon_sym_PIPE_PIPE] = ACTIONS(6073),
    [anon_sym_AMP_AMP] = ACTIONS(6075),
    [anon_sym_LT] = ACTIONS(6077),
    [anon_sym_LT_EQ] = ACTIONS(6079),
    [anon_sym_GT] = ACTIONS(6077),
    [anon_sym_GT_EQ] = ACTIONS(6079),
    [anon_sym_EQ_EQ] = ACTIONS(6079),
    [anon_sym_BANG_EQ] = ACTIONS(6079),
    [anon_sym_STAR] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6083),
    [anon_sym_STAR_STAR] = ACTIONS(6085),
    [anon_sym_CARET] = ACTIONS(6085),
    [aux_sym_binary_operator_token1] = ACTIONS(6087),
    [anon_sym_PIPE_GT] = ACTIONS(6087),
    [anon_sym_COLON] = ACTIONS(6089),
    [anon_sym_DOLLAR] = ACTIONS(6091),
    [anon_sym_AT] = ACTIONS(6091),
    [aux_sym__hex_literal_token1] = ACTIONS(5437),
    [sym__number_literal] = ACTIONS(5439),
    [anon_sym_SQUOTE] = ACTIONS(5437),
    [anon_sym_DQUOTE] = ACTIONS(5437),
    [sym_return] = ACTIONS(5439),
    [sym_next] = ACTIONS(5439),
    [sym_break] = ACTIONS(5439),
    [sym_true] = ACTIONS(5439),
    [sym_false] = ACTIONS(5439),
    [sym_null] = ACTIONS(5439),
    [sym_inf] = ACTIONS(5439),
    [sym_nan] = ACTIONS(5439),
    [anon_sym_NA] = ACTIONS(5439),
    [anon_sym_NA_integer_] = ACTIONS(5439),
    [anon_sym_NA_real_] = ACTIONS(5439),
    [anon_sym_NA_complex_] = ACTIONS(5439),
    [anon_sym_NA_character_] = ACTIONS(5439),
    [sym_dots] = ACTIONS(5439),
    [sym_dot_dot_i] = ACTIONS(5437),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5437),
    [sym__newline] = ACTIONS(5437),
    [sym__semicolon] = ACTIONS(5437),
    [sym__raw_string_literal] = ACTIONS(5437),
    [sym__external_open_parenthesis] = ACTIONS(6093),
    [sym__external_open_brace] = ACTIONS(5437),
    [sym__external_close_brace] = ACTIONS(5437),
    [sym__external_open_bracket] = ACTIONS(6095),
    [sym__external_open_bracket2] = ACTIONS(6097),
    [sym__external_close_bracket2] = ACTIONS(5437),
  },
  [1076] = {
    [sym_call_arguments] = STATE(2638),
    [sym_subset_arguments] = STATE(2647),
    [sym_subset2_arguments] = STATE(2650),
    [sym__open_parenthesis] = STATE(1537),
    [sym__open_bracket] = STATE(1534),
    [sym__open_bracket2] = STATE(1533),
    [sym_identifier] = ACTIONS(5435),
    [anon_sym_BSLASH] = ACTIONS(5433),
    [anon_sym_function] = ACTIONS(5435),
    [anon_sym_EQ] = ACTIONS(6055),
    [anon_sym_if] = ACTIONS(5435),
    [anon_sym_for] = ACTIONS(5435),
    [anon_sym_while] = ACTIONS(5435),
    [anon_sym_repeat] = ACTIONS(5435),
    [anon_sym_QMARK] = ACTIONS(5433),
    [anon_sym_TILDE] = ACTIONS(6057),
    [anon_sym_BANG] = ACTIONS(5435),
    [anon_sym_PLUS] = ACTIONS(6059),
    [anon_sym_DASH] = ACTIONS(6061),
    [anon_sym_LT_DASH] = ACTIONS(6063),
    [anon_sym_LT_LT_DASH] = ACTIONS(6063),
    [anon_sym_COLON_EQ] = ACTIONS(6063),
    [anon_sym_DASH_GT] = ACTIONS(6065),
    [anon_sym_DASH_GT_GT] = ACTIONS(6067),
    [anon_sym_PIPE] = ACTIONS(6069),
    [anon_sym_AMP] = ACTIONS(6071),
    [anon_sym_PIPE_PIPE] = ACTIONS(6073),
    [anon_sym_AMP_AMP] = ACTIONS(6075),
    [anon_sym_LT] = ACTIONS(6077),
    [anon_sym_LT_EQ] = ACTIONS(6079),
    [anon_sym_GT] = ACTIONS(6077),
    [anon_sym_GT_EQ] = ACTIONS(6079),
    [anon_sym_EQ_EQ] = ACTIONS(6079),
    [anon_sym_BANG_EQ] = ACTIONS(6079),
    [anon_sym_STAR] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6083),
    [anon_sym_STAR_STAR] = ACTIONS(6085),
    [anon_sym_CARET] = ACTIONS(6085),
    [aux_sym_binary_operator_token1] = ACTIONS(6087),
    [anon_sym_PIPE_GT] = ACTIONS(6087),
    [anon_sym_COLON] = ACTIONS(6089),
    [anon_sym_DOLLAR] = ACTIONS(6091),
    [anon_sym_AT] = ACTIONS(6091),
    [aux_sym__hex_literal_token1] = ACTIONS(5433),
    [sym__number_literal] = ACTIONS(5435),
    [anon_sym_SQUOTE] = ACTIONS(5433),
    [anon_sym_DQUOTE] = ACTIONS(5433),
    [sym_return] = ACTIONS(5435),
    [sym_next] = ACTIONS(5435),
    [sym_break] = ACTIONS(5435),
    [sym_true] = ACTIONS(5435),
    [sym_false] = ACTIONS(5435),
    [sym_null] = ACTIONS(5435),
    [sym_inf] = ACTIONS(5435),
    [sym_nan] = ACTIONS(5435),
    [anon_sym_NA] = ACTIONS(5435),
    [anon_sym_NA_integer_] = ACTIONS(5435),
    [anon_sym_NA_real_] = ACTIONS(5435),
    [anon_sym_NA_complex_] = ACTIONS(5435),
    [anon_sym_NA_character_] = ACTIONS(5435),
    [sym_dots] = ACTIONS(5435),
    [sym_dot_dot_i] = ACTIONS(5433),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5433),
    [sym__newline] = ACTIONS(5433),
    [sym__semicolon] = ACTIONS(5433),
    [sym__raw_string_literal] = ACTIONS(5433),
    [sym__external_open_parenthesis] = ACTIONS(6093),
    [sym__external_open_brace] = ACTIONS(5433),
    [sym__external_close_brace] = ACTIONS(5433),
    [sym__external_open_bracket] = ACTIONS(6095),
    [sym__external_open_bracket2] = ACTIONS(6097),
    [sym__external_close_bracket2] = ACTIONS(5433),
  },
  [1077] = {
    [sym_call_arguments] = STATE(2595),
    [sym_subset_arguments] = STATE(2594),
    [sym_subset2_arguments] = STATE(2592),
    [sym__open_parenthesis] = STATE(1423),
    [sym__open_bracket] = STATE(1419),
    [sym__open_bracket2] = STATE(1415),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(5757),
    [anon_sym_CARET] = ACTIONS(5757),
    [aux_sym_binary_operator_token1] = ACTIONS(5759),
    [anon_sym_PIPE_GT] = ACTIONS(5759),
    [anon_sym_COLON] = ACTIONS(5761),
    [anon_sym_DOLLAR] = ACTIONS(5763),
    [anon_sym_AT] = ACTIONS(5763),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5767),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5769),
    [sym__external_open_bracket2] = ACTIONS(5771),
  },
  [1078] = {
    [sym_call_arguments] = STATE(2595),
    [sym_subset_arguments] = STATE(2594),
    [sym_subset2_arguments] = STATE(2592),
    [sym__open_parenthesis] = STATE(1423),
    [sym__open_bracket] = STATE(1419),
    [sym__open_bracket2] = STATE(1415),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(5757),
    [anon_sym_CARET] = ACTIONS(5757),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(5261),
    [anon_sym_DOLLAR] = ACTIONS(5763),
    [anon_sym_AT] = ACTIONS(5763),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5767),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5769),
    [sym__external_open_bracket2] = ACTIONS(5771),
  },
  [1079] = {
    [sym_call_arguments] = STATE(2638),
    [sym_subset_arguments] = STATE(2647),
    [sym_subset2_arguments] = STATE(2650),
    [sym__open_parenthesis] = STATE(1537),
    [sym__open_bracket] = STATE(1534),
    [sym__open_bracket2] = STATE(1533),
    [sym_identifier] = ACTIONS(5431),
    [anon_sym_BSLASH] = ACTIONS(5429),
    [anon_sym_function] = ACTIONS(5431),
    [anon_sym_EQ] = ACTIONS(6055),
    [anon_sym_if] = ACTIONS(5431),
    [anon_sym_for] = ACTIONS(5431),
    [anon_sym_while] = ACTIONS(5431),
    [anon_sym_repeat] = ACTIONS(5431),
    [anon_sym_QMARK] = ACTIONS(5429),
    [anon_sym_TILDE] = ACTIONS(6057),
    [anon_sym_BANG] = ACTIONS(5431),
    [anon_sym_PLUS] = ACTIONS(6059),
    [anon_sym_DASH] = ACTIONS(6061),
    [anon_sym_LT_DASH] = ACTIONS(6063),
    [anon_sym_LT_LT_DASH] = ACTIONS(6063),
    [anon_sym_COLON_EQ] = ACTIONS(6063),
    [anon_sym_DASH_GT] = ACTIONS(6065),
    [anon_sym_DASH_GT_GT] = ACTIONS(6067),
    [anon_sym_PIPE] = ACTIONS(6069),
    [anon_sym_AMP] = ACTIONS(6071),
    [anon_sym_PIPE_PIPE] = ACTIONS(6073),
    [anon_sym_AMP_AMP] = ACTIONS(6075),
    [anon_sym_LT] = ACTIONS(6077),
    [anon_sym_LT_EQ] = ACTIONS(6079),
    [anon_sym_GT] = ACTIONS(6077),
    [anon_sym_GT_EQ] = ACTIONS(6079),
    [anon_sym_EQ_EQ] = ACTIONS(6079),
    [anon_sym_BANG_EQ] = ACTIONS(6079),
    [anon_sym_STAR] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6083),
    [anon_sym_STAR_STAR] = ACTIONS(6085),
    [anon_sym_CARET] = ACTIONS(6085),
    [aux_sym_binary_operator_token1] = ACTIONS(6087),
    [anon_sym_PIPE_GT] = ACTIONS(6087),
    [anon_sym_COLON] = ACTIONS(6089),
    [anon_sym_DOLLAR] = ACTIONS(6091),
    [anon_sym_AT] = ACTIONS(6091),
    [aux_sym__hex_literal_token1] = ACTIONS(5429),
    [sym__number_literal] = ACTIONS(5431),
    [anon_sym_SQUOTE] = ACTIONS(5429),
    [anon_sym_DQUOTE] = ACTIONS(5429),
    [sym_return] = ACTIONS(5431),
    [sym_next] = ACTIONS(5431),
    [sym_break] = ACTIONS(5431),
    [sym_true] = ACTIONS(5431),
    [sym_false] = ACTIONS(5431),
    [sym_null] = ACTIONS(5431),
    [sym_inf] = ACTIONS(5431),
    [sym_nan] = ACTIONS(5431),
    [anon_sym_NA] = ACTIONS(5431),
    [anon_sym_NA_integer_] = ACTIONS(5431),
    [anon_sym_NA_real_] = ACTIONS(5431),
    [anon_sym_NA_complex_] = ACTIONS(5431),
    [anon_sym_NA_character_] = ACTIONS(5431),
    [sym_dots] = ACTIONS(5431),
    [sym_dot_dot_i] = ACTIONS(5429),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5429),
    [sym__newline] = ACTIONS(5429),
    [sym__semicolon] = ACTIONS(5429),
    [sym__raw_string_literal] = ACTIONS(5429),
    [sym__external_open_parenthesis] = ACTIONS(6093),
    [sym__external_open_brace] = ACTIONS(5429),
    [sym__external_close_brace] = ACTIONS(5429),
    [sym__external_open_bracket] = ACTIONS(6095),
    [sym__external_open_bracket2] = ACTIONS(6097),
    [sym__external_close_bracket2] = ACTIONS(5429),
  },
  [1080] = {
    [sym_call_arguments] = STATE(2595),
    [sym_subset_arguments] = STATE(2594),
    [sym_subset2_arguments] = STATE(2592),
    [sym__open_parenthesis] = STATE(1423),
    [sym__open_bracket] = STATE(1419),
    [sym__open_bracket2] = STATE(1415),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(5757),
    [anon_sym_CARET] = ACTIONS(5757),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(5761),
    [anon_sym_DOLLAR] = ACTIONS(5763),
    [anon_sym_AT] = ACTIONS(5763),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5767),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5769),
    [sym__external_open_bracket2] = ACTIONS(5771),
  },
  [1081] = {
    [sym_call_arguments] = STATE(2595),
    [sym_subset_arguments] = STATE(2594),
    [sym_subset2_arguments] = STATE(2592),
    [sym__open_parenthesis] = STATE(1423),
    [sym__open_bracket] = STATE(1419),
    [sym__open_bracket2] = STATE(1415),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(5757),
    [anon_sym_CARET] = ACTIONS(5757),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(5261),
    [anon_sym_DOLLAR] = ACTIONS(5763),
    [anon_sym_AT] = ACTIONS(5763),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5767),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5769),
    [sym__external_open_bracket2] = ACTIONS(5771),
  },
  [1082] = {
    [sym_call_arguments] = STATE(2595),
    [sym_subset_arguments] = STATE(2594),
    [sym_subset2_arguments] = STATE(2592),
    [sym__open_parenthesis] = STATE(1423),
    [sym__open_bracket] = STATE(1419),
    [sym__open_bracket2] = STATE(1415),
    [ts_builtin_sym_end] = ACTIONS(5413),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_BSLASH] = ACTIONS(5413),
    [anon_sym_function] = ACTIONS(5415),
    [anon_sym_EQ] = ACTIONS(5727),
    [anon_sym_if] = ACTIONS(5415),
    [anon_sym_for] = ACTIONS(5415),
    [anon_sym_while] = ACTIONS(5415),
    [anon_sym_repeat] = ACTIONS(5415),
    [anon_sym_QMARK] = ACTIONS(5413),
    [anon_sym_TILDE] = ACTIONS(5729),
    [anon_sym_BANG] = ACTIONS(5415),
    [anon_sym_PLUS] = ACTIONS(5731),
    [anon_sym_DASH] = ACTIONS(5733),
    [anon_sym_LT_DASH] = ACTIONS(5735),
    [anon_sym_LT_LT_DASH] = ACTIONS(5735),
    [anon_sym_COLON_EQ] = ACTIONS(5735),
    [anon_sym_DASH_GT] = ACTIONS(5737),
    [anon_sym_DASH_GT_GT] = ACTIONS(5739),
    [anon_sym_PIPE] = ACTIONS(5741),
    [anon_sym_AMP] = ACTIONS(5743),
    [anon_sym_PIPE_PIPE] = ACTIONS(5745),
    [anon_sym_AMP_AMP] = ACTIONS(5747),
    [anon_sym_LT] = ACTIONS(5749),
    [anon_sym_LT_EQ] = ACTIONS(5751),
    [anon_sym_GT] = ACTIONS(5749),
    [anon_sym_GT_EQ] = ACTIONS(5751),
    [anon_sym_EQ_EQ] = ACTIONS(5751),
    [anon_sym_BANG_EQ] = ACTIONS(5751),
    [anon_sym_STAR] = ACTIONS(5753),
    [anon_sym_SLASH] = ACTIONS(5755),
    [anon_sym_STAR_STAR] = ACTIONS(5757),
    [anon_sym_CARET] = ACTIONS(5757),
    [aux_sym_binary_operator_token1] = ACTIONS(5759),
    [anon_sym_PIPE_GT] = ACTIONS(5759),
    [anon_sym_COLON] = ACTIONS(5761),
    [anon_sym_DOLLAR] = ACTIONS(5763),
    [anon_sym_AT] = ACTIONS(5763),
    [aux_sym__hex_literal_token1] = ACTIONS(5413),
    [sym__number_literal] = ACTIONS(5415),
    [anon_sym_SQUOTE] = ACTIONS(5413),
    [anon_sym_DQUOTE] = ACTIONS(5413),
    [sym_return] = ACTIONS(5415),
    [sym_next] = ACTIONS(5415),
    [sym_break] = ACTIONS(5415),
    [sym_true] = ACTIONS(5415),
    [sym_false] = ACTIONS(5415),
    [sym_null] = ACTIONS(5415),
    [sym_inf] = ACTIONS(5415),
    [sym_nan] = ACTIONS(5415),
    [anon_sym_NA] = ACTIONS(5415),
    [anon_sym_NA_integer_] = ACTIONS(5415),
    [anon_sym_NA_real_] = ACTIONS(5415),
    [anon_sym_NA_complex_] = ACTIONS(5415),
    [anon_sym_NA_character_] = ACTIONS(5415),
    [sym_dots] = ACTIONS(5415),
    [sym_dot_dot_i] = ACTIONS(5413),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5413),
    [sym__semicolon] = ACTIONS(5413),
    [sym__raw_string_literal] = ACTIONS(5413),
    [sym__external_else] = ACTIONS(5413),
    [sym__external_open_parenthesis] = ACTIONS(5767),
    [sym__external_open_brace] = ACTIONS(5413),
    [sym__external_close_brace] = ACTIONS(5413),
    [sym__external_open_bracket] = ACTIONS(5769),
    [sym__external_open_bracket2] = ACTIONS(5771),
  },
  [1083] = {
    [sym_call_arguments] = STATE(2638),
    [sym_subset_arguments] = STATE(2647),
    [sym_subset2_arguments] = STATE(2650),
    [sym__open_parenthesis] = STATE(1537),
    [sym__open_bracket] = STATE(1534),
    [sym__open_bracket2] = STATE(1533),
    [sym_identifier] = ACTIONS(5427),
    [anon_sym_BSLASH] = ACTIONS(5425),
    [anon_sym_function] = ACTIONS(5427),
    [anon_sym_EQ] = ACTIONS(6055),
    [anon_sym_if] = ACTIONS(5427),
    [anon_sym_for] = ACTIONS(5427),
    [anon_sym_while] = ACTIONS(5427),
    [anon_sym_repeat] = ACTIONS(5427),
    [anon_sym_QMARK] = ACTIONS(5425),
    [anon_sym_TILDE] = ACTIONS(6057),
    [anon_sym_BANG] = ACTIONS(5427),
    [anon_sym_PLUS] = ACTIONS(6059),
    [anon_sym_DASH] = ACTIONS(6061),
    [anon_sym_LT_DASH] = ACTIONS(6063),
    [anon_sym_LT_LT_DASH] = ACTIONS(6063),
    [anon_sym_COLON_EQ] = ACTIONS(6063),
    [anon_sym_DASH_GT] = ACTIONS(6065),
    [anon_sym_DASH_GT_GT] = ACTIONS(6067),
    [anon_sym_PIPE] = ACTIONS(6069),
    [anon_sym_AMP] = ACTIONS(6071),
    [anon_sym_PIPE_PIPE] = ACTIONS(6073),
    [anon_sym_AMP_AMP] = ACTIONS(6075),
    [anon_sym_LT] = ACTIONS(6077),
    [anon_sym_LT_EQ] = ACTIONS(6079),
    [anon_sym_GT] = ACTIONS(6077),
    [anon_sym_GT_EQ] = ACTIONS(6079),
    [anon_sym_EQ_EQ] = ACTIONS(6079),
    [anon_sym_BANG_EQ] = ACTIONS(6079),
    [anon_sym_STAR] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6083),
    [anon_sym_STAR_STAR] = ACTIONS(6085),
    [anon_sym_CARET] = ACTIONS(6085),
    [aux_sym_binary_operator_token1] = ACTIONS(6087),
    [anon_sym_PIPE_GT] = ACTIONS(6087),
    [anon_sym_COLON] = ACTIONS(6089),
    [anon_sym_DOLLAR] = ACTIONS(6091),
    [anon_sym_AT] = ACTIONS(6091),
    [aux_sym__hex_literal_token1] = ACTIONS(5425),
    [sym__number_literal] = ACTIONS(5427),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_DQUOTE] = ACTIONS(5425),
    [sym_return] = ACTIONS(5427),
    [sym_next] = ACTIONS(5427),
    [sym_break] = ACTIONS(5427),
    [sym_true] = ACTIONS(5427),
    [sym_false] = ACTIONS(5427),
    [sym_null] = ACTIONS(5427),
    [sym_inf] = ACTIONS(5427),
    [sym_nan] = ACTIONS(5427),
    [anon_sym_NA] = ACTIONS(5427),
    [anon_sym_NA_integer_] = ACTIONS(5427),
    [anon_sym_NA_real_] = ACTIONS(5427),
    [anon_sym_NA_complex_] = ACTIONS(5427),
    [anon_sym_NA_character_] = ACTIONS(5427),
    [sym_dots] = ACTIONS(5427),
    [sym_dot_dot_i] = ACTIONS(5425),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5425),
    [sym__newline] = ACTIONS(5425),
    [sym__semicolon] = ACTIONS(5425),
    [sym__raw_string_literal] = ACTIONS(5425),
    [sym__external_open_parenthesis] = ACTIONS(6093),
    [sym__external_open_brace] = ACTIONS(5425),
    [sym__external_close_brace] = ACTIONS(5425),
    [sym__external_open_bracket] = ACTIONS(6095),
    [sym__external_open_bracket2] = ACTIONS(6097),
    [sym__external_close_bracket2] = ACTIONS(5425),
  },
  [1084] = {
    [sym_call_arguments] = STATE(2595),
    [sym_subset_arguments] = STATE(2594),
    [sym_subset2_arguments] = STATE(2592),
    [sym__open_parenthesis] = STATE(1423),
    [sym__open_bracket] = STATE(1419),
    [sym__open_bracket2] = STATE(1415),
    [ts_builtin_sym_end] = ACTIONS(5417),
    [sym_identifier] = ACTIONS(5419),
    [anon_sym_BSLASH] = ACTIONS(5417),
    [anon_sym_function] = ACTIONS(5419),
    [anon_sym_EQ] = ACTIONS(5727),
    [anon_sym_if] = ACTIONS(5419),
    [anon_sym_for] = ACTIONS(5419),
    [anon_sym_while] = ACTIONS(5419),
    [anon_sym_repeat] = ACTIONS(5419),
    [anon_sym_QMARK] = ACTIONS(5417),
    [anon_sym_TILDE] = ACTIONS(5729),
    [anon_sym_BANG] = ACTIONS(5419),
    [anon_sym_PLUS] = ACTIONS(5731),
    [anon_sym_DASH] = ACTIONS(5733),
    [anon_sym_LT_DASH] = ACTIONS(5735),
    [anon_sym_LT_LT_DASH] = ACTIONS(5735),
    [anon_sym_COLON_EQ] = ACTIONS(5735),
    [anon_sym_DASH_GT] = ACTIONS(5737),
    [anon_sym_DASH_GT_GT] = ACTIONS(5739),
    [anon_sym_PIPE] = ACTIONS(5741),
    [anon_sym_AMP] = ACTIONS(5743),
    [anon_sym_PIPE_PIPE] = ACTIONS(5745),
    [anon_sym_AMP_AMP] = ACTIONS(5747),
    [anon_sym_LT] = ACTIONS(5749),
    [anon_sym_LT_EQ] = ACTIONS(5751),
    [anon_sym_GT] = ACTIONS(5749),
    [anon_sym_GT_EQ] = ACTIONS(5751),
    [anon_sym_EQ_EQ] = ACTIONS(5751),
    [anon_sym_BANG_EQ] = ACTIONS(5751),
    [anon_sym_STAR] = ACTIONS(5753),
    [anon_sym_SLASH] = ACTIONS(5755),
    [anon_sym_STAR_STAR] = ACTIONS(5757),
    [anon_sym_CARET] = ACTIONS(5757),
    [aux_sym_binary_operator_token1] = ACTIONS(5759),
    [anon_sym_PIPE_GT] = ACTIONS(5759),
    [anon_sym_COLON] = ACTIONS(5761),
    [anon_sym_DOLLAR] = ACTIONS(5763),
    [anon_sym_AT] = ACTIONS(5763),
    [aux_sym__hex_literal_token1] = ACTIONS(5417),
    [sym__number_literal] = ACTIONS(5419),
    [anon_sym_SQUOTE] = ACTIONS(5417),
    [anon_sym_DQUOTE] = ACTIONS(5417),
    [sym_return] = ACTIONS(5419),
    [sym_next] = ACTIONS(5419),
    [sym_break] = ACTIONS(5419),
    [sym_true] = ACTIONS(5419),
    [sym_false] = ACTIONS(5419),
    [sym_null] = ACTIONS(5419),
    [sym_inf] = ACTIONS(5419),
    [sym_nan] = ACTIONS(5419),
    [anon_sym_NA] = ACTIONS(5419),
    [anon_sym_NA_integer_] = ACTIONS(5419),
    [anon_sym_NA_real_] = ACTIONS(5419),
    [anon_sym_NA_complex_] = ACTIONS(5419),
    [anon_sym_NA_character_] = ACTIONS(5419),
    [sym_dots] = ACTIONS(5419),
    [sym_dot_dot_i] = ACTIONS(5417),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5417),
    [sym__semicolon] = ACTIONS(5417),
    [sym__raw_string_literal] = ACTIONS(5417),
    [sym__external_else] = ACTIONS(5417),
    [sym__external_open_parenthesis] = ACTIONS(5767),
    [sym__external_open_brace] = ACTIONS(5417),
    [sym__external_close_brace] = ACTIONS(5417),
    [sym__external_open_bracket] = ACTIONS(5769),
    [sym__external_open_bracket2] = ACTIONS(5771),
  },
  [1085] = {
    [sym_call_arguments] = STATE(2638),
    [sym_subset_arguments] = STATE(2647),
    [sym_subset2_arguments] = STATE(2650),
    [sym__open_parenthesis] = STATE(1537),
    [sym__open_bracket] = STATE(1534),
    [sym__open_bracket2] = STATE(1533),
    [sym_identifier] = ACTIONS(5423),
    [anon_sym_BSLASH] = ACTIONS(5421),
    [anon_sym_function] = ACTIONS(5423),
    [anon_sym_EQ] = ACTIONS(6055),
    [anon_sym_if] = ACTIONS(5423),
    [anon_sym_for] = ACTIONS(5423),
    [anon_sym_while] = ACTIONS(5423),
    [anon_sym_repeat] = ACTIONS(5423),
    [anon_sym_QMARK] = ACTIONS(5421),
    [anon_sym_TILDE] = ACTIONS(6057),
    [anon_sym_BANG] = ACTIONS(5423),
    [anon_sym_PLUS] = ACTIONS(6059),
    [anon_sym_DASH] = ACTIONS(6061),
    [anon_sym_LT_DASH] = ACTIONS(6063),
    [anon_sym_LT_LT_DASH] = ACTIONS(6063),
    [anon_sym_COLON_EQ] = ACTIONS(6063),
    [anon_sym_DASH_GT] = ACTIONS(6065),
    [anon_sym_DASH_GT_GT] = ACTIONS(6067),
    [anon_sym_PIPE] = ACTIONS(6069),
    [anon_sym_AMP] = ACTIONS(6071),
    [anon_sym_PIPE_PIPE] = ACTIONS(6073),
    [anon_sym_AMP_AMP] = ACTIONS(6075),
    [anon_sym_LT] = ACTIONS(6077),
    [anon_sym_LT_EQ] = ACTIONS(6079),
    [anon_sym_GT] = ACTIONS(6077),
    [anon_sym_GT_EQ] = ACTIONS(6079),
    [anon_sym_EQ_EQ] = ACTIONS(6079),
    [anon_sym_BANG_EQ] = ACTIONS(6079),
    [anon_sym_STAR] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6083),
    [anon_sym_STAR_STAR] = ACTIONS(6085),
    [anon_sym_CARET] = ACTIONS(6085),
    [aux_sym_binary_operator_token1] = ACTIONS(6087),
    [anon_sym_PIPE_GT] = ACTIONS(6087),
    [anon_sym_COLON] = ACTIONS(6089),
    [anon_sym_DOLLAR] = ACTIONS(6091),
    [anon_sym_AT] = ACTIONS(6091),
    [aux_sym__hex_literal_token1] = ACTIONS(5421),
    [sym__number_literal] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5421),
    [anon_sym_DQUOTE] = ACTIONS(5421),
    [sym_return] = ACTIONS(5423),
    [sym_next] = ACTIONS(5423),
    [sym_break] = ACTIONS(5423),
    [sym_true] = ACTIONS(5423),
    [sym_false] = ACTIONS(5423),
    [sym_null] = ACTIONS(5423),
    [sym_inf] = ACTIONS(5423),
    [sym_nan] = ACTIONS(5423),
    [anon_sym_NA] = ACTIONS(5423),
    [anon_sym_NA_integer_] = ACTIONS(5423),
    [anon_sym_NA_real_] = ACTIONS(5423),
    [anon_sym_NA_complex_] = ACTIONS(5423),
    [anon_sym_NA_character_] = ACTIONS(5423),
    [sym_dots] = ACTIONS(5423),
    [sym_dot_dot_i] = ACTIONS(5421),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5421),
    [sym__newline] = ACTIONS(5421),
    [sym__semicolon] = ACTIONS(5421),
    [sym__raw_string_literal] = ACTIONS(5421),
    [sym__external_open_parenthesis] = ACTIONS(6093),
    [sym__external_open_brace] = ACTIONS(5421),
    [sym__external_close_brace] = ACTIONS(5421),
    [sym__external_open_bracket] = ACTIONS(6095),
    [sym__external_open_bracket2] = ACTIONS(6097),
    [sym__external_close_bracket2] = ACTIONS(5421),
  },
  [1086] = {
    [sym_call_arguments] = STATE(2638),
    [sym_subset_arguments] = STATE(2647),
    [sym_subset2_arguments] = STATE(2650),
    [sym__open_parenthesis] = STATE(1537),
    [sym__open_bracket] = STATE(1534),
    [sym__open_bracket2] = STATE(1533),
    [sym_identifier] = ACTIONS(5419),
    [anon_sym_BSLASH] = ACTIONS(5417),
    [anon_sym_function] = ACTIONS(5419),
    [anon_sym_EQ] = ACTIONS(6055),
    [anon_sym_if] = ACTIONS(5419),
    [anon_sym_for] = ACTIONS(5419),
    [anon_sym_while] = ACTIONS(5419),
    [anon_sym_repeat] = ACTIONS(5419),
    [anon_sym_QMARK] = ACTIONS(5417),
    [anon_sym_TILDE] = ACTIONS(6057),
    [anon_sym_BANG] = ACTIONS(5419),
    [anon_sym_PLUS] = ACTIONS(6059),
    [anon_sym_DASH] = ACTIONS(6061),
    [anon_sym_LT_DASH] = ACTIONS(6063),
    [anon_sym_LT_LT_DASH] = ACTIONS(6063),
    [anon_sym_COLON_EQ] = ACTIONS(6063),
    [anon_sym_DASH_GT] = ACTIONS(6065),
    [anon_sym_DASH_GT_GT] = ACTIONS(6067),
    [anon_sym_PIPE] = ACTIONS(6069),
    [anon_sym_AMP] = ACTIONS(6071),
    [anon_sym_PIPE_PIPE] = ACTIONS(6073),
    [anon_sym_AMP_AMP] = ACTIONS(6075),
    [anon_sym_LT] = ACTIONS(6077),
    [anon_sym_LT_EQ] = ACTIONS(6079),
    [anon_sym_GT] = ACTIONS(6077),
    [anon_sym_GT_EQ] = ACTIONS(6079),
    [anon_sym_EQ_EQ] = ACTIONS(6079),
    [anon_sym_BANG_EQ] = ACTIONS(6079),
    [anon_sym_STAR] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6083),
    [anon_sym_STAR_STAR] = ACTIONS(6085),
    [anon_sym_CARET] = ACTIONS(6085),
    [aux_sym_binary_operator_token1] = ACTIONS(6087),
    [anon_sym_PIPE_GT] = ACTIONS(6087),
    [anon_sym_COLON] = ACTIONS(6089),
    [anon_sym_DOLLAR] = ACTIONS(6091),
    [anon_sym_AT] = ACTIONS(6091),
    [aux_sym__hex_literal_token1] = ACTIONS(5417),
    [sym__number_literal] = ACTIONS(5419),
    [anon_sym_SQUOTE] = ACTIONS(5417),
    [anon_sym_DQUOTE] = ACTIONS(5417),
    [sym_return] = ACTIONS(5419),
    [sym_next] = ACTIONS(5419),
    [sym_break] = ACTIONS(5419),
    [sym_true] = ACTIONS(5419),
    [sym_false] = ACTIONS(5419),
    [sym_null] = ACTIONS(5419),
    [sym_inf] = ACTIONS(5419),
    [sym_nan] = ACTIONS(5419),
    [anon_sym_NA] = ACTIONS(5419),
    [anon_sym_NA_integer_] = ACTIONS(5419),
    [anon_sym_NA_real_] = ACTIONS(5419),
    [anon_sym_NA_complex_] = ACTIONS(5419),
    [anon_sym_NA_character_] = ACTIONS(5419),
    [sym_dots] = ACTIONS(5419),
    [sym_dot_dot_i] = ACTIONS(5417),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5417),
    [sym__newline] = ACTIONS(5417),
    [sym__semicolon] = ACTIONS(5417),
    [sym__raw_string_literal] = ACTIONS(5417),
    [sym__external_open_parenthesis] = ACTIONS(6093),
    [sym__external_open_brace] = ACTIONS(5417),
    [sym__external_close_brace] = ACTIONS(5417),
    [sym__external_open_bracket] = ACTIONS(6095),
    [sym__external_open_bracket2] = ACTIONS(6097),
    [sym__external_close_bracket2] = ACTIONS(5417),
  },
  [1087] = {
    [sym_call_arguments] = STATE(2595),
    [sym_subset_arguments] = STATE(2594),
    [sym_subset2_arguments] = STATE(2592),
    [sym__open_parenthesis] = STATE(1423),
    [sym__open_bracket] = STATE(1419),
    [sym__open_bracket2] = STATE(1415),
    [ts_builtin_sym_end] = ACTIONS(5421),
    [sym_identifier] = ACTIONS(5423),
    [anon_sym_BSLASH] = ACTIONS(5421),
    [anon_sym_function] = ACTIONS(5423),
    [anon_sym_EQ] = ACTIONS(5727),
    [anon_sym_if] = ACTIONS(5423),
    [anon_sym_for] = ACTIONS(5423),
    [anon_sym_while] = ACTIONS(5423),
    [anon_sym_repeat] = ACTIONS(5423),
    [anon_sym_QMARK] = ACTIONS(5421),
    [anon_sym_TILDE] = ACTIONS(5729),
    [anon_sym_BANG] = ACTIONS(5423),
    [anon_sym_PLUS] = ACTIONS(5731),
    [anon_sym_DASH] = ACTIONS(5733),
    [anon_sym_LT_DASH] = ACTIONS(5735),
    [anon_sym_LT_LT_DASH] = ACTIONS(5735),
    [anon_sym_COLON_EQ] = ACTIONS(5735),
    [anon_sym_DASH_GT] = ACTIONS(5737),
    [anon_sym_DASH_GT_GT] = ACTIONS(5739),
    [anon_sym_PIPE] = ACTIONS(5741),
    [anon_sym_AMP] = ACTIONS(5743),
    [anon_sym_PIPE_PIPE] = ACTIONS(5745),
    [anon_sym_AMP_AMP] = ACTIONS(5747),
    [anon_sym_LT] = ACTIONS(5749),
    [anon_sym_LT_EQ] = ACTIONS(5751),
    [anon_sym_GT] = ACTIONS(5749),
    [anon_sym_GT_EQ] = ACTIONS(5751),
    [anon_sym_EQ_EQ] = ACTIONS(5751),
    [anon_sym_BANG_EQ] = ACTIONS(5751),
    [anon_sym_STAR] = ACTIONS(5753),
    [anon_sym_SLASH] = ACTIONS(5755),
    [anon_sym_STAR_STAR] = ACTIONS(5757),
    [anon_sym_CARET] = ACTIONS(5757),
    [aux_sym_binary_operator_token1] = ACTIONS(5759),
    [anon_sym_PIPE_GT] = ACTIONS(5759),
    [anon_sym_COLON] = ACTIONS(5761),
    [anon_sym_DOLLAR] = ACTIONS(5763),
    [anon_sym_AT] = ACTIONS(5763),
    [aux_sym__hex_literal_token1] = ACTIONS(5421),
    [sym__number_literal] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5421),
    [anon_sym_DQUOTE] = ACTIONS(5421),
    [sym_return] = ACTIONS(5423),
    [sym_next] = ACTIONS(5423),
    [sym_break] = ACTIONS(5423),
    [sym_true] = ACTIONS(5423),
    [sym_false] = ACTIONS(5423),
    [sym_null] = ACTIONS(5423),
    [sym_inf] = ACTIONS(5423),
    [sym_nan] = ACTIONS(5423),
    [anon_sym_NA] = ACTIONS(5423),
    [anon_sym_NA_integer_] = ACTIONS(5423),
    [anon_sym_NA_real_] = ACTIONS(5423),
    [anon_sym_NA_complex_] = ACTIONS(5423),
    [anon_sym_NA_character_] = ACTIONS(5423),
    [sym_dots] = ACTIONS(5423),
    [sym_dot_dot_i] = ACTIONS(5421),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5421),
    [sym__semicolon] = ACTIONS(5421),
    [sym__raw_string_literal] = ACTIONS(5421),
    [sym__external_else] = ACTIONS(5421),
    [sym__external_open_parenthesis] = ACTIONS(5767),
    [sym__external_open_brace] = ACTIONS(5421),
    [sym__external_close_brace] = ACTIONS(5421),
    [sym__external_open_bracket] = ACTIONS(5769),
    [sym__external_open_bracket2] = ACTIONS(5771),
  },
  [1088] = {
    [sym_call_arguments] = STATE(2595),
    [sym_subset_arguments] = STATE(2594),
    [sym_subset2_arguments] = STATE(2592),
    [sym__open_parenthesis] = STATE(1423),
    [sym__open_bracket] = STATE(1419),
    [sym__open_bracket2] = STATE(1415),
    [ts_builtin_sym_end] = ACTIONS(5425),
    [sym_identifier] = ACTIONS(5427),
    [anon_sym_BSLASH] = ACTIONS(5425),
    [anon_sym_function] = ACTIONS(5427),
    [anon_sym_EQ] = ACTIONS(5727),
    [anon_sym_if] = ACTIONS(5427),
    [anon_sym_for] = ACTIONS(5427),
    [anon_sym_while] = ACTIONS(5427),
    [anon_sym_repeat] = ACTIONS(5427),
    [anon_sym_QMARK] = ACTIONS(5425),
    [anon_sym_TILDE] = ACTIONS(5729),
    [anon_sym_BANG] = ACTIONS(5427),
    [anon_sym_PLUS] = ACTIONS(5731),
    [anon_sym_DASH] = ACTIONS(5733),
    [anon_sym_LT_DASH] = ACTIONS(5735),
    [anon_sym_LT_LT_DASH] = ACTIONS(5735),
    [anon_sym_COLON_EQ] = ACTIONS(5735),
    [anon_sym_DASH_GT] = ACTIONS(5737),
    [anon_sym_DASH_GT_GT] = ACTIONS(5739),
    [anon_sym_PIPE] = ACTIONS(5741),
    [anon_sym_AMP] = ACTIONS(5743),
    [anon_sym_PIPE_PIPE] = ACTIONS(5745),
    [anon_sym_AMP_AMP] = ACTIONS(5747),
    [anon_sym_LT] = ACTIONS(5749),
    [anon_sym_LT_EQ] = ACTIONS(5751),
    [anon_sym_GT] = ACTIONS(5749),
    [anon_sym_GT_EQ] = ACTIONS(5751),
    [anon_sym_EQ_EQ] = ACTIONS(5751),
    [anon_sym_BANG_EQ] = ACTIONS(5751),
    [anon_sym_STAR] = ACTIONS(5753),
    [anon_sym_SLASH] = ACTIONS(5755),
    [anon_sym_STAR_STAR] = ACTIONS(5757),
    [anon_sym_CARET] = ACTIONS(5757),
    [aux_sym_binary_operator_token1] = ACTIONS(5759),
    [anon_sym_PIPE_GT] = ACTIONS(5759),
    [anon_sym_COLON] = ACTIONS(5761),
    [anon_sym_DOLLAR] = ACTIONS(5763),
    [anon_sym_AT] = ACTIONS(5763),
    [aux_sym__hex_literal_token1] = ACTIONS(5425),
    [sym__number_literal] = ACTIONS(5427),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_DQUOTE] = ACTIONS(5425),
    [sym_return] = ACTIONS(5427),
    [sym_next] = ACTIONS(5427),
    [sym_break] = ACTIONS(5427),
    [sym_true] = ACTIONS(5427),
    [sym_false] = ACTIONS(5427),
    [sym_null] = ACTIONS(5427),
    [sym_inf] = ACTIONS(5427),
    [sym_nan] = ACTIONS(5427),
    [anon_sym_NA] = ACTIONS(5427),
    [anon_sym_NA_integer_] = ACTIONS(5427),
    [anon_sym_NA_real_] = ACTIONS(5427),
    [anon_sym_NA_complex_] = ACTIONS(5427),
    [anon_sym_NA_character_] = ACTIONS(5427),
    [sym_dots] = ACTIONS(5427),
    [sym_dot_dot_i] = ACTIONS(5425),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5425),
    [sym__semicolon] = ACTIONS(5425),
    [sym__raw_string_literal] = ACTIONS(5425),
    [sym__external_else] = ACTIONS(5425),
    [sym__external_open_parenthesis] = ACTIONS(5767),
    [sym__external_open_brace] = ACTIONS(5425),
    [sym__external_close_brace] = ACTIONS(5425),
    [sym__external_open_bracket] = ACTIONS(5769),
    [sym__external_open_bracket2] = ACTIONS(5771),
  },
  [1089] = {
    [sym_call_arguments] = STATE(2595),
    [sym_subset_arguments] = STATE(2594),
    [sym_subset2_arguments] = STATE(2592),
    [sym__open_parenthesis] = STATE(1423),
    [sym__open_bracket] = STATE(1419),
    [sym__open_bracket2] = STATE(1415),
    [ts_builtin_sym_end] = ACTIONS(5429),
    [sym_identifier] = ACTIONS(5431),
    [anon_sym_BSLASH] = ACTIONS(5429),
    [anon_sym_function] = ACTIONS(5431),
    [anon_sym_EQ] = ACTIONS(5727),
    [anon_sym_if] = ACTIONS(5431),
    [anon_sym_for] = ACTIONS(5431),
    [anon_sym_while] = ACTIONS(5431),
    [anon_sym_repeat] = ACTIONS(5431),
    [anon_sym_QMARK] = ACTIONS(5429),
    [anon_sym_TILDE] = ACTIONS(5729),
    [anon_sym_BANG] = ACTIONS(5431),
    [anon_sym_PLUS] = ACTIONS(5731),
    [anon_sym_DASH] = ACTIONS(5733),
    [anon_sym_LT_DASH] = ACTIONS(5735),
    [anon_sym_LT_LT_DASH] = ACTIONS(5735),
    [anon_sym_COLON_EQ] = ACTIONS(5735),
    [anon_sym_DASH_GT] = ACTIONS(5737),
    [anon_sym_DASH_GT_GT] = ACTIONS(5739),
    [anon_sym_PIPE] = ACTIONS(5741),
    [anon_sym_AMP] = ACTIONS(5743),
    [anon_sym_PIPE_PIPE] = ACTIONS(5745),
    [anon_sym_AMP_AMP] = ACTIONS(5747),
    [anon_sym_LT] = ACTIONS(5749),
    [anon_sym_LT_EQ] = ACTIONS(5751),
    [anon_sym_GT] = ACTIONS(5749),
    [anon_sym_GT_EQ] = ACTIONS(5751),
    [anon_sym_EQ_EQ] = ACTIONS(5751),
    [anon_sym_BANG_EQ] = ACTIONS(5751),
    [anon_sym_STAR] = ACTIONS(5753),
    [anon_sym_SLASH] = ACTIONS(5755),
    [anon_sym_STAR_STAR] = ACTIONS(5757),
    [anon_sym_CARET] = ACTIONS(5757),
    [aux_sym_binary_operator_token1] = ACTIONS(5759),
    [anon_sym_PIPE_GT] = ACTIONS(5759),
    [anon_sym_COLON] = ACTIONS(5761),
    [anon_sym_DOLLAR] = ACTIONS(5763),
    [anon_sym_AT] = ACTIONS(5763),
    [aux_sym__hex_literal_token1] = ACTIONS(5429),
    [sym__number_literal] = ACTIONS(5431),
    [anon_sym_SQUOTE] = ACTIONS(5429),
    [anon_sym_DQUOTE] = ACTIONS(5429),
    [sym_return] = ACTIONS(5431),
    [sym_next] = ACTIONS(5431),
    [sym_break] = ACTIONS(5431),
    [sym_true] = ACTIONS(5431),
    [sym_false] = ACTIONS(5431),
    [sym_null] = ACTIONS(5431),
    [sym_inf] = ACTIONS(5431),
    [sym_nan] = ACTIONS(5431),
    [anon_sym_NA] = ACTIONS(5431),
    [anon_sym_NA_integer_] = ACTIONS(5431),
    [anon_sym_NA_real_] = ACTIONS(5431),
    [anon_sym_NA_complex_] = ACTIONS(5431),
    [anon_sym_NA_character_] = ACTIONS(5431),
    [sym_dots] = ACTIONS(5431),
    [sym_dot_dot_i] = ACTIONS(5429),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5429),
    [sym__semicolon] = ACTIONS(5429),
    [sym__raw_string_literal] = ACTIONS(5429),
    [sym__external_else] = ACTIONS(5429),
    [sym__external_open_parenthesis] = ACTIONS(5767),
    [sym__external_open_brace] = ACTIONS(5429),
    [sym__external_close_brace] = ACTIONS(5429),
    [sym__external_open_bracket] = ACTIONS(5769),
    [sym__external_open_bracket2] = ACTIONS(5771),
  },
  [1090] = {
    [sym_call_arguments] = STATE(2595),
    [sym_subset_arguments] = STATE(2594),
    [sym_subset2_arguments] = STATE(2592),
    [sym__open_parenthesis] = STATE(1423),
    [sym__open_bracket] = STATE(1419),
    [sym__open_bracket2] = STATE(1415),
    [ts_builtin_sym_end] = ACTIONS(5433),
    [sym_identifier] = ACTIONS(5435),
    [anon_sym_BSLASH] = ACTIONS(5433),
    [anon_sym_function] = ACTIONS(5435),
    [anon_sym_EQ] = ACTIONS(5727),
    [anon_sym_if] = ACTIONS(5435),
    [anon_sym_for] = ACTIONS(5435),
    [anon_sym_while] = ACTIONS(5435),
    [anon_sym_repeat] = ACTIONS(5435),
    [anon_sym_QMARK] = ACTIONS(5433),
    [anon_sym_TILDE] = ACTIONS(5729),
    [anon_sym_BANG] = ACTIONS(5435),
    [anon_sym_PLUS] = ACTIONS(5731),
    [anon_sym_DASH] = ACTIONS(5733),
    [anon_sym_LT_DASH] = ACTIONS(5735),
    [anon_sym_LT_LT_DASH] = ACTIONS(5735),
    [anon_sym_COLON_EQ] = ACTIONS(5735),
    [anon_sym_DASH_GT] = ACTIONS(5737),
    [anon_sym_DASH_GT_GT] = ACTIONS(5739),
    [anon_sym_PIPE] = ACTIONS(5741),
    [anon_sym_AMP] = ACTIONS(5743),
    [anon_sym_PIPE_PIPE] = ACTIONS(5745),
    [anon_sym_AMP_AMP] = ACTIONS(5747),
    [anon_sym_LT] = ACTIONS(5749),
    [anon_sym_LT_EQ] = ACTIONS(5751),
    [anon_sym_GT] = ACTIONS(5749),
    [anon_sym_GT_EQ] = ACTIONS(5751),
    [anon_sym_EQ_EQ] = ACTIONS(5751),
    [anon_sym_BANG_EQ] = ACTIONS(5751),
    [anon_sym_STAR] = ACTIONS(5753),
    [anon_sym_SLASH] = ACTIONS(5755),
    [anon_sym_STAR_STAR] = ACTIONS(5757),
    [anon_sym_CARET] = ACTIONS(5757),
    [aux_sym_binary_operator_token1] = ACTIONS(5759),
    [anon_sym_PIPE_GT] = ACTIONS(5759),
    [anon_sym_COLON] = ACTIONS(5761),
    [anon_sym_DOLLAR] = ACTIONS(5763),
    [anon_sym_AT] = ACTIONS(5763),
    [aux_sym__hex_literal_token1] = ACTIONS(5433),
    [sym__number_literal] = ACTIONS(5435),
    [anon_sym_SQUOTE] = ACTIONS(5433),
    [anon_sym_DQUOTE] = ACTIONS(5433),
    [sym_return] = ACTIONS(5435),
    [sym_next] = ACTIONS(5435),
    [sym_break] = ACTIONS(5435),
    [sym_true] = ACTIONS(5435),
    [sym_false] = ACTIONS(5435),
    [sym_null] = ACTIONS(5435),
    [sym_inf] = ACTIONS(5435),
    [sym_nan] = ACTIONS(5435),
    [anon_sym_NA] = ACTIONS(5435),
    [anon_sym_NA_integer_] = ACTIONS(5435),
    [anon_sym_NA_real_] = ACTIONS(5435),
    [anon_sym_NA_complex_] = ACTIONS(5435),
    [anon_sym_NA_character_] = ACTIONS(5435),
    [sym_dots] = ACTIONS(5435),
    [sym_dot_dot_i] = ACTIONS(5433),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5433),
    [sym__semicolon] = ACTIONS(5433),
    [sym__raw_string_literal] = ACTIONS(5433),
    [sym__external_else] = ACTIONS(5433),
    [sym__external_open_parenthesis] = ACTIONS(5767),
    [sym__external_open_brace] = ACTIONS(5433),
    [sym__external_close_brace] = ACTIONS(5433),
    [sym__external_open_bracket] = ACTIONS(5769),
    [sym__external_open_bracket2] = ACTIONS(5771),
  },
  [1091] = {
    [sym_call_arguments] = STATE(2595),
    [sym_subset_arguments] = STATE(2594),
    [sym_subset2_arguments] = STATE(2592),
    [sym__open_parenthesis] = STATE(1423),
    [sym__open_bracket] = STATE(1419),
    [sym__open_bracket2] = STATE(1415),
    [ts_builtin_sym_end] = ACTIONS(5437),
    [sym_identifier] = ACTIONS(5439),
    [anon_sym_BSLASH] = ACTIONS(5437),
    [anon_sym_function] = ACTIONS(5439),
    [anon_sym_EQ] = ACTIONS(5727),
    [anon_sym_if] = ACTIONS(5439),
    [anon_sym_for] = ACTIONS(5439),
    [anon_sym_while] = ACTIONS(5439),
    [anon_sym_repeat] = ACTIONS(5439),
    [anon_sym_QMARK] = ACTIONS(5437),
    [anon_sym_TILDE] = ACTIONS(5729),
    [anon_sym_BANG] = ACTIONS(5439),
    [anon_sym_PLUS] = ACTIONS(5731),
    [anon_sym_DASH] = ACTIONS(5733),
    [anon_sym_LT_DASH] = ACTIONS(5735),
    [anon_sym_LT_LT_DASH] = ACTIONS(5735),
    [anon_sym_COLON_EQ] = ACTIONS(5735),
    [anon_sym_DASH_GT] = ACTIONS(5737),
    [anon_sym_DASH_GT_GT] = ACTIONS(5739),
    [anon_sym_PIPE] = ACTIONS(5741),
    [anon_sym_AMP] = ACTIONS(5743),
    [anon_sym_PIPE_PIPE] = ACTIONS(5745),
    [anon_sym_AMP_AMP] = ACTIONS(5747),
    [anon_sym_LT] = ACTIONS(5749),
    [anon_sym_LT_EQ] = ACTIONS(5751),
    [anon_sym_GT] = ACTIONS(5749),
    [anon_sym_GT_EQ] = ACTIONS(5751),
    [anon_sym_EQ_EQ] = ACTIONS(5751),
    [anon_sym_BANG_EQ] = ACTIONS(5751),
    [anon_sym_STAR] = ACTIONS(5753),
    [anon_sym_SLASH] = ACTIONS(5755),
    [anon_sym_STAR_STAR] = ACTIONS(5757),
    [anon_sym_CARET] = ACTIONS(5757),
    [aux_sym_binary_operator_token1] = ACTIONS(5759),
    [anon_sym_PIPE_GT] = ACTIONS(5759),
    [anon_sym_COLON] = ACTIONS(5761),
    [anon_sym_DOLLAR] = ACTIONS(5763),
    [anon_sym_AT] = ACTIONS(5763),
    [aux_sym__hex_literal_token1] = ACTIONS(5437),
    [sym__number_literal] = ACTIONS(5439),
    [anon_sym_SQUOTE] = ACTIONS(5437),
    [anon_sym_DQUOTE] = ACTIONS(5437),
    [sym_return] = ACTIONS(5439),
    [sym_next] = ACTIONS(5439),
    [sym_break] = ACTIONS(5439),
    [sym_true] = ACTIONS(5439),
    [sym_false] = ACTIONS(5439),
    [sym_null] = ACTIONS(5439),
    [sym_inf] = ACTIONS(5439),
    [sym_nan] = ACTIONS(5439),
    [anon_sym_NA] = ACTIONS(5439),
    [anon_sym_NA_integer_] = ACTIONS(5439),
    [anon_sym_NA_real_] = ACTIONS(5439),
    [anon_sym_NA_complex_] = ACTIONS(5439),
    [anon_sym_NA_character_] = ACTIONS(5439),
    [sym_dots] = ACTIONS(5439),
    [sym_dot_dot_i] = ACTIONS(5437),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5437),
    [sym__semicolon] = ACTIONS(5437),
    [sym__raw_string_literal] = ACTIONS(5437),
    [sym__external_else] = ACTIONS(5437),
    [sym__external_open_parenthesis] = ACTIONS(5767),
    [sym__external_open_brace] = ACTIONS(5437),
    [sym__external_close_brace] = ACTIONS(5437),
    [sym__external_open_bracket] = ACTIONS(5769),
    [sym__external_open_bracket2] = ACTIONS(5771),
  },
  [1092] = {
    [sym_call_arguments] = STATE(2638),
    [sym_subset_arguments] = STATE(2647),
    [sym_subset2_arguments] = STATE(2650),
    [sym__open_parenthesis] = STATE(1537),
    [sym__open_bracket] = STATE(1534),
    [sym__open_bracket2] = STATE(1533),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_BSLASH] = ACTIONS(5413),
    [anon_sym_function] = ACTIONS(5415),
    [anon_sym_EQ] = ACTIONS(6055),
    [anon_sym_if] = ACTIONS(5415),
    [anon_sym_for] = ACTIONS(5415),
    [anon_sym_while] = ACTIONS(5415),
    [anon_sym_repeat] = ACTIONS(5415),
    [anon_sym_QMARK] = ACTIONS(5413),
    [anon_sym_TILDE] = ACTIONS(6057),
    [anon_sym_BANG] = ACTIONS(5415),
    [anon_sym_PLUS] = ACTIONS(6059),
    [anon_sym_DASH] = ACTIONS(6061),
    [anon_sym_LT_DASH] = ACTIONS(6063),
    [anon_sym_LT_LT_DASH] = ACTIONS(6063),
    [anon_sym_COLON_EQ] = ACTIONS(6063),
    [anon_sym_DASH_GT] = ACTIONS(6065),
    [anon_sym_DASH_GT_GT] = ACTIONS(6067),
    [anon_sym_PIPE] = ACTIONS(6069),
    [anon_sym_AMP] = ACTIONS(6071),
    [anon_sym_PIPE_PIPE] = ACTIONS(6073),
    [anon_sym_AMP_AMP] = ACTIONS(6075),
    [anon_sym_LT] = ACTIONS(6077),
    [anon_sym_LT_EQ] = ACTIONS(6079),
    [anon_sym_GT] = ACTIONS(6077),
    [anon_sym_GT_EQ] = ACTIONS(6079),
    [anon_sym_EQ_EQ] = ACTIONS(6079),
    [anon_sym_BANG_EQ] = ACTIONS(6079),
    [anon_sym_STAR] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6083),
    [anon_sym_STAR_STAR] = ACTIONS(6085),
    [anon_sym_CARET] = ACTIONS(6085),
    [aux_sym_binary_operator_token1] = ACTIONS(6087),
    [anon_sym_PIPE_GT] = ACTIONS(6087),
    [anon_sym_COLON] = ACTIONS(6089),
    [anon_sym_DOLLAR] = ACTIONS(6091),
    [anon_sym_AT] = ACTIONS(6091),
    [aux_sym__hex_literal_token1] = ACTIONS(5413),
    [sym__number_literal] = ACTIONS(5415),
    [anon_sym_SQUOTE] = ACTIONS(5413),
    [anon_sym_DQUOTE] = ACTIONS(5413),
    [sym_return] = ACTIONS(5415),
    [sym_next] = ACTIONS(5415),
    [sym_break] = ACTIONS(5415),
    [sym_true] = ACTIONS(5415),
    [sym_false] = ACTIONS(5415),
    [sym_null] = ACTIONS(5415),
    [sym_inf] = ACTIONS(5415),
    [sym_nan] = ACTIONS(5415),
    [anon_sym_NA] = ACTIONS(5415),
    [anon_sym_NA_integer_] = ACTIONS(5415),
    [anon_sym_NA_real_] = ACTIONS(5415),
    [anon_sym_NA_complex_] = ACTIONS(5415),
    [anon_sym_NA_character_] = ACTIONS(5415),
    [sym_dots] = ACTIONS(5415),
    [sym_dot_dot_i] = ACTIONS(5413),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5413),
    [sym__newline] = ACTIONS(5413),
    [sym__semicolon] = ACTIONS(5413),
    [sym__raw_string_literal] = ACTIONS(5413),
    [sym__external_open_parenthesis] = ACTIONS(6093),
    [sym__external_open_brace] = ACTIONS(5413),
    [sym__external_close_brace] = ACTIONS(5413),
    [sym__external_open_bracket] = ACTIONS(6095),
    [sym__external_open_bracket2] = ACTIONS(6097),
    [sym__external_close_bracket2] = ACTIONS(5413),
  },
  [1093] = {
    [sym_call_arguments] = STATE(2595),
    [sym_subset_arguments] = STATE(2594),
    [sym_subset2_arguments] = STATE(2592),
    [sym__open_parenthesis] = STATE(1423),
    [sym__open_bracket] = STATE(1419),
    [sym__open_bracket2] = STATE(1415),
    [ts_builtin_sym_end] = ACTIONS(5441),
    [sym_identifier] = ACTIONS(5443),
    [anon_sym_BSLASH] = ACTIONS(5441),
    [anon_sym_function] = ACTIONS(5443),
    [anon_sym_EQ] = ACTIONS(5727),
    [anon_sym_if] = ACTIONS(5443),
    [anon_sym_for] = ACTIONS(5443),
    [anon_sym_while] = ACTIONS(5443),
    [anon_sym_repeat] = ACTIONS(5443),
    [anon_sym_QMARK] = ACTIONS(5441),
    [anon_sym_TILDE] = ACTIONS(5729),
    [anon_sym_BANG] = ACTIONS(5443),
    [anon_sym_PLUS] = ACTIONS(5731),
    [anon_sym_DASH] = ACTIONS(5733),
    [anon_sym_LT_DASH] = ACTIONS(5735),
    [anon_sym_LT_LT_DASH] = ACTIONS(5735),
    [anon_sym_COLON_EQ] = ACTIONS(5735),
    [anon_sym_DASH_GT] = ACTIONS(5737),
    [anon_sym_DASH_GT_GT] = ACTIONS(5739),
    [anon_sym_PIPE] = ACTIONS(5741),
    [anon_sym_AMP] = ACTIONS(5743),
    [anon_sym_PIPE_PIPE] = ACTIONS(5745),
    [anon_sym_AMP_AMP] = ACTIONS(5747),
    [anon_sym_LT] = ACTIONS(5749),
    [anon_sym_LT_EQ] = ACTIONS(5751),
    [anon_sym_GT] = ACTIONS(5749),
    [anon_sym_GT_EQ] = ACTIONS(5751),
    [anon_sym_EQ_EQ] = ACTIONS(5751),
    [anon_sym_BANG_EQ] = ACTIONS(5751),
    [anon_sym_STAR] = ACTIONS(5753),
    [anon_sym_SLASH] = ACTIONS(5755),
    [anon_sym_STAR_STAR] = ACTIONS(5757),
    [anon_sym_CARET] = ACTIONS(5757),
    [aux_sym_binary_operator_token1] = ACTIONS(5759),
    [anon_sym_PIPE_GT] = ACTIONS(5759),
    [anon_sym_COLON] = ACTIONS(5761),
    [anon_sym_DOLLAR] = ACTIONS(5763),
    [anon_sym_AT] = ACTIONS(5763),
    [aux_sym__hex_literal_token1] = ACTIONS(5441),
    [sym__number_literal] = ACTIONS(5443),
    [anon_sym_SQUOTE] = ACTIONS(5441),
    [anon_sym_DQUOTE] = ACTIONS(5441),
    [sym_return] = ACTIONS(5443),
    [sym_next] = ACTIONS(5443),
    [sym_break] = ACTIONS(5443),
    [sym_true] = ACTIONS(5443),
    [sym_false] = ACTIONS(5443),
    [sym_null] = ACTIONS(5443),
    [sym_inf] = ACTIONS(5443),
    [sym_nan] = ACTIONS(5443),
    [anon_sym_NA] = ACTIONS(5443),
    [anon_sym_NA_integer_] = ACTIONS(5443),
    [anon_sym_NA_real_] = ACTIONS(5443),
    [anon_sym_NA_complex_] = ACTIONS(5443),
    [anon_sym_NA_character_] = ACTIONS(5443),
    [sym_dots] = ACTIONS(5443),
    [sym_dot_dot_i] = ACTIONS(5441),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5441),
    [sym__semicolon] = ACTIONS(5441),
    [sym__raw_string_literal] = ACTIONS(5441),
    [sym__external_else] = ACTIONS(5441),
    [sym__external_open_parenthesis] = ACTIONS(5767),
    [sym__external_open_brace] = ACTIONS(5441),
    [sym__external_close_brace] = ACTIONS(5441),
    [sym__external_open_bracket] = ACTIONS(5769),
    [sym__external_open_bracket2] = ACTIONS(5771),
  },
  [1094] = {
    [sym_call_arguments] = STATE(2595),
    [sym_subset_arguments] = STATE(2594),
    [sym_subset2_arguments] = STATE(2592),
    [sym__open_parenthesis] = STATE(1423),
    [sym__open_bracket] = STATE(1419),
    [sym__open_bracket2] = STATE(1415),
    [ts_builtin_sym_end] = ACTIONS(5445),
    [sym_identifier] = ACTIONS(5447),
    [anon_sym_BSLASH] = ACTIONS(5445),
    [anon_sym_function] = ACTIONS(5447),
    [anon_sym_EQ] = ACTIONS(5727),
    [anon_sym_if] = ACTIONS(5447),
    [anon_sym_for] = ACTIONS(5447),
    [anon_sym_while] = ACTIONS(5447),
    [anon_sym_repeat] = ACTIONS(5447),
    [anon_sym_QMARK] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(5729),
    [anon_sym_BANG] = ACTIONS(5447),
    [anon_sym_PLUS] = ACTIONS(5731),
    [anon_sym_DASH] = ACTIONS(5733),
    [anon_sym_LT_DASH] = ACTIONS(5735),
    [anon_sym_LT_LT_DASH] = ACTIONS(5735),
    [anon_sym_COLON_EQ] = ACTIONS(5735),
    [anon_sym_DASH_GT] = ACTIONS(5737),
    [anon_sym_DASH_GT_GT] = ACTIONS(5739),
    [anon_sym_PIPE] = ACTIONS(5741),
    [anon_sym_AMP] = ACTIONS(5743),
    [anon_sym_PIPE_PIPE] = ACTIONS(5745),
    [anon_sym_AMP_AMP] = ACTIONS(5747),
    [anon_sym_LT] = ACTIONS(5749),
    [anon_sym_LT_EQ] = ACTIONS(5751),
    [anon_sym_GT] = ACTIONS(5749),
    [anon_sym_GT_EQ] = ACTIONS(5751),
    [anon_sym_EQ_EQ] = ACTIONS(5751),
    [anon_sym_BANG_EQ] = ACTIONS(5751),
    [anon_sym_STAR] = ACTIONS(5753),
    [anon_sym_SLASH] = ACTIONS(5755),
    [anon_sym_STAR_STAR] = ACTIONS(5757),
    [anon_sym_CARET] = ACTIONS(5757),
    [aux_sym_binary_operator_token1] = ACTIONS(5759),
    [anon_sym_PIPE_GT] = ACTIONS(5759),
    [anon_sym_COLON] = ACTIONS(5761),
    [anon_sym_DOLLAR] = ACTIONS(5763),
    [anon_sym_AT] = ACTIONS(5763),
    [aux_sym__hex_literal_token1] = ACTIONS(5445),
    [sym__number_literal] = ACTIONS(5447),
    [anon_sym_SQUOTE] = ACTIONS(5445),
    [anon_sym_DQUOTE] = ACTIONS(5445),
    [sym_return] = ACTIONS(5447),
    [sym_next] = ACTIONS(5447),
    [sym_break] = ACTIONS(5447),
    [sym_true] = ACTIONS(5447),
    [sym_false] = ACTIONS(5447),
    [sym_null] = ACTIONS(5447),
    [sym_inf] = ACTIONS(5447),
    [sym_nan] = ACTIONS(5447),
    [anon_sym_NA] = ACTIONS(5447),
    [anon_sym_NA_integer_] = ACTIONS(5447),
    [anon_sym_NA_real_] = ACTIONS(5447),
    [anon_sym_NA_complex_] = ACTIONS(5447),
    [anon_sym_NA_character_] = ACTIONS(5447),
    [sym_dots] = ACTIONS(5447),
    [sym_dot_dot_i] = ACTIONS(5445),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5445),
    [sym__semicolon] = ACTIONS(5445),
    [sym__raw_string_literal] = ACTIONS(5445),
    [sym__external_else] = ACTIONS(5445),
    [sym__external_open_parenthesis] = ACTIONS(5767),
    [sym__external_open_brace] = ACTIONS(5445),
    [sym__external_close_brace] = ACTIONS(5445),
    [sym__external_open_bracket] = ACTIONS(5769),
    [sym__external_open_bracket2] = ACTIONS(5771),
  },
  [1095] = {
    [sym_call_arguments] = STATE(2595),
    [sym_subset_arguments] = STATE(2594),
    [sym_subset2_arguments] = STATE(2592),
    [sym__open_parenthesis] = STATE(1423),
    [sym__open_bracket] = STATE(1419),
    [sym__open_bracket2] = STATE(1415),
    [ts_builtin_sym_end] = ACTIONS(5449),
    [sym_identifier] = ACTIONS(5451),
    [anon_sym_BSLASH] = ACTIONS(5449),
    [anon_sym_function] = ACTIONS(5451),
    [anon_sym_EQ] = ACTIONS(5727),
    [anon_sym_if] = ACTIONS(5451),
    [anon_sym_for] = ACTIONS(5451),
    [anon_sym_while] = ACTIONS(5451),
    [anon_sym_repeat] = ACTIONS(5451),
    [anon_sym_QMARK] = ACTIONS(5449),
    [anon_sym_TILDE] = ACTIONS(5729),
    [anon_sym_BANG] = ACTIONS(5451),
    [anon_sym_PLUS] = ACTIONS(5731),
    [anon_sym_DASH] = ACTIONS(5733),
    [anon_sym_LT_DASH] = ACTIONS(5735),
    [anon_sym_LT_LT_DASH] = ACTIONS(5735),
    [anon_sym_COLON_EQ] = ACTIONS(5735),
    [anon_sym_DASH_GT] = ACTIONS(5737),
    [anon_sym_DASH_GT_GT] = ACTIONS(5739),
    [anon_sym_PIPE] = ACTIONS(5741),
    [anon_sym_AMP] = ACTIONS(5743),
    [anon_sym_PIPE_PIPE] = ACTIONS(5745),
    [anon_sym_AMP_AMP] = ACTIONS(5747),
    [anon_sym_LT] = ACTIONS(5749),
    [anon_sym_LT_EQ] = ACTIONS(5751),
    [anon_sym_GT] = ACTIONS(5749),
    [anon_sym_GT_EQ] = ACTIONS(5751),
    [anon_sym_EQ_EQ] = ACTIONS(5751),
    [anon_sym_BANG_EQ] = ACTIONS(5751),
    [anon_sym_STAR] = ACTIONS(5753),
    [anon_sym_SLASH] = ACTIONS(5755),
    [anon_sym_STAR_STAR] = ACTIONS(5757),
    [anon_sym_CARET] = ACTIONS(5757),
    [aux_sym_binary_operator_token1] = ACTIONS(5759),
    [anon_sym_PIPE_GT] = ACTIONS(5759),
    [anon_sym_COLON] = ACTIONS(5761),
    [anon_sym_DOLLAR] = ACTIONS(5763),
    [anon_sym_AT] = ACTIONS(5763),
    [aux_sym__hex_literal_token1] = ACTIONS(5449),
    [sym__number_literal] = ACTIONS(5451),
    [anon_sym_SQUOTE] = ACTIONS(5449),
    [anon_sym_DQUOTE] = ACTIONS(5449),
    [sym_return] = ACTIONS(5451),
    [sym_next] = ACTIONS(5451),
    [sym_break] = ACTIONS(5451),
    [sym_true] = ACTIONS(5451),
    [sym_false] = ACTIONS(5451),
    [sym_null] = ACTIONS(5451),
    [sym_inf] = ACTIONS(5451),
    [sym_nan] = ACTIONS(5451),
    [anon_sym_NA] = ACTIONS(5451),
    [anon_sym_NA_integer_] = ACTIONS(5451),
    [anon_sym_NA_real_] = ACTIONS(5451),
    [anon_sym_NA_complex_] = ACTIONS(5451),
    [anon_sym_NA_character_] = ACTIONS(5451),
    [sym_dots] = ACTIONS(5451),
    [sym_dot_dot_i] = ACTIONS(5449),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5449),
    [sym__semicolon] = ACTIONS(5449),
    [sym__raw_string_literal] = ACTIONS(5449),
    [sym__external_else] = ACTIONS(5449),
    [sym__external_open_parenthesis] = ACTIONS(5767),
    [sym__external_open_brace] = ACTIONS(5449),
    [sym__external_close_brace] = ACTIONS(5449),
    [sym__external_open_bracket] = ACTIONS(5769),
    [sym__external_open_bracket2] = ACTIONS(5771),
  },
  [1096] = {
    [sym_call_arguments] = STATE(2595),
    [sym_subset_arguments] = STATE(2594),
    [sym_subset2_arguments] = STATE(2592),
    [sym__open_parenthesis] = STATE(1423),
    [sym__open_bracket] = STATE(1419),
    [sym__open_bracket2] = STATE(1415),
    [ts_builtin_sym_end] = ACTIONS(5453),
    [sym_identifier] = ACTIONS(5455),
    [anon_sym_BSLASH] = ACTIONS(5453),
    [anon_sym_function] = ACTIONS(5455),
    [anon_sym_EQ] = ACTIONS(5727),
    [anon_sym_if] = ACTIONS(5455),
    [anon_sym_for] = ACTIONS(5455),
    [anon_sym_while] = ACTIONS(5455),
    [anon_sym_repeat] = ACTIONS(5455),
    [anon_sym_QMARK] = ACTIONS(5453),
    [anon_sym_TILDE] = ACTIONS(5729),
    [anon_sym_BANG] = ACTIONS(5455),
    [anon_sym_PLUS] = ACTIONS(5731),
    [anon_sym_DASH] = ACTIONS(5733),
    [anon_sym_LT_DASH] = ACTIONS(5735),
    [anon_sym_LT_LT_DASH] = ACTIONS(5735),
    [anon_sym_COLON_EQ] = ACTIONS(5735),
    [anon_sym_DASH_GT] = ACTIONS(5737),
    [anon_sym_DASH_GT_GT] = ACTIONS(5739),
    [anon_sym_PIPE] = ACTIONS(5741),
    [anon_sym_AMP] = ACTIONS(5743),
    [anon_sym_PIPE_PIPE] = ACTIONS(5745),
    [anon_sym_AMP_AMP] = ACTIONS(5747),
    [anon_sym_LT] = ACTIONS(5749),
    [anon_sym_LT_EQ] = ACTIONS(5751),
    [anon_sym_GT] = ACTIONS(5749),
    [anon_sym_GT_EQ] = ACTIONS(5751),
    [anon_sym_EQ_EQ] = ACTIONS(5751),
    [anon_sym_BANG_EQ] = ACTIONS(5751),
    [anon_sym_STAR] = ACTIONS(5753),
    [anon_sym_SLASH] = ACTIONS(5755),
    [anon_sym_STAR_STAR] = ACTIONS(5757),
    [anon_sym_CARET] = ACTIONS(5757),
    [aux_sym_binary_operator_token1] = ACTIONS(5759),
    [anon_sym_PIPE_GT] = ACTIONS(5759),
    [anon_sym_COLON] = ACTIONS(5761),
    [anon_sym_DOLLAR] = ACTIONS(5763),
    [anon_sym_AT] = ACTIONS(5763),
    [aux_sym__hex_literal_token1] = ACTIONS(5453),
    [sym__number_literal] = ACTIONS(5455),
    [anon_sym_SQUOTE] = ACTIONS(5453),
    [anon_sym_DQUOTE] = ACTIONS(5453),
    [sym_return] = ACTIONS(5455),
    [sym_next] = ACTIONS(5455),
    [sym_break] = ACTIONS(5455),
    [sym_true] = ACTIONS(5455),
    [sym_false] = ACTIONS(5455),
    [sym_null] = ACTIONS(5455),
    [sym_inf] = ACTIONS(5455),
    [sym_nan] = ACTIONS(5455),
    [anon_sym_NA] = ACTIONS(5455),
    [anon_sym_NA_integer_] = ACTIONS(5455),
    [anon_sym_NA_real_] = ACTIONS(5455),
    [anon_sym_NA_complex_] = ACTIONS(5455),
    [anon_sym_NA_character_] = ACTIONS(5455),
    [sym_dots] = ACTIONS(5455),
    [sym_dot_dot_i] = ACTIONS(5453),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5453),
    [sym__semicolon] = ACTIONS(5453),
    [sym__raw_string_literal] = ACTIONS(5453),
    [sym__external_else] = ACTIONS(5453),
    [sym__external_open_parenthesis] = ACTIONS(5767),
    [sym__external_open_brace] = ACTIONS(5453),
    [sym__external_close_brace] = ACTIONS(5453),
    [sym__external_open_bracket] = ACTIONS(5769),
    [sym__external_open_bracket2] = ACTIONS(5771),
  },
  [1097] = {
    [sym_call_arguments] = STATE(2595),
    [sym_subset_arguments] = STATE(2594),
    [sym_subset2_arguments] = STATE(2592),
    [sym__open_parenthesis] = STATE(1423),
    [sym__open_bracket] = STATE(1419),
    [sym__open_bracket2] = STATE(1415),
    [ts_builtin_sym_end] = ACTIONS(5409),
    [sym_identifier] = ACTIONS(5411),
    [anon_sym_BSLASH] = ACTIONS(5409),
    [anon_sym_function] = ACTIONS(5411),
    [anon_sym_EQ] = ACTIONS(5727),
    [anon_sym_if] = ACTIONS(5411),
    [anon_sym_for] = ACTIONS(5411),
    [anon_sym_while] = ACTIONS(5411),
    [anon_sym_repeat] = ACTIONS(5411),
    [anon_sym_QMARK] = ACTIONS(5409),
    [anon_sym_TILDE] = ACTIONS(5729),
    [anon_sym_BANG] = ACTIONS(5411),
    [anon_sym_PLUS] = ACTIONS(5731),
    [anon_sym_DASH] = ACTIONS(5733),
    [anon_sym_LT_DASH] = ACTIONS(5735),
    [anon_sym_LT_LT_DASH] = ACTIONS(5735),
    [anon_sym_COLON_EQ] = ACTIONS(5735),
    [anon_sym_DASH_GT] = ACTIONS(5737),
    [anon_sym_DASH_GT_GT] = ACTIONS(5739),
    [anon_sym_PIPE] = ACTIONS(5741),
    [anon_sym_AMP] = ACTIONS(5743),
    [anon_sym_PIPE_PIPE] = ACTIONS(5745),
    [anon_sym_AMP_AMP] = ACTIONS(5747),
    [anon_sym_LT] = ACTIONS(5749),
    [anon_sym_LT_EQ] = ACTIONS(5751),
    [anon_sym_GT] = ACTIONS(5749),
    [anon_sym_GT_EQ] = ACTIONS(5751),
    [anon_sym_EQ_EQ] = ACTIONS(5751),
    [anon_sym_BANG_EQ] = ACTIONS(5751),
    [anon_sym_STAR] = ACTIONS(5753),
    [anon_sym_SLASH] = ACTIONS(5755),
    [anon_sym_STAR_STAR] = ACTIONS(5757),
    [anon_sym_CARET] = ACTIONS(5757),
    [aux_sym_binary_operator_token1] = ACTIONS(5759),
    [anon_sym_PIPE_GT] = ACTIONS(5759),
    [anon_sym_COLON] = ACTIONS(5761),
    [anon_sym_DOLLAR] = ACTIONS(5763),
    [anon_sym_AT] = ACTIONS(5763),
    [aux_sym__hex_literal_token1] = ACTIONS(5409),
    [sym__number_literal] = ACTIONS(5411),
    [anon_sym_SQUOTE] = ACTIONS(5409),
    [anon_sym_DQUOTE] = ACTIONS(5409),
    [sym_return] = ACTIONS(5411),
    [sym_next] = ACTIONS(5411),
    [sym_break] = ACTIONS(5411),
    [sym_true] = ACTIONS(5411),
    [sym_false] = ACTIONS(5411),
    [sym_null] = ACTIONS(5411),
    [sym_inf] = ACTIONS(5411),
    [sym_nan] = ACTIONS(5411),
    [anon_sym_NA] = ACTIONS(5411),
    [anon_sym_NA_integer_] = ACTIONS(5411),
    [anon_sym_NA_real_] = ACTIONS(5411),
    [anon_sym_NA_complex_] = ACTIONS(5411),
    [anon_sym_NA_character_] = ACTIONS(5411),
    [sym_dots] = ACTIONS(5411),
    [sym_dot_dot_i] = ACTIONS(5409),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5409),
    [sym__semicolon] = ACTIONS(5409),
    [sym__raw_string_literal] = ACTIONS(5409),
    [sym__external_else] = ACTIONS(5409),
    [sym__external_open_parenthesis] = ACTIONS(5767),
    [sym__external_open_brace] = ACTIONS(5409),
    [sym__external_close_brace] = ACTIONS(5409),
    [sym__external_open_bracket] = ACTIONS(5769),
    [sym__external_open_bracket2] = ACTIONS(5771),
  },
  [1098] = {
    [sym_call_arguments] = STATE(2638),
    [sym_subset_arguments] = STATE(2647),
    [sym_subset2_arguments] = STATE(2650),
    [sym__open_parenthesis] = STATE(1537),
    [sym__open_bracket] = STATE(1534),
    [sym__open_bracket2] = STATE(1533),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(6085),
    [anon_sym_CARET] = ACTIONS(6085),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(5261),
    [anon_sym_DOLLAR] = ACTIONS(6091),
    [anon_sym_AT] = ACTIONS(6091),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6093),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6095),
    [sym__external_open_bracket2] = ACTIONS(6097),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [1099] = {
    [sym_call_arguments] = STATE(2638),
    [sym_subset_arguments] = STATE(2647),
    [sym_subset2_arguments] = STATE(2650),
    [sym__open_parenthesis] = STATE(1537),
    [sym__open_bracket] = STATE(1534),
    [sym__open_bracket2] = STATE(1533),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(6085),
    [anon_sym_CARET] = ACTIONS(6085),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(6089),
    [anon_sym_DOLLAR] = ACTIONS(6091),
    [anon_sym_AT] = ACTIONS(6091),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6093),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6095),
    [sym__external_open_bracket2] = ACTIONS(6097),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [1100] = {
    [sym_call_arguments] = STATE(2638),
    [sym_subset_arguments] = STATE(2647),
    [sym_subset2_arguments] = STATE(2650),
    [sym__open_parenthesis] = STATE(1537),
    [sym__open_bracket] = STATE(1534),
    [sym__open_bracket2] = STATE(1533),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(6085),
    [anon_sym_CARET] = ACTIONS(6085),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(5261),
    [anon_sym_DOLLAR] = ACTIONS(6091),
    [anon_sym_AT] = ACTIONS(6091),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6093),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6095),
    [sym__external_open_bracket2] = ACTIONS(6097),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [1101] = {
    [sym_call_arguments] = STATE(2638),
    [sym_subset_arguments] = STATE(2647),
    [sym_subset2_arguments] = STATE(2650),
    [sym__open_parenthesis] = STATE(1537),
    [sym__open_bracket] = STATE(1534),
    [sym__open_bracket2] = STATE(1533),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(6085),
    [anon_sym_CARET] = ACTIONS(6085),
    [aux_sym_binary_operator_token1] = ACTIONS(6087),
    [anon_sym_PIPE_GT] = ACTIONS(6087),
    [anon_sym_COLON] = ACTIONS(6089),
    [anon_sym_DOLLAR] = ACTIONS(6091),
    [anon_sym_AT] = ACTIONS(6091),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6093),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6095),
    [sym__external_open_bracket2] = ACTIONS(6097),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [1102] = {
    [sym_call_arguments] = STATE(2638),
    [sym_subset_arguments] = STATE(2647),
    [sym_subset2_arguments] = STATE(2650),
    [sym__open_parenthesis] = STATE(1537),
    [sym__open_bracket] = STATE(1534),
    [sym__open_bracket2] = STATE(1533),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(6059),
    [anon_sym_DASH] = ACTIONS(6061),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6083),
    [anon_sym_STAR_STAR] = ACTIONS(6085),
    [anon_sym_CARET] = ACTIONS(6085),
    [aux_sym_binary_operator_token1] = ACTIONS(6087),
    [anon_sym_PIPE_GT] = ACTIONS(6087),
    [anon_sym_COLON] = ACTIONS(6089),
    [anon_sym_DOLLAR] = ACTIONS(6091),
    [anon_sym_AT] = ACTIONS(6091),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6093),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6095),
    [sym__external_open_bracket2] = ACTIONS(6097),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [1103] = {
    [sym_call_arguments] = STATE(2638),
    [sym_subset_arguments] = STATE(2647),
    [sym_subset2_arguments] = STATE(2650),
    [sym__open_parenthesis] = STATE(1537),
    [sym__open_bracket] = STATE(1534),
    [sym__open_bracket2] = STATE(1533),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(6059),
    [anon_sym_DASH] = ACTIONS(6061),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(6077),
    [anon_sym_LT_EQ] = ACTIONS(6079),
    [anon_sym_GT] = ACTIONS(6077),
    [anon_sym_GT_EQ] = ACTIONS(6079),
    [anon_sym_EQ_EQ] = ACTIONS(6079),
    [anon_sym_BANG_EQ] = ACTIONS(6079),
    [anon_sym_STAR] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6083),
    [anon_sym_STAR_STAR] = ACTIONS(6085),
    [anon_sym_CARET] = ACTIONS(6085),
    [aux_sym_binary_operator_token1] = ACTIONS(6087),
    [anon_sym_PIPE_GT] = ACTIONS(6087),
    [anon_sym_COLON] = ACTIONS(6089),
    [anon_sym_DOLLAR] = ACTIONS(6091),
    [anon_sym_AT] = ACTIONS(6091),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6093),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6095),
    [sym__external_open_bracket2] = ACTIONS(6097),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [1104] = {
    [sym_call_arguments] = STATE(2638),
    [sym_subset_arguments] = STATE(2647),
    [sym_subset2_arguments] = STATE(2650),
    [sym__open_parenthesis] = STATE(1537),
    [sym__open_bracket] = STATE(1534),
    [sym__open_bracket2] = STATE(1533),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(6059),
    [anon_sym_DASH] = ACTIONS(6061),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(6071),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(6075),
    [anon_sym_LT] = ACTIONS(6077),
    [anon_sym_LT_EQ] = ACTIONS(6079),
    [anon_sym_GT] = ACTIONS(6077),
    [anon_sym_GT_EQ] = ACTIONS(6079),
    [anon_sym_EQ_EQ] = ACTIONS(6079),
    [anon_sym_BANG_EQ] = ACTIONS(6079),
    [anon_sym_STAR] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6083),
    [anon_sym_STAR_STAR] = ACTIONS(6085),
    [anon_sym_CARET] = ACTIONS(6085),
    [aux_sym_binary_operator_token1] = ACTIONS(6087),
    [anon_sym_PIPE_GT] = ACTIONS(6087),
    [anon_sym_COLON] = ACTIONS(6089),
    [anon_sym_DOLLAR] = ACTIONS(6091),
    [anon_sym_AT] = ACTIONS(6091),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6093),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6095),
    [sym__external_open_bracket2] = ACTIONS(6097),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [1105] = {
    [sym_string] = STATE(2527),
    [sym__single_quoted_string] = STATE(2211),
    [sym__double_quoted_string] = STATE(2212),
    [sym__string_or_identifier] = STATE(2527),
    [aux_sym_function_definition_repeat1] = STATE(1061),
    [sym_identifier] = ACTIONS(6101),
    [anon_sym_BSLASH] = ACTIONS(5659),
    [anon_sym_function] = ACTIONS(5663),
    [anon_sym_EQ] = ACTIONS(5663),
    [anon_sym_if] = ACTIONS(5663),
    [anon_sym_for] = ACTIONS(5663),
    [anon_sym_while] = ACTIONS(5663),
    [anon_sym_repeat] = ACTIONS(5663),
    [anon_sym_QMARK] = ACTIONS(5659),
    [anon_sym_TILDE] = ACTIONS(5659),
    [anon_sym_BANG] = ACTIONS(5663),
    [anon_sym_PLUS] = ACTIONS(5659),
    [anon_sym_DASH] = ACTIONS(5663),
    [anon_sym_LT_DASH] = ACTIONS(5659),
    [anon_sym_LT_LT_DASH] = ACTIONS(5659),
    [anon_sym_COLON_EQ] = ACTIONS(5659),
    [anon_sym_DASH_GT] = ACTIONS(5663),
    [anon_sym_DASH_GT_GT] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(5663),
    [anon_sym_AMP] = ACTIONS(5663),
    [anon_sym_PIPE_PIPE] = ACTIONS(5659),
    [anon_sym_AMP_AMP] = ACTIONS(5659),
    [anon_sym_LT] = ACTIONS(5663),
    [anon_sym_LT_EQ] = ACTIONS(5659),
    [anon_sym_GT] = ACTIONS(5663),
    [anon_sym_GT_EQ] = ACTIONS(5659),
    [anon_sym_EQ_EQ] = ACTIONS(5659),
    [anon_sym_BANG_EQ] = ACTIONS(5659),
    [anon_sym_STAR] = ACTIONS(5663),
    [anon_sym_SLASH] = ACTIONS(5659),
    [anon_sym_STAR_STAR] = ACTIONS(5659),
    [anon_sym_CARET] = ACTIONS(5659),
    [aux_sym_binary_operator_token1] = ACTIONS(5659),
    [anon_sym_PIPE_GT] = ACTIONS(5659),
    [anon_sym_COLON] = ACTIONS(5663),
    [anon_sym_DOLLAR] = ACTIONS(5659),
    [anon_sym_AT] = ACTIONS(5659),
    [aux_sym__hex_literal_token1] = ACTIONS(5659),
    [sym__number_literal] = ACTIONS(5663),
    [anon_sym_SQUOTE] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_return] = ACTIONS(5663),
    [sym_next] = ACTIONS(5663),
    [sym_break] = ACTIONS(5663),
    [sym_true] = ACTIONS(5663),
    [sym_false] = ACTIONS(5663),
    [sym_null] = ACTIONS(5663),
    [sym_inf] = ACTIONS(5663),
    [sym_nan] = ACTIONS(5663),
    [anon_sym_NA] = ACTIONS(5663),
    [anon_sym_NA_integer_] = ACTIONS(5663),
    [anon_sym_NA_real_] = ACTIONS(5663),
    [anon_sym_NA_complex_] = ACTIONS(5663),
    [anon_sym_NA_character_] = ACTIONS(5663),
    [sym_dots] = ACTIONS(5663),
    [sym_dot_dot_i] = ACTIONS(5659),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5659),
    [sym__newline] = ACTIONS(6103),
    [sym__semicolon] = ACTIONS(5659),
    [sym__raw_string_literal] = ACTIONS(445),
    [sym__external_else] = ACTIONS(5659),
    [sym__external_open_parenthesis] = ACTIONS(5659),
    [sym__external_open_brace] = ACTIONS(5659),
    [sym__external_close_brace] = ACTIONS(5659),
    [sym__external_open_bracket] = ACTIONS(5659),
    [sym__external_open_bracket2] = ACTIONS(5659),
    [sym__external_close_bracket2] = ACTIONS(5659),
  },
  [1106] = {
    [sym_call_arguments] = STATE(2638),
    [sym_subset_arguments] = STATE(2647),
    [sym_subset2_arguments] = STATE(2650),
    [sym__open_parenthesis] = STATE(1537),
    [sym__open_bracket] = STATE(1534),
    [sym__open_bracket2] = STATE(1533),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(6057),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(6059),
    [anon_sym_DASH] = ACTIONS(6061),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(6069),
    [anon_sym_AMP] = ACTIONS(6071),
    [anon_sym_PIPE_PIPE] = ACTIONS(6073),
    [anon_sym_AMP_AMP] = ACTIONS(6075),
    [anon_sym_LT] = ACTIONS(6077),
    [anon_sym_LT_EQ] = ACTIONS(6079),
    [anon_sym_GT] = ACTIONS(6077),
    [anon_sym_GT_EQ] = ACTIONS(6079),
    [anon_sym_EQ_EQ] = ACTIONS(6079),
    [anon_sym_BANG_EQ] = ACTIONS(6079),
    [anon_sym_STAR] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6083),
    [anon_sym_STAR_STAR] = ACTIONS(6085),
    [anon_sym_CARET] = ACTIONS(6085),
    [aux_sym_binary_operator_token1] = ACTIONS(6087),
    [anon_sym_PIPE_GT] = ACTIONS(6087),
    [anon_sym_COLON] = ACTIONS(6089),
    [anon_sym_DOLLAR] = ACTIONS(6091),
    [anon_sym_AT] = ACTIONS(6091),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6093),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6095),
    [sym__external_open_bracket2] = ACTIONS(6097),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [1107] = {
    [sym_call_arguments] = STATE(2638),
    [sym_subset_arguments] = STATE(2647),
    [sym_subset2_arguments] = STATE(2650),
    [sym__open_parenthesis] = STATE(1537),
    [sym__open_bracket] = STATE(1534),
    [sym__open_bracket2] = STATE(1533),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(6055),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(6057),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(6059),
    [anon_sym_DASH] = ACTIONS(6061),
    [anon_sym_LT_DASH] = ACTIONS(6063),
    [anon_sym_LT_LT_DASH] = ACTIONS(6063),
    [anon_sym_COLON_EQ] = ACTIONS(6063),
    [anon_sym_DASH_GT] = ACTIONS(6065),
    [anon_sym_DASH_GT_GT] = ACTIONS(6067),
    [anon_sym_PIPE] = ACTIONS(6069),
    [anon_sym_AMP] = ACTIONS(6071),
    [anon_sym_PIPE_PIPE] = ACTIONS(6073),
    [anon_sym_AMP_AMP] = ACTIONS(6075),
    [anon_sym_LT] = ACTIONS(6077),
    [anon_sym_LT_EQ] = ACTIONS(6079),
    [anon_sym_GT] = ACTIONS(6077),
    [anon_sym_GT_EQ] = ACTIONS(6079),
    [anon_sym_EQ_EQ] = ACTIONS(6079),
    [anon_sym_BANG_EQ] = ACTIONS(6079),
    [anon_sym_STAR] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6083),
    [anon_sym_STAR_STAR] = ACTIONS(6085),
    [anon_sym_CARET] = ACTIONS(6085),
    [aux_sym_binary_operator_token1] = ACTIONS(6087),
    [anon_sym_PIPE_GT] = ACTIONS(6087),
    [anon_sym_COLON] = ACTIONS(6089),
    [anon_sym_DOLLAR] = ACTIONS(6091),
    [anon_sym_AT] = ACTIONS(6091),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6093),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6095),
    [sym__external_open_bracket2] = ACTIONS(6097),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [1108] = {
    [sym_call_arguments] = STATE(2638),
    [sym_subset_arguments] = STATE(2647),
    [sym_subset2_arguments] = STATE(2650),
    [sym__open_parenthesis] = STATE(1537),
    [sym__open_bracket] = STATE(1534),
    [sym__open_bracket2] = STATE(1533),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6083),
    [anon_sym_STAR_STAR] = ACTIONS(6085),
    [anon_sym_CARET] = ACTIONS(6085),
    [aux_sym_binary_operator_token1] = ACTIONS(6087),
    [anon_sym_PIPE_GT] = ACTIONS(6087),
    [anon_sym_COLON] = ACTIONS(6089),
    [anon_sym_DOLLAR] = ACTIONS(6091),
    [anon_sym_AT] = ACTIONS(6091),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6093),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6095),
    [sym__external_open_bracket2] = ACTIONS(6097),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [1109] = {
    [sym_call_arguments] = STATE(2638),
    [sym_subset_arguments] = STATE(2647),
    [sym_subset2_arguments] = STATE(2650),
    [sym__open_parenthesis] = STATE(1537),
    [sym__open_bracket] = STATE(1534),
    [sym__open_bracket2] = STATE(1533),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(6059),
    [anon_sym_DASH] = ACTIONS(6061),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(6069),
    [anon_sym_AMP] = ACTIONS(6071),
    [anon_sym_PIPE_PIPE] = ACTIONS(6073),
    [anon_sym_AMP_AMP] = ACTIONS(6075),
    [anon_sym_LT] = ACTIONS(6077),
    [anon_sym_LT_EQ] = ACTIONS(6079),
    [anon_sym_GT] = ACTIONS(6077),
    [anon_sym_GT_EQ] = ACTIONS(6079),
    [anon_sym_EQ_EQ] = ACTIONS(6079),
    [anon_sym_BANG_EQ] = ACTIONS(6079),
    [anon_sym_STAR] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6083),
    [anon_sym_STAR_STAR] = ACTIONS(6085),
    [anon_sym_CARET] = ACTIONS(6085),
    [aux_sym_binary_operator_token1] = ACTIONS(6087),
    [anon_sym_PIPE_GT] = ACTIONS(6087),
    [anon_sym_COLON] = ACTIONS(6089),
    [anon_sym_DOLLAR] = ACTIONS(6091),
    [anon_sym_AT] = ACTIONS(6091),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6093),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6095),
    [sym__external_open_bracket2] = ACTIONS(6097),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [1110] = {
    [sym_call_arguments] = STATE(2638),
    [sym_subset_arguments] = STATE(2647),
    [sym_subset2_arguments] = STATE(2650),
    [sym__open_parenthesis] = STATE(1537),
    [sym__open_bracket] = STATE(1534),
    [sym__open_bracket2] = STATE(1533),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(6055),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(6057),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(6059),
    [anon_sym_DASH] = ACTIONS(6061),
    [anon_sym_LT_DASH] = ACTIONS(6063),
    [anon_sym_LT_LT_DASH] = ACTIONS(6063),
    [anon_sym_COLON_EQ] = ACTIONS(6063),
    [anon_sym_DASH_GT] = ACTIONS(6065),
    [anon_sym_DASH_GT_GT] = ACTIONS(6067),
    [anon_sym_PIPE] = ACTIONS(6069),
    [anon_sym_AMP] = ACTIONS(6071),
    [anon_sym_PIPE_PIPE] = ACTIONS(6073),
    [anon_sym_AMP_AMP] = ACTIONS(6075),
    [anon_sym_LT] = ACTIONS(6077),
    [anon_sym_LT_EQ] = ACTIONS(6079),
    [anon_sym_GT] = ACTIONS(6077),
    [anon_sym_GT_EQ] = ACTIONS(6079),
    [anon_sym_EQ_EQ] = ACTIONS(6079),
    [anon_sym_BANG_EQ] = ACTIONS(6079),
    [anon_sym_STAR] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6083),
    [anon_sym_STAR_STAR] = ACTIONS(6085),
    [anon_sym_CARET] = ACTIONS(6085),
    [aux_sym_binary_operator_token1] = ACTIONS(6087),
    [anon_sym_PIPE_GT] = ACTIONS(6087),
    [anon_sym_COLON] = ACTIONS(6089),
    [anon_sym_DOLLAR] = ACTIONS(6091),
    [anon_sym_AT] = ACTIONS(6091),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6093),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6095),
    [sym__external_open_bracket2] = ACTIONS(6097),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [1111] = {
    [sym_string] = STATE(2360),
    [sym__single_quoted_string] = STATE(1923),
    [sym__double_quoted_string] = STATE(1934),
    [sym__string_or_identifier] = STATE(2360),
    [sym_identifier] = ACTIONS(6105),
    [anon_sym_BSLASH] = ACTIONS(5883),
    [anon_sym_function] = ACTIONS(5887),
    [anon_sym_EQ] = ACTIONS(5887),
    [anon_sym_if] = ACTIONS(5887),
    [anon_sym_for] = ACTIONS(5887),
    [anon_sym_while] = ACTIONS(5887),
    [anon_sym_repeat] = ACTIONS(5887),
    [anon_sym_QMARK] = ACTIONS(5883),
    [anon_sym_TILDE] = ACTIONS(5883),
    [anon_sym_BANG] = ACTIONS(5887),
    [anon_sym_PLUS] = ACTIONS(5883),
    [anon_sym_DASH] = ACTIONS(5887),
    [anon_sym_LT_DASH] = ACTIONS(5883),
    [anon_sym_LT_LT_DASH] = ACTIONS(5883),
    [anon_sym_COLON_EQ] = ACTIONS(5883),
    [anon_sym_DASH_GT] = ACTIONS(5887),
    [anon_sym_DASH_GT_GT] = ACTIONS(5883),
    [anon_sym_PIPE] = ACTIONS(5887),
    [anon_sym_AMP] = ACTIONS(5887),
    [anon_sym_PIPE_PIPE] = ACTIONS(5883),
    [anon_sym_AMP_AMP] = ACTIONS(5883),
    [anon_sym_LT] = ACTIONS(5887),
    [anon_sym_LT_EQ] = ACTIONS(5883),
    [anon_sym_GT] = ACTIONS(5887),
    [anon_sym_GT_EQ] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5883),
    [anon_sym_BANG_EQ] = ACTIONS(5883),
    [anon_sym_STAR] = ACTIONS(5887),
    [anon_sym_SLASH] = ACTIONS(5883),
    [anon_sym_STAR_STAR] = ACTIONS(5883),
    [anon_sym_CARET] = ACTIONS(5883),
    [aux_sym_binary_operator_token1] = ACTIONS(5883),
    [anon_sym_PIPE_GT] = ACTIONS(5883),
    [anon_sym_COLON] = ACTIONS(5887),
    [anon_sym_DOLLAR] = ACTIONS(5883),
    [anon_sym_AT] = ACTIONS(5883),
    [aux_sym__hex_literal_token1] = ACTIONS(5883),
    [sym__number_literal] = ACTIONS(5887),
    [anon_sym_SQUOTE] = ACTIONS(189),
    [anon_sym_DQUOTE] = ACTIONS(191),
    [sym_return] = ACTIONS(5887),
    [sym_next] = ACTIONS(5887),
    [sym_break] = ACTIONS(5887),
    [sym_true] = ACTIONS(5887),
    [sym_false] = ACTIONS(5887),
    [sym_null] = ACTIONS(5887),
    [sym_inf] = ACTIONS(5887),
    [sym_nan] = ACTIONS(5887),
    [anon_sym_NA] = ACTIONS(5887),
    [anon_sym_NA_integer_] = ACTIONS(5887),
    [anon_sym_NA_real_] = ACTIONS(5887),
    [anon_sym_NA_complex_] = ACTIONS(5887),
    [anon_sym_NA_character_] = ACTIONS(5887),
    [sym_dots] = ACTIONS(5887),
    [sym_dot_dot_i] = ACTIONS(5883),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5883),
    [sym__newline] = ACTIONS(5883),
    [sym__semicolon] = ACTIONS(5883),
    [sym__raw_string_literal] = ACTIONS(201),
    [sym__external_else] = ACTIONS(5883),
    [sym__external_open_parenthesis] = ACTIONS(5883),
    [sym__external_close_parenthesis] = ACTIONS(5883),
    [sym__external_open_brace] = ACTIONS(5883),
    [sym__external_close_brace] = ACTIONS(5883),
    [sym__external_open_bracket] = ACTIONS(5883),
    [sym__external_open_bracket2] = ACTIONS(5883),
    [sym__external_close_bracket2] = ACTIONS(5883),
  },
  [1112] = {
    [sym_call_arguments] = STATE(2638),
    [sym_subset_arguments] = STATE(2647),
    [sym_subset2_arguments] = STATE(2650),
    [sym__open_parenthesis] = STATE(1537),
    [sym__open_bracket] = STATE(1534),
    [sym__open_bracket2] = STATE(1533),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(6055),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(6057),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(6059),
    [anon_sym_DASH] = ACTIONS(6061),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(6065),
    [anon_sym_DASH_GT_GT] = ACTIONS(6067),
    [anon_sym_PIPE] = ACTIONS(6069),
    [anon_sym_AMP] = ACTIONS(6071),
    [anon_sym_PIPE_PIPE] = ACTIONS(6073),
    [anon_sym_AMP_AMP] = ACTIONS(6075),
    [anon_sym_LT] = ACTIONS(6077),
    [anon_sym_LT_EQ] = ACTIONS(6079),
    [anon_sym_GT] = ACTIONS(6077),
    [anon_sym_GT_EQ] = ACTIONS(6079),
    [anon_sym_EQ_EQ] = ACTIONS(6079),
    [anon_sym_BANG_EQ] = ACTIONS(6079),
    [anon_sym_STAR] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6083),
    [anon_sym_STAR_STAR] = ACTIONS(6085),
    [anon_sym_CARET] = ACTIONS(6085),
    [aux_sym_binary_operator_token1] = ACTIONS(6087),
    [anon_sym_PIPE_GT] = ACTIONS(6087),
    [anon_sym_COLON] = ACTIONS(6089),
    [anon_sym_DOLLAR] = ACTIONS(6091),
    [anon_sym_AT] = ACTIONS(6091),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6093),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6095),
    [sym__external_open_bracket2] = ACTIONS(6097),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [1113] = {
    [sym_call_arguments] = STATE(2638),
    [sym_subset_arguments] = STATE(2647),
    [sym_subset2_arguments] = STATE(2650),
    [sym__open_parenthesis] = STATE(1537),
    [sym__open_bracket] = STATE(1534),
    [sym__open_bracket2] = STATE(1533),
    [sym_identifier] = ACTIONS(5401),
    [anon_sym_BSLASH] = ACTIONS(5399),
    [anon_sym_function] = ACTIONS(5401),
    [anon_sym_EQ] = ACTIONS(6055),
    [anon_sym_if] = ACTIONS(5401),
    [anon_sym_for] = ACTIONS(5401),
    [anon_sym_while] = ACTIONS(5401),
    [anon_sym_repeat] = ACTIONS(5401),
    [anon_sym_QMARK] = ACTIONS(5399),
    [anon_sym_TILDE] = ACTIONS(6057),
    [anon_sym_BANG] = ACTIONS(5401),
    [anon_sym_PLUS] = ACTIONS(6059),
    [anon_sym_DASH] = ACTIONS(6061),
    [anon_sym_LT_DASH] = ACTIONS(6063),
    [anon_sym_LT_LT_DASH] = ACTIONS(6063),
    [anon_sym_COLON_EQ] = ACTIONS(6063),
    [anon_sym_DASH_GT] = ACTIONS(6065),
    [anon_sym_DASH_GT_GT] = ACTIONS(6067),
    [anon_sym_PIPE] = ACTIONS(6069),
    [anon_sym_AMP] = ACTIONS(6071),
    [anon_sym_PIPE_PIPE] = ACTIONS(6073),
    [anon_sym_AMP_AMP] = ACTIONS(6075),
    [anon_sym_LT] = ACTIONS(6077),
    [anon_sym_LT_EQ] = ACTIONS(6079),
    [anon_sym_GT] = ACTIONS(6077),
    [anon_sym_GT_EQ] = ACTIONS(6079),
    [anon_sym_EQ_EQ] = ACTIONS(6079),
    [anon_sym_BANG_EQ] = ACTIONS(6079),
    [anon_sym_STAR] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6083),
    [anon_sym_STAR_STAR] = ACTIONS(6085),
    [anon_sym_CARET] = ACTIONS(6085),
    [aux_sym_binary_operator_token1] = ACTIONS(6087),
    [anon_sym_PIPE_GT] = ACTIONS(6087),
    [anon_sym_COLON] = ACTIONS(6089),
    [anon_sym_DOLLAR] = ACTIONS(6091),
    [anon_sym_AT] = ACTIONS(6091),
    [aux_sym__hex_literal_token1] = ACTIONS(5399),
    [sym__number_literal] = ACTIONS(5401),
    [anon_sym_SQUOTE] = ACTIONS(5399),
    [anon_sym_DQUOTE] = ACTIONS(5399),
    [sym_return] = ACTIONS(5401),
    [sym_next] = ACTIONS(5401),
    [sym_break] = ACTIONS(5401),
    [sym_true] = ACTIONS(5401),
    [sym_false] = ACTIONS(5401),
    [sym_null] = ACTIONS(5401),
    [sym_inf] = ACTIONS(5401),
    [sym_nan] = ACTIONS(5401),
    [anon_sym_NA] = ACTIONS(5401),
    [anon_sym_NA_integer_] = ACTIONS(5401),
    [anon_sym_NA_real_] = ACTIONS(5401),
    [anon_sym_NA_complex_] = ACTIONS(5401),
    [anon_sym_NA_character_] = ACTIONS(5401),
    [sym_dots] = ACTIONS(5401),
    [sym_dot_dot_i] = ACTIONS(5399),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5399),
    [sym__newline] = ACTIONS(5399),
    [sym__semicolon] = ACTIONS(5399),
    [sym__raw_string_literal] = ACTIONS(5399),
    [sym__external_open_parenthesis] = ACTIONS(6093),
    [sym__external_open_brace] = ACTIONS(5399),
    [sym__external_close_brace] = ACTIONS(5399),
    [sym__external_open_bracket] = ACTIONS(6095),
    [sym__external_open_bracket2] = ACTIONS(6097),
    [sym__external_close_bracket2] = ACTIONS(5399),
  },
  [1114] = {
    [sym_call_arguments] = STATE(2638),
    [sym_subset_arguments] = STATE(2647),
    [sym_subset2_arguments] = STATE(2650),
    [sym__open_parenthesis] = STATE(1537),
    [sym__open_bracket] = STATE(1534),
    [sym__open_bracket2] = STATE(1533),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(6085),
    [anon_sym_CARET] = ACTIONS(6085),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(5351),
    [anon_sym_DOLLAR] = ACTIONS(6091),
    [anon_sym_AT] = ACTIONS(6091),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6093),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6095),
    [sym__external_open_bracket2] = ACTIONS(6097),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [1115] = {
    [sym_call_arguments] = STATE(2638),
    [sym_subset_arguments] = STATE(2647),
    [sym_subset2_arguments] = STATE(2650),
    [sym__open_parenthesis] = STATE(1537),
    [sym__open_bracket] = STATE(1534),
    [sym__open_bracket2] = STATE(1533),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(6085),
    [anon_sym_CARET] = ACTIONS(6085),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(6089),
    [anon_sym_DOLLAR] = ACTIONS(6091),
    [anon_sym_AT] = ACTIONS(6091),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6093),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6095),
    [sym__external_open_bracket2] = ACTIONS(6097),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [1116] = {
    [sym_call_arguments] = STATE(2638),
    [sym_subset_arguments] = STATE(2647),
    [sym_subset2_arguments] = STATE(2650),
    [sym__open_parenthesis] = STATE(1537),
    [sym__open_bracket] = STATE(1534),
    [sym__open_bracket2] = STATE(1533),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(6085),
    [anon_sym_CARET] = ACTIONS(6085),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(5351),
    [anon_sym_DOLLAR] = ACTIONS(6091),
    [anon_sym_AT] = ACTIONS(6091),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6093),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6095),
    [sym__external_open_bracket2] = ACTIONS(6097),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [1117] = {
    [sym_call_arguments] = STATE(2638),
    [sym_subset_arguments] = STATE(2647),
    [sym_subset2_arguments] = STATE(2650),
    [sym__open_parenthesis] = STATE(1537),
    [sym__open_bracket] = STATE(1534),
    [sym__open_bracket2] = STATE(1533),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(6085),
    [anon_sym_CARET] = ACTIONS(6085),
    [aux_sym_binary_operator_token1] = ACTIONS(6087),
    [anon_sym_PIPE_GT] = ACTIONS(6087),
    [anon_sym_COLON] = ACTIONS(6089),
    [anon_sym_DOLLAR] = ACTIONS(6091),
    [anon_sym_AT] = ACTIONS(6091),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6093),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6095),
    [sym__external_open_bracket2] = ACTIONS(6097),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [1118] = {
    [sym_call_arguments] = STATE(2638),
    [sym_subset_arguments] = STATE(2647),
    [sym_subset2_arguments] = STATE(2650),
    [sym__open_parenthesis] = STATE(1537),
    [sym__open_bracket] = STATE(1534),
    [sym__open_bracket2] = STATE(1533),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(6059),
    [anon_sym_DASH] = ACTIONS(6061),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6083),
    [anon_sym_STAR_STAR] = ACTIONS(6085),
    [anon_sym_CARET] = ACTIONS(6085),
    [aux_sym_binary_operator_token1] = ACTIONS(6087),
    [anon_sym_PIPE_GT] = ACTIONS(6087),
    [anon_sym_COLON] = ACTIONS(6089),
    [anon_sym_DOLLAR] = ACTIONS(6091),
    [anon_sym_AT] = ACTIONS(6091),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6093),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6095),
    [sym__external_open_bracket2] = ACTIONS(6097),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [1119] = {
    [sym_call_arguments] = STATE(2638),
    [sym_subset_arguments] = STATE(2647),
    [sym_subset2_arguments] = STATE(2650),
    [sym__open_parenthesis] = STATE(1537),
    [sym__open_bracket] = STATE(1534),
    [sym__open_bracket2] = STATE(1533),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(6059),
    [anon_sym_DASH] = ACTIONS(6061),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(6077),
    [anon_sym_LT_EQ] = ACTIONS(6079),
    [anon_sym_GT] = ACTIONS(6077),
    [anon_sym_GT_EQ] = ACTIONS(6079),
    [anon_sym_EQ_EQ] = ACTIONS(6079),
    [anon_sym_BANG_EQ] = ACTIONS(6079),
    [anon_sym_STAR] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6083),
    [anon_sym_STAR_STAR] = ACTIONS(6085),
    [anon_sym_CARET] = ACTIONS(6085),
    [aux_sym_binary_operator_token1] = ACTIONS(6087),
    [anon_sym_PIPE_GT] = ACTIONS(6087),
    [anon_sym_COLON] = ACTIONS(6089),
    [anon_sym_DOLLAR] = ACTIONS(6091),
    [anon_sym_AT] = ACTIONS(6091),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6093),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6095),
    [sym__external_open_bracket2] = ACTIONS(6097),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [1120] = {
    [sym_call_arguments] = STATE(2638),
    [sym_subset_arguments] = STATE(2647),
    [sym_subset2_arguments] = STATE(2650),
    [sym__open_parenthesis] = STATE(1537),
    [sym__open_bracket] = STATE(1534),
    [sym__open_bracket2] = STATE(1533),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(6059),
    [anon_sym_DASH] = ACTIONS(6061),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(6071),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(6075),
    [anon_sym_LT] = ACTIONS(6077),
    [anon_sym_LT_EQ] = ACTIONS(6079),
    [anon_sym_GT] = ACTIONS(6077),
    [anon_sym_GT_EQ] = ACTIONS(6079),
    [anon_sym_EQ_EQ] = ACTIONS(6079),
    [anon_sym_BANG_EQ] = ACTIONS(6079),
    [anon_sym_STAR] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6083),
    [anon_sym_STAR_STAR] = ACTIONS(6085),
    [anon_sym_CARET] = ACTIONS(6085),
    [aux_sym_binary_operator_token1] = ACTIONS(6087),
    [anon_sym_PIPE_GT] = ACTIONS(6087),
    [anon_sym_COLON] = ACTIONS(6089),
    [anon_sym_DOLLAR] = ACTIONS(6091),
    [anon_sym_AT] = ACTIONS(6091),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6093),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6095),
    [sym__external_open_bracket2] = ACTIONS(6097),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [1121] = {
    [sym_call_arguments] = STATE(2638),
    [sym_subset_arguments] = STATE(2647),
    [sym_subset2_arguments] = STATE(2650),
    [sym__open_parenthesis] = STATE(1537),
    [sym__open_bracket] = STATE(1534),
    [sym__open_bracket2] = STATE(1533),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(6057),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(6059),
    [anon_sym_DASH] = ACTIONS(6061),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(6069),
    [anon_sym_AMP] = ACTIONS(6071),
    [anon_sym_PIPE_PIPE] = ACTIONS(6073),
    [anon_sym_AMP_AMP] = ACTIONS(6075),
    [anon_sym_LT] = ACTIONS(6077),
    [anon_sym_LT_EQ] = ACTIONS(6079),
    [anon_sym_GT] = ACTIONS(6077),
    [anon_sym_GT_EQ] = ACTIONS(6079),
    [anon_sym_EQ_EQ] = ACTIONS(6079),
    [anon_sym_BANG_EQ] = ACTIONS(6079),
    [anon_sym_STAR] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6083),
    [anon_sym_STAR_STAR] = ACTIONS(6085),
    [anon_sym_CARET] = ACTIONS(6085),
    [aux_sym_binary_operator_token1] = ACTIONS(6087),
    [anon_sym_PIPE_GT] = ACTIONS(6087),
    [anon_sym_COLON] = ACTIONS(6089),
    [anon_sym_DOLLAR] = ACTIONS(6091),
    [anon_sym_AT] = ACTIONS(6091),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6093),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6095),
    [sym__external_open_bracket2] = ACTIONS(6097),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [1122] = {
    [sym_call_arguments] = STATE(2638),
    [sym_subset_arguments] = STATE(2647),
    [sym_subset2_arguments] = STATE(2650),
    [sym__open_parenthesis] = STATE(1537),
    [sym__open_bracket] = STATE(1534),
    [sym__open_bracket2] = STATE(1533),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(6055),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(6057),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(6059),
    [anon_sym_DASH] = ACTIONS(6061),
    [anon_sym_LT_DASH] = ACTIONS(6063),
    [anon_sym_LT_LT_DASH] = ACTIONS(6063),
    [anon_sym_COLON_EQ] = ACTIONS(6063),
    [anon_sym_DASH_GT] = ACTIONS(6065),
    [anon_sym_DASH_GT_GT] = ACTIONS(6067),
    [anon_sym_PIPE] = ACTIONS(6069),
    [anon_sym_AMP] = ACTIONS(6071),
    [anon_sym_PIPE_PIPE] = ACTIONS(6073),
    [anon_sym_AMP_AMP] = ACTIONS(6075),
    [anon_sym_LT] = ACTIONS(6077),
    [anon_sym_LT_EQ] = ACTIONS(6079),
    [anon_sym_GT] = ACTIONS(6077),
    [anon_sym_GT_EQ] = ACTIONS(6079),
    [anon_sym_EQ_EQ] = ACTIONS(6079),
    [anon_sym_BANG_EQ] = ACTIONS(6079),
    [anon_sym_STAR] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6083),
    [anon_sym_STAR_STAR] = ACTIONS(6085),
    [anon_sym_CARET] = ACTIONS(6085),
    [aux_sym_binary_operator_token1] = ACTIONS(6087),
    [anon_sym_PIPE_GT] = ACTIONS(6087),
    [anon_sym_COLON] = ACTIONS(6089),
    [anon_sym_DOLLAR] = ACTIONS(6091),
    [anon_sym_AT] = ACTIONS(6091),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6093),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6095),
    [sym__external_open_bracket2] = ACTIONS(6097),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [1123] = {
    [sym_call_arguments] = STATE(2638),
    [sym_subset_arguments] = STATE(2647),
    [sym_subset2_arguments] = STATE(2650),
    [sym__open_parenthesis] = STATE(1537),
    [sym__open_bracket] = STATE(1534),
    [sym__open_bracket2] = STATE(1533),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6083),
    [anon_sym_STAR_STAR] = ACTIONS(6085),
    [anon_sym_CARET] = ACTIONS(6085),
    [aux_sym_binary_operator_token1] = ACTIONS(6087),
    [anon_sym_PIPE_GT] = ACTIONS(6087),
    [anon_sym_COLON] = ACTIONS(6089),
    [anon_sym_DOLLAR] = ACTIONS(6091),
    [anon_sym_AT] = ACTIONS(6091),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6093),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6095),
    [sym__external_open_bracket2] = ACTIONS(6097),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [1124] = {
    [sym_call_arguments] = STATE(2638),
    [sym_subset_arguments] = STATE(2647),
    [sym_subset2_arguments] = STATE(2650),
    [sym__open_parenthesis] = STATE(1537),
    [sym__open_bracket] = STATE(1534),
    [sym__open_bracket2] = STATE(1533),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(6059),
    [anon_sym_DASH] = ACTIONS(6061),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(6069),
    [anon_sym_AMP] = ACTIONS(6071),
    [anon_sym_PIPE_PIPE] = ACTIONS(6073),
    [anon_sym_AMP_AMP] = ACTIONS(6075),
    [anon_sym_LT] = ACTIONS(6077),
    [anon_sym_LT_EQ] = ACTIONS(6079),
    [anon_sym_GT] = ACTIONS(6077),
    [anon_sym_GT_EQ] = ACTIONS(6079),
    [anon_sym_EQ_EQ] = ACTIONS(6079),
    [anon_sym_BANG_EQ] = ACTIONS(6079),
    [anon_sym_STAR] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6083),
    [anon_sym_STAR_STAR] = ACTIONS(6085),
    [anon_sym_CARET] = ACTIONS(6085),
    [aux_sym_binary_operator_token1] = ACTIONS(6087),
    [anon_sym_PIPE_GT] = ACTIONS(6087),
    [anon_sym_COLON] = ACTIONS(6089),
    [anon_sym_DOLLAR] = ACTIONS(6091),
    [anon_sym_AT] = ACTIONS(6091),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6093),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6095),
    [sym__external_open_bracket2] = ACTIONS(6097),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [1125] = {
    [sym_call_arguments] = STATE(2638),
    [sym_subset_arguments] = STATE(2647),
    [sym_subset2_arguments] = STATE(2650),
    [sym__open_parenthesis] = STATE(1537),
    [sym__open_bracket] = STATE(1534),
    [sym__open_bracket2] = STATE(1533),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(6055),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(6057),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(6059),
    [anon_sym_DASH] = ACTIONS(6061),
    [anon_sym_LT_DASH] = ACTIONS(6063),
    [anon_sym_LT_LT_DASH] = ACTIONS(6063),
    [anon_sym_COLON_EQ] = ACTIONS(6063),
    [anon_sym_DASH_GT] = ACTIONS(6065),
    [anon_sym_DASH_GT_GT] = ACTIONS(6067),
    [anon_sym_PIPE] = ACTIONS(6069),
    [anon_sym_AMP] = ACTIONS(6071),
    [anon_sym_PIPE_PIPE] = ACTIONS(6073),
    [anon_sym_AMP_AMP] = ACTIONS(6075),
    [anon_sym_LT] = ACTIONS(6077),
    [anon_sym_LT_EQ] = ACTIONS(6079),
    [anon_sym_GT] = ACTIONS(6077),
    [anon_sym_GT_EQ] = ACTIONS(6079),
    [anon_sym_EQ_EQ] = ACTIONS(6079),
    [anon_sym_BANG_EQ] = ACTIONS(6079),
    [anon_sym_STAR] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6083),
    [anon_sym_STAR_STAR] = ACTIONS(6085),
    [anon_sym_CARET] = ACTIONS(6085),
    [aux_sym_binary_operator_token1] = ACTIONS(6087),
    [anon_sym_PIPE_GT] = ACTIONS(6087),
    [anon_sym_COLON] = ACTIONS(6089),
    [anon_sym_DOLLAR] = ACTIONS(6091),
    [anon_sym_AT] = ACTIONS(6091),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6093),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6095),
    [sym__external_open_bracket2] = ACTIONS(6097),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [1126] = {
    [sym_call_arguments] = STATE(2638),
    [sym_subset_arguments] = STATE(2647),
    [sym_subset2_arguments] = STATE(2650),
    [sym__open_parenthesis] = STATE(1537),
    [sym__open_bracket] = STATE(1534),
    [sym__open_bracket2] = STATE(1533),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(6055),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(6057),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(6059),
    [anon_sym_DASH] = ACTIONS(6061),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(6065),
    [anon_sym_DASH_GT_GT] = ACTIONS(6067),
    [anon_sym_PIPE] = ACTIONS(6069),
    [anon_sym_AMP] = ACTIONS(6071),
    [anon_sym_PIPE_PIPE] = ACTIONS(6073),
    [anon_sym_AMP_AMP] = ACTIONS(6075),
    [anon_sym_LT] = ACTIONS(6077),
    [anon_sym_LT_EQ] = ACTIONS(6079),
    [anon_sym_GT] = ACTIONS(6077),
    [anon_sym_GT_EQ] = ACTIONS(6079),
    [anon_sym_EQ_EQ] = ACTIONS(6079),
    [anon_sym_BANG_EQ] = ACTIONS(6079),
    [anon_sym_STAR] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6083),
    [anon_sym_STAR_STAR] = ACTIONS(6085),
    [anon_sym_CARET] = ACTIONS(6085),
    [aux_sym_binary_operator_token1] = ACTIONS(6087),
    [anon_sym_PIPE_GT] = ACTIONS(6087),
    [anon_sym_COLON] = ACTIONS(6089),
    [anon_sym_DOLLAR] = ACTIONS(6091),
    [anon_sym_AT] = ACTIONS(6091),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6093),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6095),
    [sym__external_open_bracket2] = ACTIONS(6097),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [1127] = {
    [sym_call_arguments] = STATE(2638),
    [sym_subset_arguments] = STATE(2647),
    [sym_subset2_arguments] = STATE(2650),
    [sym__open_parenthesis] = STATE(1537),
    [sym__open_bracket] = STATE(1534),
    [sym__open_bracket2] = STATE(1533),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5345),
    [anon_sym_DASH] = ACTIONS(5347),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5347),
    [anon_sym_AMP] = ACTIONS(5347),
    [anon_sym_PIPE_PIPE] = ACTIONS(5345),
    [anon_sym_AMP_AMP] = ACTIONS(5345),
    [anon_sym_LT] = ACTIONS(5347),
    [anon_sym_LT_EQ] = ACTIONS(5345),
    [anon_sym_GT] = ACTIONS(5347),
    [anon_sym_GT_EQ] = ACTIONS(5345),
    [anon_sym_EQ_EQ] = ACTIONS(5345),
    [anon_sym_BANG_EQ] = ACTIONS(5345),
    [anon_sym_STAR] = ACTIONS(5347),
    [anon_sym_SLASH] = ACTIONS(5345),
    [anon_sym_STAR_STAR] = ACTIONS(6085),
    [anon_sym_CARET] = ACTIONS(6085),
    [aux_sym_binary_operator_token1] = ACTIONS(5345),
    [anon_sym_PIPE_GT] = ACTIONS(5345),
    [anon_sym_COLON] = ACTIONS(5347),
    [anon_sym_DOLLAR] = ACTIONS(6091),
    [anon_sym_AT] = ACTIONS(6091),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__semicolon] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(6093),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_close_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(6095),
    [sym__external_open_bracket2] = ACTIONS(6097),
    [sym__external_close_bracket2] = ACTIONS(5345),
  },
  [1128] = {
    [sym_call_arguments] = STATE(2638),
    [sym_subset_arguments] = STATE(2647),
    [sym_subset2_arguments] = STATE(2650),
    [sym__open_parenthesis] = STATE(1537),
    [sym__open_bracket] = STATE(1534),
    [sym__open_bracket2] = STATE(1533),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(6059),
    [anon_sym_DASH] = ACTIONS(6061),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5347),
    [anon_sym_AMP] = ACTIONS(5347),
    [anon_sym_PIPE_PIPE] = ACTIONS(5345),
    [anon_sym_AMP_AMP] = ACTIONS(5345),
    [anon_sym_LT] = ACTIONS(6077),
    [anon_sym_LT_EQ] = ACTIONS(6079),
    [anon_sym_GT] = ACTIONS(6077),
    [anon_sym_GT_EQ] = ACTIONS(6079),
    [anon_sym_EQ_EQ] = ACTIONS(6079),
    [anon_sym_BANG_EQ] = ACTIONS(6079),
    [anon_sym_STAR] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6083),
    [anon_sym_STAR_STAR] = ACTIONS(6085),
    [anon_sym_CARET] = ACTIONS(6085),
    [aux_sym_binary_operator_token1] = ACTIONS(6087),
    [anon_sym_PIPE_GT] = ACTIONS(6087),
    [anon_sym_COLON] = ACTIONS(6089),
    [anon_sym_DOLLAR] = ACTIONS(6091),
    [anon_sym_AT] = ACTIONS(6091),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__semicolon] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(6093),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_close_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(6095),
    [sym__external_open_bracket2] = ACTIONS(6097),
    [sym__external_close_bracket2] = ACTIONS(5345),
  },
  [1129] = {
    [sym_call_arguments] = STATE(2638),
    [sym_subset_arguments] = STATE(2647),
    [sym_subset2_arguments] = STATE(2650),
    [sym__open_parenthesis] = STATE(1537),
    [sym__open_bracket] = STATE(1534),
    [sym__open_bracket2] = STATE(1533),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(6059),
    [anon_sym_DASH] = ACTIONS(6061),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(6069),
    [anon_sym_AMP] = ACTIONS(6071),
    [anon_sym_PIPE_PIPE] = ACTIONS(6073),
    [anon_sym_AMP_AMP] = ACTIONS(6075),
    [anon_sym_LT] = ACTIONS(6077),
    [anon_sym_LT_EQ] = ACTIONS(6079),
    [anon_sym_GT] = ACTIONS(6077),
    [anon_sym_GT_EQ] = ACTIONS(6079),
    [anon_sym_EQ_EQ] = ACTIONS(6079),
    [anon_sym_BANG_EQ] = ACTIONS(6079),
    [anon_sym_STAR] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6083),
    [anon_sym_STAR_STAR] = ACTIONS(6085),
    [anon_sym_CARET] = ACTIONS(6085),
    [aux_sym_binary_operator_token1] = ACTIONS(6087),
    [anon_sym_PIPE_GT] = ACTIONS(6087),
    [anon_sym_COLON] = ACTIONS(6089),
    [anon_sym_DOLLAR] = ACTIONS(6091),
    [anon_sym_AT] = ACTIONS(6091),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__semicolon] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(6093),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_close_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(6095),
    [sym__external_open_bracket2] = ACTIONS(6097),
    [sym__external_close_bracket2] = ACTIONS(5345),
  },
  [1130] = {
    [sym_call_arguments] = STATE(2638),
    [sym_subset_arguments] = STATE(2647),
    [sym_subset2_arguments] = STATE(2650),
    [sym__open_parenthesis] = STATE(1537),
    [sym__open_bracket] = STATE(1534),
    [sym__open_bracket2] = STATE(1533),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(6055),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(6057),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(6059),
    [anon_sym_DASH] = ACTIONS(6061),
    [anon_sym_LT_DASH] = ACTIONS(6063),
    [anon_sym_LT_LT_DASH] = ACTIONS(6063),
    [anon_sym_COLON_EQ] = ACTIONS(6063),
    [anon_sym_DASH_GT] = ACTIONS(6065),
    [anon_sym_DASH_GT_GT] = ACTIONS(6067),
    [anon_sym_PIPE] = ACTIONS(6069),
    [anon_sym_AMP] = ACTIONS(6071),
    [anon_sym_PIPE_PIPE] = ACTIONS(6073),
    [anon_sym_AMP_AMP] = ACTIONS(6075),
    [anon_sym_LT] = ACTIONS(6077),
    [anon_sym_LT_EQ] = ACTIONS(6079),
    [anon_sym_GT] = ACTIONS(6077),
    [anon_sym_GT_EQ] = ACTIONS(6079),
    [anon_sym_EQ_EQ] = ACTIONS(6079),
    [anon_sym_BANG_EQ] = ACTIONS(6079),
    [anon_sym_STAR] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6083),
    [anon_sym_STAR_STAR] = ACTIONS(6085),
    [anon_sym_CARET] = ACTIONS(6085),
    [aux_sym_binary_operator_token1] = ACTIONS(6087),
    [anon_sym_PIPE_GT] = ACTIONS(6087),
    [anon_sym_COLON] = ACTIONS(6089),
    [anon_sym_DOLLAR] = ACTIONS(6091),
    [anon_sym_AT] = ACTIONS(6091),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__semicolon] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(6093),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_close_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(6095),
    [sym__external_open_bracket2] = ACTIONS(6097),
    [sym__external_close_bracket2] = ACTIONS(5345),
  },
  [1131] = {
    [sym_call_arguments] = STATE(2638),
    [sym_subset_arguments] = STATE(2647),
    [sym_subset2_arguments] = STATE(2650),
    [sym__open_parenthesis] = STATE(1537),
    [sym__open_bracket] = STATE(1534),
    [sym__open_bracket2] = STATE(1533),
    [sym_identifier] = ACTIONS(5343),
    [anon_sym_BSLASH] = ACTIONS(5341),
    [anon_sym_function] = ACTIONS(5343),
    [anon_sym_EQ] = ACTIONS(6055),
    [anon_sym_if] = ACTIONS(5343),
    [anon_sym_for] = ACTIONS(5343),
    [anon_sym_while] = ACTIONS(5343),
    [anon_sym_repeat] = ACTIONS(5343),
    [anon_sym_QMARK] = ACTIONS(5341),
    [anon_sym_TILDE] = ACTIONS(6057),
    [anon_sym_BANG] = ACTIONS(5343),
    [anon_sym_PLUS] = ACTIONS(6059),
    [anon_sym_DASH] = ACTIONS(6061),
    [anon_sym_LT_DASH] = ACTIONS(6063),
    [anon_sym_LT_LT_DASH] = ACTIONS(6063),
    [anon_sym_COLON_EQ] = ACTIONS(6063),
    [anon_sym_DASH_GT] = ACTIONS(6065),
    [anon_sym_DASH_GT_GT] = ACTIONS(6067),
    [anon_sym_PIPE] = ACTIONS(6069),
    [anon_sym_AMP] = ACTIONS(6071),
    [anon_sym_PIPE_PIPE] = ACTIONS(6073),
    [anon_sym_AMP_AMP] = ACTIONS(6075),
    [anon_sym_LT] = ACTIONS(6077),
    [anon_sym_LT_EQ] = ACTIONS(6079),
    [anon_sym_GT] = ACTIONS(6077),
    [anon_sym_GT_EQ] = ACTIONS(6079),
    [anon_sym_EQ_EQ] = ACTIONS(6079),
    [anon_sym_BANG_EQ] = ACTIONS(6079),
    [anon_sym_STAR] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6083),
    [anon_sym_STAR_STAR] = ACTIONS(6085),
    [anon_sym_CARET] = ACTIONS(6085),
    [aux_sym_binary_operator_token1] = ACTIONS(6087),
    [anon_sym_PIPE_GT] = ACTIONS(6087),
    [anon_sym_COLON] = ACTIONS(6089),
    [anon_sym_DOLLAR] = ACTIONS(6091),
    [anon_sym_AT] = ACTIONS(6091),
    [aux_sym__hex_literal_token1] = ACTIONS(5341),
    [sym__number_literal] = ACTIONS(5343),
    [anon_sym_SQUOTE] = ACTIONS(5341),
    [anon_sym_DQUOTE] = ACTIONS(5341),
    [sym_return] = ACTIONS(5343),
    [sym_next] = ACTIONS(5343),
    [sym_break] = ACTIONS(5343),
    [sym_true] = ACTIONS(5343),
    [sym_false] = ACTIONS(5343),
    [sym_null] = ACTIONS(5343),
    [sym_inf] = ACTIONS(5343),
    [sym_nan] = ACTIONS(5343),
    [anon_sym_NA] = ACTIONS(5343),
    [anon_sym_NA_integer_] = ACTIONS(5343),
    [anon_sym_NA_real_] = ACTIONS(5343),
    [anon_sym_NA_complex_] = ACTIONS(5343),
    [anon_sym_NA_character_] = ACTIONS(5343),
    [sym_dots] = ACTIONS(5343),
    [sym_dot_dot_i] = ACTIONS(5341),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5341),
    [sym__newline] = ACTIONS(5341),
    [sym__semicolon] = ACTIONS(5341),
    [sym__raw_string_literal] = ACTIONS(5341),
    [sym__external_open_parenthesis] = ACTIONS(6093),
    [sym__external_open_brace] = ACTIONS(5341),
    [sym__external_close_brace] = ACTIONS(5341),
    [sym__external_open_bracket] = ACTIONS(6095),
    [sym__external_open_bracket2] = ACTIONS(6097),
    [sym__external_close_bracket2] = ACTIONS(5341),
  },
  [1132] = {
    [sym_call_arguments] = STATE(2638),
    [sym_subset_arguments] = STATE(2647),
    [sym_subset2_arguments] = STATE(2650),
    [sym__open_parenthesis] = STATE(1537),
    [sym__open_bracket] = STATE(1534),
    [sym__open_bracket2] = STATE(1533),
    [sym_identifier] = ACTIONS(5339),
    [anon_sym_BSLASH] = ACTIONS(5337),
    [anon_sym_function] = ACTIONS(5339),
    [anon_sym_EQ] = ACTIONS(6055),
    [anon_sym_if] = ACTIONS(5339),
    [anon_sym_for] = ACTIONS(5339),
    [anon_sym_while] = ACTIONS(5339),
    [anon_sym_repeat] = ACTIONS(5339),
    [anon_sym_QMARK] = ACTIONS(5337),
    [anon_sym_TILDE] = ACTIONS(6057),
    [anon_sym_BANG] = ACTIONS(5339),
    [anon_sym_PLUS] = ACTIONS(6059),
    [anon_sym_DASH] = ACTIONS(6061),
    [anon_sym_LT_DASH] = ACTIONS(6063),
    [anon_sym_LT_LT_DASH] = ACTIONS(6063),
    [anon_sym_COLON_EQ] = ACTIONS(6063),
    [anon_sym_DASH_GT] = ACTIONS(6065),
    [anon_sym_DASH_GT_GT] = ACTIONS(6067),
    [anon_sym_PIPE] = ACTIONS(6069),
    [anon_sym_AMP] = ACTIONS(6071),
    [anon_sym_PIPE_PIPE] = ACTIONS(6073),
    [anon_sym_AMP_AMP] = ACTIONS(6075),
    [anon_sym_LT] = ACTIONS(6077),
    [anon_sym_LT_EQ] = ACTIONS(6079),
    [anon_sym_GT] = ACTIONS(6077),
    [anon_sym_GT_EQ] = ACTIONS(6079),
    [anon_sym_EQ_EQ] = ACTIONS(6079),
    [anon_sym_BANG_EQ] = ACTIONS(6079),
    [anon_sym_STAR] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6083),
    [anon_sym_STAR_STAR] = ACTIONS(6085),
    [anon_sym_CARET] = ACTIONS(6085),
    [aux_sym_binary_operator_token1] = ACTIONS(6087),
    [anon_sym_PIPE_GT] = ACTIONS(6087),
    [anon_sym_COLON] = ACTIONS(6089),
    [anon_sym_DOLLAR] = ACTIONS(6091),
    [anon_sym_AT] = ACTIONS(6091),
    [aux_sym__hex_literal_token1] = ACTIONS(5337),
    [sym__number_literal] = ACTIONS(5339),
    [anon_sym_SQUOTE] = ACTIONS(5337),
    [anon_sym_DQUOTE] = ACTIONS(5337),
    [sym_return] = ACTIONS(5339),
    [sym_next] = ACTIONS(5339),
    [sym_break] = ACTIONS(5339),
    [sym_true] = ACTIONS(5339),
    [sym_false] = ACTIONS(5339),
    [sym_null] = ACTIONS(5339),
    [sym_inf] = ACTIONS(5339),
    [sym_nan] = ACTIONS(5339),
    [anon_sym_NA] = ACTIONS(5339),
    [anon_sym_NA_integer_] = ACTIONS(5339),
    [anon_sym_NA_real_] = ACTIONS(5339),
    [anon_sym_NA_complex_] = ACTIONS(5339),
    [anon_sym_NA_character_] = ACTIONS(5339),
    [sym_dots] = ACTIONS(5339),
    [sym_dot_dot_i] = ACTIONS(5337),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5337),
    [sym__newline] = ACTIONS(5337),
    [sym__semicolon] = ACTIONS(5337),
    [sym__raw_string_literal] = ACTIONS(5337),
    [sym__external_open_parenthesis] = ACTIONS(6093),
    [sym__external_open_brace] = ACTIONS(5337),
    [sym__external_close_brace] = ACTIONS(5337),
    [sym__external_open_bracket] = ACTIONS(6095),
    [sym__external_open_bracket2] = ACTIONS(6097),
    [sym__external_close_bracket2] = ACTIONS(5337),
  },
  [1133] = {
    [sym_call_arguments] = STATE(2651),
    [sym_subset_arguments] = STATE(2561),
    [sym_subset2_arguments] = STATE(2648),
    [sym__open_parenthesis] = STATE(1340),
    [sym__open_bracket] = STATE(1335),
    [sym__open_bracket2] = STATE(1334),
    [sym_identifier] = ACTIONS(5311),
    [anon_sym_BSLASH] = ACTIONS(5313),
    [anon_sym_function] = ACTIONS(5311),
    [anon_sym_EQ] = ACTIONS(5675),
    [anon_sym_if] = ACTIONS(5311),
    [anon_sym_for] = ACTIONS(5311),
    [anon_sym_while] = ACTIONS(5311),
    [anon_sym_repeat] = ACTIONS(5311),
    [anon_sym_QMARK] = ACTIONS(6107),
    [anon_sym_TILDE] = ACTIONS(5677),
    [anon_sym_BANG] = ACTIONS(5311),
    [anon_sym_PLUS] = ACTIONS(5679),
    [anon_sym_DASH] = ACTIONS(5681),
    [anon_sym_LT_DASH] = ACTIONS(5683),
    [anon_sym_LT_LT_DASH] = ACTIONS(5683),
    [anon_sym_COLON_EQ] = ACTIONS(5683),
    [anon_sym_DASH_GT] = ACTIONS(5685),
    [anon_sym_DASH_GT_GT] = ACTIONS(5687),
    [anon_sym_PIPE] = ACTIONS(5689),
    [anon_sym_AMP] = ACTIONS(5691),
    [anon_sym_PIPE_PIPE] = ACTIONS(5693),
    [anon_sym_AMP_AMP] = ACTIONS(5695),
    [anon_sym_LT] = ACTIONS(5697),
    [anon_sym_LT_EQ] = ACTIONS(5699),
    [anon_sym_GT] = ACTIONS(5697),
    [anon_sym_GT_EQ] = ACTIONS(5699),
    [anon_sym_EQ_EQ] = ACTIONS(5699),
    [anon_sym_BANG_EQ] = ACTIONS(5699),
    [anon_sym_STAR] = ACTIONS(5701),
    [anon_sym_SLASH] = ACTIONS(5703),
    [anon_sym_STAR_STAR] = ACTIONS(5705),
    [anon_sym_CARET] = ACTIONS(5705),
    [aux_sym_binary_operator_token1] = ACTIONS(5707),
    [anon_sym_PIPE_GT] = ACTIONS(5707),
    [anon_sym_COLON] = ACTIONS(5709),
    [anon_sym_DOLLAR] = ACTIONS(5711),
    [anon_sym_AT] = ACTIONS(5711),
    [aux_sym__hex_literal_token1] = ACTIONS(5313),
    [sym__number_literal] = ACTIONS(5311),
    [anon_sym_SQUOTE] = ACTIONS(5313),
    [anon_sym_DQUOTE] = ACTIONS(5313),
    [sym_return] = ACTIONS(5311),
    [sym_next] = ACTIONS(5311),
    [sym_break] = ACTIONS(5311),
    [sym_true] = ACTIONS(5311),
    [sym_false] = ACTIONS(5311),
    [sym_null] = ACTIONS(5311),
    [sym_inf] = ACTIONS(5311),
    [sym_nan] = ACTIONS(5311),
    [anon_sym_NA] = ACTIONS(5311),
    [anon_sym_NA_integer_] = ACTIONS(5311),
    [anon_sym_NA_real_] = ACTIONS(5311),
    [anon_sym_NA_complex_] = ACTIONS(5311),
    [anon_sym_NA_character_] = ACTIONS(5311),
    [sym_dots] = ACTIONS(5311),
    [sym_dot_dot_i] = ACTIONS(5313),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5313),
    [sym__newline] = ACTIONS(5313),
    [sym__raw_string_literal] = ACTIONS(5313),
    [sym__external_else] = ACTIONS(5313),
    [sym__external_open_parenthesis] = ACTIONS(5715),
    [sym__external_close_parenthesis] = ACTIONS(5313),
    [sym__external_open_brace] = ACTIONS(5313),
    [sym__external_open_bracket] = ACTIONS(5717),
    [sym__external_open_bracket2] = ACTIONS(5719),
    [sym__external_close_bracket2] = ACTIONS(5313),
  },
  [1134] = {
    [sym_call_arguments] = STATE(2638),
    [sym_subset_arguments] = STATE(2647),
    [sym_subset2_arguments] = STATE(2650),
    [sym__open_parenthesis] = STATE(1537),
    [sym__open_bracket] = STATE(1534),
    [sym__open_bracket2] = STATE(1533),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(5333),
    [anon_sym_DASH] = ACTIONS(5335),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5335),
    [anon_sym_AMP] = ACTIONS(5335),
    [anon_sym_PIPE_PIPE] = ACTIONS(5333),
    [anon_sym_AMP_AMP] = ACTIONS(5333),
    [anon_sym_LT] = ACTIONS(5335),
    [anon_sym_LT_EQ] = ACTIONS(5333),
    [anon_sym_GT] = ACTIONS(5335),
    [anon_sym_GT_EQ] = ACTIONS(5333),
    [anon_sym_EQ_EQ] = ACTIONS(5333),
    [anon_sym_BANG_EQ] = ACTIONS(5333),
    [anon_sym_STAR] = ACTIONS(5335),
    [anon_sym_SLASH] = ACTIONS(5333),
    [anon_sym_STAR_STAR] = ACTIONS(6085),
    [anon_sym_CARET] = ACTIONS(6085),
    [aux_sym_binary_operator_token1] = ACTIONS(5333),
    [anon_sym_PIPE_GT] = ACTIONS(5333),
    [anon_sym_COLON] = ACTIONS(5335),
    [anon_sym_DOLLAR] = ACTIONS(6091),
    [anon_sym_AT] = ACTIONS(6091),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__semicolon] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(6093),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_close_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(6095),
    [sym__external_open_bracket2] = ACTIONS(6097),
    [sym__external_close_bracket2] = ACTIONS(5333),
  },
  [1135] = {
    [sym_call_arguments] = STATE(2638),
    [sym_subset_arguments] = STATE(2647),
    [sym_subset2_arguments] = STATE(2650),
    [sym__open_parenthesis] = STATE(1537),
    [sym__open_bracket] = STATE(1534),
    [sym__open_bracket2] = STATE(1533),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(6059),
    [anon_sym_DASH] = ACTIONS(6061),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5335),
    [anon_sym_AMP] = ACTIONS(5335),
    [anon_sym_PIPE_PIPE] = ACTIONS(5333),
    [anon_sym_AMP_AMP] = ACTIONS(5333),
    [anon_sym_LT] = ACTIONS(6077),
    [anon_sym_LT_EQ] = ACTIONS(6079),
    [anon_sym_GT] = ACTIONS(6077),
    [anon_sym_GT_EQ] = ACTIONS(6079),
    [anon_sym_EQ_EQ] = ACTIONS(6079),
    [anon_sym_BANG_EQ] = ACTIONS(6079),
    [anon_sym_STAR] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6083),
    [anon_sym_STAR_STAR] = ACTIONS(6085),
    [anon_sym_CARET] = ACTIONS(6085),
    [aux_sym_binary_operator_token1] = ACTIONS(6087),
    [anon_sym_PIPE_GT] = ACTIONS(6087),
    [anon_sym_COLON] = ACTIONS(6089),
    [anon_sym_DOLLAR] = ACTIONS(6091),
    [anon_sym_AT] = ACTIONS(6091),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__semicolon] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(6093),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_close_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(6095),
    [sym__external_open_bracket2] = ACTIONS(6097),
    [sym__external_close_bracket2] = ACTIONS(5333),
  },
  [1136] = {
    [sym_call_arguments] = STATE(2638),
    [sym_subset_arguments] = STATE(2647),
    [sym_subset2_arguments] = STATE(2650),
    [sym__open_parenthesis] = STATE(1537),
    [sym__open_bracket] = STATE(1534),
    [sym__open_bracket2] = STATE(1533),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(6059),
    [anon_sym_DASH] = ACTIONS(6061),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(6069),
    [anon_sym_AMP] = ACTIONS(6071),
    [anon_sym_PIPE_PIPE] = ACTIONS(6073),
    [anon_sym_AMP_AMP] = ACTIONS(6075),
    [anon_sym_LT] = ACTIONS(6077),
    [anon_sym_LT_EQ] = ACTIONS(6079),
    [anon_sym_GT] = ACTIONS(6077),
    [anon_sym_GT_EQ] = ACTIONS(6079),
    [anon_sym_EQ_EQ] = ACTIONS(6079),
    [anon_sym_BANG_EQ] = ACTIONS(6079),
    [anon_sym_STAR] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6083),
    [anon_sym_STAR_STAR] = ACTIONS(6085),
    [anon_sym_CARET] = ACTIONS(6085),
    [aux_sym_binary_operator_token1] = ACTIONS(6087),
    [anon_sym_PIPE_GT] = ACTIONS(6087),
    [anon_sym_COLON] = ACTIONS(6089),
    [anon_sym_DOLLAR] = ACTIONS(6091),
    [anon_sym_AT] = ACTIONS(6091),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__semicolon] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(6093),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_close_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(6095),
    [sym__external_open_bracket2] = ACTIONS(6097),
    [sym__external_close_bracket2] = ACTIONS(5333),
  },
  [1137] = {
    [sym_call_arguments] = STATE(2638),
    [sym_subset_arguments] = STATE(2647),
    [sym_subset2_arguments] = STATE(2650),
    [sym__open_parenthesis] = STATE(1537),
    [sym__open_bracket] = STATE(1534),
    [sym__open_bracket2] = STATE(1533),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(6055),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(6057),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(6059),
    [anon_sym_DASH] = ACTIONS(6061),
    [anon_sym_LT_DASH] = ACTIONS(6063),
    [anon_sym_LT_LT_DASH] = ACTIONS(6063),
    [anon_sym_COLON_EQ] = ACTIONS(6063),
    [anon_sym_DASH_GT] = ACTIONS(6065),
    [anon_sym_DASH_GT_GT] = ACTIONS(6067),
    [anon_sym_PIPE] = ACTIONS(6069),
    [anon_sym_AMP] = ACTIONS(6071),
    [anon_sym_PIPE_PIPE] = ACTIONS(6073),
    [anon_sym_AMP_AMP] = ACTIONS(6075),
    [anon_sym_LT] = ACTIONS(6077),
    [anon_sym_LT_EQ] = ACTIONS(6079),
    [anon_sym_GT] = ACTIONS(6077),
    [anon_sym_GT_EQ] = ACTIONS(6079),
    [anon_sym_EQ_EQ] = ACTIONS(6079),
    [anon_sym_BANG_EQ] = ACTIONS(6079),
    [anon_sym_STAR] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6083),
    [anon_sym_STAR_STAR] = ACTIONS(6085),
    [anon_sym_CARET] = ACTIONS(6085),
    [aux_sym_binary_operator_token1] = ACTIONS(6087),
    [anon_sym_PIPE_GT] = ACTIONS(6087),
    [anon_sym_COLON] = ACTIONS(6089),
    [anon_sym_DOLLAR] = ACTIONS(6091),
    [anon_sym_AT] = ACTIONS(6091),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__semicolon] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(6093),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_close_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(6095),
    [sym__external_open_bracket2] = ACTIONS(6097),
    [sym__external_close_bracket2] = ACTIONS(5333),
  },
  [1138] = {
    [sym_call_arguments] = STATE(2638),
    [sym_subset_arguments] = STATE(2647),
    [sym_subset2_arguments] = STATE(2650),
    [sym__open_parenthesis] = STATE(1537),
    [sym__open_bracket] = STATE(1534),
    [sym__open_bracket2] = STATE(1533),
    [sym_identifier] = ACTIONS(5331),
    [anon_sym_BSLASH] = ACTIONS(5329),
    [anon_sym_function] = ACTIONS(5331),
    [anon_sym_EQ] = ACTIONS(6055),
    [anon_sym_if] = ACTIONS(5331),
    [anon_sym_for] = ACTIONS(5331),
    [anon_sym_while] = ACTIONS(5331),
    [anon_sym_repeat] = ACTIONS(5331),
    [anon_sym_QMARK] = ACTIONS(5329),
    [anon_sym_TILDE] = ACTIONS(6057),
    [anon_sym_BANG] = ACTIONS(5331),
    [anon_sym_PLUS] = ACTIONS(6059),
    [anon_sym_DASH] = ACTIONS(6061),
    [anon_sym_LT_DASH] = ACTIONS(6063),
    [anon_sym_LT_LT_DASH] = ACTIONS(6063),
    [anon_sym_COLON_EQ] = ACTIONS(6063),
    [anon_sym_DASH_GT] = ACTIONS(6065),
    [anon_sym_DASH_GT_GT] = ACTIONS(6067),
    [anon_sym_PIPE] = ACTIONS(6069),
    [anon_sym_AMP] = ACTIONS(6071),
    [anon_sym_PIPE_PIPE] = ACTIONS(6073),
    [anon_sym_AMP_AMP] = ACTIONS(6075),
    [anon_sym_LT] = ACTIONS(6077),
    [anon_sym_LT_EQ] = ACTIONS(6079),
    [anon_sym_GT] = ACTIONS(6077),
    [anon_sym_GT_EQ] = ACTIONS(6079),
    [anon_sym_EQ_EQ] = ACTIONS(6079),
    [anon_sym_BANG_EQ] = ACTIONS(6079),
    [anon_sym_STAR] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6083),
    [anon_sym_STAR_STAR] = ACTIONS(6085),
    [anon_sym_CARET] = ACTIONS(6085),
    [aux_sym_binary_operator_token1] = ACTIONS(6087),
    [anon_sym_PIPE_GT] = ACTIONS(6087),
    [anon_sym_COLON] = ACTIONS(6089),
    [anon_sym_DOLLAR] = ACTIONS(6091),
    [anon_sym_AT] = ACTIONS(6091),
    [aux_sym__hex_literal_token1] = ACTIONS(5329),
    [sym__number_literal] = ACTIONS(5331),
    [anon_sym_SQUOTE] = ACTIONS(5329),
    [anon_sym_DQUOTE] = ACTIONS(5329),
    [sym_return] = ACTIONS(5331),
    [sym_next] = ACTIONS(5331),
    [sym_break] = ACTIONS(5331),
    [sym_true] = ACTIONS(5331),
    [sym_false] = ACTIONS(5331),
    [sym_null] = ACTIONS(5331),
    [sym_inf] = ACTIONS(5331),
    [sym_nan] = ACTIONS(5331),
    [anon_sym_NA] = ACTIONS(5331),
    [anon_sym_NA_integer_] = ACTIONS(5331),
    [anon_sym_NA_real_] = ACTIONS(5331),
    [anon_sym_NA_complex_] = ACTIONS(5331),
    [anon_sym_NA_character_] = ACTIONS(5331),
    [sym_dots] = ACTIONS(5331),
    [sym_dot_dot_i] = ACTIONS(5329),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5329),
    [sym__newline] = ACTIONS(5329),
    [sym__semicolon] = ACTIONS(5329),
    [sym__raw_string_literal] = ACTIONS(5329),
    [sym__external_open_parenthesis] = ACTIONS(6093),
    [sym__external_open_brace] = ACTIONS(5329),
    [sym__external_close_brace] = ACTIONS(5329),
    [sym__external_open_bracket] = ACTIONS(6095),
    [sym__external_open_bracket2] = ACTIONS(6097),
    [sym__external_close_bracket2] = ACTIONS(5329),
  },
  [1139] = {
    [sym_call_arguments] = STATE(2731),
    [sym_subset_arguments] = STATE(2730),
    [sym_subset2_arguments] = STATE(2729),
    [sym__open_parenthesis] = STATE(1357),
    [sym__open_bracket] = STATE(1353),
    [sym__open_bracket2] = STATE(1352),
    [sym_identifier] = ACTIONS(5311),
    [anon_sym_BSLASH] = ACTIONS(5313),
    [anon_sym_function] = ACTIONS(5311),
    [anon_sym_EQ] = ACTIONS(5783),
    [anon_sym_if] = ACTIONS(5311),
    [anon_sym_for] = ACTIONS(5311),
    [anon_sym_while] = ACTIONS(5311),
    [anon_sym_repeat] = ACTIONS(5311),
    [anon_sym_QMARK] = ACTIONS(6109),
    [anon_sym_TILDE] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(5311),
    [anon_sym_PLUS] = ACTIONS(5787),
    [anon_sym_DASH] = ACTIONS(5789),
    [anon_sym_LT_DASH] = ACTIONS(5791),
    [anon_sym_LT_LT_DASH] = ACTIONS(5791),
    [anon_sym_COLON_EQ] = ACTIONS(5791),
    [anon_sym_DASH_GT] = ACTIONS(5793),
    [anon_sym_DASH_GT_GT] = ACTIONS(5795),
    [anon_sym_PIPE] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5799),
    [anon_sym_PIPE_PIPE] = ACTIONS(5801),
    [anon_sym_AMP_AMP] = ACTIONS(5803),
    [anon_sym_LT] = ACTIONS(5805),
    [anon_sym_LT_EQ] = ACTIONS(5807),
    [anon_sym_GT] = ACTIONS(5805),
    [anon_sym_GT_EQ] = ACTIONS(5807),
    [anon_sym_EQ_EQ] = ACTIONS(5807),
    [anon_sym_BANG_EQ] = ACTIONS(5807),
    [anon_sym_STAR] = ACTIONS(5809),
    [anon_sym_SLASH] = ACTIONS(5811),
    [anon_sym_STAR_STAR] = ACTIONS(5813),
    [anon_sym_CARET] = ACTIONS(5813),
    [aux_sym_binary_operator_token1] = ACTIONS(5815),
    [anon_sym_PIPE_GT] = ACTIONS(5815),
    [anon_sym_COLON] = ACTIONS(5817),
    [anon_sym_DOLLAR] = ACTIONS(5819),
    [anon_sym_AT] = ACTIONS(5819),
    [aux_sym__hex_literal_token1] = ACTIONS(5313),
    [sym__number_literal] = ACTIONS(5311),
    [anon_sym_SQUOTE] = ACTIONS(5313),
    [anon_sym_DQUOTE] = ACTIONS(5313),
    [sym_return] = ACTIONS(5311),
    [sym_next] = ACTIONS(5311),
    [sym_break] = ACTIONS(5311),
    [sym_true] = ACTIONS(5311),
    [sym_false] = ACTIONS(5311),
    [sym_null] = ACTIONS(5311),
    [sym_inf] = ACTIONS(5311),
    [sym_nan] = ACTIONS(5311),
    [anon_sym_NA] = ACTIONS(5311),
    [anon_sym_NA_integer_] = ACTIONS(5311),
    [anon_sym_NA_real_] = ACTIONS(5311),
    [anon_sym_NA_complex_] = ACTIONS(5311),
    [anon_sym_NA_character_] = ACTIONS(5311),
    [sym_dots] = ACTIONS(5311),
    [sym_dot_dot_i] = ACTIONS(5313),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5313),
    [sym__newline] = ACTIONS(5313),
    [sym__raw_string_literal] = ACTIONS(5313),
    [sym__external_else] = ACTIONS(5313),
    [sym__external_open_parenthesis] = ACTIONS(5823),
    [sym__external_close_parenthesis] = ACTIONS(5313),
    [sym__external_open_brace] = ACTIONS(5313),
    [sym__external_open_bracket] = ACTIONS(5825),
    [sym__external_close_bracket] = ACTIONS(5313),
    [sym__external_open_bracket2] = ACTIONS(5827),
  },
  [1140] = {
    [sym_call_arguments] = STATE(2651),
    [sym_subset_arguments] = STATE(2561),
    [sym_subset2_arguments] = STATE(2648),
    [sym__open_parenthesis] = STATE(1340),
    [sym__open_bracket] = STATE(1335),
    [sym__open_bracket2] = STATE(1334),
    [sym_identifier] = ACTIONS(5411),
    [anon_sym_BSLASH] = ACTIONS(5409),
    [anon_sym_function] = ACTIONS(5411),
    [anon_sym_EQ] = ACTIONS(5675),
    [anon_sym_if] = ACTIONS(5411),
    [anon_sym_for] = ACTIONS(5411),
    [anon_sym_while] = ACTIONS(5411),
    [anon_sym_repeat] = ACTIONS(5411),
    [anon_sym_QMARK] = ACTIONS(5409),
    [anon_sym_TILDE] = ACTIONS(5677),
    [anon_sym_BANG] = ACTIONS(5411),
    [anon_sym_PLUS] = ACTIONS(5679),
    [anon_sym_DASH] = ACTIONS(5681),
    [anon_sym_LT_DASH] = ACTIONS(5683),
    [anon_sym_LT_LT_DASH] = ACTIONS(5683),
    [anon_sym_COLON_EQ] = ACTIONS(5683),
    [anon_sym_DASH_GT] = ACTIONS(5685),
    [anon_sym_DASH_GT_GT] = ACTIONS(5687),
    [anon_sym_PIPE] = ACTIONS(5689),
    [anon_sym_AMP] = ACTIONS(5691),
    [anon_sym_PIPE_PIPE] = ACTIONS(5693),
    [anon_sym_AMP_AMP] = ACTIONS(5695),
    [anon_sym_LT] = ACTIONS(5697),
    [anon_sym_LT_EQ] = ACTIONS(5699),
    [anon_sym_GT] = ACTIONS(5697),
    [anon_sym_GT_EQ] = ACTIONS(5699),
    [anon_sym_EQ_EQ] = ACTIONS(5699),
    [anon_sym_BANG_EQ] = ACTIONS(5699),
    [anon_sym_STAR] = ACTIONS(5701),
    [anon_sym_SLASH] = ACTIONS(5703),
    [anon_sym_STAR_STAR] = ACTIONS(5705),
    [anon_sym_CARET] = ACTIONS(5705),
    [aux_sym_binary_operator_token1] = ACTIONS(5707),
    [anon_sym_PIPE_GT] = ACTIONS(5707),
    [anon_sym_COLON] = ACTIONS(5709),
    [anon_sym_DOLLAR] = ACTIONS(5711),
    [anon_sym_AT] = ACTIONS(5711),
    [aux_sym__hex_literal_token1] = ACTIONS(5409),
    [sym__number_literal] = ACTIONS(5411),
    [anon_sym_SQUOTE] = ACTIONS(5409),
    [anon_sym_DQUOTE] = ACTIONS(5409),
    [sym_return] = ACTIONS(5411),
    [sym_next] = ACTIONS(5411),
    [sym_break] = ACTIONS(5411),
    [sym_true] = ACTIONS(5411),
    [sym_false] = ACTIONS(5411),
    [sym_null] = ACTIONS(5411),
    [sym_inf] = ACTIONS(5411),
    [sym_nan] = ACTIONS(5411),
    [anon_sym_NA] = ACTIONS(5411),
    [anon_sym_NA_integer_] = ACTIONS(5411),
    [anon_sym_NA_real_] = ACTIONS(5411),
    [anon_sym_NA_complex_] = ACTIONS(5411),
    [anon_sym_NA_character_] = ACTIONS(5411),
    [sym_dots] = ACTIONS(5411),
    [sym_dot_dot_i] = ACTIONS(5409),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5409),
    [sym__newline] = ACTIONS(5409),
    [sym__raw_string_literal] = ACTIONS(5409),
    [sym__external_else] = ACTIONS(5409),
    [sym__external_open_parenthesis] = ACTIONS(5715),
    [sym__external_close_parenthesis] = ACTIONS(5409),
    [sym__external_open_brace] = ACTIONS(5409),
    [sym__external_open_bracket] = ACTIONS(5717),
    [sym__external_open_bracket2] = ACTIONS(5719),
    [sym__external_close_bracket2] = ACTIONS(5409),
  },
  [1141] = {
    [sym_call_arguments] = STATE(2651),
    [sym_subset_arguments] = STATE(2561),
    [sym_subset2_arguments] = STATE(2648),
    [sym__open_parenthesis] = STATE(1340),
    [sym__open_bracket] = STATE(1335),
    [sym__open_bracket2] = STATE(1334),
    [sym_identifier] = ACTIONS(5455),
    [anon_sym_BSLASH] = ACTIONS(5453),
    [anon_sym_function] = ACTIONS(5455),
    [anon_sym_EQ] = ACTIONS(5675),
    [anon_sym_if] = ACTIONS(5455),
    [anon_sym_for] = ACTIONS(5455),
    [anon_sym_while] = ACTIONS(5455),
    [anon_sym_repeat] = ACTIONS(5455),
    [anon_sym_QMARK] = ACTIONS(5453),
    [anon_sym_TILDE] = ACTIONS(5677),
    [anon_sym_BANG] = ACTIONS(5455),
    [anon_sym_PLUS] = ACTIONS(5679),
    [anon_sym_DASH] = ACTIONS(5681),
    [anon_sym_LT_DASH] = ACTIONS(5683),
    [anon_sym_LT_LT_DASH] = ACTIONS(5683),
    [anon_sym_COLON_EQ] = ACTIONS(5683),
    [anon_sym_DASH_GT] = ACTIONS(5685),
    [anon_sym_DASH_GT_GT] = ACTIONS(5687),
    [anon_sym_PIPE] = ACTIONS(5689),
    [anon_sym_AMP] = ACTIONS(5691),
    [anon_sym_PIPE_PIPE] = ACTIONS(5693),
    [anon_sym_AMP_AMP] = ACTIONS(5695),
    [anon_sym_LT] = ACTIONS(5697),
    [anon_sym_LT_EQ] = ACTIONS(5699),
    [anon_sym_GT] = ACTIONS(5697),
    [anon_sym_GT_EQ] = ACTIONS(5699),
    [anon_sym_EQ_EQ] = ACTIONS(5699),
    [anon_sym_BANG_EQ] = ACTIONS(5699),
    [anon_sym_STAR] = ACTIONS(5701),
    [anon_sym_SLASH] = ACTIONS(5703),
    [anon_sym_STAR_STAR] = ACTIONS(5705),
    [anon_sym_CARET] = ACTIONS(5705),
    [aux_sym_binary_operator_token1] = ACTIONS(5707),
    [anon_sym_PIPE_GT] = ACTIONS(5707),
    [anon_sym_COLON] = ACTIONS(5709),
    [anon_sym_DOLLAR] = ACTIONS(5711),
    [anon_sym_AT] = ACTIONS(5711),
    [aux_sym__hex_literal_token1] = ACTIONS(5453),
    [sym__number_literal] = ACTIONS(5455),
    [anon_sym_SQUOTE] = ACTIONS(5453),
    [anon_sym_DQUOTE] = ACTIONS(5453),
    [sym_return] = ACTIONS(5455),
    [sym_next] = ACTIONS(5455),
    [sym_break] = ACTIONS(5455),
    [sym_true] = ACTIONS(5455),
    [sym_false] = ACTIONS(5455),
    [sym_null] = ACTIONS(5455),
    [sym_inf] = ACTIONS(5455),
    [sym_nan] = ACTIONS(5455),
    [anon_sym_NA] = ACTIONS(5455),
    [anon_sym_NA_integer_] = ACTIONS(5455),
    [anon_sym_NA_real_] = ACTIONS(5455),
    [anon_sym_NA_complex_] = ACTIONS(5455),
    [anon_sym_NA_character_] = ACTIONS(5455),
    [sym_dots] = ACTIONS(5455),
    [sym_dot_dot_i] = ACTIONS(5453),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5453),
    [sym__newline] = ACTIONS(5453),
    [sym__raw_string_literal] = ACTIONS(5453),
    [sym__external_else] = ACTIONS(5453),
    [sym__external_open_parenthesis] = ACTIONS(5715),
    [sym__external_close_parenthesis] = ACTIONS(5453),
    [sym__external_open_brace] = ACTIONS(5453),
    [sym__external_open_bracket] = ACTIONS(5717),
    [sym__external_open_bracket2] = ACTIONS(5719),
    [sym__external_close_bracket2] = ACTIONS(5453),
  },
  [1142] = {
    [sym_call_arguments] = STATE(2651),
    [sym_subset_arguments] = STATE(2561),
    [sym_subset2_arguments] = STATE(2648),
    [sym__open_parenthesis] = STATE(1340),
    [sym__open_bracket] = STATE(1335),
    [sym__open_bracket2] = STATE(1334),
    [sym_identifier] = ACTIONS(5451),
    [anon_sym_BSLASH] = ACTIONS(5449),
    [anon_sym_function] = ACTIONS(5451),
    [anon_sym_EQ] = ACTIONS(5675),
    [anon_sym_if] = ACTIONS(5451),
    [anon_sym_for] = ACTIONS(5451),
    [anon_sym_while] = ACTIONS(5451),
    [anon_sym_repeat] = ACTIONS(5451),
    [anon_sym_QMARK] = ACTIONS(5449),
    [anon_sym_TILDE] = ACTIONS(5677),
    [anon_sym_BANG] = ACTIONS(5451),
    [anon_sym_PLUS] = ACTIONS(5679),
    [anon_sym_DASH] = ACTIONS(5681),
    [anon_sym_LT_DASH] = ACTIONS(5683),
    [anon_sym_LT_LT_DASH] = ACTIONS(5683),
    [anon_sym_COLON_EQ] = ACTIONS(5683),
    [anon_sym_DASH_GT] = ACTIONS(5685),
    [anon_sym_DASH_GT_GT] = ACTIONS(5687),
    [anon_sym_PIPE] = ACTIONS(5689),
    [anon_sym_AMP] = ACTIONS(5691),
    [anon_sym_PIPE_PIPE] = ACTIONS(5693),
    [anon_sym_AMP_AMP] = ACTIONS(5695),
    [anon_sym_LT] = ACTIONS(5697),
    [anon_sym_LT_EQ] = ACTIONS(5699),
    [anon_sym_GT] = ACTIONS(5697),
    [anon_sym_GT_EQ] = ACTIONS(5699),
    [anon_sym_EQ_EQ] = ACTIONS(5699),
    [anon_sym_BANG_EQ] = ACTIONS(5699),
    [anon_sym_STAR] = ACTIONS(5701),
    [anon_sym_SLASH] = ACTIONS(5703),
    [anon_sym_STAR_STAR] = ACTIONS(5705),
    [anon_sym_CARET] = ACTIONS(5705),
    [aux_sym_binary_operator_token1] = ACTIONS(5707),
    [anon_sym_PIPE_GT] = ACTIONS(5707),
    [anon_sym_COLON] = ACTIONS(5709),
    [anon_sym_DOLLAR] = ACTIONS(5711),
    [anon_sym_AT] = ACTIONS(5711),
    [aux_sym__hex_literal_token1] = ACTIONS(5449),
    [sym__number_literal] = ACTIONS(5451),
    [anon_sym_SQUOTE] = ACTIONS(5449),
    [anon_sym_DQUOTE] = ACTIONS(5449),
    [sym_return] = ACTIONS(5451),
    [sym_next] = ACTIONS(5451),
    [sym_break] = ACTIONS(5451),
    [sym_true] = ACTIONS(5451),
    [sym_false] = ACTIONS(5451),
    [sym_null] = ACTIONS(5451),
    [sym_inf] = ACTIONS(5451),
    [sym_nan] = ACTIONS(5451),
    [anon_sym_NA] = ACTIONS(5451),
    [anon_sym_NA_integer_] = ACTIONS(5451),
    [anon_sym_NA_real_] = ACTIONS(5451),
    [anon_sym_NA_complex_] = ACTIONS(5451),
    [anon_sym_NA_character_] = ACTIONS(5451),
    [sym_dots] = ACTIONS(5451),
    [sym_dot_dot_i] = ACTIONS(5449),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5449),
    [sym__newline] = ACTIONS(5449),
    [sym__raw_string_literal] = ACTIONS(5449),
    [sym__external_else] = ACTIONS(5449),
    [sym__external_open_parenthesis] = ACTIONS(5715),
    [sym__external_close_parenthesis] = ACTIONS(5449),
    [sym__external_open_brace] = ACTIONS(5449),
    [sym__external_open_bracket] = ACTIONS(5717),
    [sym__external_open_bracket2] = ACTIONS(5719),
    [sym__external_close_bracket2] = ACTIONS(5449),
  },
  [1143] = {
    [sym_call_arguments] = STATE(2651),
    [sym_subset_arguments] = STATE(2561),
    [sym_subset2_arguments] = STATE(2648),
    [sym__open_parenthesis] = STATE(1340),
    [sym__open_bracket] = STATE(1335),
    [sym__open_bracket2] = STATE(1334),
    [sym_identifier] = ACTIONS(5447),
    [anon_sym_BSLASH] = ACTIONS(5445),
    [anon_sym_function] = ACTIONS(5447),
    [anon_sym_EQ] = ACTIONS(5675),
    [anon_sym_if] = ACTIONS(5447),
    [anon_sym_for] = ACTIONS(5447),
    [anon_sym_while] = ACTIONS(5447),
    [anon_sym_repeat] = ACTIONS(5447),
    [anon_sym_QMARK] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(5677),
    [anon_sym_BANG] = ACTIONS(5447),
    [anon_sym_PLUS] = ACTIONS(5679),
    [anon_sym_DASH] = ACTIONS(5681),
    [anon_sym_LT_DASH] = ACTIONS(5683),
    [anon_sym_LT_LT_DASH] = ACTIONS(5683),
    [anon_sym_COLON_EQ] = ACTIONS(5683),
    [anon_sym_DASH_GT] = ACTIONS(5685),
    [anon_sym_DASH_GT_GT] = ACTIONS(5687),
    [anon_sym_PIPE] = ACTIONS(5689),
    [anon_sym_AMP] = ACTIONS(5691),
    [anon_sym_PIPE_PIPE] = ACTIONS(5693),
    [anon_sym_AMP_AMP] = ACTIONS(5695),
    [anon_sym_LT] = ACTIONS(5697),
    [anon_sym_LT_EQ] = ACTIONS(5699),
    [anon_sym_GT] = ACTIONS(5697),
    [anon_sym_GT_EQ] = ACTIONS(5699),
    [anon_sym_EQ_EQ] = ACTIONS(5699),
    [anon_sym_BANG_EQ] = ACTIONS(5699),
    [anon_sym_STAR] = ACTIONS(5701),
    [anon_sym_SLASH] = ACTIONS(5703),
    [anon_sym_STAR_STAR] = ACTIONS(5705),
    [anon_sym_CARET] = ACTIONS(5705),
    [aux_sym_binary_operator_token1] = ACTIONS(5707),
    [anon_sym_PIPE_GT] = ACTIONS(5707),
    [anon_sym_COLON] = ACTIONS(5709),
    [anon_sym_DOLLAR] = ACTIONS(5711),
    [anon_sym_AT] = ACTIONS(5711),
    [aux_sym__hex_literal_token1] = ACTIONS(5445),
    [sym__number_literal] = ACTIONS(5447),
    [anon_sym_SQUOTE] = ACTIONS(5445),
    [anon_sym_DQUOTE] = ACTIONS(5445),
    [sym_return] = ACTIONS(5447),
    [sym_next] = ACTIONS(5447),
    [sym_break] = ACTIONS(5447),
    [sym_true] = ACTIONS(5447),
    [sym_false] = ACTIONS(5447),
    [sym_null] = ACTIONS(5447),
    [sym_inf] = ACTIONS(5447),
    [sym_nan] = ACTIONS(5447),
    [anon_sym_NA] = ACTIONS(5447),
    [anon_sym_NA_integer_] = ACTIONS(5447),
    [anon_sym_NA_real_] = ACTIONS(5447),
    [anon_sym_NA_complex_] = ACTIONS(5447),
    [anon_sym_NA_character_] = ACTIONS(5447),
    [sym_dots] = ACTIONS(5447),
    [sym_dot_dot_i] = ACTIONS(5445),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5445),
    [sym__newline] = ACTIONS(5445),
    [sym__raw_string_literal] = ACTIONS(5445),
    [sym__external_else] = ACTIONS(5445),
    [sym__external_open_parenthesis] = ACTIONS(5715),
    [sym__external_close_parenthesis] = ACTIONS(5445),
    [sym__external_open_brace] = ACTIONS(5445),
    [sym__external_open_bracket] = ACTIONS(5717),
    [sym__external_open_bracket2] = ACTIONS(5719),
    [sym__external_close_bracket2] = ACTIONS(5445),
  },
  [1144] = {
    [sym_call_arguments] = STATE(2651),
    [sym_subset_arguments] = STATE(2561),
    [sym_subset2_arguments] = STATE(2648),
    [sym__open_parenthesis] = STATE(1340),
    [sym__open_bracket] = STATE(1335),
    [sym__open_bracket2] = STATE(1334),
    [sym_identifier] = ACTIONS(5443),
    [anon_sym_BSLASH] = ACTIONS(5441),
    [anon_sym_function] = ACTIONS(5443),
    [anon_sym_EQ] = ACTIONS(5675),
    [anon_sym_if] = ACTIONS(5443),
    [anon_sym_for] = ACTIONS(5443),
    [anon_sym_while] = ACTIONS(5443),
    [anon_sym_repeat] = ACTIONS(5443),
    [anon_sym_QMARK] = ACTIONS(5441),
    [anon_sym_TILDE] = ACTIONS(5677),
    [anon_sym_BANG] = ACTIONS(5443),
    [anon_sym_PLUS] = ACTIONS(5679),
    [anon_sym_DASH] = ACTIONS(5681),
    [anon_sym_LT_DASH] = ACTIONS(5683),
    [anon_sym_LT_LT_DASH] = ACTIONS(5683),
    [anon_sym_COLON_EQ] = ACTIONS(5683),
    [anon_sym_DASH_GT] = ACTIONS(5685),
    [anon_sym_DASH_GT_GT] = ACTIONS(5687),
    [anon_sym_PIPE] = ACTIONS(5689),
    [anon_sym_AMP] = ACTIONS(5691),
    [anon_sym_PIPE_PIPE] = ACTIONS(5693),
    [anon_sym_AMP_AMP] = ACTIONS(5695),
    [anon_sym_LT] = ACTIONS(5697),
    [anon_sym_LT_EQ] = ACTIONS(5699),
    [anon_sym_GT] = ACTIONS(5697),
    [anon_sym_GT_EQ] = ACTIONS(5699),
    [anon_sym_EQ_EQ] = ACTIONS(5699),
    [anon_sym_BANG_EQ] = ACTIONS(5699),
    [anon_sym_STAR] = ACTIONS(5701),
    [anon_sym_SLASH] = ACTIONS(5703),
    [anon_sym_STAR_STAR] = ACTIONS(5705),
    [anon_sym_CARET] = ACTIONS(5705),
    [aux_sym_binary_operator_token1] = ACTIONS(5707),
    [anon_sym_PIPE_GT] = ACTIONS(5707),
    [anon_sym_COLON] = ACTIONS(5709),
    [anon_sym_DOLLAR] = ACTIONS(5711),
    [anon_sym_AT] = ACTIONS(5711),
    [aux_sym__hex_literal_token1] = ACTIONS(5441),
    [sym__number_literal] = ACTIONS(5443),
    [anon_sym_SQUOTE] = ACTIONS(5441),
    [anon_sym_DQUOTE] = ACTIONS(5441),
    [sym_return] = ACTIONS(5443),
    [sym_next] = ACTIONS(5443),
    [sym_break] = ACTIONS(5443),
    [sym_true] = ACTIONS(5443),
    [sym_false] = ACTIONS(5443),
    [sym_null] = ACTIONS(5443),
    [sym_inf] = ACTIONS(5443),
    [sym_nan] = ACTIONS(5443),
    [anon_sym_NA] = ACTIONS(5443),
    [anon_sym_NA_integer_] = ACTIONS(5443),
    [anon_sym_NA_real_] = ACTIONS(5443),
    [anon_sym_NA_complex_] = ACTIONS(5443),
    [anon_sym_NA_character_] = ACTIONS(5443),
    [sym_dots] = ACTIONS(5443),
    [sym_dot_dot_i] = ACTIONS(5441),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5441),
    [sym__newline] = ACTIONS(5441),
    [sym__raw_string_literal] = ACTIONS(5441),
    [sym__external_else] = ACTIONS(5441),
    [sym__external_open_parenthesis] = ACTIONS(5715),
    [sym__external_close_parenthesis] = ACTIONS(5441),
    [sym__external_open_brace] = ACTIONS(5441),
    [sym__external_open_bracket] = ACTIONS(5717),
    [sym__external_open_bracket2] = ACTIONS(5719),
    [sym__external_close_bracket2] = ACTIONS(5441),
  },
  [1145] = {
    [sym_call_arguments] = STATE(2870),
    [sym_subset_arguments] = STATE(2869),
    [sym_subset2_arguments] = STATE(2867),
    [sym__else] = STATE(4198),
    [sym__open_parenthesis] = STATE(1362),
    [sym__open_bracket] = STATE(1361),
    [sym__open_bracket2] = STATE(1360),
    [sym_identifier] = ACTIONS(5225),
    [anon_sym_BSLASH] = ACTIONS(5227),
    [anon_sym_function] = ACTIONS(5225),
    [anon_sym_EQ] = ACTIONS(6111),
    [anon_sym_if] = ACTIONS(5225),
    [anon_sym_for] = ACTIONS(5225),
    [anon_sym_while] = ACTIONS(5225),
    [anon_sym_repeat] = ACTIONS(5225),
    [anon_sym_QMARK] = ACTIONS(5227),
    [anon_sym_TILDE] = ACTIONS(6113),
    [anon_sym_BANG] = ACTIONS(5225),
    [anon_sym_PLUS] = ACTIONS(6115),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_LT_DASH] = ACTIONS(6119),
    [anon_sym_LT_LT_DASH] = ACTIONS(6119),
    [anon_sym_COLON_EQ] = ACTIONS(6119),
    [anon_sym_DASH_GT] = ACTIONS(6121),
    [anon_sym_DASH_GT_GT] = ACTIONS(6123),
    [anon_sym_PIPE] = ACTIONS(6125),
    [anon_sym_AMP] = ACTIONS(6127),
    [anon_sym_PIPE_PIPE] = ACTIONS(6129),
    [anon_sym_AMP_AMP] = ACTIONS(6131),
    [anon_sym_LT] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6135),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_GT_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(6135),
    [anon_sym_STAR] = ACTIONS(6137),
    [anon_sym_SLASH] = ACTIONS(6139),
    [anon_sym_STAR_STAR] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6141),
    [aux_sym_binary_operator_token1] = ACTIONS(6143),
    [anon_sym_PIPE_GT] = ACTIONS(6143),
    [anon_sym_COLON] = ACTIONS(6145),
    [anon_sym_DOLLAR] = ACTIONS(6147),
    [anon_sym_AT] = ACTIONS(6147),
    [aux_sym__hex_literal_token1] = ACTIONS(5227),
    [sym__number_literal] = ACTIONS(5225),
    [anon_sym_SQUOTE] = ACTIONS(5227),
    [anon_sym_DQUOTE] = ACTIONS(5227),
    [sym_return] = ACTIONS(5225),
    [sym_next] = ACTIONS(5225),
    [sym_break] = ACTIONS(5225),
    [sym_true] = ACTIONS(5225),
    [sym_false] = ACTIONS(5225),
    [sym_null] = ACTIONS(5225),
    [sym_inf] = ACTIONS(5225),
    [sym_nan] = ACTIONS(5225),
    [anon_sym_NA] = ACTIONS(5225),
    [anon_sym_NA_integer_] = ACTIONS(5225),
    [anon_sym_NA_real_] = ACTIONS(5225),
    [anon_sym_NA_complex_] = ACTIONS(5225),
    [anon_sym_NA_character_] = ACTIONS(5225),
    [sym_dots] = ACTIONS(5225),
    [sym_dot_dot_i] = ACTIONS(5227),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5227),
    [sym__newline] = ACTIONS(5227),
    [sym__raw_string_literal] = ACTIONS(5227),
    [sym__external_else] = ACTIONS(6149),
    [sym__external_open_parenthesis] = ACTIONS(6151),
    [sym__external_open_brace] = ACTIONS(5227),
    [sym__external_open_bracket] = ACTIONS(6153),
    [sym__external_open_bracket2] = ACTIONS(6155),
    [sym__external_close_bracket2] = ACTIONS(5227),
  },
  [1146] = {
    [sym_call_arguments] = STATE(2671),
    [sym_subset_arguments] = STATE(2663),
    [sym_subset2_arguments] = STATE(2661),
    [sym__open_parenthesis] = STATE(1555),
    [sym__open_bracket] = STATE(1551),
    [sym__open_bracket2] = STATE(1549),
    [sym_identifier] = ACTIONS(5411),
    [anon_sym_BSLASH] = ACTIONS(5409),
    [anon_sym_function] = ACTIONS(5411),
    [anon_sym_EQ] = ACTIONS(5889),
    [anon_sym_if] = ACTIONS(5411),
    [anon_sym_for] = ACTIONS(5411),
    [anon_sym_while] = ACTIONS(5411),
    [anon_sym_repeat] = ACTIONS(5411),
    [anon_sym_QMARK] = ACTIONS(5409),
    [anon_sym_TILDE] = ACTIONS(5893),
    [anon_sym_BANG] = ACTIONS(5411),
    [anon_sym_PLUS] = ACTIONS(5895),
    [anon_sym_DASH] = ACTIONS(5897),
    [anon_sym_LT_DASH] = ACTIONS(5899),
    [anon_sym_LT_LT_DASH] = ACTIONS(5899),
    [anon_sym_COLON_EQ] = ACTIONS(5899),
    [anon_sym_DASH_GT] = ACTIONS(5901),
    [anon_sym_DASH_GT_GT] = ACTIONS(5903),
    [anon_sym_PIPE] = ACTIONS(5905),
    [anon_sym_AMP] = ACTIONS(5907),
    [anon_sym_PIPE_PIPE] = ACTIONS(5909),
    [anon_sym_AMP_AMP] = ACTIONS(5911),
    [anon_sym_LT] = ACTIONS(5913),
    [anon_sym_LT_EQ] = ACTIONS(5915),
    [anon_sym_GT] = ACTIONS(5913),
    [anon_sym_GT_EQ] = ACTIONS(5915),
    [anon_sym_EQ_EQ] = ACTIONS(5915),
    [anon_sym_BANG_EQ] = ACTIONS(5915),
    [anon_sym_STAR] = ACTIONS(5917),
    [anon_sym_SLASH] = ACTIONS(5919),
    [anon_sym_STAR_STAR] = ACTIONS(5921),
    [anon_sym_CARET] = ACTIONS(5921),
    [aux_sym_binary_operator_token1] = ACTIONS(5923),
    [anon_sym_PIPE_GT] = ACTIONS(5923),
    [anon_sym_COLON] = ACTIONS(5925),
    [anon_sym_DOLLAR] = ACTIONS(5927),
    [anon_sym_AT] = ACTIONS(5927),
    [aux_sym__hex_literal_token1] = ACTIONS(5409),
    [sym__number_literal] = ACTIONS(5411),
    [anon_sym_SQUOTE] = ACTIONS(5409),
    [anon_sym_DQUOTE] = ACTIONS(5409),
    [sym_return] = ACTIONS(5411),
    [sym_next] = ACTIONS(5411),
    [sym_break] = ACTIONS(5411),
    [sym_true] = ACTIONS(5411),
    [sym_false] = ACTIONS(5411),
    [sym_null] = ACTIONS(5411),
    [sym_inf] = ACTIONS(5411),
    [sym_nan] = ACTIONS(5411),
    [anon_sym_NA] = ACTIONS(5411),
    [anon_sym_NA_integer_] = ACTIONS(5411),
    [anon_sym_NA_real_] = ACTIONS(5411),
    [anon_sym_NA_complex_] = ACTIONS(5411),
    [anon_sym_NA_character_] = ACTIONS(5411),
    [sym_dots] = ACTIONS(5411),
    [sym_dot_dot_i] = ACTIONS(5409),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5409),
    [sym__newline] = ACTIONS(5409),
    [sym__semicolon] = ACTIONS(5409),
    [sym__raw_string_literal] = ACTIONS(5409),
    [sym__external_open_parenthesis] = ACTIONS(5929),
    [sym__external_open_brace] = ACTIONS(5409),
    [sym__external_close_brace] = ACTIONS(5409),
    [sym__external_open_bracket] = ACTIONS(5931),
    [sym__external_close_bracket] = ACTIONS(5409),
    [sym__external_open_bracket2] = ACTIONS(5933),
  },
  [1147] = {
    [sym_call_arguments] = STATE(2651),
    [sym_subset_arguments] = STATE(2561),
    [sym_subset2_arguments] = STATE(2648),
    [sym__open_parenthesis] = STATE(1340),
    [sym__open_bracket] = STATE(1335),
    [sym__open_bracket2] = STATE(1334),
    [sym_identifier] = ACTIONS(5439),
    [anon_sym_BSLASH] = ACTIONS(5437),
    [anon_sym_function] = ACTIONS(5439),
    [anon_sym_EQ] = ACTIONS(5675),
    [anon_sym_if] = ACTIONS(5439),
    [anon_sym_for] = ACTIONS(5439),
    [anon_sym_while] = ACTIONS(5439),
    [anon_sym_repeat] = ACTIONS(5439),
    [anon_sym_QMARK] = ACTIONS(5437),
    [anon_sym_TILDE] = ACTIONS(5677),
    [anon_sym_BANG] = ACTIONS(5439),
    [anon_sym_PLUS] = ACTIONS(5679),
    [anon_sym_DASH] = ACTIONS(5681),
    [anon_sym_LT_DASH] = ACTIONS(5683),
    [anon_sym_LT_LT_DASH] = ACTIONS(5683),
    [anon_sym_COLON_EQ] = ACTIONS(5683),
    [anon_sym_DASH_GT] = ACTIONS(5685),
    [anon_sym_DASH_GT_GT] = ACTIONS(5687),
    [anon_sym_PIPE] = ACTIONS(5689),
    [anon_sym_AMP] = ACTIONS(5691),
    [anon_sym_PIPE_PIPE] = ACTIONS(5693),
    [anon_sym_AMP_AMP] = ACTIONS(5695),
    [anon_sym_LT] = ACTIONS(5697),
    [anon_sym_LT_EQ] = ACTIONS(5699),
    [anon_sym_GT] = ACTIONS(5697),
    [anon_sym_GT_EQ] = ACTIONS(5699),
    [anon_sym_EQ_EQ] = ACTIONS(5699),
    [anon_sym_BANG_EQ] = ACTIONS(5699),
    [anon_sym_STAR] = ACTIONS(5701),
    [anon_sym_SLASH] = ACTIONS(5703),
    [anon_sym_STAR_STAR] = ACTIONS(5705),
    [anon_sym_CARET] = ACTIONS(5705),
    [aux_sym_binary_operator_token1] = ACTIONS(5707),
    [anon_sym_PIPE_GT] = ACTIONS(5707),
    [anon_sym_COLON] = ACTIONS(5709),
    [anon_sym_DOLLAR] = ACTIONS(5711),
    [anon_sym_AT] = ACTIONS(5711),
    [aux_sym__hex_literal_token1] = ACTIONS(5437),
    [sym__number_literal] = ACTIONS(5439),
    [anon_sym_SQUOTE] = ACTIONS(5437),
    [anon_sym_DQUOTE] = ACTIONS(5437),
    [sym_return] = ACTIONS(5439),
    [sym_next] = ACTIONS(5439),
    [sym_break] = ACTIONS(5439),
    [sym_true] = ACTIONS(5439),
    [sym_false] = ACTIONS(5439),
    [sym_null] = ACTIONS(5439),
    [sym_inf] = ACTIONS(5439),
    [sym_nan] = ACTIONS(5439),
    [anon_sym_NA] = ACTIONS(5439),
    [anon_sym_NA_integer_] = ACTIONS(5439),
    [anon_sym_NA_real_] = ACTIONS(5439),
    [anon_sym_NA_complex_] = ACTIONS(5439),
    [anon_sym_NA_character_] = ACTIONS(5439),
    [sym_dots] = ACTIONS(5439),
    [sym_dot_dot_i] = ACTIONS(5437),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5437),
    [sym__newline] = ACTIONS(5437),
    [sym__raw_string_literal] = ACTIONS(5437),
    [sym__external_else] = ACTIONS(5437),
    [sym__external_open_parenthesis] = ACTIONS(5715),
    [sym__external_close_parenthesis] = ACTIONS(5437),
    [sym__external_open_brace] = ACTIONS(5437),
    [sym__external_open_bracket] = ACTIONS(5717),
    [sym__external_open_bracket2] = ACTIONS(5719),
    [sym__external_close_bracket2] = ACTIONS(5437),
  },
  [1148] = {
    [sym_call_arguments] = STATE(2651),
    [sym_subset_arguments] = STATE(2561),
    [sym_subset2_arguments] = STATE(2648),
    [sym__open_parenthesis] = STATE(1340),
    [sym__open_bracket] = STATE(1335),
    [sym__open_bracket2] = STATE(1334),
    [sym_identifier] = ACTIONS(5435),
    [anon_sym_BSLASH] = ACTIONS(5433),
    [anon_sym_function] = ACTIONS(5435),
    [anon_sym_EQ] = ACTIONS(5675),
    [anon_sym_if] = ACTIONS(5435),
    [anon_sym_for] = ACTIONS(5435),
    [anon_sym_while] = ACTIONS(5435),
    [anon_sym_repeat] = ACTIONS(5435),
    [anon_sym_QMARK] = ACTIONS(5433),
    [anon_sym_TILDE] = ACTIONS(5677),
    [anon_sym_BANG] = ACTIONS(5435),
    [anon_sym_PLUS] = ACTIONS(5679),
    [anon_sym_DASH] = ACTIONS(5681),
    [anon_sym_LT_DASH] = ACTIONS(5683),
    [anon_sym_LT_LT_DASH] = ACTIONS(5683),
    [anon_sym_COLON_EQ] = ACTIONS(5683),
    [anon_sym_DASH_GT] = ACTIONS(5685),
    [anon_sym_DASH_GT_GT] = ACTIONS(5687),
    [anon_sym_PIPE] = ACTIONS(5689),
    [anon_sym_AMP] = ACTIONS(5691),
    [anon_sym_PIPE_PIPE] = ACTIONS(5693),
    [anon_sym_AMP_AMP] = ACTIONS(5695),
    [anon_sym_LT] = ACTIONS(5697),
    [anon_sym_LT_EQ] = ACTIONS(5699),
    [anon_sym_GT] = ACTIONS(5697),
    [anon_sym_GT_EQ] = ACTIONS(5699),
    [anon_sym_EQ_EQ] = ACTIONS(5699),
    [anon_sym_BANG_EQ] = ACTIONS(5699),
    [anon_sym_STAR] = ACTIONS(5701),
    [anon_sym_SLASH] = ACTIONS(5703),
    [anon_sym_STAR_STAR] = ACTIONS(5705),
    [anon_sym_CARET] = ACTIONS(5705),
    [aux_sym_binary_operator_token1] = ACTIONS(5707),
    [anon_sym_PIPE_GT] = ACTIONS(5707),
    [anon_sym_COLON] = ACTIONS(5709),
    [anon_sym_DOLLAR] = ACTIONS(5711),
    [anon_sym_AT] = ACTIONS(5711),
    [aux_sym__hex_literal_token1] = ACTIONS(5433),
    [sym__number_literal] = ACTIONS(5435),
    [anon_sym_SQUOTE] = ACTIONS(5433),
    [anon_sym_DQUOTE] = ACTIONS(5433),
    [sym_return] = ACTIONS(5435),
    [sym_next] = ACTIONS(5435),
    [sym_break] = ACTIONS(5435),
    [sym_true] = ACTIONS(5435),
    [sym_false] = ACTIONS(5435),
    [sym_null] = ACTIONS(5435),
    [sym_inf] = ACTIONS(5435),
    [sym_nan] = ACTIONS(5435),
    [anon_sym_NA] = ACTIONS(5435),
    [anon_sym_NA_integer_] = ACTIONS(5435),
    [anon_sym_NA_real_] = ACTIONS(5435),
    [anon_sym_NA_complex_] = ACTIONS(5435),
    [anon_sym_NA_character_] = ACTIONS(5435),
    [sym_dots] = ACTIONS(5435),
    [sym_dot_dot_i] = ACTIONS(5433),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5433),
    [sym__newline] = ACTIONS(5433),
    [sym__raw_string_literal] = ACTIONS(5433),
    [sym__external_else] = ACTIONS(5433),
    [sym__external_open_parenthesis] = ACTIONS(5715),
    [sym__external_close_parenthesis] = ACTIONS(5433),
    [sym__external_open_brace] = ACTIONS(5433),
    [sym__external_open_bracket] = ACTIONS(5717),
    [sym__external_open_bracket2] = ACTIONS(5719),
    [sym__external_close_bracket2] = ACTIONS(5433),
  },
  [1149] = {
    [sym_call_arguments] = STATE(2651),
    [sym_subset_arguments] = STATE(2561),
    [sym_subset2_arguments] = STATE(2648),
    [sym__open_parenthesis] = STATE(1340),
    [sym__open_bracket] = STATE(1335),
    [sym__open_bracket2] = STATE(1334),
    [sym_identifier] = ACTIONS(5431),
    [anon_sym_BSLASH] = ACTIONS(5429),
    [anon_sym_function] = ACTIONS(5431),
    [anon_sym_EQ] = ACTIONS(5675),
    [anon_sym_if] = ACTIONS(5431),
    [anon_sym_for] = ACTIONS(5431),
    [anon_sym_while] = ACTIONS(5431),
    [anon_sym_repeat] = ACTIONS(5431),
    [anon_sym_QMARK] = ACTIONS(5429),
    [anon_sym_TILDE] = ACTIONS(5677),
    [anon_sym_BANG] = ACTIONS(5431),
    [anon_sym_PLUS] = ACTIONS(5679),
    [anon_sym_DASH] = ACTIONS(5681),
    [anon_sym_LT_DASH] = ACTIONS(5683),
    [anon_sym_LT_LT_DASH] = ACTIONS(5683),
    [anon_sym_COLON_EQ] = ACTIONS(5683),
    [anon_sym_DASH_GT] = ACTIONS(5685),
    [anon_sym_DASH_GT_GT] = ACTIONS(5687),
    [anon_sym_PIPE] = ACTIONS(5689),
    [anon_sym_AMP] = ACTIONS(5691),
    [anon_sym_PIPE_PIPE] = ACTIONS(5693),
    [anon_sym_AMP_AMP] = ACTIONS(5695),
    [anon_sym_LT] = ACTIONS(5697),
    [anon_sym_LT_EQ] = ACTIONS(5699),
    [anon_sym_GT] = ACTIONS(5697),
    [anon_sym_GT_EQ] = ACTIONS(5699),
    [anon_sym_EQ_EQ] = ACTIONS(5699),
    [anon_sym_BANG_EQ] = ACTIONS(5699),
    [anon_sym_STAR] = ACTIONS(5701),
    [anon_sym_SLASH] = ACTIONS(5703),
    [anon_sym_STAR_STAR] = ACTIONS(5705),
    [anon_sym_CARET] = ACTIONS(5705),
    [aux_sym_binary_operator_token1] = ACTIONS(5707),
    [anon_sym_PIPE_GT] = ACTIONS(5707),
    [anon_sym_COLON] = ACTIONS(5709),
    [anon_sym_DOLLAR] = ACTIONS(5711),
    [anon_sym_AT] = ACTIONS(5711),
    [aux_sym__hex_literal_token1] = ACTIONS(5429),
    [sym__number_literal] = ACTIONS(5431),
    [anon_sym_SQUOTE] = ACTIONS(5429),
    [anon_sym_DQUOTE] = ACTIONS(5429),
    [sym_return] = ACTIONS(5431),
    [sym_next] = ACTIONS(5431),
    [sym_break] = ACTIONS(5431),
    [sym_true] = ACTIONS(5431),
    [sym_false] = ACTIONS(5431),
    [sym_null] = ACTIONS(5431),
    [sym_inf] = ACTIONS(5431),
    [sym_nan] = ACTIONS(5431),
    [anon_sym_NA] = ACTIONS(5431),
    [anon_sym_NA_integer_] = ACTIONS(5431),
    [anon_sym_NA_real_] = ACTIONS(5431),
    [anon_sym_NA_complex_] = ACTIONS(5431),
    [anon_sym_NA_character_] = ACTIONS(5431),
    [sym_dots] = ACTIONS(5431),
    [sym_dot_dot_i] = ACTIONS(5429),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5429),
    [sym__newline] = ACTIONS(5429),
    [sym__raw_string_literal] = ACTIONS(5429),
    [sym__external_else] = ACTIONS(5429),
    [sym__external_open_parenthesis] = ACTIONS(5715),
    [sym__external_close_parenthesis] = ACTIONS(5429),
    [sym__external_open_brace] = ACTIONS(5429),
    [sym__external_open_bracket] = ACTIONS(5717),
    [sym__external_open_bracket2] = ACTIONS(5719),
    [sym__external_close_bracket2] = ACTIONS(5429),
  },
  [1150] = {
    [sym_call_arguments] = STATE(2870),
    [sym_subset_arguments] = STATE(2869),
    [sym_subset2_arguments] = STATE(2867),
    [sym__else] = STATE(4204),
    [sym__open_parenthesis] = STATE(1362),
    [sym__open_bracket] = STATE(1361),
    [sym__open_bracket2] = STATE(1360),
    [sym_identifier] = ACTIONS(5169),
    [anon_sym_BSLASH] = ACTIONS(5167),
    [anon_sym_function] = ACTIONS(5169),
    [anon_sym_EQ] = ACTIONS(6111),
    [anon_sym_if] = ACTIONS(5169),
    [anon_sym_for] = ACTIONS(5169),
    [anon_sym_while] = ACTIONS(5169),
    [anon_sym_repeat] = ACTIONS(5169),
    [anon_sym_QMARK] = ACTIONS(5167),
    [anon_sym_TILDE] = ACTIONS(6113),
    [anon_sym_BANG] = ACTIONS(5169),
    [anon_sym_PLUS] = ACTIONS(6115),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_LT_DASH] = ACTIONS(6119),
    [anon_sym_LT_LT_DASH] = ACTIONS(6119),
    [anon_sym_COLON_EQ] = ACTIONS(6119),
    [anon_sym_DASH_GT] = ACTIONS(6121),
    [anon_sym_DASH_GT_GT] = ACTIONS(6123),
    [anon_sym_PIPE] = ACTIONS(6125),
    [anon_sym_AMP] = ACTIONS(6127),
    [anon_sym_PIPE_PIPE] = ACTIONS(6129),
    [anon_sym_AMP_AMP] = ACTIONS(6131),
    [anon_sym_LT] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6135),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_GT_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(6135),
    [anon_sym_STAR] = ACTIONS(6137),
    [anon_sym_SLASH] = ACTIONS(6139),
    [anon_sym_STAR_STAR] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6141),
    [aux_sym_binary_operator_token1] = ACTIONS(6143),
    [anon_sym_PIPE_GT] = ACTIONS(6143),
    [anon_sym_COLON] = ACTIONS(6145),
    [anon_sym_DOLLAR] = ACTIONS(6147),
    [anon_sym_AT] = ACTIONS(6147),
    [aux_sym__hex_literal_token1] = ACTIONS(5167),
    [sym__number_literal] = ACTIONS(5169),
    [anon_sym_SQUOTE] = ACTIONS(5167),
    [anon_sym_DQUOTE] = ACTIONS(5167),
    [sym_return] = ACTIONS(5169),
    [sym_next] = ACTIONS(5169),
    [sym_break] = ACTIONS(5169),
    [sym_true] = ACTIONS(5169),
    [sym_false] = ACTIONS(5169),
    [sym_null] = ACTIONS(5169),
    [sym_inf] = ACTIONS(5169),
    [sym_nan] = ACTIONS(5169),
    [anon_sym_NA] = ACTIONS(5169),
    [anon_sym_NA_integer_] = ACTIONS(5169),
    [anon_sym_NA_real_] = ACTIONS(5169),
    [anon_sym_NA_complex_] = ACTIONS(5169),
    [anon_sym_NA_character_] = ACTIONS(5169),
    [sym_dots] = ACTIONS(5169),
    [sym_dot_dot_i] = ACTIONS(5167),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5167),
    [sym__newline] = ACTIONS(5167),
    [sym__raw_string_literal] = ACTIONS(5167),
    [sym__external_else] = ACTIONS(6157),
    [sym__external_open_parenthesis] = ACTIONS(6151),
    [sym__external_open_brace] = ACTIONS(5167),
    [sym__external_open_bracket] = ACTIONS(6153),
    [sym__external_open_bracket2] = ACTIONS(6155),
    [sym__external_close_bracket2] = ACTIONS(5167),
  },
  [1151] = {
    [sym_call_arguments] = STATE(2870),
    [sym_subset_arguments] = STATE(2869),
    [sym_subset2_arguments] = STATE(2867),
    [sym__else] = STATE(4205),
    [sym__open_parenthesis] = STATE(1362),
    [sym__open_bracket] = STATE(1361),
    [sym__open_bracket2] = STATE(1360),
    [sym_identifier] = ACTIONS(5115),
    [anon_sym_BSLASH] = ACTIONS(5117),
    [anon_sym_function] = ACTIONS(5115),
    [anon_sym_EQ] = ACTIONS(6111),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_for] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_repeat] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(5117),
    [anon_sym_TILDE] = ACTIONS(6113),
    [anon_sym_BANG] = ACTIONS(5115),
    [anon_sym_PLUS] = ACTIONS(6115),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_LT_DASH] = ACTIONS(6119),
    [anon_sym_LT_LT_DASH] = ACTIONS(6119),
    [anon_sym_COLON_EQ] = ACTIONS(6119),
    [anon_sym_DASH_GT] = ACTIONS(6121),
    [anon_sym_DASH_GT_GT] = ACTIONS(6123),
    [anon_sym_PIPE] = ACTIONS(6125),
    [anon_sym_AMP] = ACTIONS(6127),
    [anon_sym_PIPE_PIPE] = ACTIONS(6129),
    [anon_sym_AMP_AMP] = ACTIONS(6131),
    [anon_sym_LT] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6135),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_GT_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(6135),
    [anon_sym_STAR] = ACTIONS(6137),
    [anon_sym_SLASH] = ACTIONS(6139),
    [anon_sym_STAR_STAR] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6141),
    [aux_sym_binary_operator_token1] = ACTIONS(6143),
    [anon_sym_PIPE_GT] = ACTIONS(6143),
    [anon_sym_COLON] = ACTIONS(6145),
    [anon_sym_DOLLAR] = ACTIONS(6147),
    [anon_sym_AT] = ACTIONS(6147),
    [aux_sym__hex_literal_token1] = ACTIONS(5117),
    [sym__number_literal] = ACTIONS(5115),
    [anon_sym_SQUOTE] = ACTIONS(5117),
    [anon_sym_DQUOTE] = ACTIONS(5117),
    [sym_return] = ACTIONS(5115),
    [sym_next] = ACTIONS(5115),
    [sym_break] = ACTIONS(5115),
    [sym_true] = ACTIONS(5115),
    [sym_false] = ACTIONS(5115),
    [sym_null] = ACTIONS(5115),
    [sym_inf] = ACTIONS(5115),
    [sym_nan] = ACTIONS(5115),
    [anon_sym_NA] = ACTIONS(5115),
    [anon_sym_NA_integer_] = ACTIONS(5115),
    [anon_sym_NA_real_] = ACTIONS(5115),
    [anon_sym_NA_complex_] = ACTIONS(5115),
    [anon_sym_NA_character_] = ACTIONS(5115),
    [sym_dots] = ACTIONS(5115),
    [sym_dot_dot_i] = ACTIONS(5117),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5117),
    [sym__newline] = ACTIONS(5117),
    [sym__raw_string_literal] = ACTIONS(5117),
    [sym__external_else] = ACTIONS(6159),
    [sym__external_open_parenthesis] = ACTIONS(6151),
    [sym__external_open_brace] = ACTIONS(5117),
    [sym__external_open_bracket] = ACTIONS(6153),
    [sym__external_open_bracket2] = ACTIONS(6155),
    [sym__external_close_bracket2] = ACTIONS(5117),
  },
  [1152] = {
    [sym_call_arguments] = STATE(2638),
    [sym_subset_arguments] = STATE(2647),
    [sym_subset2_arguments] = STATE(2650),
    [sym__open_parenthesis] = STATE(1537),
    [sym__open_bracket] = STATE(1534),
    [sym__open_bracket2] = STATE(1533),
    [sym_identifier] = ACTIONS(5325),
    [anon_sym_BSLASH] = ACTIONS(5327),
    [anon_sym_function] = ACTIONS(5325),
    [anon_sym_EQ] = ACTIONS(6055),
    [anon_sym_if] = ACTIONS(5325),
    [anon_sym_for] = ACTIONS(5325),
    [anon_sym_while] = ACTIONS(5325),
    [anon_sym_repeat] = ACTIONS(5325),
    [anon_sym_QMARK] = ACTIONS(6161),
    [anon_sym_TILDE] = ACTIONS(6057),
    [anon_sym_BANG] = ACTIONS(5325),
    [anon_sym_PLUS] = ACTIONS(6059),
    [anon_sym_DASH] = ACTIONS(6061),
    [anon_sym_LT_DASH] = ACTIONS(6063),
    [anon_sym_LT_LT_DASH] = ACTIONS(6063),
    [anon_sym_COLON_EQ] = ACTIONS(6063),
    [anon_sym_DASH_GT] = ACTIONS(6065),
    [anon_sym_DASH_GT_GT] = ACTIONS(6067),
    [anon_sym_PIPE] = ACTIONS(6069),
    [anon_sym_AMP] = ACTIONS(6071),
    [anon_sym_PIPE_PIPE] = ACTIONS(6073),
    [anon_sym_AMP_AMP] = ACTIONS(6075),
    [anon_sym_LT] = ACTIONS(6077),
    [anon_sym_LT_EQ] = ACTIONS(6079),
    [anon_sym_GT] = ACTIONS(6077),
    [anon_sym_GT_EQ] = ACTIONS(6079),
    [anon_sym_EQ_EQ] = ACTIONS(6079),
    [anon_sym_BANG_EQ] = ACTIONS(6079),
    [anon_sym_STAR] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6083),
    [anon_sym_STAR_STAR] = ACTIONS(6085),
    [anon_sym_CARET] = ACTIONS(6085),
    [aux_sym_binary_operator_token1] = ACTIONS(6087),
    [anon_sym_PIPE_GT] = ACTIONS(6087),
    [anon_sym_COLON] = ACTIONS(6089),
    [anon_sym_DOLLAR] = ACTIONS(6091),
    [anon_sym_AT] = ACTIONS(6091),
    [aux_sym__hex_literal_token1] = ACTIONS(5327),
    [sym__number_literal] = ACTIONS(5325),
    [anon_sym_SQUOTE] = ACTIONS(5327),
    [anon_sym_DQUOTE] = ACTIONS(5327),
    [sym_return] = ACTIONS(5325),
    [sym_next] = ACTIONS(5325),
    [sym_break] = ACTIONS(5325),
    [sym_true] = ACTIONS(5325),
    [sym_false] = ACTIONS(5325),
    [sym_null] = ACTIONS(5325),
    [sym_inf] = ACTIONS(5325),
    [sym_nan] = ACTIONS(5325),
    [anon_sym_NA] = ACTIONS(5325),
    [anon_sym_NA_integer_] = ACTIONS(5325),
    [anon_sym_NA_real_] = ACTIONS(5325),
    [anon_sym_NA_complex_] = ACTIONS(5325),
    [anon_sym_NA_character_] = ACTIONS(5325),
    [sym_dots] = ACTIONS(5325),
    [sym_dot_dot_i] = ACTIONS(5327),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5327),
    [sym__newline] = ACTIONS(5327),
    [sym__semicolon] = ACTIONS(5327),
    [sym__raw_string_literal] = ACTIONS(5327),
    [sym__external_open_parenthesis] = ACTIONS(6093),
    [sym__external_open_brace] = ACTIONS(5327),
    [sym__external_close_brace] = ACTIONS(5327),
    [sym__external_open_bracket] = ACTIONS(6095),
    [sym__external_open_bracket2] = ACTIONS(6097),
    [sym__external_close_bracket2] = ACTIONS(5327),
  },
  [1153] = {
    [sym_call_arguments] = STATE(2671),
    [sym_subset_arguments] = STATE(2663),
    [sym_subset2_arguments] = STATE(2661),
    [sym__open_parenthesis] = STATE(1555),
    [sym__open_bracket] = STATE(1551),
    [sym__open_bracket2] = STATE(1549),
    [sym_identifier] = ACTIONS(5455),
    [anon_sym_BSLASH] = ACTIONS(5453),
    [anon_sym_function] = ACTIONS(5455),
    [anon_sym_EQ] = ACTIONS(5889),
    [anon_sym_if] = ACTIONS(5455),
    [anon_sym_for] = ACTIONS(5455),
    [anon_sym_while] = ACTIONS(5455),
    [anon_sym_repeat] = ACTIONS(5455),
    [anon_sym_QMARK] = ACTIONS(5453),
    [anon_sym_TILDE] = ACTIONS(5893),
    [anon_sym_BANG] = ACTIONS(5455),
    [anon_sym_PLUS] = ACTIONS(5895),
    [anon_sym_DASH] = ACTIONS(5897),
    [anon_sym_LT_DASH] = ACTIONS(5899),
    [anon_sym_LT_LT_DASH] = ACTIONS(5899),
    [anon_sym_COLON_EQ] = ACTIONS(5899),
    [anon_sym_DASH_GT] = ACTIONS(5901),
    [anon_sym_DASH_GT_GT] = ACTIONS(5903),
    [anon_sym_PIPE] = ACTIONS(5905),
    [anon_sym_AMP] = ACTIONS(5907),
    [anon_sym_PIPE_PIPE] = ACTIONS(5909),
    [anon_sym_AMP_AMP] = ACTIONS(5911),
    [anon_sym_LT] = ACTIONS(5913),
    [anon_sym_LT_EQ] = ACTIONS(5915),
    [anon_sym_GT] = ACTIONS(5913),
    [anon_sym_GT_EQ] = ACTIONS(5915),
    [anon_sym_EQ_EQ] = ACTIONS(5915),
    [anon_sym_BANG_EQ] = ACTIONS(5915),
    [anon_sym_STAR] = ACTIONS(5917),
    [anon_sym_SLASH] = ACTIONS(5919),
    [anon_sym_STAR_STAR] = ACTIONS(5921),
    [anon_sym_CARET] = ACTIONS(5921),
    [aux_sym_binary_operator_token1] = ACTIONS(5923),
    [anon_sym_PIPE_GT] = ACTIONS(5923),
    [anon_sym_COLON] = ACTIONS(5925),
    [anon_sym_DOLLAR] = ACTIONS(5927),
    [anon_sym_AT] = ACTIONS(5927),
    [aux_sym__hex_literal_token1] = ACTIONS(5453),
    [sym__number_literal] = ACTIONS(5455),
    [anon_sym_SQUOTE] = ACTIONS(5453),
    [anon_sym_DQUOTE] = ACTIONS(5453),
    [sym_return] = ACTIONS(5455),
    [sym_next] = ACTIONS(5455),
    [sym_break] = ACTIONS(5455),
    [sym_true] = ACTIONS(5455),
    [sym_false] = ACTIONS(5455),
    [sym_null] = ACTIONS(5455),
    [sym_inf] = ACTIONS(5455),
    [sym_nan] = ACTIONS(5455),
    [anon_sym_NA] = ACTIONS(5455),
    [anon_sym_NA_integer_] = ACTIONS(5455),
    [anon_sym_NA_real_] = ACTIONS(5455),
    [anon_sym_NA_complex_] = ACTIONS(5455),
    [anon_sym_NA_character_] = ACTIONS(5455),
    [sym_dots] = ACTIONS(5455),
    [sym_dot_dot_i] = ACTIONS(5453),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5453),
    [sym__newline] = ACTIONS(5453),
    [sym__semicolon] = ACTIONS(5453),
    [sym__raw_string_literal] = ACTIONS(5453),
    [sym__external_open_parenthesis] = ACTIONS(5929),
    [sym__external_open_brace] = ACTIONS(5453),
    [sym__external_close_brace] = ACTIONS(5453),
    [sym__external_open_bracket] = ACTIONS(5931),
    [sym__external_close_bracket] = ACTIONS(5453),
    [sym__external_open_bracket2] = ACTIONS(5933),
  },
  [1154] = {
    [sym_call_arguments] = STATE(2671),
    [sym_subset_arguments] = STATE(2663),
    [sym_subset2_arguments] = STATE(2661),
    [sym__open_parenthesis] = STATE(1555),
    [sym__open_bracket] = STATE(1551),
    [sym__open_bracket2] = STATE(1549),
    [sym_identifier] = ACTIONS(5451),
    [anon_sym_BSLASH] = ACTIONS(5449),
    [anon_sym_function] = ACTIONS(5451),
    [anon_sym_EQ] = ACTIONS(5889),
    [anon_sym_if] = ACTIONS(5451),
    [anon_sym_for] = ACTIONS(5451),
    [anon_sym_while] = ACTIONS(5451),
    [anon_sym_repeat] = ACTIONS(5451),
    [anon_sym_QMARK] = ACTIONS(5449),
    [anon_sym_TILDE] = ACTIONS(5893),
    [anon_sym_BANG] = ACTIONS(5451),
    [anon_sym_PLUS] = ACTIONS(5895),
    [anon_sym_DASH] = ACTIONS(5897),
    [anon_sym_LT_DASH] = ACTIONS(5899),
    [anon_sym_LT_LT_DASH] = ACTIONS(5899),
    [anon_sym_COLON_EQ] = ACTIONS(5899),
    [anon_sym_DASH_GT] = ACTIONS(5901),
    [anon_sym_DASH_GT_GT] = ACTIONS(5903),
    [anon_sym_PIPE] = ACTIONS(5905),
    [anon_sym_AMP] = ACTIONS(5907),
    [anon_sym_PIPE_PIPE] = ACTIONS(5909),
    [anon_sym_AMP_AMP] = ACTIONS(5911),
    [anon_sym_LT] = ACTIONS(5913),
    [anon_sym_LT_EQ] = ACTIONS(5915),
    [anon_sym_GT] = ACTIONS(5913),
    [anon_sym_GT_EQ] = ACTIONS(5915),
    [anon_sym_EQ_EQ] = ACTIONS(5915),
    [anon_sym_BANG_EQ] = ACTIONS(5915),
    [anon_sym_STAR] = ACTIONS(5917),
    [anon_sym_SLASH] = ACTIONS(5919),
    [anon_sym_STAR_STAR] = ACTIONS(5921),
    [anon_sym_CARET] = ACTIONS(5921),
    [aux_sym_binary_operator_token1] = ACTIONS(5923),
    [anon_sym_PIPE_GT] = ACTIONS(5923),
    [anon_sym_COLON] = ACTIONS(5925),
    [anon_sym_DOLLAR] = ACTIONS(5927),
    [anon_sym_AT] = ACTIONS(5927),
    [aux_sym__hex_literal_token1] = ACTIONS(5449),
    [sym__number_literal] = ACTIONS(5451),
    [anon_sym_SQUOTE] = ACTIONS(5449),
    [anon_sym_DQUOTE] = ACTIONS(5449),
    [sym_return] = ACTIONS(5451),
    [sym_next] = ACTIONS(5451),
    [sym_break] = ACTIONS(5451),
    [sym_true] = ACTIONS(5451),
    [sym_false] = ACTIONS(5451),
    [sym_null] = ACTIONS(5451),
    [sym_inf] = ACTIONS(5451),
    [sym_nan] = ACTIONS(5451),
    [anon_sym_NA] = ACTIONS(5451),
    [anon_sym_NA_integer_] = ACTIONS(5451),
    [anon_sym_NA_real_] = ACTIONS(5451),
    [anon_sym_NA_complex_] = ACTIONS(5451),
    [anon_sym_NA_character_] = ACTIONS(5451),
    [sym_dots] = ACTIONS(5451),
    [sym_dot_dot_i] = ACTIONS(5449),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5449),
    [sym__newline] = ACTIONS(5449),
    [sym__semicolon] = ACTIONS(5449),
    [sym__raw_string_literal] = ACTIONS(5449),
    [sym__external_open_parenthesis] = ACTIONS(5929),
    [sym__external_open_brace] = ACTIONS(5449),
    [sym__external_close_brace] = ACTIONS(5449),
    [sym__external_open_bracket] = ACTIONS(5931),
    [sym__external_close_bracket] = ACTIONS(5449),
    [sym__external_open_bracket2] = ACTIONS(5933),
  },
  [1155] = {
    [sym_call_arguments] = STATE(2651),
    [sym_subset_arguments] = STATE(2561),
    [sym_subset2_arguments] = STATE(2648),
    [sym__open_parenthesis] = STATE(1340),
    [sym__open_bracket] = STATE(1335),
    [sym__open_bracket2] = STATE(1334),
    [sym_identifier] = ACTIONS(5427),
    [anon_sym_BSLASH] = ACTIONS(5425),
    [anon_sym_function] = ACTIONS(5427),
    [anon_sym_EQ] = ACTIONS(5675),
    [anon_sym_if] = ACTIONS(5427),
    [anon_sym_for] = ACTIONS(5427),
    [anon_sym_while] = ACTIONS(5427),
    [anon_sym_repeat] = ACTIONS(5427),
    [anon_sym_QMARK] = ACTIONS(5425),
    [anon_sym_TILDE] = ACTIONS(5677),
    [anon_sym_BANG] = ACTIONS(5427),
    [anon_sym_PLUS] = ACTIONS(5679),
    [anon_sym_DASH] = ACTIONS(5681),
    [anon_sym_LT_DASH] = ACTIONS(5683),
    [anon_sym_LT_LT_DASH] = ACTIONS(5683),
    [anon_sym_COLON_EQ] = ACTIONS(5683),
    [anon_sym_DASH_GT] = ACTIONS(5685),
    [anon_sym_DASH_GT_GT] = ACTIONS(5687),
    [anon_sym_PIPE] = ACTIONS(5689),
    [anon_sym_AMP] = ACTIONS(5691),
    [anon_sym_PIPE_PIPE] = ACTIONS(5693),
    [anon_sym_AMP_AMP] = ACTIONS(5695),
    [anon_sym_LT] = ACTIONS(5697),
    [anon_sym_LT_EQ] = ACTIONS(5699),
    [anon_sym_GT] = ACTIONS(5697),
    [anon_sym_GT_EQ] = ACTIONS(5699),
    [anon_sym_EQ_EQ] = ACTIONS(5699),
    [anon_sym_BANG_EQ] = ACTIONS(5699),
    [anon_sym_STAR] = ACTIONS(5701),
    [anon_sym_SLASH] = ACTIONS(5703),
    [anon_sym_STAR_STAR] = ACTIONS(5705),
    [anon_sym_CARET] = ACTIONS(5705),
    [aux_sym_binary_operator_token1] = ACTIONS(5707),
    [anon_sym_PIPE_GT] = ACTIONS(5707),
    [anon_sym_COLON] = ACTIONS(5709),
    [anon_sym_DOLLAR] = ACTIONS(5711),
    [anon_sym_AT] = ACTIONS(5711),
    [aux_sym__hex_literal_token1] = ACTIONS(5425),
    [sym__number_literal] = ACTIONS(5427),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_DQUOTE] = ACTIONS(5425),
    [sym_return] = ACTIONS(5427),
    [sym_next] = ACTIONS(5427),
    [sym_break] = ACTIONS(5427),
    [sym_true] = ACTIONS(5427),
    [sym_false] = ACTIONS(5427),
    [sym_null] = ACTIONS(5427),
    [sym_inf] = ACTIONS(5427),
    [sym_nan] = ACTIONS(5427),
    [anon_sym_NA] = ACTIONS(5427),
    [anon_sym_NA_integer_] = ACTIONS(5427),
    [anon_sym_NA_real_] = ACTIONS(5427),
    [anon_sym_NA_complex_] = ACTIONS(5427),
    [anon_sym_NA_character_] = ACTIONS(5427),
    [sym_dots] = ACTIONS(5427),
    [sym_dot_dot_i] = ACTIONS(5425),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5425),
    [sym__newline] = ACTIONS(5425),
    [sym__raw_string_literal] = ACTIONS(5425),
    [sym__external_else] = ACTIONS(5425),
    [sym__external_open_parenthesis] = ACTIONS(5715),
    [sym__external_close_parenthesis] = ACTIONS(5425),
    [sym__external_open_brace] = ACTIONS(5425),
    [sym__external_open_bracket] = ACTIONS(5717),
    [sym__external_open_bracket2] = ACTIONS(5719),
    [sym__external_close_bracket2] = ACTIONS(5425),
  },
  [1156] = {
    [sym_call_arguments] = STATE(2671),
    [sym_subset_arguments] = STATE(2663),
    [sym_subset2_arguments] = STATE(2661),
    [sym__open_parenthesis] = STATE(1555),
    [sym__open_bracket] = STATE(1551),
    [sym__open_bracket2] = STATE(1549),
    [sym_identifier] = ACTIONS(5447),
    [anon_sym_BSLASH] = ACTIONS(5445),
    [anon_sym_function] = ACTIONS(5447),
    [anon_sym_EQ] = ACTIONS(5889),
    [anon_sym_if] = ACTIONS(5447),
    [anon_sym_for] = ACTIONS(5447),
    [anon_sym_while] = ACTIONS(5447),
    [anon_sym_repeat] = ACTIONS(5447),
    [anon_sym_QMARK] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(5893),
    [anon_sym_BANG] = ACTIONS(5447),
    [anon_sym_PLUS] = ACTIONS(5895),
    [anon_sym_DASH] = ACTIONS(5897),
    [anon_sym_LT_DASH] = ACTIONS(5899),
    [anon_sym_LT_LT_DASH] = ACTIONS(5899),
    [anon_sym_COLON_EQ] = ACTIONS(5899),
    [anon_sym_DASH_GT] = ACTIONS(5901),
    [anon_sym_DASH_GT_GT] = ACTIONS(5903),
    [anon_sym_PIPE] = ACTIONS(5905),
    [anon_sym_AMP] = ACTIONS(5907),
    [anon_sym_PIPE_PIPE] = ACTIONS(5909),
    [anon_sym_AMP_AMP] = ACTIONS(5911),
    [anon_sym_LT] = ACTIONS(5913),
    [anon_sym_LT_EQ] = ACTIONS(5915),
    [anon_sym_GT] = ACTIONS(5913),
    [anon_sym_GT_EQ] = ACTIONS(5915),
    [anon_sym_EQ_EQ] = ACTIONS(5915),
    [anon_sym_BANG_EQ] = ACTIONS(5915),
    [anon_sym_STAR] = ACTIONS(5917),
    [anon_sym_SLASH] = ACTIONS(5919),
    [anon_sym_STAR_STAR] = ACTIONS(5921),
    [anon_sym_CARET] = ACTIONS(5921),
    [aux_sym_binary_operator_token1] = ACTIONS(5923),
    [anon_sym_PIPE_GT] = ACTIONS(5923),
    [anon_sym_COLON] = ACTIONS(5925),
    [anon_sym_DOLLAR] = ACTIONS(5927),
    [anon_sym_AT] = ACTIONS(5927),
    [aux_sym__hex_literal_token1] = ACTIONS(5445),
    [sym__number_literal] = ACTIONS(5447),
    [anon_sym_SQUOTE] = ACTIONS(5445),
    [anon_sym_DQUOTE] = ACTIONS(5445),
    [sym_return] = ACTIONS(5447),
    [sym_next] = ACTIONS(5447),
    [sym_break] = ACTIONS(5447),
    [sym_true] = ACTIONS(5447),
    [sym_false] = ACTIONS(5447),
    [sym_null] = ACTIONS(5447),
    [sym_inf] = ACTIONS(5447),
    [sym_nan] = ACTIONS(5447),
    [anon_sym_NA] = ACTIONS(5447),
    [anon_sym_NA_integer_] = ACTIONS(5447),
    [anon_sym_NA_real_] = ACTIONS(5447),
    [anon_sym_NA_complex_] = ACTIONS(5447),
    [anon_sym_NA_character_] = ACTIONS(5447),
    [sym_dots] = ACTIONS(5447),
    [sym_dot_dot_i] = ACTIONS(5445),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5445),
    [sym__newline] = ACTIONS(5445),
    [sym__semicolon] = ACTIONS(5445),
    [sym__raw_string_literal] = ACTIONS(5445),
    [sym__external_open_parenthesis] = ACTIONS(5929),
    [sym__external_open_brace] = ACTIONS(5445),
    [sym__external_close_brace] = ACTIONS(5445),
    [sym__external_open_bracket] = ACTIONS(5931),
    [sym__external_close_bracket] = ACTIONS(5445),
    [sym__external_open_bracket2] = ACTIONS(5933),
  },
  [1157] = {
    [sym_call_arguments] = STATE(2651),
    [sym_subset_arguments] = STATE(2561),
    [sym_subset2_arguments] = STATE(2648),
    [sym__open_parenthesis] = STATE(1340),
    [sym__open_bracket] = STATE(1335),
    [sym__open_bracket2] = STATE(1334),
    [sym_identifier] = ACTIONS(5423),
    [anon_sym_BSLASH] = ACTIONS(5421),
    [anon_sym_function] = ACTIONS(5423),
    [anon_sym_EQ] = ACTIONS(5675),
    [anon_sym_if] = ACTIONS(5423),
    [anon_sym_for] = ACTIONS(5423),
    [anon_sym_while] = ACTIONS(5423),
    [anon_sym_repeat] = ACTIONS(5423),
    [anon_sym_QMARK] = ACTIONS(5421),
    [anon_sym_TILDE] = ACTIONS(5677),
    [anon_sym_BANG] = ACTIONS(5423),
    [anon_sym_PLUS] = ACTIONS(5679),
    [anon_sym_DASH] = ACTIONS(5681),
    [anon_sym_LT_DASH] = ACTIONS(5683),
    [anon_sym_LT_LT_DASH] = ACTIONS(5683),
    [anon_sym_COLON_EQ] = ACTIONS(5683),
    [anon_sym_DASH_GT] = ACTIONS(5685),
    [anon_sym_DASH_GT_GT] = ACTIONS(5687),
    [anon_sym_PIPE] = ACTIONS(5689),
    [anon_sym_AMP] = ACTIONS(5691),
    [anon_sym_PIPE_PIPE] = ACTIONS(5693),
    [anon_sym_AMP_AMP] = ACTIONS(5695),
    [anon_sym_LT] = ACTIONS(5697),
    [anon_sym_LT_EQ] = ACTIONS(5699),
    [anon_sym_GT] = ACTIONS(5697),
    [anon_sym_GT_EQ] = ACTIONS(5699),
    [anon_sym_EQ_EQ] = ACTIONS(5699),
    [anon_sym_BANG_EQ] = ACTIONS(5699),
    [anon_sym_STAR] = ACTIONS(5701),
    [anon_sym_SLASH] = ACTIONS(5703),
    [anon_sym_STAR_STAR] = ACTIONS(5705),
    [anon_sym_CARET] = ACTIONS(5705),
    [aux_sym_binary_operator_token1] = ACTIONS(5707),
    [anon_sym_PIPE_GT] = ACTIONS(5707),
    [anon_sym_COLON] = ACTIONS(5709),
    [anon_sym_DOLLAR] = ACTIONS(5711),
    [anon_sym_AT] = ACTIONS(5711),
    [aux_sym__hex_literal_token1] = ACTIONS(5421),
    [sym__number_literal] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5421),
    [anon_sym_DQUOTE] = ACTIONS(5421),
    [sym_return] = ACTIONS(5423),
    [sym_next] = ACTIONS(5423),
    [sym_break] = ACTIONS(5423),
    [sym_true] = ACTIONS(5423),
    [sym_false] = ACTIONS(5423),
    [sym_null] = ACTIONS(5423),
    [sym_inf] = ACTIONS(5423),
    [sym_nan] = ACTIONS(5423),
    [anon_sym_NA] = ACTIONS(5423),
    [anon_sym_NA_integer_] = ACTIONS(5423),
    [anon_sym_NA_real_] = ACTIONS(5423),
    [anon_sym_NA_complex_] = ACTIONS(5423),
    [anon_sym_NA_character_] = ACTIONS(5423),
    [sym_dots] = ACTIONS(5423),
    [sym_dot_dot_i] = ACTIONS(5421),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5421),
    [sym__newline] = ACTIONS(5421),
    [sym__raw_string_literal] = ACTIONS(5421),
    [sym__external_else] = ACTIONS(5421),
    [sym__external_open_parenthesis] = ACTIONS(5715),
    [sym__external_close_parenthesis] = ACTIONS(5421),
    [sym__external_open_brace] = ACTIONS(5421),
    [sym__external_open_bracket] = ACTIONS(5717),
    [sym__external_open_bracket2] = ACTIONS(5719),
    [sym__external_close_bracket2] = ACTIONS(5421),
  },
  [1158] = {
    [sym_call_arguments] = STATE(2651),
    [sym_subset_arguments] = STATE(2561),
    [sym_subset2_arguments] = STATE(2648),
    [sym__open_parenthesis] = STATE(1340),
    [sym__open_bracket] = STATE(1335),
    [sym__open_bracket2] = STATE(1334),
    [sym_identifier] = ACTIONS(5419),
    [anon_sym_BSLASH] = ACTIONS(5417),
    [anon_sym_function] = ACTIONS(5419),
    [anon_sym_EQ] = ACTIONS(5675),
    [anon_sym_if] = ACTIONS(5419),
    [anon_sym_for] = ACTIONS(5419),
    [anon_sym_while] = ACTIONS(5419),
    [anon_sym_repeat] = ACTIONS(5419),
    [anon_sym_QMARK] = ACTIONS(5417),
    [anon_sym_TILDE] = ACTIONS(5677),
    [anon_sym_BANG] = ACTIONS(5419),
    [anon_sym_PLUS] = ACTIONS(5679),
    [anon_sym_DASH] = ACTIONS(5681),
    [anon_sym_LT_DASH] = ACTIONS(5683),
    [anon_sym_LT_LT_DASH] = ACTIONS(5683),
    [anon_sym_COLON_EQ] = ACTIONS(5683),
    [anon_sym_DASH_GT] = ACTIONS(5685),
    [anon_sym_DASH_GT_GT] = ACTIONS(5687),
    [anon_sym_PIPE] = ACTIONS(5689),
    [anon_sym_AMP] = ACTIONS(5691),
    [anon_sym_PIPE_PIPE] = ACTIONS(5693),
    [anon_sym_AMP_AMP] = ACTIONS(5695),
    [anon_sym_LT] = ACTIONS(5697),
    [anon_sym_LT_EQ] = ACTIONS(5699),
    [anon_sym_GT] = ACTIONS(5697),
    [anon_sym_GT_EQ] = ACTIONS(5699),
    [anon_sym_EQ_EQ] = ACTIONS(5699),
    [anon_sym_BANG_EQ] = ACTIONS(5699),
    [anon_sym_STAR] = ACTIONS(5701),
    [anon_sym_SLASH] = ACTIONS(5703),
    [anon_sym_STAR_STAR] = ACTIONS(5705),
    [anon_sym_CARET] = ACTIONS(5705),
    [aux_sym_binary_operator_token1] = ACTIONS(5707),
    [anon_sym_PIPE_GT] = ACTIONS(5707),
    [anon_sym_COLON] = ACTIONS(5709),
    [anon_sym_DOLLAR] = ACTIONS(5711),
    [anon_sym_AT] = ACTIONS(5711),
    [aux_sym__hex_literal_token1] = ACTIONS(5417),
    [sym__number_literal] = ACTIONS(5419),
    [anon_sym_SQUOTE] = ACTIONS(5417),
    [anon_sym_DQUOTE] = ACTIONS(5417),
    [sym_return] = ACTIONS(5419),
    [sym_next] = ACTIONS(5419),
    [sym_break] = ACTIONS(5419),
    [sym_true] = ACTIONS(5419),
    [sym_false] = ACTIONS(5419),
    [sym_null] = ACTIONS(5419),
    [sym_inf] = ACTIONS(5419),
    [sym_nan] = ACTIONS(5419),
    [anon_sym_NA] = ACTIONS(5419),
    [anon_sym_NA_integer_] = ACTIONS(5419),
    [anon_sym_NA_real_] = ACTIONS(5419),
    [anon_sym_NA_complex_] = ACTIONS(5419),
    [anon_sym_NA_character_] = ACTIONS(5419),
    [sym_dots] = ACTIONS(5419),
    [sym_dot_dot_i] = ACTIONS(5417),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5417),
    [sym__newline] = ACTIONS(5417),
    [sym__raw_string_literal] = ACTIONS(5417),
    [sym__external_else] = ACTIONS(5417),
    [sym__external_open_parenthesis] = ACTIONS(5715),
    [sym__external_close_parenthesis] = ACTIONS(5417),
    [sym__external_open_brace] = ACTIONS(5417),
    [sym__external_open_bracket] = ACTIONS(5717),
    [sym__external_open_bracket2] = ACTIONS(5719),
    [sym__external_close_bracket2] = ACTIONS(5417),
  },
  [1159] = {
    [sym_call_arguments] = STATE(2870),
    [sym_subset_arguments] = STATE(2869),
    [sym_subset2_arguments] = STATE(2867),
    [sym__else] = STATE(4209),
    [sym__open_parenthesis] = STATE(1362),
    [sym__open_bracket] = STATE(1361),
    [sym__open_bracket2] = STATE(1360),
    [sym_identifier] = ACTIONS(5065),
    [anon_sym_BSLASH] = ACTIONS(5067),
    [anon_sym_function] = ACTIONS(5065),
    [anon_sym_EQ] = ACTIONS(6111),
    [anon_sym_if] = ACTIONS(5065),
    [anon_sym_for] = ACTIONS(5065),
    [anon_sym_while] = ACTIONS(5065),
    [anon_sym_repeat] = ACTIONS(5065),
    [anon_sym_QMARK] = ACTIONS(5067),
    [anon_sym_TILDE] = ACTIONS(6113),
    [anon_sym_BANG] = ACTIONS(5065),
    [anon_sym_PLUS] = ACTIONS(6115),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_LT_DASH] = ACTIONS(6119),
    [anon_sym_LT_LT_DASH] = ACTIONS(6119),
    [anon_sym_COLON_EQ] = ACTIONS(6119),
    [anon_sym_DASH_GT] = ACTIONS(6121),
    [anon_sym_DASH_GT_GT] = ACTIONS(6123),
    [anon_sym_PIPE] = ACTIONS(6125),
    [anon_sym_AMP] = ACTIONS(6127),
    [anon_sym_PIPE_PIPE] = ACTIONS(6129),
    [anon_sym_AMP_AMP] = ACTIONS(6131),
    [anon_sym_LT] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6135),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_GT_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(6135),
    [anon_sym_STAR] = ACTIONS(6137),
    [anon_sym_SLASH] = ACTIONS(6139),
    [anon_sym_STAR_STAR] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6141),
    [aux_sym_binary_operator_token1] = ACTIONS(6143),
    [anon_sym_PIPE_GT] = ACTIONS(6143),
    [anon_sym_COLON] = ACTIONS(6145),
    [anon_sym_DOLLAR] = ACTIONS(6147),
    [anon_sym_AT] = ACTIONS(6147),
    [aux_sym__hex_literal_token1] = ACTIONS(5067),
    [sym__number_literal] = ACTIONS(5065),
    [anon_sym_SQUOTE] = ACTIONS(5067),
    [anon_sym_DQUOTE] = ACTIONS(5067),
    [sym_return] = ACTIONS(5065),
    [sym_next] = ACTIONS(5065),
    [sym_break] = ACTIONS(5065),
    [sym_true] = ACTIONS(5065),
    [sym_false] = ACTIONS(5065),
    [sym_null] = ACTIONS(5065),
    [sym_inf] = ACTIONS(5065),
    [sym_nan] = ACTIONS(5065),
    [anon_sym_NA] = ACTIONS(5065),
    [anon_sym_NA_integer_] = ACTIONS(5065),
    [anon_sym_NA_real_] = ACTIONS(5065),
    [anon_sym_NA_complex_] = ACTIONS(5065),
    [anon_sym_NA_character_] = ACTIONS(5065),
    [sym_dots] = ACTIONS(5065),
    [sym_dot_dot_i] = ACTIONS(5067),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5067),
    [sym__newline] = ACTIONS(5067),
    [sym__raw_string_literal] = ACTIONS(5067),
    [sym__external_else] = ACTIONS(6163),
    [sym__external_open_parenthesis] = ACTIONS(6151),
    [sym__external_open_brace] = ACTIONS(5067),
    [sym__external_open_bracket] = ACTIONS(6153),
    [sym__external_open_bracket2] = ACTIONS(6155),
    [sym__external_close_bracket2] = ACTIONS(5067),
  },
  [1160] = {
    [sym_call_arguments] = STATE(2671),
    [sym_subset_arguments] = STATE(2663),
    [sym_subset2_arguments] = STATE(2661),
    [sym__open_parenthesis] = STATE(1555),
    [sym__open_bracket] = STATE(1551),
    [sym__open_bracket2] = STATE(1549),
    [sym_identifier] = ACTIONS(5443),
    [anon_sym_BSLASH] = ACTIONS(5441),
    [anon_sym_function] = ACTIONS(5443),
    [anon_sym_EQ] = ACTIONS(5889),
    [anon_sym_if] = ACTIONS(5443),
    [anon_sym_for] = ACTIONS(5443),
    [anon_sym_while] = ACTIONS(5443),
    [anon_sym_repeat] = ACTIONS(5443),
    [anon_sym_QMARK] = ACTIONS(5441),
    [anon_sym_TILDE] = ACTIONS(5893),
    [anon_sym_BANG] = ACTIONS(5443),
    [anon_sym_PLUS] = ACTIONS(5895),
    [anon_sym_DASH] = ACTIONS(5897),
    [anon_sym_LT_DASH] = ACTIONS(5899),
    [anon_sym_LT_LT_DASH] = ACTIONS(5899),
    [anon_sym_COLON_EQ] = ACTIONS(5899),
    [anon_sym_DASH_GT] = ACTIONS(5901),
    [anon_sym_DASH_GT_GT] = ACTIONS(5903),
    [anon_sym_PIPE] = ACTIONS(5905),
    [anon_sym_AMP] = ACTIONS(5907),
    [anon_sym_PIPE_PIPE] = ACTIONS(5909),
    [anon_sym_AMP_AMP] = ACTIONS(5911),
    [anon_sym_LT] = ACTIONS(5913),
    [anon_sym_LT_EQ] = ACTIONS(5915),
    [anon_sym_GT] = ACTIONS(5913),
    [anon_sym_GT_EQ] = ACTIONS(5915),
    [anon_sym_EQ_EQ] = ACTIONS(5915),
    [anon_sym_BANG_EQ] = ACTIONS(5915),
    [anon_sym_STAR] = ACTIONS(5917),
    [anon_sym_SLASH] = ACTIONS(5919),
    [anon_sym_STAR_STAR] = ACTIONS(5921),
    [anon_sym_CARET] = ACTIONS(5921),
    [aux_sym_binary_operator_token1] = ACTIONS(5923),
    [anon_sym_PIPE_GT] = ACTIONS(5923),
    [anon_sym_COLON] = ACTIONS(5925),
    [anon_sym_DOLLAR] = ACTIONS(5927),
    [anon_sym_AT] = ACTIONS(5927),
    [aux_sym__hex_literal_token1] = ACTIONS(5441),
    [sym__number_literal] = ACTIONS(5443),
    [anon_sym_SQUOTE] = ACTIONS(5441),
    [anon_sym_DQUOTE] = ACTIONS(5441),
    [sym_return] = ACTIONS(5443),
    [sym_next] = ACTIONS(5443),
    [sym_break] = ACTIONS(5443),
    [sym_true] = ACTIONS(5443),
    [sym_false] = ACTIONS(5443),
    [sym_null] = ACTIONS(5443),
    [sym_inf] = ACTIONS(5443),
    [sym_nan] = ACTIONS(5443),
    [anon_sym_NA] = ACTIONS(5443),
    [anon_sym_NA_integer_] = ACTIONS(5443),
    [anon_sym_NA_real_] = ACTIONS(5443),
    [anon_sym_NA_complex_] = ACTIONS(5443),
    [anon_sym_NA_character_] = ACTIONS(5443),
    [sym_dots] = ACTIONS(5443),
    [sym_dot_dot_i] = ACTIONS(5441),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5441),
    [sym__newline] = ACTIONS(5441),
    [sym__semicolon] = ACTIONS(5441),
    [sym__raw_string_literal] = ACTIONS(5441),
    [sym__external_open_parenthesis] = ACTIONS(5929),
    [sym__external_open_brace] = ACTIONS(5441),
    [sym__external_close_brace] = ACTIONS(5441),
    [sym__external_open_bracket] = ACTIONS(5931),
    [sym__external_close_bracket] = ACTIONS(5441),
    [sym__external_open_bracket2] = ACTIONS(5933),
  },
  [1161] = {
    [sym_call_arguments] = STATE(2651),
    [sym_subset_arguments] = STATE(2561),
    [sym_subset2_arguments] = STATE(2648),
    [sym__open_parenthesis] = STATE(1340),
    [sym__open_bracket] = STATE(1335),
    [sym__open_bracket2] = STATE(1334),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_BSLASH] = ACTIONS(5413),
    [anon_sym_function] = ACTIONS(5415),
    [anon_sym_EQ] = ACTIONS(5675),
    [anon_sym_if] = ACTIONS(5415),
    [anon_sym_for] = ACTIONS(5415),
    [anon_sym_while] = ACTIONS(5415),
    [anon_sym_repeat] = ACTIONS(5415),
    [anon_sym_QMARK] = ACTIONS(5413),
    [anon_sym_TILDE] = ACTIONS(5677),
    [anon_sym_BANG] = ACTIONS(5415),
    [anon_sym_PLUS] = ACTIONS(5679),
    [anon_sym_DASH] = ACTIONS(5681),
    [anon_sym_LT_DASH] = ACTIONS(5683),
    [anon_sym_LT_LT_DASH] = ACTIONS(5683),
    [anon_sym_COLON_EQ] = ACTIONS(5683),
    [anon_sym_DASH_GT] = ACTIONS(5685),
    [anon_sym_DASH_GT_GT] = ACTIONS(5687),
    [anon_sym_PIPE] = ACTIONS(5689),
    [anon_sym_AMP] = ACTIONS(5691),
    [anon_sym_PIPE_PIPE] = ACTIONS(5693),
    [anon_sym_AMP_AMP] = ACTIONS(5695),
    [anon_sym_LT] = ACTIONS(5697),
    [anon_sym_LT_EQ] = ACTIONS(5699),
    [anon_sym_GT] = ACTIONS(5697),
    [anon_sym_GT_EQ] = ACTIONS(5699),
    [anon_sym_EQ_EQ] = ACTIONS(5699),
    [anon_sym_BANG_EQ] = ACTIONS(5699),
    [anon_sym_STAR] = ACTIONS(5701),
    [anon_sym_SLASH] = ACTIONS(5703),
    [anon_sym_STAR_STAR] = ACTIONS(5705),
    [anon_sym_CARET] = ACTIONS(5705),
    [aux_sym_binary_operator_token1] = ACTIONS(5707),
    [anon_sym_PIPE_GT] = ACTIONS(5707),
    [anon_sym_COLON] = ACTIONS(5709),
    [anon_sym_DOLLAR] = ACTIONS(5711),
    [anon_sym_AT] = ACTIONS(5711),
    [aux_sym__hex_literal_token1] = ACTIONS(5413),
    [sym__number_literal] = ACTIONS(5415),
    [anon_sym_SQUOTE] = ACTIONS(5413),
    [anon_sym_DQUOTE] = ACTIONS(5413),
    [sym_return] = ACTIONS(5415),
    [sym_next] = ACTIONS(5415),
    [sym_break] = ACTIONS(5415),
    [sym_true] = ACTIONS(5415),
    [sym_false] = ACTIONS(5415),
    [sym_null] = ACTIONS(5415),
    [sym_inf] = ACTIONS(5415),
    [sym_nan] = ACTIONS(5415),
    [anon_sym_NA] = ACTIONS(5415),
    [anon_sym_NA_integer_] = ACTIONS(5415),
    [anon_sym_NA_real_] = ACTIONS(5415),
    [anon_sym_NA_complex_] = ACTIONS(5415),
    [anon_sym_NA_character_] = ACTIONS(5415),
    [sym_dots] = ACTIONS(5415),
    [sym_dot_dot_i] = ACTIONS(5413),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5413),
    [sym__newline] = ACTIONS(5413),
    [sym__raw_string_literal] = ACTIONS(5413),
    [sym__external_else] = ACTIONS(5413),
    [sym__external_open_parenthesis] = ACTIONS(5715),
    [sym__external_close_parenthesis] = ACTIONS(5413),
    [sym__external_open_brace] = ACTIONS(5413),
    [sym__external_open_bracket] = ACTIONS(5717),
    [sym__external_open_bracket2] = ACTIONS(5719),
    [sym__external_close_bracket2] = ACTIONS(5413),
  },
  [1162] = {
    [sym_call_arguments] = STATE(2671),
    [sym_subset_arguments] = STATE(2663),
    [sym_subset2_arguments] = STATE(2661),
    [sym__open_parenthesis] = STATE(1555),
    [sym__open_bracket] = STATE(1551),
    [sym__open_bracket2] = STATE(1549),
    [sym_identifier] = ACTIONS(5439),
    [anon_sym_BSLASH] = ACTIONS(5437),
    [anon_sym_function] = ACTIONS(5439),
    [anon_sym_EQ] = ACTIONS(5889),
    [anon_sym_if] = ACTIONS(5439),
    [anon_sym_for] = ACTIONS(5439),
    [anon_sym_while] = ACTIONS(5439),
    [anon_sym_repeat] = ACTIONS(5439),
    [anon_sym_QMARK] = ACTIONS(5437),
    [anon_sym_TILDE] = ACTIONS(5893),
    [anon_sym_BANG] = ACTIONS(5439),
    [anon_sym_PLUS] = ACTIONS(5895),
    [anon_sym_DASH] = ACTIONS(5897),
    [anon_sym_LT_DASH] = ACTIONS(5899),
    [anon_sym_LT_LT_DASH] = ACTIONS(5899),
    [anon_sym_COLON_EQ] = ACTIONS(5899),
    [anon_sym_DASH_GT] = ACTIONS(5901),
    [anon_sym_DASH_GT_GT] = ACTIONS(5903),
    [anon_sym_PIPE] = ACTIONS(5905),
    [anon_sym_AMP] = ACTIONS(5907),
    [anon_sym_PIPE_PIPE] = ACTIONS(5909),
    [anon_sym_AMP_AMP] = ACTIONS(5911),
    [anon_sym_LT] = ACTIONS(5913),
    [anon_sym_LT_EQ] = ACTIONS(5915),
    [anon_sym_GT] = ACTIONS(5913),
    [anon_sym_GT_EQ] = ACTIONS(5915),
    [anon_sym_EQ_EQ] = ACTIONS(5915),
    [anon_sym_BANG_EQ] = ACTIONS(5915),
    [anon_sym_STAR] = ACTIONS(5917),
    [anon_sym_SLASH] = ACTIONS(5919),
    [anon_sym_STAR_STAR] = ACTIONS(5921),
    [anon_sym_CARET] = ACTIONS(5921),
    [aux_sym_binary_operator_token1] = ACTIONS(5923),
    [anon_sym_PIPE_GT] = ACTIONS(5923),
    [anon_sym_COLON] = ACTIONS(5925),
    [anon_sym_DOLLAR] = ACTIONS(5927),
    [anon_sym_AT] = ACTIONS(5927),
    [aux_sym__hex_literal_token1] = ACTIONS(5437),
    [sym__number_literal] = ACTIONS(5439),
    [anon_sym_SQUOTE] = ACTIONS(5437),
    [anon_sym_DQUOTE] = ACTIONS(5437),
    [sym_return] = ACTIONS(5439),
    [sym_next] = ACTIONS(5439),
    [sym_break] = ACTIONS(5439),
    [sym_true] = ACTIONS(5439),
    [sym_false] = ACTIONS(5439),
    [sym_null] = ACTIONS(5439),
    [sym_inf] = ACTIONS(5439),
    [sym_nan] = ACTIONS(5439),
    [anon_sym_NA] = ACTIONS(5439),
    [anon_sym_NA_integer_] = ACTIONS(5439),
    [anon_sym_NA_real_] = ACTIONS(5439),
    [anon_sym_NA_complex_] = ACTIONS(5439),
    [anon_sym_NA_character_] = ACTIONS(5439),
    [sym_dots] = ACTIONS(5439),
    [sym_dot_dot_i] = ACTIONS(5437),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5437),
    [sym__newline] = ACTIONS(5437),
    [sym__semicolon] = ACTIONS(5437),
    [sym__raw_string_literal] = ACTIONS(5437),
    [sym__external_open_parenthesis] = ACTIONS(5929),
    [sym__external_open_brace] = ACTIONS(5437),
    [sym__external_close_brace] = ACTIONS(5437),
    [sym__external_open_bracket] = ACTIONS(5931),
    [sym__external_close_bracket] = ACTIONS(5437),
    [sym__external_open_bracket2] = ACTIONS(5933),
  },
  [1163] = {
    [sym_call_arguments] = STATE(2671),
    [sym_subset_arguments] = STATE(2663),
    [sym_subset2_arguments] = STATE(2661),
    [sym__open_parenthesis] = STATE(1555),
    [sym__open_bracket] = STATE(1551),
    [sym__open_bracket2] = STATE(1549),
    [sym_identifier] = ACTIONS(5435),
    [anon_sym_BSLASH] = ACTIONS(5433),
    [anon_sym_function] = ACTIONS(5435),
    [anon_sym_EQ] = ACTIONS(5889),
    [anon_sym_if] = ACTIONS(5435),
    [anon_sym_for] = ACTIONS(5435),
    [anon_sym_while] = ACTIONS(5435),
    [anon_sym_repeat] = ACTIONS(5435),
    [anon_sym_QMARK] = ACTIONS(5433),
    [anon_sym_TILDE] = ACTIONS(5893),
    [anon_sym_BANG] = ACTIONS(5435),
    [anon_sym_PLUS] = ACTIONS(5895),
    [anon_sym_DASH] = ACTIONS(5897),
    [anon_sym_LT_DASH] = ACTIONS(5899),
    [anon_sym_LT_LT_DASH] = ACTIONS(5899),
    [anon_sym_COLON_EQ] = ACTIONS(5899),
    [anon_sym_DASH_GT] = ACTIONS(5901),
    [anon_sym_DASH_GT_GT] = ACTIONS(5903),
    [anon_sym_PIPE] = ACTIONS(5905),
    [anon_sym_AMP] = ACTIONS(5907),
    [anon_sym_PIPE_PIPE] = ACTIONS(5909),
    [anon_sym_AMP_AMP] = ACTIONS(5911),
    [anon_sym_LT] = ACTIONS(5913),
    [anon_sym_LT_EQ] = ACTIONS(5915),
    [anon_sym_GT] = ACTIONS(5913),
    [anon_sym_GT_EQ] = ACTIONS(5915),
    [anon_sym_EQ_EQ] = ACTIONS(5915),
    [anon_sym_BANG_EQ] = ACTIONS(5915),
    [anon_sym_STAR] = ACTIONS(5917),
    [anon_sym_SLASH] = ACTIONS(5919),
    [anon_sym_STAR_STAR] = ACTIONS(5921),
    [anon_sym_CARET] = ACTIONS(5921),
    [aux_sym_binary_operator_token1] = ACTIONS(5923),
    [anon_sym_PIPE_GT] = ACTIONS(5923),
    [anon_sym_COLON] = ACTIONS(5925),
    [anon_sym_DOLLAR] = ACTIONS(5927),
    [anon_sym_AT] = ACTIONS(5927),
    [aux_sym__hex_literal_token1] = ACTIONS(5433),
    [sym__number_literal] = ACTIONS(5435),
    [anon_sym_SQUOTE] = ACTIONS(5433),
    [anon_sym_DQUOTE] = ACTIONS(5433),
    [sym_return] = ACTIONS(5435),
    [sym_next] = ACTIONS(5435),
    [sym_break] = ACTIONS(5435),
    [sym_true] = ACTIONS(5435),
    [sym_false] = ACTIONS(5435),
    [sym_null] = ACTIONS(5435),
    [sym_inf] = ACTIONS(5435),
    [sym_nan] = ACTIONS(5435),
    [anon_sym_NA] = ACTIONS(5435),
    [anon_sym_NA_integer_] = ACTIONS(5435),
    [anon_sym_NA_real_] = ACTIONS(5435),
    [anon_sym_NA_complex_] = ACTIONS(5435),
    [anon_sym_NA_character_] = ACTIONS(5435),
    [sym_dots] = ACTIONS(5435),
    [sym_dot_dot_i] = ACTIONS(5433),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5433),
    [sym__newline] = ACTIONS(5433),
    [sym__semicolon] = ACTIONS(5433),
    [sym__raw_string_literal] = ACTIONS(5433),
    [sym__external_open_parenthesis] = ACTIONS(5929),
    [sym__external_open_brace] = ACTIONS(5433),
    [sym__external_close_brace] = ACTIONS(5433),
    [sym__external_open_bracket] = ACTIONS(5931),
    [sym__external_close_bracket] = ACTIONS(5433),
    [sym__external_open_bracket2] = ACTIONS(5933),
  },
  [1164] = {
    [sym_call_arguments] = STATE(2671),
    [sym_subset_arguments] = STATE(2663),
    [sym_subset2_arguments] = STATE(2661),
    [sym__open_parenthesis] = STATE(1555),
    [sym__open_bracket] = STATE(1551),
    [sym__open_bracket2] = STATE(1549),
    [sym_identifier] = ACTIONS(5431),
    [anon_sym_BSLASH] = ACTIONS(5429),
    [anon_sym_function] = ACTIONS(5431),
    [anon_sym_EQ] = ACTIONS(5889),
    [anon_sym_if] = ACTIONS(5431),
    [anon_sym_for] = ACTIONS(5431),
    [anon_sym_while] = ACTIONS(5431),
    [anon_sym_repeat] = ACTIONS(5431),
    [anon_sym_QMARK] = ACTIONS(5429),
    [anon_sym_TILDE] = ACTIONS(5893),
    [anon_sym_BANG] = ACTIONS(5431),
    [anon_sym_PLUS] = ACTIONS(5895),
    [anon_sym_DASH] = ACTIONS(5897),
    [anon_sym_LT_DASH] = ACTIONS(5899),
    [anon_sym_LT_LT_DASH] = ACTIONS(5899),
    [anon_sym_COLON_EQ] = ACTIONS(5899),
    [anon_sym_DASH_GT] = ACTIONS(5901),
    [anon_sym_DASH_GT_GT] = ACTIONS(5903),
    [anon_sym_PIPE] = ACTIONS(5905),
    [anon_sym_AMP] = ACTIONS(5907),
    [anon_sym_PIPE_PIPE] = ACTIONS(5909),
    [anon_sym_AMP_AMP] = ACTIONS(5911),
    [anon_sym_LT] = ACTIONS(5913),
    [anon_sym_LT_EQ] = ACTIONS(5915),
    [anon_sym_GT] = ACTIONS(5913),
    [anon_sym_GT_EQ] = ACTIONS(5915),
    [anon_sym_EQ_EQ] = ACTIONS(5915),
    [anon_sym_BANG_EQ] = ACTIONS(5915),
    [anon_sym_STAR] = ACTIONS(5917),
    [anon_sym_SLASH] = ACTIONS(5919),
    [anon_sym_STAR_STAR] = ACTIONS(5921),
    [anon_sym_CARET] = ACTIONS(5921),
    [aux_sym_binary_operator_token1] = ACTIONS(5923),
    [anon_sym_PIPE_GT] = ACTIONS(5923),
    [anon_sym_COLON] = ACTIONS(5925),
    [anon_sym_DOLLAR] = ACTIONS(5927),
    [anon_sym_AT] = ACTIONS(5927),
    [aux_sym__hex_literal_token1] = ACTIONS(5429),
    [sym__number_literal] = ACTIONS(5431),
    [anon_sym_SQUOTE] = ACTIONS(5429),
    [anon_sym_DQUOTE] = ACTIONS(5429),
    [sym_return] = ACTIONS(5431),
    [sym_next] = ACTIONS(5431),
    [sym_break] = ACTIONS(5431),
    [sym_true] = ACTIONS(5431),
    [sym_false] = ACTIONS(5431),
    [sym_null] = ACTIONS(5431),
    [sym_inf] = ACTIONS(5431),
    [sym_nan] = ACTIONS(5431),
    [anon_sym_NA] = ACTIONS(5431),
    [anon_sym_NA_integer_] = ACTIONS(5431),
    [anon_sym_NA_real_] = ACTIONS(5431),
    [anon_sym_NA_complex_] = ACTIONS(5431),
    [anon_sym_NA_character_] = ACTIONS(5431),
    [sym_dots] = ACTIONS(5431),
    [sym_dot_dot_i] = ACTIONS(5429),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5429),
    [sym__newline] = ACTIONS(5429),
    [sym__semicolon] = ACTIONS(5429),
    [sym__raw_string_literal] = ACTIONS(5429),
    [sym__external_open_parenthesis] = ACTIONS(5929),
    [sym__external_open_brace] = ACTIONS(5429),
    [sym__external_close_brace] = ACTIONS(5429),
    [sym__external_open_bracket] = ACTIONS(5931),
    [sym__external_close_bracket] = ACTIONS(5429),
    [sym__external_open_bracket2] = ACTIONS(5933),
  },
  [1165] = {
    [sym_call_arguments] = STATE(2671),
    [sym_subset_arguments] = STATE(2663),
    [sym_subset2_arguments] = STATE(2661),
    [sym__open_parenthesis] = STATE(1555),
    [sym__open_bracket] = STATE(1551),
    [sym__open_bracket2] = STATE(1549),
    [sym_identifier] = ACTIONS(5427),
    [anon_sym_BSLASH] = ACTIONS(5425),
    [anon_sym_function] = ACTIONS(5427),
    [anon_sym_EQ] = ACTIONS(5889),
    [anon_sym_if] = ACTIONS(5427),
    [anon_sym_for] = ACTIONS(5427),
    [anon_sym_while] = ACTIONS(5427),
    [anon_sym_repeat] = ACTIONS(5427),
    [anon_sym_QMARK] = ACTIONS(5425),
    [anon_sym_TILDE] = ACTIONS(5893),
    [anon_sym_BANG] = ACTIONS(5427),
    [anon_sym_PLUS] = ACTIONS(5895),
    [anon_sym_DASH] = ACTIONS(5897),
    [anon_sym_LT_DASH] = ACTIONS(5899),
    [anon_sym_LT_LT_DASH] = ACTIONS(5899),
    [anon_sym_COLON_EQ] = ACTIONS(5899),
    [anon_sym_DASH_GT] = ACTIONS(5901),
    [anon_sym_DASH_GT_GT] = ACTIONS(5903),
    [anon_sym_PIPE] = ACTIONS(5905),
    [anon_sym_AMP] = ACTIONS(5907),
    [anon_sym_PIPE_PIPE] = ACTIONS(5909),
    [anon_sym_AMP_AMP] = ACTIONS(5911),
    [anon_sym_LT] = ACTIONS(5913),
    [anon_sym_LT_EQ] = ACTIONS(5915),
    [anon_sym_GT] = ACTIONS(5913),
    [anon_sym_GT_EQ] = ACTIONS(5915),
    [anon_sym_EQ_EQ] = ACTIONS(5915),
    [anon_sym_BANG_EQ] = ACTIONS(5915),
    [anon_sym_STAR] = ACTIONS(5917),
    [anon_sym_SLASH] = ACTIONS(5919),
    [anon_sym_STAR_STAR] = ACTIONS(5921),
    [anon_sym_CARET] = ACTIONS(5921),
    [aux_sym_binary_operator_token1] = ACTIONS(5923),
    [anon_sym_PIPE_GT] = ACTIONS(5923),
    [anon_sym_COLON] = ACTIONS(5925),
    [anon_sym_DOLLAR] = ACTIONS(5927),
    [anon_sym_AT] = ACTIONS(5927),
    [aux_sym__hex_literal_token1] = ACTIONS(5425),
    [sym__number_literal] = ACTIONS(5427),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_DQUOTE] = ACTIONS(5425),
    [sym_return] = ACTIONS(5427),
    [sym_next] = ACTIONS(5427),
    [sym_break] = ACTIONS(5427),
    [sym_true] = ACTIONS(5427),
    [sym_false] = ACTIONS(5427),
    [sym_null] = ACTIONS(5427),
    [sym_inf] = ACTIONS(5427),
    [sym_nan] = ACTIONS(5427),
    [anon_sym_NA] = ACTIONS(5427),
    [anon_sym_NA_integer_] = ACTIONS(5427),
    [anon_sym_NA_real_] = ACTIONS(5427),
    [anon_sym_NA_complex_] = ACTIONS(5427),
    [anon_sym_NA_character_] = ACTIONS(5427),
    [sym_dots] = ACTIONS(5427),
    [sym_dot_dot_i] = ACTIONS(5425),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5425),
    [sym__newline] = ACTIONS(5425),
    [sym__semicolon] = ACTIONS(5425),
    [sym__raw_string_literal] = ACTIONS(5425),
    [sym__external_open_parenthesis] = ACTIONS(5929),
    [sym__external_open_brace] = ACTIONS(5425),
    [sym__external_close_brace] = ACTIONS(5425),
    [sym__external_open_bracket] = ACTIONS(5931),
    [sym__external_close_bracket] = ACTIONS(5425),
    [sym__external_open_bracket2] = ACTIONS(5933),
  },
  [1166] = {
    [sym_call_arguments] = STATE(2651),
    [sym_subset_arguments] = STATE(2561),
    [sym_subset2_arguments] = STATE(2648),
    [sym__open_parenthesis] = STATE(1340),
    [sym__open_bracket] = STATE(1335),
    [sym__open_bracket2] = STATE(1334),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(5705),
    [anon_sym_CARET] = ACTIONS(5705),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(5261),
    [anon_sym_DOLLAR] = ACTIONS(5711),
    [anon_sym_AT] = ACTIONS(5711),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5715),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5717),
    [sym__external_open_bracket2] = ACTIONS(5719),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [1167] = {
    [sym_call_arguments] = STATE(2671),
    [sym_subset_arguments] = STATE(2663),
    [sym_subset2_arguments] = STATE(2661),
    [sym__open_parenthesis] = STATE(1555),
    [sym__open_bracket] = STATE(1551),
    [sym__open_bracket2] = STATE(1549),
    [sym_identifier] = ACTIONS(5423),
    [anon_sym_BSLASH] = ACTIONS(5421),
    [anon_sym_function] = ACTIONS(5423),
    [anon_sym_EQ] = ACTIONS(5889),
    [anon_sym_if] = ACTIONS(5423),
    [anon_sym_for] = ACTIONS(5423),
    [anon_sym_while] = ACTIONS(5423),
    [anon_sym_repeat] = ACTIONS(5423),
    [anon_sym_QMARK] = ACTIONS(5421),
    [anon_sym_TILDE] = ACTIONS(5893),
    [anon_sym_BANG] = ACTIONS(5423),
    [anon_sym_PLUS] = ACTIONS(5895),
    [anon_sym_DASH] = ACTIONS(5897),
    [anon_sym_LT_DASH] = ACTIONS(5899),
    [anon_sym_LT_LT_DASH] = ACTIONS(5899),
    [anon_sym_COLON_EQ] = ACTIONS(5899),
    [anon_sym_DASH_GT] = ACTIONS(5901),
    [anon_sym_DASH_GT_GT] = ACTIONS(5903),
    [anon_sym_PIPE] = ACTIONS(5905),
    [anon_sym_AMP] = ACTIONS(5907),
    [anon_sym_PIPE_PIPE] = ACTIONS(5909),
    [anon_sym_AMP_AMP] = ACTIONS(5911),
    [anon_sym_LT] = ACTIONS(5913),
    [anon_sym_LT_EQ] = ACTIONS(5915),
    [anon_sym_GT] = ACTIONS(5913),
    [anon_sym_GT_EQ] = ACTIONS(5915),
    [anon_sym_EQ_EQ] = ACTIONS(5915),
    [anon_sym_BANG_EQ] = ACTIONS(5915),
    [anon_sym_STAR] = ACTIONS(5917),
    [anon_sym_SLASH] = ACTIONS(5919),
    [anon_sym_STAR_STAR] = ACTIONS(5921),
    [anon_sym_CARET] = ACTIONS(5921),
    [aux_sym_binary_operator_token1] = ACTIONS(5923),
    [anon_sym_PIPE_GT] = ACTIONS(5923),
    [anon_sym_COLON] = ACTIONS(5925),
    [anon_sym_DOLLAR] = ACTIONS(5927),
    [anon_sym_AT] = ACTIONS(5927),
    [aux_sym__hex_literal_token1] = ACTIONS(5421),
    [sym__number_literal] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5421),
    [anon_sym_DQUOTE] = ACTIONS(5421),
    [sym_return] = ACTIONS(5423),
    [sym_next] = ACTIONS(5423),
    [sym_break] = ACTIONS(5423),
    [sym_true] = ACTIONS(5423),
    [sym_false] = ACTIONS(5423),
    [sym_null] = ACTIONS(5423),
    [sym_inf] = ACTIONS(5423),
    [sym_nan] = ACTIONS(5423),
    [anon_sym_NA] = ACTIONS(5423),
    [anon_sym_NA_integer_] = ACTIONS(5423),
    [anon_sym_NA_real_] = ACTIONS(5423),
    [anon_sym_NA_complex_] = ACTIONS(5423),
    [anon_sym_NA_character_] = ACTIONS(5423),
    [sym_dots] = ACTIONS(5423),
    [sym_dot_dot_i] = ACTIONS(5421),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5421),
    [sym__newline] = ACTIONS(5421),
    [sym__semicolon] = ACTIONS(5421),
    [sym__raw_string_literal] = ACTIONS(5421),
    [sym__external_open_parenthesis] = ACTIONS(5929),
    [sym__external_open_brace] = ACTIONS(5421),
    [sym__external_close_brace] = ACTIONS(5421),
    [sym__external_open_bracket] = ACTIONS(5931),
    [sym__external_close_bracket] = ACTIONS(5421),
    [sym__external_open_bracket2] = ACTIONS(5933),
  },
  [1168] = {
    [sym_call_arguments] = STATE(2671),
    [sym_subset_arguments] = STATE(2663),
    [sym_subset2_arguments] = STATE(2661),
    [sym__open_parenthesis] = STATE(1555),
    [sym__open_bracket] = STATE(1551),
    [sym__open_bracket2] = STATE(1549),
    [sym_identifier] = ACTIONS(5419),
    [anon_sym_BSLASH] = ACTIONS(5417),
    [anon_sym_function] = ACTIONS(5419),
    [anon_sym_EQ] = ACTIONS(5889),
    [anon_sym_if] = ACTIONS(5419),
    [anon_sym_for] = ACTIONS(5419),
    [anon_sym_while] = ACTIONS(5419),
    [anon_sym_repeat] = ACTIONS(5419),
    [anon_sym_QMARK] = ACTIONS(5417),
    [anon_sym_TILDE] = ACTIONS(5893),
    [anon_sym_BANG] = ACTIONS(5419),
    [anon_sym_PLUS] = ACTIONS(5895),
    [anon_sym_DASH] = ACTIONS(5897),
    [anon_sym_LT_DASH] = ACTIONS(5899),
    [anon_sym_LT_LT_DASH] = ACTIONS(5899),
    [anon_sym_COLON_EQ] = ACTIONS(5899),
    [anon_sym_DASH_GT] = ACTIONS(5901),
    [anon_sym_DASH_GT_GT] = ACTIONS(5903),
    [anon_sym_PIPE] = ACTIONS(5905),
    [anon_sym_AMP] = ACTIONS(5907),
    [anon_sym_PIPE_PIPE] = ACTIONS(5909),
    [anon_sym_AMP_AMP] = ACTIONS(5911),
    [anon_sym_LT] = ACTIONS(5913),
    [anon_sym_LT_EQ] = ACTIONS(5915),
    [anon_sym_GT] = ACTIONS(5913),
    [anon_sym_GT_EQ] = ACTIONS(5915),
    [anon_sym_EQ_EQ] = ACTIONS(5915),
    [anon_sym_BANG_EQ] = ACTIONS(5915),
    [anon_sym_STAR] = ACTIONS(5917),
    [anon_sym_SLASH] = ACTIONS(5919),
    [anon_sym_STAR_STAR] = ACTIONS(5921),
    [anon_sym_CARET] = ACTIONS(5921),
    [aux_sym_binary_operator_token1] = ACTIONS(5923),
    [anon_sym_PIPE_GT] = ACTIONS(5923),
    [anon_sym_COLON] = ACTIONS(5925),
    [anon_sym_DOLLAR] = ACTIONS(5927),
    [anon_sym_AT] = ACTIONS(5927),
    [aux_sym__hex_literal_token1] = ACTIONS(5417),
    [sym__number_literal] = ACTIONS(5419),
    [anon_sym_SQUOTE] = ACTIONS(5417),
    [anon_sym_DQUOTE] = ACTIONS(5417),
    [sym_return] = ACTIONS(5419),
    [sym_next] = ACTIONS(5419),
    [sym_break] = ACTIONS(5419),
    [sym_true] = ACTIONS(5419),
    [sym_false] = ACTIONS(5419),
    [sym_null] = ACTIONS(5419),
    [sym_inf] = ACTIONS(5419),
    [sym_nan] = ACTIONS(5419),
    [anon_sym_NA] = ACTIONS(5419),
    [anon_sym_NA_integer_] = ACTIONS(5419),
    [anon_sym_NA_real_] = ACTIONS(5419),
    [anon_sym_NA_complex_] = ACTIONS(5419),
    [anon_sym_NA_character_] = ACTIONS(5419),
    [sym_dots] = ACTIONS(5419),
    [sym_dot_dot_i] = ACTIONS(5417),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5417),
    [sym__newline] = ACTIONS(5417),
    [sym__semicolon] = ACTIONS(5417),
    [sym__raw_string_literal] = ACTIONS(5417),
    [sym__external_open_parenthesis] = ACTIONS(5929),
    [sym__external_open_brace] = ACTIONS(5417),
    [sym__external_close_brace] = ACTIONS(5417),
    [sym__external_open_bracket] = ACTIONS(5931),
    [sym__external_close_bracket] = ACTIONS(5417),
    [sym__external_open_bracket2] = ACTIONS(5933),
  },
  [1169] = {
    [sym_call_arguments] = STATE(2651),
    [sym_subset_arguments] = STATE(2561),
    [sym_subset2_arguments] = STATE(2648),
    [sym__open_parenthesis] = STATE(1340),
    [sym__open_bracket] = STATE(1335),
    [sym__open_bracket2] = STATE(1334),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(5705),
    [anon_sym_CARET] = ACTIONS(5705),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(5709),
    [anon_sym_DOLLAR] = ACTIONS(5711),
    [anon_sym_AT] = ACTIONS(5711),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5715),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5717),
    [sym__external_open_bracket2] = ACTIONS(5719),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [1170] = {
    [sym_call_arguments] = STATE(2671),
    [sym_subset_arguments] = STATE(2663),
    [sym_subset2_arguments] = STATE(2661),
    [sym__open_parenthesis] = STATE(1555),
    [sym__open_bracket] = STATE(1551),
    [sym__open_bracket2] = STATE(1549),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_BSLASH] = ACTIONS(5413),
    [anon_sym_function] = ACTIONS(5415),
    [anon_sym_EQ] = ACTIONS(5889),
    [anon_sym_if] = ACTIONS(5415),
    [anon_sym_for] = ACTIONS(5415),
    [anon_sym_while] = ACTIONS(5415),
    [anon_sym_repeat] = ACTIONS(5415),
    [anon_sym_QMARK] = ACTIONS(5413),
    [anon_sym_TILDE] = ACTIONS(5893),
    [anon_sym_BANG] = ACTIONS(5415),
    [anon_sym_PLUS] = ACTIONS(5895),
    [anon_sym_DASH] = ACTIONS(5897),
    [anon_sym_LT_DASH] = ACTIONS(5899),
    [anon_sym_LT_LT_DASH] = ACTIONS(5899),
    [anon_sym_COLON_EQ] = ACTIONS(5899),
    [anon_sym_DASH_GT] = ACTIONS(5901),
    [anon_sym_DASH_GT_GT] = ACTIONS(5903),
    [anon_sym_PIPE] = ACTIONS(5905),
    [anon_sym_AMP] = ACTIONS(5907),
    [anon_sym_PIPE_PIPE] = ACTIONS(5909),
    [anon_sym_AMP_AMP] = ACTIONS(5911),
    [anon_sym_LT] = ACTIONS(5913),
    [anon_sym_LT_EQ] = ACTIONS(5915),
    [anon_sym_GT] = ACTIONS(5913),
    [anon_sym_GT_EQ] = ACTIONS(5915),
    [anon_sym_EQ_EQ] = ACTIONS(5915),
    [anon_sym_BANG_EQ] = ACTIONS(5915),
    [anon_sym_STAR] = ACTIONS(5917),
    [anon_sym_SLASH] = ACTIONS(5919),
    [anon_sym_STAR_STAR] = ACTIONS(5921),
    [anon_sym_CARET] = ACTIONS(5921),
    [aux_sym_binary_operator_token1] = ACTIONS(5923),
    [anon_sym_PIPE_GT] = ACTIONS(5923),
    [anon_sym_COLON] = ACTIONS(5925),
    [anon_sym_DOLLAR] = ACTIONS(5927),
    [anon_sym_AT] = ACTIONS(5927),
    [aux_sym__hex_literal_token1] = ACTIONS(5413),
    [sym__number_literal] = ACTIONS(5415),
    [anon_sym_SQUOTE] = ACTIONS(5413),
    [anon_sym_DQUOTE] = ACTIONS(5413),
    [sym_return] = ACTIONS(5415),
    [sym_next] = ACTIONS(5415),
    [sym_break] = ACTIONS(5415),
    [sym_true] = ACTIONS(5415),
    [sym_false] = ACTIONS(5415),
    [sym_null] = ACTIONS(5415),
    [sym_inf] = ACTIONS(5415),
    [sym_nan] = ACTIONS(5415),
    [anon_sym_NA] = ACTIONS(5415),
    [anon_sym_NA_integer_] = ACTIONS(5415),
    [anon_sym_NA_real_] = ACTIONS(5415),
    [anon_sym_NA_complex_] = ACTIONS(5415),
    [anon_sym_NA_character_] = ACTIONS(5415),
    [sym_dots] = ACTIONS(5415),
    [sym_dot_dot_i] = ACTIONS(5413),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5413),
    [sym__newline] = ACTIONS(5413),
    [sym__semicolon] = ACTIONS(5413),
    [sym__raw_string_literal] = ACTIONS(5413),
    [sym__external_open_parenthesis] = ACTIONS(5929),
    [sym__external_open_brace] = ACTIONS(5413),
    [sym__external_close_brace] = ACTIONS(5413),
    [sym__external_open_bracket] = ACTIONS(5931),
    [sym__external_close_bracket] = ACTIONS(5413),
    [sym__external_open_bracket2] = ACTIONS(5933),
  },
  [1171] = {
    [sym_call_arguments] = STATE(2671),
    [sym_subset_arguments] = STATE(2663),
    [sym_subset2_arguments] = STATE(2661),
    [sym__open_parenthesis] = STATE(1555),
    [sym__open_bracket] = STATE(1551),
    [sym__open_bracket2] = STATE(1549),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(5921),
    [anon_sym_CARET] = ACTIONS(5921),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(5261),
    [anon_sym_DOLLAR] = ACTIONS(5927),
    [anon_sym_AT] = ACTIONS(5927),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5929),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5931),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(5933),
  },
  [1172] = {
    [sym_call_arguments] = STATE(2671),
    [sym_subset_arguments] = STATE(2663),
    [sym_subset2_arguments] = STATE(2661),
    [sym__open_parenthesis] = STATE(1555),
    [sym__open_bracket] = STATE(1551),
    [sym__open_bracket2] = STATE(1549),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(5921),
    [anon_sym_CARET] = ACTIONS(5921),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(5925),
    [anon_sym_DOLLAR] = ACTIONS(5927),
    [anon_sym_AT] = ACTIONS(5927),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5929),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5931),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(5933),
  },
  [1173] = {
    [sym_call_arguments] = STATE(2651),
    [sym_subset_arguments] = STATE(2561),
    [sym_subset2_arguments] = STATE(2648),
    [sym__open_parenthesis] = STATE(1340),
    [sym__open_bracket] = STATE(1335),
    [sym__open_bracket2] = STATE(1334),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(5705),
    [anon_sym_CARET] = ACTIONS(5705),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(5261),
    [anon_sym_DOLLAR] = ACTIONS(5711),
    [anon_sym_AT] = ACTIONS(5711),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5715),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5717),
    [sym__external_open_bracket2] = ACTIONS(5719),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [1174] = {
    [sym_call_arguments] = STATE(2651),
    [sym_subset_arguments] = STATE(2561),
    [sym_subset2_arguments] = STATE(2648),
    [sym__open_parenthesis] = STATE(1340),
    [sym__open_bracket] = STATE(1335),
    [sym__open_bracket2] = STATE(1334),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(5705),
    [anon_sym_CARET] = ACTIONS(5705),
    [aux_sym_binary_operator_token1] = ACTIONS(5707),
    [anon_sym_PIPE_GT] = ACTIONS(5707),
    [anon_sym_COLON] = ACTIONS(5709),
    [anon_sym_DOLLAR] = ACTIONS(5711),
    [anon_sym_AT] = ACTIONS(5711),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5715),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5717),
    [sym__external_open_bracket2] = ACTIONS(5719),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [1175] = {
    [sym_call_arguments] = STATE(2651),
    [sym_subset_arguments] = STATE(2561),
    [sym_subset2_arguments] = STATE(2648),
    [sym__open_parenthesis] = STATE(1340),
    [sym__open_bracket] = STATE(1335),
    [sym__open_bracket2] = STATE(1334),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5679),
    [anon_sym_DASH] = ACTIONS(5681),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5701),
    [anon_sym_SLASH] = ACTIONS(5703),
    [anon_sym_STAR_STAR] = ACTIONS(5705),
    [anon_sym_CARET] = ACTIONS(5705),
    [aux_sym_binary_operator_token1] = ACTIONS(5707),
    [anon_sym_PIPE_GT] = ACTIONS(5707),
    [anon_sym_COLON] = ACTIONS(5709),
    [anon_sym_DOLLAR] = ACTIONS(5711),
    [anon_sym_AT] = ACTIONS(5711),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5715),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5717),
    [sym__external_open_bracket2] = ACTIONS(5719),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [1176] = {
    [sym_call_arguments] = STATE(2651),
    [sym_subset_arguments] = STATE(2561),
    [sym_subset2_arguments] = STATE(2648),
    [sym__open_parenthesis] = STATE(1340),
    [sym__open_bracket] = STATE(1335),
    [sym__open_bracket2] = STATE(1334),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5679),
    [anon_sym_DASH] = ACTIONS(5681),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5697),
    [anon_sym_LT_EQ] = ACTIONS(5699),
    [anon_sym_GT] = ACTIONS(5697),
    [anon_sym_GT_EQ] = ACTIONS(5699),
    [anon_sym_EQ_EQ] = ACTIONS(5699),
    [anon_sym_BANG_EQ] = ACTIONS(5699),
    [anon_sym_STAR] = ACTIONS(5701),
    [anon_sym_SLASH] = ACTIONS(5703),
    [anon_sym_STAR_STAR] = ACTIONS(5705),
    [anon_sym_CARET] = ACTIONS(5705),
    [aux_sym_binary_operator_token1] = ACTIONS(5707),
    [anon_sym_PIPE_GT] = ACTIONS(5707),
    [anon_sym_COLON] = ACTIONS(5709),
    [anon_sym_DOLLAR] = ACTIONS(5711),
    [anon_sym_AT] = ACTIONS(5711),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5715),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5717),
    [sym__external_open_bracket2] = ACTIONS(5719),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [1177] = {
    [sym_call_arguments] = STATE(2651),
    [sym_subset_arguments] = STATE(2561),
    [sym_subset2_arguments] = STATE(2648),
    [sym__open_parenthesis] = STATE(1340),
    [sym__open_bracket] = STATE(1335),
    [sym__open_bracket2] = STATE(1334),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5679),
    [anon_sym_DASH] = ACTIONS(5681),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5691),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5695),
    [anon_sym_LT] = ACTIONS(5697),
    [anon_sym_LT_EQ] = ACTIONS(5699),
    [anon_sym_GT] = ACTIONS(5697),
    [anon_sym_GT_EQ] = ACTIONS(5699),
    [anon_sym_EQ_EQ] = ACTIONS(5699),
    [anon_sym_BANG_EQ] = ACTIONS(5699),
    [anon_sym_STAR] = ACTIONS(5701),
    [anon_sym_SLASH] = ACTIONS(5703),
    [anon_sym_STAR_STAR] = ACTIONS(5705),
    [anon_sym_CARET] = ACTIONS(5705),
    [aux_sym_binary_operator_token1] = ACTIONS(5707),
    [anon_sym_PIPE_GT] = ACTIONS(5707),
    [anon_sym_COLON] = ACTIONS(5709),
    [anon_sym_DOLLAR] = ACTIONS(5711),
    [anon_sym_AT] = ACTIONS(5711),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5715),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5717),
    [sym__external_open_bracket2] = ACTIONS(5719),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [1178] = {
    [sym_call_arguments] = STATE(2651),
    [sym_subset_arguments] = STATE(2561),
    [sym_subset2_arguments] = STATE(2648),
    [sym__open_parenthesis] = STATE(1340),
    [sym__open_bracket] = STATE(1335),
    [sym__open_bracket2] = STATE(1334),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5677),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5679),
    [anon_sym_DASH] = ACTIONS(5681),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5689),
    [anon_sym_AMP] = ACTIONS(5691),
    [anon_sym_PIPE_PIPE] = ACTIONS(5693),
    [anon_sym_AMP_AMP] = ACTIONS(5695),
    [anon_sym_LT] = ACTIONS(5697),
    [anon_sym_LT_EQ] = ACTIONS(5699),
    [anon_sym_GT] = ACTIONS(5697),
    [anon_sym_GT_EQ] = ACTIONS(5699),
    [anon_sym_EQ_EQ] = ACTIONS(5699),
    [anon_sym_BANG_EQ] = ACTIONS(5699),
    [anon_sym_STAR] = ACTIONS(5701),
    [anon_sym_SLASH] = ACTIONS(5703),
    [anon_sym_STAR_STAR] = ACTIONS(5705),
    [anon_sym_CARET] = ACTIONS(5705),
    [aux_sym_binary_operator_token1] = ACTIONS(5707),
    [anon_sym_PIPE_GT] = ACTIONS(5707),
    [anon_sym_COLON] = ACTIONS(5709),
    [anon_sym_DOLLAR] = ACTIONS(5711),
    [anon_sym_AT] = ACTIONS(5711),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5715),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5717),
    [sym__external_open_bracket2] = ACTIONS(5719),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [1179] = {
    [sym_call_arguments] = STATE(2651),
    [sym_subset_arguments] = STATE(2561),
    [sym_subset2_arguments] = STATE(2648),
    [sym__open_parenthesis] = STATE(1340),
    [sym__open_bracket] = STATE(1335),
    [sym__open_bracket2] = STATE(1334),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5675),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5677),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5679),
    [anon_sym_DASH] = ACTIONS(5681),
    [anon_sym_LT_DASH] = ACTIONS(5683),
    [anon_sym_LT_LT_DASH] = ACTIONS(5683),
    [anon_sym_COLON_EQ] = ACTIONS(5683),
    [anon_sym_DASH_GT] = ACTIONS(5685),
    [anon_sym_DASH_GT_GT] = ACTIONS(5687),
    [anon_sym_PIPE] = ACTIONS(5689),
    [anon_sym_AMP] = ACTIONS(5691),
    [anon_sym_PIPE_PIPE] = ACTIONS(5693),
    [anon_sym_AMP_AMP] = ACTIONS(5695),
    [anon_sym_LT] = ACTIONS(5697),
    [anon_sym_LT_EQ] = ACTIONS(5699),
    [anon_sym_GT] = ACTIONS(5697),
    [anon_sym_GT_EQ] = ACTIONS(5699),
    [anon_sym_EQ_EQ] = ACTIONS(5699),
    [anon_sym_BANG_EQ] = ACTIONS(5699),
    [anon_sym_STAR] = ACTIONS(5701),
    [anon_sym_SLASH] = ACTIONS(5703),
    [anon_sym_STAR_STAR] = ACTIONS(5705),
    [anon_sym_CARET] = ACTIONS(5705),
    [aux_sym_binary_operator_token1] = ACTIONS(5707),
    [anon_sym_PIPE_GT] = ACTIONS(5707),
    [anon_sym_COLON] = ACTIONS(5709),
    [anon_sym_DOLLAR] = ACTIONS(5711),
    [anon_sym_AT] = ACTIONS(5711),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5715),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5717),
    [sym__external_open_bracket2] = ACTIONS(5719),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [1180] = {
    [sym_call_arguments] = STATE(2671),
    [sym_subset_arguments] = STATE(2663),
    [sym_subset2_arguments] = STATE(2661),
    [sym__open_parenthesis] = STATE(1555),
    [sym__open_bracket] = STATE(1551),
    [sym__open_bracket2] = STATE(1549),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(5921),
    [anon_sym_CARET] = ACTIONS(5921),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(5261),
    [anon_sym_DOLLAR] = ACTIONS(5927),
    [anon_sym_AT] = ACTIONS(5927),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5929),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5931),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(5933),
  },
  [1181] = {
    [sym_call_arguments] = STATE(2671),
    [sym_subset_arguments] = STATE(2663),
    [sym_subset2_arguments] = STATE(2661),
    [sym__open_parenthesis] = STATE(1555),
    [sym__open_bracket] = STATE(1551),
    [sym__open_bracket2] = STATE(1549),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(5921),
    [anon_sym_CARET] = ACTIONS(5921),
    [aux_sym_binary_operator_token1] = ACTIONS(5923),
    [anon_sym_PIPE_GT] = ACTIONS(5923),
    [anon_sym_COLON] = ACTIONS(5925),
    [anon_sym_DOLLAR] = ACTIONS(5927),
    [anon_sym_AT] = ACTIONS(5927),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5929),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5931),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(5933),
  },
  [1182] = {
    [sym_call_arguments] = STATE(2671),
    [sym_subset_arguments] = STATE(2663),
    [sym_subset2_arguments] = STATE(2661),
    [sym__open_parenthesis] = STATE(1555),
    [sym__open_bracket] = STATE(1551),
    [sym__open_bracket2] = STATE(1549),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5895),
    [anon_sym_DASH] = ACTIONS(5897),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5917),
    [anon_sym_SLASH] = ACTIONS(5919),
    [anon_sym_STAR_STAR] = ACTIONS(5921),
    [anon_sym_CARET] = ACTIONS(5921),
    [aux_sym_binary_operator_token1] = ACTIONS(5923),
    [anon_sym_PIPE_GT] = ACTIONS(5923),
    [anon_sym_COLON] = ACTIONS(5925),
    [anon_sym_DOLLAR] = ACTIONS(5927),
    [anon_sym_AT] = ACTIONS(5927),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5929),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5931),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(5933),
  },
  [1183] = {
    [sym_call_arguments] = STATE(2651),
    [sym_subset_arguments] = STATE(2561),
    [sym_subset2_arguments] = STATE(2648),
    [sym__open_parenthesis] = STATE(1340),
    [sym__open_bracket] = STATE(1335),
    [sym__open_bracket2] = STATE(1334),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5701),
    [anon_sym_SLASH] = ACTIONS(5703),
    [anon_sym_STAR_STAR] = ACTIONS(5705),
    [anon_sym_CARET] = ACTIONS(5705),
    [aux_sym_binary_operator_token1] = ACTIONS(5707),
    [anon_sym_PIPE_GT] = ACTIONS(5707),
    [anon_sym_COLON] = ACTIONS(5709),
    [anon_sym_DOLLAR] = ACTIONS(5711),
    [anon_sym_AT] = ACTIONS(5711),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5715),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5717),
    [sym__external_open_bracket2] = ACTIONS(5719),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [1184] = {
    [sym_call_arguments] = STATE(2651),
    [sym_subset_arguments] = STATE(2561),
    [sym_subset2_arguments] = STATE(2648),
    [sym__open_parenthesis] = STATE(1340),
    [sym__open_bracket] = STATE(1335),
    [sym__open_bracket2] = STATE(1334),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5679),
    [anon_sym_DASH] = ACTIONS(5681),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5689),
    [anon_sym_AMP] = ACTIONS(5691),
    [anon_sym_PIPE_PIPE] = ACTIONS(5693),
    [anon_sym_AMP_AMP] = ACTIONS(5695),
    [anon_sym_LT] = ACTIONS(5697),
    [anon_sym_LT_EQ] = ACTIONS(5699),
    [anon_sym_GT] = ACTIONS(5697),
    [anon_sym_GT_EQ] = ACTIONS(5699),
    [anon_sym_EQ_EQ] = ACTIONS(5699),
    [anon_sym_BANG_EQ] = ACTIONS(5699),
    [anon_sym_STAR] = ACTIONS(5701),
    [anon_sym_SLASH] = ACTIONS(5703),
    [anon_sym_STAR_STAR] = ACTIONS(5705),
    [anon_sym_CARET] = ACTIONS(5705),
    [aux_sym_binary_operator_token1] = ACTIONS(5707),
    [anon_sym_PIPE_GT] = ACTIONS(5707),
    [anon_sym_COLON] = ACTIONS(5709),
    [anon_sym_DOLLAR] = ACTIONS(5711),
    [anon_sym_AT] = ACTIONS(5711),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5715),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5717),
    [sym__external_open_bracket2] = ACTIONS(5719),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [1185] = {
    [sym_call_arguments] = STATE(2651),
    [sym_subset_arguments] = STATE(2561),
    [sym_subset2_arguments] = STATE(2648),
    [sym__open_parenthesis] = STATE(1340),
    [sym__open_bracket] = STATE(1335),
    [sym__open_bracket2] = STATE(1334),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5675),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5677),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5679),
    [anon_sym_DASH] = ACTIONS(5681),
    [anon_sym_LT_DASH] = ACTIONS(5683),
    [anon_sym_LT_LT_DASH] = ACTIONS(5683),
    [anon_sym_COLON_EQ] = ACTIONS(5683),
    [anon_sym_DASH_GT] = ACTIONS(5685),
    [anon_sym_DASH_GT_GT] = ACTIONS(5687),
    [anon_sym_PIPE] = ACTIONS(5689),
    [anon_sym_AMP] = ACTIONS(5691),
    [anon_sym_PIPE_PIPE] = ACTIONS(5693),
    [anon_sym_AMP_AMP] = ACTIONS(5695),
    [anon_sym_LT] = ACTIONS(5697),
    [anon_sym_LT_EQ] = ACTIONS(5699),
    [anon_sym_GT] = ACTIONS(5697),
    [anon_sym_GT_EQ] = ACTIONS(5699),
    [anon_sym_EQ_EQ] = ACTIONS(5699),
    [anon_sym_BANG_EQ] = ACTIONS(5699),
    [anon_sym_STAR] = ACTIONS(5701),
    [anon_sym_SLASH] = ACTIONS(5703),
    [anon_sym_STAR_STAR] = ACTIONS(5705),
    [anon_sym_CARET] = ACTIONS(5705),
    [aux_sym_binary_operator_token1] = ACTIONS(5707),
    [anon_sym_PIPE_GT] = ACTIONS(5707),
    [anon_sym_COLON] = ACTIONS(5709),
    [anon_sym_DOLLAR] = ACTIONS(5711),
    [anon_sym_AT] = ACTIONS(5711),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5715),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5717),
    [sym__external_open_bracket2] = ACTIONS(5719),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [1186] = {
    [sym_call_arguments] = STATE(2671),
    [sym_subset_arguments] = STATE(2663),
    [sym_subset2_arguments] = STATE(2661),
    [sym__open_parenthesis] = STATE(1555),
    [sym__open_bracket] = STATE(1551),
    [sym__open_bracket2] = STATE(1549),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5895),
    [anon_sym_DASH] = ACTIONS(5897),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5913),
    [anon_sym_LT_EQ] = ACTIONS(5915),
    [anon_sym_GT] = ACTIONS(5913),
    [anon_sym_GT_EQ] = ACTIONS(5915),
    [anon_sym_EQ_EQ] = ACTIONS(5915),
    [anon_sym_BANG_EQ] = ACTIONS(5915),
    [anon_sym_STAR] = ACTIONS(5917),
    [anon_sym_SLASH] = ACTIONS(5919),
    [anon_sym_STAR_STAR] = ACTIONS(5921),
    [anon_sym_CARET] = ACTIONS(5921),
    [aux_sym_binary_operator_token1] = ACTIONS(5923),
    [anon_sym_PIPE_GT] = ACTIONS(5923),
    [anon_sym_COLON] = ACTIONS(5925),
    [anon_sym_DOLLAR] = ACTIONS(5927),
    [anon_sym_AT] = ACTIONS(5927),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5929),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5931),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(5933),
  },
  [1187] = {
    [sym_call_arguments] = STATE(2651),
    [sym_subset_arguments] = STATE(2561),
    [sym_subset2_arguments] = STATE(2648),
    [sym__open_parenthesis] = STATE(1340),
    [sym__open_bracket] = STATE(1335),
    [sym__open_bracket2] = STATE(1334),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5675),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5677),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5679),
    [anon_sym_DASH] = ACTIONS(5681),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5685),
    [anon_sym_DASH_GT_GT] = ACTIONS(5687),
    [anon_sym_PIPE] = ACTIONS(5689),
    [anon_sym_AMP] = ACTIONS(5691),
    [anon_sym_PIPE_PIPE] = ACTIONS(5693),
    [anon_sym_AMP_AMP] = ACTIONS(5695),
    [anon_sym_LT] = ACTIONS(5697),
    [anon_sym_LT_EQ] = ACTIONS(5699),
    [anon_sym_GT] = ACTIONS(5697),
    [anon_sym_GT_EQ] = ACTIONS(5699),
    [anon_sym_EQ_EQ] = ACTIONS(5699),
    [anon_sym_BANG_EQ] = ACTIONS(5699),
    [anon_sym_STAR] = ACTIONS(5701),
    [anon_sym_SLASH] = ACTIONS(5703),
    [anon_sym_STAR_STAR] = ACTIONS(5705),
    [anon_sym_CARET] = ACTIONS(5705),
    [aux_sym_binary_operator_token1] = ACTIONS(5707),
    [anon_sym_PIPE_GT] = ACTIONS(5707),
    [anon_sym_COLON] = ACTIONS(5709),
    [anon_sym_DOLLAR] = ACTIONS(5711),
    [anon_sym_AT] = ACTIONS(5711),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5715),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5717),
    [sym__external_open_bracket2] = ACTIONS(5719),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [1188] = {
    [sym_call_arguments] = STATE(2671),
    [sym_subset_arguments] = STATE(2663),
    [sym_subset2_arguments] = STATE(2661),
    [sym__open_parenthesis] = STATE(1555),
    [sym__open_bracket] = STATE(1551),
    [sym__open_bracket2] = STATE(1549),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5895),
    [anon_sym_DASH] = ACTIONS(5897),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5907),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5911),
    [anon_sym_LT] = ACTIONS(5913),
    [anon_sym_LT_EQ] = ACTIONS(5915),
    [anon_sym_GT] = ACTIONS(5913),
    [anon_sym_GT_EQ] = ACTIONS(5915),
    [anon_sym_EQ_EQ] = ACTIONS(5915),
    [anon_sym_BANG_EQ] = ACTIONS(5915),
    [anon_sym_STAR] = ACTIONS(5917),
    [anon_sym_SLASH] = ACTIONS(5919),
    [anon_sym_STAR_STAR] = ACTIONS(5921),
    [anon_sym_CARET] = ACTIONS(5921),
    [aux_sym_binary_operator_token1] = ACTIONS(5923),
    [anon_sym_PIPE_GT] = ACTIONS(5923),
    [anon_sym_COLON] = ACTIONS(5925),
    [anon_sym_DOLLAR] = ACTIONS(5927),
    [anon_sym_AT] = ACTIONS(5927),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5929),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5931),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(5933),
  },
  [1189] = {
    [sym_call_arguments] = STATE(2651),
    [sym_subset_arguments] = STATE(2561),
    [sym_subset2_arguments] = STATE(2648),
    [sym__open_parenthesis] = STATE(1340),
    [sym__open_bracket] = STATE(1335),
    [sym__open_bracket2] = STATE(1334),
    [sym_identifier] = ACTIONS(5401),
    [anon_sym_BSLASH] = ACTIONS(5399),
    [anon_sym_function] = ACTIONS(5401),
    [anon_sym_EQ] = ACTIONS(5675),
    [anon_sym_if] = ACTIONS(5401),
    [anon_sym_for] = ACTIONS(5401),
    [anon_sym_while] = ACTIONS(5401),
    [anon_sym_repeat] = ACTIONS(5401),
    [anon_sym_QMARK] = ACTIONS(5399),
    [anon_sym_TILDE] = ACTIONS(5677),
    [anon_sym_BANG] = ACTIONS(5401),
    [anon_sym_PLUS] = ACTIONS(5679),
    [anon_sym_DASH] = ACTIONS(5681),
    [anon_sym_LT_DASH] = ACTIONS(5683),
    [anon_sym_LT_LT_DASH] = ACTIONS(5683),
    [anon_sym_COLON_EQ] = ACTIONS(5683),
    [anon_sym_DASH_GT] = ACTIONS(5685),
    [anon_sym_DASH_GT_GT] = ACTIONS(5687),
    [anon_sym_PIPE] = ACTIONS(5689),
    [anon_sym_AMP] = ACTIONS(5691),
    [anon_sym_PIPE_PIPE] = ACTIONS(5693),
    [anon_sym_AMP_AMP] = ACTIONS(5695),
    [anon_sym_LT] = ACTIONS(5697),
    [anon_sym_LT_EQ] = ACTIONS(5699),
    [anon_sym_GT] = ACTIONS(5697),
    [anon_sym_GT_EQ] = ACTIONS(5699),
    [anon_sym_EQ_EQ] = ACTIONS(5699),
    [anon_sym_BANG_EQ] = ACTIONS(5699),
    [anon_sym_STAR] = ACTIONS(5701),
    [anon_sym_SLASH] = ACTIONS(5703),
    [anon_sym_STAR_STAR] = ACTIONS(5705),
    [anon_sym_CARET] = ACTIONS(5705),
    [aux_sym_binary_operator_token1] = ACTIONS(5707),
    [anon_sym_PIPE_GT] = ACTIONS(5707),
    [anon_sym_COLON] = ACTIONS(5709),
    [anon_sym_DOLLAR] = ACTIONS(5711),
    [anon_sym_AT] = ACTIONS(5711),
    [aux_sym__hex_literal_token1] = ACTIONS(5399),
    [sym__number_literal] = ACTIONS(5401),
    [anon_sym_SQUOTE] = ACTIONS(5399),
    [anon_sym_DQUOTE] = ACTIONS(5399),
    [sym_return] = ACTIONS(5401),
    [sym_next] = ACTIONS(5401),
    [sym_break] = ACTIONS(5401),
    [sym_true] = ACTIONS(5401),
    [sym_false] = ACTIONS(5401),
    [sym_null] = ACTIONS(5401),
    [sym_inf] = ACTIONS(5401),
    [sym_nan] = ACTIONS(5401),
    [anon_sym_NA] = ACTIONS(5401),
    [anon_sym_NA_integer_] = ACTIONS(5401),
    [anon_sym_NA_real_] = ACTIONS(5401),
    [anon_sym_NA_complex_] = ACTIONS(5401),
    [anon_sym_NA_character_] = ACTIONS(5401),
    [sym_dots] = ACTIONS(5401),
    [sym_dot_dot_i] = ACTIONS(5399),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5399),
    [sym__newline] = ACTIONS(5399),
    [sym__raw_string_literal] = ACTIONS(5399),
    [sym__external_else] = ACTIONS(5399),
    [sym__external_open_parenthesis] = ACTIONS(5715),
    [sym__external_close_parenthesis] = ACTIONS(5399),
    [sym__external_open_brace] = ACTIONS(5399),
    [sym__external_open_bracket] = ACTIONS(5717),
    [sym__external_open_bracket2] = ACTIONS(5719),
    [sym__external_close_bracket2] = ACTIONS(5399),
  },
  [1190] = {
    [sym_call_arguments] = STATE(2671),
    [sym_subset_arguments] = STATE(2663),
    [sym_subset2_arguments] = STATE(2661),
    [sym__open_parenthesis] = STATE(1555),
    [sym__open_bracket] = STATE(1551),
    [sym__open_bracket2] = STATE(1549),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5893),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5895),
    [anon_sym_DASH] = ACTIONS(5897),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5905),
    [anon_sym_AMP] = ACTIONS(5907),
    [anon_sym_PIPE_PIPE] = ACTIONS(5909),
    [anon_sym_AMP_AMP] = ACTIONS(5911),
    [anon_sym_LT] = ACTIONS(5913),
    [anon_sym_LT_EQ] = ACTIONS(5915),
    [anon_sym_GT] = ACTIONS(5913),
    [anon_sym_GT_EQ] = ACTIONS(5915),
    [anon_sym_EQ_EQ] = ACTIONS(5915),
    [anon_sym_BANG_EQ] = ACTIONS(5915),
    [anon_sym_STAR] = ACTIONS(5917),
    [anon_sym_SLASH] = ACTIONS(5919),
    [anon_sym_STAR_STAR] = ACTIONS(5921),
    [anon_sym_CARET] = ACTIONS(5921),
    [aux_sym_binary_operator_token1] = ACTIONS(5923),
    [anon_sym_PIPE_GT] = ACTIONS(5923),
    [anon_sym_COLON] = ACTIONS(5925),
    [anon_sym_DOLLAR] = ACTIONS(5927),
    [anon_sym_AT] = ACTIONS(5927),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5929),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5931),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(5933),
  },
  [1191] = {
    [sym_call_arguments] = STATE(2671),
    [sym_subset_arguments] = STATE(2663),
    [sym_subset2_arguments] = STATE(2661),
    [sym__open_parenthesis] = STATE(1555),
    [sym__open_bracket] = STATE(1551),
    [sym__open_bracket2] = STATE(1549),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5889),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5893),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5895),
    [anon_sym_DASH] = ACTIONS(5897),
    [anon_sym_LT_DASH] = ACTIONS(5899),
    [anon_sym_LT_LT_DASH] = ACTIONS(5899),
    [anon_sym_COLON_EQ] = ACTIONS(5899),
    [anon_sym_DASH_GT] = ACTIONS(5901),
    [anon_sym_DASH_GT_GT] = ACTIONS(5903),
    [anon_sym_PIPE] = ACTIONS(5905),
    [anon_sym_AMP] = ACTIONS(5907),
    [anon_sym_PIPE_PIPE] = ACTIONS(5909),
    [anon_sym_AMP_AMP] = ACTIONS(5911),
    [anon_sym_LT] = ACTIONS(5913),
    [anon_sym_LT_EQ] = ACTIONS(5915),
    [anon_sym_GT] = ACTIONS(5913),
    [anon_sym_GT_EQ] = ACTIONS(5915),
    [anon_sym_EQ_EQ] = ACTIONS(5915),
    [anon_sym_BANG_EQ] = ACTIONS(5915),
    [anon_sym_STAR] = ACTIONS(5917),
    [anon_sym_SLASH] = ACTIONS(5919),
    [anon_sym_STAR_STAR] = ACTIONS(5921),
    [anon_sym_CARET] = ACTIONS(5921),
    [aux_sym_binary_operator_token1] = ACTIONS(5923),
    [anon_sym_PIPE_GT] = ACTIONS(5923),
    [anon_sym_COLON] = ACTIONS(5925),
    [anon_sym_DOLLAR] = ACTIONS(5927),
    [anon_sym_AT] = ACTIONS(5927),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5929),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5931),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(5933),
  },
  [1192] = {
    [sym_call_arguments] = STATE(2671),
    [sym_subset_arguments] = STATE(2663),
    [sym_subset2_arguments] = STATE(2661),
    [sym__open_parenthesis] = STATE(1555),
    [sym__open_bracket] = STATE(1551),
    [sym__open_bracket2] = STATE(1549),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5917),
    [anon_sym_SLASH] = ACTIONS(5919),
    [anon_sym_STAR_STAR] = ACTIONS(5921),
    [anon_sym_CARET] = ACTIONS(5921),
    [aux_sym_binary_operator_token1] = ACTIONS(5923),
    [anon_sym_PIPE_GT] = ACTIONS(5923),
    [anon_sym_COLON] = ACTIONS(5925),
    [anon_sym_DOLLAR] = ACTIONS(5927),
    [anon_sym_AT] = ACTIONS(5927),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5929),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5931),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(5933),
  },
  [1193] = {
    [sym_call_arguments] = STATE(2671),
    [sym_subset_arguments] = STATE(2663),
    [sym_subset2_arguments] = STATE(2661),
    [sym__open_parenthesis] = STATE(1555),
    [sym__open_bracket] = STATE(1551),
    [sym__open_bracket2] = STATE(1549),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5895),
    [anon_sym_DASH] = ACTIONS(5897),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5905),
    [anon_sym_AMP] = ACTIONS(5907),
    [anon_sym_PIPE_PIPE] = ACTIONS(5909),
    [anon_sym_AMP_AMP] = ACTIONS(5911),
    [anon_sym_LT] = ACTIONS(5913),
    [anon_sym_LT_EQ] = ACTIONS(5915),
    [anon_sym_GT] = ACTIONS(5913),
    [anon_sym_GT_EQ] = ACTIONS(5915),
    [anon_sym_EQ_EQ] = ACTIONS(5915),
    [anon_sym_BANG_EQ] = ACTIONS(5915),
    [anon_sym_STAR] = ACTIONS(5917),
    [anon_sym_SLASH] = ACTIONS(5919),
    [anon_sym_STAR_STAR] = ACTIONS(5921),
    [anon_sym_CARET] = ACTIONS(5921),
    [aux_sym_binary_operator_token1] = ACTIONS(5923),
    [anon_sym_PIPE_GT] = ACTIONS(5923),
    [anon_sym_COLON] = ACTIONS(5925),
    [anon_sym_DOLLAR] = ACTIONS(5927),
    [anon_sym_AT] = ACTIONS(5927),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5929),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5931),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(5933),
  },
  [1194] = {
    [sym_call_arguments] = STATE(2671),
    [sym_subset_arguments] = STATE(2663),
    [sym_subset2_arguments] = STATE(2661),
    [sym__open_parenthesis] = STATE(1555),
    [sym__open_bracket] = STATE(1551),
    [sym__open_bracket2] = STATE(1549),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5889),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5893),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5895),
    [anon_sym_DASH] = ACTIONS(5897),
    [anon_sym_LT_DASH] = ACTIONS(5899),
    [anon_sym_LT_LT_DASH] = ACTIONS(5899),
    [anon_sym_COLON_EQ] = ACTIONS(5899),
    [anon_sym_DASH_GT] = ACTIONS(5901),
    [anon_sym_DASH_GT_GT] = ACTIONS(5903),
    [anon_sym_PIPE] = ACTIONS(5905),
    [anon_sym_AMP] = ACTIONS(5907),
    [anon_sym_PIPE_PIPE] = ACTIONS(5909),
    [anon_sym_AMP_AMP] = ACTIONS(5911),
    [anon_sym_LT] = ACTIONS(5913),
    [anon_sym_LT_EQ] = ACTIONS(5915),
    [anon_sym_GT] = ACTIONS(5913),
    [anon_sym_GT_EQ] = ACTIONS(5915),
    [anon_sym_EQ_EQ] = ACTIONS(5915),
    [anon_sym_BANG_EQ] = ACTIONS(5915),
    [anon_sym_STAR] = ACTIONS(5917),
    [anon_sym_SLASH] = ACTIONS(5919),
    [anon_sym_STAR_STAR] = ACTIONS(5921),
    [anon_sym_CARET] = ACTIONS(5921),
    [aux_sym_binary_operator_token1] = ACTIONS(5923),
    [anon_sym_PIPE_GT] = ACTIONS(5923),
    [anon_sym_COLON] = ACTIONS(5925),
    [anon_sym_DOLLAR] = ACTIONS(5927),
    [anon_sym_AT] = ACTIONS(5927),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5929),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5931),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(5933),
  },
  [1195] = {
    [sym_call_arguments] = STATE(2671),
    [sym_subset_arguments] = STATE(2663),
    [sym_subset2_arguments] = STATE(2661),
    [sym__open_parenthesis] = STATE(1555),
    [sym__open_bracket] = STATE(1551),
    [sym__open_bracket2] = STATE(1549),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5889),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5893),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5895),
    [anon_sym_DASH] = ACTIONS(5897),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5901),
    [anon_sym_DASH_GT_GT] = ACTIONS(5903),
    [anon_sym_PIPE] = ACTIONS(5905),
    [anon_sym_AMP] = ACTIONS(5907),
    [anon_sym_PIPE_PIPE] = ACTIONS(5909),
    [anon_sym_AMP_AMP] = ACTIONS(5911),
    [anon_sym_LT] = ACTIONS(5913),
    [anon_sym_LT_EQ] = ACTIONS(5915),
    [anon_sym_GT] = ACTIONS(5913),
    [anon_sym_GT_EQ] = ACTIONS(5915),
    [anon_sym_EQ_EQ] = ACTIONS(5915),
    [anon_sym_BANG_EQ] = ACTIONS(5915),
    [anon_sym_STAR] = ACTIONS(5917),
    [anon_sym_SLASH] = ACTIONS(5919),
    [anon_sym_STAR_STAR] = ACTIONS(5921),
    [anon_sym_CARET] = ACTIONS(5921),
    [aux_sym_binary_operator_token1] = ACTIONS(5923),
    [anon_sym_PIPE_GT] = ACTIONS(5923),
    [anon_sym_COLON] = ACTIONS(5925),
    [anon_sym_DOLLAR] = ACTIONS(5927),
    [anon_sym_AT] = ACTIONS(5927),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5929),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5931),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(5933),
  },
  [1196] = {
    [sym_call_arguments] = STATE(2671),
    [sym_subset_arguments] = STATE(2663),
    [sym_subset2_arguments] = STATE(2661),
    [sym__open_parenthesis] = STATE(1555),
    [sym__open_bracket] = STATE(1551),
    [sym__open_bracket2] = STATE(1549),
    [sym_identifier] = ACTIONS(5401),
    [anon_sym_BSLASH] = ACTIONS(5399),
    [anon_sym_function] = ACTIONS(5401),
    [anon_sym_EQ] = ACTIONS(5889),
    [anon_sym_if] = ACTIONS(5401),
    [anon_sym_for] = ACTIONS(5401),
    [anon_sym_while] = ACTIONS(5401),
    [anon_sym_repeat] = ACTIONS(5401),
    [anon_sym_QMARK] = ACTIONS(5399),
    [anon_sym_TILDE] = ACTIONS(5893),
    [anon_sym_BANG] = ACTIONS(5401),
    [anon_sym_PLUS] = ACTIONS(5895),
    [anon_sym_DASH] = ACTIONS(5897),
    [anon_sym_LT_DASH] = ACTIONS(5899),
    [anon_sym_LT_LT_DASH] = ACTIONS(5899),
    [anon_sym_COLON_EQ] = ACTIONS(5899),
    [anon_sym_DASH_GT] = ACTIONS(5901),
    [anon_sym_DASH_GT_GT] = ACTIONS(5903),
    [anon_sym_PIPE] = ACTIONS(5905),
    [anon_sym_AMP] = ACTIONS(5907),
    [anon_sym_PIPE_PIPE] = ACTIONS(5909),
    [anon_sym_AMP_AMP] = ACTIONS(5911),
    [anon_sym_LT] = ACTIONS(5913),
    [anon_sym_LT_EQ] = ACTIONS(5915),
    [anon_sym_GT] = ACTIONS(5913),
    [anon_sym_GT_EQ] = ACTIONS(5915),
    [anon_sym_EQ_EQ] = ACTIONS(5915),
    [anon_sym_BANG_EQ] = ACTIONS(5915),
    [anon_sym_STAR] = ACTIONS(5917),
    [anon_sym_SLASH] = ACTIONS(5919),
    [anon_sym_STAR_STAR] = ACTIONS(5921),
    [anon_sym_CARET] = ACTIONS(5921),
    [aux_sym_binary_operator_token1] = ACTIONS(5923),
    [anon_sym_PIPE_GT] = ACTIONS(5923),
    [anon_sym_COLON] = ACTIONS(5925),
    [anon_sym_DOLLAR] = ACTIONS(5927),
    [anon_sym_AT] = ACTIONS(5927),
    [aux_sym__hex_literal_token1] = ACTIONS(5399),
    [sym__number_literal] = ACTIONS(5401),
    [anon_sym_SQUOTE] = ACTIONS(5399),
    [anon_sym_DQUOTE] = ACTIONS(5399),
    [sym_return] = ACTIONS(5401),
    [sym_next] = ACTIONS(5401),
    [sym_break] = ACTIONS(5401),
    [sym_true] = ACTIONS(5401),
    [sym_false] = ACTIONS(5401),
    [sym_null] = ACTIONS(5401),
    [sym_inf] = ACTIONS(5401),
    [sym_nan] = ACTIONS(5401),
    [anon_sym_NA] = ACTIONS(5401),
    [anon_sym_NA_integer_] = ACTIONS(5401),
    [anon_sym_NA_real_] = ACTIONS(5401),
    [anon_sym_NA_complex_] = ACTIONS(5401),
    [anon_sym_NA_character_] = ACTIONS(5401),
    [sym_dots] = ACTIONS(5401),
    [sym_dot_dot_i] = ACTIONS(5399),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5399),
    [sym__newline] = ACTIONS(5399),
    [sym__semicolon] = ACTIONS(5399),
    [sym__raw_string_literal] = ACTIONS(5399),
    [sym__external_open_parenthesis] = ACTIONS(5929),
    [sym__external_open_brace] = ACTIONS(5399),
    [sym__external_close_brace] = ACTIONS(5399),
    [sym__external_open_bracket] = ACTIONS(5931),
    [sym__external_close_bracket] = ACTIONS(5399),
    [sym__external_open_bracket2] = ACTIONS(5933),
  },
  [1197] = {
    [sym_call_arguments] = STATE(2671),
    [sym_subset_arguments] = STATE(2663),
    [sym_subset2_arguments] = STATE(2661),
    [sym__open_parenthesis] = STATE(1555),
    [sym__open_bracket] = STATE(1551),
    [sym__open_bracket2] = STATE(1549),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(5921),
    [anon_sym_CARET] = ACTIONS(5921),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(5351),
    [anon_sym_DOLLAR] = ACTIONS(5927),
    [anon_sym_AT] = ACTIONS(5927),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5929),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5931),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(5933),
  },
  [1198] = {
    [sym_call_arguments] = STATE(2651),
    [sym_subset_arguments] = STATE(2561),
    [sym_subset2_arguments] = STATE(2648),
    [sym__open_parenthesis] = STATE(1340),
    [sym__open_bracket] = STATE(1335),
    [sym__open_bracket2] = STATE(1334),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(5705),
    [anon_sym_CARET] = ACTIONS(5705),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(5351),
    [anon_sym_DOLLAR] = ACTIONS(5711),
    [anon_sym_AT] = ACTIONS(5711),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5715),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5717),
    [sym__external_open_bracket2] = ACTIONS(5719),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [1199] = {
    [sym_call_arguments] = STATE(2651),
    [sym_subset_arguments] = STATE(2561),
    [sym_subset2_arguments] = STATE(2648),
    [sym__open_parenthesis] = STATE(1340),
    [sym__open_bracket] = STATE(1335),
    [sym__open_bracket2] = STATE(1334),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(5705),
    [anon_sym_CARET] = ACTIONS(5705),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(5709),
    [anon_sym_DOLLAR] = ACTIONS(5711),
    [anon_sym_AT] = ACTIONS(5711),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5715),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5717),
    [sym__external_open_bracket2] = ACTIONS(5719),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [1200] = {
    [sym_call_arguments] = STATE(2651),
    [sym_subset_arguments] = STATE(2561),
    [sym_subset2_arguments] = STATE(2648),
    [sym__open_parenthesis] = STATE(1340),
    [sym__open_bracket] = STATE(1335),
    [sym__open_bracket2] = STATE(1334),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(5705),
    [anon_sym_CARET] = ACTIONS(5705),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(5351),
    [anon_sym_DOLLAR] = ACTIONS(5711),
    [anon_sym_AT] = ACTIONS(5711),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5715),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5717),
    [sym__external_open_bracket2] = ACTIONS(5719),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [1201] = {
    [sym_call_arguments] = STATE(2651),
    [sym_subset_arguments] = STATE(2561),
    [sym_subset2_arguments] = STATE(2648),
    [sym__open_parenthesis] = STATE(1340),
    [sym__open_bracket] = STATE(1335),
    [sym__open_bracket2] = STATE(1334),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(5705),
    [anon_sym_CARET] = ACTIONS(5705),
    [aux_sym_binary_operator_token1] = ACTIONS(5707),
    [anon_sym_PIPE_GT] = ACTIONS(5707),
    [anon_sym_COLON] = ACTIONS(5709),
    [anon_sym_DOLLAR] = ACTIONS(5711),
    [anon_sym_AT] = ACTIONS(5711),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5715),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5717),
    [sym__external_open_bracket2] = ACTIONS(5719),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [1202] = {
    [sym_call_arguments] = STATE(2651),
    [sym_subset_arguments] = STATE(2561),
    [sym_subset2_arguments] = STATE(2648),
    [sym__open_parenthesis] = STATE(1340),
    [sym__open_bracket] = STATE(1335),
    [sym__open_bracket2] = STATE(1334),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5679),
    [anon_sym_DASH] = ACTIONS(5681),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5701),
    [anon_sym_SLASH] = ACTIONS(5703),
    [anon_sym_STAR_STAR] = ACTIONS(5705),
    [anon_sym_CARET] = ACTIONS(5705),
    [aux_sym_binary_operator_token1] = ACTIONS(5707),
    [anon_sym_PIPE_GT] = ACTIONS(5707),
    [anon_sym_COLON] = ACTIONS(5709),
    [anon_sym_DOLLAR] = ACTIONS(5711),
    [anon_sym_AT] = ACTIONS(5711),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5715),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5717),
    [sym__external_open_bracket2] = ACTIONS(5719),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [1203] = {
    [sym_call_arguments] = STATE(2651),
    [sym_subset_arguments] = STATE(2561),
    [sym_subset2_arguments] = STATE(2648),
    [sym__open_parenthesis] = STATE(1340),
    [sym__open_bracket] = STATE(1335),
    [sym__open_bracket2] = STATE(1334),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5679),
    [anon_sym_DASH] = ACTIONS(5681),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5697),
    [anon_sym_LT_EQ] = ACTIONS(5699),
    [anon_sym_GT] = ACTIONS(5697),
    [anon_sym_GT_EQ] = ACTIONS(5699),
    [anon_sym_EQ_EQ] = ACTIONS(5699),
    [anon_sym_BANG_EQ] = ACTIONS(5699),
    [anon_sym_STAR] = ACTIONS(5701),
    [anon_sym_SLASH] = ACTIONS(5703),
    [anon_sym_STAR_STAR] = ACTIONS(5705),
    [anon_sym_CARET] = ACTIONS(5705),
    [aux_sym_binary_operator_token1] = ACTIONS(5707),
    [anon_sym_PIPE_GT] = ACTIONS(5707),
    [anon_sym_COLON] = ACTIONS(5709),
    [anon_sym_DOLLAR] = ACTIONS(5711),
    [anon_sym_AT] = ACTIONS(5711),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5715),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5717),
    [sym__external_open_bracket2] = ACTIONS(5719),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [1204] = {
    [sym_call_arguments] = STATE(2651),
    [sym_subset_arguments] = STATE(2561),
    [sym_subset2_arguments] = STATE(2648),
    [sym__open_parenthesis] = STATE(1340),
    [sym__open_bracket] = STATE(1335),
    [sym__open_bracket2] = STATE(1334),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5679),
    [anon_sym_DASH] = ACTIONS(5681),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5691),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5695),
    [anon_sym_LT] = ACTIONS(5697),
    [anon_sym_LT_EQ] = ACTIONS(5699),
    [anon_sym_GT] = ACTIONS(5697),
    [anon_sym_GT_EQ] = ACTIONS(5699),
    [anon_sym_EQ_EQ] = ACTIONS(5699),
    [anon_sym_BANG_EQ] = ACTIONS(5699),
    [anon_sym_STAR] = ACTIONS(5701),
    [anon_sym_SLASH] = ACTIONS(5703),
    [anon_sym_STAR_STAR] = ACTIONS(5705),
    [anon_sym_CARET] = ACTIONS(5705),
    [aux_sym_binary_operator_token1] = ACTIONS(5707),
    [anon_sym_PIPE_GT] = ACTIONS(5707),
    [anon_sym_COLON] = ACTIONS(5709),
    [anon_sym_DOLLAR] = ACTIONS(5711),
    [anon_sym_AT] = ACTIONS(5711),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5715),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5717),
    [sym__external_open_bracket2] = ACTIONS(5719),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [1205] = {
    [sym_call_arguments] = STATE(2651),
    [sym_subset_arguments] = STATE(2561),
    [sym_subset2_arguments] = STATE(2648),
    [sym__open_parenthesis] = STATE(1340),
    [sym__open_bracket] = STATE(1335),
    [sym__open_bracket2] = STATE(1334),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5677),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5679),
    [anon_sym_DASH] = ACTIONS(5681),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5689),
    [anon_sym_AMP] = ACTIONS(5691),
    [anon_sym_PIPE_PIPE] = ACTIONS(5693),
    [anon_sym_AMP_AMP] = ACTIONS(5695),
    [anon_sym_LT] = ACTIONS(5697),
    [anon_sym_LT_EQ] = ACTIONS(5699),
    [anon_sym_GT] = ACTIONS(5697),
    [anon_sym_GT_EQ] = ACTIONS(5699),
    [anon_sym_EQ_EQ] = ACTIONS(5699),
    [anon_sym_BANG_EQ] = ACTIONS(5699),
    [anon_sym_STAR] = ACTIONS(5701),
    [anon_sym_SLASH] = ACTIONS(5703),
    [anon_sym_STAR_STAR] = ACTIONS(5705),
    [anon_sym_CARET] = ACTIONS(5705),
    [aux_sym_binary_operator_token1] = ACTIONS(5707),
    [anon_sym_PIPE_GT] = ACTIONS(5707),
    [anon_sym_COLON] = ACTIONS(5709),
    [anon_sym_DOLLAR] = ACTIONS(5711),
    [anon_sym_AT] = ACTIONS(5711),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5715),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5717),
    [sym__external_open_bracket2] = ACTIONS(5719),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [1206] = {
    [sym_call_arguments] = STATE(2651),
    [sym_subset_arguments] = STATE(2561),
    [sym_subset2_arguments] = STATE(2648),
    [sym__open_parenthesis] = STATE(1340),
    [sym__open_bracket] = STATE(1335),
    [sym__open_bracket2] = STATE(1334),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5675),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5677),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5679),
    [anon_sym_DASH] = ACTIONS(5681),
    [anon_sym_LT_DASH] = ACTIONS(5683),
    [anon_sym_LT_LT_DASH] = ACTIONS(5683),
    [anon_sym_COLON_EQ] = ACTIONS(5683),
    [anon_sym_DASH_GT] = ACTIONS(5685),
    [anon_sym_DASH_GT_GT] = ACTIONS(5687),
    [anon_sym_PIPE] = ACTIONS(5689),
    [anon_sym_AMP] = ACTIONS(5691),
    [anon_sym_PIPE_PIPE] = ACTIONS(5693),
    [anon_sym_AMP_AMP] = ACTIONS(5695),
    [anon_sym_LT] = ACTIONS(5697),
    [anon_sym_LT_EQ] = ACTIONS(5699),
    [anon_sym_GT] = ACTIONS(5697),
    [anon_sym_GT_EQ] = ACTIONS(5699),
    [anon_sym_EQ_EQ] = ACTIONS(5699),
    [anon_sym_BANG_EQ] = ACTIONS(5699),
    [anon_sym_STAR] = ACTIONS(5701),
    [anon_sym_SLASH] = ACTIONS(5703),
    [anon_sym_STAR_STAR] = ACTIONS(5705),
    [anon_sym_CARET] = ACTIONS(5705),
    [aux_sym_binary_operator_token1] = ACTIONS(5707),
    [anon_sym_PIPE_GT] = ACTIONS(5707),
    [anon_sym_COLON] = ACTIONS(5709),
    [anon_sym_DOLLAR] = ACTIONS(5711),
    [anon_sym_AT] = ACTIONS(5711),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5715),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5717),
    [sym__external_open_bracket2] = ACTIONS(5719),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [1207] = {
    [sym_call_arguments] = STATE(2651),
    [sym_subset_arguments] = STATE(2561),
    [sym_subset2_arguments] = STATE(2648),
    [sym__open_parenthesis] = STATE(1340),
    [sym__open_bracket] = STATE(1335),
    [sym__open_bracket2] = STATE(1334),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5701),
    [anon_sym_SLASH] = ACTIONS(5703),
    [anon_sym_STAR_STAR] = ACTIONS(5705),
    [anon_sym_CARET] = ACTIONS(5705),
    [aux_sym_binary_operator_token1] = ACTIONS(5707),
    [anon_sym_PIPE_GT] = ACTIONS(5707),
    [anon_sym_COLON] = ACTIONS(5709),
    [anon_sym_DOLLAR] = ACTIONS(5711),
    [anon_sym_AT] = ACTIONS(5711),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5715),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5717),
    [sym__external_open_bracket2] = ACTIONS(5719),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [1208] = {
    [sym_call_arguments] = STATE(2651),
    [sym_subset_arguments] = STATE(2561),
    [sym_subset2_arguments] = STATE(2648),
    [sym__open_parenthesis] = STATE(1340),
    [sym__open_bracket] = STATE(1335),
    [sym__open_bracket2] = STATE(1334),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5679),
    [anon_sym_DASH] = ACTIONS(5681),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5689),
    [anon_sym_AMP] = ACTIONS(5691),
    [anon_sym_PIPE_PIPE] = ACTIONS(5693),
    [anon_sym_AMP_AMP] = ACTIONS(5695),
    [anon_sym_LT] = ACTIONS(5697),
    [anon_sym_LT_EQ] = ACTIONS(5699),
    [anon_sym_GT] = ACTIONS(5697),
    [anon_sym_GT_EQ] = ACTIONS(5699),
    [anon_sym_EQ_EQ] = ACTIONS(5699),
    [anon_sym_BANG_EQ] = ACTIONS(5699),
    [anon_sym_STAR] = ACTIONS(5701),
    [anon_sym_SLASH] = ACTIONS(5703),
    [anon_sym_STAR_STAR] = ACTIONS(5705),
    [anon_sym_CARET] = ACTIONS(5705),
    [aux_sym_binary_operator_token1] = ACTIONS(5707),
    [anon_sym_PIPE_GT] = ACTIONS(5707),
    [anon_sym_COLON] = ACTIONS(5709),
    [anon_sym_DOLLAR] = ACTIONS(5711),
    [anon_sym_AT] = ACTIONS(5711),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5715),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5717),
    [sym__external_open_bracket2] = ACTIONS(5719),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [1209] = {
    [sym_call_arguments] = STATE(2651),
    [sym_subset_arguments] = STATE(2561),
    [sym_subset2_arguments] = STATE(2648),
    [sym__open_parenthesis] = STATE(1340),
    [sym__open_bracket] = STATE(1335),
    [sym__open_bracket2] = STATE(1334),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5675),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5677),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5679),
    [anon_sym_DASH] = ACTIONS(5681),
    [anon_sym_LT_DASH] = ACTIONS(5683),
    [anon_sym_LT_LT_DASH] = ACTIONS(5683),
    [anon_sym_COLON_EQ] = ACTIONS(5683),
    [anon_sym_DASH_GT] = ACTIONS(5685),
    [anon_sym_DASH_GT_GT] = ACTIONS(5687),
    [anon_sym_PIPE] = ACTIONS(5689),
    [anon_sym_AMP] = ACTIONS(5691),
    [anon_sym_PIPE_PIPE] = ACTIONS(5693),
    [anon_sym_AMP_AMP] = ACTIONS(5695),
    [anon_sym_LT] = ACTIONS(5697),
    [anon_sym_LT_EQ] = ACTIONS(5699),
    [anon_sym_GT] = ACTIONS(5697),
    [anon_sym_GT_EQ] = ACTIONS(5699),
    [anon_sym_EQ_EQ] = ACTIONS(5699),
    [anon_sym_BANG_EQ] = ACTIONS(5699),
    [anon_sym_STAR] = ACTIONS(5701),
    [anon_sym_SLASH] = ACTIONS(5703),
    [anon_sym_STAR_STAR] = ACTIONS(5705),
    [anon_sym_CARET] = ACTIONS(5705),
    [aux_sym_binary_operator_token1] = ACTIONS(5707),
    [anon_sym_PIPE_GT] = ACTIONS(5707),
    [anon_sym_COLON] = ACTIONS(5709),
    [anon_sym_DOLLAR] = ACTIONS(5711),
    [anon_sym_AT] = ACTIONS(5711),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5715),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5717),
    [sym__external_open_bracket2] = ACTIONS(5719),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [1210] = {
    [sym_call_arguments] = STATE(2651),
    [sym_subset_arguments] = STATE(2561),
    [sym_subset2_arguments] = STATE(2648),
    [sym__open_parenthesis] = STATE(1340),
    [sym__open_bracket] = STATE(1335),
    [sym__open_bracket2] = STATE(1334),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5675),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5677),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5679),
    [anon_sym_DASH] = ACTIONS(5681),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5685),
    [anon_sym_DASH_GT_GT] = ACTIONS(5687),
    [anon_sym_PIPE] = ACTIONS(5689),
    [anon_sym_AMP] = ACTIONS(5691),
    [anon_sym_PIPE_PIPE] = ACTIONS(5693),
    [anon_sym_AMP_AMP] = ACTIONS(5695),
    [anon_sym_LT] = ACTIONS(5697),
    [anon_sym_LT_EQ] = ACTIONS(5699),
    [anon_sym_GT] = ACTIONS(5697),
    [anon_sym_GT_EQ] = ACTIONS(5699),
    [anon_sym_EQ_EQ] = ACTIONS(5699),
    [anon_sym_BANG_EQ] = ACTIONS(5699),
    [anon_sym_STAR] = ACTIONS(5701),
    [anon_sym_SLASH] = ACTIONS(5703),
    [anon_sym_STAR_STAR] = ACTIONS(5705),
    [anon_sym_CARET] = ACTIONS(5705),
    [aux_sym_binary_operator_token1] = ACTIONS(5707),
    [anon_sym_PIPE_GT] = ACTIONS(5707),
    [anon_sym_COLON] = ACTIONS(5709),
    [anon_sym_DOLLAR] = ACTIONS(5711),
    [anon_sym_AT] = ACTIONS(5711),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5715),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5717),
    [sym__external_open_bracket2] = ACTIONS(5719),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [1211] = {
    [sym_call_arguments] = STATE(2651),
    [sym_subset_arguments] = STATE(2561),
    [sym_subset2_arguments] = STATE(2648),
    [sym__open_parenthesis] = STATE(1340),
    [sym__open_bracket] = STATE(1335),
    [sym__open_bracket2] = STATE(1334),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5345),
    [anon_sym_DASH] = ACTIONS(5347),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5347),
    [anon_sym_AMP] = ACTIONS(5347),
    [anon_sym_PIPE_PIPE] = ACTIONS(5345),
    [anon_sym_AMP_AMP] = ACTIONS(5345),
    [anon_sym_LT] = ACTIONS(5347),
    [anon_sym_LT_EQ] = ACTIONS(5345),
    [anon_sym_GT] = ACTIONS(5347),
    [anon_sym_GT_EQ] = ACTIONS(5345),
    [anon_sym_EQ_EQ] = ACTIONS(5345),
    [anon_sym_BANG_EQ] = ACTIONS(5345),
    [anon_sym_STAR] = ACTIONS(5347),
    [anon_sym_SLASH] = ACTIONS(5345),
    [anon_sym_STAR_STAR] = ACTIONS(5705),
    [anon_sym_CARET] = ACTIONS(5705),
    [aux_sym_binary_operator_token1] = ACTIONS(5345),
    [anon_sym_PIPE_GT] = ACTIONS(5345),
    [anon_sym_COLON] = ACTIONS(5347),
    [anon_sym_DOLLAR] = ACTIONS(5711),
    [anon_sym_AT] = ACTIONS(5711),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_else] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(5715),
    [sym__external_close_parenthesis] = ACTIONS(5345),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(5717),
    [sym__external_open_bracket2] = ACTIONS(5719),
    [sym__external_close_bracket2] = ACTIONS(5345),
  },
  [1212] = {
    [sym_call_arguments] = STATE(2651),
    [sym_subset_arguments] = STATE(2561),
    [sym_subset2_arguments] = STATE(2648),
    [sym__open_parenthesis] = STATE(1340),
    [sym__open_bracket] = STATE(1335),
    [sym__open_bracket2] = STATE(1334),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5679),
    [anon_sym_DASH] = ACTIONS(5681),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5347),
    [anon_sym_AMP] = ACTIONS(5347),
    [anon_sym_PIPE_PIPE] = ACTIONS(5345),
    [anon_sym_AMP_AMP] = ACTIONS(5345),
    [anon_sym_LT] = ACTIONS(5697),
    [anon_sym_LT_EQ] = ACTIONS(5699),
    [anon_sym_GT] = ACTIONS(5697),
    [anon_sym_GT_EQ] = ACTIONS(5699),
    [anon_sym_EQ_EQ] = ACTIONS(5699),
    [anon_sym_BANG_EQ] = ACTIONS(5699),
    [anon_sym_STAR] = ACTIONS(5701),
    [anon_sym_SLASH] = ACTIONS(5703),
    [anon_sym_STAR_STAR] = ACTIONS(5705),
    [anon_sym_CARET] = ACTIONS(5705),
    [aux_sym_binary_operator_token1] = ACTIONS(5707),
    [anon_sym_PIPE_GT] = ACTIONS(5707),
    [anon_sym_COLON] = ACTIONS(5709),
    [anon_sym_DOLLAR] = ACTIONS(5711),
    [anon_sym_AT] = ACTIONS(5711),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_else] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(5715),
    [sym__external_close_parenthesis] = ACTIONS(5345),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(5717),
    [sym__external_open_bracket2] = ACTIONS(5719),
    [sym__external_close_bracket2] = ACTIONS(5345),
  },
  [1213] = {
    [sym_string] = STATE(2487),
    [sym__single_quoted_string] = STATE(2181),
    [sym__double_quoted_string] = STATE(2180),
    [sym__string_or_identifier] = STATE(2487),
    [aux_sym_function_definition_repeat1] = STATE(1264),
    [ts_builtin_sym_end] = ACTIONS(5659),
    [sym_identifier] = ACTIONS(6165),
    [anon_sym_BSLASH] = ACTIONS(5659),
    [anon_sym_function] = ACTIONS(5663),
    [anon_sym_EQ] = ACTIONS(5663),
    [anon_sym_if] = ACTIONS(5663),
    [anon_sym_for] = ACTIONS(5663),
    [anon_sym_while] = ACTIONS(5663),
    [anon_sym_repeat] = ACTIONS(5663),
    [anon_sym_QMARK] = ACTIONS(5659),
    [anon_sym_TILDE] = ACTIONS(5659),
    [anon_sym_BANG] = ACTIONS(5663),
    [anon_sym_PLUS] = ACTIONS(5659),
    [anon_sym_DASH] = ACTIONS(5663),
    [anon_sym_LT_DASH] = ACTIONS(5659),
    [anon_sym_LT_LT_DASH] = ACTIONS(5659),
    [anon_sym_COLON_EQ] = ACTIONS(5659),
    [anon_sym_DASH_GT] = ACTIONS(5663),
    [anon_sym_DASH_GT_GT] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(5663),
    [anon_sym_AMP] = ACTIONS(5663),
    [anon_sym_PIPE_PIPE] = ACTIONS(5659),
    [anon_sym_AMP_AMP] = ACTIONS(5659),
    [anon_sym_LT] = ACTIONS(5663),
    [anon_sym_LT_EQ] = ACTIONS(5659),
    [anon_sym_GT] = ACTIONS(5663),
    [anon_sym_GT_EQ] = ACTIONS(5659),
    [anon_sym_EQ_EQ] = ACTIONS(5659),
    [anon_sym_BANG_EQ] = ACTIONS(5659),
    [anon_sym_STAR] = ACTIONS(5663),
    [anon_sym_SLASH] = ACTIONS(5659),
    [anon_sym_STAR_STAR] = ACTIONS(5659),
    [anon_sym_CARET] = ACTIONS(5659),
    [aux_sym_binary_operator_token1] = ACTIONS(5659),
    [anon_sym_PIPE_GT] = ACTIONS(5659),
    [anon_sym_COLON] = ACTIONS(5663),
    [anon_sym_DOLLAR] = ACTIONS(5659),
    [anon_sym_AT] = ACTIONS(5659),
    [aux_sym__hex_literal_token1] = ACTIONS(5659),
    [sym__number_literal] = ACTIONS(5663),
    [anon_sym_SQUOTE] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(351),
    [sym_return] = ACTIONS(5663),
    [sym_next] = ACTIONS(5663),
    [sym_break] = ACTIONS(5663),
    [sym_true] = ACTIONS(5663),
    [sym_false] = ACTIONS(5663),
    [sym_null] = ACTIONS(5663),
    [sym_inf] = ACTIONS(5663),
    [sym_nan] = ACTIONS(5663),
    [anon_sym_NA] = ACTIONS(5663),
    [anon_sym_NA_integer_] = ACTIONS(5663),
    [anon_sym_NA_real_] = ACTIONS(5663),
    [anon_sym_NA_complex_] = ACTIONS(5663),
    [anon_sym_NA_character_] = ACTIONS(5663),
    [sym_dots] = ACTIONS(5663),
    [sym_dot_dot_i] = ACTIONS(5659),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5659),
    [sym__newline] = ACTIONS(6167),
    [sym__semicolon] = ACTIONS(5659),
    [sym__raw_string_literal] = ACTIONS(361),
    [sym__external_open_parenthesis] = ACTIONS(5659),
    [sym__external_close_parenthesis] = ACTIONS(5659),
    [sym__external_open_brace] = ACTIONS(5659),
    [sym__external_close_brace] = ACTIONS(5659),
    [sym__external_open_bracket] = ACTIONS(5659),
    [sym__external_open_bracket2] = ACTIONS(5659),
  },
  [1214] = {
    [sym_call_arguments] = STATE(2651),
    [sym_subset_arguments] = STATE(2561),
    [sym_subset2_arguments] = STATE(2648),
    [sym__open_parenthesis] = STATE(1340),
    [sym__open_bracket] = STATE(1335),
    [sym__open_bracket2] = STATE(1334),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5679),
    [anon_sym_DASH] = ACTIONS(5681),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5689),
    [anon_sym_AMP] = ACTIONS(5691),
    [anon_sym_PIPE_PIPE] = ACTIONS(5693),
    [anon_sym_AMP_AMP] = ACTIONS(5695),
    [anon_sym_LT] = ACTIONS(5697),
    [anon_sym_LT_EQ] = ACTIONS(5699),
    [anon_sym_GT] = ACTIONS(5697),
    [anon_sym_GT_EQ] = ACTIONS(5699),
    [anon_sym_EQ_EQ] = ACTIONS(5699),
    [anon_sym_BANG_EQ] = ACTIONS(5699),
    [anon_sym_STAR] = ACTIONS(5701),
    [anon_sym_SLASH] = ACTIONS(5703),
    [anon_sym_STAR_STAR] = ACTIONS(5705),
    [anon_sym_CARET] = ACTIONS(5705),
    [aux_sym_binary_operator_token1] = ACTIONS(5707),
    [anon_sym_PIPE_GT] = ACTIONS(5707),
    [anon_sym_COLON] = ACTIONS(5709),
    [anon_sym_DOLLAR] = ACTIONS(5711),
    [anon_sym_AT] = ACTIONS(5711),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_else] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(5715),
    [sym__external_close_parenthesis] = ACTIONS(5345),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(5717),
    [sym__external_open_bracket2] = ACTIONS(5719),
    [sym__external_close_bracket2] = ACTIONS(5345),
  },
  [1215] = {
    [sym_call_arguments] = STATE(2651),
    [sym_subset_arguments] = STATE(2561),
    [sym_subset2_arguments] = STATE(2648),
    [sym__open_parenthesis] = STATE(1340),
    [sym__open_bracket] = STATE(1335),
    [sym__open_bracket2] = STATE(1334),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5675),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5677),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5679),
    [anon_sym_DASH] = ACTIONS(5681),
    [anon_sym_LT_DASH] = ACTIONS(5683),
    [anon_sym_LT_LT_DASH] = ACTIONS(5683),
    [anon_sym_COLON_EQ] = ACTIONS(5683),
    [anon_sym_DASH_GT] = ACTIONS(5685),
    [anon_sym_DASH_GT_GT] = ACTIONS(5687),
    [anon_sym_PIPE] = ACTIONS(5689),
    [anon_sym_AMP] = ACTIONS(5691),
    [anon_sym_PIPE_PIPE] = ACTIONS(5693),
    [anon_sym_AMP_AMP] = ACTIONS(5695),
    [anon_sym_LT] = ACTIONS(5697),
    [anon_sym_LT_EQ] = ACTIONS(5699),
    [anon_sym_GT] = ACTIONS(5697),
    [anon_sym_GT_EQ] = ACTIONS(5699),
    [anon_sym_EQ_EQ] = ACTIONS(5699),
    [anon_sym_BANG_EQ] = ACTIONS(5699),
    [anon_sym_STAR] = ACTIONS(5701),
    [anon_sym_SLASH] = ACTIONS(5703),
    [anon_sym_STAR_STAR] = ACTIONS(5705),
    [anon_sym_CARET] = ACTIONS(5705),
    [aux_sym_binary_operator_token1] = ACTIONS(5707),
    [anon_sym_PIPE_GT] = ACTIONS(5707),
    [anon_sym_COLON] = ACTIONS(5709),
    [anon_sym_DOLLAR] = ACTIONS(5711),
    [anon_sym_AT] = ACTIONS(5711),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_else] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(5715),
    [sym__external_close_parenthesis] = ACTIONS(5345),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(5717),
    [sym__external_open_bracket2] = ACTIONS(5719),
    [sym__external_close_bracket2] = ACTIONS(5345),
  },
  [1216] = {
    [sym_call_arguments] = STATE(2651),
    [sym_subset_arguments] = STATE(2561),
    [sym_subset2_arguments] = STATE(2648),
    [sym__open_parenthesis] = STATE(1340),
    [sym__open_bracket] = STATE(1335),
    [sym__open_bracket2] = STATE(1334),
    [sym_identifier] = ACTIONS(5343),
    [anon_sym_BSLASH] = ACTIONS(5341),
    [anon_sym_function] = ACTIONS(5343),
    [anon_sym_EQ] = ACTIONS(5675),
    [anon_sym_if] = ACTIONS(5343),
    [anon_sym_for] = ACTIONS(5343),
    [anon_sym_while] = ACTIONS(5343),
    [anon_sym_repeat] = ACTIONS(5343),
    [anon_sym_QMARK] = ACTIONS(5341),
    [anon_sym_TILDE] = ACTIONS(5677),
    [anon_sym_BANG] = ACTIONS(5343),
    [anon_sym_PLUS] = ACTIONS(5679),
    [anon_sym_DASH] = ACTIONS(5681),
    [anon_sym_LT_DASH] = ACTIONS(5683),
    [anon_sym_LT_LT_DASH] = ACTIONS(5683),
    [anon_sym_COLON_EQ] = ACTIONS(5683),
    [anon_sym_DASH_GT] = ACTIONS(5685),
    [anon_sym_DASH_GT_GT] = ACTIONS(5687),
    [anon_sym_PIPE] = ACTIONS(5689),
    [anon_sym_AMP] = ACTIONS(5691),
    [anon_sym_PIPE_PIPE] = ACTIONS(5693),
    [anon_sym_AMP_AMP] = ACTIONS(5695),
    [anon_sym_LT] = ACTIONS(5697),
    [anon_sym_LT_EQ] = ACTIONS(5699),
    [anon_sym_GT] = ACTIONS(5697),
    [anon_sym_GT_EQ] = ACTIONS(5699),
    [anon_sym_EQ_EQ] = ACTIONS(5699),
    [anon_sym_BANG_EQ] = ACTIONS(5699),
    [anon_sym_STAR] = ACTIONS(5701),
    [anon_sym_SLASH] = ACTIONS(5703),
    [anon_sym_STAR_STAR] = ACTIONS(5705),
    [anon_sym_CARET] = ACTIONS(5705),
    [aux_sym_binary_operator_token1] = ACTIONS(5707),
    [anon_sym_PIPE_GT] = ACTIONS(5707),
    [anon_sym_COLON] = ACTIONS(5709),
    [anon_sym_DOLLAR] = ACTIONS(5711),
    [anon_sym_AT] = ACTIONS(5711),
    [aux_sym__hex_literal_token1] = ACTIONS(5341),
    [sym__number_literal] = ACTIONS(5343),
    [anon_sym_SQUOTE] = ACTIONS(5341),
    [anon_sym_DQUOTE] = ACTIONS(5341),
    [sym_return] = ACTIONS(5343),
    [sym_next] = ACTIONS(5343),
    [sym_break] = ACTIONS(5343),
    [sym_true] = ACTIONS(5343),
    [sym_false] = ACTIONS(5343),
    [sym_null] = ACTIONS(5343),
    [sym_inf] = ACTIONS(5343),
    [sym_nan] = ACTIONS(5343),
    [anon_sym_NA] = ACTIONS(5343),
    [anon_sym_NA_integer_] = ACTIONS(5343),
    [anon_sym_NA_real_] = ACTIONS(5343),
    [anon_sym_NA_complex_] = ACTIONS(5343),
    [anon_sym_NA_character_] = ACTIONS(5343),
    [sym_dots] = ACTIONS(5343),
    [sym_dot_dot_i] = ACTIONS(5341),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5341),
    [sym__newline] = ACTIONS(5341),
    [sym__raw_string_literal] = ACTIONS(5341),
    [sym__external_else] = ACTIONS(5341),
    [sym__external_open_parenthesis] = ACTIONS(5715),
    [sym__external_close_parenthesis] = ACTIONS(5341),
    [sym__external_open_brace] = ACTIONS(5341),
    [sym__external_open_bracket] = ACTIONS(5717),
    [sym__external_open_bracket2] = ACTIONS(5719),
    [sym__external_close_bracket2] = ACTIONS(5341),
  },
  [1217] = {
    [sym_call_arguments] = STATE(2671),
    [sym_subset_arguments] = STATE(2663),
    [sym_subset2_arguments] = STATE(2661),
    [sym__open_parenthesis] = STATE(1555),
    [sym__open_bracket] = STATE(1551),
    [sym__open_bracket2] = STATE(1549),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(5921),
    [anon_sym_CARET] = ACTIONS(5921),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(5925),
    [anon_sym_DOLLAR] = ACTIONS(5927),
    [anon_sym_AT] = ACTIONS(5927),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5929),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5931),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(5933),
  },
  [1218] = {
    [sym_call_arguments] = STATE(2651),
    [sym_subset_arguments] = STATE(2561),
    [sym_subset2_arguments] = STATE(2648),
    [sym__open_parenthesis] = STATE(1340),
    [sym__open_bracket] = STATE(1335),
    [sym__open_bracket2] = STATE(1334),
    [sym_identifier] = ACTIONS(5339),
    [anon_sym_BSLASH] = ACTIONS(5337),
    [anon_sym_function] = ACTIONS(5339),
    [anon_sym_EQ] = ACTIONS(5675),
    [anon_sym_if] = ACTIONS(5339),
    [anon_sym_for] = ACTIONS(5339),
    [anon_sym_while] = ACTIONS(5339),
    [anon_sym_repeat] = ACTIONS(5339),
    [anon_sym_QMARK] = ACTIONS(5337),
    [anon_sym_TILDE] = ACTIONS(5677),
    [anon_sym_BANG] = ACTIONS(5339),
    [anon_sym_PLUS] = ACTIONS(5679),
    [anon_sym_DASH] = ACTIONS(5681),
    [anon_sym_LT_DASH] = ACTIONS(5683),
    [anon_sym_LT_LT_DASH] = ACTIONS(5683),
    [anon_sym_COLON_EQ] = ACTIONS(5683),
    [anon_sym_DASH_GT] = ACTIONS(5685),
    [anon_sym_DASH_GT_GT] = ACTIONS(5687),
    [anon_sym_PIPE] = ACTIONS(5689),
    [anon_sym_AMP] = ACTIONS(5691),
    [anon_sym_PIPE_PIPE] = ACTIONS(5693),
    [anon_sym_AMP_AMP] = ACTIONS(5695),
    [anon_sym_LT] = ACTIONS(5697),
    [anon_sym_LT_EQ] = ACTIONS(5699),
    [anon_sym_GT] = ACTIONS(5697),
    [anon_sym_GT_EQ] = ACTIONS(5699),
    [anon_sym_EQ_EQ] = ACTIONS(5699),
    [anon_sym_BANG_EQ] = ACTIONS(5699),
    [anon_sym_STAR] = ACTIONS(5701),
    [anon_sym_SLASH] = ACTIONS(5703),
    [anon_sym_STAR_STAR] = ACTIONS(5705),
    [anon_sym_CARET] = ACTIONS(5705),
    [aux_sym_binary_operator_token1] = ACTIONS(5707),
    [anon_sym_PIPE_GT] = ACTIONS(5707),
    [anon_sym_COLON] = ACTIONS(5709),
    [anon_sym_DOLLAR] = ACTIONS(5711),
    [anon_sym_AT] = ACTIONS(5711),
    [aux_sym__hex_literal_token1] = ACTIONS(5337),
    [sym__number_literal] = ACTIONS(5339),
    [anon_sym_SQUOTE] = ACTIONS(5337),
    [anon_sym_DQUOTE] = ACTIONS(5337),
    [sym_return] = ACTIONS(5339),
    [sym_next] = ACTIONS(5339),
    [sym_break] = ACTIONS(5339),
    [sym_true] = ACTIONS(5339),
    [sym_false] = ACTIONS(5339),
    [sym_null] = ACTIONS(5339),
    [sym_inf] = ACTIONS(5339),
    [sym_nan] = ACTIONS(5339),
    [anon_sym_NA] = ACTIONS(5339),
    [anon_sym_NA_integer_] = ACTIONS(5339),
    [anon_sym_NA_real_] = ACTIONS(5339),
    [anon_sym_NA_complex_] = ACTIONS(5339),
    [anon_sym_NA_character_] = ACTIONS(5339),
    [sym_dots] = ACTIONS(5339),
    [sym_dot_dot_i] = ACTIONS(5337),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5337),
    [sym__newline] = ACTIONS(5337),
    [sym__raw_string_literal] = ACTIONS(5337),
    [sym__external_else] = ACTIONS(5337),
    [sym__external_open_parenthesis] = ACTIONS(5715),
    [sym__external_close_parenthesis] = ACTIONS(5337),
    [sym__external_open_brace] = ACTIONS(5337),
    [sym__external_open_bracket] = ACTIONS(5717),
    [sym__external_open_bracket2] = ACTIONS(5719),
    [sym__external_close_bracket2] = ACTIONS(5337),
  },
  [1219] = {
    [sym_call_arguments] = STATE(2678),
    [sym_subset_arguments] = STATE(2679),
    [sym_subset2_arguments] = STATE(2683),
    [sym__open_parenthesis] = STATE(1443),
    [sym__open_bracket] = STATE(1442),
    [sym__open_bracket2] = STATE(1425),
    [ts_builtin_sym_end] = ACTIONS(5313),
    [sym_identifier] = ACTIONS(5311),
    [anon_sym_BSLASH] = ACTIONS(5313),
    [anon_sym_function] = ACTIONS(5311),
    [anon_sym_EQ] = ACTIONS(5609),
    [anon_sym_if] = ACTIONS(5311),
    [anon_sym_for] = ACTIONS(5311),
    [anon_sym_while] = ACTIONS(5311),
    [anon_sym_repeat] = ACTIONS(5311),
    [anon_sym_QMARK] = ACTIONS(6169),
    [anon_sym_TILDE] = ACTIONS(5611),
    [anon_sym_BANG] = ACTIONS(5311),
    [anon_sym_PLUS] = ACTIONS(5613),
    [anon_sym_DASH] = ACTIONS(5615),
    [anon_sym_LT_DASH] = ACTIONS(5617),
    [anon_sym_LT_LT_DASH] = ACTIONS(5617),
    [anon_sym_COLON_EQ] = ACTIONS(5617),
    [anon_sym_DASH_GT] = ACTIONS(5619),
    [anon_sym_DASH_GT_GT] = ACTIONS(5621),
    [anon_sym_PIPE] = ACTIONS(5623),
    [anon_sym_AMP] = ACTIONS(5625),
    [anon_sym_PIPE_PIPE] = ACTIONS(5627),
    [anon_sym_AMP_AMP] = ACTIONS(5629),
    [anon_sym_LT] = ACTIONS(5631),
    [anon_sym_LT_EQ] = ACTIONS(5633),
    [anon_sym_GT] = ACTIONS(5631),
    [anon_sym_GT_EQ] = ACTIONS(5633),
    [anon_sym_EQ_EQ] = ACTIONS(5633),
    [anon_sym_BANG_EQ] = ACTIONS(5633),
    [anon_sym_STAR] = ACTIONS(5635),
    [anon_sym_SLASH] = ACTIONS(5637),
    [anon_sym_STAR_STAR] = ACTIONS(5639),
    [anon_sym_CARET] = ACTIONS(5639),
    [aux_sym_binary_operator_token1] = ACTIONS(5641),
    [anon_sym_PIPE_GT] = ACTIONS(5641),
    [anon_sym_COLON] = ACTIONS(5643),
    [anon_sym_DOLLAR] = ACTIONS(5645),
    [anon_sym_AT] = ACTIONS(5645),
    [aux_sym__hex_literal_token1] = ACTIONS(5313),
    [sym__number_literal] = ACTIONS(5311),
    [anon_sym_SQUOTE] = ACTIONS(5313),
    [anon_sym_DQUOTE] = ACTIONS(5313),
    [sym_return] = ACTIONS(5311),
    [sym_next] = ACTIONS(5311),
    [sym_break] = ACTIONS(5311),
    [sym_true] = ACTIONS(5311),
    [sym_false] = ACTIONS(5311),
    [sym_null] = ACTIONS(5311),
    [sym_inf] = ACTIONS(5311),
    [sym_nan] = ACTIONS(5311),
    [anon_sym_NA] = ACTIONS(5311),
    [anon_sym_NA_integer_] = ACTIONS(5311),
    [anon_sym_NA_real_] = ACTIONS(5311),
    [anon_sym_NA_complex_] = ACTIONS(5311),
    [anon_sym_NA_character_] = ACTIONS(5311),
    [sym_dots] = ACTIONS(5311),
    [sym_dot_dot_i] = ACTIONS(5313),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5313),
    [sym__semicolon] = ACTIONS(5313),
    [sym__raw_string_literal] = ACTIONS(5313),
    [sym__external_else] = ACTIONS(5313),
    [sym__external_open_parenthesis] = ACTIONS(5649),
    [sym__external_close_parenthesis] = ACTIONS(5313),
    [sym__external_open_brace] = ACTIONS(5313),
    [sym__external_open_bracket] = ACTIONS(5651),
    [sym__external_open_bracket2] = ACTIONS(5653),
  },
  [1220] = {
    [sym_call_arguments] = STATE(2671),
    [sym_subset_arguments] = STATE(2663),
    [sym_subset2_arguments] = STATE(2661),
    [sym__open_parenthesis] = STATE(1555),
    [sym__open_bracket] = STATE(1551),
    [sym__open_bracket2] = STATE(1549),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(5921),
    [anon_sym_CARET] = ACTIONS(5921),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(5351),
    [anon_sym_DOLLAR] = ACTIONS(5927),
    [anon_sym_AT] = ACTIONS(5927),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5929),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5931),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(5933),
  },
  [1221] = {
    [sym_call_arguments] = STATE(2671),
    [sym_subset_arguments] = STATE(2663),
    [sym_subset2_arguments] = STATE(2661),
    [sym__open_parenthesis] = STATE(1555),
    [sym__open_bracket] = STATE(1551),
    [sym__open_bracket2] = STATE(1549),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(5921),
    [anon_sym_CARET] = ACTIONS(5921),
    [aux_sym_binary_operator_token1] = ACTIONS(5923),
    [anon_sym_PIPE_GT] = ACTIONS(5923),
    [anon_sym_COLON] = ACTIONS(5925),
    [anon_sym_DOLLAR] = ACTIONS(5927),
    [anon_sym_AT] = ACTIONS(5927),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5929),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5931),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(5933),
  },
  [1222] = {
    [sym_call_arguments] = STATE(2671),
    [sym_subset_arguments] = STATE(2663),
    [sym_subset2_arguments] = STATE(2661),
    [sym__open_parenthesis] = STATE(1555),
    [sym__open_bracket] = STATE(1551),
    [sym__open_bracket2] = STATE(1549),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5895),
    [anon_sym_DASH] = ACTIONS(5897),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5917),
    [anon_sym_SLASH] = ACTIONS(5919),
    [anon_sym_STAR_STAR] = ACTIONS(5921),
    [anon_sym_CARET] = ACTIONS(5921),
    [aux_sym_binary_operator_token1] = ACTIONS(5923),
    [anon_sym_PIPE_GT] = ACTIONS(5923),
    [anon_sym_COLON] = ACTIONS(5925),
    [anon_sym_DOLLAR] = ACTIONS(5927),
    [anon_sym_AT] = ACTIONS(5927),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5929),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5931),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(5933),
  },
  [1223] = {
    [sym_call_arguments] = STATE(2651),
    [sym_subset_arguments] = STATE(2561),
    [sym_subset2_arguments] = STATE(2648),
    [sym__open_parenthesis] = STATE(1340),
    [sym__open_bracket] = STATE(1335),
    [sym__open_bracket2] = STATE(1334),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(5333),
    [anon_sym_DASH] = ACTIONS(5335),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5335),
    [anon_sym_AMP] = ACTIONS(5335),
    [anon_sym_PIPE_PIPE] = ACTIONS(5333),
    [anon_sym_AMP_AMP] = ACTIONS(5333),
    [anon_sym_LT] = ACTIONS(5335),
    [anon_sym_LT_EQ] = ACTIONS(5333),
    [anon_sym_GT] = ACTIONS(5335),
    [anon_sym_GT_EQ] = ACTIONS(5333),
    [anon_sym_EQ_EQ] = ACTIONS(5333),
    [anon_sym_BANG_EQ] = ACTIONS(5333),
    [anon_sym_STAR] = ACTIONS(5335),
    [anon_sym_SLASH] = ACTIONS(5333),
    [anon_sym_STAR_STAR] = ACTIONS(5705),
    [anon_sym_CARET] = ACTIONS(5705),
    [aux_sym_binary_operator_token1] = ACTIONS(5333),
    [anon_sym_PIPE_GT] = ACTIONS(5333),
    [anon_sym_COLON] = ACTIONS(5335),
    [anon_sym_DOLLAR] = ACTIONS(5711),
    [anon_sym_AT] = ACTIONS(5711),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_else] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(5715),
    [sym__external_close_parenthesis] = ACTIONS(5333),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(5717),
    [sym__external_open_bracket2] = ACTIONS(5719),
    [sym__external_close_bracket2] = ACTIONS(5333),
  },
  [1224] = {
    [sym_call_arguments] = STATE(2651),
    [sym_subset_arguments] = STATE(2561),
    [sym_subset2_arguments] = STATE(2648),
    [sym__open_parenthesis] = STATE(1340),
    [sym__open_bracket] = STATE(1335),
    [sym__open_bracket2] = STATE(1334),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(5679),
    [anon_sym_DASH] = ACTIONS(5681),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5335),
    [anon_sym_AMP] = ACTIONS(5335),
    [anon_sym_PIPE_PIPE] = ACTIONS(5333),
    [anon_sym_AMP_AMP] = ACTIONS(5333),
    [anon_sym_LT] = ACTIONS(5697),
    [anon_sym_LT_EQ] = ACTIONS(5699),
    [anon_sym_GT] = ACTIONS(5697),
    [anon_sym_GT_EQ] = ACTIONS(5699),
    [anon_sym_EQ_EQ] = ACTIONS(5699),
    [anon_sym_BANG_EQ] = ACTIONS(5699),
    [anon_sym_STAR] = ACTIONS(5701),
    [anon_sym_SLASH] = ACTIONS(5703),
    [anon_sym_STAR_STAR] = ACTIONS(5705),
    [anon_sym_CARET] = ACTIONS(5705),
    [aux_sym_binary_operator_token1] = ACTIONS(5707),
    [anon_sym_PIPE_GT] = ACTIONS(5707),
    [anon_sym_COLON] = ACTIONS(5709),
    [anon_sym_DOLLAR] = ACTIONS(5711),
    [anon_sym_AT] = ACTIONS(5711),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_else] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(5715),
    [sym__external_close_parenthesis] = ACTIONS(5333),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(5717),
    [sym__external_open_bracket2] = ACTIONS(5719),
    [sym__external_close_bracket2] = ACTIONS(5333),
  },
  [1225] = {
    [sym_call_arguments] = STATE(2651),
    [sym_subset_arguments] = STATE(2561),
    [sym_subset2_arguments] = STATE(2648),
    [sym__open_parenthesis] = STATE(1340),
    [sym__open_bracket] = STATE(1335),
    [sym__open_bracket2] = STATE(1334),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(5679),
    [anon_sym_DASH] = ACTIONS(5681),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5689),
    [anon_sym_AMP] = ACTIONS(5691),
    [anon_sym_PIPE_PIPE] = ACTIONS(5693),
    [anon_sym_AMP_AMP] = ACTIONS(5695),
    [anon_sym_LT] = ACTIONS(5697),
    [anon_sym_LT_EQ] = ACTIONS(5699),
    [anon_sym_GT] = ACTIONS(5697),
    [anon_sym_GT_EQ] = ACTIONS(5699),
    [anon_sym_EQ_EQ] = ACTIONS(5699),
    [anon_sym_BANG_EQ] = ACTIONS(5699),
    [anon_sym_STAR] = ACTIONS(5701),
    [anon_sym_SLASH] = ACTIONS(5703),
    [anon_sym_STAR_STAR] = ACTIONS(5705),
    [anon_sym_CARET] = ACTIONS(5705),
    [aux_sym_binary_operator_token1] = ACTIONS(5707),
    [anon_sym_PIPE_GT] = ACTIONS(5707),
    [anon_sym_COLON] = ACTIONS(5709),
    [anon_sym_DOLLAR] = ACTIONS(5711),
    [anon_sym_AT] = ACTIONS(5711),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_else] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(5715),
    [sym__external_close_parenthesis] = ACTIONS(5333),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(5717),
    [sym__external_open_bracket2] = ACTIONS(5719),
    [sym__external_close_bracket2] = ACTIONS(5333),
  },
  [1226] = {
    [sym_call_arguments] = STATE(2671),
    [sym_subset_arguments] = STATE(2663),
    [sym_subset2_arguments] = STATE(2661),
    [sym__open_parenthesis] = STATE(1555),
    [sym__open_bracket] = STATE(1551),
    [sym__open_bracket2] = STATE(1549),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5895),
    [anon_sym_DASH] = ACTIONS(5897),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5913),
    [anon_sym_LT_EQ] = ACTIONS(5915),
    [anon_sym_GT] = ACTIONS(5913),
    [anon_sym_GT_EQ] = ACTIONS(5915),
    [anon_sym_EQ_EQ] = ACTIONS(5915),
    [anon_sym_BANG_EQ] = ACTIONS(5915),
    [anon_sym_STAR] = ACTIONS(5917),
    [anon_sym_SLASH] = ACTIONS(5919),
    [anon_sym_STAR_STAR] = ACTIONS(5921),
    [anon_sym_CARET] = ACTIONS(5921),
    [aux_sym_binary_operator_token1] = ACTIONS(5923),
    [anon_sym_PIPE_GT] = ACTIONS(5923),
    [anon_sym_COLON] = ACTIONS(5925),
    [anon_sym_DOLLAR] = ACTIONS(5927),
    [anon_sym_AT] = ACTIONS(5927),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5929),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5931),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(5933),
  },
  [1227] = {
    [sym_call_arguments] = STATE(2651),
    [sym_subset_arguments] = STATE(2561),
    [sym_subset2_arguments] = STATE(2648),
    [sym__open_parenthesis] = STATE(1340),
    [sym__open_bracket] = STATE(1335),
    [sym__open_bracket2] = STATE(1334),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5675),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5677),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(5679),
    [anon_sym_DASH] = ACTIONS(5681),
    [anon_sym_LT_DASH] = ACTIONS(5683),
    [anon_sym_LT_LT_DASH] = ACTIONS(5683),
    [anon_sym_COLON_EQ] = ACTIONS(5683),
    [anon_sym_DASH_GT] = ACTIONS(5685),
    [anon_sym_DASH_GT_GT] = ACTIONS(5687),
    [anon_sym_PIPE] = ACTIONS(5689),
    [anon_sym_AMP] = ACTIONS(5691),
    [anon_sym_PIPE_PIPE] = ACTIONS(5693),
    [anon_sym_AMP_AMP] = ACTIONS(5695),
    [anon_sym_LT] = ACTIONS(5697),
    [anon_sym_LT_EQ] = ACTIONS(5699),
    [anon_sym_GT] = ACTIONS(5697),
    [anon_sym_GT_EQ] = ACTIONS(5699),
    [anon_sym_EQ_EQ] = ACTIONS(5699),
    [anon_sym_BANG_EQ] = ACTIONS(5699),
    [anon_sym_STAR] = ACTIONS(5701),
    [anon_sym_SLASH] = ACTIONS(5703),
    [anon_sym_STAR_STAR] = ACTIONS(5705),
    [anon_sym_CARET] = ACTIONS(5705),
    [aux_sym_binary_operator_token1] = ACTIONS(5707),
    [anon_sym_PIPE_GT] = ACTIONS(5707),
    [anon_sym_COLON] = ACTIONS(5709),
    [anon_sym_DOLLAR] = ACTIONS(5711),
    [anon_sym_AT] = ACTIONS(5711),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_else] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(5715),
    [sym__external_close_parenthesis] = ACTIONS(5333),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(5717),
    [sym__external_open_bracket2] = ACTIONS(5719),
    [sym__external_close_bracket2] = ACTIONS(5333),
  },
  [1228] = {
    [sym_call_arguments] = STATE(2671),
    [sym_subset_arguments] = STATE(2663),
    [sym_subset2_arguments] = STATE(2661),
    [sym__open_parenthesis] = STATE(1555),
    [sym__open_bracket] = STATE(1551),
    [sym__open_bracket2] = STATE(1549),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5895),
    [anon_sym_DASH] = ACTIONS(5897),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5907),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5911),
    [anon_sym_LT] = ACTIONS(5913),
    [anon_sym_LT_EQ] = ACTIONS(5915),
    [anon_sym_GT] = ACTIONS(5913),
    [anon_sym_GT_EQ] = ACTIONS(5915),
    [anon_sym_EQ_EQ] = ACTIONS(5915),
    [anon_sym_BANG_EQ] = ACTIONS(5915),
    [anon_sym_STAR] = ACTIONS(5917),
    [anon_sym_SLASH] = ACTIONS(5919),
    [anon_sym_STAR_STAR] = ACTIONS(5921),
    [anon_sym_CARET] = ACTIONS(5921),
    [aux_sym_binary_operator_token1] = ACTIONS(5923),
    [anon_sym_PIPE_GT] = ACTIONS(5923),
    [anon_sym_COLON] = ACTIONS(5925),
    [anon_sym_DOLLAR] = ACTIONS(5927),
    [anon_sym_AT] = ACTIONS(5927),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5929),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5931),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(5933),
  },
  [1229] = {
    [sym_call_arguments] = STATE(2651),
    [sym_subset_arguments] = STATE(2561),
    [sym_subset2_arguments] = STATE(2648),
    [sym__open_parenthesis] = STATE(1340),
    [sym__open_bracket] = STATE(1335),
    [sym__open_bracket2] = STATE(1334),
    [sym_identifier] = ACTIONS(5331),
    [anon_sym_BSLASH] = ACTIONS(5329),
    [anon_sym_function] = ACTIONS(5331),
    [anon_sym_EQ] = ACTIONS(5675),
    [anon_sym_if] = ACTIONS(5331),
    [anon_sym_for] = ACTIONS(5331),
    [anon_sym_while] = ACTIONS(5331),
    [anon_sym_repeat] = ACTIONS(5331),
    [anon_sym_QMARK] = ACTIONS(5329),
    [anon_sym_TILDE] = ACTIONS(5677),
    [anon_sym_BANG] = ACTIONS(5331),
    [anon_sym_PLUS] = ACTIONS(5679),
    [anon_sym_DASH] = ACTIONS(5681),
    [anon_sym_LT_DASH] = ACTIONS(5683),
    [anon_sym_LT_LT_DASH] = ACTIONS(5683),
    [anon_sym_COLON_EQ] = ACTIONS(5683),
    [anon_sym_DASH_GT] = ACTIONS(5685),
    [anon_sym_DASH_GT_GT] = ACTIONS(5687),
    [anon_sym_PIPE] = ACTIONS(5689),
    [anon_sym_AMP] = ACTIONS(5691),
    [anon_sym_PIPE_PIPE] = ACTIONS(5693),
    [anon_sym_AMP_AMP] = ACTIONS(5695),
    [anon_sym_LT] = ACTIONS(5697),
    [anon_sym_LT_EQ] = ACTIONS(5699),
    [anon_sym_GT] = ACTIONS(5697),
    [anon_sym_GT_EQ] = ACTIONS(5699),
    [anon_sym_EQ_EQ] = ACTIONS(5699),
    [anon_sym_BANG_EQ] = ACTIONS(5699),
    [anon_sym_STAR] = ACTIONS(5701),
    [anon_sym_SLASH] = ACTIONS(5703),
    [anon_sym_STAR_STAR] = ACTIONS(5705),
    [anon_sym_CARET] = ACTIONS(5705),
    [aux_sym_binary_operator_token1] = ACTIONS(5707),
    [anon_sym_PIPE_GT] = ACTIONS(5707),
    [anon_sym_COLON] = ACTIONS(5709),
    [anon_sym_DOLLAR] = ACTIONS(5711),
    [anon_sym_AT] = ACTIONS(5711),
    [aux_sym__hex_literal_token1] = ACTIONS(5329),
    [sym__number_literal] = ACTIONS(5331),
    [anon_sym_SQUOTE] = ACTIONS(5329),
    [anon_sym_DQUOTE] = ACTIONS(5329),
    [sym_return] = ACTIONS(5331),
    [sym_next] = ACTIONS(5331),
    [sym_break] = ACTIONS(5331),
    [sym_true] = ACTIONS(5331),
    [sym_false] = ACTIONS(5331),
    [sym_null] = ACTIONS(5331),
    [sym_inf] = ACTIONS(5331),
    [sym_nan] = ACTIONS(5331),
    [anon_sym_NA] = ACTIONS(5331),
    [anon_sym_NA_integer_] = ACTIONS(5331),
    [anon_sym_NA_real_] = ACTIONS(5331),
    [anon_sym_NA_complex_] = ACTIONS(5331),
    [anon_sym_NA_character_] = ACTIONS(5331),
    [sym_dots] = ACTIONS(5331),
    [sym_dot_dot_i] = ACTIONS(5329),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5329),
    [sym__newline] = ACTIONS(5329),
    [sym__raw_string_literal] = ACTIONS(5329),
    [sym__external_else] = ACTIONS(5329),
    [sym__external_open_parenthesis] = ACTIONS(5715),
    [sym__external_close_parenthesis] = ACTIONS(5329),
    [sym__external_open_brace] = ACTIONS(5329),
    [sym__external_open_bracket] = ACTIONS(5717),
    [sym__external_open_bracket2] = ACTIONS(5719),
    [sym__external_close_bracket2] = ACTIONS(5329),
  },
  [1230] = {
    [sym_call_arguments] = STATE(2671),
    [sym_subset_arguments] = STATE(2663),
    [sym_subset2_arguments] = STATE(2661),
    [sym__open_parenthesis] = STATE(1555),
    [sym__open_bracket] = STATE(1551),
    [sym__open_bracket2] = STATE(1549),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5893),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5895),
    [anon_sym_DASH] = ACTIONS(5897),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5905),
    [anon_sym_AMP] = ACTIONS(5907),
    [anon_sym_PIPE_PIPE] = ACTIONS(5909),
    [anon_sym_AMP_AMP] = ACTIONS(5911),
    [anon_sym_LT] = ACTIONS(5913),
    [anon_sym_LT_EQ] = ACTIONS(5915),
    [anon_sym_GT] = ACTIONS(5913),
    [anon_sym_GT_EQ] = ACTIONS(5915),
    [anon_sym_EQ_EQ] = ACTIONS(5915),
    [anon_sym_BANG_EQ] = ACTIONS(5915),
    [anon_sym_STAR] = ACTIONS(5917),
    [anon_sym_SLASH] = ACTIONS(5919),
    [anon_sym_STAR_STAR] = ACTIONS(5921),
    [anon_sym_CARET] = ACTIONS(5921),
    [aux_sym_binary_operator_token1] = ACTIONS(5923),
    [anon_sym_PIPE_GT] = ACTIONS(5923),
    [anon_sym_COLON] = ACTIONS(5925),
    [anon_sym_DOLLAR] = ACTIONS(5927),
    [anon_sym_AT] = ACTIONS(5927),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5929),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5931),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(5933),
  },
  [1231] = {
    [sym_call_arguments] = STATE(2671),
    [sym_subset_arguments] = STATE(2663),
    [sym_subset2_arguments] = STATE(2661),
    [sym__open_parenthesis] = STATE(1555),
    [sym__open_bracket] = STATE(1551),
    [sym__open_bracket2] = STATE(1549),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5889),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5893),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5895),
    [anon_sym_DASH] = ACTIONS(5897),
    [anon_sym_LT_DASH] = ACTIONS(5899),
    [anon_sym_LT_LT_DASH] = ACTIONS(5899),
    [anon_sym_COLON_EQ] = ACTIONS(5899),
    [anon_sym_DASH_GT] = ACTIONS(5901),
    [anon_sym_DASH_GT_GT] = ACTIONS(5903),
    [anon_sym_PIPE] = ACTIONS(5905),
    [anon_sym_AMP] = ACTIONS(5907),
    [anon_sym_PIPE_PIPE] = ACTIONS(5909),
    [anon_sym_AMP_AMP] = ACTIONS(5911),
    [anon_sym_LT] = ACTIONS(5913),
    [anon_sym_LT_EQ] = ACTIONS(5915),
    [anon_sym_GT] = ACTIONS(5913),
    [anon_sym_GT_EQ] = ACTIONS(5915),
    [anon_sym_EQ_EQ] = ACTIONS(5915),
    [anon_sym_BANG_EQ] = ACTIONS(5915),
    [anon_sym_STAR] = ACTIONS(5917),
    [anon_sym_SLASH] = ACTIONS(5919),
    [anon_sym_STAR_STAR] = ACTIONS(5921),
    [anon_sym_CARET] = ACTIONS(5921),
    [aux_sym_binary_operator_token1] = ACTIONS(5923),
    [anon_sym_PIPE_GT] = ACTIONS(5923),
    [anon_sym_COLON] = ACTIONS(5925),
    [anon_sym_DOLLAR] = ACTIONS(5927),
    [anon_sym_AT] = ACTIONS(5927),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5929),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5931),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(5933),
  },
  [1232] = {
    [sym_call_arguments] = STATE(2671),
    [sym_subset_arguments] = STATE(2663),
    [sym_subset2_arguments] = STATE(2661),
    [sym__open_parenthesis] = STATE(1555),
    [sym__open_bracket] = STATE(1551),
    [sym__open_bracket2] = STATE(1549),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5917),
    [anon_sym_SLASH] = ACTIONS(5919),
    [anon_sym_STAR_STAR] = ACTIONS(5921),
    [anon_sym_CARET] = ACTIONS(5921),
    [aux_sym_binary_operator_token1] = ACTIONS(5923),
    [anon_sym_PIPE_GT] = ACTIONS(5923),
    [anon_sym_COLON] = ACTIONS(5925),
    [anon_sym_DOLLAR] = ACTIONS(5927),
    [anon_sym_AT] = ACTIONS(5927),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5929),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5931),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(5933),
  },
  [1233] = {
    [sym_call_arguments] = STATE(2671),
    [sym_subset_arguments] = STATE(2663),
    [sym_subset2_arguments] = STATE(2661),
    [sym__open_parenthesis] = STATE(1555),
    [sym__open_bracket] = STATE(1551),
    [sym__open_bracket2] = STATE(1549),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5895),
    [anon_sym_DASH] = ACTIONS(5897),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5905),
    [anon_sym_AMP] = ACTIONS(5907),
    [anon_sym_PIPE_PIPE] = ACTIONS(5909),
    [anon_sym_AMP_AMP] = ACTIONS(5911),
    [anon_sym_LT] = ACTIONS(5913),
    [anon_sym_LT_EQ] = ACTIONS(5915),
    [anon_sym_GT] = ACTIONS(5913),
    [anon_sym_GT_EQ] = ACTIONS(5915),
    [anon_sym_EQ_EQ] = ACTIONS(5915),
    [anon_sym_BANG_EQ] = ACTIONS(5915),
    [anon_sym_STAR] = ACTIONS(5917),
    [anon_sym_SLASH] = ACTIONS(5919),
    [anon_sym_STAR_STAR] = ACTIONS(5921),
    [anon_sym_CARET] = ACTIONS(5921),
    [aux_sym_binary_operator_token1] = ACTIONS(5923),
    [anon_sym_PIPE_GT] = ACTIONS(5923),
    [anon_sym_COLON] = ACTIONS(5925),
    [anon_sym_DOLLAR] = ACTIONS(5927),
    [anon_sym_AT] = ACTIONS(5927),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5929),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5931),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(5933),
  },
  [1234] = {
    [sym_call_arguments] = STATE(2671),
    [sym_subset_arguments] = STATE(2663),
    [sym_subset2_arguments] = STATE(2661),
    [sym__open_parenthesis] = STATE(1555),
    [sym__open_bracket] = STATE(1551),
    [sym__open_bracket2] = STATE(1549),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5889),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5893),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5895),
    [anon_sym_DASH] = ACTIONS(5897),
    [anon_sym_LT_DASH] = ACTIONS(5899),
    [anon_sym_LT_LT_DASH] = ACTIONS(5899),
    [anon_sym_COLON_EQ] = ACTIONS(5899),
    [anon_sym_DASH_GT] = ACTIONS(5901),
    [anon_sym_DASH_GT_GT] = ACTIONS(5903),
    [anon_sym_PIPE] = ACTIONS(5905),
    [anon_sym_AMP] = ACTIONS(5907),
    [anon_sym_PIPE_PIPE] = ACTIONS(5909),
    [anon_sym_AMP_AMP] = ACTIONS(5911),
    [anon_sym_LT] = ACTIONS(5913),
    [anon_sym_LT_EQ] = ACTIONS(5915),
    [anon_sym_GT] = ACTIONS(5913),
    [anon_sym_GT_EQ] = ACTIONS(5915),
    [anon_sym_EQ_EQ] = ACTIONS(5915),
    [anon_sym_BANG_EQ] = ACTIONS(5915),
    [anon_sym_STAR] = ACTIONS(5917),
    [anon_sym_SLASH] = ACTIONS(5919),
    [anon_sym_STAR_STAR] = ACTIONS(5921),
    [anon_sym_CARET] = ACTIONS(5921),
    [aux_sym_binary_operator_token1] = ACTIONS(5923),
    [anon_sym_PIPE_GT] = ACTIONS(5923),
    [anon_sym_COLON] = ACTIONS(5925),
    [anon_sym_DOLLAR] = ACTIONS(5927),
    [anon_sym_AT] = ACTIONS(5927),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5929),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5931),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(5933),
  },
  [1235] = {
    [sym_call_arguments] = STATE(2671),
    [sym_subset_arguments] = STATE(2663),
    [sym_subset2_arguments] = STATE(2661),
    [sym__open_parenthesis] = STATE(1555),
    [sym__open_bracket] = STATE(1551),
    [sym__open_bracket2] = STATE(1549),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5889),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5893),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5895),
    [anon_sym_DASH] = ACTIONS(5897),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5901),
    [anon_sym_DASH_GT_GT] = ACTIONS(5903),
    [anon_sym_PIPE] = ACTIONS(5905),
    [anon_sym_AMP] = ACTIONS(5907),
    [anon_sym_PIPE_PIPE] = ACTIONS(5909),
    [anon_sym_AMP_AMP] = ACTIONS(5911),
    [anon_sym_LT] = ACTIONS(5913),
    [anon_sym_LT_EQ] = ACTIONS(5915),
    [anon_sym_GT] = ACTIONS(5913),
    [anon_sym_GT_EQ] = ACTIONS(5915),
    [anon_sym_EQ_EQ] = ACTIONS(5915),
    [anon_sym_BANG_EQ] = ACTIONS(5915),
    [anon_sym_STAR] = ACTIONS(5917),
    [anon_sym_SLASH] = ACTIONS(5919),
    [anon_sym_STAR_STAR] = ACTIONS(5921),
    [anon_sym_CARET] = ACTIONS(5921),
    [aux_sym_binary_operator_token1] = ACTIONS(5923),
    [anon_sym_PIPE_GT] = ACTIONS(5923),
    [anon_sym_COLON] = ACTIONS(5925),
    [anon_sym_DOLLAR] = ACTIONS(5927),
    [anon_sym_AT] = ACTIONS(5927),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5929),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5931),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(5933),
  },
  [1236] = {
    [sym_call_arguments] = STATE(2671),
    [sym_subset_arguments] = STATE(2663),
    [sym_subset2_arguments] = STATE(2661),
    [sym__open_parenthesis] = STATE(1555),
    [sym__open_bracket] = STATE(1551),
    [sym__open_bracket2] = STATE(1549),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5345),
    [anon_sym_DASH] = ACTIONS(5347),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5347),
    [anon_sym_AMP] = ACTIONS(5347),
    [anon_sym_PIPE_PIPE] = ACTIONS(5345),
    [anon_sym_AMP_AMP] = ACTIONS(5345),
    [anon_sym_LT] = ACTIONS(5347),
    [anon_sym_LT_EQ] = ACTIONS(5345),
    [anon_sym_GT] = ACTIONS(5347),
    [anon_sym_GT_EQ] = ACTIONS(5345),
    [anon_sym_EQ_EQ] = ACTIONS(5345),
    [anon_sym_BANG_EQ] = ACTIONS(5345),
    [anon_sym_STAR] = ACTIONS(5347),
    [anon_sym_SLASH] = ACTIONS(5345),
    [anon_sym_STAR_STAR] = ACTIONS(5921),
    [anon_sym_CARET] = ACTIONS(5921),
    [aux_sym_binary_operator_token1] = ACTIONS(5345),
    [anon_sym_PIPE_GT] = ACTIONS(5345),
    [anon_sym_COLON] = ACTIONS(5347),
    [anon_sym_DOLLAR] = ACTIONS(5927),
    [anon_sym_AT] = ACTIONS(5927),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__semicolon] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(5929),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_close_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(5931),
    [sym__external_close_bracket] = ACTIONS(5345),
    [sym__external_open_bracket2] = ACTIONS(5933),
  },
  [1237] = {
    [sym_call_arguments] = STATE(2671),
    [sym_subset_arguments] = STATE(2663),
    [sym_subset2_arguments] = STATE(2661),
    [sym__open_parenthesis] = STATE(1555),
    [sym__open_bracket] = STATE(1551),
    [sym__open_bracket2] = STATE(1549),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5895),
    [anon_sym_DASH] = ACTIONS(5897),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5347),
    [anon_sym_AMP] = ACTIONS(5347),
    [anon_sym_PIPE_PIPE] = ACTIONS(5345),
    [anon_sym_AMP_AMP] = ACTIONS(5345),
    [anon_sym_LT] = ACTIONS(5913),
    [anon_sym_LT_EQ] = ACTIONS(5915),
    [anon_sym_GT] = ACTIONS(5913),
    [anon_sym_GT_EQ] = ACTIONS(5915),
    [anon_sym_EQ_EQ] = ACTIONS(5915),
    [anon_sym_BANG_EQ] = ACTIONS(5915),
    [anon_sym_STAR] = ACTIONS(5917),
    [anon_sym_SLASH] = ACTIONS(5919),
    [anon_sym_STAR_STAR] = ACTIONS(5921),
    [anon_sym_CARET] = ACTIONS(5921),
    [aux_sym_binary_operator_token1] = ACTIONS(5923),
    [anon_sym_PIPE_GT] = ACTIONS(5923),
    [anon_sym_COLON] = ACTIONS(5925),
    [anon_sym_DOLLAR] = ACTIONS(5927),
    [anon_sym_AT] = ACTIONS(5927),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__semicolon] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(5929),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_close_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(5931),
    [sym__external_close_bracket] = ACTIONS(5345),
    [sym__external_open_bracket2] = ACTIONS(5933),
  },
  [1238] = {
    [sym_call_arguments] = STATE(2671),
    [sym_subset_arguments] = STATE(2663),
    [sym_subset2_arguments] = STATE(2661),
    [sym__open_parenthesis] = STATE(1555),
    [sym__open_bracket] = STATE(1551),
    [sym__open_bracket2] = STATE(1549),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5895),
    [anon_sym_DASH] = ACTIONS(5897),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5905),
    [anon_sym_AMP] = ACTIONS(5907),
    [anon_sym_PIPE_PIPE] = ACTIONS(5909),
    [anon_sym_AMP_AMP] = ACTIONS(5911),
    [anon_sym_LT] = ACTIONS(5913),
    [anon_sym_LT_EQ] = ACTIONS(5915),
    [anon_sym_GT] = ACTIONS(5913),
    [anon_sym_GT_EQ] = ACTIONS(5915),
    [anon_sym_EQ_EQ] = ACTIONS(5915),
    [anon_sym_BANG_EQ] = ACTIONS(5915),
    [anon_sym_STAR] = ACTIONS(5917),
    [anon_sym_SLASH] = ACTIONS(5919),
    [anon_sym_STAR_STAR] = ACTIONS(5921),
    [anon_sym_CARET] = ACTIONS(5921),
    [aux_sym_binary_operator_token1] = ACTIONS(5923),
    [anon_sym_PIPE_GT] = ACTIONS(5923),
    [anon_sym_COLON] = ACTIONS(5925),
    [anon_sym_DOLLAR] = ACTIONS(5927),
    [anon_sym_AT] = ACTIONS(5927),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__semicolon] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(5929),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_close_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(5931),
    [sym__external_close_bracket] = ACTIONS(5345),
    [sym__external_open_bracket2] = ACTIONS(5933),
  },
  [1239] = {
    [sym_call_arguments] = STATE(2671),
    [sym_subset_arguments] = STATE(2663),
    [sym_subset2_arguments] = STATE(2661),
    [sym__open_parenthesis] = STATE(1555),
    [sym__open_bracket] = STATE(1551),
    [sym__open_bracket2] = STATE(1549),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5889),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5893),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5895),
    [anon_sym_DASH] = ACTIONS(5897),
    [anon_sym_LT_DASH] = ACTIONS(5899),
    [anon_sym_LT_LT_DASH] = ACTIONS(5899),
    [anon_sym_COLON_EQ] = ACTIONS(5899),
    [anon_sym_DASH_GT] = ACTIONS(5901),
    [anon_sym_DASH_GT_GT] = ACTIONS(5903),
    [anon_sym_PIPE] = ACTIONS(5905),
    [anon_sym_AMP] = ACTIONS(5907),
    [anon_sym_PIPE_PIPE] = ACTIONS(5909),
    [anon_sym_AMP_AMP] = ACTIONS(5911),
    [anon_sym_LT] = ACTIONS(5913),
    [anon_sym_LT_EQ] = ACTIONS(5915),
    [anon_sym_GT] = ACTIONS(5913),
    [anon_sym_GT_EQ] = ACTIONS(5915),
    [anon_sym_EQ_EQ] = ACTIONS(5915),
    [anon_sym_BANG_EQ] = ACTIONS(5915),
    [anon_sym_STAR] = ACTIONS(5917),
    [anon_sym_SLASH] = ACTIONS(5919),
    [anon_sym_STAR_STAR] = ACTIONS(5921),
    [anon_sym_CARET] = ACTIONS(5921),
    [aux_sym_binary_operator_token1] = ACTIONS(5923),
    [anon_sym_PIPE_GT] = ACTIONS(5923),
    [anon_sym_COLON] = ACTIONS(5925),
    [anon_sym_DOLLAR] = ACTIONS(5927),
    [anon_sym_AT] = ACTIONS(5927),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__semicolon] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(5929),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_close_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(5931),
    [sym__external_close_bracket] = ACTIONS(5345),
    [sym__external_open_bracket2] = ACTIONS(5933),
  },
  [1240] = {
    [sym_call_arguments] = STATE(2671),
    [sym_subset_arguments] = STATE(2663),
    [sym_subset2_arguments] = STATE(2661),
    [sym__open_parenthesis] = STATE(1555),
    [sym__open_bracket] = STATE(1551),
    [sym__open_bracket2] = STATE(1549),
    [sym_identifier] = ACTIONS(5343),
    [anon_sym_BSLASH] = ACTIONS(5341),
    [anon_sym_function] = ACTIONS(5343),
    [anon_sym_EQ] = ACTIONS(5889),
    [anon_sym_if] = ACTIONS(5343),
    [anon_sym_for] = ACTIONS(5343),
    [anon_sym_while] = ACTIONS(5343),
    [anon_sym_repeat] = ACTIONS(5343),
    [anon_sym_QMARK] = ACTIONS(5341),
    [anon_sym_TILDE] = ACTIONS(5893),
    [anon_sym_BANG] = ACTIONS(5343),
    [anon_sym_PLUS] = ACTIONS(5895),
    [anon_sym_DASH] = ACTIONS(5897),
    [anon_sym_LT_DASH] = ACTIONS(5899),
    [anon_sym_LT_LT_DASH] = ACTIONS(5899),
    [anon_sym_COLON_EQ] = ACTIONS(5899),
    [anon_sym_DASH_GT] = ACTIONS(5901),
    [anon_sym_DASH_GT_GT] = ACTIONS(5903),
    [anon_sym_PIPE] = ACTIONS(5905),
    [anon_sym_AMP] = ACTIONS(5907),
    [anon_sym_PIPE_PIPE] = ACTIONS(5909),
    [anon_sym_AMP_AMP] = ACTIONS(5911),
    [anon_sym_LT] = ACTIONS(5913),
    [anon_sym_LT_EQ] = ACTIONS(5915),
    [anon_sym_GT] = ACTIONS(5913),
    [anon_sym_GT_EQ] = ACTIONS(5915),
    [anon_sym_EQ_EQ] = ACTIONS(5915),
    [anon_sym_BANG_EQ] = ACTIONS(5915),
    [anon_sym_STAR] = ACTIONS(5917),
    [anon_sym_SLASH] = ACTIONS(5919),
    [anon_sym_STAR_STAR] = ACTIONS(5921),
    [anon_sym_CARET] = ACTIONS(5921),
    [aux_sym_binary_operator_token1] = ACTIONS(5923),
    [anon_sym_PIPE_GT] = ACTIONS(5923),
    [anon_sym_COLON] = ACTIONS(5925),
    [anon_sym_DOLLAR] = ACTIONS(5927),
    [anon_sym_AT] = ACTIONS(5927),
    [aux_sym__hex_literal_token1] = ACTIONS(5341),
    [sym__number_literal] = ACTIONS(5343),
    [anon_sym_SQUOTE] = ACTIONS(5341),
    [anon_sym_DQUOTE] = ACTIONS(5341),
    [sym_return] = ACTIONS(5343),
    [sym_next] = ACTIONS(5343),
    [sym_break] = ACTIONS(5343),
    [sym_true] = ACTIONS(5343),
    [sym_false] = ACTIONS(5343),
    [sym_null] = ACTIONS(5343),
    [sym_inf] = ACTIONS(5343),
    [sym_nan] = ACTIONS(5343),
    [anon_sym_NA] = ACTIONS(5343),
    [anon_sym_NA_integer_] = ACTIONS(5343),
    [anon_sym_NA_real_] = ACTIONS(5343),
    [anon_sym_NA_complex_] = ACTIONS(5343),
    [anon_sym_NA_character_] = ACTIONS(5343),
    [sym_dots] = ACTIONS(5343),
    [sym_dot_dot_i] = ACTIONS(5341),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5341),
    [sym__newline] = ACTIONS(5341),
    [sym__semicolon] = ACTIONS(5341),
    [sym__raw_string_literal] = ACTIONS(5341),
    [sym__external_open_parenthesis] = ACTIONS(5929),
    [sym__external_open_brace] = ACTIONS(5341),
    [sym__external_close_brace] = ACTIONS(5341),
    [sym__external_open_bracket] = ACTIONS(5931),
    [sym__external_close_bracket] = ACTIONS(5341),
    [sym__external_open_bracket2] = ACTIONS(5933),
  },
  [1241] = {
    [sym_call_arguments] = STATE(2671),
    [sym_subset_arguments] = STATE(2663),
    [sym_subset2_arguments] = STATE(2661),
    [sym__open_parenthesis] = STATE(1555),
    [sym__open_bracket] = STATE(1551),
    [sym__open_bracket2] = STATE(1549),
    [sym_identifier] = ACTIONS(5339),
    [anon_sym_BSLASH] = ACTIONS(5337),
    [anon_sym_function] = ACTIONS(5339),
    [anon_sym_EQ] = ACTIONS(5889),
    [anon_sym_if] = ACTIONS(5339),
    [anon_sym_for] = ACTIONS(5339),
    [anon_sym_while] = ACTIONS(5339),
    [anon_sym_repeat] = ACTIONS(5339),
    [anon_sym_QMARK] = ACTIONS(5337),
    [anon_sym_TILDE] = ACTIONS(5893),
    [anon_sym_BANG] = ACTIONS(5339),
    [anon_sym_PLUS] = ACTIONS(5895),
    [anon_sym_DASH] = ACTIONS(5897),
    [anon_sym_LT_DASH] = ACTIONS(5899),
    [anon_sym_LT_LT_DASH] = ACTIONS(5899),
    [anon_sym_COLON_EQ] = ACTIONS(5899),
    [anon_sym_DASH_GT] = ACTIONS(5901),
    [anon_sym_DASH_GT_GT] = ACTIONS(5903),
    [anon_sym_PIPE] = ACTIONS(5905),
    [anon_sym_AMP] = ACTIONS(5907),
    [anon_sym_PIPE_PIPE] = ACTIONS(5909),
    [anon_sym_AMP_AMP] = ACTIONS(5911),
    [anon_sym_LT] = ACTIONS(5913),
    [anon_sym_LT_EQ] = ACTIONS(5915),
    [anon_sym_GT] = ACTIONS(5913),
    [anon_sym_GT_EQ] = ACTIONS(5915),
    [anon_sym_EQ_EQ] = ACTIONS(5915),
    [anon_sym_BANG_EQ] = ACTIONS(5915),
    [anon_sym_STAR] = ACTIONS(5917),
    [anon_sym_SLASH] = ACTIONS(5919),
    [anon_sym_STAR_STAR] = ACTIONS(5921),
    [anon_sym_CARET] = ACTIONS(5921),
    [aux_sym_binary_operator_token1] = ACTIONS(5923),
    [anon_sym_PIPE_GT] = ACTIONS(5923),
    [anon_sym_COLON] = ACTIONS(5925),
    [anon_sym_DOLLAR] = ACTIONS(5927),
    [anon_sym_AT] = ACTIONS(5927),
    [aux_sym__hex_literal_token1] = ACTIONS(5337),
    [sym__number_literal] = ACTIONS(5339),
    [anon_sym_SQUOTE] = ACTIONS(5337),
    [anon_sym_DQUOTE] = ACTIONS(5337),
    [sym_return] = ACTIONS(5339),
    [sym_next] = ACTIONS(5339),
    [sym_break] = ACTIONS(5339),
    [sym_true] = ACTIONS(5339),
    [sym_false] = ACTIONS(5339),
    [sym_null] = ACTIONS(5339),
    [sym_inf] = ACTIONS(5339),
    [sym_nan] = ACTIONS(5339),
    [anon_sym_NA] = ACTIONS(5339),
    [anon_sym_NA_integer_] = ACTIONS(5339),
    [anon_sym_NA_real_] = ACTIONS(5339),
    [anon_sym_NA_complex_] = ACTIONS(5339),
    [anon_sym_NA_character_] = ACTIONS(5339),
    [sym_dots] = ACTIONS(5339),
    [sym_dot_dot_i] = ACTIONS(5337),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5337),
    [sym__newline] = ACTIONS(5337),
    [sym__semicolon] = ACTIONS(5337),
    [sym__raw_string_literal] = ACTIONS(5337),
    [sym__external_open_parenthesis] = ACTIONS(5929),
    [sym__external_open_brace] = ACTIONS(5337),
    [sym__external_close_brace] = ACTIONS(5337),
    [sym__external_open_bracket] = ACTIONS(5931),
    [sym__external_close_bracket] = ACTIONS(5337),
    [sym__external_open_bracket2] = ACTIONS(5933),
  },
  [1242] = {
    [sym_call_arguments] = STATE(2671),
    [sym_subset_arguments] = STATE(2663),
    [sym_subset2_arguments] = STATE(2661),
    [sym__open_parenthesis] = STATE(1555),
    [sym__open_bracket] = STATE(1551),
    [sym__open_bracket2] = STATE(1549),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(5333),
    [anon_sym_DASH] = ACTIONS(5335),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5335),
    [anon_sym_AMP] = ACTIONS(5335),
    [anon_sym_PIPE_PIPE] = ACTIONS(5333),
    [anon_sym_AMP_AMP] = ACTIONS(5333),
    [anon_sym_LT] = ACTIONS(5335),
    [anon_sym_LT_EQ] = ACTIONS(5333),
    [anon_sym_GT] = ACTIONS(5335),
    [anon_sym_GT_EQ] = ACTIONS(5333),
    [anon_sym_EQ_EQ] = ACTIONS(5333),
    [anon_sym_BANG_EQ] = ACTIONS(5333),
    [anon_sym_STAR] = ACTIONS(5335),
    [anon_sym_SLASH] = ACTIONS(5333),
    [anon_sym_STAR_STAR] = ACTIONS(5921),
    [anon_sym_CARET] = ACTIONS(5921),
    [aux_sym_binary_operator_token1] = ACTIONS(5333),
    [anon_sym_PIPE_GT] = ACTIONS(5333),
    [anon_sym_COLON] = ACTIONS(5335),
    [anon_sym_DOLLAR] = ACTIONS(5927),
    [anon_sym_AT] = ACTIONS(5927),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__semicolon] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(5929),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_close_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(5931),
    [sym__external_close_bracket] = ACTIONS(5333),
    [sym__external_open_bracket2] = ACTIONS(5933),
  },
  [1243] = {
    [sym_call_arguments] = STATE(2671),
    [sym_subset_arguments] = STATE(2663),
    [sym_subset2_arguments] = STATE(2661),
    [sym__open_parenthesis] = STATE(1555),
    [sym__open_bracket] = STATE(1551),
    [sym__open_bracket2] = STATE(1549),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(5895),
    [anon_sym_DASH] = ACTIONS(5897),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5335),
    [anon_sym_AMP] = ACTIONS(5335),
    [anon_sym_PIPE_PIPE] = ACTIONS(5333),
    [anon_sym_AMP_AMP] = ACTIONS(5333),
    [anon_sym_LT] = ACTIONS(5913),
    [anon_sym_LT_EQ] = ACTIONS(5915),
    [anon_sym_GT] = ACTIONS(5913),
    [anon_sym_GT_EQ] = ACTIONS(5915),
    [anon_sym_EQ_EQ] = ACTIONS(5915),
    [anon_sym_BANG_EQ] = ACTIONS(5915),
    [anon_sym_STAR] = ACTIONS(5917),
    [anon_sym_SLASH] = ACTIONS(5919),
    [anon_sym_STAR_STAR] = ACTIONS(5921),
    [anon_sym_CARET] = ACTIONS(5921),
    [aux_sym_binary_operator_token1] = ACTIONS(5923),
    [anon_sym_PIPE_GT] = ACTIONS(5923),
    [anon_sym_COLON] = ACTIONS(5925),
    [anon_sym_DOLLAR] = ACTIONS(5927),
    [anon_sym_AT] = ACTIONS(5927),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__semicolon] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(5929),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_close_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(5931),
    [sym__external_close_bracket] = ACTIONS(5333),
    [sym__external_open_bracket2] = ACTIONS(5933),
  },
  [1244] = {
    [sym_call_arguments] = STATE(2671),
    [sym_subset_arguments] = STATE(2663),
    [sym_subset2_arguments] = STATE(2661),
    [sym__open_parenthesis] = STATE(1555),
    [sym__open_bracket] = STATE(1551),
    [sym__open_bracket2] = STATE(1549),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(5895),
    [anon_sym_DASH] = ACTIONS(5897),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5905),
    [anon_sym_AMP] = ACTIONS(5907),
    [anon_sym_PIPE_PIPE] = ACTIONS(5909),
    [anon_sym_AMP_AMP] = ACTIONS(5911),
    [anon_sym_LT] = ACTIONS(5913),
    [anon_sym_LT_EQ] = ACTIONS(5915),
    [anon_sym_GT] = ACTIONS(5913),
    [anon_sym_GT_EQ] = ACTIONS(5915),
    [anon_sym_EQ_EQ] = ACTIONS(5915),
    [anon_sym_BANG_EQ] = ACTIONS(5915),
    [anon_sym_STAR] = ACTIONS(5917),
    [anon_sym_SLASH] = ACTIONS(5919),
    [anon_sym_STAR_STAR] = ACTIONS(5921),
    [anon_sym_CARET] = ACTIONS(5921),
    [aux_sym_binary_operator_token1] = ACTIONS(5923),
    [anon_sym_PIPE_GT] = ACTIONS(5923),
    [anon_sym_COLON] = ACTIONS(5925),
    [anon_sym_DOLLAR] = ACTIONS(5927),
    [anon_sym_AT] = ACTIONS(5927),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__semicolon] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(5929),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_close_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(5931),
    [sym__external_close_bracket] = ACTIONS(5333),
    [sym__external_open_bracket2] = ACTIONS(5933),
  },
  [1245] = {
    [sym_call_arguments] = STATE(2671),
    [sym_subset_arguments] = STATE(2663),
    [sym_subset2_arguments] = STATE(2661),
    [sym__open_parenthesis] = STATE(1555),
    [sym__open_bracket] = STATE(1551),
    [sym__open_bracket2] = STATE(1549),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5889),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5893),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(5895),
    [anon_sym_DASH] = ACTIONS(5897),
    [anon_sym_LT_DASH] = ACTIONS(5899),
    [anon_sym_LT_LT_DASH] = ACTIONS(5899),
    [anon_sym_COLON_EQ] = ACTIONS(5899),
    [anon_sym_DASH_GT] = ACTIONS(5901),
    [anon_sym_DASH_GT_GT] = ACTIONS(5903),
    [anon_sym_PIPE] = ACTIONS(5905),
    [anon_sym_AMP] = ACTIONS(5907),
    [anon_sym_PIPE_PIPE] = ACTIONS(5909),
    [anon_sym_AMP_AMP] = ACTIONS(5911),
    [anon_sym_LT] = ACTIONS(5913),
    [anon_sym_LT_EQ] = ACTIONS(5915),
    [anon_sym_GT] = ACTIONS(5913),
    [anon_sym_GT_EQ] = ACTIONS(5915),
    [anon_sym_EQ_EQ] = ACTIONS(5915),
    [anon_sym_BANG_EQ] = ACTIONS(5915),
    [anon_sym_STAR] = ACTIONS(5917),
    [anon_sym_SLASH] = ACTIONS(5919),
    [anon_sym_STAR_STAR] = ACTIONS(5921),
    [anon_sym_CARET] = ACTIONS(5921),
    [aux_sym_binary_operator_token1] = ACTIONS(5923),
    [anon_sym_PIPE_GT] = ACTIONS(5923),
    [anon_sym_COLON] = ACTIONS(5925),
    [anon_sym_DOLLAR] = ACTIONS(5927),
    [anon_sym_AT] = ACTIONS(5927),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__semicolon] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(5929),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_close_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(5931),
    [sym__external_close_bracket] = ACTIONS(5333),
    [sym__external_open_bracket2] = ACTIONS(5933),
  },
  [1246] = {
    [sym_call_arguments] = STATE(2671),
    [sym_subset_arguments] = STATE(2663),
    [sym_subset2_arguments] = STATE(2661),
    [sym__open_parenthesis] = STATE(1555),
    [sym__open_bracket] = STATE(1551),
    [sym__open_bracket2] = STATE(1549),
    [sym_identifier] = ACTIONS(5331),
    [anon_sym_BSLASH] = ACTIONS(5329),
    [anon_sym_function] = ACTIONS(5331),
    [anon_sym_EQ] = ACTIONS(5889),
    [anon_sym_if] = ACTIONS(5331),
    [anon_sym_for] = ACTIONS(5331),
    [anon_sym_while] = ACTIONS(5331),
    [anon_sym_repeat] = ACTIONS(5331),
    [anon_sym_QMARK] = ACTIONS(5329),
    [anon_sym_TILDE] = ACTIONS(5893),
    [anon_sym_BANG] = ACTIONS(5331),
    [anon_sym_PLUS] = ACTIONS(5895),
    [anon_sym_DASH] = ACTIONS(5897),
    [anon_sym_LT_DASH] = ACTIONS(5899),
    [anon_sym_LT_LT_DASH] = ACTIONS(5899),
    [anon_sym_COLON_EQ] = ACTIONS(5899),
    [anon_sym_DASH_GT] = ACTIONS(5901),
    [anon_sym_DASH_GT_GT] = ACTIONS(5903),
    [anon_sym_PIPE] = ACTIONS(5905),
    [anon_sym_AMP] = ACTIONS(5907),
    [anon_sym_PIPE_PIPE] = ACTIONS(5909),
    [anon_sym_AMP_AMP] = ACTIONS(5911),
    [anon_sym_LT] = ACTIONS(5913),
    [anon_sym_LT_EQ] = ACTIONS(5915),
    [anon_sym_GT] = ACTIONS(5913),
    [anon_sym_GT_EQ] = ACTIONS(5915),
    [anon_sym_EQ_EQ] = ACTIONS(5915),
    [anon_sym_BANG_EQ] = ACTIONS(5915),
    [anon_sym_STAR] = ACTIONS(5917),
    [anon_sym_SLASH] = ACTIONS(5919),
    [anon_sym_STAR_STAR] = ACTIONS(5921),
    [anon_sym_CARET] = ACTIONS(5921),
    [aux_sym_binary_operator_token1] = ACTIONS(5923),
    [anon_sym_PIPE_GT] = ACTIONS(5923),
    [anon_sym_COLON] = ACTIONS(5925),
    [anon_sym_DOLLAR] = ACTIONS(5927),
    [anon_sym_AT] = ACTIONS(5927),
    [aux_sym__hex_literal_token1] = ACTIONS(5329),
    [sym__number_literal] = ACTIONS(5331),
    [anon_sym_SQUOTE] = ACTIONS(5329),
    [anon_sym_DQUOTE] = ACTIONS(5329),
    [sym_return] = ACTIONS(5331),
    [sym_next] = ACTIONS(5331),
    [sym_break] = ACTIONS(5331),
    [sym_true] = ACTIONS(5331),
    [sym_false] = ACTIONS(5331),
    [sym_null] = ACTIONS(5331),
    [sym_inf] = ACTIONS(5331),
    [sym_nan] = ACTIONS(5331),
    [anon_sym_NA] = ACTIONS(5331),
    [anon_sym_NA_integer_] = ACTIONS(5331),
    [anon_sym_NA_real_] = ACTIONS(5331),
    [anon_sym_NA_complex_] = ACTIONS(5331),
    [anon_sym_NA_character_] = ACTIONS(5331),
    [sym_dots] = ACTIONS(5331),
    [sym_dot_dot_i] = ACTIONS(5329),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5329),
    [sym__newline] = ACTIONS(5329),
    [sym__semicolon] = ACTIONS(5329),
    [sym__raw_string_literal] = ACTIONS(5329),
    [sym__external_open_parenthesis] = ACTIONS(5929),
    [sym__external_open_brace] = ACTIONS(5329),
    [sym__external_close_brace] = ACTIONS(5329),
    [sym__external_open_bracket] = ACTIONS(5931),
    [sym__external_close_bracket] = ACTIONS(5329),
    [sym__external_open_bracket2] = ACTIONS(5933),
  },
  [1247] = {
    [sym_call_arguments] = STATE(2731),
    [sym_subset_arguments] = STATE(2730),
    [sym_subset2_arguments] = STATE(2729),
    [sym__open_parenthesis] = STATE(1357),
    [sym__open_bracket] = STATE(1353),
    [sym__open_bracket2] = STATE(1352),
    [sym_identifier] = ACTIONS(5331),
    [anon_sym_BSLASH] = ACTIONS(5329),
    [anon_sym_function] = ACTIONS(5331),
    [anon_sym_EQ] = ACTIONS(5783),
    [anon_sym_if] = ACTIONS(5331),
    [anon_sym_for] = ACTIONS(5331),
    [anon_sym_while] = ACTIONS(5331),
    [anon_sym_repeat] = ACTIONS(5331),
    [anon_sym_QMARK] = ACTIONS(5329),
    [anon_sym_TILDE] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(5331),
    [anon_sym_PLUS] = ACTIONS(5787),
    [anon_sym_DASH] = ACTIONS(5789),
    [anon_sym_LT_DASH] = ACTIONS(5791),
    [anon_sym_LT_LT_DASH] = ACTIONS(5791),
    [anon_sym_COLON_EQ] = ACTIONS(5791),
    [anon_sym_DASH_GT] = ACTIONS(5793),
    [anon_sym_DASH_GT_GT] = ACTIONS(5795),
    [anon_sym_PIPE] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5799),
    [anon_sym_PIPE_PIPE] = ACTIONS(5801),
    [anon_sym_AMP_AMP] = ACTIONS(5803),
    [anon_sym_LT] = ACTIONS(5805),
    [anon_sym_LT_EQ] = ACTIONS(5807),
    [anon_sym_GT] = ACTIONS(5805),
    [anon_sym_GT_EQ] = ACTIONS(5807),
    [anon_sym_EQ_EQ] = ACTIONS(5807),
    [anon_sym_BANG_EQ] = ACTIONS(5807),
    [anon_sym_STAR] = ACTIONS(5809),
    [anon_sym_SLASH] = ACTIONS(5811),
    [anon_sym_STAR_STAR] = ACTIONS(5813),
    [anon_sym_CARET] = ACTIONS(5813),
    [aux_sym_binary_operator_token1] = ACTIONS(5815),
    [anon_sym_PIPE_GT] = ACTIONS(5815),
    [anon_sym_COLON] = ACTIONS(5817),
    [anon_sym_DOLLAR] = ACTIONS(5819),
    [anon_sym_AT] = ACTIONS(5819),
    [aux_sym__hex_literal_token1] = ACTIONS(5329),
    [sym__number_literal] = ACTIONS(5331),
    [anon_sym_SQUOTE] = ACTIONS(5329),
    [anon_sym_DQUOTE] = ACTIONS(5329),
    [sym_return] = ACTIONS(5331),
    [sym_next] = ACTIONS(5331),
    [sym_break] = ACTIONS(5331),
    [sym_true] = ACTIONS(5331),
    [sym_false] = ACTIONS(5331),
    [sym_null] = ACTIONS(5331),
    [sym_inf] = ACTIONS(5331),
    [sym_nan] = ACTIONS(5331),
    [anon_sym_NA] = ACTIONS(5331),
    [anon_sym_NA_integer_] = ACTIONS(5331),
    [anon_sym_NA_real_] = ACTIONS(5331),
    [anon_sym_NA_complex_] = ACTIONS(5331),
    [anon_sym_NA_character_] = ACTIONS(5331),
    [sym_dots] = ACTIONS(5331),
    [sym_dot_dot_i] = ACTIONS(5329),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5329),
    [sym__newline] = ACTIONS(5329),
    [sym__raw_string_literal] = ACTIONS(5329),
    [sym__external_else] = ACTIONS(5329),
    [sym__external_open_parenthesis] = ACTIONS(5823),
    [sym__external_close_parenthesis] = ACTIONS(5329),
    [sym__external_open_brace] = ACTIONS(5329),
    [sym__external_open_bracket] = ACTIONS(5825),
    [sym__external_close_bracket] = ACTIONS(5329),
    [sym__external_open_bracket2] = ACTIONS(5827),
  },
  [1248] = {
    [sym_call_arguments] = STATE(2731),
    [sym_subset_arguments] = STATE(2730),
    [sym_subset2_arguments] = STATE(2729),
    [sym__open_parenthesis] = STATE(1357),
    [sym__open_bracket] = STATE(1353),
    [sym__open_bracket2] = STATE(1352),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5783),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(5787),
    [anon_sym_DASH] = ACTIONS(5789),
    [anon_sym_LT_DASH] = ACTIONS(5791),
    [anon_sym_LT_LT_DASH] = ACTIONS(5791),
    [anon_sym_COLON_EQ] = ACTIONS(5791),
    [anon_sym_DASH_GT] = ACTIONS(5793),
    [anon_sym_DASH_GT_GT] = ACTIONS(5795),
    [anon_sym_PIPE] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5799),
    [anon_sym_PIPE_PIPE] = ACTIONS(5801),
    [anon_sym_AMP_AMP] = ACTIONS(5803),
    [anon_sym_LT] = ACTIONS(5805),
    [anon_sym_LT_EQ] = ACTIONS(5807),
    [anon_sym_GT] = ACTIONS(5805),
    [anon_sym_GT_EQ] = ACTIONS(5807),
    [anon_sym_EQ_EQ] = ACTIONS(5807),
    [anon_sym_BANG_EQ] = ACTIONS(5807),
    [anon_sym_STAR] = ACTIONS(5809),
    [anon_sym_SLASH] = ACTIONS(5811),
    [anon_sym_STAR_STAR] = ACTIONS(5813),
    [anon_sym_CARET] = ACTIONS(5813),
    [aux_sym_binary_operator_token1] = ACTIONS(5815),
    [anon_sym_PIPE_GT] = ACTIONS(5815),
    [anon_sym_COLON] = ACTIONS(5817),
    [anon_sym_DOLLAR] = ACTIONS(5819),
    [anon_sym_AT] = ACTIONS(5819),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_else] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(5823),
    [sym__external_close_parenthesis] = ACTIONS(5333),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(5825),
    [sym__external_close_bracket] = ACTIONS(5333),
    [sym__external_open_bracket2] = ACTIONS(5827),
  },
  [1249] = {
    [sym_call_arguments] = STATE(2731),
    [sym_subset_arguments] = STATE(2730),
    [sym_subset2_arguments] = STATE(2729),
    [sym__open_parenthesis] = STATE(1357),
    [sym__open_bracket] = STATE(1353),
    [sym__open_bracket2] = STATE(1352),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(5787),
    [anon_sym_DASH] = ACTIONS(5789),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5799),
    [anon_sym_PIPE_PIPE] = ACTIONS(5801),
    [anon_sym_AMP_AMP] = ACTIONS(5803),
    [anon_sym_LT] = ACTIONS(5805),
    [anon_sym_LT_EQ] = ACTIONS(5807),
    [anon_sym_GT] = ACTIONS(5805),
    [anon_sym_GT_EQ] = ACTIONS(5807),
    [anon_sym_EQ_EQ] = ACTIONS(5807),
    [anon_sym_BANG_EQ] = ACTIONS(5807),
    [anon_sym_STAR] = ACTIONS(5809),
    [anon_sym_SLASH] = ACTIONS(5811),
    [anon_sym_STAR_STAR] = ACTIONS(5813),
    [anon_sym_CARET] = ACTIONS(5813),
    [aux_sym_binary_operator_token1] = ACTIONS(5815),
    [anon_sym_PIPE_GT] = ACTIONS(5815),
    [anon_sym_COLON] = ACTIONS(5817),
    [anon_sym_DOLLAR] = ACTIONS(5819),
    [anon_sym_AT] = ACTIONS(5819),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_else] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(5823),
    [sym__external_close_parenthesis] = ACTIONS(5333),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(5825),
    [sym__external_close_bracket] = ACTIONS(5333),
    [sym__external_open_bracket2] = ACTIONS(5827),
  },
  [1250] = {
    [sym_call_arguments] = STATE(2731),
    [sym_subset_arguments] = STATE(2730),
    [sym_subset2_arguments] = STATE(2729),
    [sym__open_parenthesis] = STATE(1357),
    [sym__open_bracket] = STATE(1353),
    [sym__open_bracket2] = STATE(1352),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(5787),
    [anon_sym_DASH] = ACTIONS(5789),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5335),
    [anon_sym_AMP] = ACTIONS(5335),
    [anon_sym_PIPE_PIPE] = ACTIONS(5333),
    [anon_sym_AMP_AMP] = ACTIONS(5333),
    [anon_sym_LT] = ACTIONS(5805),
    [anon_sym_LT_EQ] = ACTIONS(5807),
    [anon_sym_GT] = ACTIONS(5805),
    [anon_sym_GT_EQ] = ACTIONS(5807),
    [anon_sym_EQ_EQ] = ACTIONS(5807),
    [anon_sym_BANG_EQ] = ACTIONS(5807),
    [anon_sym_STAR] = ACTIONS(5809),
    [anon_sym_SLASH] = ACTIONS(5811),
    [anon_sym_STAR_STAR] = ACTIONS(5813),
    [anon_sym_CARET] = ACTIONS(5813),
    [aux_sym_binary_operator_token1] = ACTIONS(5815),
    [anon_sym_PIPE_GT] = ACTIONS(5815),
    [anon_sym_COLON] = ACTIONS(5817),
    [anon_sym_DOLLAR] = ACTIONS(5819),
    [anon_sym_AT] = ACTIONS(5819),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_else] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(5823),
    [sym__external_close_parenthesis] = ACTIONS(5333),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(5825),
    [sym__external_close_bracket] = ACTIONS(5333),
    [sym__external_open_bracket2] = ACTIONS(5827),
  },
  [1251] = {
    [sym_call_arguments] = STATE(2731),
    [sym_subset_arguments] = STATE(2730),
    [sym_subset2_arguments] = STATE(2729),
    [sym__open_parenthesis] = STATE(1357),
    [sym__open_bracket] = STATE(1353),
    [sym__open_bracket2] = STATE(1352),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(5333),
    [anon_sym_DASH] = ACTIONS(5335),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5335),
    [anon_sym_AMP] = ACTIONS(5335),
    [anon_sym_PIPE_PIPE] = ACTIONS(5333),
    [anon_sym_AMP_AMP] = ACTIONS(5333),
    [anon_sym_LT] = ACTIONS(5335),
    [anon_sym_LT_EQ] = ACTIONS(5333),
    [anon_sym_GT] = ACTIONS(5335),
    [anon_sym_GT_EQ] = ACTIONS(5333),
    [anon_sym_EQ_EQ] = ACTIONS(5333),
    [anon_sym_BANG_EQ] = ACTIONS(5333),
    [anon_sym_STAR] = ACTIONS(5335),
    [anon_sym_SLASH] = ACTIONS(5333),
    [anon_sym_STAR_STAR] = ACTIONS(5813),
    [anon_sym_CARET] = ACTIONS(5813),
    [aux_sym_binary_operator_token1] = ACTIONS(5333),
    [anon_sym_PIPE_GT] = ACTIONS(5333),
    [anon_sym_COLON] = ACTIONS(5335),
    [anon_sym_DOLLAR] = ACTIONS(5819),
    [anon_sym_AT] = ACTIONS(5819),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_else] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(5823),
    [sym__external_close_parenthesis] = ACTIONS(5333),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(5825),
    [sym__external_close_bracket] = ACTIONS(5333),
    [sym__external_open_bracket2] = ACTIONS(5827),
  },
  [1252] = {
    [sym_call_arguments] = STATE(2731),
    [sym_subset_arguments] = STATE(2730),
    [sym_subset2_arguments] = STATE(2729),
    [sym__open_parenthesis] = STATE(1357),
    [sym__open_bracket] = STATE(1353),
    [sym__open_bracket2] = STATE(1352),
    [sym_identifier] = ACTIONS(5339),
    [anon_sym_BSLASH] = ACTIONS(5337),
    [anon_sym_function] = ACTIONS(5339),
    [anon_sym_EQ] = ACTIONS(5783),
    [anon_sym_if] = ACTIONS(5339),
    [anon_sym_for] = ACTIONS(5339),
    [anon_sym_while] = ACTIONS(5339),
    [anon_sym_repeat] = ACTIONS(5339),
    [anon_sym_QMARK] = ACTIONS(5337),
    [anon_sym_TILDE] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(5339),
    [anon_sym_PLUS] = ACTIONS(5787),
    [anon_sym_DASH] = ACTIONS(5789),
    [anon_sym_LT_DASH] = ACTIONS(5791),
    [anon_sym_LT_LT_DASH] = ACTIONS(5791),
    [anon_sym_COLON_EQ] = ACTIONS(5791),
    [anon_sym_DASH_GT] = ACTIONS(5793),
    [anon_sym_DASH_GT_GT] = ACTIONS(5795),
    [anon_sym_PIPE] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5799),
    [anon_sym_PIPE_PIPE] = ACTIONS(5801),
    [anon_sym_AMP_AMP] = ACTIONS(5803),
    [anon_sym_LT] = ACTIONS(5805),
    [anon_sym_LT_EQ] = ACTIONS(5807),
    [anon_sym_GT] = ACTIONS(5805),
    [anon_sym_GT_EQ] = ACTIONS(5807),
    [anon_sym_EQ_EQ] = ACTIONS(5807),
    [anon_sym_BANG_EQ] = ACTIONS(5807),
    [anon_sym_STAR] = ACTIONS(5809),
    [anon_sym_SLASH] = ACTIONS(5811),
    [anon_sym_STAR_STAR] = ACTIONS(5813),
    [anon_sym_CARET] = ACTIONS(5813),
    [aux_sym_binary_operator_token1] = ACTIONS(5815),
    [anon_sym_PIPE_GT] = ACTIONS(5815),
    [anon_sym_COLON] = ACTIONS(5817),
    [anon_sym_DOLLAR] = ACTIONS(5819),
    [anon_sym_AT] = ACTIONS(5819),
    [aux_sym__hex_literal_token1] = ACTIONS(5337),
    [sym__number_literal] = ACTIONS(5339),
    [anon_sym_SQUOTE] = ACTIONS(5337),
    [anon_sym_DQUOTE] = ACTIONS(5337),
    [sym_return] = ACTIONS(5339),
    [sym_next] = ACTIONS(5339),
    [sym_break] = ACTIONS(5339),
    [sym_true] = ACTIONS(5339),
    [sym_false] = ACTIONS(5339),
    [sym_null] = ACTIONS(5339),
    [sym_inf] = ACTIONS(5339),
    [sym_nan] = ACTIONS(5339),
    [anon_sym_NA] = ACTIONS(5339),
    [anon_sym_NA_integer_] = ACTIONS(5339),
    [anon_sym_NA_real_] = ACTIONS(5339),
    [anon_sym_NA_complex_] = ACTIONS(5339),
    [anon_sym_NA_character_] = ACTIONS(5339),
    [sym_dots] = ACTIONS(5339),
    [sym_dot_dot_i] = ACTIONS(5337),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5337),
    [sym__newline] = ACTIONS(5337),
    [sym__raw_string_literal] = ACTIONS(5337),
    [sym__external_else] = ACTIONS(5337),
    [sym__external_open_parenthesis] = ACTIONS(5823),
    [sym__external_close_parenthesis] = ACTIONS(5337),
    [sym__external_open_brace] = ACTIONS(5337),
    [sym__external_open_bracket] = ACTIONS(5825),
    [sym__external_close_bracket] = ACTIONS(5337),
    [sym__external_open_bracket2] = ACTIONS(5827),
  },
  [1253] = {
    [sym_call_arguments] = STATE(2731),
    [sym_subset_arguments] = STATE(2730),
    [sym_subset2_arguments] = STATE(2729),
    [sym__open_parenthesis] = STATE(1357),
    [sym__open_bracket] = STATE(1353),
    [sym__open_bracket2] = STATE(1352),
    [sym_identifier] = ACTIONS(5343),
    [anon_sym_BSLASH] = ACTIONS(5341),
    [anon_sym_function] = ACTIONS(5343),
    [anon_sym_EQ] = ACTIONS(5783),
    [anon_sym_if] = ACTIONS(5343),
    [anon_sym_for] = ACTIONS(5343),
    [anon_sym_while] = ACTIONS(5343),
    [anon_sym_repeat] = ACTIONS(5343),
    [anon_sym_QMARK] = ACTIONS(5341),
    [anon_sym_TILDE] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(5343),
    [anon_sym_PLUS] = ACTIONS(5787),
    [anon_sym_DASH] = ACTIONS(5789),
    [anon_sym_LT_DASH] = ACTIONS(5791),
    [anon_sym_LT_LT_DASH] = ACTIONS(5791),
    [anon_sym_COLON_EQ] = ACTIONS(5791),
    [anon_sym_DASH_GT] = ACTIONS(5793),
    [anon_sym_DASH_GT_GT] = ACTIONS(5795),
    [anon_sym_PIPE] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5799),
    [anon_sym_PIPE_PIPE] = ACTIONS(5801),
    [anon_sym_AMP_AMP] = ACTIONS(5803),
    [anon_sym_LT] = ACTIONS(5805),
    [anon_sym_LT_EQ] = ACTIONS(5807),
    [anon_sym_GT] = ACTIONS(5805),
    [anon_sym_GT_EQ] = ACTIONS(5807),
    [anon_sym_EQ_EQ] = ACTIONS(5807),
    [anon_sym_BANG_EQ] = ACTIONS(5807),
    [anon_sym_STAR] = ACTIONS(5809),
    [anon_sym_SLASH] = ACTIONS(5811),
    [anon_sym_STAR_STAR] = ACTIONS(5813),
    [anon_sym_CARET] = ACTIONS(5813),
    [aux_sym_binary_operator_token1] = ACTIONS(5815),
    [anon_sym_PIPE_GT] = ACTIONS(5815),
    [anon_sym_COLON] = ACTIONS(5817),
    [anon_sym_DOLLAR] = ACTIONS(5819),
    [anon_sym_AT] = ACTIONS(5819),
    [aux_sym__hex_literal_token1] = ACTIONS(5341),
    [sym__number_literal] = ACTIONS(5343),
    [anon_sym_SQUOTE] = ACTIONS(5341),
    [anon_sym_DQUOTE] = ACTIONS(5341),
    [sym_return] = ACTIONS(5343),
    [sym_next] = ACTIONS(5343),
    [sym_break] = ACTIONS(5343),
    [sym_true] = ACTIONS(5343),
    [sym_false] = ACTIONS(5343),
    [sym_null] = ACTIONS(5343),
    [sym_inf] = ACTIONS(5343),
    [sym_nan] = ACTIONS(5343),
    [anon_sym_NA] = ACTIONS(5343),
    [anon_sym_NA_integer_] = ACTIONS(5343),
    [anon_sym_NA_real_] = ACTIONS(5343),
    [anon_sym_NA_complex_] = ACTIONS(5343),
    [anon_sym_NA_character_] = ACTIONS(5343),
    [sym_dots] = ACTIONS(5343),
    [sym_dot_dot_i] = ACTIONS(5341),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5341),
    [sym__newline] = ACTIONS(5341),
    [sym__raw_string_literal] = ACTIONS(5341),
    [sym__external_else] = ACTIONS(5341),
    [sym__external_open_parenthesis] = ACTIONS(5823),
    [sym__external_close_parenthesis] = ACTIONS(5341),
    [sym__external_open_brace] = ACTIONS(5341),
    [sym__external_open_bracket] = ACTIONS(5825),
    [sym__external_close_bracket] = ACTIONS(5341),
    [sym__external_open_bracket2] = ACTIONS(5827),
  },
  [1254] = {
    [sym_call_arguments] = STATE(2731),
    [sym_subset_arguments] = STATE(2730),
    [sym_subset2_arguments] = STATE(2729),
    [sym__open_parenthesis] = STATE(1357),
    [sym__open_bracket] = STATE(1353),
    [sym__open_bracket2] = STATE(1352),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5783),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5787),
    [anon_sym_DASH] = ACTIONS(5789),
    [anon_sym_LT_DASH] = ACTIONS(5791),
    [anon_sym_LT_LT_DASH] = ACTIONS(5791),
    [anon_sym_COLON_EQ] = ACTIONS(5791),
    [anon_sym_DASH_GT] = ACTIONS(5793),
    [anon_sym_DASH_GT_GT] = ACTIONS(5795),
    [anon_sym_PIPE] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5799),
    [anon_sym_PIPE_PIPE] = ACTIONS(5801),
    [anon_sym_AMP_AMP] = ACTIONS(5803),
    [anon_sym_LT] = ACTIONS(5805),
    [anon_sym_LT_EQ] = ACTIONS(5807),
    [anon_sym_GT] = ACTIONS(5805),
    [anon_sym_GT_EQ] = ACTIONS(5807),
    [anon_sym_EQ_EQ] = ACTIONS(5807),
    [anon_sym_BANG_EQ] = ACTIONS(5807),
    [anon_sym_STAR] = ACTIONS(5809),
    [anon_sym_SLASH] = ACTIONS(5811),
    [anon_sym_STAR_STAR] = ACTIONS(5813),
    [anon_sym_CARET] = ACTIONS(5813),
    [aux_sym_binary_operator_token1] = ACTIONS(5815),
    [anon_sym_PIPE_GT] = ACTIONS(5815),
    [anon_sym_COLON] = ACTIONS(5817),
    [anon_sym_DOLLAR] = ACTIONS(5819),
    [anon_sym_AT] = ACTIONS(5819),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_else] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(5823),
    [sym__external_close_parenthesis] = ACTIONS(5345),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(5825),
    [sym__external_close_bracket] = ACTIONS(5345),
    [sym__external_open_bracket2] = ACTIONS(5827),
  },
  [1255] = {
    [sym_call_arguments] = STATE(2731),
    [sym_subset_arguments] = STATE(2730),
    [sym_subset2_arguments] = STATE(2729),
    [sym__open_parenthesis] = STATE(1357),
    [sym__open_bracket] = STATE(1353),
    [sym__open_bracket2] = STATE(1352),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5787),
    [anon_sym_DASH] = ACTIONS(5789),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5799),
    [anon_sym_PIPE_PIPE] = ACTIONS(5801),
    [anon_sym_AMP_AMP] = ACTIONS(5803),
    [anon_sym_LT] = ACTIONS(5805),
    [anon_sym_LT_EQ] = ACTIONS(5807),
    [anon_sym_GT] = ACTIONS(5805),
    [anon_sym_GT_EQ] = ACTIONS(5807),
    [anon_sym_EQ_EQ] = ACTIONS(5807),
    [anon_sym_BANG_EQ] = ACTIONS(5807),
    [anon_sym_STAR] = ACTIONS(5809),
    [anon_sym_SLASH] = ACTIONS(5811),
    [anon_sym_STAR_STAR] = ACTIONS(5813),
    [anon_sym_CARET] = ACTIONS(5813),
    [aux_sym_binary_operator_token1] = ACTIONS(5815),
    [anon_sym_PIPE_GT] = ACTIONS(5815),
    [anon_sym_COLON] = ACTIONS(5817),
    [anon_sym_DOLLAR] = ACTIONS(5819),
    [anon_sym_AT] = ACTIONS(5819),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_else] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(5823),
    [sym__external_close_parenthesis] = ACTIONS(5345),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(5825),
    [sym__external_close_bracket] = ACTIONS(5345),
    [sym__external_open_bracket2] = ACTIONS(5827),
  },
  [1256] = {
    [sym_call_arguments] = STATE(2731),
    [sym_subset_arguments] = STATE(2730),
    [sym_subset2_arguments] = STATE(2729),
    [sym__open_parenthesis] = STATE(1357),
    [sym__open_bracket] = STATE(1353),
    [sym__open_bracket2] = STATE(1352),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5787),
    [anon_sym_DASH] = ACTIONS(5789),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5347),
    [anon_sym_AMP] = ACTIONS(5347),
    [anon_sym_PIPE_PIPE] = ACTIONS(5345),
    [anon_sym_AMP_AMP] = ACTIONS(5345),
    [anon_sym_LT] = ACTIONS(5805),
    [anon_sym_LT_EQ] = ACTIONS(5807),
    [anon_sym_GT] = ACTIONS(5805),
    [anon_sym_GT_EQ] = ACTIONS(5807),
    [anon_sym_EQ_EQ] = ACTIONS(5807),
    [anon_sym_BANG_EQ] = ACTIONS(5807),
    [anon_sym_STAR] = ACTIONS(5809),
    [anon_sym_SLASH] = ACTIONS(5811),
    [anon_sym_STAR_STAR] = ACTIONS(5813),
    [anon_sym_CARET] = ACTIONS(5813),
    [aux_sym_binary_operator_token1] = ACTIONS(5815),
    [anon_sym_PIPE_GT] = ACTIONS(5815),
    [anon_sym_COLON] = ACTIONS(5817),
    [anon_sym_DOLLAR] = ACTIONS(5819),
    [anon_sym_AT] = ACTIONS(5819),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_else] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(5823),
    [sym__external_close_parenthesis] = ACTIONS(5345),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(5825),
    [sym__external_close_bracket] = ACTIONS(5345),
    [sym__external_open_bracket2] = ACTIONS(5827),
  },
  [1257] = {
    [sym_call_arguments] = STATE(2731),
    [sym_subset_arguments] = STATE(2730),
    [sym_subset2_arguments] = STATE(2729),
    [sym__open_parenthesis] = STATE(1357),
    [sym__open_bracket] = STATE(1353),
    [sym__open_bracket2] = STATE(1352),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5345),
    [anon_sym_DASH] = ACTIONS(5347),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5347),
    [anon_sym_AMP] = ACTIONS(5347),
    [anon_sym_PIPE_PIPE] = ACTIONS(5345),
    [anon_sym_AMP_AMP] = ACTIONS(5345),
    [anon_sym_LT] = ACTIONS(5347),
    [anon_sym_LT_EQ] = ACTIONS(5345),
    [anon_sym_GT] = ACTIONS(5347),
    [anon_sym_GT_EQ] = ACTIONS(5345),
    [anon_sym_EQ_EQ] = ACTIONS(5345),
    [anon_sym_BANG_EQ] = ACTIONS(5345),
    [anon_sym_STAR] = ACTIONS(5347),
    [anon_sym_SLASH] = ACTIONS(5345),
    [anon_sym_STAR_STAR] = ACTIONS(5813),
    [anon_sym_CARET] = ACTIONS(5813),
    [aux_sym_binary_operator_token1] = ACTIONS(5345),
    [anon_sym_PIPE_GT] = ACTIONS(5345),
    [anon_sym_COLON] = ACTIONS(5347),
    [anon_sym_DOLLAR] = ACTIONS(5819),
    [anon_sym_AT] = ACTIONS(5819),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_else] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(5823),
    [sym__external_close_parenthesis] = ACTIONS(5345),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(5825),
    [sym__external_close_bracket] = ACTIONS(5345),
    [sym__external_open_bracket2] = ACTIONS(5827),
  },
  [1258] = {
    [sym_call_arguments] = STATE(2731),
    [sym_subset_arguments] = STATE(2730),
    [sym_subset2_arguments] = STATE(2729),
    [sym__open_parenthesis] = STATE(1357),
    [sym__open_bracket] = STATE(1353),
    [sym__open_bracket2] = STATE(1352),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5783),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5787),
    [anon_sym_DASH] = ACTIONS(5789),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5793),
    [anon_sym_DASH_GT_GT] = ACTIONS(5795),
    [anon_sym_PIPE] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5799),
    [anon_sym_PIPE_PIPE] = ACTIONS(5801),
    [anon_sym_AMP_AMP] = ACTIONS(5803),
    [anon_sym_LT] = ACTIONS(5805),
    [anon_sym_LT_EQ] = ACTIONS(5807),
    [anon_sym_GT] = ACTIONS(5805),
    [anon_sym_GT_EQ] = ACTIONS(5807),
    [anon_sym_EQ_EQ] = ACTIONS(5807),
    [anon_sym_BANG_EQ] = ACTIONS(5807),
    [anon_sym_STAR] = ACTIONS(5809),
    [anon_sym_SLASH] = ACTIONS(5811),
    [anon_sym_STAR_STAR] = ACTIONS(5813),
    [anon_sym_CARET] = ACTIONS(5813),
    [aux_sym_binary_operator_token1] = ACTIONS(5815),
    [anon_sym_PIPE_GT] = ACTIONS(5815),
    [anon_sym_COLON] = ACTIONS(5817),
    [anon_sym_DOLLAR] = ACTIONS(5819),
    [anon_sym_AT] = ACTIONS(5819),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5823),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5825),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(5827),
  },
  [1259] = {
    [sym_call_arguments] = STATE(2731),
    [sym_subset_arguments] = STATE(2730),
    [sym_subset2_arguments] = STATE(2729),
    [sym__open_parenthesis] = STATE(1357),
    [sym__open_bracket] = STATE(1353),
    [sym__open_bracket2] = STATE(1352),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5783),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5787),
    [anon_sym_DASH] = ACTIONS(5789),
    [anon_sym_LT_DASH] = ACTIONS(5791),
    [anon_sym_LT_LT_DASH] = ACTIONS(5791),
    [anon_sym_COLON_EQ] = ACTIONS(5791),
    [anon_sym_DASH_GT] = ACTIONS(5793),
    [anon_sym_DASH_GT_GT] = ACTIONS(5795),
    [anon_sym_PIPE] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5799),
    [anon_sym_PIPE_PIPE] = ACTIONS(5801),
    [anon_sym_AMP_AMP] = ACTIONS(5803),
    [anon_sym_LT] = ACTIONS(5805),
    [anon_sym_LT_EQ] = ACTIONS(5807),
    [anon_sym_GT] = ACTIONS(5805),
    [anon_sym_GT_EQ] = ACTIONS(5807),
    [anon_sym_EQ_EQ] = ACTIONS(5807),
    [anon_sym_BANG_EQ] = ACTIONS(5807),
    [anon_sym_STAR] = ACTIONS(5809),
    [anon_sym_SLASH] = ACTIONS(5811),
    [anon_sym_STAR_STAR] = ACTIONS(5813),
    [anon_sym_CARET] = ACTIONS(5813),
    [aux_sym_binary_operator_token1] = ACTIONS(5815),
    [anon_sym_PIPE_GT] = ACTIONS(5815),
    [anon_sym_COLON] = ACTIONS(5817),
    [anon_sym_DOLLAR] = ACTIONS(5819),
    [anon_sym_AT] = ACTIONS(5819),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5823),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5825),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(5827),
  },
  [1260] = {
    [sym_call_arguments] = STATE(2731),
    [sym_subset_arguments] = STATE(2730),
    [sym_subset2_arguments] = STATE(2729),
    [sym__open_parenthesis] = STATE(1357),
    [sym__open_bracket] = STATE(1353),
    [sym__open_bracket2] = STATE(1352),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5787),
    [anon_sym_DASH] = ACTIONS(5789),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5799),
    [anon_sym_PIPE_PIPE] = ACTIONS(5801),
    [anon_sym_AMP_AMP] = ACTIONS(5803),
    [anon_sym_LT] = ACTIONS(5805),
    [anon_sym_LT_EQ] = ACTIONS(5807),
    [anon_sym_GT] = ACTIONS(5805),
    [anon_sym_GT_EQ] = ACTIONS(5807),
    [anon_sym_EQ_EQ] = ACTIONS(5807),
    [anon_sym_BANG_EQ] = ACTIONS(5807),
    [anon_sym_STAR] = ACTIONS(5809),
    [anon_sym_SLASH] = ACTIONS(5811),
    [anon_sym_STAR_STAR] = ACTIONS(5813),
    [anon_sym_CARET] = ACTIONS(5813),
    [aux_sym_binary_operator_token1] = ACTIONS(5815),
    [anon_sym_PIPE_GT] = ACTIONS(5815),
    [anon_sym_COLON] = ACTIONS(5817),
    [anon_sym_DOLLAR] = ACTIONS(5819),
    [anon_sym_AT] = ACTIONS(5819),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5823),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5825),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(5827),
  },
  [1261] = {
    [sym_call_arguments] = STATE(2731),
    [sym_subset_arguments] = STATE(2730),
    [sym_subset2_arguments] = STATE(2729),
    [sym__open_parenthesis] = STATE(1357),
    [sym__open_bracket] = STATE(1353),
    [sym__open_bracket2] = STATE(1352),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5809),
    [anon_sym_SLASH] = ACTIONS(5811),
    [anon_sym_STAR_STAR] = ACTIONS(5813),
    [anon_sym_CARET] = ACTIONS(5813),
    [aux_sym_binary_operator_token1] = ACTIONS(5815),
    [anon_sym_PIPE_GT] = ACTIONS(5815),
    [anon_sym_COLON] = ACTIONS(5817),
    [anon_sym_DOLLAR] = ACTIONS(5819),
    [anon_sym_AT] = ACTIONS(5819),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5823),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5825),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(5827),
  },
  [1262] = {
    [sym_call_arguments] = STATE(2731),
    [sym_subset_arguments] = STATE(2730),
    [sym_subset2_arguments] = STATE(2729),
    [sym__open_parenthesis] = STATE(1357),
    [sym__open_bracket] = STATE(1353),
    [sym__open_bracket2] = STATE(1352),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5783),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5787),
    [anon_sym_DASH] = ACTIONS(5789),
    [anon_sym_LT_DASH] = ACTIONS(5791),
    [anon_sym_LT_LT_DASH] = ACTIONS(5791),
    [anon_sym_COLON_EQ] = ACTIONS(5791),
    [anon_sym_DASH_GT] = ACTIONS(5793),
    [anon_sym_DASH_GT_GT] = ACTIONS(5795),
    [anon_sym_PIPE] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5799),
    [anon_sym_PIPE_PIPE] = ACTIONS(5801),
    [anon_sym_AMP_AMP] = ACTIONS(5803),
    [anon_sym_LT] = ACTIONS(5805),
    [anon_sym_LT_EQ] = ACTIONS(5807),
    [anon_sym_GT] = ACTIONS(5805),
    [anon_sym_GT_EQ] = ACTIONS(5807),
    [anon_sym_EQ_EQ] = ACTIONS(5807),
    [anon_sym_BANG_EQ] = ACTIONS(5807),
    [anon_sym_STAR] = ACTIONS(5809),
    [anon_sym_SLASH] = ACTIONS(5811),
    [anon_sym_STAR_STAR] = ACTIONS(5813),
    [anon_sym_CARET] = ACTIONS(5813),
    [aux_sym_binary_operator_token1] = ACTIONS(5815),
    [anon_sym_PIPE_GT] = ACTIONS(5815),
    [anon_sym_COLON] = ACTIONS(5817),
    [anon_sym_DOLLAR] = ACTIONS(5819),
    [anon_sym_AT] = ACTIONS(5819),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5823),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5825),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(5827),
  },
  [1263] = {
    [sym_call_arguments] = STATE(2731),
    [sym_subset_arguments] = STATE(2730),
    [sym_subset2_arguments] = STATE(2729),
    [sym__open_parenthesis] = STATE(1357),
    [sym__open_bracket] = STATE(1353),
    [sym__open_bracket2] = STATE(1352),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5787),
    [anon_sym_DASH] = ACTIONS(5789),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5799),
    [anon_sym_PIPE_PIPE] = ACTIONS(5801),
    [anon_sym_AMP_AMP] = ACTIONS(5803),
    [anon_sym_LT] = ACTIONS(5805),
    [anon_sym_LT_EQ] = ACTIONS(5807),
    [anon_sym_GT] = ACTIONS(5805),
    [anon_sym_GT_EQ] = ACTIONS(5807),
    [anon_sym_EQ_EQ] = ACTIONS(5807),
    [anon_sym_BANG_EQ] = ACTIONS(5807),
    [anon_sym_STAR] = ACTIONS(5809),
    [anon_sym_SLASH] = ACTIONS(5811),
    [anon_sym_STAR_STAR] = ACTIONS(5813),
    [anon_sym_CARET] = ACTIONS(5813),
    [aux_sym_binary_operator_token1] = ACTIONS(5815),
    [anon_sym_PIPE_GT] = ACTIONS(5815),
    [anon_sym_COLON] = ACTIONS(5817),
    [anon_sym_DOLLAR] = ACTIONS(5819),
    [anon_sym_AT] = ACTIONS(5819),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5823),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5825),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(5827),
  },
  [1264] = {
    [sym_string] = STATE(2468),
    [sym__single_quoted_string] = STATE(2181),
    [sym__double_quoted_string] = STATE(2180),
    [sym__string_or_identifier] = STATE(2468),
    [aux_sym_function_definition_repeat1] = STATE(2281),
    [ts_builtin_sym_end] = ACTIONS(5669),
    [sym_identifier] = ACTIONS(6171),
    [anon_sym_BSLASH] = ACTIONS(5669),
    [anon_sym_function] = ACTIONS(5673),
    [anon_sym_EQ] = ACTIONS(5673),
    [anon_sym_if] = ACTIONS(5673),
    [anon_sym_for] = ACTIONS(5673),
    [anon_sym_while] = ACTIONS(5673),
    [anon_sym_repeat] = ACTIONS(5673),
    [anon_sym_QMARK] = ACTIONS(5669),
    [anon_sym_TILDE] = ACTIONS(5669),
    [anon_sym_BANG] = ACTIONS(5673),
    [anon_sym_PLUS] = ACTIONS(5669),
    [anon_sym_DASH] = ACTIONS(5673),
    [anon_sym_LT_DASH] = ACTIONS(5669),
    [anon_sym_LT_LT_DASH] = ACTIONS(5669),
    [anon_sym_COLON_EQ] = ACTIONS(5669),
    [anon_sym_DASH_GT] = ACTIONS(5673),
    [anon_sym_DASH_GT_GT] = ACTIONS(5669),
    [anon_sym_PIPE] = ACTIONS(5673),
    [anon_sym_AMP] = ACTIONS(5673),
    [anon_sym_PIPE_PIPE] = ACTIONS(5669),
    [anon_sym_AMP_AMP] = ACTIONS(5669),
    [anon_sym_LT] = ACTIONS(5673),
    [anon_sym_LT_EQ] = ACTIONS(5669),
    [anon_sym_GT] = ACTIONS(5673),
    [anon_sym_GT_EQ] = ACTIONS(5669),
    [anon_sym_EQ_EQ] = ACTIONS(5669),
    [anon_sym_BANG_EQ] = ACTIONS(5669),
    [anon_sym_STAR] = ACTIONS(5673),
    [anon_sym_SLASH] = ACTIONS(5669),
    [anon_sym_STAR_STAR] = ACTIONS(5669),
    [anon_sym_CARET] = ACTIONS(5669),
    [aux_sym_binary_operator_token1] = ACTIONS(5669),
    [anon_sym_PIPE_GT] = ACTIONS(5669),
    [anon_sym_COLON] = ACTIONS(5673),
    [anon_sym_DOLLAR] = ACTIONS(5669),
    [anon_sym_AT] = ACTIONS(5669),
    [aux_sym__hex_literal_token1] = ACTIONS(5669),
    [sym__number_literal] = ACTIONS(5673),
    [anon_sym_SQUOTE] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(351),
    [sym_return] = ACTIONS(5673),
    [sym_next] = ACTIONS(5673),
    [sym_break] = ACTIONS(5673),
    [sym_true] = ACTIONS(5673),
    [sym_false] = ACTIONS(5673),
    [sym_null] = ACTIONS(5673),
    [sym_inf] = ACTIONS(5673),
    [sym_nan] = ACTIONS(5673),
    [anon_sym_NA] = ACTIONS(5673),
    [anon_sym_NA_integer_] = ACTIONS(5673),
    [anon_sym_NA_real_] = ACTIONS(5673),
    [anon_sym_NA_complex_] = ACTIONS(5673),
    [anon_sym_NA_character_] = ACTIONS(5673),
    [sym_dots] = ACTIONS(5673),
    [sym_dot_dot_i] = ACTIONS(5669),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5669),
    [sym__newline] = ACTIONS(5669),
    [sym__semicolon] = ACTIONS(5669),
    [sym__raw_string_literal] = ACTIONS(361),
    [sym__external_open_parenthesis] = ACTIONS(5669),
    [sym__external_close_parenthesis] = ACTIONS(5669),
    [sym__external_open_brace] = ACTIONS(5669),
    [sym__external_close_brace] = ACTIONS(5669),
    [sym__external_open_bracket] = ACTIONS(5669),
    [sym__external_open_bracket2] = ACTIONS(5669),
  },
  [1265] = {
    [sym_call_arguments] = STATE(2923),
    [sym_subset_arguments] = STATE(2922),
    [sym_subset2_arguments] = STATE(2906),
    [sym__else] = STATE(4113),
    [sym__open_parenthesis] = STATE(1528),
    [sym__open_bracket] = STATE(1525),
    [sym__open_bracket2] = STATE(1519),
    [ts_builtin_sym_end] = ACTIONS(5227),
    [sym_identifier] = ACTIONS(5225),
    [anon_sym_BSLASH] = ACTIONS(5227),
    [anon_sym_function] = ACTIONS(5225),
    [anon_sym_EQ] = ACTIONS(5947),
    [anon_sym_if] = ACTIONS(5225),
    [anon_sym_for] = ACTIONS(5225),
    [anon_sym_while] = ACTIONS(5225),
    [anon_sym_repeat] = ACTIONS(5225),
    [anon_sym_QMARK] = ACTIONS(5227),
    [anon_sym_TILDE] = ACTIONS(5949),
    [anon_sym_BANG] = ACTIONS(5225),
    [anon_sym_PLUS] = ACTIONS(5951),
    [anon_sym_DASH] = ACTIONS(5953),
    [anon_sym_LT_DASH] = ACTIONS(5955),
    [anon_sym_LT_LT_DASH] = ACTIONS(5955),
    [anon_sym_COLON_EQ] = ACTIONS(5955),
    [anon_sym_DASH_GT] = ACTIONS(5957),
    [anon_sym_DASH_GT_GT] = ACTIONS(5959),
    [anon_sym_PIPE] = ACTIONS(5961),
    [anon_sym_AMP] = ACTIONS(5963),
    [anon_sym_PIPE_PIPE] = ACTIONS(5965),
    [anon_sym_AMP_AMP] = ACTIONS(5967),
    [anon_sym_LT] = ACTIONS(5969),
    [anon_sym_LT_EQ] = ACTIONS(5971),
    [anon_sym_GT] = ACTIONS(5969),
    [anon_sym_GT_EQ] = ACTIONS(5971),
    [anon_sym_EQ_EQ] = ACTIONS(5971),
    [anon_sym_BANG_EQ] = ACTIONS(5971),
    [anon_sym_STAR] = ACTIONS(5973),
    [anon_sym_SLASH] = ACTIONS(5975),
    [anon_sym_STAR_STAR] = ACTIONS(5977),
    [anon_sym_CARET] = ACTIONS(5977),
    [aux_sym_binary_operator_token1] = ACTIONS(5979),
    [anon_sym_PIPE_GT] = ACTIONS(5979),
    [anon_sym_COLON] = ACTIONS(5981),
    [anon_sym_DOLLAR] = ACTIONS(5983),
    [anon_sym_AT] = ACTIONS(5983),
    [aux_sym__hex_literal_token1] = ACTIONS(5227),
    [sym__number_literal] = ACTIONS(5225),
    [anon_sym_SQUOTE] = ACTIONS(5227),
    [anon_sym_DQUOTE] = ACTIONS(5227),
    [sym_return] = ACTIONS(5225),
    [sym_next] = ACTIONS(5225),
    [sym_break] = ACTIONS(5225),
    [sym_true] = ACTIONS(5225),
    [sym_false] = ACTIONS(5225),
    [sym_null] = ACTIONS(5225),
    [sym_inf] = ACTIONS(5225),
    [sym_nan] = ACTIONS(5225),
    [anon_sym_NA] = ACTIONS(5225),
    [anon_sym_NA_integer_] = ACTIONS(5225),
    [anon_sym_NA_real_] = ACTIONS(5225),
    [anon_sym_NA_complex_] = ACTIONS(5225),
    [anon_sym_NA_character_] = ACTIONS(5225),
    [sym_dots] = ACTIONS(5225),
    [sym_dot_dot_i] = ACTIONS(5227),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5227),
    [sym__semicolon] = ACTIONS(5227),
    [sym__raw_string_literal] = ACTIONS(5227),
    [sym__external_else] = ACTIONS(6173),
    [sym__external_open_parenthesis] = ACTIONS(5987),
    [sym__external_open_brace] = ACTIONS(5227),
    [sym__external_open_bracket] = ACTIONS(5989),
    [sym__external_open_bracket2] = ACTIONS(5991),
  },
  [1266] = {
    [sym_call_arguments] = STATE(2923),
    [sym_subset_arguments] = STATE(2922),
    [sym_subset2_arguments] = STATE(2906),
    [sym__else] = STATE(4112),
    [sym__open_parenthesis] = STATE(1528),
    [sym__open_bracket] = STATE(1525),
    [sym__open_bracket2] = STATE(1519),
    [ts_builtin_sym_end] = ACTIONS(5167),
    [sym_identifier] = ACTIONS(5169),
    [anon_sym_BSLASH] = ACTIONS(5167),
    [anon_sym_function] = ACTIONS(5169),
    [anon_sym_EQ] = ACTIONS(5947),
    [anon_sym_if] = ACTIONS(5169),
    [anon_sym_for] = ACTIONS(5169),
    [anon_sym_while] = ACTIONS(5169),
    [anon_sym_repeat] = ACTIONS(5169),
    [anon_sym_QMARK] = ACTIONS(5167),
    [anon_sym_TILDE] = ACTIONS(5949),
    [anon_sym_BANG] = ACTIONS(5169),
    [anon_sym_PLUS] = ACTIONS(5951),
    [anon_sym_DASH] = ACTIONS(5953),
    [anon_sym_LT_DASH] = ACTIONS(5955),
    [anon_sym_LT_LT_DASH] = ACTIONS(5955),
    [anon_sym_COLON_EQ] = ACTIONS(5955),
    [anon_sym_DASH_GT] = ACTIONS(5957),
    [anon_sym_DASH_GT_GT] = ACTIONS(5959),
    [anon_sym_PIPE] = ACTIONS(5961),
    [anon_sym_AMP] = ACTIONS(5963),
    [anon_sym_PIPE_PIPE] = ACTIONS(5965),
    [anon_sym_AMP_AMP] = ACTIONS(5967),
    [anon_sym_LT] = ACTIONS(5969),
    [anon_sym_LT_EQ] = ACTIONS(5971),
    [anon_sym_GT] = ACTIONS(5969),
    [anon_sym_GT_EQ] = ACTIONS(5971),
    [anon_sym_EQ_EQ] = ACTIONS(5971),
    [anon_sym_BANG_EQ] = ACTIONS(5971),
    [anon_sym_STAR] = ACTIONS(5973),
    [anon_sym_SLASH] = ACTIONS(5975),
    [anon_sym_STAR_STAR] = ACTIONS(5977),
    [anon_sym_CARET] = ACTIONS(5977),
    [aux_sym_binary_operator_token1] = ACTIONS(5979),
    [anon_sym_PIPE_GT] = ACTIONS(5979),
    [anon_sym_COLON] = ACTIONS(5981),
    [anon_sym_DOLLAR] = ACTIONS(5983),
    [anon_sym_AT] = ACTIONS(5983),
    [aux_sym__hex_literal_token1] = ACTIONS(5167),
    [sym__number_literal] = ACTIONS(5169),
    [anon_sym_SQUOTE] = ACTIONS(5167),
    [anon_sym_DQUOTE] = ACTIONS(5167),
    [sym_return] = ACTIONS(5169),
    [sym_next] = ACTIONS(5169),
    [sym_break] = ACTIONS(5169),
    [sym_true] = ACTIONS(5169),
    [sym_false] = ACTIONS(5169),
    [sym_null] = ACTIONS(5169),
    [sym_inf] = ACTIONS(5169),
    [sym_nan] = ACTIONS(5169),
    [anon_sym_NA] = ACTIONS(5169),
    [anon_sym_NA_integer_] = ACTIONS(5169),
    [anon_sym_NA_real_] = ACTIONS(5169),
    [anon_sym_NA_complex_] = ACTIONS(5169),
    [anon_sym_NA_character_] = ACTIONS(5169),
    [sym_dots] = ACTIONS(5169),
    [sym_dot_dot_i] = ACTIONS(5167),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5167),
    [sym__semicolon] = ACTIONS(5167),
    [sym__raw_string_literal] = ACTIONS(5167),
    [sym__external_else] = ACTIONS(6175),
    [sym__external_open_parenthesis] = ACTIONS(5987),
    [sym__external_open_brace] = ACTIONS(5167),
    [sym__external_open_bracket] = ACTIONS(5989),
    [sym__external_open_bracket2] = ACTIONS(5991),
  },
  [1267] = {
    [sym_call_arguments] = STATE(2731),
    [sym_subset_arguments] = STATE(2730),
    [sym_subset2_arguments] = STATE(2729),
    [sym__open_parenthesis] = STATE(1357),
    [sym__open_bracket] = STATE(1353),
    [sym__open_bracket2] = STATE(1352),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5787),
    [anon_sym_DASH] = ACTIONS(5789),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5799),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5803),
    [anon_sym_LT] = ACTIONS(5805),
    [anon_sym_LT_EQ] = ACTIONS(5807),
    [anon_sym_GT] = ACTIONS(5805),
    [anon_sym_GT_EQ] = ACTIONS(5807),
    [anon_sym_EQ_EQ] = ACTIONS(5807),
    [anon_sym_BANG_EQ] = ACTIONS(5807),
    [anon_sym_STAR] = ACTIONS(5809),
    [anon_sym_SLASH] = ACTIONS(5811),
    [anon_sym_STAR_STAR] = ACTIONS(5813),
    [anon_sym_CARET] = ACTIONS(5813),
    [aux_sym_binary_operator_token1] = ACTIONS(5815),
    [anon_sym_PIPE_GT] = ACTIONS(5815),
    [anon_sym_COLON] = ACTIONS(5817),
    [anon_sym_DOLLAR] = ACTIONS(5819),
    [anon_sym_AT] = ACTIONS(5819),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5823),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5825),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(5827),
  },
  [1268] = {
    [sym_call_arguments] = STATE(2923),
    [sym_subset_arguments] = STATE(2922),
    [sym_subset2_arguments] = STATE(2906),
    [sym__else] = STATE(4110),
    [sym__open_parenthesis] = STATE(1528),
    [sym__open_bracket] = STATE(1525),
    [sym__open_bracket2] = STATE(1519),
    [ts_builtin_sym_end] = ACTIONS(5117),
    [sym_identifier] = ACTIONS(5115),
    [anon_sym_BSLASH] = ACTIONS(5117),
    [anon_sym_function] = ACTIONS(5115),
    [anon_sym_EQ] = ACTIONS(5947),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_for] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_repeat] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(5117),
    [anon_sym_TILDE] = ACTIONS(5949),
    [anon_sym_BANG] = ACTIONS(5115),
    [anon_sym_PLUS] = ACTIONS(5951),
    [anon_sym_DASH] = ACTIONS(5953),
    [anon_sym_LT_DASH] = ACTIONS(5955),
    [anon_sym_LT_LT_DASH] = ACTIONS(5955),
    [anon_sym_COLON_EQ] = ACTIONS(5955),
    [anon_sym_DASH_GT] = ACTIONS(5957),
    [anon_sym_DASH_GT_GT] = ACTIONS(5959),
    [anon_sym_PIPE] = ACTIONS(5961),
    [anon_sym_AMP] = ACTIONS(5963),
    [anon_sym_PIPE_PIPE] = ACTIONS(5965),
    [anon_sym_AMP_AMP] = ACTIONS(5967),
    [anon_sym_LT] = ACTIONS(5969),
    [anon_sym_LT_EQ] = ACTIONS(5971),
    [anon_sym_GT] = ACTIONS(5969),
    [anon_sym_GT_EQ] = ACTIONS(5971),
    [anon_sym_EQ_EQ] = ACTIONS(5971),
    [anon_sym_BANG_EQ] = ACTIONS(5971),
    [anon_sym_STAR] = ACTIONS(5973),
    [anon_sym_SLASH] = ACTIONS(5975),
    [anon_sym_STAR_STAR] = ACTIONS(5977),
    [anon_sym_CARET] = ACTIONS(5977),
    [aux_sym_binary_operator_token1] = ACTIONS(5979),
    [anon_sym_PIPE_GT] = ACTIONS(5979),
    [anon_sym_COLON] = ACTIONS(5981),
    [anon_sym_DOLLAR] = ACTIONS(5983),
    [anon_sym_AT] = ACTIONS(5983),
    [aux_sym__hex_literal_token1] = ACTIONS(5117),
    [sym__number_literal] = ACTIONS(5115),
    [anon_sym_SQUOTE] = ACTIONS(5117),
    [anon_sym_DQUOTE] = ACTIONS(5117),
    [sym_return] = ACTIONS(5115),
    [sym_next] = ACTIONS(5115),
    [sym_break] = ACTIONS(5115),
    [sym_true] = ACTIONS(5115),
    [sym_false] = ACTIONS(5115),
    [sym_null] = ACTIONS(5115),
    [sym_inf] = ACTIONS(5115),
    [sym_nan] = ACTIONS(5115),
    [anon_sym_NA] = ACTIONS(5115),
    [anon_sym_NA_integer_] = ACTIONS(5115),
    [anon_sym_NA_real_] = ACTIONS(5115),
    [anon_sym_NA_complex_] = ACTIONS(5115),
    [anon_sym_NA_character_] = ACTIONS(5115),
    [sym_dots] = ACTIONS(5115),
    [sym_dot_dot_i] = ACTIONS(5117),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5117),
    [sym__semicolon] = ACTIONS(5117),
    [sym__raw_string_literal] = ACTIONS(5117),
    [sym__external_else] = ACTIONS(6177),
    [sym__external_open_parenthesis] = ACTIONS(5987),
    [sym__external_open_brace] = ACTIONS(5117),
    [sym__external_open_bracket] = ACTIONS(5989),
    [sym__external_open_bracket2] = ACTIONS(5991),
  },
  [1269] = {
    [sym_call_arguments] = STATE(2731),
    [sym_subset_arguments] = STATE(2730),
    [sym_subset2_arguments] = STATE(2729),
    [sym__open_parenthesis] = STATE(1357),
    [sym__open_bracket] = STATE(1353),
    [sym__open_bracket2] = STATE(1352),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5787),
    [anon_sym_DASH] = ACTIONS(5789),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5805),
    [anon_sym_LT_EQ] = ACTIONS(5807),
    [anon_sym_GT] = ACTIONS(5805),
    [anon_sym_GT_EQ] = ACTIONS(5807),
    [anon_sym_EQ_EQ] = ACTIONS(5807),
    [anon_sym_BANG_EQ] = ACTIONS(5807),
    [anon_sym_STAR] = ACTIONS(5809),
    [anon_sym_SLASH] = ACTIONS(5811),
    [anon_sym_STAR_STAR] = ACTIONS(5813),
    [anon_sym_CARET] = ACTIONS(5813),
    [aux_sym_binary_operator_token1] = ACTIONS(5815),
    [anon_sym_PIPE_GT] = ACTIONS(5815),
    [anon_sym_COLON] = ACTIONS(5817),
    [anon_sym_DOLLAR] = ACTIONS(5819),
    [anon_sym_AT] = ACTIONS(5819),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5823),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5825),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(5827),
  },
  [1270] = {
    [sym_call_arguments] = STATE(2923),
    [sym_subset_arguments] = STATE(2922),
    [sym_subset2_arguments] = STATE(2906),
    [sym__else] = STATE(4109),
    [sym__open_parenthesis] = STATE(1528),
    [sym__open_bracket] = STATE(1525),
    [sym__open_bracket2] = STATE(1519),
    [ts_builtin_sym_end] = ACTIONS(5067),
    [sym_identifier] = ACTIONS(5065),
    [anon_sym_BSLASH] = ACTIONS(5067),
    [anon_sym_function] = ACTIONS(5065),
    [anon_sym_EQ] = ACTIONS(5947),
    [anon_sym_if] = ACTIONS(5065),
    [anon_sym_for] = ACTIONS(5065),
    [anon_sym_while] = ACTIONS(5065),
    [anon_sym_repeat] = ACTIONS(5065),
    [anon_sym_QMARK] = ACTIONS(5067),
    [anon_sym_TILDE] = ACTIONS(5949),
    [anon_sym_BANG] = ACTIONS(5065),
    [anon_sym_PLUS] = ACTIONS(5951),
    [anon_sym_DASH] = ACTIONS(5953),
    [anon_sym_LT_DASH] = ACTIONS(5955),
    [anon_sym_LT_LT_DASH] = ACTIONS(5955),
    [anon_sym_COLON_EQ] = ACTIONS(5955),
    [anon_sym_DASH_GT] = ACTIONS(5957),
    [anon_sym_DASH_GT_GT] = ACTIONS(5959),
    [anon_sym_PIPE] = ACTIONS(5961),
    [anon_sym_AMP] = ACTIONS(5963),
    [anon_sym_PIPE_PIPE] = ACTIONS(5965),
    [anon_sym_AMP_AMP] = ACTIONS(5967),
    [anon_sym_LT] = ACTIONS(5969),
    [anon_sym_LT_EQ] = ACTIONS(5971),
    [anon_sym_GT] = ACTIONS(5969),
    [anon_sym_GT_EQ] = ACTIONS(5971),
    [anon_sym_EQ_EQ] = ACTIONS(5971),
    [anon_sym_BANG_EQ] = ACTIONS(5971),
    [anon_sym_STAR] = ACTIONS(5973),
    [anon_sym_SLASH] = ACTIONS(5975),
    [anon_sym_STAR_STAR] = ACTIONS(5977),
    [anon_sym_CARET] = ACTIONS(5977),
    [aux_sym_binary_operator_token1] = ACTIONS(5979),
    [anon_sym_PIPE_GT] = ACTIONS(5979),
    [anon_sym_COLON] = ACTIONS(5981),
    [anon_sym_DOLLAR] = ACTIONS(5983),
    [anon_sym_AT] = ACTIONS(5983),
    [aux_sym__hex_literal_token1] = ACTIONS(5067),
    [sym__number_literal] = ACTIONS(5065),
    [anon_sym_SQUOTE] = ACTIONS(5067),
    [anon_sym_DQUOTE] = ACTIONS(5067),
    [sym_return] = ACTIONS(5065),
    [sym_next] = ACTIONS(5065),
    [sym_break] = ACTIONS(5065),
    [sym_true] = ACTIONS(5065),
    [sym_false] = ACTIONS(5065),
    [sym_null] = ACTIONS(5065),
    [sym_inf] = ACTIONS(5065),
    [sym_nan] = ACTIONS(5065),
    [anon_sym_NA] = ACTIONS(5065),
    [anon_sym_NA_integer_] = ACTIONS(5065),
    [anon_sym_NA_real_] = ACTIONS(5065),
    [anon_sym_NA_complex_] = ACTIONS(5065),
    [anon_sym_NA_character_] = ACTIONS(5065),
    [sym_dots] = ACTIONS(5065),
    [sym_dot_dot_i] = ACTIONS(5067),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5067),
    [sym__semicolon] = ACTIONS(5067),
    [sym__raw_string_literal] = ACTIONS(5067),
    [sym__external_else] = ACTIONS(6179),
    [sym__external_open_parenthesis] = ACTIONS(5987),
    [sym__external_open_brace] = ACTIONS(5067),
    [sym__external_open_bracket] = ACTIONS(5989),
    [sym__external_open_bracket2] = ACTIONS(5991),
  },
  [1271] = {
    [sym_call_arguments] = STATE(2731),
    [sym_subset_arguments] = STATE(2730),
    [sym_subset2_arguments] = STATE(2729),
    [sym__open_parenthesis] = STATE(1357),
    [sym__open_bracket] = STATE(1353),
    [sym__open_bracket2] = STATE(1352),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5787),
    [anon_sym_DASH] = ACTIONS(5789),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5809),
    [anon_sym_SLASH] = ACTIONS(5811),
    [anon_sym_STAR_STAR] = ACTIONS(5813),
    [anon_sym_CARET] = ACTIONS(5813),
    [aux_sym_binary_operator_token1] = ACTIONS(5815),
    [anon_sym_PIPE_GT] = ACTIONS(5815),
    [anon_sym_COLON] = ACTIONS(5817),
    [anon_sym_DOLLAR] = ACTIONS(5819),
    [anon_sym_AT] = ACTIONS(5819),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5823),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5825),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(5827),
  },
  [1272] = {
    [sym_call_arguments] = STATE(2731),
    [sym_subset_arguments] = STATE(2730),
    [sym_subset2_arguments] = STATE(2729),
    [sym__open_parenthesis] = STATE(1357),
    [sym__open_bracket] = STATE(1353),
    [sym__open_bracket2] = STATE(1352),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(5813),
    [anon_sym_CARET] = ACTIONS(5813),
    [aux_sym_binary_operator_token1] = ACTIONS(5815),
    [anon_sym_PIPE_GT] = ACTIONS(5815),
    [anon_sym_COLON] = ACTIONS(5817),
    [anon_sym_DOLLAR] = ACTIONS(5819),
    [anon_sym_AT] = ACTIONS(5819),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5823),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5825),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(5827),
  },
  [1273] = {
    [sym_call_arguments] = STATE(2731),
    [sym_subset_arguments] = STATE(2730),
    [sym_subset2_arguments] = STATE(2729),
    [sym__open_parenthesis] = STATE(1357),
    [sym__open_bracket] = STATE(1353),
    [sym__open_bracket2] = STATE(1352),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(5813),
    [anon_sym_CARET] = ACTIONS(5813),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(5351),
    [anon_sym_DOLLAR] = ACTIONS(5819),
    [anon_sym_AT] = ACTIONS(5819),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5823),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5825),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(5827),
  },
  [1274] = {
    [sym_call_arguments] = STATE(2731),
    [sym_subset_arguments] = STATE(2730),
    [sym_subset2_arguments] = STATE(2729),
    [sym__open_parenthesis] = STATE(1357),
    [sym__open_bracket] = STATE(1353),
    [sym__open_bracket2] = STATE(1352),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(5813),
    [anon_sym_CARET] = ACTIONS(5813),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(5817),
    [anon_sym_DOLLAR] = ACTIONS(5819),
    [anon_sym_AT] = ACTIONS(5819),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5823),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5825),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(5827),
  },
  [1275] = {
    [sym_call_arguments] = STATE(2731),
    [sym_subset_arguments] = STATE(2730),
    [sym_subset2_arguments] = STATE(2729),
    [sym__open_parenthesis] = STATE(1357),
    [sym__open_bracket] = STATE(1353),
    [sym__open_bracket2] = STATE(1352),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(5813),
    [anon_sym_CARET] = ACTIONS(5813),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(5351),
    [anon_sym_DOLLAR] = ACTIONS(5819),
    [anon_sym_AT] = ACTIONS(5819),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5823),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5825),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(5827),
  },
  [1276] = {
    [sym_call_arguments] = STATE(2731),
    [sym_subset_arguments] = STATE(2730),
    [sym_subset2_arguments] = STATE(2729),
    [sym__open_parenthesis] = STATE(1357),
    [sym__open_bracket] = STATE(1353),
    [sym__open_bracket2] = STATE(1352),
    [sym_identifier] = ACTIONS(5401),
    [anon_sym_BSLASH] = ACTIONS(5399),
    [anon_sym_function] = ACTIONS(5401),
    [anon_sym_EQ] = ACTIONS(5783),
    [anon_sym_if] = ACTIONS(5401),
    [anon_sym_for] = ACTIONS(5401),
    [anon_sym_while] = ACTIONS(5401),
    [anon_sym_repeat] = ACTIONS(5401),
    [anon_sym_QMARK] = ACTIONS(5399),
    [anon_sym_TILDE] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(5401),
    [anon_sym_PLUS] = ACTIONS(5787),
    [anon_sym_DASH] = ACTIONS(5789),
    [anon_sym_LT_DASH] = ACTIONS(5791),
    [anon_sym_LT_LT_DASH] = ACTIONS(5791),
    [anon_sym_COLON_EQ] = ACTIONS(5791),
    [anon_sym_DASH_GT] = ACTIONS(5793),
    [anon_sym_DASH_GT_GT] = ACTIONS(5795),
    [anon_sym_PIPE] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5799),
    [anon_sym_PIPE_PIPE] = ACTIONS(5801),
    [anon_sym_AMP_AMP] = ACTIONS(5803),
    [anon_sym_LT] = ACTIONS(5805),
    [anon_sym_LT_EQ] = ACTIONS(5807),
    [anon_sym_GT] = ACTIONS(5805),
    [anon_sym_GT_EQ] = ACTIONS(5807),
    [anon_sym_EQ_EQ] = ACTIONS(5807),
    [anon_sym_BANG_EQ] = ACTIONS(5807),
    [anon_sym_STAR] = ACTIONS(5809),
    [anon_sym_SLASH] = ACTIONS(5811),
    [anon_sym_STAR_STAR] = ACTIONS(5813),
    [anon_sym_CARET] = ACTIONS(5813),
    [aux_sym_binary_operator_token1] = ACTIONS(5815),
    [anon_sym_PIPE_GT] = ACTIONS(5815),
    [anon_sym_COLON] = ACTIONS(5817),
    [anon_sym_DOLLAR] = ACTIONS(5819),
    [anon_sym_AT] = ACTIONS(5819),
    [aux_sym__hex_literal_token1] = ACTIONS(5399),
    [sym__number_literal] = ACTIONS(5401),
    [anon_sym_SQUOTE] = ACTIONS(5399),
    [anon_sym_DQUOTE] = ACTIONS(5399),
    [sym_return] = ACTIONS(5401),
    [sym_next] = ACTIONS(5401),
    [sym_break] = ACTIONS(5401),
    [sym_true] = ACTIONS(5401),
    [sym_false] = ACTIONS(5401),
    [sym_null] = ACTIONS(5401),
    [sym_inf] = ACTIONS(5401),
    [sym_nan] = ACTIONS(5401),
    [anon_sym_NA] = ACTIONS(5401),
    [anon_sym_NA_integer_] = ACTIONS(5401),
    [anon_sym_NA_real_] = ACTIONS(5401),
    [anon_sym_NA_complex_] = ACTIONS(5401),
    [anon_sym_NA_character_] = ACTIONS(5401),
    [sym_dots] = ACTIONS(5401),
    [sym_dot_dot_i] = ACTIONS(5399),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5399),
    [sym__newline] = ACTIONS(5399),
    [sym__raw_string_literal] = ACTIONS(5399),
    [sym__external_else] = ACTIONS(5399),
    [sym__external_open_parenthesis] = ACTIONS(5823),
    [sym__external_close_parenthesis] = ACTIONS(5399),
    [sym__external_open_brace] = ACTIONS(5399),
    [sym__external_open_bracket] = ACTIONS(5825),
    [sym__external_close_bracket] = ACTIONS(5399),
    [sym__external_open_bracket2] = ACTIONS(5827),
  },
  [1277] = {
    [sym_call_arguments] = STATE(2731),
    [sym_subset_arguments] = STATE(2730),
    [sym_subset2_arguments] = STATE(2729),
    [sym__open_parenthesis] = STATE(1357),
    [sym__open_bracket] = STATE(1353),
    [sym__open_bracket2] = STATE(1352),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5783),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5787),
    [anon_sym_DASH] = ACTIONS(5789),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5793),
    [anon_sym_DASH_GT_GT] = ACTIONS(5795),
    [anon_sym_PIPE] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5799),
    [anon_sym_PIPE_PIPE] = ACTIONS(5801),
    [anon_sym_AMP_AMP] = ACTIONS(5803),
    [anon_sym_LT] = ACTIONS(5805),
    [anon_sym_LT_EQ] = ACTIONS(5807),
    [anon_sym_GT] = ACTIONS(5805),
    [anon_sym_GT_EQ] = ACTIONS(5807),
    [anon_sym_EQ_EQ] = ACTIONS(5807),
    [anon_sym_BANG_EQ] = ACTIONS(5807),
    [anon_sym_STAR] = ACTIONS(5809),
    [anon_sym_SLASH] = ACTIONS(5811),
    [anon_sym_STAR_STAR] = ACTIONS(5813),
    [anon_sym_CARET] = ACTIONS(5813),
    [aux_sym_binary_operator_token1] = ACTIONS(5815),
    [anon_sym_PIPE_GT] = ACTIONS(5815),
    [anon_sym_COLON] = ACTIONS(5817),
    [anon_sym_DOLLAR] = ACTIONS(5819),
    [anon_sym_AT] = ACTIONS(5819),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5823),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5825),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(5827),
  },
  [1278] = {
    [sym_call_arguments] = STATE(2731),
    [sym_subset_arguments] = STATE(2730),
    [sym_subset2_arguments] = STATE(2729),
    [sym__open_parenthesis] = STATE(1357),
    [sym__open_bracket] = STATE(1353),
    [sym__open_bracket2] = STATE(1352),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5783),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5787),
    [anon_sym_DASH] = ACTIONS(5789),
    [anon_sym_LT_DASH] = ACTIONS(5791),
    [anon_sym_LT_LT_DASH] = ACTIONS(5791),
    [anon_sym_COLON_EQ] = ACTIONS(5791),
    [anon_sym_DASH_GT] = ACTIONS(5793),
    [anon_sym_DASH_GT_GT] = ACTIONS(5795),
    [anon_sym_PIPE] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5799),
    [anon_sym_PIPE_PIPE] = ACTIONS(5801),
    [anon_sym_AMP_AMP] = ACTIONS(5803),
    [anon_sym_LT] = ACTIONS(5805),
    [anon_sym_LT_EQ] = ACTIONS(5807),
    [anon_sym_GT] = ACTIONS(5805),
    [anon_sym_GT_EQ] = ACTIONS(5807),
    [anon_sym_EQ_EQ] = ACTIONS(5807),
    [anon_sym_BANG_EQ] = ACTIONS(5807),
    [anon_sym_STAR] = ACTIONS(5809),
    [anon_sym_SLASH] = ACTIONS(5811),
    [anon_sym_STAR_STAR] = ACTIONS(5813),
    [anon_sym_CARET] = ACTIONS(5813),
    [aux_sym_binary_operator_token1] = ACTIONS(5815),
    [anon_sym_PIPE_GT] = ACTIONS(5815),
    [anon_sym_COLON] = ACTIONS(5817),
    [anon_sym_DOLLAR] = ACTIONS(5819),
    [anon_sym_AT] = ACTIONS(5819),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5823),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5825),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(5827),
  },
  [1279] = {
    [sym_call_arguments] = STATE(2731),
    [sym_subset_arguments] = STATE(2730),
    [sym_subset2_arguments] = STATE(2729),
    [sym__open_parenthesis] = STATE(1357),
    [sym__open_bracket] = STATE(1353),
    [sym__open_bracket2] = STATE(1352),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5787),
    [anon_sym_DASH] = ACTIONS(5789),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5799),
    [anon_sym_PIPE_PIPE] = ACTIONS(5801),
    [anon_sym_AMP_AMP] = ACTIONS(5803),
    [anon_sym_LT] = ACTIONS(5805),
    [anon_sym_LT_EQ] = ACTIONS(5807),
    [anon_sym_GT] = ACTIONS(5805),
    [anon_sym_GT_EQ] = ACTIONS(5807),
    [anon_sym_EQ_EQ] = ACTIONS(5807),
    [anon_sym_BANG_EQ] = ACTIONS(5807),
    [anon_sym_STAR] = ACTIONS(5809),
    [anon_sym_SLASH] = ACTIONS(5811),
    [anon_sym_STAR_STAR] = ACTIONS(5813),
    [anon_sym_CARET] = ACTIONS(5813),
    [aux_sym_binary_operator_token1] = ACTIONS(5815),
    [anon_sym_PIPE_GT] = ACTIONS(5815),
    [anon_sym_COLON] = ACTIONS(5817),
    [anon_sym_DOLLAR] = ACTIONS(5819),
    [anon_sym_AT] = ACTIONS(5819),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5823),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5825),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(5827),
  },
  [1280] = {
    [sym_call_arguments] = STATE(2845),
    [sym_subset_arguments] = STATE(2849),
    [sym_subset2_arguments] = STATE(2852),
    [sym__else] = STATE(4180),
    [sym__open_parenthesis] = STATE(1372),
    [sym__open_bracket] = STATE(1371),
    [sym__open_bracket2] = STATE(1370),
    [sym_identifier] = ACTIONS(5065),
    [anon_sym_BSLASH] = ACTIONS(5067),
    [anon_sym_function] = ACTIONS(5065),
    [anon_sym_EQ] = ACTIONS(6181),
    [anon_sym_if] = ACTIONS(5065),
    [anon_sym_for] = ACTIONS(5065),
    [anon_sym_while] = ACTIONS(5065),
    [anon_sym_repeat] = ACTIONS(5065),
    [anon_sym_QMARK] = ACTIONS(5067),
    [anon_sym_TILDE] = ACTIONS(6183),
    [anon_sym_BANG] = ACTIONS(5065),
    [anon_sym_PLUS] = ACTIONS(6185),
    [anon_sym_DASH] = ACTIONS(6187),
    [anon_sym_LT_DASH] = ACTIONS(6189),
    [anon_sym_LT_LT_DASH] = ACTIONS(6189),
    [anon_sym_COLON_EQ] = ACTIONS(6189),
    [anon_sym_DASH_GT] = ACTIONS(6191),
    [anon_sym_DASH_GT_GT] = ACTIONS(6193),
    [anon_sym_PIPE] = ACTIONS(6195),
    [anon_sym_AMP] = ACTIONS(6197),
    [anon_sym_PIPE_PIPE] = ACTIONS(6199),
    [anon_sym_AMP_AMP] = ACTIONS(6201),
    [anon_sym_LT] = ACTIONS(6203),
    [anon_sym_LT_EQ] = ACTIONS(6205),
    [anon_sym_GT] = ACTIONS(6203),
    [anon_sym_GT_EQ] = ACTIONS(6205),
    [anon_sym_EQ_EQ] = ACTIONS(6205),
    [anon_sym_BANG_EQ] = ACTIONS(6205),
    [anon_sym_STAR] = ACTIONS(6207),
    [anon_sym_SLASH] = ACTIONS(6209),
    [anon_sym_STAR_STAR] = ACTIONS(6211),
    [anon_sym_CARET] = ACTIONS(6211),
    [aux_sym_binary_operator_token1] = ACTIONS(6213),
    [anon_sym_PIPE_GT] = ACTIONS(6213),
    [anon_sym_COLON] = ACTIONS(6215),
    [anon_sym_DOLLAR] = ACTIONS(6217),
    [anon_sym_AT] = ACTIONS(6217),
    [aux_sym__hex_literal_token1] = ACTIONS(5067),
    [sym__number_literal] = ACTIONS(5065),
    [anon_sym_SQUOTE] = ACTIONS(5067),
    [anon_sym_DQUOTE] = ACTIONS(5067),
    [sym_return] = ACTIONS(5065),
    [sym_next] = ACTIONS(5065),
    [sym_break] = ACTIONS(5065),
    [sym_true] = ACTIONS(5065),
    [sym_false] = ACTIONS(5065),
    [sym_null] = ACTIONS(5065),
    [sym_inf] = ACTIONS(5065),
    [sym_nan] = ACTIONS(5065),
    [anon_sym_NA] = ACTIONS(5065),
    [anon_sym_NA_integer_] = ACTIONS(5065),
    [anon_sym_NA_real_] = ACTIONS(5065),
    [anon_sym_NA_complex_] = ACTIONS(5065),
    [anon_sym_NA_character_] = ACTIONS(5065),
    [sym_dots] = ACTIONS(5065),
    [sym_dot_dot_i] = ACTIONS(5067),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5067),
    [sym__newline] = ACTIONS(5067),
    [sym__raw_string_literal] = ACTIONS(5067),
    [sym__external_else] = ACTIONS(6219),
    [sym__external_open_parenthesis] = ACTIONS(6221),
    [sym__external_close_parenthesis] = ACTIONS(5067),
    [sym__external_open_brace] = ACTIONS(5067),
    [sym__external_open_bracket] = ACTIONS(6223),
    [sym__external_open_bracket2] = ACTIONS(6225),
  },
  [1281] = {
    [sym_call_arguments] = STATE(2731),
    [sym_subset_arguments] = STATE(2730),
    [sym_subset2_arguments] = STATE(2729),
    [sym__open_parenthesis] = STATE(1357),
    [sym__open_bracket] = STATE(1353),
    [sym__open_bracket2] = STATE(1352),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5809),
    [anon_sym_SLASH] = ACTIONS(5811),
    [anon_sym_STAR_STAR] = ACTIONS(5813),
    [anon_sym_CARET] = ACTIONS(5813),
    [aux_sym_binary_operator_token1] = ACTIONS(5815),
    [anon_sym_PIPE_GT] = ACTIONS(5815),
    [anon_sym_COLON] = ACTIONS(5817),
    [anon_sym_DOLLAR] = ACTIONS(5819),
    [anon_sym_AT] = ACTIONS(5819),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5823),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5825),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(5827),
  },
  [1282] = {
    [sym_call_arguments] = STATE(2731),
    [sym_subset_arguments] = STATE(2730),
    [sym_subset2_arguments] = STATE(2729),
    [sym__open_parenthesis] = STATE(1357),
    [sym__open_bracket] = STATE(1353),
    [sym__open_bracket2] = STATE(1352),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5783),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5787),
    [anon_sym_DASH] = ACTIONS(5789),
    [anon_sym_LT_DASH] = ACTIONS(5791),
    [anon_sym_LT_LT_DASH] = ACTIONS(5791),
    [anon_sym_COLON_EQ] = ACTIONS(5791),
    [anon_sym_DASH_GT] = ACTIONS(5793),
    [anon_sym_DASH_GT_GT] = ACTIONS(5795),
    [anon_sym_PIPE] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5799),
    [anon_sym_PIPE_PIPE] = ACTIONS(5801),
    [anon_sym_AMP_AMP] = ACTIONS(5803),
    [anon_sym_LT] = ACTIONS(5805),
    [anon_sym_LT_EQ] = ACTIONS(5807),
    [anon_sym_GT] = ACTIONS(5805),
    [anon_sym_GT_EQ] = ACTIONS(5807),
    [anon_sym_EQ_EQ] = ACTIONS(5807),
    [anon_sym_BANG_EQ] = ACTIONS(5807),
    [anon_sym_STAR] = ACTIONS(5809),
    [anon_sym_SLASH] = ACTIONS(5811),
    [anon_sym_STAR_STAR] = ACTIONS(5813),
    [anon_sym_CARET] = ACTIONS(5813),
    [aux_sym_binary_operator_token1] = ACTIONS(5815),
    [anon_sym_PIPE_GT] = ACTIONS(5815),
    [anon_sym_COLON] = ACTIONS(5817),
    [anon_sym_DOLLAR] = ACTIONS(5819),
    [anon_sym_AT] = ACTIONS(5819),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5823),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5825),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(5827),
  },
  [1283] = {
    [sym_call_arguments] = STATE(2845),
    [sym_subset_arguments] = STATE(2849),
    [sym_subset2_arguments] = STATE(2852),
    [sym__else] = STATE(4285),
    [sym__open_parenthesis] = STATE(1372),
    [sym__open_bracket] = STATE(1371),
    [sym__open_bracket2] = STATE(1370),
    [sym_identifier] = ACTIONS(5225),
    [anon_sym_BSLASH] = ACTIONS(5227),
    [anon_sym_function] = ACTIONS(5225),
    [anon_sym_EQ] = ACTIONS(6181),
    [anon_sym_if] = ACTIONS(5225),
    [anon_sym_for] = ACTIONS(5225),
    [anon_sym_while] = ACTIONS(5225),
    [anon_sym_repeat] = ACTIONS(5225),
    [anon_sym_QMARK] = ACTIONS(5227),
    [anon_sym_TILDE] = ACTIONS(6183),
    [anon_sym_BANG] = ACTIONS(5225),
    [anon_sym_PLUS] = ACTIONS(6185),
    [anon_sym_DASH] = ACTIONS(6187),
    [anon_sym_LT_DASH] = ACTIONS(6189),
    [anon_sym_LT_LT_DASH] = ACTIONS(6189),
    [anon_sym_COLON_EQ] = ACTIONS(6189),
    [anon_sym_DASH_GT] = ACTIONS(6191),
    [anon_sym_DASH_GT_GT] = ACTIONS(6193),
    [anon_sym_PIPE] = ACTIONS(6195),
    [anon_sym_AMP] = ACTIONS(6197),
    [anon_sym_PIPE_PIPE] = ACTIONS(6199),
    [anon_sym_AMP_AMP] = ACTIONS(6201),
    [anon_sym_LT] = ACTIONS(6203),
    [anon_sym_LT_EQ] = ACTIONS(6205),
    [anon_sym_GT] = ACTIONS(6203),
    [anon_sym_GT_EQ] = ACTIONS(6205),
    [anon_sym_EQ_EQ] = ACTIONS(6205),
    [anon_sym_BANG_EQ] = ACTIONS(6205),
    [anon_sym_STAR] = ACTIONS(6207),
    [anon_sym_SLASH] = ACTIONS(6209),
    [anon_sym_STAR_STAR] = ACTIONS(6211),
    [anon_sym_CARET] = ACTIONS(6211),
    [aux_sym_binary_operator_token1] = ACTIONS(6213),
    [anon_sym_PIPE_GT] = ACTIONS(6213),
    [anon_sym_COLON] = ACTIONS(6215),
    [anon_sym_DOLLAR] = ACTIONS(6217),
    [anon_sym_AT] = ACTIONS(6217),
    [aux_sym__hex_literal_token1] = ACTIONS(5227),
    [sym__number_literal] = ACTIONS(5225),
    [anon_sym_SQUOTE] = ACTIONS(5227),
    [anon_sym_DQUOTE] = ACTIONS(5227),
    [sym_return] = ACTIONS(5225),
    [sym_next] = ACTIONS(5225),
    [sym_break] = ACTIONS(5225),
    [sym_true] = ACTIONS(5225),
    [sym_false] = ACTIONS(5225),
    [sym_null] = ACTIONS(5225),
    [sym_inf] = ACTIONS(5225),
    [sym_nan] = ACTIONS(5225),
    [anon_sym_NA] = ACTIONS(5225),
    [anon_sym_NA_integer_] = ACTIONS(5225),
    [anon_sym_NA_real_] = ACTIONS(5225),
    [anon_sym_NA_complex_] = ACTIONS(5225),
    [anon_sym_NA_character_] = ACTIONS(5225),
    [sym_dots] = ACTIONS(5225),
    [sym_dot_dot_i] = ACTIONS(5227),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5227),
    [sym__newline] = ACTIONS(5227),
    [sym__raw_string_literal] = ACTIONS(5227),
    [sym__external_else] = ACTIONS(6227),
    [sym__external_open_parenthesis] = ACTIONS(6221),
    [sym__external_close_parenthesis] = ACTIONS(5227),
    [sym__external_open_brace] = ACTIONS(5227),
    [sym__external_open_bracket] = ACTIONS(6223),
    [sym__external_open_bracket2] = ACTIONS(6225),
  },
  [1284] = {
    [sym_call_arguments] = STATE(2731),
    [sym_subset_arguments] = STATE(2730),
    [sym_subset2_arguments] = STATE(2729),
    [sym__open_parenthesis] = STATE(1357),
    [sym__open_bracket] = STATE(1353),
    [sym__open_bracket2] = STATE(1352),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5787),
    [anon_sym_DASH] = ACTIONS(5789),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5799),
    [anon_sym_PIPE_PIPE] = ACTIONS(5801),
    [anon_sym_AMP_AMP] = ACTIONS(5803),
    [anon_sym_LT] = ACTIONS(5805),
    [anon_sym_LT_EQ] = ACTIONS(5807),
    [anon_sym_GT] = ACTIONS(5805),
    [anon_sym_GT_EQ] = ACTIONS(5807),
    [anon_sym_EQ_EQ] = ACTIONS(5807),
    [anon_sym_BANG_EQ] = ACTIONS(5807),
    [anon_sym_STAR] = ACTIONS(5809),
    [anon_sym_SLASH] = ACTIONS(5811),
    [anon_sym_STAR_STAR] = ACTIONS(5813),
    [anon_sym_CARET] = ACTIONS(5813),
    [aux_sym_binary_operator_token1] = ACTIONS(5815),
    [anon_sym_PIPE_GT] = ACTIONS(5815),
    [anon_sym_COLON] = ACTIONS(5817),
    [anon_sym_DOLLAR] = ACTIONS(5819),
    [anon_sym_AT] = ACTIONS(5819),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5823),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5825),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(5827),
  },
  [1285] = {
    [sym_call_arguments] = STATE(2731),
    [sym_subset_arguments] = STATE(2730),
    [sym_subset2_arguments] = STATE(2729),
    [sym__open_parenthesis] = STATE(1357),
    [sym__open_bracket] = STATE(1353),
    [sym__open_bracket2] = STATE(1352),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5787),
    [anon_sym_DASH] = ACTIONS(5789),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5799),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5803),
    [anon_sym_LT] = ACTIONS(5805),
    [anon_sym_LT_EQ] = ACTIONS(5807),
    [anon_sym_GT] = ACTIONS(5805),
    [anon_sym_GT_EQ] = ACTIONS(5807),
    [anon_sym_EQ_EQ] = ACTIONS(5807),
    [anon_sym_BANG_EQ] = ACTIONS(5807),
    [anon_sym_STAR] = ACTIONS(5809),
    [anon_sym_SLASH] = ACTIONS(5811),
    [anon_sym_STAR_STAR] = ACTIONS(5813),
    [anon_sym_CARET] = ACTIONS(5813),
    [aux_sym_binary_operator_token1] = ACTIONS(5815),
    [anon_sym_PIPE_GT] = ACTIONS(5815),
    [anon_sym_COLON] = ACTIONS(5817),
    [anon_sym_DOLLAR] = ACTIONS(5819),
    [anon_sym_AT] = ACTIONS(5819),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5823),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5825),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(5827),
  },
  [1286] = {
    [sym_call_arguments] = STATE(2845),
    [sym_subset_arguments] = STATE(2849),
    [sym_subset2_arguments] = STATE(2852),
    [sym__else] = STATE(4185),
    [sym__open_parenthesis] = STATE(1372),
    [sym__open_bracket] = STATE(1371),
    [sym__open_bracket2] = STATE(1370),
    [sym_identifier] = ACTIONS(5169),
    [anon_sym_BSLASH] = ACTIONS(5167),
    [anon_sym_function] = ACTIONS(5169),
    [anon_sym_EQ] = ACTIONS(6181),
    [anon_sym_if] = ACTIONS(5169),
    [anon_sym_for] = ACTIONS(5169),
    [anon_sym_while] = ACTIONS(5169),
    [anon_sym_repeat] = ACTIONS(5169),
    [anon_sym_QMARK] = ACTIONS(5167),
    [anon_sym_TILDE] = ACTIONS(6183),
    [anon_sym_BANG] = ACTIONS(5169),
    [anon_sym_PLUS] = ACTIONS(6185),
    [anon_sym_DASH] = ACTIONS(6187),
    [anon_sym_LT_DASH] = ACTIONS(6189),
    [anon_sym_LT_LT_DASH] = ACTIONS(6189),
    [anon_sym_COLON_EQ] = ACTIONS(6189),
    [anon_sym_DASH_GT] = ACTIONS(6191),
    [anon_sym_DASH_GT_GT] = ACTIONS(6193),
    [anon_sym_PIPE] = ACTIONS(6195),
    [anon_sym_AMP] = ACTIONS(6197),
    [anon_sym_PIPE_PIPE] = ACTIONS(6199),
    [anon_sym_AMP_AMP] = ACTIONS(6201),
    [anon_sym_LT] = ACTIONS(6203),
    [anon_sym_LT_EQ] = ACTIONS(6205),
    [anon_sym_GT] = ACTIONS(6203),
    [anon_sym_GT_EQ] = ACTIONS(6205),
    [anon_sym_EQ_EQ] = ACTIONS(6205),
    [anon_sym_BANG_EQ] = ACTIONS(6205),
    [anon_sym_STAR] = ACTIONS(6207),
    [anon_sym_SLASH] = ACTIONS(6209),
    [anon_sym_STAR_STAR] = ACTIONS(6211),
    [anon_sym_CARET] = ACTIONS(6211),
    [aux_sym_binary_operator_token1] = ACTIONS(6213),
    [anon_sym_PIPE_GT] = ACTIONS(6213),
    [anon_sym_COLON] = ACTIONS(6215),
    [anon_sym_DOLLAR] = ACTIONS(6217),
    [anon_sym_AT] = ACTIONS(6217),
    [aux_sym__hex_literal_token1] = ACTIONS(5167),
    [sym__number_literal] = ACTIONS(5169),
    [anon_sym_SQUOTE] = ACTIONS(5167),
    [anon_sym_DQUOTE] = ACTIONS(5167),
    [sym_return] = ACTIONS(5169),
    [sym_next] = ACTIONS(5169),
    [sym_break] = ACTIONS(5169),
    [sym_true] = ACTIONS(5169),
    [sym_false] = ACTIONS(5169),
    [sym_null] = ACTIONS(5169),
    [sym_inf] = ACTIONS(5169),
    [sym_nan] = ACTIONS(5169),
    [anon_sym_NA] = ACTIONS(5169),
    [anon_sym_NA_integer_] = ACTIONS(5169),
    [anon_sym_NA_real_] = ACTIONS(5169),
    [anon_sym_NA_complex_] = ACTIONS(5169),
    [anon_sym_NA_character_] = ACTIONS(5169),
    [sym_dots] = ACTIONS(5169),
    [sym_dot_dot_i] = ACTIONS(5167),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5167),
    [sym__newline] = ACTIONS(5167),
    [sym__raw_string_literal] = ACTIONS(5167),
    [sym__external_else] = ACTIONS(6229),
    [sym__external_open_parenthesis] = ACTIONS(6221),
    [sym__external_close_parenthesis] = ACTIONS(5167),
    [sym__external_open_brace] = ACTIONS(5167),
    [sym__external_open_bracket] = ACTIONS(6223),
    [sym__external_open_bracket2] = ACTIONS(6225),
  },
  [1287] = {
    [sym_call_arguments] = STATE(2845),
    [sym_subset_arguments] = STATE(2849),
    [sym_subset2_arguments] = STATE(2852),
    [sym__else] = STATE(4188),
    [sym__open_parenthesis] = STATE(1372),
    [sym__open_bracket] = STATE(1371),
    [sym__open_bracket2] = STATE(1370),
    [sym_identifier] = ACTIONS(5115),
    [anon_sym_BSLASH] = ACTIONS(5117),
    [anon_sym_function] = ACTIONS(5115),
    [anon_sym_EQ] = ACTIONS(6181),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_for] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_repeat] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(5117),
    [anon_sym_TILDE] = ACTIONS(6183),
    [anon_sym_BANG] = ACTIONS(5115),
    [anon_sym_PLUS] = ACTIONS(6185),
    [anon_sym_DASH] = ACTIONS(6187),
    [anon_sym_LT_DASH] = ACTIONS(6189),
    [anon_sym_LT_LT_DASH] = ACTIONS(6189),
    [anon_sym_COLON_EQ] = ACTIONS(6189),
    [anon_sym_DASH_GT] = ACTIONS(6191),
    [anon_sym_DASH_GT_GT] = ACTIONS(6193),
    [anon_sym_PIPE] = ACTIONS(6195),
    [anon_sym_AMP] = ACTIONS(6197),
    [anon_sym_PIPE_PIPE] = ACTIONS(6199),
    [anon_sym_AMP_AMP] = ACTIONS(6201),
    [anon_sym_LT] = ACTIONS(6203),
    [anon_sym_LT_EQ] = ACTIONS(6205),
    [anon_sym_GT] = ACTIONS(6203),
    [anon_sym_GT_EQ] = ACTIONS(6205),
    [anon_sym_EQ_EQ] = ACTIONS(6205),
    [anon_sym_BANG_EQ] = ACTIONS(6205),
    [anon_sym_STAR] = ACTIONS(6207),
    [anon_sym_SLASH] = ACTIONS(6209),
    [anon_sym_STAR_STAR] = ACTIONS(6211),
    [anon_sym_CARET] = ACTIONS(6211),
    [aux_sym_binary_operator_token1] = ACTIONS(6213),
    [anon_sym_PIPE_GT] = ACTIONS(6213),
    [anon_sym_COLON] = ACTIONS(6215),
    [anon_sym_DOLLAR] = ACTIONS(6217),
    [anon_sym_AT] = ACTIONS(6217),
    [aux_sym__hex_literal_token1] = ACTIONS(5117),
    [sym__number_literal] = ACTIONS(5115),
    [anon_sym_SQUOTE] = ACTIONS(5117),
    [anon_sym_DQUOTE] = ACTIONS(5117),
    [sym_return] = ACTIONS(5115),
    [sym_next] = ACTIONS(5115),
    [sym_break] = ACTIONS(5115),
    [sym_true] = ACTIONS(5115),
    [sym_false] = ACTIONS(5115),
    [sym_null] = ACTIONS(5115),
    [sym_inf] = ACTIONS(5115),
    [sym_nan] = ACTIONS(5115),
    [anon_sym_NA] = ACTIONS(5115),
    [anon_sym_NA_integer_] = ACTIONS(5115),
    [anon_sym_NA_real_] = ACTIONS(5115),
    [anon_sym_NA_complex_] = ACTIONS(5115),
    [anon_sym_NA_character_] = ACTIONS(5115),
    [sym_dots] = ACTIONS(5115),
    [sym_dot_dot_i] = ACTIONS(5117),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5117),
    [sym__newline] = ACTIONS(5117),
    [sym__raw_string_literal] = ACTIONS(5117),
    [sym__external_else] = ACTIONS(6231),
    [sym__external_open_parenthesis] = ACTIONS(6221),
    [sym__external_close_parenthesis] = ACTIONS(5117),
    [sym__external_open_brace] = ACTIONS(5117),
    [sym__external_open_bracket] = ACTIONS(6223),
    [sym__external_open_bracket2] = ACTIONS(6225),
  },
  [1288] = {
    [sym_call_arguments] = STATE(2845),
    [sym_subset_arguments] = STATE(2849),
    [sym_subset2_arguments] = STATE(2852),
    [sym__else] = STATE(4200),
    [sym__open_parenthesis] = STATE(1372),
    [sym__open_bracket] = STATE(1371),
    [sym__open_bracket2] = STATE(1370),
    [sym_identifier] = ACTIONS(5169),
    [anon_sym_BSLASH] = ACTIONS(5167),
    [anon_sym_function] = ACTIONS(5169),
    [anon_sym_EQ] = ACTIONS(6181),
    [anon_sym_if] = ACTIONS(5169),
    [anon_sym_for] = ACTIONS(5169),
    [anon_sym_while] = ACTIONS(5169),
    [anon_sym_repeat] = ACTIONS(5169),
    [anon_sym_QMARK] = ACTIONS(5167),
    [anon_sym_TILDE] = ACTIONS(6183),
    [anon_sym_BANG] = ACTIONS(5169),
    [anon_sym_PLUS] = ACTIONS(6185),
    [anon_sym_DASH] = ACTIONS(6187),
    [anon_sym_LT_DASH] = ACTIONS(6189),
    [anon_sym_LT_LT_DASH] = ACTIONS(6189),
    [anon_sym_COLON_EQ] = ACTIONS(6189),
    [anon_sym_DASH_GT] = ACTIONS(6191),
    [anon_sym_DASH_GT_GT] = ACTIONS(6193),
    [anon_sym_PIPE] = ACTIONS(6195),
    [anon_sym_AMP] = ACTIONS(6197),
    [anon_sym_PIPE_PIPE] = ACTIONS(6199),
    [anon_sym_AMP_AMP] = ACTIONS(6201),
    [anon_sym_LT] = ACTIONS(6203),
    [anon_sym_LT_EQ] = ACTIONS(6205),
    [anon_sym_GT] = ACTIONS(6203),
    [anon_sym_GT_EQ] = ACTIONS(6205),
    [anon_sym_EQ_EQ] = ACTIONS(6205),
    [anon_sym_BANG_EQ] = ACTIONS(6205),
    [anon_sym_STAR] = ACTIONS(6207),
    [anon_sym_SLASH] = ACTIONS(6209),
    [anon_sym_STAR_STAR] = ACTIONS(6211),
    [anon_sym_CARET] = ACTIONS(6211),
    [aux_sym_binary_operator_token1] = ACTIONS(6213),
    [anon_sym_PIPE_GT] = ACTIONS(6213),
    [anon_sym_COLON] = ACTIONS(6215),
    [anon_sym_DOLLAR] = ACTIONS(6217),
    [anon_sym_AT] = ACTIONS(6217),
    [aux_sym__hex_literal_token1] = ACTIONS(5167),
    [sym__number_literal] = ACTIONS(5169),
    [anon_sym_SQUOTE] = ACTIONS(5167),
    [anon_sym_DQUOTE] = ACTIONS(5167),
    [sym_return] = ACTIONS(5169),
    [sym_next] = ACTIONS(5169),
    [sym_break] = ACTIONS(5169),
    [sym_true] = ACTIONS(5169),
    [sym_false] = ACTIONS(5169),
    [sym_null] = ACTIONS(5169),
    [sym_inf] = ACTIONS(5169),
    [sym_nan] = ACTIONS(5169),
    [anon_sym_NA] = ACTIONS(5169),
    [anon_sym_NA_integer_] = ACTIONS(5169),
    [anon_sym_NA_real_] = ACTIONS(5169),
    [anon_sym_NA_complex_] = ACTIONS(5169),
    [anon_sym_NA_character_] = ACTIONS(5169),
    [sym_dots] = ACTIONS(5169),
    [sym_dot_dot_i] = ACTIONS(5167),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5167),
    [sym__newline] = ACTIONS(5167),
    [sym__raw_string_literal] = ACTIONS(5167),
    [sym__external_else] = ACTIONS(6233),
    [sym__external_open_parenthesis] = ACTIONS(6221),
    [sym__external_close_parenthesis] = ACTIONS(5167),
    [sym__external_open_brace] = ACTIONS(5167),
    [sym__external_open_bracket] = ACTIONS(6223),
    [sym__external_open_bracket2] = ACTIONS(6225),
  },
  [1289] = {
    [sym_call_arguments] = STATE(2845),
    [sym_subset_arguments] = STATE(2849),
    [sym_subset2_arguments] = STATE(2852),
    [sym__else] = STATE(4186),
    [sym__open_parenthesis] = STATE(1372),
    [sym__open_bracket] = STATE(1371),
    [sym__open_bracket2] = STATE(1370),
    [sym_identifier] = ACTIONS(5115),
    [anon_sym_BSLASH] = ACTIONS(5117),
    [anon_sym_function] = ACTIONS(5115),
    [anon_sym_EQ] = ACTIONS(6181),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_for] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_repeat] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(5117),
    [anon_sym_TILDE] = ACTIONS(6183),
    [anon_sym_BANG] = ACTIONS(5115),
    [anon_sym_PLUS] = ACTIONS(6185),
    [anon_sym_DASH] = ACTIONS(6187),
    [anon_sym_LT_DASH] = ACTIONS(6189),
    [anon_sym_LT_LT_DASH] = ACTIONS(6189),
    [anon_sym_COLON_EQ] = ACTIONS(6189),
    [anon_sym_DASH_GT] = ACTIONS(6191),
    [anon_sym_DASH_GT_GT] = ACTIONS(6193),
    [anon_sym_PIPE] = ACTIONS(6195),
    [anon_sym_AMP] = ACTIONS(6197),
    [anon_sym_PIPE_PIPE] = ACTIONS(6199),
    [anon_sym_AMP_AMP] = ACTIONS(6201),
    [anon_sym_LT] = ACTIONS(6203),
    [anon_sym_LT_EQ] = ACTIONS(6205),
    [anon_sym_GT] = ACTIONS(6203),
    [anon_sym_GT_EQ] = ACTIONS(6205),
    [anon_sym_EQ_EQ] = ACTIONS(6205),
    [anon_sym_BANG_EQ] = ACTIONS(6205),
    [anon_sym_STAR] = ACTIONS(6207),
    [anon_sym_SLASH] = ACTIONS(6209),
    [anon_sym_STAR_STAR] = ACTIONS(6211),
    [anon_sym_CARET] = ACTIONS(6211),
    [aux_sym_binary_operator_token1] = ACTIONS(6213),
    [anon_sym_PIPE_GT] = ACTIONS(6213),
    [anon_sym_COLON] = ACTIONS(6215),
    [anon_sym_DOLLAR] = ACTIONS(6217),
    [anon_sym_AT] = ACTIONS(6217),
    [aux_sym__hex_literal_token1] = ACTIONS(5117),
    [sym__number_literal] = ACTIONS(5115),
    [anon_sym_SQUOTE] = ACTIONS(5117),
    [anon_sym_DQUOTE] = ACTIONS(5117),
    [sym_return] = ACTIONS(5115),
    [sym_next] = ACTIONS(5115),
    [sym_break] = ACTIONS(5115),
    [sym_true] = ACTIONS(5115),
    [sym_false] = ACTIONS(5115),
    [sym_null] = ACTIONS(5115),
    [sym_inf] = ACTIONS(5115),
    [sym_nan] = ACTIONS(5115),
    [anon_sym_NA] = ACTIONS(5115),
    [anon_sym_NA_integer_] = ACTIONS(5115),
    [anon_sym_NA_real_] = ACTIONS(5115),
    [anon_sym_NA_complex_] = ACTIONS(5115),
    [anon_sym_NA_character_] = ACTIONS(5115),
    [sym_dots] = ACTIONS(5115),
    [sym_dot_dot_i] = ACTIONS(5117),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5117),
    [sym__newline] = ACTIONS(5117),
    [sym__raw_string_literal] = ACTIONS(5117),
    [sym__external_else] = ACTIONS(6235),
    [sym__external_open_parenthesis] = ACTIONS(6221),
    [sym__external_close_parenthesis] = ACTIONS(5117),
    [sym__external_open_brace] = ACTIONS(5117),
    [sym__external_open_bracket] = ACTIONS(6223),
    [sym__external_open_bracket2] = ACTIONS(6225),
  },
  [1290] = {
    [sym_call_arguments] = STATE(2845),
    [sym_subset_arguments] = STATE(2849),
    [sym_subset2_arguments] = STATE(2852),
    [sym__else] = STATE(4187),
    [sym__open_parenthesis] = STATE(1372),
    [sym__open_bracket] = STATE(1371),
    [sym__open_bracket2] = STATE(1370),
    [sym_identifier] = ACTIONS(5065),
    [anon_sym_BSLASH] = ACTIONS(5067),
    [anon_sym_function] = ACTIONS(5065),
    [anon_sym_EQ] = ACTIONS(6181),
    [anon_sym_if] = ACTIONS(5065),
    [anon_sym_for] = ACTIONS(5065),
    [anon_sym_while] = ACTIONS(5065),
    [anon_sym_repeat] = ACTIONS(5065),
    [anon_sym_QMARK] = ACTIONS(5067),
    [anon_sym_TILDE] = ACTIONS(6183),
    [anon_sym_BANG] = ACTIONS(5065),
    [anon_sym_PLUS] = ACTIONS(6185),
    [anon_sym_DASH] = ACTIONS(6187),
    [anon_sym_LT_DASH] = ACTIONS(6189),
    [anon_sym_LT_LT_DASH] = ACTIONS(6189),
    [anon_sym_COLON_EQ] = ACTIONS(6189),
    [anon_sym_DASH_GT] = ACTIONS(6191),
    [anon_sym_DASH_GT_GT] = ACTIONS(6193),
    [anon_sym_PIPE] = ACTIONS(6195),
    [anon_sym_AMP] = ACTIONS(6197),
    [anon_sym_PIPE_PIPE] = ACTIONS(6199),
    [anon_sym_AMP_AMP] = ACTIONS(6201),
    [anon_sym_LT] = ACTIONS(6203),
    [anon_sym_LT_EQ] = ACTIONS(6205),
    [anon_sym_GT] = ACTIONS(6203),
    [anon_sym_GT_EQ] = ACTIONS(6205),
    [anon_sym_EQ_EQ] = ACTIONS(6205),
    [anon_sym_BANG_EQ] = ACTIONS(6205),
    [anon_sym_STAR] = ACTIONS(6207),
    [anon_sym_SLASH] = ACTIONS(6209),
    [anon_sym_STAR_STAR] = ACTIONS(6211),
    [anon_sym_CARET] = ACTIONS(6211),
    [aux_sym_binary_operator_token1] = ACTIONS(6213),
    [anon_sym_PIPE_GT] = ACTIONS(6213),
    [anon_sym_COLON] = ACTIONS(6215),
    [anon_sym_DOLLAR] = ACTIONS(6217),
    [anon_sym_AT] = ACTIONS(6217),
    [aux_sym__hex_literal_token1] = ACTIONS(5067),
    [sym__number_literal] = ACTIONS(5065),
    [anon_sym_SQUOTE] = ACTIONS(5067),
    [anon_sym_DQUOTE] = ACTIONS(5067),
    [sym_return] = ACTIONS(5065),
    [sym_next] = ACTIONS(5065),
    [sym_break] = ACTIONS(5065),
    [sym_true] = ACTIONS(5065),
    [sym_false] = ACTIONS(5065),
    [sym_null] = ACTIONS(5065),
    [sym_inf] = ACTIONS(5065),
    [sym_nan] = ACTIONS(5065),
    [anon_sym_NA] = ACTIONS(5065),
    [anon_sym_NA_integer_] = ACTIONS(5065),
    [anon_sym_NA_real_] = ACTIONS(5065),
    [anon_sym_NA_complex_] = ACTIONS(5065),
    [anon_sym_NA_character_] = ACTIONS(5065),
    [sym_dots] = ACTIONS(5065),
    [sym_dot_dot_i] = ACTIONS(5067),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5067),
    [sym__newline] = ACTIONS(5067),
    [sym__raw_string_literal] = ACTIONS(5067),
    [sym__external_else] = ACTIONS(6237),
    [sym__external_open_parenthesis] = ACTIONS(6221),
    [sym__external_close_parenthesis] = ACTIONS(5067),
    [sym__external_open_brace] = ACTIONS(5067),
    [sym__external_open_bracket] = ACTIONS(6223),
    [sym__external_open_bracket2] = ACTIONS(6225),
  },
  [1291] = {
    [sym_call_arguments] = STATE(2853),
    [sym_subset_arguments] = STATE(2854),
    [sym_subset2_arguments] = STATE(2864),
    [sym__else] = STATE(4239),
    [sym__open_parenthesis] = STATE(1366),
    [sym__open_bracket] = STATE(1365),
    [sym__open_bracket2] = STATE(1364),
    [sym_identifier] = ACTIONS(5225),
    [anon_sym_BSLASH] = ACTIONS(5227),
    [anon_sym_function] = ACTIONS(5225),
    [anon_sym_EQ] = ACTIONS(5995),
    [anon_sym_if] = ACTIONS(5225),
    [anon_sym_for] = ACTIONS(5225),
    [anon_sym_while] = ACTIONS(5225),
    [anon_sym_repeat] = ACTIONS(5225),
    [anon_sym_QMARK] = ACTIONS(5227),
    [anon_sym_TILDE] = ACTIONS(5997),
    [anon_sym_BANG] = ACTIONS(5225),
    [anon_sym_PLUS] = ACTIONS(5999),
    [anon_sym_DASH] = ACTIONS(6001),
    [anon_sym_LT_DASH] = ACTIONS(6003),
    [anon_sym_LT_LT_DASH] = ACTIONS(6003),
    [anon_sym_COLON_EQ] = ACTIONS(6003),
    [anon_sym_DASH_GT] = ACTIONS(6005),
    [anon_sym_DASH_GT_GT] = ACTIONS(6007),
    [anon_sym_PIPE] = ACTIONS(6009),
    [anon_sym_AMP] = ACTIONS(6011),
    [anon_sym_PIPE_PIPE] = ACTIONS(6013),
    [anon_sym_AMP_AMP] = ACTIONS(6015),
    [anon_sym_LT] = ACTIONS(6017),
    [anon_sym_LT_EQ] = ACTIONS(6019),
    [anon_sym_GT] = ACTIONS(6017),
    [anon_sym_GT_EQ] = ACTIONS(6019),
    [anon_sym_EQ_EQ] = ACTIONS(6019),
    [anon_sym_BANG_EQ] = ACTIONS(6019),
    [anon_sym_STAR] = ACTIONS(6021),
    [anon_sym_SLASH] = ACTIONS(6023),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_CARET] = ACTIONS(6025),
    [aux_sym_binary_operator_token1] = ACTIONS(6027),
    [anon_sym_PIPE_GT] = ACTIONS(6027),
    [anon_sym_COLON] = ACTIONS(6029),
    [anon_sym_DOLLAR] = ACTIONS(6031),
    [anon_sym_AT] = ACTIONS(6031),
    [aux_sym__hex_literal_token1] = ACTIONS(5227),
    [sym__number_literal] = ACTIONS(5225),
    [anon_sym_SQUOTE] = ACTIONS(5227),
    [anon_sym_DQUOTE] = ACTIONS(5227),
    [sym_return] = ACTIONS(5225),
    [sym_next] = ACTIONS(5225),
    [sym_break] = ACTIONS(5225),
    [sym_true] = ACTIONS(5225),
    [sym_false] = ACTIONS(5225),
    [sym_null] = ACTIONS(5225),
    [sym_inf] = ACTIONS(5225),
    [sym_nan] = ACTIONS(5225),
    [anon_sym_NA] = ACTIONS(5225),
    [anon_sym_NA_integer_] = ACTIONS(5225),
    [anon_sym_NA_real_] = ACTIONS(5225),
    [anon_sym_NA_complex_] = ACTIONS(5225),
    [anon_sym_NA_character_] = ACTIONS(5225),
    [sym_dots] = ACTIONS(5225),
    [sym_dot_dot_i] = ACTIONS(5227),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5227),
    [sym__newline] = ACTIONS(5227),
    [sym__raw_string_literal] = ACTIONS(5227),
    [sym__external_else] = ACTIONS(6239),
    [sym__external_open_parenthesis] = ACTIONS(6035),
    [sym__external_open_brace] = ACTIONS(5227),
    [sym__external_open_bracket] = ACTIONS(6037),
    [sym__external_close_bracket] = ACTIONS(5227),
    [sym__external_open_bracket2] = ACTIONS(6039),
  },
  [1292] = {
    [sym_call_arguments] = STATE(2731),
    [sym_subset_arguments] = STATE(2730),
    [sym_subset2_arguments] = STATE(2729),
    [sym__open_parenthesis] = STATE(1357),
    [sym__open_bracket] = STATE(1353),
    [sym__open_bracket2] = STATE(1352),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5787),
    [anon_sym_DASH] = ACTIONS(5789),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5805),
    [anon_sym_LT_EQ] = ACTIONS(5807),
    [anon_sym_GT] = ACTIONS(5805),
    [anon_sym_GT_EQ] = ACTIONS(5807),
    [anon_sym_EQ_EQ] = ACTIONS(5807),
    [anon_sym_BANG_EQ] = ACTIONS(5807),
    [anon_sym_STAR] = ACTIONS(5809),
    [anon_sym_SLASH] = ACTIONS(5811),
    [anon_sym_STAR_STAR] = ACTIONS(5813),
    [anon_sym_CARET] = ACTIONS(5813),
    [aux_sym_binary_operator_token1] = ACTIONS(5815),
    [anon_sym_PIPE_GT] = ACTIONS(5815),
    [anon_sym_COLON] = ACTIONS(5817),
    [anon_sym_DOLLAR] = ACTIONS(5819),
    [anon_sym_AT] = ACTIONS(5819),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5823),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5825),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(5827),
  },
  [1293] = {
    [sym_call_arguments] = STATE(2845),
    [sym_subset_arguments] = STATE(2849),
    [sym_subset2_arguments] = STATE(2852),
    [sym__else] = STATE(4203),
    [sym__open_parenthesis] = STATE(1372),
    [sym__open_bracket] = STATE(1371),
    [sym__open_bracket2] = STATE(1370),
    [sym_identifier] = ACTIONS(5225),
    [anon_sym_BSLASH] = ACTIONS(5227),
    [anon_sym_function] = ACTIONS(5225),
    [anon_sym_EQ] = ACTIONS(6181),
    [anon_sym_if] = ACTIONS(5225),
    [anon_sym_for] = ACTIONS(5225),
    [anon_sym_while] = ACTIONS(5225),
    [anon_sym_repeat] = ACTIONS(5225),
    [anon_sym_QMARK] = ACTIONS(5227),
    [anon_sym_TILDE] = ACTIONS(6183),
    [anon_sym_BANG] = ACTIONS(5225),
    [anon_sym_PLUS] = ACTIONS(6185),
    [anon_sym_DASH] = ACTIONS(6187),
    [anon_sym_LT_DASH] = ACTIONS(6189),
    [anon_sym_LT_LT_DASH] = ACTIONS(6189),
    [anon_sym_COLON_EQ] = ACTIONS(6189),
    [anon_sym_DASH_GT] = ACTIONS(6191),
    [anon_sym_DASH_GT_GT] = ACTIONS(6193),
    [anon_sym_PIPE] = ACTIONS(6195),
    [anon_sym_AMP] = ACTIONS(6197),
    [anon_sym_PIPE_PIPE] = ACTIONS(6199),
    [anon_sym_AMP_AMP] = ACTIONS(6201),
    [anon_sym_LT] = ACTIONS(6203),
    [anon_sym_LT_EQ] = ACTIONS(6205),
    [anon_sym_GT] = ACTIONS(6203),
    [anon_sym_GT_EQ] = ACTIONS(6205),
    [anon_sym_EQ_EQ] = ACTIONS(6205),
    [anon_sym_BANG_EQ] = ACTIONS(6205),
    [anon_sym_STAR] = ACTIONS(6207),
    [anon_sym_SLASH] = ACTIONS(6209),
    [anon_sym_STAR_STAR] = ACTIONS(6211),
    [anon_sym_CARET] = ACTIONS(6211),
    [aux_sym_binary_operator_token1] = ACTIONS(6213),
    [anon_sym_PIPE_GT] = ACTIONS(6213),
    [anon_sym_COLON] = ACTIONS(6215),
    [anon_sym_DOLLAR] = ACTIONS(6217),
    [anon_sym_AT] = ACTIONS(6217),
    [aux_sym__hex_literal_token1] = ACTIONS(5227),
    [sym__number_literal] = ACTIONS(5225),
    [anon_sym_SQUOTE] = ACTIONS(5227),
    [anon_sym_DQUOTE] = ACTIONS(5227),
    [sym_return] = ACTIONS(5225),
    [sym_next] = ACTIONS(5225),
    [sym_break] = ACTIONS(5225),
    [sym_true] = ACTIONS(5225),
    [sym_false] = ACTIONS(5225),
    [sym_null] = ACTIONS(5225),
    [sym_inf] = ACTIONS(5225),
    [sym_nan] = ACTIONS(5225),
    [anon_sym_NA] = ACTIONS(5225),
    [anon_sym_NA_integer_] = ACTIONS(5225),
    [anon_sym_NA_real_] = ACTIONS(5225),
    [anon_sym_NA_complex_] = ACTIONS(5225),
    [anon_sym_NA_character_] = ACTIONS(5225),
    [sym_dots] = ACTIONS(5225),
    [sym_dot_dot_i] = ACTIONS(5227),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5227),
    [sym__newline] = ACTIONS(5227),
    [sym__raw_string_literal] = ACTIONS(5227),
    [sym__external_else] = ACTIONS(6241),
    [sym__external_open_parenthesis] = ACTIONS(6221),
    [sym__external_close_parenthesis] = ACTIONS(5227),
    [sym__external_open_brace] = ACTIONS(5227),
    [sym__external_open_bracket] = ACTIONS(6223),
    [sym__external_open_bracket2] = ACTIONS(6225),
  },
  [1294] = {
    [sym_call_arguments] = STATE(2853),
    [sym_subset_arguments] = STATE(2854),
    [sym_subset2_arguments] = STATE(2864),
    [sym__else] = STATE(4252),
    [sym__open_parenthesis] = STATE(1366),
    [sym__open_bracket] = STATE(1365),
    [sym__open_bracket2] = STATE(1364),
    [sym_identifier] = ACTIONS(5169),
    [anon_sym_BSLASH] = ACTIONS(5167),
    [anon_sym_function] = ACTIONS(5169),
    [anon_sym_EQ] = ACTIONS(5995),
    [anon_sym_if] = ACTIONS(5169),
    [anon_sym_for] = ACTIONS(5169),
    [anon_sym_while] = ACTIONS(5169),
    [anon_sym_repeat] = ACTIONS(5169),
    [anon_sym_QMARK] = ACTIONS(5167),
    [anon_sym_TILDE] = ACTIONS(5997),
    [anon_sym_BANG] = ACTIONS(5169),
    [anon_sym_PLUS] = ACTIONS(5999),
    [anon_sym_DASH] = ACTIONS(6001),
    [anon_sym_LT_DASH] = ACTIONS(6003),
    [anon_sym_LT_LT_DASH] = ACTIONS(6003),
    [anon_sym_COLON_EQ] = ACTIONS(6003),
    [anon_sym_DASH_GT] = ACTIONS(6005),
    [anon_sym_DASH_GT_GT] = ACTIONS(6007),
    [anon_sym_PIPE] = ACTIONS(6009),
    [anon_sym_AMP] = ACTIONS(6011),
    [anon_sym_PIPE_PIPE] = ACTIONS(6013),
    [anon_sym_AMP_AMP] = ACTIONS(6015),
    [anon_sym_LT] = ACTIONS(6017),
    [anon_sym_LT_EQ] = ACTIONS(6019),
    [anon_sym_GT] = ACTIONS(6017),
    [anon_sym_GT_EQ] = ACTIONS(6019),
    [anon_sym_EQ_EQ] = ACTIONS(6019),
    [anon_sym_BANG_EQ] = ACTIONS(6019),
    [anon_sym_STAR] = ACTIONS(6021),
    [anon_sym_SLASH] = ACTIONS(6023),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_CARET] = ACTIONS(6025),
    [aux_sym_binary_operator_token1] = ACTIONS(6027),
    [anon_sym_PIPE_GT] = ACTIONS(6027),
    [anon_sym_COLON] = ACTIONS(6029),
    [anon_sym_DOLLAR] = ACTIONS(6031),
    [anon_sym_AT] = ACTIONS(6031),
    [aux_sym__hex_literal_token1] = ACTIONS(5167),
    [sym__number_literal] = ACTIONS(5169),
    [anon_sym_SQUOTE] = ACTIONS(5167),
    [anon_sym_DQUOTE] = ACTIONS(5167),
    [sym_return] = ACTIONS(5169),
    [sym_next] = ACTIONS(5169),
    [sym_break] = ACTIONS(5169),
    [sym_true] = ACTIONS(5169),
    [sym_false] = ACTIONS(5169),
    [sym_null] = ACTIONS(5169),
    [sym_inf] = ACTIONS(5169),
    [sym_nan] = ACTIONS(5169),
    [anon_sym_NA] = ACTIONS(5169),
    [anon_sym_NA_integer_] = ACTIONS(5169),
    [anon_sym_NA_real_] = ACTIONS(5169),
    [anon_sym_NA_complex_] = ACTIONS(5169),
    [anon_sym_NA_character_] = ACTIONS(5169),
    [sym_dots] = ACTIONS(5169),
    [sym_dot_dot_i] = ACTIONS(5167),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5167),
    [sym__newline] = ACTIONS(5167),
    [sym__raw_string_literal] = ACTIONS(5167),
    [sym__external_else] = ACTIONS(6243),
    [sym__external_open_parenthesis] = ACTIONS(6035),
    [sym__external_open_brace] = ACTIONS(5167),
    [sym__external_open_bracket] = ACTIONS(6037),
    [sym__external_close_bracket] = ACTIONS(5167),
    [sym__external_open_bracket2] = ACTIONS(6039),
  },
  [1295] = {
    [sym_call_arguments] = STATE(2853),
    [sym_subset_arguments] = STATE(2854),
    [sym_subset2_arguments] = STATE(2864),
    [sym__else] = STATE(4254),
    [sym__open_parenthesis] = STATE(1366),
    [sym__open_bracket] = STATE(1365),
    [sym__open_bracket2] = STATE(1364),
    [sym_identifier] = ACTIONS(5115),
    [anon_sym_BSLASH] = ACTIONS(5117),
    [anon_sym_function] = ACTIONS(5115),
    [anon_sym_EQ] = ACTIONS(5995),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_for] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_repeat] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(5117),
    [anon_sym_TILDE] = ACTIONS(5997),
    [anon_sym_BANG] = ACTIONS(5115),
    [anon_sym_PLUS] = ACTIONS(5999),
    [anon_sym_DASH] = ACTIONS(6001),
    [anon_sym_LT_DASH] = ACTIONS(6003),
    [anon_sym_LT_LT_DASH] = ACTIONS(6003),
    [anon_sym_COLON_EQ] = ACTIONS(6003),
    [anon_sym_DASH_GT] = ACTIONS(6005),
    [anon_sym_DASH_GT_GT] = ACTIONS(6007),
    [anon_sym_PIPE] = ACTIONS(6009),
    [anon_sym_AMP] = ACTIONS(6011),
    [anon_sym_PIPE_PIPE] = ACTIONS(6013),
    [anon_sym_AMP_AMP] = ACTIONS(6015),
    [anon_sym_LT] = ACTIONS(6017),
    [anon_sym_LT_EQ] = ACTIONS(6019),
    [anon_sym_GT] = ACTIONS(6017),
    [anon_sym_GT_EQ] = ACTIONS(6019),
    [anon_sym_EQ_EQ] = ACTIONS(6019),
    [anon_sym_BANG_EQ] = ACTIONS(6019),
    [anon_sym_STAR] = ACTIONS(6021),
    [anon_sym_SLASH] = ACTIONS(6023),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_CARET] = ACTIONS(6025),
    [aux_sym_binary_operator_token1] = ACTIONS(6027),
    [anon_sym_PIPE_GT] = ACTIONS(6027),
    [anon_sym_COLON] = ACTIONS(6029),
    [anon_sym_DOLLAR] = ACTIONS(6031),
    [anon_sym_AT] = ACTIONS(6031),
    [aux_sym__hex_literal_token1] = ACTIONS(5117),
    [sym__number_literal] = ACTIONS(5115),
    [anon_sym_SQUOTE] = ACTIONS(5117),
    [anon_sym_DQUOTE] = ACTIONS(5117),
    [sym_return] = ACTIONS(5115),
    [sym_next] = ACTIONS(5115),
    [sym_break] = ACTIONS(5115),
    [sym_true] = ACTIONS(5115),
    [sym_false] = ACTIONS(5115),
    [sym_null] = ACTIONS(5115),
    [sym_inf] = ACTIONS(5115),
    [sym_nan] = ACTIONS(5115),
    [anon_sym_NA] = ACTIONS(5115),
    [anon_sym_NA_integer_] = ACTIONS(5115),
    [anon_sym_NA_real_] = ACTIONS(5115),
    [anon_sym_NA_complex_] = ACTIONS(5115),
    [anon_sym_NA_character_] = ACTIONS(5115),
    [sym_dots] = ACTIONS(5115),
    [sym_dot_dot_i] = ACTIONS(5117),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5117),
    [sym__newline] = ACTIONS(5117),
    [sym__raw_string_literal] = ACTIONS(5117),
    [sym__external_else] = ACTIONS(6245),
    [sym__external_open_parenthesis] = ACTIONS(6035),
    [sym__external_open_brace] = ACTIONS(5117),
    [sym__external_open_bracket] = ACTIONS(6037),
    [sym__external_close_bracket] = ACTIONS(5117),
    [sym__external_open_bracket2] = ACTIONS(6039),
  },
  [1296] = {
    [sym_call_arguments] = STATE(2731),
    [sym_subset_arguments] = STATE(2730),
    [sym_subset2_arguments] = STATE(2729),
    [sym__open_parenthesis] = STATE(1357),
    [sym__open_bracket] = STATE(1353),
    [sym__open_bracket2] = STATE(1352),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5787),
    [anon_sym_DASH] = ACTIONS(5789),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5809),
    [anon_sym_SLASH] = ACTIONS(5811),
    [anon_sym_STAR_STAR] = ACTIONS(5813),
    [anon_sym_CARET] = ACTIONS(5813),
    [aux_sym_binary_operator_token1] = ACTIONS(5815),
    [anon_sym_PIPE_GT] = ACTIONS(5815),
    [anon_sym_COLON] = ACTIONS(5817),
    [anon_sym_DOLLAR] = ACTIONS(5819),
    [anon_sym_AT] = ACTIONS(5819),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5823),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5825),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(5827),
  },
  [1297] = {
    [sym_call_arguments] = STATE(2853),
    [sym_subset_arguments] = STATE(2854),
    [sym_subset2_arguments] = STATE(2864),
    [sym__else] = STATE(4140),
    [sym__open_parenthesis] = STATE(1366),
    [sym__open_bracket] = STATE(1365),
    [sym__open_bracket2] = STATE(1364),
    [sym_identifier] = ACTIONS(5065),
    [anon_sym_BSLASH] = ACTIONS(5067),
    [anon_sym_function] = ACTIONS(5065),
    [anon_sym_EQ] = ACTIONS(5995),
    [anon_sym_if] = ACTIONS(5065),
    [anon_sym_for] = ACTIONS(5065),
    [anon_sym_while] = ACTIONS(5065),
    [anon_sym_repeat] = ACTIONS(5065),
    [anon_sym_QMARK] = ACTIONS(5067),
    [anon_sym_TILDE] = ACTIONS(5997),
    [anon_sym_BANG] = ACTIONS(5065),
    [anon_sym_PLUS] = ACTIONS(5999),
    [anon_sym_DASH] = ACTIONS(6001),
    [anon_sym_LT_DASH] = ACTIONS(6003),
    [anon_sym_LT_LT_DASH] = ACTIONS(6003),
    [anon_sym_COLON_EQ] = ACTIONS(6003),
    [anon_sym_DASH_GT] = ACTIONS(6005),
    [anon_sym_DASH_GT_GT] = ACTIONS(6007),
    [anon_sym_PIPE] = ACTIONS(6009),
    [anon_sym_AMP] = ACTIONS(6011),
    [anon_sym_PIPE_PIPE] = ACTIONS(6013),
    [anon_sym_AMP_AMP] = ACTIONS(6015),
    [anon_sym_LT] = ACTIONS(6017),
    [anon_sym_LT_EQ] = ACTIONS(6019),
    [anon_sym_GT] = ACTIONS(6017),
    [anon_sym_GT_EQ] = ACTIONS(6019),
    [anon_sym_EQ_EQ] = ACTIONS(6019),
    [anon_sym_BANG_EQ] = ACTIONS(6019),
    [anon_sym_STAR] = ACTIONS(6021),
    [anon_sym_SLASH] = ACTIONS(6023),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_CARET] = ACTIONS(6025),
    [aux_sym_binary_operator_token1] = ACTIONS(6027),
    [anon_sym_PIPE_GT] = ACTIONS(6027),
    [anon_sym_COLON] = ACTIONS(6029),
    [anon_sym_DOLLAR] = ACTIONS(6031),
    [anon_sym_AT] = ACTIONS(6031),
    [aux_sym__hex_literal_token1] = ACTIONS(5067),
    [sym__number_literal] = ACTIONS(5065),
    [anon_sym_SQUOTE] = ACTIONS(5067),
    [anon_sym_DQUOTE] = ACTIONS(5067),
    [sym_return] = ACTIONS(5065),
    [sym_next] = ACTIONS(5065),
    [sym_break] = ACTIONS(5065),
    [sym_true] = ACTIONS(5065),
    [sym_false] = ACTIONS(5065),
    [sym_null] = ACTIONS(5065),
    [sym_inf] = ACTIONS(5065),
    [sym_nan] = ACTIONS(5065),
    [anon_sym_NA] = ACTIONS(5065),
    [anon_sym_NA_integer_] = ACTIONS(5065),
    [anon_sym_NA_real_] = ACTIONS(5065),
    [anon_sym_NA_complex_] = ACTIONS(5065),
    [anon_sym_NA_character_] = ACTIONS(5065),
    [sym_dots] = ACTIONS(5065),
    [sym_dot_dot_i] = ACTIONS(5067),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5067),
    [sym__newline] = ACTIONS(5067),
    [sym__raw_string_literal] = ACTIONS(5067),
    [sym__external_else] = ACTIONS(6247),
    [sym__external_open_parenthesis] = ACTIONS(6035),
    [sym__external_open_brace] = ACTIONS(5067),
    [sym__external_open_bracket] = ACTIONS(6037),
    [sym__external_close_bracket] = ACTIONS(5067),
    [sym__external_open_bracket2] = ACTIONS(6039),
  },
  [1298] = {
    [sym_call_arguments] = STATE(2731),
    [sym_subset_arguments] = STATE(2730),
    [sym_subset2_arguments] = STATE(2729),
    [sym__open_parenthesis] = STATE(1357),
    [sym__open_bracket] = STATE(1353),
    [sym__open_bracket2] = STATE(1352),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(5813),
    [anon_sym_CARET] = ACTIONS(5813),
    [aux_sym_binary_operator_token1] = ACTIONS(5815),
    [anon_sym_PIPE_GT] = ACTIONS(5815),
    [anon_sym_COLON] = ACTIONS(5817),
    [anon_sym_DOLLAR] = ACTIONS(5819),
    [anon_sym_AT] = ACTIONS(5819),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5823),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5825),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(5827),
  },
  [1299] = {
    [sym_string] = STATE(2473),
    [sym__single_quoted_string] = STATE(2200),
    [sym__double_quoted_string] = STATE(2201),
    [sym__string_or_identifier] = STATE(2473),
    [aux_sym_function_definition_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(6249),
    [anon_sym_BSLASH] = ACTIONS(5669),
    [anon_sym_function] = ACTIONS(5673),
    [anon_sym_EQ] = ACTIONS(5673),
    [anon_sym_if] = ACTIONS(5673),
    [anon_sym_for] = ACTIONS(5673),
    [anon_sym_while] = ACTIONS(5673),
    [anon_sym_repeat] = ACTIONS(5673),
    [anon_sym_QMARK] = ACTIONS(5669),
    [anon_sym_TILDE] = ACTIONS(5669),
    [anon_sym_BANG] = ACTIONS(5673),
    [anon_sym_PLUS] = ACTIONS(5669),
    [anon_sym_DASH] = ACTIONS(5673),
    [anon_sym_LT_DASH] = ACTIONS(5669),
    [anon_sym_LT_LT_DASH] = ACTIONS(5669),
    [anon_sym_COLON_EQ] = ACTIONS(5669),
    [anon_sym_DASH_GT] = ACTIONS(5673),
    [anon_sym_DASH_GT_GT] = ACTIONS(5669),
    [anon_sym_PIPE] = ACTIONS(5673),
    [anon_sym_AMP] = ACTIONS(5673),
    [anon_sym_PIPE_PIPE] = ACTIONS(5669),
    [anon_sym_AMP_AMP] = ACTIONS(5669),
    [anon_sym_LT] = ACTIONS(5673),
    [anon_sym_LT_EQ] = ACTIONS(5669),
    [anon_sym_GT] = ACTIONS(5673),
    [anon_sym_GT_EQ] = ACTIONS(5669),
    [anon_sym_EQ_EQ] = ACTIONS(5669),
    [anon_sym_BANG_EQ] = ACTIONS(5669),
    [anon_sym_STAR] = ACTIONS(5673),
    [anon_sym_SLASH] = ACTIONS(5669),
    [anon_sym_STAR_STAR] = ACTIONS(5669),
    [anon_sym_CARET] = ACTIONS(5669),
    [aux_sym_binary_operator_token1] = ACTIONS(5669),
    [anon_sym_PIPE_GT] = ACTIONS(5669),
    [anon_sym_COLON] = ACTIONS(5673),
    [anon_sym_DOLLAR] = ACTIONS(5669),
    [anon_sym_AT] = ACTIONS(5669),
    [aux_sym__hex_literal_token1] = ACTIONS(5669),
    [sym__number_literal] = ACTIONS(5673),
    [anon_sym_SQUOTE] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(511),
    [sym_return] = ACTIONS(5673),
    [sym_next] = ACTIONS(5673),
    [sym_break] = ACTIONS(5673),
    [sym_true] = ACTIONS(5673),
    [sym_false] = ACTIONS(5673),
    [sym_null] = ACTIONS(5673),
    [sym_inf] = ACTIONS(5673),
    [sym_nan] = ACTIONS(5673),
    [anon_sym_NA] = ACTIONS(5673),
    [anon_sym_NA_integer_] = ACTIONS(5673),
    [anon_sym_NA_real_] = ACTIONS(5673),
    [anon_sym_NA_complex_] = ACTIONS(5673),
    [anon_sym_NA_character_] = ACTIONS(5673),
    [sym_dots] = ACTIONS(5673),
    [sym_dot_dot_i] = ACTIONS(5669),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5669),
    [sym__newline] = ACTIONS(5669),
    [sym__semicolon] = ACTIONS(5669),
    [sym__raw_string_literal] = ACTIONS(521),
    [sym__external_else] = ACTIONS(5669),
    [sym__external_open_parenthesis] = ACTIONS(5669),
    [sym__external_open_brace] = ACTIONS(5669),
    [sym__external_close_brace] = ACTIONS(5669),
    [sym__external_open_bracket] = ACTIONS(5669),
    [sym__external_close_bracket] = ACTIONS(5669),
    [sym__external_open_bracket2] = ACTIONS(5669),
  },
  [1300] = {
    [sym_call_arguments] = STATE(2870),
    [sym_subset_arguments] = STATE(2869),
    [sym_subset2_arguments] = STATE(2867),
    [sym__else] = STATE(4302),
    [sym__open_parenthesis] = STATE(1362),
    [sym__open_bracket] = STATE(1361),
    [sym__open_bracket2] = STATE(1360),
    [sym_identifier] = ACTIONS(5225),
    [anon_sym_BSLASH] = ACTIONS(5227),
    [anon_sym_function] = ACTIONS(5225),
    [anon_sym_EQ] = ACTIONS(6111),
    [anon_sym_if] = ACTIONS(5225),
    [anon_sym_for] = ACTIONS(5225),
    [anon_sym_while] = ACTIONS(5225),
    [anon_sym_repeat] = ACTIONS(5225),
    [anon_sym_QMARK] = ACTIONS(5227),
    [anon_sym_TILDE] = ACTIONS(6113),
    [anon_sym_BANG] = ACTIONS(5225),
    [anon_sym_PLUS] = ACTIONS(6115),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_LT_DASH] = ACTIONS(6119),
    [anon_sym_LT_LT_DASH] = ACTIONS(6119),
    [anon_sym_COLON_EQ] = ACTIONS(6119),
    [anon_sym_DASH_GT] = ACTIONS(6121),
    [anon_sym_DASH_GT_GT] = ACTIONS(6123),
    [anon_sym_PIPE] = ACTIONS(6125),
    [anon_sym_AMP] = ACTIONS(6127),
    [anon_sym_PIPE_PIPE] = ACTIONS(6129),
    [anon_sym_AMP_AMP] = ACTIONS(6131),
    [anon_sym_LT] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6135),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_GT_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(6135),
    [anon_sym_STAR] = ACTIONS(6137),
    [anon_sym_SLASH] = ACTIONS(6139),
    [anon_sym_STAR_STAR] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6141),
    [aux_sym_binary_operator_token1] = ACTIONS(6143),
    [anon_sym_PIPE_GT] = ACTIONS(6143),
    [anon_sym_COLON] = ACTIONS(6145),
    [anon_sym_DOLLAR] = ACTIONS(6147),
    [anon_sym_AT] = ACTIONS(6147),
    [aux_sym__hex_literal_token1] = ACTIONS(5227),
    [sym__number_literal] = ACTIONS(5225),
    [anon_sym_SQUOTE] = ACTIONS(5227),
    [anon_sym_DQUOTE] = ACTIONS(5227),
    [sym_return] = ACTIONS(5225),
    [sym_next] = ACTIONS(5225),
    [sym_break] = ACTIONS(5225),
    [sym_true] = ACTIONS(5225),
    [sym_false] = ACTIONS(5225),
    [sym_null] = ACTIONS(5225),
    [sym_inf] = ACTIONS(5225),
    [sym_nan] = ACTIONS(5225),
    [anon_sym_NA] = ACTIONS(5225),
    [anon_sym_NA_integer_] = ACTIONS(5225),
    [anon_sym_NA_real_] = ACTIONS(5225),
    [anon_sym_NA_complex_] = ACTIONS(5225),
    [anon_sym_NA_character_] = ACTIONS(5225),
    [sym_dots] = ACTIONS(5225),
    [sym_dot_dot_i] = ACTIONS(5227),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5227),
    [sym__newline] = ACTIONS(5227),
    [sym__raw_string_literal] = ACTIONS(5227),
    [sym__external_else] = ACTIONS(6251),
    [sym__external_open_parenthesis] = ACTIONS(6151),
    [sym__external_open_brace] = ACTIONS(5227),
    [sym__external_open_bracket] = ACTIONS(6153),
    [sym__external_open_bracket2] = ACTIONS(6155),
    [sym__external_close_bracket2] = ACTIONS(5227),
  },
  [1301] = {
    [sym_call_arguments] = STATE(2870),
    [sym_subset_arguments] = STATE(2869),
    [sym_subset2_arguments] = STATE(2867),
    [sym__else] = STATE(4303),
    [sym__open_parenthesis] = STATE(1362),
    [sym__open_bracket] = STATE(1361),
    [sym__open_bracket2] = STATE(1360),
    [sym_identifier] = ACTIONS(5169),
    [anon_sym_BSLASH] = ACTIONS(5167),
    [anon_sym_function] = ACTIONS(5169),
    [anon_sym_EQ] = ACTIONS(6111),
    [anon_sym_if] = ACTIONS(5169),
    [anon_sym_for] = ACTIONS(5169),
    [anon_sym_while] = ACTIONS(5169),
    [anon_sym_repeat] = ACTIONS(5169),
    [anon_sym_QMARK] = ACTIONS(5167),
    [anon_sym_TILDE] = ACTIONS(6113),
    [anon_sym_BANG] = ACTIONS(5169),
    [anon_sym_PLUS] = ACTIONS(6115),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_LT_DASH] = ACTIONS(6119),
    [anon_sym_LT_LT_DASH] = ACTIONS(6119),
    [anon_sym_COLON_EQ] = ACTIONS(6119),
    [anon_sym_DASH_GT] = ACTIONS(6121),
    [anon_sym_DASH_GT_GT] = ACTIONS(6123),
    [anon_sym_PIPE] = ACTIONS(6125),
    [anon_sym_AMP] = ACTIONS(6127),
    [anon_sym_PIPE_PIPE] = ACTIONS(6129),
    [anon_sym_AMP_AMP] = ACTIONS(6131),
    [anon_sym_LT] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6135),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_GT_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(6135),
    [anon_sym_STAR] = ACTIONS(6137),
    [anon_sym_SLASH] = ACTIONS(6139),
    [anon_sym_STAR_STAR] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6141),
    [aux_sym_binary_operator_token1] = ACTIONS(6143),
    [anon_sym_PIPE_GT] = ACTIONS(6143),
    [anon_sym_COLON] = ACTIONS(6145),
    [anon_sym_DOLLAR] = ACTIONS(6147),
    [anon_sym_AT] = ACTIONS(6147),
    [aux_sym__hex_literal_token1] = ACTIONS(5167),
    [sym__number_literal] = ACTIONS(5169),
    [anon_sym_SQUOTE] = ACTIONS(5167),
    [anon_sym_DQUOTE] = ACTIONS(5167),
    [sym_return] = ACTIONS(5169),
    [sym_next] = ACTIONS(5169),
    [sym_break] = ACTIONS(5169),
    [sym_true] = ACTIONS(5169),
    [sym_false] = ACTIONS(5169),
    [sym_null] = ACTIONS(5169),
    [sym_inf] = ACTIONS(5169),
    [sym_nan] = ACTIONS(5169),
    [anon_sym_NA] = ACTIONS(5169),
    [anon_sym_NA_integer_] = ACTIONS(5169),
    [anon_sym_NA_real_] = ACTIONS(5169),
    [anon_sym_NA_complex_] = ACTIONS(5169),
    [anon_sym_NA_character_] = ACTIONS(5169),
    [sym_dots] = ACTIONS(5169),
    [sym_dot_dot_i] = ACTIONS(5167),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5167),
    [sym__newline] = ACTIONS(5167),
    [sym__raw_string_literal] = ACTIONS(5167),
    [sym__external_else] = ACTIONS(6253),
    [sym__external_open_parenthesis] = ACTIONS(6151),
    [sym__external_open_brace] = ACTIONS(5167),
    [sym__external_open_bracket] = ACTIONS(6153),
    [sym__external_open_bracket2] = ACTIONS(6155),
    [sym__external_close_bracket2] = ACTIONS(5167),
  },
  [1302] = {
    [sym_call_arguments] = STATE(2731),
    [sym_subset_arguments] = STATE(2730),
    [sym_subset2_arguments] = STATE(2729),
    [sym__open_parenthesis] = STATE(1357),
    [sym__open_bracket] = STATE(1353),
    [sym__open_bracket2] = STATE(1352),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(5813),
    [anon_sym_CARET] = ACTIONS(5813),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(5261),
    [anon_sym_DOLLAR] = ACTIONS(5819),
    [anon_sym_AT] = ACTIONS(5819),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5823),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5825),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(5827),
  },
  [1303] = {
    [sym_call_arguments] = STATE(2731),
    [sym_subset_arguments] = STATE(2730),
    [sym_subset2_arguments] = STATE(2729),
    [sym__open_parenthesis] = STATE(1357),
    [sym__open_bracket] = STATE(1353),
    [sym__open_bracket2] = STATE(1352),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(5813),
    [anon_sym_CARET] = ACTIONS(5813),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(5817),
    [anon_sym_DOLLAR] = ACTIONS(5819),
    [anon_sym_AT] = ACTIONS(5819),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5823),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5825),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(5827),
  },
  [1304] = {
    [sym_call_arguments] = STATE(2731),
    [sym_subset_arguments] = STATE(2730),
    [sym_subset2_arguments] = STATE(2729),
    [sym__open_parenthesis] = STATE(1357),
    [sym__open_bracket] = STATE(1353),
    [sym__open_bracket2] = STATE(1352),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(5813),
    [anon_sym_CARET] = ACTIONS(5813),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(5261),
    [anon_sym_DOLLAR] = ACTIONS(5819),
    [anon_sym_AT] = ACTIONS(5819),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5823),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5825),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(5827),
  },
  [1305] = {
    [sym_call_arguments] = STATE(2731),
    [sym_subset_arguments] = STATE(2730),
    [sym_subset2_arguments] = STATE(2729),
    [sym__open_parenthesis] = STATE(1357),
    [sym__open_bracket] = STATE(1353),
    [sym__open_bracket2] = STATE(1352),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_BSLASH] = ACTIONS(5413),
    [anon_sym_function] = ACTIONS(5415),
    [anon_sym_EQ] = ACTIONS(5783),
    [anon_sym_if] = ACTIONS(5415),
    [anon_sym_for] = ACTIONS(5415),
    [anon_sym_while] = ACTIONS(5415),
    [anon_sym_repeat] = ACTIONS(5415),
    [anon_sym_QMARK] = ACTIONS(5413),
    [anon_sym_TILDE] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(5415),
    [anon_sym_PLUS] = ACTIONS(5787),
    [anon_sym_DASH] = ACTIONS(5789),
    [anon_sym_LT_DASH] = ACTIONS(5791),
    [anon_sym_LT_LT_DASH] = ACTIONS(5791),
    [anon_sym_COLON_EQ] = ACTIONS(5791),
    [anon_sym_DASH_GT] = ACTIONS(5793),
    [anon_sym_DASH_GT_GT] = ACTIONS(5795),
    [anon_sym_PIPE] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5799),
    [anon_sym_PIPE_PIPE] = ACTIONS(5801),
    [anon_sym_AMP_AMP] = ACTIONS(5803),
    [anon_sym_LT] = ACTIONS(5805),
    [anon_sym_LT_EQ] = ACTIONS(5807),
    [anon_sym_GT] = ACTIONS(5805),
    [anon_sym_GT_EQ] = ACTIONS(5807),
    [anon_sym_EQ_EQ] = ACTIONS(5807),
    [anon_sym_BANG_EQ] = ACTIONS(5807),
    [anon_sym_STAR] = ACTIONS(5809),
    [anon_sym_SLASH] = ACTIONS(5811),
    [anon_sym_STAR_STAR] = ACTIONS(5813),
    [anon_sym_CARET] = ACTIONS(5813),
    [aux_sym_binary_operator_token1] = ACTIONS(5815),
    [anon_sym_PIPE_GT] = ACTIONS(5815),
    [anon_sym_COLON] = ACTIONS(5817),
    [anon_sym_DOLLAR] = ACTIONS(5819),
    [anon_sym_AT] = ACTIONS(5819),
    [aux_sym__hex_literal_token1] = ACTIONS(5413),
    [sym__number_literal] = ACTIONS(5415),
    [anon_sym_SQUOTE] = ACTIONS(5413),
    [anon_sym_DQUOTE] = ACTIONS(5413),
    [sym_return] = ACTIONS(5415),
    [sym_next] = ACTIONS(5415),
    [sym_break] = ACTIONS(5415),
    [sym_true] = ACTIONS(5415),
    [sym_false] = ACTIONS(5415),
    [sym_null] = ACTIONS(5415),
    [sym_inf] = ACTIONS(5415),
    [sym_nan] = ACTIONS(5415),
    [anon_sym_NA] = ACTIONS(5415),
    [anon_sym_NA_integer_] = ACTIONS(5415),
    [anon_sym_NA_real_] = ACTIONS(5415),
    [anon_sym_NA_complex_] = ACTIONS(5415),
    [anon_sym_NA_character_] = ACTIONS(5415),
    [sym_dots] = ACTIONS(5415),
    [sym_dot_dot_i] = ACTIONS(5413),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5413),
    [sym__newline] = ACTIONS(5413),
    [sym__raw_string_literal] = ACTIONS(5413),
    [sym__external_else] = ACTIONS(5413),
    [sym__external_open_parenthesis] = ACTIONS(5823),
    [sym__external_close_parenthesis] = ACTIONS(5413),
    [sym__external_open_brace] = ACTIONS(5413),
    [sym__external_open_bracket] = ACTIONS(5825),
    [sym__external_close_bracket] = ACTIONS(5413),
    [sym__external_open_bracket2] = ACTIONS(5827),
  },
  [1306] = {
    [sym_call_arguments] = STATE(2731),
    [sym_subset_arguments] = STATE(2730),
    [sym_subset2_arguments] = STATE(2729),
    [sym__open_parenthesis] = STATE(1357),
    [sym__open_bracket] = STATE(1353),
    [sym__open_bracket2] = STATE(1352),
    [sym_identifier] = ACTIONS(5419),
    [anon_sym_BSLASH] = ACTIONS(5417),
    [anon_sym_function] = ACTIONS(5419),
    [anon_sym_EQ] = ACTIONS(5783),
    [anon_sym_if] = ACTIONS(5419),
    [anon_sym_for] = ACTIONS(5419),
    [anon_sym_while] = ACTIONS(5419),
    [anon_sym_repeat] = ACTIONS(5419),
    [anon_sym_QMARK] = ACTIONS(5417),
    [anon_sym_TILDE] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(5419),
    [anon_sym_PLUS] = ACTIONS(5787),
    [anon_sym_DASH] = ACTIONS(5789),
    [anon_sym_LT_DASH] = ACTIONS(5791),
    [anon_sym_LT_LT_DASH] = ACTIONS(5791),
    [anon_sym_COLON_EQ] = ACTIONS(5791),
    [anon_sym_DASH_GT] = ACTIONS(5793),
    [anon_sym_DASH_GT_GT] = ACTIONS(5795),
    [anon_sym_PIPE] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5799),
    [anon_sym_PIPE_PIPE] = ACTIONS(5801),
    [anon_sym_AMP_AMP] = ACTIONS(5803),
    [anon_sym_LT] = ACTIONS(5805),
    [anon_sym_LT_EQ] = ACTIONS(5807),
    [anon_sym_GT] = ACTIONS(5805),
    [anon_sym_GT_EQ] = ACTIONS(5807),
    [anon_sym_EQ_EQ] = ACTIONS(5807),
    [anon_sym_BANG_EQ] = ACTIONS(5807),
    [anon_sym_STAR] = ACTIONS(5809),
    [anon_sym_SLASH] = ACTIONS(5811),
    [anon_sym_STAR_STAR] = ACTIONS(5813),
    [anon_sym_CARET] = ACTIONS(5813),
    [aux_sym_binary_operator_token1] = ACTIONS(5815),
    [anon_sym_PIPE_GT] = ACTIONS(5815),
    [anon_sym_COLON] = ACTIONS(5817),
    [anon_sym_DOLLAR] = ACTIONS(5819),
    [anon_sym_AT] = ACTIONS(5819),
    [aux_sym__hex_literal_token1] = ACTIONS(5417),
    [sym__number_literal] = ACTIONS(5419),
    [anon_sym_SQUOTE] = ACTIONS(5417),
    [anon_sym_DQUOTE] = ACTIONS(5417),
    [sym_return] = ACTIONS(5419),
    [sym_next] = ACTIONS(5419),
    [sym_break] = ACTIONS(5419),
    [sym_true] = ACTIONS(5419),
    [sym_false] = ACTIONS(5419),
    [sym_null] = ACTIONS(5419),
    [sym_inf] = ACTIONS(5419),
    [sym_nan] = ACTIONS(5419),
    [anon_sym_NA] = ACTIONS(5419),
    [anon_sym_NA_integer_] = ACTIONS(5419),
    [anon_sym_NA_real_] = ACTIONS(5419),
    [anon_sym_NA_complex_] = ACTIONS(5419),
    [anon_sym_NA_character_] = ACTIONS(5419),
    [sym_dots] = ACTIONS(5419),
    [sym_dot_dot_i] = ACTIONS(5417),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5417),
    [sym__newline] = ACTIONS(5417),
    [sym__raw_string_literal] = ACTIONS(5417),
    [sym__external_else] = ACTIONS(5417),
    [sym__external_open_parenthesis] = ACTIONS(5823),
    [sym__external_close_parenthesis] = ACTIONS(5417),
    [sym__external_open_brace] = ACTIONS(5417),
    [sym__external_open_bracket] = ACTIONS(5825),
    [sym__external_close_bracket] = ACTIONS(5417),
    [sym__external_open_bracket2] = ACTIONS(5827),
  },
  [1307] = {
    [sym_call_arguments] = STATE(2731),
    [sym_subset_arguments] = STATE(2730),
    [sym_subset2_arguments] = STATE(2729),
    [sym__open_parenthesis] = STATE(1357),
    [sym__open_bracket] = STATE(1353),
    [sym__open_bracket2] = STATE(1352),
    [sym_identifier] = ACTIONS(5423),
    [anon_sym_BSLASH] = ACTIONS(5421),
    [anon_sym_function] = ACTIONS(5423),
    [anon_sym_EQ] = ACTIONS(5783),
    [anon_sym_if] = ACTIONS(5423),
    [anon_sym_for] = ACTIONS(5423),
    [anon_sym_while] = ACTIONS(5423),
    [anon_sym_repeat] = ACTIONS(5423),
    [anon_sym_QMARK] = ACTIONS(5421),
    [anon_sym_TILDE] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(5423),
    [anon_sym_PLUS] = ACTIONS(5787),
    [anon_sym_DASH] = ACTIONS(5789),
    [anon_sym_LT_DASH] = ACTIONS(5791),
    [anon_sym_LT_LT_DASH] = ACTIONS(5791),
    [anon_sym_COLON_EQ] = ACTIONS(5791),
    [anon_sym_DASH_GT] = ACTIONS(5793),
    [anon_sym_DASH_GT_GT] = ACTIONS(5795),
    [anon_sym_PIPE] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5799),
    [anon_sym_PIPE_PIPE] = ACTIONS(5801),
    [anon_sym_AMP_AMP] = ACTIONS(5803),
    [anon_sym_LT] = ACTIONS(5805),
    [anon_sym_LT_EQ] = ACTIONS(5807),
    [anon_sym_GT] = ACTIONS(5805),
    [anon_sym_GT_EQ] = ACTIONS(5807),
    [anon_sym_EQ_EQ] = ACTIONS(5807),
    [anon_sym_BANG_EQ] = ACTIONS(5807),
    [anon_sym_STAR] = ACTIONS(5809),
    [anon_sym_SLASH] = ACTIONS(5811),
    [anon_sym_STAR_STAR] = ACTIONS(5813),
    [anon_sym_CARET] = ACTIONS(5813),
    [aux_sym_binary_operator_token1] = ACTIONS(5815),
    [anon_sym_PIPE_GT] = ACTIONS(5815),
    [anon_sym_COLON] = ACTIONS(5817),
    [anon_sym_DOLLAR] = ACTIONS(5819),
    [anon_sym_AT] = ACTIONS(5819),
    [aux_sym__hex_literal_token1] = ACTIONS(5421),
    [sym__number_literal] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5421),
    [anon_sym_DQUOTE] = ACTIONS(5421),
    [sym_return] = ACTIONS(5423),
    [sym_next] = ACTIONS(5423),
    [sym_break] = ACTIONS(5423),
    [sym_true] = ACTIONS(5423),
    [sym_false] = ACTIONS(5423),
    [sym_null] = ACTIONS(5423),
    [sym_inf] = ACTIONS(5423),
    [sym_nan] = ACTIONS(5423),
    [anon_sym_NA] = ACTIONS(5423),
    [anon_sym_NA_integer_] = ACTIONS(5423),
    [anon_sym_NA_real_] = ACTIONS(5423),
    [anon_sym_NA_complex_] = ACTIONS(5423),
    [anon_sym_NA_character_] = ACTIONS(5423),
    [sym_dots] = ACTIONS(5423),
    [sym_dot_dot_i] = ACTIONS(5421),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5421),
    [sym__newline] = ACTIONS(5421),
    [sym__raw_string_literal] = ACTIONS(5421),
    [sym__external_else] = ACTIONS(5421),
    [sym__external_open_parenthesis] = ACTIONS(5823),
    [sym__external_close_parenthesis] = ACTIONS(5421),
    [sym__external_open_brace] = ACTIONS(5421),
    [sym__external_open_bracket] = ACTIONS(5825),
    [sym__external_close_bracket] = ACTIONS(5421),
    [sym__external_open_bracket2] = ACTIONS(5827),
  },
  [1308] = {
    [sym_call_arguments] = STATE(2731),
    [sym_subset_arguments] = STATE(2730),
    [sym_subset2_arguments] = STATE(2729),
    [sym__open_parenthesis] = STATE(1357),
    [sym__open_bracket] = STATE(1353),
    [sym__open_bracket2] = STATE(1352),
    [sym_identifier] = ACTIONS(5427),
    [anon_sym_BSLASH] = ACTIONS(5425),
    [anon_sym_function] = ACTIONS(5427),
    [anon_sym_EQ] = ACTIONS(5783),
    [anon_sym_if] = ACTIONS(5427),
    [anon_sym_for] = ACTIONS(5427),
    [anon_sym_while] = ACTIONS(5427),
    [anon_sym_repeat] = ACTIONS(5427),
    [anon_sym_QMARK] = ACTIONS(5425),
    [anon_sym_TILDE] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(5427),
    [anon_sym_PLUS] = ACTIONS(5787),
    [anon_sym_DASH] = ACTIONS(5789),
    [anon_sym_LT_DASH] = ACTIONS(5791),
    [anon_sym_LT_LT_DASH] = ACTIONS(5791),
    [anon_sym_COLON_EQ] = ACTIONS(5791),
    [anon_sym_DASH_GT] = ACTIONS(5793),
    [anon_sym_DASH_GT_GT] = ACTIONS(5795),
    [anon_sym_PIPE] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5799),
    [anon_sym_PIPE_PIPE] = ACTIONS(5801),
    [anon_sym_AMP_AMP] = ACTIONS(5803),
    [anon_sym_LT] = ACTIONS(5805),
    [anon_sym_LT_EQ] = ACTIONS(5807),
    [anon_sym_GT] = ACTIONS(5805),
    [anon_sym_GT_EQ] = ACTIONS(5807),
    [anon_sym_EQ_EQ] = ACTIONS(5807),
    [anon_sym_BANG_EQ] = ACTIONS(5807),
    [anon_sym_STAR] = ACTIONS(5809),
    [anon_sym_SLASH] = ACTIONS(5811),
    [anon_sym_STAR_STAR] = ACTIONS(5813),
    [anon_sym_CARET] = ACTIONS(5813),
    [aux_sym_binary_operator_token1] = ACTIONS(5815),
    [anon_sym_PIPE_GT] = ACTIONS(5815),
    [anon_sym_COLON] = ACTIONS(5817),
    [anon_sym_DOLLAR] = ACTIONS(5819),
    [anon_sym_AT] = ACTIONS(5819),
    [aux_sym__hex_literal_token1] = ACTIONS(5425),
    [sym__number_literal] = ACTIONS(5427),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_DQUOTE] = ACTIONS(5425),
    [sym_return] = ACTIONS(5427),
    [sym_next] = ACTIONS(5427),
    [sym_break] = ACTIONS(5427),
    [sym_true] = ACTIONS(5427),
    [sym_false] = ACTIONS(5427),
    [sym_null] = ACTIONS(5427),
    [sym_inf] = ACTIONS(5427),
    [sym_nan] = ACTIONS(5427),
    [anon_sym_NA] = ACTIONS(5427),
    [anon_sym_NA_integer_] = ACTIONS(5427),
    [anon_sym_NA_real_] = ACTIONS(5427),
    [anon_sym_NA_complex_] = ACTIONS(5427),
    [anon_sym_NA_character_] = ACTIONS(5427),
    [sym_dots] = ACTIONS(5427),
    [sym_dot_dot_i] = ACTIONS(5425),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5425),
    [sym__newline] = ACTIONS(5425),
    [sym__raw_string_literal] = ACTIONS(5425),
    [sym__external_else] = ACTIONS(5425),
    [sym__external_open_parenthesis] = ACTIONS(5823),
    [sym__external_close_parenthesis] = ACTIONS(5425),
    [sym__external_open_brace] = ACTIONS(5425),
    [sym__external_open_bracket] = ACTIONS(5825),
    [sym__external_close_bracket] = ACTIONS(5425),
    [sym__external_open_bracket2] = ACTIONS(5827),
  },
  [1309] = {
    [sym_call_arguments] = STATE(2731),
    [sym_subset_arguments] = STATE(2730),
    [sym_subset2_arguments] = STATE(2729),
    [sym__open_parenthesis] = STATE(1357),
    [sym__open_bracket] = STATE(1353),
    [sym__open_bracket2] = STATE(1352),
    [sym_identifier] = ACTIONS(5431),
    [anon_sym_BSLASH] = ACTIONS(5429),
    [anon_sym_function] = ACTIONS(5431),
    [anon_sym_EQ] = ACTIONS(5783),
    [anon_sym_if] = ACTIONS(5431),
    [anon_sym_for] = ACTIONS(5431),
    [anon_sym_while] = ACTIONS(5431),
    [anon_sym_repeat] = ACTIONS(5431),
    [anon_sym_QMARK] = ACTIONS(5429),
    [anon_sym_TILDE] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(5431),
    [anon_sym_PLUS] = ACTIONS(5787),
    [anon_sym_DASH] = ACTIONS(5789),
    [anon_sym_LT_DASH] = ACTIONS(5791),
    [anon_sym_LT_LT_DASH] = ACTIONS(5791),
    [anon_sym_COLON_EQ] = ACTIONS(5791),
    [anon_sym_DASH_GT] = ACTIONS(5793),
    [anon_sym_DASH_GT_GT] = ACTIONS(5795),
    [anon_sym_PIPE] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5799),
    [anon_sym_PIPE_PIPE] = ACTIONS(5801),
    [anon_sym_AMP_AMP] = ACTIONS(5803),
    [anon_sym_LT] = ACTIONS(5805),
    [anon_sym_LT_EQ] = ACTIONS(5807),
    [anon_sym_GT] = ACTIONS(5805),
    [anon_sym_GT_EQ] = ACTIONS(5807),
    [anon_sym_EQ_EQ] = ACTIONS(5807),
    [anon_sym_BANG_EQ] = ACTIONS(5807),
    [anon_sym_STAR] = ACTIONS(5809),
    [anon_sym_SLASH] = ACTIONS(5811),
    [anon_sym_STAR_STAR] = ACTIONS(5813),
    [anon_sym_CARET] = ACTIONS(5813),
    [aux_sym_binary_operator_token1] = ACTIONS(5815),
    [anon_sym_PIPE_GT] = ACTIONS(5815),
    [anon_sym_COLON] = ACTIONS(5817),
    [anon_sym_DOLLAR] = ACTIONS(5819),
    [anon_sym_AT] = ACTIONS(5819),
    [aux_sym__hex_literal_token1] = ACTIONS(5429),
    [sym__number_literal] = ACTIONS(5431),
    [anon_sym_SQUOTE] = ACTIONS(5429),
    [anon_sym_DQUOTE] = ACTIONS(5429),
    [sym_return] = ACTIONS(5431),
    [sym_next] = ACTIONS(5431),
    [sym_break] = ACTIONS(5431),
    [sym_true] = ACTIONS(5431),
    [sym_false] = ACTIONS(5431),
    [sym_null] = ACTIONS(5431),
    [sym_inf] = ACTIONS(5431),
    [sym_nan] = ACTIONS(5431),
    [anon_sym_NA] = ACTIONS(5431),
    [anon_sym_NA_integer_] = ACTIONS(5431),
    [anon_sym_NA_real_] = ACTIONS(5431),
    [anon_sym_NA_complex_] = ACTIONS(5431),
    [anon_sym_NA_character_] = ACTIONS(5431),
    [sym_dots] = ACTIONS(5431),
    [sym_dot_dot_i] = ACTIONS(5429),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5429),
    [sym__newline] = ACTIONS(5429),
    [sym__raw_string_literal] = ACTIONS(5429),
    [sym__external_else] = ACTIONS(5429),
    [sym__external_open_parenthesis] = ACTIONS(5823),
    [sym__external_close_parenthesis] = ACTIONS(5429),
    [sym__external_open_brace] = ACTIONS(5429),
    [sym__external_open_bracket] = ACTIONS(5825),
    [sym__external_close_bracket] = ACTIONS(5429),
    [sym__external_open_bracket2] = ACTIONS(5827),
  },
  [1310] = {
    [sym_call_arguments] = STATE(2731),
    [sym_subset_arguments] = STATE(2730),
    [sym_subset2_arguments] = STATE(2729),
    [sym__open_parenthesis] = STATE(1357),
    [sym__open_bracket] = STATE(1353),
    [sym__open_bracket2] = STATE(1352),
    [sym_identifier] = ACTIONS(5435),
    [anon_sym_BSLASH] = ACTIONS(5433),
    [anon_sym_function] = ACTIONS(5435),
    [anon_sym_EQ] = ACTIONS(5783),
    [anon_sym_if] = ACTIONS(5435),
    [anon_sym_for] = ACTIONS(5435),
    [anon_sym_while] = ACTIONS(5435),
    [anon_sym_repeat] = ACTIONS(5435),
    [anon_sym_QMARK] = ACTIONS(5433),
    [anon_sym_TILDE] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(5435),
    [anon_sym_PLUS] = ACTIONS(5787),
    [anon_sym_DASH] = ACTIONS(5789),
    [anon_sym_LT_DASH] = ACTIONS(5791),
    [anon_sym_LT_LT_DASH] = ACTIONS(5791),
    [anon_sym_COLON_EQ] = ACTIONS(5791),
    [anon_sym_DASH_GT] = ACTIONS(5793),
    [anon_sym_DASH_GT_GT] = ACTIONS(5795),
    [anon_sym_PIPE] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5799),
    [anon_sym_PIPE_PIPE] = ACTIONS(5801),
    [anon_sym_AMP_AMP] = ACTIONS(5803),
    [anon_sym_LT] = ACTIONS(5805),
    [anon_sym_LT_EQ] = ACTIONS(5807),
    [anon_sym_GT] = ACTIONS(5805),
    [anon_sym_GT_EQ] = ACTIONS(5807),
    [anon_sym_EQ_EQ] = ACTIONS(5807),
    [anon_sym_BANG_EQ] = ACTIONS(5807),
    [anon_sym_STAR] = ACTIONS(5809),
    [anon_sym_SLASH] = ACTIONS(5811),
    [anon_sym_STAR_STAR] = ACTIONS(5813),
    [anon_sym_CARET] = ACTIONS(5813),
    [aux_sym_binary_operator_token1] = ACTIONS(5815),
    [anon_sym_PIPE_GT] = ACTIONS(5815),
    [anon_sym_COLON] = ACTIONS(5817),
    [anon_sym_DOLLAR] = ACTIONS(5819),
    [anon_sym_AT] = ACTIONS(5819),
    [aux_sym__hex_literal_token1] = ACTIONS(5433),
    [sym__number_literal] = ACTIONS(5435),
    [anon_sym_SQUOTE] = ACTIONS(5433),
    [anon_sym_DQUOTE] = ACTIONS(5433),
    [sym_return] = ACTIONS(5435),
    [sym_next] = ACTIONS(5435),
    [sym_break] = ACTIONS(5435),
    [sym_true] = ACTIONS(5435),
    [sym_false] = ACTIONS(5435),
    [sym_null] = ACTIONS(5435),
    [sym_inf] = ACTIONS(5435),
    [sym_nan] = ACTIONS(5435),
    [anon_sym_NA] = ACTIONS(5435),
    [anon_sym_NA_integer_] = ACTIONS(5435),
    [anon_sym_NA_real_] = ACTIONS(5435),
    [anon_sym_NA_complex_] = ACTIONS(5435),
    [anon_sym_NA_character_] = ACTIONS(5435),
    [sym_dots] = ACTIONS(5435),
    [sym_dot_dot_i] = ACTIONS(5433),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5433),
    [sym__newline] = ACTIONS(5433),
    [sym__raw_string_literal] = ACTIONS(5433),
    [sym__external_else] = ACTIONS(5433),
    [sym__external_open_parenthesis] = ACTIONS(5823),
    [sym__external_close_parenthesis] = ACTIONS(5433),
    [sym__external_open_brace] = ACTIONS(5433),
    [sym__external_open_bracket] = ACTIONS(5825),
    [sym__external_close_bracket] = ACTIONS(5433),
    [sym__external_open_bracket2] = ACTIONS(5827),
  },
  [1311] = {
    [sym_call_arguments] = STATE(2731),
    [sym_subset_arguments] = STATE(2730),
    [sym_subset2_arguments] = STATE(2729),
    [sym__open_parenthesis] = STATE(1357),
    [sym__open_bracket] = STATE(1353),
    [sym__open_bracket2] = STATE(1352),
    [sym_identifier] = ACTIONS(5439),
    [anon_sym_BSLASH] = ACTIONS(5437),
    [anon_sym_function] = ACTIONS(5439),
    [anon_sym_EQ] = ACTIONS(5783),
    [anon_sym_if] = ACTIONS(5439),
    [anon_sym_for] = ACTIONS(5439),
    [anon_sym_while] = ACTIONS(5439),
    [anon_sym_repeat] = ACTIONS(5439),
    [anon_sym_QMARK] = ACTIONS(5437),
    [anon_sym_TILDE] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(5439),
    [anon_sym_PLUS] = ACTIONS(5787),
    [anon_sym_DASH] = ACTIONS(5789),
    [anon_sym_LT_DASH] = ACTIONS(5791),
    [anon_sym_LT_LT_DASH] = ACTIONS(5791),
    [anon_sym_COLON_EQ] = ACTIONS(5791),
    [anon_sym_DASH_GT] = ACTIONS(5793),
    [anon_sym_DASH_GT_GT] = ACTIONS(5795),
    [anon_sym_PIPE] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5799),
    [anon_sym_PIPE_PIPE] = ACTIONS(5801),
    [anon_sym_AMP_AMP] = ACTIONS(5803),
    [anon_sym_LT] = ACTIONS(5805),
    [anon_sym_LT_EQ] = ACTIONS(5807),
    [anon_sym_GT] = ACTIONS(5805),
    [anon_sym_GT_EQ] = ACTIONS(5807),
    [anon_sym_EQ_EQ] = ACTIONS(5807),
    [anon_sym_BANG_EQ] = ACTIONS(5807),
    [anon_sym_STAR] = ACTIONS(5809),
    [anon_sym_SLASH] = ACTIONS(5811),
    [anon_sym_STAR_STAR] = ACTIONS(5813),
    [anon_sym_CARET] = ACTIONS(5813),
    [aux_sym_binary_operator_token1] = ACTIONS(5815),
    [anon_sym_PIPE_GT] = ACTIONS(5815),
    [anon_sym_COLON] = ACTIONS(5817),
    [anon_sym_DOLLAR] = ACTIONS(5819),
    [anon_sym_AT] = ACTIONS(5819),
    [aux_sym__hex_literal_token1] = ACTIONS(5437),
    [sym__number_literal] = ACTIONS(5439),
    [anon_sym_SQUOTE] = ACTIONS(5437),
    [anon_sym_DQUOTE] = ACTIONS(5437),
    [sym_return] = ACTIONS(5439),
    [sym_next] = ACTIONS(5439),
    [sym_break] = ACTIONS(5439),
    [sym_true] = ACTIONS(5439),
    [sym_false] = ACTIONS(5439),
    [sym_null] = ACTIONS(5439),
    [sym_inf] = ACTIONS(5439),
    [sym_nan] = ACTIONS(5439),
    [anon_sym_NA] = ACTIONS(5439),
    [anon_sym_NA_integer_] = ACTIONS(5439),
    [anon_sym_NA_real_] = ACTIONS(5439),
    [anon_sym_NA_complex_] = ACTIONS(5439),
    [anon_sym_NA_character_] = ACTIONS(5439),
    [sym_dots] = ACTIONS(5439),
    [sym_dot_dot_i] = ACTIONS(5437),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5437),
    [sym__newline] = ACTIONS(5437),
    [sym__raw_string_literal] = ACTIONS(5437),
    [sym__external_else] = ACTIONS(5437),
    [sym__external_open_parenthesis] = ACTIONS(5823),
    [sym__external_close_parenthesis] = ACTIONS(5437),
    [sym__external_open_brace] = ACTIONS(5437),
    [sym__external_open_bracket] = ACTIONS(5825),
    [sym__external_close_bracket] = ACTIONS(5437),
    [sym__external_open_bracket2] = ACTIONS(5827),
  },
  [1312] = {
    [sym_call_arguments] = STATE(2731),
    [sym_subset_arguments] = STATE(2730),
    [sym_subset2_arguments] = STATE(2729),
    [sym__open_parenthesis] = STATE(1357),
    [sym__open_bracket] = STATE(1353),
    [sym__open_bracket2] = STATE(1352),
    [sym_identifier] = ACTIONS(5443),
    [anon_sym_BSLASH] = ACTIONS(5441),
    [anon_sym_function] = ACTIONS(5443),
    [anon_sym_EQ] = ACTIONS(5783),
    [anon_sym_if] = ACTIONS(5443),
    [anon_sym_for] = ACTIONS(5443),
    [anon_sym_while] = ACTIONS(5443),
    [anon_sym_repeat] = ACTIONS(5443),
    [anon_sym_QMARK] = ACTIONS(5441),
    [anon_sym_TILDE] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(5443),
    [anon_sym_PLUS] = ACTIONS(5787),
    [anon_sym_DASH] = ACTIONS(5789),
    [anon_sym_LT_DASH] = ACTIONS(5791),
    [anon_sym_LT_LT_DASH] = ACTIONS(5791),
    [anon_sym_COLON_EQ] = ACTIONS(5791),
    [anon_sym_DASH_GT] = ACTIONS(5793),
    [anon_sym_DASH_GT_GT] = ACTIONS(5795),
    [anon_sym_PIPE] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5799),
    [anon_sym_PIPE_PIPE] = ACTIONS(5801),
    [anon_sym_AMP_AMP] = ACTIONS(5803),
    [anon_sym_LT] = ACTIONS(5805),
    [anon_sym_LT_EQ] = ACTIONS(5807),
    [anon_sym_GT] = ACTIONS(5805),
    [anon_sym_GT_EQ] = ACTIONS(5807),
    [anon_sym_EQ_EQ] = ACTIONS(5807),
    [anon_sym_BANG_EQ] = ACTIONS(5807),
    [anon_sym_STAR] = ACTIONS(5809),
    [anon_sym_SLASH] = ACTIONS(5811),
    [anon_sym_STAR_STAR] = ACTIONS(5813),
    [anon_sym_CARET] = ACTIONS(5813),
    [aux_sym_binary_operator_token1] = ACTIONS(5815),
    [anon_sym_PIPE_GT] = ACTIONS(5815),
    [anon_sym_COLON] = ACTIONS(5817),
    [anon_sym_DOLLAR] = ACTIONS(5819),
    [anon_sym_AT] = ACTIONS(5819),
    [aux_sym__hex_literal_token1] = ACTIONS(5441),
    [sym__number_literal] = ACTIONS(5443),
    [anon_sym_SQUOTE] = ACTIONS(5441),
    [anon_sym_DQUOTE] = ACTIONS(5441),
    [sym_return] = ACTIONS(5443),
    [sym_next] = ACTIONS(5443),
    [sym_break] = ACTIONS(5443),
    [sym_true] = ACTIONS(5443),
    [sym_false] = ACTIONS(5443),
    [sym_null] = ACTIONS(5443),
    [sym_inf] = ACTIONS(5443),
    [sym_nan] = ACTIONS(5443),
    [anon_sym_NA] = ACTIONS(5443),
    [anon_sym_NA_integer_] = ACTIONS(5443),
    [anon_sym_NA_real_] = ACTIONS(5443),
    [anon_sym_NA_complex_] = ACTIONS(5443),
    [anon_sym_NA_character_] = ACTIONS(5443),
    [sym_dots] = ACTIONS(5443),
    [sym_dot_dot_i] = ACTIONS(5441),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5441),
    [sym__newline] = ACTIONS(5441),
    [sym__raw_string_literal] = ACTIONS(5441),
    [sym__external_else] = ACTIONS(5441),
    [sym__external_open_parenthesis] = ACTIONS(5823),
    [sym__external_close_parenthesis] = ACTIONS(5441),
    [sym__external_open_brace] = ACTIONS(5441),
    [sym__external_open_bracket] = ACTIONS(5825),
    [sym__external_close_bracket] = ACTIONS(5441),
    [sym__external_open_bracket2] = ACTIONS(5827),
  },
  [1313] = {
    [sym_call_arguments] = STATE(2731),
    [sym_subset_arguments] = STATE(2730),
    [sym_subset2_arguments] = STATE(2729),
    [sym__open_parenthesis] = STATE(1357),
    [sym__open_bracket] = STATE(1353),
    [sym__open_bracket2] = STATE(1352),
    [sym_identifier] = ACTIONS(5455),
    [anon_sym_BSLASH] = ACTIONS(5453),
    [anon_sym_function] = ACTIONS(5455),
    [anon_sym_EQ] = ACTIONS(5783),
    [anon_sym_if] = ACTIONS(5455),
    [anon_sym_for] = ACTIONS(5455),
    [anon_sym_while] = ACTIONS(5455),
    [anon_sym_repeat] = ACTIONS(5455),
    [anon_sym_QMARK] = ACTIONS(5453),
    [anon_sym_TILDE] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(5455),
    [anon_sym_PLUS] = ACTIONS(5787),
    [anon_sym_DASH] = ACTIONS(5789),
    [anon_sym_LT_DASH] = ACTIONS(5791),
    [anon_sym_LT_LT_DASH] = ACTIONS(5791),
    [anon_sym_COLON_EQ] = ACTIONS(5791),
    [anon_sym_DASH_GT] = ACTIONS(5793),
    [anon_sym_DASH_GT_GT] = ACTIONS(5795),
    [anon_sym_PIPE] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5799),
    [anon_sym_PIPE_PIPE] = ACTIONS(5801),
    [anon_sym_AMP_AMP] = ACTIONS(5803),
    [anon_sym_LT] = ACTIONS(5805),
    [anon_sym_LT_EQ] = ACTIONS(5807),
    [anon_sym_GT] = ACTIONS(5805),
    [anon_sym_GT_EQ] = ACTIONS(5807),
    [anon_sym_EQ_EQ] = ACTIONS(5807),
    [anon_sym_BANG_EQ] = ACTIONS(5807),
    [anon_sym_STAR] = ACTIONS(5809),
    [anon_sym_SLASH] = ACTIONS(5811),
    [anon_sym_STAR_STAR] = ACTIONS(5813),
    [anon_sym_CARET] = ACTIONS(5813),
    [aux_sym_binary_operator_token1] = ACTIONS(5815),
    [anon_sym_PIPE_GT] = ACTIONS(5815),
    [anon_sym_COLON] = ACTIONS(5817),
    [anon_sym_DOLLAR] = ACTIONS(5819),
    [anon_sym_AT] = ACTIONS(5819),
    [aux_sym__hex_literal_token1] = ACTIONS(5453),
    [sym__number_literal] = ACTIONS(5455),
    [anon_sym_SQUOTE] = ACTIONS(5453),
    [anon_sym_DQUOTE] = ACTIONS(5453),
    [sym_return] = ACTIONS(5455),
    [sym_next] = ACTIONS(5455),
    [sym_break] = ACTIONS(5455),
    [sym_true] = ACTIONS(5455),
    [sym_false] = ACTIONS(5455),
    [sym_null] = ACTIONS(5455),
    [sym_inf] = ACTIONS(5455),
    [sym_nan] = ACTIONS(5455),
    [anon_sym_NA] = ACTIONS(5455),
    [anon_sym_NA_integer_] = ACTIONS(5455),
    [anon_sym_NA_real_] = ACTIONS(5455),
    [anon_sym_NA_complex_] = ACTIONS(5455),
    [anon_sym_NA_character_] = ACTIONS(5455),
    [sym_dots] = ACTIONS(5455),
    [sym_dot_dot_i] = ACTIONS(5453),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5453),
    [sym__newline] = ACTIONS(5453),
    [sym__raw_string_literal] = ACTIONS(5453),
    [sym__external_else] = ACTIONS(5453),
    [sym__external_open_parenthesis] = ACTIONS(5823),
    [sym__external_close_parenthesis] = ACTIONS(5453),
    [sym__external_open_brace] = ACTIONS(5453),
    [sym__external_open_bracket] = ACTIONS(5825),
    [sym__external_close_bracket] = ACTIONS(5453),
    [sym__external_open_bracket2] = ACTIONS(5827),
  },
  [1314] = {
    [sym_call_arguments] = STATE(2731),
    [sym_subset_arguments] = STATE(2730),
    [sym_subset2_arguments] = STATE(2729),
    [sym__open_parenthesis] = STATE(1357),
    [sym__open_bracket] = STATE(1353),
    [sym__open_bracket2] = STATE(1352),
    [sym_identifier] = ACTIONS(5451),
    [anon_sym_BSLASH] = ACTIONS(5449),
    [anon_sym_function] = ACTIONS(5451),
    [anon_sym_EQ] = ACTIONS(5783),
    [anon_sym_if] = ACTIONS(5451),
    [anon_sym_for] = ACTIONS(5451),
    [anon_sym_while] = ACTIONS(5451),
    [anon_sym_repeat] = ACTIONS(5451),
    [anon_sym_QMARK] = ACTIONS(5449),
    [anon_sym_TILDE] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(5451),
    [anon_sym_PLUS] = ACTIONS(5787),
    [anon_sym_DASH] = ACTIONS(5789),
    [anon_sym_LT_DASH] = ACTIONS(5791),
    [anon_sym_LT_LT_DASH] = ACTIONS(5791),
    [anon_sym_COLON_EQ] = ACTIONS(5791),
    [anon_sym_DASH_GT] = ACTIONS(5793),
    [anon_sym_DASH_GT_GT] = ACTIONS(5795),
    [anon_sym_PIPE] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5799),
    [anon_sym_PIPE_PIPE] = ACTIONS(5801),
    [anon_sym_AMP_AMP] = ACTIONS(5803),
    [anon_sym_LT] = ACTIONS(5805),
    [anon_sym_LT_EQ] = ACTIONS(5807),
    [anon_sym_GT] = ACTIONS(5805),
    [anon_sym_GT_EQ] = ACTIONS(5807),
    [anon_sym_EQ_EQ] = ACTIONS(5807),
    [anon_sym_BANG_EQ] = ACTIONS(5807),
    [anon_sym_STAR] = ACTIONS(5809),
    [anon_sym_SLASH] = ACTIONS(5811),
    [anon_sym_STAR_STAR] = ACTIONS(5813),
    [anon_sym_CARET] = ACTIONS(5813),
    [aux_sym_binary_operator_token1] = ACTIONS(5815),
    [anon_sym_PIPE_GT] = ACTIONS(5815),
    [anon_sym_COLON] = ACTIONS(5817),
    [anon_sym_DOLLAR] = ACTIONS(5819),
    [anon_sym_AT] = ACTIONS(5819),
    [aux_sym__hex_literal_token1] = ACTIONS(5449),
    [sym__number_literal] = ACTIONS(5451),
    [anon_sym_SQUOTE] = ACTIONS(5449),
    [anon_sym_DQUOTE] = ACTIONS(5449),
    [sym_return] = ACTIONS(5451),
    [sym_next] = ACTIONS(5451),
    [sym_break] = ACTIONS(5451),
    [sym_true] = ACTIONS(5451),
    [sym_false] = ACTIONS(5451),
    [sym_null] = ACTIONS(5451),
    [sym_inf] = ACTIONS(5451),
    [sym_nan] = ACTIONS(5451),
    [anon_sym_NA] = ACTIONS(5451),
    [anon_sym_NA_integer_] = ACTIONS(5451),
    [anon_sym_NA_real_] = ACTIONS(5451),
    [anon_sym_NA_complex_] = ACTIONS(5451),
    [anon_sym_NA_character_] = ACTIONS(5451),
    [sym_dots] = ACTIONS(5451),
    [sym_dot_dot_i] = ACTIONS(5449),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5449),
    [sym__newline] = ACTIONS(5449),
    [sym__raw_string_literal] = ACTIONS(5449),
    [sym__external_else] = ACTIONS(5449),
    [sym__external_open_parenthesis] = ACTIONS(5823),
    [sym__external_close_parenthesis] = ACTIONS(5449),
    [sym__external_open_brace] = ACTIONS(5449),
    [sym__external_open_bracket] = ACTIONS(5825),
    [sym__external_close_bracket] = ACTIONS(5449),
    [sym__external_open_bracket2] = ACTIONS(5827),
  },
  [1315] = {
    [sym_call_arguments] = STATE(2870),
    [sym_subset_arguments] = STATE(2869),
    [sym_subset2_arguments] = STATE(2867),
    [sym__else] = STATE(4311),
    [sym__open_parenthesis] = STATE(1362),
    [sym__open_bracket] = STATE(1361),
    [sym__open_bracket2] = STATE(1360),
    [sym_identifier] = ACTIONS(5115),
    [anon_sym_BSLASH] = ACTIONS(5117),
    [anon_sym_function] = ACTIONS(5115),
    [anon_sym_EQ] = ACTIONS(6111),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_for] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_repeat] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(5117),
    [anon_sym_TILDE] = ACTIONS(6113),
    [anon_sym_BANG] = ACTIONS(5115),
    [anon_sym_PLUS] = ACTIONS(6115),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_LT_DASH] = ACTIONS(6119),
    [anon_sym_LT_LT_DASH] = ACTIONS(6119),
    [anon_sym_COLON_EQ] = ACTIONS(6119),
    [anon_sym_DASH_GT] = ACTIONS(6121),
    [anon_sym_DASH_GT_GT] = ACTIONS(6123),
    [anon_sym_PIPE] = ACTIONS(6125),
    [anon_sym_AMP] = ACTIONS(6127),
    [anon_sym_PIPE_PIPE] = ACTIONS(6129),
    [anon_sym_AMP_AMP] = ACTIONS(6131),
    [anon_sym_LT] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6135),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_GT_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(6135),
    [anon_sym_STAR] = ACTIONS(6137),
    [anon_sym_SLASH] = ACTIONS(6139),
    [anon_sym_STAR_STAR] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6141),
    [aux_sym_binary_operator_token1] = ACTIONS(6143),
    [anon_sym_PIPE_GT] = ACTIONS(6143),
    [anon_sym_COLON] = ACTIONS(6145),
    [anon_sym_DOLLAR] = ACTIONS(6147),
    [anon_sym_AT] = ACTIONS(6147),
    [aux_sym__hex_literal_token1] = ACTIONS(5117),
    [sym__number_literal] = ACTIONS(5115),
    [anon_sym_SQUOTE] = ACTIONS(5117),
    [anon_sym_DQUOTE] = ACTIONS(5117),
    [sym_return] = ACTIONS(5115),
    [sym_next] = ACTIONS(5115),
    [sym_break] = ACTIONS(5115),
    [sym_true] = ACTIONS(5115),
    [sym_false] = ACTIONS(5115),
    [sym_null] = ACTIONS(5115),
    [sym_inf] = ACTIONS(5115),
    [sym_nan] = ACTIONS(5115),
    [anon_sym_NA] = ACTIONS(5115),
    [anon_sym_NA_integer_] = ACTIONS(5115),
    [anon_sym_NA_real_] = ACTIONS(5115),
    [anon_sym_NA_complex_] = ACTIONS(5115),
    [anon_sym_NA_character_] = ACTIONS(5115),
    [sym_dots] = ACTIONS(5115),
    [sym_dot_dot_i] = ACTIONS(5117),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5117),
    [sym__newline] = ACTIONS(5117),
    [sym__raw_string_literal] = ACTIONS(5117),
    [sym__external_else] = ACTIONS(6255),
    [sym__external_open_parenthesis] = ACTIONS(6151),
    [sym__external_open_brace] = ACTIONS(5117),
    [sym__external_open_bracket] = ACTIONS(6153),
    [sym__external_open_bracket2] = ACTIONS(6155),
    [sym__external_close_bracket2] = ACTIONS(5117),
  },
  [1316] = {
    [sym_call_arguments] = STATE(2870),
    [sym_subset_arguments] = STATE(2869),
    [sym_subset2_arguments] = STATE(2867),
    [sym__else] = STATE(4326),
    [sym__open_parenthesis] = STATE(1362),
    [sym__open_bracket] = STATE(1361),
    [sym__open_bracket2] = STATE(1360),
    [sym_identifier] = ACTIONS(5065),
    [anon_sym_BSLASH] = ACTIONS(5067),
    [anon_sym_function] = ACTIONS(5065),
    [anon_sym_EQ] = ACTIONS(6111),
    [anon_sym_if] = ACTIONS(5065),
    [anon_sym_for] = ACTIONS(5065),
    [anon_sym_while] = ACTIONS(5065),
    [anon_sym_repeat] = ACTIONS(5065),
    [anon_sym_QMARK] = ACTIONS(5067),
    [anon_sym_TILDE] = ACTIONS(6113),
    [anon_sym_BANG] = ACTIONS(5065),
    [anon_sym_PLUS] = ACTIONS(6115),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_LT_DASH] = ACTIONS(6119),
    [anon_sym_LT_LT_DASH] = ACTIONS(6119),
    [anon_sym_COLON_EQ] = ACTIONS(6119),
    [anon_sym_DASH_GT] = ACTIONS(6121),
    [anon_sym_DASH_GT_GT] = ACTIONS(6123),
    [anon_sym_PIPE] = ACTIONS(6125),
    [anon_sym_AMP] = ACTIONS(6127),
    [anon_sym_PIPE_PIPE] = ACTIONS(6129),
    [anon_sym_AMP_AMP] = ACTIONS(6131),
    [anon_sym_LT] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6135),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_GT_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(6135),
    [anon_sym_STAR] = ACTIONS(6137),
    [anon_sym_SLASH] = ACTIONS(6139),
    [anon_sym_STAR_STAR] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6141),
    [aux_sym_binary_operator_token1] = ACTIONS(6143),
    [anon_sym_PIPE_GT] = ACTIONS(6143),
    [anon_sym_COLON] = ACTIONS(6145),
    [anon_sym_DOLLAR] = ACTIONS(6147),
    [anon_sym_AT] = ACTIONS(6147),
    [aux_sym__hex_literal_token1] = ACTIONS(5067),
    [sym__number_literal] = ACTIONS(5065),
    [anon_sym_SQUOTE] = ACTIONS(5067),
    [anon_sym_DQUOTE] = ACTIONS(5067),
    [sym_return] = ACTIONS(5065),
    [sym_next] = ACTIONS(5065),
    [sym_break] = ACTIONS(5065),
    [sym_true] = ACTIONS(5065),
    [sym_false] = ACTIONS(5065),
    [sym_null] = ACTIONS(5065),
    [sym_inf] = ACTIONS(5065),
    [sym_nan] = ACTIONS(5065),
    [anon_sym_NA] = ACTIONS(5065),
    [anon_sym_NA_integer_] = ACTIONS(5065),
    [anon_sym_NA_real_] = ACTIONS(5065),
    [anon_sym_NA_complex_] = ACTIONS(5065),
    [anon_sym_NA_character_] = ACTIONS(5065),
    [sym_dots] = ACTIONS(5065),
    [sym_dot_dot_i] = ACTIONS(5067),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5067),
    [sym__newline] = ACTIONS(5067),
    [sym__raw_string_literal] = ACTIONS(5067),
    [sym__external_else] = ACTIONS(6257),
    [sym__external_open_parenthesis] = ACTIONS(6151),
    [sym__external_open_brace] = ACTIONS(5067),
    [sym__external_open_bracket] = ACTIONS(6153),
    [sym__external_open_bracket2] = ACTIONS(6155),
    [sym__external_close_bracket2] = ACTIONS(5067),
  },
  [1317] = {
    [sym_string] = STATE(2451),
    [sym__single_quoted_string] = STATE(2200),
    [sym__double_quoted_string] = STATE(2201),
    [sym__string_or_identifier] = STATE(2451),
    [aux_sym_function_definition_repeat1] = STATE(1299),
    [sym_identifier] = ACTIONS(6259),
    [anon_sym_BSLASH] = ACTIONS(5659),
    [anon_sym_function] = ACTIONS(5663),
    [anon_sym_EQ] = ACTIONS(5663),
    [anon_sym_if] = ACTIONS(5663),
    [anon_sym_for] = ACTIONS(5663),
    [anon_sym_while] = ACTIONS(5663),
    [anon_sym_repeat] = ACTIONS(5663),
    [anon_sym_QMARK] = ACTIONS(5659),
    [anon_sym_TILDE] = ACTIONS(5659),
    [anon_sym_BANG] = ACTIONS(5663),
    [anon_sym_PLUS] = ACTIONS(5659),
    [anon_sym_DASH] = ACTIONS(5663),
    [anon_sym_LT_DASH] = ACTIONS(5659),
    [anon_sym_LT_LT_DASH] = ACTIONS(5659),
    [anon_sym_COLON_EQ] = ACTIONS(5659),
    [anon_sym_DASH_GT] = ACTIONS(5663),
    [anon_sym_DASH_GT_GT] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(5663),
    [anon_sym_AMP] = ACTIONS(5663),
    [anon_sym_PIPE_PIPE] = ACTIONS(5659),
    [anon_sym_AMP_AMP] = ACTIONS(5659),
    [anon_sym_LT] = ACTIONS(5663),
    [anon_sym_LT_EQ] = ACTIONS(5659),
    [anon_sym_GT] = ACTIONS(5663),
    [anon_sym_GT_EQ] = ACTIONS(5659),
    [anon_sym_EQ_EQ] = ACTIONS(5659),
    [anon_sym_BANG_EQ] = ACTIONS(5659),
    [anon_sym_STAR] = ACTIONS(5663),
    [anon_sym_SLASH] = ACTIONS(5659),
    [anon_sym_STAR_STAR] = ACTIONS(5659),
    [anon_sym_CARET] = ACTIONS(5659),
    [aux_sym_binary_operator_token1] = ACTIONS(5659),
    [anon_sym_PIPE_GT] = ACTIONS(5659),
    [anon_sym_COLON] = ACTIONS(5663),
    [anon_sym_DOLLAR] = ACTIONS(5659),
    [anon_sym_AT] = ACTIONS(5659),
    [aux_sym__hex_literal_token1] = ACTIONS(5659),
    [sym__number_literal] = ACTIONS(5663),
    [anon_sym_SQUOTE] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(511),
    [sym_return] = ACTIONS(5663),
    [sym_next] = ACTIONS(5663),
    [sym_break] = ACTIONS(5663),
    [sym_true] = ACTIONS(5663),
    [sym_false] = ACTIONS(5663),
    [sym_null] = ACTIONS(5663),
    [sym_inf] = ACTIONS(5663),
    [sym_nan] = ACTIONS(5663),
    [anon_sym_NA] = ACTIONS(5663),
    [anon_sym_NA_integer_] = ACTIONS(5663),
    [anon_sym_NA_real_] = ACTIONS(5663),
    [anon_sym_NA_complex_] = ACTIONS(5663),
    [anon_sym_NA_character_] = ACTIONS(5663),
    [sym_dots] = ACTIONS(5663),
    [sym_dot_dot_i] = ACTIONS(5659),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5659),
    [sym__newline] = ACTIONS(6261),
    [sym__semicolon] = ACTIONS(5659),
    [sym__raw_string_literal] = ACTIONS(521),
    [sym__external_else] = ACTIONS(5659),
    [sym__external_open_parenthesis] = ACTIONS(5659),
    [sym__external_open_brace] = ACTIONS(5659),
    [sym__external_close_brace] = ACTIONS(5659),
    [sym__external_open_bracket] = ACTIONS(5659),
    [sym__external_close_bracket] = ACTIONS(5659),
    [sym__external_open_bracket2] = ACTIONS(5659),
  },
  [1318] = {
    [sym_call_arguments] = STATE(2731),
    [sym_subset_arguments] = STATE(2730),
    [sym_subset2_arguments] = STATE(2729),
    [sym__open_parenthesis] = STATE(1357),
    [sym__open_bracket] = STATE(1353),
    [sym__open_bracket2] = STATE(1352),
    [sym_identifier] = ACTIONS(5447),
    [anon_sym_BSLASH] = ACTIONS(5445),
    [anon_sym_function] = ACTIONS(5447),
    [anon_sym_EQ] = ACTIONS(5783),
    [anon_sym_if] = ACTIONS(5447),
    [anon_sym_for] = ACTIONS(5447),
    [anon_sym_while] = ACTIONS(5447),
    [anon_sym_repeat] = ACTIONS(5447),
    [anon_sym_QMARK] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(5447),
    [anon_sym_PLUS] = ACTIONS(5787),
    [anon_sym_DASH] = ACTIONS(5789),
    [anon_sym_LT_DASH] = ACTIONS(5791),
    [anon_sym_LT_LT_DASH] = ACTIONS(5791),
    [anon_sym_COLON_EQ] = ACTIONS(5791),
    [anon_sym_DASH_GT] = ACTIONS(5793),
    [anon_sym_DASH_GT_GT] = ACTIONS(5795),
    [anon_sym_PIPE] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5799),
    [anon_sym_PIPE_PIPE] = ACTIONS(5801),
    [anon_sym_AMP_AMP] = ACTIONS(5803),
    [anon_sym_LT] = ACTIONS(5805),
    [anon_sym_LT_EQ] = ACTIONS(5807),
    [anon_sym_GT] = ACTIONS(5805),
    [anon_sym_GT_EQ] = ACTIONS(5807),
    [anon_sym_EQ_EQ] = ACTIONS(5807),
    [anon_sym_BANG_EQ] = ACTIONS(5807),
    [anon_sym_STAR] = ACTIONS(5809),
    [anon_sym_SLASH] = ACTIONS(5811),
    [anon_sym_STAR_STAR] = ACTIONS(5813),
    [anon_sym_CARET] = ACTIONS(5813),
    [aux_sym_binary_operator_token1] = ACTIONS(5815),
    [anon_sym_PIPE_GT] = ACTIONS(5815),
    [anon_sym_COLON] = ACTIONS(5817),
    [anon_sym_DOLLAR] = ACTIONS(5819),
    [anon_sym_AT] = ACTIONS(5819),
    [aux_sym__hex_literal_token1] = ACTIONS(5445),
    [sym__number_literal] = ACTIONS(5447),
    [anon_sym_SQUOTE] = ACTIONS(5445),
    [anon_sym_DQUOTE] = ACTIONS(5445),
    [sym_return] = ACTIONS(5447),
    [sym_next] = ACTIONS(5447),
    [sym_break] = ACTIONS(5447),
    [sym_true] = ACTIONS(5447),
    [sym_false] = ACTIONS(5447),
    [sym_null] = ACTIONS(5447),
    [sym_inf] = ACTIONS(5447),
    [sym_nan] = ACTIONS(5447),
    [anon_sym_NA] = ACTIONS(5447),
    [anon_sym_NA_integer_] = ACTIONS(5447),
    [anon_sym_NA_real_] = ACTIONS(5447),
    [anon_sym_NA_complex_] = ACTIONS(5447),
    [anon_sym_NA_character_] = ACTIONS(5447),
    [sym_dots] = ACTIONS(5447),
    [sym_dot_dot_i] = ACTIONS(5445),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5445),
    [sym__newline] = ACTIONS(5445),
    [sym__raw_string_literal] = ACTIONS(5445),
    [sym__external_else] = ACTIONS(5445),
    [sym__external_open_parenthesis] = ACTIONS(5823),
    [sym__external_close_parenthesis] = ACTIONS(5445),
    [sym__external_open_brace] = ACTIONS(5445),
    [sym__external_open_bracket] = ACTIONS(5825),
    [sym__external_close_bracket] = ACTIONS(5445),
    [sym__external_open_bracket2] = ACTIONS(5827),
  },
  [1319] = {
    [sym_call_arguments] = STATE(2840),
    [sym_subset_arguments] = STATE(2797),
    [sym_subset2_arguments] = STATE(2801),
    [sym__open_parenthesis] = STATE(1344),
    [sym__open_bracket] = STATE(1374),
    [sym__open_bracket2] = STATE(1452),
    [ts_builtin_sym_end] = ACTIONS(5421),
    [sym_identifier] = ACTIONS(5423),
    [anon_sym_BSLASH] = ACTIONS(5421),
    [anon_sym_function] = ACTIONS(5423),
    [anon_sym_EQ] = ACTIONS(6263),
    [anon_sym_if] = ACTIONS(5423),
    [anon_sym_for] = ACTIONS(5423),
    [anon_sym_while] = ACTIONS(5423),
    [anon_sym_repeat] = ACTIONS(5423),
    [anon_sym_QMARK] = ACTIONS(5421),
    [anon_sym_TILDE] = ACTIONS(6265),
    [anon_sym_BANG] = ACTIONS(5423),
    [anon_sym_PLUS] = ACTIONS(6267),
    [anon_sym_DASH] = ACTIONS(6269),
    [anon_sym_LT_DASH] = ACTIONS(6271),
    [anon_sym_LT_LT_DASH] = ACTIONS(6271),
    [anon_sym_COLON_EQ] = ACTIONS(6271),
    [anon_sym_DASH_GT] = ACTIONS(6273),
    [anon_sym_DASH_GT_GT] = ACTIONS(6275),
    [anon_sym_PIPE] = ACTIONS(6277),
    [anon_sym_AMP] = ACTIONS(6279),
    [anon_sym_PIPE_PIPE] = ACTIONS(6281),
    [anon_sym_AMP_AMP] = ACTIONS(6283),
    [anon_sym_LT] = ACTIONS(6285),
    [anon_sym_LT_EQ] = ACTIONS(6287),
    [anon_sym_GT] = ACTIONS(6285),
    [anon_sym_GT_EQ] = ACTIONS(6287),
    [anon_sym_EQ_EQ] = ACTIONS(6287),
    [anon_sym_BANG_EQ] = ACTIONS(6287),
    [anon_sym_STAR] = ACTIONS(6289),
    [anon_sym_SLASH] = ACTIONS(6291),
    [anon_sym_STAR_STAR] = ACTIONS(6293),
    [anon_sym_CARET] = ACTIONS(6293),
    [aux_sym_binary_operator_token1] = ACTIONS(6295),
    [anon_sym_PIPE_GT] = ACTIONS(6295),
    [anon_sym_COLON] = ACTIONS(6297),
    [anon_sym_DOLLAR] = ACTIONS(6299),
    [anon_sym_AT] = ACTIONS(6299),
    [aux_sym__hex_literal_token1] = ACTIONS(5421),
    [sym__number_literal] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5421),
    [anon_sym_DQUOTE] = ACTIONS(5421),
    [sym_return] = ACTIONS(5423),
    [sym_next] = ACTIONS(5423),
    [sym_break] = ACTIONS(5423),
    [sym_true] = ACTIONS(5423),
    [sym_false] = ACTIONS(5423),
    [sym_null] = ACTIONS(5423),
    [sym_inf] = ACTIONS(5423),
    [sym_nan] = ACTIONS(5423),
    [anon_sym_NA] = ACTIONS(5423),
    [anon_sym_NA_integer_] = ACTIONS(5423),
    [anon_sym_NA_real_] = ACTIONS(5423),
    [anon_sym_NA_complex_] = ACTIONS(5423),
    [anon_sym_NA_character_] = ACTIONS(5423),
    [sym_dots] = ACTIONS(5423),
    [sym_dot_dot_i] = ACTIONS(5421),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5421),
    [sym__semicolon] = ACTIONS(5421),
    [sym__raw_string_literal] = ACTIONS(5421),
    [sym__external_open_parenthesis] = ACTIONS(6301),
    [sym__external_open_brace] = ACTIONS(5421),
    [sym__external_close_brace] = ACTIONS(5421),
    [sym__external_open_bracket] = ACTIONS(6303),
    [sym__external_open_bracket2] = ACTIONS(6305),
  },
  [1320] = {
    [sym_call_arguments] = STATE(2808),
    [sym_subset_arguments] = STATE(2920),
    [sym_subset2_arguments] = STATE(2919),
    [sym__open_parenthesis] = STATE(1545),
    [sym__open_bracket] = STATE(1541),
    [sym__open_bracket2] = STATE(1539),
    [sym_identifier] = ACTIONS(5455),
    [anon_sym_BSLASH] = ACTIONS(5453),
    [anon_sym_function] = ACTIONS(5455),
    [anon_sym_EQ] = ACTIONS(6307),
    [anon_sym_if] = ACTIONS(5455),
    [anon_sym_for] = ACTIONS(5455),
    [anon_sym_while] = ACTIONS(5455),
    [anon_sym_repeat] = ACTIONS(5455),
    [anon_sym_QMARK] = ACTIONS(5453),
    [anon_sym_TILDE] = ACTIONS(6309),
    [anon_sym_BANG] = ACTIONS(5455),
    [anon_sym_PLUS] = ACTIONS(6311),
    [anon_sym_DASH] = ACTIONS(6313),
    [anon_sym_LT_DASH] = ACTIONS(6315),
    [anon_sym_LT_LT_DASH] = ACTIONS(6315),
    [anon_sym_COLON_EQ] = ACTIONS(6315),
    [anon_sym_DASH_GT] = ACTIONS(6317),
    [anon_sym_DASH_GT_GT] = ACTIONS(6319),
    [anon_sym_PIPE] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6323),
    [anon_sym_PIPE_PIPE] = ACTIONS(6325),
    [anon_sym_AMP_AMP] = ACTIONS(6327),
    [anon_sym_LT] = ACTIONS(6329),
    [anon_sym_LT_EQ] = ACTIONS(6331),
    [anon_sym_GT] = ACTIONS(6329),
    [anon_sym_GT_EQ] = ACTIONS(6331),
    [anon_sym_EQ_EQ] = ACTIONS(6331),
    [anon_sym_BANG_EQ] = ACTIONS(6331),
    [anon_sym_STAR] = ACTIONS(6333),
    [anon_sym_SLASH] = ACTIONS(6335),
    [anon_sym_STAR_STAR] = ACTIONS(6337),
    [anon_sym_CARET] = ACTIONS(6337),
    [aux_sym_binary_operator_token1] = ACTIONS(6339),
    [anon_sym_PIPE_GT] = ACTIONS(6339),
    [anon_sym_COLON] = ACTIONS(6341),
    [anon_sym_DOLLAR] = ACTIONS(6343),
    [anon_sym_AT] = ACTIONS(6343),
    [aux_sym__hex_literal_token1] = ACTIONS(5453),
    [sym__number_literal] = ACTIONS(5455),
    [anon_sym_SQUOTE] = ACTIONS(5453),
    [anon_sym_DQUOTE] = ACTIONS(5453),
    [sym_return] = ACTIONS(5455),
    [sym_next] = ACTIONS(5455),
    [sym_break] = ACTIONS(5455),
    [sym_true] = ACTIONS(5455),
    [sym_false] = ACTIONS(5455),
    [sym_null] = ACTIONS(5455),
    [sym_inf] = ACTIONS(5455),
    [sym_nan] = ACTIONS(5455),
    [anon_sym_NA] = ACTIONS(5455),
    [anon_sym_NA_integer_] = ACTIONS(5455),
    [anon_sym_NA_real_] = ACTIONS(5455),
    [anon_sym_NA_complex_] = ACTIONS(5455),
    [anon_sym_NA_character_] = ACTIONS(5455),
    [sym_dots] = ACTIONS(5455),
    [sym_dot_dot_i] = ACTIONS(5453),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5453),
    [sym__newline] = ACTIONS(5453),
    [sym__raw_string_literal] = ACTIONS(5453),
    [sym__external_open_parenthesis] = ACTIONS(6345),
    [sym__external_close_parenthesis] = ACTIONS(5453),
    [sym__external_open_brace] = ACTIONS(5453),
    [sym__external_open_bracket] = ACTIONS(6347),
    [sym__external_open_bracket2] = ACTIONS(6349),
    [sym__external_close_bracket2] = ACTIONS(5453),
  },
  [1321] = {
    [sym_function_definition] = STATE(2038),
    [sym_if_statement] = STATE(2038),
    [sym_for_statement] = STATE(2038),
    [sym_while_statement] = STATE(2038),
    [sym_repeat_statement] = STATE(2038),
    [sym_braced_expression] = STATE(2038),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_call] = STATE(2038),
    [sym_subset] = STATE(2038),
    [sym_subset2] = STATE(2038),
    [sym__argument] = STATE(4664),
    [sym_argument] = STATE(4659),
    [sym__argument_named] = STATE(4654),
    [sym__argument_unnamed] = STATE(4676),
    [sym__argument_value] = STATE(4677),
    [sym_unary_operator] = STATE(2038),
    [sym_binary_operator] = STATE(2038),
    [sym_extract_operator] = STATE(2038),
    [sym_namespace_operator] = STATE(2038),
    [sym_integer] = STATE(2038),
    [sym_complex] = STATE(2038),
    [sym_float] = STATE(2038),
    [sym__hex_literal] = STATE(2700),
    [sym__float_literal] = STATE(2700),
    [sym_string] = STATE(2597),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym_na] = STATE(2038),
    [sym__expression] = STATE(2038),
    [sym__string_or_identifier] = STATE(5148),
    [sym__open_parenthesis] = STATE(214),
    [sym__open_brace] = STATE(192),
    [sym__close_bracket] = STATE(4723),
    [aux_sym_call_arguments_repeat1] = STATE(2034),
    [sym_identifier] = ACTIONS(6351),
    [anon_sym_BSLASH] = ACTIONS(4754),
    [anon_sym_function] = ACTIONS(4756),
    [anon_sym_if] = ACTIONS(4758),
    [anon_sym_for] = ACTIONS(4760),
    [anon_sym_while] = ACTIONS(4762),
    [anon_sym_repeat] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4766),
    [anon_sym_TILDE] = ACTIONS(4768),
    [anon_sym_BANG] = ACTIONS(6353),
    [anon_sym_PLUS] = ACTIONS(4772),
    [anon_sym_DASH] = ACTIONS(4772),
    [aux_sym__hex_literal_token1] = ACTIONS(4776),
    [sym__number_literal] = ACTIONS(4778),
    [anon_sym_SQUOTE] = ACTIONS(4780),
    [anon_sym_DQUOTE] = ACTIONS(4782),
    [sym_return] = ACTIONS(6355),
    [sym_next] = ACTIONS(6355),
    [sym_break] = ACTIONS(6355),
    [sym_true] = ACTIONS(6355),
    [sym_false] = ACTIONS(6355),
    [sym_null] = ACTIONS(6355),
    [sym_inf] = ACTIONS(6355),
    [sym_nan] = ACTIONS(6355),
    [anon_sym_NA] = ACTIONS(4786),
    [anon_sym_NA_integer_] = ACTIONS(4786),
    [anon_sym_NA_real_] = ACTIONS(4786),
    [anon_sym_NA_complex_] = ACTIONS(4786),
    [anon_sym_NA_character_] = ACTIONS(4786),
    [sym_dots] = ACTIONS(6357),
    [sym_dot_dot_i] = ACTIONS(6359),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6361),
    [sym__newline] = ACTIONS(6363),
    [sym__raw_string_literal] = ACTIONS(4790),
    [sym__external_open_parenthesis] = ACTIONS(4792),
    [sym__external_open_brace] = ACTIONS(4794),
    [sym__external_close_bracket] = ACTIONS(6365),
  },
  [1322] = {
    [sym_function_definition] = STATE(2038),
    [sym_if_statement] = STATE(2038),
    [sym_for_statement] = STATE(2038),
    [sym_while_statement] = STATE(2038),
    [sym_repeat_statement] = STATE(2038),
    [sym_braced_expression] = STATE(2038),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_call] = STATE(2038),
    [sym_subset] = STATE(2038),
    [sym_subset2] = STATE(2038),
    [sym__argument] = STATE(4664),
    [sym_argument] = STATE(4659),
    [sym__argument_named] = STATE(4654),
    [sym__argument_unnamed] = STATE(4676),
    [sym__argument_value] = STATE(4677),
    [sym_unary_operator] = STATE(2038),
    [sym_binary_operator] = STATE(2038),
    [sym_extract_operator] = STATE(2038),
    [sym_namespace_operator] = STATE(2038),
    [sym_integer] = STATE(2038),
    [sym_complex] = STATE(2038),
    [sym_float] = STATE(2038),
    [sym__hex_literal] = STATE(2700),
    [sym__float_literal] = STATE(2700),
    [sym_string] = STATE(2597),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym_na] = STATE(2038),
    [sym__expression] = STATE(2038),
    [sym__string_or_identifier] = STATE(5148),
    [sym__open_parenthesis] = STATE(214),
    [sym__open_brace] = STATE(192),
    [sym__close_bracket] = STATE(2362),
    [aux_sym_call_arguments_repeat1] = STATE(1543),
    [sym_identifier] = ACTIONS(6351),
    [anon_sym_BSLASH] = ACTIONS(4754),
    [anon_sym_function] = ACTIONS(4756),
    [anon_sym_if] = ACTIONS(4758),
    [anon_sym_for] = ACTIONS(4760),
    [anon_sym_while] = ACTIONS(4762),
    [anon_sym_repeat] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4766),
    [anon_sym_TILDE] = ACTIONS(4768),
    [anon_sym_BANG] = ACTIONS(6353),
    [anon_sym_PLUS] = ACTIONS(4772),
    [anon_sym_DASH] = ACTIONS(4772),
    [aux_sym__hex_literal_token1] = ACTIONS(4776),
    [sym__number_literal] = ACTIONS(4778),
    [anon_sym_SQUOTE] = ACTIONS(4780),
    [anon_sym_DQUOTE] = ACTIONS(4782),
    [sym_return] = ACTIONS(6355),
    [sym_next] = ACTIONS(6355),
    [sym_break] = ACTIONS(6355),
    [sym_true] = ACTIONS(6355),
    [sym_false] = ACTIONS(6355),
    [sym_null] = ACTIONS(6355),
    [sym_inf] = ACTIONS(6355),
    [sym_nan] = ACTIONS(6355),
    [anon_sym_NA] = ACTIONS(4786),
    [anon_sym_NA_integer_] = ACTIONS(4786),
    [anon_sym_NA_real_] = ACTIONS(4786),
    [anon_sym_NA_complex_] = ACTIONS(4786),
    [anon_sym_NA_character_] = ACTIONS(4786),
    [sym_dots] = ACTIONS(6357),
    [sym_dot_dot_i] = ACTIONS(6359),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6361),
    [sym__newline] = ACTIONS(6363),
    [sym__raw_string_literal] = ACTIONS(4790),
    [sym__external_open_parenthesis] = ACTIONS(4792),
    [sym__external_open_brace] = ACTIONS(4794),
    [sym__external_close_bracket] = ACTIONS(6367),
  },
  [1323] = {
    [sym_function_definition] = STATE(1940),
    [sym_if_statement] = STATE(1940),
    [sym_for_statement] = STATE(1940),
    [sym_while_statement] = STATE(1940),
    [sym_repeat_statement] = STATE(1940),
    [sym_braced_expression] = STATE(1940),
    [sym_parenthesized_expression] = STATE(1940),
    [sym_call] = STATE(1940),
    [sym_subset] = STATE(1940),
    [sym_subset2] = STATE(1940),
    [sym__argument] = STATE(4665),
    [sym_argument] = STATE(4661),
    [sym__argument_named] = STATE(4669),
    [sym__argument_unnamed] = STATE(4673),
    [sym__argument_value] = STATE(4679),
    [sym_unary_operator] = STATE(1940),
    [sym_binary_operator] = STATE(1940),
    [sym_extract_operator] = STATE(1940),
    [sym_namespace_operator] = STATE(1940),
    [sym_integer] = STATE(1940),
    [sym_complex] = STATE(1940),
    [sym_float] = STATE(1940),
    [sym__hex_literal] = STATE(2656),
    [sym__float_literal] = STATE(2656),
    [sym_string] = STATE(2606),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym_na] = STATE(1940),
    [sym__expression] = STATE(1940),
    [sym__string_or_identifier] = STATE(5141),
    [sym__open_parenthesis] = STATE(218),
    [sym__open_brace] = STATE(185),
    [sym__close_bracket2] = STATE(4715),
    [aux_sym_call_arguments_repeat1] = STATE(1912),
    [sym_identifier] = ACTIONS(6369),
    [anon_sym_BSLASH] = ACTIONS(4644),
    [anon_sym_function] = ACTIONS(4646),
    [anon_sym_if] = ACTIONS(4648),
    [anon_sym_for] = ACTIONS(4650),
    [anon_sym_while] = ACTIONS(4652),
    [anon_sym_repeat] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(6371),
    [anon_sym_PLUS] = ACTIONS(4662),
    [anon_sym_DASH] = ACTIONS(4662),
    [aux_sym__hex_literal_token1] = ACTIONS(4666),
    [sym__number_literal] = ACTIONS(4668),
    [anon_sym_SQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4672),
    [sym_return] = ACTIONS(6373),
    [sym_next] = ACTIONS(6373),
    [sym_break] = ACTIONS(6373),
    [sym_true] = ACTIONS(6373),
    [sym_false] = ACTIONS(6373),
    [sym_null] = ACTIONS(6373),
    [sym_inf] = ACTIONS(6373),
    [sym_nan] = ACTIONS(6373),
    [anon_sym_NA] = ACTIONS(4676),
    [anon_sym_NA_integer_] = ACTIONS(4676),
    [anon_sym_NA_real_] = ACTIONS(4676),
    [anon_sym_NA_complex_] = ACTIONS(4676),
    [anon_sym_NA_character_] = ACTIONS(4676),
    [sym_dots] = ACTIONS(6375),
    [sym_dot_dot_i] = ACTIONS(6377),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6379),
    [sym__newline] = ACTIONS(6381),
    [sym__raw_string_literal] = ACTIONS(4680),
    [sym__external_open_parenthesis] = ACTIONS(4682),
    [sym__external_open_brace] = ACTIONS(4684),
    [sym__external_close_bracket2] = ACTIONS(6383),
  },
  [1324] = {
    [sym_function_definition] = STATE(1940),
    [sym_if_statement] = STATE(1940),
    [sym_for_statement] = STATE(1940),
    [sym_while_statement] = STATE(1940),
    [sym_repeat_statement] = STATE(1940),
    [sym_braced_expression] = STATE(1940),
    [sym_parenthesized_expression] = STATE(1940),
    [sym_call] = STATE(1940),
    [sym_subset] = STATE(1940),
    [sym_subset2] = STATE(1940),
    [sym__argument] = STATE(4665),
    [sym_argument] = STATE(4661),
    [sym__argument_named] = STATE(4669),
    [sym__argument_unnamed] = STATE(4673),
    [sym__argument_value] = STATE(4679),
    [sym_unary_operator] = STATE(1940),
    [sym_binary_operator] = STATE(1940),
    [sym_extract_operator] = STATE(1940),
    [sym_namespace_operator] = STATE(1940),
    [sym_integer] = STATE(1940),
    [sym_complex] = STATE(1940),
    [sym_float] = STATE(1940),
    [sym__hex_literal] = STATE(2656),
    [sym__float_literal] = STATE(2656),
    [sym_string] = STATE(2606),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym_na] = STATE(1940),
    [sym__expression] = STATE(1940),
    [sym__string_or_identifier] = STATE(5141),
    [sym__open_parenthesis] = STATE(218),
    [sym__open_brace] = STATE(185),
    [sym__close_bracket2] = STATE(2955),
    [aux_sym_call_arguments_repeat1] = STATE(1912),
    [sym_identifier] = ACTIONS(6369),
    [anon_sym_BSLASH] = ACTIONS(4644),
    [anon_sym_function] = ACTIONS(4646),
    [anon_sym_if] = ACTIONS(4648),
    [anon_sym_for] = ACTIONS(4650),
    [anon_sym_while] = ACTIONS(4652),
    [anon_sym_repeat] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(6371),
    [anon_sym_PLUS] = ACTIONS(4662),
    [anon_sym_DASH] = ACTIONS(4662),
    [aux_sym__hex_literal_token1] = ACTIONS(4666),
    [sym__number_literal] = ACTIONS(4668),
    [anon_sym_SQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4672),
    [sym_return] = ACTIONS(6373),
    [sym_next] = ACTIONS(6373),
    [sym_break] = ACTIONS(6373),
    [sym_true] = ACTIONS(6373),
    [sym_false] = ACTIONS(6373),
    [sym_null] = ACTIONS(6373),
    [sym_inf] = ACTIONS(6373),
    [sym_nan] = ACTIONS(6373),
    [anon_sym_NA] = ACTIONS(4676),
    [anon_sym_NA_integer_] = ACTIONS(4676),
    [anon_sym_NA_real_] = ACTIONS(4676),
    [anon_sym_NA_complex_] = ACTIONS(4676),
    [anon_sym_NA_character_] = ACTIONS(4676),
    [sym_dots] = ACTIONS(6375),
    [sym_dot_dot_i] = ACTIONS(6377),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6379),
    [sym__newline] = ACTIONS(6381),
    [sym__raw_string_literal] = ACTIONS(4680),
    [sym__external_open_parenthesis] = ACTIONS(4682),
    [sym__external_open_brace] = ACTIONS(4684),
    [sym__external_close_bracket2] = ACTIONS(6385),
  },
  [1325] = {
    [sym_function_definition] = STATE(1931),
    [sym_if_statement] = STATE(1931),
    [sym_for_statement] = STATE(1931),
    [sym_while_statement] = STATE(1931),
    [sym_repeat_statement] = STATE(1931),
    [sym_braced_expression] = STATE(1931),
    [sym_parenthesized_expression] = STATE(1931),
    [sym_call] = STATE(1931),
    [sym_subset] = STATE(1931),
    [sym_subset2] = STATE(1931),
    [sym__argument] = STATE(4656),
    [sym_argument] = STATE(4657),
    [sym__argument_named] = STATE(4658),
    [sym__argument_unnamed] = STATE(4662),
    [sym__argument_value] = STATE(4663),
    [sym_unary_operator] = STATE(1931),
    [sym_binary_operator] = STATE(1931),
    [sym_extract_operator] = STATE(1931),
    [sym_namespace_operator] = STATE(1931),
    [sym_integer] = STATE(1931),
    [sym_complex] = STATE(1931),
    [sym_float] = STATE(1931),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2633),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(1931),
    [sym__expression] = STATE(1931),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__close_parenthesis] = STATE(2363),
    [sym__open_brace] = STATE(154),
    [aux_sym_call_arguments_repeat1] = STATE(1333),
    [sym_identifier] = ACTIONS(6387),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(6389),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3865),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(6391),
    [sym_next] = ACTIONS(6391),
    [sym_break] = ACTIONS(6391),
    [sym_true] = ACTIONS(6391),
    [sym_false] = ACTIONS(6391),
    [sym_null] = ACTIONS(6391),
    [sym_inf] = ACTIONS(6391),
    [sym_nan] = ACTIONS(6391),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(6393),
    [sym_dot_dot_i] = ACTIONS(6395),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6397),
    [sym__newline] = ACTIONS(6399),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(6401),
    [sym__external_open_brace] = ACTIONS(3891),
  },
  [1326] = {
    [sym_function_definition] = STATE(2038),
    [sym_if_statement] = STATE(2038),
    [sym_for_statement] = STATE(2038),
    [sym_while_statement] = STATE(2038),
    [sym_repeat_statement] = STATE(2038),
    [sym_braced_expression] = STATE(2038),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_call] = STATE(2038),
    [sym_subset] = STATE(2038),
    [sym_subset2] = STATE(2038),
    [sym__argument] = STATE(4664),
    [sym_argument] = STATE(4659),
    [sym__argument_named] = STATE(4654),
    [sym__argument_unnamed] = STATE(4676),
    [sym__argument_value] = STATE(4677),
    [sym_unary_operator] = STATE(2038),
    [sym_binary_operator] = STATE(2038),
    [sym_extract_operator] = STATE(2038),
    [sym_namespace_operator] = STATE(2038),
    [sym_integer] = STATE(2038),
    [sym_complex] = STATE(2038),
    [sym_float] = STATE(2038),
    [sym__hex_literal] = STATE(2700),
    [sym__float_literal] = STATE(2700),
    [sym_string] = STATE(2597),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym_na] = STATE(2038),
    [sym__expression] = STATE(2038),
    [sym__string_or_identifier] = STATE(5148),
    [sym__open_parenthesis] = STATE(214),
    [sym__open_brace] = STATE(192),
    [sym__close_bracket] = STATE(2981),
    [aux_sym_call_arguments_repeat1] = STATE(2034),
    [sym_identifier] = ACTIONS(6351),
    [anon_sym_BSLASH] = ACTIONS(4754),
    [anon_sym_function] = ACTIONS(4756),
    [anon_sym_if] = ACTIONS(4758),
    [anon_sym_for] = ACTIONS(4760),
    [anon_sym_while] = ACTIONS(4762),
    [anon_sym_repeat] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4766),
    [anon_sym_TILDE] = ACTIONS(4768),
    [anon_sym_BANG] = ACTIONS(6353),
    [anon_sym_PLUS] = ACTIONS(4772),
    [anon_sym_DASH] = ACTIONS(4772),
    [aux_sym__hex_literal_token1] = ACTIONS(4776),
    [sym__number_literal] = ACTIONS(4778),
    [anon_sym_SQUOTE] = ACTIONS(4780),
    [anon_sym_DQUOTE] = ACTIONS(4782),
    [sym_return] = ACTIONS(6355),
    [sym_next] = ACTIONS(6355),
    [sym_break] = ACTIONS(6355),
    [sym_true] = ACTIONS(6355),
    [sym_false] = ACTIONS(6355),
    [sym_null] = ACTIONS(6355),
    [sym_inf] = ACTIONS(6355),
    [sym_nan] = ACTIONS(6355),
    [anon_sym_NA] = ACTIONS(4786),
    [anon_sym_NA_integer_] = ACTIONS(4786),
    [anon_sym_NA_real_] = ACTIONS(4786),
    [anon_sym_NA_complex_] = ACTIONS(4786),
    [anon_sym_NA_character_] = ACTIONS(4786),
    [sym_dots] = ACTIONS(6357),
    [sym_dot_dot_i] = ACTIONS(6359),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6361),
    [sym__newline] = ACTIONS(6363),
    [sym__raw_string_literal] = ACTIONS(4790),
    [sym__external_open_parenthesis] = ACTIONS(4792),
    [sym__external_open_brace] = ACTIONS(4794),
    [sym__external_close_bracket] = ACTIONS(6403),
  },
  [1327] = {
    [sym_function_definition] = STATE(1940),
    [sym_if_statement] = STATE(1940),
    [sym_for_statement] = STATE(1940),
    [sym_while_statement] = STATE(1940),
    [sym_repeat_statement] = STATE(1940),
    [sym_braced_expression] = STATE(1940),
    [sym_parenthesized_expression] = STATE(1940),
    [sym_call] = STATE(1940),
    [sym_subset] = STATE(1940),
    [sym_subset2] = STATE(1940),
    [sym__argument] = STATE(4665),
    [sym_argument] = STATE(4661),
    [sym__argument_named] = STATE(4669),
    [sym__argument_unnamed] = STATE(4673),
    [sym__argument_value] = STATE(4679),
    [sym_unary_operator] = STATE(1940),
    [sym_binary_operator] = STATE(1940),
    [sym_extract_operator] = STATE(1940),
    [sym_namespace_operator] = STATE(1940),
    [sym_integer] = STATE(1940),
    [sym_complex] = STATE(1940),
    [sym_float] = STATE(1940),
    [sym__hex_literal] = STATE(2656),
    [sym__float_literal] = STATE(2656),
    [sym_string] = STATE(2606),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym_na] = STATE(1940),
    [sym__expression] = STATE(1940),
    [sym__string_or_identifier] = STATE(5141),
    [sym__open_parenthesis] = STATE(218),
    [sym__open_brace] = STATE(185),
    [sym__close_bracket2] = STATE(2326),
    [aux_sym_call_arguments_repeat1] = STATE(1889),
    [sym_identifier] = ACTIONS(6369),
    [anon_sym_BSLASH] = ACTIONS(4644),
    [anon_sym_function] = ACTIONS(4646),
    [anon_sym_if] = ACTIONS(4648),
    [anon_sym_for] = ACTIONS(4650),
    [anon_sym_while] = ACTIONS(4652),
    [anon_sym_repeat] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(6371),
    [anon_sym_PLUS] = ACTIONS(4662),
    [anon_sym_DASH] = ACTIONS(4662),
    [aux_sym__hex_literal_token1] = ACTIONS(4666),
    [sym__number_literal] = ACTIONS(4668),
    [anon_sym_SQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4672),
    [sym_return] = ACTIONS(6373),
    [sym_next] = ACTIONS(6373),
    [sym_break] = ACTIONS(6373),
    [sym_true] = ACTIONS(6373),
    [sym_false] = ACTIONS(6373),
    [sym_null] = ACTIONS(6373),
    [sym_inf] = ACTIONS(6373),
    [sym_nan] = ACTIONS(6373),
    [anon_sym_NA] = ACTIONS(4676),
    [anon_sym_NA_integer_] = ACTIONS(4676),
    [anon_sym_NA_real_] = ACTIONS(4676),
    [anon_sym_NA_complex_] = ACTIONS(4676),
    [anon_sym_NA_character_] = ACTIONS(4676),
    [sym_dots] = ACTIONS(6375),
    [sym_dot_dot_i] = ACTIONS(6377),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6379),
    [sym__newline] = ACTIONS(6381),
    [sym__raw_string_literal] = ACTIONS(4680),
    [sym__external_open_parenthesis] = ACTIONS(4682),
    [sym__external_open_brace] = ACTIONS(4684),
    [sym__external_close_bracket2] = ACTIONS(6405),
  },
  [1328] = {
    [sym_function_definition] = STATE(2038),
    [sym_if_statement] = STATE(2038),
    [sym_for_statement] = STATE(2038),
    [sym_while_statement] = STATE(2038),
    [sym_repeat_statement] = STATE(2038),
    [sym_braced_expression] = STATE(2038),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_call] = STATE(2038),
    [sym_subset] = STATE(2038),
    [sym_subset2] = STATE(2038),
    [sym__argument] = STATE(4664),
    [sym_argument] = STATE(4659),
    [sym__argument_named] = STATE(4654),
    [sym__argument_unnamed] = STATE(4676),
    [sym__argument_value] = STATE(4677),
    [sym_unary_operator] = STATE(2038),
    [sym_binary_operator] = STATE(2038),
    [sym_extract_operator] = STATE(2038),
    [sym_namespace_operator] = STATE(2038),
    [sym_integer] = STATE(2038),
    [sym_complex] = STATE(2038),
    [sym_float] = STATE(2038),
    [sym__hex_literal] = STATE(2700),
    [sym__float_literal] = STATE(2700),
    [sym_string] = STATE(2597),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym_na] = STATE(2038),
    [sym__expression] = STATE(2038),
    [sym__string_or_identifier] = STATE(5148),
    [sym__open_parenthesis] = STATE(214),
    [sym__open_brace] = STATE(192),
    [sym__close_bracket] = STATE(2325),
    [aux_sym_call_arguments_repeat1] = STATE(1891),
    [sym_identifier] = ACTIONS(6351),
    [anon_sym_BSLASH] = ACTIONS(4754),
    [anon_sym_function] = ACTIONS(4756),
    [anon_sym_if] = ACTIONS(4758),
    [anon_sym_for] = ACTIONS(4760),
    [anon_sym_while] = ACTIONS(4762),
    [anon_sym_repeat] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4766),
    [anon_sym_TILDE] = ACTIONS(4768),
    [anon_sym_BANG] = ACTIONS(6353),
    [anon_sym_PLUS] = ACTIONS(4772),
    [anon_sym_DASH] = ACTIONS(4772),
    [aux_sym__hex_literal_token1] = ACTIONS(4776),
    [sym__number_literal] = ACTIONS(4778),
    [anon_sym_SQUOTE] = ACTIONS(4780),
    [anon_sym_DQUOTE] = ACTIONS(4782),
    [sym_return] = ACTIONS(6355),
    [sym_next] = ACTIONS(6355),
    [sym_break] = ACTIONS(6355),
    [sym_true] = ACTIONS(6355),
    [sym_false] = ACTIONS(6355),
    [sym_null] = ACTIONS(6355),
    [sym_inf] = ACTIONS(6355),
    [sym_nan] = ACTIONS(6355),
    [anon_sym_NA] = ACTIONS(4786),
    [anon_sym_NA_integer_] = ACTIONS(4786),
    [anon_sym_NA_real_] = ACTIONS(4786),
    [anon_sym_NA_complex_] = ACTIONS(4786),
    [anon_sym_NA_character_] = ACTIONS(4786),
    [sym_dots] = ACTIONS(6357),
    [sym_dot_dot_i] = ACTIONS(6359),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6361),
    [sym__newline] = ACTIONS(6363),
    [sym__raw_string_literal] = ACTIONS(4790),
    [sym__external_open_parenthesis] = ACTIONS(4792),
    [sym__external_open_brace] = ACTIONS(4794),
    [sym__external_close_bracket] = ACTIONS(6407),
  },
  [1329] = {
    [sym_function_definition] = STATE(1931),
    [sym_if_statement] = STATE(1931),
    [sym_for_statement] = STATE(1931),
    [sym_while_statement] = STATE(1931),
    [sym_repeat_statement] = STATE(1931),
    [sym_braced_expression] = STATE(1931),
    [sym_parenthesized_expression] = STATE(1931),
    [sym_call] = STATE(1931),
    [sym_subset] = STATE(1931),
    [sym_subset2] = STATE(1931),
    [sym__argument] = STATE(4656),
    [sym_argument] = STATE(4657),
    [sym__argument_named] = STATE(4658),
    [sym__argument_unnamed] = STATE(4662),
    [sym__argument_value] = STATE(4663),
    [sym_unary_operator] = STATE(1931),
    [sym_binary_operator] = STATE(1931),
    [sym_extract_operator] = STATE(1931),
    [sym_namespace_operator] = STATE(1931),
    [sym_integer] = STATE(1931),
    [sym_complex] = STATE(1931),
    [sym_float] = STATE(1931),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2633),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(1931),
    [sym__expression] = STATE(1931),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__close_parenthesis] = STATE(2324),
    [sym__open_brace] = STATE(154),
    [aux_sym_call_arguments_repeat1] = STATE(1342),
    [sym_identifier] = ACTIONS(6387),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(6389),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3865),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(6391),
    [sym_next] = ACTIONS(6391),
    [sym_break] = ACTIONS(6391),
    [sym_true] = ACTIONS(6391),
    [sym_false] = ACTIONS(6391),
    [sym_null] = ACTIONS(6391),
    [sym_inf] = ACTIONS(6391),
    [sym_nan] = ACTIONS(6391),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(6393),
    [sym_dot_dot_i] = ACTIONS(6395),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6397),
    [sym__newline] = ACTIONS(6399),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(6409),
    [sym__external_open_brace] = ACTIONS(3891),
  },
  [1330] = {
    [sym_function_definition] = STATE(1940),
    [sym_if_statement] = STATE(1940),
    [sym_for_statement] = STATE(1940),
    [sym_while_statement] = STATE(1940),
    [sym_repeat_statement] = STATE(1940),
    [sym_braced_expression] = STATE(1940),
    [sym_parenthesized_expression] = STATE(1940),
    [sym_call] = STATE(1940),
    [sym_subset] = STATE(1940),
    [sym_subset2] = STATE(1940),
    [sym__argument] = STATE(4665),
    [sym_argument] = STATE(4661),
    [sym__argument_named] = STATE(4669),
    [sym__argument_unnamed] = STATE(4673),
    [sym__argument_value] = STATE(4679),
    [sym_unary_operator] = STATE(1940),
    [sym_binary_operator] = STATE(1940),
    [sym_extract_operator] = STATE(1940),
    [sym_namespace_operator] = STATE(1940),
    [sym_integer] = STATE(1940),
    [sym_complex] = STATE(1940),
    [sym_float] = STATE(1940),
    [sym__hex_literal] = STATE(2656),
    [sym__float_literal] = STATE(2656),
    [sym_string] = STATE(2606),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym_na] = STATE(1940),
    [sym__expression] = STATE(1940),
    [sym__string_or_identifier] = STATE(5141),
    [sym__open_parenthesis] = STATE(218),
    [sym__open_brace] = STATE(185),
    [sym__close_bracket2] = STATE(2519),
    [aux_sym_call_arguments_repeat1] = STATE(1906),
    [sym_identifier] = ACTIONS(6369),
    [anon_sym_BSLASH] = ACTIONS(4644),
    [anon_sym_function] = ACTIONS(4646),
    [anon_sym_if] = ACTIONS(4648),
    [anon_sym_for] = ACTIONS(4650),
    [anon_sym_while] = ACTIONS(4652),
    [anon_sym_repeat] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(6371),
    [anon_sym_PLUS] = ACTIONS(4662),
    [anon_sym_DASH] = ACTIONS(4662),
    [aux_sym__hex_literal_token1] = ACTIONS(4666),
    [sym__number_literal] = ACTIONS(4668),
    [anon_sym_SQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4672),
    [sym_return] = ACTIONS(6373),
    [sym_next] = ACTIONS(6373),
    [sym_break] = ACTIONS(6373),
    [sym_true] = ACTIONS(6373),
    [sym_false] = ACTIONS(6373),
    [sym_null] = ACTIONS(6373),
    [sym_inf] = ACTIONS(6373),
    [sym_nan] = ACTIONS(6373),
    [anon_sym_NA] = ACTIONS(4676),
    [anon_sym_NA_integer_] = ACTIONS(4676),
    [anon_sym_NA_real_] = ACTIONS(4676),
    [anon_sym_NA_complex_] = ACTIONS(4676),
    [anon_sym_NA_character_] = ACTIONS(4676),
    [sym_dots] = ACTIONS(6375),
    [sym_dot_dot_i] = ACTIONS(6377),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6379),
    [sym__newline] = ACTIONS(6381),
    [sym__raw_string_literal] = ACTIONS(4680),
    [sym__external_open_parenthesis] = ACTIONS(4682),
    [sym__external_open_brace] = ACTIONS(4684),
    [sym__external_close_bracket2] = ACTIONS(6411),
  },
  [1331] = {
    [sym_function_definition] = STATE(2038),
    [sym_if_statement] = STATE(2038),
    [sym_for_statement] = STATE(2038),
    [sym_while_statement] = STATE(2038),
    [sym_repeat_statement] = STATE(2038),
    [sym_braced_expression] = STATE(2038),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_call] = STATE(2038),
    [sym_subset] = STATE(2038),
    [sym_subset2] = STATE(2038),
    [sym__argument] = STATE(4664),
    [sym_argument] = STATE(4659),
    [sym__argument_named] = STATE(4654),
    [sym__argument_unnamed] = STATE(4676),
    [sym__argument_value] = STATE(4677),
    [sym_unary_operator] = STATE(2038),
    [sym_binary_operator] = STATE(2038),
    [sym_extract_operator] = STATE(2038),
    [sym_namespace_operator] = STATE(2038),
    [sym_integer] = STATE(2038),
    [sym_complex] = STATE(2038),
    [sym_float] = STATE(2038),
    [sym__hex_literal] = STATE(2700),
    [sym__float_literal] = STATE(2700),
    [sym_string] = STATE(2597),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym_na] = STATE(2038),
    [sym__expression] = STATE(2038),
    [sym__string_or_identifier] = STATE(5148),
    [sym__open_parenthesis] = STATE(214),
    [sym__open_brace] = STATE(192),
    [sym__close_bracket] = STATE(2524),
    [aux_sym_call_arguments_repeat1] = STATE(1908),
    [sym_identifier] = ACTIONS(6351),
    [anon_sym_BSLASH] = ACTIONS(4754),
    [anon_sym_function] = ACTIONS(4756),
    [anon_sym_if] = ACTIONS(4758),
    [anon_sym_for] = ACTIONS(4760),
    [anon_sym_while] = ACTIONS(4762),
    [anon_sym_repeat] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4766),
    [anon_sym_TILDE] = ACTIONS(4768),
    [anon_sym_BANG] = ACTIONS(6353),
    [anon_sym_PLUS] = ACTIONS(4772),
    [anon_sym_DASH] = ACTIONS(4772),
    [aux_sym__hex_literal_token1] = ACTIONS(4776),
    [sym__number_literal] = ACTIONS(4778),
    [anon_sym_SQUOTE] = ACTIONS(4780),
    [anon_sym_DQUOTE] = ACTIONS(4782),
    [sym_return] = ACTIONS(6355),
    [sym_next] = ACTIONS(6355),
    [sym_break] = ACTIONS(6355),
    [sym_true] = ACTIONS(6355),
    [sym_false] = ACTIONS(6355),
    [sym_null] = ACTIONS(6355),
    [sym_inf] = ACTIONS(6355),
    [sym_nan] = ACTIONS(6355),
    [anon_sym_NA] = ACTIONS(4786),
    [anon_sym_NA_integer_] = ACTIONS(4786),
    [anon_sym_NA_real_] = ACTIONS(4786),
    [anon_sym_NA_complex_] = ACTIONS(4786),
    [anon_sym_NA_character_] = ACTIONS(4786),
    [sym_dots] = ACTIONS(6357),
    [sym_dot_dot_i] = ACTIONS(6359),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6361),
    [sym__newline] = ACTIONS(6363),
    [sym__raw_string_literal] = ACTIONS(4790),
    [sym__external_open_parenthesis] = ACTIONS(4792),
    [sym__external_open_brace] = ACTIONS(4794),
    [sym__external_close_bracket] = ACTIONS(6413),
  },
  [1332] = {
    [sym_function_definition] = STATE(1931),
    [sym_if_statement] = STATE(1931),
    [sym_for_statement] = STATE(1931),
    [sym_while_statement] = STATE(1931),
    [sym_repeat_statement] = STATE(1931),
    [sym_braced_expression] = STATE(1931),
    [sym_parenthesized_expression] = STATE(1931),
    [sym_call] = STATE(1931),
    [sym_subset] = STATE(1931),
    [sym_subset2] = STATE(1931),
    [sym__argument] = STATE(4656),
    [sym_argument] = STATE(4657),
    [sym__argument_named] = STATE(4658),
    [sym__argument_unnamed] = STATE(4662),
    [sym__argument_value] = STATE(4663),
    [sym_unary_operator] = STATE(1931),
    [sym_binary_operator] = STATE(1931),
    [sym_extract_operator] = STATE(1931),
    [sym_namespace_operator] = STATE(1931),
    [sym_integer] = STATE(1931),
    [sym_complex] = STATE(1931),
    [sym_float] = STATE(1931),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2633),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(1931),
    [sym__expression] = STATE(1931),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__close_parenthesis] = STATE(2525),
    [sym__open_brace] = STATE(154),
    [aux_sym_call_arguments_repeat1] = STATE(1351),
    [sym_identifier] = ACTIONS(6387),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(6389),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3865),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(6391),
    [sym_next] = ACTIONS(6391),
    [sym_break] = ACTIONS(6391),
    [sym_true] = ACTIONS(6391),
    [sym_false] = ACTIONS(6391),
    [sym_null] = ACTIONS(6391),
    [sym_inf] = ACTIONS(6391),
    [sym_nan] = ACTIONS(6391),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(6393),
    [sym_dot_dot_i] = ACTIONS(6395),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6397),
    [sym__newline] = ACTIONS(6399),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(6415),
    [sym__external_open_brace] = ACTIONS(3891),
  },
  [1333] = {
    [sym_function_definition] = STATE(1931),
    [sym_if_statement] = STATE(1931),
    [sym_for_statement] = STATE(1931),
    [sym_while_statement] = STATE(1931),
    [sym_repeat_statement] = STATE(1931),
    [sym_braced_expression] = STATE(1931),
    [sym_parenthesized_expression] = STATE(1931),
    [sym_call] = STATE(1931),
    [sym_subset] = STATE(1931),
    [sym_subset2] = STATE(1931),
    [sym__argument] = STATE(4656),
    [sym_argument] = STATE(4657),
    [sym__argument_named] = STATE(4658),
    [sym__argument_unnamed] = STATE(4662),
    [sym__argument_value] = STATE(4663),
    [sym_unary_operator] = STATE(1931),
    [sym_binary_operator] = STATE(1931),
    [sym_extract_operator] = STATE(1931),
    [sym_namespace_operator] = STATE(1931),
    [sym_integer] = STATE(1931),
    [sym_complex] = STATE(1931),
    [sym_float] = STATE(1931),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2633),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(1931),
    [sym__expression] = STATE(1931),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__close_parenthesis] = STATE(2351),
    [sym__open_brace] = STATE(154),
    [aux_sym_call_arguments_repeat1] = STATE(2113),
    [sym_identifier] = ACTIONS(6387),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(6389),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3865),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(6391),
    [sym_next] = ACTIONS(6391),
    [sym_break] = ACTIONS(6391),
    [sym_true] = ACTIONS(6391),
    [sym_false] = ACTIONS(6391),
    [sym_null] = ACTIONS(6391),
    [sym_inf] = ACTIONS(6391),
    [sym_nan] = ACTIONS(6391),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(6393),
    [sym_dot_dot_i] = ACTIONS(6395),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6397),
    [sym__newline] = ACTIONS(6399),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(6417),
    [sym__external_open_brace] = ACTIONS(3891),
  },
  [1334] = {
    [sym_function_definition] = STATE(1940),
    [sym_if_statement] = STATE(1940),
    [sym_for_statement] = STATE(1940),
    [sym_while_statement] = STATE(1940),
    [sym_repeat_statement] = STATE(1940),
    [sym_braced_expression] = STATE(1940),
    [sym_parenthesized_expression] = STATE(1940),
    [sym_call] = STATE(1940),
    [sym_subset] = STATE(1940),
    [sym_subset2] = STATE(1940),
    [sym__argument] = STATE(4665),
    [sym_argument] = STATE(4661),
    [sym__argument_named] = STATE(4669),
    [sym__argument_unnamed] = STATE(4673),
    [sym__argument_value] = STATE(4679),
    [sym_unary_operator] = STATE(1940),
    [sym_binary_operator] = STATE(1940),
    [sym_extract_operator] = STATE(1940),
    [sym_namespace_operator] = STATE(1940),
    [sym_integer] = STATE(1940),
    [sym_complex] = STATE(1940),
    [sym_float] = STATE(1940),
    [sym__hex_literal] = STATE(2656),
    [sym__float_literal] = STATE(2656),
    [sym_string] = STATE(2606),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym_na] = STATE(1940),
    [sym__expression] = STATE(1940),
    [sym__string_or_identifier] = STATE(5141),
    [sym__open_parenthesis] = STATE(218),
    [sym__open_brace] = STATE(185),
    [sym__close_bracket2] = STATE(2624),
    [aux_sym_call_arguments_repeat1] = STATE(1585),
    [sym_identifier] = ACTIONS(6369),
    [anon_sym_BSLASH] = ACTIONS(4644),
    [anon_sym_function] = ACTIONS(4646),
    [anon_sym_if] = ACTIONS(4648),
    [anon_sym_for] = ACTIONS(4650),
    [anon_sym_while] = ACTIONS(4652),
    [anon_sym_repeat] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(6371),
    [anon_sym_PLUS] = ACTIONS(4662),
    [anon_sym_DASH] = ACTIONS(4662),
    [aux_sym__hex_literal_token1] = ACTIONS(4666),
    [sym__number_literal] = ACTIONS(4668),
    [anon_sym_SQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4672),
    [sym_return] = ACTIONS(6373),
    [sym_next] = ACTIONS(6373),
    [sym_break] = ACTIONS(6373),
    [sym_true] = ACTIONS(6373),
    [sym_false] = ACTIONS(6373),
    [sym_null] = ACTIONS(6373),
    [sym_inf] = ACTIONS(6373),
    [sym_nan] = ACTIONS(6373),
    [anon_sym_NA] = ACTIONS(4676),
    [anon_sym_NA_integer_] = ACTIONS(4676),
    [anon_sym_NA_real_] = ACTIONS(4676),
    [anon_sym_NA_complex_] = ACTIONS(4676),
    [anon_sym_NA_character_] = ACTIONS(4676),
    [sym_dots] = ACTIONS(6375),
    [sym_dot_dot_i] = ACTIONS(6377),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6379),
    [sym__newline] = ACTIONS(6381),
    [sym__raw_string_literal] = ACTIONS(4680),
    [sym__external_open_parenthesis] = ACTIONS(4682),
    [sym__external_open_brace] = ACTIONS(4684),
    [sym__external_close_bracket2] = ACTIONS(6419),
  },
  [1335] = {
    [sym_function_definition] = STATE(2038),
    [sym_if_statement] = STATE(2038),
    [sym_for_statement] = STATE(2038),
    [sym_while_statement] = STATE(2038),
    [sym_repeat_statement] = STATE(2038),
    [sym_braced_expression] = STATE(2038),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_call] = STATE(2038),
    [sym_subset] = STATE(2038),
    [sym_subset2] = STATE(2038),
    [sym__argument] = STATE(4664),
    [sym_argument] = STATE(4659),
    [sym__argument_named] = STATE(4654),
    [sym__argument_unnamed] = STATE(4676),
    [sym__argument_value] = STATE(4677),
    [sym_unary_operator] = STATE(2038),
    [sym_binary_operator] = STATE(2038),
    [sym_extract_operator] = STATE(2038),
    [sym_namespace_operator] = STATE(2038),
    [sym_integer] = STATE(2038),
    [sym_complex] = STATE(2038),
    [sym_float] = STATE(2038),
    [sym__hex_literal] = STATE(2700),
    [sym__float_literal] = STATE(2700),
    [sym_string] = STATE(2597),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym_na] = STATE(2038),
    [sym__expression] = STATE(2038),
    [sym__string_or_identifier] = STATE(5148),
    [sym__open_parenthesis] = STATE(214),
    [sym__open_brace] = STATE(192),
    [sym__close_bracket] = STATE(2626),
    [aux_sym_call_arguments_repeat1] = STATE(1583),
    [sym_identifier] = ACTIONS(6351),
    [anon_sym_BSLASH] = ACTIONS(4754),
    [anon_sym_function] = ACTIONS(4756),
    [anon_sym_if] = ACTIONS(4758),
    [anon_sym_for] = ACTIONS(4760),
    [anon_sym_while] = ACTIONS(4762),
    [anon_sym_repeat] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4766),
    [anon_sym_TILDE] = ACTIONS(4768),
    [anon_sym_BANG] = ACTIONS(6353),
    [anon_sym_PLUS] = ACTIONS(4772),
    [anon_sym_DASH] = ACTIONS(4772),
    [aux_sym__hex_literal_token1] = ACTIONS(4776),
    [sym__number_literal] = ACTIONS(4778),
    [anon_sym_SQUOTE] = ACTIONS(4780),
    [anon_sym_DQUOTE] = ACTIONS(4782),
    [sym_return] = ACTIONS(6355),
    [sym_next] = ACTIONS(6355),
    [sym_break] = ACTIONS(6355),
    [sym_true] = ACTIONS(6355),
    [sym_false] = ACTIONS(6355),
    [sym_null] = ACTIONS(6355),
    [sym_inf] = ACTIONS(6355),
    [sym_nan] = ACTIONS(6355),
    [anon_sym_NA] = ACTIONS(4786),
    [anon_sym_NA_integer_] = ACTIONS(4786),
    [anon_sym_NA_real_] = ACTIONS(4786),
    [anon_sym_NA_complex_] = ACTIONS(4786),
    [anon_sym_NA_character_] = ACTIONS(4786),
    [sym_dots] = ACTIONS(6357),
    [sym_dot_dot_i] = ACTIONS(6359),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6361),
    [sym__newline] = ACTIONS(6363),
    [sym__raw_string_literal] = ACTIONS(4790),
    [sym__external_open_parenthesis] = ACTIONS(4792),
    [sym__external_open_brace] = ACTIONS(4794),
    [sym__external_close_bracket] = ACTIONS(6421),
  },
  [1336] = {
    [sym_string] = STATE(2455),
    [sym__single_quoted_string] = STATE(2200),
    [sym__double_quoted_string] = STATE(2201),
    [sym__string_or_identifier] = STATE(2455),
    [sym_identifier] = ACTIONS(6423),
    [anon_sym_BSLASH] = ACTIONS(5883),
    [anon_sym_function] = ACTIONS(5887),
    [anon_sym_EQ] = ACTIONS(5887),
    [anon_sym_if] = ACTIONS(5887),
    [anon_sym_for] = ACTIONS(5887),
    [anon_sym_while] = ACTIONS(5887),
    [anon_sym_repeat] = ACTIONS(5887),
    [anon_sym_QMARK] = ACTIONS(5883),
    [anon_sym_TILDE] = ACTIONS(5883),
    [anon_sym_BANG] = ACTIONS(5887),
    [anon_sym_PLUS] = ACTIONS(5883),
    [anon_sym_DASH] = ACTIONS(5887),
    [anon_sym_LT_DASH] = ACTIONS(5883),
    [anon_sym_LT_LT_DASH] = ACTIONS(5883),
    [anon_sym_COLON_EQ] = ACTIONS(5883),
    [anon_sym_DASH_GT] = ACTIONS(5887),
    [anon_sym_DASH_GT_GT] = ACTIONS(5883),
    [anon_sym_PIPE] = ACTIONS(5887),
    [anon_sym_AMP] = ACTIONS(5887),
    [anon_sym_PIPE_PIPE] = ACTIONS(5883),
    [anon_sym_AMP_AMP] = ACTIONS(5883),
    [anon_sym_LT] = ACTIONS(5887),
    [anon_sym_LT_EQ] = ACTIONS(5883),
    [anon_sym_GT] = ACTIONS(5887),
    [anon_sym_GT_EQ] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5883),
    [anon_sym_BANG_EQ] = ACTIONS(5883),
    [anon_sym_STAR] = ACTIONS(5887),
    [anon_sym_SLASH] = ACTIONS(5883),
    [anon_sym_STAR_STAR] = ACTIONS(5883),
    [anon_sym_CARET] = ACTIONS(5883),
    [aux_sym_binary_operator_token1] = ACTIONS(5883),
    [anon_sym_PIPE_GT] = ACTIONS(5883),
    [anon_sym_COLON] = ACTIONS(5887),
    [anon_sym_DOLLAR] = ACTIONS(5883),
    [anon_sym_AT] = ACTIONS(5883),
    [aux_sym__hex_literal_token1] = ACTIONS(5883),
    [sym__number_literal] = ACTIONS(5887),
    [anon_sym_SQUOTE] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(511),
    [sym_return] = ACTIONS(5887),
    [sym_next] = ACTIONS(5887),
    [sym_break] = ACTIONS(5887),
    [sym_true] = ACTIONS(5887),
    [sym_false] = ACTIONS(5887),
    [sym_null] = ACTIONS(5887),
    [sym_inf] = ACTIONS(5887),
    [sym_nan] = ACTIONS(5887),
    [anon_sym_NA] = ACTIONS(5887),
    [anon_sym_NA_integer_] = ACTIONS(5887),
    [anon_sym_NA_real_] = ACTIONS(5887),
    [anon_sym_NA_complex_] = ACTIONS(5887),
    [anon_sym_NA_character_] = ACTIONS(5887),
    [sym_dots] = ACTIONS(5887),
    [sym_dot_dot_i] = ACTIONS(5883),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5883),
    [sym__newline] = ACTIONS(5883),
    [sym__semicolon] = ACTIONS(5883),
    [sym__raw_string_literal] = ACTIONS(521),
    [sym__external_else] = ACTIONS(5883),
    [sym__external_open_parenthesis] = ACTIONS(5883),
    [sym__external_open_brace] = ACTIONS(5883),
    [sym__external_close_brace] = ACTIONS(5883),
    [sym__external_open_bracket] = ACTIONS(5883),
    [sym__external_close_bracket] = ACTIONS(5883),
    [sym__external_open_bracket2] = ACTIONS(5883),
  },
  [1337] = {
    [sym_call_arguments] = STATE(2840),
    [sym_subset_arguments] = STATE(2797),
    [sym_subset2_arguments] = STATE(2801),
    [sym__open_parenthesis] = STATE(1344),
    [sym__open_bracket] = STATE(1374),
    [sym__open_bracket2] = STATE(1452),
    [ts_builtin_sym_end] = ACTIONS(5337),
    [sym_identifier] = ACTIONS(5339),
    [anon_sym_BSLASH] = ACTIONS(5337),
    [anon_sym_function] = ACTIONS(5339),
    [anon_sym_EQ] = ACTIONS(6263),
    [anon_sym_if] = ACTIONS(5339),
    [anon_sym_for] = ACTIONS(5339),
    [anon_sym_while] = ACTIONS(5339),
    [anon_sym_repeat] = ACTIONS(5339),
    [anon_sym_QMARK] = ACTIONS(5337),
    [anon_sym_TILDE] = ACTIONS(6265),
    [anon_sym_BANG] = ACTIONS(5339),
    [anon_sym_PLUS] = ACTIONS(6267),
    [anon_sym_DASH] = ACTIONS(6269),
    [anon_sym_LT_DASH] = ACTIONS(6271),
    [anon_sym_LT_LT_DASH] = ACTIONS(6271),
    [anon_sym_COLON_EQ] = ACTIONS(6271),
    [anon_sym_DASH_GT] = ACTIONS(6273),
    [anon_sym_DASH_GT_GT] = ACTIONS(6275),
    [anon_sym_PIPE] = ACTIONS(6277),
    [anon_sym_AMP] = ACTIONS(6279),
    [anon_sym_PIPE_PIPE] = ACTIONS(6281),
    [anon_sym_AMP_AMP] = ACTIONS(6283),
    [anon_sym_LT] = ACTIONS(6285),
    [anon_sym_LT_EQ] = ACTIONS(6287),
    [anon_sym_GT] = ACTIONS(6285),
    [anon_sym_GT_EQ] = ACTIONS(6287),
    [anon_sym_EQ_EQ] = ACTIONS(6287),
    [anon_sym_BANG_EQ] = ACTIONS(6287),
    [anon_sym_STAR] = ACTIONS(6289),
    [anon_sym_SLASH] = ACTIONS(6291),
    [anon_sym_STAR_STAR] = ACTIONS(6293),
    [anon_sym_CARET] = ACTIONS(6293),
    [aux_sym_binary_operator_token1] = ACTIONS(6295),
    [anon_sym_PIPE_GT] = ACTIONS(6295),
    [anon_sym_COLON] = ACTIONS(6297),
    [anon_sym_DOLLAR] = ACTIONS(6299),
    [anon_sym_AT] = ACTIONS(6299),
    [aux_sym__hex_literal_token1] = ACTIONS(5337),
    [sym__number_literal] = ACTIONS(5339),
    [anon_sym_SQUOTE] = ACTIONS(5337),
    [anon_sym_DQUOTE] = ACTIONS(5337),
    [sym_return] = ACTIONS(5339),
    [sym_next] = ACTIONS(5339),
    [sym_break] = ACTIONS(5339),
    [sym_true] = ACTIONS(5339),
    [sym_false] = ACTIONS(5339),
    [sym_null] = ACTIONS(5339),
    [sym_inf] = ACTIONS(5339),
    [sym_nan] = ACTIONS(5339),
    [anon_sym_NA] = ACTIONS(5339),
    [anon_sym_NA_integer_] = ACTIONS(5339),
    [anon_sym_NA_real_] = ACTIONS(5339),
    [anon_sym_NA_complex_] = ACTIONS(5339),
    [anon_sym_NA_character_] = ACTIONS(5339),
    [sym_dots] = ACTIONS(5339),
    [sym_dot_dot_i] = ACTIONS(5337),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5337),
    [sym__semicolon] = ACTIONS(5337),
    [sym__raw_string_literal] = ACTIONS(5337),
    [sym__external_open_parenthesis] = ACTIONS(6301),
    [sym__external_open_brace] = ACTIONS(5337),
    [sym__external_close_brace] = ACTIONS(5337),
    [sym__external_open_bracket] = ACTIONS(6303),
    [sym__external_open_bracket2] = ACTIONS(6305),
  },
  [1338] = {
    [sym_string] = STATE(2506),
    [sym__single_quoted_string] = STATE(2221),
    [sym__double_quoted_string] = STATE(2222),
    [sym__string_or_identifier] = STATE(2506),
    [sym_identifier] = ACTIONS(6425),
    [anon_sym_BSLASH] = ACTIONS(5883),
    [anon_sym_function] = ACTIONS(5887),
    [anon_sym_EQ] = ACTIONS(5887),
    [anon_sym_if] = ACTIONS(5887),
    [anon_sym_for] = ACTIONS(5887),
    [anon_sym_while] = ACTIONS(5887),
    [anon_sym_repeat] = ACTIONS(5887),
    [anon_sym_QMARK] = ACTIONS(5883),
    [anon_sym_TILDE] = ACTIONS(5883),
    [anon_sym_BANG] = ACTIONS(5887),
    [anon_sym_PLUS] = ACTIONS(5883),
    [anon_sym_DASH] = ACTIONS(5887),
    [anon_sym_LT_DASH] = ACTIONS(5883),
    [anon_sym_LT_LT_DASH] = ACTIONS(5883),
    [anon_sym_COLON_EQ] = ACTIONS(5883),
    [anon_sym_DASH_GT] = ACTIONS(5887),
    [anon_sym_DASH_GT_GT] = ACTIONS(5883),
    [anon_sym_PIPE] = ACTIONS(5887),
    [anon_sym_AMP] = ACTIONS(5887),
    [anon_sym_PIPE_PIPE] = ACTIONS(5883),
    [anon_sym_AMP_AMP] = ACTIONS(5883),
    [anon_sym_LT] = ACTIONS(5887),
    [anon_sym_LT_EQ] = ACTIONS(5883),
    [anon_sym_GT] = ACTIONS(5887),
    [anon_sym_GT_EQ] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5883),
    [anon_sym_BANG_EQ] = ACTIONS(5883),
    [anon_sym_STAR] = ACTIONS(5887),
    [anon_sym_SLASH] = ACTIONS(5883),
    [anon_sym_STAR_STAR] = ACTIONS(5883),
    [anon_sym_CARET] = ACTIONS(5883),
    [aux_sym_binary_operator_token1] = ACTIONS(5883),
    [anon_sym_PIPE_GT] = ACTIONS(5883),
    [anon_sym_COLON] = ACTIONS(5887),
    [anon_sym_DOLLAR] = ACTIONS(5883),
    [anon_sym_AT] = ACTIONS(5883),
    [aux_sym__hex_literal_token1] = ACTIONS(5883),
    [sym__number_literal] = ACTIONS(5887),
    [anon_sym_SQUOTE] = ACTIONS(654),
    [anon_sym_DQUOTE] = ACTIONS(656),
    [sym_return] = ACTIONS(5887),
    [sym_next] = ACTIONS(5887),
    [sym_break] = ACTIONS(5887),
    [sym_true] = ACTIONS(5887),
    [sym_false] = ACTIONS(5887),
    [sym_null] = ACTIONS(5887),
    [sym_inf] = ACTIONS(5887),
    [sym_nan] = ACTIONS(5887),
    [anon_sym_NA] = ACTIONS(5887),
    [anon_sym_NA_integer_] = ACTIONS(5887),
    [anon_sym_NA_real_] = ACTIONS(5887),
    [anon_sym_NA_complex_] = ACTIONS(5887),
    [anon_sym_NA_character_] = ACTIONS(5887),
    [sym_dots] = ACTIONS(5887),
    [sym_dot_dot_i] = ACTIONS(5883),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5883),
    [sym__newline] = ACTIONS(5883),
    [sym__semicolon] = ACTIONS(5883),
    [sym__raw_string_literal] = ACTIONS(666),
    [sym__external_open_parenthesis] = ACTIONS(5883),
    [sym__external_close_parenthesis] = ACTIONS(5883),
    [sym__external_open_brace] = ACTIONS(5883),
    [sym__external_close_brace] = ACTIONS(5883),
    [sym__external_open_bracket] = ACTIONS(5883),
    [sym__external_open_bracket2] = ACTIONS(5883),
    [sym__external_close_bracket2] = ACTIONS(5883),
  },
  [1339] = {
    [sym_function_definition] = STATE(1931),
    [sym_if_statement] = STATE(1931),
    [sym_for_statement] = STATE(1931),
    [sym_while_statement] = STATE(1931),
    [sym_repeat_statement] = STATE(1931),
    [sym_braced_expression] = STATE(1931),
    [sym_parenthesized_expression] = STATE(1931),
    [sym_call] = STATE(1931),
    [sym_subset] = STATE(1931),
    [sym_subset2] = STATE(1931),
    [sym__argument] = STATE(4656),
    [sym_argument] = STATE(4657),
    [sym__argument_named] = STATE(4658),
    [sym__argument_unnamed] = STATE(4662),
    [sym__argument_value] = STATE(4663),
    [sym_unary_operator] = STATE(1931),
    [sym_binary_operator] = STATE(1931),
    [sym_extract_operator] = STATE(1931),
    [sym_namespace_operator] = STATE(1931),
    [sym_integer] = STATE(1931),
    [sym_complex] = STATE(1931),
    [sym_float] = STATE(1931),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2633),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(1931),
    [sym__expression] = STATE(1931),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__close_parenthesis] = STATE(2991),
    [sym__open_brace] = STATE(154),
    [aux_sym_call_arguments_repeat1] = STATE(2113),
    [sym_identifier] = ACTIONS(6387),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(6389),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3865),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(6391),
    [sym_next] = ACTIONS(6391),
    [sym_break] = ACTIONS(6391),
    [sym_true] = ACTIONS(6391),
    [sym_false] = ACTIONS(6391),
    [sym_null] = ACTIONS(6391),
    [sym_inf] = ACTIONS(6391),
    [sym_nan] = ACTIONS(6391),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(6393),
    [sym_dot_dot_i] = ACTIONS(6395),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6397),
    [sym__newline] = ACTIONS(6399),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(6427),
    [sym__external_open_brace] = ACTIONS(3891),
  },
  [1340] = {
    [sym_function_definition] = STATE(1931),
    [sym_if_statement] = STATE(1931),
    [sym_for_statement] = STATE(1931),
    [sym_while_statement] = STATE(1931),
    [sym_repeat_statement] = STATE(1931),
    [sym_braced_expression] = STATE(1931),
    [sym_parenthesized_expression] = STATE(1931),
    [sym_call] = STATE(1931),
    [sym_subset] = STATE(1931),
    [sym_subset2] = STATE(1931),
    [sym__argument] = STATE(4656),
    [sym_argument] = STATE(4657),
    [sym__argument_named] = STATE(4658),
    [sym__argument_unnamed] = STATE(4662),
    [sym__argument_value] = STATE(4663),
    [sym_unary_operator] = STATE(1931),
    [sym_binary_operator] = STATE(1931),
    [sym_extract_operator] = STATE(1931),
    [sym_namespace_operator] = STATE(1931),
    [sym_integer] = STATE(1931),
    [sym_complex] = STATE(1931),
    [sym_float] = STATE(1931),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2633),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(1931),
    [sym__expression] = STATE(1931),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__close_parenthesis] = STATE(2627),
    [sym__open_brace] = STATE(154),
    [aux_sym_call_arguments_repeat1] = STATE(1359),
    [sym_identifier] = ACTIONS(6387),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(6389),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3865),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(6391),
    [sym_next] = ACTIONS(6391),
    [sym_break] = ACTIONS(6391),
    [sym_true] = ACTIONS(6391),
    [sym_false] = ACTIONS(6391),
    [sym_null] = ACTIONS(6391),
    [sym_inf] = ACTIONS(6391),
    [sym_nan] = ACTIONS(6391),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(6393),
    [sym_dot_dot_i] = ACTIONS(6395),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6397),
    [sym__newline] = ACTIONS(6399),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(6429),
    [sym__external_open_brace] = ACTIONS(3891),
  },
  [1341] = {
    [sym_call_arguments] = STATE(2763),
    [sym_subset_arguments] = STATE(2764),
    [sym_subset2_arguments] = STATE(2765),
    [sym__open_parenthesis] = STATE(1584),
    [sym__open_bracket] = STATE(1582),
    [sym__open_bracket2] = STATE(1577),
    [sym_identifier] = ACTIONS(5331),
    [anon_sym_BSLASH] = ACTIONS(5329),
    [anon_sym_function] = ACTIONS(5331),
    [anon_sym_EQ] = ACTIONS(6431),
    [anon_sym_if] = ACTIONS(5331),
    [anon_sym_for] = ACTIONS(5331),
    [anon_sym_while] = ACTIONS(5331),
    [anon_sym_repeat] = ACTIONS(5331),
    [anon_sym_QMARK] = ACTIONS(5329),
    [anon_sym_TILDE] = ACTIONS(6433),
    [anon_sym_BANG] = ACTIONS(5331),
    [anon_sym_PLUS] = ACTIONS(6435),
    [anon_sym_DASH] = ACTIONS(6437),
    [anon_sym_LT_DASH] = ACTIONS(6439),
    [anon_sym_LT_LT_DASH] = ACTIONS(6439),
    [anon_sym_COLON_EQ] = ACTIONS(6439),
    [anon_sym_DASH_GT] = ACTIONS(6441),
    [anon_sym_DASH_GT_GT] = ACTIONS(6443),
    [anon_sym_PIPE] = ACTIONS(6445),
    [anon_sym_AMP] = ACTIONS(6447),
    [anon_sym_PIPE_PIPE] = ACTIONS(6449),
    [anon_sym_AMP_AMP] = ACTIONS(6451),
    [anon_sym_LT] = ACTIONS(6453),
    [anon_sym_LT_EQ] = ACTIONS(6455),
    [anon_sym_GT] = ACTIONS(6453),
    [anon_sym_GT_EQ] = ACTIONS(6455),
    [anon_sym_EQ_EQ] = ACTIONS(6455),
    [anon_sym_BANG_EQ] = ACTIONS(6455),
    [anon_sym_STAR] = ACTIONS(6457),
    [anon_sym_SLASH] = ACTIONS(6459),
    [anon_sym_STAR_STAR] = ACTIONS(6461),
    [anon_sym_CARET] = ACTIONS(6461),
    [aux_sym_binary_operator_token1] = ACTIONS(6463),
    [anon_sym_PIPE_GT] = ACTIONS(6463),
    [anon_sym_COLON] = ACTIONS(6465),
    [anon_sym_DOLLAR] = ACTIONS(6467),
    [anon_sym_AT] = ACTIONS(6467),
    [aux_sym__hex_literal_token1] = ACTIONS(5329),
    [sym__number_literal] = ACTIONS(5331),
    [anon_sym_SQUOTE] = ACTIONS(5329),
    [anon_sym_DQUOTE] = ACTIONS(5329),
    [sym_return] = ACTIONS(5331),
    [sym_next] = ACTIONS(5331),
    [sym_break] = ACTIONS(5331),
    [sym_true] = ACTIONS(5331),
    [sym_false] = ACTIONS(5331),
    [sym_null] = ACTIONS(5331),
    [sym_inf] = ACTIONS(5331),
    [sym_nan] = ACTIONS(5331),
    [anon_sym_NA] = ACTIONS(5331),
    [anon_sym_NA_integer_] = ACTIONS(5331),
    [anon_sym_NA_real_] = ACTIONS(5331),
    [anon_sym_NA_complex_] = ACTIONS(5331),
    [anon_sym_NA_character_] = ACTIONS(5331),
    [sym_dots] = ACTIONS(5331),
    [sym_dot_dot_i] = ACTIONS(5329),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5329),
    [sym__newline] = ACTIONS(5329),
    [sym__raw_string_literal] = ACTIONS(5329),
    [sym__external_open_parenthesis] = ACTIONS(6469),
    [sym__external_close_parenthesis] = ACTIONS(5329),
    [sym__external_open_brace] = ACTIONS(5329),
    [sym__external_open_bracket] = ACTIONS(6471),
    [sym__external_close_bracket] = ACTIONS(5329),
    [sym__external_open_bracket2] = ACTIONS(6473),
  },
  [1342] = {
    [sym_function_definition] = STATE(1931),
    [sym_if_statement] = STATE(1931),
    [sym_for_statement] = STATE(1931),
    [sym_while_statement] = STATE(1931),
    [sym_repeat_statement] = STATE(1931),
    [sym_braced_expression] = STATE(1931),
    [sym_parenthesized_expression] = STATE(1931),
    [sym_call] = STATE(1931),
    [sym_subset] = STATE(1931),
    [sym_subset2] = STATE(1931),
    [sym__argument] = STATE(4656),
    [sym_argument] = STATE(4657),
    [sym__argument_named] = STATE(4658),
    [sym__argument_unnamed] = STATE(4662),
    [sym__argument_value] = STATE(4663),
    [sym_unary_operator] = STATE(1931),
    [sym_binary_operator] = STATE(1931),
    [sym_extract_operator] = STATE(1931),
    [sym_namespace_operator] = STATE(1931),
    [sym_integer] = STATE(1931),
    [sym_complex] = STATE(1931),
    [sym_float] = STATE(1931),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2633),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(1931),
    [sym__expression] = STATE(1931),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__close_parenthesis] = STATE(2331),
    [sym__open_brace] = STATE(154),
    [aux_sym_call_arguments_repeat1] = STATE(2113),
    [sym_identifier] = ACTIONS(6387),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(6389),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3865),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(6391),
    [sym_next] = ACTIONS(6391),
    [sym_break] = ACTIONS(6391),
    [sym_true] = ACTIONS(6391),
    [sym_false] = ACTIONS(6391),
    [sym_null] = ACTIONS(6391),
    [sym_inf] = ACTIONS(6391),
    [sym_nan] = ACTIONS(6391),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(6393),
    [sym_dot_dot_i] = ACTIONS(6395),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6397),
    [sym__newline] = ACTIONS(6399),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(6475),
    [sym__external_open_brace] = ACTIONS(3891),
  },
  [1343] = {
    [sym_call_arguments] = STATE(2763),
    [sym_subset_arguments] = STATE(2764),
    [sym_subset2_arguments] = STATE(2765),
    [sym__open_parenthesis] = STATE(1584),
    [sym__open_bracket] = STATE(1582),
    [sym__open_bracket2] = STATE(1577),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(6431),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(6433),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(6435),
    [anon_sym_DASH] = ACTIONS(6437),
    [anon_sym_LT_DASH] = ACTIONS(6439),
    [anon_sym_LT_LT_DASH] = ACTIONS(6439),
    [anon_sym_COLON_EQ] = ACTIONS(6439),
    [anon_sym_DASH_GT] = ACTIONS(6441),
    [anon_sym_DASH_GT_GT] = ACTIONS(6443),
    [anon_sym_PIPE] = ACTIONS(6445),
    [anon_sym_AMP] = ACTIONS(6447),
    [anon_sym_PIPE_PIPE] = ACTIONS(6449),
    [anon_sym_AMP_AMP] = ACTIONS(6451),
    [anon_sym_LT] = ACTIONS(6453),
    [anon_sym_LT_EQ] = ACTIONS(6455),
    [anon_sym_GT] = ACTIONS(6453),
    [anon_sym_GT_EQ] = ACTIONS(6455),
    [anon_sym_EQ_EQ] = ACTIONS(6455),
    [anon_sym_BANG_EQ] = ACTIONS(6455),
    [anon_sym_STAR] = ACTIONS(6457),
    [anon_sym_SLASH] = ACTIONS(6459),
    [anon_sym_STAR_STAR] = ACTIONS(6461),
    [anon_sym_CARET] = ACTIONS(6461),
    [aux_sym_binary_operator_token1] = ACTIONS(6463),
    [anon_sym_PIPE_GT] = ACTIONS(6463),
    [anon_sym_COLON] = ACTIONS(6465),
    [anon_sym_DOLLAR] = ACTIONS(6467),
    [anon_sym_AT] = ACTIONS(6467),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(6469),
    [sym__external_close_parenthesis] = ACTIONS(5333),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(6471),
    [sym__external_close_bracket] = ACTIONS(5333),
    [sym__external_open_bracket2] = ACTIONS(6473),
  },
  [1344] = {
    [sym_function_definition] = STATE(1931),
    [sym_if_statement] = STATE(1931),
    [sym_for_statement] = STATE(1931),
    [sym_while_statement] = STATE(1931),
    [sym_repeat_statement] = STATE(1931),
    [sym_braced_expression] = STATE(1931),
    [sym_parenthesized_expression] = STATE(1931),
    [sym_call] = STATE(1931),
    [sym_subset] = STATE(1931),
    [sym_subset2] = STATE(1931),
    [sym__argument] = STATE(4656),
    [sym_argument] = STATE(4657),
    [sym__argument_named] = STATE(4658),
    [sym__argument_unnamed] = STATE(4662),
    [sym__argument_value] = STATE(4663),
    [sym_unary_operator] = STATE(1931),
    [sym_binary_operator] = STATE(1931),
    [sym_extract_operator] = STATE(1931),
    [sym_namespace_operator] = STATE(1931),
    [sym_integer] = STATE(1931),
    [sym_complex] = STATE(1931),
    [sym_float] = STATE(1931),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2633),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(1931),
    [sym__expression] = STATE(1931),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__close_parenthesis] = STATE(2894),
    [sym__open_brace] = STATE(154),
    [aux_sym_call_arguments_repeat1] = STATE(1881),
    [sym_identifier] = ACTIONS(6387),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(6389),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3865),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(6391),
    [sym_next] = ACTIONS(6391),
    [sym_break] = ACTIONS(6391),
    [sym_true] = ACTIONS(6391),
    [sym_false] = ACTIONS(6391),
    [sym_null] = ACTIONS(6391),
    [sym_inf] = ACTIONS(6391),
    [sym_nan] = ACTIONS(6391),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(6393),
    [sym_dot_dot_i] = ACTIONS(6395),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6397),
    [sym__newline] = ACTIONS(6399),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(6477),
    [sym__external_open_brace] = ACTIONS(3891),
  },
  [1345] = {
    [sym_call_arguments] = STATE(2763),
    [sym_subset_arguments] = STATE(2764),
    [sym_subset2_arguments] = STATE(2765),
    [sym__open_parenthesis] = STATE(1584),
    [sym__open_bracket] = STATE(1582),
    [sym__open_bracket2] = STATE(1577),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(6435),
    [anon_sym_DASH] = ACTIONS(6437),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(6445),
    [anon_sym_AMP] = ACTIONS(6447),
    [anon_sym_PIPE_PIPE] = ACTIONS(6449),
    [anon_sym_AMP_AMP] = ACTIONS(6451),
    [anon_sym_LT] = ACTIONS(6453),
    [anon_sym_LT_EQ] = ACTIONS(6455),
    [anon_sym_GT] = ACTIONS(6453),
    [anon_sym_GT_EQ] = ACTIONS(6455),
    [anon_sym_EQ_EQ] = ACTIONS(6455),
    [anon_sym_BANG_EQ] = ACTIONS(6455),
    [anon_sym_STAR] = ACTIONS(6457),
    [anon_sym_SLASH] = ACTIONS(6459),
    [anon_sym_STAR_STAR] = ACTIONS(6461),
    [anon_sym_CARET] = ACTIONS(6461),
    [aux_sym_binary_operator_token1] = ACTIONS(6463),
    [anon_sym_PIPE_GT] = ACTIONS(6463),
    [anon_sym_COLON] = ACTIONS(6465),
    [anon_sym_DOLLAR] = ACTIONS(6467),
    [anon_sym_AT] = ACTIONS(6467),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(6469),
    [sym__external_close_parenthesis] = ACTIONS(5333),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(6471),
    [sym__external_close_bracket] = ACTIONS(5333),
    [sym__external_open_bracket2] = ACTIONS(6473),
  },
  [1346] = {
    [sym_function_definition] = STATE(1940),
    [sym_if_statement] = STATE(1940),
    [sym_for_statement] = STATE(1940),
    [sym_while_statement] = STATE(1940),
    [sym_repeat_statement] = STATE(1940),
    [sym_braced_expression] = STATE(1940),
    [sym_parenthesized_expression] = STATE(1940),
    [sym_call] = STATE(1940),
    [sym_subset] = STATE(1940),
    [sym_subset2] = STATE(1940),
    [sym__argument] = STATE(4665),
    [sym_argument] = STATE(4661),
    [sym__argument_named] = STATE(4669),
    [sym__argument_unnamed] = STATE(4673),
    [sym__argument_value] = STATE(4679),
    [sym_unary_operator] = STATE(1940),
    [sym_binary_operator] = STATE(1940),
    [sym_extract_operator] = STATE(1940),
    [sym_namespace_operator] = STATE(1940),
    [sym_integer] = STATE(1940),
    [sym_complex] = STATE(1940),
    [sym_float] = STATE(1940),
    [sym__hex_literal] = STATE(2656),
    [sym__float_literal] = STATE(2656),
    [sym_string] = STATE(2606),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym_na] = STATE(1940),
    [sym__expression] = STATE(1940),
    [sym__string_or_identifier] = STATE(5141),
    [sym__open_parenthesis] = STATE(218),
    [sym__open_brace] = STATE(185),
    [sym__close_bracket2] = STATE(2454),
    [aux_sym_call_arguments_repeat1] = STATE(1369),
    [sym_identifier] = ACTIONS(6369),
    [anon_sym_BSLASH] = ACTIONS(4644),
    [anon_sym_function] = ACTIONS(4646),
    [anon_sym_if] = ACTIONS(4648),
    [anon_sym_for] = ACTIONS(4650),
    [anon_sym_while] = ACTIONS(4652),
    [anon_sym_repeat] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(6371),
    [anon_sym_PLUS] = ACTIONS(4662),
    [anon_sym_DASH] = ACTIONS(4662),
    [aux_sym__hex_literal_token1] = ACTIONS(4666),
    [sym__number_literal] = ACTIONS(4668),
    [anon_sym_SQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4672),
    [sym_return] = ACTIONS(6373),
    [sym_next] = ACTIONS(6373),
    [sym_break] = ACTIONS(6373),
    [sym_true] = ACTIONS(6373),
    [sym_false] = ACTIONS(6373),
    [sym_null] = ACTIONS(6373),
    [sym_inf] = ACTIONS(6373),
    [sym_nan] = ACTIONS(6373),
    [anon_sym_NA] = ACTIONS(4676),
    [anon_sym_NA_integer_] = ACTIONS(4676),
    [anon_sym_NA_real_] = ACTIONS(4676),
    [anon_sym_NA_complex_] = ACTIONS(4676),
    [anon_sym_NA_character_] = ACTIONS(4676),
    [sym_dots] = ACTIONS(6375),
    [sym_dot_dot_i] = ACTIONS(6377),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6379),
    [sym__newline] = ACTIONS(6381),
    [sym__raw_string_literal] = ACTIONS(4680),
    [sym__external_open_parenthesis] = ACTIONS(4682),
    [sym__external_open_brace] = ACTIONS(4684),
    [sym__external_close_bracket2] = ACTIONS(6479),
  },
  [1347] = {
    [sym_call_arguments] = STATE(2763),
    [sym_subset_arguments] = STATE(2764),
    [sym_subset2_arguments] = STATE(2765),
    [sym__open_parenthesis] = STATE(1584),
    [sym__open_bracket] = STATE(1582),
    [sym__open_bracket2] = STATE(1577),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(6435),
    [anon_sym_DASH] = ACTIONS(6437),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5335),
    [anon_sym_AMP] = ACTIONS(5335),
    [anon_sym_PIPE_PIPE] = ACTIONS(5333),
    [anon_sym_AMP_AMP] = ACTIONS(5333),
    [anon_sym_LT] = ACTIONS(6453),
    [anon_sym_LT_EQ] = ACTIONS(6455),
    [anon_sym_GT] = ACTIONS(6453),
    [anon_sym_GT_EQ] = ACTIONS(6455),
    [anon_sym_EQ_EQ] = ACTIONS(6455),
    [anon_sym_BANG_EQ] = ACTIONS(6455),
    [anon_sym_STAR] = ACTIONS(6457),
    [anon_sym_SLASH] = ACTIONS(6459),
    [anon_sym_STAR_STAR] = ACTIONS(6461),
    [anon_sym_CARET] = ACTIONS(6461),
    [aux_sym_binary_operator_token1] = ACTIONS(6463),
    [anon_sym_PIPE_GT] = ACTIONS(6463),
    [anon_sym_COLON] = ACTIONS(6465),
    [anon_sym_DOLLAR] = ACTIONS(6467),
    [anon_sym_AT] = ACTIONS(6467),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(6469),
    [sym__external_close_parenthesis] = ACTIONS(5333),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(6471),
    [sym__external_close_bracket] = ACTIONS(5333),
    [sym__external_open_bracket2] = ACTIONS(6473),
  },
  [1348] = {
    [sym_function_definition] = STATE(2038),
    [sym_if_statement] = STATE(2038),
    [sym_for_statement] = STATE(2038),
    [sym_while_statement] = STATE(2038),
    [sym_repeat_statement] = STATE(2038),
    [sym_braced_expression] = STATE(2038),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_call] = STATE(2038),
    [sym_subset] = STATE(2038),
    [sym_subset2] = STATE(2038),
    [sym__argument] = STATE(4664),
    [sym_argument] = STATE(4659),
    [sym__argument_named] = STATE(4654),
    [sym__argument_unnamed] = STATE(4676),
    [sym__argument_value] = STATE(4677),
    [sym_unary_operator] = STATE(2038),
    [sym_binary_operator] = STATE(2038),
    [sym_extract_operator] = STATE(2038),
    [sym_namespace_operator] = STATE(2038),
    [sym_integer] = STATE(2038),
    [sym_complex] = STATE(2038),
    [sym_float] = STATE(2038),
    [sym__hex_literal] = STATE(2700),
    [sym__float_literal] = STATE(2700),
    [sym_string] = STATE(2597),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym_na] = STATE(2038),
    [sym__expression] = STATE(2038),
    [sym__string_or_identifier] = STATE(5148),
    [sym__open_parenthesis] = STATE(214),
    [sym__open_brace] = STATE(192),
    [sym__close_bracket] = STATE(2453),
    [aux_sym_call_arguments_repeat1] = STATE(1367),
    [sym_identifier] = ACTIONS(6351),
    [anon_sym_BSLASH] = ACTIONS(4754),
    [anon_sym_function] = ACTIONS(4756),
    [anon_sym_if] = ACTIONS(4758),
    [anon_sym_for] = ACTIONS(4760),
    [anon_sym_while] = ACTIONS(4762),
    [anon_sym_repeat] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4766),
    [anon_sym_TILDE] = ACTIONS(4768),
    [anon_sym_BANG] = ACTIONS(6353),
    [anon_sym_PLUS] = ACTIONS(4772),
    [anon_sym_DASH] = ACTIONS(4772),
    [aux_sym__hex_literal_token1] = ACTIONS(4776),
    [sym__number_literal] = ACTIONS(4778),
    [anon_sym_SQUOTE] = ACTIONS(4780),
    [anon_sym_DQUOTE] = ACTIONS(4782),
    [sym_return] = ACTIONS(6355),
    [sym_next] = ACTIONS(6355),
    [sym_break] = ACTIONS(6355),
    [sym_true] = ACTIONS(6355),
    [sym_false] = ACTIONS(6355),
    [sym_null] = ACTIONS(6355),
    [sym_inf] = ACTIONS(6355),
    [sym_nan] = ACTIONS(6355),
    [anon_sym_NA] = ACTIONS(4786),
    [anon_sym_NA_integer_] = ACTIONS(4786),
    [anon_sym_NA_real_] = ACTIONS(4786),
    [anon_sym_NA_complex_] = ACTIONS(4786),
    [anon_sym_NA_character_] = ACTIONS(4786),
    [sym_dots] = ACTIONS(6357),
    [sym_dot_dot_i] = ACTIONS(6359),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6361),
    [sym__newline] = ACTIONS(6363),
    [sym__raw_string_literal] = ACTIONS(4790),
    [sym__external_open_parenthesis] = ACTIONS(4792),
    [sym__external_open_brace] = ACTIONS(4794),
    [sym__external_close_bracket] = ACTIONS(6481),
  },
  [1349] = {
    [sym_call_arguments] = STATE(2763),
    [sym_subset_arguments] = STATE(2764),
    [sym_subset2_arguments] = STATE(2765),
    [sym__open_parenthesis] = STATE(1584),
    [sym__open_bracket] = STATE(1582),
    [sym__open_bracket2] = STATE(1577),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(5333),
    [anon_sym_DASH] = ACTIONS(5335),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5335),
    [anon_sym_AMP] = ACTIONS(5335),
    [anon_sym_PIPE_PIPE] = ACTIONS(5333),
    [anon_sym_AMP_AMP] = ACTIONS(5333),
    [anon_sym_LT] = ACTIONS(5335),
    [anon_sym_LT_EQ] = ACTIONS(5333),
    [anon_sym_GT] = ACTIONS(5335),
    [anon_sym_GT_EQ] = ACTIONS(5333),
    [anon_sym_EQ_EQ] = ACTIONS(5333),
    [anon_sym_BANG_EQ] = ACTIONS(5333),
    [anon_sym_STAR] = ACTIONS(5335),
    [anon_sym_SLASH] = ACTIONS(5333),
    [anon_sym_STAR_STAR] = ACTIONS(6461),
    [anon_sym_CARET] = ACTIONS(6461),
    [aux_sym_binary_operator_token1] = ACTIONS(5333),
    [anon_sym_PIPE_GT] = ACTIONS(5333),
    [anon_sym_COLON] = ACTIONS(5335),
    [anon_sym_DOLLAR] = ACTIONS(6467),
    [anon_sym_AT] = ACTIONS(6467),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(6469),
    [sym__external_close_parenthesis] = ACTIONS(5333),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(6471),
    [sym__external_close_bracket] = ACTIONS(5333),
    [sym__external_open_bracket2] = ACTIONS(6473),
  },
  [1350] = {
    [sym_function_definition] = STATE(1931),
    [sym_if_statement] = STATE(1931),
    [sym_for_statement] = STATE(1931),
    [sym_while_statement] = STATE(1931),
    [sym_repeat_statement] = STATE(1931),
    [sym_braced_expression] = STATE(1931),
    [sym_parenthesized_expression] = STATE(1931),
    [sym_call] = STATE(1931),
    [sym_subset] = STATE(1931),
    [sym_subset2] = STATE(1931),
    [sym__argument] = STATE(4656),
    [sym_argument] = STATE(4657),
    [sym__argument_named] = STATE(4658),
    [sym__argument_unnamed] = STATE(4662),
    [sym__argument_value] = STATE(4663),
    [sym_unary_operator] = STATE(1931),
    [sym_binary_operator] = STATE(1931),
    [sym_extract_operator] = STATE(1931),
    [sym_namespace_operator] = STATE(1931),
    [sym_integer] = STATE(1931),
    [sym_complex] = STATE(1931),
    [sym_float] = STATE(1931),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2633),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(1931),
    [sym__expression] = STATE(1931),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__close_parenthesis] = STATE(2452),
    [sym__open_brace] = STATE(154),
    [aux_sym_call_arguments_repeat1] = STATE(1363),
    [sym_identifier] = ACTIONS(6387),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(6389),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3865),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(6391),
    [sym_next] = ACTIONS(6391),
    [sym_break] = ACTIONS(6391),
    [sym_true] = ACTIONS(6391),
    [sym_false] = ACTIONS(6391),
    [sym_null] = ACTIONS(6391),
    [sym_inf] = ACTIONS(6391),
    [sym_nan] = ACTIONS(6391),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(6393),
    [sym_dot_dot_i] = ACTIONS(6395),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6397),
    [sym__newline] = ACTIONS(6399),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(6483),
    [sym__external_open_brace] = ACTIONS(3891),
  },
  [1351] = {
    [sym_function_definition] = STATE(1931),
    [sym_if_statement] = STATE(1931),
    [sym_for_statement] = STATE(1931),
    [sym_while_statement] = STATE(1931),
    [sym_repeat_statement] = STATE(1931),
    [sym_braced_expression] = STATE(1931),
    [sym_parenthesized_expression] = STATE(1931),
    [sym_call] = STATE(1931),
    [sym_subset] = STATE(1931),
    [sym_subset2] = STATE(1931),
    [sym__argument] = STATE(4656),
    [sym_argument] = STATE(4657),
    [sym__argument_named] = STATE(4658),
    [sym__argument_unnamed] = STATE(4662),
    [sym__argument_value] = STATE(4663),
    [sym_unary_operator] = STATE(1931),
    [sym_binary_operator] = STATE(1931),
    [sym_extract_operator] = STATE(1931),
    [sym_namespace_operator] = STATE(1931),
    [sym_integer] = STATE(1931),
    [sym_complex] = STATE(1931),
    [sym_float] = STATE(1931),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2633),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(1931),
    [sym__expression] = STATE(1931),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__close_parenthesis] = STATE(2501),
    [sym__open_brace] = STATE(154),
    [aux_sym_call_arguments_repeat1] = STATE(2113),
    [sym_identifier] = ACTIONS(6387),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(6389),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3865),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(6391),
    [sym_next] = ACTIONS(6391),
    [sym_break] = ACTIONS(6391),
    [sym_true] = ACTIONS(6391),
    [sym_false] = ACTIONS(6391),
    [sym_null] = ACTIONS(6391),
    [sym_inf] = ACTIONS(6391),
    [sym_nan] = ACTIONS(6391),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(6393),
    [sym_dot_dot_i] = ACTIONS(6395),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6397),
    [sym__newline] = ACTIONS(6399),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(6485),
    [sym__external_open_brace] = ACTIONS(3891),
  },
  [1352] = {
    [sym_function_definition] = STATE(1940),
    [sym_if_statement] = STATE(1940),
    [sym_for_statement] = STATE(1940),
    [sym_while_statement] = STATE(1940),
    [sym_repeat_statement] = STATE(1940),
    [sym_braced_expression] = STATE(1940),
    [sym_parenthesized_expression] = STATE(1940),
    [sym_call] = STATE(1940),
    [sym_subset] = STATE(1940),
    [sym_subset2] = STATE(1940),
    [sym__argument] = STATE(4665),
    [sym_argument] = STATE(4661),
    [sym__argument_named] = STATE(4669),
    [sym__argument_unnamed] = STATE(4673),
    [sym__argument_value] = STATE(4679),
    [sym_unary_operator] = STATE(1940),
    [sym_binary_operator] = STATE(1940),
    [sym_extract_operator] = STATE(1940),
    [sym_namespace_operator] = STATE(1940),
    [sym_integer] = STATE(1940),
    [sym_complex] = STATE(1940),
    [sym_float] = STATE(1940),
    [sym__hex_literal] = STATE(2656),
    [sym__float_literal] = STATE(2656),
    [sym_string] = STATE(2606),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym_na] = STATE(1940),
    [sym__expression] = STATE(1940),
    [sym__string_or_identifier] = STATE(5141),
    [sym__open_parenthesis] = STATE(218),
    [sym__open_brace] = STATE(185),
    [sym__close_bracket2] = STATE(2714),
    [aux_sym_call_arguments_repeat1] = STATE(1386),
    [sym_identifier] = ACTIONS(6369),
    [anon_sym_BSLASH] = ACTIONS(4644),
    [anon_sym_function] = ACTIONS(4646),
    [anon_sym_if] = ACTIONS(4648),
    [anon_sym_for] = ACTIONS(4650),
    [anon_sym_while] = ACTIONS(4652),
    [anon_sym_repeat] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(6371),
    [anon_sym_PLUS] = ACTIONS(4662),
    [anon_sym_DASH] = ACTIONS(4662),
    [aux_sym__hex_literal_token1] = ACTIONS(4666),
    [sym__number_literal] = ACTIONS(4668),
    [anon_sym_SQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4672),
    [sym_return] = ACTIONS(6373),
    [sym_next] = ACTIONS(6373),
    [sym_break] = ACTIONS(6373),
    [sym_true] = ACTIONS(6373),
    [sym_false] = ACTIONS(6373),
    [sym_null] = ACTIONS(6373),
    [sym_inf] = ACTIONS(6373),
    [sym_nan] = ACTIONS(6373),
    [anon_sym_NA] = ACTIONS(4676),
    [anon_sym_NA_integer_] = ACTIONS(4676),
    [anon_sym_NA_real_] = ACTIONS(4676),
    [anon_sym_NA_complex_] = ACTIONS(4676),
    [anon_sym_NA_character_] = ACTIONS(4676),
    [sym_dots] = ACTIONS(6375),
    [sym_dot_dot_i] = ACTIONS(6377),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6379),
    [sym__newline] = ACTIONS(6381),
    [sym__raw_string_literal] = ACTIONS(4680),
    [sym__external_open_parenthesis] = ACTIONS(4682),
    [sym__external_open_brace] = ACTIONS(4684),
    [sym__external_close_bracket2] = ACTIONS(6487),
  },
  [1353] = {
    [sym_function_definition] = STATE(2038),
    [sym_if_statement] = STATE(2038),
    [sym_for_statement] = STATE(2038),
    [sym_while_statement] = STATE(2038),
    [sym_repeat_statement] = STATE(2038),
    [sym_braced_expression] = STATE(2038),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_call] = STATE(2038),
    [sym_subset] = STATE(2038),
    [sym_subset2] = STATE(2038),
    [sym__argument] = STATE(4664),
    [sym_argument] = STATE(4659),
    [sym__argument_named] = STATE(4654),
    [sym__argument_unnamed] = STATE(4676),
    [sym__argument_value] = STATE(4677),
    [sym_unary_operator] = STATE(2038),
    [sym_binary_operator] = STATE(2038),
    [sym_extract_operator] = STATE(2038),
    [sym_namespace_operator] = STATE(2038),
    [sym_integer] = STATE(2038),
    [sym_complex] = STATE(2038),
    [sym_float] = STATE(2038),
    [sym__hex_literal] = STATE(2700),
    [sym__float_literal] = STATE(2700),
    [sym_string] = STATE(2597),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym_na] = STATE(2038),
    [sym__expression] = STATE(2038),
    [sym__string_or_identifier] = STATE(5148),
    [sym__open_parenthesis] = STATE(214),
    [sym__open_brace] = STATE(192),
    [sym__close_bracket] = STATE(2715),
    [aux_sym_call_arguments_repeat1] = STATE(1387),
    [sym_identifier] = ACTIONS(6351),
    [anon_sym_BSLASH] = ACTIONS(4754),
    [anon_sym_function] = ACTIONS(4756),
    [anon_sym_if] = ACTIONS(4758),
    [anon_sym_for] = ACTIONS(4760),
    [anon_sym_while] = ACTIONS(4762),
    [anon_sym_repeat] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4766),
    [anon_sym_TILDE] = ACTIONS(4768),
    [anon_sym_BANG] = ACTIONS(6353),
    [anon_sym_PLUS] = ACTIONS(4772),
    [anon_sym_DASH] = ACTIONS(4772),
    [aux_sym__hex_literal_token1] = ACTIONS(4776),
    [sym__number_literal] = ACTIONS(4778),
    [anon_sym_SQUOTE] = ACTIONS(4780),
    [anon_sym_DQUOTE] = ACTIONS(4782),
    [sym_return] = ACTIONS(6355),
    [sym_next] = ACTIONS(6355),
    [sym_break] = ACTIONS(6355),
    [sym_true] = ACTIONS(6355),
    [sym_false] = ACTIONS(6355),
    [sym_null] = ACTIONS(6355),
    [sym_inf] = ACTIONS(6355),
    [sym_nan] = ACTIONS(6355),
    [anon_sym_NA] = ACTIONS(4786),
    [anon_sym_NA_integer_] = ACTIONS(4786),
    [anon_sym_NA_real_] = ACTIONS(4786),
    [anon_sym_NA_complex_] = ACTIONS(4786),
    [anon_sym_NA_character_] = ACTIONS(4786),
    [sym_dots] = ACTIONS(6357),
    [sym_dot_dot_i] = ACTIONS(6359),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6361),
    [sym__newline] = ACTIONS(6363),
    [sym__raw_string_literal] = ACTIONS(4790),
    [sym__external_open_parenthesis] = ACTIONS(4792),
    [sym__external_open_brace] = ACTIONS(4794),
    [sym__external_close_bracket] = ACTIONS(6489),
  },
  [1354] = {
    [sym_call_arguments] = STATE(2777),
    [sym_subset_arguments] = STATE(2779),
    [sym_subset2_arguments] = STATE(2786),
    [sym__open_parenthesis] = STATE(1411),
    [sym__open_bracket] = STATE(1409),
    [sym__open_bracket2] = STATE(1407),
    [ts_builtin_sym_end] = ACTIONS(5313),
    [sym_identifier] = ACTIONS(5311),
    [anon_sym_BSLASH] = ACTIONS(5313),
    [anon_sym_function] = ACTIONS(5311),
    [anon_sym_EQ] = ACTIONS(6491),
    [anon_sym_if] = ACTIONS(5311),
    [anon_sym_for] = ACTIONS(5311),
    [anon_sym_while] = ACTIONS(5311),
    [anon_sym_repeat] = ACTIONS(5311),
    [anon_sym_QMARK] = ACTIONS(6493),
    [anon_sym_TILDE] = ACTIONS(6495),
    [anon_sym_BANG] = ACTIONS(5311),
    [anon_sym_PLUS] = ACTIONS(6497),
    [anon_sym_DASH] = ACTIONS(6499),
    [anon_sym_LT_DASH] = ACTIONS(6501),
    [anon_sym_LT_LT_DASH] = ACTIONS(6501),
    [anon_sym_COLON_EQ] = ACTIONS(6501),
    [anon_sym_DASH_GT] = ACTIONS(6503),
    [anon_sym_DASH_GT_GT] = ACTIONS(6505),
    [anon_sym_PIPE] = ACTIONS(6507),
    [anon_sym_AMP] = ACTIONS(6509),
    [anon_sym_PIPE_PIPE] = ACTIONS(6511),
    [anon_sym_AMP_AMP] = ACTIONS(6513),
    [anon_sym_LT] = ACTIONS(6515),
    [anon_sym_LT_EQ] = ACTIONS(6517),
    [anon_sym_GT] = ACTIONS(6515),
    [anon_sym_GT_EQ] = ACTIONS(6517),
    [anon_sym_EQ_EQ] = ACTIONS(6517),
    [anon_sym_BANG_EQ] = ACTIONS(6517),
    [anon_sym_STAR] = ACTIONS(6519),
    [anon_sym_SLASH] = ACTIONS(6521),
    [anon_sym_STAR_STAR] = ACTIONS(6523),
    [anon_sym_CARET] = ACTIONS(6523),
    [aux_sym_binary_operator_token1] = ACTIONS(6525),
    [anon_sym_PIPE_GT] = ACTIONS(6525),
    [anon_sym_COLON] = ACTIONS(6527),
    [anon_sym_DOLLAR] = ACTIONS(6529),
    [anon_sym_AT] = ACTIONS(6529),
    [aux_sym__hex_literal_token1] = ACTIONS(5313),
    [sym__number_literal] = ACTIONS(5311),
    [anon_sym_SQUOTE] = ACTIONS(5313),
    [anon_sym_DQUOTE] = ACTIONS(5313),
    [sym_return] = ACTIONS(5311),
    [sym_next] = ACTIONS(5311),
    [sym_break] = ACTIONS(5311),
    [sym_true] = ACTIONS(5311),
    [sym_false] = ACTIONS(5311),
    [sym_null] = ACTIONS(5311),
    [sym_inf] = ACTIONS(5311),
    [sym_nan] = ACTIONS(5311),
    [anon_sym_NA] = ACTIONS(5311),
    [anon_sym_NA_integer_] = ACTIONS(5311),
    [anon_sym_NA_real_] = ACTIONS(5311),
    [anon_sym_NA_complex_] = ACTIONS(5311),
    [anon_sym_NA_character_] = ACTIONS(5311),
    [sym_dots] = ACTIONS(5311),
    [sym_dot_dot_i] = ACTIONS(5313),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5313),
    [sym__semicolon] = ACTIONS(5313),
    [sym__raw_string_literal] = ACTIONS(5313),
    [sym__external_open_parenthesis] = ACTIONS(6531),
    [sym__external_close_parenthesis] = ACTIONS(5313),
    [sym__external_open_brace] = ACTIONS(5313),
    [sym__external_open_bracket] = ACTIONS(6533),
    [sym__external_open_bracket2] = ACTIONS(6535),
  },
  [1355] = {
    [sym_call_arguments] = STATE(2840),
    [sym_subset_arguments] = STATE(2797),
    [sym_subset2_arguments] = STATE(2801),
    [sym__open_parenthesis] = STATE(1344),
    [sym__open_bracket] = STATE(1374),
    [sym__open_bracket2] = STATE(1452),
    [ts_builtin_sym_end] = ACTIONS(5341),
    [sym_identifier] = ACTIONS(5343),
    [anon_sym_BSLASH] = ACTIONS(5341),
    [anon_sym_function] = ACTIONS(5343),
    [anon_sym_EQ] = ACTIONS(6263),
    [anon_sym_if] = ACTIONS(5343),
    [anon_sym_for] = ACTIONS(5343),
    [anon_sym_while] = ACTIONS(5343),
    [anon_sym_repeat] = ACTIONS(5343),
    [anon_sym_QMARK] = ACTIONS(5341),
    [anon_sym_TILDE] = ACTIONS(6265),
    [anon_sym_BANG] = ACTIONS(5343),
    [anon_sym_PLUS] = ACTIONS(6267),
    [anon_sym_DASH] = ACTIONS(6269),
    [anon_sym_LT_DASH] = ACTIONS(6271),
    [anon_sym_LT_LT_DASH] = ACTIONS(6271),
    [anon_sym_COLON_EQ] = ACTIONS(6271),
    [anon_sym_DASH_GT] = ACTIONS(6273),
    [anon_sym_DASH_GT_GT] = ACTIONS(6275),
    [anon_sym_PIPE] = ACTIONS(6277),
    [anon_sym_AMP] = ACTIONS(6279),
    [anon_sym_PIPE_PIPE] = ACTIONS(6281),
    [anon_sym_AMP_AMP] = ACTIONS(6283),
    [anon_sym_LT] = ACTIONS(6285),
    [anon_sym_LT_EQ] = ACTIONS(6287),
    [anon_sym_GT] = ACTIONS(6285),
    [anon_sym_GT_EQ] = ACTIONS(6287),
    [anon_sym_EQ_EQ] = ACTIONS(6287),
    [anon_sym_BANG_EQ] = ACTIONS(6287),
    [anon_sym_STAR] = ACTIONS(6289),
    [anon_sym_SLASH] = ACTIONS(6291),
    [anon_sym_STAR_STAR] = ACTIONS(6293),
    [anon_sym_CARET] = ACTIONS(6293),
    [aux_sym_binary_operator_token1] = ACTIONS(6295),
    [anon_sym_PIPE_GT] = ACTIONS(6295),
    [anon_sym_COLON] = ACTIONS(6297),
    [anon_sym_DOLLAR] = ACTIONS(6299),
    [anon_sym_AT] = ACTIONS(6299),
    [aux_sym__hex_literal_token1] = ACTIONS(5341),
    [sym__number_literal] = ACTIONS(5343),
    [anon_sym_SQUOTE] = ACTIONS(5341),
    [anon_sym_DQUOTE] = ACTIONS(5341),
    [sym_return] = ACTIONS(5343),
    [sym_next] = ACTIONS(5343),
    [sym_break] = ACTIONS(5343),
    [sym_true] = ACTIONS(5343),
    [sym_false] = ACTIONS(5343),
    [sym_null] = ACTIONS(5343),
    [sym_inf] = ACTIONS(5343),
    [sym_nan] = ACTIONS(5343),
    [anon_sym_NA] = ACTIONS(5343),
    [anon_sym_NA_integer_] = ACTIONS(5343),
    [anon_sym_NA_real_] = ACTIONS(5343),
    [anon_sym_NA_complex_] = ACTIONS(5343),
    [anon_sym_NA_character_] = ACTIONS(5343),
    [sym_dots] = ACTIONS(5343),
    [sym_dot_dot_i] = ACTIONS(5341),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5341),
    [sym__semicolon] = ACTIONS(5341),
    [sym__raw_string_literal] = ACTIONS(5341),
    [sym__external_open_parenthesis] = ACTIONS(6301),
    [sym__external_open_brace] = ACTIONS(5341),
    [sym__external_close_brace] = ACTIONS(5341),
    [sym__external_open_bracket] = ACTIONS(6303),
    [sym__external_open_bracket2] = ACTIONS(6305),
  },
  [1356] = {
    [sym_call_arguments] = STATE(2840),
    [sym_subset_arguments] = STATE(2797),
    [sym_subset2_arguments] = STATE(2801),
    [sym__open_parenthesis] = STATE(1344),
    [sym__open_bracket] = STATE(1374),
    [sym__open_bracket2] = STATE(1452),
    [ts_builtin_sym_end] = ACTIONS(5345),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(6263),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(6265),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(6267),
    [anon_sym_DASH] = ACTIONS(6269),
    [anon_sym_LT_DASH] = ACTIONS(6271),
    [anon_sym_LT_LT_DASH] = ACTIONS(6271),
    [anon_sym_COLON_EQ] = ACTIONS(6271),
    [anon_sym_DASH_GT] = ACTIONS(6273),
    [anon_sym_DASH_GT_GT] = ACTIONS(6275),
    [anon_sym_PIPE] = ACTIONS(6277),
    [anon_sym_AMP] = ACTIONS(6279),
    [anon_sym_PIPE_PIPE] = ACTIONS(6281),
    [anon_sym_AMP_AMP] = ACTIONS(6283),
    [anon_sym_LT] = ACTIONS(6285),
    [anon_sym_LT_EQ] = ACTIONS(6287),
    [anon_sym_GT] = ACTIONS(6285),
    [anon_sym_GT_EQ] = ACTIONS(6287),
    [anon_sym_EQ_EQ] = ACTIONS(6287),
    [anon_sym_BANG_EQ] = ACTIONS(6287),
    [anon_sym_STAR] = ACTIONS(6289),
    [anon_sym_SLASH] = ACTIONS(6291),
    [anon_sym_STAR_STAR] = ACTIONS(6293),
    [anon_sym_CARET] = ACTIONS(6293),
    [aux_sym_binary_operator_token1] = ACTIONS(6295),
    [anon_sym_PIPE_GT] = ACTIONS(6295),
    [anon_sym_COLON] = ACTIONS(6297),
    [anon_sym_DOLLAR] = ACTIONS(6299),
    [anon_sym_AT] = ACTIONS(6299),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5345),
    [sym__semicolon] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(6301),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_close_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(6303),
    [sym__external_open_bracket2] = ACTIONS(6305),
  },
  [1357] = {
    [sym_function_definition] = STATE(1931),
    [sym_if_statement] = STATE(1931),
    [sym_for_statement] = STATE(1931),
    [sym_while_statement] = STATE(1931),
    [sym_repeat_statement] = STATE(1931),
    [sym_braced_expression] = STATE(1931),
    [sym_parenthesized_expression] = STATE(1931),
    [sym_call] = STATE(1931),
    [sym_subset] = STATE(1931),
    [sym_subset2] = STATE(1931),
    [sym__argument] = STATE(4656),
    [sym_argument] = STATE(4657),
    [sym__argument_named] = STATE(4658),
    [sym__argument_unnamed] = STATE(4662),
    [sym__argument_value] = STATE(4663),
    [sym_unary_operator] = STATE(1931),
    [sym_binary_operator] = STATE(1931),
    [sym_extract_operator] = STATE(1931),
    [sym_namespace_operator] = STATE(1931),
    [sym_integer] = STATE(1931),
    [sym_complex] = STATE(1931),
    [sym_float] = STATE(1931),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2633),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(1931),
    [sym__expression] = STATE(1931),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__close_parenthesis] = STATE(2716),
    [sym__open_brace] = STATE(154),
    [aux_sym_call_arguments_repeat1] = STATE(1368),
    [sym_identifier] = ACTIONS(6387),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(6389),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3865),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(6391),
    [sym_next] = ACTIONS(6391),
    [sym_break] = ACTIONS(6391),
    [sym_true] = ACTIONS(6391),
    [sym_false] = ACTIONS(6391),
    [sym_null] = ACTIONS(6391),
    [sym_inf] = ACTIONS(6391),
    [sym_nan] = ACTIONS(6391),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(6393),
    [sym_dot_dot_i] = ACTIONS(6395),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6397),
    [sym__newline] = ACTIONS(6399),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(6537),
    [sym__external_open_brace] = ACTIONS(3891),
  },
  [1358] = {
    [sym_call_arguments] = STATE(2840),
    [sym_subset_arguments] = STATE(2797),
    [sym_subset2_arguments] = STATE(2801),
    [sym__open_parenthesis] = STATE(1344),
    [sym__open_bracket] = STATE(1374),
    [sym__open_bracket2] = STATE(1452),
    [ts_builtin_sym_end] = ACTIONS(5345),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(6267),
    [anon_sym_DASH] = ACTIONS(6269),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(6277),
    [anon_sym_AMP] = ACTIONS(6279),
    [anon_sym_PIPE_PIPE] = ACTIONS(6281),
    [anon_sym_AMP_AMP] = ACTIONS(6283),
    [anon_sym_LT] = ACTIONS(6285),
    [anon_sym_LT_EQ] = ACTIONS(6287),
    [anon_sym_GT] = ACTIONS(6285),
    [anon_sym_GT_EQ] = ACTIONS(6287),
    [anon_sym_EQ_EQ] = ACTIONS(6287),
    [anon_sym_BANG_EQ] = ACTIONS(6287),
    [anon_sym_STAR] = ACTIONS(6289),
    [anon_sym_SLASH] = ACTIONS(6291),
    [anon_sym_STAR_STAR] = ACTIONS(6293),
    [anon_sym_CARET] = ACTIONS(6293),
    [aux_sym_binary_operator_token1] = ACTIONS(6295),
    [anon_sym_PIPE_GT] = ACTIONS(6295),
    [anon_sym_COLON] = ACTIONS(6297),
    [anon_sym_DOLLAR] = ACTIONS(6299),
    [anon_sym_AT] = ACTIONS(6299),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5345),
    [sym__semicolon] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(6301),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_close_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(6303),
    [sym__external_open_bracket2] = ACTIONS(6305),
  },
  [1359] = {
    [sym_function_definition] = STATE(1931),
    [sym_if_statement] = STATE(1931),
    [sym_for_statement] = STATE(1931),
    [sym_while_statement] = STATE(1931),
    [sym_repeat_statement] = STATE(1931),
    [sym_braced_expression] = STATE(1931),
    [sym_parenthesized_expression] = STATE(1931),
    [sym_call] = STATE(1931),
    [sym_subset] = STATE(1931),
    [sym_subset2] = STATE(1931),
    [sym__argument] = STATE(4656),
    [sym_argument] = STATE(4657),
    [sym__argument_named] = STATE(4658),
    [sym__argument_unnamed] = STATE(4662),
    [sym__argument_value] = STATE(4663),
    [sym_unary_operator] = STATE(1931),
    [sym_binary_operator] = STATE(1931),
    [sym_extract_operator] = STATE(1931),
    [sym_namespace_operator] = STATE(1931),
    [sym_integer] = STATE(1931),
    [sym_complex] = STATE(1931),
    [sym_float] = STATE(1931),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2633),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(1931),
    [sym__expression] = STATE(1931),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__close_parenthesis] = STATE(2601),
    [sym__open_brace] = STATE(154),
    [aux_sym_call_arguments_repeat1] = STATE(2113),
    [sym_identifier] = ACTIONS(6387),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(6389),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3865),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(6391),
    [sym_next] = ACTIONS(6391),
    [sym_break] = ACTIONS(6391),
    [sym_true] = ACTIONS(6391),
    [sym_false] = ACTIONS(6391),
    [sym_null] = ACTIONS(6391),
    [sym_inf] = ACTIONS(6391),
    [sym_nan] = ACTIONS(6391),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(6393),
    [sym_dot_dot_i] = ACTIONS(6395),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6397),
    [sym__newline] = ACTIONS(6399),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(6539),
    [sym__external_open_brace] = ACTIONS(3891),
  },
  [1360] = {
    [sym_function_definition] = STATE(1940),
    [sym_if_statement] = STATE(1940),
    [sym_for_statement] = STATE(1940),
    [sym_while_statement] = STATE(1940),
    [sym_repeat_statement] = STATE(1940),
    [sym_braced_expression] = STATE(1940),
    [sym_parenthesized_expression] = STATE(1940),
    [sym_call] = STATE(1940),
    [sym_subset] = STATE(1940),
    [sym_subset2] = STATE(1940),
    [sym__argument] = STATE(4665),
    [sym_argument] = STATE(4661),
    [sym__argument_named] = STATE(4669),
    [sym__argument_unnamed] = STATE(4673),
    [sym__argument_value] = STATE(4679),
    [sym_unary_operator] = STATE(1940),
    [sym_binary_operator] = STATE(1940),
    [sym_extract_operator] = STATE(1940),
    [sym_namespace_operator] = STATE(1940),
    [sym_integer] = STATE(1940),
    [sym_complex] = STATE(1940),
    [sym_float] = STATE(1940),
    [sym__hex_literal] = STATE(2656),
    [sym__float_literal] = STATE(2656),
    [sym_string] = STATE(2606),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym_na] = STATE(1940),
    [sym__expression] = STATE(1940),
    [sym__string_or_identifier] = STATE(5141),
    [sym__open_parenthesis] = STATE(218),
    [sym__open_brace] = STATE(185),
    [sym__close_bracket2] = STATE(2812),
    [aux_sym_call_arguments_repeat1] = STATE(1503),
    [sym_identifier] = ACTIONS(6369),
    [anon_sym_BSLASH] = ACTIONS(4644),
    [anon_sym_function] = ACTIONS(4646),
    [anon_sym_if] = ACTIONS(4648),
    [anon_sym_for] = ACTIONS(4650),
    [anon_sym_while] = ACTIONS(4652),
    [anon_sym_repeat] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(6371),
    [anon_sym_PLUS] = ACTIONS(4662),
    [anon_sym_DASH] = ACTIONS(4662),
    [aux_sym__hex_literal_token1] = ACTIONS(4666),
    [sym__number_literal] = ACTIONS(4668),
    [anon_sym_SQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4672),
    [sym_return] = ACTIONS(6373),
    [sym_next] = ACTIONS(6373),
    [sym_break] = ACTIONS(6373),
    [sym_true] = ACTIONS(6373),
    [sym_false] = ACTIONS(6373),
    [sym_null] = ACTIONS(6373),
    [sym_inf] = ACTIONS(6373),
    [sym_nan] = ACTIONS(6373),
    [anon_sym_NA] = ACTIONS(4676),
    [anon_sym_NA_integer_] = ACTIONS(4676),
    [anon_sym_NA_real_] = ACTIONS(4676),
    [anon_sym_NA_complex_] = ACTIONS(4676),
    [anon_sym_NA_character_] = ACTIONS(4676),
    [sym_dots] = ACTIONS(6375),
    [sym_dot_dot_i] = ACTIONS(6377),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6379),
    [sym__newline] = ACTIONS(6381),
    [sym__raw_string_literal] = ACTIONS(4680),
    [sym__external_open_parenthesis] = ACTIONS(4682),
    [sym__external_open_brace] = ACTIONS(4684),
    [sym__external_close_bracket2] = ACTIONS(6541),
  },
  [1361] = {
    [sym_function_definition] = STATE(2038),
    [sym_if_statement] = STATE(2038),
    [sym_for_statement] = STATE(2038),
    [sym_while_statement] = STATE(2038),
    [sym_repeat_statement] = STATE(2038),
    [sym_braced_expression] = STATE(2038),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_call] = STATE(2038),
    [sym_subset] = STATE(2038),
    [sym_subset2] = STATE(2038),
    [sym__argument] = STATE(4664),
    [sym_argument] = STATE(4659),
    [sym__argument_named] = STATE(4654),
    [sym__argument_unnamed] = STATE(4676),
    [sym__argument_value] = STATE(4677),
    [sym_unary_operator] = STATE(2038),
    [sym_binary_operator] = STATE(2038),
    [sym_extract_operator] = STATE(2038),
    [sym_namespace_operator] = STATE(2038),
    [sym_integer] = STATE(2038),
    [sym_complex] = STATE(2038),
    [sym_float] = STATE(2038),
    [sym__hex_literal] = STATE(2700),
    [sym__float_literal] = STATE(2700),
    [sym_string] = STATE(2597),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym_na] = STATE(2038),
    [sym__expression] = STATE(2038),
    [sym__string_or_identifier] = STATE(5148),
    [sym__open_parenthesis] = STATE(214),
    [sym__open_brace] = STATE(192),
    [sym__close_bracket] = STATE(2819),
    [aux_sym_call_arguments_repeat1] = STATE(1504),
    [sym_identifier] = ACTIONS(6351),
    [anon_sym_BSLASH] = ACTIONS(4754),
    [anon_sym_function] = ACTIONS(4756),
    [anon_sym_if] = ACTIONS(4758),
    [anon_sym_for] = ACTIONS(4760),
    [anon_sym_while] = ACTIONS(4762),
    [anon_sym_repeat] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4766),
    [anon_sym_TILDE] = ACTIONS(4768),
    [anon_sym_BANG] = ACTIONS(6353),
    [anon_sym_PLUS] = ACTIONS(4772),
    [anon_sym_DASH] = ACTIONS(4772),
    [aux_sym__hex_literal_token1] = ACTIONS(4776),
    [sym__number_literal] = ACTIONS(4778),
    [anon_sym_SQUOTE] = ACTIONS(4780),
    [anon_sym_DQUOTE] = ACTIONS(4782),
    [sym_return] = ACTIONS(6355),
    [sym_next] = ACTIONS(6355),
    [sym_break] = ACTIONS(6355),
    [sym_true] = ACTIONS(6355),
    [sym_false] = ACTIONS(6355),
    [sym_null] = ACTIONS(6355),
    [sym_inf] = ACTIONS(6355),
    [sym_nan] = ACTIONS(6355),
    [anon_sym_NA] = ACTIONS(4786),
    [anon_sym_NA_integer_] = ACTIONS(4786),
    [anon_sym_NA_real_] = ACTIONS(4786),
    [anon_sym_NA_complex_] = ACTIONS(4786),
    [anon_sym_NA_character_] = ACTIONS(4786),
    [sym_dots] = ACTIONS(6357),
    [sym_dot_dot_i] = ACTIONS(6359),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6361),
    [sym__newline] = ACTIONS(6363),
    [sym__raw_string_literal] = ACTIONS(4790),
    [sym__external_open_parenthesis] = ACTIONS(4792),
    [sym__external_open_brace] = ACTIONS(4794),
    [sym__external_close_bracket] = ACTIONS(6543),
  },
  [1362] = {
    [sym_function_definition] = STATE(1931),
    [sym_if_statement] = STATE(1931),
    [sym_for_statement] = STATE(1931),
    [sym_while_statement] = STATE(1931),
    [sym_repeat_statement] = STATE(1931),
    [sym_braced_expression] = STATE(1931),
    [sym_parenthesized_expression] = STATE(1931),
    [sym_call] = STATE(1931),
    [sym_subset] = STATE(1931),
    [sym_subset2] = STATE(1931),
    [sym__argument] = STATE(4656),
    [sym_argument] = STATE(4657),
    [sym__argument_named] = STATE(4658),
    [sym__argument_unnamed] = STATE(4662),
    [sym__argument_value] = STATE(4663),
    [sym_unary_operator] = STATE(1931),
    [sym_binary_operator] = STATE(1931),
    [sym_extract_operator] = STATE(1931),
    [sym_namespace_operator] = STATE(1931),
    [sym_integer] = STATE(1931),
    [sym_complex] = STATE(1931),
    [sym_float] = STATE(1931),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2633),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(1931),
    [sym__expression] = STATE(1931),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__close_parenthesis] = STATE(2820),
    [sym__open_brace] = STATE(154),
    [aux_sym_call_arguments_repeat1] = STATE(1373),
    [sym_identifier] = ACTIONS(6387),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(6389),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3865),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(6391),
    [sym_next] = ACTIONS(6391),
    [sym_break] = ACTIONS(6391),
    [sym_true] = ACTIONS(6391),
    [sym_false] = ACTIONS(6391),
    [sym_null] = ACTIONS(6391),
    [sym_inf] = ACTIONS(6391),
    [sym_nan] = ACTIONS(6391),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(6393),
    [sym_dot_dot_i] = ACTIONS(6395),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6397),
    [sym__newline] = ACTIONS(6399),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(6545),
    [sym__external_open_brace] = ACTIONS(3891),
  },
  [1363] = {
    [sym_function_definition] = STATE(1931),
    [sym_if_statement] = STATE(1931),
    [sym_for_statement] = STATE(1931),
    [sym_while_statement] = STATE(1931),
    [sym_repeat_statement] = STATE(1931),
    [sym_braced_expression] = STATE(1931),
    [sym_parenthesized_expression] = STATE(1931),
    [sym_call] = STATE(1931),
    [sym_subset] = STATE(1931),
    [sym_subset2] = STATE(1931),
    [sym__argument] = STATE(4656),
    [sym_argument] = STATE(4657),
    [sym__argument_named] = STATE(4658),
    [sym__argument_unnamed] = STATE(4662),
    [sym__argument_value] = STATE(4663),
    [sym_unary_operator] = STATE(1931),
    [sym_binary_operator] = STATE(1931),
    [sym_extract_operator] = STATE(1931),
    [sym_namespace_operator] = STATE(1931),
    [sym_integer] = STATE(1931),
    [sym_complex] = STATE(1931),
    [sym_float] = STATE(1931),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2633),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(1931),
    [sym__expression] = STATE(1931),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__close_parenthesis] = STATE(2474),
    [sym__open_brace] = STATE(154),
    [aux_sym_call_arguments_repeat1] = STATE(2113),
    [sym_identifier] = ACTIONS(6387),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(6389),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3865),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(6391),
    [sym_next] = ACTIONS(6391),
    [sym_break] = ACTIONS(6391),
    [sym_true] = ACTIONS(6391),
    [sym_false] = ACTIONS(6391),
    [sym_null] = ACTIONS(6391),
    [sym_inf] = ACTIONS(6391),
    [sym_nan] = ACTIONS(6391),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(6393),
    [sym_dot_dot_i] = ACTIONS(6395),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6397),
    [sym__newline] = ACTIONS(6399),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(6547),
    [sym__external_open_brace] = ACTIONS(3891),
  },
  [1364] = {
    [sym_function_definition] = STATE(1940),
    [sym_if_statement] = STATE(1940),
    [sym_for_statement] = STATE(1940),
    [sym_while_statement] = STATE(1940),
    [sym_repeat_statement] = STATE(1940),
    [sym_braced_expression] = STATE(1940),
    [sym_parenthesized_expression] = STATE(1940),
    [sym_call] = STATE(1940),
    [sym_subset] = STATE(1940),
    [sym_subset2] = STATE(1940),
    [sym__argument] = STATE(4665),
    [sym_argument] = STATE(4661),
    [sym__argument_named] = STATE(4669),
    [sym__argument_unnamed] = STATE(4673),
    [sym__argument_value] = STATE(4679),
    [sym_unary_operator] = STATE(1940),
    [sym_binary_operator] = STATE(1940),
    [sym_extract_operator] = STATE(1940),
    [sym_namespace_operator] = STATE(1940),
    [sym_integer] = STATE(1940),
    [sym_complex] = STATE(1940),
    [sym_float] = STATE(1940),
    [sym__hex_literal] = STATE(2656),
    [sym__float_literal] = STATE(2656),
    [sym_string] = STATE(2606),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym_na] = STATE(1940),
    [sym__expression] = STATE(1940),
    [sym__string_or_identifier] = STATE(5141),
    [sym__open_parenthesis] = STATE(218),
    [sym__open_brace] = STATE(185),
    [sym__close_bracket2] = STATE(2863),
    [aux_sym_call_arguments_repeat1] = STATE(1622),
    [sym_identifier] = ACTIONS(6369),
    [anon_sym_BSLASH] = ACTIONS(4644),
    [anon_sym_function] = ACTIONS(4646),
    [anon_sym_if] = ACTIONS(4648),
    [anon_sym_for] = ACTIONS(4650),
    [anon_sym_while] = ACTIONS(4652),
    [anon_sym_repeat] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(6371),
    [anon_sym_PLUS] = ACTIONS(4662),
    [anon_sym_DASH] = ACTIONS(4662),
    [aux_sym__hex_literal_token1] = ACTIONS(4666),
    [sym__number_literal] = ACTIONS(4668),
    [anon_sym_SQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4672),
    [sym_return] = ACTIONS(6373),
    [sym_next] = ACTIONS(6373),
    [sym_break] = ACTIONS(6373),
    [sym_true] = ACTIONS(6373),
    [sym_false] = ACTIONS(6373),
    [sym_null] = ACTIONS(6373),
    [sym_inf] = ACTIONS(6373),
    [sym_nan] = ACTIONS(6373),
    [anon_sym_NA] = ACTIONS(4676),
    [anon_sym_NA_integer_] = ACTIONS(4676),
    [anon_sym_NA_real_] = ACTIONS(4676),
    [anon_sym_NA_complex_] = ACTIONS(4676),
    [anon_sym_NA_character_] = ACTIONS(4676),
    [sym_dots] = ACTIONS(6375),
    [sym_dot_dot_i] = ACTIONS(6377),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6379),
    [sym__newline] = ACTIONS(6381),
    [sym__raw_string_literal] = ACTIONS(4680),
    [sym__external_open_parenthesis] = ACTIONS(4682),
    [sym__external_open_brace] = ACTIONS(4684),
    [sym__external_close_bracket2] = ACTIONS(6549),
  },
  [1365] = {
    [sym_function_definition] = STATE(2038),
    [sym_if_statement] = STATE(2038),
    [sym_for_statement] = STATE(2038),
    [sym_while_statement] = STATE(2038),
    [sym_repeat_statement] = STATE(2038),
    [sym_braced_expression] = STATE(2038),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_call] = STATE(2038),
    [sym_subset] = STATE(2038),
    [sym_subset2] = STATE(2038),
    [sym__argument] = STATE(4664),
    [sym_argument] = STATE(4659),
    [sym__argument_named] = STATE(4654),
    [sym__argument_unnamed] = STATE(4676),
    [sym__argument_value] = STATE(4677),
    [sym_unary_operator] = STATE(2038),
    [sym_binary_operator] = STATE(2038),
    [sym_extract_operator] = STATE(2038),
    [sym_namespace_operator] = STATE(2038),
    [sym_integer] = STATE(2038),
    [sym_complex] = STATE(2038),
    [sym_float] = STATE(2038),
    [sym__hex_literal] = STATE(2700),
    [sym__float_literal] = STATE(2700),
    [sym_string] = STATE(2597),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym_na] = STATE(2038),
    [sym__expression] = STATE(2038),
    [sym__string_or_identifier] = STATE(5148),
    [sym__open_parenthesis] = STATE(214),
    [sym__open_brace] = STATE(192),
    [sym__close_bracket] = STATE(2860),
    [aux_sym_call_arguments_repeat1] = STATE(1625),
    [sym_identifier] = ACTIONS(6351),
    [anon_sym_BSLASH] = ACTIONS(4754),
    [anon_sym_function] = ACTIONS(4756),
    [anon_sym_if] = ACTIONS(4758),
    [anon_sym_for] = ACTIONS(4760),
    [anon_sym_while] = ACTIONS(4762),
    [anon_sym_repeat] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4766),
    [anon_sym_TILDE] = ACTIONS(4768),
    [anon_sym_BANG] = ACTIONS(6353),
    [anon_sym_PLUS] = ACTIONS(4772),
    [anon_sym_DASH] = ACTIONS(4772),
    [aux_sym__hex_literal_token1] = ACTIONS(4776),
    [sym__number_literal] = ACTIONS(4778),
    [anon_sym_SQUOTE] = ACTIONS(4780),
    [anon_sym_DQUOTE] = ACTIONS(4782),
    [sym_return] = ACTIONS(6355),
    [sym_next] = ACTIONS(6355),
    [sym_break] = ACTIONS(6355),
    [sym_true] = ACTIONS(6355),
    [sym_false] = ACTIONS(6355),
    [sym_null] = ACTIONS(6355),
    [sym_inf] = ACTIONS(6355),
    [sym_nan] = ACTIONS(6355),
    [anon_sym_NA] = ACTIONS(4786),
    [anon_sym_NA_integer_] = ACTIONS(4786),
    [anon_sym_NA_real_] = ACTIONS(4786),
    [anon_sym_NA_complex_] = ACTIONS(4786),
    [anon_sym_NA_character_] = ACTIONS(4786),
    [sym_dots] = ACTIONS(6357),
    [sym_dot_dot_i] = ACTIONS(6359),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6361),
    [sym__newline] = ACTIONS(6363),
    [sym__raw_string_literal] = ACTIONS(4790),
    [sym__external_open_parenthesis] = ACTIONS(4792),
    [sym__external_open_brace] = ACTIONS(4794),
    [sym__external_close_bracket] = ACTIONS(6551),
  },
  [1366] = {
    [sym_function_definition] = STATE(1931),
    [sym_if_statement] = STATE(1931),
    [sym_for_statement] = STATE(1931),
    [sym_while_statement] = STATE(1931),
    [sym_repeat_statement] = STATE(1931),
    [sym_braced_expression] = STATE(1931),
    [sym_parenthesized_expression] = STATE(1931),
    [sym_call] = STATE(1931),
    [sym_subset] = STATE(1931),
    [sym_subset2] = STATE(1931),
    [sym__argument] = STATE(4656),
    [sym_argument] = STATE(4657),
    [sym__argument_named] = STATE(4658),
    [sym__argument_unnamed] = STATE(4662),
    [sym__argument_value] = STATE(4663),
    [sym_unary_operator] = STATE(1931),
    [sym_binary_operator] = STATE(1931),
    [sym_extract_operator] = STATE(1931),
    [sym_namespace_operator] = STATE(1931),
    [sym_integer] = STATE(1931),
    [sym_complex] = STATE(1931),
    [sym_float] = STATE(1931),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2633),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(1931),
    [sym__expression] = STATE(1931),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__close_parenthesis] = STATE(2857),
    [sym__open_brace] = STATE(154),
    [aux_sym_call_arguments_repeat1] = STATE(1393),
    [sym_identifier] = ACTIONS(6387),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(6389),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3865),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(6391),
    [sym_next] = ACTIONS(6391),
    [sym_break] = ACTIONS(6391),
    [sym_true] = ACTIONS(6391),
    [sym_false] = ACTIONS(6391),
    [sym_null] = ACTIONS(6391),
    [sym_inf] = ACTIONS(6391),
    [sym_nan] = ACTIONS(6391),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(6393),
    [sym_dot_dot_i] = ACTIONS(6395),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6397),
    [sym__newline] = ACTIONS(6399),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(6553),
    [sym__external_open_brace] = ACTIONS(3891),
  },
  [1367] = {
    [sym_function_definition] = STATE(2038),
    [sym_if_statement] = STATE(2038),
    [sym_for_statement] = STATE(2038),
    [sym_while_statement] = STATE(2038),
    [sym_repeat_statement] = STATE(2038),
    [sym_braced_expression] = STATE(2038),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_call] = STATE(2038),
    [sym_subset] = STATE(2038),
    [sym_subset2] = STATE(2038),
    [sym__argument] = STATE(4664),
    [sym_argument] = STATE(4659),
    [sym__argument_named] = STATE(4654),
    [sym__argument_unnamed] = STATE(4676),
    [sym__argument_value] = STATE(4677),
    [sym_unary_operator] = STATE(2038),
    [sym_binary_operator] = STATE(2038),
    [sym_extract_operator] = STATE(2038),
    [sym_namespace_operator] = STATE(2038),
    [sym_integer] = STATE(2038),
    [sym_complex] = STATE(2038),
    [sym_float] = STATE(2038),
    [sym__hex_literal] = STATE(2700),
    [sym__float_literal] = STATE(2700),
    [sym_string] = STATE(2597),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym_na] = STATE(2038),
    [sym__expression] = STATE(2038),
    [sym__string_or_identifier] = STATE(5148),
    [sym__open_parenthesis] = STATE(214),
    [sym__open_brace] = STATE(192),
    [sym__close_bracket] = STATE(2475),
    [aux_sym_call_arguments_repeat1] = STATE(2034),
    [sym_identifier] = ACTIONS(6351),
    [anon_sym_BSLASH] = ACTIONS(4754),
    [anon_sym_function] = ACTIONS(4756),
    [anon_sym_if] = ACTIONS(4758),
    [anon_sym_for] = ACTIONS(4760),
    [anon_sym_while] = ACTIONS(4762),
    [anon_sym_repeat] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4766),
    [anon_sym_TILDE] = ACTIONS(4768),
    [anon_sym_BANG] = ACTIONS(6353),
    [anon_sym_PLUS] = ACTIONS(4772),
    [anon_sym_DASH] = ACTIONS(4772),
    [aux_sym__hex_literal_token1] = ACTIONS(4776),
    [sym__number_literal] = ACTIONS(4778),
    [anon_sym_SQUOTE] = ACTIONS(4780),
    [anon_sym_DQUOTE] = ACTIONS(4782),
    [sym_return] = ACTIONS(6355),
    [sym_next] = ACTIONS(6355),
    [sym_break] = ACTIONS(6355),
    [sym_true] = ACTIONS(6355),
    [sym_false] = ACTIONS(6355),
    [sym_null] = ACTIONS(6355),
    [sym_inf] = ACTIONS(6355),
    [sym_nan] = ACTIONS(6355),
    [anon_sym_NA] = ACTIONS(4786),
    [anon_sym_NA_integer_] = ACTIONS(4786),
    [anon_sym_NA_real_] = ACTIONS(4786),
    [anon_sym_NA_complex_] = ACTIONS(4786),
    [anon_sym_NA_character_] = ACTIONS(4786),
    [sym_dots] = ACTIONS(6357),
    [sym_dot_dot_i] = ACTIONS(6359),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6361),
    [sym__newline] = ACTIONS(6363),
    [sym__raw_string_literal] = ACTIONS(4790),
    [sym__external_open_parenthesis] = ACTIONS(4792),
    [sym__external_open_brace] = ACTIONS(4794),
    [sym__external_close_bracket] = ACTIONS(6555),
  },
  [1368] = {
    [sym_function_definition] = STATE(1931),
    [sym_if_statement] = STATE(1931),
    [sym_for_statement] = STATE(1931),
    [sym_while_statement] = STATE(1931),
    [sym_repeat_statement] = STATE(1931),
    [sym_braced_expression] = STATE(1931),
    [sym_parenthesized_expression] = STATE(1931),
    [sym_call] = STATE(1931),
    [sym_subset] = STATE(1931),
    [sym_subset2] = STATE(1931),
    [sym__argument] = STATE(4656),
    [sym_argument] = STATE(4657),
    [sym__argument_named] = STATE(4658),
    [sym__argument_unnamed] = STATE(4662),
    [sym__argument_value] = STATE(4663),
    [sym_unary_operator] = STATE(1931),
    [sym_binary_operator] = STATE(1931),
    [sym_extract_operator] = STATE(1931),
    [sym_namespace_operator] = STATE(1931),
    [sym_integer] = STATE(1931),
    [sym_complex] = STATE(1931),
    [sym_float] = STATE(1931),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2633),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(1931),
    [sym__expression] = STATE(1931),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__close_parenthesis] = STATE(2705),
    [sym__open_brace] = STATE(154),
    [aux_sym_call_arguments_repeat1] = STATE(2113),
    [sym_identifier] = ACTIONS(6387),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(6389),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3865),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(6391),
    [sym_next] = ACTIONS(6391),
    [sym_break] = ACTIONS(6391),
    [sym_true] = ACTIONS(6391),
    [sym_false] = ACTIONS(6391),
    [sym_null] = ACTIONS(6391),
    [sym_inf] = ACTIONS(6391),
    [sym_nan] = ACTIONS(6391),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(6393),
    [sym_dot_dot_i] = ACTIONS(6395),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6397),
    [sym__newline] = ACTIONS(6399),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(6557),
    [sym__external_open_brace] = ACTIONS(3891),
  },
  [1369] = {
    [sym_function_definition] = STATE(1940),
    [sym_if_statement] = STATE(1940),
    [sym_for_statement] = STATE(1940),
    [sym_while_statement] = STATE(1940),
    [sym_repeat_statement] = STATE(1940),
    [sym_braced_expression] = STATE(1940),
    [sym_parenthesized_expression] = STATE(1940),
    [sym_call] = STATE(1940),
    [sym_subset] = STATE(1940),
    [sym_subset2] = STATE(1940),
    [sym__argument] = STATE(4665),
    [sym_argument] = STATE(4661),
    [sym__argument_named] = STATE(4669),
    [sym__argument_unnamed] = STATE(4673),
    [sym__argument_value] = STATE(4679),
    [sym_unary_operator] = STATE(1940),
    [sym_binary_operator] = STATE(1940),
    [sym_extract_operator] = STATE(1940),
    [sym_namespace_operator] = STATE(1940),
    [sym_integer] = STATE(1940),
    [sym_complex] = STATE(1940),
    [sym_float] = STATE(1940),
    [sym__hex_literal] = STATE(2656),
    [sym__float_literal] = STATE(2656),
    [sym_string] = STATE(2606),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym_na] = STATE(1940),
    [sym__expression] = STATE(1940),
    [sym__string_or_identifier] = STATE(5141),
    [sym__open_parenthesis] = STATE(218),
    [sym__open_brace] = STATE(185),
    [sym__close_bracket2] = STATE(2476),
    [aux_sym_call_arguments_repeat1] = STATE(1912),
    [sym_identifier] = ACTIONS(6369),
    [anon_sym_BSLASH] = ACTIONS(4644),
    [anon_sym_function] = ACTIONS(4646),
    [anon_sym_if] = ACTIONS(4648),
    [anon_sym_for] = ACTIONS(4650),
    [anon_sym_while] = ACTIONS(4652),
    [anon_sym_repeat] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(6371),
    [anon_sym_PLUS] = ACTIONS(4662),
    [anon_sym_DASH] = ACTIONS(4662),
    [aux_sym__hex_literal_token1] = ACTIONS(4666),
    [sym__number_literal] = ACTIONS(4668),
    [anon_sym_SQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4672),
    [sym_return] = ACTIONS(6373),
    [sym_next] = ACTIONS(6373),
    [sym_break] = ACTIONS(6373),
    [sym_true] = ACTIONS(6373),
    [sym_false] = ACTIONS(6373),
    [sym_null] = ACTIONS(6373),
    [sym_inf] = ACTIONS(6373),
    [sym_nan] = ACTIONS(6373),
    [anon_sym_NA] = ACTIONS(4676),
    [anon_sym_NA_integer_] = ACTIONS(4676),
    [anon_sym_NA_real_] = ACTIONS(4676),
    [anon_sym_NA_complex_] = ACTIONS(4676),
    [anon_sym_NA_character_] = ACTIONS(4676),
    [sym_dots] = ACTIONS(6375),
    [sym_dot_dot_i] = ACTIONS(6377),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6379),
    [sym__newline] = ACTIONS(6381),
    [sym__raw_string_literal] = ACTIONS(4680),
    [sym__external_open_parenthesis] = ACTIONS(4682),
    [sym__external_open_brace] = ACTIONS(4684),
    [sym__external_close_bracket2] = ACTIONS(6559),
  },
  [1370] = {
    [sym_function_definition] = STATE(1940),
    [sym_if_statement] = STATE(1940),
    [sym_for_statement] = STATE(1940),
    [sym_while_statement] = STATE(1940),
    [sym_repeat_statement] = STATE(1940),
    [sym_braced_expression] = STATE(1940),
    [sym_parenthesized_expression] = STATE(1940),
    [sym_call] = STATE(1940),
    [sym_subset] = STATE(1940),
    [sym_subset2] = STATE(1940),
    [sym__argument] = STATE(4665),
    [sym_argument] = STATE(4661),
    [sym__argument_named] = STATE(4669),
    [sym__argument_unnamed] = STATE(4673),
    [sym__argument_value] = STATE(4679),
    [sym_unary_operator] = STATE(1940),
    [sym_binary_operator] = STATE(1940),
    [sym_extract_operator] = STATE(1940),
    [sym_namespace_operator] = STATE(1940),
    [sym_integer] = STATE(1940),
    [sym_complex] = STATE(1940),
    [sym_float] = STATE(1940),
    [sym__hex_literal] = STATE(2656),
    [sym__float_literal] = STATE(2656),
    [sym_string] = STATE(2606),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym_na] = STATE(1940),
    [sym__expression] = STATE(1940),
    [sym__string_or_identifier] = STATE(5141),
    [sym__open_parenthesis] = STATE(218),
    [sym__open_brace] = STATE(185),
    [sym__close_bracket2] = STATE(2766),
    [aux_sym_call_arguments_repeat1] = STATE(1723),
    [sym_identifier] = ACTIONS(6369),
    [anon_sym_BSLASH] = ACTIONS(4644),
    [anon_sym_function] = ACTIONS(4646),
    [anon_sym_if] = ACTIONS(4648),
    [anon_sym_for] = ACTIONS(4650),
    [anon_sym_while] = ACTIONS(4652),
    [anon_sym_repeat] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(6371),
    [anon_sym_PLUS] = ACTIONS(4662),
    [anon_sym_DASH] = ACTIONS(4662),
    [aux_sym__hex_literal_token1] = ACTIONS(4666),
    [sym__number_literal] = ACTIONS(4668),
    [anon_sym_SQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4672),
    [sym_return] = ACTIONS(6373),
    [sym_next] = ACTIONS(6373),
    [sym_break] = ACTIONS(6373),
    [sym_true] = ACTIONS(6373),
    [sym_false] = ACTIONS(6373),
    [sym_null] = ACTIONS(6373),
    [sym_inf] = ACTIONS(6373),
    [sym_nan] = ACTIONS(6373),
    [anon_sym_NA] = ACTIONS(4676),
    [anon_sym_NA_integer_] = ACTIONS(4676),
    [anon_sym_NA_real_] = ACTIONS(4676),
    [anon_sym_NA_complex_] = ACTIONS(4676),
    [anon_sym_NA_character_] = ACTIONS(4676),
    [sym_dots] = ACTIONS(6375),
    [sym_dot_dot_i] = ACTIONS(6377),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6379),
    [sym__newline] = ACTIONS(6381),
    [sym__raw_string_literal] = ACTIONS(4680),
    [sym__external_open_parenthesis] = ACTIONS(4682),
    [sym__external_open_brace] = ACTIONS(4684),
    [sym__external_close_bracket2] = ACTIONS(6561),
  },
  [1371] = {
    [sym_function_definition] = STATE(2038),
    [sym_if_statement] = STATE(2038),
    [sym_for_statement] = STATE(2038),
    [sym_while_statement] = STATE(2038),
    [sym_repeat_statement] = STATE(2038),
    [sym_braced_expression] = STATE(2038),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_call] = STATE(2038),
    [sym_subset] = STATE(2038),
    [sym_subset2] = STATE(2038),
    [sym__argument] = STATE(4664),
    [sym_argument] = STATE(4659),
    [sym__argument_named] = STATE(4654),
    [sym__argument_unnamed] = STATE(4676),
    [sym__argument_value] = STATE(4677),
    [sym_unary_operator] = STATE(2038),
    [sym_binary_operator] = STATE(2038),
    [sym_extract_operator] = STATE(2038),
    [sym_namespace_operator] = STATE(2038),
    [sym_integer] = STATE(2038),
    [sym_complex] = STATE(2038),
    [sym_float] = STATE(2038),
    [sym__hex_literal] = STATE(2700),
    [sym__float_literal] = STATE(2700),
    [sym_string] = STATE(2597),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym_na] = STATE(2038),
    [sym__expression] = STATE(2038),
    [sym__string_or_identifier] = STATE(5148),
    [sym__open_parenthesis] = STATE(214),
    [sym__open_brace] = STATE(192),
    [sym__close_bracket] = STATE(2784),
    [aux_sym_call_arguments_repeat1] = STATE(1724),
    [sym_identifier] = ACTIONS(6351),
    [anon_sym_BSLASH] = ACTIONS(4754),
    [anon_sym_function] = ACTIONS(4756),
    [anon_sym_if] = ACTIONS(4758),
    [anon_sym_for] = ACTIONS(4760),
    [anon_sym_while] = ACTIONS(4762),
    [anon_sym_repeat] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4766),
    [anon_sym_TILDE] = ACTIONS(4768),
    [anon_sym_BANG] = ACTIONS(6353),
    [anon_sym_PLUS] = ACTIONS(4772),
    [anon_sym_DASH] = ACTIONS(4772),
    [aux_sym__hex_literal_token1] = ACTIONS(4776),
    [sym__number_literal] = ACTIONS(4778),
    [anon_sym_SQUOTE] = ACTIONS(4780),
    [anon_sym_DQUOTE] = ACTIONS(4782),
    [sym_return] = ACTIONS(6355),
    [sym_next] = ACTIONS(6355),
    [sym_break] = ACTIONS(6355),
    [sym_true] = ACTIONS(6355),
    [sym_false] = ACTIONS(6355),
    [sym_null] = ACTIONS(6355),
    [sym_inf] = ACTIONS(6355),
    [sym_nan] = ACTIONS(6355),
    [anon_sym_NA] = ACTIONS(4786),
    [anon_sym_NA_integer_] = ACTIONS(4786),
    [anon_sym_NA_real_] = ACTIONS(4786),
    [anon_sym_NA_complex_] = ACTIONS(4786),
    [anon_sym_NA_character_] = ACTIONS(4786),
    [sym_dots] = ACTIONS(6357),
    [sym_dot_dot_i] = ACTIONS(6359),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6361),
    [sym__newline] = ACTIONS(6363),
    [sym__raw_string_literal] = ACTIONS(4790),
    [sym__external_open_parenthesis] = ACTIONS(4792),
    [sym__external_open_brace] = ACTIONS(4794),
    [sym__external_close_bracket] = ACTIONS(6563),
  },
  [1372] = {
    [sym_function_definition] = STATE(1931),
    [sym_if_statement] = STATE(1931),
    [sym_for_statement] = STATE(1931),
    [sym_while_statement] = STATE(1931),
    [sym_repeat_statement] = STATE(1931),
    [sym_braced_expression] = STATE(1931),
    [sym_parenthesized_expression] = STATE(1931),
    [sym_call] = STATE(1931),
    [sym_subset] = STATE(1931),
    [sym_subset2] = STATE(1931),
    [sym__argument] = STATE(4656),
    [sym_argument] = STATE(4657),
    [sym__argument_named] = STATE(4658),
    [sym__argument_unnamed] = STATE(4662),
    [sym__argument_value] = STATE(4663),
    [sym_unary_operator] = STATE(1931),
    [sym_binary_operator] = STATE(1931),
    [sym_extract_operator] = STATE(1931),
    [sym_namespace_operator] = STATE(1931),
    [sym_integer] = STATE(1931),
    [sym_complex] = STATE(1931),
    [sym_float] = STATE(1931),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2633),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(1931),
    [sym__expression] = STATE(1931),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__close_parenthesis] = STATE(2782),
    [sym__open_brace] = STATE(154),
    [aux_sym_call_arguments_repeat1] = STATE(1401),
    [sym_identifier] = ACTIONS(6387),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(6389),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3865),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(6391),
    [sym_next] = ACTIONS(6391),
    [sym_break] = ACTIONS(6391),
    [sym_true] = ACTIONS(6391),
    [sym_false] = ACTIONS(6391),
    [sym_null] = ACTIONS(6391),
    [sym_inf] = ACTIONS(6391),
    [sym_nan] = ACTIONS(6391),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(6393),
    [sym_dot_dot_i] = ACTIONS(6395),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6397),
    [sym__newline] = ACTIONS(6399),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(6565),
    [sym__external_open_brace] = ACTIONS(3891),
  },
  [1373] = {
    [sym_function_definition] = STATE(1931),
    [sym_if_statement] = STATE(1931),
    [sym_for_statement] = STATE(1931),
    [sym_while_statement] = STATE(1931),
    [sym_repeat_statement] = STATE(1931),
    [sym_braced_expression] = STATE(1931),
    [sym_parenthesized_expression] = STATE(1931),
    [sym_call] = STATE(1931),
    [sym_subset] = STATE(1931),
    [sym_subset2] = STATE(1931),
    [sym__argument] = STATE(4656),
    [sym_argument] = STATE(4657),
    [sym__argument_named] = STATE(4658),
    [sym__argument_unnamed] = STATE(4662),
    [sym__argument_value] = STATE(4663),
    [sym_unary_operator] = STATE(1931),
    [sym_binary_operator] = STATE(1931),
    [sym_extract_operator] = STATE(1931),
    [sym_namespace_operator] = STATE(1931),
    [sym_integer] = STATE(1931),
    [sym_complex] = STATE(1931),
    [sym_float] = STATE(1931),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2633),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(1931),
    [sym__expression] = STATE(1931),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__close_parenthesis] = STATE(2796),
    [sym__open_brace] = STATE(154),
    [aux_sym_call_arguments_repeat1] = STATE(2113),
    [sym_identifier] = ACTIONS(6387),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(6389),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3865),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(6391),
    [sym_next] = ACTIONS(6391),
    [sym_break] = ACTIONS(6391),
    [sym_true] = ACTIONS(6391),
    [sym_false] = ACTIONS(6391),
    [sym_null] = ACTIONS(6391),
    [sym_inf] = ACTIONS(6391),
    [sym_nan] = ACTIONS(6391),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(6393),
    [sym_dot_dot_i] = ACTIONS(6395),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6397),
    [sym__newline] = ACTIONS(6399),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(6567),
    [sym__external_open_brace] = ACTIONS(3891),
  },
  [1374] = {
    [sym_function_definition] = STATE(2038),
    [sym_if_statement] = STATE(2038),
    [sym_for_statement] = STATE(2038),
    [sym_while_statement] = STATE(2038),
    [sym_repeat_statement] = STATE(2038),
    [sym_braced_expression] = STATE(2038),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_call] = STATE(2038),
    [sym_subset] = STATE(2038),
    [sym_subset2] = STATE(2038),
    [sym__argument] = STATE(4664),
    [sym_argument] = STATE(4659),
    [sym__argument_named] = STATE(4654),
    [sym__argument_unnamed] = STATE(4676),
    [sym__argument_value] = STATE(4677),
    [sym_unary_operator] = STATE(2038),
    [sym_binary_operator] = STATE(2038),
    [sym_extract_operator] = STATE(2038),
    [sym_namespace_operator] = STATE(2038),
    [sym_integer] = STATE(2038),
    [sym_complex] = STATE(2038),
    [sym_float] = STATE(2038),
    [sym__hex_literal] = STATE(2700),
    [sym__float_literal] = STATE(2700),
    [sym_string] = STATE(2597),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym_na] = STATE(2038),
    [sym__expression] = STATE(2038),
    [sym__string_or_identifier] = STATE(5148),
    [sym__open_parenthesis] = STATE(214),
    [sym__open_brace] = STATE(192),
    [sym__close_bracket] = STATE(2909),
    [aux_sym_call_arguments_repeat1] = STATE(1876),
    [sym_identifier] = ACTIONS(6351),
    [anon_sym_BSLASH] = ACTIONS(4754),
    [anon_sym_function] = ACTIONS(4756),
    [anon_sym_if] = ACTIONS(4758),
    [anon_sym_for] = ACTIONS(4760),
    [anon_sym_while] = ACTIONS(4762),
    [anon_sym_repeat] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4766),
    [anon_sym_TILDE] = ACTIONS(4768),
    [anon_sym_BANG] = ACTIONS(6353),
    [anon_sym_PLUS] = ACTIONS(4772),
    [anon_sym_DASH] = ACTIONS(4772),
    [aux_sym__hex_literal_token1] = ACTIONS(4776),
    [sym__number_literal] = ACTIONS(4778),
    [anon_sym_SQUOTE] = ACTIONS(4780),
    [anon_sym_DQUOTE] = ACTIONS(4782),
    [sym_return] = ACTIONS(6355),
    [sym_next] = ACTIONS(6355),
    [sym_break] = ACTIONS(6355),
    [sym_true] = ACTIONS(6355),
    [sym_false] = ACTIONS(6355),
    [sym_null] = ACTIONS(6355),
    [sym_inf] = ACTIONS(6355),
    [sym_nan] = ACTIONS(6355),
    [anon_sym_NA] = ACTIONS(4786),
    [anon_sym_NA_integer_] = ACTIONS(4786),
    [anon_sym_NA_real_] = ACTIONS(4786),
    [anon_sym_NA_complex_] = ACTIONS(4786),
    [anon_sym_NA_character_] = ACTIONS(4786),
    [sym_dots] = ACTIONS(6357),
    [sym_dot_dot_i] = ACTIONS(6359),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6361),
    [sym__newline] = ACTIONS(6363),
    [sym__raw_string_literal] = ACTIONS(4790),
    [sym__external_open_parenthesis] = ACTIONS(4792),
    [sym__external_open_brace] = ACTIONS(4794),
    [sym__external_close_bracket] = ACTIONS(6569),
  },
  [1375] = {
    [sym_function_definition] = STATE(1931),
    [sym_if_statement] = STATE(1931),
    [sym_for_statement] = STATE(1931),
    [sym_while_statement] = STATE(1931),
    [sym_repeat_statement] = STATE(1931),
    [sym_braced_expression] = STATE(1931),
    [sym_parenthesized_expression] = STATE(1931),
    [sym_call] = STATE(1931),
    [sym_subset] = STATE(1931),
    [sym_subset2] = STATE(1931),
    [sym__argument] = STATE(4656),
    [sym_argument] = STATE(4657),
    [sym__argument_named] = STATE(4658),
    [sym__argument_unnamed] = STATE(4662),
    [sym__argument_value] = STATE(4663),
    [sym_unary_operator] = STATE(1931),
    [sym_binary_operator] = STATE(1931),
    [sym_extract_operator] = STATE(1931),
    [sym_namespace_operator] = STATE(1931),
    [sym_integer] = STATE(1931),
    [sym_complex] = STATE(1931),
    [sym_float] = STATE(1931),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2633),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(1931),
    [sym__expression] = STATE(1931),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__close_parenthesis] = STATE(3019),
    [sym__open_brace] = STATE(154),
    [aux_sym_call_arguments_repeat1] = STATE(2113),
    [sym_identifier] = ACTIONS(6387),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(6389),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3865),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(6391),
    [sym_next] = ACTIONS(6391),
    [sym_break] = ACTIONS(6391),
    [sym_true] = ACTIONS(6391),
    [sym_false] = ACTIONS(6391),
    [sym_null] = ACTIONS(6391),
    [sym_inf] = ACTIONS(6391),
    [sym_nan] = ACTIONS(6391),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(6393),
    [sym_dot_dot_i] = ACTIONS(6395),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6397),
    [sym__newline] = ACTIONS(6399),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(6571),
    [sym__external_open_brace] = ACTIONS(3891),
  },
  [1376] = {
    [sym_call_arguments] = STATE(2840),
    [sym_subset_arguments] = STATE(2797),
    [sym_subset2_arguments] = STATE(2801),
    [sym__open_parenthesis] = STATE(1344),
    [sym__open_bracket] = STATE(1374),
    [sym__open_bracket2] = STATE(1452),
    [ts_builtin_sym_end] = ACTIONS(5433),
    [sym_identifier] = ACTIONS(5435),
    [anon_sym_BSLASH] = ACTIONS(5433),
    [anon_sym_function] = ACTIONS(5435),
    [anon_sym_EQ] = ACTIONS(6263),
    [anon_sym_if] = ACTIONS(5435),
    [anon_sym_for] = ACTIONS(5435),
    [anon_sym_while] = ACTIONS(5435),
    [anon_sym_repeat] = ACTIONS(5435),
    [anon_sym_QMARK] = ACTIONS(5433),
    [anon_sym_TILDE] = ACTIONS(6265),
    [anon_sym_BANG] = ACTIONS(5435),
    [anon_sym_PLUS] = ACTIONS(6267),
    [anon_sym_DASH] = ACTIONS(6269),
    [anon_sym_LT_DASH] = ACTIONS(6271),
    [anon_sym_LT_LT_DASH] = ACTIONS(6271),
    [anon_sym_COLON_EQ] = ACTIONS(6271),
    [anon_sym_DASH_GT] = ACTIONS(6273),
    [anon_sym_DASH_GT_GT] = ACTIONS(6275),
    [anon_sym_PIPE] = ACTIONS(6277),
    [anon_sym_AMP] = ACTIONS(6279),
    [anon_sym_PIPE_PIPE] = ACTIONS(6281),
    [anon_sym_AMP_AMP] = ACTIONS(6283),
    [anon_sym_LT] = ACTIONS(6285),
    [anon_sym_LT_EQ] = ACTIONS(6287),
    [anon_sym_GT] = ACTIONS(6285),
    [anon_sym_GT_EQ] = ACTIONS(6287),
    [anon_sym_EQ_EQ] = ACTIONS(6287),
    [anon_sym_BANG_EQ] = ACTIONS(6287),
    [anon_sym_STAR] = ACTIONS(6289),
    [anon_sym_SLASH] = ACTIONS(6291),
    [anon_sym_STAR_STAR] = ACTIONS(6293),
    [anon_sym_CARET] = ACTIONS(6293),
    [aux_sym_binary_operator_token1] = ACTIONS(6295),
    [anon_sym_PIPE_GT] = ACTIONS(6295),
    [anon_sym_COLON] = ACTIONS(6297),
    [anon_sym_DOLLAR] = ACTIONS(6299),
    [anon_sym_AT] = ACTIONS(6299),
    [aux_sym__hex_literal_token1] = ACTIONS(5433),
    [sym__number_literal] = ACTIONS(5435),
    [anon_sym_SQUOTE] = ACTIONS(5433),
    [anon_sym_DQUOTE] = ACTIONS(5433),
    [sym_return] = ACTIONS(5435),
    [sym_next] = ACTIONS(5435),
    [sym_break] = ACTIONS(5435),
    [sym_true] = ACTIONS(5435),
    [sym_false] = ACTIONS(5435),
    [sym_null] = ACTIONS(5435),
    [sym_inf] = ACTIONS(5435),
    [sym_nan] = ACTIONS(5435),
    [anon_sym_NA] = ACTIONS(5435),
    [anon_sym_NA_integer_] = ACTIONS(5435),
    [anon_sym_NA_real_] = ACTIONS(5435),
    [anon_sym_NA_complex_] = ACTIONS(5435),
    [anon_sym_NA_character_] = ACTIONS(5435),
    [sym_dots] = ACTIONS(5435),
    [sym_dot_dot_i] = ACTIONS(5433),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5433),
    [sym__semicolon] = ACTIONS(5433),
    [sym__raw_string_literal] = ACTIONS(5433),
    [sym__external_open_parenthesis] = ACTIONS(6301),
    [sym__external_open_brace] = ACTIONS(5433),
    [sym__external_close_brace] = ACTIONS(5433),
    [sym__external_open_bracket] = ACTIONS(6303),
    [sym__external_open_bracket2] = ACTIONS(6305),
  },
  [1377] = {
    [sym_call_arguments] = STATE(2763),
    [sym_subset_arguments] = STATE(2764),
    [sym_subset2_arguments] = STATE(2765),
    [sym__open_parenthesis] = STATE(1584),
    [sym__open_bracket] = STATE(1582),
    [sym__open_bracket2] = STATE(1577),
    [sym_identifier] = ACTIONS(5339),
    [anon_sym_BSLASH] = ACTIONS(5337),
    [anon_sym_function] = ACTIONS(5339),
    [anon_sym_EQ] = ACTIONS(6431),
    [anon_sym_if] = ACTIONS(5339),
    [anon_sym_for] = ACTIONS(5339),
    [anon_sym_while] = ACTIONS(5339),
    [anon_sym_repeat] = ACTIONS(5339),
    [anon_sym_QMARK] = ACTIONS(5337),
    [anon_sym_TILDE] = ACTIONS(6433),
    [anon_sym_BANG] = ACTIONS(5339),
    [anon_sym_PLUS] = ACTIONS(6435),
    [anon_sym_DASH] = ACTIONS(6437),
    [anon_sym_LT_DASH] = ACTIONS(6439),
    [anon_sym_LT_LT_DASH] = ACTIONS(6439),
    [anon_sym_COLON_EQ] = ACTIONS(6439),
    [anon_sym_DASH_GT] = ACTIONS(6441),
    [anon_sym_DASH_GT_GT] = ACTIONS(6443),
    [anon_sym_PIPE] = ACTIONS(6445),
    [anon_sym_AMP] = ACTIONS(6447),
    [anon_sym_PIPE_PIPE] = ACTIONS(6449),
    [anon_sym_AMP_AMP] = ACTIONS(6451),
    [anon_sym_LT] = ACTIONS(6453),
    [anon_sym_LT_EQ] = ACTIONS(6455),
    [anon_sym_GT] = ACTIONS(6453),
    [anon_sym_GT_EQ] = ACTIONS(6455),
    [anon_sym_EQ_EQ] = ACTIONS(6455),
    [anon_sym_BANG_EQ] = ACTIONS(6455),
    [anon_sym_STAR] = ACTIONS(6457),
    [anon_sym_SLASH] = ACTIONS(6459),
    [anon_sym_STAR_STAR] = ACTIONS(6461),
    [anon_sym_CARET] = ACTIONS(6461),
    [aux_sym_binary_operator_token1] = ACTIONS(6463),
    [anon_sym_PIPE_GT] = ACTIONS(6463),
    [anon_sym_COLON] = ACTIONS(6465),
    [anon_sym_DOLLAR] = ACTIONS(6467),
    [anon_sym_AT] = ACTIONS(6467),
    [aux_sym__hex_literal_token1] = ACTIONS(5337),
    [sym__number_literal] = ACTIONS(5339),
    [anon_sym_SQUOTE] = ACTIONS(5337),
    [anon_sym_DQUOTE] = ACTIONS(5337),
    [sym_return] = ACTIONS(5339),
    [sym_next] = ACTIONS(5339),
    [sym_break] = ACTIONS(5339),
    [sym_true] = ACTIONS(5339),
    [sym_false] = ACTIONS(5339),
    [sym_null] = ACTIONS(5339),
    [sym_inf] = ACTIONS(5339),
    [sym_nan] = ACTIONS(5339),
    [anon_sym_NA] = ACTIONS(5339),
    [anon_sym_NA_integer_] = ACTIONS(5339),
    [anon_sym_NA_real_] = ACTIONS(5339),
    [anon_sym_NA_complex_] = ACTIONS(5339),
    [anon_sym_NA_character_] = ACTIONS(5339),
    [sym_dots] = ACTIONS(5339),
    [sym_dot_dot_i] = ACTIONS(5337),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5337),
    [sym__newline] = ACTIONS(5337),
    [sym__raw_string_literal] = ACTIONS(5337),
    [sym__external_open_parenthesis] = ACTIONS(6469),
    [sym__external_close_parenthesis] = ACTIONS(5337),
    [sym__external_open_brace] = ACTIONS(5337),
    [sym__external_open_bracket] = ACTIONS(6471),
    [sym__external_close_bracket] = ACTIONS(5337),
    [sym__external_open_bracket2] = ACTIONS(6473),
  },
  [1378] = {
    [sym_function_definition] = STATE(1940),
    [sym_if_statement] = STATE(1940),
    [sym_for_statement] = STATE(1940),
    [sym_while_statement] = STATE(1940),
    [sym_repeat_statement] = STATE(1940),
    [sym_braced_expression] = STATE(1940),
    [sym_parenthesized_expression] = STATE(1940),
    [sym_call] = STATE(1940),
    [sym_subset] = STATE(1940),
    [sym_subset2] = STATE(1940),
    [sym__argument] = STATE(4665),
    [sym_argument] = STATE(4661),
    [sym__argument_named] = STATE(4669),
    [sym__argument_unnamed] = STATE(4673),
    [sym__argument_value] = STATE(4679),
    [sym_unary_operator] = STATE(1940),
    [sym_binary_operator] = STATE(1940),
    [sym_extract_operator] = STATE(1940),
    [sym_namespace_operator] = STATE(1940),
    [sym_integer] = STATE(1940),
    [sym_complex] = STATE(1940),
    [sym_float] = STATE(1940),
    [sym__hex_literal] = STATE(2656),
    [sym__float_literal] = STATE(2656),
    [sym_string] = STATE(2606),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym_na] = STATE(1940),
    [sym__expression] = STATE(1940),
    [sym__string_or_identifier] = STATE(5141),
    [sym__open_parenthesis] = STATE(218),
    [sym__open_brace] = STATE(185),
    [sym__close_bracket2] = STATE(2248),
    [aux_sym_call_arguments_repeat1] = STATE(1812),
    [sym_identifier] = ACTIONS(6369),
    [anon_sym_BSLASH] = ACTIONS(4644),
    [anon_sym_function] = ACTIONS(4646),
    [anon_sym_if] = ACTIONS(4648),
    [anon_sym_for] = ACTIONS(4650),
    [anon_sym_while] = ACTIONS(4652),
    [anon_sym_repeat] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(6371),
    [anon_sym_PLUS] = ACTIONS(4662),
    [anon_sym_DASH] = ACTIONS(4662),
    [aux_sym__hex_literal_token1] = ACTIONS(4666),
    [sym__number_literal] = ACTIONS(4668),
    [anon_sym_SQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4672),
    [sym_return] = ACTIONS(6373),
    [sym_next] = ACTIONS(6373),
    [sym_break] = ACTIONS(6373),
    [sym_true] = ACTIONS(6373),
    [sym_false] = ACTIONS(6373),
    [sym_null] = ACTIONS(6373),
    [sym_inf] = ACTIONS(6373),
    [sym_nan] = ACTIONS(6373),
    [anon_sym_NA] = ACTIONS(4676),
    [anon_sym_NA_integer_] = ACTIONS(4676),
    [anon_sym_NA_real_] = ACTIONS(4676),
    [anon_sym_NA_complex_] = ACTIONS(4676),
    [anon_sym_NA_character_] = ACTIONS(4676),
    [sym_dots] = ACTIONS(6375),
    [sym_dot_dot_i] = ACTIONS(6377),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6379),
    [sym__newline] = ACTIONS(6381),
    [sym__raw_string_literal] = ACTIONS(4680),
    [sym__external_open_parenthesis] = ACTIONS(4682),
    [sym__external_open_brace] = ACTIONS(4684),
    [sym__external_close_bracket2] = ACTIONS(6573),
  },
  [1379] = {
    [sym_function_definition] = STATE(2038),
    [sym_if_statement] = STATE(2038),
    [sym_for_statement] = STATE(2038),
    [sym_while_statement] = STATE(2038),
    [sym_repeat_statement] = STATE(2038),
    [sym_braced_expression] = STATE(2038),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_call] = STATE(2038),
    [sym_subset] = STATE(2038),
    [sym_subset2] = STATE(2038),
    [sym__argument] = STATE(4664),
    [sym_argument] = STATE(4659),
    [sym__argument_named] = STATE(4654),
    [sym__argument_unnamed] = STATE(4676),
    [sym__argument_value] = STATE(4677),
    [sym_unary_operator] = STATE(2038),
    [sym_binary_operator] = STATE(2038),
    [sym_extract_operator] = STATE(2038),
    [sym_namespace_operator] = STATE(2038),
    [sym_integer] = STATE(2038),
    [sym_complex] = STATE(2038),
    [sym_float] = STATE(2038),
    [sym__hex_literal] = STATE(2700),
    [sym__float_literal] = STATE(2700),
    [sym_string] = STATE(2597),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym_na] = STATE(2038),
    [sym__expression] = STATE(2038),
    [sym__string_or_identifier] = STATE(5148),
    [sym__open_parenthesis] = STATE(214),
    [sym__open_brace] = STATE(192),
    [sym__close_bracket] = STATE(2249),
    [aux_sym_call_arguments_repeat1] = STATE(1813),
    [sym_identifier] = ACTIONS(6351),
    [anon_sym_BSLASH] = ACTIONS(4754),
    [anon_sym_function] = ACTIONS(4756),
    [anon_sym_if] = ACTIONS(4758),
    [anon_sym_for] = ACTIONS(4760),
    [anon_sym_while] = ACTIONS(4762),
    [anon_sym_repeat] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4766),
    [anon_sym_TILDE] = ACTIONS(4768),
    [anon_sym_BANG] = ACTIONS(6353),
    [anon_sym_PLUS] = ACTIONS(4772),
    [anon_sym_DASH] = ACTIONS(4772),
    [aux_sym__hex_literal_token1] = ACTIONS(4776),
    [sym__number_literal] = ACTIONS(4778),
    [anon_sym_SQUOTE] = ACTIONS(4780),
    [anon_sym_DQUOTE] = ACTIONS(4782),
    [sym_return] = ACTIONS(6355),
    [sym_next] = ACTIONS(6355),
    [sym_break] = ACTIONS(6355),
    [sym_true] = ACTIONS(6355),
    [sym_false] = ACTIONS(6355),
    [sym_null] = ACTIONS(6355),
    [sym_inf] = ACTIONS(6355),
    [sym_nan] = ACTIONS(6355),
    [anon_sym_NA] = ACTIONS(4786),
    [anon_sym_NA_integer_] = ACTIONS(4786),
    [anon_sym_NA_real_] = ACTIONS(4786),
    [anon_sym_NA_complex_] = ACTIONS(4786),
    [anon_sym_NA_character_] = ACTIONS(4786),
    [sym_dots] = ACTIONS(6357),
    [sym_dot_dot_i] = ACTIONS(6359),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6361),
    [sym__newline] = ACTIONS(6363),
    [sym__raw_string_literal] = ACTIONS(4790),
    [sym__external_open_parenthesis] = ACTIONS(4792),
    [sym__external_open_brace] = ACTIONS(4794),
    [sym__external_close_bracket] = ACTIONS(6575),
  },
  [1380] = {
    [sym_function_definition] = STATE(1931),
    [sym_if_statement] = STATE(1931),
    [sym_for_statement] = STATE(1931),
    [sym_while_statement] = STATE(1931),
    [sym_repeat_statement] = STATE(1931),
    [sym_braced_expression] = STATE(1931),
    [sym_parenthesized_expression] = STATE(1931),
    [sym_call] = STATE(1931),
    [sym_subset] = STATE(1931),
    [sym_subset2] = STATE(1931),
    [sym__argument] = STATE(4656),
    [sym_argument] = STATE(4657),
    [sym__argument_named] = STATE(4658),
    [sym__argument_unnamed] = STATE(4662),
    [sym__argument_value] = STATE(4663),
    [sym_unary_operator] = STATE(1931),
    [sym_binary_operator] = STATE(1931),
    [sym_extract_operator] = STATE(1931),
    [sym_namespace_operator] = STATE(1931),
    [sym_integer] = STATE(1931),
    [sym_complex] = STATE(1931),
    [sym_float] = STATE(1931),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2633),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(1931),
    [sym__expression] = STATE(1931),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__close_parenthesis] = STATE(2250),
    [sym__open_brace] = STATE(154),
    [aux_sym_call_arguments_repeat1] = STATE(1424),
    [sym_identifier] = ACTIONS(6387),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(6389),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3865),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(6391),
    [sym_next] = ACTIONS(6391),
    [sym_break] = ACTIONS(6391),
    [sym_true] = ACTIONS(6391),
    [sym_false] = ACTIONS(6391),
    [sym_null] = ACTIONS(6391),
    [sym_inf] = ACTIONS(6391),
    [sym_nan] = ACTIONS(6391),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(6393),
    [sym_dot_dot_i] = ACTIONS(6395),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6397),
    [sym__newline] = ACTIONS(6399),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(6577),
    [sym__external_open_brace] = ACTIONS(3891),
  },
  [1381] = {
    [sym_call_arguments] = STATE(2763),
    [sym_subset_arguments] = STATE(2764),
    [sym_subset2_arguments] = STATE(2765),
    [sym__open_parenthesis] = STATE(1584),
    [sym__open_bracket] = STATE(1582),
    [sym__open_bracket2] = STATE(1577),
    [sym_identifier] = ACTIONS(5343),
    [anon_sym_BSLASH] = ACTIONS(5341),
    [anon_sym_function] = ACTIONS(5343),
    [anon_sym_EQ] = ACTIONS(6431),
    [anon_sym_if] = ACTIONS(5343),
    [anon_sym_for] = ACTIONS(5343),
    [anon_sym_while] = ACTIONS(5343),
    [anon_sym_repeat] = ACTIONS(5343),
    [anon_sym_QMARK] = ACTIONS(5341),
    [anon_sym_TILDE] = ACTIONS(6433),
    [anon_sym_BANG] = ACTIONS(5343),
    [anon_sym_PLUS] = ACTIONS(6435),
    [anon_sym_DASH] = ACTIONS(6437),
    [anon_sym_LT_DASH] = ACTIONS(6439),
    [anon_sym_LT_LT_DASH] = ACTIONS(6439),
    [anon_sym_COLON_EQ] = ACTIONS(6439),
    [anon_sym_DASH_GT] = ACTIONS(6441),
    [anon_sym_DASH_GT_GT] = ACTIONS(6443),
    [anon_sym_PIPE] = ACTIONS(6445),
    [anon_sym_AMP] = ACTIONS(6447),
    [anon_sym_PIPE_PIPE] = ACTIONS(6449),
    [anon_sym_AMP_AMP] = ACTIONS(6451),
    [anon_sym_LT] = ACTIONS(6453),
    [anon_sym_LT_EQ] = ACTIONS(6455),
    [anon_sym_GT] = ACTIONS(6453),
    [anon_sym_GT_EQ] = ACTIONS(6455),
    [anon_sym_EQ_EQ] = ACTIONS(6455),
    [anon_sym_BANG_EQ] = ACTIONS(6455),
    [anon_sym_STAR] = ACTIONS(6457),
    [anon_sym_SLASH] = ACTIONS(6459),
    [anon_sym_STAR_STAR] = ACTIONS(6461),
    [anon_sym_CARET] = ACTIONS(6461),
    [aux_sym_binary_operator_token1] = ACTIONS(6463),
    [anon_sym_PIPE_GT] = ACTIONS(6463),
    [anon_sym_COLON] = ACTIONS(6465),
    [anon_sym_DOLLAR] = ACTIONS(6467),
    [anon_sym_AT] = ACTIONS(6467),
    [aux_sym__hex_literal_token1] = ACTIONS(5341),
    [sym__number_literal] = ACTIONS(5343),
    [anon_sym_SQUOTE] = ACTIONS(5341),
    [anon_sym_DQUOTE] = ACTIONS(5341),
    [sym_return] = ACTIONS(5343),
    [sym_next] = ACTIONS(5343),
    [sym_break] = ACTIONS(5343),
    [sym_true] = ACTIONS(5343),
    [sym_false] = ACTIONS(5343),
    [sym_null] = ACTIONS(5343),
    [sym_inf] = ACTIONS(5343),
    [sym_nan] = ACTIONS(5343),
    [anon_sym_NA] = ACTIONS(5343),
    [anon_sym_NA_integer_] = ACTIONS(5343),
    [anon_sym_NA_real_] = ACTIONS(5343),
    [anon_sym_NA_complex_] = ACTIONS(5343),
    [anon_sym_NA_character_] = ACTIONS(5343),
    [sym_dots] = ACTIONS(5343),
    [sym_dot_dot_i] = ACTIONS(5341),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5341),
    [sym__newline] = ACTIONS(5341),
    [sym__raw_string_literal] = ACTIONS(5341),
    [sym__external_open_parenthesis] = ACTIONS(6469),
    [sym__external_close_parenthesis] = ACTIONS(5341),
    [sym__external_open_brace] = ACTIONS(5341),
    [sym__external_open_bracket] = ACTIONS(6471),
    [sym__external_close_bracket] = ACTIONS(5341),
    [sym__external_open_bracket2] = ACTIONS(6473),
  },
  [1382] = {
    [sym_call_arguments] = STATE(2763),
    [sym_subset_arguments] = STATE(2764),
    [sym_subset2_arguments] = STATE(2765),
    [sym__open_parenthesis] = STATE(1584),
    [sym__open_bracket] = STATE(1582),
    [sym__open_bracket2] = STATE(1577),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(6431),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(6433),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(6435),
    [anon_sym_DASH] = ACTIONS(6437),
    [anon_sym_LT_DASH] = ACTIONS(6439),
    [anon_sym_LT_LT_DASH] = ACTIONS(6439),
    [anon_sym_COLON_EQ] = ACTIONS(6439),
    [anon_sym_DASH_GT] = ACTIONS(6441),
    [anon_sym_DASH_GT_GT] = ACTIONS(6443),
    [anon_sym_PIPE] = ACTIONS(6445),
    [anon_sym_AMP] = ACTIONS(6447),
    [anon_sym_PIPE_PIPE] = ACTIONS(6449),
    [anon_sym_AMP_AMP] = ACTIONS(6451),
    [anon_sym_LT] = ACTIONS(6453),
    [anon_sym_LT_EQ] = ACTIONS(6455),
    [anon_sym_GT] = ACTIONS(6453),
    [anon_sym_GT_EQ] = ACTIONS(6455),
    [anon_sym_EQ_EQ] = ACTIONS(6455),
    [anon_sym_BANG_EQ] = ACTIONS(6455),
    [anon_sym_STAR] = ACTIONS(6457),
    [anon_sym_SLASH] = ACTIONS(6459),
    [anon_sym_STAR_STAR] = ACTIONS(6461),
    [anon_sym_CARET] = ACTIONS(6461),
    [aux_sym_binary_operator_token1] = ACTIONS(6463),
    [anon_sym_PIPE_GT] = ACTIONS(6463),
    [anon_sym_COLON] = ACTIONS(6465),
    [anon_sym_DOLLAR] = ACTIONS(6467),
    [anon_sym_AT] = ACTIONS(6467),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(6469),
    [sym__external_close_parenthesis] = ACTIONS(5345),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(6471),
    [sym__external_close_bracket] = ACTIONS(5345),
    [sym__external_open_bracket2] = ACTIONS(6473),
  },
  [1383] = {
    [sym_call_arguments] = STATE(2763),
    [sym_subset_arguments] = STATE(2764),
    [sym_subset2_arguments] = STATE(2765),
    [sym__open_parenthesis] = STATE(1584),
    [sym__open_bracket] = STATE(1582),
    [sym__open_bracket2] = STATE(1577),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(6435),
    [anon_sym_DASH] = ACTIONS(6437),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(6445),
    [anon_sym_AMP] = ACTIONS(6447),
    [anon_sym_PIPE_PIPE] = ACTIONS(6449),
    [anon_sym_AMP_AMP] = ACTIONS(6451),
    [anon_sym_LT] = ACTIONS(6453),
    [anon_sym_LT_EQ] = ACTIONS(6455),
    [anon_sym_GT] = ACTIONS(6453),
    [anon_sym_GT_EQ] = ACTIONS(6455),
    [anon_sym_EQ_EQ] = ACTIONS(6455),
    [anon_sym_BANG_EQ] = ACTIONS(6455),
    [anon_sym_STAR] = ACTIONS(6457),
    [anon_sym_SLASH] = ACTIONS(6459),
    [anon_sym_STAR_STAR] = ACTIONS(6461),
    [anon_sym_CARET] = ACTIONS(6461),
    [aux_sym_binary_operator_token1] = ACTIONS(6463),
    [anon_sym_PIPE_GT] = ACTIONS(6463),
    [anon_sym_COLON] = ACTIONS(6465),
    [anon_sym_DOLLAR] = ACTIONS(6467),
    [anon_sym_AT] = ACTIONS(6467),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(6469),
    [sym__external_close_parenthesis] = ACTIONS(5345),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(6471),
    [sym__external_close_bracket] = ACTIONS(5345),
    [sym__external_open_bracket2] = ACTIONS(6473),
  },
  [1384] = {
    [sym_call_arguments] = STATE(2763),
    [sym_subset_arguments] = STATE(2764),
    [sym_subset2_arguments] = STATE(2765),
    [sym__open_parenthesis] = STATE(1584),
    [sym__open_bracket] = STATE(1582),
    [sym__open_bracket2] = STATE(1577),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(6435),
    [anon_sym_DASH] = ACTIONS(6437),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5347),
    [anon_sym_AMP] = ACTIONS(5347),
    [anon_sym_PIPE_PIPE] = ACTIONS(5345),
    [anon_sym_AMP_AMP] = ACTIONS(5345),
    [anon_sym_LT] = ACTIONS(6453),
    [anon_sym_LT_EQ] = ACTIONS(6455),
    [anon_sym_GT] = ACTIONS(6453),
    [anon_sym_GT_EQ] = ACTIONS(6455),
    [anon_sym_EQ_EQ] = ACTIONS(6455),
    [anon_sym_BANG_EQ] = ACTIONS(6455),
    [anon_sym_STAR] = ACTIONS(6457),
    [anon_sym_SLASH] = ACTIONS(6459),
    [anon_sym_STAR_STAR] = ACTIONS(6461),
    [anon_sym_CARET] = ACTIONS(6461),
    [aux_sym_binary_operator_token1] = ACTIONS(6463),
    [anon_sym_PIPE_GT] = ACTIONS(6463),
    [anon_sym_COLON] = ACTIONS(6465),
    [anon_sym_DOLLAR] = ACTIONS(6467),
    [anon_sym_AT] = ACTIONS(6467),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(6469),
    [sym__external_close_parenthesis] = ACTIONS(5345),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(6471),
    [sym__external_close_bracket] = ACTIONS(5345),
    [sym__external_open_bracket2] = ACTIONS(6473),
  },
  [1385] = {
    [sym_call_arguments] = STATE(2763),
    [sym_subset_arguments] = STATE(2764),
    [sym_subset2_arguments] = STATE(2765),
    [sym__open_parenthesis] = STATE(1584),
    [sym__open_bracket] = STATE(1582),
    [sym__open_bracket2] = STATE(1577),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5345),
    [anon_sym_DASH] = ACTIONS(5347),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5347),
    [anon_sym_AMP] = ACTIONS(5347),
    [anon_sym_PIPE_PIPE] = ACTIONS(5345),
    [anon_sym_AMP_AMP] = ACTIONS(5345),
    [anon_sym_LT] = ACTIONS(5347),
    [anon_sym_LT_EQ] = ACTIONS(5345),
    [anon_sym_GT] = ACTIONS(5347),
    [anon_sym_GT_EQ] = ACTIONS(5345),
    [anon_sym_EQ_EQ] = ACTIONS(5345),
    [anon_sym_BANG_EQ] = ACTIONS(5345),
    [anon_sym_STAR] = ACTIONS(5347),
    [anon_sym_SLASH] = ACTIONS(5345),
    [anon_sym_STAR_STAR] = ACTIONS(6461),
    [anon_sym_CARET] = ACTIONS(6461),
    [aux_sym_binary_operator_token1] = ACTIONS(5345),
    [anon_sym_PIPE_GT] = ACTIONS(5345),
    [anon_sym_COLON] = ACTIONS(5347),
    [anon_sym_DOLLAR] = ACTIONS(6467),
    [anon_sym_AT] = ACTIONS(6467),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(6469),
    [sym__external_close_parenthesis] = ACTIONS(5345),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(6471),
    [sym__external_close_bracket] = ACTIONS(5345),
    [sym__external_open_bracket2] = ACTIONS(6473),
  },
  [1386] = {
    [sym_function_definition] = STATE(1940),
    [sym_if_statement] = STATE(1940),
    [sym_for_statement] = STATE(1940),
    [sym_while_statement] = STATE(1940),
    [sym_repeat_statement] = STATE(1940),
    [sym_braced_expression] = STATE(1940),
    [sym_parenthesized_expression] = STATE(1940),
    [sym_call] = STATE(1940),
    [sym_subset] = STATE(1940),
    [sym_subset2] = STATE(1940),
    [sym__argument] = STATE(4665),
    [sym_argument] = STATE(4661),
    [sym__argument_named] = STATE(4669),
    [sym__argument_unnamed] = STATE(4673),
    [sym__argument_value] = STATE(4679),
    [sym_unary_operator] = STATE(1940),
    [sym_binary_operator] = STATE(1940),
    [sym_extract_operator] = STATE(1940),
    [sym_namespace_operator] = STATE(1940),
    [sym_integer] = STATE(1940),
    [sym_complex] = STATE(1940),
    [sym_float] = STATE(1940),
    [sym__hex_literal] = STATE(2656),
    [sym__float_literal] = STATE(2656),
    [sym_string] = STATE(2606),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym_na] = STATE(1940),
    [sym__expression] = STATE(1940),
    [sym__string_or_identifier] = STATE(5141),
    [sym__open_parenthesis] = STATE(218),
    [sym__open_brace] = STATE(185),
    [sym__close_bracket2] = STATE(2703),
    [aux_sym_call_arguments_repeat1] = STATE(1912),
    [sym_identifier] = ACTIONS(6369),
    [anon_sym_BSLASH] = ACTIONS(4644),
    [anon_sym_function] = ACTIONS(4646),
    [anon_sym_if] = ACTIONS(4648),
    [anon_sym_for] = ACTIONS(4650),
    [anon_sym_while] = ACTIONS(4652),
    [anon_sym_repeat] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(6371),
    [anon_sym_PLUS] = ACTIONS(4662),
    [anon_sym_DASH] = ACTIONS(4662),
    [aux_sym__hex_literal_token1] = ACTIONS(4666),
    [sym__number_literal] = ACTIONS(4668),
    [anon_sym_SQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4672),
    [sym_return] = ACTIONS(6373),
    [sym_next] = ACTIONS(6373),
    [sym_break] = ACTIONS(6373),
    [sym_true] = ACTIONS(6373),
    [sym_false] = ACTIONS(6373),
    [sym_null] = ACTIONS(6373),
    [sym_inf] = ACTIONS(6373),
    [sym_nan] = ACTIONS(6373),
    [anon_sym_NA] = ACTIONS(4676),
    [anon_sym_NA_integer_] = ACTIONS(4676),
    [anon_sym_NA_real_] = ACTIONS(4676),
    [anon_sym_NA_complex_] = ACTIONS(4676),
    [anon_sym_NA_character_] = ACTIONS(4676),
    [sym_dots] = ACTIONS(6375),
    [sym_dot_dot_i] = ACTIONS(6377),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6379),
    [sym__newline] = ACTIONS(6381),
    [sym__raw_string_literal] = ACTIONS(4680),
    [sym__external_open_parenthesis] = ACTIONS(4682),
    [sym__external_open_brace] = ACTIONS(4684),
    [sym__external_close_bracket2] = ACTIONS(6579),
  },
  [1387] = {
    [sym_function_definition] = STATE(2038),
    [sym_if_statement] = STATE(2038),
    [sym_for_statement] = STATE(2038),
    [sym_while_statement] = STATE(2038),
    [sym_repeat_statement] = STATE(2038),
    [sym_braced_expression] = STATE(2038),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_call] = STATE(2038),
    [sym_subset] = STATE(2038),
    [sym_subset2] = STATE(2038),
    [sym__argument] = STATE(4664),
    [sym_argument] = STATE(4659),
    [sym__argument_named] = STATE(4654),
    [sym__argument_unnamed] = STATE(4676),
    [sym__argument_value] = STATE(4677),
    [sym_unary_operator] = STATE(2038),
    [sym_binary_operator] = STATE(2038),
    [sym_extract_operator] = STATE(2038),
    [sym_namespace_operator] = STATE(2038),
    [sym_integer] = STATE(2038),
    [sym_complex] = STATE(2038),
    [sym_float] = STATE(2038),
    [sym__hex_literal] = STATE(2700),
    [sym__float_literal] = STATE(2700),
    [sym_string] = STATE(2597),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym_na] = STATE(2038),
    [sym__expression] = STATE(2038),
    [sym__string_or_identifier] = STATE(5148),
    [sym__open_parenthesis] = STATE(214),
    [sym__open_brace] = STATE(192),
    [sym__close_bracket] = STATE(2704),
    [aux_sym_call_arguments_repeat1] = STATE(2034),
    [sym_identifier] = ACTIONS(6351),
    [anon_sym_BSLASH] = ACTIONS(4754),
    [anon_sym_function] = ACTIONS(4756),
    [anon_sym_if] = ACTIONS(4758),
    [anon_sym_for] = ACTIONS(4760),
    [anon_sym_while] = ACTIONS(4762),
    [anon_sym_repeat] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4766),
    [anon_sym_TILDE] = ACTIONS(4768),
    [anon_sym_BANG] = ACTIONS(6353),
    [anon_sym_PLUS] = ACTIONS(4772),
    [anon_sym_DASH] = ACTIONS(4772),
    [aux_sym__hex_literal_token1] = ACTIONS(4776),
    [sym__number_literal] = ACTIONS(4778),
    [anon_sym_SQUOTE] = ACTIONS(4780),
    [anon_sym_DQUOTE] = ACTIONS(4782),
    [sym_return] = ACTIONS(6355),
    [sym_next] = ACTIONS(6355),
    [sym_break] = ACTIONS(6355),
    [sym_true] = ACTIONS(6355),
    [sym_false] = ACTIONS(6355),
    [sym_null] = ACTIONS(6355),
    [sym_inf] = ACTIONS(6355),
    [sym_nan] = ACTIONS(6355),
    [anon_sym_NA] = ACTIONS(4786),
    [anon_sym_NA_integer_] = ACTIONS(4786),
    [anon_sym_NA_real_] = ACTIONS(4786),
    [anon_sym_NA_complex_] = ACTIONS(4786),
    [anon_sym_NA_character_] = ACTIONS(4786),
    [sym_dots] = ACTIONS(6357),
    [sym_dot_dot_i] = ACTIONS(6359),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6361),
    [sym__newline] = ACTIONS(6363),
    [sym__raw_string_literal] = ACTIONS(4790),
    [sym__external_open_parenthesis] = ACTIONS(4792),
    [sym__external_open_brace] = ACTIONS(4794),
    [sym__external_close_bracket] = ACTIONS(6581),
  },
  [1388] = {
    [sym_call_arguments] = STATE(2763),
    [sym_subset_arguments] = STATE(2764),
    [sym_subset2_arguments] = STATE(2765),
    [sym__open_parenthesis] = STATE(1584),
    [sym__open_bracket] = STATE(1582),
    [sym__open_bracket2] = STATE(1577),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(6431),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(6433),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(6435),
    [anon_sym_DASH] = ACTIONS(6437),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(6441),
    [anon_sym_DASH_GT_GT] = ACTIONS(6443),
    [anon_sym_PIPE] = ACTIONS(6445),
    [anon_sym_AMP] = ACTIONS(6447),
    [anon_sym_PIPE_PIPE] = ACTIONS(6449),
    [anon_sym_AMP_AMP] = ACTIONS(6451),
    [anon_sym_LT] = ACTIONS(6453),
    [anon_sym_LT_EQ] = ACTIONS(6455),
    [anon_sym_GT] = ACTIONS(6453),
    [anon_sym_GT_EQ] = ACTIONS(6455),
    [anon_sym_EQ_EQ] = ACTIONS(6455),
    [anon_sym_BANG_EQ] = ACTIONS(6455),
    [anon_sym_STAR] = ACTIONS(6457),
    [anon_sym_SLASH] = ACTIONS(6459),
    [anon_sym_STAR_STAR] = ACTIONS(6461),
    [anon_sym_CARET] = ACTIONS(6461),
    [aux_sym_binary_operator_token1] = ACTIONS(6463),
    [anon_sym_PIPE_GT] = ACTIONS(6463),
    [anon_sym_COLON] = ACTIONS(6465),
    [anon_sym_DOLLAR] = ACTIONS(6467),
    [anon_sym_AT] = ACTIONS(6467),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6469),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6471),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(6473),
  },
  [1389] = {
    [sym_string] = STATE(2706),
    [sym__single_quoted_string] = STATE(2273),
    [sym__double_quoted_string] = STATE(2274),
    [sym__string_or_identifier] = STATE(2706),
    [aux_sym_function_definition_repeat1] = STATE(2503),
    [sym_identifier] = ACTIONS(6583),
    [anon_sym_BSLASH] = ACTIONS(5669),
    [anon_sym_function] = ACTIONS(5673),
    [anon_sym_EQ] = ACTIONS(5673),
    [anon_sym_if] = ACTIONS(5673),
    [anon_sym_for] = ACTIONS(5673),
    [anon_sym_while] = ACTIONS(5673),
    [anon_sym_repeat] = ACTIONS(5673),
    [anon_sym_QMARK] = ACTIONS(5669),
    [anon_sym_TILDE] = ACTIONS(5669),
    [anon_sym_BANG] = ACTIONS(5673),
    [anon_sym_PLUS] = ACTIONS(5669),
    [anon_sym_DASH] = ACTIONS(5673),
    [anon_sym_LT_DASH] = ACTIONS(5669),
    [anon_sym_LT_LT_DASH] = ACTIONS(5669),
    [anon_sym_COLON_EQ] = ACTIONS(5669),
    [anon_sym_DASH_GT] = ACTIONS(5673),
    [anon_sym_DASH_GT_GT] = ACTIONS(5669),
    [anon_sym_PIPE] = ACTIONS(5673),
    [anon_sym_AMP] = ACTIONS(5673),
    [anon_sym_PIPE_PIPE] = ACTIONS(5669),
    [anon_sym_AMP_AMP] = ACTIONS(5669),
    [anon_sym_LT] = ACTIONS(5673),
    [anon_sym_LT_EQ] = ACTIONS(5669),
    [anon_sym_GT] = ACTIONS(5673),
    [anon_sym_GT_EQ] = ACTIONS(5669),
    [anon_sym_EQ_EQ] = ACTIONS(5669),
    [anon_sym_BANG_EQ] = ACTIONS(5669),
    [anon_sym_STAR] = ACTIONS(5673),
    [anon_sym_SLASH] = ACTIONS(5669),
    [anon_sym_STAR_STAR] = ACTIONS(5669),
    [anon_sym_CARET] = ACTIONS(5669),
    [aux_sym_binary_operator_token1] = ACTIONS(5669),
    [anon_sym_PIPE_GT] = ACTIONS(5669),
    [anon_sym_COLON] = ACTIONS(5673),
    [anon_sym_DOLLAR] = ACTIONS(5669),
    [anon_sym_AT] = ACTIONS(5669),
    [aux_sym__hex_literal_token1] = ACTIONS(5669),
    [sym__number_literal] = ACTIONS(5673),
    [anon_sym_SQUOTE] = ACTIONS(1269),
    [anon_sym_DQUOTE] = ACTIONS(1271),
    [sym_return] = ACTIONS(5673),
    [sym_next] = ACTIONS(5673),
    [sym_break] = ACTIONS(5673),
    [sym_true] = ACTIONS(5673),
    [sym_false] = ACTIONS(5673),
    [sym_null] = ACTIONS(5673),
    [sym_inf] = ACTIONS(5673),
    [sym_nan] = ACTIONS(5673),
    [anon_sym_NA] = ACTIONS(5673),
    [anon_sym_NA_integer_] = ACTIONS(5673),
    [anon_sym_NA_real_] = ACTIONS(5673),
    [anon_sym_NA_complex_] = ACTIONS(5673),
    [anon_sym_NA_character_] = ACTIONS(5673),
    [sym_dots] = ACTIONS(5673),
    [sym_dot_dot_i] = ACTIONS(5669),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5669),
    [sym__newline] = ACTIONS(5669),
    [sym__raw_string_literal] = ACTIONS(1281),
    [sym__external_else] = ACTIONS(5669),
    [sym__external_open_parenthesis] = ACTIONS(5669),
    [sym__external_close_parenthesis] = ACTIONS(5669),
    [sym__external_open_brace] = ACTIONS(5669),
    [sym__external_open_bracket] = ACTIONS(5669),
    [sym__external_close_bracket] = ACTIONS(5669),
    [sym__external_open_bracket2] = ACTIONS(5669),
  },
  [1390] = {
    [sym_call_arguments] = STATE(2763),
    [sym_subset_arguments] = STATE(2764),
    [sym_subset2_arguments] = STATE(2765),
    [sym__open_parenthesis] = STATE(1584),
    [sym__open_bracket] = STATE(1582),
    [sym__open_bracket2] = STATE(1577),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(6431),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(6433),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(6435),
    [anon_sym_DASH] = ACTIONS(6437),
    [anon_sym_LT_DASH] = ACTIONS(6439),
    [anon_sym_LT_LT_DASH] = ACTIONS(6439),
    [anon_sym_COLON_EQ] = ACTIONS(6439),
    [anon_sym_DASH_GT] = ACTIONS(6441),
    [anon_sym_DASH_GT_GT] = ACTIONS(6443),
    [anon_sym_PIPE] = ACTIONS(6445),
    [anon_sym_AMP] = ACTIONS(6447),
    [anon_sym_PIPE_PIPE] = ACTIONS(6449),
    [anon_sym_AMP_AMP] = ACTIONS(6451),
    [anon_sym_LT] = ACTIONS(6453),
    [anon_sym_LT_EQ] = ACTIONS(6455),
    [anon_sym_GT] = ACTIONS(6453),
    [anon_sym_GT_EQ] = ACTIONS(6455),
    [anon_sym_EQ_EQ] = ACTIONS(6455),
    [anon_sym_BANG_EQ] = ACTIONS(6455),
    [anon_sym_STAR] = ACTIONS(6457),
    [anon_sym_SLASH] = ACTIONS(6459),
    [anon_sym_STAR_STAR] = ACTIONS(6461),
    [anon_sym_CARET] = ACTIONS(6461),
    [aux_sym_binary_operator_token1] = ACTIONS(6463),
    [anon_sym_PIPE_GT] = ACTIONS(6463),
    [anon_sym_COLON] = ACTIONS(6465),
    [anon_sym_DOLLAR] = ACTIONS(6467),
    [anon_sym_AT] = ACTIONS(6467),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6469),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6471),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(6473),
  },
  [1391] = {
    [sym_call_arguments] = STATE(2840),
    [sym_subset_arguments] = STATE(2797),
    [sym_subset2_arguments] = STATE(2801),
    [sym__open_parenthesis] = STATE(1344),
    [sym__open_bracket] = STATE(1374),
    [sym__open_bracket2] = STATE(1452),
    [ts_builtin_sym_end] = ACTIONS(5345),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(6267),
    [anon_sym_DASH] = ACTIONS(6269),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5347),
    [anon_sym_AMP] = ACTIONS(5347),
    [anon_sym_PIPE_PIPE] = ACTIONS(5345),
    [anon_sym_AMP_AMP] = ACTIONS(5345),
    [anon_sym_LT] = ACTIONS(6285),
    [anon_sym_LT_EQ] = ACTIONS(6287),
    [anon_sym_GT] = ACTIONS(6285),
    [anon_sym_GT_EQ] = ACTIONS(6287),
    [anon_sym_EQ_EQ] = ACTIONS(6287),
    [anon_sym_BANG_EQ] = ACTIONS(6287),
    [anon_sym_STAR] = ACTIONS(6289),
    [anon_sym_SLASH] = ACTIONS(6291),
    [anon_sym_STAR_STAR] = ACTIONS(6293),
    [anon_sym_CARET] = ACTIONS(6293),
    [aux_sym_binary_operator_token1] = ACTIONS(6295),
    [anon_sym_PIPE_GT] = ACTIONS(6295),
    [anon_sym_COLON] = ACTIONS(6297),
    [anon_sym_DOLLAR] = ACTIONS(6299),
    [anon_sym_AT] = ACTIONS(6299),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5345),
    [sym__semicolon] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(6301),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_close_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(6303),
    [sym__external_open_bracket2] = ACTIONS(6305),
  },
  [1392] = {
    [sym_call_arguments] = STATE(2763),
    [sym_subset_arguments] = STATE(2764),
    [sym_subset2_arguments] = STATE(2765),
    [sym__open_parenthesis] = STATE(1584),
    [sym__open_bracket] = STATE(1582),
    [sym__open_bracket2] = STATE(1577),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(6435),
    [anon_sym_DASH] = ACTIONS(6437),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(6445),
    [anon_sym_AMP] = ACTIONS(6447),
    [anon_sym_PIPE_PIPE] = ACTIONS(6449),
    [anon_sym_AMP_AMP] = ACTIONS(6451),
    [anon_sym_LT] = ACTIONS(6453),
    [anon_sym_LT_EQ] = ACTIONS(6455),
    [anon_sym_GT] = ACTIONS(6453),
    [anon_sym_GT_EQ] = ACTIONS(6455),
    [anon_sym_EQ_EQ] = ACTIONS(6455),
    [anon_sym_BANG_EQ] = ACTIONS(6455),
    [anon_sym_STAR] = ACTIONS(6457),
    [anon_sym_SLASH] = ACTIONS(6459),
    [anon_sym_STAR_STAR] = ACTIONS(6461),
    [anon_sym_CARET] = ACTIONS(6461),
    [aux_sym_binary_operator_token1] = ACTIONS(6463),
    [anon_sym_PIPE_GT] = ACTIONS(6463),
    [anon_sym_COLON] = ACTIONS(6465),
    [anon_sym_DOLLAR] = ACTIONS(6467),
    [anon_sym_AT] = ACTIONS(6467),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6469),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6471),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(6473),
  },
  [1393] = {
    [sym_function_definition] = STATE(1931),
    [sym_if_statement] = STATE(1931),
    [sym_for_statement] = STATE(1931),
    [sym_while_statement] = STATE(1931),
    [sym_repeat_statement] = STATE(1931),
    [sym_braced_expression] = STATE(1931),
    [sym_parenthesized_expression] = STATE(1931),
    [sym_call] = STATE(1931),
    [sym_subset] = STATE(1931),
    [sym_subset2] = STATE(1931),
    [sym__argument] = STATE(4656),
    [sym_argument] = STATE(4657),
    [sym__argument_named] = STATE(4658),
    [sym__argument_unnamed] = STATE(4662),
    [sym__argument_value] = STATE(4663),
    [sym_unary_operator] = STATE(1931),
    [sym_binary_operator] = STATE(1931),
    [sym_extract_operator] = STATE(1931),
    [sym_namespace_operator] = STATE(1931),
    [sym_integer] = STATE(1931),
    [sym_complex] = STATE(1931),
    [sym_float] = STATE(1931),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2633),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(1931),
    [sym__expression] = STATE(1931),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__close_parenthesis] = STATE(2915),
    [sym__open_brace] = STATE(154),
    [aux_sym_call_arguments_repeat1] = STATE(2113),
    [sym_identifier] = ACTIONS(6387),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(6389),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3865),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(6391),
    [sym_next] = ACTIONS(6391),
    [sym_break] = ACTIONS(6391),
    [sym_true] = ACTIONS(6391),
    [sym_false] = ACTIONS(6391),
    [sym_null] = ACTIONS(6391),
    [sym_inf] = ACTIONS(6391),
    [sym_nan] = ACTIONS(6391),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(6393),
    [sym_dot_dot_i] = ACTIONS(6395),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6397),
    [sym__newline] = ACTIONS(6399),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(6585),
    [sym__external_open_brace] = ACTIONS(3891),
  },
  [1394] = {
    [sym_call_arguments] = STATE(2763),
    [sym_subset_arguments] = STATE(2764),
    [sym_subset2_arguments] = STATE(2765),
    [sym__open_parenthesis] = STATE(1584),
    [sym__open_bracket] = STATE(1582),
    [sym__open_bracket2] = STATE(1577),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(6457),
    [anon_sym_SLASH] = ACTIONS(6459),
    [anon_sym_STAR_STAR] = ACTIONS(6461),
    [anon_sym_CARET] = ACTIONS(6461),
    [aux_sym_binary_operator_token1] = ACTIONS(6463),
    [anon_sym_PIPE_GT] = ACTIONS(6463),
    [anon_sym_COLON] = ACTIONS(6465),
    [anon_sym_DOLLAR] = ACTIONS(6467),
    [anon_sym_AT] = ACTIONS(6467),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6469),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6471),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(6473),
  },
  [1395] = {
    [sym_function_definition] = STATE(1940),
    [sym_if_statement] = STATE(1940),
    [sym_for_statement] = STATE(1940),
    [sym_while_statement] = STATE(1940),
    [sym_repeat_statement] = STATE(1940),
    [sym_braced_expression] = STATE(1940),
    [sym_parenthesized_expression] = STATE(1940),
    [sym_call] = STATE(1940),
    [sym_subset] = STATE(1940),
    [sym_subset2] = STATE(1940),
    [sym__argument] = STATE(4665),
    [sym_argument] = STATE(4661),
    [sym__argument_named] = STATE(4669),
    [sym__argument_unnamed] = STATE(4673),
    [sym__argument_value] = STATE(4679),
    [sym_unary_operator] = STATE(1940),
    [sym_binary_operator] = STATE(1940),
    [sym_extract_operator] = STATE(1940),
    [sym_namespace_operator] = STATE(1940),
    [sym_integer] = STATE(1940),
    [sym_complex] = STATE(1940),
    [sym_float] = STATE(1940),
    [sym__hex_literal] = STATE(2656),
    [sym__float_literal] = STATE(2656),
    [sym_string] = STATE(2606),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym_na] = STATE(1940),
    [sym__expression] = STATE(1940),
    [sym__string_or_identifier] = STATE(5141),
    [sym__open_parenthesis] = STATE(218),
    [sym__open_brace] = STATE(185),
    [sym__close_bracket2] = STATE(4699),
    [aux_sym_call_arguments_repeat1] = STATE(1875),
    [sym_identifier] = ACTIONS(6369),
    [anon_sym_BSLASH] = ACTIONS(4644),
    [anon_sym_function] = ACTIONS(4646),
    [anon_sym_if] = ACTIONS(4648),
    [anon_sym_for] = ACTIONS(4650),
    [anon_sym_while] = ACTIONS(4652),
    [anon_sym_repeat] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(6371),
    [anon_sym_PLUS] = ACTIONS(4662),
    [anon_sym_DASH] = ACTIONS(4662),
    [aux_sym__hex_literal_token1] = ACTIONS(4666),
    [sym__number_literal] = ACTIONS(4668),
    [anon_sym_SQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4672),
    [sym_return] = ACTIONS(6373),
    [sym_next] = ACTIONS(6373),
    [sym_break] = ACTIONS(6373),
    [sym_true] = ACTIONS(6373),
    [sym_false] = ACTIONS(6373),
    [sym_null] = ACTIONS(6373),
    [sym_inf] = ACTIONS(6373),
    [sym_nan] = ACTIONS(6373),
    [anon_sym_NA] = ACTIONS(4676),
    [anon_sym_NA_integer_] = ACTIONS(4676),
    [anon_sym_NA_real_] = ACTIONS(4676),
    [anon_sym_NA_complex_] = ACTIONS(4676),
    [anon_sym_NA_character_] = ACTIONS(4676),
    [sym_dots] = ACTIONS(6375),
    [sym_dot_dot_i] = ACTIONS(6377),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6379),
    [sym__newline] = ACTIONS(6381),
    [sym__raw_string_literal] = ACTIONS(4680),
    [sym__external_open_parenthesis] = ACTIONS(4682),
    [sym__external_open_brace] = ACTIONS(4684),
    [sym__external_close_bracket2] = ACTIONS(6587),
  },
  [1396] = {
    [sym_call_arguments] = STATE(2763),
    [sym_subset_arguments] = STATE(2764),
    [sym_subset2_arguments] = STATE(2765),
    [sym__open_parenthesis] = STATE(1584),
    [sym__open_bracket] = STATE(1582),
    [sym__open_bracket2] = STATE(1577),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(6431),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(6433),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(6435),
    [anon_sym_DASH] = ACTIONS(6437),
    [anon_sym_LT_DASH] = ACTIONS(6439),
    [anon_sym_LT_LT_DASH] = ACTIONS(6439),
    [anon_sym_COLON_EQ] = ACTIONS(6439),
    [anon_sym_DASH_GT] = ACTIONS(6441),
    [anon_sym_DASH_GT_GT] = ACTIONS(6443),
    [anon_sym_PIPE] = ACTIONS(6445),
    [anon_sym_AMP] = ACTIONS(6447),
    [anon_sym_PIPE_PIPE] = ACTIONS(6449),
    [anon_sym_AMP_AMP] = ACTIONS(6451),
    [anon_sym_LT] = ACTIONS(6453),
    [anon_sym_LT_EQ] = ACTIONS(6455),
    [anon_sym_GT] = ACTIONS(6453),
    [anon_sym_GT_EQ] = ACTIONS(6455),
    [anon_sym_EQ_EQ] = ACTIONS(6455),
    [anon_sym_BANG_EQ] = ACTIONS(6455),
    [anon_sym_STAR] = ACTIONS(6457),
    [anon_sym_SLASH] = ACTIONS(6459),
    [anon_sym_STAR_STAR] = ACTIONS(6461),
    [anon_sym_CARET] = ACTIONS(6461),
    [aux_sym_binary_operator_token1] = ACTIONS(6463),
    [anon_sym_PIPE_GT] = ACTIONS(6463),
    [anon_sym_COLON] = ACTIONS(6465),
    [anon_sym_DOLLAR] = ACTIONS(6467),
    [anon_sym_AT] = ACTIONS(6467),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6469),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6471),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(6473),
  },
  [1397] = {
    [sym_function_definition] = STATE(2038),
    [sym_if_statement] = STATE(2038),
    [sym_for_statement] = STATE(2038),
    [sym_while_statement] = STATE(2038),
    [sym_repeat_statement] = STATE(2038),
    [sym_braced_expression] = STATE(2038),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_call] = STATE(2038),
    [sym_subset] = STATE(2038),
    [sym_subset2] = STATE(2038),
    [sym__argument] = STATE(4664),
    [sym_argument] = STATE(4659),
    [sym__argument_named] = STATE(4654),
    [sym__argument_unnamed] = STATE(4676),
    [sym__argument_value] = STATE(4677),
    [sym_unary_operator] = STATE(2038),
    [sym_binary_operator] = STATE(2038),
    [sym_extract_operator] = STATE(2038),
    [sym_namespace_operator] = STATE(2038),
    [sym_integer] = STATE(2038),
    [sym_complex] = STATE(2038),
    [sym_float] = STATE(2038),
    [sym__hex_literal] = STATE(2700),
    [sym__float_literal] = STATE(2700),
    [sym_string] = STATE(2597),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym_na] = STATE(2038),
    [sym__expression] = STATE(2038),
    [sym__string_or_identifier] = STATE(5148),
    [sym__open_parenthesis] = STATE(214),
    [sym__open_brace] = STATE(192),
    [sym__close_bracket] = STATE(4702),
    [aux_sym_call_arguments_repeat1] = STATE(1877),
    [sym_identifier] = ACTIONS(6351),
    [anon_sym_BSLASH] = ACTIONS(4754),
    [anon_sym_function] = ACTIONS(4756),
    [anon_sym_if] = ACTIONS(4758),
    [anon_sym_for] = ACTIONS(4760),
    [anon_sym_while] = ACTIONS(4762),
    [anon_sym_repeat] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4766),
    [anon_sym_TILDE] = ACTIONS(4768),
    [anon_sym_BANG] = ACTIONS(6353),
    [anon_sym_PLUS] = ACTIONS(4772),
    [anon_sym_DASH] = ACTIONS(4772),
    [aux_sym__hex_literal_token1] = ACTIONS(4776),
    [sym__number_literal] = ACTIONS(4778),
    [anon_sym_SQUOTE] = ACTIONS(4780),
    [anon_sym_DQUOTE] = ACTIONS(4782),
    [sym_return] = ACTIONS(6355),
    [sym_next] = ACTIONS(6355),
    [sym_break] = ACTIONS(6355),
    [sym_true] = ACTIONS(6355),
    [sym_false] = ACTIONS(6355),
    [sym_null] = ACTIONS(6355),
    [sym_inf] = ACTIONS(6355),
    [sym_nan] = ACTIONS(6355),
    [anon_sym_NA] = ACTIONS(4786),
    [anon_sym_NA_integer_] = ACTIONS(4786),
    [anon_sym_NA_real_] = ACTIONS(4786),
    [anon_sym_NA_complex_] = ACTIONS(4786),
    [anon_sym_NA_character_] = ACTIONS(4786),
    [sym_dots] = ACTIONS(6357),
    [sym_dot_dot_i] = ACTIONS(6359),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6361),
    [sym__newline] = ACTIONS(6363),
    [sym__raw_string_literal] = ACTIONS(4790),
    [sym__external_open_parenthesis] = ACTIONS(4792),
    [sym__external_open_brace] = ACTIONS(4794),
    [sym__external_close_bracket] = ACTIONS(6589),
  },
  [1398] = {
    [sym_call_arguments] = STATE(2763),
    [sym_subset_arguments] = STATE(2764),
    [sym_subset2_arguments] = STATE(2765),
    [sym__open_parenthesis] = STATE(1584),
    [sym__open_bracket] = STATE(1582),
    [sym__open_bracket2] = STATE(1577),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(6433),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(6435),
    [anon_sym_DASH] = ACTIONS(6437),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(6445),
    [anon_sym_AMP] = ACTIONS(6447),
    [anon_sym_PIPE_PIPE] = ACTIONS(6449),
    [anon_sym_AMP_AMP] = ACTIONS(6451),
    [anon_sym_LT] = ACTIONS(6453),
    [anon_sym_LT_EQ] = ACTIONS(6455),
    [anon_sym_GT] = ACTIONS(6453),
    [anon_sym_GT_EQ] = ACTIONS(6455),
    [anon_sym_EQ_EQ] = ACTIONS(6455),
    [anon_sym_BANG_EQ] = ACTIONS(6455),
    [anon_sym_STAR] = ACTIONS(6457),
    [anon_sym_SLASH] = ACTIONS(6459),
    [anon_sym_STAR_STAR] = ACTIONS(6461),
    [anon_sym_CARET] = ACTIONS(6461),
    [aux_sym_binary_operator_token1] = ACTIONS(6463),
    [anon_sym_PIPE_GT] = ACTIONS(6463),
    [anon_sym_COLON] = ACTIONS(6465),
    [anon_sym_DOLLAR] = ACTIONS(6467),
    [anon_sym_AT] = ACTIONS(6467),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6469),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6471),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(6473),
  },
  [1399] = {
    [sym_function_definition] = STATE(1931),
    [sym_if_statement] = STATE(1931),
    [sym_for_statement] = STATE(1931),
    [sym_while_statement] = STATE(1931),
    [sym_repeat_statement] = STATE(1931),
    [sym_braced_expression] = STATE(1931),
    [sym_parenthesized_expression] = STATE(1931),
    [sym_call] = STATE(1931),
    [sym_subset] = STATE(1931),
    [sym_subset2] = STATE(1931),
    [sym__argument] = STATE(4656),
    [sym_argument] = STATE(4657),
    [sym__argument_named] = STATE(4658),
    [sym__argument_unnamed] = STATE(4662),
    [sym__argument_value] = STATE(4663),
    [sym_unary_operator] = STATE(1931),
    [sym_binary_operator] = STATE(1931),
    [sym_extract_operator] = STATE(1931),
    [sym_namespace_operator] = STATE(1931),
    [sym_integer] = STATE(1931),
    [sym_complex] = STATE(1931),
    [sym_float] = STATE(1931),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2633),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(1931),
    [sym__expression] = STATE(1931),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__close_parenthesis] = STATE(4705),
    [sym__open_brace] = STATE(154),
    [aux_sym_call_arguments_repeat1] = STATE(1444),
    [sym_identifier] = ACTIONS(6387),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(6389),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3865),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(6391),
    [sym_next] = ACTIONS(6391),
    [sym_break] = ACTIONS(6391),
    [sym_true] = ACTIONS(6391),
    [sym_false] = ACTIONS(6391),
    [sym_null] = ACTIONS(6391),
    [sym_inf] = ACTIONS(6391),
    [sym_nan] = ACTIONS(6391),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(6393),
    [sym_dot_dot_i] = ACTIONS(6395),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6397),
    [sym__newline] = ACTIONS(6399),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(6591),
    [sym__external_open_brace] = ACTIONS(3891),
  },
  [1400] = {
    [sym_call_arguments] = STATE(2763),
    [sym_subset_arguments] = STATE(2764),
    [sym_subset2_arguments] = STATE(2765),
    [sym__open_parenthesis] = STATE(1584),
    [sym__open_bracket] = STATE(1582),
    [sym__open_bracket2] = STATE(1577),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(6435),
    [anon_sym_DASH] = ACTIONS(6437),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(6447),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(6451),
    [anon_sym_LT] = ACTIONS(6453),
    [anon_sym_LT_EQ] = ACTIONS(6455),
    [anon_sym_GT] = ACTIONS(6453),
    [anon_sym_GT_EQ] = ACTIONS(6455),
    [anon_sym_EQ_EQ] = ACTIONS(6455),
    [anon_sym_BANG_EQ] = ACTIONS(6455),
    [anon_sym_STAR] = ACTIONS(6457),
    [anon_sym_SLASH] = ACTIONS(6459),
    [anon_sym_STAR_STAR] = ACTIONS(6461),
    [anon_sym_CARET] = ACTIONS(6461),
    [aux_sym_binary_operator_token1] = ACTIONS(6463),
    [anon_sym_PIPE_GT] = ACTIONS(6463),
    [anon_sym_COLON] = ACTIONS(6465),
    [anon_sym_DOLLAR] = ACTIONS(6467),
    [anon_sym_AT] = ACTIONS(6467),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6469),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6471),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(6473),
  },
  [1401] = {
    [sym_function_definition] = STATE(1931),
    [sym_if_statement] = STATE(1931),
    [sym_for_statement] = STATE(1931),
    [sym_while_statement] = STATE(1931),
    [sym_repeat_statement] = STATE(1931),
    [sym_braced_expression] = STATE(1931),
    [sym_parenthesized_expression] = STATE(1931),
    [sym_call] = STATE(1931),
    [sym_subset] = STATE(1931),
    [sym_subset2] = STATE(1931),
    [sym__argument] = STATE(4656),
    [sym_argument] = STATE(4657),
    [sym__argument_named] = STATE(4658),
    [sym__argument_unnamed] = STATE(4662),
    [sym__argument_value] = STATE(4663),
    [sym_unary_operator] = STATE(1931),
    [sym_binary_operator] = STATE(1931),
    [sym_extract_operator] = STATE(1931),
    [sym_namespace_operator] = STATE(1931),
    [sym_integer] = STATE(1931),
    [sym_complex] = STATE(1931),
    [sym_float] = STATE(1931),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2633),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(1931),
    [sym__expression] = STATE(1931),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__close_parenthesis] = STATE(2839),
    [sym__open_brace] = STATE(154),
    [aux_sym_call_arguments_repeat1] = STATE(2113),
    [sym_identifier] = ACTIONS(6387),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(6389),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3865),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(6391),
    [sym_next] = ACTIONS(6391),
    [sym_break] = ACTIONS(6391),
    [sym_true] = ACTIONS(6391),
    [sym_false] = ACTIONS(6391),
    [sym_null] = ACTIONS(6391),
    [sym_inf] = ACTIONS(6391),
    [sym_nan] = ACTIONS(6391),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(6393),
    [sym_dot_dot_i] = ACTIONS(6395),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6397),
    [sym__newline] = ACTIONS(6399),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(6593),
    [sym__external_open_brace] = ACTIONS(3891),
  },
  [1402] = {
    [sym_call_arguments] = STATE(2763),
    [sym_subset_arguments] = STATE(2764),
    [sym_subset2_arguments] = STATE(2765),
    [sym__open_parenthesis] = STATE(1584),
    [sym__open_bracket] = STATE(1582),
    [sym__open_bracket2] = STATE(1577),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(6435),
    [anon_sym_DASH] = ACTIONS(6437),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(6453),
    [anon_sym_LT_EQ] = ACTIONS(6455),
    [anon_sym_GT] = ACTIONS(6453),
    [anon_sym_GT_EQ] = ACTIONS(6455),
    [anon_sym_EQ_EQ] = ACTIONS(6455),
    [anon_sym_BANG_EQ] = ACTIONS(6455),
    [anon_sym_STAR] = ACTIONS(6457),
    [anon_sym_SLASH] = ACTIONS(6459),
    [anon_sym_STAR_STAR] = ACTIONS(6461),
    [anon_sym_CARET] = ACTIONS(6461),
    [aux_sym_binary_operator_token1] = ACTIONS(6463),
    [anon_sym_PIPE_GT] = ACTIONS(6463),
    [anon_sym_COLON] = ACTIONS(6465),
    [anon_sym_DOLLAR] = ACTIONS(6467),
    [anon_sym_AT] = ACTIONS(6467),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6469),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6471),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(6473),
  },
  [1403] = {
    [sym_function_definition] = STATE(1940),
    [sym_if_statement] = STATE(1940),
    [sym_for_statement] = STATE(1940),
    [sym_while_statement] = STATE(1940),
    [sym_repeat_statement] = STATE(1940),
    [sym_braced_expression] = STATE(1940),
    [sym_parenthesized_expression] = STATE(1940),
    [sym_call] = STATE(1940),
    [sym_subset] = STATE(1940),
    [sym_subset2] = STATE(1940),
    [sym__argument] = STATE(4665),
    [sym_argument] = STATE(4661),
    [sym__argument_named] = STATE(4669),
    [sym__argument_unnamed] = STATE(4673),
    [sym__argument_value] = STATE(4679),
    [sym_unary_operator] = STATE(1940),
    [sym_binary_operator] = STATE(1940),
    [sym_extract_operator] = STATE(1940),
    [sym_namespace_operator] = STATE(1940),
    [sym_integer] = STATE(1940),
    [sym_complex] = STATE(1940),
    [sym_float] = STATE(1940),
    [sym__hex_literal] = STATE(2656),
    [sym__float_literal] = STATE(2656),
    [sym_string] = STATE(2606),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym_na] = STATE(1940),
    [sym__expression] = STATE(1940),
    [sym__string_or_identifier] = STATE(5141),
    [sym__open_parenthesis] = STATE(218),
    [sym__open_brace] = STATE(185),
    [sym__close_bracket2] = STATE(2463),
    [aux_sym_call_arguments_repeat1] = STATE(1912),
    [sym_identifier] = ACTIONS(6369),
    [anon_sym_BSLASH] = ACTIONS(4644),
    [anon_sym_function] = ACTIONS(4646),
    [anon_sym_if] = ACTIONS(4648),
    [anon_sym_for] = ACTIONS(4650),
    [anon_sym_while] = ACTIONS(4652),
    [anon_sym_repeat] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(6371),
    [anon_sym_PLUS] = ACTIONS(4662),
    [anon_sym_DASH] = ACTIONS(4662),
    [aux_sym__hex_literal_token1] = ACTIONS(4666),
    [sym__number_literal] = ACTIONS(4668),
    [anon_sym_SQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4672),
    [sym_return] = ACTIONS(6373),
    [sym_next] = ACTIONS(6373),
    [sym_break] = ACTIONS(6373),
    [sym_true] = ACTIONS(6373),
    [sym_false] = ACTIONS(6373),
    [sym_null] = ACTIONS(6373),
    [sym_inf] = ACTIONS(6373),
    [sym_nan] = ACTIONS(6373),
    [anon_sym_NA] = ACTIONS(4676),
    [anon_sym_NA_integer_] = ACTIONS(4676),
    [anon_sym_NA_real_] = ACTIONS(4676),
    [anon_sym_NA_complex_] = ACTIONS(4676),
    [anon_sym_NA_character_] = ACTIONS(4676),
    [sym_dots] = ACTIONS(6375),
    [sym_dot_dot_i] = ACTIONS(6377),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6379),
    [sym__newline] = ACTIONS(6381),
    [sym__raw_string_literal] = ACTIONS(4680),
    [sym__external_open_parenthesis] = ACTIONS(4682),
    [sym__external_open_brace] = ACTIONS(4684),
    [sym__external_close_bracket2] = ACTIONS(6595),
  },
  [1404] = {
    [sym_call_arguments] = STATE(2763),
    [sym_subset_arguments] = STATE(2764),
    [sym_subset2_arguments] = STATE(2765),
    [sym__open_parenthesis] = STATE(1584),
    [sym__open_bracket] = STATE(1582),
    [sym__open_bracket2] = STATE(1577),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(6435),
    [anon_sym_DASH] = ACTIONS(6437),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(6457),
    [anon_sym_SLASH] = ACTIONS(6459),
    [anon_sym_STAR_STAR] = ACTIONS(6461),
    [anon_sym_CARET] = ACTIONS(6461),
    [aux_sym_binary_operator_token1] = ACTIONS(6463),
    [anon_sym_PIPE_GT] = ACTIONS(6463),
    [anon_sym_COLON] = ACTIONS(6465),
    [anon_sym_DOLLAR] = ACTIONS(6467),
    [anon_sym_AT] = ACTIONS(6467),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6469),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6471),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(6473),
  },
  [1405] = {
    [sym_function_definition] = STATE(2038),
    [sym_if_statement] = STATE(2038),
    [sym_for_statement] = STATE(2038),
    [sym_while_statement] = STATE(2038),
    [sym_repeat_statement] = STATE(2038),
    [sym_braced_expression] = STATE(2038),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_call] = STATE(2038),
    [sym_subset] = STATE(2038),
    [sym_subset2] = STATE(2038),
    [sym__argument] = STATE(4664),
    [sym_argument] = STATE(4659),
    [sym__argument_named] = STATE(4654),
    [sym__argument_unnamed] = STATE(4676),
    [sym__argument_value] = STATE(4677),
    [sym_unary_operator] = STATE(2038),
    [sym_binary_operator] = STATE(2038),
    [sym_extract_operator] = STATE(2038),
    [sym_namespace_operator] = STATE(2038),
    [sym_integer] = STATE(2038),
    [sym_complex] = STATE(2038),
    [sym_float] = STATE(2038),
    [sym__hex_literal] = STATE(2700),
    [sym__float_literal] = STATE(2700),
    [sym_string] = STATE(2597),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym_na] = STATE(2038),
    [sym__expression] = STATE(2038),
    [sym__string_or_identifier] = STATE(5148),
    [sym__open_parenthesis] = STATE(214),
    [sym__open_brace] = STATE(192),
    [sym__close_bracket] = STATE(2464),
    [aux_sym_call_arguments_repeat1] = STATE(2034),
    [sym_identifier] = ACTIONS(6351),
    [anon_sym_BSLASH] = ACTIONS(4754),
    [anon_sym_function] = ACTIONS(4756),
    [anon_sym_if] = ACTIONS(4758),
    [anon_sym_for] = ACTIONS(4760),
    [anon_sym_while] = ACTIONS(4762),
    [anon_sym_repeat] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4766),
    [anon_sym_TILDE] = ACTIONS(4768),
    [anon_sym_BANG] = ACTIONS(6353),
    [anon_sym_PLUS] = ACTIONS(4772),
    [anon_sym_DASH] = ACTIONS(4772),
    [aux_sym__hex_literal_token1] = ACTIONS(4776),
    [sym__number_literal] = ACTIONS(4778),
    [anon_sym_SQUOTE] = ACTIONS(4780),
    [anon_sym_DQUOTE] = ACTIONS(4782),
    [sym_return] = ACTIONS(6355),
    [sym_next] = ACTIONS(6355),
    [sym_break] = ACTIONS(6355),
    [sym_true] = ACTIONS(6355),
    [sym_false] = ACTIONS(6355),
    [sym_null] = ACTIONS(6355),
    [sym_inf] = ACTIONS(6355),
    [sym_nan] = ACTIONS(6355),
    [anon_sym_NA] = ACTIONS(4786),
    [anon_sym_NA_integer_] = ACTIONS(4786),
    [anon_sym_NA_real_] = ACTIONS(4786),
    [anon_sym_NA_complex_] = ACTIONS(4786),
    [anon_sym_NA_character_] = ACTIONS(4786),
    [sym_dots] = ACTIONS(6357),
    [sym_dot_dot_i] = ACTIONS(6359),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6361),
    [sym__newline] = ACTIONS(6363),
    [sym__raw_string_literal] = ACTIONS(4790),
    [sym__external_open_parenthesis] = ACTIONS(4792),
    [sym__external_open_brace] = ACTIONS(4794),
    [sym__external_close_bracket] = ACTIONS(6597),
  },
  [1406] = {
    [sym_call_arguments] = STATE(2763),
    [sym_subset_arguments] = STATE(2764),
    [sym_subset2_arguments] = STATE(2765),
    [sym__open_parenthesis] = STATE(1584),
    [sym__open_bracket] = STATE(1582),
    [sym__open_bracket2] = STATE(1577),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(6461),
    [anon_sym_CARET] = ACTIONS(6461),
    [aux_sym_binary_operator_token1] = ACTIONS(6463),
    [anon_sym_PIPE_GT] = ACTIONS(6463),
    [anon_sym_COLON] = ACTIONS(6465),
    [anon_sym_DOLLAR] = ACTIONS(6467),
    [anon_sym_AT] = ACTIONS(6467),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6469),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6471),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(6473),
  },
  [1407] = {
    [sym_function_definition] = STATE(1940),
    [sym_if_statement] = STATE(1940),
    [sym_for_statement] = STATE(1940),
    [sym_while_statement] = STATE(1940),
    [sym_repeat_statement] = STATE(1940),
    [sym_braced_expression] = STATE(1940),
    [sym_parenthesized_expression] = STATE(1940),
    [sym_call] = STATE(1940),
    [sym_subset] = STATE(1940),
    [sym_subset2] = STATE(1940),
    [sym__argument] = STATE(4665),
    [sym_argument] = STATE(4661),
    [sym__argument_named] = STATE(4669),
    [sym__argument_unnamed] = STATE(4673),
    [sym__argument_value] = STATE(4679),
    [sym_unary_operator] = STATE(1940),
    [sym_binary_operator] = STATE(1940),
    [sym_extract_operator] = STATE(1940),
    [sym_namespace_operator] = STATE(1940),
    [sym_integer] = STATE(1940),
    [sym_complex] = STATE(1940),
    [sym_float] = STATE(1940),
    [sym__hex_literal] = STATE(2656),
    [sym__float_literal] = STATE(2656),
    [sym_string] = STATE(2606),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym_na] = STATE(1940),
    [sym__expression] = STATE(1940),
    [sym__string_or_identifier] = STATE(5141),
    [sym__open_parenthesis] = STATE(218),
    [sym__open_brace] = STATE(185),
    [sym__close_bracket2] = STATE(2880),
    [aux_sym_call_arguments_repeat1] = STATE(1806),
    [sym_identifier] = ACTIONS(6369),
    [anon_sym_BSLASH] = ACTIONS(4644),
    [anon_sym_function] = ACTIONS(4646),
    [anon_sym_if] = ACTIONS(4648),
    [anon_sym_for] = ACTIONS(4650),
    [anon_sym_while] = ACTIONS(4652),
    [anon_sym_repeat] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(6371),
    [anon_sym_PLUS] = ACTIONS(4662),
    [anon_sym_DASH] = ACTIONS(4662),
    [aux_sym__hex_literal_token1] = ACTIONS(4666),
    [sym__number_literal] = ACTIONS(4668),
    [anon_sym_SQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4672),
    [sym_return] = ACTIONS(6373),
    [sym_next] = ACTIONS(6373),
    [sym_break] = ACTIONS(6373),
    [sym_true] = ACTIONS(6373),
    [sym_false] = ACTIONS(6373),
    [sym_null] = ACTIONS(6373),
    [sym_inf] = ACTIONS(6373),
    [sym_nan] = ACTIONS(6373),
    [anon_sym_NA] = ACTIONS(4676),
    [anon_sym_NA_integer_] = ACTIONS(4676),
    [anon_sym_NA_real_] = ACTIONS(4676),
    [anon_sym_NA_complex_] = ACTIONS(4676),
    [anon_sym_NA_character_] = ACTIONS(4676),
    [sym_dots] = ACTIONS(6375),
    [sym_dot_dot_i] = ACTIONS(6377),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6379),
    [sym__newline] = ACTIONS(6381),
    [sym__raw_string_literal] = ACTIONS(4680),
    [sym__external_open_parenthesis] = ACTIONS(4682),
    [sym__external_open_brace] = ACTIONS(4684),
    [sym__external_close_bracket2] = ACTIONS(6599),
  },
  [1408] = {
    [sym_call_arguments] = STATE(2763),
    [sym_subset_arguments] = STATE(2764),
    [sym_subset2_arguments] = STATE(2765),
    [sym__open_parenthesis] = STATE(1584),
    [sym__open_bracket] = STATE(1582),
    [sym__open_bracket2] = STATE(1577),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(6461),
    [anon_sym_CARET] = ACTIONS(6461),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(5351),
    [anon_sym_DOLLAR] = ACTIONS(6467),
    [anon_sym_AT] = ACTIONS(6467),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6469),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6471),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(6473),
  },
  [1409] = {
    [sym_function_definition] = STATE(2038),
    [sym_if_statement] = STATE(2038),
    [sym_for_statement] = STATE(2038),
    [sym_while_statement] = STATE(2038),
    [sym_repeat_statement] = STATE(2038),
    [sym_braced_expression] = STATE(2038),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_call] = STATE(2038),
    [sym_subset] = STATE(2038),
    [sym_subset2] = STATE(2038),
    [sym__argument] = STATE(4664),
    [sym_argument] = STATE(4659),
    [sym__argument_named] = STATE(4654),
    [sym__argument_unnamed] = STATE(4676),
    [sym__argument_value] = STATE(4677),
    [sym_unary_operator] = STATE(2038),
    [sym_binary_operator] = STATE(2038),
    [sym_extract_operator] = STATE(2038),
    [sym_namespace_operator] = STATE(2038),
    [sym_integer] = STATE(2038),
    [sym_complex] = STATE(2038),
    [sym_float] = STATE(2038),
    [sym__hex_literal] = STATE(2700),
    [sym__float_literal] = STATE(2700),
    [sym_string] = STATE(2597),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym_na] = STATE(2038),
    [sym__expression] = STATE(2038),
    [sym__string_or_identifier] = STATE(5148),
    [sym__open_parenthesis] = STATE(214),
    [sym__open_brace] = STATE(192),
    [sym__close_bracket] = STATE(2882),
    [aux_sym_call_arguments_repeat1] = STATE(1805),
    [sym_identifier] = ACTIONS(6351),
    [anon_sym_BSLASH] = ACTIONS(4754),
    [anon_sym_function] = ACTIONS(4756),
    [anon_sym_if] = ACTIONS(4758),
    [anon_sym_for] = ACTIONS(4760),
    [anon_sym_while] = ACTIONS(4762),
    [anon_sym_repeat] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4766),
    [anon_sym_TILDE] = ACTIONS(4768),
    [anon_sym_BANG] = ACTIONS(6353),
    [anon_sym_PLUS] = ACTIONS(4772),
    [anon_sym_DASH] = ACTIONS(4772),
    [aux_sym__hex_literal_token1] = ACTIONS(4776),
    [sym__number_literal] = ACTIONS(4778),
    [anon_sym_SQUOTE] = ACTIONS(4780),
    [anon_sym_DQUOTE] = ACTIONS(4782),
    [sym_return] = ACTIONS(6355),
    [sym_next] = ACTIONS(6355),
    [sym_break] = ACTIONS(6355),
    [sym_true] = ACTIONS(6355),
    [sym_false] = ACTIONS(6355),
    [sym_null] = ACTIONS(6355),
    [sym_inf] = ACTIONS(6355),
    [sym_nan] = ACTIONS(6355),
    [anon_sym_NA] = ACTIONS(4786),
    [anon_sym_NA_integer_] = ACTIONS(4786),
    [anon_sym_NA_real_] = ACTIONS(4786),
    [anon_sym_NA_complex_] = ACTIONS(4786),
    [anon_sym_NA_character_] = ACTIONS(4786),
    [sym_dots] = ACTIONS(6357),
    [sym_dot_dot_i] = ACTIONS(6359),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6361),
    [sym__newline] = ACTIONS(6363),
    [sym__raw_string_literal] = ACTIONS(4790),
    [sym__external_open_parenthesis] = ACTIONS(4792),
    [sym__external_open_brace] = ACTIONS(4794),
    [sym__external_close_bracket] = ACTIONS(6601),
  },
  [1410] = {
    [sym_call_arguments] = STATE(2763),
    [sym_subset_arguments] = STATE(2764),
    [sym_subset2_arguments] = STATE(2765),
    [sym__open_parenthesis] = STATE(1584),
    [sym__open_bracket] = STATE(1582),
    [sym__open_bracket2] = STATE(1577),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(6461),
    [anon_sym_CARET] = ACTIONS(6461),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(6465),
    [anon_sym_DOLLAR] = ACTIONS(6467),
    [anon_sym_AT] = ACTIONS(6467),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6469),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6471),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(6473),
  },
  [1411] = {
    [sym_function_definition] = STATE(1931),
    [sym_if_statement] = STATE(1931),
    [sym_for_statement] = STATE(1931),
    [sym_while_statement] = STATE(1931),
    [sym_repeat_statement] = STATE(1931),
    [sym_braced_expression] = STATE(1931),
    [sym_parenthesized_expression] = STATE(1931),
    [sym_call] = STATE(1931),
    [sym_subset] = STATE(1931),
    [sym_subset2] = STATE(1931),
    [sym__argument] = STATE(4656),
    [sym_argument] = STATE(4657),
    [sym__argument_named] = STATE(4658),
    [sym__argument_unnamed] = STATE(4662),
    [sym__argument_value] = STATE(4663),
    [sym_unary_operator] = STATE(1931),
    [sym_binary_operator] = STATE(1931),
    [sym_extract_operator] = STATE(1931),
    [sym_namespace_operator] = STATE(1931),
    [sym_integer] = STATE(1931),
    [sym_complex] = STATE(1931),
    [sym_float] = STATE(1931),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2633),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(1931),
    [sym__expression] = STATE(1931),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__close_parenthesis] = STATE(2889),
    [sym__open_brace] = STATE(154),
    [aux_sym_call_arguments_repeat1] = STATE(1804),
    [sym_identifier] = ACTIONS(6387),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(6389),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3865),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(6391),
    [sym_next] = ACTIONS(6391),
    [sym_break] = ACTIONS(6391),
    [sym_true] = ACTIONS(6391),
    [sym_false] = ACTIONS(6391),
    [sym_null] = ACTIONS(6391),
    [sym_inf] = ACTIONS(6391),
    [sym_nan] = ACTIONS(6391),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(6393),
    [sym_dot_dot_i] = ACTIONS(6395),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6397),
    [sym__newline] = ACTIONS(6399),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(6603),
    [sym__external_open_brace] = ACTIONS(3891),
  },
  [1412] = {
    [sym_call_arguments] = STATE(2763),
    [sym_subset_arguments] = STATE(2764),
    [sym_subset2_arguments] = STATE(2765),
    [sym__open_parenthesis] = STATE(1584),
    [sym__open_bracket] = STATE(1582),
    [sym__open_bracket2] = STATE(1577),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(6461),
    [anon_sym_CARET] = ACTIONS(6461),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(5351),
    [anon_sym_DOLLAR] = ACTIONS(6467),
    [anon_sym_AT] = ACTIONS(6467),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6469),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6471),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(6473),
  },
  [1413] = {
    [sym_call_arguments] = STATE(2777),
    [sym_subset_arguments] = STATE(2779),
    [sym_subset2_arguments] = STATE(2786),
    [sym__open_parenthesis] = STATE(1411),
    [sym__open_bracket] = STATE(1409),
    [sym__open_bracket2] = STATE(1407),
    [ts_builtin_sym_end] = ACTIONS(5333),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(5333),
    [anon_sym_DASH] = ACTIONS(5335),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5335),
    [anon_sym_AMP] = ACTIONS(5335),
    [anon_sym_PIPE_PIPE] = ACTIONS(5333),
    [anon_sym_AMP_AMP] = ACTIONS(5333),
    [anon_sym_LT] = ACTIONS(5335),
    [anon_sym_LT_EQ] = ACTIONS(5333),
    [anon_sym_GT] = ACTIONS(5335),
    [anon_sym_GT_EQ] = ACTIONS(5333),
    [anon_sym_EQ_EQ] = ACTIONS(5333),
    [anon_sym_BANG_EQ] = ACTIONS(5333),
    [anon_sym_STAR] = ACTIONS(5335),
    [anon_sym_SLASH] = ACTIONS(5333),
    [anon_sym_STAR_STAR] = ACTIONS(6523),
    [anon_sym_CARET] = ACTIONS(6523),
    [aux_sym_binary_operator_token1] = ACTIONS(5333),
    [anon_sym_PIPE_GT] = ACTIONS(5333),
    [anon_sym_COLON] = ACTIONS(5335),
    [anon_sym_DOLLAR] = ACTIONS(6529),
    [anon_sym_AT] = ACTIONS(6529),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5333),
    [sym__semicolon] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(6531),
    [sym__external_close_parenthesis] = ACTIONS(5333),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(6533),
    [sym__external_open_bracket2] = ACTIONS(6535),
  },
  [1414] = {
    [sym_function_definition] = STATE(1931),
    [sym_if_statement] = STATE(1931),
    [sym_for_statement] = STATE(1931),
    [sym_while_statement] = STATE(1931),
    [sym_repeat_statement] = STATE(1931),
    [sym_braced_expression] = STATE(1931),
    [sym_parenthesized_expression] = STATE(1931),
    [sym_call] = STATE(1931),
    [sym_subset] = STATE(1931),
    [sym_subset2] = STATE(1931),
    [sym__argument] = STATE(4656),
    [sym_argument] = STATE(4657),
    [sym__argument_named] = STATE(4658),
    [sym__argument_unnamed] = STATE(4662),
    [sym__argument_value] = STATE(4663),
    [sym_unary_operator] = STATE(1931),
    [sym_binary_operator] = STATE(1931),
    [sym_extract_operator] = STATE(1931),
    [sym_namespace_operator] = STATE(1931),
    [sym_integer] = STATE(1931),
    [sym_complex] = STATE(1931),
    [sym_float] = STATE(1931),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2633),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(1931),
    [sym__expression] = STATE(1931),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__close_parenthesis] = STATE(3013),
    [sym__open_brace] = STATE(154),
    [aux_sym_call_arguments_repeat1] = STATE(1898),
    [sym_identifier] = ACTIONS(6387),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(6389),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3865),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(6391),
    [sym_next] = ACTIONS(6391),
    [sym_break] = ACTIONS(6391),
    [sym_true] = ACTIONS(6391),
    [sym_false] = ACTIONS(6391),
    [sym_null] = ACTIONS(6391),
    [sym_inf] = ACTIONS(6391),
    [sym_nan] = ACTIONS(6391),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(6393),
    [sym_dot_dot_i] = ACTIONS(6395),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6397),
    [sym__newline] = ACTIONS(6399),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(6605),
    [sym__external_open_brace] = ACTIONS(3891),
  },
  [1415] = {
    [sym_function_definition] = STATE(1940),
    [sym_if_statement] = STATE(1940),
    [sym_for_statement] = STATE(1940),
    [sym_while_statement] = STATE(1940),
    [sym_repeat_statement] = STATE(1940),
    [sym_braced_expression] = STATE(1940),
    [sym_parenthesized_expression] = STATE(1940),
    [sym_call] = STATE(1940),
    [sym_subset] = STATE(1940),
    [sym_subset2] = STATE(1940),
    [sym__argument] = STATE(4665),
    [sym_argument] = STATE(4661),
    [sym__argument_named] = STATE(4669),
    [sym__argument_unnamed] = STATE(4673),
    [sym__argument_value] = STATE(4679),
    [sym_unary_operator] = STATE(1940),
    [sym_binary_operator] = STATE(1940),
    [sym_extract_operator] = STATE(1940),
    [sym_namespace_operator] = STATE(1940),
    [sym_integer] = STATE(1940),
    [sym_complex] = STATE(1940),
    [sym_float] = STATE(1940),
    [sym__hex_literal] = STATE(2656),
    [sym__float_literal] = STATE(2656),
    [sym_string] = STATE(2606),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym_na] = STATE(1940),
    [sym__expression] = STATE(1940),
    [sym__string_or_identifier] = STATE(5141),
    [sym__open_parenthesis] = STATE(218),
    [sym__open_brace] = STATE(185),
    [sym__close_bracket2] = STATE(2587),
    [aux_sym_call_arguments_repeat1] = STATE(1905),
    [sym_identifier] = ACTIONS(6369),
    [anon_sym_BSLASH] = ACTIONS(4644),
    [anon_sym_function] = ACTIONS(4646),
    [anon_sym_if] = ACTIONS(4648),
    [anon_sym_for] = ACTIONS(4650),
    [anon_sym_while] = ACTIONS(4652),
    [anon_sym_repeat] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(6371),
    [anon_sym_PLUS] = ACTIONS(4662),
    [anon_sym_DASH] = ACTIONS(4662),
    [aux_sym__hex_literal_token1] = ACTIONS(4666),
    [sym__number_literal] = ACTIONS(4668),
    [anon_sym_SQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4672),
    [sym_return] = ACTIONS(6373),
    [sym_next] = ACTIONS(6373),
    [sym_break] = ACTIONS(6373),
    [sym_true] = ACTIONS(6373),
    [sym_false] = ACTIONS(6373),
    [sym_null] = ACTIONS(6373),
    [sym_inf] = ACTIONS(6373),
    [sym_nan] = ACTIONS(6373),
    [anon_sym_NA] = ACTIONS(4676),
    [anon_sym_NA_integer_] = ACTIONS(4676),
    [anon_sym_NA_real_] = ACTIONS(4676),
    [anon_sym_NA_complex_] = ACTIONS(4676),
    [anon_sym_NA_character_] = ACTIONS(4676),
    [sym_dots] = ACTIONS(6375),
    [sym_dot_dot_i] = ACTIONS(6377),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6379),
    [sym__newline] = ACTIONS(6381),
    [sym__raw_string_literal] = ACTIONS(4680),
    [sym__external_open_parenthesis] = ACTIONS(4682),
    [sym__external_open_brace] = ACTIONS(4684),
    [sym__external_close_bracket2] = ACTIONS(6607),
  },
  [1416] = {
    [sym_function_definition] = STATE(2038),
    [sym_if_statement] = STATE(2038),
    [sym_for_statement] = STATE(2038),
    [sym_while_statement] = STATE(2038),
    [sym_repeat_statement] = STATE(2038),
    [sym_braced_expression] = STATE(2038),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_call] = STATE(2038),
    [sym_subset] = STATE(2038),
    [sym_subset2] = STATE(2038),
    [sym__argument] = STATE(4664),
    [sym_argument] = STATE(4659),
    [sym__argument_named] = STATE(4654),
    [sym__argument_unnamed] = STATE(4676),
    [sym__argument_value] = STATE(4677),
    [sym_unary_operator] = STATE(2038),
    [sym_binary_operator] = STATE(2038),
    [sym_extract_operator] = STATE(2038),
    [sym_namespace_operator] = STATE(2038),
    [sym_integer] = STATE(2038),
    [sym_complex] = STATE(2038),
    [sym_float] = STATE(2038),
    [sym__hex_literal] = STATE(2700),
    [sym__float_literal] = STATE(2700),
    [sym_string] = STATE(2597),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym_na] = STATE(2038),
    [sym__expression] = STATE(2038),
    [sym__string_or_identifier] = STATE(5148),
    [sym__open_parenthesis] = STATE(214),
    [sym__open_brace] = STATE(192),
    [sym__close_bracket] = STATE(3012),
    [aux_sym_call_arguments_repeat1] = STATE(1894),
    [sym_identifier] = ACTIONS(6351),
    [anon_sym_BSLASH] = ACTIONS(4754),
    [anon_sym_function] = ACTIONS(4756),
    [anon_sym_if] = ACTIONS(4758),
    [anon_sym_for] = ACTIONS(4760),
    [anon_sym_while] = ACTIONS(4762),
    [anon_sym_repeat] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4766),
    [anon_sym_TILDE] = ACTIONS(4768),
    [anon_sym_BANG] = ACTIONS(6353),
    [anon_sym_PLUS] = ACTIONS(4772),
    [anon_sym_DASH] = ACTIONS(4772),
    [aux_sym__hex_literal_token1] = ACTIONS(4776),
    [sym__number_literal] = ACTIONS(4778),
    [anon_sym_SQUOTE] = ACTIONS(4780),
    [anon_sym_DQUOTE] = ACTIONS(4782),
    [sym_return] = ACTIONS(6355),
    [sym_next] = ACTIONS(6355),
    [sym_break] = ACTIONS(6355),
    [sym_true] = ACTIONS(6355),
    [sym_false] = ACTIONS(6355),
    [sym_null] = ACTIONS(6355),
    [sym_inf] = ACTIONS(6355),
    [sym_nan] = ACTIONS(6355),
    [anon_sym_NA] = ACTIONS(4786),
    [anon_sym_NA_integer_] = ACTIONS(4786),
    [anon_sym_NA_real_] = ACTIONS(4786),
    [anon_sym_NA_complex_] = ACTIONS(4786),
    [anon_sym_NA_character_] = ACTIONS(4786),
    [sym_dots] = ACTIONS(6357),
    [sym_dot_dot_i] = ACTIONS(6359),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6361),
    [sym__newline] = ACTIONS(6363),
    [sym__raw_string_literal] = ACTIONS(4790),
    [sym__external_open_parenthesis] = ACTIONS(4792),
    [sym__external_open_brace] = ACTIONS(4794),
    [sym__external_close_bracket] = ACTIONS(6609),
  },
  [1417] = {
    [sym_function_definition] = STATE(1940),
    [sym_if_statement] = STATE(1940),
    [sym_for_statement] = STATE(1940),
    [sym_while_statement] = STATE(1940),
    [sym_repeat_statement] = STATE(1940),
    [sym_braced_expression] = STATE(1940),
    [sym_parenthesized_expression] = STATE(1940),
    [sym_call] = STATE(1940),
    [sym_subset] = STATE(1940),
    [sym_subset2] = STATE(1940),
    [sym__argument] = STATE(4665),
    [sym_argument] = STATE(4661),
    [sym__argument_named] = STATE(4669),
    [sym__argument_unnamed] = STATE(4673),
    [sym__argument_value] = STATE(4679),
    [sym_unary_operator] = STATE(1940),
    [sym_binary_operator] = STATE(1940),
    [sym_extract_operator] = STATE(1940),
    [sym_namespace_operator] = STATE(1940),
    [sym_integer] = STATE(1940),
    [sym_complex] = STATE(1940),
    [sym_float] = STATE(1940),
    [sym__hex_literal] = STATE(2656),
    [sym__float_literal] = STATE(2656),
    [sym_string] = STATE(2606),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym_na] = STATE(1940),
    [sym__expression] = STATE(1940),
    [sym__string_or_identifier] = STATE(5141),
    [sym__open_parenthesis] = STATE(218),
    [sym__open_brace] = STATE(185),
    [sym__close_bracket2] = STATE(2495),
    [aux_sym_call_arguments_repeat1] = STATE(1912),
    [sym_identifier] = ACTIONS(6369),
    [anon_sym_BSLASH] = ACTIONS(4644),
    [anon_sym_function] = ACTIONS(4646),
    [anon_sym_if] = ACTIONS(4648),
    [anon_sym_for] = ACTIONS(4650),
    [anon_sym_while] = ACTIONS(4652),
    [anon_sym_repeat] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(6371),
    [anon_sym_PLUS] = ACTIONS(4662),
    [anon_sym_DASH] = ACTIONS(4662),
    [aux_sym__hex_literal_token1] = ACTIONS(4666),
    [sym__number_literal] = ACTIONS(4668),
    [anon_sym_SQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4672),
    [sym_return] = ACTIONS(6373),
    [sym_next] = ACTIONS(6373),
    [sym_break] = ACTIONS(6373),
    [sym_true] = ACTIONS(6373),
    [sym_false] = ACTIONS(6373),
    [sym_null] = ACTIONS(6373),
    [sym_inf] = ACTIONS(6373),
    [sym_nan] = ACTIONS(6373),
    [anon_sym_NA] = ACTIONS(4676),
    [anon_sym_NA_integer_] = ACTIONS(4676),
    [anon_sym_NA_real_] = ACTIONS(4676),
    [anon_sym_NA_complex_] = ACTIONS(4676),
    [anon_sym_NA_character_] = ACTIONS(4676),
    [sym_dots] = ACTIONS(6375),
    [sym_dot_dot_i] = ACTIONS(6377),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6379),
    [sym__newline] = ACTIONS(6381),
    [sym__raw_string_literal] = ACTIONS(4680),
    [sym__external_open_parenthesis] = ACTIONS(4682),
    [sym__external_open_brace] = ACTIONS(4684),
    [sym__external_close_bracket2] = ACTIONS(6611),
  },
  [1418] = {
    [sym_function_definition] = STATE(2038),
    [sym_if_statement] = STATE(2038),
    [sym_for_statement] = STATE(2038),
    [sym_while_statement] = STATE(2038),
    [sym_repeat_statement] = STATE(2038),
    [sym_braced_expression] = STATE(2038),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_call] = STATE(2038),
    [sym_subset] = STATE(2038),
    [sym_subset2] = STATE(2038),
    [sym__argument] = STATE(4664),
    [sym_argument] = STATE(4659),
    [sym__argument_named] = STATE(4654),
    [sym__argument_unnamed] = STATE(4676),
    [sym__argument_value] = STATE(4677),
    [sym_unary_operator] = STATE(2038),
    [sym_binary_operator] = STATE(2038),
    [sym_extract_operator] = STATE(2038),
    [sym_namespace_operator] = STATE(2038),
    [sym_integer] = STATE(2038),
    [sym_complex] = STATE(2038),
    [sym_float] = STATE(2038),
    [sym__hex_literal] = STATE(2700),
    [sym__float_literal] = STATE(2700),
    [sym_string] = STATE(2597),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym_na] = STATE(2038),
    [sym__expression] = STATE(2038),
    [sym__string_or_identifier] = STATE(5148),
    [sym__open_parenthesis] = STATE(214),
    [sym__open_brace] = STATE(192),
    [sym__close_bracket] = STATE(2775),
    [aux_sym_call_arguments_repeat1] = STATE(2034),
    [sym_identifier] = ACTIONS(6351),
    [anon_sym_BSLASH] = ACTIONS(4754),
    [anon_sym_function] = ACTIONS(4756),
    [anon_sym_if] = ACTIONS(4758),
    [anon_sym_for] = ACTIONS(4760),
    [anon_sym_while] = ACTIONS(4762),
    [anon_sym_repeat] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4766),
    [anon_sym_TILDE] = ACTIONS(4768),
    [anon_sym_BANG] = ACTIONS(6353),
    [anon_sym_PLUS] = ACTIONS(4772),
    [anon_sym_DASH] = ACTIONS(4772),
    [aux_sym__hex_literal_token1] = ACTIONS(4776),
    [sym__number_literal] = ACTIONS(4778),
    [anon_sym_SQUOTE] = ACTIONS(4780),
    [anon_sym_DQUOTE] = ACTIONS(4782),
    [sym_return] = ACTIONS(6355),
    [sym_next] = ACTIONS(6355),
    [sym_break] = ACTIONS(6355),
    [sym_true] = ACTIONS(6355),
    [sym_false] = ACTIONS(6355),
    [sym_null] = ACTIONS(6355),
    [sym_inf] = ACTIONS(6355),
    [sym_nan] = ACTIONS(6355),
    [anon_sym_NA] = ACTIONS(4786),
    [anon_sym_NA_integer_] = ACTIONS(4786),
    [anon_sym_NA_real_] = ACTIONS(4786),
    [anon_sym_NA_complex_] = ACTIONS(4786),
    [anon_sym_NA_character_] = ACTIONS(4786),
    [sym_dots] = ACTIONS(6357),
    [sym_dot_dot_i] = ACTIONS(6359),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6361),
    [sym__newline] = ACTIONS(6363),
    [sym__raw_string_literal] = ACTIONS(4790),
    [sym__external_open_parenthesis] = ACTIONS(4792),
    [sym__external_open_brace] = ACTIONS(4794),
    [sym__external_close_bracket] = ACTIONS(6613),
  },
  [1419] = {
    [sym_function_definition] = STATE(2038),
    [sym_if_statement] = STATE(2038),
    [sym_for_statement] = STATE(2038),
    [sym_while_statement] = STATE(2038),
    [sym_repeat_statement] = STATE(2038),
    [sym_braced_expression] = STATE(2038),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_call] = STATE(2038),
    [sym_subset] = STATE(2038),
    [sym_subset2] = STATE(2038),
    [sym__argument] = STATE(4664),
    [sym_argument] = STATE(4659),
    [sym__argument_named] = STATE(4654),
    [sym__argument_unnamed] = STATE(4676),
    [sym__argument_value] = STATE(4677),
    [sym_unary_operator] = STATE(2038),
    [sym_binary_operator] = STATE(2038),
    [sym_extract_operator] = STATE(2038),
    [sym_namespace_operator] = STATE(2038),
    [sym_integer] = STATE(2038),
    [sym_complex] = STATE(2038),
    [sym_float] = STATE(2038),
    [sym__hex_literal] = STATE(2700),
    [sym__float_literal] = STATE(2700),
    [sym_string] = STATE(2597),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym_na] = STATE(2038),
    [sym__expression] = STATE(2038),
    [sym__string_or_identifier] = STATE(5148),
    [sym__open_parenthesis] = STATE(214),
    [sym__open_brace] = STATE(192),
    [sym__close_bracket] = STATE(2585),
    [aux_sym_call_arguments_repeat1] = STATE(1904),
    [sym_identifier] = ACTIONS(6351),
    [anon_sym_BSLASH] = ACTIONS(4754),
    [anon_sym_function] = ACTIONS(4756),
    [anon_sym_if] = ACTIONS(4758),
    [anon_sym_for] = ACTIONS(4760),
    [anon_sym_while] = ACTIONS(4762),
    [anon_sym_repeat] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4766),
    [anon_sym_TILDE] = ACTIONS(4768),
    [anon_sym_BANG] = ACTIONS(6353),
    [anon_sym_PLUS] = ACTIONS(4772),
    [anon_sym_DASH] = ACTIONS(4772),
    [aux_sym__hex_literal_token1] = ACTIONS(4776),
    [sym__number_literal] = ACTIONS(4778),
    [anon_sym_SQUOTE] = ACTIONS(4780),
    [anon_sym_DQUOTE] = ACTIONS(4782),
    [sym_return] = ACTIONS(6355),
    [sym_next] = ACTIONS(6355),
    [sym_break] = ACTIONS(6355),
    [sym_true] = ACTIONS(6355),
    [sym_false] = ACTIONS(6355),
    [sym_null] = ACTIONS(6355),
    [sym_inf] = ACTIONS(6355),
    [sym_nan] = ACTIONS(6355),
    [anon_sym_NA] = ACTIONS(4786),
    [anon_sym_NA_integer_] = ACTIONS(4786),
    [anon_sym_NA_real_] = ACTIONS(4786),
    [anon_sym_NA_complex_] = ACTIONS(4786),
    [anon_sym_NA_character_] = ACTIONS(4786),
    [sym_dots] = ACTIONS(6357),
    [sym_dot_dot_i] = ACTIONS(6359),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6361),
    [sym__newline] = ACTIONS(6363),
    [sym__raw_string_literal] = ACTIONS(4790),
    [sym__external_open_parenthesis] = ACTIONS(4792),
    [sym__external_open_brace] = ACTIONS(4794),
    [sym__external_close_bracket] = ACTIONS(6615),
  },
  [1420] = {
    [sym_function_definition] = STATE(1940),
    [sym_if_statement] = STATE(1940),
    [sym_for_statement] = STATE(1940),
    [sym_while_statement] = STATE(1940),
    [sym_repeat_statement] = STATE(1940),
    [sym_braced_expression] = STATE(1940),
    [sym_parenthesized_expression] = STATE(1940),
    [sym_call] = STATE(1940),
    [sym_subset] = STATE(1940),
    [sym_subset2] = STATE(1940),
    [sym__argument] = STATE(4665),
    [sym_argument] = STATE(4661),
    [sym__argument_named] = STATE(4669),
    [sym__argument_unnamed] = STATE(4673),
    [sym__argument_value] = STATE(4679),
    [sym_unary_operator] = STATE(1940),
    [sym_binary_operator] = STATE(1940),
    [sym_extract_operator] = STATE(1940),
    [sym_namespace_operator] = STATE(1940),
    [sym_integer] = STATE(1940),
    [sym_complex] = STATE(1940),
    [sym_float] = STATE(1940),
    [sym__hex_literal] = STATE(2656),
    [sym__float_literal] = STATE(2656),
    [sym_string] = STATE(2606),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym_na] = STATE(1940),
    [sym__expression] = STATE(1940),
    [sym__string_or_identifier] = STATE(5141),
    [sym__open_parenthesis] = STATE(218),
    [sym__open_brace] = STATE(185),
    [sym__close_bracket2] = STATE(2776),
    [aux_sym_call_arguments_repeat1] = STATE(1912),
    [sym_identifier] = ACTIONS(6369),
    [anon_sym_BSLASH] = ACTIONS(4644),
    [anon_sym_function] = ACTIONS(4646),
    [anon_sym_if] = ACTIONS(4648),
    [anon_sym_for] = ACTIONS(4650),
    [anon_sym_while] = ACTIONS(4652),
    [anon_sym_repeat] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(6371),
    [anon_sym_PLUS] = ACTIONS(4662),
    [anon_sym_DASH] = ACTIONS(4662),
    [aux_sym__hex_literal_token1] = ACTIONS(4666),
    [sym__number_literal] = ACTIONS(4668),
    [anon_sym_SQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4672),
    [sym_return] = ACTIONS(6373),
    [sym_next] = ACTIONS(6373),
    [sym_break] = ACTIONS(6373),
    [sym_true] = ACTIONS(6373),
    [sym_false] = ACTIONS(6373),
    [sym_null] = ACTIONS(6373),
    [sym_inf] = ACTIONS(6373),
    [sym_nan] = ACTIONS(6373),
    [anon_sym_NA] = ACTIONS(4676),
    [anon_sym_NA_integer_] = ACTIONS(4676),
    [anon_sym_NA_real_] = ACTIONS(4676),
    [anon_sym_NA_complex_] = ACTIONS(4676),
    [anon_sym_NA_character_] = ACTIONS(4676),
    [sym_dots] = ACTIONS(6375),
    [sym_dot_dot_i] = ACTIONS(6377),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6379),
    [sym__newline] = ACTIONS(6381),
    [sym__raw_string_literal] = ACTIONS(4680),
    [sym__external_open_parenthesis] = ACTIONS(4682),
    [sym__external_open_brace] = ACTIONS(4684),
    [sym__external_close_bracket2] = ACTIONS(6617),
  },
  [1421] = {
    [sym_function_definition] = STATE(2038),
    [sym_if_statement] = STATE(2038),
    [sym_for_statement] = STATE(2038),
    [sym_while_statement] = STATE(2038),
    [sym_repeat_statement] = STATE(2038),
    [sym_braced_expression] = STATE(2038),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_call] = STATE(2038),
    [sym_subset] = STATE(2038),
    [sym_subset2] = STATE(2038),
    [sym__argument] = STATE(4664),
    [sym_argument] = STATE(4659),
    [sym__argument_named] = STATE(4654),
    [sym__argument_unnamed] = STATE(4676),
    [sym__argument_value] = STATE(4677),
    [sym_unary_operator] = STATE(2038),
    [sym_binary_operator] = STATE(2038),
    [sym_extract_operator] = STATE(2038),
    [sym_namespace_operator] = STATE(2038),
    [sym_integer] = STATE(2038),
    [sym_complex] = STATE(2038),
    [sym_float] = STATE(2038),
    [sym__hex_literal] = STATE(2700),
    [sym__float_literal] = STATE(2700),
    [sym_string] = STATE(2597),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym_na] = STATE(2038),
    [sym__expression] = STATE(2038),
    [sym__string_or_identifier] = STATE(5148),
    [sym__open_parenthesis] = STATE(214),
    [sym__open_brace] = STATE(192),
    [sym__close_bracket] = STATE(2414),
    [aux_sym_call_arguments_repeat1] = STATE(2034),
    [sym_identifier] = ACTIONS(6351),
    [anon_sym_BSLASH] = ACTIONS(4754),
    [anon_sym_function] = ACTIONS(4756),
    [anon_sym_if] = ACTIONS(4758),
    [anon_sym_for] = ACTIONS(4760),
    [anon_sym_while] = ACTIONS(4762),
    [anon_sym_repeat] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4766),
    [anon_sym_TILDE] = ACTIONS(4768),
    [anon_sym_BANG] = ACTIONS(6353),
    [anon_sym_PLUS] = ACTIONS(4772),
    [anon_sym_DASH] = ACTIONS(4772),
    [aux_sym__hex_literal_token1] = ACTIONS(4776),
    [sym__number_literal] = ACTIONS(4778),
    [anon_sym_SQUOTE] = ACTIONS(4780),
    [anon_sym_DQUOTE] = ACTIONS(4782),
    [sym_return] = ACTIONS(6355),
    [sym_next] = ACTIONS(6355),
    [sym_break] = ACTIONS(6355),
    [sym_true] = ACTIONS(6355),
    [sym_false] = ACTIONS(6355),
    [sym_null] = ACTIONS(6355),
    [sym_inf] = ACTIONS(6355),
    [sym_nan] = ACTIONS(6355),
    [anon_sym_NA] = ACTIONS(4786),
    [anon_sym_NA_integer_] = ACTIONS(4786),
    [anon_sym_NA_real_] = ACTIONS(4786),
    [anon_sym_NA_complex_] = ACTIONS(4786),
    [anon_sym_NA_character_] = ACTIONS(4786),
    [sym_dots] = ACTIONS(6357),
    [sym_dot_dot_i] = ACTIONS(6359),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6361),
    [sym__newline] = ACTIONS(6363),
    [sym__raw_string_literal] = ACTIONS(4790),
    [sym__external_open_parenthesis] = ACTIONS(4792),
    [sym__external_open_brace] = ACTIONS(4794),
    [sym__external_close_bracket] = ACTIONS(6619),
  },
  [1422] = {
    [sym_call_arguments] = STATE(2777),
    [sym_subset_arguments] = STATE(2779),
    [sym_subset2_arguments] = STATE(2786),
    [sym__open_parenthesis] = STATE(1411),
    [sym__open_bracket] = STATE(1409),
    [sym__open_bracket2] = STATE(1407),
    [ts_builtin_sym_end] = ACTIONS(5333),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(6497),
    [anon_sym_DASH] = ACTIONS(6499),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5335),
    [anon_sym_AMP] = ACTIONS(5335),
    [anon_sym_PIPE_PIPE] = ACTIONS(5333),
    [anon_sym_AMP_AMP] = ACTIONS(5333),
    [anon_sym_LT] = ACTIONS(6515),
    [anon_sym_LT_EQ] = ACTIONS(6517),
    [anon_sym_GT] = ACTIONS(6515),
    [anon_sym_GT_EQ] = ACTIONS(6517),
    [anon_sym_EQ_EQ] = ACTIONS(6517),
    [anon_sym_BANG_EQ] = ACTIONS(6517),
    [anon_sym_STAR] = ACTIONS(6519),
    [anon_sym_SLASH] = ACTIONS(6521),
    [anon_sym_STAR_STAR] = ACTIONS(6523),
    [anon_sym_CARET] = ACTIONS(6523),
    [aux_sym_binary_operator_token1] = ACTIONS(6525),
    [anon_sym_PIPE_GT] = ACTIONS(6525),
    [anon_sym_COLON] = ACTIONS(6527),
    [anon_sym_DOLLAR] = ACTIONS(6529),
    [anon_sym_AT] = ACTIONS(6529),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5333),
    [sym__semicolon] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(6531),
    [sym__external_close_parenthesis] = ACTIONS(5333),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(6533),
    [sym__external_open_bracket2] = ACTIONS(6535),
  },
  [1423] = {
    [sym_function_definition] = STATE(1931),
    [sym_if_statement] = STATE(1931),
    [sym_for_statement] = STATE(1931),
    [sym_while_statement] = STATE(1931),
    [sym_repeat_statement] = STATE(1931),
    [sym_braced_expression] = STATE(1931),
    [sym_parenthesized_expression] = STATE(1931),
    [sym_call] = STATE(1931),
    [sym_subset] = STATE(1931),
    [sym_subset2] = STATE(1931),
    [sym__argument] = STATE(4656),
    [sym_argument] = STATE(4657),
    [sym__argument_named] = STATE(4658),
    [sym__argument_unnamed] = STATE(4662),
    [sym__argument_value] = STATE(4663),
    [sym_unary_operator] = STATE(1931),
    [sym_binary_operator] = STATE(1931),
    [sym_extract_operator] = STATE(1931),
    [sym_namespace_operator] = STATE(1931),
    [sym_integer] = STATE(1931),
    [sym_complex] = STATE(1931),
    [sym_float] = STATE(1931),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2633),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(1931),
    [sym__expression] = STATE(1931),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__close_parenthesis] = STATE(2584),
    [sym__open_brace] = STATE(154),
    [aux_sym_call_arguments_repeat1] = STATE(1488),
    [sym_identifier] = ACTIONS(6387),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(6389),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3865),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(6391),
    [sym_next] = ACTIONS(6391),
    [sym_break] = ACTIONS(6391),
    [sym_true] = ACTIONS(6391),
    [sym_false] = ACTIONS(6391),
    [sym_null] = ACTIONS(6391),
    [sym_inf] = ACTIONS(6391),
    [sym_nan] = ACTIONS(6391),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(6393),
    [sym_dot_dot_i] = ACTIONS(6395),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6397),
    [sym__newline] = ACTIONS(6399),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(6621),
    [sym__external_open_brace] = ACTIONS(3891),
  },
  [1424] = {
    [sym_function_definition] = STATE(1931),
    [sym_if_statement] = STATE(1931),
    [sym_for_statement] = STATE(1931),
    [sym_while_statement] = STATE(1931),
    [sym_repeat_statement] = STATE(1931),
    [sym_braced_expression] = STATE(1931),
    [sym_parenthesized_expression] = STATE(1931),
    [sym_call] = STATE(1931),
    [sym_subset] = STATE(1931),
    [sym_subset2] = STATE(1931),
    [sym__argument] = STATE(4656),
    [sym_argument] = STATE(4657),
    [sym__argument_named] = STATE(4658),
    [sym__argument_unnamed] = STATE(4662),
    [sym__argument_value] = STATE(4663),
    [sym_unary_operator] = STATE(1931),
    [sym_binary_operator] = STATE(1931),
    [sym_extract_operator] = STATE(1931),
    [sym_namespace_operator] = STATE(1931),
    [sym_integer] = STATE(1931),
    [sym_complex] = STATE(1931),
    [sym_float] = STATE(1931),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2633),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(1931),
    [sym__expression] = STATE(1931),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__close_parenthesis] = STATE(2242),
    [sym__open_brace] = STATE(154),
    [aux_sym_call_arguments_repeat1] = STATE(2113),
    [sym_identifier] = ACTIONS(6387),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(6389),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3865),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(6391),
    [sym_next] = ACTIONS(6391),
    [sym_break] = ACTIONS(6391),
    [sym_true] = ACTIONS(6391),
    [sym_false] = ACTIONS(6391),
    [sym_null] = ACTIONS(6391),
    [sym_inf] = ACTIONS(6391),
    [sym_nan] = ACTIONS(6391),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(6393),
    [sym_dot_dot_i] = ACTIONS(6395),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6397),
    [sym__newline] = ACTIONS(6399),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(6623),
    [sym__external_open_brace] = ACTIONS(3891),
  },
  [1425] = {
    [sym_function_definition] = STATE(1940),
    [sym_if_statement] = STATE(1940),
    [sym_for_statement] = STATE(1940),
    [sym_while_statement] = STATE(1940),
    [sym_repeat_statement] = STATE(1940),
    [sym_braced_expression] = STATE(1940),
    [sym_parenthesized_expression] = STATE(1940),
    [sym_call] = STATE(1940),
    [sym_subset] = STATE(1940),
    [sym_subset2] = STATE(1940),
    [sym__argument] = STATE(4665),
    [sym_argument] = STATE(4661),
    [sym__argument_named] = STATE(4669),
    [sym__argument_unnamed] = STATE(4673),
    [sym__argument_value] = STATE(4679),
    [sym_unary_operator] = STATE(1940),
    [sym_binary_operator] = STATE(1940),
    [sym_extract_operator] = STATE(1940),
    [sym_namespace_operator] = STATE(1940),
    [sym_integer] = STATE(1940),
    [sym_complex] = STATE(1940),
    [sym_float] = STATE(1940),
    [sym__hex_literal] = STATE(2656),
    [sym__float_literal] = STATE(2656),
    [sym_string] = STATE(2606),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym_na] = STATE(1940),
    [sym__expression] = STATE(1940),
    [sym__string_or_identifier] = STATE(5141),
    [sym__open_parenthesis] = STATE(218),
    [sym__open_brace] = STATE(185),
    [sym__close_bracket2] = STATE(2695),
    [aux_sym_call_arguments_repeat1] = STATE(1796),
    [sym_identifier] = ACTIONS(6369),
    [anon_sym_BSLASH] = ACTIONS(4644),
    [anon_sym_function] = ACTIONS(4646),
    [anon_sym_if] = ACTIONS(4648),
    [anon_sym_for] = ACTIONS(4650),
    [anon_sym_while] = ACTIONS(4652),
    [anon_sym_repeat] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(6371),
    [anon_sym_PLUS] = ACTIONS(4662),
    [anon_sym_DASH] = ACTIONS(4662),
    [aux_sym__hex_literal_token1] = ACTIONS(4666),
    [sym__number_literal] = ACTIONS(4668),
    [anon_sym_SQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4672),
    [sym_return] = ACTIONS(6373),
    [sym_next] = ACTIONS(6373),
    [sym_break] = ACTIONS(6373),
    [sym_true] = ACTIONS(6373),
    [sym_false] = ACTIONS(6373),
    [sym_null] = ACTIONS(6373),
    [sym_inf] = ACTIONS(6373),
    [sym_nan] = ACTIONS(6373),
    [anon_sym_NA] = ACTIONS(4676),
    [anon_sym_NA_integer_] = ACTIONS(4676),
    [anon_sym_NA_real_] = ACTIONS(4676),
    [anon_sym_NA_complex_] = ACTIONS(4676),
    [anon_sym_NA_character_] = ACTIONS(4676),
    [sym_dots] = ACTIONS(6375),
    [sym_dot_dot_i] = ACTIONS(6377),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6379),
    [sym__newline] = ACTIONS(6381),
    [sym__raw_string_literal] = ACTIONS(4680),
    [sym__external_open_parenthesis] = ACTIONS(4682),
    [sym__external_open_brace] = ACTIONS(4684),
    [sym__external_close_bracket2] = ACTIONS(6625),
  },
  [1426] = {
    [sym_call_arguments] = STATE(2763),
    [sym_subset_arguments] = STATE(2764),
    [sym_subset2_arguments] = STATE(2765),
    [sym__open_parenthesis] = STATE(1584),
    [sym__open_bracket] = STATE(1582),
    [sym__open_bracket2] = STATE(1577),
    [sym_identifier] = ACTIONS(5401),
    [anon_sym_BSLASH] = ACTIONS(5399),
    [anon_sym_function] = ACTIONS(5401),
    [anon_sym_EQ] = ACTIONS(6431),
    [anon_sym_if] = ACTIONS(5401),
    [anon_sym_for] = ACTIONS(5401),
    [anon_sym_while] = ACTIONS(5401),
    [anon_sym_repeat] = ACTIONS(5401),
    [anon_sym_QMARK] = ACTIONS(5399),
    [anon_sym_TILDE] = ACTIONS(6433),
    [anon_sym_BANG] = ACTIONS(5401),
    [anon_sym_PLUS] = ACTIONS(6435),
    [anon_sym_DASH] = ACTIONS(6437),
    [anon_sym_LT_DASH] = ACTIONS(6439),
    [anon_sym_LT_LT_DASH] = ACTIONS(6439),
    [anon_sym_COLON_EQ] = ACTIONS(6439),
    [anon_sym_DASH_GT] = ACTIONS(6441),
    [anon_sym_DASH_GT_GT] = ACTIONS(6443),
    [anon_sym_PIPE] = ACTIONS(6445),
    [anon_sym_AMP] = ACTIONS(6447),
    [anon_sym_PIPE_PIPE] = ACTIONS(6449),
    [anon_sym_AMP_AMP] = ACTIONS(6451),
    [anon_sym_LT] = ACTIONS(6453),
    [anon_sym_LT_EQ] = ACTIONS(6455),
    [anon_sym_GT] = ACTIONS(6453),
    [anon_sym_GT_EQ] = ACTIONS(6455),
    [anon_sym_EQ_EQ] = ACTIONS(6455),
    [anon_sym_BANG_EQ] = ACTIONS(6455),
    [anon_sym_STAR] = ACTIONS(6457),
    [anon_sym_SLASH] = ACTIONS(6459),
    [anon_sym_STAR_STAR] = ACTIONS(6461),
    [anon_sym_CARET] = ACTIONS(6461),
    [aux_sym_binary_operator_token1] = ACTIONS(6463),
    [anon_sym_PIPE_GT] = ACTIONS(6463),
    [anon_sym_COLON] = ACTIONS(6465),
    [anon_sym_DOLLAR] = ACTIONS(6467),
    [anon_sym_AT] = ACTIONS(6467),
    [aux_sym__hex_literal_token1] = ACTIONS(5399),
    [sym__number_literal] = ACTIONS(5401),
    [anon_sym_SQUOTE] = ACTIONS(5399),
    [anon_sym_DQUOTE] = ACTIONS(5399),
    [sym_return] = ACTIONS(5401),
    [sym_next] = ACTIONS(5401),
    [sym_break] = ACTIONS(5401),
    [sym_true] = ACTIONS(5401),
    [sym_false] = ACTIONS(5401),
    [sym_null] = ACTIONS(5401),
    [sym_inf] = ACTIONS(5401),
    [sym_nan] = ACTIONS(5401),
    [anon_sym_NA] = ACTIONS(5401),
    [anon_sym_NA_integer_] = ACTIONS(5401),
    [anon_sym_NA_real_] = ACTIONS(5401),
    [anon_sym_NA_complex_] = ACTIONS(5401),
    [anon_sym_NA_character_] = ACTIONS(5401),
    [sym_dots] = ACTIONS(5401),
    [sym_dot_dot_i] = ACTIONS(5399),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5399),
    [sym__newline] = ACTIONS(5399),
    [sym__raw_string_literal] = ACTIONS(5399),
    [sym__external_open_parenthesis] = ACTIONS(6469),
    [sym__external_close_parenthesis] = ACTIONS(5399),
    [sym__external_open_brace] = ACTIONS(5399),
    [sym__external_open_bracket] = ACTIONS(6471),
    [sym__external_close_bracket] = ACTIONS(5399),
    [sym__external_open_bracket2] = ACTIONS(6473),
  },
  [1427] = {
    [sym_string] = STATE(2717),
    [sym__single_quoted_string] = STATE(2273),
    [sym__double_quoted_string] = STATE(2274),
    [sym__string_or_identifier] = STATE(2717),
    [aux_sym_function_definition_repeat1] = STATE(1389),
    [sym_identifier] = ACTIONS(6627),
    [anon_sym_BSLASH] = ACTIONS(5659),
    [anon_sym_function] = ACTIONS(5663),
    [anon_sym_EQ] = ACTIONS(5663),
    [anon_sym_if] = ACTIONS(5663),
    [anon_sym_for] = ACTIONS(5663),
    [anon_sym_while] = ACTIONS(5663),
    [anon_sym_repeat] = ACTIONS(5663),
    [anon_sym_QMARK] = ACTIONS(5659),
    [anon_sym_TILDE] = ACTIONS(5659),
    [anon_sym_BANG] = ACTIONS(5663),
    [anon_sym_PLUS] = ACTIONS(5659),
    [anon_sym_DASH] = ACTIONS(5663),
    [anon_sym_LT_DASH] = ACTIONS(5659),
    [anon_sym_LT_LT_DASH] = ACTIONS(5659),
    [anon_sym_COLON_EQ] = ACTIONS(5659),
    [anon_sym_DASH_GT] = ACTIONS(5663),
    [anon_sym_DASH_GT_GT] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(5663),
    [anon_sym_AMP] = ACTIONS(5663),
    [anon_sym_PIPE_PIPE] = ACTIONS(5659),
    [anon_sym_AMP_AMP] = ACTIONS(5659),
    [anon_sym_LT] = ACTIONS(5663),
    [anon_sym_LT_EQ] = ACTIONS(5659),
    [anon_sym_GT] = ACTIONS(5663),
    [anon_sym_GT_EQ] = ACTIONS(5659),
    [anon_sym_EQ_EQ] = ACTIONS(5659),
    [anon_sym_BANG_EQ] = ACTIONS(5659),
    [anon_sym_STAR] = ACTIONS(5663),
    [anon_sym_SLASH] = ACTIONS(5659),
    [anon_sym_STAR_STAR] = ACTIONS(5659),
    [anon_sym_CARET] = ACTIONS(5659),
    [aux_sym_binary_operator_token1] = ACTIONS(5659),
    [anon_sym_PIPE_GT] = ACTIONS(5659),
    [anon_sym_COLON] = ACTIONS(5663),
    [anon_sym_DOLLAR] = ACTIONS(5659),
    [anon_sym_AT] = ACTIONS(5659),
    [aux_sym__hex_literal_token1] = ACTIONS(5659),
    [sym__number_literal] = ACTIONS(5663),
    [anon_sym_SQUOTE] = ACTIONS(1269),
    [anon_sym_DQUOTE] = ACTIONS(1271),
    [sym_return] = ACTIONS(5663),
    [sym_next] = ACTIONS(5663),
    [sym_break] = ACTIONS(5663),
    [sym_true] = ACTIONS(5663),
    [sym_false] = ACTIONS(5663),
    [sym_null] = ACTIONS(5663),
    [sym_inf] = ACTIONS(5663),
    [sym_nan] = ACTIONS(5663),
    [anon_sym_NA] = ACTIONS(5663),
    [anon_sym_NA_integer_] = ACTIONS(5663),
    [anon_sym_NA_real_] = ACTIONS(5663),
    [anon_sym_NA_complex_] = ACTIONS(5663),
    [anon_sym_NA_character_] = ACTIONS(5663),
    [sym_dots] = ACTIONS(5663),
    [sym_dot_dot_i] = ACTIONS(5659),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5659),
    [sym__newline] = ACTIONS(6629),
    [sym__raw_string_literal] = ACTIONS(1281),
    [sym__external_else] = ACTIONS(5659),
    [sym__external_open_parenthesis] = ACTIONS(5659),
    [sym__external_close_parenthesis] = ACTIONS(5659),
    [sym__external_open_brace] = ACTIONS(5659),
    [sym__external_open_bracket] = ACTIONS(5659),
    [sym__external_close_bracket] = ACTIONS(5659),
    [sym__external_open_bracket2] = ACTIONS(5659),
  },
  [1428] = {
    [sym_function_definition] = STATE(1940),
    [sym_if_statement] = STATE(1940),
    [sym_for_statement] = STATE(1940),
    [sym_while_statement] = STATE(1940),
    [sym_repeat_statement] = STATE(1940),
    [sym_braced_expression] = STATE(1940),
    [sym_parenthesized_expression] = STATE(1940),
    [sym_call] = STATE(1940),
    [sym_subset] = STATE(1940),
    [sym_subset2] = STATE(1940),
    [sym__argument] = STATE(4665),
    [sym_argument] = STATE(4661),
    [sym__argument_named] = STATE(4669),
    [sym__argument_unnamed] = STATE(4673),
    [sym__argument_value] = STATE(4679),
    [sym_unary_operator] = STATE(1940),
    [sym_binary_operator] = STATE(1940),
    [sym_extract_operator] = STATE(1940),
    [sym_namespace_operator] = STATE(1940),
    [sym_integer] = STATE(1940),
    [sym_complex] = STATE(1940),
    [sym_float] = STATE(1940),
    [sym__hex_literal] = STATE(2656),
    [sym__float_literal] = STATE(2656),
    [sym_string] = STATE(2606),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym_na] = STATE(1940),
    [sym__expression] = STATE(1940),
    [sym__string_or_identifier] = STATE(5141),
    [sym__open_parenthesis] = STATE(218),
    [sym__open_brace] = STATE(185),
    [sym__close_bracket2] = STATE(3011),
    [aux_sym_call_arguments_repeat1] = STATE(1892),
    [sym_identifier] = ACTIONS(6369),
    [anon_sym_BSLASH] = ACTIONS(4644),
    [anon_sym_function] = ACTIONS(4646),
    [anon_sym_if] = ACTIONS(4648),
    [anon_sym_for] = ACTIONS(4650),
    [anon_sym_while] = ACTIONS(4652),
    [anon_sym_repeat] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(6371),
    [anon_sym_PLUS] = ACTIONS(4662),
    [anon_sym_DASH] = ACTIONS(4662),
    [aux_sym__hex_literal_token1] = ACTIONS(4666),
    [sym__number_literal] = ACTIONS(4668),
    [anon_sym_SQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4672),
    [sym_return] = ACTIONS(6373),
    [sym_next] = ACTIONS(6373),
    [sym_break] = ACTIONS(6373),
    [sym_true] = ACTIONS(6373),
    [sym_false] = ACTIONS(6373),
    [sym_null] = ACTIONS(6373),
    [sym_inf] = ACTIONS(6373),
    [sym_nan] = ACTIONS(6373),
    [anon_sym_NA] = ACTIONS(4676),
    [anon_sym_NA_integer_] = ACTIONS(4676),
    [anon_sym_NA_real_] = ACTIONS(4676),
    [anon_sym_NA_complex_] = ACTIONS(4676),
    [anon_sym_NA_character_] = ACTIONS(4676),
    [sym_dots] = ACTIONS(6375),
    [sym_dot_dot_i] = ACTIONS(6377),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6379),
    [sym__newline] = ACTIONS(6381),
    [sym__raw_string_literal] = ACTIONS(4680),
    [sym__external_open_parenthesis] = ACTIONS(4682),
    [sym__external_open_brace] = ACTIONS(4684),
    [sym__external_close_bracket2] = ACTIONS(6631),
  },
  [1429] = {
    [sym_call_arguments] = STATE(2763),
    [sym_subset_arguments] = STATE(2764),
    [sym_subset2_arguments] = STATE(2765),
    [sym__open_parenthesis] = STATE(1584),
    [sym__open_bracket] = STATE(1582),
    [sym__open_bracket2] = STATE(1577),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(6431),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(6433),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(6435),
    [anon_sym_DASH] = ACTIONS(6437),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(6441),
    [anon_sym_DASH_GT_GT] = ACTIONS(6443),
    [anon_sym_PIPE] = ACTIONS(6445),
    [anon_sym_AMP] = ACTIONS(6447),
    [anon_sym_PIPE_PIPE] = ACTIONS(6449),
    [anon_sym_AMP_AMP] = ACTIONS(6451),
    [anon_sym_LT] = ACTIONS(6453),
    [anon_sym_LT_EQ] = ACTIONS(6455),
    [anon_sym_GT] = ACTIONS(6453),
    [anon_sym_GT_EQ] = ACTIONS(6455),
    [anon_sym_EQ_EQ] = ACTIONS(6455),
    [anon_sym_BANG_EQ] = ACTIONS(6455),
    [anon_sym_STAR] = ACTIONS(6457),
    [anon_sym_SLASH] = ACTIONS(6459),
    [anon_sym_STAR_STAR] = ACTIONS(6461),
    [anon_sym_CARET] = ACTIONS(6461),
    [aux_sym_binary_operator_token1] = ACTIONS(6463),
    [anon_sym_PIPE_GT] = ACTIONS(6463),
    [anon_sym_COLON] = ACTIONS(6465),
    [anon_sym_DOLLAR] = ACTIONS(6467),
    [anon_sym_AT] = ACTIONS(6467),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6469),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6471),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(6473),
  },
  [1430] = {
    [sym_call_arguments] = STATE(2763),
    [sym_subset_arguments] = STATE(2764),
    [sym_subset2_arguments] = STATE(2765),
    [sym__open_parenthesis] = STATE(1584),
    [sym__open_bracket] = STATE(1582),
    [sym__open_bracket2] = STATE(1577),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(6431),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(6433),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(6435),
    [anon_sym_DASH] = ACTIONS(6437),
    [anon_sym_LT_DASH] = ACTIONS(6439),
    [anon_sym_LT_LT_DASH] = ACTIONS(6439),
    [anon_sym_COLON_EQ] = ACTIONS(6439),
    [anon_sym_DASH_GT] = ACTIONS(6441),
    [anon_sym_DASH_GT_GT] = ACTIONS(6443),
    [anon_sym_PIPE] = ACTIONS(6445),
    [anon_sym_AMP] = ACTIONS(6447),
    [anon_sym_PIPE_PIPE] = ACTIONS(6449),
    [anon_sym_AMP_AMP] = ACTIONS(6451),
    [anon_sym_LT] = ACTIONS(6453),
    [anon_sym_LT_EQ] = ACTIONS(6455),
    [anon_sym_GT] = ACTIONS(6453),
    [anon_sym_GT_EQ] = ACTIONS(6455),
    [anon_sym_EQ_EQ] = ACTIONS(6455),
    [anon_sym_BANG_EQ] = ACTIONS(6455),
    [anon_sym_STAR] = ACTIONS(6457),
    [anon_sym_SLASH] = ACTIONS(6459),
    [anon_sym_STAR_STAR] = ACTIONS(6461),
    [anon_sym_CARET] = ACTIONS(6461),
    [aux_sym_binary_operator_token1] = ACTIONS(6463),
    [anon_sym_PIPE_GT] = ACTIONS(6463),
    [anon_sym_COLON] = ACTIONS(6465),
    [anon_sym_DOLLAR] = ACTIONS(6467),
    [anon_sym_AT] = ACTIONS(6467),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6469),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6471),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(6473),
  },
  [1431] = {
    [sym_call_arguments] = STATE(2763),
    [sym_subset_arguments] = STATE(2764),
    [sym_subset2_arguments] = STATE(2765),
    [sym__open_parenthesis] = STATE(1584),
    [sym__open_bracket] = STATE(1582),
    [sym__open_bracket2] = STATE(1577),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(6435),
    [anon_sym_DASH] = ACTIONS(6437),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(6445),
    [anon_sym_AMP] = ACTIONS(6447),
    [anon_sym_PIPE_PIPE] = ACTIONS(6449),
    [anon_sym_AMP_AMP] = ACTIONS(6451),
    [anon_sym_LT] = ACTIONS(6453),
    [anon_sym_LT_EQ] = ACTIONS(6455),
    [anon_sym_GT] = ACTIONS(6453),
    [anon_sym_GT_EQ] = ACTIONS(6455),
    [anon_sym_EQ_EQ] = ACTIONS(6455),
    [anon_sym_BANG_EQ] = ACTIONS(6455),
    [anon_sym_STAR] = ACTIONS(6457),
    [anon_sym_SLASH] = ACTIONS(6459),
    [anon_sym_STAR_STAR] = ACTIONS(6461),
    [anon_sym_CARET] = ACTIONS(6461),
    [aux_sym_binary_operator_token1] = ACTIONS(6463),
    [anon_sym_PIPE_GT] = ACTIONS(6463),
    [anon_sym_COLON] = ACTIONS(6465),
    [anon_sym_DOLLAR] = ACTIONS(6467),
    [anon_sym_AT] = ACTIONS(6467),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6469),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6471),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(6473),
  },
  [1432] = {
    [sym_call_arguments] = STATE(2763),
    [sym_subset_arguments] = STATE(2764),
    [sym_subset2_arguments] = STATE(2765),
    [sym__open_parenthesis] = STATE(1584),
    [sym__open_bracket] = STATE(1582),
    [sym__open_bracket2] = STATE(1577),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(6457),
    [anon_sym_SLASH] = ACTIONS(6459),
    [anon_sym_STAR_STAR] = ACTIONS(6461),
    [anon_sym_CARET] = ACTIONS(6461),
    [aux_sym_binary_operator_token1] = ACTIONS(6463),
    [anon_sym_PIPE_GT] = ACTIONS(6463),
    [anon_sym_COLON] = ACTIONS(6465),
    [anon_sym_DOLLAR] = ACTIONS(6467),
    [anon_sym_AT] = ACTIONS(6467),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6469),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6471),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(6473),
  },
  [1433] = {
    [sym_call_arguments] = STATE(2763),
    [sym_subset_arguments] = STATE(2764),
    [sym_subset2_arguments] = STATE(2765),
    [sym__open_parenthesis] = STATE(1584),
    [sym__open_bracket] = STATE(1582),
    [sym__open_bracket2] = STATE(1577),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(6431),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(6433),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(6435),
    [anon_sym_DASH] = ACTIONS(6437),
    [anon_sym_LT_DASH] = ACTIONS(6439),
    [anon_sym_LT_LT_DASH] = ACTIONS(6439),
    [anon_sym_COLON_EQ] = ACTIONS(6439),
    [anon_sym_DASH_GT] = ACTIONS(6441),
    [anon_sym_DASH_GT_GT] = ACTIONS(6443),
    [anon_sym_PIPE] = ACTIONS(6445),
    [anon_sym_AMP] = ACTIONS(6447),
    [anon_sym_PIPE_PIPE] = ACTIONS(6449),
    [anon_sym_AMP_AMP] = ACTIONS(6451),
    [anon_sym_LT] = ACTIONS(6453),
    [anon_sym_LT_EQ] = ACTIONS(6455),
    [anon_sym_GT] = ACTIONS(6453),
    [anon_sym_GT_EQ] = ACTIONS(6455),
    [anon_sym_EQ_EQ] = ACTIONS(6455),
    [anon_sym_BANG_EQ] = ACTIONS(6455),
    [anon_sym_STAR] = ACTIONS(6457),
    [anon_sym_SLASH] = ACTIONS(6459),
    [anon_sym_STAR_STAR] = ACTIONS(6461),
    [anon_sym_CARET] = ACTIONS(6461),
    [aux_sym_binary_operator_token1] = ACTIONS(6463),
    [anon_sym_PIPE_GT] = ACTIONS(6463),
    [anon_sym_COLON] = ACTIONS(6465),
    [anon_sym_DOLLAR] = ACTIONS(6467),
    [anon_sym_AT] = ACTIONS(6467),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6469),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6471),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(6473),
  },
  [1434] = {
    [sym_call_arguments] = STATE(2763),
    [sym_subset_arguments] = STATE(2764),
    [sym_subset2_arguments] = STATE(2765),
    [sym__open_parenthesis] = STATE(1584),
    [sym__open_bracket] = STATE(1582),
    [sym__open_bracket2] = STATE(1577),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(6433),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(6435),
    [anon_sym_DASH] = ACTIONS(6437),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(6445),
    [anon_sym_AMP] = ACTIONS(6447),
    [anon_sym_PIPE_PIPE] = ACTIONS(6449),
    [anon_sym_AMP_AMP] = ACTIONS(6451),
    [anon_sym_LT] = ACTIONS(6453),
    [anon_sym_LT_EQ] = ACTIONS(6455),
    [anon_sym_GT] = ACTIONS(6453),
    [anon_sym_GT_EQ] = ACTIONS(6455),
    [anon_sym_EQ_EQ] = ACTIONS(6455),
    [anon_sym_BANG_EQ] = ACTIONS(6455),
    [anon_sym_STAR] = ACTIONS(6457),
    [anon_sym_SLASH] = ACTIONS(6459),
    [anon_sym_STAR_STAR] = ACTIONS(6461),
    [anon_sym_CARET] = ACTIONS(6461),
    [aux_sym_binary_operator_token1] = ACTIONS(6463),
    [anon_sym_PIPE_GT] = ACTIONS(6463),
    [anon_sym_COLON] = ACTIONS(6465),
    [anon_sym_DOLLAR] = ACTIONS(6467),
    [anon_sym_AT] = ACTIONS(6467),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6469),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6471),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(6473),
  },
  [1435] = {
    [sym_call_arguments] = STATE(2763),
    [sym_subset_arguments] = STATE(2764),
    [sym_subset2_arguments] = STATE(2765),
    [sym__open_parenthesis] = STATE(1584),
    [sym__open_bracket] = STATE(1582),
    [sym__open_bracket2] = STATE(1577),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(6435),
    [anon_sym_DASH] = ACTIONS(6437),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(6447),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(6451),
    [anon_sym_LT] = ACTIONS(6453),
    [anon_sym_LT_EQ] = ACTIONS(6455),
    [anon_sym_GT] = ACTIONS(6453),
    [anon_sym_GT_EQ] = ACTIONS(6455),
    [anon_sym_EQ_EQ] = ACTIONS(6455),
    [anon_sym_BANG_EQ] = ACTIONS(6455),
    [anon_sym_STAR] = ACTIONS(6457),
    [anon_sym_SLASH] = ACTIONS(6459),
    [anon_sym_STAR_STAR] = ACTIONS(6461),
    [anon_sym_CARET] = ACTIONS(6461),
    [aux_sym_binary_operator_token1] = ACTIONS(6463),
    [anon_sym_PIPE_GT] = ACTIONS(6463),
    [anon_sym_COLON] = ACTIONS(6465),
    [anon_sym_DOLLAR] = ACTIONS(6467),
    [anon_sym_AT] = ACTIONS(6467),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6469),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6471),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(6473),
  },
  [1436] = {
    [sym_call_arguments] = STATE(2763),
    [sym_subset_arguments] = STATE(2764),
    [sym_subset2_arguments] = STATE(2765),
    [sym__open_parenthesis] = STATE(1584),
    [sym__open_bracket] = STATE(1582),
    [sym__open_bracket2] = STATE(1577),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(6435),
    [anon_sym_DASH] = ACTIONS(6437),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(6453),
    [anon_sym_LT_EQ] = ACTIONS(6455),
    [anon_sym_GT] = ACTIONS(6453),
    [anon_sym_GT_EQ] = ACTIONS(6455),
    [anon_sym_EQ_EQ] = ACTIONS(6455),
    [anon_sym_BANG_EQ] = ACTIONS(6455),
    [anon_sym_STAR] = ACTIONS(6457),
    [anon_sym_SLASH] = ACTIONS(6459),
    [anon_sym_STAR_STAR] = ACTIONS(6461),
    [anon_sym_CARET] = ACTIONS(6461),
    [aux_sym_binary_operator_token1] = ACTIONS(6463),
    [anon_sym_PIPE_GT] = ACTIONS(6463),
    [anon_sym_COLON] = ACTIONS(6465),
    [anon_sym_DOLLAR] = ACTIONS(6467),
    [anon_sym_AT] = ACTIONS(6467),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6469),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6471),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(6473),
  },
  [1437] = {
    [sym_call_arguments] = STATE(2763),
    [sym_subset_arguments] = STATE(2764),
    [sym_subset2_arguments] = STATE(2765),
    [sym__open_parenthesis] = STATE(1584),
    [sym__open_bracket] = STATE(1582),
    [sym__open_bracket2] = STATE(1577),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(6435),
    [anon_sym_DASH] = ACTIONS(6437),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(6457),
    [anon_sym_SLASH] = ACTIONS(6459),
    [anon_sym_STAR_STAR] = ACTIONS(6461),
    [anon_sym_CARET] = ACTIONS(6461),
    [aux_sym_binary_operator_token1] = ACTIONS(6463),
    [anon_sym_PIPE_GT] = ACTIONS(6463),
    [anon_sym_COLON] = ACTIONS(6465),
    [anon_sym_DOLLAR] = ACTIONS(6467),
    [anon_sym_AT] = ACTIONS(6467),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6469),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6471),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(6473),
  },
  [1438] = {
    [sym_call_arguments] = STATE(2763),
    [sym_subset_arguments] = STATE(2764),
    [sym_subset2_arguments] = STATE(2765),
    [sym__open_parenthesis] = STATE(1584),
    [sym__open_bracket] = STATE(1582),
    [sym__open_bracket2] = STATE(1577),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(6461),
    [anon_sym_CARET] = ACTIONS(6461),
    [aux_sym_binary_operator_token1] = ACTIONS(6463),
    [anon_sym_PIPE_GT] = ACTIONS(6463),
    [anon_sym_COLON] = ACTIONS(6465),
    [anon_sym_DOLLAR] = ACTIONS(6467),
    [anon_sym_AT] = ACTIONS(6467),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6469),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6471),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(6473),
  },
  [1439] = {
    [sym_call_arguments] = STATE(2763),
    [sym_subset_arguments] = STATE(2764),
    [sym_subset2_arguments] = STATE(2765),
    [sym__open_parenthesis] = STATE(1584),
    [sym__open_bracket] = STATE(1582),
    [sym__open_bracket2] = STATE(1577),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(6461),
    [anon_sym_CARET] = ACTIONS(6461),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(5261),
    [anon_sym_DOLLAR] = ACTIONS(6467),
    [anon_sym_AT] = ACTIONS(6467),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6469),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6471),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(6473),
  },
  [1440] = {
    [sym_call_arguments] = STATE(2763),
    [sym_subset_arguments] = STATE(2764),
    [sym_subset2_arguments] = STATE(2765),
    [sym__open_parenthesis] = STATE(1584),
    [sym__open_bracket] = STATE(1582),
    [sym__open_bracket2] = STATE(1577),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(6461),
    [anon_sym_CARET] = ACTIONS(6461),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(6465),
    [anon_sym_DOLLAR] = ACTIONS(6467),
    [anon_sym_AT] = ACTIONS(6467),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6469),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6471),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(6473),
  },
  [1441] = {
    [sym_call_arguments] = STATE(2763),
    [sym_subset_arguments] = STATE(2764),
    [sym_subset2_arguments] = STATE(2765),
    [sym__open_parenthesis] = STATE(1584),
    [sym__open_bracket] = STATE(1582),
    [sym__open_bracket2] = STATE(1577),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(6461),
    [anon_sym_CARET] = ACTIONS(6461),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(5261),
    [anon_sym_DOLLAR] = ACTIONS(6467),
    [anon_sym_AT] = ACTIONS(6467),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6469),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6471),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(6473),
  },
  [1442] = {
    [sym_function_definition] = STATE(2038),
    [sym_if_statement] = STATE(2038),
    [sym_for_statement] = STATE(2038),
    [sym_while_statement] = STATE(2038),
    [sym_repeat_statement] = STATE(2038),
    [sym_braced_expression] = STATE(2038),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_call] = STATE(2038),
    [sym_subset] = STATE(2038),
    [sym_subset2] = STATE(2038),
    [sym__argument] = STATE(4664),
    [sym_argument] = STATE(4659),
    [sym__argument_named] = STATE(4654),
    [sym__argument_unnamed] = STATE(4676),
    [sym__argument_value] = STATE(4677),
    [sym_unary_operator] = STATE(2038),
    [sym_binary_operator] = STATE(2038),
    [sym_extract_operator] = STATE(2038),
    [sym_namespace_operator] = STATE(2038),
    [sym_integer] = STATE(2038),
    [sym_complex] = STATE(2038),
    [sym_float] = STATE(2038),
    [sym__hex_literal] = STATE(2700),
    [sym__float_literal] = STATE(2700),
    [sym_string] = STATE(2597),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym_na] = STATE(2038),
    [sym__expression] = STATE(2038),
    [sym__string_or_identifier] = STATE(5148),
    [sym__open_parenthesis] = STATE(214),
    [sym__open_brace] = STATE(192),
    [sym__close_bracket] = STATE(2696),
    [aux_sym_call_arguments_repeat1] = STATE(1794),
    [sym_identifier] = ACTIONS(6351),
    [anon_sym_BSLASH] = ACTIONS(4754),
    [anon_sym_function] = ACTIONS(4756),
    [anon_sym_if] = ACTIONS(4758),
    [anon_sym_for] = ACTIONS(4760),
    [anon_sym_while] = ACTIONS(4762),
    [anon_sym_repeat] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4766),
    [anon_sym_TILDE] = ACTIONS(4768),
    [anon_sym_BANG] = ACTIONS(6353),
    [anon_sym_PLUS] = ACTIONS(4772),
    [anon_sym_DASH] = ACTIONS(4772),
    [aux_sym__hex_literal_token1] = ACTIONS(4776),
    [sym__number_literal] = ACTIONS(4778),
    [anon_sym_SQUOTE] = ACTIONS(4780),
    [anon_sym_DQUOTE] = ACTIONS(4782),
    [sym_return] = ACTIONS(6355),
    [sym_next] = ACTIONS(6355),
    [sym_break] = ACTIONS(6355),
    [sym_true] = ACTIONS(6355),
    [sym_false] = ACTIONS(6355),
    [sym_null] = ACTIONS(6355),
    [sym_inf] = ACTIONS(6355),
    [sym_nan] = ACTIONS(6355),
    [anon_sym_NA] = ACTIONS(4786),
    [anon_sym_NA_integer_] = ACTIONS(4786),
    [anon_sym_NA_real_] = ACTIONS(4786),
    [anon_sym_NA_complex_] = ACTIONS(4786),
    [anon_sym_NA_character_] = ACTIONS(4786),
    [sym_dots] = ACTIONS(6357),
    [sym_dot_dot_i] = ACTIONS(6359),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6361),
    [sym__newline] = ACTIONS(6363),
    [sym__raw_string_literal] = ACTIONS(4790),
    [sym__external_open_parenthesis] = ACTIONS(4792),
    [sym__external_open_brace] = ACTIONS(4794),
    [sym__external_close_bracket] = ACTIONS(6633),
  },
  [1443] = {
    [sym_function_definition] = STATE(1931),
    [sym_if_statement] = STATE(1931),
    [sym_for_statement] = STATE(1931),
    [sym_while_statement] = STATE(1931),
    [sym_repeat_statement] = STATE(1931),
    [sym_braced_expression] = STATE(1931),
    [sym_parenthesized_expression] = STATE(1931),
    [sym_call] = STATE(1931),
    [sym_subset] = STATE(1931),
    [sym_subset2] = STATE(1931),
    [sym__argument] = STATE(4656),
    [sym_argument] = STATE(4657),
    [sym__argument_named] = STATE(4658),
    [sym__argument_unnamed] = STATE(4662),
    [sym__argument_value] = STATE(4663),
    [sym_unary_operator] = STATE(1931),
    [sym_binary_operator] = STATE(1931),
    [sym_extract_operator] = STATE(1931),
    [sym_namespace_operator] = STATE(1931),
    [sym_integer] = STATE(1931),
    [sym_complex] = STATE(1931),
    [sym_float] = STATE(1931),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2633),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(1931),
    [sym__expression] = STATE(1931),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__close_parenthesis] = STATE(2697),
    [sym__open_brace] = STATE(154),
    [aux_sym_call_arguments_repeat1] = STATE(1505),
    [sym_identifier] = ACTIONS(6387),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(6389),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3865),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(6391),
    [sym_next] = ACTIONS(6391),
    [sym_break] = ACTIONS(6391),
    [sym_true] = ACTIONS(6391),
    [sym_false] = ACTIONS(6391),
    [sym_null] = ACTIONS(6391),
    [sym_inf] = ACTIONS(6391),
    [sym_nan] = ACTIONS(6391),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(6393),
    [sym_dot_dot_i] = ACTIONS(6395),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6397),
    [sym__newline] = ACTIONS(6399),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(6635),
    [sym__external_open_brace] = ACTIONS(3891),
  },
  [1444] = {
    [sym_function_definition] = STATE(1931),
    [sym_if_statement] = STATE(1931),
    [sym_for_statement] = STATE(1931),
    [sym_while_statement] = STATE(1931),
    [sym_repeat_statement] = STATE(1931),
    [sym_braced_expression] = STATE(1931),
    [sym_parenthesized_expression] = STATE(1931),
    [sym_call] = STATE(1931),
    [sym_subset] = STATE(1931),
    [sym_subset2] = STATE(1931),
    [sym__argument] = STATE(4656),
    [sym_argument] = STATE(4657),
    [sym__argument_named] = STATE(4658),
    [sym__argument_unnamed] = STATE(4662),
    [sym__argument_value] = STATE(4663),
    [sym_unary_operator] = STATE(1931),
    [sym_binary_operator] = STATE(1931),
    [sym_extract_operator] = STATE(1931),
    [sym_namespace_operator] = STATE(1931),
    [sym_integer] = STATE(1931),
    [sym_complex] = STATE(1931),
    [sym_float] = STATE(1931),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2633),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(1931),
    [sym__expression] = STATE(1931),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__close_parenthesis] = STATE(4709),
    [sym__open_brace] = STATE(154),
    [aux_sym_call_arguments_repeat1] = STATE(2113),
    [sym_identifier] = ACTIONS(6387),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(6389),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3865),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(6391),
    [sym_next] = ACTIONS(6391),
    [sym_break] = ACTIONS(6391),
    [sym_true] = ACTIONS(6391),
    [sym_false] = ACTIONS(6391),
    [sym_null] = ACTIONS(6391),
    [sym_inf] = ACTIONS(6391),
    [sym_nan] = ACTIONS(6391),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(6393),
    [sym_dot_dot_i] = ACTIONS(6395),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6397),
    [sym__newline] = ACTIONS(6399),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(6637),
    [sym__external_open_brace] = ACTIONS(3891),
  },
  [1445] = {
    [sym_call_arguments] = STATE(2840),
    [sym_subset_arguments] = STATE(2797),
    [sym_subset2_arguments] = STATE(2801),
    [sym__open_parenthesis] = STATE(1344),
    [sym__open_bracket] = STATE(1374),
    [sym__open_bracket2] = STATE(1452),
    [ts_builtin_sym_end] = ACTIONS(5327),
    [sym_identifier] = ACTIONS(5325),
    [anon_sym_BSLASH] = ACTIONS(5327),
    [anon_sym_function] = ACTIONS(5325),
    [anon_sym_EQ] = ACTIONS(6263),
    [anon_sym_if] = ACTIONS(5325),
    [anon_sym_for] = ACTIONS(5325),
    [anon_sym_while] = ACTIONS(5325),
    [anon_sym_repeat] = ACTIONS(5325),
    [anon_sym_QMARK] = ACTIONS(6639),
    [anon_sym_TILDE] = ACTIONS(6265),
    [anon_sym_BANG] = ACTIONS(5325),
    [anon_sym_PLUS] = ACTIONS(6267),
    [anon_sym_DASH] = ACTIONS(6269),
    [anon_sym_LT_DASH] = ACTIONS(6271),
    [anon_sym_LT_LT_DASH] = ACTIONS(6271),
    [anon_sym_COLON_EQ] = ACTIONS(6271),
    [anon_sym_DASH_GT] = ACTIONS(6273),
    [anon_sym_DASH_GT_GT] = ACTIONS(6275),
    [anon_sym_PIPE] = ACTIONS(6277),
    [anon_sym_AMP] = ACTIONS(6279),
    [anon_sym_PIPE_PIPE] = ACTIONS(6281),
    [anon_sym_AMP_AMP] = ACTIONS(6283),
    [anon_sym_LT] = ACTIONS(6285),
    [anon_sym_LT_EQ] = ACTIONS(6287),
    [anon_sym_GT] = ACTIONS(6285),
    [anon_sym_GT_EQ] = ACTIONS(6287),
    [anon_sym_EQ_EQ] = ACTIONS(6287),
    [anon_sym_BANG_EQ] = ACTIONS(6287),
    [anon_sym_STAR] = ACTIONS(6289),
    [anon_sym_SLASH] = ACTIONS(6291),
    [anon_sym_STAR_STAR] = ACTIONS(6293),
    [anon_sym_CARET] = ACTIONS(6293),
    [aux_sym_binary_operator_token1] = ACTIONS(6295),
    [anon_sym_PIPE_GT] = ACTIONS(6295),
    [anon_sym_COLON] = ACTIONS(6297),
    [anon_sym_DOLLAR] = ACTIONS(6299),
    [anon_sym_AT] = ACTIONS(6299),
    [aux_sym__hex_literal_token1] = ACTIONS(5327),
    [sym__number_literal] = ACTIONS(5325),
    [anon_sym_SQUOTE] = ACTIONS(5327),
    [anon_sym_DQUOTE] = ACTIONS(5327),
    [sym_return] = ACTIONS(5325),
    [sym_next] = ACTIONS(5325),
    [sym_break] = ACTIONS(5325),
    [sym_true] = ACTIONS(5325),
    [sym_false] = ACTIONS(5325),
    [sym_null] = ACTIONS(5325),
    [sym_inf] = ACTIONS(5325),
    [sym_nan] = ACTIONS(5325),
    [anon_sym_NA] = ACTIONS(5325),
    [anon_sym_NA_integer_] = ACTIONS(5325),
    [anon_sym_NA_real_] = ACTIONS(5325),
    [anon_sym_NA_complex_] = ACTIONS(5325),
    [anon_sym_NA_character_] = ACTIONS(5325),
    [sym_dots] = ACTIONS(5325),
    [sym_dot_dot_i] = ACTIONS(5327),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5327),
    [sym__semicolon] = ACTIONS(5327),
    [sym__raw_string_literal] = ACTIONS(5327),
    [sym__external_open_parenthesis] = ACTIONS(6301),
    [sym__external_open_brace] = ACTIONS(5327),
    [sym__external_close_brace] = ACTIONS(5327),
    [sym__external_open_bracket] = ACTIONS(6303),
    [sym__external_open_bracket2] = ACTIONS(6305),
  },
  [1446] = {
    [sym_call_arguments] = STATE(2870),
    [sym_subset_arguments] = STATE(2869),
    [sym_subset2_arguments] = STATE(2867),
    [sym__open_parenthesis] = STATE(1362),
    [sym__open_bracket] = STATE(1361),
    [sym__open_bracket2] = STATE(1360),
    [sym_identifier] = ACTIONS(5411),
    [anon_sym_BSLASH] = ACTIONS(5409),
    [anon_sym_function] = ACTIONS(5411),
    [anon_sym_EQ] = ACTIONS(6111),
    [anon_sym_if] = ACTIONS(5411),
    [anon_sym_for] = ACTIONS(5411),
    [anon_sym_while] = ACTIONS(5411),
    [anon_sym_repeat] = ACTIONS(5411),
    [anon_sym_QMARK] = ACTIONS(5409),
    [anon_sym_TILDE] = ACTIONS(6113),
    [anon_sym_BANG] = ACTIONS(5411),
    [anon_sym_PLUS] = ACTIONS(6115),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_LT_DASH] = ACTIONS(6119),
    [anon_sym_LT_LT_DASH] = ACTIONS(6119),
    [anon_sym_COLON_EQ] = ACTIONS(6119),
    [anon_sym_DASH_GT] = ACTIONS(6121),
    [anon_sym_DASH_GT_GT] = ACTIONS(6123),
    [anon_sym_PIPE] = ACTIONS(6125),
    [anon_sym_AMP] = ACTIONS(6127),
    [anon_sym_PIPE_PIPE] = ACTIONS(6129),
    [anon_sym_AMP_AMP] = ACTIONS(6131),
    [anon_sym_LT] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6135),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_GT_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(6135),
    [anon_sym_STAR] = ACTIONS(6137),
    [anon_sym_SLASH] = ACTIONS(6139),
    [anon_sym_STAR_STAR] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6141),
    [aux_sym_binary_operator_token1] = ACTIONS(6143),
    [anon_sym_PIPE_GT] = ACTIONS(6143),
    [anon_sym_COLON] = ACTIONS(6145),
    [anon_sym_DOLLAR] = ACTIONS(6147),
    [anon_sym_AT] = ACTIONS(6147),
    [aux_sym__hex_literal_token1] = ACTIONS(5409),
    [sym__number_literal] = ACTIONS(5411),
    [anon_sym_SQUOTE] = ACTIONS(5409),
    [anon_sym_DQUOTE] = ACTIONS(5409),
    [sym_return] = ACTIONS(5411),
    [sym_next] = ACTIONS(5411),
    [sym_break] = ACTIONS(5411),
    [sym_true] = ACTIONS(5411),
    [sym_false] = ACTIONS(5411),
    [sym_null] = ACTIONS(5411),
    [sym_inf] = ACTIONS(5411),
    [sym_nan] = ACTIONS(5411),
    [anon_sym_NA] = ACTIONS(5411),
    [anon_sym_NA_integer_] = ACTIONS(5411),
    [anon_sym_NA_real_] = ACTIONS(5411),
    [anon_sym_NA_complex_] = ACTIONS(5411),
    [anon_sym_NA_character_] = ACTIONS(5411),
    [sym_dots] = ACTIONS(5411),
    [sym_dot_dot_i] = ACTIONS(5409),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5409),
    [sym__newline] = ACTIONS(5409),
    [sym__raw_string_literal] = ACTIONS(5409),
    [sym__external_else] = ACTIONS(5409),
    [sym__external_open_parenthesis] = ACTIONS(6151),
    [sym__external_open_brace] = ACTIONS(5409),
    [sym__external_open_bracket] = ACTIONS(6153),
    [sym__external_open_bracket2] = ACTIONS(6155),
    [sym__external_close_bracket2] = ACTIONS(5409),
  },
  [1447] = {
    [sym_function_definition] = STATE(1940),
    [sym_if_statement] = STATE(1940),
    [sym_for_statement] = STATE(1940),
    [sym_while_statement] = STATE(1940),
    [sym_repeat_statement] = STATE(1940),
    [sym_braced_expression] = STATE(1940),
    [sym_parenthesized_expression] = STATE(1940),
    [sym_call] = STATE(1940),
    [sym_subset] = STATE(1940),
    [sym_subset2] = STATE(1940),
    [sym__argument] = STATE(4665),
    [sym_argument] = STATE(4661),
    [sym__argument_named] = STATE(4669),
    [sym__argument_unnamed] = STATE(4673),
    [sym__argument_value] = STATE(4679),
    [sym_unary_operator] = STATE(1940),
    [sym_binary_operator] = STATE(1940),
    [sym_extract_operator] = STATE(1940),
    [sym_namespace_operator] = STATE(1940),
    [sym_integer] = STATE(1940),
    [sym_complex] = STATE(1940),
    [sym_float] = STATE(1940),
    [sym__hex_literal] = STATE(2656),
    [sym__float_literal] = STATE(2656),
    [sym_string] = STATE(2606),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym_na] = STATE(1940),
    [sym__expression] = STATE(1940),
    [sym__string_or_identifier] = STATE(5141),
    [sym__open_parenthesis] = STATE(218),
    [sym__open_brace] = STATE(185),
    [sym__close_bracket2] = STATE(2508),
    [aux_sym_call_arguments_repeat1] = STATE(1463),
    [sym_identifier] = ACTIONS(6369),
    [anon_sym_BSLASH] = ACTIONS(4644),
    [anon_sym_function] = ACTIONS(4646),
    [anon_sym_if] = ACTIONS(4648),
    [anon_sym_for] = ACTIONS(4650),
    [anon_sym_while] = ACTIONS(4652),
    [anon_sym_repeat] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(6371),
    [anon_sym_PLUS] = ACTIONS(4662),
    [anon_sym_DASH] = ACTIONS(4662),
    [aux_sym__hex_literal_token1] = ACTIONS(4666),
    [sym__number_literal] = ACTIONS(4668),
    [anon_sym_SQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4672),
    [sym_return] = ACTIONS(6373),
    [sym_next] = ACTIONS(6373),
    [sym_break] = ACTIONS(6373),
    [sym_true] = ACTIONS(6373),
    [sym_false] = ACTIONS(6373),
    [sym_null] = ACTIONS(6373),
    [sym_inf] = ACTIONS(6373),
    [sym_nan] = ACTIONS(6373),
    [anon_sym_NA] = ACTIONS(4676),
    [anon_sym_NA_integer_] = ACTIONS(4676),
    [anon_sym_NA_real_] = ACTIONS(4676),
    [anon_sym_NA_complex_] = ACTIONS(4676),
    [anon_sym_NA_character_] = ACTIONS(4676),
    [sym_dots] = ACTIONS(6375),
    [sym_dot_dot_i] = ACTIONS(6377),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6379),
    [sym__newline] = ACTIONS(6381),
    [sym__raw_string_literal] = ACTIONS(4680),
    [sym__external_open_parenthesis] = ACTIONS(4682),
    [sym__external_open_brace] = ACTIONS(4684),
    [sym__external_close_bracket2] = ACTIONS(6641),
  },
  [1448] = {
    [sym_call_arguments] = STATE(2763),
    [sym_subset_arguments] = STATE(2764),
    [sym_subset2_arguments] = STATE(2765),
    [sym__open_parenthesis] = STATE(1584),
    [sym__open_bracket] = STATE(1582),
    [sym__open_bracket2] = STATE(1577),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_BSLASH] = ACTIONS(5413),
    [anon_sym_function] = ACTIONS(5415),
    [anon_sym_EQ] = ACTIONS(6431),
    [anon_sym_if] = ACTIONS(5415),
    [anon_sym_for] = ACTIONS(5415),
    [anon_sym_while] = ACTIONS(5415),
    [anon_sym_repeat] = ACTIONS(5415),
    [anon_sym_QMARK] = ACTIONS(5413),
    [anon_sym_TILDE] = ACTIONS(6433),
    [anon_sym_BANG] = ACTIONS(5415),
    [anon_sym_PLUS] = ACTIONS(6435),
    [anon_sym_DASH] = ACTIONS(6437),
    [anon_sym_LT_DASH] = ACTIONS(6439),
    [anon_sym_LT_LT_DASH] = ACTIONS(6439),
    [anon_sym_COLON_EQ] = ACTIONS(6439),
    [anon_sym_DASH_GT] = ACTIONS(6441),
    [anon_sym_DASH_GT_GT] = ACTIONS(6443),
    [anon_sym_PIPE] = ACTIONS(6445),
    [anon_sym_AMP] = ACTIONS(6447),
    [anon_sym_PIPE_PIPE] = ACTIONS(6449),
    [anon_sym_AMP_AMP] = ACTIONS(6451),
    [anon_sym_LT] = ACTIONS(6453),
    [anon_sym_LT_EQ] = ACTIONS(6455),
    [anon_sym_GT] = ACTIONS(6453),
    [anon_sym_GT_EQ] = ACTIONS(6455),
    [anon_sym_EQ_EQ] = ACTIONS(6455),
    [anon_sym_BANG_EQ] = ACTIONS(6455),
    [anon_sym_STAR] = ACTIONS(6457),
    [anon_sym_SLASH] = ACTIONS(6459),
    [anon_sym_STAR_STAR] = ACTIONS(6461),
    [anon_sym_CARET] = ACTIONS(6461),
    [aux_sym_binary_operator_token1] = ACTIONS(6463),
    [anon_sym_PIPE_GT] = ACTIONS(6463),
    [anon_sym_COLON] = ACTIONS(6465),
    [anon_sym_DOLLAR] = ACTIONS(6467),
    [anon_sym_AT] = ACTIONS(6467),
    [aux_sym__hex_literal_token1] = ACTIONS(5413),
    [sym__number_literal] = ACTIONS(5415),
    [anon_sym_SQUOTE] = ACTIONS(5413),
    [anon_sym_DQUOTE] = ACTIONS(5413),
    [sym_return] = ACTIONS(5415),
    [sym_next] = ACTIONS(5415),
    [sym_break] = ACTIONS(5415),
    [sym_true] = ACTIONS(5415),
    [sym_false] = ACTIONS(5415),
    [sym_null] = ACTIONS(5415),
    [sym_inf] = ACTIONS(5415),
    [sym_nan] = ACTIONS(5415),
    [anon_sym_NA] = ACTIONS(5415),
    [anon_sym_NA_integer_] = ACTIONS(5415),
    [anon_sym_NA_real_] = ACTIONS(5415),
    [anon_sym_NA_complex_] = ACTIONS(5415),
    [anon_sym_NA_character_] = ACTIONS(5415),
    [sym_dots] = ACTIONS(5415),
    [sym_dot_dot_i] = ACTIONS(5413),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5413),
    [sym__newline] = ACTIONS(5413),
    [sym__raw_string_literal] = ACTIONS(5413),
    [sym__external_open_parenthesis] = ACTIONS(6469),
    [sym__external_close_parenthesis] = ACTIONS(5413),
    [sym__external_open_brace] = ACTIONS(5413),
    [sym__external_open_bracket] = ACTIONS(6471),
    [sym__external_close_bracket] = ACTIONS(5413),
    [sym__external_open_bracket2] = ACTIONS(6473),
  },
  [1449] = {
    [sym_call_arguments] = STATE(2870),
    [sym_subset_arguments] = STATE(2869),
    [sym_subset2_arguments] = STATE(2867),
    [sym__open_parenthesis] = STATE(1362),
    [sym__open_bracket] = STATE(1361),
    [sym__open_bracket2] = STATE(1360),
    [sym_identifier] = ACTIONS(5455),
    [anon_sym_BSLASH] = ACTIONS(5453),
    [anon_sym_function] = ACTIONS(5455),
    [anon_sym_EQ] = ACTIONS(6111),
    [anon_sym_if] = ACTIONS(5455),
    [anon_sym_for] = ACTIONS(5455),
    [anon_sym_while] = ACTIONS(5455),
    [anon_sym_repeat] = ACTIONS(5455),
    [anon_sym_QMARK] = ACTIONS(5453),
    [anon_sym_TILDE] = ACTIONS(6113),
    [anon_sym_BANG] = ACTIONS(5455),
    [anon_sym_PLUS] = ACTIONS(6115),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_LT_DASH] = ACTIONS(6119),
    [anon_sym_LT_LT_DASH] = ACTIONS(6119),
    [anon_sym_COLON_EQ] = ACTIONS(6119),
    [anon_sym_DASH_GT] = ACTIONS(6121),
    [anon_sym_DASH_GT_GT] = ACTIONS(6123),
    [anon_sym_PIPE] = ACTIONS(6125),
    [anon_sym_AMP] = ACTIONS(6127),
    [anon_sym_PIPE_PIPE] = ACTIONS(6129),
    [anon_sym_AMP_AMP] = ACTIONS(6131),
    [anon_sym_LT] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6135),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_GT_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(6135),
    [anon_sym_STAR] = ACTIONS(6137),
    [anon_sym_SLASH] = ACTIONS(6139),
    [anon_sym_STAR_STAR] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6141),
    [aux_sym_binary_operator_token1] = ACTIONS(6143),
    [anon_sym_PIPE_GT] = ACTIONS(6143),
    [anon_sym_COLON] = ACTIONS(6145),
    [anon_sym_DOLLAR] = ACTIONS(6147),
    [anon_sym_AT] = ACTIONS(6147),
    [aux_sym__hex_literal_token1] = ACTIONS(5453),
    [sym__number_literal] = ACTIONS(5455),
    [anon_sym_SQUOTE] = ACTIONS(5453),
    [anon_sym_DQUOTE] = ACTIONS(5453),
    [sym_return] = ACTIONS(5455),
    [sym_next] = ACTIONS(5455),
    [sym_break] = ACTIONS(5455),
    [sym_true] = ACTIONS(5455),
    [sym_false] = ACTIONS(5455),
    [sym_null] = ACTIONS(5455),
    [sym_inf] = ACTIONS(5455),
    [sym_nan] = ACTIONS(5455),
    [anon_sym_NA] = ACTIONS(5455),
    [anon_sym_NA_integer_] = ACTIONS(5455),
    [anon_sym_NA_real_] = ACTIONS(5455),
    [anon_sym_NA_complex_] = ACTIONS(5455),
    [anon_sym_NA_character_] = ACTIONS(5455),
    [sym_dots] = ACTIONS(5455),
    [sym_dot_dot_i] = ACTIONS(5453),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5453),
    [sym__newline] = ACTIONS(5453),
    [sym__raw_string_literal] = ACTIONS(5453),
    [sym__external_else] = ACTIONS(5453),
    [sym__external_open_parenthesis] = ACTIONS(6151),
    [sym__external_open_brace] = ACTIONS(5453),
    [sym__external_open_bracket] = ACTIONS(6153),
    [sym__external_open_bracket2] = ACTIONS(6155),
    [sym__external_close_bracket2] = ACTIONS(5453),
  },
  [1450] = {
    [sym_function_definition] = STATE(2038),
    [sym_if_statement] = STATE(2038),
    [sym_for_statement] = STATE(2038),
    [sym_while_statement] = STATE(2038),
    [sym_repeat_statement] = STATE(2038),
    [sym_braced_expression] = STATE(2038),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_call] = STATE(2038),
    [sym_subset] = STATE(2038),
    [sym_subset2] = STATE(2038),
    [sym__argument] = STATE(4664),
    [sym_argument] = STATE(4659),
    [sym__argument_named] = STATE(4654),
    [sym__argument_unnamed] = STATE(4676),
    [sym__argument_value] = STATE(4677),
    [sym_unary_operator] = STATE(2038),
    [sym_binary_operator] = STATE(2038),
    [sym_extract_operator] = STATE(2038),
    [sym_namespace_operator] = STATE(2038),
    [sym_integer] = STATE(2038),
    [sym_complex] = STATE(2038),
    [sym_float] = STATE(2038),
    [sym__hex_literal] = STATE(2700),
    [sym__float_literal] = STATE(2700),
    [sym_string] = STATE(2597),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym_na] = STATE(2038),
    [sym__expression] = STATE(2038),
    [sym__string_or_identifier] = STATE(5148),
    [sym__open_parenthesis] = STATE(214),
    [sym__open_brace] = STATE(192),
    [sym__close_bracket] = STATE(2520),
    [aux_sym_call_arguments_repeat1] = STATE(1453),
    [sym_identifier] = ACTIONS(6351),
    [anon_sym_BSLASH] = ACTIONS(4754),
    [anon_sym_function] = ACTIONS(4756),
    [anon_sym_if] = ACTIONS(4758),
    [anon_sym_for] = ACTIONS(4760),
    [anon_sym_while] = ACTIONS(4762),
    [anon_sym_repeat] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4766),
    [anon_sym_TILDE] = ACTIONS(4768),
    [anon_sym_BANG] = ACTIONS(6353),
    [anon_sym_PLUS] = ACTIONS(4772),
    [anon_sym_DASH] = ACTIONS(4772),
    [aux_sym__hex_literal_token1] = ACTIONS(4776),
    [sym__number_literal] = ACTIONS(4778),
    [anon_sym_SQUOTE] = ACTIONS(4780),
    [anon_sym_DQUOTE] = ACTIONS(4782),
    [sym_return] = ACTIONS(6355),
    [sym_next] = ACTIONS(6355),
    [sym_break] = ACTIONS(6355),
    [sym_true] = ACTIONS(6355),
    [sym_false] = ACTIONS(6355),
    [sym_null] = ACTIONS(6355),
    [sym_inf] = ACTIONS(6355),
    [sym_nan] = ACTIONS(6355),
    [anon_sym_NA] = ACTIONS(4786),
    [anon_sym_NA_integer_] = ACTIONS(4786),
    [anon_sym_NA_real_] = ACTIONS(4786),
    [anon_sym_NA_complex_] = ACTIONS(4786),
    [anon_sym_NA_character_] = ACTIONS(4786),
    [sym_dots] = ACTIONS(6357),
    [sym_dot_dot_i] = ACTIONS(6359),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6361),
    [sym__newline] = ACTIONS(6363),
    [sym__raw_string_literal] = ACTIONS(4790),
    [sym__external_open_parenthesis] = ACTIONS(4792),
    [sym__external_open_brace] = ACTIONS(4794),
    [sym__external_close_bracket] = ACTIONS(6643),
  },
  [1451] = {
    [sym_call_arguments] = STATE(2870),
    [sym_subset_arguments] = STATE(2869),
    [sym_subset2_arguments] = STATE(2867),
    [sym__open_parenthesis] = STATE(1362),
    [sym__open_bracket] = STATE(1361),
    [sym__open_bracket2] = STATE(1360),
    [sym_identifier] = ACTIONS(5451),
    [anon_sym_BSLASH] = ACTIONS(5449),
    [anon_sym_function] = ACTIONS(5451),
    [anon_sym_EQ] = ACTIONS(6111),
    [anon_sym_if] = ACTIONS(5451),
    [anon_sym_for] = ACTIONS(5451),
    [anon_sym_while] = ACTIONS(5451),
    [anon_sym_repeat] = ACTIONS(5451),
    [anon_sym_QMARK] = ACTIONS(5449),
    [anon_sym_TILDE] = ACTIONS(6113),
    [anon_sym_BANG] = ACTIONS(5451),
    [anon_sym_PLUS] = ACTIONS(6115),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_LT_DASH] = ACTIONS(6119),
    [anon_sym_LT_LT_DASH] = ACTIONS(6119),
    [anon_sym_COLON_EQ] = ACTIONS(6119),
    [anon_sym_DASH_GT] = ACTIONS(6121),
    [anon_sym_DASH_GT_GT] = ACTIONS(6123),
    [anon_sym_PIPE] = ACTIONS(6125),
    [anon_sym_AMP] = ACTIONS(6127),
    [anon_sym_PIPE_PIPE] = ACTIONS(6129),
    [anon_sym_AMP_AMP] = ACTIONS(6131),
    [anon_sym_LT] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6135),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_GT_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(6135),
    [anon_sym_STAR] = ACTIONS(6137),
    [anon_sym_SLASH] = ACTIONS(6139),
    [anon_sym_STAR_STAR] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6141),
    [aux_sym_binary_operator_token1] = ACTIONS(6143),
    [anon_sym_PIPE_GT] = ACTIONS(6143),
    [anon_sym_COLON] = ACTIONS(6145),
    [anon_sym_DOLLAR] = ACTIONS(6147),
    [anon_sym_AT] = ACTIONS(6147),
    [aux_sym__hex_literal_token1] = ACTIONS(5449),
    [sym__number_literal] = ACTIONS(5451),
    [anon_sym_SQUOTE] = ACTIONS(5449),
    [anon_sym_DQUOTE] = ACTIONS(5449),
    [sym_return] = ACTIONS(5451),
    [sym_next] = ACTIONS(5451),
    [sym_break] = ACTIONS(5451),
    [sym_true] = ACTIONS(5451),
    [sym_false] = ACTIONS(5451),
    [sym_null] = ACTIONS(5451),
    [sym_inf] = ACTIONS(5451),
    [sym_nan] = ACTIONS(5451),
    [anon_sym_NA] = ACTIONS(5451),
    [anon_sym_NA_integer_] = ACTIONS(5451),
    [anon_sym_NA_real_] = ACTIONS(5451),
    [anon_sym_NA_complex_] = ACTIONS(5451),
    [anon_sym_NA_character_] = ACTIONS(5451),
    [sym_dots] = ACTIONS(5451),
    [sym_dot_dot_i] = ACTIONS(5449),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5449),
    [sym__newline] = ACTIONS(5449),
    [sym__raw_string_literal] = ACTIONS(5449),
    [sym__external_else] = ACTIONS(5449),
    [sym__external_open_parenthesis] = ACTIONS(6151),
    [sym__external_open_brace] = ACTIONS(5449),
    [sym__external_open_bracket] = ACTIONS(6153),
    [sym__external_open_bracket2] = ACTIONS(6155),
    [sym__external_close_bracket2] = ACTIONS(5449),
  },
  [1452] = {
    [sym_function_definition] = STATE(1940),
    [sym_if_statement] = STATE(1940),
    [sym_for_statement] = STATE(1940),
    [sym_while_statement] = STATE(1940),
    [sym_repeat_statement] = STATE(1940),
    [sym_braced_expression] = STATE(1940),
    [sym_parenthesized_expression] = STATE(1940),
    [sym_call] = STATE(1940),
    [sym_subset] = STATE(1940),
    [sym_subset2] = STATE(1940),
    [sym__argument] = STATE(4665),
    [sym_argument] = STATE(4661),
    [sym__argument_named] = STATE(4669),
    [sym__argument_unnamed] = STATE(4673),
    [sym__argument_value] = STATE(4679),
    [sym_unary_operator] = STATE(1940),
    [sym_binary_operator] = STATE(1940),
    [sym_extract_operator] = STATE(1940),
    [sym_namespace_operator] = STATE(1940),
    [sym_integer] = STATE(1940),
    [sym_complex] = STATE(1940),
    [sym_float] = STATE(1940),
    [sym__hex_literal] = STATE(2656),
    [sym__float_literal] = STATE(2656),
    [sym_string] = STATE(2606),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym_na] = STATE(1940),
    [sym__expression] = STATE(1940),
    [sym__string_or_identifier] = STATE(5141),
    [sym__open_parenthesis] = STATE(218),
    [sym__open_brace] = STATE(185),
    [sym__close_bracket2] = STATE(2830),
    [aux_sym_call_arguments_repeat1] = STATE(1829),
    [sym_identifier] = ACTIONS(6369),
    [anon_sym_BSLASH] = ACTIONS(4644),
    [anon_sym_function] = ACTIONS(4646),
    [anon_sym_if] = ACTIONS(4648),
    [anon_sym_for] = ACTIONS(4650),
    [anon_sym_while] = ACTIONS(4652),
    [anon_sym_repeat] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(6371),
    [anon_sym_PLUS] = ACTIONS(4662),
    [anon_sym_DASH] = ACTIONS(4662),
    [aux_sym__hex_literal_token1] = ACTIONS(4666),
    [sym__number_literal] = ACTIONS(4668),
    [anon_sym_SQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4672),
    [sym_return] = ACTIONS(6373),
    [sym_next] = ACTIONS(6373),
    [sym_break] = ACTIONS(6373),
    [sym_true] = ACTIONS(6373),
    [sym_false] = ACTIONS(6373),
    [sym_null] = ACTIONS(6373),
    [sym_inf] = ACTIONS(6373),
    [sym_nan] = ACTIONS(6373),
    [anon_sym_NA] = ACTIONS(4676),
    [anon_sym_NA_integer_] = ACTIONS(4676),
    [anon_sym_NA_real_] = ACTIONS(4676),
    [anon_sym_NA_complex_] = ACTIONS(4676),
    [anon_sym_NA_character_] = ACTIONS(4676),
    [sym_dots] = ACTIONS(6375),
    [sym_dot_dot_i] = ACTIONS(6377),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6379),
    [sym__newline] = ACTIONS(6381),
    [sym__raw_string_literal] = ACTIONS(4680),
    [sym__external_open_parenthesis] = ACTIONS(4682),
    [sym__external_open_brace] = ACTIONS(4684),
    [sym__external_close_bracket2] = ACTIONS(6645),
  },
  [1453] = {
    [sym_function_definition] = STATE(2038),
    [sym_if_statement] = STATE(2038),
    [sym_for_statement] = STATE(2038),
    [sym_while_statement] = STATE(2038),
    [sym_repeat_statement] = STATE(2038),
    [sym_braced_expression] = STATE(2038),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_call] = STATE(2038),
    [sym_subset] = STATE(2038),
    [sym_subset2] = STATE(2038),
    [sym__argument] = STATE(4664),
    [sym_argument] = STATE(4659),
    [sym__argument_named] = STATE(4654),
    [sym__argument_unnamed] = STATE(4676),
    [sym__argument_value] = STATE(4677),
    [sym_unary_operator] = STATE(2038),
    [sym_binary_operator] = STATE(2038),
    [sym_extract_operator] = STATE(2038),
    [sym_namespace_operator] = STATE(2038),
    [sym_integer] = STATE(2038),
    [sym_complex] = STATE(2038),
    [sym_float] = STATE(2038),
    [sym__hex_literal] = STATE(2700),
    [sym__float_literal] = STATE(2700),
    [sym_string] = STATE(2597),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym_na] = STATE(2038),
    [sym__expression] = STATE(2038),
    [sym__string_or_identifier] = STATE(5148),
    [sym__open_parenthesis] = STATE(214),
    [sym__open_brace] = STATE(192),
    [sym__close_bracket] = STATE(2420),
    [aux_sym_call_arguments_repeat1] = STATE(2034),
    [sym_identifier] = ACTIONS(6351),
    [anon_sym_BSLASH] = ACTIONS(4754),
    [anon_sym_function] = ACTIONS(4756),
    [anon_sym_if] = ACTIONS(4758),
    [anon_sym_for] = ACTIONS(4760),
    [anon_sym_while] = ACTIONS(4762),
    [anon_sym_repeat] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4766),
    [anon_sym_TILDE] = ACTIONS(4768),
    [anon_sym_BANG] = ACTIONS(6353),
    [anon_sym_PLUS] = ACTIONS(4772),
    [anon_sym_DASH] = ACTIONS(4772),
    [aux_sym__hex_literal_token1] = ACTIONS(4776),
    [sym__number_literal] = ACTIONS(4778),
    [anon_sym_SQUOTE] = ACTIONS(4780),
    [anon_sym_DQUOTE] = ACTIONS(4782),
    [sym_return] = ACTIONS(6355),
    [sym_next] = ACTIONS(6355),
    [sym_break] = ACTIONS(6355),
    [sym_true] = ACTIONS(6355),
    [sym_false] = ACTIONS(6355),
    [sym_null] = ACTIONS(6355),
    [sym_inf] = ACTIONS(6355),
    [sym_nan] = ACTIONS(6355),
    [anon_sym_NA] = ACTIONS(4786),
    [anon_sym_NA_integer_] = ACTIONS(4786),
    [anon_sym_NA_real_] = ACTIONS(4786),
    [anon_sym_NA_complex_] = ACTIONS(4786),
    [anon_sym_NA_character_] = ACTIONS(4786),
    [sym_dots] = ACTIONS(6357),
    [sym_dot_dot_i] = ACTIONS(6359),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6361),
    [sym__newline] = ACTIONS(6363),
    [sym__raw_string_literal] = ACTIONS(4790),
    [sym__external_open_parenthesis] = ACTIONS(4792),
    [sym__external_open_brace] = ACTIONS(4794),
    [sym__external_close_bracket] = ACTIONS(6647),
  },
  [1454] = {
    [sym_call_arguments] = STATE(2870),
    [sym_subset_arguments] = STATE(2869),
    [sym_subset2_arguments] = STATE(2867),
    [sym__open_parenthesis] = STATE(1362),
    [sym__open_bracket] = STATE(1361),
    [sym__open_bracket2] = STATE(1360),
    [sym_identifier] = ACTIONS(5447),
    [anon_sym_BSLASH] = ACTIONS(5445),
    [anon_sym_function] = ACTIONS(5447),
    [anon_sym_EQ] = ACTIONS(6111),
    [anon_sym_if] = ACTIONS(5447),
    [anon_sym_for] = ACTIONS(5447),
    [anon_sym_while] = ACTIONS(5447),
    [anon_sym_repeat] = ACTIONS(5447),
    [anon_sym_QMARK] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(6113),
    [anon_sym_BANG] = ACTIONS(5447),
    [anon_sym_PLUS] = ACTIONS(6115),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_LT_DASH] = ACTIONS(6119),
    [anon_sym_LT_LT_DASH] = ACTIONS(6119),
    [anon_sym_COLON_EQ] = ACTIONS(6119),
    [anon_sym_DASH_GT] = ACTIONS(6121),
    [anon_sym_DASH_GT_GT] = ACTIONS(6123),
    [anon_sym_PIPE] = ACTIONS(6125),
    [anon_sym_AMP] = ACTIONS(6127),
    [anon_sym_PIPE_PIPE] = ACTIONS(6129),
    [anon_sym_AMP_AMP] = ACTIONS(6131),
    [anon_sym_LT] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6135),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_GT_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(6135),
    [anon_sym_STAR] = ACTIONS(6137),
    [anon_sym_SLASH] = ACTIONS(6139),
    [anon_sym_STAR_STAR] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6141),
    [aux_sym_binary_operator_token1] = ACTIONS(6143),
    [anon_sym_PIPE_GT] = ACTIONS(6143),
    [anon_sym_COLON] = ACTIONS(6145),
    [anon_sym_DOLLAR] = ACTIONS(6147),
    [anon_sym_AT] = ACTIONS(6147),
    [aux_sym__hex_literal_token1] = ACTIONS(5445),
    [sym__number_literal] = ACTIONS(5447),
    [anon_sym_SQUOTE] = ACTIONS(5445),
    [anon_sym_DQUOTE] = ACTIONS(5445),
    [sym_return] = ACTIONS(5447),
    [sym_next] = ACTIONS(5447),
    [sym_break] = ACTIONS(5447),
    [sym_true] = ACTIONS(5447),
    [sym_false] = ACTIONS(5447),
    [sym_null] = ACTIONS(5447),
    [sym_inf] = ACTIONS(5447),
    [sym_nan] = ACTIONS(5447),
    [anon_sym_NA] = ACTIONS(5447),
    [anon_sym_NA_integer_] = ACTIONS(5447),
    [anon_sym_NA_real_] = ACTIONS(5447),
    [anon_sym_NA_complex_] = ACTIONS(5447),
    [anon_sym_NA_character_] = ACTIONS(5447),
    [sym_dots] = ACTIONS(5447),
    [sym_dot_dot_i] = ACTIONS(5445),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5445),
    [sym__newline] = ACTIONS(5445),
    [sym__raw_string_literal] = ACTIONS(5445),
    [sym__external_else] = ACTIONS(5445),
    [sym__external_open_parenthesis] = ACTIONS(6151),
    [sym__external_open_brace] = ACTIONS(5445),
    [sym__external_open_bracket] = ACTIONS(6153),
    [sym__external_open_bracket2] = ACTIONS(6155),
    [sym__external_close_bracket2] = ACTIONS(5445),
  },
  [1455] = {
    [sym_call_arguments] = STATE(2763),
    [sym_subset_arguments] = STATE(2764),
    [sym_subset2_arguments] = STATE(2765),
    [sym__open_parenthesis] = STATE(1584),
    [sym__open_bracket] = STATE(1582),
    [sym__open_bracket2] = STATE(1577),
    [sym_identifier] = ACTIONS(5419),
    [anon_sym_BSLASH] = ACTIONS(5417),
    [anon_sym_function] = ACTIONS(5419),
    [anon_sym_EQ] = ACTIONS(6431),
    [anon_sym_if] = ACTIONS(5419),
    [anon_sym_for] = ACTIONS(5419),
    [anon_sym_while] = ACTIONS(5419),
    [anon_sym_repeat] = ACTIONS(5419),
    [anon_sym_QMARK] = ACTIONS(5417),
    [anon_sym_TILDE] = ACTIONS(6433),
    [anon_sym_BANG] = ACTIONS(5419),
    [anon_sym_PLUS] = ACTIONS(6435),
    [anon_sym_DASH] = ACTIONS(6437),
    [anon_sym_LT_DASH] = ACTIONS(6439),
    [anon_sym_LT_LT_DASH] = ACTIONS(6439),
    [anon_sym_COLON_EQ] = ACTIONS(6439),
    [anon_sym_DASH_GT] = ACTIONS(6441),
    [anon_sym_DASH_GT_GT] = ACTIONS(6443),
    [anon_sym_PIPE] = ACTIONS(6445),
    [anon_sym_AMP] = ACTIONS(6447),
    [anon_sym_PIPE_PIPE] = ACTIONS(6449),
    [anon_sym_AMP_AMP] = ACTIONS(6451),
    [anon_sym_LT] = ACTIONS(6453),
    [anon_sym_LT_EQ] = ACTIONS(6455),
    [anon_sym_GT] = ACTIONS(6453),
    [anon_sym_GT_EQ] = ACTIONS(6455),
    [anon_sym_EQ_EQ] = ACTIONS(6455),
    [anon_sym_BANG_EQ] = ACTIONS(6455),
    [anon_sym_STAR] = ACTIONS(6457),
    [anon_sym_SLASH] = ACTIONS(6459),
    [anon_sym_STAR_STAR] = ACTIONS(6461),
    [anon_sym_CARET] = ACTIONS(6461),
    [aux_sym_binary_operator_token1] = ACTIONS(6463),
    [anon_sym_PIPE_GT] = ACTIONS(6463),
    [anon_sym_COLON] = ACTIONS(6465),
    [anon_sym_DOLLAR] = ACTIONS(6467),
    [anon_sym_AT] = ACTIONS(6467),
    [aux_sym__hex_literal_token1] = ACTIONS(5417),
    [sym__number_literal] = ACTIONS(5419),
    [anon_sym_SQUOTE] = ACTIONS(5417),
    [anon_sym_DQUOTE] = ACTIONS(5417),
    [sym_return] = ACTIONS(5419),
    [sym_next] = ACTIONS(5419),
    [sym_break] = ACTIONS(5419),
    [sym_true] = ACTIONS(5419),
    [sym_false] = ACTIONS(5419),
    [sym_null] = ACTIONS(5419),
    [sym_inf] = ACTIONS(5419),
    [sym_nan] = ACTIONS(5419),
    [anon_sym_NA] = ACTIONS(5419),
    [anon_sym_NA_integer_] = ACTIONS(5419),
    [anon_sym_NA_real_] = ACTIONS(5419),
    [anon_sym_NA_complex_] = ACTIONS(5419),
    [anon_sym_NA_character_] = ACTIONS(5419),
    [sym_dots] = ACTIONS(5419),
    [sym_dot_dot_i] = ACTIONS(5417),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5417),
    [sym__newline] = ACTIONS(5417),
    [sym__raw_string_literal] = ACTIONS(5417),
    [sym__external_open_parenthesis] = ACTIONS(6469),
    [sym__external_close_parenthesis] = ACTIONS(5417),
    [sym__external_open_brace] = ACTIONS(5417),
    [sym__external_open_bracket] = ACTIONS(6471),
    [sym__external_close_bracket] = ACTIONS(5417),
    [sym__external_open_bracket2] = ACTIONS(6473),
  },
  [1456] = {
    [sym_call_arguments] = STATE(2763),
    [sym_subset_arguments] = STATE(2764),
    [sym_subset2_arguments] = STATE(2765),
    [sym__open_parenthesis] = STATE(1584),
    [sym__open_bracket] = STATE(1582),
    [sym__open_bracket2] = STATE(1577),
    [sym_identifier] = ACTIONS(5423),
    [anon_sym_BSLASH] = ACTIONS(5421),
    [anon_sym_function] = ACTIONS(5423),
    [anon_sym_EQ] = ACTIONS(6431),
    [anon_sym_if] = ACTIONS(5423),
    [anon_sym_for] = ACTIONS(5423),
    [anon_sym_while] = ACTIONS(5423),
    [anon_sym_repeat] = ACTIONS(5423),
    [anon_sym_QMARK] = ACTIONS(5421),
    [anon_sym_TILDE] = ACTIONS(6433),
    [anon_sym_BANG] = ACTIONS(5423),
    [anon_sym_PLUS] = ACTIONS(6435),
    [anon_sym_DASH] = ACTIONS(6437),
    [anon_sym_LT_DASH] = ACTIONS(6439),
    [anon_sym_LT_LT_DASH] = ACTIONS(6439),
    [anon_sym_COLON_EQ] = ACTIONS(6439),
    [anon_sym_DASH_GT] = ACTIONS(6441),
    [anon_sym_DASH_GT_GT] = ACTIONS(6443),
    [anon_sym_PIPE] = ACTIONS(6445),
    [anon_sym_AMP] = ACTIONS(6447),
    [anon_sym_PIPE_PIPE] = ACTIONS(6449),
    [anon_sym_AMP_AMP] = ACTIONS(6451),
    [anon_sym_LT] = ACTIONS(6453),
    [anon_sym_LT_EQ] = ACTIONS(6455),
    [anon_sym_GT] = ACTIONS(6453),
    [anon_sym_GT_EQ] = ACTIONS(6455),
    [anon_sym_EQ_EQ] = ACTIONS(6455),
    [anon_sym_BANG_EQ] = ACTIONS(6455),
    [anon_sym_STAR] = ACTIONS(6457),
    [anon_sym_SLASH] = ACTIONS(6459),
    [anon_sym_STAR_STAR] = ACTIONS(6461),
    [anon_sym_CARET] = ACTIONS(6461),
    [aux_sym_binary_operator_token1] = ACTIONS(6463),
    [anon_sym_PIPE_GT] = ACTIONS(6463),
    [anon_sym_COLON] = ACTIONS(6465),
    [anon_sym_DOLLAR] = ACTIONS(6467),
    [anon_sym_AT] = ACTIONS(6467),
    [aux_sym__hex_literal_token1] = ACTIONS(5421),
    [sym__number_literal] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5421),
    [anon_sym_DQUOTE] = ACTIONS(5421),
    [sym_return] = ACTIONS(5423),
    [sym_next] = ACTIONS(5423),
    [sym_break] = ACTIONS(5423),
    [sym_true] = ACTIONS(5423),
    [sym_false] = ACTIONS(5423),
    [sym_null] = ACTIONS(5423),
    [sym_inf] = ACTIONS(5423),
    [sym_nan] = ACTIONS(5423),
    [anon_sym_NA] = ACTIONS(5423),
    [anon_sym_NA_integer_] = ACTIONS(5423),
    [anon_sym_NA_real_] = ACTIONS(5423),
    [anon_sym_NA_complex_] = ACTIONS(5423),
    [anon_sym_NA_character_] = ACTIONS(5423),
    [sym_dots] = ACTIONS(5423),
    [sym_dot_dot_i] = ACTIONS(5421),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5421),
    [sym__newline] = ACTIONS(5421),
    [sym__raw_string_literal] = ACTIONS(5421),
    [sym__external_open_parenthesis] = ACTIONS(6469),
    [sym__external_close_parenthesis] = ACTIONS(5421),
    [sym__external_open_brace] = ACTIONS(5421),
    [sym__external_open_bracket] = ACTIONS(6471),
    [sym__external_close_bracket] = ACTIONS(5421),
    [sym__external_open_bracket2] = ACTIONS(6473),
  },
  [1457] = {
    [sym_call_arguments] = STATE(2870),
    [sym_subset_arguments] = STATE(2869),
    [sym_subset2_arguments] = STATE(2867),
    [sym__open_parenthesis] = STATE(1362),
    [sym__open_bracket] = STATE(1361),
    [sym__open_bracket2] = STATE(1360),
    [sym_identifier] = ACTIONS(5443),
    [anon_sym_BSLASH] = ACTIONS(5441),
    [anon_sym_function] = ACTIONS(5443),
    [anon_sym_EQ] = ACTIONS(6111),
    [anon_sym_if] = ACTIONS(5443),
    [anon_sym_for] = ACTIONS(5443),
    [anon_sym_while] = ACTIONS(5443),
    [anon_sym_repeat] = ACTIONS(5443),
    [anon_sym_QMARK] = ACTIONS(5441),
    [anon_sym_TILDE] = ACTIONS(6113),
    [anon_sym_BANG] = ACTIONS(5443),
    [anon_sym_PLUS] = ACTIONS(6115),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_LT_DASH] = ACTIONS(6119),
    [anon_sym_LT_LT_DASH] = ACTIONS(6119),
    [anon_sym_COLON_EQ] = ACTIONS(6119),
    [anon_sym_DASH_GT] = ACTIONS(6121),
    [anon_sym_DASH_GT_GT] = ACTIONS(6123),
    [anon_sym_PIPE] = ACTIONS(6125),
    [anon_sym_AMP] = ACTIONS(6127),
    [anon_sym_PIPE_PIPE] = ACTIONS(6129),
    [anon_sym_AMP_AMP] = ACTIONS(6131),
    [anon_sym_LT] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6135),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_GT_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(6135),
    [anon_sym_STAR] = ACTIONS(6137),
    [anon_sym_SLASH] = ACTIONS(6139),
    [anon_sym_STAR_STAR] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6141),
    [aux_sym_binary_operator_token1] = ACTIONS(6143),
    [anon_sym_PIPE_GT] = ACTIONS(6143),
    [anon_sym_COLON] = ACTIONS(6145),
    [anon_sym_DOLLAR] = ACTIONS(6147),
    [anon_sym_AT] = ACTIONS(6147),
    [aux_sym__hex_literal_token1] = ACTIONS(5441),
    [sym__number_literal] = ACTIONS(5443),
    [anon_sym_SQUOTE] = ACTIONS(5441),
    [anon_sym_DQUOTE] = ACTIONS(5441),
    [sym_return] = ACTIONS(5443),
    [sym_next] = ACTIONS(5443),
    [sym_break] = ACTIONS(5443),
    [sym_true] = ACTIONS(5443),
    [sym_false] = ACTIONS(5443),
    [sym_null] = ACTIONS(5443),
    [sym_inf] = ACTIONS(5443),
    [sym_nan] = ACTIONS(5443),
    [anon_sym_NA] = ACTIONS(5443),
    [anon_sym_NA_integer_] = ACTIONS(5443),
    [anon_sym_NA_real_] = ACTIONS(5443),
    [anon_sym_NA_complex_] = ACTIONS(5443),
    [anon_sym_NA_character_] = ACTIONS(5443),
    [sym_dots] = ACTIONS(5443),
    [sym_dot_dot_i] = ACTIONS(5441),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5441),
    [sym__newline] = ACTIONS(5441),
    [sym__raw_string_literal] = ACTIONS(5441),
    [sym__external_else] = ACTIONS(5441),
    [sym__external_open_parenthesis] = ACTIONS(6151),
    [sym__external_open_brace] = ACTIONS(5441),
    [sym__external_open_bracket] = ACTIONS(6153),
    [sym__external_open_bracket2] = ACTIONS(6155),
    [sym__external_close_bracket2] = ACTIONS(5441),
  },
  [1458] = {
    [sym_call_arguments] = STATE(2763),
    [sym_subset_arguments] = STATE(2764),
    [sym_subset2_arguments] = STATE(2765),
    [sym__open_parenthesis] = STATE(1584),
    [sym__open_bracket] = STATE(1582),
    [sym__open_bracket2] = STATE(1577),
    [sym_identifier] = ACTIONS(5427),
    [anon_sym_BSLASH] = ACTIONS(5425),
    [anon_sym_function] = ACTIONS(5427),
    [anon_sym_EQ] = ACTIONS(6431),
    [anon_sym_if] = ACTIONS(5427),
    [anon_sym_for] = ACTIONS(5427),
    [anon_sym_while] = ACTIONS(5427),
    [anon_sym_repeat] = ACTIONS(5427),
    [anon_sym_QMARK] = ACTIONS(5425),
    [anon_sym_TILDE] = ACTIONS(6433),
    [anon_sym_BANG] = ACTIONS(5427),
    [anon_sym_PLUS] = ACTIONS(6435),
    [anon_sym_DASH] = ACTIONS(6437),
    [anon_sym_LT_DASH] = ACTIONS(6439),
    [anon_sym_LT_LT_DASH] = ACTIONS(6439),
    [anon_sym_COLON_EQ] = ACTIONS(6439),
    [anon_sym_DASH_GT] = ACTIONS(6441),
    [anon_sym_DASH_GT_GT] = ACTIONS(6443),
    [anon_sym_PIPE] = ACTIONS(6445),
    [anon_sym_AMP] = ACTIONS(6447),
    [anon_sym_PIPE_PIPE] = ACTIONS(6449),
    [anon_sym_AMP_AMP] = ACTIONS(6451),
    [anon_sym_LT] = ACTIONS(6453),
    [anon_sym_LT_EQ] = ACTIONS(6455),
    [anon_sym_GT] = ACTIONS(6453),
    [anon_sym_GT_EQ] = ACTIONS(6455),
    [anon_sym_EQ_EQ] = ACTIONS(6455),
    [anon_sym_BANG_EQ] = ACTIONS(6455),
    [anon_sym_STAR] = ACTIONS(6457),
    [anon_sym_SLASH] = ACTIONS(6459),
    [anon_sym_STAR_STAR] = ACTIONS(6461),
    [anon_sym_CARET] = ACTIONS(6461),
    [aux_sym_binary_operator_token1] = ACTIONS(6463),
    [anon_sym_PIPE_GT] = ACTIONS(6463),
    [anon_sym_COLON] = ACTIONS(6465),
    [anon_sym_DOLLAR] = ACTIONS(6467),
    [anon_sym_AT] = ACTIONS(6467),
    [aux_sym__hex_literal_token1] = ACTIONS(5425),
    [sym__number_literal] = ACTIONS(5427),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_DQUOTE] = ACTIONS(5425),
    [sym_return] = ACTIONS(5427),
    [sym_next] = ACTIONS(5427),
    [sym_break] = ACTIONS(5427),
    [sym_true] = ACTIONS(5427),
    [sym_false] = ACTIONS(5427),
    [sym_null] = ACTIONS(5427),
    [sym_inf] = ACTIONS(5427),
    [sym_nan] = ACTIONS(5427),
    [anon_sym_NA] = ACTIONS(5427),
    [anon_sym_NA_integer_] = ACTIONS(5427),
    [anon_sym_NA_real_] = ACTIONS(5427),
    [anon_sym_NA_complex_] = ACTIONS(5427),
    [anon_sym_NA_character_] = ACTIONS(5427),
    [sym_dots] = ACTIONS(5427),
    [sym_dot_dot_i] = ACTIONS(5425),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5425),
    [sym__newline] = ACTIONS(5425),
    [sym__raw_string_literal] = ACTIONS(5425),
    [sym__external_open_parenthesis] = ACTIONS(6469),
    [sym__external_close_parenthesis] = ACTIONS(5425),
    [sym__external_open_brace] = ACTIONS(5425),
    [sym__external_open_bracket] = ACTIONS(6471),
    [sym__external_close_bracket] = ACTIONS(5425),
    [sym__external_open_bracket2] = ACTIONS(6473),
  },
  [1459] = {
    [sym_call_arguments] = STATE(2870),
    [sym_subset_arguments] = STATE(2869),
    [sym_subset2_arguments] = STATE(2867),
    [sym__open_parenthesis] = STATE(1362),
    [sym__open_bracket] = STATE(1361),
    [sym__open_bracket2] = STATE(1360),
    [sym_identifier] = ACTIONS(5439),
    [anon_sym_BSLASH] = ACTIONS(5437),
    [anon_sym_function] = ACTIONS(5439),
    [anon_sym_EQ] = ACTIONS(6111),
    [anon_sym_if] = ACTIONS(5439),
    [anon_sym_for] = ACTIONS(5439),
    [anon_sym_while] = ACTIONS(5439),
    [anon_sym_repeat] = ACTIONS(5439),
    [anon_sym_QMARK] = ACTIONS(5437),
    [anon_sym_TILDE] = ACTIONS(6113),
    [anon_sym_BANG] = ACTIONS(5439),
    [anon_sym_PLUS] = ACTIONS(6115),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_LT_DASH] = ACTIONS(6119),
    [anon_sym_LT_LT_DASH] = ACTIONS(6119),
    [anon_sym_COLON_EQ] = ACTIONS(6119),
    [anon_sym_DASH_GT] = ACTIONS(6121),
    [anon_sym_DASH_GT_GT] = ACTIONS(6123),
    [anon_sym_PIPE] = ACTIONS(6125),
    [anon_sym_AMP] = ACTIONS(6127),
    [anon_sym_PIPE_PIPE] = ACTIONS(6129),
    [anon_sym_AMP_AMP] = ACTIONS(6131),
    [anon_sym_LT] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6135),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_GT_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(6135),
    [anon_sym_STAR] = ACTIONS(6137),
    [anon_sym_SLASH] = ACTIONS(6139),
    [anon_sym_STAR_STAR] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6141),
    [aux_sym_binary_operator_token1] = ACTIONS(6143),
    [anon_sym_PIPE_GT] = ACTIONS(6143),
    [anon_sym_COLON] = ACTIONS(6145),
    [anon_sym_DOLLAR] = ACTIONS(6147),
    [anon_sym_AT] = ACTIONS(6147),
    [aux_sym__hex_literal_token1] = ACTIONS(5437),
    [sym__number_literal] = ACTIONS(5439),
    [anon_sym_SQUOTE] = ACTIONS(5437),
    [anon_sym_DQUOTE] = ACTIONS(5437),
    [sym_return] = ACTIONS(5439),
    [sym_next] = ACTIONS(5439),
    [sym_break] = ACTIONS(5439),
    [sym_true] = ACTIONS(5439),
    [sym_false] = ACTIONS(5439),
    [sym_null] = ACTIONS(5439),
    [sym_inf] = ACTIONS(5439),
    [sym_nan] = ACTIONS(5439),
    [anon_sym_NA] = ACTIONS(5439),
    [anon_sym_NA_integer_] = ACTIONS(5439),
    [anon_sym_NA_real_] = ACTIONS(5439),
    [anon_sym_NA_complex_] = ACTIONS(5439),
    [anon_sym_NA_character_] = ACTIONS(5439),
    [sym_dots] = ACTIONS(5439),
    [sym_dot_dot_i] = ACTIONS(5437),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5437),
    [sym__newline] = ACTIONS(5437),
    [sym__raw_string_literal] = ACTIONS(5437),
    [sym__external_else] = ACTIONS(5437),
    [sym__external_open_parenthesis] = ACTIONS(6151),
    [sym__external_open_brace] = ACTIONS(5437),
    [sym__external_open_bracket] = ACTIONS(6153),
    [sym__external_open_bracket2] = ACTIONS(6155),
    [sym__external_close_bracket2] = ACTIONS(5437),
  },
  [1460] = {
    [sym_call_arguments] = STATE(2870),
    [sym_subset_arguments] = STATE(2869),
    [sym_subset2_arguments] = STATE(2867),
    [sym__open_parenthesis] = STATE(1362),
    [sym__open_bracket] = STATE(1361),
    [sym__open_bracket2] = STATE(1360),
    [sym_identifier] = ACTIONS(5435),
    [anon_sym_BSLASH] = ACTIONS(5433),
    [anon_sym_function] = ACTIONS(5435),
    [anon_sym_EQ] = ACTIONS(6111),
    [anon_sym_if] = ACTIONS(5435),
    [anon_sym_for] = ACTIONS(5435),
    [anon_sym_while] = ACTIONS(5435),
    [anon_sym_repeat] = ACTIONS(5435),
    [anon_sym_QMARK] = ACTIONS(5433),
    [anon_sym_TILDE] = ACTIONS(6113),
    [anon_sym_BANG] = ACTIONS(5435),
    [anon_sym_PLUS] = ACTIONS(6115),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_LT_DASH] = ACTIONS(6119),
    [anon_sym_LT_LT_DASH] = ACTIONS(6119),
    [anon_sym_COLON_EQ] = ACTIONS(6119),
    [anon_sym_DASH_GT] = ACTIONS(6121),
    [anon_sym_DASH_GT_GT] = ACTIONS(6123),
    [anon_sym_PIPE] = ACTIONS(6125),
    [anon_sym_AMP] = ACTIONS(6127),
    [anon_sym_PIPE_PIPE] = ACTIONS(6129),
    [anon_sym_AMP_AMP] = ACTIONS(6131),
    [anon_sym_LT] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6135),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_GT_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(6135),
    [anon_sym_STAR] = ACTIONS(6137),
    [anon_sym_SLASH] = ACTIONS(6139),
    [anon_sym_STAR_STAR] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6141),
    [aux_sym_binary_operator_token1] = ACTIONS(6143),
    [anon_sym_PIPE_GT] = ACTIONS(6143),
    [anon_sym_COLON] = ACTIONS(6145),
    [anon_sym_DOLLAR] = ACTIONS(6147),
    [anon_sym_AT] = ACTIONS(6147),
    [aux_sym__hex_literal_token1] = ACTIONS(5433),
    [sym__number_literal] = ACTIONS(5435),
    [anon_sym_SQUOTE] = ACTIONS(5433),
    [anon_sym_DQUOTE] = ACTIONS(5433),
    [sym_return] = ACTIONS(5435),
    [sym_next] = ACTIONS(5435),
    [sym_break] = ACTIONS(5435),
    [sym_true] = ACTIONS(5435),
    [sym_false] = ACTIONS(5435),
    [sym_null] = ACTIONS(5435),
    [sym_inf] = ACTIONS(5435),
    [sym_nan] = ACTIONS(5435),
    [anon_sym_NA] = ACTIONS(5435),
    [anon_sym_NA_integer_] = ACTIONS(5435),
    [anon_sym_NA_real_] = ACTIONS(5435),
    [anon_sym_NA_complex_] = ACTIONS(5435),
    [anon_sym_NA_character_] = ACTIONS(5435),
    [sym_dots] = ACTIONS(5435),
    [sym_dot_dot_i] = ACTIONS(5433),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5433),
    [sym__newline] = ACTIONS(5433),
    [sym__raw_string_literal] = ACTIONS(5433),
    [sym__external_else] = ACTIONS(5433),
    [sym__external_open_parenthesis] = ACTIONS(6151),
    [sym__external_open_brace] = ACTIONS(5433),
    [sym__external_open_bracket] = ACTIONS(6153),
    [sym__external_open_bracket2] = ACTIONS(6155),
    [sym__external_close_bracket2] = ACTIONS(5433),
  },
  [1461] = {
    [sym_function_definition] = STATE(1931),
    [sym_if_statement] = STATE(1931),
    [sym_for_statement] = STATE(1931),
    [sym_while_statement] = STATE(1931),
    [sym_repeat_statement] = STATE(1931),
    [sym_braced_expression] = STATE(1931),
    [sym_parenthesized_expression] = STATE(1931),
    [sym_call] = STATE(1931),
    [sym_subset] = STATE(1931),
    [sym_subset2] = STATE(1931),
    [sym__argument] = STATE(4656),
    [sym_argument] = STATE(4657),
    [sym__argument_named] = STATE(4658),
    [sym__argument_unnamed] = STATE(4662),
    [sym__argument_value] = STATE(4663),
    [sym_unary_operator] = STATE(1931),
    [sym_binary_operator] = STATE(1931),
    [sym_extract_operator] = STATE(1931),
    [sym_namespace_operator] = STATE(1931),
    [sym_integer] = STATE(1931),
    [sym_complex] = STATE(1931),
    [sym_float] = STATE(1931),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2633),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(1931),
    [sym__expression] = STATE(1931),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__close_parenthesis] = STATE(2521),
    [sym__open_brace] = STATE(154),
    [aux_sym_call_arguments_repeat1] = STATE(1532),
    [sym_identifier] = ACTIONS(6387),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(6389),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3865),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(6391),
    [sym_next] = ACTIONS(6391),
    [sym_break] = ACTIONS(6391),
    [sym_true] = ACTIONS(6391),
    [sym_false] = ACTIONS(6391),
    [sym_null] = ACTIONS(6391),
    [sym_inf] = ACTIONS(6391),
    [sym_nan] = ACTIONS(6391),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(6393),
    [sym_dot_dot_i] = ACTIONS(6395),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6397),
    [sym__newline] = ACTIONS(6399),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(6649),
    [sym__external_open_brace] = ACTIONS(3891),
  },
  [1462] = {
    [sym_call_arguments] = STATE(2763),
    [sym_subset_arguments] = STATE(2764),
    [sym_subset2_arguments] = STATE(2765),
    [sym__open_parenthesis] = STATE(1584),
    [sym__open_bracket] = STATE(1582),
    [sym__open_bracket2] = STATE(1577),
    [sym_identifier] = ACTIONS(5431),
    [anon_sym_BSLASH] = ACTIONS(5429),
    [anon_sym_function] = ACTIONS(5431),
    [anon_sym_EQ] = ACTIONS(6431),
    [anon_sym_if] = ACTIONS(5431),
    [anon_sym_for] = ACTIONS(5431),
    [anon_sym_while] = ACTIONS(5431),
    [anon_sym_repeat] = ACTIONS(5431),
    [anon_sym_QMARK] = ACTIONS(5429),
    [anon_sym_TILDE] = ACTIONS(6433),
    [anon_sym_BANG] = ACTIONS(5431),
    [anon_sym_PLUS] = ACTIONS(6435),
    [anon_sym_DASH] = ACTIONS(6437),
    [anon_sym_LT_DASH] = ACTIONS(6439),
    [anon_sym_LT_LT_DASH] = ACTIONS(6439),
    [anon_sym_COLON_EQ] = ACTIONS(6439),
    [anon_sym_DASH_GT] = ACTIONS(6441),
    [anon_sym_DASH_GT_GT] = ACTIONS(6443),
    [anon_sym_PIPE] = ACTIONS(6445),
    [anon_sym_AMP] = ACTIONS(6447),
    [anon_sym_PIPE_PIPE] = ACTIONS(6449),
    [anon_sym_AMP_AMP] = ACTIONS(6451),
    [anon_sym_LT] = ACTIONS(6453),
    [anon_sym_LT_EQ] = ACTIONS(6455),
    [anon_sym_GT] = ACTIONS(6453),
    [anon_sym_GT_EQ] = ACTIONS(6455),
    [anon_sym_EQ_EQ] = ACTIONS(6455),
    [anon_sym_BANG_EQ] = ACTIONS(6455),
    [anon_sym_STAR] = ACTIONS(6457),
    [anon_sym_SLASH] = ACTIONS(6459),
    [anon_sym_STAR_STAR] = ACTIONS(6461),
    [anon_sym_CARET] = ACTIONS(6461),
    [aux_sym_binary_operator_token1] = ACTIONS(6463),
    [anon_sym_PIPE_GT] = ACTIONS(6463),
    [anon_sym_COLON] = ACTIONS(6465),
    [anon_sym_DOLLAR] = ACTIONS(6467),
    [anon_sym_AT] = ACTIONS(6467),
    [aux_sym__hex_literal_token1] = ACTIONS(5429),
    [sym__number_literal] = ACTIONS(5431),
    [anon_sym_SQUOTE] = ACTIONS(5429),
    [anon_sym_DQUOTE] = ACTIONS(5429),
    [sym_return] = ACTIONS(5431),
    [sym_next] = ACTIONS(5431),
    [sym_break] = ACTIONS(5431),
    [sym_true] = ACTIONS(5431),
    [sym_false] = ACTIONS(5431),
    [sym_null] = ACTIONS(5431),
    [sym_inf] = ACTIONS(5431),
    [sym_nan] = ACTIONS(5431),
    [anon_sym_NA] = ACTIONS(5431),
    [anon_sym_NA_integer_] = ACTIONS(5431),
    [anon_sym_NA_real_] = ACTIONS(5431),
    [anon_sym_NA_complex_] = ACTIONS(5431),
    [anon_sym_NA_character_] = ACTIONS(5431),
    [sym_dots] = ACTIONS(5431),
    [sym_dot_dot_i] = ACTIONS(5429),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5429),
    [sym__newline] = ACTIONS(5429),
    [sym__raw_string_literal] = ACTIONS(5429),
    [sym__external_open_parenthesis] = ACTIONS(6469),
    [sym__external_close_parenthesis] = ACTIONS(5429),
    [sym__external_open_brace] = ACTIONS(5429),
    [sym__external_open_bracket] = ACTIONS(6471),
    [sym__external_close_bracket] = ACTIONS(5429),
    [sym__external_open_bracket2] = ACTIONS(6473),
  },
  [1463] = {
    [sym_function_definition] = STATE(1940),
    [sym_if_statement] = STATE(1940),
    [sym_for_statement] = STATE(1940),
    [sym_while_statement] = STATE(1940),
    [sym_repeat_statement] = STATE(1940),
    [sym_braced_expression] = STATE(1940),
    [sym_parenthesized_expression] = STATE(1940),
    [sym_call] = STATE(1940),
    [sym_subset] = STATE(1940),
    [sym_subset2] = STATE(1940),
    [sym__argument] = STATE(4665),
    [sym_argument] = STATE(4661),
    [sym__argument_named] = STATE(4669),
    [sym__argument_unnamed] = STATE(4673),
    [sym__argument_value] = STATE(4679),
    [sym_unary_operator] = STATE(1940),
    [sym_binary_operator] = STATE(1940),
    [sym_extract_operator] = STATE(1940),
    [sym_namespace_operator] = STATE(1940),
    [sym_integer] = STATE(1940),
    [sym_complex] = STATE(1940),
    [sym_float] = STATE(1940),
    [sym__hex_literal] = STATE(2656),
    [sym__float_literal] = STATE(2656),
    [sym_string] = STATE(2606),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym_na] = STATE(1940),
    [sym__expression] = STATE(1940),
    [sym__string_or_identifier] = STATE(5141),
    [sym__open_parenthesis] = STATE(218),
    [sym__open_brace] = STATE(185),
    [sym__close_bracket2] = STATE(2419),
    [aux_sym_call_arguments_repeat1] = STATE(1912),
    [sym_identifier] = ACTIONS(6369),
    [anon_sym_BSLASH] = ACTIONS(4644),
    [anon_sym_function] = ACTIONS(4646),
    [anon_sym_if] = ACTIONS(4648),
    [anon_sym_for] = ACTIONS(4650),
    [anon_sym_while] = ACTIONS(4652),
    [anon_sym_repeat] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(6371),
    [anon_sym_PLUS] = ACTIONS(4662),
    [anon_sym_DASH] = ACTIONS(4662),
    [aux_sym__hex_literal_token1] = ACTIONS(4666),
    [sym__number_literal] = ACTIONS(4668),
    [anon_sym_SQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4672),
    [sym_return] = ACTIONS(6373),
    [sym_next] = ACTIONS(6373),
    [sym_break] = ACTIONS(6373),
    [sym_true] = ACTIONS(6373),
    [sym_false] = ACTIONS(6373),
    [sym_null] = ACTIONS(6373),
    [sym_inf] = ACTIONS(6373),
    [sym_nan] = ACTIONS(6373),
    [anon_sym_NA] = ACTIONS(4676),
    [anon_sym_NA_integer_] = ACTIONS(4676),
    [anon_sym_NA_real_] = ACTIONS(4676),
    [anon_sym_NA_complex_] = ACTIONS(4676),
    [anon_sym_NA_character_] = ACTIONS(4676),
    [sym_dots] = ACTIONS(6375),
    [sym_dot_dot_i] = ACTIONS(6377),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6379),
    [sym__newline] = ACTIONS(6381),
    [sym__raw_string_literal] = ACTIONS(4680),
    [sym__external_open_parenthesis] = ACTIONS(4682),
    [sym__external_open_brace] = ACTIONS(4684),
    [sym__external_close_bracket2] = ACTIONS(6651),
  },
  [1464] = {
    [sym_call_arguments] = STATE(2840),
    [sym_subset_arguments] = STATE(2797),
    [sym_subset2_arguments] = STATE(2801),
    [sym__open_parenthesis] = STATE(1344),
    [sym__open_bracket] = STATE(1374),
    [sym__open_bracket2] = STATE(1452),
    [ts_builtin_sym_end] = ACTIONS(5409),
    [sym_identifier] = ACTIONS(5411),
    [anon_sym_BSLASH] = ACTIONS(5409),
    [anon_sym_function] = ACTIONS(5411),
    [anon_sym_EQ] = ACTIONS(6263),
    [anon_sym_if] = ACTIONS(5411),
    [anon_sym_for] = ACTIONS(5411),
    [anon_sym_while] = ACTIONS(5411),
    [anon_sym_repeat] = ACTIONS(5411),
    [anon_sym_QMARK] = ACTIONS(5409),
    [anon_sym_TILDE] = ACTIONS(6265),
    [anon_sym_BANG] = ACTIONS(5411),
    [anon_sym_PLUS] = ACTIONS(6267),
    [anon_sym_DASH] = ACTIONS(6269),
    [anon_sym_LT_DASH] = ACTIONS(6271),
    [anon_sym_LT_LT_DASH] = ACTIONS(6271),
    [anon_sym_COLON_EQ] = ACTIONS(6271),
    [anon_sym_DASH_GT] = ACTIONS(6273),
    [anon_sym_DASH_GT_GT] = ACTIONS(6275),
    [anon_sym_PIPE] = ACTIONS(6277),
    [anon_sym_AMP] = ACTIONS(6279),
    [anon_sym_PIPE_PIPE] = ACTIONS(6281),
    [anon_sym_AMP_AMP] = ACTIONS(6283),
    [anon_sym_LT] = ACTIONS(6285),
    [anon_sym_LT_EQ] = ACTIONS(6287),
    [anon_sym_GT] = ACTIONS(6285),
    [anon_sym_GT_EQ] = ACTIONS(6287),
    [anon_sym_EQ_EQ] = ACTIONS(6287),
    [anon_sym_BANG_EQ] = ACTIONS(6287),
    [anon_sym_STAR] = ACTIONS(6289),
    [anon_sym_SLASH] = ACTIONS(6291),
    [anon_sym_STAR_STAR] = ACTIONS(6293),
    [anon_sym_CARET] = ACTIONS(6293),
    [aux_sym_binary_operator_token1] = ACTIONS(6295),
    [anon_sym_PIPE_GT] = ACTIONS(6295),
    [anon_sym_COLON] = ACTIONS(6297),
    [anon_sym_DOLLAR] = ACTIONS(6299),
    [anon_sym_AT] = ACTIONS(6299),
    [aux_sym__hex_literal_token1] = ACTIONS(5409),
    [sym__number_literal] = ACTIONS(5411),
    [anon_sym_SQUOTE] = ACTIONS(5409),
    [anon_sym_DQUOTE] = ACTIONS(5409),
    [sym_return] = ACTIONS(5411),
    [sym_next] = ACTIONS(5411),
    [sym_break] = ACTIONS(5411),
    [sym_true] = ACTIONS(5411),
    [sym_false] = ACTIONS(5411),
    [sym_null] = ACTIONS(5411),
    [sym_inf] = ACTIONS(5411),
    [sym_nan] = ACTIONS(5411),
    [anon_sym_NA] = ACTIONS(5411),
    [anon_sym_NA_integer_] = ACTIONS(5411),
    [anon_sym_NA_real_] = ACTIONS(5411),
    [anon_sym_NA_complex_] = ACTIONS(5411),
    [anon_sym_NA_character_] = ACTIONS(5411),
    [sym_dots] = ACTIONS(5411),
    [sym_dot_dot_i] = ACTIONS(5409),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5409),
    [sym__semicolon] = ACTIONS(5409),
    [sym__raw_string_literal] = ACTIONS(5409),
    [sym__external_open_parenthesis] = ACTIONS(6301),
    [sym__external_open_brace] = ACTIONS(5409),
    [sym__external_close_brace] = ACTIONS(5409),
    [sym__external_open_bracket] = ACTIONS(6303),
    [sym__external_open_bracket2] = ACTIONS(6305),
  },
  [1465] = {
    [sym_call_arguments] = STATE(2763),
    [sym_subset_arguments] = STATE(2764),
    [sym_subset2_arguments] = STATE(2765),
    [sym__open_parenthesis] = STATE(1584),
    [sym__open_bracket] = STATE(1582),
    [sym__open_bracket2] = STATE(1577),
    [sym_identifier] = ACTIONS(5435),
    [anon_sym_BSLASH] = ACTIONS(5433),
    [anon_sym_function] = ACTIONS(5435),
    [anon_sym_EQ] = ACTIONS(6431),
    [anon_sym_if] = ACTIONS(5435),
    [anon_sym_for] = ACTIONS(5435),
    [anon_sym_while] = ACTIONS(5435),
    [anon_sym_repeat] = ACTIONS(5435),
    [anon_sym_QMARK] = ACTIONS(5433),
    [anon_sym_TILDE] = ACTIONS(6433),
    [anon_sym_BANG] = ACTIONS(5435),
    [anon_sym_PLUS] = ACTIONS(6435),
    [anon_sym_DASH] = ACTIONS(6437),
    [anon_sym_LT_DASH] = ACTIONS(6439),
    [anon_sym_LT_LT_DASH] = ACTIONS(6439),
    [anon_sym_COLON_EQ] = ACTIONS(6439),
    [anon_sym_DASH_GT] = ACTIONS(6441),
    [anon_sym_DASH_GT_GT] = ACTIONS(6443),
    [anon_sym_PIPE] = ACTIONS(6445),
    [anon_sym_AMP] = ACTIONS(6447),
    [anon_sym_PIPE_PIPE] = ACTIONS(6449),
    [anon_sym_AMP_AMP] = ACTIONS(6451),
    [anon_sym_LT] = ACTIONS(6453),
    [anon_sym_LT_EQ] = ACTIONS(6455),
    [anon_sym_GT] = ACTIONS(6453),
    [anon_sym_GT_EQ] = ACTIONS(6455),
    [anon_sym_EQ_EQ] = ACTIONS(6455),
    [anon_sym_BANG_EQ] = ACTIONS(6455),
    [anon_sym_STAR] = ACTIONS(6457),
    [anon_sym_SLASH] = ACTIONS(6459),
    [anon_sym_STAR_STAR] = ACTIONS(6461),
    [anon_sym_CARET] = ACTIONS(6461),
    [aux_sym_binary_operator_token1] = ACTIONS(6463),
    [anon_sym_PIPE_GT] = ACTIONS(6463),
    [anon_sym_COLON] = ACTIONS(6465),
    [anon_sym_DOLLAR] = ACTIONS(6467),
    [anon_sym_AT] = ACTIONS(6467),
    [aux_sym__hex_literal_token1] = ACTIONS(5433),
    [sym__number_literal] = ACTIONS(5435),
    [anon_sym_SQUOTE] = ACTIONS(5433),
    [anon_sym_DQUOTE] = ACTIONS(5433),
    [sym_return] = ACTIONS(5435),
    [sym_next] = ACTIONS(5435),
    [sym_break] = ACTIONS(5435),
    [sym_true] = ACTIONS(5435),
    [sym_false] = ACTIONS(5435),
    [sym_null] = ACTIONS(5435),
    [sym_inf] = ACTIONS(5435),
    [sym_nan] = ACTIONS(5435),
    [anon_sym_NA] = ACTIONS(5435),
    [anon_sym_NA_integer_] = ACTIONS(5435),
    [anon_sym_NA_real_] = ACTIONS(5435),
    [anon_sym_NA_complex_] = ACTIONS(5435),
    [anon_sym_NA_character_] = ACTIONS(5435),
    [sym_dots] = ACTIONS(5435),
    [sym_dot_dot_i] = ACTIONS(5433),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5433),
    [sym__newline] = ACTIONS(5433),
    [sym__raw_string_literal] = ACTIONS(5433),
    [sym__external_open_parenthesis] = ACTIONS(6469),
    [sym__external_close_parenthesis] = ACTIONS(5433),
    [sym__external_open_brace] = ACTIONS(5433),
    [sym__external_open_bracket] = ACTIONS(6471),
    [sym__external_close_bracket] = ACTIONS(5433),
    [sym__external_open_bracket2] = ACTIONS(6473),
  },
  [1466] = {
    [sym_call_arguments] = STATE(2763),
    [sym_subset_arguments] = STATE(2764),
    [sym_subset2_arguments] = STATE(2765),
    [sym__open_parenthesis] = STATE(1584),
    [sym__open_bracket] = STATE(1582),
    [sym__open_bracket2] = STATE(1577),
    [sym_identifier] = ACTIONS(5439),
    [anon_sym_BSLASH] = ACTIONS(5437),
    [anon_sym_function] = ACTIONS(5439),
    [anon_sym_EQ] = ACTIONS(6431),
    [anon_sym_if] = ACTIONS(5439),
    [anon_sym_for] = ACTIONS(5439),
    [anon_sym_while] = ACTIONS(5439),
    [anon_sym_repeat] = ACTIONS(5439),
    [anon_sym_QMARK] = ACTIONS(5437),
    [anon_sym_TILDE] = ACTIONS(6433),
    [anon_sym_BANG] = ACTIONS(5439),
    [anon_sym_PLUS] = ACTIONS(6435),
    [anon_sym_DASH] = ACTIONS(6437),
    [anon_sym_LT_DASH] = ACTIONS(6439),
    [anon_sym_LT_LT_DASH] = ACTIONS(6439),
    [anon_sym_COLON_EQ] = ACTIONS(6439),
    [anon_sym_DASH_GT] = ACTIONS(6441),
    [anon_sym_DASH_GT_GT] = ACTIONS(6443),
    [anon_sym_PIPE] = ACTIONS(6445),
    [anon_sym_AMP] = ACTIONS(6447),
    [anon_sym_PIPE_PIPE] = ACTIONS(6449),
    [anon_sym_AMP_AMP] = ACTIONS(6451),
    [anon_sym_LT] = ACTIONS(6453),
    [anon_sym_LT_EQ] = ACTIONS(6455),
    [anon_sym_GT] = ACTIONS(6453),
    [anon_sym_GT_EQ] = ACTIONS(6455),
    [anon_sym_EQ_EQ] = ACTIONS(6455),
    [anon_sym_BANG_EQ] = ACTIONS(6455),
    [anon_sym_STAR] = ACTIONS(6457),
    [anon_sym_SLASH] = ACTIONS(6459),
    [anon_sym_STAR_STAR] = ACTIONS(6461),
    [anon_sym_CARET] = ACTIONS(6461),
    [aux_sym_binary_operator_token1] = ACTIONS(6463),
    [anon_sym_PIPE_GT] = ACTIONS(6463),
    [anon_sym_COLON] = ACTIONS(6465),
    [anon_sym_DOLLAR] = ACTIONS(6467),
    [anon_sym_AT] = ACTIONS(6467),
    [aux_sym__hex_literal_token1] = ACTIONS(5437),
    [sym__number_literal] = ACTIONS(5439),
    [anon_sym_SQUOTE] = ACTIONS(5437),
    [anon_sym_DQUOTE] = ACTIONS(5437),
    [sym_return] = ACTIONS(5439),
    [sym_next] = ACTIONS(5439),
    [sym_break] = ACTIONS(5439),
    [sym_true] = ACTIONS(5439),
    [sym_false] = ACTIONS(5439),
    [sym_null] = ACTIONS(5439),
    [sym_inf] = ACTIONS(5439),
    [sym_nan] = ACTIONS(5439),
    [anon_sym_NA] = ACTIONS(5439),
    [anon_sym_NA_integer_] = ACTIONS(5439),
    [anon_sym_NA_real_] = ACTIONS(5439),
    [anon_sym_NA_complex_] = ACTIONS(5439),
    [anon_sym_NA_character_] = ACTIONS(5439),
    [sym_dots] = ACTIONS(5439),
    [sym_dot_dot_i] = ACTIONS(5437),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5437),
    [sym__newline] = ACTIONS(5437),
    [sym__raw_string_literal] = ACTIONS(5437),
    [sym__external_open_parenthesis] = ACTIONS(6469),
    [sym__external_close_parenthesis] = ACTIONS(5437),
    [sym__external_open_brace] = ACTIONS(5437),
    [sym__external_open_bracket] = ACTIONS(6471),
    [sym__external_close_bracket] = ACTIONS(5437),
    [sym__external_open_bracket2] = ACTIONS(6473),
  },
  [1467] = {
    [sym_call_arguments] = STATE(2763),
    [sym_subset_arguments] = STATE(2764),
    [sym_subset2_arguments] = STATE(2765),
    [sym__open_parenthesis] = STATE(1584),
    [sym__open_bracket] = STATE(1582),
    [sym__open_bracket2] = STATE(1577),
    [sym_identifier] = ACTIONS(5443),
    [anon_sym_BSLASH] = ACTIONS(5441),
    [anon_sym_function] = ACTIONS(5443),
    [anon_sym_EQ] = ACTIONS(6431),
    [anon_sym_if] = ACTIONS(5443),
    [anon_sym_for] = ACTIONS(5443),
    [anon_sym_while] = ACTIONS(5443),
    [anon_sym_repeat] = ACTIONS(5443),
    [anon_sym_QMARK] = ACTIONS(5441),
    [anon_sym_TILDE] = ACTIONS(6433),
    [anon_sym_BANG] = ACTIONS(5443),
    [anon_sym_PLUS] = ACTIONS(6435),
    [anon_sym_DASH] = ACTIONS(6437),
    [anon_sym_LT_DASH] = ACTIONS(6439),
    [anon_sym_LT_LT_DASH] = ACTIONS(6439),
    [anon_sym_COLON_EQ] = ACTIONS(6439),
    [anon_sym_DASH_GT] = ACTIONS(6441),
    [anon_sym_DASH_GT_GT] = ACTIONS(6443),
    [anon_sym_PIPE] = ACTIONS(6445),
    [anon_sym_AMP] = ACTIONS(6447),
    [anon_sym_PIPE_PIPE] = ACTIONS(6449),
    [anon_sym_AMP_AMP] = ACTIONS(6451),
    [anon_sym_LT] = ACTIONS(6453),
    [anon_sym_LT_EQ] = ACTIONS(6455),
    [anon_sym_GT] = ACTIONS(6453),
    [anon_sym_GT_EQ] = ACTIONS(6455),
    [anon_sym_EQ_EQ] = ACTIONS(6455),
    [anon_sym_BANG_EQ] = ACTIONS(6455),
    [anon_sym_STAR] = ACTIONS(6457),
    [anon_sym_SLASH] = ACTIONS(6459),
    [anon_sym_STAR_STAR] = ACTIONS(6461),
    [anon_sym_CARET] = ACTIONS(6461),
    [aux_sym_binary_operator_token1] = ACTIONS(6463),
    [anon_sym_PIPE_GT] = ACTIONS(6463),
    [anon_sym_COLON] = ACTIONS(6465),
    [anon_sym_DOLLAR] = ACTIONS(6467),
    [anon_sym_AT] = ACTIONS(6467),
    [aux_sym__hex_literal_token1] = ACTIONS(5441),
    [sym__number_literal] = ACTIONS(5443),
    [anon_sym_SQUOTE] = ACTIONS(5441),
    [anon_sym_DQUOTE] = ACTIONS(5441),
    [sym_return] = ACTIONS(5443),
    [sym_next] = ACTIONS(5443),
    [sym_break] = ACTIONS(5443),
    [sym_true] = ACTIONS(5443),
    [sym_false] = ACTIONS(5443),
    [sym_null] = ACTIONS(5443),
    [sym_inf] = ACTIONS(5443),
    [sym_nan] = ACTIONS(5443),
    [anon_sym_NA] = ACTIONS(5443),
    [anon_sym_NA_integer_] = ACTIONS(5443),
    [anon_sym_NA_real_] = ACTIONS(5443),
    [anon_sym_NA_complex_] = ACTIONS(5443),
    [anon_sym_NA_character_] = ACTIONS(5443),
    [sym_dots] = ACTIONS(5443),
    [sym_dot_dot_i] = ACTIONS(5441),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5441),
    [sym__newline] = ACTIONS(5441),
    [sym__raw_string_literal] = ACTIONS(5441),
    [sym__external_open_parenthesis] = ACTIONS(6469),
    [sym__external_close_parenthesis] = ACTIONS(5441),
    [sym__external_open_brace] = ACTIONS(5441),
    [sym__external_open_bracket] = ACTIONS(6471),
    [sym__external_close_bracket] = ACTIONS(5441),
    [sym__external_open_bracket2] = ACTIONS(6473),
  },
  [1468] = {
    [sym_call_arguments] = STATE(2870),
    [sym_subset_arguments] = STATE(2869),
    [sym_subset2_arguments] = STATE(2867),
    [sym__open_parenthesis] = STATE(1362),
    [sym__open_bracket] = STATE(1361),
    [sym__open_bracket2] = STATE(1360),
    [sym_identifier] = ACTIONS(5431),
    [anon_sym_BSLASH] = ACTIONS(5429),
    [anon_sym_function] = ACTIONS(5431),
    [anon_sym_EQ] = ACTIONS(6111),
    [anon_sym_if] = ACTIONS(5431),
    [anon_sym_for] = ACTIONS(5431),
    [anon_sym_while] = ACTIONS(5431),
    [anon_sym_repeat] = ACTIONS(5431),
    [anon_sym_QMARK] = ACTIONS(5429),
    [anon_sym_TILDE] = ACTIONS(6113),
    [anon_sym_BANG] = ACTIONS(5431),
    [anon_sym_PLUS] = ACTIONS(6115),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_LT_DASH] = ACTIONS(6119),
    [anon_sym_LT_LT_DASH] = ACTIONS(6119),
    [anon_sym_COLON_EQ] = ACTIONS(6119),
    [anon_sym_DASH_GT] = ACTIONS(6121),
    [anon_sym_DASH_GT_GT] = ACTIONS(6123),
    [anon_sym_PIPE] = ACTIONS(6125),
    [anon_sym_AMP] = ACTIONS(6127),
    [anon_sym_PIPE_PIPE] = ACTIONS(6129),
    [anon_sym_AMP_AMP] = ACTIONS(6131),
    [anon_sym_LT] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6135),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_GT_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(6135),
    [anon_sym_STAR] = ACTIONS(6137),
    [anon_sym_SLASH] = ACTIONS(6139),
    [anon_sym_STAR_STAR] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6141),
    [aux_sym_binary_operator_token1] = ACTIONS(6143),
    [anon_sym_PIPE_GT] = ACTIONS(6143),
    [anon_sym_COLON] = ACTIONS(6145),
    [anon_sym_DOLLAR] = ACTIONS(6147),
    [anon_sym_AT] = ACTIONS(6147),
    [aux_sym__hex_literal_token1] = ACTIONS(5429),
    [sym__number_literal] = ACTIONS(5431),
    [anon_sym_SQUOTE] = ACTIONS(5429),
    [anon_sym_DQUOTE] = ACTIONS(5429),
    [sym_return] = ACTIONS(5431),
    [sym_next] = ACTIONS(5431),
    [sym_break] = ACTIONS(5431),
    [sym_true] = ACTIONS(5431),
    [sym_false] = ACTIONS(5431),
    [sym_null] = ACTIONS(5431),
    [sym_inf] = ACTIONS(5431),
    [sym_nan] = ACTIONS(5431),
    [anon_sym_NA] = ACTIONS(5431),
    [anon_sym_NA_integer_] = ACTIONS(5431),
    [anon_sym_NA_real_] = ACTIONS(5431),
    [anon_sym_NA_complex_] = ACTIONS(5431),
    [anon_sym_NA_character_] = ACTIONS(5431),
    [sym_dots] = ACTIONS(5431),
    [sym_dot_dot_i] = ACTIONS(5429),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5429),
    [sym__newline] = ACTIONS(5429),
    [sym__raw_string_literal] = ACTIONS(5429),
    [sym__external_else] = ACTIONS(5429),
    [sym__external_open_parenthesis] = ACTIONS(6151),
    [sym__external_open_brace] = ACTIONS(5429),
    [sym__external_open_bracket] = ACTIONS(6153),
    [sym__external_open_bracket2] = ACTIONS(6155),
    [sym__external_close_bracket2] = ACTIONS(5429),
  },
  [1469] = {
    [sym_call_arguments] = STATE(2763),
    [sym_subset_arguments] = STATE(2764),
    [sym_subset2_arguments] = STATE(2765),
    [sym__open_parenthesis] = STATE(1584),
    [sym__open_bracket] = STATE(1582),
    [sym__open_bracket2] = STATE(1577),
    [sym_identifier] = ACTIONS(5447),
    [anon_sym_BSLASH] = ACTIONS(5445),
    [anon_sym_function] = ACTIONS(5447),
    [anon_sym_EQ] = ACTIONS(6431),
    [anon_sym_if] = ACTIONS(5447),
    [anon_sym_for] = ACTIONS(5447),
    [anon_sym_while] = ACTIONS(5447),
    [anon_sym_repeat] = ACTIONS(5447),
    [anon_sym_QMARK] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(6433),
    [anon_sym_BANG] = ACTIONS(5447),
    [anon_sym_PLUS] = ACTIONS(6435),
    [anon_sym_DASH] = ACTIONS(6437),
    [anon_sym_LT_DASH] = ACTIONS(6439),
    [anon_sym_LT_LT_DASH] = ACTIONS(6439),
    [anon_sym_COLON_EQ] = ACTIONS(6439),
    [anon_sym_DASH_GT] = ACTIONS(6441),
    [anon_sym_DASH_GT_GT] = ACTIONS(6443),
    [anon_sym_PIPE] = ACTIONS(6445),
    [anon_sym_AMP] = ACTIONS(6447),
    [anon_sym_PIPE_PIPE] = ACTIONS(6449),
    [anon_sym_AMP_AMP] = ACTIONS(6451),
    [anon_sym_LT] = ACTIONS(6453),
    [anon_sym_LT_EQ] = ACTIONS(6455),
    [anon_sym_GT] = ACTIONS(6453),
    [anon_sym_GT_EQ] = ACTIONS(6455),
    [anon_sym_EQ_EQ] = ACTIONS(6455),
    [anon_sym_BANG_EQ] = ACTIONS(6455),
    [anon_sym_STAR] = ACTIONS(6457),
    [anon_sym_SLASH] = ACTIONS(6459),
    [anon_sym_STAR_STAR] = ACTIONS(6461),
    [anon_sym_CARET] = ACTIONS(6461),
    [aux_sym_binary_operator_token1] = ACTIONS(6463),
    [anon_sym_PIPE_GT] = ACTIONS(6463),
    [anon_sym_COLON] = ACTIONS(6465),
    [anon_sym_DOLLAR] = ACTIONS(6467),
    [anon_sym_AT] = ACTIONS(6467),
    [aux_sym__hex_literal_token1] = ACTIONS(5445),
    [sym__number_literal] = ACTIONS(5447),
    [anon_sym_SQUOTE] = ACTIONS(5445),
    [anon_sym_DQUOTE] = ACTIONS(5445),
    [sym_return] = ACTIONS(5447),
    [sym_next] = ACTIONS(5447),
    [sym_break] = ACTIONS(5447),
    [sym_true] = ACTIONS(5447),
    [sym_false] = ACTIONS(5447),
    [sym_null] = ACTIONS(5447),
    [sym_inf] = ACTIONS(5447),
    [sym_nan] = ACTIONS(5447),
    [anon_sym_NA] = ACTIONS(5447),
    [anon_sym_NA_integer_] = ACTIONS(5447),
    [anon_sym_NA_real_] = ACTIONS(5447),
    [anon_sym_NA_complex_] = ACTIONS(5447),
    [anon_sym_NA_character_] = ACTIONS(5447),
    [sym_dots] = ACTIONS(5447),
    [sym_dot_dot_i] = ACTIONS(5445),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5445),
    [sym__newline] = ACTIONS(5445),
    [sym__raw_string_literal] = ACTIONS(5445),
    [sym__external_open_parenthesis] = ACTIONS(6469),
    [sym__external_close_parenthesis] = ACTIONS(5445),
    [sym__external_open_brace] = ACTIONS(5445),
    [sym__external_open_bracket] = ACTIONS(6471),
    [sym__external_close_bracket] = ACTIONS(5445),
    [sym__external_open_bracket2] = ACTIONS(6473),
  },
  [1470] = {
    [sym_call_arguments] = STATE(2763),
    [sym_subset_arguments] = STATE(2764),
    [sym_subset2_arguments] = STATE(2765),
    [sym__open_parenthesis] = STATE(1584),
    [sym__open_bracket] = STATE(1582),
    [sym__open_bracket2] = STATE(1577),
    [sym_identifier] = ACTIONS(5451),
    [anon_sym_BSLASH] = ACTIONS(5449),
    [anon_sym_function] = ACTIONS(5451),
    [anon_sym_EQ] = ACTIONS(6431),
    [anon_sym_if] = ACTIONS(5451),
    [anon_sym_for] = ACTIONS(5451),
    [anon_sym_while] = ACTIONS(5451),
    [anon_sym_repeat] = ACTIONS(5451),
    [anon_sym_QMARK] = ACTIONS(5449),
    [anon_sym_TILDE] = ACTIONS(6433),
    [anon_sym_BANG] = ACTIONS(5451),
    [anon_sym_PLUS] = ACTIONS(6435),
    [anon_sym_DASH] = ACTIONS(6437),
    [anon_sym_LT_DASH] = ACTIONS(6439),
    [anon_sym_LT_LT_DASH] = ACTIONS(6439),
    [anon_sym_COLON_EQ] = ACTIONS(6439),
    [anon_sym_DASH_GT] = ACTIONS(6441),
    [anon_sym_DASH_GT_GT] = ACTIONS(6443),
    [anon_sym_PIPE] = ACTIONS(6445),
    [anon_sym_AMP] = ACTIONS(6447),
    [anon_sym_PIPE_PIPE] = ACTIONS(6449),
    [anon_sym_AMP_AMP] = ACTIONS(6451),
    [anon_sym_LT] = ACTIONS(6453),
    [anon_sym_LT_EQ] = ACTIONS(6455),
    [anon_sym_GT] = ACTIONS(6453),
    [anon_sym_GT_EQ] = ACTIONS(6455),
    [anon_sym_EQ_EQ] = ACTIONS(6455),
    [anon_sym_BANG_EQ] = ACTIONS(6455),
    [anon_sym_STAR] = ACTIONS(6457),
    [anon_sym_SLASH] = ACTIONS(6459),
    [anon_sym_STAR_STAR] = ACTIONS(6461),
    [anon_sym_CARET] = ACTIONS(6461),
    [aux_sym_binary_operator_token1] = ACTIONS(6463),
    [anon_sym_PIPE_GT] = ACTIONS(6463),
    [anon_sym_COLON] = ACTIONS(6465),
    [anon_sym_DOLLAR] = ACTIONS(6467),
    [anon_sym_AT] = ACTIONS(6467),
    [aux_sym__hex_literal_token1] = ACTIONS(5449),
    [sym__number_literal] = ACTIONS(5451),
    [anon_sym_SQUOTE] = ACTIONS(5449),
    [anon_sym_DQUOTE] = ACTIONS(5449),
    [sym_return] = ACTIONS(5451),
    [sym_next] = ACTIONS(5451),
    [sym_break] = ACTIONS(5451),
    [sym_true] = ACTIONS(5451),
    [sym_false] = ACTIONS(5451),
    [sym_null] = ACTIONS(5451),
    [sym_inf] = ACTIONS(5451),
    [sym_nan] = ACTIONS(5451),
    [anon_sym_NA] = ACTIONS(5451),
    [anon_sym_NA_integer_] = ACTIONS(5451),
    [anon_sym_NA_real_] = ACTIONS(5451),
    [anon_sym_NA_complex_] = ACTIONS(5451),
    [anon_sym_NA_character_] = ACTIONS(5451),
    [sym_dots] = ACTIONS(5451),
    [sym_dot_dot_i] = ACTIONS(5449),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5449),
    [sym__newline] = ACTIONS(5449),
    [sym__raw_string_literal] = ACTIONS(5449),
    [sym__external_open_parenthesis] = ACTIONS(6469),
    [sym__external_close_parenthesis] = ACTIONS(5449),
    [sym__external_open_brace] = ACTIONS(5449),
    [sym__external_open_bracket] = ACTIONS(6471),
    [sym__external_close_bracket] = ACTIONS(5449),
    [sym__external_open_bracket2] = ACTIONS(6473),
  },
  [1471] = {
    [sym_call_arguments] = STATE(2840),
    [sym_subset_arguments] = STATE(2797),
    [sym_subset2_arguments] = STATE(2801),
    [sym__open_parenthesis] = STATE(1344),
    [sym__open_bracket] = STATE(1374),
    [sym__open_bracket2] = STATE(1452),
    [ts_builtin_sym_end] = ACTIONS(5453),
    [sym_identifier] = ACTIONS(5455),
    [anon_sym_BSLASH] = ACTIONS(5453),
    [anon_sym_function] = ACTIONS(5455),
    [anon_sym_EQ] = ACTIONS(6263),
    [anon_sym_if] = ACTIONS(5455),
    [anon_sym_for] = ACTIONS(5455),
    [anon_sym_while] = ACTIONS(5455),
    [anon_sym_repeat] = ACTIONS(5455),
    [anon_sym_QMARK] = ACTIONS(5453),
    [anon_sym_TILDE] = ACTIONS(6265),
    [anon_sym_BANG] = ACTIONS(5455),
    [anon_sym_PLUS] = ACTIONS(6267),
    [anon_sym_DASH] = ACTIONS(6269),
    [anon_sym_LT_DASH] = ACTIONS(6271),
    [anon_sym_LT_LT_DASH] = ACTIONS(6271),
    [anon_sym_COLON_EQ] = ACTIONS(6271),
    [anon_sym_DASH_GT] = ACTIONS(6273),
    [anon_sym_DASH_GT_GT] = ACTIONS(6275),
    [anon_sym_PIPE] = ACTIONS(6277),
    [anon_sym_AMP] = ACTIONS(6279),
    [anon_sym_PIPE_PIPE] = ACTIONS(6281),
    [anon_sym_AMP_AMP] = ACTIONS(6283),
    [anon_sym_LT] = ACTIONS(6285),
    [anon_sym_LT_EQ] = ACTIONS(6287),
    [anon_sym_GT] = ACTIONS(6285),
    [anon_sym_GT_EQ] = ACTIONS(6287),
    [anon_sym_EQ_EQ] = ACTIONS(6287),
    [anon_sym_BANG_EQ] = ACTIONS(6287),
    [anon_sym_STAR] = ACTIONS(6289),
    [anon_sym_SLASH] = ACTIONS(6291),
    [anon_sym_STAR_STAR] = ACTIONS(6293),
    [anon_sym_CARET] = ACTIONS(6293),
    [aux_sym_binary_operator_token1] = ACTIONS(6295),
    [anon_sym_PIPE_GT] = ACTIONS(6295),
    [anon_sym_COLON] = ACTIONS(6297),
    [anon_sym_DOLLAR] = ACTIONS(6299),
    [anon_sym_AT] = ACTIONS(6299),
    [aux_sym__hex_literal_token1] = ACTIONS(5453),
    [sym__number_literal] = ACTIONS(5455),
    [anon_sym_SQUOTE] = ACTIONS(5453),
    [anon_sym_DQUOTE] = ACTIONS(5453),
    [sym_return] = ACTIONS(5455),
    [sym_next] = ACTIONS(5455),
    [sym_break] = ACTIONS(5455),
    [sym_true] = ACTIONS(5455),
    [sym_false] = ACTIONS(5455),
    [sym_null] = ACTIONS(5455),
    [sym_inf] = ACTIONS(5455),
    [sym_nan] = ACTIONS(5455),
    [anon_sym_NA] = ACTIONS(5455),
    [anon_sym_NA_integer_] = ACTIONS(5455),
    [anon_sym_NA_real_] = ACTIONS(5455),
    [anon_sym_NA_complex_] = ACTIONS(5455),
    [anon_sym_NA_character_] = ACTIONS(5455),
    [sym_dots] = ACTIONS(5455),
    [sym_dot_dot_i] = ACTIONS(5453),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5453),
    [sym__semicolon] = ACTIONS(5453),
    [sym__raw_string_literal] = ACTIONS(5453),
    [sym__external_open_parenthesis] = ACTIONS(6301),
    [sym__external_open_brace] = ACTIONS(5453),
    [sym__external_close_brace] = ACTIONS(5453),
    [sym__external_open_bracket] = ACTIONS(6303),
    [sym__external_open_bracket2] = ACTIONS(6305),
  },
  [1472] = {
    [sym_call_arguments] = STATE(2763),
    [sym_subset_arguments] = STATE(2764),
    [sym_subset2_arguments] = STATE(2765),
    [sym__open_parenthesis] = STATE(1584),
    [sym__open_bracket] = STATE(1582),
    [sym__open_bracket2] = STATE(1577),
    [sym_identifier] = ACTIONS(5455),
    [anon_sym_BSLASH] = ACTIONS(5453),
    [anon_sym_function] = ACTIONS(5455),
    [anon_sym_EQ] = ACTIONS(6431),
    [anon_sym_if] = ACTIONS(5455),
    [anon_sym_for] = ACTIONS(5455),
    [anon_sym_while] = ACTIONS(5455),
    [anon_sym_repeat] = ACTIONS(5455),
    [anon_sym_QMARK] = ACTIONS(5453),
    [anon_sym_TILDE] = ACTIONS(6433),
    [anon_sym_BANG] = ACTIONS(5455),
    [anon_sym_PLUS] = ACTIONS(6435),
    [anon_sym_DASH] = ACTIONS(6437),
    [anon_sym_LT_DASH] = ACTIONS(6439),
    [anon_sym_LT_LT_DASH] = ACTIONS(6439),
    [anon_sym_COLON_EQ] = ACTIONS(6439),
    [anon_sym_DASH_GT] = ACTIONS(6441),
    [anon_sym_DASH_GT_GT] = ACTIONS(6443),
    [anon_sym_PIPE] = ACTIONS(6445),
    [anon_sym_AMP] = ACTIONS(6447),
    [anon_sym_PIPE_PIPE] = ACTIONS(6449),
    [anon_sym_AMP_AMP] = ACTIONS(6451),
    [anon_sym_LT] = ACTIONS(6453),
    [anon_sym_LT_EQ] = ACTIONS(6455),
    [anon_sym_GT] = ACTIONS(6453),
    [anon_sym_GT_EQ] = ACTIONS(6455),
    [anon_sym_EQ_EQ] = ACTIONS(6455),
    [anon_sym_BANG_EQ] = ACTIONS(6455),
    [anon_sym_STAR] = ACTIONS(6457),
    [anon_sym_SLASH] = ACTIONS(6459),
    [anon_sym_STAR_STAR] = ACTIONS(6461),
    [anon_sym_CARET] = ACTIONS(6461),
    [aux_sym_binary_operator_token1] = ACTIONS(6463),
    [anon_sym_PIPE_GT] = ACTIONS(6463),
    [anon_sym_COLON] = ACTIONS(6465),
    [anon_sym_DOLLAR] = ACTIONS(6467),
    [anon_sym_AT] = ACTIONS(6467),
    [aux_sym__hex_literal_token1] = ACTIONS(5453),
    [sym__number_literal] = ACTIONS(5455),
    [anon_sym_SQUOTE] = ACTIONS(5453),
    [anon_sym_DQUOTE] = ACTIONS(5453),
    [sym_return] = ACTIONS(5455),
    [sym_next] = ACTIONS(5455),
    [sym_break] = ACTIONS(5455),
    [sym_true] = ACTIONS(5455),
    [sym_false] = ACTIONS(5455),
    [sym_null] = ACTIONS(5455),
    [sym_inf] = ACTIONS(5455),
    [sym_nan] = ACTIONS(5455),
    [anon_sym_NA] = ACTIONS(5455),
    [anon_sym_NA_integer_] = ACTIONS(5455),
    [anon_sym_NA_real_] = ACTIONS(5455),
    [anon_sym_NA_complex_] = ACTIONS(5455),
    [anon_sym_NA_character_] = ACTIONS(5455),
    [sym_dots] = ACTIONS(5455),
    [sym_dot_dot_i] = ACTIONS(5453),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5453),
    [sym__newline] = ACTIONS(5453),
    [sym__raw_string_literal] = ACTIONS(5453),
    [sym__external_open_parenthesis] = ACTIONS(6469),
    [sym__external_close_parenthesis] = ACTIONS(5453),
    [sym__external_open_brace] = ACTIONS(5453),
    [sym__external_open_bracket] = ACTIONS(6471),
    [sym__external_close_bracket] = ACTIONS(5453),
    [sym__external_open_bracket2] = ACTIONS(6473),
  },
  [1473] = {
    [sym_call_arguments] = STATE(2763),
    [sym_subset_arguments] = STATE(2764),
    [sym_subset2_arguments] = STATE(2765),
    [sym__open_parenthesis] = STATE(1584),
    [sym__open_bracket] = STATE(1582),
    [sym__open_bracket2] = STATE(1577),
    [sym_identifier] = ACTIONS(5411),
    [anon_sym_BSLASH] = ACTIONS(5409),
    [anon_sym_function] = ACTIONS(5411),
    [anon_sym_EQ] = ACTIONS(6431),
    [anon_sym_if] = ACTIONS(5411),
    [anon_sym_for] = ACTIONS(5411),
    [anon_sym_while] = ACTIONS(5411),
    [anon_sym_repeat] = ACTIONS(5411),
    [anon_sym_QMARK] = ACTIONS(5409),
    [anon_sym_TILDE] = ACTIONS(6433),
    [anon_sym_BANG] = ACTIONS(5411),
    [anon_sym_PLUS] = ACTIONS(6435),
    [anon_sym_DASH] = ACTIONS(6437),
    [anon_sym_LT_DASH] = ACTIONS(6439),
    [anon_sym_LT_LT_DASH] = ACTIONS(6439),
    [anon_sym_COLON_EQ] = ACTIONS(6439),
    [anon_sym_DASH_GT] = ACTIONS(6441),
    [anon_sym_DASH_GT_GT] = ACTIONS(6443),
    [anon_sym_PIPE] = ACTIONS(6445),
    [anon_sym_AMP] = ACTIONS(6447),
    [anon_sym_PIPE_PIPE] = ACTIONS(6449),
    [anon_sym_AMP_AMP] = ACTIONS(6451),
    [anon_sym_LT] = ACTIONS(6453),
    [anon_sym_LT_EQ] = ACTIONS(6455),
    [anon_sym_GT] = ACTIONS(6453),
    [anon_sym_GT_EQ] = ACTIONS(6455),
    [anon_sym_EQ_EQ] = ACTIONS(6455),
    [anon_sym_BANG_EQ] = ACTIONS(6455),
    [anon_sym_STAR] = ACTIONS(6457),
    [anon_sym_SLASH] = ACTIONS(6459),
    [anon_sym_STAR_STAR] = ACTIONS(6461),
    [anon_sym_CARET] = ACTIONS(6461),
    [aux_sym_binary_operator_token1] = ACTIONS(6463),
    [anon_sym_PIPE_GT] = ACTIONS(6463),
    [anon_sym_COLON] = ACTIONS(6465),
    [anon_sym_DOLLAR] = ACTIONS(6467),
    [anon_sym_AT] = ACTIONS(6467),
    [aux_sym__hex_literal_token1] = ACTIONS(5409),
    [sym__number_literal] = ACTIONS(5411),
    [anon_sym_SQUOTE] = ACTIONS(5409),
    [anon_sym_DQUOTE] = ACTIONS(5409),
    [sym_return] = ACTIONS(5411),
    [sym_next] = ACTIONS(5411),
    [sym_break] = ACTIONS(5411),
    [sym_true] = ACTIONS(5411),
    [sym_false] = ACTIONS(5411),
    [sym_null] = ACTIONS(5411),
    [sym_inf] = ACTIONS(5411),
    [sym_nan] = ACTIONS(5411),
    [anon_sym_NA] = ACTIONS(5411),
    [anon_sym_NA_integer_] = ACTIONS(5411),
    [anon_sym_NA_real_] = ACTIONS(5411),
    [anon_sym_NA_complex_] = ACTIONS(5411),
    [anon_sym_NA_character_] = ACTIONS(5411),
    [sym_dots] = ACTIONS(5411),
    [sym_dot_dot_i] = ACTIONS(5409),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5409),
    [sym__newline] = ACTIONS(5409),
    [sym__raw_string_literal] = ACTIONS(5409),
    [sym__external_open_parenthesis] = ACTIONS(6469),
    [sym__external_close_parenthesis] = ACTIONS(5409),
    [sym__external_open_brace] = ACTIONS(5409),
    [sym__external_open_bracket] = ACTIONS(6471),
    [sym__external_close_bracket] = ACTIONS(5409),
    [sym__external_open_bracket2] = ACTIONS(6473),
  },
  [1474] = {
    [sym_call_arguments] = STATE(2870),
    [sym_subset_arguments] = STATE(2869),
    [sym_subset2_arguments] = STATE(2867),
    [sym__open_parenthesis] = STATE(1362),
    [sym__open_bracket] = STATE(1361),
    [sym__open_bracket2] = STATE(1360),
    [sym_identifier] = ACTIONS(5427),
    [anon_sym_BSLASH] = ACTIONS(5425),
    [anon_sym_function] = ACTIONS(5427),
    [anon_sym_EQ] = ACTIONS(6111),
    [anon_sym_if] = ACTIONS(5427),
    [anon_sym_for] = ACTIONS(5427),
    [anon_sym_while] = ACTIONS(5427),
    [anon_sym_repeat] = ACTIONS(5427),
    [anon_sym_QMARK] = ACTIONS(5425),
    [anon_sym_TILDE] = ACTIONS(6113),
    [anon_sym_BANG] = ACTIONS(5427),
    [anon_sym_PLUS] = ACTIONS(6115),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_LT_DASH] = ACTIONS(6119),
    [anon_sym_LT_LT_DASH] = ACTIONS(6119),
    [anon_sym_COLON_EQ] = ACTIONS(6119),
    [anon_sym_DASH_GT] = ACTIONS(6121),
    [anon_sym_DASH_GT_GT] = ACTIONS(6123),
    [anon_sym_PIPE] = ACTIONS(6125),
    [anon_sym_AMP] = ACTIONS(6127),
    [anon_sym_PIPE_PIPE] = ACTIONS(6129),
    [anon_sym_AMP_AMP] = ACTIONS(6131),
    [anon_sym_LT] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6135),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_GT_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(6135),
    [anon_sym_STAR] = ACTIONS(6137),
    [anon_sym_SLASH] = ACTIONS(6139),
    [anon_sym_STAR_STAR] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6141),
    [aux_sym_binary_operator_token1] = ACTIONS(6143),
    [anon_sym_PIPE_GT] = ACTIONS(6143),
    [anon_sym_COLON] = ACTIONS(6145),
    [anon_sym_DOLLAR] = ACTIONS(6147),
    [anon_sym_AT] = ACTIONS(6147),
    [aux_sym__hex_literal_token1] = ACTIONS(5425),
    [sym__number_literal] = ACTIONS(5427),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_DQUOTE] = ACTIONS(5425),
    [sym_return] = ACTIONS(5427),
    [sym_next] = ACTIONS(5427),
    [sym_break] = ACTIONS(5427),
    [sym_true] = ACTIONS(5427),
    [sym_false] = ACTIONS(5427),
    [sym_null] = ACTIONS(5427),
    [sym_inf] = ACTIONS(5427),
    [sym_nan] = ACTIONS(5427),
    [anon_sym_NA] = ACTIONS(5427),
    [anon_sym_NA_integer_] = ACTIONS(5427),
    [anon_sym_NA_real_] = ACTIONS(5427),
    [anon_sym_NA_complex_] = ACTIONS(5427),
    [anon_sym_NA_character_] = ACTIONS(5427),
    [sym_dots] = ACTIONS(5427),
    [sym_dot_dot_i] = ACTIONS(5425),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5425),
    [sym__newline] = ACTIONS(5425),
    [sym__raw_string_literal] = ACTIONS(5425),
    [sym__external_else] = ACTIONS(5425),
    [sym__external_open_parenthesis] = ACTIONS(6151),
    [sym__external_open_brace] = ACTIONS(5425),
    [sym__external_open_bracket] = ACTIONS(6153),
    [sym__external_open_bracket2] = ACTIONS(6155),
    [sym__external_close_bracket2] = ACTIONS(5425),
  },
  [1475] = {
    [sym_call_arguments] = STATE(2840),
    [sym_subset_arguments] = STATE(2797),
    [sym_subset2_arguments] = STATE(2801),
    [sym__open_parenthesis] = STATE(1344),
    [sym__open_bracket] = STATE(1374),
    [sym__open_bracket2] = STATE(1452),
    [ts_builtin_sym_end] = ACTIONS(5449),
    [sym_identifier] = ACTIONS(5451),
    [anon_sym_BSLASH] = ACTIONS(5449),
    [anon_sym_function] = ACTIONS(5451),
    [anon_sym_EQ] = ACTIONS(6263),
    [anon_sym_if] = ACTIONS(5451),
    [anon_sym_for] = ACTIONS(5451),
    [anon_sym_while] = ACTIONS(5451),
    [anon_sym_repeat] = ACTIONS(5451),
    [anon_sym_QMARK] = ACTIONS(5449),
    [anon_sym_TILDE] = ACTIONS(6265),
    [anon_sym_BANG] = ACTIONS(5451),
    [anon_sym_PLUS] = ACTIONS(6267),
    [anon_sym_DASH] = ACTIONS(6269),
    [anon_sym_LT_DASH] = ACTIONS(6271),
    [anon_sym_LT_LT_DASH] = ACTIONS(6271),
    [anon_sym_COLON_EQ] = ACTIONS(6271),
    [anon_sym_DASH_GT] = ACTIONS(6273),
    [anon_sym_DASH_GT_GT] = ACTIONS(6275),
    [anon_sym_PIPE] = ACTIONS(6277),
    [anon_sym_AMP] = ACTIONS(6279),
    [anon_sym_PIPE_PIPE] = ACTIONS(6281),
    [anon_sym_AMP_AMP] = ACTIONS(6283),
    [anon_sym_LT] = ACTIONS(6285),
    [anon_sym_LT_EQ] = ACTIONS(6287),
    [anon_sym_GT] = ACTIONS(6285),
    [anon_sym_GT_EQ] = ACTIONS(6287),
    [anon_sym_EQ_EQ] = ACTIONS(6287),
    [anon_sym_BANG_EQ] = ACTIONS(6287),
    [anon_sym_STAR] = ACTIONS(6289),
    [anon_sym_SLASH] = ACTIONS(6291),
    [anon_sym_STAR_STAR] = ACTIONS(6293),
    [anon_sym_CARET] = ACTIONS(6293),
    [aux_sym_binary_operator_token1] = ACTIONS(6295),
    [anon_sym_PIPE_GT] = ACTIONS(6295),
    [anon_sym_COLON] = ACTIONS(6297),
    [anon_sym_DOLLAR] = ACTIONS(6299),
    [anon_sym_AT] = ACTIONS(6299),
    [aux_sym__hex_literal_token1] = ACTIONS(5449),
    [sym__number_literal] = ACTIONS(5451),
    [anon_sym_SQUOTE] = ACTIONS(5449),
    [anon_sym_DQUOTE] = ACTIONS(5449),
    [sym_return] = ACTIONS(5451),
    [sym_next] = ACTIONS(5451),
    [sym_break] = ACTIONS(5451),
    [sym_true] = ACTIONS(5451),
    [sym_false] = ACTIONS(5451),
    [sym_null] = ACTIONS(5451),
    [sym_inf] = ACTIONS(5451),
    [sym_nan] = ACTIONS(5451),
    [anon_sym_NA] = ACTIONS(5451),
    [anon_sym_NA_integer_] = ACTIONS(5451),
    [anon_sym_NA_real_] = ACTIONS(5451),
    [anon_sym_NA_complex_] = ACTIONS(5451),
    [anon_sym_NA_character_] = ACTIONS(5451),
    [sym_dots] = ACTIONS(5451),
    [sym_dot_dot_i] = ACTIONS(5449),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5449),
    [sym__semicolon] = ACTIONS(5449),
    [sym__raw_string_literal] = ACTIONS(5449),
    [sym__external_open_parenthesis] = ACTIONS(6301),
    [sym__external_open_brace] = ACTIONS(5449),
    [sym__external_close_brace] = ACTIONS(5449),
    [sym__external_open_bracket] = ACTIONS(6303),
    [sym__external_open_bracket2] = ACTIONS(6305),
  },
  [1476] = {
    [sym_call_arguments] = STATE(2870),
    [sym_subset_arguments] = STATE(2869),
    [sym_subset2_arguments] = STATE(2867),
    [sym__open_parenthesis] = STATE(1362),
    [sym__open_bracket] = STATE(1361),
    [sym__open_bracket2] = STATE(1360),
    [sym_identifier] = ACTIONS(5423),
    [anon_sym_BSLASH] = ACTIONS(5421),
    [anon_sym_function] = ACTIONS(5423),
    [anon_sym_EQ] = ACTIONS(6111),
    [anon_sym_if] = ACTIONS(5423),
    [anon_sym_for] = ACTIONS(5423),
    [anon_sym_while] = ACTIONS(5423),
    [anon_sym_repeat] = ACTIONS(5423),
    [anon_sym_QMARK] = ACTIONS(5421),
    [anon_sym_TILDE] = ACTIONS(6113),
    [anon_sym_BANG] = ACTIONS(5423),
    [anon_sym_PLUS] = ACTIONS(6115),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_LT_DASH] = ACTIONS(6119),
    [anon_sym_LT_LT_DASH] = ACTIONS(6119),
    [anon_sym_COLON_EQ] = ACTIONS(6119),
    [anon_sym_DASH_GT] = ACTIONS(6121),
    [anon_sym_DASH_GT_GT] = ACTIONS(6123),
    [anon_sym_PIPE] = ACTIONS(6125),
    [anon_sym_AMP] = ACTIONS(6127),
    [anon_sym_PIPE_PIPE] = ACTIONS(6129),
    [anon_sym_AMP_AMP] = ACTIONS(6131),
    [anon_sym_LT] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6135),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_GT_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(6135),
    [anon_sym_STAR] = ACTIONS(6137),
    [anon_sym_SLASH] = ACTIONS(6139),
    [anon_sym_STAR_STAR] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6141),
    [aux_sym_binary_operator_token1] = ACTIONS(6143),
    [anon_sym_PIPE_GT] = ACTIONS(6143),
    [anon_sym_COLON] = ACTIONS(6145),
    [anon_sym_DOLLAR] = ACTIONS(6147),
    [anon_sym_AT] = ACTIONS(6147),
    [aux_sym__hex_literal_token1] = ACTIONS(5421),
    [sym__number_literal] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5421),
    [anon_sym_DQUOTE] = ACTIONS(5421),
    [sym_return] = ACTIONS(5423),
    [sym_next] = ACTIONS(5423),
    [sym_break] = ACTIONS(5423),
    [sym_true] = ACTIONS(5423),
    [sym_false] = ACTIONS(5423),
    [sym_null] = ACTIONS(5423),
    [sym_inf] = ACTIONS(5423),
    [sym_nan] = ACTIONS(5423),
    [anon_sym_NA] = ACTIONS(5423),
    [anon_sym_NA_integer_] = ACTIONS(5423),
    [anon_sym_NA_real_] = ACTIONS(5423),
    [anon_sym_NA_complex_] = ACTIONS(5423),
    [anon_sym_NA_character_] = ACTIONS(5423),
    [sym_dots] = ACTIONS(5423),
    [sym_dot_dot_i] = ACTIONS(5421),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5421),
    [sym__newline] = ACTIONS(5421),
    [sym__raw_string_literal] = ACTIONS(5421),
    [sym__external_else] = ACTIONS(5421),
    [sym__external_open_parenthesis] = ACTIONS(6151),
    [sym__external_open_brace] = ACTIONS(5421),
    [sym__external_open_bracket] = ACTIONS(6153),
    [sym__external_open_bracket2] = ACTIONS(6155),
    [sym__external_close_bracket2] = ACTIONS(5421),
  },
  [1477] = {
    [sym_call_arguments] = STATE(2870),
    [sym_subset_arguments] = STATE(2869),
    [sym_subset2_arguments] = STATE(2867),
    [sym__open_parenthesis] = STATE(1362),
    [sym__open_bracket] = STATE(1361),
    [sym__open_bracket2] = STATE(1360),
    [sym_identifier] = ACTIONS(5419),
    [anon_sym_BSLASH] = ACTIONS(5417),
    [anon_sym_function] = ACTIONS(5419),
    [anon_sym_EQ] = ACTIONS(6111),
    [anon_sym_if] = ACTIONS(5419),
    [anon_sym_for] = ACTIONS(5419),
    [anon_sym_while] = ACTIONS(5419),
    [anon_sym_repeat] = ACTIONS(5419),
    [anon_sym_QMARK] = ACTIONS(5417),
    [anon_sym_TILDE] = ACTIONS(6113),
    [anon_sym_BANG] = ACTIONS(5419),
    [anon_sym_PLUS] = ACTIONS(6115),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_LT_DASH] = ACTIONS(6119),
    [anon_sym_LT_LT_DASH] = ACTIONS(6119),
    [anon_sym_COLON_EQ] = ACTIONS(6119),
    [anon_sym_DASH_GT] = ACTIONS(6121),
    [anon_sym_DASH_GT_GT] = ACTIONS(6123),
    [anon_sym_PIPE] = ACTIONS(6125),
    [anon_sym_AMP] = ACTIONS(6127),
    [anon_sym_PIPE_PIPE] = ACTIONS(6129),
    [anon_sym_AMP_AMP] = ACTIONS(6131),
    [anon_sym_LT] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6135),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_GT_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(6135),
    [anon_sym_STAR] = ACTIONS(6137),
    [anon_sym_SLASH] = ACTIONS(6139),
    [anon_sym_STAR_STAR] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6141),
    [aux_sym_binary_operator_token1] = ACTIONS(6143),
    [anon_sym_PIPE_GT] = ACTIONS(6143),
    [anon_sym_COLON] = ACTIONS(6145),
    [anon_sym_DOLLAR] = ACTIONS(6147),
    [anon_sym_AT] = ACTIONS(6147),
    [aux_sym__hex_literal_token1] = ACTIONS(5417),
    [sym__number_literal] = ACTIONS(5419),
    [anon_sym_SQUOTE] = ACTIONS(5417),
    [anon_sym_DQUOTE] = ACTIONS(5417),
    [sym_return] = ACTIONS(5419),
    [sym_next] = ACTIONS(5419),
    [sym_break] = ACTIONS(5419),
    [sym_true] = ACTIONS(5419),
    [sym_false] = ACTIONS(5419),
    [sym_null] = ACTIONS(5419),
    [sym_inf] = ACTIONS(5419),
    [sym_nan] = ACTIONS(5419),
    [anon_sym_NA] = ACTIONS(5419),
    [anon_sym_NA_integer_] = ACTIONS(5419),
    [anon_sym_NA_real_] = ACTIONS(5419),
    [anon_sym_NA_complex_] = ACTIONS(5419),
    [anon_sym_NA_character_] = ACTIONS(5419),
    [sym_dots] = ACTIONS(5419),
    [sym_dot_dot_i] = ACTIONS(5417),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5417),
    [sym__newline] = ACTIONS(5417),
    [sym__raw_string_literal] = ACTIONS(5417),
    [sym__external_else] = ACTIONS(5417),
    [sym__external_open_parenthesis] = ACTIONS(6151),
    [sym__external_open_brace] = ACTIONS(5417),
    [sym__external_open_bracket] = ACTIONS(6153),
    [sym__external_open_bracket2] = ACTIONS(6155),
    [sym__external_close_bracket2] = ACTIONS(5417),
  },
  [1478] = {
    [sym_function_definition] = STATE(1931),
    [sym_if_statement] = STATE(1931),
    [sym_for_statement] = STATE(1931),
    [sym_while_statement] = STATE(1931),
    [sym_repeat_statement] = STATE(1931),
    [sym_braced_expression] = STATE(1931),
    [sym_parenthesized_expression] = STATE(1931),
    [sym_call] = STATE(1931),
    [sym_subset] = STATE(1931),
    [sym_subset2] = STATE(1931),
    [sym__argument] = STATE(4656),
    [sym_argument] = STATE(4657),
    [sym__argument_named] = STATE(4658),
    [sym__argument_unnamed] = STATE(4662),
    [sym__argument_value] = STATE(4663),
    [sym_unary_operator] = STATE(1931),
    [sym_binary_operator] = STATE(1931),
    [sym_extract_operator] = STATE(1931),
    [sym_namespace_operator] = STATE(1931),
    [sym_integer] = STATE(1931),
    [sym_complex] = STATE(1931),
    [sym_float] = STATE(1931),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2633),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(1931),
    [sym__expression] = STATE(1931),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__close_parenthesis] = STATE(4729),
    [sym__open_brace] = STATE(154),
    [aux_sym_call_arguments_repeat1] = STATE(1492),
    [sym_identifier] = ACTIONS(6387),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(6389),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3865),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(6391),
    [sym_next] = ACTIONS(6391),
    [sym_break] = ACTIONS(6391),
    [sym_true] = ACTIONS(6391),
    [sym_false] = ACTIONS(6391),
    [sym_null] = ACTIONS(6391),
    [sym_inf] = ACTIONS(6391),
    [sym_nan] = ACTIONS(6391),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(6393),
    [sym_dot_dot_i] = ACTIONS(6395),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6397),
    [sym__newline] = ACTIONS(6399),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(6653),
    [sym__external_open_brace] = ACTIONS(3891),
  },
  [1479] = {
    [sym_call_arguments] = STATE(2870),
    [sym_subset_arguments] = STATE(2869),
    [sym_subset2_arguments] = STATE(2867),
    [sym__open_parenthesis] = STATE(1362),
    [sym__open_bracket] = STATE(1361),
    [sym__open_bracket2] = STATE(1360),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_BSLASH] = ACTIONS(5413),
    [anon_sym_function] = ACTIONS(5415),
    [anon_sym_EQ] = ACTIONS(6111),
    [anon_sym_if] = ACTIONS(5415),
    [anon_sym_for] = ACTIONS(5415),
    [anon_sym_while] = ACTIONS(5415),
    [anon_sym_repeat] = ACTIONS(5415),
    [anon_sym_QMARK] = ACTIONS(5413),
    [anon_sym_TILDE] = ACTIONS(6113),
    [anon_sym_BANG] = ACTIONS(5415),
    [anon_sym_PLUS] = ACTIONS(6115),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_LT_DASH] = ACTIONS(6119),
    [anon_sym_LT_LT_DASH] = ACTIONS(6119),
    [anon_sym_COLON_EQ] = ACTIONS(6119),
    [anon_sym_DASH_GT] = ACTIONS(6121),
    [anon_sym_DASH_GT_GT] = ACTIONS(6123),
    [anon_sym_PIPE] = ACTIONS(6125),
    [anon_sym_AMP] = ACTIONS(6127),
    [anon_sym_PIPE_PIPE] = ACTIONS(6129),
    [anon_sym_AMP_AMP] = ACTIONS(6131),
    [anon_sym_LT] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6135),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_GT_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(6135),
    [anon_sym_STAR] = ACTIONS(6137),
    [anon_sym_SLASH] = ACTIONS(6139),
    [anon_sym_STAR_STAR] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6141),
    [aux_sym_binary_operator_token1] = ACTIONS(6143),
    [anon_sym_PIPE_GT] = ACTIONS(6143),
    [anon_sym_COLON] = ACTIONS(6145),
    [anon_sym_DOLLAR] = ACTIONS(6147),
    [anon_sym_AT] = ACTIONS(6147),
    [aux_sym__hex_literal_token1] = ACTIONS(5413),
    [sym__number_literal] = ACTIONS(5415),
    [anon_sym_SQUOTE] = ACTIONS(5413),
    [anon_sym_DQUOTE] = ACTIONS(5413),
    [sym_return] = ACTIONS(5415),
    [sym_next] = ACTIONS(5415),
    [sym_break] = ACTIONS(5415),
    [sym_true] = ACTIONS(5415),
    [sym_false] = ACTIONS(5415),
    [sym_null] = ACTIONS(5415),
    [sym_inf] = ACTIONS(5415),
    [sym_nan] = ACTIONS(5415),
    [anon_sym_NA] = ACTIONS(5415),
    [anon_sym_NA_integer_] = ACTIONS(5415),
    [anon_sym_NA_real_] = ACTIONS(5415),
    [anon_sym_NA_complex_] = ACTIONS(5415),
    [anon_sym_NA_character_] = ACTIONS(5415),
    [sym_dots] = ACTIONS(5415),
    [sym_dot_dot_i] = ACTIONS(5413),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5413),
    [sym__newline] = ACTIONS(5413),
    [sym__raw_string_literal] = ACTIONS(5413),
    [sym__external_else] = ACTIONS(5413),
    [sym__external_open_parenthesis] = ACTIONS(6151),
    [sym__external_open_brace] = ACTIONS(5413),
    [sym__external_open_bracket] = ACTIONS(6153),
    [sym__external_open_bracket2] = ACTIONS(6155),
    [sym__external_close_bracket2] = ACTIONS(5413),
  },
  [1480] = {
    [sym_call_arguments] = STATE(2870),
    [sym_subset_arguments] = STATE(2869),
    [sym_subset2_arguments] = STATE(2867),
    [sym__open_parenthesis] = STATE(1362),
    [sym__open_bracket] = STATE(1361),
    [sym__open_bracket2] = STATE(1360),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6141),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(5261),
    [anon_sym_DOLLAR] = ACTIONS(6147),
    [anon_sym_AT] = ACTIONS(6147),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6151),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6153),
    [sym__external_open_bracket2] = ACTIONS(6155),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [1481] = {
    [sym_call_arguments] = STATE(2870),
    [sym_subset_arguments] = STATE(2869),
    [sym_subset2_arguments] = STATE(2867),
    [sym__open_parenthesis] = STATE(1362),
    [sym__open_bracket] = STATE(1361),
    [sym__open_bracket2] = STATE(1360),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6141),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(6145),
    [anon_sym_DOLLAR] = ACTIONS(6147),
    [anon_sym_AT] = ACTIONS(6147),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6151),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6153),
    [sym__external_open_bracket2] = ACTIONS(6155),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [1482] = {
    [sym_call_arguments] = STATE(2870),
    [sym_subset_arguments] = STATE(2869),
    [sym_subset2_arguments] = STATE(2867),
    [sym__open_parenthesis] = STATE(1362),
    [sym__open_bracket] = STATE(1361),
    [sym__open_bracket2] = STATE(1360),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6141),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(5261),
    [anon_sym_DOLLAR] = ACTIONS(6147),
    [anon_sym_AT] = ACTIONS(6147),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6151),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6153),
    [sym__external_open_bracket2] = ACTIONS(6155),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [1483] = {
    [sym_call_arguments] = STATE(2870),
    [sym_subset_arguments] = STATE(2869),
    [sym_subset2_arguments] = STATE(2867),
    [sym__open_parenthesis] = STATE(1362),
    [sym__open_bracket] = STATE(1361),
    [sym__open_bracket2] = STATE(1360),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6141),
    [aux_sym_binary_operator_token1] = ACTIONS(6143),
    [anon_sym_PIPE_GT] = ACTIONS(6143),
    [anon_sym_COLON] = ACTIONS(6145),
    [anon_sym_DOLLAR] = ACTIONS(6147),
    [anon_sym_AT] = ACTIONS(6147),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6151),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6153),
    [sym__external_open_bracket2] = ACTIONS(6155),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [1484] = {
    [sym_call_arguments] = STATE(2870),
    [sym_subset_arguments] = STATE(2869),
    [sym_subset2_arguments] = STATE(2867),
    [sym__open_parenthesis] = STATE(1362),
    [sym__open_bracket] = STATE(1361),
    [sym__open_bracket2] = STATE(1360),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(6115),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(6137),
    [anon_sym_SLASH] = ACTIONS(6139),
    [anon_sym_STAR_STAR] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6141),
    [aux_sym_binary_operator_token1] = ACTIONS(6143),
    [anon_sym_PIPE_GT] = ACTIONS(6143),
    [anon_sym_COLON] = ACTIONS(6145),
    [anon_sym_DOLLAR] = ACTIONS(6147),
    [anon_sym_AT] = ACTIONS(6147),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6151),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6153),
    [sym__external_open_bracket2] = ACTIONS(6155),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [1485] = {
    [sym_call_arguments] = STATE(2840),
    [sym_subset_arguments] = STATE(2797),
    [sym_subset2_arguments] = STATE(2801),
    [sym__open_parenthesis] = STATE(1344),
    [sym__open_bracket] = STATE(1374),
    [sym__open_bracket2] = STATE(1452),
    [ts_builtin_sym_end] = ACTIONS(5445),
    [sym_identifier] = ACTIONS(5447),
    [anon_sym_BSLASH] = ACTIONS(5445),
    [anon_sym_function] = ACTIONS(5447),
    [anon_sym_EQ] = ACTIONS(6263),
    [anon_sym_if] = ACTIONS(5447),
    [anon_sym_for] = ACTIONS(5447),
    [anon_sym_while] = ACTIONS(5447),
    [anon_sym_repeat] = ACTIONS(5447),
    [anon_sym_QMARK] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(6265),
    [anon_sym_BANG] = ACTIONS(5447),
    [anon_sym_PLUS] = ACTIONS(6267),
    [anon_sym_DASH] = ACTIONS(6269),
    [anon_sym_LT_DASH] = ACTIONS(6271),
    [anon_sym_LT_LT_DASH] = ACTIONS(6271),
    [anon_sym_COLON_EQ] = ACTIONS(6271),
    [anon_sym_DASH_GT] = ACTIONS(6273),
    [anon_sym_DASH_GT_GT] = ACTIONS(6275),
    [anon_sym_PIPE] = ACTIONS(6277),
    [anon_sym_AMP] = ACTIONS(6279),
    [anon_sym_PIPE_PIPE] = ACTIONS(6281),
    [anon_sym_AMP_AMP] = ACTIONS(6283),
    [anon_sym_LT] = ACTIONS(6285),
    [anon_sym_LT_EQ] = ACTIONS(6287),
    [anon_sym_GT] = ACTIONS(6285),
    [anon_sym_GT_EQ] = ACTIONS(6287),
    [anon_sym_EQ_EQ] = ACTIONS(6287),
    [anon_sym_BANG_EQ] = ACTIONS(6287),
    [anon_sym_STAR] = ACTIONS(6289),
    [anon_sym_SLASH] = ACTIONS(6291),
    [anon_sym_STAR_STAR] = ACTIONS(6293),
    [anon_sym_CARET] = ACTIONS(6293),
    [aux_sym_binary_operator_token1] = ACTIONS(6295),
    [anon_sym_PIPE_GT] = ACTIONS(6295),
    [anon_sym_COLON] = ACTIONS(6297),
    [anon_sym_DOLLAR] = ACTIONS(6299),
    [anon_sym_AT] = ACTIONS(6299),
    [aux_sym__hex_literal_token1] = ACTIONS(5445),
    [sym__number_literal] = ACTIONS(5447),
    [anon_sym_SQUOTE] = ACTIONS(5445),
    [anon_sym_DQUOTE] = ACTIONS(5445),
    [sym_return] = ACTIONS(5447),
    [sym_next] = ACTIONS(5447),
    [sym_break] = ACTIONS(5447),
    [sym_true] = ACTIONS(5447),
    [sym_false] = ACTIONS(5447),
    [sym_null] = ACTIONS(5447),
    [sym_inf] = ACTIONS(5447),
    [sym_nan] = ACTIONS(5447),
    [anon_sym_NA] = ACTIONS(5447),
    [anon_sym_NA_integer_] = ACTIONS(5447),
    [anon_sym_NA_real_] = ACTIONS(5447),
    [anon_sym_NA_complex_] = ACTIONS(5447),
    [anon_sym_NA_character_] = ACTIONS(5447),
    [sym_dots] = ACTIONS(5447),
    [sym_dot_dot_i] = ACTIONS(5445),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5445),
    [sym__semicolon] = ACTIONS(5445),
    [sym__raw_string_literal] = ACTIONS(5445),
    [sym__external_open_parenthesis] = ACTIONS(6301),
    [sym__external_open_brace] = ACTIONS(5445),
    [sym__external_close_brace] = ACTIONS(5445),
    [sym__external_open_bracket] = ACTIONS(6303),
    [sym__external_open_bracket2] = ACTIONS(6305),
  },
  [1486] = {
    [sym_call_arguments] = STATE(2870),
    [sym_subset_arguments] = STATE(2869),
    [sym_subset2_arguments] = STATE(2867),
    [sym__open_parenthesis] = STATE(1362),
    [sym__open_bracket] = STATE(1361),
    [sym__open_bracket2] = STATE(1360),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(6115),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6135),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_GT_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(6135),
    [anon_sym_STAR] = ACTIONS(6137),
    [anon_sym_SLASH] = ACTIONS(6139),
    [anon_sym_STAR_STAR] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6141),
    [aux_sym_binary_operator_token1] = ACTIONS(6143),
    [anon_sym_PIPE_GT] = ACTIONS(6143),
    [anon_sym_COLON] = ACTIONS(6145),
    [anon_sym_DOLLAR] = ACTIONS(6147),
    [anon_sym_AT] = ACTIONS(6147),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6151),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6153),
    [sym__external_open_bracket2] = ACTIONS(6155),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [1487] = {
    [sym_call_arguments] = STATE(2840),
    [sym_subset_arguments] = STATE(2797),
    [sym_subset2_arguments] = STATE(2801),
    [sym__open_parenthesis] = STATE(1344),
    [sym__open_bracket] = STATE(1374),
    [sym__open_bracket2] = STATE(1452),
    [ts_builtin_sym_end] = ACTIONS(5441),
    [sym_identifier] = ACTIONS(5443),
    [anon_sym_BSLASH] = ACTIONS(5441),
    [anon_sym_function] = ACTIONS(5443),
    [anon_sym_EQ] = ACTIONS(6263),
    [anon_sym_if] = ACTIONS(5443),
    [anon_sym_for] = ACTIONS(5443),
    [anon_sym_while] = ACTIONS(5443),
    [anon_sym_repeat] = ACTIONS(5443),
    [anon_sym_QMARK] = ACTIONS(5441),
    [anon_sym_TILDE] = ACTIONS(6265),
    [anon_sym_BANG] = ACTIONS(5443),
    [anon_sym_PLUS] = ACTIONS(6267),
    [anon_sym_DASH] = ACTIONS(6269),
    [anon_sym_LT_DASH] = ACTIONS(6271),
    [anon_sym_LT_LT_DASH] = ACTIONS(6271),
    [anon_sym_COLON_EQ] = ACTIONS(6271),
    [anon_sym_DASH_GT] = ACTIONS(6273),
    [anon_sym_DASH_GT_GT] = ACTIONS(6275),
    [anon_sym_PIPE] = ACTIONS(6277),
    [anon_sym_AMP] = ACTIONS(6279),
    [anon_sym_PIPE_PIPE] = ACTIONS(6281),
    [anon_sym_AMP_AMP] = ACTIONS(6283),
    [anon_sym_LT] = ACTIONS(6285),
    [anon_sym_LT_EQ] = ACTIONS(6287),
    [anon_sym_GT] = ACTIONS(6285),
    [anon_sym_GT_EQ] = ACTIONS(6287),
    [anon_sym_EQ_EQ] = ACTIONS(6287),
    [anon_sym_BANG_EQ] = ACTIONS(6287),
    [anon_sym_STAR] = ACTIONS(6289),
    [anon_sym_SLASH] = ACTIONS(6291),
    [anon_sym_STAR_STAR] = ACTIONS(6293),
    [anon_sym_CARET] = ACTIONS(6293),
    [aux_sym_binary_operator_token1] = ACTIONS(6295),
    [anon_sym_PIPE_GT] = ACTIONS(6295),
    [anon_sym_COLON] = ACTIONS(6297),
    [anon_sym_DOLLAR] = ACTIONS(6299),
    [anon_sym_AT] = ACTIONS(6299),
    [aux_sym__hex_literal_token1] = ACTIONS(5441),
    [sym__number_literal] = ACTIONS(5443),
    [anon_sym_SQUOTE] = ACTIONS(5441),
    [anon_sym_DQUOTE] = ACTIONS(5441),
    [sym_return] = ACTIONS(5443),
    [sym_next] = ACTIONS(5443),
    [sym_break] = ACTIONS(5443),
    [sym_true] = ACTIONS(5443),
    [sym_false] = ACTIONS(5443),
    [sym_null] = ACTIONS(5443),
    [sym_inf] = ACTIONS(5443),
    [sym_nan] = ACTIONS(5443),
    [anon_sym_NA] = ACTIONS(5443),
    [anon_sym_NA_integer_] = ACTIONS(5443),
    [anon_sym_NA_real_] = ACTIONS(5443),
    [anon_sym_NA_complex_] = ACTIONS(5443),
    [anon_sym_NA_character_] = ACTIONS(5443),
    [sym_dots] = ACTIONS(5443),
    [sym_dot_dot_i] = ACTIONS(5441),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5441),
    [sym__semicolon] = ACTIONS(5441),
    [sym__raw_string_literal] = ACTIONS(5441),
    [sym__external_open_parenthesis] = ACTIONS(6301),
    [sym__external_open_brace] = ACTIONS(5441),
    [sym__external_close_brace] = ACTIONS(5441),
    [sym__external_open_bracket] = ACTIONS(6303),
    [sym__external_open_bracket2] = ACTIONS(6305),
  },
  [1488] = {
    [sym_function_definition] = STATE(1931),
    [sym_if_statement] = STATE(1931),
    [sym_for_statement] = STATE(1931),
    [sym_while_statement] = STATE(1931),
    [sym_repeat_statement] = STATE(1931),
    [sym_braced_expression] = STATE(1931),
    [sym_parenthesized_expression] = STATE(1931),
    [sym_call] = STATE(1931),
    [sym_subset] = STATE(1931),
    [sym_subset2] = STATE(1931),
    [sym__argument] = STATE(4656),
    [sym_argument] = STATE(4657),
    [sym__argument_named] = STATE(4658),
    [sym__argument_unnamed] = STATE(4662),
    [sym__argument_value] = STATE(4663),
    [sym_unary_operator] = STATE(1931),
    [sym_binary_operator] = STATE(1931),
    [sym_extract_operator] = STATE(1931),
    [sym_namespace_operator] = STATE(1931),
    [sym_integer] = STATE(1931),
    [sym_complex] = STATE(1931),
    [sym_float] = STATE(1931),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2633),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(1931),
    [sym__expression] = STATE(1931),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__close_parenthesis] = STATE(2609),
    [sym__open_brace] = STATE(154),
    [aux_sym_call_arguments_repeat1] = STATE(2113),
    [sym_identifier] = ACTIONS(6387),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(6389),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3865),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(6391),
    [sym_next] = ACTIONS(6391),
    [sym_break] = ACTIONS(6391),
    [sym_true] = ACTIONS(6391),
    [sym_false] = ACTIONS(6391),
    [sym_null] = ACTIONS(6391),
    [sym_inf] = ACTIONS(6391),
    [sym_nan] = ACTIONS(6391),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(6393),
    [sym_dot_dot_i] = ACTIONS(6395),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6397),
    [sym__newline] = ACTIONS(6399),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(6655),
    [sym__external_open_brace] = ACTIONS(3891),
  },
  [1489] = {
    [sym_call_arguments] = STATE(2840),
    [sym_subset_arguments] = STATE(2797),
    [sym_subset2_arguments] = STATE(2801),
    [sym__open_parenthesis] = STATE(1344),
    [sym__open_bracket] = STATE(1374),
    [sym__open_bracket2] = STATE(1452),
    [ts_builtin_sym_end] = ACTIONS(5437),
    [sym_identifier] = ACTIONS(5439),
    [anon_sym_BSLASH] = ACTIONS(5437),
    [anon_sym_function] = ACTIONS(5439),
    [anon_sym_EQ] = ACTIONS(6263),
    [anon_sym_if] = ACTIONS(5439),
    [anon_sym_for] = ACTIONS(5439),
    [anon_sym_while] = ACTIONS(5439),
    [anon_sym_repeat] = ACTIONS(5439),
    [anon_sym_QMARK] = ACTIONS(5437),
    [anon_sym_TILDE] = ACTIONS(6265),
    [anon_sym_BANG] = ACTIONS(5439),
    [anon_sym_PLUS] = ACTIONS(6267),
    [anon_sym_DASH] = ACTIONS(6269),
    [anon_sym_LT_DASH] = ACTIONS(6271),
    [anon_sym_LT_LT_DASH] = ACTIONS(6271),
    [anon_sym_COLON_EQ] = ACTIONS(6271),
    [anon_sym_DASH_GT] = ACTIONS(6273),
    [anon_sym_DASH_GT_GT] = ACTIONS(6275),
    [anon_sym_PIPE] = ACTIONS(6277),
    [anon_sym_AMP] = ACTIONS(6279),
    [anon_sym_PIPE_PIPE] = ACTIONS(6281),
    [anon_sym_AMP_AMP] = ACTIONS(6283),
    [anon_sym_LT] = ACTIONS(6285),
    [anon_sym_LT_EQ] = ACTIONS(6287),
    [anon_sym_GT] = ACTIONS(6285),
    [anon_sym_GT_EQ] = ACTIONS(6287),
    [anon_sym_EQ_EQ] = ACTIONS(6287),
    [anon_sym_BANG_EQ] = ACTIONS(6287),
    [anon_sym_STAR] = ACTIONS(6289),
    [anon_sym_SLASH] = ACTIONS(6291),
    [anon_sym_STAR_STAR] = ACTIONS(6293),
    [anon_sym_CARET] = ACTIONS(6293),
    [aux_sym_binary_operator_token1] = ACTIONS(6295),
    [anon_sym_PIPE_GT] = ACTIONS(6295),
    [anon_sym_COLON] = ACTIONS(6297),
    [anon_sym_DOLLAR] = ACTIONS(6299),
    [anon_sym_AT] = ACTIONS(6299),
    [aux_sym__hex_literal_token1] = ACTIONS(5437),
    [sym__number_literal] = ACTIONS(5439),
    [anon_sym_SQUOTE] = ACTIONS(5437),
    [anon_sym_DQUOTE] = ACTIONS(5437),
    [sym_return] = ACTIONS(5439),
    [sym_next] = ACTIONS(5439),
    [sym_break] = ACTIONS(5439),
    [sym_true] = ACTIONS(5439),
    [sym_false] = ACTIONS(5439),
    [sym_null] = ACTIONS(5439),
    [sym_inf] = ACTIONS(5439),
    [sym_nan] = ACTIONS(5439),
    [anon_sym_NA] = ACTIONS(5439),
    [anon_sym_NA_integer_] = ACTIONS(5439),
    [anon_sym_NA_real_] = ACTIONS(5439),
    [anon_sym_NA_complex_] = ACTIONS(5439),
    [anon_sym_NA_character_] = ACTIONS(5439),
    [sym_dots] = ACTIONS(5439),
    [sym_dot_dot_i] = ACTIONS(5437),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5437),
    [sym__semicolon] = ACTIONS(5437),
    [sym__raw_string_literal] = ACTIONS(5437),
    [sym__external_open_parenthesis] = ACTIONS(6301),
    [sym__external_open_brace] = ACTIONS(5437),
    [sym__external_close_brace] = ACTIONS(5437),
    [sym__external_open_bracket] = ACTIONS(6303),
    [sym__external_open_bracket2] = ACTIONS(6305),
  },
  [1490] = {
    [sym_function_definition] = STATE(1940),
    [sym_if_statement] = STATE(1940),
    [sym_for_statement] = STATE(1940),
    [sym_while_statement] = STATE(1940),
    [sym_repeat_statement] = STATE(1940),
    [sym_braced_expression] = STATE(1940),
    [sym_parenthesized_expression] = STATE(1940),
    [sym_call] = STATE(1940),
    [sym_subset] = STATE(1940),
    [sym_subset2] = STATE(1940),
    [sym__argument] = STATE(4665),
    [sym_argument] = STATE(4661),
    [sym__argument_named] = STATE(4669),
    [sym__argument_unnamed] = STATE(4673),
    [sym__argument_value] = STATE(4679),
    [sym_unary_operator] = STATE(1940),
    [sym_binary_operator] = STATE(1940),
    [sym_extract_operator] = STATE(1940),
    [sym_namespace_operator] = STATE(1940),
    [sym_integer] = STATE(1940),
    [sym_complex] = STATE(1940),
    [sym_float] = STATE(1940),
    [sym__hex_literal] = STATE(2656),
    [sym__float_literal] = STATE(2656),
    [sym_string] = STATE(2606),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym_na] = STATE(1940),
    [sym__expression] = STATE(1940),
    [sym__string_or_identifier] = STATE(5141),
    [sym__open_parenthesis] = STATE(218),
    [sym__open_brace] = STATE(185),
    [sym__close_bracket2] = STATE(2513),
    [aux_sym_call_arguments_repeat1] = STATE(1417),
    [sym_identifier] = ACTIONS(6369),
    [anon_sym_BSLASH] = ACTIONS(4644),
    [anon_sym_function] = ACTIONS(4646),
    [anon_sym_if] = ACTIONS(4648),
    [anon_sym_for] = ACTIONS(4650),
    [anon_sym_while] = ACTIONS(4652),
    [anon_sym_repeat] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(6371),
    [anon_sym_PLUS] = ACTIONS(4662),
    [anon_sym_DASH] = ACTIONS(4662),
    [aux_sym__hex_literal_token1] = ACTIONS(4666),
    [sym__number_literal] = ACTIONS(4668),
    [anon_sym_SQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4672),
    [sym_return] = ACTIONS(6373),
    [sym_next] = ACTIONS(6373),
    [sym_break] = ACTIONS(6373),
    [sym_true] = ACTIONS(6373),
    [sym_false] = ACTIONS(6373),
    [sym_null] = ACTIONS(6373),
    [sym_inf] = ACTIONS(6373),
    [sym_nan] = ACTIONS(6373),
    [anon_sym_NA] = ACTIONS(4676),
    [anon_sym_NA_integer_] = ACTIONS(4676),
    [anon_sym_NA_real_] = ACTIONS(4676),
    [anon_sym_NA_complex_] = ACTIONS(4676),
    [anon_sym_NA_character_] = ACTIONS(4676),
    [sym_dots] = ACTIONS(6375),
    [sym_dot_dot_i] = ACTIONS(6377),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6379),
    [sym__newline] = ACTIONS(6381),
    [sym__raw_string_literal] = ACTIONS(4680),
    [sym__external_open_parenthesis] = ACTIONS(4682),
    [sym__external_open_brace] = ACTIONS(4684),
    [sym__external_close_bracket2] = ACTIONS(6657),
  },
  [1491] = {
    [sym_call_arguments] = STATE(2870),
    [sym_subset_arguments] = STATE(2869),
    [sym_subset2_arguments] = STATE(2867),
    [sym__open_parenthesis] = STATE(1362),
    [sym__open_bracket] = STATE(1361),
    [sym__open_bracket2] = STATE(1360),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(6115),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(6127),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(6131),
    [anon_sym_LT] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6135),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_GT_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(6135),
    [anon_sym_STAR] = ACTIONS(6137),
    [anon_sym_SLASH] = ACTIONS(6139),
    [anon_sym_STAR_STAR] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6141),
    [aux_sym_binary_operator_token1] = ACTIONS(6143),
    [anon_sym_PIPE_GT] = ACTIONS(6143),
    [anon_sym_COLON] = ACTIONS(6145),
    [anon_sym_DOLLAR] = ACTIONS(6147),
    [anon_sym_AT] = ACTIONS(6147),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6151),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6153),
    [sym__external_open_bracket2] = ACTIONS(6155),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [1492] = {
    [sym_function_definition] = STATE(1931),
    [sym_if_statement] = STATE(1931),
    [sym_for_statement] = STATE(1931),
    [sym_while_statement] = STATE(1931),
    [sym_repeat_statement] = STATE(1931),
    [sym_braced_expression] = STATE(1931),
    [sym_parenthesized_expression] = STATE(1931),
    [sym_call] = STATE(1931),
    [sym_subset] = STATE(1931),
    [sym_subset2] = STATE(1931),
    [sym__argument] = STATE(4656),
    [sym_argument] = STATE(4657),
    [sym__argument_named] = STATE(4658),
    [sym__argument_unnamed] = STATE(4662),
    [sym__argument_value] = STATE(4663),
    [sym_unary_operator] = STATE(1931),
    [sym_binary_operator] = STATE(1931),
    [sym_extract_operator] = STATE(1931),
    [sym_namespace_operator] = STATE(1931),
    [sym_integer] = STATE(1931),
    [sym_complex] = STATE(1931),
    [sym_float] = STATE(1931),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2633),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(1931),
    [sym__expression] = STATE(1931),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__close_parenthesis] = STATE(4725),
    [sym__open_brace] = STATE(154),
    [aux_sym_call_arguments_repeat1] = STATE(2113),
    [sym_identifier] = ACTIONS(6387),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(6389),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3865),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(6391),
    [sym_next] = ACTIONS(6391),
    [sym_break] = ACTIONS(6391),
    [sym_true] = ACTIONS(6391),
    [sym_false] = ACTIONS(6391),
    [sym_null] = ACTIONS(6391),
    [sym_inf] = ACTIONS(6391),
    [sym_nan] = ACTIONS(6391),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(6393),
    [sym_dot_dot_i] = ACTIONS(6395),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6397),
    [sym__newline] = ACTIONS(6399),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(6659),
    [sym__external_open_brace] = ACTIONS(3891),
  },
  [1493] = {
    [sym_call_arguments] = STATE(2870),
    [sym_subset_arguments] = STATE(2869),
    [sym_subset2_arguments] = STATE(2867),
    [sym__open_parenthesis] = STATE(1362),
    [sym__open_bracket] = STATE(1361),
    [sym__open_bracket2] = STATE(1360),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(6113),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(6115),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(6125),
    [anon_sym_AMP] = ACTIONS(6127),
    [anon_sym_PIPE_PIPE] = ACTIONS(6129),
    [anon_sym_AMP_AMP] = ACTIONS(6131),
    [anon_sym_LT] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6135),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_GT_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(6135),
    [anon_sym_STAR] = ACTIONS(6137),
    [anon_sym_SLASH] = ACTIONS(6139),
    [anon_sym_STAR_STAR] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6141),
    [aux_sym_binary_operator_token1] = ACTIONS(6143),
    [anon_sym_PIPE_GT] = ACTIONS(6143),
    [anon_sym_COLON] = ACTIONS(6145),
    [anon_sym_DOLLAR] = ACTIONS(6147),
    [anon_sym_AT] = ACTIONS(6147),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6151),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6153),
    [sym__external_open_bracket2] = ACTIONS(6155),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [1494] = {
    [sym_function_definition] = STATE(2038),
    [sym_if_statement] = STATE(2038),
    [sym_for_statement] = STATE(2038),
    [sym_while_statement] = STATE(2038),
    [sym_repeat_statement] = STATE(2038),
    [sym_braced_expression] = STATE(2038),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_call] = STATE(2038),
    [sym_subset] = STATE(2038),
    [sym_subset2] = STATE(2038),
    [sym__argument] = STATE(4664),
    [sym_argument] = STATE(4659),
    [sym__argument_named] = STATE(4654),
    [sym__argument_unnamed] = STATE(4676),
    [sym__argument_value] = STATE(4677),
    [sym_unary_operator] = STATE(2038),
    [sym_binary_operator] = STATE(2038),
    [sym_extract_operator] = STATE(2038),
    [sym_namespace_operator] = STATE(2038),
    [sym_integer] = STATE(2038),
    [sym_complex] = STATE(2038),
    [sym_float] = STATE(2038),
    [sym__hex_literal] = STATE(2700),
    [sym__float_literal] = STATE(2700),
    [sym_string] = STATE(2597),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym_na] = STATE(2038),
    [sym__expression] = STATE(2038),
    [sym__string_or_identifier] = STATE(5148),
    [sym__open_parenthesis] = STATE(214),
    [sym__open_brace] = STATE(192),
    [sym__close_bracket] = STATE(2512),
    [aux_sym_call_arguments_repeat1] = STATE(1421),
    [sym_identifier] = ACTIONS(6351),
    [anon_sym_BSLASH] = ACTIONS(4754),
    [anon_sym_function] = ACTIONS(4756),
    [anon_sym_if] = ACTIONS(4758),
    [anon_sym_for] = ACTIONS(4760),
    [anon_sym_while] = ACTIONS(4762),
    [anon_sym_repeat] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4766),
    [anon_sym_TILDE] = ACTIONS(4768),
    [anon_sym_BANG] = ACTIONS(6353),
    [anon_sym_PLUS] = ACTIONS(4772),
    [anon_sym_DASH] = ACTIONS(4772),
    [aux_sym__hex_literal_token1] = ACTIONS(4776),
    [sym__number_literal] = ACTIONS(4778),
    [anon_sym_SQUOTE] = ACTIONS(4780),
    [anon_sym_DQUOTE] = ACTIONS(4782),
    [sym_return] = ACTIONS(6355),
    [sym_next] = ACTIONS(6355),
    [sym_break] = ACTIONS(6355),
    [sym_true] = ACTIONS(6355),
    [sym_false] = ACTIONS(6355),
    [sym_null] = ACTIONS(6355),
    [sym_inf] = ACTIONS(6355),
    [sym_nan] = ACTIONS(6355),
    [anon_sym_NA] = ACTIONS(4786),
    [anon_sym_NA_integer_] = ACTIONS(4786),
    [anon_sym_NA_real_] = ACTIONS(4786),
    [anon_sym_NA_complex_] = ACTIONS(4786),
    [anon_sym_NA_character_] = ACTIONS(4786),
    [sym_dots] = ACTIONS(6357),
    [sym_dot_dot_i] = ACTIONS(6359),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6361),
    [sym__newline] = ACTIONS(6363),
    [sym__raw_string_literal] = ACTIONS(4790),
    [sym__external_open_parenthesis] = ACTIONS(4792),
    [sym__external_open_brace] = ACTIONS(4794),
    [sym__external_close_bracket] = ACTIONS(6661),
  },
  [1495] = {
    [sym_call_arguments] = STATE(2870),
    [sym_subset_arguments] = STATE(2869),
    [sym_subset2_arguments] = STATE(2867),
    [sym__open_parenthesis] = STATE(1362),
    [sym__open_bracket] = STATE(1361),
    [sym__open_bracket2] = STATE(1360),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(6111),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(6113),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(6115),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_LT_DASH] = ACTIONS(6119),
    [anon_sym_LT_LT_DASH] = ACTIONS(6119),
    [anon_sym_COLON_EQ] = ACTIONS(6119),
    [anon_sym_DASH_GT] = ACTIONS(6121),
    [anon_sym_DASH_GT_GT] = ACTIONS(6123),
    [anon_sym_PIPE] = ACTIONS(6125),
    [anon_sym_AMP] = ACTIONS(6127),
    [anon_sym_PIPE_PIPE] = ACTIONS(6129),
    [anon_sym_AMP_AMP] = ACTIONS(6131),
    [anon_sym_LT] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6135),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_GT_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(6135),
    [anon_sym_STAR] = ACTIONS(6137),
    [anon_sym_SLASH] = ACTIONS(6139),
    [anon_sym_STAR_STAR] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6141),
    [aux_sym_binary_operator_token1] = ACTIONS(6143),
    [anon_sym_PIPE_GT] = ACTIONS(6143),
    [anon_sym_COLON] = ACTIONS(6145),
    [anon_sym_DOLLAR] = ACTIONS(6147),
    [anon_sym_AT] = ACTIONS(6147),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6151),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6153),
    [sym__external_open_bracket2] = ACTIONS(6155),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [1496] = {
    [sym_function_definition] = STATE(1931),
    [sym_if_statement] = STATE(1931),
    [sym_for_statement] = STATE(1931),
    [sym_while_statement] = STATE(1931),
    [sym_repeat_statement] = STATE(1931),
    [sym_braced_expression] = STATE(1931),
    [sym_parenthesized_expression] = STATE(1931),
    [sym_call] = STATE(1931),
    [sym_subset] = STATE(1931),
    [sym_subset2] = STATE(1931),
    [sym__argument] = STATE(4656),
    [sym_argument] = STATE(4657),
    [sym__argument_named] = STATE(4658),
    [sym__argument_unnamed] = STATE(4662),
    [sym__argument_value] = STATE(4663),
    [sym_unary_operator] = STATE(1931),
    [sym_binary_operator] = STATE(1931),
    [sym_extract_operator] = STATE(1931),
    [sym_namespace_operator] = STATE(1931),
    [sym_integer] = STATE(1931),
    [sym_complex] = STATE(1931),
    [sym_float] = STATE(1931),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2633),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(1931),
    [sym__expression] = STATE(1931),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__close_parenthesis] = STATE(2533),
    [sym__open_brace] = STATE(154),
    [aux_sym_call_arguments_repeat1] = STATE(1538),
    [sym_identifier] = ACTIONS(6387),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(6389),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3865),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(6391),
    [sym_next] = ACTIONS(6391),
    [sym_break] = ACTIONS(6391),
    [sym_true] = ACTIONS(6391),
    [sym_false] = ACTIONS(6391),
    [sym_null] = ACTIONS(6391),
    [sym_inf] = ACTIONS(6391),
    [sym_nan] = ACTIONS(6391),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(6393),
    [sym_dot_dot_i] = ACTIONS(6395),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6397),
    [sym__newline] = ACTIONS(6399),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(6663),
    [sym__external_open_brace] = ACTIONS(3891),
  },
  [1497] = {
    [sym_call_arguments] = STATE(2870),
    [sym_subset_arguments] = STATE(2869),
    [sym_subset2_arguments] = STATE(2867),
    [sym__open_parenthesis] = STATE(1362),
    [sym__open_bracket] = STATE(1361),
    [sym__open_bracket2] = STATE(1360),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(6137),
    [anon_sym_SLASH] = ACTIONS(6139),
    [anon_sym_STAR_STAR] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6141),
    [aux_sym_binary_operator_token1] = ACTIONS(6143),
    [anon_sym_PIPE_GT] = ACTIONS(6143),
    [anon_sym_COLON] = ACTIONS(6145),
    [anon_sym_DOLLAR] = ACTIONS(6147),
    [anon_sym_AT] = ACTIONS(6147),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6151),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6153),
    [sym__external_open_bracket2] = ACTIONS(6155),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [1498] = {
    [sym_call_arguments] = STATE(2870),
    [sym_subset_arguments] = STATE(2869),
    [sym_subset2_arguments] = STATE(2867),
    [sym__open_parenthesis] = STATE(1362),
    [sym__open_bracket] = STATE(1361),
    [sym__open_bracket2] = STATE(1360),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(6115),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(6125),
    [anon_sym_AMP] = ACTIONS(6127),
    [anon_sym_PIPE_PIPE] = ACTIONS(6129),
    [anon_sym_AMP_AMP] = ACTIONS(6131),
    [anon_sym_LT] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6135),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_GT_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(6135),
    [anon_sym_STAR] = ACTIONS(6137),
    [anon_sym_SLASH] = ACTIONS(6139),
    [anon_sym_STAR_STAR] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6141),
    [aux_sym_binary_operator_token1] = ACTIONS(6143),
    [anon_sym_PIPE_GT] = ACTIONS(6143),
    [anon_sym_COLON] = ACTIONS(6145),
    [anon_sym_DOLLAR] = ACTIONS(6147),
    [anon_sym_AT] = ACTIONS(6147),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6151),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6153),
    [sym__external_open_bracket2] = ACTIONS(6155),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [1499] = {
    [sym_call_arguments] = STATE(2870),
    [sym_subset_arguments] = STATE(2869),
    [sym_subset2_arguments] = STATE(2867),
    [sym__open_parenthesis] = STATE(1362),
    [sym__open_bracket] = STATE(1361),
    [sym__open_bracket2] = STATE(1360),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(6111),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(6113),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(6115),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_LT_DASH] = ACTIONS(6119),
    [anon_sym_LT_LT_DASH] = ACTIONS(6119),
    [anon_sym_COLON_EQ] = ACTIONS(6119),
    [anon_sym_DASH_GT] = ACTIONS(6121),
    [anon_sym_DASH_GT_GT] = ACTIONS(6123),
    [anon_sym_PIPE] = ACTIONS(6125),
    [anon_sym_AMP] = ACTIONS(6127),
    [anon_sym_PIPE_PIPE] = ACTIONS(6129),
    [anon_sym_AMP_AMP] = ACTIONS(6131),
    [anon_sym_LT] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6135),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_GT_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(6135),
    [anon_sym_STAR] = ACTIONS(6137),
    [anon_sym_SLASH] = ACTIONS(6139),
    [anon_sym_STAR_STAR] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6141),
    [aux_sym_binary_operator_token1] = ACTIONS(6143),
    [anon_sym_PIPE_GT] = ACTIONS(6143),
    [anon_sym_COLON] = ACTIONS(6145),
    [anon_sym_DOLLAR] = ACTIONS(6147),
    [anon_sym_AT] = ACTIONS(6147),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6151),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6153),
    [sym__external_open_bracket2] = ACTIONS(6155),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [1500] = {
    [sym_call_arguments] = STATE(2870),
    [sym_subset_arguments] = STATE(2869),
    [sym_subset2_arguments] = STATE(2867),
    [sym__open_parenthesis] = STATE(1362),
    [sym__open_bracket] = STATE(1361),
    [sym__open_bracket2] = STATE(1360),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(6111),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(6113),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(6115),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(6121),
    [anon_sym_DASH_GT_GT] = ACTIONS(6123),
    [anon_sym_PIPE] = ACTIONS(6125),
    [anon_sym_AMP] = ACTIONS(6127),
    [anon_sym_PIPE_PIPE] = ACTIONS(6129),
    [anon_sym_AMP_AMP] = ACTIONS(6131),
    [anon_sym_LT] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6135),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_GT_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(6135),
    [anon_sym_STAR] = ACTIONS(6137),
    [anon_sym_SLASH] = ACTIONS(6139),
    [anon_sym_STAR_STAR] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6141),
    [aux_sym_binary_operator_token1] = ACTIONS(6143),
    [anon_sym_PIPE_GT] = ACTIONS(6143),
    [anon_sym_COLON] = ACTIONS(6145),
    [anon_sym_DOLLAR] = ACTIONS(6147),
    [anon_sym_AT] = ACTIONS(6147),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6151),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6153),
    [sym__external_open_bracket2] = ACTIONS(6155),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [1501] = {
    [sym_call_arguments] = STATE(2777),
    [sym_subset_arguments] = STATE(2779),
    [sym_subset2_arguments] = STATE(2786),
    [sym__open_parenthesis] = STATE(1411),
    [sym__open_bracket] = STATE(1409),
    [sym__open_bracket2] = STATE(1407),
    [ts_builtin_sym_end] = ACTIONS(5337),
    [sym_identifier] = ACTIONS(5339),
    [anon_sym_BSLASH] = ACTIONS(5337),
    [anon_sym_function] = ACTIONS(5339),
    [anon_sym_EQ] = ACTIONS(6491),
    [anon_sym_if] = ACTIONS(5339),
    [anon_sym_for] = ACTIONS(5339),
    [anon_sym_while] = ACTIONS(5339),
    [anon_sym_repeat] = ACTIONS(5339),
    [anon_sym_QMARK] = ACTIONS(5337),
    [anon_sym_TILDE] = ACTIONS(6495),
    [anon_sym_BANG] = ACTIONS(5339),
    [anon_sym_PLUS] = ACTIONS(6497),
    [anon_sym_DASH] = ACTIONS(6499),
    [anon_sym_LT_DASH] = ACTIONS(6501),
    [anon_sym_LT_LT_DASH] = ACTIONS(6501),
    [anon_sym_COLON_EQ] = ACTIONS(6501),
    [anon_sym_DASH_GT] = ACTIONS(6503),
    [anon_sym_DASH_GT_GT] = ACTIONS(6505),
    [anon_sym_PIPE] = ACTIONS(6507),
    [anon_sym_AMP] = ACTIONS(6509),
    [anon_sym_PIPE_PIPE] = ACTIONS(6511),
    [anon_sym_AMP_AMP] = ACTIONS(6513),
    [anon_sym_LT] = ACTIONS(6515),
    [anon_sym_LT_EQ] = ACTIONS(6517),
    [anon_sym_GT] = ACTIONS(6515),
    [anon_sym_GT_EQ] = ACTIONS(6517),
    [anon_sym_EQ_EQ] = ACTIONS(6517),
    [anon_sym_BANG_EQ] = ACTIONS(6517),
    [anon_sym_STAR] = ACTIONS(6519),
    [anon_sym_SLASH] = ACTIONS(6521),
    [anon_sym_STAR_STAR] = ACTIONS(6523),
    [anon_sym_CARET] = ACTIONS(6523),
    [aux_sym_binary_operator_token1] = ACTIONS(6525),
    [anon_sym_PIPE_GT] = ACTIONS(6525),
    [anon_sym_COLON] = ACTIONS(6527),
    [anon_sym_DOLLAR] = ACTIONS(6529),
    [anon_sym_AT] = ACTIONS(6529),
    [aux_sym__hex_literal_token1] = ACTIONS(5337),
    [sym__number_literal] = ACTIONS(5339),
    [anon_sym_SQUOTE] = ACTIONS(5337),
    [anon_sym_DQUOTE] = ACTIONS(5337),
    [sym_return] = ACTIONS(5339),
    [sym_next] = ACTIONS(5339),
    [sym_break] = ACTIONS(5339),
    [sym_true] = ACTIONS(5339),
    [sym_false] = ACTIONS(5339),
    [sym_null] = ACTIONS(5339),
    [sym_inf] = ACTIONS(5339),
    [sym_nan] = ACTIONS(5339),
    [anon_sym_NA] = ACTIONS(5339),
    [anon_sym_NA_integer_] = ACTIONS(5339),
    [anon_sym_NA_real_] = ACTIONS(5339),
    [anon_sym_NA_complex_] = ACTIONS(5339),
    [anon_sym_NA_character_] = ACTIONS(5339),
    [sym_dots] = ACTIONS(5339),
    [sym_dot_dot_i] = ACTIONS(5337),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5337),
    [sym__semicolon] = ACTIONS(5337),
    [sym__raw_string_literal] = ACTIONS(5337),
    [sym__external_open_parenthesis] = ACTIONS(6531),
    [sym__external_close_parenthesis] = ACTIONS(5337),
    [sym__external_open_brace] = ACTIONS(5337),
    [sym__external_open_bracket] = ACTIONS(6533),
    [sym__external_open_bracket2] = ACTIONS(6535),
  },
  [1502] = {
    [sym_call_arguments] = STATE(2870),
    [sym_subset_arguments] = STATE(2869),
    [sym_subset2_arguments] = STATE(2867),
    [sym__open_parenthesis] = STATE(1362),
    [sym__open_bracket] = STATE(1361),
    [sym__open_bracket2] = STATE(1360),
    [sym_identifier] = ACTIONS(5401),
    [anon_sym_BSLASH] = ACTIONS(5399),
    [anon_sym_function] = ACTIONS(5401),
    [anon_sym_EQ] = ACTIONS(6111),
    [anon_sym_if] = ACTIONS(5401),
    [anon_sym_for] = ACTIONS(5401),
    [anon_sym_while] = ACTIONS(5401),
    [anon_sym_repeat] = ACTIONS(5401),
    [anon_sym_QMARK] = ACTIONS(5399),
    [anon_sym_TILDE] = ACTIONS(6113),
    [anon_sym_BANG] = ACTIONS(5401),
    [anon_sym_PLUS] = ACTIONS(6115),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_LT_DASH] = ACTIONS(6119),
    [anon_sym_LT_LT_DASH] = ACTIONS(6119),
    [anon_sym_COLON_EQ] = ACTIONS(6119),
    [anon_sym_DASH_GT] = ACTIONS(6121),
    [anon_sym_DASH_GT_GT] = ACTIONS(6123),
    [anon_sym_PIPE] = ACTIONS(6125),
    [anon_sym_AMP] = ACTIONS(6127),
    [anon_sym_PIPE_PIPE] = ACTIONS(6129),
    [anon_sym_AMP_AMP] = ACTIONS(6131),
    [anon_sym_LT] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6135),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_GT_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(6135),
    [anon_sym_STAR] = ACTIONS(6137),
    [anon_sym_SLASH] = ACTIONS(6139),
    [anon_sym_STAR_STAR] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6141),
    [aux_sym_binary_operator_token1] = ACTIONS(6143),
    [anon_sym_PIPE_GT] = ACTIONS(6143),
    [anon_sym_COLON] = ACTIONS(6145),
    [anon_sym_DOLLAR] = ACTIONS(6147),
    [anon_sym_AT] = ACTIONS(6147),
    [aux_sym__hex_literal_token1] = ACTIONS(5399),
    [sym__number_literal] = ACTIONS(5401),
    [anon_sym_SQUOTE] = ACTIONS(5399),
    [anon_sym_DQUOTE] = ACTIONS(5399),
    [sym_return] = ACTIONS(5401),
    [sym_next] = ACTIONS(5401),
    [sym_break] = ACTIONS(5401),
    [sym_true] = ACTIONS(5401),
    [sym_false] = ACTIONS(5401),
    [sym_null] = ACTIONS(5401),
    [sym_inf] = ACTIONS(5401),
    [sym_nan] = ACTIONS(5401),
    [anon_sym_NA] = ACTIONS(5401),
    [anon_sym_NA_integer_] = ACTIONS(5401),
    [anon_sym_NA_real_] = ACTIONS(5401),
    [anon_sym_NA_complex_] = ACTIONS(5401),
    [anon_sym_NA_character_] = ACTIONS(5401),
    [sym_dots] = ACTIONS(5401),
    [sym_dot_dot_i] = ACTIONS(5399),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5399),
    [sym__newline] = ACTIONS(5399),
    [sym__raw_string_literal] = ACTIONS(5399),
    [sym__external_else] = ACTIONS(5399),
    [sym__external_open_parenthesis] = ACTIONS(6151),
    [sym__external_open_brace] = ACTIONS(5399),
    [sym__external_open_bracket] = ACTIONS(6153),
    [sym__external_open_bracket2] = ACTIONS(6155),
    [sym__external_close_bracket2] = ACTIONS(5399),
  },
  [1503] = {
    [sym_function_definition] = STATE(1940),
    [sym_if_statement] = STATE(1940),
    [sym_for_statement] = STATE(1940),
    [sym_while_statement] = STATE(1940),
    [sym_repeat_statement] = STATE(1940),
    [sym_braced_expression] = STATE(1940),
    [sym_parenthesized_expression] = STATE(1940),
    [sym_call] = STATE(1940),
    [sym_subset] = STATE(1940),
    [sym_subset2] = STATE(1940),
    [sym__argument] = STATE(4665),
    [sym_argument] = STATE(4661),
    [sym__argument_named] = STATE(4669),
    [sym__argument_unnamed] = STATE(4673),
    [sym__argument_value] = STATE(4679),
    [sym_unary_operator] = STATE(1940),
    [sym_binary_operator] = STATE(1940),
    [sym_extract_operator] = STATE(1940),
    [sym_namespace_operator] = STATE(1940),
    [sym_integer] = STATE(1940),
    [sym_complex] = STATE(1940),
    [sym_float] = STATE(1940),
    [sym__hex_literal] = STATE(2656),
    [sym__float_literal] = STATE(2656),
    [sym_string] = STATE(2606),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym_na] = STATE(1940),
    [sym__expression] = STATE(1940),
    [sym__string_or_identifier] = STATE(5141),
    [sym__open_parenthesis] = STATE(218),
    [sym__open_brace] = STATE(185),
    [sym__close_bracket2] = STATE(2794),
    [aux_sym_call_arguments_repeat1] = STATE(1912),
    [sym_identifier] = ACTIONS(6369),
    [anon_sym_BSLASH] = ACTIONS(4644),
    [anon_sym_function] = ACTIONS(4646),
    [anon_sym_if] = ACTIONS(4648),
    [anon_sym_for] = ACTIONS(4650),
    [anon_sym_while] = ACTIONS(4652),
    [anon_sym_repeat] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(6371),
    [anon_sym_PLUS] = ACTIONS(4662),
    [anon_sym_DASH] = ACTIONS(4662),
    [aux_sym__hex_literal_token1] = ACTIONS(4666),
    [sym__number_literal] = ACTIONS(4668),
    [anon_sym_SQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4672),
    [sym_return] = ACTIONS(6373),
    [sym_next] = ACTIONS(6373),
    [sym_break] = ACTIONS(6373),
    [sym_true] = ACTIONS(6373),
    [sym_false] = ACTIONS(6373),
    [sym_null] = ACTIONS(6373),
    [sym_inf] = ACTIONS(6373),
    [sym_nan] = ACTIONS(6373),
    [anon_sym_NA] = ACTIONS(4676),
    [anon_sym_NA_integer_] = ACTIONS(4676),
    [anon_sym_NA_real_] = ACTIONS(4676),
    [anon_sym_NA_complex_] = ACTIONS(4676),
    [anon_sym_NA_character_] = ACTIONS(4676),
    [sym_dots] = ACTIONS(6375),
    [sym_dot_dot_i] = ACTIONS(6377),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6379),
    [sym__newline] = ACTIONS(6381),
    [sym__raw_string_literal] = ACTIONS(4680),
    [sym__external_open_parenthesis] = ACTIONS(4682),
    [sym__external_open_brace] = ACTIONS(4684),
    [sym__external_close_bracket2] = ACTIONS(6665),
  },
  [1504] = {
    [sym_function_definition] = STATE(2038),
    [sym_if_statement] = STATE(2038),
    [sym_for_statement] = STATE(2038),
    [sym_while_statement] = STATE(2038),
    [sym_repeat_statement] = STATE(2038),
    [sym_braced_expression] = STATE(2038),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_call] = STATE(2038),
    [sym_subset] = STATE(2038),
    [sym_subset2] = STATE(2038),
    [sym__argument] = STATE(4664),
    [sym_argument] = STATE(4659),
    [sym__argument_named] = STATE(4654),
    [sym__argument_unnamed] = STATE(4676),
    [sym__argument_value] = STATE(4677),
    [sym_unary_operator] = STATE(2038),
    [sym_binary_operator] = STATE(2038),
    [sym_extract_operator] = STATE(2038),
    [sym_namespace_operator] = STATE(2038),
    [sym_integer] = STATE(2038),
    [sym_complex] = STATE(2038),
    [sym_float] = STATE(2038),
    [sym__hex_literal] = STATE(2700),
    [sym__float_literal] = STATE(2700),
    [sym_string] = STATE(2597),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym_na] = STATE(2038),
    [sym__expression] = STATE(2038),
    [sym__string_or_identifier] = STATE(5148),
    [sym__open_parenthesis] = STATE(214),
    [sym__open_brace] = STATE(192),
    [sym__close_bracket] = STATE(2795),
    [aux_sym_call_arguments_repeat1] = STATE(2034),
    [sym_identifier] = ACTIONS(6351),
    [anon_sym_BSLASH] = ACTIONS(4754),
    [anon_sym_function] = ACTIONS(4756),
    [anon_sym_if] = ACTIONS(4758),
    [anon_sym_for] = ACTIONS(4760),
    [anon_sym_while] = ACTIONS(4762),
    [anon_sym_repeat] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4766),
    [anon_sym_TILDE] = ACTIONS(4768),
    [anon_sym_BANG] = ACTIONS(6353),
    [anon_sym_PLUS] = ACTIONS(4772),
    [anon_sym_DASH] = ACTIONS(4772),
    [aux_sym__hex_literal_token1] = ACTIONS(4776),
    [sym__number_literal] = ACTIONS(4778),
    [anon_sym_SQUOTE] = ACTIONS(4780),
    [anon_sym_DQUOTE] = ACTIONS(4782),
    [sym_return] = ACTIONS(6355),
    [sym_next] = ACTIONS(6355),
    [sym_break] = ACTIONS(6355),
    [sym_true] = ACTIONS(6355),
    [sym_false] = ACTIONS(6355),
    [sym_null] = ACTIONS(6355),
    [sym_inf] = ACTIONS(6355),
    [sym_nan] = ACTIONS(6355),
    [anon_sym_NA] = ACTIONS(4786),
    [anon_sym_NA_integer_] = ACTIONS(4786),
    [anon_sym_NA_real_] = ACTIONS(4786),
    [anon_sym_NA_complex_] = ACTIONS(4786),
    [anon_sym_NA_character_] = ACTIONS(4786),
    [sym_dots] = ACTIONS(6357),
    [sym_dot_dot_i] = ACTIONS(6359),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6361),
    [sym__newline] = ACTIONS(6363),
    [sym__raw_string_literal] = ACTIONS(4790),
    [sym__external_open_parenthesis] = ACTIONS(4792),
    [sym__external_open_brace] = ACTIONS(4794),
    [sym__external_close_bracket] = ACTIONS(6667),
  },
  [1505] = {
    [sym_function_definition] = STATE(1931),
    [sym_if_statement] = STATE(1931),
    [sym_for_statement] = STATE(1931),
    [sym_while_statement] = STATE(1931),
    [sym_repeat_statement] = STATE(1931),
    [sym_braced_expression] = STATE(1931),
    [sym_parenthesized_expression] = STATE(1931),
    [sym_call] = STATE(1931),
    [sym_subset] = STATE(1931),
    [sym_subset2] = STATE(1931),
    [sym__argument] = STATE(4656),
    [sym_argument] = STATE(4657),
    [sym__argument_named] = STATE(4658),
    [sym__argument_unnamed] = STATE(4662),
    [sym__argument_value] = STATE(4663),
    [sym_unary_operator] = STATE(1931),
    [sym_binary_operator] = STATE(1931),
    [sym_extract_operator] = STATE(1931),
    [sym_namespace_operator] = STATE(1931),
    [sym_integer] = STATE(1931),
    [sym_complex] = STATE(1931),
    [sym_float] = STATE(1931),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2633),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(1931),
    [sym__expression] = STATE(1931),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__close_parenthesis] = STATE(2677),
    [sym__open_brace] = STATE(154),
    [aux_sym_call_arguments_repeat1] = STATE(2113),
    [sym_identifier] = ACTIONS(6387),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(6389),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3865),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(6391),
    [sym_next] = ACTIONS(6391),
    [sym_break] = ACTIONS(6391),
    [sym_true] = ACTIONS(6391),
    [sym_false] = ACTIONS(6391),
    [sym_null] = ACTIONS(6391),
    [sym_inf] = ACTIONS(6391),
    [sym_nan] = ACTIONS(6391),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(6393),
    [sym_dot_dot_i] = ACTIONS(6395),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6397),
    [sym__newline] = ACTIONS(6399),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(6669),
    [sym__external_open_brace] = ACTIONS(3891),
  },
  [1506] = {
    [sym_call_arguments] = STATE(2870),
    [sym_subset_arguments] = STATE(2869),
    [sym_subset2_arguments] = STATE(2867),
    [sym__open_parenthesis] = STATE(1362),
    [sym__open_bracket] = STATE(1361),
    [sym__open_bracket2] = STATE(1360),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6141),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(5351),
    [anon_sym_DOLLAR] = ACTIONS(6147),
    [anon_sym_AT] = ACTIONS(6147),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6151),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6153),
    [sym__external_open_bracket2] = ACTIONS(6155),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [1507] = {
    [sym_call_arguments] = STATE(2870),
    [sym_subset_arguments] = STATE(2869),
    [sym_subset2_arguments] = STATE(2867),
    [sym__open_parenthesis] = STATE(1362),
    [sym__open_bracket] = STATE(1361),
    [sym__open_bracket2] = STATE(1360),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6141),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(6145),
    [anon_sym_DOLLAR] = ACTIONS(6147),
    [anon_sym_AT] = ACTIONS(6147),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6151),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6153),
    [sym__external_open_bracket2] = ACTIONS(6155),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [1508] = {
    [sym_call_arguments] = STATE(2870),
    [sym_subset_arguments] = STATE(2869),
    [sym_subset2_arguments] = STATE(2867),
    [sym__open_parenthesis] = STATE(1362),
    [sym__open_bracket] = STATE(1361),
    [sym__open_bracket2] = STATE(1360),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6141),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(5351),
    [anon_sym_DOLLAR] = ACTIONS(6147),
    [anon_sym_AT] = ACTIONS(6147),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6151),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6153),
    [sym__external_open_bracket2] = ACTIONS(6155),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [1509] = {
    [sym_call_arguments] = STATE(2870),
    [sym_subset_arguments] = STATE(2869),
    [sym_subset2_arguments] = STATE(2867),
    [sym__open_parenthesis] = STATE(1362),
    [sym__open_bracket] = STATE(1361),
    [sym__open_bracket2] = STATE(1360),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6141),
    [aux_sym_binary_operator_token1] = ACTIONS(6143),
    [anon_sym_PIPE_GT] = ACTIONS(6143),
    [anon_sym_COLON] = ACTIONS(6145),
    [anon_sym_DOLLAR] = ACTIONS(6147),
    [anon_sym_AT] = ACTIONS(6147),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6151),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6153),
    [sym__external_open_bracket2] = ACTIONS(6155),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [1510] = {
    [sym_call_arguments] = STATE(2870),
    [sym_subset_arguments] = STATE(2869),
    [sym_subset2_arguments] = STATE(2867),
    [sym__open_parenthesis] = STATE(1362),
    [sym__open_bracket] = STATE(1361),
    [sym__open_bracket2] = STATE(1360),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(6115),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(6137),
    [anon_sym_SLASH] = ACTIONS(6139),
    [anon_sym_STAR_STAR] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6141),
    [aux_sym_binary_operator_token1] = ACTIONS(6143),
    [anon_sym_PIPE_GT] = ACTIONS(6143),
    [anon_sym_COLON] = ACTIONS(6145),
    [anon_sym_DOLLAR] = ACTIONS(6147),
    [anon_sym_AT] = ACTIONS(6147),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6151),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6153),
    [sym__external_open_bracket2] = ACTIONS(6155),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [1511] = {
    [sym_call_arguments] = STATE(2870),
    [sym_subset_arguments] = STATE(2869),
    [sym_subset2_arguments] = STATE(2867),
    [sym__open_parenthesis] = STATE(1362),
    [sym__open_bracket] = STATE(1361),
    [sym__open_bracket2] = STATE(1360),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(6115),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6135),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_GT_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(6135),
    [anon_sym_STAR] = ACTIONS(6137),
    [anon_sym_SLASH] = ACTIONS(6139),
    [anon_sym_STAR_STAR] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6141),
    [aux_sym_binary_operator_token1] = ACTIONS(6143),
    [anon_sym_PIPE_GT] = ACTIONS(6143),
    [anon_sym_COLON] = ACTIONS(6145),
    [anon_sym_DOLLAR] = ACTIONS(6147),
    [anon_sym_AT] = ACTIONS(6147),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6151),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6153),
    [sym__external_open_bracket2] = ACTIONS(6155),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [1512] = {
    [sym_call_arguments] = STATE(2870),
    [sym_subset_arguments] = STATE(2869),
    [sym_subset2_arguments] = STATE(2867),
    [sym__open_parenthesis] = STATE(1362),
    [sym__open_bracket] = STATE(1361),
    [sym__open_bracket2] = STATE(1360),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(6115),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(6127),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(6131),
    [anon_sym_LT] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6135),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_GT_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(6135),
    [anon_sym_STAR] = ACTIONS(6137),
    [anon_sym_SLASH] = ACTIONS(6139),
    [anon_sym_STAR_STAR] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6141),
    [aux_sym_binary_operator_token1] = ACTIONS(6143),
    [anon_sym_PIPE_GT] = ACTIONS(6143),
    [anon_sym_COLON] = ACTIONS(6145),
    [anon_sym_DOLLAR] = ACTIONS(6147),
    [anon_sym_AT] = ACTIONS(6147),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6151),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6153),
    [sym__external_open_bracket2] = ACTIONS(6155),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [1513] = {
    [sym_call_arguments] = STATE(2870),
    [sym_subset_arguments] = STATE(2869),
    [sym_subset2_arguments] = STATE(2867),
    [sym__open_parenthesis] = STATE(1362),
    [sym__open_bracket] = STATE(1361),
    [sym__open_bracket2] = STATE(1360),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(6113),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(6115),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(6125),
    [anon_sym_AMP] = ACTIONS(6127),
    [anon_sym_PIPE_PIPE] = ACTIONS(6129),
    [anon_sym_AMP_AMP] = ACTIONS(6131),
    [anon_sym_LT] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6135),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_GT_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(6135),
    [anon_sym_STAR] = ACTIONS(6137),
    [anon_sym_SLASH] = ACTIONS(6139),
    [anon_sym_STAR_STAR] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6141),
    [aux_sym_binary_operator_token1] = ACTIONS(6143),
    [anon_sym_PIPE_GT] = ACTIONS(6143),
    [anon_sym_COLON] = ACTIONS(6145),
    [anon_sym_DOLLAR] = ACTIONS(6147),
    [anon_sym_AT] = ACTIONS(6147),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6151),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6153),
    [sym__external_open_bracket2] = ACTIONS(6155),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [1514] = {
    [sym_call_arguments] = STATE(2870),
    [sym_subset_arguments] = STATE(2869),
    [sym_subset2_arguments] = STATE(2867),
    [sym__open_parenthesis] = STATE(1362),
    [sym__open_bracket] = STATE(1361),
    [sym__open_bracket2] = STATE(1360),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(6111),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(6113),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(6115),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_LT_DASH] = ACTIONS(6119),
    [anon_sym_LT_LT_DASH] = ACTIONS(6119),
    [anon_sym_COLON_EQ] = ACTIONS(6119),
    [anon_sym_DASH_GT] = ACTIONS(6121),
    [anon_sym_DASH_GT_GT] = ACTIONS(6123),
    [anon_sym_PIPE] = ACTIONS(6125),
    [anon_sym_AMP] = ACTIONS(6127),
    [anon_sym_PIPE_PIPE] = ACTIONS(6129),
    [anon_sym_AMP_AMP] = ACTIONS(6131),
    [anon_sym_LT] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6135),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_GT_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(6135),
    [anon_sym_STAR] = ACTIONS(6137),
    [anon_sym_SLASH] = ACTIONS(6139),
    [anon_sym_STAR_STAR] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6141),
    [aux_sym_binary_operator_token1] = ACTIONS(6143),
    [anon_sym_PIPE_GT] = ACTIONS(6143),
    [anon_sym_COLON] = ACTIONS(6145),
    [anon_sym_DOLLAR] = ACTIONS(6147),
    [anon_sym_AT] = ACTIONS(6147),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6151),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6153),
    [sym__external_open_bracket2] = ACTIONS(6155),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [1515] = {
    [sym_string] = STATE(2615),
    [sym__single_quoted_string] = STATE(2265),
    [sym__double_quoted_string] = STATE(2264),
    [sym__string_or_identifier] = STATE(2615),
    [aux_sym_function_definition_repeat1] = STATE(1566),
    [sym_identifier] = ACTIONS(6671),
    [anon_sym_BSLASH] = ACTIONS(5659),
    [anon_sym_function] = ACTIONS(5663),
    [anon_sym_EQ] = ACTIONS(5663),
    [anon_sym_if] = ACTIONS(5663),
    [anon_sym_for] = ACTIONS(5663),
    [anon_sym_while] = ACTIONS(5663),
    [anon_sym_repeat] = ACTIONS(5663),
    [anon_sym_QMARK] = ACTIONS(5659),
    [anon_sym_TILDE] = ACTIONS(5659),
    [anon_sym_BANG] = ACTIONS(5663),
    [anon_sym_PLUS] = ACTIONS(5659),
    [anon_sym_DASH] = ACTIONS(5663),
    [anon_sym_LT_DASH] = ACTIONS(5659),
    [anon_sym_LT_LT_DASH] = ACTIONS(5659),
    [anon_sym_COLON_EQ] = ACTIONS(5659),
    [anon_sym_DASH_GT] = ACTIONS(5663),
    [anon_sym_DASH_GT_GT] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(5663),
    [anon_sym_AMP] = ACTIONS(5663),
    [anon_sym_PIPE_PIPE] = ACTIONS(5659),
    [anon_sym_AMP_AMP] = ACTIONS(5659),
    [anon_sym_LT] = ACTIONS(5663),
    [anon_sym_LT_EQ] = ACTIONS(5659),
    [anon_sym_GT] = ACTIONS(5663),
    [anon_sym_GT_EQ] = ACTIONS(5659),
    [anon_sym_EQ_EQ] = ACTIONS(5659),
    [anon_sym_BANG_EQ] = ACTIONS(5659),
    [anon_sym_STAR] = ACTIONS(5663),
    [anon_sym_SLASH] = ACTIONS(5659),
    [anon_sym_STAR_STAR] = ACTIONS(5659),
    [anon_sym_CARET] = ACTIONS(5659),
    [aux_sym_binary_operator_token1] = ACTIONS(5659),
    [anon_sym_PIPE_GT] = ACTIONS(5659),
    [anon_sym_COLON] = ACTIONS(5663),
    [anon_sym_DOLLAR] = ACTIONS(5659),
    [anon_sym_AT] = ACTIONS(5659),
    [aux_sym__hex_literal_token1] = ACTIONS(5659),
    [sym__number_literal] = ACTIONS(5663),
    [anon_sym_SQUOTE] = ACTIONS(1317),
    [anon_sym_DQUOTE] = ACTIONS(1319),
    [sym_return] = ACTIONS(5663),
    [sym_next] = ACTIONS(5663),
    [sym_break] = ACTIONS(5663),
    [sym_true] = ACTIONS(5663),
    [sym_false] = ACTIONS(5663),
    [sym_null] = ACTIONS(5663),
    [sym_inf] = ACTIONS(5663),
    [sym_nan] = ACTIONS(5663),
    [anon_sym_NA] = ACTIONS(5663),
    [anon_sym_NA_integer_] = ACTIONS(5663),
    [anon_sym_NA_real_] = ACTIONS(5663),
    [anon_sym_NA_complex_] = ACTIONS(5663),
    [anon_sym_NA_character_] = ACTIONS(5663),
    [sym_dots] = ACTIONS(5663),
    [sym_dot_dot_i] = ACTIONS(5659),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5659),
    [sym__newline] = ACTIONS(6673),
    [sym__semicolon] = ACTIONS(5659),
    [sym__raw_string_literal] = ACTIONS(1329),
    [sym__external_open_parenthesis] = ACTIONS(5659),
    [sym__external_open_brace] = ACTIONS(5659),
    [sym__external_close_brace] = ACTIONS(5659),
    [sym__external_open_bracket] = ACTIONS(5659),
    [sym__external_close_bracket] = ACTIONS(5659),
    [sym__external_open_bracket2] = ACTIONS(5659),
  },
  [1516] = {
    [sym_call_arguments] = STATE(2870),
    [sym_subset_arguments] = STATE(2869),
    [sym_subset2_arguments] = STATE(2867),
    [sym__open_parenthesis] = STATE(1362),
    [sym__open_bracket] = STATE(1361),
    [sym__open_bracket2] = STATE(1360),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(6137),
    [anon_sym_SLASH] = ACTIONS(6139),
    [anon_sym_STAR_STAR] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6141),
    [aux_sym_binary_operator_token1] = ACTIONS(6143),
    [anon_sym_PIPE_GT] = ACTIONS(6143),
    [anon_sym_COLON] = ACTIONS(6145),
    [anon_sym_DOLLAR] = ACTIONS(6147),
    [anon_sym_AT] = ACTIONS(6147),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6151),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6153),
    [sym__external_open_bracket2] = ACTIONS(6155),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [1517] = {
    [sym_call_arguments] = STATE(2870),
    [sym_subset_arguments] = STATE(2869),
    [sym_subset2_arguments] = STATE(2867),
    [sym__open_parenthesis] = STATE(1362),
    [sym__open_bracket] = STATE(1361),
    [sym__open_bracket2] = STATE(1360),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(6115),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(6125),
    [anon_sym_AMP] = ACTIONS(6127),
    [anon_sym_PIPE_PIPE] = ACTIONS(6129),
    [anon_sym_AMP_AMP] = ACTIONS(6131),
    [anon_sym_LT] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6135),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_GT_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(6135),
    [anon_sym_STAR] = ACTIONS(6137),
    [anon_sym_SLASH] = ACTIONS(6139),
    [anon_sym_STAR_STAR] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6141),
    [aux_sym_binary_operator_token1] = ACTIONS(6143),
    [anon_sym_PIPE_GT] = ACTIONS(6143),
    [anon_sym_COLON] = ACTIONS(6145),
    [anon_sym_DOLLAR] = ACTIONS(6147),
    [anon_sym_AT] = ACTIONS(6147),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6151),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6153),
    [sym__external_open_bracket2] = ACTIONS(6155),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [1518] = {
    [sym_call_arguments] = STATE(2870),
    [sym_subset_arguments] = STATE(2869),
    [sym_subset2_arguments] = STATE(2867),
    [sym__open_parenthesis] = STATE(1362),
    [sym__open_bracket] = STATE(1361),
    [sym__open_bracket2] = STATE(1360),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(6111),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(6113),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(6115),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_LT_DASH] = ACTIONS(6119),
    [anon_sym_LT_LT_DASH] = ACTIONS(6119),
    [anon_sym_COLON_EQ] = ACTIONS(6119),
    [anon_sym_DASH_GT] = ACTIONS(6121),
    [anon_sym_DASH_GT_GT] = ACTIONS(6123),
    [anon_sym_PIPE] = ACTIONS(6125),
    [anon_sym_AMP] = ACTIONS(6127),
    [anon_sym_PIPE_PIPE] = ACTIONS(6129),
    [anon_sym_AMP_AMP] = ACTIONS(6131),
    [anon_sym_LT] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6135),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_GT_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(6135),
    [anon_sym_STAR] = ACTIONS(6137),
    [anon_sym_SLASH] = ACTIONS(6139),
    [anon_sym_STAR_STAR] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6141),
    [aux_sym_binary_operator_token1] = ACTIONS(6143),
    [anon_sym_PIPE_GT] = ACTIONS(6143),
    [anon_sym_COLON] = ACTIONS(6145),
    [anon_sym_DOLLAR] = ACTIONS(6147),
    [anon_sym_AT] = ACTIONS(6147),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6151),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6153),
    [sym__external_open_bracket2] = ACTIONS(6155),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [1519] = {
    [sym_function_definition] = STATE(1940),
    [sym_if_statement] = STATE(1940),
    [sym_for_statement] = STATE(1940),
    [sym_while_statement] = STATE(1940),
    [sym_repeat_statement] = STATE(1940),
    [sym_braced_expression] = STATE(1940),
    [sym_parenthesized_expression] = STATE(1940),
    [sym_call] = STATE(1940),
    [sym_subset] = STATE(1940),
    [sym_subset2] = STATE(1940),
    [sym__argument] = STATE(4665),
    [sym_argument] = STATE(4661),
    [sym__argument_named] = STATE(4669),
    [sym__argument_unnamed] = STATE(4673),
    [sym__argument_value] = STATE(4679),
    [sym_unary_operator] = STATE(1940),
    [sym_binary_operator] = STATE(1940),
    [sym_extract_operator] = STATE(1940),
    [sym_namespace_operator] = STATE(1940),
    [sym_integer] = STATE(1940),
    [sym_complex] = STATE(1940),
    [sym_float] = STATE(1940),
    [sym__hex_literal] = STATE(2656),
    [sym__float_literal] = STATE(2656),
    [sym_string] = STATE(2606),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym_na] = STATE(1940),
    [sym__expression] = STATE(1940),
    [sym__string_or_identifier] = STATE(5141),
    [sym__open_parenthesis] = STATE(218),
    [sym__open_brace] = STATE(185),
    [sym__close_bracket2] = STATE(2813),
    [aux_sym_call_arguments_repeat1] = STATE(1838),
    [sym_identifier] = ACTIONS(6369),
    [anon_sym_BSLASH] = ACTIONS(4644),
    [anon_sym_function] = ACTIONS(4646),
    [anon_sym_if] = ACTIONS(4648),
    [anon_sym_for] = ACTIONS(4650),
    [anon_sym_while] = ACTIONS(4652),
    [anon_sym_repeat] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(6371),
    [anon_sym_PLUS] = ACTIONS(4662),
    [anon_sym_DASH] = ACTIONS(4662),
    [aux_sym__hex_literal_token1] = ACTIONS(4666),
    [sym__number_literal] = ACTIONS(4668),
    [anon_sym_SQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4672),
    [sym_return] = ACTIONS(6373),
    [sym_next] = ACTIONS(6373),
    [sym_break] = ACTIONS(6373),
    [sym_true] = ACTIONS(6373),
    [sym_false] = ACTIONS(6373),
    [sym_null] = ACTIONS(6373),
    [sym_inf] = ACTIONS(6373),
    [sym_nan] = ACTIONS(6373),
    [anon_sym_NA] = ACTIONS(4676),
    [anon_sym_NA_integer_] = ACTIONS(4676),
    [anon_sym_NA_real_] = ACTIONS(4676),
    [anon_sym_NA_complex_] = ACTIONS(4676),
    [anon_sym_NA_character_] = ACTIONS(4676),
    [sym_dots] = ACTIONS(6375),
    [sym_dot_dot_i] = ACTIONS(6377),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6379),
    [sym__newline] = ACTIONS(6381),
    [sym__raw_string_literal] = ACTIONS(4680),
    [sym__external_open_parenthesis] = ACTIONS(4682),
    [sym__external_open_brace] = ACTIONS(4684),
    [sym__external_close_bracket2] = ACTIONS(6675),
  },
  [1520] = {
    [sym_call_arguments] = STATE(2870),
    [sym_subset_arguments] = STATE(2869),
    [sym_subset2_arguments] = STATE(2867),
    [sym__open_parenthesis] = STATE(1362),
    [sym__open_bracket] = STATE(1361),
    [sym__open_bracket2] = STATE(1360),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(6111),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(6113),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(6115),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(6121),
    [anon_sym_DASH_GT_GT] = ACTIONS(6123),
    [anon_sym_PIPE] = ACTIONS(6125),
    [anon_sym_AMP] = ACTIONS(6127),
    [anon_sym_PIPE_PIPE] = ACTIONS(6129),
    [anon_sym_AMP_AMP] = ACTIONS(6131),
    [anon_sym_LT] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6135),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_GT_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(6135),
    [anon_sym_STAR] = ACTIONS(6137),
    [anon_sym_SLASH] = ACTIONS(6139),
    [anon_sym_STAR_STAR] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6141),
    [aux_sym_binary_operator_token1] = ACTIONS(6143),
    [anon_sym_PIPE_GT] = ACTIONS(6143),
    [anon_sym_COLON] = ACTIONS(6145),
    [anon_sym_DOLLAR] = ACTIONS(6147),
    [anon_sym_AT] = ACTIONS(6147),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6151),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6153),
    [sym__external_open_bracket2] = ACTIONS(6155),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [1521] = {
    [sym_call_arguments] = STATE(2845),
    [sym_subset_arguments] = STATE(2849),
    [sym_subset2_arguments] = STATE(2852),
    [sym__open_parenthesis] = STATE(1372),
    [sym__open_bracket] = STATE(1371),
    [sym__open_bracket2] = STATE(1370),
    [sym_identifier] = ACTIONS(5311),
    [anon_sym_BSLASH] = ACTIONS(5313),
    [anon_sym_function] = ACTIONS(5311),
    [anon_sym_EQ] = ACTIONS(6181),
    [anon_sym_if] = ACTIONS(5311),
    [anon_sym_for] = ACTIONS(5311),
    [anon_sym_while] = ACTIONS(5311),
    [anon_sym_repeat] = ACTIONS(5311),
    [anon_sym_QMARK] = ACTIONS(6677),
    [anon_sym_TILDE] = ACTIONS(6183),
    [anon_sym_BANG] = ACTIONS(5311),
    [anon_sym_PLUS] = ACTIONS(6185),
    [anon_sym_DASH] = ACTIONS(6187),
    [anon_sym_LT_DASH] = ACTIONS(6189),
    [anon_sym_LT_LT_DASH] = ACTIONS(6189),
    [anon_sym_COLON_EQ] = ACTIONS(6189),
    [anon_sym_DASH_GT] = ACTIONS(6191),
    [anon_sym_DASH_GT_GT] = ACTIONS(6193),
    [anon_sym_PIPE] = ACTIONS(6195),
    [anon_sym_AMP] = ACTIONS(6197),
    [anon_sym_PIPE_PIPE] = ACTIONS(6199),
    [anon_sym_AMP_AMP] = ACTIONS(6201),
    [anon_sym_LT] = ACTIONS(6203),
    [anon_sym_LT_EQ] = ACTIONS(6205),
    [anon_sym_GT] = ACTIONS(6203),
    [anon_sym_GT_EQ] = ACTIONS(6205),
    [anon_sym_EQ_EQ] = ACTIONS(6205),
    [anon_sym_BANG_EQ] = ACTIONS(6205),
    [anon_sym_STAR] = ACTIONS(6207),
    [anon_sym_SLASH] = ACTIONS(6209),
    [anon_sym_STAR_STAR] = ACTIONS(6211),
    [anon_sym_CARET] = ACTIONS(6211),
    [aux_sym_binary_operator_token1] = ACTIONS(6213),
    [anon_sym_PIPE_GT] = ACTIONS(6213),
    [anon_sym_COLON] = ACTIONS(6215),
    [anon_sym_DOLLAR] = ACTIONS(6217),
    [anon_sym_AT] = ACTIONS(6217),
    [aux_sym__hex_literal_token1] = ACTIONS(5313),
    [sym__number_literal] = ACTIONS(5311),
    [anon_sym_SQUOTE] = ACTIONS(5313),
    [anon_sym_DQUOTE] = ACTIONS(5313),
    [sym_return] = ACTIONS(5311),
    [sym_next] = ACTIONS(5311),
    [sym_break] = ACTIONS(5311),
    [sym_true] = ACTIONS(5311),
    [sym_false] = ACTIONS(5311),
    [sym_null] = ACTIONS(5311),
    [sym_inf] = ACTIONS(5311),
    [sym_nan] = ACTIONS(5311),
    [anon_sym_NA] = ACTIONS(5311),
    [anon_sym_NA_integer_] = ACTIONS(5311),
    [anon_sym_NA_real_] = ACTIONS(5311),
    [anon_sym_NA_complex_] = ACTIONS(5311),
    [anon_sym_NA_character_] = ACTIONS(5311),
    [sym_dots] = ACTIONS(5311),
    [sym_dot_dot_i] = ACTIONS(5313),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5313),
    [sym__newline] = ACTIONS(5313),
    [sym__raw_string_literal] = ACTIONS(5313),
    [sym__external_else] = ACTIONS(5313),
    [sym__external_open_parenthesis] = ACTIONS(6221),
    [sym__external_close_parenthesis] = ACTIONS(5313),
    [sym__external_open_brace] = ACTIONS(5313),
    [sym__external_open_bracket] = ACTIONS(6223),
    [sym__external_open_bracket2] = ACTIONS(6225),
  },
  [1522] = {
    [sym_call_arguments] = STATE(2870),
    [sym_subset_arguments] = STATE(2869),
    [sym_subset2_arguments] = STATE(2867),
    [sym__open_parenthesis] = STATE(1362),
    [sym__open_bracket] = STATE(1361),
    [sym__open_bracket2] = STATE(1360),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5345),
    [anon_sym_DASH] = ACTIONS(5347),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5347),
    [anon_sym_AMP] = ACTIONS(5347),
    [anon_sym_PIPE_PIPE] = ACTIONS(5345),
    [anon_sym_AMP_AMP] = ACTIONS(5345),
    [anon_sym_LT] = ACTIONS(5347),
    [anon_sym_LT_EQ] = ACTIONS(5345),
    [anon_sym_GT] = ACTIONS(5347),
    [anon_sym_GT_EQ] = ACTIONS(5345),
    [anon_sym_EQ_EQ] = ACTIONS(5345),
    [anon_sym_BANG_EQ] = ACTIONS(5345),
    [anon_sym_STAR] = ACTIONS(5347),
    [anon_sym_SLASH] = ACTIONS(5345),
    [anon_sym_STAR_STAR] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6141),
    [aux_sym_binary_operator_token1] = ACTIONS(5345),
    [anon_sym_PIPE_GT] = ACTIONS(5345),
    [anon_sym_COLON] = ACTIONS(5347),
    [anon_sym_DOLLAR] = ACTIONS(6147),
    [anon_sym_AT] = ACTIONS(6147),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_else] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(6151),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(6153),
    [sym__external_open_bracket2] = ACTIONS(6155),
    [sym__external_close_bracket2] = ACTIONS(5345),
  },
  [1523] = {
    [sym_call_arguments] = STATE(2870),
    [sym_subset_arguments] = STATE(2869),
    [sym_subset2_arguments] = STATE(2867),
    [sym__open_parenthesis] = STATE(1362),
    [sym__open_bracket] = STATE(1361),
    [sym__open_bracket2] = STATE(1360),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(6115),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5347),
    [anon_sym_AMP] = ACTIONS(5347),
    [anon_sym_PIPE_PIPE] = ACTIONS(5345),
    [anon_sym_AMP_AMP] = ACTIONS(5345),
    [anon_sym_LT] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6135),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_GT_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(6135),
    [anon_sym_STAR] = ACTIONS(6137),
    [anon_sym_SLASH] = ACTIONS(6139),
    [anon_sym_STAR_STAR] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6141),
    [aux_sym_binary_operator_token1] = ACTIONS(6143),
    [anon_sym_PIPE_GT] = ACTIONS(6143),
    [anon_sym_COLON] = ACTIONS(6145),
    [anon_sym_DOLLAR] = ACTIONS(6147),
    [anon_sym_AT] = ACTIONS(6147),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_else] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(6151),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(6153),
    [sym__external_open_bracket2] = ACTIONS(6155),
    [sym__external_close_bracket2] = ACTIONS(5345),
  },
  [1524] = {
    [sym_call_arguments] = STATE(2870),
    [sym_subset_arguments] = STATE(2869),
    [sym_subset2_arguments] = STATE(2867),
    [sym__open_parenthesis] = STATE(1362),
    [sym__open_bracket] = STATE(1361),
    [sym__open_bracket2] = STATE(1360),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(6115),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(6125),
    [anon_sym_AMP] = ACTIONS(6127),
    [anon_sym_PIPE_PIPE] = ACTIONS(6129),
    [anon_sym_AMP_AMP] = ACTIONS(6131),
    [anon_sym_LT] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6135),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_GT_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(6135),
    [anon_sym_STAR] = ACTIONS(6137),
    [anon_sym_SLASH] = ACTIONS(6139),
    [anon_sym_STAR_STAR] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6141),
    [aux_sym_binary_operator_token1] = ACTIONS(6143),
    [anon_sym_PIPE_GT] = ACTIONS(6143),
    [anon_sym_COLON] = ACTIONS(6145),
    [anon_sym_DOLLAR] = ACTIONS(6147),
    [anon_sym_AT] = ACTIONS(6147),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_else] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(6151),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(6153),
    [sym__external_open_bracket2] = ACTIONS(6155),
    [sym__external_close_bracket2] = ACTIONS(5345),
  },
  [1525] = {
    [sym_function_definition] = STATE(2038),
    [sym_if_statement] = STATE(2038),
    [sym_for_statement] = STATE(2038),
    [sym_while_statement] = STATE(2038),
    [sym_repeat_statement] = STATE(2038),
    [sym_braced_expression] = STATE(2038),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_call] = STATE(2038),
    [sym_subset] = STATE(2038),
    [sym_subset2] = STATE(2038),
    [sym__argument] = STATE(4664),
    [sym_argument] = STATE(4659),
    [sym__argument_named] = STATE(4654),
    [sym__argument_unnamed] = STATE(4676),
    [sym__argument_value] = STATE(4677),
    [sym_unary_operator] = STATE(2038),
    [sym_binary_operator] = STATE(2038),
    [sym_extract_operator] = STATE(2038),
    [sym_namespace_operator] = STATE(2038),
    [sym_integer] = STATE(2038),
    [sym_complex] = STATE(2038),
    [sym_float] = STATE(2038),
    [sym__hex_literal] = STATE(2700),
    [sym__float_literal] = STATE(2700),
    [sym_string] = STATE(2597),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym_na] = STATE(2038),
    [sym__expression] = STATE(2038),
    [sym__string_or_identifier] = STATE(5148),
    [sym__open_parenthesis] = STATE(214),
    [sym__open_brace] = STATE(192),
    [sym__close_bracket] = STATE(2815),
    [aux_sym_call_arguments_repeat1] = STATE(1839),
    [sym_identifier] = ACTIONS(6351),
    [anon_sym_BSLASH] = ACTIONS(4754),
    [anon_sym_function] = ACTIONS(4756),
    [anon_sym_if] = ACTIONS(4758),
    [anon_sym_for] = ACTIONS(4760),
    [anon_sym_while] = ACTIONS(4762),
    [anon_sym_repeat] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4766),
    [anon_sym_TILDE] = ACTIONS(4768),
    [anon_sym_BANG] = ACTIONS(6353),
    [anon_sym_PLUS] = ACTIONS(4772),
    [anon_sym_DASH] = ACTIONS(4772),
    [aux_sym__hex_literal_token1] = ACTIONS(4776),
    [sym__number_literal] = ACTIONS(4778),
    [anon_sym_SQUOTE] = ACTIONS(4780),
    [anon_sym_DQUOTE] = ACTIONS(4782),
    [sym_return] = ACTIONS(6355),
    [sym_next] = ACTIONS(6355),
    [sym_break] = ACTIONS(6355),
    [sym_true] = ACTIONS(6355),
    [sym_false] = ACTIONS(6355),
    [sym_null] = ACTIONS(6355),
    [sym_inf] = ACTIONS(6355),
    [sym_nan] = ACTIONS(6355),
    [anon_sym_NA] = ACTIONS(4786),
    [anon_sym_NA_integer_] = ACTIONS(4786),
    [anon_sym_NA_real_] = ACTIONS(4786),
    [anon_sym_NA_complex_] = ACTIONS(4786),
    [anon_sym_NA_character_] = ACTIONS(4786),
    [sym_dots] = ACTIONS(6357),
    [sym_dot_dot_i] = ACTIONS(6359),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6361),
    [sym__newline] = ACTIONS(6363),
    [sym__raw_string_literal] = ACTIONS(4790),
    [sym__external_open_parenthesis] = ACTIONS(4792),
    [sym__external_open_brace] = ACTIONS(4794),
    [sym__external_close_bracket] = ACTIONS(6679),
  },
  [1526] = {
    [sym_call_arguments] = STATE(2870),
    [sym_subset_arguments] = STATE(2869),
    [sym_subset2_arguments] = STATE(2867),
    [sym__open_parenthesis] = STATE(1362),
    [sym__open_bracket] = STATE(1361),
    [sym__open_bracket2] = STATE(1360),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(6111),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(6113),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(6115),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_LT_DASH] = ACTIONS(6119),
    [anon_sym_LT_LT_DASH] = ACTIONS(6119),
    [anon_sym_COLON_EQ] = ACTIONS(6119),
    [anon_sym_DASH_GT] = ACTIONS(6121),
    [anon_sym_DASH_GT_GT] = ACTIONS(6123),
    [anon_sym_PIPE] = ACTIONS(6125),
    [anon_sym_AMP] = ACTIONS(6127),
    [anon_sym_PIPE_PIPE] = ACTIONS(6129),
    [anon_sym_AMP_AMP] = ACTIONS(6131),
    [anon_sym_LT] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6135),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_GT_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(6135),
    [anon_sym_STAR] = ACTIONS(6137),
    [anon_sym_SLASH] = ACTIONS(6139),
    [anon_sym_STAR_STAR] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6141),
    [aux_sym_binary_operator_token1] = ACTIONS(6143),
    [anon_sym_PIPE_GT] = ACTIONS(6143),
    [anon_sym_COLON] = ACTIONS(6145),
    [anon_sym_DOLLAR] = ACTIONS(6147),
    [anon_sym_AT] = ACTIONS(6147),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_else] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(6151),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(6153),
    [sym__external_open_bracket2] = ACTIONS(6155),
    [sym__external_close_bracket2] = ACTIONS(5345),
  },
  [1527] = {
    [sym_call_arguments] = STATE(2840),
    [sym_subset_arguments] = STATE(2797),
    [sym_subset2_arguments] = STATE(2801),
    [sym__open_parenthesis] = STATE(1344),
    [sym__open_bracket] = STATE(1374),
    [sym__open_bracket2] = STATE(1452),
    [ts_builtin_sym_end] = ACTIONS(5429),
    [sym_identifier] = ACTIONS(5431),
    [anon_sym_BSLASH] = ACTIONS(5429),
    [anon_sym_function] = ACTIONS(5431),
    [anon_sym_EQ] = ACTIONS(6263),
    [anon_sym_if] = ACTIONS(5431),
    [anon_sym_for] = ACTIONS(5431),
    [anon_sym_while] = ACTIONS(5431),
    [anon_sym_repeat] = ACTIONS(5431),
    [anon_sym_QMARK] = ACTIONS(5429),
    [anon_sym_TILDE] = ACTIONS(6265),
    [anon_sym_BANG] = ACTIONS(5431),
    [anon_sym_PLUS] = ACTIONS(6267),
    [anon_sym_DASH] = ACTIONS(6269),
    [anon_sym_LT_DASH] = ACTIONS(6271),
    [anon_sym_LT_LT_DASH] = ACTIONS(6271),
    [anon_sym_COLON_EQ] = ACTIONS(6271),
    [anon_sym_DASH_GT] = ACTIONS(6273),
    [anon_sym_DASH_GT_GT] = ACTIONS(6275),
    [anon_sym_PIPE] = ACTIONS(6277),
    [anon_sym_AMP] = ACTIONS(6279),
    [anon_sym_PIPE_PIPE] = ACTIONS(6281),
    [anon_sym_AMP_AMP] = ACTIONS(6283),
    [anon_sym_LT] = ACTIONS(6285),
    [anon_sym_LT_EQ] = ACTIONS(6287),
    [anon_sym_GT] = ACTIONS(6285),
    [anon_sym_GT_EQ] = ACTIONS(6287),
    [anon_sym_EQ_EQ] = ACTIONS(6287),
    [anon_sym_BANG_EQ] = ACTIONS(6287),
    [anon_sym_STAR] = ACTIONS(6289),
    [anon_sym_SLASH] = ACTIONS(6291),
    [anon_sym_STAR_STAR] = ACTIONS(6293),
    [anon_sym_CARET] = ACTIONS(6293),
    [aux_sym_binary_operator_token1] = ACTIONS(6295),
    [anon_sym_PIPE_GT] = ACTIONS(6295),
    [anon_sym_COLON] = ACTIONS(6297),
    [anon_sym_DOLLAR] = ACTIONS(6299),
    [anon_sym_AT] = ACTIONS(6299),
    [aux_sym__hex_literal_token1] = ACTIONS(5429),
    [sym__number_literal] = ACTIONS(5431),
    [anon_sym_SQUOTE] = ACTIONS(5429),
    [anon_sym_DQUOTE] = ACTIONS(5429),
    [sym_return] = ACTIONS(5431),
    [sym_next] = ACTIONS(5431),
    [sym_break] = ACTIONS(5431),
    [sym_true] = ACTIONS(5431),
    [sym_false] = ACTIONS(5431),
    [sym_null] = ACTIONS(5431),
    [sym_inf] = ACTIONS(5431),
    [sym_nan] = ACTIONS(5431),
    [anon_sym_NA] = ACTIONS(5431),
    [anon_sym_NA_integer_] = ACTIONS(5431),
    [anon_sym_NA_real_] = ACTIONS(5431),
    [anon_sym_NA_complex_] = ACTIONS(5431),
    [anon_sym_NA_character_] = ACTIONS(5431),
    [sym_dots] = ACTIONS(5431),
    [sym_dot_dot_i] = ACTIONS(5429),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5429),
    [sym__semicolon] = ACTIONS(5429),
    [sym__raw_string_literal] = ACTIONS(5429),
    [sym__external_open_parenthesis] = ACTIONS(6301),
    [sym__external_open_brace] = ACTIONS(5429),
    [sym__external_close_brace] = ACTIONS(5429),
    [sym__external_open_bracket] = ACTIONS(6303),
    [sym__external_open_bracket2] = ACTIONS(6305),
  },
  [1528] = {
    [sym_function_definition] = STATE(1931),
    [sym_if_statement] = STATE(1931),
    [sym_for_statement] = STATE(1931),
    [sym_while_statement] = STATE(1931),
    [sym_repeat_statement] = STATE(1931),
    [sym_braced_expression] = STATE(1931),
    [sym_parenthesized_expression] = STATE(1931),
    [sym_call] = STATE(1931),
    [sym_subset] = STATE(1931),
    [sym_subset2] = STATE(1931),
    [sym__argument] = STATE(4656),
    [sym_argument] = STATE(4657),
    [sym__argument_named] = STATE(4658),
    [sym__argument_unnamed] = STATE(4662),
    [sym__argument_value] = STATE(4663),
    [sym_unary_operator] = STATE(1931),
    [sym_binary_operator] = STATE(1931),
    [sym_extract_operator] = STATE(1931),
    [sym_namespace_operator] = STATE(1931),
    [sym_integer] = STATE(1931),
    [sym_complex] = STATE(1931),
    [sym_float] = STATE(1931),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2633),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(1931),
    [sym__expression] = STATE(1931),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__close_parenthesis] = STATE(2816),
    [sym__open_brace] = STATE(154),
    [aux_sym_call_arguments_repeat1] = STATE(1547),
    [sym_identifier] = ACTIONS(6387),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(6389),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3865),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(6391),
    [sym_next] = ACTIONS(6391),
    [sym_break] = ACTIONS(6391),
    [sym_true] = ACTIONS(6391),
    [sym_false] = ACTIONS(6391),
    [sym_null] = ACTIONS(6391),
    [sym_inf] = ACTIONS(6391),
    [sym_nan] = ACTIONS(6391),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(6393),
    [sym_dot_dot_i] = ACTIONS(6395),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6397),
    [sym__newline] = ACTIONS(6399),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(6681),
    [sym__external_open_brace] = ACTIONS(3891),
  },
  [1529] = {
    [sym_function_definition] = STATE(2038),
    [sym_if_statement] = STATE(2038),
    [sym_for_statement] = STATE(2038),
    [sym_while_statement] = STATE(2038),
    [sym_repeat_statement] = STATE(2038),
    [sym_braced_expression] = STATE(2038),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_call] = STATE(2038),
    [sym_subset] = STATE(2038),
    [sym_subset2] = STATE(2038),
    [sym__argument] = STATE(4664),
    [sym_argument] = STATE(4659),
    [sym__argument_named] = STATE(4654),
    [sym__argument_unnamed] = STATE(4676),
    [sym__argument_value] = STATE(4677),
    [sym_unary_operator] = STATE(2038),
    [sym_binary_operator] = STATE(2038),
    [sym_extract_operator] = STATE(2038),
    [sym_namespace_operator] = STATE(2038),
    [sym_integer] = STATE(2038),
    [sym_complex] = STATE(2038),
    [sym_float] = STATE(2038),
    [sym__hex_literal] = STATE(2700),
    [sym__float_literal] = STATE(2700),
    [sym_string] = STATE(2597),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym_na] = STATE(2038),
    [sym__expression] = STATE(2038),
    [sym__string_or_identifier] = STATE(5148),
    [sym__open_parenthesis] = STATE(214),
    [sym__open_brace] = STATE(192),
    [sym__close_bracket] = STATE(4718),
    [aux_sym_call_arguments_repeat1] = STATE(1321),
    [sym_identifier] = ACTIONS(6351),
    [anon_sym_BSLASH] = ACTIONS(4754),
    [anon_sym_function] = ACTIONS(4756),
    [anon_sym_if] = ACTIONS(4758),
    [anon_sym_for] = ACTIONS(4760),
    [anon_sym_while] = ACTIONS(4762),
    [anon_sym_repeat] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4766),
    [anon_sym_TILDE] = ACTIONS(4768),
    [anon_sym_BANG] = ACTIONS(6353),
    [anon_sym_PLUS] = ACTIONS(4772),
    [anon_sym_DASH] = ACTIONS(4772),
    [aux_sym__hex_literal_token1] = ACTIONS(4776),
    [sym__number_literal] = ACTIONS(4778),
    [anon_sym_SQUOTE] = ACTIONS(4780),
    [anon_sym_DQUOTE] = ACTIONS(4782),
    [sym_return] = ACTIONS(6355),
    [sym_next] = ACTIONS(6355),
    [sym_break] = ACTIONS(6355),
    [sym_true] = ACTIONS(6355),
    [sym_false] = ACTIONS(6355),
    [sym_null] = ACTIONS(6355),
    [sym_inf] = ACTIONS(6355),
    [sym_nan] = ACTIONS(6355),
    [anon_sym_NA] = ACTIONS(4786),
    [anon_sym_NA_integer_] = ACTIONS(4786),
    [anon_sym_NA_real_] = ACTIONS(4786),
    [anon_sym_NA_complex_] = ACTIONS(4786),
    [anon_sym_NA_character_] = ACTIONS(4786),
    [sym_dots] = ACTIONS(6357),
    [sym_dot_dot_i] = ACTIONS(6359),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6361),
    [sym__newline] = ACTIONS(6363),
    [sym__raw_string_literal] = ACTIONS(4790),
    [sym__external_open_parenthesis] = ACTIONS(4792),
    [sym__external_open_brace] = ACTIONS(4794),
    [sym__external_close_bracket] = ACTIONS(6683),
  },
  [1530] = {
    [sym_call_arguments] = STATE(2870),
    [sym_subset_arguments] = STATE(2869),
    [sym_subset2_arguments] = STATE(2867),
    [sym__open_parenthesis] = STATE(1362),
    [sym__open_bracket] = STATE(1361),
    [sym__open_bracket2] = STATE(1360),
    [sym_identifier] = ACTIONS(5343),
    [anon_sym_BSLASH] = ACTIONS(5341),
    [anon_sym_function] = ACTIONS(5343),
    [anon_sym_EQ] = ACTIONS(6111),
    [anon_sym_if] = ACTIONS(5343),
    [anon_sym_for] = ACTIONS(5343),
    [anon_sym_while] = ACTIONS(5343),
    [anon_sym_repeat] = ACTIONS(5343),
    [anon_sym_QMARK] = ACTIONS(5341),
    [anon_sym_TILDE] = ACTIONS(6113),
    [anon_sym_BANG] = ACTIONS(5343),
    [anon_sym_PLUS] = ACTIONS(6115),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_LT_DASH] = ACTIONS(6119),
    [anon_sym_LT_LT_DASH] = ACTIONS(6119),
    [anon_sym_COLON_EQ] = ACTIONS(6119),
    [anon_sym_DASH_GT] = ACTIONS(6121),
    [anon_sym_DASH_GT_GT] = ACTIONS(6123),
    [anon_sym_PIPE] = ACTIONS(6125),
    [anon_sym_AMP] = ACTIONS(6127),
    [anon_sym_PIPE_PIPE] = ACTIONS(6129),
    [anon_sym_AMP_AMP] = ACTIONS(6131),
    [anon_sym_LT] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6135),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_GT_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(6135),
    [anon_sym_STAR] = ACTIONS(6137),
    [anon_sym_SLASH] = ACTIONS(6139),
    [anon_sym_STAR_STAR] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6141),
    [aux_sym_binary_operator_token1] = ACTIONS(6143),
    [anon_sym_PIPE_GT] = ACTIONS(6143),
    [anon_sym_COLON] = ACTIONS(6145),
    [anon_sym_DOLLAR] = ACTIONS(6147),
    [anon_sym_AT] = ACTIONS(6147),
    [aux_sym__hex_literal_token1] = ACTIONS(5341),
    [sym__number_literal] = ACTIONS(5343),
    [anon_sym_SQUOTE] = ACTIONS(5341),
    [anon_sym_DQUOTE] = ACTIONS(5341),
    [sym_return] = ACTIONS(5343),
    [sym_next] = ACTIONS(5343),
    [sym_break] = ACTIONS(5343),
    [sym_true] = ACTIONS(5343),
    [sym_false] = ACTIONS(5343),
    [sym_null] = ACTIONS(5343),
    [sym_inf] = ACTIONS(5343),
    [sym_nan] = ACTIONS(5343),
    [anon_sym_NA] = ACTIONS(5343),
    [anon_sym_NA_integer_] = ACTIONS(5343),
    [anon_sym_NA_real_] = ACTIONS(5343),
    [anon_sym_NA_complex_] = ACTIONS(5343),
    [anon_sym_NA_character_] = ACTIONS(5343),
    [sym_dots] = ACTIONS(5343),
    [sym_dot_dot_i] = ACTIONS(5341),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5341),
    [sym__newline] = ACTIONS(5341),
    [sym__raw_string_literal] = ACTIONS(5341),
    [sym__external_else] = ACTIONS(5341),
    [sym__external_open_parenthesis] = ACTIONS(6151),
    [sym__external_open_brace] = ACTIONS(5341),
    [sym__external_open_bracket] = ACTIONS(6153),
    [sym__external_open_bracket2] = ACTIONS(6155),
    [sym__external_close_bracket2] = ACTIONS(5341),
  },
  [1531] = {
    [sym_call_arguments] = STATE(2870),
    [sym_subset_arguments] = STATE(2869),
    [sym_subset2_arguments] = STATE(2867),
    [sym__open_parenthesis] = STATE(1362),
    [sym__open_bracket] = STATE(1361),
    [sym__open_bracket2] = STATE(1360),
    [sym_identifier] = ACTIONS(5339),
    [anon_sym_BSLASH] = ACTIONS(5337),
    [anon_sym_function] = ACTIONS(5339),
    [anon_sym_EQ] = ACTIONS(6111),
    [anon_sym_if] = ACTIONS(5339),
    [anon_sym_for] = ACTIONS(5339),
    [anon_sym_while] = ACTIONS(5339),
    [anon_sym_repeat] = ACTIONS(5339),
    [anon_sym_QMARK] = ACTIONS(5337),
    [anon_sym_TILDE] = ACTIONS(6113),
    [anon_sym_BANG] = ACTIONS(5339),
    [anon_sym_PLUS] = ACTIONS(6115),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_LT_DASH] = ACTIONS(6119),
    [anon_sym_LT_LT_DASH] = ACTIONS(6119),
    [anon_sym_COLON_EQ] = ACTIONS(6119),
    [anon_sym_DASH_GT] = ACTIONS(6121),
    [anon_sym_DASH_GT_GT] = ACTIONS(6123),
    [anon_sym_PIPE] = ACTIONS(6125),
    [anon_sym_AMP] = ACTIONS(6127),
    [anon_sym_PIPE_PIPE] = ACTIONS(6129),
    [anon_sym_AMP_AMP] = ACTIONS(6131),
    [anon_sym_LT] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6135),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_GT_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(6135),
    [anon_sym_STAR] = ACTIONS(6137),
    [anon_sym_SLASH] = ACTIONS(6139),
    [anon_sym_STAR_STAR] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6141),
    [aux_sym_binary_operator_token1] = ACTIONS(6143),
    [anon_sym_PIPE_GT] = ACTIONS(6143),
    [anon_sym_COLON] = ACTIONS(6145),
    [anon_sym_DOLLAR] = ACTIONS(6147),
    [anon_sym_AT] = ACTIONS(6147),
    [aux_sym__hex_literal_token1] = ACTIONS(5337),
    [sym__number_literal] = ACTIONS(5339),
    [anon_sym_SQUOTE] = ACTIONS(5337),
    [anon_sym_DQUOTE] = ACTIONS(5337),
    [sym_return] = ACTIONS(5339),
    [sym_next] = ACTIONS(5339),
    [sym_break] = ACTIONS(5339),
    [sym_true] = ACTIONS(5339),
    [sym_false] = ACTIONS(5339),
    [sym_null] = ACTIONS(5339),
    [sym_inf] = ACTIONS(5339),
    [sym_nan] = ACTIONS(5339),
    [anon_sym_NA] = ACTIONS(5339),
    [anon_sym_NA_integer_] = ACTIONS(5339),
    [anon_sym_NA_real_] = ACTIONS(5339),
    [anon_sym_NA_complex_] = ACTIONS(5339),
    [anon_sym_NA_character_] = ACTIONS(5339),
    [sym_dots] = ACTIONS(5339),
    [sym_dot_dot_i] = ACTIONS(5337),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5337),
    [sym__newline] = ACTIONS(5337),
    [sym__raw_string_literal] = ACTIONS(5337),
    [sym__external_else] = ACTIONS(5337),
    [sym__external_open_parenthesis] = ACTIONS(6151),
    [sym__external_open_brace] = ACTIONS(5337),
    [sym__external_open_bracket] = ACTIONS(6153),
    [sym__external_open_bracket2] = ACTIONS(6155),
    [sym__external_close_bracket2] = ACTIONS(5337),
  },
  [1532] = {
    [sym_function_definition] = STATE(1931),
    [sym_if_statement] = STATE(1931),
    [sym_for_statement] = STATE(1931),
    [sym_while_statement] = STATE(1931),
    [sym_repeat_statement] = STATE(1931),
    [sym_braced_expression] = STATE(1931),
    [sym_parenthesized_expression] = STATE(1931),
    [sym_call] = STATE(1931),
    [sym_subset] = STATE(1931),
    [sym_subset2] = STATE(1931),
    [sym__argument] = STATE(4656),
    [sym_argument] = STATE(4657),
    [sym__argument_named] = STATE(4658),
    [sym__argument_unnamed] = STATE(4662),
    [sym__argument_value] = STATE(4663),
    [sym_unary_operator] = STATE(1931),
    [sym_binary_operator] = STATE(1931),
    [sym_extract_operator] = STATE(1931),
    [sym_namespace_operator] = STATE(1931),
    [sym_integer] = STATE(1931),
    [sym_complex] = STATE(1931),
    [sym_float] = STATE(1931),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2633),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(1931),
    [sym__expression] = STATE(1931),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__close_parenthesis] = STATE(2421),
    [sym__open_brace] = STATE(154),
    [aux_sym_call_arguments_repeat1] = STATE(2113),
    [sym_identifier] = ACTIONS(6387),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(6389),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3865),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(6391),
    [sym_next] = ACTIONS(6391),
    [sym_break] = ACTIONS(6391),
    [sym_true] = ACTIONS(6391),
    [sym_false] = ACTIONS(6391),
    [sym_null] = ACTIONS(6391),
    [sym_inf] = ACTIONS(6391),
    [sym_nan] = ACTIONS(6391),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(6393),
    [sym_dot_dot_i] = ACTIONS(6395),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6397),
    [sym__newline] = ACTIONS(6399),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(6685),
    [sym__external_open_brace] = ACTIONS(3891),
  },
  [1533] = {
    [sym_function_definition] = STATE(1940),
    [sym_if_statement] = STATE(1940),
    [sym_for_statement] = STATE(1940),
    [sym_while_statement] = STATE(1940),
    [sym_repeat_statement] = STATE(1940),
    [sym_braced_expression] = STATE(1940),
    [sym_parenthesized_expression] = STATE(1940),
    [sym_call] = STATE(1940),
    [sym_subset] = STATE(1940),
    [sym_subset2] = STATE(1940),
    [sym__argument] = STATE(4665),
    [sym_argument] = STATE(4661),
    [sym__argument_named] = STATE(4669),
    [sym__argument_unnamed] = STATE(4673),
    [sym__argument_value] = STATE(4679),
    [sym_unary_operator] = STATE(1940),
    [sym_binary_operator] = STATE(1940),
    [sym_extract_operator] = STATE(1940),
    [sym_namespace_operator] = STATE(1940),
    [sym_integer] = STATE(1940),
    [sym_complex] = STATE(1940),
    [sym_float] = STATE(1940),
    [sym__hex_literal] = STATE(2656),
    [sym__float_literal] = STATE(2656),
    [sym_string] = STATE(2606),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym_na] = STATE(1940),
    [sym__expression] = STATE(1940),
    [sym__string_or_identifier] = STATE(5141),
    [sym__open_parenthesis] = STATE(218),
    [sym__open_brace] = STATE(185),
    [sym__close_bracket2] = STATE(2721),
    [aux_sym_call_arguments_repeat1] = STATE(1873),
    [sym_identifier] = ACTIONS(6369),
    [anon_sym_BSLASH] = ACTIONS(4644),
    [anon_sym_function] = ACTIONS(4646),
    [anon_sym_if] = ACTIONS(4648),
    [anon_sym_for] = ACTIONS(4650),
    [anon_sym_while] = ACTIONS(4652),
    [anon_sym_repeat] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(6371),
    [anon_sym_PLUS] = ACTIONS(4662),
    [anon_sym_DASH] = ACTIONS(4662),
    [aux_sym__hex_literal_token1] = ACTIONS(4666),
    [sym__number_literal] = ACTIONS(4668),
    [anon_sym_SQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4672),
    [sym_return] = ACTIONS(6373),
    [sym_next] = ACTIONS(6373),
    [sym_break] = ACTIONS(6373),
    [sym_true] = ACTIONS(6373),
    [sym_false] = ACTIONS(6373),
    [sym_null] = ACTIONS(6373),
    [sym_inf] = ACTIONS(6373),
    [sym_nan] = ACTIONS(6373),
    [anon_sym_NA] = ACTIONS(4676),
    [anon_sym_NA_integer_] = ACTIONS(4676),
    [anon_sym_NA_real_] = ACTIONS(4676),
    [anon_sym_NA_complex_] = ACTIONS(4676),
    [anon_sym_NA_character_] = ACTIONS(4676),
    [sym_dots] = ACTIONS(6375),
    [sym_dot_dot_i] = ACTIONS(6377),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6379),
    [sym__newline] = ACTIONS(6381),
    [sym__raw_string_literal] = ACTIONS(4680),
    [sym__external_open_parenthesis] = ACTIONS(4682),
    [sym__external_open_brace] = ACTIONS(4684),
    [sym__external_close_bracket2] = ACTIONS(6687),
  },
  [1534] = {
    [sym_function_definition] = STATE(2038),
    [sym_if_statement] = STATE(2038),
    [sym_for_statement] = STATE(2038),
    [sym_while_statement] = STATE(2038),
    [sym_repeat_statement] = STATE(2038),
    [sym_braced_expression] = STATE(2038),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_call] = STATE(2038),
    [sym_subset] = STATE(2038),
    [sym_subset2] = STATE(2038),
    [sym__argument] = STATE(4664),
    [sym_argument] = STATE(4659),
    [sym__argument_named] = STATE(4654),
    [sym__argument_unnamed] = STATE(4676),
    [sym__argument_value] = STATE(4677),
    [sym_unary_operator] = STATE(2038),
    [sym_binary_operator] = STATE(2038),
    [sym_extract_operator] = STATE(2038),
    [sym_namespace_operator] = STATE(2038),
    [sym_integer] = STATE(2038),
    [sym_complex] = STATE(2038),
    [sym_float] = STATE(2038),
    [sym__hex_literal] = STATE(2700),
    [sym__float_literal] = STATE(2700),
    [sym_string] = STATE(2597),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym_na] = STATE(2038),
    [sym__expression] = STATE(2038),
    [sym__string_or_identifier] = STATE(5148),
    [sym__open_parenthesis] = STATE(214),
    [sym__open_brace] = STATE(192),
    [sym__close_bracket] = STATE(2725),
    [aux_sym_call_arguments_repeat1] = STATE(1871),
    [sym_identifier] = ACTIONS(6351),
    [anon_sym_BSLASH] = ACTIONS(4754),
    [anon_sym_function] = ACTIONS(4756),
    [anon_sym_if] = ACTIONS(4758),
    [anon_sym_for] = ACTIONS(4760),
    [anon_sym_while] = ACTIONS(4762),
    [anon_sym_repeat] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4766),
    [anon_sym_TILDE] = ACTIONS(4768),
    [anon_sym_BANG] = ACTIONS(6353),
    [anon_sym_PLUS] = ACTIONS(4772),
    [anon_sym_DASH] = ACTIONS(4772),
    [aux_sym__hex_literal_token1] = ACTIONS(4776),
    [sym__number_literal] = ACTIONS(4778),
    [anon_sym_SQUOTE] = ACTIONS(4780),
    [anon_sym_DQUOTE] = ACTIONS(4782),
    [sym_return] = ACTIONS(6355),
    [sym_next] = ACTIONS(6355),
    [sym_break] = ACTIONS(6355),
    [sym_true] = ACTIONS(6355),
    [sym_false] = ACTIONS(6355),
    [sym_null] = ACTIONS(6355),
    [sym_inf] = ACTIONS(6355),
    [sym_nan] = ACTIONS(6355),
    [anon_sym_NA] = ACTIONS(4786),
    [anon_sym_NA_integer_] = ACTIONS(4786),
    [anon_sym_NA_real_] = ACTIONS(4786),
    [anon_sym_NA_complex_] = ACTIONS(4786),
    [anon_sym_NA_character_] = ACTIONS(4786),
    [sym_dots] = ACTIONS(6357),
    [sym_dot_dot_i] = ACTIONS(6359),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6361),
    [sym__newline] = ACTIONS(6363),
    [sym__raw_string_literal] = ACTIONS(4790),
    [sym__external_open_parenthesis] = ACTIONS(4792),
    [sym__external_open_brace] = ACTIONS(4794),
    [sym__external_close_bracket] = ACTIONS(6689),
  },
  [1535] = {
    [sym_call_arguments] = STATE(2777),
    [sym_subset_arguments] = STATE(2779),
    [sym_subset2_arguments] = STATE(2786),
    [sym__open_parenthesis] = STATE(1411),
    [sym__open_bracket] = STATE(1409),
    [sym__open_bracket2] = STATE(1407),
    [ts_builtin_sym_end] = ACTIONS(5333),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(6497),
    [anon_sym_DASH] = ACTIONS(6499),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(6507),
    [anon_sym_AMP] = ACTIONS(6509),
    [anon_sym_PIPE_PIPE] = ACTIONS(6511),
    [anon_sym_AMP_AMP] = ACTIONS(6513),
    [anon_sym_LT] = ACTIONS(6515),
    [anon_sym_LT_EQ] = ACTIONS(6517),
    [anon_sym_GT] = ACTIONS(6515),
    [anon_sym_GT_EQ] = ACTIONS(6517),
    [anon_sym_EQ_EQ] = ACTIONS(6517),
    [anon_sym_BANG_EQ] = ACTIONS(6517),
    [anon_sym_STAR] = ACTIONS(6519),
    [anon_sym_SLASH] = ACTIONS(6521),
    [anon_sym_STAR_STAR] = ACTIONS(6523),
    [anon_sym_CARET] = ACTIONS(6523),
    [aux_sym_binary_operator_token1] = ACTIONS(6525),
    [anon_sym_PIPE_GT] = ACTIONS(6525),
    [anon_sym_COLON] = ACTIONS(6527),
    [anon_sym_DOLLAR] = ACTIONS(6529),
    [anon_sym_AT] = ACTIONS(6529),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5333),
    [sym__semicolon] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(6531),
    [sym__external_close_parenthesis] = ACTIONS(5333),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(6533),
    [sym__external_open_bracket2] = ACTIONS(6535),
  },
  [1536] = {
    [sym_function_definition] = STATE(1940),
    [sym_if_statement] = STATE(1940),
    [sym_for_statement] = STATE(1940),
    [sym_while_statement] = STATE(1940),
    [sym_repeat_statement] = STATE(1940),
    [sym_braced_expression] = STATE(1940),
    [sym_parenthesized_expression] = STATE(1940),
    [sym_call] = STATE(1940),
    [sym_subset] = STATE(1940),
    [sym_subset2] = STATE(1940),
    [sym__argument] = STATE(4665),
    [sym_argument] = STATE(4661),
    [sym__argument_named] = STATE(4669),
    [sym__argument_unnamed] = STATE(4673),
    [sym__argument_value] = STATE(4679),
    [sym_unary_operator] = STATE(1940),
    [sym_binary_operator] = STATE(1940),
    [sym_extract_operator] = STATE(1940),
    [sym_namespace_operator] = STATE(1940),
    [sym_integer] = STATE(1940),
    [sym_complex] = STATE(1940),
    [sym_float] = STATE(1940),
    [sym__hex_literal] = STATE(2656),
    [sym__float_literal] = STATE(2656),
    [sym_string] = STATE(2606),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym_na] = STATE(1940),
    [sym__expression] = STATE(1940),
    [sym__string_or_identifier] = STATE(5141),
    [sym__open_parenthesis] = STATE(218),
    [sym__open_brace] = STATE(185),
    [sym__close_bracket2] = STATE(2350),
    [aux_sym_call_arguments_repeat1] = STATE(1912),
    [sym_identifier] = ACTIONS(6369),
    [anon_sym_BSLASH] = ACTIONS(4644),
    [anon_sym_function] = ACTIONS(4646),
    [anon_sym_if] = ACTIONS(4648),
    [anon_sym_for] = ACTIONS(4650),
    [anon_sym_while] = ACTIONS(4652),
    [anon_sym_repeat] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(6371),
    [anon_sym_PLUS] = ACTIONS(4662),
    [anon_sym_DASH] = ACTIONS(4662),
    [aux_sym__hex_literal_token1] = ACTIONS(4666),
    [sym__number_literal] = ACTIONS(4668),
    [anon_sym_SQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4672),
    [sym_return] = ACTIONS(6373),
    [sym_next] = ACTIONS(6373),
    [sym_break] = ACTIONS(6373),
    [sym_true] = ACTIONS(6373),
    [sym_false] = ACTIONS(6373),
    [sym_null] = ACTIONS(6373),
    [sym_inf] = ACTIONS(6373),
    [sym_nan] = ACTIONS(6373),
    [anon_sym_NA] = ACTIONS(4676),
    [anon_sym_NA_integer_] = ACTIONS(4676),
    [anon_sym_NA_real_] = ACTIONS(4676),
    [anon_sym_NA_complex_] = ACTIONS(4676),
    [anon_sym_NA_character_] = ACTIONS(4676),
    [sym_dots] = ACTIONS(6375),
    [sym_dot_dot_i] = ACTIONS(6377),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6379),
    [sym__newline] = ACTIONS(6381),
    [sym__raw_string_literal] = ACTIONS(4680),
    [sym__external_open_parenthesis] = ACTIONS(4682),
    [sym__external_open_brace] = ACTIONS(4684),
    [sym__external_close_bracket2] = ACTIONS(6691),
  },
  [1537] = {
    [sym_function_definition] = STATE(1931),
    [sym_if_statement] = STATE(1931),
    [sym_for_statement] = STATE(1931),
    [sym_while_statement] = STATE(1931),
    [sym_repeat_statement] = STATE(1931),
    [sym_braced_expression] = STATE(1931),
    [sym_parenthesized_expression] = STATE(1931),
    [sym_call] = STATE(1931),
    [sym_subset] = STATE(1931),
    [sym_subset2] = STATE(1931),
    [sym__argument] = STATE(4656),
    [sym_argument] = STATE(4657),
    [sym__argument_named] = STATE(4658),
    [sym__argument_unnamed] = STATE(4662),
    [sym__argument_value] = STATE(4663),
    [sym_unary_operator] = STATE(1931),
    [sym_binary_operator] = STATE(1931),
    [sym_extract_operator] = STATE(1931),
    [sym_namespace_operator] = STATE(1931),
    [sym_integer] = STATE(1931),
    [sym_complex] = STATE(1931),
    [sym_float] = STATE(1931),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2633),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(1931),
    [sym__expression] = STATE(1931),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__close_parenthesis] = STATE(2726),
    [sym__open_brace] = STATE(154),
    [aux_sym_call_arguments_repeat1] = STATE(1559),
    [sym_identifier] = ACTIONS(6387),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(6389),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3865),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(6391),
    [sym_next] = ACTIONS(6391),
    [sym_break] = ACTIONS(6391),
    [sym_true] = ACTIONS(6391),
    [sym_false] = ACTIONS(6391),
    [sym_null] = ACTIONS(6391),
    [sym_inf] = ACTIONS(6391),
    [sym_nan] = ACTIONS(6391),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(6393),
    [sym_dot_dot_i] = ACTIONS(6395),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6397),
    [sym__newline] = ACTIONS(6399),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(6693),
    [sym__external_open_brace] = ACTIONS(3891),
  },
  [1538] = {
    [sym_function_definition] = STATE(1931),
    [sym_if_statement] = STATE(1931),
    [sym_for_statement] = STATE(1931),
    [sym_while_statement] = STATE(1931),
    [sym_repeat_statement] = STATE(1931),
    [sym_braced_expression] = STATE(1931),
    [sym_parenthesized_expression] = STATE(1931),
    [sym_call] = STATE(1931),
    [sym_subset] = STATE(1931),
    [sym_subset2] = STATE(1931),
    [sym__argument] = STATE(4656),
    [sym_argument] = STATE(4657),
    [sym__argument_named] = STATE(4658),
    [sym__argument_unnamed] = STATE(4662),
    [sym__argument_value] = STATE(4663),
    [sym_unary_operator] = STATE(1931),
    [sym_binary_operator] = STATE(1931),
    [sym_extract_operator] = STATE(1931),
    [sym_namespace_operator] = STATE(1931),
    [sym_integer] = STATE(1931),
    [sym_complex] = STATE(1931),
    [sym_float] = STATE(1931),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2633),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(1931),
    [sym__expression] = STATE(1931),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__close_parenthesis] = STATE(2417),
    [sym__open_brace] = STATE(154),
    [aux_sym_call_arguments_repeat1] = STATE(2113),
    [sym_identifier] = ACTIONS(6387),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(6389),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3865),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(6391),
    [sym_next] = ACTIONS(6391),
    [sym_break] = ACTIONS(6391),
    [sym_true] = ACTIONS(6391),
    [sym_false] = ACTIONS(6391),
    [sym_null] = ACTIONS(6391),
    [sym_inf] = ACTIONS(6391),
    [sym_nan] = ACTIONS(6391),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(6393),
    [sym_dot_dot_i] = ACTIONS(6395),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6397),
    [sym__newline] = ACTIONS(6399),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(6695),
    [sym__external_open_brace] = ACTIONS(3891),
  },
  [1539] = {
    [sym_function_definition] = STATE(1940),
    [sym_if_statement] = STATE(1940),
    [sym_for_statement] = STATE(1940),
    [sym_while_statement] = STATE(1940),
    [sym_repeat_statement] = STATE(1940),
    [sym_braced_expression] = STATE(1940),
    [sym_parenthesized_expression] = STATE(1940),
    [sym_call] = STATE(1940),
    [sym_subset] = STATE(1940),
    [sym_subset2] = STATE(1940),
    [sym__argument] = STATE(4665),
    [sym_argument] = STATE(4661),
    [sym__argument_named] = STATE(4669),
    [sym__argument_unnamed] = STATE(4673),
    [sym__argument_value] = STATE(4679),
    [sym_unary_operator] = STATE(1940),
    [sym_binary_operator] = STATE(1940),
    [sym_extract_operator] = STATE(1940),
    [sym_namespace_operator] = STATE(1940),
    [sym_integer] = STATE(1940),
    [sym_complex] = STATE(1940),
    [sym_float] = STATE(1940),
    [sym__hex_literal] = STATE(2656),
    [sym__float_literal] = STATE(2656),
    [sym_string] = STATE(2606),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym_na] = STATE(1940),
    [sym__expression] = STATE(1940),
    [sym__string_or_identifier] = STATE(5141),
    [sym__open_parenthesis] = STATE(218),
    [sym__open_brace] = STATE(185),
    [sym__close_bracket2] = STATE(2788),
    [aux_sym_call_arguments_repeat1] = STATE(1722),
    [sym_identifier] = ACTIONS(6369),
    [anon_sym_BSLASH] = ACTIONS(4644),
    [anon_sym_function] = ACTIONS(4646),
    [anon_sym_if] = ACTIONS(4648),
    [anon_sym_for] = ACTIONS(4650),
    [anon_sym_while] = ACTIONS(4652),
    [anon_sym_repeat] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(6371),
    [anon_sym_PLUS] = ACTIONS(4662),
    [anon_sym_DASH] = ACTIONS(4662),
    [aux_sym__hex_literal_token1] = ACTIONS(4666),
    [sym__number_literal] = ACTIONS(4668),
    [anon_sym_SQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4672),
    [sym_return] = ACTIONS(6373),
    [sym_next] = ACTIONS(6373),
    [sym_break] = ACTIONS(6373),
    [sym_true] = ACTIONS(6373),
    [sym_false] = ACTIONS(6373),
    [sym_null] = ACTIONS(6373),
    [sym_inf] = ACTIONS(6373),
    [sym_nan] = ACTIONS(6373),
    [anon_sym_NA] = ACTIONS(4676),
    [anon_sym_NA_integer_] = ACTIONS(4676),
    [anon_sym_NA_real_] = ACTIONS(4676),
    [anon_sym_NA_complex_] = ACTIONS(4676),
    [anon_sym_NA_character_] = ACTIONS(4676),
    [sym_dots] = ACTIONS(6375),
    [sym_dot_dot_i] = ACTIONS(6377),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6379),
    [sym__newline] = ACTIONS(6381),
    [sym__raw_string_literal] = ACTIONS(4680),
    [sym__external_open_parenthesis] = ACTIONS(4682),
    [sym__external_open_brace] = ACTIONS(4684),
    [sym__external_close_bracket2] = ACTIONS(6697),
  },
  [1540] = {
    [sym_call_arguments] = STATE(2870),
    [sym_subset_arguments] = STATE(2869),
    [sym_subset2_arguments] = STATE(2867),
    [sym__open_parenthesis] = STATE(1362),
    [sym__open_bracket] = STATE(1361),
    [sym__open_bracket2] = STATE(1360),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(5333),
    [anon_sym_DASH] = ACTIONS(5335),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5335),
    [anon_sym_AMP] = ACTIONS(5335),
    [anon_sym_PIPE_PIPE] = ACTIONS(5333),
    [anon_sym_AMP_AMP] = ACTIONS(5333),
    [anon_sym_LT] = ACTIONS(5335),
    [anon_sym_LT_EQ] = ACTIONS(5333),
    [anon_sym_GT] = ACTIONS(5335),
    [anon_sym_GT_EQ] = ACTIONS(5333),
    [anon_sym_EQ_EQ] = ACTIONS(5333),
    [anon_sym_BANG_EQ] = ACTIONS(5333),
    [anon_sym_STAR] = ACTIONS(5335),
    [anon_sym_SLASH] = ACTIONS(5333),
    [anon_sym_STAR_STAR] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6141),
    [aux_sym_binary_operator_token1] = ACTIONS(5333),
    [anon_sym_PIPE_GT] = ACTIONS(5333),
    [anon_sym_COLON] = ACTIONS(5335),
    [anon_sym_DOLLAR] = ACTIONS(6147),
    [anon_sym_AT] = ACTIONS(6147),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_else] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(6151),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(6153),
    [sym__external_open_bracket2] = ACTIONS(6155),
    [sym__external_close_bracket2] = ACTIONS(5333),
  },
  [1541] = {
    [sym_function_definition] = STATE(2038),
    [sym_if_statement] = STATE(2038),
    [sym_for_statement] = STATE(2038),
    [sym_while_statement] = STATE(2038),
    [sym_repeat_statement] = STATE(2038),
    [sym_braced_expression] = STATE(2038),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_call] = STATE(2038),
    [sym_subset] = STATE(2038),
    [sym_subset2] = STATE(2038),
    [sym__argument] = STATE(4664),
    [sym_argument] = STATE(4659),
    [sym__argument_named] = STATE(4654),
    [sym__argument_unnamed] = STATE(4676),
    [sym__argument_value] = STATE(4677),
    [sym_unary_operator] = STATE(2038),
    [sym_binary_operator] = STATE(2038),
    [sym_extract_operator] = STATE(2038),
    [sym_namespace_operator] = STATE(2038),
    [sym_integer] = STATE(2038),
    [sym_complex] = STATE(2038),
    [sym_float] = STATE(2038),
    [sym__hex_literal] = STATE(2700),
    [sym__float_literal] = STATE(2700),
    [sym_string] = STATE(2597),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym_na] = STATE(2038),
    [sym__expression] = STATE(2038),
    [sym__string_or_identifier] = STATE(5148),
    [sym__open_parenthesis] = STATE(214),
    [sym__open_brace] = STATE(192),
    [sym__close_bracket] = STATE(2791),
    [aux_sym_call_arguments_repeat1] = STATE(1720),
    [sym_identifier] = ACTIONS(6351),
    [anon_sym_BSLASH] = ACTIONS(4754),
    [anon_sym_function] = ACTIONS(4756),
    [anon_sym_if] = ACTIONS(4758),
    [anon_sym_for] = ACTIONS(4760),
    [anon_sym_while] = ACTIONS(4762),
    [anon_sym_repeat] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4766),
    [anon_sym_TILDE] = ACTIONS(4768),
    [anon_sym_BANG] = ACTIONS(6353),
    [anon_sym_PLUS] = ACTIONS(4772),
    [anon_sym_DASH] = ACTIONS(4772),
    [aux_sym__hex_literal_token1] = ACTIONS(4776),
    [sym__number_literal] = ACTIONS(4778),
    [anon_sym_SQUOTE] = ACTIONS(4780),
    [anon_sym_DQUOTE] = ACTIONS(4782),
    [sym_return] = ACTIONS(6355),
    [sym_next] = ACTIONS(6355),
    [sym_break] = ACTIONS(6355),
    [sym_true] = ACTIONS(6355),
    [sym_false] = ACTIONS(6355),
    [sym_null] = ACTIONS(6355),
    [sym_inf] = ACTIONS(6355),
    [sym_nan] = ACTIONS(6355),
    [anon_sym_NA] = ACTIONS(4786),
    [anon_sym_NA_integer_] = ACTIONS(4786),
    [anon_sym_NA_real_] = ACTIONS(4786),
    [anon_sym_NA_complex_] = ACTIONS(4786),
    [anon_sym_NA_character_] = ACTIONS(4786),
    [sym_dots] = ACTIONS(6357),
    [sym_dot_dot_i] = ACTIONS(6359),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6361),
    [sym__newline] = ACTIONS(6363),
    [sym__raw_string_literal] = ACTIONS(4790),
    [sym__external_open_parenthesis] = ACTIONS(4792),
    [sym__external_open_brace] = ACTIONS(4794),
    [sym__external_close_bracket] = ACTIONS(6699),
  },
  [1542] = {
    [sym_call_arguments] = STATE(2870),
    [sym_subset_arguments] = STATE(2869),
    [sym_subset2_arguments] = STATE(2867),
    [sym__open_parenthesis] = STATE(1362),
    [sym__open_bracket] = STATE(1361),
    [sym__open_bracket2] = STATE(1360),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(6115),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5335),
    [anon_sym_AMP] = ACTIONS(5335),
    [anon_sym_PIPE_PIPE] = ACTIONS(5333),
    [anon_sym_AMP_AMP] = ACTIONS(5333),
    [anon_sym_LT] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6135),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_GT_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(6135),
    [anon_sym_STAR] = ACTIONS(6137),
    [anon_sym_SLASH] = ACTIONS(6139),
    [anon_sym_STAR_STAR] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6141),
    [aux_sym_binary_operator_token1] = ACTIONS(6143),
    [anon_sym_PIPE_GT] = ACTIONS(6143),
    [anon_sym_COLON] = ACTIONS(6145),
    [anon_sym_DOLLAR] = ACTIONS(6147),
    [anon_sym_AT] = ACTIONS(6147),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_else] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(6151),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(6153),
    [sym__external_open_bracket2] = ACTIONS(6155),
    [sym__external_close_bracket2] = ACTIONS(5333),
  },
  [1543] = {
    [sym_function_definition] = STATE(2038),
    [sym_if_statement] = STATE(2038),
    [sym_for_statement] = STATE(2038),
    [sym_while_statement] = STATE(2038),
    [sym_repeat_statement] = STATE(2038),
    [sym_braced_expression] = STATE(2038),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_call] = STATE(2038),
    [sym_subset] = STATE(2038),
    [sym_subset2] = STATE(2038),
    [sym__argument] = STATE(4664),
    [sym_argument] = STATE(4659),
    [sym__argument_named] = STATE(4654),
    [sym__argument_unnamed] = STATE(4676),
    [sym__argument_value] = STATE(4677),
    [sym_unary_operator] = STATE(2038),
    [sym_binary_operator] = STATE(2038),
    [sym_extract_operator] = STATE(2038),
    [sym_namespace_operator] = STATE(2038),
    [sym_integer] = STATE(2038),
    [sym_complex] = STATE(2038),
    [sym_float] = STATE(2038),
    [sym__hex_literal] = STATE(2700),
    [sym__float_literal] = STATE(2700),
    [sym_string] = STATE(2597),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym_na] = STATE(2038),
    [sym__expression] = STATE(2038),
    [sym__string_or_identifier] = STATE(5148),
    [sym__open_parenthesis] = STATE(214),
    [sym__open_brace] = STATE(192),
    [sym__close_bracket] = STATE(2230),
    [aux_sym_call_arguments_repeat1] = STATE(2034),
    [sym_identifier] = ACTIONS(6351),
    [anon_sym_BSLASH] = ACTIONS(4754),
    [anon_sym_function] = ACTIONS(4756),
    [anon_sym_if] = ACTIONS(4758),
    [anon_sym_for] = ACTIONS(4760),
    [anon_sym_while] = ACTIONS(4762),
    [anon_sym_repeat] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4766),
    [anon_sym_TILDE] = ACTIONS(4768),
    [anon_sym_BANG] = ACTIONS(6353),
    [anon_sym_PLUS] = ACTIONS(4772),
    [anon_sym_DASH] = ACTIONS(4772),
    [aux_sym__hex_literal_token1] = ACTIONS(4776),
    [sym__number_literal] = ACTIONS(4778),
    [anon_sym_SQUOTE] = ACTIONS(4780),
    [anon_sym_DQUOTE] = ACTIONS(4782),
    [sym_return] = ACTIONS(6355),
    [sym_next] = ACTIONS(6355),
    [sym_break] = ACTIONS(6355),
    [sym_true] = ACTIONS(6355),
    [sym_false] = ACTIONS(6355),
    [sym_null] = ACTIONS(6355),
    [sym_inf] = ACTIONS(6355),
    [sym_nan] = ACTIONS(6355),
    [anon_sym_NA] = ACTIONS(4786),
    [anon_sym_NA_integer_] = ACTIONS(4786),
    [anon_sym_NA_real_] = ACTIONS(4786),
    [anon_sym_NA_complex_] = ACTIONS(4786),
    [anon_sym_NA_character_] = ACTIONS(4786),
    [sym_dots] = ACTIONS(6357),
    [sym_dot_dot_i] = ACTIONS(6359),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6361),
    [sym__newline] = ACTIONS(6363),
    [sym__raw_string_literal] = ACTIONS(4790),
    [sym__external_open_parenthesis] = ACTIONS(4792),
    [sym__external_open_brace] = ACTIONS(4794),
    [sym__external_close_bracket] = ACTIONS(6701),
  },
  [1544] = {
    [sym_call_arguments] = STATE(2870),
    [sym_subset_arguments] = STATE(2869),
    [sym_subset2_arguments] = STATE(2867),
    [sym__open_parenthesis] = STATE(1362),
    [sym__open_bracket] = STATE(1361),
    [sym__open_bracket2] = STATE(1360),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(6115),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(6125),
    [anon_sym_AMP] = ACTIONS(6127),
    [anon_sym_PIPE_PIPE] = ACTIONS(6129),
    [anon_sym_AMP_AMP] = ACTIONS(6131),
    [anon_sym_LT] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6135),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_GT_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(6135),
    [anon_sym_STAR] = ACTIONS(6137),
    [anon_sym_SLASH] = ACTIONS(6139),
    [anon_sym_STAR_STAR] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6141),
    [aux_sym_binary_operator_token1] = ACTIONS(6143),
    [anon_sym_PIPE_GT] = ACTIONS(6143),
    [anon_sym_COLON] = ACTIONS(6145),
    [anon_sym_DOLLAR] = ACTIONS(6147),
    [anon_sym_AT] = ACTIONS(6147),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_else] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(6151),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(6153),
    [sym__external_open_bracket2] = ACTIONS(6155),
    [sym__external_close_bracket2] = ACTIONS(5333),
  },
  [1545] = {
    [sym_function_definition] = STATE(1931),
    [sym_if_statement] = STATE(1931),
    [sym_for_statement] = STATE(1931),
    [sym_while_statement] = STATE(1931),
    [sym_repeat_statement] = STATE(1931),
    [sym_braced_expression] = STATE(1931),
    [sym_parenthesized_expression] = STATE(1931),
    [sym_call] = STATE(1931),
    [sym_subset] = STATE(1931),
    [sym_subset2] = STATE(1931),
    [sym__argument] = STATE(4656),
    [sym_argument] = STATE(4657),
    [sym__argument_named] = STATE(4658),
    [sym__argument_unnamed] = STATE(4662),
    [sym__argument_value] = STATE(4663),
    [sym_unary_operator] = STATE(1931),
    [sym_binary_operator] = STATE(1931),
    [sym_extract_operator] = STATE(1931),
    [sym_namespace_operator] = STATE(1931),
    [sym_integer] = STATE(1931),
    [sym_complex] = STATE(1931),
    [sym_float] = STATE(1931),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2633),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(1931),
    [sym__expression] = STATE(1931),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__close_parenthesis] = STATE(2804),
    [sym__open_brace] = STATE(154),
    [aux_sym_call_arguments_repeat1] = STATE(1587),
    [sym_identifier] = ACTIONS(6387),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(6389),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3865),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(6391),
    [sym_next] = ACTIONS(6391),
    [sym_break] = ACTIONS(6391),
    [sym_true] = ACTIONS(6391),
    [sym_false] = ACTIONS(6391),
    [sym_null] = ACTIONS(6391),
    [sym_inf] = ACTIONS(6391),
    [sym_nan] = ACTIONS(6391),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(6393),
    [sym_dot_dot_i] = ACTIONS(6395),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6397),
    [sym__newline] = ACTIONS(6399),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(6703),
    [sym__external_open_brace] = ACTIONS(3891),
  },
  [1546] = {
    [sym_call_arguments] = STATE(2870),
    [sym_subset_arguments] = STATE(2869),
    [sym_subset2_arguments] = STATE(2867),
    [sym__open_parenthesis] = STATE(1362),
    [sym__open_bracket] = STATE(1361),
    [sym__open_bracket2] = STATE(1360),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(6111),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(6113),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(6115),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_LT_DASH] = ACTIONS(6119),
    [anon_sym_LT_LT_DASH] = ACTIONS(6119),
    [anon_sym_COLON_EQ] = ACTIONS(6119),
    [anon_sym_DASH_GT] = ACTIONS(6121),
    [anon_sym_DASH_GT_GT] = ACTIONS(6123),
    [anon_sym_PIPE] = ACTIONS(6125),
    [anon_sym_AMP] = ACTIONS(6127),
    [anon_sym_PIPE_PIPE] = ACTIONS(6129),
    [anon_sym_AMP_AMP] = ACTIONS(6131),
    [anon_sym_LT] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6135),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_GT_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(6135),
    [anon_sym_STAR] = ACTIONS(6137),
    [anon_sym_SLASH] = ACTIONS(6139),
    [anon_sym_STAR_STAR] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6141),
    [aux_sym_binary_operator_token1] = ACTIONS(6143),
    [anon_sym_PIPE_GT] = ACTIONS(6143),
    [anon_sym_COLON] = ACTIONS(6145),
    [anon_sym_DOLLAR] = ACTIONS(6147),
    [anon_sym_AT] = ACTIONS(6147),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_else] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(6151),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(6153),
    [sym__external_open_bracket2] = ACTIONS(6155),
    [sym__external_close_bracket2] = ACTIONS(5333),
  },
  [1547] = {
    [sym_function_definition] = STATE(1931),
    [sym_if_statement] = STATE(1931),
    [sym_for_statement] = STATE(1931),
    [sym_while_statement] = STATE(1931),
    [sym_repeat_statement] = STATE(1931),
    [sym_braced_expression] = STATE(1931),
    [sym_parenthesized_expression] = STATE(1931),
    [sym_call] = STATE(1931),
    [sym_subset] = STATE(1931),
    [sym_subset2] = STATE(1931),
    [sym__argument] = STATE(4656),
    [sym_argument] = STATE(4657),
    [sym__argument_named] = STATE(4658),
    [sym__argument_unnamed] = STATE(4662),
    [sym__argument_value] = STATE(4663),
    [sym_unary_operator] = STATE(1931),
    [sym_binary_operator] = STATE(1931),
    [sym_extract_operator] = STATE(1931),
    [sym_namespace_operator] = STATE(1931),
    [sym_integer] = STATE(1931),
    [sym_complex] = STATE(1931),
    [sym_float] = STATE(1931),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2633),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(1931),
    [sym__expression] = STATE(1931),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__close_parenthesis] = STATE(2792),
    [sym__open_brace] = STATE(154),
    [aux_sym_call_arguments_repeat1] = STATE(2113),
    [sym_identifier] = ACTIONS(6387),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(6389),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3865),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(6391),
    [sym_next] = ACTIONS(6391),
    [sym_break] = ACTIONS(6391),
    [sym_true] = ACTIONS(6391),
    [sym_false] = ACTIONS(6391),
    [sym_null] = ACTIONS(6391),
    [sym_inf] = ACTIONS(6391),
    [sym_nan] = ACTIONS(6391),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(6393),
    [sym_dot_dot_i] = ACTIONS(6395),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6397),
    [sym__newline] = ACTIONS(6399),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(6705),
    [sym__external_open_brace] = ACTIONS(3891),
  },
  [1548] = {
    [sym_call_arguments] = STATE(2870),
    [sym_subset_arguments] = STATE(2869),
    [sym_subset2_arguments] = STATE(2867),
    [sym__open_parenthesis] = STATE(1362),
    [sym__open_bracket] = STATE(1361),
    [sym__open_bracket2] = STATE(1360),
    [sym_identifier] = ACTIONS(5331),
    [anon_sym_BSLASH] = ACTIONS(5329),
    [anon_sym_function] = ACTIONS(5331),
    [anon_sym_EQ] = ACTIONS(6111),
    [anon_sym_if] = ACTIONS(5331),
    [anon_sym_for] = ACTIONS(5331),
    [anon_sym_while] = ACTIONS(5331),
    [anon_sym_repeat] = ACTIONS(5331),
    [anon_sym_QMARK] = ACTIONS(5329),
    [anon_sym_TILDE] = ACTIONS(6113),
    [anon_sym_BANG] = ACTIONS(5331),
    [anon_sym_PLUS] = ACTIONS(6115),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_LT_DASH] = ACTIONS(6119),
    [anon_sym_LT_LT_DASH] = ACTIONS(6119),
    [anon_sym_COLON_EQ] = ACTIONS(6119),
    [anon_sym_DASH_GT] = ACTIONS(6121),
    [anon_sym_DASH_GT_GT] = ACTIONS(6123),
    [anon_sym_PIPE] = ACTIONS(6125),
    [anon_sym_AMP] = ACTIONS(6127),
    [anon_sym_PIPE_PIPE] = ACTIONS(6129),
    [anon_sym_AMP_AMP] = ACTIONS(6131),
    [anon_sym_LT] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6135),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_GT_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(6135),
    [anon_sym_STAR] = ACTIONS(6137),
    [anon_sym_SLASH] = ACTIONS(6139),
    [anon_sym_STAR_STAR] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6141),
    [aux_sym_binary_operator_token1] = ACTIONS(6143),
    [anon_sym_PIPE_GT] = ACTIONS(6143),
    [anon_sym_COLON] = ACTIONS(6145),
    [anon_sym_DOLLAR] = ACTIONS(6147),
    [anon_sym_AT] = ACTIONS(6147),
    [aux_sym__hex_literal_token1] = ACTIONS(5329),
    [sym__number_literal] = ACTIONS(5331),
    [anon_sym_SQUOTE] = ACTIONS(5329),
    [anon_sym_DQUOTE] = ACTIONS(5329),
    [sym_return] = ACTIONS(5331),
    [sym_next] = ACTIONS(5331),
    [sym_break] = ACTIONS(5331),
    [sym_true] = ACTIONS(5331),
    [sym_false] = ACTIONS(5331),
    [sym_null] = ACTIONS(5331),
    [sym_inf] = ACTIONS(5331),
    [sym_nan] = ACTIONS(5331),
    [anon_sym_NA] = ACTIONS(5331),
    [anon_sym_NA_integer_] = ACTIONS(5331),
    [anon_sym_NA_real_] = ACTIONS(5331),
    [anon_sym_NA_complex_] = ACTIONS(5331),
    [anon_sym_NA_character_] = ACTIONS(5331),
    [sym_dots] = ACTIONS(5331),
    [sym_dot_dot_i] = ACTIONS(5329),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5329),
    [sym__newline] = ACTIONS(5329),
    [sym__raw_string_literal] = ACTIONS(5329),
    [sym__external_else] = ACTIONS(5329),
    [sym__external_open_parenthesis] = ACTIONS(6151),
    [sym__external_open_brace] = ACTIONS(5329),
    [sym__external_open_bracket] = ACTIONS(6153),
    [sym__external_open_bracket2] = ACTIONS(6155),
    [sym__external_close_bracket2] = ACTIONS(5329),
  },
  [1549] = {
    [sym_function_definition] = STATE(1940),
    [sym_if_statement] = STATE(1940),
    [sym_for_statement] = STATE(1940),
    [sym_while_statement] = STATE(1940),
    [sym_repeat_statement] = STATE(1940),
    [sym_braced_expression] = STATE(1940),
    [sym_parenthesized_expression] = STATE(1940),
    [sym_call] = STATE(1940),
    [sym_subset] = STATE(1940),
    [sym_subset2] = STATE(1940),
    [sym__argument] = STATE(4665),
    [sym_argument] = STATE(4661),
    [sym__argument_named] = STATE(4669),
    [sym__argument_unnamed] = STATE(4673),
    [sym__argument_value] = STATE(4679),
    [sym_unary_operator] = STATE(1940),
    [sym_binary_operator] = STATE(1940),
    [sym_extract_operator] = STATE(1940),
    [sym_namespace_operator] = STATE(1940),
    [sym_integer] = STATE(1940),
    [sym_complex] = STATE(1940),
    [sym_float] = STATE(1940),
    [sym__hex_literal] = STATE(2656),
    [sym__float_literal] = STATE(2656),
    [sym_string] = STATE(2606),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym_na] = STATE(1940),
    [sym__expression] = STATE(1940),
    [sym__string_or_identifier] = STATE(5141),
    [sym__open_parenthesis] = STATE(218),
    [sym__open_brace] = STATE(185),
    [sym__close_bracket2] = STATE(2613),
    [aux_sym_call_arguments_repeat1] = STATE(1571),
    [sym_identifier] = ACTIONS(6369),
    [anon_sym_BSLASH] = ACTIONS(4644),
    [anon_sym_function] = ACTIONS(4646),
    [anon_sym_if] = ACTIONS(4648),
    [anon_sym_for] = ACTIONS(4650),
    [anon_sym_while] = ACTIONS(4652),
    [anon_sym_repeat] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(6371),
    [anon_sym_PLUS] = ACTIONS(4662),
    [anon_sym_DASH] = ACTIONS(4662),
    [aux_sym__hex_literal_token1] = ACTIONS(4666),
    [sym__number_literal] = ACTIONS(4668),
    [anon_sym_SQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4672),
    [sym_return] = ACTIONS(6373),
    [sym_next] = ACTIONS(6373),
    [sym_break] = ACTIONS(6373),
    [sym_true] = ACTIONS(6373),
    [sym_false] = ACTIONS(6373),
    [sym_null] = ACTIONS(6373),
    [sym_inf] = ACTIONS(6373),
    [sym_nan] = ACTIONS(6373),
    [anon_sym_NA] = ACTIONS(4676),
    [anon_sym_NA_integer_] = ACTIONS(4676),
    [anon_sym_NA_real_] = ACTIONS(4676),
    [anon_sym_NA_complex_] = ACTIONS(4676),
    [anon_sym_NA_character_] = ACTIONS(4676),
    [sym_dots] = ACTIONS(6375),
    [sym_dot_dot_i] = ACTIONS(6377),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6379),
    [sym__newline] = ACTIONS(6381),
    [sym__raw_string_literal] = ACTIONS(4680),
    [sym__external_open_parenthesis] = ACTIONS(4682),
    [sym__external_open_brace] = ACTIONS(4684),
    [sym__external_close_bracket2] = ACTIONS(6707),
  },
  [1550] = {
    [sym_call_arguments] = STATE(2777),
    [sym_subset_arguments] = STATE(2779),
    [sym_subset2_arguments] = STATE(2786),
    [sym__open_parenthesis] = STATE(1411),
    [sym__open_bracket] = STATE(1409),
    [sym__open_bracket2] = STATE(1407),
    [ts_builtin_sym_end] = ACTIONS(5341),
    [sym_identifier] = ACTIONS(5343),
    [anon_sym_BSLASH] = ACTIONS(5341),
    [anon_sym_function] = ACTIONS(5343),
    [anon_sym_EQ] = ACTIONS(6491),
    [anon_sym_if] = ACTIONS(5343),
    [anon_sym_for] = ACTIONS(5343),
    [anon_sym_while] = ACTIONS(5343),
    [anon_sym_repeat] = ACTIONS(5343),
    [anon_sym_QMARK] = ACTIONS(5341),
    [anon_sym_TILDE] = ACTIONS(6495),
    [anon_sym_BANG] = ACTIONS(5343),
    [anon_sym_PLUS] = ACTIONS(6497),
    [anon_sym_DASH] = ACTIONS(6499),
    [anon_sym_LT_DASH] = ACTIONS(6501),
    [anon_sym_LT_LT_DASH] = ACTIONS(6501),
    [anon_sym_COLON_EQ] = ACTIONS(6501),
    [anon_sym_DASH_GT] = ACTIONS(6503),
    [anon_sym_DASH_GT_GT] = ACTIONS(6505),
    [anon_sym_PIPE] = ACTIONS(6507),
    [anon_sym_AMP] = ACTIONS(6509),
    [anon_sym_PIPE_PIPE] = ACTIONS(6511),
    [anon_sym_AMP_AMP] = ACTIONS(6513),
    [anon_sym_LT] = ACTIONS(6515),
    [anon_sym_LT_EQ] = ACTIONS(6517),
    [anon_sym_GT] = ACTIONS(6515),
    [anon_sym_GT_EQ] = ACTIONS(6517),
    [anon_sym_EQ_EQ] = ACTIONS(6517),
    [anon_sym_BANG_EQ] = ACTIONS(6517),
    [anon_sym_STAR] = ACTIONS(6519),
    [anon_sym_SLASH] = ACTIONS(6521),
    [anon_sym_STAR_STAR] = ACTIONS(6523),
    [anon_sym_CARET] = ACTIONS(6523),
    [aux_sym_binary_operator_token1] = ACTIONS(6525),
    [anon_sym_PIPE_GT] = ACTIONS(6525),
    [anon_sym_COLON] = ACTIONS(6527),
    [anon_sym_DOLLAR] = ACTIONS(6529),
    [anon_sym_AT] = ACTIONS(6529),
    [aux_sym__hex_literal_token1] = ACTIONS(5341),
    [sym__number_literal] = ACTIONS(5343),
    [anon_sym_SQUOTE] = ACTIONS(5341),
    [anon_sym_DQUOTE] = ACTIONS(5341),
    [sym_return] = ACTIONS(5343),
    [sym_next] = ACTIONS(5343),
    [sym_break] = ACTIONS(5343),
    [sym_true] = ACTIONS(5343),
    [sym_false] = ACTIONS(5343),
    [sym_null] = ACTIONS(5343),
    [sym_inf] = ACTIONS(5343),
    [sym_nan] = ACTIONS(5343),
    [anon_sym_NA] = ACTIONS(5343),
    [anon_sym_NA_integer_] = ACTIONS(5343),
    [anon_sym_NA_real_] = ACTIONS(5343),
    [anon_sym_NA_complex_] = ACTIONS(5343),
    [anon_sym_NA_character_] = ACTIONS(5343),
    [sym_dots] = ACTIONS(5343),
    [sym_dot_dot_i] = ACTIONS(5341),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5341),
    [sym__semicolon] = ACTIONS(5341),
    [sym__raw_string_literal] = ACTIONS(5341),
    [sym__external_open_parenthesis] = ACTIONS(6531),
    [sym__external_close_parenthesis] = ACTIONS(5341),
    [sym__external_open_brace] = ACTIONS(5341),
    [sym__external_open_bracket] = ACTIONS(6533),
    [sym__external_open_bracket2] = ACTIONS(6535),
  },
  [1551] = {
    [sym_function_definition] = STATE(2038),
    [sym_if_statement] = STATE(2038),
    [sym_for_statement] = STATE(2038),
    [sym_while_statement] = STATE(2038),
    [sym_repeat_statement] = STATE(2038),
    [sym_braced_expression] = STATE(2038),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_call] = STATE(2038),
    [sym_subset] = STATE(2038),
    [sym_subset2] = STATE(2038),
    [sym__argument] = STATE(4664),
    [sym_argument] = STATE(4659),
    [sym__argument_named] = STATE(4654),
    [sym__argument_unnamed] = STATE(4676),
    [sym__argument_value] = STATE(4677),
    [sym_unary_operator] = STATE(2038),
    [sym_binary_operator] = STATE(2038),
    [sym_extract_operator] = STATE(2038),
    [sym_namespace_operator] = STATE(2038),
    [sym_integer] = STATE(2038),
    [sym_complex] = STATE(2038),
    [sym_float] = STATE(2038),
    [sym__hex_literal] = STATE(2700),
    [sym__float_literal] = STATE(2700),
    [sym_string] = STATE(2597),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym_na] = STATE(2038),
    [sym__expression] = STATE(2038),
    [sym__string_or_identifier] = STATE(5148),
    [sym__open_parenthesis] = STATE(214),
    [sym__open_brace] = STATE(192),
    [sym__close_bracket] = STATE(2605),
    [aux_sym_call_arguments_repeat1] = STATE(1569),
    [sym_identifier] = ACTIONS(6351),
    [anon_sym_BSLASH] = ACTIONS(4754),
    [anon_sym_function] = ACTIONS(4756),
    [anon_sym_if] = ACTIONS(4758),
    [anon_sym_for] = ACTIONS(4760),
    [anon_sym_while] = ACTIONS(4762),
    [anon_sym_repeat] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4766),
    [anon_sym_TILDE] = ACTIONS(4768),
    [anon_sym_BANG] = ACTIONS(6353),
    [anon_sym_PLUS] = ACTIONS(4772),
    [anon_sym_DASH] = ACTIONS(4772),
    [aux_sym__hex_literal_token1] = ACTIONS(4776),
    [sym__number_literal] = ACTIONS(4778),
    [anon_sym_SQUOTE] = ACTIONS(4780),
    [anon_sym_DQUOTE] = ACTIONS(4782),
    [sym_return] = ACTIONS(6355),
    [sym_next] = ACTIONS(6355),
    [sym_break] = ACTIONS(6355),
    [sym_true] = ACTIONS(6355),
    [sym_false] = ACTIONS(6355),
    [sym_null] = ACTIONS(6355),
    [sym_inf] = ACTIONS(6355),
    [sym_nan] = ACTIONS(6355),
    [anon_sym_NA] = ACTIONS(4786),
    [anon_sym_NA_integer_] = ACTIONS(4786),
    [anon_sym_NA_real_] = ACTIONS(4786),
    [anon_sym_NA_complex_] = ACTIONS(4786),
    [anon_sym_NA_character_] = ACTIONS(4786),
    [sym_dots] = ACTIONS(6357),
    [sym_dot_dot_i] = ACTIONS(6359),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6361),
    [sym__newline] = ACTIONS(6363),
    [sym__raw_string_literal] = ACTIONS(4790),
    [sym__external_open_parenthesis] = ACTIONS(4792),
    [sym__external_open_brace] = ACTIONS(4794),
    [sym__external_close_bracket] = ACTIONS(6709),
  },
  [1552] = {
    [sym_call_arguments] = STATE(2853),
    [sym_subset_arguments] = STATE(2854),
    [sym_subset2_arguments] = STATE(2864),
    [sym__open_parenthesis] = STATE(1366),
    [sym__open_bracket] = STATE(1365),
    [sym__open_bracket2] = STATE(1364),
    [sym_identifier] = ACTIONS(5411),
    [anon_sym_BSLASH] = ACTIONS(5409),
    [anon_sym_function] = ACTIONS(5411),
    [anon_sym_EQ] = ACTIONS(5995),
    [anon_sym_if] = ACTIONS(5411),
    [anon_sym_for] = ACTIONS(5411),
    [anon_sym_while] = ACTIONS(5411),
    [anon_sym_repeat] = ACTIONS(5411),
    [anon_sym_QMARK] = ACTIONS(5409),
    [anon_sym_TILDE] = ACTIONS(5997),
    [anon_sym_BANG] = ACTIONS(5411),
    [anon_sym_PLUS] = ACTIONS(5999),
    [anon_sym_DASH] = ACTIONS(6001),
    [anon_sym_LT_DASH] = ACTIONS(6003),
    [anon_sym_LT_LT_DASH] = ACTIONS(6003),
    [anon_sym_COLON_EQ] = ACTIONS(6003),
    [anon_sym_DASH_GT] = ACTIONS(6005),
    [anon_sym_DASH_GT_GT] = ACTIONS(6007),
    [anon_sym_PIPE] = ACTIONS(6009),
    [anon_sym_AMP] = ACTIONS(6011),
    [anon_sym_PIPE_PIPE] = ACTIONS(6013),
    [anon_sym_AMP_AMP] = ACTIONS(6015),
    [anon_sym_LT] = ACTIONS(6017),
    [anon_sym_LT_EQ] = ACTIONS(6019),
    [anon_sym_GT] = ACTIONS(6017),
    [anon_sym_GT_EQ] = ACTIONS(6019),
    [anon_sym_EQ_EQ] = ACTIONS(6019),
    [anon_sym_BANG_EQ] = ACTIONS(6019),
    [anon_sym_STAR] = ACTIONS(6021),
    [anon_sym_SLASH] = ACTIONS(6023),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_CARET] = ACTIONS(6025),
    [aux_sym_binary_operator_token1] = ACTIONS(6027),
    [anon_sym_PIPE_GT] = ACTIONS(6027),
    [anon_sym_COLON] = ACTIONS(6029),
    [anon_sym_DOLLAR] = ACTIONS(6031),
    [anon_sym_AT] = ACTIONS(6031),
    [aux_sym__hex_literal_token1] = ACTIONS(5409),
    [sym__number_literal] = ACTIONS(5411),
    [anon_sym_SQUOTE] = ACTIONS(5409),
    [anon_sym_DQUOTE] = ACTIONS(5409),
    [sym_return] = ACTIONS(5411),
    [sym_next] = ACTIONS(5411),
    [sym_break] = ACTIONS(5411),
    [sym_true] = ACTIONS(5411),
    [sym_false] = ACTIONS(5411),
    [sym_null] = ACTIONS(5411),
    [sym_inf] = ACTIONS(5411),
    [sym_nan] = ACTIONS(5411),
    [anon_sym_NA] = ACTIONS(5411),
    [anon_sym_NA_integer_] = ACTIONS(5411),
    [anon_sym_NA_real_] = ACTIONS(5411),
    [anon_sym_NA_complex_] = ACTIONS(5411),
    [anon_sym_NA_character_] = ACTIONS(5411),
    [sym_dots] = ACTIONS(5411),
    [sym_dot_dot_i] = ACTIONS(5409),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5409),
    [sym__newline] = ACTIONS(5409),
    [sym__raw_string_literal] = ACTIONS(5409),
    [sym__external_else] = ACTIONS(5409),
    [sym__external_open_parenthesis] = ACTIONS(6035),
    [sym__external_open_brace] = ACTIONS(5409),
    [sym__external_open_bracket] = ACTIONS(6037),
    [sym__external_close_bracket] = ACTIONS(5409),
    [sym__external_open_bracket2] = ACTIONS(6039),
  },
  [1553] = {
    [sym_call_arguments] = STATE(2777),
    [sym_subset_arguments] = STATE(2779),
    [sym_subset2_arguments] = STATE(2786),
    [sym__open_parenthesis] = STATE(1411),
    [sym__open_bracket] = STATE(1409),
    [sym__open_bracket2] = STATE(1407),
    [ts_builtin_sym_end] = ACTIONS(5333),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(6491),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(6495),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(6497),
    [anon_sym_DASH] = ACTIONS(6499),
    [anon_sym_LT_DASH] = ACTIONS(6501),
    [anon_sym_LT_LT_DASH] = ACTIONS(6501),
    [anon_sym_COLON_EQ] = ACTIONS(6501),
    [anon_sym_DASH_GT] = ACTIONS(6503),
    [anon_sym_DASH_GT_GT] = ACTIONS(6505),
    [anon_sym_PIPE] = ACTIONS(6507),
    [anon_sym_AMP] = ACTIONS(6509),
    [anon_sym_PIPE_PIPE] = ACTIONS(6511),
    [anon_sym_AMP_AMP] = ACTIONS(6513),
    [anon_sym_LT] = ACTIONS(6515),
    [anon_sym_LT_EQ] = ACTIONS(6517),
    [anon_sym_GT] = ACTIONS(6515),
    [anon_sym_GT_EQ] = ACTIONS(6517),
    [anon_sym_EQ_EQ] = ACTIONS(6517),
    [anon_sym_BANG_EQ] = ACTIONS(6517),
    [anon_sym_STAR] = ACTIONS(6519),
    [anon_sym_SLASH] = ACTIONS(6521),
    [anon_sym_STAR_STAR] = ACTIONS(6523),
    [anon_sym_CARET] = ACTIONS(6523),
    [aux_sym_binary_operator_token1] = ACTIONS(6525),
    [anon_sym_PIPE_GT] = ACTIONS(6525),
    [anon_sym_COLON] = ACTIONS(6527),
    [anon_sym_DOLLAR] = ACTIONS(6529),
    [anon_sym_AT] = ACTIONS(6529),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5333),
    [sym__semicolon] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(6531),
    [sym__external_close_parenthesis] = ACTIONS(5333),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(6533),
    [sym__external_open_bracket2] = ACTIONS(6535),
  },
  [1554] = {
    [sym_call_arguments] = STATE(2853),
    [sym_subset_arguments] = STATE(2854),
    [sym_subset2_arguments] = STATE(2864),
    [sym__open_parenthesis] = STATE(1366),
    [sym__open_bracket] = STATE(1365),
    [sym__open_bracket2] = STATE(1364),
    [sym_identifier] = ACTIONS(5455),
    [anon_sym_BSLASH] = ACTIONS(5453),
    [anon_sym_function] = ACTIONS(5455),
    [anon_sym_EQ] = ACTIONS(5995),
    [anon_sym_if] = ACTIONS(5455),
    [anon_sym_for] = ACTIONS(5455),
    [anon_sym_while] = ACTIONS(5455),
    [anon_sym_repeat] = ACTIONS(5455),
    [anon_sym_QMARK] = ACTIONS(5453),
    [anon_sym_TILDE] = ACTIONS(5997),
    [anon_sym_BANG] = ACTIONS(5455),
    [anon_sym_PLUS] = ACTIONS(5999),
    [anon_sym_DASH] = ACTIONS(6001),
    [anon_sym_LT_DASH] = ACTIONS(6003),
    [anon_sym_LT_LT_DASH] = ACTIONS(6003),
    [anon_sym_COLON_EQ] = ACTIONS(6003),
    [anon_sym_DASH_GT] = ACTIONS(6005),
    [anon_sym_DASH_GT_GT] = ACTIONS(6007),
    [anon_sym_PIPE] = ACTIONS(6009),
    [anon_sym_AMP] = ACTIONS(6011),
    [anon_sym_PIPE_PIPE] = ACTIONS(6013),
    [anon_sym_AMP_AMP] = ACTIONS(6015),
    [anon_sym_LT] = ACTIONS(6017),
    [anon_sym_LT_EQ] = ACTIONS(6019),
    [anon_sym_GT] = ACTIONS(6017),
    [anon_sym_GT_EQ] = ACTIONS(6019),
    [anon_sym_EQ_EQ] = ACTIONS(6019),
    [anon_sym_BANG_EQ] = ACTIONS(6019),
    [anon_sym_STAR] = ACTIONS(6021),
    [anon_sym_SLASH] = ACTIONS(6023),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_CARET] = ACTIONS(6025),
    [aux_sym_binary_operator_token1] = ACTIONS(6027),
    [anon_sym_PIPE_GT] = ACTIONS(6027),
    [anon_sym_COLON] = ACTIONS(6029),
    [anon_sym_DOLLAR] = ACTIONS(6031),
    [anon_sym_AT] = ACTIONS(6031),
    [aux_sym__hex_literal_token1] = ACTIONS(5453),
    [sym__number_literal] = ACTIONS(5455),
    [anon_sym_SQUOTE] = ACTIONS(5453),
    [anon_sym_DQUOTE] = ACTIONS(5453),
    [sym_return] = ACTIONS(5455),
    [sym_next] = ACTIONS(5455),
    [sym_break] = ACTIONS(5455),
    [sym_true] = ACTIONS(5455),
    [sym_false] = ACTIONS(5455),
    [sym_null] = ACTIONS(5455),
    [sym_inf] = ACTIONS(5455),
    [sym_nan] = ACTIONS(5455),
    [anon_sym_NA] = ACTIONS(5455),
    [anon_sym_NA_integer_] = ACTIONS(5455),
    [anon_sym_NA_real_] = ACTIONS(5455),
    [anon_sym_NA_complex_] = ACTIONS(5455),
    [anon_sym_NA_character_] = ACTIONS(5455),
    [sym_dots] = ACTIONS(5455),
    [sym_dot_dot_i] = ACTIONS(5453),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5453),
    [sym__newline] = ACTIONS(5453),
    [sym__raw_string_literal] = ACTIONS(5453),
    [sym__external_else] = ACTIONS(5453),
    [sym__external_open_parenthesis] = ACTIONS(6035),
    [sym__external_open_brace] = ACTIONS(5453),
    [sym__external_open_bracket] = ACTIONS(6037),
    [sym__external_close_bracket] = ACTIONS(5453),
    [sym__external_open_bracket2] = ACTIONS(6039),
  },
  [1555] = {
    [sym_function_definition] = STATE(1931),
    [sym_if_statement] = STATE(1931),
    [sym_for_statement] = STATE(1931),
    [sym_while_statement] = STATE(1931),
    [sym_repeat_statement] = STATE(1931),
    [sym_braced_expression] = STATE(1931),
    [sym_parenthesized_expression] = STATE(1931),
    [sym_call] = STATE(1931),
    [sym_subset] = STATE(1931),
    [sym_subset2] = STATE(1931),
    [sym__argument] = STATE(4656),
    [sym_argument] = STATE(4657),
    [sym__argument_named] = STATE(4658),
    [sym__argument_unnamed] = STATE(4662),
    [sym__argument_value] = STATE(4663),
    [sym_unary_operator] = STATE(1931),
    [sym_binary_operator] = STATE(1931),
    [sym_extract_operator] = STATE(1931),
    [sym_namespace_operator] = STATE(1931),
    [sym_integer] = STATE(1931),
    [sym_complex] = STATE(1931),
    [sym_float] = STATE(1931),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2633),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(1931),
    [sym__expression] = STATE(1931),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__close_parenthesis] = STATE(2612),
    [sym__open_brace] = STATE(154),
    [aux_sym_call_arguments_repeat1] = STATE(1591),
    [sym_identifier] = ACTIONS(6387),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(6389),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3865),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(6391),
    [sym_next] = ACTIONS(6391),
    [sym_break] = ACTIONS(6391),
    [sym_true] = ACTIONS(6391),
    [sym_false] = ACTIONS(6391),
    [sym_null] = ACTIONS(6391),
    [sym_inf] = ACTIONS(6391),
    [sym_nan] = ACTIONS(6391),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(6393),
    [sym_dot_dot_i] = ACTIONS(6395),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6397),
    [sym__newline] = ACTIONS(6399),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(6711),
    [sym__external_open_brace] = ACTIONS(3891),
  },
  [1556] = {
    [sym_call_arguments] = STATE(2777),
    [sym_subset_arguments] = STATE(2779),
    [sym_subset2_arguments] = STATE(2786),
    [sym__open_parenthesis] = STATE(1411),
    [sym__open_bracket] = STATE(1409),
    [sym__open_bracket2] = STATE(1407),
    [ts_builtin_sym_end] = ACTIONS(5345),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(6491),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(6495),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(6497),
    [anon_sym_DASH] = ACTIONS(6499),
    [anon_sym_LT_DASH] = ACTIONS(6501),
    [anon_sym_LT_LT_DASH] = ACTIONS(6501),
    [anon_sym_COLON_EQ] = ACTIONS(6501),
    [anon_sym_DASH_GT] = ACTIONS(6503),
    [anon_sym_DASH_GT_GT] = ACTIONS(6505),
    [anon_sym_PIPE] = ACTIONS(6507),
    [anon_sym_AMP] = ACTIONS(6509),
    [anon_sym_PIPE_PIPE] = ACTIONS(6511),
    [anon_sym_AMP_AMP] = ACTIONS(6513),
    [anon_sym_LT] = ACTIONS(6515),
    [anon_sym_LT_EQ] = ACTIONS(6517),
    [anon_sym_GT] = ACTIONS(6515),
    [anon_sym_GT_EQ] = ACTIONS(6517),
    [anon_sym_EQ_EQ] = ACTIONS(6517),
    [anon_sym_BANG_EQ] = ACTIONS(6517),
    [anon_sym_STAR] = ACTIONS(6519),
    [anon_sym_SLASH] = ACTIONS(6521),
    [anon_sym_STAR_STAR] = ACTIONS(6523),
    [anon_sym_CARET] = ACTIONS(6523),
    [aux_sym_binary_operator_token1] = ACTIONS(6525),
    [anon_sym_PIPE_GT] = ACTIONS(6525),
    [anon_sym_COLON] = ACTIONS(6527),
    [anon_sym_DOLLAR] = ACTIONS(6529),
    [anon_sym_AT] = ACTIONS(6529),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5345),
    [sym__semicolon] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(6531),
    [sym__external_close_parenthesis] = ACTIONS(5345),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(6533),
    [sym__external_open_bracket2] = ACTIONS(6535),
  },
  [1557] = {
    [sym_string] = STATE(2629),
    [sym__single_quoted_string] = STATE(2289),
    [sym__double_quoted_string] = STATE(2290),
    [sym__string_or_identifier] = STATE(2629),
    [aux_sym_function_definition_repeat1] = STATE(1581),
    [sym_identifier] = ACTIONS(6713),
    [anon_sym_BSLASH] = ACTIONS(5659),
    [anon_sym_function] = ACTIONS(5663),
    [anon_sym_EQ] = ACTIONS(5663),
    [anon_sym_if] = ACTIONS(5663),
    [anon_sym_for] = ACTIONS(5663),
    [anon_sym_while] = ACTIONS(5663),
    [anon_sym_repeat] = ACTIONS(5663),
    [anon_sym_QMARK] = ACTIONS(5659),
    [anon_sym_TILDE] = ACTIONS(5659),
    [anon_sym_BANG] = ACTIONS(5663),
    [anon_sym_PLUS] = ACTIONS(5659),
    [anon_sym_DASH] = ACTIONS(5663),
    [anon_sym_LT_DASH] = ACTIONS(5659),
    [anon_sym_LT_LT_DASH] = ACTIONS(5659),
    [anon_sym_COLON_EQ] = ACTIONS(5659),
    [anon_sym_DASH_GT] = ACTIONS(5663),
    [anon_sym_DASH_GT_GT] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(5663),
    [anon_sym_AMP] = ACTIONS(5663),
    [anon_sym_PIPE_PIPE] = ACTIONS(5659),
    [anon_sym_AMP_AMP] = ACTIONS(5659),
    [anon_sym_LT] = ACTIONS(5663),
    [anon_sym_LT_EQ] = ACTIONS(5659),
    [anon_sym_GT] = ACTIONS(5663),
    [anon_sym_GT_EQ] = ACTIONS(5659),
    [anon_sym_EQ_EQ] = ACTIONS(5659),
    [anon_sym_BANG_EQ] = ACTIONS(5659),
    [anon_sym_STAR] = ACTIONS(5663),
    [anon_sym_SLASH] = ACTIONS(5659),
    [anon_sym_STAR_STAR] = ACTIONS(5659),
    [anon_sym_CARET] = ACTIONS(5659),
    [aux_sym_binary_operator_token1] = ACTIONS(5659),
    [anon_sym_PIPE_GT] = ACTIONS(5659),
    [anon_sym_COLON] = ACTIONS(5663),
    [anon_sym_DOLLAR] = ACTIONS(5659),
    [anon_sym_AT] = ACTIONS(5659),
    [aux_sym__hex_literal_token1] = ACTIONS(5659),
    [sym__number_literal] = ACTIONS(5663),
    [anon_sym_SQUOTE] = ACTIONS(1596),
    [anon_sym_DQUOTE] = ACTIONS(1598),
    [sym_return] = ACTIONS(5663),
    [sym_next] = ACTIONS(5663),
    [sym_break] = ACTIONS(5663),
    [sym_true] = ACTIONS(5663),
    [sym_false] = ACTIONS(5663),
    [sym_null] = ACTIONS(5663),
    [sym_inf] = ACTIONS(5663),
    [sym_nan] = ACTIONS(5663),
    [anon_sym_NA] = ACTIONS(5663),
    [anon_sym_NA_integer_] = ACTIONS(5663),
    [anon_sym_NA_real_] = ACTIONS(5663),
    [anon_sym_NA_complex_] = ACTIONS(5663),
    [anon_sym_NA_character_] = ACTIONS(5663),
    [sym_dots] = ACTIONS(5663),
    [sym_dot_dot_i] = ACTIONS(5659),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5659),
    [sym__newline] = ACTIONS(6715),
    [sym__raw_string_literal] = ACTIONS(1608),
    [sym__external_else] = ACTIONS(5659),
    [sym__external_open_parenthesis] = ACTIONS(5659),
    [sym__external_close_parenthesis] = ACTIONS(5659),
    [sym__external_open_brace] = ACTIONS(5659),
    [sym__external_open_bracket] = ACTIONS(5659),
    [sym__external_open_bracket2] = ACTIONS(5659),
    [sym__external_close_bracket2] = ACTIONS(5659),
  },
  [1558] = {
    [sym_call_arguments] = STATE(2853),
    [sym_subset_arguments] = STATE(2854),
    [sym_subset2_arguments] = STATE(2864),
    [sym__open_parenthesis] = STATE(1366),
    [sym__open_bracket] = STATE(1365),
    [sym__open_bracket2] = STATE(1364),
    [sym_identifier] = ACTIONS(5451),
    [anon_sym_BSLASH] = ACTIONS(5449),
    [anon_sym_function] = ACTIONS(5451),
    [anon_sym_EQ] = ACTIONS(5995),
    [anon_sym_if] = ACTIONS(5451),
    [anon_sym_for] = ACTIONS(5451),
    [anon_sym_while] = ACTIONS(5451),
    [anon_sym_repeat] = ACTIONS(5451),
    [anon_sym_QMARK] = ACTIONS(5449),
    [anon_sym_TILDE] = ACTIONS(5997),
    [anon_sym_BANG] = ACTIONS(5451),
    [anon_sym_PLUS] = ACTIONS(5999),
    [anon_sym_DASH] = ACTIONS(6001),
    [anon_sym_LT_DASH] = ACTIONS(6003),
    [anon_sym_LT_LT_DASH] = ACTIONS(6003),
    [anon_sym_COLON_EQ] = ACTIONS(6003),
    [anon_sym_DASH_GT] = ACTIONS(6005),
    [anon_sym_DASH_GT_GT] = ACTIONS(6007),
    [anon_sym_PIPE] = ACTIONS(6009),
    [anon_sym_AMP] = ACTIONS(6011),
    [anon_sym_PIPE_PIPE] = ACTIONS(6013),
    [anon_sym_AMP_AMP] = ACTIONS(6015),
    [anon_sym_LT] = ACTIONS(6017),
    [anon_sym_LT_EQ] = ACTIONS(6019),
    [anon_sym_GT] = ACTIONS(6017),
    [anon_sym_GT_EQ] = ACTIONS(6019),
    [anon_sym_EQ_EQ] = ACTIONS(6019),
    [anon_sym_BANG_EQ] = ACTIONS(6019),
    [anon_sym_STAR] = ACTIONS(6021),
    [anon_sym_SLASH] = ACTIONS(6023),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_CARET] = ACTIONS(6025),
    [aux_sym_binary_operator_token1] = ACTIONS(6027),
    [anon_sym_PIPE_GT] = ACTIONS(6027),
    [anon_sym_COLON] = ACTIONS(6029),
    [anon_sym_DOLLAR] = ACTIONS(6031),
    [anon_sym_AT] = ACTIONS(6031),
    [aux_sym__hex_literal_token1] = ACTIONS(5449),
    [sym__number_literal] = ACTIONS(5451),
    [anon_sym_SQUOTE] = ACTIONS(5449),
    [anon_sym_DQUOTE] = ACTIONS(5449),
    [sym_return] = ACTIONS(5451),
    [sym_next] = ACTIONS(5451),
    [sym_break] = ACTIONS(5451),
    [sym_true] = ACTIONS(5451),
    [sym_false] = ACTIONS(5451),
    [sym_null] = ACTIONS(5451),
    [sym_inf] = ACTIONS(5451),
    [sym_nan] = ACTIONS(5451),
    [anon_sym_NA] = ACTIONS(5451),
    [anon_sym_NA_integer_] = ACTIONS(5451),
    [anon_sym_NA_real_] = ACTIONS(5451),
    [anon_sym_NA_complex_] = ACTIONS(5451),
    [anon_sym_NA_character_] = ACTIONS(5451),
    [sym_dots] = ACTIONS(5451),
    [sym_dot_dot_i] = ACTIONS(5449),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5449),
    [sym__newline] = ACTIONS(5449),
    [sym__raw_string_literal] = ACTIONS(5449),
    [sym__external_else] = ACTIONS(5449),
    [sym__external_open_parenthesis] = ACTIONS(6035),
    [sym__external_open_brace] = ACTIONS(5449),
    [sym__external_open_bracket] = ACTIONS(6037),
    [sym__external_close_bracket] = ACTIONS(5449),
    [sym__external_open_bracket2] = ACTIONS(6039),
  },
  [1559] = {
    [sym_function_definition] = STATE(1931),
    [sym_if_statement] = STATE(1931),
    [sym_for_statement] = STATE(1931),
    [sym_while_statement] = STATE(1931),
    [sym_repeat_statement] = STATE(1931),
    [sym_braced_expression] = STATE(1931),
    [sym_parenthesized_expression] = STATE(1931),
    [sym_call] = STATE(1931),
    [sym_subset] = STATE(1931),
    [sym_subset2] = STATE(1931),
    [sym__argument] = STATE(4656),
    [sym_argument] = STATE(4657),
    [sym__argument_named] = STATE(4658),
    [sym__argument_unnamed] = STATE(4662),
    [sym__argument_value] = STATE(4663),
    [sym_unary_operator] = STATE(1931),
    [sym_binary_operator] = STATE(1931),
    [sym_extract_operator] = STATE(1931),
    [sym_namespace_operator] = STATE(1931),
    [sym_integer] = STATE(1931),
    [sym_complex] = STATE(1931),
    [sym_float] = STATE(1931),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2633),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(1931),
    [sym__expression] = STATE(1931),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__close_parenthesis] = STATE(2635),
    [sym__open_brace] = STATE(154),
    [aux_sym_call_arguments_repeat1] = STATE(2113),
    [sym_identifier] = ACTIONS(6387),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(6389),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3865),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(6391),
    [sym_next] = ACTIONS(6391),
    [sym_break] = ACTIONS(6391),
    [sym_true] = ACTIONS(6391),
    [sym_false] = ACTIONS(6391),
    [sym_null] = ACTIONS(6391),
    [sym_inf] = ACTIONS(6391),
    [sym_nan] = ACTIONS(6391),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(6393),
    [sym_dot_dot_i] = ACTIONS(6395),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6397),
    [sym__newline] = ACTIONS(6399),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(6717),
    [sym__external_open_brace] = ACTIONS(3891),
  },
  [1560] = {
    [sym_call_arguments] = STATE(2853),
    [sym_subset_arguments] = STATE(2854),
    [sym_subset2_arguments] = STATE(2864),
    [sym__open_parenthesis] = STATE(1366),
    [sym__open_bracket] = STATE(1365),
    [sym__open_bracket2] = STATE(1364),
    [sym_identifier] = ACTIONS(5447),
    [anon_sym_BSLASH] = ACTIONS(5445),
    [anon_sym_function] = ACTIONS(5447),
    [anon_sym_EQ] = ACTIONS(5995),
    [anon_sym_if] = ACTIONS(5447),
    [anon_sym_for] = ACTIONS(5447),
    [anon_sym_while] = ACTIONS(5447),
    [anon_sym_repeat] = ACTIONS(5447),
    [anon_sym_QMARK] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(5997),
    [anon_sym_BANG] = ACTIONS(5447),
    [anon_sym_PLUS] = ACTIONS(5999),
    [anon_sym_DASH] = ACTIONS(6001),
    [anon_sym_LT_DASH] = ACTIONS(6003),
    [anon_sym_LT_LT_DASH] = ACTIONS(6003),
    [anon_sym_COLON_EQ] = ACTIONS(6003),
    [anon_sym_DASH_GT] = ACTIONS(6005),
    [anon_sym_DASH_GT_GT] = ACTIONS(6007),
    [anon_sym_PIPE] = ACTIONS(6009),
    [anon_sym_AMP] = ACTIONS(6011),
    [anon_sym_PIPE_PIPE] = ACTIONS(6013),
    [anon_sym_AMP_AMP] = ACTIONS(6015),
    [anon_sym_LT] = ACTIONS(6017),
    [anon_sym_LT_EQ] = ACTIONS(6019),
    [anon_sym_GT] = ACTIONS(6017),
    [anon_sym_GT_EQ] = ACTIONS(6019),
    [anon_sym_EQ_EQ] = ACTIONS(6019),
    [anon_sym_BANG_EQ] = ACTIONS(6019),
    [anon_sym_STAR] = ACTIONS(6021),
    [anon_sym_SLASH] = ACTIONS(6023),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_CARET] = ACTIONS(6025),
    [aux_sym_binary_operator_token1] = ACTIONS(6027),
    [anon_sym_PIPE_GT] = ACTIONS(6027),
    [anon_sym_COLON] = ACTIONS(6029),
    [anon_sym_DOLLAR] = ACTIONS(6031),
    [anon_sym_AT] = ACTIONS(6031),
    [aux_sym__hex_literal_token1] = ACTIONS(5445),
    [sym__number_literal] = ACTIONS(5447),
    [anon_sym_SQUOTE] = ACTIONS(5445),
    [anon_sym_DQUOTE] = ACTIONS(5445),
    [sym_return] = ACTIONS(5447),
    [sym_next] = ACTIONS(5447),
    [sym_break] = ACTIONS(5447),
    [sym_true] = ACTIONS(5447),
    [sym_false] = ACTIONS(5447),
    [sym_null] = ACTIONS(5447),
    [sym_inf] = ACTIONS(5447),
    [sym_nan] = ACTIONS(5447),
    [anon_sym_NA] = ACTIONS(5447),
    [anon_sym_NA_integer_] = ACTIONS(5447),
    [anon_sym_NA_real_] = ACTIONS(5447),
    [anon_sym_NA_complex_] = ACTIONS(5447),
    [anon_sym_NA_character_] = ACTIONS(5447),
    [sym_dots] = ACTIONS(5447),
    [sym_dot_dot_i] = ACTIONS(5445),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5445),
    [sym__newline] = ACTIONS(5445),
    [sym__raw_string_literal] = ACTIONS(5445),
    [sym__external_else] = ACTIONS(5445),
    [sym__external_open_parenthesis] = ACTIONS(6035),
    [sym__external_open_brace] = ACTIONS(5445),
    [sym__external_open_bracket] = ACTIONS(6037),
    [sym__external_close_bracket] = ACTIONS(5445),
    [sym__external_open_bracket2] = ACTIONS(6039),
  },
  [1561] = {
    [sym_call_arguments] = STATE(2777),
    [sym_subset_arguments] = STATE(2779),
    [sym_subset2_arguments] = STATE(2786),
    [sym__open_parenthesis] = STATE(1411),
    [sym__open_bracket] = STATE(1409),
    [sym__open_bracket2] = STATE(1407),
    [ts_builtin_sym_end] = ACTIONS(5329),
    [sym_identifier] = ACTIONS(5331),
    [anon_sym_BSLASH] = ACTIONS(5329),
    [anon_sym_function] = ACTIONS(5331),
    [anon_sym_EQ] = ACTIONS(6491),
    [anon_sym_if] = ACTIONS(5331),
    [anon_sym_for] = ACTIONS(5331),
    [anon_sym_while] = ACTIONS(5331),
    [anon_sym_repeat] = ACTIONS(5331),
    [anon_sym_QMARK] = ACTIONS(5329),
    [anon_sym_TILDE] = ACTIONS(6495),
    [anon_sym_BANG] = ACTIONS(5331),
    [anon_sym_PLUS] = ACTIONS(6497),
    [anon_sym_DASH] = ACTIONS(6499),
    [anon_sym_LT_DASH] = ACTIONS(6501),
    [anon_sym_LT_LT_DASH] = ACTIONS(6501),
    [anon_sym_COLON_EQ] = ACTIONS(6501),
    [anon_sym_DASH_GT] = ACTIONS(6503),
    [anon_sym_DASH_GT_GT] = ACTIONS(6505),
    [anon_sym_PIPE] = ACTIONS(6507),
    [anon_sym_AMP] = ACTIONS(6509),
    [anon_sym_PIPE_PIPE] = ACTIONS(6511),
    [anon_sym_AMP_AMP] = ACTIONS(6513),
    [anon_sym_LT] = ACTIONS(6515),
    [anon_sym_LT_EQ] = ACTIONS(6517),
    [anon_sym_GT] = ACTIONS(6515),
    [anon_sym_GT_EQ] = ACTIONS(6517),
    [anon_sym_EQ_EQ] = ACTIONS(6517),
    [anon_sym_BANG_EQ] = ACTIONS(6517),
    [anon_sym_STAR] = ACTIONS(6519),
    [anon_sym_SLASH] = ACTIONS(6521),
    [anon_sym_STAR_STAR] = ACTIONS(6523),
    [anon_sym_CARET] = ACTIONS(6523),
    [aux_sym_binary_operator_token1] = ACTIONS(6525),
    [anon_sym_PIPE_GT] = ACTIONS(6525),
    [anon_sym_COLON] = ACTIONS(6527),
    [anon_sym_DOLLAR] = ACTIONS(6529),
    [anon_sym_AT] = ACTIONS(6529),
    [aux_sym__hex_literal_token1] = ACTIONS(5329),
    [sym__number_literal] = ACTIONS(5331),
    [anon_sym_SQUOTE] = ACTIONS(5329),
    [anon_sym_DQUOTE] = ACTIONS(5329),
    [sym_return] = ACTIONS(5331),
    [sym_next] = ACTIONS(5331),
    [sym_break] = ACTIONS(5331),
    [sym_true] = ACTIONS(5331),
    [sym_false] = ACTIONS(5331),
    [sym_null] = ACTIONS(5331),
    [sym_inf] = ACTIONS(5331),
    [sym_nan] = ACTIONS(5331),
    [anon_sym_NA] = ACTIONS(5331),
    [anon_sym_NA_integer_] = ACTIONS(5331),
    [anon_sym_NA_real_] = ACTIONS(5331),
    [anon_sym_NA_complex_] = ACTIONS(5331),
    [anon_sym_NA_character_] = ACTIONS(5331),
    [sym_dots] = ACTIONS(5331),
    [sym_dot_dot_i] = ACTIONS(5329),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5329),
    [sym__semicolon] = ACTIONS(5329),
    [sym__raw_string_literal] = ACTIONS(5329),
    [sym__external_open_parenthesis] = ACTIONS(6531),
    [sym__external_close_parenthesis] = ACTIONS(5329),
    [sym__external_open_brace] = ACTIONS(5329),
    [sym__external_open_bracket] = ACTIONS(6533),
    [sym__external_open_bracket2] = ACTIONS(6535),
  },
  [1562] = {
    [sym_call_arguments] = STATE(2853),
    [sym_subset_arguments] = STATE(2854),
    [sym_subset2_arguments] = STATE(2864),
    [sym__open_parenthesis] = STATE(1366),
    [sym__open_bracket] = STATE(1365),
    [sym__open_bracket2] = STATE(1364),
    [sym_identifier] = ACTIONS(5443),
    [anon_sym_BSLASH] = ACTIONS(5441),
    [anon_sym_function] = ACTIONS(5443),
    [anon_sym_EQ] = ACTIONS(5995),
    [anon_sym_if] = ACTIONS(5443),
    [anon_sym_for] = ACTIONS(5443),
    [anon_sym_while] = ACTIONS(5443),
    [anon_sym_repeat] = ACTIONS(5443),
    [anon_sym_QMARK] = ACTIONS(5441),
    [anon_sym_TILDE] = ACTIONS(5997),
    [anon_sym_BANG] = ACTIONS(5443),
    [anon_sym_PLUS] = ACTIONS(5999),
    [anon_sym_DASH] = ACTIONS(6001),
    [anon_sym_LT_DASH] = ACTIONS(6003),
    [anon_sym_LT_LT_DASH] = ACTIONS(6003),
    [anon_sym_COLON_EQ] = ACTIONS(6003),
    [anon_sym_DASH_GT] = ACTIONS(6005),
    [anon_sym_DASH_GT_GT] = ACTIONS(6007),
    [anon_sym_PIPE] = ACTIONS(6009),
    [anon_sym_AMP] = ACTIONS(6011),
    [anon_sym_PIPE_PIPE] = ACTIONS(6013),
    [anon_sym_AMP_AMP] = ACTIONS(6015),
    [anon_sym_LT] = ACTIONS(6017),
    [anon_sym_LT_EQ] = ACTIONS(6019),
    [anon_sym_GT] = ACTIONS(6017),
    [anon_sym_GT_EQ] = ACTIONS(6019),
    [anon_sym_EQ_EQ] = ACTIONS(6019),
    [anon_sym_BANG_EQ] = ACTIONS(6019),
    [anon_sym_STAR] = ACTIONS(6021),
    [anon_sym_SLASH] = ACTIONS(6023),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_CARET] = ACTIONS(6025),
    [aux_sym_binary_operator_token1] = ACTIONS(6027),
    [anon_sym_PIPE_GT] = ACTIONS(6027),
    [anon_sym_COLON] = ACTIONS(6029),
    [anon_sym_DOLLAR] = ACTIONS(6031),
    [anon_sym_AT] = ACTIONS(6031),
    [aux_sym__hex_literal_token1] = ACTIONS(5441),
    [sym__number_literal] = ACTIONS(5443),
    [anon_sym_SQUOTE] = ACTIONS(5441),
    [anon_sym_DQUOTE] = ACTIONS(5441),
    [sym_return] = ACTIONS(5443),
    [sym_next] = ACTIONS(5443),
    [sym_break] = ACTIONS(5443),
    [sym_true] = ACTIONS(5443),
    [sym_false] = ACTIONS(5443),
    [sym_null] = ACTIONS(5443),
    [sym_inf] = ACTIONS(5443),
    [sym_nan] = ACTIONS(5443),
    [anon_sym_NA] = ACTIONS(5443),
    [anon_sym_NA_integer_] = ACTIONS(5443),
    [anon_sym_NA_real_] = ACTIONS(5443),
    [anon_sym_NA_complex_] = ACTIONS(5443),
    [anon_sym_NA_character_] = ACTIONS(5443),
    [sym_dots] = ACTIONS(5443),
    [sym_dot_dot_i] = ACTIONS(5441),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5441),
    [sym__newline] = ACTIONS(5441),
    [sym__raw_string_literal] = ACTIONS(5441),
    [sym__external_else] = ACTIONS(5441),
    [sym__external_open_parenthesis] = ACTIONS(6035),
    [sym__external_open_brace] = ACTIONS(5441),
    [sym__external_open_bracket] = ACTIONS(6037),
    [sym__external_close_bracket] = ACTIONS(5441),
    [sym__external_open_bracket2] = ACTIONS(6039),
  },
  [1563] = {
    [sym_string] = STATE(2471),
    [sym__single_quoted_string] = STATE(2181),
    [sym__double_quoted_string] = STATE(2180),
    [sym__string_or_identifier] = STATE(2471),
    [ts_builtin_sym_end] = ACTIONS(5883),
    [sym_identifier] = ACTIONS(6719),
    [anon_sym_BSLASH] = ACTIONS(5883),
    [anon_sym_function] = ACTIONS(5887),
    [anon_sym_EQ] = ACTIONS(5887),
    [anon_sym_if] = ACTIONS(5887),
    [anon_sym_for] = ACTIONS(5887),
    [anon_sym_while] = ACTIONS(5887),
    [anon_sym_repeat] = ACTIONS(5887),
    [anon_sym_QMARK] = ACTIONS(5883),
    [anon_sym_TILDE] = ACTIONS(5883),
    [anon_sym_BANG] = ACTIONS(5887),
    [anon_sym_PLUS] = ACTIONS(5883),
    [anon_sym_DASH] = ACTIONS(5887),
    [anon_sym_LT_DASH] = ACTIONS(5883),
    [anon_sym_LT_LT_DASH] = ACTIONS(5883),
    [anon_sym_COLON_EQ] = ACTIONS(5883),
    [anon_sym_DASH_GT] = ACTIONS(5887),
    [anon_sym_DASH_GT_GT] = ACTIONS(5883),
    [anon_sym_PIPE] = ACTIONS(5887),
    [anon_sym_AMP] = ACTIONS(5887),
    [anon_sym_PIPE_PIPE] = ACTIONS(5883),
    [anon_sym_AMP_AMP] = ACTIONS(5883),
    [anon_sym_LT] = ACTIONS(5887),
    [anon_sym_LT_EQ] = ACTIONS(5883),
    [anon_sym_GT] = ACTIONS(5887),
    [anon_sym_GT_EQ] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5883),
    [anon_sym_BANG_EQ] = ACTIONS(5883),
    [anon_sym_STAR] = ACTIONS(5887),
    [anon_sym_SLASH] = ACTIONS(5883),
    [anon_sym_STAR_STAR] = ACTIONS(5883),
    [anon_sym_CARET] = ACTIONS(5883),
    [aux_sym_binary_operator_token1] = ACTIONS(5883),
    [anon_sym_PIPE_GT] = ACTIONS(5883),
    [anon_sym_COLON] = ACTIONS(5887),
    [anon_sym_DOLLAR] = ACTIONS(5883),
    [anon_sym_AT] = ACTIONS(5883),
    [aux_sym__hex_literal_token1] = ACTIONS(5883),
    [sym__number_literal] = ACTIONS(5887),
    [anon_sym_SQUOTE] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(351),
    [sym_return] = ACTIONS(5887),
    [sym_next] = ACTIONS(5887),
    [sym_break] = ACTIONS(5887),
    [sym_true] = ACTIONS(5887),
    [sym_false] = ACTIONS(5887),
    [sym_null] = ACTIONS(5887),
    [sym_inf] = ACTIONS(5887),
    [sym_nan] = ACTIONS(5887),
    [anon_sym_NA] = ACTIONS(5887),
    [anon_sym_NA_integer_] = ACTIONS(5887),
    [anon_sym_NA_real_] = ACTIONS(5887),
    [anon_sym_NA_complex_] = ACTIONS(5887),
    [anon_sym_NA_character_] = ACTIONS(5887),
    [sym_dots] = ACTIONS(5887),
    [sym_dot_dot_i] = ACTIONS(5883),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5883),
    [sym__newline] = ACTIONS(5883),
    [sym__semicolon] = ACTIONS(5883),
    [sym__raw_string_literal] = ACTIONS(361),
    [sym__external_open_parenthesis] = ACTIONS(5883),
    [sym__external_close_parenthesis] = ACTIONS(5883),
    [sym__external_open_brace] = ACTIONS(5883),
    [sym__external_close_brace] = ACTIONS(5883),
    [sym__external_open_bracket] = ACTIONS(5883),
    [sym__external_open_bracket2] = ACTIONS(5883),
  },
  [1564] = {
    [sym_call_arguments] = STATE(2853),
    [sym_subset_arguments] = STATE(2854),
    [sym_subset2_arguments] = STATE(2864),
    [sym__open_parenthesis] = STATE(1366),
    [sym__open_bracket] = STATE(1365),
    [sym__open_bracket2] = STATE(1364),
    [sym_identifier] = ACTIONS(5439),
    [anon_sym_BSLASH] = ACTIONS(5437),
    [anon_sym_function] = ACTIONS(5439),
    [anon_sym_EQ] = ACTIONS(5995),
    [anon_sym_if] = ACTIONS(5439),
    [anon_sym_for] = ACTIONS(5439),
    [anon_sym_while] = ACTIONS(5439),
    [anon_sym_repeat] = ACTIONS(5439),
    [anon_sym_QMARK] = ACTIONS(5437),
    [anon_sym_TILDE] = ACTIONS(5997),
    [anon_sym_BANG] = ACTIONS(5439),
    [anon_sym_PLUS] = ACTIONS(5999),
    [anon_sym_DASH] = ACTIONS(6001),
    [anon_sym_LT_DASH] = ACTIONS(6003),
    [anon_sym_LT_LT_DASH] = ACTIONS(6003),
    [anon_sym_COLON_EQ] = ACTIONS(6003),
    [anon_sym_DASH_GT] = ACTIONS(6005),
    [anon_sym_DASH_GT_GT] = ACTIONS(6007),
    [anon_sym_PIPE] = ACTIONS(6009),
    [anon_sym_AMP] = ACTIONS(6011),
    [anon_sym_PIPE_PIPE] = ACTIONS(6013),
    [anon_sym_AMP_AMP] = ACTIONS(6015),
    [anon_sym_LT] = ACTIONS(6017),
    [anon_sym_LT_EQ] = ACTIONS(6019),
    [anon_sym_GT] = ACTIONS(6017),
    [anon_sym_GT_EQ] = ACTIONS(6019),
    [anon_sym_EQ_EQ] = ACTIONS(6019),
    [anon_sym_BANG_EQ] = ACTIONS(6019),
    [anon_sym_STAR] = ACTIONS(6021),
    [anon_sym_SLASH] = ACTIONS(6023),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_CARET] = ACTIONS(6025),
    [aux_sym_binary_operator_token1] = ACTIONS(6027),
    [anon_sym_PIPE_GT] = ACTIONS(6027),
    [anon_sym_COLON] = ACTIONS(6029),
    [anon_sym_DOLLAR] = ACTIONS(6031),
    [anon_sym_AT] = ACTIONS(6031),
    [aux_sym__hex_literal_token1] = ACTIONS(5437),
    [sym__number_literal] = ACTIONS(5439),
    [anon_sym_SQUOTE] = ACTIONS(5437),
    [anon_sym_DQUOTE] = ACTIONS(5437),
    [sym_return] = ACTIONS(5439),
    [sym_next] = ACTIONS(5439),
    [sym_break] = ACTIONS(5439),
    [sym_true] = ACTIONS(5439),
    [sym_false] = ACTIONS(5439),
    [sym_null] = ACTIONS(5439),
    [sym_inf] = ACTIONS(5439),
    [sym_nan] = ACTIONS(5439),
    [anon_sym_NA] = ACTIONS(5439),
    [anon_sym_NA_integer_] = ACTIONS(5439),
    [anon_sym_NA_real_] = ACTIONS(5439),
    [anon_sym_NA_complex_] = ACTIONS(5439),
    [anon_sym_NA_character_] = ACTIONS(5439),
    [sym_dots] = ACTIONS(5439),
    [sym_dot_dot_i] = ACTIONS(5437),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5437),
    [sym__newline] = ACTIONS(5437),
    [sym__raw_string_literal] = ACTIONS(5437),
    [sym__external_else] = ACTIONS(5437),
    [sym__external_open_parenthesis] = ACTIONS(6035),
    [sym__external_open_brace] = ACTIONS(5437),
    [sym__external_open_bracket] = ACTIONS(6037),
    [sym__external_close_bracket] = ACTIONS(5437),
    [sym__external_open_bracket2] = ACTIONS(6039),
  },
  [1565] = {
    [sym_call_arguments] = STATE(2853),
    [sym_subset_arguments] = STATE(2854),
    [sym_subset2_arguments] = STATE(2864),
    [sym__open_parenthesis] = STATE(1366),
    [sym__open_bracket] = STATE(1365),
    [sym__open_bracket2] = STATE(1364),
    [sym_identifier] = ACTIONS(5435),
    [anon_sym_BSLASH] = ACTIONS(5433),
    [anon_sym_function] = ACTIONS(5435),
    [anon_sym_EQ] = ACTIONS(5995),
    [anon_sym_if] = ACTIONS(5435),
    [anon_sym_for] = ACTIONS(5435),
    [anon_sym_while] = ACTIONS(5435),
    [anon_sym_repeat] = ACTIONS(5435),
    [anon_sym_QMARK] = ACTIONS(5433),
    [anon_sym_TILDE] = ACTIONS(5997),
    [anon_sym_BANG] = ACTIONS(5435),
    [anon_sym_PLUS] = ACTIONS(5999),
    [anon_sym_DASH] = ACTIONS(6001),
    [anon_sym_LT_DASH] = ACTIONS(6003),
    [anon_sym_LT_LT_DASH] = ACTIONS(6003),
    [anon_sym_COLON_EQ] = ACTIONS(6003),
    [anon_sym_DASH_GT] = ACTIONS(6005),
    [anon_sym_DASH_GT_GT] = ACTIONS(6007),
    [anon_sym_PIPE] = ACTIONS(6009),
    [anon_sym_AMP] = ACTIONS(6011),
    [anon_sym_PIPE_PIPE] = ACTIONS(6013),
    [anon_sym_AMP_AMP] = ACTIONS(6015),
    [anon_sym_LT] = ACTIONS(6017),
    [anon_sym_LT_EQ] = ACTIONS(6019),
    [anon_sym_GT] = ACTIONS(6017),
    [anon_sym_GT_EQ] = ACTIONS(6019),
    [anon_sym_EQ_EQ] = ACTIONS(6019),
    [anon_sym_BANG_EQ] = ACTIONS(6019),
    [anon_sym_STAR] = ACTIONS(6021),
    [anon_sym_SLASH] = ACTIONS(6023),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_CARET] = ACTIONS(6025),
    [aux_sym_binary_operator_token1] = ACTIONS(6027),
    [anon_sym_PIPE_GT] = ACTIONS(6027),
    [anon_sym_COLON] = ACTIONS(6029),
    [anon_sym_DOLLAR] = ACTIONS(6031),
    [anon_sym_AT] = ACTIONS(6031),
    [aux_sym__hex_literal_token1] = ACTIONS(5433),
    [sym__number_literal] = ACTIONS(5435),
    [anon_sym_SQUOTE] = ACTIONS(5433),
    [anon_sym_DQUOTE] = ACTIONS(5433),
    [sym_return] = ACTIONS(5435),
    [sym_next] = ACTIONS(5435),
    [sym_break] = ACTIONS(5435),
    [sym_true] = ACTIONS(5435),
    [sym_false] = ACTIONS(5435),
    [sym_null] = ACTIONS(5435),
    [sym_inf] = ACTIONS(5435),
    [sym_nan] = ACTIONS(5435),
    [anon_sym_NA] = ACTIONS(5435),
    [anon_sym_NA_integer_] = ACTIONS(5435),
    [anon_sym_NA_real_] = ACTIONS(5435),
    [anon_sym_NA_complex_] = ACTIONS(5435),
    [anon_sym_NA_character_] = ACTIONS(5435),
    [sym_dots] = ACTIONS(5435),
    [sym_dot_dot_i] = ACTIONS(5433),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5433),
    [sym__newline] = ACTIONS(5433),
    [sym__raw_string_literal] = ACTIONS(5433),
    [sym__external_else] = ACTIONS(5433),
    [sym__external_open_parenthesis] = ACTIONS(6035),
    [sym__external_open_brace] = ACTIONS(5433),
    [sym__external_open_bracket] = ACTIONS(6037),
    [sym__external_close_bracket] = ACTIONS(5433),
    [sym__external_open_bracket2] = ACTIONS(6039),
  },
  [1566] = {
    [sym_string] = STATE(2574),
    [sym__single_quoted_string] = STATE(2265),
    [sym__double_quoted_string] = STATE(2264),
    [sym__string_or_identifier] = STATE(2574),
    [aux_sym_function_definition_repeat1] = STATE(2398),
    [sym_identifier] = ACTIONS(6721),
    [anon_sym_BSLASH] = ACTIONS(5669),
    [anon_sym_function] = ACTIONS(5673),
    [anon_sym_EQ] = ACTIONS(5673),
    [anon_sym_if] = ACTIONS(5673),
    [anon_sym_for] = ACTIONS(5673),
    [anon_sym_while] = ACTIONS(5673),
    [anon_sym_repeat] = ACTIONS(5673),
    [anon_sym_QMARK] = ACTIONS(5669),
    [anon_sym_TILDE] = ACTIONS(5669),
    [anon_sym_BANG] = ACTIONS(5673),
    [anon_sym_PLUS] = ACTIONS(5669),
    [anon_sym_DASH] = ACTIONS(5673),
    [anon_sym_LT_DASH] = ACTIONS(5669),
    [anon_sym_LT_LT_DASH] = ACTIONS(5669),
    [anon_sym_COLON_EQ] = ACTIONS(5669),
    [anon_sym_DASH_GT] = ACTIONS(5673),
    [anon_sym_DASH_GT_GT] = ACTIONS(5669),
    [anon_sym_PIPE] = ACTIONS(5673),
    [anon_sym_AMP] = ACTIONS(5673),
    [anon_sym_PIPE_PIPE] = ACTIONS(5669),
    [anon_sym_AMP_AMP] = ACTIONS(5669),
    [anon_sym_LT] = ACTIONS(5673),
    [anon_sym_LT_EQ] = ACTIONS(5669),
    [anon_sym_GT] = ACTIONS(5673),
    [anon_sym_GT_EQ] = ACTIONS(5669),
    [anon_sym_EQ_EQ] = ACTIONS(5669),
    [anon_sym_BANG_EQ] = ACTIONS(5669),
    [anon_sym_STAR] = ACTIONS(5673),
    [anon_sym_SLASH] = ACTIONS(5669),
    [anon_sym_STAR_STAR] = ACTIONS(5669),
    [anon_sym_CARET] = ACTIONS(5669),
    [aux_sym_binary_operator_token1] = ACTIONS(5669),
    [anon_sym_PIPE_GT] = ACTIONS(5669),
    [anon_sym_COLON] = ACTIONS(5673),
    [anon_sym_DOLLAR] = ACTIONS(5669),
    [anon_sym_AT] = ACTIONS(5669),
    [aux_sym__hex_literal_token1] = ACTIONS(5669),
    [sym__number_literal] = ACTIONS(5673),
    [anon_sym_SQUOTE] = ACTIONS(1317),
    [anon_sym_DQUOTE] = ACTIONS(1319),
    [sym_return] = ACTIONS(5673),
    [sym_next] = ACTIONS(5673),
    [sym_break] = ACTIONS(5673),
    [sym_true] = ACTIONS(5673),
    [sym_false] = ACTIONS(5673),
    [sym_null] = ACTIONS(5673),
    [sym_inf] = ACTIONS(5673),
    [sym_nan] = ACTIONS(5673),
    [anon_sym_NA] = ACTIONS(5673),
    [anon_sym_NA_integer_] = ACTIONS(5673),
    [anon_sym_NA_real_] = ACTIONS(5673),
    [anon_sym_NA_complex_] = ACTIONS(5673),
    [anon_sym_NA_character_] = ACTIONS(5673),
    [sym_dots] = ACTIONS(5673),
    [sym_dot_dot_i] = ACTIONS(5669),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5669),
    [sym__newline] = ACTIONS(5669),
    [sym__semicolon] = ACTIONS(5669),
    [sym__raw_string_literal] = ACTIONS(1329),
    [sym__external_open_parenthesis] = ACTIONS(5669),
    [sym__external_open_brace] = ACTIONS(5669),
    [sym__external_close_brace] = ACTIONS(5669),
    [sym__external_open_bracket] = ACTIONS(5669),
    [sym__external_close_bracket] = ACTIONS(5669),
    [sym__external_open_bracket2] = ACTIONS(5669),
  },
  [1567] = {
    [sym_call_arguments] = STATE(2777),
    [sym_subset_arguments] = STATE(2779),
    [sym_subset2_arguments] = STATE(2786),
    [sym__open_parenthesis] = STATE(1411),
    [sym__open_bracket] = STATE(1409),
    [sym__open_bracket2] = STATE(1407),
    [ts_builtin_sym_end] = ACTIONS(5345),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(6497),
    [anon_sym_DASH] = ACTIONS(6499),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(6507),
    [anon_sym_AMP] = ACTIONS(6509),
    [anon_sym_PIPE_PIPE] = ACTIONS(6511),
    [anon_sym_AMP_AMP] = ACTIONS(6513),
    [anon_sym_LT] = ACTIONS(6515),
    [anon_sym_LT_EQ] = ACTIONS(6517),
    [anon_sym_GT] = ACTIONS(6515),
    [anon_sym_GT_EQ] = ACTIONS(6517),
    [anon_sym_EQ_EQ] = ACTIONS(6517),
    [anon_sym_BANG_EQ] = ACTIONS(6517),
    [anon_sym_STAR] = ACTIONS(6519),
    [anon_sym_SLASH] = ACTIONS(6521),
    [anon_sym_STAR_STAR] = ACTIONS(6523),
    [anon_sym_CARET] = ACTIONS(6523),
    [aux_sym_binary_operator_token1] = ACTIONS(6525),
    [anon_sym_PIPE_GT] = ACTIONS(6525),
    [anon_sym_COLON] = ACTIONS(6527),
    [anon_sym_DOLLAR] = ACTIONS(6529),
    [anon_sym_AT] = ACTIONS(6529),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5345),
    [sym__semicolon] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(6531),
    [sym__external_close_parenthesis] = ACTIONS(5345),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(6533),
    [sym__external_open_bracket2] = ACTIONS(6535),
  },
  [1568] = {
    [sym_call_arguments] = STATE(2777),
    [sym_subset_arguments] = STATE(2779),
    [sym_subset2_arguments] = STATE(2786),
    [sym__open_parenthesis] = STATE(1411),
    [sym__open_bracket] = STATE(1409),
    [sym__open_bracket2] = STATE(1407),
    [ts_builtin_sym_end] = ACTIONS(5345),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(6497),
    [anon_sym_DASH] = ACTIONS(6499),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5347),
    [anon_sym_AMP] = ACTIONS(5347),
    [anon_sym_PIPE_PIPE] = ACTIONS(5345),
    [anon_sym_AMP_AMP] = ACTIONS(5345),
    [anon_sym_LT] = ACTIONS(6515),
    [anon_sym_LT_EQ] = ACTIONS(6517),
    [anon_sym_GT] = ACTIONS(6515),
    [anon_sym_GT_EQ] = ACTIONS(6517),
    [anon_sym_EQ_EQ] = ACTIONS(6517),
    [anon_sym_BANG_EQ] = ACTIONS(6517),
    [anon_sym_STAR] = ACTIONS(6519),
    [anon_sym_SLASH] = ACTIONS(6521),
    [anon_sym_STAR_STAR] = ACTIONS(6523),
    [anon_sym_CARET] = ACTIONS(6523),
    [aux_sym_binary_operator_token1] = ACTIONS(6525),
    [anon_sym_PIPE_GT] = ACTIONS(6525),
    [anon_sym_COLON] = ACTIONS(6527),
    [anon_sym_DOLLAR] = ACTIONS(6529),
    [anon_sym_AT] = ACTIONS(6529),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5345),
    [sym__semicolon] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(6531),
    [sym__external_close_parenthesis] = ACTIONS(5345),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(6533),
    [sym__external_open_bracket2] = ACTIONS(6535),
  },
  [1569] = {
    [sym_function_definition] = STATE(2038),
    [sym_if_statement] = STATE(2038),
    [sym_for_statement] = STATE(2038),
    [sym_while_statement] = STATE(2038),
    [sym_repeat_statement] = STATE(2038),
    [sym_braced_expression] = STATE(2038),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_call] = STATE(2038),
    [sym_subset] = STATE(2038),
    [sym_subset2] = STATE(2038),
    [sym__argument] = STATE(4664),
    [sym_argument] = STATE(4659),
    [sym__argument_named] = STATE(4654),
    [sym__argument_unnamed] = STATE(4676),
    [sym__argument_value] = STATE(4677),
    [sym_unary_operator] = STATE(2038),
    [sym_binary_operator] = STATE(2038),
    [sym_extract_operator] = STATE(2038),
    [sym_namespace_operator] = STATE(2038),
    [sym_integer] = STATE(2038),
    [sym_complex] = STATE(2038),
    [sym_float] = STATE(2038),
    [sym__hex_literal] = STATE(2700),
    [sym__float_literal] = STATE(2700),
    [sym_string] = STATE(2597),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym_na] = STATE(2038),
    [sym__expression] = STATE(2038),
    [sym__string_or_identifier] = STATE(5148),
    [sym__open_parenthesis] = STATE(214),
    [sym__open_brace] = STATE(192),
    [sym__close_bracket] = STATE(2571),
    [aux_sym_call_arguments_repeat1] = STATE(2034),
    [sym_identifier] = ACTIONS(6351),
    [anon_sym_BSLASH] = ACTIONS(4754),
    [anon_sym_function] = ACTIONS(4756),
    [anon_sym_if] = ACTIONS(4758),
    [anon_sym_for] = ACTIONS(4760),
    [anon_sym_while] = ACTIONS(4762),
    [anon_sym_repeat] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4766),
    [anon_sym_TILDE] = ACTIONS(4768),
    [anon_sym_BANG] = ACTIONS(6353),
    [anon_sym_PLUS] = ACTIONS(4772),
    [anon_sym_DASH] = ACTIONS(4772),
    [aux_sym__hex_literal_token1] = ACTIONS(4776),
    [sym__number_literal] = ACTIONS(4778),
    [anon_sym_SQUOTE] = ACTIONS(4780),
    [anon_sym_DQUOTE] = ACTIONS(4782),
    [sym_return] = ACTIONS(6355),
    [sym_next] = ACTIONS(6355),
    [sym_break] = ACTIONS(6355),
    [sym_true] = ACTIONS(6355),
    [sym_false] = ACTIONS(6355),
    [sym_null] = ACTIONS(6355),
    [sym_inf] = ACTIONS(6355),
    [sym_nan] = ACTIONS(6355),
    [anon_sym_NA] = ACTIONS(4786),
    [anon_sym_NA_integer_] = ACTIONS(4786),
    [anon_sym_NA_real_] = ACTIONS(4786),
    [anon_sym_NA_complex_] = ACTIONS(4786),
    [anon_sym_NA_character_] = ACTIONS(4786),
    [sym_dots] = ACTIONS(6357),
    [sym_dot_dot_i] = ACTIONS(6359),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6361),
    [sym__newline] = ACTIONS(6363),
    [sym__raw_string_literal] = ACTIONS(4790),
    [sym__external_open_parenthesis] = ACTIONS(4792),
    [sym__external_open_brace] = ACTIONS(4794),
    [sym__external_close_bracket] = ACTIONS(6723),
  },
  [1570] = {
    [sym_call_arguments] = STATE(2853),
    [sym_subset_arguments] = STATE(2854),
    [sym_subset2_arguments] = STATE(2864),
    [sym__open_parenthesis] = STATE(1366),
    [sym__open_bracket] = STATE(1365),
    [sym__open_bracket2] = STATE(1364),
    [sym_identifier] = ACTIONS(5431),
    [anon_sym_BSLASH] = ACTIONS(5429),
    [anon_sym_function] = ACTIONS(5431),
    [anon_sym_EQ] = ACTIONS(5995),
    [anon_sym_if] = ACTIONS(5431),
    [anon_sym_for] = ACTIONS(5431),
    [anon_sym_while] = ACTIONS(5431),
    [anon_sym_repeat] = ACTIONS(5431),
    [anon_sym_QMARK] = ACTIONS(5429),
    [anon_sym_TILDE] = ACTIONS(5997),
    [anon_sym_BANG] = ACTIONS(5431),
    [anon_sym_PLUS] = ACTIONS(5999),
    [anon_sym_DASH] = ACTIONS(6001),
    [anon_sym_LT_DASH] = ACTIONS(6003),
    [anon_sym_LT_LT_DASH] = ACTIONS(6003),
    [anon_sym_COLON_EQ] = ACTIONS(6003),
    [anon_sym_DASH_GT] = ACTIONS(6005),
    [anon_sym_DASH_GT_GT] = ACTIONS(6007),
    [anon_sym_PIPE] = ACTIONS(6009),
    [anon_sym_AMP] = ACTIONS(6011),
    [anon_sym_PIPE_PIPE] = ACTIONS(6013),
    [anon_sym_AMP_AMP] = ACTIONS(6015),
    [anon_sym_LT] = ACTIONS(6017),
    [anon_sym_LT_EQ] = ACTIONS(6019),
    [anon_sym_GT] = ACTIONS(6017),
    [anon_sym_GT_EQ] = ACTIONS(6019),
    [anon_sym_EQ_EQ] = ACTIONS(6019),
    [anon_sym_BANG_EQ] = ACTIONS(6019),
    [anon_sym_STAR] = ACTIONS(6021),
    [anon_sym_SLASH] = ACTIONS(6023),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_CARET] = ACTIONS(6025),
    [aux_sym_binary_operator_token1] = ACTIONS(6027),
    [anon_sym_PIPE_GT] = ACTIONS(6027),
    [anon_sym_COLON] = ACTIONS(6029),
    [anon_sym_DOLLAR] = ACTIONS(6031),
    [anon_sym_AT] = ACTIONS(6031),
    [aux_sym__hex_literal_token1] = ACTIONS(5429),
    [sym__number_literal] = ACTIONS(5431),
    [anon_sym_SQUOTE] = ACTIONS(5429),
    [anon_sym_DQUOTE] = ACTIONS(5429),
    [sym_return] = ACTIONS(5431),
    [sym_next] = ACTIONS(5431),
    [sym_break] = ACTIONS(5431),
    [sym_true] = ACTIONS(5431),
    [sym_false] = ACTIONS(5431),
    [sym_null] = ACTIONS(5431),
    [sym_inf] = ACTIONS(5431),
    [sym_nan] = ACTIONS(5431),
    [anon_sym_NA] = ACTIONS(5431),
    [anon_sym_NA_integer_] = ACTIONS(5431),
    [anon_sym_NA_real_] = ACTIONS(5431),
    [anon_sym_NA_complex_] = ACTIONS(5431),
    [anon_sym_NA_character_] = ACTIONS(5431),
    [sym_dots] = ACTIONS(5431),
    [sym_dot_dot_i] = ACTIONS(5429),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5429),
    [sym__newline] = ACTIONS(5429),
    [sym__raw_string_literal] = ACTIONS(5429),
    [sym__external_else] = ACTIONS(5429),
    [sym__external_open_parenthesis] = ACTIONS(6035),
    [sym__external_open_brace] = ACTIONS(5429),
    [sym__external_open_bracket] = ACTIONS(6037),
    [sym__external_close_bracket] = ACTIONS(5429),
    [sym__external_open_bracket2] = ACTIONS(6039),
  },
  [1571] = {
    [sym_function_definition] = STATE(1940),
    [sym_if_statement] = STATE(1940),
    [sym_for_statement] = STATE(1940),
    [sym_while_statement] = STATE(1940),
    [sym_repeat_statement] = STATE(1940),
    [sym_braced_expression] = STATE(1940),
    [sym_parenthesized_expression] = STATE(1940),
    [sym_call] = STATE(1940),
    [sym_subset] = STATE(1940),
    [sym_subset2] = STATE(1940),
    [sym__argument] = STATE(4665),
    [sym_argument] = STATE(4661),
    [sym__argument_named] = STATE(4669),
    [sym__argument_unnamed] = STATE(4673),
    [sym__argument_value] = STATE(4679),
    [sym_unary_operator] = STATE(1940),
    [sym_binary_operator] = STATE(1940),
    [sym_extract_operator] = STATE(1940),
    [sym_namespace_operator] = STATE(1940),
    [sym_integer] = STATE(1940),
    [sym_complex] = STATE(1940),
    [sym_float] = STATE(1940),
    [sym__hex_literal] = STATE(2656),
    [sym__float_literal] = STATE(2656),
    [sym_string] = STATE(2606),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym_na] = STATE(1940),
    [sym__expression] = STATE(1940),
    [sym__string_or_identifier] = STATE(5141),
    [sym__open_parenthesis] = STATE(218),
    [sym__open_brace] = STATE(185),
    [sym__close_bracket2] = STATE(2570),
    [aux_sym_call_arguments_repeat1] = STATE(1912),
    [sym_identifier] = ACTIONS(6369),
    [anon_sym_BSLASH] = ACTIONS(4644),
    [anon_sym_function] = ACTIONS(4646),
    [anon_sym_if] = ACTIONS(4648),
    [anon_sym_for] = ACTIONS(4650),
    [anon_sym_while] = ACTIONS(4652),
    [anon_sym_repeat] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(6371),
    [anon_sym_PLUS] = ACTIONS(4662),
    [anon_sym_DASH] = ACTIONS(4662),
    [aux_sym__hex_literal_token1] = ACTIONS(4666),
    [sym__number_literal] = ACTIONS(4668),
    [anon_sym_SQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4672),
    [sym_return] = ACTIONS(6373),
    [sym_next] = ACTIONS(6373),
    [sym_break] = ACTIONS(6373),
    [sym_true] = ACTIONS(6373),
    [sym_false] = ACTIONS(6373),
    [sym_null] = ACTIONS(6373),
    [sym_inf] = ACTIONS(6373),
    [sym_nan] = ACTIONS(6373),
    [anon_sym_NA] = ACTIONS(4676),
    [anon_sym_NA_integer_] = ACTIONS(4676),
    [anon_sym_NA_real_] = ACTIONS(4676),
    [anon_sym_NA_complex_] = ACTIONS(4676),
    [anon_sym_NA_character_] = ACTIONS(4676),
    [sym_dots] = ACTIONS(6375),
    [sym_dot_dot_i] = ACTIONS(6377),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6379),
    [sym__newline] = ACTIONS(6381),
    [sym__raw_string_literal] = ACTIONS(4680),
    [sym__external_open_parenthesis] = ACTIONS(4682),
    [sym__external_open_brace] = ACTIONS(4684),
    [sym__external_close_bracket2] = ACTIONS(6725),
  },
  [1572] = {
    [sym_call_arguments] = STATE(2853),
    [sym_subset_arguments] = STATE(2854),
    [sym_subset2_arguments] = STATE(2864),
    [sym__open_parenthesis] = STATE(1366),
    [sym__open_bracket] = STATE(1365),
    [sym__open_bracket2] = STATE(1364),
    [sym_identifier] = ACTIONS(5427),
    [anon_sym_BSLASH] = ACTIONS(5425),
    [anon_sym_function] = ACTIONS(5427),
    [anon_sym_EQ] = ACTIONS(5995),
    [anon_sym_if] = ACTIONS(5427),
    [anon_sym_for] = ACTIONS(5427),
    [anon_sym_while] = ACTIONS(5427),
    [anon_sym_repeat] = ACTIONS(5427),
    [anon_sym_QMARK] = ACTIONS(5425),
    [anon_sym_TILDE] = ACTIONS(5997),
    [anon_sym_BANG] = ACTIONS(5427),
    [anon_sym_PLUS] = ACTIONS(5999),
    [anon_sym_DASH] = ACTIONS(6001),
    [anon_sym_LT_DASH] = ACTIONS(6003),
    [anon_sym_LT_LT_DASH] = ACTIONS(6003),
    [anon_sym_COLON_EQ] = ACTIONS(6003),
    [anon_sym_DASH_GT] = ACTIONS(6005),
    [anon_sym_DASH_GT_GT] = ACTIONS(6007),
    [anon_sym_PIPE] = ACTIONS(6009),
    [anon_sym_AMP] = ACTIONS(6011),
    [anon_sym_PIPE_PIPE] = ACTIONS(6013),
    [anon_sym_AMP_AMP] = ACTIONS(6015),
    [anon_sym_LT] = ACTIONS(6017),
    [anon_sym_LT_EQ] = ACTIONS(6019),
    [anon_sym_GT] = ACTIONS(6017),
    [anon_sym_GT_EQ] = ACTIONS(6019),
    [anon_sym_EQ_EQ] = ACTIONS(6019),
    [anon_sym_BANG_EQ] = ACTIONS(6019),
    [anon_sym_STAR] = ACTIONS(6021),
    [anon_sym_SLASH] = ACTIONS(6023),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_CARET] = ACTIONS(6025),
    [aux_sym_binary_operator_token1] = ACTIONS(6027),
    [anon_sym_PIPE_GT] = ACTIONS(6027),
    [anon_sym_COLON] = ACTIONS(6029),
    [anon_sym_DOLLAR] = ACTIONS(6031),
    [anon_sym_AT] = ACTIONS(6031),
    [aux_sym__hex_literal_token1] = ACTIONS(5425),
    [sym__number_literal] = ACTIONS(5427),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_DQUOTE] = ACTIONS(5425),
    [sym_return] = ACTIONS(5427),
    [sym_next] = ACTIONS(5427),
    [sym_break] = ACTIONS(5427),
    [sym_true] = ACTIONS(5427),
    [sym_false] = ACTIONS(5427),
    [sym_null] = ACTIONS(5427),
    [sym_inf] = ACTIONS(5427),
    [sym_nan] = ACTIONS(5427),
    [anon_sym_NA] = ACTIONS(5427),
    [anon_sym_NA_integer_] = ACTIONS(5427),
    [anon_sym_NA_real_] = ACTIONS(5427),
    [anon_sym_NA_complex_] = ACTIONS(5427),
    [anon_sym_NA_character_] = ACTIONS(5427),
    [sym_dots] = ACTIONS(5427),
    [sym_dot_dot_i] = ACTIONS(5425),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5425),
    [sym__newline] = ACTIONS(5425),
    [sym__raw_string_literal] = ACTIONS(5425),
    [sym__external_else] = ACTIONS(5425),
    [sym__external_open_parenthesis] = ACTIONS(6035),
    [sym__external_open_brace] = ACTIONS(5425),
    [sym__external_open_bracket] = ACTIONS(6037),
    [sym__external_close_bracket] = ACTIONS(5425),
    [sym__external_open_bracket2] = ACTIONS(6039),
  },
  [1573] = {
    [sym_call_arguments] = STATE(2853),
    [sym_subset_arguments] = STATE(2854),
    [sym_subset2_arguments] = STATE(2864),
    [sym__open_parenthesis] = STATE(1366),
    [sym__open_bracket] = STATE(1365),
    [sym__open_bracket2] = STATE(1364),
    [sym_identifier] = ACTIONS(5423),
    [anon_sym_BSLASH] = ACTIONS(5421),
    [anon_sym_function] = ACTIONS(5423),
    [anon_sym_EQ] = ACTIONS(5995),
    [anon_sym_if] = ACTIONS(5423),
    [anon_sym_for] = ACTIONS(5423),
    [anon_sym_while] = ACTIONS(5423),
    [anon_sym_repeat] = ACTIONS(5423),
    [anon_sym_QMARK] = ACTIONS(5421),
    [anon_sym_TILDE] = ACTIONS(5997),
    [anon_sym_BANG] = ACTIONS(5423),
    [anon_sym_PLUS] = ACTIONS(5999),
    [anon_sym_DASH] = ACTIONS(6001),
    [anon_sym_LT_DASH] = ACTIONS(6003),
    [anon_sym_LT_LT_DASH] = ACTIONS(6003),
    [anon_sym_COLON_EQ] = ACTIONS(6003),
    [anon_sym_DASH_GT] = ACTIONS(6005),
    [anon_sym_DASH_GT_GT] = ACTIONS(6007),
    [anon_sym_PIPE] = ACTIONS(6009),
    [anon_sym_AMP] = ACTIONS(6011),
    [anon_sym_PIPE_PIPE] = ACTIONS(6013),
    [anon_sym_AMP_AMP] = ACTIONS(6015),
    [anon_sym_LT] = ACTIONS(6017),
    [anon_sym_LT_EQ] = ACTIONS(6019),
    [anon_sym_GT] = ACTIONS(6017),
    [anon_sym_GT_EQ] = ACTIONS(6019),
    [anon_sym_EQ_EQ] = ACTIONS(6019),
    [anon_sym_BANG_EQ] = ACTIONS(6019),
    [anon_sym_STAR] = ACTIONS(6021),
    [anon_sym_SLASH] = ACTIONS(6023),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_CARET] = ACTIONS(6025),
    [aux_sym_binary_operator_token1] = ACTIONS(6027),
    [anon_sym_PIPE_GT] = ACTIONS(6027),
    [anon_sym_COLON] = ACTIONS(6029),
    [anon_sym_DOLLAR] = ACTIONS(6031),
    [anon_sym_AT] = ACTIONS(6031),
    [aux_sym__hex_literal_token1] = ACTIONS(5421),
    [sym__number_literal] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5421),
    [anon_sym_DQUOTE] = ACTIONS(5421),
    [sym_return] = ACTIONS(5423),
    [sym_next] = ACTIONS(5423),
    [sym_break] = ACTIONS(5423),
    [sym_true] = ACTIONS(5423),
    [sym_false] = ACTIONS(5423),
    [sym_null] = ACTIONS(5423),
    [sym_inf] = ACTIONS(5423),
    [sym_nan] = ACTIONS(5423),
    [anon_sym_NA] = ACTIONS(5423),
    [anon_sym_NA_integer_] = ACTIONS(5423),
    [anon_sym_NA_real_] = ACTIONS(5423),
    [anon_sym_NA_complex_] = ACTIONS(5423),
    [anon_sym_NA_character_] = ACTIONS(5423),
    [sym_dots] = ACTIONS(5423),
    [sym_dot_dot_i] = ACTIONS(5421),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5421),
    [sym__newline] = ACTIONS(5421),
    [sym__raw_string_literal] = ACTIONS(5421),
    [sym__external_else] = ACTIONS(5421),
    [sym__external_open_parenthesis] = ACTIONS(6035),
    [sym__external_open_brace] = ACTIONS(5421),
    [sym__external_open_bracket] = ACTIONS(6037),
    [sym__external_close_bracket] = ACTIONS(5421),
    [sym__external_open_bracket2] = ACTIONS(6039),
  },
  [1574] = {
    [sym_call_arguments] = STATE(2853),
    [sym_subset_arguments] = STATE(2854),
    [sym_subset2_arguments] = STATE(2864),
    [sym__open_parenthesis] = STATE(1366),
    [sym__open_bracket] = STATE(1365),
    [sym__open_bracket2] = STATE(1364),
    [sym_identifier] = ACTIONS(5419),
    [anon_sym_BSLASH] = ACTIONS(5417),
    [anon_sym_function] = ACTIONS(5419),
    [anon_sym_EQ] = ACTIONS(5995),
    [anon_sym_if] = ACTIONS(5419),
    [anon_sym_for] = ACTIONS(5419),
    [anon_sym_while] = ACTIONS(5419),
    [anon_sym_repeat] = ACTIONS(5419),
    [anon_sym_QMARK] = ACTIONS(5417),
    [anon_sym_TILDE] = ACTIONS(5997),
    [anon_sym_BANG] = ACTIONS(5419),
    [anon_sym_PLUS] = ACTIONS(5999),
    [anon_sym_DASH] = ACTIONS(6001),
    [anon_sym_LT_DASH] = ACTIONS(6003),
    [anon_sym_LT_LT_DASH] = ACTIONS(6003),
    [anon_sym_COLON_EQ] = ACTIONS(6003),
    [anon_sym_DASH_GT] = ACTIONS(6005),
    [anon_sym_DASH_GT_GT] = ACTIONS(6007),
    [anon_sym_PIPE] = ACTIONS(6009),
    [anon_sym_AMP] = ACTIONS(6011),
    [anon_sym_PIPE_PIPE] = ACTIONS(6013),
    [anon_sym_AMP_AMP] = ACTIONS(6015),
    [anon_sym_LT] = ACTIONS(6017),
    [anon_sym_LT_EQ] = ACTIONS(6019),
    [anon_sym_GT] = ACTIONS(6017),
    [anon_sym_GT_EQ] = ACTIONS(6019),
    [anon_sym_EQ_EQ] = ACTIONS(6019),
    [anon_sym_BANG_EQ] = ACTIONS(6019),
    [anon_sym_STAR] = ACTIONS(6021),
    [anon_sym_SLASH] = ACTIONS(6023),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_CARET] = ACTIONS(6025),
    [aux_sym_binary_operator_token1] = ACTIONS(6027),
    [anon_sym_PIPE_GT] = ACTIONS(6027),
    [anon_sym_COLON] = ACTIONS(6029),
    [anon_sym_DOLLAR] = ACTIONS(6031),
    [anon_sym_AT] = ACTIONS(6031),
    [aux_sym__hex_literal_token1] = ACTIONS(5417),
    [sym__number_literal] = ACTIONS(5419),
    [anon_sym_SQUOTE] = ACTIONS(5417),
    [anon_sym_DQUOTE] = ACTIONS(5417),
    [sym_return] = ACTIONS(5419),
    [sym_next] = ACTIONS(5419),
    [sym_break] = ACTIONS(5419),
    [sym_true] = ACTIONS(5419),
    [sym_false] = ACTIONS(5419),
    [sym_null] = ACTIONS(5419),
    [sym_inf] = ACTIONS(5419),
    [sym_nan] = ACTIONS(5419),
    [anon_sym_NA] = ACTIONS(5419),
    [anon_sym_NA_integer_] = ACTIONS(5419),
    [anon_sym_NA_real_] = ACTIONS(5419),
    [anon_sym_NA_complex_] = ACTIONS(5419),
    [anon_sym_NA_character_] = ACTIONS(5419),
    [sym_dots] = ACTIONS(5419),
    [sym_dot_dot_i] = ACTIONS(5417),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5417),
    [sym__newline] = ACTIONS(5417),
    [sym__raw_string_literal] = ACTIONS(5417),
    [sym__external_else] = ACTIONS(5417),
    [sym__external_open_parenthesis] = ACTIONS(6035),
    [sym__external_open_brace] = ACTIONS(5417),
    [sym__external_open_bracket] = ACTIONS(6037),
    [sym__external_close_bracket] = ACTIONS(5417),
    [sym__external_open_bracket2] = ACTIONS(6039),
  },
  [1575] = {
    [sym_call_arguments] = STATE(2777),
    [sym_subset_arguments] = STATE(2779),
    [sym_subset2_arguments] = STATE(2786),
    [sym__open_parenthesis] = STATE(1411),
    [sym__open_bracket] = STATE(1409),
    [sym__open_bracket2] = STATE(1407),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(6491),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(6495),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(6497),
    [anon_sym_DASH] = ACTIONS(6499),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(6503),
    [anon_sym_DASH_GT_GT] = ACTIONS(6505),
    [anon_sym_PIPE] = ACTIONS(6507),
    [anon_sym_AMP] = ACTIONS(6509),
    [anon_sym_PIPE_PIPE] = ACTIONS(6511),
    [anon_sym_AMP_AMP] = ACTIONS(6513),
    [anon_sym_LT] = ACTIONS(6515),
    [anon_sym_LT_EQ] = ACTIONS(6517),
    [anon_sym_GT] = ACTIONS(6515),
    [anon_sym_GT_EQ] = ACTIONS(6517),
    [anon_sym_EQ_EQ] = ACTIONS(6517),
    [anon_sym_BANG_EQ] = ACTIONS(6517),
    [anon_sym_STAR] = ACTIONS(6519),
    [anon_sym_SLASH] = ACTIONS(6521),
    [anon_sym_STAR_STAR] = ACTIONS(6523),
    [anon_sym_CARET] = ACTIONS(6523),
    [aux_sym_binary_operator_token1] = ACTIONS(6525),
    [anon_sym_PIPE_GT] = ACTIONS(6525),
    [anon_sym_COLON] = ACTIONS(6527),
    [anon_sym_DOLLAR] = ACTIONS(6529),
    [anon_sym_AT] = ACTIONS(6529),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6531),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6533),
    [sym__external_open_bracket2] = ACTIONS(6535),
  },
  [1576] = {
    [sym_call_arguments] = STATE(2853),
    [sym_subset_arguments] = STATE(2854),
    [sym_subset2_arguments] = STATE(2864),
    [sym__open_parenthesis] = STATE(1366),
    [sym__open_bracket] = STATE(1365),
    [sym__open_bracket2] = STATE(1364),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_BSLASH] = ACTIONS(5413),
    [anon_sym_function] = ACTIONS(5415),
    [anon_sym_EQ] = ACTIONS(5995),
    [anon_sym_if] = ACTIONS(5415),
    [anon_sym_for] = ACTIONS(5415),
    [anon_sym_while] = ACTIONS(5415),
    [anon_sym_repeat] = ACTIONS(5415),
    [anon_sym_QMARK] = ACTIONS(5413),
    [anon_sym_TILDE] = ACTIONS(5997),
    [anon_sym_BANG] = ACTIONS(5415),
    [anon_sym_PLUS] = ACTIONS(5999),
    [anon_sym_DASH] = ACTIONS(6001),
    [anon_sym_LT_DASH] = ACTIONS(6003),
    [anon_sym_LT_LT_DASH] = ACTIONS(6003),
    [anon_sym_COLON_EQ] = ACTIONS(6003),
    [anon_sym_DASH_GT] = ACTIONS(6005),
    [anon_sym_DASH_GT_GT] = ACTIONS(6007),
    [anon_sym_PIPE] = ACTIONS(6009),
    [anon_sym_AMP] = ACTIONS(6011),
    [anon_sym_PIPE_PIPE] = ACTIONS(6013),
    [anon_sym_AMP_AMP] = ACTIONS(6015),
    [anon_sym_LT] = ACTIONS(6017),
    [anon_sym_LT_EQ] = ACTIONS(6019),
    [anon_sym_GT] = ACTIONS(6017),
    [anon_sym_GT_EQ] = ACTIONS(6019),
    [anon_sym_EQ_EQ] = ACTIONS(6019),
    [anon_sym_BANG_EQ] = ACTIONS(6019),
    [anon_sym_STAR] = ACTIONS(6021),
    [anon_sym_SLASH] = ACTIONS(6023),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_CARET] = ACTIONS(6025),
    [aux_sym_binary_operator_token1] = ACTIONS(6027),
    [anon_sym_PIPE_GT] = ACTIONS(6027),
    [anon_sym_COLON] = ACTIONS(6029),
    [anon_sym_DOLLAR] = ACTIONS(6031),
    [anon_sym_AT] = ACTIONS(6031),
    [aux_sym__hex_literal_token1] = ACTIONS(5413),
    [sym__number_literal] = ACTIONS(5415),
    [anon_sym_SQUOTE] = ACTIONS(5413),
    [anon_sym_DQUOTE] = ACTIONS(5413),
    [sym_return] = ACTIONS(5415),
    [sym_next] = ACTIONS(5415),
    [sym_break] = ACTIONS(5415),
    [sym_true] = ACTIONS(5415),
    [sym_false] = ACTIONS(5415),
    [sym_null] = ACTIONS(5415),
    [sym_inf] = ACTIONS(5415),
    [sym_nan] = ACTIONS(5415),
    [anon_sym_NA] = ACTIONS(5415),
    [anon_sym_NA_integer_] = ACTIONS(5415),
    [anon_sym_NA_real_] = ACTIONS(5415),
    [anon_sym_NA_complex_] = ACTIONS(5415),
    [anon_sym_NA_character_] = ACTIONS(5415),
    [sym_dots] = ACTIONS(5415),
    [sym_dot_dot_i] = ACTIONS(5413),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5413),
    [sym__newline] = ACTIONS(5413),
    [sym__raw_string_literal] = ACTIONS(5413),
    [sym__external_else] = ACTIONS(5413),
    [sym__external_open_parenthesis] = ACTIONS(6035),
    [sym__external_open_brace] = ACTIONS(5413),
    [sym__external_open_bracket] = ACTIONS(6037),
    [sym__external_close_bracket] = ACTIONS(5413),
    [sym__external_open_bracket2] = ACTIONS(6039),
  },
  [1577] = {
    [sym_function_definition] = STATE(1940),
    [sym_if_statement] = STATE(1940),
    [sym_for_statement] = STATE(1940),
    [sym_while_statement] = STATE(1940),
    [sym_repeat_statement] = STATE(1940),
    [sym_braced_expression] = STATE(1940),
    [sym_parenthesized_expression] = STATE(1940),
    [sym_call] = STATE(1940),
    [sym_subset] = STATE(1940),
    [sym_subset2] = STATE(1940),
    [sym__argument] = STATE(4665),
    [sym_argument] = STATE(4661),
    [sym__argument_named] = STATE(4669),
    [sym__argument_unnamed] = STATE(4673),
    [sym__argument_value] = STATE(4679),
    [sym_unary_operator] = STATE(1940),
    [sym_binary_operator] = STATE(1940),
    [sym_extract_operator] = STATE(1940),
    [sym_namespace_operator] = STATE(1940),
    [sym_integer] = STATE(1940),
    [sym_complex] = STATE(1940),
    [sym_float] = STATE(1940),
    [sym__hex_literal] = STATE(2656),
    [sym__float_literal] = STATE(2656),
    [sym_string] = STATE(2606),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym_na] = STATE(1940),
    [sym__expression] = STATE(1940),
    [sym__string_or_identifier] = STATE(5141),
    [sym__open_parenthesis] = STATE(218),
    [sym__open_brace] = STATE(185),
    [sym__close_bracket2] = STATE(2753),
    [aux_sym_call_arguments_repeat1] = STATE(1420),
    [sym_identifier] = ACTIONS(6369),
    [anon_sym_BSLASH] = ACTIONS(4644),
    [anon_sym_function] = ACTIONS(4646),
    [anon_sym_if] = ACTIONS(4648),
    [anon_sym_for] = ACTIONS(4650),
    [anon_sym_while] = ACTIONS(4652),
    [anon_sym_repeat] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(6371),
    [anon_sym_PLUS] = ACTIONS(4662),
    [anon_sym_DASH] = ACTIONS(4662),
    [aux_sym__hex_literal_token1] = ACTIONS(4666),
    [sym__number_literal] = ACTIONS(4668),
    [anon_sym_SQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4672),
    [sym_return] = ACTIONS(6373),
    [sym_next] = ACTIONS(6373),
    [sym_break] = ACTIONS(6373),
    [sym_true] = ACTIONS(6373),
    [sym_false] = ACTIONS(6373),
    [sym_null] = ACTIONS(6373),
    [sym_inf] = ACTIONS(6373),
    [sym_nan] = ACTIONS(6373),
    [anon_sym_NA] = ACTIONS(4676),
    [anon_sym_NA_integer_] = ACTIONS(4676),
    [anon_sym_NA_real_] = ACTIONS(4676),
    [anon_sym_NA_complex_] = ACTIONS(4676),
    [anon_sym_NA_character_] = ACTIONS(4676),
    [sym_dots] = ACTIONS(6375),
    [sym_dot_dot_i] = ACTIONS(6377),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6379),
    [sym__newline] = ACTIONS(6381),
    [sym__raw_string_literal] = ACTIONS(4680),
    [sym__external_open_parenthesis] = ACTIONS(4682),
    [sym__external_open_brace] = ACTIONS(4684),
    [sym__external_close_bracket2] = ACTIONS(6727),
  },
  [1578] = {
    [sym_call_arguments] = STATE(2853),
    [sym_subset_arguments] = STATE(2854),
    [sym_subset2_arguments] = STATE(2864),
    [sym__open_parenthesis] = STATE(1366),
    [sym__open_bracket] = STATE(1365),
    [sym__open_bracket2] = STATE(1364),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_CARET] = ACTIONS(6025),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(5261),
    [anon_sym_DOLLAR] = ACTIONS(6031),
    [anon_sym_AT] = ACTIONS(6031),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6035),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6037),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(6039),
  },
  [1579] = {
    [sym_call_arguments] = STATE(2840),
    [sym_subset_arguments] = STATE(2797),
    [sym_subset2_arguments] = STATE(2801),
    [sym__open_parenthesis] = STATE(1344),
    [sym__open_bracket] = STATE(1374),
    [sym__open_bracket2] = STATE(1452),
    [ts_builtin_sym_end] = ACTIONS(5425),
    [sym_identifier] = ACTIONS(5427),
    [anon_sym_BSLASH] = ACTIONS(5425),
    [anon_sym_function] = ACTIONS(5427),
    [anon_sym_EQ] = ACTIONS(6263),
    [anon_sym_if] = ACTIONS(5427),
    [anon_sym_for] = ACTIONS(5427),
    [anon_sym_while] = ACTIONS(5427),
    [anon_sym_repeat] = ACTIONS(5427),
    [anon_sym_QMARK] = ACTIONS(5425),
    [anon_sym_TILDE] = ACTIONS(6265),
    [anon_sym_BANG] = ACTIONS(5427),
    [anon_sym_PLUS] = ACTIONS(6267),
    [anon_sym_DASH] = ACTIONS(6269),
    [anon_sym_LT_DASH] = ACTIONS(6271),
    [anon_sym_LT_LT_DASH] = ACTIONS(6271),
    [anon_sym_COLON_EQ] = ACTIONS(6271),
    [anon_sym_DASH_GT] = ACTIONS(6273),
    [anon_sym_DASH_GT_GT] = ACTIONS(6275),
    [anon_sym_PIPE] = ACTIONS(6277),
    [anon_sym_AMP] = ACTIONS(6279),
    [anon_sym_PIPE_PIPE] = ACTIONS(6281),
    [anon_sym_AMP_AMP] = ACTIONS(6283),
    [anon_sym_LT] = ACTIONS(6285),
    [anon_sym_LT_EQ] = ACTIONS(6287),
    [anon_sym_GT] = ACTIONS(6285),
    [anon_sym_GT_EQ] = ACTIONS(6287),
    [anon_sym_EQ_EQ] = ACTIONS(6287),
    [anon_sym_BANG_EQ] = ACTIONS(6287),
    [anon_sym_STAR] = ACTIONS(6289),
    [anon_sym_SLASH] = ACTIONS(6291),
    [anon_sym_STAR_STAR] = ACTIONS(6293),
    [anon_sym_CARET] = ACTIONS(6293),
    [aux_sym_binary_operator_token1] = ACTIONS(6295),
    [anon_sym_PIPE_GT] = ACTIONS(6295),
    [anon_sym_COLON] = ACTIONS(6297),
    [anon_sym_DOLLAR] = ACTIONS(6299),
    [anon_sym_AT] = ACTIONS(6299),
    [aux_sym__hex_literal_token1] = ACTIONS(5425),
    [sym__number_literal] = ACTIONS(5427),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_DQUOTE] = ACTIONS(5425),
    [sym_return] = ACTIONS(5427),
    [sym_next] = ACTIONS(5427),
    [sym_break] = ACTIONS(5427),
    [sym_true] = ACTIONS(5427),
    [sym_false] = ACTIONS(5427),
    [sym_null] = ACTIONS(5427),
    [sym_inf] = ACTIONS(5427),
    [sym_nan] = ACTIONS(5427),
    [anon_sym_NA] = ACTIONS(5427),
    [anon_sym_NA_integer_] = ACTIONS(5427),
    [anon_sym_NA_real_] = ACTIONS(5427),
    [anon_sym_NA_complex_] = ACTIONS(5427),
    [anon_sym_NA_character_] = ACTIONS(5427),
    [sym_dots] = ACTIONS(5427),
    [sym_dot_dot_i] = ACTIONS(5425),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5425),
    [sym__semicolon] = ACTIONS(5425),
    [sym__raw_string_literal] = ACTIONS(5425),
    [sym__external_open_parenthesis] = ACTIONS(6301),
    [sym__external_open_brace] = ACTIONS(5425),
    [sym__external_close_brace] = ACTIONS(5425),
    [sym__external_open_bracket] = ACTIONS(6303),
    [sym__external_open_bracket2] = ACTIONS(6305),
  },
  [1580] = {
    [sym_call_arguments] = STATE(2840),
    [sym_subset_arguments] = STATE(2797),
    [sym_subset2_arguments] = STATE(2801),
    [sym__open_parenthesis] = STATE(1344),
    [sym__open_bracket] = STATE(1374),
    [sym__open_bracket2] = STATE(1452),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(6263),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(6265),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(6267),
    [anon_sym_DASH] = ACTIONS(6269),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(6273),
    [anon_sym_DASH_GT_GT] = ACTIONS(6275),
    [anon_sym_PIPE] = ACTIONS(6277),
    [anon_sym_AMP] = ACTIONS(6279),
    [anon_sym_PIPE_PIPE] = ACTIONS(6281),
    [anon_sym_AMP_AMP] = ACTIONS(6283),
    [anon_sym_LT] = ACTIONS(6285),
    [anon_sym_LT_EQ] = ACTIONS(6287),
    [anon_sym_GT] = ACTIONS(6285),
    [anon_sym_GT_EQ] = ACTIONS(6287),
    [anon_sym_EQ_EQ] = ACTIONS(6287),
    [anon_sym_BANG_EQ] = ACTIONS(6287),
    [anon_sym_STAR] = ACTIONS(6289),
    [anon_sym_SLASH] = ACTIONS(6291),
    [anon_sym_STAR_STAR] = ACTIONS(6293),
    [anon_sym_CARET] = ACTIONS(6293),
    [aux_sym_binary_operator_token1] = ACTIONS(6295),
    [anon_sym_PIPE_GT] = ACTIONS(6295),
    [anon_sym_COLON] = ACTIONS(6297),
    [anon_sym_DOLLAR] = ACTIONS(6299),
    [anon_sym_AT] = ACTIONS(6299),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6301),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6303),
    [sym__external_open_bracket2] = ACTIONS(6305),
  },
  [1581] = {
    [sym_string] = STATE(2604),
    [sym__single_quoted_string] = STATE(2289),
    [sym__double_quoted_string] = STATE(2290),
    [sym__string_or_identifier] = STATE(2604),
    [aux_sym_function_definition_repeat1] = STATE(2460),
    [sym_identifier] = ACTIONS(6729),
    [anon_sym_BSLASH] = ACTIONS(5669),
    [anon_sym_function] = ACTIONS(5673),
    [anon_sym_EQ] = ACTIONS(5673),
    [anon_sym_if] = ACTIONS(5673),
    [anon_sym_for] = ACTIONS(5673),
    [anon_sym_while] = ACTIONS(5673),
    [anon_sym_repeat] = ACTIONS(5673),
    [anon_sym_QMARK] = ACTIONS(5669),
    [anon_sym_TILDE] = ACTIONS(5669),
    [anon_sym_BANG] = ACTIONS(5673),
    [anon_sym_PLUS] = ACTIONS(5669),
    [anon_sym_DASH] = ACTIONS(5673),
    [anon_sym_LT_DASH] = ACTIONS(5669),
    [anon_sym_LT_LT_DASH] = ACTIONS(5669),
    [anon_sym_COLON_EQ] = ACTIONS(5669),
    [anon_sym_DASH_GT] = ACTIONS(5673),
    [anon_sym_DASH_GT_GT] = ACTIONS(5669),
    [anon_sym_PIPE] = ACTIONS(5673),
    [anon_sym_AMP] = ACTIONS(5673),
    [anon_sym_PIPE_PIPE] = ACTIONS(5669),
    [anon_sym_AMP_AMP] = ACTIONS(5669),
    [anon_sym_LT] = ACTIONS(5673),
    [anon_sym_LT_EQ] = ACTIONS(5669),
    [anon_sym_GT] = ACTIONS(5673),
    [anon_sym_GT_EQ] = ACTIONS(5669),
    [anon_sym_EQ_EQ] = ACTIONS(5669),
    [anon_sym_BANG_EQ] = ACTIONS(5669),
    [anon_sym_STAR] = ACTIONS(5673),
    [anon_sym_SLASH] = ACTIONS(5669),
    [anon_sym_STAR_STAR] = ACTIONS(5669),
    [anon_sym_CARET] = ACTIONS(5669),
    [aux_sym_binary_operator_token1] = ACTIONS(5669),
    [anon_sym_PIPE_GT] = ACTIONS(5669),
    [anon_sym_COLON] = ACTIONS(5673),
    [anon_sym_DOLLAR] = ACTIONS(5669),
    [anon_sym_AT] = ACTIONS(5669),
    [aux_sym__hex_literal_token1] = ACTIONS(5669),
    [sym__number_literal] = ACTIONS(5673),
    [anon_sym_SQUOTE] = ACTIONS(1596),
    [anon_sym_DQUOTE] = ACTIONS(1598),
    [sym_return] = ACTIONS(5673),
    [sym_next] = ACTIONS(5673),
    [sym_break] = ACTIONS(5673),
    [sym_true] = ACTIONS(5673),
    [sym_false] = ACTIONS(5673),
    [sym_null] = ACTIONS(5673),
    [sym_inf] = ACTIONS(5673),
    [sym_nan] = ACTIONS(5673),
    [anon_sym_NA] = ACTIONS(5673),
    [anon_sym_NA_integer_] = ACTIONS(5673),
    [anon_sym_NA_real_] = ACTIONS(5673),
    [anon_sym_NA_complex_] = ACTIONS(5673),
    [anon_sym_NA_character_] = ACTIONS(5673),
    [sym_dots] = ACTIONS(5673),
    [sym_dot_dot_i] = ACTIONS(5669),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5669),
    [sym__newline] = ACTIONS(5669),
    [sym__raw_string_literal] = ACTIONS(1608),
    [sym__external_else] = ACTIONS(5669),
    [sym__external_open_parenthesis] = ACTIONS(5669),
    [sym__external_close_parenthesis] = ACTIONS(5669),
    [sym__external_open_brace] = ACTIONS(5669),
    [sym__external_open_bracket] = ACTIONS(5669),
    [sym__external_open_bracket2] = ACTIONS(5669),
    [sym__external_close_bracket2] = ACTIONS(5669),
  },
  [1582] = {
    [sym_function_definition] = STATE(2038),
    [sym_if_statement] = STATE(2038),
    [sym_for_statement] = STATE(2038),
    [sym_while_statement] = STATE(2038),
    [sym_repeat_statement] = STATE(2038),
    [sym_braced_expression] = STATE(2038),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_call] = STATE(2038),
    [sym_subset] = STATE(2038),
    [sym_subset2] = STATE(2038),
    [sym__argument] = STATE(4664),
    [sym_argument] = STATE(4659),
    [sym__argument_named] = STATE(4654),
    [sym__argument_unnamed] = STATE(4676),
    [sym__argument_value] = STATE(4677),
    [sym_unary_operator] = STATE(2038),
    [sym_binary_operator] = STATE(2038),
    [sym_extract_operator] = STATE(2038),
    [sym_namespace_operator] = STATE(2038),
    [sym_integer] = STATE(2038),
    [sym_complex] = STATE(2038),
    [sym_float] = STATE(2038),
    [sym__hex_literal] = STATE(2700),
    [sym__float_literal] = STATE(2700),
    [sym_string] = STATE(2597),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym_na] = STATE(2038),
    [sym__expression] = STATE(2038),
    [sym__string_or_identifier] = STATE(5148),
    [sym__open_parenthesis] = STATE(214),
    [sym__open_brace] = STATE(192),
    [sym__close_bracket] = STATE(2752),
    [aux_sym_call_arguments_repeat1] = STATE(1418),
    [sym_identifier] = ACTIONS(6351),
    [anon_sym_BSLASH] = ACTIONS(4754),
    [anon_sym_function] = ACTIONS(4756),
    [anon_sym_if] = ACTIONS(4758),
    [anon_sym_for] = ACTIONS(4760),
    [anon_sym_while] = ACTIONS(4762),
    [anon_sym_repeat] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4766),
    [anon_sym_TILDE] = ACTIONS(4768),
    [anon_sym_BANG] = ACTIONS(6353),
    [anon_sym_PLUS] = ACTIONS(4772),
    [anon_sym_DASH] = ACTIONS(4772),
    [aux_sym__hex_literal_token1] = ACTIONS(4776),
    [sym__number_literal] = ACTIONS(4778),
    [anon_sym_SQUOTE] = ACTIONS(4780),
    [anon_sym_DQUOTE] = ACTIONS(4782),
    [sym_return] = ACTIONS(6355),
    [sym_next] = ACTIONS(6355),
    [sym_break] = ACTIONS(6355),
    [sym_true] = ACTIONS(6355),
    [sym_false] = ACTIONS(6355),
    [sym_null] = ACTIONS(6355),
    [sym_inf] = ACTIONS(6355),
    [sym_nan] = ACTIONS(6355),
    [anon_sym_NA] = ACTIONS(4786),
    [anon_sym_NA_integer_] = ACTIONS(4786),
    [anon_sym_NA_real_] = ACTIONS(4786),
    [anon_sym_NA_complex_] = ACTIONS(4786),
    [anon_sym_NA_character_] = ACTIONS(4786),
    [sym_dots] = ACTIONS(6357),
    [sym_dot_dot_i] = ACTIONS(6359),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6361),
    [sym__newline] = ACTIONS(6363),
    [sym__raw_string_literal] = ACTIONS(4790),
    [sym__external_open_parenthesis] = ACTIONS(4792),
    [sym__external_open_brace] = ACTIONS(4794),
    [sym__external_close_bracket] = ACTIONS(6731),
  },
  [1583] = {
    [sym_function_definition] = STATE(2038),
    [sym_if_statement] = STATE(2038),
    [sym_for_statement] = STATE(2038),
    [sym_while_statement] = STATE(2038),
    [sym_repeat_statement] = STATE(2038),
    [sym_braced_expression] = STATE(2038),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_call] = STATE(2038),
    [sym_subset] = STATE(2038),
    [sym_subset2] = STATE(2038),
    [sym__argument] = STATE(4664),
    [sym_argument] = STATE(4659),
    [sym__argument_named] = STATE(4654),
    [sym__argument_unnamed] = STATE(4676),
    [sym__argument_value] = STATE(4677),
    [sym_unary_operator] = STATE(2038),
    [sym_binary_operator] = STATE(2038),
    [sym_extract_operator] = STATE(2038),
    [sym_namespace_operator] = STATE(2038),
    [sym_integer] = STATE(2038),
    [sym_complex] = STATE(2038),
    [sym_float] = STATE(2038),
    [sym__hex_literal] = STATE(2700),
    [sym__float_literal] = STATE(2700),
    [sym_string] = STATE(2597),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym_na] = STATE(2038),
    [sym__expression] = STATE(2038),
    [sym__string_or_identifier] = STATE(5148),
    [sym__open_parenthesis] = STATE(214),
    [sym__open_brace] = STATE(192),
    [sym__close_bracket] = STATE(2600),
    [aux_sym_call_arguments_repeat1] = STATE(2034),
    [sym_identifier] = ACTIONS(6351),
    [anon_sym_BSLASH] = ACTIONS(4754),
    [anon_sym_function] = ACTIONS(4756),
    [anon_sym_if] = ACTIONS(4758),
    [anon_sym_for] = ACTIONS(4760),
    [anon_sym_while] = ACTIONS(4762),
    [anon_sym_repeat] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4766),
    [anon_sym_TILDE] = ACTIONS(4768),
    [anon_sym_BANG] = ACTIONS(6353),
    [anon_sym_PLUS] = ACTIONS(4772),
    [anon_sym_DASH] = ACTIONS(4772),
    [aux_sym__hex_literal_token1] = ACTIONS(4776),
    [sym__number_literal] = ACTIONS(4778),
    [anon_sym_SQUOTE] = ACTIONS(4780),
    [anon_sym_DQUOTE] = ACTIONS(4782),
    [sym_return] = ACTIONS(6355),
    [sym_next] = ACTIONS(6355),
    [sym_break] = ACTIONS(6355),
    [sym_true] = ACTIONS(6355),
    [sym_false] = ACTIONS(6355),
    [sym_null] = ACTIONS(6355),
    [sym_inf] = ACTIONS(6355),
    [sym_nan] = ACTIONS(6355),
    [anon_sym_NA] = ACTIONS(4786),
    [anon_sym_NA_integer_] = ACTIONS(4786),
    [anon_sym_NA_real_] = ACTIONS(4786),
    [anon_sym_NA_complex_] = ACTIONS(4786),
    [anon_sym_NA_character_] = ACTIONS(4786),
    [sym_dots] = ACTIONS(6357),
    [sym_dot_dot_i] = ACTIONS(6359),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6361),
    [sym__newline] = ACTIONS(6363),
    [sym__raw_string_literal] = ACTIONS(4790),
    [sym__external_open_parenthesis] = ACTIONS(4792),
    [sym__external_open_brace] = ACTIONS(4794),
    [sym__external_close_bracket] = ACTIONS(6733),
  },
  [1584] = {
    [sym_function_definition] = STATE(1931),
    [sym_if_statement] = STATE(1931),
    [sym_for_statement] = STATE(1931),
    [sym_while_statement] = STATE(1931),
    [sym_repeat_statement] = STATE(1931),
    [sym_braced_expression] = STATE(1931),
    [sym_parenthesized_expression] = STATE(1931),
    [sym_call] = STATE(1931),
    [sym_subset] = STATE(1931),
    [sym_subset2] = STATE(1931),
    [sym__argument] = STATE(4656),
    [sym_argument] = STATE(4657),
    [sym__argument_named] = STATE(4658),
    [sym__argument_unnamed] = STATE(4662),
    [sym__argument_value] = STATE(4663),
    [sym_unary_operator] = STATE(1931),
    [sym_binary_operator] = STATE(1931),
    [sym_extract_operator] = STATE(1931),
    [sym_namespace_operator] = STATE(1931),
    [sym_integer] = STATE(1931),
    [sym_complex] = STATE(1931),
    [sym_float] = STATE(1931),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2633),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(1931),
    [sym__expression] = STATE(1931),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__close_parenthesis] = STATE(2746),
    [sym__open_brace] = STATE(154),
    [aux_sym_call_arguments_repeat1] = STATE(1620),
    [sym_identifier] = ACTIONS(6387),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(6389),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3865),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(6391),
    [sym_next] = ACTIONS(6391),
    [sym_break] = ACTIONS(6391),
    [sym_true] = ACTIONS(6391),
    [sym_false] = ACTIONS(6391),
    [sym_null] = ACTIONS(6391),
    [sym_inf] = ACTIONS(6391),
    [sym_nan] = ACTIONS(6391),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(6393),
    [sym_dot_dot_i] = ACTIONS(6395),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6397),
    [sym__newline] = ACTIONS(6399),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(6735),
    [sym__external_open_brace] = ACTIONS(3891),
  },
  [1585] = {
    [sym_function_definition] = STATE(1940),
    [sym_if_statement] = STATE(1940),
    [sym_for_statement] = STATE(1940),
    [sym_while_statement] = STATE(1940),
    [sym_repeat_statement] = STATE(1940),
    [sym_braced_expression] = STATE(1940),
    [sym_parenthesized_expression] = STATE(1940),
    [sym_call] = STATE(1940),
    [sym_subset] = STATE(1940),
    [sym_subset2] = STATE(1940),
    [sym__argument] = STATE(4665),
    [sym_argument] = STATE(4661),
    [sym__argument_named] = STATE(4669),
    [sym__argument_unnamed] = STATE(4673),
    [sym__argument_value] = STATE(4679),
    [sym_unary_operator] = STATE(1940),
    [sym_binary_operator] = STATE(1940),
    [sym_extract_operator] = STATE(1940),
    [sym_namespace_operator] = STATE(1940),
    [sym_integer] = STATE(1940),
    [sym_complex] = STATE(1940),
    [sym_float] = STATE(1940),
    [sym__hex_literal] = STATE(2656),
    [sym__float_literal] = STATE(2656),
    [sym_string] = STATE(2606),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym_na] = STATE(1940),
    [sym__expression] = STATE(1940),
    [sym__string_or_identifier] = STATE(5141),
    [sym__open_parenthesis] = STATE(218),
    [sym__open_brace] = STATE(185),
    [sym__close_bracket2] = STATE(2599),
    [aux_sym_call_arguments_repeat1] = STATE(1912),
    [sym_identifier] = ACTIONS(6369),
    [anon_sym_BSLASH] = ACTIONS(4644),
    [anon_sym_function] = ACTIONS(4646),
    [anon_sym_if] = ACTIONS(4648),
    [anon_sym_for] = ACTIONS(4650),
    [anon_sym_while] = ACTIONS(4652),
    [anon_sym_repeat] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(6371),
    [anon_sym_PLUS] = ACTIONS(4662),
    [anon_sym_DASH] = ACTIONS(4662),
    [aux_sym__hex_literal_token1] = ACTIONS(4666),
    [sym__number_literal] = ACTIONS(4668),
    [anon_sym_SQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4672),
    [sym_return] = ACTIONS(6373),
    [sym_next] = ACTIONS(6373),
    [sym_break] = ACTIONS(6373),
    [sym_true] = ACTIONS(6373),
    [sym_false] = ACTIONS(6373),
    [sym_null] = ACTIONS(6373),
    [sym_inf] = ACTIONS(6373),
    [sym_nan] = ACTIONS(6373),
    [anon_sym_NA] = ACTIONS(4676),
    [anon_sym_NA_integer_] = ACTIONS(4676),
    [anon_sym_NA_real_] = ACTIONS(4676),
    [anon_sym_NA_complex_] = ACTIONS(4676),
    [anon_sym_NA_character_] = ACTIONS(4676),
    [sym_dots] = ACTIONS(6375),
    [sym_dot_dot_i] = ACTIONS(6377),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6379),
    [sym__newline] = ACTIONS(6381),
    [sym__raw_string_literal] = ACTIONS(4680),
    [sym__external_open_parenthesis] = ACTIONS(4682),
    [sym__external_open_brace] = ACTIONS(4684),
    [sym__external_close_bracket2] = ACTIONS(6737),
  },
  [1586] = {
    [sym_string] = STATE(2491),
    [sym__single_quoted_string] = STATE(2188),
    [sym__double_quoted_string] = STATE(2187),
    [sym__string_or_identifier] = STATE(2491),
    [sym_identifier] = ACTIONS(6739),
    [anon_sym_BSLASH] = ACTIONS(5883),
    [anon_sym_function] = ACTIONS(5887),
    [anon_sym_EQ] = ACTIONS(5887),
    [anon_sym_if] = ACTIONS(5887),
    [anon_sym_for] = ACTIONS(5887),
    [anon_sym_while] = ACTIONS(5887),
    [anon_sym_repeat] = ACTIONS(5887),
    [anon_sym_QMARK] = ACTIONS(5883),
    [anon_sym_TILDE] = ACTIONS(5883),
    [anon_sym_BANG] = ACTIONS(5887),
    [anon_sym_PLUS] = ACTIONS(5883),
    [anon_sym_DASH] = ACTIONS(5887),
    [anon_sym_LT_DASH] = ACTIONS(5883),
    [anon_sym_LT_LT_DASH] = ACTIONS(5883),
    [anon_sym_COLON_EQ] = ACTIONS(5883),
    [anon_sym_DASH_GT] = ACTIONS(5887),
    [anon_sym_DASH_GT_GT] = ACTIONS(5883),
    [anon_sym_PIPE] = ACTIONS(5887),
    [anon_sym_AMP] = ACTIONS(5887),
    [anon_sym_PIPE_PIPE] = ACTIONS(5883),
    [anon_sym_AMP_AMP] = ACTIONS(5883),
    [anon_sym_LT] = ACTIONS(5887),
    [anon_sym_LT_EQ] = ACTIONS(5883),
    [anon_sym_GT] = ACTIONS(5887),
    [anon_sym_GT_EQ] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5883),
    [anon_sym_BANG_EQ] = ACTIONS(5883),
    [anon_sym_STAR] = ACTIONS(5887),
    [anon_sym_SLASH] = ACTIONS(5883),
    [anon_sym_STAR_STAR] = ACTIONS(5883),
    [anon_sym_CARET] = ACTIONS(5883),
    [aux_sym_binary_operator_token1] = ACTIONS(5883),
    [anon_sym_PIPE_GT] = ACTIONS(5883),
    [anon_sym_COLON] = ACTIONS(5887),
    [anon_sym_DOLLAR] = ACTIONS(5883),
    [anon_sym_AT] = ACTIONS(5883),
    [aux_sym__hex_literal_token1] = ACTIONS(5883),
    [sym__number_literal] = ACTIONS(5887),
    [anon_sym_SQUOTE] = ACTIONS(301),
    [anon_sym_DQUOTE] = ACTIONS(303),
    [sym_return] = ACTIONS(5887),
    [sym_next] = ACTIONS(5887),
    [sym_break] = ACTIONS(5887),
    [sym_true] = ACTIONS(5887),
    [sym_false] = ACTIONS(5887),
    [sym_null] = ACTIONS(5887),
    [sym_inf] = ACTIONS(5887),
    [sym_nan] = ACTIONS(5887),
    [anon_sym_NA] = ACTIONS(5887),
    [anon_sym_NA_integer_] = ACTIONS(5887),
    [anon_sym_NA_real_] = ACTIONS(5887),
    [anon_sym_NA_complex_] = ACTIONS(5887),
    [anon_sym_NA_character_] = ACTIONS(5887),
    [sym_dots] = ACTIONS(5887),
    [sym_dot_dot_i] = ACTIONS(5883),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5883),
    [sym__newline] = ACTIONS(5883),
    [sym__semicolon] = ACTIONS(5883),
    [sym__raw_string_literal] = ACTIONS(313),
    [sym__external_open_parenthesis] = ACTIONS(5883),
    [sym__external_close_parenthesis] = ACTIONS(5883),
    [sym__external_open_brace] = ACTIONS(5883),
    [sym__external_close_brace] = ACTIONS(5883),
    [sym__external_open_bracket] = ACTIONS(5883),
    [sym__external_close_bracket] = ACTIONS(5883),
    [sym__external_open_bracket2] = ACTIONS(5883),
  },
  [1587] = {
    [sym_function_definition] = STATE(1931),
    [sym_if_statement] = STATE(1931),
    [sym_for_statement] = STATE(1931),
    [sym_while_statement] = STATE(1931),
    [sym_repeat_statement] = STATE(1931),
    [sym_braced_expression] = STATE(1931),
    [sym_parenthesized_expression] = STATE(1931),
    [sym_call] = STATE(1931),
    [sym_subset] = STATE(1931),
    [sym_subset2] = STATE(1931),
    [sym__argument] = STATE(4656),
    [sym_argument] = STATE(4657),
    [sym__argument_named] = STATE(4658),
    [sym__argument_unnamed] = STATE(4662),
    [sym__argument_value] = STATE(4663),
    [sym_unary_operator] = STATE(1931),
    [sym_binary_operator] = STATE(1931),
    [sym_extract_operator] = STATE(1931),
    [sym_namespace_operator] = STATE(1931),
    [sym_integer] = STATE(1931),
    [sym_complex] = STATE(1931),
    [sym_float] = STATE(1931),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2633),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(1931),
    [sym__expression] = STATE(1931),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__close_parenthesis] = STATE(2757),
    [sym__open_brace] = STATE(154),
    [aux_sym_call_arguments_repeat1] = STATE(2113),
    [sym_identifier] = ACTIONS(6387),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(6389),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3865),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(6391),
    [sym_next] = ACTIONS(6391),
    [sym_break] = ACTIONS(6391),
    [sym_true] = ACTIONS(6391),
    [sym_false] = ACTIONS(6391),
    [sym_null] = ACTIONS(6391),
    [sym_inf] = ACTIONS(6391),
    [sym_nan] = ACTIONS(6391),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(6393),
    [sym_dot_dot_i] = ACTIONS(6395),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6397),
    [sym__newline] = ACTIONS(6399),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(6741),
    [sym__external_open_brace] = ACTIONS(3891),
  },
  [1588] = {
    [sym_function_definition] = STATE(1940),
    [sym_if_statement] = STATE(1940),
    [sym_for_statement] = STATE(1940),
    [sym_while_statement] = STATE(1940),
    [sym_repeat_statement] = STATE(1940),
    [sym_braced_expression] = STATE(1940),
    [sym_parenthesized_expression] = STATE(1940),
    [sym_call] = STATE(1940),
    [sym_subset] = STATE(1940),
    [sym_subset2] = STATE(1940),
    [sym__argument] = STATE(4665),
    [sym_argument] = STATE(4661),
    [sym__argument_named] = STATE(4669),
    [sym__argument_unnamed] = STATE(4673),
    [sym__argument_value] = STATE(4679),
    [sym_unary_operator] = STATE(1940),
    [sym_binary_operator] = STATE(1940),
    [sym_extract_operator] = STATE(1940),
    [sym_namespace_operator] = STATE(1940),
    [sym_integer] = STATE(1940),
    [sym_complex] = STATE(1940),
    [sym_float] = STATE(1940),
    [sym__hex_literal] = STATE(2656),
    [sym__float_literal] = STATE(2656),
    [sym_string] = STATE(2606),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym_na] = STATE(1940),
    [sym__expression] = STATE(1940),
    [sym__string_or_identifier] = STATE(5141),
    [sym__open_parenthesis] = STATE(218),
    [sym__open_brace] = STATE(185),
    [sym__close_bracket2] = STATE(2472),
    [aux_sym_call_arguments_repeat1] = STATE(1403),
    [sym_identifier] = ACTIONS(6369),
    [anon_sym_BSLASH] = ACTIONS(4644),
    [anon_sym_function] = ACTIONS(4646),
    [anon_sym_if] = ACTIONS(4648),
    [anon_sym_for] = ACTIONS(4650),
    [anon_sym_while] = ACTIONS(4652),
    [anon_sym_repeat] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(6371),
    [anon_sym_PLUS] = ACTIONS(4662),
    [anon_sym_DASH] = ACTIONS(4662),
    [aux_sym__hex_literal_token1] = ACTIONS(4666),
    [sym__number_literal] = ACTIONS(4668),
    [anon_sym_SQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4672),
    [sym_return] = ACTIONS(6373),
    [sym_next] = ACTIONS(6373),
    [sym_break] = ACTIONS(6373),
    [sym_true] = ACTIONS(6373),
    [sym_false] = ACTIONS(6373),
    [sym_null] = ACTIONS(6373),
    [sym_inf] = ACTIONS(6373),
    [sym_nan] = ACTIONS(6373),
    [anon_sym_NA] = ACTIONS(4676),
    [anon_sym_NA_integer_] = ACTIONS(4676),
    [anon_sym_NA_real_] = ACTIONS(4676),
    [anon_sym_NA_complex_] = ACTIONS(4676),
    [anon_sym_NA_character_] = ACTIONS(4676),
    [sym_dots] = ACTIONS(6375),
    [sym_dot_dot_i] = ACTIONS(6377),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6379),
    [sym__newline] = ACTIONS(6381),
    [sym__raw_string_literal] = ACTIONS(4680),
    [sym__external_open_parenthesis] = ACTIONS(4682),
    [sym__external_open_brace] = ACTIONS(4684),
    [sym__external_close_bracket2] = ACTIONS(6743),
  },
  [1589] = {
    [sym_function_definition] = STATE(2038),
    [sym_if_statement] = STATE(2038),
    [sym_for_statement] = STATE(2038),
    [sym_while_statement] = STATE(2038),
    [sym_repeat_statement] = STATE(2038),
    [sym_braced_expression] = STATE(2038),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_call] = STATE(2038),
    [sym_subset] = STATE(2038),
    [sym_subset2] = STATE(2038),
    [sym__argument] = STATE(4664),
    [sym_argument] = STATE(4659),
    [sym__argument_named] = STATE(4654),
    [sym__argument_unnamed] = STATE(4676),
    [sym__argument_value] = STATE(4677),
    [sym_unary_operator] = STATE(2038),
    [sym_binary_operator] = STATE(2038),
    [sym_extract_operator] = STATE(2038),
    [sym_namespace_operator] = STATE(2038),
    [sym_integer] = STATE(2038),
    [sym_complex] = STATE(2038),
    [sym_float] = STATE(2038),
    [sym__hex_literal] = STATE(2700),
    [sym__float_literal] = STATE(2700),
    [sym_string] = STATE(2597),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym_na] = STATE(2038),
    [sym__expression] = STATE(2038),
    [sym__string_or_identifier] = STATE(5148),
    [sym__open_parenthesis] = STATE(214),
    [sym__open_brace] = STATE(192),
    [sym__close_bracket] = STATE(2480),
    [aux_sym_call_arguments_repeat1] = STATE(1405),
    [sym_identifier] = ACTIONS(6351),
    [anon_sym_BSLASH] = ACTIONS(4754),
    [anon_sym_function] = ACTIONS(4756),
    [anon_sym_if] = ACTIONS(4758),
    [anon_sym_for] = ACTIONS(4760),
    [anon_sym_while] = ACTIONS(4762),
    [anon_sym_repeat] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4766),
    [anon_sym_TILDE] = ACTIONS(4768),
    [anon_sym_BANG] = ACTIONS(6353),
    [anon_sym_PLUS] = ACTIONS(4772),
    [anon_sym_DASH] = ACTIONS(4772),
    [aux_sym__hex_literal_token1] = ACTIONS(4776),
    [sym__number_literal] = ACTIONS(4778),
    [anon_sym_SQUOTE] = ACTIONS(4780),
    [anon_sym_DQUOTE] = ACTIONS(4782),
    [sym_return] = ACTIONS(6355),
    [sym_next] = ACTIONS(6355),
    [sym_break] = ACTIONS(6355),
    [sym_true] = ACTIONS(6355),
    [sym_false] = ACTIONS(6355),
    [sym_null] = ACTIONS(6355),
    [sym_inf] = ACTIONS(6355),
    [sym_nan] = ACTIONS(6355),
    [anon_sym_NA] = ACTIONS(4786),
    [anon_sym_NA_integer_] = ACTIONS(4786),
    [anon_sym_NA_real_] = ACTIONS(4786),
    [anon_sym_NA_complex_] = ACTIONS(4786),
    [anon_sym_NA_character_] = ACTIONS(4786),
    [sym_dots] = ACTIONS(6357),
    [sym_dot_dot_i] = ACTIONS(6359),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6361),
    [sym__newline] = ACTIONS(6363),
    [sym__raw_string_literal] = ACTIONS(4790),
    [sym__external_open_parenthesis] = ACTIONS(4792),
    [sym__external_open_brace] = ACTIONS(4794),
    [sym__external_close_bracket] = ACTIONS(6745),
  },
  [1590] = {
    [sym_function_definition] = STATE(1931),
    [sym_if_statement] = STATE(1931),
    [sym_for_statement] = STATE(1931),
    [sym_while_statement] = STATE(1931),
    [sym_repeat_statement] = STATE(1931),
    [sym_braced_expression] = STATE(1931),
    [sym_parenthesized_expression] = STATE(1931),
    [sym_call] = STATE(1931),
    [sym_subset] = STATE(1931),
    [sym_subset2] = STATE(1931),
    [sym__argument] = STATE(4656),
    [sym_argument] = STATE(4657),
    [sym__argument_named] = STATE(4658),
    [sym__argument_unnamed] = STATE(4662),
    [sym__argument_value] = STATE(4663),
    [sym_unary_operator] = STATE(1931),
    [sym_binary_operator] = STATE(1931),
    [sym_extract_operator] = STATE(1931),
    [sym_namespace_operator] = STATE(1931),
    [sym_integer] = STATE(1931),
    [sym_complex] = STATE(1931),
    [sym_float] = STATE(1931),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2633),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(1931),
    [sym__expression] = STATE(1931),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__close_parenthesis] = STATE(2485),
    [sym__open_brace] = STATE(154),
    [aux_sym_call_arguments_repeat1] = STATE(1846),
    [sym_identifier] = ACTIONS(6387),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(6389),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3865),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(6391),
    [sym_next] = ACTIONS(6391),
    [sym_break] = ACTIONS(6391),
    [sym_true] = ACTIONS(6391),
    [sym_false] = ACTIONS(6391),
    [sym_null] = ACTIONS(6391),
    [sym_inf] = ACTIONS(6391),
    [sym_nan] = ACTIONS(6391),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(6393),
    [sym_dot_dot_i] = ACTIONS(6395),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6397),
    [sym__newline] = ACTIONS(6399),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(6747),
    [sym__external_open_brace] = ACTIONS(3891),
  },
  [1591] = {
    [sym_function_definition] = STATE(1931),
    [sym_if_statement] = STATE(1931),
    [sym_for_statement] = STATE(1931),
    [sym_while_statement] = STATE(1931),
    [sym_repeat_statement] = STATE(1931),
    [sym_braced_expression] = STATE(1931),
    [sym_parenthesized_expression] = STATE(1931),
    [sym_call] = STATE(1931),
    [sym_subset] = STATE(1931),
    [sym_subset2] = STATE(1931),
    [sym__argument] = STATE(4656),
    [sym_argument] = STATE(4657),
    [sym__argument_named] = STATE(4658),
    [sym__argument_unnamed] = STATE(4662),
    [sym__argument_value] = STATE(4663),
    [sym_unary_operator] = STATE(1931),
    [sym_binary_operator] = STATE(1931),
    [sym_extract_operator] = STATE(1931),
    [sym_namespace_operator] = STATE(1931),
    [sym_integer] = STATE(1931),
    [sym_complex] = STATE(1931),
    [sym_float] = STATE(1931),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2633),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(1931),
    [sym__expression] = STATE(1931),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__close_parenthesis] = STATE(2572),
    [sym__open_brace] = STATE(154),
    [aux_sym_call_arguments_repeat1] = STATE(2113),
    [sym_identifier] = ACTIONS(6387),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(6389),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3865),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(6391),
    [sym_next] = ACTIONS(6391),
    [sym_break] = ACTIONS(6391),
    [sym_true] = ACTIONS(6391),
    [sym_false] = ACTIONS(6391),
    [sym_null] = ACTIONS(6391),
    [sym_inf] = ACTIONS(6391),
    [sym_nan] = ACTIONS(6391),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(6393),
    [sym_dot_dot_i] = ACTIONS(6395),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6397),
    [sym__newline] = ACTIONS(6399),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(6749),
    [sym__external_open_brace] = ACTIONS(3891),
  },
  [1592] = {
    [sym_function_definition] = STATE(1940),
    [sym_if_statement] = STATE(1940),
    [sym_for_statement] = STATE(1940),
    [sym_while_statement] = STATE(1940),
    [sym_repeat_statement] = STATE(1940),
    [sym_braced_expression] = STATE(1940),
    [sym_parenthesized_expression] = STATE(1940),
    [sym_call] = STATE(1940),
    [sym_subset] = STATE(1940),
    [sym_subset2] = STATE(1940),
    [sym__argument] = STATE(4665),
    [sym_argument] = STATE(4661),
    [sym__argument_named] = STATE(4669),
    [sym__argument_unnamed] = STATE(4673),
    [sym__argument_value] = STATE(4679),
    [sym_unary_operator] = STATE(1940),
    [sym_binary_operator] = STATE(1940),
    [sym_extract_operator] = STATE(1940),
    [sym_namespace_operator] = STATE(1940),
    [sym_integer] = STATE(1940),
    [sym_complex] = STATE(1940),
    [sym_float] = STATE(1940),
    [sym__hex_literal] = STATE(2656),
    [sym__float_literal] = STATE(2656),
    [sym_string] = STATE(2606),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym_na] = STATE(1940),
    [sym__expression] = STATE(1940),
    [sym__string_or_identifier] = STATE(5141),
    [sym__open_parenthesis] = STATE(218),
    [sym__open_brace] = STATE(185),
    [sym__close_bracket2] = STATE(2967),
    [aux_sym_call_arguments_repeat1] = STATE(1859),
    [sym_identifier] = ACTIONS(6369),
    [anon_sym_BSLASH] = ACTIONS(4644),
    [anon_sym_function] = ACTIONS(4646),
    [anon_sym_if] = ACTIONS(4648),
    [anon_sym_for] = ACTIONS(4650),
    [anon_sym_while] = ACTIONS(4652),
    [anon_sym_repeat] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(6371),
    [anon_sym_PLUS] = ACTIONS(4662),
    [anon_sym_DASH] = ACTIONS(4662),
    [aux_sym__hex_literal_token1] = ACTIONS(4666),
    [sym__number_literal] = ACTIONS(4668),
    [anon_sym_SQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4672),
    [sym_return] = ACTIONS(6373),
    [sym_next] = ACTIONS(6373),
    [sym_break] = ACTIONS(6373),
    [sym_true] = ACTIONS(6373),
    [sym_false] = ACTIONS(6373),
    [sym_null] = ACTIONS(6373),
    [sym_inf] = ACTIONS(6373),
    [sym_nan] = ACTIONS(6373),
    [anon_sym_NA] = ACTIONS(4676),
    [anon_sym_NA_integer_] = ACTIONS(4676),
    [anon_sym_NA_real_] = ACTIONS(4676),
    [anon_sym_NA_complex_] = ACTIONS(4676),
    [anon_sym_NA_character_] = ACTIONS(4676),
    [sym_dots] = ACTIONS(6375),
    [sym_dot_dot_i] = ACTIONS(6377),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6379),
    [sym__newline] = ACTIONS(6381),
    [sym__raw_string_literal] = ACTIONS(4680),
    [sym__external_open_parenthesis] = ACTIONS(4682),
    [sym__external_open_brace] = ACTIONS(4684),
    [sym__external_close_bracket2] = ACTIONS(6751),
  },
  [1593] = {
    [sym_call_arguments] = STATE(2853),
    [sym_subset_arguments] = STATE(2854),
    [sym_subset2_arguments] = STATE(2864),
    [sym__open_parenthesis] = STATE(1366),
    [sym__open_bracket] = STATE(1365),
    [sym__open_bracket2] = STATE(1364),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_CARET] = ACTIONS(6025),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(6029),
    [anon_sym_DOLLAR] = ACTIONS(6031),
    [anon_sym_AT] = ACTIONS(6031),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6035),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6037),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(6039),
  },
  [1594] = {
    [sym_call_arguments] = STATE(2853),
    [sym_subset_arguments] = STATE(2854),
    [sym_subset2_arguments] = STATE(2864),
    [sym__open_parenthesis] = STATE(1366),
    [sym__open_bracket] = STATE(1365),
    [sym__open_bracket2] = STATE(1364),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_CARET] = ACTIONS(6025),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(5261),
    [anon_sym_DOLLAR] = ACTIONS(6031),
    [anon_sym_AT] = ACTIONS(6031),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6035),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6037),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(6039),
  },
  [1595] = {
    [sym_call_arguments] = STATE(2853),
    [sym_subset_arguments] = STATE(2854),
    [sym_subset2_arguments] = STATE(2864),
    [sym__open_parenthesis] = STATE(1366),
    [sym__open_bracket] = STATE(1365),
    [sym__open_bracket2] = STATE(1364),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_CARET] = ACTIONS(6025),
    [aux_sym_binary_operator_token1] = ACTIONS(6027),
    [anon_sym_PIPE_GT] = ACTIONS(6027),
    [anon_sym_COLON] = ACTIONS(6029),
    [anon_sym_DOLLAR] = ACTIONS(6031),
    [anon_sym_AT] = ACTIONS(6031),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6035),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6037),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(6039),
  },
  [1596] = {
    [sym_call_arguments] = STATE(2853),
    [sym_subset_arguments] = STATE(2854),
    [sym_subset2_arguments] = STATE(2864),
    [sym__open_parenthesis] = STATE(1366),
    [sym__open_bracket] = STATE(1365),
    [sym__open_bracket2] = STATE(1364),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5999),
    [anon_sym_DASH] = ACTIONS(6001),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(6021),
    [anon_sym_SLASH] = ACTIONS(6023),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_CARET] = ACTIONS(6025),
    [aux_sym_binary_operator_token1] = ACTIONS(6027),
    [anon_sym_PIPE_GT] = ACTIONS(6027),
    [anon_sym_COLON] = ACTIONS(6029),
    [anon_sym_DOLLAR] = ACTIONS(6031),
    [anon_sym_AT] = ACTIONS(6031),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6035),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6037),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(6039),
  },
  [1597] = {
    [sym_call_arguments] = STATE(2853),
    [sym_subset_arguments] = STATE(2854),
    [sym_subset2_arguments] = STATE(2864),
    [sym__open_parenthesis] = STATE(1366),
    [sym__open_bracket] = STATE(1365),
    [sym__open_bracket2] = STATE(1364),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5999),
    [anon_sym_DASH] = ACTIONS(6001),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(6017),
    [anon_sym_LT_EQ] = ACTIONS(6019),
    [anon_sym_GT] = ACTIONS(6017),
    [anon_sym_GT_EQ] = ACTIONS(6019),
    [anon_sym_EQ_EQ] = ACTIONS(6019),
    [anon_sym_BANG_EQ] = ACTIONS(6019),
    [anon_sym_STAR] = ACTIONS(6021),
    [anon_sym_SLASH] = ACTIONS(6023),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_CARET] = ACTIONS(6025),
    [aux_sym_binary_operator_token1] = ACTIONS(6027),
    [anon_sym_PIPE_GT] = ACTIONS(6027),
    [anon_sym_COLON] = ACTIONS(6029),
    [anon_sym_DOLLAR] = ACTIONS(6031),
    [anon_sym_AT] = ACTIONS(6031),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6035),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6037),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(6039),
  },
  [1598] = {
    [sym_function_definition] = STATE(2038),
    [sym_if_statement] = STATE(2038),
    [sym_for_statement] = STATE(2038),
    [sym_while_statement] = STATE(2038),
    [sym_repeat_statement] = STATE(2038),
    [sym_braced_expression] = STATE(2038),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_call] = STATE(2038),
    [sym_subset] = STATE(2038),
    [sym_subset2] = STATE(2038),
    [sym__argument] = STATE(4664),
    [sym_argument] = STATE(4659),
    [sym__argument_named] = STATE(4654),
    [sym__argument_unnamed] = STATE(4676),
    [sym__argument_value] = STATE(4677),
    [sym_unary_operator] = STATE(2038),
    [sym_binary_operator] = STATE(2038),
    [sym_extract_operator] = STATE(2038),
    [sym_namespace_operator] = STATE(2038),
    [sym_integer] = STATE(2038),
    [sym_complex] = STATE(2038),
    [sym_float] = STATE(2038),
    [sym__hex_literal] = STATE(2700),
    [sym__float_literal] = STATE(2700),
    [sym_string] = STATE(2597),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym_na] = STATE(2038),
    [sym__expression] = STATE(2038),
    [sym__string_or_identifier] = STATE(5148),
    [sym__open_parenthesis] = STATE(214),
    [sym__open_brace] = STATE(192),
    [sym__close_bracket] = STATE(2968),
    [aux_sym_call_arguments_repeat1] = STATE(1863),
    [sym_identifier] = ACTIONS(6351),
    [anon_sym_BSLASH] = ACTIONS(4754),
    [anon_sym_function] = ACTIONS(4756),
    [anon_sym_if] = ACTIONS(4758),
    [anon_sym_for] = ACTIONS(4760),
    [anon_sym_while] = ACTIONS(4762),
    [anon_sym_repeat] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4766),
    [anon_sym_TILDE] = ACTIONS(4768),
    [anon_sym_BANG] = ACTIONS(6353),
    [anon_sym_PLUS] = ACTIONS(4772),
    [anon_sym_DASH] = ACTIONS(4772),
    [aux_sym__hex_literal_token1] = ACTIONS(4776),
    [sym__number_literal] = ACTIONS(4778),
    [anon_sym_SQUOTE] = ACTIONS(4780),
    [anon_sym_DQUOTE] = ACTIONS(4782),
    [sym_return] = ACTIONS(6355),
    [sym_next] = ACTIONS(6355),
    [sym_break] = ACTIONS(6355),
    [sym_true] = ACTIONS(6355),
    [sym_false] = ACTIONS(6355),
    [sym_null] = ACTIONS(6355),
    [sym_inf] = ACTIONS(6355),
    [sym_nan] = ACTIONS(6355),
    [anon_sym_NA] = ACTIONS(4786),
    [anon_sym_NA_integer_] = ACTIONS(4786),
    [anon_sym_NA_real_] = ACTIONS(4786),
    [anon_sym_NA_complex_] = ACTIONS(4786),
    [anon_sym_NA_character_] = ACTIONS(4786),
    [sym_dots] = ACTIONS(6357),
    [sym_dot_dot_i] = ACTIONS(6359),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6361),
    [sym__newline] = ACTIONS(6363),
    [sym__raw_string_literal] = ACTIONS(4790),
    [sym__external_open_parenthesis] = ACTIONS(4792),
    [sym__external_open_brace] = ACTIONS(4794),
    [sym__external_close_bracket] = ACTIONS(6753),
  },
  [1599] = {
    [sym_call_arguments] = STATE(2808),
    [sym_subset_arguments] = STATE(2920),
    [sym_subset2_arguments] = STATE(2919),
    [sym__open_parenthesis] = STATE(1545),
    [sym__open_bracket] = STATE(1541),
    [sym__open_bracket2] = STATE(1539),
    [sym_identifier] = ACTIONS(5311),
    [anon_sym_BSLASH] = ACTIONS(5313),
    [anon_sym_function] = ACTIONS(5311),
    [anon_sym_EQ] = ACTIONS(6307),
    [anon_sym_if] = ACTIONS(5311),
    [anon_sym_for] = ACTIONS(5311),
    [anon_sym_while] = ACTIONS(5311),
    [anon_sym_repeat] = ACTIONS(5311),
    [anon_sym_QMARK] = ACTIONS(6755),
    [anon_sym_TILDE] = ACTIONS(6309),
    [anon_sym_BANG] = ACTIONS(5311),
    [anon_sym_PLUS] = ACTIONS(6311),
    [anon_sym_DASH] = ACTIONS(6313),
    [anon_sym_LT_DASH] = ACTIONS(6315),
    [anon_sym_LT_LT_DASH] = ACTIONS(6315),
    [anon_sym_COLON_EQ] = ACTIONS(6315),
    [anon_sym_DASH_GT] = ACTIONS(6317),
    [anon_sym_DASH_GT_GT] = ACTIONS(6319),
    [anon_sym_PIPE] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6323),
    [anon_sym_PIPE_PIPE] = ACTIONS(6325),
    [anon_sym_AMP_AMP] = ACTIONS(6327),
    [anon_sym_LT] = ACTIONS(6329),
    [anon_sym_LT_EQ] = ACTIONS(6331),
    [anon_sym_GT] = ACTIONS(6329),
    [anon_sym_GT_EQ] = ACTIONS(6331),
    [anon_sym_EQ_EQ] = ACTIONS(6331),
    [anon_sym_BANG_EQ] = ACTIONS(6331),
    [anon_sym_STAR] = ACTIONS(6333),
    [anon_sym_SLASH] = ACTIONS(6335),
    [anon_sym_STAR_STAR] = ACTIONS(6337),
    [anon_sym_CARET] = ACTIONS(6337),
    [aux_sym_binary_operator_token1] = ACTIONS(6339),
    [anon_sym_PIPE_GT] = ACTIONS(6339),
    [anon_sym_COLON] = ACTIONS(6341),
    [anon_sym_DOLLAR] = ACTIONS(6343),
    [anon_sym_AT] = ACTIONS(6343),
    [aux_sym__hex_literal_token1] = ACTIONS(5313),
    [sym__number_literal] = ACTIONS(5311),
    [anon_sym_SQUOTE] = ACTIONS(5313),
    [anon_sym_DQUOTE] = ACTIONS(5313),
    [sym_return] = ACTIONS(5311),
    [sym_next] = ACTIONS(5311),
    [sym_break] = ACTIONS(5311),
    [sym_true] = ACTIONS(5311),
    [sym_false] = ACTIONS(5311),
    [sym_null] = ACTIONS(5311),
    [sym_inf] = ACTIONS(5311),
    [sym_nan] = ACTIONS(5311),
    [anon_sym_NA] = ACTIONS(5311),
    [anon_sym_NA_integer_] = ACTIONS(5311),
    [anon_sym_NA_real_] = ACTIONS(5311),
    [anon_sym_NA_complex_] = ACTIONS(5311),
    [anon_sym_NA_character_] = ACTIONS(5311),
    [sym_dots] = ACTIONS(5311),
    [sym_dot_dot_i] = ACTIONS(5313),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5313),
    [sym__newline] = ACTIONS(5313),
    [sym__raw_string_literal] = ACTIONS(5313),
    [sym__external_open_parenthesis] = ACTIONS(6345),
    [sym__external_close_parenthesis] = ACTIONS(5313),
    [sym__external_open_brace] = ACTIONS(5313),
    [sym__external_open_bracket] = ACTIONS(6347),
    [sym__external_open_bracket2] = ACTIONS(6349),
    [sym__external_close_bracket2] = ACTIONS(5313),
  },
  [1600] = {
    [sym_call_arguments] = STATE(2840),
    [sym_subset_arguments] = STATE(2797),
    [sym_subset2_arguments] = STATE(2801),
    [sym__open_parenthesis] = STATE(1344),
    [sym__open_bracket] = STATE(1374),
    [sym__open_bracket2] = STATE(1452),
    [ts_builtin_sym_end] = ACTIONS(5417),
    [sym_identifier] = ACTIONS(5419),
    [anon_sym_BSLASH] = ACTIONS(5417),
    [anon_sym_function] = ACTIONS(5419),
    [anon_sym_EQ] = ACTIONS(6263),
    [anon_sym_if] = ACTIONS(5419),
    [anon_sym_for] = ACTIONS(5419),
    [anon_sym_while] = ACTIONS(5419),
    [anon_sym_repeat] = ACTIONS(5419),
    [anon_sym_QMARK] = ACTIONS(5417),
    [anon_sym_TILDE] = ACTIONS(6265),
    [anon_sym_BANG] = ACTIONS(5419),
    [anon_sym_PLUS] = ACTIONS(6267),
    [anon_sym_DASH] = ACTIONS(6269),
    [anon_sym_LT_DASH] = ACTIONS(6271),
    [anon_sym_LT_LT_DASH] = ACTIONS(6271),
    [anon_sym_COLON_EQ] = ACTIONS(6271),
    [anon_sym_DASH_GT] = ACTIONS(6273),
    [anon_sym_DASH_GT_GT] = ACTIONS(6275),
    [anon_sym_PIPE] = ACTIONS(6277),
    [anon_sym_AMP] = ACTIONS(6279),
    [anon_sym_PIPE_PIPE] = ACTIONS(6281),
    [anon_sym_AMP_AMP] = ACTIONS(6283),
    [anon_sym_LT] = ACTIONS(6285),
    [anon_sym_LT_EQ] = ACTIONS(6287),
    [anon_sym_GT] = ACTIONS(6285),
    [anon_sym_GT_EQ] = ACTIONS(6287),
    [anon_sym_EQ_EQ] = ACTIONS(6287),
    [anon_sym_BANG_EQ] = ACTIONS(6287),
    [anon_sym_STAR] = ACTIONS(6289),
    [anon_sym_SLASH] = ACTIONS(6291),
    [anon_sym_STAR_STAR] = ACTIONS(6293),
    [anon_sym_CARET] = ACTIONS(6293),
    [aux_sym_binary_operator_token1] = ACTIONS(6295),
    [anon_sym_PIPE_GT] = ACTIONS(6295),
    [anon_sym_COLON] = ACTIONS(6297),
    [anon_sym_DOLLAR] = ACTIONS(6299),
    [anon_sym_AT] = ACTIONS(6299),
    [aux_sym__hex_literal_token1] = ACTIONS(5417),
    [sym__number_literal] = ACTIONS(5419),
    [anon_sym_SQUOTE] = ACTIONS(5417),
    [anon_sym_DQUOTE] = ACTIONS(5417),
    [sym_return] = ACTIONS(5419),
    [sym_next] = ACTIONS(5419),
    [sym_break] = ACTIONS(5419),
    [sym_true] = ACTIONS(5419),
    [sym_false] = ACTIONS(5419),
    [sym_null] = ACTIONS(5419),
    [sym_inf] = ACTIONS(5419),
    [sym_nan] = ACTIONS(5419),
    [anon_sym_NA] = ACTIONS(5419),
    [anon_sym_NA_integer_] = ACTIONS(5419),
    [anon_sym_NA_real_] = ACTIONS(5419),
    [anon_sym_NA_complex_] = ACTIONS(5419),
    [anon_sym_NA_character_] = ACTIONS(5419),
    [sym_dots] = ACTIONS(5419),
    [sym_dot_dot_i] = ACTIONS(5417),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5417),
    [sym__semicolon] = ACTIONS(5417),
    [sym__raw_string_literal] = ACTIONS(5417),
    [sym__external_open_parenthesis] = ACTIONS(6301),
    [sym__external_open_brace] = ACTIONS(5417),
    [sym__external_close_brace] = ACTIONS(5417),
    [sym__external_open_bracket] = ACTIONS(6303),
    [sym__external_open_bracket2] = ACTIONS(6305),
  },
  [1601] = {
    [sym_call_arguments] = STATE(2853),
    [sym_subset_arguments] = STATE(2854),
    [sym_subset2_arguments] = STATE(2864),
    [sym__open_parenthesis] = STATE(1366),
    [sym__open_bracket] = STATE(1365),
    [sym__open_bracket2] = STATE(1364),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5999),
    [anon_sym_DASH] = ACTIONS(6001),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(6011),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(6015),
    [anon_sym_LT] = ACTIONS(6017),
    [anon_sym_LT_EQ] = ACTIONS(6019),
    [anon_sym_GT] = ACTIONS(6017),
    [anon_sym_GT_EQ] = ACTIONS(6019),
    [anon_sym_EQ_EQ] = ACTIONS(6019),
    [anon_sym_BANG_EQ] = ACTIONS(6019),
    [anon_sym_STAR] = ACTIONS(6021),
    [anon_sym_SLASH] = ACTIONS(6023),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_CARET] = ACTIONS(6025),
    [aux_sym_binary_operator_token1] = ACTIONS(6027),
    [anon_sym_PIPE_GT] = ACTIONS(6027),
    [anon_sym_COLON] = ACTIONS(6029),
    [anon_sym_DOLLAR] = ACTIONS(6031),
    [anon_sym_AT] = ACTIONS(6031),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6035),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6037),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(6039),
  },
  [1602] = {
    [sym_call_arguments] = STATE(2853),
    [sym_subset_arguments] = STATE(2854),
    [sym_subset2_arguments] = STATE(2864),
    [sym__open_parenthesis] = STATE(1366),
    [sym__open_bracket] = STATE(1365),
    [sym__open_bracket2] = STATE(1364),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5997),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5999),
    [anon_sym_DASH] = ACTIONS(6001),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(6009),
    [anon_sym_AMP] = ACTIONS(6011),
    [anon_sym_PIPE_PIPE] = ACTIONS(6013),
    [anon_sym_AMP_AMP] = ACTIONS(6015),
    [anon_sym_LT] = ACTIONS(6017),
    [anon_sym_LT_EQ] = ACTIONS(6019),
    [anon_sym_GT] = ACTIONS(6017),
    [anon_sym_GT_EQ] = ACTIONS(6019),
    [anon_sym_EQ_EQ] = ACTIONS(6019),
    [anon_sym_BANG_EQ] = ACTIONS(6019),
    [anon_sym_STAR] = ACTIONS(6021),
    [anon_sym_SLASH] = ACTIONS(6023),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_CARET] = ACTIONS(6025),
    [aux_sym_binary_operator_token1] = ACTIONS(6027),
    [anon_sym_PIPE_GT] = ACTIONS(6027),
    [anon_sym_COLON] = ACTIONS(6029),
    [anon_sym_DOLLAR] = ACTIONS(6031),
    [anon_sym_AT] = ACTIONS(6031),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6035),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6037),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(6039),
  },
  [1603] = {
    [sym_function_definition] = STATE(1931),
    [sym_if_statement] = STATE(1931),
    [sym_for_statement] = STATE(1931),
    [sym_while_statement] = STATE(1931),
    [sym_repeat_statement] = STATE(1931),
    [sym_braced_expression] = STATE(1931),
    [sym_parenthesized_expression] = STATE(1931),
    [sym_call] = STATE(1931),
    [sym_subset] = STATE(1931),
    [sym_subset2] = STATE(1931),
    [sym__argument] = STATE(4656),
    [sym_argument] = STATE(4657),
    [sym__argument_named] = STATE(4658),
    [sym__argument_unnamed] = STATE(4662),
    [sym__argument_value] = STATE(4663),
    [sym_unary_operator] = STATE(1931),
    [sym_binary_operator] = STATE(1931),
    [sym_extract_operator] = STATE(1931),
    [sym_namespace_operator] = STATE(1931),
    [sym_integer] = STATE(1931),
    [sym_complex] = STATE(1931),
    [sym_float] = STATE(1931),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2633),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(1931),
    [sym__expression] = STATE(1931),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__close_parenthesis] = STATE(2961),
    [sym__open_brace] = STATE(154),
    [aux_sym_call_arguments_repeat1] = STATE(2113),
    [sym_identifier] = ACTIONS(6387),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(6389),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3865),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(6391),
    [sym_next] = ACTIONS(6391),
    [sym_break] = ACTIONS(6391),
    [sym_true] = ACTIONS(6391),
    [sym_false] = ACTIONS(6391),
    [sym_null] = ACTIONS(6391),
    [sym_inf] = ACTIONS(6391),
    [sym_nan] = ACTIONS(6391),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(6393),
    [sym_dot_dot_i] = ACTIONS(6395),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6397),
    [sym__newline] = ACTIONS(6399),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(6757),
    [sym__external_open_brace] = ACTIONS(3891),
  },
  [1604] = {
    [sym_function_definition] = STATE(1940),
    [sym_if_statement] = STATE(1940),
    [sym_for_statement] = STATE(1940),
    [sym_while_statement] = STATE(1940),
    [sym_repeat_statement] = STATE(1940),
    [sym_braced_expression] = STATE(1940),
    [sym_parenthesized_expression] = STATE(1940),
    [sym_call] = STATE(1940),
    [sym_subset] = STATE(1940),
    [sym_subset2] = STATE(1940),
    [sym__argument] = STATE(4665),
    [sym_argument] = STATE(4661),
    [sym__argument_named] = STATE(4669),
    [sym__argument_unnamed] = STATE(4673),
    [sym__argument_value] = STATE(4679),
    [sym_unary_operator] = STATE(1940),
    [sym_binary_operator] = STATE(1940),
    [sym_extract_operator] = STATE(1940),
    [sym_namespace_operator] = STATE(1940),
    [sym_integer] = STATE(1940),
    [sym_complex] = STATE(1940),
    [sym_float] = STATE(1940),
    [sym__hex_literal] = STATE(2656),
    [sym__float_literal] = STATE(2656),
    [sym_string] = STATE(2606),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym_na] = STATE(1940),
    [sym__expression] = STATE(1940),
    [sym__string_or_identifier] = STATE(5141),
    [sym__open_parenthesis] = STATE(218),
    [sym__open_brace] = STATE(185),
    [sym__close_bracket2] = STATE(4730),
    [aux_sym_call_arguments_repeat1] = STATE(1323),
    [sym_identifier] = ACTIONS(6369),
    [anon_sym_BSLASH] = ACTIONS(4644),
    [anon_sym_function] = ACTIONS(4646),
    [anon_sym_if] = ACTIONS(4648),
    [anon_sym_for] = ACTIONS(4650),
    [anon_sym_while] = ACTIONS(4652),
    [anon_sym_repeat] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(6371),
    [anon_sym_PLUS] = ACTIONS(4662),
    [anon_sym_DASH] = ACTIONS(4662),
    [aux_sym__hex_literal_token1] = ACTIONS(4666),
    [sym__number_literal] = ACTIONS(4668),
    [anon_sym_SQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4672),
    [sym_return] = ACTIONS(6373),
    [sym_next] = ACTIONS(6373),
    [sym_break] = ACTIONS(6373),
    [sym_true] = ACTIONS(6373),
    [sym_false] = ACTIONS(6373),
    [sym_null] = ACTIONS(6373),
    [sym_inf] = ACTIONS(6373),
    [sym_nan] = ACTIONS(6373),
    [anon_sym_NA] = ACTIONS(4676),
    [anon_sym_NA_integer_] = ACTIONS(4676),
    [anon_sym_NA_real_] = ACTIONS(4676),
    [anon_sym_NA_complex_] = ACTIONS(4676),
    [anon_sym_NA_character_] = ACTIONS(4676),
    [sym_dots] = ACTIONS(6375),
    [sym_dot_dot_i] = ACTIONS(6377),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6379),
    [sym__newline] = ACTIONS(6381),
    [sym__raw_string_literal] = ACTIONS(4680),
    [sym__external_open_parenthesis] = ACTIONS(4682),
    [sym__external_open_brace] = ACTIONS(4684),
    [sym__external_close_bracket2] = ACTIONS(6759),
  },
  [1605] = {
    [sym_call_arguments] = STATE(2853),
    [sym_subset_arguments] = STATE(2854),
    [sym_subset2_arguments] = STATE(2864),
    [sym__open_parenthesis] = STATE(1366),
    [sym__open_bracket] = STATE(1365),
    [sym__open_bracket2] = STATE(1364),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5995),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5997),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5999),
    [anon_sym_DASH] = ACTIONS(6001),
    [anon_sym_LT_DASH] = ACTIONS(6003),
    [anon_sym_LT_LT_DASH] = ACTIONS(6003),
    [anon_sym_COLON_EQ] = ACTIONS(6003),
    [anon_sym_DASH_GT] = ACTIONS(6005),
    [anon_sym_DASH_GT_GT] = ACTIONS(6007),
    [anon_sym_PIPE] = ACTIONS(6009),
    [anon_sym_AMP] = ACTIONS(6011),
    [anon_sym_PIPE_PIPE] = ACTIONS(6013),
    [anon_sym_AMP_AMP] = ACTIONS(6015),
    [anon_sym_LT] = ACTIONS(6017),
    [anon_sym_LT_EQ] = ACTIONS(6019),
    [anon_sym_GT] = ACTIONS(6017),
    [anon_sym_GT_EQ] = ACTIONS(6019),
    [anon_sym_EQ_EQ] = ACTIONS(6019),
    [anon_sym_BANG_EQ] = ACTIONS(6019),
    [anon_sym_STAR] = ACTIONS(6021),
    [anon_sym_SLASH] = ACTIONS(6023),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_CARET] = ACTIONS(6025),
    [aux_sym_binary_operator_token1] = ACTIONS(6027),
    [anon_sym_PIPE_GT] = ACTIONS(6027),
    [anon_sym_COLON] = ACTIONS(6029),
    [anon_sym_DOLLAR] = ACTIONS(6031),
    [anon_sym_AT] = ACTIONS(6031),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6035),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6037),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(6039),
  },
  [1606] = {
    [sym_function_definition] = STATE(1931),
    [sym_if_statement] = STATE(1931),
    [sym_for_statement] = STATE(1931),
    [sym_while_statement] = STATE(1931),
    [sym_repeat_statement] = STATE(1931),
    [sym_braced_expression] = STATE(1931),
    [sym_parenthesized_expression] = STATE(1931),
    [sym_call] = STATE(1931),
    [sym_subset] = STATE(1931),
    [sym_subset2] = STATE(1931),
    [sym__argument] = STATE(4656),
    [sym_argument] = STATE(4657),
    [sym__argument_named] = STATE(4658),
    [sym__argument_unnamed] = STATE(4662),
    [sym__argument_value] = STATE(4663),
    [sym_unary_operator] = STATE(1931),
    [sym_binary_operator] = STATE(1931),
    [sym_extract_operator] = STATE(1931),
    [sym_namespace_operator] = STATE(1931),
    [sym_integer] = STATE(1931),
    [sym_complex] = STATE(1931),
    [sym_float] = STATE(1931),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2633),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(1931),
    [sym__expression] = STATE(1931),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__close_parenthesis] = STATE(2969),
    [sym__open_brace] = STATE(154),
    [aux_sym_call_arguments_repeat1] = STATE(1603),
    [sym_identifier] = ACTIONS(6387),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(6389),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3865),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(6391),
    [sym_next] = ACTIONS(6391),
    [sym_break] = ACTIONS(6391),
    [sym_true] = ACTIONS(6391),
    [sym_false] = ACTIONS(6391),
    [sym_null] = ACTIONS(6391),
    [sym_inf] = ACTIONS(6391),
    [sym_nan] = ACTIONS(6391),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(6393),
    [sym_dot_dot_i] = ACTIONS(6395),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6397),
    [sym__newline] = ACTIONS(6399),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(6761),
    [sym__external_open_brace] = ACTIONS(3891),
  },
  [1607] = {
    [sym_function_definition] = STATE(1940),
    [sym_if_statement] = STATE(1940),
    [sym_for_statement] = STATE(1940),
    [sym_while_statement] = STATE(1940),
    [sym_repeat_statement] = STATE(1940),
    [sym_braced_expression] = STATE(1940),
    [sym_parenthesized_expression] = STATE(1940),
    [sym_call] = STATE(1940),
    [sym_subset] = STATE(1940),
    [sym_subset2] = STATE(1940),
    [sym__argument] = STATE(4665),
    [sym_argument] = STATE(4661),
    [sym__argument_named] = STATE(4669),
    [sym__argument_unnamed] = STATE(4673),
    [sym__argument_value] = STATE(4679),
    [sym_unary_operator] = STATE(1940),
    [sym_binary_operator] = STATE(1940),
    [sym_extract_operator] = STATE(1940),
    [sym_namespace_operator] = STATE(1940),
    [sym_integer] = STATE(1940),
    [sym_complex] = STATE(1940),
    [sym_float] = STATE(1940),
    [sym__hex_literal] = STATE(2656),
    [sym__float_literal] = STATE(2656),
    [sym_string] = STATE(2606),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym_na] = STATE(1940),
    [sym__expression] = STATE(1940),
    [sym__string_or_identifier] = STATE(5141),
    [sym__open_parenthesis] = STATE(218),
    [sym__open_brace] = STATE(185),
    [sym__close_bracket2] = STATE(2361),
    [aux_sym_call_arguments_repeat1] = STATE(1536),
    [sym_identifier] = ACTIONS(6369),
    [anon_sym_BSLASH] = ACTIONS(4644),
    [anon_sym_function] = ACTIONS(4646),
    [anon_sym_if] = ACTIONS(4648),
    [anon_sym_for] = ACTIONS(4650),
    [anon_sym_while] = ACTIONS(4652),
    [anon_sym_repeat] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(6371),
    [anon_sym_PLUS] = ACTIONS(4662),
    [anon_sym_DASH] = ACTIONS(4662),
    [aux_sym__hex_literal_token1] = ACTIONS(4666),
    [sym__number_literal] = ACTIONS(4668),
    [anon_sym_SQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4672),
    [sym_return] = ACTIONS(6373),
    [sym_next] = ACTIONS(6373),
    [sym_break] = ACTIONS(6373),
    [sym_true] = ACTIONS(6373),
    [sym_false] = ACTIONS(6373),
    [sym_null] = ACTIONS(6373),
    [sym_inf] = ACTIONS(6373),
    [sym_nan] = ACTIONS(6373),
    [anon_sym_NA] = ACTIONS(4676),
    [anon_sym_NA_integer_] = ACTIONS(4676),
    [anon_sym_NA_real_] = ACTIONS(4676),
    [anon_sym_NA_complex_] = ACTIONS(4676),
    [anon_sym_NA_character_] = ACTIONS(4676),
    [sym_dots] = ACTIONS(6375),
    [sym_dot_dot_i] = ACTIONS(6377),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6379),
    [sym__newline] = ACTIONS(6381),
    [sym__raw_string_literal] = ACTIONS(4680),
    [sym__external_open_parenthesis] = ACTIONS(4682),
    [sym__external_open_brace] = ACTIONS(4684),
    [sym__external_close_bracket2] = ACTIONS(6763),
  },
  [1608] = {
    [sym_call_arguments] = STATE(2853),
    [sym_subset_arguments] = STATE(2854),
    [sym_subset2_arguments] = STATE(2864),
    [sym__open_parenthesis] = STATE(1366),
    [sym__open_bracket] = STATE(1365),
    [sym__open_bracket2] = STATE(1364),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(6021),
    [anon_sym_SLASH] = ACTIONS(6023),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_CARET] = ACTIONS(6025),
    [aux_sym_binary_operator_token1] = ACTIONS(6027),
    [anon_sym_PIPE_GT] = ACTIONS(6027),
    [anon_sym_COLON] = ACTIONS(6029),
    [anon_sym_DOLLAR] = ACTIONS(6031),
    [anon_sym_AT] = ACTIONS(6031),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6035),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6037),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(6039),
  },
  [1609] = {
    [sym_string] = STATE(2698),
    [sym__single_quoted_string] = STATE(2355),
    [sym__double_quoted_string] = STATE(2354),
    [sym__string_or_identifier] = STATE(2698),
    [aux_sym_function_definition_repeat1] = STATE(1786),
    [ts_builtin_sym_end] = ACTIONS(5659),
    [sym_identifier] = ACTIONS(6765),
    [anon_sym_BSLASH] = ACTIONS(5659),
    [anon_sym_function] = ACTIONS(5663),
    [anon_sym_EQ] = ACTIONS(5663),
    [anon_sym_if] = ACTIONS(5663),
    [anon_sym_for] = ACTIONS(5663),
    [anon_sym_while] = ACTIONS(5663),
    [anon_sym_repeat] = ACTIONS(5663),
    [anon_sym_QMARK] = ACTIONS(5659),
    [anon_sym_TILDE] = ACTIONS(5659),
    [anon_sym_BANG] = ACTIONS(5663),
    [anon_sym_PLUS] = ACTIONS(5659),
    [anon_sym_DASH] = ACTIONS(5663),
    [anon_sym_LT_DASH] = ACTIONS(5659),
    [anon_sym_LT_LT_DASH] = ACTIONS(5659),
    [anon_sym_COLON_EQ] = ACTIONS(5659),
    [anon_sym_DASH_GT] = ACTIONS(5663),
    [anon_sym_DASH_GT_GT] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(5663),
    [anon_sym_AMP] = ACTIONS(5663),
    [anon_sym_PIPE_PIPE] = ACTIONS(5659),
    [anon_sym_AMP_AMP] = ACTIONS(5659),
    [anon_sym_LT] = ACTIONS(5663),
    [anon_sym_LT_EQ] = ACTIONS(5659),
    [anon_sym_GT] = ACTIONS(5663),
    [anon_sym_GT_EQ] = ACTIONS(5659),
    [anon_sym_EQ_EQ] = ACTIONS(5659),
    [anon_sym_BANG_EQ] = ACTIONS(5659),
    [anon_sym_STAR] = ACTIONS(5663),
    [anon_sym_SLASH] = ACTIONS(5659),
    [anon_sym_STAR_STAR] = ACTIONS(5659),
    [anon_sym_CARET] = ACTIONS(5659),
    [aux_sym_binary_operator_token1] = ACTIONS(5659),
    [anon_sym_PIPE_GT] = ACTIONS(5659),
    [anon_sym_COLON] = ACTIONS(5663),
    [anon_sym_DOLLAR] = ACTIONS(5659),
    [anon_sym_AT] = ACTIONS(5659),
    [aux_sym__hex_literal_token1] = ACTIONS(5659),
    [sym__number_literal] = ACTIONS(5663),
    [anon_sym_SQUOTE] = ACTIONS(1365),
    [anon_sym_DQUOTE] = ACTIONS(1367),
    [sym_return] = ACTIONS(5663),
    [sym_next] = ACTIONS(5663),
    [sym_break] = ACTIONS(5663),
    [sym_true] = ACTIONS(5663),
    [sym_false] = ACTIONS(5663),
    [sym_null] = ACTIONS(5663),
    [sym_inf] = ACTIONS(5663),
    [sym_nan] = ACTIONS(5663),
    [anon_sym_NA] = ACTIONS(5663),
    [anon_sym_NA_integer_] = ACTIONS(5663),
    [anon_sym_NA_real_] = ACTIONS(5663),
    [anon_sym_NA_complex_] = ACTIONS(5663),
    [anon_sym_NA_character_] = ACTIONS(5663),
    [sym_dots] = ACTIONS(5663),
    [sym_dot_dot_i] = ACTIONS(5659),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(6767),
    [sym__semicolon] = ACTIONS(5659),
    [sym__raw_string_literal] = ACTIONS(1377),
    [sym__external_else] = ACTIONS(5659),
    [sym__external_open_parenthesis] = ACTIONS(5659),
    [sym__external_close_parenthesis] = ACTIONS(5659),
    [sym__external_open_brace] = ACTIONS(5659),
    [sym__external_open_bracket] = ACTIONS(5659),
    [sym__external_open_bracket2] = ACTIONS(5659),
  },
  [1610] = {
    [sym_call_arguments] = STATE(2853),
    [sym_subset_arguments] = STATE(2854),
    [sym_subset2_arguments] = STATE(2864),
    [sym__open_parenthesis] = STATE(1366),
    [sym__open_bracket] = STATE(1365),
    [sym__open_bracket2] = STATE(1364),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5999),
    [anon_sym_DASH] = ACTIONS(6001),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(6009),
    [anon_sym_AMP] = ACTIONS(6011),
    [anon_sym_PIPE_PIPE] = ACTIONS(6013),
    [anon_sym_AMP_AMP] = ACTIONS(6015),
    [anon_sym_LT] = ACTIONS(6017),
    [anon_sym_LT_EQ] = ACTIONS(6019),
    [anon_sym_GT] = ACTIONS(6017),
    [anon_sym_GT_EQ] = ACTIONS(6019),
    [anon_sym_EQ_EQ] = ACTIONS(6019),
    [anon_sym_BANG_EQ] = ACTIONS(6019),
    [anon_sym_STAR] = ACTIONS(6021),
    [anon_sym_SLASH] = ACTIONS(6023),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_CARET] = ACTIONS(6025),
    [aux_sym_binary_operator_token1] = ACTIONS(6027),
    [anon_sym_PIPE_GT] = ACTIONS(6027),
    [anon_sym_COLON] = ACTIONS(6029),
    [anon_sym_DOLLAR] = ACTIONS(6031),
    [anon_sym_AT] = ACTIONS(6031),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6035),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6037),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(6039),
  },
  [1611] = {
    [sym_call_arguments] = STATE(2853),
    [sym_subset_arguments] = STATE(2854),
    [sym_subset2_arguments] = STATE(2864),
    [sym__open_parenthesis] = STATE(1366),
    [sym__open_bracket] = STATE(1365),
    [sym__open_bracket2] = STATE(1364),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5995),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5997),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5999),
    [anon_sym_DASH] = ACTIONS(6001),
    [anon_sym_LT_DASH] = ACTIONS(6003),
    [anon_sym_LT_LT_DASH] = ACTIONS(6003),
    [anon_sym_COLON_EQ] = ACTIONS(6003),
    [anon_sym_DASH_GT] = ACTIONS(6005),
    [anon_sym_DASH_GT_GT] = ACTIONS(6007),
    [anon_sym_PIPE] = ACTIONS(6009),
    [anon_sym_AMP] = ACTIONS(6011),
    [anon_sym_PIPE_PIPE] = ACTIONS(6013),
    [anon_sym_AMP_AMP] = ACTIONS(6015),
    [anon_sym_LT] = ACTIONS(6017),
    [anon_sym_LT_EQ] = ACTIONS(6019),
    [anon_sym_GT] = ACTIONS(6017),
    [anon_sym_GT_EQ] = ACTIONS(6019),
    [anon_sym_EQ_EQ] = ACTIONS(6019),
    [anon_sym_BANG_EQ] = ACTIONS(6019),
    [anon_sym_STAR] = ACTIONS(6021),
    [anon_sym_SLASH] = ACTIONS(6023),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_CARET] = ACTIONS(6025),
    [aux_sym_binary_operator_token1] = ACTIONS(6027),
    [anon_sym_PIPE_GT] = ACTIONS(6027),
    [anon_sym_COLON] = ACTIONS(6029),
    [anon_sym_DOLLAR] = ACTIONS(6031),
    [anon_sym_AT] = ACTIONS(6031),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6035),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6037),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(6039),
  },
  [1612] = {
    [sym_call_arguments] = STATE(2840),
    [sym_subset_arguments] = STATE(2797),
    [sym_subset2_arguments] = STATE(2801),
    [sym__open_parenthesis] = STATE(1344),
    [sym__open_bracket] = STATE(1374),
    [sym__open_bracket2] = STATE(1452),
    [ts_builtin_sym_end] = ACTIONS(5413),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_BSLASH] = ACTIONS(5413),
    [anon_sym_function] = ACTIONS(5415),
    [anon_sym_EQ] = ACTIONS(6263),
    [anon_sym_if] = ACTIONS(5415),
    [anon_sym_for] = ACTIONS(5415),
    [anon_sym_while] = ACTIONS(5415),
    [anon_sym_repeat] = ACTIONS(5415),
    [anon_sym_QMARK] = ACTIONS(5413),
    [anon_sym_TILDE] = ACTIONS(6265),
    [anon_sym_BANG] = ACTIONS(5415),
    [anon_sym_PLUS] = ACTIONS(6267),
    [anon_sym_DASH] = ACTIONS(6269),
    [anon_sym_LT_DASH] = ACTIONS(6271),
    [anon_sym_LT_LT_DASH] = ACTIONS(6271),
    [anon_sym_COLON_EQ] = ACTIONS(6271),
    [anon_sym_DASH_GT] = ACTIONS(6273),
    [anon_sym_DASH_GT_GT] = ACTIONS(6275),
    [anon_sym_PIPE] = ACTIONS(6277),
    [anon_sym_AMP] = ACTIONS(6279),
    [anon_sym_PIPE_PIPE] = ACTIONS(6281),
    [anon_sym_AMP_AMP] = ACTIONS(6283),
    [anon_sym_LT] = ACTIONS(6285),
    [anon_sym_LT_EQ] = ACTIONS(6287),
    [anon_sym_GT] = ACTIONS(6285),
    [anon_sym_GT_EQ] = ACTIONS(6287),
    [anon_sym_EQ_EQ] = ACTIONS(6287),
    [anon_sym_BANG_EQ] = ACTIONS(6287),
    [anon_sym_STAR] = ACTIONS(6289),
    [anon_sym_SLASH] = ACTIONS(6291),
    [anon_sym_STAR_STAR] = ACTIONS(6293),
    [anon_sym_CARET] = ACTIONS(6293),
    [aux_sym_binary_operator_token1] = ACTIONS(6295),
    [anon_sym_PIPE_GT] = ACTIONS(6295),
    [anon_sym_COLON] = ACTIONS(6297),
    [anon_sym_DOLLAR] = ACTIONS(6299),
    [anon_sym_AT] = ACTIONS(6299),
    [aux_sym__hex_literal_token1] = ACTIONS(5413),
    [sym__number_literal] = ACTIONS(5415),
    [anon_sym_SQUOTE] = ACTIONS(5413),
    [anon_sym_DQUOTE] = ACTIONS(5413),
    [sym_return] = ACTIONS(5415),
    [sym_next] = ACTIONS(5415),
    [sym_break] = ACTIONS(5415),
    [sym_true] = ACTIONS(5415),
    [sym_false] = ACTIONS(5415),
    [sym_null] = ACTIONS(5415),
    [sym_inf] = ACTIONS(5415),
    [sym_nan] = ACTIONS(5415),
    [anon_sym_NA] = ACTIONS(5415),
    [anon_sym_NA_integer_] = ACTIONS(5415),
    [anon_sym_NA_real_] = ACTIONS(5415),
    [anon_sym_NA_complex_] = ACTIONS(5415),
    [anon_sym_NA_character_] = ACTIONS(5415),
    [sym_dots] = ACTIONS(5415),
    [sym_dot_dot_i] = ACTIONS(5413),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5413),
    [sym__semicolon] = ACTIONS(5413),
    [sym__raw_string_literal] = ACTIONS(5413),
    [sym__external_open_parenthesis] = ACTIONS(6301),
    [sym__external_open_brace] = ACTIONS(5413),
    [sym__external_close_brace] = ACTIONS(5413),
    [sym__external_open_bracket] = ACTIONS(6303),
    [sym__external_open_bracket2] = ACTIONS(6305),
  },
  [1613] = {
    [sym_function_definition] = STATE(1940),
    [sym_if_statement] = STATE(1940),
    [sym_for_statement] = STATE(1940),
    [sym_while_statement] = STATE(1940),
    [sym_repeat_statement] = STATE(1940),
    [sym_braced_expression] = STATE(1940),
    [sym_parenthesized_expression] = STATE(1940),
    [sym_call] = STATE(1940),
    [sym_subset] = STATE(1940),
    [sym_subset2] = STATE(1940),
    [sym__argument] = STATE(4665),
    [sym_argument] = STATE(4661),
    [sym__argument_named] = STATE(4669),
    [sym__argument_unnamed] = STATE(4673),
    [sym__argument_value] = STATE(4679),
    [sym_unary_operator] = STATE(1940),
    [sym_binary_operator] = STATE(1940),
    [sym_extract_operator] = STATE(1940),
    [sym_namespace_operator] = STATE(1940),
    [sym_integer] = STATE(1940),
    [sym_complex] = STATE(1940),
    [sym_float] = STATE(1940),
    [sym__hex_literal] = STATE(2656),
    [sym__float_literal] = STATE(2656),
    [sym_string] = STATE(2606),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym_na] = STATE(1940),
    [sym__expression] = STATE(1940),
    [sym__string_or_identifier] = STATE(5141),
    [sym__open_parenthesis] = STATE(218),
    [sym__open_brace] = STATE(185),
    [sym__close_bracket2] = STATE(3003),
    [aux_sym_call_arguments_repeat1] = STATE(1895),
    [sym_identifier] = ACTIONS(6369),
    [anon_sym_BSLASH] = ACTIONS(4644),
    [anon_sym_function] = ACTIONS(4646),
    [anon_sym_if] = ACTIONS(4648),
    [anon_sym_for] = ACTIONS(4650),
    [anon_sym_while] = ACTIONS(4652),
    [anon_sym_repeat] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(6371),
    [anon_sym_PLUS] = ACTIONS(4662),
    [anon_sym_DASH] = ACTIONS(4662),
    [aux_sym__hex_literal_token1] = ACTIONS(4666),
    [sym__number_literal] = ACTIONS(4668),
    [anon_sym_SQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4672),
    [sym_return] = ACTIONS(6373),
    [sym_next] = ACTIONS(6373),
    [sym_break] = ACTIONS(6373),
    [sym_true] = ACTIONS(6373),
    [sym_false] = ACTIONS(6373),
    [sym_null] = ACTIONS(6373),
    [sym_inf] = ACTIONS(6373),
    [sym_nan] = ACTIONS(6373),
    [anon_sym_NA] = ACTIONS(4676),
    [anon_sym_NA_integer_] = ACTIONS(4676),
    [anon_sym_NA_real_] = ACTIONS(4676),
    [anon_sym_NA_complex_] = ACTIONS(4676),
    [anon_sym_NA_character_] = ACTIONS(4676),
    [sym_dots] = ACTIONS(6375),
    [sym_dot_dot_i] = ACTIONS(6377),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6379),
    [sym__newline] = ACTIONS(6381),
    [sym__raw_string_literal] = ACTIONS(4680),
    [sym__external_open_parenthesis] = ACTIONS(4682),
    [sym__external_open_brace] = ACTIONS(4684),
    [sym__external_close_bracket2] = ACTIONS(6769),
  },
  [1614] = {
    [sym_call_arguments] = STATE(2853),
    [sym_subset_arguments] = STATE(2854),
    [sym_subset2_arguments] = STATE(2864),
    [sym__open_parenthesis] = STATE(1366),
    [sym__open_bracket] = STATE(1365),
    [sym__open_bracket2] = STATE(1364),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5995),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5997),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5999),
    [anon_sym_DASH] = ACTIONS(6001),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(6005),
    [anon_sym_DASH_GT_GT] = ACTIONS(6007),
    [anon_sym_PIPE] = ACTIONS(6009),
    [anon_sym_AMP] = ACTIONS(6011),
    [anon_sym_PIPE_PIPE] = ACTIONS(6013),
    [anon_sym_AMP_AMP] = ACTIONS(6015),
    [anon_sym_LT] = ACTIONS(6017),
    [anon_sym_LT_EQ] = ACTIONS(6019),
    [anon_sym_GT] = ACTIONS(6017),
    [anon_sym_GT_EQ] = ACTIONS(6019),
    [anon_sym_EQ_EQ] = ACTIONS(6019),
    [anon_sym_BANG_EQ] = ACTIONS(6019),
    [anon_sym_STAR] = ACTIONS(6021),
    [anon_sym_SLASH] = ACTIONS(6023),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_CARET] = ACTIONS(6025),
    [aux_sym_binary_operator_token1] = ACTIONS(6027),
    [anon_sym_PIPE_GT] = ACTIONS(6027),
    [anon_sym_COLON] = ACTIONS(6029),
    [anon_sym_DOLLAR] = ACTIONS(6031),
    [anon_sym_AT] = ACTIONS(6031),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6035),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6037),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(6039),
  },
  [1615] = {
    [sym_function_definition] = STATE(2038),
    [sym_if_statement] = STATE(2038),
    [sym_for_statement] = STATE(2038),
    [sym_while_statement] = STATE(2038),
    [sym_repeat_statement] = STATE(2038),
    [sym_braced_expression] = STATE(2038),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_call] = STATE(2038),
    [sym_subset] = STATE(2038),
    [sym_subset2] = STATE(2038),
    [sym__argument] = STATE(4664),
    [sym_argument] = STATE(4659),
    [sym__argument_named] = STATE(4654),
    [sym__argument_unnamed] = STATE(4676),
    [sym__argument_value] = STATE(4677),
    [sym_unary_operator] = STATE(2038),
    [sym_binary_operator] = STATE(2038),
    [sym_extract_operator] = STATE(2038),
    [sym_namespace_operator] = STATE(2038),
    [sym_integer] = STATE(2038),
    [sym_complex] = STATE(2038),
    [sym_float] = STATE(2038),
    [sym__hex_literal] = STATE(2700),
    [sym__float_literal] = STATE(2700),
    [sym_string] = STATE(2597),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym_na] = STATE(2038),
    [sym__expression] = STATE(2038),
    [sym__string_or_identifier] = STATE(5148),
    [sym__open_parenthesis] = STATE(214),
    [sym__open_brace] = STATE(192),
    [sym__close_bracket] = STATE(3004),
    [aux_sym_call_arguments_repeat1] = STATE(1888),
    [sym_identifier] = ACTIONS(6351),
    [anon_sym_BSLASH] = ACTIONS(4754),
    [anon_sym_function] = ACTIONS(4756),
    [anon_sym_if] = ACTIONS(4758),
    [anon_sym_for] = ACTIONS(4760),
    [anon_sym_while] = ACTIONS(4762),
    [anon_sym_repeat] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4766),
    [anon_sym_TILDE] = ACTIONS(4768),
    [anon_sym_BANG] = ACTIONS(6353),
    [anon_sym_PLUS] = ACTIONS(4772),
    [anon_sym_DASH] = ACTIONS(4772),
    [aux_sym__hex_literal_token1] = ACTIONS(4776),
    [sym__number_literal] = ACTIONS(4778),
    [anon_sym_SQUOTE] = ACTIONS(4780),
    [anon_sym_DQUOTE] = ACTIONS(4782),
    [sym_return] = ACTIONS(6355),
    [sym_next] = ACTIONS(6355),
    [sym_break] = ACTIONS(6355),
    [sym_true] = ACTIONS(6355),
    [sym_false] = ACTIONS(6355),
    [sym_null] = ACTIONS(6355),
    [sym_inf] = ACTIONS(6355),
    [sym_nan] = ACTIONS(6355),
    [anon_sym_NA] = ACTIONS(4786),
    [anon_sym_NA_integer_] = ACTIONS(4786),
    [anon_sym_NA_real_] = ACTIONS(4786),
    [anon_sym_NA_complex_] = ACTIONS(4786),
    [anon_sym_NA_character_] = ACTIONS(4786),
    [sym_dots] = ACTIONS(6357),
    [sym_dot_dot_i] = ACTIONS(6359),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6361),
    [sym__newline] = ACTIONS(6363),
    [sym__raw_string_literal] = ACTIONS(4790),
    [sym__external_open_parenthesis] = ACTIONS(4792),
    [sym__external_open_brace] = ACTIONS(4794),
    [sym__external_close_bracket] = ACTIONS(6771),
  },
  [1616] = {
    [sym_function_definition] = STATE(1931),
    [sym_if_statement] = STATE(1931),
    [sym_for_statement] = STATE(1931),
    [sym_while_statement] = STATE(1931),
    [sym_repeat_statement] = STATE(1931),
    [sym_braced_expression] = STATE(1931),
    [sym_parenthesized_expression] = STATE(1931),
    [sym_call] = STATE(1931),
    [sym_subset] = STATE(1931),
    [sym_subset2] = STATE(1931),
    [sym__argument] = STATE(4656),
    [sym_argument] = STATE(4657),
    [sym__argument_named] = STATE(4658),
    [sym__argument_unnamed] = STATE(4662),
    [sym__argument_value] = STATE(4663),
    [sym_unary_operator] = STATE(1931),
    [sym_binary_operator] = STATE(1931),
    [sym_extract_operator] = STATE(1931),
    [sym_namespace_operator] = STATE(1931),
    [sym_integer] = STATE(1931),
    [sym_complex] = STATE(1931),
    [sym_float] = STATE(1931),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2633),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(1931),
    [sym__expression] = STATE(1931),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__close_parenthesis] = STATE(3005),
    [sym__open_brace] = STATE(154),
    [aux_sym_call_arguments_repeat1] = STATE(1339),
    [sym_identifier] = ACTIONS(6387),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(6389),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3865),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(6391),
    [sym_next] = ACTIONS(6391),
    [sym_break] = ACTIONS(6391),
    [sym_true] = ACTIONS(6391),
    [sym_false] = ACTIONS(6391),
    [sym_null] = ACTIONS(6391),
    [sym_inf] = ACTIONS(6391),
    [sym_nan] = ACTIONS(6391),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(6393),
    [sym_dot_dot_i] = ACTIONS(6395),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6397),
    [sym__newline] = ACTIONS(6399),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(6773),
    [sym__external_open_brace] = ACTIONS(3891),
  },
  [1617] = {
    [sym_call_arguments] = STATE(2840),
    [sym_subset_arguments] = STATE(2797),
    [sym_subset2_arguments] = STATE(2801),
    [sym__open_parenthesis] = STATE(1344),
    [sym__open_bracket] = STATE(1374),
    [sym__open_bracket2] = STATE(1452),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(6263),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(6265),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(6267),
    [anon_sym_DASH] = ACTIONS(6269),
    [anon_sym_LT_DASH] = ACTIONS(6271),
    [anon_sym_LT_LT_DASH] = ACTIONS(6271),
    [anon_sym_COLON_EQ] = ACTIONS(6271),
    [anon_sym_DASH_GT] = ACTIONS(6273),
    [anon_sym_DASH_GT_GT] = ACTIONS(6275),
    [anon_sym_PIPE] = ACTIONS(6277),
    [anon_sym_AMP] = ACTIONS(6279),
    [anon_sym_PIPE_PIPE] = ACTIONS(6281),
    [anon_sym_AMP_AMP] = ACTIONS(6283),
    [anon_sym_LT] = ACTIONS(6285),
    [anon_sym_LT_EQ] = ACTIONS(6287),
    [anon_sym_GT] = ACTIONS(6285),
    [anon_sym_GT_EQ] = ACTIONS(6287),
    [anon_sym_EQ_EQ] = ACTIONS(6287),
    [anon_sym_BANG_EQ] = ACTIONS(6287),
    [anon_sym_STAR] = ACTIONS(6289),
    [anon_sym_SLASH] = ACTIONS(6291),
    [anon_sym_STAR_STAR] = ACTIONS(6293),
    [anon_sym_CARET] = ACTIONS(6293),
    [aux_sym_binary_operator_token1] = ACTIONS(6295),
    [anon_sym_PIPE_GT] = ACTIONS(6295),
    [anon_sym_COLON] = ACTIONS(6297),
    [anon_sym_DOLLAR] = ACTIONS(6299),
    [anon_sym_AT] = ACTIONS(6299),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6301),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6303),
    [sym__external_open_bracket2] = ACTIONS(6305),
  },
  [1618] = {
    [sym_call_arguments] = STATE(2763),
    [sym_subset_arguments] = STATE(2764),
    [sym_subset2_arguments] = STATE(2765),
    [sym__open_parenthesis] = STATE(1584),
    [sym__open_bracket] = STATE(1582),
    [sym__open_bracket2] = STATE(1577),
    [sym_identifier] = ACTIONS(5311),
    [anon_sym_BSLASH] = ACTIONS(5313),
    [anon_sym_function] = ACTIONS(5311),
    [anon_sym_EQ] = ACTIONS(6431),
    [anon_sym_if] = ACTIONS(5311),
    [anon_sym_for] = ACTIONS(5311),
    [anon_sym_while] = ACTIONS(5311),
    [anon_sym_repeat] = ACTIONS(5311),
    [anon_sym_QMARK] = ACTIONS(6775),
    [anon_sym_TILDE] = ACTIONS(6433),
    [anon_sym_BANG] = ACTIONS(5311),
    [anon_sym_PLUS] = ACTIONS(6435),
    [anon_sym_DASH] = ACTIONS(6437),
    [anon_sym_LT_DASH] = ACTIONS(6439),
    [anon_sym_LT_LT_DASH] = ACTIONS(6439),
    [anon_sym_COLON_EQ] = ACTIONS(6439),
    [anon_sym_DASH_GT] = ACTIONS(6441),
    [anon_sym_DASH_GT_GT] = ACTIONS(6443),
    [anon_sym_PIPE] = ACTIONS(6445),
    [anon_sym_AMP] = ACTIONS(6447),
    [anon_sym_PIPE_PIPE] = ACTIONS(6449),
    [anon_sym_AMP_AMP] = ACTIONS(6451),
    [anon_sym_LT] = ACTIONS(6453),
    [anon_sym_LT_EQ] = ACTIONS(6455),
    [anon_sym_GT] = ACTIONS(6453),
    [anon_sym_GT_EQ] = ACTIONS(6455),
    [anon_sym_EQ_EQ] = ACTIONS(6455),
    [anon_sym_BANG_EQ] = ACTIONS(6455),
    [anon_sym_STAR] = ACTIONS(6457),
    [anon_sym_SLASH] = ACTIONS(6459),
    [anon_sym_STAR_STAR] = ACTIONS(6461),
    [anon_sym_CARET] = ACTIONS(6461),
    [aux_sym_binary_operator_token1] = ACTIONS(6463),
    [anon_sym_PIPE_GT] = ACTIONS(6463),
    [anon_sym_COLON] = ACTIONS(6465),
    [anon_sym_DOLLAR] = ACTIONS(6467),
    [anon_sym_AT] = ACTIONS(6467),
    [aux_sym__hex_literal_token1] = ACTIONS(5313),
    [sym__number_literal] = ACTIONS(5311),
    [anon_sym_SQUOTE] = ACTIONS(5313),
    [anon_sym_DQUOTE] = ACTIONS(5313),
    [sym_return] = ACTIONS(5311),
    [sym_next] = ACTIONS(5311),
    [sym_break] = ACTIONS(5311),
    [sym_true] = ACTIONS(5311),
    [sym_false] = ACTIONS(5311),
    [sym_null] = ACTIONS(5311),
    [sym_inf] = ACTIONS(5311),
    [sym_nan] = ACTIONS(5311),
    [anon_sym_NA] = ACTIONS(5311),
    [anon_sym_NA_integer_] = ACTIONS(5311),
    [anon_sym_NA_real_] = ACTIONS(5311),
    [anon_sym_NA_complex_] = ACTIONS(5311),
    [anon_sym_NA_character_] = ACTIONS(5311),
    [sym_dots] = ACTIONS(5311),
    [sym_dot_dot_i] = ACTIONS(5313),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5313),
    [sym__newline] = ACTIONS(5313),
    [sym__raw_string_literal] = ACTIONS(5313),
    [sym__external_open_parenthesis] = ACTIONS(6469),
    [sym__external_close_parenthesis] = ACTIONS(5313),
    [sym__external_open_brace] = ACTIONS(5313),
    [sym__external_open_bracket] = ACTIONS(6471),
    [sym__external_close_bracket] = ACTIONS(5313),
    [sym__external_open_bracket2] = ACTIONS(6473),
  },
  [1619] = {
    [sym_call_arguments] = STATE(2853),
    [sym_subset_arguments] = STATE(2854),
    [sym_subset2_arguments] = STATE(2864),
    [sym__open_parenthesis] = STATE(1366),
    [sym__open_bracket] = STATE(1365),
    [sym__open_bracket2] = STATE(1364),
    [sym_identifier] = ACTIONS(5401),
    [anon_sym_BSLASH] = ACTIONS(5399),
    [anon_sym_function] = ACTIONS(5401),
    [anon_sym_EQ] = ACTIONS(5995),
    [anon_sym_if] = ACTIONS(5401),
    [anon_sym_for] = ACTIONS(5401),
    [anon_sym_while] = ACTIONS(5401),
    [anon_sym_repeat] = ACTIONS(5401),
    [anon_sym_QMARK] = ACTIONS(5399),
    [anon_sym_TILDE] = ACTIONS(5997),
    [anon_sym_BANG] = ACTIONS(5401),
    [anon_sym_PLUS] = ACTIONS(5999),
    [anon_sym_DASH] = ACTIONS(6001),
    [anon_sym_LT_DASH] = ACTIONS(6003),
    [anon_sym_LT_LT_DASH] = ACTIONS(6003),
    [anon_sym_COLON_EQ] = ACTIONS(6003),
    [anon_sym_DASH_GT] = ACTIONS(6005),
    [anon_sym_DASH_GT_GT] = ACTIONS(6007),
    [anon_sym_PIPE] = ACTIONS(6009),
    [anon_sym_AMP] = ACTIONS(6011),
    [anon_sym_PIPE_PIPE] = ACTIONS(6013),
    [anon_sym_AMP_AMP] = ACTIONS(6015),
    [anon_sym_LT] = ACTIONS(6017),
    [anon_sym_LT_EQ] = ACTIONS(6019),
    [anon_sym_GT] = ACTIONS(6017),
    [anon_sym_GT_EQ] = ACTIONS(6019),
    [anon_sym_EQ_EQ] = ACTIONS(6019),
    [anon_sym_BANG_EQ] = ACTIONS(6019),
    [anon_sym_STAR] = ACTIONS(6021),
    [anon_sym_SLASH] = ACTIONS(6023),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_CARET] = ACTIONS(6025),
    [aux_sym_binary_operator_token1] = ACTIONS(6027),
    [anon_sym_PIPE_GT] = ACTIONS(6027),
    [anon_sym_COLON] = ACTIONS(6029),
    [anon_sym_DOLLAR] = ACTIONS(6031),
    [anon_sym_AT] = ACTIONS(6031),
    [aux_sym__hex_literal_token1] = ACTIONS(5399),
    [sym__number_literal] = ACTIONS(5401),
    [anon_sym_SQUOTE] = ACTIONS(5399),
    [anon_sym_DQUOTE] = ACTIONS(5399),
    [sym_return] = ACTIONS(5401),
    [sym_next] = ACTIONS(5401),
    [sym_break] = ACTIONS(5401),
    [sym_true] = ACTIONS(5401),
    [sym_false] = ACTIONS(5401),
    [sym_null] = ACTIONS(5401),
    [sym_inf] = ACTIONS(5401),
    [sym_nan] = ACTIONS(5401),
    [anon_sym_NA] = ACTIONS(5401),
    [anon_sym_NA_integer_] = ACTIONS(5401),
    [anon_sym_NA_real_] = ACTIONS(5401),
    [anon_sym_NA_complex_] = ACTIONS(5401),
    [anon_sym_NA_character_] = ACTIONS(5401),
    [sym_dots] = ACTIONS(5401),
    [sym_dot_dot_i] = ACTIONS(5399),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5399),
    [sym__newline] = ACTIONS(5399),
    [sym__raw_string_literal] = ACTIONS(5399),
    [sym__external_else] = ACTIONS(5399),
    [sym__external_open_parenthesis] = ACTIONS(6035),
    [sym__external_open_brace] = ACTIONS(5399),
    [sym__external_open_bracket] = ACTIONS(6037),
    [sym__external_close_bracket] = ACTIONS(5399),
    [sym__external_open_bracket2] = ACTIONS(6039),
  },
  [1620] = {
    [sym_function_definition] = STATE(1931),
    [sym_if_statement] = STATE(1931),
    [sym_for_statement] = STATE(1931),
    [sym_while_statement] = STATE(1931),
    [sym_repeat_statement] = STATE(1931),
    [sym_braced_expression] = STATE(1931),
    [sym_parenthesized_expression] = STATE(1931),
    [sym_call] = STATE(1931),
    [sym_subset] = STATE(1931),
    [sym_subset2] = STATE(1931),
    [sym__argument] = STATE(4656),
    [sym_argument] = STATE(4657),
    [sym__argument_named] = STATE(4658),
    [sym__argument_unnamed] = STATE(4662),
    [sym__argument_value] = STATE(4663),
    [sym_unary_operator] = STATE(1931),
    [sym_binary_operator] = STATE(1931),
    [sym_extract_operator] = STATE(1931),
    [sym_namespace_operator] = STATE(1931),
    [sym_integer] = STATE(1931),
    [sym_complex] = STATE(1931),
    [sym_float] = STATE(1931),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2633),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(1931),
    [sym__expression] = STATE(1931),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__close_parenthesis] = STATE(2774),
    [sym__open_brace] = STATE(154),
    [aux_sym_call_arguments_repeat1] = STATE(2113),
    [sym_identifier] = ACTIONS(6387),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(6389),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3865),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(6391),
    [sym_next] = ACTIONS(6391),
    [sym_break] = ACTIONS(6391),
    [sym_true] = ACTIONS(6391),
    [sym_false] = ACTIONS(6391),
    [sym_null] = ACTIONS(6391),
    [sym_inf] = ACTIONS(6391),
    [sym_nan] = ACTIONS(6391),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(6393),
    [sym_dot_dot_i] = ACTIONS(6395),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6397),
    [sym__newline] = ACTIONS(6399),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(6777),
    [sym__external_open_brace] = ACTIONS(3891),
  },
  [1621] = {
    [sym_call_arguments] = STATE(2840),
    [sym_subset_arguments] = STATE(2797),
    [sym_subset2_arguments] = STATE(2801),
    [sym__open_parenthesis] = STATE(1344),
    [sym__open_bracket] = STATE(1374),
    [sym__open_bracket2] = STATE(1452),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(6267),
    [anon_sym_DASH] = ACTIONS(6269),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(6277),
    [anon_sym_AMP] = ACTIONS(6279),
    [anon_sym_PIPE_PIPE] = ACTIONS(6281),
    [anon_sym_AMP_AMP] = ACTIONS(6283),
    [anon_sym_LT] = ACTIONS(6285),
    [anon_sym_LT_EQ] = ACTIONS(6287),
    [anon_sym_GT] = ACTIONS(6285),
    [anon_sym_GT_EQ] = ACTIONS(6287),
    [anon_sym_EQ_EQ] = ACTIONS(6287),
    [anon_sym_BANG_EQ] = ACTIONS(6287),
    [anon_sym_STAR] = ACTIONS(6289),
    [anon_sym_SLASH] = ACTIONS(6291),
    [anon_sym_STAR_STAR] = ACTIONS(6293),
    [anon_sym_CARET] = ACTIONS(6293),
    [aux_sym_binary_operator_token1] = ACTIONS(6295),
    [anon_sym_PIPE_GT] = ACTIONS(6295),
    [anon_sym_COLON] = ACTIONS(6297),
    [anon_sym_DOLLAR] = ACTIONS(6299),
    [anon_sym_AT] = ACTIONS(6299),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6301),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6303),
    [sym__external_open_bracket2] = ACTIONS(6305),
  },
  [1622] = {
    [sym_function_definition] = STATE(1940),
    [sym_if_statement] = STATE(1940),
    [sym_for_statement] = STATE(1940),
    [sym_while_statement] = STATE(1940),
    [sym_repeat_statement] = STATE(1940),
    [sym_braced_expression] = STATE(1940),
    [sym_parenthesized_expression] = STATE(1940),
    [sym_call] = STATE(1940),
    [sym_subset] = STATE(1940),
    [sym_subset2] = STATE(1940),
    [sym__argument] = STATE(4665),
    [sym_argument] = STATE(4661),
    [sym__argument_named] = STATE(4669),
    [sym__argument_unnamed] = STATE(4673),
    [sym__argument_value] = STATE(4679),
    [sym_unary_operator] = STATE(1940),
    [sym_binary_operator] = STATE(1940),
    [sym_extract_operator] = STATE(1940),
    [sym_namespace_operator] = STATE(1940),
    [sym_integer] = STATE(1940),
    [sym_complex] = STATE(1940),
    [sym_float] = STATE(1940),
    [sym__hex_literal] = STATE(2656),
    [sym__float_literal] = STATE(2656),
    [sym_string] = STATE(2606),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym_na] = STATE(1940),
    [sym__expression] = STATE(1940),
    [sym__string_or_identifier] = STATE(5141),
    [sym__open_parenthesis] = STATE(218),
    [sym__open_brace] = STATE(185),
    [sym__close_bracket2] = STATE(2913),
    [aux_sym_call_arguments_repeat1] = STATE(1912),
    [sym_identifier] = ACTIONS(6369),
    [anon_sym_BSLASH] = ACTIONS(4644),
    [anon_sym_function] = ACTIONS(4646),
    [anon_sym_if] = ACTIONS(4648),
    [anon_sym_for] = ACTIONS(4650),
    [anon_sym_while] = ACTIONS(4652),
    [anon_sym_repeat] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(6371),
    [anon_sym_PLUS] = ACTIONS(4662),
    [anon_sym_DASH] = ACTIONS(4662),
    [aux_sym__hex_literal_token1] = ACTIONS(4666),
    [sym__number_literal] = ACTIONS(4668),
    [anon_sym_SQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4672),
    [sym_return] = ACTIONS(6373),
    [sym_next] = ACTIONS(6373),
    [sym_break] = ACTIONS(6373),
    [sym_true] = ACTIONS(6373),
    [sym_false] = ACTIONS(6373),
    [sym_null] = ACTIONS(6373),
    [sym_inf] = ACTIONS(6373),
    [sym_nan] = ACTIONS(6373),
    [anon_sym_NA] = ACTIONS(4676),
    [anon_sym_NA_integer_] = ACTIONS(4676),
    [anon_sym_NA_real_] = ACTIONS(4676),
    [anon_sym_NA_complex_] = ACTIONS(4676),
    [anon_sym_NA_character_] = ACTIONS(4676),
    [sym_dots] = ACTIONS(6375),
    [sym_dot_dot_i] = ACTIONS(6377),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6379),
    [sym__newline] = ACTIONS(6381),
    [sym__raw_string_literal] = ACTIONS(4680),
    [sym__external_open_parenthesis] = ACTIONS(4682),
    [sym__external_open_brace] = ACTIONS(4684),
    [sym__external_close_bracket2] = ACTIONS(6779),
  },
  [1623] = {
    [sym_call_arguments] = STATE(2923),
    [sym_subset_arguments] = STATE(2922),
    [sym_subset2_arguments] = STATE(2906),
    [sym__open_parenthesis] = STATE(1528),
    [sym__open_bracket] = STATE(1525),
    [sym__open_bracket2] = STATE(1519),
    [ts_builtin_sym_end] = ACTIONS(5409),
    [sym_identifier] = ACTIONS(5411),
    [anon_sym_BSLASH] = ACTIONS(5409),
    [anon_sym_function] = ACTIONS(5411),
    [anon_sym_EQ] = ACTIONS(5947),
    [anon_sym_if] = ACTIONS(5411),
    [anon_sym_for] = ACTIONS(5411),
    [anon_sym_while] = ACTIONS(5411),
    [anon_sym_repeat] = ACTIONS(5411),
    [anon_sym_QMARK] = ACTIONS(5409),
    [anon_sym_TILDE] = ACTIONS(5949),
    [anon_sym_BANG] = ACTIONS(5411),
    [anon_sym_PLUS] = ACTIONS(5951),
    [anon_sym_DASH] = ACTIONS(5953),
    [anon_sym_LT_DASH] = ACTIONS(5955),
    [anon_sym_LT_LT_DASH] = ACTIONS(5955),
    [anon_sym_COLON_EQ] = ACTIONS(5955),
    [anon_sym_DASH_GT] = ACTIONS(5957),
    [anon_sym_DASH_GT_GT] = ACTIONS(5959),
    [anon_sym_PIPE] = ACTIONS(5961),
    [anon_sym_AMP] = ACTIONS(5963),
    [anon_sym_PIPE_PIPE] = ACTIONS(5965),
    [anon_sym_AMP_AMP] = ACTIONS(5967),
    [anon_sym_LT] = ACTIONS(5969),
    [anon_sym_LT_EQ] = ACTIONS(5971),
    [anon_sym_GT] = ACTIONS(5969),
    [anon_sym_GT_EQ] = ACTIONS(5971),
    [anon_sym_EQ_EQ] = ACTIONS(5971),
    [anon_sym_BANG_EQ] = ACTIONS(5971),
    [anon_sym_STAR] = ACTIONS(5973),
    [anon_sym_SLASH] = ACTIONS(5975),
    [anon_sym_STAR_STAR] = ACTIONS(5977),
    [anon_sym_CARET] = ACTIONS(5977),
    [aux_sym_binary_operator_token1] = ACTIONS(5979),
    [anon_sym_PIPE_GT] = ACTIONS(5979),
    [anon_sym_COLON] = ACTIONS(5981),
    [anon_sym_DOLLAR] = ACTIONS(5983),
    [anon_sym_AT] = ACTIONS(5983),
    [aux_sym__hex_literal_token1] = ACTIONS(5409),
    [sym__number_literal] = ACTIONS(5411),
    [anon_sym_SQUOTE] = ACTIONS(5409),
    [anon_sym_DQUOTE] = ACTIONS(5409),
    [sym_return] = ACTIONS(5411),
    [sym_next] = ACTIONS(5411),
    [sym_break] = ACTIONS(5411),
    [sym_true] = ACTIONS(5411),
    [sym_false] = ACTIONS(5411),
    [sym_null] = ACTIONS(5411),
    [sym_inf] = ACTIONS(5411),
    [sym_nan] = ACTIONS(5411),
    [anon_sym_NA] = ACTIONS(5411),
    [anon_sym_NA_integer_] = ACTIONS(5411),
    [anon_sym_NA_real_] = ACTIONS(5411),
    [anon_sym_NA_complex_] = ACTIONS(5411),
    [anon_sym_NA_character_] = ACTIONS(5411),
    [sym_dots] = ACTIONS(5411),
    [sym_dot_dot_i] = ACTIONS(5409),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5409),
    [sym__semicolon] = ACTIONS(5409),
    [sym__raw_string_literal] = ACTIONS(5409),
    [sym__external_else] = ACTIONS(5409),
    [sym__external_open_parenthesis] = ACTIONS(5987),
    [sym__external_open_brace] = ACTIONS(5409),
    [sym__external_open_bracket] = ACTIONS(5989),
    [sym__external_open_bracket2] = ACTIONS(5991),
  },
  [1624] = {
    [sym_call_arguments] = STATE(2923),
    [sym_subset_arguments] = STATE(2922),
    [sym_subset2_arguments] = STATE(2906),
    [sym__open_parenthesis] = STATE(1528),
    [sym__open_bracket] = STATE(1525),
    [sym__open_bracket2] = STATE(1519),
    [ts_builtin_sym_end] = ACTIONS(5453),
    [sym_identifier] = ACTIONS(5455),
    [anon_sym_BSLASH] = ACTIONS(5453),
    [anon_sym_function] = ACTIONS(5455),
    [anon_sym_EQ] = ACTIONS(5947),
    [anon_sym_if] = ACTIONS(5455),
    [anon_sym_for] = ACTIONS(5455),
    [anon_sym_while] = ACTIONS(5455),
    [anon_sym_repeat] = ACTIONS(5455),
    [anon_sym_QMARK] = ACTIONS(5453),
    [anon_sym_TILDE] = ACTIONS(5949),
    [anon_sym_BANG] = ACTIONS(5455),
    [anon_sym_PLUS] = ACTIONS(5951),
    [anon_sym_DASH] = ACTIONS(5953),
    [anon_sym_LT_DASH] = ACTIONS(5955),
    [anon_sym_LT_LT_DASH] = ACTIONS(5955),
    [anon_sym_COLON_EQ] = ACTIONS(5955),
    [anon_sym_DASH_GT] = ACTIONS(5957),
    [anon_sym_DASH_GT_GT] = ACTIONS(5959),
    [anon_sym_PIPE] = ACTIONS(5961),
    [anon_sym_AMP] = ACTIONS(5963),
    [anon_sym_PIPE_PIPE] = ACTIONS(5965),
    [anon_sym_AMP_AMP] = ACTIONS(5967),
    [anon_sym_LT] = ACTIONS(5969),
    [anon_sym_LT_EQ] = ACTIONS(5971),
    [anon_sym_GT] = ACTIONS(5969),
    [anon_sym_GT_EQ] = ACTIONS(5971),
    [anon_sym_EQ_EQ] = ACTIONS(5971),
    [anon_sym_BANG_EQ] = ACTIONS(5971),
    [anon_sym_STAR] = ACTIONS(5973),
    [anon_sym_SLASH] = ACTIONS(5975),
    [anon_sym_STAR_STAR] = ACTIONS(5977),
    [anon_sym_CARET] = ACTIONS(5977),
    [aux_sym_binary_operator_token1] = ACTIONS(5979),
    [anon_sym_PIPE_GT] = ACTIONS(5979),
    [anon_sym_COLON] = ACTIONS(5981),
    [anon_sym_DOLLAR] = ACTIONS(5983),
    [anon_sym_AT] = ACTIONS(5983),
    [aux_sym__hex_literal_token1] = ACTIONS(5453),
    [sym__number_literal] = ACTIONS(5455),
    [anon_sym_SQUOTE] = ACTIONS(5453),
    [anon_sym_DQUOTE] = ACTIONS(5453),
    [sym_return] = ACTIONS(5455),
    [sym_next] = ACTIONS(5455),
    [sym_break] = ACTIONS(5455),
    [sym_true] = ACTIONS(5455),
    [sym_false] = ACTIONS(5455),
    [sym_null] = ACTIONS(5455),
    [sym_inf] = ACTIONS(5455),
    [sym_nan] = ACTIONS(5455),
    [anon_sym_NA] = ACTIONS(5455),
    [anon_sym_NA_integer_] = ACTIONS(5455),
    [anon_sym_NA_real_] = ACTIONS(5455),
    [anon_sym_NA_complex_] = ACTIONS(5455),
    [anon_sym_NA_character_] = ACTIONS(5455),
    [sym_dots] = ACTIONS(5455),
    [sym_dot_dot_i] = ACTIONS(5453),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5453),
    [sym__semicolon] = ACTIONS(5453),
    [sym__raw_string_literal] = ACTIONS(5453),
    [sym__external_else] = ACTIONS(5453),
    [sym__external_open_parenthesis] = ACTIONS(5987),
    [sym__external_open_brace] = ACTIONS(5453),
    [sym__external_open_bracket] = ACTIONS(5989),
    [sym__external_open_bracket2] = ACTIONS(5991),
  },
  [1625] = {
    [sym_function_definition] = STATE(2038),
    [sym_if_statement] = STATE(2038),
    [sym_for_statement] = STATE(2038),
    [sym_while_statement] = STATE(2038),
    [sym_repeat_statement] = STATE(2038),
    [sym_braced_expression] = STATE(2038),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_call] = STATE(2038),
    [sym_subset] = STATE(2038),
    [sym_subset2] = STATE(2038),
    [sym__argument] = STATE(4664),
    [sym_argument] = STATE(4659),
    [sym__argument_named] = STATE(4654),
    [sym__argument_unnamed] = STATE(4676),
    [sym__argument_value] = STATE(4677),
    [sym_unary_operator] = STATE(2038),
    [sym_binary_operator] = STATE(2038),
    [sym_extract_operator] = STATE(2038),
    [sym_namespace_operator] = STATE(2038),
    [sym_integer] = STATE(2038),
    [sym_complex] = STATE(2038),
    [sym_float] = STATE(2038),
    [sym__hex_literal] = STATE(2700),
    [sym__float_literal] = STATE(2700),
    [sym_string] = STATE(2597),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym_na] = STATE(2038),
    [sym__expression] = STATE(2038),
    [sym__string_or_identifier] = STATE(5148),
    [sym__open_parenthesis] = STATE(214),
    [sym__open_brace] = STATE(192),
    [sym__close_bracket] = STATE(2914),
    [aux_sym_call_arguments_repeat1] = STATE(2034),
    [sym_identifier] = ACTIONS(6351),
    [anon_sym_BSLASH] = ACTIONS(4754),
    [anon_sym_function] = ACTIONS(4756),
    [anon_sym_if] = ACTIONS(4758),
    [anon_sym_for] = ACTIONS(4760),
    [anon_sym_while] = ACTIONS(4762),
    [anon_sym_repeat] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4766),
    [anon_sym_TILDE] = ACTIONS(4768),
    [anon_sym_BANG] = ACTIONS(6353),
    [anon_sym_PLUS] = ACTIONS(4772),
    [anon_sym_DASH] = ACTIONS(4772),
    [aux_sym__hex_literal_token1] = ACTIONS(4776),
    [sym__number_literal] = ACTIONS(4778),
    [anon_sym_SQUOTE] = ACTIONS(4780),
    [anon_sym_DQUOTE] = ACTIONS(4782),
    [sym_return] = ACTIONS(6355),
    [sym_next] = ACTIONS(6355),
    [sym_break] = ACTIONS(6355),
    [sym_true] = ACTIONS(6355),
    [sym_false] = ACTIONS(6355),
    [sym_null] = ACTIONS(6355),
    [sym_inf] = ACTIONS(6355),
    [sym_nan] = ACTIONS(6355),
    [anon_sym_NA] = ACTIONS(4786),
    [anon_sym_NA_integer_] = ACTIONS(4786),
    [anon_sym_NA_real_] = ACTIONS(4786),
    [anon_sym_NA_complex_] = ACTIONS(4786),
    [anon_sym_NA_character_] = ACTIONS(4786),
    [sym_dots] = ACTIONS(6357),
    [sym_dot_dot_i] = ACTIONS(6359),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6361),
    [sym__newline] = ACTIONS(6363),
    [sym__raw_string_literal] = ACTIONS(4790),
    [sym__external_open_parenthesis] = ACTIONS(4792),
    [sym__external_open_brace] = ACTIONS(4794),
    [sym__external_close_bracket] = ACTIONS(6781),
  },
  [1626] = {
    [sym_call_arguments] = STATE(2840),
    [sym_subset_arguments] = STATE(2797),
    [sym_subset2_arguments] = STATE(2801),
    [sym__open_parenthesis] = STATE(1344),
    [sym__open_bracket] = STATE(1374),
    [sym__open_bracket2] = STATE(1452),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(6289),
    [anon_sym_SLASH] = ACTIONS(6291),
    [anon_sym_STAR_STAR] = ACTIONS(6293),
    [anon_sym_CARET] = ACTIONS(6293),
    [aux_sym_binary_operator_token1] = ACTIONS(6295),
    [anon_sym_PIPE_GT] = ACTIONS(6295),
    [anon_sym_COLON] = ACTIONS(6297),
    [anon_sym_DOLLAR] = ACTIONS(6299),
    [anon_sym_AT] = ACTIONS(6299),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6301),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6303),
    [sym__external_open_bracket2] = ACTIONS(6305),
  },
  [1627] = {
    [sym_call_arguments] = STATE(2853),
    [sym_subset_arguments] = STATE(2854),
    [sym_subset2_arguments] = STATE(2864),
    [sym__open_parenthesis] = STATE(1366),
    [sym__open_bracket] = STATE(1365),
    [sym__open_bracket2] = STATE(1364),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_CARET] = ACTIONS(6025),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(5351),
    [anon_sym_DOLLAR] = ACTIONS(6031),
    [anon_sym_AT] = ACTIONS(6031),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6035),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6037),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(6039),
  },
  [1628] = {
    [sym_call_arguments] = STATE(2853),
    [sym_subset_arguments] = STATE(2854),
    [sym_subset2_arguments] = STATE(2864),
    [sym__open_parenthesis] = STATE(1366),
    [sym__open_bracket] = STATE(1365),
    [sym__open_bracket2] = STATE(1364),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_CARET] = ACTIONS(6025),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(6029),
    [anon_sym_DOLLAR] = ACTIONS(6031),
    [anon_sym_AT] = ACTIONS(6031),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6035),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6037),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(6039),
  },
  [1629] = {
    [sym_call_arguments] = STATE(2853),
    [sym_subset_arguments] = STATE(2854),
    [sym_subset2_arguments] = STATE(2864),
    [sym__open_parenthesis] = STATE(1366),
    [sym__open_bracket] = STATE(1365),
    [sym__open_bracket2] = STATE(1364),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_CARET] = ACTIONS(6025),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(5351),
    [anon_sym_DOLLAR] = ACTIONS(6031),
    [anon_sym_AT] = ACTIONS(6031),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6035),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6037),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(6039),
  },
  [1630] = {
    [sym_call_arguments] = STATE(2853),
    [sym_subset_arguments] = STATE(2854),
    [sym_subset2_arguments] = STATE(2864),
    [sym__open_parenthesis] = STATE(1366),
    [sym__open_bracket] = STATE(1365),
    [sym__open_bracket2] = STATE(1364),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_CARET] = ACTIONS(6025),
    [aux_sym_binary_operator_token1] = ACTIONS(6027),
    [anon_sym_PIPE_GT] = ACTIONS(6027),
    [anon_sym_COLON] = ACTIONS(6029),
    [anon_sym_DOLLAR] = ACTIONS(6031),
    [anon_sym_AT] = ACTIONS(6031),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6035),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6037),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(6039),
  },
  [1631] = {
    [sym_call_arguments] = STATE(2853),
    [sym_subset_arguments] = STATE(2854),
    [sym_subset2_arguments] = STATE(2864),
    [sym__open_parenthesis] = STATE(1366),
    [sym__open_bracket] = STATE(1365),
    [sym__open_bracket2] = STATE(1364),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5999),
    [anon_sym_DASH] = ACTIONS(6001),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(6021),
    [anon_sym_SLASH] = ACTIONS(6023),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_CARET] = ACTIONS(6025),
    [aux_sym_binary_operator_token1] = ACTIONS(6027),
    [anon_sym_PIPE_GT] = ACTIONS(6027),
    [anon_sym_COLON] = ACTIONS(6029),
    [anon_sym_DOLLAR] = ACTIONS(6031),
    [anon_sym_AT] = ACTIONS(6031),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6035),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6037),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(6039),
  },
  [1632] = {
    [sym_call_arguments] = STATE(2853),
    [sym_subset_arguments] = STATE(2854),
    [sym_subset2_arguments] = STATE(2864),
    [sym__open_parenthesis] = STATE(1366),
    [sym__open_bracket] = STATE(1365),
    [sym__open_bracket2] = STATE(1364),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5999),
    [anon_sym_DASH] = ACTIONS(6001),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(6017),
    [anon_sym_LT_EQ] = ACTIONS(6019),
    [anon_sym_GT] = ACTIONS(6017),
    [anon_sym_GT_EQ] = ACTIONS(6019),
    [anon_sym_EQ_EQ] = ACTIONS(6019),
    [anon_sym_BANG_EQ] = ACTIONS(6019),
    [anon_sym_STAR] = ACTIONS(6021),
    [anon_sym_SLASH] = ACTIONS(6023),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_CARET] = ACTIONS(6025),
    [aux_sym_binary_operator_token1] = ACTIONS(6027),
    [anon_sym_PIPE_GT] = ACTIONS(6027),
    [anon_sym_COLON] = ACTIONS(6029),
    [anon_sym_DOLLAR] = ACTIONS(6031),
    [anon_sym_AT] = ACTIONS(6031),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6035),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6037),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(6039),
  },
  [1633] = {
    [sym_call_arguments] = STATE(2853),
    [sym_subset_arguments] = STATE(2854),
    [sym_subset2_arguments] = STATE(2864),
    [sym__open_parenthesis] = STATE(1366),
    [sym__open_bracket] = STATE(1365),
    [sym__open_bracket2] = STATE(1364),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5999),
    [anon_sym_DASH] = ACTIONS(6001),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(6011),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(6015),
    [anon_sym_LT] = ACTIONS(6017),
    [anon_sym_LT_EQ] = ACTIONS(6019),
    [anon_sym_GT] = ACTIONS(6017),
    [anon_sym_GT_EQ] = ACTIONS(6019),
    [anon_sym_EQ_EQ] = ACTIONS(6019),
    [anon_sym_BANG_EQ] = ACTIONS(6019),
    [anon_sym_STAR] = ACTIONS(6021),
    [anon_sym_SLASH] = ACTIONS(6023),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_CARET] = ACTIONS(6025),
    [aux_sym_binary_operator_token1] = ACTIONS(6027),
    [anon_sym_PIPE_GT] = ACTIONS(6027),
    [anon_sym_COLON] = ACTIONS(6029),
    [anon_sym_DOLLAR] = ACTIONS(6031),
    [anon_sym_AT] = ACTIONS(6031),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6035),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6037),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(6039),
  },
  [1634] = {
    [sym_call_arguments] = STATE(2853),
    [sym_subset_arguments] = STATE(2854),
    [sym_subset2_arguments] = STATE(2864),
    [sym__open_parenthesis] = STATE(1366),
    [sym__open_bracket] = STATE(1365),
    [sym__open_bracket2] = STATE(1364),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5997),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5999),
    [anon_sym_DASH] = ACTIONS(6001),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(6009),
    [anon_sym_AMP] = ACTIONS(6011),
    [anon_sym_PIPE_PIPE] = ACTIONS(6013),
    [anon_sym_AMP_AMP] = ACTIONS(6015),
    [anon_sym_LT] = ACTIONS(6017),
    [anon_sym_LT_EQ] = ACTIONS(6019),
    [anon_sym_GT] = ACTIONS(6017),
    [anon_sym_GT_EQ] = ACTIONS(6019),
    [anon_sym_EQ_EQ] = ACTIONS(6019),
    [anon_sym_BANG_EQ] = ACTIONS(6019),
    [anon_sym_STAR] = ACTIONS(6021),
    [anon_sym_SLASH] = ACTIONS(6023),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_CARET] = ACTIONS(6025),
    [aux_sym_binary_operator_token1] = ACTIONS(6027),
    [anon_sym_PIPE_GT] = ACTIONS(6027),
    [anon_sym_COLON] = ACTIONS(6029),
    [anon_sym_DOLLAR] = ACTIONS(6031),
    [anon_sym_AT] = ACTIONS(6031),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6035),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6037),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(6039),
  },
  [1635] = {
    [sym_call_arguments] = STATE(2853),
    [sym_subset_arguments] = STATE(2854),
    [sym_subset2_arguments] = STATE(2864),
    [sym__open_parenthesis] = STATE(1366),
    [sym__open_bracket] = STATE(1365),
    [sym__open_bracket2] = STATE(1364),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5995),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5997),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5999),
    [anon_sym_DASH] = ACTIONS(6001),
    [anon_sym_LT_DASH] = ACTIONS(6003),
    [anon_sym_LT_LT_DASH] = ACTIONS(6003),
    [anon_sym_COLON_EQ] = ACTIONS(6003),
    [anon_sym_DASH_GT] = ACTIONS(6005),
    [anon_sym_DASH_GT_GT] = ACTIONS(6007),
    [anon_sym_PIPE] = ACTIONS(6009),
    [anon_sym_AMP] = ACTIONS(6011),
    [anon_sym_PIPE_PIPE] = ACTIONS(6013),
    [anon_sym_AMP_AMP] = ACTIONS(6015),
    [anon_sym_LT] = ACTIONS(6017),
    [anon_sym_LT_EQ] = ACTIONS(6019),
    [anon_sym_GT] = ACTIONS(6017),
    [anon_sym_GT_EQ] = ACTIONS(6019),
    [anon_sym_EQ_EQ] = ACTIONS(6019),
    [anon_sym_BANG_EQ] = ACTIONS(6019),
    [anon_sym_STAR] = ACTIONS(6021),
    [anon_sym_SLASH] = ACTIONS(6023),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_CARET] = ACTIONS(6025),
    [aux_sym_binary_operator_token1] = ACTIONS(6027),
    [anon_sym_PIPE_GT] = ACTIONS(6027),
    [anon_sym_COLON] = ACTIONS(6029),
    [anon_sym_DOLLAR] = ACTIONS(6031),
    [anon_sym_AT] = ACTIONS(6031),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6035),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6037),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(6039),
  },
  [1636] = {
    [sym_call_arguments] = STATE(2840),
    [sym_subset_arguments] = STATE(2797),
    [sym_subset2_arguments] = STATE(2801),
    [sym__open_parenthesis] = STATE(1344),
    [sym__open_bracket] = STATE(1374),
    [sym__open_bracket2] = STATE(1452),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(6289),
    [anon_sym_SLASH] = ACTIONS(6291),
    [anon_sym_STAR_STAR] = ACTIONS(6293),
    [anon_sym_CARET] = ACTIONS(6293),
    [aux_sym_binary_operator_token1] = ACTIONS(6295),
    [anon_sym_PIPE_GT] = ACTIONS(6295),
    [anon_sym_COLON] = ACTIONS(6297),
    [anon_sym_DOLLAR] = ACTIONS(6299),
    [anon_sym_AT] = ACTIONS(6299),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6301),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6303),
    [sym__external_open_bracket2] = ACTIONS(6305),
  },
  [1637] = {
    [sym_call_arguments] = STATE(2923),
    [sym_subset_arguments] = STATE(2922),
    [sym_subset2_arguments] = STATE(2906),
    [sym__open_parenthesis] = STATE(1528),
    [sym__open_bracket] = STATE(1525),
    [sym__open_bracket2] = STATE(1519),
    [ts_builtin_sym_end] = ACTIONS(5449),
    [sym_identifier] = ACTIONS(5451),
    [anon_sym_BSLASH] = ACTIONS(5449),
    [anon_sym_function] = ACTIONS(5451),
    [anon_sym_EQ] = ACTIONS(5947),
    [anon_sym_if] = ACTIONS(5451),
    [anon_sym_for] = ACTIONS(5451),
    [anon_sym_while] = ACTIONS(5451),
    [anon_sym_repeat] = ACTIONS(5451),
    [anon_sym_QMARK] = ACTIONS(5449),
    [anon_sym_TILDE] = ACTIONS(5949),
    [anon_sym_BANG] = ACTIONS(5451),
    [anon_sym_PLUS] = ACTIONS(5951),
    [anon_sym_DASH] = ACTIONS(5953),
    [anon_sym_LT_DASH] = ACTIONS(5955),
    [anon_sym_LT_LT_DASH] = ACTIONS(5955),
    [anon_sym_COLON_EQ] = ACTIONS(5955),
    [anon_sym_DASH_GT] = ACTIONS(5957),
    [anon_sym_DASH_GT_GT] = ACTIONS(5959),
    [anon_sym_PIPE] = ACTIONS(5961),
    [anon_sym_AMP] = ACTIONS(5963),
    [anon_sym_PIPE_PIPE] = ACTIONS(5965),
    [anon_sym_AMP_AMP] = ACTIONS(5967),
    [anon_sym_LT] = ACTIONS(5969),
    [anon_sym_LT_EQ] = ACTIONS(5971),
    [anon_sym_GT] = ACTIONS(5969),
    [anon_sym_GT_EQ] = ACTIONS(5971),
    [anon_sym_EQ_EQ] = ACTIONS(5971),
    [anon_sym_BANG_EQ] = ACTIONS(5971),
    [anon_sym_STAR] = ACTIONS(5973),
    [anon_sym_SLASH] = ACTIONS(5975),
    [anon_sym_STAR_STAR] = ACTIONS(5977),
    [anon_sym_CARET] = ACTIONS(5977),
    [aux_sym_binary_operator_token1] = ACTIONS(5979),
    [anon_sym_PIPE_GT] = ACTIONS(5979),
    [anon_sym_COLON] = ACTIONS(5981),
    [anon_sym_DOLLAR] = ACTIONS(5983),
    [anon_sym_AT] = ACTIONS(5983),
    [aux_sym__hex_literal_token1] = ACTIONS(5449),
    [sym__number_literal] = ACTIONS(5451),
    [anon_sym_SQUOTE] = ACTIONS(5449),
    [anon_sym_DQUOTE] = ACTIONS(5449),
    [sym_return] = ACTIONS(5451),
    [sym_next] = ACTIONS(5451),
    [sym_break] = ACTIONS(5451),
    [sym_true] = ACTIONS(5451),
    [sym_false] = ACTIONS(5451),
    [sym_null] = ACTIONS(5451),
    [sym_inf] = ACTIONS(5451),
    [sym_nan] = ACTIONS(5451),
    [anon_sym_NA] = ACTIONS(5451),
    [anon_sym_NA_integer_] = ACTIONS(5451),
    [anon_sym_NA_real_] = ACTIONS(5451),
    [anon_sym_NA_complex_] = ACTIONS(5451),
    [anon_sym_NA_character_] = ACTIONS(5451),
    [sym_dots] = ACTIONS(5451),
    [sym_dot_dot_i] = ACTIONS(5449),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5449),
    [sym__semicolon] = ACTIONS(5449),
    [sym__raw_string_literal] = ACTIONS(5449),
    [sym__external_else] = ACTIONS(5449),
    [sym__external_open_parenthesis] = ACTIONS(5987),
    [sym__external_open_brace] = ACTIONS(5449),
    [sym__external_open_bracket] = ACTIONS(5989),
    [sym__external_open_bracket2] = ACTIONS(5991),
  },
  [1638] = {
    [sym_call_arguments] = STATE(2853),
    [sym_subset_arguments] = STATE(2854),
    [sym_subset2_arguments] = STATE(2864),
    [sym__open_parenthesis] = STATE(1366),
    [sym__open_bracket] = STATE(1365),
    [sym__open_bracket2] = STATE(1364),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(6021),
    [anon_sym_SLASH] = ACTIONS(6023),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_CARET] = ACTIONS(6025),
    [aux_sym_binary_operator_token1] = ACTIONS(6027),
    [anon_sym_PIPE_GT] = ACTIONS(6027),
    [anon_sym_COLON] = ACTIONS(6029),
    [anon_sym_DOLLAR] = ACTIONS(6031),
    [anon_sym_AT] = ACTIONS(6031),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6035),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6037),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(6039),
  },
  [1639] = {
    [sym_call_arguments] = STATE(2808),
    [sym_subset_arguments] = STATE(2920),
    [sym_subset2_arguments] = STATE(2919),
    [sym__open_parenthesis] = STATE(1545),
    [sym__open_bracket] = STATE(1541),
    [sym__open_bracket2] = STATE(1539),
    [sym_identifier] = ACTIONS(5331),
    [anon_sym_BSLASH] = ACTIONS(5329),
    [anon_sym_function] = ACTIONS(5331),
    [anon_sym_EQ] = ACTIONS(6307),
    [anon_sym_if] = ACTIONS(5331),
    [anon_sym_for] = ACTIONS(5331),
    [anon_sym_while] = ACTIONS(5331),
    [anon_sym_repeat] = ACTIONS(5331),
    [anon_sym_QMARK] = ACTIONS(5329),
    [anon_sym_TILDE] = ACTIONS(6309),
    [anon_sym_BANG] = ACTIONS(5331),
    [anon_sym_PLUS] = ACTIONS(6311),
    [anon_sym_DASH] = ACTIONS(6313),
    [anon_sym_LT_DASH] = ACTIONS(6315),
    [anon_sym_LT_LT_DASH] = ACTIONS(6315),
    [anon_sym_COLON_EQ] = ACTIONS(6315),
    [anon_sym_DASH_GT] = ACTIONS(6317),
    [anon_sym_DASH_GT_GT] = ACTIONS(6319),
    [anon_sym_PIPE] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6323),
    [anon_sym_PIPE_PIPE] = ACTIONS(6325),
    [anon_sym_AMP_AMP] = ACTIONS(6327),
    [anon_sym_LT] = ACTIONS(6329),
    [anon_sym_LT_EQ] = ACTIONS(6331),
    [anon_sym_GT] = ACTIONS(6329),
    [anon_sym_GT_EQ] = ACTIONS(6331),
    [anon_sym_EQ_EQ] = ACTIONS(6331),
    [anon_sym_BANG_EQ] = ACTIONS(6331),
    [anon_sym_STAR] = ACTIONS(6333),
    [anon_sym_SLASH] = ACTIONS(6335),
    [anon_sym_STAR_STAR] = ACTIONS(6337),
    [anon_sym_CARET] = ACTIONS(6337),
    [aux_sym_binary_operator_token1] = ACTIONS(6339),
    [anon_sym_PIPE_GT] = ACTIONS(6339),
    [anon_sym_COLON] = ACTIONS(6341),
    [anon_sym_DOLLAR] = ACTIONS(6343),
    [anon_sym_AT] = ACTIONS(6343),
    [aux_sym__hex_literal_token1] = ACTIONS(5329),
    [sym__number_literal] = ACTIONS(5331),
    [anon_sym_SQUOTE] = ACTIONS(5329),
    [anon_sym_DQUOTE] = ACTIONS(5329),
    [sym_return] = ACTIONS(5331),
    [sym_next] = ACTIONS(5331),
    [sym_break] = ACTIONS(5331),
    [sym_true] = ACTIONS(5331),
    [sym_false] = ACTIONS(5331),
    [sym_null] = ACTIONS(5331),
    [sym_inf] = ACTIONS(5331),
    [sym_nan] = ACTIONS(5331),
    [anon_sym_NA] = ACTIONS(5331),
    [anon_sym_NA_integer_] = ACTIONS(5331),
    [anon_sym_NA_real_] = ACTIONS(5331),
    [anon_sym_NA_complex_] = ACTIONS(5331),
    [anon_sym_NA_character_] = ACTIONS(5331),
    [sym_dots] = ACTIONS(5331),
    [sym_dot_dot_i] = ACTIONS(5329),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5329),
    [sym__newline] = ACTIONS(5329),
    [sym__raw_string_literal] = ACTIONS(5329),
    [sym__external_open_parenthesis] = ACTIONS(6345),
    [sym__external_close_parenthesis] = ACTIONS(5329),
    [sym__external_open_brace] = ACTIONS(5329),
    [sym__external_open_bracket] = ACTIONS(6347),
    [sym__external_open_bracket2] = ACTIONS(6349),
    [sym__external_close_bracket2] = ACTIONS(5329),
  },
  [1640] = {
    [sym_call_arguments] = STATE(2853),
    [sym_subset_arguments] = STATE(2854),
    [sym_subset2_arguments] = STATE(2864),
    [sym__open_parenthesis] = STATE(1366),
    [sym__open_bracket] = STATE(1365),
    [sym__open_bracket2] = STATE(1364),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5999),
    [anon_sym_DASH] = ACTIONS(6001),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(6009),
    [anon_sym_AMP] = ACTIONS(6011),
    [anon_sym_PIPE_PIPE] = ACTIONS(6013),
    [anon_sym_AMP_AMP] = ACTIONS(6015),
    [anon_sym_LT] = ACTIONS(6017),
    [anon_sym_LT_EQ] = ACTIONS(6019),
    [anon_sym_GT] = ACTIONS(6017),
    [anon_sym_GT_EQ] = ACTIONS(6019),
    [anon_sym_EQ_EQ] = ACTIONS(6019),
    [anon_sym_BANG_EQ] = ACTIONS(6019),
    [anon_sym_STAR] = ACTIONS(6021),
    [anon_sym_SLASH] = ACTIONS(6023),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_CARET] = ACTIONS(6025),
    [aux_sym_binary_operator_token1] = ACTIONS(6027),
    [anon_sym_PIPE_GT] = ACTIONS(6027),
    [anon_sym_COLON] = ACTIONS(6029),
    [anon_sym_DOLLAR] = ACTIONS(6031),
    [anon_sym_AT] = ACTIONS(6031),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6035),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6037),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(6039),
  },
  [1641] = {
    [sym_call_arguments] = STATE(2808),
    [sym_subset_arguments] = STATE(2920),
    [sym_subset2_arguments] = STATE(2919),
    [sym__open_parenthesis] = STATE(1545),
    [sym__open_bracket] = STATE(1541),
    [sym__open_bracket2] = STATE(1539),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(6307),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(6309),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(6311),
    [anon_sym_DASH] = ACTIONS(6313),
    [anon_sym_LT_DASH] = ACTIONS(6315),
    [anon_sym_LT_LT_DASH] = ACTIONS(6315),
    [anon_sym_COLON_EQ] = ACTIONS(6315),
    [anon_sym_DASH_GT] = ACTIONS(6317),
    [anon_sym_DASH_GT_GT] = ACTIONS(6319),
    [anon_sym_PIPE] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6323),
    [anon_sym_PIPE_PIPE] = ACTIONS(6325),
    [anon_sym_AMP_AMP] = ACTIONS(6327),
    [anon_sym_LT] = ACTIONS(6329),
    [anon_sym_LT_EQ] = ACTIONS(6331),
    [anon_sym_GT] = ACTIONS(6329),
    [anon_sym_GT_EQ] = ACTIONS(6331),
    [anon_sym_EQ_EQ] = ACTIONS(6331),
    [anon_sym_BANG_EQ] = ACTIONS(6331),
    [anon_sym_STAR] = ACTIONS(6333),
    [anon_sym_SLASH] = ACTIONS(6335),
    [anon_sym_STAR_STAR] = ACTIONS(6337),
    [anon_sym_CARET] = ACTIONS(6337),
    [aux_sym_binary_operator_token1] = ACTIONS(6339),
    [anon_sym_PIPE_GT] = ACTIONS(6339),
    [anon_sym_COLON] = ACTIONS(6341),
    [anon_sym_DOLLAR] = ACTIONS(6343),
    [anon_sym_AT] = ACTIONS(6343),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(6345),
    [sym__external_close_parenthesis] = ACTIONS(5333),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(6347),
    [sym__external_open_bracket2] = ACTIONS(6349),
    [sym__external_close_bracket2] = ACTIONS(5333),
  },
  [1642] = {
    [sym_call_arguments] = STATE(2853),
    [sym_subset_arguments] = STATE(2854),
    [sym_subset2_arguments] = STATE(2864),
    [sym__open_parenthesis] = STATE(1366),
    [sym__open_bracket] = STATE(1365),
    [sym__open_bracket2] = STATE(1364),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5995),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5997),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5999),
    [anon_sym_DASH] = ACTIONS(6001),
    [anon_sym_LT_DASH] = ACTIONS(6003),
    [anon_sym_LT_LT_DASH] = ACTIONS(6003),
    [anon_sym_COLON_EQ] = ACTIONS(6003),
    [anon_sym_DASH_GT] = ACTIONS(6005),
    [anon_sym_DASH_GT_GT] = ACTIONS(6007),
    [anon_sym_PIPE] = ACTIONS(6009),
    [anon_sym_AMP] = ACTIONS(6011),
    [anon_sym_PIPE_PIPE] = ACTIONS(6013),
    [anon_sym_AMP_AMP] = ACTIONS(6015),
    [anon_sym_LT] = ACTIONS(6017),
    [anon_sym_LT_EQ] = ACTIONS(6019),
    [anon_sym_GT] = ACTIONS(6017),
    [anon_sym_GT_EQ] = ACTIONS(6019),
    [anon_sym_EQ_EQ] = ACTIONS(6019),
    [anon_sym_BANG_EQ] = ACTIONS(6019),
    [anon_sym_STAR] = ACTIONS(6021),
    [anon_sym_SLASH] = ACTIONS(6023),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_CARET] = ACTIONS(6025),
    [aux_sym_binary_operator_token1] = ACTIONS(6027),
    [anon_sym_PIPE_GT] = ACTIONS(6027),
    [anon_sym_COLON] = ACTIONS(6029),
    [anon_sym_DOLLAR] = ACTIONS(6031),
    [anon_sym_AT] = ACTIONS(6031),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6035),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6037),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(6039),
  },
  [1643] = {
    [sym_call_arguments] = STATE(2808),
    [sym_subset_arguments] = STATE(2920),
    [sym_subset2_arguments] = STATE(2919),
    [sym__open_parenthesis] = STATE(1545),
    [sym__open_bracket] = STATE(1541),
    [sym__open_bracket2] = STATE(1539),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(6311),
    [anon_sym_DASH] = ACTIONS(6313),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6323),
    [anon_sym_PIPE_PIPE] = ACTIONS(6325),
    [anon_sym_AMP_AMP] = ACTIONS(6327),
    [anon_sym_LT] = ACTIONS(6329),
    [anon_sym_LT_EQ] = ACTIONS(6331),
    [anon_sym_GT] = ACTIONS(6329),
    [anon_sym_GT_EQ] = ACTIONS(6331),
    [anon_sym_EQ_EQ] = ACTIONS(6331),
    [anon_sym_BANG_EQ] = ACTIONS(6331),
    [anon_sym_STAR] = ACTIONS(6333),
    [anon_sym_SLASH] = ACTIONS(6335),
    [anon_sym_STAR_STAR] = ACTIONS(6337),
    [anon_sym_CARET] = ACTIONS(6337),
    [aux_sym_binary_operator_token1] = ACTIONS(6339),
    [anon_sym_PIPE_GT] = ACTIONS(6339),
    [anon_sym_COLON] = ACTIONS(6341),
    [anon_sym_DOLLAR] = ACTIONS(6343),
    [anon_sym_AT] = ACTIONS(6343),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(6345),
    [sym__external_close_parenthesis] = ACTIONS(5333),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(6347),
    [sym__external_open_bracket2] = ACTIONS(6349),
    [sym__external_close_bracket2] = ACTIONS(5333),
  },
  [1644] = {
    [sym_call_arguments] = STATE(2853),
    [sym_subset_arguments] = STATE(2854),
    [sym_subset2_arguments] = STATE(2864),
    [sym__open_parenthesis] = STATE(1366),
    [sym__open_bracket] = STATE(1365),
    [sym__open_bracket2] = STATE(1364),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5995),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5997),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5999),
    [anon_sym_DASH] = ACTIONS(6001),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(6005),
    [anon_sym_DASH_GT_GT] = ACTIONS(6007),
    [anon_sym_PIPE] = ACTIONS(6009),
    [anon_sym_AMP] = ACTIONS(6011),
    [anon_sym_PIPE_PIPE] = ACTIONS(6013),
    [anon_sym_AMP_AMP] = ACTIONS(6015),
    [anon_sym_LT] = ACTIONS(6017),
    [anon_sym_LT_EQ] = ACTIONS(6019),
    [anon_sym_GT] = ACTIONS(6017),
    [anon_sym_GT_EQ] = ACTIONS(6019),
    [anon_sym_EQ_EQ] = ACTIONS(6019),
    [anon_sym_BANG_EQ] = ACTIONS(6019),
    [anon_sym_STAR] = ACTIONS(6021),
    [anon_sym_SLASH] = ACTIONS(6023),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_CARET] = ACTIONS(6025),
    [aux_sym_binary_operator_token1] = ACTIONS(6027),
    [anon_sym_PIPE_GT] = ACTIONS(6027),
    [anon_sym_COLON] = ACTIONS(6029),
    [anon_sym_DOLLAR] = ACTIONS(6031),
    [anon_sym_AT] = ACTIONS(6031),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6035),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6037),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(6039),
  },
  [1645] = {
    [sym_call_arguments] = STATE(2808),
    [sym_subset_arguments] = STATE(2920),
    [sym_subset2_arguments] = STATE(2919),
    [sym__open_parenthesis] = STATE(1545),
    [sym__open_bracket] = STATE(1541),
    [sym__open_bracket2] = STATE(1539),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(6311),
    [anon_sym_DASH] = ACTIONS(6313),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5335),
    [anon_sym_AMP] = ACTIONS(5335),
    [anon_sym_PIPE_PIPE] = ACTIONS(5333),
    [anon_sym_AMP_AMP] = ACTIONS(5333),
    [anon_sym_LT] = ACTIONS(6329),
    [anon_sym_LT_EQ] = ACTIONS(6331),
    [anon_sym_GT] = ACTIONS(6329),
    [anon_sym_GT_EQ] = ACTIONS(6331),
    [anon_sym_EQ_EQ] = ACTIONS(6331),
    [anon_sym_BANG_EQ] = ACTIONS(6331),
    [anon_sym_STAR] = ACTIONS(6333),
    [anon_sym_SLASH] = ACTIONS(6335),
    [anon_sym_STAR_STAR] = ACTIONS(6337),
    [anon_sym_CARET] = ACTIONS(6337),
    [aux_sym_binary_operator_token1] = ACTIONS(6339),
    [anon_sym_PIPE_GT] = ACTIONS(6339),
    [anon_sym_COLON] = ACTIONS(6341),
    [anon_sym_DOLLAR] = ACTIONS(6343),
    [anon_sym_AT] = ACTIONS(6343),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(6345),
    [sym__external_close_parenthesis] = ACTIONS(5333),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(6347),
    [sym__external_open_bracket2] = ACTIONS(6349),
    [sym__external_close_bracket2] = ACTIONS(5333),
  },
  [1646] = {
    [sym_call_arguments] = STATE(2853),
    [sym_subset_arguments] = STATE(2854),
    [sym_subset2_arguments] = STATE(2864),
    [sym__open_parenthesis] = STATE(1366),
    [sym__open_bracket] = STATE(1365),
    [sym__open_bracket2] = STATE(1364),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5345),
    [anon_sym_DASH] = ACTIONS(5347),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5347),
    [anon_sym_AMP] = ACTIONS(5347),
    [anon_sym_PIPE_PIPE] = ACTIONS(5345),
    [anon_sym_AMP_AMP] = ACTIONS(5345),
    [anon_sym_LT] = ACTIONS(5347),
    [anon_sym_LT_EQ] = ACTIONS(5345),
    [anon_sym_GT] = ACTIONS(5347),
    [anon_sym_GT_EQ] = ACTIONS(5345),
    [anon_sym_EQ_EQ] = ACTIONS(5345),
    [anon_sym_BANG_EQ] = ACTIONS(5345),
    [anon_sym_STAR] = ACTIONS(5347),
    [anon_sym_SLASH] = ACTIONS(5345),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_CARET] = ACTIONS(6025),
    [aux_sym_binary_operator_token1] = ACTIONS(5345),
    [anon_sym_PIPE_GT] = ACTIONS(5345),
    [anon_sym_COLON] = ACTIONS(5347),
    [anon_sym_DOLLAR] = ACTIONS(6031),
    [anon_sym_AT] = ACTIONS(6031),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_else] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(6035),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(6037),
    [sym__external_close_bracket] = ACTIONS(5345),
    [sym__external_open_bracket2] = ACTIONS(6039),
  },
  [1647] = {
    [sym_call_arguments] = STATE(2808),
    [sym_subset_arguments] = STATE(2920),
    [sym_subset2_arguments] = STATE(2919),
    [sym__open_parenthesis] = STATE(1545),
    [sym__open_bracket] = STATE(1541),
    [sym__open_bracket2] = STATE(1539),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(5333),
    [anon_sym_DASH] = ACTIONS(5335),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5335),
    [anon_sym_AMP] = ACTIONS(5335),
    [anon_sym_PIPE_PIPE] = ACTIONS(5333),
    [anon_sym_AMP_AMP] = ACTIONS(5333),
    [anon_sym_LT] = ACTIONS(5335),
    [anon_sym_LT_EQ] = ACTIONS(5333),
    [anon_sym_GT] = ACTIONS(5335),
    [anon_sym_GT_EQ] = ACTIONS(5333),
    [anon_sym_EQ_EQ] = ACTIONS(5333),
    [anon_sym_BANG_EQ] = ACTIONS(5333),
    [anon_sym_STAR] = ACTIONS(5335),
    [anon_sym_SLASH] = ACTIONS(5333),
    [anon_sym_STAR_STAR] = ACTIONS(6337),
    [anon_sym_CARET] = ACTIONS(6337),
    [aux_sym_binary_operator_token1] = ACTIONS(5333),
    [anon_sym_PIPE_GT] = ACTIONS(5333),
    [anon_sym_COLON] = ACTIONS(5335),
    [anon_sym_DOLLAR] = ACTIONS(6343),
    [anon_sym_AT] = ACTIONS(6343),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(6345),
    [sym__external_close_parenthesis] = ACTIONS(5333),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(6347),
    [sym__external_open_bracket2] = ACTIONS(6349),
    [sym__external_close_bracket2] = ACTIONS(5333),
  },
  [1648] = {
    [sym_call_arguments] = STATE(2853),
    [sym_subset_arguments] = STATE(2854),
    [sym_subset2_arguments] = STATE(2864),
    [sym__open_parenthesis] = STATE(1366),
    [sym__open_bracket] = STATE(1365),
    [sym__open_bracket2] = STATE(1364),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5999),
    [anon_sym_DASH] = ACTIONS(6001),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5347),
    [anon_sym_AMP] = ACTIONS(5347),
    [anon_sym_PIPE_PIPE] = ACTIONS(5345),
    [anon_sym_AMP_AMP] = ACTIONS(5345),
    [anon_sym_LT] = ACTIONS(6017),
    [anon_sym_LT_EQ] = ACTIONS(6019),
    [anon_sym_GT] = ACTIONS(6017),
    [anon_sym_GT_EQ] = ACTIONS(6019),
    [anon_sym_EQ_EQ] = ACTIONS(6019),
    [anon_sym_BANG_EQ] = ACTIONS(6019),
    [anon_sym_STAR] = ACTIONS(6021),
    [anon_sym_SLASH] = ACTIONS(6023),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_CARET] = ACTIONS(6025),
    [aux_sym_binary_operator_token1] = ACTIONS(6027),
    [anon_sym_PIPE_GT] = ACTIONS(6027),
    [anon_sym_COLON] = ACTIONS(6029),
    [anon_sym_DOLLAR] = ACTIONS(6031),
    [anon_sym_AT] = ACTIONS(6031),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_else] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(6035),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(6037),
    [sym__external_close_bracket] = ACTIONS(5345),
    [sym__external_open_bracket2] = ACTIONS(6039),
  },
  [1649] = {
    [sym_call_arguments] = STATE(2853),
    [sym_subset_arguments] = STATE(2854),
    [sym_subset2_arguments] = STATE(2864),
    [sym__open_parenthesis] = STATE(1366),
    [sym__open_bracket] = STATE(1365),
    [sym__open_bracket2] = STATE(1364),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5999),
    [anon_sym_DASH] = ACTIONS(6001),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(6009),
    [anon_sym_AMP] = ACTIONS(6011),
    [anon_sym_PIPE_PIPE] = ACTIONS(6013),
    [anon_sym_AMP_AMP] = ACTIONS(6015),
    [anon_sym_LT] = ACTIONS(6017),
    [anon_sym_LT_EQ] = ACTIONS(6019),
    [anon_sym_GT] = ACTIONS(6017),
    [anon_sym_GT_EQ] = ACTIONS(6019),
    [anon_sym_EQ_EQ] = ACTIONS(6019),
    [anon_sym_BANG_EQ] = ACTIONS(6019),
    [anon_sym_STAR] = ACTIONS(6021),
    [anon_sym_SLASH] = ACTIONS(6023),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_CARET] = ACTIONS(6025),
    [aux_sym_binary_operator_token1] = ACTIONS(6027),
    [anon_sym_PIPE_GT] = ACTIONS(6027),
    [anon_sym_COLON] = ACTIONS(6029),
    [anon_sym_DOLLAR] = ACTIONS(6031),
    [anon_sym_AT] = ACTIONS(6031),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_else] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(6035),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(6037),
    [sym__external_close_bracket] = ACTIONS(5345),
    [sym__external_open_bracket2] = ACTIONS(6039),
  },
  [1650] = {
    [sym_call_arguments] = STATE(2853),
    [sym_subset_arguments] = STATE(2854),
    [sym_subset2_arguments] = STATE(2864),
    [sym__open_parenthesis] = STATE(1366),
    [sym__open_bracket] = STATE(1365),
    [sym__open_bracket2] = STATE(1364),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5995),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5997),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5999),
    [anon_sym_DASH] = ACTIONS(6001),
    [anon_sym_LT_DASH] = ACTIONS(6003),
    [anon_sym_LT_LT_DASH] = ACTIONS(6003),
    [anon_sym_COLON_EQ] = ACTIONS(6003),
    [anon_sym_DASH_GT] = ACTIONS(6005),
    [anon_sym_DASH_GT_GT] = ACTIONS(6007),
    [anon_sym_PIPE] = ACTIONS(6009),
    [anon_sym_AMP] = ACTIONS(6011),
    [anon_sym_PIPE_PIPE] = ACTIONS(6013),
    [anon_sym_AMP_AMP] = ACTIONS(6015),
    [anon_sym_LT] = ACTIONS(6017),
    [anon_sym_LT_EQ] = ACTIONS(6019),
    [anon_sym_GT] = ACTIONS(6017),
    [anon_sym_GT_EQ] = ACTIONS(6019),
    [anon_sym_EQ_EQ] = ACTIONS(6019),
    [anon_sym_BANG_EQ] = ACTIONS(6019),
    [anon_sym_STAR] = ACTIONS(6021),
    [anon_sym_SLASH] = ACTIONS(6023),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_CARET] = ACTIONS(6025),
    [aux_sym_binary_operator_token1] = ACTIONS(6027),
    [anon_sym_PIPE_GT] = ACTIONS(6027),
    [anon_sym_COLON] = ACTIONS(6029),
    [anon_sym_DOLLAR] = ACTIONS(6031),
    [anon_sym_AT] = ACTIONS(6031),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_else] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(6035),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(6037),
    [sym__external_close_bracket] = ACTIONS(5345),
    [sym__external_open_bracket2] = ACTIONS(6039),
  },
  [1651] = {
    [sym_call_arguments] = STATE(2853),
    [sym_subset_arguments] = STATE(2854),
    [sym_subset2_arguments] = STATE(2864),
    [sym__open_parenthesis] = STATE(1366),
    [sym__open_bracket] = STATE(1365),
    [sym__open_bracket2] = STATE(1364),
    [sym_identifier] = ACTIONS(5343),
    [anon_sym_BSLASH] = ACTIONS(5341),
    [anon_sym_function] = ACTIONS(5343),
    [anon_sym_EQ] = ACTIONS(5995),
    [anon_sym_if] = ACTIONS(5343),
    [anon_sym_for] = ACTIONS(5343),
    [anon_sym_while] = ACTIONS(5343),
    [anon_sym_repeat] = ACTIONS(5343),
    [anon_sym_QMARK] = ACTIONS(5341),
    [anon_sym_TILDE] = ACTIONS(5997),
    [anon_sym_BANG] = ACTIONS(5343),
    [anon_sym_PLUS] = ACTIONS(5999),
    [anon_sym_DASH] = ACTIONS(6001),
    [anon_sym_LT_DASH] = ACTIONS(6003),
    [anon_sym_LT_LT_DASH] = ACTIONS(6003),
    [anon_sym_COLON_EQ] = ACTIONS(6003),
    [anon_sym_DASH_GT] = ACTIONS(6005),
    [anon_sym_DASH_GT_GT] = ACTIONS(6007),
    [anon_sym_PIPE] = ACTIONS(6009),
    [anon_sym_AMP] = ACTIONS(6011),
    [anon_sym_PIPE_PIPE] = ACTIONS(6013),
    [anon_sym_AMP_AMP] = ACTIONS(6015),
    [anon_sym_LT] = ACTIONS(6017),
    [anon_sym_LT_EQ] = ACTIONS(6019),
    [anon_sym_GT] = ACTIONS(6017),
    [anon_sym_GT_EQ] = ACTIONS(6019),
    [anon_sym_EQ_EQ] = ACTIONS(6019),
    [anon_sym_BANG_EQ] = ACTIONS(6019),
    [anon_sym_STAR] = ACTIONS(6021),
    [anon_sym_SLASH] = ACTIONS(6023),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_CARET] = ACTIONS(6025),
    [aux_sym_binary_operator_token1] = ACTIONS(6027),
    [anon_sym_PIPE_GT] = ACTIONS(6027),
    [anon_sym_COLON] = ACTIONS(6029),
    [anon_sym_DOLLAR] = ACTIONS(6031),
    [anon_sym_AT] = ACTIONS(6031),
    [aux_sym__hex_literal_token1] = ACTIONS(5341),
    [sym__number_literal] = ACTIONS(5343),
    [anon_sym_SQUOTE] = ACTIONS(5341),
    [anon_sym_DQUOTE] = ACTIONS(5341),
    [sym_return] = ACTIONS(5343),
    [sym_next] = ACTIONS(5343),
    [sym_break] = ACTIONS(5343),
    [sym_true] = ACTIONS(5343),
    [sym_false] = ACTIONS(5343),
    [sym_null] = ACTIONS(5343),
    [sym_inf] = ACTIONS(5343),
    [sym_nan] = ACTIONS(5343),
    [anon_sym_NA] = ACTIONS(5343),
    [anon_sym_NA_integer_] = ACTIONS(5343),
    [anon_sym_NA_real_] = ACTIONS(5343),
    [anon_sym_NA_complex_] = ACTIONS(5343),
    [anon_sym_NA_character_] = ACTIONS(5343),
    [sym_dots] = ACTIONS(5343),
    [sym_dot_dot_i] = ACTIONS(5341),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5341),
    [sym__newline] = ACTIONS(5341),
    [sym__raw_string_literal] = ACTIONS(5341),
    [sym__external_else] = ACTIONS(5341),
    [sym__external_open_parenthesis] = ACTIONS(6035),
    [sym__external_open_brace] = ACTIONS(5341),
    [sym__external_open_bracket] = ACTIONS(6037),
    [sym__external_close_bracket] = ACTIONS(5341),
    [sym__external_open_bracket2] = ACTIONS(6039),
  },
  [1652] = {
    [sym_call_arguments] = STATE(2923),
    [sym_subset_arguments] = STATE(2922),
    [sym_subset2_arguments] = STATE(2906),
    [sym__open_parenthesis] = STATE(1528),
    [sym__open_bracket] = STATE(1525),
    [sym__open_bracket2] = STATE(1519),
    [ts_builtin_sym_end] = ACTIONS(5445),
    [sym_identifier] = ACTIONS(5447),
    [anon_sym_BSLASH] = ACTIONS(5445),
    [anon_sym_function] = ACTIONS(5447),
    [anon_sym_EQ] = ACTIONS(5947),
    [anon_sym_if] = ACTIONS(5447),
    [anon_sym_for] = ACTIONS(5447),
    [anon_sym_while] = ACTIONS(5447),
    [anon_sym_repeat] = ACTIONS(5447),
    [anon_sym_QMARK] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(5949),
    [anon_sym_BANG] = ACTIONS(5447),
    [anon_sym_PLUS] = ACTIONS(5951),
    [anon_sym_DASH] = ACTIONS(5953),
    [anon_sym_LT_DASH] = ACTIONS(5955),
    [anon_sym_LT_LT_DASH] = ACTIONS(5955),
    [anon_sym_COLON_EQ] = ACTIONS(5955),
    [anon_sym_DASH_GT] = ACTIONS(5957),
    [anon_sym_DASH_GT_GT] = ACTIONS(5959),
    [anon_sym_PIPE] = ACTIONS(5961),
    [anon_sym_AMP] = ACTIONS(5963),
    [anon_sym_PIPE_PIPE] = ACTIONS(5965),
    [anon_sym_AMP_AMP] = ACTIONS(5967),
    [anon_sym_LT] = ACTIONS(5969),
    [anon_sym_LT_EQ] = ACTIONS(5971),
    [anon_sym_GT] = ACTIONS(5969),
    [anon_sym_GT_EQ] = ACTIONS(5971),
    [anon_sym_EQ_EQ] = ACTIONS(5971),
    [anon_sym_BANG_EQ] = ACTIONS(5971),
    [anon_sym_STAR] = ACTIONS(5973),
    [anon_sym_SLASH] = ACTIONS(5975),
    [anon_sym_STAR_STAR] = ACTIONS(5977),
    [anon_sym_CARET] = ACTIONS(5977),
    [aux_sym_binary_operator_token1] = ACTIONS(5979),
    [anon_sym_PIPE_GT] = ACTIONS(5979),
    [anon_sym_COLON] = ACTIONS(5981),
    [anon_sym_DOLLAR] = ACTIONS(5983),
    [anon_sym_AT] = ACTIONS(5983),
    [aux_sym__hex_literal_token1] = ACTIONS(5445),
    [sym__number_literal] = ACTIONS(5447),
    [anon_sym_SQUOTE] = ACTIONS(5445),
    [anon_sym_DQUOTE] = ACTIONS(5445),
    [sym_return] = ACTIONS(5447),
    [sym_next] = ACTIONS(5447),
    [sym_break] = ACTIONS(5447),
    [sym_true] = ACTIONS(5447),
    [sym_false] = ACTIONS(5447),
    [sym_null] = ACTIONS(5447),
    [sym_inf] = ACTIONS(5447),
    [sym_nan] = ACTIONS(5447),
    [anon_sym_NA] = ACTIONS(5447),
    [anon_sym_NA_integer_] = ACTIONS(5447),
    [anon_sym_NA_real_] = ACTIONS(5447),
    [anon_sym_NA_complex_] = ACTIONS(5447),
    [anon_sym_NA_character_] = ACTIONS(5447),
    [sym_dots] = ACTIONS(5447),
    [sym_dot_dot_i] = ACTIONS(5445),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5445),
    [sym__semicolon] = ACTIONS(5445),
    [sym__raw_string_literal] = ACTIONS(5445),
    [sym__external_else] = ACTIONS(5445),
    [sym__external_open_parenthesis] = ACTIONS(5987),
    [sym__external_open_brace] = ACTIONS(5445),
    [sym__external_open_bracket] = ACTIONS(5989),
    [sym__external_open_bracket2] = ACTIONS(5991),
  },
  [1653] = {
    [sym_call_arguments] = STATE(2777),
    [sym_subset_arguments] = STATE(2779),
    [sym_subset2_arguments] = STATE(2786),
    [sym__open_parenthesis] = STATE(1411),
    [sym__open_bracket] = STATE(1409),
    [sym__open_bracket2] = STATE(1407),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(6491),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(6495),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(6497),
    [anon_sym_DASH] = ACTIONS(6499),
    [anon_sym_LT_DASH] = ACTIONS(6501),
    [anon_sym_LT_LT_DASH] = ACTIONS(6501),
    [anon_sym_COLON_EQ] = ACTIONS(6501),
    [anon_sym_DASH_GT] = ACTIONS(6503),
    [anon_sym_DASH_GT_GT] = ACTIONS(6505),
    [anon_sym_PIPE] = ACTIONS(6507),
    [anon_sym_AMP] = ACTIONS(6509),
    [anon_sym_PIPE_PIPE] = ACTIONS(6511),
    [anon_sym_AMP_AMP] = ACTIONS(6513),
    [anon_sym_LT] = ACTIONS(6515),
    [anon_sym_LT_EQ] = ACTIONS(6517),
    [anon_sym_GT] = ACTIONS(6515),
    [anon_sym_GT_EQ] = ACTIONS(6517),
    [anon_sym_EQ_EQ] = ACTIONS(6517),
    [anon_sym_BANG_EQ] = ACTIONS(6517),
    [anon_sym_STAR] = ACTIONS(6519),
    [anon_sym_SLASH] = ACTIONS(6521),
    [anon_sym_STAR_STAR] = ACTIONS(6523),
    [anon_sym_CARET] = ACTIONS(6523),
    [aux_sym_binary_operator_token1] = ACTIONS(6525),
    [anon_sym_PIPE_GT] = ACTIONS(6525),
    [anon_sym_COLON] = ACTIONS(6527),
    [anon_sym_DOLLAR] = ACTIONS(6529),
    [anon_sym_AT] = ACTIONS(6529),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6531),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6533),
    [sym__external_open_bracket2] = ACTIONS(6535),
  },
  [1654] = {
    [sym_call_arguments] = STATE(2853),
    [sym_subset_arguments] = STATE(2854),
    [sym_subset2_arguments] = STATE(2864),
    [sym__open_parenthesis] = STATE(1366),
    [sym__open_bracket] = STATE(1365),
    [sym__open_bracket2] = STATE(1364),
    [sym_identifier] = ACTIONS(5339),
    [anon_sym_BSLASH] = ACTIONS(5337),
    [anon_sym_function] = ACTIONS(5339),
    [anon_sym_EQ] = ACTIONS(5995),
    [anon_sym_if] = ACTIONS(5339),
    [anon_sym_for] = ACTIONS(5339),
    [anon_sym_while] = ACTIONS(5339),
    [anon_sym_repeat] = ACTIONS(5339),
    [anon_sym_QMARK] = ACTIONS(5337),
    [anon_sym_TILDE] = ACTIONS(5997),
    [anon_sym_BANG] = ACTIONS(5339),
    [anon_sym_PLUS] = ACTIONS(5999),
    [anon_sym_DASH] = ACTIONS(6001),
    [anon_sym_LT_DASH] = ACTIONS(6003),
    [anon_sym_LT_LT_DASH] = ACTIONS(6003),
    [anon_sym_COLON_EQ] = ACTIONS(6003),
    [anon_sym_DASH_GT] = ACTIONS(6005),
    [anon_sym_DASH_GT_GT] = ACTIONS(6007),
    [anon_sym_PIPE] = ACTIONS(6009),
    [anon_sym_AMP] = ACTIONS(6011),
    [anon_sym_PIPE_PIPE] = ACTIONS(6013),
    [anon_sym_AMP_AMP] = ACTIONS(6015),
    [anon_sym_LT] = ACTIONS(6017),
    [anon_sym_LT_EQ] = ACTIONS(6019),
    [anon_sym_GT] = ACTIONS(6017),
    [anon_sym_GT_EQ] = ACTIONS(6019),
    [anon_sym_EQ_EQ] = ACTIONS(6019),
    [anon_sym_BANG_EQ] = ACTIONS(6019),
    [anon_sym_STAR] = ACTIONS(6021),
    [anon_sym_SLASH] = ACTIONS(6023),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_CARET] = ACTIONS(6025),
    [aux_sym_binary_operator_token1] = ACTIONS(6027),
    [anon_sym_PIPE_GT] = ACTIONS(6027),
    [anon_sym_COLON] = ACTIONS(6029),
    [anon_sym_DOLLAR] = ACTIONS(6031),
    [anon_sym_AT] = ACTIONS(6031),
    [aux_sym__hex_literal_token1] = ACTIONS(5337),
    [sym__number_literal] = ACTIONS(5339),
    [anon_sym_SQUOTE] = ACTIONS(5337),
    [anon_sym_DQUOTE] = ACTIONS(5337),
    [sym_return] = ACTIONS(5339),
    [sym_next] = ACTIONS(5339),
    [sym_break] = ACTIONS(5339),
    [sym_true] = ACTIONS(5339),
    [sym_false] = ACTIONS(5339),
    [sym_null] = ACTIONS(5339),
    [sym_inf] = ACTIONS(5339),
    [sym_nan] = ACTIONS(5339),
    [anon_sym_NA] = ACTIONS(5339),
    [anon_sym_NA_integer_] = ACTIONS(5339),
    [anon_sym_NA_real_] = ACTIONS(5339),
    [anon_sym_NA_complex_] = ACTIONS(5339),
    [anon_sym_NA_character_] = ACTIONS(5339),
    [sym_dots] = ACTIONS(5339),
    [sym_dot_dot_i] = ACTIONS(5337),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5337),
    [sym__newline] = ACTIONS(5337),
    [sym__raw_string_literal] = ACTIONS(5337),
    [sym__external_else] = ACTIONS(5337),
    [sym__external_open_parenthesis] = ACTIONS(6035),
    [sym__external_open_brace] = ACTIONS(5337),
    [sym__external_open_bracket] = ACTIONS(6037),
    [sym__external_close_bracket] = ACTIONS(5337),
    [sym__external_open_bracket2] = ACTIONS(6039),
  },
  [1655] = {
    [sym_call_arguments] = STATE(2923),
    [sym_subset_arguments] = STATE(2922),
    [sym_subset2_arguments] = STATE(2906),
    [sym__open_parenthesis] = STATE(1528),
    [sym__open_bracket] = STATE(1525),
    [sym__open_bracket2] = STATE(1519),
    [ts_builtin_sym_end] = ACTIONS(5441),
    [sym_identifier] = ACTIONS(5443),
    [anon_sym_BSLASH] = ACTIONS(5441),
    [anon_sym_function] = ACTIONS(5443),
    [anon_sym_EQ] = ACTIONS(5947),
    [anon_sym_if] = ACTIONS(5443),
    [anon_sym_for] = ACTIONS(5443),
    [anon_sym_while] = ACTIONS(5443),
    [anon_sym_repeat] = ACTIONS(5443),
    [anon_sym_QMARK] = ACTIONS(5441),
    [anon_sym_TILDE] = ACTIONS(5949),
    [anon_sym_BANG] = ACTIONS(5443),
    [anon_sym_PLUS] = ACTIONS(5951),
    [anon_sym_DASH] = ACTIONS(5953),
    [anon_sym_LT_DASH] = ACTIONS(5955),
    [anon_sym_LT_LT_DASH] = ACTIONS(5955),
    [anon_sym_COLON_EQ] = ACTIONS(5955),
    [anon_sym_DASH_GT] = ACTIONS(5957),
    [anon_sym_DASH_GT_GT] = ACTIONS(5959),
    [anon_sym_PIPE] = ACTIONS(5961),
    [anon_sym_AMP] = ACTIONS(5963),
    [anon_sym_PIPE_PIPE] = ACTIONS(5965),
    [anon_sym_AMP_AMP] = ACTIONS(5967),
    [anon_sym_LT] = ACTIONS(5969),
    [anon_sym_LT_EQ] = ACTIONS(5971),
    [anon_sym_GT] = ACTIONS(5969),
    [anon_sym_GT_EQ] = ACTIONS(5971),
    [anon_sym_EQ_EQ] = ACTIONS(5971),
    [anon_sym_BANG_EQ] = ACTIONS(5971),
    [anon_sym_STAR] = ACTIONS(5973),
    [anon_sym_SLASH] = ACTIONS(5975),
    [anon_sym_STAR_STAR] = ACTIONS(5977),
    [anon_sym_CARET] = ACTIONS(5977),
    [aux_sym_binary_operator_token1] = ACTIONS(5979),
    [anon_sym_PIPE_GT] = ACTIONS(5979),
    [anon_sym_COLON] = ACTIONS(5981),
    [anon_sym_DOLLAR] = ACTIONS(5983),
    [anon_sym_AT] = ACTIONS(5983),
    [aux_sym__hex_literal_token1] = ACTIONS(5441),
    [sym__number_literal] = ACTIONS(5443),
    [anon_sym_SQUOTE] = ACTIONS(5441),
    [anon_sym_DQUOTE] = ACTIONS(5441),
    [sym_return] = ACTIONS(5443),
    [sym_next] = ACTIONS(5443),
    [sym_break] = ACTIONS(5443),
    [sym_true] = ACTIONS(5443),
    [sym_false] = ACTIONS(5443),
    [sym_null] = ACTIONS(5443),
    [sym_inf] = ACTIONS(5443),
    [sym_nan] = ACTIONS(5443),
    [anon_sym_NA] = ACTIONS(5443),
    [anon_sym_NA_integer_] = ACTIONS(5443),
    [anon_sym_NA_real_] = ACTIONS(5443),
    [anon_sym_NA_complex_] = ACTIONS(5443),
    [anon_sym_NA_character_] = ACTIONS(5443),
    [sym_dots] = ACTIONS(5443),
    [sym_dot_dot_i] = ACTIONS(5441),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5441),
    [sym__semicolon] = ACTIONS(5441),
    [sym__raw_string_literal] = ACTIONS(5441),
    [sym__external_else] = ACTIONS(5441),
    [sym__external_open_parenthesis] = ACTIONS(5987),
    [sym__external_open_brace] = ACTIONS(5441),
    [sym__external_open_bracket] = ACTIONS(5989),
    [sym__external_open_bracket2] = ACTIONS(5991),
  },
  [1656] = {
    [sym_call_arguments] = STATE(2923),
    [sym_subset_arguments] = STATE(2922),
    [sym_subset2_arguments] = STATE(2906),
    [sym__open_parenthesis] = STATE(1528),
    [sym__open_bracket] = STATE(1525),
    [sym__open_bracket2] = STATE(1519),
    [ts_builtin_sym_end] = ACTIONS(5437),
    [sym_identifier] = ACTIONS(5439),
    [anon_sym_BSLASH] = ACTIONS(5437),
    [anon_sym_function] = ACTIONS(5439),
    [anon_sym_EQ] = ACTIONS(5947),
    [anon_sym_if] = ACTIONS(5439),
    [anon_sym_for] = ACTIONS(5439),
    [anon_sym_while] = ACTIONS(5439),
    [anon_sym_repeat] = ACTIONS(5439),
    [anon_sym_QMARK] = ACTIONS(5437),
    [anon_sym_TILDE] = ACTIONS(5949),
    [anon_sym_BANG] = ACTIONS(5439),
    [anon_sym_PLUS] = ACTIONS(5951),
    [anon_sym_DASH] = ACTIONS(5953),
    [anon_sym_LT_DASH] = ACTIONS(5955),
    [anon_sym_LT_LT_DASH] = ACTIONS(5955),
    [anon_sym_COLON_EQ] = ACTIONS(5955),
    [anon_sym_DASH_GT] = ACTIONS(5957),
    [anon_sym_DASH_GT_GT] = ACTIONS(5959),
    [anon_sym_PIPE] = ACTIONS(5961),
    [anon_sym_AMP] = ACTIONS(5963),
    [anon_sym_PIPE_PIPE] = ACTIONS(5965),
    [anon_sym_AMP_AMP] = ACTIONS(5967),
    [anon_sym_LT] = ACTIONS(5969),
    [anon_sym_LT_EQ] = ACTIONS(5971),
    [anon_sym_GT] = ACTIONS(5969),
    [anon_sym_GT_EQ] = ACTIONS(5971),
    [anon_sym_EQ_EQ] = ACTIONS(5971),
    [anon_sym_BANG_EQ] = ACTIONS(5971),
    [anon_sym_STAR] = ACTIONS(5973),
    [anon_sym_SLASH] = ACTIONS(5975),
    [anon_sym_STAR_STAR] = ACTIONS(5977),
    [anon_sym_CARET] = ACTIONS(5977),
    [aux_sym_binary_operator_token1] = ACTIONS(5979),
    [anon_sym_PIPE_GT] = ACTIONS(5979),
    [anon_sym_COLON] = ACTIONS(5981),
    [anon_sym_DOLLAR] = ACTIONS(5983),
    [anon_sym_AT] = ACTIONS(5983),
    [aux_sym__hex_literal_token1] = ACTIONS(5437),
    [sym__number_literal] = ACTIONS(5439),
    [anon_sym_SQUOTE] = ACTIONS(5437),
    [anon_sym_DQUOTE] = ACTIONS(5437),
    [sym_return] = ACTIONS(5439),
    [sym_next] = ACTIONS(5439),
    [sym_break] = ACTIONS(5439),
    [sym_true] = ACTIONS(5439),
    [sym_false] = ACTIONS(5439),
    [sym_null] = ACTIONS(5439),
    [sym_inf] = ACTIONS(5439),
    [sym_nan] = ACTIONS(5439),
    [anon_sym_NA] = ACTIONS(5439),
    [anon_sym_NA_integer_] = ACTIONS(5439),
    [anon_sym_NA_real_] = ACTIONS(5439),
    [anon_sym_NA_complex_] = ACTIONS(5439),
    [anon_sym_NA_character_] = ACTIONS(5439),
    [sym_dots] = ACTIONS(5439),
    [sym_dot_dot_i] = ACTIONS(5437),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5437),
    [sym__semicolon] = ACTIONS(5437),
    [sym__raw_string_literal] = ACTIONS(5437),
    [sym__external_else] = ACTIONS(5437),
    [sym__external_open_parenthesis] = ACTIONS(5987),
    [sym__external_open_brace] = ACTIONS(5437),
    [sym__external_open_bracket] = ACTIONS(5989),
    [sym__external_open_bracket2] = ACTIONS(5991),
  },
  [1657] = {
    [sym_call_arguments] = STATE(2853),
    [sym_subset_arguments] = STATE(2854),
    [sym_subset2_arguments] = STATE(2864),
    [sym__open_parenthesis] = STATE(1366),
    [sym__open_bracket] = STATE(1365),
    [sym__open_bracket2] = STATE(1364),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(5333),
    [anon_sym_DASH] = ACTIONS(5335),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5335),
    [anon_sym_AMP] = ACTIONS(5335),
    [anon_sym_PIPE_PIPE] = ACTIONS(5333),
    [anon_sym_AMP_AMP] = ACTIONS(5333),
    [anon_sym_LT] = ACTIONS(5335),
    [anon_sym_LT_EQ] = ACTIONS(5333),
    [anon_sym_GT] = ACTIONS(5335),
    [anon_sym_GT_EQ] = ACTIONS(5333),
    [anon_sym_EQ_EQ] = ACTIONS(5333),
    [anon_sym_BANG_EQ] = ACTIONS(5333),
    [anon_sym_STAR] = ACTIONS(5335),
    [anon_sym_SLASH] = ACTIONS(5333),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_CARET] = ACTIONS(6025),
    [aux_sym_binary_operator_token1] = ACTIONS(5333),
    [anon_sym_PIPE_GT] = ACTIONS(5333),
    [anon_sym_COLON] = ACTIONS(5335),
    [anon_sym_DOLLAR] = ACTIONS(6031),
    [anon_sym_AT] = ACTIONS(6031),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_else] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(6035),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(6037),
    [sym__external_close_bracket] = ACTIONS(5333),
    [sym__external_open_bracket2] = ACTIONS(6039),
  },
  [1658] = {
    [sym_call_arguments] = STATE(2853),
    [sym_subset_arguments] = STATE(2854),
    [sym_subset2_arguments] = STATE(2864),
    [sym__open_parenthesis] = STATE(1366),
    [sym__open_bracket] = STATE(1365),
    [sym__open_bracket2] = STATE(1364),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(5999),
    [anon_sym_DASH] = ACTIONS(6001),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5335),
    [anon_sym_AMP] = ACTIONS(5335),
    [anon_sym_PIPE_PIPE] = ACTIONS(5333),
    [anon_sym_AMP_AMP] = ACTIONS(5333),
    [anon_sym_LT] = ACTIONS(6017),
    [anon_sym_LT_EQ] = ACTIONS(6019),
    [anon_sym_GT] = ACTIONS(6017),
    [anon_sym_GT_EQ] = ACTIONS(6019),
    [anon_sym_EQ_EQ] = ACTIONS(6019),
    [anon_sym_BANG_EQ] = ACTIONS(6019),
    [anon_sym_STAR] = ACTIONS(6021),
    [anon_sym_SLASH] = ACTIONS(6023),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_CARET] = ACTIONS(6025),
    [aux_sym_binary_operator_token1] = ACTIONS(6027),
    [anon_sym_PIPE_GT] = ACTIONS(6027),
    [anon_sym_COLON] = ACTIONS(6029),
    [anon_sym_DOLLAR] = ACTIONS(6031),
    [anon_sym_AT] = ACTIONS(6031),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_else] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(6035),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(6037),
    [sym__external_close_bracket] = ACTIONS(5333),
    [sym__external_open_bracket2] = ACTIONS(6039),
  },
  [1659] = {
    [sym_call_arguments] = STATE(2853),
    [sym_subset_arguments] = STATE(2854),
    [sym_subset2_arguments] = STATE(2864),
    [sym__open_parenthesis] = STATE(1366),
    [sym__open_bracket] = STATE(1365),
    [sym__open_bracket2] = STATE(1364),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(5999),
    [anon_sym_DASH] = ACTIONS(6001),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(6009),
    [anon_sym_AMP] = ACTIONS(6011),
    [anon_sym_PIPE_PIPE] = ACTIONS(6013),
    [anon_sym_AMP_AMP] = ACTIONS(6015),
    [anon_sym_LT] = ACTIONS(6017),
    [anon_sym_LT_EQ] = ACTIONS(6019),
    [anon_sym_GT] = ACTIONS(6017),
    [anon_sym_GT_EQ] = ACTIONS(6019),
    [anon_sym_EQ_EQ] = ACTIONS(6019),
    [anon_sym_BANG_EQ] = ACTIONS(6019),
    [anon_sym_STAR] = ACTIONS(6021),
    [anon_sym_SLASH] = ACTIONS(6023),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_CARET] = ACTIONS(6025),
    [aux_sym_binary_operator_token1] = ACTIONS(6027),
    [anon_sym_PIPE_GT] = ACTIONS(6027),
    [anon_sym_COLON] = ACTIONS(6029),
    [anon_sym_DOLLAR] = ACTIONS(6031),
    [anon_sym_AT] = ACTIONS(6031),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_else] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(6035),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(6037),
    [sym__external_close_bracket] = ACTIONS(5333),
    [sym__external_open_bracket2] = ACTIONS(6039),
  },
  [1660] = {
    [sym_call_arguments] = STATE(2853),
    [sym_subset_arguments] = STATE(2854),
    [sym_subset2_arguments] = STATE(2864),
    [sym__open_parenthesis] = STATE(1366),
    [sym__open_bracket] = STATE(1365),
    [sym__open_bracket2] = STATE(1364),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5995),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5997),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(5999),
    [anon_sym_DASH] = ACTIONS(6001),
    [anon_sym_LT_DASH] = ACTIONS(6003),
    [anon_sym_LT_LT_DASH] = ACTIONS(6003),
    [anon_sym_COLON_EQ] = ACTIONS(6003),
    [anon_sym_DASH_GT] = ACTIONS(6005),
    [anon_sym_DASH_GT_GT] = ACTIONS(6007),
    [anon_sym_PIPE] = ACTIONS(6009),
    [anon_sym_AMP] = ACTIONS(6011),
    [anon_sym_PIPE_PIPE] = ACTIONS(6013),
    [anon_sym_AMP_AMP] = ACTIONS(6015),
    [anon_sym_LT] = ACTIONS(6017),
    [anon_sym_LT_EQ] = ACTIONS(6019),
    [anon_sym_GT] = ACTIONS(6017),
    [anon_sym_GT_EQ] = ACTIONS(6019),
    [anon_sym_EQ_EQ] = ACTIONS(6019),
    [anon_sym_BANG_EQ] = ACTIONS(6019),
    [anon_sym_STAR] = ACTIONS(6021),
    [anon_sym_SLASH] = ACTIONS(6023),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_CARET] = ACTIONS(6025),
    [aux_sym_binary_operator_token1] = ACTIONS(6027),
    [anon_sym_PIPE_GT] = ACTIONS(6027),
    [anon_sym_COLON] = ACTIONS(6029),
    [anon_sym_DOLLAR] = ACTIONS(6031),
    [anon_sym_AT] = ACTIONS(6031),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_else] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(6035),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(6037),
    [sym__external_close_bracket] = ACTIONS(5333),
    [sym__external_open_bracket2] = ACTIONS(6039),
  },
  [1661] = {
    [sym_call_arguments] = STATE(2777),
    [sym_subset_arguments] = STATE(2779),
    [sym_subset2_arguments] = STATE(2786),
    [sym__open_parenthesis] = STATE(1411),
    [sym__open_bracket] = STATE(1409),
    [sym__open_bracket2] = STATE(1407),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(6497),
    [anon_sym_DASH] = ACTIONS(6499),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(6507),
    [anon_sym_AMP] = ACTIONS(6509),
    [anon_sym_PIPE_PIPE] = ACTIONS(6511),
    [anon_sym_AMP_AMP] = ACTIONS(6513),
    [anon_sym_LT] = ACTIONS(6515),
    [anon_sym_LT_EQ] = ACTIONS(6517),
    [anon_sym_GT] = ACTIONS(6515),
    [anon_sym_GT_EQ] = ACTIONS(6517),
    [anon_sym_EQ_EQ] = ACTIONS(6517),
    [anon_sym_BANG_EQ] = ACTIONS(6517),
    [anon_sym_STAR] = ACTIONS(6519),
    [anon_sym_SLASH] = ACTIONS(6521),
    [anon_sym_STAR_STAR] = ACTIONS(6523),
    [anon_sym_CARET] = ACTIONS(6523),
    [aux_sym_binary_operator_token1] = ACTIONS(6525),
    [anon_sym_PIPE_GT] = ACTIONS(6525),
    [anon_sym_COLON] = ACTIONS(6527),
    [anon_sym_DOLLAR] = ACTIONS(6529),
    [anon_sym_AT] = ACTIONS(6529),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6531),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6533),
    [sym__external_open_bracket2] = ACTIONS(6535),
  },
  [1662] = {
    [sym_call_arguments] = STATE(2853),
    [sym_subset_arguments] = STATE(2854),
    [sym_subset2_arguments] = STATE(2864),
    [sym__open_parenthesis] = STATE(1366),
    [sym__open_bracket] = STATE(1365),
    [sym__open_bracket2] = STATE(1364),
    [sym_identifier] = ACTIONS(5331),
    [anon_sym_BSLASH] = ACTIONS(5329),
    [anon_sym_function] = ACTIONS(5331),
    [anon_sym_EQ] = ACTIONS(5995),
    [anon_sym_if] = ACTIONS(5331),
    [anon_sym_for] = ACTIONS(5331),
    [anon_sym_while] = ACTIONS(5331),
    [anon_sym_repeat] = ACTIONS(5331),
    [anon_sym_QMARK] = ACTIONS(5329),
    [anon_sym_TILDE] = ACTIONS(5997),
    [anon_sym_BANG] = ACTIONS(5331),
    [anon_sym_PLUS] = ACTIONS(5999),
    [anon_sym_DASH] = ACTIONS(6001),
    [anon_sym_LT_DASH] = ACTIONS(6003),
    [anon_sym_LT_LT_DASH] = ACTIONS(6003),
    [anon_sym_COLON_EQ] = ACTIONS(6003),
    [anon_sym_DASH_GT] = ACTIONS(6005),
    [anon_sym_DASH_GT_GT] = ACTIONS(6007),
    [anon_sym_PIPE] = ACTIONS(6009),
    [anon_sym_AMP] = ACTIONS(6011),
    [anon_sym_PIPE_PIPE] = ACTIONS(6013),
    [anon_sym_AMP_AMP] = ACTIONS(6015),
    [anon_sym_LT] = ACTIONS(6017),
    [anon_sym_LT_EQ] = ACTIONS(6019),
    [anon_sym_GT] = ACTIONS(6017),
    [anon_sym_GT_EQ] = ACTIONS(6019),
    [anon_sym_EQ_EQ] = ACTIONS(6019),
    [anon_sym_BANG_EQ] = ACTIONS(6019),
    [anon_sym_STAR] = ACTIONS(6021),
    [anon_sym_SLASH] = ACTIONS(6023),
    [anon_sym_STAR_STAR] = ACTIONS(6025),
    [anon_sym_CARET] = ACTIONS(6025),
    [aux_sym_binary_operator_token1] = ACTIONS(6027),
    [anon_sym_PIPE_GT] = ACTIONS(6027),
    [anon_sym_COLON] = ACTIONS(6029),
    [anon_sym_DOLLAR] = ACTIONS(6031),
    [anon_sym_AT] = ACTIONS(6031),
    [aux_sym__hex_literal_token1] = ACTIONS(5329),
    [sym__number_literal] = ACTIONS(5331),
    [anon_sym_SQUOTE] = ACTIONS(5329),
    [anon_sym_DQUOTE] = ACTIONS(5329),
    [sym_return] = ACTIONS(5331),
    [sym_next] = ACTIONS(5331),
    [sym_break] = ACTIONS(5331),
    [sym_true] = ACTIONS(5331),
    [sym_false] = ACTIONS(5331),
    [sym_null] = ACTIONS(5331),
    [sym_inf] = ACTIONS(5331),
    [sym_nan] = ACTIONS(5331),
    [anon_sym_NA] = ACTIONS(5331),
    [anon_sym_NA_integer_] = ACTIONS(5331),
    [anon_sym_NA_real_] = ACTIONS(5331),
    [anon_sym_NA_complex_] = ACTIONS(5331),
    [anon_sym_NA_character_] = ACTIONS(5331),
    [sym_dots] = ACTIONS(5331),
    [sym_dot_dot_i] = ACTIONS(5329),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5329),
    [sym__newline] = ACTIONS(5329),
    [sym__raw_string_literal] = ACTIONS(5329),
    [sym__external_else] = ACTIONS(5329),
    [sym__external_open_parenthesis] = ACTIONS(6035),
    [sym__external_open_brace] = ACTIONS(5329),
    [sym__external_open_bracket] = ACTIONS(6037),
    [sym__external_close_bracket] = ACTIONS(5329),
    [sym__external_open_bracket2] = ACTIONS(6039),
  },
  [1663] = {
    [sym_call_arguments] = STATE(2777),
    [sym_subset_arguments] = STATE(2779),
    [sym_subset2_arguments] = STATE(2786),
    [sym__open_parenthesis] = STATE(1411),
    [sym__open_bracket] = STATE(1409),
    [sym__open_bracket2] = STATE(1407),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(6519),
    [anon_sym_SLASH] = ACTIONS(6521),
    [anon_sym_STAR_STAR] = ACTIONS(6523),
    [anon_sym_CARET] = ACTIONS(6523),
    [aux_sym_binary_operator_token1] = ACTIONS(6525),
    [anon_sym_PIPE_GT] = ACTIONS(6525),
    [anon_sym_COLON] = ACTIONS(6527),
    [anon_sym_DOLLAR] = ACTIONS(6529),
    [anon_sym_AT] = ACTIONS(6529),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6531),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6533),
    [sym__external_open_bracket2] = ACTIONS(6535),
  },
  [1664] = {
    [sym_call_arguments] = STATE(2845),
    [sym_subset_arguments] = STATE(2849),
    [sym_subset2_arguments] = STATE(2852),
    [sym__open_parenthesis] = STATE(1372),
    [sym__open_bracket] = STATE(1371),
    [sym__open_bracket2] = STATE(1370),
    [sym_identifier] = ACTIONS(5411),
    [anon_sym_BSLASH] = ACTIONS(5409),
    [anon_sym_function] = ACTIONS(5411),
    [anon_sym_EQ] = ACTIONS(6181),
    [anon_sym_if] = ACTIONS(5411),
    [anon_sym_for] = ACTIONS(5411),
    [anon_sym_while] = ACTIONS(5411),
    [anon_sym_repeat] = ACTIONS(5411),
    [anon_sym_QMARK] = ACTIONS(5409),
    [anon_sym_TILDE] = ACTIONS(6183),
    [anon_sym_BANG] = ACTIONS(5411),
    [anon_sym_PLUS] = ACTIONS(6185),
    [anon_sym_DASH] = ACTIONS(6187),
    [anon_sym_LT_DASH] = ACTIONS(6189),
    [anon_sym_LT_LT_DASH] = ACTIONS(6189),
    [anon_sym_COLON_EQ] = ACTIONS(6189),
    [anon_sym_DASH_GT] = ACTIONS(6191),
    [anon_sym_DASH_GT_GT] = ACTIONS(6193),
    [anon_sym_PIPE] = ACTIONS(6195),
    [anon_sym_AMP] = ACTIONS(6197),
    [anon_sym_PIPE_PIPE] = ACTIONS(6199),
    [anon_sym_AMP_AMP] = ACTIONS(6201),
    [anon_sym_LT] = ACTIONS(6203),
    [anon_sym_LT_EQ] = ACTIONS(6205),
    [anon_sym_GT] = ACTIONS(6203),
    [anon_sym_GT_EQ] = ACTIONS(6205),
    [anon_sym_EQ_EQ] = ACTIONS(6205),
    [anon_sym_BANG_EQ] = ACTIONS(6205),
    [anon_sym_STAR] = ACTIONS(6207),
    [anon_sym_SLASH] = ACTIONS(6209),
    [anon_sym_STAR_STAR] = ACTIONS(6211),
    [anon_sym_CARET] = ACTIONS(6211),
    [aux_sym_binary_operator_token1] = ACTIONS(6213),
    [anon_sym_PIPE_GT] = ACTIONS(6213),
    [anon_sym_COLON] = ACTIONS(6215),
    [anon_sym_DOLLAR] = ACTIONS(6217),
    [anon_sym_AT] = ACTIONS(6217),
    [aux_sym__hex_literal_token1] = ACTIONS(5409),
    [sym__number_literal] = ACTIONS(5411),
    [anon_sym_SQUOTE] = ACTIONS(5409),
    [anon_sym_DQUOTE] = ACTIONS(5409),
    [sym_return] = ACTIONS(5411),
    [sym_next] = ACTIONS(5411),
    [sym_break] = ACTIONS(5411),
    [sym_true] = ACTIONS(5411),
    [sym_false] = ACTIONS(5411),
    [sym_null] = ACTIONS(5411),
    [sym_inf] = ACTIONS(5411),
    [sym_nan] = ACTIONS(5411),
    [anon_sym_NA] = ACTIONS(5411),
    [anon_sym_NA_integer_] = ACTIONS(5411),
    [anon_sym_NA_real_] = ACTIONS(5411),
    [anon_sym_NA_complex_] = ACTIONS(5411),
    [anon_sym_NA_character_] = ACTIONS(5411),
    [sym_dots] = ACTIONS(5411),
    [sym_dot_dot_i] = ACTIONS(5409),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5409),
    [sym__newline] = ACTIONS(5409),
    [sym__raw_string_literal] = ACTIONS(5409),
    [sym__external_else] = ACTIONS(5409),
    [sym__external_open_parenthesis] = ACTIONS(6221),
    [sym__external_close_parenthesis] = ACTIONS(5409),
    [sym__external_open_brace] = ACTIONS(5409),
    [sym__external_open_bracket] = ACTIONS(6223),
    [sym__external_open_bracket2] = ACTIONS(6225),
  },
  [1665] = {
    [sym_call_arguments] = STATE(2845),
    [sym_subset_arguments] = STATE(2849),
    [sym_subset2_arguments] = STATE(2852),
    [sym__open_parenthesis] = STATE(1372),
    [sym__open_bracket] = STATE(1371),
    [sym__open_bracket2] = STATE(1370),
    [sym_identifier] = ACTIONS(5455),
    [anon_sym_BSLASH] = ACTIONS(5453),
    [anon_sym_function] = ACTIONS(5455),
    [anon_sym_EQ] = ACTIONS(6181),
    [anon_sym_if] = ACTIONS(5455),
    [anon_sym_for] = ACTIONS(5455),
    [anon_sym_while] = ACTIONS(5455),
    [anon_sym_repeat] = ACTIONS(5455),
    [anon_sym_QMARK] = ACTIONS(5453),
    [anon_sym_TILDE] = ACTIONS(6183),
    [anon_sym_BANG] = ACTIONS(5455),
    [anon_sym_PLUS] = ACTIONS(6185),
    [anon_sym_DASH] = ACTIONS(6187),
    [anon_sym_LT_DASH] = ACTIONS(6189),
    [anon_sym_LT_LT_DASH] = ACTIONS(6189),
    [anon_sym_COLON_EQ] = ACTIONS(6189),
    [anon_sym_DASH_GT] = ACTIONS(6191),
    [anon_sym_DASH_GT_GT] = ACTIONS(6193),
    [anon_sym_PIPE] = ACTIONS(6195),
    [anon_sym_AMP] = ACTIONS(6197),
    [anon_sym_PIPE_PIPE] = ACTIONS(6199),
    [anon_sym_AMP_AMP] = ACTIONS(6201),
    [anon_sym_LT] = ACTIONS(6203),
    [anon_sym_LT_EQ] = ACTIONS(6205),
    [anon_sym_GT] = ACTIONS(6203),
    [anon_sym_GT_EQ] = ACTIONS(6205),
    [anon_sym_EQ_EQ] = ACTIONS(6205),
    [anon_sym_BANG_EQ] = ACTIONS(6205),
    [anon_sym_STAR] = ACTIONS(6207),
    [anon_sym_SLASH] = ACTIONS(6209),
    [anon_sym_STAR_STAR] = ACTIONS(6211),
    [anon_sym_CARET] = ACTIONS(6211),
    [aux_sym_binary_operator_token1] = ACTIONS(6213),
    [anon_sym_PIPE_GT] = ACTIONS(6213),
    [anon_sym_COLON] = ACTIONS(6215),
    [anon_sym_DOLLAR] = ACTIONS(6217),
    [anon_sym_AT] = ACTIONS(6217),
    [aux_sym__hex_literal_token1] = ACTIONS(5453),
    [sym__number_literal] = ACTIONS(5455),
    [anon_sym_SQUOTE] = ACTIONS(5453),
    [anon_sym_DQUOTE] = ACTIONS(5453),
    [sym_return] = ACTIONS(5455),
    [sym_next] = ACTIONS(5455),
    [sym_break] = ACTIONS(5455),
    [sym_true] = ACTIONS(5455),
    [sym_false] = ACTIONS(5455),
    [sym_null] = ACTIONS(5455),
    [sym_inf] = ACTIONS(5455),
    [sym_nan] = ACTIONS(5455),
    [anon_sym_NA] = ACTIONS(5455),
    [anon_sym_NA_integer_] = ACTIONS(5455),
    [anon_sym_NA_real_] = ACTIONS(5455),
    [anon_sym_NA_complex_] = ACTIONS(5455),
    [anon_sym_NA_character_] = ACTIONS(5455),
    [sym_dots] = ACTIONS(5455),
    [sym_dot_dot_i] = ACTIONS(5453),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5453),
    [sym__newline] = ACTIONS(5453),
    [sym__raw_string_literal] = ACTIONS(5453),
    [sym__external_else] = ACTIONS(5453),
    [sym__external_open_parenthesis] = ACTIONS(6221),
    [sym__external_close_parenthesis] = ACTIONS(5453),
    [sym__external_open_brace] = ACTIONS(5453),
    [sym__external_open_bracket] = ACTIONS(6223),
    [sym__external_open_bracket2] = ACTIONS(6225),
  },
  [1666] = {
    [sym_call_arguments] = STATE(2923),
    [sym_subset_arguments] = STATE(2922),
    [sym_subset2_arguments] = STATE(2906),
    [sym__open_parenthesis] = STATE(1528),
    [sym__open_bracket] = STATE(1525),
    [sym__open_bracket2] = STATE(1519),
    [ts_builtin_sym_end] = ACTIONS(5433),
    [sym_identifier] = ACTIONS(5435),
    [anon_sym_BSLASH] = ACTIONS(5433),
    [anon_sym_function] = ACTIONS(5435),
    [anon_sym_EQ] = ACTIONS(5947),
    [anon_sym_if] = ACTIONS(5435),
    [anon_sym_for] = ACTIONS(5435),
    [anon_sym_while] = ACTIONS(5435),
    [anon_sym_repeat] = ACTIONS(5435),
    [anon_sym_QMARK] = ACTIONS(5433),
    [anon_sym_TILDE] = ACTIONS(5949),
    [anon_sym_BANG] = ACTIONS(5435),
    [anon_sym_PLUS] = ACTIONS(5951),
    [anon_sym_DASH] = ACTIONS(5953),
    [anon_sym_LT_DASH] = ACTIONS(5955),
    [anon_sym_LT_LT_DASH] = ACTIONS(5955),
    [anon_sym_COLON_EQ] = ACTIONS(5955),
    [anon_sym_DASH_GT] = ACTIONS(5957),
    [anon_sym_DASH_GT_GT] = ACTIONS(5959),
    [anon_sym_PIPE] = ACTIONS(5961),
    [anon_sym_AMP] = ACTIONS(5963),
    [anon_sym_PIPE_PIPE] = ACTIONS(5965),
    [anon_sym_AMP_AMP] = ACTIONS(5967),
    [anon_sym_LT] = ACTIONS(5969),
    [anon_sym_LT_EQ] = ACTIONS(5971),
    [anon_sym_GT] = ACTIONS(5969),
    [anon_sym_GT_EQ] = ACTIONS(5971),
    [anon_sym_EQ_EQ] = ACTIONS(5971),
    [anon_sym_BANG_EQ] = ACTIONS(5971),
    [anon_sym_STAR] = ACTIONS(5973),
    [anon_sym_SLASH] = ACTIONS(5975),
    [anon_sym_STAR_STAR] = ACTIONS(5977),
    [anon_sym_CARET] = ACTIONS(5977),
    [aux_sym_binary_operator_token1] = ACTIONS(5979),
    [anon_sym_PIPE_GT] = ACTIONS(5979),
    [anon_sym_COLON] = ACTIONS(5981),
    [anon_sym_DOLLAR] = ACTIONS(5983),
    [anon_sym_AT] = ACTIONS(5983),
    [aux_sym__hex_literal_token1] = ACTIONS(5433),
    [sym__number_literal] = ACTIONS(5435),
    [anon_sym_SQUOTE] = ACTIONS(5433),
    [anon_sym_DQUOTE] = ACTIONS(5433),
    [sym_return] = ACTIONS(5435),
    [sym_next] = ACTIONS(5435),
    [sym_break] = ACTIONS(5435),
    [sym_true] = ACTIONS(5435),
    [sym_false] = ACTIONS(5435),
    [sym_null] = ACTIONS(5435),
    [sym_inf] = ACTIONS(5435),
    [sym_nan] = ACTIONS(5435),
    [anon_sym_NA] = ACTIONS(5435),
    [anon_sym_NA_integer_] = ACTIONS(5435),
    [anon_sym_NA_real_] = ACTIONS(5435),
    [anon_sym_NA_complex_] = ACTIONS(5435),
    [anon_sym_NA_character_] = ACTIONS(5435),
    [sym_dots] = ACTIONS(5435),
    [sym_dot_dot_i] = ACTIONS(5433),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5433),
    [sym__semicolon] = ACTIONS(5433),
    [sym__raw_string_literal] = ACTIONS(5433),
    [sym__external_else] = ACTIONS(5433),
    [sym__external_open_parenthesis] = ACTIONS(5987),
    [sym__external_open_brace] = ACTIONS(5433),
    [sym__external_open_bracket] = ACTIONS(5989),
    [sym__external_open_bracket2] = ACTIONS(5991),
  },
  [1667] = {
    [sym_call_arguments] = STATE(2777),
    [sym_subset_arguments] = STATE(2779),
    [sym_subset2_arguments] = STATE(2786),
    [sym__open_parenthesis] = STATE(1411),
    [sym__open_bracket] = STATE(1409),
    [sym__open_bracket2] = STATE(1407),
    [ts_builtin_sym_end] = ACTIONS(5345),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5345),
    [anon_sym_DASH] = ACTIONS(5347),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5347),
    [anon_sym_AMP] = ACTIONS(5347),
    [anon_sym_PIPE_PIPE] = ACTIONS(5345),
    [anon_sym_AMP_AMP] = ACTIONS(5345),
    [anon_sym_LT] = ACTIONS(5347),
    [anon_sym_LT_EQ] = ACTIONS(5345),
    [anon_sym_GT] = ACTIONS(5347),
    [anon_sym_GT_EQ] = ACTIONS(5345),
    [anon_sym_EQ_EQ] = ACTIONS(5345),
    [anon_sym_BANG_EQ] = ACTIONS(5345),
    [anon_sym_STAR] = ACTIONS(5347),
    [anon_sym_SLASH] = ACTIONS(5345),
    [anon_sym_STAR_STAR] = ACTIONS(6523),
    [anon_sym_CARET] = ACTIONS(6523),
    [aux_sym_binary_operator_token1] = ACTIONS(5345),
    [anon_sym_PIPE_GT] = ACTIONS(5345),
    [anon_sym_COLON] = ACTIONS(5347),
    [anon_sym_DOLLAR] = ACTIONS(6529),
    [anon_sym_AT] = ACTIONS(6529),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5345),
    [sym__semicolon] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(6531),
    [sym__external_close_parenthesis] = ACTIONS(5345),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(6533),
    [sym__external_open_bracket2] = ACTIONS(6535),
  },
  [1668] = {
    [sym_call_arguments] = STATE(2845),
    [sym_subset_arguments] = STATE(2849),
    [sym_subset2_arguments] = STATE(2852),
    [sym__open_parenthesis] = STATE(1372),
    [sym__open_bracket] = STATE(1371),
    [sym__open_bracket2] = STATE(1370),
    [sym_identifier] = ACTIONS(5451),
    [anon_sym_BSLASH] = ACTIONS(5449),
    [anon_sym_function] = ACTIONS(5451),
    [anon_sym_EQ] = ACTIONS(6181),
    [anon_sym_if] = ACTIONS(5451),
    [anon_sym_for] = ACTIONS(5451),
    [anon_sym_while] = ACTIONS(5451),
    [anon_sym_repeat] = ACTIONS(5451),
    [anon_sym_QMARK] = ACTIONS(5449),
    [anon_sym_TILDE] = ACTIONS(6183),
    [anon_sym_BANG] = ACTIONS(5451),
    [anon_sym_PLUS] = ACTIONS(6185),
    [anon_sym_DASH] = ACTIONS(6187),
    [anon_sym_LT_DASH] = ACTIONS(6189),
    [anon_sym_LT_LT_DASH] = ACTIONS(6189),
    [anon_sym_COLON_EQ] = ACTIONS(6189),
    [anon_sym_DASH_GT] = ACTIONS(6191),
    [anon_sym_DASH_GT_GT] = ACTIONS(6193),
    [anon_sym_PIPE] = ACTIONS(6195),
    [anon_sym_AMP] = ACTIONS(6197),
    [anon_sym_PIPE_PIPE] = ACTIONS(6199),
    [anon_sym_AMP_AMP] = ACTIONS(6201),
    [anon_sym_LT] = ACTIONS(6203),
    [anon_sym_LT_EQ] = ACTIONS(6205),
    [anon_sym_GT] = ACTIONS(6203),
    [anon_sym_GT_EQ] = ACTIONS(6205),
    [anon_sym_EQ_EQ] = ACTIONS(6205),
    [anon_sym_BANG_EQ] = ACTIONS(6205),
    [anon_sym_STAR] = ACTIONS(6207),
    [anon_sym_SLASH] = ACTIONS(6209),
    [anon_sym_STAR_STAR] = ACTIONS(6211),
    [anon_sym_CARET] = ACTIONS(6211),
    [aux_sym_binary_operator_token1] = ACTIONS(6213),
    [anon_sym_PIPE_GT] = ACTIONS(6213),
    [anon_sym_COLON] = ACTIONS(6215),
    [anon_sym_DOLLAR] = ACTIONS(6217),
    [anon_sym_AT] = ACTIONS(6217),
    [aux_sym__hex_literal_token1] = ACTIONS(5449),
    [sym__number_literal] = ACTIONS(5451),
    [anon_sym_SQUOTE] = ACTIONS(5449),
    [anon_sym_DQUOTE] = ACTIONS(5449),
    [sym_return] = ACTIONS(5451),
    [sym_next] = ACTIONS(5451),
    [sym_break] = ACTIONS(5451),
    [sym_true] = ACTIONS(5451),
    [sym_false] = ACTIONS(5451),
    [sym_null] = ACTIONS(5451),
    [sym_inf] = ACTIONS(5451),
    [sym_nan] = ACTIONS(5451),
    [anon_sym_NA] = ACTIONS(5451),
    [anon_sym_NA_integer_] = ACTIONS(5451),
    [anon_sym_NA_real_] = ACTIONS(5451),
    [anon_sym_NA_complex_] = ACTIONS(5451),
    [anon_sym_NA_character_] = ACTIONS(5451),
    [sym_dots] = ACTIONS(5451),
    [sym_dot_dot_i] = ACTIONS(5449),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5449),
    [sym__newline] = ACTIONS(5449),
    [sym__raw_string_literal] = ACTIONS(5449),
    [sym__external_else] = ACTIONS(5449),
    [sym__external_open_parenthesis] = ACTIONS(6221),
    [sym__external_close_parenthesis] = ACTIONS(5449),
    [sym__external_open_brace] = ACTIONS(5449),
    [sym__external_open_bracket] = ACTIONS(6223),
    [sym__external_open_bracket2] = ACTIONS(6225),
  },
  [1669] = {
    [sym_call_arguments] = STATE(2845),
    [sym_subset_arguments] = STATE(2849),
    [sym_subset2_arguments] = STATE(2852),
    [sym__open_parenthesis] = STATE(1372),
    [sym__open_bracket] = STATE(1371),
    [sym__open_bracket2] = STATE(1370),
    [sym_identifier] = ACTIONS(5447),
    [anon_sym_BSLASH] = ACTIONS(5445),
    [anon_sym_function] = ACTIONS(5447),
    [anon_sym_EQ] = ACTIONS(6181),
    [anon_sym_if] = ACTIONS(5447),
    [anon_sym_for] = ACTIONS(5447),
    [anon_sym_while] = ACTIONS(5447),
    [anon_sym_repeat] = ACTIONS(5447),
    [anon_sym_QMARK] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(6183),
    [anon_sym_BANG] = ACTIONS(5447),
    [anon_sym_PLUS] = ACTIONS(6185),
    [anon_sym_DASH] = ACTIONS(6187),
    [anon_sym_LT_DASH] = ACTIONS(6189),
    [anon_sym_LT_LT_DASH] = ACTIONS(6189),
    [anon_sym_COLON_EQ] = ACTIONS(6189),
    [anon_sym_DASH_GT] = ACTIONS(6191),
    [anon_sym_DASH_GT_GT] = ACTIONS(6193),
    [anon_sym_PIPE] = ACTIONS(6195),
    [anon_sym_AMP] = ACTIONS(6197),
    [anon_sym_PIPE_PIPE] = ACTIONS(6199),
    [anon_sym_AMP_AMP] = ACTIONS(6201),
    [anon_sym_LT] = ACTIONS(6203),
    [anon_sym_LT_EQ] = ACTIONS(6205),
    [anon_sym_GT] = ACTIONS(6203),
    [anon_sym_GT_EQ] = ACTIONS(6205),
    [anon_sym_EQ_EQ] = ACTIONS(6205),
    [anon_sym_BANG_EQ] = ACTIONS(6205),
    [anon_sym_STAR] = ACTIONS(6207),
    [anon_sym_SLASH] = ACTIONS(6209),
    [anon_sym_STAR_STAR] = ACTIONS(6211),
    [anon_sym_CARET] = ACTIONS(6211),
    [aux_sym_binary_operator_token1] = ACTIONS(6213),
    [anon_sym_PIPE_GT] = ACTIONS(6213),
    [anon_sym_COLON] = ACTIONS(6215),
    [anon_sym_DOLLAR] = ACTIONS(6217),
    [anon_sym_AT] = ACTIONS(6217),
    [aux_sym__hex_literal_token1] = ACTIONS(5445),
    [sym__number_literal] = ACTIONS(5447),
    [anon_sym_SQUOTE] = ACTIONS(5445),
    [anon_sym_DQUOTE] = ACTIONS(5445),
    [sym_return] = ACTIONS(5447),
    [sym_next] = ACTIONS(5447),
    [sym_break] = ACTIONS(5447),
    [sym_true] = ACTIONS(5447),
    [sym_false] = ACTIONS(5447),
    [sym_null] = ACTIONS(5447),
    [sym_inf] = ACTIONS(5447),
    [sym_nan] = ACTIONS(5447),
    [anon_sym_NA] = ACTIONS(5447),
    [anon_sym_NA_integer_] = ACTIONS(5447),
    [anon_sym_NA_real_] = ACTIONS(5447),
    [anon_sym_NA_complex_] = ACTIONS(5447),
    [anon_sym_NA_character_] = ACTIONS(5447),
    [sym_dots] = ACTIONS(5447),
    [sym_dot_dot_i] = ACTIONS(5445),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5445),
    [sym__newline] = ACTIONS(5445),
    [sym__raw_string_literal] = ACTIONS(5445),
    [sym__external_else] = ACTIONS(5445),
    [sym__external_open_parenthesis] = ACTIONS(6221),
    [sym__external_close_parenthesis] = ACTIONS(5445),
    [sym__external_open_brace] = ACTIONS(5445),
    [sym__external_open_bracket] = ACTIONS(6223),
    [sym__external_open_bracket2] = ACTIONS(6225),
  },
  [1670] = {
    [sym_call_arguments] = STATE(2840),
    [sym_subset_arguments] = STATE(2797),
    [sym_subset2_arguments] = STATE(2801),
    [sym__open_parenthesis] = STATE(1344),
    [sym__open_bracket] = STATE(1374),
    [sym__open_bracket2] = STATE(1452),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(6263),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(6265),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(6267),
    [anon_sym_DASH] = ACTIONS(6269),
    [anon_sym_LT_DASH] = ACTIONS(6271),
    [anon_sym_LT_LT_DASH] = ACTIONS(6271),
    [anon_sym_COLON_EQ] = ACTIONS(6271),
    [anon_sym_DASH_GT] = ACTIONS(6273),
    [anon_sym_DASH_GT_GT] = ACTIONS(6275),
    [anon_sym_PIPE] = ACTIONS(6277),
    [anon_sym_AMP] = ACTIONS(6279),
    [anon_sym_PIPE_PIPE] = ACTIONS(6281),
    [anon_sym_AMP_AMP] = ACTIONS(6283),
    [anon_sym_LT] = ACTIONS(6285),
    [anon_sym_LT_EQ] = ACTIONS(6287),
    [anon_sym_GT] = ACTIONS(6285),
    [anon_sym_GT_EQ] = ACTIONS(6287),
    [anon_sym_EQ_EQ] = ACTIONS(6287),
    [anon_sym_BANG_EQ] = ACTIONS(6287),
    [anon_sym_STAR] = ACTIONS(6289),
    [anon_sym_SLASH] = ACTIONS(6291),
    [anon_sym_STAR_STAR] = ACTIONS(6293),
    [anon_sym_CARET] = ACTIONS(6293),
    [aux_sym_binary_operator_token1] = ACTIONS(6295),
    [anon_sym_PIPE_GT] = ACTIONS(6295),
    [anon_sym_COLON] = ACTIONS(6297),
    [anon_sym_DOLLAR] = ACTIONS(6299),
    [anon_sym_AT] = ACTIONS(6299),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6301),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6303),
    [sym__external_open_bracket2] = ACTIONS(6305),
  },
  [1671] = {
    [sym_call_arguments] = STATE(2845),
    [sym_subset_arguments] = STATE(2849),
    [sym_subset2_arguments] = STATE(2852),
    [sym__open_parenthesis] = STATE(1372),
    [sym__open_bracket] = STATE(1371),
    [sym__open_bracket2] = STATE(1370),
    [sym_identifier] = ACTIONS(5443),
    [anon_sym_BSLASH] = ACTIONS(5441),
    [anon_sym_function] = ACTIONS(5443),
    [anon_sym_EQ] = ACTIONS(6181),
    [anon_sym_if] = ACTIONS(5443),
    [anon_sym_for] = ACTIONS(5443),
    [anon_sym_while] = ACTIONS(5443),
    [anon_sym_repeat] = ACTIONS(5443),
    [anon_sym_QMARK] = ACTIONS(5441),
    [anon_sym_TILDE] = ACTIONS(6183),
    [anon_sym_BANG] = ACTIONS(5443),
    [anon_sym_PLUS] = ACTIONS(6185),
    [anon_sym_DASH] = ACTIONS(6187),
    [anon_sym_LT_DASH] = ACTIONS(6189),
    [anon_sym_LT_LT_DASH] = ACTIONS(6189),
    [anon_sym_COLON_EQ] = ACTIONS(6189),
    [anon_sym_DASH_GT] = ACTIONS(6191),
    [anon_sym_DASH_GT_GT] = ACTIONS(6193),
    [anon_sym_PIPE] = ACTIONS(6195),
    [anon_sym_AMP] = ACTIONS(6197),
    [anon_sym_PIPE_PIPE] = ACTIONS(6199),
    [anon_sym_AMP_AMP] = ACTIONS(6201),
    [anon_sym_LT] = ACTIONS(6203),
    [anon_sym_LT_EQ] = ACTIONS(6205),
    [anon_sym_GT] = ACTIONS(6203),
    [anon_sym_GT_EQ] = ACTIONS(6205),
    [anon_sym_EQ_EQ] = ACTIONS(6205),
    [anon_sym_BANG_EQ] = ACTIONS(6205),
    [anon_sym_STAR] = ACTIONS(6207),
    [anon_sym_SLASH] = ACTIONS(6209),
    [anon_sym_STAR_STAR] = ACTIONS(6211),
    [anon_sym_CARET] = ACTIONS(6211),
    [aux_sym_binary_operator_token1] = ACTIONS(6213),
    [anon_sym_PIPE_GT] = ACTIONS(6213),
    [anon_sym_COLON] = ACTIONS(6215),
    [anon_sym_DOLLAR] = ACTIONS(6217),
    [anon_sym_AT] = ACTIONS(6217),
    [aux_sym__hex_literal_token1] = ACTIONS(5441),
    [sym__number_literal] = ACTIONS(5443),
    [anon_sym_SQUOTE] = ACTIONS(5441),
    [anon_sym_DQUOTE] = ACTIONS(5441),
    [sym_return] = ACTIONS(5443),
    [sym_next] = ACTIONS(5443),
    [sym_break] = ACTIONS(5443),
    [sym_true] = ACTIONS(5443),
    [sym_false] = ACTIONS(5443),
    [sym_null] = ACTIONS(5443),
    [sym_inf] = ACTIONS(5443),
    [sym_nan] = ACTIONS(5443),
    [anon_sym_NA] = ACTIONS(5443),
    [anon_sym_NA_integer_] = ACTIONS(5443),
    [anon_sym_NA_real_] = ACTIONS(5443),
    [anon_sym_NA_complex_] = ACTIONS(5443),
    [anon_sym_NA_character_] = ACTIONS(5443),
    [sym_dots] = ACTIONS(5443),
    [sym_dot_dot_i] = ACTIONS(5441),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5441),
    [sym__newline] = ACTIONS(5441),
    [sym__raw_string_literal] = ACTIONS(5441),
    [sym__external_else] = ACTIONS(5441),
    [sym__external_open_parenthesis] = ACTIONS(6221),
    [sym__external_close_parenthesis] = ACTIONS(5441),
    [sym__external_open_brace] = ACTIONS(5441),
    [sym__external_open_bracket] = ACTIONS(6223),
    [sym__external_open_bracket2] = ACTIONS(6225),
  },
  [1672] = {
    [sym_call_arguments] = STATE(2923),
    [sym_subset_arguments] = STATE(2922),
    [sym_subset2_arguments] = STATE(2906),
    [sym__open_parenthesis] = STATE(1528),
    [sym__open_bracket] = STATE(1525),
    [sym__open_bracket2] = STATE(1519),
    [ts_builtin_sym_end] = ACTIONS(5429),
    [sym_identifier] = ACTIONS(5431),
    [anon_sym_BSLASH] = ACTIONS(5429),
    [anon_sym_function] = ACTIONS(5431),
    [anon_sym_EQ] = ACTIONS(5947),
    [anon_sym_if] = ACTIONS(5431),
    [anon_sym_for] = ACTIONS(5431),
    [anon_sym_while] = ACTIONS(5431),
    [anon_sym_repeat] = ACTIONS(5431),
    [anon_sym_QMARK] = ACTIONS(5429),
    [anon_sym_TILDE] = ACTIONS(5949),
    [anon_sym_BANG] = ACTIONS(5431),
    [anon_sym_PLUS] = ACTIONS(5951),
    [anon_sym_DASH] = ACTIONS(5953),
    [anon_sym_LT_DASH] = ACTIONS(5955),
    [anon_sym_LT_LT_DASH] = ACTIONS(5955),
    [anon_sym_COLON_EQ] = ACTIONS(5955),
    [anon_sym_DASH_GT] = ACTIONS(5957),
    [anon_sym_DASH_GT_GT] = ACTIONS(5959),
    [anon_sym_PIPE] = ACTIONS(5961),
    [anon_sym_AMP] = ACTIONS(5963),
    [anon_sym_PIPE_PIPE] = ACTIONS(5965),
    [anon_sym_AMP_AMP] = ACTIONS(5967),
    [anon_sym_LT] = ACTIONS(5969),
    [anon_sym_LT_EQ] = ACTIONS(5971),
    [anon_sym_GT] = ACTIONS(5969),
    [anon_sym_GT_EQ] = ACTIONS(5971),
    [anon_sym_EQ_EQ] = ACTIONS(5971),
    [anon_sym_BANG_EQ] = ACTIONS(5971),
    [anon_sym_STAR] = ACTIONS(5973),
    [anon_sym_SLASH] = ACTIONS(5975),
    [anon_sym_STAR_STAR] = ACTIONS(5977),
    [anon_sym_CARET] = ACTIONS(5977),
    [aux_sym_binary_operator_token1] = ACTIONS(5979),
    [anon_sym_PIPE_GT] = ACTIONS(5979),
    [anon_sym_COLON] = ACTIONS(5981),
    [anon_sym_DOLLAR] = ACTIONS(5983),
    [anon_sym_AT] = ACTIONS(5983),
    [aux_sym__hex_literal_token1] = ACTIONS(5429),
    [sym__number_literal] = ACTIONS(5431),
    [anon_sym_SQUOTE] = ACTIONS(5429),
    [anon_sym_DQUOTE] = ACTIONS(5429),
    [sym_return] = ACTIONS(5431),
    [sym_next] = ACTIONS(5431),
    [sym_break] = ACTIONS(5431),
    [sym_true] = ACTIONS(5431),
    [sym_false] = ACTIONS(5431),
    [sym_null] = ACTIONS(5431),
    [sym_inf] = ACTIONS(5431),
    [sym_nan] = ACTIONS(5431),
    [anon_sym_NA] = ACTIONS(5431),
    [anon_sym_NA_integer_] = ACTIONS(5431),
    [anon_sym_NA_real_] = ACTIONS(5431),
    [anon_sym_NA_complex_] = ACTIONS(5431),
    [anon_sym_NA_character_] = ACTIONS(5431),
    [sym_dots] = ACTIONS(5431),
    [sym_dot_dot_i] = ACTIONS(5429),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5429),
    [sym__semicolon] = ACTIONS(5429),
    [sym__raw_string_literal] = ACTIONS(5429),
    [sym__external_else] = ACTIONS(5429),
    [sym__external_open_parenthesis] = ACTIONS(5987),
    [sym__external_open_brace] = ACTIONS(5429),
    [sym__external_open_bracket] = ACTIONS(5989),
    [sym__external_open_bracket2] = ACTIONS(5991),
  },
  [1673] = {
    [sym_call_arguments] = STATE(2845),
    [sym_subset_arguments] = STATE(2849),
    [sym_subset2_arguments] = STATE(2852),
    [sym__open_parenthesis] = STATE(1372),
    [sym__open_bracket] = STATE(1371),
    [sym__open_bracket2] = STATE(1370),
    [sym_identifier] = ACTIONS(5439),
    [anon_sym_BSLASH] = ACTIONS(5437),
    [anon_sym_function] = ACTIONS(5439),
    [anon_sym_EQ] = ACTIONS(6181),
    [anon_sym_if] = ACTIONS(5439),
    [anon_sym_for] = ACTIONS(5439),
    [anon_sym_while] = ACTIONS(5439),
    [anon_sym_repeat] = ACTIONS(5439),
    [anon_sym_QMARK] = ACTIONS(5437),
    [anon_sym_TILDE] = ACTIONS(6183),
    [anon_sym_BANG] = ACTIONS(5439),
    [anon_sym_PLUS] = ACTIONS(6185),
    [anon_sym_DASH] = ACTIONS(6187),
    [anon_sym_LT_DASH] = ACTIONS(6189),
    [anon_sym_LT_LT_DASH] = ACTIONS(6189),
    [anon_sym_COLON_EQ] = ACTIONS(6189),
    [anon_sym_DASH_GT] = ACTIONS(6191),
    [anon_sym_DASH_GT_GT] = ACTIONS(6193),
    [anon_sym_PIPE] = ACTIONS(6195),
    [anon_sym_AMP] = ACTIONS(6197),
    [anon_sym_PIPE_PIPE] = ACTIONS(6199),
    [anon_sym_AMP_AMP] = ACTIONS(6201),
    [anon_sym_LT] = ACTIONS(6203),
    [anon_sym_LT_EQ] = ACTIONS(6205),
    [anon_sym_GT] = ACTIONS(6203),
    [anon_sym_GT_EQ] = ACTIONS(6205),
    [anon_sym_EQ_EQ] = ACTIONS(6205),
    [anon_sym_BANG_EQ] = ACTIONS(6205),
    [anon_sym_STAR] = ACTIONS(6207),
    [anon_sym_SLASH] = ACTIONS(6209),
    [anon_sym_STAR_STAR] = ACTIONS(6211),
    [anon_sym_CARET] = ACTIONS(6211),
    [aux_sym_binary_operator_token1] = ACTIONS(6213),
    [anon_sym_PIPE_GT] = ACTIONS(6213),
    [anon_sym_COLON] = ACTIONS(6215),
    [anon_sym_DOLLAR] = ACTIONS(6217),
    [anon_sym_AT] = ACTIONS(6217),
    [aux_sym__hex_literal_token1] = ACTIONS(5437),
    [sym__number_literal] = ACTIONS(5439),
    [anon_sym_SQUOTE] = ACTIONS(5437),
    [anon_sym_DQUOTE] = ACTIONS(5437),
    [sym_return] = ACTIONS(5439),
    [sym_next] = ACTIONS(5439),
    [sym_break] = ACTIONS(5439),
    [sym_true] = ACTIONS(5439),
    [sym_false] = ACTIONS(5439),
    [sym_null] = ACTIONS(5439),
    [sym_inf] = ACTIONS(5439),
    [sym_nan] = ACTIONS(5439),
    [anon_sym_NA] = ACTIONS(5439),
    [anon_sym_NA_integer_] = ACTIONS(5439),
    [anon_sym_NA_real_] = ACTIONS(5439),
    [anon_sym_NA_complex_] = ACTIONS(5439),
    [anon_sym_NA_character_] = ACTIONS(5439),
    [sym_dots] = ACTIONS(5439),
    [sym_dot_dot_i] = ACTIONS(5437),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5437),
    [sym__newline] = ACTIONS(5437),
    [sym__raw_string_literal] = ACTIONS(5437),
    [sym__external_else] = ACTIONS(5437),
    [sym__external_open_parenthesis] = ACTIONS(6221),
    [sym__external_close_parenthesis] = ACTIONS(5437),
    [sym__external_open_brace] = ACTIONS(5437),
    [sym__external_open_bracket] = ACTIONS(6223),
    [sym__external_open_bracket2] = ACTIONS(6225),
  },
  [1674] = {
    [sym_call_arguments] = STATE(2845),
    [sym_subset_arguments] = STATE(2849),
    [sym_subset2_arguments] = STATE(2852),
    [sym__open_parenthesis] = STATE(1372),
    [sym__open_bracket] = STATE(1371),
    [sym__open_bracket2] = STATE(1370),
    [sym_identifier] = ACTIONS(5435),
    [anon_sym_BSLASH] = ACTIONS(5433),
    [anon_sym_function] = ACTIONS(5435),
    [anon_sym_EQ] = ACTIONS(6181),
    [anon_sym_if] = ACTIONS(5435),
    [anon_sym_for] = ACTIONS(5435),
    [anon_sym_while] = ACTIONS(5435),
    [anon_sym_repeat] = ACTIONS(5435),
    [anon_sym_QMARK] = ACTIONS(5433),
    [anon_sym_TILDE] = ACTIONS(6183),
    [anon_sym_BANG] = ACTIONS(5435),
    [anon_sym_PLUS] = ACTIONS(6185),
    [anon_sym_DASH] = ACTIONS(6187),
    [anon_sym_LT_DASH] = ACTIONS(6189),
    [anon_sym_LT_LT_DASH] = ACTIONS(6189),
    [anon_sym_COLON_EQ] = ACTIONS(6189),
    [anon_sym_DASH_GT] = ACTIONS(6191),
    [anon_sym_DASH_GT_GT] = ACTIONS(6193),
    [anon_sym_PIPE] = ACTIONS(6195),
    [anon_sym_AMP] = ACTIONS(6197),
    [anon_sym_PIPE_PIPE] = ACTIONS(6199),
    [anon_sym_AMP_AMP] = ACTIONS(6201),
    [anon_sym_LT] = ACTIONS(6203),
    [anon_sym_LT_EQ] = ACTIONS(6205),
    [anon_sym_GT] = ACTIONS(6203),
    [anon_sym_GT_EQ] = ACTIONS(6205),
    [anon_sym_EQ_EQ] = ACTIONS(6205),
    [anon_sym_BANG_EQ] = ACTIONS(6205),
    [anon_sym_STAR] = ACTIONS(6207),
    [anon_sym_SLASH] = ACTIONS(6209),
    [anon_sym_STAR_STAR] = ACTIONS(6211),
    [anon_sym_CARET] = ACTIONS(6211),
    [aux_sym_binary_operator_token1] = ACTIONS(6213),
    [anon_sym_PIPE_GT] = ACTIONS(6213),
    [anon_sym_COLON] = ACTIONS(6215),
    [anon_sym_DOLLAR] = ACTIONS(6217),
    [anon_sym_AT] = ACTIONS(6217),
    [aux_sym__hex_literal_token1] = ACTIONS(5433),
    [sym__number_literal] = ACTIONS(5435),
    [anon_sym_SQUOTE] = ACTIONS(5433),
    [anon_sym_DQUOTE] = ACTIONS(5433),
    [sym_return] = ACTIONS(5435),
    [sym_next] = ACTIONS(5435),
    [sym_break] = ACTIONS(5435),
    [sym_true] = ACTIONS(5435),
    [sym_false] = ACTIONS(5435),
    [sym_null] = ACTIONS(5435),
    [sym_inf] = ACTIONS(5435),
    [sym_nan] = ACTIONS(5435),
    [anon_sym_NA] = ACTIONS(5435),
    [anon_sym_NA_integer_] = ACTIONS(5435),
    [anon_sym_NA_real_] = ACTIONS(5435),
    [anon_sym_NA_complex_] = ACTIONS(5435),
    [anon_sym_NA_character_] = ACTIONS(5435),
    [sym_dots] = ACTIONS(5435),
    [sym_dot_dot_i] = ACTIONS(5433),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5433),
    [sym__newline] = ACTIONS(5433),
    [sym__raw_string_literal] = ACTIONS(5433),
    [sym__external_else] = ACTIONS(5433),
    [sym__external_open_parenthesis] = ACTIONS(6221),
    [sym__external_close_parenthesis] = ACTIONS(5433),
    [sym__external_open_brace] = ACTIONS(5433),
    [sym__external_open_bracket] = ACTIONS(6223),
    [sym__external_open_bracket2] = ACTIONS(6225),
  },
  [1675] = {
    [sym_call_arguments] = STATE(2777),
    [sym_subset_arguments] = STATE(2779),
    [sym_subset2_arguments] = STATE(2786),
    [sym__open_parenthesis] = STATE(1411),
    [sym__open_bracket] = STATE(1409),
    [sym__open_bracket2] = STATE(1407),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(6491),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(6495),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(6497),
    [anon_sym_DASH] = ACTIONS(6499),
    [anon_sym_LT_DASH] = ACTIONS(6501),
    [anon_sym_LT_LT_DASH] = ACTIONS(6501),
    [anon_sym_COLON_EQ] = ACTIONS(6501),
    [anon_sym_DASH_GT] = ACTIONS(6503),
    [anon_sym_DASH_GT_GT] = ACTIONS(6505),
    [anon_sym_PIPE] = ACTIONS(6507),
    [anon_sym_AMP] = ACTIONS(6509),
    [anon_sym_PIPE_PIPE] = ACTIONS(6511),
    [anon_sym_AMP_AMP] = ACTIONS(6513),
    [anon_sym_LT] = ACTIONS(6515),
    [anon_sym_LT_EQ] = ACTIONS(6517),
    [anon_sym_GT] = ACTIONS(6515),
    [anon_sym_GT_EQ] = ACTIONS(6517),
    [anon_sym_EQ_EQ] = ACTIONS(6517),
    [anon_sym_BANG_EQ] = ACTIONS(6517),
    [anon_sym_STAR] = ACTIONS(6519),
    [anon_sym_SLASH] = ACTIONS(6521),
    [anon_sym_STAR_STAR] = ACTIONS(6523),
    [anon_sym_CARET] = ACTIONS(6523),
    [aux_sym_binary_operator_token1] = ACTIONS(6525),
    [anon_sym_PIPE_GT] = ACTIONS(6525),
    [anon_sym_COLON] = ACTIONS(6527),
    [anon_sym_DOLLAR] = ACTIONS(6529),
    [anon_sym_AT] = ACTIONS(6529),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6531),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6533),
    [sym__external_open_bracket2] = ACTIONS(6535),
  },
  [1676] = {
    [sym_call_arguments] = STATE(2840),
    [sym_subset_arguments] = STATE(2797),
    [sym_subset2_arguments] = STATE(2801),
    [sym__open_parenthesis] = STATE(1344),
    [sym__open_bracket] = STATE(1374),
    [sym__open_bracket2] = STATE(1452),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(6293),
    [anon_sym_CARET] = ACTIONS(6293),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(5261),
    [anon_sym_DOLLAR] = ACTIONS(6299),
    [anon_sym_AT] = ACTIONS(6299),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6301),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6303),
    [sym__external_open_bracket2] = ACTIONS(6305),
  },
  [1677] = {
    [sym_call_arguments] = STATE(2845),
    [sym_subset_arguments] = STATE(2849),
    [sym_subset2_arguments] = STATE(2852),
    [sym__open_parenthesis] = STATE(1372),
    [sym__open_bracket] = STATE(1371),
    [sym__open_bracket2] = STATE(1370),
    [sym_identifier] = ACTIONS(5431),
    [anon_sym_BSLASH] = ACTIONS(5429),
    [anon_sym_function] = ACTIONS(5431),
    [anon_sym_EQ] = ACTIONS(6181),
    [anon_sym_if] = ACTIONS(5431),
    [anon_sym_for] = ACTIONS(5431),
    [anon_sym_while] = ACTIONS(5431),
    [anon_sym_repeat] = ACTIONS(5431),
    [anon_sym_QMARK] = ACTIONS(5429),
    [anon_sym_TILDE] = ACTIONS(6183),
    [anon_sym_BANG] = ACTIONS(5431),
    [anon_sym_PLUS] = ACTIONS(6185),
    [anon_sym_DASH] = ACTIONS(6187),
    [anon_sym_LT_DASH] = ACTIONS(6189),
    [anon_sym_LT_LT_DASH] = ACTIONS(6189),
    [anon_sym_COLON_EQ] = ACTIONS(6189),
    [anon_sym_DASH_GT] = ACTIONS(6191),
    [anon_sym_DASH_GT_GT] = ACTIONS(6193),
    [anon_sym_PIPE] = ACTIONS(6195),
    [anon_sym_AMP] = ACTIONS(6197),
    [anon_sym_PIPE_PIPE] = ACTIONS(6199),
    [anon_sym_AMP_AMP] = ACTIONS(6201),
    [anon_sym_LT] = ACTIONS(6203),
    [anon_sym_LT_EQ] = ACTIONS(6205),
    [anon_sym_GT] = ACTIONS(6203),
    [anon_sym_GT_EQ] = ACTIONS(6205),
    [anon_sym_EQ_EQ] = ACTIONS(6205),
    [anon_sym_BANG_EQ] = ACTIONS(6205),
    [anon_sym_STAR] = ACTIONS(6207),
    [anon_sym_SLASH] = ACTIONS(6209),
    [anon_sym_STAR_STAR] = ACTIONS(6211),
    [anon_sym_CARET] = ACTIONS(6211),
    [aux_sym_binary_operator_token1] = ACTIONS(6213),
    [anon_sym_PIPE_GT] = ACTIONS(6213),
    [anon_sym_COLON] = ACTIONS(6215),
    [anon_sym_DOLLAR] = ACTIONS(6217),
    [anon_sym_AT] = ACTIONS(6217),
    [aux_sym__hex_literal_token1] = ACTIONS(5429),
    [sym__number_literal] = ACTIONS(5431),
    [anon_sym_SQUOTE] = ACTIONS(5429),
    [anon_sym_DQUOTE] = ACTIONS(5429),
    [sym_return] = ACTIONS(5431),
    [sym_next] = ACTIONS(5431),
    [sym_break] = ACTIONS(5431),
    [sym_true] = ACTIONS(5431),
    [sym_false] = ACTIONS(5431),
    [sym_null] = ACTIONS(5431),
    [sym_inf] = ACTIONS(5431),
    [sym_nan] = ACTIONS(5431),
    [anon_sym_NA] = ACTIONS(5431),
    [anon_sym_NA_integer_] = ACTIONS(5431),
    [anon_sym_NA_real_] = ACTIONS(5431),
    [anon_sym_NA_complex_] = ACTIONS(5431),
    [anon_sym_NA_character_] = ACTIONS(5431),
    [sym_dots] = ACTIONS(5431),
    [sym_dot_dot_i] = ACTIONS(5429),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5429),
    [sym__newline] = ACTIONS(5429),
    [sym__raw_string_literal] = ACTIONS(5429),
    [sym__external_else] = ACTIONS(5429),
    [sym__external_open_parenthesis] = ACTIONS(6221),
    [sym__external_close_parenthesis] = ACTIONS(5429),
    [sym__external_open_brace] = ACTIONS(5429),
    [sym__external_open_bracket] = ACTIONS(6223),
    [sym__external_open_bracket2] = ACTIONS(6225),
  },
  [1678] = {
    [sym_call_arguments] = STATE(2840),
    [sym_subset_arguments] = STATE(2797),
    [sym_subset2_arguments] = STATE(2801),
    [sym__open_parenthesis] = STATE(1344),
    [sym__open_bracket] = STATE(1374),
    [sym__open_bracket2] = STATE(1452),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(6293),
    [anon_sym_CARET] = ACTIONS(6293),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(6297),
    [anon_sym_DOLLAR] = ACTIONS(6299),
    [anon_sym_AT] = ACTIONS(6299),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6301),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6303),
    [sym__external_open_bracket2] = ACTIONS(6305),
  },
  [1679] = {
    [sym_call_arguments] = STATE(2808),
    [sym_subset_arguments] = STATE(2920),
    [sym_subset2_arguments] = STATE(2919),
    [sym__open_parenthesis] = STATE(1545),
    [sym__open_bracket] = STATE(1541),
    [sym__open_bracket2] = STATE(1539),
    [sym_identifier] = ACTIONS(5339),
    [anon_sym_BSLASH] = ACTIONS(5337),
    [anon_sym_function] = ACTIONS(5339),
    [anon_sym_EQ] = ACTIONS(6307),
    [anon_sym_if] = ACTIONS(5339),
    [anon_sym_for] = ACTIONS(5339),
    [anon_sym_while] = ACTIONS(5339),
    [anon_sym_repeat] = ACTIONS(5339),
    [anon_sym_QMARK] = ACTIONS(5337),
    [anon_sym_TILDE] = ACTIONS(6309),
    [anon_sym_BANG] = ACTIONS(5339),
    [anon_sym_PLUS] = ACTIONS(6311),
    [anon_sym_DASH] = ACTIONS(6313),
    [anon_sym_LT_DASH] = ACTIONS(6315),
    [anon_sym_LT_LT_DASH] = ACTIONS(6315),
    [anon_sym_COLON_EQ] = ACTIONS(6315),
    [anon_sym_DASH_GT] = ACTIONS(6317),
    [anon_sym_DASH_GT_GT] = ACTIONS(6319),
    [anon_sym_PIPE] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6323),
    [anon_sym_PIPE_PIPE] = ACTIONS(6325),
    [anon_sym_AMP_AMP] = ACTIONS(6327),
    [anon_sym_LT] = ACTIONS(6329),
    [anon_sym_LT_EQ] = ACTIONS(6331),
    [anon_sym_GT] = ACTIONS(6329),
    [anon_sym_GT_EQ] = ACTIONS(6331),
    [anon_sym_EQ_EQ] = ACTIONS(6331),
    [anon_sym_BANG_EQ] = ACTIONS(6331),
    [anon_sym_STAR] = ACTIONS(6333),
    [anon_sym_SLASH] = ACTIONS(6335),
    [anon_sym_STAR_STAR] = ACTIONS(6337),
    [anon_sym_CARET] = ACTIONS(6337),
    [aux_sym_binary_operator_token1] = ACTIONS(6339),
    [anon_sym_PIPE_GT] = ACTIONS(6339),
    [anon_sym_COLON] = ACTIONS(6341),
    [anon_sym_DOLLAR] = ACTIONS(6343),
    [anon_sym_AT] = ACTIONS(6343),
    [aux_sym__hex_literal_token1] = ACTIONS(5337),
    [sym__number_literal] = ACTIONS(5339),
    [anon_sym_SQUOTE] = ACTIONS(5337),
    [anon_sym_DQUOTE] = ACTIONS(5337),
    [sym_return] = ACTIONS(5339),
    [sym_next] = ACTIONS(5339),
    [sym_break] = ACTIONS(5339),
    [sym_true] = ACTIONS(5339),
    [sym_false] = ACTIONS(5339),
    [sym_null] = ACTIONS(5339),
    [sym_inf] = ACTIONS(5339),
    [sym_nan] = ACTIONS(5339),
    [anon_sym_NA] = ACTIONS(5339),
    [anon_sym_NA_integer_] = ACTIONS(5339),
    [anon_sym_NA_real_] = ACTIONS(5339),
    [anon_sym_NA_complex_] = ACTIONS(5339),
    [anon_sym_NA_character_] = ACTIONS(5339),
    [sym_dots] = ACTIONS(5339),
    [sym_dot_dot_i] = ACTIONS(5337),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5337),
    [sym__newline] = ACTIONS(5337),
    [sym__raw_string_literal] = ACTIONS(5337),
    [sym__external_open_parenthesis] = ACTIONS(6345),
    [sym__external_close_parenthesis] = ACTIONS(5337),
    [sym__external_open_brace] = ACTIONS(5337),
    [sym__external_open_bracket] = ACTIONS(6347),
    [sym__external_open_bracket2] = ACTIONS(6349),
    [sym__external_close_bracket2] = ACTIONS(5337),
  },
  [1680] = {
    [sym_call_arguments] = STATE(2840),
    [sym_subset_arguments] = STATE(2797),
    [sym_subset2_arguments] = STATE(2801),
    [sym__open_parenthesis] = STATE(1344),
    [sym__open_bracket] = STATE(1374),
    [sym__open_bracket2] = STATE(1452),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(6293),
    [anon_sym_CARET] = ACTIONS(6293),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(5261),
    [anon_sym_DOLLAR] = ACTIONS(6299),
    [anon_sym_AT] = ACTIONS(6299),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6301),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6303),
    [sym__external_open_bracket2] = ACTIONS(6305),
  },
  [1681] = {
    [sym_call_arguments] = STATE(2845),
    [sym_subset_arguments] = STATE(2849),
    [sym_subset2_arguments] = STATE(2852),
    [sym__open_parenthesis] = STATE(1372),
    [sym__open_bracket] = STATE(1371),
    [sym__open_bracket2] = STATE(1370),
    [sym_identifier] = ACTIONS(5427),
    [anon_sym_BSLASH] = ACTIONS(5425),
    [anon_sym_function] = ACTIONS(5427),
    [anon_sym_EQ] = ACTIONS(6181),
    [anon_sym_if] = ACTIONS(5427),
    [anon_sym_for] = ACTIONS(5427),
    [anon_sym_while] = ACTIONS(5427),
    [anon_sym_repeat] = ACTIONS(5427),
    [anon_sym_QMARK] = ACTIONS(5425),
    [anon_sym_TILDE] = ACTIONS(6183),
    [anon_sym_BANG] = ACTIONS(5427),
    [anon_sym_PLUS] = ACTIONS(6185),
    [anon_sym_DASH] = ACTIONS(6187),
    [anon_sym_LT_DASH] = ACTIONS(6189),
    [anon_sym_LT_LT_DASH] = ACTIONS(6189),
    [anon_sym_COLON_EQ] = ACTIONS(6189),
    [anon_sym_DASH_GT] = ACTIONS(6191),
    [anon_sym_DASH_GT_GT] = ACTIONS(6193),
    [anon_sym_PIPE] = ACTIONS(6195),
    [anon_sym_AMP] = ACTIONS(6197),
    [anon_sym_PIPE_PIPE] = ACTIONS(6199),
    [anon_sym_AMP_AMP] = ACTIONS(6201),
    [anon_sym_LT] = ACTIONS(6203),
    [anon_sym_LT_EQ] = ACTIONS(6205),
    [anon_sym_GT] = ACTIONS(6203),
    [anon_sym_GT_EQ] = ACTIONS(6205),
    [anon_sym_EQ_EQ] = ACTIONS(6205),
    [anon_sym_BANG_EQ] = ACTIONS(6205),
    [anon_sym_STAR] = ACTIONS(6207),
    [anon_sym_SLASH] = ACTIONS(6209),
    [anon_sym_STAR_STAR] = ACTIONS(6211),
    [anon_sym_CARET] = ACTIONS(6211),
    [aux_sym_binary_operator_token1] = ACTIONS(6213),
    [anon_sym_PIPE_GT] = ACTIONS(6213),
    [anon_sym_COLON] = ACTIONS(6215),
    [anon_sym_DOLLAR] = ACTIONS(6217),
    [anon_sym_AT] = ACTIONS(6217),
    [aux_sym__hex_literal_token1] = ACTIONS(5425),
    [sym__number_literal] = ACTIONS(5427),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_DQUOTE] = ACTIONS(5425),
    [sym_return] = ACTIONS(5427),
    [sym_next] = ACTIONS(5427),
    [sym_break] = ACTIONS(5427),
    [sym_true] = ACTIONS(5427),
    [sym_false] = ACTIONS(5427),
    [sym_null] = ACTIONS(5427),
    [sym_inf] = ACTIONS(5427),
    [sym_nan] = ACTIONS(5427),
    [anon_sym_NA] = ACTIONS(5427),
    [anon_sym_NA_integer_] = ACTIONS(5427),
    [anon_sym_NA_real_] = ACTIONS(5427),
    [anon_sym_NA_complex_] = ACTIONS(5427),
    [anon_sym_NA_character_] = ACTIONS(5427),
    [sym_dots] = ACTIONS(5427),
    [sym_dot_dot_i] = ACTIONS(5425),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5425),
    [sym__newline] = ACTIONS(5425),
    [sym__raw_string_literal] = ACTIONS(5425),
    [sym__external_else] = ACTIONS(5425),
    [sym__external_open_parenthesis] = ACTIONS(6221),
    [sym__external_close_parenthesis] = ACTIONS(5425),
    [sym__external_open_brace] = ACTIONS(5425),
    [sym__external_open_bracket] = ACTIONS(6223),
    [sym__external_open_bracket2] = ACTIONS(6225),
  },
  [1682] = {
    [sym_call_arguments] = STATE(2777),
    [sym_subset_arguments] = STATE(2779),
    [sym_subset2_arguments] = STATE(2786),
    [sym__open_parenthesis] = STATE(1411),
    [sym__open_bracket] = STATE(1409),
    [sym__open_bracket2] = STATE(1407),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(6495),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(6497),
    [anon_sym_DASH] = ACTIONS(6499),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(6507),
    [anon_sym_AMP] = ACTIONS(6509),
    [anon_sym_PIPE_PIPE] = ACTIONS(6511),
    [anon_sym_AMP_AMP] = ACTIONS(6513),
    [anon_sym_LT] = ACTIONS(6515),
    [anon_sym_LT_EQ] = ACTIONS(6517),
    [anon_sym_GT] = ACTIONS(6515),
    [anon_sym_GT_EQ] = ACTIONS(6517),
    [anon_sym_EQ_EQ] = ACTIONS(6517),
    [anon_sym_BANG_EQ] = ACTIONS(6517),
    [anon_sym_STAR] = ACTIONS(6519),
    [anon_sym_SLASH] = ACTIONS(6521),
    [anon_sym_STAR_STAR] = ACTIONS(6523),
    [anon_sym_CARET] = ACTIONS(6523),
    [aux_sym_binary_operator_token1] = ACTIONS(6525),
    [anon_sym_PIPE_GT] = ACTIONS(6525),
    [anon_sym_COLON] = ACTIONS(6527),
    [anon_sym_DOLLAR] = ACTIONS(6529),
    [anon_sym_AT] = ACTIONS(6529),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6531),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6533),
    [sym__external_open_bracket2] = ACTIONS(6535),
  },
  [1683] = {
    [sym_call_arguments] = STATE(2808),
    [sym_subset_arguments] = STATE(2920),
    [sym_subset2_arguments] = STATE(2919),
    [sym__open_parenthesis] = STATE(1545),
    [sym__open_bracket] = STATE(1541),
    [sym__open_bracket2] = STATE(1539),
    [sym_identifier] = ACTIONS(5343),
    [anon_sym_BSLASH] = ACTIONS(5341),
    [anon_sym_function] = ACTIONS(5343),
    [anon_sym_EQ] = ACTIONS(6307),
    [anon_sym_if] = ACTIONS(5343),
    [anon_sym_for] = ACTIONS(5343),
    [anon_sym_while] = ACTIONS(5343),
    [anon_sym_repeat] = ACTIONS(5343),
    [anon_sym_QMARK] = ACTIONS(5341),
    [anon_sym_TILDE] = ACTIONS(6309),
    [anon_sym_BANG] = ACTIONS(5343),
    [anon_sym_PLUS] = ACTIONS(6311),
    [anon_sym_DASH] = ACTIONS(6313),
    [anon_sym_LT_DASH] = ACTIONS(6315),
    [anon_sym_LT_LT_DASH] = ACTIONS(6315),
    [anon_sym_COLON_EQ] = ACTIONS(6315),
    [anon_sym_DASH_GT] = ACTIONS(6317),
    [anon_sym_DASH_GT_GT] = ACTIONS(6319),
    [anon_sym_PIPE] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6323),
    [anon_sym_PIPE_PIPE] = ACTIONS(6325),
    [anon_sym_AMP_AMP] = ACTIONS(6327),
    [anon_sym_LT] = ACTIONS(6329),
    [anon_sym_LT_EQ] = ACTIONS(6331),
    [anon_sym_GT] = ACTIONS(6329),
    [anon_sym_GT_EQ] = ACTIONS(6331),
    [anon_sym_EQ_EQ] = ACTIONS(6331),
    [anon_sym_BANG_EQ] = ACTIONS(6331),
    [anon_sym_STAR] = ACTIONS(6333),
    [anon_sym_SLASH] = ACTIONS(6335),
    [anon_sym_STAR_STAR] = ACTIONS(6337),
    [anon_sym_CARET] = ACTIONS(6337),
    [aux_sym_binary_operator_token1] = ACTIONS(6339),
    [anon_sym_PIPE_GT] = ACTIONS(6339),
    [anon_sym_COLON] = ACTIONS(6341),
    [anon_sym_DOLLAR] = ACTIONS(6343),
    [anon_sym_AT] = ACTIONS(6343),
    [aux_sym__hex_literal_token1] = ACTIONS(5341),
    [sym__number_literal] = ACTIONS(5343),
    [anon_sym_SQUOTE] = ACTIONS(5341),
    [anon_sym_DQUOTE] = ACTIONS(5341),
    [sym_return] = ACTIONS(5343),
    [sym_next] = ACTIONS(5343),
    [sym_break] = ACTIONS(5343),
    [sym_true] = ACTIONS(5343),
    [sym_false] = ACTIONS(5343),
    [sym_null] = ACTIONS(5343),
    [sym_inf] = ACTIONS(5343),
    [sym_nan] = ACTIONS(5343),
    [anon_sym_NA] = ACTIONS(5343),
    [anon_sym_NA_integer_] = ACTIONS(5343),
    [anon_sym_NA_real_] = ACTIONS(5343),
    [anon_sym_NA_complex_] = ACTIONS(5343),
    [anon_sym_NA_character_] = ACTIONS(5343),
    [sym_dots] = ACTIONS(5343),
    [sym_dot_dot_i] = ACTIONS(5341),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5341),
    [sym__newline] = ACTIONS(5341),
    [sym__raw_string_literal] = ACTIONS(5341),
    [sym__external_open_parenthesis] = ACTIONS(6345),
    [sym__external_close_parenthesis] = ACTIONS(5341),
    [sym__external_open_brace] = ACTIONS(5341),
    [sym__external_open_bracket] = ACTIONS(6347),
    [sym__external_open_bracket2] = ACTIONS(6349),
    [sym__external_close_bracket2] = ACTIONS(5341),
  },
  [1684] = {
    [sym_call_arguments] = STATE(2808),
    [sym_subset_arguments] = STATE(2920),
    [sym_subset2_arguments] = STATE(2919),
    [sym__open_parenthesis] = STATE(1545),
    [sym__open_bracket] = STATE(1541),
    [sym__open_bracket2] = STATE(1539),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(6307),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(6309),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(6311),
    [anon_sym_DASH] = ACTIONS(6313),
    [anon_sym_LT_DASH] = ACTIONS(6315),
    [anon_sym_LT_LT_DASH] = ACTIONS(6315),
    [anon_sym_COLON_EQ] = ACTIONS(6315),
    [anon_sym_DASH_GT] = ACTIONS(6317),
    [anon_sym_DASH_GT_GT] = ACTIONS(6319),
    [anon_sym_PIPE] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6323),
    [anon_sym_PIPE_PIPE] = ACTIONS(6325),
    [anon_sym_AMP_AMP] = ACTIONS(6327),
    [anon_sym_LT] = ACTIONS(6329),
    [anon_sym_LT_EQ] = ACTIONS(6331),
    [anon_sym_GT] = ACTIONS(6329),
    [anon_sym_GT_EQ] = ACTIONS(6331),
    [anon_sym_EQ_EQ] = ACTIONS(6331),
    [anon_sym_BANG_EQ] = ACTIONS(6331),
    [anon_sym_STAR] = ACTIONS(6333),
    [anon_sym_SLASH] = ACTIONS(6335),
    [anon_sym_STAR_STAR] = ACTIONS(6337),
    [anon_sym_CARET] = ACTIONS(6337),
    [aux_sym_binary_operator_token1] = ACTIONS(6339),
    [anon_sym_PIPE_GT] = ACTIONS(6339),
    [anon_sym_COLON] = ACTIONS(6341),
    [anon_sym_DOLLAR] = ACTIONS(6343),
    [anon_sym_AT] = ACTIONS(6343),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(6345),
    [sym__external_close_parenthesis] = ACTIONS(5345),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(6347),
    [sym__external_open_bracket2] = ACTIONS(6349),
    [sym__external_close_bracket2] = ACTIONS(5345),
  },
  [1685] = {
    [sym_call_arguments] = STATE(2808),
    [sym_subset_arguments] = STATE(2920),
    [sym_subset2_arguments] = STATE(2919),
    [sym__open_parenthesis] = STATE(1545),
    [sym__open_bracket] = STATE(1541),
    [sym__open_bracket2] = STATE(1539),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(6311),
    [anon_sym_DASH] = ACTIONS(6313),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6323),
    [anon_sym_PIPE_PIPE] = ACTIONS(6325),
    [anon_sym_AMP_AMP] = ACTIONS(6327),
    [anon_sym_LT] = ACTIONS(6329),
    [anon_sym_LT_EQ] = ACTIONS(6331),
    [anon_sym_GT] = ACTIONS(6329),
    [anon_sym_GT_EQ] = ACTIONS(6331),
    [anon_sym_EQ_EQ] = ACTIONS(6331),
    [anon_sym_BANG_EQ] = ACTIONS(6331),
    [anon_sym_STAR] = ACTIONS(6333),
    [anon_sym_SLASH] = ACTIONS(6335),
    [anon_sym_STAR_STAR] = ACTIONS(6337),
    [anon_sym_CARET] = ACTIONS(6337),
    [aux_sym_binary_operator_token1] = ACTIONS(6339),
    [anon_sym_PIPE_GT] = ACTIONS(6339),
    [anon_sym_COLON] = ACTIONS(6341),
    [anon_sym_DOLLAR] = ACTIONS(6343),
    [anon_sym_AT] = ACTIONS(6343),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(6345),
    [sym__external_close_parenthesis] = ACTIONS(5345),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(6347),
    [sym__external_open_bracket2] = ACTIONS(6349),
    [sym__external_close_bracket2] = ACTIONS(5345),
  },
  [1686] = {
    [sym_call_arguments] = STATE(2808),
    [sym_subset_arguments] = STATE(2920),
    [sym_subset2_arguments] = STATE(2919),
    [sym__open_parenthesis] = STATE(1545),
    [sym__open_bracket] = STATE(1541),
    [sym__open_bracket2] = STATE(1539),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(6311),
    [anon_sym_DASH] = ACTIONS(6313),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5347),
    [anon_sym_AMP] = ACTIONS(5347),
    [anon_sym_PIPE_PIPE] = ACTIONS(5345),
    [anon_sym_AMP_AMP] = ACTIONS(5345),
    [anon_sym_LT] = ACTIONS(6329),
    [anon_sym_LT_EQ] = ACTIONS(6331),
    [anon_sym_GT] = ACTIONS(6329),
    [anon_sym_GT_EQ] = ACTIONS(6331),
    [anon_sym_EQ_EQ] = ACTIONS(6331),
    [anon_sym_BANG_EQ] = ACTIONS(6331),
    [anon_sym_STAR] = ACTIONS(6333),
    [anon_sym_SLASH] = ACTIONS(6335),
    [anon_sym_STAR_STAR] = ACTIONS(6337),
    [anon_sym_CARET] = ACTIONS(6337),
    [aux_sym_binary_operator_token1] = ACTIONS(6339),
    [anon_sym_PIPE_GT] = ACTIONS(6339),
    [anon_sym_COLON] = ACTIONS(6341),
    [anon_sym_DOLLAR] = ACTIONS(6343),
    [anon_sym_AT] = ACTIONS(6343),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(6345),
    [sym__external_close_parenthesis] = ACTIONS(5345),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(6347),
    [sym__external_open_bracket2] = ACTIONS(6349),
    [sym__external_close_bracket2] = ACTIONS(5345),
  },
  [1687] = {
    [sym_call_arguments] = STATE(2808),
    [sym_subset_arguments] = STATE(2920),
    [sym_subset2_arguments] = STATE(2919),
    [sym__open_parenthesis] = STATE(1545),
    [sym__open_bracket] = STATE(1541),
    [sym__open_bracket2] = STATE(1539),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5345),
    [anon_sym_DASH] = ACTIONS(5347),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5347),
    [anon_sym_AMP] = ACTIONS(5347),
    [anon_sym_PIPE_PIPE] = ACTIONS(5345),
    [anon_sym_AMP_AMP] = ACTIONS(5345),
    [anon_sym_LT] = ACTIONS(5347),
    [anon_sym_LT_EQ] = ACTIONS(5345),
    [anon_sym_GT] = ACTIONS(5347),
    [anon_sym_GT_EQ] = ACTIONS(5345),
    [anon_sym_EQ_EQ] = ACTIONS(5345),
    [anon_sym_BANG_EQ] = ACTIONS(5345),
    [anon_sym_STAR] = ACTIONS(5347),
    [anon_sym_SLASH] = ACTIONS(5345),
    [anon_sym_STAR_STAR] = ACTIONS(6337),
    [anon_sym_CARET] = ACTIONS(6337),
    [aux_sym_binary_operator_token1] = ACTIONS(5345),
    [anon_sym_PIPE_GT] = ACTIONS(5345),
    [anon_sym_COLON] = ACTIONS(5347),
    [anon_sym_DOLLAR] = ACTIONS(6343),
    [anon_sym_AT] = ACTIONS(6343),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(6345),
    [sym__external_close_parenthesis] = ACTIONS(5345),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(6347),
    [sym__external_open_bracket2] = ACTIONS(6349),
    [sym__external_close_bracket2] = ACTIONS(5345),
  },
  [1688] = {
    [sym_call_arguments] = STATE(2845),
    [sym_subset_arguments] = STATE(2849),
    [sym_subset2_arguments] = STATE(2852),
    [sym__open_parenthesis] = STATE(1372),
    [sym__open_bracket] = STATE(1371),
    [sym__open_bracket2] = STATE(1370),
    [sym_identifier] = ACTIONS(5423),
    [anon_sym_BSLASH] = ACTIONS(5421),
    [anon_sym_function] = ACTIONS(5423),
    [anon_sym_EQ] = ACTIONS(6181),
    [anon_sym_if] = ACTIONS(5423),
    [anon_sym_for] = ACTIONS(5423),
    [anon_sym_while] = ACTIONS(5423),
    [anon_sym_repeat] = ACTIONS(5423),
    [anon_sym_QMARK] = ACTIONS(5421),
    [anon_sym_TILDE] = ACTIONS(6183),
    [anon_sym_BANG] = ACTIONS(5423),
    [anon_sym_PLUS] = ACTIONS(6185),
    [anon_sym_DASH] = ACTIONS(6187),
    [anon_sym_LT_DASH] = ACTIONS(6189),
    [anon_sym_LT_LT_DASH] = ACTIONS(6189),
    [anon_sym_COLON_EQ] = ACTIONS(6189),
    [anon_sym_DASH_GT] = ACTIONS(6191),
    [anon_sym_DASH_GT_GT] = ACTIONS(6193),
    [anon_sym_PIPE] = ACTIONS(6195),
    [anon_sym_AMP] = ACTIONS(6197),
    [anon_sym_PIPE_PIPE] = ACTIONS(6199),
    [anon_sym_AMP_AMP] = ACTIONS(6201),
    [anon_sym_LT] = ACTIONS(6203),
    [anon_sym_LT_EQ] = ACTIONS(6205),
    [anon_sym_GT] = ACTIONS(6203),
    [anon_sym_GT_EQ] = ACTIONS(6205),
    [anon_sym_EQ_EQ] = ACTIONS(6205),
    [anon_sym_BANG_EQ] = ACTIONS(6205),
    [anon_sym_STAR] = ACTIONS(6207),
    [anon_sym_SLASH] = ACTIONS(6209),
    [anon_sym_STAR_STAR] = ACTIONS(6211),
    [anon_sym_CARET] = ACTIONS(6211),
    [aux_sym_binary_operator_token1] = ACTIONS(6213),
    [anon_sym_PIPE_GT] = ACTIONS(6213),
    [anon_sym_COLON] = ACTIONS(6215),
    [anon_sym_DOLLAR] = ACTIONS(6217),
    [anon_sym_AT] = ACTIONS(6217),
    [aux_sym__hex_literal_token1] = ACTIONS(5421),
    [sym__number_literal] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5421),
    [anon_sym_DQUOTE] = ACTIONS(5421),
    [sym_return] = ACTIONS(5423),
    [sym_next] = ACTIONS(5423),
    [sym_break] = ACTIONS(5423),
    [sym_true] = ACTIONS(5423),
    [sym_false] = ACTIONS(5423),
    [sym_null] = ACTIONS(5423),
    [sym_inf] = ACTIONS(5423),
    [sym_nan] = ACTIONS(5423),
    [anon_sym_NA] = ACTIONS(5423),
    [anon_sym_NA_integer_] = ACTIONS(5423),
    [anon_sym_NA_real_] = ACTIONS(5423),
    [anon_sym_NA_complex_] = ACTIONS(5423),
    [anon_sym_NA_character_] = ACTIONS(5423),
    [sym_dots] = ACTIONS(5423),
    [sym_dot_dot_i] = ACTIONS(5421),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5421),
    [sym__newline] = ACTIONS(5421),
    [sym__raw_string_literal] = ACTIONS(5421),
    [sym__external_else] = ACTIONS(5421),
    [sym__external_open_parenthesis] = ACTIONS(6221),
    [sym__external_close_parenthesis] = ACTIONS(5421),
    [sym__external_open_brace] = ACTIONS(5421),
    [sym__external_open_bracket] = ACTIONS(6223),
    [sym__external_open_bracket2] = ACTIONS(6225),
  },
  [1689] = {
    [sym_call_arguments] = STATE(2845),
    [sym_subset_arguments] = STATE(2849),
    [sym_subset2_arguments] = STATE(2852),
    [sym__open_parenthesis] = STATE(1372),
    [sym__open_bracket] = STATE(1371),
    [sym__open_bracket2] = STATE(1370),
    [sym_identifier] = ACTIONS(5419),
    [anon_sym_BSLASH] = ACTIONS(5417),
    [anon_sym_function] = ACTIONS(5419),
    [anon_sym_EQ] = ACTIONS(6181),
    [anon_sym_if] = ACTIONS(5419),
    [anon_sym_for] = ACTIONS(5419),
    [anon_sym_while] = ACTIONS(5419),
    [anon_sym_repeat] = ACTIONS(5419),
    [anon_sym_QMARK] = ACTIONS(5417),
    [anon_sym_TILDE] = ACTIONS(6183),
    [anon_sym_BANG] = ACTIONS(5419),
    [anon_sym_PLUS] = ACTIONS(6185),
    [anon_sym_DASH] = ACTIONS(6187),
    [anon_sym_LT_DASH] = ACTIONS(6189),
    [anon_sym_LT_LT_DASH] = ACTIONS(6189),
    [anon_sym_COLON_EQ] = ACTIONS(6189),
    [anon_sym_DASH_GT] = ACTIONS(6191),
    [anon_sym_DASH_GT_GT] = ACTIONS(6193),
    [anon_sym_PIPE] = ACTIONS(6195),
    [anon_sym_AMP] = ACTIONS(6197),
    [anon_sym_PIPE_PIPE] = ACTIONS(6199),
    [anon_sym_AMP_AMP] = ACTIONS(6201),
    [anon_sym_LT] = ACTIONS(6203),
    [anon_sym_LT_EQ] = ACTIONS(6205),
    [anon_sym_GT] = ACTIONS(6203),
    [anon_sym_GT_EQ] = ACTIONS(6205),
    [anon_sym_EQ_EQ] = ACTIONS(6205),
    [anon_sym_BANG_EQ] = ACTIONS(6205),
    [anon_sym_STAR] = ACTIONS(6207),
    [anon_sym_SLASH] = ACTIONS(6209),
    [anon_sym_STAR_STAR] = ACTIONS(6211),
    [anon_sym_CARET] = ACTIONS(6211),
    [aux_sym_binary_operator_token1] = ACTIONS(6213),
    [anon_sym_PIPE_GT] = ACTIONS(6213),
    [anon_sym_COLON] = ACTIONS(6215),
    [anon_sym_DOLLAR] = ACTIONS(6217),
    [anon_sym_AT] = ACTIONS(6217),
    [aux_sym__hex_literal_token1] = ACTIONS(5417),
    [sym__number_literal] = ACTIONS(5419),
    [anon_sym_SQUOTE] = ACTIONS(5417),
    [anon_sym_DQUOTE] = ACTIONS(5417),
    [sym_return] = ACTIONS(5419),
    [sym_next] = ACTIONS(5419),
    [sym_break] = ACTIONS(5419),
    [sym_true] = ACTIONS(5419),
    [sym_false] = ACTIONS(5419),
    [sym_null] = ACTIONS(5419),
    [sym_inf] = ACTIONS(5419),
    [sym_nan] = ACTIONS(5419),
    [anon_sym_NA] = ACTIONS(5419),
    [anon_sym_NA_integer_] = ACTIONS(5419),
    [anon_sym_NA_real_] = ACTIONS(5419),
    [anon_sym_NA_complex_] = ACTIONS(5419),
    [anon_sym_NA_character_] = ACTIONS(5419),
    [sym_dots] = ACTIONS(5419),
    [sym_dot_dot_i] = ACTIONS(5417),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5417),
    [sym__newline] = ACTIONS(5417),
    [sym__raw_string_literal] = ACTIONS(5417),
    [sym__external_else] = ACTIONS(5417),
    [sym__external_open_parenthesis] = ACTIONS(6221),
    [sym__external_close_parenthesis] = ACTIONS(5417),
    [sym__external_open_brace] = ACTIONS(5417),
    [sym__external_open_bracket] = ACTIONS(6223),
    [sym__external_open_bracket2] = ACTIONS(6225),
  },
  [1690] = {
    [sym_call_arguments] = STATE(2808),
    [sym_subset_arguments] = STATE(2920),
    [sym_subset2_arguments] = STATE(2919),
    [sym__open_parenthesis] = STATE(1545),
    [sym__open_bracket] = STATE(1541),
    [sym__open_bracket2] = STATE(1539),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(6307),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(6309),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(6311),
    [anon_sym_DASH] = ACTIONS(6313),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(6317),
    [anon_sym_DASH_GT_GT] = ACTIONS(6319),
    [anon_sym_PIPE] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6323),
    [anon_sym_PIPE_PIPE] = ACTIONS(6325),
    [anon_sym_AMP_AMP] = ACTIONS(6327),
    [anon_sym_LT] = ACTIONS(6329),
    [anon_sym_LT_EQ] = ACTIONS(6331),
    [anon_sym_GT] = ACTIONS(6329),
    [anon_sym_GT_EQ] = ACTIONS(6331),
    [anon_sym_EQ_EQ] = ACTIONS(6331),
    [anon_sym_BANG_EQ] = ACTIONS(6331),
    [anon_sym_STAR] = ACTIONS(6333),
    [anon_sym_SLASH] = ACTIONS(6335),
    [anon_sym_STAR_STAR] = ACTIONS(6337),
    [anon_sym_CARET] = ACTIONS(6337),
    [aux_sym_binary_operator_token1] = ACTIONS(6339),
    [anon_sym_PIPE_GT] = ACTIONS(6339),
    [anon_sym_COLON] = ACTIONS(6341),
    [anon_sym_DOLLAR] = ACTIONS(6343),
    [anon_sym_AT] = ACTIONS(6343),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6345),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6347),
    [sym__external_open_bracket2] = ACTIONS(6349),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [1691] = {
    [sym_call_arguments] = STATE(2777),
    [sym_subset_arguments] = STATE(2779),
    [sym_subset2_arguments] = STATE(2786),
    [sym__open_parenthesis] = STATE(1411),
    [sym__open_bracket] = STATE(1409),
    [sym__open_bracket2] = STATE(1407),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(6497),
    [anon_sym_DASH] = ACTIONS(6499),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(6509),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(6513),
    [anon_sym_LT] = ACTIONS(6515),
    [anon_sym_LT_EQ] = ACTIONS(6517),
    [anon_sym_GT] = ACTIONS(6515),
    [anon_sym_GT_EQ] = ACTIONS(6517),
    [anon_sym_EQ_EQ] = ACTIONS(6517),
    [anon_sym_BANG_EQ] = ACTIONS(6517),
    [anon_sym_STAR] = ACTIONS(6519),
    [anon_sym_SLASH] = ACTIONS(6521),
    [anon_sym_STAR_STAR] = ACTIONS(6523),
    [anon_sym_CARET] = ACTIONS(6523),
    [aux_sym_binary_operator_token1] = ACTIONS(6525),
    [anon_sym_PIPE_GT] = ACTIONS(6525),
    [anon_sym_COLON] = ACTIONS(6527),
    [anon_sym_DOLLAR] = ACTIONS(6529),
    [anon_sym_AT] = ACTIONS(6529),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6531),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6533),
    [sym__external_open_bracket2] = ACTIONS(6535),
  },
  [1692] = {
    [sym_call_arguments] = STATE(2808),
    [sym_subset_arguments] = STATE(2920),
    [sym_subset2_arguments] = STATE(2919),
    [sym__open_parenthesis] = STATE(1545),
    [sym__open_bracket] = STATE(1541),
    [sym__open_bracket2] = STATE(1539),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(6307),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(6309),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(6311),
    [anon_sym_DASH] = ACTIONS(6313),
    [anon_sym_LT_DASH] = ACTIONS(6315),
    [anon_sym_LT_LT_DASH] = ACTIONS(6315),
    [anon_sym_COLON_EQ] = ACTIONS(6315),
    [anon_sym_DASH_GT] = ACTIONS(6317),
    [anon_sym_DASH_GT_GT] = ACTIONS(6319),
    [anon_sym_PIPE] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6323),
    [anon_sym_PIPE_PIPE] = ACTIONS(6325),
    [anon_sym_AMP_AMP] = ACTIONS(6327),
    [anon_sym_LT] = ACTIONS(6329),
    [anon_sym_LT_EQ] = ACTIONS(6331),
    [anon_sym_GT] = ACTIONS(6329),
    [anon_sym_GT_EQ] = ACTIONS(6331),
    [anon_sym_EQ_EQ] = ACTIONS(6331),
    [anon_sym_BANG_EQ] = ACTIONS(6331),
    [anon_sym_STAR] = ACTIONS(6333),
    [anon_sym_SLASH] = ACTIONS(6335),
    [anon_sym_STAR_STAR] = ACTIONS(6337),
    [anon_sym_CARET] = ACTIONS(6337),
    [aux_sym_binary_operator_token1] = ACTIONS(6339),
    [anon_sym_PIPE_GT] = ACTIONS(6339),
    [anon_sym_COLON] = ACTIONS(6341),
    [anon_sym_DOLLAR] = ACTIONS(6343),
    [anon_sym_AT] = ACTIONS(6343),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6345),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6347),
    [sym__external_open_bracket2] = ACTIONS(6349),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [1693] = {
    [sym_call_arguments] = STATE(2845),
    [sym_subset_arguments] = STATE(2849),
    [sym_subset2_arguments] = STATE(2852),
    [sym__open_parenthesis] = STATE(1372),
    [sym__open_bracket] = STATE(1371),
    [sym__open_bracket2] = STATE(1370),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_BSLASH] = ACTIONS(5413),
    [anon_sym_function] = ACTIONS(5415),
    [anon_sym_EQ] = ACTIONS(6181),
    [anon_sym_if] = ACTIONS(5415),
    [anon_sym_for] = ACTIONS(5415),
    [anon_sym_while] = ACTIONS(5415),
    [anon_sym_repeat] = ACTIONS(5415),
    [anon_sym_QMARK] = ACTIONS(5413),
    [anon_sym_TILDE] = ACTIONS(6183),
    [anon_sym_BANG] = ACTIONS(5415),
    [anon_sym_PLUS] = ACTIONS(6185),
    [anon_sym_DASH] = ACTIONS(6187),
    [anon_sym_LT_DASH] = ACTIONS(6189),
    [anon_sym_LT_LT_DASH] = ACTIONS(6189),
    [anon_sym_COLON_EQ] = ACTIONS(6189),
    [anon_sym_DASH_GT] = ACTIONS(6191),
    [anon_sym_DASH_GT_GT] = ACTIONS(6193),
    [anon_sym_PIPE] = ACTIONS(6195),
    [anon_sym_AMP] = ACTIONS(6197),
    [anon_sym_PIPE_PIPE] = ACTIONS(6199),
    [anon_sym_AMP_AMP] = ACTIONS(6201),
    [anon_sym_LT] = ACTIONS(6203),
    [anon_sym_LT_EQ] = ACTIONS(6205),
    [anon_sym_GT] = ACTIONS(6203),
    [anon_sym_GT_EQ] = ACTIONS(6205),
    [anon_sym_EQ_EQ] = ACTIONS(6205),
    [anon_sym_BANG_EQ] = ACTIONS(6205),
    [anon_sym_STAR] = ACTIONS(6207),
    [anon_sym_SLASH] = ACTIONS(6209),
    [anon_sym_STAR_STAR] = ACTIONS(6211),
    [anon_sym_CARET] = ACTIONS(6211),
    [aux_sym_binary_operator_token1] = ACTIONS(6213),
    [anon_sym_PIPE_GT] = ACTIONS(6213),
    [anon_sym_COLON] = ACTIONS(6215),
    [anon_sym_DOLLAR] = ACTIONS(6217),
    [anon_sym_AT] = ACTIONS(6217),
    [aux_sym__hex_literal_token1] = ACTIONS(5413),
    [sym__number_literal] = ACTIONS(5415),
    [anon_sym_SQUOTE] = ACTIONS(5413),
    [anon_sym_DQUOTE] = ACTIONS(5413),
    [sym_return] = ACTIONS(5415),
    [sym_next] = ACTIONS(5415),
    [sym_break] = ACTIONS(5415),
    [sym_true] = ACTIONS(5415),
    [sym_false] = ACTIONS(5415),
    [sym_null] = ACTIONS(5415),
    [sym_inf] = ACTIONS(5415),
    [sym_nan] = ACTIONS(5415),
    [anon_sym_NA] = ACTIONS(5415),
    [anon_sym_NA_integer_] = ACTIONS(5415),
    [anon_sym_NA_real_] = ACTIONS(5415),
    [anon_sym_NA_complex_] = ACTIONS(5415),
    [anon_sym_NA_character_] = ACTIONS(5415),
    [sym_dots] = ACTIONS(5415),
    [sym_dot_dot_i] = ACTIONS(5413),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5413),
    [sym__newline] = ACTIONS(5413),
    [sym__raw_string_literal] = ACTIONS(5413),
    [sym__external_else] = ACTIONS(5413),
    [sym__external_open_parenthesis] = ACTIONS(6221),
    [sym__external_close_parenthesis] = ACTIONS(5413),
    [sym__external_open_brace] = ACTIONS(5413),
    [sym__external_open_bracket] = ACTIONS(6223),
    [sym__external_open_bracket2] = ACTIONS(6225),
  },
  [1694] = {
    [sym_call_arguments] = STATE(2808),
    [sym_subset_arguments] = STATE(2920),
    [sym_subset2_arguments] = STATE(2919),
    [sym__open_parenthesis] = STATE(1545),
    [sym__open_bracket] = STATE(1541),
    [sym__open_bracket2] = STATE(1539),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(6311),
    [anon_sym_DASH] = ACTIONS(6313),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6323),
    [anon_sym_PIPE_PIPE] = ACTIONS(6325),
    [anon_sym_AMP_AMP] = ACTIONS(6327),
    [anon_sym_LT] = ACTIONS(6329),
    [anon_sym_LT_EQ] = ACTIONS(6331),
    [anon_sym_GT] = ACTIONS(6329),
    [anon_sym_GT_EQ] = ACTIONS(6331),
    [anon_sym_EQ_EQ] = ACTIONS(6331),
    [anon_sym_BANG_EQ] = ACTIONS(6331),
    [anon_sym_STAR] = ACTIONS(6333),
    [anon_sym_SLASH] = ACTIONS(6335),
    [anon_sym_STAR_STAR] = ACTIONS(6337),
    [anon_sym_CARET] = ACTIONS(6337),
    [aux_sym_binary_operator_token1] = ACTIONS(6339),
    [anon_sym_PIPE_GT] = ACTIONS(6339),
    [anon_sym_COLON] = ACTIONS(6341),
    [anon_sym_DOLLAR] = ACTIONS(6343),
    [anon_sym_AT] = ACTIONS(6343),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6345),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6347),
    [sym__external_open_bracket2] = ACTIONS(6349),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [1695] = {
    [sym_call_arguments] = STATE(2845),
    [sym_subset_arguments] = STATE(2849),
    [sym_subset2_arguments] = STATE(2852),
    [sym__open_parenthesis] = STATE(1372),
    [sym__open_bracket] = STATE(1371),
    [sym__open_bracket2] = STATE(1370),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(6211),
    [anon_sym_CARET] = ACTIONS(6211),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(5261),
    [anon_sym_DOLLAR] = ACTIONS(6217),
    [anon_sym_AT] = ACTIONS(6217),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6221),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6223),
    [sym__external_open_bracket2] = ACTIONS(6225),
  },
  [1696] = {
    [sym_call_arguments] = STATE(2808),
    [sym_subset_arguments] = STATE(2920),
    [sym_subset2_arguments] = STATE(2919),
    [sym__open_parenthesis] = STATE(1545),
    [sym__open_bracket] = STATE(1541),
    [sym__open_bracket2] = STATE(1539),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(6333),
    [anon_sym_SLASH] = ACTIONS(6335),
    [anon_sym_STAR_STAR] = ACTIONS(6337),
    [anon_sym_CARET] = ACTIONS(6337),
    [aux_sym_binary_operator_token1] = ACTIONS(6339),
    [anon_sym_PIPE_GT] = ACTIONS(6339),
    [anon_sym_COLON] = ACTIONS(6341),
    [anon_sym_DOLLAR] = ACTIONS(6343),
    [anon_sym_AT] = ACTIONS(6343),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6345),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6347),
    [sym__external_open_bracket2] = ACTIONS(6349),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [1697] = {
    [sym_call_arguments] = STATE(2845),
    [sym_subset_arguments] = STATE(2849),
    [sym_subset2_arguments] = STATE(2852),
    [sym__open_parenthesis] = STATE(1372),
    [sym__open_bracket] = STATE(1371),
    [sym__open_bracket2] = STATE(1370),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(6211),
    [anon_sym_CARET] = ACTIONS(6211),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(6215),
    [anon_sym_DOLLAR] = ACTIONS(6217),
    [anon_sym_AT] = ACTIONS(6217),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6221),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6223),
    [sym__external_open_bracket2] = ACTIONS(6225),
  },
  [1698] = {
    [sym_call_arguments] = STATE(2808),
    [sym_subset_arguments] = STATE(2920),
    [sym_subset2_arguments] = STATE(2919),
    [sym__open_parenthesis] = STATE(1545),
    [sym__open_bracket] = STATE(1541),
    [sym__open_bracket2] = STATE(1539),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(6307),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(6309),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(6311),
    [anon_sym_DASH] = ACTIONS(6313),
    [anon_sym_LT_DASH] = ACTIONS(6315),
    [anon_sym_LT_LT_DASH] = ACTIONS(6315),
    [anon_sym_COLON_EQ] = ACTIONS(6315),
    [anon_sym_DASH_GT] = ACTIONS(6317),
    [anon_sym_DASH_GT_GT] = ACTIONS(6319),
    [anon_sym_PIPE] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6323),
    [anon_sym_PIPE_PIPE] = ACTIONS(6325),
    [anon_sym_AMP_AMP] = ACTIONS(6327),
    [anon_sym_LT] = ACTIONS(6329),
    [anon_sym_LT_EQ] = ACTIONS(6331),
    [anon_sym_GT] = ACTIONS(6329),
    [anon_sym_GT_EQ] = ACTIONS(6331),
    [anon_sym_EQ_EQ] = ACTIONS(6331),
    [anon_sym_BANG_EQ] = ACTIONS(6331),
    [anon_sym_STAR] = ACTIONS(6333),
    [anon_sym_SLASH] = ACTIONS(6335),
    [anon_sym_STAR_STAR] = ACTIONS(6337),
    [anon_sym_CARET] = ACTIONS(6337),
    [aux_sym_binary_operator_token1] = ACTIONS(6339),
    [anon_sym_PIPE_GT] = ACTIONS(6339),
    [anon_sym_COLON] = ACTIONS(6341),
    [anon_sym_DOLLAR] = ACTIONS(6343),
    [anon_sym_AT] = ACTIONS(6343),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6345),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6347),
    [sym__external_open_bracket2] = ACTIONS(6349),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [1699] = {
    [sym_call_arguments] = STATE(2845),
    [sym_subset_arguments] = STATE(2849),
    [sym_subset2_arguments] = STATE(2852),
    [sym__open_parenthesis] = STATE(1372),
    [sym__open_bracket] = STATE(1371),
    [sym__open_bracket2] = STATE(1370),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(6211),
    [anon_sym_CARET] = ACTIONS(6211),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(5261),
    [anon_sym_DOLLAR] = ACTIONS(6217),
    [anon_sym_AT] = ACTIONS(6217),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6221),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6223),
    [sym__external_open_bracket2] = ACTIONS(6225),
  },
  [1700] = {
    [sym_call_arguments] = STATE(2808),
    [sym_subset_arguments] = STATE(2920),
    [sym_subset2_arguments] = STATE(2919),
    [sym__open_parenthesis] = STATE(1545),
    [sym__open_bracket] = STATE(1541),
    [sym__open_bracket2] = STATE(1539),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(6309),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(6311),
    [anon_sym_DASH] = ACTIONS(6313),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6323),
    [anon_sym_PIPE_PIPE] = ACTIONS(6325),
    [anon_sym_AMP_AMP] = ACTIONS(6327),
    [anon_sym_LT] = ACTIONS(6329),
    [anon_sym_LT_EQ] = ACTIONS(6331),
    [anon_sym_GT] = ACTIONS(6329),
    [anon_sym_GT_EQ] = ACTIONS(6331),
    [anon_sym_EQ_EQ] = ACTIONS(6331),
    [anon_sym_BANG_EQ] = ACTIONS(6331),
    [anon_sym_STAR] = ACTIONS(6333),
    [anon_sym_SLASH] = ACTIONS(6335),
    [anon_sym_STAR_STAR] = ACTIONS(6337),
    [anon_sym_CARET] = ACTIONS(6337),
    [aux_sym_binary_operator_token1] = ACTIONS(6339),
    [anon_sym_PIPE_GT] = ACTIONS(6339),
    [anon_sym_COLON] = ACTIONS(6341),
    [anon_sym_DOLLAR] = ACTIONS(6343),
    [anon_sym_AT] = ACTIONS(6343),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6345),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6347),
    [sym__external_open_bracket2] = ACTIONS(6349),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [1701] = {
    [sym_call_arguments] = STATE(2845),
    [sym_subset_arguments] = STATE(2849),
    [sym_subset2_arguments] = STATE(2852),
    [sym__open_parenthesis] = STATE(1372),
    [sym__open_bracket] = STATE(1371),
    [sym__open_bracket2] = STATE(1370),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(6211),
    [anon_sym_CARET] = ACTIONS(6211),
    [aux_sym_binary_operator_token1] = ACTIONS(6213),
    [anon_sym_PIPE_GT] = ACTIONS(6213),
    [anon_sym_COLON] = ACTIONS(6215),
    [anon_sym_DOLLAR] = ACTIONS(6217),
    [anon_sym_AT] = ACTIONS(6217),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6221),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6223),
    [sym__external_open_bracket2] = ACTIONS(6225),
  },
  [1702] = {
    [sym_call_arguments] = STATE(2808),
    [sym_subset_arguments] = STATE(2920),
    [sym_subset2_arguments] = STATE(2919),
    [sym__open_parenthesis] = STATE(1545),
    [sym__open_bracket] = STATE(1541),
    [sym__open_bracket2] = STATE(1539),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(6311),
    [anon_sym_DASH] = ACTIONS(6313),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(6323),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(6327),
    [anon_sym_LT] = ACTIONS(6329),
    [anon_sym_LT_EQ] = ACTIONS(6331),
    [anon_sym_GT] = ACTIONS(6329),
    [anon_sym_GT_EQ] = ACTIONS(6331),
    [anon_sym_EQ_EQ] = ACTIONS(6331),
    [anon_sym_BANG_EQ] = ACTIONS(6331),
    [anon_sym_STAR] = ACTIONS(6333),
    [anon_sym_SLASH] = ACTIONS(6335),
    [anon_sym_STAR_STAR] = ACTIONS(6337),
    [anon_sym_CARET] = ACTIONS(6337),
    [aux_sym_binary_operator_token1] = ACTIONS(6339),
    [anon_sym_PIPE_GT] = ACTIONS(6339),
    [anon_sym_COLON] = ACTIONS(6341),
    [anon_sym_DOLLAR] = ACTIONS(6343),
    [anon_sym_AT] = ACTIONS(6343),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6345),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6347),
    [sym__external_open_bracket2] = ACTIONS(6349),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [1703] = {
    [sym_call_arguments] = STATE(2845),
    [sym_subset_arguments] = STATE(2849),
    [sym_subset2_arguments] = STATE(2852),
    [sym__open_parenthesis] = STATE(1372),
    [sym__open_bracket] = STATE(1371),
    [sym__open_bracket2] = STATE(1370),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(6185),
    [anon_sym_DASH] = ACTIONS(6187),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(6207),
    [anon_sym_SLASH] = ACTIONS(6209),
    [anon_sym_STAR_STAR] = ACTIONS(6211),
    [anon_sym_CARET] = ACTIONS(6211),
    [aux_sym_binary_operator_token1] = ACTIONS(6213),
    [anon_sym_PIPE_GT] = ACTIONS(6213),
    [anon_sym_COLON] = ACTIONS(6215),
    [anon_sym_DOLLAR] = ACTIONS(6217),
    [anon_sym_AT] = ACTIONS(6217),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6221),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6223),
    [sym__external_open_bracket2] = ACTIONS(6225),
  },
  [1704] = {
    [sym_call_arguments] = STATE(2808),
    [sym_subset_arguments] = STATE(2920),
    [sym_subset2_arguments] = STATE(2919),
    [sym__open_parenthesis] = STATE(1545),
    [sym__open_bracket] = STATE(1541),
    [sym__open_bracket2] = STATE(1539),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(6311),
    [anon_sym_DASH] = ACTIONS(6313),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(6329),
    [anon_sym_LT_EQ] = ACTIONS(6331),
    [anon_sym_GT] = ACTIONS(6329),
    [anon_sym_GT_EQ] = ACTIONS(6331),
    [anon_sym_EQ_EQ] = ACTIONS(6331),
    [anon_sym_BANG_EQ] = ACTIONS(6331),
    [anon_sym_STAR] = ACTIONS(6333),
    [anon_sym_SLASH] = ACTIONS(6335),
    [anon_sym_STAR_STAR] = ACTIONS(6337),
    [anon_sym_CARET] = ACTIONS(6337),
    [aux_sym_binary_operator_token1] = ACTIONS(6339),
    [anon_sym_PIPE_GT] = ACTIONS(6339),
    [anon_sym_COLON] = ACTIONS(6341),
    [anon_sym_DOLLAR] = ACTIONS(6343),
    [anon_sym_AT] = ACTIONS(6343),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6345),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6347),
    [sym__external_open_bracket2] = ACTIONS(6349),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [1705] = {
    [sym_call_arguments] = STATE(2845),
    [sym_subset_arguments] = STATE(2849),
    [sym_subset2_arguments] = STATE(2852),
    [sym__open_parenthesis] = STATE(1372),
    [sym__open_bracket] = STATE(1371),
    [sym__open_bracket2] = STATE(1370),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(6185),
    [anon_sym_DASH] = ACTIONS(6187),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(6203),
    [anon_sym_LT_EQ] = ACTIONS(6205),
    [anon_sym_GT] = ACTIONS(6203),
    [anon_sym_GT_EQ] = ACTIONS(6205),
    [anon_sym_EQ_EQ] = ACTIONS(6205),
    [anon_sym_BANG_EQ] = ACTIONS(6205),
    [anon_sym_STAR] = ACTIONS(6207),
    [anon_sym_SLASH] = ACTIONS(6209),
    [anon_sym_STAR_STAR] = ACTIONS(6211),
    [anon_sym_CARET] = ACTIONS(6211),
    [aux_sym_binary_operator_token1] = ACTIONS(6213),
    [anon_sym_PIPE_GT] = ACTIONS(6213),
    [anon_sym_COLON] = ACTIONS(6215),
    [anon_sym_DOLLAR] = ACTIONS(6217),
    [anon_sym_AT] = ACTIONS(6217),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6221),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6223),
    [sym__external_open_bracket2] = ACTIONS(6225),
  },
  [1706] = {
    [sym_call_arguments] = STATE(2808),
    [sym_subset_arguments] = STATE(2920),
    [sym_subset2_arguments] = STATE(2919),
    [sym__open_parenthesis] = STATE(1545),
    [sym__open_bracket] = STATE(1541),
    [sym__open_bracket2] = STATE(1539),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(6311),
    [anon_sym_DASH] = ACTIONS(6313),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(6333),
    [anon_sym_SLASH] = ACTIONS(6335),
    [anon_sym_STAR_STAR] = ACTIONS(6337),
    [anon_sym_CARET] = ACTIONS(6337),
    [aux_sym_binary_operator_token1] = ACTIONS(6339),
    [anon_sym_PIPE_GT] = ACTIONS(6339),
    [anon_sym_COLON] = ACTIONS(6341),
    [anon_sym_DOLLAR] = ACTIONS(6343),
    [anon_sym_AT] = ACTIONS(6343),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6345),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6347),
    [sym__external_open_bracket2] = ACTIONS(6349),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [1707] = {
    [sym_call_arguments] = STATE(2845),
    [sym_subset_arguments] = STATE(2849),
    [sym_subset2_arguments] = STATE(2852),
    [sym__open_parenthesis] = STATE(1372),
    [sym__open_bracket] = STATE(1371),
    [sym__open_bracket2] = STATE(1370),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(6185),
    [anon_sym_DASH] = ACTIONS(6187),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(6197),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(6201),
    [anon_sym_LT] = ACTIONS(6203),
    [anon_sym_LT_EQ] = ACTIONS(6205),
    [anon_sym_GT] = ACTIONS(6203),
    [anon_sym_GT_EQ] = ACTIONS(6205),
    [anon_sym_EQ_EQ] = ACTIONS(6205),
    [anon_sym_BANG_EQ] = ACTIONS(6205),
    [anon_sym_STAR] = ACTIONS(6207),
    [anon_sym_SLASH] = ACTIONS(6209),
    [anon_sym_STAR_STAR] = ACTIONS(6211),
    [anon_sym_CARET] = ACTIONS(6211),
    [aux_sym_binary_operator_token1] = ACTIONS(6213),
    [anon_sym_PIPE_GT] = ACTIONS(6213),
    [anon_sym_COLON] = ACTIONS(6215),
    [anon_sym_DOLLAR] = ACTIONS(6217),
    [anon_sym_AT] = ACTIONS(6217),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6221),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6223),
    [sym__external_open_bracket2] = ACTIONS(6225),
  },
  [1708] = {
    [sym_call_arguments] = STATE(2808),
    [sym_subset_arguments] = STATE(2920),
    [sym_subset2_arguments] = STATE(2919),
    [sym__open_parenthesis] = STATE(1545),
    [sym__open_bracket] = STATE(1541),
    [sym__open_bracket2] = STATE(1539),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(6337),
    [anon_sym_CARET] = ACTIONS(6337),
    [aux_sym_binary_operator_token1] = ACTIONS(6339),
    [anon_sym_PIPE_GT] = ACTIONS(6339),
    [anon_sym_COLON] = ACTIONS(6341),
    [anon_sym_DOLLAR] = ACTIONS(6343),
    [anon_sym_AT] = ACTIONS(6343),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6345),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6347),
    [sym__external_open_bracket2] = ACTIONS(6349),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [1709] = {
    [sym_call_arguments] = STATE(2845),
    [sym_subset_arguments] = STATE(2849),
    [sym_subset2_arguments] = STATE(2852),
    [sym__open_parenthesis] = STATE(1372),
    [sym__open_bracket] = STATE(1371),
    [sym__open_bracket2] = STATE(1370),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(6183),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(6185),
    [anon_sym_DASH] = ACTIONS(6187),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(6195),
    [anon_sym_AMP] = ACTIONS(6197),
    [anon_sym_PIPE_PIPE] = ACTIONS(6199),
    [anon_sym_AMP_AMP] = ACTIONS(6201),
    [anon_sym_LT] = ACTIONS(6203),
    [anon_sym_LT_EQ] = ACTIONS(6205),
    [anon_sym_GT] = ACTIONS(6203),
    [anon_sym_GT_EQ] = ACTIONS(6205),
    [anon_sym_EQ_EQ] = ACTIONS(6205),
    [anon_sym_BANG_EQ] = ACTIONS(6205),
    [anon_sym_STAR] = ACTIONS(6207),
    [anon_sym_SLASH] = ACTIONS(6209),
    [anon_sym_STAR_STAR] = ACTIONS(6211),
    [anon_sym_CARET] = ACTIONS(6211),
    [aux_sym_binary_operator_token1] = ACTIONS(6213),
    [anon_sym_PIPE_GT] = ACTIONS(6213),
    [anon_sym_COLON] = ACTIONS(6215),
    [anon_sym_DOLLAR] = ACTIONS(6217),
    [anon_sym_AT] = ACTIONS(6217),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6221),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6223),
    [sym__external_open_bracket2] = ACTIONS(6225),
  },
  [1710] = {
    [sym_call_arguments] = STATE(2808),
    [sym_subset_arguments] = STATE(2920),
    [sym_subset2_arguments] = STATE(2919),
    [sym__open_parenthesis] = STATE(1545),
    [sym__open_bracket] = STATE(1541),
    [sym__open_bracket2] = STATE(1539),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(6337),
    [anon_sym_CARET] = ACTIONS(6337),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(5351),
    [anon_sym_DOLLAR] = ACTIONS(6343),
    [anon_sym_AT] = ACTIONS(6343),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6345),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6347),
    [sym__external_open_bracket2] = ACTIONS(6349),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [1711] = {
    [sym_call_arguments] = STATE(2845),
    [sym_subset_arguments] = STATE(2849),
    [sym_subset2_arguments] = STATE(2852),
    [sym__open_parenthesis] = STATE(1372),
    [sym__open_bracket] = STATE(1371),
    [sym__open_bracket2] = STATE(1370),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(6181),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(6183),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(6185),
    [anon_sym_DASH] = ACTIONS(6187),
    [anon_sym_LT_DASH] = ACTIONS(6189),
    [anon_sym_LT_LT_DASH] = ACTIONS(6189),
    [anon_sym_COLON_EQ] = ACTIONS(6189),
    [anon_sym_DASH_GT] = ACTIONS(6191),
    [anon_sym_DASH_GT_GT] = ACTIONS(6193),
    [anon_sym_PIPE] = ACTIONS(6195),
    [anon_sym_AMP] = ACTIONS(6197),
    [anon_sym_PIPE_PIPE] = ACTIONS(6199),
    [anon_sym_AMP_AMP] = ACTIONS(6201),
    [anon_sym_LT] = ACTIONS(6203),
    [anon_sym_LT_EQ] = ACTIONS(6205),
    [anon_sym_GT] = ACTIONS(6203),
    [anon_sym_GT_EQ] = ACTIONS(6205),
    [anon_sym_EQ_EQ] = ACTIONS(6205),
    [anon_sym_BANG_EQ] = ACTIONS(6205),
    [anon_sym_STAR] = ACTIONS(6207),
    [anon_sym_SLASH] = ACTIONS(6209),
    [anon_sym_STAR_STAR] = ACTIONS(6211),
    [anon_sym_CARET] = ACTIONS(6211),
    [aux_sym_binary_operator_token1] = ACTIONS(6213),
    [anon_sym_PIPE_GT] = ACTIONS(6213),
    [anon_sym_COLON] = ACTIONS(6215),
    [anon_sym_DOLLAR] = ACTIONS(6217),
    [anon_sym_AT] = ACTIONS(6217),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6221),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6223),
    [sym__external_open_bracket2] = ACTIONS(6225),
  },
  [1712] = {
    [sym_call_arguments] = STATE(2808),
    [sym_subset_arguments] = STATE(2920),
    [sym_subset2_arguments] = STATE(2919),
    [sym__open_parenthesis] = STATE(1545),
    [sym__open_bracket] = STATE(1541),
    [sym__open_bracket2] = STATE(1539),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(6337),
    [anon_sym_CARET] = ACTIONS(6337),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(6341),
    [anon_sym_DOLLAR] = ACTIONS(6343),
    [anon_sym_AT] = ACTIONS(6343),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6345),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6347),
    [sym__external_open_bracket2] = ACTIONS(6349),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [1713] = {
    [sym_call_arguments] = STATE(2845),
    [sym_subset_arguments] = STATE(2849),
    [sym_subset2_arguments] = STATE(2852),
    [sym__open_parenthesis] = STATE(1372),
    [sym__open_bracket] = STATE(1371),
    [sym__open_bracket2] = STATE(1370),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(6207),
    [anon_sym_SLASH] = ACTIONS(6209),
    [anon_sym_STAR_STAR] = ACTIONS(6211),
    [anon_sym_CARET] = ACTIONS(6211),
    [aux_sym_binary_operator_token1] = ACTIONS(6213),
    [anon_sym_PIPE_GT] = ACTIONS(6213),
    [anon_sym_COLON] = ACTIONS(6215),
    [anon_sym_DOLLAR] = ACTIONS(6217),
    [anon_sym_AT] = ACTIONS(6217),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6221),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6223),
    [sym__external_open_bracket2] = ACTIONS(6225),
  },
  [1714] = {
    [sym_call_arguments] = STATE(2808),
    [sym_subset_arguments] = STATE(2920),
    [sym_subset2_arguments] = STATE(2919),
    [sym__open_parenthesis] = STATE(1545),
    [sym__open_bracket] = STATE(1541),
    [sym__open_bracket2] = STATE(1539),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(6337),
    [anon_sym_CARET] = ACTIONS(6337),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(5351),
    [anon_sym_DOLLAR] = ACTIONS(6343),
    [anon_sym_AT] = ACTIONS(6343),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6345),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6347),
    [sym__external_open_bracket2] = ACTIONS(6349),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [1715] = {
    [sym_call_arguments] = STATE(2845),
    [sym_subset_arguments] = STATE(2849),
    [sym_subset2_arguments] = STATE(2852),
    [sym__open_parenthesis] = STATE(1372),
    [sym__open_bracket] = STATE(1371),
    [sym__open_bracket2] = STATE(1370),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(6185),
    [anon_sym_DASH] = ACTIONS(6187),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(6195),
    [anon_sym_AMP] = ACTIONS(6197),
    [anon_sym_PIPE_PIPE] = ACTIONS(6199),
    [anon_sym_AMP_AMP] = ACTIONS(6201),
    [anon_sym_LT] = ACTIONS(6203),
    [anon_sym_LT_EQ] = ACTIONS(6205),
    [anon_sym_GT] = ACTIONS(6203),
    [anon_sym_GT_EQ] = ACTIONS(6205),
    [anon_sym_EQ_EQ] = ACTIONS(6205),
    [anon_sym_BANG_EQ] = ACTIONS(6205),
    [anon_sym_STAR] = ACTIONS(6207),
    [anon_sym_SLASH] = ACTIONS(6209),
    [anon_sym_STAR_STAR] = ACTIONS(6211),
    [anon_sym_CARET] = ACTIONS(6211),
    [aux_sym_binary_operator_token1] = ACTIONS(6213),
    [anon_sym_PIPE_GT] = ACTIONS(6213),
    [anon_sym_COLON] = ACTIONS(6215),
    [anon_sym_DOLLAR] = ACTIONS(6217),
    [anon_sym_AT] = ACTIONS(6217),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6221),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6223),
    [sym__external_open_bracket2] = ACTIONS(6225),
  },
  [1716] = {
    [sym_call_arguments] = STATE(2845),
    [sym_subset_arguments] = STATE(2849),
    [sym_subset2_arguments] = STATE(2852),
    [sym__open_parenthesis] = STATE(1372),
    [sym__open_bracket] = STATE(1371),
    [sym__open_bracket2] = STATE(1370),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(6181),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(6183),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(6185),
    [anon_sym_DASH] = ACTIONS(6187),
    [anon_sym_LT_DASH] = ACTIONS(6189),
    [anon_sym_LT_LT_DASH] = ACTIONS(6189),
    [anon_sym_COLON_EQ] = ACTIONS(6189),
    [anon_sym_DASH_GT] = ACTIONS(6191),
    [anon_sym_DASH_GT_GT] = ACTIONS(6193),
    [anon_sym_PIPE] = ACTIONS(6195),
    [anon_sym_AMP] = ACTIONS(6197),
    [anon_sym_PIPE_PIPE] = ACTIONS(6199),
    [anon_sym_AMP_AMP] = ACTIONS(6201),
    [anon_sym_LT] = ACTIONS(6203),
    [anon_sym_LT_EQ] = ACTIONS(6205),
    [anon_sym_GT] = ACTIONS(6203),
    [anon_sym_GT_EQ] = ACTIONS(6205),
    [anon_sym_EQ_EQ] = ACTIONS(6205),
    [anon_sym_BANG_EQ] = ACTIONS(6205),
    [anon_sym_STAR] = ACTIONS(6207),
    [anon_sym_SLASH] = ACTIONS(6209),
    [anon_sym_STAR_STAR] = ACTIONS(6211),
    [anon_sym_CARET] = ACTIONS(6211),
    [aux_sym_binary_operator_token1] = ACTIONS(6213),
    [anon_sym_PIPE_GT] = ACTIONS(6213),
    [anon_sym_COLON] = ACTIONS(6215),
    [anon_sym_DOLLAR] = ACTIONS(6217),
    [anon_sym_AT] = ACTIONS(6217),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6221),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6223),
    [sym__external_open_bracket2] = ACTIONS(6225),
  },
  [1717] = {
    [sym_call_arguments] = STATE(2923),
    [sym_subset_arguments] = STATE(2922),
    [sym_subset2_arguments] = STATE(2906),
    [sym__open_parenthesis] = STATE(1528),
    [sym__open_bracket] = STATE(1525),
    [sym__open_bracket2] = STATE(1519),
    [ts_builtin_sym_end] = ACTIONS(5425),
    [sym_identifier] = ACTIONS(5427),
    [anon_sym_BSLASH] = ACTIONS(5425),
    [anon_sym_function] = ACTIONS(5427),
    [anon_sym_EQ] = ACTIONS(5947),
    [anon_sym_if] = ACTIONS(5427),
    [anon_sym_for] = ACTIONS(5427),
    [anon_sym_while] = ACTIONS(5427),
    [anon_sym_repeat] = ACTIONS(5427),
    [anon_sym_QMARK] = ACTIONS(5425),
    [anon_sym_TILDE] = ACTIONS(5949),
    [anon_sym_BANG] = ACTIONS(5427),
    [anon_sym_PLUS] = ACTIONS(5951),
    [anon_sym_DASH] = ACTIONS(5953),
    [anon_sym_LT_DASH] = ACTIONS(5955),
    [anon_sym_LT_LT_DASH] = ACTIONS(5955),
    [anon_sym_COLON_EQ] = ACTIONS(5955),
    [anon_sym_DASH_GT] = ACTIONS(5957),
    [anon_sym_DASH_GT_GT] = ACTIONS(5959),
    [anon_sym_PIPE] = ACTIONS(5961),
    [anon_sym_AMP] = ACTIONS(5963),
    [anon_sym_PIPE_PIPE] = ACTIONS(5965),
    [anon_sym_AMP_AMP] = ACTIONS(5967),
    [anon_sym_LT] = ACTIONS(5969),
    [anon_sym_LT_EQ] = ACTIONS(5971),
    [anon_sym_GT] = ACTIONS(5969),
    [anon_sym_GT_EQ] = ACTIONS(5971),
    [anon_sym_EQ_EQ] = ACTIONS(5971),
    [anon_sym_BANG_EQ] = ACTIONS(5971),
    [anon_sym_STAR] = ACTIONS(5973),
    [anon_sym_SLASH] = ACTIONS(5975),
    [anon_sym_STAR_STAR] = ACTIONS(5977),
    [anon_sym_CARET] = ACTIONS(5977),
    [aux_sym_binary_operator_token1] = ACTIONS(5979),
    [anon_sym_PIPE_GT] = ACTIONS(5979),
    [anon_sym_COLON] = ACTIONS(5981),
    [anon_sym_DOLLAR] = ACTIONS(5983),
    [anon_sym_AT] = ACTIONS(5983),
    [aux_sym__hex_literal_token1] = ACTIONS(5425),
    [sym__number_literal] = ACTIONS(5427),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_DQUOTE] = ACTIONS(5425),
    [sym_return] = ACTIONS(5427),
    [sym_next] = ACTIONS(5427),
    [sym_break] = ACTIONS(5427),
    [sym_true] = ACTIONS(5427),
    [sym_false] = ACTIONS(5427),
    [sym_null] = ACTIONS(5427),
    [sym_inf] = ACTIONS(5427),
    [sym_nan] = ACTIONS(5427),
    [anon_sym_NA] = ACTIONS(5427),
    [anon_sym_NA_integer_] = ACTIONS(5427),
    [anon_sym_NA_real_] = ACTIONS(5427),
    [anon_sym_NA_complex_] = ACTIONS(5427),
    [anon_sym_NA_character_] = ACTIONS(5427),
    [sym_dots] = ACTIONS(5427),
    [sym_dot_dot_i] = ACTIONS(5425),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5425),
    [sym__semicolon] = ACTIONS(5425),
    [sym__raw_string_literal] = ACTIONS(5425),
    [sym__external_else] = ACTIONS(5425),
    [sym__external_open_parenthesis] = ACTIONS(5987),
    [sym__external_open_brace] = ACTIONS(5425),
    [sym__external_open_bracket] = ACTIONS(5989),
    [sym__external_open_bracket2] = ACTIONS(5991),
  },
  [1718] = {
    [sym_call_arguments] = STATE(2845),
    [sym_subset_arguments] = STATE(2849),
    [sym_subset2_arguments] = STATE(2852),
    [sym__open_parenthesis] = STATE(1372),
    [sym__open_bracket] = STATE(1371),
    [sym__open_bracket2] = STATE(1370),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(6181),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(6183),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(6185),
    [anon_sym_DASH] = ACTIONS(6187),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(6191),
    [anon_sym_DASH_GT_GT] = ACTIONS(6193),
    [anon_sym_PIPE] = ACTIONS(6195),
    [anon_sym_AMP] = ACTIONS(6197),
    [anon_sym_PIPE_PIPE] = ACTIONS(6199),
    [anon_sym_AMP_AMP] = ACTIONS(6201),
    [anon_sym_LT] = ACTIONS(6203),
    [anon_sym_LT_EQ] = ACTIONS(6205),
    [anon_sym_GT] = ACTIONS(6203),
    [anon_sym_GT_EQ] = ACTIONS(6205),
    [anon_sym_EQ_EQ] = ACTIONS(6205),
    [anon_sym_BANG_EQ] = ACTIONS(6205),
    [anon_sym_STAR] = ACTIONS(6207),
    [anon_sym_SLASH] = ACTIONS(6209),
    [anon_sym_STAR_STAR] = ACTIONS(6211),
    [anon_sym_CARET] = ACTIONS(6211),
    [aux_sym_binary_operator_token1] = ACTIONS(6213),
    [anon_sym_PIPE_GT] = ACTIONS(6213),
    [anon_sym_COLON] = ACTIONS(6215),
    [anon_sym_DOLLAR] = ACTIONS(6217),
    [anon_sym_AT] = ACTIONS(6217),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6221),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6223),
    [sym__external_open_bracket2] = ACTIONS(6225),
  },
  [1719] = {
    [sym_call_arguments] = STATE(2777),
    [sym_subset_arguments] = STATE(2779),
    [sym_subset2_arguments] = STATE(2786),
    [sym__open_parenthesis] = STATE(1411),
    [sym__open_bracket] = STATE(1409),
    [sym__open_bracket2] = STATE(1407),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(6497),
    [anon_sym_DASH] = ACTIONS(6499),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(6515),
    [anon_sym_LT_EQ] = ACTIONS(6517),
    [anon_sym_GT] = ACTIONS(6515),
    [anon_sym_GT_EQ] = ACTIONS(6517),
    [anon_sym_EQ_EQ] = ACTIONS(6517),
    [anon_sym_BANG_EQ] = ACTIONS(6517),
    [anon_sym_STAR] = ACTIONS(6519),
    [anon_sym_SLASH] = ACTIONS(6521),
    [anon_sym_STAR_STAR] = ACTIONS(6523),
    [anon_sym_CARET] = ACTIONS(6523),
    [aux_sym_binary_operator_token1] = ACTIONS(6525),
    [anon_sym_PIPE_GT] = ACTIONS(6525),
    [anon_sym_COLON] = ACTIONS(6527),
    [anon_sym_DOLLAR] = ACTIONS(6529),
    [anon_sym_AT] = ACTIONS(6529),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6531),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6533),
    [sym__external_open_bracket2] = ACTIONS(6535),
  },
  [1720] = {
    [sym_function_definition] = STATE(2038),
    [sym_if_statement] = STATE(2038),
    [sym_for_statement] = STATE(2038),
    [sym_while_statement] = STATE(2038),
    [sym_repeat_statement] = STATE(2038),
    [sym_braced_expression] = STATE(2038),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_call] = STATE(2038),
    [sym_subset] = STATE(2038),
    [sym_subset2] = STATE(2038),
    [sym__argument] = STATE(4664),
    [sym_argument] = STATE(4659),
    [sym__argument_named] = STATE(4654),
    [sym__argument_unnamed] = STATE(4676),
    [sym__argument_value] = STATE(4677),
    [sym_unary_operator] = STATE(2038),
    [sym_binary_operator] = STATE(2038),
    [sym_extract_operator] = STATE(2038),
    [sym_namespace_operator] = STATE(2038),
    [sym_integer] = STATE(2038),
    [sym_complex] = STATE(2038),
    [sym_float] = STATE(2038),
    [sym__hex_literal] = STATE(2700),
    [sym__float_literal] = STATE(2700),
    [sym_string] = STATE(2597),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym_na] = STATE(2038),
    [sym__expression] = STATE(2038),
    [sym__string_or_identifier] = STATE(5148),
    [sym__open_parenthesis] = STATE(214),
    [sym__open_brace] = STATE(192),
    [sym__close_bracket] = STATE(2780),
    [aux_sym_call_arguments_repeat1] = STATE(2034),
    [sym_identifier] = ACTIONS(6351),
    [anon_sym_BSLASH] = ACTIONS(4754),
    [anon_sym_function] = ACTIONS(4756),
    [anon_sym_if] = ACTIONS(4758),
    [anon_sym_for] = ACTIONS(4760),
    [anon_sym_while] = ACTIONS(4762),
    [anon_sym_repeat] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4766),
    [anon_sym_TILDE] = ACTIONS(4768),
    [anon_sym_BANG] = ACTIONS(6353),
    [anon_sym_PLUS] = ACTIONS(4772),
    [anon_sym_DASH] = ACTIONS(4772),
    [aux_sym__hex_literal_token1] = ACTIONS(4776),
    [sym__number_literal] = ACTIONS(4778),
    [anon_sym_SQUOTE] = ACTIONS(4780),
    [anon_sym_DQUOTE] = ACTIONS(4782),
    [sym_return] = ACTIONS(6355),
    [sym_next] = ACTIONS(6355),
    [sym_break] = ACTIONS(6355),
    [sym_true] = ACTIONS(6355),
    [sym_false] = ACTIONS(6355),
    [sym_null] = ACTIONS(6355),
    [sym_inf] = ACTIONS(6355),
    [sym_nan] = ACTIONS(6355),
    [anon_sym_NA] = ACTIONS(4786),
    [anon_sym_NA_integer_] = ACTIONS(4786),
    [anon_sym_NA_real_] = ACTIONS(4786),
    [anon_sym_NA_complex_] = ACTIONS(4786),
    [anon_sym_NA_character_] = ACTIONS(4786),
    [sym_dots] = ACTIONS(6357),
    [sym_dot_dot_i] = ACTIONS(6359),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6361),
    [sym__newline] = ACTIONS(6363),
    [sym__raw_string_literal] = ACTIONS(4790),
    [sym__external_open_parenthesis] = ACTIONS(4792),
    [sym__external_open_brace] = ACTIONS(4794),
    [sym__external_close_bracket] = ACTIONS(6783),
  },
  [1721] = {
    [sym_call_arguments] = STATE(2845),
    [sym_subset_arguments] = STATE(2849),
    [sym_subset2_arguments] = STATE(2852),
    [sym__open_parenthesis] = STATE(1372),
    [sym__open_bracket] = STATE(1371),
    [sym__open_bracket2] = STATE(1370),
    [sym_identifier] = ACTIONS(5401),
    [anon_sym_BSLASH] = ACTIONS(5399),
    [anon_sym_function] = ACTIONS(5401),
    [anon_sym_EQ] = ACTIONS(6181),
    [anon_sym_if] = ACTIONS(5401),
    [anon_sym_for] = ACTIONS(5401),
    [anon_sym_while] = ACTIONS(5401),
    [anon_sym_repeat] = ACTIONS(5401),
    [anon_sym_QMARK] = ACTIONS(5399),
    [anon_sym_TILDE] = ACTIONS(6183),
    [anon_sym_BANG] = ACTIONS(5401),
    [anon_sym_PLUS] = ACTIONS(6185),
    [anon_sym_DASH] = ACTIONS(6187),
    [anon_sym_LT_DASH] = ACTIONS(6189),
    [anon_sym_LT_LT_DASH] = ACTIONS(6189),
    [anon_sym_COLON_EQ] = ACTIONS(6189),
    [anon_sym_DASH_GT] = ACTIONS(6191),
    [anon_sym_DASH_GT_GT] = ACTIONS(6193),
    [anon_sym_PIPE] = ACTIONS(6195),
    [anon_sym_AMP] = ACTIONS(6197),
    [anon_sym_PIPE_PIPE] = ACTIONS(6199),
    [anon_sym_AMP_AMP] = ACTIONS(6201),
    [anon_sym_LT] = ACTIONS(6203),
    [anon_sym_LT_EQ] = ACTIONS(6205),
    [anon_sym_GT] = ACTIONS(6203),
    [anon_sym_GT_EQ] = ACTIONS(6205),
    [anon_sym_EQ_EQ] = ACTIONS(6205),
    [anon_sym_BANG_EQ] = ACTIONS(6205),
    [anon_sym_STAR] = ACTIONS(6207),
    [anon_sym_SLASH] = ACTIONS(6209),
    [anon_sym_STAR_STAR] = ACTIONS(6211),
    [anon_sym_CARET] = ACTIONS(6211),
    [aux_sym_binary_operator_token1] = ACTIONS(6213),
    [anon_sym_PIPE_GT] = ACTIONS(6213),
    [anon_sym_COLON] = ACTIONS(6215),
    [anon_sym_DOLLAR] = ACTIONS(6217),
    [anon_sym_AT] = ACTIONS(6217),
    [aux_sym__hex_literal_token1] = ACTIONS(5399),
    [sym__number_literal] = ACTIONS(5401),
    [anon_sym_SQUOTE] = ACTIONS(5399),
    [anon_sym_DQUOTE] = ACTIONS(5399),
    [sym_return] = ACTIONS(5401),
    [sym_next] = ACTIONS(5401),
    [sym_break] = ACTIONS(5401),
    [sym_true] = ACTIONS(5401),
    [sym_false] = ACTIONS(5401),
    [sym_null] = ACTIONS(5401),
    [sym_inf] = ACTIONS(5401),
    [sym_nan] = ACTIONS(5401),
    [anon_sym_NA] = ACTIONS(5401),
    [anon_sym_NA_integer_] = ACTIONS(5401),
    [anon_sym_NA_real_] = ACTIONS(5401),
    [anon_sym_NA_complex_] = ACTIONS(5401),
    [anon_sym_NA_character_] = ACTIONS(5401),
    [sym_dots] = ACTIONS(5401),
    [sym_dot_dot_i] = ACTIONS(5399),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5399),
    [sym__newline] = ACTIONS(5399),
    [sym__raw_string_literal] = ACTIONS(5399),
    [sym__external_else] = ACTIONS(5399),
    [sym__external_open_parenthesis] = ACTIONS(6221),
    [sym__external_close_parenthesis] = ACTIONS(5399),
    [sym__external_open_brace] = ACTIONS(5399),
    [sym__external_open_bracket] = ACTIONS(6223),
    [sym__external_open_bracket2] = ACTIONS(6225),
  },
  [1722] = {
    [sym_function_definition] = STATE(1940),
    [sym_if_statement] = STATE(1940),
    [sym_for_statement] = STATE(1940),
    [sym_while_statement] = STATE(1940),
    [sym_repeat_statement] = STATE(1940),
    [sym_braced_expression] = STATE(1940),
    [sym_parenthesized_expression] = STATE(1940),
    [sym_call] = STATE(1940),
    [sym_subset] = STATE(1940),
    [sym_subset2] = STATE(1940),
    [sym__argument] = STATE(4665),
    [sym_argument] = STATE(4661),
    [sym__argument_named] = STATE(4669),
    [sym__argument_unnamed] = STATE(4673),
    [sym__argument_value] = STATE(4679),
    [sym_unary_operator] = STATE(1940),
    [sym_binary_operator] = STATE(1940),
    [sym_extract_operator] = STATE(1940),
    [sym_namespace_operator] = STATE(1940),
    [sym_integer] = STATE(1940),
    [sym_complex] = STATE(1940),
    [sym_float] = STATE(1940),
    [sym__hex_literal] = STATE(2656),
    [sym__float_literal] = STATE(2656),
    [sym_string] = STATE(2606),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym_na] = STATE(1940),
    [sym__expression] = STATE(1940),
    [sym__string_or_identifier] = STATE(5141),
    [sym__open_parenthesis] = STATE(218),
    [sym__open_brace] = STATE(185),
    [sym__close_bracket2] = STATE(2823),
    [aux_sym_call_arguments_repeat1] = STATE(1912),
    [sym_identifier] = ACTIONS(6369),
    [anon_sym_BSLASH] = ACTIONS(4644),
    [anon_sym_function] = ACTIONS(4646),
    [anon_sym_if] = ACTIONS(4648),
    [anon_sym_for] = ACTIONS(4650),
    [anon_sym_while] = ACTIONS(4652),
    [anon_sym_repeat] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(6371),
    [anon_sym_PLUS] = ACTIONS(4662),
    [anon_sym_DASH] = ACTIONS(4662),
    [aux_sym__hex_literal_token1] = ACTIONS(4666),
    [sym__number_literal] = ACTIONS(4668),
    [anon_sym_SQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4672),
    [sym_return] = ACTIONS(6373),
    [sym_next] = ACTIONS(6373),
    [sym_break] = ACTIONS(6373),
    [sym_true] = ACTIONS(6373),
    [sym_false] = ACTIONS(6373),
    [sym_null] = ACTIONS(6373),
    [sym_inf] = ACTIONS(6373),
    [sym_nan] = ACTIONS(6373),
    [anon_sym_NA] = ACTIONS(4676),
    [anon_sym_NA_integer_] = ACTIONS(4676),
    [anon_sym_NA_real_] = ACTIONS(4676),
    [anon_sym_NA_complex_] = ACTIONS(4676),
    [anon_sym_NA_character_] = ACTIONS(4676),
    [sym_dots] = ACTIONS(6375),
    [sym_dot_dot_i] = ACTIONS(6377),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6379),
    [sym__newline] = ACTIONS(6381),
    [sym__raw_string_literal] = ACTIONS(4680),
    [sym__external_open_parenthesis] = ACTIONS(4682),
    [sym__external_open_brace] = ACTIONS(4684),
    [sym__external_close_bracket2] = ACTIONS(6785),
  },
  [1723] = {
    [sym_function_definition] = STATE(1940),
    [sym_if_statement] = STATE(1940),
    [sym_for_statement] = STATE(1940),
    [sym_while_statement] = STATE(1940),
    [sym_repeat_statement] = STATE(1940),
    [sym_braced_expression] = STATE(1940),
    [sym_parenthesized_expression] = STATE(1940),
    [sym_call] = STATE(1940),
    [sym_subset] = STATE(1940),
    [sym_subset2] = STATE(1940),
    [sym__argument] = STATE(4665),
    [sym_argument] = STATE(4661),
    [sym__argument_named] = STATE(4669),
    [sym__argument_unnamed] = STATE(4673),
    [sym__argument_value] = STATE(4679),
    [sym_unary_operator] = STATE(1940),
    [sym_binary_operator] = STATE(1940),
    [sym_extract_operator] = STATE(1940),
    [sym_namespace_operator] = STATE(1940),
    [sym_integer] = STATE(1940),
    [sym_complex] = STATE(1940),
    [sym_float] = STATE(1940),
    [sym__hex_literal] = STATE(2656),
    [sym__float_literal] = STATE(2656),
    [sym_string] = STATE(2606),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym_na] = STATE(1940),
    [sym__expression] = STATE(1940),
    [sym__string_or_identifier] = STATE(5141),
    [sym__open_parenthesis] = STATE(218),
    [sym__open_brace] = STATE(185),
    [sym__close_bracket2] = STATE(2875),
    [aux_sym_call_arguments_repeat1] = STATE(1912),
    [sym_identifier] = ACTIONS(6369),
    [anon_sym_BSLASH] = ACTIONS(4644),
    [anon_sym_function] = ACTIONS(4646),
    [anon_sym_if] = ACTIONS(4648),
    [anon_sym_for] = ACTIONS(4650),
    [anon_sym_while] = ACTIONS(4652),
    [anon_sym_repeat] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(6371),
    [anon_sym_PLUS] = ACTIONS(4662),
    [anon_sym_DASH] = ACTIONS(4662),
    [aux_sym__hex_literal_token1] = ACTIONS(4666),
    [sym__number_literal] = ACTIONS(4668),
    [anon_sym_SQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4672),
    [sym_return] = ACTIONS(6373),
    [sym_next] = ACTIONS(6373),
    [sym_break] = ACTIONS(6373),
    [sym_true] = ACTIONS(6373),
    [sym_false] = ACTIONS(6373),
    [sym_null] = ACTIONS(6373),
    [sym_inf] = ACTIONS(6373),
    [sym_nan] = ACTIONS(6373),
    [anon_sym_NA] = ACTIONS(4676),
    [anon_sym_NA_integer_] = ACTIONS(4676),
    [anon_sym_NA_real_] = ACTIONS(4676),
    [anon_sym_NA_complex_] = ACTIONS(4676),
    [anon_sym_NA_character_] = ACTIONS(4676),
    [sym_dots] = ACTIONS(6375),
    [sym_dot_dot_i] = ACTIONS(6377),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6379),
    [sym__newline] = ACTIONS(6381),
    [sym__raw_string_literal] = ACTIONS(4680),
    [sym__external_open_parenthesis] = ACTIONS(4682),
    [sym__external_open_brace] = ACTIONS(4684),
    [sym__external_close_bracket2] = ACTIONS(6787),
  },
  [1724] = {
    [sym_function_definition] = STATE(2038),
    [sym_if_statement] = STATE(2038),
    [sym_for_statement] = STATE(2038),
    [sym_while_statement] = STATE(2038),
    [sym_repeat_statement] = STATE(2038),
    [sym_braced_expression] = STATE(2038),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_call] = STATE(2038),
    [sym_subset] = STATE(2038),
    [sym_subset2] = STATE(2038),
    [sym__argument] = STATE(4664),
    [sym_argument] = STATE(4659),
    [sym__argument_named] = STATE(4654),
    [sym__argument_unnamed] = STATE(4676),
    [sym__argument_value] = STATE(4677),
    [sym_unary_operator] = STATE(2038),
    [sym_binary_operator] = STATE(2038),
    [sym_extract_operator] = STATE(2038),
    [sym_namespace_operator] = STATE(2038),
    [sym_integer] = STATE(2038),
    [sym_complex] = STATE(2038),
    [sym_float] = STATE(2038),
    [sym__hex_literal] = STATE(2700),
    [sym__float_literal] = STATE(2700),
    [sym_string] = STATE(2597),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym_na] = STATE(2038),
    [sym__expression] = STATE(2038),
    [sym__string_or_identifier] = STATE(5148),
    [sym__open_parenthesis] = STATE(214),
    [sym__open_brace] = STATE(192),
    [sym__close_bracket] = STATE(2747),
    [aux_sym_call_arguments_repeat1] = STATE(2034),
    [sym_identifier] = ACTIONS(6351),
    [anon_sym_BSLASH] = ACTIONS(4754),
    [anon_sym_function] = ACTIONS(4756),
    [anon_sym_if] = ACTIONS(4758),
    [anon_sym_for] = ACTIONS(4760),
    [anon_sym_while] = ACTIONS(4762),
    [anon_sym_repeat] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4766),
    [anon_sym_TILDE] = ACTIONS(4768),
    [anon_sym_BANG] = ACTIONS(6353),
    [anon_sym_PLUS] = ACTIONS(4772),
    [anon_sym_DASH] = ACTIONS(4772),
    [aux_sym__hex_literal_token1] = ACTIONS(4776),
    [sym__number_literal] = ACTIONS(4778),
    [anon_sym_SQUOTE] = ACTIONS(4780),
    [anon_sym_DQUOTE] = ACTIONS(4782),
    [sym_return] = ACTIONS(6355),
    [sym_next] = ACTIONS(6355),
    [sym_break] = ACTIONS(6355),
    [sym_true] = ACTIONS(6355),
    [sym_false] = ACTIONS(6355),
    [sym_null] = ACTIONS(6355),
    [sym_inf] = ACTIONS(6355),
    [sym_nan] = ACTIONS(6355),
    [anon_sym_NA] = ACTIONS(4786),
    [anon_sym_NA_integer_] = ACTIONS(4786),
    [anon_sym_NA_real_] = ACTIONS(4786),
    [anon_sym_NA_complex_] = ACTIONS(4786),
    [anon_sym_NA_character_] = ACTIONS(4786),
    [sym_dots] = ACTIONS(6357),
    [sym_dot_dot_i] = ACTIONS(6359),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6361),
    [sym__newline] = ACTIONS(6363),
    [sym__raw_string_literal] = ACTIONS(4790),
    [sym__external_open_parenthesis] = ACTIONS(4792),
    [sym__external_open_brace] = ACTIONS(4794),
    [sym__external_close_bracket] = ACTIONS(6789),
  },
  [1725] = {
    [sym_call_arguments] = STATE(2840),
    [sym_subset_arguments] = STATE(2797),
    [sym_subset2_arguments] = STATE(2801),
    [sym__open_parenthesis] = STATE(1344),
    [sym__open_bracket] = STATE(1374),
    [sym__open_bracket2] = STATE(1452),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(6293),
    [anon_sym_CARET] = ACTIONS(6293),
    [aux_sym_binary_operator_token1] = ACTIONS(6295),
    [anon_sym_PIPE_GT] = ACTIONS(6295),
    [anon_sym_COLON] = ACTIONS(6297),
    [anon_sym_DOLLAR] = ACTIONS(6299),
    [anon_sym_AT] = ACTIONS(6299),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6301),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6303),
    [sym__external_open_bracket2] = ACTIONS(6305),
  },
  [1726] = {
    [sym_call_arguments] = STATE(2840),
    [sym_subset_arguments] = STATE(2797),
    [sym_subset2_arguments] = STATE(2801),
    [sym__open_parenthesis] = STATE(1344),
    [sym__open_bracket] = STATE(1374),
    [sym__open_bracket2] = STATE(1452),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(6265),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(6267),
    [anon_sym_DASH] = ACTIONS(6269),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(6277),
    [anon_sym_AMP] = ACTIONS(6279),
    [anon_sym_PIPE_PIPE] = ACTIONS(6281),
    [anon_sym_AMP_AMP] = ACTIONS(6283),
    [anon_sym_LT] = ACTIONS(6285),
    [anon_sym_LT_EQ] = ACTIONS(6287),
    [anon_sym_GT] = ACTIONS(6285),
    [anon_sym_GT_EQ] = ACTIONS(6287),
    [anon_sym_EQ_EQ] = ACTIONS(6287),
    [anon_sym_BANG_EQ] = ACTIONS(6287),
    [anon_sym_STAR] = ACTIONS(6289),
    [anon_sym_SLASH] = ACTIONS(6291),
    [anon_sym_STAR_STAR] = ACTIONS(6293),
    [anon_sym_CARET] = ACTIONS(6293),
    [aux_sym_binary_operator_token1] = ACTIONS(6295),
    [anon_sym_PIPE_GT] = ACTIONS(6295),
    [anon_sym_COLON] = ACTIONS(6297),
    [anon_sym_DOLLAR] = ACTIONS(6299),
    [anon_sym_AT] = ACTIONS(6299),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6301),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6303),
    [sym__external_open_bracket2] = ACTIONS(6305),
  },
  [1727] = {
    [sym_call_arguments] = STATE(2840),
    [sym_subset_arguments] = STATE(2797),
    [sym_subset2_arguments] = STATE(2801),
    [sym__open_parenthesis] = STATE(1344),
    [sym__open_bracket] = STATE(1374),
    [sym__open_bracket2] = STATE(1452),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(6267),
    [anon_sym_DASH] = ACTIONS(6269),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(6289),
    [anon_sym_SLASH] = ACTIONS(6291),
    [anon_sym_STAR_STAR] = ACTIONS(6293),
    [anon_sym_CARET] = ACTIONS(6293),
    [aux_sym_binary_operator_token1] = ACTIONS(6295),
    [anon_sym_PIPE_GT] = ACTIONS(6295),
    [anon_sym_COLON] = ACTIONS(6297),
    [anon_sym_DOLLAR] = ACTIONS(6299),
    [anon_sym_AT] = ACTIONS(6299),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6301),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6303),
    [sym__external_open_bracket2] = ACTIONS(6305),
  },
  [1728] = {
    [sym_call_arguments] = STATE(2808),
    [sym_subset_arguments] = STATE(2920),
    [sym_subset2_arguments] = STATE(2919),
    [sym__open_parenthesis] = STATE(1545),
    [sym__open_bracket] = STATE(1541),
    [sym__open_bracket2] = STATE(1539),
    [sym_identifier] = ACTIONS(5401),
    [anon_sym_BSLASH] = ACTIONS(5399),
    [anon_sym_function] = ACTIONS(5401),
    [anon_sym_EQ] = ACTIONS(6307),
    [anon_sym_if] = ACTIONS(5401),
    [anon_sym_for] = ACTIONS(5401),
    [anon_sym_while] = ACTIONS(5401),
    [anon_sym_repeat] = ACTIONS(5401),
    [anon_sym_QMARK] = ACTIONS(5399),
    [anon_sym_TILDE] = ACTIONS(6309),
    [anon_sym_BANG] = ACTIONS(5401),
    [anon_sym_PLUS] = ACTIONS(6311),
    [anon_sym_DASH] = ACTIONS(6313),
    [anon_sym_LT_DASH] = ACTIONS(6315),
    [anon_sym_LT_LT_DASH] = ACTIONS(6315),
    [anon_sym_COLON_EQ] = ACTIONS(6315),
    [anon_sym_DASH_GT] = ACTIONS(6317),
    [anon_sym_DASH_GT_GT] = ACTIONS(6319),
    [anon_sym_PIPE] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6323),
    [anon_sym_PIPE_PIPE] = ACTIONS(6325),
    [anon_sym_AMP_AMP] = ACTIONS(6327),
    [anon_sym_LT] = ACTIONS(6329),
    [anon_sym_LT_EQ] = ACTIONS(6331),
    [anon_sym_GT] = ACTIONS(6329),
    [anon_sym_GT_EQ] = ACTIONS(6331),
    [anon_sym_EQ_EQ] = ACTIONS(6331),
    [anon_sym_BANG_EQ] = ACTIONS(6331),
    [anon_sym_STAR] = ACTIONS(6333),
    [anon_sym_SLASH] = ACTIONS(6335),
    [anon_sym_STAR_STAR] = ACTIONS(6337),
    [anon_sym_CARET] = ACTIONS(6337),
    [aux_sym_binary_operator_token1] = ACTIONS(6339),
    [anon_sym_PIPE_GT] = ACTIONS(6339),
    [anon_sym_COLON] = ACTIONS(6341),
    [anon_sym_DOLLAR] = ACTIONS(6343),
    [anon_sym_AT] = ACTIONS(6343),
    [aux_sym__hex_literal_token1] = ACTIONS(5399),
    [sym__number_literal] = ACTIONS(5401),
    [anon_sym_SQUOTE] = ACTIONS(5399),
    [anon_sym_DQUOTE] = ACTIONS(5399),
    [sym_return] = ACTIONS(5401),
    [sym_next] = ACTIONS(5401),
    [sym_break] = ACTIONS(5401),
    [sym_true] = ACTIONS(5401),
    [sym_false] = ACTIONS(5401),
    [sym_null] = ACTIONS(5401),
    [sym_inf] = ACTIONS(5401),
    [sym_nan] = ACTIONS(5401),
    [anon_sym_NA] = ACTIONS(5401),
    [anon_sym_NA_integer_] = ACTIONS(5401),
    [anon_sym_NA_real_] = ACTIONS(5401),
    [anon_sym_NA_complex_] = ACTIONS(5401),
    [anon_sym_NA_character_] = ACTIONS(5401),
    [sym_dots] = ACTIONS(5401),
    [sym_dot_dot_i] = ACTIONS(5399),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5399),
    [sym__newline] = ACTIONS(5399),
    [sym__raw_string_literal] = ACTIONS(5399),
    [sym__external_open_parenthesis] = ACTIONS(6345),
    [sym__external_close_parenthesis] = ACTIONS(5399),
    [sym__external_open_brace] = ACTIONS(5399),
    [sym__external_open_bracket] = ACTIONS(6347),
    [sym__external_open_bracket2] = ACTIONS(6349),
    [sym__external_close_bracket2] = ACTIONS(5399),
  },
  [1729] = {
    [sym_call_arguments] = STATE(2845),
    [sym_subset_arguments] = STATE(2849),
    [sym_subset2_arguments] = STATE(2852),
    [sym__open_parenthesis] = STATE(1372),
    [sym__open_bracket] = STATE(1371),
    [sym__open_bracket2] = STATE(1370),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(6211),
    [anon_sym_CARET] = ACTIONS(6211),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(5351),
    [anon_sym_DOLLAR] = ACTIONS(6217),
    [anon_sym_AT] = ACTIONS(6217),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6221),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6223),
    [sym__external_open_bracket2] = ACTIONS(6225),
  },
  [1730] = {
    [sym_call_arguments] = STATE(2840),
    [sym_subset_arguments] = STATE(2797),
    [sym_subset2_arguments] = STATE(2801),
    [sym__open_parenthesis] = STATE(1344),
    [sym__open_bracket] = STATE(1374),
    [sym__open_bracket2] = STATE(1452),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(6267),
    [anon_sym_DASH] = ACTIONS(6269),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(6285),
    [anon_sym_LT_EQ] = ACTIONS(6287),
    [anon_sym_GT] = ACTIONS(6285),
    [anon_sym_GT_EQ] = ACTIONS(6287),
    [anon_sym_EQ_EQ] = ACTIONS(6287),
    [anon_sym_BANG_EQ] = ACTIONS(6287),
    [anon_sym_STAR] = ACTIONS(6289),
    [anon_sym_SLASH] = ACTIONS(6291),
    [anon_sym_STAR_STAR] = ACTIONS(6293),
    [anon_sym_CARET] = ACTIONS(6293),
    [aux_sym_binary_operator_token1] = ACTIONS(6295),
    [anon_sym_PIPE_GT] = ACTIONS(6295),
    [anon_sym_COLON] = ACTIONS(6297),
    [anon_sym_DOLLAR] = ACTIONS(6299),
    [anon_sym_AT] = ACTIONS(6299),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6301),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6303),
    [sym__external_open_bracket2] = ACTIONS(6305),
  },
  [1731] = {
    [sym_call_arguments] = STATE(2808),
    [sym_subset_arguments] = STATE(2920),
    [sym_subset2_arguments] = STATE(2919),
    [sym__open_parenthesis] = STATE(1545),
    [sym__open_bracket] = STATE(1541),
    [sym__open_bracket2] = STATE(1539),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(6307),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(6309),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(6311),
    [anon_sym_DASH] = ACTIONS(6313),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(6317),
    [anon_sym_DASH_GT_GT] = ACTIONS(6319),
    [anon_sym_PIPE] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6323),
    [anon_sym_PIPE_PIPE] = ACTIONS(6325),
    [anon_sym_AMP_AMP] = ACTIONS(6327),
    [anon_sym_LT] = ACTIONS(6329),
    [anon_sym_LT_EQ] = ACTIONS(6331),
    [anon_sym_GT] = ACTIONS(6329),
    [anon_sym_GT_EQ] = ACTIONS(6331),
    [anon_sym_EQ_EQ] = ACTIONS(6331),
    [anon_sym_BANG_EQ] = ACTIONS(6331),
    [anon_sym_STAR] = ACTIONS(6333),
    [anon_sym_SLASH] = ACTIONS(6335),
    [anon_sym_STAR_STAR] = ACTIONS(6337),
    [anon_sym_CARET] = ACTIONS(6337),
    [aux_sym_binary_operator_token1] = ACTIONS(6339),
    [anon_sym_PIPE_GT] = ACTIONS(6339),
    [anon_sym_COLON] = ACTIONS(6341),
    [anon_sym_DOLLAR] = ACTIONS(6343),
    [anon_sym_AT] = ACTIONS(6343),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6345),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6347),
    [sym__external_open_bracket2] = ACTIONS(6349),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [1732] = {
    [sym_call_arguments] = STATE(2808),
    [sym_subset_arguments] = STATE(2920),
    [sym_subset2_arguments] = STATE(2919),
    [sym__open_parenthesis] = STATE(1545),
    [sym__open_bracket] = STATE(1541),
    [sym__open_bracket2] = STATE(1539),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(6307),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(6309),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(6311),
    [anon_sym_DASH] = ACTIONS(6313),
    [anon_sym_LT_DASH] = ACTIONS(6315),
    [anon_sym_LT_LT_DASH] = ACTIONS(6315),
    [anon_sym_COLON_EQ] = ACTIONS(6315),
    [anon_sym_DASH_GT] = ACTIONS(6317),
    [anon_sym_DASH_GT_GT] = ACTIONS(6319),
    [anon_sym_PIPE] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6323),
    [anon_sym_PIPE_PIPE] = ACTIONS(6325),
    [anon_sym_AMP_AMP] = ACTIONS(6327),
    [anon_sym_LT] = ACTIONS(6329),
    [anon_sym_LT_EQ] = ACTIONS(6331),
    [anon_sym_GT] = ACTIONS(6329),
    [anon_sym_GT_EQ] = ACTIONS(6331),
    [anon_sym_EQ_EQ] = ACTIONS(6331),
    [anon_sym_BANG_EQ] = ACTIONS(6331),
    [anon_sym_STAR] = ACTIONS(6333),
    [anon_sym_SLASH] = ACTIONS(6335),
    [anon_sym_STAR_STAR] = ACTIONS(6337),
    [anon_sym_CARET] = ACTIONS(6337),
    [aux_sym_binary_operator_token1] = ACTIONS(6339),
    [anon_sym_PIPE_GT] = ACTIONS(6339),
    [anon_sym_COLON] = ACTIONS(6341),
    [anon_sym_DOLLAR] = ACTIONS(6343),
    [anon_sym_AT] = ACTIONS(6343),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6345),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6347),
    [sym__external_open_bracket2] = ACTIONS(6349),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [1733] = {
    [sym_call_arguments] = STATE(2808),
    [sym_subset_arguments] = STATE(2920),
    [sym_subset2_arguments] = STATE(2919),
    [sym__open_parenthesis] = STATE(1545),
    [sym__open_bracket] = STATE(1541),
    [sym__open_bracket2] = STATE(1539),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(6311),
    [anon_sym_DASH] = ACTIONS(6313),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6323),
    [anon_sym_PIPE_PIPE] = ACTIONS(6325),
    [anon_sym_AMP_AMP] = ACTIONS(6327),
    [anon_sym_LT] = ACTIONS(6329),
    [anon_sym_LT_EQ] = ACTIONS(6331),
    [anon_sym_GT] = ACTIONS(6329),
    [anon_sym_GT_EQ] = ACTIONS(6331),
    [anon_sym_EQ_EQ] = ACTIONS(6331),
    [anon_sym_BANG_EQ] = ACTIONS(6331),
    [anon_sym_STAR] = ACTIONS(6333),
    [anon_sym_SLASH] = ACTIONS(6335),
    [anon_sym_STAR_STAR] = ACTIONS(6337),
    [anon_sym_CARET] = ACTIONS(6337),
    [aux_sym_binary_operator_token1] = ACTIONS(6339),
    [anon_sym_PIPE_GT] = ACTIONS(6339),
    [anon_sym_COLON] = ACTIONS(6341),
    [anon_sym_DOLLAR] = ACTIONS(6343),
    [anon_sym_AT] = ACTIONS(6343),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6345),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6347),
    [sym__external_open_bracket2] = ACTIONS(6349),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [1734] = {
    [sym_call_arguments] = STATE(2808),
    [sym_subset_arguments] = STATE(2920),
    [sym_subset2_arguments] = STATE(2919),
    [sym__open_parenthesis] = STATE(1545),
    [sym__open_bracket] = STATE(1541),
    [sym__open_bracket2] = STATE(1539),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(6333),
    [anon_sym_SLASH] = ACTIONS(6335),
    [anon_sym_STAR_STAR] = ACTIONS(6337),
    [anon_sym_CARET] = ACTIONS(6337),
    [aux_sym_binary_operator_token1] = ACTIONS(6339),
    [anon_sym_PIPE_GT] = ACTIONS(6339),
    [anon_sym_COLON] = ACTIONS(6341),
    [anon_sym_DOLLAR] = ACTIONS(6343),
    [anon_sym_AT] = ACTIONS(6343),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6345),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6347),
    [sym__external_open_bracket2] = ACTIONS(6349),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [1735] = {
    [sym_call_arguments] = STATE(2808),
    [sym_subset_arguments] = STATE(2920),
    [sym_subset2_arguments] = STATE(2919),
    [sym__open_parenthesis] = STATE(1545),
    [sym__open_bracket] = STATE(1541),
    [sym__open_bracket2] = STATE(1539),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(6307),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(6309),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(6311),
    [anon_sym_DASH] = ACTIONS(6313),
    [anon_sym_LT_DASH] = ACTIONS(6315),
    [anon_sym_LT_LT_DASH] = ACTIONS(6315),
    [anon_sym_COLON_EQ] = ACTIONS(6315),
    [anon_sym_DASH_GT] = ACTIONS(6317),
    [anon_sym_DASH_GT_GT] = ACTIONS(6319),
    [anon_sym_PIPE] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6323),
    [anon_sym_PIPE_PIPE] = ACTIONS(6325),
    [anon_sym_AMP_AMP] = ACTIONS(6327),
    [anon_sym_LT] = ACTIONS(6329),
    [anon_sym_LT_EQ] = ACTIONS(6331),
    [anon_sym_GT] = ACTIONS(6329),
    [anon_sym_GT_EQ] = ACTIONS(6331),
    [anon_sym_EQ_EQ] = ACTIONS(6331),
    [anon_sym_BANG_EQ] = ACTIONS(6331),
    [anon_sym_STAR] = ACTIONS(6333),
    [anon_sym_SLASH] = ACTIONS(6335),
    [anon_sym_STAR_STAR] = ACTIONS(6337),
    [anon_sym_CARET] = ACTIONS(6337),
    [aux_sym_binary_operator_token1] = ACTIONS(6339),
    [anon_sym_PIPE_GT] = ACTIONS(6339),
    [anon_sym_COLON] = ACTIONS(6341),
    [anon_sym_DOLLAR] = ACTIONS(6343),
    [anon_sym_AT] = ACTIONS(6343),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6345),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6347),
    [sym__external_open_bracket2] = ACTIONS(6349),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [1736] = {
    [sym_call_arguments] = STATE(2808),
    [sym_subset_arguments] = STATE(2920),
    [sym_subset2_arguments] = STATE(2919),
    [sym__open_parenthesis] = STATE(1545),
    [sym__open_bracket] = STATE(1541),
    [sym__open_bracket2] = STATE(1539),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(6309),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(6311),
    [anon_sym_DASH] = ACTIONS(6313),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6323),
    [anon_sym_PIPE_PIPE] = ACTIONS(6325),
    [anon_sym_AMP_AMP] = ACTIONS(6327),
    [anon_sym_LT] = ACTIONS(6329),
    [anon_sym_LT_EQ] = ACTIONS(6331),
    [anon_sym_GT] = ACTIONS(6329),
    [anon_sym_GT_EQ] = ACTIONS(6331),
    [anon_sym_EQ_EQ] = ACTIONS(6331),
    [anon_sym_BANG_EQ] = ACTIONS(6331),
    [anon_sym_STAR] = ACTIONS(6333),
    [anon_sym_SLASH] = ACTIONS(6335),
    [anon_sym_STAR_STAR] = ACTIONS(6337),
    [anon_sym_CARET] = ACTIONS(6337),
    [aux_sym_binary_operator_token1] = ACTIONS(6339),
    [anon_sym_PIPE_GT] = ACTIONS(6339),
    [anon_sym_COLON] = ACTIONS(6341),
    [anon_sym_DOLLAR] = ACTIONS(6343),
    [anon_sym_AT] = ACTIONS(6343),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6345),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6347),
    [sym__external_open_bracket2] = ACTIONS(6349),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [1737] = {
    [sym_call_arguments] = STATE(2808),
    [sym_subset_arguments] = STATE(2920),
    [sym_subset2_arguments] = STATE(2919),
    [sym__open_parenthesis] = STATE(1545),
    [sym__open_bracket] = STATE(1541),
    [sym__open_bracket2] = STATE(1539),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(6311),
    [anon_sym_DASH] = ACTIONS(6313),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(6323),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(6327),
    [anon_sym_LT] = ACTIONS(6329),
    [anon_sym_LT_EQ] = ACTIONS(6331),
    [anon_sym_GT] = ACTIONS(6329),
    [anon_sym_GT_EQ] = ACTIONS(6331),
    [anon_sym_EQ_EQ] = ACTIONS(6331),
    [anon_sym_BANG_EQ] = ACTIONS(6331),
    [anon_sym_STAR] = ACTIONS(6333),
    [anon_sym_SLASH] = ACTIONS(6335),
    [anon_sym_STAR_STAR] = ACTIONS(6337),
    [anon_sym_CARET] = ACTIONS(6337),
    [aux_sym_binary_operator_token1] = ACTIONS(6339),
    [anon_sym_PIPE_GT] = ACTIONS(6339),
    [anon_sym_COLON] = ACTIONS(6341),
    [anon_sym_DOLLAR] = ACTIONS(6343),
    [anon_sym_AT] = ACTIONS(6343),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6345),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6347),
    [sym__external_open_bracket2] = ACTIONS(6349),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [1738] = {
    [sym_call_arguments] = STATE(2808),
    [sym_subset_arguments] = STATE(2920),
    [sym_subset2_arguments] = STATE(2919),
    [sym__open_parenthesis] = STATE(1545),
    [sym__open_bracket] = STATE(1541),
    [sym__open_bracket2] = STATE(1539),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(6311),
    [anon_sym_DASH] = ACTIONS(6313),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(6329),
    [anon_sym_LT_EQ] = ACTIONS(6331),
    [anon_sym_GT] = ACTIONS(6329),
    [anon_sym_GT_EQ] = ACTIONS(6331),
    [anon_sym_EQ_EQ] = ACTIONS(6331),
    [anon_sym_BANG_EQ] = ACTIONS(6331),
    [anon_sym_STAR] = ACTIONS(6333),
    [anon_sym_SLASH] = ACTIONS(6335),
    [anon_sym_STAR_STAR] = ACTIONS(6337),
    [anon_sym_CARET] = ACTIONS(6337),
    [aux_sym_binary_operator_token1] = ACTIONS(6339),
    [anon_sym_PIPE_GT] = ACTIONS(6339),
    [anon_sym_COLON] = ACTIONS(6341),
    [anon_sym_DOLLAR] = ACTIONS(6343),
    [anon_sym_AT] = ACTIONS(6343),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6345),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6347),
    [sym__external_open_bracket2] = ACTIONS(6349),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [1739] = {
    [sym_call_arguments] = STATE(2808),
    [sym_subset_arguments] = STATE(2920),
    [sym_subset2_arguments] = STATE(2919),
    [sym__open_parenthesis] = STATE(1545),
    [sym__open_bracket] = STATE(1541),
    [sym__open_bracket2] = STATE(1539),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(6311),
    [anon_sym_DASH] = ACTIONS(6313),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(6333),
    [anon_sym_SLASH] = ACTIONS(6335),
    [anon_sym_STAR_STAR] = ACTIONS(6337),
    [anon_sym_CARET] = ACTIONS(6337),
    [aux_sym_binary_operator_token1] = ACTIONS(6339),
    [anon_sym_PIPE_GT] = ACTIONS(6339),
    [anon_sym_COLON] = ACTIONS(6341),
    [anon_sym_DOLLAR] = ACTIONS(6343),
    [anon_sym_AT] = ACTIONS(6343),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6345),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6347),
    [sym__external_open_bracket2] = ACTIONS(6349),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [1740] = {
    [sym_call_arguments] = STATE(2808),
    [sym_subset_arguments] = STATE(2920),
    [sym_subset2_arguments] = STATE(2919),
    [sym__open_parenthesis] = STATE(1545),
    [sym__open_bracket] = STATE(1541),
    [sym__open_bracket2] = STATE(1539),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(6337),
    [anon_sym_CARET] = ACTIONS(6337),
    [aux_sym_binary_operator_token1] = ACTIONS(6339),
    [anon_sym_PIPE_GT] = ACTIONS(6339),
    [anon_sym_COLON] = ACTIONS(6341),
    [anon_sym_DOLLAR] = ACTIONS(6343),
    [anon_sym_AT] = ACTIONS(6343),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6345),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6347),
    [sym__external_open_bracket2] = ACTIONS(6349),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [1741] = {
    [sym_call_arguments] = STATE(2808),
    [sym_subset_arguments] = STATE(2920),
    [sym_subset2_arguments] = STATE(2919),
    [sym__open_parenthesis] = STATE(1545),
    [sym__open_bracket] = STATE(1541),
    [sym__open_bracket2] = STATE(1539),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(6337),
    [anon_sym_CARET] = ACTIONS(6337),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(5261),
    [anon_sym_DOLLAR] = ACTIONS(6343),
    [anon_sym_AT] = ACTIONS(6343),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6345),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6347),
    [sym__external_open_bracket2] = ACTIONS(6349),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [1742] = {
    [sym_call_arguments] = STATE(2808),
    [sym_subset_arguments] = STATE(2920),
    [sym_subset2_arguments] = STATE(2919),
    [sym__open_parenthesis] = STATE(1545),
    [sym__open_bracket] = STATE(1541),
    [sym__open_bracket2] = STATE(1539),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(6337),
    [anon_sym_CARET] = ACTIONS(6337),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(6341),
    [anon_sym_DOLLAR] = ACTIONS(6343),
    [anon_sym_AT] = ACTIONS(6343),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6345),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6347),
    [sym__external_open_bracket2] = ACTIONS(6349),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [1743] = {
    [sym_call_arguments] = STATE(2808),
    [sym_subset_arguments] = STATE(2920),
    [sym_subset2_arguments] = STATE(2919),
    [sym__open_parenthesis] = STATE(1545),
    [sym__open_bracket] = STATE(1541),
    [sym__open_bracket2] = STATE(1539),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(6337),
    [anon_sym_CARET] = ACTIONS(6337),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(5261),
    [anon_sym_DOLLAR] = ACTIONS(6343),
    [anon_sym_AT] = ACTIONS(6343),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6345),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6347),
    [sym__external_open_bracket2] = ACTIONS(6349),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [1744] = {
    [sym_call_arguments] = STATE(2845),
    [sym_subset_arguments] = STATE(2849),
    [sym_subset2_arguments] = STATE(2852),
    [sym__open_parenthesis] = STATE(1372),
    [sym__open_bracket] = STATE(1371),
    [sym__open_bracket2] = STATE(1370),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(6211),
    [anon_sym_CARET] = ACTIONS(6211),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(6215),
    [anon_sym_DOLLAR] = ACTIONS(6217),
    [anon_sym_AT] = ACTIONS(6217),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6221),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6223),
    [sym__external_open_bracket2] = ACTIONS(6225),
  },
  [1745] = {
    [sym_call_arguments] = STATE(2845),
    [sym_subset_arguments] = STATE(2849),
    [sym_subset2_arguments] = STATE(2852),
    [sym__open_parenthesis] = STATE(1372),
    [sym__open_bracket] = STATE(1371),
    [sym__open_bracket2] = STATE(1370),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(6211),
    [anon_sym_CARET] = ACTIONS(6211),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(5351),
    [anon_sym_DOLLAR] = ACTIONS(6217),
    [anon_sym_AT] = ACTIONS(6217),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6221),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6223),
    [sym__external_open_bracket2] = ACTIONS(6225),
  },
  [1746] = {
    [sym_call_arguments] = STATE(2845),
    [sym_subset_arguments] = STATE(2849),
    [sym_subset2_arguments] = STATE(2852),
    [sym__open_parenthesis] = STATE(1372),
    [sym__open_bracket] = STATE(1371),
    [sym__open_bracket2] = STATE(1370),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(6211),
    [anon_sym_CARET] = ACTIONS(6211),
    [aux_sym_binary_operator_token1] = ACTIONS(6213),
    [anon_sym_PIPE_GT] = ACTIONS(6213),
    [anon_sym_COLON] = ACTIONS(6215),
    [anon_sym_DOLLAR] = ACTIONS(6217),
    [anon_sym_AT] = ACTIONS(6217),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6221),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6223),
    [sym__external_open_bracket2] = ACTIONS(6225),
  },
  [1747] = {
    [sym_call_arguments] = STATE(2845),
    [sym_subset_arguments] = STATE(2849),
    [sym_subset2_arguments] = STATE(2852),
    [sym__open_parenthesis] = STATE(1372),
    [sym__open_bracket] = STATE(1371),
    [sym__open_bracket2] = STATE(1370),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(6185),
    [anon_sym_DASH] = ACTIONS(6187),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(6207),
    [anon_sym_SLASH] = ACTIONS(6209),
    [anon_sym_STAR_STAR] = ACTIONS(6211),
    [anon_sym_CARET] = ACTIONS(6211),
    [aux_sym_binary_operator_token1] = ACTIONS(6213),
    [anon_sym_PIPE_GT] = ACTIONS(6213),
    [anon_sym_COLON] = ACTIONS(6215),
    [anon_sym_DOLLAR] = ACTIONS(6217),
    [anon_sym_AT] = ACTIONS(6217),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6221),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6223),
    [sym__external_open_bracket2] = ACTIONS(6225),
  },
  [1748] = {
    [sym_call_arguments] = STATE(2845),
    [sym_subset_arguments] = STATE(2849),
    [sym_subset2_arguments] = STATE(2852),
    [sym__open_parenthesis] = STATE(1372),
    [sym__open_bracket] = STATE(1371),
    [sym__open_bracket2] = STATE(1370),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(6185),
    [anon_sym_DASH] = ACTIONS(6187),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(6203),
    [anon_sym_LT_EQ] = ACTIONS(6205),
    [anon_sym_GT] = ACTIONS(6203),
    [anon_sym_GT_EQ] = ACTIONS(6205),
    [anon_sym_EQ_EQ] = ACTIONS(6205),
    [anon_sym_BANG_EQ] = ACTIONS(6205),
    [anon_sym_STAR] = ACTIONS(6207),
    [anon_sym_SLASH] = ACTIONS(6209),
    [anon_sym_STAR_STAR] = ACTIONS(6211),
    [anon_sym_CARET] = ACTIONS(6211),
    [aux_sym_binary_operator_token1] = ACTIONS(6213),
    [anon_sym_PIPE_GT] = ACTIONS(6213),
    [anon_sym_COLON] = ACTIONS(6215),
    [anon_sym_DOLLAR] = ACTIONS(6217),
    [anon_sym_AT] = ACTIONS(6217),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6221),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6223),
    [sym__external_open_bracket2] = ACTIONS(6225),
  },
  [1749] = {
    [sym_call_arguments] = STATE(2923),
    [sym_subset_arguments] = STATE(2922),
    [sym_subset2_arguments] = STATE(2906),
    [sym__open_parenthesis] = STATE(1528),
    [sym__open_bracket] = STATE(1525),
    [sym__open_bracket2] = STATE(1519),
    [ts_builtin_sym_end] = ACTIONS(5421),
    [sym_identifier] = ACTIONS(5423),
    [anon_sym_BSLASH] = ACTIONS(5421),
    [anon_sym_function] = ACTIONS(5423),
    [anon_sym_EQ] = ACTIONS(5947),
    [anon_sym_if] = ACTIONS(5423),
    [anon_sym_for] = ACTIONS(5423),
    [anon_sym_while] = ACTIONS(5423),
    [anon_sym_repeat] = ACTIONS(5423),
    [anon_sym_QMARK] = ACTIONS(5421),
    [anon_sym_TILDE] = ACTIONS(5949),
    [anon_sym_BANG] = ACTIONS(5423),
    [anon_sym_PLUS] = ACTIONS(5951),
    [anon_sym_DASH] = ACTIONS(5953),
    [anon_sym_LT_DASH] = ACTIONS(5955),
    [anon_sym_LT_LT_DASH] = ACTIONS(5955),
    [anon_sym_COLON_EQ] = ACTIONS(5955),
    [anon_sym_DASH_GT] = ACTIONS(5957),
    [anon_sym_DASH_GT_GT] = ACTIONS(5959),
    [anon_sym_PIPE] = ACTIONS(5961),
    [anon_sym_AMP] = ACTIONS(5963),
    [anon_sym_PIPE_PIPE] = ACTIONS(5965),
    [anon_sym_AMP_AMP] = ACTIONS(5967),
    [anon_sym_LT] = ACTIONS(5969),
    [anon_sym_LT_EQ] = ACTIONS(5971),
    [anon_sym_GT] = ACTIONS(5969),
    [anon_sym_GT_EQ] = ACTIONS(5971),
    [anon_sym_EQ_EQ] = ACTIONS(5971),
    [anon_sym_BANG_EQ] = ACTIONS(5971),
    [anon_sym_STAR] = ACTIONS(5973),
    [anon_sym_SLASH] = ACTIONS(5975),
    [anon_sym_STAR_STAR] = ACTIONS(5977),
    [anon_sym_CARET] = ACTIONS(5977),
    [aux_sym_binary_operator_token1] = ACTIONS(5979),
    [anon_sym_PIPE_GT] = ACTIONS(5979),
    [anon_sym_COLON] = ACTIONS(5981),
    [anon_sym_DOLLAR] = ACTIONS(5983),
    [anon_sym_AT] = ACTIONS(5983),
    [aux_sym__hex_literal_token1] = ACTIONS(5421),
    [sym__number_literal] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5421),
    [anon_sym_DQUOTE] = ACTIONS(5421),
    [sym_return] = ACTIONS(5423),
    [sym_next] = ACTIONS(5423),
    [sym_break] = ACTIONS(5423),
    [sym_true] = ACTIONS(5423),
    [sym_false] = ACTIONS(5423),
    [sym_null] = ACTIONS(5423),
    [sym_inf] = ACTIONS(5423),
    [sym_nan] = ACTIONS(5423),
    [anon_sym_NA] = ACTIONS(5423),
    [anon_sym_NA_integer_] = ACTIONS(5423),
    [anon_sym_NA_real_] = ACTIONS(5423),
    [anon_sym_NA_complex_] = ACTIONS(5423),
    [anon_sym_NA_character_] = ACTIONS(5423),
    [sym_dots] = ACTIONS(5423),
    [sym_dot_dot_i] = ACTIONS(5421),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5421),
    [sym__semicolon] = ACTIONS(5421),
    [sym__raw_string_literal] = ACTIONS(5421),
    [sym__external_else] = ACTIONS(5421),
    [sym__external_open_parenthesis] = ACTIONS(5987),
    [sym__external_open_brace] = ACTIONS(5421),
    [sym__external_open_bracket] = ACTIONS(5989),
    [sym__external_open_bracket2] = ACTIONS(5991),
  },
  [1750] = {
    [sym_call_arguments] = STATE(2808),
    [sym_subset_arguments] = STATE(2920),
    [sym_subset2_arguments] = STATE(2919),
    [sym__open_parenthesis] = STATE(1545),
    [sym__open_bracket] = STATE(1541),
    [sym__open_bracket2] = STATE(1539),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_BSLASH] = ACTIONS(5413),
    [anon_sym_function] = ACTIONS(5415),
    [anon_sym_EQ] = ACTIONS(6307),
    [anon_sym_if] = ACTIONS(5415),
    [anon_sym_for] = ACTIONS(5415),
    [anon_sym_while] = ACTIONS(5415),
    [anon_sym_repeat] = ACTIONS(5415),
    [anon_sym_QMARK] = ACTIONS(5413),
    [anon_sym_TILDE] = ACTIONS(6309),
    [anon_sym_BANG] = ACTIONS(5415),
    [anon_sym_PLUS] = ACTIONS(6311),
    [anon_sym_DASH] = ACTIONS(6313),
    [anon_sym_LT_DASH] = ACTIONS(6315),
    [anon_sym_LT_LT_DASH] = ACTIONS(6315),
    [anon_sym_COLON_EQ] = ACTIONS(6315),
    [anon_sym_DASH_GT] = ACTIONS(6317),
    [anon_sym_DASH_GT_GT] = ACTIONS(6319),
    [anon_sym_PIPE] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6323),
    [anon_sym_PIPE_PIPE] = ACTIONS(6325),
    [anon_sym_AMP_AMP] = ACTIONS(6327),
    [anon_sym_LT] = ACTIONS(6329),
    [anon_sym_LT_EQ] = ACTIONS(6331),
    [anon_sym_GT] = ACTIONS(6329),
    [anon_sym_GT_EQ] = ACTIONS(6331),
    [anon_sym_EQ_EQ] = ACTIONS(6331),
    [anon_sym_BANG_EQ] = ACTIONS(6331),
    [anon_sym_STAR] = ACTIONS(6333),
    [anon_sym_SLASH] = ACTIONS(6335),
    [anon_sym_STAR_STAR] = ACTIONS(6337),
    [anon_sym_CARET] = ACTIONS(6337),
    [aux_sym_binary_operator_token1] = ACTIONS(6339),
    [anon_sym_PIPE_GT] = ACTIONS(6339),
    [anon_sym_COLON] = ACTIONS(6341),
    [anon_sym_DOLLAR] = ACTIONS(6343),
    [anon_sym_AT] = ACTIONS(6343),
    [aux_sym__hex_literal_token1] = ACTIONS(5413),
    [sym__number_literal] = ACTIONS(5415),
    [anon_sym_SQUOTE] = ACTIONS(5413),
    [anon_sym_DQUOTE] = ACTIONS(5413),
    [sym_return] = ACTIONS(5415),
    [sym_next] = ACTIONS(5415),
    [sym_break] = ACTIONS(5415),
    [sym_true] = ACTIONS(5415),
    [sym_false] = ACTIONS(5415),
    [sym_null] = ACTIONS(5415),
    [sym_inf] = ACTIONS(5415),
    [sym_nan] = ACTIONS(5415),
    [anon_sym_NA] = ACTIONS(5415),
    [anon_sym_NA_integer_] = ACTIONS(5415),
    [anon_sym_NA_real_] = ACTIONS(5415),
    [anon_sym_NA_complex_] = ACTIONS(5415),
    [anon_sym_NA_character_] = ACTIONS(5415),
    [sym_dots] = ACTIONS(5415),
    [sym_dot_dot_i] = ACTIONS(5413),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5413),
    [sym__newline] = ACTIONS(5413),
    [sym__raw_string_literal] = ACTIONS(5413),
    [sym__external_open_parenthesis] = ACTIONS(6345),
    [sym__external_close_parenthesis] = ACTIONS(5413),
    [sym__external_open_brace] = ACTIONS(5413),
    [sym__external_open_bracket] = ACTIONS(6347),
    [sym__external_open_bracket2] = ACTIONS(6349),
    [sym__external_close_bracket2] = ACTIONS(5413),
  },
  [1751] = {
    [sym_call_arguments] = STATE(2840),
    [sym_subset_arguments] = STATE(2797),
    [sym_subset2_arguments] = STATE(2801),
    [sym__open_parenthesis] = STATE(1344),
    [sym__open_bracket] = STATE(1374),
    [sym__open_bracket2] = STATE(1452),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(6267),
    [anon_sym_DASH] = ACTIONS(6269),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(6279),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(6283),
    [anon_sym_LT] = ACTIONS(6285),
    [anon_sym_LT_EQ] = ACTIONS(6287),
    [anon_sym_GT] = ACTIONS(6285),
    [anon_sym_GT_EQ] = ACTIONS(6287),
    [anon_sym_EQ_EQ] = ACTIONS(6287),
    [anon_sym_BANG_EQ] = ACTIONS(6287),
    [anon_sym_STAR] = ACTIONS(6289),
    [anon_sym_SLASH] = ACTIONS(6291),
    [anon_sym_STAR_STAR] = ACTIONS(6293),
    [anon_sym_CARET] = ACTIONS(6293),
    [aux_sym_binary_operator_token1] = ACTIONS(6295),
    [anon_sym_PIPE_GT] = ACTIONS(6295),
    [anon_sym_COLON] = ACTIONS(6297),
    [anon_sym_DOLLAR] = ACTIONS(6299),
    [anon_sym_AT] = ACTIONS(6299),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6301),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6303),
    [sym__external_open_bracket2] = ACTIONS(6305),
  },
  [1752] = {
    [sym_call_arguments] = STATE(2840),
    [sym_subset_arguments] = STATE(2797),
    [sym_subset2_arguments] = STATE(2801),
    [sym__open_parenthesis] = STATE(1344),
    [sym__open_bracket] = STATE(1374),
    [sym__open_bracket2] = STATE(1452),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(6265),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(6267),
    [anon_sym_DASH] = ACTIONS(6269),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(6277),
    [anon_sym_AMP] = ACTIONS(6279),
    [anon_sym_PIPE_PIPE] = ACTIONS(6281),
    [anon_sym_AMP_AMP] = ACTIONS(6283),
    [anon_sym_LT] = ACTIONS(6285),
    [anon_sym_LT_EQ] = ACTIONS(6287),
    [anon_sym_GT] = ACTIONS(6285),
    [anon_sym_GT_EQ] = ACTIONS(6287),
    [anon_sym_EQ_EQ] = ACTIONS(6287),
    [anon_sym_BANG_EQ] = ACTIONS(6287),
    [anon_sym_STAR] = ACTIONS(6289),
    [anon_sym_SLASH] = ACTIONS(6291),
    [anon_sym_STAR_STAR] = ACTIONS(6293),
    [anon_sym_CARET] = ACTIONS(6293),
    [aux_sym_binary_operator_token1] = ACTIONS(6295),
    [anon_sym_PIPE_GT] = ACTIONS(6295),
    [anon_sym_COLON] = ACTIONS(6297),
    [anon_sym_DOLLAR] = ACTIONS(6299),
    [anon_sym_AT] = ACTIONS(6299),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6301),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6303),
    [sym__external_open_bracket2] = ACTIONS(6305),
  },
  [1753] = {
    [sym_call_arguments] = STATE(2845),
    [sym_subset_arguments] = STATE(2849),
    [sym_subset2_arguments] = STATE(2852),
    [sym__open_parenthesis] = STATE(1372),
    [sym__open_bracket] = STATE(1371),
    [sym__open_bracket2] = STATE(1370),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(6185),
    [anon_sym_DASH] = ACTIONS(6187),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(6197),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(6201),
    [anon_sym_LT] = ACTIONS(6203),
    [anon_sym_LT_EQ] = ACTIONS(6205),
    [anon_sym_GT] = ACTIONS(6203),
    [anon_sym_GT_EQ] = ACTIONS(6205),
    [anon_sym_EQ_EQ] = ACTIONS(6205),
    [anon_sym_BANG_EQ] = ACTIONS(6205),
    [anon_sym_STAR] = ACTIONS(6207),
    [anon_sym_SLASH] = ACTIONS(6209),
    [anon_sym_STAR_STAR] = ACTIONS(6211),
    [anon_sym_CARET] = ACTIONS(6211),
    [aux_sym_binary_operator_token1] = ACTIONS(6213),
    [anon_sym_PIPE_GT] = ACTIONS(6213),
    [anon_sym_COLON] = ACTIONS(6215),
    [anon_sym_DOLLAR] = ACTIONS(6217),
    [anon_sym_AT] = ACTIONS(6217),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6221),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6223),
    [sym__external_open_bracket2] = ACTIONS(6225),
  },
  [1754] = {
    [sym_call_arguments] = STATE(2923),
    [sym_subset_arguments] = STATE(2922),
    [sym_subset2_arguments] = STATE(2906),
    [sym__open_parenthesis] = STATE(1528),
    [sym__open_bracket] = STATE(1525),
    [sym__open_bracket2] = STATE(1519),
    [ts_builtin_sym_end] = ACTIONS(5417),
    [sym_identifier] = ACTIONS(5419),
    [anon_sym_BSLASH] = ACTIONS(5417),
    [anon_sym_function] = ACTIONS(5419),
    [anon_sym_EQ] = ACTIONS(5947),
    [anon_sym_if] = ACTIONS(5419),
    [anon_sym_for] = ACTIONS(5419),
    [anon_sym_while] = ACTIONS(5419),
    [anon_sym_repeat] = ACTIONS(5419),
    [anon_sym_QMARK] = ACTIONS(5417),
    [anon_sym_TILDE] = ACTIONS(5949),
    [anon_sym_BANG] = ACTIONS(5419),
    [anon_sym_PLUS] = ACTIONS(5951),
    [anon_sym_DASH] = ACTIONS(5953),
    [anon_sym_LT_DASH] = ACTIONS(5955),
    [anon_sym_LT_LT_DASH] = ACTIONS(5955),
    [anon_sym_COLON_EQ] = ACTIONS(5955),
    [anon_sym_DASH_GT] = ACTIONS(5957),
    [anon_sym_DASH_GT_GT] = ACTIONS(5959),
    [anon_sym_PIPE] = ACTIONS(5961),
    [anon_sym_AMP] = ACTIONS(5963),
    [anon_sym_PIPE_PIPE] = ACTIONS(5965),
    [anon_sym_AMP_AMP] = ACTIONS(5967),
    [anon_sym_LT] = ACTIONS(5969),
    [anon_sym_LT_EQ] = ACTIONS(5971),
    [anon_sym_GT] = ACTIONS(5969),
    [anon_sym_GT_EQ] = ACTIONS(5971),
    [anon_sym_EQ_EQ] = ACTIONS(5971),
    [anon_sym_BANG_EQ] = ACTIONS(5971),
    [anon_sym_STAR] = ACTIONS(5973),
    [anon_sym_SLASH] = ACTIONS(5975),
    [anon_sym_STAR_STAR] = ACTIONS(5977),
    [anon_sym_CARET] = ACTIONS(5977),
    [aux_sym_binary_operator_token1] = ACTIONS(5979),
    [anon_sym_PIPE_GT] = ACTIONS(5979),
    [anon_sym_COLON] = ACTIONS(5981),
    [anon_sym_DOLLAR] = ACTIONS(5983),
    [anon_sym_AT] = ACTIONS(5983),
    [aux_sym__hex_literal_token1] = ACTIONS(5417),
    [sym__number_literal] = ACTIONS(5419),
    [anon_sym_SQUOTE] = ACTIONS(5417),
    [anon_sym_DQUOTE] = ACTIONS(5417),
    [sym_return] = ACTIONS(5419),
    [sym_next] = ACTIONS(5419),
    [sym_break] = ACTIONS(5419),
    [sym_true] = ACTIONS(5419),
    [sym_false] = ACTIONS(5419),
    [sym_null] = ACTIONS(5419),
    [sym_inf] = ACTIONS(5419),
    [sym_nan] = ACTIONS(5419),
    [anon_sym_NA] = ACTIONS(5419),
    [anon_sym_NA_integer_] = ACTIONS(5419),
    [anon_sym_NA_real_] = ACTIONS(5419),
    [anon_sym_NA_complex_] = ACTIONS(5419),
    [anon_sym_NA_character_] = ACTIONS(5419),
    [sym_dots] = ACTIONS(5419),
    [sym_dot_dot_i] = ACTIONS(5417),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5417),
    [sym__semicolon] = ACTIONS(5417),
    [sym__raw_string_literal] = ACTIONS(5417),
    [sym__external_else] = ACTIONS(5417),
    [sym__external_open_parenthesis] = ACTIONS(5987),
    [sym__external_open_brace] = ACTIONS(5417),
    [sym__external_open_bracket] = ACTIONS(5989),
    [sym__external_open_bracket2] = ACTIONS(5991),
  },
  [1755] = {
    [sym_function_definition] = STATE(1931),
    [sym_if_statement] = STATE(1931),
    [sym_for_statement] = STATE(1931),
    [sym_while_statement] = STATE(1931),
    [sym_repeat_statement] = STATE(1931),
    [sym_braced_expression] = STATE(1931),
    [sym_parenthesized_expression] = STATE(1931),
    [sym_call] = STATE(1931),
    [sym_subset] = STATE(1931),
    [sym_subset2] = STATE(1931),
    [sym__argument] = STATE(4656),
    [sym_argument] = STATE(4657),
    [sym__argument_named] = STATE(4658),
    [sym__argument_unnamed] = STATE(4662),
    [sym__argument_value] = STATE(4663),
    [sym_unary_operator] = STATE(1931),
    [sym_binary_operator] = STATE(1931),
    [sym_extract_operator] = STATE(1931),
    [sym_namespace_operator] = STATE(1931),
    [sym_integer] = STATE(1931),
    [sym_complex] = STATE(1931),
    [sym_float] = STATE(1931),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2633),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(1931),
    [sym__expression] = STATE(1931),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__close_parenthesis] = STATE(2950),
    [sym__open_brace] = STATE(154),
    [aux_sym_call_arguments_repeat1] = STATE(1375),
    [sym_identifier] = ACTIONS(6387),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(6389),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3865),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(6391),
    [sym_next] = ACTIONS(6391),
    [sym_break] = ACTIONS(6391),
    [sym_true] = ACTIONS(6391),
    [sym_false] = ACTIONS(6391),
    [sym_null] = ACTIONS(6391),
    [sym_inf] = ACTIONS(6391),
    [sym_nan] = ACTIONS(6391),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(6393),
    [sym_dot_dot_i] = ACTIONS(6395),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6397),
    [sym__newline] = ACTIONS(6399),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(6791),
    [sym__external_open_brace] = ACTIONS(3891),
  },
  [1756] = {
    [sym_call_arguments] = STATE(2840),
    [sym_subset_arguments] = STATE(2797),
    [sym_subset2_arguments] = STATE(2801),
    [sym__open_parenthesis] = STATE(1344),
    [sym__open_bracket] = STATE(1374),
    [sym__open_bracket2] = STATE(1452),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(6263),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(6265),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(6267),
    [anon_sym_DASH] = ACTIONS(6269),
    [anon_sym_LT_DASH] = ACTIONS(6271),
    [anon_sym_LT_LT_DASH] = ACTIONS(6271),
    [anon_sym_COLON_EQ] = ACTIONS(6271),
    [anon_sym_DASH_GT] = ACTIONS(6273),
    [anon_sym_DASH_GT_GT] = ACTIONS(6275),
    [anon_sym_PIPE] = ACTIONS(6277),
    [anon_sym_AMP] = ACTIONS(6279),
    [anon_sym_PIPE_PIPE] = ACTIONS(6281),
    [anon_sym_AMP_AMP] = ACTIONS(6283),
    [anon_sym_LT] = ACTIONS(6285),
    [anon_sym_LT_EQ] = ACTIONS(6287),
    [anon_sym_GT] = ACTIONS(6285),
    [anon_sym_GT_EQ] = ACTIONS(6287),
    [anon_sym_EQ_EQ] = ACTIONS(6287),
    [anon_sym_BANG_EQ] = ACTIONS(6287),
    [anon_sym_STAR] = ACTIONS(6289),
    [anon_sym_SLASH] = ACTIONS(6291),
    [anon_sym_STAR_STAR] = ACTIONS(6293),
    [anon_sym_CARET] = ACTIONS(6293),
    [aux_sym_binary_operator_token1] = ACTIONS(6295),
    [anon_sym_PIPE_GT] = ACTIONS(6295),
    [anon_sym_COLON] = ACTIONS(6297),
    [anon_sym_DOLLAR] = ACTIONS(6299),
    [anon_sym_AT] = ACTIONS(6299),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6301),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6303),
    [sym__external_open_bracket2] = ACTIONS(6305),
  },
  [1757] = {
    [sym_call_arguments] = STATE(2808),
    [sym_subset_arguments] = STATE(2920),
    [sym_subset2_arguments] = STATE(2919),
    [sym__open_parenthesis] = STATE(1545),
    [sym__open_bracket] = STATE(1541),
    [sym__open_bracket2] = STATE(1539),
    [sym_identifier] = ACTIONS(5419),
    [anon_sym_BSLASH] = ACTIONS(5417),
    [anon_sym_function] = ACTIONS(5419),
    [anon_sym_EQ] = ACTIONS(6307),
    [anon_sym_if] = ACTIONS(5419),
    [anon_sym_for] = ACTIONS(5419),
    [anon_sym_while] = ACTIONS(5419),
    [anon_sym_repeat] = ACTIONS(5419),
    [anon_sym_QMARK] = ACTIONS(5417),
    [anon_sym_TILDE] = ACTIONS(6309),
    [anon_sym_BANG] = ACTIONS(5419),
    [anon_sym_PLUS] = ACTIONS(6311),
    [anon_sym_DASH] = ACTIONS(6313),
    [anon_sym_LT_DASH] = ACTIONS(6315),
    [anon_sym_LT_LT_DASH] = ACTIONS(6315),
    [anon_sym_COLON_EQ] = ACTIONS(6315),
    [anon_sym_DASH_GT] = ACTIONS(6317),
    [anon_sym_DASH_GT_GT] = ACTIONS(6319),
    [anon_sym_PIPE] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6323),
    [anon_sym_PIPE_PIPE] = ACTIONS(6325),
    [anon_sym_AMP_AMP] = ACTIONS(6327),
    [anon_sym_LT] = ACTIONS(6329),
    [anon_sym_LT_EQ] = ACTIONS(6331),
    [anon_sym_GT] = ACTIONS(6329),
    [anon_sym_GT_EQ] = ACTIONS(6331),
    [anon_sym_EQ_EQ] = ACTIONS(6331),
    [anon_sym_BANG_EQ] = ACTIONS(6331),
    [anon_sym_STAR] = ACTIONS(6333),
    [anon_sym_SLASH] = ACTIONS(6335),
    [anon_sym_STAR_STAR] = ACTIONS(6337),
    [anon_sym_CARET] = ACTIONS(6337),
    [aux_sym_binary_operator_token1] = ACTIONS(6339),
    [anon_sym_PIPE_GT] = ACTIONS(6339),
    [anon_sym_COLON] = ACTIONS(6341),
    [anon_sym_DOLLAR] = ACTIONS(6343),
    [anon_sym_AT] = ACTIONS(6343),
    [aux_sym__hex_literal_token1] = ACTIONS(5417),
    [sym__number_literal] = ACTIONS(5419),
    [anon_sym_SQUOTE] = ACTIONS(5417),
    [anon_sym_DQUOTE] = ACTIONS(5417),
    [sym_return] = ACTIONS(5419),
    [sym_next] = ACTIONS(5419),
    [sym_break] = ACTIONS(5419),
    [sym_true] = ACTIONS(5419),
    [sym_false] = ACTIONS(5419),
    [sym_null] = ACTIONS(5419),
    [sym_inf] = ACTIONS(5419),
    [sym_nan] = ACTIONS(5419),
    [anon_sym_NA] = ACTIONS(5419),
    [anon_sym_NA_integer_] = ACTIONS(5419),
    [anon_sym_NA_real_] = ACTIONS(5419),
    [anon_sym_NA_complex_] = ACTIONS(5419),
    [anon_sym_NA_character_] = ACTIONS(5419),
    [sym_dots] = ACTIONS(5419),
    [sym_dot_dot_i] = ACTIONS(5417),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5417),
    [sym__newline] = ACTIONS(5417),
    [sym__raw_string_literal] = ACTIONS(5417),
    [sym__external_open_parenthesis] = ACTIONS(6345),
    [sym__external_close_parenthesis] = ACTIONS(5417),
    [sym__external_open_brace] = ACTIONS(5417),
    [sym__external_open_bracket] = ACTIONS(6347),
    [sym__external_open_bracket2] = ACTIONS(6349),
    [sym__external_close_bracket2] = ACTIONS(5417),
  },
  [1758] = {
    [sym_call_arguments] = STATE(2808),
    [sym_subset_arguments] = STATE(2920),
    [sym_subset2_arguments] = STATE(2919),
    [sym__open_parenthesis] = STATE(1545),
    [sym__open_bracket] = STATE(1541),
    [sym__open_bracket2] = STATE(1539),
    [sym_identifier] = ACTIONS(5423),
    [anon_sym_BSLASH] = ACTIONS(5421),
    [anon_sym_function] = ACTIONS(5423),
    [anon_sym_EQ] = ACTIONS(6307),
    [anon_sym_if] = ACTIONS(5423),
    [anon_sym_for] = ACTIONS(5423),
    [anon_sym_while] = ACTIONS(5423),
    [anon_sym_repeat] = ACTIONS(5423),
    [anon_sym_QMARK] = ACTIONS(5421),
    [anon_sym_TILDE] = ACTIONS(6309),
    [anon_sym_BANG] = ACTIONS(5423),
    [anon_sym_PLUS] = ACTIONS(6311),
    [anon_sym_DASH] = ACTIONS(6313),
    [anon_sym_LT_DASH] = ACTIONS(6315),
    [anon_sym_LT_LT_DASH] = ACTIONS(6315),
    [anon_sym_COLON_EQ] = ACTIONS(6315),
    [anon_sym_DASH_GT] = ACTIONS(6317),
    [anon_sym_DASH_GT_GT] = ACTIONS(6319),
    [anon_sym_PIPE] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6323),
    [anon_sym_PIPE_PIPE] = ACTIONS(6325),
    [anon_sym_AMP_AMP] = ACTIONS(6327),
    [anon_sym_LT] = ACTIONS(6329),
    [anon_sym_LT_EQ] = ACTIONS(6331),
    [anon_sym_GT] = ACTIONS(6329),
    [anon_sym_GT_EQ] = ACTIONS(6331),
    [anon_sym_EQ_EQ] = ACTIONS(6331),
    [anon_sym_BANG_EQ] = ACTIONS(6331),
    [anon_sym_STAR] = ACTIONS(6333),
    [anon_sym_SLASH] = ACTIONS(6335),
    [anon_sym_STAR_STAR] = ACTIONS(6337),
    [anon_sym_CARET] = ACTIONS(6337),
    [aux_sym_binary_operator_token1] = ACTIONS(6339),
    [anon_sym_PIPE_GT] = ACTIONS(6339),
    [anon_sym_COLON] = ACTIONS(6341),
    [anon_sym_DOLLAR] = ACTIONS(6343),
    [anon_sym_AT] = ACTIONS(6343),
    [aux_sym__hex_literal_token1] = ACTIONS(5421),
    [sym__number_literal] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5421),
    [anon_sym_DQUOTE] = ACTIONS(5421),
    [sym_return] = ACTIONS(5423),
    [sym_next] = ACTIONS(5423),
    [sym_break] = ACTIONS(5423),
    [sym_true] = ACTIONS(5423),
    [sym_false] = ACTIONS(5423),
    [sym_null] = ACTIONS(5423),
    [sym_inf] = ACTIONS(5423),
    [sym_nan] = ACTIONS(5423),
    [anon_sym_NA] = ACTIONS(5423),
    [anon_sym_NA_integer_] = ACTIONS(5423),
    [anon_sym_NA_real_] = ACTIONS(5423),
    [anon_sym_NA_complex_] = ACTIONS(5423),
    [anon_sym_NA_character_] = ACTIONS(5423),
    [sym_dots] = ACTIONS(5423),
    [sym_dot_dot_i] = ACTIONS(5421),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5421),
    [sym__newline] = ACTIONS(5421),
    [sym__raw_string_literal] = ACTIONS(5421),
    [sym__external_open_parenthesis] = ACTIONS(6345),
    [sym__external_close_parenthesis] = ACTIONS(5421),
    [sym__external_open_brace] = ACTIONS(5421),
    [sym__external_open_bracket] = ACTIONS(6347),
    [sym__external_open_bracket2] = ACTIONS(6349),
    [sym__external_close_bracket2] = ACTIONS(5421),
  },
  [1759] = {
    [sym_call_arguments] = STATE(2840),
    [sym_subset_arguments] = STATE(2797),
    [sym_subset2_arguments] = STATE(2801),
    [sym__open_parenthesis] = STATE(1344),
    [sym__open_bracket] = STATE(1374),
    [sym__open_bracket2] = STATE(1452),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(6267),
    [anon_sym_DASH] = ACTIONS(6269),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(6277),
    [anon_sym_AMP] = ACTIONS(6279),
    [anon_sym_PIPE_PIPE] = ACTIONS(6281),
    [anon_sym_AMP_AMP] = ACTIONS(6283),
    [anon_sym_LT] = ACTIONS(6285),
    [anon_sym_LT_EQ] = ACTIONS(6287),
    [anon_sym_GT] = ACTIONS(6285),
    [anon_sym_GT_EQ] = ACTIONS(6287),
    [anon_sym_EQ_EQ] = ACTIONS(6287),
    [anon_sym_BANG_EQ] = ACTIONS(6287),
    [anon_sym_STAR] = ACTIONS(6289),
    [anon_sym_SLASH] = ACTIONS(6291),
    [anon_sym_STAR_STAR] = ACTIONS(6293),
    [anon_sym_CARET] = ACTIONS(6293),
    [aux_sym_binary_operator_token1] = ACTIONS(6295),
    [anon_sym_PIPE_GT] = ACTIONS(6295),
    [anon_sym_COLON] = ACTIONS(6297),
    [anon_sym_DOLLAR] = ACTIONS(6299),
    [anon_sym_AT] = ACTIONS(6299),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6301),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6303),
    [sym__external_open_bracket2] = ACTIONS(6305),
  },
  [1760] = {
    [sym_call_arguments] = STATE(2808),
    [sym_subset_arguments] = STATE(2920),
    [sym_subset2_arguments] = STATE(2919),
    [sym__open_parenthesis] = STATE(1545),
    [sym__open_bracket] = STATE(1541),
    [sym__open_bracket2] = STATE(1539),
    [sym_identifier] = ACTIONS(5427),
    [anon_sym_BSLASH] = ACTIONS(5425),
    [anon_sym_function] = ACTIONS(5427),
    [anon_sym_EQ] = ACTIONS(6307),
    [anon_sym_if] = ACTIONS(5427),
    [anon_sym_for] = ACTIONS(5427),
    [anon_sym_while] = ACTIONS(5427),
    [anon_sym_repeat] = ACTIONS(5427),
    [anon_sym_QMARK] = ACTIONS(5425),
    [anon_sym_TILDE] = ACTIONS(6309),
    [anon_sym_BANG] = ACTIONS(5427),
    [anon_sym_PLUS] = ACTIONS(6311),
    [anon_sym_DASH] = ACTIONS(6313),
    [anon_sym_LT_DASH] = ACTIONS(6315),
    [anon_sym_LT_LT_DASH] = ACTIONS(6315),
    [anon_sym_COLON_EQ] = ACTIONS(6315),
    [anon_sym_DASH_GT] = ACTIONS(6317),
    [anon_sym_DASH_GT_GT] = ACTIONS(6319),
    [anon_sym_PIPE] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6323),
    [anon_sym_PIPE_PIPE] = ACTIONS(6325),
    [anon_sym_AMP_AMP] = ACTIONS(6327),
    [anon_sym_LT] = ACTIONS(6329),
    [anon_sym_LT_EQ] = ACTIONS(6331),
    [anon_sym_GT] = ACTIONS(6329),
    [anon_sym_GT_EQ] = ACTIONS(6331),
    [anon_sym_EQ_EQ] = ACTIONS(6331),
    [anon_sym_BANG_EQ] = ACTIONS(6331),
    [anon_sym_STAR] = ACTIONS(6333),
    [anon_sym_SLASH] = ACTIONS(6335),
    [anon_sym_STAR_STAR] = ACTIONS(6337),
    [anon_sym_CARET] = ACTIONS(6337),
    [aux_sym_binary_operator_token1] = ACTIONS(6339),
    [anon_sym_PIPE_GT] = ACTIONS(6339),
    [anon_sym_COLON] = ACTIONS(6341),
    [anon_sym_DOLLAR] = ACTIONS(6343),
    [anon_sym_AT] = ACTIONS(6343),
    [aux_sym__hex_literal_token1] = ACTIONS(5425),
    [sym__number_literal] = ACTIONS(5427),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_DQUOTE] = ACTIONS(5425),
    [sym_return] = ACTIONS(5427),
    [sym_next] = ACTIONS(5427),
    [sym_break] = ACTIONS(5427),
    [sym_true] = ACTIONS(5427),
    [sym_false] = ACTIONS(5427),
    [sym_null] = ACTIONS(5427),
    [sym_inf] = ACTIONS(5427),
    [sym_nan] = ACTIONS(5427),
    [anon_sym_NA] = ACTIONS(5427),
    [anon_sym_NA_integer_] = ACTIONS(5427),
    [anon_sym_NA_real_] = ACTIONS(5427),
    [anon_sym_NA_complex_] = ACTIONS(5427),
    [anon_sym_NA_character_] = ACTIONS(5427),
    [sym_dots] = ACTIONS(5427),
    [sym_dot_dot_i] = ACTIONS(5425),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5425),
    [sym__newline] = ACTIONS(5425),
    [sym__raw_string_literal] = ACTIONS(5425),
    [sym__external_open_parenthesis] = ACTIONS(6345),
    [sym__external_close_parenthesis] = ACTIONS(5425),
    [sym__external_open_brace] = ACTIONS(5425),
    [sym__external_open_bracket] = ACTIONS(6347),
    [sym__external_open_bracket2] = ACTIONS(6349),
    [sym__external_close_bracket2] = ACTIONS(5425),
  },
  [1761] = {
    [sym_call_arguments] = STATE(2845),
    [sym_subset_arguments] = STATE(2849),
    [sym_subset2_arguments] = STATE(2852),
    [sym__open_parenthesis] = STATE(1372),
    [sym__open_bracket] = STATE(1371),
    [sym__open_bracket2] = STATE(1370),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(6183),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(6185),
    [anon_sym_DASH] = ACTIONS(6187),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(6195),
    [anon_sym_AMP] = ACTIONS(6197),
    [anon_sym_PIPE_PIPE] = ACTIONS(6199),
    [anon_sym_AMP_AMP] = ACTIONS(6201),
    [anon_sym_LT] = ACTIONS(6203),
    [anon_sym_LT_EQ] = ACTIONS(6205),
    [anon_sym_GT] = ACTIONS(6203),
    [anon_sym_GT_EQ] = ACTIONS(6205),
    [anon_sym_EQ_EQ] = ACTIONS(6205),
    [anon_sym_BANG_EQ] = ACTIONS(6205),
    [anon_sym_STAR] = ACTIONS(6207),
    [anon_sym_SLASH] = ACTIONS(6209),
    [anon_sym_STAR_STAR] = ACTIONS(6211),
    [anon_sym_CARET] = ACTIONS(6211),
    [aux_sym_binary_operator_token1] = ACTIONS(6213),
    [anon_sym_PIPE_GT] = ACTIONS(6213),
    [anon_sym_COLON] = ACTIONS(6215),
    [anon_sym_DOLLAR] = ACTIONS(6217),
    [anon_sym_AT] = ACTIONS(6217),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6221),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6223),
    [sym__external_open_bracket2] = ACTIONS(6225),
  },
  [1762] = {
    [sym_call_arguments] = STATE(2845),
    [sym_subset_arguments] = STATE(2849),
    [sym_subset2_arguments] = STATE(2852),
    [sym__open_parenthesis] = STATE(1372),
    [sym__open_bracket] = STATE(1371),
    [sym__open_bracket2] = STATE(1370),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(6181),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(6183),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(6185),
    [anon_sym_DASH] = ACTIONS(6187),
    [anon_sym_LT_DASH] = ACTIONS(6189),
    [anon_sym_LT_LT_DASH] = ACTIONS(6189),
    [anon_sym_COLON_EQ] = ACTIONS(6189),
    [anon_sym_DASH_GT] = ACTIONS(6191),
    [anon_sym_DASH_GT_GT] = ACTIONS(6193),
    [anon_sym_PIPE] = ACTIONS(6195),
    [anon_sym_AMP] = ACTIONS(6197),
    [anon_sym_PIPE_PIPE] = ACTIONS(6199),
    [anon_sym_AMP_AMP] = ACTIONS(6201),
    [anon_sym_LT] = ACTIONS(6203),
    [anon_sym_LT_EQ] = ACTIONS(6205),
    [anon_sym_GT] = ACTIONS(6203),
    [anon_sym_GT_EQ] = ACTIONS(6205),
    [anon_sym_EQ_EQ] = ACTIONS(6205),
    [anon_sym_BANG_EQ] = ACTIONS(6205),
    [anon_sym_STAR] = ACTIONS(6207),
    [anon_sym_SLASH] = ACTIONS(6209),
    [anon_sym_STAR_STAR] = ACTIONS(6211),
    [anon_sym_CARET] = ACTIONS(6211),
    [aux_sym_binary_operator_token1] = ACTIONS(6213),
    [anon_sym_PIPE_GT] = ACTIONS(6213),
    [anon_sym_COLON] = ACTIONS(6215),
    [anon_sym_DOLLAR] = ACTIONS(6217),
    [anon_sym_AT] = ACTIONS(6217),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6221),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6223),
    [sym__external_open_bracket2] = ACTIONS(6225),
  },
  [1763] = {
    [sym_function_definition] = STATE(2038),
    [sym_if_statement] = STATE(2038),
    [sym_for_statement] = STATE(2038),
    [sym_while_statement] = STATE(2038),
    [sym_repeat_statement] = STATE(2038),
    [sym_braced_expression] = STATE(2038),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_call] = STATE(2038),
    [sym_subset] = STATE(2038),
    [sym_subset2] = STATE(2038),
    [sym__argument] = STATE(4664),
    [sym_argument] = STATE(4659),
    [sym__argument_named] = STATE(4654),
    [sym__argument_unnamed] = STATE(4676),
    [sym__argument_value] = STATE(4677),
    [sym_unary_operator] = STATE(2038),
    [sym_binary_operator] = STATE(2038),
    [sym_extract_operator] = STATE(2038),
    [sym_namespace_operator] = STATE(2038),
    [sym_integer] = STATE(2038),
    [sym_complex] = STATE(2038),
    [sym_float] = STATE(2038),
    [sym__hex_literal] = STATE(2700),
    [sym__float_literal] = STATE(2700),
    [sym_string] = STATE(2597),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym_na] = STATE(2038),
    [sym__expression] = STATE(2038),
    [sym__string_or_identifier] = STATE(5148),
    [sym__open_parenthesis] = STATE(214),
    [sym__open_brace] = STATE(192),
    [sym__close_bracket] = STATE(2951),
    [aux_sym_call_arguments_repeat1] = STATE(1326),
    [sym_identifier] = ACTIONS(6351),
    [anon_sym_BSLASH] = ACTIONS(4754),
    [anon_sym_function] = ACTIONS(4756),
    [anon_sym_if] = ACTIONS(4758),
    [anon_sym_for] = ACTIONS(4760),
    [anon_sym_while] = ACTIONS(4762),
    [anon_sym_repeat] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4766),
    [anon_sym_TILDE] = ACTIONS(4768),
    [anon_sym_BANG] = ACTIONS(6353),
    [anon_sym_PLUS] = ACTIONS(4772),
    [anon_sym_DASH] = ACTIONS(4772),
    [aux_sym__hex_literal_token1] = ACTIONS(4776),
    [sym__number_literal] = ACTIONS(4778),
    [anon_sym_SQUOTE] = ACTIONS(4780),
    [anon_sym_DQUOTE] = ACTIONS(4782),
    [sym_return] = ACTIONS(6355),
    [sym_next] = ACTIONS(6355),
    [sym_break] = ACTIONS(6355),
    [sym_true] = ACTIONS(6355),
    [sym_false] = ACTIONS(6355),
    [sym_null] = ACTIONS(6355),
    [sym_inf] = ACTIONS(6355),
    [sym_nan] = ACTIONS(6355),
    [anon_sym_NA] = ACTIONS(4786),
    [anon_sym_NA_integer_] = ACTIONS(4786),
    [anon_sym_NA_real_] = ACTIONS(4786),
    [anon_sym_NA_complex_] = ACTIONS(4786),
    [anon_sym_NA_character_] = ACTIONS(4786),
    [sym_dots] = ACTIONS(6357),
    [sym_dot_dot_i] = ACTIONS(6359),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6361),
    [sym__newline] = ACTIONS(6363),
    [sym__raw_string_literal] = ACTIONS(4790),
    [sym__external_open_parenthesis] = ACTIONS(4792),
    [sym__external_open_brace] = ACTIONS(4794),
    [sym__external_close_bracket] = ACTIONS(6793),
  },
  [1764] = {
    [sym_call_arguments] = STATE(2808),
    [sym_subset_arguments] = STATE(2920),
    [sym_subset2_arguments] = STATE(2919),
    [sym__open_parenthesis] = STATE(1545),
    [sym__open_bracket] = STATE(1541),
    [sym__open_bracket2] = STATE(1539),
    [sym_identifier] = ACTIONS(5431),
    [anon_sym_BSLASH] = ACTIONS(5429),
    [anon_sym_function] = ACTIONS(5431),
    [anon_sym_EQ] = ACTIONS(6307),
    [anon_sym_if] = ACTIONS(5431),
    [anon_sym_for] = ACTIONS(5431),
    [anon_sym_while] = ACTIONS(5431),
    [anon_sym_repeat] = ACTIONS(5431),
    [anon_sym_QMARK] = ACTIONS(5429),
    [anon_sym_TILDE] = ACTIONS(6309),
    [anon_sym_BANG] = ACTIONS(5431),
    [anon_sym_PLUS] = ACTIONS(6311),
    [anon_sym_DASH] = ACTIONS(6313),
    [anon_sym_LT_DASH] = ACTIONS(6315),
    [anon_sym_LT_LT_DASH] = ACTIONS(6315),
    [anon_sym_COLON_EQ] = ACTIONS(6315),
    [anon_sym_DASH_GT] = ACTIONS(6317),
    [anon_sym_DASH_GT_GT] = ACTIONS(6319),
    [anon_sym_PIPE] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6323),
    [anon_sym_PIPE_PIPE] = ACTIONS(6325),
    [anon_sym_AMP_AMP] = ACTIONS(6327),
    [anon_sym_LT] = ACTIONS(6329),
    [anon_sym_LT_EQ] = ACTIONS(6331),
    [anon_sym_GT] = ACTIONS(6329),
    [anon_sym_GT_EQ] = ACTIONS(6331),
    [anon_sym_EQ_EQ] = ACTIONS(6331),
    [anon_sym_BANG_EQ] = ACTIONS(6331),
    [anon_sym_STAR] = ACTIONS(6333),
    [anon_sym_SLASH] = ACTIONS(6335),
    [anon_sym_STAR_STAR] = ACTIONS(6337),
    [anon_sym_CARET] = ACTIONS(6337),
    [aux_sym_binary_operator_token1] = ACTIONS(6339),
    [anon_sym_PIPE_GT] = ACTIONS(6339),
    [anon_sym_COLON] = ACTIONS(6341),
    [anon_sym_DOLLAR] = ACTIONS(6343),
    [anon_sym_AT] = ACTIONS(6343),
    [aux_sym__hex_literal_token1] = ACTIONS(5429),
    [sym__number_literal] = ACTIONS(5431),
    [anon_sym_SQUOTE] = ACTIONS(5429),
    [anon_sym_DQUOTE] = ACTIONS(5429),
    [sym_return] = ACTIONS(5431),
    [sym_next] = ACTIONS(5431),
    [sym_break] = ACTIONS(5431),
    [sym_true] = ACTIONS(5431),
    [sym_false] = ACTIONS(5431),
    [sym_null] = ACTIONS(5431),
    [sym_inf] = ACTIONS(5431),
    [sym_nan] = ACTIONS(5431),
    [anon_sym_NA] = ACTIONS(5431),
    [anon_sym_NA_integer_] = ACTIONS(5431),
    [anon_sym_NA_real_] = ACTIONS(5431),
    [anon_sym_NA_complex_] = ACTIONS(5431),
    [anon_sym_NA_character_] = ACTIONS(5431),
    [sym_dots] = ACTIONS(5431),
    [sym_dot_dot_i] = ACTIONS(5429),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5429),
    [sym__newline] = ACTIONS(5429),
    [sym__raw_string_literal] = ACTIONS(5429),
    [sym__external_open_parenthesis] = ACTIONS(6345),
    [sym__external_close_parenthesis] = ACTIONS(5429),
    [sym__external_open_brace] = ACTIONS(5429),
    [sym__external_open_bracket] = ACTIONS(6347),
    [sym__external_open_bracket2] = ACTIONS(6349),
    [sym__external_close_bracket2] = ACTIONS(5429),
  },
  [1765] = {
    [sym_call_arguments] = STATE(2845),
    [sym_subset_arguments] = STATE(2849),
    [sym_subset2_arguments] = STATE(2852),
    [sym__open_parenthesis] = STATE(1372),
    [sym__open_bracket] = STATE(1371),
    [sym__open_bracket2] = STATE(1370),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(6207),
    [anon_sym_SLASH] = ACTIONS(6209),
    [anon_sym_STAR_STAR] = ACTIONS(6211),
    [anon_sym_CARET] = ACTIONS(6211),
    [aux_sym_binary_operator_token1] = ACTIONS(6213),
    [anon_sym_PIPE_GT] = ACTIONS(6213),
    [anon_sym_COLON] = ACTIONS(6215),
    [anon_sym_DOLLAR] = ACTIONS(6217),
    [anon_sym_AT] = ACTIONS(6217),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6221),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6223),
    [sym__external_open_bracket2] = ACTIONS(6225),
  },
  [1766] = {
    [sym_call_arguments] = STATE(2840),
    [sym_subset_arguments] = STATE(2797),
    [sym_subset2_arguments] = STATE(2801),
    [sym__open_parenthesis] = STATE(1344),
    [sym__open_bracket] = STATE(1374),
    [sym__open_bracket2] = STATE(1452),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(6263),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(6265),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(6267),
    [anon_sym_DASH] = ACTIONS(6269),
    [anon_sym_LT_DASH] = ACTIONS(6271),
    [anon_sym_LT_LT_DASH] = ACTIONS(6271),
    [anon_sym_COLON_EQ] = ACTIONS(6271),
    [anon_sym_DASH_GT] = ACTIONS(6273),
    [anon_sym_DASH_GT_GT] = ACTIONS(6275),
    [anon_sym_PIPE] = ACTIONS(6277),
    [anon_sym_AMP] = ACTIONS(6279),
    [anon_sym_PIPE_PIPE] = ACTIONS(6281),
    [anon_sym_AMP_AMP] = ACTIONS(6283),
    [anon_sym_LT] = ACTIONS(6285),
    [anon_sym_LT_EQ] = ACTIONS(6287),
    [anon_sym_GT] = ACTIONS(6285),
    [anon_sym_GT_EQ] = ACTIONS(6287),
    [anon_sym_EQ_EQ] = ACTIONS(6287),
    [anon_sym_BANG_EQ] = ACTIONS(6287),
    [anon_sym_STAR] = ACTIONS(6289),
    [anon_sym_SLASH] = ACTIONS(6291),
    [anon_sym_STAR_STAR] = ACTIONS(6293),
    [anon_sym_CARET] = ACTIONS(6293),
    [aux_sym_binary_operator_token1] = ACTIONS(6295),
    [anon_sym_PIPE_GT] = ACTIONS(6295),
    [anon_sym_COLON] = ACTIONS(6297),
    [anon_sym_DOLLAR] = ACTIONS(6299),
    [anon_sym_AT] = ACTIONS(6299),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6301),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6303),
    [sym__external_open_bracket2] = ACTIONS(6305),
  },
  [1767] = {
    [sym_call_arguments] = STATE(2808),
    [sym_subset_arguments] = STATE(2920),
    [sym_subset2_arguments] = STATE(2919),
    [sym__open_parenthesis] = STATE(1545),
    [sym__open_bracket] = STATE(1541),
    [sym__open_bracket2] = STATE(1539),
    [sym_identifier] = ACTIONS(5435),
    [anon_sym_BSLASH] = ACTIONS(5433),
    [anon_sym_function] = ACTIONS(5435),
    [anon_sym_EQ] = ACTIONS(6307),
    [anon_sym_if] = ACTIONS(5435),
    [anon_sym_for] = ACTIONS(5435),
    [anon_sym_while] = ACTIONS(5435),
    [anon_sym_repeat] = ACTIONS(5435),
    [anon_sym_QMARK] = ACTIONS(5433),
    [anon_sym_TILDE] = ACTIONS(6309),
    [anon_sym_BANG] = ACTIONS(5435),
    [anon_sym_PLUS] = ACTIONS(6311),
    [anon_sym_DASH] = ACTIONS(6313),
    [anon_sym_LT_DASH] = ACTIONS(6315),
    [anon_sym_LT_LT_DASH] = ACTIONS(6315),
    [anon_sym_COLON_EQ] = ACTIONS(6315),
    [anon_sym_DASH_GT] = ACTIONS(6317),
    [anon_sym_DASH_GT_GT] = ACTIONS(6319),
    [anon_sym_PIPE] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6323),
    [anon_sym_PIPE_PIPE] = ACTIONS(6325),
    [anon_sym_AMP_AMP] = ACTIONS(6327),
    [anon_sym_LT] = ACTIONS(6329),
    [anon_sym_LT_EQ] = ACTIONS(6331),
    [anon_sym_GT] = ACTIONS(6329),
    [anon_sym_GT_EQ] = ACTIONS(6331),
    [anon_sym_EQ_EQ] = ACTIONS(6331),
    [anon_sym_BANG_EQ] = ACTIONS(6331),
    [anon_sym_STAR] = ACTIONS(6333),
    [anon_sym_SLASH] = ACTIONS(6335),
    [anon_sym_STAR_STAR] = ACTIONS(6337),
    [anon_sym_CARET] = ACTIONS(6337),
    [aux_sym_binary_operator_token1] = ACTIONS(6339),
    [anon_sym_PIPE_GT] = ACTIONS(6339),
    [anon_sym_COLON] = ACTIONS(6341),
    [anon_sym_DOLLAR] = ACTIONS(6343),
    [anon_sym_AT] = ACTIONS(6343),
    [aux_sym__hex_literal_token1] = ACTIONS(5433),
    [sym__number_literal] = ACTIONS(5435),
    [anon_sym_SQUOTE] = ACTIONS(5433),
    [anon_sym_DQUOTE] = ACTIONS(5433),
    [sym_return] = ACTIONS(5435),
    [sym_next] = ACTIONS(5435),
    [sym_break] = ACTIONS(5435),
    [sym_true] = ACTIONS(5435),
    [sym_false] = ACTIONS(5435),
    [sym_null] = ACTIONS(5435),
    [sym_inf] = ACTIONS(5435),
    [sym_nan] = ACTIONS(5435),
    [anon_sym_NA] = ACTIONS(5435),
    [anon_sym_NA_integer_] = ACTIONS(5435),
    [anon_sym_NA_real_] = ACTIONS(5435),
    [anon_sym_NA_complex_] = ACTIONS(5435),
    [anon_sym_NA_character_] = ACTIONS(5435),
    [sym_dots] = ACTIONS(5435),
    [sym_dot_dot_i] = ACTIONS(5433),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5433),
    [sym__newline] = ACTIONS(5433),
    [sym__raw_string_literal] = ACTIONS(5433),
    [sym__external_open_parenthesis] = ACTIONS(6345),
    [sym__external_close_parenthesis] = ACTIONS(5433),
    [sym__external_open_brace] = ACTIONS(5433),
    [sym__external_open_bracket] = ACTIONS(6347),
    [sym__external_open_bracket2] = ACTIONS(6349),
    [sym__external_close_bracket2] = ACTIONS(5433),
  },
  [1768] = {
    [sym_call_arguments] = STATE(2808),
    [sym_subset_arguments] = STATE(2920),
    [sym_subset2_arguments] = STATE(2919),
    [sym__open_parenthesis] = STATE(1545),
    [sym__open_bracket] = STATE(1541),
    [sym__open_bracket2] = STATE(1539),
    [sym_identifier] = ACTIONS(5439),
    [anon_sym_BSLASH] = ACTIONS(5437),
    [anon_sym_function] = ACTIONS(5439),
    [anon_sym_EQ] = ACTIONS(6307),
    [anon_sym_if] = ACTIONS(5439),
    [anon_sym_for] = ACTIONS(5439),
    [anon_sym_while] = ACTIONS(5439),
    [anon_sym_repeat] = ACTIONS(5439),
    [anon_sym_QMARK] = ACTIONS(5437),
    [anon_sym_TILDE] = ACTIONS(6309),
    [anon_sym_BANG] = ACTIONS(5439),
    [anon_sym_PLUS] = ACTIONS(6311),
    [anon_sym_DASH] = ACTIONS(6313),
    [anon_sym_LT_DASH] = ACTIONS(6315),
    [anon_sym_LT_LT_DASH] = ACTIONS(6315),
    [anon_sym_COLON_EQ] = ACTIONS(6315),
    [anon_sym_DASH_GT] = ACTIONS(6317),
    [anon_sym_DASH_GT_GT] = ACTIONS(6319),
    [anon_sym_PIPE] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6323),
    [anon_sym_PIPE_PIPE] = ACTIONS(6325),
    [anon_sym_AMP_AMP] = ACTIONS(6327),
    [anon_sym_LT] = ACTIONS(6329),
    [anon_sym_LT_EQ] = ACTIONS(6331),
    [anon_sym_GT] = ACTIONS(6329),
    [anon_sym_GT_EQ] = ACTIONS(6331),
    [anon_sym_EQ_EQ] = ACTIONS(6331),
    [anon_sym_BANG_EQ] = ACTIONS(6331),
    [anon_sym_STAR] = ACTIONS(6333),
    [anon_sym_SLASH] = ACTIONS(6335),
    [anon_sym_STAR_STAR] = ACTIONS(6337),
    [anon_sym_CARET] = ACTIONS(6337),
    [aux_sym_binary_operator_token1] = ACTIONS(6339),
    [anon_sym_PIPE_GT] = ACTIONS(6339),
    [anon_sym_COLON] = ACTIONS(6341),
    [anon_sym_DOLLAR] = ACTIONS(6343),
    [anon_sym_AT] = ACTIONS(6343),
    [aux_sym__hex_literal_token1] = ACTIONS(5437),
    [sym__number_literal] = ACTIONS(5439),
    [anon_sym_SQUOTE] = ACTIONS(5437),
    [anon_sym_DQUOTE] = ACTIONS(5437),
    [sym_return] = ACTIONS(5439),
    [sym_next] = ACTIONS(5439),
    [sym_break] = ACTIONS(5439),
    [sym_true] = ACTIONS(5439),
    [sym_false] = ACTIONS(5439),
    [sym_null] = ACTIONS(5439),
    [sym_inf] = ACTIONS(5439),
    [sym_nan] = ACTIONS(5439),
    [anon_sym_NA] = ACTIONS(5439),
    [anon_sym_NA_integer_] = ACTIONS(5439),
    [anon_sym_NA_real_] = ACTIONS(5439),
    [anon_sym_NA_complex_] = ACTIONS(5439),
    [anon_sym_NA_character_] = ACTIONS(5439),
    [sym_dots] = ACTIONS(5439),
    [sym_dot_dot_i] = ACTIONS(5437),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5437),
    [sym__newline] = ACTIONS(5437),
    [sym__raw_string_literal] = ACTIONS(5437),
    [sym__external_open_parenthesis] = ACTIONS(6345),
    [sym__external_close_parenthesis] = ACTIONS(5437),
    [sym__external_open_brace] = ACTIONS(5437),
    [sym__external_open_bracket] = ACTIONS(6347),
    [sym__external_open_bracket2] = ACTIONS(6349),
    [sym__external_close_bracket2] = ACTIONS(5437),
  },
  [1769] = {
    [sym_call_arguments] = STATE(2808),
    [sym_subset_arguments] = STATE(2920),
    [sym_subset2_arguments] = STATE(2919),
    [sym__open_parenthesis] = STATE(1545),
    [sym__open_bracket] = STATE(1541),
    [sym__open_bracket2] = STATE(1539),
    [sym_identifier] = ACTIONS(5443),
    [anon_sym_BSLASH] = ACTIONS(5441),
    [anon_sym_function] = ACTIONS(5443),
    [anon_sym_EQ] = ACTIONS(6307),
    [anon_sym_if] = ACTIONS(5443),
    [anon_sym_for] = ACTIONS(5443),
    [anon_sym_while] = ACTIONS(5443),
    [anon_sym_repeat] = ACTIONS(5443),
    [anon_sym_QMARK] = ACTIONS(5441),
    [anon_sym_TILDE] = ACTIONS(6309),
    [anon_sym_BANG] = ACTIONS(5443),
    [anon_sym_PLUS] = ACTIONS(6311),
    [anon_sym_DASH] = ACTIONS(6313),
    [anon_sym_LT_DASH] = ACTIONS(6315),
    [anon_sym_LT_LT_DASH] = ACTIONS(6315),
    [anon_sym_COLON_EQ] = ACTIONS(6315),
    [anon_sym_DASH_GT] = ACTIONS(6317),
    [anon_sym_DASH_GT_GT] = ACTIONS(6319),
    [anon_sym_PIPE] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6323),
    [anon_sym_PIPE_PIPE] = ACTIONS(6325),
    [anon_sym_AMP_AMP] = ACTIONS(6327),
    [anon_sym_LT] = ACTIONS(6329),
    [anon_sym_LT_EQ] = ACTIONS(6331),
    [anon_sym_GT] = ACTIONS(6329),
    [anon_sym_GT_EQ] = ACTIONS(6331),
    [anon_sym_EQ_EQ] = ACTIONS(6331),
    [anon_sym_BANG_EQ] = ACTIONS(6331),
    [anon_sym_STAR] = ACTIONS(6333),
    [anon_sym_SLASH] = ACTIONS(6335),
    [anon_sym_STAR_STAR] = ACTIONS(6337),
    [anon_sym_CARET] = ACTIONS(6337),
    [aux_sym_binary_operator_token1] = ACTIONS(6339),
    [anon_sym_PIPE_GT] = ACTIONS(6339),
    [anon_sym_COLON] = ACTIONS(6341),
    [anon_sym_DOLLAR] = ACTIONS(6343),
    [anon_sym_AT] = ACTIONS(6343),
    [aux_sym__hex_literal_token1] = ACTIONS(5441),
    [sym__number_literal] = ACTIONS(5443),
    [anon_sym_SQUOTE] = ACTIONS(5441),
    [anon_sym_DQUOTE] = ACTIONS(5441),
    [sym_return] = ACTIONS(5443),
    [sym_next] = ACTIONS(5443),
    [sym_break] = ACTIONS(5443),
    [sym_true] = ACTIONS(5443),
    [sym_false] = ACTIONS(5443),
    [sym_null] = ACTIONS(5443),
    [sym_inf] = ACTIONS(5443),
    [sym_nan] = ACTIONS(5443),
    [anon_sym_NA] = ACTIONS(5443),
    [anon_sym_NA_integer_] = ACTIONS(5443),
    [anon_sym_NA_real_] = ACTIONS(5443),
    [anon_sym_NA_complex_] = ACTIONS(5443),
    [anon_sym_NA_character_] = ACTIONS(5443),
    [sym_dots] = ACTIONS(5443),
    [sym_dot_dot_i] = ACTIONS(5441),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5441),
    [sym__newline] = ACTIONS(5441),
    [sym__raw_string_literal] = ACTIONS(5441),
    [sym__external_open_parenthesis] = ACTIONS(6345),
    [sym__external_close_parenthesis] = ACTIONS(5441),
    [sym__external_open_brace] = ACTIONS(5441),
    [sym__external_open_bracket] = ACTIONS(6347),
    [sym__external_open_bracket2] = ACTIONS(6349),
    [sym__external_close_bracket2] = ACTIONS(5441),
  },
  [1770] = {
    [sym_call_arguments] = STATE(2845),
    [sym_subset_arguments] = STATE(2849),
    [sym_subset2_arguments] = STATE(2852),
    [sym__open_parenthesis] = STATE(1372),
    [sym__open_bracket] = STATE(1371),
    [sym__open_bracket2] = STATE(1370),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(6185),
    [anon_sym_DASH] = ACTIONS(6187),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(6195),
    [anon_sym_AMP] = ACTIONS(6197),
    [anon_sym_PIPE_PIPE] = ACTIONS(6199),
    [anon_sym_AMP_AMP] = ACTIONS(6201),
    [anon_sym_LT] = ACTIONS(6203),
    [anon_sym_LT_EQ] = ACTIONS(6205),
    [anon_sym_GT] = ACTIONS(6203),
    [anon_sym_GT_EQ] = ACTIONS(6205),
    [anon_sym_EQ_EQ] = ACTIONS(6205),
    [anon_sym_BANG_EQ] = ACTIONS(6205),
    [anon_sym_STAR] = ACTIONS(6207),
    [anon_sym_SLASH] = ACTIONS(6209),
    [anon_sym_STAR_STAR] = ACTIONS(6211),
    [anon_sym_CARET] = ACTIONS(6211),
    [aux_sym_binary_operator_token1] = ACTIONS(6213),
    [anon_sym_PIPE_GT] = ACTIONS(6213),
    [anon_sym_COLON] = ACTIONS(6215),
    [anon_sym_DOLLAR] = ACTIONS(6217),
    [anon_sym_AT] = ACTIONS(6217),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6221),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6223),
    [sym__external_open_bracket2] = ACTIONS(6225),
  },
  [1771] = {
    [sym_call_arguments] = STATE(2808),
    [sym_subset_arguments] = STATE(2920),
    [sym_subset2_arguments] = STATE(2919),
    [sym__open_parenthesis] = STATE(1545),
    [sym__open_bracket] = STATE(1541),
    [sym__open_bracket2] = STATE(1539),
    [sym_identifier] = ACTIONS(5447),
    [anon_sym_BSLASH] = ACTIONS(5445),
    [anon_sym_function] = ACTIONS(5447),
    [anon_sym_EQ] = ACTIONS(6307),
    [anon_sym_if] = ACTIONS(5447),
    [anon_sym_for] = ACTIONS(5447),
    [anon_sym_while] = ACTIONS(5447),
    [anon_sym_repeat] = ACTIONS(5447),
    [anon_sym_QMARK] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(6309),
    [anon_sym_BANG] = ACTIONS(5447),
    [anon_sym_PLUS] = ACTIONS(6311),
    [anon_sym_DASH] = ACTIONS(6313),
    [anon_sym_LT_DASH] = ACTIONS(6315),
    [anon_sym_LT_LT_DASH] = ACTIONS(6315),
    [anon_sym_COLON_EQ] = ACTIONS(6315),
    [anon_sym_DASH_GT] = ACTIONS(6317),
    [anon_sym_DASH_GT_GT] = ACTIONS(6319),
    [anon_sym_PIPE] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6323),
    [anon_sym_PIPE_PIPE] = ACTIONS(6325),
    [anon_sym_AMP_AMP] = ACTIONS(6327),
    [anon_sym_LT] = ACTIONS(6329),
    [anon_sym_LT_EQ] = ACTIONS(6331),
    [anon_sym_GT] = ACTIONS(6329),
    [anon_sym_GT_EQ] = ACTIONS(6331),
    [anon_sym_EQ_EQ] = ACTIONS(6331),
    [anon_sym_BANG_EQ] = ACTIONS(6331),
    [anon_sym_STAR] = ACTIONS(6333),
    [anon_sym_SLASH] = ACTIONS(6335),
    [anon_sym_STAR_STAR] = ACTIONS(6337),
    [anon_sym_CARET] = ACTIONS(6337),
    [aux_sym_binary_operator_token1] = ACTIONS(6339),
    [anon_sym_PIPE_GT] = ACTIONS(6339),
    [anon_sym_COLON] = ACTIONS(6341),
    [anon_sym_DOLLAR] = ACTIONS(6343),
    [anon_sym_AT] = ACTIONS(6343),
    [aux_sym__hex_literal_token1] = ACTIONS(5445),
    [sym__number_literal] = ACTIONS(5447),
    [anon_sym_SQUOTE] = ACTIONS(5445),
    [anon_sym_DQUOTE] = ACTIONS(5445),
    [sym_return] = ACTIONS(5447),
    [sym_next] = ACTIONS(5447),
    [sym_break] = ACTIONS(5447),
    [sym_true] = ACTIONS(5447),
    [sym_false] = ACTIONS(5447),
    [sym_null] = ACTIONS(5447),
    [sym_inf] = ACTIONS(5447),
    [sym_nan] = ACTIONS(5447),
    [anon_sym_NA] = ACTIONS(5447),
    [anon_sym_NA_integer_] = ACTIONS(5447),
    [anon_sym_NA_real_] = ACTIONS(5447),
    [anon_sym_NA_complex_] = ACTIONS(5447),
    [anon_sym_NA_character_] = ACTIONS(5447),
    [sym_dots] = ACTIONS(5447),
    [sym_dot_dot_i] = ACTIONS(5445),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5445),
    [sym__newline] = ACTIONS(5445),
    [sym__raw_string_literal] = ACTIONS(5445),
    [sym__external_open_parenthesis] = ACTIONS(6345),
    [sym__external_close_parenthesis] = ACTIONS(5445),
    [sym__external_open_brace] = ACTIONS(5445),
    [sym__external_open_bracket] = ACTIONS(6347),
    [sym__external_open_bracket2] = ACTIONS(6349),
    [sym__external_close_bracket2] = ACTIONS(5445),
  },
  [1772] = {
    [sym_call_arguments] = STATE(2808),
    [sym_subset_arguments] = STATE(2920),
    [sym_subset2_arguments] = STATE(2919),
    [sym__open_parenthesis] = STATE(1545),
    [sym__open_bracket] = STATE(1541),
    [sym__open_bracket2] = STATE(1539),
    [sym_identifier] = ACTIONS(5451),
    [anon_sym_BSLASH] = ACTIONS(5449),
    [anon_sym_function] = ACTIONS(5451),
    [anon_sym_EQ] = ACTIONS(6307),
    [anon_sym_if] = ACTIONS(5451),
    [anon_sym_for] = ACTIONS(5451),
    [anon_sym_while] = ACTIONS(5451),
    [anon_sym_repeat] = ACTIONS(5451),
    [anon_sym_QMARK] = ACTIONS(5449),
    [anon_sym_TILDE] = ACTIONS(6309),
    [anon_sym_BANG] = ACTIONS(5451),
    [anon_sym_PLUS] = ACTIONS(6311),
    [anon_sym_DASH] = ACTIONS(6313),
    [anon_sym_LT_DASH] = ACTIONS(6315),
    [anon_sym_LT_LT_DASH] = ACTIONS(6315),
    [anon_sym_COLON_EQ] = ACTIONS(6315),
    [anon_sym_DASH_GT] = ACTIONS(6317),
    [anon_sym_DASH_GT_GT] = ACTIONS(6319),
    [anon_sym_PIPE] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6323),
    [anon_sym_PIPE_PIPE] = ACTIONS(6325),
    [anon_sym_AMP_AMP] = ACTIONS(6327),
    [anon_sym_LT] = ACTIONS(6329),
    [anon_sym_LT_EQ] = ACTIONS(6331),
    [anon_sym_GT] = ACTIONS(6329),
    [anon_sym_GT_EQ] = ACTIONS(6331),
    [anon_sym_EQ_EQ] = ACTIONS(6331),
    [anon_sym_BANG_EQ] = ACTIONS(6331),
    [anon_sym_STAR] = ACTIONS(6333),
    [anon_sym_SLASH] = ACTIONS(6335),
    [anon_sym_STAR_STAR] = ACTIONS(6337),
    [anon_sym_CARET] = ACTIONS(6337),
    [aux_sym_binary_operator_token1] = ACTIONS(6339),
    [anon_sym_PIPE_GT] = ACTIONS(6339),
    [anon_sym_COLON] = ACTIONS(6341),
    [anon_sym_DOLLAR] = ACTIONS(6343),
    [anon_sym_AT] = ACTIONS(6343),
    [aux_sym__hex_literal_token1] = ACTIONS(5449),
    [sym__number_literal] = ACTIONS(5451),
    [anon_sym_SQUOTE] = ACTIONS(5449),
    [anon_sym_DQUOTE] = ACTIONS(5449),
    [sym_return] = ACTIONS(5451),
    [sym_next] = ACTIONS(5451),
    [sym_break] = ACTIONS(5451),
    [sym_true] = ACTIONS(5451),
    [sym_false] = ACTIONS(5451),
    [sym_null] = ACTIONS(5451),
    [sym_inf] = ACTIONS(5451),
    [sym_nan] = ACTIONS(5451),
    [anon_sym_NA] = ACTIONS(5451),
    [anon_sym_NA_integer_] = ACTIONS(5451),
    [anon_sym_NA_real_] = ACTIONS(5451),
    [anon_sym_NA_complex_] = ACTIONS(5451),
    [anon_sym_NA_character_] = ACTIONS(5451),
    [sym_dots] = ACTIONS(5451),
    [sym_dot_dot_i] = ACTIONS(5449),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5449),
    [sym__newline] = ACTIONS(5449),
    [sym__raw_string_literal] = ACTIONS(5449),
    [sym__external_open_parenthesis] = ACTIONS(6345),
    [sym__external_close_parenthesis] = ACTIONS(5449),
    [sym__external_open_brace] = ACTIONS(5449),
    [sym__external_open_bracket] = ACTIONS(6347),
    [sym__external_open_bracket2] = ACTIONS(6349),
    [sym__external_close_bracket2] = ACTIONS(5449),
  },
  [1773] = {
    [sym_call_arguments] = STATE(2840),
    [sym_subset_arguments] = STATE(2797),
    [sym_subset2_arguments] = STATE(2801),
    [sym__open_parenthesis] = STATE(1344),
    [sym__open_bracket] = STATE(1374),
    [sym__open_bracket2] = STATE(1452),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(6263),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(6265),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(6267),
    [anon_sym_DASH] = ACTIONS(6269),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(6273),
    [anon_sym_DASH_GT_GT] = ACTIONS(6275),
    [anon_sym_PIPE] = ACTIONS(6277),
    [anon_sym_AMP] = ACTIONS(6279),
    [anon_sym_PIPE_PIPE] = ACTIONS(6281),
    [anon_sym_AMP_AMP] = ACTIONS(6283),
    [anon_sym_LT] = ACTIONS(6285),
    [anon_sym_LT_EQ] = ACTIONS(6287),
    [anon_sym_GT] = ACTIONS(6285),
    [anon_sym_GT_EQ] = ACTIONS(6287),
    [anon_sym_EQ_EQ] = ACTIONS(6287),
    [anon_sym_BANG_EQ] = ACTIONS(6287),
    [anon_sym_STAR] = ACTIONS(6289),
    [anon_sym_SLASH] = ACTIONS(6291),
    [anon_sym_STAR_STAR] = ACTIONS(6293),
    [anon_sym_CARET] = ACTIONS(6293),
    [aux_sym_binary_operator_token1] = ACTIONS(6295),
    [anon_sym_PIPE_GT] = ACTIONS(6295),
    [anon_sym_COLON] = ACTIONS(6297),
    [anon_sym_DOLLAR] = ACTIONS(6299),
    [anon_sym_AT] = ACTIONS(6299),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6301),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_close_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6303),
    [sym__external_open_bracket2] = ACTIONS(6305),
  },
  [1774] = {
    [sym_call_arguments] = STATE(2840),
    [sym_subset_arguments] = STATE(2797),
    [sym_subset2_arguments] = STATE(2801),
    [sym__open_parenthesis] = STATE(1344),
    [sym__open_bracket] = STATE(1374),
    [sym__open_bracket2] = STATE(1452),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(6267),
    [anon_sym_DASH] = ACTIONS(6269),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(6279),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(6283),
    [anon_sym_LT] = ACTIONS(6285),
    [anon_sym_LT_EQ] = ACTIONS(6287),
    [anon_sym_GT] = ACTIONS(6285),
    [anon_sym_GT_EQ] = ACTIONS(6287),
    [anon_sym_EQ_EQ] = ACTIONS(6287),
    [anon_sym_BANG_EQ] = ACTIONS(6287),
    [anon_sym_STAR] = ACTIONS(6289),
    [anon_sym_SLASH] = ACTIONS(6291),
    [anon_sym_STAR_STAR] = ACTIONS(6293),
    [anon_sym_CARET] = ACTIONS(6293),
    [aux_sym_binary_operator_token1] = ACTIONS(6295),
    [anon_sym_PIPE_GT] = ACTIONS(6295),
    [anon_sym_COLON] = ACTIONS(6297),
    [anon_sym_DOLLAR] = ACTIONS(6299),
    [anon_sym_AT] = ACTIONS(6299),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6301),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6303),
    [sym__external_open_bracket2] = ACTIONS(6305),
  },
  [1775] = {
    [sym_call_arguments] = STATE(2808),
    [sym_subset_arguments] = STATE(2920),
    [sym_subset2_arguments] = STATE(2919),
    [sym__open_parenthesis] = STATE(1545),
    [sym__open_bracket] = STATE(1541),
    [sym__open_bracket2] = STATE(1539),
    [sym_identifier] = ACTIONS(5411),
    [anon_sym_BSLASH] = ACTIONS(5409),
    [anon_sym_function] = ACTIONS(5411),
    [anon_sym_EQ] = ACTIONS(6307),
    [anon_sym_if] = ACTIONS(5411),
    [anon_sym_for] = ACTIONS(5411),
    [anon_sym_while] = ACTIONS(5411),
    [anon_sym_repeat] = ACTIONS(5411),
    [anon_sym_QMARK] = ACTIONS(5409),
    [anon_sym_TILDE] = ACTIONS(6309),
    [anon_sym_BANG] = ACTIONS(5411),
    [anon_sym_PLUS] = ACTIONS(6311),
    [anon_sym_DASH] = ACTIONS(6313),
    [anon_sym_LT_DASH] = ACTIONS(6315),
    [anon_sym_LT_LT_DASH] = ACTIONS(6315),
    [anon_sym_COLON_EQ] = ACTIONS(6315),
    [anon_sym_DASH_GT] = ACTIONS(6317),
    [anon_sym_DASH_GT_GT] = ACTIONS(6319),
    [anon_sym_PIPE] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6323),
    [anon_sym_PIPE_PIPE] = ACTIONS(6325),
    [anon_sym_AMP_AMP] = ACTIONS(6327),
    [anon_sym_LT] = ACTIONS(6329),
    [anon_sym_LT_EQ] = ACTIONS(6331),
    [anon_sym_GT] = ACTIONS(6329),
    [anon_sym_GT_EQ] = ACTIONS(6331),
    [anon_sym_EQ_EQ] = ACTIONS(6331),
    [anon_sym_BANG_EQ] = ACTIONS(6331),
    [anon_sym_STAR] = ACTIONS(6333),
    [anon_sym_SLASH] = ACTIONS(6335),
    [anon_sym_STAR_STAR] = ACTIONS(6337),
    [anon_sym_CARET] = ACTIONS(6337),
    [aux_sym_binary_operator_token1] = ACTIONS(6339),
    [anon_sym_PIPE_GT] = ACTIONS(6339),
    [anon_sym_COLON] = ACTIONS(6341),
    [anon_sym_DOLLAR] = ACTIONS(6343),
    [anon_sym_AT] = ACTIONS(6343),
    [aux_sym__hex_literal_token1] = ACTIONS(5409),
    [sym__number_literal] = ACTIONS(5411),
    [anon_sym_SQUOTE] = ACTIONS(5409),
    [anon_sym_DQUOTE] = ACTIONS(5409),
    [sym_return] = ACTIONS(5411),
    [sym_next] = ACTIONS(5411),
    [sym_break] = ACTIONS(5411),
    [sym_true] = ACTIONS(5411),
    [sym_false] = ACTIONS(5411),
    [sym_null] = ACTIONS(5411),
    [sym_inf] = ACTIONS(5411),
    [sym_nan] = ACTIONS(5411),
    [anon_sym_NA] = ACTIONS(5411),
    [anon_sym_NA_integer_] = ACTIONS(5411),
    [anon_sym_NA_real_] = ACTIONS(5411),
    [anon_sym_NA_complex_] = ACTIONS(5411),
    [anon_sym_NA_character_] = ACTIONS(5411),
    [sym_dots] = ACTIONS(5411),
    [sym_dot_dot_i] = ACTIONS(5409),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5409),
    [sym__newline] = ACTIONS(5409),
    [sym__raw_string_literal] = ACTIONS(5409),
    [sym__external_open_parenthesis] = ACTIONS(6345),
    [sym__external_close_parenthesis] = ACTIONS(5409),
    [sym__external_open_brace] = ACTIONS(5409),
    [sym__external_open_bracket] = ACTIONS(6347),
    [sym__external_open_bracket2] = ACTIONS(6349),
    [sym__external_close_bracket2] = ACTIONS(5409),
  },
  [1776] = {
    [sym_call_arguments] = STATE(2845),
    [sym_subset_arguments] = STATE(2849),
    [sym_subset2_arguments] = STATE(2852),
    [sym__open_parenthesis] = STATE(1372),
    [sym__open_bracket] = STATE(1371),
    [sym__open_bracket2] = STATE(1370),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(6181),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(6183),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(6185),
    [anon_sym_DASH] = ACTIONS(6187),
    [anon_sym_LT_DASH] = ACTIONS(6189),
    [anon_sym_LT_LT_DASH] = ACTIONS(6189),
    [anon_sym_COLON_EQ] = ACTIONS(6189),
    [anon_sym_DASH_GT] = ACTIONS(6191),
    [anon_sym_DASH_GT_GT] = ACTIONS(6193),
    [anon_sym_PIPE] = ACTIONS(6195),
    [anon_sym_AMP] = ACTIONS(6197),
    [anon_sym_PIPE_PIPE] = ACTIONS(6199),
    [anon_sym_AMP_AMP] = ACTIONS(6201),
    [anon_sym_LT] = ACTIONS(6203),
    [anon_sym_LT_EQ] = ACTIONS(6205),
    [anon_sym_GT] = ACTIONS(6203),
    [anon_sym_GT_EQ] = ACTIONS(6205),
    [anon_sym_EQ_EQ] = ACTIONS(6205),
    [anon_sym_BANG_EQ] = ACTIONS(6205),
    [anon_sym_STAR] = ACTIONS(6207),
    [anon_sym_SLASH] = ACTIONS(6209),
    [anon_sym_STAR_STAR] = ACTIONS(6211),
    [anon_sym_CARET] = ACTIONS(6211),
    [aux_sym_binary_operator_token1] = ACTIONS(6213),
    [anon_sym_PIPE_GT] = ACTIONS(6213),
    [anon_sym_COLON] = ACTIONS(6215),
    [anon_sym_DOLLAR] = ACTIONS(6217),
    [anon_sym_AT] = ACTIONS(6217),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6221),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6223),
    [sym__external_open_bracket2] = ACTIONS(6225),
  },
  [1777] = {
    [sym_call_arguments] = STATE(2845),
    [sym_subset_arguments] = STATE(2849),
    [sym_subset2_arguments] = STATE(2852),
    [sym__open_parenthesis] = STATE(1372),
    [sym__open_bracket] = STATE(1371),
    [sym__open_bracket2] = STATE(1370),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(6181),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(6183),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(6185),
    [anon_sym_DASH] = ACTIONS(6187),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(6191),
    [anon_sym_DASH_GT_GT] = ACTIONS(6193),
    [anon_sym_PIPE] = ACTIONS(6195),
    [anon_sym_AMP] = ACTIONS(6197),
    [anon_sym_PIPE_PIPE] = ACTIONS(6199),
    [anon_sym_AMP_AMP] = ACTIONS(6201),
    [anon_sym_LT] = ACTIONS(6203),
    [anon_sym_LT_EQ] = ACTIONS(6205),
    [anon_sym_GT] = ACTIONS(6203),
    [anon_sym_GT_EQ] = ACTIONS(6205),
    [anon_sym_EQ_EQ] = ACTIONS(6205),
    [anon_sym_BANG_EQ] = ACTIONS(6205),
    [anon_sym_STAR] = ACTIONS(6207),
    [anon_sym_SLASH] = ACTIONS(6209),
    [anon_sym_STAR_STAR] = ACTIONS(6211),
    [anon_sym_CARET] = ACTIONS(6211),
    [aux_sym_binary_operator_token1] = ACTIONS(6213),
    [anon_sym_PIPE_GT] = ACTIONS(6213),
    [anon_sym_COLON] = ACTIONS(6215),
    [anon_sym_DOLLAR] = ACTIONS(6217),
    [anon_sym_AT] = ACTIONS(6217),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6221),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6223),
    [sym__external_open_bracket2] = ACTIONS(6225),
  },
  [1778] = {
    [sym_call_arguments] = STATE(2845),
    [sym_subset_arguments] = STATE(2849),
    [sym_subset2_arguments] = STATE(2852),
    [sym__open_parenthesis] = STATE(1372),
    [sym__open_bracket] = STATE(1371),
    [sym__open_bracket2] = STATE(1370),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5345),
    [anon_sym_DASH] = ACTIONS(5347),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5347),
    [anon_sym_AMP] = ACTIONS(5347),
    [anon_sym_PIPE_PIPE] = ACTIONS(5345),
    [anon_sym_AMP_AMP] = ACTIONS(5345),
    [anon_sym_LT] = ACTIONS(5347),
    [anon_sym_LT_EQ] = ACTIONS(5345),
    [anon_sym_GT] = ACTIONS(5347),
    [anon_sym_GT_EQ] = ACTIONS(5345),
    [anon_sym_EQ_EQ] = ACTIONS(5345),
    [anon_sym_BANG_EQ] = ACTIONS(5345),
    [anon_sym_STAR] = ACTIONS(5347),
    [anon_sym_SLASH] = ACTIONS(5345),
    [anon_sym_STAR_STAR] = ACTIONS(6211),
    [anon_sym_CARET] = ACTIONS(6211),
    [aux_sym_binary_operator_token1] = ACTIONS(5345),
    [anon_sym_PIPE_GT] = ACTIONS(5345),
    [anon_sym_COLON] = ACTIONS(5347),
    [anon_sym_DOLLAR] = ACTIONS(6217),
    [anon_sym_AT] = ACTIONS(6217),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_else] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(6221),
    [sym__external_close_parenthesis] = ACTIONS(5345),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(6223),
    [sym__external_open_bracket2] = ACTIONS(6225),
  },
  [1779] = {
    [sym_call_arguments] = STATE(2845),
    [sym_subset_arguments] = STATE(2849),
    [sym_subset2_arguments] = STATE(2852),
    [sym__open_parenthesis] = STATE(1372),
    [sym__open_bracket] = STATE(1371),
    [sym__open_bracket2] = STATE(1370),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(6185),
    [anon_sym_DASH] = ACTIONS(6187),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5347),
    [anon_sym_AMP] = ACTIONS(5347),
    [anon_sym_PIPE_PIPE] = ACTIONS(5345),
    [anon_sym_AMP_AMP] = ACTIONS(5345),
    [anon_sym_LT] = ACTIONS(6203),
    [anon_sym_LT_EQ] = ACTIONS(6205),
    [anon_sym_GT] = ACTIONS(6203),
    [anon_sym_GT_EQ] = ACTIONS(6205),
    [anon_sym_EQ_EQ] = ACTIONS(6205),
    [anon_sym_BANG_EQ] = ACTIONS(6205),
    [anon_sym_STAR] = ACTIONS(6207),
    [anon_sym_SLASH] = ACTIONS(6209),
    [anon_sym_STAR_STAR] = ACTIONS(6211),
    [anon_sym_CARET] = ACTIONS(6211),
    [aux_sym_binary_operator_token1] = ACTIONS(6213),
    [anon_sym_PIPE_GT] = ACTIONS(6213),
    [anon_sym_COLON] = ACTIONS(6215),
    [anon_sym_DOLLAR] = ACTIONS(6217),
    [anon_sym_AT] = ACTIONS(6217),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_else] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(6221),
    [sym__external_close_parenthesis] = ACTIONS(5345),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(6223),
    [sym__external_open_bracket2] = ACTIONS(6225),
  },
  [1780] = {
    [sym_call_arguments] = STATE(2845),
    [sym_subset_arguments] = STATE(2849),
    [sym_subset2_arguments] = STATE(2852),
    [sym__open_parenthesis] = STATE(1372),
    [sym__open_bracket] = STATE(1371),
    [sym__open_bracket2] = STATE(1370),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(6185),
    [anon_sym_DASH] = ACTIONS(6187),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(6195),
    [anon_sym_AMP] = ACTIONS(6197),
    [anon_sym_PIPE_PIPE] = ACTIONS(6199),
    [anon_sym_AMP_AMP] = ACTIONS(6201),
    [anon_sym_LT] = ACTIONS(6203),
    [anon_sym_LT_EQ] = ACTIONS(6205),
    [anon_sym_GT] = ACTIONS(6203),
    [anon_sym_GT_EQ] = ACTIONS(6205),
    [anon_sym_EQ_EQ] = ACTIONS(6205),
    [anon_sym_BANG_EQ] = ACTIONS(6205),
    [anon_sym_STAR] = ACTIONS(6207),
    [anon_sym_SLASH] = ACTIONS(6209),
    [anon_sym_STAR_STAR] = ACTIONS(6211),
    [anon_sym_CARET] = ACTIONS(6211),
    [aux_sym_binary_operator_token1] = ACTIONS(6213),
    [anon_sym_PIPE_GT] = ACTIONS(6213),
    [anon_sym_COLON] = ACTIONS(6215),
    [anon_sym_DOLLAR] = ACTIONS(6217),
    [anon_sym_AT] = ACTIONS(6217),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_else] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(6221),
    [sym__external_close_parenthesis] = ACTIONS(5345),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(6223),
    [sym__external_open_bracket2] = ACTIONS(6225),
  },
  [1781] = {
    [sym_call_arguments] = STATE(2845),
    [sym_subset_arguments] = STATE(2849),
    [sym_subset2_arguments] = STATE(2852),
    [sym__open_parenthesis] = STATE(1372),
    [sym__open_bracket] = STATE(1371),
    [sym__open_bracket2] = STATE(1370),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(6181),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(6183),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(6185),
    [anon_sym_DASH] = ACTIONS(6187),
    [anon_sym_LT_DASH] = ACTIONS(6189),
    [anon_sym_LT_LT_DASH] = ACTIONS(6189),
    [anon_sym_COLON_EQ] = ACTIONS(6189),
    [anon_sym_DASH_GT] = ACTIONS(6191),
    [anon_sym_DASH_GT_GT] = ACTIONS(6193),
    [anon_sym_PIPE] = ACTIONS(6195),
    [anon_sym_AMP] = ACTIONS(6197),
    [anon_sym_PIPE_PIPE] = ACTIONS(6199),
    [anon_sym_AMP_AMP] = ACTIONS(6201),
    [anon_sym_LT] = ACTIONS(6203),
    [anon_sym_LT_EQ] = ACTIONS(6205),
    [anon_sym_GT] = ACTIONS(6203),
    [anon_sym_GT_EQ] = ACTIONS(6205),
    [anon_sym_EQ_EQ] = ACTIONS(6205),
    [anon_sym_BANG_EQ] = ACTIONS(6205),
    [anon_sym_STAR] = ACTIONS(6207),
    [anon_sym_SLASH] = ACTIONS(6209),
    [anon_sym_STAR_STAR] = ACTIONS(6211),
    [anon_sym_CARET] = ACTIONS(6211),
    [aux_sym_binary_operator_token1] = ACTIONS(6213),
    [anon_sym_PIPE_GT] = ACTIONS(6213),
    [anon_sym_COLON] = ACTIONS(6215),
    [anon_sym_DOLLAR] = ACTIONS(6217),
    [anon_sym_AT] = ACTIONS(6217),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_else] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(6221),
    [sym__external_close_parenthesis] = ACTIONS(5345),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(6223),
    [sym__external_open_bracket2] = ACTIONS(6225),
  },
  [1782] = {
    [sym_call_arguments] = STATE(2845),
    [sym_subset_arguments] = STATE(2849),
    [sym_subset2_arguments] = STATE(2852),
    [sym__open_parenthesis] = STATE(1372),
    [sym__open_bracket] = STATE(1371),
    [sym__open_bracket2] = STATE(1370),
    [sym_identifier] = ACTIONS(5343),
    [anon_sym_BSLASH] = ACTIONS(5341),
    [anon_sym_function] = ACTIONS(5343),
    [anon_sym_EQ] = ACTIONS(6181),
    [anon_sym_if] = ACTIONS(5343),
    [anon_sym_for] = ACTIONS(5343),
    [anon_sym_while] = ACTIONS(5343),
    [anon_sym_repeat] = ACTIONS(5343),
    [anon_sym_QMARK] = ACTIONS(5341),
    [anon_sym_TILDE] = ACTIONS(6183),
    [anon_sym_BANG] = ACTIONS(5343),
    [anon_sym_PLUS] = ACTIONS(6185),
    [anon_sym_DASH] = ACTIONS(6187),
    [anon_sym_LT_DASH] = ACTIONS(6189),
    [anon_sym_LT_LT_DASH] = ACTIONS(6189),
    [anon_sym_COLON_EQ] = ACTIONS(6189),
    [anon_sym_DASH_GT] = ACTIONS(6191),
    [anon_sym_DASH_GT_GT] = ACTIONS(6193),
    [anon_sym_PIPE] = ACTIONS(6195),
    [anon_sym_AMP] = ACTIONS(6197),
    [anon_sym_PIPE_PIPE] = ACTIONS(6199),
    [anon_sym_AMP_AMP] = ACTIONS(6201),
    [anon_sym_LT] = ACTIONS(6203),
    [anon_sym_LT_EQ] = ACTIONS(6205),
    [anon_sym_GT] = ACTIONS(6203),
    [anon_sym_GT_EQ] = ACTIONS(6205),
    [anon_sym_EQ_EQ] = ACTIONS(6205),
    [anon_sym_BANG_EQ] = ACTIONS(6205),
    [anon_sym_STAR] = ACTIONS(6207),
    [anon_sym_SLASH] = ACTIONS(6209),
    [anon_sym_STAR_STAR] = ACTIONS(6211),
    [anon_sym_CARET] = ACTIONS(6211),
    [aux_sym_binary_operator_token1] = ACTIONS(6213),
    [anon_sym_PIPE_GT] = ACTIONS(6213),
    [anon_sym_COLON] = ACTIONS(6215),
    [anon_sym_DOLLAR] = ACTIONS(6217),
    [anon_sym_AT] = ACTIONS(6217),
    [aux_sym__hex_literal_token1] = ACTIONS(5341),
    [sym__number_literal] = ACTIONS(5343),
    [anon_sym_SQUOTE] = ACTIONS(5341),
    [anon_sym_DQUOTE] = ACTIONS(5341),
    [sym_return] = ACTIONS(5343),
    [sym_next] = ACTIONS(5343),
    [sym_break] = ACTIONS(5343),
    [sym_true] = ACTIONS(5343),
    [sym_false] = ACTIONS(5343),
    [sym_null] = ACTIONS(5343),
    [sym_inf] = ACTIONS(5343),
    [sym_nan] = ACTIONS(5343),
    [anon_sym_NA] = ACTIONS(5343),
    [anon_sym_NA_integer_] = ACTIONS(5343),
    [anon_sym_NA_real_] = ACTIONS(5343),
    [anon_sym_NA_complex_] = ACTIONS(5343),
    [anon_sym_NA_character_] = ACTIONS(5343),
    [sym_dots] = ACTIONS(5343),
    [sym_dot_dot_i] = ACTIONS(5341),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5341),
    [sym__newline] = ACTIONS(5341),
    [sym__raw_string_literal] = ACTIONS(5341),
    [sym__external_else] = ACTIONS(5341),
    [sym__external_open_parenthesis] = ACTIONS(6221),
    [sym__external_close_parenthesis] = ACTIONS(5341),
    [sym__external_open_brace] = ACTIONS(5341),
    [sym__external_open_bracket] = ACTIONS(6223),
    [sym__external_open_bracket2] = ACTIONS(6225),
  },
  [1783] = {
    [sym_call_arguments] = STATE(2845),
    [sym_subset_arguments] = STATE(2849),
    [sym_subset2_arguments] = STATE(2852),
    [sym__open_parenthesis] = STATE(1372),
    [sym__open_bracket] = STATE(1371),
    [sym__open_bracket2] = STATE(1370),
    [sym_identifier] = ACTIONS(5339),
    [anon_sym_BSLASH] = ACTIONS(5337),
    [anon_sym_function] = ACTIONS(5339),
    [anon_sym_EQ] = ACTIONS(6181),
    [anon_sym_if] = ACTIONS(5339),
    [anon_sym_for] = ACTIONS(5339),
    [anon_sym_while] = ACTIONS(5339),
    [anon_sym_repeat] = ACTIONS(5339),
    [anon_sym_QMARK] = ACTIONS(5337),
    [anon_sym_TILDE] = ACTIONS(6183),
    [anon_sym_BANG] = ACTIONS(5339),
    [anon_sym_PLUS] = ACTIONS(6185),
    [anon_sym_DASH] = ACTIONS(6187),
    [anon_sym_LT_DASH] = ACTIONS(6189),
    [anon_sym_LT_LT_DASH] = ACTIONS(6189),
    [anon_sym_COLON_EQ] = ACTIONS(6189),
    [anon_sym_DASH_GT] = ACTIONS(6191),
    [anon_sym_DASH_GT_GT] = ACTIONS(6193),
    [anon_sym_PIPE] = ACTIONS(6195),
    [anon_sym_AMP] = ACTIONS(6197),
    [anon_sym_PIPE_PIPE] = ACTIONS(6199),
    [anon_sym_AMP_AMP] = ACTIONS(6201),
    [anon_sym_LT] = ACTIONS(6203),
    [anon_sym_LT_EQ] = ACTIONS(6205),
    [anon_sym_GT] = ACTIONS(6203),
    [anon_sym_GT_EQ] = ACTIONS(6205),
    [anon_sym_EQ_EQ] = ACTIONS(6205),
    [anon_sym_BANG_EQ] = ACTIONS(6205),
    [anon_sym_STAR] = ACTIONS(6207),
    [anon_sym_SLASH] = ACTIONS(6209),
    [anon_sym_STAR_STAR] = ACTIONS(6211),
    [anon_sym_CARET] = ACTIONS(6211),
    [aux_sym_binary_operator_token1] = ACTIONS(6213),
    [anon_sym_PIPE_GT] = ACTIONS(6213),
    [anon_sym_COLON] = ACTIONS(6215),
    [anon_sym_DOLLAR] = ACTIONS(6217),
    [anon_sym_AT] = ACTIONS(6217),
    [aux_sym__hex_literal_token1] = ACTIONS(5337),
    [sym__number_literal] = ACTIONS(5339),
    [anon_sym_SQUOTE] = ACTIONS(5337),
    [anon_sym_DQUOTE] = ACTIONS(5337),
    [sym_return] = ACTIONS(5339),
    [sym_next] = ACTIONS(5339),
    [sym_break] = ACTIONS(5339),
    [sym_true] = ACTIONS(5339),
    [sym_false] = ACTIONS(5339),
    [sym_null] = ACTIONS(5339),
    [sym_inf] = ACTIONS(5339),
    [sym_nan] = ACTIONS(5339),
    [anon_sym_NA] = ACTIONS(5339),
    [anon_sym_NA_integer_] = ACTIONS(5339),
    [anon_sym_NA_real_] = ACTIONS(5339),
    [anon_sym_NA_complex_] = ACTIONS(5339),
    [anon_sym_NA_character_] = ACTIONS(5339),
    [sym_dots] = ACTIONS(5339),
    [sym_dot_dot_i] = ACTIONS(5337),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5337),
    [sym__newline] = ACTIONS(5337),
    [sym__raw_string_literal] = ACTIONS(5337),
    [sym__external_else] = ACTIONS(5337),
    [sym__external_open_parenthesis] = ACTIONS(6221),
    [sym__external_close_parenthesis] = ACTIONS(5337),
    [sym__external_open_brace] = ACTIONS(5337),
    [sym__external_open_bracket] = ACTIONS(6223),
    [sym__external_open_bracket2] = ACTIONS(6225),
  },
  [1784] = {
    [sym_call_arguments] = STATE(2777),
    [sym_subset_arguments] = STATE(2779),
    [sym_subset2_arguments] = STATE(2786),
    [sym__open_parenthesis] = STATE(1411),
    [sym__open_bracket] = STATE(1409),
    [sym__open_bracket2] = STATE(1407),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(6497),
    [anon_sym_DASH] = ACTIONS(6499),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(6519),
    [anon_sym_SLASH] = ACTIONS(6521),
    [anon_sym_STAR_STAR] = ACTIONS(6523),
    [anon_sym_CARET] = ACTIONS(6523),
    [aux_sym_binary_operator_token1] = ACTIONS(6525),
    [anon_sym_PIPE_GT] = ACTIONS(6525),
    [anon_sym_COLON] = ACTIONS(6527),
    [anon_sym_DOLLAR] = ACTIONS(6529),
    [anon_sym_AT] = ACTIONS(6529),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6531),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6533),
    [sym__external_open_bracket2] = ACTIONS(6535),
  },
  [1785] = {
    [sym_call_arguments] = STATE(2840),
    [sym_subset_arguments] = STATE(2797),
    [sym_subset2_arguments] = STATE(2801),
    [sym__open_parenthesis] = STATE(1344),
    [sym__open_bracket] = STATE(1374),
    [sym__open_bracket2] = STATE(1452),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(6267),
    [anon_sym_DASH] = ACTIONS(6269),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(6285),
    [anon_sym_LT_EQ] = ACTIONS(6287),
    [anon_sym_GT] = ACTIONS(6285),
    [anon_sym_GT_EQ] = ACTIONS(6287),
    [anon_sym_EQ_EQ] = ACTIONS(6287),
    [anon_sym_BANG_EQ] = ACTIONS(6287),
    [anon_sym_STAR] = ACTIONS(6289),
    [anon_sym_SLASH] = ACTIONS(6291),
    [anon_sym_STAR_STAR] = ACTIONS(6293),
    [anon_sym_CARET] = ACTIONS(6293),
    [aux_sym_binary_operator_token1] = ACTIONS(6295),
    [anon_sym_PIPE_GT] = ACTIONS(6295),
    [anon_sym_COLON] = ACTIONS(6297),
    [anon_sym_DOLLAR] = ACTIONS(6299),
    [anon_sym_AT] = ACTIONS(6299),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6301),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6303),
    [sym__external_open_bracket2] = ACTIONS(6305),
  },
  [1786] = {
    [sym_string] = STATE(2643),
    [sym__single_quoted_string] = STATE(2355),
    [sym__double_quoted_string] = STATE(2354),
    [sym__string_or_identifier] = STATE(2643),
    [aux_sym_function_definition_repeat1] = STATE(2465),
    [ts_builtin_sym_end] = ACTIONS(5669),
    [sym_identifier] = ACTIONS(6795),
    [anon_sym_BSLASH] = ACTIONS(5669),
    [anon_sym_function] = ACTIONS(5673),
    [anon_sym_EQ] = ACTIONS(5673),
    [anon_sym_if] = ACTIONS(5673),
    [anon_sym_for] = ACTIONS(5673),
    [anon_sym_while] = ACTIONS(5673),
    [anon_sym_repeat] = ACTIONS(5673),
    [anon_sym_QMARK] = ACTIONS(5669),
    [anon_sym_TILDE] = ACTIONS(5669),
    [anon_sym_BANG] = ACTIONS(5673),
    [anon_sym_PLUS] = ACTIONS(5669),
    [anon_sym_DASH] = ACTIONS(5673),
    [anon_sym_LT_DASH] = ACTIONS(5669),
    [anon_sym_LT_LT_DASH] = ACTIONS(5669),
    [anon_sym_COLON_EQ] = ACTIONS(5669),
    [anon_sym_DASH_GT] = ACTIONS(5673),
    [anon_sym_DASH_GT_GT] = ACTIONS(5669),
    [anon_sym_PIPE] = ACTIONS(5673),
    [anon_sym_AMP] = ACTIONS(5673),
    [anon_sym_PIPE_PIPE] = ACTIONS(5669),
    [anon_sym_AMP_AMP] = ACTIONS(5669),
    [anon_sym_LT] = ACTIONS(5673),
    [anon_sym_LT_EQ] = ACTIONS(5669),
    [anon_sym_GT] = ACTIONS(5673),
    [anon_sym_GT_EQ] = ACTIONS(5669),
    [anon_sym_EQ_EQ] = ACTIONS(5669),
    [anon_sym_BANG_EQ] = ACTIONS(5669),
    [anon_sym_STAR] = ACTIONS(5673),
    [anon_sym_SLASH] = ACTIONS(5669),
    [anon_sym_STAR_STAR] = ACTIONS(5669),
    [anon_sym_CARET] = ACTIONS(5669),
    [aux_sym_binary_operator_token1] = ACTIONS(5669),
    [anon_sym_PIPE_GT] = ACTIONS(5669),
    [anon_sym_COLON] = ACTIONS(5673),
    [anon_sym_DOLLAR] = ACTIONS(5669),
    [anon_sym_AT] = ACTIONS(5669),
    [aux_sym__hex_literal_token1] = ACTIONS(5669),
    [sym__number_literal] = ACTIONS(5673),
    [anon_sym_SQUOTE] = ACTIONS(1365),
    [anon_sym_DQUOTE] = ACTIONS(1367),
    [sym_return] = ACTIONS(5673),
    [sym_next] = ACTIONS(5673),
    [sym_break] = ACTIONS(5673),
    [sym_true] = ACTIONS(5673),
    [sym_false] = ACTIONS(5673),
    [sym_null] = ACTIONS(5673),
    [sym_inf] = ACTIONS(5673),
    [sym_nan] = ACTIONS(5673),
    [anon_sym_NA] = ACTIONS(5673),
    [anon_sym_NA_integer_] = ACTIONS(5673),
    [anon_sym_NA_real_] = ACTIONS(5673),
    [anon_sym_NA_complex_] = ACTIONS(5673),
    [anon_sym_NA_character_] = ACTIONS(5673),
    [sym_dots] = ACTIONS(5673),
    [sym_dot_dot_i] = ACTIONS(5669),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5669),
    [sym__semicolon] = ACTIONS(5669),
    [sym__raw_string_literal] = ACTIONS(1377),
    [sym__external_else] = ACTIONS(5669),
    [sym__external_open_parenthesis] = ACTIONS(5669),
    [sym__external_close_parenthesis] = ACTIONS(5669),
    [sym__external_open_brace] = ACTIONS(5669),
    [sym__external_open_bracket] = ACTIONS(5669),
    [sym__external_open_bracket2] = ACTIONS(5669),
  },
  [1787] = {
    [sym_call_arguments] = STATE(2845),
    [sym_subset_arguments] = STATE(2849),
    [sym_subset2_arguments] = STATE(2852),
    [sym__open_parenthesis] = STATE(1372),
    [sym__open_bracket] = STATE(1371),
    [sym__open_bracket2] = STATE(1370),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(5333),
    [anon_sym_DASH] = ACTIONS(5335),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5335),
    [anon_sym_AMP] = ACTIONS(5335),
    [anon_sym_PIPE_PIPE] = ACTIONS(5333),
    [anon_sym_AMP_AMP] = ACTIONS(5333),
    [anon_sym_LT] = ACTIONS(5335),
    [anon_sym_LT_EQ] = ACTIONS(5333),
    [anon_sym_GT] = ACTIONS(5335),
    [anon_sym_GT_EQ] = ACTIONS(5333),
    [anon_sym_EQ_EQ] = ACTIONS(5333),
    [anon_sym_BANG_EQ] = ACTIONS(5333),
    [anon_sym_STAR] = ACTIONS(5335),
    [anon_sym_SLASH] = ACTIONS(5333),
    [anon_sym_STAR_STAR] = ACTIONS(6211),
    [anon_sym_CARET] = ACTIONS(6211),
    [aux_sym_binary_operator_token1] = ACTIONS(5333),
    [anon_sym_PIPE_GT] = ACTIONS(5333),
    [anon_sym_COLON] = ACTIONS(5335),
    [anon_sym_DOLLAR] = ACTIONS(6217),
    [anon_sym_AT] = ACTIONS(6217),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_else] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(6221),
    [sym__external_close_parenthesis] = ACTIONS(5333),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(6223),
    [sym__external_open_bracket2] = ACTIONS(6225),
  },
  [1788] = {
    [sym_call_arguments] = STATE(2845),
    [sym_subset_arguments] = STATE(2849),
    [sym_subset2_arguments] = STATE(2852),
    [sym__open_parenthesis] = STATE(1372),
    [sym__open_bracket] = STATE(1371),
    [sym__open_bracket2] = STATE(1370),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(6185),
    [anon_sym_DASH] = ACTIONS(6187),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5335),
    [anon_sym_AMP] = ACTIONS(5335),
    [anon_sym_PIPE_PIPE] = ACTIONS(5333),
    [anon_sym_AMP_AMP] = ACTIONS(5333),
    [anon_sym_LT] = ACTIONS(6203),
    [anon_sym_LT_EQ] = ACTIONS(6205),
    [anon_sym_GT] = ACTIONS(6203),
    [anon_sym_GT_EQ] = ACTIONS(6205),
    [anon_sym_EQ_EQ] = ACTIONS(6205),
    [anon_sym_BANG_EQ] = ACTIONS(6205),
    [anon_sym_STAR] = ACTIONS(6207),
    [anon_sym_SLASH] = ACTIONS(6209),
    [anon_sym_STAR_STAR] = ACTIONS(6211),
    [anon_sym_CARET] = ACTIONS(6211),
    [aux_sym_binary_operator_token1] = ACTIONS(6213),
    [anon_sym_PIPE_GT] = ACTIONS(6213),
    [anon_sym_COLON] = ACTIONS(6215),
    [anon_sym_DOLLAR] = ACTIONS(6217),
    [anon_sym_AT] = ACTIONS(6217),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_else] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(6221),
    [sym__external_close_parenthesis] = ACTIONS(5333),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(6223),
    [sym__external_open_bracket2] = ACTIONS(6225),
  },
  [1789] = {
    [sym_call_arguments] = STATE(2840),
    [sym_subset_arguments] = STATE(2797),
    [sym_subset2_arguments] = STATE(2801),
    [sym__open_parenthesis] = STATE(1344),
    [sym__open_bracket] = STATE(1374),
    [sym__open_bracket2] = STATE(1452),
    [ts_builtin_sym_end] = ACTIONS(5399),
    [sym_identifier] = ACTIONS(5401),
    [anon_sym_BSLASH] = ACTIONS(5399),
    [anon_sym_function] = ACTIONS(5401),
    [anon_sym_EQ] = ACTIONS(6263),
    [anon_sym_if] = ACTIONS(5401),
    [anon_sym_for] = ACTIONS(5401),
    [anon_sym_while] = ACTIONS(5401),
    [anon_sym_repeat] = ACTIONS(5401),
    [anon_sym_QMARK] = ACTIONS(5399),
    [anon_sym_TILDE] = ACTIONS(6265),
    [anon_sym_BANG] = ACTIONS(5401),
    [anon_sym_PLUS] = ACTIONS(6267),
    [anon_sym_DASH] = ACTIONS(6269),
    [anon_sym_LT_DASH] = ACTIONS(6271),
    [anon_sym_LT_LT_DASH] = ACTIONS(6271),
    [anon_sym_COLON_EQ] = ACTIONS(6271),
    [anon_sym_DASH_GT] = ACTIONS(6273),
    [anon_sym_DASH_GT_GT] = ACTIONS(6275),
    [anon_sym_PIPE] = ACTIONS(6277),
    [anon_sym_AMP] = ACTIONS(6279),
    [anon_sym_PIPE_PIPE] = ACTIONS(6281),
    [anon_sym_AMP_AMP] = ACTIONS(6283),
    [anon_sym_LT] = ACTIONS(6285),
    [anon_sym_LT_EQ] = ACTIONS(6287),
    [anon_sym_GT] = ACTIONS(6285),
    [anon_sym_GT_EQ] = ACTIONS(6287),
    [anon_sym_EQ_EQ] = ACTIONS(6287),
    [anon_sym_BANG_EQ] = ACTIONS(6287),
    [anon_sym_STAR] = ACTIONS(6289),
    [anon_sym_SLASH] = ACTIONS(6291),
    [anon_sym_STAR_STAR] = ACTIONS(6293),
    [anon_sym_CARET] = ACTIONS(6293),
    [aux_sym_binary_operator_token1] = ACTIONS(6295),
    [anon_sym_PIPE_GT] = ACTIONS(6295),
    [anon_sym_COLON] = ACTIONS(6297),
    [anon_sym_DOLLAR] = ACTIONS(6299),
    [anon_sym_AT] = ACTIONS(6299),
    [aux_sym__hex_literal_token1] = ACTIONS(5399),
    [sym__number_literal] = ACTIONS(5401),
    [anon_sym_SQUOTE] = ACTIONS(5399),
    [anon_sym_DQUOTE] = ACTIONS(5399),
    [sym_return] = ACTIONS(5401),
    [sym_next] = ACTIONS(5401),
    [sym_break] = ACTIONS(5401),
    [sym_true] = ACTIONS(5401),
    [sym_false] = ACTIONS(5401),
    [sym_null] = ACTIONS(5401),
    [sym_inf] = ACTIONS(5401),
    [sym_nan] = ACTIONS(5401),
    [anon_sym_NA] = ACTIONS(5401),
    [anon_sym_NA_integer_] = ACTIONS(5401),
    [anon_sym_NA_real_] = ACTIONS(5401),
    [anon_sym_NA_complex_] = ACTIONS(5401),
    [anon_sym_NA_character_] = ACTIONS(5401),
    [sym_dots] = ACTIONS(5401),
    [sym_dot_dot_i] = ACTIONS(5399),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5399),
    [sym__semicolon] = ACTIONS(5399),
    [sym__raw_string_literal] = ACTIONS(5399),
    [sym__external_open_parenthesis] = ACTIONS(6301),
    [sym__external_open_brace] = ACTIONS(5399),
    [sym__external_close_brace] = ACTIONS(5399),
    [sym__external_open_bracket] = ACTIONS(6303),
    [sym__external_open_bracket2] = ACTIONS(6305),
  },
  [1790] = {
    [sym_call_arguments] = STATE(2923),
    [sym_subset_arguments] = STATE(2922),
    [sym_subset2_arguments] = STATE(2906),
    [sym__open_parenthesis] = STATE(1528),
    [sym__open_bracket] = STATE(1525),
    [sym__open_bracket2] = STATE(1519),
    [ts_builtin_sym_end] = ACTIONS(5413),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_BSLASH] = ACTIONS(5413),
    [anon_sym_function] = ACTIONS(5415),
    [anon_sym_EQ] = ACTIONS(5947),
    [anon_sym_if] = ACTIONS(5415),
    [anon_sym_for] = ACTIONS(5415),
    [anon_sym_while] = ACTIONS(5415),
    [anon_sym_repeat] = ACTIONS(5415),
    [anon_sym_QMARK] = ACTIONS(5413),
    [anon_sym_TILDE] = ACTIONS(5949),
    [anon_sym_BANG] = ACTIONS(5415),
    [anon_sym_PLUS] = ACTIONS(5951),
    [anon_sym_DASH] = ACTIONS(5953),
    [anon_sym_LT_DASH] = ACTIONS(5955),
    [anon_sym_LT_LT_DASH] = ACTIONS(5955),
    [anon_sym_COLON_EQ] = ACTIONS(5955),
    [anon_sym_DASH_GT] = ACTIONS(5957),
    [anon_sym_DASH_GT_GT] = ACTIONS(5959),
    [anon_sym_PIPE] = ACTIONS(5961),
    [anon_sym_AMP] = ACTIONS(5963),
    [anon_sym_PIPE_PIPE] = ACTIONS(5965),
    [anon_sym_AMP_AMP] = ACTIONS(5967),
    [anon_sym_LT] = ACTIONS(5969),
    [anon_sym_LT_EQ] = ACTIONS(5971),
    [anon_sym_GT] = ACTIONS(5969),
    [anon_sym_GT_EQ] = ACTIONS(5971),
    [anon_sym_EQ_EQ] = ACTIONS(5971),
    [anon_sym_BANG_EQ] = ACTIONS(5971),
    [anon_sym_STAR] = ACTIONS(5973),
    [anon_sym_SLASH] = ACTIONS(5975),
    [anon_sym_STAR_STAR] = ACTIONS(5977),
    [anon_sym_CARET] = ACTIONS(5977),
    [aux_sym_binary_operator_token1] = ACTIONS(5979),
    [anon_sym_PIPE_GT] = ACTIONS(5979),
    [anon_sym_COLON] = ACTIONS(5981),
    [anon_sym_DOLLAR] = ACTIONS(5983),
    [anon_sym_AT] = ACTIONS(5983),
    [aux_sym__hex_literal_token1] = ACTIONS(5413),
    [sym__number_literal] = ACTIONS(5415),
    [anon_sym_SQUOTE] = ACTIONS(5413),
    [anon_sym_DQUOTE] = ACTIONS(5413),
    [sym_return] = ACTIONS(5415),
    [sym_next] = ACTIONS(5415),
    [sym_break] = ACTIONS(5415),
    [sym_true] = ACTIONS(5415),
    [sym_false] = ACTIONS(5415),
    [sym_null] = ACTIONS(5415),
    [sym_inf] = ACTIONS(5415),
    [sym_nan] = ACTIONS(5415),
    [anon_sym_NA] = ACTIONS(5415),
    [anon_sym_NA_integer_] = ACTIONS(5415),
    [anon_sym_NA_real_] = ACTIONS(5415),
    [anon_sym_NA_complex_] = ACTIONS(5415),
    [anon_sym_NA_character_] = ACTIONS(5415),
    [sym_dots] = ACTIONS(5415),
    [sym_dot_dot_i] = ACTIONS(5413),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5413),
    [sym__semicolon] = ACTIONS(5413),
    [sym__raw_string_literal] = ACTIONS(5413),
    [sym__external_else] = ACTIONS(5413),
    [sym__external_open_parenthesis] = ACTIONS(5987),
    [sym__external_open_brace] = ACTIONS(5413),
    [sym__external_open_bracket] = ACTIONS(5989),
    [sym__external_open_bracket2] = ACTIONS(5991),
  },
  [1791] = {
    [sym_call_arguments] = STATE(2845),
    [sym_subset_arguments] = STATE(2849),
    [sym_subset2_arguments] = STATE(2852),
    [sym__open_parenthesis] = STATE(1372),
    [sym__open_bracket] = STATE(1371),
    [sym__open_bracket2] = STATE(1370),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(6185),
    [anon_sym_DASH] = ACTIONS(6187),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(6195),
    [anon_sym_AMP] = ACTIONS(6197),
    [anon_sym_PIPE_PIPE] = ACTIONS(6199),
    [anon_sym_AMP_AMP] = ACTIONS(6201),
    [anon_sym_LT] = ACTIONS(6203),
    [anon_sym_LT_EQ] = ACTIONS(6205),
    [anon_sym_GT] = ACTIONS(6203),
    [anon_sym_GT_EQ] = ACTIONS(6205),
    [anon_sym_EQ_EQ] = ACTIONS(6205),
    [anon_sym_BANG_EQ] = ACTIONS(6205),
    [anon_sym_STAR] = ACTIONS(6207),
    [anon_sym_SLASH] = ACTIONS(6209),
    [anon_sym_STAR_STAR] = ACTIONS(6211),
    [anon_sym_CARET] = ACTIONS(6211),
    [aux_sym_binary_operator_token1] = ACTIONS(6213),
    [anon_sym_PIPE_GT] = ACTIONS(6213),
    [anon_sym_COLON] = ACTIONS(6215),
    [anon_sym_DOLLAR] = ACTIONS(6217),
    [anon_sym_AT] = ACTIONS(6217),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_else] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(6221),
    [sym__external_close_parenthesis] = ACTIONS(5333),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(6223),
    [sym__external_open_bracket2] = ACTIONS(6225),
  },
  [1792] = {
    [sym_call_arguments] = STATE(2840),
    [sym_subset_arguments] = STATE(2797),
    [sym_subset2_arguments] = STATE(2801),
    [sym__open_parenthesis] = STATE(1344),
    [sym__open_bracket] = STATE(1374),
    [sym__open_bracket2] = STATE(1452),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(6267),
    [anon_sym_DASH] = ACTIONS(6269),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(6289),
    [anon_sym_SLASH] = ACTIONS(6291),
    [anon_sym_STAR_STAR] = ACTIONS(6293),
    [anon_sym_CARET] = ACTIONS(6293),
    [aux_sym_binary_operator_token1] = ACTIONS(6295),
    [anon_sym_PIPE_GT] = ACTIONS(6295),
    [anon_sym_COLON] = ACTIONS(6297),
    [anon_sym_DOLLAR] = ACTIONS(6299),
    [anon_sym_AT] = ACTIONS(6299),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6301),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6303),
    [sym__external_open_bracket2] = ACTIONS(6305),
  },
  [1793] = {
    [sym_call_arguments] = STATE(2845),
    [sym_subset_arguments] = STATE(2849),
    [sym_subset2_arguments] = STATE(2852),
    [sym__open_parenthesis] = STATE(1372),
    [sym__open_bracket] = STATE(1371),
    [sym__open_bracket2] = STATE(1370),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(6181),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(6183),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(6185),
    [anon_sym_DASH] = ACTIONS(6187),
    [anon_sym_LT_DASH] = ACTIONS(6189),
    [anon_sym_LT_LT_DASH] = ACTIONS(6189),
    [anon_sym_COLON_EQ] = ACTIONS(6189),
    [anon_sym_DASH_GT] = ACTIONS(6191),
    [anon_sym_DASH_GT_GT] = ACTIONS(6193),
    [anon_sym_PIPE] = ACTIONS(6195),
    [anon_sym_AMP] = ACTIONS(6197),
    [anon_sym_PIPE_PIPE] = ACTIONS(6199),
    [anon_sym_AMP_AMP] = ACTIONS(6201),
    [anon_sym_LT] = ACTIONS(6203),
    [anon_sym_LT_EQ] = ACTIONS(6205),
    [anon_sym_GT] = ACTIONS(6203),
    [anon_sym_GT_EQ] = ACTIONS(6205),
    [anon_sym_EQ_EQ] = ACTIONS(6205),
    [anon_sym_BANG_EQ] = ACTIONS(6205),
    [anon_sym_STAR] = ACTIONS(6207),
    [anon_sym_SLASH] = ACTIONS(6209),
    [anon_sym_STAR_STAR] = ACTIONS(6211),
    [anon_sym_CARET] = ACTIONS(6211),
    [aux_sym_binary_operator_token1] = ACTIONS(6213),
    [anon_sym_PIPE_GT] = ACTIONS(6213),
    [anon_sym_COLON] = ACTIONS(6215),
    [anon_sym_DOLLAR] = ACTIONS(6217),
    [anon_sym_AT] = ACTIONS(6217),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_else] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(6221),
    [sym__external_close_parenthesis] = ACTIONS(5333),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(6223),
    [sym__external_open_bracket2] = ACTIONS(6225),
  },
  [1794] = {
    [sym_function_definition] = STATE(2038),
    [sym_if_statement] = STATE(2038),
    [sym_for_statement] = STATE(2038),
    [sym_while_statement] = STATE(2038),
    [sym_repeat_statement] = STATE(2038),
    [sym_braced_expression] = STATE(2038),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_call] = STATE(2038),
    [sym_subset] = STATE(2038),
    [sym_subset2] = STATE(2038),
    [sym__argument] = STATE(4664),
    [sym_argument] = STATE(4659),
    [sym__argument_named] = STATE(4654),
    [sym__argument_unnamed] = STATE(4676),
    [sym__argument_value] = STATE(4677),
    [sym_unary_operator] = STATE(2038),
    [sym_binary_operator] = STATE(2038),
    [sym_extract_operator] = STATE(2038),
    [sym_namespace_operator] = STATE(2038),
    [sym_integer] = STATE(2038),
    [sym_complex] = STATE(2038),
    [sym_float] = STATE(2038),
    [sym__hex_literal] = STATE(2700),
    [sym__float_literal] = STATE(2700),
    [sym_string] = STATE(2597),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym_na] = STATE(2038),
    [sym__expression] = STATE(2038),
    [sym__string_or_identifier] = STATE(5148),
    [sym__open_parenthesis] = STATE(214),
    [sym__open_brace] = STATE(192),
    [sym__close_bracket] = STATE(2676),
    [aux_sym_call_arguments_repeat1] = STATE(2034),
    [sym_identifier] = ACTIONS(6351),
    [anon_sym_BSLASH] = ACTIONS(4754),
    [anon_sym_function] = ACTIONS(4756),
    [anon_sym_if] = ACTIONS(4758),
    [anon_sym_for] = ACTIONS(4760),
    [anon_sym_while] = ACTIONS(4762),
    [anon_sym_repeat] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4766),
    [anon_sym_TILDE] = ACTIONS(4768),
    [anon_sym_BANG] = ACTIONS(6353),
    [anon_sym_PLUS] = ACTIONS(4772),
    [anon_sym_DASH] = ACTIONS(4772),
    [aux_sym__hex_literal_token1] = ACTIONS(4776),
    [sym__number_literal] = ACTIONS(4778),
    [anon_sym_SQUOTE] = ACTIONS(4780),
    [anon_sym_DQUOTE] = ACTIONS(4782),
    [sym_return] = ACTIONS(6355),
    [sym_next] = ACTIONS(6355),
    [sym_break] = ACTIONS(6355),
    [sym_true] = ACTIONS(6355),
    [sym_false] = ACTIONS(6355),
    [sym_null] = ACTIONS(6355),
    [sym_inf] = ACTIONS(6355),
    [sym_nan] = ACTIONS(6355),
    [anon_sym_NA] = ACTIONS(4786),
    [anon_sym_NA_integer_] = ACTIONS(4786),
    [anon_sym_NA_real_] = ACTIONS(4786),
    [anon_sym_NA_complex_] = ACTIONS(4786),
    [anon_sym_NA_character_] = ACTIONS(4786),
    [sym_dots] = ACTIONS(6357),
    [sym_dot_dot_i] = ACTIONS(6359),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6361),
    [sym__newline] = ACTIONS(6363),
    [sym__raw_string_literal] = ACTIONS(4790),
    [sym__external_open_parenthesis] = ACTIONS(4792),
    [sym__external_open_brace] = ACTIONS(4794),
    [sym__external_close_bracket] = ACTIONS(6797),
  },
  [1795] = {
    [sym_call_arguments] = STATE(2845),
    [sym_subset_arguments] = STATE(2849),
    [sym_subset2_arguments] = STATE(2852),
    [sym__open_parenthesis] = STATE(1372),
    [sym__open_bracket] = STATE(1371),
    [sym__open_bracket2] = STATE(1370),
    [sym_identifier] = ACTIONS(5331),
    [anon_sym_BSLASH] = ACTIONS(5329),
    [anon_sym_function] = ACTIONS(5331),
    [anon_sym_EQ] = ACTIONS(6181),
    [anon_sym_if] = ACTIONS(5331),
    [anon_sym_for] = ACTIONS(5331),
    [anon_sym_while] = ACTIONS(5331),
    [anon_sym_repeat] = ACTIONS(5331),
    [anon_sym_QMARK] = ACTIONS(5329),
    [anon_sym_TILDE] = ACTIONS(6183),
    [anon_sym_BANG] = ACTIONS(5331),
    [anon_sym_PLUS] = ACTIONS(6185),
    [anon_sym_DASH] = ACTIONS(6187),
    [anon_sym_LT_DASH] = ACTIONS(6189),
    [anon_sym_LT_LT_DASH] = ACTIONS(6189),
    [anon_sym_COLON_EQ] = ACTIONS(6189),
    [anon_sym_DASH_GT] = ACTIONS(6191),
    [anon_sym_DASH_GT_GT] = ACTIONS(6193),
    [anon_sym_PIPE] = ACTIONS(6195),
    [anon_sym_AMP] = ACTIONS(6197),
    [anon_sym_PIPE_PIPE] = ACTIONS(6199),
    [anon_sym_AMP_AMP] = ACTIONS(6201),
    [anon_sym_LT] = ACTIONS(6203),
    [anon_sym_LT_EQ] = ACTIONS(6205),
    [anon_sym_GT] = ACTIONS(6203),
    [anon_sym_GT_EQ] = ACTIONS(6205),
    [anon_sym_EQ_EQ] = ACTIONS(6205),
    [anon_sym_BANG_EQ] = ACTIONS(6205),
    [anon_sym_STAR] = ACTIONS(6207),
    [anon_sym_SLASH] = ACTIONS(6209),
    [anon_sym_STAR_STAR] = ACTIONS(6211),
    [anon_sym_CARET] = ACTIONS(6211),
    [aux_sym_binary_operator_token1] = ACTIONS(6213),
    [anon_sym_PIPE_GT] = ACTIONS(6213),
    [anon_sym_COLON] = ACTIONS(6215),
    [anon_sym_DOLLAR] = ACTIONS(6217),
    [anon_sym_AT] = ACTIONS(6217),
    [aux_sym__hex_literal_token1] = ACTIONS(5329),
    [sym__number_literal] = ACTIONS(5331),
    [anon_sym_SQUOTE] = ACTIONS(5329),
    [anon_sym_DQUOTE] = ACTIONS(5329),
    [sym_return] = ACTIONS(5331),
    [sym_next] = ACTIONS(5331),
    [sym_break] = ACTIONS(5331),
    [sym_true] = ACTIONS(5331),
    [sym_false] = ACTIONS(5331),
    [sym_null] = ACTIONS(5331),
    [sym_inf] = ACTIONS(5331),
    [sym_nan] = ACTIONS(5331),
    [anon_sym_NA] = ACTIONS(5331),
    [anon_sym_NA_integer_] = ACTIONS(5331),
    [anon_sym_NA_real_] = ACTIONS(5331),
    [anon_sym_NA_complex_] = ACTIONS(5331),
    [anon_sym_NA_character_] = ACTIONS(5331),
    [sym_dots] = ACTIONS(5331),
    [sym_dot_dot_i] = ACTIONS(5329),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5329),
    [sym__newline] = ACTIONS(5329),
    [sym__raw_string_literal] = ACTIONS(5329),
    [sym__external_else] = ACTIONS(5329),
    [sym__external_open_parenthesis] = ACTIONS(6221),
    [sym__external_close_parenthesis] = ACTIONS(5329),
    [sym__external_open_brace] = ACTIONS(5329),
    [sym__external_open_bracket] = ACTIONS(6223),
    [sym__external_open_bracket2] = ACTIONS(6225),
  },
  [1796] = {
    [sym_function_definition] = STATE(1940),
    [sym_if_statement] = STATE(1940),
    [sym_for_statement] = STATE(1940),
    [sym_while_statement] = STATE(1940),
    [sym_repeat_statement] = STATE(1940),
    [sym_braced_expression] = STATE(1940),
    [sym_parenthesized_expression] = STATE(1940),
    [sym_call] = STATE(1940),
    [sym_subset] = STATE(1940),
    [sym_subset2] = STATE(1940),
    [sym__argument] = STATE(4665),
    [sym_argument] = STATE(4661),
    [sym__argument_named] = STATE(4669),
    [sym__argument_unnamed] = STATE(4673),
    [sym__argument_value] = STATE(4679),
    [sym_unary_operator] = STATE(1940),
    [sym_binary_operator] = STATE(1940),
    [sym_extract_operator] = STATE(1940),
    [sym_namespace_operator] = STATE(1940),
    [sym_integer] = STATE(1940),
    [sym_complex] = STATE(1940),
    [sym_float] = STATE(1940),
    [sym__hex_literal] = STATE(2656),
    [sym__float_literal] = STATE(2656),
    [sym_string] = STATE(2606),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym_na] = STATE(1940),
    [sym__expression] = STATE(1940),
    [sym__string_or_identifier] = STATE(5141),
    [sym__open_parenthesis] = STATE(218),
    [sym__open_brace] = STATE(185),
    [sym__close_bracket2] = STATE(2675),
    [aux_sym_call_arguments_repeat1] = STATE(1912),
    [sym_identifier] = ACTIONS(6369),
    [anon_sym_BSLASH] = ACTIONS(4644),
    [anon_sym_function] = ACTIONS(4646),
    [anon_sym_if] = ACTIONS(4648),
    [anon_sym_for] = ACTIONS(4650),
    [anon_sym_while] = ACTIONS(4652),
    [anon_sym_repeat] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(6371),
    [anon_sym_PLUS] = ACTIONS(4662),
    [anon_sym_DASH] = ACTIONS(4662),
    [aux_sym__hex_literal_token1] = ACTIONS(4666),
    [sym__number_literal] = ACTIONS(4668),
    [anon_sym_SQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4672),
    [sym_return] = ACTIONS(6373),
    [sym_next] = ACTIONS(6373),
    [sym_break] = ACTIONS(6373),
    [sym_true] = ACTIONS(6373),
    [sym_false] = ACTIONS(6373),
    [sym_null] = ACTIONS(6373),
    [sym_inf] = ACTIONS(6373),
    [sym_nan] = ACTIONS(6373),
    [anon_sym_NA] = ACTIONS(4676),
    [anon_sym_NA_integer_] = ACTIONS(4676),
    [anon_sym_NA_real_] = ACTIONS(4676),
    [anon_sym_NA_complex_] = ACTIONS(4676),
    [anon_sym_NA_character_] = ACTIONS(4676),
    [sym_dots] = ACTIONS(6375),
    [sym_dot_dot_i] = ACTIONS(6377),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6379),
    [sym__newline] = ACTIONS(6381),
    [sym__raw_string_literal] = ACTIONS(4680),
    [sym__external_open_parenthesis] = ACTIONS(4682),
    [sym__external_open_brace] = ACTIONS(4684),
    [sym__external_close_bracket2] = ACTIONS(6799),
  },
  [1797] = {
    [sym_call_arguments] = STATE(2777),
    [sym_subset_arguments] = STATE(2779),
    [sym_subset2_arguments] = STATE(2786),
    [sym__open_parenthesis] = STATE(1411),
    [sym__open_bracket] = STATE(1409),
    [sym__open_bracket2] = STATE(1407),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(6523),
    [anon_sym_CARET] = ACTIONS(6523),
    [aux_sym_binary_operator_token1] = ACTIONS(6525),
    [anon_sym_PIPE_GT] = ACTIONS(6525),
    [anon_sym_COLON] = ACTIONS(6527),
    [anon_sym_DOLLAR] = ACTIONS(6529),
    [anon_sym_AT] = ACTIONS(6529),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6531),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6533),
    [sym__external_open_bracket2] = ACTIONS(6535),
  },
  [1798] = {
    [sym_call_arguments] = STATE(2923),
    [sym_subset_arguments] = STATE(2922),
    [sym_subset2_arguments] = STATE(2906),
    [sym__open_parenthesis] = STATE(1528),
    [sym__open_bracket] = STATE(1525),
    [sym__open_bracket2] = STATE(1519),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(5977),
    [anon_sym_CARET] = ACTIONS(5977),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(5261),
    [anon_sym_DOLLAR] = ACTIONS(5983),
    [anon_sym_AT] = ACTIONS(5983),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5987),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5989),
    [sym__external_open_bracket2] = ACTIONS(5991),
  },
  [1799] = {
    [sym_call_arguments] = STATE(2777),
    [sym_subset_arguments] = STATE(2779),
    [sym_subset2_arguments] = STATE(2786),
    [sym__open_parenthesis] = STATE(1411),
    [sym__open_bracket] = STATE(1409),
    [sym__open_bracket2] = STATE(1407),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(6523),
    [anon_sym_CARET] = ACTIONS(6523),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(5351),
    [anon_sym_DOLLAR] = ACTIONS(6529),
    [anon_sym_AT] = ACTIONS(6529),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6531),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6533),
    [sym__external_open_bracket2] = ACTIONS(6535),
  },
  [1800] = {
    [sym_call_arguments] = STATE(2777),
    [sym_subset_arguments] = STATE(2779),
    [sym_subset2_arguments] = STATE(2786),
    [sym__open_parenthesis] = STATE(1411),
    [sym__open_bracket] = STATE(1409),
    [sym__open_bracket2] = STATE(1407),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(6523),
    [anon_sym_CARET] = ACTIONS(6523),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(6527),
    [anon_sym_DOLLAR] = ACTIONS(6529),
    [anon_sym_AT] = ACTIONS(6529),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6531),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6533),
    [sym__external_open_bracket2] = ACTIONS(6535),
  },
  [1801] = {
    [sym_call_arguments] = STATE(2777),
    [sym_subset_arguments] = STATE(2779),
    [sym_subset2_arguments] = STATE(2786),
    [sym__open_parenthesis] = STATE(1411),
    [sym__open_bracket] = STATE(1409),
    [sym__open_bracket2] = STATE(1407),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(6523),
    [anon_sym_CARET] = ACTIONS(6523),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(5351),
    [anon_sym_DOLLAR] = ACTIONS(6529),
    [anon_sym_AT] = ACTIONS(6529),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6531),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6533),
    [sym__external_open_bracket2] = ACTIONS(6535),
  },
  [1802] = {
    [sym_call_arguments] = STATE(2923),
    [sym_subset_arguments] = STATE(2922),
    [sym_subset2_arguments] = STATE(2906),
    [sym__open_parenthesis] = STATE(1528),
    [sym__open_bracket] = STATE(1525),
    [sym__open_bracket2] = STATE(1519),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(5977),
    [anon_sym_CARET] = ACTIONS(5977),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(5981),
    [anon_sym_DOLLAR] = ACTIONS(5983),
    [anon_sym_AT] = ACTIONS(5983),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5987),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5989),
    [sym__external_open_bracket2] = ACTIONS(5991),
  },
  [1803] = {
    [sym_call_arguments] = STATE(2923),
    [sym_subset_arguments] = STATE(2922),
    [sym_subset2_arguments] = STATE(2906),
    [sym__open_parenthesis] = STATE(1528),
    [sym__open_bracket] = STATE(1525),
    [sym__open_bracket2] = STATE(1519),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(5977),
    [anon_sym_CARET] = ACTIONS(5977),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(5261),
    [anon_sym_DOLLAR] = ACTIONS(5983),
    [anon_sym_AT] = ACTIONS(5983),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5987),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5989),
    [sym__external_open_bracket2] = ACTIONS(5991),
  },
  [1804] = {
    [sym_function_definition] = STATE(1931),
    [sym_if_statement] = STATE(1931),
    [sym_for_statement] = STATE(1931),
    [sym_while_statement] = STATE(1931),
    [sym_repeat_statement] = STATE(1931),
    [sym_braced_expression] = STATE(1931),
    [sym_parenthesized_expression] = STATE(1931),
    [sym_call] = STATE(1931),
    [sym_subset] = STATE(1931),
    [sym_subset2] = STATE(1931),
    [sym__argument] = STATE(4656),
    [sym_argument] = STATE(4657),
    [sym__argument_named] = STATE(4658),
    [sym__argument_unnamed] = STATE(4662),
    [sym__argument_value] = STATE(4663),
    [sym_unary_operator] = STATE(1931),
    [sym_binary_operator] = STATE(1931),
    [sym_extract_operator] = STATE(1931),
    [sym_namespace_operator] = STATE(1931),
    [sym_integer] = STATE(1931),
    [sym_complex] = STATE(1931),
    [sym_float] = STATE(1931),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2633),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(1931),
    [sym__expression] = STATE(1931),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__close_parenthesis] = STATE(2833),
    [sym__open_brace] = STATE(154),
    [aux_sym_call_arguments_repeat1] = STATE(2113),
    [sym_identifier] = ACTIONS(6387),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(6389),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3865),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(6391),
    [sym_next] = ACTIONS(6391),
    [sym_break] = ACTIONS(6391),
    [sym_true] = ACTIONS(6391),
    [sym_false] = ACTIONS(6391),
    [sym_null] = ACTIONS(6391),
    [sym_inf] = ACTIONS(6391),
    [sym_nan] = ACTIONS(6391),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(6393),
    [sym_dot_dot_i] = ACTIONS(6395),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6397),
    [sym__newline] = ACTIONS(6399),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(6801),
    [sym__external_open_brace] = ACTIONS(3891),
  },
  [1805] = {
    [sym_function_definition] = STATE(2038),
    [sym_if_statement] = STATE(2038),
    [sym_for_statement] = STATE(2038),
    [sym_while_statement] = STATE(2038),
    [sym_repeat_statement] = STATE(2038),
    [sym_braced_expression] = STATE(2038),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_call] = STATE(2038),
    [sym_subset] = STATE(2038),
    [sym_subset2] = STATE(2038),
    [sym__argument] = STATE(4664),
    [sym_argument] = STATE(4659),
    [sym__argument_named] = STATE(4654),
    [sym__argument_unnamed] = STATE(4676),
    [sym__argument_value] = STATE(4677),
    [sym_unary_operator] = STATE(2038),
    [sym_binary_operator] = STATE(2038),
    [sym_extract_operator] = STATE(2038),
    [sym_namespace_operator] = STATE(2038),
    [sym_integer] = STATE(2038),
    [sym_complex] = STATE(2038),
    [sym_float] = STATE(2038),
    [sym__hex_literal] = STATE(2700),
    [sym__float_literal] = STATE(2700),
    [sym_string] = STATE(2597),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym_na] = STATE(2038),
    [sym__expression] = STATE(2038),
    [sym__string_or_identifier] = STATE(5148),
    [sym__open_parenthesis] = STATE(214),
    [sym__open_brace] = STATE(192),
    [sym__close_bracket] = STATE(2828),
    [aux_sym_call_arguments_repeat1] = STATE(2034),
    [sym_identifier] = ACTIONS(6351),
    [anon_sym_BSLASH] = ACTIONS(4754),
    [anon_sym_function] = ACTIONS(4756),
    [anon_sym_if] = ACTIONS(4758),
    [anon_sym_for] = ACTIONS(4760),
    [anon_sym_while] = ACTIONS(4762),
    [anon_sym_repeat] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4766),
    [anon_sym_TILDE] = ACTIONS(4768),
    [anon_sym_BANG] = ACTIONS(6353),
    [anon_sym_PLUS] = ACTIONS(4772),
    [anon_sym_DASH] = ACTIONS(4772),
    [aux_sym__hex_literal_token1] = ACTIONS(4776),
    [sym__number_literal] = ACTIONS(4778),
    [anon_sym_SQUOTE] = ACTIONS(4780),
    [anon_sym_DQUOTE] = ACTIONS(4782),
    [sym_return] = ACTIONS(6355),
    [sym_next] = ACTIONS(6355),
    [sym_break] = ACTIONS(6355),
    [sym_true] = ACTIONS(6355),
    [sym_false] = ACTIONS(6355),
    [sym_null] = ACTIONS(6355),
    [sym_inf] = ACTIONS(6355),
    [sym_nan] = ACTIONS(6355),
    [anon_sym_NA] = ACTIONS(4786),
    [anon_sym_NA_integer_] = ACTIONS(4786),
    [anon_sym_NA_real_] = ACTIONS(4786),
    [anon_sym_NA_complex_] = ACTIONS(4786),
    [anon_sym_NA_character_] = ACTIONS(4786),
    [sym_dots] = ACTIONS(6357),
    [sym_dot_dot_i] = ACTIONS(6359),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6361),
    [sym__newline] = ACTIONS(6363),
    [sym__raw_string_literal] = ACTIONS(4790),
    [sym__external_open_parenthesis] = ACTIONS(4792),
    [sym__external_open_brace] = ACTIONS(4794),
    [sym__external_close_bracket] = ACTIONS(6803),
  },
  [1806] = {
    [sym_function_definition] = STATE(1940),
    [sym_if_statement] = STATE(1940),
    [sym_for_statement] = STATE(1940),
    [sym_while_statement] = STATE(1940),
    [sym_repeat_statement] = STATE(1940),
    [sym_braced_expression] = STATE(1940),
    [sym_parenthesized_expression] = STATE(1940),
    [sym_call] = STATE(1940),
    [sym_subset] = STATE(1940),
    [sym_subset2] = STATE(1940),
    [sym__argument] = STATE(4665),
    [sym_argument] = STATE(4661),
    [sym__argument_named] = STATE(4669),
    [sym__argument_unnamed] = STATE(4673),
    [sym__argument_value] = STATE(4679),
    [sym_unary_operator] = STATE(1940),
    [sym_binary_operator] = STATE(1940),
    [sym_extract_operator] = STATE(1940),
    [sym_namespace_operator] = STATE(1940),
    [sym_integer] = STATE(1940),
    [sym_complex] = STATE(1940),
    [sym_float] = STATE(1940),
    [sym__hex_literal] = STATE(2656),
    [sym__float_literal] = STATE(2656),
    [sym_string] = STATE(2606),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym_na] = STATE(1940),
    [sym__expression] = STATE(1940),
    [sym__string_or_identifier] = STATE(5141),
    [sym__open_parenthesis] = STATE(218),
    [sym__open_brace] = STATE(185),
    [sym__close_bracket2] = STATE(2827),
    [aux_sym_call_arguments_repeat1] = STATE(1912),
    [sym_identifier] = ACTIONS(6369),
    [anon_sym_BSLASH] = ACTIONS(4644),
    [anon_sym_function] = ACTIONS(4646),
    [anon_sym_if] = ACTIONS(4648),
    [anon_sym_for] = ACTIONS(4650),
    [anon_sym_while] = ACTIONS(4652),
    [anon_sym_repeat] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(6371),
    [anon_sym_PLUS] = ACTIONS(4662),
    [anon_sym_DASH] = ACTIONS(4662),
    [aux_sym__hex_literal_token1] = ACTIONS(4666),
    [sym__number_literal] = ACTIONS(4668),
    [anon_sym_SQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4672),
    [sym_return] = ACTIONS(6373),
    [sym_next] = ACTIONS(6373),
    [sym_break] = ACTIONS(6373),
    [sym_true] = ACTIONS(6373),
    [sym_false] = ACTIONS(6373),
    [sym_null] = ACTIONS(6373),
    [sym_inf] = ACTIONS(6373),
    [sym_nan] = ACTIONS(6373),
    [anon_sym_NA] = ACTIONS(4676),
    [anon_sym_NA_integer_] = ACTIONS(4676),
    [anon_sym_NA_real_] = ACTIONS(4676),
    [anon_sym_NA_complex_] = ACTIONS(4676),
    [anon_sym_NA_character_] = ACTIONS(4676),
    [sym_dots] = ACTIONS(6375),
    [sym_dot_dot_i] = ACTIONS(6377),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6379),
    [sym__newline] = ACTIONS(6381),
    [sym__raw_string_literal] = ACTIONS(4680),
    [sym__external_open_parenthesis] = ACTIONS(4682),
    [sym__external_open_brace] = ACTIONS(4684),
    [sym__external_close_bracket2] = ACTIONS(6805),
  },
  [1807] = {
    [sym_call_arguments] = STATE(2777),
    [sym_subset_arguments] = STATE(2779),
    [sym_subset2_arguments] = STATE(2786),
    [sym__open_parenthesis] = STATE(1411),
    [sym__open_bracket] = STATE(1409),
    [sym__open_bracket2] = STATE(1407),
    [ts_builtin_sym_end] = ACTIONS(5399),
    [sym_identifier] = ACTIONS(5401),
    [anon_sym_BSLASH] = ACTIONS(5399),
    [anon_sym_function] = ACTIONS(5401),
    [anon_sym_EQ] = ACTIONS(6491),
    [anon_sym_if] = ACTIONS(5401),
    [anon_sym_for] = ACTIONS(5401),
    [anon_sym_while] = ACTIONS(5401),
    [anon_sym_repeat] = ACTIONS(5401),
    [anon_sym_QMARK] = ACTIONS(5399),
    [anon_sym_TILDE] = ACTIONS(6495),
    [anon_sym_BANG] = ACTIONS(5401),
    [anon_sym_PLUS] = ACTIONS(6497),
    [anon_sym_DASH] = ACTIONS(6499),
    [anon_sym_LT_DASH] = ACTIONS(6501),
    [anon_sym_LT_LT_DASH] = ACTIONS(6501),
    [anon_sym_COLON_EQ] = ACTIONS(6501),
    [anon_sym_DASH_GT] = ACTIONS(6503),
    [anon_sym_DASH_GT_GT] = ACTIONS(6505),
    [anon_sym_PIPE] = ACTIONS(6507),
    [anon_sym_AMP] = ACTIONS(6509),
    [anon_sym_PIPE_PIPE] = ACTIONS(6511),
    [anon_sym_AMP_AMP] = ACTIONS(6513),
    [anon_sym_LT] = ACTIONS(6515),
    [anon_sym_LT_EQ] = ACTIONS(6517),
    [anon_sym_GT] = ACTIONS(6515),
    [anon_sym_GT_EQ] = ACTIONS(6517),
    [anon_sym_EQ_EQ] = ACTIONS(6517),
    [anon_sym_BANG_EQ] = ACTIONS(6517),
    [anon_sym_STAR] = ACTIONS(6519),
    [anon_sym_SLASH] = ACTIONS(6521),
    [anon_sym_STAR_STAR] = ACTIONS(6523),
    [anon_sym_CARET] = ACTIONS(6523),
    [aux_sym_binary_operator_token1] = ACTIONS(6525),
    [anon_sym_PIPE_GT] = ACTIONS(6525),
    [anon_sym_COLON] = ACTIONS(6527),
    [anon_sym_DOLLAR] = ACTIONS(6529),
    [anon_sym_AT] = ACTIONS(6529),
    [aux_sym__hex_literal_token1] = ACTIONS(5399),
    [sym__number_literal] = ACTIONS(5401),
    [anon_sym_SQUOTE] = ACTIONS(5399),
    [anon_sym_DQUOTE] = ACTIONS(5399),
    [sym_return] = ACTIONS(5401),
    [sym_next] = ACTIONS(5401),
    [sym_break] = ACTIONS(5401),
    [sym_true] = ACTIONS(5401),
    [sym_false] = ACTIONS(5401),
    [sym_null] = ACTIONS(5401),
    [sym_inf] = ACTIONS(5401),
    [sym_nan] = ACTIONS(5401),
    [anon_sym_NA] = ACTIONS(5401),
    [anon_sym_NA_integer_] = ACTIONS(5401),
    [anon_sym_NA_real_] = ACTIONS(5401),
    [anon_sym_NA_complex_] = ACTIONS(5401),
    [anon_sym_NA_character_] = ACTIONS(5401),
    [sym_dots] = ACTIONS(5401),
    [sym_dot_dot_i] = ACTIONS(5399),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5399),
    [sym__semicolon] = ACTIONS(5399),
    [sym__raw_string_literal] = ACTIONS(5399),
    [sym__external_open_parenthesis] = ACTIONS(6531),
    [sym__external_close_parenthesis] = ACTIONS(5399),
    [sym__external_open_brace] = ACTIONS(5399),
    [sym__external_open_bracket] = ACTIONS(6533),
    [sym__external_open_bracket2] = ACTIONS(6535),
  },
  [1808] = {
    [sym_call_arguments] = STATE(2777),
    [sym_subset_arguments] = STATE(2779),
    [sym_subset2_arguments] = STATE(2786),
    [sym__open_parenthesis] = STATE(1411),
    [sym__open_bracket] = STATE(1409),
    [sym__open_bracket2] = STATE(1407),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(6491),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(6495),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(6497),
    [anon_sym_DASH] = ACTIONS(6499),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(6503),
    [anon_sym_DASH_GT_GT] = ACTIONS(6505),
    [anon_sym_PIPE] = ACTIONS(6507),
    [anon_sym_AMP] = ACTIONS(6509),
    [anon_sym_PIPE_PIPE] = ACTIONS(6511),
    [anon_sym_AMP_AMP] = ACTIONS(6513),
    [anon_sym_LT] = ACTIONS(6515),
    [anon_sym_LT_EQ] = ACTIONS(6517),
    [anon_sym_GT] = ACTIONS(6515),
    [anon_sym_GT_EQ] = ACTIONS(6517),
    [anon_sym_EQ_EQ] = ACTIONS(6517),
    [anon_sym_BANG_EQ] = ACTIONS(6517),
    [anon_sym_STAR] = ACTIONS(6519),
    [anon_sym_SLASH] = ACTIONS(6521),
    [anon_sym_STAR_STAR] = ACTIONS(6523),
    [anon_sym_CARET] = ACTIONS(6523),
    [aux_sym_binary_operator_token1] = ACTIONS(6525),
    [anon_sym_PIPE_GT] = ACTIONS(6525),
    [anon_sym_COLON] = ACTIONS(6527),
    [anon_sym_DOLLAR] = ACTIONS(6529),
    [anon_sym_AT] = ACTIONS(6529),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6531),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6533),
    [sym__external_open_bracket2] = ACTIONS(6535),
  },
  [1809] = {
    [sym_call_arguments] = STATE(2777),
    [sym_subset_arguments] = STATE(2779),
    [sym_subset2_arguments] = STATE(2786),
    [sym__open_parenthesis] = STATE(1411),
    [sym__open_bracket] = STATE(1409),
    [sym__open_bracket2] = STATE(1407),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(6491),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(6495),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(6497),
    [anon_sym_DASH] = ACTIONS(6499),
    [anon_sym_LT_DASH] = ACTIONS(6501),
    [anon_sym_LT_LT_DASH] = ACTIONS(6501),
    [anon_sym_COLON_EQ] = ACTIONS(6501),
    [anon_sym_DASH_GT] = ACTIONS(6503),
    [anon_sym_DASH_GT_GT] = ACTIONS(6505),
    [anon_sym_PIPE] = ACTIONS(6507),
    [anon_sym_AMP] = ACTIONS(6509),
    [anon_sym_PIPE_PIPE] = ACTIONS(6511),
    [anon_sym_AMP_AMP] = ACTIONS(6513),
    [anon_sym_LT] = ACTIONS(6515),
    [anon_sym_LT_EQ] = ACTIONS(6517),
    [anon_sym_GT] = ACTIONS(6515),
    [anon_sym_GT_EQ] = ACTIONS(6517),
    [anon_sym_EQ_EQ] = ACTIONS(6517),
    [anon_sym_BANG_EQ] = ACTIONS(6517),
    [anon_sym_STAR] = ACTIONS(6519),
    [anon_sym_SLASH] = ACTIONS(6521),
    [anon_sym_STAR_STAR] = ACTIONS(6523),
    [anon_sym_CARET] = ACTIONS(6523),
    [aux_sym_binary_operator_token1] = ACTIONS(6525),
    [anon_sym_PIPE_GT] = ACTIONS(6525),
    [anon_sym_COLON] = ACTIONS(6527),
    [anon_sym_DOLLAR] = ACTIONS(6529),
    [anon_sym_AT] = ACTIONS(6529),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6531),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6533),
    [sym__external_open_bracket2] = ACTIONS(6535),
  },
  [1810] = {
    [sym_call_arguments] = STATE(2777),
    [sym_subset_arguments] = STATE(2779),
    [sym_subset2_arguments] = STATE(2786),
    [sym__open_parenthesis] = STATE(1411),
    [sym__open_bracket] = STATE(1409),
    [sym__open_bracket2] = STATE(1407),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(6497),
    [anon_sym_DASH] = ACTIONS(6499),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(6507),
    [anon_sym_AMP] = ACTIONS(6509),
    [anon_sym_PIPE_PIPE] = ACTIONS(6511),
    [anon_sym_AMP_AMP] = ACTIONS(6513),
    [anon_sym_LT] = ACTIONS(6515),
    [anon_sym_LT_EQ] = ACTIONS(6517),
    [anon_sym_GT] = ACTIONS(6515),
    [anon_sym_GT_EQ] = ACTIONS(6517),
    [anon_sym_EQ_EQ] = ACTIONS(6517),
    [anon_sym_BANG_EQ] = ACTIONS(6517),
    [anon_sym_STAR] = ACTIONS(6519),
    [anon_sym_SLASH] = ACTIONS(6521),
    [anon_sym_STAR_STAR] = ACTIONS(6523),
    [anon_sym_CARET] = ACTIONS(6523),
    [aux_sym_binary_operator_token1] = ACTIONS(6525),
    [anon_sym_PIPE_GT] = ACTIONS(6525),
    [anon_sym_COLON] = ACTIONS(6527),
    [anon_sym_DOLLAR] = ACTIONS(6529),
    [anon_sym_AT] = ACTIONS(6529),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6531),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6533),
    [sym__external_open_bracket2] = ACTIONS(6535),
  },
  [1811] = {
    [sym_call_arguments] = STATE(2777),
    [sym_subset_arguments] = STATE(2779),
    [sym_subset2_arguments] = STATE(2786),
    [sym__open_parenthesis] = STATE(1411),
    [sym__open_bracket] = STATE(1409),
    [sym__open_bracket2] = STATE(1407),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(6519),
    [anon_sym_SLASH] = ACTIONS(6521),
    [anon_sym_STAR_STAR] = ACTIONS(6523),
    [anon_sym_CARET] = ACTIONS(6523),
    [aux_sym_binary_operator_token1] = ACTIONS(6525),
    [anon_sym_PIPE_GT] = ACTIONS(6525),
    [anon_sym_COLON] = ACTIONS(6527),
    [anon_sym_DOLLAR] = ACTIONS(6529),
    [anon_sym_AT] = ACTIONS(6529),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6531),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6533),
    [sym__external_open_bracket2] = ACTIONS(6535),
  },
  [1812] = {
    [sym_function_definition] = STATE(1940),
    [sym_if_statement] = STATE(1940),
    [sym_for_statement] = STATE(1940),
    [sym_while_statement] = STATE(1940),
    [sym_repeat_statement] = STATE(1940),
    [sym_braced_expression] = STATE(1940),
    [sym_parenthesized_expression] = STATE(1940),
    [sym_call] = STATE(1940),
    [sym_subset] = STATE(1940),
    [sym_subset2] = STATE(1940),
    [sym__argument] = STATE(4665),
    [sym_argument] = STATE(4661),
    [sym__argument_named] = STATE(4669),
    [sym__argument_unnamed] = STATE(4673),
    [sym__argument_value] = STATE(4679),
    [sym_unary_operator] = STATE(1940),
    [sym_binary_operator] = STATE(1940),
    [sym_extract_operator] = STATE(1940),
    [sym_namespace_operator] = STATE(1940),
    [sym_integer] = STATE(1940),
    [sym_complex] = STATE(1940),
    [sym_float] = STATE(1940),
    [sym__hex_literal] = STATE(2656),
    [sym__float_literal] = STATE(2656),
    [sym_string] = STATE(2606),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym_na] = STATE(1940),
    [sym__expression] = STATE(1940),
    [sym__string_or_identifier] = STATE(5141),
    [sym__open_parenthesis] = STATE(218),
    [sym__open_brace] = STATE(185),
    [sym__close_bracket2] = STATE(2240),
    [aux_sym_call_arguments_repeat1] = STATE(1912),
    [sym_identifier] = ACTIONS(6369),
    [anon_sym_BSLASH] = ACTIONS(4644),
    [anon_sym_function] = ACTIONS(4646),
    [anon_sym_if] = ACTIONS(4648),
    [anon_sym_for] = ACTIONS(4650),
    [anon_sym_while] = ACTIONS(4652),
    [anon_sym_repeat] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(6371),
    [anon_sym_PLUS] = ACTIONS(4662),
    [anon_sym_DASH] = ACTIONS(4662),
    [aux_sym__hex_literal_token1] = ACTIONS(4666),
    [sym__number_literal] = ACTIONS(4668),
    [anon_sym_SQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4672),
    [sym_return] = ACTIONS(6373),
    [sym_next] = ACTIONS(6373),
    [sym_break] = ACTIONS(6373),
    [sym_true] = ACTIONS(6373),
    [sym_false] = ACTIONS(6373),
    [sym_null] = ACTIONS(6373),
    [sym_inf] = ACTIONS(6373),
    [sym_nan] = ACTIONS(6373),
    [anon_sym_NA] = ACTIONS(4676),
    [anon_sym_NA_integer_] = ACTIONS(4676),
    [anon_sym_NA_real_] = ACTIONS(4676),
    [anon_sym_NA_complex_] = ACTIONS(4676),
    [anon_sym_NA_character_] = ACTIONS(4676),
    [sym_dots] = ACTIONS(6375),
    [sym_dot_dot_i] = ACTIONS(6377),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6379),
    [sym__newline] = ACTIONS(6381),
    [sym__raw_string_literal] = ACTIONS(4680),
    [sym__external_open_parenthesis] = ACTIONS(4682),
    [sym__external_open_brace] = ACTIONS(4684),
    [sym__external_close_bracket2] = ACTIONS(6807),
  },
  [1813] = {
    [sym_function_definition] = STATE(2038),
    [sym_if_statement] = STATE(2038),
    [sym_for_statement] = STATE(2038),
    [sym_while_statement] = STATE(2038),
    [sym_repeat_statement] = STATE(2038),
    [sym_braced_expression] = STATE(2038),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_call] = STATE(2038),
    [sym_subset] = STATE(2038),
    [sym_subset2] = STATE(2038),
    [sym__argument] = STATE(4664),
    [sym_argument] = STATE(4659),
    [sym__argument_named] = STATE(4654),
    [sym__argument_unnamed] = STATE(4676),
    [sym__argument_value] = STATE(4677),
    [sym_unary_operator] = STATE(2038),
    [sym_binary_operator] = STATE(2038),
    [sym_extract_operator] = STATE(2038),
    [sym_namespace_operator] = STATE(2038),
    [sym_integer] = STATE(2038),
    [sym_complex] = STATE(2038),
    [sym_float] = STATE(2038),
    [sym__hex_literal] = STATE(2700),
    [sym__float_literal] = STATE(2700),
    [sym_string] = STATE(2597),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym_na] = STATE(2038),
    [sym__expression] = STATE(2038),
    [sym__string_or_identifier] = STATE(5148),
    [sym__open_parenthesis] = STATE(214),
    [sym__open_brace] = STATE(192),
    [sym__close_bracket] = STATE(2241),
    [aux_sym_call_arguments_repeat1] = STATE(2034),
    [sym_identifier] = ACTIONS(6351),
    [anon_sym_BSLASH] = ACTIONS(4754),
    [anon_sym_function] = ACTIONS(4756),
    [anon_sym_if] = ACTIONS(4758),
    [anon_sym_for] = ACTIONS(4760),
    [anon_sym_while] = ACTIONS(4762),
    [anon_sym_repeat] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4766),
    [anon_sym_TILDE] = ACTIONS(4768),
    [anon_sym_BANG] = ACTIONS(6353),
    [anon_sym_PLUS] = ACTIONS(4772),
    [anon_sym_DASH] = ACTIONS(4772),
    [aux_sym__hex_literal_token1] = ACTIONS(4776),
    [sym__number_literal] = ACTIONS(4778),
    [anon_sym_SQUOTE] = ACTIONS(4780),
    [anon_sym_DQUOTE] = ACTIONS(4782),
    [sym_return] = ACTIONS(6355),
    [sym_next] = ACTIONS(6355),
    [sym_break] = ACTIONS(6355),
    [sym_true] = ACTIONS(6355),
    [sym_false] = ACTIONS(6355),
    [sym_null] = ACTIONS(6355),
    [sym_inf] = ACTIONS(6355),
    [sym_nan] = ACTIONS(6355),
    [anon_sym_NA] = ACTIONS(4786),
    [anon_sym_NA_integer_] = ACTIONS(4786),
    [anon_sym_NA_real_] = ACTIONS(4786),
    [anon_sym_NA_complex_] = ACTIONS(4786),
    [anon_sym_NA_character_] = ACTIONS(4786),
    [sym_dots] = ACTIONS(6357),
    [sym_dot_dot_i] = ACTIONS(6359),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6361),
    [sym__newline] = ACTIONS(6363),
    [sym__raw_string_literal] = ACTIONS(4790),
    [sym__external_open_parenthesis] = ACTIONS(4792),
    [sym__external_open_brace] = ACTIONS(4794),
    [sym__external_close_bracket] = ACTIONS(6809),
  },
  [1814] = {
    [sym_call_arguments] = STATE(2923),
    [sym_subset_arguments] = STATE(2922),
    [sym_subset2_arguments] = STATE(2906),
    [sym__open_parenthesis] = STATE(1528),
    [sym__open_bracket] = STATE(1525),
    [sym__open_bracket2] = STATE(1519),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(5977),
    [anon_sym_CARET] = ACTIONS(5977),
    [aux_sym_binary_operator_token1] = ACTIONS(5979),
    [anon_sym_PIPE_GT] = ACTIONS(5979),
    [anon_sym_COLON] = ACTIONS(5981),
    [anon_sym_DOLLAR] = ACTIONS(5983),
    [anon_sym_AT] = ACTIONS(5983),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5987),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5989),
    [sym__external_open_bracket2] = ACTIONS(5991),
  },
  [1815] = {
    [sym_call_arguments] = STATE(2777),
    [sym_subset_arguments] = STATE(2779),
    [sym_subset2_arguments] = STATE(2786),
    [sym__open_parenthesis] = STATE(1411),
    [sym__open_bracket] = STATE(1409),
    [sym__open_bracket2] = STATE(1407),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(6491),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(6495),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(6497),
    [anon_sym_DASH] = ACTIONS(6499),
    [anon_sym_LT_DASH] = ACTIONS(6501),
    [anon_sym_LT_LT_DASH] = ACTIONS(6501),
    [anon_sym_COLON_EQ] = ACTIONS(6501),
    [anon_sym_DASH_GT] = ACTIONS(6503),
    [anon_sym_DASH_GT_GT] = ACTIONS(6505),
    [anon_sym_PIPE] = ACTIONS(6507),
    [anon_sym_AMP] = ACTIONS(6509),
    [anon_sym_PIPE_PIPE] = ACTIONS(6511),
    [anon_sym_AMP_AMP] = ACTIONS(6513),
    [anon_sym_LT] = ACTIONS(6515),
    [anon_sym_LT_EQ] = ACTIONS(6517),
    [anon_sym_GT] = ACTIONS(6515),
    [anon_sym_GT_EQ] = ACTIONS(6517),
    [anon_sym_EQ_EQ] = ACTIONS(6517),
    [anon_sym_BANG_EQ] = ACTIONS(6517),
    [anon_sym_STAR] = ACTIONS(6519),
    [anon_sym_SLASH] = ACTIONS(6521),
    [anon_sym_STAR_STAR] = ACTIONS(6523),
    [anon_sym_CARET] = ACTIONS(6523),
    [aux_sym_binary_operator_token1] = ACTIONS(6525),
    [anon_sym_PIPE_GT] = ACTIONS(6525),
    [anon_sym_COLON] = ACTIONS(6527),
    [anon_sym_DOLLAR] = ACTIONS(6529),
    [anon_sym_AT] = ACTIONS(6529),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6531),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6533),
    [sym__external_open_bracket2] = ACTIONS(6535),
  },
  [1816] = {
    [sym_call_arguments] = STATE(2777),
    [sym_subset_arguments] = STATE(2779),
    [sym_subset2_arguments] = STATE(2786),
    [sym__open_parenthesis] = STATE(1411),
    [sym__open_bracket] = STATE(1409),
    [sym__open_bracket2] = STATE(1407),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(6495),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(6497),
    [anon_sym_DASH] = ACTIONS(6499),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(6507),
    [anon_sym_AMP] = ACTIONS(6509),
    [anon_sym_PIPE_PIPE] = ACTIONS(6511),
    [anon_sym_AMP_AMP] = ACTIONS(6513),
    [anon_sym_LT] = ACTIONS(6515),
    [anon_sym_LT_EQ] = ACTIONS(6517),
    [anon_sym_GT] = ACTIONS(6515),
    [anon_sym_GT_EQ] = ACTIONS(6517),
    [anon_sym_EQ_EQ] = ACTIONS(6517),
    [anon_sym_BANG_EQ] = ACTIONS(6517),
    [anon_sym_STAR] = ACTIONS(6519),
    [anon_sym_SLASH] = ACTIONS(6521),
    [anon_sym_STAR_STAR] = ACTIONS(6523),
    [anon_sym_CARET] = ACTIONS(6523),
    [aux_sym_binary_operator_token1] = ACTIONS(6525),
    [anon_sym_PIPE_GT] = ACTIONS(6525),
    [anon_sym_COLON] = ACTIONS(6527),
    [anon_sym_DOLLAR] = ACTIONS(6529),
    [anon_sym_AT] = ACTIONS(6529),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6531),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6533),
    [sym__external_open_bracket2] = ACTIONS(6535),
  },
  [1817] = {
    [sym_string] = STATE(2733),
    [sym__single_quoted_string] = STATE(2236),
    [sym__double_quoted_string] = STATE(2237),
    [sym__string_or_identifier] = STATE(2733),
    [aux_sym_function_definition_repeat1] = STATE(1868),
    [sym_identifier] = ACTIONS(6811),
    [anon_sym_BSLASH] = ACTIONS(5659),
    [anon_sym_function] = ACTIONS(5663),
    [anon_sym_EQ] = ACTIONS(5663),
    [anon_sym_if] = ACTIONS(5663),
    [anon_sym_for] = ACTIONS(5663),
    [anon_sym_while] = ACTIONS(5663),
    [anon_sym_repeat] = ACTIONS(5663),
    [anon_sym_QMARK] = ACTIONS(5659),
    [anon_sym_TILDE] = ACTIONS(5659),
    [anon_sym_BANG] = ACTIONS(5663),
    [anon_sym_PLUS] = ACTIONS(5659),
    [anon_sym_DASH] = ACTIONS(5663),
    [anon_sym_LT_DASH] = ACTIONS(5659),
    [anon_sym_LT_LT_DASH] = ACTIONS(5659),
    [anon_sym_COLON_EQ] = ACTIONS(5659),
    [anon_sym_DASH_GT] = ACTIONS(5663),
    [anon_sym_DASH_GT_GT] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(5663),
    [anon_sym_AMP] = ACTIONS(5663),
    [anon_sym_PIPE_PIPE] = ACTIONS(5659),
    [anon_sym_AMP_AMP] = ACTIONS(5659),
    [anon_sym_LT] = ACTIONS(5663),
    [anon_sym_LT_EQ] = ACTIONS(5659),
    [anon_sym_GT] = ACTIONS(5663),
    [anon_sym_GT_EQ] = ACTIONS(5659),
    [anon_sym_EQ_EQ] = ACTIONS(5659),
    [anon_sym_BANG_EQ] = ACTIONS(5659),
    [anon_sym_STAR] = ACTIONS(5663),
    [anon_sym_SLASH] = ACTIONS(5659),
    [anon_sym_STAR_STAR] = ACTIONS(5659),
    [anon_sym_CARET] = ACTIONS(5659),
    [aux_sym_binary_operator_token1] = ACTIONS(5659),
    [anon_sym_PIPE_GT] = ACTIONS(5659),
    [anon_sym_COLON] = ACTIONS(5663),
    [anon_sym_DOLLAR] = ACTIONS(5659),
    [anon_sym_AT] = ACTIONS(5659),
    [aux_sym__hex_literal_token1] = ACTIONS(5659),
    [sym__number_literal] = ACTIONS(5663),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [anon_sym_DQUOTE] = ACTIONS(1463),
    [sym_return] = ACTIONS(5663),
    [sym_next] = ACTIONS(5663),
    [sym_break] = ACTIONS(5663),
    [sym_true] = ACTIONS(5663),
    [sym_false] = ACTIONS(5663),
    [sym_null] = ACTIONS(5663),
    [sym_inf] = ACTIONS(5663),
    [sym_nan] = ACTIONS(5663),
    [anon_sym_NA] = ACTIONS(5663),
    [anon_sym_NA_integer_] = ACTIONS(5663),
    [anon_sym_NA_real_] = ACTIONS(5663),
    [anon_sym_NA_complex_] = ACTIONS(5663),
    [anon_sym_NA_character_] = ACTIONS(5663),
    [sym_dots] = ACTIONS(5663),
    [sym_dot_dot_i] = ACTIONS(5659),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5659),
    [sym__newline] = ACTIONS(6813),
    [sym__semicolon] = ACTIONS(5659),
    [sym__raw_string_literal] = ACTIONS(1473),
    [sym__external_open_parenthesis] = ACTIONS(5659),
    [sym__external_open_brace] = ACTIONS(5659),
    [sym__external_close_brace] = ACTIONS(5659),
    [sym__external_open_bracket] = ACTIONS(5659),
    [sym__external_open_bracket2] = ACTIONS(5659),
    [sym__external_close_bracket2] = ACTIONS(5659),
  },
  [1818] = {
    [sym_call_arguments] = STATE(2777),
    [sym_subset_arguments] = STATE(2779),
    [sym_subset2_arguments] = STATE(2786),
    [sym__open_parenthesis] = STATE(1411),
    [sym__open_bracket] = STATE(1409),
    [sym__open_bracket2] = STATE(1407),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(6497),
    [anon_sym_DASH] = ACTIONS(6499),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(6509),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(6513),
    [anon_sym_LT] = ACTIONS(6515),
    [anon_sym_LT_EQ] = ACTIONS(6517),
    [anon_sym_GT] = ACTIONS(6515),
    [anon_sym_GT_EQ] = ACTIONS(6517),
    [anon_sym_EQ_EQ] = ACTIONS(6517),
    [anon_sym_BANG_EQ] = ACTIONS(6517),
    [anon_sym_STAR] = ACTIONS(6519),
    [anon_sym_SLASH] = ACTIONS(6521),
    [anon_sym_STAR_STAR] = ACTIONS(6523),
    [anon_sym_CARET] = ACTIONS(6523),
    [aux_sym_binary_operator_token1] = ACTIONS(6525),
    [anon_sym_PIPE_GT] = ACTIONS(6525),
    [anon_sym_COLON] = ACTIONS(6527),
    [anon_sym_DOLLAR] = ACTIONS(6529),
    [anon_sym_AT] = ACTIONS(6529),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6531),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6533),
    [sym__external_open_bracket2] = ACTIONS(6535),
  },
  [1819] = {
    [sym_call_arguments] = STATE(2777),
    [sym_subset_arguments] = STATE(2779),
    [sym_subset2_arguments] = STATE(2786),
    [sym__open_parenthesis] = STATE(1411),
    [sym__open_bracket] = STATE(1409),
    [sym__open_bracket2] = STATE(1407),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(6497),
    [anon_sym_DASH] = ACTIONS(6499),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(6515),
    [anon_sym_LT_EQ] = ACTIONS(6517),
    [anon_sym_GT] = ACTIONS(6515),
    [anon_sym_GT_EQ] = ACTIONS(6517),
    [anon_sym_EQ_EQ] = ACTIONS(6517),
    [anon_sym_BANG_EQ] = ACTIONS(6517),
    [anon_sym_STAR] = ACTIONS(6519),
    [anon_sym_SLASH] = ACTIONS(6521),
    [anon_sym_STAR_STAR] = ACTIONS(6523),
    [anon_sym_CARET] = ACTIONS(6523),
    [aux_sym_binary_operator_token1] = ACTIONS(6525),
    [anon_sym_PIPE_GT] = ACTIONS(6525),
    [anon_sym_COLON] = ACTIONS(6527),
    [anon_sym_DOLLAR] = ACTIONS(6529),
    [anon_sym_AT] = ACTIONS(6529),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6531),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6533),
    [sym__external_open_bracket2] = ACTIONS(6535),
  },
  [1820] = {
    [sym_call_arguments] = STATE(2777),
    [sym_subset_arguments] = STATE(2779),
    [sym_subset2_arguments] = STATE(2786),
    [sym__open_parenthesis] = STATE(1411),
    [sym__open_bracket] = STATE(1409),
    [sym__open_bracket2] = STATE(1407),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(6497),
    [anon_sym_DASH] = ACTIONS(6499),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(6519),
    [anon_sym_SLASH] = ACTIONS(6521),
    [anon_sym_STAR_STAR] = ACTIONS(6523),
    [anon_sym_CARET] = ACTIONS(6523),
    [aux_sym_binary_operator_token1] = ACTIONS(6525),
    [anon_sym_PIPE_GT] = ACTIONS(6525),
    [anon_sym_COLON] = ACTIONS(6527),
    [anon_sym_DOLLAR] = ACTIONS(6529),
    [anon_sym_AT] = ACTIONS(6529),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6531),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6533),
    [sym__external_open_bracket2] = ACTIONS(6535),
  },
  [1821] = {
    [sym_call_arguments] = STATE(2923),
    [sym_subset_arguments] = STATE(2922),
    [sym_subset2_arguments] = STATE(2906),
    [sym__open_parenthesis] = STATE(1528),
    [sym__open_bracket] = STATE(1525),
    [sym__open_bracket2] = STATE(1519),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5951),
    [anon_sym_DASH] = ACTIONS(5953),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5973),
    [anon_sym_SLASH] = ACTIONS(5975),
    [anon_sym_STAR_STAR] = ACTIONS(5977),
    [anon_sym_CARET] = ACTIONS(5977),
    [aux_sym_binary_operator_token1] = ACTIONS(5979),
    [anon_sym_PIPE_GT] = ACTIONS(5979),
    [anon_sym_COLON] = ACTIONS(5981),
    [anon_sym_DOLLAR] = ACTIONS(5983),
    [anon_sym_AT] = ACTIONS(5983),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5987),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5989),
    [sym__external_open_bracket2] = ACTIONS(5991),
  },
  [1822] = {
    [sym_call_arguments] = STATE(2777),
    [sym_subset_arguments] = STATE(2779),
    [sym_subset2_arguments] = STATE(2786),
    [sym__open_parenthesis] = STATE(1411),
    [sym__open_bracket] = STATE(1409),
    [sym__open_bracket2] = STATE(1407),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(6523),
    [anon_sym_CARET] = ACTIONS(6523),
    [aux_sym_binary_operator_token1] = ACTIONS(6525),
    [anon_sym_PIPE_GT] = ACTIONS(6525),
    [anon_sym_COLON] = ACTIONS(6527),
    [anon_sym_DOLLAR] = ACTIONS(6529),
    [anon_sym_AT] = ACTIONS(6529),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6531),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6533),
    [sym__external_open_bracket2] = ACTIONS(6535),
  },
  [1823] = {
    [sym_call_arguments] = STATE(2923),
    [sym_subset_arguments] = STATE(2922),
    [sym_subset2_arguments] = STATE(2906),
    [sym__open_parenthesis] = STATE(1528),
    [sym__open_bracket] = STATE(1525),
    [sym__open_bracket2] = STATE(1519),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5951),
    [anon_sym_DASH] = ACTIONS(5953),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5969),
    [anon_sym_LT_EQ] = ACTIONS(5971),
    [anon_sym_GT] = ACTIONS(5969),
    [anon_sym_GT_EQ] = ACTIONS(5971),
    [anon_sym_EQ_EQ] = ACTIONS(5971),
    [anon_sym_BANG_EQ] = ACTIONS(5971),
    [anon_sym_STAR] = ACTIONS(5973),
    [anon_sym_SLASH] = ACTIONS(5975),
    [anon_sym_STAR_STAR] = ACTIONS(5977),
    [anon_sym_CARET] = ACTIONS(5977),
    [aux_sym_binary_operator_token1] = ACTIONS(5979),
    [anon_sym_PIPE_GT] = ACTIONS(5979),
    [anon_sym_COLON] = ACTIONS(5981),
    [anon_sym_DOLLAR] = ACTIONS(5983),
    [anon_sym_AT] = ACTIONS(5983),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5987),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5989),
    [sym__external_open_bracket2] = ACTIONS(5991),
  },
  [1824] = {
    [sym_call_arguments] = STATE(2777),
    [sym_subset_arguments] = STATE(2779),
    [sym_subset2_arguments] = STATE(2786),
    [sym__open_parenthesis] = STATE(1411),
    [sym__open_bracket] = STATE(1409),
    [sym__open_bracket2] = STATE(1407),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(6523),
    [anon_sym_CARET] = ACTIONS(6523),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(5261),
    [anon_sym_DOLLAR] = ACTIONS(6529),
    [anon_sym_AT] = ACTIONS(6529),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6531),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6533),
    [sym__external_open_bracket2] = ACTIONS(6535),
  },
  [1825] = {
    [sym_call_arguments] = STATE(2777),
    [sym_subset_arguments] = STATE(2779),
    [sym_subset2_arguments] = STATE(2786),
    [sym__open_parenthesis] = STATE(1411),
    [sym__open_bracket] = STATE(1409),
    [sym__open_bracket2] = STATE(1407),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(6523),
    [anon_sym_CARET] = ACTIONS(6523),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(6527),
    [anon_sym_DOLLAR] = ACTIONS(6529),
    [anon_sym_AT] = ACTIONS(6529),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6531),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6533),
    [sym__external_open_bracket2] = ACTIONS(6535),
  },
  [1826] = {
    [sym_call_arguments] = STATE(2777),
    [sym_subset_arguments] = STATE(2779),
    [sym_subset2_arguments] = STATE(2786),
    [sym__open_parenthesis] = STATE(1411),
    [sym__open_bracket] = STATE(1409),
    [sym__open_bracket2] = STATE(1407),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(6523),
    [anon_sym_CARET] = ACTIONS(6523),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(5261),
    [anon_sym_DOLLAR] = ACTIONS(6529),
    [anon_sym_AT] = ACTIONS(6529),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6531),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6533),
    [sym__external_open_bracket2] = ACTIONS(6535),
  },
  [1827] = {
    [sym_call_arguments] = STATE(2923),
    [sym_subset_arguments] = STATE(2922),
    [sym_subset2_arguments] = STATE(2906),
    [sym__open_parenthesis] = STATE(1528),
    [sym__open_bracket] = STATE(1525),
    [sym__open_bracket2] = STATE(1519),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5951),
    [anon_sym_DASH] = ACTIONS(5953),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5963),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5967),
    [anon_sym_LT] = ACTIONS(5969),
    [anon_sym_LT_EQ] = ACTIONS(5971),
    [anon_sym_GT] = ACTIONS(5969),
    [anon_sym_GT_EQ] = ACTIONS(5971),
    [anon_sym_EQ_EQ] = ACTIONS(5971),
    [anon_sym_BANG_EQ] = ACTIONS(5971),
    [anon_sym_STAR] = ACTIONS(5973),
    [anon_sym_SLASH] = ACTIONS(5975),
    [anon_sym_STAR_STAR] = ACTIONS(5977),
    [anon_sym_CARET] = ACTIONS(5977),
    [aux_sym_binary_operator_token1] = ACTIONS(5979),
    [anon_sym_PIPE_GT] = ACTIONS(5979),
    [anon_sym_COLON] = ACTIONS(5981),
    [anon_sym_DOLLAR] = ACTIONS(5983),
    [anon_sym_AT] = ACTIONS(5983),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5987),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5989),
    [sym__external_open_bracket2] = ACTIONS(5991),
  },
  [1828] = {
    [sym_call_arguments] = STATE(2923),
    [sym_subset_arguments] = STATE(2922),
    [sym_subset2_arguments] = STATE(2906),
    [sym__open_parenthesis] = STATE(1528),
    [sym__open_bracket] = STATE(1525),
    [sym__open_bracket2] = STATE(1519),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5949),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5951),
    [anon_sym_DASH] = ACTIONS(5953),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5961),
    [anon_sym_AMP] = ACTIONS(5963),
    [anon_sym_PIPE_PIPE] = ACTIONS(5965),
    [anon_sym_AMP_AMP] = ACTIONS(5967),
    [anon_sym_LT] = ACTIONS(5969),
    [anon_sym_LT_EQ] = ACTIONS(5971),
    [anon_sym_GT] = ACTIONS(5969),
    [anon_sym_GT_EQ] = ACTIONS(5971),
    [anon_sym_EQ_EQ] = ACTIONS(5971),
    [anon_sym_BANG_EQ] = ACTIONS(5971),
    [anon_sym_STAR] = ACTIONS(5973),
    [anon_sym_SLASH] = ACTIONS(5975),
    [anon_sym_STAR_STAR] = ACTIONS(5977),
    [anon_sym_CARET] = ACTIONS(5977),
    [aux_sym_binary_operator_token1] = ACTIONS(5979),
    [anon_sym_PIPE_GT] = ACTIONS(5979),
    [anon_sym_COLON] = ACTIONS(5981),
    [anon_sym_DOLLAR] = ACTIONS(5983),
    [anon_sym_AT] = ACTIONS(5983),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5987),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5989),
    [sym__external_open_bracket2] = ACTIONS(5991),
  },
  [1829] = {
    [sym_function_definition] = STATE(1940),
    [sym_if_statement] = STATE(1940),
    [sym_for_statement] = STATE(1940),
    [sym_while_statement] = STATE(1940),
    [sym_repeat_statement] = STATE(1940),
    [sym_braced_expression] = STATE(1940),
    [sym_parenthesized_expression] = STATE(1940),
    [sym_call] = STATE(1940),
    [sym_subset] = STATE(1940),
    [sym_subset2] = STATE(1940),
    [sym__argument] = STATE(4665),
    [sym_argument] = STATE(4661),
    [sym__argument_named] = STATE(4669),
    [sym__argument_unnamed] = STATE(4673),
    [sym__argument_value] = STATE(4679),
    [sym_unary_operator] = STATE(1940),
    [sym_binary_operator] = STATE(1940),
    [sym_extract_operator] = STATE(1940),
    [sym_namespace_operator] = STATE(1940),
    [sym_integer] = STATE(1940),
    [sym_complex] = STATE(1940),
    [sym_float] = STATE(1940),
    [sym__hex_literal] = STATE(2656),
    [sym__float_literal] = STATE(2656),
    [sym_string] = STATE(2606),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym_na] = STATE(1940),
    [sym__expression] = STATE(1940),
    [sym__string_or_identifier] = STATE(5141),
    [sym__open_parenthesis] = STATE(218),
    [sym__open_brace] = STATE(185),
    [sym__close_bracket2] = STATE(2862),
    [aux_sym_call_arguments_repeat1] = STATE(1912),
    [sym_identifier] = ACTIONS(6369),
    [anon_sym_BSLASH] = ACTIONS(4644),
    [anon_sym_function] = ACTIONS(4646),
    [anon_sym_if] = ACTIONS(4648),
    [anon_sym_for] = ACTIONS(4650),
    [anon_sym_while] = ACTIONS(4652),
    [anon_sym_repeat] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(6371),
    [anon_sym_PLUS] = ACTIONS(4662),
    [anon_sym_DASH] = ACTIONS(4662),
    [aux_sym__hex_literal_token1] = ACTIONS(4666),
    [sym__number_literal] = ACTIONS(4668),
    [anon_sym_SQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4672),
    [sym_return] = ACTIONS(6373),
    [sym_next] = ACTIONS(6373),
    [sym_break] = ACTIONS(6373),
    [sym_true] = ACTIONS(6373),
    [sym_false] = ACTIONS(6373),
    [sym_null] = ACTIONS(6373),
    [sym_inf] = ACTIONS(6373),
    [sym_nan] = ACTIONS(6373),
    [anon_sym_NA] = ACTIONS(4676),
    [anon_sym_NA_integer_] = ACTIONS(4676),
    [anon_sym_NA_real_] = ACTIONS(4676),
    [anon_sym_NA_complex_] = ACTIONS(4676),
    [anon_sym_NA_character_] = ACTIONS(4676),
    [sym_dots] = ACTIONS(6375),
    [sym_dot_dot_i] = ACTIONS(6377),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6379),
    [sym__newline] = ACTIONS(6381),
    [sym__raw_string_literal] = ACTIONS(4680),
    [sym__external_open_parenthesis] = ACTIONS(4682),
    [sym__external_open_brace] = ACTIONS(4684),
    [sym__external_close_bracket2] = ACTIONS(6815),
  },
  [1830] = {
    [sym_call_arguments] = STATE(2923),
    [sym_subset_arguments] = STATE(2922),
    [sym_subset2_arguments] = STATE(2906),
    [sym__open_parenthesis] = STATE(1528),
    [sym__open_bracket] = STATE(1525),
    [sym__open_bracket2] = STATE(1519),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5947),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5949),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5951),
    [anon_sym_DASH] = ACTIONS(5953),
    [anon_sym_LT_DASH] = ACTIONS(5955),
    [anon_sym_LT_LT_DASH] = ACTIONS(5955),
    [anon_sym_COLON_EQ] = ACTIONS(5955),
    [anon_sym_DASH_GT] = ACTIONS(5957),
    [anon_sym_DASH_GT_GT] = ACTIONS(5959),
    [anon_sym_PIPE] = ACTIONS(5961),
    [anon_sym_AMP] = ACTIONS(5963),
    [anon_sym_PIPE_PIPE] = ACTIONS(5965),
    [anon_sym_AMP_AMP] = ACTIONS(5967),
    [anon_sym_LT] = ACTIONS(5969),
    [anon_sym_LT_EQ] = ACTIONS(5971),
    [anon_sym_GT] = ACTIONS(5969),
    [anon_sym_GT_EQ] = ACTIONS(5971),
    [anon_sym_EQ_EQ] = ACTIONS(5971),
    [anon_sym_BANG_EQ] = ACTIONS(5971),
    [anon_sym_STAR] = ACTIONS(5973),
    [anon_sym_SLASH] = ACTIONS(5975),
    [anon_sym_STAR_STAR] = ACTIONS(5977),
    [anon_sym_CARET] = ACTIONS(5977),
    [aux_sym_binary_operator_token1] = ACTIONS(5979),
    [anon_sym_PIPE_GT] = ACTIONS(5979),
    [anon_sym_COLON] = ACTIONS(5981),
    [anon_sym_DOLLAR] = ACTIONS(5983),
    [anon_sym_AT] = ACTIONS(5983),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5987),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5989),
    [sym__external_open_bracket2] = ACTIONS(5991),
  },
  [1831] = {
    [sym_call_arguments] = STATE(2923),
    [sym_subset_arguments] = STATE(2922),
    [sym_subset2_arguments] = STATE(2906),
    [sym__open_parenthesis] = STATE(1528),
    [sym__open_bracket] = STATE(1525),
    [sym__open_bracket2] = STATE(1519),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5973),
    [anon_sym_SLASH] = ACTIONS(5975),
    [anon_sym_STAR_STAR] = ACTIONS(5977),
    [anon_sym_CARET] = ACTIONS(5977),
    [aux_sym_binary_operator_token1] = ACTIONS(5979),
    [anon_sym_PIPE_GT] = ACTIONS(5979),
    [anon_sym_COLON] = ACTIONS(5981),
    [anon_sym_DOLLAR] = ACTIONS(5983),
    [anon_sym_AT] = ACTIONS(5983),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5987),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5989),
    [sym__external_open_bracket2] = ACTIONS(5991),
  },
  [1832] = {
    [sym_call_arguments] = STATE(2923),
    [sym_subset_arguments] = STATE(2922),
    [sym_subset2_arguments] = STATE(2906),
    [sym__open_parenthesis] = STATE(1528),
    [sym__open_bracket] = STATE(1525),
    [sym__open_bracket2] = STATE(1519),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5951),
    [anon_sym_DASH] = ACTIONS(5953),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5961),
    [anon_sym_AMP] = ACTIONS(5963),
    [anon_sym_PIPE_PIPE] = ACTIONS(5965),
    [anon_sym_AMP_AMP] = ACTIONS(5967),
    [anon_sym_LT] = ACTIONS(5969),
    [anon_sym_LT_EQ] = ACTIONS(5971),
    [anon_sym_GT] = ACTIONS(5969),
    [anon_sym_GT_EQ] = ACTIONS(5971),
    [anon_sym_EQ_EQ] = ACTIONS(5971),
    [anon_sym_BANG_EQ] = ACTIONS(5971),
    [anon_sym_STAR] = ACTIONS(5973),
    [anon_sym_SLASH] = ACTIONS(5975),
    [anon_sym_STAR_STAR] = ACTIONS(5977),
    [anon_sym_CARET] = ACTIONS(5977),
    [aux_sym_binary_operator_token1] = ACTIONS(5979),
    [anon_sym_PIPE_GT] = ACTIONS(5979),
    [anon_sym_COLON] = ACTIONS(5981),
    [anon_sym_DOLLAR] = ACTIONS(5983),
    [anon_sym_AT] = ACTIONS(5983),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5987),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5989),
    [sym__external_open_bracket2] = ACTIONS(5991),
  },
  [1833] = {
    [sym_call_arguments] = STATE(2777),
    [sym_subset_arguments] = STATE(2779),
    [sym_subset2_arguments] = STATE(2786),
    [sym__open_parenthesis] = STATE(1411),
    [sym__open_bracket] = STATE(1409),
    [sym__open_bracket2] = STATE(1407),
    [ts_builtin_sym_end] = ACTIONS(5413),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_BSLASH] = ACTIONS(5413),
    [anon_sym_function] = ACTIONS(5415),
    [anon_sym_EQ] = ACTIONS(6491),
    [anon_sym_if] = ACTIONS(5415),
    [anon_sym_for] = ACTIONS(5415),
    [anon_sym_while] = ACTIONS(5415),
    [anon_sym_repeat] = ACTIONS(5415),
    [anon_sym_QMARK] = ACTIONS(5413),
    [anon_sym_TILDE] = ACTIONS(6495),
    [anon_sym_BANG] = ACTIONS(5415),
    [anon_sym_PLUS] = ACTIONS(6497),
    [anon_sym_DASH] = ACTIONS(6499),
    [anon_sym_LT_DASH] = ACTIONS(6501),
    [anon_sym_LT_LT_DASH] = ACTIONS(6501),
    [anon_sym_COLON_EQ] = ACTIONS(6501),
    [anon_sym_DASH_GT] = ACTIONS(6503),
    [anon_sym_DASH_GT_GT] = ACTIONS(6505),
    [anon_sym_PIPE] = ACTIONS(6507),
    [anon_sym_AMP] = ACTIONS(6509),
    [anon_sym_PIPE_PIPE] = ACTIONS(6511),
    [anon_sym_AMP_AMP] = ACTIONS(6513),
    [anon_sym_LT] = ACTIONS(6515),
    [anon_sym_LT_EQ] = ACTIONS(6517),
    [anon_sym_GT] = ACTIONS(6515),
    [anon_sym_GT_EQ] = ACTIONS(6517),
    [anon_sym_EQ_EQ] = ACTIONS(6517),
    [anon_sym_BANG_EQ] = ACTIONS(6517),
    [anon_sym_STAR] = ACTIONS(6519),
    [anon_sym_SLASH] = ACTIONS(6521),
    [anon_sym_STAR_STAR] = ACTIONS(6523),
    [anon_sym_CARET] = ACTIONS(6523),
    [aux_sym_binary_operator_token1] = ACTIONS(6525),
    [anon_sym_PIPE_GT] = ACTIONS(6525),
    [anon_sym_COLON] = ACTIONS(6527),
    [anon_sym_DOLLAR] = ACTIONS(6529),
    [anon_sym_AT] = ACTIONS(6529),
    [aux_sym__hex_literal_token1] = ACTIONS(5413),
    [sym__number_literal] = ACTIONS(5415),
    [anon_sym_SQUOTE] = ACTIONS(5413),
    [anon_sym_DQUOTE] = ACTIONS(5413),
    [sym_return] = ACTIONS(5415),
    [sym_next] = ACTIONS(5415),
    [sym_break] = ACTIONS(5415),
    [sym_true] = ACTIONS(5415),
    [sym_false] = ACTIONS(5415),
    [sym_null] = ACTIONS(5415),
    [sym_inf] = ACTIONS(5415),
    [sym_nan] = ACTIONS(5415),
    [anon_sym_NA] = ACTIONS(5415),
    [anon_sym_NA_integer_] = ACTIONS(5415),
    [anon_sym_NA_real_] = ACTIONS(5415),
    [anon_sym_NA_complex_] = ACTIONS(5415),
    [anon_sym_NA_character_] = ACTIONS(5415),
    [sym_dots] = ACTIONS(5415),
    [sym_dot_dot_i] = ACTIONS(5413),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5413),
    [sym__semicolon] = ACTIONS(5413),
    [sym__raw_string_literal] = ACTIONS(5413),
    [sym__external_open_parenthesis] = ACTIONS(6531),
    [sym__external_close_parenthesis] = ACTIONS(5413),
    [sym__external_open_brace] = ACTIONS(5413),
    [sym__external_open_bracket] = ACTIONS(6533),
    [sym__external_open_bracket2] = ACTIONS(6535),
  },
  [1834] = {
    [sym_call_arguments] = STATE(2923),
    [sym_subset_arguments] = STATE(2922),
    [sym_subset2_arguments] = STATE(2906),
    [sym__open_parenthesis] = STATE(1528),
    [sym__open_bracket] = STATE(1525),
    [sym__open_bracket2] = STATE(1519),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5947),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5949),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5951),
    [anon_sym_DASH] = ACTIONS(5953),
    [anon_sym_LT_DASH] = ACTIONS(5955),
    [anon_sym_LT_LT_DASH] = ACTIONS(5955),
    [anon_sym_COLON_EQ] = ACTIONS(5955),
    [anon_sym_DASH_GT] = ACTIONS(5957),
    [anon_sym_DASH_GT_GT] = ACTIONS(5959),
    [anon_sym_PIPE] = ACTIONS(5961),
    [anon_sym_AMP] = ACTIONS(5963),
    [anon_sym_PIPE_PIPE] = ACTIONS(5965),
    [anon_sym_AMP_AMP] = ACTIONS(5967),
    [anon_sym_LT] = ACTIONS(5969),
    [anon_sym_LT_EQ] = ACTIONS(5971),
    [anon_sym_GT] = ACTIONS(5969),
    [anon_sym_GT_EQ] = ACTIONS(5971),
    [anon_sym_EQ_EQ] = ACTIONS(5971),
    [anon_sym_BANG_EQ] = ACTIONS(5971),
    [anon_sym_STAR] = ACTIONS(5973),
    [anon_sym_SLASH] = ACTIONS(5975),
    [anon_sym_STAR_STAR] = ACTIONS(5977),
    [anon_sym_CARET] = ACTIONS(5977),
    [aux_sym_binary_operator_token1] = ACTIONS(5979),
    [anon_sym_PIPE_GT] = ACTIONS(5979),
    [anon_sym_COLON] = ACTIONS(5981),
    [anon_sym_DOLLAR] = ACTIONS(5983),
    [anon_sym_AT] = ACTIONS(5983),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5987),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5989),
    [sym__external_open_bracket2] = ACTIONS(5991),
  },
  [1835] = {
    [sym_call_arguments] = STATE(2923),
    [sym_subset_arguments] = STATE(2922),
    [sym_subset2_arguments] = STATE(2906),
    [sym__open_parenthesis] = STATE(1528),
    [sym__open_bracket] = STATE(1525),
    [sym__open_bracket2] = STATE(1519),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5947),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5949),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5951),
    [anon_sym_DASH] = ACTIONS(5953),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5957),
    [anon_sym_DASH_GT_GT] = ACTIONS(5959),
    [anon_sym_PIPE] = ACTIONS(5961),
    [anon_sym_AMP] = ACTIONS(5963),
    [anon_sym_PIPE_PIPE] = ACTIONS(5965),
    [anon_sym_AMP_AMP] = ACTIONS(5967),
    [anon_sym_LT] = ACTIONS(5969),
    [anon_sym_LT_EQ] = ACTIONS(5971),
    [anon_sym_GT] = ACTIONS(5969),
    [anon_sym_GT_EQ] = ACTIONS(5971),
    [anon_sym_EQ_EQ] = ACTIONS(5971),
    [anon_sym_BANG_EQ] = ACTIONS(5971),
    [anon_sym_STAR] = ACTIONS(5973),
    [anon_sym_SLASH] = ACTIONS(5975),
    [anon_sym_STAR_STAR] = ACTIONS(5977),
    [anon_sym_CARET] = ACTIONS(5977),
    [aux_sym_binary_operator_token1] = ACTIONS(5979),
    [anon_sym_PIPE_GT] = ACTIONS(5979),
    [anon_sym_COLON] = ACTIONS(5981),
    [anon_sym_DOLLAR] = ACTIONS(5983),
    [anon_sym_AT] = ACTIONS(5983),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_else] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(5987),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(5989),
    [sym__external_open_bracket2] = ACTIONS(5991),
  },
  [1836] = {
    [sym_call_arguments] = STATE(2923),
    [sym_subset_arguments] = STATE(2922),
    [sym_subset2_arguments] = STATE(2906),
    [sym__open_parenthesis] = STATE(1528),
    [sym__open_bracket] = STATE(1525),
    [sym__open_bracket2] = STATE(1519),
    [ts_builtin_sym_end] = ACTIONS(5399),
    [sym_identifier] = ACTIONS(5401),
    [anon_sym_BSLASH] = ACTIONS(5399),
    [anon_sym_function] = ACTIONS(5401),
    [anon_sym_EQ] = ACTIONS(5947),
    [anon_sym_if] = ACTIONS(5401),
    [anon_sym_for] = ACTIONS(5401),
    [anon_sym_while] = ACTIONS(5401),
    [anon_sym_repeat] = ACTIONS(5401),
    [anon_sym_QMARK] = ACTIONS(5399),
    [anon_sym_TILDE] = ACTIONS(5949),
    [anon_sym_BANG] = ACTIONS(5401),
    [anon_sym_PLUS] = ACTIONS(5951),
    [anon_sym_DASH] = ACTIONS(5953),
    [anon_sym_LT_DASH] = ACTIONS(5955),
    [anon_sym_LT_LT_DASH] = ACTIONS(5955),
    [anon_sym_COLON_EQ] = ACTIONS(5955),
    [anon_sym_DASH_GT] = ACTIONS(5957),
    [anon_sym_DASH_GT_GT] = ACTIONS(5959),
    [anon_sym_PIPE] = ACTIONS(5961),
    [anon_sym_AMP] = ACTIONS(5963),
    [anon_sym_PIPE_PIPE] = ACTIONS(5965),
    [anon_sym_AMP_AMP] = ACTIONS(5967),
    [anon_sym_LT] = ACTIONS(5969),
    [anon_sym_LT_EQ] = ACTIONS(5971),
    [anon_sym_GT] = ACTIONS(5969),
    [anon_sym_GT_EQ] = ACTIONS(5971),
    [anon_sym_EQ_EQ] = ACTIONS(5971),
    [anon_sym_BANG_EQ] = ACTIONS(5971),
    [anon_sym_STAR] = ACTIONS(5973),
    [anon_sym_SLASH] = ACTIONS(5975),
    [anon_sym_STAR_STAR] = ACTIONS(5977),
    [anon_sym_CARET] = ACTIONS(5977),
    [aux_sym_binary_operator_token1] = ACTIONS(5979),
    [anon_sym_PIPE_GT] = ACTIONS(5979),
    [anon_sym_COLON] = ACTIONS(5981),
    [anon_sym_DOLLAR] = ACTIONS(5983),
    [anon_sym_AT] = ACTIONS(5983),
    [aux_sym__hex_literal_token1] = ACTIONS(5399),
    [sym__number_literal] = ACTIONS(5401),
    [anon_sym_SQUOTE] = ACTIONS(5399),
    [anon_sym_DQUOTE] = ACTIONS(5399),
    [sym_return] = ACTIONS(5401),
    [sym_next] = ACTIONS(5401),
    [sym_break] = ACTIONS(5401),
    [sym_true] = ACTIONS(5401),
    [sym_false] = ACTIONS(5401),
    [sym_null] = ACTIONS(5401),
    [sym_inf] = ACTIONS(5401),
    [sym_nan] = ACTIONS(5401),
    [anon_sym_NA] = ACTIONS(5401),
    [anon_sym_NA_integer_] = ACTIONS(5401),
    [anon_sym_NA_real_] = ACTIONS(5401),
    [anon_sym_NA_complex_] = ACTIONS(5401),
    [anon_sym_NA_character_] = ACTIONS(5401),
    [sym_dots] = ACTIONS(5401),
    [sym_dot_dot_i] = ACTIONS(5399),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5399),
    [sym__semicolon] = ACTIONS(5399),
    [sym__raw_string_literal] = ACTIONS(5399),
    [sym__external_else] = ACTIONS(5399),
    [sym__external_open_parenthesis] = ACTIONS(5987),
    [sym__external_open_brace] = ACTIONS(5399),
    [sym__external_open_bracket] = ACTIONS(5989),
    [sym__external_open_bracket2] = ACTIONS(5991),
  },
  [1837] = {
    [sym_call_arguments] = STATE(2840),
    [sym_subset_arguments] = STATE(2797),
    [sym_subset2_arguments] = STATE(2801),
    [sym__open_parenthesis] = STATE(1344),
    [sym__open_bracket] = STATE(1374),
    [sym__open_bracket2] = STATE(1452),
    [ts_builtin_sym_end] = ACTIONS(5345),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5345),
    [anon_sym_DASH] = ACTIONS(5347),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5347),
    [anon_sym_AMP] = ACTIONS(5347),
    [anon_sym_PIPE_PIPE] = ACTIONS(5345),
    [anon_sym_AMP_AMP] = ACTIONS(5345),
    [anon_sym_LT] = ACTIONS(5347),
    [anon_sym_LT_EQ] = ACTIONS(5345),
    [anon_sym_GT] = ACTIONS(5347),
    [anon_sym_GT_EQ] = ACTIONS(5345),
    [anon_sym_EQ_EQ] = ACTIONS(5345),
    [anon_sym_BANG_EQ] = ACTIONS(5345),
    [anon_sym_STAR] = ACTIONS(5347),
    [anon_sym_SLASH] = ACTIONS(5345),
    [anon_sym_STAR_STAR] = ACTIONS(6293),
    [anon_sym_CARET] = ACTIONS(6293),
    [aux_sym_binary_operator_token1] = ACTIONS(5345),
    [anon_sym_PIPE_GT] = ACTIONS(5345),
    [anon_sym_COLON] = ACTIONS(5347),
    [anon_sym_DOLLAR] = ACTIONS(6299),
    [anon_sym_AT] = ACTIONS(6299),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5345),
    [sym__semicolon] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(6301),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_close_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(6303),
    [sym__external_open_bracket2] = ACTIONS(6305),
  },
  [1838] = {
    [sym_function_definition] = STATE(1940),
    [sym_if_statement] = STATE(1940),
    [sym_for_statement] = STATE(1940),
    [sym_while_statement] = STATE(1940),
    [sym_repeat_statement] = STATE(1940),
    [sym_braced_expression] = STATE(1940),
    [sym_parenthesized_expression] = STATE(1940),
    [sym_call] = STATE(1940),
    [sym_subset] = STATE(1940),
    [sym_subset2] = STATE(1940),
    [sym__argument] = STATE(4665),
    [sym_argument] = STATE(4661),
    [sym__argument_named] = STATE(4669),
    [sym__argument_unnamed] = STATE(4673),
    [sym__argument_value] = STATE(4679),
    [sym_unary_operator] = STATE(1940),
    [sym_binary_operator] = STATE(1940),
    [sym_extract_operator] = STATE(1940),
    [sym_namespace_operator] = STATE(1940),
    [sym_integer] = STATE(1940),
    [sym_complex] = STATE(1940),
    [sym_float] = STATE(1940),
    [sym__hex_literal] = STATE(2656),
    [sym__float_literal] = STATE(2656),
    [sym_string] = STATE(2606),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym_na] = STATE(1940),
    [sym__expression] = STATE(1940),
    [sym__string_or_identifier] = STATE(5141),
    [sym__open_parenthesis] = STATE(218),
    [sym__open_brace] = STATE(185),
    [sym__close_bracket2] = STATE(2751),
    [aux_sym_call_arguments_repeat1] = STATE(1912),
    [sym_identifier] = ACTIONS(6369),
    [anon_sym_BSLASH] = ACTIONS(4644),
    [anon_sym_function] = ACTIONS(4646),
    [anon_sym_if] = ACTIONS(4648),
    [anon_sym_for] = ACTIONS(4650),
    [anon_sym_while] = ACTIONS(4652),
    [anon_sym_repeat] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(6371),
    [anon_sym_PLUS] = ACTIONS(4662),
    [anon_sym_DASH] = ACTIONS(4662),
    [aux_sym__hex_literal_token1] = ACTIONS(4666),
    [sym__number_literal] = ACTIONS(4668),
    [anon_sym_SQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4672),
    [sym_return] = ACTIONS(6373),
    [sym_next] = ACTIONS(6373),
    [sym_break] = ACTIONS(6373),
    [sym_true] = ACTIONS(6373),
    [sym_false] = ACTIONS(6373),
    [sym_null] = ACTIONS(6373),
    [sym_inf] = ACTIONS(6373),
    [sym_nan] = ACTIONS(6373),
    [anon_sym_NA] = ACTIONS(4676),
    [anon_sym_NA_integer_] = ACTIONS(4676),
    [anon_sym_NA_real_] = ACTIONS(4676),
    [anon_sym_NA_complex_] = ACTIONS(4676),
    [anon_sym_NA_character_] = ACTIONS(4676),
    [sym_dots] = ACTIONS(6375),
    [sym_dot_dot_i] = ACTIONS(6377),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6379),
    [sym__newline] = ACTIONS(6381),
    [sym__raw_string_literal] = ACTIONS(4680),
    [sym__external_open_parenthesis] = ACTIONS(4682),
    [sym__external_open_brace] = ACTIONS(4684),
    [sym__external_close_bracket2] = ACTIONS(6817),
  },
  [1839] = {
    [sym_function_definition] = STATE(2038),
    [sym_if_statement] = STATE(2038),
    [sym_for_statement] = STATE(2038),
    [sym_while_statement] = STATE(2038),
    [sym_repeat_statement] = STATE(2038),
    [sym_braced_expression] = STATE(2038),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_call] = STATE(2038),
    [sym_subset] = STATE(2038),
    [sym_subset2] = STATE(2038),
    [sym__argument] = STATE(4664),
    [sym_argument] = STATE(4659),
    [sym__argument_named] = STATE(4654),
    [sym__argument_unnamed] = STATE(4676),
    [sym__argument_value] = STATE(4677),
    [sym_unary_operator] = STATE(2038),
    [sym_binary_operator] = STATE(2038),
    [sym_extract_operator] = STATE(2038),
    [sym_namespace_operator] = STATE(2038),
    [sym_integer] = STATE(2038),
    [sym_complex] = STATE(2038),
    [sym_float] = STATE(2038),
    [sym__hex_literal] = STATE(2700),
    [sym__float_literal] = STATE(2700),
    [sym_string] = STATE(2597),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym_na] = STATE(2038),
    [sym__expression] = STATE(2038),
    [sym__string_or_identifier] = STATE(5148),
    [sym__open_parenthesis] = STATE(214),
    [sym__open_brace] = STATE(192),
    [sym__close_bracket] = STATE(2754),
    [aux_sym_call_arguments_repeat1] = STATE(2034),
    [sym_identifier] = ACTIONS(6351),
    [anon_sym_BSLASH] = ACTIONS(4754),
    [anon_sym_function] = ACTIONS(4756),
    [anon_sym_if] = ACTIONS(4758),
    [anon_sym_for] = ACTIONS(4760),
    [anon_sym_while] = ACTIONS(4762),
    [anon_sym_repeat] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4766),
    [anon_sym_TILDE] = ACTIONS(4768),
    [anon_sym_BANG] = ACTIONS(6353),
    [anon_sym_PLUS] = ACTIONS(4772),
    [anon_sym_DASH] = ACTIONS(4772),
    [aux_sym__hex_literal_token1] = ACTIONS(4776),
    [sym__number_literal] = ACTIONS(4778),
    [anon_sym_SQUOTE] = ACTIONS(4780),
    [anon_sym_DQUOTE] = ACTIONS(4782),
    [sym_return] = ACTIONS(6355),
    [sym_next] = ACTIONS(6355),
    [sym_break] = ACTIONS(6355),
    [sym_true] = ACTIONS(6355),
    [sym_false] = ACTIONS(6355),
    [sym_null] = ACTIONS(6355),
    [sym_inf] = ACTIONS(6355),
    [sym_nan] = ACTIONS(6355),
    [anon_sym_NA] = ACTIONS(4786),
    [anon_sym_NA_integer_] = ACTIONS(4786),
    [anon_sym_NA_real_] = ACTIONS(4786),
    [anon_sym_NA_complex_] = ACTIONS(4786),
    [anon_sym_NA_character_] = ACTIONS(4786),
    [sym_dots] = ACTIONS(6357),
    [sym_dot_dot_i] = ACTIONS(6359),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6361),
    [sym__newline] = ACTIONS(6363),
    [sym__raw_string_literal] = ACTIONS(4790),
    [sym__external_open_parenthesis] = ACTIONS(4792),
    [sym__external_open_brace] = ACTIONS(4794),
    [sym__external_close_bracket] = ACTIONS(6819),
  },
  [1840] = {
    [sym_call_arguments] = STATE(2923),
    [sym_subset_arguments] = STATE(2922),
    [sym_subset2_arguments] = STATE(2906),
    [sym__open_parenthesis] = STATE(1528),
    [sym__open_bracket] = STATE(1525),
    [sym__open_bracket2] = STATE(1519),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(5977),
    [anon_sym_CARET] = ACTIONS(5977),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(5351),
    [anon_sym_DOLLAR] = ACTIONS(5983),
    [anon_sym_AT] = ACTIONS(5983),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5987),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5989),
    [sym__external_open_bracket2] = ACTIONS(5991),
  },
  [1841] = {
    [sym_call_arguments] = STATE(2923),
    [sym_subset_arguments] = STATE(2922),
    [sym_subset2_arguments] = STATE(2906),
    [sym__open_parenthesis] = STATE(1528),
    [sym__open_bracket] = STATE(1525),
    [sym__open_bracket2] = STATE(1519),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(5977),
    [anon_sym_CARET] = ACTIONS(5977),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(5981),
    [anon_sym_DOLLAR] = ACTIONS(5983),
    [anon_sym_AT] = ACTIONS(5983),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5987),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5989),
    [sym__external_open_bracket2] = ACTIONS(5991),
  },
  [1842] = {
    [sym_call_arguments] = STATE(2923),
    [sym_subset_arguments] = STATE(2922),
    [sym_subset2_arguments] = STATE(2906),
    [sym__open_parenthesis] = STATE(1528),
    [sym__open_bracket] = STATE(1525),
    [sym__open_bracket2] = STATE(1519),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(5977),
    [anon_sym_CARET] = ACTIONS(5977),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(5351),
    [anon_sym_DOLLAR] = ACTIONS(5983),
    [anon_sym_AT] = ACTIONS(5983),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5987),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5989),
    [sym__external_open_bracket2] = ACTIONS(5991),
  },
  [1843] = {
    [sym_call_arguments] = STATE(2923),
    [sym_subset_arguments] = STATE(2922),
    [sym_subset2_arguments] = STATE(2906),
    [sym__open_parenthesis] = STATE(1528),
    [sym__open_bracket] = STATE(1525),
    [sym__open_bracket2] = STATE(1519),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(5977),
    [anon_sym_CARET] = ACTIONS(5977),
    [aux_sym_binary_operator_token1] = ACTIONS(5979),
    [anon_sym_PIPE_GT] = ACTIONS(5979),
    [anon_sym_COLON] = ACTIONS(5981),
    [anon_sym_DOLLAR] = ACTIONS(5983),
    [anon_sym_AT] = ACTIONS(5983),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5987),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5989),
    [sym__external_open_bracket2] = ACTIONS(5991),
  },
  [1844] = {
    [sym_call_arguments] = STATE(2923),
    [sym_subset_arguments] = STATE(2922),
    [sym_subset2_arguments] = STATE(2906),
    [sym__open_parenthesis] = STATE(1528),
    [sym__open_bracket] = STATE(1525),
    [sym__open_bracket2] = STATE(1519),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5951),
    [anon_sym_DASH] = ACTIONS(5953),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5973),
    [anon_sym_SLASH] = ACTIONS(5975),
    [anon_sym_STAR_STAR] = ACTIONS(5977),
    [anon_sym_CARET] = ACTIONS(5977),
    [aux_sym_binary_operator_token1] = ACTIONS(5979),
    [anon_sym_PIPE_GT] = ACTIONS(5979),
    [anon_sym_COLON] = ACTIONS(5981),
    [anon_sym_DOLLAR] = ACTIONS(5983),
    [anon_sym_AT] = ACTIONS(5983),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5987),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5989),
    [sym__external_open_bracket2] = ACTIONS(5991),
  },
  [1845] = {
    [sym_call_arguments] = STATE(2923),
    [sym_subset_arguments] = STATE(2922),
    [sym_subset2_arguments] = STATE(2906),
    [sym__open_parenthesis] = STATE(1528),
    [sym__open_bracket] = STATE(1525),
    [sym__open_bracket2] = STATE(1519),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5951),
    [anon_sym_DASH] = ACTIONS(5953),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5969),
    [anon_sym_LT_EQ] = ACTIONS(5971),
    [anon_sym_GT] = ACTIONS(5969),
    [anon_sym_GT_EQ] = ACTIONS(5971),
    [anon_sym_EQ_EQ] = ACTIONS(5971),
    [anon_sym_BANG_EQ] = ACTIONS(5971),
    [anon_sym_STAR] = ACTIONS(5973),
    [anon_sym_SLASH] = ACTIONS(5975),
    [anon_sym_STAR_STAR] = ACTIONS(5977),
    [anon_sym_CARET] = ACTIONS(5977),
    [aux_sym_binary_operator_token1] = ACTIONS(5979),
    [anon_sym_PIPE_GT] = ACTIONS(5979),
    [anon_sym_COLON] = ACTIONS(5981),
    [anon_sym_DOLLAR] = ACTIONS(5983),
    [anon_sym_AT] = ACTIONS(5983),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5987),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5989),
    [sym__external_open_bracket2] = ACTIONS(5991),
  },
  [1846] = {
    [sym_function_definition] = STATE(1931),
    [sym_if_statement] = STATE(1931),
    [sym_for_statement] = STATE(1931),
    [sym_while_statement] = STATE(1931),
    [sym_repeat_statement] = STATE(1931),
    [sym_braced_expression] = STATE(1931),
    [sym_parenthesized_expression] = STATE(1931),
    [sym_call] = STATE(1931),
    [sym_subset] = STATE(1931),
    [sym_subset2] = STATE(1931),
    [sym__argument] = STATE(4656),
    [sym_argument] = STATE(4657),
    [sym__argument_named] = STATE(4658),
    [sym__argument_unnamed] = STATE(4662),
    [sym__argument_value] = STATE(4663),
    [sym_unary_operator] = STATE(1931),
    [sym_binary_operator] = STATE(1931),
    [sym_extract_operator] = STATE(1931),
    [sym_namespace_operator] = STATE(1931),
    [sym_integer] = STATE(1931),
    [sym_complex] = STATE(1931),
    [sym_float] = STATE(1931),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2633),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(1931),
    [sym__expression] = STATE(1931),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__close_parenthesis] = STATE(2467),
    [sym__open_brace] = STATE(154),
    [aux_sym_call_arguments_repeat1] = STATE(2113),
    [sym_identifier] = ACTIONS(6387),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(6389),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3865),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(6391),
    [sym_next] = ACTIONS(6391),
    [sym_break] = ACTIONS(6391),
    [sym_true] = ACTIONS(6391),
    [sym_false] = ACTIONS(6391),
    [sym_null] = ACTIONS(6391),
    [sym_inf] = ACTIONS(6391),
    [sym_nan] = ACTIONS(6391),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(6393),
    [sym_dot_dot_i] = ACTIONS(6395),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6397),
    [sym__newline] = ACTIONS(6399),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(6821),
    [sym__external_open_brace] = ACTIONS(3891),
  },
  [1847] = {
    [sym_call_arguments] = STATE(2923),
    [sym_subset_arguments] = STATE(2922),
    [sym_subset2_arguments] = STATE(2906),
    [sym__open_parenthesis] = STATE(1528),
    [sym__open_bracket] = STATE(1525),
    [sym__open_bracket2] = STATE(1519),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5951),
    [anon_sym_DASH] = ACTIONS(5953),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5963),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5967),
    [anon_sym_LT] = ACTIONS(5969),
    [anon_sym_LT_EQ] = ACTIONS(5971),
    [anon_sym_GT] = ACTIONS(5969),
    [anon_sym_GT_EQ] = ACTIONS(5971),
    [anon_sym_EQ_EQ] = ACTIONS(5971),
    [anon_sym_BANG_EQ] = ACTIONS(5971),
    [anon_sym_STAR] = ACTIONS(5973),
    [anon_sym_SLASH] = ACTIONS(5975),
    [anon_sym_STAR_STAR] = ACTIONS(5977),
    [anon_sym_CARET] = ACTIONS(5977),
    [aux_sym_binary_operator_token1] = ACTIONS(5979),
    [anon_sym_PIPE_GT] = ACTIONS(5979),
    [anon_sym_COLON] = ACTIONS(5981),
    [anon_sym_DOLLAR] = ACTIONS(5983),
    [anon_sym_AT] = ACTIONS(5983),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5987),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5989),
    [sym__external_open_bracket2] = ACTIONS(5991),
  },
  [1848] = {
    [sym_call_arguments] = STATE(2840),
    [sym_subset_arguments] = STATE(2797),
    [sym_subset2_arguments] = STATE(2801),
    [sym__open_parenthesis] = STATE(1344),
    [sym__open_bracket] = STATE(1374),
    [sym__open_bracket2] = STATE(1452),
    [ts_builtin_sym_end] = ACTIONS(5333),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(5333),
    [anon_sym_DASH] = ACTIONS(5335),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5335),
    [anon_sym_AMP] = ACTIONS(5335),
    [anon_sym_PIPE_PIPE] = ACTIONS(5333),
    [anon_sym_AMP_AMP] = ACTIONS(5333),
    [anon_sym_LT] = ACTIONS(5335),
    [anon_sym_LT_EQ] = ACTIONS(5333),
    [anon_sym_GT] = ACTIONS(5335),
    [anon_sym_GT_EQ] = ACTIONS(5333),
    [anon_sym_EQ_EQ] = ACTIONS(5333),
    [anon_sym_BANG_EQ] = ACTIONS(5333),
    [anon_sym_STAR] = ACTIONS(5335),
    [anon_sym_SLASH] = ACTIONS(5333),
    [anon_sym_STAR_STAR] = ACTIONS(6293),
    [anon_sym_CARET] = ACTIONS(6293),
    [aux_sym_binary_operator_token1] = ACTIONS(5333),
    [anon_sym_PIPE_GT] = ACTIONS(5333),
    [anon_sym_COLON] = ACTIONS(5335),
    [anon_sym_DOLLAR] = ACTIONS(6299),
    [anon_sym_AT] = ACTIONS(6299),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5333),
    [sym__semicolon] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(6301),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_close_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(6303),
    [sym__external_open_bracket2] = ACTIONS(6305),
  },
  [1849] = {
    [sym_call_arguments] = STATE(2923),
    [sym_subset_arguments] = STATE(2922),
    [sym_subset2_arguments] = STATE(2906),
    [sym__open_parenthesis] = STATE(1528),
    [sym__open_bracket] = STATE(1525),
    [sym__open_bracket2] = STATE(1519),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5949),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5951),
    [anon_sym_DASH] = ACTIONS(5953),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5961),
    [anon_sym_AMP] = ACTIONS(5963),
    [anon_sym_PIPE_PIPE] = ACTIONS(5965),
    [anon_sym_AMP_AMP] = ACTIONS(5967),
    [anon_sym_LT] = ACTIONS(5969),
    [anon_sym_LT_EQ] = ACTIONS(5971),
    [anon_sym_GT] = ACTIONS(5969),
    [anon_sym_GT_EQ] = ACTIONS(5971),
    [anon_sym_EQ_EQ] = ACTIONS(5971),
    [anon_sym_BANG_EQ] = ACTIONS(5971),
    [anon_sym_STAR] = ACTIONS(5973),
    [anon_sym_SLASH] = ACTIONS(5975),
    [anon_sym_STAR_STAR] = ACTIONS(5977),
    [anon_sym_CARET] = ACTIONS(5977),
    [aux_sym_binary_operator_token1] = ACTIONS(5979),
    [anon_sym_PIPE_GT] = ACTIONS(5979),
    [anon_sym_COLON] = ACTIONS(5981),
    [anon_sym_DOLLAR] = ACTIONS(5983),
    [anon_sym_AT] = ACTIONS(5983),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5987),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5989),
    [sym__external_open_bracket2] = ACTIONS(5991),
  },
  [1850] = {
    [sym_call_arguments] = STATE(2777),
    [sym_subset_arguments] = STATE(2779),
    [sym_subset2_arguments] = STATE(2786),
    [sym__open_parenthesis] = STATE(1411),
    [sym__open_bracket] = STATE(1409),
    [sym__open_bracket2] = STATE(1407),
    [ts_builtin_sym_end] = ACTIONS(5417),
    [sym_identifier] = ACTIONS(5419),
    [anon_sym_BSLASH] = ACTIONS(5417),
    [anon_sym_function] = ACTIONS(5419),
    [anon_sym_EQ] = ACTIONS(6491),
    [anon_sym_if] = ACTIONS(5419),
    [anon_sym_for] = ACTIONS(5419),
    [anon_sym_while] = ACTIONS(5419),
    [anon_sym_repeat] = ACTIONS(5419),
    [anon_sym_QMARK] = ACTIONS(5417),
    [anon_sym_TILDE] = ACTIONS(6495),
    [anon_sym_BANG] = ACTIONS(5419),
    [anon_sym_PLUS] = ACTIONS(6497),
    [anon_sym_DASH] = ACTIONS(6499),
    [anon_sym_LT_DASH] = ACTIONS(6501),
    [anon_sym_LT_LT_DASH] = ACTIONS(6501),
    [anon_sym_COLON_EQ] = ACTIONS(6501),
    [anon_sym_DASH_GT] = ACTIONS(6503),
    [anon_sym_DASH_GT_GT] = ACTIONS(6505),
    [anon_sym_PIPE] = ACTIONS(6507),
    [anon_sym_AMP] = ACTIONS(6509),
    [anon_sym_PIPE_PIPE] = ACTIONS(6511),
    [anon_sym_AMP_AMP] = ACTIONS(6513),
    [anon_sym_LT] = ACTIONS(6515),
    [anon_sym_LT_EQ] = ACTIONS(6517),
    [anon_sym_GT] = ACTIONS(6515),
    [anon_sym_GT_EQ] = ACTIONS(6517),
    [anon_sym_EQ_EQ] = ACTIONS(6517),
    [anon_sym_BANG_EQ] = ACTIONS(6517),
    [anon_sym_STAR] = ACTIONS(6519),
    [anon_sym_SLASH] = ACTIONS(6521),
    [anon_sym_STAR_STAR] = ACTIONS(6523),
    [anon_sym_CARET] = ACTIONS(6523),
    [aux_sym_binary_operator_token1] = ACTIONS(6525),
    [anon_sym_PIPE_GT] = ACTIONS(6525),
    [anon_sym_COLON] = ACTIONS(6527),
    [anon_sym_DOLLAR] = ACTIONS(6529),
    [anon_sym_AT] = ACTIONS(6529),
    [aux_sym__hex_literal_token1] = ACTIONS(5417),
    [sym__number_literal] = ACTIONS(5419),
    [anon_sym_SQUOTE] = ACTIONS(5417),
    [anon_sym_DQUOTE] = ACTIONS(5417),
    [sym_return] = ACTIONS(5419),
    [sym_next] = ACTIONS(5419),
    [sym_break] = ACTIONS(5419),
    [sym_true] = ACTIONS(5419),
    [sym_false] = ACTIONS(5419),
    [sym_null] = ACTIONS(5419),
    [sym_inf] = ACTIONS(5419),
    [sym_nan] = ACTIONS(5419),
    [anon_sym_NA] = ACTIONS(5419),
    [anon_sym_NA_integer_] = ACTIONS(5419),
    [anon_sym_NA_real_] = ACTIONS(5419),
    [anon_sym_NA_complex_] = ACTIONS(5419),
    [anon_sym_NA_character_] = ACTIONS(5419),
    [sym_dots] = ACTIONS(5419),
    [sym_dot_dot_i] = ACTIONS(5417),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5417),
    [sym__semicolon] = ACTIONS(5417),
    [sym__raw_string_literal] = ACTIONS(5417),
    [sym__external_open_parenthesis] = ACTIONS(6531),
    [sym__external_close_parenthesis] = ACTIONS(5417),
    [sym__external_open_brace] = ACTIONS(5417),
    [sym__external_open_bracket] = ACTIONS(6533),
    [sym__external_open_bracket2] = ACTIONS(6535),
  },
  [1851] = {
    [sym_call_arguments] = STATE(2923),
    [sym_subset_arguments] = STATE(2922),
    [sym_subset2_arguments] = STATE(2906),
    [sym__open_parenthesis] = STATE(1528),
    [sym__open_bracket] = STATE(1525),
    [sym__open_bracket2] = STATE(1519),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5947),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5949),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5951),
    [anon_sym_DASH] = ACTIONS(5953),
    [anon_sym_LT_DASH] = ACTIONS(5955),
    [anon_sym_LT_LT_DASH] = ACTIONS(5955),
    [anon_sym_COLON_EQ] = ACTIONS(5955),
    [anon_sym_DASH_GT] = ACTIONS(5957),
    [anon_sym_DASH_GT_GT] = ACTIONS(5959),
    [anon_sym_PIPE] = ACTIONS(5961),
    [anon_sym_AMP] = ACTIONS(5963),
    [anon_sym_PIPE_PIPE] = ACTIONS(5965),
    [anon_sym_AMP_AMP] = ACTIONS(5967),
    [anon_sym_LT] = ACTIONS(5969),
    [anon_sym_LT_EQ] = ACTIONS(5971),
    [anon_sym_GT] = ACTIONS(5969),
    [anon_sym_GT_EQ] = ACTIONS(5971),
    [anon_sym_EQ_EQ] = ACTIONS(5971),
    [anon_sym_BANG_EQ] = ACTIONS(5971),
    [anon_sym_STAR] = ACTIONS(5973),
    [anon_sym_SLASH] = ACTIONS(5975),
    [anon_sym_STAR_STAR] = ACTIONS(5977),
    [anon_sym_CARET] = ACTIONS(5977),
    [aux_sym_binary_operator_token1] = ACTIONS(5979),
    [anon_sym_PIPE_GT] = ACTIONS(5979),
    [anon_sym_COLON] = ACTIONS(5981),
    [anon_sym_DOLLAR] = ACTIONS(5983),
    [anon_sym_AT] = ACTIONS(5983),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5987),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5989),
    [sym__external_open_bracket2] = ACTIONS(5991),
  },
  [1852] = {
    [sym_call_arguments] = STATE(2777),
    [sym_subset_arguments] = STATE(2779),
    [sym_subset2_arguments] = STATE(2786),
    [sym__open_parenthesis] = STATE(1411),
    [sym__open_bracket] = STATE(1409),
    [sym__open_bracket2] = STATE(1407),
    [ts_builtin_sym_end] = ACTIONS(5421),
    [sym_identifier] = ACTIONS(5423),
    [anon_sym_BSLASH] = ACTIONS(5421),
    [anon_sym_function] = ACTIONS(5423),
    [anon_sym_EQ] = ACTIONS(6491),
    [anon_sym_if] = ACTIONS(5423),
    [anon_sym_for] = ACTIONS(5423),
    [anon_sym_while] = ACTIONS(5423),
    [anon_sym_repeat] = ACTIONS(5423),
    [anon_sym_QMARK] = ACTIONS(5421),
    [anon_sym_TILDE] = ACTIONS(6495),
    [anon_sym_BANG] = ACTIONS(5423),
    [anon_sym_PLUS] = ACTIONS(6497),
    [anon_sym_DASH] = ACTIONS(6499),
    [anon_sym_LT_DASH] = ACTIONS(6501),
    [anon_sym_LT_LT_DASH] = ACTIONS(6501),
    [anon_sym_COLON_EQ] = ACTIONS(6501),
    [anon_sym_DASH_GT] = ACTIONS(6503),
    [anon_sym_DASH_GT_GT] = ACTIONS(6505),
    [anon_sym_PIPE] = ACTIONS(6507),
    [anon_sym_AMP] = ACTIONS(6509),
    [anon_sym_PIPE_PIPE] = ACTIONS(6511),
    [anon_sym_AMP_AMP] = ACTIONS(6513),
    [anon_sym_LT] = ACTIONS(6515),
    [anon_sym_LT_EQ] = ACTIONS(6517),
    [anon_sym_GT] = ACTIONS(6515),
    [anon_sym_GT_EQ] = ACTIONS(6517),
    [anon_sym_EQ_EQ] = ACTIONS(6517),
    [anon_sym_BANG_EQ] = ACTIONS(6517),
    [anon_sym_STAR] = ACTIONS(6519),
    [anon_sym_SLASH] = ACTIONS(6521),
    [anon_sym_STAR_STAR] = ACTIONS(6523),
    [anon_sym_CARET] = ACTIONS(6523),
    [aux_sym_binary_operator_token1] = ACTIONS(6525),
    [anon_sym_PIPE_GT] = ACTIONS(6525),
    [anon_sym_COLON] = ACTIONS(6527),
    [anon_sym_DOLLAR] = ACTIONS(6529),
    [anon_sym_AT] = ACTIONS(6529),
    [aux_sym__hex_literal_token1] = ACTIONS(5421),
    [sym__number_literal] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5421),
    [anon_sym_DQUOTE] = ACTIONS(5421),
    [sym_return] = ACTIONS(5423),
    [sym_next] = ACTIONS(5423),
    [sym_break] = ACTIONS(5423),
    [sym_true] = ACTIONS(5423),
    [sym_false] = ACTIONS(5423),
    [sym_null] = ACTIONS(5423),
    [sym_inf] = ACTIONS(5423),
    [sym_nan] = ACTIONS(5423),
    [anon_sym_NA] = ACTIONS(5423),
    [anon_sym_NA_integer_] = ACTIONS(5423),
    [anon_sym_NA_real_] = ACTIONS(5423),
    [anon_sym_NA_complex_] = ACTIONS(5423),
    [anon_sym_NA_character_] = ACTIONS(5423),
    [sym_dots] = ACTIONS(5423),
    [sym_dot_dot_i] = ACTIONS(5421),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5421),
    [sym__semicolon] = ACTIONS(5421),
    [sym__raw_string_literal] = ACTIONS(5421),
    [sym__external_open_parenthesis] = ACTIONS(6531),
    [sym__external_close_parenthesis] = ACTIONS(5421),
    [sym__external_open_brace] = ACTIONS(5421),
    [sym__external_open_bracket] = ACTIONS(6533),
    [sym__external_open_bracket2] = ACTIONS(6535),
  },
  [1853] = {
    [sym_call_arguments] = STATE(2923),
    [sym_subset_arguments] = STATE(2922),
    [sym_subset2_arguments] = STATE(2906),
    [sym__open_parenthesis] = STATE(1528),
    [sym__open_bracket] = STATE(1525),
    [sym__open_bracket2] = STATE(1519),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5973),
    [anon_sym_SLASH] = ACTIONS(5975),
    [anon_sym_STAR_STAR] = ACTIONS(5977),
    [anon_sym_CARET] = ACTIONS(5977),
    [aux_sym_binary_operator_token1] = ACTIONS(5979),
    [anon_sym_PIPE_GT] = ACTIONS(5979),
    [anon_sym_COLON] = ACTIONS(5981),
    [anon_sym_DOLLAR] = ACTIONS(5983),
    [anon_sym_AT] = ACTIONS(5983),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5987),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5989),
    [sym__external_open_bracket2] = ACTIONS(5991),
  },
  [1854] = {
    [sym_call_arguments] = STATE(2777),
    [sym_subset_arguments] = STATE(2779),
    [sym_subset2_arguments] = STATE(2786),
    [sym__open_parenthesis] = STATE(1411),
    [sym__open_bracket] = STATE(1409),
    [sym__open_bracket2] = STATE(1407),
    [ts_builtin_sym_end] = ACTIONS(5425),
    [sym_identifier] = ACTIONS(5427),
    [anon_sym_BSLASH] = ACTIONS(5425),
    [anon_sym_function] = ACTIONS(5427),
    [anon_sym_EQ] = ACTIONS(6491),
    [anon_sym_if] = ACTIONS(5427),
    [anon_sym_for] = ACTIONS(5427),
    [anon_sym_while] = ACTIONS(5427),
    [anon_sym_repeat] = ACTIONS(5427),
    [anon_sym_QMARK] = ACTIONS(5425),
    [anon_sym_TILDE] = ACTIONS(6495),
    [anon_sym_BANG] = ACTIONS(5427),
    [anon_sym_PLUS] = ACTIONS(6497),
    [anon_sym_DASH] = ACTIONS(6499),
    [anon_sym_LT_DASH] = ACTIONS(6501),
    [anon_sym_LT_LT_DASH] = ACTIONS(6501),
    [anon_sym_COLON_EQ] = ACTIONS(6501),
    [anon_sym_DASH_GT] = ACTIONS(6503),
    [anon_sym_DASH_GT_GT] = ACTIONS(6505),
    [anon_sym_PIPE] = ACTIONS(6507),
    [anon_sym_AMP] = ACTIONS(6509),
    [anon_sym_PIPE_PIPE] = ACTIONS(6511),
    [anon_sym_AMP_AMP] = ACTIONS(6513),
    [anon_sym_LT] = ACTIONS(6515),
    [anon_sym_LT_EQ] = ACTIONS(6517),
    [anon_sym_GT] = ACTIONS(6515),
    [anon_sym_GT_EQ] = ACTIONS(6517),
    [anon_sym_EQ_EQ] = ACTIONS(6517),
    [anon_sym_BANG_EQ] = ACTIONS(6517),
    [anon_sym_STAR] = ACTIONS(6519),
    [anon_sym_SLASH] = ACTIONS(6521),
    [anon_sym_STAR_STAR] = ACTIONS(6523),
    [anon_sym_CARET] = ACTIONS(6523),
    [aux_sym_binary_operator_token1] = ACTIONS(6525),
    [anon_sym_PIPE_GT] = ACTIONS(6525),
    [anon_sym_COLON] = ACTIONS(6527),
    [anon_sym_DOLLAR] = ACTIONS(6529),
    [anon_sym_AT] = ACTIONS(6529),
    [aux_sym__hex_literal_token1] = ACTIONS(5425),
    [sym__number_literal] = ACTIONS(5427),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_DQUOTE] = ACTIONS(5425),
    [sym_return] = ACTIONS(5427),
    [sym_next] = ACTIONS(5427),
    [sym_break] = ACTIONS(5427),
    [sym_true] = ACTIONS(5427),
    [sym_false] = ACTIONS(5427),
    [sym_null] = ACTIONS(5427),
    [sym_inf] = ACTIONS(5427),
    [sym_nan] = ACTIONS(5427),
    [anon_sym_NA] = ACTIONS(5427),
    [anon_sym_NA_integer_] = ACTIONS(5427),
    [anon_sym_NA_real_] = ACTIONS(5427),
    [anon_sym_NA_complex_] = ACTIONS(5427),
    [anon_sym_NA_character_] = ACTIONS(5427),
    [sym_dots] = ACTIONS(5427),
    [sym_dot_dot_i] = ACTIONS(5425),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5425),
    [sym__semicolon] = ACTIONS(5425),
    [sym__raw_string_literal] = ACTIONS(5425),
    [sym__external_open_parenthesis] = ACTIONS(6531),
    [sym__external_close_parenthesis] = ACTIONS(5425),
    [sym__external_open_brace] = ACTIONS(5425),
    [sym__external_open_bracket] = ACTIONS(6533),
    [sym__external_open_bracket2] = ACTIONS(6535),
  },
  [1855] = {
    [sym_call_arguments] = STATE(2923),
    [sym_subset_arguments] = STATE(2922),
    [sym_subset2_arguments] = STATE(2906),
    [sym__open_parenthesis] = STATE(1528),
    [sym__open_bracket] = STATE(1525),
    [sym__open_bracket2] = STATE(1519),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5951),
    [anon_sym_DASH] = ACTIONS(5953),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5961),
    [anon_sym_AMP] = ACTIONS(5963),
    [anon_sym_PIPE_PIPE] = ACTIONS(5965),
    [anon_sym_AMP_AMP] = ACTIONS(5967),
    [anon_sym_LT] = ACTIONS(5969),
    [anon_sym_LT_EQ] = ACTIONS(5971),
    [anon_sym_GT] = ACTIONS(5969),
    [anon_sym_GT_EQ] = ACTIONS(5971),
    [anon_sym_EQ_EQ] = ACTIONS(5971),
    [anon_sym_BANG_EQ] = ACTIONS(5971),
    [anon_sym_STAR] = ACTIONS(5973),
    [anon_sym_SLASH] = ACTIONS(5975),
    [anon_sym_STAR_STAR] = ACTIONS(5977),
    [anon_sym_CARET] = ACTIONS(5977),
    [aux_sym_binary_operator_token1] = ACTIONS(5979),
    [anon_sym_PIPE_GT] = ACTIONS(5979),
    [anon_sym_COLON] = ACTIONS(5981),
    [anon_sym_DOLLAR] = ACTIONS(5983),
    [anon_sym_AT] = ACTIONS(5983),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5987),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5989),
    [sym__external_open_bracket2] = ACTIONS(5991),
  },
  [1856] = {
    [sym_call_arguments] = STATE(2923),
    [sym_subset_arguments] = STATE(2922),
    [sym_subset2_arguments] = STATE(2906),
    [sym__open_parenthesis] = STATE(1528),
    [sym__open_bracket] = STATE(1525),
    [sym__open_bracket2] = STATE(1519),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5947),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5949),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5951),
    [anon_sym_DASH] = ACTIONS(5953),
    [anon_sym_LT_DASH] = ACTIONS(5955),
    [anon_sym_LT_LT_DASH] = ACTIONS(5955),
    [anon_sym_COLON_EQ] = ACTIONS(5955),
    [anon_sym_DASH_GT] = ACTIONS(5957),
    [anon_sym_DASH_GT_GT] = ACTIONS(5959),
    [anon_sym_PIPE] = ACTIONS(5961),
    [anon_sym_AMP] = ACTIONS(5963),
    [anon_sym_PIPE_PIPE] = ACTIONS(5965),
    [anon_sym_AMP_AMP] = ACTIONS(5967),
    [anon_sym_LT] = ACTIONS(5969),
    [anon_sym_LT_EQ] = ACTIONS(5971),
    [anon_sym_GT] = ACTIONS(5969),
    [anon_sym_GT_EQ] = ACTIONS(5971),
    [anon_sym_EQ_EQ] = ACTIONS(5971),
    [anon_sym_BANG_EQ] = ACTIONS(5971),
    [anon_sym_STAR] = ACTIONS(5973),
    [anon_sym_SLASH] = ACTIONS(5975),
    [anon_sym_STAR_STAR] = ACTIONS(5977),
    [anon_sym_CARET] = ACTIONS(5977),
    [aux_sym_binary_operator_token1] = ACTIONS(5979),
    [anon_sym_PIPE_GT] = ACTIONS(5979),
    [anon_sym_COLON] = ACTIONS(5981),
    [anon_sym_DOLLAR] = ACTIONS(5983),
    [anon_sym_AT] = ACTIONS(5983),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5987),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5989),
    [sym__external_open_bracket2] = ACTIONS(5991),
  },
  [1857] = {
    [sym_call_arguments] = STATE(2923),
    [sym_subset_arguments] = STATE(2922),
    [sym_subset2_arguments] = STATE(2906),
    [sym__open_parenthesis] = STATE(1528),
    [sym__open_bracket] = STATE(1525),
    [sym__open_bracket2] = STATE(1519),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5947),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5949),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5951),
    [anon_sym_DASH] = ACTIONS(5953),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5957),
    [anon_sym_DASH_GT_GT] = ACTIONS(5959),
    [anon_sym_PIPE] = ACTIONS(5961),
    [anon_sym_AMP] = ACTIONS(5963),
    [anon_sym_PIPE_PIPE] = ACTIONS(5965),
    [anon_sym_AMP_AMP] = ACTIONS(5967),
    [anon_sym_LT] = ACTIONS(5969),
    [anon_sym_LT_EQ] = ACTIONS(5971),
    [anon_sym_GT] = ACTIONS(5969),
    [anon_sym_GT_EQ] = ACTIONS(5971),
    [anon_sym_EQ_EQ] = ACTIONS(5971),
    [anon_sym_BANG_EQ] = ACTIONS(5971),
    [anon_sym_STAR] = ACTIONS(5973),
    [anon_sym_SLASH] = ACTIONS(5975),
    [anon_sym_STAR_STAR] = ACTIONS(5977),
    [anon_sym_CARET] = ACTIONS(5977),
    [aux_sym_binary_operator_token1] = ACTIONS(5979),
    [anon_sym_PIPE_GT] = ACTIONS(5979),
    [anon_sym_COLON] = ACTIONS(5981),
    [anon_sym_DOLLAR] = ACTIONS(5983),
    [anon_sym_AT] = ACTIONS(5983),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_else] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(5987),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(5989),
    [sym__external_open_bracket2] = ACTIONS(5991),
  },
  [1858] = {
    [sym_call_arguments] = STATE(2923),
    [sym_subset_arguments] = STATE(2922),
    [sym_subset2_arguments] = STATE(2906),
    [sym__open_parenthesis] = STATE(1528),
    [sym__open_bracket] = STATE(1525),
    [sym__open_bracket2] = STATE(1519),
    [ts_builtin_sym_end] = ACTIONS(5345),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5345),
    [anon_sym_DASH] = ACTIONS(5347),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5347),
    [anon_sym_AMP] = ACTIONS(5347),
    [anon_sym_PIPE_PIPE] = ACTIONS(5345),
    [anon_sym_AMP_AMP] = ACTIONS(5345),
    [anon_sym_LT] = ACTIONS(5347),
    [anon_sym_LT_EQ] = ACTIONS(5345),
    [anon_sym_GT] = ACTIONS(5347),
    [anon_sym_GT_EQ] = ACTIONS(5345),
    [anon_sym_EQ_EQ] = ACTIONS(5345),
    [anon_sym_BANG_EQ] = ACTIONS(5345),
    [anon_sym_STAR] = ACTIONS(5347),
    [anon_sym_SLASH] = ACTIONS(5345),
    [anon_sym_STAR_STAR] = ACTIONS(5977),
    [anon_sym_CARET] = ACTIONS(5977),
    [aux_sym_binary_operator_token1] = ACTIONS(5345),
    [anon_sym_PIPE_GT] = ACTIONS(5345),
    [anon_sym_COLON] = ACTIONS(5347),
    [anon_sym_DOLLAR] = ACTIONS(5983),
    [anon_sym_AT] = ACTIONS(5983),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5345),
    [sym__semicolon] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_else] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(5987),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(5989),
    [sym__external_open_bracket2] = ACTIONS(5991),
  },
  [1859] = {
    [sym_function_definition] = STATE(1940),
    [sym_if_statement] = STATE(1940),
    [sym_for_statement] = STATE(1940),
    [sym_while_statement] = STATE(1940),
    [sym_repeat_statement] = STATE(1940),
    [sym_braced_expression] = STATE(1940),
    [sym_parenthesized_expression] = STATE(1940),
    [sym_call] = STATE(1940),
    [sym_subset] = STATE(1940),
    [sym_subset2] = STATE(1940),
    [sym__argument] = STATE(4665),
    [sym_argument] = STATE(4661),
    [sym__argument_named] = STATE(4669),
    [sym__argument_unnamed] = STATE(4673),
    [sym__argument_value] = STATE(4679),
    [sym_unary_operator] = STATE(1940),
    [sym_binary_operator] = STATE(1940),
    [sym_extract_operator] = STATE(1940),
    [sym_namespace_operator] = STATE(1940),
    [sym_integer] = STATE(1940),
    [sym_complex] = STATE(1940),
    [sym_float] = STATE(1940),
    [sym__hex_literal] = STATE(2656),
    [sym__float_literal] = STATE(2656),
    [sym_string] = STATE(2606),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym_na] = STATE(1940),
    [sym__expression] = STATE(1940),
    [sym__string_or_identifier] = STATE(5141),
    [sym__open_parenthesis] = STATE(218),
    [sym__open_brace] = STATE(185),
    [sym__close_bracket2] = STATE(2960),
    [aux_sym_call_arguments_repeat1] = STATE(1912),
    [sym_identifier] = ACTIONS(6369),
    [anon_sym_BSLASH] = ACTIONS(4644),
    [anon_sym_function] = ACTIONS(4646),
    [anon_sym_if] = ACTIONS(4648),
    [anon_sym_for] = ACTIONS(4650),
    [anon_sym_while] = ACTIONS(4652),
    [anon_sym_repeat] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(6371),
    [anon_sym_PLUS] = ACTIONS(4662),
    [anon_sym_DASH] = ACTIONS(4662),
    [aux_sym__hex_literal_token1] = ACTIONS(4666),
    [sym__number_literal] = ACTIONS(4668),
    [anon_sym_SQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4672),
    [sym_return] = ACTIONS(6373),
    [sym_next] = ACTIONS(6373),
    [sym_break] = ACTIONS(6373),
    [sym_true] = ACTIONS(6373),
    [sym_false] = ACTIONS(6373),
    [sym_null] = ACTIONS(6373),
    [sym_inf] = ACTIONS(6373),
    [sym_nan] = ACTIONS(6373),
    [anon_sym_NA] = ACTIONS(4676),
    [anon_sym_NA_integer_] = ACTIONS(4676),
    [anon_sym_NA_real_] = ACTIONS(4676),
    [anon_sym_NA_complex_] = ACTIONS(4676),
    [anon_sym_NA_character_] = ACTIONS(4676),
    [sym_dots] = ACTIONS(6375),
    [sym_dot_dot_i] = ACTIONS(6377),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6379),
    [sym__newline] = ACTIONS(6381),
    [sym__raw_string_literal] = ACTIONS(4680),
    [sym__external_open_parenthesis] = ACTIONS(4682),
    [sym__external_open_brace] = ACTIONS(4684),
    [sym__external_close_bracket2] = ACTIONS(6823),
  },
  [1860] = {
    [sym_call_arguments] = STATE(2923),
    [sym_subset_arguments] = STATE(2922),
    [sym_subset2_arguments] = STATE(2906),
    [sym__open_parenthesis] = STATE(1528),
    [sym__open_bracket] = STATE(1525),
    [sym__open_bracket2] = STATE(1519),
    [ts_builtin_sym_end] = ACTIONS(5345),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5951),
    [anon_sym_DASH] = ACTIONS(5953),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5347),
    [anon_sym_AMP] = ACTIONS(5347),
    [anon_sym_PIPE_PIPE] = ACTIONS(5345),
    [anon_sym_AMP_AMP] = ACTIONS(5345),
    [anon_sym_LT] = ACTIONS(5969),
    [anon_sym_LT_EQ] = ACTIONS(5971),
    [anon_sym_GT] = ACTIONS(5969),
    [anon_sym_GT_EQ] = ACTIONS(5971),
    [anon_sym_EQ_EQ] = ACTIONS(5971),
    [anon_sym_BANG_EQ] = ACTIONS(5971),
    [anon_sym_STAR] = ACTIONS(5973),
    [anon_sym_SLASH] = ACTIONS(5975),
    [anon_sym_STAR_STAR] = ACTIONS(5977),
    [anon_sym_CARET] = ACTIONS(5977),
    [aux_sym_binary_operator_token1] = ACTIONS(5979),
    [anon_sym_PIPE_GT] = ACTIONS(5979),
    [anon_sym_COLON] = ACTIONS(5981),
    [anon_sym_DOLLAR] = ACTIONS(5983),
    [anon_sym_AT] = ACTIONS(5983),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5345),
    [sym__semicolon] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_else] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(5987),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(5989),
    [sym__external_open_bracket2] = ACTIONS(5991),
  },
  [1861] = {
    [sym_call_arguments] = STATE(2923),
    [sym_subset_arguments] = STATE(2922),
    [sym_subset2_arguments] = STATE(2906),
    [sym__open_parenthesis] = STATE(1528),
    [sym__open_bracket] = STATE(1525),
    [sym__open_bracket2] = STATE(1519),
    [ts_builtin_sym_end] = ACTIONS(5345),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5951),
    [anon_sym_DASH] = ACTIONS(5953),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5961),
    [anon_sym_AMP] = ACTIONS(5963),
    [anon_sym_PIPE_PIPE] = ACTIONS(5965),
    [anon_sym_AMP_AMP] = ACTIONS(5967),
    [anon_sym_LT] = ACTIONS(5969),
    [anon_sym_LT_EQ] = ACTIONS(5971),
    [anon_sym_GT] = ACTIONS(5969),
    [anon_sym_GT_EQ] = ACTIONS(5971),
    [anon_sym_EQ_EQ] = ACTIONS(5971),
    [anon_sym_BANG_EQ] = ACTIONS(5971),
    [anon_sym_STAR] = ACTIONS(5973),
    [anon_sym_SLASH] = ACTIONS(5975),
    [anon_sym_STAR_STAR] = ACTIONS(5977),
    [anon_sym_CARET] = ACTIONS(5977),
    [aux_sym_binary_operator_token1] = ACTIONS(5979),
    [anon_sym_PIPE_GT] = ACTIONS(5979),
    [anon_sym_COLON] = ACTIONS(5981),
    [anon_sym_DOLLAR] = ACTIONS(5983),
    [anon_sym_AT] = ACTIONS(5983),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5345),
    [sym__semicolon] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_else] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(5987),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(5989),
    [sym__external_open_bracket2] = ACTIONS(5991),
  },
  [1862] = {
    [sym_call_arguments] = STATE(2923),
    [sym_subset_arguments] = STATE(2922),
    [sym_subset2_arguments] = STATE(2906),
    [sym__open_parenthesis] = STATE(1528),
    [sym__open_bracket] = STATE(1525),
    [sym__open_bracket2] = STATE(1519),
    [ts_builtin_sym_end] = ACTIONS(5345),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5947),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5949),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5951),
    [anon_sym_DASH] = ACTIONS(5953),
    [anon_sym_LT_DASH] = ACTIONS(5955),
    [anon_sym_LT_LT_DASH] = ACTIONS(5955),
    [anon_sym_COLON_EQ] = ACTIONS(5955),
    [anon_sym_DASH_GT] = ACTIONS(5957),
    [anon_sym_DASH_GT_GT] = ACTIONS(5959),
    [anon_sym_PIPE] = ACTIONS(5961),
    [anon_sym_AMP] = ACTIONS(5963),
    [anon_sym_PIPE_PIPE] = ACTIONS(5965),
    [anon_sym_AMP_AMP] = ACTIONS(5967),
    [anon_sym_LT] = ACTIONS(5969),
    [anon_sym_LT_EQ] = ACTIONS(5971),
    [anon_sym_GT] = ACTIONS(5969),
    [anon_sym_GT_EQ] = ACTIONS(5971),
    [anon_sym_EQ_EQ] = ACTIONS(5971),
    [anon_sym_BANG_EQ] = ACTIONS(5971),
    [anon_sym_STAR] = ACTIONS(5973),
    [anon_sym_SLASH] = ACTIONS(5975),
    [anon_sym_STAR_STAR] = ACTIONS(5977),
    [anon_sym_CARET] = ACTIONS(5977),
    [aux_sym_binary_operator_token1] = ACTIONS(5979),
    [anon_sym_PIPE_GT] = ACTIONS(5979),
    [anon_sym_COLON] = ACTIONS(5981),
    [anon_sym_DOLLAR] = ACTIONS(5983),
    [anon_sym_AT] = ACTIONS(5983),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5345),
    [sym__semicolon] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_else] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(5987),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(5989),
    [sym__external_open_bracket2] = ACTIONS(5991),
  },
  [1863] = {
    [sym_function_definition] = STATE(2038),
    [sym_if_statement] = STATE(2038),
    [sym_for_statement] = STATE(2038),
    [sym_while_statement] = STATE(2038),
    [sym_repeat_statement] = STATE(2038),
    [sym_braced_expression] = STATE(2038),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_call] = STATE(2038),
    [sym_subset] = STATE(2038),
    [sym_subset2] = STATE(2038),
    [sym__argument] = STATE(4664),
    [sym_argument] = STATE(4659),
    [sym__argument_named] = STATE(4654),
    [sym__argument_unnamed] = STATE(4676),
    [sym__argument_value] = STATE(4677),
    [sym_unary_operator] = STATE(2038),
    [sym_binary_operator] = STATE(2038),
    [sym_extract_operator] = STATE(2038),
    [sym_namespace_operator] = STATE(2038),
    [sym_integer] = STATE(2038),
    [sym_complex] = STATE(2038),
    [sym_float] = STATE(2038),
    [sym__hex_literal] = STATE(2700),
    [sym__float_literal] = STATE(2700),
    [sym_string] = STATE(2597),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym_na] = STATE(2038),
    [sym__expression] = STATE(2038),
    [sym__string_or_identifier] = STATE(5148),
    [sym__open_parenthesis] = STATE(214),
    [sym__open_brace] = STATE(192),
    [sym__close_bracket] = STATE(2958),
    [aux_sym_call_arguments_repeat1] = STATE(2034),
    [sym_identifier] = ACTIONS(6351),
    [anon_sym_BSLASH] = ACTIONS(4754),
    [anon_sym_function] = ACTIONS(4756),
    [anon_sym_if] = ACTIONS(4758),
    [anon_sym_for] = ACTIONS(4760),
    [anon_sym_while] = ACTIONS(4762),
    [anon_sym_repeat] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4766),
    [anon_sym_TILDE] = ACTIONS(4768),
    [anon_sym_BANG] = ACTIONS(6353),
    [anon_sym_PLUS] = ACTIONS(4772),
    [anon_sym_DASH] = ACTIONS(4772),
    [aux_sym__hex_literal_token1] = ACTIONS(4776),
    [sym__number_literal] = ACTIONS(4778),
    [anon_sym_SQUOTE] = ACTIONS(4780),
    [anon_sym_DQUOTE] = ACTIONS(4782),
    [sym_return] = ACTIONS(6355),
    [sym_next] = ACTIONS(6355),
    [sym_break] = ACTIONS(6355),
    [sym_true] = ACTIONS(6355),
    [sym_false] = ACTIONS(6355),
    [sym_null] = ACTIONS(6355),
    [sym_inf] = ACTIONS(6355),
    [sym_nan] = ACTIONS(6355),
    [anon_sym_NA] = ACTIONS(4786),
    [anon_sym_NA_integer_] = ACTIONS(4786),
    [anon_sym_NA_real_] = ACTIONS(4786),
    [anon_sym_NA_complex_] = ACTIONS(4786),
    [anon_sym_NA_character_] = ACTIONS(4786),
    [sym_dots] = ACTIONS(6357),
    [sym_dot_dot_i] = ACTIONS(6359),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6361),
    [sym__newline] = ACTIONS(6363),
    [sym__raw_string_literal] = ACTIONS(4790),
    [sym__external_open_parenthesis] = ACTIONS(4792),
    [sym__external_open_brace] = ACTIONS(4794),
    [sym__external_close_bracket] = ACTIONS(6825),
  },
  [1864] = {
    [sym_call_arguments] = STATE(2923),
    [sym_subset_arguments] = STATE(2922),
    [sym_subset2_arguments] = STATE(2906),
    [sym__open_parenthesis] = STATE(1528),
    [sym__open_bracket] = STATE(1525),
    [sym__open_bracket2] = STATE(1519),
    [ts_builtin_sym_end] = ACTIONS(5341),
    [sym_identifier] = ACTIONS(5343),
    [anon_sym_BSLASH] = ACTIONS(5341),
    [anon_sym_function] = ACTIONS(5343),
    [anon_sym_EQ] = ACTIONS(5947),
    [anon_sym_if] = ACTIONS(5343),
    [anon_sym_for] = ACTIONS(5343),
    [anon_sym_while] = ACTIONS(5343),
    [anon_sym_repeat] = ACTIONS(5343),
    [anon_sym_QMARK] = ACTIONS(5341),
    [anon_sym_TILDE] = ACTIONS(5949),
    [anon_sym_BANG] = ACTIONS(5343),
    [anon_sym_PLUS] = ACTIONS(5951),
    [anon_sym_DASH] = ACTIONS(5953),
    [anon_sym_LT_DASH] = ACTIONS(5955),
    [anon_sym_LT_LT_DASH] = ACTIONS(5955),
    [anon_sym_COLON_EQ] = ACTIONS(5955),
    [anon_sym_DASH_GT] = ACTIONS(5957),
    [anon_sym_DASH_GT_GT] = ACTIONS(5959),
    [anon_sym_PIPE] = ACTIONS(5961),
    [anon_sym_AMP] = ACTIONS(5963),
    [anon_sym_PIPE_PIPE] = ACTIONS(5965),
    [anon_sym_AMP_AMP] = ACTIONS(5967),
    [anon_sym_LT] = ACTIONS(5969),
    [anon_sym_LT_EQ] = ACTIONS(5971),
    [anon_sym_GT] = ACTIONS(5969),
    [anon_sym_GT_EQ] = ACTIONS(5971),
    [anon_sym_EQ_EQ] = ACTIONS(5971),
    [anon_sym_BANG_EQ] = ACTIONS(5971),
    [anon_sym_STAR] = ACTIONS(5973),
    [anon_sym_SLASH] = ACTIONS(5975),
    [anon_sym_STAR_STAR] = ACTIONS(5977),
    [anon_sym_CARET] = ACTIONS(5977),
    [aux_sym_binary_operator_token1] = ACTIONS(5979),
    [anon_sym_PIPE_GT] = ACTIONS(5979),
    [anon_sym_COLON] = ACTIONS(5981),
    [anon_sym_DOLLAR] = ACTIONS(5983),
    [anon_sym_AT] = ACTIONS(5983),
    [aux_sym__hex_literal_token1] = ACTIONS(5341),
    [sym__number_literal] = ACTIONS(5343),
    [anon_sym_SQUOTE] = ACTIONS(5341),
    [anon_sym_DQUOTE] = ACTIONS(5341),
    [sym_return] = ACTIONS(5343),
    [sym_next] = ACTIONS(5343),
    [sym_break] = ACTIONS(5343),
    [sym_true] = ACTIONS(5343),
    [sym_false] = ACTIONS(5343),
    [sym_null] = ACTIONS(5343),
    [sym_inf] = ACTIONS(5343),
    [sym_nan] = ACTIONS(5343),
    [anon_sym_NA] = ACTIONS(5343),
    [anon_sym_NA_integer_] = ACTIONS(5343),
    [anon_sym_NA_real_] = ACTIONS(5343),
    [anon_sym_NA_complex_] = ACTIONS(5343),
    [anon_sym_NA_character_] = ACTIONS(5343),
    [sym_dots] = ACTIONS(5343),
    [sym_dot_dot_i] = ACTIONS(5341),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5341),
    [sym__semicolon] = ACTIONS(5341),
    [sym__raw_string_literal] = ACTIONS(5341),
    [sym__external_else] = ACTIONS(5341),
    [sym__external_open_parenthesis] = ACTIONS(5987),
    [sym__external_open_brace] = ACTIONS(5341),
    [sym__external_open_bracket] = ACTIONS(5989),
    [sym__external_open_bracket2] = ACTIONS(5991),
  },
  [1865] = {
    [sym_call_arguments] = STATE(2840),
    [sym_subset_arguments] = STATE(2797),
    [sym_subset2_arguments] = STATE(2801),
    [sym__open_parenthesis] = STATE(1344),
    [sym__open_bracket] = STATE(1374),
    [sym__open_bracket2] = STATE(1452),
    [ts_builtin_sym_end] = ACTIONS(5333),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(6267),
    [anon_sym_DASH] = ACTIONS(6269),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5335),
    [anon_sym_AMP] = ACTIONS(5335),
    [anon_sym_PIPE_PIPE] = ACTIONS(5333),
    [anon_sym_AMP_AMP] = ACTIONS(5333),
    [anon_sym_LT] = ACTIONS(6285),
    [anon_sym_LT_EQ] = ACTIONS(6287),
    [anon_sym_GT] = ACTIONS(6285),
    [anon_sym_GT_EQ] = ACTIONS(6287),
    [anon_sym_EQ_EQ] = ACTIONS(6287),
    [anon_sym_BANG_EQ] = ACTIONS(6287),
    [anon_sym_STAR] = ACTIONS(6289),
    [anon_sym_SLASH] = ACTIONS(6291),
    [anon_sym_STAR_STAR] = ACTIONS(6293),
    [anon_sym_CARET] = ACTIONS(6293),
    [aux_sym_binary_operator_token1] = ACTIONS(6295),
    [anon_sym_PIPE_GT] = ACTIONS(6295),
    [anon_sym_COLON] = ACTIONS(6297),
    [anon_sym_DOLLAR] = ACTIONS(6299),
    [anon_sym_AT] = ACTIONS(6299),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5333),
    [sym__semicolon] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(6301),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_close_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(6303),
    [sym__external_open_bracket2] = ACTIONS(6305),
  },
  [1866] = {
    [sym_function_definition] = STATE(1940),
    [sym_if_statement] = STATE(1940),
    [sym_for_statement] = STATE(1940),
    [sym_while_statement] = STATE(1940),
    [sym_repeat_statement] = STATE(1940),
    [sym_braced_expression] = STATE(1940),
    [sym_parenthesized_expression] = STATE(1940),
    [sym_call] = STATE(1940),
    [sym_subset] = STATE(1940),
    [sym_subset2] = STATE(1940),
    [sym__argument] = STATE(4665),
    [sym_argument] = STATE(4661),
    [sym__argument_named] = STATE(4669),
    [sym__argument_unnamed] = STATE(4673),
    [sym__argument_value] = STATE(4679),
    [sym_unary_operator] = STATE(1940),
    [sym_binary_operator] = STATE(1940),
    [sym_extract_operator] = STATE(1940),
    [sym_namespace_operator] = STATE(1940),
    [sym_integer] = STATE(1940),
    [sym_complex] = STATE(1940),
    [sym_float] = STATE(1940),
    [sym__hex_literal] = STATE(2656),
    [sym__float_literal] = STATE(2656),
    [sym_string] = STATE(2606),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym_na] = STATE(1940),
    [sym__expression] = STATE(1940),
    [sym__string_or_identifier] = STATE(5141),
    [sym__open_parenthesis] = STATE(218),
    [sym__open_brace] = STATE(185),
    [sym__close_bracket2] = STATE(2952),
    [aux_sym_call_arguments_repeat1] = STATE(1324),
    [sym_identifier] = ACTIONS(6369),
    [anon_sym_BSLASH] = ACTIONS(4644),
    [anon_sym_function] = ACTIONS(4646),
    [anon_sym_if] = ACTIONS(4648),
    [anon_sym_for] = ACTIONS(4650),
    [anon_sym_while] = ACTIONS(4652),
    [anon_sym_repeat] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(6371),
    [anon_sym_PLUS] = ACTIONS(4662),
    [anon_sym_DASH] = ACTIONS(4662),
    [aux_sym__hex_literal_token1] = ACTIONS(4666),
    [sym__number_literal] = ACTIONS(4668),
    [anon_sym_SQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4672),
    [sym_return] = ACTIONS(6373),
    [sym_next] = ACTIONS(6373),
    [sym_break] = ACTIONS(6373),
    [sym_true] = ACTIONS(6373),
    [sym_false] = ACTIONS(6373),
    [sym_null] = ACTIONS(6373),
    [sym_inf] = ACTIONS(6373),
    [sym_nan] = ACTIONS(6373),
    [anon_sym_NA] = ACTIONS(4676),
    [anon_sym_NA_integer_] = ACTIONS(4676),
    [anon_sym_NA_real_] = ACTIONS(4676),
    [anon_sym_NA_complex_] = ACTIONS(4676),
    [anon_sym_NA_character_] = ACTIONS(4676),
    [sym_dots] = ACTIONS(6375),
    [sym_dot_dot_i] = ACTIONS(6377),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6379),
    [sym__newline] = ACTIONS(6381),
    [sym__raw_string_literal] = ACTIONS(4680),
    [sym__external_open_parenthesis] = ACTIONS(4682),
    [sym__external_open_brace] = ACTIONS(4684),
    [sym__external_close_bracket2] = ACTIONS(6827),
  },
  [1867] = {
    [sym_call_arguments] = STATE(2777),
    [sym_subset_arguments] = STATE(2779),
    [sym_subset2_arguments] = STATE(2786),
    [sym__open_parenthesis] = STATE(1411),
    [sym__open_bracket] = STATE(1409),
    [sym__open_bracket2] = STATE(1407),
    [ts_builtin_sym_end] = ACTIONS(5429),
    [sym_identifier] = ACTIONS(5431),
    [anon_sym_BSLASH] = ACTIONS(5429),
    [anon_sym_function] = ACTIONS(5431),
    [anon_sym_EQ] = ACTIONS(6491),
    [anon_sym_if] = ACTIONS(5431),
    [anon_sym_for] = ACTIONS(5431),
    [anon_sym_while] = ACTIONS(5431),
    [anon_sym_repeat] = ACTIONS(5431),
    [anon_sym_QMARK] = ACTIONS(5429),
    [anon_sym_TILDE] = ACTIONS(6495),
    [anon_sym_BANG] = ACTIONS(5431),
    [anon_sym_PLUS] = ACTIONS(6497),
    [anon_sym_DASH] = ACTIONS(6499),
    [anon_sym_LT_DASH] = ACTIONS(6501),
    [anon_sym_LT_LT_DASH] = ACTIONS(6501),
    [anon_sym_COLON_EQ] = ACTIONS(6501),
    [anon_sym_DASH_GT] = ACTIONS(6503),
    [anon_sym_DASH_GT_GT] = ACTIONS(6505),
    [anon_sym_PIPE] = ACTIONS(6507),
    [anon_sym_AMP] = ACTIONS(6509),
    [anon_sym_PIPE_PIPE] = ACTIONS(6511),
    [anon_sym_AMP_AMP] = ACTIONS(6513),
    [anon_sym_LT] = ACTIONS(6515),
    [anon_sym_LT_EQ] = ACTIONS(6517),
    [anon_sym_GT] = ACTIONS(6515),
    [anon_sym_GT_EQ] = ACTIONS(6517),
    [anon_sym_EQ_EQ] = ACTIONS(6517),
    [anon_sym_BANG_EQ] = ACTIONS(6517),
    [anon_sym_STAR] = ACTIONS(6519),
    [anon_sym_SLASH] = ACTIONS(6521),
    [anon_sym_STAR_STAR] = ACTIONS(6523),
    [anon_sym_CARET] = ACTIONS(6523),
    [aux_sym_binary_operator_token1] = ACTIONS(6525),
    [anon_sym_PIPE_GT] = ACTIONS(6525),
    [anon_sym_COLON] = ACTIONS(6527),
    [anon_sym_DOLLAR] = ACTIONS(6529),
    [anon_sym_AT] = ACTIONS(6529),
    [aux_sym__hex_literal_token1] = ACTIONS(5429),
    [sym__number_literal] = ACTIONS(5431),
    [anon_sym_SQUOTE] = ACTIONS(5429),
    [anon_sym_DQUOTE] = ACTIONS(5429),
    [sym_return] = ACTIONS(5431),
    [sym_next] = ACTIONS(5431),
    [sym_break] = ACTIONS(5431),
    [sym_true] = ACTIONS(5431),
    [sym_false] = ACTIONS(5431),
    [sym_null] = ACTIONS(5431),
    [sym_inf] = ACTIONS(5431),
    [sym_nan] = ACTIONS(5431),
    [anon_sym_NA] = ACTIONS(5431),
    [anon_sym_NA_integer_] = ACTIONS(5431),
    [anon_sym_NA_real_] = ACTIONS(5431),
    [anon_sym_NA_complex_] = ACTIONS(5431),
    [anon_sym_NA_character_] = ACTIONS(5431),
    [sym_dots] = ACTIONS(5431),
    [sym_dot_dot_i] = ACTIONS(5429),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5429),
    [sym__semicolon] = ACTIONS(5429),
    [sym__raw_string_literal] = ACTIONS(5429),
    [sym__external_open_parenthesis] = ACTIONS(6531),
    [sym__external_close_parenthesis] = ACTIONS(5429),
    [sym__external_open_brace] = ACTIONS(5429),
    [sym__external_open_bracket] = ACTIONS(6533),
    [sym__external_open_bracket2] = ACTIONS(6535),
  },
  [1868] = {
    [sym_string] = STATE(2681),
    [sym__single_quoted_string] = STATE(2236),
    [sym__double_quoted_string] = STATE(2237),
    [sym__string_or_identifier] = STATE(2681),
    [aux_sym_function_definition_repeat1] = STATE(2400),
    [sym_identifier] = ACTIONS(6829),
    [anon_sym_BSLASH] = ACTIONS(5669),
    [anon_sym_function] = ACTIONS(5673),
    [anon_sym_EQ] = ACTIONS(5673),
    [anon_sym_if] = ACTIONS(5673),
    [anon_sym_for] = ACTIONS(5673),
    [anon_sym_while] = ACTIONS(5673),
    [anon_sym_repeat] = ACTIONS(5673),
    [anon_sym_QMARK] = ACTIONS(5669),
    [anon_sym_TILDE] = ACTIONS(5669),
    [anon_sym_BANG] = ACTIONS(5673),
    [anon_sym_PLUS] = ACTIONS(5669),
    [anon_sym_DASH] = ACTIONS(5673),
    [anon_sym_LT_DASH] = ACTIONS(5669),
    [anon_sym_LT_LT_DASH] = ACTIONS(5669),
    [anon_sym_COLON_EQ] = ACTIONS(5669),
    [anon_sym_DASH_GT] = ACTIONS(5673),
    [anon_sym_DASH_GT_GT] = ACTIONS(5669),
    [anon_sym_PIPE] = ACTIONS(5673),
    [anon_sym_AMP] = ACTIONS(5673),
    [anon_sym_PIPE_PIPE] = ACTIONS(5669),
    [anon_sym_AMP_AMP] = ACTIONS(5669),
    [anon_sym_LT] = ACTIONS(5673),
    [anon_sym_LT_EQ] = ACTIONS(5669),
    [anon_sym_GT] = ACTIONS(5673),
    [anon_sym_GT_EQ] = ACTIONS(5669),
    [anon_sym_EQ_EQ] = ACTIONS(5669),
    [anon_sym_BANG_EQ] = ACTIONS(5669),
    [anon_sym_STAR] = ACTIONS(5673),
    [anon_sym_SLASH] = ACTIONS(5669),
    [anon_sym_STAR_STAR] = ACTIONS(5669),
    [anon_sym_CARET] = ACTIONS(5669),
    [aux_sym_binary_operator_token1] = ACTIONS(5669),
    [anon_sym_PIPE_GT] = ACTIONS(5669),
    [anon_sym_COLON] = ACTIONS(5673),
    [anon_sym_DOLLAR] = ACTIONS(5669),
    [anon_sym_AT] = ACTIONS(5669),
    [aux_sym__hex_literal_token1] = ACTIONS(5669),
    [sym__number_literal] = ACTIONS(5673),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [anon_sym_DQUOTE] = ACTIONS(1463),
    [sym_return] = ACTIONS(5673),
    [sym_next] = ACTIONS(5673),
    [sym_break] = ACTIONS(5673),
    [sym_true] = ACTIONS(5673),
    [sym_false] = ACTIONS(5673),
    [sym_null] = ACTIONS(5673),
    [sym_inf] = ACTIONS(5673),
    [sym_nan] = ACTIONS(5673),
    [anon_sym_NA] = ACTIONS(5673),
    [anon_sym_NA_integer_] = ACTIONS(5673),
    [anon_sym_NA_real_] = ACTIONS(5673),
    [anon_sym_NA_complex_] = ACTIONS(5673),
    [anon_sym_NA_character_] = ACTIONS(5673),
    [sym_dots] = ACTIONS(5673),
    [sym_dot_dot_i] = ACTIONS(5669),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5669),
    [sym__newline] = ACTIONS(5669),
    [sym__semicolon] = ACTIONS(5669),
    [sym__raw_string_literal] = ACTIONS(1473),
    [sym__external_open_parenthesis] = ACTIONS(5669),
    [sym__external_open_brace] = ACTIONS(5669),
    [sym__external_close_brace] = ACTIONS(5669),
    [sym__external_open_bracket] = ACTIONS(5669),
    [sym__external_open_bracket2] = ACTIONS(5669),
    [sym__external_close_bracket2] = ACTIONS(5669),
  },
  [1869] = {
    [sym_call_arguments] = STATE(2777),
    [sym_subset_arguments] = STATE(2779),
    [sym_subset2_arguments] = STATE(2786),
    [sym__open_parenthesis] = STATE(1411),
    [sym__open_bracket] = STATE(1409),
    [sym__open_bracket2] = STATE(1407),
    [ts_builtin_sym_end] = ACTIONS(5433),
    [sym_identifier] = ACTIONS(5435),
    [anon_sym_BSLASH] = ACTIONS(5433),
    [anon_sym_function] = ACTIONS(5435),
    [anon_sym_EQ] = ACTIONS(6491),
    [anon_sym_if] = ACTIONS(5435),
    [anon_sym_for] = ACTIONS(5435),
    [anon_sym_while] = ACTIONS(5435),
    [anon_sym_repeat] = ACTIONS(5435),
    [anon_sym_QMARK] = ACTIONS(5433),
    [anon_sym_TILDE] = ACTIONS(6495),
    [anon_sym_BANG] = ACTIONS(5435),
    [anon_sym_PLUS] = ACTIONS(6497),
    [anon_sym_DASH] = ACTIONS(6499),
    [anon_sym_LT_DASH] = ACTIONS(6501),
    [anon_sym_LT_LT_DASH] = ACTIONS(6501),
    [anon_sym_COLON_EQ] = ACTIONS(6501),
    [anon_sym_DASH_GT] = ACTIONS(6503),
    [anon_sym_DASH_GT_GT] = ACTIONS(6505),
    [anon_sym_PIPE] = ACTIONS(6507),
    [anon_sym_AMP] = ACTIONS(6509),
    [anon_sym_PIPE_PIPE] = ACTIONS(6511),
    [anon_sym_AMP_AMP] = ACTIONS(6513),
    [anon_sym_LT] = ACTIONS(6515),
    [anon_sym_LT_EQ] = ACTIONS(6517),
    [anon_sym_GT] = ACTIONS(6515),
    [anon_sym_GT_EQ] = ACTIONS(6517),
    [anon_sym_EQ_EQ] = ACTIONS(6517),
    [anon_sym_BANG_EQ] = ACTIONS(6517),
    [anon_sym_STAR] = ACTIONS(6519),
    [anon_sym_SLASH] = ACTIONS(6521),
    [anon_sym_STAR_STAR] = ACTIONS(6523),
    [anon_sym_CARET] = ACTIONS(6523),
    [aux_sym_binary_operator_token1] = ACTIONS(6525),
    [anon_sym_PIPE_GT] = ACTIONS(6525),
    [anon_sym_COLON] = ACTIONS(6527),
    [anon_sym_DOLLAR] = ACTIONS(6529),
    [anon_sym_AT] = ACTIONS(6529),
    [aux_sym__hex_literal_token1] = ACTIONS(5433),
    [sym__number_literal] = ACTIONS(5435),
    [anon_sym_SQUOTE] = ACTIONS(5433),
    [anon_sym_DQUOTE] = ACTIONS(5433),
    [sym_return] = ACTIONS(5435),
    [sym_next] = ACTIONS(5435),
    [sym_break] = ACTIONS(5435),
    [sym_true] = ACTIONS(5435),
    [sym_false] = ACTIONS(5435),
    [sym_null] = ACTIONS(5435),
    [sym_inf] = ACTIONS(5435),
    [sym_nan] = ACTIONS(5435),
    [anon_sym_NA] = ACTIONS(5435),
    [anon_sym_NA_integer_] = ACTIONS(5435),
    [anon_sym_NA_real_] = ACTIONS(5435),
    [anon_sym_NA_complex_] = ACTIONS(5435),
    [anon_sym_NA_character_] = ACTIONS(5435),
    [sym_dots] = ACTIONS(5435),
    [sym_dot_dot_i] = ACTIONS(5433),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5433),
    [sym__semicolon] = ACTIONS(5433),
    [sym__raw_string_literal] = ACTIONS(5433),
    [sym__external_open_parenthesis] = ACTIONS(6531),
    [sym__external_close_parenthesis] = ACTIONS(5433),
    [sym__external_open_brace] = ACTIONS(5433),
    [sym__external_open_bracket] = ACTIONS(6533),
    [sym__external_open_bracket2] = ACTIONS(6535),
  },
  [1870] = {
    [sym_call_arguments] = STATE(2777),
    [sym_subset_arguments] = STATE(2779),
    [sym_subset2_arguments] = STATE(2786),
    [sym__open_parenthesis] = STATE(1411),
    [sym__open_bracket] = STATE(1409),
    [sym__open_bracket2] = STATE(1407),
    [ts_builtin_sym_end] = ACTIONS(5437),
    [sym_identifier] = ACTIONS(5439),
    [anon_sym_BSLASH] = ACTIONS(5437),
    [anon_sym_function] = ACTIONS(5439),
    [anon_sym_EQ] = ACTIONS(6491),
    [anon_sym_if] = ACTIONS(5439),
    [anon_sym_for] = ACTIONS(5439),
    [anon_sym_while] = ACTIONS(5439),
    [anon_sym_repeat] = ACTIONS(5439),
    [anon_sym_QMARK] = ACTIONS(5437),
    [anon_sym_TILDE] = ACTIONS(6495),
    [anon_sym_BANG] = ACTIONS(5439),
    [anon_sym_PLUS] = ACTIONS(6497),
    [anon_sym_DASH] = ACTIONS(6499),
    [anon_sym_LT_DASH] = ACTIONS(6501),
    [anon_sym_LT_LT_DASH] = ACTIONS(6501),
    [anon_sym_COLON_EQ] = ACTIONS(6501),
    [anon_sym_DASH_GT] = ACTIONS(6503),
    [anon_sym_DASH_GT_GT] = ACTIONS(6505),
    [anon_sym_PIPE] = ACTIONS(6507),
    [anon_sym_AMP] = ACTIONS(6509),
    [anon_sym_PIPE_PIPE] = ACTIONS(6511),
    [anon_sym_AMP_AMP] = ACTIONS(6513),
    [anon_sym_LT] = ACTIONS(6515),
    [anon_sym_LT_EQ] = ACTIONS(6517),
    [anon_sym_GT] = ACTIONS(6515),
    [anon_sym_GT_EQ] = ACTIONS(6517),
    [anon_sym_EQ_EQ] = ACTIONS(6517),
    [anon_sym_BANG_EQ] = ACTIONS(6517),
    [anon_sym_STAR] = ACTIONS(6519),
    [anon_sym_SLASH] = ACTIONS(6521),
    [anon_sym_STAR_STAR] = ACTIONS(6523),
    [anon_sym_CARET] = ACTIONS(6523),
    [aux_sym_binary_operator_token1] = ACTIONS(6525),
    [anon_sym_PIPE_GT] = ACTIONS(6525),
    [anon_sym_COLON] = ACTIONS(6527),
    [anon_sym_DOLLAR] = ACTIONS(6529),
    [anon_sym_AT] = ACTIONS(6529),
    [aux_sym__hex_literal_token1] = ACTIONS(5437),
    [sym__number_literal] = ACTIONS(5439),
    [anon_sym_SQUOTE] = ACTIONS(5437),
    [anon_sym_DQUOTE] = ACTIONS(5437),
    [sym_return] = ACTIONS(5439),
    [sym_next] = ACTIONS(5439),
    [sym_break] = ACTIONS(5439),
    [sym_true] = ACTIONS(5439),
    [sym_false] = ACTIONS(5439),
    [sym_null] = ACTIONS(5439),
    [sym_inf] = ACTIONS(5439),
    [sym_nan] = ACTIONS(5439),
    [anon_sym_NA] = ACTIONS(5439),
    [anon_sym_NA_integer_] = ACTIONS(5439),
    [anon_sym_NA_real_] = ACTIONS(5439),
    [anon_sym_NA_complex_] = ACTIONS(5439),
    [anon_sym_NA_character_] = ACTIONS(5439),
    [sym_dots] = ACTIONS(5439),
    [sym_dot_dot_i] = ACTIONS(5437),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5437),
    [sym__semicolon] = ACTIONS(5437),
    [sym__raw_string_literal] = ACTIONS(5437),
    [sym__external_open_parenthesis] = ACTIONS(6531),
    [sym__external_close_parenthesis] = ACTIONS(5437),
    [sym__external_open_brace] = ACTIONS(5437),
    [sym__external_open_bracket] = ACTIONS(6533),
    [sym__external_open_bracket2] = ACTIONS(6535),
  },
  [1871] = {
    [sym_function_definition] = STATE(2038),
    [sym_if_statement] = STATE(2038),
    [sym_for_statement] = STATE(2038),
    [sym_while_statement] = STATE(2038),
    [sym_repeat_statement] = STATE(2038),
    [sym_braced_expression] = STATE(2038),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_call] = STATE(2038),
    [sym_subset] = STATE(2038),
    [sym_subset2] = STATE(2038),
    [sym__argument] = STATE(4664),
    [sym_argument] = STATE(4659),
    [sym__argument_named] = STATE(4654),
    [sym__argument_unnamed] = STATE(4676),
    [sym__argument_value] = STATE(4677),
    [sym_unary_operator] = STATE(2038),
    [sym_binary_operator] = STATE(2038),
    [sym_extract_operator] = STATE(2038),
    [sym_namespace_operator] = STATE(2038),
    [sym_integer] = STATE(2038),
    [sym_complex] = STATE(2038),
    [sym_float] = STATE(2038),
    [sym__hex_literal] = STATE(2700),
    [sym__float_literal] = STATE(2700),
    [sym_string] = STATE(2597),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym_na] = STATE(2038),
    [sym__expression] = STATE(2038),
    [sym__string_or_identifier] = STATE(5148),
    [sym__open_parenthesis] = STATE(214),
    [sym__open_brace] = STATE(192),
    [sym__close_bracket] = STATE(2634),
    [aux_sym_call_arguments_repeat1] = STATE(2034),
    [sym_identifier] = ACTIONS(6351),
    [anon_sym_BSLASH] = ACTIONS(4754),
    [anon_sym_function] = ACTIONS(4756),
    [anon_sym_if] = ACTIONS(4758),
    [anon_sym_for] = ACTIONS(4760),
    [anon_sym_while] = ACTIONS(4762),
    [anon_sym_repeat] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4766),
    [anon_sym_TILDE] = ACTIONS(4768),
    [anon_sym_BANG] = ACTIONS(6353),
    [anon_sym_PLUS] = ACTIONS(4772),
    [anon_sym_DASH] = ACTIONS(4772),
    [aux_sym__hex_literal_token1] = ACTIONS(4776),
    [sym__number_literal] = ACTIONS(4778),
    [anon_sym_SQUOTE] = ACTIONS(4780),
    [anon_sym_DQUOTE] = ACTIONS(4782),
    [sym_return] = ACTIONS(6355),
    [sym_next] = ACTIONS(6355),
    [sym_break] = ACTIONS(6355),
    [sym_true] = ACTIONS(6355),
    [sym_false] = ACTIONS(6355),
    [sym_null] = ACTIONS(6355),
    [sym_inf] = ACTIONS(6355),
    [sym_nan] = ACTIONS(6355),
    [anon_sym_NA] = ACTIONS(4786),
    [anon_sym_NA_integer_] = ACTIONS(4786),
    [anon_sym_NA_real_] = ACTIONS(4786),
    [anon_sym_NA_complex_] = ACTIONS(4786),
    [anon_sym_NA_character_] = ACTIONS(4786),
    [sym_dots] = ACTIONS(6357),
    [sym_dot_dot_i] = ACTIONS(6359),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6361),
    [sym__newline] = ACTIONS(6363),
    [sym__raw_string_literal] = ACTIONS(4790),
    [sym__external_open_parenthesis] = ACTIONS(4792),
    [sym__external_open_brace] = ACTIONS(4794),
    [sym__external_close_bracket] = ACTIONS(6831),
  },
  [1872] = {
    [sym_call_arguments] = STATE(2777),
    [sym_subset_arguments] = STATE(2779),
    [sym_subset2_arguments] = STATE(2786),
    [sym__open_parenthesis] = STATE(1411),
    [sym__open_bracket] = STATE(1409),
    [sym__open_bracket2] = STATE(1407),
    [ts_builtin_sym_end] = ACTIONS(5441),
    [sym_identifier] = ACTIONS(5443),
    [anon_sym_BSLASH] = ACTIONS(5441),
    [anon_sym_function] = ACTIONS(5443),
    [anon_sym_EQ] = ACTIONS(6491),
    [anon_sym_if] = ACTIONS(5443),
    [anon_sym_for] = ACTIONS(5443),
    [anon_sym_while] = ACTIONS(5443),
    [anon_sym_repeat] = ACTIONS(5443),
    [anon_sym_QMARK] = ACTIONS(5441),
    [anon_sym_TILDE] = ACTIONS(6495),
    [anon_sym_BANG] = ACTIONS(5443),
    [anon_sym_PLUS] = ACTIONS(6497),
    [anon_sym_DASH] = ACTIONS(6499),
    [anon_sym_LT_DASH] = ACTIONS(6501),
    [anon_sym_LT_LT_DASH] = ACTIONS(6501),
    [anon_sym_COLON_EQ] = ACTIONS(6501),
    [anon_sym_DASH_GT] = ACTIONS(6503),
    [anon_sym_DASH_GT_GT] = ACTIONS(6505),
    [anon_sym_PIPE] = ACTIONS(6507),
    [anon_sym_AMP] = ACTIONS(6509),
    [anon_sym_PIPE_PIPE] = ACTIONS(6511),
    [anon_sym_AMP_AMP] = ACTIONS(6513),
    [anon_sym_LT] = ACTIONS(6515),
    [anon_sym_LT_EQ] = ACTIONS(6517),
    [anon_sym_GT] = ACTIONS(6515),
    [anon_sym_GT_EQ] = ACTIONS(6517),
    [anon_sym_EQ_EQ] = ACTIONS(6517),
    [anon_sym_BANG_EQ] = ACTIONS(6517),
    [anon_sym_STAR] = ACTIONS(6519),
    [anon_sym_SLASH] = ACTIONS(6521),
    [anon_sym_STAR_STAR] = ACTIONS(6523),
    [anon_sym_CARET] = ACTIONS(6523),
    [aux_sym_binary_operator_token1] = ACTIONS(6525),
    [anon_sym_PIPE_GT] = ACTIONS(6525),
    [anon_sym_COLON] = ACTIONS(6527),
    [anon_sym_DOLLAR] = ACTIONS(6529),
    [anon_sym_AT] = ACTIONS(6529),
    [aux_sym__hex_literal_token1] = ACTIONS(5441),
    [sym__number_literal] = ACTIONS(5443),
    [anon_sym_SQUOTE] = ACTIONS(5441),
    [anon_sym_DQUOTE] = ACTIONS(5441),
    [sym_return] = ACTIONS(5443),
    [sym_next] = ACTIONS(5443),
    [sym_break] = ACTIONS(5443),
    [sym_true] = ACTIONS(5443),
    [sym_false] = ACTIONS(5443),
    [sym_null] = ACTIONS(5443),
    [sym_inf] = ACTIONS(5443),
    [sym_nan] = ACTIONS(5443),
    [anon_sym_NA] = ACTIONS(5443),
    [anon_sym_NA_integer_] = ACTIONS(5443),
    [anon_sym_NA_real_] = ACTIONS(5443),
    [anon_sym_NA_complex_] = ACTIONS(5443),
    [anon_sym_NA_character_] = ACTIONS(5443),
    [sym_dots] = ACTIONS(5443),
    [sym_dot_dot_i] = ACTIONS(5441),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5441),
    [sym__semicolon] = ACTIONS(5441),
    [sym__raw_string_literal] = ACTIONS(5441),
    [sym__external_open_parenthesis] = ACTIONS(6531),
    [sym__external_close_parenthesis] = ACTIONS(5441),
    [sym__external_open_brace] = ACTIONS(5441),
    [sym__external_open_bracket] = ACTIONS(6533),
    [sym__external_open_bracket2] = ACTIONS(6535),
  },
  [1873] = {
    [sym_function_definition] = STATE(1940),
    [sym_if_statement] = STATE(1940),
    [sym_for_statement] = STATE(1940),
    [sym_while_statement] = STATE(1940),
    [sym_repeat_statement] = STATE(1940),
    [sym_braced_expression] = STATE(1940),
    [sym_parenthesized_expression] = STATE(1940),
    [sym_call] = STATE(1940),
    [sym_subset] = STATE(1940),
    [sym_subset2] = STATE(1940),
    [sym__argument] = STATE(4665),
    [sym_argument] = STATE(4661),
    [sym__argument_named] = STATE(4669),
    [sym__argument_unnamed] = STATE(4673),
    [sym__argument_value] = STATE(4679),
    [sym_unary_operator] = STATE(1940),
    [sym_binary_operator] = STATE(1940),
    [sym_extract_operator] = STATE(1940),
    [sym_namespace_operator] = STATE(1940),
    [sym_integer] = STATE(1940),
    [sym_complex] = STATE(1940),
    [sym_float] = STATE(1940),
    [sym__hex_literal] = STATE(2656),
    [sym__float_literal] = STATE(2656),
    [sym_string] = STATE(2606),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym_na] = STATE(1940),
    [sym__expression] = STATE(1940),
    [sym__string_or_identifier] = STATE(5141),
    [sym__open_parenthesis] = STATE(218),
    [sym__open_brace] = STATE(185),
    [sym__close_bracket2] = STATE(2632),
    [aux_sym_call_arguments_repeat1] = STATE(1912),
    [sym_identifier] = ACTIONS(6369),
    [anon_sym_BSLASH] = ACTIONS(4644),
    [anon_sym_function] = ACTIONS(4646),
    [anon_sym_if] = ACTIONS(4648),
    [anon_sym_for] = ACTIONS(4650),
    [anon_sym_while] = ACTIONS(4652),
    [anon_sym_repeat] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(6371),
    [anon_sym_PLUS] = ACTIONS(4662),
    [anon_sym_DASH] = ACTIONS(4662),
    [aux_sym__hex_literal_token1] = ACTIONS(4666),
    [sym__number_literal] = ACTIONS(4668),
    [anon_sym_SQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4672),
    [sym_return] = ACTIONS(6373),
    [sym_next] = ACTIONS(6373),
    [sym_break] = ACTIONS(6373),
    [sym_true] = ACTIONS(6373),
    [sym_false] = ACTIONS(6373),
    [sym_null] = ACTIONS(6373),
    [sym_inf] = ACTIONS(6373),
    [sym_nan] = ACTIONS(6373),
    [anon_sym_NA] = ACTIONS(4676),
    [anon_sym_NA_integer_] = ACTIONS(4676),
    [anon_sym_NA_real_] = ACTIONS(4676),
    [anon_sym_NA_complex_] = ACTIONS(4676),
    [anon_sym_NA_character_] = ACTIONS(4676),
    [sym_dots] = ACTIONS(6375),
    [sym_dot_dot_i] = ACTIONS(6377),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6379),
    [sym__newline] = ACTIONS(6381),
    [sym__raw_string_literal] = ACTIONS(4680),
    [sym__external_open_parenthesis] = ACTIONS(4682),
    [sym__external_open_brace] = ACTIONS(4684),
    [sym__external_close_bracket2] = ACTIONS(6833),
  },
  [1874] = {
    [sym_call_arguments] = STATE(2777),
    [sym_subset_arguments] = STATE(2779),
    [sym_subset2_arguments] = STATE(2786),
    [sym__open_parenthesis] = STATE(1411),
    [sym__open_bracket] = STATE(1409),
    [sym__open_bracket2] = STATE(1407),
    [ts_builtin_sym_end] = ACTIONS(5449),
    [sym_identifier] = ACTIONS(5451),
    [anon_sym_BSLASH] = ACTIONS(5449),
    [anon_sym_function] = ACTIONS(5451),
    [anon_sym_EQ] = ACTIONS(6491),
    [anon_sym_if] = ACTIONS(5451),
    [anon_sym_for] = ACTIONS(5451),
    [anon_sym_while] = ACTIONS(5451),
    [anon_sym_repeat] = ACTIONS(5451),
    [anon_sym_QMARK] = ACTIONS(5449),
    [anon_sym_TILDE] = ACTIONS(6495),
    [anon_sym_BANG] = ACTIONS(5451),
    [anon_sym_PLUS] = ACTIONS(6497),
    [anon_sym_DASH] = ACTIONS(6499),
    [anon_sym_LT_DASH] = ACTIONS(6501),
    [anon_sym_LT_LT_DASH] = ACTIONS(6501),
    [anon_sym_COLON_EQ] = ACTIONS(6501),
    [anon_sym_DASH_GT] = ACTIONS(6503),
    [anon_sym_DASH_GT_GT] = ACTIONS(6505),
    [anon_sym_PIPE] = ACTIONS(6507),
    [anon_sym_AMP] = ACTIONS(6509),
    [anon_sym_PIPE_PIPE] = ACTIONS(6511),
    [anon_sym_AMP_AMP] = ACTIONS(6513),
    [anon_sym_LT] = ACTIONS(6515),
    [anon_sym_LT_EQ] = ACTIONS(6517),
    [anon_sym_GT] = ACTIONS(6515),
    [anon_sym_GT_EQ] = ACTIONS(6517),
    [anon_sym_EQ_EQ] = ACTIONS(6517),
    [anon_sym_BANG_EQ] = ACTIONS(6517),
    [anon_sym_STAR] = ACTIONS(6519),
    [anon_sym_SLASH] = ACTIONS(6521),
    [anon_sym_STAR_STAR] = ACTIONS(6523),
    [anon_sym_CARET] = ACTIONS(6523),
    [aux_sym_binary_operator_token1] = ACTIONS(6525),
    [anon_sym_PIPE_GT] = ACTIONS(6525),
    [anon_sym_COLON] = ACTIONS(6527),
    [anon_sym_DOLLAR] = ACTIONS(6529),
    [anon_sym_AT] = ACTIONS(6529),
    [aux_sym__hex_literal_token1] = ACTIONS(5449),
    [sym__number_literal] = ACTIONS(5451),
    [anon_sym_SQUOTE] = ACTIONS(5449),
    [anon_sym_DQUOTE] = ACTIONS(5449),
    [sym_return] = ACTIONS(5451),
    [sym_next] = ACTIONS(5451),
    [sym_break] = ACTIONS(5451),
    [sym_true] = ACTIONS(5451),
    [sym_false] = ACTIONS(5451),
    [sym_null] = ACTIONS(5451),
    [sym_inf] = ACTIONS(5451),
    [sym_nan] = ACTIONS(5451),
    [anon_sym_NA] = ACTIONS(5451),
    [anon_sym_NA_integer_] = ACTIONS(5451),
    [anon_sym_NA_real_] = ACTIONS(5451),
    [anon_sym_NA_complex_] = ACTIONS(5451),
    [anon_sym_NA_character_] = ACTIONS(5451),
    [sym_dots] = ACTIONS(5451),
    [sym_dot_dot_i] = ACTIONS(5449),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5449),
    [sym__semicolon] = ACTIONS(5449),
    [sym__raw_string_literal] = ACTIONS(5449),
    [sym__external_open_parenthesis] = ACTIONS(6531),
    [sym__external_close_parenthesis] = ACTIONS(5449),
    [sym__external_open_brace] = ACTIONS(5449),
    [sym__external_open_bracket] = ACTIONS(6533),
    [sym__external_open_bracket2] = ACTIONS(6535),
  },
  [1875] = {
    [sym_function_definition] = STATE(1940),
    [sym_if_statement] = STATE(1940),
    [sym_for_statement] = STATE(1940),
    [sym_while_statement] = STATE(1940),
    [sym_repeat_statement] = STATE(1940),
    [sym_braced_expression] = STATE(1940),
    [sym_parenthesized_expression] = STATE(1940),
    [sym_call] = STATE(1940),
    [sym_subset] = STATE(1940),
    [sym_subset2] = STATE(1940),
    [sym__argument] = STATE(4665),
    [sym_argument] = STATE(4661),
    [sym__argument_named] = STATE(4669),
    [sym__argument_unnamed] = STATE(4673),
    [sym__argument_value] = STATE(4679),
    [sym_unary_operator] = STATE(1940),
    [sym_binary_operator] = STATE(1940),
    [sym_extract_operator] = STATE(1940),
    [sym_namespace_operator] = STATE(1940),
    [sym_integer] = STATE(1940),
    [sym_complex] = STATE(1940),
    [sym_float] = STATE(1940),
    [sym__hex_literal] = STATE(2656),
    [sym__float_literal] = STATE(2656),
    [sym_string] = STATE(2606),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym_na] = STATE(1940),
    [sym__expression] = STATE(1940),
    [sym__string_or_identifier] = STATE(5141),
    [sym__open_parenthesis] = STATE(218),
    [sym__open_brace] = STATE(185),
    [sym__close_bracket2] = STATE(4711),
    [aux_sym_call_arguments_repeat1] = STATE(1912),
    [sym_identifier] = ACTIONS(6369),
    [anon_sym_BSLASH] = ACTIONS(4644),
    [anon_sym_function] = ACTIONS(4646),
    [anon_sym_if] = ACTIONS(4648),
    [anon_sym_for] = ACTIONS(4650),
    [anon_sym_while] = ACTIONS(4652),
    [anon_sym_repeat] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(6371),
    [anon_sym_PLUS] = ACTIONS(4662),
    [anon_sym_DASH] = ACTIONS(4662),
    [aux_sym__hex_literal_token1] = ACTIONS(4666),
    [sym__number_literal] = ACTIONS(4668),
    [anon_sym_SQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4672),
    [sym_return] = ACTIONS(6373),
    [sym_next] = ACTIONS(6373),
    [sym_break] = ACTIONS(6373),
    [sym_true] = ACTIONS(6373),
    [sym_false] = ACTIONS(6373),
    [sym_null] = ACTIONS(6373),
    [sym_inf] = ACTIONS(6373),
    [sym_nan] = ACTIONS(6373),
    [anon_sym_NA] = ACTIONS(4676),
    [anon_sym_NA_integer_] = ACTIONS(4676),
    [anon_sym_NA_real_] = ACTIONS(4676),
    [anon_sym_NA_complex_] = ACTIONS(4676),
    [anon_sym_NA_character_] = ACTIONS(4676),
    [sym_dots] = ACTIONS(6375),
    [sym_dot_dot_i] = ACTIONS(6377),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6379),
    [sym__newline] = ACTIONS(6381),
    [sym__raw_string_literal] = ACTIONS(4680),
    [sym__external_open_parenthesis] = ACTIONS(4682),
    [sym__external_open_brace] = ACTIONS(4684),
    [sym__external_close_bracket2] = ACTIONS(6835),
  },
  [1876] = {
    [sym_function_definition] = STATE(2038),
    [sym_if_statement] = STATE(2038),
    [sym_for_statement] = STATE(2038),
    [sym_while_statement] = STATE(2038),
    [sym_repeat_statement] = STATE(2038),
    [sym_braced_expression] = STATE(2038),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_call] = STATE(2038),
    [sym_subset] = STATE(2038),
    [sym_subset2] = STATE(2038),
    [sym__argument] = STATE(4664),
    [sym_argument] = STATE(4659),
    [sym__argument_named] = STATE(4654),
    [sym__argument_unnamed] = STATE(4676),
    [sym__argument_value] = STATE(4677),
    [sym_unary_operator] = STATE(2038),
    [sym_binary_operator] = STATE(2038),
    [sym_extract_operator] = STATE(2038),
    [sym_namespace_operator] = STATE(2038),
    [sym_integer] = STATE(2038),
    [sym_complex] = STATE(2038),
    [sym_float] = STATE(2038),
    [sym__hex_literal] = STATE(2700),
    [sym__float_literal] = STATE(2700),
    [sym_string] = STATE(2597),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym_na] = STATE(2038),
    [sym__expression] = STATE(2038),
    [sym__string_or_identifier] = STATE(5148),
    [sym__open_parenthesis] = STATE(214),
    [sym__open_brace] = STATE(192),
    [sym__close_bracket] = STATE(2844),
    [aux_sym_call_arguments_repeat1] = STATE(2034),
    [sym_identifier] = ACTIONS(6351),
    [anon_sym_BSLASH] = ACTIONS(4754),
    [anon_sym_function] = ACTIONS(4756),
    [anon_sym_if] = ACTIONS(4758),
    [anon_sym_for] = ACTIONS(4760),
    [anon_sym_while] = ACTIONS(4762),
    [anon_sym_repeat] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4766),
    [anon_sym_TILDE] = ACTIONS(4768),
    [anon_sym_BANG] = ACTIONS(6353),
    [anon_sym_PLUS] = ACTIONS(4772),
    [anon_sym_DASH] = ACTIONS(4772),
    [aux_sym__hex_literal_token1] = ACTIONS(4776),
    [sym__number_literal] = ACTIONS(4778),
    [anon_sym_SQUOTE] = ACTIONS(4780),
    [anon_sym_DQUOTE] = ACTIONS(4782),
    [sym_return] = ACTIONS(6355),
    [sym_next] = ACTIONS(6355),
    [sym_break] = ACTIONS(6355),
    [sym_true] = ACTIONS(6355),
    [sym_false] = ACTIONS(6355),
    [sym_null] = ACTIONS(6355),
    [sym_inf] = ACTIONS(6355),
    [sym_nan] = ACTIONS(6355),
    [anon_sym_NA] = ACTIONS(4786),
    [anon_sym_NA_integer_] = ACTIONS(4786),
    [anon_sym_NA_real_] = ACTIONS(4786),
    [anon_sym_NA_complex_] = ACTIONS(4786),
    [anon_sym_NA_character_] = ACTIONS(4786),
    [sym_dots] = ACTIONS(6357),
    [sym_dot_dot_i] = ACTIONS(6359),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6361),
    [sym__newline] = ACTIONS(6363),
    [sym__raw_string_literal] = ACTIONS(4790),
    [sym__external_open_parenthesis] = ACTIONS(4792),
    [sym__external_open_brace] = ACTIONS(4794),
    [sym__external_close_bracket] = ACTIONS(6837),
  },
  [1877] = {
    [sym_function_definition] = STATE(2038),
    [sym_if_statement] = STATE(2038),
    [sym_for_statement] = STATE(2038),
    [sym_while_statement] = STATE(2038),
    [sym_repeat_statement] = STATE(2038),
    [sym_braced_expression] = STATE(2038),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_call] = STATE(2038),
    [sym_subset] = STATE(2038),
    [sym_subset2] = STATE(2038),
    [sym__argument] = STATE(4664),
    [sym_argument] = STATE(4659),
    [sym__argument_named] = STATE(4654),
    [sym__argument_unnamed] = STATE(4676),
    [sym__argument_value] = STATE(4677),
    [sym_unary_operator] = STATE(2038),
    [sym_binary_operator] = STATE(2038),
    [sym_extract_operator] = STATE(2038),
    [sym_namespace_operator] = STATE(2038),
    [sym_integer] = STATE(2038),
    [sym_complex] = STATE(2038),
    [sym_float] = STATE(2038),
    [sym__hex_literal] = STATE(2700),
    [sym__float_literal] = STATE(2700),
    [sym_string] = STATE(2597),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym_na] = STATE(2038),
    [sym__expression] = STATE(2038),
    [sym__string_or_identifier] = STATE(5148),
    [sym__open_parenthesis] = STATE(214),
    [sym__open_brace] = STATE(192),
    [sym__close_bracket] = STATE(4712),
    [aux_sym_call_arguments_repeat1] = STATE(2034),
    [sym_identifier] = ACTIONS(6351),
    [anon_sym_BSLASH] = ACTIONS(4754),
    [anon_sym_function] = ACTIONS(4756),
    [anon_sym_if] = ACTIONS(4758),
    [anon_sym_for] = ACTIONS(4760),
    [anon_sym_while] = ACTIONS(4762),
    [anon_sym_repeat] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4766),
    [anon_sym_TILDE] = ACTIONS(4768),
    [anon_sym_BANG] = ACTIONS(6353),
    [anon_sym_PLUS] = ACTIONS(4772),
    [anon_sym_DASH] = ACTIONS(4772),
    [aux_sym__hex_literal_token1] = ACTIONS(4776),
    [sym__number_literal] = ACTIONS(4778),
    [anon_sym_SQUOTE] = ACTIONS(4780),
    [anon_sym_DQUOTE] = ACTIONS(4782),
    [sym_return] = ACTIONS(6355),
    [sym_next] = ACTIONS(6355),
    [sym_break] = ACTIONS(6355),
    [sym_true] = ACTIONS(6355),
    [sym_false] = ACTIONS(6355),
    [sym_null] = ACTIONS(6355),
    [sym_inf] = ACTIONS(6355),
    [sym_nan] = ACTIONS(6355),
    [anon_sym_NA] = ACTIONS(4786),
    [anon_sym_NA_integer_] = ACTIONS(4786),
    [anon_sym_NA_real_] = ACTIONS(4786),
    [anon_sym_NA_complex_] = ACTIONS(4786),
    [anon_sym_NA_character_] = ACTIONS(4786),
    [sym_dots] = ACTIONS(6357),
    [sym_dot_dot_i] = ACTIONS(6359),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6361),
    [sym__newline] = ACTIONS(6363),
    [sym__raw_string_literal] = ACTIONS(4790),
    [sym__external_open_parenthesis] = ACTIONS(4792),
    [sym__external_open_brace] = ACTIONS(4794),
    [sym__external_close_bracket] = ACTIONS(6839),
  },
  [1878] = {
    [sym_call_arguments] = STATE(2777),
    [sym_subset_arguments] = STATE(2779),
    [sym_subset2_arguments] = STATE(2786),
    [sym__open_parenthesis] = STATE(1411),
    [sym__open_bracket] = STATE(1409),
    [sym__open_bracket2] = STATE(1407),
    [ts_builtin_sym_end] = ACTIONS(5453),
    [sym_identifier] = ACTIONS(5455),
    [anon_sym_BSLASH] = ACTIONS(5453),
    [anon_sym_function] = ACTIONS(5455),
    [anon_sym_EQ] = ACTIONS(6491),
    [anon_sym_if] = ACTIONS(5455),
    [anon_sym_for] = ACTIONS(5455),
    [anon_sym_while] = ACTIONS(5455),
    [anon_sym_repeat] = ACTIONS(5455),
    [anon_sym_QMARK] = ACTIONS(5453),
    [anon_sym_TILDE] = ACTIONS(6495),
    [anon_sym_BANG] = ACTIONS(5455),
    [anon_sym_PLUS] = ACTIONS(6497),
    [anon_sym_DASH] = ACTIONS(6499),
    [anon_sym_LT_DASH] = ACTIONS(6501),
    [anon_sym_LT_LT_DASH] = ACTIONS(6501),
    [anon_sym_COLON_EQ] = ACTIONS(6501),
    [anon_sym_DASH_GT] = ACTIONS(6503),
    [anon_sym_DASH_GT_GT] = ACTIONS(6505),
    [anon_sym_PIPE] = ACTIONS(6507),
    [anon_sym_AMP] = ACTIONS(6509),
    [anon_sym_PIPE_PIPE] = ACTIONS(6511),
    [anon_sym_AMP_AMP] = ACTIONS(6513),
    [anon_sym_LT] = ACTIONS(6515),
    [anon_sym_LT_EQ] = ACTIONS(6517),
    [anon_sym_GT] = ACTIONS(6515),
    [anon_sym_GT_EQ] = ACTIONS(6517),
    [anon_sym_EQ_EQ] = ACTIONS(6517),
    [anon_sym_BANG_EQ] = ACTIONS(6517),
    [anon_sym_STAR] = ACTIONS(6519),
    [anon_sym_SLASH] = ACTIONS(6521),
    [anon_sym_STAR_STAR] = ACTIONS(6523),
    [anon_sym_CARET] = ACTIONS(6523),
    [aux_sym_binary_operator_token1] = ACTIONS(6525),
    [anon_sym_PIPE_GT] = ACTIONS(6525),
    [anon_sym_COLON] = ACTIONS(6527),
    [anon_sym_DOLLAR] = ACTIONS(6529),
    [anon_sym_AT] = ACTIONS(6529),
    [aux_sym__hex_literal_token1] = ACTIONS(5453),
    [sym__number_literal] = ACTIONS(5455),
    [anon_sym_SQUOTE] = ACTIONS(5453),
    [anon_sym_DQUOTE] = ACTIONS(5453),
    [sym_return] = ACTIONS(5455),
    [sym_next] = ACTIONS(5455),
    [sym_break] = ACTIONS(5455),
    [sym_true] = ACTIONS(5455),
    [sym_false] = ACTIONS(5455),
    [sym_null] = ACTIONS(5455),
    [sym_inf] = ACTIONS(5455),
    [sym_nan] = ACTIONS(5455),
    [anon_sym_NA] = ACTIONS(5455),
    [anon_sym_NA_integer_] = ACTIONS(5455),
    [anon_sym_NA_real_] = ACTIONS(5455),
    [anon_sym_NA_complex_] = ACTIONS(5455),
    [anon_sym_NA_character_] = ACTIONS(5455),
    [sym_dots] = ACTIONS(5455),
    [sym_dot_dot_i] = ACTIONS(5453),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5453),
    [sym__semicolon] = ACTIONS(5453),
    [sym__raw_string_literal] = ACTIONS(5453),
    [sym__external_open_parenthesis] = ACTIONS(6531),
    [sym__external_close_parenthesis] = ACTIONS(5453),
    [sym__external_open_brace] = ACTIONS(5453),
    [sym__external_open_bracket] = ACTIONS(6533),
    [sym__external_open_bracket2] = ACTIONS(6535),
  },
  [1879] = {
    [sym_call_arguments] = STATE(2840),
    [sym_subset_arguments] = STATE(2797),
    [sym_subset2_arguments] = STATE(2801),
    [sym__open_parenthesis] = STATE(1344),
    [sym__open_bracket] = STATE(1374),
    [sym__open_bracket2] = STATE(1452),
    [ts_builtin_sym_end] = ACTIONS(5333),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(6267),
    [anon_sym_DASH] = ACTIONS(6269),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(6277),
    [anon_sym_AMP] = ACTIONS(6279),
    [anon_sym_PIPE_PIPE] = ACTIONS(6281),
    [anon_sym_AMP_AMP] = ACTIONS(6283),
    [anon_sym_LT] = ACTIONS(6285),
    [anon_sym_LT_EQ] = ACTIONS(6287),
    [anon_sym_GT] = ACTIONS(6285),
    [anon_sym_GT_EQ] = ACTIONS(6287),
    [anon_sym_EQ_EQ] = ACTIONS(6287),
    [anon_sym_BANG_EQ] = ACTIONS(6287),
    [anon_sym_STAR] = ACTIONS(6289),
    [anon_sym_SLASH] = ACTIONS(6291),
    [anon_sym_STAR_STAR] = ACTIONS(6293),
    [anon_sym_CARET] = ACTIONS(6293),
    [aux_sym_binary_operator_token1] = ACTIONS(6295),
    [anon_sym_PIPE_GT] = ACTIONS(6295),
    [anon_sym_COLON] = ACTIONS(6297),
    [anon_sym_DOLLAR] = ACTIONS(6299),
    [anon_sym_AT] = ACTIONS(6299),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5333),
    [sym__semicolon] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(6301),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_close_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(6303),
    [sym__external_open_bracket2] = ACTIONS(6305),
  },
  [1880] = {
    [sym_call_arguments] = STATE(2777),
    [sym_subset_arguments] = STATE(2779),
    [sym_subset2_arguments] = STATE(2786),
    [sym__open_parenthesis] = STATE(1411),
    [sym__open_bracket] = STATE(1409),
    [sym__open_bracket2] = STATE(1407),
    [ts_builtin_sym_end] = ACTIONS(5445),
    [sym_identifier] = ACTIONS(5447),
    [anon_sym_BSLASH] = ACTIONS(5445),
    [anon_sym_function] = ACTIONS(5447),
    [anon_sym_EQ] = ACTIONS(6491),
    [anon_sym_if] = ACTIONS(5447),
    [anon_sym_for] = ACTIONS(5447),
    [anon_sym_while] = ACTIONS(5447),
    [anon_sym_repeat] = ACTIONS(5447),
    [anon_sym_QMARK] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(6495),
    [anon_sym_BANG] = ACTIONS(5447),
    [anon_sym_PLUS] = ACTIONS(6497),
    [anon_sym_DASH] = ACTIONS(6499),
    [anon_sym_LT_DASH] = ACTIONS(6501),
    [anon_sym_LT_LT_DASH] = ACTIONS(6501),
    [anon_sym_COLON_EQ] = ACTIONS(6501),
    [anon_sym_DASH_GT] = ACTIONS(6503),
    [anon_sym_DASH_GT_GT] = ACTIONS(6505),
    [anon_sym_PIPE] = ACTIONS(6507),
    [anon_sym_AMP] = ACTIONS(6509),
    [anon_sym_PIPE_PIPE] = ACTIONS(6511),
    [anon_sym_AMP_AMP] = ACTIONS(6513),
    [anon_sym_LT] = ACTIONS(6515),
    [anon_sym_LT_EQ] = ACTIONS(6517),
    [anon_sym_GT] = ACTIONS(6515),
    [anon_sym_GT_EQ] = ACTIONS(6517),
    [anon_sym_EQ_EQ] = ACTIONS(6517),
    [anon_sym_BANG_EQ] = ACTIONS(6517),
    [anon_sym_STAR] = ACTIONS(6519),
    [anon_sym_SLASH] = ACTIONS(6521),
    [anon_sym_STAR_STAR] = ACTIONS(6523),
    [anon_sym_CARET] = ACTIONS(6523),
    [aux_sym_binary_operator_token1] = ACTIONS(6525),
    [anon_sym_PIPE_GT] = ACTIONS(6525),
    [anon_sym_COLON] = ACTIONS(6527),
    [anon_sym_DOLLAR] = ACTIONS(6529),
    [anon_sym_AT] = ACTIONS(6529),
    [aux_sym__hex_literal_token1] = ACTIONS(5445),
    [sym__number_literal] = ACTIONS(5447),
    [anon_sym_SQUOTE] = ACTIONS(5445),
    [anon_sym_DQUOTE] = ACTIONS(5445),
    [sym_return] = ACTIONS(5447),
    [sym_next] = ACTIONS(5447),
    [sym_break] = ACTIONS(5447),
    [sym_true] = ACTIONS(5447),
    [sym_false] = ACTIONS(5447),
    [sym_null] = ACTIONS(5447),
    [sym_inf] = ACTIONS(5447),
    [sym_nan] = ACTIONS(5447),
    [anon_sym_NA] = ACTIONS(5447),
    [anon_sym_NA_integer_] = ACTIONS(5447),
    [anon_sym_NA_real_] = ACTIONS(5447),
    [anon_sym_NA_complex_] = ACTIONS(5447),
    [anon_sym_NA_character_] = ACTIONS(5447),
    [sym_dots] = ACTIONS(5447),
    [sym_dot_dot_i] = ACTIONS(5445),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5445),
    [sym__semicolon] = ACTIONS(5445),
    [sym__raw_string_literal] = ACTIONS(5445),
    [sym__external_open_parenthesis] = ACTIONS(6531),
    [sym__external_close_parenthesis] = ACTIONS(5445),
    [sym__external_open_brace] = ACTIONS(5445),
    [sym__external_open_bracket] = ACTIONS(6533),
    [sym__external_open_bracket2] = ACTIONS(6535),
  },
  [1881] = {
    [sym_function_definition] = STATE(1931),
    [sym_if_statement] = STATE(1931),
    [sym_for_statement] = STATE(1931),
    [sym_while_statement] = STATE(1931),
    [sym_repeat_statement] = STATE(1931),
    [sym_braced_expression] = STATE(1931),
    [sym_parenthesized_expression] = STATE(1931),
    [sym_call] = STATE(1931),
    [sym_subset] = STATE(1931),
    [sym_subset2] = STATE(1931),
    [sym__argument] = STATE(4656),
    [sym_argument] = STATE(4657),
    [sym__argument_named] = STATE(4658),
    [sym__argument_unnamed] = STATE(4662),
    [sym__argument_value] = STATE(4663),
    [sym_unary_operator] = STATE(1931),
    [sym_binary_operator] = STATE(1931),
    [sym_extract_operator] = STATE(1931),
    [sym_namespace_operator] = STATE(1931),
    [sym_integer] = STATE(1931),
    [sym_complex] = STATE(1931),
    [sym_float] = STATE(1931),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2633),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(1931),
    [sym__expression] = STATE(1931),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__close_parenthesis] = STATE(2836),
    [sym__open_brace] = STATE(154),
    [aux_sym_call_arguments_repeat1] = STATE(2113),
    [sym_identifier] = ACTIONS(6387),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(6389),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3865),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(6391),
    [sym_next] = ACTIONS(6391),
    [sym_break] = ACTIONS(6391),
    [sym_true] = ACTIONS(6391),
    [sym_false] = ACTIONS(6391),
    [sym_null] = ACTIONS(6391),
    [sym_inf] = ACTIONS(6391),
    [sym_nan] = ACTIONS(6391),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(6393),
    [sym_dot_dot_i] = ACTIONS(6395),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6397),
    [sym__newline] = ACTIONS(6399),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(6841),
    [sym__external_open_brace] = ACTIONS(3891),
  },
  [1882] = {
    [sym_call_arguments] = STATE(2923),
    [sym_subset_arguments] = STATE(2922),
    [sym_subset2_arguments] = STATE(2906),
    [sym__open_parenthesis] = STATE(1528),
    [sym__open_bracket] = STATE(1525),
    [sym__open_bracket2] = STATE(1519),
    [ts_builtin_sym_end] = ACTIONS(5337),
    [sym_identifier] = ACTIONS(5339),
    [anon_sym_BSLASH] = ACTIONS(5337),
    [anon_sym_function] = ACTIONS(5339),
    [anon_sym_EQ] = ACTIONS(5947),
    [anon_sym_if] = ACTIONS(5339),
    [anon_sym_for] = ACTIONS(5339),
    [anon_sym_while] = ACTIONS(5339),
    [anon_sym_repeat] = ACTIONS(5339),
    [anon_sym_QMARK] = ACTIONS(5337),
    [anon_sym_TILDE] = ACTIONS(5949),
    [anon_sym_BANG] = ACTIONS(5339),
    [anon_sym_PLUS] = ACTIONS(5951),
    [anon_sym_DASH] = ACTIONS(5953),
    [anon_sym_LT_DASH] = ACTIONS(5955),
    [anon_sym_LT_LT_DASH] = ACTIONS(5955),
    [anon_sym_COLON_EQ] = ACTIONS(5955),
    [anon_sym_DASH_GT] = ACTIONS(5957),
    [anon_sym_DASH_GT_GT] = ACTIONS(5959),
    [anon_sym_PIPE] = ACTIONS(5961),
    [anon_sym_AMP] = ACTIONS(5963),
    [anon_sym_PIPE_PIPE] = ACTIONS(5965),
    [anon_sym_AMP_AMP] = ACTIONS(5967),
    [anon_sym_LT] = ACTIONS(5969),
    [anon_sym_LT_EQ] = ACTIONS(5971),
    [anon_sym_GT] = ACTIONS(5969),
    [anon_sym_GT_EQ] = ACTIONS(5971),
    [anon_sym_EQ_EQ] = ACTIONS(5971),
    [anon_sym_BANG_EQ] = ACTIONS(5971),
    [anon_sym_STAR] = ACTIONS(5973),
    [anon_sym_SLASH] = ACTIONS(5975),
    [anon_sym_STAR_STAR] = ACTIONS(5977),
    [anon_sym_CARET] = ACTIONS(5977),
    [aux_sym_binary_operator_token1] = ACTIONS(5979),
    [anon_sym_PIPE_GT] = ACTIONS(5979),
    [anon_sym_COLON] = ACTIONS(5981),
    [anon_sym_DOLLAR] = ACTIONS(5983),
    [anon_sym_AT] = ACTIONS(5983),
    [aux_sym__hex_literal_token1] = ACTIONS(5337),
    [sym__number_literal] = ACTIONS(5339),
    [anon_sym_SQUOTE] = ACTIONS(5337),
    [anon_sym_DQUOTE] = ACTIONS(5337),
    [sym_return] = ACTIONS(5339),
    [sym_next] = ACTIONS(5339),
    [sym_break] = ACTIONS(5339),
    [sym_true] = ACTIONS(5339),
    [sym_false] = ACTIONS(5339),
    [sym_null] = ACTIONS(5339),
    [sym_inf] = ACTIONS(5339),
    [sym_nan] = ACTIONS(5339),
    [anon_sym_NA] = ACTIONS(5339),
    [anon_sym_NA_integer_] = ACTIONS(5339),
    [anon_sym_NA_real_] = ACTIONS(5339),
    [anon_sym_NA_complex_] = ACTIONS(5339),
    [anon_sym_NA_character_] = ACTIONS(5339),
    [sym_dots] = ACTIONS(5339),
    [sym_dot_dot_i] = ACTIONS(5337),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5337),
    [sym__semicolon] = ACTIONS(5337),
    [sym__raw_string_literal] = ACTIONS(5337),
    [sym__external_else] = ACTIONS(5337),
    [sym__external_open_parenthesis] = ACTIONS(5987),
    [sym__external_open_brace] = ACTIONS(5337),
    [sym__external_open_bracket] = ACTIONS(5989),
    [sym__external_open_bracket2] = ACTIONS(5991),
  },
  [1883] = {
    [sym_call_arguments] = STATE(2840),
    [sym_subset_arguments] = STATE(2797),
    [sym_subset2_arguments] = STATE(2801),
    [sym__open_parenthesis] = STATE(1344),
    [sym__open_bracket] = STATE(1374),
    [sym__open_bracket2] = STATE(1452),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(6293),
    [anon_sym_CARET] = ACTIONS(6293),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(5351),
    [anon_sym_DOLLAR] = ACTIONS(6299),
    [anon_sym_AT] = ACTIONS(6299),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6301),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6303),
    [sym__external_open_bracket2] = ACTIONS(6305),
  },
  [1884] = {
    [sym_call_arguments] = STATE(2840),
    [sym_subset_arguments] = STATE(2797),
    [sym_subset2_arguments] = STATE(2801),
    [sym__open_parenthesis] = STATE(1344),
    [sym__open_bracket] = STATE(1374),
    [sym__open_bracket2] = STATE(1452),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(6293),
    [anon_sym_CARET] = ACTIONS(6293),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(6297),
    [anon_sym_DOLLAR] = ACTIONS(6299),
    [anon_sym_AT] = ACTIONS(6299),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6301),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6303),
    [sym__external_open_bracket2] = ACTIONS(6305),
  },
  [1885] = {
    [sym_string] = STATE(2582),
    [sym__single_quoted_string] = STATE(2310),
    [sym__double_quoted_string] = STATE(2309),
    [sym__string_or_identifier] = STATE(2582),
    [aux_sym_function_definition_repeat1] = STATE(1901),
    [ts_builtin_sym_end] = ACTIONS(5659),
    [sym_identifier] = ACTIONS(6843),
    [anon_sym_BSLASH] = ACTIONS(5659),
    [anon_sym_function] = ACTIONS(5663),
    [anon_sym_EQ] = ACTIONS(5663),
    [anon_sym_if] = ACTIONS(5663),
    [anon_sym_for] = ACTIONS(5663),
    [anon_sym_while] = ACTIONS(5663),
    [anon_sym_repeat] = ACTIONS(5663),
    [anon_sym_QMARK] = ACTIONS(5659),
    [anon_sym_TILDE] = ACTIONS(5659),
    [anon_sym_BANG] = ACTIONS(5663),
    [anon_sym_PLUS] = ACTIONS(5659),
    [anon_sym_DASH] = ACTIONS(5663),
    [anon_sym_LT_DASH] = ACTIONS(5659),
    [anon_sym_LT_LT_DASH] = ACTIONS(5659),
    [anon_sym_COLON_EQ] = ACTIONS(5659),
    [anon_sym_DASH_GT] = ACTIONS(5663),
    [anon_sym_DASH_GT_GT] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(5663),
    [anon_sym_AMP] = ACTIONS(5663),
    [anon_sym_PIPE_PIPE] = ACTIONS(5659),
    [anon_sym_AMP_AMP] = ACTIONS(5659),
    [anon_sym_LT] = ACTIONS(5663),
    [anon_sym_LT_EQ] = ACTIONS(5659),
    [anon_sym_GT] = ACTIONS(5663),
    [anon_sym_GT_EQ] = ACTIONS(5659),
    [anon_sym_EQ_EQ] = ACTIONS(5659),
    [anon_sym_BANG_EQ] = ACTIONS(5659),
    [anon_sym_STAR] = ACTIONS(5663),
    [anon_sym_SLASH] = ACTIONS(5659),
    [anon_sym_STAR_STAR] = ACTIONS(5659),
    [anon_sym_CARET] = ACTIONS(5659),
    [aux_sym_binary_operator_token1] = ACTIONS(5659),
    [anon_sym_PIPE_GT] = ACTIONS(5659),
    [anon_sym_COLON] = ACTIONS(5663),
    [anon_sym_DOLLAR] = ACTIONS(5659),
    [anon_sym_AT] = ACTIONS(5659),
    [aux_sym__hex_literal_token1] = ACTIONS(5659),
    [sym__number_literal] = ACTIONS(5663),
    [anon_sym_SQUOTE] = ACTIONS(1413),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [sym_return] = ACTIONS(5663),
    [sym_next] = ACTIONS(5663),
    [sym_break] = ACTIONS(5663),
    [sym_true] = ACTIONS(5663),
    [sym_false] = ACTIONS(5663),
    [sym_null] = ACTIONS(5663),
    [sym_inf] = ACTIONS(5663),
    [sym_nan] = ACTIONS(5663),
    [anon_sym_NA] = ACTIONS(5663),
    [anon_sym_NA_integer_] = ACTIONS(5663),
    [anon_sym_NA_real_] = ACTIONS(5663),
    [anon_sym_NA_complex_] = ACTIONS(5663),
    [anon_sym_NA_character_] = ACTIONS(5663),
    [sym_dots] = ACTIONS(5663),
    [sym_dot_dot_i] = ACTIONS(5659),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(6845),
    [sym__semicolon] = ACTIONS(5659),
    [sym__raw_string_literal] = ACTIONS(1425),
    [sym__external_else] = ACTIONS(5659),
    [sym__external_open_parenthesis] = ACTIONS(5659),
    [sym__external_open_brace] = ACTIONS(5659),
    [sym__external_close_brace] = ACTIONS(5659),
    [sym__external_open_bracket] = ACTIONS(5659),
    [sym__external_open_bracket2] = ACTIONS(5659),
  },
  [1886] = {
    [sym_call_arguments] = STATE(2777),
    [sym_subset_arguments] = STATE(2779),
    [sym_subset2_arguments] = STATE(2786),
    [sym__open_parenthesis] = STATE(1411),
    [sym__open_bracket] = STATE(1409),
    [sym__open_bracket2] = STATE(1407),
    [ts_builtin_sym_end] = ACTIONS(5409),
    [sym_identifier] = ACTIONS(5411),
    [anon_sym_BSLASH] = ACTIONS(5409),
    [anon_sym_function] = ACTIONS(5411),
    [anon_sym_EQ] = ACTIONS(6491),
    [anon_sym_if] = ACTIONS(5411),
    [anon_sym_for] = ACTIONS(5411),
    [anon_sym_while] = ACTIONS(5411),
    [anon_sym_repeat] = ACTIONS(5411),
    [anon_sym_QMARK] = ACTIONS(5409),
    [anon_sym_TILDE] = ACTIONS(6495),
    [anon_sym_BANG] = ACTIONS(5411),
    [anon_sym_PLUS] = ACTIONS(6497),
    [anon_sym_DASH] = ACTIONS(6499),
    [anon_sym_LT_DASH] = ACTIONS(6501),
    [anon_sym_LT_LT_DASH] = ACTIONS(6501),
    [anon_sym_COLON_EQ] = ACTIONS(6501),
    [anon_sym_DASH_GT] = ACTIONS(6503),
    [anon_sym_DASH_GT_GT] = ACTIONS(6505),
    [anon_sym_PIPE] = ACTIONS(6507),
    [anon_sym_AMP] = ACTIONS(6509),
    [anon_sym_PIPE_PIPE] = ACTIONS(6511),
    [anon_sym_AMP_AMP] = ACTIONS(6513),
    [anon_sym_LT] = ACTIONS(6515),
    [anon_sym_LT_EQ] = ACTIONS(6517),
    [anon_sym_GT] = ACTIONS(6515),
    [anon_sym_GT_EQ] = ACTIONS(6517),
    [anon_sym_EQ_EQ] = ACTIONS(6517),
    [anon_sym_BANG_EQ] = ACTIONS(6517),
    [anon_sym_STAR] = ACTIONS(6519),
    [anon_sym_SLASH] = ACTIONS(6521),
    [anon_sym_STAR_STAR] = ACTIONS(6523),
    [anon_sym_CARET] = ACTIONS(6523),
    [aux_sym_binary_operator_token1] = ACTIONS(6525),
    [anon_sym_PIPE_GT] = ACTIONS(6525),
    [anon_sym_COLON] = ACTIONS(6527),
    [anon_sym_DOLLAR] = ACTIONS(6529),
    [anon_sym_AT] = ACTIONS(6529),
    [aux_sym__hex_literal_token1] = ACTIONS(5409),
    [sym__number_literal] = ACTIONS(5411),
    [anon_sym_SQUOTE] = ACTIONS(5409),
    [anon_sym_DQUOTE] = ACTIONS(5409),
    [sym_return] = ACTIONS(5411),
    [sym_next] = ACTIONS(5411),
    [sym_break] = ACTIONS(5411),
    [sym_true] = ACTIONS(5411),
    [sym_false] = ACTIONS(5411),
    [sym_null] = ACTIONS(5411),
    [sym_inf] = ACTIONS(5411),
    [sym_nan] = ACTIONS(5411),
    [anon_sym_NA] = ACTIONS(5411),
    [anon_sym_NA_integer_] = ACTIONS(5411),
    [anon_sym_NA_real_] = ACTIONS(5411),
    [anon_sym_NA_complex_] = ACTIONS(5411),
    [anon_sym_NA_character_] = ACTIONS(5411),
    [sym_dots] = ACTIONS(5411),
    [sym_dot_dot_i] = ACTIONS(5409),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5409),
    [sym__semicolon] = ACTIONS(5409),
    [sym__raw_string_literal] = ACTIONS(5409),
    [sym__external_open_parenthesis] = ACTIONS(6531),
    [sym__external_close_parenthesis] = ACTIONS(5409),
    [sym__external_open_brace] = ACTIONS(5409),
    [sym__external_open_bracket] = ACTIONS(6533),
    [sym__external_open_bracket2] = ACTIONS(6535),
  },
  [1887] = {
    [sym_call_arguments] = STATE(2840),
    [sym_subset_arguments] = STATE(2797),
    [sym_subset2_arguments] = STATE(2801),
    [sym__open_parenthesis] = STATE(1344),
    [sym__open_bracket] = STATE(1374),
    [sym__open_bracket2] = STATE(1452),
    [ts_builtin_sym_end] = ACTIONS(5333),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(6263),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(6265),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(6267),
    [anon_sym_DASH] = ACTIONS(6269),
    [anon_sym_LT_DASH] = ACTIONS(6271),
    [anon_sym_LT_LT_DASH] = ACTIONS(6271),
    [anon_sym_COLON_EQ] = ACTIONS(6271),
    [anon_sym_DASH_GT] = ACTIONS(6273),
    [anon_sym_DASH_GT_GT] = ACTIONS(6275),
    [anon_sym_PIPE] = ACTIONS(6277),
    [anon_sym_AMP] = ACTIONS(6279),
    [anon_sym_PIPE_PIPE] = ACTIONS(6281),
    [anon_sym_AMP_AMP] = ACTIONS(6283),
    [anon_sym_LT] = ACTIONS(6285),
    [anon_sym_LT_EQ] = ACTIONS(6287),
    [anon_sym_GT] = ACTIONS(6285),
    [anon_sym_GT_EQ] = ACTIONS(6287),
    [anon_sym_EQ_EQ] = ACTIONS(6287),
    [anon_sym_BANG_EQ] = ACTIONS(6287),
    [anon_sym_STAR] = ACTIONS(6289),
    [anon_sym_SLASH] = ACTIONS(6291),
    [anon_sym_STAR_STAR] = ACTIONS(6293),
    [anon_sym_CARET] = ACTIONS(6293),
    [aux_sym_binary_operator_token1] = ACTIONS(6295),
    [anon_sym_PIPE_GT] = ACTIONS(6295),
    [anon_sym_COLON] = ACTIONS(6297),
    [anon_sym_DOLLAR] = ACTIONS(6299),
    [anon_sym_AT] = ACTIONS(6299),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5333),
    [sym__semicolon] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(6301),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_close_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(6303),
    [sym__external_open_bracket2] = ACTIONS(6305),
  },
  [1888] = {
    [sym_function_definition] = STATE(2038),
    [sym_if_statement] = STATE(2038),
    [sym_for_statement] = STATE(2038),
    [sym_while_statement] = STATE(2038),
    [sym_repeat_statement] = STATE(2038),
    [sym_braced_expression] = STATE(2038),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_call] = STATE(2038),
    [sym_subset] = STATE(2038),
    [sym_subset2] = STATE(2038),
    [sym__argument] = STATE(4664),
    [sym_argument] = STATE(4659),
    [sym__argument_named] = STATE(4654),
    [sym__argument_unnamed] = STATE(4676),
    [sym__argument_value] = STATE(4677),
    [sym_unary_operator] = STATE(2038),
    [sym_binary_operator] = STATE(2038),
    [sym_extract_operator] = STATE(2038),
    [sym_namespace_operator] = STATE(2038),
    [sym_integer] = STATE(2038),
    [sym_complex] = STATE(2038),
    [sym_float] = STATE(2038),
    [sym__hex_literal] = STATE(2700),
    [sym__float_literal] = STATE(2700),
    [sym_string] = STATE(2597),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym_na] = STATE(2038),
    [sym__expression] = STATE(2038),
    [sym__string_or_identifier] = STATE(5148),
    [sym__open_parenthesis] = STATE(214),
    [sym__open_brace] = STATE(192),
    [sym__close_bracket] = STATE(2990),
    [aux_sym_call_arguments_repeat1] = STATE(2034),
    [sym_identifier] = ACTIONS(6351),
    [anon_sym_BSLASH] = ACTIONS(4754),
    [anon_sym_function] = ACTIONS(4756),
    [anon_sym_if] = ACTIONS(4758),
    [anon_sym_for] = ACTIONS(4760),
    [anon_sym_while] = ACTIONS(4762),
    [anon_sym_repeat] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4766),
    [anon_sym_TILDE] = ACTIONS(4768),
    [anon_sym_BANG] = ACTIONS(6353),
    [anon_sym_PLUS] = ACTIONS(4772),
    [anon_sym_DASH] = ACTIONS(4772),
    [aux_sym__hex_literal_token1] = ACTIONS(4776),
    [sym__number_literal] = ACTIONS(4778),
    [anon_sym_SQUOTE] = ACTIONS(4780),
    [anon_sym_DQUOTE] = ACTIONS(4782),
    [sym_return] = ACTIONS(6355),
    [sym_next] = ACTIONS(6355),
    [sym_break] = ACTIONS(6355),
    [sym_true] = ACTIONS(6355),
    [sym_false] = ACTIONS(6355),
    [sym_null] = ACTIONS(6355),
    [sym_inf] = ACTIONS(6355),
    [sym_nan] = ACTIONS(6355),
    [anon_sym_NA] = ACTIONS(4786),
    [anon_sym_NA_integer_] = ACTIONS(4786),
    [anon_sym_NA_real_] = ACTIONS(4786),
    [anon_sym_NA_complex_] = ACTIONS(4786),
    [anon_sym_NA_character_] = ACTIONS(4786),
    [sym_dots] = ACTIONS(6357),
    [sym_dot_dot_i] = ACTIONS(6359),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6361),
    [sym__newline] = ACTIONS(6363),
    [sym__raw_string_literal] = ACTIONS(4790),
    [sym__external_open_parenthesis] = ACTIONS(4792),
    [sym__external_open_brace] = ACTIONS(4794),
    [sym__external_close_bracket] = ACTIONS(6847),
  },
  [1889] = {
    [sym_function_definition] = STATE(1940),
    [sym_if_statement] = STATE(1940),
    [sym_for_statement] = STATE(1940),
    [sym_while_statement] = STATE(1940),
    [sym_repeat_statement] = STATE(1940),
    [sym_braced_expression] = STATE(1940),
    [sym_parenthesized_expression] = STATE(1940),
    [sym_call] = STATE(1940),
    [sym_subset] = STATE(1940),
    [sym_subset2] = STATE(1940),
    [sym__argument] = STATE(4665),
    [sym_argument] = STATE(4661),
    [sym__argument_named] = STATE(4669),
    [sym__argument_unnamed] = STATE(4673),
    [sym__argument_value] = STATE(4679),
    [sym_unary_operator] = STATE(1940),
    [sym_binary_operator] = STATE(1940),
    [sym_extract_operator] = STATE(1940),
    [sym_namespace_operator] = STATE(1940),
    [sym_integer] = STATE(1940),
    [sym_complex] = STATE(1940),
    [sym_float] = STATE(1940),
    [sym__hex_literal] = STATE(2656),
    [sym__float_literal] = STATE(2656),
    [sym_string] = STATE(2606),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym_na] = STATE(1940),
    [sym__expression] = STATE(1940),
    [sym__string_or_identifier] = STATE(5141),
    [sym__open_parenthesis] = STATE(218),
    [sym__open_brace] = STATE(185),
    [sym__close_bracket2] = STATE(2333),
    [aux_sym_call_arguments_repeat1] = STATE(1912),
    [sym_identifier] = ACTIONS(6369),
    [anon_sym_BSLASH] = ACTIONS(4644),
    [anon_sym_function] = ACTIONS(4646),
    [anon_sym_if] = ACTIONS(4648),
    [anon_sym_for] = ACTIONS(4650),
    [anon_sym_while] = ACTIONS(4652),
    [anon_sym_repeat] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(6371),
    [anon_sym_PLUS] = ACTIONS(4662),
    [anon_sym_DASH] = ACTIONS(4662),
    [aux_sym__hex_literal_token1] = ACTIONS(4666),
    [sym__number_literal] = ACTIONS(4668),
    [anon_sym_SQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4672),
    [sym_return] = ACTIONS(6373),
    [sym_next] = ACTIONS(6373),
    [sym_break] = ACTIONS(6373),
    [sym_true] = ACTIONS(6373),
    [sym_false] = ACTIONS(6373),
    [sym_null] = ACTIONS(6373),
    [sym_inf] = ACTIONS(6373),
    [sym_nan] = ACTIONS(6373),
    [anon_sym_NA] = ACTIONS(4676),
    [anon_sym_NA_integer_] = ACTIONS(4676),
    [anon_sym_NA_real_] = ACTIONS(4676),
    [anon_sym_NA_complex_] = ACTIONS(4676),
    [anon_sym_NA_character_] = ACTIONS(4676),
    [sym_dots] = ACTIONS(6375),
    [sym_dot_dot_i] = ACTIONS(6377),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6379),
    [sym__newline] = ACTIONS(6381),
    [sym__raw_string_literal] = ACTIONS(4680),
    [sym__external_open_parenthesis] = ACTIONS(4682),
    [sym__external_open_brace] = ACTIONS(4684),
    [sym__external_close_bracket2] = ACTIONS(6849),
  },
  [1890] = {
    [sym_string] = STATE(2517),
    [sym__single_quoted_string] = STATE(2211),
    [sym__double_quoted_string] = STATE(2212),
    [sym__string_or_identifier] = STATE(2517),
    [sym_identifier] = ACTIONS(6851),
    [anon_sym_BSLASH] = ACTIONS(5883),
    [anon_sym_function] = ACTIONS(5887),
    [anon_sym_EQ] = ACTIONS(5887),
    [anon_sym_if] = ACTIONS(5887),
    [anon_sym_for] = ACTIONS(5887),
    [anon_sym_while] = ACTIONS(5887),
    [anon_sym_repeat] = ACTIONS(5887),
    [anon_sym_QMARK] = ACTIONS(5883),
    [anon_sym_TILDE] = ACTIONS(5883),
    [anon_sym_BANG] = ACTIONS(5887),
    [anon_sym_PLUS] = ACTIONS(5883),
    [anon_sym_DASH] = ACTIONS(5887),
    [anon_sym_LT_DASH] = ACTIONS(5883),
    [anon_sym_LT_LT_DASH] = ACTIONS(5883),
    [anon_sym_COLON_EQ] = ACTIONS(5883),
    [anon_sym_DASH_GT] = ACTIONS(5887),
    [anon_sym_DASH_GT_GT] = ACTIONS(5883),
    [anon_sym_PIPE] = ACTIONS(5887),
    [anon_sym_AMP] = ACTIONS(5887),
    [anon_sym_PIPE_PIPE] = ACTIONS(5883),
    [anon_sym_AMP_AMP] = ACTIONS(5883),
    [anon_sym_LT] = ACTIONS(5887),
    [anon_sym_LT_EQ] = ACTIONS(5883),
    [anon_sym_GT] = ACTIONS(5887),
    [anon_sym_GT_EQ] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5883),
    [anon_sym_BANG_EQ] = ACTIONS(5883),
    [anon_sym_STAR] = ACTIONS(5887),
    [anon_sym_SLASH] = ACTIONS(5883),
    [anon_sym_STAR_STAR] = ACTIONS(5883),
    [anon_sym_CARET] = ACTIONS(5883),
    [aux_sym_binary_operator_token1] = ACTIONS(5883),
    [anon_sym_PIPE_GT] = ACTIONS(5883),
    [anon_sym_COLON] = ACTIONS(5887),
    [anon_sym_DOLLAR] = ACTIONS(5883),
    [anon_sym_AT] = ACTIONS(5883),
    [aux_sym__hex_literal_token1] = ACTIONS(5883),
    [sym__number_literal] = ACTIONS(5887),
    [anon_sym_SQUOTE] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_return] = ACTIONS(5887),
    [sym_next] = ACTIONS(5887),
    [sym_break] = ACTIONS(5887),
    [sym_true] = ACTIONS(5887),
    [sym_false] = ACTIONS(5887),
    [sym_null] = ACTIONS(5887),
    [sym_inf] = ACTIONS(5887),
    [sym_nan] = ACTIONS(5887),
    [anon_sym_NA] = ACTIONS(5887),
    [anon_sym_NA_integer_] = ACTIONS(5887),
    [anon_sym_NA_real_] = ACTIONS(5887),
    [anon_sym_NA_complex_] = ACTIONS(5887),
    [anon_sym_NA_character_] = ACTIONS(5887),
    [sym_dots] = ACTIONS(5887),
    [sym_dot_dot_i] = ACTIONS(5883),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5883),
    [sym__newline] = ACTIONS(5883),
    [sym__semicolon] = ACTIONS(5883),
    [sym__raw_string_literal] = ACTIONS(445),
    [sym__external_else] = ACTIONS(5883),
    [sym__external_open_parenthesis] = ACTIONS(5883),
    [sym__external_open_brace] = ACTIONS(5883),
    [sym__external_close_brace] = ACTIONS(5883),
    [sym__external_open_bracket] = ACTIONS(5883),
    [sym__external_open_bracket2] = ACTIONS(5883),
    [sym__external_close_bracket2] = ACTIONS(5883),
  },
  [1891] = {
    [sym_function_definition] = STATE(2038),
    [sym_if_statement] = STATE(2038),
    [sym_for_statement] = STATE(2038),
    [sym_while_statement] = STATE(2038),
    [sym_repeat_statement] = STATE(2038),
    [sym_braced_expression] = STATE(2038),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_call] = STATE(2038),
    [sym_subset] = STATE(2038),
    [sym_subset2] = STATE(2038),
    [sym__argument] = STATE(4664),
    [sym_argument] = STATE(4659),
    [sym__argument_named] = STATE(4654),
    [sym__argument_unnamed] = STATE(4676),
    [sym__argument_value] = STATE(4677),
    [sym_unary_operator] = STATE(2038),
    [sym_binary_operator] = STATE(2038),
    [sym_extract_operator] = STATE(2038),
    [sym_namespace_operator] = STATE(2038),
    [sym_integer] = STATE(2038),
    [sym_complex] = STATE(2038),
    [sym_float] = STATE(2038),
    [sym__hex_literal] = STATE(2700),
    [sym__float_literal] = STATE(2700),
    [sym_string] = STATE(2597),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym_na] = STATE(2038),
    [sym__expression] = STATE(2038),
    [sym__string_or_identifier] = STATE(5148),
    [sym__open_parenthesis] = STATE(214),
    [sym__open_brace] = STATE(192),
    [sym__close_bracket] = STATE(2332),
    [aux_sym_call_arguments_repeat1] = STATE(2034),
    [sym_identifier] = ACTIONS(6351),
    [anon_sym_BSLASH] = ACTIONS(4754),
    [anon_sym_function] = ACTIONS(4756),
    [anon_sym_if] = ACTIONS(4758),
    [anon_sym_for] = ACTIONS(4760),
    [anon_sym_while] = ACTIONS(4762),
    [anon_sym_repeat] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4766),
    [anon_sym_TILDE] = ACTIONS(4768),
    [anon_sym_BANG] = ACTIONS(6353),
    [anon_sym_PLUS] = ACTIONS(4772),
    [anon_sym_DASH] = ACTIONS(4772),
    [aux_sym__hex_literal_token1] = ACTIONS(4776),
    [sym__number_literal] = ACTIONS(4778),
    [anon_sym_SQUOTE] = ACTIONS(4780),
    [anon_sym_DQUOTE] = ACTIONS(4782),
    [sym_return] = ACTIONS(6355),
    [sym_next] = ACTIONS(6355),
    [sym_break] = ACTIONS(6355),
    [sym_true] = ACTIONS(6355),
    [sym_false] = ACTIONS(6355),
    [sym_null] = ACTIONS(6355),
    [sym_inf] = ACTIONS(6355),
    [sym_nan] = ACTIONS(6355),
    [anon_sym_NA] = ACTIONS(4786),
    [anon_sym_NA_integer_] = ACTIONS(4786),
    [anon_sym_NA_real_] = ACTIONS(4786),
    [anon_sym_NA_complex_] = ACTIONS(4786),
    [anon_sym_NA_character_] = ACTIONS(4786),
    [sym_dots] = ACTIONS(6357),
    [sym_dot_dot_i] = ACTIONS(6359),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6361),
    [sym__newline] = ACTIONS(6363),
    [sym__raw_string_literal] = ACTIONS(4790),
    [sym__external_open_parenthesis] = ACTIONS(4792),
    [sym__external_open_brace] = ACTIONS(4794),
    [sym__external_close_bracket] = ACTIONS(6853),
  },
  [1892] = {
    [sym_function_definition] = STATE(1940),
    [sym_if_statement] = STATE(1940),
    [sym_for_statement] = STATE(1940),
    [sym_while_statement] = STATE(1940),
    [sym_repeat_statement] = STATE(1940),
    [sym_braced_expression] = STATE(1940),
    [sym_parenthesized_expression] = STATE(1940),
    [sym_call] = STATE(1940),
    [sym_subset] = STATE(1940),
    [sym_subset2] = STATE(1940),
    [sym__argument] = STATE(4665),
    [sym_argument] = STATE(4661),
    [sym__argument_named] = STATE(4669),
    [sym__argument_unnamed] = STATE(4673),
    [sym__argument_value] = STATE(4679),
    [sym_unary_operator] = STATE(1940),
    [sym_binary_operator] = STATE(1940),
    [sym_extract_operator] = STATE(1940),
    [sym_namespace_operator] = STATE(1940),
    [sym_integer] = STATE(1940),
    [sym_complex] = STATE(1940),
    [sym_float] = STATE(1940),
    [sym__hex_literal] = STATE(2656),
    [sym__float_literal] = STATE(2656),
    [sym_string] = STATE(2606),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym_na] = STATE(1940),
    [sym__expression] = STATE(1940),
    [sym__string_or_identifier] = STATE(5141),
    [sym__open_parenthesis] = STATE(218),
    [sym__open_brace] = STATE(185),
    [sym__close_bracket2] = STATE(2993),
    [aux_sym_call_arguments_repeat1] = STATE(1912),
    [sym_identifier] = ACTIONS(6369),
    [anon_sym_BSLASH] = ACTIONS(4644),
    [anon_sym_function] = ACTIONS(4646),
    [anon_sym_if] = ACTIONS(4648),
    [anon_sym_for] = ACTIONS(4650),
    [anon_sym_while] = ACTIONS(4652),
    [anon_sym_repeat] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(6371),
    [anon_sym_PLUS] = ACTIONS(4662),
    [anon_sym_DASH] = ACTIONS(4662),
    [aux_sym__hex_literal_token1] = ACTIONS(4666),
    [sym__number_literal] = ACTIONS(4668),
    [anon_sym_SQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4672),
    [sym_return] = ACTIONS(6373),
    [sym_next] = ACTIONS(6373),
    [sym_break] = ACTIONS(6373),
    [sym_true] = ACTIONS(6373),
    [sym_false] = ACTIONS(6373),
    [sym_null] = ACTIONS(6373),
    [sym_inf] = ACTIONS(6373),
    [sym_nan] = ACTIONS(6373),
    [anon_sym_NA] = ACTIONS(4676),
    [anon_sym_NA_integer_] = ACTIONS(4676),
    [anon_sym_NA_real_] = ACTIONS(4676),
    [anon_sym_NA_complex_] = ACTIONS(4676),
    [anon_sym_NA_character_] = ACTIONS(4676),
    [sym_dots] = ACTIONS(6375),
    [sym_dot_dot_i] = ACTIONS(6377),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6379),
    [sym__newline] = ACTIONS(6381),
    [sym__raw_string_literal] = ACTIONS(4680),
    [sym__external_open_parenthesis] = ACTIONS(4682),
    [sym__external_open_brace] = ACTIONS(4684),
    [sym__external_close_bracket2] = ACTIONS(6855),
  },
  [1893] = {
    [sym_call_arguments] = STATE(2923),
    [sym_subset_arguments] = STATE(2922),
    [sym_subset2_arguments] = STATE(2906),
    [sym__open_parenthesis] = STATE(1528),
    [sym__open_bracket] = STATE(1525),
    [sym__open_bracket2] = STATE(1519),
    [ts_builtin_sym_end] = ACTIONS(5333),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(5333),
    [anon_sym_DASH] = ACTIONS(5335),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5335),
    [anon_sym_AMP] = ACTIONS(5335),
    [anon_sym_PIPE_PIPE] = ACTIONS(5333),
    [anon_sym_AMP_AMP] = ACTIONS(5333),
    [anon_sym_LT] = ACTIONS(5335),
    [anon_sym_LT_EQ] = ACTIONS(5333),
    [anon_sym_GT] = ACTIONS(5335),
    [anon_sym_GT_EQ] = ACTIONS(5333),
    [anon_sym_EQ_EQ] = ACTIONS(5333),
    [anon_sym_BANG_EQ] = ACTIONS(5333),
    [anon_sym_STAR] = ACTIONS(5335),
    [anon_sym_SLASH] = ACTIONS(5333),
    [anon_sym_STAR_STAR] = ACTIONS(5977),
    [anon_sym_CARET] = ACTIONS(5977),
    [aux_sym_binary_operator_token1] = ACTIONS(5333),
    [anon_sym_PIPE_GT] = ACTIONS(5333),
    [anon_sym_COLON] = ACTIONS(5335),
    [anon_sym_DOLLAR] = ACTIONS(5983),
    [anon_sym_AT] = ACTIONS(5983),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5333),
    [sym__semicolon] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_else] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(5987),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(5989),
    [sym__external_open_bracket2] = ACTIONS(5991),
  },
  [1894] = {
    [sym_function_definition] = STATE(2038),
    [sym_if_statement] = STATE(2038),
    [sym_for_statement] = STATE(2038),
    [sym_while_statement] = STATE(2038),
    [sym_repeat_statement] = STATE(2038),
    [sym_braced_expression] = STATE(2038),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_call] = STATE(2038),
    [sym_subset] = STATE(2038),
    [sym_subset2] = STATE(2038),
    [sym__argument] = STATE(4664),
    [sym_argument] = STATE(4659),
    [sym__argument_named] = STATE(4654),
    [sym__argument_unnamed] = STATE(4676),
    [sym__argument_value] = STATE(4677),
    [sym_unary_operator] = STATE(2038),
    [sym_binary_operator] = STATE(2038),
    [sym_extract_operator] = STATE(2038),
    [sym_namespace_operator] = STATE(2038),
    [sym_integer] = STATE(2038),
    [sym_complex] = STATE(2038),
    [sym_float] = STATE(2038),
    [sym__hex_literal] = STATE(2700),
    [sym__float_literal] = STATE(2700),
    [sym_string] = STATE(2597),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym_na] = STATE(2038),
    [sym__expression] = STATE(2038),
    [sym__string_or_identifier] = STATE(5148),
    [sym__open_parenthesis] = STATE(214),
    [sym__open_brace] = STATE(192),
    [sym__close_bracket] = STATE(2994),
    [aux_sym_call_arguments_repeat1] = STATE(2034),
    [sym_identifier] = ACTIONS(6351),
    [anon_sym_BSLASH] = ACTIONS(4754),
    [anon_sym_function] = ACTIONS(4756),
    [anon_sym_if] = ACTIONS(4758),
    [anon_sym_for] = ACTIONS(4760),
    [anon_sym_while] = ACTIONS(4762),
    [anon_sym_repeat] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4766),
    [anon_sym_TILDE] = ACTIONS(4768),
    [anon_sym_BANG] = ACTIONS(6353),
    [anon_sym_PLUS] = ACTIONS(4772),
    [anon_sym_DASH] = ACTIONS(4772),
    [aux_sym__hex_literal_token1] = ACTIONS(4776),
    [sym__number_literal] = ACTIONS(4778),
    [anon_sym_SQUOTE] = ACTIONS(4780),
    [anon_sym_DQUOTE] = ACTIONS(4782),
    [sym_return] = ACTIONS(6355),
    [sym_next] = ACTIONS(6355),
    [sym_break] = ACTIONS(6355),
    [sym_true] = ACTIONS(6355),
    [sym_false] = ACTIONS(6355),
    [sym_null] = ACTIONS(6355),
    [sym_inf] = ACTIONS(6355),
    [sym_nan] = ACTIONS(6355),
    [anon_sym_NA] = ACTIONS(4786),
    [anon_sym_NA_integer_] = ACTIONS(4786),
    [anon_sym_NA_real_] = ACTIONS(4786),
    [anon_sym_NA_complex_] = ACTIONS(4786),
    [anon_sym_NA_character_] = ACTIONS(4786),
    [sym_dots] = ACTIONS(6357),
    [sym_dot_dot_i] = ACTIONS(6359),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6361),
    [sym__newline] = ACTIONS(6363),
    [sym__raw_string_literal] = ACTIONS(4790),
    [sym__external_open_parenthesis] = ACTIONS(4792),
    [sym__external_open_brace] = ACTIONS(4794),
    [sym__external_close_bracket] = ACTIONS(6857),
  },
  [1895] = {
    [sym_function_definition] = STATE(1940),
    [sym_if_statement] = STATE(1940),
    [sym_for_statement] = STATE(1940),
    [sym_while_statement] = STATE(1940),
    [sym_repeat_statement] = STATE(1940),
    [sym_braced_expression] = STATE(1940),
    [sym_parenthesized_expression] = STATE(1940),
    [sym_call] = STATE(1940),
    [sym_subset] = STATE(1940),
    [sym_subset2] = STATE(1940),
    [sym__argument] = STATE(4665),
    [sym_argument] = STATE(4661),
    [sym__argument_named] = STATE(4669),
    [sym__argument_unnamed] = STATE(4673),
    [sym__argument_value] = STATE(4679),
    [sym_unary_operator] = STATE(1940),
    [sym_binary_operator] = STATE(1940),
    [sym_extract_operator] = STATE(1940),
    [sym_namespace_operator] = STATE(1940),
    [sym_integer] = STATE(1940),
    [sym_complex] = STATE(1940),
    [sym_float] = STATE(1940),
    [sym__hex_literal] = STATE(2656),
    [sym__float_literal] = STATE(2656),
    [sym_string] = STATE(2606),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym_na] = STATE(1940),
    [sym__expression] = STATE(1940),
    [sym__string_or_identifier] = STATE(5141),
    [sym__open_parenthesis] = STATE(218),
    [sym__open_brace] = STATE(185),
    [sym__close_bracket2] = STATE(2989),
    [aux_sym_call_arguments_repeat1] = STATE(1912),
    [sym_identifier] = ACTIONS(6369),
    [anon_sym_BSLASH] = ACTIONS(4644),
    [anon_sym_function] = ACTIONS(4646),
    [anon_sym_if] = ACTIONS(4648),
    [anon_sym_for] = ACTIONS(4650),
    [anon_sym_while] = ACTIONS(4652),
    [anon_sym_repeat] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(6371),
    [anon_sym_PLUS] = ACTIONS(4662),
    [anon_sym_DASH] = ACTIONS(4662),
    [aux_sym__hex_literal_token1] = ACTIONS(4666),
    [sym__number_literal] = ACTIONS(4668),
    [anon_sym_SQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4672),
    [sym_return] = ACTIONS(6373),
    [sym_next] = ACTIONS(6373),
    [sym_break] = ACTIONS(6373),
    [sym_true] = ACTIONS(6373),
    [sym_false] = ACTIONS(6373),
    [sym_null] = ACTIONS(6373),
    [sym_inf] = ACTIONS(6373),
    [sym_nan] = ACTIONS(6373),
    [anon_sym_NA] = ACTIONS(4676),
    [anon_sym_NA_integer_] = ACTIONS(4676),
    [anon_sym_NA_real_] = ACTIONS(4676),
    [anon_sym_NA_complex_] = ACTIONS(4676),
    [anon_sym_NA_character_] = ACTIONS(4676),
    [sym_dots] = ACTIONS(6375),
    [sym_dot_dot_i] = ACTIONS(6377),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6379),
    [sym__newline] = ACTIONS(6381),
    [sym__raw_string_literal] = ACTIONS(4680),
    [sym__external_open_parenthesis] = ACTIONS(4682),
    [sym__external_open_brace] = ACTIONS(4684),
    [sym__external_close_bracket2] = ACTIONS(6859),
  },
  [1896] = {
    [sym_call_arguments] = STATE(2923),
    [sym_subset_arguments] = STATE(2922),
    [sym_subset2_arguments] = STATE(2906),
    [sym__open_parenthesis] = STATE(1528),
    [sym__open_bracket] = STATE(1525),
    [sym__open_bracket2] = STATE(1519),
    [ts_builtin_sym_end] = ACTIONS(5333),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(5951),
    [anon_sym_DASH] = ACTIONS(5953),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5335),
    [anon_sym_AMP] = ACTIONS(5335),
    [anon_sym_PIPE_PIPE] = ACTIONS(5333),
    [anon_sym_AMP_AMP] = ACTIONS(5333),
    [anon_sym_LT] = ACTIONS(5969),
    [anon_sym_LT_EQ] = ACTIONS(5971),
    [anon_sym_GT] = ACTIONS(5969),
    [anon_sym_GT_EQ] = ACTIONS(5971),
    [anon_sym_EQ_EQ] = ACTIONS(5971),
    [anon_sym_BANG_EQ] = ACTIONS(5971),
    [anon_sym_STAR] = ACTIONS(5973),
    [anon_sym_SLASH] = ACTIONS(5975),
    [anon_sym_STAR_STAR] = ACTIONS(5977),
    [anon_sym_CARET] = ACTIONS(5977),
    [aux_sym_binary_operator_token1] = ACTIONS(5979),
    [anon_sym_PIPE_GT] = ACTIONS(5979),
    [anon_sym_COLON] = ACTIONS(5981),
    [anon_sym_DOLLAR] = ACTIONS(5983),
    [anon_sym_AT] = ACTIONS(5983),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5333),
    [sym__semicolon] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_else] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(5987),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(5989),
    [sym__external_open_bracket2] = ACTIONS(5991),
  },
  [1897] = {
    [sym_call_arguments] = STATE(2923),
    [sym_subset_arguments] = STATE(2922),
    [sym_subset2_arguments] = STATE(2906),
    [sym__open_parenthesis] = STATE(1528),
    [sym__open_bracket] = STATE(1525),
    [sym__open_bracket2] = STATE(1519),
    [ts_builtin_sym_end] = ACTIONS(5333),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(5951),
    [anon_sym_DASH] = ACTIONS(5953),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5961),
    [anon_sym_AMP] = ACTIONS(5963),
    [anon_sym_PIPE_PIPE] = ACTIONS(5965),
    [anon_sym_AMP_AMP] = ACTIONS(5967),
    [anon_sym_LT] = ACTIONS(5969),
    [anon_sym_LT_EQ] = ACTIONS(5971),
    [anon_sym_GT] = ACTIONS(5969),
    [anon_sym_GT_EQ] = ACTIONS(5971),
    [anon_sym_EQ_EQ] = ACTIONS(5971),
    [anon_sym_BANG_EQ] = ACTIONS(5971),
    [anon_sym_STAR] = ACTIONS(5973),
    [anon_sym_SLASH] = ACTIONS(5975),
    [anon_sym_STAR_STAR] = ACTIONS(5977),
    [anon_sym_CARET] = ACTIONS(5977),
    [aux_sym_binary_operator_token1] = ACTIONS(5979),
    [anon_sym_PIPE_GT] = ACTIONS(5979),
    [anon_sym_COLON] = ACTIONS(5981),
    [anon_sym_DOLLAR] = ACTIONS(5983),
    [anon_sym_AT] = ACTIONS(5983),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5333),
    [sym__semicolon] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_else] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(5987),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(5989),
    [sym__external_open_bracket2] = ACTIONS(5991),
  },
  [1898] = {
    [sym_function_definition] = STATE(1931),
    [sym_if_statement] = STATE(1931),
    [sym_for_statement] = STATE(1931),
    [sym_while_statement] = STATE(1931),
    [sym_repeat_statement] = STATE(1931),
    [sym_braced_expression] = STATE(1931),
    [sym_parenthesized_expression] = STATE(1931),
    [sym_call] = STATE(1931),
    [sym_subset] = STATE(1931),
    [sym_subset2] = STATE(1931),
    [sym__argument] = STATE(4656),
    [sym_argument] = STATE(4657),
    [sym__argument_named] = STATE(4658),
    [sym__argument_unnamed] = STATE(4662),
    [sym__argument_value] = STATE(4663),
    [sym_unary_operator] = STATE(1931),
    [sym_binary_operator] = STATE(1931),
    [sym_extract_operator] = STATE(1931),
    [sym_namespace_operator] = STATE(1931),
    [sym_integer] = STATE(1931),
    [sym_complex] = STATE(1931),
    [sym_float] = STATE(1931),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2633),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(1931),
    [sym__expression] = STATE(1931),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__close_parenthesis] = STATE(2996),
    [sym__open_brace] = STATE(154),
    [aux_sym_call_arguments_repeat1] = STATE(2113),
    [sym_identifier] = ACTIONS(6387),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(6389),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3865),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(6391),
    [sym_next] = ACTIONS(6391),
    [sym_break] = ACTIONS(6391),
    [sym_true] = ACTIONS(6391),
    [sym_false] = ACTIONS(6391),
    [sym_null] = ACTIONS(6391),
    [sym_inf] = ACTIONS(6391),
    [sym_nan] = ACTIONS(6391),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(6393),
    [sym_dot_dot_i] = ACTIONS(6395),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6397),
    [sym__newline] = ACTIONS(6399),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(6861),
    [sym__external_open_brace] = ACTIONS(3891),
  },
  [1899] = {
    [sym_call_arguments] = STATE(2923),
    [sym_subset_arguments] = STATE(2922),
    [sym_subset2_arguments] = STATE(2906),
    [sym__open_parenthesis] = STATE(1528),
    [sym__open_bracket] = STATE(1525),
    [sym__open_bracket2] = STATE(1519),
    [ts_builtin_sym_end] = ACTIONS(5333),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5947),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5949),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(5951),
    [anon_sym_DASH] = ACTIONS(5953),
    [anon_sym_LT_DASH] = ACTIONS(5955),
    [anon_sym_LT_LT_DASH] = ACTIONS(5955),
    [anon_sym_COLON_EQ] = ACTIONS(5955),
    [anon_sym_DASH_GT] = ACTIONS(5957),
    [anon_sym_DASH_GT_GT] = ACTIONS(5959),
    [anon_sym_PIPE] = ACTIONS(5961),
    [anon_sym_AMP] = ACTIONS(5963),
    [anon_sym_PIPE_PIPE] = ACTIONS(5965),
    [anon_sym_AMP_AMP] = ACTIONS(5967),
    [anon_sym_LT] = ACTIONS(5969),
    [anon_sym_LT_EQ] = ACTIONS(5971),
    [anon_sym_GT] = ACTIONS(5969),
    [anon_sym_GT_EQ] = ACTIONS(5971),
    [anon_sym_EQ_EQ] = ACTIONS(5971),
    [anon_sym_BANG_EQ] = ACTIONS(5971),
    [anon_sym_STAR] = ACTIONS(5973),
    [anon_sym_SLASH] = ACTIONS(5975),
    [anon_sym_STAR_STAR] = ACTIONS(5977),
    [anon_sym_CARET] = ACTIONS(5977),
    [aux_sym_binary_operator_token1] = ACTIONS(5979),
    [anon_sym_PIPE_GT] = ACTIONS(5979),
    [anon_sym_COLON] = ACTIONS(5981),
    [anon_sym_DOLLAR] = ACTIONS(5983),
    [anon_sym_AT] = ACTIONS(5983),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5333),
    [sym__semicolon] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_else] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(5987),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(5989),
    [sym__external_open_bracket2] = ACTIONS(5991),
  },
  [1900] = {
    [sym_call_arguments] = STATE(2840),
    [sym_subset_arguments] = STATE(2797),
    [sym_subset2_arguments] = STATE(2801),
    [sym__open_parenthesis] = STATE(1344),
    [sym__open_bracket] = STATE(1374),
    [sym__open_bracket2] = STATE(1452),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(6293),
    [anon_sym_CARET] = ACTIONS(6293),
    [aux_sym_binary_operator_token1] = ACTIONS(6295),
    [anon_sym_PIPE_GT] = ACTIONS(6295),
    [anon_sym_COLON] = ACTIONS(6297),
    [anon_sym_DOLLAR] = ACTIONS(6299),
    [anon_sym_AT] = ACTIONS(6299),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6301),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6303),
    [sym__external_open_bracket2] = ACTIONS(6305),
  },
  [1901] = {
    [sym_string] = STATE(2608),
    [sym__single_quoted_string] = STATE(2310),
    [sym__double_quoted_string] = STATE(2309),
    [sym__string_or_identifier] = STATE(2608),
    [aux_sym_function_definition_repeat1] = STATE(2399),
    [ts_builtin_sym_end] = ACTIONS(5669),
    [sym_identifier] = ACTIONS(6863),
    [anon_sym_BSLASH] = ACTIONS(5669),
    [anon_sym_function] = ACTIONS(5673),
    [anon_sym_EQ] = ACTIONS(5673),
    [anon_sym_if] = ACTIONS(5673),
    [anon_sym_for] = ACTIONS(5673),
    [anon_sym_while] = ACTIONS(5673),
    [anon_sym_repeat] = ACTIONS(5673),
    [anon_sym_QMARK] = ACTIONS(5669),
    [anon_sym_TILDE] = ACTIONS(5669),
    [anon_sym_BANG] = ACTIONS(5673),
    [anon_sym_PLUS] = ACTIONS(5669),
    [anon_sym_DASH] = ACTIONS(5673),
    [anon_sym_LT_DASH] = ACTIONS(5669),
    [anon_sym_LT_LT_DASH] = ACTIONS(5669),
    [anon_sym_COLON_EQ] = ACTIONS(5669),
    [anon_sym_DASH_GT] = ACTIONS(5673),
    [anon_sym_DASH_GT_GT] = ACTIONS(5669),
    [anon_sym_PIPE] = ACTIONS(5673),
    [anon_sym_AMP] = ACTIONS(5673),
    [anon_sym_PIPE_PIPE] = ACTIONS(5669),
    [anon_sym_AMP_AMP] = ACTIONS(5669),
    [anon_sym_LT] = ACTIONS(5673),
    [anon_sym_LT_EQ] = ACTIONS(5669),
    [anon_sym_GT] = ACTIONS(5673),
    [anon_sym_GT_EQ] = ACTIONS(5669),
    [anon_sym_EQ_EQ] = ACTIONS(5669),
    [anon_sym_BANG_EQ] = ACTIONS(5669),
    [anon_sym_STAR] = ACTIONS(5673),
    [anon_sym_SLASH] = ACTIONS(5669),
    [anon_sym_STAR_STAR] = ACTIONS(5669),
    [anon_sym_CARET] = ACTIONS(5669),
    [aux_sym_binary_operator_token1] = ACTIONS(5669),
    [anon_sym_PIPE_GT] = ACTIONS(5669),
    [anon_sym_COLON] = ACTIONS(5673),
    [anon_sym_DOLLAR] = ACTIONS(5669),
    [anon_sym_AT] = ACTIONS(5669),
    [aux_sym__hex_literal_token1] = ACTIONS(5669),
    [sym__number_literal] = ACTIONS(5673),
    [anon_sym_SQUOTE] = ACTIONS(1413),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [sym_return] = ACTIONS(5673),
    [sym_next] = ACTIONS(5673),
    [sym_break] = ACTIONS(5673),
    [sym_true] = ACTIONS(5673),
    [sym_false] = ACTIONS(5673),
    [sym_null] = ACTIONS(5673),
    [sym_inf] = ACTIONS(5673),
    [sym_nan] = ACTIONS(5673),
    [anon_sym_NA] = ACTIONS(5673),
    [anon_sym_NA_integer_] = ACTIONS(5673),
    [anon_sym_NA_real_] = ACTIONS(5673),
    [anon_sym_NA_complex_] = ACTIONS(5673),
    [anon_sym_NA_character_] = ACTIONS(5673),
    [sym_dots] = ACTIONS(5673),
    [sym_dot_dot_i] = ACTIONS(5669),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5669),
    [sym__semicolon] = ACTIONS(5669),
    [sym__raw_string_literal] = ACTIONS(1425),
    [sym__external_else] = ACTIONS(5669),
    [sym__external_open_parenthesis] = ACTIONS(5669),
    [sym__external_open_brace] = ACTIONS(5669),
    [sym__external_close_brace] = ACTIONS(5669),
    [sym__external_open_bracket] = ACTIONS(5669),
    [sym__external_open_bracket2] = ACTIONS(5669),
  },
  [1902] = {
    [sym_call_arguments] = STATE(2923),
    [sym_subset_arguments] = STATE(2922),
    [sym_subset2_arguments] = STATE(2906),
    [sym__open_parenthesis] = STATE(1528),
    [sym__open_bracket] = STATE(1525),
    [sym__open_bracket2] = STATE(1519),
    [ts_builtin_sym_end] = ACTIONS(5329),
    [sym_identifier] = ACTIONS(5331),
    [anon_sym_BSLASH] = ACTIONS(5329),
    [anon_sym_function] = ACTIONS(5331),
    [anon_sym_EQ] = ACTIONS(5947),
    [anon_sym_if] = ACTIONS(5331),
    [anon_sym_for] = ACTIONS(5331),
    [anon_sym_while] = ACTIONS(5331),
    [anon_sym_repeat] = ACTIONS(5331),
    [anon_sym_QMARK] = ACTIONS(5329),
    [anon_sym_TILDE] = ACTIONS(5949),
    [anon_sym_BANG] = ACTIONS(5331),
    [anon_sym_PLUS] = ACTIONS(5951),
    [anon_sym_DASH] = ACTIONS(5953),
    [anon_sym_LT_DASH] = ACTIONS(5955),
    [anon_sym_LT_LT_DASH] = ACTIONS(5955),
    [anon_sym_COLON_EQ] = ACTIONS(5955),
    [anon_sym_DASH_GT] = ACTIONS(5957),
    [anon_sym_DASH_GT_GT] = ACTIONS(5959),
    [anon_sym_PIPE] = ACTIONS(5961),
    [anon_sym_AMP] = ACTIONS(5963),
    [anon_sym_PIPE_PIPE] = ACTIONS(5965),
    [anon_sym_AMP_AMP] = ACTIONS(5967),
    [anon_sym_LT] = ACTIONS(5969),
    [anon_sym_LT_EQ] = ACTIONS(5971),
    [anon_sym_GT] = ACTIONS(5969),
    [anon_sym_GT_EQ] = ACTIONS(5971),
    [anon_sym_EQ_EQ] = ACTIONS(5971),
    [anon_sym_BANG_EQ] = ACTIONS(5971),
    [anon_sym_STAR] = ACTIONS(5973),
    [anon_sym_SLASH] = ACTIONS(5975),
    [anon_sym_STAR_STAR] = ACTIONS(5977),
    [anon_sym_CARET] = ACTIONS(5977),
    [aux_sym_binary_operator_token1] = ACTIONS(5979),
    [anon_sym_PIPE_GT] = ACTIONS(5979),
    [anon_sym_COLON] = ACTIONS(5981),
    [anon_sym_DOLLAR] = ACTIONS(5983),
    [anon_sym_AT] = ACTIONS(5983),
    [aux_sym__hex_literal_token1] = ACTIONS(5329),
    [sym__number_literal] = ACTIONS(5331),
    [anon_sym_SQUOTE] = ACTIONS(5329),
    [anon_sym_DQUOTE] = ACTIONS(5329),
    [sym_return] = ACTIONS(5331),
    [sym_next] = ACTIONS(5331),
    [sym_break] = ACTIONS(5331),
    [sym_true] = ACTIONS(5331),
    [sym_false] = ACTIONS(5331),
    [sym_null] = ACTIONS(5331),
    [sym_inf] = ACTIONS(5331),
    [sym_nan] = ACTIONS(5331),
    [anon_sym_NA] = ACTIONS(5331),
    [anon_sym_NA_integer_] = ACTIONS(5331),
    [anon_sym_NA_real_] = ACTIONS(5331),
    [anon_sym_NA_complex_] = ACTIONS(5331),
    [anon_sym_NA_character_] = ACTIONS(5331),
    [sym_dots] = ACTIONS(5331),
    [sym_dot_dot_i] = ACTIONS(5329),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5329),
    [sym__semicolon] = ACTIONS(5329),
    [sym__raw_string_literal] = ACTIONS(5329),
    [sym__external_else] = ACTIONS(5329),
    [sym__external_open_parenthesis] = ACTIONS(5987),
    [sym__external_open_brace] = ACTIONS(5329),
    [sym__external_open_bracket] = ACTIONS(5989),
    [sym__external_open_bracket2] = ACTIONS(5991),
  },
  [1903] = {
    [sym_call_arguments] = STATE(2840),
    [sym_subset_arguments] = STATE(2797),
    [sym_subset2_arguments] = STATE(2801),
    [sym__open_parenthesis] = STATE(1344),
    [sym__open_bracket] = STATE(1374),
    [sym__open_bracket2] = STATE(1452),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(6293),
    [anon_sym_CARET] = ACTIONS(6293),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(5351),
    [anon_sym_DOLLAR] = ACTIONS(6299),
    [anon_sym_AT] = ACTIONS(6299),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6301),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_close_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6303),
    [sym__external_open_bracket2] = ACTIONS(6305),
  },
  [1904] = {
    [sym_function_definition] = STATE(2038),
    [sym_if_statement] = STATE(2038),
    [sym_for_statement] = STATE(2038),
    [sym_while_statement] = STATE(2038),
    [sym_repeat_statement] = STATE(2038),
    [sym_braced_expression] = STATE(2038),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_call] = STATE(2038),
    [sym_subset] = STATE(2038),
    [sym_subset2] = STATE(2038),
    [sym__argument] = STATE(4664),
    [sym_argument] = STATE(4659),
    [sym__argument_named] = STATE(4654),
    [sym__argument_unnamed] = STATE(4676),
    [sym__argument_value] = STATE(4677),
    [sym_unary_operator] = STATE(2038),
    [sym_binary_operator] = STATE(2038),
    [sym_extract_operator] = STATE(2038),
    [sym_namespace_operator] = STATE(2038),
    [sym_integer] = STATE(2038),
    [sym_complex] = STATE(2038),
    [sym_float] = STATE(2038),
    [sym__hex_literal] = STATE(2700),
    [sym__float_literal] = STATE(2700),
    [sym_string] = STATE(2597),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym_na] = STATE(2038),
    [sym__expression] = STATE(2038),
    [sym__string_or_identifier] = STATE(5148),
    [sym__open_parenthesis] = STATE(214),
    [sym__open_brace] = STATE(192),
    [sym__close_bracket] = STATE(2610),
    [aux_sym_call_arguments_repeat1] = STATE(2034),
    [sym_identifier] = ACTIONS(6351),
    [anon_sym_BSLASH] = ACTIONS(4754),
    [anon_sym_function] = ACTIONS(4756),
    [anon_sym_if] = ACTIONS(4758),
    [anon_sym_for] = ACTIONS(4760),
    [anon_sym_while] = ACTIONS(4762),
    [anon_sym_repeat] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4766),
    [anon_sym_TILDE] = ACTIONS(4768),
    [anon_sym_BANG] = ACTIONS(6353),
    [anon_sym_PLUS] = ACTIONS(4772),
    [anon_sym_DASH] = ACTIONS(4772),
    [aux_sym__hex_literal_token1] = ACTIONS(4776),
    [sym__number_literal] = ACTIONS(4778),
    [anon_sym_SQUOTE] = ACTIONS(4780),
    [anon_sym_DQUOTE] = ACTIONS(4782),
    [sym_return] = ACTIONS(6355),
    [sym_next] = ACTIONS(6355),
    [sym_break] = ACTIONS(6355),
    [sym_true] = ACTIONS(6355),
    [sym_false] = ACTIONS(6355),
    [sym_null] = ACTIONS(6355),
    [sym_inf] = ACTIONS(6355),
    [sym_nan] = ACTIONS(6355),
    [anon_sym_NA] = ACTIONS(4786),
    [anon_sym_NA_integer_] = ACTIONS(4786),
    [anon_sym_NA_real_] = ACTIONS(4786),
    [anon_sym_NA_complex_] = ACTIONS(4786),
    [anon_sym_NA_character_] = ACTIONS(4786),
    [sym_dots] = ACTIONS(6357),
    [sym_dot_dot_i] = ACTIONS(6359),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6361),
    [sym__newline] = ACTIONS(6363),
    [sym__raw_string_literal] = ACTIONS(4790),
    [sym__external_open_parenthesis] = ACTIONS(4792),
    [sym__external_open_brace] = ACTIONS(4794),
    [sym__external_close_bracket] = ACTIONS(6865),
  },
  [1905] = {
    [sym_function_definition] = STATE(1940),
    [sym_if_statement] = STATE(1940),
    [sym_for_statement] = STATE(1940),
    [sym_while_statement] = STATE(1940),
    [sym_repeat_statement] = STATE(1940),
    [sym_braced_expression] = STATE(1940),
    [sym_parenthesized_expression] = STATE(1940),
    [sym_call] = STATE(1940),
    [sym_subset] = STATE(1940),
    [sym_subset2] = STATE(1940),
    [sym__argument] = STATE(4665),
    [sym_argument] = STATE(4661),
    [sym__argument_named] = STATE(4669),
    [sym__argument_unnamed] = STATE(4673),
    [sym__argument_value] = STATE(4679),
    [sym_unary_operator] = STATE(1940),
    [sym_binary_operator] = STATE(1940),
    [sym_extract_operator] = STATE(1940),
    [sym_namespace_operator] = STATE(1940),
    [sym_integer] = STATE(1940),
    [sym_complex] = STATE(1940),
    [sym_float] = STATE(1940),
    [sym__hex_literal] = STATE(2656),
    [sym__float_literal] = STATE(2656),
    [sym_string] = STATE(2606),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym_na] = STATE(1940),
    [sym__expression] = STATE(1940),
    [sym__string_or_identifier] = STATE(5141),
    [sym__open_parenthesis] = STATE(218),
    [sym__open_brace] = STATE(185),
    [sym__close_bracket2] = STATE(2611),
    [aux_sym_call_arguments_repeat1] = STATE(1912),
    [sym_identifier] = ACTIONS(6369),
    [anon_sym_BSLASH] = ACTIONS(4644),
    [anon_sym_function] = ACTIONS(4646),
    [anon_sym_if] = ACTIONS(4648),
    [anon_sym_for] = ACTIONS(4650),
    [anon_sym_while] = ACTIONS(4652),
    [anon_sym_repeat] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(6371),
    [anon_sym_PLUS] = ACTIONS(4662),
    [anon_sym_DASH] = ACTIONS(4662),
    [aux_sym__hex_literal_token1] = ACTIONS(4666),
    [sym__number_literal] = ACTIONS(4668),
    [anon_sym_SQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4672),
    [sym_return] = ACTIONS(6373),
    [sym_next] = ACTIONS(6373),
    [sym_break] = ACTIONS(6373),
    [sym_true] = ACTIONS(6373),
    [sym_false] = ACTIONS(6373),
    [sym_null] = ACTIONS(6373),
    [sym_inf] = ACTIONS(6373),
    [sym_nan] = ACTIONS(6373),
    [anon_sym_NA] = ACTIONS(4676),
    [anon_sym_NA_integer_] = ACTIONS(4676),
    [anon_sym_NA_real_] = ACTIONS(4676),
    [anon_sym_NA_complex_] = ACTIONS(4676),
    [anon_sym_NA_character_] = ACTIONS(4676),
    [sym_dots] = ACTIONS(6375),
    [sym_dot_dot_i] = ACTIONS(6377),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6379),
    [sym__newline] = ACTIONS(6381),
    [sym__raw_string_literal] = ACTIONS(4680),
    [sym__external_open_parenthesis] = ACTIONS(4682),
    [sym__external_open_brace] = ACTIONS(4684),
    [sym__external_close_bracket2] = ACTIONS(6867),
  },
  [1906] = {
    [sym_function_definition] = STATE(1940),
    [sym_if_statement] = STATE(1940),
    [sym_for_statement] = STATE(1940),
    [sym_while_statement] = STATE(1940),
    [sym_repeat_statement] = STATE(1940),
    [sym_braced_expression] = STATE(1940),
    [sym_parenthesized_expression] = STATE(1940),
    [sym_call] = STATE(1940),
    [sym_subset] = STATE(1940),
    [sym_subset2] = STATE(1940),
    [sym__argument] = STATE(4665),
    [sym_argument] = STATE(4661),
    [sym__argument_named] = STATE(4669),
    [sym__argument_unnamed] = STATE(4673),
    [sym__argument_value] = STATE(4679),
    [sym_unary_operator] = STATE(1940),
    [sym_binary_operator] = STATE(1940),
    [sym_extract_operator] = STATE(1940),
    [sym_namespace_operator] = STATE(1940),
    [sym_integer] = STATE(1940),
    [sym_complex] = STATE(1940),
    [sym_float] = STATE(1940),
    [sym__hex_literal] = STATE(2656),
    [sym__float_literal] = STATE(2656),
    [sym_string] = STATE(2606),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym_na] = STATE(1940),
    [sym__expression] = STATE(1940),
    [sym__string_or_identifier] = STATE(5141),
    [sym__open_parenthesis] = STATE(218),
    [sym__open_brace] = STATE(185),
    [sym__close_bracket2] = STATE(2496),
    [aux_sym_call_arguments_repeat1] = STATE(1912),
    [sym_identifier] = ACTIONS(6369),
    [anon_sym_BSLASH] = ACTIONS(4644),
    [anon_sym_function] = ACTIONS(4646),
    [anon_sym_if] = ACTIONS(4648),
    [anon_sym_for] = ACTIONS(4650),
    [anon_sym_while] = ACTIONS(4652),
    [anon_sym_repeat] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(6371),
    [anon_sym_PLUS] = ACTIONS(4662),
    [anon_sym_DASH] = ACTIONS(4662),
    [aux_sym__hex_literal_token1] = ACTIONS(4666),
    [sym__number_literal] = ACTIONS(4668),
    [anon_sym_SQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4672),
    [sym_return] = ACTIONS(6373),
    [sym_next] = ACTIONS(6373),
    [sym_break] = ACTIONS(6373),
    [sym_true] = ACTIONS(6373),
    [sym_false] = ACTIONS(6373),
    [sym_null] = ACTIONS(6373),
    [sym_inf] = ACTIONS(6373),
    [sym_nan] = ACTIONS(6373),
    [anon_sym_NA] = ACTIONS(4676),
    [anon_sym_NA_integer_] = ACTIONS(4676),
    [anon_sym_NA_real_] = ACTIONS(4676),
    [anon_sym_NA_complex_] = ACTIONS(4676),
    [anon_sym_NA_character_] = ACTIONS(4676),
    [sym_dots] = ACTIONS(6375),
    [sym_dot_dot_i] = ACTIONS(6377),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6379),
    [sym__newline] = ACTIONS(6381),
    [sym__raw_string_literal] = ACTIONS(4680),
    [sym__external_open_parenthesis] = ACTIONS(4682),
    [sym__external_open_brace] = ACTIONS(4684),
    [sym__external_close_bracket2] = ACTIONS(6869),
  },
  [1907] = {
    [sym_call_arguments] = STATE(2840),
    [sym_subset_arguments] = STATE(2797),
    [sym_subset2_arguments] = STATE(2801),
    [sym__open_parenthesis] = STATE(1344),
    [sym__open_bracket] = STATE(1374),
    [sym__open_bracket2] = STATE(1452),
    [ts_builtin_sym_end] = ACTIONS(5329),
    [sym_identifier] = ACTIONS(5331),
    [anon_sym_BSLASH] = ACTIONS(5329),
    [anon_sym_function] = ACTIONS(5331),
    [anon_sym_EQ] = ACTIONS(6263),
    [anon_sym_if] = ACTIONS(5331),
    [anon_sym_for] = ACTIONS(5331),
    [anon_sym_while] = ACTIONS(5331),
    [anon_sym_repeat] = ACTIONS(5331),
    [anon_sym_QMARK] = ACTIONS(5329),
    [anon_sym_TILDE] = ACTIONS(6265),
    [anon_sym_BANG] = ACTIONS(5331),
    [anon_sym_PLUS] = ACTIONS(6267),
    [anon_sym_DASH] = ACTIONS(6269),
    [anon_sym_LT_DASH] = ACTIONS(6271),
    [anon_sym_LT_LT_DASH] = ACTIONS(6271),
    [anon_sym_COLON_EQ] = ACTIONS(6271),
    [anon_sym_DASH_GT] = ACTIONS(6273),
    [anon_sym_DASH_GT_GT] = ACTIONS(6275),
    [anon_sym_PIPE] = ACTIONS(6277),
    [anon_sym_AMP] = ACTIONS(6279),
    [anon_sym_PIPE_PIPE] = ACTIONS(6281),
    [anon_sym_AMP_AMP] = ACTIONS(6283),
    [anon_sym_LT] = ACTIONS(6285),
    [anon_sym_LT_EQ] = ACTIONS(6287),
    [anon_sym_GT] = ACTIONS(6285),
    [anon_sym_GT_EQ] = ACTIONS(6287),
    [anon_sym_EQ_EQ] = ACTIONS(6287),
    [anon_sym_BANG_EQ] = ACTIONS(6287),
    [anon_sym_STAR] = ACTIONS(6289),
    [anon_sym_SLASH] = ACTIONS(6291),
    [anon_sym_STAR_STAR] = ACTIONS(6293),
    [anon_sym_CARET] = ACTIONS(6293),
    [aux_sym_binary_operator_token1] = ACTIONS(6295),
    [anon_sym_PIPE_GT] = ACTIONS(6295),
    [anon_sym_COLON] = ACTIONS(6297),
    [anon_sym_DOLLAR] = ACTIONS(6299),
    [anon_sym_AT] = ACTIONS(6299),
    [aux_sym__hex_literal_token1] = ACTIONS(5329),
    [sym__number_literal] = ACTIONS(5331),
    [anon_sym_SQUOTE] = ACTIONS(5329),
    [anon_sym_DQUOTE] = ACTIONS(5329),
    [sym_return] = ACTIONS(5331),
    [sym_next] = ACTIONS(5331),
    [sym_break] = ACTIONS(5331),
    [sym_true] = ACTIONS(5331),
    [sym_false] = ACTIONS(5331),
    [sym_null] = ACTIONS(5331),
    [sym_inf] = ACTIONS(5331),
    [sym_nan] = ACTIONS(5331),
    [anon_sym_NA] = ACTIONS(5331),
    [anon_sym_NA_integer_] = ACTIONS(5331),
    [anon_sym_NA_real_] = ACTIONS(5331),
    [anon_sym_NA_complex_] = ACTIONS(5331),
    [anon_sym_NA_character_] = ACTIONS(5331),
    [sym_dots] = ACTIONS(5331),
    [sym_dot_dot_i] = ACTIONS(5329),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5329),
    [sym__semicolon] = ACTIONS(5329),
    [sym__raw_string_literal] = ACTIONS(5329),
    [sym__external_open_parenthesis] = ACTIONS(6301),
    [sym__external_open_brace] = ACTIONS(5329),
    [sym__external_close_brace] = ACTIONS(5329),
    [sym__external_open_bracket] = ACTIONS(6303),
    [sym__external_open_bracket2] = ACTIONS(6305),
  },
  [1908] = {
    [sym_function_definition] = STATE(2038),
    [sym_if_statement] = STATE(2038),
    [sym_for_statement] = STATE(2038),
    [sym_while_statement] = STATE(2038),
    [sym_repeat_statement] = STATE(2038),
    [sym_braced_expression] = STATE(2038),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_call] = STATE(2038),
    [sym_subset] = STATE(2038),
    [sym_subset2] = STATE(2038),
    [sym__argument] = STATE(4664),
    [sym_argument] = STATE(4659),
    [sym__argument_named] = STATE(4654),
    [sym__argument_unnamed] = STATE(4676),
    [sym__argument_value] = STATE(4677),
    [sym_unary_operator] = STATE(2038),
    [sym_binary_operator] = STATE(2038),
    [sym_extract_operator] = STATE(2038),
    [sym_namespace_operator] = STATE(2038),
    [sym_integer] = STATE(2038),
    [sym_complex] = STATE(2038),
    [sym_float] = STATE(2038),
    [sym__hex_literal] = STATE(2700),
    [sym__float_literal] = STATE(2700),
    [sym_string] = STATE(2597),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym_na] = STATE(2038),
    [sym__expression] = STATE(2038),
    [sym__string_or_identifier] = STATE(5148),
    [sym__open_parenthesis] = STATE(214),
    [sym__open_brace] = STATE(192),
    [sym__close_bracket] = STATE(2500),
    [aux_sym_call_arguments_repeat1] = STATE(2034),
    [sym_identifier] = ACTIONS(6351),
    [anon_sym_BSLASH] = ACTIONS(4754),
    [anon_sym_function] = ACTIONS(4756),
    [anon_sym_if] = ACTIONS(4758),
    [anon_sym_for] = ACTIONS(4760),
    [anon_sym_while] = ACTIONS(4762),
    [anon_sym_repeat] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4766),
    [anon_sym_TILDE] = ACTIONS(4768),
    [anon_sym_BANG] = ACTIONS(6353),
    [anon_sym_PLUS] = ACTIONS(4772),
    [anon_sym_DASH] = ACTIONS(4772),
    [aux_sym__hex_literal_token1] = ACTIONS(4776),
    [sym__number_literal] = ACTIONS(4778),
    [anon_sym_SQUOTE] = ACTIONS(4780),
    [anon_sym_DQUOTE] = ACTIONS(4782),
    [sym_return] = ACTIONS(6355),
    [sym_next] = ACTIONS(6355),
    [sym_break] = ACTIONS(6355),
    [sym_true] = ACTIONS(6355),
    [sym_false] = ACTIONS(6355),
    [sym_null] = ACTIONS(6355),
    [sym_inf] = ACTIONS(6355),
    [sym_nan] = ACTIONS(6355),
    [anon_sym_NA] = ACTIONS(4786),
    [anon_sym_NA_integer_] = ACTIONS(4786),
    [anon_sym_NA_real_] = ACTIONS(4786),
    [anon_sym_NA_complex_] = ACTIONS(4786),
    [anon_sym_NA_character_] = ACTIONS(4786),
    [sym_dots] = ACTIONS(6357),
    [sym_dot_dot_i] = ACTIONS(6359),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(6361),
    [sym__newline] = ACTIONS(6363),
    [sym__raw_string_literal] = ACTIONS(4790),
    [sym__external_open_parenthesis] = ACTIONS(4792),
    [sym__external_open_brace] = ACTIONS(4794),
    [sym__external_close_bracket] = ACTIONS(6871),
  },
  [1909] = {
    [sym_string] = STATE(2921),
    [sym__single_quoted_string] = STATE(2456),
    [sym__double_quoted_string] = STATE(2478),
    [sym__string_or_identifier] = STATE(2921),
    [aux_sym_function_definition_repeat1] = STATE(2639),
    [sym_identifier] = ACTIONS(6873),
    [anon_sym_BSLASH] = ACTIONS(5669),
    [anon_sym_function] = ACTIONS(5673),
    [anon_sym_EQ] = ACTIONS(5673),
    [anon_sym_if] = ACTIONS(5673),
    [anon_sym_for] = ACTIONS(5673),
    [anon_sym_while] = ACTIONS(5673),
    [anon_sym_repeat] = ACTIONS(5673),
    [anon_sym_QMARK] = ACTIONS(5669),
    [anon_sym_TILDE] = ACTIONS(5669),
    [anon_sym_BANG] = ACTIONS(5673),
    [anon_sym_PLUS] = ACTIONS(5669),
    [anon_sym_DASH] = ACTIONS(5673),
    [anon_sym_LT_DASH] = ACTIONS(5669),
    [anon_sym_LT_LT_DASH] = ACTIONS(5669),
    [anon_sym_COLON_EQ] = ACTIONS(5669),
    [anon_sym_DASH_GT] = ACTIONS(5673),
    [anon_sym_DASH_GT_GT] = ACTIONS(5669),
    [anon_sym_PIPE] = ACTIONS(5673),
    [anon_sym_AMP] = ACTIONS(5673),
    [anon_sym_PIPE_PIPE] = ACTIONS(5669),
    [anon_sym_AMP_AMP] = ACTIONS(5669),
    [anon_sym_LT] = ACTIONS(5673),
    [anon_sym_LT_EQ] = ACTIONS(5669),
    [anon_sym_GT] = ACTIONS(5673),
    [anon_sym_GT_EQ] = ACTIONS(5669),
    [anon_sym_EQ_EQ] = ACTIONS(5669),
    [anon_sym_BANG_EQ] = ACTIONS(5669),
    [anon_sym_STAR] = ACTIONS(5673),
    [anon_sym_SLASH] = ACTIONS(5669),
    [anon_sym_STAR_STAR] = ACTIONS(5669),
    [anon_sym_CARET] = ACTIONS(5669),
    [aux_sym_binary_operator_token1] = ACTIONS(5669),
    [anon_sym_PIPE_GT] = ACTIONS(5669),
    [anon_sym_COLON] = ACTIONS(5673),
    [anon_sym_DOLLAR] = ACTIONS(5669),
    [anon_sym_AT] = ACTIONS(5669),
    [aux_sym__hex_literal_token1] = ACTIONS(5669),
    [sym__number_literal] = ACTIONS(5673),
    [anon_sym_SQUOTE] = ACTIONS(3519),
    [anon_sym_DQUOTE] = ACTIONS(3521),
    [sym_return] = ACTIONS(5673),
    [sym_next] = ACTIONS(5673),
    [sym_break] = ACTIONS(5673),
    [sym_true] = ACTIONS(5673),
    [sym_false] = ACTIONS(5673),
    [sym_null] = ACTIONS(5673),
    [sym_inf] = ACTIONS(5673),
    [sym_nan] = ACTIONS(5673),
    [anon_sym_NA] = ACTIONS(5673),
    [anon_sym_NA_integer_] = ACTIONS(5673),
    [anon_sym_NA_real_] = ACTIONS(5673),
    [anon_sym_NA_complex_] = ACTIONS(5673),
    [anon_sym_NA_character_] = ACTIONS(5673),
    [sym_dots] = ACTIONS(5673),
    [sym_dot_dot_i] = ACTIONS(5669),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5669),
    [sym__newline] = ACTIONS(5669),
    [sym__raw_string_literal] = ACTIONS(3531),
    [sym__external_else] = ACTIONS(5669),
    [sym__external_open_parenthesis] = ACTIONS(5669),
    [sym__external_open_brace] = ACTIONS(5669),
    [sym__external_open_bracket] = ACTIONS(5669),
    [sym__external_close_bracket] = ACTIONS(5669),
    [sym__external_open_bracket2] = ACTIONS(5669),
  },
  [1910] = {
    [sym_call_arguments] = STATE(2978),
    [sym_subset_arguments] = STATE(2977),
    [sym_subset2_arguments] = STATE(2976),
    [sym__open_parenthesis] = STATE(1606),
    [sym__open_bracket] = STATE(1598),
    [sym__open_bracket2] = STATE(1592),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(6875),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(6877),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(6879),
    [anon_sym_DASH] = ACTIONS(6881),
    [anon_sym_LT_DASH] = ACTIONS(6883),
    [anon_sym_LT_LT_DASH] = ACTIONS(6883),
    [anon_sym_COLON_EQ] = ACTIONS(6883),
    [anon_sym_DASH_GT] = ACTIONS(6885),
    [anon_sym_DASH_GT_GT] = ACTIONS(6887),
    [anon_sym_PIPE] = ACTIONS(6889),
    [anon_sym_AMP] = ACTIONS(6891),
    [anon_sym_PIPE_PIPE] = ACTIONS(6893),
    [anon_sym_AMP_AMP] = ACTIONS(6895),
    [anon_sym_LT] = ACTIONS(6897),
    [anon_sym_LT_EQ] = ACTIONS(6899),
    [anon_sym_GT] = ACTIONS(6897),
    [anon_sym_GT_EQ] = ACTIONS(6899),
    [anon_sym_EQ_EQ] = ACTIONS(6899),
    [anon_sym_BANG_EQ] = ACTIONS(6899),
    [anon_sym_STAR] = ACTIONS(6901),
    [anon_sym_SLASH] = ACTIONS(6903),
    [anon_sym_STAR_STAR] = ACTIONS(6905),
    [anon_sym_CARET] = ACTIONS(6905),
    [aux_sym_binary_operator_token1] = ACTIONS(6907),
    [anon_sym_PIPE_GT] = ACTIONS(6907),
    [anon_sym_COLON] = ACTIONS(6909),
    [anon_sym_DOLLAR] = ACTIONS(6911),
    [anon_sym_AT] = ACTIONS(6911),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6913),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6915),
    [sym__external_open_bracket2] = ACTIONS(6917),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [1911] = {
    [sym_call_arguments] = STATE(2941),
    [sym_subset_arguments] = STATE(2942),
    [sym_subset2_arguments] = STATE(2943),
    [sym__open_parenthesis] = STATE(1755),
    [sym__open_bracket] = STATE(1763),
    [sym__open_bracket2] = STATE(1866),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(6919),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(6921),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(6923),
    [anon_sym_DASH] = ACTIONS(6925),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(6927),
    [anon_sym_DASH_GT_GT] = ACTIONS(6929),
    [anon_sym_PIPE] = ACTIONS(6931),
    [anon_sym_AMP] = ACTIONS(6933),
    [anon_sym_PIPE_PIPE] = ACTIONS(6935),
    [anon_sym_AMP_AMP] = ACTIONS(6937),
    [anon_sym_LT] = ACTIONS(6939),
    [anon_sym_LT_EQ] = ACTIONS(6941),
    [anon_sym_GT] = ACTIONS(6939),
    [anon_sym_GT_EQ] = ACTIONS(6941),
    [anon_sym_EQ_EQ] = ACTIONS(6941),
    [anon_sym_BANG_EQ] = ACTIONS(6941),
    [anon_sym_STAR] = ACTIONS(6943),
    [anon_sym_SLASH] = ACTIONS(6945),
    [anon_sym_STAR_STAR] = ACTIONS(6947),
    [anon_sym_CARET] = ACTIONS(6947),
    [aux_sym_binary_operator_token1] = ACTIONS(6949),
    [anon_sym_PIPE_GT] = ACTIONS(6949),
    [anon_sym_COLON] = ACTIONS(6951),
    [anon_sym_DOLLAR] = ACTIONS(6953),
    [anon_sym_AT] = ACTIONS(6953),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6955),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6957),
    [sym__external_open_bracket2] = ACTIONS(6959),
  },
  [1912] = {
    [sym_function_definition] = STATE(1940),
    [sym_if_statement] = STATE(1940),
    [sym_for_statement] = STATE(1940),
    [sym_while_statement] = STATE(1940),
    [sym_repeat_statement] = STATE(1940),
    [sym_braced_expression] = STATE(1940),
    [sym_parenthesized_expression] = STATE(1940),
    [sym_call] = STATE(1940),
    [sym_subset] = STATE(1940),
    [sym_subset2] = STATE(1940),
    [sym__argument] = STATE(4665),
    [sym_argument] = STATE(4661),
    [sym__argument_named] = STATE(4669),
    [sym__argument_unnamed] = STATE(4673),
    [sym__argument_value] = STATE(4679),
    [sym_unary_operator] = STATE(1940),
    [sym_binary_operator] = STATE(1940),
    [sym_extract_operator] = STATE(1940),
    [sym_namespace_operator] = STATE(1940),
    [sym_integer] = STATE(1940),
    [sym_complex] = STATE(1940),
    [sym_float] = STATE(1940),
    [sym__hex_literal] = STATE(2656),
    [sym__float_literal] = STATE(2656),
    [sym_string] = STATE(2606),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym_na] = STATE(1940),
    [sym__expression] = STATE(1940),
    [sym__string_or_identifier] = STATE(5141),
    [sym__open_parenthesis] = STATE(218),
    [sym__open_brace] = STATE(185),
    [aux_sym_call_arguments_repeat1] = STATE(1912),
    [sym_identifier] = ACTIONS(6961),
    [anon_sym_BSLASH] = ACTIONS(6964),
    [anon_sym_function] = ACTIONS(6967),
    [anon_sym_if] = ACTIONS(6970),
    [anon_sym_for] = ACTIONS(6973),
    [anon_sym_while] = ACTIONS(6976),
    [anon_sym_repeat] = ACTIONS(6979),
    [anon_sym_QMARK] = ACTIONS(6982),
    [anon_sym_TILDE] = ACTIONS(6985),
    [anon_sym_BANG] = ACTIONS(6988),
    [anon_sym_PLUS] = ACTIONS(6991),
    [anon_sym_DASH] = ACTIONS(6991),
    [aux_sym__hex_literal_token1] = ACTIONS(6994),
    [sym__number_literal] = ACTIONS(6997),
    [anon_sym_SQUOTE] = ACTIONS(7000),
    [anon_sym_DQUOTE] = ACTIONS(7003),
    [sym_return] = ACTIONS(7006),
    [sym_next] = ACTIONS(7006),
    [sym_break] = ACTIONS(7006),
    [sym_true] = ACTIONS(7006),
    [sym_false] = ACTIONS(7006),
    [sym_null] = ACTIONS(7006),
    [sym_inf] = ACTIONS(7006),
    [sym_nan] = ACTIONS(7006),
    [anon_sym_NA] = ACTIONS(7009),
    [anon_sym_NA_integer_] = ACTIONS(7009),
    [anon_sym_NA_real_] = ACTIONS(7009),
    [anon_sym_NA_complex_] = ACTIONS(7009),
    [anon_sym_NA_character_] = ACTIONS(7009),
    [sym_dots] = ACTIONS(7012),
    [sym_dot_dot_i] = ACTIONS(7015),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7018),
    [sym__newline] = ACTIONS(7021),
    [sym__raw_string_literal] = ACTIONS(7024),
    [sym__external_open_parenthesis] = ACTIONS(7027),
    [sym__external_open_brace] = ACTIONS(7030),
    [sym__external_close_bracket2] = ACTIONS(7033),
  },
  [1913] = {
    [sym_call_arguments] = STATE(2978),
    [sym_subset_arguments] = STATE(2977),
    [sym_subset2_arguments] = STATE(2976),
    [sym__open_parenthesis] = STATE(1606),
    [sym__open_bracket] = STATE(1598),
    [sym__open_bracket2] = STATE(1592),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(6879),
    [anon_sym_DASH] = ACTIONS(6881),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5347),
    [anon_sym_AMP] = ACTIONS(5347),
    [anon_sym_PIPE_PIPE] = ACTIONS(5345),
    [anon_sym_AMP_AMP] = ACTIONS(5345),
    [anon_sym_LT] = ACTIONS(6897),
    [anon_sym_LT_EQ] = ACTIONS(6899),
    [anon_sym_GT] = ACTIONS(6897),
    [anon_sym_GT_EQ] = ACTIONS(6899),
    [anon_sym_EQ_EQ] = ACTIONS(6899),
    [anon_sym_BANG_EQ] = ACTIONS(6899),
    [anon_sym_STAR] = ACTIONS(6901),
    [anon_sym_SLASH] = ACTIONS(6903),
    [anon_sym_STAR_STAR] = ACTIONS(6905),
    [anon_sym_CARET] = ACTIONS(6905),
    [aux_sym_binary_operator_token1] = ACTIONS(6907),
    [anon_sym_PIPE_GT] = ACTIONS(6907),
    [anon_sym_COLON] = ACTIONS(6909),
    [anon_sym_DOLLAR] = ACTIONS(6911),
    [anon_sym_AT] = ACTIONS(6911),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(6913),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(6915),
    [sym__external_open_bracket2] = ACTIONS(6917),
    [sym__external_close_bracket2] = ACTIONS(5345),
  },
  [1914] = {
    [sym_call_arguments] = STATE(2978),
    [sym_subset_arguments] = STATE(2977),
    [sym_subset2_arguments] = STATE(2976),
    [sym__open_parenthesis] = STATE(1606),
    [sym__open_bracket] = STATE(1598),
    [sym__open_bracket2] = STATE(1592),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(6879),
    [anon_sym_DASH] = ACTIONS(6881),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(6889),
    [anon_sym_AMP] = ACTIONS(6891),
    [anon_sym_PIPE_PIPE] = ACTIONS(6893),
    [anon_sym_AMP_AMP] = ACTIONS(6895),
    [anon_sym_LT] = ACTIONS(6897),
    [anon_sym_LT_EQ] = ACTIONS(6899),
    [anon_sym_GT] = ACTIONS(6897),
    [anon_sym_GT_EQ] = ACTIONS(6899),
    [anon_sym_EQ_EQ] = ACTIONS(6899),
    [anon_sym_BANG_EQ] = ACTIONS(6899),
    [anon_sym_STAR] = ACTIONS(6901),
    [anon_sym_SLASH] = ACTIONS(6903),
    [anon_sym_STAR_STAR] = ACTIONS(6905),
    [anon_sym_CARET] = ACTIONS(6905),
    [aux_sym_binary_operator_token1] = ACTIONS(6907),
    [anon_sym_PIPE_GT] = ACTIONS(6907),
    [anon_sym_COLON] = ACTIONS(6909),
    [anon_sym_DOLLAR] = ACTIONS(6911),
    [anon_sym_AT] = ACTIONS(6911),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(6913),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(6915),
    [sym__external_open_bracket2] = ACTIONS(6917),
    [sym__external_close_bracket2] = ACTIONS(5345),
  },
  [1915] = {
    [sym_call_arguments] = STATE(2978),
    [sym_subset_arguments] = STATE(2977),
    [sym_subset2_arguments] = STATE(2976),
    [sym__open_parenthesis] = STATE(1606),
    [sym__open_bracket] = STATE(1598),
    [sym__open_bracket2] = STATE(1592),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(6875),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(6877),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(6879),
    [anon_sym_DASH] = ACTIONS(6881),
    [anon_sym_LT_DASH] = ACTIONS(6883),
    [anon_sym_LT_LT_DASH] = ACTIONS(6883),
    [anon_sym_COLON_EQ] = ACTIONS(6883),
    [anon_sym_DASH_GT] = ACTIONS(6885),
    [anon_sym_DASH_GT_GT] = ACTIONS(6887),
    [anon_sym_PIPE] = ACTIONS(6889),
    [anon_sym_AMP] = ACTIONS(6891),
    [anon_sym_PIPE_PIPE] = ACTIONS(6893),
    [anon_sym_AMP_AMP] = ACTIONS(6895),
    [anon_sym_LT] = ACTIONS(6897),
    [anon_sym_LT_EQ] = ACTIONS(6899),
    [anon_sym_GT] = ACTIONS(6897),
    [anon_sym_GT_EQ] = ACTIONS(6899),
    [anon_sym_EQ_EQ] = ACTIONS(6899),
    [anon_sym_BANG_EQ] = ACTIONS(6899),
    [anon_sym_STAR] = ACTIONS(6901),
    [anon_sym_SLASH] = ACTIONS(6903),
    [anon_sym_STAR_STAR] = ACTIONS(6905),
    [anon_sym_CARET] = ACTIONS(6905),
    [aux_sym_binary_operator_token1] = ACTIONS(6907),
    [anon_sym_PIPE_GT] = ACTIONS(6907),
    [anon_sym_COLON] = ACTIONS(6909),
    [anon_sym_DOLLAR] = ACTIONS(6911),
    [anon_sym_AT] = ACTIONS(6911),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(6913),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(6915),
    [sym__external_open_bracket2] = ACTIONS(6917),
    [sym__external_close_bracket2] = ACTIONS(5345),
  },
  [1916] = {
    [sym_call_arguments] = STATE(2978),
    [sym_subset_arguments] = STATE(2977),
    [sym_subset2_arguments] = STATE(2976),
    [sym__open_parenthesis] = STATE(1606),
    [sym__open_bracket] = STATE(1598),
    [sym__open_bracket2] = STATE(1592),
    [sym_identifier] = ACTIONS(5343),
    [anon_sym_BSLASH] = ACTIONS(5341),
    [anon_sym_function] = ACTIONS(5343),
    [anon_sym_EQ] = ACTIONS(6875),
    [anon_sym_if] = ACTIONS(5343),
    [anon_sym_for] = ACTIONS(5343),
    [anon_sym_while] = ACTIONS(5343),
    [anon_sym_repeat] = ACTIONS(5343),
    [anon_sym_QMARK] = ACTIONS(5341),
    [anon_sym_TILDE] = ACTIONS(6877),
    [anon_sym_BANG] = ACTIONS(5343),
    [anon_sym_PLUS] = ACTIONS(6879),
    [anon_sym_DASH] = ACTIONS(6881),
    [anon_sym_LT_DASH] = ACTIONS(6883),
    [anon_sym_LT_LT_DASH] = ACTIONS(6883),
    [anon_sym_COLON_EQ] = ACTIONS(6883),
    [anon_sym_DASH_GT] = ACTIONS(6885),
    [anon_sym_DASH_GT_GT] = ACTIONS(6887),
    [anon_sym_PIPE] = ACTIONS(6889),
    [anon_sym_AMP] = ACTIONS(6891),
    [anon_sym_PIPE_PIPE] = ACTIONS(6893),
    [anon_sym_AMP_AMP] = ACTIONS(6895),
    [anon_sym_LT] = ACTIONS(6897),
    [anon_sym_LT_EQ] = ACTIONS(6899),
    [anon_sym_GT] = ACTIONS(6897),
    [anon_sym_GT_EQ] = ACTIONS(6899),
    [anon_sym_EQ_EQ] = ACTIONS(6899),
    [anon_sym_BANG_EQ] = ACTIONS(6899),
    [anon_sym_STAR] = ACTIONS(6901),
    [anon_sym_SLASH] = ACTIONS(6903),
    [anon_sym_STAR_STAR] = ACTIONS(6905),
    [anon_sym_CARET] = ACTIONS(6905),
    [aux_sym_binary_operator_token1] = ACTIONS(6907),
    [anon_sym_PIPE_GT] = ACTIONS(6907),
    [anon_sym_COLON] = ACTIONS(6909),
    [anon_sym_DOLLAR] = ACTIONS(6911),
    [anon_sym_AT] = ACTIONS(6911),
    [aux_sym__hex_literal_token1] = ACTIONS(5341),
    [sym__number_literal] = ACTIONS(5343),
    [anon_sym_SQUOTE] = ACTIONS(5341),
    [anon_sym_DQUOTE] = ACTIONS(5341),
    [sym_return] = ACTIONS(5343),
    [sym_next] = ACTIONS(5343),
    [sym_break] = ACTIONS(5343),
    [sym_true] = ACTIONS(5343),
    [sym_false] = ACTIONS(5343),
    [sym_null] = ACTIONS(5343),
    [sym_inf] = ACTIONS(5343),
    [sym_nan] = ACTIONS(5343),
    [anon_sym_NA] = ACTIONS(5343),
    [anon_sym_NA_integer_] = ACTIONS(5343),
    [anon_sym_NA_real_] = ACTIONS(5343),
    [anon_sym_NA_complex_] = ACTIONS(5343),
    [anon_sym_NA_character_] = ACTIONS(5343),
    [sym_dots] = ACTIONS(5343),
    [sym_dot_dot_i] = ACTIONS(5341),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5341),
    [sym__newline] = ACTIONS(5341),
    [sym__raw_string_literal] = ACTIONS(5341),
    [sym__external_open_parenthesis] = ACTIONS(6913),
    [sym__external_open_brace] = ACTIONS(5341),
    [sym__external_open_bracket] = ACTIONS(6915),
    [sym__external_open_bracket2] = ACTIONS(6917),
    [sym__external_close_bracket2] = ACTIONS(5341),
  },
  [1917] = {
    [sym_call_arguments] = STATE(3027),
    [sym_subset_arguments] = STATE(3026),
    [sym_subset2_arguments] = STATE(3025),
    [sym__open_parenthesis] = STATE(1616),
    [sym__open_bracket] = STATE(1615),
    [sym__open_bracket2] = STATE(1613),
    [sym_identifier] = ACTIONS(5343),
    [anon_sym_BSLASH] = ACTIONS(5341),
    [anon_sym_function] = ACTIONS(5343),
    [anon_sym_EQ] = ACTIONS(7035),
    [anon_sym_if] = ACTIONS(5343),
    [anon_sym_for] = ACTIONS(5343),
    [anon_sym_while] = ACTIONS(5343),
    [anon_sym_repeat] = ACTIONS(5343),
    [anon_sym_QMARK] = ACTIONS(5341),
    [anon_sym_TILDE] = ACTIONS(7037),
    [anon_sym_BANG] = ACTIONS(5343),
    [anon_sym_PLUS] = ACTIONS(7039),
    [anon_sym_DASH] = ACTIONS(7041),
    [anon_sym_LT_DASH] = ACTIONS(7043),
    [anon_sym_LT_LT_DASH] = ACTIONS(7043),
    [anon_sym_COLON_EQ] = ACTIONS(7043),
    [anon_sym_DASH_GT] = ACTIONS(7045),
    [anon_sym_DASH_GT_GT] = ACTIONS(7047),
    [anon_sym_PIPE] = ACTIONS(7049),
    [anon_sym_AMP] = ACTIONS(7051),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_AMP_AMP] = ACTIONS(7055),
    [anon_sym_LT] = ACTIONS(7057),
    [anon_sym_LT_EQ] = ACTIONS(7059),
    [anon_sym_GT] = ACTIONS(7057),
    [anon_sym_GT_EQ] = ACTIONS(7059),
    [anon_sym_EQ_EQ] = ACTIONS(7059),
    [anon_sym_BANG_EQ] = ACTIONS(7059),
    [anon_sym_STAR] = ACTIONS(7061),
    [anon_sym_SLASH] = ACTIONS(7063),
    [anon_sym_STAR_STAR] = ACTIONS(7065),
    [anon_sym_CARET] = ACTIONS(7065),
    [aux_sym_binary_operator_token1] = ACTIONS(7067),
    [anon_sym_PIPE_GT] = ACTIONS(7067),
    [anon_sym_COLON] = ACTIONS(7069),
    [anon_sym_DOLLAR] = ACTIONS(7071),
    [anon_sym_AT] = ACTIONS(7071),
    [aux_sym__hex_literal_token1] = ACTIONS(5341),
    [sym__number_literal] = ACTIONS(5343),
    [anon_sym_SQUOTE] = ACTIONS(5341),
    [anon_sym_DQUOTE] = ACTIONS(5341),
    [sym_return] = ACTIONS(5343),
    [sym_next] = ACTIONS(5343),
    [sym_break] = ACTIONS(5343),
    [sym_true] = ACTIONS(5343),
    [sym_false] = ACTIONS(5343),
    [sym_null] = ACTIONS(5343),
    [sym_inf] = ACTIONS(5343),
    [sym_nan] = ACTIONS(5343),
    [anon_sym_NA] = ACTIONS(5343),
    [anon_sym_NA_integer_] = ACTIONS(5343),
    [anon_sym_NA_real_] = ACTIONS(5343),
    [anon_sym_NA_complex_] = ACTIONS(5343),
    [anon_sym_NA_character_] = ACTIONS(5343),
    [sym_dots] = ACTIONS(5343),
    [sym_dot_dot_i] = ACTIONS(5341),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5341),
    [sym__newline] = ACTIONS(5341),
    [sym__raw_string_literal] = ACTIONS(5341),
    [sym__external_open_parenthesis] = ACTIONS(7073),
    [sym__external_open_brace] = ACTIONS(5341),
    [sym__external_open_bracket] = ACTIONS(7075),
    [sym__external_close_bracket] = ACTIONS(5341),
    [sym__external_open_bracket2] = ACTIONS(7077),
  },
  [1918] = {
    [sym_call_arguments] = STATE(2985),
    [sym_subset_arguments] = STATE(2986),
    [sym_subset2_arguments] = STATE(2987),
    [sym__open_parenthesis] = STATE(1414),
    [sym__open_bracket] = STATE(1416),
    [sym__open_bracket2] = STATE(1428),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(7079),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(7081),
    [anon_sym_DASH] = ACTIONS(7083),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(7085),
    [anon_sym_AMP] = ACTIONS(7087),
    [anon_sym_PIPE_PIPE] = ACTIONS(7089),
    [anon_sym_AMP_AMP] = ACTIONS(7091),
    [anon_sym_LT] = ACTIONS(7093),
    [anon_sym_LT_EQ] = ACTIONS(7095),
    [anon_sym_GT] = ACTIONS(7093),
    [anon_sym_GT_EQ] = ACTIONS(7095),
    [anon_sym_EQ_EQ] = ACTIONS(7095),
    [anon_sym_BANG_EQ] = ACTIONS(7095),
    [anon_sym_STAR] = ACTIONS(7097),
    [anon_sym_SLASH] = ACTIONS(7099),
    [anon_sym_STAR_STAR] = ACTIONS(7101),
    [anon_sym_CARET] = ACTIONS(7101),
    [aux_sym_binary_operator_token1] = ACTIONS(7103),
    [anon_sym_PIPE_GT] = ACTIONS(7103),
    [anon_sym_COLON] = ACTIONS(7105),
    [anon_sym_DOLLAR] = ACTIONS(7107),
    [anon_sym_AT] = ACTIONS(7107),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(7109),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(7111),
    [sym__external_open_bracket2] = ACTIONS(7113),
  },
  [1919] = {
    [sym_call_arguments] = STATE(3027),
    [sym_subset_arguments] = STATE(3026),
    [sym_subset2_arguments] = STATE(3025),
    [sym__open_parenthesis] = STATE(1616),
    [sym__open_bracket] = STATE(1615),
    [sym__open_bracket2] = STATE(1613),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(7035),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(7037),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(7039),
    [anon_sym_DASH] = ACTIONS(7041),
    [anon_sym_LT_DASH] = ACTIONS(7043),
    [anon_sym_LT_LT_DASH] = ACTIONS(7043),
    [anon_sym_COLON_EQ] = ACTIONS(7043),
    [anon_sym_DASH_GT] = ACTIONS(7045),
    [anon_sym_DASH_GT_GT] = ACTIONS(7047),
    [anon_sym_PIPE] = ACTIONS(7049),
    [anon_sym_AMP] = ACTIONS(7051),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_AMP_AMP] = ACTIONS(7055),
    [anon_sym_LT] = ACTIONS(7057),
    [anon_sym_LT_EQ] = ACTIONS(7059),
    [anon_sym_GT] = ACTIONS(7057),
    [anon_sym_GT_EQ] = ACTIONS(7059),
    [anon_sym_EQ_EQ] = ACTIONS(7059),
    [anon_sym_BANG_EQ] = ACTIONS(7059),
    [anon_sym_STAR] = ACTIONS(7061),
    [anon_sym_SLASH] = ACTIONS(7063),
    [anon_sym_STAR_STAR] = ACTIONS(7065),
    [anon_sym_CARET] = ACTIONS(7065),
    [aux_sym_binary_operator_token1] = ACTIONS(7067),
    [anon_sym_PIPE_GT] = ACTIONS(7067),
    [anon_sym_COLON] = ACTIONS(7069),
    [anon_sym_DOLLAR] = ACTIONS(7071),
    [anon_sym_AT] = ACTIONS(7071),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(7073),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(7075),
    [sym__external_close_bracket] = ACTIONS(5345),
    [sym__external_open_bracket2] = ACTIONS(7077),
  },
  [1920] = {
    [sym_call_arguments] = STATE(2978),
    [sym_subset_arguments] = STATE(2977),
    [sym_subset2_arguments] = STATE(2976),
    [sym__open_parenthesis] = STATE(1606),
    [sym__open_bracket] = STATE(1598),
    [sym__open_bracket2] = STATE(1592),
    [sym_identifier] = ACTIONS(5339),
    [anon_sym_BSLASH] = ACTIONS(5337),
    [anon_sym_function] = ACTIONS(5339),
    [anon_sym_EQ] = ACTIONS(6875),
    [anon_sym_if] = ACTIONS(5339),
    [anon_sym_for] = ACTIONS(5339),
    [anon_sym_while] = ACTIONS(5339),
    [anon_sym_repeat] = ACTIONS(5339),
    [anon_sym_QMARK] = ACTIONS(5337),
    [anon_sym_TILDE] = ACTIONS(6877),
    [anon_sym_BANG] = ACTIONS(5339),
    [anon_sym_PLUS] = ACTIONS(6879),
    [anon_sym_DASH] = ACTIONS(6881),
    [anon_sym_LT_DASH] = ACTIONS(6883),
    [anon_sym_LT_LT_DASH] = ACTIONS(6883),
    [anon_sym_COLON_EQ] = ACTIONS(6883),
    [anon_sym_DASH_GT] = ACTIONS(6885),
    [anon_sym_DASH_GT_GT] = ACTIONS(6887),
    [anon_sym_PIPE] = ACTIONS(6889),
    [anon_sym_AMP] = ACTIONS(6891),
    [anon_sym_PIPE_PIPE] = ACTIONS(6893),
    [anon_sym_AMP_AMP] = ACTIONS(6895),
    [anon_sym_LT] = ACTIONS(6897),
    [anon_sym_LT_EQ] = ACTIONS(6899),
    [anon_sym_GT] = ACTIONS(6897),
    [anon_sym_GT_EQ] = ACTIONS(6899),
    [anon_sym_EQ_EQ] = ACTIONS(6899),
    [anon_sym_BANG_EQ] = ACTIONS(6899),
    [anon_sym_STAR] = ACTIONS(6901),
    [anon_sym_SLASH] = ACTIONS(6903),
    [anon_sym_STAR_STAR] = ACTIONS(6905),
    [anon_sym_CARET] = ACTIONS(6905),
    [aux_sym_binary_operator_token1] = ACTIONS(6907),
    [anon_sym_PIPE_GT] = ACTIONS(6907),
    [anon_sym_COLON] = ACTIONS(6909),
    [anon_sym_DOLLAR] = ACTIONS(6911),
    [anon_sym_AT] = ACTIONS(6911),
    [aux_sym__hex_literal_token1] = ACTIONS(5337),
    [sym__number_literal] = ACTIONS(5339),
    [anon_sym_SQUOTE] = ACTIONS(5337),
    [anon_sym_DQUOTE] = ACTIONS(5337),
    [sym_return] = ACTIONS(5339),
    [sym_next] = ACTIONS(5339),
    [sym_break] = ACTIONS(5339),
    [sym_true] = ACTIONS(5339),
    [sym_false] = ACTIONS(5339),
    [sym_null] = ACTIONS(5339),
    [sym_inf] = ACTIONS(5339),
    [sym_nan] = ACTIONS(5339),
    [anon_sym_NA] = ACTIONS(5339),
    [anon_sym_NA_integer_] = ACTIONS(5339),
    [anon_sym_NA_real_] = ACTIONS(5339),
    [anon_sym_NA_complex_] = ACTIONS(5339),
    [anon_sym_NA_character_] = ACTIONS(5339),
    [sym_dots] = ACTIONS(5339),
    [sym_dot_dot_i] = ACTIONS(5337),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5337),
    [sym__newline] = ACTIONS(5337),
    [sym__raw_string_literal] = ACTIONS(5337),
    [sym__external_open_parenthesis] = ACTIONS(6913),
    [sym__external_open_brace] = ACTIONS(5337),
    [sym__external_open_bracket] = ACTIONS(6915),
    [sym__external_open_bracket2] = ACTIONS(6917),
    [sym__external_close_bracket2] = ACTIONS(5337),
  },
  [1921] = {
    [sym_call_arguments] = STATE(3027),
    [sym_subset_arguments] = STATE(3026),
    [sym_subset2_arguments] = STATE(3025),
    [sym__open_parenthesis] = STATE(1616),
    [sym__open_bracket] = STATE(1615),
    [sym__open_bracket2] = STATE(1613),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(7039),
    [anon_sym_DASH] = ACTIONS(7041),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5347),
    [anon_sym_AMP] = ACTIONS(5347),
    [anon_sym_PIPE_PIPE] = ACTIONS(5345),
    [anon_sym_AMP_AMP] = ACTIONS(5345),
    [anon_sym_LT] = ACTIONS(7057),
    [anon_sym_LT_EQ] = ACTIONS(7059),
    [anon_sym_GT] = ACTIONS(7057),
    [anon_sym_GT_EQ] = ACTIONS(7059),
    [anon_sym_EQ_EQ] = ACTIONS(7059),
    [anon_sym_BANG_EQ] = ACTIONS(7059),
    [anon_sym_STAR] = ACTIONS(7061),
    [anon_sym_SLASH] = ACTIONS(7063),
    [anon_sym_STAR_STAR] = ACTIONS(7065),
    [anon_sym_CARET] = ACTIONS(7065),
    [aux_sym_binary_operator_token1] = ACTIONS(7067),
    [anon_sym_PIPE_GT] = ACTIONS(7067),
    [anon_sym_COLON] = ACTIONS(7069),
    [anon_sym_DOLLAR] = ACTIONS(7071),
    [anon_sym_AT] = ACTIONS(7071),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(7073),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(7075),
    [sym__external_close_bracket] = ACTIONS(5345),
    [sym__external_open_bracket2] = ACTIONS(7077),
  },
  [1922] = {
    [sym_call_arguments] = STATE(3027),
    [sym_subset_arguments] = STATE(3026),
    [sym_subset2_arguments] = STATE(3025),
    [sym__open_parenthesis] = STATE(1616),
    [sym__open_bracket] = STATE(1615),
    [sym__open_bracket2] = STATE(1613),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5345),
    [anon_sym_DASH] = ACTIONS(5347),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5347),
    [anon_sym_AMP] = ACTIONS(5347),
    [anon_sym_PIPE_PIPE] = ACTIONS(5345),
    [anon_sym_AMP_AMP] = ACTIONS(5345),
    [anon_sym_LT] = ACTIONS(5347),
    [anon_sym_LT_EQ] = ACTIONS(5345),
    [anon_sym_GT] = ACTIONS(5347),
    [anon_sym_GT_EQ] = ACTIONS(5345),
    [anon_sym_EQ_EQ] = ACTIONS(5345),
    [anon_sym_BANG_EQ] = ACTIONS(5345),
    [anon_sym_STAR] = ACTIONS(5347),
    [anon_sym_SLASH] = ACTIONS(5345),
    [anon_sym_STAR_STAR] = ACTIONS(7065),
    [anon_sym_CARET] = ACTIONS(7065),
    [aux_sym_binary_operator_token1] = ACTIONS(5345),
    [anon_sym_PIPE_GT] = ACTIONS(5345),
    [anon_sym_COLON] = ACTIONS(5347),
    [anon_sym_DOLLAR] = ACTIONS(7071),
    [anon_sym_AT] = ACTIONS(7071),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(7073),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(7075),
    [sym__external_close_bracket] = ACTIONS(5345),
    [sym__external_open_bracket2] = ACTIONS(7077),
  },
  [1923] = {
    [sym_identifier] = ACTIONS(7115),
    [anon_sym_BSLASH] = ACTIONS(7117),
    [anon_sym_function] = ACTIONS(7115),
    [anon_sym_EQ] = ACTIONS(7115),
    [anon_sym_if] = ACTIONS(7115),
    [anon_sym_for] = ACTIONS(7115),
    [anon_sym_while] = ACTIONS(7115),
    [anon_sym_repeat] = ACTIONS(7115),
    [anon_sym_QMARK] = ACTIONS(7117),
    [anon_sym_TILDE] = ACTIONS(7117),
    [anon_sym_BANG] = ACTIONS(7115),
    [anon_sym_PLUS] = ACTIONS(7117),
    [anon_sym_DASH] = ACTIONS(7115),
    [anon_sym_LT_DASH] = ACTIONS(7117),
    [anon_sym_LT_LT_DASH] = ACTIONS(7117),
    [anon_sym_COLON_EQ] = ACTIONS(7117),
    [anon_sym_DASH_GT] = ACTIONS(7115),
    [anon_sym_DASH_GT_GT] = ACTIONS(7117),
    [anon_sym_PIPE] = ACTIONS(7115),
    [anon_sym_AMP] = ACTIONS(7115),
    [anon_sym_PIPE_PIPE] = ACTIONS(7117),
    [anon_sym_AMP_AMP] = ACTIONS(7117),
    [anon_sym_LT] = ACTIONS(7115),
    [anon_sym_LT_EQ] = ACTIONS(7117),
    [anon_sym_GT] = ACTIONS(7115),
    [anon_sym_GT_EQ] = ACTIONS(7117),
    [anon_sym_EQ_EQ] = ACTIONS(7117),
    [anon_sym_BANG_EQ] = ACTIONS(7117),
    [anon_sym_STAR] = ACTIONS(7115),
    [anon_sym_SLASH] = ACTIONS(7117),
    [anon_sym_STAR_STAR] = ACTIONS(7117),
    [anon_sym_CARET] = ACTIONS(7117),
    [aux_sym_binary_operator_token1] = ACTIONS(7117),
    [anon_sym_PIPE_GT] = ACTIONS(7117),
    [anon_sym_COLON] = ACTIONS(7115),
    [anon_sym_DOLLAR] = ACTIONS(7117),
    [anon_sym_AT] = ACTIONS(7117),
    [anon_sym_COLON_COLON] = ACTIONS(7115),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7117),
    [aux_sym__hex_literal_token1] = ACTIONS(7117),
    [sym__number_literal] = ACTIONS(7115),
    [anon_sym_SQUOTE] = ACTIONS(7117),
    [anon_sym_DQUOTE] = ACTIONS(7117),
    [sym_return] = ACTIONS(7115),
    [sym_next] = ACTIONS(7115),
    [sym_break] = ACTIONS(7115),
    [sym_true] = ACTIONS(7115),
    [sym_false] = ACTIONS(7115),
    [sym_null] = ACTIONS(7115),
    [sym_inf] = ACTIONS(7115),
    [sym_nan] = ACTIONS(7115),
    [anon_sym_NA] = ACTIONS(7115),
    [anon_sym_NA_integer_] = ACTIONS(7115),
    [anon_sym_NA_real_] = ACTIONS(7115),
    [anon_sym_NA_complex_] = ACTIONS(7115),
    [anon_sym_NA_character_] = ACTIONS(7115),
    [sym_dots] = ACTIONS(7115),
    [sym_dot_dot_i] = ACTIONS(7117),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7117),
    [sym__newline] = ACTIONS(7117),
    [sym__semicolon] = ACTIONS(7117),
    [sym__raw_string_literal] = ACTIONS(7117),
    [sym__external_else] = ACTIONS(7117),
    [sym__external_open_parenthesis] = ACTIONS(7117),
    [sym__external_close_parenthesis] = ACTIONS(7117),
    [sym__external_open_brace] = ACTIONS(7117),
    [sym__external_close_brace] = ACTIONS(7117),
    [sym__external_open_bracket] = ACTIONS(7117),
    [sym__external_open_bracket2] = ACTIONS(7117),
    [sym__external_close_bracket2] = ACTIONS(7117),
  },
  [1924] = {
    [sym_string] = STATE(2910),
    [sym__single_quoted_string] = STATE(2528),
    [sym__double_quoted_string] = STATE(2529),
    [sym__string_or_identifier] = STATE(2910),
    [aux_sym_function_definition_repeat1] = STATE(2680),
    [ts_builtin_sym_end] = ACTIONS(5669),
    [sym_identifier] = ACTIONS(7119),
    [anon_sym_BSLASH] = ACTIONS(5669),
    [anon_sym_function] = ACTIONS(5673),
    [anon_sym_EQ] = ACTIONS(5673),
    [anon_sym_if] = ACTIONS(5673),
    [anon_sym_for] = ACTIONS(5673),
    [anon_sym_while] = ACTIONS(5673),
    [anon_sym_repeat] = ACTIONS(5673),
    [anon_sym_QMARK] = ACTIONS(5669),
    [anon_sym_TILDE] = ACTIONS(5669),
    [anon_sym_BANG] = ACTIONS(5673),
    [anon_sym_PLUS] = ACTIONS(5669),
    [anon_sym_DASH] = ACTIONS(5673),
    [anon_sym_LT_DASH] = ACTIONS(5669),
    [anon_sym_LT_LT_DASH] = ACTIONS(5669),
    [anon_sym_COLON_EQ] = ACTIONS(5669),
    [anon_sym_DASH_GT] = ACTIONS(5673),
    [anon_sym_DASH_GT_GT] = ACTIONS(5669),
    [anon_sym_PIPE] = ACTIONS(5673),
    [anon_sym_AMP] = ACTIONS(5673),
    [anon_sym_PIPE_PIPE] = ACTIONS(5669),
    [anon_sym_AMP_AMP] = ACTIONS(5669),
    [anon_sym_LT] = ACTIONS(5673),
    [anon_sym_LT_EQ] = ACTIONS(5669),
    [anon_sym_GT] = ACTIONS(5673),
    [anon_sym_GT_EQ] = ACTIONS(5669),
    [anon_sym_EQ_EQ] = ACTIONS(5669),
    [anon_sym_BANG_EQ] = ACTIONS(5669),
    [anon_sym_STAR] = ACTIONS(5673),
    [anon_sym_SLASH] = ACTIONS(5669),
    [anon_sym_STAR_STAR] = ACTIONS(5669),
    [anon_sym_CARET] = ACTIONS(5669),
    [aux_sym_binary_operator_token1] = ACTIONS(5669),
    [anon_sym_PIPE_GT] = ACTIONS(5669),
    [anon_sym_COLON] = ACTIONS(5673),
    [anon_sym_DOLLAR] = ACTIONS(5669),
    [anon_sym_AT] = ACTIONS(5669),
    [aux_sym__hex_literal_token1] = ACTIONS(5669),
    [sym__number_literal] = ACTIONS(5673),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE] = ACTIONS(2856),
    [sym_return] = ACTIONS(5673),
    [sym_next] = ACTIONS(5673),
    [sym_break] = ACTIONS(5673),
    [sym_true] = ACTIONS(5673),
    [sym_false] = ACTIONS(5673),
    [sym_null] = ACTIONS(5673),
    [sym_inf] = ACTIONS(5673),
    [sym_nan] = ACTIONS(5673),
    [anon_sym_NA] = ACTIONS(5673),
    [anon_sym_NA_integer_] = ACTIONS(5673),
    [anon_sym_NA_real_] = ACTIONS(5673),
    [anon_sym_NA_complex_] = ACTIONS(5673),
    [anon_sym_NA_character_] = ACTIONS(5673),
    [sym_dots] = ACTIONS(5673),
    [sym_dot_dot_i] = ACTIONS(5669),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5669),
    [sym__semicolon] = ACTIONS(5669),
    [sym__raw_string_literal] = ACTIONS(2866),
    [sym__external_open_parenthesis] = ACTIONS(5669),
    [sym__external_open_brace] = ACTIONS(5669),
    [sym__external_close_brace] = ACTIONS(5669),
    [sym__external_open_bracket] = ACTIONS(5669),
    [sym__external_open_bracket2] = ACTIONS(5669),
  },
  [1925] = {
    [sym_identifier] = ACTIONS(7121),
    [anon_sym_BSLASH] = ACTIONS(7123),
    [anon_sym_function] = ACTIONS(7121),
    [anon_sym_EQ] = ACTIONS(7121),
    [anon_sym_if] = ACTIONS(7121),
    [anon_sym_for] = ACTIONS(7121),
    [anon_sym_while] = ACTIONS(7121),
    [anon_sym_repeat] = ACTIONS(7121),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_TILDE] = ACTIONS(7123),
    [anon_sym_BANG] = ACTIONS(7121),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_DASH] = ACTIONS(7121),
    [anon_sym_LT_DASH] = ACTIONS(7123),
    [anon_sym_LT_LT_DASH] = ACTIONS(7123),
    [anon_sym_COLON_EQ] = ACTIONS(7123),
    [anon_sym_DASH_GT] = ACTIONS(7121),
    [anon_sym_DASH_GT_GT] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_LT_EQ] = ACTIONS(7123),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
    [aux_sym_binary_operator_token1] = ACTIONS(7123),
    [anon_sym_PIPE_GT] = ACTIONS(7123),
    [anon_sym_COLON] = ACTIONS(7121),
    [anon_sym_DOLLAR] = ACTIONS(7123),
    [anon_sym_AT] = ACTIONS(7123),
    [anon_sym_L] = ACTIONS(7125),
    [anon_sym_i] = ACTIONS(7127),
    [aux_sym__hex_literal_token1] = ACTIONS(7123),
    [sym__number_literal] = ACTIONS(7121),
    [anon_sym_SQUOTE] = ACTIONS(7123),
    [anon_sym_DQUOTE] = ACTIONS(7123),
    [sym_return] = ACTIONS(7121),
    [sym_next] = ACTIONS(7121),
    [sym_break] = ACTIONS(7121),
    [sym_true] = ACTIONS(7121),
    [sym_false] = ACTIONS(7121),
    [sym_null] = ACTIONS(7121),
    [sym_inf] = ACTIONS(7121),
    [sym_nan] = ACTIONS(7121),
    [anon_sym_NA] = ACTIONS(7121),
    [anon_sym_NA_integer_] = ACTIONS(7121),
    [anon_sym_NA_real_] = ACTIONS(7121),
    [anon_sym_NA_complex_] = ACTIONS(7121),
    [anon_sym_NA_character_] = ACTIONS(7121),
    [sym_dots] = ACTIONS(7121),
    [sym_dot_dot_i] = ACTIONS(7123),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7123),
    [sym__newline] = ACTIONS(7123),
    [sym__semicolon] = ACTIONS(7123),
    [sym__raw_string_literal] = ACTIONS(7123),
    [sym__external_else] = ACTIONS(7123),
    [sym__external_open_parenthesis] = ACTIONS(7123),
    [sym__external_close_parenthesis] = ACTIONS(7123),
    [sym__external_open_brace] = ACTIONS(7123),
    [sym__external_close_brace] = ACTIONS(7123),
    [sym__external_open_bracket] = ACTIONS(7123),
    [sym__external_open_bracket2] = ACTIONS(7123),
    [sym__external_close_bracket2] = ACTIONS(7123),
  },
  [1926] = {
    [sym_call_arguments] = STATE(3027),
    [sym_subset_arguments] = STATE(3026),
    [sym_subset2_arguments] = STATE(3025),
    [sym__open_parenthesis] = STATE(1616),
    [sym__open_bracket] = STATE(1615),
    [sym__open_bracket2] = STATE(1613),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(7035),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(7037),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(7039),
    [anon_sym_DASH] = ACTIONS(7041),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(7045),
    [anon_sym_DASH_GT_GT] = ACTIONS(7047),
    [anon_sym_PIPE] = ACTIONS(7049),
    [anon_sym_AMP] = ACTIONS(7051),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_AMP_AMP] = ACTIONS(7055),
    [anon_sym_LT] = ACTIONS(7057),
    [anon_sym_LT_EQ] = ACTIONS(7059),
    [anon_sym_GT] = ACTIONS(7057),
    [anon_sym_GT_EQ] = ACTIONS(7059),
    [anon_sym_EQ_EQ] = ACTIONS(7059),
    [anon_sym_BANG_EQ] = ACTIONS(7059),
    [anon_sym_STAR] = ACTIONS(7061),
    [anon_sym_SLASH] = ACTIONS(7063),
    [anon_sym_STAR_STAR] = ACTIONS(7065),
    [anon_sym_CARET] = ACTIONS(7065),
    [aux_sym_binary_operator_token1] = ACTIONS(7067),
    [anon_sym_PIPE_GT] = ACTIONS(7067),
    [anon_sym_COLON] = ACTIONS(7069),
    [anon_sym_DOLLAR] = ACTIONS(7071),
    [anon_sym_AT] = ACTIONS(7071),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(7073),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(7075),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(7077),
  },
  [1927] = {
    [sym_identifier] = ACTIONS(7129),
    [anon_sym_BSLASH] = ACTIONS(7131),
    [anon_sym_function] = ACTIONS(7129),
    [anon_sym_EQ] = ACTIONS(7129),
    [anon_sym_if] = ACTIONS(7129),
    [anon_sym_for] = ACTIONS(7129),
    [anon_sym_while] = ACTIONS(7129),
    [anon_sym_repeat] = ACTIONS(7129),
    [anon_sym_QMARK] = ACTIONS(7131),
    [anon_sym_TILDE] = ACTIONS(7131),
    [anon_sym_BANG] = ACTIONS(7129),
    [anon_sym_PLUS] = ACTIONS(7131),
    [anon_sym_DASH] = ACTIONS(7129),
    [anon_sym_LT_DASH] = ACTIONS(7131),
    [anon_sym_LT_LT_DASH] = ACTIONS(7131),
    [anon_sym_COLON_EQ] = ACTIONS(7131),
    [anon_sym_DASH_GT] = ACTIONS(7129),
    [anon_sym_DASH_GT_GT] = ACTIONS(7131),
    [anon_sym_PIPE] = ACTIONS(7129),
    [anon_sym_AMP] = ACTIONS(7129),
    [anon_sym_PIPE_PIPE] = ACTIONS(7131),
    [anon_sym_AMP_AMP] = ACTIONS(7131),
    [anon_sym_LT] = ACTIONS(7129),
    [anon_sym_LT_EQ] = ACTIONS(7131),
    [anon_sym_GT] = ACTIONS(7129),
    [anon_sym_GT_EQ] = ACTIONS(7131),
    [anon_sym_EQ_EQ] = ACTIONS(7131),
    [anon_sym_BANG_EQ] = ACTIONS(7131),
    [anon_sym_STAR] = ACTIONS(7129),
    [anon_sym_SLASH] = ACTIONS(7131),
    [anon_sym_STAR_STAR] = ACTIONS(7131),
    [anon_sym_CARET] = ACTIONS(7131),
    [aux_sym_binary_operator_token1] = ACTIONS(7131),
    [anon_sym_PIPE_GT] = ACTIONS(7131),
    [anon_sym_COLON] = ACTIONS(7129),
    [anon_sym_DOLLAR] = ACTIONS(7131),
    [anon_sym_AT] = ACTIONS(7131),
    [anon_sym_COLON_COLON] = ACTIONS(7133),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7135),
    [aux_sym__hex_literal_token1] = ACTIONS(7131),
    [sym__number_literal] = ACTIONS(7129),
    [anon_sym_SQUOTE] = ACTIONS(7131),
    [anon_sym_DQUOTE] = ACTIONS(7131),
    [sym_return] = ACTIONS(7129),
    [sym_next] = ACTIONS(7129),
    [sym_break] = ACTIONS(7129),
    [sym_true] = ACTIONS(7129),
    [sym_false] = ACTIONS(7129),
    [sym_null] = ACTIONS(7129),
    [sym_inf] = ACTIONS(7129),
    [sym_nan] = ACTIONS(7129),
    [anon_sym_NA] = ACTIONS(7129),
    [anon_sym_NA_integer_] = ACTIONS(7129),
    [anon_sym_NA_real_] = ACTIONS(7129),
    [anon_sym_NA_complex_] = ACTIONS(7129),
    [anon_sym_NA_character_] = ACTIONS(7129),
    [sym_dots] = ACTIONS(7129),
    [sym_dot_dot_i] = ACTIONS(7131),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7131),
    [sym__newline] = ACTIONS(7131),
    [sym__semicolon] = ACTIONS(7131),
    [sym__raw_string_literal] = ACTIONS(7131),
    [sym__external_else] = ACTIONS(7131),
    [sym__external_open_parenthesis] = ACTIONS(7131),
    [sym__external_close_parenthesis] = ACTIONS(7131),
    [sym__external_open_brace] = ACTIONS(7131),
    [sym__external_close_brace] = ACTIONS(7131),
    [sym__external_open_bracket] = ACTIONS(7131),
    [sym__external_open_bracket2] = ACTIONS(7131),
    [sym__external_close_bracket2] = ACTIONS(7131),
  },
  [1928] = {
    [sym_call_arguments] = STATE(2978),
    [sym_subset_arguments] = STATE(2977),
    [sym_subset2_arguments] = STATE(2976),
    [sym__open_parenthesis] = STATE(1606),
    [sym__open_bracket] = STATE(1598),
    [sym__open_bracket2] = STATE(1592),
    [sym_identifier] = ACTIONS(5419),
    [anon_sym_BSLASH] = ACTIONS(5417),
    [anon_sym_function] = ACTIONS(5419),
    [anon_sym_EQ] = ACTIONS(6875),
    [anon_sym_if] = ACTIONS(5419),
    [anon_sym_for] = ACTIONS(5419),
    [anon_sym_while] = ACTIONS(5419),
    [anon_sym_repeat] = ACTIONS(5419),
    [anon_sym_QMARK] = ACTIONS(5417),
    [anon_sym_TILDE] = ACTIONS(6877),
    [anon_sym_BANG] = ACTIONS(5419),
    [anon_sym_PLUS] = ACTIONS(6879),
    [anon_sym_DASH] = ACTIONS(6881),
    [anon_sym_LT_DASH] = ACTIONS(6883),
    [anon_sym_LT_LT_DASH] = ACTIONS(6883),
    [anon_sym_COLON_EQ] = ACTIONS(6883),
    [anon_sym_DASH_GT] = ACTIONS(6885),
    [anon_sym_DASH_GT_GT] = ACTIONS(6887),
    [anon_sym_PIPE] = ACTIONS(6889),
    [anon_sym_AMP] = ACTIONS(6891),
    [anon_sym_PIPE_PIPE] = ACTIONS(6893),
    [anon_sym_AMP_AMP] = ACTIONS(6895),
    [anon_sym_LT] = ACTIONS(6897),
    [anon_sym_LT_EQ] = ACTIONS(6899),
    [anon_sym_GT] = ACTIONS(6897),
    [anon_sym_GT_EQ] = ACTIONS(6899),
    [anon_sym_EQ_EQ] = ACTIONS(6899),
    [anon_sym_BANG_EQ] = ACTIONS(6899),
    [anon_sym_STAR] = ACTIONS(6901),
    [anon_sym_SLASH] = ACTIONS(6903),
    [anon_sym_STAR_STAR] = ACTIONS(6905),
    [anon_sym_CARET] = ACTIONS(6905),
    [aux_sym_binary_operator_token1] = ACTIONS(6907),
    [anon_sym_PIPE_GT] = ACTIONS(6907),
    [anon_sym_COLON] = ACTIONS(6909),
    [anon_sym_DOLLAR] = ACTIONS(6911),
    [anon_sym_AT] = ACTIONS(6911),
    [aux_sym__hex_literal_token1] = ACTIONS(5417),
    [sym__number_literal] = ACTIONS(5419),
    [anon_sym_SQUOTE] = ACTIONS(5417),
    [anon_sym_DQUOTE] = ACTIONS(5417),
    [sym_return] = ACTIONS(5419),
    [sym_next] = ACTIONS(5419),
    [sym_break] = ACTIONS(5419),
    [sym_true] = ACTIONS(5419),
    [sym_false] = ACTIONS(5419),
    [sym_null] = ACTIONS(5419),
    [sym_inf] = ACTIONS(5419),
    [sym_nan] = ACTIONS(5419),
    [anon_sym_NA] = ACTIONS(5419),
    [anon_sym_NA_integer_] = ACTIONS(5419),
    [anon_sym_NA_real_] = ACTIONS(5419),
    [anon_sym_NA_complex_] = ACTIONS(5419),
    [anon_sym_NA_character_] = ACTIONS(5419),
    [sym_dots] = ACTIONS(5419),
    [sym_dot_dot_i] = ACTIONS(5417),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5417),
    [sym__newline] = ACTIONS(5417),
    [sym__raw_string_literal] = ACTIONS(5417),
    [sym__external_open_parenthesis] = ACTIONS(6913),
    [sym__external_open_brace] = ACTIONS(5417),
    [sym__external_open_bracket] = ACTIONS(6915),
    [sym__external_open_bracket2] = ACTIONS(6917),
    [sym__external_close_bracket2] = ACTIONS(5417),
  },
  [1929] = {
    [sym_identifier] = ACTIONS(7137),
    [anon_sym_BSLASH] = ACTIONS(7139),
    [anon_sym_function] = ACTIONS(7137),
    [anon_sym_EQ] = ACTIONS(7137),
    [anon_sym_if] = ACTIONS(7137),
    [anon_sym_for] = ACTIONS(7137),
    [anon_sym_while] = ACTIONS(7137),
    [anon_sym_repeat] = ACTIONS(7137),
    [anon_sym_QMARK] = ACTIONS(7139),
    [anon_sym_TILDE] = ACTIONS(7139),
    [anon_sym_BANG] = ACTIONS(7137),
    [anon_sym_PLUS] = ACTIONS(7139),
    [anon_sym_DASH] = ACTIONS(7137),
    [anon_sym_LT_DASH] = ACTIONS(7139),
    [anon_sym_LT_LT_DASH] = ACTIONS(7139),
    [anon_sym_COLON_EQ] = ACTIONS(7139),
    [anon_sym_DASH_GT] = ACTIONS(7137),
    [anon_sym_DASH_GT_GT] = ACTIONS(7139),
    [anon_sym_PIPE] = ACTIONS(7137),
    [anon_sym_AMP] = ACTIONS(7137),
    [anon_sym_PIPE_PIPE] = ACTIONS(7139),
    [anon_sym_AMP_AMP] = ACTIONS(7139),
    [anon_sym_LT] = ACTIONS(7137),
    [anon_sym_LT_EQ] = ACTIONS(7139),
    [anon_sym_GT] = ACTIONS(7137),
    [anon_sym_GT_EQ] = ACTIONS(7139),
    [anon_sym_EQ_EQ] = ACTIONS(7139),
    [anon_sym_BANG_EQ] = ACTIONS(7139),
    [anon_sym_STAR] = ACTIONS(7137),
    [anon_sym_SLASH] = ACTIONS(7139),
    [anon_sym_STAR_STAR] = ACTIONS(7139),
    [anon_sym_CARET] = ACTIONS(7139),
    [aux_sym_binary_operator_token1] = ACTIONS(7139),
    [anon_sym_PIPE_GT] = ACTIONS(7139),
    [anon_sym_COLON] = ACTIONS(7137),
    [anon_sym_DOLLAR] = ACTIONS(7139),
    [anon_sym_AT] = ACTIONS(7139),
    [anon_sym_COLON_COLON] = ACTIONS(7137),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7139),
    [aux_sym__hex_literal_token1] = ACTIONS(7139),
    [sym__number_literal] = ACTIONS(7137),
    [anon_sym_SQUOTE] = ACTIONS(7139),
    [anon_sym_DQUOTE] = ACTIONS(7139),
    [sym_return] = ACTIONS(7137),
    [sym_next] = ACTIONS(7137),
    [sym_break] = ACTIONS(7137),
    [sym_true] = ACTIONS(7137),
    [sym_false] = ACTIONS(7137),
    [sym_null] = ACTIONS(7137),
    [sym_inf] = ACTIONS(7137),
    [sym_nan] = ACTIONS(7137),
    [anon_sym_NA] = ACTIONS(7137),
    [anon_sym_NA_integer_] = ACTIONS(7137),
    [anon_sym_NA_real_] = ACTIONS(7137),
    [anon_sym_NA_complex_] = ACTIONS(7137),
    [anon_sym_NA_character_] = ACTIONS(7137),
    [sym_dots] = ACTIONS(7137),
    [sym_dot_dot_i] = ACTIONS(7139),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7139),
    [sym__newline] = ACTIONS(7139),
    [sym__semicolon] = ACTIONS(7139),
    [sym__raw_string_literal] = ACTIONS(7139),
    [sym__external_else] = ACTIONS(7139),
    [sym__external_open_parenthesis] = ACTIONS(7139),
    [sym__external_close_parenthesis] = ACTIONS(7139),
    [sym__external_open_brace] = ACTIONS(7139),
    [sym__external_close_brace] = ACTIONS(7139),
    [sym__external_open_bracket] = ACTIONS(7139),
    [sym__external_open_bracket2] = ACTIONS(7139),
    [sym__external_close_bracket2] = ACTIONS(7139),
  },
  [1930] = {
    [sym_call_arguments] = STATE(3027),
    [sym_subset_arguments] = STATE(3026),
    [sym_subset2_arguments] = STATE(3025),
    [sym__open_parenthesis] = STATE(1616),
    [sym__open_bracket] = STATE(1615),
    [sym__open_bracket2] = STATE(1613),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(7039),
    [anon_sym_DASH] = ACTIONS(7041),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(7049),
    [anon_sym_AMP] = ACTIONS(7051),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_AMP_AMP] = ACTIONS(7055),
    [anon_sym_LT] = ACTIONS(7057),
    [anon_sym_LT_EQ] = ACTIONS(7059),
    [anon_sym_GT] = ACTIONS(7057),
    [anon_sym_GT_EQ] = ACTIONS(7059),
    [anon_sym_EQ_EQ] = ACTIONS(7059),
    [anon_sym_BANG_EQ] = ACTIONS(7059),
    [anon_sym_STAR] = ACTIONS(7061),
    [anon_sym_SLASH] = ACTIONS(7063),
    [anon_sym_STAR_STAR] = ACTIONS(7065),
    [anon_sym_CARET] = ACTIONS(7065),
    [aux_sym_binary_operator_token1] = ACTIONS(7067),
    [anon_sym_PIPE_GT] = ACTIONS(7067),
    [anon_sym_COLON] = ACTIONS(7069),
    [anon_sym_DOLLAR] = ACTIONS(7071),
    [anon_sym_AT] = ACTIONS(7071),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(7073),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(7075),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(7077),
  },
  [1931] = {
    [sym_call_arguments] = STATE(2941),
    [sym_subset_arguments] = STATE(2942),
    [sym_subset2_arguments] = STATE(2943),
    [sym__open_parenthesis] = STATE(1755),
    [sym__open_bracket] = STATE(1763),
    [sym__open_bracket2] = STATE(1866),
    [sym_identifier] = ACTIONS(7141),
    [anon_sym_BSLASH] = ACTIONS(7143),
    [anon_sym_function] = ACTIONS(7141),
    [anon_sym_EQ] = ACTIONS(6919),
    [anon_sym_if] = ACTIONS(7141),
    [anon_sym_for] = ACTIONS(7141),
    [anon_sym_while] = ACTIONS(7141),
    [anon_sym_repeat] = ACTIONS(7141),
    [anon_sym_QMARK] = ACTIONS(7145),
    [anon_sym_TILDE] = ACTIONS(6921),
    [anon_sym_BANG] = ACTIONS(7141),
    [anon_sym_PLUS] = ACTIONS(6923),
    [anon_sym_DASH] = ACTIONS(6925),
    [anon_sym_LT_DASH] = ACTIONS(7147),
    [anon_sym_LT_LT_DASH] = ACTIONS(7147),
    [anon_sym_COLON_EQ] = ACTIONS(7147),
    [anon_sym_DASH_GT] = ACTIONS(6927),
    [anon_sym_DASH_GT_GT] = ACTIONS(6929),
    [anon_sym_PIPE] = ACTIONS(6931),
    [anon_sym_AMP] = ACTIONS(6933),
    [anon_sym_PIPE_PIPE] = ACTIONS(6935),
    [anon_sym_AMP_AMP] = ACTIONS(6937),
    [anon_sym_LT] = ACTIONS(6939),
    [anon_sym_LT_EQ] = ACTIONS(6941),
    [anon_sym_GT] = ACTIONS(6939),
    [anon_sym_GT_EQ] = ACTIONS(6941),
    [anon_sym_EQ_EQ] = ACTIONS(6941),
    [anon_sym_BANG_EQ] = ACTIONS(6941),
    [anon_sym_STAR] = ACTIONS(6943),
    [anon_sym_SLASH] = ACTIONS(6945),
    [anon_sym_STAR_STAR] = ACTIONS(6947),
    [anon_sym_CARET] = ACTIONS(6947),
    [aux_sym_binary_operator_token1] = ACTIONS(6949),
    [anon_sym_PIPE_GT] = ACTIONS(6949),
    [anon_sym_COLON] = ACTIONS(6951),
    [anon_sym_DOLLAR] = ACTIONS(6953),
    [anon_sym_AT] = ACTIONS(6953),
    [aux_sym__hex_literal_token1] = ACTIONS(7143),
    [sym__number_literal] = ACTIONS(7141),
    [anon_sym_SQUOTE] = ACTIONS(7143),
    [anon_sym_DQUOTE] = ACTIONS(7143),
    [sym_return] = ACTIONS(7141),
    [sym_next] = ACTIONS(7141),
    [sym_break] = ACTIONS(7141),
    [sym_true] = ACTIONS(7141),
    [sym_false] = ACTIONS(7141),
    [sym_null] = ACTIONS(7141),
    [sym_inf] = ACTIONS(7141),
    [sym_nan] = ACTIONS(7141),
    [anon_sym_NA] = ACTIONS(7141),
    [anon_sym_NA_integer_] = ACTIONS(7141),
    [anon_sym_NA_real_] = ACTIONS(7141),
    [anon_sym_NA_complex_] = ACTIONS(7141),
    [anon_sym_NA_character_] = ACTIONS(7141),
    [sym_dots] = ACTIONS(7141),
    [sym_dot_dot_i] = ACTIONS(7143),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7143),
    [sym__newline] = ACTIONS(7143),
    [sym__raw_string_literal] = ACTIONS(7143),
    [sym__external_open_parenthesis] = ACTIONS(6955),
    [sym__external_close_parenthesis] = ACTIONS(7143),
    [sym__external_open_brace] = ACTIONS(7143),
    [sym__external_open_bracket] = ACTIONS(6957),
    [sym__external_open_bracket2] = ACTIONS(6959),
  },
  [1932] = {
    [sym_call_arguments] = STATE(3027),
    [sym_subset_arguments] = STATE(3026),
    [sym_subset2_arguments] = STATE(3025),
    [sym__open_parenthesis] = STATE(1616),
    [sym__open_bracket] = STATE(1615),
    [sym__open_bracket2] = STATE(1613),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(7061),
    [anon_sym_SLASH] = ACTIONS(7063),
    [anon_sym_STAR_STAR] = ACTIONS(7065),
    [anon_sym_CARET] = ACTIONS(7065),
    [aux_sym_binary_operator_token1] = ACTIONS(7067),
    [anon_sym_PIPE_GT] = ACTIONS(7067),
    [anon_sym_COLON] = ACTIONS(7069),
    [anon_sym_DOLLAR] = ACTIONS(7071),
    [anon_sym_AT] = ACTIONS(7071),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(7073),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(7075),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(7077),
  },
  [1933] = {
    [sym_call_arguments] = STATE(2941),
    [sym_subset_arguments] = STATE(2942),
    [sym_subset2_arguments] = STATE(2943),
    [sym__open_parenthesis] = STATE(1755),
    [sym__open_bracket] = STATE(1763),
    [sym__open_bracket2] = STATE(1866),
    [sym_identifier] = ACTIONS(5401),
    [anon_sym_BSLASH] = ACTIONS(5399),
    [anon_sym_function] = ACTIONS(5401),
    [anon_sym_EQ] = ACTIONS(6919),
    [anon_sym_if] = ACTIONS(5401),
    [anon_sym_for] = ACTIONS(5401),
    [anon_sym_while] = ACTIONS(5401),
    [anon_sym_repeat] = ACTIONS(5401),
    [anon_sym_QMARK] = ACTIONS(5399),
    [anon_sym_TILDE] = ACTIONS(6921),
    [anon_sym_BANG] = ACTIONS(5401),
    [anon_sym_PLUS] = ACTIONS(6923),
    [anon_sym_DASH] = ACTIONS(6925),
    [anon_sym_LT_DASH] = ACTIONS(7147),
    [anon_sym_LT_LT_DASH] = ACTIONS(7147),
    [anon_sym_COLON_EQ] = ACTIONS(7147),
    [anon_sym_DASH_GT] = ACTIONS(6927),
    [anon_sym_DASH_GT_GT] = ACTIONS(6929),
    [anon_sym_PIPE] = ACTIONS(6931),
    [anon_sym_AMP] = ACTIONS(6933),
    [anon_sym_PIPE_PIPE] = ACTIONS(6935),
    [anon_sym_AMP_AMP] = ACTIONS(6937),
    [anon_sym_LT] = ACTIONS(6939),
    [anon_sym_LT_EQ] = ACTIONS(6941),
    [anon_sym_GT] = ACTIONS(6939),
    [anon_sym_GT_EQ] = ACTIONS(6941),
    [anon_sym_EQ_EQ] = ACTIONS(6941),
    [anon_sym_BANG_EQ] = ACTIONS(6941),
    [anon_sym_STAR] = ACTIONS(6943),
    [anon_sym_SLASH] = ACTIONS(6945),
    [anon_sym_STAR_STAR] = ACTIONS(6947),
    [anon_sym_CARET] = ACTIONS(6947),
    [aux_sym_binary_operator_token1] = ACTIONS(6949),
    [anon_sym_PIPE_GT] = ACTIONS(6949),
    [anon_sym_COLON] = ACTIONS(6951),
    [anon_sym_DOLLAR] = ACTIONS(6953),
    [anon_sym_AT] = ACTIONS(6953),
    [aux_sym__hex_literal_token1] = ACTIONS(5399),
    [sym__number_literal] = ACTIONS(5401),
    [anon_sym_SQUOTE] = ACTIONS(5399),
    [anon_sym_DQUOTE] = ACTIONS(5399),
    [sym_return] = ACTIONS(5401),
    [sym_next] = ACTIONS(5401),
    [sym_break] = ACTIONS(5401),
    [sym_true] = ACTIONS(5401),
    [sym_false] = ACTIONS(5401),
    [sym_null] = ACTIONS(5401),
    [sym_inf] = ACTIONS(5401),
    [sym_nan] = ACTIONS(5401),
    [anon_sym_NA] = ACTIONS(5401),
    [anon_sym_NA_integer_] = ACTIONS(5401),
    [anon_sym_NA_real_] = ACTIONS(5401),
    [anon_sym_NA_complex_] = ACTIONS(5401),
    [anon_sym_NA_character_] = ACTIONS(5401),
    [sym_dots] = ACTIONS(5401),
    [sym_dot_dot_i] = ACTIONS(5399),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5399),
    [sym__newline] = ACTIONS(5399),
    [sym__raw_string_literal] = ACTIONS(5399),
    [sym__external_open_parenthesis] = ACTIONS(6955),
    [sym__external_close_parenthesis] = ACTIONS(5399),
    [sym__external_open_brace] = ACTIONS(5399),
    [sym__external_open_bracket] = ACTIONS(6957),
    [sym__external_open_bracket2] = ACTIONS(6959),
  },
  [1934] = {
    [sym_identifier] = ACTIONS(7115),
    [anon_sym_BSLASH] = ACTIONS(7117),
    [anon_sym_function] = ACTIONS(7115),
    [anon_sym_EQ] = ACTIONS(7115),
    [anon_sym_if] = ACTIONS(7115),
    [anon_sym_for] = ACTIONS(7115),
    [anon_sym_while] = ACTIONS(7115),
    [anon_sym_repeat] = ACTIONS(7115),
    [anon_sym_QMARK] = ACTIONS(7117),
    [anon_sym_TILDE] = ACTIONS(7117),
    [anon_sym_BANG] = ACTIONS(7115),
    [anon_sym_PLUS] = ACTIONS(7117),
    [anon_sym_DASH] = ACTIONS(7115),
    [anon_sym_LT_DASH] = ACTIONS(7117),
    [anon_sym_LT_LT_DASH] = ACTIONS(7117),
    [anon_sym_COLON_EQ] = ACTIONS(7117),
    [anon_sym_DASH_GT] = ACTIONS(7115),
    [anon_sym_DASH_GT_GT] = ACTIONS(7117),
    [anon_sym_PIPE] = ACTIONS(7115),
    [anon_sym_AMP] = ACTIONS(7115),
    [anon_sym_PIPE_PIPE] = ACTIONS(7117),
    [anon_sym_AMP_AMP] = ACTIONS(7117),
    [anon_sym_LT] = ACTIONS(7115),
    [anon_sym_LT_EQ] = ACTIONS(7117),
    [anon_sym_GT] = ACTIONS(7115),
    [anon_sym_GT_EQ] = ACTIONS(7117),
    [anon_sym_EQ_EQ] = ACTIONS(7117),
    [anon_sym_BANG_EQ] = ACTIONS(7117),
    [anon_sym_STAR] = ACTIONS(7115),
    [anon_sym_SLASH] = ACTIONS(7117),
    [anon_sym_STAR_STAR] = ACTIONS(7117),
    [anon_sym_CARET] = ACTIONS(7117),
    [aux_sym_binary_operator_token1] = ACTIONS(7117),
    [anon_sym_PIPE_GT] = ACTIONS(7117),
    [anon_sym_COLON] = ACTIONS(7115),
    [anon_sym_DOLLAR] = ACTIONS(7117),
    [anon_sym_AT] = ACTIONS(7117),
    [anon_sym_COLON_COLON] = ACTIONS(7115),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7117),
    [aux_sym__hex_literal_token1] = ACTIONS(7117),
    [sym__number_literal] = ACTIONS(7115),
    [anon_sym_SQUOTE] = ACTIONS(7117),
    [anon_sym_DQUOTE] = ACTIONS(7117),
    [sym_return] = ACTIONS(7115),
    [sym_next] = ACTIONS(7115),
    [sym_break] = ACTIONS(7115),
    [sym_true] = ACTIONS(7115),
    [sym_false] = ACTIONS(7115),
    [sym_null] = ACTIONS(7115),
    [sym_inf] = ACTIONS(7115),
    [sym_nan] = ACTIONS(7115),
    [anon_sym_NA] = ACTIONS(7115),
    [anon_sym_NA_integer_] = ACTIONS(7115),
    [anon_sym_NA_real_] = ACTIONS(7115),
    [anon_sym_NA_complex_] = ACTIONS(7115),
    [anon_sym_NA_character_] = ACTIONS(7115),
    [sym_dots] = ACTIONS(7115),
    [sym_dot_dot_i] = ACTIONS(7117),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7117),
    [sym__newline] = ACTIONS(7117),
    [sym__semicolon] = ACTIONS(7117),
    [sym__raw_string_literal] = ACTIONS(7117),
    [sym__external_else] = ACTIONS(7117),
    [sym__external_open_parenthesis] = ACTIONS(7117),
    [sym__external_close_parenthesis] = ACTIONS(7117),
    [sym__external_open_brace] = ACTIONS(7117),
    [sym__external_close_brace] = ACTIONS(7117),
    [sym__external_open_bracket] = ACTIONS(7117),
    [sym__external_open_bracket2] = ACTIONS(7117),
    [sym__external_close_bracket2] = ACTIONS(7117),
  },
  [1935] = {
    [sym_call_arguments] = STATE(2978),
    [sym_subset_arguments] = STATE(2977),
    [sym_subset2_arguments] = STATE(2976),
    [sym__open_parenthesis] = STATE(1606),
    [sym__open_bracket] = STATE(1598),
    [sym__open_bracket2] = STATE(1592),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(6875),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(6877),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(6879),
    [anon_sym_DASH] = ACTIONS(6881),
    [anon_sym_LT_DASH] = ACTIONS(6883),
    [anon_sym_LT_LT_DASH] = ACTIONS(6883),
    [anon_sym_COLON_EQ] = ACTIONS(6883),
    [anon_sym_DASH_GT] = ACTIONS(6885),
    [anon_sym_DASH_GT_GT] = ACTIONS(6887),
    [anon_sym_PIPE] = ACTIONS(6889),
    [anon_sym_AMP] = ACTIONS(6891),
    [anon_sym_PIPE_PIPE] = ACTIONS(6893),
    [anon_sym_AMP_AMP] = ACTIONS(6895),
    [anon_sym_LT] = ACTIONS(6897),
    [anon_sym_LT_EQ] = ACTIONS(6899),
    [anon_sym_GT] = ACTIONS(6897),
    [anon_sym_GT_EQ] = ACTIONS(6899),
    [anon_sym_EQ_EQ] = ACTIONS(6899),
    [anon_sym_BANG_EQ] = ACTIONS(6899),
    [anon_sym_STAR] = ACTIONS(6901),
    [anon_sym_SLASH] = ACTIONS(6903),
    [anon_sym_STAR_STAR] = ACTIONS(6905),
    [anon_sym_CARET] = ACTIONS(6905),
    [aux_sym_binary_operator_token1] = ACTIONS(6907),
    [anon_sym_PIPE_GT] = ACTIONS(6907),
    [anon_sym_COLON] = ACTIONS(6909),
    [anon_sym_DOLLAR] = ACTIONS(6911),
    [anon_sym_AT] = ACTIONS(6911),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6913),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6915),
    [sym__external_open_bracket2] = ACTIONS(6917),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [1936] = {
    [sym_call_arguments] = STATE(2985),
    [sym_subset_arguments] = STATE(2986),
    [sym_subset2_arguments] = STATE(2987),
    [sym__open_parenthesis] = STATE(1414),
    [sym__open_bracket] = STATE(1416),
    [sym__open_bracket2] = STATE(1428),
    [ts_builtin_sym_end] = ACTIONS(5333),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(5333),
    [anon_sym_DASH] = ACTIONS(5335),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5335),
    [anon_sym_AMP] = ACTIONS(5335),
    [anon_sym_PIPE_PIPE] = ACTIONS(5333),
    [anon_sym_AMP_AMP] = ACTIONS(5333),
    [anon_sym_LT] = ACTIONS(5335),
    [anon_sym_LT_EQ] = ACTIONS(5333),
    [anon_sym_GT] = ACTIONS(5335),
    [anon_sym_GT_EQ] = ACTIONS(5333),
    [anon_sym_EQ_EQ] = ACTIONS(5333),
    [anon_sym_BANG_EQ] = ACTIONS(5333),
    [anon_sym_STAR] = ACTIONS(5335),
    [anon_sym_SLASH] = ACTIONS(5333),
    [anon_sym_STAR_STAR] = ACTIONS(7101),
    [anon_sym_CARET] = ACTIONS(7101),
    [aux_sym_binary_operator_token1] = ACTIONS(5333),
    [anon_sym_PIPE_GT] = ACTIONS(5333),
    [anon_sym_COLON] = ACTIONS(5335),
    [anon_sym_DOLLAR] = ACTIONS(7107),
    [anon_sym_AT] = ACTIONS(7107),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5333),
    [sym__semicolon] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(7109),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(7111),
    [sym__external_open_bracket2] = ACTIONS(7113),
  },
  [1937] = {
    [sym_call_arguments] = STATE(2978),
    [sym_subset_arguments] = STATE(2977),
    [sym_subset2_arguments] = STATE(2976),
    [sym__open_parenthesis] = STATE(1606),
    [sym__open_bracket] = STATE(1598),
    [sym__open_bracket2] = STATE(1592),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(6879),
    [anon_sym_DASH] = ACTIONS(6881),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(6889),
    [anon_sym_AMP] = ACTIONS(6891),
    [anon_sym_PIPE_PIPE] = ACTIONS(6893),
    [anon_sym_AMP_AMP] = ACTIONS(6895),
    [anon_sym_LT] = ACTIONS(6897),
    [anon_sym_LT_EQ] = ACTIONS(6899),
    [anon_sym_GT] = ACTIONS(6897),
    [anon_sym_GT_EQ] = ACTIONS(6899),
    [anon_sym_EQ_EQ] = ACTIONS(6899),
    [anon_sym_BANG_EQ] = ACTIONS(6899),
    [anon_sym_STAR] = ACTIONS(6901),
    [anon_sym_SLASH] = ACTIONS(6903),
    [anon_sym_STAR_STAR] = ACTIONS(6905),
    [anon_sym_CARET] = ACTIONS(6905),
    [aux_sym_binary_operator_token1] = ACTIONS(6907),
    [anon_sym_PIPE_GT] = ACTIONS(6907),
    [anon_sym_COLON] = ACTIONS(6909),
    [anon_sym_DOLLAR] = ACTIONS(6911),
    [anon_sym_AT] = ACTIONS(6911),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6913),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6915),
    [sym__external_open_bracket2] = ACTIONS(6917),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [1938] = {
    [sym_call_arguments] = STATE(2985),
    [sym_subset_arguments] = STATE(2986),
    [sym_subset2_arguments] = STATE(2987),
    [sym__open_parenthesis] = STATE(1414),
    [sym__open_bracket] = STATE(1416),
    [sym__open_bracket2] = STATE(1428),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(7101),
    [anon_sym_CARET] = ACTIONS(7101),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(5351),
    [anon_sym_DOLLAR] = ACTIONS(7107),
    [anon_sym_AT] = ACTIONS(7107),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(7109),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(7111),
    [sym__external_open_bracket2] = ACTIONS(7113),
  },
  [1939] = {
    [sym_call_arguments] = STATE(2978),
    [sym_subset_arguments] = STATE(2977),
    [sym_subset2_arguments] = STATE(2976),
    [sym__open_parenthesis] = STATE(1606),
    [sym__open_bracket] = STATE(1598),
    [sym__open_bracket2] = STATE(1592),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(6901),
    [anon_sym_SLASH] = ACTIONS(6903),
    [anon_sym_STAR_STAR] = ACTIONS(6905),
    [anon_sym_CARET] = ACTIONS(6905),
    [aux_sym_binary_operator_token1] = ACTIONS(6907),
    [anon_sym_PIPE_GT] = ACTIONS(6907),
    [anon_sym_COLON] = ACTIONS(6909),
    [anon_sym_DOLLAR] = ACTIONS(6911),
    [anon_sym_AT] = ACTIONS(6911),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6913),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6915),
    [sym__external_open_bracket2] = ACTIONS(6917),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [1940] = {
    [sym_call_arguments] = STATE(2978),
    [sym_subset_arguments] = STATE(2977),
    [sym_subset2_arguments] = STATE(2976),
    [sym__open_parenthesis] = STATE(1606),
    [sym__open_bracket] = STATE(1598),
    [sym__open_bracket2] = STATE(1592),
    [sym_identifier] = ACTIONS(7141),
    [anon_sym_BSLASH] = ACTIONS(7143),
    [anon_sym_function] = ACTIONS(7141),
    [anon_sym_EQ] = ACTIONS(6875),
    [anon_sym_if] = ACTIONS(7141),
    [anon_sym_for] = ACTIONS(7141),
    [anon_sym_while] = ACTIONS(7141),
    [anon_sym_repeat] = ACTIONS(7141),
    [anon_sym_QMARK] = ACTIONS(7149),
    [anon_sym_TILDE] = ACTIONS(6877),
    [anon_sym_BANG] = ACTIONS(7141),
    [anon_sym_PLUS] = ACTIONS(6879),
    [anon_sym_DASH] = ACTIONS(6881),
    [anon_sym_LT_DASH] = ACTIONS(6883),
    [anon_sym_LT_LT_DASH] = ACTIONS(6883),
    [anon_sym_COLON_EQ] = ACTIONS(6883),
    [anon_sym_DASH_GT] = ACTIONS(6885),
    [anon_sym_DASH_GT_GT] = ACTIONS(6887),
    [anon_sym_PIPE] = ACTIONS(6889),
    [anon_sym_AMP] = ACTIONS(6891),
    [anon_sym_PIPE_PIPE] = ACTIONS(6893),
    [anon_sym_AMP_AMP] = ACTIONS(6895),
    [anon_sym_LT] = ACTIONS(6897),
    [anon_sym_LT_EQ] = ACTIONS(6899),
    [anon_sym_GT] = ACTIONS(6897),
    [anon_sym_GT_EQ] = ACTIONS(6899),
    [anon_sym_EQ_EQ] = ACTIONS(6899),
    [anon_sym_BANG_EQ] = ACTIONS(6899),
    [anon_sym_STAR] = ACTIONS(6901),
    [anon_sym_SLASH] = ACTIONS(6903),
    [anon_sym_STAR_STAR] = ACTIONS(6905),
    [anon_sym_CARET] = ACTIONS(6905),
    [aux_sym_binary_operator_token1] = ACTIONS(6907),
    [anon_sym_PIPE_GT] = ACTIONS(6907),
    [anon_sym_COLON] = ACTIONS(6909),
    [anon_sym_DOLLAR] = ACTIONS(6911),
    [anon_sym_AT] = ACTIONS(6911),
    [aux_sym__hex_literal_token1] = ACTIONS(7143),
    [sym__number_literal] = ACTIONS(7141),
    [anon_sym_SQUOTE] = ACTIONS(7143),
    [anon_sym_DQUOTE] = ACTIONS(7143),
    [sym_return] = ACTIONS(7141),
    [sym_next] = ACTIONS(7141),
    [sym_break] = ACTIONS(7141),
    [sym_true] = ACTIONS(7141),
    [sym_false] = ACTIONS(7141),
    [sym_null] = ACTIONS(7141),
    [sym_inf] = ACTIONS(7141),
    [sym_nan] = ACTIONS(7141),
    [anon_sym_NA] = ACTIONS(7141),
    [anon_sym_NA_integer_] = ACTIONS(7141),
    [anon_sym_NA_real_] = ACTIONS(7141),
    [anon_sym_NA_complex_] = ACTIONS(7141),
    [anon_sym_NA_character_] = ACTIONS(7141),
    [sym_dots] = ACTIONS(7141),
    [sym_dot_dot_i] = ACTIONS(7143),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7143),
    [sym__newline] = ACTIONS(7143),
    [sym__raw_string_literal] = ACTIONS(7143),
    [sym__external_open_parenthesis] = ACTIONS(6913),
    [sym__external_open_brace] = ACTIONS(7143),
    [sym__external_open_bracket] = ACTIONS(6915),
    [sym__external_open_bracket2] = ACTIONS(6917),
    [sym__external_close_bracket2] = ACTIONS(7143),
  },
  [1941] = {
    [sym_call_arguments] = STATE(3027),
    [sym_subset_arguments] = STATE(3026),
    [sym_subset2_arguments] = STATE(3025),
    [sym__open_parenthesis] = STATE(1616),
    [sym__open_bracket] = STATE(1615),
    [sym__open_bracket2] = STATE(1613),
    [sym_identifier] = ACTIONS(5339),
    [anon_sym_BSLASH] = ACTIONS(5337),
    [anon_sym_function] = ACTIONS(5339),
    [anon_sym_EQ] = ACTIONS(7035),
    [anon_sym_if] = ACTIONS(5339),
    [anon_sym_for] = ACTIONS(5339),
    [anon_sym_while] = ACTIONS(5339),
    [anon_sym_repeat] = ACTIONS(5339),
    [anon_sym_QMARK] = ACTIONS(5337),
    [anon_sym_TILDE] = ACTIONS(7037),
    [anon_sym_BANG] = ACTIONS(5339),
    [anon_sym_PLUS] = ACTIONS(7039),
    [anon_sym_DASH] = ACTIONS(7041),
    [anon_sym_LT_DASH] = ACTIONS(7043),
    [anon_sym_LT_LT_DASH] = ACTIONS(7043),
    [anon_sym_COLON_EQ] = ACTIONS(7043),
    [anon_sym_DASH_GT] = ACTIONS(7045),
    [anon_sym_DASH_GT_GT] = ACTIONS(7047),
    [anon_sym_PIPE] = ACTIONS(7049),
    [anon_sym_AMP] = ACTIONS(7051),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_AMP_AMP] = ACTIONS(7055),
    [anon_sym_LT] = ACTIONS(7057),
    [anon_sym_LT_EQ] = ACTIONS(7059),
    [anon_sym_GT] = ACTIONS(7057),
    [anon_sym_GT_EQ] = ACTIONS(7059),
    [anon_sym_EQ_EQ] = ACTIONS(7059),
    [anon_sym_BANG_EQ] = ACTIONS(7059),
    [anon_sym_STAR] = ACTIONS(7061),
    [anon_sym_SLASH] = ACTIONS(7063),
    [anon_sym_STAR_STAR] = ACTIONS(7065),
    [anon_sym_CARET] = ACTIONS(7065),
    [aux_sym_binary_operator_token1] = ACTIONS(7067),
    [anon_sym_PIPE_GT] = ACTIONS(7067),
    [anon_sym_COLON] = ACTIONS(7069),
    [anon_sym_DOLLAR] = ACTIONS(7071),
    [anon_sym_AT] = ACTIONS(7071),
    [aux_sym__hex_literal_token1] = ACTIONS(5337),
    [sym__number_literal] = ACTIONS(5339),
    [anon_sym_SQUOTE] = ACTIONS(5337),
    [anon_sym_DQUOTE] = ACTIONS(5337),
    [sym_return] = ACTIONS(5339),
    [sym_next] = ACTIONS(5339),
    [sym_break] = ACTIONS(5339),
    [sym_true] = ACTIONS(5339),
    [sym_false] = ACTIONS(5339),
    [sym_null] = ACTIONS(5339),
    [sym_inf] = ACTIONS(5339),
    [sym_nan] = ACTIONS(5339),
    [anon_sym_NA] = ACTIONS(5339),
    [anon_sym_NA_integer_] = ACTIONS(5339),
    [anon_sym_NA_real_] = ACTIONS(5339),
    [anon_sym_NA_complex_] = ACTIONS(5339),
    [anon_sym_NA_character_] = ACTIONS(5339),
    [sym_dots] = ACTIONS(5339),
    [sym_dot_dot_i] = ACTIONS(5337),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5337),
    [sym__newline] = ACTIONS(5337),
    [sym__raw_string_literal] = ACTIONS(5337),
    [sym__external_open_parenthesis] = ACTIONS(7073),
    [sym__external_open_brace] = ACTIONS(5337),
    [sym__external_open_bracket] = ACTIONS(7075),
    [sym__external_close_bracket] = ACTIONS(5337),
    [sym__external_open_bracket2] = ACTIONS(7077),
  },
  [1942] = {
    [sym_call_arguments] = STATE(2978),
    [sym_subset_arguments] = STATE(2977),
    [sym_subset2_arguments] = STATE(2976),
    [sym__open_parenthesis] = STATE(1606),
    [sym__open_bracket] = STATE(1598),
    [sym__open_bracket2] = STATE(1592),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(6875),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(6877),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(6879),
    [anon_sym_DASH] = ACTIONS(6881),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(6885),
    [anon_sym_DASH_GT_GT] = ACTIONS(6887),
    [anon_sym_PIPE] = ACTIONS(6889),
    [anon_sym_AMP] = ACTIONS(6891),
    [anon_sym_PIPE_PIPE] = ACTIONS(6893),
    [anon_sym_AMP_AMP] = ACTIONS(6895),
    [anon_sym_LT] = ACTIONS(6897),
    [anon_sym_LT_EQ] = ACTIONS(6899),
    [anon_sym_GT] = ACTIONS(6897),
    [anon_sym_GT_EQ] = ACTIONS(6899),
    [anon_sym_EQ_EQ] = ACTIONS(6899),
    [anon_sym_BANG_EQ] = ACTIONS(6899),
    [anon_sym_STAR] = ACTIONS(6901),
    [anon_sym_SLASH] = ACTIONS(6903),
    [anon_sym_STAR_STAR] = ACTIONS(6905),
    [anon_sym_CARET] = ACTIONS(6905),
    [aux_sym_binary_operator_token1] = ACTIONS(6907),
    [anon_sym_PIPE_GT] = ACTIONS(6907),
    [anon_sym_COLON] = ACTIONS(6909),
    [anon_sym_DOLLAR] = ACTIONS(6911),
    [anon_sym_AT] = ACTIONS(6911),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6913),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6915),
    [sym__external_open_bracket2] = ACTIONS(6917),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [1943] = {
    [sym_identifier] = ACTIONS(7151),
    [anon_sym_BSLASH] = ACTIONS(7153),
    [anon_sym_function] = ACTIONS(7151),
    [anon_sym_EQ] = ACTIONS(7151),
    [anon_sym_if] = ACTIONS(7151),
    [anon_sym_for] = ACTIONS(7151),
    [anon_sym_while] = ACTIONS(7151),
    [anon_sym_repeat] = ACTIONS(7151),
    [anon_sym_QMARK] = ACTIONS(7153),
    [anon_sym_TILDE] = ACTIONS(7153),
    [anon_sym_BANG] = ACTIONS(7151),
    [anon_sym_PLUS] = ACTIONS(7153),
    [anon_sym_DASH] = ACTIONS(7151),
    [anon_sym_LT_DASH] = ACTIONS(7153),
    [anon_sym_LT_LT_DASH] = ACTIONS(7153),
    [anon_sym_COLON_EQ] = ACTIONS(7153),
    [anon_sym_DASH_GT] = ACTIONS(7151),
    [anon_sym_DASH_GT_GT] = ACTIONS(7153),
    [anon_sym_PIPE] = ACTIONS(7151),
    [anon_sym_AMP] = ACTIONS(7151),
    [anon_sym_PIPE_PIPE] = ACTIONS(7153),
    [anon_sym_AMP_AMP] = ACTIONS(7153),
    [anon_sym_LT] = ACTIONS(7151),
    [anon_sym_LT_EQ] = ACTIONS(7153),
    [anon_sym_GT] = ACTIONS(7151),
    [anon_sym_GT_EQ] = ACTIONS(7153),
    [anon_sym_EQ_EQ] = ACTIONS(7153),
    [anon_sym_BANG_EQ] = ACTIONS(7153),
    [anon_sym_STAR] = ACTIONS(7151),
    [anon_sym_SLASH] = ACTIONS(7153),
    [anon_sym_STAR_STAR] = ACTIONS(7153),
    [anon_sym_CARET] = ACTIONS(7153),
    [aux_sym_binary_operator_token1] = ACTIONS(7153),
    [anon_sym_PIPE_GT] = ACTIONS(7153),
    [anon_sym_COLON] = ACTIONS(7151),
    [anon_sym_DOLLAR] = ACTIONS(7153),
    [anon_sym_AT] = ACTIONS(7153),
    [anon_sym_COLON_COLON] = ACTIONS(7151),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7153),
    [aux_sym__hex_literal_token1] = ACTIONS(7153),
    [sym__number_literal] = ACTIONS(7151),
    [anon_sym_SQUOTE] = ACTIONS(7153),
    [anon_sym_DQUOTE] = ACTIONS(7153),
    [sym_return] = ACTIONS(7151),
    [sym_next] = ACTIONS(7151),
    [sym_break] = ACTIONS(7151),
    [sym_true] = ACTIONS(7151),
    [sym_false] = ACTIONS(7151),
    [sym_null] = ACTIONS(7151),
    [sym_inf] = ACTIONS(7151),
    [sym_nan] = ACTIONS(7151),
    [anon_sym_NA] = ACTIONS(7151),
    [anon_sym_NA_integer_] = ACTIONS(7151),
    [anon_sym_NA_real_] = ACTIONS(7151),
    [anon_sym_NA_complex_] = ACTIONS(7151),
    [anon_sym_NA_character_] = ACTIONS(7151),
    [sym_dots] = ACTIONS(7151),
    [sym_dot_dot_i] = ACTIONS(7153),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7153),
    [sym__newline] = ACTIONS(7153),
    [sym__semicolon] = ACTIONS(7153),
    [sym__raw_string_literal] = ACTIONS(7153),
    [sym__external_else] = ACTIONS(7153),
    [sym__external_open_parenthesis] = ACTIONS(7153),
    [sym__external_close_parenthesis] = ACTIONS(7153),
    [sym__external_open_brace] = ACTIONS(7153),
    [sym__external_close_brace] = ACTIONS(7153),
    [sym__external_open_bracket] = ACTIONS(7153),
    [sym__external_open_bracket2] = ACTIONS(7153),
    [sym__external_close_bracket2] = ACTIONS(7153),
  },
  [1944] = {
    [sym_call_arguments] = STATE(2978),
    [sym_subset_arguments] = STATE(2977),
    [sym_subset2_arguments] = STATE(2976),
    [sym__open_parenthesis] = STATE(1606),
    [sym__open_bracket] = STATE(1598),
    [sym__open_bracket2] = STATE(1592),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(6877),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(6879),
    [anon_sym_DASH] = ACTIONS(6881),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(6889),
    [anon_sym_AMP] = ACTIONS(6891),
    [anon_sym_PIPE_PIPE] = ACTIONS(6893),
    [anon_sym_AMP_AMP] = ACTIONS(6895),
    [anon_sym_LT] = ACTIONS(6897),
    [anon_sym_LT_EQ] = ACTIONS(6899),
    [anon_sym_GT] = ACTIONS(6897),
    [anon_sym_GT_EQ] = ACTIONS(6899),
    [anon_sym_EQ_EQ] = ACTIONS(6899),
    [anon_sym_BANG_EQ] = ACTIONS(6899),
    [anon_sym_STAR] = ACTIONS(6901),
    [anon_sym_SLASH] = ACTIONS(6903),
    [anon_sym_STAR_STAR] = ACTIONS(6905),
    [anon_sym_CARET] = ACTIONS(6905),
    [aux_sym_binary_operator_token1] = ACTIONS(6907),
    [anon_sym_PIPE_GT] = ACTIONS(6907),
    [anon_sym_COLON] = ACTIONS(6909),
    [anon_sym_DOLLAR] = ACTIONS(6911),
    [anon_sym_AT] = ACTIONS(6911),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6913),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6915),
    [sym__external_open_bracket2] = ACTIONS(6917),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [1945] = {
    [sym_call_arguments] = STATE(3027),
    [sym_subset_arguments] = STATE(3026),
    [sym_subset2_arguments] = STATE(3025),
    [sym__open_parenthesis] = STATE(1616),
    [sym__open_bracket] = STATE(1615),
    [sym__open_bracket2] = STATE(1613),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(7035),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(7037),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(7039),
    [anon_sym_DASH] = ACTIONS(7041),
    [anon_sym_LT_DASH] = ACTIONS(7043),
    [anon_sym_LT_LT_DASH] = ACTIONS(7043),
    [anon_sym_COLON_EQ] = ACTIONS(7043),
    [anon_sym_DASH_GT] = ACTIONS(7045),
    [anon_sym_DASH_GT_GT] = ACTIONS(7047),
    [anon_sym_PIPE] = ACTIONS(7049),
    [anon_sym_AMP] = ACTIONS(7051),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_AMP_AMP] = ACTIONS(7055),
    [anon_sym_LT] = ACTIONS(7057),
    [anon_sym_LT_EQ] = ACTIONS(7059),
    [anon_sym_GT] = ACTIONS(7057),
    [anon_sym_GT_EQ] = ACTIONS(7059),
    [anon_sym_EQ_EQ] = ACTIONS(7059),
    [anon_sym_BANG_EQ] = ACTIONS(7059),
    [anon_sym_STAR] = ACTIONS(7061),
    [anon_sym_SLASH] = ACTIONS(7063),
    [anon_sym_STAR_STAR] = ACTIONS(7065),
    [anon_sym_CARET] = ACTIONS(7065),
    [aux_sym_binary_operator_token1] = ACTIONS(7067),
    [anon_sym_PIPE_GT] = ACTIONS(7067),
    [anon_sym_COLON] = ACTIONS(7069),
    [anon_sym_DOLLAR] = ACTIONS(7071),
    [anon_sym_AT] = ACTIONS(7071),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(7073),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(7075),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(7077),
  },
  [1946] = {
    [sym_call_arguments] = STATE(2985),
    [sym_subset_arguments] = STATE(2986),
    [sym_subset2_arguments] = STATE(2987),
    [sym__open_parenthesis] = STATE(1414),
    [sym__open_bracket] = STATE(1416),
    [sym__open_bracket2] = STATE(1428),
    [ts_builtin_sym_end] = ACTIONS(5445),
    [sym_identifier] = ACTIONS(5447),
    [anon_sym_BSLASH] = ACTIONS(5445),
    [anon_sym_function] = ACTIONS(5447),
    [anon_sym_EQ] = ACTIONS(7155),
    [anon_sym_if] = ACTIONS(5447),
    [anon_sym_for] = ACTIONS(5447),
    [anon_sym_while] = ACTIONS(5447),
    [anon_sym_repeat] = ACTIONS(5447),
    [anon_sym_QMARK] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(7079),
    [anon_sym_BANG] = ACTIONS(5447),
    [anon_sym_PLUS] = ACTIONS(7081),
    [anon_sym_DASH] = ACTIONS(7083),
    [anon_sym_LT_DASH] = ACTIONS(7157),
    [anon_sym_LT_LT_DASH] = ACTIONS(7157),
    [anon_sym_COLON_EQ] = ACTIONS(7157),
    [anon_sym_DASH_GT] = ACTIONS(7159),
    [anon_sym_DASH_GT_GT] = ACTIONS(7161),
    [anon_sym_PIPE] = ACTIONS(7085),
    [anon_sym_AMP] = ACTIONS(7087),
    [anon_sym_PIPE_PIPE] = ACTIONS(7089),
    [anon_sym_AMP_AMP] = ACTIONS(7091),
    [anon_sym_LT] = ACTIONS(7093),
    [anon_sym_LT_EQ] = ACTIONS(7095),
    [anon_sym_GT] = ACTIONS(7093),
    [anon_sym_GT_EQ] = ACTIONS(7095),
    [anon_sym_EQ_EQ] = ACTIONS(7095),
    [anon_sym_BANG_EQ] = ACTIONS(7095),
    [anon_sym_STAR] = ACTIONS(7097),
    [anon_sym_SLASH] = ACTIONS(7099),
    [anon_sym_STAR_STAR] = ACTIONS(7101),
    [anon_sym_CARET] = ACTIONS(7101),
    [aux_sym_binary_operator_token1] = ACTIONS(7103),
    [anon_sym_PIPE_GT] = ACTIONS(7103),
    [anon_sym_COLON] = ACTIONS(7105),
    [anon_sym_DOLLAR] = ACTIONS(7107),
    [anon_sym_AT] = ACTIONS(7107),
    [aux_sym__hex_literal_token1] = ACTIONS(5445),
    [sym__number_literal] = ACTIONS(5447),
    [anon_sym_SQUOTE] = ACTIONS(5445),
    [anon_sym_DQUOTE] = ACTIONS(5445),
    [sym_return] = ACTIONS(5447),
    [sym_next] = ACTIONS(5447),
    [sym_break] = ACTIONS(5447),
    [sym_true] = ACTIONS(5447),
    [sym_false] = ACTIONS(5447),
    [sym_null] = ACTIONS(5447),
    [sym_inf] = ACTIONS(5447),
    [sym_nan] = ACTIONS(5447),
    [anon_sym_NA] = ACTIONS(5447),
    [anon_sym_NA_integer_] = ACTIONS(5447),
    [anon_sym_NA_real_] = ACTIONS(5447),
    [anon_sym_NA_complex_] = ACTIONS(5447),
    [anon_sym_NA_character_] = ACTIONS(5447),
    [sym_dots] = ACTIONS(5447),
    [sym_dot_dot_i] = ACTIONS(5445),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5445),
    [sym__semicolon] = ACTIONS(5445),
    [sym__raw_string_literal] = ACTIONS(5445),
    [sym__external_open_parenthesis] = ACTIONS(7109),
    [sym__external_open_brace] = ACTIONS(5445),
    [sym__external_open_bracket] = ACTIONS(7111),
    [sym__external_open_bracket2] = ACTIONS(7113),
  },
  [1947] = {
    [sym_identifier] = ACTIONS(7163),
    [anon_sym_BSLASH] = ACTIONS(7165),
    [anon_sym_function] = ACTIONS(7163),
    [anon_sym_EQ] = ACTIONS(7163),
    [anon_sym_if] = ACTIONS(7163),
    [anon_sym_for] = ACTIONS(7163),
    [anon_sym_while] = ACTIONS(7163),
    [anon_sym_repeat] = ACTIONS(7163),
    [anon_sym_QMARK] = ACTIONS(7165),
    [anon_sym_TILDE] = ACTIONS(7165),
    [anon_sym_BANG] = ACTIONS(7163),
    [anon_sym_PLUS] = ACTIONS(7165),
    [anon_sym_DASH] = ACTIONS(7163),
    [anon_sym_LT_DASH] = ACTIONS(7165),
    [anon_sym_LT_LT_DASH] = ACTIONS(7165),
    [anon_sym_COLON_EQ] = ACTIONS(7165),
    [anon_sym_DASH_GT] = ACTIONS(7163),
    [anon_sym_DASH_GT_GT] = ACTIONS(7165),
    [anon_sym_PIPE] = ACTIONS(7163),
    [anon_sym_AMP] = ACTIONS(7163),
    [anon_sym_PIPE_PIPE] = ACTIONS(7165),
    [anon_sym_AMP_AMP] = ACTIONS(7165),
    [anon_sym_LT] = ACTIONS(7163),
    [anon_sym_LT_EQ] = ACTIONS(7165),
    [anon_sym_GT] = ACTIONS(7163),
    [anon_sym_GT_EQ] = ACTIONS(7165),
    [anon_sym_EQ_EQ] = ACTIONS(7165),
    [anon_sym_BANG_EQ] = ACTIONS(7165),
    [anon_sym_STAR] = ACTIONS(7163),
    [anon_sym_SLASH] = ACTIONS(7165),
    [anon_sym_STAR_STAR] = ACTIONS(7165),
    [anon_sym_CARET] = ACTIONS(7165),
    [aux_sym_binary_operator_token1] = ACTIONS(7165),
    [anon_sym_PIPE_GT] = ACTIONS(7165),
    [anon_sym_COLON] = ACTIONS(7163),
    [anon_sym_DOLLAR] = ACTIONS(7165),
    [anon_sym_AT] = ACTIONS(7165),
    [anon_sym_COLON_COLON] = ACTIONS(7163),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7165),
    [aux_sym__hex_literal_token1] = ACTIONS(7165),
    [sym__number_literal] = ACTIONS(7163),
    [anon_sym_SQUOTE] = ACTIONS(7165),
    [anon_sym_DQUOTE] = ACTIONS(7165),
    [sym_return] = ACTIONS(7163),
    [sym_next] = ACTIONS(7163),
    [sym_break] = ACTIONS(7163),
    [sym_true] = ACTIONS(7163),
    [sym_false] = ACTIONS(7163),
    [sym_null] = ACTIONS(7163),
    [sym_inf] = ACTIONS(7163),
    [sym_nan] = ACTIONS(7163),
    [anon_sym_NA] = ACTIONS(7163),
    [anon_sym_NA_integer_] = ACTIONS(7163),
    [anon_sym_NA_real_] = ACTIONS(7163),
    [anon_sym_NA_complex_] = ACTIONS(7163),
    [anon_sym_NA_character_] = ACTIONS(7163),
    [sym_dots] = ACTIONS(7163),
    [sym_dot_dot_i] = ACTIONS(7165),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7165),
    [sym__newline] = ACTIONS(7165),
    [sym__semicolon] = ACTIONS(7165),
    [sym__raw_string_literal] = ACTIONS(7165),
    [sym__external_else] = ACTIONS(7165),
    [sym__external_open_parenthesis] = ACTIONS(7165),
    [sym__external_close_parenthesis] = ACTIONS(7165),
    [sym__external_open_brace] = ACTIONS(7165),
    [sym__external_close_brace] = ACTIONS(7165),
    [sym__external_open_bracket] = ACTIONS(7165),
    [sym__external_open_bracket2] = ACTIONS(7165),
    [sym__external_close_bracket2] = ACTIONS(7165),
  },
  [1948] = {
    [sym_call_arguments] = STATE(2978),
    [sym_subset_arguments] = STATE(2977),
    [sym_subset2_arguments] = STATE(2976),
    [sym__open_parenthesis] = STATE(1606),
    [sym__open_bracket] = STATE(1598),
    [sym__open_bracket2] = STATE(1592),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(6879),
    [anon_sym_DASH] = ACTIONS(6881),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(6897),
    [anon_sym_LT_EQ] = ACTIONS(6899),
    [anon_sym_GT] = ACTIONS(6897),
    [anon_sym_GT_EQ] = ACTIONS(6899),
    [anon_sym_EQ_EQ] = ACTIONS(6899),
    [anon_sym_BANG_EQ] = ACTIONS(6899),
    [anon_sym_STAR] = ACTIONS(6901),
    [anon_sym_SLASH] = ACTIONS(6903),
    [anon_sym_STAR_STAR] = ACTIONS(6905),
    [anon_sym_CARET] = ACTIONS(6905),
    [aux_sym_binary_operator_token1] = ACTIONS(6907),
    [anon_sym_PIPE_GT] = ACTIONS(6907),
    [anon_sym_COLON] = ACTIONS(6909),
    [anon_sym_DOLLAR] = ACTIONS(6911),
    [anon_sym_AT] = ACTIONS(6911),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6913),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6915),
    [sym__external_open_bracket2] = ACTIONS(6917),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [1949] = {
    [sym_call_arguments] = STATE(3027),
    [sym_subset_arguments] = STATE(3026),
    [sym_subset2_arguments] = STATE(3025),
    [sym__open_parenthesis] = STATE(1616),
    [sym__open_bracket] = STATE(1615),
    [sym__open_bracket2] = STATE(1613),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(7037),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(7039),
    [anon_sym_DASH] = ACTIONS(7041),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(7049),
    [anon_sym_AMP] = ACTIONS(7051),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_AMP_AMP] = ACTIONS(7055),
    [anon_sym_LT] = ACTIONS(7057),
    [anon_sym_LT_EQ] = ACTIONS(7059),
    [anon_sym_GT] = ACTIONS(7057),
    [anon_sym_GT_EQ] = ACTIONS(7059),
    [anon_sym_EQ_EQ] = ACTIONS(7059),
    [anon_sym_BANG_EQ] = ACTIONS(7059),
    [anon_sym_STAR] = ACTIONS(7061),
    [anon_sym_SLASH] = ACTIONS(7063),
    [anon_sym_STAR_STAR] = ACTIONS(7065),
    [anon_sym_CARET] = ACTIONS(7065),
    [aux_sym_binary_operator_token1] = ACTIONS(7067),
    [anon_sym_PIPE_GT] = ACTIONS(7067),
    [anon_sym_COLON] = ACTIONS(7069),
    [anon_sym_DOLLAR] = ACTIONS(7071),
    [anon_sym_AT] = ACTIONS(7071),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(7073),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(7075),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(7077),
  },
  [1950] = {
    [sym_call_arguments] = STATE(2985),
    [sym_subset_arguments] = STATE(2986),
    [sym_subset2_arguments] = STATE(2987),
    [sym__open_parenthesis] = STATE(1414),
    [sym__open_bracket] = STATE(1416),
    [sym__open_bracket2] = STATE(1428),
    [ts_builtin_sym_end] = ACTIONS(5449),
    [sym_identifier] = ACTIONS(5451),
    [anon_sym_BSLASH] = ACTIONS(5449),
    [anon_sym_function] = ACTIONS(5451),
    [anon_sym_EQ] = ACTIONS(7155),
    [anon_sym_if] = ACTIONS(5451),
    [anon_sym_for] = ACTIONS(5451),
    [anon_sym_while] = ACTIONS(5451),
    [anon_sym_repeat] = ACTIONS(5451),
    [anon_sym_QMARK] = ACTIONS(5449),
    [anon_sym_TILDE] = ACTIONS(7079),
    [anon_sym_BANG] = ACTIONS(5451),
    [anon_sym_PLUS] = ACTIONS(7081),
    [anon_sym_DASH] = ACTIONS(7083),
    [anon_sym_LT_DASH] = ACTIONS(7157),
    [anon_sym_LT_LT_DASH] = ACTIONS(7157),
    [anon_sym_COLON_EQ] = ACTIONS(7157),
    [anon_sym_DASH_GT] = ACTIONS(7159),
    [anon_sym_DASH_GT_GT] = ACTIONS(7161),
    [anon_sym_PIPE] = ACTIONS(7085),
    [anon_sym_AMP] = ACTIONS(7087),
    [anon_sym_PIPE_PIPE] = ACTIONS(7089),
    [anon_sym_AMP_AMP] = ACTIONS(7091),
    [anon_sym_LT] = ACTIONS(7093),
    [anon_sym_LT_EQ] = ACTIONS(7095),
    [anon_sym_GT] = ACTIONS(7093),
    [anon_sym_GT_EQ] = ACTIONS(7095),
    [anon_sym_EQ_EQ] = ACTIONS(7095),
    [anon_sym_BANG_EQ] = ACTIONS(7095),
    [anon_sym_STAR] = ACTIONS(7097),
    [anon_sym_SLASH] = ACTIONS(7099),
    [anon_sym_STAR_STAR] = ACTIONS(7101),
    [anon_sym_CARET] = ACTIONS(7101),
    [aux_sym_binary_operator_token1] = ACTIONS(7103),
    [anon_sym_PIPE_GT] = ACTIONS(7103),
    [anon_sym_COLON] = ACTIONS(7105),
    [anon_sym_DOLLAR] = ACTIONS(7107),
    [anon_sym_AT] = ACTIONS(7107),
    [aux_sym__hex_literal_token1] = ACTIONS(5449),
    [sym__number_literal] = ACTIONS(5451),
    [anon_sym_SQUOTE] = ACTIONS(5449),
    [anon_sym_DQUOTE] = ACTIONS(5449),
    [sym_return] = ACTIONS(5451),
    [sym_next] = ACTIONS(5451),
    [sym_break] = ACTIONS(5451),
    [sym_true] = ACTIONS(5451),
    [sym_false] = ACTIONS(5451),
    [sym_null] = ACTIONS(5451),
    [sym_inf] = ACTIONS(5451),
    [sym_nan] = ACTIONS(5451),
    [anon_sym_NA] = ACTIONS(5451),
    [anon_sym_NA_integer_] = ACTIONS(5451),
    [anon_sym_NA_real_] = ACTIONS(5451),
    [anon_sym_NA_complex_] = ACTIONS(5451),
    [anon_sym_NA_character_] = ACTIONS(5451),
    [sym_dots] = ACTIONS(5451),
    [sym_dot_dot_i] = ACTIONS(5449),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5449),
    [sym__semicolon] = ACTIONS(5449),
    [sym__raw_string_literal] = ACTIONS(5449),
    [sym__external_open_parenthesis] = ACTIONS(7109),
    [sym__external_open_brace] = ACTIONS(5449),
    [sym__external_open_bracket] = ACTIONS(7111),
    [sym__external_open_bracket2] = ACTIONS(7113),
  },
  [1951] = {
    [sym_call_arguments] = STATE(3027),
    [sym_subset_arguments] = STATE(3026),
    [sym_subset2_arguments] = STATE(3025),
    [sym__open_parenthesis] = STATE(1616),
    [sym__open_bracket] = STATE(1615),
    [sym__open_bracket2] = STATE(1613),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(7039),
    [anon_sym_DASH] = ACTIONS(7041),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(7051),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(7055),
    [anon_sym_LT] = ACTIONS(7057),
    [anon_sym_LT_EQ] = ACTIONS(7059),
    [anon_sym_GT] = ACTIONS(7057),
    [anon_sym_GT_EQ] = ACTIONS(7059),
    [anon_sym_EQ_EQ] = ACTIONS(7059),
    [anon_sym_BANG_EQ] = ACTIONS(7059),
    [anon_sym_STAR] = ACTIONS(7061),
    [anon_sym_SLASH] = ACTIONS(7063),
    [anon_sym_STAR_STAR] = ACTIONS(7065),
    [anon_sym_CARET] = ACTIONS(7065),
    [aux_sym_binary_operator_token1] = ACTIONS(7067),
    [anon_sym_PIPE_GT] = ACTIONS(7067),
    [anon_sym_COLON] = ACTIONS(7069),
    [anon_sym_DOLLAR] = ACTIONS(7071),
    [anon_sym_AT] = ACTIONS(7071),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(7073),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(7075),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(7077),
  },
  [1952] = {
    [sym_call_arguments] = STATE(2985),
    [sym_subset_arguments] = STATE(2986),
    [sym_subset2_arguments] = STATE(2987),
    [sym__open_parenthesis] = STATE(1414),
    [sym__open_bracket] = STATE(1416),
    [sym__open_bracket2] = STATE(1428),
    [ts_builtin_sym_end] = ACTIONS(5399),
    [sym_identifier] = ACTIONS(5401),
    [anon_sym_BSLASH] = ACTIONS(5399),
    [anon_sym_function] = ACTIONS(5401),
    [anon_sym_EQ] = ACTIONS(7155),
    [anon_sym_if] = ACTIONS(5401),
    [anon_sym_for] = ACTIONS(5401),
    [anon_sym_while] = ACTIONS(5401),
    [anon_sym_repeat] = ACTIONS(5401),
    [anon_sym_QMARK] = ACTIONS(5399),
    [anon_sym_TILDE] = ACTIONS(7079),
    [anon_sym_BANG] = ACTIONS(5401),
    [anon_sym_PLUS] = ACTIONS(7081),
    [anon_sym_DASH] = ACTIONS(7083),
    [anon_sym_LT_DASH] = ACTIONS(7157),
    [anon_sym_LT_LT_DASH] = ACTIONS(7157),
    [anon_sym_COLON_EQ] = ACTIONS(7157),
    [anon_sym_DASH_GT] = ACTIONS(7159),
    [anon_sym_DASH_GT_GT] = ACTIONS(7161),
    [anon_sym_PIPE] = ACTIONS(7085),
    [anon_sym_AMP] = ACTIONS(7087),
    [anon_sym_PIPE_PIPE] = ACTIONS(7089),
    [anon_sym_AMP_AMP] = ACTIONS(7091),
    [anon_sym_LT] = ACTIONS(7093),
    [anon_sym_LT_EQ] = ACTIONS(7095),
    [anon_sym_GT] = ACTIONS(7093),
    [anon_sym_GT_EQ] = ACTIONS(7095),
    [anon_sym_EQ_EQ] = ACTIONS(7095),
    [anon_sym_BANG_EQ] = ACTIONS(7095),
    [anon_sym_STAR] = ACTIONS(7097),
    [anon_sym_SLASH] = ACTIONS(7099),
    [anon_sym_STAR_STAR] = ACTIONS(7101),
    [anon_sym_CARET] = ACTIONS(7101),
    [aux_sym_binary_operator_token1] = ACTIONS(7103),
    [anon_sym_PIPE_GT] = ACTIONS(7103),
    [anon_sym_COLON] = ACTIONS(7105),
    [anon_sym_DOLLAR] = ACTIONS(7107),
    [anon_sym_AT] = ACTIONS(7107),
    [aux_sym__hex_literal_token1] = ACTIONS(5399),
    [sym__number_literal] = ACTIONS(5401),
    [anon_sym_SQUOTE] = ACTIONS(5399),
    [anon_sym_DQUOTE] = ACTIONS(5399),
    [sym_return] = ACTIONS(5401),
    [sym_next] = ACTIONS(5401),
    [sym_break] = ACTIONS(5401),
    [sym_true] = ACTIONS(5401),
    [sym_false] = ACTIONS(5401),
    [sym_null] = ACTIONS(5401),
    [sym_inf] = ACTIONS(5401),
    [sym_nan] = ACTIONS(5401),
    [anon_sym_NA] = ACTIONS(5401),
    [anon_sym_NA_integer_] = ACTIONS(5401),
    [anon_sym_NA_real_] = ACTIONS(5401),
    [anon_sym_NA_complex_] = ACTIONS(5401),
    [anon_sym_NA_character_] = ACTIONS(5401),
    [sym_dots] = ACTIONS(5401),
    [sym_dot_dot_i] = ACTIONS(5399),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5399),
    [sym__semicolon] = ACTIONS(5399),
    [sym__raw_string_literal] = ACTIONS(5399),
    [sym__external_open_parenthesis] = ACTIONS(7109),
    [sym__external_open_brace] = ACTIONS(5399),
    [sym__external_open_bracket] = ACTIONS(7111),
    [sym__external_open_bracket2] = ACTIONS(7113),
  },
  [1953] = {
    [sym_call_arguments] = STATE(3027),
    [sym_subset_arguments] = STATE(3026),
    [sym_subset2_arguments] = STATE(3025),
    [sym__open_parenthesis] = STATE(1616),
    [sym__open_bracket] = STATE(1615),
    [sym__open_bracket2] = STATE(1613),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(7039),
    [anon_sym_DASH] = ACTIONS(7041),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(7049),
    [anon_sym_AMP] = ACTIONS(7051),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_AMP_AMP] = ACTIONS(7055),
    [anon_sym_LT] = ACTIONS(7057),
    [anon_sym_LT_EQ] = ACTIONS(7059),
    [anon_sym_GT] = ACTIONS(7057),
    [anon_sym_GT_EQ] = ACTIONS(7059),
    [anon_sym_EQ_EQ] = ACTIONS(7059),
    [anon_sym_BANG_EQ] = ACTIONS(7059),
    [anon_sym_STAR] = ACTIONS(7061),
    [anon_sym_SLASH] = ACTIONS(7063),
    [anon_sym_STAR_STAR] = ACTIONS(7065),
    [anon_sym_CARET] = ACTIONS(7065),
    [aux_sym_binary_operator_token1] = ACTIONS(7067),
    [anon_sym_PIPE_GT] = ACTIONS(7067),
    [anon_sym_COLON] = ACTIONS(7069),
    [anon_sym_DOLLAR] = ACTIONS(7071),
    [anon_sym_AT] = ACTIONS(7071),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(7073),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(7075),
    [sym__external_close_bracket] = ACTIONS(5345),
    [sym__external_open_bracket2] = ACTIONS(7077),
  },
  [1954] = {
    [sym_call_arguments] = STATE(2978),
    [sym_subset_arguments] = STATE(2977),
    [sym_subset2_arguments] = STATE(2976),
    [sym__open_parenthesis] = STATE(1606),
    [sym__open_bracket] = STATE(1598),
    [sym__open_bracket2] = STATE(1592),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(6879),
    [anon_sym_DASH] = ACTIONS(6881),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(6901),
    [anon_sym_SLASH] = ACTIONS(6903),
    [anon_sym_STAR_STAR] = ACTIONS(6905),
    [anon_sym_CARET] = ACTIONS(6905),
    [aux_sym_binary_operator_token1] = ACTIONS(6907),
    [anon_sym_PIPE_GT] = ACTIONS(6907),
    [anon_sym_COLON] = ACTIONS(6909),
    [anon_sym_DOLLAR] = ACTIONS(6911),
    [anon_sym_AT] = ACTIONS(6911),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6913),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6915),
    [sym__external_open_bracket2] = ACTIONS(6917),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [1955] = {
    [sym_call_arguments] = STATE(3027),
    [sym_subset_arguments] = STATE(3026),
    [sym_subset2_arguments] = STATE(3025),
    [sym__open_parenthesis] = STATE(1616),
    [sym__open_bracket] = STATE(1615),
    [sym__open_bracket2] = STATE(1613),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(7065),
    [anon_sym_CARET] = ACTIONS(7065),
    [aux_sym_binary_operator_token1] = ACTIONS(7067),
    [anon_sym_PIPE_GT] = ACTIONS(7067),
    [anon_sym_COLON] = ACTIONS(7069),
    [anon_sym_DOLLAR] = ACTIONS(7071),
    [anon_sym_AT] = ACTIONS(7071),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(7073),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(7075),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(7077),
  },
  [1956] = {
    [sym_call_arguments] = STATE(2978),
    [sym_subset_arguments] = STATE(2977),
    [sym_subset2_arguments] = STATE(2976),
    [sym__open_parenthesis] = STATE(1606),
    [sym__open_bracket] = STATE(1598),
    [sym__open_bracket2] = STATE(1592),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(6905),
    [anon_sym_CARET] = ACTIONS(6905),
    [aux_sym_binary_operator_token1] = ACTIONS(6907),
    [anon_sym_PIPE_GT] = ACTIONS(6907),
    [anon_sym_COLON] = ACTIONS(6909),
    [anon_sym_DOLLAR] = ACTIONS(6911),
    [anon_sym_AT] = ACTIONS(6911),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6913),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6915),
    [sym__external_open_bracket2] = ACTIONS(6917),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [1957] = {
    [sym_call_arguments] = STATE(2978),
    [sym_subset_arguments] = STATE(2977),
    [sym_subset2_arguments] = STATE(2976),
    [sym__open_parenthesis] = STATE(1606),
    [sym__open_bracket] = STATE(1598),
    [sym__open_bracket2] = STATE(1592),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(6905),
    [anon_sym_CARET] = ACTIONS(6905),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(5351),
    [anon_sym_DOLLAR] = ACTIONS(6911),
    [anon_sym_AT] = ACTIONS(6911),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6913),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6915),
    [sym__external_open_bracket2] = ACTIONS(6917),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [1958] = {
    [sym_call_arguments] = STATE(2985),
    [sym_subset_arguments] = STATE(2986),
    [sym_subset2_arguments] = STATE(2987),
    [sym__open_parenthesis] = STATE(1414),
    [sym__open_bracket] = STATE(1416),
    [sym__open_bracket2] = STATE(1428),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(7081),
    [anon_sym_DASH] = ACTIONS(7083),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(7097),
    [anon_sym_SLASH] = ACTIONS(7099),
    [anon_sym_STAR_STAR] = ACTIONS(7101),
    [anon_sym_CARET] = ACTIONS(7101),
    [aux_sym_binary_operator_token1] = ACTIONS(7103),
    [anon_sym_PIPE_GT] = ACTIONS(7103),
    [anon_sym_COLON] = ACTIONS(7105),
    [anon_sym_DOLLAR] = ACTIONS(7107),
    [anon_sym_AT] = ACTIONS(7107),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(7109),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(7111),
    [sym__external_open_bracket2] = ACTIONS(7113),
  },
  [1959] = {
    [sym_call_arguments] = STATE(2985),
    [sym_subset_arguments] = STATE(2986),
    [sym_subset2_arguments] = STATE(2987),
    [sym__open_parenthesis] = STATE(1414),
    [sym__open_bracket] = STATE(1416),
    [sym__open_bracket2] = STATE(1428),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(7081),
    [anon_sym_DASH] = ACTIONS(7083),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(7093),
    [anon_sym_LT_EQ] = ACTIONS(7095),
    [anon_sym_GT] = ACTIONS(7093),
    [anon_sym_GT_EQ] = ACTIONS(7095),
    [anon_sym_EQ_EQ] = ACTIONS(7095),
    [anon_sym_BANG_EQ] = ACTIONS(7095),
    [anon_sym_STAR] = ACTIONS(7097),
    [anon_sym_SLASH] = ACTIONS(7099),
    [anon_sym_STAR_STAR] = ACTIONS(7101),
    [anon_sym_CARET] = ACTIONS(7101),
    [aux_sym_binary_operator_token1] = ACTIONS(7103),
    [anon_sym_PIPE_GT] = ACTIONS(7103),
    [anon_sym_COLON] = ACTIONS(7105),
    [anon_sym_DOLLAR] = ACTIONS(7107),
    [anon_sym_AT] = ACTIONS(7107),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(7109),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(7111),
    [sym__external_open_bracket2] = ACTIONS(7113),
  },
  [1960] = {
    [sym_call_arguments] = STATE(2985),
    [sym_subset_arguments] = STATE(2986),
    [sym_subset2_arguments] = STATE(2987),
    [sym__open_parenthesis] = STATE(1414),
    [sym__open_bracket] = STATE(1416),
    [sym__open_bracket2] = STATE(1428),
    [ts_builtin_sym_end] = ACTIONS(5333),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(7081),
    [anon_sym_DASH] = ACTIONS(7083),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5335),
    [anon_sym_AMP] = ACTIONS(5335),
    [anon_sym_PIPE_PIPE] = ACTIONS(5333),
    [anon_sym_AMP_AMP] = ACTIONS(5333),
    [anon_sym_LT] = ACTIONS(7093),
    [anon_sym_LT_EQ] = ACTIONS(7095),
    [anon_sym_GT] = ACTIONS(7093),
    [anon_sym_GT_EQ] = ACTIONS(7095),
    [anon_sym_EQ_EQ] = ACTIONS(7095),
    [anon_sym_BANG_EQ] = ACTIONS(7095),
    [anon_sym_STAR] = ACTIONS(7097),
    [anon_sym_SLASH] = ACTIONS(7099),
    [anon_sym_STAR_STAR] = ACTIONS(7101),
    [anon_sym_CARET] = ACTIONS(7101),
    [aux_sym_binary_operator_token1] = ACTIONS(7103),
    [anon_sym_PIPE_GT] = ACTIONS(7103),
    [anon_sym_COLON] = ACTIONS(7105),
    [anon_sym_DOLLAR] = ACTIONS(7107),
    [anon_sym_AT] = ACTIONS(7107),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5333),
    [sym__semicolon] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(7109),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(7111),
    [sym__external_open_bracket2] = ACTIONS(7113),
  },
  [1961] = {
    [sym_call_arguments] = STATE(2978),
    [sym_subset_arguments] = STATE(2977),
    [sym_subset2_arguments] = STATE(2976),
    [sym__open_parenthesis] = STATE(1606),
    [sym__open_bracket] = STATE(1598),
    [sym__open_bracket2] = STATE(1592),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(5333),
    [anon_sym_DASH] = ACTIONS(5335),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5335),
    [anon_sym_AMP] = ACTIONS(5335),
    [anon_sym_PIPE_PIPE] = ACTIONS(5333),
    [anon_sym_AMP_AMP] = ACTIONS(5333),
    [anon_sym_LT] = ACTIONS(5335),
    [anon_sym_LT_EQ] = ACTIONS(5333),
    [anon_sym_GT] = ACTIONS(5335),
    [anon_sym_GT_EQ] = ACTIONS(5333),
    [anon_sym_EQ_EQ] = ACTIONS(5333),
    [anon_sym_BANG_EQ] = ACTIONS(5333),
    [anon_sym_STAR] = ACTIONS(5335),
    [anon_sym_SLASH] = ACTIONS(5333),
    [anon_sym_STAR_STAR] = ACTIONS(6905),
    [anon_sym_CARET] = ACTIONS(6905),
    [aux_sym_binary_operator_token1] = ACTIONS(5333),
    [anon_sym_PIPE_GT] = ACTIONS(5333),
    [anon_sym_COLON] = ACTIONS(5335),
    [anon_sym_DOLLAR] = ACTIONS(6911),
    [anon_sym_AT] = ACTIONS(6911),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(6913),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(6915),
    [sym__external_open_bracket2] = ACTIONS(6917),
    [sym__external_close_bracket2] = ACTIONS(5333),
  },
  [1962] = {
    [sym_call_arguments] = STATE(2985),
    [sym_subset_arguments] = STATE(2986),
    [sym_subset2_arguments] = STATE(2987),
    [sym__open_parenthesis] = STATE(1414),
    [sym__open_bracket] = STATE(1416),
    [sym__open_bracket2] = STATE(1428),
    [ts_builtin_sym_end] = ACTIONS(5441),
    [sym_identifier] = ACTIONS(5443),
    [anon_sym_BSLASH] = ACTIONS(5441),
    [anon_sym_function] = ACTIONS(5443),
    [anon_sym_EQ] = ACTIONS(7155),
    [anon_sym_if] = ACTIONS(5443),
    [anon_sym_for] = ACTIONS(5443),
    [anon_sym_while] = ACTIONS(5443),
    [anon_sym_repeat] = ACTIONS(5443),
    [anon_sym_QMARK] = ACTIONS(5441),
    [anon_sym_TILDE] = ACTIONS(7079),
    [anon_sym_BANG] = ACTIONS(5443),
    [anon_sym_PLUS] = ACTIONS(7081),
    [anon_sym_DASH] = ACTIONS(7083),
    [anon_sym_LT_DASH] = ACTIONS(7157),
    [anon_sym_LT_LT_DASH] = ACTIONS(7157),
    [anon_sym_COLON_EQ] = ACTIONS(7157),
    [anon_sym_DASH_GT] = ACTIONS(7159),
    [anon_sym_DASH_GT_GT] = ACTIONS(7161),
    [anon_sym_PIPE] = ACTIONS(7085),
    [anon_sym_AMP] = ACTIONS(7087),
    [anon_sym_PIPE_PIPE] = ACTIONS(7089),
    [anon_sym_AMP_AMP] = ACTIONS(7091),
    [anon_sym_LT] = ACTIONS(7093),
    [anon_sym_LT_EQ] = ACTIONS(7095),
    [anon_sym_GT] = ACTIONS(7093),
    [anon_sym_GT_EQ] = ACTIONS(7095),
    [anon_sym_EQ_EQ] = ACTIONS(7095),
    [anon_sym_BANG_EQ] = ACTIONS(7095),
    [anon_sym_STAR] = ACTIONS(7097),
    [anon_sym_SLASH] = ACTIONS(7099),
    [anon_sym_STAR_STAR] = ACTIONS(7101),
    [anon_sym_CARET] = ACTIONS(7101),
    [aux_sym_binary_operator_token1] = ACTIONS(7103),
    [anon_sym_PIPE_GT] = ACTIONS(7103),
    [anon_sym_COLON] = ACTIONS(7105),
    [anon_sym_DOLLAR] = ACTIONS(7107),
    [anon_sym_AT] = ACTIONS(7107),
    [aux_sym__hex_literal_token1] = ACTIONS(5441),
    [sym__number_literal] = ACTIONS(5443),
    [anon_sym_SQUOTE] = ACTIONS(5441),
    [anon_sym_DQUOTE] = ACTIONS(5441),
    [sym_return] = ACTIONS(5443),
    [sym_next] = ACTIONS(5443),
    [sym_break] = ACTIONS(5443),
    [sym_true] = ACTIONS(5443),
    [sym_false] = ACTIONS(5443),
    [sym_null] = ACTIONS(5443),
    [sym_inf] = ACTIONS(5443),
    [sym_nan] = ACTIONS(5443),
    [anon_sym_NA] = ACTIONS(5443),
    [anon_sym_NA_integer_] = ACTIONS(5443),
    [anon_sym_NA_real_] = ACTIONS(5443),
    [anon_sym_NA_complex_] = ACTIONS(5443),
    [anon_sym_NA_character_] = ACTIONS(5443),
    [sym_dots] = ACTIONS(5443),
    [sym_dot_dot_i] = ACTIONS(5441),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5441),
    [sym__semicolon] = ACTIONS(5441),
    [sym__raw_string_literal] = ACTIONS(5441),
    [sym__external_open_parenthesis] = ACTIONS(7109),
    [sym__external_open_brace] = ACTIONS(5441),
    [sym__external_open_bracket] = ACTIONS(7111),
    [sym__external_open_bracket2] = ACTIONS(7113),
  },
  [1963] = {
    [sym_call_arguments] = STATE(2978),
    [sym_subset_arguments] = STATE(2977),
    [sym_subset2_arguments] = STATE(2976),
    [sym__open_parenthesis] = STATE(1606),
    [sym__open_bracket] = STATE(1598),
    [sym__open_bracket2] = STATE(1592),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(6879),
    [anon_sym_DASH] = ACTIONS(6881),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5335),
    [anon_sym_AMP] = ACTIONS(5335),
    [anon_sym_PIPE_PIPE] = ACTIONS(5333),
    [anon_sym_AMP_AMP] = ACTIONS(5333),
    [anon_sym_LT] = ACTIONS(6897),
    [anon_sym_LT_EQ] = ACTIONS(6899),
    [anon_sym_GT] = ACTIONS(6897),
    [anon_sym_GT_EQ] = ACTIONS(6899),
    [anon_sym_EQ_EQ] = ACTIONS(6899),
    [anon_sym_BANG_EQ] = ACTIONS(6899),
    [anon_sym_STAR] = ACTIONS(6901),
    [anon_sym_SLASH] = ACTIONS(6903),
    [anon_sym_STAR_STAR] = ACTIONS(6905),
    [anon_sym_CARET] = ACTIONS(6905),
    [aux_sym_binary_operator_token1] = ACTIONS(6907),
    [anon_sym_PIPE_GT] = ACTIONS(6907),
    [anon_sym_COLON] = ACTIONS(6909),
    [anon_sym_DOLLAR] = ACTIONS(6911),
    [anon_sym_AT] = ACTIONS(6911),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(6913),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(6915),
    [sym__external_open_bracket2] = ACTIONS(6917),
    [sym__external_close_bracket2] = ACTIONS(5333),
  },
  [1964] = {
    [sym_call_arguments] = STATE(2985),
    [sym_subset_arguments] = STATE(2986),
    [sym_subset2_arguments] = STATE(2987),
    [sym__open_parenthesis] = STATE(1414),
    [sym__open_bracket] = STATE(1416),
    [sym__open_bracket2] = STATE(1428),
    [ts_builtin_sym_end] = ACTIONS(5333),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(7081),
    [anon_sym_DASH] = ACTIONS(7083),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(7085),
    [anon_sym_AMP] = ACTIONS(7087),
    [anon_sym_PIPE_PIPE] = ACTIONS(7089),
    [anon_sym_AMP_AMP] = ACTIONS(7091),
    [anon_sym_LT] = ACTIONS(7093),
    [anon_sym_LT_EQ] = ACTIONS(7095),
    [anon_sym_GT] = ACTIONS(7093),
    [anon_sym_GT_EQ] = ACTIONS(7095),
    [anon_sym_EQ_EQ] = ACTIONS(7095),
    [anon_sym_BANG_EQ] = ACTIONS(7095),
    [anon_sym_STAR] = ACTIONS(7097),
    [anon_sym_SLASH] = ACTIONS(7099),
    [anon_sym_STAR_STAR] = ACTIONS(7101),
    [anon_sym_CARET] = ACTIONS(7101),
    [aux_sym_binary_operator_token1] = ACTIONS(7103),
    [anon_sym_PIPE_GT] = ACTIONS(7103),
    [anon_sym_COLON] = ACTIONS(7105),
    [anon_sym_DOLLAR] = ACTIONS(7107),
    [anon_sym_AT] = ACTIONS(7107),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5333),
    [sym__semicolon] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(7109),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(7111),
    [sym__external_open_bracket2] = ACTIONS(7113),
  },
  [1965] = {
    [sym_call_arguments] = STATE(2985),
    [sym_subset_arguments] = STATE(2986),
    [sym_subset2_arguments] = STATE(2987),
    [sym__open_parenthesis] = STATE(1414),
    [sym__open_bracket] = STATE(1416),
    [sym__open_bracket2] = STATE(1428),
    [ts_builtin_sym_end] = ACTIONS(5437),
    [sym_identifier] = ACTIONS(5439),
    [anon_sym_BSLASH] = ACTIONS(5437),
    [anon_sym_function] = ACTIONS(5439),
    [anon_sym_EQ] = ACTIONS(7155),
    [anon_sym_if] = ACTIONS(5439),
    [anon_sym_for] = ACTIONS(5439),
    [anon_sym_while] = ACTIONS(5439),
    [anon_sym_repeat] = ACTIONS(5439),
    [anon_sym_QMARK] = ACTIONS(5437),
    [anon_sym_TILDE] = ACTIONS(7079),
    [anon_sym_BANG] = ACTIONS(5439),
    [anon_sym_PLUS] = ACTIONS(7081),
    [anon_sym_DASH] = ACTIONS(7083),
    [anon_sym_LT_DASH] = ACTIONS(7157),
    [anon_sym_LT_LT_DASH] = ACTIONS(7157),
    [anon_sym_COLON_EQ] = ACTIONS(7157),
    [anon_sym_DASH_GT] = ACTIONS(7159),
    [anon_sym_DASH_GT_GT] = ACTIONS(7161),
    [anon_sym_PIPE] = ACTIONS(7085),
    [anon_sym_AMP] = ACTIONS(7087),
    [anon_sym_PIPE_PIPE] = ACTIONS(7089),
    [anon_sym_AMP_AMP] = ACTIONS(7091),
    [anon_sym_LT] = ACTIONS(7093),
    [anon_sym_LT_EQ] = ACTIONS(7095),
    [anon_sym_GT] = ACTIONS(7093),
    [anon_sym_GT_EQ] = ACTIONS(7095),
    [anon_sym_EQ_EQ] = ACTIONS(7095),
    [anon_sym_BANG_EQ] = ACTIONS(7095),
    [anon_sym_STAR] = ACTIONS(7097),
    [anon_sym_SLASH] = ACTIONS(7099),
    [anon_sym_STAR_STAR] = ACTIONS(7101),
    [anon_sym_CARET] = ACTIONS(7101),
    [aux_sym_binary_operator_token1] = ACTIONS(7103),
    [anon_sym_PIPE_GT] = ACTIONS(7103),
    [anon_sym_COLON] = ACTIONS(7105),
    [anon_sym_DOLLAR] = ACTIONS(7107),
    [anon_sym_AT] = ACTIONS(7107),
    [aux_sym__hex_literal_token1] = ACTIONS(5437),
    [sym__number_literal] = ACTIONS(5439),
    [anon_sym_SQUOTE] = ACTIONS(5437),
    [anon_sym_DQUOTE] = ACTIONS(5437),
    [sym_return] = ACTIONS(5439),
    [sym_next] = ACTIONS(5439),
    [sym_break] = ACTIONS(5439),
    [sym_true] = ACTIONS(5439),
    [sym_false] = ACTIONS(5439),
    [sym_null] = ACTIONS(5439),
    [sym_inf] = ACTIONS(5439),
    [sym_nan] = ACTIONS(5439),
    [anon_sym_NA] = ACTIONS(5439),
    [anon_sym_NA_integer_] = ACTIONS(5439),
    [anon_sym_NA_real_] = ACTIONS(5439),
    [anon_sym_NA_complex_] = ACTIONS(5439),
    [anon_sym_NA_character_] = ACTIONS(5439),
    [sym_dots] = ACTIONS(5439),
    [sym_dot_dot_i] = ACTIONS(5437),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5437),
    [sym__semicolon] = ACTIONS(5437),
    [sym__raw_string_literal] = ACTIONS(5437),
    [sym__external_open_parenthesis] = ACTIONS(7109),
    [sym__external_open_brace] = ACTIONS(5437),
    [sym__external_open_bracket] = ACTIONS(7111),
    [sym__external_open_bracket2] = ACTIONS(7113),
  },
  [1966] = {
    [sym_string] = STATE(2818),
    [sym__single_quoted_string] = STATE(2538),
    [sym__double_quoted_string] = STATE(2539),
    [sym__string_or_identifier] = STATE(2818),
    [aux_sym_function_definition_repeat1] = STATE(2015),
    [ts_builtin_sym_end] = ACTIONS(5659),
    [sym_identifier] = ACTIONS(7167),
    [anon_sym_BSLASH] = ACTIONS(5659),
    [anon_sym_function] = ACTIONS(5663),
    [anon_sym_EQ] = ACTIONS(5663),
    [anon_sym_if] = ACTIONS(5663),
    [anon_sym_for] = ACTIONS(5663),
    [anon_sym_while] = ACTIONS(5663),
    [anon_sym_repeat] = ACTIONS(5663),
    [anon_sym_QMARK] = ACTIONS(5659),
    [anon_sym_TILDE] = ACTIONS(5659),
    [anon_sym_BANG] = ACTIONS(5663),
    [anon_sym_PLUS] = ACTIONS(5659),
    [anon_sym_DASH] = ACTIONS(5663),
    [anon_sym_LT_DASH] = ACTIONS(5659),
    [anon_sym_LT_LT_DASH] = ACTIONS(5659),
    [anon_sym_COLON_EQ] = ACTIONS(5659),
    [anon_sym_DASH_GT] = ACTIONS(5663),
    [anon_sym_DASH_GT_GT] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(5663),
    [anon_sym_AMP] = ACTIONS(5663),
    [anon_sym_PIPE_PIPE] = ACTIONS(5659),
    [anon_sym_AMP_AMP] = ACTIONS(5659),
    [anon_sym_LT] = ACTIONS(5663),
    [anon_sym_LT_EQ] = ACTIONS(5659),
    [anon_sym_GT] = ACTIONS(5663),
    [anon_sym_GT_EQ] = ACTIONS(5659),
    [anon_sym_EQ_EQ] = ACTIONS(5659),
    [anon_sym_BANG_EQ] = ACTIONS(5659),
    [anon_sym_STAR] = ACTIONS(5663),
    [anon_sym_SLASH] = ACTIONS(5659),
    [anon_sym_STAR_STAR] = ACTIONS(5659),
    [anon_sym_CARET] = ACTIONS(5659),
    [aux_sym_binary_operator_token1] = ACTIONS(5659),
    [anon_sym_PIPE_GT] = ACTIONS(5659),
    [anon_sym_COLON] = ACTIONS(5663),
    [anon_sym_DOLLAR] = ACTIONS(5659),
    [anon_sym_AT] = ACTIONS(5659),
    [aux_sym__hex_literal_token1] = ACTIONS(5659),
    [sym__number_literal] = ACTIONS(5663),
    [anon_sym_SQUOTE] = ACTIONS(4081),
    [anon_sym_DQUOTE] = ACTIONS(4083),
    [sym_return] = ACTIONS(5663),
    [sym_next] = ACTIONS(5663),
    [sym_break] = ACTIONS(5663),
    [sym_true] = ACTIONS(5663),
    [sym_false] = ACTIONS(5663),
    [sym_null] = ACTIONS(5663),
    [sym_inf] = ACTIONS(5663),
    [sym_nan] = ACTIONS(5663),
    [anon_sym_NA] = ACTIONS(5663),
    [anon_sym_NA_integer_] = ACTIONS(5663),
    [anon_sym_NA_real_] = ACTIONS(5663),
    [anon_sym_NA_complex_] = ACTIONS(5663),
    [anon_sym_NA_character_] = ACTIONS(5663),
    [sym_dots] = ACTIONS(5663),
    [sym_dot_dot_i] = ACTIONS(5659),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7169),
    [sym__semicolon] = ACTIONS(5659),
    [sym__raw_string_literal] = ACTIONS(4093),
    [sym__external_else] = ACTIONS(5659),
    [sym__external_open_parenthesis] = ACTIONS(5659),
    [sym__external_open_brace] = ACTIONS(5659),
    [sym__external_open_bracket] = ACTIONS(5659),
    [sym__external_open_bracket2] = ACTIONS(5659),
  },
  [1967] = {
    [sym_call_arguments] = STATE(2978),
    [sym_subset_arguments] = STATE(2977),
    [sym_subset2_arguments] = STATE(2976),
    [sym__open_parenthesis] = STATE(1606),
    [sym__open_bracket] = STATE(1598),
    [sym__open_bracket2] = STATE(1592),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(6905),
    [anon_sym_CARET] = ACTIONS(6905),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(6909),
    [anon_sym_DOLLAR] = ACTIONS(6911),
    [anon_sym_AT] = ACTIONS(6911),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6913),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6915),
    [sym__external_open_bracket2] = ACTIONS(6917),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [1968] = {
    [sym_string] = STATE(2589),
    [sym__single_quoted_string] = STATE(2310),
    [sym__double_quoted_string] = STATE(2309),
    [sym__string_or_identifier] = STATE(2589),
    [ts_builtin_sym_end] = ACTIONS(5883),
    [sym_identifier] = ACTIONS(7171),
    [anon_sym_BSLASH] = ACTIONS(5883),
    [anon_sym_function] = ACTIONS(5887),
    [anon_sym_EQ] = ACTIONS(5887),
    [anon_sym_if] = ACTIONS(5887),
    [anon_sym_for] = ACTIONS(5887),
    [anon_sym_while] = ACTIONS(5887),
    [anon_sym_repeat] = ACTIONS(5887),
    [anon_sym_QMARK] = ACTIONS(5883),
    [anon_sym_TILDE] = ACTIONS(5883),
    [anon_sym_BANG] = ACTIONS(5887),
    [anon_sym_PLUS] = ACTIONS(5883),
    [anon_sym_DASH] = ACTIONS(5887),
    [anon_sym_LT_DASH] = ACTIONS(5883),
    [anon_sym_LT_LT_DASH] = ACTIONS(5883),
    [anon_sym_COLON_EQ] = ACTIONS(5883),
    [anon_sym_DASH_GT] = ACTIONS(5887),
    [anon_sym_DASH_GT_GT] = ACTIONS(5883),
    [anon_sym_PIPE] = ACTIONS(5887),
    [anon_sym_AMP] = ACTIONS(5887),
    [anon_sym_PIPE_PIPE] = ACTIONS(5883),
    [anon_sym_AMP_AMP] = ACTIONS(5883),
    [anon_sym_LT] = ACTIONS(5887),
    [anon_sym_LT_EQ] = ACTIONS(5883),
    [anon_sym_GT] = ACTIONS(5887),
    [anon_sym_GT_EQ] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5883),
    [anon_sym_BANG_EQ] = ACTIONS(5883),
    [anon_sym_STAR] = ACTIONS(5887),
    [anon_sym_SLASH] = ACTIONS(5883),
    [anon_sym_STAR_STAR] = ACTIONS(5883),
    [anon_sym_CARET] = ACTIONS(5883),
    [aux_sym_binary_operator_token1] = ACTIONS(5883),
    [anon_sym_PIPE_GT] = ACTIONS(5883),
    [anon_sym_COLON] = ACTIONS(5887),
    [anon_sym_DOLLAR] = ACTIONS(5883),
    [anon_sym_AT] = ACTIONS(5883),
    [aux_sym__hex_literal_token1] = ACTIONS(5883),
    [sym__number_literal] = ACTIONS(5887),
    [anon_sym_SQUOTE] = ACTIONS(1413),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [sym_return] = ACTIONS(5887),
    [sym_next] = ACTIONS(5887),
    [sym_break] = ACTIONS(5887),
    [sym_true] = ACTIONS(5887),
    [sym_false] = ACTIONS(5887),
    [sym_null] = ACTIONS(5887),
    [sym_inf] = ACTIONS(5887),
    [sym_nan] = ACTIONS(5887),
    [anon_sym_NA] = ACTIONS(5887),
    [anon_sym_NA_integer_] = ACTIONS(5887),
    [anon_sym_NA_real_] = ACTIONS(5887),
    [anon_sym_NA_complex_] = ACTIONS(5887),
    [anon_sym_NA_character_] = ACTIONS(5887),
    [sym_dots] = ACTIONS(5887),
    [sym_dot_dot_i] = ACTIONS(5883),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5883),
    [sym__semicolon] = ACTIONS(5883),
    [sym__raw_string_literal] = ACTIONS(1425),
    [sym__external_else] = ACTIONS(5883),
    [sym__external_open_parenthesis] = ACTIONS(5883),
    [sym__external_open_brace] = ACTIONS(5883),
    [sym__external_close_brace] = ACTIONS(5883),
    [sym__external_open_bracket] = ACTIONS(5883),
    [sym__external_open_bracket2] = ACTIONS(5883),
  },
  [1969] = {
    [sym_call_arguments] = STATE(2941),
    [sym_subset_arguments] = STATE(2942),
    [sym_subset2_arguments] = STATE(2943),
    [sym__open_parenthesis] = STATE(1755),
    [sym__open_bracket] = STATE(1763),
    [sym__open_bracket2] = STATE(1866),
    [sym_identifier] = ACTIONS(5311),
    [anon_sym_BSLASH] = ACTIONS(5313),
    [anon_sym_function] = ACTIONS(5311),
    [anon_sym_EQ] = ACTIONS(6919),
    [anon_sym_if] = ACTIONS(5311),
    [anon_sym_for] = ACTIONS(5311),
    [anon_sym_while] = ACTIONS(5311),
    [anon_sym_repeat] = ACTIONS(5311),
    [anon_sym_QMARK] = ACTIONS(7145),
    [anon_sym_TILDE] = ACTIONS(6921),
    [anon_sym_BANG] = ACTIONS(5311),
    [anon_sym_PLUS] = ACTIONS(6923),
    [anon_sym_DASH] = ACTIONS(6925),
    [anon_sym_LT_DASH] = ACTIONS(7147),
    [anon_sym_LT_LT_DASH] = ACTIONS(7147),
    [anon_sym_COLON_EQ] = ACTIONS(7147),
    [anon_sym_DASH_GT] = ACTIONS(6927),
    [anon_sym_DASH_GT_GT] = ACTIONS(6929),
    [anon_sym_PIPE] = ACTIONS(6931),
    [anon_sym_AMP] = ACTIONS(6933),
    [anon_sym_PIPE_PIPE] = ACTIONS(6935),
    [anon_sym_AMP_AMP] = ACTIONS(6937),
    [anon_sym_LT] = ACTIONS(6939),
    [anon_sym_LT_EQ] = ACTIONS(6941),
    [anon_sym_GT] = ACTIONS(6939),
    [anon_sym_GT_EQ] = ACTIONS(6941),
    [anon_sym_EQ_EQ] = ACTIONS(6941),
    [anon_sym_BANG_EQ] = ACTIONS(6941),
    [anon_sym_STAR] = ACTIONS(6943),
    [anon_sym_SLASH] = ACTIONS(6945),
    [anon_sym_STAR_STAR] = ACTIONS(6947),
    [anon_sym_CARET] = ACTIONS(6947),
    [aux_sym_binary_operator_token1] = ACTIONS(6949),
    [anon_sym_PIPE_GT] = ACTIONS(6949),
    [anon_sym_COLON] = ACTIONS(6951),
    [anon_sym_DOLLAR] = ACTIONS(6953),
    [anon_sym_AT] = ACTIONS(6953),
    [aux_sym__hex_literal_token1] = ACTIONS(5313),
    [sym__number_literal] = ACTIONS(5311),
    [anon_sym_SQUOTE] = ACTIONS(5313),
    [anon_sym_DQUOTE] = ACTIONS(5313),
    [sym_return] = ACTIONS(5311),
    [sym_next] = ACTIONS(5311),
    [sym_break] = ACTIONS(5311),
    [sym_true] = ACTIONS(5311),
    [sym_false] = ACTIONS(5311),
    [sym_null] = ACTIONS(5311),
    [sym_inf] = ACTIONS(5311),
    [sym_nan] = ACTIONS(5311),
    [anon_sym_NA] = ACTIONS(5311),
    [anon_sym_NA_integer_] = ACTIONS(5311),
    [anon_sym_NA_real_] = ACTIONS(5311),
    [anon_sym_NA_complex_] = ACTIONS(5311),
    [anon_sym_NA_character_] = ACTIONS(5311),
    [sym_dots] = ACTIONS(5311),
    [sym_dot_dot_i] = ACTIONS(5313),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5313),
    [sym__newline] = ACTIONS(5313),
    [sym__raw_string_literal] = ACTIONS(5313),
    [sym__external_open_parenthesis] = ACTIONS(6955),
    [sym__external_close_parenthesis] = ACTIONS(5313),
    [sym__external_open_brace] = ACTIONS(5313),
    [sym__external_open_bracket] = ACTIONS(6957),
    [sym__external_open_bracket2] = ACTIONS(6959),
  },
  [1970] = {
    [sym_call_arguments] = STATE(2985),
    [sym_subset_arguments] = STATE(2986),
    [sym_subset2_arguments] = STATE(2987),
    [sym__open_parenthesis] = STATE(1414),
    [sym__open_bracket] = STATE(1416),
    [sym__open_bracket2] = STATE(1428),
    [ts_builtin_sym_end] = ACTIONS(5333),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(7155),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(7079),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(7081),
    [anon_sym_DASH] = ACTIONS(7083),
    [anon_sym_LT_DASH] = ACTIONS(7157),
    [anon_sym_LT_LT_DASH] = ACTIONS(7157),
    [anon_sym_COLON_EQ] = ACTIONS(7157),
    [anon_sym_DASH_GT] = ACTIONS(7159),
    [anon_sym_DASH_GT_GT] = ACTIONS(7161),
    [anon_sym_PIPE] = ACTIONS(7085),
    [anon_sym_AMP] = ACTIONS(7087),
    [anon_sym_PIPE_PIPE] = ACTIONS(7089),
    [anon_sym_AMP_AMP] = ACTIONS(7091),
    [anon_sym_LT] = ACTIONS(7093),
    [anon_sym_LT_EQ] = ACTIONS(7095),
    [anon_sym_GT] = ACTIONS(7093),
    [anon_sym_GT_EQ] = ACTIONS(7095),
    [anon_sym_EQ_EQ] = ACTIONS(7095),
    [anon_sym_BANG_EQ] = ACTIONS(7095),
    [anon_sym_STAR] = ACTIONS(7097),
    [anon_sym_SLASH] = ACTIONS(7099),
    [anon_sym_STAR_STAR] = ACTIONS(7101),
    [anon_sym_CARET] = ACTIONS(7101),
    [aux_sym_binary_operator_token1] = ACTIONS(7103),
    [anon_sym_PIPE_GT] = ACTIONS(7103),
    [anon_sym_COLON] = ACTIONS(7105),
    [anon_sym_DOLLAR] = ACTIONS(7107),
    [anon_sym_AT] = ACTIONS(7107),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5333),
    [sym__semicolon] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(7109),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(7111),
    [sym__external_open_bracket2] = ACTIONS(7113),
  },
  [1971] = {
    [sym_call_arguments] = STATE(2978),
    [sym_subset_arguments] = STATE(2977),
    [sym_subset2_arguments] = STATE(2976),
    [sym__open_parenthesis] = STATE(1606),
    [sym__open_bracket] = STATE(1598),
    [sym__open_bracket2] = STATE(1592),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(6879),
    [anon_sym_DASH] = ACTIONS(6881),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(6889),
    [anon_sym_AMP] = ACTIONS(6891),
    [anon_sym_PIPE_PIPE] = ACTIONS(6893),
    [anon_sym_AMP_AMP] = ACTIONS(6895),
    [anon_sym_LT] = ACTIONS(6897),
    [anon_sym_LT_EQ] = ACTIONS(6899),
    [anon_sym_GT] = ACTIONS(6897),
    [anon_sym_GT_EQ] = ACTIONS(6899),
    [anon_sym_EQ_EQ] = ACTIONS(6899),
    [anon_sym_BANG_EQ] = ACTIONS(6899),
    [anon_sym_STAR] = ACTIONS(6901),
    [anon_sym_SLASH] = ACTIONS(6903),
    [anon_sym_STAR_STAR] = ACTIONS(6905),
    [anon_sym_CARET] = ACTIONS(6905),
    [aux_sym_binary_operator_token1] = ACTIONS(6907),
    [anon_sym_PIPE_GT] = ACTIONS(6907),
    [anon_sym_COLON] = ACTIONS(6909),
    [anon_sym_DOLLAR] = ACTIONS(6911),
    [anon_sym_AT] = ACTIONS(6911),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(6913),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(6915),
    [sym__external_open_bracket2] = ACTIONS(6917),
    [sym__external_close_bracket2] = ACTIONS(5333),
  },
  [1972] = {
    [sym_call_arguments] = STATE(2978),
    [sym_subset_arguments] = STATE(2977),
    [sym_subset2_arguments] = STATE(2976),
    [sym__open_parenthesis] = STATE(1606),
    [sym__open_bracket] = STATE(1598),
    [sym__open_bracket2] = STATE(1592),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(6905),
    [anon_sym_CARET] = ACTIONS(6905),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(5351),
    [anon_sym_DOLLAR] = ACTIONS(6911),
    [anon_sym_AT] = ACTIONS(6911),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6913),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6915),
    [sym__external_open_bracket2] = ACTIONS(6917),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [1973] = {
    [sym_call_arguments] = STATE(2985),
    [sym_subset_arguments] = STATE(2986),
    [sym_subset2_arguments] = STATE(2987),
    [sym__open_parenthesis] = STATE(1414),
    [sym__open_bracket] = STATE(1416),
    [sym__open_bracket2] = STATE(1428),
    [ts_builtin_sym_end] = ACTIONS(5433),
    [sym_identifier] = ACTIONS(5435),
    [anon_sym_BSLASH] = ACTIONS(5433),
    [anon_sym_function] = ACTIONS(5435),
    [anon_sym_EQ] = ACTIONS(7155),
    [anon_sym_if] = ACTIONS(5435),
    [anon_sym_for] = ACTIONS(5435),
    [anon_sym_while] = ACTIONS(5435),
    [anon_sym_repeat] = ACTIONS(5435),
    [anon_sym_QMARK] = ACTIONS(5433),
    [anon_sym_TILDE] = ACTIONS(7079),
    [anon_sym_BANG] = ACTIONS(5435),
    [anon_sym_PLUS] = ACTIONS(7081),
    [anon_sym_DASH] = ACTIONS(7083),
    [anon_sym_LT_DASH] = ACTIONS(7157),
    [anon_sym_LT_LT_DASH] = ACTIONS(7157),
    [anon_sym_COLON_EQ] = ACTIONS(7157),
    [anon_sym_DASH_GT] = ACTIONS(7159),
    [anon_sym_DASH_GT_GT] = ACTIONS(7161),
    [anon_sym_PIPE] = ACTIONS(7085),
    [anon_sym_AMP] = ACTIONS(7087),
    [anon_sym_PIPE_PIPE] = ACTIONS(7089),
    [anon_sym_AMP_AMP] = ACTIONS(7091),
    [anon_sym_LT] = ACTIONS(7093),
    [anon_sym_LT_EQ] = ACTIONS(7095),
    [anon_sym_GT] = ACTIONS(7093),
    [anon_sym_GT_EQ] = ACTIONS(7095),
    [anon_sym_EQ_EQ] = ACTIONS(7095),
    [anon_sym_BANG_EQ] = ACTIONS(7095),
    [anon_sym_STAR] = ACTIONS(7097),
    [anon_sym_SLASH] = ACTIONS(7099),
    [anon_sym_STAR_STAR] = ACTIONS(7101),
    [anon_sym_CARET] = ACTIONS(7101),
    [aux_sym_binary_operator_token1] = ACTIONS(7103),
    [anon_sym_PIPE_GT] = ACTIONS(7103),
    [anon_sym_COLON] = ACTIONS(7105),
    [anon_sym_DOLLAR] = ACTIONS(7107),
    [anon_sym_AT] = ACTIONS(7107),
    [aux_sym__hex_literal_token1] = ACTIONS(5433),
    [sym__number_literal] = ACTIONS(5435),
    [anon_sym_SQUOTE] = ACTIONS(5433),
    [anon_sym_DQUOTE] = ACTIONS(5433),
    [sym_return] = ACTIONS(5435),
    [sym_next] = ACTIONS(5435),
    [sym_break] = ACTIONS(5435),
    [sym_true] = ACTIONS(5435),
    [sym_false] = ACTIONS(5435),
    [sym_null] = ACTIONS(5435),
    [sym_inf] = ACTIONS(5435),
    [sym_nan] = ACTIONS(5435),
    [anon_sym_NA] = ACTIONS(5435),
    [anon_sym_NA_integer_] = ACTIONS(5435),
    [anon_sym_NA_real_] = ACTIONS(5435),
    [anon_sym_NA_complex_] = ACTIONS(5435),
    [anon_sym_NA_character_] = ACTIONS(5435),
    [sym_dots] = ACTIONS(5435),
    [sym_dot_dot_i] = ACTIONS(5433),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5433),
    [sym__semicolon] = ACTIONS(5433),
    [sym__raw_string_literal] = ACTIONS(5433),
    [sym__external_open_parenthesis] = ACTIONS(7109),
    [sym__external_open_brace] = ACTIONS(5433),
    [sym__external_open_bracket] = ACTIONS(7111),
    [sym__external_open_bracket2] = ACTIONS(7113),
  },
  [1974] = {
    [sym_call_arguments] = STATE(2978),
    [sym_subset_arguments] = STATE(2977),
    [sym_subset2_arguments] = STATE(2976),
    [sym__open_parenthesis] = STATE(1606),
    [sym__open_bracket] = STATE(1598),
    [sym__open_bracket2] = STATE(1592),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(6875),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(6877),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(6879),
    [anon_sym_DASH] = ACTIONS(6881),
    [anon_sym_LT_DASH] = ACTIONS(6883),
    [anon_sym_LT_LT_DASH] = ACTIONS(6883),
    [anon_sym_COLON_EQ] = ACTIONS(6883),
    [anon_sym_DASH_GT] = ACTIONS(6885),
    [anon_sym_DASH_GT_GT] = ACTIONS(6887),
    [anon_sym_PIPE] = ACTIONS(6889),
    [anon_sym_AMP] = ACTIONS(6891),
    [anon_sym_PIPE_PIPE] = ACTIONS(6893),
    [anon_sym_AMP_AMP] = ACTIONS(6895),
    [anon_sym_LT] = ACTIONS(6897),
    [anon_sym_LT_EQ] = ACTIONS(6899),
    [anon_sym_GT] = ACTIONS(6897),
    [anon_sym_GT_EQ] = ACTIONS(6899),
    [anon_sym_EQ_EQ] = ACTIONS(6899),
    [anon_sym_BANG_EQ] = ACTIONS(6899),
    [anon_sym_STAR] = ACTIONS(6901),
    [anon_sym_SLASH] = ACTIONS(6903),
    [anon_sym_STAR_STAR] = ACTIONS(6905),
    [anon_sym_CARET] = ACTIONS(6905),
    [aux_sym_binary_operator_token1] = ACTIONS(6907),
    [anon_sym_PIPE_GT] = ACTIONS(6907),
    [anon_sym_COLON] = ACTIONS(6909),
    [anon_sym_DOLLAR] = ACTIONS(6911),
    [anon_sym_AT] = ACTIONS(6911),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(6913),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(6915),
    [sym__external_open_bracket2] = ACTIONS(6917),
    [sym__external_close_bracket2] = ACTIONS(5333),
  },
  [1975] = {
    [sym_call_arguments] = STATE(2985),
    [sym_subset_arguments] = STATE(2986),
    [sym_subset2_arguments] = STATE(2987),
    [sym__open_parenthesis] = STATE(1414),
    [sym__open_bracket] = STATE(1416),
    [sym__open_bracket2] = STATE(1428),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(7081),
    [anon_sym_DASH] = ACTIONS(7083),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(7087),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(7091),
    [anon_sym_LT] = ACTIONS(7093),
    [anon_sym_LT_EQ] = ACTIONS(7095),
    [anon_sym_GT] = ACTIONS(7093),
    [anon_sym_GT_EQ] = ACTIONS(7095),
    [anon_sym_EQ_EQ] = ACTIONS(7095),
    [anon_sym_BANG_EQ] = ACTIONS(7095),
    [anon_sym_STAR] = ACTIONS(7097),
    [anon_sym_SLASH] = ACTIONS(7099),
    [anon_sym_STAR_STAR] = ACTIONS(7101),
    [anon_sym_CARET] = ACTIONS(7101),
    [aux_sym_binary_operator_token1] = ACTIONS(7103),
    [anon_sym_PIPE_GT] = ACTIONS(7103),
    [anon_sym_COLON] = ACTIONS(7105),
    [anon_sym_DOLLAR] = ACTIONS(7107),
    [anon_sym_AT] = ACTIONS(7107),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(7109),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(7111),
    [sym__external_open_bracket2] = ACTIONS(7113),
  },
  [1976] = {
    [sym_call_arguments] = STATE(2985),
    [sym_subset_arguments] = STATE(2986),
    [sym_subset2_arguments] = STATE(2987),
    [sym__open_parenthesis] = STATE(1414),
    [sym__open_bracket] = STATE(1416),
    [sym__open_bracket2] = STATE(1428),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(7101),
    [anon_sym_CARET] = ACTIONS(7101),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(7105),
    [anon_sym_DOLLAR] = ACTIONS(7107),
    [anon_sym_AT] = ACTIONS(7107),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(7109),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(7111),
    [sym__external_open_bracket2] = ACTIONS(7113),
  },
  [1977] = {
    [sym_call_arguments] = STATE(2985),
    [sym_subset_arguments] = STATE(2986),
    [sym_subset2_arguments] = STATE(2987),
    [sym__open_parenthesis] = STATE(1414),
    [sym__open_bracket] = STATE(1416),
    [sym__open_bracket2] = STATE(1428),
    [ts_builtin_sym_end] = ACTIONS(5329),
    [sym_identifier] = ACTIONS(5331),
    [anon_sym_BSLASH] = ACTIONS(5329),
    [anon_sym_function] = ACTIONS(5331),
    [anon_sym_EQ] = ACTIONS(7155),
    [anon_sym_if] = ACTIONS(5331),
    [anon_sym_for] = ACTIONS(5331),
    [anon_sym_while] = ACTIONS(5331),
    [anon_sym_repeat] = ACTIONS(5331),
    [anon_sym_QMARK] = ACTIONS(5329),
    [anon_sym_TILDE] = ACTIONS(7079),
    [anon_sym_BANG] = ACTIONS(5331),
    [anon_sym_PLUS] = ACTIONS(7081),
    [anon_sym_DASH] = ACTIONS(7083),
    [anon_sym_LT_DASH] = ACTIONS(7157),
    [anon_sym_LT_LT_DASH] = ACTIONS(7157),
    [anon_sym_COLON_EQ] = ACTIONS(7157),
    [anon_sym_DASH_GT] = ACTIONS(7159),
    [anon_sym_DASH_GT_GT] = ACTIONS(7161),
    [anon_sym_PIPE] = ACTIONS(7085),
    [anon_sym_AMP] = ACTIONS(7087),
    [anon_sym_PIPE_PIPE] = ACTIONS(7089),
    [anon_sym_AMP_AMP] = ACTIONS(7091),
    [anon_sym_LT] = ACTIONS(7093),
    [anon_sym_LT_EQ] = ACTIONS(7095),
    [anon_sym_GT] = ACTIONS(7093),
    [anon_sym_GT_EQ] = ACTIONS(7095),
    [anon_sym_EQ_EQ] = ACTIONS(7095),
    [anon_sym_BANG_EQ] = ACTIONS(7095),
    [anon_sym_STAR] = ACTIONS(7097),
    [anon_sym_SLASH] = ACTIONS(7099),
    [anon_sym_STAR_STAR] = ACTIONS(7101),
    [anon_sym_CARET] = ACTIONS(7101),
    [aux_sym_binary_operator_token1] = ACTIONS(7103),
    [anon_sym_PIPE_GT] = ACTIONS(7103),
    [anon_sym_COLON] = ACTIONS(7105),
    [anon_sym_DOLLAR] = ACTIONS(7107),
    [anon_sym_AT] = ACTIONS(7107),
    [aux_sym__hex_literal_token1] = ACTIONS(5329),
    [sym__number_literal] = ACTIONS(5331),
    [anon_sym_SQUOTE] = ACTIONS(5329),
    [anon_sym_DQUOTE] = ACTIONS(5329),
    [sym_return] = ACTIONS(5331),
    [sym_next] = ACTIONS(5331),
    [sym_break] = ACTIONS(5331),
    [sym_true] = ACTIONS(5331),
    [sym_false] = ACTIONS(5331),
    [sym_null] = ACTIONS(5331),
    [sym_inf] = ACTIONS(5331),
    [sym_nan] = ACTIONS(5331),
    [anon_sym_NA] = ACTIONS(5331),
    [anon_sym_NA_integer_] = ACTIONS(5331),
    [anon_sym_NA_real_] = ACTIONS(5331),
    [anon_sym_NA_complex_] = ACTIONS(5331),
    [anon_sym_NA_character_] = ACTIONS(5331),
    [sym_dots] = ACTIONS(5331),
    [sym_dot_dot_i] = ACTIONS(5329),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5329),
    [sym__semicolon] = ACTIONS(5329),
    [sym__raw_string_literal] = ACTIONS(5329),
    [sym__external_open_parenthesis] = ACTIONS(7109),
    [sym__external_open_brace] = ACTIONS(5329),
    [sym__external_open_bracket] = ACTIONS(7111),
    [sym__external_open_bracket2] = ACTIONS(7113),
  },
  [1978] = {
    [sym_call_arguments] = STATE(2985),
    [sym_subset_arguments] = STATE(2986),
    [sym_subset2_arguments] = STATE(2987),
    [sym__open_parenthesis] = STATE(1414),
    [sym__open_bracket] = STATE(1416),
    [sym__open_bracket2] = STATE(1428),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(7101),
    [anon_sym_CARET] = ACTIONS(7101),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(5351),
    [anon_sym_DOLLAR] = ACTIONS(7107),
    [anon_sym_AT] = ACTIONS(7107),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(7109),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(7111),
    [sym__external_open_bracket2] = ACTIONS(7113),
  },
  [1979] = {
    [sym_call_arguments] = STATE(2978),
    [sym_subset_arguments] = STATE(2977),
    [sym_subset2_arguments] = STATE(2976),
    [sym__open_parenthesis] = STATE(1606),
    [sym__open_bracket] = STATE(1598),
    [sym__open_bracket2] = STATE(1592),
    [sym_identifier] = ACTIONS(5331),
    [anon_sym_BSLASH] = ACTIONS(5329),
    [anon_sym_function] = ACTIONS(5331),
    [anon_sym_EQ] = ACTIONS(6875),
    [anon_sym_if] = ACTIONS(5331),
    [anon_sym_for] = ACTIONS(5331),
    [anon_sym_while] = ACTIONS(5331),
    [anon_sym_repeat] = ACTIONS(5331),
    [anon_sym_QMARK] = ACTIONS(5329),
    [anon_sym_TILDE] = ACTIONS(6877),
    [anon_sym_BANG] = ACTIONS(5331),
    [anon_sym_PLUS] = ACTIONS(6879),
    [anon_sym_DASH] = ACTIONS(6881),
    [anon_sym_LT_DASH] = ACTIONS(6883),
    [anon_sym_LT_LT_DASH] = ACTIONS(6883),
    [anon_sym_COLON_EQ] = ACTIONS(6883),
    [anon_sym_DASH_GT] = ACTIONS(6885),
    [anon_sym_DASH_GT_GT] = ACTIONS(6887),
    [anon_sym_PIPE] = ACTIONS(6889),
    [anon_sym_AMP] = ACTIONS(6891),
    [anon_sym_PIPE_PIPE] = ACTIONS(6893),
    [anon_sym_AMP_AMP] = ACTIONS(6895),
    [anon_sym_LT] = ACTIONS(6897),
    [anon_sym_LT_EQ] = ACTIONS(6899),
    [anon_sym_GT] = ACTIONS(6897),
    [anon_sym_GT_EQ] = ACTIONS(6899),
    [anon_sym_EQ_EQ] = ACTIONS(6899),
    [anon_sym_BANG_EQ] = ACTIONS(6899),
    [anon_sym_STAR] = ACTIONS(6901),
    [anon_sym_SLASH] = ACTIONS(6903),
    [anon_sym_STAR_STAR] = ACTIONS(6905),
    [anon_sym_CARET] = ACTIONS(6905),
    [aux_sym_binary_operator_token1] = ACTIONS(6907),
    [anon_sym_PIPE_GT] = ACTIONS(6907),
    [anon_sym_COLON] = ACTIONS(6909),
    [anon_sym_DOLLAR] = ACTIONS(6911),
    [anon_sym_AT] = ACTIONS(6911),
    [aux_sym__hex_literal_token1] = ACTIONS(5329),
    [sym__number_literal] = ACTIONS(5331),
    [anon_sym_SQUOTE] = ACTIONS(5329),
    [anon_sym_DQUOTE] = ACTIONS(5329),
    [sym_return] = ACTIONS(5331),
    [sym_next] = ACTIONS(5331),
    [sym_break] = ACTIONS(5331),
    [sym_true] = ACTIONS(5331),
    [sym_false] = ACTIONS(5331),
    [sym_null] = ACTIONS(5331),
    [sym_inf] = ACTIONS(5331),
    [sym_nan] = ACTIONS(5331),
    [anon_sym_NA] = ACTIONS(5331),
    [anon_sym_NA_integer_] = ACTIONS(5331),
    [anon_sym_NA_real_] = ACTIONS(5331),
    [anon_sym_NA_complex_] = ACTIONS(5331),
    [anon_sym_NA_character_] = ACTIONS(5331),
    [sym_dots] = ACTIONS(5331),
    [sym_dot_dot_i] = ACTIONS(5329),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5329),
    [sym__newline] = ACTIONS(5329),
    [sym__raw_string_literal] = ACTIONS(5329),
    [sym__external_open_parenthesis] = ACTIONS(6913),
    [sym__external_open_brace] = ACTIONS(5329),
    [sym__external_open_bracket] = ACTIONS(6915),
    [sym__external_open_bracket2] = ACTIONS(6917),
    [sym__external_close_bracket2] = ACTIONS(5329),
  },
  [1980] = {
    [sym_call_arguments] = STATE(2985),
    [sym_subset_arguments] = STATE(2986),
    [sym_subset2_arguments] = STATE(2987),
    [sym__open_parenthesis] = STATE(1414),
    [sym__open_bracket] = STATE(1416),
    [sym__open_bracket2] = STATE(1428),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(7101),
    [anon_sym_CARET] = ACTIONS(7101),
    [aux_sym_binary_operator_token1] = ACTIONS(7103),
    [anon_sym_PIPE_GT] = ACTIONS(7103),
    [anon_sym_COLON] = ACTIONS(7105),
    [anon_sym_DOLLAR] = ACTIONS(7107),
    [anon_sym_AT] = ACTIONS(7107),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(7109),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(7111),
    [sym__external_open_bracket2] = ACTIONS(7113),
  },
  [1981] = {
    [ts_builtin_sym_end] = ACTIONS(7139),
    [sym_identifier] = ACTIONS(7137),
    [anon_sym_BSLASH] = ACTIONS(7139),
    [anon_sym_function] = ACTIONS(7137),
    [anon_sym_EQ] = ACTIONS(7137),
    [anon_sym_if] = ACTIONS(7137),
    [anon_sym_for] = ACTIONS(7137),
    [anon_sym_while] = ACTIONS(7137),
    [anon_sym_repeat] = ACTIONS(7137),
    [anon_sym_QMARK] = ACTIONS(7139),
    [anon_sym_TILDE] = ACTIONS(7139),
    [anon_sym_BANG] = ACTIONS(7137),
    [anon_sym_PLUS] = ACTIONS(7139),
    [anon_sym_DASH] = ACTIONS(7137),
    [anon_sym_LT_DASH] = ACTIONS(7139),
    [anon_sym_LT_LT_DASH] = ACTIONS(7139),
    [anon_sym_COLON_EQ] = ACTIONS(7139),
    [anon_sym_DASH_GT] = ACTIONS(7137),
    [anon_sym_DASH_GT_GT] = ACTIONS(7139),
    [anon_sym_PIPE] = ACTIONS(7137),
    [anon_sym_AMP] = ACTIONS(7137),
    [anon_sym_PIPE_PIPE] = ACTIONS(7139),
    [anon_sym_AMP_AMP] = ACTIONS(7139),
    [anon_sym_LT] = ACTIONS(7137),
    [anon_sym_LT_EQ] = ACTIONS(7139),
    [anon_sym_GT] = ACTIONS(7137),
    [anon_sym_GT_EQ] = ACTIONS(7139),
    [anon_sym_EQ_EQ] = ACTIONS(7139),
    [anon_sym_BANG_EQ] = ACTIONS(7139),
    [anon_sym_STAR] = ACTIONS(7137),
    [anon_sym_SLASH] = ACTIONS(7139),
    [anon_sym_STAR_STAR] = ACTIONS(7139),
    [anon_sym_CARET] = ACTIONS(7139),
    [aux_sym_binary_operator_token1] = ACTIONS(7139),
    [anon_sym_PIPE_GT] = ACTIONS(7139),
    [anon_sym_COLON] = ACTIONS(7137),
    [anon_sym_DOLLAR] = ACTIONS(7139),
    [anon_sym_AT] = ACTIONS(7139),
    [anon_sym_COLON_COLON] = ACTIONS(7137),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7139),
    [aux_sym__hex_literal_token1] = ACTIONS(7139),
    [sym__number_literal] = ACTIONS(7137),
    [anon_sym_SQUOTE] = ACTIONS(7139),
    [anon_sym_DQUOTE] = ACTIONS(7139),
    [sym_return] = ACTIONS(7137),
    [sym_next] = ACTIONS(7137),
    [sym_break] = ACTIONS(7137),
    [sym_true] = ACTIONS(7137),
    [sym_false] = ACTIONS(7137),
    [sym_null] = ACTIONS(7137),
    [sym_inf] = ACTIONS(7137),
    [sym_nan] = ACTIONS(7137),
    [anon_sym_NA] = ACTIONS(7137),
    [anon_sym_NA_integer_] = ACTIONS(7137),
    [anon_sym_NA_real_] = ACTIONS(7137),
    [anon_sym_NA_complex_] = ACTIONS(7137),
    [anon_sym_NA_character_] = ACTIONS(7137),
    [sym_dots] = ACTIONS(7137),
    [sym_dot_dot_i] = ACTIONS(7139),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7139),
    [sym__newline] = ACTIONS(7139),
    [sym__semicolon] = ACTIONS(7139),
    [sym__raw_string_literal] = ACTIONS(7139),
    [sym__external_else] = ACTIONS(7139),
    [sym__external_open_parenthesis] = ACTIONS(7139),
    [sym__external_close_parenthesis] = ACTIONS(7139),
    [sym__external_open_brace] = ACTIONS(7139),
    [sym__external_close_brace] = ACTIONS(7139),
    [sym__external_open_bracket] = ACTIONS(7139),
    [sym__external_open_bracket2] = ACTIONS(7139),
  },
  [1982] = {
    [ts_builtin_sym_end] = ACTIONS(7131),
    [sym_identifier] = ACTIONS(7129),
    [anon_sym_BSLASH] = ACTIONS(7131),
    [anon_sym_function] = ACTIONS(7129),
    [anon_sym_EQ] = ACTIONS(7129),
    [anon_sym_if] = ACTIONS(7129),
    [anon_sym_for] = ACTIONS(7129),
    [anon_sym_while] = ACTIONS(7129),
    [anon_sym_repeat] = ACTIONS(7129),
    [anon_sym_QMARK] = ACTIONS(7131),
    [anon_sym_TILDE] = ACTIONS(7131),
    [anon_sym_BANG] = ACTIONS(7129),
    [anon_sym_PLUS] = ACTIONS(7131),
    [anon_sym_DASH] = ACTIONS(7129),
    [anon_sym_LT_DASH] = ACTIONS(7131),
    [anon_sym_LT_LT_DASH] = ACTIONS(7131),
    [anon_sym_COLON_EQ] = ACTIONS(7131),
    [anon_sym_DASH_GT] = ACTIONS(7129),
    [anon_sym_DASH_GT_GT] = ACTIONS(7131),
    [anon_sym_PIPE] = ACTIONS(7129),
    [anon_sym_AMP] = ACTIONS(7129),
    [anon_sym_PIPE_PIPE] = ACTIONS(7131),
    [anon_sym_AMP_AMP] = ACTIONS(7131),
    [anon_sym_LT] = ACTIONS(7129),
    [anon_sym_LT_EQ] = ACTIONS(7131),
    [anon_sym_GT] = ACTIONS(7129),
    [anon_sym_GT_EQ] = ACTIONS(7131),
    [anon_sym_EQ_EQ] = ACTIONS(7131),
    [anon_sym_BANG_EQ] = ACTIONS(7131),
    [anon_sym_STAR] = ACTIONS(7129),
    [anon_sym_SLASH] = ACTIONS(7131),
    [anon_sym_STAR_STAR] = ACTIONS(7131),
    [anon_sym_CARET] = ACTIONS(7131),
    [aux_sym_binary_operator_token1] = ACTIONS(7131),
    [anon_sym_PIPE_GT] = ACTIONS(7131),
    [anon_sym_COLON] = ACTIONS(7129),
    [anon_sym_DOLLAR] = ACTIONS(7131),
    [anon_sym_AT] = ACTIONS(7131),
    [anon_sym_COLON_COLON] = ACTIONS(7133),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7135),
    [aux_sym__hex_literal_token1] = ACTIONS(7131),
    [sym__number_literal] = ACTIONS(7129),
    [anon_sym_SQUOTE] = ACTIONS(7131),
    [anon_sym_DQUOTE] = ACTIONS(7131),
    [sym_return] = ACTIONS(7129),
    [sym_next] = ACTIONS(7129),
    [sym_break] = ACTIONS(7129),
    [sym_true] = ACTIONS(7129),
    [sym_false] = ACTIONS(7129),
    [sym_null] = ACTIONS(7129),
    [sym_inf] = ACTIONS(7129),
    [sym_nan] = ACTIONS(7129),
    [anon_sym_NA] = ACTIONS(7129),
    [anon_sym_NA_integer_] = ACTIONS(7129),
    [anon_sym_NA_real_] = ACTIONS(7129),
    [anon_sym_NA_complex_] = ACTIONS(7129),
    [anon_sym_NA_character_] = ACTIONS(7129),
    [sym_dots] = ACTIONS(7129),
    [sym_dot_dot_i] = ACTIONS(7131),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7131),
    [sym__newline] = ACTIONS(7131),
    [sym__semicolon] = ACTIONS(7131),
    [sym__raw_string_literal] = ACTIONS(7131),
    [sym__external_else] = ACTIONS(7131),
    [sym__external_open_parenthesis] = ACTIONS(7131),
    [sym__external_close_parenthesis] = ACTIONS(7131),
    [sym__external_open_brace] = ACTIONS(7131),
    [sym__external_close_brace] = ACTIONS(7131),
    [sym__external_open_bracket] = ACTIONS(7131),
    [sym__external_open_bracket2] = ACTIONS(7131),
  },
  [1983] = {
    [sym_call_arguments] = STATE(2985),
    [sym_subset_arguments] = STATE(2986),
    [sym_subset2_arguments] = STATE(2987),
    [sym__open_parenthesis] = STATE(1414),
    [sym__open_bracket] = STATE(1416),
    [sym__open_bracket2] = STATE(1428),
    [ts_builtin_sym_end] = ACTIONS(5453),
    [sym_identifier] = ACTIONS(5455),
    [anon_sym_BSLASH] = ACTIONS(5453),
    [anon_sym_function] = ACTIONS(5455),
    [anon_sym_EQ] = ACTIONS(7155),
    [anon_sym_if] = ACTIONS(5455),
    [anon_sym_for] = ACTIONS(5455),
    [anon_sym_while] = ACTIONS(5455),
    [anon_sym_repeat] = ACTIONS(5455),
    [anon_sym_QMARK] = ACTIONS(5453),
    [anon_sym_TILDE] = ACTIONS(7079),
    [anon_sym_BANG] = ACTIONS(5455),
    [anon_sym_PLUS] = ACTIONS(7081),
    [anon_sym_DASH] = ACTIONS(7083),
    [anon_sym_LT_DASH] = ACTIONS(7157),
    [anon_sym_LT_LT_DASH] = ACTIONS(7157),
    [anon_sym_COLON_EQ] = ACTIONS(7157),
    [anon_sym_DASH_GT] = ACTIONS(7159),
    [anon_sym_DASH_GT_GT] = ACTIONS(7161),
    [anon_sym_PIPE] = ACTIONS(7085),
    [anon_sym_AMP] = ACTIONS(7087),
    [anon_sym_PIPE_PIPE] = ACTIONS(7089),
    [anon_sym_AMP_AMP] = ACTIONS(7091),
    [anon_sym_LT] = ACTIONS(7093),
    [anon_sym_LT_EQ] = ACTIONS(7095),
    [anon_sym_GT] = ACTIONS(7093),
    [anon_sym_GT_EQ] = ACTIONS(7095),
    [anon_sym_EQ_EQ] = ACTIONS(7095),
    [anon_sym_BANG_EQ] = ACTIONS(7095),
    [anon_sym_STAR] = ACTIONS(7097),
    [anon_sym_SLASH] = ACTIONS(7099),
    [anon_sym_STAR_STAR] = ACTIONS(7101),
    [anon_sym_CARET] = ACTIONS(7101),
    [aux_sym_binary_operator_token1] = ACTIONS(7103),
    [anon_sym_PIPE_GT] = ACTIONS(7103),
    [anon_sym_COLON] = ACTIONS(7105),
    [anon_sym_DOLLAR] = ACTIONS(7107),
    [anon_sym_AT] = ACTIONS(7107),
    [aux_sym__hex_literal_token1] = ACTIONS(5453),
    [sym__number_literal] = ACTIONS(5455),
    [anon_sym_SQUOTE] = ACTIONS(5453),
    [anon_sym_DQUOTE] = ACTIONS(5453),
    [sym_return] = ACTIONS(5455),
    [sym_next] = ACTIONS(5455),
    [sym_break] = ACTIONS(5455),
    [sym_true] = ACTIONS(5455),
    [sym_false] = ACTIONS(5455),
    [sym_null] = ACTIONS(5455),
    [sym_inf] = ACTIONS(5455),
    [sym_nan] = ACTIONS(5455),
    [anon_sym_NA] = ACTIONS(5455),
    [anon_sym_NA_integer_] = ACTIONS(5455),
    [anon_sym_NA_real_] = ACTIONS(5455),
    [anon_sym_NA_complex_] = ACTIONS(5455),
    [anon_sym_NA_character_] = ACTIONS(5455),
    [sym_dots] = ACTIONS(5455),
    [sym_dot_dot_i] = ACTIONS(5453),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5453),
    [sym__semicolon] = ACTIONS(5453),
    [sym__raw_string_literal] = ACTIONS(5453),
    [sym__external_open_parenthesis] = ACTIONS(7109),
    [sym__external_open_brace] = ACTIONS(5453),
    [sym__external_open_bracket] = ACTIONS(7111),
    [sym__external_open_bracket2] = ACTIONS(7113),
  },
  [1984] = {
    [ts_builtin_sym_end] = ACTIONS(7123),
    [sym_identifier] = ACTIONS(7121),
    [anon_sym_BSLASH] = ACTIONS(7123),
    [anon_sym_function] = ACTIONS(7121),
    [anon_sym_EQ] = ACTIONS(7121),
    [anon_sym_if] = ACTIONS(7121),
    [anon_sym_for] = ACTIONS(7121),
    [anon_sym_while] = ACTIONS(7121),
    [anon_sym_repeat] = ACTIONS(7121),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_TILDE] = ACTIONS(7123),
    [anon_sym_BANG] = ACTIONS(7121),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_DASH] = ACTIONS(7121),
    [anon_sym_LT_DASH] = ACTIONS(7123),
    [anon_sym_LT_LT_DASH] = ACTIONS(7123),
    [anon_sym_COLON_EQ] = ACTIONS(7123),
    [anon_sym_DASH_GT] = ACTIONS(7121),
    [anon_sym_DASH_GT_GT] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_LT_EQ] = ACTIONS(7123),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
    [aux_sym_binary_operator_token1] = ACTIONS(7123),
    [anon_sym_PIPE_GT] = ACTIONS(7123),
    [anon_sym_COLON] = ACTIONS(7121),
    [anon_sym_DOLLAR] = ACTIONS(7123),
    [anon_sym_AT] = ACTIONS(7123),
    [anon_sym_L] = ACTIONS(7173),
    [anon_sym_i] = ACTIONS(7175),
    [aux_sym__hex_literal_token1] = ACTIONS(7123),
    [sym__number_literal] = ACTIONS(7121),
    [anon_sym_SQUOTE] = ACTIONS(7123),
    [anon_sym_DQUOTE] = ACTIONS(7123),
    [sym_return] = ACTIONS(7121),
    [sym_next] = ACTIONS(7121),
    [sym_break] = ACTIONS(7121),
    [sym_true] = ACTIONS(7121),
    [sym_false] = ACTIONS(7121),
    [sym_null] = ACTIONS(7121),
    [sym_inf] = ACTIONS(7121),
    [sym_nan] = ACTIONS(7121),
    [anon_sym_NA] = ACTIONS(7121),
    [anon_sym_NA_integer_] = ACTIONS(7121),
    [anon_sym_NA_real_] = ACTIONS(7121),
    [anon_sym_NA_complex_] = ACTIONS(7121),
    [anon_sym_NA_character_] = ACTIONS(7121),
    [sym_dots] = ACTIONS(7121),
    [sym_dot_dot_i] = ACTIONS(7123),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7123),
    [sym__newline] = ACTIONS(7123),
    [sym__semicolon] = ACTIONS(7123),
    [sym__raw_string_literal] = ACTIONS(7123),
    [sym__external_else] = ACTIONS(7123),
    [sym__external_open_parenthesis] = ACTIONS(7123),
    [sym__external_close_parenthesis] = ACTIONS(7123),
    [sym__external_open_brace] = ACTIONS(7123),
    [sym__external_close_brace] = ACTIONS(7123),
    [sym__external_open_bracket] = ACTIONS(7123),
    [sym__external_open_bracket2] = ACTIONS(7123),
  },
  [1985] = {
    [ts_builtin_sym_end] = ACTIONS(7117),
    [sym_identifier] = ACTIONS(7115),
    [anon_sym_BSLASH] = ACTIONS(7117),
    [anon_sym_function] = ACTIONS(7115),
    [anon_sym_EQ] = ACTIONS(7115),
    [anon_sym_if] = ACTIONS(7115),
    [anon_sym_for] = ACTIONS(7115),
    [anon_sym_while] = ACTIONS(7115),
    [anon_sym_repeat] = ACTIONS(7115),
    [anon_sym_QMARK] = ACTIONS(7117),
    [anon_sym_TILDE] = ACTIONS(7117),
    [anon_sym_BANG] = ACTIONS(7115),
    [anon_sym_PLUS] = ACTIONS(7117),
    [anon_sym_DASH] = ACTIONS(7115),
    [anon_sym_LT_DASH] = ACTIONS(7117),
    [anon_sym_LT_LT_DASH] = ACTIONS(7117),
    [anon_sym_COLON_EQ] = ACTIONS(7117),
    [anon_sym_DASH_GT] = ACTIONS(7115),
    [anon_sym_DASH_GT_GT] = ACTIONS(7117),
    [anon_sym_PIPE] = ACTIONS(7115),
    [anon_sym_AMP] = ACTIONS(7115),
    [anon_sym_PIPE_PIPE] = ACTIONS(7117),
    [anon_sym_AMP_AMP] = ACTIONS(7117),
    [anon_sym_LT] = ACTIONS(7115),
    [anon_sym_LT_EQ] = ACTIONS(7117),
    [anon_sym_GT] = ACTIONS(7115),
    [anon_sym_GT_EQ] = ACTIONS(7117),
    [anon_sym_EQ_EQ] = ACTIONS(7117),
    [anon_sym_BANG_EQ] = ACTIONS(7117),
    [anon_sym_STAR] = ACTIONS(7115),
    [anon_sym_SLASH] = ACTIONS(7117),
    [anon_sym_STAR_STAR] = ACTIONS(7117),
    [anon_sym_CARET] = ACTIONS(7117),
    [aux_sym_binary_operator_token1] = ACTIONS(7117),
    [anon_sym_PIPE_GT] = ACTIONS(7117),
    [anon_sym_COLON] = ACTIONS(7115),
    [anon_sym_DOLLAR] = ACTIONS(7117),
    [anon_sym_AT] = ACTIONS(7117),
    [anon_sym_COLON_COLON] = ACTIONS(7115),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7117),
    [aux_sym__hex_literal_token1] = ACTIONS(7117),
    [sym__number_literal] = ACTIONS(7115),
    [anon_sym_SQUOTE] = ACTIONS(7117),
    [anon_sym_DQUOTE] = ACTIONS(7117),
    [sym_return] = ACTIONS(7115),
    [sym_next] = ACTIONS(7115),
    [sym_break] = ACTIONS(7115),
    [sym_true] = ACTIONS(7115),
    [sym_false] = ACTIONS(7115),
    [sym_null] = ACTIONS(7115),
    [sym_inf] = ACTIONS(7115),
    [sym_nan] = ACTIONS(7115),
    [anon_sym_NA] = ACTIONS(7115),
    [anon_sym_NA_integer_] = ACTIONS(7115),
    [anon_sym_NA_real_] = ACTIONS(7115),
    [anon_sym_NA_complex_] = ACTIONS(7115),
    [anon_sym_NA_character_] = ACTIONS(7115),
    [sym_dots] = ACTIONS(7115),
    [sym_dot_dot_i] = ACTIONS(7117),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7117),
    [sym__newline] = ACTIONS(7117),
    [sym__semicolon] = ACTIONS(7117),
    [sym__raw_string_literal] = ACTIONS(7117),
    [sym__external_else] = ACTIONS(7117),
    [sym__external_open_parenthesis] = ACTIONS(7117),
    [sym__external_close_parenthesis] = ACTIONS(7117),
    [sym__external_open_brace] = ACTIONS(7117),
    [sym__external_close_brace] = ACTIONS(7117),
    [sym__external_open_bracket] = ACTIONS(7117),
    [sym__external_open_bracket2] = ACTIONS(7117),
  },
  [1986] = {
    [sym_call_arguments] = STATE(2985),
    [sym_subset_arguments] = STATE(2986),
    [sym_subset2_arguments] = STATE(2987),
    [sym__open_parenthesis] = STATE(1414),
    [sym__open_bracket] = STATE(1416),
    [sym__open_bracket2] = STATE(1428),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(7079),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(7081),
    [anon_sym_DASH] = ACTIONS(7083),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(7085),
    [anon_sym_AMP] = ACTIONS(7087),
    [anon_sym_PIPE_PIPE] = ACTIONS(7089),
    [anon_sym_AMP_AMP] = ACTIONS(7091),
    [anon_sym_LT] = ACTIONS(7093),
    [anon_sym_LT_EQ] = ACTIONS(7095),
    [anon_sym_GT] = ACTIONS(7093),
    [anon_sym_GT_EQ] = ACTIONS(7095),
    [anon_sym_EQ_EQ] = ACTIONS(7095),
    [anon_sym_BANG_EQ] = ACTIONS(7095),
    [anon_sym_STAR] = ACTIONS(7097),
    [anon_sym_SLASH] = ACTIONS(7099),
    [anon_sym_STAR_STAR] = ACTIONS(7101),
    [anon_sym_CARET] = ACTIONS(7101),
    [aux_sym_binary_operator_token1] = ACTIONS(7103),
    [anon_sym_PIPE_GT] = ACTIONS(7103),
    [anon_sym_COLON] = ACTIONS(7105),
    [anon_sym_DOLLAR] = ACTIONS(7107),
    [anon_sym_AT] = ACTIONS(7107),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(7109),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(7111),
    [sym__external_open_bracket2] = ACTIONS(7113),
  },
  [1987] = {
    [sym_call_arguments] = STATE(2985),
    [sym_subset_arguments] = STATE(2986),
    [sym_subset2_arguments] = STATE(2987),
    [sym__open_parenthesis] = STATE(1414),
    [sym__open_bracket] = STATE(1416),
    [sym__open_bracket2] = STATE(1428),
    [ts_builtin_sym_end] = ACTIONS(5429),
    [sym_identifier] = ACTIONS(5431),
    [anon_sym_BSLASH] = ACTIONS(5429),
    [anon_sym_function] = ACTIONS(5431),
    [anon_sym_EQ] = ACTIONS(7155),
    [anon_sym_if] = ACTIONS(5431),
    [anon_sym_for] = ACTIONS(5431),
    [anon_sym_while] = ACTIONS(5431),
    [anon_sym_repeat] = ACTIONS(5431),
    [anon_sym_QMARK] = ACTIONS(5429),
    [anon_sym_TILDE] = ACTIONS(7079),
    [anon_sym_BANG] = ACTIONS(5431),
    [anon_sym_PLUS] = ACTIONS(7081),
    [anon_sym_DASH] = ACTIONS(7083),
    [anon_sym_LT_DASH] = ACTIONS(7157),
    [anon_sym_LT_LT_DASH] = ACTIONS(7157),
    [anon_sym_COLON_EQ] = ACTIONS(7157),
    [anon_sym_DASH_GT] = ACTIONS(7159),
    [anon_sym_DASH_GT_GT] = ACTIONS(7161),
    [anon_sym_PIPE] = ACTIONS(7085),
    [anon_sym_AMP] = ACTIONS(7087),
    [anon_sym_PIPE_PIPE] = ACTIONS(7089),
    [anon_sym_AMP_AMP] = ACTIONS(7091),
    [anon_sym_LT] = ACTIONS(7093),
    [anon_sym_LT_EQ] = ACTIONS(7095),
    [anon_sym_GT] = ACTIONS(7093),
    [anon_sym_GT_EQ] = ACTIONS(7095),
    [anon_sym_EQ_EQ] = ACTIONS(7095),
    [anon_sym_BANG_EQ] = ACTIONS(7095),
    [anon_sym_STAR] = ACTIONS(7097),
    [anon_sym_SLASH] = ACTIONS(7099),
    [anon_sym_STAR_STAR] = ACTIONS(7101),
    [anon_sym_CARET] = ACTIONS(7101),
    [aux_sym_binary_operator_token1] = ACTIONS(7103),
    [anon_sym_PIPE_GT] = ACTIONS(7103),
    [anon_sym_COLON] = ACTIONS(7105),
    [anon_sym_DOLLAR] = ACTIONS(7107),
    [anon_sym_AT] = ACTIONS(7107),
    [aux_sym__hex_literal_token1] = ACTIONS(5429),
    [sym__number_literal] = ACTIONS(5431),
    [anon_sym_SQUOTE] = ACTIONS(5429),
    [anon_sym_DQUOTE] = ACTIONS(5429),
    [sym_return] = ACTIONS(5431),
    [sym_next] = ACTIONS(5431),
    [sym_break] = ACTIONS(5431),
    [sym_true] = ACTIONS(5431),
    [sym_false] = ACTIONS(5431),
    [sym_null] = ACTIONS(5431),
    [sym_inf] = ACTIONS(5431),
    [sym_nan] = ACTIONS(5431),
    [anon_sym_NA] = ACTIONS(5431),
    [anon_sym_NA_integer_] = ACTIONS(5431),
    [anon_sym_NA_real_] = ACTIONS(5431),
    [anon_sym_NA_complex_] = ACTIONS(5431),
    [anon_sym_NA_character_] = ACTIONS(5431),
    [sym_dots] = ACTIONS(5431),
    [sym_dot_dot_i] = ACTIONS(5429),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5429),
    [sym__semicolon] = ACTIONS(5429),
    [sym__raw_string_literal] = ACTIONS(5429),
    [sym__external_open_parenthesis] = ACTIONS(7109),
    [sym__external_open_brace] = ACTIONS(5429),
    [sym__external_open_bracket] = ACTIONS(7111),
    [sym__external_open_bracket2] = ACTIONS(7113),
  },
  [1988] = {
    [sym_call_arguments] = STATE(2985),
    [sym_subset_arguments] = STATE(2986),
    [sym_subset2_arguments] = STATE(2987),
    [sym__open_parenthesis] = STATE(1414),
    [sym__open_bracket] = STATE(1416),
    [sym__open_bracket2] = STATE(1428),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(7081),
    [anon_sym_DASH] = ACTIONS(7083),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(7097),
    [anon_sym_SLASH] = ACTIONS(7099),
    [anon_sym_STAR_STAR] = ACTIONS(7101),
    [anon_sym_CARET] = ACTIONS(7101),
    [aux_sym_binary_operator_token1] = ACTIONS(7103),
    [anon_sym_PIPE_GT] = ACTIONS(7103),
    [anon_sym_COLON] = ACTIONS(7105),
    [anon_sym_DOLLAR] = ACTIONS(7107),
    [anon_sym_AT] = ACTIONS(7107),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(7109),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(7111),
    [sym__external_open_bracket2] = ACTIONS(7113),
  },
  [1989] = {
    [sym_call_arguments] = STATE(3027),
    [sym_subset_arguments] = STATE(3026),
    [sym_subset2_arguments] = STATE(3025),
    [sym__open_parenthesis] = STATE(1616),
    [sym__open_bracket] = STATE(1615),
    [sym__open_bracket2] = STATE(1613),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(7065),
    [anon_sym_CARET] = ACTIONS(7065),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(5351),
    [anon_sym_DOLLAR] = ACTIONS(7071),
    [anon_sym_AT] = ACTIONS(7071),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(7073),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(7075),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(7077),
  },
  [1990] = {
    [ts_builtin_sym_end] = ACTIONS(7117),
    [sym_identifier] = ACTIONS(7115),
    [anon_sym_BSLASH] = ACTIONS(7117),
    [anon_sym_function] = ACTIONS(7115),
    [anon_sym_EQ] = ACTIONS(7115),
    [anon_sym_if] = ACTIONS(7115),
    [anon_sym_for] = ACTIONS(7115),
    [anon_sym_while] = ACTIONS(7115),
    [anon_sym_repeat] = ACTIONS(7115),
    [anon_sym_QMARK] = ACTIONS(7117),
    [anon_sym_TILDE] = ACTIONS(7117),
    [anon_sym_BANG] = ACTIONS(7115),
    [anon_sym_PLUS] = ACTIONS(7117),
    [anon_sym_DASH] = ACTIONS(7115),
    [anon_sym_LT_DASH] = ACTIONS(7117),
    [anon_sym_LT_LT_DASH] = ACTIONS(7117),
    [anon_sym_COLON_EQ] = ACTIONS(7117),
    [anon_sym_DASH_GT] = ACTIONS(7115),
    [anon_sym_DASH_GT_GT] = ACTIONS(7117),
    [anon_sym_PIPE] = ACTIONS(7115),
    [anon_sym_AMP] = ACTIONS(7115),
    [anon_sym_PIPE_PIPE] = ACTIONS(7117),
    [anon_sym_AMP_AMP] = ACTIONS(7117),
    [anon_sym_LT] = ACTIONS(7115),
    [anon_sym_LT_EQ] = ACTIONS(7117),
    [anon_sym_GT] = ACTIONS(7115),
    [anon_sym_GT_EQ] = ACTIONS(7117),
    [anon_sym_EQ_EQ] = ACTIONS(7117),
    [anon_sym_BANG_EQ] = ACTIONS(7117),
    [anon_sym_STAR] = ACTIONS(7115),
    [anon_sym_SLASH] = ACTIONS(7117),
    [anon_sym_STAR_STAR] = ACTIONS(7117),
    [anon_sym_CARET] = ACTIONS(7117),
    [aux_sym_binary_operator_token1] = ACTIONS(7117),
    [anon_sym_PIPE_GT] = ACTIONS(7117),
    [anon_sym_COLON] = ACTIONS(7115),
    [anon_sym_DOLLAR] = ACTIONS(7117),
    [anon_sym_AT] = ACTIONS(7117),
    [anon_sym_COLON_COLON] = ACTIONS(7115),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7117),
    [aux_sym__hex_literal_token1] = ACTIONS(7117),
    [sym__number_literal] = ACTIONS(7115),
    [anon_sym_SQUOTE] = ACTIONS(7117),
    [anon_sym_DQUOTE] = ACTIONS(7117),
    [sym_return] = ACTIONS(7115),
    [sym_next] = ACTIONS(7115),
    [sym_break] = ACTIONS(7115),
    [sym_true] = ACTIONS(7115),
    [sym_false] = ACTIONS(7115),
    [sym_null] = ACTIONS(7115),
    [sym_inf] = ACTIONS(7115),
    [sym_nan] = ACTIONS(7115),
    [anon_sym_NA] = ACTIONS(7115),
    [anon_sym_NA_integer_] = ACTIONS(7115),
    [anon_sym_NA_real_] = ACTIONS(7115),
    [anon_sym_NA_complex_] = ACTIONS(7115),
    [anon_sym_NA_character_] = ACTIONS(7115),
    [sym_dots] = ACTIONS(7115),
    [sym_dot_dot_i] = ACTIONS(7117),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7117),
    [sym__newline] = ACTIONS(7117),
    [sym__semicolon] = ACTIONS(7117),
    [sym__raw_string_literal] = ACTIONS(7117),
    [sym__external_else] = ACTIONS(7117),
    [sym__external_open_parenthesis] = ACTIONS(7117),
    [sym__external_close_parenthesis] = ACTIONS(7117),
    [sym__external_open_brace] = ACTIONS(7117),
    [sym__external_close_brace] = ACTIONS(7117),
    [sym__external_open_bracket] = ACTIONS(7117),
    [sym__external_open_bracket2] = ACTIONS(7117),
  },
  [1991] = {
    [sym_call_arguments] = STATE(2985),
    [sym_subset_arguments] = STATE(2986),
    [sym_subset2_arguments] = STATE(2987),
    [sym__open_parenthesis] = STATE(1414),
    [sym__open_bracket] = STATE(1416),
    [sym__open_bracket2] = STATE(1428),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(7155),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(7079),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(7081),
    [anon_sym_DASH] = ACTIONS(7083),
    [anon_sym_LT_DASH] = ACTIONS(7157),
    [anon_sym_LT_LT_DASH] = ACTIONS(7157),
    [anon_sym_COLON_EQ] = ACTIONS(7157),
    [anon_sym_DASH_GT] = ACTIONS(7159),
    [anon_sym_DASH_GT_GT] = ACTIONS(7161),
    [anon_sym_PIPE] = ACTIONS(7085),
    [anon_sym_AMP] = ACTIONS(7087),
    [anon_sym_PIPE_PIPE] = ACTIONS(7089),
    [anon_sym_AMP_AMP] = ACTIONS(7091),
    [anon_sym_LT] = ACTIONS(7093),
    [anon_sym_LT_EQ] = ACTIONS(7095),
    [anon_sym_GT] = ACTIONS(7093),
    [anon_sym_GT_EQ] = ACTIONS(7095),
    [anon_sym_EQ_EQ] = ACTIONS(7095),
    [anon_sym_BANG_EQ] = ACTIONS(7095),
    [anon_sym_STAR] = ACTIONS(7097),
    [anon_sym_SLASH] = ACTIONS(7099),
    [anon_sym_STAR_STAR] = ACTIONS(7101),
    [anon_sym_CARET] = ACTIONS(7101),
    [aux_sym_binary_operator_token1] = ACTIONS(7103),
    [anon_sym_PIPE_GT] = ACTIONS(7103),
    [anon_sym_COLON] = ACTIONS(7105),
    [anon_sym_DOLLAR] = ACTIONS(7107),
    [anon_sym_AT] = ACTIONS(7107),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(7109),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(7111),
    [sym__external_open_bracket2] = ACTIONS(7113),
  },
  [1992] = {
    [sym_call_arguments] = STATE(2985),
    [sym_subset_arguments] = STATE(2986),
    [sym_subset2_arguments] = STATE(2987),
    [sym__open_parenthesis] = STATE(1414),
    [sym__open_bracket] = STATE(1416),
    [sym__open_bracket2] = STATE(1428),
    [ts_builtin_sym_end] = ACTIONS(5409),
    [sym_identifier] = ACTIONS(5411),
    [anon_sym_BSLASH] = ACTIONS(5409),
    [anon_sym_function] = ACTIONS(5411),
    [anon_sym_EQ] = ACTIONS(7155),
    [anon_sym_if] = ACTIONS(5411),
    [anon_sym_for] = ACTIONS(5411),
    [anon_sym_while] = ACTIONS(5411),
    [anon_sym_repeat] = ACTIONS(5411),
    [anon_sym_QMARK] = ACTIONS(5409),
    [anon_sym_TILDE] = ACTIONS(7079),
    [anon_sym_BANG] = ACTIONS(5411),
    [anon_sym_PLUS] = ACTIONS(7081),
    [anon_sym_DASH] = ACTIONS(7083),
    [anon_sym_LT_DASH] = ACTIONS(7157),
    [anon_sym_LT_LT_DASH] = ACTIONS(7157),
    [anon_sym_COLON_EQ] = ACTIONS(7157),
    [anon_sym_DASH_GT] = ACTIONS(7159),
    [anon_sym_DASH_GT_GT] = ACTIONS(7161),
    [anon_sym_PIPE] = ACTIONS(7085),
    [anon_sym_AMP] = ACTIONS(7087),
    [anon_sym_PIPE_PIPE] = ACTIONS(7089),
    [anon_sym_AMP_AMP] = ACTIONS(7091),
    [anon_sym_LT] = ACTIONS(7093),
    [anon_sym_LT_EQ] = ACTIONS(7095),
    [anon_sym_GT] = ACTIONS(7093),
    [anon_sym_GT_EQ] = ACTIONS(7095),
    [anon_sym_EQ_EQ] = ACTIONS(7095),
    [anon_sym_BANG_EQ] = ACTIONS(7095),
    [anon_sym_STAR] = ACTIONS(7097),
    [anon_sym_SLASH] = ACTIONS(7099),
    [anon_sym_STAR_STAR] = ACTIONS(7101),
    [anon_sym_CARET] = ACTIONS(7101),
    [aux_sym_binary_operator_token1] = ACTIONS(7103),
    [anon_sym_PIPE_GT] = ACTIONS(7103),
    [anon_sym_COLON] = ACTIONS(7105),
    [anon_sym_DOLLAR] = ACTIONS(7107),
    [anon_sym_AT] = ACTIONS(7107),
    [aux_sym__hex_literal_token1] = ACTIONS(5409),
    [sym__number_literal] = ACTIONS(5411),
    [anon_sym_SQUOTE] = ACTIONS(5409),
    [anon_sym_DQUOTE] = ACTIONS(5409),
    [sym_return] = ACTIONS(5411),
    [sym_next] = ACTIONS(5411),
    [sym_break] = ACTIONS(5411),
    [sym_true] = ACTIONS(5411),
    [sym_false] = ACTIONS(5411),
    [sym_null] = ACTIONS(5411),
    [sym_inf] = ACTIONS(5411),
    [sym_nan] = ACTIONS(5411),
    [anon_sym_NA] = ACTIONS(5411),
    [anon_sym_NA_integer_] = ACTIONS(5411),
    [anon_sym_NA_real_] = ACTIONS(5411),
    [anon_sym_NA_complex_] = ACTIONS(5411),
    [anon_sym_NA_character_] = ACTIONS(5411),
    [sym_dots] = ACTIONS(5411),
    [sym_dot_dot_i] = ACTIONS(5409),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5409),
    [sym__semicolon] = ACTIONS(5409),
    [sym__raw_string_literal] = ACTIONS(5409),
    [sym__external_open_parenthesis] = ACTIONS(7109),
    [sym__external_open_brace] = ACTIONS(5409),
    [sym__external_open_bracket] = ACTIONS(7111),
    [sym__external_open_bracket2] = ACTIONS(7113),
  },
  [1993] = {
    [sym_call_arguments] = STATE(3027),
    [sym_subset_arguments] = STATE(3026),
    [sym_subset2_arguments] = STATE(3025),
    [sym__open_parenthesis] = STATE(1616),
    [sym__open_bracket] = STATE(1615),
    [sym__open_bracket2] = STATE(1613),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(7065),
    [anon_sym_CARET] = ACTIONS(7065),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(7069),
    [anon_sym_DOLLAR] = ACTIONS(7071),
    [anon_sym_AT] = ACTIONS(7071),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(7073),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(7075),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(7077),
  },
  [1994] = {
    [sym_call_arguments] = STATE(2941),
    [sym_subset_arguments] = STATE(2942),
    [sym_subset2_arguments] = STATE(2943),
    [sym__open_parenthesis] = STATE(1755),
    [sym__open_bracket] = STATE(1763),
    [sym__open_bracket2] = STATE(1866),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(6947),
    [anon_sym_CARET] = ACTIONS(6947),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(5351),
    [anon_sym_DOLLAR] = ACTIONS(6953),
    [anon_sym_AT] = ACTIONS(6953),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6955),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6957),
    [sym__external_open_bracket2] = ACTIONS(6959),
  },
  [1995] = {
    [sym_call_arguments] = STATE(2985),
    [sym_subset_arguments] = STATE(2986),
    [sym_subset2_arguments] = STATE(2987),
    [sym__open_parenthesis] = STATE(1414),
    [sym__open_bracket] = STATE(1416),
    [sym__open_bracket2] = STATE(1428),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(7097),
    [anon_sym_SLASH] = ACTIONS(7099),
    [anon_sym_STAR_STAR] = ACTIONS(7101),
    [anon_sym_CARET] = ACTIONS(7101),
    [aux_sym_binary_operator_token1] = ACTIONS(7103),
    [anon_sym_PIPE_GT] = ACTIONS(7103),
    [anon_sym_COLON] = ACTIONS(7105),
    [anon_sym_DOLLAR] = ACTIONS(7107),
    [anon_sym_AT] = ACTIONS(7107),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(7109),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(7111),
    [sym__external_open_bracket2] = ACTIONS(7113),
  },
  [1996] = {
    [sym_call_arguments] = STATE(2941),
    [sym_subset_arguments] = STATE(2942),
    [sym_subset2_arguments] = STATE(2943),
    [sym__open_parenthesis] = STATE(1755),
    [sym__open_bracket] = STATE(1763),
    [sym__open_bracket2] = STATE(1866),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(6947),
    [anon_sym_CARET] = ACTIONS(6947),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(6951),
    [anon_sym_DOLLAR] = ACTIONS(6953),
    [anon_sym_AT] = ACTIONS(6953),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6955),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6957),
    [sym__external_open_bracket2] = ACTIONS(6959),
  },
  [1997] = {
    [sym_call_arguments] = STATE(3027),
    [sym_subset_arguments] = STATE(3026),
    [sym_subset2_arguments] = STATE(3025),
    [sym__open_parenthesis] = STATE(1616),
    [sym__open_bracket] = STATE(1615),
    [sym__open_bracket2] = STATE(1613),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(7065),
    [anon_sym_CARET] = ACTIONS(7065),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(5351),
    [anon_sym_DOLLAR] = ACTIONS(7071),
    [anon_sym_AT] = ACTIONS(7071),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(7073),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(7075),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(7077),
  },
  [1998] = {
    [sym_call_arguments] = STATE(2985),
    [sym_subset_arguments] = STATE(2986),
    [sym_subset2_arguments] = STATE(2987),
    [sym__open_parenthesis] = STATE(1414),
    [sym__open_bracket] = STATE(1416),
    [sym__open_bracket2] = STATE(1428),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(7101),
    [anon_sym_CARET] = ACTIONS(7101),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(5261),
    [anon_sym_DOLLAR] = ACTIONS(7107),
    [anon_sym_AT] = ACTIONS(7107),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(7109),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(7111),
    [sym__external_open_bracket2] = ACTIONS(7113),
  },
  [1999] = {
    [sym_call_arguments] = STATE(2941),
    [sym_subset_arguments] = STATE(2942),
    [sym_subset2_arguments] = STATE(2943),
    [sym__open_parenthesis] = STATE(1755),
    [sym__open_bracket] = STATE(1763),
    [sym__open_bracket2] = STATE(1866),
    [sym_identifier] = ACTIONS(5343),
    [anon_sym_BSLASH] = ACTIONS(5341),
    [anon_sym_function] = ACTIONS(5343),
    [anon_sym_EQ] = ACTIONS(6919),
    [anon_sym_if] = ACTIONS(5343),
    [anon_sym_for] = ACTIONS(5343),
    [anon_sym_while] = ACTIONS(5343),
    [anon_sym_repeat] = ACTIONS(5343),
    [anon_sym_QMARK] = ACTIONS(5341),
    [anon_sym_TILDE] = ACTIONS(6921),
    [anon_sym_BANG] = ACTIONS(5343),
    [anon_sym_PLUS] = ACTIONS(6923),
    [anon_sym_DASH] = ACTIONS(6925),
    [anon_sym_LT_DASH] = ACTIONS(7147),
    [anon_sym_LT_LT_DASH] = ACTIONS(7147),
    [anon_sym_COLON_EQ] = ACTIONS(7147),
    [anon_sym_DASH_GT] = ACTIONS(6927),
    [anon_sym_DASH_GT_GT] = ACTIONS(6929),
    [anon_sym_PIPE] = ACTIONS(6931),
    [anon_sym_AMP] = ACTIONS(6933),
    [anon_sym_PIPE_PIPE] = ACTIONS(6935),
    [anon_sym_AMP_AMP] = ACTIONS(6937),
    [anon_sym_LT] = ACTIONS(6939),
    [anon_sym_LT_EQ] = ACTIONS(6941),
    [anon_sym_GT] = ACTIONS(6939),
    [anon_sym_GT_EQ] = ACTIONS(6941),
    [anon_sym_EQ_EQ] = ACTIONS(6941),
    [anon_sym_BANG_EQ] = ACTIONS(6941),
    [anon_sym_STAR] = ACTIONS(6943),
    [anon_sym_SLASH] = ACTIONS(6945),
    [anon_sym_STAR_STAR] = ACTIONS(6947),
    [anon_sym_CARET] = ACTIONS(6947),
    [aux_sym_binary_operator_token1] = ACTIONS(6949),
    [anon_sym_PIPE_GT] = ACTIONS(6949),
    [anon_sym_COLON] = ACTIONS(6951),
    [anon_sym_DOLLAR] = ACTIONS(6953),
    [anon_sym_AT] = ACTIONS(6953),
    [aux_sym__hex_literal_token1] = ACTIONS(5341),
    [sym__number_literal] = ACTIONS(5343),
    [anon_sym_SQUOTE] = ACTIONS(5341),
    [anon_sym_DQUOTE] = ACTIONS(5341),
    [sym_return] = ACTIONS(5343),
    [sym_next] = ACTIONS(5343),
    [sym_break] = ACTIONS(5343),
    [sym_true] = ACTIONS(5343),
    [sym_false] = ACTIONS(5343),
    [sym_null] = ACTIONS(5343),
    [sym_inf] = ACTIONS(5343),
    [sym_nan] = ACTIONS(5343),
    [anon_sym_NA] = ACTIONS(5343),
    [anon_sym_NA_integer_] = ACTIONS(5343),
    [anon_sym_NA_real_] = ACTIONS(5343),
    [anon_sym_NA_complex_] = ACTIONS(5343),
    [anon_sym_NA_character_] = ACTIONS(5343),
    [sym_dots] = ACTIONS(5343),
    [sym_dot_dot_i] = ACTIONS(5341),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5341),
    [sym__newline] = ACTIONS(5341),
    [sym__raw_string_literal] = ACTIONS(5341),
    [sym__external_open_parenthesis] = ACTIONS(6955),
    [sym__external_close_parenthesis] = ACTIONS(5341),
    [sym__external_open_brace] = ACTIONS(5341),
    [sym__external_open_bracket] = ACTIONS(6957),
    [sym__external_open_bracket2] = ACTIONS(6959),
  },
  [2000] = {
    [sym_call_arguments] = STATE(2978),
    [sym_subset_arguments] = STATE(2977),
    [sym_subset2_arguments] = STATE(2976),
    [sym__open_parenthesis] = STATE(1606),
    [sym__open_bracket] = STATE(1598),
    [sym__open_bracket2] = STATE(1592),
    [sym_identifier] = ACTIONS(5401),
    [anon_sym_BSLASH] = ACTIONS(5399),
    [anon_sym_function] = ACTIONS(5401),
    [anon_sym_EQ] = ACTIONS(6875),
    [anon_sym_if] = ACTIONS(5401),
    [anon_sym_for] = ACTIONS(5401),
    [anon_sym_while] = ACTIONS(5401),
    [anon_sym_repeat] = ACTIONS(5401),
    [anon_sym_QMARK] = ACTIONS(5399),
    [anon_sym_TILDE] = ACTIONS(6877),
    [anon_sym_BANG] = ACTIONS(5401),
    [anon_sym_PLUS] = ACTIONS(6879),
    [anon_sym_DASH] = ACTIONS(6881),
    [anon_sym_LT_DASH] = ACTIONS(6883),
    [anon_sym_LT_LT_DASH] = ACTIONS(6883),
    [anon_sym_COLON_EQ] = ACTIONS(6883),
    [anon_sym_DASH_GT] = ACTIONS(6885),
    [anon_sym_DASH_GT_GT] = ACTIONS(6887),
    [anon_sym_PIPE] = ACTIONS(6889),
    [anon_sym_AMP] = ACTIONS(6891),
    [anon_sym_PIPE_PIPE] = ACTIONS(6893),
    [anon_sym_AMP_AMP] = ACTIONS(6895),
    [anon_sym_LT] = ACTIONS(6897),
    [anon_sym_LT_EQ] = ACTIONS(6899),
    [anon_sym_GT] = ACTIONS(6897),
    [anon_sym_GT_EQ] = ACTIONS(6899),
    [anon_sym_EQ_EQ] = ACTIONS(6899),
    [anon_sym_BANG_EQ] = ACTIONS(6899),
    [anon_sym_STAR] = ACTIONS(6901),
    [anon_sym_SLASH] = ACTIONS(6903),
    [anon_sym_STAR_STAR] = ACTIONS(6905),
    [anon_sym_CARET] = ACTIONS(6905),
    [aux_sym_binary_operator_token1] = ACTIONS(6907),
    [anon_sym_PIPE_GT] = ACTIONS(6907),
    [anon_sym_COLON] = ACTIONS(6909),
    [anon_sym_DOLLAR] = ACTIONS(6911),
    [anon_sym_AT] = ACTIONS(6911),
    [aux_sym__hex_literal_token1] = ACTIONS(5399),
    [sym__number_literal] = ACTIONS(5401),
    [anon_sym_SQUOTE] = ACTIONS(5399),
    [anon_sym_DQUOTE] = ACTIONS(5399),
    [sym_return] = ACTIONS(5401),
    [sym_next] = ACTIONS(5401),
    [sym_break] = ACTIONS(5401),
    [sym_true] = ACTIONS(5401),
    [sym_false] = ACTIONS(5401),
    [sym_null] = ACTIONS(5401),
    [sym_inf] = ACTIONS(5401),
    [sym_nan] = ACTIONS(5401),
    [anon_sym_NA] = ACTIONS(5401),
    [anon_sym_NA_integer_] = ACTIONS(5401),
    [anon_sym_NA_real_] = ACTIONS(5401),
    [anon_sym_NA_complex_] = ACTIONS(5401),
    [anon_sym_NA_character_] = ACTIONS(5401),
    [sym_dots] = ACTIONS(5401),
    [sym_dot_dot_i] = ACTIONS(5399),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5399),
    [sym__newline] = ACTIONS(5399),
    [sym__raw_string_literal] = ACTIONS(5399),
    [sym__external_open_parenthesis] = ACTIONS(6913),
    [sym__external_open_brace] = ACTIONS(5399),
    [sym__external_open_bracket] = ACTIONS(6915),
    [sym__external_open_bracket2] = ACTIONS(6917),
    [sym__external_close_bracket2] = ACTIONS(5399),
  },
  [2001] = {
    [sym_call_arguments] = STATE(2985),
    [sym_subset_arguments] = STATE(2986),
    [sym_subset2_arguments] = STATE(2987),
    [sym__open_parenthesis] = STATE(1414),
    [sym__open_bracket] = STATE(1416),
    [sym__open_bracket2] = STATE(1428),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(7081),
    [anon_sym_DASH] = ACTIONS(7083),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(7085),
    [anon_sym_AMP] = ACTIONS(7087),
    [anon_sym_PIPE_PIPE] = ACTIONS(7089),
    [anon_sym_AMP_AMP] = ACTIONS(7091),
    [anon_sym_LT] = ACTIONS(7093),
    [anon_sym_LT_EQ] = ACTIONS(7095),
    [anon_sym_GT] = ACTIONS(7093),
    [anon_sym_GT_EQ] = ACTIONS(7095),
    [anon_sym_EQ_EQ] = ACTIONS(7095),
    [anon_sym_BANG_EQ] = ACTIONS(7095),
    [anon_sym_STAR] = ACTIONS(7097),
    [anon_sym_SLASH] = ACTIONS(7099),
    [anon_sym_STAR_STAR] = ACTIONS(7101),
    [anon_sym_CARET] = ACTIONS(7101),
    [aux_sym_binary_operator_token1] = ACTIONS(7103),
    [anon_sym_PIPE_GT] = ACTIONS(7103),
    [anon_sym_COLON] = ACTIONS(7105),
    [anon_sym_DOLLAR] = ACTIONS(7107),
    [anon_sym_AT] = ACTIONS(7107),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(7109),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(7111),
    [sym__external_open_bracket2] = ACTIONS(7113),
  },
  [2002] = {
    [sym_call_arguments] = STATE(2985),
    [sym_subset_arguments] = STATE(2986),
    [sym_subset2_arguments] = STATE(2987),
    [sym__open_parenthesis] = STATE(1414),
    [sym__open_bracket] = STATE(1416),
    [sym__open_bracket2] = STATE(1428),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(7101),
    [anon_sym_CARET] = ACTIONS(7101),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(7105),
    [anon_sym_DOLLAR] = ACTIONS(7107),
    [anon_sym_AT] = ACTIONS(7107),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(7109),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(7111),
    [sym__external_open_bracket2] = ACTIONS(7113),
  },
  [2003] = {
    [sym_call_arguments] = STATE(3027),
    [sym_subset_arguments] = STATE(3026),
    [sym_subset2_arguments] = STATE(3025),
    [sym__open_parenthesis] = STATE(1616),
    [sym__open_bracket] = STATE(1615),
    [sym__open_bracket2] = STATE(1613),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(7065),
    [anon_sym_CARET] = ACTIONS(7065),
    [aux_sym_binary_operator_token1] = ACTIONS(7067),
    [anon_sym_PIPE_GT] = ACTIONS(7067),
    [anon_sym_COLON] = ACTIONS(7069),
    [anon_sym_DOLLAR] = ACTIONS(7071),
    [anon_sym_AT] = ACTIONS(7071),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(7073),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(7075),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(7077),
  },
  [2004] = {
    [ts_builtin_sym_end] = ACTIONS(7153),
    [sym_identifier] = ACTIONS(7151),
    [anon_sym_BSLASH] = ACTIONS(7153),
    [anon_sym_function] = ACTIONS(7151),
    [anon_sym_EQ] = ACTIONS(7151),
    [anon_sym_if] = ACTIONS(7151),
    [anon_sym_for] = ACTIONS(7151),
    [anon_sym_while] = ACTIONS(7151),
    [anon_sym_repeat] = ACTIONS(7151),
    [anon_sym_QMARK] = ACTIONS(7153),
    [anon_sym_TILDE] = ACTIONS(7153),
    [anon_sym_BANG] = ACTIONS(7151),
    [anon_sym_PLUS] = ACTIONS(7153),
    [anon_sym_DASH] = ACTIONS(7151),
    [anon_sym_LT_DASH] = ACTIONS(7153),
    [anon_sym_LT_LT_DASH] = ACTIONS(7153),
    [anon_sym_COLON_EQ] = ACTIONS(7153),
    [anon_sym_DASH_GT] = ACTIONS(7151),
    [anon_sym_DASH_GT_GT] = ACTIONS(7153),
    [anon_sym_PIPE] = ACTIONS(7151),
    [anon_sym_AMP] = ACTIONS(7151),
    [anon_sym_PIPE_PIPE] = ACTIONS(7153),
    [anon_sym_AMP_AMP] = ACTIONS(7153),
    [anon_sym_LT] = ACTIONS(7151),
    [anon_sym_LT_EQ] = ACTIONS(7153),
    [anon_sym_GT] = ACTIONS(7151),
    [anon_sym_GT_EQ] = ACTIONS(7153),
    [anon_sym_EQ_EQ] = ACTIONS(7153),
    [anon_sym_BANG_EQ] = ACTIONS(7153),
    [anon_sym_STAR] = ACTIONS(7151),
    [anon_sym_SLASH] = ACTIONS(7153),
    [anon_sym_STAR_STAR] = ACTIONS(7153),
    [anon_sym_CARET] = ACTIONS(7153),
    [aux_sym_binary_operator_token1] = ACTIONS(7153),
    [anon_sym_PIPE_GT] = ACTIONS(7153),
    [anon_sym_COLON] = ACTIONS(7151),
    [anon_sym_DOLLAR] = ACTIONS(7153),
    [anon_sym_AT] = ACTIONS(7153),
    [anon_sym_COLON_COLON] = ACTIONS(7151),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7153),
    [aux_sym__hex_literal_token1] = ACTIONS(7153),
    [sym__number_literal] = ACTIONS(7151),
    [anon_sym_SQUOTE] = ACTIONS(7153),
    [anon_sym_DQUOTE] = ACTIONS(7153),
    [sym_return] = ACTIONS(7151),
    [sym_next] = ACTIONS(7151),
    [sym_break] = ACTIONS(7151),
    [sym_true] = ACTIONS(7151),
    [sym_false] = ACTIONS(7151),
    [sym_null] = ACTIONS(7151),
    [sym_inf] = ACTIONS(7151),
    [sym_nan] = ACTIONS(7151),
    [anon_sym_NA] = ACTIONS(7151),
    [anon_sym_NA_integer_] = ACTIONS(7151),
    [anon_sym_NA_real_] = ACTIONS(7151),
    [anon_sym_NA_complex_] = ACTIONS(7151),
    [anon_sym_NA_character_] = ACTIONS(7151),
    [sym_dots] = ACTIONS(7151),
    [sym_dot_dot_i] = ACTIONS(7153),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7153),
    [sym__newline] = ACTIONS(7153),
    [sym__semicolon] = ACTIONS(7153),
    [sym__raw_string_literal] = ACTIONS(7153),
    [sym__external_else] = ACTIONS(7153),
    [sym__external_open_parenthesis] = ACTIONS(7153),
    [sym__external_close_parenthesis] = ACTIONS(7153),
    [sym__external_open_brace] = ACTIONS(7153),
    [sym__external_close_brace] = ACTIONS(7153),
    [sym__external_open_bracket] = ACTIONS(7153),
    [sym__external_open_bracket2] = ACTIONS(7153),
  },
  [2005] = {
    [sym_call_arguments] = STATE(2985),
    [sym_subset_arguments] = STATE(2986),
    [sym_subset2_arguments] = STATE(2987),
    [sym__open_parenthesis] = STATE(1414),
    [sym__open_bracket] = STATE(1416),
    [sym__open_bracket2] = STATE(1428),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(7155),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(7079),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(7081),
    [anon_sym_DASH] = ACTIONS(7083),
    [anon_sym_LT_DASH] = ACTIONS(7157),
    [anon_sym_LT_LT_DASH] = ACTIONS(7157),
    [anon_sym_COLON_EQ] = ACTIONS(7157),
    [anon_sym_DASH_GT] = ACTIONS(7159),
    [anon_sym_DASH_GT_GT] = ACTIONS(7161),
    [anon_sym_PIPE] = ACTIONS(7085),
    [anon_sym_AMP] = ACTIONS(7087),
    [anon_sym_PIPE_PIPE] = ACTIONS(7089),
    [anon_sym_AMP_AMP] = ACTIONS(7091),
    [anon_sym_LT] = ACTIONS(7093),
    [anon_sym_LT_EQ] = ACTIONS(7095),
    [anon_sym_GT] = ACTIONS(7093),
    [anon_sym_GT_EQ] = ACTIONS(7095),
    [anon_sym_EQ_EQ] = ACTIONS(7095),
    [anon_sym_BANG_EQ] = ACTIONS(7095),
    [anon_sym_STAR] = ACTIONS(7097),
    [anon_sym_SLASH] = ACTIONS(7099),
    [anon_sym_STAR_STAR] = ACTIONS(7101),
    [anon_sym_CARET] = ACTIONS(7101),
    [aux_sym_binary_operator_token1] = ACTIONS(7103),
    [anon_sym_PIPE_GT] = ACTIONS(7103),
    [anon_sym_COLON] = ACTIONS(7105),
    [anon_sym_DOLLAR] = ACTIONS(7107),
    [anon_sym_AT] = ACTIONS(7107),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(7109),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(7111),
    [sym__external_open_bracket2] = ACTIONS(7113),
  },
  [2006] = {
    [sym_call_arguments] = STATE(2941),
    [sym_subset_arguments] = STATE(2942),
    [sym_subset2_arguments] = STATE(2943),
    [sym__open_parenthesis] = STATE(1755),
    [sym__open_bracket] = STATE(1763),
    [sym__open_bracket2] = STATE(1866),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(6947),
    [anon_sym_CARET] = ACTIONS(6947),
    [aux_sym_binary_operator_token1] = ACTIONS(5349),
    [anon_sym_PIPE_GT] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(5351),
    [anon_sym_DOLLAR] = ACTIONS(6953),
    [anon_sym_AT] = ACTIONS(6953),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6955),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6957),
    [sym__external_open_bracket2] = ACTIONS(6959),
  },
  [2007] = {
    [sym_call_arguments] = STATE(3027),
    [sym_subset_arguments] = STATE(3026),
    [sym_subset2_arguments] = STATE(3025),
    [sym__open_parenthesis] = STATE(1616),
    [sym__open_bracket] = STATE(1615),
    [sym__open_bracket2] = STATE(1613),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(7039),
    [anon_sym_DASH] = ACTIONS(7041),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(7061),
    [anon_sym_SLASH] = ACTIONS(7063),
    [anon_sym_STAR_STAR] = ACTIONS(7065),
    [anon_sym_CARET] = ACTIONS(7065),
    [aux_sym_binary_operator_token1] = ACTIONS(7067),
    [anon_sym_PIPE_GT] = ACTIONS(7067),
    [anon_sym_COLON] = ACTIONS(7069),
    [anon_sym_DOLLAR] = ACTIONS(7071),
    [anon_sym_AT] = ACTIONS(7071),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(7073),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(7075),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(7077),
  },
  [2008] = {
    [ts_builtin_sym_end] = ACTIONS(7165),
    [sym_identifier] = ACTIONS(7163),
    [anon_sym_BSLASH] = ACTIONS(7165),
    [anon_sym_function] = ACTIONS(7163),
    [anon_sym_EQ] = ACTIONS(7163),
    [anon_sym_if] = ACTIONS(7163),
    [anon_sym_for] = ACTIONS(7163),
    [anon_sym_while] = ACTIONS(7163),
    [anon_sym_repeat] = ACTIONS(7163),
    [anon_sym_QMARK] = ACTIONS(7165),
    [anon_sym_TILDE] = ACTIONS(7165),
    [anon_sym_BANG] = ACTIONS(7163),
    [anon_sym_PLUS] = ACTIONS(7165),
    [anon_sym_DASH] = ACTIONS(7163),
    [anon_sym_LT_DASH] = ACTIONS(7165),
    [anon_sym_LT_LT_DASH] = ACTIONS(7165),
    [anon_sym_COLON_EQ] = ACTIONS(7165),
    [anon_sym_DASH_GT] = ACTIONS(7163),
    [anon_sym_DASH_GT_GT] = ACTIONS(7165),
    [anon_sym_PIPE] = ACTIONS(7163),
    [anon_sym_AMP] = ACTIONS(7163),
    [anon_sym_PIPE_PIPE] = ACTIONS(7165),
    [anon_sym_AMP_AMP] = ACTIONS(7165),
    [anon_sym_LT] = ACTIONS(7163),
    [anon_sym_LT_EQ] = ACTIONS(7165),
    [anon_sym_GT] = ACTIONS(7163),
    [anon_sym_GT_EQ] = ACTIONS(7165),
    [anon_sym_EQ_EQ] = ACTIONS(7165),
    [anon_sym_BANG_EQ] = ACTIONS(7165),
    [anon_sym_STAR] = ACTIONS(7163),
    [anon_sym_SLASH] = ACTIONS(7165),
    [anon_sym_STAR_STAR] = ACTIONS(7165),
    [anon_sym_CARET] = ACTIONS(7165),
    [aux_sym_binary_operator_token1] = ACTIONS(7165),
    [anon_sym_PIPE_GT] = ACTIONS(7165),
    [anon_sym_COLON] = ACTIONS(7163),
    [anon_sym_DOLLAR] = ACTIONS(7165),
    [anon_sym_AT] = ACTIONS(7165),
    [anon_sym_COLON_COLON] = ACTIONS(7163),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7165),
    [aux_sym__hex_literal_token1] = ACTIONS(7165),
    [sym__number_literal] = ACTIONS(7163),
    [anon_sym_SQUOTE] = ACTIONS(7165),
    [anon_sym_DQUOTE] = ACTIONS(7165),
    [sym_return] = ACTIONS(7163),
    [sym_next] = ACTIONS(7163),
    [sym_break] = ACTIONS(7163),
    [sym_true] = ACTIONS(7163),
    [sym_false] = ACTIONS(7163),
    [sym_null] = ACTIONS(7163),
    [sym_inf] = ACTIONS(7163),
    [sym_nan] = ACTIONS(7163),
    [anon_sym_NA] = ACTIONS(7163),
    [anon_sym_NA_integer_] = ACTIONS(7163),
    [anon_sym_NA_real_] = ACTIONS(7163),
    [anon_sym_NA_complex_] = ACTIONS(7163),
    [anon_sym_NA_character_] = ACTIONS(7163),
    [sym_dots] = ACTIONS(7163),
    [sym_dot_dot_i] = ACTIONS(7165),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7165),
    [sym__newline] = ACTIONS(7165),
    [sym__semicolon] = ACTIONS(7165),
    [sym__raw_string_literal] = ACTIONS(7165),
    [sym__external_else] = ACTIONS(7165),
    [sym__external_open_parenthesis] = ACTIONS(7165),
    [sym__external_close_parenthesis] = ACTIONS(7165),
    [sym__external_open_brace] = ACTIONS(7165),
    [sym__external_close_brace] = ACTIONS(7165),
    [sym__external_open_bracket] = ACTIONS(7165),
    [sym__external_open_bracket2] = ACTIONS(7165),
  },
  [2009] = {
    [sym_identifier] = ACTIONS(7137),
    [anon_sym_BSLASH] = ACTIONS(7139),
    [anon_sym_function] = ACTIONS(7137),
    [anon_sym_EQ] = ACTIONS(7137),
    [anon_sym_if] = ACTIONS(7137),
    [anon_sym_for] = ACTIONS(7137),
    [anon_sym_while] = ACTIONS(7137),
    [anon_sym_repeat] = ACTIONS(7137),
    [anon_sym_QMARK] = ACTIONS(7139),
    [anon_sym_TILDE] = ACTIONS(7139),
    [anon_sym_BANG] = ACTIONS(7137),
    [anon_sym_PLUS] = ACTIONS(7139),
    [anon_sym_DASH] = ACTIONS(7137),
    [anon_sym_LT_DASH] = ACTIONS(7139),
    [anon_sym_LT_LT_DASH] = ACTIONS(7139),
    [anon_sym_COLON_EQ] = ACTIONS(7139),
    [anon_sym_DASH_GT] = ACTIONS(7137),
    [anon_sym_DASH_GT_GT] = ACTIONS(7139),
    [anon_sym_PIPE] = ACTIONS(7137),
    [anon_sym_AMP] = ACTIONS(7137),
    [anon_sym_PIPE_PIPE] = ACTIONS(7139),
    [anon_sym_AMP_AMP] = ACTIONS(7139),
    [anon_sym_LT] = ACTIONS(7137),
    [anon_sym_LT_EQ] = ACTIONS(7139),
    [anon_sym_GT] = ACTIONS(7137),
    [anon_sym_GT_EQ] = ACTIONS(7139),
    [anon_sym_EQ_EQ] = ACTIONS(7139),
    [anon_sym_BANG_EQ] = ACTIONS(7139),
    [anon_sym_STAR] = ACTIONS(7137),
    [anon_sym_SLASH] = ACTIONS(7139),
    [anon_sym_STAR_STAR] = ACTIONS(7139),
    [anon_sym_CARET] = ACTIONS(7139),
    [aux_sym_binary_operator_token1] = ACTIONS(7139),
    [anon_sym_PIPE_GT] = ACTIONS(7139),
    [anon_sym_COLON] = ACTIONS(7137),
    [anon_sym_DOLLAR] = ACTIONS(7139),
    [anon_sym_AT] = ACTIONS(7139),
    [anon_sym_COLON_COLON] = ACTIONS(7137),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7139),
    [aux_sym__hex_literal_token1] = ACTIONS(7139),
    [sym__number_literal] = ACTIONS(7137),
    [anon_sym_SQUOTE] = ACTIONS(7139),
    [anon_sym_DQUOTE] = ACTIONS(7139),
    [sym_return] = ACTIONS(7137),
    [sym_next] = ACTIONS(7137),
    [sym_break] = ACTIONS(7137),
    [sym_true] = ACTIONS(7137),
    [sym_false] = ACTIONS(7137),
    [sym_null] = ACTIONS(7137),
    [sym_inf] = ACTIONS(7137),
    [sym_nan] = ACTIONS(7137),
    [anon_sym_NA] = ACTIONS(7137),
    [anon_sym_NA_integer_] = ACTIONS(7137),
    [anon_sym_NA_real_] = ACTIONS(7137),
    [anon_sym_NA_complex_] = ACTIONS(7137),
    [anon_sym_NA_character_] = ACTIONS(7137),
    [sym_dots] = ACTIONS(7137),
    [sym_dot_dot_i] = ACTIONS(7139),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7139),
    [sym__newline] = ACTIONS(7139),
    [sym__semicolon] = ACTIONS(7139),
    [sym__raw_string_literal] = ACTIONS(7139),
    [sym__external_else] = ACTIONS(7139),
    [sym__external_open_parenthesis] = ACTIONS(7139),
    [sym__external_close_parenthesis] = ACTIONS(7139),
    [sym__external_open_brace] = ACTIONS(7139),
    [sym__external_close_brace] = ACTIONS(7139),
    [sym__external_open_bracket] = ACTIONS(7139),
    [sym__external_close_bracket] = ACTIONS(7139),
    [sym__external_open_bracket2] = ACTIONS(7139),
  },
  [2010] = {
    [sym_call_arguments] = STATE(2978),
    [sym_subset_arguments] = STATE(2977),
    [sym_subset2_arguments] = STATE(2976),
    [sym__open_parenthesis] = STATE(1606),
    [sym__open_bracket] = STATE(1598),
    [sym__open_bracket2] = STATE(1592),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(6875),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(6877),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(6879),
    [anon_sym_DASH] = ACTIONS(6881),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(6885),
    [anon_sym_DASH_GT_GT] = ACTIONS(6887),
    [anon_sym_PIPE] = ACTIONS(6889),
    [anon_sym_AMP] = ACTIONS(6891),
    [anon_sym_PIPE_PIPE] = ACTIONS(6893),
    [anon_sym_AMP_AMP] = ACTIONS(6895),
    [anon_sym_LT] = ACTIONS(6897),
    [anon_sym_LT_EQ] = ACTIONS(6899),
    [anon_sym_GT] = ACTIONS(6897),
    [anon_sym_GT_EQ] = ACTIONS(6899),
    [anon_sym_EQ_EQ] = ACTIONS(6899),
    [anon_sym_BANG_EQ] = ACTIONS(6899),
    [anon_sym_STAR] = ACTIONS(6901),
    [anon_sym_SLASH] = ACTIONS(6903),
    [anon_sym_STAR_STAR] = ACTIONS(6905),
    [anon_sym_CARET] = ACTIONS(6905),
    [aux_sym_binary_operator_token1] = ACTIONS(6907),
    [anon_sym_PIPE_GT] = ACTIONS(6907),
    [anon_sym_COLON] = ACTIONS(6909),
    [anon_sym_DOLLAR] = ACTIONS(6911),
    [anon_sym_AT] = ACTIONS(6911),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6913),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6915),
    [sym__external_open_bracket2] = ACTIONS(6917),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [2011] = {
    [sym_call_arguments] = STATE(2985),
    [sym_subset_arguments] = STATE(2986),
    [sym_subset2_arguments] = STATE(2987),
    [sym__open_parenthesis] = STATE(1414),
    [sym__open_bracket] = STATE(1416),
    [sym__open_bracket2] = STATE(1428),
    [ts_builtin_sym_end] = ACTIONS(5425),
    [sym_identifier] = ACTIONS(5427),
    [anon_sym_BSLASH] = ACTIONS(5425),
    [anon_sym_function] = ACTIONS(5427),
    [anon_sym_EQ] = ACTIONS(7155),
    [anon_sym_if] = ACTIONS(5427),
    [anon_sym_for] = ACTIONS(5427),
    [anon_sym_while] = ACTIONS(5427),
    [anon_sym_repeat] = ACTIONS(5427),
    [anon_sym_QMARK] = ACTIONS(5425),
    [anon_sym_TILDE] = ACTIONS(7079),
    [anon_sym_BANG] = ACTIONS(5427),
    [anon_sym_PLUS] = ACTIONS(7081),
    [anon_sym_DASH] = ACTIONS(7083),
    [anon_sym_LT_DASH] = ACTIONS(7157),
    [anon_sym_LT_LT_DASH] = ACTIONS(7157),
    [anon_sym_COLON_EQ] = ACTIONS(7157),
    [anon_sym_DASH_GT] = ACTIONS(7159),
    [anon_sym_DASH_GT_GT] = ACTIONS(7161),
    [anon_sym_PIPE] = ACTIONS(7085),
    [anon_sym_AMP] = ACTIONS(7087),
    [anon_sym_PIPE_PIPE] = ACTIONS(7089),
    [anon_sym_AMP_AMP] = ACTIONS(7091),
    [anon_sym_LT] = ACTIONS(7093),
    [anon_sym_LT_EQ] = ACTIONS(7095),
    [anon_sym_GT] = ACTIONS(7093),
    [anon_sym_GT_EQ] = ACTIONS(7095),
    [anon_sym_EQ_EQ] = ACTIONS(7095),
    [anon_sym_BANG_EQ] = ACTIONS(7095),
    [anon_sym_STAR] = ACTIONS(7097),
    [anon_sym_SLASH] = ACTIONS(7099),
    [anon_sym_STAR_STAR] = ACTIONS(7101),
    [anon_sym_CARET] = ACTIONS(7101),
    [aux_sym_binary_operator_token1] = ACTIONS(7103),
    [anon_sym_PIPE_GT] = ACTIONS(7103),
    [anon_sym_COLON] = ACTIONS(7105),
    [anon_sym_DOLLAR] = ACTIONS(7107),
    [anon_sym_AT] = ACTIONS(7107),
    [aux_sym__hex_literal_token1] = ACTIONS(5425),
    [sym__number_literal] = ACTIONS(5427),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_DQUOTE] = ACTIONS(5425),
    [sym_return] = ACTIONS(5427),
    [sym_next] = ACTIONS(5427),
    [sym_break] = ACTIONS(5427),
    [sym_true] = ACTIONS(5427),
    [sym_false] = ACTIONS(5427),
    [sym_null] = ACTIONS(5427),
    [sym_inf] = ACTIONS(5427),
    [sym_nan] = ACTIONS(5427),
    [anon_sym_NA] = ACTIONS(5427),
    [anon_sym_NA_integer_] = ACTIONS(5427),
    [anon_sym_NA_real_] = ACTIONS(5427),
    [anon_sym_NA_complex_] = ACTIONS(5427),
    [anon_sym_NA_character_] = ACTIONS(5427),
    [sym_dots] = ACTIONS(5427),
    [sym_dot_dot_i] = ACTIONS(5425),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5425),
    [sym__semicolon] = ACTIONS(5425),
    [sym__raw_string_literal] = ACTIONS(5425),
    [sym__external_open_parenthesis] = ACTIONS(7109),
    [sym__external_open_brace] = ACTIONS(5425),
    [sym__external_open_bracket] = ACTIONS(7111),
    [sym__external_open_bracket2] = ACTIONS(7113),
  },
  [2012] = {
    [sym_call_arguments] = STATE(2941),
    [sym_subset_arguments] = STATE(2942),
    [sym_subset2_arguments] = STATE(2943),
    [sym__open_parenthesis] = STATE(1755),
    [sym__open_bracket] = STATE(1763),
    [sym__open_bracket2] = STATE(1866),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(6923),
    [anon_sym_DASH] = ACTIONS(6925),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(6931),
    [anon_sym_AMP] = ACTIONS(6933),
    [anon_sym_PIPE_PIPE] = ACTIONS(6935),
    [anon_sym_AMP_AMP] = ACTIONS(6937),
    [anon_sym_LT] = ACTIONS(6939),
    [anon_sym_LT_EQ] = ACTIONS(6941),
    [anon_sym_GT] = ACTIONS(6939),
    [anon_sym_GT_EQ] = ACTIONS(6941),
    [anon_sym_EQ_EQ] = ACTIONS(6941),
    [anon_sym_BANG_EQ] = ACTIONS(6941),
    [anon_sym_STAR] = ACTIONS(6943),
    [anon_sym_SLASH] = ACTIONS(6945),
    [anon_sym_STAR_STAR] = ACTIONS(6947),
    [anon_sym_CARET] = ACTIONS(6947),
    [aux_sym_binary_operator_token1] = ACTIONS(6949),
    [anon_sym_PIPE_GT] = ACTIONS(6949),
    [anon_sym_COLON] = ACTIONS(6951),
    [anon_sym_DOLLAR] = ACTIONS(6953),
    [anon_sym_AT] = ACTIONS(6953),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(6955),
    [sym__external_close_parenthesis] = ACTIONS(5345),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(6957),
    [sym__external_open_bracket2] = ACTIONS(6959),
  },
  [2013] = {
    [sym_call_arguments] = STATE(3027),
    [sym_subset_arguments] = STATE(3026),
    [sym_subset2_arguments] = STATE(3025),
    [sym__open_parenthesis] = STATE(1616),
    [sym__open_bracket] = STATE(1615),
    [sym__open_bracket2] = STATE(1613),
    [sym_identifier] = ACTIONS(5411),
    [anon_sym_BSLASH] = ACTIONS(5409),
    [anon_sym_function] = ACTIONS(5411),
    [anon_sym_EQ] = ACTIONS(7035),
    [anon_sym_if] = ACTIONS(5411),
    [anon_sym_for] = ACTIONS(5411),
    [anon_sym_while] = ACTIONS(5411),
    [anon_sym_repeat] = ACTIONS(5411),
    [anon_sym_QMARK] = ACTIONS(5409),
    [anon_sym_TILDE] = ACTIONS(7037),
    [anon_sym_BANG] = ACTIONS(5411),
    [anon_sym_PLUS] = ACTIONS(7039),
    [anon_sym_DASH] = ACTIONS(7041),
    [anon_sym_LT_DASH] = ACTIONS(7043),
    [anon_sym_LT_LT_DASH] = ACTIONS(7043),
    [anon_sym_COLON_EQ] = ACTIONS(7043),
    [anon_sym_DASH_GT] = ACTIONS(7045),
    [anon_sym_DASH_GT_GT] = ACTIONS(7047),
    [anon_sym_PIPE] = ACTIONS(7049),
    [anon_sym_AMP] = ACTIONS(7051),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_AMP_AMP] = ACTIONS(7055),
    [anon_sym_LT] = ACTIONS(7057),
    [anon_sym_LT_EQ] = ACTIONS(7059),
    [anon_sym_GT] = ACTIONS(7057),
    [anon_sym_GT_EQ] = ACTIONS(7059),
    [anon_sym_EQ_EQ] = ACTIONS(7059),
    [anon_sym_BANG_EQ] = ACTIONS(7059),
    [anon_sym_STAR] = ACTIONS(7061),
    [anon_sym_SLASH] = ACTIONS(7063),
    [anon_sym_STAR_STAR] = ACTIONS(7065),
    [anon_sym_CARET] = ACTIONS(7065),
    [aux_sym_binary_operator_token1] = ACTIONS(7067),
    [anon_sym_PIPE_GT] = ACTIONS(7067),
    [anon_sym_COLON] = ACTIONS(7069),
    [anon_sym_DOLLAR] = ACTIONS(7071),
    [anon_sym_AT] = ACTIONS(7071),
    [aux_sym__hex_literal_token1] = ACTIONS(5409),
    [sym__number_literal] = ACTIONS(5411),
    [anon_sym_SQUOTE] = ACTIONS(5409),
    [anon_sym_DQUOTE] = ACTIONS(5409),
    [sym_return] = ACTIONS(5411),
    [sym_next] = ACTIONS(5411),
    [sym_break] = ACTIONS(5411),
    [sym_true] = ACTIONS(5411),
    [sym_false] = ACTIONS(5411),
    [sym_null] = ACTIONS(5411),
    [sym_inf] = ACTIONS(5411),
    [sym_nan] = ACTIONS(5411),
    [anon_sym_NA] = ACTIONS(5411),
    [anon_sym_NA_integer_] = ACTIONS(5411),
    [anon_sym_NA_real_] = ACTIONS(5411),
    [anon_sym_NA_complex_] = ACTIONS(5411),
    [anon_sym_NA_character_] = ACTIONS(5411),
    [sym_dots] = ACTIONS(5411),
    [sym_dot_dot_i] = ACTIONS(5409),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5409),
    [sym__newline] = ACTIONS(5409),
    [sym__raw_string_literal] = ACTIONS(5409),
    [sym__external_open_parenthesis] = ACTIONS(7073),
    [sym__external_open_brace] = ACTIONS(5409),
    [sym__external_open_bracket] = ACTIONS(7075),
    [sym__external_close_bracket] = ACTIONS(5409),
    [sym__external_open_bracket2] = ACTIONS(7077),
  },
  [2014] = {
    [sym_call_arguments] = STATE(3027),
    [sym_subset_arguments] = STATE(3026),
    [sym_subset2_arguments] = STATE(3025),
    [sym__open_parenthesis] = STATE(1616),
    [sym__open_bracket] = STATE(1615),
    [sym__open_bracket2] = STATE(1613),
    [sym_identifier] = ACTIONS(5455),
    [anon_sym_BSLASH] = ACTIONS(5453),
    [anon_sym_function] = ACTIONS(5455),
    [anon_sym_EQ] = ACTIONS(7035),
    [anon_sym_if] = ACTIONS(5455),
    [anon_sym_for] = ACTIONS(5455),
    [anon_sym_while] = ACTIONS(5455),
    [anon_sym_repeat] = ACTIONS(5455),
    [anon_sym_QMARK] = ACTIONS(5453),
    [anon_sym_TILDE] = ACTIONS(7037),
    [anon_sym_BANG] = ACTIONS(5455),
    [anon_sym_PLUS] = ACTIONS(7039),
    [anon_sym_DASH] = ACTIONS(7041),
    [anon_sym_LT_DASH] = ACTIONS(7043),
    [anon_sym_LT_LT_DASH] = ACTIONS(7043),
    [anon_sym_COLON_EQ] = ACTIONS(7043),
    [anon_sym_DASH_GT] = ACTIONS(7045),
    [anon_sym_DASH_GT_GT] = ACTIONS(7047),
    [anon_sym_PIPE] = ACTIONS(7049),
    [anon_sym_AMP] = ACTIONS(7051),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_AMP_AMP] = ACTIONS(7055),
    [anon_sym_LT] = ACTIONS(7057),
    [anon_sym_LT_EQ] = ACTIONS(7059),
    [anon_sym_GT] = ACTIONS(7057),
    [anon_sym_GT_EQ] = ACTIONS(7059),
    [anon_sym_EQ_EQ] = ACTIONS(7059),
    [anon_sym_BANG_EQ] = ACTIONS(7059),
    [anon_sym_STAR] = ACTIONS(7061),
    [anon_sym_SLASH] = ACTIONS(7063),
    [anon_sym_STAR_STAR] = ACTIONS(7065),
    [anon_sym_CARET] = ACTIONS(7065),
    [aux_sym_binary_operator_token1] = ACTIONS(7067),
    [anon_sym_PIPE_GT] = ACTIONS(7067),
    [anon_sym_COLON] = ACTIONS(7069),
    [anon_sym_DOLLAR] = ACTIONS(7071),
    [anon_sym_AT] = ACTIONS(7071),
    [aux_sym__hex_literal_token1] = ACTIONS(5453),
    [sym__number_literal] = ACTIONS(5455),
    [anon_sym_SQUOTE] = ACTIONS(5453),
    [anon_sym_DQUOTE] = ACTIONS(5453),
    [sym_return] = ACTIONS(5455),
    [sym_next] = ACTIONS(5455),
    [sym_break] = ACTIONS(5455),
    [sym_true] = ACTIONS(5455),
    [sym_false] = ACTIONS(5455),
    [sym_null] = ACTIONS(5455),
    [sym_inf] = ACTIONS(5455),
    [sym_nan] = ACTIONS(5455),
    [anon_sym_NA] = ACTIONS(5455),
    [anon_sym_NA_integer_] = ACTIONS(5455),
    [anon_sym_NA_real_] = ACTIONS(5455),
    [anon_sym_NA_complex_] = ACTIONS(5455),
    [anon_sym_NA_character_] = ACTIONS(5455),
    [sym_dots] = ACTIONS(5455),
    [sym_dot_dot_i] = ACTIONS(5453),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5453),
    [sym__newline] = ACTIONS(5453),
    [sym__raw_string_literal] = ACTIONS(5453),
    [sym__external_open_parenthesis] = ACTIONS(7073),
    [sym__external_open_brace] = ACTIONS(5453),
    [sym__external_open_bracket] = ACTIONS(7075),
    [sym__external_close_bracket] = ACTIONS(5453),
    [sym__external_open_bracket2] = ACTIONS(7077),
  },
  [2015] = {
    [sym_string] = STATE(2758),
    [sym__single_quoted_string] = STATE(2538),
    [sym__double_quoted_string] = STATE(2539),
    [sym__string_or_identifier] = STATE(2758),
    [aux_sym_function_definition_repeat1] = STATE(2742),
    [ts_builtin_sym_end] = ACTIONS(5669),
    [sym_identifier] = ACTIONS(7177),
    [anon_sym_BSLASH] = ACTIONS(5669),
    [anon_sym_function] = ACTIONS(5673),
    [anon_sym_EQ] = ACTIONS(5673),
    [anon_sym_if] = ACTIONS(5673),
    [anon_sym_for] = ACTIONS(5673),
    [anon_sym_while] = ACTIONS(5673),
    [anon_sym_repeat] = ACTIONS(5673),
    [anon_sym_QMARK] = ACTIONS(5669),
    [anon_sym_TILDE] = ACTIONS(5669),
    [anon_sym_BANG] = ACTIONS(5673),
    [anon_sym_PLUS] = ACTIONS(5669),
    [anon_sym_DASH] = ACTIONS(5673),
    [anon_sym_LT_DASH] = ACTIONS(5669),
    [anon_sym_LT_LT_DASH] = ACTIONS(5669),
    [anon_sym_COLON_EQ] = ACTIONS(5669),
    [anon_sym_DASH_GT] = ACTIONS(5673),
    [anon_sym_DASH_GT_GT] = ACTIONS(5669),
    [anon_sym_PIPE] = ACTIONS(5673),
    [anon_sym_AMP] = ACTIONS(5673),
    [anon_sym_PIPE_PIPE] = ACTIONS(5669),
    [anon_sym_AMP_AMP] = ACTIONS(5669),
    [anon_sym_LT] = ACTIONS(5673),
    [anon_sym_LT_EQ] = ACTIONS(5669),
    [anon_sym_GT] = ACTIONS(5673),
    [anon_sym_GT_EQ] = ACTIONS(5669),
    [anon_sym_EQ_EQ] = ACTIONS(5669),
    [anon_sym_BANG_EQ] = ACTIONS(5669),
    [anon_sym_STAR] = ACTIONS(5673),
    [anon_sym_SLASH] = ACTIONS(5669),
    [anon_sym_STAR_STAR] = ACTIONS(5669),
    [anon_sym_CARET] = ACTIONS(5669),
    [aux_sym_binary_operator_token1] = ACTIONS(5669),
    [anon_sym_PIPE_GT] = ACTIONS(5669),
    [anon_sym_COLON] = ACTIONS(5673),
    [anon_sym_DOLLAR] = ACTIONS(5669),
    [anon_sym_AT] = ACTIONS(5669),
    [aux_sym__hex_literal_token1] = ACTIONS(5669),
    [sym__number_literal] = ACTIONS(5673),
    [anon_sym_SQUOTE] = ACTIONS(4081),
    [anon_sym_DQUOTE] = ACTIONS(4083),
    [sym_return] = ACTIONS(5673),
    [sym_next] = ACTIONS(5673),
    [sym_break] = ACTIONS(5673),
    [sym_true] = ACTIONS(5673),
    [sym_false] = ACTIONS(5673),
    [sym_null] = ACTIONS(5673),
    [sym_inf] = ACTIONS(5673),
    [sym_nan] = ACTIONS(5673),
    [anon_sym_NA] = ACTIONS(5673),
    [anon_sym_NA_integer_] = ACTIONS(5673),
    [anon_sym_NA_real_] = ACTIONS(5673),
    [anon_sym_NA_complex_] = ACTIONS(5673),
    [anon_sym_NA_character_] = ACTIONS(5673),
    [sym_dots] = ACTIONS(5673),
    [sym_dot_dot_i] = ACTIONS(5669),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5669),
    [sym__semicolon] = ACTIONS(5669),
    [sym__raw_string_literal] = ACTIONS(4093),
    [sym__external_else] = ACTIONS(5669),
    [sym__external_open_parenthesis] = ACTIONS(5669),
    [sym__external_open_brace] = ACTIONS(5669),
    [sym__external_open_bracket] = ACTIONS(5669),
    [sym__external_open_bracket2] = ACTIONS(5669),
  },
  [2016] = {
    [sym_identifier] = ACTIONS(7129),
    [anon_sym_BSLASH] = ACTIONS(7131),
    [anon_sym_function] = ACTIONS(7129),
    [anon_sym_EQ] = ACTIONS(7129),
    [anon_sym_if] = ACTIONS(7129),
    [anon_sym_for] = ACTIONS(7129),
    [anon_sym_while] = ACTIONS(7129),
    [anon_sym_repeat] = ACTIONS(7129),
    [anon_sym_QMARK] = ACTIONS(7131),
    [anon_sym_TILDE] = ACTIONS(7131),
    [anon_sym_BANG] = ACTIONS(7129),
    [anon_sym_PLUS] = ACTIONS(7131),
    [anon_sym_DASH] = ACTIONS(7129),
    [anon_sym_LT_DASH] = ACTIONS(7131),
    [anon_sym_LT_LT_DASH] = ACTIONS(7131),
    [anon_sym_COLON_EQ] = ACTIONS(7131),
    [anon_sym_DASH_GT] = ACTIONS(7129),
    [anon_sym_DASH_GT_GT] = ACTIONS(7131),
    [anon_sym_PIPE] = ACTIONS(7129),
    [anon_sym_AMP] = ACTIONS(7129),
    [anon_sym_PIPE_PIPE] = ACTIONS(7131),
    [anon_sym_AMP_AMP] = ACTIONS(7131),
    [anon_sym_LT] = ACTIONS(7129),
    [anon_sym_LT_EQ] = ACTIONS(7131),
    [anon_sym_GT] = ACTIONS(7129),
    [anon_sym_GT_EQ] = ACTIONS(7131),
    [anon_sym_EQ_EQ] = ACTIONS(7131),
    [anon_sym_BANG_EQ] = ACTIONS(7131),
    [anon_sym_STAR] = ACTIONS(7129),
    [anon_sym_SLASH] = ACTIONS(7131),
    [anon_sym_STAR_STAR] = ACTIONS(7131),
    [anon_sym_CARET] = ACTIONS(7131),
    [aux_sym_binary_operator_token1] = ACTIONS(7131),
    [anon_sym_PIPE_GT] = ACTIONS(7131),
    [anon_sym_COLON] = ACTIONS(7129),
    [anon_sym_DOLLAR] = ACTIONS(7131),
    [anon_sym_AT] = ACTIONS(7131),
    [anon_sym_COLON_COLON] = ACTIONS(7133),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7135),
    [aux_sym__hex_literal_token1] = ACTIONS(7131),
    [sym__number_literal] = ACTIONS(7129),
    [anon_sym_SQUOTE] = ACTIONS(7131),
    [anon_sym_DQUOTE] = ACTIONS(7131),
    [sym_return] = ACTIONS(7129),
    [sym_next] = ACTIONS(7129),
    [sym_break] = ACTIONS(7129),
    [sym_true] = ACTIONS(7129),
    [sym_false] = ACTIONS(7129),
    [sym_null] = ACTIONS(7129),
    [sym_inf] = ACTIONS(7129),
    [sym_nan] = ACTIONS(7129),
    [anon_sym_NA] = ACTIONS(7129),
    [anon_sym_NA_integer_] = ACTIONS(7129),
    [anon_sym_NA_real_] = ACTIONS(7129),
    [anon_sym_NA_complex_] = ACTIONS(7129),
    [anon_sym_NA_character_] = ACTIONS(7129),
    [sym_dots] = ACTIONS(7129),
    [sym_dot_dot_i] = ACTIONS(7131),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7131),
    [sym__newline] = ACTIONS(7131),
    [sym__semicolon] = ACTIONS(7131),
    [sym__raw_string_literal] = ACTIONS(7131),
    [sym__external_else] = ACTIONS(7131),
    [sym__external_open_parenthesis] = ACTIONS(7131),
    [sym__external_close_parenthesis] = ACTIONS(7131),
    [sym__external_open_brace] = ACTIONS(7131),
    [sym__external_close_brace] = ACTIONS(7131),
    [sym__external_open_bracket] = ACTIONS(7131),
    [sym__external_close_bracket] = ACTIONS(7131),
    [sym__external_open_bracket2] = ACTIONS(7131),
  },
  [2017] = {
    [sym_call_arguments] = STATE(3027),
    [sym_subset_arguments] = STATE(3026),
    [sym_subset2_arguments] = STATE(3025),
    [sym__open_parenthesis] = STATE(1616),
    [sym__open_bracket] = STATE(1615),
    [sym__open_bracket2] = STATE(1613),
    [sym_identifier] = ACTIONS(5451),
    [anon_sym_BSLASH] = ACTIONS(5449),
    [anon_sym_function] = ACTIONS(5451),
    [anon_sym_EQ] = ACTIONS(7035),
    [anon_sym_if] = ACTIONS(5451),
    [anon_sym_for] = ACTIONS(5451),
    [anon_sym_while] = ACTIONS(5451),
    [anon_sym_repeat] = ACTIONS(5451),
    [anon_sym_QMARK] = ACTIONS(5449),
    [anon_sym_TILDE] = ACTIONS(7037),
    [anon_sym_BANG] = ACTIONS(5451),
    [anon_sym_PLUS] = ACTIONS(7039),
    [anon_sym_DASH] = ACTIONS(7041),
    [anon_sym_LT_DASH] = ACTIONS(7043),
    [anon_sym_LT_LT_DASH] = ACTIONS(7043),
    [anon_sym_COLON_EQ] = ACTIONS(7043),
    [anon_sym_DASH_GT] = ACTIONS(7045),
    [anon_sym_DASH_GT_GT] = ACTIONS(7047),
    [anon_sym_PIPE] = ACTIONS(7049),
    [anon_sym_AMP] = ACTIONS(7051),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_AMP_AMP] = ACTIONS(7055),
    [anon_sym_LT] = ACTIONS(7057),
    [anon_sym_LT_EQ] = ACTIONS(7059),
    [anon_sym_GT] = ACTIONS(7057),
    [anon_sym_GT_EQ] = ACTIONS(7059),
    [anon_sym_EQ_EQ] = ACTIONS(7059),
    [anon_sym_BANG_EQ] = ACTIONS(7059),
    [anon_sym_STAR] = ACTIONS(7061),
    [anon_sym_SLASH] = ACTIONS(7063),
    [anon_sym_STAR_STAR] = ACTIONS(7065),
    [anon_sym_CARET] = ACTIONS(7065),
    [aux_sym_binary_operator_token1] = ACTIONS(7067),
    [anon_sym_PIPE_GT] = ACTIONS(7067),
    [anon_sym_COLON] = ACTIONS(7069),
    [anon_sym_DOLLAR] = ACTIONS(7071),
    [anon_sym_AT] = ACTIONS(7071),
    [aux_sym__hex_literal_token1] = ACTIONS(5449),
    [sym__number_literal] = ACTIONS(5451),
    [anon_sym_SQUOTE] = ACTIONS(5449),
    [anon_sym_DQUOTE] = ACTIONS(5449),
    [sym_return] = ACTIONS(5451),
    [sym_next] = ACTIONS(5451),
    [sym_break] = ACTIONS(5451),
    [sym_true] = ACTIONS(5451),
    [sym_false] = ACTIONS(5451),
    [sym_null] = ACTIONS(5451),
    [sym_inf] = ACTIONS(5451),
    [sym_nan] = ACTIONS(5451),
    [anon_sym_NA] = ACTIONS(5451),
    [anon_sym_NA_integer_] = ACTIONS(5451),
    [anon_sym_NA_real_] = ACTIONS(5451),
    [anon_sym_NA_complex_] = ACTIONS(5451),
    [anon_sym_NA_character_] = ACTIONS(5451),
    [sym_dots] = ACTIONS(5451),
    [sym_dot_dot_i] = ACTIONS(5449),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5449),
    [sym__newline] = ACTIONS(5449),
    [sym__raw_string_literal] = ACTIONS(5449),
    [sym__external_open_parenthesis] = ACTIONS(7073),
    [sym__external_open_brace] = ACTIONS(5449),
    [sym__external_open_bracket] = ACTIONS(7075),
    [sym__external_close_bracket] = ACTIONS(5449),
    [sym__external_open_bracket2] = ACTIONS(7077),
  },
  [2018] = {
    [sym_call_arguments] = STATE(2985),
    [sym_subset_arguments] = STATE(2986),
    [sym_subset2_arguments] = STATE(2987),
    [sym__open_parenthesis] = STATE(1414),
    [sym__open_bracket] = STATE(1416),
    [sym__open_bracket2] = STATE(1428),
    [ts_builtin_sym_end] = ACTIONS(7179),
    [sym_identifier] = ACTIONS(7181),
    [anon_sym_BSLASH] = ACTIONS(7179),
    [anon_sym_function] = ACTIONS(7181),
    [anon_sym_EQ] = ACTIONS(7155),
    [anon_sym_if] = ACTIONS(7181),
    [anon_sym_for] = ACTIONS(7181),
    [anon_sym_while] = ACTIONS(7181),
    [anon_sym_repeat] = ACTIONS(7181),
    [anon_sym_QMARK] = ACTIONS(7183),
    [anon_sym_TILDE] = ACTIONS(7079),
    [anon_sym_BANG] = ACTIONS(7181),
    [anon_sym_PLUS] = ACTIONS(7081),
    [anon_sym_DASH] = ACTIONS(7083),
    [anon_sym_LT_DASH] = ACTIONS(7157),
    [anon_sym_LT_LT_DASH] = ACTIONS(7157),
    [anon_sym_COLON_EQ] = ACTIONS(7157),
    [anon_sym_DASH_GT] = ACTIONS(7159),
    [anon_sym_DASH_GT_GT] = ACTIONS(7161),
    [anon_sym_PIPE] = ACTIONS(7085),
    [anon_sym_AMP] = ACTIONS(7087),
    [anon_sym_PIPE_PIPE] = ACTIONS(7089),
    [anon_sym_AMP_AMP] = ACTIONS(7091),
    [anon_sym_LT] = ACTIONS(7093),
    [anon_sym_LT_EQ] = ACTIONS(7095),
    [anon_sym_GT] = ACTIONS(7093),
    [anon_sym_GT_EQ] = ACTIONS(7095),
    [anon_sym_EQ_EQ] = ACTIONS(7095),
    [anon_sym_BANG_EQ] = ACTIONS(7095),
    [anon_sym_STAR] = ACTIONS(7097),
    [anon_sym_SLASH] = ACTIONS(7099),
    [anon_sym_STAR_STAR] = ACTIONS(7101),
    [anon_sym_CARET] = ACTIONS(7101),
    [aux_sym_binary_operator_token1] = ACTIONS(7103),
    [anon_sym_PIPE_GT] = ACTIONS(7103),
    [anon_sym_COLON] = ACTIONS(7105),
    [anon_sym_DOLLAR] = ACTIONS(7107),
    [anon_sym_AT] = ACTIONS(7107),
    [aux_sym__hex_literal_token1] = ACTIONS(7179),
    [sym__number_literal] = ACTIONS(7181),
    [anon_sym_SQUOTE] = ACTIONS(7179),
    [anon_sym_DQUOTE] = ACTIONS(7179),
    [sym_return] = ACTIONS(7181),
    [sym_next] = ACTIONS(7181),
    [sym_break] = ACTIONS(7181),
    [sym_true] = ACTIONS(7181),
    [sym_false] = ACTIONS(7181),
    [sym_null] = ACTIONS(7181),
    [sym_inf] = ACTIONS(7181),
    [sym_nan] = ACTIONS(7181),
    [anon_sym_NA] = ACTIONS(7181),
    [anon_sym_NA_integer_] = ACTIONS(7181),
    [anon_sym_NA_real_] = ACTIONS(7181),
    [anon_sym_NA_complex_] = ACTIONS(7181),
    [anon_sym_NA_character_] = ACTIONS(7181),
    [sym_dots] = ACTIONS(7181),
    [sym_dot_dot_i] = ACTIONS(7179),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7179),
    [sym__semicolon] = ACTIONS(7179),
    [sym__raw_string_literal] = ACTIONS(7179),
    [sym__external_open_parenthesis] = ACTIONS(7109),
    [sym__external_open_brace] = ACTIONS(7179),
    [sym__external_open_bracket] = ACTIONS(7111),
    [sym__external_open_bracket2] = ACTIONS(7113),
  },
  [2019] = {
    [sym_call_arguments] = STATE(3027),
    [sym_subset_arguments] = STATE(3026),
    [sym_subset2_arguments] = STATE(3025),
    [sym__open_parenthesis] = STATE(1616),
    [sym__open_bracket] = STATE(1615),
    [sym__open_bracket2] = STATE(1613),
    [sym_identifier] = ACTIONS(5447),
    [anon_sym_BSLASH] = ACTIONS(5445),
    [anon_sym_function] = ACTIONS(5447),
    [anon_sym_EQ] = ACTIONS(7035),
    [anon_sym_if] = ACTIONS(5447),
    [anon_sym_for] = ACTIONS(5447),
    [anon_sym_while] = ACTIONS(5447),
    [anon_sym_repeat] = ACTIONS(5447),
    [anon_sym_QMARK] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(7037),
    [anon_sym_BANG] = ACTIONS(5447),
    [anon_sym_PLUS] = ACTIONS(7039),
    [anon_sym_DASH] = ACTIONS(7041),
    [anon_sym_LT_DASH] = ACTIONS(7043),
    [anon_sym_LT_LT_DASH] = ACTIONS(7043),
    [anon_sym_COLON_EQ] = ACTIONS(7043),
    [anon_sym_DASH_GT] = ACTIONS(7045),
    [anon_sym_DASH_GT_GT] = ACTIONS(7047),
    [anon_sym_PIPE] = ACTIONS(7049),
    [anon_sym_AMP] = ACTIONS(7051),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_AMP_AMP] = ACTIONS(7055),
    [anon_sym_LT] = ACTIONS(7057),
    [anon_sym_LT_EQ] = ACTIONS(7059),
    [anon_sym_GT] = ACTIONS(7057),
    [anon_sym_GT_EQ] = ACTIONS(7059),
    [anon_sym_EQ_EQ] = ACTIONS(7059),
    [anon_sym_BANG_EQ] = ACTIONS(7059),
    [anon_sym_STAR] = ACTIONS(7061),
    [anon_sym_SLASH] = ACTIONS(7063),
    [anon_sym_STAR_STAR] = ACTIONS(7065),
    [anon_sym_CARET] = ACTIONS(7065),
    [aux_sym_binary_operator_token1] = ACTIONS(7067),
    [anon_sym_PIPE_GT] = ACTIONS(7067),
    [anon_sym_COLON] = ACTIONS(7069),
    [anon_sym_DOLLAR] = ACTIONS(7071),
    [anon_sym_AT] = ACTIONS(7071),
    [aux_sym__hex_literal_token1] = ACTIONS(5445),
    [sym__number_literal] = ACTIONS(5447),
    [anon_sym_SQUOTE] = ACTIONS(5445),
    [anon_sym_DQUOTE] = ACTIONS(5445),
    [sym_return] = ACTIONS(5447),
    [sym_next] = ACTIONS(5447),
    [sym_break] = ACTIONS(5447),
    [sym_true] = ACTIONS(5447),
    [sym_false] = ACTIONS(5447),
    [sym_null] = ACTIONS(5447),
    [sym_inf] = ACTIONS(5447),
    [sym_nan] = ACTIONS(5447),
    [anon_sym_NA] = ACTIONS(5447),
    [anon_sym_NA_integer_] = ACTIONS(5447),
    [anon_sym_NA_real_] = ACTIONS(5447),
    [anon_sym_NA_complex_] = ACTIONS(5447),
    [anon_sym_NA_character_] = ACTIONS(5447),
    [sym_dots] = ACTIONS(5447),
    [sym_dot_dot_i] = ACTIONS(5445),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5445),
    [sym__newline] = ACTIONS(5445),
    [sym__raw_string_literal] = ACTIONS(5445),
    [sym__external_open_parenthesis] = ACTIONS(7073),
    [sym__external_open_brace] = ACTIONS(5445),
    [sym__external_open_bracket] = ACTIONS(7075),
    [sym__external_close_bracket] = ACTIONS(5445),
    [sym__external_open_bracket2] = ACTIONS(7077),
  },
  [2020] = {
    [sym_call_arguments] = STATE(2978),
    [sym_subset_arguments] = STATE(2977),
    [sym_subset2_arguments] = STATE(2976),
    [sym__open_parenthesis] = STATE(1606),
    [sym__open_bracket] = STATE(1598),
    [sym__open_bracket2] = STATE(1592),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(6875),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(6877),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(6879),
    [anon_sym_DASH] = ACTIONS(6881),
    [anon_sym_LT_DASH] = ACTIONS(6883),
    [anon_sym_LT_LT_DASH] = ACTIONS(6883),
    [anon_sym_COLON_EQ] = ACTIONS(6883),
    [anon_sym_DASH_GT] = ACTIONS(6885),
    [anon_sym_DASH_GT_GT] = ACTIONS(6887),
    [anon_sym_PIPE] = ACTIONS(6889),
    [anon_sym_AMP] = ACTIONS(6891),
    [anon_sym_PIPE_PIPE] = ACTIONS(6893),
    [anon_sym_AMP_AMP] = ACTIONS(6895),
    [anon_sym_LT] = ACTIONS(6897),
    [anon_sym_LT_EQ] = ACTIONS(6899),
    [anon_sym_GT] = ACTIONS(6897),
    [anon_sym_GT_EQ] = ACTIONS(6899),
    [anon_sym_EQ_EQ] = ACTIONS(6899),
    [anon_sym_BANG_EQ] = ACTIONS(6899),
    [anon_sym_STAR] = ACTIONS(6901),
    [anon_sym_SLASH] = ACTIONS(6903),
    [anon_sym_STAR_STAR] = ACTIONS(6905),
    [anon_sym_CARET] = ACTIONS(6905),
    [aux_sym_binary_operator_token1] = ACTIONS(6907),
    [anon_sym_PIPE_GT] = ACTIONS(6907),
    [anon_sym_COLON] = ACTIONS(6909),
    [anon_sym_DOLLAR] = ACTIONS(6911),
    [anon_sym_AT] = ACTIONS(6911),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6913),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6915),
    [sym__external_open_bracket2] = ACTIONS(6917),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [2021] = {
    [sym_identifier] = ACTIONS(7121),
    [anon_sym_BSLASH] = ACTIONS(7123),
    [anon_sym_function] = ACTIONS(7121),
    [anon_sym_EQ] = ACTIONS(7121),
    [anon_sym_if] = ACTIONS(7121),
    [anon_sym_for] = ACTIONS(7121),
    [anon_sym_while] = ACTIONS(7121),
    [anon_sym_repeat] = ACTIONS(7121),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_TILDE] = ACTIONS(7123),
    [anon_sym_BANG] = ACTIONS(7121),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_DASH] = ACTIONS(7121),
    [anon_sym_LT_DASH] = ACTIONS(7123),
    [anon_sym_LT_LT_DASH] = ACTIONS(7123),
    [anon_sym_COLON_EQ] = ACTIONS(7123),
    [anon_sym_DASH_GT] = ACTIONS(7121),
    [anon_sym_DASH_GT_GT] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_LT_EQ] = ACTIONS(7123),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
    [aux_sym_binary_operator_token1] = ACTIONS(7123),
    [anon_sym_PIPE_GT] = ACTIONS(7123),
    [anon_sym_COLON] = ACTIONS(7121),
    [anon_sym_DOLLAR] = ACTIONS(7123),
    [anon_sym_AT] = ACTIONS(7123),
    [anon_sym_L] = ACTIONS(7185),
    [anon_sym_i] = ACTIONS(7187),
    [aux_sym__hex_literal_token1] = ACTIONS(7123),
    [sym__number_literal] = ACTIONS(7121),
    [anon_sym_SQUOTE] = ACTIONS(7123),
    [anon_sym_DQUOTE] = ACTIONS(7123),
    [sym_return] = ACTIONS(7121),
    [sym_next] = ACTIONS(7121),
    [sym_break] = ACTIONS(7121),
    [sym_true] = ACTIONS(7121),
    [sym_false] = ACTIONS(7121),
    [sym_null] = ACTIONS(7121),
    [sym_inf] = ACTIONS(7121),
    [sym_nan] = ACTIONS(7121),
    [anon_sym_NA] = ACTIONS(7121),
    [anon_sym_NA_integer_] = ACTIONS(7121),
    [anon_sym_NA_real_] = ACTIONS(7121),
    [anon_sym_NA_complex_] = ACTIONS(7121),
    [anon_sym_NA_character_] = ACTIONS(7121),
    [sym_dots] = ACTIONS(7121),
    [sym_dot_dot_i] = ACTIONS(7123),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7123),
    [sym__newline] = ACTIONS(7123),
    [sym__semicolon] = ACTIONS(7123),
    [sym__raw_string_literal] = ACTIONS(7123),
    [sym__external_else] = ACTIONS(7123),
    [sym__external_open_parenthesis] = ACTIONS(7123),
    [sym__external_close_parenthesis] = ACTIONS(7123),
    [sym__external_open_brace] = ACTIONS(7123),
    [sym__external_close_brace] = ACTIONS(7123),
    [sym__external_open_bracket] = ACTIONS(7123),
    [sym__external_close_bracket] = ACTIONS(7123),
    [sym__external_open_bracket2] = ACTIONS(7123),
  },
  [2022] = {
    [sym_call_arguments] = STATE(3027),
    [sym_subset_arguments] = STATE(3026),
    [sym_subset2_arguments] = STATE(3025),
    [sym__open_parenthesis] = STATE(1616),
    [sym__open_bracket] = STATE(1615),
    [sym__open_bracket2] = STATE(1613),
    [sym_identifier] = ACTIONS(5443),
    [anon_sym_BSLASH] = ACTIONS(5441),
    [anon_sym_function] = ACTIONS(5443),
    [anon_sym_EQ] = ACTIONS(7035),
    [anon_sym_if] = ACTIONS(5443),
    [anon_sym_for] = ACTIONS(5443),
    [anon_sym_while] = ACTIONS(5443),
    [anon_sym_repeat] = ACTIONS(5443),
    [anon_sym_QMARK] = ACTIONS(5441),
    [anon_sym_TILDE] = ACTIONS(7037),
    [anon_sym_BANG] = ACTIONS(5443),
    [anon_sym_PLUS] = ACTIONS(7039),
    [anon_sym_DASH] = ACTIONS(7041),
    [anon_sym_LT_DASH] = ACTIONS(7043),
    [anon_sym_LT_LT_DASH] = ACTIONS(7043),
    [anon_sym_COLON_EQ] = ACTIONS(7043),
    [anon_sym_DASH_GT] = ACTIONS(7045),
    [anon_sym_DASH_GT_GT] = ACTIONS(7047),
    [anon_sym_PIPE] = ACTIONS(7049),
    [anon_sym_AMP] = ACTIONS(7051),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_AMP_AMP] = ACTIONS(7055),
    [anon_sym_LT] = ACTIONS(7057),
    [anon_sym_LT_EQ] = ACTIONS(7059),
    [anon_sym_GT] = ACTIONS(7057),
    [anon_sym_GT_EQ] = ACTIONS(7059),
    [anon_sym_EQ_EQ] = ACTIONS(7059),
    [anon_sym_BANG_EQ] = ACTIONS(7059),
    [anon_sym_STAR] = ACTIONS(7061),
    [anon_sym_SLASH] = ACTIONS(7063),
    [anon_sym_STAR_STAR] = ACTIONS(7065),
    [anon_sym_CARET] = ACTIONS(7065),
    [aux_sym_binary_operator_token1] = ACTIONS(7067),
    [anon_sym_PIPE_GT] = ACTIONS(7067),
    [anon_sym_COLON] = ACTIONS(7069),
    [anon_sym_DOLLAR] = ACTIONS(7071),
    [anon_sym_AT] = ACTIONS(7071),
    [aux_sym__hex_literal_token1] = ACTIONS(5441),
    [sym__number_literal] = ACTIONS(5443),
    [anon_sym_SQUOTE] = ACTIONS(5441),
    [anon_sym_DQUOTE] = ACTIONS(5441),
    [sym_return] = ACTIONS(5443),
    [sym_next] = ACTIONS(5443),
    [sym_break] = ACTIONS(5443),
    [sym_true] = ACTIONS(5443),
    [sym_false] = ACTIONS(5443),
    [sym_null] = ACTIONS(5443),
    [sym_inf] = ACTIONS(5443),
    [sym_nan] = ACTIONS(5443),
    [anon_sym_NA] = ACTIONS(5443),
    [anon_sym_NA_integer_] = ACTIONS(5443),
    [anon_sym_NA_real_] = ACTIONS(5443),
    [anon_sym_NA_complex_] = ACTIONS(5443),
    [anon_sym_NA_character_] = ACTIONS(5443),
    [sym_dots] = ACTIONS(5443),
    [sym_dot_dot_i] = ACTIONS(5441),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5441),
    [sym__newline] = ACTIONS(5441),
    [sym__raw_string_literal] = ACTIONS(5441),
    [sym__external_open_parenthesis] = ACTIONS(7073),
    [sym__external_open_brace] = ACTIONS(5441),
    [sym__external_open_bracket] = ACTIONS(7075),
    [sym__external_close_bracket] = ACTIONS(5441),
    [sym__external_open_bracket2] = ACTIONS(7077),
  },
  [2023] = {
    [sym_call_arguments] = STATE(2978),
    [sym_subset_arguments] = STATE(2977),
    [sym_subset2_arguments] = STATE(2976),
    [sym__open_parenthesis] = STATE(1606),
    [sym__open_bracket] = STATE(1598),
    [sym__open_bracket2] = STATE(1592),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(6879),
    [anon_sym_DASH] = ACTIONS(6881),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(6889),
    [anon_sym_AMP] = ACTIONS(6891),
    [anon_sym_PIPE_PIPE] = ACTIONS(6893),
    [anon_sym_AMP_AMP] = ACTIONS(6895),
    [anon_sym_LT] = ACTIONS(6897),
    [anon_sym_LT_EQ] = ACTIONS(6899),
    [anon_sym_GT] = ACTIONS(6897),
    [anon_sym_GT_EQ] = ACTIONS(6899),
    [anon_sym_EQ_EQ] = ACTIONS(6899),
    [anon_sym_BANG_EQ] = ACTIONS(6899),
    [anon_sym_STAR] = ACTIONS(6901),
    [anon_sym_SLASH] = ACTIONS(6903),
    [anon_sym_STAR_STAR] = ACTIONS(6905),
    [anon_sym_CARET] = ACTIONS(6905),
    [aux_sym_binary_operator_token1] = ACTIONS(6907),
    [anon_sym_PIPE_GT] = ACTIONS(6907),
    [anon_sym_COLON] = ACTIONS(6909),
    [anon_sym_DOLLAR] = ACTIONS(6911),
    [anon_sym_AT] = ACTIONS(6911),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6913),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6915),
    [sym__external_open_bracket2] = ACTIONS(6917),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [2024] = {
    [sym_call_arguments] = STATE(3027),
    [sym_subset_arguments] = STATE(3026),
    [sym_subset2_arguments] = STATE(3025),
    [sym__open_parenthesis] = STATE(1616),
    [sym__open_bracket] = STATE(1615),
    [sym__open_bracket2] = STATE(1613),
    [sym_identifier] = ACTIONS(5439),
    [anon_sym_BSLASH] = ACTIONS(5437),
    [anon_sym_function] = ACTIONS(5439),
    [anon_sym_EQ] = ACTIONS(7035),
    [anon_sym_if] = ACTIONS(5439),
    [anon_sym_for] = ACTIONS(5439),
    [anon_sym_while] = ACTIONS(5439),
    [anon_sym_repeat] = ACTIONS(5439),
    [anon_sym_QMARK] = ACTIONS(5437),
    [anon_sym_TILDE] = ACTIONS(7037),
    [anon_sym_BANG] = ACTIONS(5439),
    [anon_sym_PLUS] = ACTIONS(7039),
    [anon_sym_DASH] = ACTIONS(7041),
    [anon_sym_LT_DASH] = ACTIONS(7043),
    [anon_sym_LT_LT_DASH] = ACTIONS(7043),
    [anon_sym_COLON_EQ] = ACTIONS(7043),
    [anon_sym_DASH_GT] = ACTIONS(7045),
    [anon_sym_DASH_GT_GT] = ACTIONS(7047),
    [anon_sym_PIPE] = ACTIONS(7049),
    [anon_sym_AMP] = ACTIONS(7051),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_AMP_AMP] = ACTIONS(7055),
    [anon_sym_LT] = ACTIONS(7057),
    [anon_sym_LT_EQ] = ACTIONS(7059),
    [anon_sym_GT] = ACTIONS(7057),
    [anon_sym_GT_EQ] = ACTIONS(7059),
    [anon_sym_EQ_EQ] = ACTIONS(7059),
    [anon_sym_BANG_EQ] = ACTIONS(7059),
    [anon_sym_STAR] = ACTIONS(7061),
    [anon_sym_SLASH] = ACTIONS(7063),
    [anon_sym_STAR_STAR] = ACTIONS(7065),
    [anon_sym_CARET] = ACTIONS(7065),
    [aux_sym_binary_operator_token1] = ACTIONS(7067),
    [anon_sym_PIPE_GT] = ACTIONS(7067),
    [anon_sym_COLON] = ACTIONS(7069),
    [anon_sym_DOLLAR] = ACTIONS(7071),
    [anon_sym_AT] = ACTIONS(7071),
    [aux_sym__hex_literal_token1] = ACTIONS(5437),
    [sym__number_literal] = ACTIONS(5439),
    [anon_sym_SQUOTE] = ACTIONS(5437),
    [anon_sym_DQUOTE] = ACTIONS(5437),
    [sym_return] = ACTIONS(5439),
    [sym_next] = ACTIONS(5439),
    [sym_break] = ACTIONS(5439),
    [sym_true] = ACTIONS(5439),
    [sym_false] = ACTIONS(5439),
    [sym_null] = ACTIONS(5439),
    [sym_inf] = ACTIONS(5439),
    [sym_nan] = ACTIONS(5439),
    [anon_sym_NA] = ACTIONS(5439),
    [anon_sym_NA_integer_] = ACTIONS(5439),
    [anon_sym_NA_real_] = ACTIONS(5439),
    [anon_sym_NA_complex_] = ACTIONS(5439),
    [anon_sym_NA_character_] = ACTIONS(5439),
    [sym_dots] = ACTIONS(5439),
    [sym_dot_dot_i] = ACTIONS(5437),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5437),
    [sym__newline] = ACTIONS(5437),
    [sym__raw_string_literal] = ACTIONS(5437),
    [sym__external_open_parenthesis] = ACTIONS(7073),
    [sym__external_open_brace] = ACTIONS(5437),
    [sym__external_open_bracket] = ACTIONS(7075),
    [sym__external_close_bracket] = ACTIONS(5437),
    [sym__external_open_bracket2] = ACTIONS(7077),
  },
  [2025] = {
    [sym_call_arguments] = STATE(2978),
    [sym_subset_arguments] = STATE(2977),
    [sym_subset2_arguments] = STATE(2976),
    [sym__open_parenthesis] = STATE(1606),
    [sym__open_bracket] = STATE(1598),
    [sym__open_bracket2] = STATE(1592),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(6901),
    [anon_sym_SLASH] = ACTIONS(6903),
    [anon_sym_STAR_STAR] = ACTIONS(6905),
    [anon_sym_CARET] = ACTIONS(6905),
    [aux_sym_binary_operator_token1] = ACTIONS(6907),
    [anon_sym_PIPE_GT] = ACTIONS(6907),
    [anon_sym_COLON] = ACTIONS(6909),
    [anon_sym_DOLLAR] = ACTIONS(6911),
    [anon_sym_AT] = ACTIONS(6911),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6913),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6915),
    [sym__external_open_bracket2] = ACTIONS(6917),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [2026] = {
    [sym_call_arguments] = STATE(3027),
    [sym_subset_arguments] = STATE(3026),
    [sym_subset2_arguments] = STATE(3025),
    [sym__open_parenthesis] = STATE(1616),
    [sym__open_bracket] = STATE(1615),
    [sym__open_bracket2] = STATE(1613),
    [sym_identifier] = ACTIONS(5435),
    [anon_sym_BSLASH] = ACTIONS(5433),
    [anon_sym_function] = ACTIONS(5435),
    [anon_sym_EQ] = ACTIONS(7035),
    [anon_sym_if] = ACTIONS(5435),
    [anon_sym_for] = ACTIONS(5435),
    [anon_sym_while] = ACTIONS(5435),
    [anon_sym_repeat] = ACTIONS(5435),
    [anon_sym_QMARK] = ACTIONS(5433),
    [anon_sym_TILDE] = ACTIONS(7037),
    [anon_sym_BANG] = ACTIONS(5435),
    [anon_sym_PLUS] = ACTIONS(7039),
    [anon_sym_DASH] = ACTIONS(7041),
    [anon_sym_LT_DASH] = ACTIONS(7043),
    [anon_sym_LT_LT_DASH] = ACTIONS(7043),
    [anon_sym_COLON_EQ] = ACTIONS(7043),
    [anon_sym_DASH_GT] = ACTIONS(7045),
    [anon_sym_DASH_GT_GT] = ACTIONS(7047),
    [anon_sym_PIPE] = ACTIONS(7049),
    [anon_sym_AMP] = ACTIONS(7051),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_AMP_AMP] = ACTIONS(7055),
    [anon_sym_LT] = ACTIONS(7057),
    [anon_sym_LT_EQ] = ACTIONS(7059),
    [anon_sym_GT] = ACTIONS(7057),
    [anon_sym_GT_EQ] = ACTIONS(7059),
    [anon_sym_EQ_EQ] = ACTIONS(7059),
    [anon_sym_BANG_EQ] = ACTIONS(7059),
    [anon_sym_STAR] = ACTIONS(7061),
    [anon_sym_SLASH] = ACTIONS(7063),
    [anon_sym_STAR_STAR] = ACTIONS(7065),
    [anon_sym_CARET] = ACTIONS(7065),
    [aux_sym_binary_operator_token1] = ACTIONS(7067),
    [anon_sym_PIPE_GT] = ACTIONS(7067),
    [anon_sym_COLON] = ACTIONS(7069),
    [anon_sym_DOLLAR] = ACTIONS(7071),
    [anon_sym_AT] = ACTIONS(7071),
    [aux_sym__hex_literal_token1] = ACTIONS(5433),
    [sym__number_literal] = ACTIONS(5435),
    [anon_sym_SQUOTE] = ACTIONS(5433),
    [anon_sym_DQUOTE] = ACTIONS(5433),
    [sym_return] = ACTIONS(5435),
    [sym_next] = ACTIONS(5435),
    [sym_break] = ACTIONS(5435),
    [sym_true] = ACTIONS(5435),
    [sym_false] = ACTIONS(5435),
    [sym_null] = ACTIONS(5435),
    [sym_inf] = ACTIONS(5435),
    [sym_nan] = ACTIONS(5435),
    [anon_sym_NA] = ACTIONS(5435),
    [anon_sym_NA_integer_] = ACTIONS(5435),
    [anon_sym_NA_real_] = ACTIONS(5435),
    [anon_sym_NA_complex_] = ACTIONS(5435),
    [anon_sym_NA_character_] = ACTIONS(5435),
    [sym_dots] = ACTIONS(5435),
    [sym_dot_dot_i] = ACTIONS(5433),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5433),
    [sym__newline] = ACTIONS(5433),
    [sym__raw_string_literal] = ACTIONS(5433),
    [sym__external_open_parenthesis] = ACTIONS(7073),
    [sym__external_open_brace] = ACTIONS(5433),
    [sym__external_open_bracket] = ACTIONS(7075),
    [sym__external_close_bracket] = ACTIONS(5433),
    [sym__external_open_bracket2] = ACTIONS(7077),
  },
  [2027] = {
    [sym_identifier] = ACTIONS(7115),
    [anon_sym_BSLASH] = ACTIONS(7117),
    [anon_sym_function] = ACTIONS(7115),
    [anon_sym_EQ] = ACTIONS(7115),
    [anon_sym_if] = ACTIONS(7115),
    [anon_sym_for] = ACTIONS(7115),
    [anon_sym_while] = ACTIONS(7115),
    [anon_sym_repeat] = ACTIONS(7115),
    [anon_sym_QMARK] = ACTIONS(7117),
    [anon_sym_TILDE] = ACTIONS(7117),
    [anon_sym_BANG] = ACTIONS(7115),
    [anon_sym_PLUS] = ACTIONS(7117),
    [anon_sym_DASH] = ACTIONS(7115),
    [anon_sym_LT_DASH] = ACTIONS(7117),
    [anon_sym_LT_LT_DASH] = ACTIONS(7117),
    [anon_sym_COLON_EQ] = ACTIONS(7117),
    [anon_sym_DASH_GT] = ACTIONS(7115),
    [anon_sym_DASH_GT_GT] = ACTIONS(7117),
    [anon_sym_PIPE] = ACTIONS(7115),
    [anon_sym_AMP] = ACTIONS(7115),
    [anon_sym_PIPE_PIPE] = ACTIONS(7117),
    [anon_sym_AMP_AMP] = ACTIONS(7117),
    [anon_sym_LT] = ACTIONS(7115),
    [anon_sym_LT_EQ] = ACTIONS(7117),
    [anon_sym_GT] = ACTIONS(7115),
    [anon_sym_GT_EQ] = ACTIONS(7117),
    [anon_sym_EQ_EQ] = ACTIONS(7117),
    [anon_sym_BANG_EQ] = ACTIONS(7117),
    [anon_sym_STAR] = ACTIONS(7115),
    [anon_sym_SLASH] = ACTIONS(7117),
    [anon_sym_STAR_STAR] = ACTIONS(7117),
    [anon_sym_CARET] = ACTIONS(7117),
    [aux_sym_binary_operator_token1] = ACTIONS(7117),
    [anon_sym_PIPE_GT] = ACTIONS(7117),
    [anon_sym_COLON] = ACTIONS(7115),
    [anon_sym_DOLLAR] = ACTIONS(7117),
    [anon_sym_AT] = ACTIONS(7117),
    [anon_sym_COLON_COLON] = ACTIONS(7115),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7117),
    [aux_sym__hex_literal_token1] = ACTIONS(7117),
    [sym__number_literal] = ACTIONS(7115),
    [anon_sym_SQUOTE] = ACTIONS(7117),
    [anon_sym_DQUOTE] = ACTIONS(7117),
    [sym_return] = ACTIONS(7115),
    [sym_next] = ACTIONS(7115),
    [sym_break] = ACTIONS(7115),
    [sym_true] = ACTIONS(7115),
    [sym_false] = ACTIONS(7115),
    [sym_null] = ACTIONS(7115),
    [sym_inf] = ACTIONS(7115),
    [sym_nan] = ACTIONS(7115),
    [anon_sym_NA] = ACTIONS(7115),
    [anon_sym_NA_integer_] = ACTIONS(7115),
    [anon_sym_NA_real_] = ACTIONS(7115),
    [anon_sym_NA_complex_] = ACTIONS(7115),
    [anon_sym_NA_character_] = ACTIONS(7115),
    [sym_dots] = ACTIONS(7115),
    [sym_dot_dot_i] = ACTIONS(7117),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7117),
    [sym__newline] = ACTIONS(7117),
    [sym__semicolon] = ACTIONS(7117),
    [sym__raw_string_literal] = ACTIONS(7117),
    [sym__external_else] = ACTIONS(7117),
    [sym__external_open_parenthesis] = ACTIONS(7117),
    [sym__external_close_parenthesis] = ACTIONS(7117),
    [sym__external_open_brace] = ACTIONS(7117),
    [sym__external_close_brace] = ACTIONS(7117),
    [sym__external_open_bracket] = ACTIONS(7117),
    [sym__external_close_bracket] = ACTIONS(7117),
    [sym__external_open_bracket2] = ACTIONS(7117),
  },
  [2028] = {
    [sym_call_arguments] = STATE(2978),
    [sym_subset_arguments] = STATE(2977),
    [sym_subset2_arguments] = STATE(2976),
    [sym__open_parenthesis] = STATE(1606),
    [sym__open_bracket] = STATE(1598),
    [sym__open_bracket2] = STATE(1592),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(6875),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(6877),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(6879),
    [anon_sym_DASH] = ACTIONS(6881),
    [anon_sym_LT_DASH] = ACTIONS(6883),
    [anon_sym_LT_LT_DASH] = ACTIONS(6883),
    [anon_sym_COLON_EQ] = ACTIONS(6883),
    [anon_sym_DASH_GT] = ACTIONS(6885),
    [anon_sym_DASH_GT_GT] = ACTIONS(6887),
    [anon_sym_PIPE] = ACTIONS(6889),
    [anon_sym_AMP] = ACTIONS(6891),
    [anon_sym_PIPE_PIPE] = ACTIONS(6893),
    [anon_sym_AMP_AMP] = ACTIONS(6895),
    [anon_sym_LT] = ACTIONS(6897),
    [anon_sym_LT_EQ] = ACTIONS(6899),
    [anon_sym_GT] = ACTIONS(6897),
    [anon_sym_GT_EQ] = ACTIONS(6899),
    [anon_sym_EQ_EQ] = ACTIONS(6899),
    [anon_sym_BANG_EQ] = ACTIONS(6899),
    [anon_sym_STAR] = ACTIONS(6901),
    [anon_sym_SLASH] = ACTIONS(6903),
    [anon_sym_STAR_STAR] = ACTIONS(6905),
    [anon_sym_CARET] = ACTIONS(6905),
    [aux_sym_binary_operator_token1] = ACTIONS(6907),
    [anon_sym_PIPE_GT] = ACTIONS(6907),
    [anon_sym_COLON] = ACTIONS(6909),
    [anon_sym_DOLLAR] = ACTIONS(6911),
    [anon_sym_AT] = ACTIONS(6911),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6913),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6915),
    [sym__external_open_bracket2] = ACTIONS(6917),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [2029] = {
    [sym_call_arguments] = STATE(2978),
    [sym_subset_arguments] = STATE(2977),
    [sym_subset2_arguments] = STATE(2976),
    [sym__open_parenthesis] = STATE(1606),
    [sym__open_bracket] = STATE(1598),
    [sym__open_bracket2] = STATE(1592),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(6877),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(6879),
    [anon_sym_DASH] = ACTIONS(6881),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(6889),
    [anon_sym_AMP] = ACTIONS(6891),
    [anon_sym_PIPE_PIPE] = ACTIONS(6893),
    [anon_sym_AMP_AMP] = ACTIONS(6895),
    [anon_sym_LT] = ACTIONS(6897),
    [anon_sym_LT_EQ] = ACTIONS(6899),
    [anon_sym_GT] = ACTIONS(6897),
    [anon_sym_GT_EQ] = ACTIONS(6899),
    [anon_sym_EQ_EQ] = ACTIONS(6899),
    [anon_sym_BANG_EQ] = ACTIONS(6899),
    [anon_sym_STAR] = ACTIONS(6901),
    [anon_sym_SLASH] = ACTIONS(6903),
    [anon_sym_STAR_STAR] = ACTIONS(6905),
    [anon_sym_CARET] = ACTIONS(6905),
    [aux_sym_binary_operator_token1] = ACTIONS(6907),
    [anon_sym_PIPE_GT] = ACTIONS(6907),
    [anon_sym_COLON] = ACTIONS(6909),
    [anon_sym_DOLLAR] = ACTIONS(6911),
    [anon_sym_AT] = ACTIONS(6911),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6913),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6915),
    [sym__external_open_bracket2] = ACTIONS(6917),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [2030] = {
    [sym_call_arguments] = STATE(2941),
    [sym_subset_arguments] = STATE(2942),
    [sym_subset2_arguments] = STATE(2943),
    [sym__open_parenthesis] = STATE(1755),
    [sym__open_bracket] = STATE(1763),
    [sym__open_bracket2] = STATE(1866),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(6923),
    [anon_sym_DASH] = ACTIONS(6925),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5347),
    [anon_sym_AMP] = ACTIONS(5347),
    [anon_sym_PIPE_PIPE] = ACTIONS(5345),
    [anon_sym_AMP_AMP] = ACTIONS(5345),
    [anon_sym_LT] = ACTIONS(6939),
    [anon_sym_LT_EQ] = ACTIONS(6941),
    [anon_sym_GT] = ACTIONS(6939),
    [anon_sym_GT_EQ] = ACTIONS(6941),
    [anon_sym_EQ_EQ] = ACTIONS(6941),
    [anon_sym_BANG_EQ] = ACTIONS(6941),
    [anon_sym_STAR] = ACTIONS(6943),
    [anon_sym_SLASH] = ACTIONS(6945),
    [anon_sym_STAR_STAR] = ACTIONS(6947),
    [anon_sym_CARET] = ACTIONS(6947),
    [aux_sym_binary_operator_token1] = ACTIONS(6949),
    [anon_sym_PIPE_GT] = ACTIONS(6949),
    [anon_sym_COLON] = ACTIONS(6951),
    [anon_sym_DOLLAR] = ACTIONS(6953),
    [anon_sym_AT] = ACTIONS(6953),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(6955),
    [sym__external_close_parenthesis] = ACTIONS(5345),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(6957),
    [sym__external_open_bracket2] = ACTIONS(6959),
  },
  [2031] = {
    [ts_builtin_sym_end] = ACTIONS(7189),
    [sym_identifier] = ACTIONS(7191),
    [anon_sym_BSLASH] = ACTIONS(7189),
    [anon_sym_function] = ACTIONS(7191),
    [anon_sym_EQ] = ACTIONS(7191),
    [anon_sym_if] = ACTIONS(7191),
    [anon_sym_for] = ACTIONS(7191),
    [anon_sym_while] = ACTIONS(7191),
    [anon_sym_repeat] = ACTIONS(7191),
    [anon_sym_QMARK] = ACTIONS(7189),
    [anon_sym_TILDE] = ACTIONS(7189),
    [anon_sym_BANG] = ACTIONS(7191),
    [anon_sym_PLUS] = ACTIONS(7189),
    [anon_sym_DASH] = ACTIONS(7191),
    [anon_sym_LT_DASH] = ACTIONS(7189),
    [anon_sym_LT_LT_DASH] = ACTIONS(7189),
    [anon_sym_COLON_EQ] = ACTIONS(7189),
    [anon_sym_DASH_GT] = ACTIONS(7191),
    [anon_sym_DASH_GT_GT] = ACTIONS(7189),
    [anon_sym_PIPE] = ACTIONS(7191),
    [anon_sym_AMP] = ACTIONS(7191),
    [anon_sym_PIPE_PIPE] = ACTIONS(7189),
    [anon_sym_AMP_AMP] = ACTIONS(7189),
    [anon_sym_LT] = ACTIONS(7191),
    [anon_sym_LT_EQ] = ACTIONS(7189),
    [anon_sym_GT] = ACTIONS(7191),
    [anon_sym_GT_EQ] = ACTIONS(7189),
    [anon_sym_EQ_EQ] = ACTIONS(7189),
    [anon_sym_BANG_EQ] = ACTIONS(7189),
    [anon_sym_STAR] = ACTIONS(7191),
    [anon_sym_SLASH] = ACTIONS(7189),
    [anon_sym_STAR_STAR] = ACTIONS(7189),
    [anon_sym_CARET] = ACTIONS(7189),
    [aux_sym_binary_operator_token1] = ACTIONS(7189),
    [anon_sym_PIPE_GT] = ACTIONS(7189),
    [anon_sym_COLON] = ACTIONS(7191),
    [anon_sym_DOLLAR] = ACTIONS(7189),
    [anon_sym_AT] = ACTIONS(7189),
    [anon_sym_COLON_COLON] = ACTIONS(7191),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7189),
    [aux_sym__hex_literal_token1] = ACTIONS(7189),
    [sym__number_literal] = ACTIONS(7191),
    [anon_sym_SQUOTE] = ACTIONS(7189),
    [anon_sym_DQUOTE] = ACTIONS(7189),
    [sym_return] = ACTIONS(7191),
    [sym_next] = ACTIONS(7191),
    [sym_break] = ACTIONS(7191),
    [sym_true] = ACTIONS(7191),
    [sym_false] = ACTIONS(7191),
    [sym_null] = ACTIONS(7191),
    [sym_inf] = ACTIONS(7191),
    [sym_nan] = ACTIONS(7191),
    [anon_sym_NA] = ACTIONS(7191),
    [anon_sym_NA_integer_] = ACTIONS(7191),
    [anon_sym_NA_real_] = ACTIONS(7191),
    [anon_sym_NA_complex_] = ACTIONS(7191),
    [anon_sym_NA_character_] = ACTIONS(7191),
    [sym_dots] = ACTIONS(7191),
    [sym_dot_dot_i] = ACTIONS(7189),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7189),
    [sym__newline] = ACTIONS(7189),
    [sym__semicolon] = ACTIONS(7189),
    [sym__raw_string_literal] = ACTIONS(7189),
    [sym__external_else] = ACTIONS(7189),
    [sym__external_open_parenthesis] = ACTIONS(7189),
    [sym__external_close_parenthesis] = ACTIONS(7189),
    [sym__external_open_brace] = ACTIONS(7189),
    [sym__external_close_brace] = ACTIONS(7189),
    [sym__external_open_bracket] = ACTIONS(7189),
    [sym__external_open_bracket2] = ACTIONS(7189),
  },
  [2032] = {
    [sym_call_arguments] = STATE(2978),
    [sym_subset_arguments] = STATE(2977),
    [sym_subset2_arguments] = STATE(2976),
    [sym__open_parenthesis] = STATE(1606),
    [sym__open_bracket] = STATE(1598),
    [sym__open_bracket2] = STATE(1592),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(6879),
    [anon_sym_DASH] = ACTIONS(6881),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(6891),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(6895),
    [anon_sym_LT] = ACTIONS(6897),
    [anon_sym_LT_EQ] = ACTIONS(6899),
    [anon_sym_GT] = ACTIONS(6897),
    [anon_sym_GT_EQ] = ACTIONS(6899),
    [anon_sym_EQ_EQ] = ACTIONS(6899),
    [anon_sym_BANG_EQ] = ACTIONS(6899),
    [anon_sym_STAR] = ACTIONS(6901),
    [anon_sym_SLASH] = ACTIONS(6903),
    [anon_sym_STAR_STAR] = ACTIONS(6905),
    [anon_sym_CARET] = ACTIONS(6905),
    [aux_sym_binary_operator_token1] = ACTIONS(6907),
    [anon_sym_PIPE_GT] = ACTIONS(6907),
    [anon_sym_COLON] = ACTIONS(6909),
    [anon_sym_DOLLAR] = ACTIONS(6911),
    [anon_sym_AT] = ACTIONS(6911),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6913),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6915),
    [sym__external_open_bracket2] = ACTIONS(6917),
    [sym__external_close_bracket2] = ACTIONS(5349),
  },
  [2033] = {
    [ts_builtin_sym_end] = ACTIONS(7193),
    [sym_identifier] = ACTIONS(7195),
    [anon_sym_BSLASH] = ACTIONS(7193),
    [anon_sym_function] = ACTIONS(7195),
    [anon_sym_EQ] = ACTIONS(7195),
    [anon_sym_if] = ACTIONS(7195),
    [anon_sym_for] = ACTIONS(7195),
    [anon_sym_while] = ACTIONS(7195),
    [anon_sym_repeat] = ACTIONS(7195),
    [anon_sym_QMARK] = ACTIONS(7193),
    [anon_sym_TILDE] = ACTIONS(7193),
    [anon_sym_BANG] = ACTIONS(7195),
    [anon_sym_PLUS] = ACTIONS(7193),
    [anon_sym_DASH] = ACTIONS(7195),
    [anon_sym_LT_DASH] = ACTIONS(7193),
    [anon_sym_LT_LT_DASH] = ACTIONS(7193),
    [anon_sym_COLON_EQ] = ACTIONS(7193),
    [anon_sym_DASH_GT] = ACTIONS(7195),
    [anon_sym_DASH_GT_GT] = ACTIONS(7193),
    [anon_sym_PIPE] = ACTIONS(7195),
    [anon_sym_AMP] = ACTIONS(7195),
    [anon_sym_PIPE_PIPE] = ACTIONS(7193),
    [anon_sym_AMP_AMP] = ACTIONS(7193),
    [anon_sym_LT] = ACTIONS(7195),
    [anon_sym_LT_EQ] = ACTIONS(7193),
    [anon_sym_GT] = ACTIONS(7195),
    [anon_sym_GT_EQ] = ACTIONS(7193),
    [anon_sym_EQ_EQ] = ACTIONS(7193),
    [anon_sym_BANG_EQ] = ACTIONS(7193),
    [anon_sym_STAR] = ACTIONS(7195),
    [anon_sym_SLASH] = ACTIONS(7193),
    [anon_sym_STAR_STAR] = ACTIONS(7193),
    [anon_sym_CARET] = ACTIONS(7193),
    [aux_sym_binary_operator_token1] = ACTIONS(7193),
    [anon_sym_PIPE_GT] = ACTIONS(7193),
    [anon_sym_COLON] = ACTIONS(7195),
    [anon_sym_DOLLAR] = ACTIONS(7193),
    [anon_sym_AT] = ACTIONS(7193),
    [anon_sym_COLON_COLON] = ACTIONS(7195),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7193),
    [aux_sym__hex_literal_token1] = ACTIONS(7193),
    [sym__number_literal] = ACTIONS(7195),
    [anon_sym_SQUOTE] = ACTIONS(7193),
    [anon_sym_DQUOTE] = ACTIONS(7193),
    [sym_return] = ACTIONS(7195),
    [sym_next] = ACTIONS(7195),
    [sym_break] = ACTIONS(7195),
    [sym_true] = ACTIONS(7195),
    [sym_false] = ACTIONS(7195),
    [sym_null] = ACTIONS(7195),
    [sym_inf] = ACTIONS(7195),
    [sym_nan] = ACTIONS(7195),
    [anon_sym_NA] = ACTIONS(7195),
    [anon_sym_NA_integer_] = ACTIONS(7195),
    [anon_sym_NA_real_] = ACTIONS(7195),
    [anon_sym_NA_complex_] = ACTIONS(7195),
    [anon_sym_NA_character_] = ACTIONS(7195),
    [sym_dots] = ACTIONS(7195),
    [sym_dot_dot_i] = ACTIONS(7193),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7193),
    [sym__newline] = ACTIONS(7193),
    [sym__semicolon] = ACTIONS(7193),
    [sym__raw_string_literal] = ACTIONS(7193),
    [sym__external_else] = ACTIONS(7193),
    [sym__external_open_parenthesis] = ACTIONS(7193),
    [sym__external_close_parenthesis] = ACTIONS(7193),
    [sym__external_open_brace] = ACTIONS(7193),
    [sym__external_close_brace] = ACTIONS(7193),
    [sym__external_open_bracket] = ACTIONS(7193),
    [sym__external_open_bracket2] = ACTIONS(7193),
  },
  [2034] = {
    [sym_function_definition] = STATE(2038),
    [sym_if_statement] = STATE(2038),
    [sym_for_statement] = STATE(2038),
    [sym_while_statement] = STATE(2038),
    [sym_repeat_statement] = STATE(2038),
    [sym_braced_expression] = STATE(2038),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_call] = STATE(2038),
    [sym_subset] = STATE(2038),
    [sym_subset2] = STATE(2038),
    [sym__argument] = STATE(4664),
    [sym_argument] = STATE(4659),
    [sym__argument_named] = STATE(4654),
    [sym__argument_unnamed] = STATE(4676),
    [sym__argument_value] = STATE(4677),
    [sym_unary_operator] = STATE(2038),
    [sym_binary_operator] = STATE(2038),
    [sym_extract_operator] = STATE(2038),
    [sym_namespace_operator] = STATE(2038),
    [sym_integer] = STATE(2038),
    [sym_complex] = STATE(2038),
    [sym_float] = STATE(2038),
    [sym__hex_literal] = STATE(2700),
    [sym__float_literal] = STATE(2700),
    [sym_string] = STATE(2597),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym_na] = STATE(2038),
    [sym__expression] = STATE(2038),
    [sym__string_or_identifier] = STATE(5148),
    [sym__open_parenthesis] = STATE(214),
    [sym__open_brace] = STATE(192),
    [aux_sym_call_arguments_repeat1] = STATE(2034),
    [sym_identifier] = ACTIONS(7197),
    [anon_sym_BSLASH] = ACTIONS(7200),
    [anon_sym_function] = ACTIONS(7203),
    [anon_sym_if] = ACTIONS(7206),
    [anon_sym_for] = ACTIONS(7209),
    [anon_sym_while] = ACTIONS(7212),
    [anon_sym_repeat] = ACTIONS(7215),
    [anon_sym_QMARK] = ACTIONS(7218),
    [anon_sym_TILDE] = ACTIONS(7221),
    [anon_sym_BANG] = ACTIONS(7224),
    [anon_sym_PLUS] = ACTIONS(7227),
    [anon_sym_DASH] = ACTIONS(7227),
    [aux_sym__hex_literal_token1] = ACTIONS(7230),
    [sym__number_literal] = ACTIONS(7233),
    [anon_sym_SQUOTE] = ACTIONS(7236),
    [anon_sym_DQUOTE] = ACTIONS(7239),
    [sym_return] = ACTIONS(7242),
    [sym_next] = ACTIONS(7242),
    [sym_break] = ACTIONS(7242),
    [sym_true] = ACTIONS(7242),
    [sym_false] = ACTIONS(7242),
    [sym_null] = ACTIONS(7242),
    [sym_inf] = ACTIONS(7242),
    [sym_nan] = ACTIONS(7242),
    [anon_sym_NA] = ACTIONS(7245),
    [anon_sym_NA_integer_] = ACTIONS(7245),
    [anon_sym_NA_real_] = ACTIONS(7245),
    [anon_sym_NA_complex_] = ACTIONS(7245),
    [anon_sym_NA_character_] = ACTIONS(7245),
    [sym_dots] = ACTIONS(7248),
    [sym_dot_dot_i] = ACTIONS(7251),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7254),
    [sym__newline] = ACTIONS(7257),
    [sym__raw_string_literal] = ACTIONS(7260),
    [sym__external_open_parenthesis] = ACTIONS(7263),
    [sym__external_open_brace] = ACTIONS(7266),
    [sym__external_close_bracket] = ACTIONS(7033),
  },
  [2035] = {
    [sym_call_arguments] = STATE(2978),
    [sym_subset_arguments] = STATE(2977),
    [sym_subset2_arguments] = STATE(2976),
    [sym__open_parenthesis] = STATE(1606),
    [sym__open_bracket] = STATE(1598),
    [sym__open_bracket2] = STATE(1592),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(6879),
    [anon_sym_DASH] = ACTIONS(6881),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(6897),
    [anon_sym_LT_EQ] = ACTIONS(6899),
    [anon_sym_GT] = ACTIONS(6897),
    [anon_sym_GT_EQ] = ACTIONS(6899),
    [anon_sym_EQ_EQ] = ACTIONS(6899),
    [anon_sym_BANG_EQ] = ACTIONS(6899),
    [anon_sym_STAR] = ACTIONS(6901),
    [anon_sym_SLASH] = ACTIONS(6903),
    [anon_sym_STAR_STAR] = ACTIONS(6905),
    [anon_sym_CARET] = ACTIONS(6905),
    [aux_sym_binary_operator_token1] = ACTIONS(6907),
    [anon_sym_PIPE_GT] = ACTIONS(6907),
    [anon_sym_COLON] = ACTIONS(6909),
    [anon_sym_DOLLAR] = ACTIONS(6911),
    [anon_sym_AT] = ACTIONS(6911),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6913),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6915),
    [sym__external_open_bracket2] = ACTIONS(6917),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [2036] = {
    [sym_string] = STATE(2720),
    [sym__single_quoted_string] = STATE(2236),
    [sym__double_quoted_string] = STATE(2237),
    [sym__string_or_identifier] = STATE(2720),
    [sym_identifier] = ACTIONS(7269),
    [anon_sym_BSLASH] = ACTIONS(5883),
    [anon_sym_function] = ACTIONS(5887),
    [anon_sym_EQ] = ACTIONS(5887),
    [anon_sym_if] = ACTIONS(5887),
    [anon_sym_for] = ACTIONS(5887),
    [anon_sym_while] = ACTIONS(5887),
    [anon_sym_repeat] = ACTIONS(5887),
    [anon_sym_QMARK] = ACTIONS(5883),
    [anon_sym_TILDE] = ACTIONS(5883),
    [anon_sym_BANG] = ACTIONS(5887),
    [anon_sym_PLUS] = ACTIONS(5883),
    [anon_sym_DASH] = ACTIONS(5887),
    [anon_sym_LT_DASH] = ACTIONS(5883),
    [anon_sym_LT_LT_DASH] = ACTIONS(5883),
    [anon_sym_COLON_EQ] = ACTIONS(5883),
    [anon_sym_DASH_GT] = ACTIONS(5887),
    [anon_sym_DASH_GT_GT] = ACTIONS(5883),
    [anon_sym_PIPE] = ACTIONS(5887),
    [anon_sym_AMP] = ACTIONS(5887),
    [anon_sym_PIPE_PIPE] = ACTIONS(5883),
    [anon_sym_AMP_AMP] = ACTIONS(5883),
    [anon_sym_LT] = ACTIONS(5887),
    [anon_sym_LT_EQ] = ACTIONS(5883),
    [anon_sym_GT] = ACTIONS(5887),
    [anon_sym_GT_EQ] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5883),
    [anon_sym_BANG_EQ] = ACTIONS(5883),
    [anon_sym_STAR] = ACTIONS(5887),
    [anon_sym_SLASH] = ACTIONS(5883),
    [anon_sym_STAR_STAR] = ACTIONS(5883),
    [anon_sym_CARET] = ACTIONS(5883),
    [aux_sym_binary_operator_token1] = ACTIONS(5883),
    [anon_sym_PIPE_GT] = ACTIONS(5883),
    [anon_sym_COLON] = ACTIONS(5887),
    [anon_sym_DOLLAR] = ACTIONS(5883),
    [anon_sym_AT] = ACTIONS(5883),
    [aux_sym__hex_literal_token1] = ACTIONS(5883),
    [sym__number_literal] = ACTIONS(5887),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [anon_sym_DQUOTE] = ACTIONS(1463),
    [sym_return] = ACTIONS(5887),
    [sym_next] = ACTIONS(5887),
    [sym_break] = ACTIONS(5887),
    [sym_true] = ACTIONS(5887),
    [sym_false] = ACTIONS(5887),
    [sym_null] = ACTIONS(5887),
    [sym_inf] = ACTIONS(5887),
    [sym_nan] = ACTIONS(5887),
    [anon_sym_NA] = ACTIONS(5887),
    [anon_sym_NA_integer_] = ACTIONS(5887),
    [anon_sym_NA_real_] = ACTIONS(5887),
    [anon_sym_NA_complex_] = ACTIONS(5887),
    [anon_sym_NA_character_] = ACTIONS(5887),
    [sym_dots] = ACTIONS(5887),
    [sym_dot_dot_i] = ACTIONS(5883),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5883),
    [sym__newline] = ACTIONS(5883),
    [sym__semicolon] = ACTIONS(5883),
    [sym__raw_string_literal] = ACTIONS(1473),
    [sym__external_open_parenthesis] = ACTIONS(5883),
    [sym__external_open_brace] = ACTIONS(5883),
    [sym__external_close_brace] = ACTIONS(5883),
    [sym__external_open_bracket] = ACTIONS(5883),
    [sym__external_open_bracket2] = ACTIONS(5883),
    [sym__external_close_bracket2] = ACTIONS(5883),
  },
  [2037] = {
    [sym_call_arguments] = STATE(2941),
    [sym_subset_arguments] = STATE(2942),
    [sym_subset2_arguments] = STATE(2943),
    [sym__open_parenthesis] = STATE(1755),
    [sym__open_bracket] = STATE(1763),
    [sym__open_bracket2] = STATE(1866),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5345),
    [anon_sym_DASH] = ACTIONS(5347),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5347),
    [anon_sym_AMP] = ACTIONS(5347),
    [anon_sym_PIPE_PIPE] = ACTIONS(5345),
    [anon_sym_AMP_AMP] = ACTIONS(5345),
    [anon_sym_LT] = ACTIONS(5347),
    [anon_sym_LT_EQ] = ACTIONS(5345),
    [anon_sym_GT] = ACTIONS(5347),
    [anon_sym_GT_EQ] = ACTIONS(5345),
    [anon_sym_EQ_EQ] = ACTIONS(5345),
    [anon_sym_BANG_EQ] = ACTIONS(5345),
    [anon_sym_STAR] = ACTIONS(5347),
    [anon_sym_SLASH] = ACTIONS(5345),
    [anon_sym_STAR_STAR] = ACTIONS(6947),
    [anon_sym_CARET] = ACTIONS(6947),
    [aux_sym_binary_operator_token1] = ACTIONS(5345),
    [anon_sym_PIPE_GT] = ACTIONS(5345),
    [anon_sym_COLON] = ACTIONS(5347),
    [anon_sym_DOLLAR] = ACTIONS(6953),
    [anon_sym_AT] = ACTIONS(6953),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(6955),
    [sym__external_close_parenthesis] = ACTIONS(5345),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(6957),
    [sym__external_open_bracket2] = ACTIONS(6959),
  },
  [2038] = {
    [sym_call_arguments] = STATE(3027),
    [sym_subset_arguments] = STATE(3026),
    [sym_subset2_arguments] = STATE(3025),
    [sym__open_parenthesis] = STATE(1616),
    [sym__open_bracket] = STATE(1615),
    [sym__open_bracket2] = STATE(1613),
    [sym_identifier] = ACTIONS(7141),
    [anon_sym_BSLASH] = ACTIONS(7143),
    [anon_sym_function] = ACTIONS(7141),
    [anon_sym_EQ] = ACTIONS(7035),
    [anon_sym_if] = ACTIONS(7141),
    [anon_sym_for] = ACTIONS(7141),
    [anon_sym_while] = ACTIONS(7141),
    [anon_sym_repeat] = ACTIONS(7141),
    [anon_sym_QMARK] = ACTIONS(7271),
    [anon_sym_TILDE] = ACTIONS(7037),
    [anon_sym_BANG] = ACTIONS(7141),
    [anon_sym_PLUS] = ACTIONS(7039),
    [anon_sym_DASH] = ACTIONS(7041),
    [anon_sym_LT_DASH] = ACTIONS(7043),
    [anon_sym_LT_LT_DASH] = ACTIONS(7043),
    [anon_sym_COLON_EQ] = ACTIONS(7043),
    [anon_sym_DASH_GT] = ACTIONS(7045),
    [anon_sym_DASH_GT_GT] = ACTIONS(7047),
    [anon_sym_PIPE] = ACTIONS(7049),
    [anon_sym_AMP] = ACTIONS(7051),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_AMP_AMP] = ACTIONS(7055),
    [anon_sym_LT] = ACTIONS(7057),
    [anon_sym_LT_EQ] = ACTIONS(7059),
    [anon_sym_GT] = ACTIONS(7057),
    [anon_sym_GT_EQ] = ACTIONS(7059),
    [anon_sym_EQ_EQ] = ACTIONS(7059),
    [anon_sym_BANG_EQ] = ACTIONS(7059),
    [anon_sym_STAR] = ACTIONS(7061),
    [anon_sym_SLASH] = ACTIONS(7063),
    [anon_sym_STAR_STAR] = ACTIONS(7065),
    [anon_sym_CARET] = ACTIONS(7065),
    [aux_sym_binary_operator_token1] = ACTIONS(7067),
    [anon_sym_PIPE_GT] = ACTIONS(7067),
    [anon_sym_COLON] = ACTIONS(7069),
    [anon_sym_DOLLAR] = ACTIONS(7071),
    [anon_sym_AT] = ACTIONS(7071),
    [aux_sym__hex_literal_token1] = ACTIONS(7143),
    [sym__number_literal] = ACTIONS(7141),
    [anon_sym_SQUOTE] = ACTIONS(7143),
    [anon_sym_DQUOTE] = ACTIONS(7143),
    [sym_return] = ACTIONS(7141),
    [sym_next] = ACTIONS(7141),
    [sym_break] = ACTIONS(7141),
    [sym_true] = ACTIONS(7141),
    [sym_false] = ACTIONS(7141),
    [sym_null] = ACTIONS(7141),
    [sym_inf] = ACTIONS(7141),
    [sym_nan] = ACTIONS(7141),
    [anon_sym_NA] = ACTIONS(7141),
    [anon_sym_NA_integer_] = ACTIONS(7141),
    [anon_sym_NA_real_] = ACTIONS(7141),
    [anon_sym_NA_complex_] = ACTIONS(7141),
    [anon_sym_NA_character_] = ACTIONS(7141),
    [sym_dots] = ACTIONS(7141),
    [sym_dot_dot_i] = ACTIONS(7143),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7143),
    [sym__newline] = ACTIONS(7143),
    [sym__raw_string_literal] = ACTIONS(7143),
    [sym__external_open_parenthesis] = ACTIONS(7073),
    [sym__external_open_brace] = ACTIONS(7143),
    [sym__external_open_bracket] = ACTIONS(7075),
    [sym__external_close_bracket] = ACTIONS(7143),
    [sym__external_open_bracket2] = ACTIONS(7077),
  },
  [2039] = {
    [sym_string] = STATE(2837),
    [sym__single_quoted_string] = STATE(2462),
    [sym__double_quoted_string] = STATE(2494),
    [sym__string_or_identifier] = STATE(2837),
    [aux_sym_function_definition_repeat1] = STATE(2670),
    [ts_builtin_sym_end] = ACTIONS(5669),
    [sym_identifier] = ACTIONS(7273),
    [anon_sym_BSLASH] = ACTIONS(5669),
    [anon_sym_function] = ACTIONS(5673),
    [anon_sym_EQ] = ACTIONS(5673),
    [anon_sym_if] = ACTIONS(5673),
    [anon_sym_for] = ACTIONS(5673),
    [anon_sym_while] = ACTIONS(5673),
    [anon_sym_repeat] = ACTIONS(5673),
    [anon_sym_QMARK] = ACTIONS(5669),
    [anon_sym_TILDE] = ACTIONS(5669),
    [anon_sym_BANG] = ACTIONS(5673),
    [anon_sym_PLUS] = ACTIONS(5669),
    [anon_sym_DASH] = ACTIONS(5673),
    [anon_sym_LT_DASH] = ACTIONS(5669),
    [anon_sym_LT_LT_DASH] = ACTIONS(5669),
    [anon_sym_COLON_EQ] = ACTIONS(5669),
    [anon_sym_DASH_GT] = ACTIONS(5673),
    [anon_sym_DASH_GT_GT] = ACTIONS(5669),
    [anon_sym_PIPE] = ACTIONS(5673),
    [anon_sym_AMP] = ACTIONS(5673),
    [anon_sym_PIPE_PIPE] = ACTIONS(5669),
    [anon_sym_AMP_AMP] = ACTIONS(5669),
    [anon_sym_LT] = ACTIONS(5673),
    [anon_sym_LT_EQ] = ACTIONS(5669),
    [anon_sym_GT] = ACTIONS(5673),
    [anon_sym_GT_EQ] = ACTIONS(5669),
    [anon_sym_EQ_EQ] = ACTIONS(5669),
    [anon_sym_BANG_EQ] = ACTIONS(5669),
    [anon_sym_STAR] = ACTIONS(5673),
    [anon_sym_SLASH] = ACTIONS(5669),
    [anon_sym_STAR_STAR] = ACTIONS(5669),
    [anon_sym_CARET] = ACTIONS(5669),
    [aux_sym_binary_operator_token1] = ACTIONS(5669),
    [anon_sym_PIPE_GT] = ACTIONS(5669),
    [anon_sym_COLON] = ACTIONS(5673),
    [anon_sym_DOLLAR] = ACTIONS(5669),
    [anon_sym_AT] = ACTIONS(5669),
    [aux_sym__hex_literal_token1] = ACTIONS(5669),
    [sym__number_literal] = ACTIONS(5673),
    [anon_sym_SQUOTE] = ACTIONS(2971),
    [anon_sym_DQUOTE] = ACTIONS(2973),
    [sym_return] = ACTIONS(5673),
    [sym_next] = ACTIONS(5673),
    [sym_break] = ACTIONS(5673),
    [sym_true] = ACTIONS(5673),
    [sym_false] = ACTIONS(5673),
    [sym_null] = ACTIONS(5673),
    [sym_inf] = ACTIONS(5673),
    [sym_nan] = ACTIONS(5673),
    [anon_sym_NA] = ACTIONS(5673),
    [anon_sym_NA_integer_] = ACTIONS(5673),
    [anon_sym_NA_real_] = ACTIONS(5673),
    [anon_sym_NA_complex_] = ACTIONS(5673),
    [anon_sym_NA_character_] = ACTIONS(5673),
    [sym_dots] = ACTIONS(5673),
    [sym_dot_dot_i] = ACTIONS(5669),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5669),
    [sym__semicolon] = ACTIONS(5669),
    [sym__raw_string_literal] = ACTIONS(2983),
    [sym__external_open_parenthesis] = ACTIONS(5669),
    [sym__external_close_parenthesis] = ACTIONS(5669),
    [sym__external_open_brace] = ACTIONS(5669),
    [sym__external_open_bracket] = ACTIONS(5669),
    [sym__external_open_bracket2] = ACTIONS(5669),
  },
  [2040] = {
    [sym_call_arguments] = STATE(2978),
    [sym_subset_arguments] = STATE(2977),
    [sym_subset2_arguments] = STATE(2976),
    [sym__open_parenthesis] = STATE(1606),
    [sym__open_bracket] = STATE(1598),
    [sym__open_bracket2] = STATE(1592),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(6879),
    [anon_sym_DASH] = ACTIONS(6881),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(6901),
    [anon_sym_SLASH] = ACTIONS(6903),
    [anon_sym_STAR_STAR] = ACTIONS(6905),
    [anon_sym_CARET] = ACTIONS(6905),
    [aux_sym_binary_operator_token1] = ACTIONS(6907),
    [anon_sym_PIPE_GT] = ACTIONS(6907),
    [anon_sym_COLON] = ACTIONS(6909),
    [anon_sym_DOLLAR] = ACTIONS(6911),
    [anon_sym_AT] = ACTIONS(6911),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6913),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6915),
    [sym__external_open_bracket2] = ACTIONS(6917),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [2041] = {
    [sym_identifier] = ACTIONS(7115),
    [anon_sym_BSLASH] = ACTIONS(7117),
    [anon_sym_function] = ACTIONS(7115),
    [anon_sym_EQ] = ACTIONS(7115),
    [anon_sym_if] = ACTIONS(7115),
    [anon_sym_for] = ACTIONS(7115),
    [anon_sym_while] = ACTIONS(7115),
    [anon_sym_repeat] = ACTIONS(7115),
    [anon_sym_QMARK] = ACTIONS(7117),
    [anon_sym_TILDE] = ACTIONS(7117),
    [anon_sym_BANG] = ACTIONS(7115),
    [anon_sym_PLUS] = ACTIONS(7117),
    [anon_sym_DASH] = ACTIONS(7115),
    [anon_sym_LT_DASH] = ACTIONS(7117),
    [anon_sym_LT_LT_DASH] = ACTIONS(7117),
    [anon_sym_COLON_EQ] = ACTIONS(7117),
    [anon_sym_DASH_GT] = ACTIONS(7115),
    [anon_sym_DASH_GT_GT] = ACTIONS(7117),
    [anon_sym_PIPE] = ACTIONS(7115),
    [anon_sym_AMP] = ACTIONS(7115),
    [anon_sym_PIPE_PIPE] = ACTIONS(7117),
    [anon_sym_AMP_AMP] = ACTIONS(7117),
    [anon_sym_LT] = ACTIONS(7115),
    [anon_sym_LT_EQ] = ACTIONS(7117),
    [anon_sym_GT] = ACTIONS(7115),
    [anon_sym_GT_EQ] = ACTIONS(7117),
    [anon_sym_EQ_EQ] = ACTIONS(7117),
    [anon_sym_BANG_EQ] = ACTIONS(7117),
    [anon_sym_STAR] = ACTIONS(7115),
    [anon_sym_SLASH] = ACTIONS(7117),
    [anon_sym_STAR_STAR] = ACTIONS(7117),
    [anon_sym_CARET] = ACTIONS(7117),
    [aux_sym_binary_operator_token1] = ACTIONS(7117),
    [anon_sym_PIPE_GT] = ACTIONS(7117),
    [anon_sym_COLON] = ACTIONS(7115),
    [anon_sym_DOLLAR] = ACTIONS(7117),
    [anon_sym_AT] = ACTIONS(7117),
    [anon_sym_COLON_COLON] = ACTIONS(7115),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7117),
    [aux_sym__hex_literal_token1] = ACTIONS(7117),
    [sym__number_literal] = ACTIONS(7115),
    [anon_sym_SQUOTE] = ACTIONS(7117),
    [anon_sym_DQUOTE] = ACTIONS(7117),
    [sym_return] = ACTIONS(7115),
    [sym_next] = ACTIONS(7115),
    [sym_break] = ACTIONS(7115),
    [sym_true] = ACTIONS(7115),
    [sym_false] = ACTIONS(7115),
    [sym_null] = ACTIONS(7115),
    [sym_inf] = ACTIONS(7115),
    [sym_nan] = ACTIONS(7115),
    [anon_sym_NA] = ACTIONS(7115),
    [anon_sym_NA_integer_] = ACTIONS(7115),
    [anon_sym_NA_real_] = ACTIONS(7115),
    [anon_sym_NA_complex_] = ACTIONS(7115),
    [anon_sym_NA_character_] = ACTIONS(7115),
    [sym_dots] = ACTIONS(7115),
    [sym_dot_dot_i] = ACTIONS(7117),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7117),
    [sym__newline] = ACTIONS(7117),
    [sym__semicolon] = ACTIONS(7117),
    [sym__raw_string_literal] = ACTIONS(7117),
    [sym__external_else] = ACTIONS(7117),
    [sym__external_open_parenthesis] = ACTIONS(7117),
    [sym__external_close_parenthesis] = ACTIONS(7117),
    [sym__external_open_brace] = ACTIONS(7117),
    [sym__external_close_brace] = ACTIONS(7117),
    [sym__external_open_bracket] = ACTIONS(7117),
    [sym__external_close_bracket] = ACTIONS(7117),
    [sym__external_open_bracket2] = ACTIONS(7117),
  },
  [2042] = {
    [sym_call_arguments] = STATE(3027),
    [sym_subset_arguments] = STATE(3026),
    [sym_subset2_arguments] = STATE(3025),
    [sym__open_parenthesis] = STATE(1616),
    [sym__open_bracket] = STATE(1615),
    [sym__open_bracket2] = STATE(1613),
    [sym_identifier] = ACTIONS(5431),
    [anon_sym_BSLASH] = ACTIONS(5429),
    [anon_sym_function] = ACTIONS(5431),
    [anon_sym_EQ] = ACTIONS(7035),
    [anon_sym_if] = ACTIONS(5431),
    [anon_sym_for] = ACTIONS(5431),
    [anon_sym_while] = ACTIONS(5431),
    [anon_sym_repeat] = ACTIONS(5431),
    [anon_sym_QMARK] = ACTIONS(5429),
    [anon_sym_TILDE] = ACTIONS(7037),
    [anon_sym_BANG] = ACTIONS(5431),
    [anon_sym_PLUS] = ACTIONS(7039),
    [anon_sym_DASH] = ACTIONS(7041),
    [anon_sym_LT_DASH] = ACTIONS(7043),
    [anon_sym_LT_LT_DASH] = ACTIONS(7043),
    [anon_sym_COLON_EQ] = ACTIONS(7043),
    [anon_sym_DASH_GT] = ACTIONS(7045),
    [anon_sym_DASH_GT_GT] = ACTIONS(7047),
    [anon_sym_PIPE] = ACTIONS(7049),
    [anon_sym_AMP] = ACTIONS(7051),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_AMP_AMP] = ACTIONS(7055),
    [anon_sym_LT] = ACTIONS(7057),
    [anon_sym_LT_EQ] = ACTIONS(7059),
    [anon_sym_GT] = ACTIONS(7057),
    [anon_sym_GT_EQ] = ACTIONS(7059),
    [anon_sym_EQ_EQ] = ACTIONS(7059),
    [anon_sym_BANG_EQ] = ACTIONS(7059),
    [anon_sym_STAR] = ACTIONS(7061),
    [anon_sym_SLASH] = ACTIONS(7063),
    [anon_sym_STAR_STAR] = ACTIONS(7065),
    [anon_sym_CARET] = ACTIONS(7065),
    [aux_sym_binary_operator_token1] = ACTIONS(7067),
    [anon_sym_PIPE_GT] = ACTIONS(7067),
    [anon_sym_COLON] = ACTIONS(7069),
    [anon_sym_DOLLAR] = ACTIONS(7071),
    [anon_sym_AT] = ACTIONS(7071),
    [aux_sym__hex_literal_token1] = ACTIONS(5429),
    [sym__number_literal] = ACTIONS(5431),
    [anon_sym_SQUOTE] = ACTIONS(5429),
    [anon_sym_DQUOTE] = ACTIONS(5429),
    [sym_return] = ACTIONS(5431),
    [sym_next] = ACTIONS(5431),
    [sym_break] = ACTIONS(5431),
    [sym_true] = ACTIONS(5431),
    [sym_false] = ACTIONS(5431),
    [sym_null] = ACTIONS(5431),
    [sym_inf] = ACTIONS(5431),
    [sym_nan] = ACTIONS(5431),
    [anon_sym_NA] = ACTIONS(5431),
    [anon_sym_NA_integer_] = ACTIONS(5431),
    [anon_sym_NA_real_] = ACTIONS(5431),
    [anon_sym_NA_complex_] = ACTIONS(5431),
    [anon_sym_NA_character_] = ACTIONS(5431),
    [sym_dots] = ACTIONS(5431),
    [sym_dot_dot_i] = ACTIONS(5429),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5429),
    [sym__newline] = ACTIONS(5429),
    [sym__raw_string_literal] = ACTIONS(5429),
    [sym__external_open_parenthesis] = ACTIONS(7073),
    [sym__external_open_brace] = ACTIONS(5429),
    [sym__external_open_bracket] = ACTIONS(7075),
    [sym__external_close_bracket] = ACTIONS(5429),
    [sym__external_open_bracket2] = ACTIONS(7077),
  },
  [2043] = {
    [sym_call_arguments] = STATE(2985),
    [sym_subset_arguments] = STATE(2986),
    [sym_subset2_arguments] = STATE(2987),
    [sym__open_parenthesis] = STATE(1414),
    [sym__open_bracket] = STATE(1416),
    [sym__open_bracket2] = STATE(1428),
    [ts_builtin_sym_end] = ACTIONS(5421),
    [sym_identifier] = ACTIONS(5423),
    [anon_sym_BSLASH] = ACTIONS(5421),
    [anon_sym_function] = ACTIONS(5423),
    [anon_sym_EQ] = ACTIONS(7155),
    [anon_sym_if] = ACTIONS(5423),
    [anon_sym_for] = ACTIONS(5423),
    [anon_sym_while] = ACTIONS(5423),
    [anon_sym_repeat] = ACTIONS(5423),
    [anon_sym_QMARK] = ACTIONS(5421),
    [anon_sym_TILDE] = ACTIONS(7079),
    [anon_sym_BANG] = ACTIONS(5423),
    [anon_sym_PLUS] = ACTIONS(7081),
    [anon_sym_DASH] = ACTIONS(7083),
    [anon_sym_LT_DASH] = ACTIONS(7157),
    [anon_sym_LT_LT_DASH] = ACTIONS(7157),
    [anon_sym_COLON_EQ] = ACTIONS(7157),
    [anon_sym_DASH_GT] = ACTIONS(7159),
    [anon_sym_DASH_GT_GT] = ACTIONS(7161),
    [anon_sym_PIPE] = ACTIONS(7085),
    [anon_sym_AMP] = ACTIONS(7087),
    [anon_sym_PIPE_PIPE] = ACTIONS(7089),
    [anon_sym_AMP_AMP] = ACTIONS(7091),
    [anon_sym_LT] = ACTIONS(7093),
    [anon_sym_LT_EQ] = ACTIONS(7095),
    [anon_sym_GT] = ACTIONS(7093),
    [anon_sym_GT_EQ] = ACTIONS(7095),
    [anon_sym_EQ_EQ] = ACTIONS(7095),
    [anon_sym_BANG_EQ] = ACTIONS(7095),
    [anon_sym_STAR] = ACTIONS(7097),
    [anon_sym_SLASH] = ACTIONS(7099),
    [anon_sym_STAR_STAR] = ACTIONS(7101),
    [anon_sym_CARET] = ACTIONS(7101),
    [aux_sym_binary_operator_token1] = ACTIONS(7103),
    [anon_sym_PIPE_GT] = ACTIONS(7103),
    [anon_sym_COLON] = ACTIONS(7105),
    [anon_sym_DOLLAR] = ACTIONS(7107),
    [anon_sym_AT] = ACTIONS(7107),
    [aux_sym__hex_literal_token1] = ACTIONS(5421),
    [sym__number_literal] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5421),
    [anon_sym_DQUOTE] = ACTIONS(5421),
    [sym_return] = ACTIONS(5423),
    [sym_next] = ACTIONS(5423),
    [sym_break] = ACTIONS(5423),
    [sym_true] = ACTIONS(5423),
    [sym_false] = ACTIONS(5423),
    [sym_null] = ACTIONS(5423),
    [sym_inf] = ACTIONS(5423),
    [sym_nan] = ACTIONS(5423),
    [anon_sym_NA] = ACTIONS(5423),
    [anon_sym_NA_integer_] = ACTIONS(5423),
    [anon_sym_NA_real_] = ACTIONS(5423),
    [anon_sym_NA_complex_] = ACTIONS(5423),
    [anon_sym_NA_character_] = ACTIONS(5423),
    [sym_dots] = ACTIONS(5423),
    [sym_dot_dot_i] = ACTIONS(5421),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5421),
    [sym__semicolon] = ACTIONS(5421),
    [sym__raw_string_literal] = ACTIONS(5421),
    [sym__external_open_parenthesis] = ACTIONS(7109),
    [sym__external_open_brace] = ACTIONS(5421),
    [sym__external_open_bracket] = ACTIONS(7111),
    [sym__external_open_bracket2] = ACTIONS(7113),
  },
  [2044] = {
    [sym_call_arguments] = STATE(2978),
    [sym_subset_arguments] = STATE(2977),
    [sym_subset2_arguments] = STATE(2976),
    [sym__open_parenthesis] = STATE(1606),
    [sym__open_bracket] = STATE(1598),
    [sym__open_bracket2] = STATE(1592),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(6905),
    [anon_sym_CARET] = ACTIONS(6905),
    [aux_sym_binary_operator_token1] = ACTIONS(6907),
    [anon_sym_PIPE_GT] = ACTIONS(6907),
    [anon_sym_COLON] = ACTIONS(6909),
    [anon_sym_DOLLAR] = ACTIONS(6911),
    [anon_sym_AT] = ACTIONS(6911),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6913),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6915),
    [sym__external_open_bracket2] = ACTIONS(6917),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [2045] = {
    [sym_call_arguments] = STATE(2978),
    [sym_subset_arguments] = STATE(2977),
    [sym_subset2_arguments] = STATE(2976),
    [sym__open_parenthesis] = STATE(1606),
    [sym__open_bracket] = STATE(1598),
    [sym__open_bracket2] = STATE(1592),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(6905),
    [anon_sym_CARET] = ACTIONS(6905),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(5261),
    [anon_sym_DOLLAR] = ACTIONS(6911),
    [anon_sym_AT] = ACTIONS(6911),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6913),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6915),
    [sym__external_open_bracket2] = ACTIONS(6917),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [2046] = {
    [sym_call_arguments] = STATE(2978),
    [sym_subset_arguments] = STATE(2977),
    [sym_subset2_arguments] = STATE(2976),
    [sym__open_parenthesis] = STATE(1606),
    [sym__open_bracket] = STATE(1598),
    [sym__open_bracket2] = STATE(1592),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(6905),
    [anon_sym_CARET] = ACTIONS(6905),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(6909),
    [anon_sym_DOLLAR] = ACTIONS(6911),
    [anon_sym_AT] = ACTIONS(6911),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6913),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6915),
    [sym__external_open_bracket2] = ACTIONS(6917),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [2047] = {
    [sym_call_arguments] = STATE(2978),
    [sym_subset_arguments] = STATE(2977),
    [sym_subset2_arguments] = STATE(2976),
    [sym__open_parenthesis] = STATE(1606),
    [sym__open_bracket] = STATE(1598),
    [sym__open_bracket2] = STATE(1592),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(6879),
    [anon_sym_DASH] = ACTIONS(6881),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(6891),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(6895),
    [anon_sym_LT] = ACTIONS(6897),
    [anon_sym_LT_EQ] = ACTIONS(6899),
    [anon_sym_GT] = ACTIONS(6897),
    [anon_sym_GT_EQ] = ACTIONS(6899),
    [anon_sym_EQ_EQ] = ACTIONS(6899),
    [anon_sym_BANG_EQ] = ACTIONS(6899),
    [anon_sym_STAR] = ACTIONS(6901),
    [anon_sym_SLASH] = ACTIONS(6903),
    [anon_sym_STAR_STAR] = ACTIONS(6905),
    [anon_sym_CARET] = ACTIONS(6905),
    [aux_sym_binary_operator_token1] = ACTIONS(6907),
    [anon_sym_PIPE_GT] = ACTIONS(6907),
    [anon_sym_COLON] = ACTIONS(6909),
    [anon_sym_DOLLAR] = ACTIONS(6911),
    [anon_sym_AT] = ACTIONS(6911),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6913),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6915),
    [sym__external_open_bracket2] = ACTIONS(6917),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [2048] = {
    [sym_string] = STATE(2768),
    [sym__single_quoted_string] = STATE(2370),
    [sym__double_quoted_string] = STATE(2369),
    [sym__string_or_identifier] = STATE(2768),
    [aux_sym_function_definition_repeat1] = STATE(2056),
    [sym_identifier] = ACTIONS(7275),
    [anon_sym_BSLASH] = ACTIONS(5659),
    [anon_sym_function] = ACTIONS(5663),
    [anon_sym_EQ] = ACTIONS(5663),
    [anon_sym_if] = ACTIONS(5663),
    [anon_sym_for] = ACTIONS(5663),
    [anon_sym_while] = ACTIONS(5663),
    [anon_sym_repeat] = ACTIONS(5663),
    [anon_sym_QMARK] = ACTIONS(5659),
    [anon_sym_TILDE] = ACTIONS(5659),
    [anon_sym_BANG] = ACTIONS(5663),
    [anon_sym_PLUS] = ACTIONS(5659),
    [anon_sym_DASH] = ACTIONS(5663),
    [anon_sym_LT_DASH] = ACTIONS(5659),
    [anon_sym_LT_LT_DASH] = ACTIONS(5659),
    [anon_sym_COLON_EQ] = ACTIONS(5659),
    [anon_sym_DASH_GT] = ACTIONS(5663),
    [anon_sym_DASH_GT_GT] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(5663),
    [anon_sym_AMP] = ACTIONS(5663),
    [anon_sym_PIPE_PIPE] = ACTIONS(5659),
    [anon_sym_AMP_AMP] = ACTIONS(5659),
    [anon_sym_LT] = ACTIONS(5663),
    [anon_sym_LT_EQ] = ACTIONS(5659),
    [anon_sym_GT] = ACTIONS(5663),
    [anon_sym_GT_EQ] = ACTIONS(5659),
    [anon_sym_EQ_EQ] = ACTIONS(5659),
    [anon_sym_BANG_EQ] = ACTIONS(5659),
    [anon_sym_STAR] = ACTIONS(5663),
    [anon_sym_SLASH] = ACTIONS(5659),
    [anon_sym_STAR_STAR] = ACTIONS(5659),
    [anon_sym_CARET] = ACTIONS(5659),
    [aux_sym_binary_operator_token1] = ACTIONS(5659),
    [anon_sym_PIPE_GT] = ACTIONS(5659),
    [anon_sym_COLON] = ACTIONS(5663),
    [anon_sym_DOLLAR] = ACTIONS(5659),
    [anon_sym_AT] = ACTIONS(5659),
    [aux_sym__hex_literal_token1] = ACTIONS(5659),
    [sym__number_literal] = ACTIONS(5663),
    [anon_sym_SQUOTE] = ACTIONS(2453),
    [anon_sym_DQUOTE] = ACTIONS(2455),
    [sym_return] = ACTIONS(5663),
    [sym_next] = ACTIONS(5663),
    [sym_break] = ACTIONS(5663),
    [sym_true] = ACTIONS(5663),
    [sym_false] = ACTIONS(5663),
    [sym_null] = ACTIONS(5663),
    [sym_inf] = ACTIONS(5663),
    [sym_nan] = ACTIONS(5663),
    [anon_sym_NA] = ACTIONS(5663),
    [anon_sym_NA_integer_] = ACTIONS(5663),
    [anon_sym_NA_real_] = ACTIONS(5663),
    [anon_sym_NA_complex_] = ACTIONS(5663),
    [anon_sym_NA_character_] = ACTIONS(5663),
    [sym_dots] = ACTIONS(5663),
    [sym_dot_dot_i] = ACTIONS(5659),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5659),
    [sym__newline] = ACTIONS(7277),
    [sym__raw_string_literal] = ACTIONS(2465),
    [sym__external_else] = ACTIONS(5659),
    [sym__external_open_parenthesis] = ACTIONS(5659),
    [sym__external_close_parenthesis] = ACTIONS(5659),
    [sym__external_open_brace] = ACTIONS(5659),
    [sym__external_open_bracket] = ACTIONS(5659),
    [sym__external_open_bracket2] = ACTIONS(5659),
  },
  [2049] = {
    [sym_call_arguments] = STATE(2941),
    [sym_subset_arguments] = STATE(2942),
    [sym_subset2_arguments] = STATE(2943),
    [sym__open_parenthesis] = STATE(1755),
    [sym__open_bracket] = STATE(1763),
    [sym__open_bracket2] = STATE(1866),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(6923),
    [anon_sym_DASH] = ACTIONS(6925),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(6943),
    [anon_sym_SLASH] = ACTIONS(6945),
    [anon_sym_STAR_STAR] = ACTIONS(6947),
    [anon_sym_CARET] = ACTIONS(6947),
    [aux_sym_binary_operator_token1] = ACTIONS(6949),
    [anon_sym_PIPE_GT] = ACTIONS(6949),
    [anon_sym_COLON] = ACTIONS(6951),
    [anon_sym_DOLLAR] = ACTIONS(6953),
    [anon_sym_AT] = ACTIONS(6953),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6955),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6957),
    [sym__external_open_bracket2] = ACTIONS(6959),
  },
  [2050] = {
    [sym_call_arguments] = STATE(2985),
    [sym_subset_arguments] = STATE(2986),
    [sym_subset2_arguments] = STATE(2987),
    [sym__open_parenthesis] = STATE(1414),
    [sym__open_bracket] = STATE(1416),
    [sym__open_bracket2] = STATE(1428),
    [ts_builtin_sym_end] = ACTIONS(5417),
    [sym_identifier] = ACTIONS(5419),
    [anon_sym_BSLASH] = ACTIONS(5417),
    [anon_sym_function] = ACTIONS(5419),
    [anon_sym_EQ] = ACTIONS(7155),
    [anon_sym_if] = ACTIONS(5419),
    [anon_sym_for] = ACTIONS(5419),
    [anon_sym_while] = ACTIONS(5419),
    [anon_sym_repeat] = ACTIONS(5419),
    [anon_sym_QMARK] = ACTIONS(5417),
    [anon_sym_TILDE] = ACTIONS(7079),
    [anon_sym_BANG] = ACTIONS(5419),
    [anon_sym_PLUS] = ACTIONS(7081),
    [anon_sym_DASH] = ACTIONS(7083),
    [anon_sym_LT_DASH] = ACTIONS(7157),
    [anon_sym_LT_LT_DASH] = ACTIONS(7157),
    [anon_sym_COLON_EQ] = ACTIONS(7157),
    [anon_sym_DASH_GT] = ACTIONS(7159),
    [anon_sym_DASH_GT_GT] = ACTIONS(7161),
    [anon_sym_PIPE] = ACTIONS(7085),
    [anon_sym_AMP] = ACTIONS(7087),
    [anon_sym_PIPE_PIPE] = ACTIONS(7089),
    [anon_sym_AMP_AMP] = ACTIONS(7091),
    [anon_sym_LT] = ACTIONS(7093),
    [anon_sym_LT_EQ] = ACTIONS(7095),
    [anon_sym_GT] = ACTIONS(7093),
    [anon_sym_GT_EQ] = ACTIONS(7095),
    [anon_sym_EQ_EQ] = ACTIONS(7095),
    [anon_sym_BANG_EQ] = ACTIONS(7095),
    [anon_sym_STAR] = ACTIONS(7097),
    [anon_sym_SLASH] = ACTIONS(7099),
    [anon_sym_STAR_STAR] = ACTIONS(7101),
    [anon_sym_CARET] = ACTIONS(7101),
    [aux_sym_binary_operator_token1] = ACTIONS(7103),
    [anon_sym_PIPE_GT] = ACTIONS(7103),
    [anon_sym_COLON] = ACTIONS(7105),
    [anon_sym_DOLLAR] = ACTIONS(7107),
    [anon_sym_AT] = ACTIONS(7107),
    [aux_sym__hex_literal_token1] = ACTIONS(5417),
    [sym__number_literal] = ACTIONS(5419),
    [anon_sym_SQUOTE] = ACTIONS(5417),
    [anon_sym_DQUOTE] = ACTIONS(5417),
    [sym_return] = ACTIONS(5419),
    [sym_next] = ACTIONS(5419),
    [sym_break] = ACTIONS(5419),
    [sym_true] = ACTIONS(5419),
    [sym_false] = ACTIONS(5419),
    [sym_null] = ACTIONS(5419),
    [sym_inf] = ACTIONS(5419),
    [sym_nan] = ACTIONS(5419),
    [anon_sym_NA] = ACTIONS(5419),
    [anon_sym_NA_integer_] = ACTIONS(5419),
    [anon_sym_NA_real_] = ACTIONS(5419),
    [anon_sym_NA_complex_] = ACTIONS(5419),
    [anon_sym_NA_character_] = ACTIONS(5419),
    [sym_dots] = ACTIONS(5419),
    [sym_dot_dot_i] = ACTIONS(5417),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5417),
    [sym__semicolon] = ACTIONS(5417),
    [sym__raw_string_literal] = ACTIONS(5417),
    [sym__external_open_parenthesis] = ACTIONS(7109),
    [sym__external_open_brace] = ACTIONS(5417),
    [sym__external_open_bracket] = ACTIONS(7111),
    [sym__external_open_bracket2] = ACTIONS(7113),
  },
  [2051] = {
    [sym_call_arguments] = STATE(3027),
    [sym_subset_arguments] = STATE(3026),
    [sym_subset2_arguments] = STATE(3025),
    [sym__open_parenthesis] = STATE(1616),
    [sym__open_bracket] = STATE(1615),
    [sym__open_bracket2] = STATE(1613),
    [sym_identifier] = ACTIONS(5427),
    [anon_sym_BSLASH] = ACTIONS(5425),
    [anon_sym_function] = ACTIONS(5427),
    [anon_sym_EQ] = ACTIONS(7035),
    [anon_sym_if] = ACTIONS(5427),
    [anon_sym_for] = ACTIONS(5427),
    [anon_sym_while] = ACTIONS(5427),
    [anon_sym_repeat] = ACTIONS(5427),
    [anon_sym_QMARK] = ACTIONS(5425),
    [anon_sym_TILDE] = ACTIONS(7037),
    [anon_sym_BANG] = ACTIONS(5427),
    [anon_sym_PLUS] = ACTIONS(7039),
    [anon_sym_DASH] = ACTIONS(7041),
    [anon_sym_LT_DASH] = ACTIONS(7043),
    [anon_sym_LT_LT_DASH] = ACTIONS(7043),
    [anon_sym_COLON_EQ] = ACTIONS(7043),
    [anon_sym_DASH_GT] = ACTIONS(7045),
    [anon_sym_DASH_GT_GT] = ACTIONS(7047),
    [anon_sym_PIPE] = ACTIONS(7049),
    [anon_sym_AMP] = ACTIONS(7051),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_AMP_AMP] = ACTIONS(7055),
    [anon_sym_LT] = ACTIONS(7057),
    [anon_sym_LT_EQ] = ACTIONS(7059),
    [anon_sym_GT] = ACTIONS(7057),
    [anon_sym_GT_EQ] = ACTIONS(7059),
    [anon_sym_EQ_EQ] = ACTIONS(7059),
    [anon_sym_BANG_EQ] = ACTIONS(7059),
    [anon_sym_STAR] = ACTIONS(7061),
    [anon_sym_SLASH] = ACTIONS(7063),
    [anon_sym_STAR_STAR] = ACTIONS(7065),
    [anon_sym_CARET] = ACTIONS(7065),
    [aux_sym_binary_operator_token1] = ACTIONS(7067),
    [anon_sym_PIPE_GT] = ACTIONS(7067),
    [anon_sym_COLON] = ACTIONS(7069),
    [anon_sym_DOLLAR] = ACTIONS(7071),
    [anon_sym_AT] = ACTIONS(7071),
    [aux_sym__hex_literal_token1] = ACTIONS(5425),
    [sym__number_literal] = ACTIONS(5427),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_DQUOTE] = ACTIONS(5425),
    [sym_return] = ACTIONS(5427),
    [sym_next] = ACTIONS(5427),
    [sym_break] = ACTIONS(5427),
    [sym_true] = ACTIONS(5427),
    [sym_false] = ACTIONS(5427),
    [sym_null] = ACTIONS(5427),
    [sym_inf] = ACTIONS(5427),
    [sym_nan] = ACTIONS(5427),
    [anon_sym_NA] = ACTIONS(5427),
    [anon_sym_NA_integer_] = ACTIONS(5427),
    [anon_sym_NA_real_] = ACTIONS(5427),
    [anon_sym_NA_complex_] = ACTIONS(5427),
    [anon_sym_NA_character_] = ACTIONS(5427),
    [sym_dots] = ACTIONS(5427),
    [sym_dot_dot_i] = ACTIONS(5425),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5425),
    [sym__newline] = ACTIONS(5425),
    [sym__raw_string_literal] = ACTIONS(5425),
    [sym__external_open_parenthesis] = ACTIONS(7073),
    [sym__external_open_brace] = ACTIONS(5425),
    [sym__external_open_bracket] = ACTIONS(7075),
    [sym__external_close_bracket] = ACTIONS(5425),
    [sym__external_open_bracket2] = ACTIONS(7077),
  },
  [2052] = {
    [sym_call_arguments] = STATE(2941),
    [sym_subset_arguments] = STATE(2942),
    [sym_subset2_arguments] = STATE(2943),
    [sym__open_parenthesis] = STATE(1755),
    [sym__open_bracket] = STATE(1763),
    [sym__open_bracket2] = STATE(1866),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(6919),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(6921),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(6923),
    [anon_sym_DASH] = ACTIONS(6925),
    [anon_sym_LT_DASH] = ACTIONS(7147),
    [anon_sym_LT_LT_DASH] = ACTIONS(7147),
    [anon_sym_COLON_EQ] = ACTIONS(7147),
    [anon_sym_DASH_GT] = ACTIONS(6927),
    [anon_sym_DASH_GT_GT] = ACTIONS(6929),
    [anon_sym_PIPE] = ACTIONS(6931),
    [anon_sym_AMP] = ACTIONS(6933),
    [anon_sym_PIPE_PIPE] = ACTIONS(6935),
    [anon_sym_AMP_AMP] = ACTIONS(6937),
    [anon_sym_LT] = ACTIONS(6939),
    [anon_sym_LT_EQ] = ACTIONS(6941),
    [anon_sym_GT] = ACTIONS(6939),
    [anon_sym_GT_EQ] = ACTIONS(6941),
    [anon_sym_EQ_EQ] = ACTIONS(6941),
    [anon_sym_BANG_EQ] = ACTIONS(6941),
    [anon_sym_STAR] = ACTIONS(6943),
    [anon_sym_SLASH] = ACTIONS(6945),
    [anon_sym_STAR_STAR] = ACTIONS(6947),
    [anon_sym_CARET] = ACTIONS(6947),
    [aux_sym_binary_operator_token1] = ACTIONS(6949),
    [anon_sym_PIPE_GT] = ACTIONS(6949),
    [anon_sym_COLON] = ACTIONS(6951),
    [anon_sym_DOLLAR] = ACTIONS(6953),
    [anon_sym_AT] = ACTIONS(6953),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6955),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6957),
    [sym__external_open_bracket2] = ACTIONS(6959),
  },
  [2053] = {
    [sym_call_arguments] = STATE(3027),
    [sym_subset_arguments] = STATE(3026),
    [sym_subset2_arguments] = STATE(3025),
    [sym__open_parenthesis] = STATE(1616),
    [sym__open_bracket] = STATE(1615),
    [sym__open_bracket2] = STATE(1613),
    [sym_identifier] = ACTIONS(5423),
    [anon_sym_BSLASH] = ACTIONS(5421),
    [anon_sym_function] = ACTIONS(5423),
    [anon_sym_EQ] = ACTIONS(7035),
    [anon_sym_if] = ACTIONS(5423),
    [anon_sym_for] = ACTIONS(5423),
    [anon_sym_while] = ACTIONS(5423),
    [anon_sym_repeat] = ACTIONS(5423),
    [anon_sym_QMARK] = ACTIONS(5421),
    [anon_sym_TILDE] = ACTIONS(7037),
    [anon_sym_BANG] = ACTIONS(5423),
    [anon_sym_PLUS] = ACTIONS(7039),
    [anon_sym_DASH] = ACTIONS(7041),
    [anon_sym_LT_DASH] = ACTIONS(7043),
    [anon_sym_LT_LT_DASH] = ACTIONS(7043),
    [anon_sym_COLON_EQ] = ACTIONS(7043),
    [anon_sym_DASH_GT] = ACTIONS(7045),
    [anon_sym_DASH_GT_GT] = ACTIONS(7047),
    [anon_sym_PIPE] = ACTIONS(7049),
    [anon_sym_AMP] = ACTIONS(7051),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_AMP_AMP] = ACTIONS(7055),
    [anon_sym_LT] = ACTIONS(7057),
    [anon_sym_LT_EQ] = ACTIONS(7059),
    [anon_sym_GT] = ACTIONS(7057),
    [anon_sym_GT_EQ] = ACTIONS(7059),
    [anon_sym_EQ_EQ] = ACTIONS(7059),
    [anon_sym_BANG_EQ] = ACTIONS(7059),
    [anon_sym_STAR] = ACTIONS(7061),
    [anon_sym_SLASH] = ACTIONS(7063),
    [anon_sym_STAR_STAR] = ACTIONS(7065),
    [anon_sym_CARET] = ACTIONS(7065),
    [aux_sym_binary_operator_token1] = ACTIONS(7067),
    [anon_sym_PIPE_GT] = ACTIONS(7067),
    [anon_sym_COLON] = ACTIONS(7069),
    [anon_sym_DOLLAR] = ACTIONS(7071),
    [anon_sym_AT] = ACTIONS(7071),
    [aux_sym__hex_literal_token1] = ACTIONS(5421),
    [sym__number_literal] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5421),
    [anon_sym_DQUOTE] = ACTIONS(5421),
    [sym_return] = ACTIONS(5423),
    [sym_next] = ACTIONS(5423),
    [sym_break] = ACTIONS(5423),
    [sym_true] = ACTIONS(5423),
    [sym_false] = ACTIONS(5423),
    [sym_null] = ACTIONS(5423),
    [sym_inf] = ACTIONS(5423),
    [sym_nan] = ACTIONS(5423),
    [anon_sym_NA] = ACTIONS(5423),
    [anon_sym_NA_integer_] = ACTIONS(5423),
    [anon_sym_NA_real_] = ACTIONS(5423),
    [anon_sym_NA_complex_] = ACTIONS(5423),
    [anon_sym_NA_character_] = ACTIONS(5423),
    [sym_dots] = ACTIONS(5423),
    [sym_dot_dot_i] = ACTIONS(5421),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5421),
    [sym__newline] = ACTIONS(5421),
    [sym__raw_string_literal] = ACTIONS(5421),
    [sym__external_open_parenthesis] = ACTIONS(7073),
    [sym__external_open_brace] = ACTIONS(5421),
    [sym__external_open_bracket] = ACTIONS(7075),
    [sym__external_close_bracket] = ACTIONS(5421),
    [sym__external_open_bracket2] = ACTIONS(7077),
  },
  [2054] = {
    [sym_call_arguments] = STATE(2941),
    [sym_subset_arguments] = STATE(2942),
    [sym_subset2_arguments] = STATE(2943),
    [sym__open_parenthesis] = STATE(1755),
    [sym__open_bracket] = STATE(1763),
    [sym__open_bracket2] = STATE(1866),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(6919),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(6921),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(6923),
    [anon_sym_DASH] = ACTIONS(6925),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(6927),
    [anon_sym_DASH_GT_GT] = ACTIONS(6929),
    [anon_sym_PIPE] = ACTIONS(6931),
    [anon_sym_AMP] = ACTIONS(6933),
    [anon_sym_PIPE_PIPE] = ACTIONS(6935),
    [anon_sym_AMP_AMP] = ACTIONS(6937),
    [anon_sym_LT] = ACTIONS(6939),
    [anon_sym_LT_EQ] = ACTIONS(6941),
    [anon_sym_GT] = ACTIONS(6939),
    [anon_sym_GT_EQ] = ACTIONS(6941),
    [anon_sym_EQ_EQ] = ACTIONS(6941),
    [anon_sym_BANG_EQ] = ACTIONS(6941),
    [anon_sym_STAR] = ACTIONS(6943),
    [anon_sym_SLASH] = ACTIONS(6945),
    [anon_sym_STAR_STAR] = ACTIONS(6947),
    [anon_sym_CARET] = ACTIONS(6947),
    [aux_sym_binary_operator_token1] = ACTIONS(6949),
    [anon_sym_PIPE_GT] = ACTIONS(6949),
    [anon_sym_COLON] = ACTIONS(6951),
    [anon_sym_DOLLAR] = ACTIONS(6953),
    [anon_sym_AT] = ACTIONS(6953),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6955),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6957),
    [sym__external_open_bracket2] = ACTIONS(6959),
  },
  [2055] = {
    [sym_call_arguments] = STATE(2941),
    [sym_subset_arguments] = STATE(2942),
    [sym_subset2_arguments] = STATE(2943),
    [sym__open_parenthesis] = STATE(1755),
    [sym__open_bracket] = STATE(1763),
    [sym__open_bracket2] = STATE(1866),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(6919),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(6921),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(6923),
    [anon_sym_DASH] = ACTIONS(6925),
    [anon_sym_LT_DASH] = ACTIONS(7147),
    [anon_sym_LT_LT_DASH] = ACTIONS(7147),
    [anon_sym_COLON_EQ] = ACTIONS(7147),
    [anon_sym_DASH_GT] = ACTIONS(6927),
    [anon_sym_DASH_GT_GT] = ACTIONS(6929),
    [anon_sym_PIPE] = ACTIONS(6931),
    [anon_sym_AMP] = ACTIONS(6933),
    [anon_sym_PIPE_PIPE] = ACTIONS(6935),
    [anon_sym_AMP_AMP] = ACTIONS(6937),
    [anon_sym_LT] = ACTIONS(6939),
    [anon_sym_LT_EQ] = ACTIONS(6941),
    [anon_sym_GT] = ACTIONS(6939),
    [anon_sym_GT_EQ] = ACTIONS(6941),
    [anon_sym_EQ_EQ] = ACTIONS(6941),
    [anon_sym_BANG_EQ] = ACTIONS(6941),
    [anon_sym_STAR] = ACTIONS(6943),
    [anon_sym_SLASH] = ACTIONS(6945),
    [anon_sym_STAR_STAR] = ACTIONS(6947),
    [anon_sym_CARET] = ACTIONS(6947),
    [aux_sym_binary_operator_token1] = ACTIONS(6949),
    [anon_sym_PIPE_GT] = ACTIONS(6949),
    [anon_sym_COLON] = ACTIONS(6951),
    [anon_sym_DOLLAR] = ACTIONS(6953),
    [anon_sym_AT] = ACTIONS(6953),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(6955),
    [sym__external_close_parenthesis] = ACTIONS(5345),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(6957),
    [sym__external_open_bracket2] = ACTIONS(6959),
  },
  [2056] = {
    [sym_string] = STATE(2814),
    [sym__single_quoted_string] = STATE(2370),
    [sym__double_quoted_string] = STATE(2369),
    [sym__string_or_identifier] = STATE(2814),
    [aux_sym_function_definition_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(7279),
    [anon_sym_BSLASH] = ACTIONS(5669),
    [anon_sym_function] = ACTIONS(5673),
    [anon_sym_EQ] = ACTIONS(5673),
    [anon_sym_if] = ACTIONS(5673),
    [anon_sym_for] = ACTIONS(5673),
    [anon_sym_while] = ACTIONS(5673),
    [anon_sym_repeat] = ACTIONS(5673),
    [anon_sym_QMARK] = ACTIONS(5669),
    [anon_sym_TILDE] = ACTIONS(5669),
    [anon_sym_BANG] = ACTIONS(5673),
    [anon_sym_PLUS] = ACTIONS(5669),
    [anon_sym_DASH] = ACTIONS(5673),
    [anon_sym_LT_DASH] = ACTIONS(5669),
    [anon_sym_LT_LT_DASH] = ACTIONS(5669),
    [anon_sym_COLON_EQ] = ACTIONS(5669),
    [anon_sym_DASH_GT] = ACTIONS(5673),
    [anon_sym_DASH_GT_GT] = ACTIONS(5669),
    [anon_sym_PIPE] = ACTIONS(5673),
    [anon_sym_AMP] = ACTIONS(5673),
    [anon_sym_PIPE_PIPE] = ACTIONS(5669),
    [anon_sym_AMP_AMP] = ACTIONS(5669),
    [anon_sym_LT] = ACTIONS(5673),
    [anon_sym_LT_EQ] = ACTIONS(5669),
    [anon_sym_GT] = ACTIONS(5673),
    [anon_sym_GT_EQ] = ACTIONS(5669),
    [anon_sym_EQ_EQ] = ACTIONS(5669),
    [anon_sym_BANG_EQ] = ACTIONS(5669),
    [anon_sym_STAR] = ACTIONS(5673),
    [anon_sym_SLASH] = ACTIONS(5669),
    [anon_sym_STAR_STAR] = ACTIONS(5669),
    [anon_sym_CARET] = ACTIONS(5669),
    [aux_sym_binary_operator_token1] = ACTIONS(5669),
    [anon_sym_PIPE_GT] = ACTIONS(5669),
    [anon_sym_COLON] = ACTIONS(5673),
    [anon_sym_DOLLAR] = ACTIONS(5669),
    [anon_sym_AT] = ACTIONS(5669),
    [aux_sym__hex_literal_token1] = ACTIONS(5669),
    [sym__number_literal] = ACTIONS(5673),
    [anon_sym_SQUOTE] = ACTIONS(2453),
    [anon_sym_DQUOTE] = ACTIONS(2455),
    [sym_return] = ACTIONS(5673),
    [sym_next] = ACTIONS(5673),
    [sym_break] = ACTIONS(5673),
    [sym_true] = ACTIONS(5673),
    [sym_false] = ACTIONS(5673),
    [sym_null] = ACTIONS(5673),
    [sym_inf] = ACTIONS(5673),
    [sym_nan] = ACTIONS(5673),
    [anon_sym_NA] = ACTIONS(5673),
    [anon_sym_NA_integer_] = ACTIONS(5673),
    [anon_sym_NA_real_] = ACTIONS(5673),
    [anon_sym_NA_complex_] = ACTIONS(5673),
    [anon_sym_NA_character_] = ACTIONS(5673),
    [sym_dots] = ACTIONS(5673),
    [sym_dot_dot_i] = ACTIONS(5669),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5669),
    [sym__newline] = ACTIONS(5669),
    [sym__raw_string_literal] = ACTIONS(2465),
    [sym__external_else] = ACTIONS(5669),
    [sym__external_open_parenthesis] = ACTIONS(5669),
    [sym__external_close_parenthesis] = ACTIONS(5669),
    [sym__external_open_brace] = ACTIONS(5669),
    [sym__external_open_bracket] = ACTIONS(5669),
    [sym__external_open_bracket2] = ACTIONS(5669),
  },
  [2057] = {
    [sym_string] = STATE(2762),
    [sym__single_quoted_string] = STATE(2430),
    [sym__double_quoted_string] = STATE(2466),
    [sym__string_or_identifier] = STATE(2762),
    [aux_sym_function_definition_repeat1] = STATE(2637),
    [sym_identifier] = ACTIONS(7281),
    [anon_sym_BSLASH] = ACTIONS(5669),
    [anon_sym_function] = ACTIONS(5673),
    [anon_sym_EQ] = ACTIONS(5673),
    [anon_sym_if] = ACTIONS(5673),
    [anon_sym_for] = ACTIONS(5673),
    [anon_sym_while] = ACTIONS(5673),
    [anon_sym_repeat] = ACTIONS(5673),
    [anon_sym_QMARK] = ACTIONS(5669),
    [anon_sym_TILDE] = ACTIONS(5669),
    [anon_sym_BANG] = ACTIONS(5673),
    [anon_sym_PLUS] = ACTIONS(5669),
    [anon_sym_DASH] = ACTIONS(5673),
    [anon_sym_LT_DASH] = ACTIONS(5669),
    [anon_sym_LT_LT_DASH] = ACTIONS(5669),
    [anon_sym_COLON_EQ] = ACTIONS(5669),
    [anon_sym_DASH_GT] = ACTIONS(5673),
    [anon_sym_DASH_GT_GT] = ACTIONS(5669),
    [anon_sym_PIPE] = ACTIONS(5673),
    [anon_sym_AMP] = ACTIONS(5673),
    [anon_sym_PIPE_PIPE] = ACTIONS(5669),
    [anon_sym_AMP_AMP] = ACTIONS(5669),
    [anon_sym_LT] = ACTIONS(5673),
    [anon_sym_LT_EQ] = ACTIONS(5669),
    [anon_sym_GT] = ACTIONS(5673),
    [anon_sym_GT_EQ] = ACTIONS(5669),
    [anon_sym_EQ_EQ] = ACTIONS(5669),
    [anon_sym_BANG_EQ] = ACTIONS(5669),
    [anon_sym_STAR] = ACTIONS(5673),
    [anon_sym_SLASH] = ACTIONS(5669),
    [anon_sym_STAR_STAR] = ACTIONS(5669),
    [anon_sym_CARET] = ACTIONS(5669),
    [aux_sym_binary_operator_token1] = ACTIONS(5669),
    [anon_sym_PIPE_GT] = ACTIONS(5669),
    [anon_sym_COLON] = ACTIONS(5673),
    [anon_sym_DOLLAR] = ACTIONS(5669),
    [anon_sym_AT] = ACTIONS(5669),
    [aux_sym__hex_literal_token1] = ACTIONS(5669),
    [sym__number_literal] = ACTIONS(5673),
    [anon_sym_SQUOTE] = ACTIONS(2511),
    [anon_sym_DQUOTE] = ACTIONS(2513),
    [sym_return] = ACTIONS(5673),
    [sym_next] = ACTIONS(5673),
    [sym_break] = ACTIONS(5673),
    [sym_true] = ACTIONS(5673),
    [sym_false] = ACTIONS(5673),
    [sym_null] = ACTIONS(5673),
    [sym_inf] = ACTIONS(5673),
    [sym_nan] = ACTIONS(5673),
    [anon_sym_NA] = ACTIONS(5673),
    [anon_sym_NA_integer_] = ACTIONS(5673),
    [anon_sym_NA_real_] = ACTIONS(5673),
    [anon_sym_NA_complex_] = ACTIONS(5673),
    [anon_sym_NA_character_] = ACTIONS(5673),
    [sym_dots] = ACTIONS(5673),
    [sym_dot_dot_i] = ACTIONS(5669),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5669),
    [sym__newline] = ACTIONS(5669),
    [sym__raw_string_literal] = ACTIONS(2523),
    [sym__external_open_parenthesis] = ACTIONS(5669),
    [sym__external_close_parenthesis] = ACTIONS(5669),
    [sym__external_open_brace] = ACTIONS(5669),
    [sym__external_open_bracket] = ACTIONS(5669),
    [sym__external_open_bracket2] = ACTIONS(5669),
    [sym__external_close_bracket2] = ACTIONS(5669),
  },
  [2058] = {
    [sym_call_arguments] = STATE(3027),
    [sym_subset_arguments] = STATE(3026),
    [sym_subset2_arguments] = STATE(3025),
    [sym__open_parenthesis] = STATE(1616),
    [sym__open_bracket] = STATE(1615),
    [sym__open_bracket2] = STATE(1613),
    [sym_identifier] = ACTIONS(5419),
    [anon_sym_BSLASH] = ACTIONS(5417),
    [anon_sym_function] = ACTIONS(5419),
    [anon_sym_EQ] = ACTIONS(7035),
    [anon_sym_if] = ACTIONS(5419),
    [anon_sym_for] = ACTIONS(5419),
    [anon_sym_while] = ACTIONS(5419),
    [anon_sym_repeat] = ACTIONS(5419),
    [anon_sym_QMARK] = ACTIONS(5417),
    [anon_sym_TILDE] = ACTIONS(7037),
    [anon_sym_BANG] = ACTIONS(5419),
    [anon_sym_PLUS] = ACTIONS(7039),
    [anon_sym_DASH] = ACTIONS(7041),
    [anon_sym_LT_DASH] = ACTIONS(7043),
    [anon_sym_LT_LT_DASH] = ACTIONS(7043),
    [anon_sym_COLON_EQ] = ACTIONS(7043),
    [anon_sym_DASH_GT] = ACTIONS(7045),
    [anon_sym_DASH_GT_GT] = ACTIONS(7047),
    [anon_sym_PIPE] = ACTIONS(7049),
    [anon_sym_AMP] = ACTIONS(7051),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_AMP_AMP] = ACTIONS(7055),
    [anon_sym_LT] = ACTIONS(7057),
    [anon_sym_LT_EQ] = ACTIONS(7059),
    [anon_sym_GT] = ACTIONS(7057),
    [anon_sym_GT_EQ] = ACTIONS(7059),
    [anon_sym_EQ_EQ] = ACTIONS(7059),
    [anon_sym_BANG_EQ] = ACTIONS(7059),
    [anon_sym_STAR] = ACTIONS(7061),
    [anon_sym_SLASH] = ACTIONS(7063),
    [anon_sym_STAR_STAR] = ACTIONS(7065),
    [anon_sym_CARET] = ACTIONS(7065),
    [aux_sym_binary_operator_token1] = ACTIONS(7067),
    [anon_sym_PIPE_GT] = ACTIONS(7067),
    [anon_sym_COLON] = ACTIONS(7069),
    [anon_sym_DOLLAR] = ACTIONS(7071),
    [anon_sym_AT] = ACTIONS(7071),
    [aux_sym__hex_literal_token1] = ACTIONS(5417),
    [sym__number_literal] = ACTIONS(5419),
    [anon_sym_SQUOTE] = ACTIONS(5417),
    [anon_sym_DQUOTE] = ACTIONS(5417),
    [sym_return] = ACTIONS(5419),
    [sym_next] = ACTIONS(5419),
    [sym_break] = ACTIONS(5419),
    [sym_true] = ACTIONS(5419),
    [sym_false] = ACTIONS(5419),
    [sym_null] = ACTIONS(5419),
    [sym_inf] = ACTIONS(5419),
    [sym_nan] = ACTIONS(5419),
    [anon_sym_NA] = ACTIONS(5419),
    [anon_sym_NA_integer_] = ACTIONS(5419),
    [anon_sym_NA_real_] = ACTIONS(5419),
    [anon_sym_NA_complex_] = ACTIONS(5419),
    [anon_sym_NA_character_] = ACTIONS(5419),
    [sym_dots] = ACTIONS(5419),
    [sym_dot_dot_i] = ACTIONS(5417),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5417),
    [sym__newline] = ACTIONS(5417),
    [sym__raw_string_literal] = ACTIONS(5417),
    [sym__external_open_parenthesis] = ACTIONS(7073),
    [sym__external_open_brace] = ACTIONS(5417),
    [sym__external_open_bracket] = ACTIONS(7075),
    [sym__external_close_bracket] = ACTIONS(5417),
    [sym__external_open_bracket2] = ACTIONS(7077),
  },
  [2059] = {
    [sym_identifier] = ACTIONS(7151),
    [anon_sym_BSLASH] = ACTIONS(7153),
    [anon_sym_function] = ACTIONS(7151),
    [anon_sym_EQ] = ACTIONS(7151),
    [anon_sym_if] = ACTIONS(7151),
    [anon_sym_for] = ACTIONS(7151),
    [anon_sym_while] = ACTIONS(7151),
    [anon_sym_repeat] = ACTIONS(7151),
    [anon_sym_QMARK] = ACTIONS(7153),
    [anon_sym_TILDE] = ACTIONS(7153),
    [anon_sym_BANG] = ACTIONS(7151),
    [anon_sym_PLUS] = ACTIONS(7153),
    [anon_sym_DASH] = ACTIONS(7151),
    [anon_sym_LT_DASH] = ACTIONS(7153),
    [anon_sym_LT_LT_DASH] = ACTIONS(7153),
    [anon_sym_COLON_EQ] = ACTIONS(7153),
    [anon_sym_DASH_GT] = ACTIONS(7151),
    [anon_sym_DASH_GT_GT] = ACTIONS(7153),
    [anon_sym_PIPE] = ACTIONS(7151),
    [anon_sym_AMP] = ACTIONS(7151),
    [anon_sym_PIPE_PIPE] = ACTIONS(7153),
    [anon_sym_AMP_AMP] = ACTIONS(7153),
    [anon_sym_LT] = ACTIONS(7151),
    [anon_sym_LT_EQ] = ACTIONS(7153),
    [anon_sym_GT] = ACTIONS(7151),
    [anon_sym_GT_EQ] = ACTIONS(7153),
    [anon_sym_EQ_EQ] = ACTIONS(7153),
    [anon_sym_BANG_EQ] = ACTIONS(7153),
    [anon_sym_STAR] = ACTIONS(7151),
    [anon_sym_SLASH] = ACTIONS(7153),
    [anon_sym_STAR_STAR] = ACTIONS(7153),
    [anon_sym_CARET] = ACTIONS(7153),
    [aux_sym_binary_operator_token1] = ACTIONS(7153),
    [anon_sym_PIPE_GT] = ACTIONS(7153),
    [anon_sym_COLON] = ACTIONS(7151),
    [anon_sym_DOLLAR] = ACTIONS(7153),
    [anon_sym_AT] = ACTIONS(7153),
    [anon_sym_COLON_COLON] = ACTIONS(7151),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7153),
    [aux_sym__hex_literal_token1] = ACTIONS(7153),
    [sym__number_literal] = ACTIONS(7151),
    [anon_sym_SQUOTE] = ACTIONS(7153),
    [anon_sym_DQUOTE] = ACTIONS(7153),
    [sym_return] = ACTIONS(7151),
    [sym_next] = ACTIONS(7151),
    [sym_break] = ACTIONS(7151),
    [sym_true] = ACTIONS(7151),
    [sym_false] = ACTIONS(7151),
    [sym_null] = ACTIONS(7151),
    [sym_inf] = ACTIONS(7151),
    [sym_nan] = ACTIONS(7151),
    [anon_sym_NA] = ACTIONS(7151),
    [anon_sym_NA_integer_] = ACTIONS(7151),
    [anon_sym_NA_real_] = ACTIONS(7151),
    [anon_sym_NA_complex_] = ACTIONS(7151),
    [anon_sym_NA_character_] = ACTIONS(7151),
    [sym_dots] = ACTIONS(7151),
    [sym_dot_dot_i] = ACTIONS(7153),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7153),
    [sym__newline] = ACTIONS(7153),
    [sym__semicolon] = ACTIONS(7153),
    [sym__raw_string_literal] = ACTIONS(7153),
    [sym__external_else] = ACTIONS(7153),
    [sym__external_open_parenthesis] = ACTIONS(7153),
    [sym__external_close_parenthesis] = ACTIONS(7153),
    [sym__external_open_brace] = ACTIONS(7153),
    [sym__external_close_brace] = ACTIONS(7153),
    [sym__external_open_bracket] = ACTIONS(7153),
    [sym__external_close_bracket] = ACTIONS(7153),
    [sym__external_open_bracket2] = ACTIONS(7153),
  },
  [2060] = {
    [sym_identifier] = ACTIONS(7163),
    [anon_sym_BSLASH] = ACTIONS(7165),
    [anon_sym_function] = ACTIONS(7163),
    [anon_sym_EQ] = ACTIONS(7163),
    [anon_sym_if] = ACTIONS(7163),
    [anon_sym_for] = ACTIONS(7163),
    [anon_sym_while] = ACTIONS(7163),
    [anon_sym_repeat] = ACTIONS(7163),
    [anon_sym_QMARK] = ACTIONS(7165),
    [anon_sym_TILDE] = ACTIONS(7165),
    [anon_sym_BANG] = ACTIONS(7163),
    [anon_sym_PLUS] = ACTIONS(7165),
    [anon_sym_DASH] = ACTIONS(7163),
    [anon_sym_LT_DASH] = ACTIONS(7165),
    [anon_sym_LT_LT_DASH] = ACTIONS(7165),
    [anon_sym_COLON_EQ] = ACTIONS(7165),
    [anon_sym_DASH_GT] = ACTIONS(7163),
    [anon_sym_DASH_GT_GT] = ACTIONS(7165),
    [anon_sym_PIPE] = ACTIONS(7163),
    [anon_sym_AMP] = ACTIONS(7163),
    [anon_sym_PIPE_PIPE] = ACTIONS(7165),
    [anon_sym_AMP_AMP] = ACTIONS(7165),
    [anon_sym_LT] = ACTIONS(7163),
    [anon_sym_LT_EQ] = ACTIONS(7165),
    [anon_sym_GT] = ACTIONS(7163),
    [anon_sym_GT_EQ] = ACTIONS(7165),
    [anon_sym_EQ_EQ] = ACTIONS(7165),
    [anon_sym_BANG_EQ] = ACTIONS(7165),
    [anon_sym_STAR] = ACTIONS(7163),
    [anon_sym_SLASH] = ACTIONS(7165),
    [anon_sym_STAR_STAR] = ACTIONS(7165),
    [anon_sym_CARET] = ACTIONS(7165),
    [aux_sym_binary_operator_token1] = ACTIONS(7165),
    [anon_sym_PIPE_GT] = ACTIONS(7165),
    [anon_sym_COLON] = ACTIONS(7163),
    [anon_sym_DOLLAR] = ACTIONS(7165),
    [anon_sym_AT] = ACTIONS(7165),
    [anon_sym_COLON_COLON] = ACTIONS(7163),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7165),
    [aux_sym__hex_literal_token1] = ACTIONS(7165),
    [sym__number_literal] = ACTIONS(7163),
    [anon_sym_SQUOTE] = ACTIONS(7165),
    [anon_sym_DQUOTE] = ACTIONS(7165),
    [sym_return] = ACTIONS(7163),
    [sym_next] = ACTIONS(7163),
    [sym_break] = ACTIONS(7163),
    [sym_true] = ACTIONS(7163),
    [sym_false] = ACTIONS(7163),
    [sym_null] = ACTIONS(7163),
    [sym_inf] = ACTIONS(7163),
    [sym_nan] = ACTIONS(7163),
    [anon_sym_NA] = ACTIONS(7163),
    [anon_sym_NA_integer_] = ACTIONS(7163),
    [anon_sym_NA_real_] = ACTIONS(7163),
    [anon_sym_NA_complex_] = ACTIONS(7163),
    [anon_sym_NA_character_] = ACTIONS(7163),
    [sym_dots] = ACTIONS(7163),
    [sym_dot_dot_i] = ACTIONS(7165),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7165),
    [sym__newline] = ACTIONS(7165),
    [sym__semicolon] = ACTIONS(7165),
    [sym__raw_string_literal] = ACTIONS(7165),
    [sym__external_else] = ACTIONS(7165),
    [sym__external_open_parenthesis] = ACTIONS(7165),
    [sym__external_close_parenthesis] = ACTIONS(7165),
    [sym__external_open_brace] = ACTIONS(7165),
    [sym__external_close_brace] = ACTIONS(7165),
    [sym__external_open_bracket] = ACTIONS(7165),
    [sym__external_close_bracket] = ACTIONS(7165),
    [sym__external_open_bracket2] = ACTIONS(7165),
  },
  [2061] = {
    [sym_call_arguments] = STATE(2978),
    [sym_subset_arguments] = STATE(2977),
    [sym_subset2_arguments] = STATE(2976),
    [sym__open_parenthesis] = STATE(1606),
    [sym__open_bracket] = STATE(1598),
    [sym__open_bracket2] = STATE(1592),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_BSLASH] = ACTIONS(5413),
    [anon_sym_function] = ACTIONS(5415),
    [anon_sym_EQ] = ACTIONS(6875),
    [anon_sym_if] = ACTIONS(5415),
    [anon_sym_for] = ACTIONS(5415),
    [anon_sym_while] = ACTIONS(5415),
    [anon_sym_repeat] = ACTIONS(5415),
    [anon_sym_QMARK] = ACTIONS(5413),
    [anon_sym_TILDE] = ACTIONS(6877),
    [anon_sym_BANG] = ACTIONS(5415),
    [anon_sym_PLUS] = ACTIONS(6879),
    [anon_sym_DASH] = ACTIONS(6881),
    [anon_sym_LT_DASH] = ACTIONS(6883),
    [anon_sym_LT_LT_DASH] = ACTIONS(6883),
    [anon_sym_COLON_EQ] = ACTIONS(6883),
    [anon_sym_DASH_GT] = ACTIONS(6885),
    [anon_sym_DASH_GT_GT] = ACTIONS(6887),
    [anon_sym_PIPE] = ACTIONS(6889),
    [anon_sym_AMP] = ACTIONS(6891),
    [anon_sym_PIPE_PIPE] = ACTIONS(6893),
    [anon_sym_AMP_AMP] = ACTIONS(6895),
    [anon_sym_LT] = ACTIONS(6897),
    [anon_sym_LT_EQ] = ACTIONS(6899),
    [anon_sym_GT] = ACTIONS(6897),
    [anon_sym_GT_EQ] = ACTIONS(6899),
    [anon_sym_EQ_EQ] = ACTIONS(6899),
    [anon_sym_BANG_EQ] = ACTIONS(6899),
    [anon_sym_STAR] = ACTIONS(6901),
    [anon_sym_SLASH] = ACTIONS(6903),
    [anon_sym_STAR_STAR] = ACTIONS(6905),
    [anon_sym_CARET] = ACTIONS(6905),
    [aux_sym_binary_operator_token1] = ACTIONS(6907),
    [anon_sym_PIPE_GT] = ACTIONS(6907),
    [anon_sym_COLON] = ACTIONS(6909),
    [anon_sym_DOLLAR] = ACTIONS(6911),
    [anon_sym_AT] = ACTIONS(6911),
    [aux_sym__hex_literal_token1] = ACTIONS(5413),
    [sym__number_literal] = ACTIONS(5415),
    [anon_sym_SQUOTE] = ACTIONS(5413),
    [anon_sym_DQUOTE] = ACTIONS(5413),
    [sym_return] = ACTIONS(5415),
    [sym_next] = ACTIONS(5415),
    [sym_break] = ACTIONS(5415),
    [sym_true] = ACTIONS(5415),
    [sym_false] = ACTIONS(5415),
    [sym_null] = ACTIONS(5415),
    [sym_inf] = ACTIONS(5415),
    [sym_nan] = ACTIONS(5415),
    [anon_sym_NA] = ACTIONS(5415),
    [anon_sym_NA_integer_] = ACTIONS(5415),
    [anon_sym_NA_real_] = ACTIONS(5415),
    [anon_sym_NA_complex_] = ACTIONS(5415),
    [anon_sym_NA_character_] = ACTIONS(5415),
    [sym_dots] = ACTIONS(5415),
    [sym_dot_dot_i] = ACTIONS(5413),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5413),
    [sym__newline] = ACTIONS(5413),
    [sym__raw_string_literal] = ACTIONS(5413),
    [sym__external_open_parenthesis] = ACTIONS(6913),
    [sym__external_open_brace] = ACTIONS(5413),
    [sym__external_open_bracket] = ACTIONS(6915),
    [sym__external_open_bracket2] = ACTIONS(6917),
    [sym__external_close_bracket2] = ACTIONS(5413),
  },
  [2062] = {
    [sym_call_arguments] = STATE(2941),
    [sym_subset_arguments] = STATE(2942),
    [sym_subset2_arguments] = STATE(2943),
    [sym__open_parenthesis] = STATE(1755),
    [sym__open_bracket] = STATE(1763),
    [sym__open_bracket2] = STATE(1866),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(6923),
    [anon_sym_DASH] = ACTIONS(6925),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(6939),
    [anon_sym_LT_EQ] = ACTIONS(6941),
    [anon_sym_GT] = ACTIONS(6939),
    [anon_sym_GT_EQ] = ACTIONS(6941),
    [anon_sym_EQ_EQ] = ACTIONS(6941),
    [anon_sym_BANG_EQ] = ACTIONS(6941),
    [anon_sym_STAR] = ACTIONS(6943),
    [anon_sym_SLASH] = ACTIONS(6945),
    [anon_sym_STAR_STAR] = ACTIONS(6947),
    [anon_sym_CARET] = ACTIONS(6947),
    [aux_sym_binary_operator_token1] = ACTIONS(6949),
    [anon_sym_PIPE_GT] = ACTIONS(6949),
    [anon_sym_COLON] = ACTIONS(6951),
    [anon_sym_DOLLAR] = ACTIONS(6953),
    [anon_sym_AT] = ACTIONS(6953),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6955),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6957),
    [sym__external_open_bracket2] = ACTIONS(6959),
  },
  [2063] = {
    [sym_call_arguments] = STATE(2985),
    [sym_subset_arguments] = STATE(2986),
    [sym_subset2_arguments] = STATE(2987),
    [sym__open_parenthesis] = STATE(1414),
    [sym__open_bracket] = STATE(1416),
    [sym__open_bracket2] = STATE(1428),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(7155),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(7079),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(7081),
    [anon_sym_DASH] = ACTIONS(7083),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(7159),
    [anon_sym_DASH_GT_GT] = ACTIONS(7161),
    [anon_sym_PIPE] = ACTIONS(7085),
    [anon_sym_AMP] = ACTIONS(7087),
    [anon_sym_PIPE_PIPE] = ACTIONS(7089),
    [anon_sym_AMP_AMP] = ACTIONS(7091),
    [anon_sym_LT] = ACTIONS(7093),
    [anon_sym_LT_EQ] = ACTIONS(7095),
    [anon_sym_GT] = ACTIONS(7093),
    [anon_sym_GT_EQ] = ACTIONS(7095),
    [anon_sym_EQ_EQ] = ACTIONS(7095),
    [anon_sym_BANG_EQ] = ACTIONS(7095),
    [anon_sym_STAR] = ACTIONS(7097),
    [anon_sym_SLASH] = ACTIONS(7099),
    [anon_sym_STAR_STAR] = ACTIONS(7101),
    [anon_sym_CARET] = ACTIONS(7101),
    [aux_sym_binary_operator_token1] = ACTIONS(7103),
    [anon_sym_PIPE_GT] = ACTIONS(7103),
    [anon_sym_COLON] = ACTIONS(7105),
    [anon_sym_DOLLAR] = ACTIONS(7107),
    [anon_sym_AT] = ACTIONS(7107),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(7109),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(7111),
    [sym__external_open_bracket2] = ACTIONS(7113),
  },
  [2064] = {
    [sym_string] = STATE(2831),
    [sym__single_quoted_string] = STATE(2430),
    [sym__double_quoted_string] = STATE(2466),
    [sym__string_or_identifier] = STATE(2831),
    [aux_sym_function_definition_repeat1] = STATE(2057),
    [sym_identifier] = ACTIONS(7283),
    [anon_sym_BSLASH] = ACTIONS(5659),
    [anon_sym_function] = ACTIONS(5663),
    [anon_sym_EQ] = ACTIONS(5663),
    [anon_sym_if] = ACTIONS(5663),
    [anon_sym_for] = ACTIONS(5663),
    [anon_sym_while] = ACTIONS(5663),
    [anon_sym_repeat] = ACTIONS(5663),
    [anon_sym_QMARK] = ACTIONS(5659),
    [anon_sym_TILDE] = ACTIONS(5659),
    [anon_sym_BANG] = ACTIONS(5663),
    [anon_sym_PLUS] = ACTIONS(5659),
    [anon_sym_DASH] = ACTIONS(5663),
    [anon_sym_LT_DASH] = ACTIONS(5659),
    [anon_sym_LT_LT_DASH] = ACTIONS(5659),
    [anon_sym_COLON_EQ] = ACTIONS(5659),
    [anon_sym_DASH_GT] = ACTIONS(5663),
    [anon_sym_DASH_GT_GT] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(5663),
    [anon_sym_AMP] = ACTIONS(5663),
    [anon_sym_PIPE_PIPE] = ACTIONS(5659),
    [anon_sym_AMP_AMP] = ACTIONS(5659),
    [anon_sym_LT] = ACTIONS(5663),
    [anon_sym_LT_EQ] = ACTIONS(5659),
    [anon_sym_GT] = ACTIONS(5663),
    [anon_sym_GT_EQ] = ACTIONS(5659),
    [anon_sym_EQ_EQ] = ACTIONS(5659),
    [anon_sym_BANG_EQ] = ACTIONS(5659),
    [anon_sym_STAR] = ACTIONS(5663),
    [anon_sym_SLASH] = ACTIONS(5659),
    [anon_sym_STAR_STAR] = ACTIONS(5659),
    [anon_sym_CARET] = ACTIONS(5659),
    [aux_sym_binary_operator_token1] = ACTIONS(5659),
    [anon_sym_PIPE_GT] = ACTIONS(5659),
    [anon_sym_COLON] = ACTIONS(5663),
    [anon_sym_DOLLAR] = ACTIONS(5659),
    [anon_sym_AT] = ACTIONS(5659),
    [aux_sym__hex_literal_token1] = ACTIONS(5659),
    [sym__number_literal] = ACTIONS(5663),
    [anon_sym_SQUOTE] = ACTIONS(2511),
    [anon_sym_DQUOTE] = ACTIONS(2513),
    [sym_return] = ACTIONS(5663),
    [sym_next] = ACTIONS(5663),
    [sym_break] = ACTIONS(5663),
    [sym_true] = ACTIONS(5663),
    [sym_false] = ACTIONS(5663),
    [sym_null] = ACTIONS(5663),
    [sym_inf] = ACTIONS(5663),
    [sym_nan] = ACTIONS(5663),
    [anon_sym_NA] = ACTIONS(5663),
    [anon_sym_NA_integer_] = ACTIONS(5663),
    [anon_sym_NA_real_] = ACTIONS(5663),
    [anon_sym_NA_complex_] = ACTIONS(5663),
    [anon_sym_NA_character_] = ACTIONS(5663),
    [sym_dots] = ACTIONS(5663),
    [sym_dot_dot_i] = ACTIONS(5659),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5659),
    [sym__newline] = ACTIONS(7285),
    [sym__raw_string_literal] = ACTIONS(2523),
    [sym__external_open_parenthesis] = ACTIONS(5659),
    [sym__external_close_parenthesis] = ACTIONS(5659),
    [sym__external_open_brace] = ACTIONS(5659),
    [sym__external_open_bracket] = ACTIONS(5659),
    [sym__external_open_bracket2] = ACTIONS(5659),
    [sym__external_close_bracket2] = ACTIONS(5659),
  },
  [2065] = {
    [sym_string] = STATE(2855),
    [sym__single_quoted_string] = STATE(2456),
    [sym__double_quoted_string] = STATE(2478),
    [sym__string_or_identifier] = STATE(2855),
    [aux_sym_function_definition_repeat1] = STATE(1909),
    [sym_identifier] = ACTIONS(7287),
    [anon_sym_BSLASH] = ACTIONS(5659),
    [anon_sym_function] = ACTIONS(5663),
    [anon_sym_EQ] = ACTIONS(5663),
    [anon_sym_if] = ACTIONS(5663),
    [anon_sym_for] = ACTIONS(5663),
    [anon_sym_while] = ACTIONS(5663),
    [anon_sym_repeat] = ACTIONS(5663),
    [anon_sym_QMARK] = ACTIONS(5659),
    [anon_sym_TILDE] = ACTIONS(5659),
    [anon_sym_BANG] = ACTIONS(5663),
    [anon_sym_PLUS] = ACTIONS(5659),
    [anon_sym_DASH] = ACTIONS(5663),
    [anon_sym_LT_DASH] = ACTIONS(5659),
    [anon_sym_LT_LT_DASH] = ACTIONS(5659),
    [anon_sym_COLON_EQ] = ACTIONS(5659),
    [anon_sym_DASH_GT] = ACTIONS(5663),
    [anon_sym_DASH_GT_GT] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(5663),
    [anon_sym_AMP] = ACTIONS(5663),
    [anon_sym_PIPE_PIPE] = ACTIONS(5659),
    [anon_sym_AMP_AMP] = ACTIONS(5659),
    [anon_sym_LT] = ACTIONS(5663),
    [anon_sym_LT_EQ] = ACTIONS(5659),
    [anon_sym_GT] = ACTIONS(5663),
    [anon_sym_GT_EQ] = ACTIONS(5659),
    [anon_sym_EQ_EQ] = ACTIONS(5659),
    [anon_sym_BANG_EQ] = ACTIONS(5659),
    [anon_sym_STAR] = ACTIONS(5663),
    [anon_sym_SLASH] = ACTIONS(5659),
    [anon_sym_STAR_STAR] = ACTIONS(5659),
    [anon_sym_CARET] = ACTIONS(5659),
    [aux_sym_binary_operator_token1] = ACTIONS(5659),
    [anon_sym_PIPE_GT] = ACTIONS(5659),
    [anon_sym_COLON] = ACTIONS(5663),
    [anon_sym_DOLLAR] = ACTIONS(5659),
    [anon_sym_AT] = ACTIONS(5659),
    [aux_sym__hex_literal_token1] = ACTIONS(5659),
    [sym__number_literal] = ACTIONS(5663),
    [anon_sym_SQUOTE] = ACTIONS(3519),
    [anon_sym_DQUOTE] = ACTIONS(3521),
    [sym_return] = ACTIONS(5663),
    [sym_next] = ACTIONS(5663),
    [sym_break] = ACTIONS(5663),
    [sym_true] = ACTIONS(5663),
    [sym_false] = ACTIONS(5663),
    [sym_null] = ACTIONS(5663),
    [sym_inf] = ACTIONS(5663),
    [sym_nan] = ACTIONS(5663),
    [anon_sym_NA] = ACTIONS(5663),
    [anon_sym_NA_integer_] = ACTIONS(5663),
    [anon_sym_NA_real_] = ACTIONS(5663),
    [anon_sym_NA_complex_] = ACTIONS(5663),
    [anon_sym_NA_character_] = ACTIONS(5663),
    [sym_dots] = ACTIONS(5663),
    [sym_dot_dot_i] = ACTIONS(5659),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5659),
    [sym__newline] = ACTIONS(7289),
    [sym__raw_string_literal] = ACTIONS(3531),
    [sym__external_else] = ACTIONS(5659),
    [sym__external_open_parenthesis] = ACTIONS(5659),
    [sym__external_open_brace] = ACTIONS(5659),
    [sym__external_open_bracket] = ACTIONS(5659),
    [sym__external_close_bracket] = ACTIONS(5659),
    [sym__external_open_bracket2] = ACTIONS(5659),
  },
  [2066] = {
    [sym_call_arguments] = STATE(2941),
    [sym_subset_arguments] = STATE(2942),
    [sym_subset2_arguments] = STATE(2943),
    [sym__open_parenthesis] = STATE(1755),
    [sym__open_bracket] = STATE(1763),
    [sym__open_bracket2] = STATE(1866),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(6923),
    [anon_sym_DASH] = ACTIONS(6925),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(6931),
    [anon_sym_AMP] = ACTIONS(6933),
    [anon_sym_PIPE_PIPE] = ACTIONS(6935),
    [anon_sym_AMP_AMP] = ACTIONS(6937),
    [anon_sym_LT] = ACTIONS(6939),
    [anon_sym_LT_EQ] = ACTIONS(6941),
    [anon_sym_GT] = ACTIONS(6939),
    [anon_sym_GT_EQ] = ACTIONS(6941),
    [anon_sym_EQ_EQ] = ACTIONS(6941),
    [anon_sym_BANG_EQ] = ACTIONS(6941),
    [anon_sym_STAR] = ACTIONS(6943),
    [anon_sym_SLASH] = ACTIONS(6945),
    [anon_sym_STAR_STAR] = ACTIONS(6947),
    [anon_sym_CARET] = ACTIONS(6947),
    [aux_sym_binary_operator_token1] = ACTIONS(6949),
    [anon_sym_PIPE_GT] = ACTIONS(6949),
    [anon_sym_COLON] = ACTIONS(6951),
    [anon_sym_DOLLAR] = ACTIONS(6953),
    [anon_sym_AT] = ACTIONS(6953),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6955),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6957),
    [sym__external_open_bracket2] = ACTIONS(6959),
  },
  [2067] = {
    [sym_call_arguments] = STATE(3027),
    [sym_subset_arguments] = STATE(3026),
    [sym_subset2_arguments] = STATE(3025),
    [sym__open_parenthesis] = STATE(1616),
    [sym__open_bracket] = STATE(1615),
    [sym__open_bracket2] = STATE(1613),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_BSLASH] = ACTIONS(5413),
    [anon_sym_function] = ACTIONS(5415),
    [anon_sym_EQ] = ACTIONS(7035),
    [anon_sym_if] = ACTIONS(5415),
    [anon_sym_for] = ACTIONS(5415),
    [anon_sym_while] = ACTIONS(5415),
    [anon_sym_repeat] = ACTIONS(5415),
    [anon_sym_QMARK] = ACTIONS(5413),
    [anon_sym_TILDE] = ACTIONS(7037),
    [anon_sym_BANG] = ACTIONS(5415),
    [anon_sym_PLUS] = ACTIONS(7039),
    [anon_sym_DASH] = ACTIONS(7041),
    [anon_sym_LT_DASH] = ACTIONS(7043),
    [anon_sym_LT_LT_DASH] = ACTIONS(7043),
    [anon_sym_COLON_EQ] = ACTIONS(7043),
    [anon_sym_DASH_GT] = ACTIONS(7045),
    [anon_sym_DASH_GT_GT] = ACTIONS(7047),
    [anon_sym_PIPE] = ACTIONS(7049),
    [anon_sym_AMP] = ACTIONS(7051),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_AMP_AMP] = ACTIONS(7055),
    [anon_sym_LT] = ACTIONS(7057),
    [anon_sym_LT_EQ] = ACTIONS(7059),
    [anon_sym_GT] = ACTIONS(7057),
    [anon_sym_GT_EQ] = ACTIONS(7059),
    [anon_sym_EQ_EQ] = ACTIONS(7059),
    [anon_sym_BANG_EQ] = ACTIONS(7059),
    [anon_sym_STAR] = ACTIONS(7061),
    [anon_sym_SLASH] = ACTIONS(7063),
    [anon_sym_STAR_STAR] = ACTIONS(7065),
    [anon_sym_CARET] = ACTIONS(7065),
    [aux_sym_binary_operator_token1] = ACTIONS(7067),
    [anon_sym_PIPE_GT] = ACTIONS(7067),
    [anon_sym_COLON] = ACTIONS(7069),
    [anon_sym_DOLLAR] = ACTIONS(7071),
    [anon_sym_AT] = ACTIONS(7071),
    [aux_sym__hex_literal_token1] = ACTIONS(5413),
    [sym__number_literal] = ACTIONS(5415),
    [anon_sym_SQUOTE] = ACTIONS(5413),
    [anon_sym_DQUOTE] = ACTIONS(5413),
    [sym_return] = ACTIONS(5415),
    [sym_next] = ACTIONS(5415),
    [sym_break] = ACTIONS(5415),
    [sym_true] = ACTIONS(5415),
    [sym_false] = ACTIONS(5415),
    [sym_null] = ACTIONS(5415),
    [sym_inf] = ACTIONS(5415),
    [sym_nan] = ACTIONS(5415),
    [anon_sym_NA] = ACTIONS(5415),
    [anon_sym_NA_integer_] = ACTIONS(5415),
    [anon_sym_NA_real_] = ACTIONS(5415),
    [anon_sym_NA_complex_] = ACTIONS(5415),
    [anon_sym_NA_character_] = ACTIONS(5415),
    [sym_dots] = ACTIONS(5415),
    [sym_dot_dot_i] = ACTIONS(5413),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5413),
    [sym__newline] = ACTIONS(5413),
    [sym__raw_string_literal] = ACTIONS(5413),
    [sym__external_open_parenthesis] = ACTIONS(7073),
    [sym__external_open_brace] = ACTIONS(5413),
    [sym__external_open_bracket] = ACTIONS(7075),
    [sym__external_close_bracket] = ACTIONS(5413),
    [sym__external_open_bracket2] = ACTIONS(7077),
  },
  [2068] = {
    [sym_call_arguments] = STATE(2941),
    [sym_subset_arguments] = STATE(2942),
    [sym_subset2_arguments] = STATE(2943),
    [sym__open_parenthesis] = STATE(1755),
    [sym__open_bracket] = STATE(1763),
    [sym__open_bracket2] = STATE(1866),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(6943),
    [anon_sym_SLASH] = ACTIONS(6945),
    [anon_sym_STAR_STAR] = ACTIONS(6947),
    [anon_sym_CARET] = ACTIONS(6947),
    [aux_sym_binary_operator_token1] = ACTIONS(6949),
    [anon_sym_PIPE_GT] = ACTIONS(6949),
    [anon_sym_COLON] = ACTIONS(6951),
    [anon_sym_DOLLAR] = ACTIONS(6953),
    [anon_sym_AT] = ACTIONS(6953),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6955),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6957),
    [sym__external_open_bracket2] = ACTIONS(6959),
  },
  [2069] = {
    [sym_call_arguments] = STATE(2978),
    [sym_subset_arguments] = STATE(2977),
    [sym_subset2_arguments] = STATE(2976),
    [sym__open_parenthesis] = STATE(1606),
    [sym__open_bracket] = STATE(1598),
    [sym__open_bracket2] = STATE(1592),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5345),
    [anon_sym_DASH] = ACTIONS(5347),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5347),
    [anon_sym_AMP] = ACTIONS(5347),
    [anon_sym_PIPE_PIPE] = ACTIONS(5345),
    [anon_sym_AMP_AMP] = ACTIONS(5345),
    [anon_sym_LT] = ACTIONS(5347),
    [anon_sym_LT_EQ] = ACTIONS(5345),
    [anon_sym_GT] = ACTIONS(5347),
    [anon_sym_GT_EQ] = ACTIONS(5345),
    [anon_sym_EQ_EQ] = ACTIONS(5345),
    [anon_sym_BANG_EQ] = ACTIONS(5345),
    [anon_sym_STAR] = ACTIONS(5347),
    [anon_sym_SLASH] = ACTIONS(5345),
    [anon_sym_STAR_STAR] = ACTIONS(6905),
    [anon_sym_CARET] = ACTIONS(6905),
    [aux_sym_binary_operator_token1] = ACTIONS(5345),
    [anon_sym_PIPE_GT] = ACTIONS(5345),
    [anon_sym_COLON] = ACTIONS(5347),
    [anon_sym_DOLLAR] = ACTIONS(6911),
    [anon_sym_AT] = ACTIONS(6911),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5345),
    [sym__newline] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(6913),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(6915),
    [sym__external_open_bracket2] = ACTIONS(6917),
    [sym__external_close_bracket2] = ACTIONS(5345),
  },
  [2070] = {
    [sym_call_arguments] = STATE(2941),
    [sym_subset_arguments] = STATE(2942),
    [sym_subset2_arguments] = STATE(2943),
    [sym__open_parenthesis] = STATE(1755),
    [sym__open_bracket] = STATE(1763),
    [sym__open_bracket2] = STATE(1866),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(6919),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(6921),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(6923),
    [anon_sym_DASH] = ACTIONS(6925),
    [anon_sym_LT_DASH] = ACTIONS(7147),
    [anon_sym_LT_LT_DASH] = ACTIONS(7147),
    [anon_sym_COLON_EQ] = ACTIONS(7147),
    [anon_sym_DASH_GT] = ACTIONS(6927),
    [anon_sym_DASH_GT_GT] = ACTIONS(6929),
    [anon_sym_PIPE] = ACTIONS(6931),
    [anon_sym_AMP] = ACTIONS(6933),
    [anon_sym_PIPE_PIPE] = ACTIONS(6935),
    [anon_sym_AMP_AMP] = ACTIONS(6937),
    [anon_sym_LT] = ACTIONS(6939),
    [anon_sym_LT_EQ] = ACTIONS(6941),
    [anon_sym_GT] = ACTIONS(6939),
    [anon_sym_GT_EQ] = ACTIONS(6941),
    [anon_sym_EQ_EQ] = ACTIONS(6941),
    [anon_sym_BANG_EQ] = ACTIONS(6941),
    [anon_sym_STAR] = ACTIONS(6943),
    [anon_sym_SLASH] = ACTIONS(6945),
    [anon_sym_STAR_STAR] = ACTIONS(6947),
    [anon_sym_CARET] = ACTIONS(6947),
    [aux_sym_binary_operator_token1] = ACTIONS(6949),
    [anon_sym_PIPE_GT] = ACTIONS(6949),
    [anon_sym_COLON] = ACTIONS(6951),
    [anon_sym_DOLLAR] = ACTIONS(6953),
    [anon_sym_AT] = ACTIONS(6953),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6955),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6957),
    [sym__external_open_bracket2] = ACTIONS(6959),
  },
  [2071] = {
    [sym_call_arguments] = STATE(3027),
    [sym_subset_arguments] = STATE(3026),
    [sym_subset2_arguments] = STATE(3025),
    [sym__open_parenthesis] = STATE(1616),
    [sym__open_bracket] = STATE(1615),
    [sym__open_bracket2] = STATE(1613),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(7035),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(7037),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(7039),
    [anon_sym_DASH] = ACTIONS(7041),
    [anon_sym_LT_DASH] = ACTIONS(7043),
    [anon_sym_LT_LT_DASH] = ACTIONS(7043),
    [anon_sym_COLON_EQ] = ACTIONS(7043),
    [anon_sym_DASH_GT] = ACTIONS(7045),
    [anon_sym_DASH_GT_GT] = ACTIONS(7047),
    [anon_sym_PIPE] = ACTIONS(7049),
    [anon_sym_AMP] = ACTIONS(7051),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_AMP_AMP] = ACTIONS(7055),
    [anon_sym_LT] = ACTIONS(7057),
    [anon_sym_LT_EQ] = ACTIONS(7059),
    [anon_sym_GT] = ACTIONS(7057),
    [anon_sym_GT_EQ] = ACTIONS(7059),
    [anon_sym_EQ_EQ] = ACTIONS(7059),
    [anon_sym_BANG_EQ] = ACTIONS(7059),
    [anon_sym_STAR] = ACTIONS(7061),
    [anon_sym_SLASH] = ACTIONS(7063),
    [anon_sym_STAR_STAR] = ACTIONS(7065),
    [anon_sym_CARET] = ACTIONS(7065),
    [aux_sym_binary_operator_token1] = ACTIONS(7067),
    [anon_sym_PIPE_GT] = ACTIONS(7067),
    [anon_sym_COLON] = ACTIONS(7069),
    [anon_sym_DOLLAR] = ACTIONS(7071),
    [anon_sym_AT] = ACTIONS(7071),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(7073),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(7075),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(7077),
  },
  [2072] = {
    [sym_call_arguments] = STATE(2978),
    [sym_subset_arguments] = STATE(2977),
    [sym_subset2_arguments] = STATE(2976),
    [sym__open_parenthesis] = STATE(1606),
    [sym__open_bracket] = STATE(1598),
    [sym__open_bracket2] = STATE(1592),
    [sym_identifier] = ACTIONS(5423),
    [anon_sym_BSLASH] = ACTIONS(5421),
    [anon_sym_function] = ACTIONS(5423),
    [anon_sym_EQ] = ACTIONS(6875),
    [anon_sym_if] = ACTIONS(5423),
    [anon_sym_for] = ACTIONS(5423),
    [anon_sym_while] = ACTIONS(5423),
    [anon_sym_repeat] = ACTIONS(5423),
    [anon_sym_QMARK] = ACTIONS(5421),
    [anon_sym_TILDE] = ACTIONS(6877),
    [anon_sym_BANG] = ACTIONS(5423),
    [anon_sym_PLUS] = ACTIONS(6879),
    [anon_sym_DASH] = ACTIONS(6881),
    [anon_sym_LT_DASH] = ACTIONS(6883),
    [anon_sym_LT_LT_DASH] = ACTIONS(6883),
    [anon_sym_COLON_EQ] = ACTIONS(6883),
    [anon_sym_DASH_GT] = ACTIONS(6885),
    [anon_sym_DASH_GT_GT] = ACTIONS(6887),
    [anon_sym_PIPE] = ACTIONS(6889),
    [anon_sym_AMP] = ACTIONS(6891),
    [anon_sym_PIPE_PIPE] = ACTIONS(6893),
    [anon_sym_AMP_AMP] = ACTIONS(6895),
    [anon_sym_LT] = ACTIONS(6897),
    [anon_sym_LT_EQ] = ACTIONS(6899),
    [anon_sym_GT] = ACTIONS(6897),
    [anon_sym_GT_EQ] = ACTIONS(6899),
    [anon_sym_EQ_EQ] = ACTIONS(6899),
    [anon_sym_BANG_EQ] = ACTIONS(6899),
    [anon_sym_STAR] = ACTIONS(6901),
    [anon_sym_SLASH] = ACTIONS(6903),
    [anon_sym_STAR_STAR] = ACTIONS(6905),
    [anon_sym_CARET] = ACTIONS(6905),
    [aux_sym_binary_operator_token1] = ACTIONS(6907),
    [anon_sym_PIPE_GT] = ACTIONS(6907),
    [anon_sym_COLON] = ACTIONS(6909),
    [anon_sym_DOLLAR] = ACTIONS(6911),
    [anon_sym_AT] = ACTIONS(6911),
    [aux_sym__hex_literal_token1] = ACTIONS(5421),
    [sym__number_literal] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5421),
    [anon_sym_DQUOTE] = ACTIONS(5421),
    [sym_return] = ACTIONS(5423),
    [sym_next] = ACTIONS(5423),
    [sym_break] = ACTIONS(5423),
    [sym_true] = ACTIONS(5423),
    [sym_false] = ACTIONS(5423),
    [sym_null] = ACTIONS(5423),
    [sym_inf] = ACTIONS(5423),
    [sym_nan] = ACTIONS(5423),
    [anon_sym_NA] = ACTIONS(5423),
    [anon_sym_NA_integer_] = ACTIONS(5423),
    [anon_sym_NA_real_] = ACTIONS(5423),
    [anon_sym_NA_complex_] = ACTIONS(5423),
    [anon_sym_NA_character_] = ACTIONS(5423),
    [sym_dots] = ACTIONS(5423),
    [sym_dot_dot_i] = ACTIONS(5421),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5421),
    [sym__newline] = ACTIONS(5421),
    [sym__raw_string_literal] = ACTIONS(5421),
    [sym__external_open_parenthesis] = ACTIONS(6913),
    [sym__external_open_brace] = ACTIONS(5421),
    [sym__external_open_bracket] = ACTIONS(6915),
    [sym__external_open_bracket2] = ACTIONS(6917),
    [sym__external_close_bracket2] = ACTIONS(5421),
  },
  [2073] = {
    [sym_call_arguments] = STATE(2941),
    [sym_subset_arguments] = STATE(2942),
    [sym_subset2_arguments] = STATE(2943),
    [sym__open_parenthesis] = STATE(1755),
    [sym__open_bracket] = STATE(1763),
    [sym__open_bracket2] = STATE(1866),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(6921),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(6923),
    [anon_sym_DASH] = ACTIONS(6925),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(6931),
    [anon_sym_AMP] = ACTIONS(6933),
    [anon_sym_PIPE_PIPE] = ACTIONS(6935),
    [anon_sym_AMP_AMP] = ACTIONS(6937),
    [anon_sym_LT] = ACTIONS(6939),
    [anon_sym_LT_EQ] = ACTIONS(6941),
    [anon_sym_GT] = ACTIONS(6939),
    [anon_sym_GT_EQ] = ACTIONS(6941),
    [anon_sym_EQ_EQ] = ACTIONS(6941),
    [anon_sym_BANG_EQ] = ACTIONS(6941),
    [anon_sym_STAR] = ACTIONS(6943),
    [anon_sym_SLASH] = ACTIONS(6945),
    [anon_sym_STAR_STAR] = ACTIONS(6947),
    [anon_sym_CARET] = ACTIONS(6947),
    [aux_sym_binary_operator_token1] = ACTIONS(6949),
    [anon_sym_PIPE_GT] = ACTIONS(6949),
    [anon_sym_COLON] = ACTIONS(6951),
    [anon_sym_DOLLAR] = ACTIONS(6953),
    [anon_sym_AT] = ACTIONS(6953),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6955),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6957),
    [sym__external_open_bracket2] = ACTIONS(6959),
  },
  [2074] = {
    [sym_call_arguments] = STATE(2985),
    [sym_subset_arguments] = STATE(2986),
    [sym_subset2_arguments] = STATE(2987),
    [sym__open_parenthesis] = STATE(1414),
    [sym__open_bracket] = STATE(1416),
    [sym__open_bracket2] = STATE(1428),
    [ts_builtin_sym_end] = ACTIONS(5413),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_BSLASH] = ACTIONS(5413),
    [anon_sym_function] = ACTIONS(5415),
    [anon_sym_EQ] = ACTIONS(7155),
    [anon_sym_if] = ACTIONS(5415),
    [anon_sym_for] = ACTIONS(5415),
    [anon_sym_while] = ACTIONS(5415),
    [anon_sym_repeat] = ACTIONS(5415),
    [anon_sym_QMARK] = ACTIONS(5413),
    [anon_sym_TILDE] = ACTIONS(7079),
    [anon_sym_BANG] = ACTIONS(5415),
    [anon_sym_PLUS] = ACTIONS(7081),
    [anon_sym_DASH] = ACTIONS(7083),
    [anon_sym_LT_DASH] = ACTIONS(7157),
    [anon_sym_LT_LT_DASH] = ACTIONS(7157),
    [anon_sym_COLON_EQ] = ACTIONS(7157),
    [anon_sym_DASH_GT] = ACTIONS(7159),
    [anon_sym_DASH_GT_GT] = ACTIONS(7161),
    [anon_sym_PIPE] = ACTIONS(7085),
    [anon_sym_AMP] = ACTIONS(7087),
    [anon_sym_PIPE_PIPE] = ACTIONS(7089),
    [anon_sym_AMP_AMP] = ACTIONS(7091),
    [anon_sym_LT] = ACTIONS(7093),
    [anon_sym_LT_EQ] = ACTIONS(7095),
    [anon_sym_GT] = ACTIONS(7093),
    [anon_sym_GT_EQ] = ACTIONS(7095),
    [anon_sym_EQ_EQ] = ACTIONS(7095),
    [anon_sym_BANG_EQ] = ACTIONS(7095),
    [anon_sym_STAR] = ACTIONS(7097),
    [anon_sym_SLASH] = ACTIONS(7099),
    [anon_sym_STAR_STAR] = ACTIONS(7101),
    [anon_sym_CARET] = ACTIONS(7101),
    [aux_sym_binary_operator_token1] = ACTIONS(7103),
    [anon_sym_PIPE_GT] = ACTIONS(7103),
    [anon_sym_COLON] = ACTIONS(7105),
    [anon_sym_DOLLAR] = ACTIONS(7107),
    [anon_sym_AT] = ACTIONS(7107),
    [aux_sym__hex_literal_token1] = ACTIONS(5413),
    [sym__number_literal] = ACTIONS(5415),
    [anon_sym_SQUOTE] = ACTIONS(5413),
    [anon_sym_DQUOTE] = ACTIONS(5413),
    [sym_return] = ACTIONS(5415),
    [sym_next] = ACTIONS(5415),
    [sym_break] = ACTIONS(5415),
    [sym_true] = ACTIONS(5415),
    [sym_false] = ACTIONS(5415),
    [sym_null] = ACTIONS(5415),
    [sym_inf] = ACTIONS(5415),
    [sym_nan] = ACTIONS(5415),
    [anon_sym_NA] = ACTIONS(5415),
    [anon_sym_NA_integer_] = ACTIONS(5415),
    [anon_sym_NA_real_] = ACTIONS(5415),
    [anon_sym_NA_complex_] = ACTIONS(5415),
    [anon_sym_NA_character_] = ACTIONS(5415),
    [sym_dots] = ACTIONS(5415),
    [sym_dot_dot_i] = ACTIONS(5413),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5413),
    [sym__semicolon] = ACTIONS(5413),
    [sym__raw_string_literal] = ACTIONS(5413),
    [sym__external_open_parenthesis] = ACTIONS(7109),
    [sym__external_open_brace] = ACTIONS(5413),
    [sym__external_open_bracket] = ACTIONS(7111),
    [sym__external_open_bracket2] = ACTIONS(7113),
  },
  [2075] = {
    [sym_identifier] = ACTIONS(7191),
    [anon_sym_BSLASH] = ACTIONS(7189),
    [anon_sym_function] = ACTIONS(7191),
    [anon_sym_EQ] = ACTIONS(7191),
    [anon_sym_if] = ACTIONS(7191),
    [anon_sym_for] = ACTIONS(7191),
    [anon_sym_while] = ACTIONS(7191),
    [anon_sym_repeat] = ACTIONS(7191),
    [anon_sym_QMARK] = ACTIONS(7189),
    [anon_sym_TILDE] = ACTIONS(7189),
    [anon_sym_BANG] = ACTIONS(7191),
    [anon_sym_PLUS] = ACTIONS(7189),
    [anon_sym_DASH] = ACTIONS(7191),
    [anon_sym_LT_DASH] = ACTIONS(7189),
    [anon_sym_LT_LT_DASH] = ACTIONS(7189),
    [anon_sym_COLON_EQ] = ACTIONS(7189),
    [anon_sym_DASH_GT] = ACTIONS(7191),
    [anon_sym_DASH_GT_GT] = ACTIONS(7189),
    [anon_sym_PIPE] = ACTIONS(7191),
    [anon_sym_AMP] = ACTIONS(7191),
    [anon_sym_PIPE_PIPE] = ACTIONS(7189),
    [anon_sym_AMP_AMP] = ACTIONS(7189),
    [anon_sym_LT] = ACTIONS(7191),
    [anon_sym_LT_EQ] = ACTIONS(7189),
    [anon_sym_GT] = ACTIONS(7191),
    [anon_sym_GT_EQ] = ACTIONS(7189),
    [anon_sym_EQ_EQ] = ACTIONS(7189),
    [anon_sym_BANG_EQ] = ACTIONS(7189),
    [anon_sym_STAR] = ACTIONS(7191),
    [anon_sym_SLASH] = ACTIONS(7189),
    [anon_sym_STAR_STAR] = ACTIONS(7189),
    [anon_sym_CARET] = ACTIONS(7189),
    [aux_sym_binary_operator_token1] = ACTIONS(7189),
    [anon_sym_PIPE_GT] = ACTIONS(7189),
    [anon_sym_COLON] = ACTIONS(7191),
    [anon_sym_DOLLAR] = ACTIONS(7189),
    [anon_sym_AT] = ACTIONS(7189),
    [anon_sym_COLON_COLON] = ACTIONS(7191),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7189),
    [aux_sym__hex_literal_token1] = ACTIONS(7189),
    [sym__number_literal] = ACTIONS(7191),
    [anon_sym_SQUOTE] = ACTIONS(7189),
    [anon_sym_DQUOTE] = ACTIONS(7189),
    [sym_return] = ACTIONS(7191),
    [sym_next] = ACTIONS(7191),
    [sym_break] = ACTIONS(7191),
    [sym_true] = ACTIONS(7191),
    [sym_false] = ACTIONS(7191),
    [sym_null] = ACTIONS(7191),
    [sym_inf] = ACTIONS(7191),
    [sym_nan] = ACTIONS(7191),
    [anon_sym_NA] = ACTIONS(7191),
    [anon_sym_NA_integer_] = ACTIONS(7191),
    [anon_sym_NA_real_] = ACTIONS(7191),
    [anon_sym_NA_complex_] = ACTIONS(7191),
    [anon_sym_NA_character_] = ACTIONS(7191),
    [sym_dots] = ACTIONS(7191),
    [sym_dot_dot_i] = ACTIONS(7189),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7189),
    [sym__newline] = ACTIONS(7189),
    [sym__semicolon] = ACTIONS(7189),
    [sym__raw_string_literal] = ACTIONS(7189),
    [sym__external_else] = ACTIONS(7189),
    [sym__external_open_parenthesis] = ACTIONS(7189),
    [sym__external_close_parenthesis] = ACTIONS(7189),
    [sym__external_open_brace] = ACTIONS(7189),
    [sym__external_close_brace] = ACTIONS(7189),
    [sym__external_open_bracket] = ACTIONS(7189),
    [sym__external_close_bracket] = ACTIONS(7189),
    [sym__external_open_bracket2] = ACTIONS(7189),
  },
  [2076] = {
    [sym_identifier] = ACTIONS(7195),
    [anon_sym_BSLASH] = ACTIONS(7193),
    [anon_sym_function] = ACTIONS(7195),
    [anon_sym_EQ] = ACTIONS(7195),
    [anon_sym_if] = ACTIONS(7195),
    [anon_sym_for] = ACTIONS(7195),
    [anon_sym_while] = ACTIONS(7195),
    [anon_sym_repeat] = ACTIONS(7195),
    [anon_sym_QMARK] = ACTIONS(7193),
    [anon_sym_TILDE] = ACTIONS(7193),
    [anon_sym_BANG] = ACTIONS(7195),
    [anon_sym_PLUS] = ACTIONS(7193),
    [anon_sym_DASH] = ACTIONS(7195),
    [anon_sym_LT_DASH] = ACTIONS(7193),
    [anon_sym_LT_LT_DASH] = ACTIONS(7193),
    [anon_sym_COLON_EQ] = ACTIONS(7193),
    [anon_sym_DASH_GT] = ACTIONS(7195),
    [anon_sym_DASH_GT_GT] = ACTIONS(7193),
    [anon_sym_PIPE] = ACTIONS(7195),
    [anon_sym_AMP] = ACTIONS(7195),
    [anon_sym_PIPE_PIPE] = ACTIONS(7193),
    [anon_sym_AMP_AMP] = ACTIONS(7193),
    [anon_sym_LT] = ACTIONS(7195),
    [anon_sym_LT_EQ] = ACTIONS(7193),
    [anon_sym_GT] = ACTIONS(7195),
    [anon_sym_GT_EQ] = ACTIONS(7193),
    [anon_sym_EQ_EQ] = ACTIONS(7193),
    [anon_sym_BANG_EQ] = ACTIONS(7193),
    [anon_sym_STAR] = ACTIONS(7195),
    [anon_sym_SLASH] = ACTIONS(7193),
    [anon_sym_STAR_STAR] = ACTIONS(7193),
    [anon_sym_CARET] = ACTIONS(7193),
    [aux_sym_binary_operator_token1] = ACTIONS(7193),
    [anon_sym_PIPE_GT] = ACTIONS(7193),
    [anon_sym_COLON] = ACTIONS(7195),
    [anon_sym_DOLLAR] = ACTIONS(7193),
    [anon_sym_AT] = ACTIONS(7193),
    [anon_sym_COLON_COLON] = ACTIONS(7195),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7193),
    [aux_sym__hex_literal_token1] = ACTIONS(7193),
    [sym__number_literal] = ACTIONS(7195),
    [anon_sym_SQUOTE] = ACTIONS(7193),
    [anon_sym_DQUOTE] = ACTIONS(7193),
    [sym_return] = ACTIONS(7195),
    [sym_next] = ACTIONS(7195),
    [sym_break] = ACTIONS(7195),
    [sym_true] = ACTIONS(7195),
    [sym_false] = ACTIONS(7195),
    [sym_null] = ACTIONS(7195),
    [sym_inf] = ACTIONS(7195),
    [sym_nan] = ACTIONS(7195),
    [anon_sym_NA] = ACTIONS(7195),
    [anon_sym_NA_integer_] = ACTIONS(7195),
    [anon_sym_NA_real_] = ACTIONS(7195),
    [anon_sym_NA_complex_] = ACTIONS(7195),
    [anon_sym_NA_character_] = ACTIONS(7195),
    [sym_dots] = ACTIONS(7195),
    [sym_dot_dot_i] = ACTIONS(7193),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7193),
    [sym__newline] = ACTIONS(7193),
    [sym__semicolon] = ACTIONS(7193),
    [sym__raw_string_literal] = ACTIONS(7193),
    [sym__external_else] = ACTIONS(7193),
    [sym__external_open_parenthesis] = ACTIONS(7193),
    [sym__external_close_parenthesis] = ACTIONS(7193),
    [sym__external_open_brace] = ACTIONS(7193),
    [sym__external_close_brace] = ACTIONS(7193),
    [sym__external_open_bracket] = ACTIONS(7193),
    [sym__external_close_bracket] = ACTIONS(7193),
    [sym__external_open_bracket2] = ACTIONS(7193),
  },
  [2077] = {
    [sym_call_arguments] = STATE(3027),
    [sym_subset_arguments] = STATE(3026),
    [sym_subset2_arguments] = STATE(3025),
    [sym__open_parenthesis] = STATE(1616),
    [sym__open_bracket] = STATE(1615),
    [sym__open_bracket2] = STATE(1613),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(7065),
    [anon_sym_CARET] = ACTIONS(7065),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(5261),
    [anon_sym_DOLLAR] = ACTIONS(7071),
    [anon_sym_AT] = ACTIONS(7071),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(7073),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(7075),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(7077),
  },
  [2078] = {
    [sym_call_arguments] = STATE(3027),
    [sym_subset_arguments] = STATE(3026),
    [sym_subset2_arguments] = STATE(3025),
    [sym__open_parenthesis] = STATE(1616),
    [sym__open_bracket] = STATE(1615),
    [sym__open_bracket2] = STATE(1613),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(7065),
    [anon_sym_CARET] = ACTIONS(7065),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(7069),
    [anon_sym_DOLLAR] = ACTIONS(7071),
    [anon_sym_AT] = ACTIONS(7071),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(7073),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(7075),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(7077),
  },
  [2079] = {
    [sym_call_arguments] = STATE(2941),
    [sym_subset_arguments] = STATE(2942),
    [sym_subset2_arguments] = STATE(2943),
    [sym__open_parenthesis] = STATE(1755),
    [sym__open_bracket] = STATE(1763),
    [sym__open_bracket2] = STATE(1866),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(6923),
    [anon_sym_DASH] = ACTIONS(6925),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(6933),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(6937),
    [anon_sym_LT] = ACTIONS(6939),
    [anon_sym_LT_EQ] = ACTIONS(6941),
    [anon_sym_GT] = ACTIONS(6939),
    [anon_sym_GT_EQ] = ACTIONS(6941),
    [anon_sym_EQ_EQ] = ACTIONS(6941),
    [anon_sym_BANG_EQ] = ACTIONS(6941),
    [anon_sym_STAR] = ACTIONS(6943),
    [anon_sym_SLASH] = ACTIONS(6945),
    [anon_sym_STAR_STAR] = ACTIONS(6947),
    [anon_sym_CARET] = ACTIONS(6947),
    [aux_sym_binary_operator_token1] = ACTIONS(6949),
    [anon_sym_PIPE_GT] = ACTIONS(6949),
    [anon_sym_COLON] = ACTIONS(6951),
    [anon_sym_DOLLAR] = ACTIONS(6953),
    [anon_sym_AT] = ACTIONS(6953),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6955),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6957),
    [sym__external_open_bracket2] = ACTIONS(6959),
  },
  [2080] = {
    [sym_call_arguments] = STATE(3027),
    [sym_subset_arguments] = STATE(3026),
    [sym_subset2_arguments] = STATE(3025),
    [sym__open_parenthesis] = STATE(1616),
    [sym__open_bracket] = STATE(1615),
    [sym__open_bracket2] = STATE(1613),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(7065),
    [anon_sym_CARET] = ACTIONS(7065),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(5261),
    [anon_sym_DOLLAR] = ACTIONS(7071),
    [anon_sym_AT] = ACTIONS(7071),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(7073),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(7075),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(7077),
  },
  [2081] = {
    [sym_call_arguments] = STATE(2941),
    [sym_subset_arguments] = STATE(2942),
    [sym_subset2_arguments] = STATE(2943),
    [sym__open_parenthesis] = STATE(1755),
    [sym__open_bracket] = STATE(1763),
    [sym__open_bracket2] = STATE(1866),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(6923),
    [anon_sym_DASH] = ACTIONS(6925),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(6939),
    [anon_sym_LT_EQ] = ACTIONS(6941),
    [anon_sym_GT] = ACTIONS(6939),
    [anon_sym_GT_EQ] = ACTIONS(6941),
    [anon_sym_EQ_EQ] = ACTIONS(6941),
    [anon_sym_BANG_EQ] = ACTIONS(6941),
    [anon_sym_STAR] = ACTIONS(6943),
    [anon_sym_SLASH] = ACTIONS(6945),
    [anon_sym_STAR_STAR] = ACTIONS(6947),
    [anon_sym_CARET] = ACTIONS(6947),
    [aux_sym_binary_operator_token1] = ACTIONS(6949),
    [anon_sym_PIPE_GT] = ACTIONS(6949),
    [anon_sym_COLON] = ACTIONS(6951),
    [anon_sym_DOLLAR] = ACTIONS(6953),
    [anon_sym_AT] = ACTIONS(6953),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6955),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6957),
    [sym__external_open_bracket2] = ACTIONS(6959),
  },
  [2082] = {
    [sym_call_arguments] = STATE(2941),
    [sym_subset_arguments] = STATE(2942),
    [sym_subset2_arguments] = STATE(2943),
    [sym__open_parenthesis] = STATE(1755),
    [sym__open_bracket] = STATE(1763),
    [sym__open_bracket2] = STATE(1866),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(6923),
    [anon_sym_DASH] = ACTIONS(6925),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(6943),
    [anon_sym_SLASH] = ACTIONS(6945),
    [anon_sym_STAR_STAR] = ACTIONS(6947),
    [anon_sym_CARET] = ACTIONS(6947),
    [aux_sym_binary_operator_token1] = ACTIONS(6949),
    [anon_sym_PIPE_GT] = ACTIONS(6949),
    [anon_sym_COLON] = ACTIONS(6951),
    [anon_sym_DOLLAR] = ACTIONS(6953),
    [anon_sym_AT] = ACTIONS(6953),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6955),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6957),
    [sym__external_open_bracket2] = ACTIONS(6959),
  },
  [2083] = {
    [sym_call_arguments] = STATE(2941),
    [sym_subset_arguments] = STATE(2942),
    [sym_subset2_arguments] = STATE(2943),
    [sym__open_parenthesis] = STATE(1755),
    [sym__open_bracket] = STATE(1763),
    [sym__open_bracket2] = STATE(1866),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(6947),
    [anon_sym_CARET] = ACTIONS(6947),
    [aux_sym_binary_operator_token1] = ACTIONS(6949),
    [anon_sym_PIPE_GT] = ACTIONS(6949),
    [anon_sym_COLON] = ACTIONS(6951),
    [anon_sym_DOLLAR] = ACTIONS(6953),
    [anon_sym_AT] = ACTIONS(6953),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6955),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6957),
    [sym__external_open_bracket2] = ACTIONS(6959),
  },
  [2084] = {
    [sym_call_arguments] = STATE(2978),
    [sym_subset_arguments] = STATE(2977),
    [sym_subset2_arguments] = STATE(2976),
    [sym__open_parenthesis] = STATE(1606),
    [sym__open_bracket] = STATE(1598),
    [sym__open_bracket2] = STATE(1592),
    [sym_identifier] = ACTIONS(5427),
    [anon_sym_BSLASH] = ACTIONS(5425),
    [anon_sym_function] = ACTIONS(5427),
    [anon_sym_EQ] = ACTIONS(6875),
    [anon_sym_if] = ACTIONS(5427),
    [anon_sym_for] = ACTIONS(5427),
    [anon_sym_while] = ACTIONS(5427),
    [anon_sym_repeat] = ACTIONS(5427),
    [anon_sym_QMARK] = ACTIONS(5425),
    [anon_sym_TILDE] = ACTIONS(6877),
    [anon_sym_BANG] = ACTIONS(5427),
    [anon_sym_PLUS] = ACTIONS(6879),
    [anon_sym_DASH] = ACTIONS(6881),
    [anon_sym_LT_DASH] = ACTIONS(6883),
    [anon_sym_LT_LT_DASH] = ACTIONS(6883),
    [anon_sym_COLON_EQ] = ACTIONS(6883),
    [anon_sym_DASH_GT] = ACTIONS(6885),
    [anon_sym_DASH_GT_GT] = ACTIONS(6887),
    [anon_sym_PIPE] = ACTIONS(6889),
    [anon_sym_AMP] = ACTIONS(6891),
    [anon_sym_PIPE_PIPE] = ACTIONS(6893),
    [anon_sym_AMP_AMP] = ACTIONS(6895),
    [anon_sym_LT] = ACTIONS(6897),
    [anon_sym_LT_EQ] = ACTIONS(6899),
    [anon_sym_GT] = ACTIONS(6897),
    [anon_sym_GT_EQ] = ACTIONS(6899),
    [anon_sym_EQ_EQ] = ACTIONS(6899),
    [anon_sym_BANG_EQ] = ACTIONS(6899),
    [anon_sym_STAR] = ACTIONS(6901),
    [anon_sym_SLASH] = ACTIONS(6903),
    [anon_sym_STAR_STAR] = ACTIONS(6905),
    [anon_sym_CARET] = ACTIONS(6905),
    [aux_sym_binary_operator_token1] = ACTIONS(6907),
    [anon_sym_PIPE_GT] = ACTIONS(6907),
    [anon_sym_COLON] = ACTIONS(6909),
    [anon_sym_DOLLAR] = ACTIONS(6911),
    [anon_sym_AT] = ACTIONS(6911),
    [aux_sym__hex_literal_token1] = ACTIONS(5425),
    [sym__number_literal] = ACTIONS(5427),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_DQUOTE] = ACTIONS(5425),
    [sym_return] = ACTIONS(5427),
    [sym_next] = ACTIONS(5427),
    [sym_break] = ACTIONS(5427),
    [sym_true] = ACTIONS(5427),
    [sym_false] = ACTIONS(5427),
    [sym_null] = ACTIONS(5427),
    [sym_inf] = ACTIONS(5427),
    [sym_nan] = ACTIONS(5427),
    [anon_sym_NA] = ACTIONS(5427),
    [anon_sym_NA_integer_] = ACTIONS(5427),
    [anon_sym_NA_real_] = ACTIONS(5427),
    [anon_sym_NA_complex_] = ACTIONS(5427),
    [anon_sym_NA_character_] = ACTIONS(5427),
    [sym_dots] = ACTIONS(5427),
    [sym_dot_dot_i] = ACTIONS(5425),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5425),
    [sym__newline] = ACTIONS(5425),
    [sym__raw_string_literal] = ACTIONS(5425),
    [sym__external_open_parenthesis] = ACTIONS(6913),
    [sym__external_open_brace] = ACTIONS(5425),
    [sym__external_open_bracket] = ACTIONS(6915),
    [sym__external_open_bracket2] = ACTIONS(6917),
    [sym__external_close_bracket2] = ACTIONS(5425),
  },
  [2085] = {
    [sym_call_arguments] = STATE(2985),
    [sym_subset_arguments] = STATE(2986),
    [sym_subset2_arguments] = STATE(2987),
    [sym__open_parenthesis] = STATE(1414),
    [sym__open_bracket] = STATE(1416),
    [sym__open_bracket2] = STATE(1428),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(7101),
    [anon_sym_CARET] = ACTIONS(7101),
    [aux_sym_binary_operator_token1] = ACTIONS(7103),
    [anon_sym_PIPE_GT] = ACTIONS(7103),
    [anon_sym_COLON] = ACTIONS(7105),
    [anon_sym_DOLLAR] = ACTIONS(7107),
    [anon_sym_AT] = ACTIONS(7107),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(7109),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(7111),
    [sym__external_open_bracket2] = ACTIONS(7113),
  },
  [2086] = {
    [sym_call_arguments] = STATE(2978),
    [sym_subset_arguments] = STATE(2977),
    [sym_subset2_arguments] = STATE(2976),
    [sym__open_parenthesis] = STATE(1606),
    [sym__open_bracket] = STATE(1598),
    [sym__open_bracket2] = STATE(1592),
    [sym_identifier] = ACTIONS(5431),
    [anon_sym_BSLASH] = ACTIONS(5429),
    [anon_sym_function] = ACTIONS(5431),
    [anon_sym_EQ] = ACTIONS(6875),
    [anon_sym_if] = ACTIONS(5431),
    [anon_sym_for] = ACTIONS(5431),
    [anon_sym_while] = ACTIONS(5431),
    [anon_sym_repeat] = ACTIONS(5431),
    [anon_sym_QMARK] = ACTIONS(5429),
    [anon_sym_TILDE] = ACTIONS(6877),
    [anon_sym_BANG] = ACTIONS(5431),
    [anon_sym_PLUS] = ACTIONS(6879),
    [anon_sym_DASH] = ACTIONS(6881),
    [anon_sym_LT_DASH] = ACTIONS(6883),
    [anon_sym_LT_LT_DASH] = ACTIONS(6883),
    [anon_sym_COLON_EQ] = ACTIONS(6883),
    [anon_sym_DASH_GT] = ACTIONS(6885),
    [anon_sym_DASH_GT_GT] = ACTIONS(6887),
    [anon_sym_PIPE] = ACTIONS(6889),
    [anon_sym_AMP] = ACTIONS(6891),
    [anon_sym_PIPE_PIPE] = ACTIONS(6893),
    [anon_sym_AMP_AMP] = ACTIONS(6895),
    [anon_sym_LT] = ACTIONS(6897),
    [anon_sym_LT_EQ] = ACTIONS(6899),
    [anon_sym_GT] = ACTIONS(6897),
    [anon_sym_GT_EQ] = ACTIONS(6899),
    [anon_sym_EQ_EQ] = ACTIONS(6899),
    [anon_sym_BANG_EQ] = ACTIONS(6899),
    [anon_sym_STAR] = ACTIONS(6901),
    [anon_sym_SLASH] = ACTIONS(6903),
    [anon_sym_STAR_STAR] = ACTIONS(6905),
    [anon_sym_CARET] = ACTIONS(6905),
    [aux_sym_binary_operator_token1] = ACTIONS(6907),
    [anon_sym_PIPE_GT] = ACTIONS(6907),
    [anon_sym_COLON] = ACTIONS(6909),
    [anon_sym_DOLLAR] = ACTIONS(6911),
    [anon_sym_AT] = ACTIONS(6911),
    [aux_sym__hex_literal_token1] = ACTIONS(5429),
    [sym__number_literal] = ACTIONS(5431),
    [anon_sym_SQUOTE] = ACTIONS(5429),
    [anon_sym_DQUOTE] = ACTIONS(5429),
    [sym_return] = ACTIONS(5431),
    [sym_next] = ACTIONS(5431),
    [sym_break] = ACTIONS(5431),
    [sym_true] = ACTIONS(5431),
    [sym_false] = ACTIONS(5431),
    [sym_null] = ACTIONS(5431),
    [sym_inf] = ACTIONS(5431),
    [sym_nan] = ACTIONS(5431),
    [anon_sym_NA] = ACTIONS(5431),
    [anon_sym_NA_integer_] = ACTIONS(5431),
    [anon_sym_NA_real_] = ACTIONS(5431),
    [anon_sym_NA_complex_] = ACTIONS(5431),
    [anon_sym_NA_character_] = ACTIONS(5431),
    [sym_dots] = ACTIONS(5431),
    [sym_dot_dot_i] = ACTIONS(5429),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5429),
    [sym__newline] = ACTIONS(5429),
    [sym__raw_string_literal] = ACTIONS(5429),
    [sym__external_open_parenthesis] = ACTIONS(6913),
    [sym__external_open_brace] = ACTIONS(5429),
    [sym__external_open_bracket] = ACTIONS(6915),
    [sym__external_open_bracket2] = ACTIONS(6917),
    [sym__external_close_bracket2] = ACTIONS(5429),
  },
  [2087] = {
    [sym_call_arguments] = STATE(2978),
    [sym_subset_arguments] = STATE(2977),
    [sym_subset2_arguments] = STATE(2976),
    [sym__open_parenthesis] = STATE(1606),
    [sym__open_bracket] = STATE(1598),
    [sym__open_bracket2] = STATE(1592),
    [sym_identifier] = ACTIONS(5435),
    [anon_sym_BSLASH] = ACTIONS(5433),
    [anon_sym_function] = ACTIONS(5435),
    [anon_sym_EQ] = ACTIONS(6875),
    [anon_sym_if] = ACTIONS(5435),
    [anon_sym_for] = ACTIONS(5435),
    [anon_sym_while] = ACTIONS(5435),
    [anon_sym_repeat] = ACTIONS(5435),
    [anon_sym_QMARK] = ACTIONS(5433),
    [anon_sym_TILDE] = ACTIONS(6877),
    [anon_sym_BANG] = ACTIONS(5435),
    [anon_sym_PLUS] = ACTIONS(6879),
    [anon_sym_DASH] = ACTIONS(6881),
    [anon_sym_LT_DASH] = ACTIONS(6883),
    [anon_sym_LT_LT_DASH] = ACTIONS(6883),
    [anon_sym_COLON_EQ] = ACTIONS(6883),
    [anon_sym_DASH_GT] = ACTIONS(6885),
    [anon_sym_DASH_GT_GT] = ACTIONS(6887),
    [anon_sym_PIPE] = ACTIONS(6889),
    [anon_sym_AMP] = ACTIONS(6891),
    [anon_sym_PIPE_PIPE] = ACTIONS(6893),
    [anon_sym_AMP_AMP] = ACTIONS(6895),
    [anon_sym_LT] = ACTIONS(6897),
    [anon_sym_LT_EQ] = ACTIONS(6899),
    [anon_sym_GT] = ACTIONS(6897),
    [anon_sym_GT_EQ] = ACTIONS(6899),
    [anon_sym_EQ_EQ] = ACTIONS(6899),
    [anon_sym_BANG_EQ] = ACTIONS(6899),
    [anon_sym_STAR] = ACTIONS(6901),
    [anon_sym_SLASH] = ACTIONS(6903),
    [anon_sym_STAR_STAR] = ACTIONS(6905),
    [anon_sym_CARET] = ACTIONS(6905),
    [aux_sym_binary_operator_token1] = ACTIONS(6907),
    [anon_sym_PIPE_GT] = ACTIONS(6907),
    [anon_sym_COLON] = ACTIONS(6909),
    [anon_sym_DOLLAR] = ACTIONS(6911),
    [anon_sym_AT] = ACTIONS(6911),
    [aux_sym__hex_literal_token1] = ACTIONS(5433),
    [sym__number_literal] = ACTIONS(5435),
    [anon_sym_SQUOTE] = ACTIONS(5433),
    [anon_sym_DQUOTE] = ACTIONS(5433),
    [sym_return] = ACTIONS(5435),
    [sym_next] = ACTIONS(5435),
    [sym_break] = ACTIONS(5435),
    [sym_true] = ACTIONS(5435),
    [sym_false] = ACTIONS(5435),
    [sym_null] = ACTIONS(5435),
    [sym_inf] = ACTIONS(5435),
    [sym_nan] = ACTIONS(5435),
    [anon_sym_NA] = ACTIONS(5435),
    [anon_sym_NA_integer_] = ACTIONS(5435),
    [anon_sym_NA_real_] = ACTIONS(5435),
    [anon_sym_NA_complex_] = ACTIONS(5435),
    [anon_sym_NA_character_] = ACTIONS(5435),
    [sym_dots] = ACTIONS(5435),
    [sym_dot_dot_i] = ACTIONS(5433),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5433),
    [sym__newline] = ACTIONS(5433),
    [sym__raw_string_literal] = ACTIONS(5433),
    [sym__external_open_parenthesis] = ACTIONS(6913),
    [sym__external_open_brace] = ACTIONS(5433),
    [sym__external_open_bracket] = ACTIONS(6915),
    [sym__external_open_bracket2] = ACTIONS(6917),
    [sym__external_close_bracket2] = ACTIONS(5433),
  },
  [2088] = {
    [sym_call_arguments] = STATE(2978),
    [sym_subset_arguments] = STATE(2977),
    [sym_subset2_arguments] = STATE(2976),
    [sym__open_parenthesis] = STATE(1606),
    [sym__open_bracket] = STATE(1598),
    [sym__open_bracket2] = STATE(1592),
    [sym_identifier] = ACTIONS(5439),
    [anon_sym_BSLASH] = ACTIONS(5437),
    [anon_sym_function] = ACTIONS(5439),
    [anon_sym_EQ] = ACTIONS(6875),
    [anon_sym_if] = ACTIONS(5439),
    [anon_sym_for] = ACTIONS(5439),
    [anon_sym_while] = ACTIONS(5439),
    [anon_sym_repeat] = ACTIONS(5439),
    [anon_sym_QMARK] = ACTIONS(5437),
    [anon_sym_TILDE] = ACTIONS(6877),
    [anon_sym_BANG] = ACTIONS(5439),
    [anon_sym_PLUS] = ACTIONS(6879),
    [anon_sym_DASH] = ACTIONS(6881),
    [anon_sym_LT_DASH] = ACTIONS(6883),
    [anon_sym_LT_LT_DASH] = ACTIONS(6883),
    [anon_sym_COLON_EQ] = ACTIONS(6883),
    [anon_sym_DASH_GT] = ACTIONS(6885),
    [anon_sym_DASH_GT_GT] = ACTIONS(6887),
    [anon_sym_PIPE] = ACTIONS(6889),
    [anon_sym_AMP] = ACTIONS(6891),
    [anon_sym_PIPE_PIPE] = ACTIONS(6893),
    [anon_sym_AMP_AMP] = ACTIONS(6895),
    [anon_sym_LT] = ACTIONS(6897),
    [anon_sym_LT_EQ] = ACTIONS(6899),
    [anon_sym_GT] = ACTIONS(6897),
    [anon_sym_GT_EQ] = ACTIONS(6899),
    [anon_sym_EQ_EQ] = ACTIONS(6899),
    [anon_sym_BANG_EQ] = ACTIONS(6899),
    [anon_sym_STAR] = ACTIONS(6901),
    [anon_sym_SLASH] = ACTIONS(6903),
    [anon_sym_STAR_STAR] = ACTIONS(6905),
    [anon_sym_CARET] = ACTIONS(6905),
    [aux_sym_binary_operator_token1] = ACTIONS(6907),
    [anon_sym_PIPE_GT] = ACTIONS(6907),
    [anon_sym_COLON] = ACTIONS(6909),
    [anon_sym_DOLLAR] = ACTIONS(6911),
    [anon_sym_AT] = ACTIONS(6911),
    [aux_sym__hex_literal_token1] = ACTIONS(5437),
    [sym__number_literal] = ACTIONS(5439),
    [anon_sym_SQUOTE] = ACTIONS(5437),
    [anon_sym_DQUOTE] = ACTIONS(5437),
    [sym_return] = ACTIONS(5439),
    [sym_next] = ACTIONS(5439),
    [sym_break] = ACTIONS(5439),
    [sym_true] = ACTIONS(5439),
    [sym_false] = ACTIONS(5439),
    [sym_null] = ACTIONS(5439),
    [sym_inf] = ACTIONS(5439),
    [sym_nan] = ACTIONS(5439),
    [anon_sym_NA] = ACTIONS(5439),
    [anon_sym_NA_integer_] = ACTIONS(5439),
    [anon_sym_NA_real_] = ACTIONS(5439),
    [anon_sym_NA_complex_] = ACTIONS(5439),
    [anon_sym_NA_character_] = ACTIONS(5439),
    [sym_dots] = ACTIONS(5439),
    [sym_dot_dot_i] = ACTIONS(5437),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5437),
    [sym__newline] = ACTIONS(5437),
    [sym__raw_string_literal] = ACTIONS(5437),
    [sym__external_open_parenthesis] = ACTIONS(6913),
    [sym__external_open_brace] = ACTIONS(5437),
    [sym__external_open_bracket] = ACTIONS(6915),
    [sym__external_open_bracket2] = ACTIONS(6917),
    [sym__external_close_bracket2] = ACTIONS(5437),
  },
  [2089] = {
    [sym_call_arguments] = STATE(3027),
    [sym_subset_arguments] = STATE(3026),
    [sym_subset2_arguments] = STATE(3025),
    [sym__open_parenthesis] = STATE(1616),
    [sym__open_bracket] = STATE(1615),
    [sym__open_bracket2] = STATE(1613),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(7039),
    [anon_sym_DASH] = ACTIONS(7041),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(7061),
    [anon_sym_SLASH] = ACTIONS(7063),
    [anon_sym_STAR_STAR] = ACTIONS(7065),
    [anon_sym_CARET] = ACTIONS(7065),
    [aux_sym_binary_operator_token1] = ACTIONS(7067),
    [anon_sym_PIPE_GT] = ACTIONS(7067),
    [anon_sym_COLON] = ACTIONS(7069),
    [anon_sym_DOLLAR] = ACTIONS(7071),
    [anon_sym_AT] = ACTIONS(7071),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(7073),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(7075),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(7077),
  },
  [2090] = {
    [sym_call_arguments] = STATE(2941),
    [sym_subset_arguments] = STATE(2942),
    [sym_subset2_arguments] = STATE(2943),
    [sym__open_parenthesis] = STATE(1755),
    [sym__open_bracket] = STATE(1763),
    [sym__open_bracket2] = STATE(1866),
    [sym_identifier] = ACTIONS(5339),
    [anon_sym_BSLASH] = ACTIONS(5337),
    [anon_sym_function] = ACTIONS(5339),
    [anon_sym_EQ] = ACTIONS(6919),
    [anon_sym_if] = ACTIONS(5339),
    [anon_sym_for] = ACTIONS(5339),
    [anon_sym_while] = ACTIONS(5339),
    [anon_sym_repeat] = ACTIONS(5339),
    [anon_sym_QMARK] = ACTIONS(5337),
    [anon_sym_TILDE] = ACTIONS(6921),
    [anon_sym_BANG] = ACTIONS(5339),
    [anon_sym_PLUS] = ACTIONS(6923),
    [anon_sym_DASH] = ACTIONS(6925),
    [anon_sym_LT_DASH] = ACTIONS(7147),
    [anon_sym_LT_LT_DASH] = ACTIONS(7147),
    [anon_sym_COLON_EQ] = ACTIONS(7147),
    [anon_sym_DASH_GT] = ACTIONS(6927),
    [anon_sym_DASH_GT_GT] = ACTIONS(6929),
    [anon_sym_PIPE] = ACTIONS(6931),
    [anon_sym_AMP] = ACTIONS(6933),
    [anon_sym_PIPE_PIPE] = ACTIONS(6935),
    [anon_sym_AMP_AMP] = ACTIONS(6937),
    [anon_sym_LT] = ACTIONS(6939),
    [anon_sym_LT_EQ] = ACTIONS(6941),
    [anon_sym_GT] = ACTIONS(6939),
    [anon_sym_GT_EQ] = ACTIONS(6941),
    [anon_sym_EQ_EQ] = ACTIONS(6941),
    [anon_sym_BANG_EQ] = ACTIONS(6941),
    [anon_sym_STAR] = ACTIONS(6943),
    [anon_sym_SLASH] = ACTIONS(6945),
    [anon_sym_STAR_STAR] = ACTIONS(6947),
    [anon_sym_CARET] = ACTIONS(6947),
    [aux_sym_binary_operator_token1] = ACTIONS(6949),
    [anon_sym_PIPE_GT] = ACTIONS(6949),
    [anon_sym_COLON] = ACTIONS(6951),
    [anon_sym_DOLLAR] = ACTIONS(6953),
    [anon_sym_AT] = ACTIONS(6953),
    [aux_sym__hex_literal_token1] = ACTIONS(5337),
    [sym__number_literal] = ACTIONS(5339),
    [anon_sym_SQUOTE] = ACTIONS(5337),
    [anon_sym_DQUOTE] = ACTIONS(5337),
    [sym_return] = ACTIONS(5339),
    [sym_next] = ACTIONS(5339),
    [sym_break] = ACTIONS(5339),
    [sym_true] = ACTIONS(5339),
    [sym_false] = ACTIONS(5339),
    [sym_null] = ACTIONS(5339),
    [sym_inf] = ACTIONS(5339),
    [sym_nan] = ACTIONS(5339),
    [anon_sym_NA] = ACTIONS(5339),
    [anon_sym_NA_integer_] = ACTIONS(5339),
    [anon_sym_NA_real_] = ACTIONS(5339),
    [anon_sym_NA_complex_] = ACTIONS(5339),
    [anon_sym_NA_character_] = ACTIONS(5339),
    [sym_dots] = ACTIONS(5339),
    [sym_dot_dot_i] = ACTIONS(5337),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5337),
    [sym__newline] = ACTIONS(5337),
    [sym__raw_string_literal] = ACTIONS(5337),
    [sym__external_open_parenthesis] = ACTIONS(6955),
    [sym__external_close_parenthesis] = ACTIONS(5337),
    [sym__external_open_brace] = ACTIONS(5337),
    [sym__external_open_bracket] = ACTIONS(6957),
    [sym__external_open_bracket2] = ACTIONS(6959),
  },
  [2091] = {
    [sym_call_arguments] = STATE(3027),
    [sym_subset_arguments] = STATE(3026),
    [sym_subset2_arguments] = STATE(3025),
    [sym__open_parenthesis] = STATE(1616),
    [sym__open_bracket] = STATE(1615),
    [sym__open_bracket2] = STATE(1613),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(7039),
    [anon_sym_DASH] = ACTIONS(7041),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(7057),
    [anon_sym_LT_EQ] = ACTIONS(7059),
    [anon_sym_GT] = ACTIONS(7057),
    [anon_sym_GT_EQ] = ACTIONS(7059),
    [anon_sym_EQ_EQ] = ACTIONS(7059),
    [anon_sym_BANG_EQ] = ACTIONS(7059),
    [anon_sym_STAR] = ACTIONS(7061),
    [anon_sym_SLASH] = ACTIONS(7063),
    [anon_sym_STAR_STAR] = ACTIONS(7065),
    [anon_sym_CARET] = ACTIONS(7065),
    [aux_sym_binary_operator_token1] = ACTIONS(7067),
    [anon_sym_PIPE_GT] = ACTIONS(7067),
    [anon_sym_COLON] = ACTIONS(7069),
    [anon_sym_DOLLAR] = ACTIONS(7071),
    [anon_sym_AT] = ACTIONS(7071),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(7073),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(7075),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(7077),
  },
  [2092] = {
    [sym_call_arguments] = STATE(2941),
    [sym_subset_arguments] = STATE(2942),
    [sym_subset2_arguments] = STATE(2943),
    [sym__open_parenthesis] = STATE(1755),
    [sym__open_bracket] = STATE(1763),
    [sym__open_bracket2] = STATE(1866),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(6919),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(6921),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(6923),
    [anon_sym_DASH] = ACTIONS(6925),
    [anon_sym_LT_DASH] = ACTIONS(7147),
    [anon_sym_LT_LT_DASH] = ACTIONS(7147),
    [anon_sym_COLON_EQ] = ACTIONS(7147),
    [anon_sym_DASH_GT] = ACTIONS(6927),
    [anon_sym_DASH_GT_GT] = ACTIONS(6929),
    [anon_sym_PIPE] = ACTIONS(6931),
    [anon_sym_AMP] = ACTIONS(6933),
    [anon_sym_PIPE_PIPE] = ACTIONS(6935),
    [anon_sym_AMP_AMP] = ACTIONS(6937),
    [anon_sym_LT] = ACTIONS(6939),
    [anon_sym_LT_EQ] = ACTIONS(6941),
    [anon_sym_GT] = ACTIONS(6939),
    [anon_sym_GT_EQ] = ACTIONS(6941),
    [anon_sym_EQ_EQ] = ACTIONS(6941),
    [anon_sym_BANG_EQ] = ACTIONS(6941),
    [anon_sym_STAR] = ACTIONS(6943),
    [anon_sym_SLASH] = ACTIONS(6945),
    [anon_sym_STAR_STAR] = ACTIONS(6947),
    [anon_sym_CARET] = ACTIONS(6947),
    [aux_sym_binary_operator_token1] = ACTIONS(6949),
    [anon_sym_PIPE_GT] = ACTIONS(6949),
    [anon_sym_COLON] = ACTIONS(6951),
    [anon_sym_DOLLAR] = ACTIONS(6953),
    [anon_sym_AT] = ACTIONS(6953),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6955),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6957),
    [sym__external_open_bracket2] = ACTIONS(6959),
  },
  [2093] = {
    [sym_call_arguments] = STATE(3027),
    [sym_subset_arguments] = STATE(3026),
    [sym_subset2_arguments] = STATE(3025),
    [sym__open_parenthesis] = STATE(1616),
    [sym__open_bracket] = STATE(1615),
    [sym__open_bracket2] = STATE(1613),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(7039),
    [anon_sym_DASH] = ACTIONS(7041),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(7051),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(7055),
    [anon_sym_LT] = ACTIONS(7057),
    [anon_sym_LT_EQ] = ACTIONS(7059),
    [anon_sym_GT] = ACTIONS(7057),
    [anon_sym_GT_EQ] = ACTIONS(7059),
    [anon_sym_EQ_EQ] = ACTIONS(7059),
    [anon_sym_BANG_EQ] = ACTIONS(7059),
    [anon_sym_STAR] = ACTIONS(7061),
    [anon_sym_SLASH] = ACTIONS(7063),
    [anon_sym_STAR_STAR] = ACTIONS(7065),
    [anon_sym_CARET] = ACTIONS(7065),
    [aux_sym_binary_operator_token1] = ACTIONS(7067),
    [anon_sym_PIPE_GT] = ACTIONS(7067),
    [anon_sym_COLON] = ACTIONS(7069),
    [anon_sym_DOLLAR] = ACTIONS(7071),
    [anon_sym_AT] = ACTIONS(7071),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(7073),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(7075),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(7077),
  },
  [2094] = {
    [sym_call_arguments] = STATE(2978),
    [sym_subset_arguments] = STATE(2977),
    [sym_subset2_arguments] = STATE(2976),
    [sym__open_parenthesis] = STATE(1606),
    [sym__open_bracket] = STATE(1598),
    [sym__open_bracket2] = STATE(1592),
    [sym_identifier] = ACTIONS(5443),
    [anon_sym_BSLASH] = ACTIONS(5441),
    [anon_sym_function] = ACTIONS(5443),
    [anon_sym_EQ] = ACTIONS(6875),
    [anon_sym_if] = ACTIONS(5443),
    [anon_sym_for] = ACTIONS(5443),
    [anon_sym_while] = ACTIONS(5443),
    [anon_sym_repeat] = ACTIONS(5443),
    [anon_sym_QMARK] = ACTIONS(5441),
    [anon_sym_TILDE] = ACTIONS(6877),
    [anon_sym_BANG] = ACTIONS(5443),
    [anon_sym_PLUS] = ACTIONS(6879),
    [anon_sym_DASH] = ACTIONS(6881),
    [anon_sym_LT_DASH] = ACTIONS(6883),
    [anon_sym_LT_LT_DASH] = ACTIONS(6883),
    [anon_sym_COLON_EQ] = ACTIONS(6883),
    [anon_sym_DASH_GT] = ACTIONS(6885),
    [anon_sym_DASH_GT_GT] = ACTIONS(6887),
    [anon_sym_PIPE] = ACTIONS(6889),
    [anon_sym_AMP] = ACTIONS(6891),
    [anon_sym_PIPE_PIPE] = ACTIONS(6893),
    [anon_sym_AMP_AMP] = ACTIONS(6895),
    [anon_sym_LT] = ACTIONS(6897),
    [anon_sym_LT_EQ] = ACTIONS(6899),
    [anon_sym_GT] = ACTIONS(6897),
    [anon_sym_GT_EQ] = ACTIONS(6899),
    [anon_sym_EQ_EQ] = ACTIONS(6899),
    [anon_sym_BANG_EQ] = ACTIONS(6899),
    [anon_sym_STAR] = ACTIONS(6901),
    [anon_sym_SLASH] = ACTIONS(6903),
    [anon_sym_STAR_STAR] = ACTIONS(6905),
    [anon_sym_CARET] = ACTIONS(6905),
    [aux_sym_binary_operator_token1] = ACTIONS(6907),
    [anon_sym_PIPE_GT] = ACTIONS(6907),
    [anon_sym_COLON] = ACTIONS(6909),
    [anon_sym_DOLLAR] = ACTIONS(6911),
    [anon_sym_AT] = ACTIONS(6911),
    [aux_sym__hex_literal_token1] = ACTIONS(5441),
    [sym__number_literal] = ACTIONS(5443),
    [anon_sym_SQUOTE] = ACTIONS(5441),
    [anon_sym_DQUOTE] = ACTIONS(5441),
    [sym_return] = ACTIONS(5443),
    [sym_next] = ACTIONS(5443),
    [sym_break] = ACTIONS(5443),
    [sym_true] = ACTIONS(5443),
    [sym_false] = ACTIONS(5443),
    [sym_null] = ACTIONS(5443),
    [sym_inf] = ACTIONS(5443),
    [sym_nan] = ACTIONS(5443),
    [anon_sym_NA] = ACTIONS(5443),
    [anon_sym_NA_integer_] = ACTIONS(5443),
    [anon_sym_NA_real_] = ACTIONS(5443),
    [anon_sym_NA_complex_] = ACTIONS(5443),
    [anon_sym_NA_character_] = ACTIONS(5443),
    [sym_dots] = ACTIONS(5443),
    [sym_dot_dot_i] = ACTIONS(5441),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5441),
    [sym__newline] = ACTIONS(5441),
    [sym__raw_string_literal] = ACTIONS(5441),
    [sym__external_open_parenthesis] = ACTIONS(6913),
    [sym__external_open_brace] = ACTIONS(5441),
    [sym__external_open_bracket] = ACTIONS(6915),
    [sym__external_open_bracket2] = ACTIONS(6917),
    [sym__external_close_bracket2] = ACTIONS(5441),
  },
  [2095] = {
    [sym_call_arguments] = STATE(3027),
    [sym_subset_arguments] = STATE(3026),
    [sym_subset2_arguments] = STATE(3025),
    [sym__open_parenthesis] = STATE(1616),
    [sym__open_bracket] = STATE(1615),
    [sym__open_bracket2] = STATE(1613),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(7037),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(7039),
    [anon_sym_DASH] = ACTIONS(7041),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(7049),
    [anon_sym_AMP] = ACTIONS(7051),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_AMP_AMP] = ACTIONS(7055),
    [anon_sym_LT] = ACTIONS(7057),
    [anon_sym_LT_EQ] = ACTIONS(7059),
    [anon_sym_GT] = ACTIONS(7057),
    [anon_sym_GT_EQ] = ACTIONS(7059),
    [anon_sym_EQ_EQ] = ACTIONS(7059),
    [anon_sym_BANG_EQ] = ACTIONS(7059),
    [anon_sym_STAR] = ACTIONS(7061),
    [anon_sym_SLASH] = ACTIONS(7063),
    [anon_sym_STAR_STAR] = ACTIONS(7065),
    [anon_sym_CARET] = ACTIONS(7065),
    [aux_sym_binary_operator_token1] = ACTIONS(7067),
    [anon_sym_PIPE_GT] = ACTIONS(7067),
    [anon_sym_COLON] = ACTIONS(7069),
    [anon_sym_DOLLAR] = ACTIONS(7071),
    [anon_sym_AT] = ACTIONS(7071),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(7073),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(7075),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(7077),
  },
  [2096] = {
    [sym_call_arguments] = STATE(2941),
    [sym_subset_arguments] = STATE(2942),
    [sym_subset2_arguments] = STATE(2943),
    [sym__open_parenthesis] = STATE(1755),
    [sym__open_bracket] = STATE(1763),
    [sym__open_bracket2] = STATE(1866),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(6947),
    [anon_sym_CARET] = ACTIONS(6947),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(5261),
    [anon_sym_DOLLAR] = ACTIONS(6953),
    [anon_sym_AT] = ACTIONS(6953),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6955),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6957),
    [sym__external_open_bracket2] = ACTIONS(6959),
  },
  [2097] = {
    [sym_string] = STATE(2841),
    [sym__single_quoted_string] = STATE(2442),
    [sym__double_quoted_string] = STATE(2437),
    [sym__string_or_identifier] = STATE(2841),
    [aux_sym_function_definition_repeat1] = STATE(2155),
    [sym_identifier] = ACTIONS(7291),
    [anon_sym_BSLASH] = ACTIONS(5659),
    [anon_sym_function] = ACTIONS(5663),
    [anon_sym_EQ] = ACTIONS(5663),
    [anon_sym_if] = ACTIONS(5663),
    [anon_sym_for] = ACTIONS(5663),
    [anon_sym_while] = ACTIONS(5663),
    [anon_sym_repeat] = ACTIONS(5663),
    [anon_sym_QMARK] = ACTIONS(5659),
    [anon_sym_TILDE] = ACTIONS(5659),
    [anon_sym_BANG] = ACTIONS(5663),
    [anon_sym_PLUS] = ACTIONS(5659),
    [anon_sym_DASH] = ACTIONS(5663),
    [anon_sym_LT_DASH] = ACTIONS(5659),
    [anon_sym_LT_LT_DASH] = ACTIONS(5659),
    [anon_sym_COLON_EQ] = ACTIONS(5659),
    [anon_sym_DASH_GT] = ACTIONS(5663),
    [anon_sym_DASH_GT_GT] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(5663),
    [anon_sym_AMP] = ACTIONS(5663),
    [anon_sym_PIPE_PIPE] = ACTIONS(5659),
    [anon_sym_AMP_AMP] = ACTIONS(5659),
    [anon_sym_LT] = ACTIONS(5663),
    [anon_sym_LT_EQ] = ACTIONS(5659),
    [anon_sym_GT] = ACTIONS(5663),
    [anon_sym_GT_EQ] = ACTIONS(5659),
    [anon_sym_EQ_EQ] = ACTIONS(5659),
    [anon_sym_BANG_EQ] = ACTIONS(5659),
    [anon_sym_STAR] = ACTIONS(5663),
    [anon_sym_SLASH] = ACTIONS(5659),
    [anon_sym_STAR_STAR] = ACTIONS(5659),
    [anon_sym_CARET] = ACTIONS(5659),
    [aux_sym_binary_operator_token1] = ACTIONS(5659),
    [anon_sym_PIPE_GT] = ACTIONS(5659),
    [anon_sym_COLON] = ACTIONS(5663),
    [anon_sym_DOLLAR] = ACTIONS(5659),
    [anon_sym_AT] = ACTIONS(5659),
    [aux_sym__hex_literal_token1] = ACTIONS(5659),
    [sym__number_literal] = ACTIONS(5663),
    [anon_sym_SQUOTE] = ACTIONS(2559),
    [anon_sym_DQUOTE] = ACTIONS(2561),
    [sym_return] = ACTIONS(5663),
    [sym_next] = ACTIONS(5663),
    [sym_break] = ACTIONS(5663),
    [sym_true] = ACTIONS(5663),
    [sym_false] = ACTIONS(5663),
    [sym_null] = ACTIONS(5663),
    [sym_inf] = ACTIONS(5663),
    [sym_nan] = ACTIONS(5663),
    [anon_sym_NA] = ACTIONS(5663),
    [anon_sym_NA_integer_] = ACTIONS(5663),
    [anon_sym_NA_real_] = ACTIONS(5663),
    [anon_sym_NA_complex_] = ACTIONS(5663),
    [anon_sym_NA_character_] = ACTIONS(5663),
    [sym_dots] = ACTIONS(5663),
    [sym_dot_dot_i] = ACTIONS(5659),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5659),
    [sym__newline] = ACTIONS(7293),
    [sym__raw_string_literal] = ACTIONS(2571),
    [sym__external_open_parenthesis] = ACTIONS(5659),
    [sym__external_close_parenthesis] = ACTIONS(5659),
    [sym__external_open_brace] = ACTIONS(5659),
    [sym__external_open_bracket] = ACTIONS(5659),
    [sym__external_close_bracket] = ACTIONS(5659),
    [sym__external_open_bracket2] = ACTIONS(5659),
  },
  [2098] = {
    [sym_string] = STATE(2694),
    [sym__single_quoted_string] = STATE(2355),
    [sym__double_quoted_string] = STATE(2354),
    [sym__string_or_identifier] = STATE(2694),
    [ts_builtin_sym_end] = ACTIONS(5883),
    [sym_identifier] = ACTIONS(7295),
    [anon_sym_BSLASH] = ACTIONS(5883),
    [anon_sym_function] = ACTIONS(5887),
    [anon_sym_EQ] = ACTIONS(5887),
    [anon_sym_if] = ACTIONS(5887),
    [anon_sym_for] = ACTIONS(5887),
    [anon_sym_while] = ACTIONS(5887),
    [anon_sym_repeat] = ACTIONS(5887),
    [anon_sym_QMARK] = ACTIONS(5883),
    [anon_sym_TILDE] = ACTIONS(5883),
    [anon_sym_BANG] = ACTIONS(5887),
    [anon_sym_PLUS] = ACTIONS(5883),
    [anon_sym_DASH] = ACTIONS(5887),
    [anon_sym_LT_DASH] = ACTIONS(5883),
    [anon_sym_LT_LT_DASH] = ACTIONS(5883),
    [anon_sym_COLON_EQ] = ACTIONS(5883),
    [anon_sym_DASH_GT] = ACTIONS(5887),
    [anon_sym_DASH_GT_GT] = ACTIONS(5883),
    [anon_sym_PIPE] = ACTIONS(5887),
    [anon_sym_AMP] = ACTIONS(5887),
    [anon_sym_PIPE_PIPE] = ACTIONS(5883),
    [anon_sym_AMP_AMP] = ACTIONS(5883),
    [anon_sym_LT] = ACTIONS(5887),
    [anon_sym_LT_EQ] = ACTIONS(5883),
    [anon_sym_GT] = ACTIONS(5887),
    [anon_sym_GT_EQ] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5883),
    [anon_sym_BANG_EQ] = ACTIONS(5883),
    [anon_sym_STAR] = ACTIONS(5887),
    [anon_sym_SLASH] = ACTIONS(5883),
    [anon_sym_STAR_STAR] = ACTIONS(5883),
    [anon_sym_CARET] = ACTIONS(5883),
    [aux_sym_binary_operator_token1] = ACTIONS(5883),
    [anon_sym_PIPE_GT] = ACTIONS(5883),
    [anon_sym_COLON] = ACTIONS(5887),
    [anon_sym_DOLLAR] = ACTIONS(5883),
    [anon_sym_AT] = ACTIONS(5883),
    [aux_sym__hex_literal_token1] = ACTIONS(5883),
    [sym__number_literal] = ACTIONS(5887),
    [anon_sym_SQUOTE] = ACTIONS(1365),
    [anon_sym_DQUOTE] = ACTIONS(1367),
    [sym_return] = ACTIONS(5887),
    [sym_next] = ACTIONS(5887),
    [sym_break] = ACTIONS(5887),
    [sym_true] = ACTIONS(5887),
    [sym_false] = ACTIONS(5887),
    [sym_null] = ACTIONS(5887),
    [sym_inf] = ACTIONS(5887),
    [sym_nan] = ACTIONS(5887),
    [anon_sym_NA] = ACTIONS(5887),
    [anon_sym_NA_integer_] = ACTIONS(5887),
    [anon_sym_NA_real_] = ACTIONS(5887),
    [anon_sym_NA_complex_] = ACTIONS(5887),
    [anon_sym_NA_character_] = ACTIONS(5887),
    [sym_dots] = ACTIONS(5887),
    [sym_dot_dot_i] = ACTIONS(5883),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5883),
    [sym__semicolon] = ACTIONS(5883),
    [sym__raw_string_literal] = ACTIONS(1377),
    [sym__external_else] = ACTIONS(5883),
    [sym__external_open_parenthesis] = ACTIONS(5883),
    [sym__external_close_parenthesis] = ACTIONS(5883),
    [sym__external_open_brace] = ACTIONS(5883),
    [sym__external_open_bracket] = ACTIONS(5883),
    [sym__external_open_bracket2] = ACTIONS(5883),
  },
  [2099] = {
    [sym_call_arguments] = STATE(2978),
    [sym_subset_arguments] = STATE(2977),
    [sym_subset2_arguments] = STATE(2976),
    [sym__open_parenthesis] = STATE(1606),
    [sym__open_bracket] = STATE(1598),
    [sym__open_bracket2] = STATE(1592),
    [sym_identifier] = ACTIONS(5447),
    [anon_sym_BSLASH] = ACTIONS(5445),
    [anon_sym_function] = ACTIONS(5447),
    [anon_sym_EQ] = ACTIONS(6875),
    [anon_sym_if] = ACTIONS(5447),
    [anon_sym_for] = ACTIONS(5447),
    [anon_sym_while] = ACTIONS(5447),
    [anon_sym_repeat] = ACTIONS(5447),
    [anon_sym_QMARK] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(6877),
    [anon_sym_BANG] = ACTIONS(5447),
    [anon_sym_PLUS] = ACTIONS(6879),
    [anon_sym_DASH] = ACTIONS(6881),
    [anon_sym_LT_DASH] = ACTIONS(6883),
    [anon_sym_LT_LT_DASH] = ACTIONS(6883),
    [anon_sym_COLON_EQ] = ACTIONS(6883),
    [anon_sym_DASH_GT] = ACTIONS(6885),
    [anon_sym_DASH_GT_GT] = ACTIONS(6887),
    [anon_sym_PIPE] = ACTIONS(6889),
    [anon_sym_AMP] = ACTIONS(6891),
    [anon_sym_PIPE_PIPE] = ACTIONS(6893),
    [anon_sym_AMP_AMP] = ACTIONS(6895),
    [anon_sym_LT] = ACTIONS(6897),
    [anon_sym_LT_EQ] = ACTIONS(6899),
    [anon_sym_GT] = ACTIONS(6897),
    [anon_sym_GT_EQ] = ACTIONS(6899),
    [anon_sym_EQ_EQ] = ACTIONS(6899),
    [anon_sym_BANG_EQ] = ACTIONS(6899),
    [anon_sym_STAR] = ACTIONS(6901),
    [anon_sym_SLASH] = ACTIONS(6903),
    [anon_sym_STAR_STAR] = ACTIONS(6905),
    [anon_sym_CARET] = ACTIONS(6905),
    [aux_sym_binary_operator_token1] = ACTIONS(6907),
    [anon_sym_PIPE_GT] = ACTIONS(6907),
    [anon_sym_COLON] = ACTIONS(6909),
    [anon_sym_DOLLAR] = ACTIONS(6911),
    [anon_sym_AT] = ACTIONS(6911),
    [aux_sym__hex_literal_token1] = ACTIONS(5445),
    [sym__number_literal] = ACTIONS(5447),
    [anon_sym_SQUOTE] = ACTIONS(5445),
    [anon_sym_DQUOTE] = ACTIONS(5445),
    [sym_return] = ACTIONS(5447),
    [sym_next] = ACTIONS(5447),
    [sym_break] = ACTIONS(5447),
    [sym_true] = ACTIONS(5447),
    [sym_false] = ACTIONS(5447),
    [sym_null] = ACTIONS(5447),
    [sym_inf] = ACTIONS(5447),
    [sym_nan] = ACTIONS(5447),
    [anon_sym_NA] = ACTIONS(5447),
    [anon_sym_NA_integer_] = ACTIONS(5447),
    [anon_sym_NA_real_] = ACTIONS(5447),
    [anon_sym_NA_complex_] = ACTIONS(5447),
    [anon_sym_NA_character_] = ACTIONS(5447),
    [sym_dots] = ACTIONS(5447),
    [sym_dot_dot_i] = ACTIONS(5445),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5445),
    [sym__newline] = ACTIONS(5445),
    [sym__raw_string_literal] = ACTIONS(5445),
    [sym__external_open_parenthesis] = ACTIONS(6913),
    [sym__external_open_brace] = ACTIONS(5445),
    [sym__external_open_bracket] = ACTIONS(6915),
    [sym__external_open_bracket2] = ACTIONS(6917),
    [sym__external_close_bracket2] = ACTIONS(5445),
  },
  [2100] = {
    [sym_call_arguments] = STATE(3027),
    [sym_subset_arguments] = STATE(3026),
    [sym_subset2_arguments] = STATE(3025),
    [sym__open_parenthesis] = STATE(1616),
    [sym__open_bracket] = STATE(1615),
    [sym__open_bracket2] = STATE(1613),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(7035),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(7037),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(7039),
    [anon_sym_DASH] = ACTIONS(7041),
    [anon_sym_LT_DASH] = ACTIONS(7043),
    [anon_sym_LT_LT_DASH] = ACTIONS(7043),
    [anon_sym_COLON_EQ] = ACTIONS(7043),
    [anon_sym_DASH_GT] = ACTIONS(7045),
    [anon_sym_DASH_GT_GT] = ACTIONS(7047),
    [anon_sym_PIPE] = ACTIONS(7049),
    [anon_sym_AMP] = ACTIONS(7051),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_AMP_AMP] = ACTIONS(7055),
    [anon_sym_LT] = ACTIONS(7057),
    [anon_sym_LT_EQ] = ACTIONS(7059),
    [anon_sym_GT] = ACTIONS(7057),
    [anon_sym_GT_EQ] = ACTIONS(7059),
    [anon_sym_EQ_EQ] = ACTIONS(7059),
    [anon_sym_BANG_EQ] = ACTIONS(7059),
    [anon_sym_STAR] = ACTIONS(7061),
    [anon_sym_SLASH] = ACTIONS(7063),
    [anon_sym_STAR_STAR] = ACTIONS(7065),
    [anon_sym_CARET] = ACTIONS(7065),
    [aux_sym_binary_operator_token1] = ACTIONS(7067),
    [anon_sym_PIPE_GT] = ACTIONS(7067),
    [anon_sym_COLON] = ACTIONS(7069),
    [anon_sym_DOLLAR] = ACTIONS(7071),
    [anon_sym_AT] = ACTIONS(7071),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(7073),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(7075),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(7077),
  },
  [2101] = {
    [sym_call_arguments] = STATE(3027),
    [sym_subset_arguments] = STATE(3026),
    [sym_subset2_arguments] = STATE(3025),
    [sym__open_parenthesis] = STATE(1616),
    [sym__open_bracket] = STATE(1615),
    [sym__open_bracket2] = STATE(1613),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(7061),
    [anon_sym_SLASH] = ACTIONS(7063),
    [anon_sym_STAR_STAR] = ACTIONS(7065),
    [anon_sym_CARET] = ACTIONS(7065),
    [aux_sym_binary_operator_token1] = ACTIONS(7067),
    [anon_sym_PIPE_GT] = ACTIONS(7067),
    [anon_sym_COLON] = ACTIONS(7069),
    [anon_sym_DOLLAR] = ACTIONS(7071),
    [anon_sym_AT] = ACTIONS(7071),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(7073),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(7075),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(7077),
  },
  [2102] = {
    [sym_call_arguments] = STATE(3027),
    [sym_subset_arguments] = STATE(3026),
    [sym_subset2_arguments] = STATE(3025),
    [sym__open_parenthesis] = STATE(1616),
    [sym__open_bracket] = STATE(1615),
    [sym__open_bracket2] = STATE(1613),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(7039),
    [anon_sym_DASH] = ACTIONS(7041),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(7049),
    [anon_sym_AMP] = ACTIONS(7051),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_AMP_AMP] = ACTIONS(7055),
    [anon_sym_LT] = ACTIONS(7057),
    [anon_sym_LT_EQ] = ACTIONS(7059),
    [anon_sym_GT] = ACTIONS(7057),
    [anon_sym_GT_EQ] = ACTIONS(7059),
    [anon_sym_EQ_EQ] = ACTIONS(7059),
    [anon_sym_BANG_EQ] = ACTIONS(7059),
    [anon_sym_STAR] = ACTIONS(7061),
    [anon_sym_SLASH] = ACTIONS(7063),
    [anon_sym_STAR_STAR] = ACTIONS(7065),
    [anon_sym_CARET] = ACTIONS(7065),
    [aux_sym_binary_operator_token1] = ACTIONS(7067),
    [anon_sym_PIPE_GT] = ACTIONS(7067),
    [anon_sym_COLON] = ACTIONS(7069),
    [anon_sym_DOLLAR] = ACTIONS(7071),
    [anon_sym_AT] = ACTIONS(7071),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(7073),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(7075),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(7077),
  },
  [2103] = {
    [sym_call_arguments] = STATE(3027),
    [sym_subset_arguments] = STATE(3026),
    [sym_subset2_arguments] = STATE(3025),
    [sym__open_parenthesis] = STATE(1616),
    [sym__open_bracket] = STATE(1615),
    [sym__open_bracket2] = STATE(1613),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(7035),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(7037),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(7039),
    [anon_sym_DASH] = ACTIONS(7041),
    [anon_sym_LT_DASH] = ACTIONS(7043),
    [anon_sym_LT_LT_DASH] = ACTIONS(7043),
    [anon_sym_COLON_EQ] = ACTIONS(7043),
    [anon_sym_DASH_GT] = ACTIONS(7045),
    [anon_sym_DASH_GT_GT] = ACTIONS(7047),
    [anon_sym_PIPE] = ACTIONS(7049),
    [anon_sym_AMP] = ACTIONS(7051),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_AMP_AMP] = ACTIONS(7055),
    [anon_sym_LT] = ACTIONS(7057),
    [anon_sym_LT_EQ] = ACTIONS(7059),
    [anon_sym_GT] = ACTIONS(7057),
    [anon_sym_GT_EQ] = ACTIONS(7059),
    [anon_sym_EQ_EQ] = ACTIONS(7059),
    [anon_sym_BANG_EQ] = ACTIONS(7059),
    [anon_sym_STAR] = ACTIONS(7061),
    [anon_sym_SLASH] = ACTIONS(7063),
    [anon_sym_STAR_STAR] = ACTIONS(7065),
    [anon_sym_CARET] = ACTIONS(7065),
    [aux_sym_binary_operator_token1] = ACTIONS(7067),
    [anon_sym_PIPE_GT] = ACTIONS(7067),
    [anon_sym_COLON] = ACTIONS(7069),
    [anon_sym_DOLLAR] = ACTIONS(7071),
    [anon_sym_AT] = ACTIONS(7071),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(7073),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(7075),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(7077),
  },
  [2104] = {
    [sym_call_arguments] = STATE(3027),
    [sym_subset_arguments] = STATE(3026),
    [sym_subset2_arguments] = STATE(3025),
    [sym__open_parenthesis] = STATE(1616),
    [sym__open_bracket] = STATE(1615),
    [sym__open_bracket2] = STATE(1613),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(7035),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(7037),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(7039),
    [anon_sym_DASH] = ACTIONS(7041),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(7045),
    [anon_sym_DASH_GT_GT] = ACTIONS(7047),
    [anon_sym_PIPE] = ACTIONS(7049),
    [anon_sym_AMP] = ACTIONS(7051),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_AMP_AMP] = ACTIONS(7055),
    [anon_sym_LT] = ACTIONS(7057),
    [anon_sym_LT_EQ] = ACTIONS(7059),
    [anon_sym_GT] = ACTIONS(7057),
    [anon_sym_GT_EQ] = ACTIONS(7059),
    [anon_sym_EQ_EQ] = ACTIONS(7059),
    [anon_sym_BANG_EQ] = ACTIONS(7059),
    [anon_sym_STAR] = ACTIONS(7061),
    [anon_sym_SLASH] = ACTIONS(7063),
    [anon_sym_STAR_STAR] = ACTIONS(7065),
    [anon_sym_CARET] = ACTIONS(7065),
    [aux_sym_binary_operator_token1] = ACTIONS(7067),
    [anon_sym_PIPE_GT] = ACTIONS(7067),
    [anon_sym_COLON] = ACTIONS(7069),
    [anon_sym_DOLLAR] = ACTIONS(7071),
    [anon_sym_AT] = ACTIONS(7071),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(7073),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(7075),
    [sym__external_close_bracket] = ACTIONS(5263),
    [sym__external_open_bracket2] = ACTIONS(7077),
  },
  [2105] = {
    [sym_call_arguments] = STATE(2978),
    [sym_subset_arguments] = STATE(2977),
    [sym_subset2_arguments] = STATE(2976),
    [sym__open_parenthesis] = STATE(1606),
    [sym__open_bracket] = STATE(1598),
    [sym__open_bracket2] = STATE(1592),
    [sym_identifier] = ACTIONS(5451),
    [anon_sym_BSLASH] = ACTIONS(5449),
    [anon_sym_function] = ACTIONS(5451),
    [anon_sym_EQ] = ACTIONS(6875),
    [anon_sym_if] = ACTIONS(5451),
    [anon_sym_for] = ACTIONS(5451),
    [anon_sym_while] = ACTIONS(5451),
    [anon_sym_repeat] = ACTIONS(5451),
    [anon_sym_QMARK] = ACTIONS(5449),
    [anon_sym_TILDE] = ACTIONS(6877),
    [anon_sym_BANG] = ACTIONS(5451),
    [anon_sym_PLUS] = ACTIONS(6879),
    [anon_sym_DASH] = ACTIONS(6881),
    [anon_sym_LT_DASH] = ACTIONS(6883),
    [anon_sym_LT_LT_DASH] = ACTIONS(6883),
    [anon_sym_COLON_EQ] = ACTIONS(6883),
    [anon_sym_DASH_GT] = ACTIONS(6885),
    [anon_sym_DASH_GT_GT] = ACTIONS(6887),
    [anon_sym_PIPE] = ACTIONS(6889),
    [anon_sym_AMP] = ACTIONS(6891),
    [anon_sym_PIPE_PIPE] = ACTIONS(6893),
    [anon_sym_AMP_AMP] = ACTIONS(6895),
    [anon_sym_LT] = ACTIONS(6897),
    [anon_sym_LT_EQ] = ACTIONS(6899),
    [anon_sym_GT] = ACTIONS(6897),
    [anon_sym_GT_EQ] = ACTIONS(6899),
    [anon_sym_EQ_EQ] = ACTIONS(6899),
    [anon_sym_BANG_EQ] = ACTIONS(6899),
    [anon_sym_STAR] = ACTIONS(6901),
    [anon_sym_SLASH] = ACTIONS(6903),
    [anon_sym_STAR_STAR] = ACTIONS(6905),
    [anon_sym_CARET] = ACTIONS(6905),
    [aux_sym_binary_operator_token1] = ACTIONS(6907),
    [anon_sym_PIPE_GT] = ACTIONS(6907),
    [anon_sym_COLON] = ACTIONS(6909),
    [anon_sym_DOLLAR] = ACTIONS(6911),
    [anon_sym_AT] = ACTIONS(6911),
    [aux_sym__hex_literal_token1] = ACTIONS(5449),
    [sym__number_literal] = ACTIONS(5451),
    [anon_sym_SQUOTE] = ACTIONS(5449),
    [anon_sym_DQUOTE] = ACTIONS(5449),
    [sym_return] = ACTIONS(5451),
    [sym_next] = ACTIONS(5451),
    [sym_break] = ACTIONS(5451),
    [sym_true] = ACTIONS(5451),
    [sym_false] = ACTIONS(5451),
    [sym_null] = ACTIONS(5451),
    [sym_inf] = ACTIONS(5451),
    [sym_nan] = ACTIONS(5451),
    [anon_sym_NA] = ACTIONS(5451),
    [anon_sym_NA_integer_] = ACTIONS(5451),
    [anon_sym_NA_real_] = ACTIONS(5451),
    [anon_sym_NA_complex_] = ACTIONS(5451),
    [anon_sym_NA_character_] = ACTIONS(5451),
    [sym_dots] = ACTIONS(5451),
    [sym_dot_dot_i] = ACTIONS(5449),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5449),
    [sym__newline] = ACTIONS(5449),
    [sym__raw_string_literal] = ACTIONS(5449),
    [sym__external_open_parenthesis] = ACTIONS(6913),
    [sym__external_open_brace] = ACTIONS(5449),
    [sym__external_open_bracket] = ACTIONS(6915),
    [sym__external_open_bracket2] = ACTIONS(6917),
    [sym__external_close_bracket2] = ACTIONS(5449),
  },
  [2106] = {
    [sym_call_arguments] = STATE(2978),
    [sym_subset_arguments] = STATE(2977),
    [sym_subset2_arguments] = STATE(2976),
    [sym__open_parenthesis] = STATE(1606),
    [sym__open_bracket] = STATE(1598),
    [sym__open_bracket2] = STATE(1592),
    [sym_identifier] = ACTIONS(5455),
    [anon_sym_BSLASH] = ACTIONS(5453),
    [anon_sym_function] = ACTIONS(5455),
    [anon_sym_EQ] = ACTIONS(6875),
    [anon_sym_if] = ACTIONS(5455),
    [anon_sym_for] = ACTIONS(5455),
    [anon_sym_while] = ACTIONS(5455),
    [anon_sym_repeat] = ACTIONS(5455),
    [anon_sym_QMARK] = ACTIONS(5453),
    [anon_sym_TILDE] = ACTIONS(6877),
    [anon_sym_BANG] = ACTIONS(5455),
    [anon_sym_PLUS] = ACTIONS(6879),
    [anon_sym_DASH] = ACTIONS(6881),
    [anon_sym_LT_DASH] = ACTIONS(6883),
    [anon_sym_LT_LT_DASH] = ACTIONS(6883),
    [anon_sym_COLON_EQ] = ACTIONS(6883),
    [anon_sym_DASH_GT] = ACTIONS(6885),
    [anon_sym_DASH_GT_GT] = ACTIONS(6887),
    [anon_sym_PIPE] = ACTIONS(6889),
    [anon_sym_AMP] = ACTIONS(6891),
    [anon_sym_PIPE_PIPE] = ACTIONS(6893),
    [anon_sym_AMP_AMP] = ACTIONS(6895),
    [anon_sym_LT] = ACTIONS(6897),
    [anon_sym_LT_EQ] = ACTIONS(6899),
    [anon_sym_GT] = ACTIONS(6897),
    [anon_sym_GT_EQ] = ACTIONS(6899),
    [anon_sym_EQ_EQ] = ACTIONS(6899),
    [anon_sym_BANG_EQ] = ACTIONS(6899),
    [anon_sym_STAR] = ACTIONS(6901),
    [anon_sym_SLASH] = ACTIONS(6903),
    [anon_sym_STAR_STAR] = ACTIONS(6905),
    [anon_sym_CARET] = ACTIONS(6905),
    [aux_sym_binary_operator_token1] = ACTIONS(6907),
    [anon_sym_PIPE_GT] = ACTIONS(6907),
    [anon_sym_COLON] = ACTIONS(6909),
    [anon_sym_DOLLAR] = ACTIONS(6911),
    [anon_sym_AT] = ACTIONS(6911),
    [aux_sym__hex_literal_token1] = ACTIONS(5453),
    [sym__number_literal] = ACTIONS(5455),
    [anon_sym_SQUOTE] = ACTIONS(5453),
    [anon_sym_DQUOTE] = ACTIONS(5453),
    [sym_return] = ACTIONS(5455),
    [sym_next] = ACTIONS(5455),
    [sym_break] = ACTIONS(5455),
    [sym_true] = ACTIONS(5455),
    [sym_false] = ACTIONS(5455),
    [sym_null] = ACTIONS(5455),
    [sym_inf] = ACTIONS(5455),
    [sym_nan] = ACTIONS(5455),
    [anon_sym_NA] = ACTIONS(5455),
    [anon_sym_NA_integer_] = ACTIONS(5455),
    [anon_sym_NA_real_] = ACTIONS(5455),
    [anon_sym_NA_complex_] = ACTIONS(5455),
    [anon_sym_NA_character_] = ACTIONS(5455),
    [sym_dots] = ACTIONS(5455),
    [sym_dot_dot_i] = ACTIONS(5453),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5453),
    [sym__newline] = ACTIONS(5453),
    [sym__raw_string_literal] = ACTIONS(5453),
    [sym__external_open_parenthesis] = ACTIONS(6913),
    [sym__external_open_brace] = ACTIONS(5453),
    [sym__external_open_bracket] = ACTIONS(6915),
    [sym__external_open_bracket2] = ACTIONS(6917),
    [sym__external_close_bracket2] = ACTIONS(5453),
  },
  [2107] = {
    [sym_call_arguments] = STATE(2978),
    [sym_subset_arguments] = STATE(2977),
    [sym_subset2_arguments] = STATE(2976),
    [sym__open_parenthesis] = STATE(1606),
    [sym__open_bracket] = STATE(1598),
    [sym__open_bracket2] = STATE(1592),
    [sym_identifier] = ACTIONS(5411),
    [anon_sym_BSLASH] = ACTIONS(5409),
    [anon_sym_function] = ACTIONS(5411),
    [anon_sym_EQ] = ACTIONS(6875),
    [anon_sym_if] = ACTIONS(5411),
    [anon_sym_for] = ACTIONS(5411),
    [anon_sym_while] = ACTIONS(5411),
    [anon_sym_repeat] = ACTIONS(5411),
    [anon_sym_QMARK] = ACTIONS(5409),
    [anon_sym_TILDE] = ACTIONS(6877),
    [anon_sym_BANG] = ACTIONS(5411),
    [anon_sym_PLUS] = ACTIONS(6879),
    [anon_sym_DASH] = ACTIONS(6881),
    [anon_sym_LT_DASH] = ACTIONS(6883),
    [anon_sym_LT_LT_DASH] = ACTIONS(6883),
    [anon_sym_COLON_EQ] = ACTIONS(6883),
    [anon_sym_DASH_GT] = ACTIONS(6885),
    [anon_sym_DASH_GT_GT] = ACTIONS(6887),
    [anon_sym_PIPE] = ACTIONS(6889),
    [anon_sym_AMP] = ACTIONS(6891),
    [anon_sym_PIPE_PIPE] = ACTIONS(6893),
    [anon_sym_AMP_AMP] = ACTIONS(6895),
    [anon_sym_LT] = ACTIONS(6897),
    [anon_sym_LT_EQ] = ACTIONS(6899),
    [anon_sym_GT] = ACTIONS(6897),
    [anon_sym_GT_EQ] = ACTIONS(6899),
    [anon_sym_EQ_EQ] = ACTIONS(6899),
    [anon_sym_BANG_EQ] = ACTIONS(6899),
    [anon_sym_STAR] = ACTIONS(6901),
    [anon_sym_SLASH] = ACTIONS(6903),
    [anon_sym_STAR_STAR] = ACTIONS(6905),
    [anon_sym_CARET] = ACTIONS(6905),
    [aux_sym_binary_operator_token1] = ACTIONS(6907),
    [anon_sym_PIPE_GT] = ACTIONS(6907),
    [anon_sym_COLON] = ACTIONS(6909),
    [anon_sym_DOLLAR] = ACTIONS(6911),
    [anon_sym_AT] = ACTIONS(6911),
    [aux_sym__hex_literal_token1] = ACTIONS(5409),
    [sym__number_literal] = ACTIONS(5411),
    [anon_sym_SQUOTE] = ACTIONS(5409),
    [anon_sym_DQUOTE] = ACTIONS(5409),
    [sym_return] = ACTIONS(5411),
    [sym_next] = ACTIONS(5411),
    [sym_break] = ACTIONS(5411),
    [sym_true] = ACTIONS(5411),
    [sym_false] = ACTIONS(5411),
    [sym_null] = ACTIONS(5411),
    [sym_inf] = ACTIONS(5411),
    [sym_nan] = ACTIONS(5411),
    [anon_sym_NA] = ACTIONS(5411),
    [anon_sym_NA_integer_] = ACTIONS(5411),
    [anon_sym_NA_real_] = ACTIONS(5411),
    [anon_sym_NA_complex_] = ACTIONS(5411),
    [anon_sym_NA_character_] = ACTIONS(5411),
    [sym_dots] = ACTIONS(5411),
    [sym_dot_dot_i] = ACTIONS(5409),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5409),
    [sym__newline] = ACTIONS(5409),
    [sym__raw_string_literal] = ACTIONS(5409),
    [sym__external_open_parenthesis] = ACTIONS(6913),
    [sym__external_open_brace] = ACTIONS(5409),
    [sym__external_open_bracket] = ACTIONS(6915),
    [sym__external_open_bracket2] = ACTIONS(6917),
    [sym__external_close_bracket2] = ACTIONS(5409),
  },
  [2108] = {
    [sym_call_arguments] = STATE(3027),
    [sym_subset_arguments] = STATE(3026),
    [sym_subset2_arguments] = STATE(3025),
    [sym__open_parenthesis] = STATE(1616),
    [sym__open_bracket] = STATE(1615),
    [sym__open_bracket2] = STATE(1613),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(7039),
    [anon_sym_DASH] = ACTIONS(7041),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(7057),
    [anon_sym_LT_EQ] = ACTIONS(7059),
    [anon_sym_GT] = ACTIONS(7057),
    [anon_sym_GT_EQ] = ACTIONS(7059),
    [anon_sym_EQ_EQ] = ACTIONS(7059),
    [anon_sym_BANG_EQ] = ACTIONS(7059),
    [anon_sym_STAR] = ACTIONS(7061),
    [anon_sym_SLASH] = ACTIONS(7063),
    [anon_sym_STAR_STAR] = ACTIONS(7065),
    [anon_sym_CARET] = ACTIONS(7065),
    [aux_sym_binary_operator_token1] = ACTIONS(7067),
    [anon_sym_PIPE_GT] = ACTIONS(7067),
    [anon_sym_COLON] = ACTIONS(7069),
    [anon_sym_DOLLAR] = ACTIONS(7071),
    [anon_sym_AT] = ACTIONS(7071),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(7073),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(7075),
    [sym__external_close_bracket] = ACTIONS(5349),
    [sym__external_open_bracket2] = ACTIONS(7077),
  },
  [2109] = {
    [sym_call_arguments] = STATE(2941),
    [sym_subset_arguments] = STATE(2942),
    [sym_subset2_arguments] = STATE(2943),
    [sym__open_parenthesis] = STATE(1755),
    [sym__open_bracket] = STATE(1763),
    [sym__open_bracket2] = STATE(1866),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(6947),
    [anon_sym_CARET] = ACTIONS(6947),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(6951),
    [anon_sym_DOLLAR] = ACTIONS(6953),
    [anon_sym_AT] = ACTIONS(6953),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6955),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6957),
    [sym__external_open_bracket2] = ACTIONS(6959),
  },
  [2110] = {
    [sym_call_arguments] = STATE(2941),
    [sym_subset_arguments] = STATE(2942),
    [sym_subset2_arguments] = STATE(2943),
    [sym__open_parenthesis] = STATE(1755),
    [sym__open_bracket] = STATE(1763),
    [sym__open_bracket2] = STATE(1866),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(6947),
    [anon_sym_CARET] = ACTIONS(6947),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(5261),
    [anon_sym_DOLLAR] = ACTIONS(6953),
    [anon_sym_AT] = ACTIONS(6953),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6955),
    [sym__external_close_parenthesis] = ACTIONS(5263),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6957),
    [sym__external_open_bracket2] = ACTIONS(6959),
  },
  [2111] = {
    [sym_call_arguments] = STATE(2941),
    [sym_subset_arguments] = STATE(2942),
    [sym_subset2_arguments] = STATE(2943),
    [sym__open_parenthesis] = STATE(1755),
    [sym__open_bracket] = STATE(1763),
    [sym__open_bracket2] = STATE(1866),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_BSLASH] = ACTIONS(5413),
    [anon_sym_function] = ACTIONS(5415),
    [anon_sym_EQ] = ACTIONS(6919),
    [anon_sym_if] = ACTIONS(5415),
    [anon_sym_for] = ACTIONS(5415),
    [anon_sym_while] = ACTIONS(5415),
    [anon_sym_repeat] = ACTIONS(5415),
    [anon_sym_QMARK] = ACTIONS(5413),
    [anon_sym_TILDE] = ACTIONS(6921),
    [anon_sym_BANG] = ACTIONS(5415),
    [anon_sym_PLUS] = ACTIONS(6923),
    [anon_sym_DASH] = ACTIONS(6925),
    [anon_sym_LT_DASH] = ACTIONS(7147),
    [anon_sym_LT_LT_DASH] = ACTIONS(7147),
    [anon_sym_COLON_EQ] = ACTIONS(7147),
    [anon_sym_DASH_GT] = ACTIONS(6927),
    [anon_sym_DASH_GT_GT] = ACTIONS(6929),
    [anon_sym_PIPE] = ACTIONS(6931),
    [anon_sym_AMP] = ACTIONS(6933),
    [anon_sym_PIPE_PIPE] = ACTIONS(6935),
    [anon_sym_AMP_AMP] = ACTIONS(6937),
    [anon_sym_LT] = ACTIONS(6939),
    [anon_sym_LT_EQ] = ACTIONS(6941),
    [anon_sym_GT] = ACTIONS(6939),
    [anon_sym_GT_EQ] = ACTIONS(6941),
    [anon_sym_EQ_EQ] = ACTIONS(6941),
    [anon_sym_BANG_EQ] = ACTIONS(6941),
    [anon_sym_STAR] = ACTIONS(6943),
    [anon_sym_SLASH] = ACTIONS(6945),
    [anon_sym_STAR_STAR] = ACTIONS(6947),
    [anon_sym_CARET] = ACTIONS(6947),
    [aux_sym_binary_operator_token1] = ACTIONS(6949),
    [anon_sym_PIPE_GT] = ACTIONS(6949),
    [anon_sym_COLON] = ACTIONS(6951),
    [anon_sym_DOLLAR] = ACTIONS(6953),
    [anon_sym_AT] = ACTIONS(6953),
    [aux_sym__hex_literal_token1] = ACTIONS(5413),
    [sym__number_literal] = ACTIONS(5415),
    [anon_sym_SQUOTE] = ACTIONS(5413),
    [anon_sym_DQUOTE] = ACTIONS(5413),
    [sym_return] = ACTIONS(5415),
    [sym_next] = ACTIONS(5415),
    [sym_break] = ACTIONS(5415),
    [sym_true] = ACTIONS(5415),
    [sym_false] = ACTIONS(5415),
    [sym_null] = ACTIONS(5415),
    [sym_inf] = ACTIONS(5415),
    [sym_nan] = ACTIONS(5415),
    [anon_sym_NA] = ACTIONS(5415),
    [anon_sym_NA_integer_] = ACTIONS(5415),
    [anon_sym_NA_real_] = ACTIONS(5415),
    [anon_sym_NA_complex_] = ACTIONS(5415),
    [anon_sym_NA_character_] = ACTIONS(5415),
    [sym_dots] = ACTIONS(5415),
    [sym_dot_dot_i] = ACTIONS(5413),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5413),
    [sym__newline] = ACTIONS(5413),
    [sym__raw_string_literal] = ACTIONS(5413),
    [sym__external_open_parenthesis] = ACTIONS(6955),
    [sym__external_close_parenthesis] = ACTIONS(5413),
    [sym__external_open_brace] = ACTIONS(5413),
    [sym__external_open_bracket] = ACTIONS(6957),
    [sym__external_open_bracket2] = ACTIONS(6959),
  },
  [2112] = {
    [sym_call_arguments] = STATE(2941),
    [sym_subset_arguments] = STATE(2942),
    [sym_subset2_arguments] = STATE(2943),
    [sym__open_parenthesis] = STATE(1755),
    [sym__open_bracket] = STATE(1763),
    [sym__open_bracket2] = STATE(1866),
    [sym_identifier] = ACTIONS(5419),
    [anon_sym_BSLASH] = ACTIONS(5417),
    [anon_sym_function] = ACTIONS(5419),
    [anon_sym_EQ] = ACTIONS(6919),
    [anon_sym_if] = ACTIONS(5419),
    [anon_sym_for] = ACTIONS(5419),
    [anon_sym_while] = ACTIONS(5419),
    [anon_sym_repeat] = ACTIONS(5419),
    [anon_sym_QMARK] = ACTIONS(5417),
    [anon_sym_TILDE] = ACTIONS(6921),
    [anon_sym_BANG] = ACTIONS(5419),
    [anon_sym_PLUS] = ACTIONS(6923),
    [anon_sym_DASH] = ACTIONS(6925),
    [anon_sym_LT_DASH] = ACTIONS(7147),
    [anon_sym_LT_LT_DASH] = ACTIONS(7147),
    [anon_sym_COLON_EQ] = ACTIONS(7147),
    [anon_sym_DASH_GT] = ACTIONS(6927),
    [anon_sym_DASH_GT_GT] = ACTIONS(6929),
    [anon_sym_PIPE] = ACTIONS(6931),
    [anon_sym_AMP] = ACTIONS(6933),
    [anon_sym_PIPE_PIPE] = ACTIONS(6935),
    [anon_sym_AMP_AMP] = ACTIONS(6937),
    [anon_sym_LT] = ACTIONS(6939),
    [anon_sym_LT_EQ] = ACTIONS(6941),
    [anon_sym_GT] = ACTIONS(6939),
    [anon_sym_GT_EQ] = ACTIONS(6941),
    [anon_sym_EQ_EQ] = ACTIONS(6941),
    [anon_sym_BANG_EQ] = ACTIONS(6941),
    [anon_sym_STAR] = ACTIONS(6943),
    [anon_sym_SLASH] = ACTIONS(6945),
    [anon_sym_STAR_STAR] = ACTIONS(6947),
    [anon_sym_CARET] = ACTIONS(6947),
    [aux_sym_binary_operator_token1] = ACTIONS(6949),
    [anon_sym_PIPE_GT] = ACTIONS(6949),
    [anon_sym_COLON] = ACTIONS(6951),
    [anon_sym_DOLLAR] = ACTIONS(6953),
    [anon_sym_AT] = ACTIONS(6953),
    [aux_sym__hex_literal_token1] = ACTIONS(5417),
    [sym__number_literal] = ACTIONS(5419),
    [anon_sym_SQUOTE] = ACTIONS(5417),
    [anon_sym_DQUOTE] = ACTIONS(5417),
    [sym_return] = ACTIONS(5419),
    [sym_next] = ACTIONS(5419),
    [sym_break] = ACTIONS(5419),
    [sym_true] = ACTIONS(5419),
    [sym_false] = ACTIONS(5419),
    [sym_null] = ACTIONS(5419),
    [sym_inf] = ACTIONS(5419),
    [sym_nan] = ACTIONS(5419),
    [anon_sym_NA] = ACTIONS(5419),
    [anon_sym_NA_integer_] = ACTIONS(5419),
    [anon_sym_NA_real_] = ACTIONS(5419),
    [anon_sym_NA_complex_] = ACTIONS(5419),
    [anon_sym_NA_character_] = ACTIONS(5419),
    [sym_dots] = ACTIONS(5419),
    [sym_dot_dot_i] = ACTIONS(5417),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5417),
    [sym__newline] = ACTIONS(5417),
    [sym__raw_string_literal] = ACTIONS(5417),
    [sym__external_open_parenthesis] = ACTIONS(6955),
    [sym__external_close_parenthesis] = ACTIONS(5417),
    [sym__external_open_brace] = ACTIONS(5417),
    [sym__external_open_bracket] = ACTIONS(6957),
    [sym__external_open_bracket2] = ACTIONS(6959),
  },
  [2113] = {
    [sym_function_definition] = STATE(1931),
    [sym_if_statement] = STATE(1931),
    [sym_for_statement] = STATE(1931),
    [sym_while_statement] = STATE(1931),
    [sym_repeat_statement] = STATE(1931),
    [sym_braced_expression] = STATE(1931),
    [sym_parenthesized_expression] = STATE(1931),
    [sym_call] = STATE(1931),
    [sym_subset] = STATE(1931),
    [sym_subset2] = STATE(1931),
    [sym__argument] = STATE(4656),
    [sym_argument] = STATE(4657),
    [sym__argument_named] = STATE(4658),
    [sym__argument_unnamed] = STATE(4662),
    [sym__argument_value] = STATE(4663),
    [sym_unary_operator] = STATE(1931),
    [sym_binary_operator] = STATE(1931),
    [sym_extract_operator] = STATE(1931),
    [sym_namespace_operator] = STATE(1931),
    [sym_integer] = STATE(1931),
    [sym_complex] = STATE(1931),
    [sym_float] = STATE(1931),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2633),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(1931),
    [sym__expression] = STATE(1931),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__open_brace] = STATE(154),
    [aux_sym_call_arguments_repeat1] = STATE(2113),
    [sym_identifier] = ACTIONS(7297),
    [anon_sym_BSLASH] = ACTIONS(7300),
    [anon_sym_function] = ACTIONS(7303),
    [anon_sym_if] = ACTIONS(7306),
    [anon_sym_for] = ACTIONS(7309),
    [anon_sym_while] = ACTIONS(7312),
    [anon_sym_repeat] = ACTIONS(7315),
    [anon_sym_QMARK] = ACTIONS(7318),
    [anon_sym_TILDE] = ACTIONS(7321),
    [anon_sym_BANG] = ACTIONS(7324),
    [anon_sym_PLUS] = ACTIONS(7327),
    [anon_sym_DASH] = ACTIONS(7327),
    [aux_sym__hex_literal_token1] = ACTIONS(7330),
    [sym__number_literal] = ACTIONS(7333),
    [anon_sym_SQUOTE] = ACTIONS(7336),
    [anon_sym_DQUOTE] = ACTIONS(7339),
    [sym_return] = ACTIONS(7342),
    [sym_next] = ACTIONS(7342),
    [sym_break] = ACTIONS(7342),
    [sym_true] = ACTIONS(7342),
    [sym_false] = ACTIONS(7342),
    [sym_null] = ACTIONS(7342),
    [sym_inf] = ACTIONS(7342),
    [sym_nan] = ACTIONS(7342),
    [anon_sym_NA] = ACTIONS(7345),
    [anon_sym_NA_integer_] = ACTIONS(7345),
    [anon_sym_NA_real_] = ACTIONS(7345),
    [anon_sym_NA_complex_] = ACTIONS(7345),
    [anon_sym_NA_character_] = ACTIONS(7345),
    [sym_dots] = ACTIONS(7348),
    [sym_dot_dot_i] = ACTIONS(7351),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7354),
    [sym__newline] = ACTIONS(7357),
    [sym__raw_string_literal] = ACTIONS(7360),
    [sym__external_open_parenthesis] = ACTIONS(7363),
    [sym__external_close_parenthesis] = ACTIONS(7033),
    [sym__external_open_brace] = ACTIONS(7366),
  },
  [2114] = {
    [sym_call_arguments] = STATE(2941),
    [sym_subset_arguments] = STATE(2942),
    [sym_subset2_arguments] = STATE(2943),
    [sym__open_parenthesis] = STATE(1755),
    [sym__open_bracket] = STATE(1763),
    [sym__open_bracket2] = STATE(1866),
    [sym_identifier] = ACTIONS(5423),
    [anon_sym_BSLASH] = ACTIONS(5421),
    [anon_sym_function] = ACTIONS(5423),
    [anon_sym_EQ] = ACTIONS(6919),
    [anon_sym_if] = ACTIONS(5423),
    [anon_sym_for] = ACTIONS(5423),
    [anon_sym_while] = ACTIONS(5423),
    [anon_sym_repeat] = ACTIONS(5423),
    [anon_sym_QMARK] = ACTIONS(5421),
    [anon_sym_TILDE] = ACTIONS(6921),
    [anon_sym_BANG] = ACTIONS(5423),
    [anon_sym_PLUS] = ACTIONS(6923),
    [anon_sym_DASH] = ACTIONS(6925),
    [anon_sym_LT_DASH] = ACTIONS(7147),
    [anon_sym_LT_LT_DASH] = ACTIONS(7147),
    [anon_sym_COLON_EQ] = ACTIONS(7147),
    [anon_sym_DASH_GT] = ACTIONS(6927),
    [anon_sym_DASH_GT_GT] = ACTIONS(6929),
    [anon_sym_PIPE] = ACTIONS(6931),
    [anon_sym_AMP] = ACTIONS(6933),
    [anon_sym_PIPE_PIPE] = ACTIONS(6935),
    [anon_sym_AMP_AMP] = ACTIONS(6937),
    [anon_sym_LT] = ACTIONS(6939),
    [anon_sym_LT_EQ] = ACTIONS(6941),
    [anon_sym_GT] = ACTIONS(6939),
    [anon_sym_GT_EQ] = ACTIONS(6941),
    [anon_sym_EQ_EQ] = ACTIONS(6941),
    [anon_sym_BANG_EQ] = ACTIONS(6941),
    [anon_sym_STAR] = ACTIONS(6943),
    [anon_sym_SLASH] = ACTIONS(6945),
    [anon_sym_STAR_STAR] = ACTIONS(6947),
    [anon_sym_CARET] = ACTIONS(6947),
    [aux_sym_binary_operator_token1] = ACTIONS(6949),
    [anon_sym_PIPE_GT] = ACTIONS(6949),
    [anon_sym_COLON] = ACTIONS(6951),
    [anon_sym_DOLLAR] = ACTIONS(6953),
    [anon_sym_AT] = ACTIONS(6953),
    [aux_sym__hex_literal_token1] = ACTIONS(5421),
    [sym__number_literal] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5421),
    [anon_sym_DQUOTE] = ACTIONS(5421),
    [sym_return] = ACTIONS(5423),
    [sym_next] = ACTIONS(5423),
    [sym_break] = ACTIONS(5423),
    [sym_true] = ACTIONS(5423),
    [sym_false] = ACTIONS(5423),
    [sym_null] = ACTIONS(5423),
    [sym_inf] = ACTIONS(5423),
    [sym_nan] = ACTIONS(5423),
    [anon_sym_NA] = ACTIONS(5423),
    [anon_sym_NA_integer_] = ACTIONS(5423),
    [anon_sym_NA_real_] = ACTIONS(5423),
    [anon_sym_NA_complex_] = ACTIONS(5423),
    [anon_sym_NA_character_] = ACTIONS(5423),
    [sym_dots] = ACTIONS(5423),
    [sym_dot_dot_i] = ACTIONS(5421),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5421),
    [sym__newline] = ACTIONS(5421),
    [sym__raw_string_literal] = ACTIONS(5421),
    [sym__external_open_parenthesis] = ACTIONS(6955),
    [sym__external_close_parenthesis] = ACTIONS(5421),
    [sym__external_open_brace] = ACTIONS(5421),
    [sym__external_open_bracket] = ACTIONS(6957),
    [sym__external_open_bracket2] = ACTIONS(6959),
  },
  [2115] = {
    [sym_identifier] = ACTIONS(7191),
    [anon_sym_BSLASH] = ACTIONS(7189),
    [anon_sym_function] = ACTIONS(7191),
    [anon_sym_EQ] = ACTIONS(7191),
    [anon_sym_if] = ACTIONS(7191),
    [anon_sym_for] = ACTIONS(7191),
    [anon_sym_while] = ACTIONS(7191),
    [anon_sym_repeat] = ACTIONS(7191),
    [anon_sym_QMARK] = ACTIONS(7189),
    [anon_sym_TILDE] = ACTIONS(7189),
    [anon_sym_BANG] = ACTIONS(7191),
    [anon_sym_PLUS] = ACTIONS(7189),
    [anon_sym_DASH] = ACTIONS(7191),
    [anon_sym_LT_DASH] = ACTIONS(7189),
    [anon_sym_LT_LT_DASH] = ACTIONS(7189),
    [anon_sym_COLON_EQ] = ACTIONS(7189),
    [anon_sym_DASH_GT] = ACTIONS(7191),
    [anon_sym_DASH_GT_GT] = ACTIONS(7189),
    [anon_sym_PIPE] = ACTIONS(7191),
    [anon_sym_AMP] = ACTIONS(7191),
    [anon_sym_PIPE_PIPE] = ACTIONS(7189),
    [anon_sym_AMP_AMP] = ACTIONS(7189),
    [anon_sym_LT] = ACTIONS(7191),
    [anon_sym_LT_EQ] = ACTIONS(7189),
    [anon_sym_GT] = ACTIONS(7191),
    [anon_sym_GT_EQ] = ACTIONS(7189),
    [anon_sym_EQ_EQ] = ACTIONS(7189),
    [anon_sym_BANG_EQ] = ACTIONS(7189),
    [anon_sym_STAR] = ACTIONS(7191),
    [anon_sym_SLASH] = ACTIONS(7189),
    [anon_sym_STAR_STAR] = ACTIONS(7189),
    [anon_sym_CARET] = ACTIONS(7189),
    [aux_sym_binary_operator_token1] = ACTIONS(7189),
    [anon_sym_PIPE_GT] = ACTIONS(7189),
    [anon_sym_COLON] = ACTIONS(7191),
    [anon_sym_DOLLAR] = ACTIONS(7189),
    [anon_sym_AT] = ACTIONS(7189),
    [anon_sym_COLON_COLON] = ACTIONS(7191),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7189),
    [aux_sym__hex_literal_token1] = ACTIONS(7189),
    [sym__number_literal] = ACTIONS(7191),
    [anon_sym_SQUOTE] = ACTIONS(7189),
    [anon_sym_DQUOTE] = ACTIONS(7189),
    [sym_return] = ACTIONS(7191),
    [sym_next] = ACTIONS(7191),
    [sym_break] = ACTIONS(7191),
    [sym_true] = ACTIONS(7191),
    [sym_false] = ACTIONS(7191),
    [sym_null] = ACTIONS(7191),
    [sym_inf] = ACTIONS(7191),
    [sym_nan] = ACTIONS(7191),
    [anon_sym_NA] = ACTIONS(7191),
    [anon_sym_NA_integer_] = ACTIONS(7191),
    [anon_sym_NA_real_] = ACTIONS(7191),
    [anon_sym_NA_complex_] = ACTIONS(7191),
    [anon_sym_NA_character_] = ACTIONS(7191),
    [sym_dots] = ACTIONS(7191),
    [sym_dot_dot_i] = ACTIONS(7189),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7189),
    [sym__newline] = ACTIONS(7189),
    [sym__semicolon] = ACTIONS(7189),
    [sym__raw_string_literal] = ACTIONS(7189),
    [sym__external_else] = ACTIONS(7189),
    [sym__external_open_parenthesis] = ACTIONS(7189),
    [sym__external_close_parenthesis] = ACTIONS(7189),
    [sym__external_open_brace] = ACTIONS(7189),
    [sym__external_close_brace] = ACTIONS(7189),
    [sym__external_open_bracket] = ACTIONS(7189),
    [sym__external_open_bracket2] = ACTIONS(7189),
    [sym__external_close_bracket2] = ACTIONS(7189),
  },
  [2116] = {
    [sym_identifier] = ACTIONS(7195),
    [anon_sym_BSLASH] = ACTIONS(7193),
    [anon_sym_function] = ACTIONS(7195),
    [anon_sym_EQ] = ACTIONS(7195),
    [anon_sym_if] = ACTIONS(7195),
    [anon_sym_for] = ACTIONS(7195),
    [anon_sym_while] = ACTIONS(7195),
    [anon_sym_repeat] = ACTIONS(7195),
    [anon_sym_QMARK] = ACTIONS(7193),
    [anon_sym_TILDE] = ACTIONS(7193),
    [anon_sym_BANG] = ACTIONS(7195),
    [anon_sym_PLUS] = ACTIONS(7193),
    [anon_sym_DASH] = ACTIONS(7195),
    [anon_sym_LT_DASH] = ACTIONS(7193),
    [anon_sym_LT_LT_DASH] = ACTIONS(7193),
    [anon_sym_COLON_EQ] = ACTIONS(7193),
    [anon_sym_DASH_GT] = ACTIONS(7195),
    [anon_sym_DASH_GT_GT] = ACTIONS(7193),
    [anon_sym_PIPE] = ACTIONS(7195),
    [anon_sym_AMP] = ACTIONS(7195),
    [anon_sym_PIPE_PIPE] = ACTIONS(7193),
    [anon_sym_AMP_AMP] = ACTIONS(7193),
    [anon_sym_LT] = ACTIONS(7195),
    [anon_sym_LT_EQ] = ACTIONS(7193),
    [anon_sym_GT] = ACTIONS(7195),
    [anon_sym_GT_EQ] = ACTIONS(7193),
    [anon_sym_EQ_EQ] = ACTIONS(7193),
    [anon_sym_BANG_EQ] = ACTIONS(7193),
    [anon_sym_STAR] = ACTIONS(7195),
    [anon_sym_SLASH] = ACTIONS(7193),
    [anon_sym_STAR_STAR] = ACTIONS(7193),
    [anon_sym_CARET] = ACTIONS(7193),
    [aux_sym_binary_operator_token1] = ACTIONS(7193),
    [anon_sym_PIPE_GT] = ACTIONS(7193),
    [anon_sym_COLON] = ACTIONS(7195),
    [anon_sym_DOLLAR] = ACTIONS(7193),
    [anon_sym_AT] = ACTIONS(7193),
    [anon_sym_COLON_COLON] = ACTIONS(7195),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7193),
    [aux_sym__hex_literal_token1] = ACTIONS(7193),
    [sym__number_literal] = ACTIONS(7195),
    [anon_sym_SQUOTE] = ACTIONS(7193),
    [anon_sym_DQUOTE] = ACTIONS(7193),
    [sym_return] = ACTIONS(7195),
    [sym_next] = ACTIONS(7195),
    [sym_break] = ACTIONS(7195),
    [sym_true] = ACTIONS(7195),
    [sym_false] = ACTIONS(7195),
    [sym_null] = ACTIONS(7195),
    [sym_inf] = ACTIONS(7195),
    [sym_nan] = ACTIONS(7195),
    [anon_sym_NA] = ACTIONS(7195),
    [anon_sym_NA_integer_] = ACTIONS(7195),
    [anon_sym_NA_real_] = ACTIONS(7195),
    [anon_sym_NA_complex_] = ACTIONS(7195),
    [anon_sym_NA_character_] = ACTIONS(7195),
    [sym_dots] = ACTIONS(7195),
    [sym_dot_dot_i] = ACTIONS(7193),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7193),
    [sym__newline] = ACTIONS(7193),
    [sym__semicolon] = ACTIONS(7193),
    [sym__raw_string_literal] = ACTIONS(7193),
    [sym__external_else] = ACTIONS(7193),
    [sym__external_open_parenthesis] = ACTIONS(7193),
    [sym__external_close_parenthesis] = ACTIONS(7193),
    [sym__external_open_brace] = ACTIONS(7193),
    [sym__external_close_brace] = ACTIONS(7193),
    [sym__external_open_bracket] = ACTIONS(7193),
    [sym__external_open_bracket2] = ACTIONS(7193),
    [sym__external_close_bracket2] = ACTIONS(7193),
  },
  [2117] = {
    [sym_call_arguments] = STATE(2941),
    [sym_subset_arguments] = STATE(2942),
    [sym_subset2_arguments] = STATE(2943),
    [sym__open_parenthesis] = STATE(1755),
    [sym__open_bracket] = STATE(1763),
    [sym__open_bracket2] = STATE(1866),
    [sym_identifier] = ACTIONS(5427),
    [anon_sym_BSLASH] = ACTIONS(5425),
    [anon_sym_function] = ACTIONS(5427),
    [anon_sym_EQ] = ACTIONS(6919),
    [anon_sym_if] = ACTIONS(5427),
    [anon_sym_for] = ACTIONS(5427),
    [anon_sym_while] = ACTIONS(5427),
    [anon_sym_repeat] = ACTIONS(5427),
    [anon_sym_QMARK] = ACTIONS(5425),
    [anon_sym_TILDE] = ACTIONS(6921),
    [anon_sym_BANG] = ACTIONS(5427),
    [anon_sym_PLUS] = ACTIONS(6923),
    [anon_sym_DASH] = ACTIONS(6925),
    [anon_sym_LT_DASH] = ACTIONS(7147),
    [anon_sym_LT_LT_DASH] = ACTIONS(7147),
    [anon_sym_COLON_EQ] = ACTIONS(7147),
    [anon_sym_DASH_GT] = ACTIONS(6927),
    [anon_sym_DASH_GT_GT] = ACTIONS(6929),
    [anon_sym_PIPE] = ACTIONS(6931),
    [anon_sym_AMP] = ACTIONS(6933),
    [anon_sym_PIPE_PIPE] = ACTIONS(6935),
    [anon_sym_AMP_AMP] = ACTIONS(6937),
    [anon_sym_LT] = ACTIONS(6939),
    [anon_sym_LT_EQ] = ACTIONS(6941),
    [anon_sym_GT] = ACTIONS(6939),
    [anon_sym_GT_EQ] = ACTIONS(6941),
    [anon_sym_EQ_EQ] = ACTIONS(6941),
    [anon_sym_BANG_EQ] = ACTIONS(6941),
    [anon_sym_STAR] = ACTIONS(6943),
    [anon_sym_SLASH] = ACTIONS(6945),
    [anon_sym_STAR_STAR] = ACTIONS(6947),
    [anon_sym_CARET] = ACTIONS(6947),
    [aux_sym_binary_operator_token1] = ACTIONS(6949),
    [anon_sym_PIPE_GT] = ACTIONS(6949),
    [anon_sym_COLON] = ACTIONS(6951),
    [anon_sym_DOLLAR] = ACTIONS(6953),
    [anon_sym_AT] = ACTIONS(6953),
    [aux_sym__hex_literal_token1] = ACTIONS(5425),
    [sym__number_literal] = ACTIONS(5427),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_DQUOTE] = ACTIONS(5425),
    [sym_return] = ACTIONS(5427),
    [sym_next] = ACTIONS(5427),
    [sym_break] = ACTIONS(5427),
    [sym_true] = ACTIONS(5427),
    [sym_false] = ACTIONS(5427),
    [sym_null] = ACTIONS(5427),
    [sym_inf] = ACTIONS(5427),
    [sym_nan] = ACTIONS(5427),
    [anon_sym_NA] = ACTIONS(5427),
    [anon_sym_NA_integer_] = ACTIONS(5427),
    [anon_sym_NA_real_] = ACTIONS(5427),
    [anon_sym_NA_complex_] = ACTIONS(5427),
    [anon_sym_NA_character_] = ACTIONS(5427),
    [sym_dots] = ACTIONS(5427),
    [sym_dot_dot_i] = ACTIONS(5425),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5425),
    [sym__newline] = ACTIONS(5425),
    [sym__raw_string_literal] = ACTIONS(5425),
    [sym__external_open_parenthesis] = ACTIONS(6955),
    [sym__external_close_parenthesis] = ACTIONS(5425),
    [sym__external_open_brace] = ACTIONS(5425),
    [sym__external_open_bracket] = ACTIONS(6957),
    [sym__external_open_bracket2] = ACTIONS(6959),
  },
  [2118] = {
    [sym_string] = STATE(2900),
    [sym__single_quoted_string] = STATE(2528),
    [sym__double_quoted_string] = STATE(2529),
    [sym__string_or_identifier] = STATE(2900),
    [aux_sym_function_definition_repeat1] = STATE(1924),
    [ts_builtin_sym_end] = ACTIONS(5659),
    [sym_identifier] = ACTIONS(7369),
    [anon_sym_BSLASH] = ACTIONS(5659),
    [anon_sym_function] = ACTIONS(5663),
    [anon_sym_EQ] = ACTIONS(5663),
    [anon_sym_if] = ACTIONS(5663),
    [anon_sym_for] = ACTIONS(5663),
    [anon_sym_while] = ACTIONS(5663),
    [anon_sym_repeat] = ACTIONS(5663),
    [anon_sym_QMARK] = ACTIONS(5659),
    [anon_sym_TILDE] = ACTIONS(5659),
    [anon_sym_BANG] = ACTIONS(5663),
    [anon_sym_PLUS] = ACTIONS(5659),
    [anon_sym_DASH] = ACTIONS(5663),
    [anon_sym_LT_DASH] = ACTIONS(5659),
    [anon_sym_LT_LT_DASH] = ACTIONS(5659),
    [anon_sym_COLON_EQ] = ACTIONS(5659),
    [anon_sym_DASH_GT] = ACTIONS(5663),
    [anon_sym_DASH_GT_GT] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(5663),
    [anon_sym_AMP] = ACTIONS(5663),
    [anon_sym_PIPE_PIPE] = ACTIONS(5659),
    [anon_sym_AMP_AMP] = ACTIONS(5659),
    [anon_sym_LT] = ACTIONS(5663),
    [anon_sym_LT_EQ] = ACTIONS(5659),
    [anon_sym_GT] = ACTIONS(5663),
    [anon_sym_GT_EQ] = ACTIONS(5659),
    [anon_sym_EQ_EQ] = ACTIONS(5659),
    [anon_sym_BANG_EQ] = ACTIONS(5659),
    [anon_sym_STAR] = ACTIONS(5663),
    [anon_sym_SLASH] = ACTIONS(5659),
    [anon_sym_STAR_STAR] = ACTIONS(5659),
    [anon_sym_CARET] = ACTIONS(5659),
    [aux_sym_binary_operator_token1] = ACTIONS(5659),
    [anon_sym_PIPE_GT] = ACTIONS(5659),
    [anon_sym_COLON] = ACTIONS(5663),
    [anon_sym_DOLLAR] = ACTIONS(5659),
    [anon_sym_AT] = ACTIONS(5659),
    [aux_sym__hex_literal_token1] = ACTIONS(5659),
    [sym__number_literal] = ACTIONS(5663),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE] = ACTIONS(2856),
    [sym_return] = ACTIONS(5663),
    [sym_next] = ACTIONS(5663),
    [sym_break] = ACTIONS(5663),
    [sym_true] = ACTIONS(5663),
    [sym_false] = ACTIONS(5663),
    [sym_null] = ACTIONS(5663),
    [sym_inf] = ACTIONS(5663),
    [sym_nan] = ACTIONS(5663),
    [anon_sym_NA] = ACTIONS(5663),
    [anon_sym_NA_integer_] = ACTIONS(5663),
    [anon_sym_NA_real_] = ACTIONS(5663),
    [anon_sym_NA_complex_] = ACTIONS(5663),
    [anon_sym_NA_character_] = ACTIONS(5663),
    [sym_dots] = ACTIONS(5663),
    [sym_dot_dot_i] = ACTIONS(5659),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7371),
    [sym__semicolon] = ACTIONS(5659),
    [sym__raw_string_literal] = ACTIONS(2866),
    [sym__external_open_parenthesis] = ACTIONS(5659),
    [sym__external_open_brace] = ACTIONS(5659),
    [sym__external_close_brace] = ACTIONS(5659),
    [sym__external_open_bracket] = ACTIONS(5659),
    [sym__external_open_bracket2] = ACTIONS(5659),
  },
  [2119] = {
    [sym_call_arguments] = STATE(2985),
    [sym_subset_arguments] = STATE(2986),
    [sym_subset2_arguments] = STATE(2987),
    [sym__open_parenthesis] = STATE(1414),
    [sym__open_bracket] = STATE(1416),
    [sym__open_bracket2] = STATE(1428),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(7081),
    [anon_sym_DASH] = ACTIONS(7083),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(7093),
    [anon_sym_LT_EQ] = ACTIONS(7095),
    [anon_sym_GT] = ACTIONS(7093),
    [anon_sym_GT_EQ] = ACTIONS(7095),
    [anon_sym_EQ_EQ] = ACTIONS(7095),
    [anon_sym_BANG_EQ] = ACTIONS(7095),
    [anon_sym_STAR] = ACTIONS(7097),
    [anon_sym_SLASH] = ACTIONS(7099),
    [anon_sym_STAR_STAR] = ACTIONS(7101),
    [anon_sym_CARET] = ACTIONS(7101),
    [aux_sym_binary_operator_token1] = ACTIONS(7103),
    [anon_sym_PIPE_GT] = ACTIONS(7103),
    [anon_sym_COLON] = ACTIONS(7105),
    [anon_sym_DOLLAR] = ACTIONS(7107),
    [anon_sym_AT] = ACTIONS(7107),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(7109),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(7111),
    [sym__external_open_bracket2] = ACTIONS(7113),
  },
  [2120] = {
    [sym_call_arguments] = STATE(2985),
    [sym_subset_arguments] = STATE(2986),
    [sym_subset2_arguments] = STATE(2987),
    [sym__open_parenthesis] = STATE(1414),
    [sym__open_bracket] = STATE(1416),
    [sym__open_bracket2] = STATE(1428),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(7081),
    [anon_sym_DASH] = ACTIONS(7083),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(7087),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(7091),
    [anon_sym_LT] = ACTIONS(7093),
    [anon_sym_LT_EQ] = ACTIONS(7095),
    [anon_sym_GT] = ACTIONS(7093),
    [anon_sym_GT_EQ] = ACTIONS(7095),
    [anon_sym_EQ_EQ] = ACTIONS(7095),
    [anon_sym_BANG_EQ] = ACTIONS(7095),
    [anon_sym_STAR] = ACTIONS(7097),
    [anon_sym_SLASH] = ACTIONS(7099),
    [anon_sym_STAR_STAR] = ACTIONS(7101),
    [anon_sym_CARET] = ACTIONS(7101),
    [aux_sym_binary_operator_token1] = ACTIONS(7103),
    [anon_sym_PIPE_GT] = ACTIONS(7103),
    [anon_sym_COLON] = ACTIONS(7105),
    [anon_sym_DOLLAR] = ACTIONS(7107),
    [anon_sym_AT] = ACTIONS(7107),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(7109),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(7111),
    [sym__external_open_bracket2] = ACTIONS(7113),
  },
  [2121] = {
    [sym_call_arguments] = STATE(2941),
    [sym_subset_arguments] = STATE(2942),
    [sym_subset2_arguments] = STATE(2943),
    [sym__open_parenthesis] = STATE(1755),
    [sym__open_bracket] = STATE(1763),
    [sym__open_bracket2] = STATE(1866),
    [sym_identifier] = ACTIONS(5431),
    [anon_sym_BSLASH] = ACTIONS(5429),
    [anon_sym_function] = ACTIONS(5431),
    [anon_sym_EQ] = ACTIONS(6919),
    [anon_sym_if] = ACTIONS(5431),
    [anon_sym_for] = ACTIONS(5431),
    [anon_sym_while] = ACTIONS(5431),
    [anon_sym_repeat] = ACTIONS(5431),
    [anon_sym_QMARK] = ACTIONS(5429),
    [anon_sym_TILDE] = ACTIONS(6921),
    [anon_sym_BANG] = ACTIONS(5431),
    [anon_sym_PLUS] = ACTIONS(6923),
    [anon_sym_DASH] = ACTIONS(6925),
    [anon_sym_LT_DASH] = ACTIONS(7147),
    [anon_sym_LT_LT_DASH] = ACTIONS(7147),
    [anon_sym_COLON_EQ] = ACTIONS(7147),
    [anon_sym_DASH_GT] = ACTIONS(6927),
    [anon_sym_DASH_GT_GT] = ACTIONS(6929),
    [anon_sym_PIPE] = ACTIONS(6931),
    [anon_sym_AMP] = ACTIONS(6933),
    [anon_sym_PIPE_PIPE] = ACTIONS(6935),
    [anon_sym_AMP_AMP] = ACTIONS(6937),
    [anon_sym_LT] = ACTIONS(6939),
    [anon_sym_LT_EQ] = ACTIONS(6941),
    [anon_sym_GT] = ACTIONS(6939),
    [anon_sym_GT_EQ] = ACTIONS(6941),
    [anon_sym_EQ_EQ] = ACTIONS(6941),
    [anon_sym_BANG_EQ] = ACTIONS(6941),
    [anon_sym_STAR] = ACTIONS(6943),
    [anon_sym_SLASH] = ACTIONS(6945),
    [anon_sym_STAR_STAR] = ACTIONS(6947),
    [anon_sym_CARET] = ACTIONS(6947),
    [aux_sym_binary_operator_token1] = ACTIONS(6949),
    [anon_sym_PIPE_GT] = ACTIONS(6949),
    [anon_sym_COLON] = ACTIONS(6951),
    [anon_sym_DOLLAR] = ACTIONS(6953),
    [anon_sym_AT] = ACTIONS(6953),
    [aux_sym__hex_literal_token1] = ACTIONS(5429),
    [sym__number_literal] = ACTIONS(5431),
    [anon_sym_SQUOTE] = ACTIONS(5429),
    [anon_sym_DQUOTE] = ACTIONS(5429),
    [sym_return] = ACTIONS(5431),
    [sym_next] = ACTIONS(5431),
    [sym_break] = ACTIONS(5431),
    [sym_true] = ACTIONS(5431),
    [sym_false] = ACTIONS(5431),
    [sym_null] = ACTIONS(5431),
    [sym_inf] = ACTIONS(5431),
    [sym_nan] = ACTIONS(5431),
    [anon_sym_NA] = ACTIONS(5431),
    [anon_sym_NA_integer_] = ACTIONS(5431),
    [anon_sym_NA_real_] = ACTIONS(5431),
    [anon_sym_NA_complex_] = ACTIONS(5431),
    [anon_sym_NA_character_] = ACTIONS(5431),
    [sym_dots] = ACTIONS(5431),
    [sym_dot_dot_i] = ACTIONS(5429),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5429),
    [sym__newline] = ACTIONS(5429),
    [sym__raw_string_literal] = ACTIONS(5429),
    [sym__external_open_parenthesis] = ACTIONS(6955),
    [sym__external_close_parenthesis] = ACTIONS(5429),
    [sym__external_open_brace] = ACTIONS(5429),
    [sym__external_open_bracket] = ACTIONS(6957),
    [sym__external_open_bracket2] = ACTIONS(6959),
  },
  [2122] = {
    [sym_call_arguments] = STATE(2978),
    [sym_subset_arguments] = STATE(2977),
    [sym_subset2_arguments] = STATE(2976),
    [sym__open_parenthesis] = STATE(1606),
    [sym__open_bracket] = STATE(1598),
    [sym__open_bracket2] = STATE(1592),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(6905),
    [anon_sym_CARET] = ACTIONS(6905),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(5261),
    [anon_sym_DOLLAR] = ACTIONS(6911),
    [anon_sym_AT] = ACTIONS(6911),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5263),
    [sym__newline] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(6913),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(6915),
    [sym__external_open_bracket2] = ACTIONS(6917),
    [sym__external_close_bracket2] = ACTIONS(5263),
  },
  [2123] = {
    [sym_string] = STATE(2623),
    [sym__single_quoted_string] = STATE(2289),
    [sym__double_quoted_string] = STATE(2290),
    [sym__string_or_identifier] = STATE(2623),
    [sym_identifier] = ACTIONS(7373),
    [anon_sym_BSLASH] = ACTIONS(5883),
    [anon_sym_function] = ACTIONS(5887),
    [anon_sym_EQ] = ACTIONS(5887),
    [anon_sym_if] = ACTIONS(5887),
    [anon_sym_for] = ACTIONS(5887),
    [anon_sym_while] = ACTIONS(5887),
    [anon_sym_repeat] = ACTIONS(5887),
    [anon_sym_QMARK] = ACTIONS(5883),
    [anon_sym_TILDE] = ACTIONS(5883),
    [anon_sym_BANG] = ACTIONS(5887),
    [anon_sym_PLUS] = ACTIONS(5883),
    [anon_sym_DASH] = ACTIONS(5887),
    [anon_sym_LT_DASH] = ACTIONS(5883),
    [anon_sym_LT_LT_DASH] = ACTIONS(5883),
    [anon_sym_COLON_EQ] = ACTIONS(5883),
    [anon_sym_DASH_GT] = ACTIONS(5887),
    [anon_sym_DASH_GT_GT] = ACTIONS(5883),
    [anon_sym_PIPE] = ACTIONS(5887),
    [anon_sym_AMP] = ACTIONS(5887),
    [anon_sym_PIPE_PIPE] = ACTIONS(5883),
    [anon_sym_AMP_AMP] = ACTIONS(5883),
    [anon_sym_LT] = ACTIONS(5887),
    [anon_sym_LT_EQ] = ACTIONS(5883),
    [anon_sym_GT] = ACTIONS(5887),
    [anon_sym_GT_EQ] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5883),
    [anon_sym_BANG_EQ] = ACTIONS(5883),
    [anon_sym_STAR] = ACTIONS(5887),
    [anon_sym_SLASH] = ACTIONS(5883),
    [anon_sym_STAR_STAR] = ACTIONS(5883),
    [anon_sym_CARET] = ACTIONS(5883),
    [aux_sym_binary_operator_token1] = ACTIONS(5883),
    [anon_sym_PIPE_GT] = ACTIONS(5883),
    [anon_sym_COLON] = ACTIONS(5887),
    [anon_sym_DOLLAR] = ACTIONS(5883),
    [anon_sym_AT] = ACTIONS(5883),
    [aux_sym__hex_literal_token1] = ACTIONS(5883),
    [sym__number_literal] = ACTIONS(5887),
    [anon_sym_SQUOTE] = ACTIONS(1596),
    [anon_sym_DQUOTE] = ACTIONS(1598),
    [sym_return] = ACTIONS(5887),
    [sym_next] = ACTIONS(5887),
    [sym_break] = ACTIONS(5887),
    [sym_true] = ACTIONS(5887),
    [sym_false] = ACTIONS(5887),
    [sym_null] = ACTIONS(5887),
    [sym_inf] = ACTIONS(5887),
    [sym_nan] = ACTIONS(5887),
    [anon_sym_NA] = ACTIONS(5887),
    [anon_sym_NA_integer_] = ACTIONS(5887),
    [anon_sym_NA_real_] = ACTIONS(5887),
    [anon_sym_NA_complex_] = ACTIONS(5887),
    [anon_sym_NA_character_] = ACTIONS(5887),
    [sym_dots] = ACTIONS(5887),
    [sym_dot_dot_i] = ACTIONS(5883),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5883),
    [sym__newline] = ACTIONS(5883),
    [sym__raw_string_literal] = ACTIONS(1608),
    [sym__external_else] = ACTIONS(5883),
    [sym__external_open_parenthesis] = ACTIONS(5883),
    [sym__external_close_parenthesis] = ACTIONS(5883),
    [sym__external_open_brace] = ACTIONS(5883),
    [sym__external_open_bracket] = ACTIONS(5883),
    [sym__external_open_bracket2] = ACTIONS(5883),
    [sym__external_close_bracket2] = ACTIONS(5883),
  },
  [2124] = {
    [sym_call_arguments] = STATE(2941),
    [sym_subset_arguments] = STATE(2942),
    [sym_subset2_arguments] = STATE(2943),
    [sym__open_parenthesis] = STATE(1755),
    [sym__open_bracket] = STATE(1763),
    [sym__open_bracket2] = STATE(1866),
    [sym_identifier] = ACTIONS(5435),
    [anon_sym_BSLASH] = ACTIONS(5433),
    [anon_sym_function] = ACTIONS(5435),
    [anon_sym_EQ] = ACTIONS(6919),
    [anon_sym_if] = ACTIONS(5435),
    [anon_sym_for] = ACTIONS(5435),
    [anon_sym_while] = ACTIONS(5435),
    [anon_sym_repeat] = ACTIONS(5435),
    [anon_sym_QMARK] = ACTIONS(5433),
    [anon_sym_TILDE] = ACTIONS(6921),
    [anon_sym_BANG] = ACTIONS(5435),
    [anon_sym_PLUS] = ACTIONS(6923),
    [anon_sym_DASH] = ACTIONS(6925),
    [anon_sym_LT_DASH] = ACTIONS(7147),
    [anon_sym_LT_LT_DASH] = ACTIONS(7147),
    [anon_sym_COLON_EQ] = ACTIONS(7147),
    [anon_sym_DASH_GT] = ACTIONS(6927),
    [anon_sym_DASH_GT_GT] = ACTIONS(6929),
    [anon_sym_PIPE] = ACTIONS(6931),
    [anon_sym_AMP] = ACTIONS(6933),
    [anon_sym_PIPE_PIPE] = ACTIONS(6935),
    [anon_sym_AMP_AMP] = ACTIONS(6937),
    [anon_sym_LT] = ACTIONS(6939),
    [anon_sym_LT_EQ] = ACTIONS(6941),
    [anon_sym_GT] = ACTIONS(6939),
    [anon_sym_GT_EQ] = ACTIONS(6941),
    [anon_sym_EQ_EQ] = ACTIONS(6941),
    [anon_sym_BANG_EQ] = ACTIONS(6941),
    [anon_sym_STAR] = ACTIONS(6943),
    [anon_sym_SLASH] = ACTIONS(6945),
    [anon_sym_STAR_STAR] = ACTIONS(6947),
    [anon_sym_CARET] = ACTIONS(6947),
    [aux_sym_binary_operator_token1] = ACTIONS(6949),
    [anon_sym_PIPE_GT] = ACTIONS(6949),
    [anon_sym_COLON] = ACTIONS(6951),
    [anon_sym_DOLLAR] = ACTIONS(6953),
    [anon_sym_AT] = ACTIONS(6953),
    [aux_sym__hex_literal_token1] = ACTIONS(5433),
    [sym__number_literal] = ACTIONS(5435),
    [anon_sym_SQUOTE] = ACTIONS(5433),
    [anon_sym_DQUOTE] = ACTIONS(5433),
    [sym_return] = ACTIONS(5435),
    [sym_next] = ACTIONS(5435),
    [sym_break] = ACTIONS(5435),
    [sym_true] = ACTIONS(5435),
    [sym_false] = ACTIONS(5435),
    [sym_null] = ACTIONS(5435),
    [sym_inf] = ACTIONS(5435),
    [sym_nan] = ACTIONS(5435),
    [anon_sym_NA] = ACTIONS(5435),
    [anon_sym_NA_integer_] = ACTIONS(5435),
    [anon_sym_NA_real_] = ACTIONS(5435),
    [anon_sym_NA_complex_] = ACTIONS(5435),
    [anon_sym_NA_character_] = ACTIONS(5435),
    [sym_dots] = ACTIONS(5435),
    [sym_dot_dot_i] = ACTIONS(5433),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5433),
    [sym__newline] = ACTIONS(5433),
    [sym__raw_string_literal] = ACTIONS(5433),
    [sym__external_open_parenthesis] = ACTIONS(6955),
    [sym__external_close_parenthesis] = ACTIONS(5433),
    [sym__external_open_brace] = ACTIONS(5433),
    [sym__external_open_bracket] = ACTIONS(6957),
    [sym__external_open_bracket2] = ACTIONS(6959),
  },
  [2125] = {
    [sym_call_arguments] = STATE(2985),
    [sym_subset_arguments] = STATE(2986),
    [sym_subset2_arguments] = STATE(2987),
    [sym__open_parenthesis] = STATE(1414),
    [sym__open_bracket] = STATE(1416),
    [sym__open_bracket2] = STATE(1428),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(7155),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(7079),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(7081),
    [anon_sym_DASH] = ACTIONS(7083),
    [anon_sym_LT_DASH] = ACTIONS(7157),
    [anon_sym_LT_LT_DASH] = ACTIONS(7157),
    [anon_sym_COLON_EQ] = ACTIONS(7157),
    [anon_sym_DASH_GT] = ACTIONS(7159),
    [anon_sym_DASH_GT_GT] = ACTIONS(7161),
    [anon_sym_PIPE] = ACTIONS(7085),
    [anon_sym_AMP] = ACTIONS(7087),
    [anon_sym_PIPE_PIPE] = ACTIONS(7089),
    [anon_sym_AMP_AMP] = ACTIONS(7091),
    [anon_sym_LT] = ACTIONS(7093),
    [anon_sym_LT_EQ] = ACTIONS(7095),
    [anon_sym_GT] = ACTIONS(7093),
    [anon_sym_GT_EQ] = ACTIONS(7095),
    [anon_sym_EQ_EQ] = ACTIONS(7095),
    [anon_sym_BANG_EQ] = ACTIONS(7095),
    [anon_sym_STAR] = ACTIONS(7097),
    [anon_sym_SLASH] = ACTIONS(7099),
    [anon_sym_STAR_STAR] = ACTIONS(7101),
    [anon_sym_CARET] = ACTIONS(7101),
    [aux_sym_binary_operator_token1] = ACTIONS(7103),
    [anon_sym_PIPE_GT] = ACTIONS(7103),
    [anon_sym_COLON] = ACTIONS(7105),
    [anon_sym_DOLLAR] = ACTIONS(7107),
    [anon_sym_AT] = ACTIONS(7107),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(7109),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(7111),
    [sym__external_open_bracket2] = ACTIONS(7113),
  },
  [2126] = {
    [sym_call_arguments] = STATE(2985),
    [sym_subset_arguments] = STATE(2986),
    [sym_subset2_arguments] = STATE(2987),
    [sym__open_parenthesis] = STATE(1414),
    [sym__open_bracket] = STATE(1416),
    [sym__open_bracket2] = STATE(1428),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(7097),
    [anon_sym_SLASH] = ACTIONS(7099),
    [anon_sym_STAR_STAR] = ACTIONS(7101),
    [anon_sym_CARET] = ACTIONS(7101),
    [aux_sym_binary_operator_token1] = ACTIONS(7103),
    [anon_sym_PIPE_GT] = ACTIONS(7103),
    [anon_sym_COLON] = ACTIONS(7105),
    [anon_sym_DOLLAR] = ACTIONS(7107),
    [anon_sym_AT] = ACTIONS(7107),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(7109),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(7111),
    [sym__external_open_bracket2] = ACTIONS(7113),
  },
  [2127] = {
    [sym_call_arguments] = STATE(2985),
    [sym_subset_arguments] = STATE(2986),
    [sym_subset2_arguments] = STATE(2987),
    [sym__open_parenthesis] = STATE(1414),
    [sym__open_bracket] = STATE(1416),
    [sym__open_bracket2] = STATE(1428),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(7081),
    [anon_sym_DASH] = ACTIONS(7083),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(7085),
    [anon_sym_AMP] = ACTIONS(7087),
    [anon_sym_PIPE_PIPE] = ACTIONS(7089),
    [anon_sym_AMP_AMP] = ACTIONS(7091),
    [anon_sym_LT] = ACTIONS(7093),
    [anon_sym_LT_EQ] = ACTIONS(7095),
    [anon_sym_GT] = ACTIONS(7093),
    [anon_sym_GT_EQ] = ACTIONS(7095),
    [anon_sym_EQ_EQ] = ACTIONS(7095),
    [anon_sym_BANG_EQ] = ACTIONS(7095),
    [anon_sym_STAR] = ACTIONS(7097),
    [anon_sym_SLASH] = ACTIONS(7099),
    [anon_sym_STAR_STAR] = ACTIONS(7101),
    [anon_sym_CARET] = ACTIONS(7101),
    [aux_sym_binary_operator_token1] = ACTIONS(7103),
    [anon_sym_PIPE_GT] = ACTIONS(7103),
    [anon_sym_COLON] = ACTIONS(7105),
    [anon_sym_DOLLAR] = ACTIONS(7107),
    [anon_sym_AT] = ACTIONS(7107),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(7109),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(7111),
    [sym__external_open_bracket2] = ACTIONS(7113),
  },
  [2128] = {
    [sym_call_arguments] = STATE(2985),
    [sym_subset_arguments] = STATE(2986),
    [sym_subset2_arguments] = STATE(2987),
    [sym__open_parenthesis] = STATE(1414),
    [sym__open_bracket] = STATE(1416),
    [sym__open_bracket2] = STATE(1428),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(7155),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(7079),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(7081),
    [anon_sym_DASH] = ACTIONS(7083),
    [anon_sym_LT_DASH] = ACTIONS(7157),
    [anon_sym_LT_LT_DASH] = ACTIONS(7157),
    [anon_sym_COLON_EQ] = ACTIONS(7157),
    [anon_sym_DASH_GT] = ACTIONS(7159),
    [anon_sym_DASH_GT_GT] = ACTIONS(7161),
    [anon_sym_PIPE] = ACTIONS(7085),
    [anon_sym_AMP] = ACTIONS(7087),
    [anon_sym_PIPE_PIPE] = ACTIONS(7089),
    [anon_sym_AMP_AMP] = ACTIONS(7091),
    [anon_sym_LT] = ACTIONS(7093),
    [anon_sym_LT_EQ] = ACTIONS(7095),
    [anon_sym_GT] = ACTIONS(7093),
    [anon_sym_GT_EQ] = ACTIONS(7095),
    [anon_sym_EQ_EQ] = ACTIONS(7095),
    [anon_sym_BANG_EQ] = ACTIONS(7095),
    [anon_sym_STAR] = ACTIONS(7097),
    [anon_sym_SLASH] = ACTIONS(7099),
    [anon_sym_STAR_STAR] = ACTIONS(7101),
    [anon_sym_CARET] = ACTIONS(7101),
    [aux_sym_binary_operator_token1] = ACTIONS(7103),
    [anon_sym_PIPE_GT] = ACTIONS(7103),
    [anon_sym_COLON] = ACTIONS(7105),
    [anon_sym_DOLLAR] = ACTIONS(7107),
    [anon_sym_AT] = ACTIONS(7107),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(7109),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(7111),
    [sym__external_open_bracket2] = ACTIONS(7113),
  },
  [2129] = {
    [sym_call_arguments] = STATE(2941),
    [sym_subset_arguments] = STATE(2942),
    [sym_subset2_arguments] = STATE(2943),
    [sym__open_parenthesis] = STATE(1755),
    [sym__open_bracket] = STATE(1763),
    [sym__open_bracket2] = STATE(1866),
    [sym_identifier] = ACTIONS(5439),
    [anon_sym_BSLASH] = ACTIONS(5437),
    [anon_sym_function] = ACTIONS(5439),
    [anon_sym_EQ] = ACTIONS(6919),
    [anon_sym_if] = ACTIONS(5439),
    [anon_sym_for] = ACTIONS(5439),
    [anon_sym_while] = ACTIONS(5439),
    [anon_sym_repeat] = ACTIONS(5439),
    [anon_sym_QMARK] = ACTIONS(5437),
    [anon_sym_TILDE] = ACTIONS(6921),
    [anon_sym_BANG] = ACTIONS(5439),
    [anon_sym_PLUS] = ACTIONS(6923),
    [anon_sym_DASH] = ACTIONS(6925),
    [anon_sym_LT_DASH] = ACTIONS(7147),
    [anon_sym_LT_LT_DASH] = ACTIONS(7147),
    [anon_sym_COLON_EQ] = ACTIONS(7147),
    [anon_sym_DASH_GT] = ACTIONS(6927),
    [anon_sym_DASH_GT_GT] = ACTIONS(6929),
    [anon_sym_PIPE] = ACTIONS(6931),
    [anon_sym_AMP] = ACTIONS(6933),
    [anon_sym_PIPE_PIPE] = ACTIONS(6935),
    [anon_sym_AMP_AMP] = ACTIONS(6937),
    [anon_sym_LT] = ACTIONS(6939),
    [anon_sym_LT_EQ] = ACTIONS(6941),
    [anon_sym_GT] = ACTIONS(6939),
    [anon_sym_GT_EQ] = ACTIONS(6941),
    [anon_sym_EQ_EQ] = ACTIONS(6941),
    [anon_sym_BANG_EQ] = ACTIONS(6941),
    [anon_sym_STAR] = ACTIONS(6943),
    [anon_sym_SLASH] = ACTIONS(6945),
    [anon_sym_STAR_STAR] = ACTIONS(6947),
    [anon_sym_CARET] = ACTIONS(6947),
    [aux_sym_binary_operator_token1] = ACTIONS(6949),
    [anon_sym_PIPE_GT] = ACTIONS(6949),
    [anon_sym_COLON] = ACTIONS(6951),
    [anon_sym_DOLLAR] = ACTIONS(6953),
    [anon_sym_AT] = ACTIONS(6953),
    [aux_sym__hex_literal_token1] = ACTIONS(5437),
    [sym__number_literal] = ACTIONS(5439),
    [anon_sym_SQUOTE] = ACTIONS(5437),
    [anon_sym_DQUOTE] = ACTIONS(5437),
    [sym_return] = ACTIONS(5439),
    [sym_next] = ACTIONS(5439),
    [sym_break] = ACTIONS(5439),
    [sym_true] = ACTIONS(5439),
    [sym_false] = ACTIONS(5439),
    [sym_null] = ACTIONS(5439),
    [sym_inf] = ACTIONS(5439),
    [sym_nan] = ACTIONS(5439),
    [anon_sym_NA] = ACTIONS(5439),
    [anon_sym_NA_integer_] = ACTIONS(5439),
    [anon_sym_NA_real_] = ACTIONS(5439),
    [anon_sym_NA_complex_] = ACTIONS(5439),
    [anon_sym_NA_character_] = ACTIONS(5439),
    [sym_dots] = ACTIONS(5439),
    [sym_dot_dot_i] = ACTIONS(5437),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5437),
    [sym__newline] = ACTIONS(5437),
    [sym__raw_string_literal] = ACTIONS(5437),
    [sym__external_open_parenthesis] = ACTIONS(6955),
    [sym__external_close_parenthesis] = ACTIONS(5437),
    [sym__external_open_brace] = ACTIONS(5437),
    [sym__external_open_bracket] = ACTIONS(6957),
    [sym__external_open_bracket2] = ACTIONS(6959),
  },
  [2130] = {
    [sym_call_arguments] = STATE(2941),
    [sym_subset_arguments] = STATE(2942),
    [sym_subset2_arguments] = STATE(2943),
    [sym__open_parenthesis] = STATE(1755),
    [sym__open_bracket] = STATE(1763),
    [sym__open_bracket2] = STATE(1866),
    [sym_identifier] = ACTIONS(5443),
    [anon_sym_BSLASH] = ACTIONS(5441),
    [anon_sym_function] = ACTIONS(5443),
    [anon_sym_EQ] = ACTIONS(6919),
    [anon_sym_if] = ACTIONS(5443),
    [anon_sym_for] = ACTIONS(5443),
    [anon_sym_while] = ACTIONS(5443),
    [anon_sym_repeat] = ACTIONS(5443),
    [anon_sym_QMARK] = ACTIONS(5441),
    [anon_sym_TILDE] = ACTIONS(6921),
    [anon_sym_BANG] = ACTIONS(5443),
    [anon_sym_PLUS] = ACTIONS(6923),
    [anon_sym_DASH] = ACTIONS(6925),
    [anon_sym_LT_DASH] = ACTIONS(7147),
    [anon_sym_LT_LT_DASH] = ACTIONS(7147),
    [anon_sym_COLON_EQ] = ACTIONS(7147),
    [anon_sym_DASH_GT] = ACTIONS(6927),
    [anon_sym_DASH_GT_GT] = ACTIONS(6929),
    [anon_sym_PIPE] = ACTIONS(6931),
    [anon_sym_AMP] = ACTIONS(6933),
    [anon_sym_PIPE_PIPE] = ACTIONS(6935),
    [anon_sym_AMP_AMP] = ACTIONS(6937),
    [anon_sym_LT] = ACTIONS(6939),
    [anon_sym_LT_EQ] = ACTIONS(6941),
    [anon_sym_GT] = ACTIONS(6939),
    [anon_sym_GT_EQ] = ACTIONS(6941),
    [anon_sym_EQ_EQ] = ACTIONS(6941),
    [anon_sym_BANG_EQ] = ACTIONS(6941),
    [anon_sym_STAR] = ACTIONS(6943),
    [anon_sym_SLASH] = ACTIONS(6945),
    [anon_sym_STAR_STAR] = ACTIONS(6947),
    [anon_sym_CARET] = ACTIONS(6947),
    [aux_sym_binary_operator_token1] = ACTIONS(6949),
    [anon_sym_PIPE_GT] = ACTIONS(6949),
    [anon_sym_COLON] = ACTIONS(6951),
    [anon_sym_DOLLAR] = ACTIONS(6953),
    [anon_sym_AT] = ACTIONS(6953),
    [aux_sym__hex_literal_token1] = ACTIONS(5441),
    [sym__number_literal] = ACTIONS(5443),
    [anon_sym_SQUOTE] = ACTIONS(5441),
    [anon_sym_DQUOTE] = ACTIONS(5441),
    [sym_return] = ACTIONS(5443),
    [sym_next] = ACTIONS(5443),
    [sym_break] = ACTIONS(5443),
    [sym_true] = ACTIONS(5443),
    [sym_false] = ACTIONS(5443),
    [sym_null] = ACTIONS(5443),
    [sym_inf] = ACTIONS(5443),
    [sym_nan] = ACTIONS(5443),
    [anon_sym_NA] = ACTIONS(5443),
    [anon_sym_NA_integer_] = ACTIONS(5443),
    [anon_sym_NA_real_] = ACTIONS(5443),
    [anon_sym_NA_complex_] = ACTIONS(5443),
    [anon_sym_NA_character_] = ACTIONS(5443),
    [sym_dots] = ACTIONS(5443),
    [sym_dot_dot_i] = ACTIONS(5441),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5441),
    [sym__newline] = ACTIONS(5441),
    [sym__raw_string_literal] = ACTIONS(5441),
    [sym__external_open_parenthesis] = ACTIONS(6955),
    [sym__external_close_parenthesis] = ACTIONS(5441),
    [sym__external_open_brace] = ACTIONS(5441),
    [sym__external_open_bracket] = ACTIONS(6957),
    [sym__external_open_bracket2] = ACTIONS(6959),
  },
  [2131] = {
    [sym_string] = STATE(2824),
    [sym__single_quoted_string] = STATE(2382),
    [sym__double_quoted_string] = STATE(2383),
    [sym__string_or_identifier] = STATE(2824),
    [aux_sym_function_definition_repeat1] = STATE(2146),
    [sym_identifier] = ACTIONS(7375),
    [anon_sym_BSLASH] = ACTIONS(5659),
    [anon_sym_function] = ACTIONS(5663),
    [anon_sym_EQ] = ACTIONS(5663),
    [anon_sym_if] = ACTIONS(5663),
    [anon_sym_for] = ACTIONS(5663),
    [anon_sym_while] = ACTIONS(5663),
    [anon_sym_repeat] = ACTIONS(5663),
    [anon_sym_QMARK] = ACTIONS(5659),
    [anon_sym_TILDE] = ACTIONS(5659),
    [anon_sym_BANG] = ACTIONS(5663),
    [anon_sym_PLUS] = ACTIONS(5659),
    [anon_sym_DASH] = ACTIONS(5663),
    [anon_sym_LT_DASH] = ACTIONS(5659),
    [anon_sym_LT_LT_DASH] = ACTIONS(5659),
    [anon_sym_COLON_EQ] = ACTIONS(5659),
    [anon_sym_DASH_GT] = ACTIONS(5663),
    [anon_sym_DASH_GT_GT] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(5663),
    [anon_sym_AMP] = ACTIONS(5663),
    [anon_sym_PIPE_PIPE] = ACTIONS(5659),
    [anon_sym_AMP_AMP] = ACTIONS(5659),
    [anon_sym_LT] = ACTIONS(5663),
    [anon_sym_LT_EQ] = ACTIONS(5659),
    [anon_sym_GT] = ACTIONS(5663),
    [anon_sym_GT_EQ] = ACTIONS(5659),
    [anon_sym_EQ_EQ] = ACTIONS(5659),
    [anon_sym_BANG_EQ] = ACTIONS(5659),
    [anon_sym_STAR] = ACTIONS(5663),
    [anon_sym_SLASH] = ACTIONS(5659),
    [anon_sym_STAR_STAR] = ACTIONS(5659),
    [anon_sym_CARET] = ACTIONS(5659),
    [aux_sym_binary_operator_token1] = ACTIONS(5659),
    [anon_sym_PIPE_GT] = ACTIONS(5659),
    [anon_sym_COLON] = ACTIONS(5663),
    [anon_sym_DOLLAR] = ACTIONS(5659),
    [anon_sym_AT] = ACTIONS(5659),
    [aux_sym__hex_literal_token1] = ACTIONS(5659),
    [sym__number_literal] = ACTIONS(5663),
    [anon_sym_SQUOTE] = ACTIONS(3706),
    [anon_sym_DQUOTE] = ACTIONS(3708),
    [sym_return] = ACTIONS(5663),
    [sym_next] = ACTIONS(5663),
    [sym_break] = ACTIONS(5663),
    [sym_true] = ACTIONS(5663),
    [sym_false] = ACTIONS(5663),
    [sym_null] = ACTIONS(5663),
    [sym_inf] = ACTIONS(5663),
    [sym_nan] = ACTIONS(5663),
    [anon_sym_NA] = ACTIONS(5663),
    [anon_sym_NA_integer_] = ACTIONS(5663),
    [anon_sym_NA_real_] = ACTIONS(5663),
    [anon_sym_NA_complex_] = ACTIONS(5663),
    [anon_sym_NA_character_] = ACTIONS(5663),
    [sym_dots] = ACTIONS(5663),
    [sym_dot_dot_i] = ACTIONS(5659),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5659),
    [sym__newline] = ACTIONS(7377),
    [sym__raw_string_literal] = ACTIONS(3718),
    [sym__external_else] = ACTIONS(5659),
    [sym__external_open_parenthesis] = ACTIONS(5659),
    [sym__external_open_brace] = ACTIONS(5659),
    [sym__external_open_bracket] = ACTIONS(5659),
    [sym__external_open_bracket2] = ACTIONS(5659),
    [sym__external_close_bracket2] = ACTIONS(5659),
  },
  [2132] = {
    [sym_call_arguments] = STATE(2941),
    [sym_subset_arguments] = STATE(2942),
    [sym_subset2_arguments] = STATE(2943),
    [sym__open_parenthesis] = STATE(1755),
    [sym__open_bracket] = STATE(1763),
    [sym__open_bracket2] = STATE(1866),
    [sym_identifier] = ACTIONS(5447),
    [anon_sym_BSLASH] = ACTIONS(5445),
    [anon_sym_function] = ACTIONS(5447),
    [anon_sym_EQ] = ACTIONS(6919),
    [anon_sym_if] = ACTIONS(5447),
    [anon_sym_for] = ACTIONS(5447),
    [anon_sym_while] = ACTIONS(5447),
    [anon_sym_repeat] = ACTIONS(5447),
    [anon_sym_QMARK] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(6921),
    [anon_sym_BANG] = ACTIONS(5447),
    [anon_sym_PLUS] = ACTIONS(6923),
    [anon_sym_DASH] = ACTIONS(6925),
    [anon_sym_LT_DASH] = ACTIONS(7147),
    [anon_sym_LT_LT_DASH] = ACTIONS(7147),
    [anon_sym_COLON_EQ] = ACTIONS(7147),
    [anon_sym_DASH_GT] = ACTIONS(6927),
    [anon_sym_DASH_GT_GT] = ACTIONS(6929),
    [anon_sym_PIPE] = ACTIONS(6931),
    [anon_sym_AMP] = ACTIONS(6933),
    [anon_sym_PIPE_PIPE] = ACTIONS(6935),
    [anon_sym_AMP_AMP] = ACTIONS(6937),
    [anon_sym_LT] = ACTIONS(6939),
    [anon_sym_LT_EQ] = ACTIONS(6941),
    [anon_sym_GT] = ACTIONS(6939),
    [anon_sym_GT_EQ] = ACTIONS(6941),
    [anon_sym_EQ_EQ] = ACTIONS(6941),
    [anon_sym_BANG_EQ] = ACTIONS(6941),
    [anon_sym_STAR] = ACTIONS(6943),
    [anon_sym_SLASH] = ACTIONS(6945),
    [anon_sym_STAR_STAR] = ACTIONS(6947),
    [anon_sym_CARET] = ACTIONS(6947),
    [aux_sym_binary_operator_token1] = ACTIONS(6949),
    [anon_sym_PIPE_GT] = ACTIONS(6949),
    [anon_sym_COLON] = ACTIONS(6951),
    [anon_sym_DOLLAR] = ACTIONS(6953),
    [anon_sym_AT] = ACTIONS(6953),
    [aux_sym__hex_literal_token1] = ACTIONS(5445),
    [sym__number_literal] = ACTIONS(5447),
    [anon_sym_SQUOTE] = ACTIONS(5445),
    [anon_sym_DQUOTE] = ACTIONS(5445),
    [sym_return] = ACTIONS(5447),
    [sym_next] = ACTIONS(5447),
    [sym_break] = ACTIONS(5447),
    [sym_true] = ACTIONS(5447),
    [sym_false] = ACTIONS(5447),
    [sym_null] = ACTIONS(5447),
    [sym_inf] = ACTIONS(5447),
    [sym_nan] = ACTIONS(5447),
    [anon_sym_NA] = ACTIONS(5447),
    [anon_sym_NA_integer_] = ACTIONS(5447),
    [anon_sym_NA_real_] = ACTIONS(5447),
    [anon_sym_NA_complex_] = ACTIONS(5447),
    [anon_sym_NA_character_] = ACTIONS(5447),
    [sym_dots] = ACTIONS(5447),
    [sym_dot_dot_i] = ACTIONS(5445),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5445),
    [sym__newline] = ACTIONS(5445),
    [sym__raw_string_literal] = ACTIONS(5445),
    [sym__external_open_parenthesis] = ACTIONS(6955),
    [sym__external_close_parenthesis] = ACTIONS(5445),
    [sym__external_open_brace] = ACTIONS(5445),
    [sym__external_open_bracket] = ACTIONS(6957),
    [sym__external_open_bracket2] = ACTIONS(6959),
  },
  [2133] = {
    [sym_call_arguments] = STATE(2941),
    [sym_subset_arguments] = STATE(2942),
    [sym_subset2_arguments] = STATE(2943),
    [sym__open_parenthesis] = STATE(1755),
    [sym__open_bracket] = STATE(1763),
    [sym__open_bracket2] = STATE(1866),
    [sym_identifier] = ACTIONS(5451),
    [anon_sym_BSLASH] = ACTIONS(5449),
    [anon_sym_function] = ACTIONS(5451),
    [anon_sym_EQ] = ACTIONS(6919),
    [anon_sym_if] = ACTIONS(5451),
    [anon_sym_for] = ACTIONS(5451),
    [anon_sym_while] = ACTIONS(5451),
    [anon_sym_repeat] = ACTIONS(5451),
    [anon_sym_QMARK] = ACTIONS(5449),
    [anon_sym_TILDE] = ACTIONS(6921),
    [anon_sym_BANG] = ACTIONS(5451),
    [anon_sym_PLUS] = ACTIONS(6923),
    [anon_sym_DASH] = ACTIONS(6925),
    [anon_sym_LT_DASH] = ACTIONS(7147),
    [anon_sym_LT_LT_DASH] = ACTIONS(7147),
    [anon_sym_COLON_EQ] = ACTIONS(7147),
    [anon_sym_DASH_GT] = ACTIONS(6927),
    [anon_sym_DASH_GT_GT] = ACTIONS(6929),
    [anon_sym_PIPE] = ACTIONS(6931),
    [anon_sym_AMP] = ACTIONS(6933),
    [anon_sym_PIPE_PIPE] = ACTIONS(6935),
    [anon_sym_AMP_AMP] = ACTIONS(6937),
    [anon_sym_LT] = ACTIONS(6939),
    [anon_sym_LT_EQ] = ACTIONS(6941),
    [anon_sym_GT] = ACTIONS(6939),
    [anon_sym_GT_EQ] = ACTIONS(6941),
    [anon_sym_EQ_EQ] = ACTIONS(6941),
    [anon_sym_BANG_EQ] = ACTIONS(6941),
    [anon_sym_STAR] = ACTIONS(6943),
    [anon_sym_SLASH] = ACTIONS(6945),
    [anon_sym_STAR_STAR] = ACTIONS(6947),
    [anon_sym_CARET] = ACTIONS(6947),
    [aux_sym_binary_operator_token1] = ACTIONS(6949),
    [anon_sym_PIPE_GT] = ACTIONS(6949),
    [anon_sym_COLON] = ACTIONS(6951),
    [anon_sym_DOLLAR] = ACTIONS(6953),
    [anon_sym_AT] = ACTIONS(6953),
    [aux_sym__hex_literal_token1] = ACTIONS(5449),
    [sym__number_literal] = ACTIONS(5451),
    [anon_sym_SQUOTE] = ACTIONS(5449),
    [anon_sym_DQUOTE] = ACTIONS(5449),
    [sym_return] = ACTIONS(5451),
    [sym_next] = ACTIONS(5451),
    [sym_break] = ACTIONS(5451),
    [sym_true] = ACTIONS(5451),
    [sym_false] = ACTIONS(5451),
    [sym_null] = ACTIONS(5451),
    [sym_inf] = ACTIONS(5451),
    [sym_nan] = ACTIONS(5451),
    [anon_sym_NA] = ACTIONS(5451),
    [anon_sym_NA_integer_] = ACTIONS(5451),
    [anon_sym_NA_real_] = ACTIONS(5451),
    [anon_sym_NA_complex_] = ACTIONS(5451),
    [anon_sym_NA_character_] = ACTIONS(5451),
    [sym_dots] = ACTIONS(5451),
    [sym_dot_dot_i] = ACTIONS(5449),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5449),
    [sym__newline] = ACTIONS(5449),
    [sym__raw_string_literal] = ACTIONS(5449),
    [sym__external_open_parenthesis] = ACTIONS(6955),
    [sym__external_close_parenthesis] = ACTIONS(5449),
    [sym__external_open_brace] = ACTIONS(5449),
    [sym__external_open_bracket] = ACTIONS(6957),
    [sym__external_open_bracket2] = ACTIONS(6959),
  },
  [2134] = {
    [sym_call_arguments] = STATE(2941),
    [sym_subset_arguments] = STATE(2942),
    [sym_subset2_arguments] = STATE(2943),
    [sym__open_parenthesis] = STATE(1755),
    [sym__open_bracket] = STATE(1763),
    [sym__open_bracket2] = STATE(1866),
    [sym_identifier] = ACTIONS(5455),
    [anon_sym_BSLASH] = ACTIONS(5453),
    [anon_sym_function] = ACTIONS(5455),
    [anon_sym_EQ] = ACTIONS(6919),
    [anon_sym_if] = ACTIONS(5455),
    [anon_sym_for] = ACTIONS(5455),
    [anon_sym_while] = ACTIONS(5455),
    [anon_sym_repeat] = ACTIONS(5455),
    [anon_sym_QMARK] = ACTIONS(5453),
    [anon_sym_TILDE] = ACTIONS(6921),
    [anon_sym_BANG] = ACTIONS(5455),
    [anon_sym_PLUS] = ACTIONS(6923),
    [anon_sym_DASH] = ACTIONS(6925),
    [anon_sym_LT_DASH] = ACTIONS(7147),
    [anon_sym_LT_LT_DASH] = ACTIONS(7147),
    [anon_sym_COLON_EQ] = ACTIONS(7147),
    [anon_sym_DASH_GT] = ACTIONS(6927),
    [anon_sym_DASH_GT_GT] = ACTIONS(6929),
    [anon_sym_PIPE] = ACTIONS(6931),
    [anon_sym_AMP] = ACTIONS(6933),
    [anon_sym_PIPE_PIPE] = ACTIONS(6935),
    [anon_sym_AMP_AMP] = ACTIONS(6937),
    [anon_sym_LT] = ACTIONS(6939),
    [anon_sym_LT_EQ] = ACTIONS(6941),
    [anon_sym_GT] = ACTIONS(6939),
    [anon_sym_GT_EQ] = ACTIONS(6941),
    [anon_sym_EQ_EQ] = ACTIONS(6941),
    [anon_sym_BANG_EQ] = ACTIONS(6941),
    [anon_sym_STAR] = ACTIONS(6943),
    [anon_sym_SLASH] = ACTIONS(6945),
    [anon_sym_STAR_STAR] = ACTIONS(6947),
    [anon_sym_CARET] = ACTIONS(6947),
    [aux_sym_binary_operator_token1] = ACTIONS(6949),
    [anon_sym_PIPE_GT] = ACTIONS(6949),
    [anon_sym_COLON] = ACTIONS(6951),
    [anon_sym_DOLLAR] = ACTIONS(6953),
    [anon_sym_AT] = ACTIONS(6953),
    [aux_sym__hex_literal_token1] = ACTIONS(5453),
    [sym__number_literal] = ACTIONS(5455),
    [anon_sym_SQUOTE] = ACTIONS(5453),
    [anon_sym_DQUOTE] = ACTIONS(5453),
    [sym_return] = ACTIONS(5455),
    [sym_next] = ACTIONS(5455),
    [sym_break] = ACTIONS(5455),
    [sym_true] = ACTIONS(5455),
    [sym_false] = ACTIONS(5455),
    [sym_null] = ACTIONS(5455),
    [sym_inf] = ACTIONS(5455),
    [sym_nan] = ACTIONS(5455),
    [anon_sym_NA] = ACTIONS(5455),
    [anon_sym_NA_integer_] = ACTIONS(5455),
    [anon_sym_NA_real_] = ACTIONS(5455),
    [anon_sym_NA_complex_] = ACTIONS(5455),
    [anon_sym_NA_character_] = ACTIONS(5455),
    [sym_dots] = ACTIONS(5455),
    [sym_dot_dot_i] = ACTIONS(5453),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5453),
    [sym__newline] = ACTIONS(5453),
    [sym__raw_string_literal] = ACTIONS(5453),
    [sym__external_open_parenthesis] = ACTIONS(6955),
    [sym__external_close_parenthesis] = ACTIONS(5453),
    [sym__external_open_brace] = ACTIONS(5453),
    [sym__external_open_bracket] = ACTIONS(6957),
    [sym__external_open_bracket2] = ACTIONS(6959),
  },
  [2135] = {
    [sym_call_arguments] = STATE(2985),
    [sym_subset_arguments] = STATE(2986),
    [sym_subset2_arguments] = STATE(2987),
    [sym__open_parenthesis] = STATE(1414),
    [sym__open_bracket] = STATE(1416),
    [sym__open_bracket2] = STATE(1428),
    [ts_builtin_sym_end] = ACTIONS(5349),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(7155),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(7079),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(7081),
    [anon_sym_DASH] = ACTIONS(7083),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(7159),
    [anon_sym_DASH_GT_GT] = ACTIONS(7161),
    [anon_sym_PIPE] = ACTIONS(7085),
    [anon_sym_AMP] = ACTIONS(7087),
    [anon_sym_PIPE_PIPE] = ACTIONS(7089),
    [anon_sym_AMP_AMP] = ACTIONS(7091),
    [anon_sym_LT] = ACTIONS(7093),
    [anon_sym_LT_EQ] = ACTIONS(7095),
    [anon_sym_GT] = ACTIONS(7093),
    [anon_sym_GT_EQ] = ACTIONS(7095),
    [anon_sym_EQ_EQ] = ACTIONS(7095),
    [anon_sym_BANG_EQ] = ACTIONS(7095),
    [anon_sym_STAR] = ACTIONS(7097),
    [anon_sym_SLASH] = ACTIONS(7099),
    [anon_sym_STAR_STAR] = ACTIONS(7101),
    [anon_sym_CARET] = ACTIONS(7101),
    [aux_sym_binary_operator_token1] = ACTIONS(7103),
    [anon_sym_PIPE_GT] = ACTIONS(7103),
    [anon_sym_COLON] = ACTIONS(7105),
    [anon_sym_DOLLAR] = ACTIONS(7107),
    [anon_sym_AT] = ACTIONS(7107),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5349),
    [sym__semicolon] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(7109),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(7111),
    [sym__external_open_bracket2] = ACTIONS(7113),
  },
  [2136] = {
    [sym_call_arguments] = STATE(2985),
    [sym_subset_arguments] = STATE(2986),
    [sym_subset2_arguments] = STATE(2987),
    [sym__open_parenthesis] = STATE(1414),
    [sym__open_bracket] = STATE(1416),
    [sym__open_bracket2] = STATE(1428),
    [ts_builtin_sym_end] = ACTIONS(5345),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5345),
    [anon_sym_DASH] = ACTIONS(5347),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5347),
    [anon_sym_AMP] = ACTIONS(5347),
    [anon_sym_PIPE_PIPE] = ACTIONS(5345),
    [anon_sym_AMP_AMP] = ACTIONS(5345),
    [anon_sym_LT] = ACTIONS(5347),
    [anon_sym_LT_EQ] = ACTIONS(5345),
    [anon_sym_GT] = ACTIONS(5347),
    [anon_sym_GT_EQ] = ACTIONS(5345),
    [anon_sym_EQ_EQ] = ACTIONS(5345),
    [anon_sym_BANG_EQ] = ACTIONS(5345),
    [anon_sym_STAR] = ACTIONS(5347),
    [anon_sym_SLASH] = ACTIONS(5345),
    [anon_sym_STAR_STAR] = ACTIONS(7101),
    [anon_sym_CARET] = ACTIONS(7101),
    [aux_sym_binary_operator_token1] = ACTIONS(5345),
    [anon_sym_PIPE_GT] = ACTIONS(5345),
    [anon_sym_COLON] = ACTIONS(5347),
    [anon_sym_DOLLAR] = ACTIONS(7107),
    [anon_sym_AT] = ACTIONS(7107),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5345),
    [sym__semicolon] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(7109),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(7111),
    [sym__external_open_bracket2] = ACTIONS(7113),
  },
  [2137] = {
    [sym_call_arguments] = STATE(2985),
    [sym_subset_arguments] = STATE(2986),
    [sym_subset2_arguments] = STATE(2987),
    [sym__open_parenthesis] = STATE(1414),
    [sym__open_bracket] = STATE(1416),
    [sym__open_bracket2] = STATE(1428),
    [ts_builtin_sym_end] = ACTIONS(5345),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(7081),
    [anon_sym_DASH] = ACTIONS(7083),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5347),
    [anon_sym_AMP] = ACTIONS(5347),
    [anon_sym_PIPE_PIPE] = ACTIONS(5345),
    [anon_sym_AMP_AMP] = ACTIONS(5345),
    [anon_sym_LT] = ACTIONS(7093),
    [anon_sym_LT_EQ] = ACTIONS(7095),
    [anon_sym_GT] = ACTIONS(7093),
    [anon_sym_GT_EQ] = ACTIONS(7095),
    [anon_sym_EQ_EQ] = ACTIONS(7095),
    [anon_sym_BANG_EQ] = ACTIONS(7095),
    [anon_sym_STAR] = ACTIONS(7097),
    [anon_sym_SLASH] = ACTIONS(7099),
    [anon_sym_STAR_STAR] = ACTIONS(7101),
    [anon_sym_CARET] = ACTIONS(7101),
    [aux_sym_binary_operator_token1] = ACTIONS(7103),
    [anon_sym_PIPE_GT] = ACTIONS(7103),
    [anon_sym_COLON] = ACTIONS(7105),
    [anon_sym_DOLLAR] = ACTIONS(7107),
    [anon_sym_AT] = ACTIONS(7107),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5345),
    [sym__semicolon] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(7109),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(7111),
    [sym__external_open_bracket2] = ACTIONS(7113),
  },
  [2138] = {
    [sym_call_arguments] = STATE(2941),
    [sym_subset_arguments] = STATE(2942),
    [sym_subset2_arguments] = STATE(2943),
    [sym__open_parenthesis] = STATE(1755),
    [sym__open_bracket] = STATE(1763),
    [sym__open_bracket2] = STATE(1866),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(5333),
    [anon_sym_DASH] = ACTIONS(5335),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5335),
    [anon_sym_AMP] = ACTIONS(5335),
    [anon_sym_PIPE_PIPE] = ACTIONS(5333),
    [anon_sym_AMP_AMP] = ACTIONS(5333),
    [anon_sym_LT] = ACTIONS(5335),
    [anon_sym_LT_EQ] = ACTIONS(5333),
    [anon_sym_GT] = ACTIONS(5335),
    [anon_sym_GT_EQ] = ACTIONS(5333),
    [anon_sym_EQ_EQ] = ACTIONS(5333),
    [anon_sym_BANG_EQ] = ACTIONS(5333),
    [anon_sym_STAR] = ACTIONS(5335),
    [anon_sym_SLASH] = ACTIONS(5333),
    [anon_sym_STAR_STAR] = ACTIONS(6947),
    [anon_sym_CARET] = ACTIONS(6947),
    [aux_sym_binary_operator_token1] = ACTIONS(5333),
    [anon_sym_PIPE_GT] = ACTIONS(5333),
    [anon_sym_COLON] = ACTIONS(5335),
    [anon_sym_DOLLAR] = ACTIONS(6953),
    [anon_sym_AT] = ACTIONS(6953),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(6955),
    [sym__external_close_parenthesis] = ACTIONS(5333),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(6957),
    [sym__external_open_bracket2] = ACTIONS(6959),
  },
  [2139] = {
    [sym_call_arguments] = STATE(2985),
    [sym_subset_arguments] = STATE(2986),
    [sym_subset2_arguments] = STATE(2987),
    [sym__open_parenthesis] = STATE(1414),
    [sym__open_bracket] = STATE(1416),
    [sym__open_bracket2] = STATE(1428),
    [ts_builtin_sym_end] = ACTIONS(5345),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(7081),
    [anon_sym_DASH] = ACTIONS(7083),
    [anon_sym_LT_DASH] = ACTIONS(5345),
    [anon_sym_LT_LT_DASH] = ACTIONS(5345),
    [anon_sym_COLON_EQ] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5347),
    [anon_sym_DASH_GT_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(7085),
    [anon_sym_AMP] = ACTIONS(7087),
    [anon_sym_PIPE_PIPE] = ACTIONS(7089),
    [anon_sym_AMP_AMP] = ACTIONS(7091),
    [anon_sym_LT] = ACTIONS(7093),
    [anon_sym_LT_EQ] = ACTIONS(7095),
    [anon_sym_GT] = ACTIONS(7093),
    [anon_sym_GT_EQ] = ACTIONS(7095),
    [anon_sym_EQ_EQ] = ACTIONS(7095),
    [anon_sym_BANG_EQ] = ACTIONS(7095),
    [anon_sym_STAR] = ACTIONS(7097),
    [anon_sym_SLASH] = ACTIONS(7099),
    [anon_sym_STAR_STAR] = ACTIONS(7101),
    [anon_sym_CARET] = ACTIONS(7101),
    [aux_sym_binary_operator_token1] = ACTIONS(7103),
    [anon_sym_PIPE_GT] = ACTIONS(7103),
    [anon_sym_COLON] = ACTIONS(7105),
    [anon_sym_DOLLAR] = ACTIONS(7107),
    [anon_sym_AT] = ACTIONS(7107),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5345),
    [sym__semicolon] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(7109),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(7111),
    [sym__external_open_bracket2] = ACTIONS(7113),
  },
  [2140] = {
    [sym_call_arguments] = STATE(2941),
    [sym_subset_arguments] = STATE(2942),
    [sym_subset2_arguments] = STATE(2943),
    [sym__open_parenthesis] = STATE(1755),
    [sym__open_bracket] = STATE(1763),
    [sym__open_bracket2] = STATE(1866),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(6923),
    [anon_sym_DASH] = ACTIONS(6925),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5335),
    [anon_sym_AMP] = ACTIONS(5335),
    [anon_sym_PIPE_PIPE] = ACTIONS(5333),
    [anon_sym_AMP_AMP] = ACTIONS(5333),
    [anon_sym_LT] = ACTIONS(6939),
    [anon_sym_LT_EQ] = ACTIONS(6941),
    [anon_sym_GT] = ACTIONS(6939),
    [anon_sym_GT_EQ] = ACTIONS(6941),
    [anon_sym_EQ_EQ] = ACTIONS(6941),
    [anon_sym_BANG_EQ] = ACTIONS(6941),
    [anon_sym_STAR] = ACTIONS(6943),
    [anon_sym_SLASH] = ACTIONS(6945),
    [anon_sym_STAR_STAR] = ACTIONS(6947),
    [anon_sym_CARET] = ACTIONS(6947),
    [aux_sym_binary_operator_token1] = ACTIONS(6949),
    [anon_sym_PIPE_GT] = ACTIONS(6949),
    [anon_sym_COLON] = ACTIONS(6951),
    [anon_sym_DOLLAR] = ACTIONS(6953),
    [anon_sym_AT] = ACTIONS(6953),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(6955),
    [sym__external_close_parenthesis] = ACTIONS(5333),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(6957),
    [sym__external_open_bracket2] = ACTIONS(6959),
  },
  [2141] = {
    [sym_call_arguments] = STATE(2941),
    [sym_subset_arguments] = STATE(2942),
    [sym_subset2_arguments] = STATE(2943),
    [sym__open_parenthesis] = STATE(1755),
    [sym__open_bracket] = STATE(1763),
    [sym__open_bracket2] = STATE(1866),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(6943),
    [anon_sym_SLASH] = ACTIONS(6945),
    [anon_sym_STAR_STAR] = ACTIONS(6947),
    [anon_sym_CARET] = ACTIONS(6947),
    [aux_sym_binary_operator_token1] = ACTIONS(6949),
    [anon_sym_PIPE_GT] = ACTIONS(6949),
    [anon_sym_COLON] = ACTIONS(6951),
    [anon_sym_DOLLAR] = ACTIONS(6953),
    [anon_sym_AT] = ACTIONS(6953),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6955),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6957),
    [sym__external_open_bracket2] = ACTIONS(6959),
  },
  [2142] = {
    [sym_call_arguments] = STATE(2941),
    [sym_subset_arguments] = STATE(2942),
    [sym_subset2_arguments] = STATE(2943),
    [sym__open_parenthesis] = STATE(1755),
    [sym__open_bracket] = STATE(1763),
    [sym__open_bracket2] = STATE(1866),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(6923),
    [anon_sym_DASH] = ACTIONS(6925),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(6931),
    [anon_sym_AMP] = ACTIONS(6933),
    [anon_sym_PIPE_PIPE] = ACTIONS(6935),
    [anon_sym_AMP_AMP] = ACTIONS(6937),
    [anon_sym_LT] = ACTIONS(6939),
    [anon_sym_LT_EQ] = ACTIONS(6941),
    [anon_sym_GT] = ACTIONS(6939),
    [anon_sym_GT_EQ] = ACTIONS(6941),
    [anon_sym_EQ_EQ] = ACTIONS(6941),
    [anon_sym_BANG_EQ] = ACTIONS(6941),
    [anon_sym_STAR] = ACTIONS(6943),
    [anon_sym_SLASH] = ACTIONS(6945),
    [anon_sym_STAR_STAR] = ACTIONS(6947),
    [anon_sym_CARET] = ACTIONS(6947),
    [aux_sym_binary_operator_token1] = ACTIONS(6949),
    [anon_sym_PIPE_GT] = ACTIONS(6949),
    [anon_sym_COLON] = ACTIONS(6951),
    [anon_sym_DOLLAR] = ACTIONS(6953),
    [anon_sym_AT] = ACTIONS(6953),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(6955),
    [sym__external_close_parenthesis] = ACTIONS(5333),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(6957),
    [sym__external_open_bracket2] = ACTIONS(6959),
  },
  [2143] = {
    [sym_string] = STATE(2602),
    [sym__single_quoted_string] = STATE(2265),
    [sym__double_quoted_string] = STATE(2264),
    [sym__string_or_identifier] = STATE(2602),
    [sym_identifier] = ACTIONS(7379),
    [anon_sym_BSLASH] = ACTIONS(5883),
    [anon_sym_function] = ACTIONS(5887),
    [anon_sym_EQ] = ACTIONS(5887),
    [anon_sym_if] = ACTIONS(5887),
    [anon_sym_for] = ACTIONS(5887),
    [anon_sym_while] = ACTIONS(5887),
    [anon_sym_repeat] = ACTIONS(5887),
    [anon_sym_QMARK] = ACTIONS(5883),
    [anon_sym_TILDE] = ACTIONS(5883),
    [anon_sym_BANG] = ACTIONS(5887),
    [anon_sym_PLUS] = ACTIONS(5883),
    [anon_sym_DASH] = ACTIONS(5887),
    [anon_sym_LT_DASH] = ACTIONS(5883),
    [anon_sym_LT_LT_DASH] = ACTIONS(5883),
    [anon_sym_COLON_EQ] = ACTIONS(5883),
    [anon_sym_DASH_GT] = ACTIONS(5887),
    [anon_sym_DASH_GT_GT] = ACTIONS(5883),
    [anon_sym_PIPE] = ACTIONS(5887),
    [anon_sym_AMP] = ACTIONS(5887),
    [anon_sym_PIPE_PIPE] = ACTIONS(5883),
    [anon_sym_AMP_AMP] = ACTIONS(5883),
    [anon_sym_LT] = ACTIONS(5887),
    [anon_sym_LT_EQ] = ACTIONS(5883),
    [anon_sym_GT] = ACTIONS(5887),
    [anon_sym_GT_EQ] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5883),
    [anon_sym_BANG_EQ] = ACTIONS(5883),
    [anon_sym_STAR] = ACTIONS(5887),
    [anon_sym_SLASH] = ACTIONS(5883),
    [anon_sym_STAR_STAR] = ACTIONS(5883),
    [anon_sym_CARET] = ACTIONS(5883),
    [aux_sym_binary_operator_token1] = ACTIONS(5883),
    [anon_sym_PIPE_GT] = ACTIONS(5883),
    [anon_sym_COLON] = ACTIONS(5887),
    [anon_sym_DOLLAR] = ACTIONS(5883),
    [anon_sym_AT] = ACTIONS(5883),
    [aux_sym__hex_literal_token1] = ACTIONS(5883),
    [sym__number_literal] = ACTIONS(5887),
    [anon_sym_SQUOTE] = ACTIONS(1317),
    [anon_sym_DQUOTE] = ACTIONS(1319),
    [sym_return] = ACTIONS(5887),
    [sym_next] = ACTIONS(5887),
    [sym_break] = ACTIONS(5887),
    [sym_true] = ACTIONS(5887),
    [sym_false] = ACTIONS(5887),
    [sym_null] = ACTIONS(5887),
    [sym_inf] = ACTIONS(5887),
    [sym_nan] = ACTIONS(5887),
    [anon_sym_NA] = ACTIONS(5887),
    [anon_sym_NA_integer_] = ACTIONS(5887),
    [anon_sym_NA_real_] = ACTIONS(5887),
    [anon_sym_NA_complex_] = ACTIONS(5887),
    [anon_sym_NA_character_] = ACTIONS(5887),
    [sym_dots] = ACTIONS(5887),
    [sym_dot_dot_i] = ACTIONS(5883),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5883),
    [sym__newline] = ACTIONS(5883),
    [sym__semicolon] = ACTIONS(5883),
    [sym__raw_string_literal] = ACTIONS(1329),
    [sym__external_open_parenthesis] = ACTIONS(5883),
    [sym__external_open_brace] = ACTIONS(5883),
    [sym__external_close_brace] = ACTIONS(5883),
    [sym__external_open_bracket] = ACTIONS(5883),
    [sym__external_close_bracket] = ACTIONS(5883),
    [sym__external_open_bracket2] = ACTIONS(5883),
  },
  [2144] = {
    [sym_call_arguments] = STATE(2941),
    [sym_subset_arguments] = STATE(2942),
    [sym_subset2_arguments] = STATE(2943),
    [sym__open_parenthesis] = STATE(1755),
    [sym__open_bracket] = STATE(1763),
    [sym__open_bracket2] = STATE(1866),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(6919),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(6921),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(6923),
    [anon_sym_DASH] = ACTIONS(6925),
    [anon_sym_LT_DASH] = ACTIONS(7147),
    [anon_sym_LT_LT_DASH] = ACTIONS(7147),
    [anon_sym_COLON_EQ] = ACTIONS(7147),
    [anon_sym_DASH_GT] = ACTIONS(6927),
    [anon_sym_DASH_GT_GT] = ACTIONS(6929),
    [anon_sym_PIPE] = ACTIONS(6931),
    [anon_sym_AMP] = ACTIONS(6933),
    [anon_sym_PIPE_PIPE] = ACTIONS(6935),
    [anon_sym_AMP_AMP] = ACTIONS(6937),
    [anon_sym_LT] = ACTIONS(6939),
    [anon_sym_LT_EQ] = ACTIONS(6941),
    [anon_sym_GT] = ACTIONS(6939),
    [anon_sym_GT_EQ] = ACTIONS(6941),
    [anon_sym_EQ_EQ] = ACTIONS(6941),
    [anon_sym_BANG_EQ] = ACTIONS(6941),
    [anon_sym_STAR] = ACTIONS(6943),
    [anon_sym_SLASH] = ACTIONS(6945),
    [anon_sym_STAR_STAR] = ACTIONS(6947),
    [anon_sym_CARET] = ACTIONS(6947),
    [aux_sym_binary_operator_token1] = ACTIONS(6949),
    [anon_sym_PIPE_GT] = ACTIONS(6949),
    [anon_sym_COLON] = ACTIONS(6951),
    [anon_sym_DOLLAR] = ACTIONS(6953),
    [anon_sym_AT] = ACTIONS(6953),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(6955),
    [sym__external_close_parenthesis] = ACTIONS(5333),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(6957),
    [sym__external_open_bracket2] = ACTIONS(6959),
  },
  [2145] = {
    [sym_call_arguments] = STATE(2941),
    [sym_subset_arguments] = STATE(2942),
    [sym_subset2_arguments] = STATE(2943),
    [sym__open_parenthesis] = STATE(1755),
    [sym__open_bracket] = STATE(1763),
    [sym__open_bracket2] = STATE(1866),
    [sym_identifier] = ACTIONS(5331),
    [anon_sym_BSLASH] = ACTIONS(5329),
    [anon_sym_function] = ACTIONS(5331),
    [anon_sym_EQ] = ACTIONS(6919),
    [anon_sym_if] = ACTIONS(5331),
    [anon_sym_for] = ACTIONS(5331),
    [anon_sym_while] = ACTIONS(5331),
    [anon_sym_repeat] = ACTIONS(5331),
    [anon_sym_QMARK] = ACTIONS(5329),
    [anon_sym_TILDE] = ACTIONS(6921),
    [anon_sym_BANG] = ACTIONS(5331),
    [anon_sym_PLUS] = ACTIONS(6923),
    [anon_sym_DASH] = ACTIONS(6925),
    [anon_sym_LT_DASH] = ACTIONS(7147),
    [anon_sym_LT_LT_DASH] = ACTIONS(7147),
    [anon_sym_COLON_EQ] = ACTIONS(7147),
    [anon_sym_DASH_GT] = ACTIONS(6927),
    [anon_sym_DASH_GT_GT] = ACTIONS(6929),
    [anon_sym_PIPE] = ACTIONS(6931),
    [anon_sym_AMP] = ACTIONS(6933),
    [anon_sym_PIPE_PIPE] = ACTIONS(6935),
    [anon_sym_AMP_AMP] = ACTIONS(6937),
    [anon_sym_LT] = ACTIONS(6939),
    [anon_sym_LT_EQ] = ACTIONS(6941),
    [anon_sym_GT] = ACTIONS(6939),
    [anon_sym_GT_EQ] = ACTIONS(6941),
    [anon_sym_EQ_EQ] = ACTIONS(6941),
    [anon_sym_BANG_EQ] = ACTIONS(6941),
    [anon_sym_STAR] = ACTIONS(6943),
    [anon_sym_SLASH] = ACTIONS(6945),
    [anon_sym_STAR_STAR] = ACTIONS(6947),
    [anon_sym_CARET] = ACTIONS(6947),
    [aux_sym_binary_operator_token1] = ACTIONS(6949),
    [anon_sym_PIPE_GT] = ACTIONS(6949),
    [anon_sym_COLON] = ACTIONS(6951),
    [anon_sym_DOLLAR] = ACTIONS(6953),
    [anon_sym_AT] = ACTIONS(6953),
    [aux_sym__hex_literal_token1] = ACTIONS(5329),
    [sym__number_literal] = ACTIONS(5331),
    [anon_sym_SQUOTE] = ACTIONS(5329),
    [anon_sym_DQUOTE] = ACTIONS(5329),
    [sym_return] = ACTIONS(5331),
    [sym_next] = ACTIONS(5331),
    [sym_break] = ACTIONS(5331),
    [sym_true] = ACTIONS(5331),
    [sym_false] = ACTIONS(5331),
    [sym_null] = ACTIONS(5331),
    [sym_inf] = ACTIONS(5331),
    [sym_nan] = ACTIONS(5331),
    [anon_sym_NA] = ACTIONS(5331),
    [anon_sym_NA_integer_] = ACTIONS(5331),
    [anon_sym_NA_real_] = ACTIONS(5331),
    [anon_sym_NA_complex_] = ACTIONS(5331),
    [anon_sym_NA_character_] = ACTIONS(5331),
    [sym_dots] = ACTIONS(5331),
    [sym_dot_dot_i] = ACTIONS(5329),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5329),
    [sym__newline] = ACTIONS(5329),
    [sym__raw_string_literal] = ACTIONS(5329),
    [sym__external_open_parenthesis] = ACTIONS(6955),
    [sym__external_close_parenthesis] = ACTIONS(5329),
    [sym__external_open_brace] = ACTIONS(5329),
    [sym__external_open_bracket] = ACTIONS(6957),
    [sym__external_open_bracket2] = ACTIONS(6959),
  },
  [2146] = {
    [sym_string] = STATE(2799),
    [sym__single_quoted_string] = STATE(2382),
    [sym__double_quoted_string] = STATE(2383),
    [sym__string_or_identifier] = STATE(2799),
    [aux_sym_function_definition_repeat1] = STATE(2722),
    [sym_identifier] = ACTIONS(7381),
    [anon_sym_BSLASH] = ACTIONS(5669),
    [anon_sym_function] = ACTIONS(5673),
    [anon_sym_EQ] = ACTIONS(5673),
    [anon_sym_if] = ACTIONS(5673),
    [anon_sym_for] = ACTIONS(5673),
    [anon_sym_while] = ACTIONS(5673),
    [anon_sym_repeat] = ACTIONS(5673),
    [anon_sym_QMARK] = ACTIONS(5669),
    [anon_sym_TILDE] = ACTIONS(5669),
    [anon_sym_BANG] = ACTIONS(5673),
    [anon_sym_PLUS] = ACTIONS(5669),
    [anon_sym_DASH] = ACTIONS(5673),
    [anon_sym_LT_DASH] = ACTIONS(5669),
    [anon_sym_LT_LT_DASH] = ACTIONS(5669),
    [anon_sym_COLON_EQ] = ACTIONS(5669),
    [anon_sym_DASH_GT] = ACTIONS(5673),
    [anon_sym_DASH_GT_GT] = ACTIONS(5669),
    [anon_sym_PIPE] = ACTIONS(5673),
    [anon_sym_AMP] = ACTIONS(5673),
    [anon_sym_PIPE_PIPE] = ACTIONS(5669),
    [anon_sym_AMP_AMP] = ACTIONS(5669),
    [anon_sym_LT] = ACTIONS(5673),
    [anon_sym_LT_EQ] = ACTIONS(5669),
    [anon_sym_GT] = ACTIONS(5673),
    [anon_sym_GT_EQ] = ACTIONS(5669),
    [anon_sym_EQ_EQ] = ACTIONS(5669),
    [anon_sym_BANG_EQ] = ACTIONS(5669),
    [anon_sym_STAR] = ACTIONS(5673),
    [anon_sym_SLASH] = ACTIONS(5669),
    [anon_sym_STAR_STAR] = ACTIONS(5669),
    [anon_sym_CARET] = ACTIONS(5669),
    [aux_sym_binary_operator_token1] = ACTIONS(5669),
    [anon_sym_PIPE_GT] = ACTIONS(5669),
    [anon_sym_COLON] = ACTIONS(5673),
    [anon_sym_DOLLAR] = ACTIONS(5669),
    [anon_sym_AT] = ACTIONS(5669),
    [aux_sym__hex_literal_token1] = ACTIONS(5669),
    [sym__number_literal] = ACTIONS(5673),
    [anon_sym_SQUOTE] = ACTIONS(3706),
    [anon_sym_DQUOTE] = ACTIONS(3708),
    [sym_return] = ACTIONS(5673),
    [sym_next] = ACTIONS(5673),
    [sym_break] = ACTIONS(5673),
    [sym_true] = ACTIONS(5673),
    [sym_false] = ACTIONS(5673),
    [sym_null] = ACTIONS(5673),
    [sym_inf] = ACTIONS(5673),
    [sym_nan] = ACTIONS(5673),
    [anon_sym_NA] = ACTIONS(5673),
    [anon_sym_NA_integer_] = ACTIONS(5673),
    [anon_sym_NA_real_] = ACTIONS(5673),
    [anon_sym_NA_complex_] = ACTIONS(5673),
    [anon_sym_NA_character_] = ACTIONS(5673),
    [sym_dots] = ACTIONS(5673),
    [sym_dot_dot_i] = ACTIONS(5669),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5669),
    [sym__newline] = ACTIONS(5669),
    [sym__raw_string_literal] = ACTIONS(3718),
    [sym__external_else] = ACTIONS(5669),
    [sym__external_open_parenthesis] = ACTIONS(5669),
    [sym__external_open_brace] = ACTIONS(5669),
    [sym__external_open_bracket] = ACTIONS(5669),
    [sym__external_open_bracket2] = ACTIONS(5669),
    [sym__external_close_bracket2] = ACTIONS(5669),
  },
  [2147] = {
    [sym_call_arguments] = STATE(2985),
    [sym_subset_arguments] = STATE(2986),
    [sym_subset2_arguments] = STATE(2987),
    [sym__open_parenthesis] = STATE(1414),
    [sym__open_bracket] = STATE(1416),
    [sym__open_bracket2] = STATE(1428),
    [ts_builtin_sym_end] = ACTIONS(5345),
    [sym_identifier] = ACTIONS(5347),
    [anon_sym_BSLASH] = ACTIONS(5345),
    [anon_sym_function] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(7155),
    [anon_sym_if] = ACTIONS(5347),
    [anon_sym_for] = ACTIONS(5347),
    [anon_sym_while] = ACTIONS(5347),
    [anon_sym_repeat] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5345),
    [anon_sym_TILDE] = ACTIONS(7079),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(7081),
    [anon_sym_DASH] = ACTIONS(7083),
    [anon_sym_LT_DASH] = ACTIONS(7157),
    [anon_sym_LT_LT_DASH] = ACTIONS(7157),
    [anon_sym_COLON_EQ] = ACTIONS(7157),
    [anon_sym_DASH_GT] = ACTIONS(7159),
    [anon_sym_DASH_GT_GT] = ACTIONS(7161),
    [anon_sym_PIPE] = ACTIONS(7085),
    [anon_sym_AMP] = ACTIONS(7087),
    [anon_sym_PIPE_PIPE] = ACTIONS(7089),
    [anon_sym_AMP_AMP] = ACTIONS(7091),
    [anon_sym_LT] = ACTIONS(7093),
    [anon_sym_LT_EQ] = ACTIONS(7095),
    [anon_sym_GT] = ACTIONS(7093),
    [anon_sym_GT_EQ] = ACTIONS(7095),
    [anon_sym_EQ_EQ] = ACTIONS(7095),
    [anon_sym_BANG_EQ] = ACTIONS(7095),
    [anon_sym_STAR] = ACTIONS(7097),
    [anon_sym_SLASH] = ACTIONS(7099),
    [anon_sym_STAR_STAR] = ACTIONS(7101),
    [anon_sym_CARET] = ACTIONS(7101),
    [aux_sym_binary_operator_token1] = ACTIONS(7103),
    [anon_sym_PIPE_GT] = ACTIONS(7103),
    [anon_sym_COLON] = ACTIONS(7105),
    [anon_sym_DOLLAR] = ACTIONS(7107),
    [anon_sym_AT] = ACTIONS(7107),
    [aux_sym__hex_literal_token1] = ACTIONS(5345),
    [sym__number_literal] = ACTIONS(5347),
    [anon_sym_SQUOTE] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [sym_return] = ACTIONS(5347),
    [sym_next] = ACTIONS(5347),
    [sym_break] = ACTIONS(5347),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [sym_null] = ACTIONS(5347),
    [sym_inf] = ACTIONS(5347),
    [sym_nan] = ACTIONS(5347),
    [anon_sym_NA] = ACTIONS(5347),
    [anon_sym_NA_integer_] = ACTIONS(5347),
    [anon_sym_NA_real_] = ACTIONS(5347),
    [anon_sym_NA_complex_] = ACTIONS(5347),
    [anon_sym_NA_character_] = ACTIONS(5347),
    [sym_dots] = ACTIONS(5347),
    [sym_dot_dot_i] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5345),
    [sym__semicolon] = ACTIONS(5345),
    [sym__raw_string_literal] = ACTIONS(5345),
    [sym__external_open_parenthesis] = ACTIONS(7109),
    [sym__external_open_brace] = ACTIONS(5345),
    [sym__external_open_bracket] = ACTIONS(7111),
    [sym__external_open_bracket2] = ACTIONS(7113),
  },
  [2148] = {
    [sym_call_arguments] = STATE(2985),
    [sym_subset_arguments] = STATE(2986),
    [sym_subset2_arguments] = STATE(2987),
    [sym__open_parenthesis] = STATE(1414),
    [sym__open_bracket] = STATE(1416),
    [sym__open_bracket2] = STATE(1428),
    [ts_builtin_sym_end] = ACTIONS(5341),
    [sym_identifier] = ACTIONS(5343),
    [anon_sym_BSLASH] = ACTIONS(5341),
    [anon_sym_function] = ACTIONS(5343),
    [anon_sym_EQ] = ACTIONS(7155),
    [anon_sym_if] = ACTIONS(5343),
    [anon_sym_for] = ACTIONS(5343),
    [anon_sym_while] = ACTIONS(5343),
    [anon_sym_repeat] = ACTIONS(5343),
    [anon_sym_QMARK] = ACTIONS(5341),
    [anon_sym_TILDE] = ACTIONS(7079),
    [anon_sym_BANG] = ACTIONS(5343),
    [anon_sym_PLUS] = ACTIONS(7081),
    [anon_sym_DASH] = ACTIONS(7083),
    [anon_sym_LT_DASH] = ACTIONS(7157),
    [anon_sym_LT_LT_DASH] = ACTIONS(7157),
    [anon_sym_COLON_EQ] = ACTIONS(7157),
    [anon_sym_DASH_GT] = ACTIONS(7159),
    [anon_sym_DASH_GT_GT] = ACTIONS(7161),
    [anon_sym_PIPE] = ACTIONS(7085),
    [anon_sym_AMP] = ACTIONS(7087),
    [anon_sym_PIPE_PIPE] = ACTIONS(7089),
    [anon_sym_AMP_AMP] = ACTIONS(7091),
    [anon_sym_LT] = ACTIONS(7093),
    [anon_sym_LT_EQ] = ACTIONS(7095),
    [anon_sym_GT] = ACTIONS(7093),
    [anon_sym_GT_EQ] = ACTIONS(7095),
    [anon_sym_EQ_EQ] = ACTIONS(7095),
    [anon_sym_BANG_EQ] = ACTIONS(7095),
    [anon_sym_STAR] = ACTIONS(7097),
    [anon_sym_SLASH] = ACTIONS(7099),
    [anon_sym_STAR_STAR] = ACTIONS(7101),
    [anon_sym_CARET] = ACTIONS(7101),
    [aux_sym_binary_operator_token1] = ACTIONS(7103),
    [anon_sym_PIPE_GT] = ACTIONS(7103),
    [anon_sym_COLON] = ACTIONS(7105),
    [anon_sym_DOLLAR] = ACTIONS(7107),
    [anon_sym_AT] = ACTIONS(7107),
    [aux_sym__hex_literal_token1] = ACTIONS(5341),
    [sym__number_literal] = ACTIONS(5343),
    [anon_sym_SQUOTE] = ACTIONS(5341),
    [anon_sym_DQUOTE] = ACTIONS(5341),
    [sym_return] = ACTIONS(5343),
    [sym_next] = ACTIONS(5343),
    [sym_break] = ACTIONS(5343),
    [sym_true] = ACTIONS(5343),
    [sym_false] = ACTIONS(5343),
    [sym_null] = ACTIONS(5343),
    [sym_inf] = ACTIONS(5343),
    [sym_nan] = ACTIONS(5343),
    [anon_sym_NA] = ACTIONS(5343),
    [anon_sym_NA_integer_] = ACTIONS(5343),
    [anon_sym_NA_real_] = ACTIONS(5343),
    [anon_sym_NA_complex_] = ACTIONS(5343),
    [anon_sym_NA_character_] = ACTIONS(5343),
    [sym_dots] = ACTIONS(5343),
    [sym_dot_dot_i] = ACTIONS(5341),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5341),
    [sym__semicolon] = ACTIONS(5341),
    [sym__raw_string_literal] = ACTIONS(5341),
    [sym__external_open_parenthesis] = ACTIONS(7109),
    [sym__external_open_brace] = ACTIONS(5341),
    [sym__external_open_bracket] = ACTIONS(7111),
    [sym__external_open_bracket2] = ACTIONS(7113),
  },
  [2149] = {
    [sym_call_arguments] = STATE(2985),
    [sym_subset_arguments] = STATE(2986),
    [sym_subset2_arguments] = STATE(2987),
    [sym__open_parenthesis] = STATE(1414),
    [sym__open_bracket] = STATE(1416),
    [sym__open_bracket2] = STATE(1428),
    [ts_builtin_sym_end] = ACTIONS(5337),
    [sym_identifier] = ACTIONS(5339),
    [anon_sym_BSLASH] = ACTIONS(5337),
    [anon_sym_function] = ACTIONS(5339),
    [anon_sym_EQ] = ACTIONS(7155),
    [anon_sym_if] = ACTIONS(5339),
    [anon_sym_for] = ACTIONS(5339),
    [anon_sym_while] = ACTIONS(5339),
    [anon_sym_repeat] = ACTIONS(5339),
    [anon_sym_QMARK] = ACTIONS(5337),
    [anon_sym_TILDE] = ACTIONS(7079),
    [anon_sym_BANG] = ACTIONS(5339),
    [anon_sym_PLUS] = ACTIONS(7081),
    [anon_sym_DASH] = ACTIONS(7083),
    [anon_sym_LT_DASH] = ACTIONS(7157),
    [anon_sym_LT_LT_DASH] = ACTIONS(7157),
    [anon_sym_COLON_EQ] = ACTIONS(7157),
    [anon_sym_DASH_GT] = ACTIONS(7159),
    [anon_sym_DASH_GT_GT] = ACTIONS(7161),
    [anon_sym_PIPE] = ACTIONS(7085),
    [anon_sym_AMP] = ACTIONS(7087),
    [anon_sym_PIPE_PIPE] = ACTIONS(7089),
    [anon_sym_AMP_AMP] = ACTIONS(7091),
    [anon_sym_LT] = ACTIONS(7093),
    [anon_sym_LT_EQ] = ACTIONS(7095),
    [anon_sym_GT] = ACTIONS(7093),
    [anon_sym_GT_EQ] = ACTIONS(7095),
    [anon_sym_EQ_EQ] = ACTIONS(7095),
    [anon_sym_BANG_EQ] = ACTIONS(7095),
    [anon_sym_STAR] = ACTIONS(7097),
    [anon_sym_SLASH] = ACTIONS(7099),
    [anon_sym_STAR_STAR] = ACTIONS(7101),
    [anon_sym_CARET] = ACTIONS(7101),
    [aux_sym_binary_operator_token1] = ACTIONS(7103),
    [anon_sym_PIPE_GT] = ACTIONS(7103),
    [anon_sym_COLON] = ACTIONS(7105),
    [anon_sym_DOLLAR] = ACTIONS(7107),
    [anon_sym_AT] = ACTIONS(7107),
    [aux_sym__hex_literal_token1] = ACTIONS(5337),
    [sym__number_literal] = ACTIONS(5339),
    [anon_sym_SQUOTE] = ACTIONS(5337),
    [anon_sym_DQUOTE] = ACTIONS(5337),
    [sym_return] = ACTIONS(5339),
    [sym_next] = ACTIONS(5339),
    [sym_break] = ACTIONS(5339),
    [sym_true] = ACTIONS(5339),
    [sym_false] = ACTIONS(5339),
    [sym_null] = ACTIONS(5339),
    [sym_inf] = ACTIONS(5339),
    [sym_nan] = ACTIONS(5339),
    [anon_sym_NA] = ACTIONS(5339),
    [anon_sym_NA_integer_] = ACTIONS(5339),
    [anon_sym_NA_real_] = ACTIONS(5339),
    [anon_sym_NA_complex_] = ACTIONS(5339),
    [anon_sym_NA_character_] = ACTIONS(5339),
    [sym_dots] = ACTIONS(5339),
    [sym_dot_dot_i] = ACTIONS(5337),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5337),
    [sym__semicolon] = ACTIONS(5337),
    [sym__raw_string_literal] = ACTIONS(5337),
    [sym__external_open_parenthesis] = ACTIONS(7109),
    [sym__external_open_brace] = ACTIONS(5337),
    [sym__external_open_bracket] = ACTIONS(7111),
    [sym__external_open_bracket2] = ACTIONS(7113),
  },
  [2150] = {
    [sym_call_arguments] = STATE(2941),
    [sym_subset_arguments] = STATE(2942),
    [sym_subset2_arguments] = STATE(2943),
    [sym__open_parenthesis] = STATE(1755),
    [sym__open_bracket] = STATE(1763),
    [sym__open_bracket2] = STATE(1866),
    [sym_identifier] = ACTIONS(5411),
    [anon_sym_BSLASH] = ACTIONS(5409),
    [anon_sym_function] = ACTIONS(5411),
    [anon_sym_EQ] = ACTIONS(6919),
    [anon_sym_if] = ACTIONS(5411),
    [anon_sym_for] = ACTIONS(5411),
    [anon_sym_while] = ACTIONS(5411),
    [anon_sym_repeat] = ACTIONS(5411),
    [anon_sym_QMARK] = ACTIONS(5409),
    [anon_sym_TILDE] = ACTIONS(6921),
    [anon_sym_BANG] = ACTIONS(5411),
    [anon_sym_PLUS] = ACTIONS(6923),
    [anon_sym_DASH] = ACTIONS(6925),
    [anon_sym_LT_DASH] = ACTIONS(7147),
    [anon_sym_LT_LT_DASH] = ACTIONS(7147),
    [anon_sym_COLON_EQ] = ACTIONS(7147),
    [anon_sym_DASH_GT] = ACTIONS(6927),
    [anon_sym_DASH_GT_GT] = ACTIONS(6929),
    [anon_sym_PIPE] = ACTIONS(6931),
    [anon_sym_AMP] = ACTIONS(6933),
    [anon_sym_PIPE_PIPE] = ACTIONS(6935),
    [anon_sym_AMP_AMP] = ACTIONS(6937),
    [anon_sym_LT] = ACTIONS(6939),
    [anon_sym_LT_EQ] = ACTIONS(6941),
    [anon_sym_GT] = ACTIONS(6939),
    [anon_sym_GT_EQ] = ACTIONS(6941),
    [anon_sym_EQ_EQ] = ACTIONS(6941),
    [anon_sym_BANG_EQ] = ACTIONS(6941),
    [anon_sym_STAR] = ACTIONS(6943),
    [anon_sym_SLASH] = ACTIONS(6945),
    [anon_sym_STAR_STAR] = ACTIONS(6947),
    [anon_sym_CARET] = ACTIONS(6947),
    [aux_sym_binary_operator_token1] = ACTIONS(6949),
    [anon_sym_PIPE_GT] = ACTIONS(6949),
    [anon_sym_COLON] = ACTIONS(6951),
    [anon_sym_DOLLAR] = ACTIONS(6953),
    [anon_sym_AT] = ACTIONS(6953),
    [aux_sym__hex_literal_token1] = ACTIONS(5409),
    [sym__number_literal] = ACTIONS(5411),
    [anon_sym_SQUOTE] = ACTIONS(5409),
    [anon_sym_DQUOTE] = ACTIONS(5409),
    [sym_return] = ACTIONS(5411),
    [sym_next] = ACTIONS(5411),
    [sym_break] = ACTIONS(5411),
    [sym_true] = ACTIONS(5411),
    [sym_false] = ACTIONS(5411),
    [sym_null] = ACTIONS(5411),
    [sym_inf] = ACTIONS(5411),
    [sym_nan] = ACTIONS(5411),
    [anon_sym_NA] = ACTIONS(5411),
    [anon_sym_NA_integer_] = ACTIONS(5411),
    [anon_sym_NA_real_] = ACTIONS(5411),
    [anon_sym_NA_complex_] = ACTIONS(5411),
    [anon_sym_NA_character_] = ACTIONS(5411),
    [sym_dots] = ACTIONS(5411),
    [sym_dot_dot_i] = ACTIONS(5409),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5409),
    [sym__newline] = ACTIONS(5409),
    [sym__raw_string_literal] = ACTIONS(5409),
    [sym__external_open_parenthesis] = ACTIONS(6955),
    [sym__external_close_parenthesis] = ACTIONS(5409),
    [sym__external_open_brace] = ACTIONS(5409),
    [sym__external_open_bracket] = ACTIONS(6957),
    [sym__external_open_bracket2] = ACTIONS(6959),
  },
  [2151] = {
    [sym_call_arguments] = STATE(3027),
    [sym_subset_arguments] = STATE(3026),
    [sym_subset2_arguments] = STATE(3025),
    [sym__open_parenthesis] = STATE(1616),
    [sym__open_bracket] = STATE(1615),
    [sym__open_bracket2] = STATE(1613),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(5333),
    [anon_sym_DASH] = ACTIONS(5335),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5335),
    [anon_sym_AMP] = ACTIONS(5335),
    [anon_sym_PIPE_PIPE] = ACTIONS(5333),
    [anon_sym_AMP_AMP] = ACTIONS(5333),
    [anon_sym_LT] = ACTIONS(5335),
    [anon_sym_LT_EQ] = ACTIONS(5333),
    [anon_sym_GT] = ACTIONS(5335),
    [anon_sym_GT_EQ] = ACTIONS(5333),
    [anon_sym_EQ_EQ] = ACTIONS(5333),
    [anon_sym_BANG_EQ] = ACTIONS(5333),
    [anon_sym_STAR] = ACTIONS(5335),
    [anon_sym_SLASH] = ACTIONS(5333),
    [anon_sym_STAR_STAR] = ACTIONS(7065),
    [anon_sym_CARET] = ACTIONS(7065),
    [aux_sym_binary_operator_token1] = ACTIONS(5333),
    [anon_sym_PIPE_GT] = ACTIONS(5333),
    [anon_sym_COLON] = ACTIONS(5335),
    [anon_sym_DOLLAR] = ACTIONS(7071),
    [anon_sym_AT] = ACTIONS(7071),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(7073),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(7075),
    [sym__external_close_bracket] = ACTIONS(5333),
    [sym__external_open_bracket2] = ACTIONS(7077),
  },
  [2152] = {
    [sym_call_arguments] = STATE(2941),
    [sym_subset_arguments] = STATE(2942),
    [sym_subset2_arguments] = STATE(2943),
    [sym__open_parenthesis] = STATE(1755),
    [sym__open_bracket] = STATE(1763),
    [sym__open_bracket2] = STATE(1866),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(6919),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(6921),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(6923),
    [anon_sym_DASH] = ACTIONS(6925),
    [anon_sym_LT_DASH] = ACTIONS(7147),
    [anon_sym_LT_LT_DASH] = ACTIONS(7147),
    [anon_sym_COLON_EQ] = ACTIONS(7147),
    [anon_sym_DASH_GT] = ACTIONS(6927),
    [anon_sym_DASH_GT_GT] = ACTIONS(6929),
    [anon_sym_PIPE] = ACTIONS(6931),
    [anon_sym_AMP] = ACTIONS(6933),
    [anon_sym_PIPE_PIPE] = ACTIONS(6935),
    [anon_sym_AMP_AMP] = ACTIONS(6937),
    [anon_sym_LT] = ACTIONS(6939),
    [anon_sym_LT_EQ] = ACTIONS(6941),
    [anon_sym_GT] = ACTIONS(6939),
    [anon_sym_GT_EQ] = ACTIONS(6941),
    [anon_sym_EQ_EQ] = ACTIONS(6941),
    [anon_sym_BANG_EQ] = ACTIONS(6941),
    [anon_sym_STAR] = ACTIONS(6943),
    [anon_sym_SLASH] = ACTIONS(6945),
    [anon_sym_STAR_STAR] = ACTIONS(6947),
    [anon_sym_CARET] = ACTIONS(6947),
    [aux_sym_binary_operator_token1] = ACTIONS(6949),
    [anon_sym_PIPE_GT] = ACTIONS(6949),
    [anon_sym_COLON] = ACTIONS(6951),
    [anon_sym_DOLLAR] = ACTIONS(6953),
    [anon_sym_AT] = ACTIONS(6953),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6955),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6957),
    [sym__external_open_bracket2] = ACTIONS(6959),
  },
  [2153] = {
    [sym_call_arguments] = STATE(2941),
    [sym_subset_arguments] = STATE(2942),
    [sym_subset2_arguments] = STATE(2943),
    [sym__open_parenthesis] = STATE(1755),
    [sym__open_bracket] = STATE(1763),
    [sym__open_bracket2] = STATE(1866),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(6923),
    [anon_sym_DASH] = ACTIONS(6925),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(6931),
    [anon_sym_AMP] = ACTIONS(6933),
    [anon_sym_PIPE_PIPE] = ACTIONS(6935),
    [anon_sym_AMP_AMP] = ACTIONS(6937),
    [anon_sym_LT] = ACTIONS(6939),
    [anon_sym_LT_EQ] = ACTIONS(6941),
    [anon_sym_GT] = ACTIONS(6939),
    [anon_sym_GT_EQ] = ACTIONS(6941),
    [anon_sym_EQ_EQ] = ACTIONS(6941),
    [anon_sym_BANG_EQ] = ACTIONS(6941),
    [anon_sym_STAR] = ACTIONS(6943),
    [anon_sym_SLASH] = ACTIONS(6945),
    [anon_sym_STAR_STAR] = ACTIONS(6947),
    [anon_sym_CARET] = ACTIONS(6947),
    [aux_sym_binary_operator_token1] = ACTIONS(6949),
    [anon_sym_PIPE_GT] = ACTIONS(6949),
    [anon_sym_COLON] = ACTIONS(6951),
    [anon_sym_DOLLAR] = ACTIONS(6953),
    [anon_sym_AT] = ACTIONS(6953),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6955),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6957),
    [sym__external_open_bracket2] = ACTIONS(6959),
  },
  [2154] = {
    [sym_call_arguments] = STATE(2941),
    [sym_subset_arguments] = STATE(2942),
    [sym_subset2_arguments] = STATE(2943),
    [sym__open_parenthesis] = STATE(1755),
    [sym__open_bracket] = STATE(1763),
    [sym__open_bracket2] = STATE(1866),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(6921),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(6923),
    [anon_sym_DASH] = ACTIONS(6925),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(6931),
    [anon_sym_AMP] = ACTIONS(6933),
    [anon_sym_PIPE_PIPE] = ACTIONS(6935),
    [anon_sym_AMP_AMP] = ACTIONS(6937),
    [anon_sym_LT] = ACTIONS(6939),
    [anon_sym_LT_EQ] = ACTIONS(6941),
    [anon_sym_GT] = ACTIONS(6939),
    [anon_sym_GT_EQ] = ACTIONS(6941),
    [anon_sym_EQ_EQ] = ACTIONS(6941),
    [anon_sym_BANG_EQ] = ACTIONS(6941),
    [anon_sym_STAR] = ACTIONS(6943),
    [anon_sym_SLASH] = ACTIONS(6945),
    [anon_sym_STAR_STAR] = ACTIONS(6947),
    [anon_sym_CARET] = ACTIONS(6947),
    [aux_sym_binary_operator_token1] = ACTIONS(6949),
    [anon_sym_PIPE_GT] = ACTIONS(6949),
    [anon_sym_COLON] = ACTIONS(6951),
    [anon_sym_DOLLAR] = ACTIONS(6953),
    [anon_sym_AT] = ACTIONS(6953),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6955),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6957),
    [sym__external_open_bracket2] = ACTIONS(6959),
  },
  [2155] = {
    [sym_string] = STATE(2871),
    [sym__single_quoted_string] = STATE(2442),
    [sym__double_quoted_string] = STATE(2437),
    [sym__string_or_identifier] = STATE(2871),
    [aux_sym_function_definition_repeat1] = STATE(2617),
    [sym_identifier] = ACTIONS(7383),
    [anon_sym_BSLASH] = ACTIONS(5669),
    [anon_sym_function] = ACTIONS(5673),
    [anon_sym_EQ] = ACTIONS(5673),
    [anon_sym_if] = ACTIONS(5673),
    [anon_sym_for] = ACTIONS(5673),
    [anon_sym_while] = ACTIONS(5673),
    [anon_sym_repeat] = ACTIONS(5673),
    [anon_sym_QMARK] = ACTIONS(5669),
    [anon_sym_TILDE] = ACTIONS(5669),
    [anon_sym_BANG] = ACTIONS(5673),
    [anon_sym_PLUS] = ACTIONS(5669),
    [anon_sym_DASH] = ACTIONS(5673),
    [anon_sym_LT_DASH] = ACTIONS(5669),
    [anon_sym_LT_LT_DASH] = ACTIONS(5669),
    [anon_sym_COLON_EQ] = ACTIONS(5669),
    [anon_sym_DASH_GT] = ACTIONS(5673),
    [anon_sym_DASH_GT_GT] = ACTIONS(5669),
    [anon_sym_PIPE] = ACTIONS(5673),
    [anon_sym_AMP] = ACTIONS(5673),
    [anon_sym_PIPE_PIPE] = ACTIONS(5669),
    [anon_sym_AMP_AMP] = ACTIONS(5669),
    [anon_sym_LT] = ACTIONS(5673),
    [anon_sym_LT_EQ] = ACTIONS(5669),
    [anon_sym_GT] = ACTIONS(5673),
    [anon_sym_GT_EQ] = ACTIONS(5669),
    [anon_sym_EQ_EQ] = ACTIONS(5669),
    [anon_sym_BANG_EQ] = ACTIONS(5669),
    [anon_sym_STAR] = ACTIONS(5673),
    [anon_sym_SLASH] = ACTIONS(5669),
    [anon_sym_STAR_STAR] = ACTIONS(5669),
    [anon_sym_CARET] = ACTIONS(5669),
    [aux_sym_binary_operator_token1] = ACTIONS(5669),
    [anon_sym_PIPE_GT] = ACTIONS(5669),
    [anon_sym_COLON] = ACTIONS(5673),
    [anon_sym_DOLLAR] = ACTIONS(5669),
    [anon_sym_AT] = ACTIONS(5669),
    [aux_sym__hex_literal_token1] = ACTIONS(5669),
    [sym__number_literal] = ACTIONS(5673),
    [anon_sym_SQUOTE] = ACTIONS(2559),
    [anon_sym_DQUOTE] = ACTIONS(2561),
    [sym_return] = ACTIONS(5673),
    [sym_next] = ACTIONS(5673),
    [sym_break] = ACTIONS(5673),
    [sym_true] = ACTIONS(5673),
    [sym_false] = ACTIONS(5673),
    [sym_null] = ACTIONS(5673),
    [sym_inf] = ACTIONS(5673),
    [sym_nan] = ACTIONS(5673),
    [anon_sym_NA] = ACTIONS(5673),
    [anon_sym_NA_integer_] = ACTIONS(5673),
    [anon_sym_NA_real_] = ACTIONS(5673),
    [anon_sym_NA_complex_] = ACTIONS(5673),
    [anon_sym_NA_character_] = ACTIONS(5673),
    [sym_dots] = ACTIONS(5673),
    [sym_dot_dot_i] = ACTIONS(5669),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5669),
    [sym__newline] = ACTIONS(5669),
    [sym__raw_string_literal] = ACTIONS(2571),
    [sym__external_open_parenthesis] = ACTIONS(5669),
    [sym__external_close_parenthesis] = ACTIONS(5669),
    [sym__external_open_brace] = ACTIONS(5669),
    [sym__external_open_bracket] = ACTIONS(5669),
    [sym__external_close_bracket] = ACTIONS(5669),
    [sym__external_open_bracket2] = ACTIONS(5669),
  },
  [2156] = {
    [sym_call_arguments] = STATE(2985),
    [sym_subset_arguments] = STATE(2986),
    [sym_subset2_arguments] = STATE(2987),
    [sym__open_parenthesis] = STATE(1414),
    [sym__open_bracket] = STATE(1416),
    [sym__open_bracket2] = STATE(1428),
    [ts_builtin_sym_end] = ACTIONS(5263),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_BSLASH] = ACTIONS(5263),
    [anon_sym_function] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5261),
    [anon_sym_if] = ACTIONS(5261),
    [anon_sym_for] = ACTIONS(5261),
    [anon_sym_while] = ACTIONS(5261),
    [anon_sym_repeat] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_TILDE] = ACTIONS(5263),
    [anon_sym_BANG] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5263),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_LT_DASH] = ACTIONS(5263),
    [anon_sym_LT_LT_DASH] = ACTIONS(5263),
    [anon_sym_COLON_EQ] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5261),
    [anon_sym_DASH_GT_GT] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5263),
    [anon_sym_STAR_STAR] = ACTIONS(7101),
    [anon_sym_CARET] = ACTIONS(7101),
    [aux_sym_binary_operator_token1] = ACTIONS(5263),
    [anon_sym_PIPE_GT] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(5261),
    [anon_sym_DOLLAR] = ACTIONS(7107),
    [anon_sym_AT] = ACTIONS(7107),
    [aux_sym__hex_literal_token1] = ACTIONS(5263),
    [sym__number_literal] = ACTIONS(5261),
    [anon_sym_SQUOTE] = ACTIONS(5263),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [sym_return] = ACTIONS(5261),
    [sym_next] = ACTIONS(5261),
    [sym_break] = ACTIONS(5261),
    [sym_true] = ACTIONS(5261),
    [sym_false] = ACTIONS(5261),
    [sym_null] = ACTIONS(5261),
    [sym_inf] = ACTIONS(5261),
    [sym_nan] = ACTIONS(5261),
    [anon_sym_NA] = ACTIONS(5261),
    [anon_sym_NA_integer_] = ACTIONS(5261),
    [anon_sym_NA_real_] = ACTIONS(5261),
    [anon_sym_NA_complex_] = ACTIONS(5261),
    [anon_sym_NA_character_] = ACTIONS(5261),
    [sym_dots] = ACTIONS(5261),
    [sym_dot_dot_i] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5263),
    [sym__semicolon] = ACTIONS(5263),
    [sym__raw_string_literal] = ACTIONS(5263),
    [sym__external_open_parenthesis] = ACTIONS(7109),
    [sym__external_open_brace] = ACTIONS(5263),
    [sym__external_open_bracket] = ACTIONS(7111),
    [sym__external_open_bracket2] = ACTIONS(7113),
  },
  [2157] = {
    [sym_call_arguments] = STATE(2941),
    [sym_subset_arguments] = STATE(2942),
    [sym_subset2_arguments] = STATE(2943),
    [sym__open_parenthesis] = STATE(1755),
    [sym__open_bracket] = STATE(1763),
    [sym__open_bracket2] = STATE(1866),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(6923),
    [anon_sym_DASH] = ACTIONS(6925),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(6933),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(6937),
    [anon_sym_LT] = ACTIONS(6939),
    [anon_sym_LT_EQ] = ACTIONS(6941),
    [anon_sym_GT] = ACTIONS(6939),
    [anon_sym_GT_EQ] = ACTIONS(6941),
    [anon_sym_EQ_EQ] = ACTIONS(6941),
    [anon_sym_BANG_EQ] = ACTIONS(6941),
    [anon_sym_STAR] = ACTIONS(6943),
    [anon_sym_SLASH] = ACTIONS(6945),
    [anon_sym_STAR_STAR] = ACTIONS(6947),
    [anon_sym_CARET] = ACTIONS(6947),
    [aux_sym_binary_operator_token1] = ACTIONS(6949),
    [anon_sym_PIPE_GT] = ACTIONS(6949),
    [anon_sym_COLON] = ACTIONS(6951),
    [anon_sym_DOLLAR] = ACTIONS(6953),
    [anon_sym_AT] = ACTIONS(6953),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6955),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6957),
    [sym__external_open_bracket2] = ACTIONS(6959),
  },
  [2158] = {
    [sym_call_arguments] = STATE(3027),
    [sym_subset_arguments] = STATE(3026),
    [sym_subset2_arguments] = STATE(3025),
    [sym__open_parenthesis] = STATE(1616),
    [sym__open_bracket] = STATE(1615),
    [sym__open_bracket2] = STATE(1613),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(7039),
    [anon_sym_DASH] = ACTIONS(7041),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5335),
    [anon_sym_AMP] = ACTIONS(5335),
    [anon_sym_PIPE_PIPE] = ACTIONS(5333),
    [anon_sym_AMP_AMP] = ACTIONS(5333),
    [anon_sym_LT] = ACTIONS(7057),
    [anon_sym_LT_EQ] = ACTIONS(7059),
    [anon_sym_GT] = ACTIONS(7057),
    [anon_sym_GT_EQ] = ACTIONS(7059),
    [anon_sym_EQ_EQ] = ACTIONS(7059),
    [anon_sym_BANG_EQ] = ACTIONS(7059),
    [anon_sym_STAR] = ACTIONS(7061),
    [anon_sym_SLASH] = ACTIONS(7063),
    [anon_sym_STAR_STAR] = ACTIONS(7065),
    [anon_sym_CARET] = ACTIONS(7065),
    [aux_sym_binary_operator_token1] = ACTIONS(7067),
    [anon_sym_PIPE_GT] = ACTIONS(7067),
    [anon_sym_COLON] = ACTIONS(7069),
    [anon_sym_DOLLAR] = ACTIONS(7071),
    [anon_sym_AT] = ACTIONS(7071),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(7073),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(7075),
    [sym__external_close_bracket] = ACTIONS(5333),
    [sym__external_open_bracket2] = ACTIONS(7077),
  },
  [2159] = {
    [sym_call_arguments] = STATE(2941),
    [sym_subset_arguments] = STATE(2942),
    [sym_subset2_arguments] = STATE(2943),
    [sym__open_parenthesis] = STATE(1755),
    [sym__open_bracket] = STATE(1763),
    [sym__open_bracket2] = STATE(1866),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_BSLASH] = ACTIONS(5349),
    [anon_sym_function] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_if] = ACTIONS(5351),
    [anon_sym_for] = ACTIONS(5351),
    [anon_sym_while] = ACTIONS(5351),
    [anon_sym_repeat] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_LT_DASH] = ACTIONS(5349),
    [anon_sym_LT_LT_DASH] = ACTIONS(5349),
    [anon_sym_COLON_EQ] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_DASH_GT_GT] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5349),
    [anon_sym_STAR_STAR] = ACTIONS(6947),
    [anon_sym_CARET] = ACTIONS(6947),
    [aux_sym_binary_operator_token1] = ACTIONS(6949),
    [anon_sym_PIPE_GT] = ACTIONS(6949),
    [anon_sym_COLON] = ACTIONS(6951),
    [anon_sym_DOLLAR] = ACTIONS(6953),
    [anon_sym_AT] = ACTIONS(6953),
    [aux_sym__hex_literal_token1] = ACTIONS(5349),
    [sym__number_literal] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(5349),
    [sym_return] = ACTIONS(5351),
    [sym_next] = ACTIONS(5351),
    [sym_break] = ACTIONS(5351),
    [sym_true] = ACTIONS(5351),
    [sym_false] = ACTIONS(5351),
    [sym_null] = ACTIONS(5351),
    [sym_inf] = ACTIONS(5351),
    [sym_nan] = ACTIONS(5351),
    [anon_sym_NA] = ACTIONS(5351),
    [anon_sym_NA_integer_] = ACTIONS(5351),
    [anon_sym_NA_real_] = ACTIONS(5351),
    [anon_sym_NA_complex_] = ACTIONS(5351),
    [anon_sym_NA_character_] = ACTIONS(5351),
    [sym_dots] = ACTIONS(5351),
    [sym_dot_dot_i] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5349),
    [sym__newline] = ACTIONS(5349),
    [sym__raw_string_literal] = ACTIONS(5349),
    [sym__external_open_parenthesis] = ACTIONS(6955),
    [sym__external_close_parenthesis] = ACTIONS(5349),
    [sym__external_open_brace] = ACTIONS(5349),
    [sym__external_open_bracket] = ACTIONS(6957),
    [sym__external_open_bracket2] = ACTIONS(6959),
  },
  [2160] = {
    [sym_call_arguments] = STATE(3027),
    [sym_subset_arguments] = STATE(3026),
    [sym_subset2_arguments] = STATE(3025),
    [sym__open_parenthesis] = STATE(1616),
    [sym__open_bracket] = STATE(1615),
    [sym__open_bracket2] = STATE(1613),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(5333),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(7039),
    [anon_sym_DASH] = ACTIONS(7041),
    [anon_sym_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_COLON_EQ] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5335),
    [anon_sym_DASH_GT_GT] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(7049),
    [anon_sym_AMP] = ACTIONS(7051),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_AMP_AMP] = ACTIONS(7055),
    [anon_sym_LT] = ACTIONS(7057),
    [anon_sym_LT_EQ] = ACTIONS(7059),
    [anon_sym_GT] = ACTIONS(7057),
    [anon_sym_GT_EQ] = ACTIONS(7059),
    [anon_sym_EQ_EQ] = ACTIONS(7059),
    [anon_sym_BANG_EQ] = ACTIONS(7059),
    [anon_sym_STAR] = ACTIONS(7061),
    [anon_sym_SLASH] = ACTIONS(7063),
    [anon_sym_STAR_STAR] = ACTIONS(7065),
    [anon_sym_CARET] = ACTIONS(7065),
    [aux_sym_binary_operator_token1] = ACTIONS(7067),
    [anon_sym_PIPE_GT] = ACTIONS(7067),
    [anon_sym_COLON] = ACTIONS(7069),
    [anon_sym_DOLLAR] = ACTIONS(7071),
    [anon_sym_AT] = ACTIONS(7071),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(7073),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(7075),
    [sym__external_close_bracket] = ACTIONS(5333),
    [sym__external_open_bracket2] = ACTIONS(7077),
  },
  [2161] = {
    [sym_string] = STATE(2713),
    [sym__single_quoted_string] = STATE(2273),
    [sym__double_quoted_string] = STATE(2274),
    [sym__string_or_identifier] = STATE(2713),
    [sym_identifier] = ACTIONS(7385),
    [anon_sym_BSLASH] = ACTIONS(5883),
    [anon_sym_function] = ACTIONS(5887),
    [anon_sym_EQ] = ACTIONS(5887),
    [anon_sym_if] = ACTIONS(5887),
    [anon_sym_for] = ACTIONS(5887),
    [anon_sym_while] = ACTIONS(5887),
    [anon_sym_repeat] = ACTIONS(5887),
    [anon_sym_QMARK] = ACTIONS(5883),
    [anon_sym_TILDE] = ACTIONS(5883),
    [anon_sym_BANG] = ACTIONS(5887),
    [anon_sym_PLUS] = ACTIONS(5883),
    [anon_sym_DASH] = ACTIONS(5887),
    [anon_sym_LT_DASH] = ACTIONS(5883),
    [anon_sym_LT_LT_DASH] = ACTIONS(5883),
    [anon_sym_COLON_EQ] = ACTIONS(5883),
    [anon_sym_DASH_GT] = ACTIONS(5887),
    [anon_sym_DASH_GT_GT] = ACTIONS(5883),
    [anon_sym_PIPE] = ACTIONS(5887),
    [anon_sym_AMP] = ACTIONS(5887),
    [anon_sym_PIPE_PIPE] = ACTIONS(5883),
    [anon_sym_AMP_AMP] = ACTIONS(5883),
    [anon_sym_LT] = ACTIONS(5887),
    [anon_sym_LT_EQ] = ACTIONS(5883),
    [anon_sym_GT] = ACTIONS(5887),
    [anon_sym_GT_EQ] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5883),
    [anon_sym_BANG_EQ] = ACTIONS(5883),
    [anon_sym_STAR] = ACTIONS(5887),
    [anon_sym_SLASH] = ACTIONS(5883),
    [anon_sym_STAR_STAR] = ACTIONS(5883),
    [anon_sym_CARET] = ACTIONS(5883),
    [aux_sym_binary_operator_token1] = ACTIONS(5883),
    [anon_sym_PIPE_GT] = ACTIONS(5883),
    [anon_sym_COLON] = ACTIONS(5887),
    [anon_sym_DOLLAR] = ACTIONS(5883),
    [anon_sym_AT] = ACTIONS(5883),
    [aux_sym__hex_literal_token1] = ACTIONS(5883),
    [sym__number_literal] = ACTIONS(5887),
    [anon_sym_SQUOTE] = ACTIONS(1269),
    [anon_sym_DQUOTE] = ACTIONS(1271),
    [sym_return] = ACTIONS(5887),
    [sym_next] = ACTIONS(5887),
    [sym_break] = ACTIONS(5887),
    [sym_true] = ACTIONS(5887),
    [sym_false] = ACTIONS(5887),
    [sym_null] = ACTIONS(5887),
    [sym_inf] = ACTIONS(5887),
    [sym_nan] = ACTIONS(5887),
    [anon_sym_NA] = ACTIONS(5887),
    [anon_sym_NA_integer_] = ACTIONS(5887),
    [anon_sym_NA_real_] = ACTIONS(5887),
    [anon_sym_NA_complex_] = ACTIONS(5887),
    [anon_sym_NA_character_] = ACTIONS(5887),
    [sym_dots] = ACTIONS(5887),
    [sym_dot_dot_i] = ACTIONS(5883),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5883),
    [sym__newline] = ACTIONS(5883),
    [sym__raw_string_literal] = ACTIONS(1281),
    [sym__external_else] = ACTIONS(5883),
    [sym__external_open_parenthesis] = ACTIONS(5883),
    [sym__external_close_parenthesis] = ACTIONS(5883),
    [sym__external_open_brace] = ACTIONS(5883),
    [sym__external_open_bracket] = ACTIONS(5883),
    [sym__external_close_bracket] = ACTIONS(5883),
    [sym__external_open_bracket2] = ACTIONS(5883),
  },
  [2162] = {
    [sym_call_arguments] = STATE(3027),
    [sym_subset_arguments] = STATE(3026),
    [sym_subset2_arguments] = STATE(3025),
    [sym__open_parenthesis] = STATE(1616),
    [sym__open_bracket] = STATE(1615),
    [sym__open_bracket2] = STATE(1613),
    [sym_identifier] = ACTIONS(5401),
    [anon_sym_BSLASH] = ACTIONS(5399),
    [anon_sym_function] = ACTIONS(5401),
    [anon_sym_EQ] = ACTIONS(7035),
    [anon_sym_if] = ACTIONS(5401),
    [anon_sym_for] = ACTIONS(5401),
    [anon_sym_while] = ACTIONS(5401),
    [anon_sym_repeat] = ACTIONS(5401),
    [anon_sym_QMARK] = ACTIONS(5399),
    [anon_sym_TILDE] = ACTIONS(7037),
    [anon_sym_BANG] = ACTIONS(5401),
    [anon_sym_PLUS] = ACTIONS(7039),
    [anon_sym_DASH] = ACTIONS(7041),
    [anon_sym_LT_DASH] = ACTIONS(7043),
    [anon_sym_LT_LT_DASH] = ACTIONS(7043),
    [anon_sym_COLON_EQ] = ACTIONS(7043),
    [anon_sym_DASH_GT] = ACTIONS(7045),
    [anon_sym_DASH_GT_GT] = ACTIONS(7047),
    [anon_sym_PIPE] = ACTIONS(7049),
    [anon_sym_AMP] = ACTIONS(7051),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_AMP_AMP] = ACTIONS(7055),
    [anon_sym_LT] = ACTIONS(7057),
    [anon_sym_LT_EQ] = ACTIONS(7059),
    [anon_sym_GT] = ACTIONS(7057),
    [anon_sym_GT_EQ] = ACTIONS(7059),
    [anon_sym_EQ_EQ] = ACTIONS(7059),
    [anon_sym_BANG_EQ] = ACTIONS(7059),
    [anon_sym_STAR] = ACTIONS(7061),
    [anon_sym_SLASH] = ACTIONS(7063),
    [anon_sym_STAR_STAR] = ACTIONS(7065),
    [anon_sym_CARET] = ACTIONS(7065),
    [aux_sym_binary_operator_token1] = ACTIONS(7067),
    [anon_sym_PIPE_GT] = ACTIONS(7067),
    [anon_sym_COLON] = ACTIONS(7069),
    [anon_sym_DOLLAR] = ACTIONS(7071),
    [anon_sym_AT] = ACTIONS(7071),
    [aux_sym__hex_literal_token1] = ACTIONS(5399),
    [sym__number_literal] = ACTIONS(5401),
    [anon_sym_SQUOTE] = ACTIONS(5399),
    [anon_sym_DQUOTE] = ACTIONS(5399),
    [sym_return] = ACTIONS(5401),
    [sym_next] = ACTIONS(5401),
    [sym_break] = ACTIONS(5401),
    [sym_true] = ACTIONS(5401),
    [sym_false] = ACTIONS(5401),
    [sym_null] = ACTIONS(5401),
    [sym_inf] = ACTIONS(5401),
    [sym_nan] = ACTIONS(5401),
    [anon_sym_NA] = ACTIONS(5401),
    [anon_sym_NA_integer_] = ACTIONS(5401),
    [anon_sym_NA_real_] = ACTIONS(5401),
    [anon_sym_NA_complex_] = ACTIONS(5401),
    [anon_sym_NA_character_] = ACTIONS(5401),
    [sym_dots] = ACTIONS(5401),
    [sym_dot_dot_i] = ACTIONS(5399),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5399),
    [sym__newline] = ACTIONS(5399),
    [sym__raw_string_literal] = ACTIONS(5399),
    [sym__external_open_parenthesis] = ACTIONS(7073),
    [sym__external_open_brace] = ACTIONS(5399),
    [sym__external_open_bracket] = ACTIONS(7075),
    [sym__external_close_bracket] = ACTIONS(5399),
    [sym__external_open_bracket2] = ACTIONS(7077),
  },
  [2163] = {
    [sym_string] = STATE(2903),
    [sym__single_quoted_string] = STATE(2462),
    [sym__double_quoted_string] = STATE(2494),
    [sym__string_or_identifier] = STATE(2903),
    [aux_sym_function_definition_repeat1] = STATE(2039),
    [ts_builtin_sym_end] = ACTIONS(5659),
    [sym_identifier] = ACTIONS(7387),
    [anon_sym_BSLASH] = ACTIONS(5659),
    [anon_sym_function] = ACTIONS(5663),
    [anon_sym_EQ] = ACTIONS(5663),
    [anon_sym_if] = ACTIONS(5663),
    [anon_sym_for] = ACTIONS(5663),
    [anon_sym_while] = ACTIONS(5663),
    [anon_sym_repeat] = ACTIONS(5663),
    [anon_sym_QMARK] = ACTIONS(5659),
    [anon_sym_TILDE] = ACTIONS(5659),
    [anon_sym_BANG] = ACTIONS(5663),
    [anon_sym_PLUS] = ACTIONS(5659),
    [anon_sym_DASH] = ACTIONS(5663),
    [anon_sym_LT_DASH] = ACTIONS(5659),
    [anon_sym_LT_LT_DASH] = ACTIONS(5659),
    [anon_sym_COLON_EQ] = ACTIONS(5659),
    [anon_sym_DASH_GT] = ACTIONS(5663),
    [anon_sym_DASH_GT_GT] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(5663),
    [anon_sym_AMP] = ACTIONS(5663),
    [anon_sym_PIPE_PIPE] = ACTIONS(5659),
    [anon_sym_AMP_AMP] = ACTIONS(5659),
    [anon_sym_LT] = ACTIONS(5663),
    [anon_sym_LT_EQ] = ACTIONS(5659),
    [anon_sym_GT] = ACTIONS(5663),
    [anon_sym_GT_EQ] = ACTIONS(5659),
    [anon_sym_EQ_EQ] = ACTIONS(5659),
    [anon_sym_BANG_EQ] = ACTIONS(5659),
    [anon_sym_STAR] = ACTIONS(5663),
    [anon_sym_SLASH] = ACTIONS(5659),
    [anon_sym_STAR_STAR] = ACTIONS(5659),
    [anon_sym_CARET] = ACTIONS(5659),
    [aux_sym_binary_operator_token1] = ACTIONS(5659),
    [anon_sym_PIPE_GT] = ACTIONS(5659),
    [anon_sym_COLON] = ACTIONS(5663),
    [anon_sym_DOLLAR] = ACTIONS(5659),
    [anon_sym_AT] = ACTIONS(5659),
    [aux_sym__hex_literal_token1] = ACTIONS(5659),
    [sym__number_literal] = ACTIONS(5663),
    [anon_sym_SQUOTE] = ACTIONS(2971),
    [anon_sym_DQUOTE] = ACTIONS(2973),
    [sym_return] = ACTIONS(5663),
    [sym_next] = ACTIONS(5663),
    [sym_break] = ACTIONS(5663),
    [sym_true] = ACTIONS(5663),
    [sym_false] = ACTIONS(5663),
    [sym_null] = ACTIONS(5663),
    [sym_inf] = ACTIONS(5663),
    [sym_nan] = ACTIONS(5663),
    [anon_sym_NA] = ACTIONS(5663),
    [anon_sym_NA_integer_] = ACTIONS(5663),
    [anon_sym_NA_real_] = ACTIONS(5663),
    [anon_sym_NA_complex_] = ACTIONS(5663),
    [anon_sym_NA_character_] = ACTIONS(5663),
    [sym_dots] = ACTIONS(5663),
    [sym_dot_dot_i] = ACTIONS(5659),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7389),
    [sym__semicolon] = ACTIONS(5659),
    [sym__raw_string_literal] = ACTIONS(2983),
    [sym__external_open_parenthesis] = ACTIONS(5659),
    [sym__external_close_parenthesis] = ACTIONS(5659),
    [sym__external_open_brace] = ACTIONS(5659),
    [sym__external_open_bracket] = ACTIONS(5659),
    [sym__external_open_bracket2] = ACTIONS(5659),
  },
  [2164] = {
    [sym_call_arguments] = STATE(3027),
    [sym_subset_arguments] = STATE(3026),
    [sym_subset2_arguments] = STATE(3025),
    [sym__open_parenthesis] = STATE(1616),
    [sym__open_bracket] = STATE(1615),
    [sym__open_bracket2] = STATE(1613),
    [sym_identifier] = ACTIONS(5335),
    [anon_sym_BSLASH] = ACTIONS(5333),
    [anon_sym_function] = ACTIONS(5335),
    [anon_sym_EQ] = ACTIONS(7035),
    [anon_sym_if] = ACTIONS(5335),
    [anon_sym_for] = ACTIONS(5335),
    [anon_sym_while] = ACTIONS(5335),
    [anon_sym_repeat] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5333),
    [anon_sym_TILDE] = ACTIONS(7037),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS] = ACTIONS(7039),
    [anon_sym_DASH] = ACTIONS(7041),
    [anon_sym_LT_DASH] = ACTIONS(7043),
    [anon_sym_LT_LT_DASH] = ACTIONS(7043),
    [anon_sym_COLON_EQ] = ACTIONS(7043),
    [anon_sym_DASH_GT] = ACTIONS(7045),
    [anon_sym_DASH_GT_GT] = ACTIONS(7047),
    [anon_sym_PIPE] = ACTIONS(7049),
    [anon_sym_AMP] = ACTIONS(7051),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_AMP_AMP] = ACTIONS(7055),
    [anon_sym_LT] = ACTIONS(7057),
    [anon_sym_LT_EQ] = ACTIONS(7059),
    [anon_sym_GT] = ACTIONS(7057),
    [anon_sym_GT_EQ] = ACTIONS(7059),
    [anon_sym_EQ_EQ] = ACTIONS(7059),
    [anon_sym_BANG_EQ] = ACTIONS(7059),
    [anon_sym_STAR] = ACTIONS(7061),
    [anon_sym_SLASH] = ACTIONS(7063),
    [anon_sym_STAR_STAR] = ACTIONS(7065),
    [anon_sym_CARET] = ACTIONS(7065),
    [aux_sym_binary_operator_token1] = ACTIONS(7067),
    [anon_sym_PIPE_GT] = ACTIONS(7067),
    [anon_sym_COLON] = ACTIONS(7069),
    [anon_sym_DOLLAR] = ACTIONS(7071),
    [anon_sym_AT] = ACTIONS(7071),
    [aux_sym__hex_literal_token1] = ACTIONS(5333),
    [sym__number_literal] = ACTIONS(5335),
    [anon_sym_SQUOTE] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [sym_return] = ACTIONS(5335),
    [sym_next] = ACTIONS(5335),
    [sym_break] = ACTIONS(5335),
    [sym_true] = ACTIONS(5335),
    [sym_false] = ACTIONS(5335),
    [sym_null] = ACTIONS(5335),
    [sym_inf] = ACTIONS(5335),
    [sym_nan] = ACTIONS(5335),
    [anon_sym_NA] = ACTIONS(5335),
    [anon_sym_NA_integer_] = ACTIONS(5335),
    [anon_sym_NA_real_] = ACTIONS(5335),
    [anon_sym_NA_complex_] = ACTIONS(5335),
    [anon_sym_NA_character_] = ACTIONS(5335),
    [sym_dots] = ACTIONS(5335),
    [sym_dot_dot_i] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5333),
    [sym__newline] = ACTIONS(5333),
    [sym__raw_string_literal] = ACTIONS(5333),
    [sym__external_open_parenthesis] = ACTIONS(7073),
    [sym__external_open_brace] = ACTIONS(5333),
    [sym__external_open_bracket] = ACTIONS(7075),
    [sym__external_close_bracket] = ACTIONS(5333),
    [sym__external_open_bracket2] = ACTIONS(7077),
  },
  [2165] = {
    [sym_call_arguments] = STATE(3027),
    [sym_subset_arguments] = STATE(3026),
    [sym_subset2_arguments] = STATE(3025),
    [sym__open_parenthesis] = STATE(1616),
    [sym__open_bracket] = STATE(1615),
    [sym__open_bracket2] = STATE(1613),
    [sym_identifier] = ACTIONS(5331),
    [anon_sym_BSLASH] = ACTIONS(5329),
    [anon_sym_function] = ACTIONS(5331),
    [anon_sym_EQ] = ACTIONS(7035),
    [anon_sym_if] = ACTIONS(5331),
    [anon_sym_for] = ACTIONS(5331),
    [anon_sym_while] = ACTIONS(5331),
    [anon_sym_repeat] = ACTIONS(5331),
    [anon_sym_QMARK] = ACTIONS(5329),
    [anon_sym_TILDE] = ACTIONS(7037),
    [anon_sym_BANG] = ACTIONS(5331),
    [anon_sym_PLUS] = ACTIONS(7039),
    [anon_sym_DASH] = ACTIONS(7041),
    [anon_sym_LT_DASH] = ACTIONS(7043),
    [anon_sym_LT_LT_DASH] = ACTIONS(7043),
    [anon_sym_COLON_EQ] = ACTIONS(7043),
    [anon_sym_DASH_GT] = ACTIONS(7045),
    [anon_sym_DASH_GT_GT] = ACTIONS(7047),
    [anon_sym_PIPE] = ACTIONS(7049),
    [anon_sym_AMP] = ACTIONS(7051),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_AMP_AMP] = ACTIONS(7055),
    [anon_sym_LT] = ACTIONS(7057),
    [anon_sym_LT_EQ] = ACTIONS(7059),
    [anon_sym_GT] = ACTIONS(7057),
    [anon_sym_GT_EQ] = ACTIONS(7059),
    [anon_sym_EQ_EQ] = ACTIONS(7059),
    [anon_sym_BANG_EQ] = ACTIONS(7059),
    [anon_sym_STAR] = ACTIONS(7061),
    [anon_sym_SLASH] = ACTIONS(7063),
    [anon_sym_STAR_STAR] = ACTIONS(7065),
    [anon_sym_CARET] = ACTIONS(7065),
    [aux_sym_binary_operator_token1] = ACTIONS(7067),
    [anon_sym_PIPE_GT] = ACTIONS(7067),
    [anon_sym_COLON] = ACTIONS(7069),
    [anon_sym_DOLLAR] = ACTIONS(7071),
    [anon_sym_AT] = ACTIONS(7071),
    [aux_sym__hex_literal_token1] = ACTIONS(5329),
    [sym__number_literal] = ACTIONS(5331),
    [anon_sym_SQUOTE] = ACTIONS(5329),
    [anon_sym_DQUOTE] = ACTIONS(5329),
    [sym_return] = ACTIONS(5331),
    [sym_next] = ACTIONS(5331),
    [sym_break] = ACTIONS(5331),
    [sym_true] = ACTIONS(5331),
    [sym_false] = ACTIONS(5331),
    [sym_null] = ACTIONS(5331),
    [sym_inf] = ACTIONS(5331),
    [sym_nan] = ACTIONS(5331),
    [anon_sym_NA] = ACTIONS(5331),
    [anon_sym_NA_integer_] = ACTIONS(5331),
    [anon_sym_NA_real_] = ACTIONS(5331),
    [anon_sym_NA_complex_] = ACTIONS(5331),
    [anon_sym_NA_character_] = ACTIONS(5331),
    [sym_dots] = ACTIONS(5331),
    [sym_dot_dot_i] = ACTIONS(5329),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5329),
    [sym__newline] = ACTIONS(5329),
    [sym__raw_string_literal] = ACTIONS(5329),
    [sym__external_open_parenthesis] = ACTIONS(7073),
    [sym__external_open_brace] = ACTIONS(5329),
    [sym__external_open_bracket] = ACTIONS(7075),
    [sym__external_close_bracket] = ACTIONS(5329),
    [sym__external_open_bracket2] = ACTIONS(7077),
  },
  [2166] = {
    [sym_identifier] = ACTIONS(7129),
    [anon_sym_BSLASH] = ACTIONS(7131),
    [anon_sym_function] = ACTIONS(7129),
    [anon_sym_EQ] = ACTIONS(7129),
    [anon_sym_if] = ACTIONS(7129),
    [anon_sym_for] = ACTIONS(7129),
    [anon_sym_while] = ACTIONS(7129),
    [anon_sym_repeat] = ACTIONS(7129),
    [anon_sym_QMARK] = ACTIONS(7131),
    [anon_sym_TILDE] = ACTIONS(7131),
    [anon_sym_BANG] = ACTIONS(7129),
    [anon_sym_PLUS] = ACTIONS(7131),
    [anon_sym_DASH] = ACTIONS(7129),
    [anon_sym_LT_DASH] = ACTIONS(7131),
    [anon_sym_LT_LT_DASH] = ACTIONS(7131),
    [anon_sym_COLON_EQ] = ACTIONS(7131),
    [anon_sym_DASH_GT] = ACTIONS(7129),
    [anon_sym_DASH_GT_GT] = ACTIONS(7131),
    [anon_sym_PIPE] = ACTIONS(7129),
    [anon_sym_AMP] = ACTIONS(7129),
    [anon_sym_PIPE_PIPE] = ACTIONS(7131),
    [anon_sym_AMP_AMP] = ACTIONS(7131),
    [anon_sym_LT] = ACTIONS(7129),
    [anon_sym_LT_EQ] = ACTIONS(7131),
    [anon_sym_GT] = ACTIONS(7129),
    [anon_sym_GT_EQ] = ACTIONS(7131),
    [anon_sym_EQ_EQ] = ACTIONS(7131),
    [anon_sym_BANG_EQ] = ACTIONS(7131),
    [anon_sym_STAR] = ACTIONS(7129),
    [anon_sym_SLASH] = ACTIONS(7131),
    [anon_sym_STAR_STAR] = ACTIONS(7131),
    [anon_sym_CARET] = ACTIONS(7131),
    [aux_sym_binary_operator_token1] = ACTIONS(7131),
    [anon_sym_PIPE_GT] = ACTIONS(7131),
    [anon_sym_COLON] = ACTIONS(7129),
    [anon_sym_DOLLAR] = ACTIONS(7131),
    [anon_sym_AT] = ACTIONS(7131),
    [anon_sym_COLON_COLON] = ACTIONS(7133),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7135),
    [aux_sym__hex_literal_token1] = ACTIONS(7131),
    [sym__number_literal] = ACTIONS(7129),
    [anon_sym_SQUOTE] = ACTIONS(7131),
    [anon_sym_DQUOTE] = ACTIONS(7131),
    [sym_return] = ACTIONS(7129),
    [sym_next] = ACTIONS(7129),
    [sym_break] = ACTIONS(7129),
    [sym_true] = ACTIONS(7129),
    [sym_false] = ACTIONS(7129),
    [sym_null] = ACTIONS(7129),
    [sym_inf] = ACTIONS(7129),
    [sym_nan] = ACTIONS(7129),
    [anon_sym_NA] = ACTIONS(7129),
    [anon_sym_NA_integer_] = ACTIONS(7129),
    [anon_sym_NA_real_] = ACTIONS(7129),
    [anon_sym_NA_complex_] = ACTIONS(7129),
    [anon_sym_NA_character_] = ACTIONS(7129),
    [sym_dots] = ACTIONS(7129),
    [sym_dot_dot_i] = ACTIONS(7131),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7131),
    [sym__newline] = ACTIONS(7131),
    [sym__semicolon] = ACTIONS(7131),
    [sym__raw_string_literal] = ACTIONS(7131),
    [sym__external_else] = ACTIONS(7131),
    [sym__external_open_parenthesis] = ACTIONS(7131),
    [sym__external_open_brace] = ACTIONS(7131),
    [sym__external_close_brace] = ACTIONS(7131),
    [sym__external_open_bracket] = ACTIONS(7131),
    [sym__external_close_bracket] = ACTIONS(7131),
    [sym__external_open_bracket2] = ACTIONS(7131),
  },
  [2167] = {
    [sym_identifier] = ACTIONS(7137),
    [anon_sym_BSLASH] = ACTIONS(7139),
    [anon_sym_function] = ACTIONS(7137),
    [anon_sym_EQ] = ACTIONS(7137),
    [anon_sym_if] = ACTIONS(7137),
    [anon_sym_for] = ACTIONS(7137),
    [anon_sym_while] = ACTIONS(7137),
    [anon_sym_repeat] = ACTIONS(7137),
    [anon_sym_QMARK] = ACTIONS(7139),
    [anon_sym_TILDE] = ACTIONS(7139),
    [anon_sym_BANG] = ACTIONS(7137),
    [anon_sym_PLUS] = ACTIONS(7139),
    [anon_sym_DASH] = ACTIONS(7137),
    [anon_sym_LT_DASH] = ACTIONS(7139),
    [anon_sym_LT_LT_DASH] = ACTIONS(7139),
    [anon_sym_COLON_EQ] = ACTIONS(7139),
    [anon_sym_DASH_GT] = ACTIONS(7137),
    [anon_sym_DASH_GT_GT] = ACTIONS(7139),
    [anon_sym_PIPE] = ACTIONS(7137),
    [anon_sym_AMP] = ACTIONS(7137),
    [anon_sym_PIPE_PIPE] = ACTIONS(7139),
    [anon_sym_AMP_AMP] = ACTIONS(7139),
    [anon_sym_LT] = ACTIONS(7137),
    [anon_sym_LT_EQ] = ACTIONS(7139),
    [anon_sym_GT] = ACTIONS(7137),
    [anon_sym_GT_EQ] = ACTIONS(7139),
    [anon_sym_EQ_EQ] = ACTIONS(7139),
    [anon_sym_BANG_EQ] = ACTIONS(7139),
    [anon_sym_STAR] = ACTIONS(7137),
    [anon_sym_SLASH] = ACTIONS(7139),
    [anon_sym_STAR_STAR] = ACTIONS(7139),
    [anon_sym_CARET] = ACTIONS(7139),
    [aux_sym_binary_operator_token1] = ACTIONS(7139),
    [anon_sym_PIPE_GT] = ACTIONS(7139),
    [anon_sym_COLON] = ACTIONS(7137),
    [anon_sym_DOLLAR] = ACTIONS(7139),
    [anon_sym_AT] = ACTIONS(7139),
    [anon_sym_COLON_COLON] = ACTIONS(7137),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7139),
    [aux_sym__hex_literal_token1] = ACTIONS(7139),
    [sym__number_literal] = ACTIONS(7137),
    [anon_sym_SQUOTE] = ACTIONS(7139),
    [anon_sym_DQUOTE] = ACTIONS(7139),
    [sym_return] = ACTIONS(7137),
    [sym_next] = ACTIONS(7137),
    [sym_break] = ACTIONS(7137),
    [sym_true] = ACTIONS(7137),
    [sym_false] = ACTIONS(7137),
    [sym_null] = ACTIONS(7137),
    [sym_inf] = ACTIONS(7137),
    [sym_nan] = ACTIONS(7137),
    [anon_sym_NA] = ACTIONS(7137),
    [anon_sym_NA_integer_] = ACTIONS(7137),
    [anon_sym_NA_real_] = ACTIONS(7137),
    [anon_sym_NA_complex_] = ACTIONS(7137),
    [anon_sym_NA_character_] = ACTIONS(7137),
    [sym_dots] = ACTIONS(7137),
    [sym_dot_dot_i] = ACTIONS(7139),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7139),
    [sym__newline] = ACTIONS(7139),
    [sym__semicolon] = ACTIONS(7139),
    [sym__raw_string_literal] = ACTIONS(7139),
    [sym__external_else] = ACTIONS(7139),
    [sym__external_open_parenthesis] = ACTIONS(7139),
    [sym__external_open_brace] = ACTIONS(7139),
    [sym__external_close_brace] = ACTIONS(7139),
    [sym__external_open_bracket] = ACTIONS(7139),
    [sym__external_close_bracket] = ACTIONS(7139),
    [sym__external_open_bracket2] = ACTIONS(7139),
  },
  [2168] = {
    [sym_string] = STATE(2878),
    [sym__single_quoted_string] = STATE(2462),
    [sym__double_quoted_string] = STATE(2494),
    [sym__string_or_identifier] = STATE(2878),
    [ts_builtin_sym_end] = ACTIONS(5883),
    [sym_identifier] = ACTIONS(7391),
    [anon_sym_BSLASH] = ACTIONS(5883),
    [anon_sym_function] = ACTIONS(5887),
    [anon_sym_EQ] = ACTIONS(5887),
    [anon_sym_if] = ACTIONS(5887),
    [anon_sym_for] = ACTIONS(5887),
    [anon_sym_while] = ACTIONS(5887),
    [anon_sym_repeat] = ACTIONS(5887),
    [anon_sym_QMARK] = ACTIONS(5883),
    [anon_sym_TILDE] = ACTIONS(5883),
    [anon_sym_BANG] = ACTIONS(5887),
    [anon_sym_PLUS] = ACTIONS(5883),
    [anon_sym_DASH] = ACTIONS(5887),
    [anon_sym_LT_DASH] = ACTIONS(5883),
    [anon_sym_LT_LT_DASH] = ACTIONS(5883),
    [anon_sym_COLON_EQ] = ACTIONS(5883),
    [anon_sym_DASH_GT] = ACTIONS(5887),
    [anon_sym_DASH_GT_GT] = ACTIONS(5883),
    [anon_sym_PIPE] = ACTIONS(5887),
    [anon_sym_AMP] = ACTIONS(5887),
    [anon_sym_PIPE_PIPE] = ACTIONS(5883),
    [anon_sym_AMP_AMP] = ACTIONS(5883),
    [anon_sym_LT] = ACTIONS(5887),
    [anon_sym_LT_EQ] = ACTIONS(5883),
    [anon_sym_GT] = ACTIONS(5887),
    [anon_sym_GT_EQ] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5883),
    [anon_sym_BANG_EQ] = ACTIONS(5883),
    [anon_sym_STAR] = ACTIONS(5887),
    [anon_sym_SLASH] = ACTIONS(5883),
    [anon_sym_STAR_STAR] = ACTIONS(5883),
    [anon_sym_CARET] = ACTIONS(5883),
    [aux_sym_binary_operator_token1] = ACTIONS(5883),
    [anon_sym_PIPE_GT] = ACTIONS(5883),
    [anon_sym_COLON] = ACTIONS(5887),
    [anon_sym_DOLLAR] = ACTIONS(5883),
    [anon_sym_AT] = ACTIONS(5883),
    [aux_sym__hex_literal_token1] = ACTIONS(5883),
    [sym__number_literal] = ACTIONS(5887),
    [anon_sym_SQUOTE] = ACTIONS(2971),
    [anon_sym_DQUOTE] = ACTIONS(2973),
    [sym_return] = ACTIONS(5887),
    [sym_next] = ACTIONS(5887),
    [sym_break] = ACTIONS(5887),
    [sym_true] = ACTIONS(5887),
    [sym_false] = ACTIONS(5887),
    [sym_null] = ACTIONS(5887),
    [sym_inf] = ACTIONS(5887),
    [sym_nan] = ACTIONS(5887),
    [anon_sym_NA] = ACTIONS(5887),
    [anon_sym_NA_integer_] = ACTIONS(5887),
    [anon_sym_NA_real_] = ACTIONS(5887),
    [anon_sym_NA_complex_] = ACTIONS(5887),
    [anon_sym_NA_character_] = ACTIONS(5887),
    [sym_dots] = ACTIONS(5887),
    [sym_dot_dot_i] = ACTIONS(5883),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5883),
    [sym__semicolon] = ACTIONS(5883),
    [sym__raw_string_literal] = ACTIONS(2983),
    [sym__external_open_parenthesis] = ACTIONS(5883),
    [sym__external_close_parenthesis] = ACTIONS(5883),
    [sym__external_open_brace] = ACTIONS(5883),
    [sym__external_open_bracket] = ACTIONS(5883),
    [sym__external_open_bracket2] = ACTIONS(5883),
  },
  [2169] = {
    [ts_builtin_sym_end] = ACTIONS(7131),
    [sym_identifier] = ACTIONS(7129),
    [anon_sym_BSLASH] = ACTIONS(7131),
    [anon_sym_function] = ACTIONS(7129),
    [anon_sym_EQ] = ACTIONS(7129),
    [anon_sym_if] = ACTIONS(7129),
    [anon_sym_for] = ACTIONS(7129),
    [anon_sym_while] = ACTIONS(7129),
    [anon_sym_repeat] = ACTIONS(7129),
    [anon_sym_QMARK] = ACTIONS(7131),
    [anon_sym_TILDE] = ACTIONS(7131),
    [anon_sym_BANG] = ACTIONS(7129),
    [anon_sym_PLUS] = ACTIONS(7131),
    [anon_sym_DASH] = ACTIONS(7129),
    [anon_sym_LT_DASH] = ACTIONS(7131),
    [anon_sym_LT_LT_DASH] = ACTIONS(7131),
    [anon_sym_COLON_EQ] = ACTIONS(7131),
    [anon_sym_DASH_GT] = ACTIONS(7129),
    [anon_sym_DASH_GT_GT] = ACTIONS(7131),
    [anon_sym_PIPE] = ACTIONS(7129),
    [anon_sym_AMP] = ACTIONS(7129),
    [anon_sym_PIPE_PIPE] = ACTIONS(7131),
    [anon_sym_AMP_AMP] = ACTIONS(7131),
    [anon_sym_LT] = ACTIONS(7129),
    [anon_sym_LT_EQ] = ACTIONS(7131),
    [anon_sym_GT] = ACTIONS(7129),
    [anon_sym_GT_EQ] = ACTIONS(7131),
    [anon_sym_EQ_EQ] = ACTIONS(7131),
    [anon_sym_BANG_EQ] = ACTIONS(7131),
    [anon_sym_STAR] = ACTIONS(7129),
    [anon_sym_SLASH] = ACTIONS(7131),
    [anon_sym_STAR_STAR] = ACTIONS(7131),
    [anon_sym_CARET] = ACTIONS(7131),
    [aux_sym_binary_operator_token1] = ACTIONS(7131),
    [anon_sym_PIPE_GT] = ACTIONS(7131),
    [anon_sym_COLON] = ACTIONS(7129),
    [anon_sym_DOLLAR] = ACTIONS(7131),
    [anon_sym_AT] = ACTIONS(7131),
    [anon_sym_COLON_COLON] = ACTIONS(7133),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7135),
    [aux_sym__hex_literal_token1] = ACTIONS(7131),
    [sym__number_literal] = ACTIONS(7129),
    [anon_sym_SQUOTE] = ACTIONS(7131),
    [anon_sym_DQUOTE] = ACTIONS(7131),
    [sym_return] = ACTIONS(7129),
    [sym_next] = ACTIONS(7129),
    [sym_break] = ACTIONS(7129),
    [sym_true] = ACTIONS(7129),
    [sym_false] = ACTIONS(7129),
    [sym_null] = ACTIONS(7129),
    [sym_inf] = ACTIONS(7129),
    [sym_nan] = ACTIONS(7129),
    [anon_sym_NA] = ACTIONS(7129),
    [anon_sym_NA_integer_] = ACTIONS(7129),
    [anon_sym_NA_real_] = ACTIONS(7129),
    [anon_sym_NA_complex_] = ACTIONS(7129),
    [anon_sym_NA_character_] = ACTIONS(7129),
    [sym_dots] = ACTIONS(7129),
    [sym_dot_dot_i] = ACTIONS(7131),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7131),
    [sym__newline] = ACTIONS(7131),
    [sym__semicolon] = ACTIONS(7131),
    [sym__raw_string_literal] = ACTIONS(7131),
    [sym__external_open_parenthesis] = ACTIONS(7131),
    [sym__external_close_parenthesis] = ACTIONS(7131),
    [sym__external_open_brace] = ACTIONS(7131),
    [sym__external_close_brace] = ACTIONS(7131),
    [sym__external_open_bracket] = ACTIONS(7131),
    [sym__external_open_bracket2] = ACTIONS(7131),
  },
  [2170] = {
    [sym_identifier] = ACTIONS(7195),
    [anon_sym_BSLASH] = ACTIONS(7193),
    [anon_sym_function] = ACTIONS(7195),
    [anon_sym_EQ] = ACTIONS(7195),
    [anon_sym_if] = ACTIONS(7195),
    [anon_sym_for] = ACTIONS(7195),
    [anon_sym_while] = ACTIONS(7195),
    [anon_sym_repeat] = ACTIONS(7195),
    [anon_sym_QMARK] = ACTIONS(7193),
    [anon_sym_TILDE] = ACTIONS(7193),
    [anon_sym_BANG] = ACTIONS(7195),
    [anon_sym_PLUS] = ACTIONS(7193),
    [anon_sym_DASH] = ACTIONS(7195),
    [anon_sym_LT_DASH] = ACTIONS(7193),
    [anon_sym_LT_LT_DASH] = ACTIONS(7193),
    [anon_sym_COLON_EQ] = ACTIONS(7193),
    [anon_sym_DASH_GT] = ACTIONS(7195),
    [anon_sym_DASH_GT_GT] = ACTIONS(7193),
    [anon_sym_PIPE] = ACTIONS(7195),
    [anon_sym_AMP] = ACTIONS(7195),
    [anon_sym_PIPE_PIPE] = ACTIONS(7193),
    [anon_sym_AMP_AMP] = ACTIONS(7193),
    [anon_sym_LT] = ACTIONS(7195),
    [anon_sym_LT_EQ] = ACTIONS(7193),
    [anon_sym_GT] = ACTIONS(7195),
    [anon_sym_GT_EQ] = ACTIONS(7193),
    [anon_sym_EQ_EQ] = ACTIONS(7193),
    [anon_sym_BANG_EQ] = ACTIONS(7193),
    [anon_sym_STAR] = ACTIONS(7195),
    [anon_sym_SLASH] = ACTIONS(7193),
    [anon_sym_STAR_STAR] = ACTIONS(7193),
    [anon_sym_CARET] = ACTIONS(7193),
    [aux_sym_binary_operator_token1] = ACTIONS(7193),
    [anon_sym_PIPE_GT] = ACTIONS(7193),
    [anon_sym_COLON] = ACTIONS(7195),
    [anon_sym_DOLLAR] = ACTIONS(7193),
    [anon_sym_AT] = ACTIONS(7193),
    [anon_sym_COLON_COLON] = ACTIONS(7195),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7193),
    [aux_sym__hex_literal_token1] = ACTIONS(7193),
    [sym__number_literal] = ACTIONS(7195),
    [anon_sym_SQUOTE] = ACTIONS(7193),
    [anon_sym_DQUOTE] = ACTIONS(7193),
    [sym_return] = ACTIONS(7195),
    [sym_next] = ACTIONS(7195),
    [sym_break] = ACTIONS(7195),
    [sym_true] = ACTIONS(7195),
    [sym_false] = ACTIONS(7195),
    [sym_null] = ACTIONS(7195),
    [sym_inf] = ACTIONS(7195),
    [sym_nan] = ACTIONS(7195),
    [anon_sym_NA] = ACTIONS(7195),
    [anon_sym_NA_integer_] = ACTIONS(7195),
    [anon_sym_NA_real_] = ACTIONS(7195),
    [anon_sym_NA_complex_] = ACTIONS(7195),
    [anon_sym_NA_character_] = ACTIONS(7195),
    [sym_dots] = ACTIONS(7195),
    [sym_dot_dot_i] = ACTIONS(7193),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7193),
    [sym__newline] = ACTIONS(7193),
    [sym__semicolon] = ACTIONS(7193),
    [sym__raw_string_literal] = ACTIONS(7193),
    [sym__external_open_parenthesis] = ACTIONS(7193),
    [sym__external_close_parenthesis] = ACTIONS(7193),
    [sym__external_open_brace] = ACTIONS(7193),
    [sym__external_close_brace] = ACTIONS(7193),
    [sym__external_open_bracket] = ACTIONS(7193),
    [sym__external_close_bracket] = ACTIONS(7193),
    [sym__external_open_bracket2] = ACTIONS(7193),
  },
  [2171] = {
    [sym_string] = STATE(3015),
    [sym__single_quoted_string] = STATE(2738),
    [sym__double_quoted_string] = STATE(2737),
    [sym__string_or_identifier] = STATE(3015),
    [aux_sym_function_definition_repeat1] = STATE(2226),
    [ts_builtin_sym_end] = ACTIONS(5659),
    [sym_identifier] = ACTIONS(7393),
    [anon_sym_BSLASH] = ACTIONS(5659),
    [anon_sym_function] = ACTIONS(5663),
    [anon_sym_EQ] = ACTIONS(5663),
    [anon_sym_if] = ACTIONS(5663),
    [anon_sym_for] = ACTIONS(5663),
    [anon_sym_while] = ACTIONS(5663),
    [anon_sym_repeat] = ACTIONS(5663),
    [anon_sym_QMARK] = ACTIONS(5659),
    [anon_sym_TILDE] = ACTIONS(5659),
    [anon_sym_BANG] = ACTIONS(5663),
    [anon_sym_PLUS] = ACTIONS(5659),
    [anon_sym_DASH] = ACTIONS(5663),
    [anon_sym_LT_DASH] = ACTIONS(5659),
    [anon_sym_LT_LT_DASH] = ACTIONS(5659),
    [anon_sym_COLON_EQ] = ACTIONS(5659),
    [anon_sym_DASH_GT] = ACTIONS(5663),
    [anon_sym_DASH_GT_GT] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(5663),
    [anon_sym_AMP] = ACTIONS(5663),
    [anon_sym_PIPE_PIPE] = ACTIONS(5659),
    [anon_sym_AMP_AMP] = ACTIONS(5659),
    [anon_sym_LT] = ACTIONS(5663),
    [anon_sym_LT_EQ] = ACTIONS(5659),
    [anon_sym_GT] = ACTIONS(5663),
    [anon_sym_GT_EQ] = ACTIONS(5659),
    [anon_sym_EQ_EQ] = ACTIONS(5659),
    [anon_sym_BANG_EQ] = ACTIONS(5659),
    [anon_sym_STAR] = ACTIONS(5663),
    [anon_sym_SLASH] = ACTIONS(5659),
    [anon_sym_STAR_STAR] = ACTIONS(5659),
    [anon_sym_CARET] = ACTIONS(5659),
    [aux_sym_binary_operator_token1] = ACTIONS(5659),
    [anon_sym_PIPE_GT] = ACTIONS(5659),
    [anon_sym_COLON] = ACTIONS(5663),
    [anon_sym_DOLLAR] = ACTIONS(5659),
    [anon_sym_AT] = ACTIONS(5659),
    [aux_sym__hex_literal_token1] = ACTIONS(5659),
    [sym__number_literal] = ACTIONS(5663),
    [anon_sym_SQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE] = ACTIONS(35),
    [sym_return] = ACTIONS(5663),
    [sym_next] = ACTIONS(5663),
    [sym_break] = ACTIONS(5663),
    [sym_true] = ACTIONS(5663),
    [sym_false] = ACTIONS(5663),
    [sym_null] = ACTIONS(5663),
    [sym_inf] = ACTIONS(5663),
    [sym_nan] = ACTIONS(5663),
    [anon_sym_NA] = ACTIONS(5663),
    [anon_sym_NA_integer_] = ACTIONS(5663),
    [anon_sym_NA_real_] = ACTIONS(5663),
    [anon_sym_NA_complex_] = ACTIONS(5663),
    [anon_sym_NA_character_] = ACTIONS(5663),
    [sym_dots] = ACTIONS(5663),
    [sym_dot_dot_i] = ACTIONS(5659),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7395),
    [sym__semicolon] = ACTIONS(5659),
    [sym__raw_string_literal] = ACTIONS(45),
    [sym__external_open_parenthesis] = ACTIONS(5659),
    [sym__external_open_brace] = ACTIONS(5659),
    [sym__external_open_bracket] = ACTIONS(5659),
    [sym__external_open_bracket2] = ACTIONS(5659),
  },
  [2172] = {
    [sym_identifier] = ACTIONS(7191),
    [anon_sym_BSLASH] = ACTIONS(7189),
    [anon_sym_function] = ACTIONS(7191),
    [anon_sym_EQ] = ACTIONS(7191),
    [anon_sym_if] = ACTIONS(7191),
    [anon_sym_for] = ACTIONS(7191),
    [anon_sym_while] = ACTIONS(7191),
    [anon_sym_repeat] = ACTIONS(7191),
    [anon_sym_QMARK] = ACTIONS(7189),
    [anon_sym_TILDE] = ACTIONS(7189),
    [anon_sym_BANG] = ACTIONS(7191),
    [anon_sym_PLUS] = ACTIONS(7189),
    [anon_sym_DASH] = ACTIONS(7191),
    [anon_sym_LT_DASH] = ACTIONS(7189),
    [anon_sym_LT_LT_DASH] = ACTIONS(7189),
    [anon_sym_COLON_EQ] = ACTIONS(7189),
    [anon_sym_DASH_GT] = ACTIONS(7191),
    [anon_sym_DASH_GT_GT] = ACTIONS(7189),
    [anon_sym_PIPE] = ACTIONS(7191),
    [anon_sym_AMP] = ACTIONS(7191),
    [anon_sym_PIPE_PIPE] = ACTIONS(7189),
    [anon_sym_AMP_AMP] = ACTIONS(7189),
    [anon_sym_LT] = ACTIONS(7191),
    [anon_sym_LT_EQ] = ACTIONS(7189),
    [anon_sym_GT] = ACTIONS(7191),
    [anon_sym_GT_EQ] = ACTIONS(7189),
    [anon_sym_EQ_EQ] = ACTIONS(7189),
    [anon_sym_BANG_EQ] = ACTIONS(7189),
    [anon_sym_STAR] = ACTIONS(7191),
    [anon_sym_SLASH] = ACTIONS(7189),
    [anon_sym_STAR_STAR] = ACTIONS(7189),
    [anon_sym_CARET] = ACTIONS(7189),
    [aux_sym_binary_operator_token1] = ACTIONS(7189),
    [anon_sym_PIPE_GT] = ACTIONS(7189),
    [anon_sym_COLON] = ACTIONS(7191),
    [anon_sym_DOLLAR] = ACTIONS(7189),
    [anon_sym_AT] = ACTIONS(7189),
    [anon_sym_COLON_COLON] = ACTIONS(7191),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7189),
    [aux_sym__hex_literal_token1] = ACTIONS(7189),
    [sym__number_literal] = ACTIONS(7191),
    [anon_sym_SQUOTE] = ACTIONS(7189),
    [anon_sym_DQUOTE] = ACTIONS(7189),
    [sym_return] = ACTIONS(7191),
    [sym_next] = ACTIONS(7191),
    [sym_break] = ACTIONS(7191),
    [sym_true] = ACTIONS(7191),
    [sym_false] = ACTIONS(7191),
    [sym_null] = ACTIONS(7191),
    [sym_inf] = ACTIONS(7191),
    [sym_nan] = ACTIONS(7191),
    [anon_sym_NA] = ACTIONS(7191),
    [anon_sym_NA_integer_] = ACTIONS(7191),
    [anon_sym_NA_real_] = ACTIONS(7191),
    [anon_sym_NA_complex_] = ACTIONS(7191),
    [anon_sym_NA_character_] = ACTIONS(7191),
    [sym_dots] = ACTIONS(7191),
    [sym_dot_dot_i] = ACTIONS(7189),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7189),
    [sym__newline] = ACTIONS(7189),
    [sym__semicolon] = ACTIONS(7189),
    [sym__raw_string_literal] = ACTIONS(7189),
    [sym__external_open_parenthesis] = ACTIONS(7189),
    [sym__external_close_parenthesis] = ACTIONS(7189),
    [sym__external_open_brace] = ACTIONS(7189),
    [sym__external_close_brace] = ACTIONS(7189),
    [sym__external_open_bracket] = ACTIONS(7189),
    [sym__external_close_bracket] = ACTIONS(7189),
    [sym__external_open_bracket2] = ACTIONS(7189),
  },
  [2173] = {
    [sym_string] = STATE(2811),
    [sym__single_quoted_string] = STATE(2382),
    [sym__double_quoted_string] = STATE(2383),
    [sym__string_or_identifier] = STATE(2811),
    [sym_identifier] = ACTIONS(7397),
    [anon_sym_BSLASH] = ACTIONS(5883),
    [anon_sym_function] = ACTIONS(5887),
    [anon_sym_EQ] = ACTIONS(5887),
    [anon_sym_if] = ACTIONS(5887),
    [anon_sym_for] = ACTIONS(5887),
    [anon_sym_while] = ACTIONS(5887),
    [anon_sym_repeat] = ACTIONS(5887),
    [anon_sym_QMARK] = ACTIONS(5883),
    [anon_sym_TILDE] = ACTIONS(5883),
    [anon_sym_BANG] = ACTIONS(5887),
    [anon_sym_PLUS] = ACTIONS(5883),
    [anon_sym_DASH] = ACTIONS(5887),
    [anon_sym_LT_DASH] = ACTIONS(5883),
    [anon_sym_LT_LT_DASH] = ACTIONS(5883),
    [anon_sym_COLON_EQ] = ACTIONS(5883),
    [anon_sym_DASH_GT] = ACTIONS(5887),
    [anon_sym_DASH_GT_GT] = ACTIONS(5883),
    [anon_sym_PIPE] = ACTIONS(5887),
    [anon_sym_AMP] = ACTIONS(5887),
    [anon_sym_PIPE_PIPE] = ACTIONS(5883),
    [anon_sym_AMP_AMP] = ACTIONS(5883),
    [anon_sym_LT] = ACTIONS(5887),
    [anon_sym_LT_EQ] = ACTIONS(5883),
    [anon_sym_GT] = ACTIONS(5887),
    [anon_sym_GT_EQ] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5883),
    [anon_sym_BANG_EQ] = ACTIONS(5883),
    [anon_sym_STAR] = ACTIONS(5887),
    [anon_sym_SLASH] = ACTIONS(5883),
    [anon_sym_STAR_STAR] = ACTIONS(5883),
    [anon_sym_CARET] = ACTIONS(5883),
    [aux_sym_binary_operator_token1] = ACTIONS(5883),
    [anon_sym_PIPE_GT] = ACTIONS(5883),
    [anon_sym_COLON] = ACTIONS(5887),
    [anon_sym_DOLLAR] = ACTIONS(5883),
    [anon_sym_AT] = ACTIONS(5883),
    [aux_sym__hex_literal_token1] = ACTIONS(5883),
    [sym__number_literal] = ACTIONS(5887),
    [anon_sym_SQUOTE] = ACTIONS(3706),
    [anon_sym_DQUOTE] = ACTIONS(3708),
    [sym_return] = ACTIONS(5887),
    [sym_next] = ACTIONS(5887),
    [sym_break] = ACTIONS(5887),
    [sym_true] = ACTIONS(5887),
    [sym_false] = ACTIONS(5887),
    [sym_null] = ACTIONS(5887),
    [sym_inf] = ACTIONS(5887),
    [sym_nan] = ACTIONS(5887),
    [anon_sym_NA] = ACTIONS(5887),
    [anon_sym_NA_integer_] = ACTIONS(5887),
    [anon_sym_NA_real_] = ACTIONS(5887),
    [anon_sym_NA_complex_] = ACTIONS(5887),
    [anon_sym_NA_character_] = ACTIONS(5887),
    [sym_dots] = ACTIONS(5887),
    [sym_dot_dot_i] = ACTIONS(5883),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5883),
    [sym__newline] = ACTIONS(5883),
    [sym__raw_string_literal] = ACTIONS(3718),
    [sym__external_else] = ACTIONS(5883),
    [sym__external_open_parenthesis] = ACTIONS(5883),
    [sym__external_open_brace] = ACTIONS(5883),
    [sym__external_open_bracket] = ACTIONS(5883),
    [sym__external_open_bracket2] = ACTIONS(5883),
    [sym__external_close_bracket2] = ACTIONS(5883),
  },
  [2174] = {
    [ts_builtin_sym_end] = ACTIONS(7193),
    [sym_identifier] = ACTIONS(7195),
    [anon_sym_BSLASH] = ACTIONS(7193),
    [anon_sym_function] = ACTIONS(7195),
    [anon_sym_EQ] = ACTIONS(7195),
    [anon_sym_if] = ACTIONS(7195),
    [anon_sym_for] = ACTIONS(7195),
    [anon_sym_while] = ACTIONS(7195),
    [anon_sym_repeat] = ACTIONS(7195),
    [anon_sym_QMARK] = ACTIONS(7193),
    [anon_sym_TILDE] = ACTIONS(7193),
    [anon_sym_BANG] = ACTIONS(7195),
    [anon_sym_PLUS] = ACTIONS(7193),
    [anon_sym_DASH] = ACTIONS(7195),
    [anon_sym_LT_DASH] = ACTIONS(7193),
    [anon_sym_LT_LT_DASH] = ACTIONS(7193),
    [anon_sym_COLON_EQ] = ACTIONS(7193),
    [anon_sym_DASH_GT] = ACTIONS(7195),
    [anon_sym_DASH_GT_GT] = ACTIONS(7193),
    [anon_sym_PIPE] = ACTIONS(7195),
    [anon_sym_AMP] = ACTIONS(7195),
    [anon_sym_PIPE_PIPE] = ACTIONS(7193),
    [anon_sym_AMP_AMP] = ACTIONS(7193),
    [anon_sym_LT] = ACTIONS(7195),
    [anon_sym_LT_EQ] = ACTIONS(7193),
    [anon_sym_GT] = ACTIONS(7195),
    [anon_sym_GT_EQ] = ACTIONS(7193),
    [anon_sym_EQ_EQ] = ACTIONS(7193),
    [anon_sym_BANG_EQ] = ACTIONS(7193),
    [anon_sym_STAR] = ACTIONS(7195),
    [anon_sym_SLASH] = ACTIONS(7193),
    [anon_sym_STAR_STAR] = ACTIONS(7193),
    [anon_sym_CARET] = ACTIONS(7193),
    [aux_sym_binary_operator_token1] = ACTIONS(7193),
    [anon_sym_PIPE_GT] = ACTIONS(7193),
    [anon_sym_COLON] = ACTIONS(7195),
    [anon_sym_DOLLAR] = ACTIONS(7193),
    [anon_sym_AT] = ACTIONS(7193),
    [anon_sym_COLON_COLON] = ACTIONS(7195),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7193),
    [aux_sym__hex_literal_token1] = ACTIONS(7193),
    [sym__number_literal] = ACTIONS(7195),
    [anon_sym_SQUOTE] = ACTIONS(7193),
    [anon_sym_DQUOTE] = ACTIONS(7193),
    [sym_return] = ACTIONS(7195),
    [sym_next] = ACTIONS(7195),
    [sym_break] = ACTIONS(7195),
    [sym_true] = ACTIONS(7195),
    [sym_false] = ACTIONS(7195),
    [sym_null] = ACTIONS(7195),
    [sym_inf] = ACTIONS(7195),
    [sym_nan] = ACTIONS(7195),
    [anon_sym_NA] = ACTIONS(7195),
    [anon_sym_NA_integer_] = ACTIONS(7195),
    [anon_sym_NA_real_] = ACTIONS(7195),
    [anon_sym_NA_complex_] = ACTIONS(7195),
    [anon_sym_NA_character_] = ACTIONS(7195),
    [sym_dots] = ACTIONS(7195),
    [sym_dot_dot_i] = ACTIONS(7193),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7193),
    [sym__newline] = ACTIONS(7193),
    [sym__semicolon] = ACTIONS(7193),
    [sym__raw_string_literal] = ACTIONS(7193),
    [sym__external_open_parenthesis] = ACTIONS(7193),
    [sym__external_close_parenthesis] = ACTIONS(7193),
    [sym__external_open_brace] = ACTIONS(7193),
    [sym__external_close_brace] = ACTIONS(7193),
    [sym__external_open_bracket] = ACTIONS(7193),
    [sym__external_open_bracket2] = ACTIONS(7193),
  },
  [2175] = {
    [ts_builtin_sym_end] = ACTIONS(7189),
    [sym_identifier] = ACTIONS(7191),
    [anon_sym_BSLASH] = ACTIONS(7189),
    [anon_sym_function] = ACTIONS(7191),
    [anon_sym_EQ] = ACTIONS(7191),
    [anon_sym_if] = ACTIONS(7191),
    [anon_sym_for] = ACTIONS(7191),
    [anon_sym_while] = ACTIONS(7191),
    [anon_sym_repeat] = ACTIONS(7191),
    [anon_sym_QMARK] = ACTIONS(7189),
    [anon_sym_TILDE] = ACTIONS(7189),
    [anon_sym_BANG] = ACTIONS(7191),
    [anon_sym_PLUS] = ACTIONS(7189),
    [anon_sym_DASH] = ACTIONS(7191),
    [anon_sym_LT_DASH] = ACTIONS(7189),
    [anon_sym_LT_LT_DASH] = ACTIONS(7189),
    [anon_sym_COLON_EQ] = ACTIONS(7189),
    [anon_sym_DASH_GT] = ACTIONS(7191),
    [anon_sym_DASH_GT_GT] = ACTIONS(7189),
    [anon_sym_PIPE] = ACTIONS(7191),
    [anon_sym_AMP] = ACTIONS(7191),
    [anon_sym_PIPE_PIPE] = ACTIONS(7189),
    [anon_sym_AMP_AMP] = ACTIONS(7189),
    [anon_sym_LT] = ACTIONS(7191),
    [anon_sym_LT_EQ] = ACTIONS(7189),
    [anon_sym_GT] = ACTIONS(7191),
    [anon_sym_GT_EQ] = ACTIONS(7189),
    [anon_sym_EQ_EQ] = ACTIONS(7189),
    [anon_sym_BANG_EQ] = ACTIONS(7189),
    [anon_sym_STAR] = ACTIONS(7191),
    [anon_sym_SLASH] = ACTIONS(7189),
    [anon_sym_STAR_STAR] = ACTIONS(7189),
    [anon_sym_CARET] = ACTIONS(7189),
    [aux_sym_binary_operator_token1] = ACTIONS(7189),
    [anon_sym_PIPE_GT] = ACTIONS(7189),
    [anon_sym_COLON] = ACTIONS(7191),
    [anon_sym_DOLLAR] = ACTIONS(7189),
    [anon_sym_AT] = ACTIONS(7189),
    [anon_sym_COLON_COLON] = ACTIONS(7191),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7189),
    [aux_sym__hex_literal_token1] = ACTIONS(7189),
    [sym__number_literal] = ACTIONS(7191),
    [anon_sym_SQUOTE] = ACTIONS(7189),
    [anon_sym_DQUOTE] = ACTIONS(7189),
    [sym_return] = ACTIONS(7191),
    [sym_next] = ACTIONS(7191),
    [sym_break] = ACTIONS(7191),
    [sym_true] = ACTIONS(7191),
    [sym_false] = ACTIONS(7191),
    [sym_null] = ACTIONS(7191),
    [sym_inf] = ACTIONS(7191),
    [sym_nan] = ACTIONS(7191),
    [anon_sym_NA] = ACTIONS(7191),
    [anon_sym_NA_integer_] = ACTIONS(7191),
    [anon_sym_NA_real_] = ACTIONS(7191),
    [anon_sym_NA_complex_] = ACTIONS(7191),
    [anon_sym_NA_character_] = ACTIONS(7191),
    [sym_dots] = ACTIONS(7191),
    [sym_dot_dot_i] = ACTIONS(7189),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7189),
    [sym__newline] = ACTIONS(7189),
    [sym__semicolon] = ACTIONS(7189),
    [sym__raw_string_literal] = ACTIONS(7189),
    [sym__external_open_parenthesis] = ACTIONS(7189),
    [sym__external_close_parenthesis] = ACTIONS(7189),
    [sym__external_open_brace] = ACTIONS(7189),
    [sym__external_close_brace] = ACTIONS(7189),
    [sym__external_open_bracket] = ACTIONS(7189),
    [sym__external_open_bracket2] = ACTIONS(7189),
  },
  [2176] = {
    [ts_builtin_sym_end] = ACTIONS(7165),
    [sym_identifier] = ACTIONS(7163),
    [anon_sym_BSLASH] = ACTIONS(7165),
    [anon_sym_function] = ACTIONS(7163),
    [anon_sym_EQ] = ACTIONS(7163),
    [anon_sym_if] = ACTIONS(7163),
    [anon_sym_for] = ACTIONS(7163),
    [anon_sym_while] = ACTIONS(7163),
    [anon_sym_repeat] = ACTIONS(7163),
    [anon_sym_QMARK] = ACTIONS(7165),
    [anon_sym_TILDE] = ACTIONS(7165),
    [anon_sym_BANG] = ACTIONS(7163),
    [anon_sym_PLUS] = ACTIONS(7165),
    [anon_sym_DASH] = ACTIONS(7163),
    [anon_sym_LT_DASH] = ACTIONS(7165),
    [anon_sym_LT_LT_DASH] = ACTIONS(7165),
    [anon_sym_COLON_EQ] = ACTIONS(7165),
    [anon_sym_DASH_GT] = ACTIONS(7163),
    [anon_sym_DASH_GT_GT] = ACTIONS(7165),
    [anon_sym_PIPE] = ACTIONS(7163),
    [anon_sym_AMP] = ACTIONS(7163),
    [anon_sym_PIPE_PIPE] = ACTIONS(7165),
    [anon_sym_AMP_AMP] = ACTIONS(7165),
    [anon_sym_LT] = ACTIONS(7163),
    [anon_sym_LT_EQ] = ACTIONS(7165),
    [anon_sym_GT] = ACTIONS(7163),
    [anon_sym_GT_EQ] = ACTIONS(7165),
    [anon_sym_EQ_EQ] = ACTIONS(7165),
    [anon_sym_BANG_EQ] = ACTIONS(7165),
    [anon_sym_STAR] = ACTIONS(7163),
    [anon_sym_SLASH] = ACTIONS(7165),
    [anon_sym_STAR_STAR] = ACTIONS(7165),
    [anon_sym_CARET] = ACTIONS(7165),
    [aux_sym_binary_operator_token1] = ACTIONS(7165),
    [anon_sym_PIPE_GT] = ACTIONS(7165),
    [anon_sym_COLON] = ACTIONS(7163),
    [anon_sym_DOLLAR] = ACTIONS(7165),
    [anon_sym_AT] = ACTIONS(7165),
    [anon_sym_COLON_COLON] = ACTIONS(7163),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7165),
    [aux_sym__hex_literal_token1] = ACTIONS(7165),
    [sym__number_literal] = ACTIONS(7163),
    [anon_sym_SQUOTE] = ACTIONS(7165),
    [anon_sym_DQUOTE] = ACTIONS(7165),
    [sym_return] = ACTIONS(7163),
    [sym_next] = ACTIONS(7163),
    [sym_break] = ACTIONS(7163),
    [sym_true] = ACTIONS(7163),
    [sym_false] = ACTIONS(7163),
    [sym_null] = ACTIONS(7163),
    [sym_inf] = ACTIONS(7163),
    [sym_nan] = ACTIONS(7163),
    [anon_sym_NA] = ACTIONS(7163),
    [anon_sym_NA_integer_] = ACTIONS(7163),
    [anon_sym_NA_real_] = ACTIONS(7163),
    [anon_sym_NA_complex_] = ACTIONS(7163),
    [anon_sym_NA_character_] = ACTIONS(7163),
    [sym_dots] = ACTIONS(7163),
    [sym_dot_dot_i] = ACTIONS(7165),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7165),
    [sym__newline] = ACTIONS(7165),
    [sym__semicolon] = ACTIONS(7165),
    [sym__raw_string_literal] = ACTIONS(7165),
    [sym__external_open_parenthesis] = ACTIONS(7165),
    [sym__external_close_parenthesis] = ACTIONS(7165),
    [sym__external_open_brace] = ACTIONS(7165),
    [sym__external_close_brace] = ACTIONS(7165),
    [sym__external_open_bracket] = ACTIONS(7165),
    [sym__external_open_bracket2] = ACTIONS(7165),
  },
  [2177] = {
    [ts_builtin_sym_end] = ACTIONS(7153),
    [sym_identifier] = ACTIONS(7151),
    [anon_sym_BSLASH] = ACTIONS(7153),
    [anon_sym_function] = ACTIONS(7151),
    [anon_sym_EQ] = ACTIONS(7151),
    [anon_sym_if] = ACTIONS(7151),
    [anon_sym_for] = ACTIONS(7151),
    [anon_sym_while] = ACTIONS(7151),
    [anon_sym_repeat] = ACTIONS(7151),
    [anon_sym_QMARK] = ACTIONS(7153),
    [anon_sym_TILDE] = ACTIONS(7153),
    [anon_sym_BANG] = ACTIONS(7151),
    [anon_sym_PLUS] = ACTIONS(7153),
    [anon_sym_DASH] = ACTIONS(7151),
    [anon_sym_LT_DASH] = ACTIONS(7153),
    [anon_sym_LT_LT_DASH] = ACTIONS(7153),
    [anon_sym_COLON_EQ] = ACTIONS(7153),
    [anon_sym_DASH_GT] = ACTIONS(7151),
    [anon_sym_DASH_GT_GT] = ACTIONS(7153),
    [anon_sym_PIPE] = ACTIONS(7151),
    [anon_sym_AMP] = ACTIONS(7151),
    [anon_sym_PIPE_PIPE] = ACTIONS(7153),
    [anon_sym_AMP_AMP] = ACTIONS(7153),
    [anon_sym_LT] = ACTIONS(7151),
    [anon_sym_LT_EQ] = ACTIONS(7153),
    [anon_sym_GT] = ACTIONS(7151),
    [anon_sym_GT_EQ] = ACTIONS(7153),
    [anon_sym_EQ_EQ] = ACTIONS(7153),
    [anon_sym_BANG_EQ] = ACTIONS(7153),
    [anon_sym_STAR] = ACTIONS(7151),
    [anon_sym_SLASH] = ACTIONS(7153),
    [anon_sym_STAR_STAR] = ACTIONS(7153),
    [anon_sym_CARET] = ACTIONS(7153),
    [aux_sym_binary_operator_token1] = ACTIONS(7153),
    [anon_sym_PIPE_GT] = ACTIONS(7153),
    [anon_sym_COLON] = ACTIONS(7151),
    [anon_sym_DOLLAR] = ACTIONS(7153),
    [anon_sym_AT] = ACTIONS(7153),
    [anon_sym_COLON_COLON] = ACTIONS(7151),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7153),
    [aux_sym__hex_literal_token1] = ACTIONS(7153),
    [sym__number_literal] = ACTIONS(7151),
    [anon_sym_SQUOTE] = ACTIONS(7153),
    [anon_sym_DQUOTE] = ACTIONS(7153),
    [sym_return] = ACTIONS(7151),
    [sym_next] = ACTIONS(7151),
    [sym_break] = ACTIONS(7151),
    [sym_true] = ACTIONS(7151),
    [sym_false] = ACTIONS(7151),
    [sym_null] = ACTIONS(7151),
    [sym_inf] = ACTIONS(7151),
    [sym_nan] = ACTIONS(7151),
    [anon_sym_NA] = ACTIONS(7151),
    [anon_sym_NA_integer_] = ACTIONS(7151),
    [anon_sym_NA_real_] = ACTIONS(7151),
    [anon_sym_NA_complex_] = ACTIONS(7151),
    [anon_sym_NA_character_] = ACTIONS(7151),
    [sym_dots] = ACTIONS(7151),
    [sym_dot_dot_i] = ACTIONS(7153),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7153),
    [sym__newline] = ACTIONS(7153),
    [sym__semicolon] = ACTIONS(7153),
    [sym__raw_string_literal] = ACTIONS(7153),
    [sym__external_open_parenthesis] = ACTIONS(7153),
    [sym__external_close_parenthesis] = ACTIONS(7153),
    [sym__external_open_brace] = ACTIONS(7153),
    [sym__external_close_brace] = ACTIONS(7153),
    [sym__external_open_bracket] = ACTIONS(7153),
    [sym__external_open_bracket2] = ACTIONS(7153),
  },
  [2178] = {
    [sym_string] = STATE(3006),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym__string_or_identifier] = STATE(3006),
    [aux_sym_function_definition_repeat1] = STATE(2225),
    [sym_identifier] = ACTIONS(7399),
    [anon_sym_BSLASH] = ACTIONS(5659),
    [anon_sym_function] = ACTIONS(5663),
    [anon_sym_EQ] = ACTIONS(5663),
    [anon_sym_if] = ACTIONS(5663),
    [anon_sym_for] = ACTIONS(5663),
    [anon_sym_while] = ACTIONS(5663),
    [anon_sym_repeat] = ACTIONS(5663),
    [anon_sym_QMARK] = ACTIONS(5659),
    [anon_sym_TILDE] = ACTIONS(5659),
    [anon_sym_BANG] = ACTIONS(5663),
    [anon_sym_PLUS] = ACTIONS(5659),
    [anon_sym_DASH] = ACTIONS(5663),
    [anon_sym_LT_DASH] = ACTIONS(5659),
    [anon_sym_LT_LT_DASH] = ACTIONS(5659),
    [anon_sym_COLON_EQ] = ACTIONS(5659),
    [anon_sym_DASH_GT] = ACTIONS(5663),
    [anon_sym_DASH_GT_GT] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(5663),
    [anon_sym_AMP] = ACTIONS(5663),
    [anon_sym_PIPE_PIPE] = ACTIONS(5659),
    [anon_sym_AMP_AMP] = ACTIONS(5659),
    [anon_sym_LT] = ACTIONS(5663),
    [anon_sym_LT_EQ] = ACTIONS(5659),
    [anon_sym_GT] = ACTIONS(5663),
    [anon_sym_GT_EQ] = ACTIONS(5659),
    [anon_sym_EQ_EQ] = ACTIONS(5659),
    [anon_sym_BANG_EQ] = ACTIONS(5659),
    [anon_sym_STAR] = ACTIONS(5663),
    [anon_sym_SLASH] = ACTIONS(5659),
    [anon_sym_STAR_STAR] = ACTIONS(5659),
    [anon_sym_CARET] = ACTIONS(5659),
    [aux_sym_binary_operator_token1] = ACTIONS(5659),
    [anon_sym_PIPE_GT] = ACTIONS(5659),
    [anon_sym_COLON] = ACTIONS(5663),
    [anon_sym_DOLLAR] = ACTIONS(5659),
    [anon_sym_AT] = ACTIONS(5659),
    [aux_sym__hex_literal_token1] = ACTIONS(5659),
    [sym__number_literal] = ACTIONS(5663),
    [anon_sym_SQUOTE] = ACTIONS(4780),
    [anon_sym_DQUOTE] = ACTIONS(4782),
    [sym_return] = ACTIONS(5663),
    [sym_next] = ACTIONS(5663),
    [sym_break] = ACTIONS(5663),
    [sym_true] = ACTIONS(5663),
    [sym_false] = ACTIONS(5663),
    [sym_null] = ACTIONS(5663),
    [sym_inf] = ACTIONS(5663),
    [sym_nan] = ACTIONS(5663),
    [anon_sym_NA] = ACTIONS(5663),
    [anon_sym_NA_integer_] = ACTIONS(5663),
    [anon_sym_NA_real_] = ACTIONS(5663),
    [anon_sym_NA_complex_] = ACTIONS(5663),
    [anon_sym_NA_character_] = ACTIONS(5663),
    [sym_dots] = ACTIONS(5663),
    [sym_dot_dot_i] = ACTIONS(5659),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5659),
    [sym__newline] = ACTIONS(7401),
    [sym__raw_string_literal] = ACTIONS(4790),
    [sym__external_open_parenthesis] = ACTIONS(5659),
    [sym__external_open_brace] = ACTIONS(5659),
    [sym__external_open_bracket] = ACTIONS(5659),
    [sym__external_close_bracket] = ACTIONS(5659),
    [sym__external_open_bracket2] = ACTIONS(5659),
  },
  [2179] = {
    [sym_string] = STATE(2949),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym__string_or_identifier] = STATE(2949),
    [aux_sym_function_definition_repeat1] = STATE(2214),
    [sym_identifier] = ACTIONS(7403),
    [anon_sym_BSLASH] = ACTIONS(5659),
    [anon_sym_function] = ACTIONS(5663),
    [anon_sym_EQ] = ACTIONS(5663),
    [anon_sym_if] = ACTIONS(5663),
    [anon_sym_for] = ACTIONS(5663),
    [anon_sym_while] = ACTIONS(5663),
    [anon_sym_repeat] = ACTIONS(5663),
    [anon_sym_QMARK] = ACTIONS(5659),
    [anon_sym_TILDE] = ACTIONS(5659),
    [anon_sym_BANG] = ACTIONS(5663),
    [anon_sym_PLUS] = ACTIONS(5659),
    [anon_sym_DASH] = ACTIONS(5663),
    [anon_sym_LT_DASH] = ACTIONS(5659),
    [anon_sym_LT_LT_DASH] = ACTIONS(5659),
    [anon_sym_COLON_EQ] = ACTIONS(5659),
    [anon_sym_DASH_GT] = ACTIONS(5663),
    [anon_sym_DASH_GT_GT] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(5663),
    [anon_sym_AMP] = ACTIONS(5663),
    [anon_sym_PIPE_PIPE] = ACTIONS(5659),
    [anon_sym_AMP_AMP] = ACTIONS(5659),
    [anon_sym_LT] = ACTIONS(5663),
    [anon_sym_LT_EQ] = ACTIONS(5659),
    [anon_sym_GT] = ACTIONS(5663),
    [anon_sym_GT_EQ] = ACTIONS(5659),
    [anon_sym_EQ_EQ] = ACTIONS(5659),
    [anon_sym_BANG_EQ] = ACTIONS(5659),
    [anon_sym_STAR] = ACTIONS(5663),
    [anon_sym_SLASH] = ACTIONS(5659),
    [anon_sym_STAR_STAR] = ACTIONS(5659),
    [anon_sym_CARET] = ACTIONS(5659),
    [aux_sym_binary_operator_token1] = ACTIONS(5659),
    [anon_sym_PIPE_GT] = ACTIONS(5659),
    [anon_sym_COLON] = ACTIONS(5663),
    [anon_sym_DOLLAR] = ACTIONS(5659),
    [anon_sym_AT] = ACTIONS(5659),
    [aux_sym__hex_literal_token1] = ACTIONS(5659),
    [sym__number_literal] = ACTIONS(5663),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(5663),
    [sym_next] = ACTIONS(5663),
    [sym_break] = ACTIONS(5663),
    [sym_true] = ACTIONS(5663),
    [sym_false] = ACTIONS(5663),
    [sym_null] = ACTIONS(5663),
    [sym_inf] = ACTIONS(5663),
    [sym_nan] = ACTIONS(5663),
    [anon_sym_NA] = ACTIONS(5663),
    [anon_sym_NA_integer_] = ACTIONS(5663),
    [anon_sym_NA_real_] = ACTIONS(5663),
    [anon_sym_NA_complex_] = ACTIONS(5663),
    [anon_sym_NA_character_] = ACTIONS(5663),
    [sym_dots] = ACTIONS(5663),
    [sym_dot_dot_i] = ACTIONS(5659),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5659),
    [sym__newline] = ACTIONS(7405),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(5659),
    [sym__external_close_parenthesis] = ACTIONS(5659),
    [sym__external_open_brace] = ACTIONS(5659),
    [sym__external_open_bracket] = ACTIONS(5659),
    [sym__external_open_bracket2] = ACTIONS(5659),
  },
  [2180] = {
    [ts_builtin_sym_end] = ACTIONS(7117),
    [sym_identifier] = ACTIONS(7115),
    [anon_sym_BSLASH] = ACTIONS(7117),
    [anon_sym_function] = ACTIONS(7115),
    [anon_sym_EQ] = ACTIONS(7115),
    [anon_sym_if] = ACTIONS(7115),
    [anon_sym_for] = ACTIONS(7115),
    [anon_sym_while] = ACTIONS(7115),
    [anon_sym_repeat] = ACTIONS(7115),
    [anon_sym_QMARK] = ACTIONS(7117),
    [anon_sym_TILDE] = ACTIONS(7117),
    [anon_sym_BANG] = ACTIONS(7115),
    [anon_sym_PLUS] = ACTIONS(7117),
    [anon_sym_DASH] = ACTIONS(7115),
    [anon_sym_LT_DASH] = ACTIONS(7117),
    [anon_sym_LT_LT_DASH] = ACTIONS(7117),
    [anon_sym_COLON_EQ] = ACTIONS(7117),
    [anon_sym_DASH_GT] = ACTIONS(7115),
    [anon_sym_DASH_GT_GT] = ACTIONS(7117),
    [anon_sym_PIPE] = ACTIONS(7115),
    [anon_sym_AMP] = ACTIONS(7115),
    [anon_sym_PIPE_PIPE] = ACTIONS(7117),
    [anon_sym_AMP_AMP] = ACTIONS(7117),
    [anon_sym_LT] = ACTIONS(7115),
    [anon_sym_LT_EQ] = ACTIONS(7117),
    [anon_sym_GT] = ACTIONS(7115),
    [anon_sym_GT_EQ] = ACTIONS(7117),
    [anon_sym_EQ_EQ] = ACTIONS(7117),
    [anon_sym_BANG_EQ] = ACTIONS(7117),
    [anon_sym_STAR] = ACTIONS(7115),
    [anon_sym_SLASH] = ACTIONS(7117),
    [anon_sym_STAR_STAR] = ACTIONS(7117),
    [anon_sym_CARET] = ACTIONS(7117),
    [aux_sym_binary_operator_token1] = ACTIONS(7117),
    [anon_sym_PIPE_GT] = ACTIONS(7117),
    [anon_sym_COLON] = ACTIONS(7115),
    [anon_sym_DOLLAR] = ACTIONS(7117),
    [anon_sym_AT] = ACTIONS(7117),
    [anon_sym_COLON_COLON] = ACTIONS(7115),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7117),
    [aux_sym__hex_literal_token1] = ACTIONS(7117),
    [sym__number_literal] = ACTIONS(7115),
    [anon_sym_SQUOTE] = ACTIONS(7117),
    [anon_sym_DQUOTE] = ACTIONS(7117),
    [sym_return] = ACTIONS(7115),
    [sym_next] = ACTIONS(7115),
    [sym_break] = ACTIONS(7115),
    [sym_true] = ACTIONS(7115),
    [sym_false] = ACTIONS(7115),
    [sym_null] = ACTIONS(7115),
    [sym_inf] = ACTIONS(7115),
    [sym_nan] = ACTIONS(7115),
    [anon_sym_NA] = ACTIONS(7115),
    [anon_sym_NA_integer_] = ACTIONS(7115),
    [anon_sym_NA_real_] = ACTIONS(7115),
    [anon_sym_NA_complex_] = ACTIONS(7115),
    [anon_sym_NA_character_] = ACTIONS(7115),
    [sym_dots] = ACTIONS(7115),
    [sym_dot_dot_i] = ACTIONS(7117),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7117),
    [sym__newline] = ACTIONS(7117),
    [sym__semicolon] = ACTIONS(7117),
    [sym__raw_string_literal] = ACTIONS(7117),
    [sym__external_open_parenthesis] = ACTIONS(7117),
    [sym__external_close_parenthesis] = ACTIONS(7117),
    [sym__external_open_brace] = ACTIONS(7117),
    [sym__external_close_brace] = ACTIONS(7117),
    [sym__external_open_bracket] = ACTIONS(7117),
    [sym__external_open_bracket2] = ACTIONS(7117),
  },
  [2181] = {
    [ts_builtin_sym_end] = ACTIONS(7117),
    [sym_identifier] = ACTIONS(7115),
    [anon_sym_BSLASH] = ACTIONS(7117),
    [anon_sym_function] = ACTIONS(7115),
    [anon_sym_EQ] = ACTIONS(7115),
    [anon_sym_if] = ACTIONS(7115),
    [anon_sym_for] = ACTIONS(7115),
    [anon_sym_while] = ACTIONS(7115),
    [anon_sym_repeat] = ACTIONS(7115),
    [anon_sym_QMARK] = ACTIONS(7117),
    [anon_sym_TILDE] = ACTIONS(7117),
    [anon_sym_BANG] = ACTIONS(7115),
    [anon_sym_PLUS] = ACTIONS(7117),
    [anon_sym_DASH] = ACTIONS(7115),
    [anon_sym_LT_DASH] = ACTIONS(7117),
    [anon_sym_LT_LT_DASH] = ACTIONS(7117),
    [anon_sym_COLON_EQ] = ACTIONS(7117),
    [anon_sym_DASH_GT] = ACTIONS(7115),
    [anon_sym_DASH_GT_GT] = ACTIONS(7117),
    [anon_sym_PIPE] = ACTIONS(7115),
    [anon_sym_AMP] = ACTIONS(7115),
    [anon_sym_PIPE_PIPE] = ACTIONS(7117),
    [anon_sym_AMP_AMP] = ACTIONS(7117),
    [anon_sym_LT] = ACTIONS(7115),
    [anon_sym_LT_EQ] = ACTIONS(7117),
    [anon_sym_GT] = ACTIONS(7115),
    [anon_sym_GT_EQ] = ACTIONS(7117),
    [anon_sym_EQ_EQ] = ACTIONS(7117),
    [anon_sym_BANG_EQ] = ACTIONS(7117),
    [anon_sym_STAR] = ACTIONS(7115),
    [anon_sym_SLASH] = ACTIONS(7117),
    [anon_sym_STAR_STAR] = ACTIONS(7117),
    [anon_sym_CARET] = ACTIONS(7117),
    [aux_sym_binary_operator_token1] = ACTIONS(7117),
    [anon_sym_PIPE_GT] = ACTIONS(7117),
    [anon_sym_COLON] = ACTIONS(7115),
    [anon_sym_DOLLAR] = ACTIONS(7117),
    [anon_sym_AT] = ACTIONS(7117),
    [anon_sym_COLON_COLON] = ACTIONS(7115),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7117),
    [aux_sym__hex_literal_token1] = ACTIONS(7117),
    [sym__number_literal] = ACTIONS(7115),
    [anon_sym_SQUOTE] = ACTIONS(7117),
    [anon_sym_DQUOTE] = ACTIONS(7117),
    [sym_return] = ACTIONS(7115),
    [sym_next] = ACTIONS(7115),
    [sym_break] = ACTIONS(7115),
    [sym_true] = ACTIONS(7115),
    [sym_false] = ACTIONS(7115),
    [sym_null] = ACTIONS(7115),
    [sym_inf] = ACTIONS(7115),
    [sym_nan] = ACTIONS(7115),
    [anon_sym_NA] = ACTIONS(7115),
    [anon_sym_NA_integer_] = ACTIONS(7115),
    [anon_sym_NA_real_] = ACTIONS(7115),
    [anon_sym_NA_complex_] = ACTIONS(7115),
    [anon_sym_NA_character_] = ACTIONS(7115),
    [sym_dots] = ACTIONS(7115),
    [sym_dot_dot_i] = ACTIONS(7117),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7117),
    [sym__newline] = ACTIONS(7117),
    [sym__semicolon] = ACTIONS(7117),
    [sym__raw_string_literal] = ACTIONS(7117),
    [sym__external_open_parenthesis] = ACTIONS(7117),
    [sym__external_close_parenthesis] = ACTIONS(7117),
    [sym__external_open_brace] = ACTIONS(7117),
    [sym__external_close_brace] = ACTIONS(7117),
    [sym__external_open_bracket] = ACTIONS(7117),
    [sym__external_open_bracket2] = ACTIONS(7117),
  },
  [2182] = {
    [sym_string] = STATE(2755),
    [sym__single_quoted_string] = STATE(2442),
    [sym__double_quoted_string] = STATE(2437),
    [sym__string_or_identifier] = STATE(2755),
    [sym_identifier] = ACTIONS(7407),
    [anon_sym_BSLASH] = ACTIONS(5883),
    [anon_sym_function] = ACTIONS(5887),
    [anon_sym_EQ] = ACTIONS(5887),
    [anon_sym_if] = ACTIONS(5887),
    [anon_sym_for] = ACTIONS(5887),
    [anon_sym_while] = ACTIONS(5887),
    [anon_sym_repeat] = ACTIONS(5887),
    [anon_sym_QMARK] = ACTIONS(5883),
    [anon_sym_TILDE] = ACTIONS(5883),
    [anon_sym_BANG] = ACTIONS(5887),
    [anon_sym_PLUS] = ACTIONS(5883),
    [anon_sym_DASH] = ACTIONS(5887),
    [anon_sym_LT_DASH] = ACTIONS(5883),
    [anon_sym_LT_LT_DASH] = ACTIONS(5883),
    [anon_sym_COLON_EQ] = ACTIONS(5883),
    [anon_sym_DASH_GT] = ACTIONS(5887),
    [anon_sym_DASH_GT_GT] = ACTIONS(5883),
    [anon_sym_PIPE] = ACTIONS(5887),
    [anon_sym_AMP] = ACTIONS(5887),
    [anon_sym_PIPE_PIPE] = ACTIONS(5883),
    [anon_sym_AMP_AMP] = ACTIONS(5883),
    [anon_sym_LT] = ACTIONS(5887),
    [anon_sym_LT_EQ] = ACTIONS(5883),
    [anon_sym_GT] = ACTIONS(5887),
    [anon_sym_GT_EQ] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5883),
    [anon_sym_BANG_EQ] = ACTIONS(5883),
    [anon_sym_STAR] = ACTIONS(5887),
    [anon_sym_SLASH] = ACTIONS(5883),
    [anon_sym_STAR_STAR] = ACTIONS(5883),
    [anon_sym_CARET] = ACTIONS(5883),
    [aux_sym_binary_operator_token1] = ACTIONS(5883),
    [anon_sym_PIPE_GT] = ACTIONS(5883),
    [anon_sym_COLON] = ACTIONS(5887),
    [anon_sym_DOLLAR] = ACTIONS(5883),
    [anon_sym_AT] = ACTIONS(5883),
    [aux_sym__hex_literal_token1] = ACTIONS(5883),
    [sym__number_literal] = ACTIONS(5887),
    [anon_sym_SQUOTE] = ACTIONS(2559),
    [anon_sym_DQUOTE] = ACTIONS(2561),
    [sym_return] = ACTIONS(5887),
    [sym_next] = ACTIONS(5887),
    [sym_break] = ACTIONS(5887),
    [sym_true] = ACTIONS(5887),
    [sym_false] = ACTIONS(5887),
    [sym_null] = ACTIONS(5887),
    [sym_inf] = ACTIONS(5887),
    [sym_nan] = ACTIONS(5887),
    [anon_sym_NA] = ACTIONS(5887),
    [anon_sym_NA_integer_] = ACTIONS(5887),
    [anon_sym_NA_real_] = ACTIONS(5887),
    [anon_sym_NA_complex_] = ACTIONS(5887),
    [anon_sym_NA_character_] = ACTIONS(5887),
    [sym_dots] = ACTIONS(5887),
    [sym_dot_dot_i] = ACTIONS(5883),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5883),
    [sym__newline] = ACTIONS(5883),
    [sym__raw_string_literal] = ACTIONS(2571),
    [sym__external_open_parenthesis] = ACTIONS(5883),
    [sym__external_close_parenthesis] = ACTIONS(5883),
    [sym__external_open_brace] = ACTIONS(5883),
    [sym__external_open_bracket] = ACTIONS(5883),
    [sym__external_close_bracket] = ACTIONS(5883),
    [sym__external_open_bracket2] = ACTIONS(5883),
  },
  [2183] = {
    [ts_builtin_sym_end] = ACTIONS(7123),
    [sym_identifier] = ACTIONS(7121),
    [anon_sym_BSLASH] = ACTIONS(7123),
    [anon_sym_function] = ACTIONS(7121),
    [anon_sym_EQ] = ACTIONS(7121),
    [anon_sym_if] = ACTIONS(7121),
    [anon_sym_for] = ACTIONS(7121),
    [anon_sym_while] = ACTIONS(7121),
    [anon_sym_repeat] = ACTIONS(7121),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_TILDE] = ACTIONS(7123),
    [anon_sym_BANG] = ACTIONS(7121),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_DASH] = ACTIONS(7121),
    [anon_sym_LT_DASH] = ACTIONS(7123),
    [anon_sym_LT_LT_DASH] = ACTIONS(7123),
    [anon_sym_COLON_EQ] = ACTIONS(7123),
    [anon_sym_DASH_GT] = ACTIONS(7121),
    [anon_sym_DASH_GT_GT] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_LT_EQ] = ACTIONS(7123),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
    [aux_sym_binary_operator_token1] = ACTIONS(7123),
    [anon_sym_PIPE_GT] = ACTIONS(7123),
    [anon_sym_COLON] = ACTIONS(7121),
    [anon_sym_DOLLAR] = ACTIONS(7123),
    [anon_sym_AT] = ACTIONS(7123),
    [anon_sym_L] = ACTIONS(7409),
    [anon_sym_i] = ACTIONS(7411),
    [aux_sym__hex_literal_token1] = ACTIONS(7123),
    [sym__number_literal] = ACTIONS(7121),
    [anon_sym_SQUOTE] = ACTIONS(7123),
    [anon_sym_DQUOTE] = ACTIONS(7123),
    [sym_return] = ACTIONS(7121),
    [sym_next] = ACTIONS(7121),
    [sym_break] = ACTIONS(7121),
    [sym_true] = ACTIONS(7121),
    [sym_false] = ACTIONS(7121),
    [sym_null] = ACTIONS(7121),
    [sym_inf] = ACTIONS(7121),
    [sym_nan] = ACTIONS(7121),
    [anon_sym_NA] = ACTIONS(7121),
    [anon_sym_NA_integer_] = ACTIONS(7121),
    [anon_sym_NA_real_] = ACTIONS(7121),
    [anon_sym_NA_complex_] = ACTIONS(7121),
    [anon_sym_NA_character_] = ACTIONS(7121),
    [sym_dots] = ACTIONS(7121),
    [sym_dot_dot_i] = ACTIONS(7123),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7123),
    [sym__newline] = ACTIONS(7123),
    [sym__semicolon] = ACTIONS(7123),
    [sym__raw_string_literal] = ACTIONS(7123),
    [sym__external_open_parenthesis] = ACTIONS(7123),
    [sym__external_close_parenthesis] = ACTIONS(7123),
    [sym__external_open_brace] = ACTIONS(7123),
    [sym__external_close_brace] = ACTIONS(7123),
    [sym__external_open_bracket] = ACTIONS(7123),
    [sym__external_open_bracket2] = ACTIONS(7123),
  },
  [2184] = {
    [ts_builtin_sym_end] = ACTIONS(7139),
    [sym_identifier] = ACTIONS(7137),
    [anon_sym_BSLASH] = ACTIONS(7139),
    [anon_sym_function] = ACTIONS(7137),
    [anon_sym_EQ] = ACTIONS(7137),
    [anon_sym_if] = ACTIONS(7137),
    [anon_sym_for] = ACTIONS(7137),
    [anon_sym_while] = ACTIONS(7137),
    [anon_sym_repeat] = ACTIONS(7137),
    [anon_sym_QMARK] = ACTIONS(7139),
    [anon_sym_TILDE] = ACTIONS(7139),
    [anon_sym_BANG] = ACTIONS(7137),
    [anon_sym_PLUS] = ACTIONS(7139),
    [anon_sym_DASH] = ACTIONS(7137),
    [anon_sym_LT_DASH] = ACTIONS(7139),
    [anon_sym_LT_LT_DASH] = ACTIONS(7139),
    [anon_sym_COLON_EQ] = ACTIONS(7139),
    [anon_sym_DASH_GT] = ACTIONS(7137),
    [anon_sym_DASH_GT_GT] = ACTIONS(7139),
    [anon_sym_PIPE] = ACTIONS(7137),
    [anon_sym_AMP] = ACTIONS(7137),
    [anon_sym_PIPE_PIPE] = ACTIONS(7139),
    [anon_sym_AMP_AMP] = ACTIONS(7139),
    [anon_sym_LT] = ACTIONS(7137),
    [anon_sym_LT_EQ] = ACTIONS(7139),
    [anon_sym_GT] = ACTIONS(7137),
    [anon_sym_GT_EQ] = ACTIONS(7139),
    [anon_sym_EQ_EQ] = ACTIONS(7139),
    [anon_sym_BANG_EQ] = ACTIONS(7139),
    [anon_sym_STAR] = ACTIONS(7137),
    [anon_sym_SLASH] = ACTIONS(7139),
    [anon_sym_STAR_STAR] = ACTIONS(7139),
    [anon_sym_CARET] = ACTIONS(7139),
    [aux_sym_binary_operator_token1] = ACTIONS(7139),
    [anon_sym_PIPE_GT] = ACTIONS(7139),
    [anon_sym_COLON] = ACTIONS(7137),
    [anon_sym_DOLLAR] = ACTIONS(7139),
    [anon_sym_AT] = ACTIONS(7139),
    [anon_sym_COLON_COLON] = ACTIONS(7137),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7139),
    [aux_sym__hex_literal_token1] = ACTIONS(7139),
    [sym__number_literal] = ACTIONS(7137),
    [anon_sym_SQUOTE] = ACTIONS(7139),
    [anon_sym_DQUOTE] = ACTIONS(7139),
    [sym_return] = ACTIONS(7137),
    [sym_next] = ACTIONS(7137),
    [sym_break] = ACTIONS(7137),
    [sym_true] = ACTIONS(7137),
    [sym_false] = ACTIONS(7137),
    [sym_null] = ACTIONS(7137),
    [sym_inf] = ACTIONS(7137),
    [sym_nan] = ACTIONS(7137),
    [anon_sym_NA] = ACTIONS(7137),
    [anon_sym_NA_integer_] = ACTIONS(7137),
    [anon_sym_NA_real_] = ACTIONS(7137),
    [anon_sym_NA_complex_] = ACTIONS(7137),
    [anon_sym_NA_character_] = ACTIONS(7137),
    [sym_dots] = ACTIONS(7137),
    [sym_dot_dot_i] = ACTIONS(7139),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7139),
    [sym__newline] = ACTIONS(7139),
    [sym__semicolon] = ACTIONS(7139),
    [sym__raw_string_literal] = ACTIONS(7139),
    [sym__external_open_parenthesis] = ACTIONS(7139),
    [sym__external_close_parenthesis] = ACTIONS(7139),
    [sym__external_open_brace] = ACTIONS(7139),
    [sym__external_close_brace] = ACTIONS(7139),
    [sym__external_open_bracket] = ACTIONS(7139),
    [sym__external_open_bracket2] = ACTIONS(7139),
  },
  [2185] = {
    [sym_identifier] = ACTIONS(7163),
    [anon_sym_BSLASH] = ACTIONS(7165),
    [anon_sym_function] = ACTIONS(7163),
    [anon_sym_EQ] = ACTIONS(7163),
    [anon_sym_if] = ACTIONS(7163),
    [anon_sym_for] = ACTIONS(7163),
    [anon_sym_while] = ACTIONS(7163),
    [anon_sym_repeat] = ACTIONS(7163),
    [anon_sym_QMARK] = ACTIONS(7165),
    [anon_sym_TILDE] = ACTIONS(7165),
    [anon_sym_BANG] = ACTIONS(7163),
    [anon_sym_PLUS] = ACTIONS(7165),
    [anon_sym_DASH] = ACTIONS(7163),
    [anon_sym_LT_DASH] = ACTIONS(7165),
    [anon_sym_LT_LT_DASH] = ACTIONS(7165),
    [anon_sym_COLON_EQ] = ACTIONS(7165),
    [anon_sym_DASH_GT] = ACTIONS(7163),
    [anon_sym_DASH_GT_GT] = ACTIONS(7165),
    [anon_sym_PIPE] = ACTIONS(7163),
    [anon_sym_AMP] = ACTIONS(7163),
    [anon_sym_PIPE_PIPE] = ACTIONS(7165),
    [anon_sym_AMP_AMP] = ACTIONS(7165),
    [anon_sym_LT] = ACTIONS(7163),
    [anon_sym_LT_EQ] = ACTIONS(7165),
    [anon_sym_GT] = ACTIONS(7163),
    [anon_sym_GT_EQ] = ACTIONS(7165),
    [anon_sym_EQ_EQ] = ACTIONS(7165),
    [anon_sym_BANG_EQ] = ACTIONS(7165),
    [anon_sym_STAR] = ACTIONS(7163),
    [anon_sym_SLASH] = ACTIONS(7165),
    [anon_sym_STAR_STAR] = ACTIONS(7165),
    [anon_sym_CARET] = ACTIONS(7165),
    [aux_sym_binary_operator_token1] = ACTIONS(7165),
    [anon_sym_PIPE_GT] = ACTIONS(7165),
    [anon_sym_COLON] = ACTIONS(7163),
    [anon_sym_DOLLAR] = ACTIONS(7165),
    [anon_sym_AT] = ACTIONS(7165),
    [anon_sym_COLON_COLON] = ACTIONS(7163),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7165),
    [aux_sym__hex_literal_token1] = ACTIONS(7165),
    [sym__number_literal] = ACTIONS(7163),
    [anon_sym_SQUOTE] = ACTIONS(7165),
    [anon_sym_DQUOTE] = ACTIONS(7165),
    [sym_return] = ACTIONS(7163),
    [sym_next] = ACTIONS(7163),
    [sym_break] = ACTIONS(7163),
    [sym_true] = ACTIONS(7163),
    [sym_false] = ACTIONS(7163),
    [sym_null] = ACTIONS(7163),
    [sym_inf] = ACTIONS(7163),
    [sym_nan] = ACTIONS(7163),
    [anon_sym_NA] = ACTIONS(7163),
    [anon_sym_NA_integer_] = ACTIONS(7163),
    [anon_sym_NA_real_] = ACTIONS(7163),
    [anon_sym_NA_complex_] = ACTIONS(7163),
    [anon_sym_NA_character_] = ACTIONS(7163),
    [sym_dots] = ACTIONS(7163),
    [sym_dot_dot_i] = ACTIONS(7165),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7165),
    [sym__newline] = ACTIONS(7165),
    [sym__semicolon] = ACTIONS(7165),
    [sym__raw_string_literal] = ACTIONS(7165),
    [sym__external_open_parenthesis] = ACTIONS(7165),
    [sym__external_close_parenthesis] = ACTIONS(7165),
    [sym__external_open_brace] = ACTIONS(7165),
    [sym__external_close_brace] = ACTIONS(7165),
    [sym__external_open_bracket] = ACTIONS(7165),
    [sym__external_close_bracket] = ACTIONS(7165),
    [sym__external_open_bracket2] = ACTIONS(7165),
  },
  [2186] = {
    [sym_identifier] = ACTIONS(7151),
    [anon_sym_BSLASH] = ACTIONS(7153),
    [anon_sym_function] = ACTIONS(7151),
    [anon_sym_EQ] = ACTIONS(7151),
    [anon_sym_if] = ACTIONS(7151),
    [anon_sym_for] = ACTIONS(7151),
    [anon_sym_while] = ACTIONS(7151),
    [anon_sym_repeat] = ACTIONS(7151),
    [anon_sym_QMARK] = ACTIONS(7153),
    [anon_sym_TILDE] = ACTIONS(7153),
    [anon_sym_BANG] = ACTIONS(7151),
    [anon_sym_PLUS] = ACTIONS(7153),
    [anon_sym_DASH] = ACTIONS(7151),
    [anon_sym_LT_DASH] = ACTIONS(7153),
    [anon_sym_LT_LT_DASH] = ACTIONS(7153),
    [anon_sym_COLON_EQ] = ACTIONS(7153),
    [anon_sym_DASH_GT] = ACTIONS(7151),
    [anon_sym_DASH_GT_GT] = ACTIONS(7153),
    [anon_sym_PIPE] = ACTIONS(7151),
    [anon_sym_AMP] = ACTIONS(7151),
    [anon_sym_PIPE_PIPE] = ACTIONS(7153),
    [anon_sym_AMP_AMP] = ACTIONS(7153),
    [anon_sym_LT] = ACTIONS(7151),
    [anon_sym_LT_EQ] = ACTIONS(7153),
    [anon_sym_GT] = ACTIONS(7151),
    [anon_sym_GT_EQ] = ACTIONS(7153),
    [anon_sym_EQ_EQ] = ACTIONS(7153),
    [anon_sym_BANG_EQ] = ACTIONS(7153),
    [anon_sym_STAR] = ACTIONS(7151),
    [anon_sym_SLASH] = ACTIONS(7153),
    [anon_sym_STAR_STAR] = ACTIONS(7153),
    [anon_sym_CARET] = ACTIONS(7153),
    [aux_sym_binary_operator_token1] = ACTIONS(7153),
    [anon_sym_PIPE_GT] = ACTIONS(7153),
    [anon_sym_COLON] = ACTIONS(7151),
    [anon_sym_DOLLAR] = ACTIONS(7153),
    [anon_sym_AT] = ACTIONS(7153),
    [anon_sym_COLON_COLON] = ACTIONS(7151),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7153),
    [aux_sym__hex_literal_token1] = ACTIONS(7153),
    [sym__number_literal] = ACTIONS(7151),
    [anon_sym_SQUOTE] = ACTIONS(7153),
    [anon_sym_DQUOTE] = ACTIONS(7153),
    [sym_return] = ACTIONS(7151),
    [sym_next] = ACTIONS(7151),
    [sym_break] = ACTIONS(7151),
    [sym_true] = ACTIONS(7151),
    [sym_false] = ACTIONS(7151),
    [sym_null] = ACTIONS(7151),
    [sym_inf] = ACTIONS(7151),
    [sym_nan] = ACTIONS(7151),
    [anon_sym_NA] = ACTIONS(7151),
    [anon_sym_NA_integer_] = ACTIONS(7151),
    [anon_sym_NA_real_] = ACTIONS(7151),
    [anon_sym_NA_complex_] = ACTIONS(7151),
    [anon_sym_NA_character_] = ACTIONS(7151),
    [sym_dots] = ACTIONS(7151),
    [sym_dot_dot_i] = ACTIONS(7153),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7153),
    [sym__newline] = ACTIONS(7153),
    [sym__semicolon] = ACTIONS(7153),
    [sym__raw_string_literal] = ACTIONS(7153),
    [sym__external_open_parenthesis] = ACTIONS(7153),
    [sym__external_close_parenthesis] = ACTIONS(7153),
    [sym__external_open_brace] = ACTIONS(7153),
    [sym__external_close_brace] = ACTIONS(7153),
    [sym__external_open_bracket] = ACTIONS(7153),
    [sym__external_close_bracket] = ACTIONS(7153),
    [sym__external_open_bracket2] = ACTIONS(7153),
  },
  [2187] = {
    [sym_identifier] = ACTIONS(7115),
    [anon_sym_BSLASH] = ACTIONS(7117),
    [anon_sym_function] = ACTIONS(7115),
    [anon_sym_EQ] = ACTIONS(7115),
    [anon_sym_if] = ACTIONS(7115),
    [anon_sym_for] = ACTIONS(7115),
    [anon_sym_while] = ACTIONS(7115),
    [anon_sym_repeat] = ACTIONS(7115),
    [anon_sym_QMARK] = ACTIONS(7117),
    [anon_sym_TILDE] = ACTIONS(7117),
    [anon_sym_BANG] = ACTIONS(7115),
    [anon_sym_PLUS] = ACTIONS(7117),
    [anon_sym_DASH] = ACTIONS(7115),
    [anon_sym_LT_DASH] = ACTIONS(7117),
    [anon_sym_LT_LT_DASH] = ACTIONS(7117),
    [anon_sym_COLON_EQ] = ACTIONS(7117),
    [anon_sym_DASH_GT] = ACTIONS(7115),
    [anon_sym_DASH_GT_GT] = ACTIONS(7117),
    [anon_sym_PIPE] = ACTIONS(7115),
    [anon_sym_AMP] = ACTIONS(7115),
    [anon_sym_PIPE_PIPE] = ACTIONS(7117),
    [anon_sym_AMP_AMP] = ACTIONS(7117),
    [anon_sym_LT] = ACTIONS(7115),
    [anon_sym_LT_EQ] = ACTIONS(7117),
    [anon_sym_GT] = ACTIONS(7115),
    [anon_sym_GT_EQ] = ACTIONS(7117),
    [anon_sym_EQ_EQ] = ACTIONS(7117),
    [anon_sym_BANG_EQ] = ACTIONS(7117),
    [anon_sym_STAR] = ACTIONS(7115),
    [anon_sym_SLASH] = ACTIONS(7117),
    [anon_sym_STAR_STAR] = ACTIONS(7117),
    [anon_sym_CARET] = ACTIONS(7117),
    [aux_sym_binary_operator_token1] = ACTIONS(7117),
    [anon_sym_PIPE_GT] = ACTIONS(7117),
    [anon_sym_COLON] = ACTIONS(7115),
    [anon_sym_DOLLAR] = ACTIONS(7117),
    [anon_sym_AT] = ACTIONS(7117),
    [anon_sym_COLON_COLON] = ACTIONS(7115),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7117),
    [aux_sym__hex_literal_token1] = ACTIONS(7117),
    [sym__number_literal] = ACTIONS(7115),
    [anon_sym_SQUOTE] = ACTIONS(7117),
    [anon_sym_DQUOTE] = ACTIONS(7117),
    [sym_return] = ACTIONS(7115),
    [sym_next] = ACTIONS(7115),
    [sym_break] = ACTIONS(7115),
    [sym_true] = ACTIONS(7115),
    [sym_false] = ACTIONS(7115),
    [sym_null] = ACTIONS(7115),
    [sym_inf] = ACTIONS(7115),
    [sym_nan] = ACTIONS(7115),
    [anon_sym_NA] = ACTIONS(7115),
    [anon_sym_NA_integer_] = ACTIONS(7115),
    [anon_sym_NA_real_] = ACTIONS(7115),
    [anon_sym_NA_complex_] = ACTIONS(7115),
    [anon_sym_NA_character_] = ACTIONS(7115),
    [sym_dots] = ACTIONS(7115),
    [sym_dot_dot_i] = ACTIONS(7117),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7117),
    [sym__newline] = ACTIONS(7117),
    [sym__semicolon] = ACTIONS(7117),
    [sym__raw_string_literal] = ACTIONS(7117),
    [sym__external_open_parenthesis] = ACTIONS(7117),
    [sym__external_close_parenthesis] = ACTIONS(7117),
    [sym__external_open_brace] = ACTIONS(7117),
    [sym__external_close_brace] = ACTIONS(7117),
    [sym__external_open_bracket] = ACTIONS(7117),
    [sym__external_close_bracket] = ACTIONS(7117),
    [sym__external_open_bracket2] = ACTIONS(7117),
  },
  [2188] = {
    [sym_identifier] = ACTIONS(7115),
    [anon_sym_BSLASH] = ACTIONS(7117),
    [anon_sym_function] = ACTIONS(7115),
    [anon_sym_EQ] = ACTIONS(7115),
    [anon_sym_if] = ACTIONS(7115),
    [anon_sym_for] = ACTIONS(7115),
    [anon_sym_while] = ACTIONS(7115),
    [anon_sym_repeat] = ACTIONS(7115),
    [anon_sym_QMARK] = ACTIONS(7117),
    [anon_sym_TILDE] = ACTIONS(7117),
    [anon_sym_BANG] = ACTIONS(7115),
    [anon_sym_PLUS] = ACTIONS(7117),
    [anon_sym_DASH] = ACTIONS(7115),
    [anon_sym_LT_DASH] = ACTIONS(7117),
    [anon_sym_LT_LT_DASH] = ACTIONS(7117),
    [anon_sym_COLON_EQ] = ACTIONS(7117),
    [anon_sym_DASH_GT] = ACTIONS(7115),
    [anon_sym_DASH_GT_GT] = ACTIONS(7117),
    [anon_sym_PIPE] = ACTIONS(7115),
    [anon_sym_AMP] = ACTIONS(7115),
    [anon_sym_PIPE_PIPE] = ACTIONS(7117),
    [anon_sym_AMP_AMP] = ACTIONS(7117),
    [anon_sym_LT] = ACTIONS(7115),
    [anon_sym_LT_EQ] = ACTIONS(7117),
    [anon_sym_GT] = ACTIONS(7115),
    [anon_sym_GT_EQ] = ACTIONS(7117),
    [anon_sym_EQ_EQ] = ACTIONS(7117),
    [anon_sym_BANG_EQ] = ACTIONS(7117),
    [anon_sym_STAR] = ACTIONS(7115),
    [anon_sym_SLASH] = ACTIONS(7117),
    [anon_sym_STAR_STAR] = ACTIONS(7117),
    [anon_sym_CARET] = ACTIONS(7117),
    [aux_sym_binary_operator_token1] = ACTIONS(7117),
    [anon_sym_PIPE_GT] = ACTIONS(7117),
    [anon_sym_COLON] = ACTIONS(7115),
    [anon_sym_DOLLAR] = ACTIONS(7117),
    [anon_sym_AT] = ACTIONS(7117),
    [anon_sym_COLON_COLON] = ACTIONS(7115),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7117),
    [aux_sym__hex_literal_token1] = ACTIONS(7117),
    [sym__number_literal] = ACTIONS(7115),
    [anon_sym_SQUOTE] = ACTIONS(7117),
    [anon_sym_DQUOTE] = ACTIONS(7117),
    [sym_return] = ACTIONS(7115),
    [sym_next] = ACTIONS(7115),
    [sym_break] = ACTIONS(7115),
    [sym_true] = ACTIONS(7115),
    [sym_false] = ACTIONS(7115),
    [sym_null] = ACTIONS(7115),
    [sym_inf] = ACTIONS(7115),
    [sym_nan] = ACTIONS(7115),
    [anon_sym_NA] = ACTIONS(7115),
    [anon_sym_NA_integer_] = ACTIONS(7115),
    [anon_sym_NA_real_] = ACTIONS(7115),
    [anon_sym_NA_complex_] = ACTIONS(7115),
    [anon_sym_NA_character_] = ACTIONS(7115),
    [sym_dots] = ACTIONS(7115),
    [sym_dot_dot_i] = ACTIONS(7117),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7117),
    [sym__newline] = ACTIONS(7117),
    [sym__semicolon] = ACTIONS(7117),
    [sym__raw_string_literal] = ACTIONS(7117),
    [sym__external_open_parenthesis] = ACTIONS(7117),
    [sym__external_close_parenthesis] = ACTIONS(7117),
    [sym__external_open_brace] = ACTIONS(7117),
    [sym__external_close_brace] = ACTIONS(7117),
    [sym__external_open_bracket] = ACTIONS(7117),
    [sym__external_close_bracket] = ACTIONS(7117),
    [sym__external_open_bracket2] = ACTIONS(7117),
  },
  [2189] = {
    [sym_identifier] = ACTIONS(7121),
    [anon_sym_BSLASH] = ACTIONS(7123),
    [anon_sym_function] = ACTIONS(7121),
    [anon_sym_EQ] = ACTIONS(7121),
    [anon_sym_if] = ACTIONS(7121),
    [anon_sym_for] = ACTIONS(7121),
    [anon_sym_while] = ACTIONS(7121),
    [anon_sym_repeat] = ACTIONS(7121),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_TILDE] = ACTIONS(7123),
    [anon_sym_BANG] = ACTIONS(7121),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_DASH] = ACTIONS(7121),
    [anon_sym_LT_DASH] = ACTIONS(7123),
    [anon_sym_LT_LT_DASH] = ACTIONS(7123),
    [anon_sym_COLON_EQ] = ACTIONS(7123),
    [anon_sym_DASH_GT] = ACTIONS(7121),
    [anon_sym_DASH_GT_GT] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_LT_EQ] = ACTIONS(7123),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
    [aux_sym_binary_operator_token1] = ACTIONS(7123),
    [anon_sym_PIPE_GT] = ACTIONS(7123),
    [anon_sym_COLON] = ACTIONS(7121),
    [anon_sym_DOLLAR] = ACTIONS(7123),
    [anon_sym_AT] = ACTIONS(7123),
    [anon_sym_L] = ACTIONS(7413),
    [anon_sym_i] = ACTIONS(7415),
    [aux_sym__hex_literal_token1] = ACTIONS(7123),
    [sym__number_literal] = ACTIONS(7121),
    [anon_sym_SQUOTE] = ACTIONS(7123),
    [anon_sym_DQUOTE] = ACTIONS(7123),
    [sym_return] = ACTIONS(7121),
    [sym_next] = ACTIONS(7121),
    [sym_break] = ACTIONS(7121),
    [sym_true] = ACTIONS(7121),
    [sym_false] = ACTIONS(7121),
    [sym_null] = ACTIONS(7121),
    [sym_inf] = ACTIONS(7121),
    [sym_nan] = ACTIONS(7121),
    [anon_sym_NA] = ACTIONS(7121),
    [anon_sym_NA_integer_] = ACTIONS(7121),
    [anon_sym_NA_real_] = ACTIONS(7121),
    [anon_sym_NA_complex_] = ACTIONS(7121),
    [anon_sym_NA_character_] = ACTIONS(7121),
    [sym_dots] = ACTIONS(7121),
    [sym_dot_dot_i] = ACTIONS(7123),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7123),
    [sym__newline] = ACTIONS(7123),
    [sym__semicolon] = ACTIONS(7123),
    [sym__raw_string_literal] = ACTIONS(7123),
    [sym__external_open_parenthesis] = ACTIONS(7123),
    [sym__external_close_parenthesis] = ACTIONS(7123),
    [sym__external_open_brace] = ACTIONS(7123),
    [sym__external_close_brace] = ACTIONS(7123),
    [sym__external_open_bracket] = ACTIONS(7123),
    [sym__external_close_bracket] = ACTIONS(7123),
    [sym__external_open_bracket2] = ACTIONS(7123),
  },
  [2190] = {
    [sym_identifier] = ACTIONS(7195),
    [anon_sym_BSLASH] = ACTIONS(7193),
    [anon_sym_function] = ACTIONS(7195),
    [anon_sym_EQ] = ACTIONS(7195),
    [anon_sym_if] = ACTIONS(7195),
    [anon_sym_for] = ACTIONS(7195),
    [anon_sym_while] = ACTIONS(7195),
    [anon_sym_repeat] = ACTIONS(7195),
    [anon_sym_QMARK] = ACTIONS(7193),
    [anon_sym_TILDE] = ACTIONS(7193),
    [anon_sym_BANG] = ACTIONS(7195),
    [anon_sym_PLUS] = ACTIONS(7193),
    [anon_sym_DASH] = ACTIONS(7195),
    [anon_sym_LT_DASH] = ACTIONS(7193),
    [anon_sym_LT_LT_DASH] = ACTIONS(7193),
    [anon_sym_COLON_EQ] = ACTIONS(7193),
    [anon_sym_DASH_GT] = ACTIONS(7195),
    [anon_sym_DASH_GT_GT] = ACTIONS(7193),
    [anon_sym_PIPE] = ACTIONS(7195),
    [anon_sym_AMP] = ACTIONS(7195),
    [anon_sym_PIPE_PIPE] = ACTIONS(7193),
    [anon_sym_AMP_AMP] = ACTIONS(7193),
    [anon_sym_LT] = ACTIONS(7195),
    [anon_sym_LT_EQ] = ACTIONS(7193),
    [anon_sym_GT] = ACTIONS(7195),
    [anon_sym_GT_EQ] = ACTIONS(7193),
    [anon_sym_EQ_EQ] = ACTIONS(7193),
    [anon_sym_BANG_EQ] = ACTIONS(7193),
    [anon_sym_STAR] = ACTIONS(7195),
    [anon_sym_SLASH] = ACTIONS(7193),
    [anon_sym_STAR_STAR] = ACTIONS(7193),
    [anon_sym_CARET] = ACTIONS(7193),
    [aux_sym_binary_operator_token1] = ACTIONS(7193),
    [anon_sym_PIPE_GT] = ACTIONS(7193),
    [anon_sym_COLON] = ACTIONS(7195),
    [anon_sym_DOLLAR] = ACTIONS(7193),
    [anon_sym_AT] = ACTIONS(7193),
    [anon_sym_COLON_COLON] = ACTIONS(7195),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7193),
    [aux_sym__hex_literal_token1] = ACTIONS(7193),
    [sym__number_literal] = ACTIONS(7195),
    [anon_sym_SQUOTE] = ACTIONS(7193),
    [anon_sym_DQUOTE] = ACTIONS(7193),
    [sym_return] = ACTIONS(7195),
    [sym_next] = ACTIONS(7195),
    [sym_break] = ACTIONS(7195),
    [sym_true] = ACTIONS(7195),
    [sym_false] = ACTIONS(7195),
    [sym_null] = ACTIONS(7195),
    [sym_inf] = ACTIONS(7195),
    [sym_nan] = ACTIONS(7195),
    [anon_sym_NA] = ACTIONS(7195),
    [anon_sym_NA_integer_] = ACTIONS(7195),
    [anon_sym_NA_real_] = ACTIONS(7195),
    [anon_sym_NA_complex_] = ACTIONS(7195),
    [anon_sym_NA_character_] = ACTIONS(7195),
    [sym_dots] = ACTIONS(7195),
    [sym_dot_dot_i] = ACTIONS(7193),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7193),
    [sym__newline] = ACTIONS(7193),
    [sym__semicolon] = ACTIONS(7193),
    [sym__raw_string_literal] = ACTIONS(7193),
    [sym__external_open_parenthesis] = ACTIONS(7193),
    [sym__external_close_parenthesis] = ACTIONS(7193),
    [sym__external_open_brace] = ACTIONS(7193),
    [sym__external_close_brace] = ACTIONS(7193),
    [sym__external_open_bracket] = ACTIONS(7193),
    [sym__external_open_bracket2] = ACTIONS(7193),
    [sym__external_close_bracket2] = ACTIONS(7193),
  },
  [2191] = {
    [sym_identifier] = ACTIONS(7191),
    [anon_sym_BSLASH] = ACTIONS(7189),
    [anon_sym_function] = ACTIONS(7191),
    [anon_sym_EQ] = ACTIONS(7191),
    [anon_sym_if] = ACTIONS(7191),
    [anon_sym_for] = ACTIONS(7191),
    [anon_sym_while] = ACTIONS(7191),
    [anon_sym_repeat] = ACTIONS(7191),
    [anon_sym_QMARK] = ACTIONS(7189),
    [anon_sym_TILDE] = ACTIONS(7189),
    [anon_sym_BANG] = ACTIONS(7191),
    [anon_sym_PLUS] = ACTIONS(7189),
    [anon_sym_DASH] = ACTIONS(7191),
    [anon_sym_LT_DASH] = ACTIONS(7189),
    [anon_sym_LT_LT_DASH] = ACTIONS(7189),
    [anon_sym_COLON_EQ] = ACTIONS(7189),
    [anon_sym_DASH_GT] = ACTIONS(7191),
    [anon_sym_DASH_GT_GT] = ACTIONS(7189),
    [anon_sym_PIPE] = ACTIONS(7191),
    [anon_sym_AMP] = ACTIONS(7191),
    [anon_sym_PIPE_PIPE] = ACTIONS(7189),
    [anon_sym_AMP_AMP] = ACTIONS(7189),
    [anon_sym_LT] = ACTIONS(7191),
    [anon_sym_LT_EQ] = ACTIONS(7189),
    [anon_sym_GT] = ACTIONS(7191),
    [anon_sym_GT_EQ] = ACTIONS(7189),
    [anon_sym_EQ_EQ] = ACTIONS(7189),
    [anon_sym_BANG_EQ] = ACTIONS(7189),
    [anon_sym_STAR] = ACTIONS(7191),
    [anon_sym_SLASH] = ACTIONS(7189),
    [anon_sym_STAR_STAR] = ACTIONS(7189),
    [anon_sym_CARET] = ACTIONS(7189),
    [aux_sym_binary_operator_token1] = ACTIONS(7189),
    [anon_sym_PIPE_GT] = ACTIONS(7189),
    [anon_sym_COLON] = ACTIONS(7191),
    [anon_sym_DOLLAR] = ACTIONS(7189),
    [anon_sym_AT] = ACTIONS(7189),
    [anon_sym_COLON_COLON] = ACTIONS(7191),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7189),
    [aux_sym__hex_literal_token1] = ACTIONS(7189),
    [sym__number_literal] = ACTIONS(7191),
    [anon_sym_SQUOTE] = ACTIONS(7189),
    [anon_sym_DQUOTE] = ACTIONS(7189),
    [sym_return] = ACTIONS(7191),
    [sym_next] = ACTIONS(7191),
    [sym_break] = ACTIONS(7191),
    [sym_true] = ACTIONS(7191),
    [sym_false] = ACTIONS(7191),
    [sym_null] = ACTIONS(7191),
    [sym_inf] = ACTIONS(7191),
    [sym_nan] = ACTIONS(7191),
    [anon_sym_NA] = ACTIONS(7191),
    [anon_sym_NA_integer_] = ACTIONS(7191),
    [anon_sym_NA_real_] = ACTIONS(7191),
    [anon_sym_NA_complex_] = ACTIONS(7191),
    [anon_sym_NA_character_] = ACTIONS(7191),
    [sym_dots] = ACTIONS(7191),
    [sym_dot_dot_i] = ACTIONS(7189),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7189),
    [sym__newline] = ACTIONS(7189),
    [sym__semicolon] = ACTIONS(7189),
    [sym__raw_string_literal] = ACTIONS(7189),
    [sym__external_open_parenthesis] = ACTIONS(7189),
    [sym__external_close_parenthesis] = ACTIONS(7189),
    [sym__external_open_brace] = ACTIONS(7189),
    [sym__external_close_brace] = ACTIONS(7189),
    [sym__external_open_bracket] = ACTIONS(7189),
    [sym__external_open_bracket2] = ACTIONS(7189),
    [sym__external_close_bracket2] = ACTIONS(7189),
  },
  [2192] = {
    [sym_identifier] = ACTIONS(7129),
    [anon_sym_BSLASH] = ACTIONS(7131),
    [anon_sym_function] = ACTIONS(7129),
    [anon_sym_EQ] = ACTIONS(7129),
    [anon_sym_if] = ACTIONS(7129),
    [anon_sym_for] = ACTIONS(7129),
    [anon_sym_while] = ACTIONS(7129),
    [anon_sym_repeat] = ACTIONS(7129),
    [anon_sym_QMARK] = ACTIONS(7131),
    [anon_sym_TILDE] = ACTIONS(7131),
    [anon_sym_BANG] = ACTIONS(7129),
    [anon_sym_PLUS] = ACTIONS(7131),
    [anon_sym_DASH] = ACTIONS(7129),
    [anon_sym_LT_DASH] = ACTIONS(7131),
    [anon_sym_LT_LT_DASH] = ACTIONS(7131),
    [anon_sym_COLON_EQ] = ACTIONS(7131),
    [anon_sym_DASH_GT] = ACTIONS(7129),
    [anon_sym_DASH_GT_GT] = ACTIONS(7131),
    [anon_sym_PIPE] = ACTIONS(7129),
    [anon_sym_AMP] = ACTIONS(7129),
    [anon_sym_PIPE_PIPE] = ACTIONS(7131),
    [anon_sym_AMP_AMP] = ACTIONS(7131),
    [anon_sym_LT] = ACTIONS(7129),
    [anon_sym_LT_EQ] = ACTIONS(7131),
    [anon_sym_GT] = ACTIONS(7129),
    [anon_sym_GT_EQ] = ACTIONS(7131),
    [anon_sym_EQ_EQ] = ACTIONS(7131),
    [anon_sym_BANG_EQ] = ACTIONS(7131),
    [anon_sym_STAR] = ACTIONS(7129),
    [anon_sym_SLASH] = ACTIONS(7131),
    [anon_sym_STAR_STAR] = ACTIONS(7131),
    [anon_sym_CARET] = ACTIONS(7131),
    [aux_sym_binary_operator_token1] = ACTIONS(7131),
    [anon_sym_PIPE_GT] = ACTIONS(7131),
    [anon_sym_COLON] = ACTIONS(7129),
    [anon_sym_DOLLAR] = ACTIONS(7131),
    [anon_sym_AT] = ACTIONS(7131),
    [anon_sym_COLON_COLON] = ACTIONS(7133),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7135),
    [aux_sym__hex_literal_token1] = ACTIONS(7131),
    [sym__number_literal] = ACTIONS(7129),
    [anon_sym_SQUOTE] = ACTIONS(7131),
    [anon_sym_DQUOTE] = ACTIONS(7131),
    [sym_return] = ACTIONS(7129),
    [sym_next] = ACTIONS(7129),
    [sym_break] = ACTIONS(7129),
    [sym_true] = ACTIONS(7129),
    [sym_false] = ACTIONS(7129),
    [sym_null] = ACTIONS(7129),
    [sym_inf] = ACTIONS(7129),
    [sym_nan] = ACTIONS(7129),
    [anon_sym_NA] = ACTIONS(7129),
    [anon_sym_NA_integer_] = ACTIONS(7129),
    [anon_sym_NA_real_] = ACTIONS(7129),
    [anon_sym_NA_complex_] = ACTIONS(7129),
    [anon_sym_NA_character_] = ACTIONS(7129),
    [sym_dots] = ACTIONS(7129),
    [sym_dot_dot_i] = ACTIONS(7131),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7131),
    [sym__newline] = ACTIONS(7131),
    [sym__semicolon] = ACTIONS(7131),
    [sym__raw_string_literal] = ACTIONS(7131),
    [sym__external_open_parenthesis] = ACTIONS(7131),
    [sym__external_close_parenthesis] = ACTIONS(7131),
    [sym__external_open_brace] = ACTIONS(7131),
    [sym__external_close_brace] = ACTIONS(7131),
    [sym__external_open_bracket] = ACTIONS(7131),
    [sym__external_close_bracket] = ACTIONS(7131),
    [sym__external_open_bracket2] = ACTIONS(7131),
  },
  [2193] = {
    [sym_identifier] = ACTIONS(7137),
    [anon_sym_BSLASH] = ACTIONS(7139),
    [anon_sym_function] = ACTIONS(7137),
    [anon_sym_EQ] = ACTIONS(7137),
    [anon_sym_if] = ACTIONS(7137),
    [anon_sym_for] = ACTIONS(7137),
    [anon_sym_while] = ACTIONS(7137),
    [anon_sym_repeat] = ACTIONS(7137),
    [anon_sym_QMARK] = ACTIONS(7139),
    [anon_sym_TILDE] = ACTIONS(7139),
    [anon_sym_BANG] = ACTIONS(7137),
    [anon_sym_PLUS] = ACTIONS(7139),
    [anon_sym_DASH] = ACTIONS(7137),
    [anon_sym_LT_DASH] = ACTIONS(7139),
    [anon_sym_LT_LT_DASH] = ACTIONS(7139),
    [anon_sym_COLON_EQ] = ACTIONS(7139),
    [anon_sym_DASH_GT] = ACTIONS(7137),
    [anon_sym_DASH_GT_GT] = ACTIONS(7139),
    [anon_sym_PIPE] = ACTIONS(7137),
    [anon_sym_AMP] = ACTIONS(7137),
    [anon_sym_PIPE_PIPE] = ACTIONS(7139),
    [anon_sym_AMP_AMP] = ACTIONS(7139),
    [anon_sym_LT] = ACTIONS(7137),
    [anon_sym_LT_EQ] = ACTIONS(7139),
    [anon_sym_GT] = ACTIONS(7137),
    [anon_sym_GT_EQ] = ACTIONS(7139),
    [anon_sym_EQ_EQ] = ACTIONS(7139),
    [anon_sym_BANG_EQ] = ACTIONS(7139),
    [anon_sym_STAR] = ACTIONS(7137),
    [anon_sym_SLASH] = ACTIONS(7139),
    [anon_sym_STAR_STAR] = ACTIONS(7139),
    [anon_sym_CARET] = ACTIONS(7139),
    [aux_sym_binary_operator_token1] = ACTIONS(7139),
    [anon_sym_PIPE_GT] = ACTIONS(7139),
    [anon_sym_COLON] = ACTIONS(7137),
    [anon_sym_DOLLAR] = ACTIONS(7139),
    [anon_sym_AT] = ACTIONS(7139),
    [anon_sym_COLON_COLON] = ACTIONS(7137),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7139),
    [aux_sym__hex_literal_token1] = ACTIONS(7139),
    [sym__number_literal] = ACTIONS(7137),
    [anon_sym_SQUOTE] = ACTIONS(7139),
    [anon_sym_DQUOTE] = ACTIONS(7139),
    [sym_return] = ACTIONS(7137),
    [sym_next] = ACTIONS(7137),
    [sym_break] = ACTIONS(7137),
    [sym_true] = ACTIONS(7137),
    [sym_false] = ACTIONS(7137),
    [sym_null] = ACTIONS(7137),
    [sym_inf] = ACTIONS(7137),
    [sym_nan] = ACTIONS(7137),
    [anon_sym_NA] = ACTIONS(7137),
    [anon_sym_NA_integer_] = ACTIONS(7137),
    [anon_sym_NA_real_] = ACTIONS(7137),
    [anon_sym_NA_complex_] = ACTIONS(7137),
    [anon_sym_NA_character_] = ACTIONS(7137),
    [sym_dots] = ACTIONS(7137),
    [sym_dot_dot_i] = ACTIONS(7139),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7139),
    [sym__newline] = ACTIONS(7139),
    [sym__semicolon] = ACTIONS(7139),
    [sym__raw_string_literal] = ACTIONS(7139),
    [sym__external_open_parenthesis] = ACTIONS(7139),
    [sym__external_close_parenthesis] = ACTIONS(7139),
    [sym__external_open_brace] = ACTIONS(7139),
    [sym__external_close_brace] = ACTIONS(7139),
    [sym__external_open_bracket] = ACTIONS(7139),
    [sym__external_close_bracket] = ACTIONS(7139),
    [sym__external_open_bracket2] = ACTIONS(7139),
  },
  [2194] = {
    [sym_identifier] = ACTIONS(7191),
    [anon_sym_BSLASH] = ACTIONS(7189),
    [anon_sym_function] = ACTIONS(7191),
    [anon_sym_EQ] = ACTIONS(7191),
    [anon_sym_if] = ACTIONS(7191),
    [anon_sym_for] = ACTIONS(7191),
    [anon_sym_while] = ACTIONS(7191),
    [anon_sym_repeat] = ACTIONS(7191),
    [anon_sym_QMARK] = ACTIONS(7189),
    [anon_sym_TILDE] = ACTIONS(7189),
    [anon_sym_BANG] = ACTIONS(7191),
    [anon_sym_PLUS] = ACTIONS(7189),
    [anon_sym_DASH] = ACTIONS(7191),
    [anon_sym_LT_DASH] = ACTIONS(7189),
    [anon_sym_LT_LT_DASH] = ACTIONS(7189),
    [anon_sym_COLON_EQ] = ACTIONS(7189),
    [anon_sym_DASH_GT] = ACTIONS(7191),
    [anon_sym_DASH_GT_GT] = ACTIONS(7189),
    [anon_sym_PIPE] = ACTIONS(7191),
    [anon_sym_AMP] = ACTIONS(7191),
    [anon_sym_PIPE_PIPE] = ACTIONS(7189),
    [anon_sym_AMP_AMP] = ACTIONS(7189),
    [anon_sym_LT] = ACTIONS(7191),
    [anon_sym_LT_EQ] = ACTIONS(7189),
    [anon_sym_GT] = ACTIONS(7191),
    [anon_sym_GT_EQ] = ACTIONS(7189),
    [anon_sym_EQ_EQ] = ACTIONS(7189),
    [anon_sym_BANG_EQ] = ACTIONS(7189),
    [anon_sym_STAR] = ACTIONS(7191),
    [anon_sym_SLASH] = ACTIONS(7189),
    [anon_sym_STAR_STAR] = ACTIONS(7189),
    [anon_sym_CARET] = ACTIONS(7189),
    [aux_sym_binary_operator_token1] = ACTIONS(7189),
    [anon_sym_PIPE_GT] = ACTIONS(7189),
    [anon_sym_COLON] = ACTIONS(7191),
    [anon_sym_DOLLAR] = ACTIONS(7189),
    [anon_sym_AT] = ACTIONS(7189),
    [anon_sym_COLON_COLON] = ACTIONS(7191),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7189),
    [aux_sym__hex_literal_token1] = ACTIONS(7189),
    [sym__number_literal] = ACTIONS(7191),
    [anon_sym_SQUOTE] = ACTIONS(7189),
    [anon_sym_DQUOTE] = ACTIONS(7189),
    [sym_return] = ACTIONS(7191),
    [sym_next] = ACTIONS(7191),
    [sym_break] = ACTIONS(7191),
    [sym_true] = ACTIONS(7191),
    [sym_false] = ACTIONS(7191),
    [sym_null] = ACTIONS(7191),
    [sym_inf] = ACTIONS(7191),
    [sym_nan] = ACTIONS(7191),
    [anon_sym_NA] = ACTIONS(7191),
    [anon_sym_NA_integer_] = ACTIONS(7191),
    [anon_sym_NA_real_] = ACTIONS(7191),
    [anon_sym_NA_complex_] = ACTIONS(7191),
    [anon_sym_NA_character_] = ACTIONS(7191),
    [sym_dots] = ACTIONS(7191),
    [sym_dot_dot_i] = ACTIONS(7189),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7189),
    [sym__newline] = ACTIONS(7189),
    [sym__semicolon] = ACTIONS(7189),
    [sym__raw_string_literal] = ACTIONS(7189),
    [sym__external_else] = ACTIONS(7189),
    [sym__external_open_parenthesis] = ACTIONS(7189),
    [sym__external_open_brace] = ACTIONS(7189),
    [sym__external_close_brace] = ACTIONS(7189),
    [sym__external_open_bracket] = ACTIONS(7189),
    [sym__external_open_bracket2] = ACTIONS(7189),
    [sym__external_close_bracket2] = ACTIONS(7189),
  },
  [2195] = {
    [aux_sym_function_definition_repeat1] = STATE(2195),
    [ts_builtin_sym_end] = ACTIONS(7417),
    [sym_identifier] = ACTIONS(7419),
    [anon_sym_BSLASH] = ACTIONS(7417),
    [anon_sym_function] = ACTIONS(7419),
    [anon_sym_EQ] = ACTIONS(7419),
    [anon_sym_if] = ACTIONS(7419),
    [anon_sym_for] = ACTIONS(7419),
    [anon_sym_while] = ACTIONS(7419),
    [anon_sym_repeat] = ACTIONS(7419),
    [anon_sym_QMARK] = ACTIONS(7417),
    [anon_sym_TILDE] = ACTIONS(7417),
    [anon_sym_BANG] = ACTIONS(7419),
    [anon_sym_PLUS] = ACTIONS(7417),
    [anon_sym_DASH] = ACTIONS(7419),
    [anon_sym_LT_DASH] = ACTIONS(7417),
    [anon_sym_LT_LT_DASH] = ACTIONS(7417),
    [anon_sym_COLON_EQ] = ACTIONS(7417),
    [anon_sym_DASH_GT] = ACTIONS(7419),
    [anon_sym_DASH_GT_GT] = ACTIONS(7417),
    [anon_sym_PIPE] = ACTIONS(7419),
    [anon_sym_AMP] = ACTIONS(7419),
    [anon_sym_PIPE_PIPE] = ACTIONS(7417),
    [anon_sym_AMP_AMP] = ACTIONS(7417),
    [anon_sym_LT] = ACTIONS(7419),
    [anon_sym_LT_EQ] = ACTIONS(7417),
    [anon_sym_GT] = ACTIONS(7419),
    [anon_sym_GT_EQ] = ACTIONS(7417),
    [anon_sym_EQ_EQ] = ACTIONS(7417),
    [anon_sym_BANG_EQ] = ACTIONS(7417),
    [anon_sym_STAR] = ACTIONS(7419),
    [anon_sym_SLASH] = ACTIONS(7417),
    [anon_sym_STAR_STAR] = ACTIONS(7417),
    [anon_sym_CARET] = ACTIONS(7417),
    [aux_sym_binary_operator_token1] = ACTIONS(7417),
    [anon_sym_PIPE_GT] = ACTIONS(7417),
    [anon_sym_COLON] = ACTIONS(7419),
    [anon_sym_DOLLAR] = ACTIONS(7417),
    [anon_sym_AT] = ACTIONS(7417),
    [aux_sym__hex_literal_token1] = ACTIONS(7417),
    [sym__number_literal] = ACTIONS(7419),
    [anon_sym_SQUOTE] = ACTIONS(7417),
    [anon_sym_DQUOTE] = ACTIONS(7417),
    [sym_return] = ACTIONS(7419),
    [sym_next] = ACTIONS(7419),
    [sym_break] = ACTIONS(7419),
    [sym_true] = ACTIONS(7419),
    [sym_false] = ACTIONS(7419),
    [sym_null] = ACTIONS(7419),
    [sym_inf] = ACTIONS(7419),
    [sym_nan] = ACTIONS(7419),
    [anon_sym_NA] = ACTIONS(7419),
    [anon_sym_NA_integer_] = ACTIONS(7419),
    [anon_sym_NA_real_] = ACTIONS(7419),
    [anon_sym_NA_complex_] = ACTIONS(7419),
    [anon_sym_NA_character_] = ACTIONS(7419),
    [sym_dots] = ACTIONS(7419),
    [sym_dot_dot_i] = ACTIONS(7417),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7417),
    [sym__newline] = ACTIONS(7421),
    [sym__semicolon] = ACTIONS(7417),
    [sym__raw_string_literal] = ACTIONS(7417),
    [sym__external_else] = ACTIONS(7417),
    [sym__external_open_parenthesis] = ACTIONS(7417),
    [sym__external_close_parenthesis] = ACTIONS(7417),
    [sym__external_open_brace] = ACTIONS(7417),
    [sym__external_close_brace] = ACTIONS(7417),
    [sym__external_open_bracket] = ACTIONS(7417),
    [sym__external_open_bracket2] = ACTIONS(7417),
  },
  [2196] = {
    [aux_sym_function_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(7419),
    [anon_sym_BSLASH] = ACTIONS(7417),
    [anon_sym_function] = ACTIONS(7419),
    [anon_sym_EQ] = ACTIONS(7419),
    [anon_sym_if] = ACTIONS(7419),
    [anon_sym_for] = ACTIONS(7419),
    [anon_sym_while] = ACTIONS(7419),
    [anon_sym_repeat] = ACTIONS(7419),
    [anon_sym_QMARK] = ACTIONS(7417),
    [anon_sym_TILDE] = ACTIONS(7417),
    [anon_sym_BANG] = ACTIONS(7419),
    [anon_sym_PLUS] = ACTIONS(7417),
    [anon_sym_DASH] = ACTIONS(7419),
    [anon_sym_LT_DASH] = ACTIONS(7417),
    [anon_sym_LT_LT_DASH] = ACTIONS(7417),
    [anon_sym_COLON_EQ] = ACTIONS(7417),
    [anon_sym_DASH_GT] = ACTIONS(7419),
    [anon_sym_DASH_GT_GT] = ACTIONS(7417),
    [anon_sym_PIPE] = ACTIONS(7419),
    [anon_sym_AMP] = ACTIONS(7419),
    [anon_sym_PIPE_PIPE] = ACTIONS(7417),
    [anon_sym_AMP_AMP] = ACTIONS(7417),
    [anon_sym_LT] = ACTIONS(7419),
    [anon_sym_LT_EQ] = ACTIONS(7417),
    [anon_sym_GT] = ACTIONS(7419),
    [anon_sym_GT_EQ] = ACTIONS(7417),
    [anon_sym_EQ_EQ] = ACTIONS(7417),
    [anon_sym_BANG_EQ] = ACTIONS(7417),
    [anon_sym_STAR] = ACTIONS(7419),
    [anon_sym_SLASH] = ACTIONS(7417),
    [anon_sym_STAR_STAR] = ACTIONS(7417),
    [anon_sym_CARET] = ACTIONS(7417),
    [aux_sym_binary_operator_token1] = ACTIONS(7417),
    [anon_sym_PIPE_GT] = ACTIONS(7417),
    [anon_sym_COLON] = ACTIONS(7419),
    [anon_sym_DOLLAR] = ACTIONS(7417),
    [anon_sym_AT] = ACTIONS(7417),
    [aux_sym__hex_literal_token1] = ACTIONS(7417),
    [sym__number_literal] = ACTIONS(7419),
    [anon_sym_SQUOTE] = ACTIONS(7417),
    [anon_sym_DQUOTE] = ACTIONS(7417),
    [sym_return] = ACTIONS(7419),
    [sym_next] = ACTIONS(7419),
    [sym_break] = ACTIONS(7419),
    [sym_true] = ACTIONS(7419),
    [sym_false] = ACTIONS(7419),
    [sym_null] = ACTIONS(7419),
    [sym_inf] = ACTIONS(7419),
    [sym_nan] = ACTIONS(7419),
    [anon_sym_NA] = ACTIONS(7419),
    [anon_sym_NA_integer_] = ACTIONS(7419),
    [anon_sym_NA_real_] = ACTIONS(7419),
    [anon_sym_NA_complex_] = ACTIONS(7419),
    [anon_sym_NA_character_] = ACTIONS(7419),
    [sym_dots] = ACTIONS(7419),
    [sym_dot_dot_i] = ACTIONS(7417),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7417),
    [sym__newline] = ACTIONS(7424),
    [sym__semicolon] = ACTIONS(7417),
    [sym__raw_string_literal] = ACTIONS(7417),
    [sym__external_else] = ACTIONS(7417),
    [sym__external_open_parenthesis] = ACTIONS(7417),
    [sym__external_close_parenthesis] = ACTIONS(7417),
    [sym__external_open_brace] = ACTIONS(7417),
    [sym__external_close_brace] = ACTIONS(7417),
    [sym__external_open_bracket] = ACTIONS(7417),
    [sym__external_open_bracket2] = ACTIONS(7417),
    [sym__external_close_bracket2] = ACTIONS(7417),
  },
  [2197] = {
    [sym_string] = STATE(2899),
    [sym__single_quoted_string] = STATE(2456),
    [sym__double_quoted_string] = STATE(2478),
    [sym__string_or_identifier] = STATE(2899),
    [sym_identifier] = ACTIONS(7427),
    [anon_sym_BSLASH] = ACTIONS(5883),
    [anon_sym_function] = ACTIONS(5887),
    [anon_sym_EQ] = ACTIONS(5887),
    [anon_sym_if] = ACTIONS(5887),
    [anon_sym_for] = ACTIONS(5887),
    [anon_sym_while] = ACTIONS(5887),
    [anon_sym_repeat] = ACTIONS(5887),
    [anon_sym_QMARK] = ACTIONS(5883),
    [anon_sym_TILDE] = ACTIONS(5883),
    [anon_sym_BANG] = ACTIONS(5887),
    [anon_sym_PLUS] = ACTIONS(5883),
    [anon_sym_DASH] = ACTIONS(5887),
    [anon_sym_LT_DASH] = ACTIONS(5883),
    [anon_sym_LT_LT_DASH] = ACTIONS(5883),
    [anon_sym_COLON_EQ] = ACTIONS(5883),
    [anon_sym_DASH_GT] = ACTIONS(5887),
    [anon_sym_DASH_GT_GT] = ACTIONS(5883),
    [anon_sym_PIPE] = ACTIONS(5887),
    [anon_sym_AMP] = ACTIONS(5887),
    [anon_sym_PIPE_PIPE] = ACTIONS(5883),
    [anon_sym_AMP_AMP] = ACTIONS(5883),
    [anon_sym_LT] = ACTIONS(5887),
    [anon_sym_LT_EQ] = ACTIONS(5883),
    [anon_sym_GT] = ACTIONS(5887),
    [anon_sym_GT_EQ] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5883),
    [anon_sym_BANG_EQ] = ACTIONS(5883),
    [anon_sym_STAR] = ACTIONS(5887),
    [anon_sym_SLASH] = ACTIONS(5883),
    [anon_sym_STAR_STAR] = ACTIONS(5883),
    [anon_sym_CARET] = ACTIONS(5883),
    [aux_sym_binary_operator_token1] = ACTIONS(5883),
    [anon_sym_PIPE_GT] = ACTIONS(5883),
    [anon_sym_COLON] = ACTIONS(5887),
    [anon_sym_DOLLAR] = ACTIONS(5883),
    [anon_sym_AT] = ACTIONS(5883),
    [aux_sym__hex_literal_token1] = ACTIONS(5883),
    [sym__number_literal] = ACTIONS(5887),
    [anon_sym_SQUOTE] = ACTIONS(3519),
    [anon_sym_DQUOTE] = ACTIONS(3521),
    [sym_return] = ACTIONS(5887),
    [sym_next] = ACTIONS(5887),
    [sym_break] = ACTIONS(5887),
    [sym_true] = ACTIONS(5887),
    [sym_false] = ACTIONS(5887),
    [sym_null] = ACTIONS(5887),
    [sym_inf] = ACTIONS(5887),
    [sym_nan] = ACTIONS(5887),
    [anon_sym_NA] = ACTIONS(5887),
    [anon_sym_NA_integer_] = ACTIONS(5887),
    [anon_sym_NA_real_] = ACTIONS(5887),
    [anon_sym_NA_complex_] = ACTIONS(5887),
    [anon_sym_NA_character_] = ACTIONS(5887),
    [sym_dots] = ACTIONS(5887),
    [sym_dot_dot_i] = ACTIONS(5883),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5883),
    [sym__newline] = ACTIONS(5883),
    [sym__raw_string_literal] = ACTIONS(3531),
    [sym__external_else] = ACTIONS(5883),
    [sym__external_open_parenthesis] = ACTIONS(5883),
    [sym__external_open_brace] = ACTIONS(5883),
    [sym__external_open_bracket] = ACTIONS(5883),
    [sym__external_close_bracket] = ACTIONS(5883),
    [sym__external_open_bracket2] = ACTIONS(5883),
  },
  [2198] = {
    [sym_identifier] = ACTIONS(7151),
    [anon_sym_BSLASH] = ACTIONS(7153),
    [anon_sym_function] = ACTIONS(7151),
    [anon_sym_EQ] = ACTIONS(7151),
    [anon_sym_if] = ACTIONS(7151),
    [anon_sym_for] = ACTIONS(7151),
    [anon_sym_while] = ACTIONS(7151),
    [anon_sym_repeat] = ACTIONS(7151),
    [anon_sym_QMARK] = ACTIONS(7153),
    [anon_sym_TILDE] = ACTIONS(7153),
    [anon_sym_BANG] = ACTIONS(7151),
    [anon_sym_PLUS] = ACTIONS(7153),
    [anon_sym_DASH] = ACTIONS(7151),
    [anon_sym_LT_DASH] = ACTIONS(7153),
    [anon_sym_LT_LT_DASH] = ACTIONS(7153),
    [anon_sym_COLON_EQ] = ACTIONS(7153),
    [anon_sym_DASH_GT] = ACTIONS(7151),
    [anon_sym_DASH_GT_GT] = ACTIONS(7153),
    [anon_sym_PIPE] = ACTIONS(7151),
    [anon_sym_AMP] = ACTIONS(7151),
    [anon_sym_PIPE_PIPE] = ACTIONS(7153),
    [anon_sym_AMP_AMP] = ACTIONS(7153),
    [anon_sym_LT] = ACTIONS(7151),
    [anon_sym_LT_EQ] = ACTIONS(7153),
    [anon_sym_GT] = ACTIONS(7151),
    [anon_sym_GT_EQ] = ACTIONS(7153),
    [anon_sym_EQ_EQ] = ACTIONS(7153),
    [anon_sym_BANG_EQ] = ACTIONS(7153),
    [anon_sym_STAR] = ACTIONS(7151),
    [anon_sym_SLASH] = ACTIONS(7153),
    [anon_sym_STAR_STAR] = ACTIONS(7153),
    [anon_sym_CARET] = ACTIONS(7153),
    [aux_sym_binary_operator_token1] = ACTIONS(7153),
    [anon_sym_PIPE_GT] = ACTIONS(7153),
    [anon_sym_COLON] = ACTIONS(7151),
    [anon_sym_DOLLAR] = ACTIONS(7153),
    [anon_sym_AT] = ACTIONS(7153),
    [anon_sym_COLON_COLON] = ACTIONS(7151),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7153),
    [aux_sym__hex_literal_token1] = ACTIONS(7153),
    [sym__number_literal] = ACTIONS(7151),
    [anon_sym_SQUOTE] = ACTIONS(7153),
    [anon_sym_DQUOTE] = ACTIONS(7153),
    [sym_return] = ACTIONS(7151),
    [sym_next] = ACTIONS(7151),
    [sym_break] = ACTIONS(7151),
    [sym_true] = ACTIONS(7151),
    [sym_false] = ACTIONS(7151),
    [sym_null] = ACTIONS(7151),
    [sym_inf] = ACTIONS(7151),
    [sym_nan] = ACTIONS(7151),
    [anon_sym_NA] = ACTIONS(7151),
    [anon_sym_NA_integer_] = ACTIONS(7151),
    [anon_sym_NA_real_] = ACTIONS(7151),
    [anon_sym_NA_complex_] = ACTIONS(7151),
    [anon_sym_NA_character_] = ACTIONS(7151),
    [sym_dots] = ACTIONS(7151),
    [sym_dot_dot_i] = ACTIONS(7153),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7153),
    [sym__newline] = ACTIONS(7153),
    [sym__semicolon] = ACTIONS(7153),
    [sym__raw_string_literal] = ACTIONS(7153),
    [sym__external_else] = ACTIONS(7153),
    [sym__external_open_parenthesis] = ACTIONS(7153),
    [sym__external_open_brace] = ACTIONS(7153),
    [sym__external_close_brace] = ACTIONS(7153),
    [sym__external_open_bracket] = ACTIONS(7153),
    [sym__external_close_bracket] = ACTIONS(7153),
    [sym__external_open_bracket2] = ACTIONS(7153),
  },
  [2199] = {
    [aux_sym_function_definition_repeat1] = STATE(2199),
    [sym_identifier] = ACTIONS(7419),
    [anon_sym_BSLASH] = ACTIONS(7417),
    [anon_sym_function] = ACTIONS(7419),
    [anon_sym_EQ] = ACTIONS(7419),
    [anon_sym_if] = ACTIONS(7419),
    [anon_sym_for] = ACTIONS(7419),
    [anon_sym_while] = ACTIONS(7419),
    [anon_sym_repeat] = ACTIONS(7419),
    [anon_sym_QMARK] = ACTIONS(7417),
    [anon_sym_TILDE] = ACTIONS(7417),
    [anon_sym_BANG] = ACTIONS(7419),
    [anon_sym_PLUS] = ACTIONS(7417),
    [anon_sym_DASH] = ACTIONS(7419),
    [anon_sym_LT_DASH] = ACTIONS(7417),
    [anon_sym_LT_LT_DASH] = ACTIONS(7417),
    [anon_sym_COLON_EQ] = ACTIONS(7417),
    [anon_sym_DASH_GT] = ACTIONS(7419),
    [anon_sym_DASH_GT_GT] = ACTIONS(7417),
    [anon_sym_PIPE] = ACTIONS(7419),
    [anon_sym_AMP] = ACTIONS(7419),
    [anon_sym_PIPE_PIPE] = ACTIONS(7417),
    [anon_sym_AMP_AMP] = ACTIONS(7417),
    [anon_sym_LT] = ACTIONS(7419),
    [anon_sym_LT_EQ] = ACTIONS(7417),
    [anon_sym_GT] = ACTIONS(7419),
    [anon_sym_GT_EQ] = ACTIONS(7417),
    [anon_sym_EQ_EQ] = ACTIONS(7417),
    [anon_sym_BANG_EQ] = ACTIONS(7417),
    [anon_sym_STAR] = ACTIONS(7419),
    [anon_sym_SLASH] = ACTIONS(7417),
    [anon_sym_STAR_STAR] = ACTIONS(7417),
    [anon_sym_CARET] = ACTIONS(7417),
    [aux_sym_binary_operator_token1] = ACTIONS(7417),
    [anon_sym_PIPE_GT] = ACTIONS(7417),
    [anon_sym_COLON] = ACTIONS(7419),
    [anon_sym_DOLLAR] = ACTIONS(7417),
    [anon_sym_AT] = ACTIONS(7417),
    [aux_sym__hex_literal_token1] = ACTIONS(7417),
    [sym__number_literal] = ACTIONS(7419),
    [anon_sym_SQUOTE] = ACTIONS(7417),
    [anon_sym_DQUOTE] = ACTIONS(7417),
    [sym_return] = ACTIONS(7419),
    [sym_next] = ACTIONS(7419),
    [sym_break] = ACTIONS(7419),
    [sym_true] = ACTIONS(7419),
    [sym_false] = ACTIONS(7419),
    [sym_null] = ACTIONS(7419),
    [sym_inf] = ACTIONS(7419),
    [sym_nan] = ACTIONS(7419),
    [anon_sym_NA] = ACTIONS(7419),
    [anon_sym_NA_integer_] = ACTIONS(7419),
    [anon_sym_NA_real_] = ACTIONS(7419),
    [anon_sym_NA_complex_] = ACTIONS(7419),
    [anon_sym_NA_character_] = ACTIONS(7419),
    [sym_dots] = ACTIONS(7419),
    [sym_dot_dot_i] = ACTIONS(7417),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7417),
    [sym__newline] = ACTIONS(7429),
    [sym__semicolon] = ACTIONS(7417),
    [sym__raw_string_literal] = ACTIONS(7417),
    [sym__external_else] = ACTIONS(7417),
    [sym__external_open_parenthesis] = ACTIONS(7417),
    [sym__external_close_parenthesis] = ACTIONS(7417),
    [sym__external_open_brace] = ACTIONS(7417),
    [sym__external_close_brace] = ACTIONS(7417),
    [sym__external_open_bracket] = ACTIONS(7417),
    [sym__external_close_bracket] = ACTIONS(7417),
    [sym__external_open_bracket2] = ACTIONS(7417),
  },
  [2200] = {
    [sym_identifier] = ACTIONS(7115),
    [anon_sym_BSLASH] = ACTIONS(7117),
    [anon_sym_function] = ACTIONS(7115),
    [anon_sym_EQ] = ACTIONS(7115),
    [anon_sym_if] = ACTIONS(7115),
    [anon_sym_for] = ACTIONS(7115),
    [anon_sym_while] = ACTIONS(7115),
    [anon_sym_repeat] = ACTIONS(7115),
    [anon_sym_QMARK] = ACTIONS(7117),
    [anon_sym_TILDE] = ACTIONS(7117),
    [anon_sym_BANG] = ACTIONS(7115),
    [anon_sym_PLUS] = ACTIONS(7117),
    [anon_sym_DASH] = ACTIONS(7115),
    [anon_sym_LT_DASH] = ACTIONS(7117),
    [anon_sym_LT_LT_DASH] = ACTIONS(7117),
    [anon_sym_COLON_EQ] = ACTIONS(7117),
    [anon_sym_DASH_GT] = ACTIONS(7115),
    [anon_sym_DASH_GT_GT] = ACTIONS(7117),
    [anon_sym_PIPE] = ACTIONS(7115),
    [anon_sym_AMP] = ACTIONS(7115),
    [anon_sym_PIPE_PIPE] = ACTIONS(7117),
    [anon_sym_AMP_AMP] = ACTIONS(7117),
    [anon_sym_LT] = ACTIONS(7115),
    [anon_sym_LT_EQ] = ACTIONS(7117),
    [anon_sym_GT] = ACTIONS(7115),
    [anon_sym_GT_EQ] = ACTIONS(7117),
    [anon_sym_EQ_EQ] = ACTIONS(7117),
    [anon_sym_BANG_EQ] = ACTIONS(7117),
    [anon_sym_STAR] = ACTIONS(7115),
    [anon_sym_SLASH] = ACTIONS(7117),
    [anon_sym_STAR_STAR] = ACTIONS(7117),
    [anon_sym_CARET] = ACTIONS(7117),
    [aux_sym_binary_operator_token1] = ACTIONS(7117),
    [anon_sym_PIPE_GT] = ACTIONS(7117),
    [anon_sym_COLON] = ACTIONS(7115),
    [anon_sym_DOLLAR] = ACTIONS(7117),
    [anon_sym_AT] = ACTIONS(7117),
    [anon_sym_COLON_COLON] = ACTIONS(7115),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7117),
    [aux_sym__hex_literal_token1] = ACTIONS(7117),
    [sym__number_literal] = ACTIONS(7115),
    [anon_sym_SQUOTE] = ACTIONS(7117),
    [anon_sym_DQUOTE] = ACTIONS(7117),
    [sym_return] = ACTIONS(7115),
    [sym_next] = ACTIONS(7115),
    [sym_break] = ACTIONS(7115),
    [sym_true] = ACTIONS(7115),
    [sym_false] = ACTIONS(7115),
    [sym_null] = ACTIONS(7115),
    [sym_inf] = ACTIONS(7115),
    [sym_nan] = ACTIONS(7115),
    [anon_sym_NA] = ACTIONS(7115),
    [anon_sym_NA_integer_] = ACTIONS(7115),
    [anon_sym_NA_real_] = ACTIONS(7115),
    [anon_sym_NA_complex_] = ACTIONS(7115),
    [anon_sym_NA_character_] = ACTIONS(7115),
    [sym_dots] = ACTIONS(7115),
    [sym_dot_dot_i] = ACTIONS(7117),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7117),
    [sym__newline] = ACTIONS(7117),
    [sym__semicolon] = ACTIONS(7117),
    [sym__raw_string_literal] = ACTIONS(7117),
    [sym__external_else] = ACTIONS(7117),
    [sym__external_open_parenthesis] = ACTIONS(7117),
    [sym__external_open_brace] = ACTIONS(7117),
    [sym__external_close_brace] = ACTIONS(7117),
    [sym__external_open_bracket] = ACTIONS(7117),
    [sym__external_close_bracket] = ACTIONS(7117),
    [sym__external_open_bracket2] = ACTIONS(7117),
  },
  [2201] = {
    [sym_identifier] = ACTIONS(7115),
    [anon_sym_BSLASH] = ACTIONS(7117),
    [anon_sym_function] = ACTIONS(7115),
    [anon_sym_EQ] = ACTIONS(7115),
    [anon_sym_if] = ACTIONS(7115),
    [anon_sym_for] = ACTIONS(7115),
    [anon_sym_while] = ACTIONS(7115),
    [anon_sym_repeat] = ACTIONS(7115),
    [anon_sym_QMARK] = ACTIONS(7117),
    [anon_sym_TILDE] = ACTIONS(7117),
    [anon_sym_BANG] = ACTIONS(7115),
    [anon_sym_PLUS] = ACTIONS(7117),
    [anon_sym_DASH] = ACTIONS(7115),
    [anon_sym_LT_DASH] = ACTIONS(7117),
    [anon_sym_LT_LT_DASH] = ACTIONS(7117),
    [anon_sym_COLON_EQ] = ACTIONS(7117),
    [anon_sym_DASH_GT] = ACTIONS(7115),
    [anon_sym_DASH_GT_GT] = ACTIONS(7117),
    [anon_sym_PIPE] = ACTIONS(7115),
    [anon_sym_AMP] = ACTIONS(7115),
    [anon_sym_PIPE_PIPE] = ACTIONS(7117),
    [anon_sym_AMP_AMP] = ACTIONS(7117),
    [anon_sym_LT] = ACTIONS(7115),
    [anon_sym_LT_EQ] = ACTIONS(7117),
    [anon_sym_GT] = ACTIONS(7115),
    [anon_sym_GT_EQ] = ACTIONS(7117),
    [anon_sym_EQ_EQ] = ACTIONS(7117),
    [anon_sym_BANG_EQ] = ACTIONS(7117),
    [anon_sym_STAR] = ACTIONS(7115),
    [anon_sym_SLASH] = ACTIONS(7117),
    [anon_sym_STAR_STAR] = ACTIONS(7117),
    [anon_sym_CARET] = ACTIONS(7117),
    [aux_sym_binary_operator_token1] = ACTIONS(7117),
    [anon_sym_PIPE_GT] = ACTIONS(7117),
    [anon_sym_COLON] = ACTIONS(7115),
    [anon_sym_DOLLAR] = ACTIONS(7117),
    [anon_sym_AT] = ACTIONS(7117),
    [anon_sym_COLON_COLON] = ACTIONS(7115),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7117),
    [aux_sym__hex_literal_token1] = ACTIONS(7117),
    [sym__number_literal] = ACTIONS(7115),
    [anon_sym_SQUOTE] = ACTIONS(7117),
    [anon_sym_DQUOTE] = ACTIONS(7117),
    [sym_return] = ACTIONS(7115),
    [sym_next] = ACTIONS(7115),
    [sym_break] = ACTIONS(7115),
    [sym_true] = ACTIONS(7115),
    [sym_false] = ACTIONS(7115),
    [sym_null] = ACTIONS(7115),
    [sym_inf] = ACTIONS(7115),
    [sym_nan] = ACTIONS(7115),
    [anon_sym_NA] = ACTIONS(7115),
    [anon_sym_NA_integer_] = ACTIONS(7115),
    [anon_sym_NA_real_] = ACTIONS(7115),
    [anon_sym_NA_complex_] = ACTIONS(7115),
    [anon_sym_NA_character_] = ACTIONS(7115),
    [sym_dots] = ACTIONS(7115),
    [sym_dot_dot_i] = ACTIONS(7117),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7117),
    [sym__newline] = ACTIONS(7117),
    [sym__semicolon] = ACTIONS(7117),
    [sym__raw_string_literal] = ACTIONS(7117),
    [sym__external_else] = ACTIONS(7117),
    [sym__external_open_parenthesis] = ACTIONS(7117),
    [sym__external_open_brace] = ACTIONS(7117),
    [sym__external_close_brace] = ACTIONS(7117),
    [sym__external_open_bracket] = ACTIONS(7117),
    [sym__external_close_bracket] = ACTIONS(7117),
    [sym__external_open_bracket2] = ACTIONS(7117),
  },
  [2202] = {
    [sym_string] = STATE(2749),
    [sym__single_quoted_string] = STATE(2430),
    [sym__double_quoted_string] = STATE(2466),
    [sym__string_or_identifier] = STATE(2749),
    [sym_identifier] = ACTIONS(7432),
    [anon_sym_BSLASH] = ACTIONS(5883),
    [anon_sym_function] = ACTIONS(5887),
    [anon_sym_EQ] = ACTIONS(5887),
    [anon_sym_if] = ACTIONS(5887),
    [anon_sym_for] = ACTIONS(5887),
    [anon_sym_while] = ACTIONS(5887),
    [anon_sym_repeat] = ACTIONS(5887),
    [anon_sym_QMARK] = ACTIONS(5883),
    [anon_sym_TILDE] = ACTIONS(5883),
    [anon_sym_BANG] = ACTIONS(5887),
    [anon_sym_PLUS] = ACTIONS(5883),
    [anon_sym_DASH] = ACTIONS(5887),
    [anon_sym_LT_DASH] = ACTIONS(5883),
    [anon_sym_LT_LT_DASH] = ACTIONS(5883),
    [anon_sym_COLON_EQ] = ACTIONS(5883),
    [anon_sym_DASH_GT] = ACTIONS(5887),
    [anon_sym_DASH_GT_GT] = ACTIONS(5883),
    [anon_sym_PIPE] = ACTIONS(5887),
    [anon_sym_AMP] = ACTIONS(5887),
    [anon_sym_PIPE_PIPE] = ACTIONS(5883),
    [anon_sym_AMP_AMP] = ACTIONS(5883),
    [anon_sym_LT] = ACTIONS(5887),
    [anon_sym_LT_EQ] = ACTIONS(5883),
    [anon_sym_GT] = ACTIONS(5887),
    [anon_sym_GT_EQ] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5883),
    [anon_sym_BANG_EQ] = ACTIONS(5883),
    [anon_sym_STAR] = ACTIONS(5887),
    [anon_sym_SLASH] = ACTIONS(5883),
    [anon_sym_STAR_STAR] = ACTIONS(5883),
    [anon_sym_CARET] = ACTIONS(5883),
    [aux_sym_binary_operator_token1] = ACTIONS(5883),
    [anon_sym_PIPE_GT] = ACTIONS(5883),
    [anon_sym_COLON] = ACTIONS(5887),
    [anon_sym_DOLLAR] = ACTIONS(5883),
    [anon_sym_AT] = ACTIONS(5883),
    [aux_sym__hex_literal_token1] = ACTIONS(5883),
    [sym__number_literal] = ACTIONS(5887),
    [anon_sym_SQUOTE] = ACTIONS(2511),
    [anon_sym_DQUOTE] = ACTIONS(2513),
    [sym_return] = ACTIONS(5887),
    [sym_next] = ACTIONS(5887),
    [sym_break] = ACTIONS(5887),
    [sym_true] = ACTIONS(5887),
    [sym_false] = ACTIONS(5887),
    [sym_null] = ACTIONS(5887),
    [sym_inf] = ACTIONS(5887),
    [sym_nan] = ACTIONS(5887),
    [anon_sym_NA] = ACTIONS(5887),
    [anon_sym_NA_integer_] = ACTIONS(5887),
    [anon_sym_NA_real_] = ACTIONS(5887),
    [anon_sym_NA_complex_] = ACTIONS(5887),
    [anon_sym_NA_character_] = ACTIONS(5887),
    [sym_dots] = ACTIONS(5887),
    [sym_dot_dot_i] = ACTIONS(5883),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5883),
    [sym__newline] = ACTIONS(5883),
    [sym__raw_string_literal] = ACTIONS(2523),
    [sym__external_open_parenthesis] = ACTIONS(5883),
    [sym__external_close_parenthesis] = ACTIONS(5883),
    [sym__external_open_brace] = ACTIONS(5883),
    [sym__external_open_bracket] = ACTIONS(5883),
    [sym__external_open_bracket2] = ACTIONS(5883),
    [sym__external_close_bracket2] = ACTIONS(5883),
  },
  [2203] = {
    [sym_string] = STATE(2770),
    [sym__single_quoted_string] = STATE(2370),
    [sym__double_quoted_string] = STATE(2369),
    [sym__string_or_identifier] = STATE(2770),
    [sym_identifier] = ACTIONS(7434),
    [anon_sym_BSLASH] = ACTIONS(5883),
    [anon_sym_function] = ACTIONS(5887),
    [anon_sym_EQ] = ACTIONS(5887),
    [anon_sym_if] = ACTIONS(5887),
    [anon_sym_for] = ACTIONS(5887),
    [anon_sym_while] = ACTIONS(5887),
    [anon_sym_repeat] = ACTIONS(5887),
    [anon_sym_QMARK] = ACTIONS(5883),
    [anon_sym_TILDE] = ACTIONS(5883),
    [anon_sym_BANG] = ACTIONS(5887),
    [anon_sym_PLUS] = ACTIONS(5883),
    [anon_sym_DASH] = ACTIONS(5887),
    [anon_sym_LT_DASH] = ACTIONS(5883),
    [anon_sym_LT_LT_DASH] = ACTIONS(5883),
    [anon_sym_COLON_EQ] = ACTIONS(5883),
    [anon_sym_DASH_GT] = ACTIONS(5887),
    [anon_sym_DASH_GT_GT] = ACTIONS(5883),
    [anon_sym_PIPE] = ACTIONS(5887),
    [anon_sym_AMP] = ACTIONS(5887),
    [anon_sym_PIPE_PIPE] = ACTIONS(5883),
    [anon_sym_AMP_AMP] = ACTIONS(5883),
    [anon_sym_LT] = ACTIONS(5887),
    [anon_sym_LT_EQ] = ACTIONS(5883),
    [anon_sym_GT] = ACTIONS(5887),
    [anon_sym_GT_EQ] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5883),
    [anon_sym_BANG_EQ] = ACTIONS(5883),
    [anon_sym_STAR] = ACTIONS(5887),
    [anon_sym_SLASH] = ACTIONS(5883),
    [anon_sym_STAR_STAR] = ACTIONS(5883),
    [anon_sym_CARET] = ACTIONS(5883),
    [aux_sym_binary_operator_token1] = ACTIONS(5883),
    [anon_sym_PIPE_GT] = ACTIONS(5883),
    [anon_sym_COLON] = ACTIONS(5887),
    [anon_sym_DOLLAR] = ACTIONS(5883),
    [anon_sym_AT] = ACTIONS(5883),
    [aux_sym__hex_literal_token1] = ACTIONS(5883),
    [sym__number_literal] = ACTIONS(5887),
    [anon_sym_SQUOTE] = ACTIONS(2453),
    [anon_sym_DQUOTE] = ACTIONS(2455),
    [sym_return] = ACTIONS(5887),
    [sym_next] = ACTIONS(5887),
    [sym_break] = ACTIONS(5887),
    [sym_true] = ACTIONS(5887),
    [sym_false] = ACTIONS(5887),
    [sym_null] = ACTIONS(5887),
    [sym_inf] = ACTIONS(5887),
    [sym_nan] = ACTIONS(5887),
    [anon_sym_NA] = ACTIONS(5887),
    [anon_sym_NA_integer_] = ACTIONS(5887),
    [anon_sym_NA_real_] = ACTIONS(5887),
    [anon_sym_NA_complex_] = ACTIONS(5887),
    [anon_sym_NA_character_] = ACTIONS(5887),
    [sym_dots] = ACTIONS(5887),
    [sym_dot_dot_i] = ACTIONS(5883),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5883),
    [sym__newline] = ACTIONS(5883),
    [sym__raw_string_literal] = ACTIONS(2465),
    [sym__external_else] = ACTIONS(5883),
    [sym__external_open_parenthesis] = ACTIONS(5883),
    [sym__external_close_parenthesis] = ACTIONS(5883),
    [sym__external_open_brace] = ACTIONS(5883),
    [sym__external_open_bracket] = ACTIONS(5883),
    [sym__external_open_bracket2] = ACTIONS(5883),
  },
  [2204] = {
    [sym_identifier] = ACTIONS(7163),
    [anon_sym_BSLASH] = ACTIONS(7165),
    [anon_sym_function] = ACTIONS(7163),
    [anon_sym_EQ] = ACTIONS(7163),
    [anon_sym_if] = ACTIONS(7163),
    [anon_sym_for] = ACTIONS(7163),
    [anon_sym_while] = ACTIONS(7163),
    [anon_sym_repeat] = ACTIONS(7163),
    [anon_sym_QMARK] = ACTIONS(7165),
    [anon_sym_TILDE] = ACTIONS(7165),
    [anon_sym_BANG] = ACTIONS(7163),
    [anon_sym_PLUS] = ACTIONS(7165),
    [anon_sym_DASH] = ACTIONS(7163),
    [anon_sym_LT_DASH] = ACTIONS(7165),
    [anon_sym_LT_LT_DASH] = ACTIONS(7165),
    [anon_sym_COLON_EQ] = ACTIONS(7165),
    [anon_sym_DASH_GT] = ACTIONS(7163),
    [anon_sym_DASH_GT_GT] = ACTIONS(7165),
    [anon_sym_PIPE] = ACTIONS(7163),
    [anon_sym_AMP] = ACTIONS(7163),
    [anon_sym_PIPE_PIPE] = ACTIONS(7165),
    [anon_sym_AMP_AMP] = ACTIONS(7165),
    [anon_sym_LT] = ACTIONS(7163),
    [anon_sym_LT_EQ] = ACTIONS(7165),
    [anon_sym_GT] = ACTIONS(7163),
    [anon_sym_GT_EQ] = ACTIONS(7165),
    [anon_sym_EQ_EQ] = ACTIONS(7165),
    [anon_sym_BANG_EQ] = ACTIONS(7165),
    [anon_sym_STAR] = ACTIONS(7163),
    [anon_sym_SLASH] = ACTIONS(7165),
    [anon_sym_STAR_STAR] = ACTIONS(7165),
    [anon_sym_CARET] = ACTIONS(7165),
    [aux_sym_binary_operator_token1] = ACTIONS(7165),
    [anon_sym_PIPE_GT] = ACTIONS(7165),
    [anon_sym_COLON] = ACTIONS(7163),
    [anon_sym_DOLLAR] = ACTIONS(7165),
    [anon_sym_AT] = ACTIONS(7165),
    [anon_sym_COLON_COLON] = ACTIONS(7163),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7165),
    [aux_sym__hex_literal_token1] = ACTIONS(7165),
    [sym__number_literal] = ACTIONS(7163),
    [anon_sym_SQUOTE] = ACTIONS(7165),
    [anon_sym_DQUOTE] = ACTIONS(7165),
    [sym_return] = ACTIONS(7163),
    [sym_next] = ACTIONS(7163),
    [sym_break] = ACTIONS(7163),
    [sym_true] = ACTIONS(7163),
    [sym_false] = ACTIONS(7163),
    [sym_null] = ACTIONS(7163),
    [sym_inf] = ACTIONS(7163),
    [sym_nan] = ACTIONS(7163),
    [anon_sym_NA] = ACTIONS(7163),
    [anon_sym_NA_integer_] = ACTIONS(7163),
    [anon_sym_NA_real_] = ACTIONS(7163),
    [anon_sym_NA_complex_] = ACTIONS(7163),
    [anon_sym_NA_character_] = ACTIONS(7163),
    [sym_dots] = ACTIONS(7163),
    [sym_dot_dot_i] = ACTIONS(7165),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7165),
    [sym__newline] = ACTIONS(7165),
    [sym__semicolon] = ACTIONS(7165),
    [sym__raw_string_literal] = ACTIONS(7165),
    [sym__external_open_parenthesis] = ACTIONS(7165),
    [sym__external_close_parenthesis] = ACTIONS(7165),
    [sym__external_open_brace] = ACTIONS(7165),
    [sym__external_close_brace] = ACTIONS(7165),
    [sym__external_open_bracket] = ACTIONS(7165),
    [sym__external_open_bracket2] = ACTIONS(7165),
    [sym__external_close_bracket2] = ACTIONS(7165),
  },
  [2205] = {
    [sym_string] = STATE(2759),
    [sym__single_quoted_string] = STATE(2528),
    [sym__double_quoted_string] = STATE(2529),
    [sym__string_or_identifier] = STATE(2759),
    [ts_builtin_sym_end] = ACTIONS(5883),
    [sym_identifier] = ACTIONS(7436),
    [anon_sym_BSLASH] = ACTIONS(5883),
    [anon_sym_function] = ACTIONS(5887),
    [anon_sym_EQ] = ACTIONS(5887),
    [anon_sym_if] = ACTIONS(5887),
    [anon_sym_for] = ACTIONS(5887),
    [anon_sym_while] = ACTIONS(5887),
    [anon_sym_repeat] = ACTIONS(5887),
    [anon_sym_QMARK] = ACTIONS(5883),
    [anon_sym_TILDE] = ACTIONS(5883),
    [anon_sym_BANG] = ACTIONS(5887),
    [anon_sym_PLUS] = ACTIONS(5883),
    [anon_sym_DASH] = ACTIONS(5887),
    [anon_sym_LT_DASH] = ACTIONS(5883),
    [anon_sym_LT_LT_DASH] = ACTIONS(5883),
    [anon_sym_COLON_EQ] = ACTIONS(5883),
    [anon_sym_DASH_GT] = ACTIONS(5887),
    [anon_sym_DASH_GT_GT] = ACTIONS(5883),
    [anon_sym_PIPE] = ACTIONS(5887),
    [anon_sym_AMP] = ACTIONS(5887),
    [anon_sym_PIPE_PIPE] = ACTIONS(5883),
    [anon_sym_AMP_AMP] = ACTIONS(5883),
    [anon_sym_LT] = ACTIONS(5887),
    [anon_sym_LT_EQ] = ACTIONS(5883),
    [anon_sym_GT] = ACTIONS(5887),
    [anon_sym_GT_EQ] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5883),
    [anon_sym_BANG_EQ] = ACTIONS(5883),
    [anon_sym_STAR] = ACTIONS(5887),
    [anon_sym_SLASH] = ACTIONS(5883),
    [anon_sym_STAR_STAR] = ACTIONS(5883),
    [anon_sym_CARET] = ACTIONS(5883),
    [aux_sym_binary_operator_token1] = ACTIONS(5883),
    [anon_sym_PIPE_GT] = ACTIONS(5883),
    [anon_sym_COLON] = ACTIONS(5887),
    [anon_sym_DOLLAR] = ACTIONS(5883),
    [anon_sym_AT] = ACTIONS(5883),
    [aux_sym__hex_literal_token1] = ACTIONS(5883),
    [sym__number_literal] = ACTIONS(5887),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE] = ACTIONS(2856),
    [sym_return] = ACTIONS(5887),
    [sym_next] = ACTIONS(5887),
    [sym_break] = ACTIONS(5887),
    [sym_true] = ACTIONS(5887),
    [sym_false] = ACTIONS(5887),
    [sym_null] = ACTIONS(5887),
    [sym_inf] = ACTIONS(5887),
    [sym_nan] = ACTIONS(5887),
    [anon_sym_NA] = ACTIONS(5887),
    [anon_sym_NA_integer_] = ACTIONS(5887),
    [anon_sym_NA_real_] = ACTIONS(5887),
    [anon_sym_NA_complex_] = ACTIONS(5887),
    [anon_sym_NA_character_] = ACTIONS(5887),
    [sym_dots] = ACTIONS(5887),
    [sym_dot_dot_i] = ACTIONS(5883),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5883),
    [sym__semicolon] = ACTIONS(5883),
    [sym__raw_string_literal] = ACTIONS(2866),
    [sym__external_open_parenthesis] = ACTIONS(5883),
    [sym__external_open_brace] = ACTIONS(5883),
    [sym__external_close_brace] = ACTIONS(5883),
    [sym__external_open_bracket] = ACTIONS(5883),
    [sym__external_open_bracket2] = ACTIONS(5883),
  },
  [2206] = {
    [sym_identifier] = ACTIONS(7121),
    [anon_sym_BSLASH] = ACTIONS(7123),
    [anon_sym_function] = ACTIONS(7121),
    [anon_sym_EQ] = ACTIONS(7121),
    [anon_sym_if] = ACTIONS(7121),
    [anon_sym_for] = ACTIONS(7121),
    [anon_sym_while] = ACTIONS(7121),
    [anon_sym_repeat] = ACTIONS(7121),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_TILDE] = ACTIONS(7123),
    [anon_sym_BANG] = ACTIONS(7121),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_DASH] = ACTIONS(7121),
    [anon_sym_LT_DASH] = ACTIONS(7123),
    [anon_sym_LT_LT_DASH] = ACTIONS(7123),
    [anon_sym_COLON_EQ] = ACTIONS(7123),
    [anon_sym_DASH_GT] = ACTIONS(7121),
    [anon_sym_DASH_GT_GT] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_LT_EQ] = ACTIONS(7123),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
    [aux_sym_binary_operator_token1] = ACTIONS(7123),
    [anon_sym_PIPE_GT] = ACTIONS(7123),
    [anon_sym_COLON] = ACTIONS(7121),
    [anon_sym_DOLLAR] = ACTIONS(7123),
    [anon_sym_AT] = ACTIONS(7123),
    [anon_sym_L] = ACTIONS(7438),
    [anon_sym_i] = ACTIONS(7440),
    [aux_sym__hex_literal_token1] = ACTIONS(7123),
    [sym__number_literal] = ACTIONS(7121),
    [anon_sym_SQUOTE] = ACTIONS(7123),
    [anon_sym_DQUOTE] = ACTIONS(7123),
    [sym_return] = ACTIONS(7121),
    [sym_next] = ACTIONS(7121),
    [sym_break] = ACTIONS(7121),
    [sym_true] = ACTIONS(7121),
    [sym_false] = ACTIONS(7121),
    [sym_null] = ACTIONS(7121),
    [sym_inf] = ACTIONS(7121),
    [sym_nan] = ACTIONS(7121),
    [anon_sym_NA] = ACTIONS(7121),
    [anon_sym_NA_integer_] = ACTIONS(7121),
    [anon_sym_NA_real_] = ACTIONS(7121),
    [anon_sym_NA_complex_] = ACTIONS(7121),
    [anon_sym_NA_character_] = ACTIONS(7121),
    [sym_dots] = ACTIONS(7121),
    [sym_dot_dot_i] = ACTIONS(7123),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7123),
    [sym__newline] = ACTIONS(7123),
    [sym__semicolon] = ACTIONS(7123),
    [sym__raw_string_literal] = ACTIONS(7123),
    [sym__external_else] = ACTIONS(7123),
    [sym__external_open_parenthesis] = ACTIONS(7123),
    [sym__external_open_brace] = ACTIONS(7123),
    [sym__external_close_brace] = ACTIONS(7123),
    [sym__external_open_bracket] = ACTIONS(7123),
    [sym__external_close_bracket] = ACTIONS(7123),
    [sym__external_open_bracket2] = ACTIONS(7123),
  },
  [2207] = {
    [sym_identifier] = ACTIONS(7163),
    [anon_sym_BSLASH] = ACTIONS(7165),
    [anon_sym_function] = ACTIONS(7163),
    [anon_sym_EQ] = ACTIONS(7163),
    [anon_sym_if] = ACTIONS(7163),
    [anon_sym_for] = ACTIONS(7163),
    [anon_sym_while] = ACTIONS(7163),
    [anon_sym_repeat] = ACTIONS(7163),
    [anon_sym_QMARK] = ACTIONS(7165),
    [anon_sym_TILDE] = ACTIONS(7165),
    [anon_sym_BANG] = ACTIONS(7163),
    [anon_sym_PLUS] = ACTIONS(7165),
    [anon_sym_DASH] = ACTIONS(7163),
    [anon_sym_LT_DASH] = ACTIONS(7165),
    [anon_sym_LT_LT_DASH] = ACTIONS(7165),
    [anon_sym_COLON_EQ] = ACTIONS(7165),
    [anon_sym_DASH_GT] = ACTIONS(7163),
    [anon_sym_DASH_GT_GT] = ACTIONS(7165),
    [anon_sym_PIPE] = ACTIONS(7163),
    [anon_sym_AMP] = ACTIONS(7163),
    [anon_sym_PIPE_PIPE] = ACTIONS(7165),
    [anon_sym_AMP_AMP] = ACTIONS(7165),
    [anon_sym_LT] = ACTIONS(7163),
    [anon_sym_LT_EQ] = ACTIONS(7165),
    [anon_sym_GT] = ACTIONS(7163),
    [anon_sym_GT_EQ] = ACTIONS(7165),
    [anon_sym_EQ_EQ] = ACTIONS(7165),
    [anon_sym_BANG_EQ] = ACTIONS(7165),
    [anon_sym_STAR] = ACTIONS(7163),
    [anon_sym_SLASH] = ACTIONS(7165),
    [anon_sym_STAR_STAR] = ACTIONS(7165),
    [anon_sym_CARET] = ACTIONS(7165),
    [aux_sym_binary_operator_token1] = ACTIONS(7165),
    [anon_sym_PIPE_GT] = ACTIONS(7165),
    [anon_sym_COLON] = ACTIONS(7163),
    [anon_sym_DOLLAR] = ACTIONS(7165),
    [anon_sym_AT] = ACTIONS(7165),
    [anon_sym_COLON_COLON] = ACTIONS(7163),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7165),
    [aux_sym__hex_literal_token1] = ACTIONS(7165),
    [sym__number_literal] = ACTIONS(7163),
    [anon_sym_SQUOTE] = ACTIONS(7165),
    [anon_sym_DQUOTE] = ACTIONS(7165),
    [sym_return] = ACTIONS(7163),
    [sym_next] = ACTIONS(7163),
    [sym_break] = ACTIONS(7163),
    [sym_true] = ACTIONS(7163),
    [sym_false] = ACTIONS(7163),
    [sym_null] = ACTIONS(7163),
    [sym_inf] = ACTIONS(7163),
    [sym_nan] = ACTIONS(7163),
    [anon_sym_NA] = ACTIONS(7163),
    [anon_sym_NA_integer_] = ACTIONS(7163),
    [anon_sym_NA_real_] = ACTIONS(7163),
    [anon_sym_NA_complex_] = ACTIONS(7163),
    [anon_sym_NA_character_] = ACTIONS(7163),
    [sym_dots] = ACTIONS(7163),
    [sym_dot_dot_i] = ACTIONS(7165),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7165),
    [sym__newline] = ACTIONS(7165),
    [sym__semicolon] = ACTIONS(7165),
    [sym__raw_string_literal] = ACTIONS(7165),
    [sym__external_else] = ACTIONS(7165),
    [sym__external_open_parenthesis] = ACTIONS(7165),
    [sym__external_open_brace] = ACTIONS(7165),
    [sym__external_close_brace] = ACTIONS(7165),
    [sym__external_open_bracket] = ACTIONS(7165),
    [sym__external_close_bracket] = ACTIONS(7165),
    [sym__external_open_bracket2] = ACTIONS(7165),
  },
  [2208] = {
    [sym_identifier] = ACTIONS(7137),
    [anon_sym_BSLASH] = ACTIONS(7139),
    [anon_sym_function] = ACTIONS(7137),
    [anon_sym_EQ] = ACTIONS(7137),
    [anon_sym_if] = ACTIONS(7137),
    [anon_sym_for] = ACTIONS(7137),
    [anon_sym_while] = ACTIONS(7137),
    [anon_sym_repeat] = ACTIONS(7137),
    [anon_sym_QMARK] = ACTIONS(7139),
    [anon_sym_TILDE] = ACTIONS(7139),
    [anon_sym_BANG] = ACTIONS(7137),
    [anon_sym_PLUS] = ACTIONS(7139),
    [anon_sym_DASH] = ACTIONS(7137),
    [anon_sym_LT_DASH] = ACTIONS(7139),
    [anon_sym_LT_LT_DASH] = ACTIONS(7139),
    [anon_sym_COLON_EQ] = ACTIONS(7139),
    [anon_sym_DASH_GT] = ACTIONS(7137),
    [anon_sym_DASH_GT_GT] = ACTIONS(7139),
    [anon_sym_PIPE] = ACTIONS(7137),
    [anon_sym_AMP] = ACTIONS(7137),
    [anon_sym_PIPE_PIPE] = ACTIONS(7139),
    [anon_sym_AMP_AMP] = ACTIONS(7139),
    [anon_sym_LT] = ACTIONS(7137),
    [anon_sym_LT_EQ] = ACTIONS(7139),
    [anon_sym_GT] = ACTIONS(7137),
    [anon_sym_GT_EQ] = ACTIONS(7139),
    [anon_sym_EQ_EQ] = ACTIONS(7139),
    [anon_sym_BANG_EQ] = ACTIONS(7139),
    [anon_sym_STAR] = ACTIONS(7137),
    [anon_sym_SLASH] = ACTIONS(7139),
    [anon_sym_STAR_STAR] = ACTIONS(7139),
    [anon_sym_CARET] = ACTIONS(7139),
    [aux_sym_binary_operator_token1] = ACTIONS(7139),
    [anon_sym_PIPE_GT] = ACTIONS(7139),
    [anon_sym_COLON] = ACTIONS(7137),
    [anon_sym_DOLLAR] = ACTIONS(7139),
    [anon_sym_AT] = ACTIONS(7139),
    [anon_sym_COLON_COLON] = ACTIONS(7137),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7139),
    [aux_sym__hex_literal_token1] = ACTIONS(7139),
    [sym__number_literal] = ACTIONS(7137),
    [anon_sym_SQUOTE] = ACTIONS(7139),
    [anon_sym_DQUOTE] = ACTIONS(7139),
    [sym_return] = ACTIONS(7137),
    [sym_next] = ACTIONS(7137),
    [sym_break] = ACTIONS(7137),
    [sym_true] = ACTIONS(7137),
    [sym_false] = ACTIONS(7137),
    [sym_null] = ACTIONS(7137),
    [sym_inf] = ACTIONS(7137),
    [sym_nan] = ACTIONS(7137),
    [anon_sym_NA] = ACTIONS(7137),
    [anon_sym_NA_integer_] = ACTIONS(7137),
    [anon_sym_NA_real_] = ACTIONS(7137),
    [anon_sym_NA_complex_] = ACTIONS(7137),
    [anon_sym_NA_character_] = ACTIONS(7137),
    [sym_dots] = ACTIONS(7137),
    [sym_dot_dot_i] = ACTIONS(7139),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7139),
    [sym__newline] = ACTIONS(7139),
    [sym__semicolon] = ACTIONS(7139),
    [sym__raw_string_literal] = ACTIONS(7139),
    [sym__external_else] = ACTIONS(7139),
    [sym__external_open_parenthesis] = ACTIONS(7139),
    [sym__external_open_brace] = ACTIONS(7139),
    [sym__external_close_brace] = ACTIONS(7139),
    [sym__external_open_bracket] = ACTIONS(7139),
    [sym__external_open_bracket2] = ACTIONS(7139),
    [sym__external_close_bracket2] = ACTIONS(7139),
  },
  [2209] = {
    [sym_identifier] = ACTIONS(7129),
    [anon_sym_BSLASH] = ACTIONS(7131),
    [anon_sym_function] = ACTIONS(7129),
    [anon_sym_EQ] = ACTIONS(7129),
    [anon_sym_if] = ACTIONS(7129),
    [anon_sym_for] = ACTIONS(7129),
    [anon_sym_while] = ACTIONS(7129),
    [anon_sym_repeat] = ACTIONS(7129),
    [anon_sym_QMARK] = ACTIONS(7131),
    [anon_sym_TILDE] = ACTIONS(7131),
    [anon_sym_BANG] = ACTIONS(7129),
    [anon_sym_PLUS] = ACTIONS(7131),
    [anon_sym_DASH] = ACTIONS(7129),
    [anon_sym_LT_DASH] = ACTIONS(7131),
    [anon_sym_LT_LT_DASH] = ACTIONS(7131),
    [anon_sym_COLON_EQ] = ACTIONS(7131),
    [anon_sym_DASH_GT] = ACTIONS(7129),
    [anon_sym_DASH_GT_GT] = ACTIONS(7131),
    [anon_sym_PIPE] = ACTIONS(7129),
    [anon_sym_AMP] = ACTIONS(7129),
    [anon_sym_PIPE_PIPE] = ACTIONS(7131),
    [anon_sym_AMP_AMP] = ACTIONS(7131),
    [anon_sym_LT] = ACTIONS(7129),
    [anon_sym_LT_EQ] = ACTIONS(7131),
    [anon_sym_GT] = ACTIONS(7129),
    [anon_sym_GT_EQ] = ACTIONS(7131),
    [anon_sym_EQ_EQ] = ACTIONS(7131),
    [anon_sym_BANG_EQ] = ACTIONS(7131),
    [anon_sym_STAR] = ACTIONS(7129),
    [anon_sym_SLASH] = ACTIONS(7131),
    [anon_sym_STAR_STAR] = ACTIONS(7131),
    [anon_sym_CARET] = ACTIONS(7131),
    [aux_sym_binary_operator_token1] = ACTIONS(7131),
    [anon_sym_PIPE_GT] = ACTIONS(7131),
    [anon_sym_COLON] = ACTIONS(7129),
    [anon_sym_DOLLAR] = ACTIONS(7131),
    [anon_sym_AT] = ACTIONS(7131),
    [anon_sym_COLON_COLON] = ACTIONS(7133),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7135),
    [aux_sym__hex_literal_token1] = ACTIONS(7131),
    [sym__number_literal] = ACTIONS(7129),
    [anon_sym_SQUOTE] = ACTIONS(7131),
    [anon_sym_DQUOTE] = ACTIONS(7131),
    [sym_return] = ACTIONS(7129),
    [sym_next] = ACTIONS(7129),
    [sym_break] = ACTIONS(7129),
    [sym_true] = ACTIONS(7129),
    [sym_false] = ACTIONS(7129),
    [sym_null] = ACTIONS(7129),
    [sym_inf] = ACTIONS(7129),
    [sym_nan] = ACTIONS(7129),
    [anon_sym_NA] = ACTIONS(7129),
    [anon_sym_NA_integer_] = ACTIONS(7129),
    [anon_sym_NA_real_] = ACTIONS(7129),
    [anon_sym_NA_complex_] = ACTIONS(7129),
    [anon_sym_NA_character_] = ACTIONS(7129),
    [sym_dots] = ACTIONS(7129),
    [sym_dot_dot_i] = ACTIONS(7131),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7131),
    [sym__newline] = ACTIONS(7131),
    [sym__semicolon] = ACTIONS(7131),
    [sym__raw_string_literal] = ACTIONS(7131),
    [sym__external_else] = ACTIONS(7131),
    [sym__external_open_parenthesis] = ACTIONS(7131),
    [sym__external_open_brace] = ACTIONS(7131),
    [sym__external_close_brace] = ACTIONS(7131),
    [sym__external_open_bracket] = ACTIONS(7131),
    [sym__external_open_bracket2] = ACTIONS(7131),
    [sym__external_close_bracket2] = ACTIONS(7131),
  },
  [2210] = {
    [sym_identifier] = ACTIONS(7121),
    [anon_sym_BSLASH] = ACTIONS(7123),
    [anon_sym_function] = ACTIONS(7121),
    [anon_sym_EQ] = ACTIONS(7121),
    [anon_sym_if] = ACTIONS(7121),
    [anon_sym_for] = ACTIONS(7121),
    [anon_sym_while] = ACTIONS(7121),
    [anon_sym_repeat] = ACTIONS(7121),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_TILDE] = ACTIONS(7123),
    [anon_sym_BANG] = ACTIONS(7121),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_DASH] = ACTIONS(7121),
    [anon_sym_LT_DASH] = ACTIONS(7123),
    [anon_sym_LT_LT_DASH] = ACTIONS(7123),
    [anon_sym_COLON_EQ] = ACTIONS(7123),
    [anon_sym_DASH_GT] = ACTIONS(7121),
    [anon_sym_DASH_GT_GT] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_LT_EQ] = ACTIONS(7123),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
    [aux_sym_binary_operator_token1] = ACTIONS(7123),
    [anon_sym_PIPE_GT] = ACTIONS(7123),
    [anon_sym_COLON] = ACTIONS(7121),
    [anon_sym_DOLLAR] = ACTIONS(7123),
    [anon_sym_AT] = ACTIONS(7123),
    [anon_sym_L] = ACTIONS(7442),
    [anon_sym_i] = ACTIONS(7444),
    [aux_sym__hex_literal_token1] = ACTIONS(7123),
    [sym__number_literal] = ACTIONS(7121),
    [anon_sym_SQUOTE] = ACTIONS(7123),
    [anon_sym_DQUOTE] = ACTIONS(7123),
    [sym_return] = ACTIONS(7121),
    [sym_next] = ACTIONS(7121),
    [sym_break] = ACTIONS(7121),
    [sym_true] = ACTIONS(7121),
    [sym_false] = ACTIONS(7121),
    [sym_null] = ACTIONS(7121),
    [sym_inf] = ACTIONS(7121),
    [sym_nan] = ACTIONS(7121),
    [anon_sym_NA] = ACTIONS(7121),
    [anon_sym_NA_integer_] = ACTIONS(7121),
    [anon_sym_NA_real_] = ACTIONS(7121),
    [anon_sym_NA_complex_] = ACTIONS(7121),
    [anon_sym_NA_character_] = ACTIONS(7121),
    [sym_dots] = ACTIONS(7121),
    [sym_dot_dot_i] = ACTIONS(7123),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7123),
    [sym__newline] = ACTIONS(7123),
    [sym__semicolon] = ACTIONS(7123),
    [sym__raw_string_literal] = ACTIONS(7123),
    [sym__external_else] = ACTIONS(7123),
    [sym__external_open_parenthesis] = ACTIONS(7123),
    [sym__external_open_brace] = ACTIONS(7123),
    [sym__external_close_brace] = ACTIONS(7123),
    [sym__external_open_bracket] = ACTIONS(7123),
    [sym__external_open_bracket2] = ACTIONS(7123),
    [sym__external_close_bracket2] = ACTIONS(7123),
  },
  [2211] = {
    [sym_identifier] = ACTIONS(7115),
    [anon_sym_BSLASH] = ACTIONS(7117),
    [anon_sym_function] = ACTIONS(7115),
    [anon_sym_EQ] = ACTIONS(7115),
    [anon_sym_if] = ACTIONS(7115),
    [anon_sym_for] = ACTIONS(7115),
    [anon_sym_while] = ACTIONS(7115),
    [anon_sym_repeat] = ACTIONS(7115),
    [anon_sym_QMARK] = ACTIONS(7117),
    [anon_sym_TILDE] = ACTIONS(7117),
    [anon_sym_BANG] = ACTIONS(7115),
    [anon_sym_PLUS] = ACTIONS(7117),
    [anon_sym_DASH] = ACTIONS(7115),
    [anon_sym_LT_DASH] = ACTIONS(7117),
    [anon_sym_LT_LT_DASH] = ACTIONS(7117),
    [anon_sym_COLON_EQ] = ACTIONS(7117),
    [anon_sym_DASH_GT] = ACTIONS(7115),
    [anon_sym_DASH_GT_GT] = ACTIONS(7117),
    [anon_sym_PIPE] = ACTIONS(7115),
    [anon_sym_AMP] = ACTIONS(7115),
    [anon_sym_PIPE_PIPE] = ACTIONS(7117),
    [anon_sym_AMP_AMP] = ACTIONS(7117),
    [anon_sym_LT] = ACTIONS(7115),
    [anon_sym_LT_EQ] = ACTIONS(7117),
    [anon_sym_GT] = ACTIONS(7115),
    [anon_sym_GT_EQ] = ACTIONS(7117),
    [anon_sym_EQ_EQ] = ACTIONS(7117),
    [anon_sym_BANG_EQ] = ACTIONS(7117),
    [anon_sym_STAR] = ACTIONS(7115),
    [anon_sym_SLASH] = ACTIONS(7117),
    [anon_sym_STAR_STAR] = ACTIONS(7117),
    [anon_sym_CARET] = ACTIONS(7117),
    [aux_sym_binary_operator_token1] = ACTIONS(7117),
    [anon_sym_PIPE_GT] = ACTIONS(7117),
    [anon_sym_COLON] = ACTIONS(7115),
    [anon_sym_DOLLAR] = ACTIONS(7117),
    [anon_sym_AT] = ACTIONS(7117),
    [anon_sym_COLON_COLON] = ACTIONS(7115),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7117),
    [aux_sym__hex_literal_token1] = ACTIONS(7117),
    [sym__number_literal] = ACTIONS(7115),
    [anon_sym_SQUOTE] = ACTIONS(7117),
    [anon_sym_DQUOTE] = ACTIONS(7117),
    [sym_return] = ACTIONS(7115),
    [sym_next] = ACTIONS(7115),
    [sym_break] = ACTIONS(7115),
    [sym_true] = ACTIONS(7115),
    [sym_false] = ACTIONS(7115),
    [sym_null] = ACTIONS(7115),
    [sym_inf] = ACTIONS(7115),
    [sym_nan] = ACTIONS(7115),
    [anon_sym_NA] = ACTIONS(7115),
    [anon_sym_NA_integer_] = ACTIONS(7115),
    [anon_sym_NA_real_] = ACTIONS(7115),
    [anon_sym_NA_complex_] = ACTIONS(7115),
    [anon_sym_NA_character_] = ACTIONS(7115),
    [sym_dots] = ACTIONS(7115),
    [sym_dot_dot_i] = ACTIONS(7117),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7117),
    [sym__newline] = ACTIONS(7117),
    [sym__semicolon] = ACTIONS(7117),
    [sym__raw_string_literal] = ACTIONS(7117),
    [sym__external_else] = ACTIONS(7117),
    [sym__external_open_parenthesis] = ACTIONS(7117),
    [sym__external_open_brace] = ACTIONS(7117),
    [sym__external_close_brace] = ACTIONS(7117),
    [sym__external_open_bracket] = ACTIONS(7117),
    [sym__external_open_bracket2] = ACTIONS(7117),
    [sym__external_close_bracket2] = ACTIONS(7117),
  },
  [2212] = {
    [sym_identifier] = ACTIONS(7115),
    [anon_sym_BSLASH] = ACTIONS(7117),
    [anon_sym_function] = ACTIONS(7115),
    [anon_sym_EQ] = ACTIONS(7115),
    [anon_sym_if] = ACTIONS(7115),
    [anon_sym_for] = ACTIONS(7115),
    [anon_sym_while] = ACTIONS(7115),
    [anon_sym_repeat] = ACTIONS(7115),
    [anon_sym_QMARK] = ACTIONS(7117),
    [anon_sym_TILDE] = ACTIONS(7117),
    [anon_sym_BANG] = ACTIONS(7115),
    [anon_sym_PLUS] = ACTIONS(7117),
    [anon_sym_DASH] = ACTIONS(7115),
    [anon_sym_LT_DASH] = ACTIONS(7117),
    [anon_sym_LT_LT_DASH] = ACTIONS(7117),
    [anon_sym_COLON_EQ] = ACTIONS(7117),
    [anon_sym_DASH_GT] = ACTIONS(7115),
    [anon_sym_DASH_GT_GT] = ACTIONS(7117),
    [anon_sym_PIPE] = ACTIONS(7115),
    [anon_sym_AMP] = ACTIONS(7115),
    [anon_sym_PIPE_PIPE] = ACTIONS(7117),
    [anon_sym_AMP_AMP] = ACTIONS(7117),
    [anon_sym_LT] = ACTIONS(7115),
    [anon_sym_LT_EQ] = ACTIONS(7117),
    [anon_sym_GT] = ACTIONS(7115),
    [anon_sym_GT_EQ] = ACTIONS(7117),
    [anon_sym_EQ_EQ] = ACTIONS(7117),
    [anon_sym_BANG_EQ] = ACTIONS(7117),
    [anon_sym_STAR] = ACTIONS(7115),
    [anon_sym_SLASH] = ACTIONS(7117),
    [anon_sym_STAR_STAR] = ACTIONS(7117),
    [anon_sym_CARET] = ACTIONS(7117),
    [aux_sym_binary_operator_token1] = ACTIONS(7117),
    [anon_sym_PIPE_GT] = ACTIONS(7117),
    [anon_sym_COLON] = ACTIONS(7115),
    [anon_sym_DOLLAR] = ACTIONS(7117),
    [anon_sym_AT] = ACTIONS(7117),
    [anon_sym_COLON_COLON] = ACTIONS(7115),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7117),
    [aux_sym__hex_literal_token1] = ACTIONS(7117),
    [sym__number_literal] = ACTIONS(7115),
    [anon_sym_SQUOTE] = ACTIONS(7117),
    [anon_sym_DQUOTE] = ACTIONS(7117),
    [sym_return] = ACTIONS(7115),
    [sym_next] = ACTIONS(7115),
    [sym_break] = ACTIONS(7115),
    [sym_true] = ACTIONS(7115),
    [sym_false] = ACTIONS(7115),
    [sym_null] = ACTIONS(7115),
    [sym_inf] = ACTIONS(7115),
    [sym_nan] = ACTIONS(7115),
    [anon_sym_NA] = ACTIONS(7115),
    [anon_sym_NA_integer_] = ACTIONS(7115),
    [anon_sym_NA_real_] = ACTIONS(7115),
    [anon_sym_NA_complex_] = ACTIONS(7115),
    [anon_sym_NA_character_] = ACTIONS(7115),
    [sym_dots] = ACTIONS(7115),
    [sym_dot_dot_i] = ACTIONS(7117),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7117),
    [sym__newline] = ACTIONS(7117),
    [sym__semicolon] = ACTIONS(7117),
    [sym__raw_string_literal] = ACTIONS(7117),
    [sym__external_else] = ACTIONS(7117),
    [sym__external_open_parenthesis] = ACTIONS(7117),
    [sym__external_open_brace] = ACTIONS(7117),
    [sym__external_close_brace] = ACTIONS(7117),
    [sym__external_open_bracket] = ACTIONS(7117),
    [sym__external_open_bracket2] = ACTIONS(7117),
    [sym__external_close_bracket2] = ACTIONS(7117),
  },
  [2213] = {
    [sym_string] = STATE(2962),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym__string_or_identifier] = STATE(2962),
    [aux_sym_function_definition_repeat1] = STATE(2847),
    [sym_identifier] = ACTIONS(7446),
    [anon_sym_BSLASH] = ACTIONS(5669),
    [anon_sym_function] = ACTIONS(5673),
    [anon_sym_EQ] = ACTIONS(5673),
    [anon_sym_if] = ACTIONS(5673),
    [anon_sym_for] = ACTIONS(5673),
    [anon_sym_while] = ACTIONS(5673),
    [anon_sym_repeat] = ACTIONS(5673),
    [anon_sym_QMARK] = ACTIONS(5669),
    [anon_sym_TILDE] = ACTIONS(5669),
    [anon_sym_BANG] = ACTIONS(5673),
    [anon_sym_PLUS] = ACTIONS(5669),
    [anon_sym_DASH] = ACTIONS(5673),
    [anon_sym_LT_DASH] = ACTIONS(5669),
    [anon_sym_LT_LT_DASH] = ACTIONS(5669),
    [anon_sym_COLON_EQ] = ACTIONS(5669),
    [anon_sym_DASH_GT] = ACTIONS(5673),
    [anon_sym_DASH_GT_GT] = ACTIONS(5669),
    [anon_sym_PIPE] = ACTIONS(5673),
    [anon_sym_AMP] = ACTIONS(5673),
    [anon_sym_PIPE_PIPE] = ACTIONS(5669),
    [anon_sym_AMP_AMP] = ACTIONS(5669),
    [anon_sym_LT] = ACTIONS(5673),
    [anon_sym_LT_EQ] = ACTIONS(5669),
    [anon_sym_GT] = ACTIONS(5673),
    [anon_sym_GT_EQ] = ACTIONS(5669),
    [anon_sym_EQ_EQ] = ACTIONS(5669),
    [anon_sym_BANG_EQ] = ACTIONS(5669),
    [anon_sym_STAR] = ACTIONS(5673),
    [anon_sym_SLASH] = ACTIONS(5669),
    [anon_sym_STAR_STAR] = ACTIONS(5669),
    [anon_sym_CARET] = ACTIONS(5669),
    [aux_sym_binary_operator_token1] = ACTIONS(5669),
    [anon_sym_PIPE_GT] = ACTIONS(5669),
    [anon_sym_COLON] = ACTIONS(5673),
    [anon_sym_DOLLAR] = ACTIONS(5669),
    [anon_sym_AT] = ACTIONS(5669),
    [aux_sym__hex_literal_token1] = ACTIONS(5669),
    [sym__number_literal] = ACTIONS(5673),
    [anon_sym_SQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4672),
    [sym_return] = ACTIONS(5673),
    [sym_next] = ACTIONS(5673),
    [sym_break] = ACTIONS(5673),
    [sym_true] = ACTIONS(5673),
    [sym_false] = ACTIONS(5673),
    [sym_null] = ACTIONS(5673),
    [sym_inf] = ACTIONS(5673),
    [sym_nan] = ACTIONS(5673),
    [anon_sym_NA] = ACTIONS(5673),
    [anon_sym_NA_integer_] = ACTIONS(5673),
    [anon_sym_NA_real_] = ACTIONS(5673),
    [anon_sym_NA_complex_] = ACTIONS(5673),
    [anon_sym_NA_character_] = ACTIONS(5673),
    [sym_dots] = ACTIONS(5673),
    [sym_dot_dot_i] = ACTIONS(5669),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5669),
    [sym__newline] = ACTIONS(5669),
    [sym__raw_string_literal] = ACTIONS(4680),
    [sym__external_open_parenthesis] = ACTIONS(5669),
    [sym__external_open_brace] = ACTIONS(5669),
    [sym__external_open_bracket] = ACTIONS(5669),
    [sym__external_open_bracket2] = ACTIONS(5669),
    [sym__external_close_bracket2] = ACTIONS(5669),
  },
  [2214] = {
    [sym_string] = STATE(2936),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym__string_or_identifier] = STATE(2936),
    [aux_sym_function_definition_repeat1] = STATE(2866),
    [sym_identifier] = ACTIONS(7448),
    [anon_sym_BSLASH] = ACTIONS(5669),
    [anon_sym_function] = ACTIONS(5673),
    [anon_sym_EQ] = ACTIONS(5673),
    [anon_sym_if] = ACTIONS(5673),
    [anon_sym_for] = ACTIONS(5673),
    [anon_sym_while] = ACTIONS(5673),
    [anon_sym_repeat] = ACTIONS(5673),
    [anon_sym_QMARK] = ACTIONS(5669),
    [anon_sym_TILDE] = ACTIONS(5669),
    [anon_sym_BANG] = ACTIONS(5673),
    [anon_sym_PLUS] = ACTIONS(5669),
    [anon_sym_DASH] = ACTIONS(5673),
    [anon_sym_LT_DASH] = ACTIONS(5669),
    [anon_sym_LT_LT_DASH] = ACTIONS(5669),
    [anon_sym_COLON_EQ] = ACTIONS(5669),
    [anon_sym_DASH_GT] = ACTIONS(5673),
    [anon_sym_DASH_GT_GT] = ACTIONS(5669),
    [anon_sym_PIPE] = ACTIONS(5673),
    [anon_sym_AMP] = ACTIONS(5673),
    [anon_sym_PIPE_PIPE] = ACTIONS(5669),
    [anon_sym_AMP_AMP] = ACTIONS(5669),
    [anon_sym_LT] = ACTIONS(5673),
    [anon_sym_LT_EQ] = ACTIONS(5669),
    [anon_sym_GT] = ACTIONS(5673),
    [anon_sym_GT_EQ] = ACTIONS(5669),
    [anon_sym_EQ_EQ] = ACTIONS(5669),
    [anon_sym_BANG_EQ] = ACTIONS(5669),
    [anon_sym_STAR] = ACTIONS(5673),
    [anon_sym_SLASH] = ACTIONS(5669),
    [anon_sym_STAR_STAR] = ACTIONS(5669),
    [anon_sym_CARET] = ACTIONS(5669),
    [aux_sym_binary_operator_token1] = ACTIONS(5669),
    [anon_sym_PIPE_GT] = ACTIONS(5669),
    [anon_sym_COLON] = ACTIONS(5673),
    [anon_sym_DOLLAR] = ACTIONS(5669),
    [anon_sym_AT] = ACTIONS(5669),
    [aux_sym__hex_literal_token1] = ACTIONS(5669),
    [sym__number_literal] = ACTIONS(5673),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(5673),
    [sym_next] = ACTIONS(5673),
    [sym_break] = ACTIONS(5673),
    [sym_true] = ACTIONS(5673),
    [sym_false] = ACTIONS(5673),
    [sym_null] = ACTIONS(5673),
    [sym_inf] = ACTIONS(5673),
    [sym_nan] = ACTIONS(5673),
    [anon_sym_NA] = ACTIONS(5673),
    [anon_sym_NA_integer_] = ACTIONS(5673),
    [anon_sym_NA_real_] = ACTIONS(5673),
    [anon_sym_NA_complex_] = ACTIONS(5673),
    [anon_sym_NA_character_] = ACTIONS(5673),
    [sym_dots] = ACTIONS(5673),
    [sym_dot_dot_i] = ACTIONS(5669),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5669),
    [sym__newline] = ACTIONS(5669),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(5669),
    [sym__external_close_parenthesis] = ACTIONS(5669),
    [sym__external_open_brace] = ACTIONS(5669),
    [sym__external_open_bracket] = ACTIONS(5669),
    [sym__external_open_bracket2] = ACTIONS(5669),
  },
  [2215] = {
    [sym_string] = STATE(2807),
    [sym__single_quoted_string] = STATE(2538),
    [sym__double_quoted_string] = STATE(2539),
    [sym__string_or_identifier] = STATE(2807),
    [ts_builtin_sym_end] = ACTIONS(5883),
    [sym_identifier] = ACTIONS(7450),
    [anon_sym_BSLASH] = ACTIONS(5883),
    [anon_sym_function] = ACTIONS(5887),
    [anon_sym_EQ] = ACTIONS(5887),
    [anon_sym_if] = ACTIONS(5887),
    [anon_sym_for] = ACTIONS(5887),
    [anon_sym_while] = ACTIONS(5887),
    [anon_sym_repeat] = ACTIONS(5887),
    [anon_sym_QMARK] = ACTIONS(5883),
    [anon_sym_TILDE] = ACTIONS(5883),
    [anon_sym_BANG] = ACTIONS(5887),
    [anon_sym_PLUS] = ACTIONS(5883),
    [anon_sym_DASH] = ACTIONS(5887),
    [anon_sym_LT_DASH] = ACTIONS(5883),
    [anon_sym_LT_LT_DASH] = ACTIONS(5883),
    [anon_sym_COLON_EQ] = ACTIONS(5883),
    [anon_sym_DASH_GT] = ACTIONS(5887),
    [anon_sym_DASH_GT_GT] = ACTIONS(5883),
    [anon_sym_PIPE] = ACTIONS(5887),
    [anon_sym_AMP] = ACTIONS(5887),
    [anon_sym_PIPE_PIPE] = ACTIONS(5883),
    [anon_sym_AMP_AMP] = ACTIONS(5883),
    [anon_sym_LT] = ACTIONS(5887),
    [anon_sym_LT_EQ] = ACTIONS(5883),
    [anon_sym_GT] = ACTIONS(5887),
    [anon_sym_GT_EQ] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5883),
    [anon_sym_BANG_EQ] = ACTIONS(5883),
    [anon_sym_STAR] = ACTIONS(5887),
    [anon_sym_SLASH] = ACTIONS(5883),
    [anon_sym_STAR_STAR] = ACTIONS(5883),
    [anon_sym_CARET] = ACTIONS(5883),
    [aux_sym_binary_operator_token1] = ACTIONS(5883),
    [anon_sym_PIPE_GT] = ACTIONS(5883),
    [anon_sym_COLON] = ACTIONS(5887),
    [anon_sym_DOLLAR] = ACTIONS(5883),
    [anon_sym_AT] = ACTIONS(5883),
    [aux_sym__hex_literal_token1] = ACTIONS(5883),
    [sym__number_literal] = ACTIONS(5887),
    [anon_sym_SQUOTE] = ACTIONS(4081),
    [anon_sym_DQUOTE] = ACTIONS(4083),
    [sym_return] = ACTIONS(5887),
    [sym_next] = ACTIONS(5887),
    [sym_break] = ACTIONS(5887),
    [sym_true] = ACTIONS(5887),
    [sym_false] = ACTIONS(5887),
    [sym_null] = ACTIONS(5887),
    [sym_inf] = ACTIONS(5887),
    [sym_nan] = ACTIONS(5887),
    [anon_sym_NA] = ACTIONS(5887),
    [anon_sym_NA_integer_] = ACTIONS(5887),
    [anon_sym_NA_real_] = ACTIONS(5887),
    [anon_sym_NA_complex_] = ACTIONS(5887),
    [anon_sym_NA_character_] = ACTIONS(5887),
    [sym_dots] = ACTIONS(5887),
    [sym_dot_dot_i] = ACTIONS(5883),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5883),
    [sym__semicolon] = ACTIONS(5883),
    [sym__raw_string_literal] = ACTIONS(4093),
    [sym__external_else] = ACTIONS(5883),
    [sym__external_open_parenthesis] = ACTIONS(5883),
    [sym__external_open_brace] = ACTIONS(5883),
    [sym__external_open_bracket] = ACTIONS(5883),
    [sym__external_open_bracket2] = ACTIONS(5883),
  },
  [2216] = {
    [sym_identifier] = ACTIONS(7191),
    [anon_sym_BSLASH] = ACTIONS(7189),
    [anon_sym_function] = ACTIONS(7191),
    [anon_sym_EQ] = ACTIONS(7191),
    [anon_sym_if] = ACTIONS(7191),
    [anon_sym_for] = ACTIONS(7191),
    [anon_sym_while] = ACTIONS(7191),
    [anon_sym_repeat] = ACTIONS(7191),
    [anon_sym_QMARK] = ACTIONS(7189),
    [anon_sym_TILDE] = ACTIONS(7189),
    [anon_sym_BANG] = ACTIONS(7191),
    [anon_sym_PLUS] = ACTIONS(7189),
    [anon_sym_DASH] = ACTIONS(7191),
    [anon_sym_LT_DASH] = ACTIONS(7189),
    [anon_sym_LT_LT_DASH] = ACTIONS(7189),
    [anon_sym_COLON_EQ] = ACTIONS(7189),
    [anon_sym_DASH_GT] = ACTIONS(7191),
    [anon_sym_DASH_GT_GT] = ACTIONS(7189),
    [anon_sym_PIPE] = ACTIONS(7191),
    [anon_sym_AMP] = ACTIONS(7191),
    [anon_sym_PIPE_PIPE] = ACTIONS(7189),
    [anon_sym_AMP_AMP] = ACTIONS(7189),
    [anon_sym_LT] = ACTIONS(7191),
    [anon_sym_LT_EQ] = ACTIONS(7189),
    [anon_sym_GT] = ACTIONS(7191),
    [anon_sym_GT_EQ] = ACTIONS(7189),
    [anon_sym_EQ_EQ] = ACTIONS(7189),
    [anon_sym_BANG_EQ] = ACTIONS(7189),
    [anon_sym_STAR] = ACTIONS(7191),
    [anon_sym_SLASH] = ACTIONS(7189),
    [anon_sym_STAR_STAR] = ACTIONS(7189),
    [anon_sym_CARET] = ACTIONS(7189),
    [aux_sym_binary_operator_token1] = ACTIONS(7189),
    [anon_sym_PIPE_GT] = ACTIONS(7189),
    [anon_sym_COLON] = ACTIONS(7191),
    [anon_sym_DOLLAR] = ACTIONS(7189),
    [anon_sym_AT] = ACTIONS(7189),
    [anon_sym_COLON_COLON] = ACTIONS(7191),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7189),
    [aux_sym__hex_literal_token1] = ACTIONS(7189),
    [sym__number_literal] = ACTIONS(7191),
    [anon_sym_SQUOTE] = ACTIONS(7189),
    [anon_sym_DQUOTE] = ACTIONS(7189),
    [sym_return] = ACTIONS(7191),
    [sym_next] = ACTIONS(7191),
    [sym_break] = ACTIONS(7191),
    [sym_true] = ACTIONS(7191),
    [sym_false] = ACTIONS(7191),
    [sym_null] = ACTIONS(7191),
    [sym_inf] = ACTIONS(7191),
    [sym_nan] = ACTIONS(7191),
    [anon_sym_NA] = ACTIONS(7191),
    [anon_sym_NA_integer_] = ACTIONS(7191),
    [anon_sym_NA_real_] = ACTIONS(7191),
    [anon_sym_NA_complex_] = ACTIONS(7191),
    [anon_sym_NA_character_] = ACTIONS(7191),
    [sym_dots] = ACTIONS(7191),
    [sym_dot_dot_i] = ACTIONS(7189),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7189),
    [sym__newline] = ACTIONS(7189),
    [sym__semicolon] = ACTIONS(7189),
    [sym__raw_string_literal] = ACTIONS(7189),
    [sym__external_else] = ACTIONS(7189),
    [sym__external_open_parenthesis] = ACTIONS(7189),
    [sym__external_open_brace] = ACTIONS(7189),
    [sym__external_close_brace] = ACTIONS(7189),
    [sym__external_open_bracket] = ACTIONS(7189),
    [sym__external_close_bracket] = ACTIONS(7189),
    [sym__external_open_bracket2] = ACTIONS(7189),
  },
  [2217] = {
    [sym_identifier] = ACTIONS(7195),
    [anon_sym_BSLASH] = ACTIONS(7193),
    [anon_sym_function] = ACTIONS(7195),
    [anon_sym_EQ] = ACTIONS(7195),
    [anon_sym_if] = ACTIONS(7195),
    [anon_sym_for] = ACTIONS(7195),
    [anon_sym_while] = ACTIONS(7195),
    [anon_sym_repeat] = ACTIONS(7195),
    [anon_sym_QMARK] = ACTIONS(7193),
    [anon_sym_TILDE] = ACTIONS(7193),
    [anon_sym_BANG] = ACTIONS(7195),
    [anon_sym_PLUS] = ACTIONS(7193),
    [anon_sym_DASH] = ACTIONS(7195),
    [anon_sym_LT_DASH] = ACTIONS(7193),
    [anon_sym_LT_LT_DASH] = ACTIONS(7193),
    [anon_sym_COLON_EQ] = ACTIONS(7193),
    [anon_sym_DASH_GT] = ACTIONS(7195),
    [anon_sym_DASH_GT_GT] = ACTIONS(7193),
    [anon_sym_PIPE] = ACTIONS(7195),
    [anon_sym_AMP] = ACTIONS(7195),
    [anon_sym_PIPE_PIPE] = ACTIONS(7193),
    [anon_sym_AMP_AMP] = ACTIONS(7193),
    [anon_sym_LT] = ACTIONS(7195),
    [anon_sym_LT_EQ] = ACTIONS(7193),
    [anon_sym_GT] = ACTIONS(7195),
    [anon_sym_GT_EQ] = ACTIONS(7193),
    [anon_sym_EQ_EQ] = ACTIONS(7193),
    [anon_sym_BANG_EQ] = ACTIONS(7193),
    [anon_sym_STAR] = ACTIONS(7195),
    [anon_sym_SLASH] = ACTIONS(7193),
    [anon_sym_STAR_STAR] = ACTIONS(7193),
    [anon_sym_CARET] = ACTIONS(7193),
    [aux_sym_binary_operator_token1] = ACTIONS(7193),
    [anon_sym_PIPE_GT] = ACTIONS(7193),
    [anon_sym_COLON] = ACTIONS(7195),
    [anon_sym_DOLLAR] = ACTIONS(7193),
    [anon_sym_AT] = ACTIONS(7193),
    [anon_sym_COLON_COLON] = ACTIONS(7195),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7193),
    [aux_sym__hex_literal_token1] = ACTIONS(7193),
    [sym__number_literal] = ACTIONS(7195),
    [anon_sym_SQUOTE] = ACTIONS(7193),
    [anon_sym_DQUOTE] = ACTIONS(7193),
    [sym_return] = ACTIONS(7195),
    [sym_next] = ACTIONS(7195),
    [sym_break] = ACTIONS(7195),
    [sym_true] = ACTIONS(7195),
    [sym_false] = ACTIONS(7195),
    [sym_null] = ACTIONS(7195),
    [sym_inf] = ACTIONS(7195),
    [sym_nan] = ACTIONS(7195),
    [anon_sym_NA] = ACTIONS(7195),
    [anon_sym_NA_integer_] = ACTIONS(7195),
    [anon_sym_NA_real_] = ACTIONS(7195),
    [anon_sym_NA_complex_] = ACTIONS(7195),
    [anon_sym_NA_character_] = ACTIONS(7195),
    [sym_dots] = ACTIONS(7195),
    [sym_dot_dot_i] = ACTIONS(7193),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7193),
    [sym__newline] = ACTIONS(7193),
    [sym__semicolon] = ACTIONS(7193),
    [sym__raw_string_literal] = ACTIONS(7193),
    [sym__external_else] = ACTIONS(7193),
    [sym__external_open_parenthesis] = ACTIONS(7193),
    [sym__external_open_brace] = ACTIONS(7193),
    [sym__external_close_brace] = ACTIONS(7193),
    [sym__external_open_bracket] = ACTIONS(7193),
    [sym__external_close_bracket] = ACTIONS(7193),
    [sym__external_open_bracket2] = ACTIONS(7193),
  },
  [2218] = {
    [sym_identifier] = ACTIONS(7137),
    [anon_sym_BSLASH] = ACTIONS(7139),
    [anon_sym_function] = ACTIONS(7137),
    [anon_sym_EQ] = ACTIONS(7137),
    [anon_sym_if] = ACTIONS(7137),
    [anon_sym_for] = ACTIONS(7137),
    [anon_sym_while] = ACTIONS(7137),
    [anon_sym_repeat] = ACTIONS(7137),
    [anon_sym_QMARK] = ACTIONS(7139),
    [anon_sym_TILDE] = ACTIONS(7139),
    [anon_sym_BANG] = ACTIONS(7137),
    [anon_sym_PLUS] = ACTIONS(7139),
    [anon_sym_DASH] = ACTIONS(7137),
    [anon_sym_LT_DASH] = ACTIONS(7139),
    [anon_sym_LT_LT_DASH] = ACTIONS(7139),
    [anon_sym_COLON_EQ] = ACTIONS(7139),
    [anon_sym_DASH_GT] = ACTIONS(7137),
    [anon_sym_DASH_GT_GT] = ACTIONS(7139),
    [anon_sym_PIPE] = ACTIONS(7137),
    [anon_sym_AMP] = ACTIONS(7137),
    [anon_sym_PIPE_PIPE] = ACTIONS(7139),
    [anon_sym_AMP_AMP] = ACTIONS(7139),
    [anon_sym_LT] = ACTIONS(7137),
    [anon_sym_LT_EQ] = ACTIONS(7139),
    [anon_sym_GT] = ACTIONS(7137),
    [anon_sym_GT_EQ] = ACTIONS(7139),
    [anon_sym_EQ_EQ] = ACTIONS(7139),
    [anon_sym_BANG_EQ] = ACTIONS(7139),
    [anon_sym_STAR] = ACTIONS(7137),
    [anon_sym_SLASH] = ACTIONS(7139),
    [anon_sym_STAR_STAR] = ACTIONS(7139),
    [anon_sym_CARET] = ACTIONS(7139),
    [aux_sym_binary_operator_token1] = ACTIONS(7139),
    [anon_sym_PIPE_GT] = ACTIONS(7139),
    [anon_sym_COLON] = ACTIONS(7137),
    [anon_sym_DOLLAR] = ACTIONS(7139),
    [anon_sym_AT] = ACTIONS(7139),
    [anon_sym_COLON_COLON] = ACTIONS(7137),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7139),
    [aux_sym__hex_literal_token1] = ACTIONS(7139),
    [sym__number_literal] = ACTIONS(7137),
    [anon_sym_SQUOTE] = ACTIONS(7139),
    [anon_sym_DQUOTE] = ACTIONS(7139),
    [sym_return] = ACTIONS(7137),
    [sym_next] = ACTIONS(7137),
    [sym_break] = ACTIONS(7137),
    [sym_true] = ACTIONS(7137),
    [sym_false] = ACTIONS(7137),
    [sym_null] = ACTIONS(7137),
    [sym_inf] = ACTIONS(7137),
    [sym_nan] = ACTIONS(7137),
    [anon_sym_NA] = ACTIONS(7137),
    [anon_sym_NA_integer_] = ACTIONS(7137),
    [anon_sym_NA_real_] = ACTIONS(7137),
    [anon_sym_NA_complex_] = ACTIONS(7137),
    [anon_sym_NA_character_] = ACTIONS(7137),
    [sym_dots] = ACTIONS(7137),
    [sym_dot_dot_i] = ACTIONS(7139),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7139),
    [sym__newline] = ACTIONS(7139),
    [sym__semicolon] = ACTIONS(7139),
    [sym__raw_string_literal] = ACTIONS(7139),
    [sym__external_open_parenthesis] = ACTIONS(7139),
    [sym__external_close_parenthesis] = ACTIONS(7139),
    [sym__external_open_brace] = ACTIONS(7139),
    [sym__external_close_brace] = ACTIONS(7139),
    [sym__external_open_bracket] = ACTIONS(7139),
    [sym__external_open_bracket2] = ACTIONS(7139),
    [sym__external_close_bracket2] = ACTIONS(7139),
  },
  [2219] = {
    [sym_identifier] = ACTIONS(7129),
    [anon_sym_BSLASH] = ACTIONS(7131),
    [anon_sym_function] = ACTIONS(7129),
    [anon_sym_EQ] = ACTIONS(7129),
    [anon_sym_if] = ACTIONS(7129),
    [anon_sym_for] = ACTIONS(7129),
    [anon_sym_while] = ACTIONS(7129),
    [anon_sym_repeat] = ACTIONS(7129),
    [anon_sym_QMARK] = ACTIONS(7131),
    [anon_sym_TILDE] = ACTIONS(7131),
    [anon_sym_BANG] = ACTIONS(7129),
    [anon_sym_PLUS] = ACTIONS(7131),
    [anon_sym_DASH] = ACTIONS(7129),
    [anon_sym_LT_DASH] = ACTIONS(7131),
    [anon_sym_LT_LT_DASH] = ACTIONS(7131),
    [anon_sym_COLON_EQ] = ACTIONS(7131),
    [anon_sym_DASH_GT] = ACTIONS(7129),
    [anon_sym_DASH_GT_GT] = ACTIONS(7131),
    [anon_sym_PIPE] = ACTIONS(7129),
    [anon_sym_AMP] = ACTIONS(7129),
    [anon_sym_PIPE_PIPE] = ACTIONS(7131),
    [anon_sym_AMP_AMP] = ACTIONS(7131),
    [anon_sym_LT] = ACTIONS(7129),
    [anon_sym_LT_EQ] = ACTIONS(7131),
    [anon_sym_GT] = ACTIONS(7129),
    [anon_sym_GT_EQ] = ACTIONS(7131),
    [anon_sym_EQ_EQ] = ACTIONS(7131),
    [anon_sym_BANG_EQ] = ACTIONS(7131),
    [anon_sym_STAR] = ACTIONS(7129),
    [anon_sym_SLASH] = ACTIONS(7131),
    [anon_sym_STAR_STAR] = ACTIONS(7131),
    [anon_sym_CARET] = ACTIONS(7131),
    [aux_sym_binary_operator_token1] = ACTIONS(7131),
    [anon_sym_PIPE_GT] = ACTIONS(7131),
    [anon_sym_COLON] = ACTIONS(7129),
    [anon_sym_DOLLAR] = ACTIONS(7131),
    [anon_sym_AT] = ACTIONS(7131),
    [anon_sym_COLON_COLON] = ACTIONS(7133),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7135),
    [aux_sym__hex_literal_token1] = ACTIONS(7131),
    [sym__number_literal] = ACTIONS(7129),
    [anon_sym_SQUOTE] = ACTIONS(7131),
    [anon_sym_DQUOTE] = ACTIONS(7131),
    [sym_return] = ACTIONS(7129),
    [sym_next] = ACTIONS(7129),
    [sym_break] = ACTIONS(7129),
    [sym_true] = ACTIONS(7129),
    [sym_false] = ACTIONS(7129),
    [sym_null] = ACTIONS(7129),
    [sym_inf] = ACTIONS(7129),
    [sym_nan] = ACTIONS(7129),
    [anon_sym_NA] = ACTIONS(7129),
    [anon_sym_NA_integer_] = ACTIONS(7129),
    [anon_sym_NA_real_] = ACTIONS(7129),
    [anon_sym_NA_complex_] = ACTIONS(7129),
    [anon_sym_NA_character_] = ACTIONS(7129),
    [sym_dots] = ACTIONS(7129),
    [sym_dot_dot_i] = ACTIONS(7131),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7131),
    [sym__newline] = ACTIONS(7131),
    [sym__semicolon] = ACTIONS(7131),
    [sym__raw_string_literal] = ACTIONS(7131),
    [sym__external_open_parenthesis] = ACTIONS(7131),
    [sym__external_close_parenthesis] = ACTIONS(7131),
    [sym__external_open_brace] = ACTIONS(7131),
    [sym__external_close_brace] = ACTIONS(7131),
    [sym__external_open_bracket] = ACTIONS(7131),
    [sym__external_open_bracket2] = ACTIONS(7131),
    [sym__external_close_bracket2] = ACTIONS(7131),
  },
  [2220] = {
    [sym_identifier] = ACTIONS(7121),
    [anon_sym_BSLASH] = ACTIONS(7123),
    [anon_sym_function] = ACTIONS(7121),
    [anon_sym_EQ] = ACTIONS(7121),
    [anon_sym_if] = ACTIONS(7121),
    [anon_sym_for] = ACTIONS(7121),
    [anon_sym_while] = ACTIONS(7121),
    [anon_sym_repeat] = ACTIONS(7121),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_TILDE] = ACTIONS(7123),
    [anon_sym_BANG] = ACTIONS(7121),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_DASH] = ACTIONS(7121),
    [anon_sym_LT_DASH] = ACTIONS(7123),
    [anon_sym_LT_LT_DASH] = ACTIONS(7123),
    [anon_sym_COLON_EQ] = ACTIONS(7123),
    [anon_sym_DASH_GT] = ACTIONS(7121),
    [anon_sym_DASH_GT_GT] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_LT_EQ] = ACTIONS(7123),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
    [aux_sym_binary_operator_token1] = ACTIONS(7123),
    [anon_sym_PIPE_GT] = ACTIONS(7123),
    [anon_sym_COLON] = ACTIONS(7121),
    [anon_sym_DOLLAR] = ACTIONS(7123),
    [anon_sym_AT] = ACTIONS(7123),
    [anon_sym_L] = ACTIONS(7452),
    [anon_sym_i] = ACTIONS(7454),
    [aux_sym__hex_literal_token1] = ACTIONS(7123),
    [sym__number_literal] = ACTIONS(7121),
    [anon_sym_SQUOTE] = ACTIONS(7123),
    [anon_sym_DQUOTE] = ACTIONS(7123),
    [sym_return] = ACTIONS(7121),
    [sym_next] = ACTIONS(7121),
    [sym_break] = ACTIONS(7121),
    [sym_true] = ACTIONS(7121),
    [sym_false] = ACTIONS(7121),
    [sym_null] = ACTIONS(7121),
    [sym_inf] = ACTIONS(7121),
    [sym_nan] = ACTIONS(7121),
    [anon_sym_NA] = ACTIONS(7121),
    [anon_sym_NA_integer_] = ACTIONS(7121),
    [anon_sym_NA_real_] = ACTIONS(7121),
    [anon_sym_NA_complex_] = ACTIONS(7121),
    [anon_sym_NA_character_] = ACTIONS(7121),
    [sym_dots] = ACTIONS(7121),
    [sym_dot_dot_i] = ACTIONS(7123),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7123),
    [sym__newline] = ACTIONS(7123),
    [sym__semicolon] = ACTIONS(7123),
    [sym__raw_string_literal] = ACTIONS(7123),
    [sym__external_open_parenthesis] = ACTIONS(7123),
    [sym__external_close_parenthesis] = ACTIONS(7123),
    [sym__external_open_brace] = ACTIONS(7123),
    [sym__external_close_brace] = ACTIONS(7123),
    [sym__external_open_bracket] = ACTIONS(7123),
    [sym__external_open_bracket2] = ACTIONS(7123),
    [sym__external_close_bracket2] = ACTIONS(7123),
  },
  [2221] = {
    [sym_identifier] = ACTIONS(7115),
    [anon_sym_BSLASH] = ACTIONS(7117),
    [anon_sym_function] = ACTIONS(7115),
    [anon_sym_EQ] = ACTIONS(7115),
    [anon_sym_if] = ACTIONS(7115),
    [anon_sym_for] = ACTIONS(7115),
    [anon_sym_while] = ACTIONS(7115),
    [anon_sym_repeat] = ACTIONS(7115),
    [anon_sym_QMARK] = ACTIONS(7117),
    [anon_sym_TILDE] = ACTIONS(7117),
    [anon_sym_BANG] = ACTIONS(7115),
    [anon_sym_PLUS] = ACTIONS(7117),
    [anon_sym_DASH] = ACTIONS(7115),
    [anon_sym_LT_DASH] = ACTIONS(7117),
    [anon_sym_LT_LT_DASH] = ACTIONS(7117),
    [anon_sym_COLON_EQ] = ACTIONS(7117),
    [anon_sym_DASH_GT] = ACTIONS(7115),
    [anon_sym_DASH_GT_GT] = ACTIONS(7117),
    [anon_sym_PIPE] = ACTIONS(7115),
    [anon_sym_AMP] = ACTIONS(7115),
    [anon_sym_PIPE_PIPE] = ACTIONS(7117),
    [anon_sym_AMP_AMP] = ACTIONS(7117),
    [anon_sym_LT] = ACTIONS(7115),
    [anon_sym_LT_EQ] = ACTIONS(7117),
    [anon_sym_GT] = ACTIONS(7115),
    [anon_sym_GT_EQ] = ACTIONS(7117),
    [anon_sym_EQ_EQ] = ACTIONS(7117),
    [anon_sym_BANG_EQ] = ACTIONS(7117),
    [anon_sym_STAR] = ACTIONS(7115),
    [anon_sym_SLASH] = ACTIONS(7117),
    [anon_sym_STAR_STAR] = ACTIONS(7117),
    [anon_sym_CARET] = ACTIONS(7117),
    [aux_sym_binary_operator_token1] = ACTIONS(7117),
    [anon_sym_PIPE_GT] = ACTIONS(7117),
    [anon_sym_COLON] = ACTIONS(7115),
    [anon_sym_DOLLAR] = ACTIONS(7117),
    [anon_sym_AT] = ACTIONS(7117),
    [anon_sym_COLON_COLON] = ACTIONS(7115),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7117),
    [aux_sym__hex_literal_token1] = ACTIONS(7117),
    [sym__number_literal] = ACTIONS(7115),
    [anon_sym_SQUOTE] = ACTIONS(7117),
    [anon_sym_DQUOTE] = ACTIONS(7117),
    [sym_return] = ACTIONS(7115),
    [sym_next] = ACTIONS(7115),
    [sym_break] = ACTIONS(7115),
    [sym_true] = ACTIONS(7115),
    [sym_false] = ACTIONS(7115),
    [sym_null] = ACTIONS(7115),
    [sym_inf] = ACTIONS(7115),
    [sym_nan] = ACTIONS(7115),
    [anon_sym_NA] = ACTIONS(7115),
    [anon_sym_NA_integer_] = ACTIONS(7115),
    [anon_sym_NA_real_] = ACTIONS(7115),
    [anon_sym_NA_complex_] = ACTIONS(7115),
    [anon_sym_NA_character_] = ACTIONS(7115),
    [sym_dots] = ACTIONS(7115),
    [sym_dot_dot_i] = ACTIONS(7117),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7117),
    [sym__newline] = ACTIONS(7117),
    [sym__semicolon] = ACTIONS(7117),
    [sym__raw_string_literal] = ACTIONS(7117),
    [sym__external_open_parenthesis] = ACTIONS(7117),
    [sym__external_close_parenthesis] = ACTIONS(7117),
    [sym__external_open_brace] = ACTIONS(7117),
    [sym__external_close_brace] = ACTIONS(7117),
    [sym__external_open_bracket] = ACTIONS(7117),
    [sym__external_open_bracket2] = ACTIONS(7117),
    [sym__external_close_bracket2] = ACTIONS(7117),
  },
  [2222] = {
    [sym_identifier] = ACTIONS(7115),
    [anon_sym_BSLASH] = ACTIONS(7117),
    [anon_sym_function] = ACTIONS(7115),
    [anon_sym_EQ] = ACTIONS(7115),
    [anon_sym_if] = ACTIONS(7115),
    [anon_sym_for] = ACTIONS(7115),
    [anon_sym_while] = ACTIONS(7115),
    [anon_sym_repeat] = ACTIONS(7115),
    [anon_sym_QMARK] = ACTIONS(7117),
    [anon_sym_TILDE] = ACTIONS(7117),
    [anon_sym_BANG] = ACTIONS(7115),
    [anon_sym_PLUS] = ACTIONS(7117),
    [anon_sym_DASH] = ACTIONS(7115),
    [anon_sym_LT_DASH] = ACTIONS(7117),
    [anon_sym_LT_LT_DASH] = ACTIONS(7117),
    [anon_sym_COLON_EQ] = ACTIONS(7117),
    [anon_sym_DASH_GT] = ACTIONS(7115),
    [anon_sym_DASH_GT_GT] = ACTIONS(7117),
    [anon_sym_PIPE] = ACTIONS(7115),
    [anon_sym_AMP] = ACTIONS(7115),
    [anon_sym_PIPE_PIPE] = ACTIONS(7117),
    [anon_sym_AMP_AMP] = ACTIONS(7117),
    [anon_sym_LT] = ACTIONS(7115),
    [anon_sym_LT_EQ] = ACTIONS(7117),
    [anon_sym_GT] = ACTIONS(7115),
    [anon_sym_GT_EQ] = ACTIONS(7117),
    [anon_sym_EQ_EQ] = ACTIONS(7117),
    [anon_sym_BANG_EQ] = ACTIONS(7117),
    [anon_sym_STAR] = ACTIONS(7115),
    [anon_sym_SLASH] = ACTIONS(7117),
    [anon_sym_STAR_STAR] = ACTIONS(7117),
    [anon_sym_CARET] = ACTIONS(7117),
    [aux_sym_binary_operator_token1] = ACTIONS(7117),
    [anon_sym_PIPE_GT] = ACTIONS(7117),
    [anon_sym_COLON] = ACTIONS(7115),
    [anon_sym_DOLLAR] = ACTIONS(7117),
    [anon_sym_AT] = ACTIONS(7117),
    [anon_sym_COLON_COLON] = ACTIONS(7115),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7117),
    [aux_sym__hex_literal_token1] = ACTIONS(7117),
    [sym__number_literal] = ACTIONS(7115),
    [anon_sym_SQUOTE] = ACTIONS(7117),
    [anon_sym_DQUOTE] = ACTIONS(7117),
    [sym_return] = ACTIONS(7115),
    [sym_next] = ACTIONS(7115),
    [sym_break] = ACTIONS(7115),
    [sym_true] = ACTIONS(7115),
    [sym_false] = ACTIONS(7115),
    [sym_null] = ACTIONS(7115),
    [sym_inf] = ACTIONS(7115),
    [sym_nan] = ACTIONS(7115),
    [anon_sym_NA] = ACTIONS(7115),
    [anon_sym_NA_integer_] = ACTIONS(7115),
    [anon_sym_NA_real_] = ACTIONS(7115),
    [anon_sym_NA_complex_] = ACTIONS(7115),
    [anon_sym_NA_character_] = ACTIONS(7115),
    [sym_dots] = ACTIONS(7115),
    [sym_dot_dot_i] = ACTIONS(7117),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7117),
    [sym__newline] = ACTIONS(7117),
    [sym__semicolon] = ACTIONS(7117),
    [sym__raw_string_literal] = ACTIONS(7117),
    [sym__external_open_parenthesis] = ACTIONS(7117),
    [sym__external_close_parenthesis] = ACTIONS(7117),
    [sym__external_open_brace] = ACTIONS(7117),
    [sym__external_close_brace] = ACTIONS(7117),
    [sym__external_open_bracket] = ACTIONS(7117),
    [sym__external_open_bracket2] = ACTIONS(7117),
    [sym__external_close_bracket2] = ACTIONS(7117),
  },
  [2223] = {
    [sym_identifier] = ACTIONS(7151),
    [anon_sym_BSLASH] = ACTIONS(7153),
    [anon_sym_function] = ACTIONS(7151),
    [anon_sym_EQ] = ACTIONS(7151),
    [anon_sym_if] = ACTIONS(7151),
    [anon_sym_for] = ACTIONS(7151),
    [anon_sym_while] = ACTIONS(7151),
    [anon_sym_repeat] = ACTIONS(7151),
    [anon_sym_QMARK] = ACTIONS(7153),
    [anon_sym_TILDE] = ACTIONS(7153),
    [anon_sym_BANG] = ACTIONS(7151),
    [anon_sym_PLUS] = ACTIONS(7153),
    [anon_sym_DASH] = ACTIONS(7151),
    [anon_sym_LT_DASH] = ACTIONS(7153),
    [anon_sym_LT_LT_DASH] = ACTIONS(7153),
    [anon_sym_COLON_EQ] = ACTIONS(7153),
    [anon_sym_DASH_GT] = ACTIONS(7151),
    [anon_sym_DASH_GT_GT] = ACTIONS(7153),
    [anon_sym_PIPE] = ACTIONS(7151),
    [anon_sym_AMP] = ACTIONS(7151),
    [anon_sym_PIPE_PIPE] = ACTIONS(7153),
    [anon_sym_AMP_AMP] = ACTIONS(7153),
    [anon_sym_LT] = ACTIONS(7151),
    [anon_sym_LT_EQ] = ACTIONS(7153),
    [anon_sym_GT] = ACTIONS(7151),
    [anon_sym_GT_EQ] = ACTIONS(7153),
    [anon_sym_EQ_EQ] = ACTIONS(7153),
    [anon_sym_BANG_EQ] = ACTIONS(7153),
    [anon_sym_STAR] = ACTIONS(7151),
    [anon_sym_SLASH] = ACTIONS(7153),
    [anon_sym_STAR_STAR] = ACTIONS(7153),
    [anon_sym_CARET] = ACTIONS(7153),
    [aux_sym_binary_operator_token1] = ACTIONS(7153),
    [anon_sym_PIPE_GT] = ACTIONS(7153),
    [anon_sym_COLON] = ACTIONS(7151),
    [anon_sym_DOLLAR] = ACTIONS(7153),
    [anon_sym_AT] = ACTIONS(7153),
    [anon_sym_COLON_COLON] = ACTIONS(7151),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7153),
    [aux_sym__hex_literal_token1] = ACTIONS(7153),
    [sym__number_literal] = ACTIONS(7151),
    [anon_sym_SQUOTE] = ACTIONS(7153),
    [anon_sym_DQUOTE] = ACTIONS(7153),
    [sym_return] = ACTIONS(7151),
    [sym_next] = ACTIONS(7151),
    [sym_break] = ACTIONS(7151),
    [sym_true] = ACTIONS(7151),
    [sym_false] = ACTIONS(7151),
    [sym_null] = ACTIONS(7151),
    [sym_inf] = ACTIONS(7151),
    [sym_nan] = ACTIONS(7151),
    [anon_sym_NA] = ACTIONS(7151),
    [anon_sym_NA_integer_] = ACTIONS(7151),
    [anon_sym_NA_real_] = ACTIONS(7151),
    [anon_sym_NA_complex_] = ACTIONS(7151),
    [anon_sym_NA_character_] = ACTIONS(7151),
    [sym_dots] = ACTIONS(7151),
    [sym_dot_dot_i] = ACTIONS(7153),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7153),
    [sym__newline] = ACTIONS(7153),
    [sym__semicolon] = ACTIONS(7153),
    [sym__raw_string_literal] = ACTIONS(7153),
    [sym__external_else] = ACTIONS(7153),
    [sym__external_open_parenthesis] = ACTIONS(7153),
    [sym__external_open_brace] = ACTIONS(7153),
    [sym__external_close_brace] = ACTIONS(7153),
    [sym__external_open_bracket] = ACTIONS(7153),
    [sym__external_open_bracket2] = ACTIONS(7153),
    [sym__external_close_bracket2] = ACTIONS(7153),
  },
  [2224] = {
    [sym_identifier] = ACTIONS(7163),
    [anon_sym_BSLASH] = ACTIONS(7165),
    [anon_sym_function] = ACTIONS(7163),
    [anon_sym_EQ] = ACTIONS(7163),
    [anon_sym_if] = ACTIONS(7163),
    [anon_sym_for] = ACTIONS(7163),
    [anon_sym_while] = ACTIONS(7163),
    [anon_sym_repeat] = ACTIONS(7163),
    [anon_sym_QMARK] = ACTIONS(7165),
    [anon_sym_TILDE] = ACTIONS(7165),
    [anon_sym_BANG] = ACTIONS(7163),
    [anon_sym_PLUS] = ACTIONS(7165),
    [anon_sym_DASH] = ACTIONS(7163),
    [anon_sym_LT_DASH] = ACTIONS(7165),
    [anon_sym_LT_LT_DASH] = ACTIONS(7165),
    [anon_sym_COLON_EQ] = ACTIONS(7165),
    [anon_sym_DASH_GT] = ACTIONS(7163),
    [anon_sym_DASH_GT_GT] = ACTIONS(7165),
    [anon_sym_PIPE] = ACTIONS(7163),
    [anon_sym_AMP] = ACTIONS(7163),
    [anon_sym_PIPE_PIPE] = ACTIONS(7165),
    [anon_sym_AMP_AMP] = ACTIONS(7165),
    [anon_sym_LT] = ACTIONS(7163),
    [anon_sym_LT_EQ] = ACTIONS(7165),
    [anon_sym_GT] = ACTIONS(7163),
    [anon_sym_GT_EQ] = ACTIONS(7165),
    [anon_sym_EQ_EQ] = ACTIONS(7165),
    [anon_sym_BANG_EQ] = ACTIONS(7165),
    [anon_sym_STAR] = ACTIONS(7163),
    [anon_sym_SLASH] = ACTIONS(7165),
    [anon_sym_STAR_STAR] = ACTIONS(7165),
    [anon_sym_CARET] = ACTIONS(7165),
    [aux_sym_binary_operator_token1] = ACTIONS(7165),
    [anon_sym_PIPE_GT] = ACTIONS(7165),
    [anon_sym_COLON] = ACTIONS(7163),
    [anon_sym_DOLLAR] = ACTIONS(7165),
    [anon_sym_AT] = ACTIONS(7165),
    [anon_sym_COLON_COLON] = ACTIONS(7163),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7165),
    [aux_sym__hex_literal_token1] = ACTIONS(7165),
    [sym__number_literal] = ACTIONS(7163),
    [anon_sym_SQUOTE] = ACTIONS(7165),
    [anon_sym_DQUOTE] = ACTIONS(7165),
    [sym_return] = ACTIONS(7163),
    [sym_next] = ACTIONS(7163),
    [sym_break] = ACTIONS(7163),
    [sym_true] = ACTIONS(7163),
    [sym_false] = ACTIONS(7163),
    [sym_null] = ACTIONS(7163),
    [sym_inf] = ACTIONS(7163),
    [sym_nan] = ACTIONS(7163),
    [anon_sym_NA] = ACTIONS(7163),
    [anon_sym_NA_integer_] = ACTIONS(7163),
    [anon_sym_NA_real_] = ACTIONS(7163),
    [anon_sym_NA_complex_] = ACTIONS(7163),
    [anon_sym_NA_character_] = ACTIONS(7163),
    [sym_dots] = ACTIONS(7163),
    [sym_dot_dot_i] = ACTIONS(7165),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7165),
    [sym__newline] = ACTIONS(7165),
    [sym__semicolon] = ACTIONS(7165),
    [sym__raw_string_literal] = ACTIONS(7165),
    [sym__external_else] = ACTIONS(7165),
    [sym__external_open_parenthesis] = ACTIONS(7165),
    [sym__external_open_brace] = ACTIONS(7165),
    [sym__external_close_brace] = ACTIONS(7165),
    [sym__external_open_bracket] = ACTIONS(7165),
    [sym__external_open_bracket2] = ACTIONS(7165),
    [sym__external_close_bracket2] = ACTIONS(7165),
  },
  [2225] = {
    [sym_string] = STATE(2995),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym__string_or_identifier] = STATE(2995),
    [aux_sym_function_definition_repeat1] = STATE(2901),
    [sym_identifier] = ACTIONS(7456),
    [anon_sym_BSLASH] = ACTIONS(5669),
    [anon_sym_function] = ACTIONS(5673),
    [anon_sym_EQ] = ACTIONS(5673),
    [anon_sym_if] = ACTIONS(5673),
    [anon_sym_for] = ACTIONS(5673),
    [anon_sym_while] = ACTIONS(5673),
    [anon_sym_repeat] = ACTIONS(5673),
    [anon_sym_QMARK] = ACTIONS(5669),
    [anon_sym_TILDE] = ACTIONS(5669),
    [anon_sym_BANG] = ACTIONS(5673),
    [anon_sym_PLUS] = ACTIONS(5669),
    [anon_sym_DASH] = ACTIONS(5673),
    [anon_sym_LT_DASH] = ACTIONS(5669),
    [anon_sym_LT_LT_DASH] = ACTIONS(5669),
    [anon_sym_COLON_EQ] = ACTIONS(5669),
    [anon_sym_DASH_GT] = ACTIONS(5673),
    [anon_sym_DASH_GT_GT] = ACTIONS(5669),
    [anon_sym_PIPE] = ACTIONS(5673),
    [anon_sym_AMP] = ACTIONS(5673),
    [anon_sym_PIPE_PIPE] = ACTIONS(5669),
    [anon_sym_AMP_AMP] = ACTIONS(5669),
    [anon_sym_LT] = ACTIONS(5673),
    [anon_sym_LT_EQ] = ACTIONS(5669),
    [anon_sym_GT] = ACTIONS(5673),
    [anon_sym_GT_EQ] = ACTIONS(5669),
    [anon_sym_EQ_EQ] = ACTIONS(5669),
    [anon_sym_BANG_EQ] = ACTIONS(5669),
    [anon_sym_STAR] = ACTIONS(5673),
    [anon_sym_SLASH] = ACTIONS(5669),
    [anon_sym_STAR_STAR] = ACTIONS(5669),
    [anon_sym_CARET] = ACTIONS(5669),
    [aux_sym_binary_operator_token1] = ACTIONS(5669),
    [anon_sym_PIPE_GT] = ACTIONS(5669),
    [anon_sym_COLON] = ACTIONS(5673),
    [anon_sym_DOLLAR] = ACTIONS(5669),
    [anon_sym_AT] = ACTIONS(5669),
    [aux_sym__hex_literal_token1] = ACTIONS(5669),
    [sym__number_literal] = ACTIONS(5673),
    [anon_sym_SQUOTE] = ACTIONS(4780),
    [anon_sym_DQUOTE] = ACTIONS(4782),
    [sym_return] = ACTIONS(5673),
    [sym_next] = ACTIONS(5673),
    [sym_break] = ACTIONS(5673),
    [sym_true] = ACTIONS(5673),
    [sym_false] = ACTIONS(5673),
    [sym_null] = ACTIONS(5673),
    [sym_inf] = ACTIONS(5673),
    [sym_nan] = ACTIONS(5673),
    [anon_sym_NA] = ACTIONS(5673),
    [anon_sym_NA_integer_] = ACTIONS(5673),
    [anon_sym_NA_real_] = ACTIONS(5673),
    [anon_sym_NA_complex_] = ACTIONS(5673),
    [anon_sym_NA_character_] = ACTIONS(5673),
    [sym_dots] = ACTIONS(5673),
    [sym_dot_dot_i] = ACTIONS(5669),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5669),
    [sym__newline] = ACTIONS(5669),
    [sym__raw_string_literal] = ACTIONS(4790),
    [sym__external_open_parenthesis] = ACTIONS(5669),
    [sym__external_open_brace] = ACTIONS(5669),
    [sym__external_open_bracket] = ACTIONS(5669),
    [sym__external_close_bracket] = ACTIONS(5669),
    [sym__external_open_bracket2] = ACTIONS(5669),
  },
  [2226] = {
    [sym_string] = STATE(2997),
    [sym__single_quoted_string] = STATE(2738),
    [sym__double_quoted_string] = STATE(2737),
    [sym__string_or_identifier] = STATE(2997),
    [aux_sym_function_definition_repeat1] = STATE(2881),
    [ts_builtin_sym_end] = ACTIONS(5669),
    [sym_identifier] = ACTIONS(7458),
    [anon_sym_BSLASH] = ACTIONS(5669),
    [anon_sym_function] = ACTIONS(5673),
    [anon_sym_EQ] = ACTIONS(5673),
    [anon_sym_if] = ACTIONS(5673),
    [anon_sym_for] = ACTIONS(5673),
    [anon_sym_while] = ACTIONS(5673),
    [anon_sym_repeat] = ACTIONS(5673),
    [anon_sym_QMARK] = ACTIONS(5669),
    [anon_sym_TILDE] = ACTIONS(5669),
    [anon_sym_BANG] = ACTIONS(5673),
    [anon_sym_PLUS] = ACTIONS(5669),
    [anon_sym_DASH] = ACTIONS(5673),
    [anon_sym_LT_DASH] = ACTIONS(5669),
    [anon_sym_LT_LT_DASH] = ACTIONS(5669),
    [anon_sym_COLON_EQ] = ACTIONS(5669),
    [anon_sym_DASH_GT] = ACTIONS(5673),
    [anon_sym_DASH_GT_GT] = ACTIONS(5669),
    [anon_sym_PIPE] = ACTIONS(5673),
    [anon_sym_AMP] = ACTIONS(5673),
    [anon_sym_PIPE_PIPE] = ACTIONS(5669),
    [anon_sym_AMP_AMP] = ACTIONS(5669),
    [anon_sym_LT] = ACTIONS(5673),
    [anon_sym_LT_EQ] = ACTIONS(5669),
    [anon_sym_GT] = ACTIONS(5673),
    [anon_sym_GT_EQ] = ACTIONS(5669),
    [anon_sym_EQ_EQ] = ACTIONS(5669),
    [anon_sym_BANG_EQ] = ACTIONS(5669),
    [anon_sym_STAR] = ACTIONS(5673),
    [anon_sym_SLASH] = ACTIONS(5669),
    [anon_sym_STAR_STAR] = ACTIONS(5669),
    [anon_sym_CARET] = ACTIONS(5669),
    [aux_sym_binary_operator_token1] = ACTIONS(5669),
    [anon_sym_PIPE_GT] = ACTIONS(5669),
    [anon_sym_COLON] = ACTIONS(5673),
    [anon_sym_DOLLAR] = ACTIONS(5669),
    [anon_sym_AT] = ACTIONS(5669),
    [aux_sym__hex_literal_token1] = ACTIONS(5669),
    [sym__number_literal] = ACTIONS(5673),
    [anon_sym_SQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE] = ACTIONS(35),
    [sym_return] = ACTIONS(5673),
    [sym_next] = ACTIONS(5673),
    [sym_break] = ACTIONS(5673),
    [sym_true] = ACTIONS(5673),
    [sym_false] = ACTIONS(5673),
    [sym_null] = ACTIONS(5673),
    [sym_inf] = ACTIONS(5673),
    [sym_nan] = ACTIONS(5673),
    [anon_sym_NA] = ACTIONS(5673),
    [anon_sym_NA_integer_] = ACTIONS(5673),
    [anon_sym_NA_real_] = ACTIONS(5673),
    [anon_sym_NA_complex_] = ACTIONS(5673),
    [anon_sym_NA_character_] = ACTIONS(5673),
    [sym_dots] = ACTIONS(5673),
    [sym_dot_dot_i] = ACTIONS(5669),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5669),
    [sym__semicolon] = ACTIONS(5669),
    [sym__raw_string_literal] = ACTIONS(45),
    [sym__external_open_parenthesis] = ACTIONS(5669),
    [sym__external_open_brace] = ACTIONS(5669),
    [sym__external_open_bracket] = ACTIONS(5669),
    [sym__external_open_bracket2] = ACTIONS(5669),
  },
  [2227] = {
    [sym_string] = STATE(2970),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym__string_or_identifier] = STATE(2970),
    [aux_sym_function_definition_repeat1] = STATE(2213),
    [sym_identifier] = ACTIONS(7460),
    [anon_sym_BSLASH] = ACTIONS(5659),
    [anon_sym_function] = ACTIONS(5663),
    [anon_sym_EQ] = ACTIONS(5663),
    [anon_sym_if] = ACTIONS(5663),
    [anon_sym_for] = ACTIONS(5663),
    [anon_sym_while] = ACTIONS(5663),
    [anon_sym_repeat] = ACTIONS(5663),
    [anon_sym_QMARK] = ACTIONS(5659),
    [anon_sym_TILDE] = ACTIONS(5659),
    [anon_sym_BANG] = ACTIONS(5663),
    [anon_sym_PLUS] = ACTIONS(5659),
    [anon_sym_DASH] = ACTIONS(5663),
    [anon_sym_LT_DASH] = ACTIONS(5659),
    [anon_sym_LT_LT_DASH] = ACTIONS(5659),
    [anon_sym_COLON_EQ] = ACTIONS(5659),
    [anon_sym_DASH_GT] = ACTIONS(5663),
    [anon_sym_DASH_GT_GT] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(5663),
    [anon_sym_AMP] = ACTIONS(5663),
    [anon_sym_PIPE_PIPE] = ACTIONS(5659),
    [anon_sym_AMP_AMP] = ACTIONS(5659),
    [anon_sym_LT] = ACTIONS(5663),
    [anon_sym_LT_EQ] = ACTIONS(5659),
    [anon_sym_GT] = ACTIONS(5663),
    [anon_sym_GT_EQ] = ACTIONS(5659),
    [anon_sym_EQ_EQ] = ACTIONS(5659),
    [anon_sym_BANG_EQ] = ACTIONS(5659),
    [anon_sym_STAR] = ACTIONS(5663),
    [anon_sym_SLASH] = ACTIONS(5659),
    [anon_sym_STAR_STAR] = ACTIONS(5659),
    [anon_sym_CARET] = ACTIONS(5659),
    [aux_sym_binary_operator_token1] = ACTIONS(5659),
    [anon_sym_PIPE_GT] = ACTIONS(5659),
    [anon_sym_COLON] = ACTIONS(5663),
    [anon_sym_DOLLAR] = ACTIONS(5659),
    [anon_sym_AT] = ACTIONS(5659),
    [aux_sym__hex_literal_token1] = ACTIONS(5659),
    [sym__number_literal] = ACTIONS(5663),
    [anon_sym_SQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4672),
    [sym_return] = ACTIONS(5663),
    [sym_next] = ACTIONS(5663),
    [sym_break] = ACTIONS(5663),
    [sym_true] = ACTIONS(5663),
    [sym_false] = ACTIONS(5663),
    [sym_null] = ACTIONS(5663),
    [sym_inf] = ACTIONS(5663),
    [sym_nan] = ACTIONS(5663),
    [anon_sym_NA] = ACTIONS(5663),
    [anon_sym_NA_integer_] = ACTIONS(5663),
    [anon_sym_NA_real_] = ACTIONS(5663),
    [anon_sym_NA_complex_] = ACTIONS(5663),
    [anon_sym_NA_character_] = ACTIONS(5663),
    [sym_dots] = ACTIONS(5663),
    [sym_dot_dot_i] = ACTIONS(5659),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5659),
    [sym__newline] = ACTIONS(7462),
    [sym__raw_string_literal] = ACTIONS(4680),
    [sym__external_open_parenthesis] = ACTIONS(5659),
    [sym__external_open_brace] = ACTIONS(5659),
    [sym__external_open_bracket] = ACTIONS(5659),
    [sym__external_open_bracket2] = ACTIONS(5659),
    [sym__external_close_bracket2] = ACTIONS(5659),
  },
  [2228] = {
    [sym_identifier] = ACTIONS(7195),
    [anon_sym_BSLASH] = ACTIONS(7193),
    [anon_sym_function] = ACTIONS(7195),
    [anon_sym_EQ] = ACTIONS(7195),
    [anon_sym_if] = ACTIONS(7195),
    [anon_sym_for] = ACTIONS(7195),
    [anon_sym_while] = ACTIONS(7195),
    [anon_sym_repeat] = ACTIONS(7195),
    [anon_sym_QMARK] = ACTIONS(7193),
    [anon_sym_TILDE] = ACTIONS(7193),
    [anon_sym_BANG] = ACTIONS(7195),
    [anon_sym_PLUS] = ACTIONS(7193),
    [anon_sym_DASH] = ACTIONS(7195),
    [anon_sym_LT_DASH] = ACTIONS(7193),
    [anon_sym_LT_LT_DASH] = ACTIONS(7193),
    [anon_sym_COLON_EQ] = ACTIONS(7193),
    [anon_sym_DASH_GT] = ACTIONS(7195),
    [anon_sym_DASH_GT_GT] = ACTIONS(7193),
    [anon_sym_PIPE] = ACTIONS(7195),
    [anon_sym_AMP] = ACTIONS(7195),
    [anon_sym_PIPE_PIPE] = ACTIONS(7193),
    [anon_sym_AMP_AMP] = ACTIONS(7193),
    [anon_sym_LT] = ACTIONS(7195),
    [anon_sym_LT_EQ] = ACTIONS(7193),
    [anon_sym_GT] = ACTIONS(7195),
    [anon_sym_GT_EQ] = ACTIONS(7193),
    [anon_sym_EQ_EQ] = ACTIONS(7193),
    [anon_sym_BANG_EQ] = ACTIONS(7193),
    [anon_sym_STAR] = ACTIONS(7195),
    [anon_sym_SLASH] = ACTIONS(7193),
    [anon_sym_STAR_STAR] = ACTIONS(7193),
    [anon_sym_CARET] = ACTIONS(7193),
    [aux_sym_binary_operator_token1] = ACTIONS(7193),
    [anon_sym_PIPE_GT] = ACTIONS(7193),
    [anon_sym_COLON] = ACTIONS(7195),
    [anon_sym_DOLLAR] = ACTIONS(7193),
    [anon_sym_AT] = ACTIONS(7193),
    [anon_sym_COLON_COLON] = ACTIONS(7195),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7193),
    [aux_sym__hex_literal_token1] = ACTIONS(7193),
    [sym__number_literal] = ACTIONS(7195),
    [anon_sym_SQUOTE] = ACTIONS(7193),
    [anon_sym_DQUOTE] = ACTIONS(7193),
    [sym_return] = ACTIONS(7195),
    [sym_next] = ACTIONS(7195),
    [sym_break] = ACTIONS(7195),
    [sym_true] = ACTIONS(7195),
    [sym_false] = ACTIONS(7195),
    [sym_null] = ACTIONS(7195),
    [sym_inf] = ACTIONS(7195),
    [sym_nan] = ACTIONS(7195),
    [anon_sym_NA] = ACTIONS(7195),
    [anon_sym_NA_integer_] = ACTIONS(7195),
    [anon_sym_NA_real_] = ACTIONS(7195),
    [anon_sym_NA_complex_] = ACTIONS(7195),
    [anon_sym_NA_character_] = ACTIONS(7195),
    [sym_dots] = ACTIONS(7195),
    [sym_dot_dot_i] = ACTIONS(7193),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7193),
    [sym__newline] = ACTIONS(7193),
    [sym__semicolon] = ACTIONS(7193),
    [sym__raw_string_literal] = ACTIONS(7193),
    [sym__external_else] = ACTIONS(7193),
    [sym__external_open_parenthesis] = ACTIONS(7193),
    [sym__external_open_brace] = ACTIONS(7193),
    [sym__external_close_brace] = ACTIONS(7193),
    [sym__external_open_bracket] = ACTIONS(7193),
    [sym__external_open_bracket2] = ACTIONS(7193),
    [sym__external_close_bracket2] = ACTIONS(7193),
  },
  [2229] = {
    [sym_identifier] = ACTIONS(7151),
    [anon_sym_BSLASH] = ACTIONS(7153),
    [anon_sym_function] = ACTIONS(7151),
    [anon_sym_EQ] = ACTIONS(7151),
    [anon_sym_if] = ACTIONS(7151),
    [anon_sym_for] = ACTIONS(7151),
    [anon_sym_while] = ACTIONS(7151),
    [anon_sym_repeat] = ACTIONS(7151),
    [anon_sym_QMARK] = ACTIONS(7153),
    [anon_sym_TILDE] = ACTIONS(7153),
    [anon_sym_BANG] = ACTIONS(7151),
    [anon_sym_PLUS] = ACTIONS(7153),
    [anon_sym_DASH] = ACTIONS(7151),
    [anon_sym_LT_DASH] = ACTIONS(7153),
    [anon_sym_LT_LT_DASH] = ACTIONS(7153),
    [anon_sym_COLON_EQ] = ACTIONS(7153),
    [anon_sym_DASH_GT] = ACTIONS(7151),
    [anon_sym_DASH_GT_GT] = ACTIONS(7153),
    [anon_sym_PIPE] = ACTIONS(7151),
    [anon_sym_AMP] = ACTIONS(7151),
    [anon_sym_PIPE_PIPE] = ACTIONS(7153),
    [anon_sym_AMP_AMP] = ACTIONS(7153),
    [anon_sym_LT] = ACTIONS(7151),
    [anon_sym_LT_EQ] = ACTIONS(7153),
    [anon_sym_GT] = ACTIONS(7151),
    [anon_sym_GT_EQ] = ACTIONS(7153),
    [anon_sym_EQ_EQ] = ACTIONS(7153),
    [anon_sym_BANG_EQ] = ACTIONS(7153),
    [anon_sym_STAR] = ACTIONS(7151),
    [anon_sym_SLASH] = ACTIONS(7153),
    [anon_sym_STAR_STAR] = ACTIONS(7153),
    [anon_sym_CARET] = ACTIONS(7153),
    [aux_sym_binary_operator_token1] = ACTIONS(7153),
    [anon_sym_PIPE_GT] = ACTIONS(7153),
    [anon_sym_COLON] = ACTIONS(7151),
    [anon_sym_DOLLAR] = ACTIONS(7153),
    [anon_sym_AT] = ACTIONS(7153),
    [anon_sym_COLON_COLON] = ACTIONS(7151),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7153),
    [aux_sym__hex_literal_token1] = ACTIONS(7153),
    [sym__number_literal] = ACTIONS(7151),
    [anon_sym_SQUOTE] = ACTIONS(7153),
    [anon_sym_DQUOTE] = ACTIONS(7153),
    [sym_return] = ACTIONS(7151),
    [sym_next] = ACTIONS(7151),
    [sym_break] = ACTIONS(7151),
    [sym_true] = ACTIONS(7151),
    [sym_false] = ACTIONS(7151),
    [sym_null] = ACTIONS(7151),
    [sym_inf] = ACTIONS(7151),
    [sym_nan] = ACTIONS(7151),
    [anon_sym_NA] = ACTIONS(7151),
    [anon_sym_NA_integer_] = ACTIONS(7151),
    [anon_sym_NA_real_] = ACTIONS(7151),
    [anon_sym_NA_complex_] = ACTIONS(7151),
    [anon_sym_NA_character_] = ACTIONS(7151),
    [sym_dots] = ACTIONS(7151),
    [sym_dot_dot_i] = ACTIONS(7153),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7153),
    [sym__newline] = ACTIONS(7153),
    [sym__semicolon] = ACTIONS(7153),
    [sym__raw_string_literal] = ACTIONS(7153),
    [sym__external_open_parenthesis] = ACTIONS(7153),
    [sym__external_close_parenthesis] = ACTIONS(7153),
    [sym__external_open_brace] = ACTIONS(7153),
    [sym__external_close_brace] = ACTIONS(7153),
    [sym__external_open_bracket] = ACTIONS(7153),
    [sym__external_open_bracket2] = ACTIONS(7153),
    [sym__external_close_bracket2] = ACTIONS(7153),
  },
  [2230] = {
    [sym_identifier] = ACTIONS(7464),
    [anon_sym_BSLASH] = ACTIONS(7466),
    [anon_sym_function] = ACTIONS(7464),
    [anon_sym_EQ] = ACTIONS(7464),
    [anon_sym_if] = ACTIONS(7464),
    [anon_sym_for] = ACTIONS(7464),
    [anon_sym_while] = ACTIONS(7464),
    [anon_sym_repeat] = ACTIONS(7464),
    [anon_sym_QMARK] = ACTIONS(7466),
    [anon_sym_TILDE] = ACTIONS(7466),
    [anon_sym_BANG] = ACTIONS(7464),
    [anon_sym_PLUS] = ACTIONS(7466),
    [anon_sym_DASH] = ACTIONS(7464),
    [anon_sym_LT_DASH] = ACTIONS(7466),
    [anon_sym_LT_LT_DASH] = ACTIONS(7466),
    [anon_sym_COLON_EQ] = ACTIONS(7466),
    [anon_sym_DASH_GT] = ACTIONS(7464),
    [anon_sym_DASH_GT_GT] = ACTIONS(7466),
    [anon_sym_PIPE] = ACTIONS(7464),
    [anon_sym_AMP] = ACTIONS(7464),
    [anon_sym_PIPE_PIPE] = ACTIONS(7466),
    [anon_sym_AMP_AMP] = ACTIONS(7466),
    [anon_sym_LT] = ACTIONS(7464),
    [anon_sym_LT_EQ] = ACTIONS(7466),
    [anon_sym_GT] = ACTIONS(7464),
    [anon_sym_GT_EQ] = ACTIONS(7466),
    [anon_sym_EQ_EQ] = ACTIONS(7466),
    [anon_sym_BANG_EQ] = ACTIONS(7466),
    [anon_sym_STAR] = ACTIONS(7464),
    [anon_sym_SLASH] = ACTIONS(7466),
    [anon_sym_STAR_STAR] = ACTIONS(7466),
    [anon_sym_CARET] = ACTIONS(7466),
    [aux_sym_binary_operator_token1] = ACTIONS(7466),
    [anon_sym_PIPE_GT] = ACTIONS(7466),
    [anon_sym_COLON] = ACTIONS(7464),
    [anon_sym_DOLLAR] = ACTIONS(7466),
    [anon_sym_AT] = ACTIONS(7466),
    [aux_sym__hex_literal_token1] = ACTIONS(7466),
    [sym__number_literal] = ACTIONS(7464),
    [anon_sym_SQUOTE] = ACTIONS(7466),
    [anon_sym_DQUOTE] = ACTIONS(7466),
    [sym_return] = ACTIONS(7464),
    [sym_next] = ACTIONS(7464),
    [sym_break] = ACTIONS(7464),
    [sym_true] = ACTIONS(7464),
    [sym_false] = ACTIONS(7464),
    [sym_null] = ACTIONS(7464),
    [sym_inf] = ACTIONS(7464),
    [sym_nan] = ACTIONS(7464),
    [anon_sym_NA] = ACTIONS(7464),
    [anon_sym_NA_integer_] = ACTIONS(7464),
    [anon_sym_NA_real_] = ACTIONS(7464),
    [anon_sym_NA_complex_] = ACTIONS(7464),
    [anon_sym_NA_character_] = ACTIONS(7464),
    [sym_dots] = ACTIONS(7464),
    [sym_dot_dot_i] = ACTIONS(7466),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7466),
    [sym__newline] = ACTIONS(7466),
    [sym__semicolon] = ACTIONS(7466),
    [sym__raw_string_literal] = ACTIONS(7466),
    [sym__external_else] = ACTIONS(7466),
    [sym__external_open_parenthesis] = ACTIONS(7466),
    [sym__external_close_parenthesis] = ACTIONS(7466),
    [sym__external_open_brace] = ACTIONS(7466),
    [sym__external_close_brace] = ACTIONS(7466),
    [sym__external_open_bracket] = ACTIONS(7466),
    [sym__external_open_bracket2] = ACTIONS(7466),
    [sym__external_close_bracket2] = ACTIONS(7466),
  },
  [2231] = {
    [ts_builtin_sym_end] = ACTIONS(7131),
    [sym_identifier] = ACTIONS(7129),
    [anon_sym_BSLASH] = ACTIONS(7131),
    [anon_sym_function] = ACTIONS(7129),
    [anon_sym_EQ] = ACTIONS(7129),
    [anon_sym_if] = ACTIONS(7129),
    [anon_sym_for] = ACTIONS(7129),
    [anon_sym_while] = ACTIONS(7129),
    [anon_sym_repeat] = ACTIONS(7129),
    [anon_sym_QMARK] = ACTIONS(7131),
    [anon_sym_TILDE] = ACTIONS(7131),
    [anon_sym_BANG] = ACTIONS(7129),
    [anon_sym_PLUS] = ACTIONS(7131),
    [anon_sym_DASH] = ACTIONS(7129),
    [anon_sym_LT_DASH] = ACTIONS(7131),
    [anon_sym_LT_LT_DASH] = ACTIONS(7131),
    [anon_sym_COLON_EQ] = ACTIONS(7131),
    [anon_sym_DASH_GT] = ACTIONS(7129),
    [anon_sym_DASH_GT_GT] = ACTIONS(7131),
    [anon_sym_PIPE] = ACTIONS(7129),
    [anon_sym_AMP] = ACTIONS(7129),
    [anon_sym_PIPE_PIPE] = ACTIONS(7131),
    [anon_sym_AMP_AMP] = ACTIONS(7131),
    [anon_sym_LT] = ACTIONS(7129),
    [anon_sym_LT_EQ] = ACTIONS(7131),
    [anon_sym_GT] = ACTIONS(7129),
    [anon_sym_GT_EQ] = ACTIONS(7131),
    [anon_sym_EQ_EQ] = ACTIONS(7131),
    [anon_sym_BANG_EQ] = ACTIONS(7131),
    [anon_sym_STAR] = ACTIONS(7129),
    [anon_sym_SLASH] = ACTIONS(7131),
    [anon_sym_STAR_STAR] = ACTIONS(7131),
    [anon_sym_CARET] = ACTIONS(7131),
    [aux_sym_binary_operator_token1] = ACTIONS(7131),
    [anon_sym_PIPE_GT] = ACTIONS(7131),
    [anon_sym_COLON] = ACTIONS(7129),
    [anon_sym_DOLLAR] = ACTIONS(7131),
    [anon_sym_AT] = ACTIONS(7131),
    [anon_sym_COLON_COLON] = ACTIONS(7133),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7135),
    [aux_sym__hex_literal_token1] = ACTIONS(7131),
    [sym__number_literal] = ACTIONS(7129),
    [anon_sym_SQUOTE] = ACTIONS(7131),
    [anon_sym_DQUOTE] = ACTIONS(7131),
    [sym_return] = ACTIONS(7129),
    [sym_next] = ACTIONS(7129),
    [sym_break] = ACTIONS(7129),
    [sym_true] = ACTIONS(7129),
    [sym_false] = ACTIONS(7129),
    [sym_null] = ACTIONS(7129),
    [sym_inf] = ACTIONS(7129),
    [sym_nan] = ACTIONS(7129),
    [anon_sym_NA] = ACTIONS(7129),
    [anon_sym_NA_integer_] = ACTIONS(7129),
    [anon_sym_NA_real_] = ACTIONS(7129),
    [anon_sym_NA_complex_] = ACTIONS(7129),
    [anon_sym_NA_character_] = ACTIONS(7129),
    [sym_dots] = ACTIONS(7129),
    [sym_dot_dot_i] = ACTIONS(7131),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7131),
    [sym__semicolon] = ACTIONS(7131),
    [sym__raw_string_literal] = ACTIONS(7131),
    [sym__external_else] = ACTIONS(7131),
    [sym__external_open_parenthesis] = ACTIONS(7131),
    [sym__external_close_parenthesis] = ACTIONS(7131),
    [sym__external_open_brace] = ACTIONS(7131),
    [sym__external_open_bracket] = ACTIONS(7131),
    [sym__external_open_bracket2] = ACTIONS(7131),
  },
  [2232] = {
    [sym_identifier] = ACTIONS(5325),
    [anon_sym_BSLASH] = ACTIONS(5327),
    [anon_sym_function] = ACTIONS(5325),
    [anon_sym_EQ] = ACTIONS(5325),
    [anon_sym_if] = ACTIONS(5325),
    [anon_sym_for] = ACTIONS(5325),
    [anon_sym_while] = ACTIONS(5325),
    [anon_sym_repeat] = ACTIONS(5325),
    [anon_sym_QMARK] = ACTIONS(5327),
    [anon_sym_TILDE] = ACTIONS(5327),
    [anon_sym_BANG] = ACTIONS(5325),
    [anon_sym_PLUS] = ACTIONS(5327),
    [anon_sym_DASH] = ACTIONS(5325),
    [anon_sym_LT_DASH] = ACTIONS(5327),
    [anon_sym_LT_LT_DASH] = ACTIONS(5327),
    [anon_sym_COLON_EQ] = ACTIONS(5327),
    [anon_sym_DASH_GT] = ACTIONS(5325),
    [anon_sym_DASH_GT_GT] = ACTIONS(5327),
    [anon_sym_PIPE] = ACTIONS(5325),
    [anon_sym_AMP] = ACTIONS(5325),
    [anon_sym_PIPE_PIPE] = ACTIONS(5327),
    [anon_sym_AMP_AMP] = ACTIONS(5327),
    [anon_sym_LT] = ACTIONS(5325),
    [anon_sym_LT_EQ] = ACTIONS(5327),
    [anon_sym_GT] = ACTIONS(5325),
    [anon_sym_GT_EQ] = ACTIONS(5327),
    [anon_sym_EQ_EQ] = ACTIONS(5327),
    [anon_sym_BANG_EQ] = ACTIONS(5327),
    [anon_sym_STAR] = ACTIONS(5325),
    [anon_sym_SLASH] = ACTIONS(5327),
    [anon_sym_STAR_STAR] = ACTIONS(5327),
    [anon_sym_CARET] = ACTIONS(5327),
    [aux_sym_binary_operator_token1] = ACTIONS(5327),
    [anon_sym_PIPE_GT] = ACTIONS(5327),
    [anon_sym_COLON] = ACTIONS(5325),
    [anon_sym_DOLLAR] = ACTIONS(5327),
    [anon_sym_AT] = ACTIONS(5327),
    [aux_sym__hex_literal_token1] = ACTIONS(5327),
    [sym__number_literal] = ACTIONS(5325),
    [anon_sym_SQUOTE] = ACTIONS(5327),
    [anon_sym_DQUOTE] = ACTIONS(5327),
    [sym_return] = ACTIONS(5325),
    [sym_next] = ACTIONS(5325),
    [sym_break] = ACTIONS(5325),
    [sym_true] = ACTIONS(5325),
    [sym_false] = ACTIONS(5325),
    [sym_null] = ACTIONS(5325),
    [sym_inf] = ACTIONS(5325),
    [sym_nan] = ACTIONS(5325),
    [anon_sym_NA] = ACTIONS(5325),
    [anon_sym_NA_integer_] = ACTIONS(5325),
    [anon_sym_NA_real_] = ACTIONS(5325),
    [anon_sym_NA_complex_] = ACTIONS(5325),
    [anon_sym_NA_character_] = ACTIONS(5325),
    [sym_dots] = ACTIONS(5325),
    [sym_dot_dot_i] = ACTIONS(5327),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5327),
    [sym__newline] = ACTIONS(5327),
    [sym__semicolon] = ACTIONS(5327),
    [sym__raw_string_literal] = ACTIONS(5327),
    [sym__external_else] = ACTIONS(5327),
    [sym__external_open_parenthesis] = ACTIONS(5327),
    [sym__external_close_parenthesis] = ACTIONS(5327),
    [sym__external_open_brace] = ACTIONS(5327),
    [sym__external_close_brace] = ACTIONS(5327),
    [sym__external_open_bracket] = ACTIONS(5327),
    [sym__external_close_bracket] = ACTIONS(5327),
    [sym__external_open_bracket2] = ACTIONS(5327),
  },
  [2233] = {
    [sym_identifier] = ACTIONS(7137),
    [anon_sym_BSLASH] = ACTIONS(7139),
    [anon_sym_function] = ACTIONS(7137),
    [anon_sym_EQ] = ACTIONS(7137),
    [anon_sym_if] = ACTIONS(7137),
    [anon_sym_for] = ACTIONS(7137),
    [anon_sym_while] = ACTIONS(7137),
    [anon_sym_repeat] = ACTIONS(7137),
    [anon_sym_QMARK] = ACTIONS(7139),
    [anon_sym_TILDE] = ACTIONS(7139),
    [anon_sym_BANG] = ACTIONS(7137),
    [anon_sym_PLUS] = ACTIONS(7139),
    [anon_sym_DASH] = ACTIONS(7137),
    [anon_sym_LT_DASH] = ACTIONS(7139),
    [anon_sym_LT_LT_DASH] = ACTIONS(7139),
    [anon_sym_COLON_EQ] = ACTIONS(7139),
    [anon_sym_DASH_GT] = ACTIONS(7137),
    [anon_sym_DASH_GT_GT] = ACTIONS(7139),
    [anon_sym_PIPE] = ACTIONS(7137),
    [anon_sym_AMP] = ACTIONS(7137),
    [anon_sym_PIPE_PIPE] = ACTIONS(7139),
    [anon_sym_AMP_AMP] = ACTIONS(7139),
    [anon_sym_LT] = ACTIONS(7137),
    [anon_sym_LT_EQ] = ACTIONS(7139),
    [anon_sym_GT] = ACTIONS(7137),
    [anon_sym_GT_EQ] = ACTIONS(7139),
    [anon_sym_EQ_EQ] = ACTIONS(7139),
    [anon_sym_BANG_EQ] = ACTIONS(7139),
    [anon_sym_STAR] = ACTIONS(7137),
    [anon_sym_SLASH] = ACTIONS(7139),
    [anon_sym_STAR_STAR] = ACTIONS(7139),
    [anon_sym_CARET] = ACTIONS(7139),
    [aux_sym_binary_operator_token1] = ACTIONS(7139),
    [anon_sym_PIPE_GT] = ACTIONS(7139),
    [anon_sym_COLON] = ACTIONS(7137),
    [anon_sym_DOLLAR] = ACTIONS(7139),
    [anon_sym_AT] = ACTIONS(7139),
    [anon_sym_COLON_COLON] = ACTIONS(7137),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7139),
    [aux_sym__hex_literal_token1] = ACTIONS(7139),
    [sym__number_literal] = ACTIONS(7137),
    [anon_sym_SQUOTE] = ACTIONS(7139),
    [anon_sym_DQUOTE] = ACTIONS(7139),
    [sym_return] = ACTIONS(7137),
    [sym_next] = ACTIONS(7137),
    [sym_break] = ACTIONS(7137),
    [sym_true] = ACTIONS(7137),
    [sym_false] = ACTIONS(7137),
    [sym_null] = ACTIONS(7137),
    [sym_inf] = ACTIONS(7137),
    [sym_nan] = ACTIONS(7137),
    [anon_sym_NA] = ACTIONS(7137),
    [anon_sym_NA_integer_] = ACTIONS(7137),
    [anon_sym_NA_real_] = ACTIONS(7137),
    [anon_sym_NA_complex_] = ACTIONS(7137),
    [anon_sym_NA_character_] = ACTIONS(7137),
    [sym_dots] = ACTIONS(7137),
    [sym_dot_dot_i] = ACTIONS(7139),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7139),
    [sym__newline] = ACTIONS(7139),
    [sym__semicolon] = ACTIONS(7139),
    [sym__raw_string_literal] = ACTIONS(7139),
    [sym__external_open_parenthesis] = ACTIONS(7139),
    [sym__external_open_brace] = ACTIONS(7139),
    [sym__external_close_brace] = ACTIONS(7139),
    [sym__external_open_bracket] = ACTIONS(7139),
    [sym__external_open_bracket2] = ACTIONS(7139),
    [sym__external_close_bracket2] = ACTIONS(7139),
  },
  [2234] = {
    [sym_identifier] = ACTIONS(7129),
    [anon_sym_BSLASH] = ACTIONS(7131),
    [anon_sym_function] = ACTIONS(7129),
    [anon_sym_EQ] = ACTIONS(7129),
    [anon_sym_if] = ACTIONS(7129),
    [anon_sym_for] = ACTIONS(7129),
    [anon_sym_while] = ACTIONS(7129),
    [anon_sym_repeat] = ACTIONS(7129),
    [anon_sym_QMARK] = ACTIONS(7131),
    [anon_sym_TILDE] = ACTIONS(7131),
    [anon_sym_BANG] = ACTIONS(7129),
    [anon_sym_PLUS] = ACTIONS(7131),
    [anon_sym_DASH] = ACTIONS(7129),
    [anon_sym_LT_DASH] = ACTIONS(7131),
    [anon_sym_LT_LT_DASH] = ACTIONS(7131),
    [anon_sym_COLON_EQ] = ACTIONS(7131),
    [anon_sym_DASH_GT] = ACTIONS(7129),
    [anon_sym_DASH_GT_GT] = ACTIONS(7131),
    [anon_sym_PIPE] = ACTIONS(7129),
    [anon_sym_AMP] = ACTIONS(7129),
    [anon_sym_PIPE_PIPE] = ACTIONS(7131),
    [anon_sym_AMP_AMP] = ACTIONS(7131),
    [anon_sym_LT] = ACTIONS(7129),
    [anon_sym_LT_EQ] = ACTIONS(7131),
    [anon_sym_GT] = ACTIONS(7129),
    [anon_sym_GT_EQ] = ACTIONS(7131),
    [anon_sym_EQ_EQ] = ACTIONS(7131),
    [anon_sym_BANG_EQ] = ACTIONS(7131),
    [anon_sym_STAR] = ACTIONS(7129),
    [anon_sym_SLASH] = ACTIONS(7131),
    [anon_sym_STAR_STAR] = ACTIONS(7131),
    [anon_sym_CARET] = ACTIONS(7131),
    [aux_sym_binary_operator_token1] = ACTIONS(7131),
    [anon_sym_PIPE_GT] = ACTIONS(7131),
    [anon_sym_COLON] = ACTIONS(7129),
    [anon_sym_DOLLAR] = ACTIONS(7131),
    [anon_sym_AT] = ACTIONS(7131),
    [anon_sym_COLON_COLON] = ACTIONS(7133),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7135),
    [aux_sym__hex_literal_token1] = ACTIONS(7131),
    [sym__number_literal] = ACTIONS(7129),
    [anon_sym_SQUOTE] = ACTIONS(7131),
    [anon_sym_DQUOTE] = ACTIONS(7131),
    [sym_return] = ACTIONS(7129),
    [sym_next] = ACTIONS(7129),
    [sym_break] = ACTIONS(7129),
    [sym_true] = ACTIONS(7129),
    [sym_false] = ACTIONS(7129),
    [sym_null] = ACTIONS(7129),
    [sym_inf] = ACTIONS(7129),
    [sym_nan] = ACTIONS(7129),
    [anon_sym_NA] = ACTIONS(7129),
    [anon_sym_NA_integer_] = ACTIONS(7129),
    [anon_sym_NA_real_] = ACTIONS(7129),
    [anon_sym_NA_complex_] = ACTIONS(7129),
    [anon_sym_NA_character_] = ACTIONS(7129),
    [sym_dots] = ACTIONS(7129),
    [sym_dot_dot_i] = ACTIONS(7131),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7131),
    [sym__newline] = ACTIONS(7131),
    [sym__semicolon] = ACTIONS(7131),
    [sym__raw_string_literal] = ACTIONS(7131),
    [sym__external_open_parenthesis] = ACTIONS(7131),
    [sym__external_open_brace] = ACTIONS(7131),
    [sym__external_close_brace] = ACTIONS(7131),
    [sym__external_open_bracket] = ACTIONS(7131),
    [sym__external_open_bracket2] = ACTIONS(7131),
    [sym__external_close_bracket2] = ACTIONS(7131),
  },
  [2235] = {
    [sym_identifier] = ACTIONS(7121),
    [anon_sym_BSLASH] = ACTIONS(7123),
    [anon_sym_function] = ACTIONS(7121),
    [anon_sym_EQ] = ACTIONS(7121),
    [anon_sym_if] = ACTIONS(7121),
    [anon_sym_for] = ACTIONS(7121),
    [anon_sym_while] = ACTIONS(7121),
    [anon_sym_repeat] = ACTIONS(7121),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_TILDE] = ACTIONS(7123),
    [anon_sym_BANG] = ACTIONS(7121),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_DASH] = ACTIONS(7121),
    [anon_sym_LT_DASH] = ACTIONS(7123),
    [anon_sym_LT_LT_DASH] = ACTIONS(7123),
    [anon_sym_COLON_EQ] = ACTIONS(7123),
    [anon_sym_DASH_GT] = ACTIONS(7121),
    [anon_sym_DASH_GT_GT] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_LT_EQ] = ACTIONS(7123),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
    [aux_sym_binary_operator_token1] = ACTIONS(7123),
    [anon_sym_PIPE_GT] = ACTIONS(7123),
    [anon_sym_COLON] = ACTIONS(7121),
    [anon_sym_DOLLAR] = ACTIONS(7123),
    [anon_sym_AT] = ACTIONS(7123),
    [anon_sym_L] = ACTIONS(7468),
    [anon_sym_i] = ACTIONS(7470),
    [aux_sym__hex_literal_token1] = ACTIONS(7123),
    [sym__number_literal] = ACTIONS(7121),
    [anon_sym_SQUOTE] = ACTIONS(7123),
    [anon_sym_DQUOTE] = ACTIONS(7123),
    [sym_return] = ACTIONS(7121),
    [sym_next] = ACTIONS(7121),
    [sym_break] = ACTIONS(7121),
    [sym_true] = ACTIONS(7121),
    [sym_false] = ACTIONS(7121),
    [sym_null] = ACTIONS(7121),
    [sym_inf] = ACTIONS(7121),
    [sym_nan] = ACTIONS(7121),
    [anon_sym_NA] = ACTIONS(7121),
    [anon_sym_NA_integer_] = ACTIONS(7121),
    [anon_sym_NA_real_] = ACTIONS(7121),
    [anon_sym_NA_complex_] = ACTIONS(7121),
    [anon_sym_NA_character_] = ACTIONS(7121),
    [sym_dots] = ACTIONS(7121),
    [sym_dot_dot_i] = ACTIONS(7123),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7123),
    [sym__newline] = ACTIONS(7123),
    [sym__semicolon] = ACTIONS(7123),
    [sym__raw_string_literal] = ACTIONS(7123),
    [sym__external_open_parenthesis] = ACTIONS(7123),
    [sym__external_open_brace] = ACTIONS(7123),
    [sym__external_close_brace] = ACTIONS(7123),
    [sym__external_open_bracket] = ACTIONS(7123),
    [sym__external_open_bracket2] = ACTIONS(7123),
    [sym__external_close_bracket2] = ACTIONS(7123),
  },
  [2236] = {
    [sym_identifier] = ACTIONS(7115),
    [anon_sym_BSLASH] = ACTIONS(7117),
    [anon_sym_function] = ACTIONS(7115),
    [anon_sym_EQ] = ACTIONS(7115),
    [anon_sym_if] = ACTIONS(7115),
    [anon_sym_for] = ACTIONS(7115),
    [anon_sym_while] = ACTIONS(7115),
    [anon_sym_repeat] = ACTIONS(7115),
    [anon_sym_QMARK] = ACTIONS(7117),
    [anon_sym_TILDE] = ACTIONS(7117),
    [anon_sym_BANG] = ACTIONS(7115),
    [anon_sym_PLUS] = ACTIONS(7117),
    [anon_sym_DASH] = ACTIONS(7115),
    [anon_sym_LT_DASH] = ACTIONS(7117),
    [anon_sym_LT_LT_DASH] = ACTIONS(7117),
    [anon_sym_COLON_EQ] = ACTIONS(7117),
    [anon_sym_DASH_GT] = ACTIONS(7115),
    [anon_sym_DASH_GT_GT] = ACTIONS(7117),
    [anon_sym_PIPE] = ACTIONS(7115),
    [anon_sym_AMP] = ACTIONS(7115),
    [anon_sym_PIPE_PIPE] = ACTIONS(7117),
    [anon_sym_AMP_AMP] = ACTIONS(7117),
    [anon_sym_LT] = ACTIONS(7115),
    [anon_sym_LT_EQ] = ACTIONS(7117),
    [anon_sym_GT] = ACTIONS(7115),
    [anon_sym_GT_EQ] = ACTIONS(7117),
    [anon_sym_EQ_EQ] = ACTIONS(7117),
    [anon_sym_BANG_EQ] = ACTIONS(7117),
    [anon_sym_STAR] = ACTIONS(7115),
    [anon_sym_SLASH] = ACTIONS(7117),
    [anon_sym_STAR_STAR] = ACTIONS(7117),
    [anon_sym_CARET] = ACTIONS(7117),
    [aux_sym_binary_operator_token1] = ACTIONS(7117),
    [anon_sym_PIPE_GT] = ACTIONS(7117),
    [anon_sym_COLON] = ACTIONS(7115),
    [anon_sym_DOLLAR] = ACTIONS(7117),
    [anon_sym_AT] = ACTIONS(7117),
    [anon_sym_COLON_COLON] = ACTIONS(7115),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7117),
    [aux_sym__hex_literal_token1] = ACTIONS(7117),
    [sym__number_literal] = ACTIONS(7115),
    [anon_sym_SQUOTE] = ACTIONS(7117),
    [anon_sym_DQUOTE] = ACTIONS(7117),
    [sym_return] = ACTIONS(7115),
    [sym_next] = ACTIONS(7115),
    [sym_break] = ACTIONS(7115),
    [sym_true] = ACTIONS(7115),
    [sym_false] = ACTIONS(7115),
    [sym_null] = ACTIONS(7115),
    [sym_inf] = ACTIONS(7115),
    [sym_nan] = ACTIONS(7115),
    [anon_sym_NA] = ACTIONS(7115),
    [anon_sym_NA_integer_] = ACTIONS(7115),
    [anon_sym_NA_real_] = ACTIONS(7115),
    [anon_sym_NA_complex_] = ACTIONS(7115),
    [anon_sym_NA_character_] = ACTIONS(7115),
    [sym_dots] = ACTIONS(7115),
    [sym_dot_dot_i] = ACTIONS(7117),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7117),
    [sym__newline] = ACTIONS(7117),
    [sym__semicolon] = ACTIONS(7117),
    [sym__raw_string_literal] = ACTIONS(7117),
    [sym__external_open_parenthesis] = ACTIONS(7117),
    [sym__external_open_brace] = ACTIONS(7117),
    [sym__external_close_brace] = ACTIONS(7117),
    [sym__external_open_bracket] = ACTIONS(7117),
    [sym__external_open_bracket2] = ACTIONS(7117),
    [sym__external_close_bracket2] = ACTIONS(7117),
  },
  [2237] = {
    [sym_identifier] = ACTIONS(7115),
    [anon_sym_BSLASH] = ACTIONS(7117),
    [anon_sym_function] = ACTIONS(7115),
    [anon_sym_EQ] = ACTIONS(7115),
    [anon_sym_if] = ACTIONS(7115),
    [anon_sym_for] = ACTIONS(7115),
    [anon_sym_while] = ACTIONS(7115),
    [anon_sym_repeat] = ACTIONS(7115),
    [anon_sym_QMARK] = ACTIONS(7117),
    [anon_sym_TILDE] = ACTIONS(7117),
    [anon_sym_BANG] = ACTIONS(7115),
    [anon_sym_PLUS] = ACTIONS(7117),
    [anon_sym_DASH] = ACTIONS(7115),
    [anon_sym_LT_DASH] = ACTIONS(7117),
    [anon_sym_LT_LT_DASH] = ACTIONS(7117),
    [anon_sym_COLON_EQ] = ACTIONS(7117),
    [anon_sym_DASH_GT] = ACTIONS(7115),
    [anon_sym_DASH_GT_GT] = ACTIONS(7117),
    [anon_sym_PIPE] = ACTIONS(7115),
    [anon_sym_AMP] = ACTIONS(7115),
    [anon_sym_PIPE_PIPE] = ACTIONS(7117),
    [anon_sym_AMP_AMP] = ACTIONS(7117),
    [anon_sym_LT] = ACTIONS(7115),
    [anon_sym_LT_EQ] = ACTIONS(7117),
    [anon_sym_GT] = ACTIONS(7115),
    [anon_sym_GT_EQ] = ACTIONS(7117),
    [anon_sym_EQ_EQ] = ACTIONS(7117),
    [anon_sym_BANG_EQ] = ACTIONS(7117),
    [anon_sym_STAR] = ACTIONS(7115),
    [anon_sym_SLASH] = ACTIONS(7117),
    [anon_sym_STAR_STAR] = ACTIONS(7117),
    [anon_sym_CARET] = ACTIONS(7117),
    [aux_sym_binary_operator_token1] = ACTIONS(7117),
    [anon_sym_PIPE_GT] = ACTIONS(7117),
    [anon_sym_COLON] = ACTIONS(7115),
    [anon_sym_DOLLAR] = ACTIONS(7117),
    [anon_sym_AT] = ACTIONS(7117),
    [anon_sym_COLON_COLON] = ACTIONS(7115),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7117),
    [aux_sym__hex_literal_token1] = ACTIONS(7117),
    [sym__number_literal] = ACTIONS(7115),
    [anon_sym_SQUOTE] = ACTIONS(7117),
    [anon_sym_DQUOTE] = ACTIONS(7117),
    [sym_return] = ACTIONS(7115),
    [sym_next] = ACTIONS(7115),
    [sym_break] = ACTIONS(7115),
    [sym_true] = ACTIONS(7115),
    [sym_false] = ACTIONS(7115),
    [sym_null] = ACTIONS(7115),
    [sym_inf] = ACTIONS(7115),
    [sym_nan] = ACTIONS(7115),
    [anon_sym_NA] = ACTIONS(7115),
    [anon_sym_NA_integer_] = ACTIONS(7115),
    [anon_sym_NA_real_] = ACTIONS(7115),
    [anon_sym_NA_complex_] = ACTIONS(7115),
    [anon_sym_NA_character_] = ACTIONS(7115),
    [sym_dots] = ACTIONS(7115),
    [sym_dot_dot_i] = ACTIONS(7117),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7117),
    [sym__newline] = ACTIONS(7117),
    [sym__semicolon] = ACTIONS(7117),
    [sym__raw_string_literal] = ACTIONS(7117),
    [sym__external_open_parenthesis] = ACTIONS(7117),
    [sym__external_open_brace] = ACTIONS(7117),
    [sym__external_close_brace] = ACTIONS(7117),
    [sym__external_open_bracket] = ACTIONS(7117),
    [sym__external_open_bracket2] = ACTIONS(7117),
    [sym__external_close_bracket2] = ACTIONS(7117),
  },
  [2238] = {
    [sym_identifier] = ACTIONS(7151),
    [anon_sym_BSLASH] = ACTIONS(7153),
    [anon_sym_function] = ACTIONS(7151),
    [anon_sym_EQ] = ACTIONS(7151),
    [anon_sym_if] = ACTIONS(7151),
    [anon_sym_for] = ACTIONS(7151),
    [anon_sym_while] = ACTIONS(7151),
    [anon_sym_repeat] = ACTIONS(7151),
    [anon_sym_QMARK] = ACTIONS(7153),
    [anon_sym_TILDE] = ACTIONS(7153),
    [anon_sym_BANG] = ACTIONS(7151),
    [anon_sym_PLUS] = ACTIONS(7153),
    [anon_sym_DASH] = ACTIONS(7151),
    [anon_sym_LT_DASH] = ACTIONS(7153),
    [anon_sym_LT_LT_DASH] = ACTIONS(7153),
    [anon_sym_COLON_EQ] = ACTIONS(7153),
    [anon_sym_DASH_GT] = ACTIONS(7151),
    [anon_sym_DASH_GT_GT] = ACTIONS(7153),
    [anon_sym_PIPE] = ACTIONS(7151),
    [anon_sym_AMP] = ACTIONS(7151),
    [anon_sym_PIPE_PIPE] = ACTIONS(7153),
    [anon_sym_AMP_AMP] = ACTIONS(7153),
    [anon_sym_LT] = ACTIONS(7151),
    [anon_sym_LT_EQ] = ACTIONS(7153),
    [anon_sym_GT] = ACTIONS(7151),
    [anon_sym_GT_EQ] = ACTIONS(7153),
    [anon_sym_EQ_EQ] = ACTIONS(7153),
    [anon_sym_BANG_EQ] = ACTIONS(7153),
    [anon_sym_STAR] = ACTIONS(7151),
    [anon_sym_SLASH] = ACTIONS(7153),
    [anon_sym_STAR_STAR] = ACTIONS(7153),
    [anon_sym_CARET] = ACTIONS(7153),
    [aux_sym_binary_operator_token1] = ACTIONS(7153),
    [anon_sym_PIPE_GT] = ACTIONS(7153),
    [anon_sym_COLON] = ACTIONS(7151),
    [anon_sym_DOLLAR] = ACTIONS(7153),
    [anon_sym_AT] = ACTIONS(7153),
    [anon_sym_COLON_COLON] = ACTIONS(7151),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7153),
    [aux_sym__hex_literal_token1] = ACTIONS(7153),
    [sym__number_literal] = ACTIONS(7151),
    [anon_sym_SQUOTE] = ACTIONS(7153),
    [anon_sym_DQUOTE] = ACTIONS(7153),
    [sym_return] = ACTIONS(7151),
    [sym_next] = ACTIONS(7151),
    [sym_break] = ACTIONS(7151),
    [sym_true] = ACTIONS(7151),
    [sym_false] = ACTIONS(7151),
    [sym_null] = ACTIONS(7151),
    [sym_inf] = ACTIONS(7151),
    [sym_nan] = ACTIONS(7151),
    [anon_sym_NA] = ACTIONS(7151),
    [anon_sym_NA_integer_] = ACTIONS(7151),
    [anon_sym_NA_real_] = ACTIONS(7151),
    [anon_sym_NA_complex_] = ACTIONS(7151),
    [anon_sym_NA_character_] = ACTIONS(7151),
    [sym_dots] = ACTIONS(7151),
    [sym_dot_dot_i] = ACTIONS(7153),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7153),
    [sym__newline] = ACTIONS(7153),
    [sym__semicolon] = ACTIONS(7153),
    [sym__raw_string_literal] = ACTIONS(7153),
    [sym__external_open_parenthesis] = ACTIONS(7153),
    [sym__external_open_brace] = ACTIONS(7153),
    [sym__external_close_brace] = ACTIONS(7153),
    [sym__external_open_bracket] = ACTIONS(7153),
    [sym__external_open_bracket2] = ACTIONS(7153),
    [sym__external_close_bracket2] = ACTIONS(7153),
  },
  [2239] = {
    [sym_identifier] = ACTIONS(7163),
    [anon_sym_BSLASH] = ACTIONS(7165),
    [anon_sym_function] = ACTIONS(7163),
    [anon_sym_EQ] = ACTIONS(7163),
    [anon_sym_if] = ACTIONS(7163),
    [anon_sym_for] = ACTIONS(7163),
    [anon_sym_while] = ACTIONS(7163),
    [anon_sym_repeat] = ACTIONS(7163),
    [anon_sym_QMARK] = ACTIONS(7165),
    [anon_sym_TILDE] = ACTIONS(7165),
    [anon_sym_BANG] = ACTIONS(7163),
    [anon_sym_PLUS] = ACTIONS(7165),
    [anon_sym_DASH] = ACTIONS(7163),
    [anon_sym_LT_DASH] = ACTIONS(7165),
    [anon_sym_LT_LT_DASH] = ACTIONS(7165),
    [anon_sym_COLON_EQ] = ACTIONS(7165),
    [anon_sym_DASH_GT] = ACTIONS(7163),
    [anon_sym_DASH_GT_GT] = ACTIONS(7165),
    [anon_sym_PIPE] = ACTIONS(7163),
    [anon_sym_AMP] = ACTIONS(7163),
    [anon_sym_PIPE_PIPE] = ACTIONS(7165),
    [anon_sym_AMP_AMP] = ACTIONS(7165),
    [anon_sym_LT] = ACTIONS(7163),
    [anon_sym_LT_EQ] = ACTIONS(7165),
    [anon_sym_GT] = ACTIONS(7163),
    [anon_sym_GT_EQ] = ACTIONS(7165),
    [anon_sym_EQ_EQ] = ACTIONS(7165),
    [anon_sym_BANG_EQ] = ACTIONS(7165),
    [anon_sym_STAR] = ACTIONS(7163),
    [anon_sym_SLASH] = ACTIONS(7165),
    [anon_sym_STAR_STAR] = ACTIONS(7165),
    [anon_sym_CARET] = ACTIONS(7165),
    [aux_sym_binary_operator_token1] = ACTIONS(7165),
    [anon_sym_PIPE_GT] = ACTIONS(7165),
    [anon_sym_COLON] = ACTIONS(7163),
    [anon_sym_DOLLAR] = ACTIONS(7165),
    [anon_sym_AT] = ACTIONS(7165),
    [anon_sym_COLON_COLON] = ACTIONS(7163),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7165),
    [aux_sym__hex_literal_token1] = ACTIONS(7165),
    [sym__number_literal] = ACTIONS(7163),
    [anon_sym_SQUOTE] = ACTIONS(7165),
    [anon_sym_DQUOTE] = ACTIONS(7165),
    [sym_return] = ACTIONS(7163),
    [sym_next] = ACTIONS(7163),
    [sym_break] = ACTIONS(7163),
    [sym_true] = ACTIONS(7163),
    [sym_false] = ACTIONS(7163),
    [sym_null] = ACTIONS(7163),
    [sym_inf] = ACTIONS(7163),
    [sym_nan] = ACTIONS(7163),
    [anon_sym_NA] = ACTIONS(7163),
    [anon_sym_NA_integer_] = ACTIONS(7163),
    [anon_sym_NA_real_] = ACTIONS(7163),
    [anon_sym_NA_complex_] = ACTIONS(7163),
    [anon_sym_NA_character_] = ACTIONS(7163),
    [sym_dots] = ACTIONS(7163),
    [sym_dot_dot_i] = ACTIONS(7165),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7165),
    [sym__newline] = ACTIONS(7165),
    [sym__semicolon] = ACTIONS(7165),
    [sym__raw_string_literal] = ACTIONS(7165),
    [sym__external_open_parenthesis] = ACTIONS(7165),
    [sym__external_open_brace] = ACTIONS(7165),
    [sym__external_close_brace] = ACTIONS(7165),
    [sym__external_open_bracket] = ACTIONS(7165),
    [sym__external_open_bracket2] = ACTIONS(7165),
    [sym__external_close_bracket2] = ACTIONS(7165),
  },
  [2240] = {
    [ts_builtin_sym_end] = ACTIONS(7472),
    [sym_identifier] = ACTIONS(7474),
    [anon_sym_BSLASH] = ACTIONS(7472),
    [anon_sym_function] = ACTIONS(7474),
    [anon_sym_EQ] = ACTIONS(7474),
    [anon_sym_if] = ACTIONS(7474),
    [anon_sym_for] = ACTIONS(7474),
    [anon_sym_while] = ACTIONS(7474),
    [anon_sym_repeat] = ACTIONS(7474),
    [anon_sym_QMARK] = ACTIONS(7472),
    [anon_sym_TILDE] = ACTIONS(7472),
    [anon_sym_BANG] = ACTIONS(7474),
    [anon_sym_PLUS] = ACTIONS(7472),
    [anon_sym_DASH] = ACTIONS(7474),
    [anon_sym_LT_DASH] = ACTIONS(7472),
    [anon_sym_LT_LT_DASH] = ACTIONS(7472),
    [anon_sym_COLON_EQ] = ACTIONS(7472),
    [anon_sym_DASH_GT] = ACTIONS(7474),
    [anon_sym_DASH_GT_GT] = ACTIONS(7472),
    [anon_sym_PIPE] = ACTIONS(7474),
    [anon_sym_AMP] = ACTIONS(7474),
    [anon_sym_PIPE_PIPE] = ACTIONS(7472),
    [anon_sym_AMP_AMP] = ACTIONS(7472),
    [anon_sym_LT] = ACTIONS(7474),
    [anon_sym_LT_EQ] = ACTIONS(7472),
    [anon_sym_GT] = ACTIONS(7474),
    [anon_sym_GT_EQ] = ACTIONS(7472),
    [anon_sym_EQ_EQ] = ACTIONS(7472),
    [anon_sym_BANG_EQ] = ACTIONS(7472),
    [anon_sym_STAR] = ACTIONS(7474),
    [anon_sym_SLASH] = ACTIONS(7472),
    [anon_sym_STAR_STAR] = ACTIONS(7472),
    [anon_sym_CARET] = ACTIONS(7472),
    [aux_sym_binary_operator_token1] = ACTIONS(7472),
    [anon_sym_PIPE_GT] = ACTIONS(7472),
    [anon_sym_COLON] = ACTIONS(7474),
    [anon_sym_DOLLAR] = ACTIONS(7472),
    [anon_sym_AT] = ACTIONS(7472),
    [aux_sym__hex_literal_token1] = ACTIONS(7472),
    [sym__number_literal] = ACTIONS(7474),
    [anon_sym_SQUOTE] = ACTIONS(7472),
    [anon_sym_DQUOTE] = ACTIONS(7472),
    [sym_return] = ACTIONS(7474),
    [sym_next] = ACTIONS(7474),
    [sym_break] = ACTIONS(7474),
    [sym_true] = ACTIONS(7474),
    [sym_false] = ACTIONS(7474),
    [sym_null] = ACTIONS(7474),
    [sym_inf] = ACTIONS(7474),
    [sym_nan] = ACTIONS(7474),
    [anon_sym_NA] = ACTIONS(7474),
    [anon_sym_NA_integer_] = ACTIONS(7474),
    [anon_sym_NA_real_] = ACTIONS(7474),
    [anon_sym_NA_complex_] = ACTIONS(7474),
    [anon_sym_NA_character_] = ACTIONS(7474),
    [sym_dots] = ACTIONS(7474),
    [sym_dot_dot_i] = ACTIONS(7472),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7472),
    [sym__newline] = ACTIONS(7472),
    [sym__semicolon] = ACTIONS(7472),
    [sym__raw_string_literal] = ACTIONS(7472),
    [sym__external_else] = ACTIONS(7472),
    [sym__external_open_parenthesis] = ACTIONS(7472),
    [sym__external_close_parenthesis] = ACTIONS(7472),
    [sym__external_open_brace] = ACTIONS(7472),
    [sym__external_close_brace] = ACTIONS(7472),
    [sym__external_open_bracket] = ACTIONS(7472),
    [sym__external_open_bracket2] = ACTIONS(7472),
  },
  [2241] = {
    [ts_builtin_sym_end] = ACTIONS(7466),
    [sym_identifier] = ACTIONS(7464),
    [anon_sym_BSLASH] = ACTIONS(7466),
    [anon_sym_function] = ACTIONS(7464),
    [anon_sym_EQ] = ACTIONS(7464),
    [anon_sym_if] = ACTIONS(7464),
    [anon_sym_for] = ACTIONS(7464),
    [anon_sym_while] = ACTIONS(7464),
    [anon_sym_repeat] = ACTIONS(7464),
    [anon_sym_QMARK] = ACTIONS(7466),
    [anon_sym_TILDE] = ACTIONS(7466),
    [anon_sym_BANG] = ACTIONS(7464),
    [anon_sym_PLUS] = ACTIONS(7466),
    [anon_sym_DASH] = ACTIONS(7464),
    [anon_sym_LT_DASH] = ACTIONS(7466),
    [anon_sym_LT_LT_DASH] = ACTIONS(7466),
    [anon_sym_COLON_EQ] = ACTIONS(7466),
    [anon_sym_DASH_GT] = ACTIONS(7464),
    [anon_sym_DASH_GT_GT] = ACTIONS(7466),
    [anon_sym_PIPE] = ACTIONS(7464),
    [anon_sym_AMP] = ACTIONS(7464),
    [anon_sym_PIPE_PIPE] = ACTIONS(7466),
    [anon_sym_AMP_AMP] = ACTIONS(7466),
    [anon_sym_LT] = ACTIONS(7464),
    [anon_sym_LT_EQ] = ACTIONS(7466),
    [anon_sym_GT] = ACTIONS(7464),
    [anon_sym_GT_EQ] = ACTIONS(7466),
    [anon_sym_EQ_EQ] = ACTIONS(7466),
    [anon_sym_BANG_EQ] = ACTIONS(7466),
    [anon_sym_STAR] = ACTIONS(7464),
    [anon_sym_SLASH] = ACTIONS(7466),
    [anon_sym_STAR_STAR] = ACTIONS(7466),
    [anon_sym_CARET] = ACTIONS(7466),
    [aux_sym_binary_operator_token1] = ACTIONS(7466),
    [anon_sym_PIPE_GT] = ACTIONS(7466),
    [anon_sym_COLON] = ACTIONS(7464),
    [anon_sym_DOLLAR] = ACTIONS(7466),
    [anon_sym_AT] = ACTIONS(7466),
    [aux_sym__hex_literal_token1] = ACTIONS(7466),
    [sym__number_literal] = ACTIONS(7464),
    [anon_sym_SQUOTE] = ACTIONS(7466),
    [anon_sym_DQUOTE] = ACTIONS(7466),
    [sym_return] = ACTIONS(7464),
    [sym_next] = ACTIONS(7464),
    [sym_break] = ACTIONS(7464),
    [sym_true] = ACTIONS(7464),
    [sym_false] = ACTIONS(7464),
    [sym_null] = ACTIONS(7464),
    [sym_inf] = ACTIONS(7464),
    [sym_nan] = ACTIONS(7464),
    [anon_sym_NA] = ACTIONS(7464),
    [anon_sym_NA_integer_] = ACTIONS(7464),
    [anon_sym_NA_real_] = ACTIONS(7464),
    [anon_sym_NA_complex_] = ACTIONS(7464),
    [anon_sym_NA_character_] = ACTIONS(7464),
    [sym_dots] = ACTIONS(7464),
    [sym_dot_dot_i] = ACTIONS(7466),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7466),
    [sym__newline] = ACTIONS(7466),
    [sym__semicolon] = ACTIONS(7466),
    [sym__raw_string_literal] = ACTIONS(7466),
    [sym__external_else] = ACTIONS(7466),
    [sym__external_open_parenthesis] = ACTIONS(7466),
    [sym__external_close_parenthesis] = ACTIONS(7466),
    [sym__external_open_brace] = ACTIONS(7466),
    [sym__external_close_brace] = ACTIONS(7466),
    [sym__external_open_bracket] = ACTIONS(7466),
    [sym__external_open_bracket2] = ACTIONS(7466),
  },
  [2242] = {
    [ts_builtin_sym_end] = ACTIONS(7476),
    [sym_identifier] = ACTIONS(7478),
    [anon_sym_BSLASH] = ACTIONS(7476),
    [anon_sym_function] = ACTIONS(7478),
    [anon_sym_EQ] = ACTIONS(7478),
    [anon_sym_if] = ACTIONS(7478),
    [anon_sym_for] = ACTIONS(7478),
    [anon_sym_while] = ACTIONS(7478),
    [anon_sym_repeat] = ACTIONS(7478),
    [anon_sym_QMARK] = ACTIONS(7476),
    [anon_sym_TILDE] = ACTIONS(7476),
    [anon_sym_BANG] = ACTIONS(7478),
    [anon_sym_PLUS] = ACTIONS(7476),
    [anon_sym_DASH] = ACTIONS(7478),
    [anon_sym_LT_DASH] = ACTIONS(7476),
    [anon_sym_LT_LT_DASH] = ACTIONS(7476),
    [anon_sym_COLON_EQ] = ACTIONS(7476),
    [anon_sym_DASH_GT] = ACTIONS(7478),
    [anon_sym_DASH_GT_GT] = ACTIONS(7476),
    [anon_sym_PIPE] = ACTIONS(7478),
    [anon_sym_AMP] = ACTIONS(7478),
    [anon_sym_PIPE_PIPE] = ACTIONS(7476),
    [anon_sym_AMP_AMP] = ACTIONS(7476),
    [anon_sym_LT] = ACTIONS(7478),
    [anon_sym_LT_EQ] = ACTIONS(7476),
    [anon_sym_GT] = ACTIONS(7478),
    [anon_sym_GT_EQ] = ACTIONS(7476),
    [anon_sym_EQ_EQ] = ACTIONS(7476),
    [anon_sym_BANG_EQ] = ACTIONS(7476),
    [anon_sym_STAR] = ACTIONS(7478),
    [anon_sym_SLASH] = ACTIONS(7476),
    [anon_sym_STAR_STAR] = ACTIONS(7476),
    [anon_sym_CARET] = ACTIONS(7476),
    [aux_sym_binary_operator_token1] = ACTIONS(7476),
    [anon_sym_PIPE_GT] = ACTIONS(7476),
    [anon_sym_COLON] = ACTIONS(7478),
    [anon_sym_DOLLAR] = ACTIONS(7476),
    [anon_sym_AT] = ACTIONS(7476),
    [aux_sym__hex_literal_token1] = ACTIONS(7476),
    [sym__number_literal] = ACTIONS(7478),
    [anon_sym_SQUOTE] = ACTIONS(7476),
    [anon_sym_DQUOTE] = ACTIONS(7476),
    [sym_return] = ACTIONS(7478),
    [sym_next] = ACTIONS(7478),
    [sym_break] = ACTIONS(7478),
    [sym_true] = ACTIONS(7478),
    [sym_false] = ACTIONS(7478),
    [sym_null] = ACTIONS(7478),
    [sym_inf] = ACTIONS(7478),
    [sym_nan] = ACTIONS(7478),
    [anon_sym_NA] = ACTIONS(7478),
    [anon_sym_NA_integer_] = ACTIONS(7478),
    [anon_sym_NA_real_] = ACTIONS(7478),
    [anon_sym_NA_complex_] = ACTIONS(7478),
    [anon_sym_NA_character_] = ACTIONS(7478),
    [sym_dots] = ACTIONS(7478),
    [sym_dot_dot_i] = ACTIONS(7476),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7476),
    [sym__newline] = ACTIONS(7476),
    [sym__semicolon] = ACTIONS(7476),
    [sym__raw_string_literal] = ACTIONS(7476),
    [sym__external_else] = ACTIONS(7476),
    [sym__external_open_parenthesis] = ACTIONS(7476),
    [sym__external_close_parenthesis] = ACTIONS(7476),
    [sym__external_open_brace] = ACTIONS(7476),
    [sym__external_close_brace] = ACTIONS(7476),
    [sym__external_open_bracket] = ACTIONS(7476),
    [sym__external_open_bracket2] = ACTIONS(7476),
  },
  [2243] = {
    [ts_builtin_sym_end] = ACTIONS(7480),
    [sym_identifier] = ACTIONS(7482),
    [anon_sym_BSLASH] = ACTIONS(7480),
    [anon_sym_function] = ACTIONS(7482),
    [anon_sym_EQ] = ACTIONS(7482),
    [anon_sym_if] = ACTIONS(7482),
    [anon_sym_for] = ACTIONS(7482),
    [anon_sym_while] = ACTIONS(7482),
    [anon_sym_repeat] = ACTIONS(7482),
    [anon_sym_QMARK] = ACTIONS(7480),
    [anon_sym_TILDE] = ACTIONS(7480),
    [anon_sym_BANG] = ACTIONS(7482),
    [anon_sym_PLUS] = ACTIONS(7480),
    [anon_sym_DASH] = ACTIONS(7482),
    [anon_sym_LT_DASH] = ACTIONS(7480),
    [anon_sym_LT_LT_DASH] = ACTIONS(7480),
    [anon_sym_COLON_EQ] = ACTIONS(7480),
    [anon_sym_DASH_GT] = ACTIONS(7482),
    [anon_sym_DASH_GT_GT] = ACTIONS(7480),
    [anon_sym_PIPE] = ACTIONS(7482),
    [anon_sym_AMP] = ACTIONS(7482),
    [anon_sym_PIPE_PIPE] = ACTIONS(7480),
    [anon_sym_AMP_AMP] = ACTIONS(7480),
    [anon_sym_LT] = ACTIONS(7482),
    [anon_sym_LT_EQ] = ACTIONS(7480),
    [anon_sym_GT] = ACTIONS(7482),
    [anon_sym_GT_EQ] = ACTIONS(7480),
    [anon_sym_EQ_EQ] = ACTIONS(7480),
    [anon_sym_BANG_EQ] = ACTIONS(7480),
    [anon_sym_STAR] = ACTIONS(7482),
    [anon_sym_SLASH] = ACTIONS(7480),
    [anon_sym_STAR_STAR] = ACTIONS(7480),
    [anon_sym_CARET] = ACTIONS(7480),
    [aux_sym_binary_operator_token1] = ACTIONS(7480),
    [anon_sym_PIPE_GT] = ACTIONS(7480),
    [anon_sym_COLON] = ACTIONS(7482),
    [anon_sym_DOLLAR] = ACTIONS(7480),
    [anon_sym_AT] = ACTIONS(7480),
    [aux_sym__hex_literal_token1] = ACTIONS(7480),
    [sym__number_literal] = ACTIONS(7482),
    [anon_sym_SQUOTE] = ACTIONS(7480),
    [anon_sym_DQUOTE] = ACTIONS(7480),
    [sym_return] = ACTIONS(7482),
    [sym_next] = ACTIONS(7482),
    [sym_break] = ACTIONS(7482),
    [sym_true] = ACTIONS(7482),
    [sym_false] = ACTIONS(7482),
    [sym_null] = ACTIONS(7482),
    [sym_inf] = ACTIONS(7482),
    [sym_nan] = ACTIONS(7482),
    [anon_sym_NA] = ACTIONS(7482),
    [anon_sym_NA_integer_] = ACTIONS(7482),
    [anon_sym_NA_real_] = ACTIONS(7482),
    [anon_sym_NA_complex_] = ACTIONS(7482),
    [anon_sym_NA_character_] = ACTIONS(7482),
    [sym_dots] = ACTIONS(7482),
    [sym_dot_dot_i] = ACTIONS(7480),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7480),
    [sym__newline] = ACTIONS(7480),
    [sym__semicolon] = ACTIONS(7480),
    [sym__raw_string_literal] = ACTIONS(7480),
    [sym__external_else] = ACTIONS(7480),
    [sym__external_open_parenthesis] = ACTIONS(7480),
    [sym__external_close_parenthesis] = ACTIONS(7480),
    [sym__external_open_brace] = ACTIONS(7480),
    [sym__external_close_brace] = ACTIONS(7480),
    [sym__external_open_bracket] = ACTIONS(7480),
    [sym__external_open_bracket2] = ACTIONS(7480),
  },
  [2244] = {
    [ts_builtin_sym_end] = ACTIONS(7484),
    [sym_identifier] = ACTIONS(7486),
    [anon_sym_BSLASH] = ACTIONS(7484),
    [anon_sym_function] = ACTIONS(7486),
    [anon_sym_EQ] = ACTIONS(7486),
    [anon_sym_if] = ACTIONS(7486),
    [anon_sym_for] = ACTIONS(7486),
    [anon_sym_while] = ACTIONS(7486),
    [anon_sym_repeat] = ACTIONS(7486),
    [anon_sym_QMARK] = ACTIONS(7484),
    [anon_sym_TILDE] = ACTIONS(7484),
    [anon_sym_BANG] = ACTIONS(7486),
    [anon_sym_PLUS] = ACTIONS(7484),
    [anon_sym_DASH] = ACTIONS(7486),
    [anon_sym_LT_DASH] = ACTIONS(7484),
    [anon_sym_LT_LT_DASH] = ACTIONS(7484),
    [anon_sym_COLON_EQ] = ACTIONS(7484),
    [anon_sym_DASH_GT] = ACTIONS(7486),
    [anon_sym_DASH_GT_GT] = ACTIONS(7484),
    [anon_sym_PIPE] = ACTIONS(7486),
    [anon_sym_AMP] = ACTIONS(7486),
    [anon_sym_PIPE_PIPE] = ACTIONS(7484),
    [anon_sym_AMP_AMP] = ACTIONS(7484),
    [anon_sym_LT] = ACTIONS(7486),
    [anon_sym_LT_EQ] = ACTIONS(7484),
    [anon_sym_GT] = ACTIONS(7486),
    [anon_sym_GT_EQ] = ACTIONS(7484),
    [anon_sym_EQ_EQ] = ACTIONS(7484),
    [anon_sym_BANG_EQ] = ACTIONS(7484),
    [anon_sym_STAR] = ACTIONS(7486),
    [anon_sym_SLASH] = ACTIONS(7484),
    [anon_sym_STAR_STAR] = ACTIONS(7484),
    [anon_sym_CARET] = ACTIONS(7484),
    [aux_sym_binary_operator_token1] = ACTIONS(7484),
    [anon_sym_PIPE_GT] = ACTIONS(7484),
    [anon_sym_COLON] = ACTIONS(7486),
    [anon_sym_DOLLAR] = ACTIONS(7484),
    [anon_sym_AT] = ACTIONS(7484),
    [aux_sym__hex_literal_token1] = ACTIONS(7484),
    [sym__number_literal] = ACTIONS(7486),
    [anon_sym_SQUOTE] = ACTIONS(7484),
    [anon_sym_DQUOTE] = ACTIONS(7484),
    [sym_return] = ACTIONS(7486),
    [sym_next] = ACTIONS(7486),
    [sym_break] = ACTIONS(7486),
    [sym_true] = ACTIONS(7486),
    [sym_false] = ACTIONS(7486),
    [sym_null] = ACTIONS(7486),
    [sym_inf] = ACTIONS(7486),
    [sym_nan] = ACTIONS(7486),
    [anon_sym_NA] = ACTIONS(7486),
    [anon_sym_NA_integer_] = ACTIONS(7486),
    [anon_sym_NA_real_] = ACTIONS(7486),
    [anon_sym_NA_complex_] = ACTIONS(7486),
    [anon_sym_NA_character_] = ACTIONS(7486),
    [sym_dots] = ACTIONS(7486),
    [sym_dot_dot_i] = ACTIONS(7484),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7484),
    [sym__newline] = ACTIONS(7484),
    [sym__semicolon] = ACTIONS(7484),
    [sym__raw_string_literal] = ACTIONS(7484),
    [sym__external_else] = ACTIONS(7484),
    [sym__external_open_parenthesis] = ACTIONS(7484),
    [sym__external_close_parenthesis] = ACTIONS(7484),
    [sym__external_open_brace] = ACTIONS(7484),
    [sym__external_close_brace] = ACTIONS(7484),
    [sym__external_open_bracket] = ACTIONS(7484),
    [sym__external_open_bracket2] = ACTIONS(7484),
  },
  [2245] = {
    [ts_builtin_sym_end] = ACTIONS(7488),
    [sym_identifier] = ACTIONS(7490),
    [anon_sym_BSLASH] = ACTIONS(7488),
    [anon_sym_function] = ACTIONS(7490),
    [anon_sym_EQ] = ACTIONS(7490),
    [anon_sym_if] = ACTIONS(7490),
    [anon_sym_for] = ACTIONS(7490),
    [anon_sym_while] = ACTIONS(7490),
    [anon_sym_repeat] = ACTIONS(7490),
    [anon_sym_QMARK] = ACTIONS(7488),
    [anon_sym_TILDE] = ACTIONS(7488),
    [anon_sym_BANG] = ACTIONS(7490),
    [anon_sym_PLUS] = ACTIONS(7488),
    [anon_sym_DASH] = ACTIONS(7490),
    [anon_sym_LT_DASH] = ACTIONS(7488),
    [anon_sym_LT_LT_DASH] = ACTIONS(7488),
    [anon_sym_COLON_EQ] = ACTIONS(7488),
    [anon_sym_DASH_GT] = ACTIONS(7490),
    [anon_sym_DASH_GT_GT] = ACTIONS(7488),
    [anon_sym_PIPE] = ACTIONS(7490),
    [anon_sym_AMP] = ACTIONS(7490),
    [anon_sym_PIPE_PIPE] = ACTIONS(7488),
    [anon_sym_AMP_AMP] = ACTIONS(7488),
    [anon_sym_LT] = ACTIONS(7490),
    [anon_sym_LT_EQ] = ACTIONS(7488),
    [anon_sym_GT] = ACTIONS(7490),
    [anon_sym_GT_EQ] = ACTIONS(7488),
    [anon_sym_EQ_EQ] = ACTIONS(7488),
    [anon_sym_BANG_EQ] = ACTIONS(7488),
    [anon_sym_STAR] = ACTIONS(7490),
    [anon_sym_SLASH] = ACTIONS(7488),
    [anon_sym_STAR_STAR] = ACTIONS(7488),
    [anon_sym_CARET] = ACTIONS(7488),
    [aux_sym_binary_operator_token1] = ACTIONS(7488),
    [anon_sym_PIPE_GT] = ACTIONS(7488),
    [anon_sym_COLON] = ACTIONS(7490),
    [anon_sym_DOLLAR] = ACTIONS(7488),
    [anon_sym_AT] = ACTIONS(7488),
    [aux_sym__hex_literal_token1] = ACTIONS(7488),
    [sym__number_literal] = ACTIONS(7490),
    [anon_sym_SQUOTE] = ACTIONS(7488),
    [anon_sym_DQUOTE] = ACTIONS(7488),
    [sym_return] = ACTIONS(7490),
    [sym_next] = ACTIONS(7490),
    [sym_break] = ACTIONS(7490),
    [sym_true] = ACTIONS(7490),
    [sym_false] = ACTIONS(7490),
    [sym_null] = ACTIONS(7490),
    [sym_inf] = ACTIONS(7490),
    [sym_nan] = ACTIONS(7490),
    [anon_sym_NA] = ACTIONS(7490),
    [anon_sym_NA_integer_] = ACTIONS(7490),
    [anon_sym_NA_real_] = ACTIONS(7490),
    [anon_sym_NA_complex_] = ACTIONS(7490),
    [anon_sym_NA_character_] = ACTIONS(7490),
    [sym_dots] = ACTIONS(7490),
    [sym_dot_dot_i] = ACTIONS(7488),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7488),
    [sym__newline] = ACTIONS(7488),
    [sym__semicolon] = ACTIONS(7488),
    [sym__raw_string_literal] = ACTIONS(7488),
    [sym__external_else] = ACTIONS(7488),
    [sym__external_open_parenthesis] = ACTIONS(7488),
    [sym__external_close_parenthesis] = ACTIONS(7488),
    [sym__external_open_brace] = ACTIONS(7488),
    [sym__external_close_brace] = ACTIONS(7488),
    [sym__external_open_bracket] = ACTIONS(7488),
    [sym__external_open_bracket2] = ACTIONS(7488),
  },
  [2246] = {
    [ts_builtin_sym_end] = ACTIONS(7492),
    [sym_identifier] = ACTIONS(7494),
    [anon_sym_BSLASH] = ACTIONS(7492),
    [anon_sym_function] = ACTIONS(7494),
    [anon_sym_EQ] = ACTIONS(7494),
    [anon_sym_if] = ACTIONS(7494),
    [anon_sym_for] = ACTIONS(7494),
    [anon_sym_while] = ACTIONS(7494),
    [anon_sym_repeat] = ACTIONS(7494),
    [anon_sym_QMARK] = ACTIONS(7492),
    [anon_sym_TILDE] = ACTIONS(7492),
    [anon_sym_BANG] = ACTIONS(7494),
    [anon_sym_PLUS] = ACTIONS(7492),
    [anon_sym_DASH] = ACTIONS(7494),
    [anon_sym_LT_DASH] = ACTIONS(7492),
    [anon_sym_LT_LT_DASH] = ACTIONS(7492),
    [anon_sym_COLON_EQ] = ACTIONS(7492),
    [anon_sym_DASH_GT] = ACTIONS(7494),
    [anon_sym_DASH_GT_GT] = ACTIONS(7492),
    [anon_sym_PIPE] = ACTIONS(7494),
    [anon_sym_AMP] = ACTIONS(7494),
    [anon_sym_PIPE_PIPE] = ACTIONS(7492),
    [anon_sym_AMP_AMP] = ACTIONS(7492),
    [anon_sym_LT] = ACTIONS(7494),
    [anon_sym_LT_EQ] = ACTIONS(7492),
    [anon_sym_GT] = ACTIONS(7494),
    [anon_sym_GT_EQ] = ACTIONS(7492),
    [anon_sym_EQ_EQ] = ACTIONS(7492),
    [anon_sym_BANG_EQ] = ACTIONS(7492),
    [anon_sym_STAR] = ACTIONS(7494),
    [anon_sym_SLASH] = ACTIONS(7492),
    [anon_sym_STAR_STAR] = ACTIONS(7492),
    [anon_sym_CARET] = ACTIONS(7492),
    [aux_sym_binary_operator_token1] = ACTIONS(7492),
    [anon_sym_PIPE_GT] = ACTIONS(7492),
    [anon_sym_COLON] = ACTIONS(7494),
    [anon_sym_DOLLAR] = ACTIONS(7492),
    [anon_sym_AT] = ACTIONS(7492),
    [aux_sym__hex_literal_token1] = ACTIONS(7492),
    [sym__number_literal] = ACTIONS(7494),
    [anon_sym_SQUOTE] = ACTIONS(7492),
    [anon_sym_DQUOTE] = ACTIONS(7492),
    [sym_return] = ACTIONS(7494),
    [sym_next] = ACTIONS(7494),
    [sym_break] = ACTIONS(7494),
    [sym_true] = ACTIONS(7494),
    [sym_false] = ACTIONS(7494),
    [sym_null] = ACTIONS(7494),
    [sym_inf] = ACTIONS(7494),
    [sym_nan] = ACTIONS(7494),
    [anon_sym_NA] = ACTIONS(7494),
    [anon_sym_NA_integer_] = ACTIONS(7494),
    [anon_sym_NA_real_] = ACTIONS(7494),
    [anon_sym_NA_complex_] = ACTIONS(7494),
    [anon_sym_NA_character_] = ACTIONS(7494),
    [sym_dots] = ACTIONS(7494),
    [sym_dot_dot_i] = ACTIONS(7492),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7492),
    [sym__newline] = ACTIONS(7492),
    [sym__semicolon] = ACTIONS(7492),
    [sym__raw_string_literal] = ACTIONS(7492),
    [sym__external_else] = ACTIONS(7492),
    [sym__external_open_parenthesis] = ACTIONS(7492),
    [sym__external_close_parenthesis] = ACTIONS(7492),
    [sym__external_open_brace] = ACTIONS(7492),
    [sym__external_close_brace] = ACTIONS(7492),
    [sym__external_open_bracket] = ACTIONS(7492),
    [sym__external_open_bracket2] = ACTIONS(7492),
  },
  [2247] = {
    [sym_identifier] = ACTIONS(7195),
    [anon_sym_BSLASH] = ACTIONS(7193),
    [anon_sym_function] = ACTIONS(7195),
    [anon_sym_EQ] = ACTIONS(7195),
    [anon_sym_if] = ACTIONS(7195),
    [anon_sym_for] = ACTIONS(7195),
    [anon_sym_while] = ACTIONS(7195),
    [anon_sym_repeat] = ACTIONS(7195),
    [anon_sym_QMARK] = ACTIONS(7193),
    [anon_sym_TILDE] = ACTIONS(7193),
    [anon_sym_BANG] = ACTIONS(7195),
    [anon_sym_PLUS] = ACTIONS(7193),
    [anon_sym_DASH] = ACTIONS(7195),
    [anon_sym_LT_DASH] = ACTIONS(7193),
    [anon_sym_LT_LT_DASH] = ACTIONS(7193),
    [anon_sym_COLON_EQ] = ACTIONS(7193),
    [anon_sym_DASH_GT] = ACTIONS(7195),
    [anon_sym_DASH_GT_GT] = ACTIONS(7193),
    [anon_sym_PIPE] = ACTIONS(7195),
    [anon_sym_AMP] = ACTIONS(7195),
    [anon_sym_PIPE_PIPE] = ACTIONS(7193),
    [anon_sym_AMP_AMP] = ACTIONS(7193),
    [anon_sym_LT] = ACTIONS(7195),
    [anon_sym_LT_EQ] = ACTIONS(7193),
    [anon_sym_GT] = ACTIONS(7195),
    [anon_sym_GT_EQ] = ACTIONS(7193),
    [anon_sym_EQ_EQ] = ACTIONS(7193),
    [anon_sym_BANG_EQ] = ACTIONS(7193),
    [anon_sym_STAR] = ACTIONS(7195),
    [anon_sym_SLASH] = ACTIONS(7193),
    [anon_sym_STAR_STAR] = ACTIONS(7193),
    [anon_sym_CARET] = ACTIONS(7193),
    [aux_sym_binary_operator_token1] = ACTIONS(7193),
    [anon_sym_PIPE_GT] = ACTIONS(7193),
    [anon_sym_COLON] = ACTIONS(7195),
    [anon_sym_DOLLAR] = ACTIONS(7193),
    [anon_sym_AT] = ACTIONS(7193),
    [anon_sym_COLON_COLON] = ACTIONS(7195),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7193),
    [aux_sym__hex_literal_token1] = ACTIONS(7193),
    [sym__number_literal] = ACTIONS(7195),
    [anon_sym_SQUOTE] = ACTIONS(7193),
    [anon_sym_DQUOTE] = ACTIONS(7193),
    [sym_return] = ACTIONS(7195),
    [sym_next] = ACTIONS(7195),
    [sym_break] = ACTIONS(7195),
    [sym_true] = ACTIONS(7195),
    [sym_false] = ACTIONS(7195),
    [sym_null] = ACTIONS(7195),
    [sym_inf] = ACTIONS(7195),
    [sym_nan] = ACTIONS(7195),
    [anon_sym_NA] = ACTIONS(7195),
    [anon_sym_NA_integer_] = ACTIONS(7195),
    [anon_sym_NA_real_] = ACTIONS(7195),
    [anon_sym_NA_complex_] = ACTIONS(7195),
    [anon_sym_NA_character_] = ACTIONS(7195),
    [sym_dots] = ACTIONS(7195),
    [sym_dot_dot_i] = ACTIONS(7193),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7193),
    [sym__newline] = ACTIONS(7193),
    [sym__semicolon] = ACTIONS(7193),
    [sym__raw_string_literal] = ACTIONS(7193),
    [sym__external_open_parenthesis] = ACTIONS(7193),
    [sym__external_open_brace] = ACTIONS(7193),
    [sym__external_close_brace] = ACTIONS(7193),
    [sym__external_open_bracket] = ACTIONS(7193),
    [sym__external_close_bracket] = ACTIONS(7193),
    [sym__external_open_bracket2] = ACTIONS(7193),
  },
  [2248] = {
    [ts_builtin_sym_end] = ACTIONS(7496),
    [sym_identifier] = ACTIONS(7498),
    [anon_sym_BSLASH] = ACTIONS(7496),
    [anon_sym_function] = ACTIONS(7498),
    [anon_sym_EQ] = ACTIONS(7498),
    [anon_sym_if] = ACTIONS(7498),
    [anon_sym_for] = ACTIONS(7498),
    [anon_sym_while] = ACTIONS(7498),
    [anon_sym_repeat] = ACTIONS(7498),
    [anon_sym_QMARK] = ACTIONS(7496),
    [anon_sym_TILDE] = ACTIONS(7496),
    [anon_sym_BANG] = ACTIONS(7498),
    [anon_sym_PLUS] = ACTIONS(7496),
    [anon_sym_DASH] = ACTIONS(7498),
    [anon_sym_LT_DASH] = ACTIONS(7496),
    [anon_sym_LT_LT_DASH] = ACTIONS(7496),
    [anon_sym_COLON_EQ] = ACTIONS(7496),
    [anon_sym_DASH_GT] = ACTIONS(7498),
    [anon_sym_DASH_GT_GT] = ACTIONS(7496),
    [anon_sym_PIPE] = ACTIONS(7498),
    [anon_sym_AMP] = ACTIONS(7498),
    [anon_sym_PIPE_PIPE] = ACTIONS(7496),
    [anon_sym_AMP_AMP] = ACTIONS(7496),
    [anon_sym_LT] = ACTIONS(7498),
    [anon_sym_LT_EQ] = ACTIONS(7496),
    [anon_sym_GT] = ACTIONS(7498),
    [anon_sym_GT_EQ] = ACTIONS(7496),
    [anon_sym_EQ_EQ] = ACTIONS(7496),
    [anon_sym_BANG_EQ] = ACTIONS(7496),
    [anon_sym_STAR] = ACTIONS(7498),
    [anon_sym_SLASH] = ACTIONS(7496),
    [anon_sym_STAR_STAR] = ACTIONS(7496),
    [anon_sym_CARET] = ACTIONS(7496),
    [aux_sym_binary_operator_token1] = ACTIONS(7496),
    [anon_sym_PIPE_GT] = ACTIONS(7496),
    [anon_sym_COLON] = ACTIONS(7498),
    [anon_sym_DOLLAR] = ACTIONS(7496),
    [anon_sym_AT] = ACTIONS(7496),
    [aux_sym__hex_literal_token1] = ACTIONS(7496),
    [sym__number_literal] = ACTIONS(7498),
    [anon_sym_SQUOTE] = ACTIONS(7496),
    [anon_sym_DQUOTE] = ACTIONS(7496),
    [sym_return] = ACTIONS(7498),
    [sym_next] = ACTIONS(7498),
    [sym_break] = ACTIONS(7498),
    [sym_true] = ACTIONS(7498),
    [sym_false] = ACTIONS(7498),
    [sym_null] = ACTIONS(7498),
    [sym_inf] = ACTIONS(7498),
    [sym_nan] = ACTIONS(7498),
    [anon_sym_NA] = ACTIONS(7498),
    [anon_sym_NA_integer_] = ACTIONS(7498),
    [anon_sym_NA_real_] = ACTIONS(7498),
    [anon_sym_NA_complex_] = ACTIONS(7498),
    [anon_sym_NA_character_] = ACTIONS(7498),
    [sym_dots] = ACTIONS(7498),
    [sym_dot_dot_i] = ACTIONS(7496),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7496),
    [sym__newline] = ACTIONS(7496),
    [sym__semicolon] = ACTIONS(7496),
    [sym__raw_string_literal] = ACTIONS(7496),
    [sym__external_else] = ACTIONS(7496),
    [sym__external_open_parenthesis] = ACTIONS(7496),
    [sym__external_close_parenthesis] = ACTIONS(7496),
    [sym__external_open_brace] = ACTIONS(7496),
    [sym__external_close_brace] = ACTIONS(7496),
    [sym__external_open_bracket] = ACTIONS(7496),
    [sym__external_open_bracket2] = ACTIONS(7496),
  },
  [2249] = {
    [ts_builtin_sym_end] = ACTIONS(7500),
    [sym_identifier] = ACTIONS(7502),
    [anon_sym_BSLASH] = ACTIONS(7500),
    [anon_sym_function] = ACTIONS(7502),
    [anon_sym_EQ] = ACTIONS(7502),
    [anon_sym_if] = ACTIONS(7502),
    [anon_sym_for] = ACTIONS(7502),
    [anon_sym_while] = ACTIONS(7502),
    [anon_sym_repeat] = ACTIONS(7502),
    [anon_sym_QMARK] = ACTIONS(7500),
    [anon_sym_TILDE] = ACTIONS(7500),
    [anon_sym_BANG] = ACTIONS(7502),
    [anon_sym_PLUS] = ACTIONS(7500),
    [anon_sym_DASH] = ACTIONS(7502),
    [anon_sym_LT_DASH] = ACTIONS(7500),
    [anon_sym_LT_LT_DASH] = ACTIONS(7500),
    [anon_sym_COLON_EQ] = ACTIONS(7500),
    [anon_sym_DASH_GT] = ACTIONS(7502),
    [anon_sym_DASH_GT_GT] = ACTIONS(7500),
    [anon_sym_PIPE] = ACTIONS(7502),
    [anon_sym_AMP] = ACTIONS(7502),
    [anon_sym_PIPE_PIPE] = ACTIONS(7500),
    [anon_sym_AMP_AMP] = ACTIONS(7500),
    [anon_sym_LT] = ACTIONS(7502),
    [anon_sym_LT_EQ] = ACTIONS(7500),
    [anon_sym_GT] = ACTIONS(7502),
    [anon_sym_GT_EQ] = ACTIONS(7500),
    [anon_sym_EQ_EQ] = ACTIONS(7500),
    [anon_sym_BANG_EQ] = ACTIONS(7500),
    [anon_sym_STAR] = ACTIONS(7502),
    [anon_sym_SLASH] = ACTIONS(7500),
    [anon_sym_STAR_STAR] = ACTIONS(7500),
    [anon_sym_CARET] = ACTIONS(7500),
    [aux_sym_binary_operator_token1] = ACTIONS(7500),
    [anon_sym_PIPE_GT] = ACTIONS(7500),
    [anon_sym_COLON] = ACTIONS(7502),
    [anon_sym_DOLLAR] = ACTIONS(7500),
    [anon_sym_AT] = ACTIONS(7500),
    [aux_sym__hex_literal_token1] = ACTIONS(7500),
    [sym__number_literal] = ACTIONS(7502),
    [anon_sym_SQUOTE] = ACTIONS(7500),
    [anon_sym_DQUOTE] = ACTIONS(7500),
    [sym_return] = ACTIONS(7502),
    [sym_next] = ACTIONS(7502),
    [sym_break] = ACTIONS(7502),
    [sym_true] = ACTIONS(7502),
    [sym_false] = ACTIONS(7502),
    [sym_null] = ACTIONS(7502),
    [sym_inf] = ACTIONS(7502),
    [sym_nan] = ACTIONS(7502),
    [anon_sym_NA] = ACTIONS(7502),
    [anon_sym_NA_integer_] = ACTIONS(7502),
    [anon_sym_NA_real_] = ACTIONS(7502),
    [anon_sym_NA_complex_] = ACTIONS(7502),
    [anon_sym_NA_character_] = ACTIONS(7502),
    [sym_dots] = ACTIONS(7502),
    [sym_dot_dot_i] = ACTIONS(7500),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7500),
    [sym__newline] = ACTIONS(7500),
    [sym__semicolon] = ACTIONS(7500),
    [sym__raw_string_literal] = ACTIONS(7500),
    [sym__external_else] = ACTIONS(7500),
    [sym__external_open_parenthesis] = ACTIONS(7500),
    [sym__external_close_parenthesis] = ACTIONS(7500),
    [sym__external_open_brace] = ACTIONS(7500),
    [sym__external_close_brace] = ACTIONS(7500),
    [sym__external_open_bracket] = ACTIONS(7500),
    [sym__external_open_bracket2] = ACTIONS(7500),
  },
  [2250] = {
    [ts_builtin_sym_end] = ACTIONS(7504),
    [sym_identifier] = ACTIONS(7506),
    [anon_sym_BSLASH] = ACTIONS(7504),
    [anon_sym_function] = ACTIONS(7506),
    [anon_sym_EQ] = ACTIONS(7506),
    [anon_sym_if] = ACTIONS(7506),
    [anon_sym_for] = ACTIONS(7506),
    [anon_sym_while] = ACTIONS(7506),
    [anon_sym_repeat] = ACTIONS(7506),
    [anon_sym_QMARK] = ACTIONS(7504),
    [anon_sym_TILDE] = ACTIONS(7504),
    [anon_sym_BANG] = ACTIONS(7506),
    [anon_sym_PLUS] = ACTIONS(7504),
    [anon_sym_DASH] = ACTIONS(7506),
    [anon_sym_LT_DASH] = ACTIONS(7504),
    [anon_sym_LT_LT_DASH] = ACTIONS(7504),
    [anon_sym_COLON_EQ] = ACTIONS(7504),
    [anon_sym_DASH_GT] = ACTIONS(7506),
    [anon_sym_DASH_GT_GT] = ACTIONS(7504),
    [anon_sym_PIPE] = ACTIONS(7506),
    [anon_sym_AMP] = ACTIONS(7506),
    [anon_sym_PIPE_PIPE] = ACTIONS(7504),
    [anon_sym_AMP_AMP] = ACTIONS(7504),
    [anon_sym_LT] = ACTIONS(7506),
    [anon_sym_LT_EQ] = ACTIONS(7504),
    [anon_sym_GT] = ACTIONS(7506),
    [anon_sym_GT_EQ] = ACTIONS(7504),
    [anon_sym_EQ_EQ] = ACTIONS(7504),
    [anon_sym_BANG_EQ] = ACTIONS(7504),
    [anon_sym_STAR] = ACTIONS(7506),
    [anon_sym_SLASH] = ACTIONS(7504),
    [anon_sym_STAR_STAR] = ACTIONS(7504),
    [anon_sym_CARET] = ACTIONS(7504),
    [aux_sym_binary_operator_token1] = ACTIONS(7504),
    [anon_sym_PIPE_GT] = ACTIONS(7504),
    [anon_sym_COLON] = ACTIONS(7506),
    [anon_sym_DOLLAR] = ACTIONS(7504),
    [anon_sym_AT] = ACTIONS(7504),
    [aux_sym__hex_literal_token1] = ACTIONS(7504),
    [sym__number_literal] = ACTIONS(7506),
    [anon_sym_SQUOTE] = ACTIONS(7504),
    [anon_sym_DQUOTE] = ACTIONS(7504),
    [sym_return] = ACTIONS(7506),
    [sym_next] = ACTIONS(7506),
    [sym_break] = ACTIONS(7506),
    [sym_true] = ACTIONS(7506),
    [sym_false] = ACTIONS(7506),
    [sym_null] = ACTIONS(7506),
    [sym_inf] = ACTIONS(7506),
    [sym_nan] = ACTIONS(7506),
    [anon_sym_NA] = ACTIONS(7506),
    [anon_sym_NA_integer_] = ACTIONS(7506),
    [anon_sym_NA_real_] = ACTIONS(7506),
    [anon_sym_NA_complex_] = ACTIONS(7506),
    [anon_sym_NA_character_] = ACTIONS(7506),
    [sym_dots] = ACTIONS(7506),
    [sym_dot_dot_i] = ACTIONS(7504),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7504),
    [sym__newline] = ACTIONS(7504),
    [sym__semicolon] = ACTIONS(7504),
    [sym__raw_string_literal] = ACTIONS(7504),
    [sym__external_else] = ACTIONS(7504),
    [sym__external_open_parenthesis] = ACTIONS(7504),
    [sym__external_close_parenthesis] = ACTIONS(7504),
    [sym__external_open_brace] = ACTIONS(7504),
    [sym__external_close_brace] = ACTIONS(7504),
    [sym__external_open_bracket] = ACTIONS(7504),
    [sym__external_open_bracket2] = ACTIONS(7504),
  },
  [2251] = {
    [sym_string] = STATE(2953),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym__string_or_identifier] = STATE(2953),
    [sym_identifier] = ACTIONS(7508),
    [anon_sym_BSLASH] = ACTIONS(5883),
    [anon_sym_function] = ACTIONS(5887),
    [anon_sym_EQ] = ACTIONS(5887),
    [anon_sym_if] = ACTIONS(5887),
    [anon_sym_for] = ACTIONS(5887),
    [anon_sym_while] = ACTIONS(5887),
    [anon_sym_repeat] = ACTIONS(5887),
    [anon_sym_QMARK] = ACTIONS(5883),
    [anon_sym_TILDE] = ACTIONS(5883),
    [anon_sym_BANG] = ACTIONS(5887),
    [anon_sym_PLUS] = ACTIONS(5883),
    [anon_sym_DASH] = ACTIONS(5887),
    [anon_sym_LT_DASH] = ACTIONS(5883),
    [anon_sym_LT_LT_DASH] = ACTIONS(5883),
    [anon_sym_COLON_EQ] = ACTIONS(5883),
    [anon_sym_DASH_GT] = ACTIONS(5887),
    [anon_sym_DASH_GT_GT] = ACTIONS(5883),
    [anon_sym_PIPE] = ACTIONS(5887),
    [anon_sym_AMP] = ACTIONS(5887),
    [anon_sym_PIPE_PIPE] = ACTIONS(5883),
    [anon_sym_AMP_AMP] = ACTIONS(5883),
    [anon_sym_LT] = ACTIONS(5887),
    [anon_sym_LT_EQ] = ACTIONS(5883),
    [anon_sym_GT] = ACTIONS(5887),
    [anon_sym_GT_EQ] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5883),
    [anon_sym_BANG_EQ] = ACTIONS(5883),
    [anon_sym_STAR] = ACTIONS(5887),
    [anon_sym_SLASH] = ACTIONS(5883),
    [anon_sym_STAR_STAR] = ACTIONS(5883),
    [anon_sym_CARET] = ACTIONS(5883),
    [aux_sym_binary_operator_token1] = ACTIONS(5883),
    [anon_sym_PIPE_GT] = ACTIONS(5883),
    [anon_sym_COLON] = ACTIONS(5887),
    [anon_sym_DOLLAR] = ACTIONS(5883),
    [anon_sym_AT] = ACTIONS(5883),
    [aux_sym__hex_literal_token1] = ACTIONS(5883),
    [sym__number_literal] = ACTIONS(5887),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(5887),
    [sym_next] = ACTIONS(5887),
    [sym_break] = ACTIONS(5887),
    [sym_true] = ACTIONS(5887),
    [sym_false] = ACTIONS(5887),
    [sym_null] = ACTIONS(5887),
    [sym_inf] = ACTIONS(5887),
    [sym_nan] = ACTIONS(5887),
    [anon_sym_NA] = ACTIONS(5887),
    [anon_sym_NA_integer_] = ACTIONS(5887),
    [anon_sym_NA_real_] = ACTIONS(5887),
    [anon_sym_NA_complex_] = ACTIONS(5887),
    [anon_sym_NA_character_] = ACTIONS(5887),
    [sym_dots] = ACTIONS(5887),
    [sym_dot_dot_i] = ACTIONS(5883),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5883),
    [sym__newline] = ACTIONS(5883),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(5883),
    [sym__external_close_parenthesis] = ACTIONS(5883),
    [sym__external_open_brace] = ACTIONS(5883),
    [sym__external_open_bracket] = ACTIONS(5883),
    [sym__external_open_bracket2] = ACTIONS(5883),
  },
  [2252] = {
    [ts_builtin_sym_end] = ACTIONS(7510),
    [sym_identifier] = ACTIONS(7512),
    [anon_sym_BSLASH] = ACTIONS(7510),
    [anon_sym_function] = ACTIONS(7512),
    [anon_sym_EQ] = ACTIONS(7512),
    [anon_sym_if] = ACTIONS(7512),
    [anon_sym_for] = ACTIONS(7512),
    [anon_sym_while] = ACTIONS(7512),
    [anon_sym_repeat] = ACTIONS(7512),
    [anon_sym_QMARK] = ACTIONS(7510),
    [anon_sym_TILDE] = ACTIONS(7510),
    [anon_sym_BANG] = ACTIONS(7512),
    [anon_sym_PLUS] = ACTIONS(7510),
    [anon_sym_DASH] = ACTIONS(7512),
    [anon_sym_LT_DASH] = ACTIONS(7510),
    [anon_sym_LT_LT_DASH] = ACTIONS(7510),
    [anon_sym_COLON_EQ] = ACTIONS(7510),
    [anon_sym_DASH_GT] = ACTIONS(7512),
    [anon_sym_DASH_GT_GT] = ACTIONS(7510),
    [anon_sym_PIPE] = ACTIONS(7512),
    [anon_sym_AMP] = ACTIONS(7512),
    [anon_sym_PIPE_PIPE] = ACTIONS(7510),
    [anon_sym_AMP_AMP] = ACTIONS(7510),
    [anon_sym_LT] = ACTIONS(7512),
    [anon_sym_LT_EQ] = ACTIONS(7510),
    [anon_sym_GT] = ACTIONS(7512),
    [anon_sym_GT_EQ] = ACTIONS(7510),
    [anon_sym_EQ_EQ] = ACTIONS(7510),
    [anon_sym_BANG_EQ] = ACTIONS(7510),
    [anon_sym_STAR] = ACTIONS(7512),
    [anon_sym_SLASH] = ACTIONS(7510),
    [anon_sym_STAR_STAR] = ACTIONS(7510),
    [anon_sym_CARET] = ACTIONS(7510),
    [aux_sym_binary_operator_token1] = ACTIONS(7510),
    [anon_sym_PIPE_GT] = ACTIONS(7510),
    [anon_sym_COLON] = ACTIONS(7512),
    [anon_sym_DOLLAR] = ACTIONS(7510),
    [anon_sym_AT] = ACTIONS(7510),
    [aux_sym__hex_literal_token1] = ACTIONS(7510),
    [sym__number_literal] = ACTIONS(7512),
    [anon_sym_SQUOTE] = ACTIONS(7510),
    [anon_sym_DQUOTE] = ACTIONS(7510),
    [sym_return] = ACTIONS(7512),
    [sym_next] = ACTIONS(7512),
    [sym_break] = ACTIONS(7512),
    [sym_true] = ACTIONS(7512),
    [sym_false] = ACTIONS(7512),
    [sym_null] = ACTIONS(7512),
    [sym_inf] = ACTIONS(7512),
    [sym_nan] = ACTIONS(7512),
    [anon_sym_NA] = ACTIONS(7512),
    [anon_sym_NA_integer_] = ACTIONS(7512),
    [anon_sym_NA_real_] = ACTIONS(7512),
    [anon_sym_NA_complex_] = ACTIONS(7512),
    [anon_sym_NA_character_] = ACTIONS(7512),
    [sym_dots] = ACTIONS(7512),
    [sym_dot_dot_i] = ACTIONS(7510),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7510),
    [sym__newline] = ACTIONS(7510),
    [sym__semicolon] = ACTIONS(7510),
    [sym__raw_string_literal] = ACTIONS(7510),
    [sym__external_else] = ACTIONS(7510),
    [sym__external_open_parenthesis] = ACTIONS(7510),
    [sym__external_close_parenthesis] = ACTIONS(7510),
    [sym__external_open_brace] = ACTIONS(7510),
    [sym__external_close_brace] = ACTIONS(7510),
    [sym__external_open_bracket] = ACTIONS(7510),
    [sym__external_open_bracket2] = ACTIONS(7510),
  },
  [2253] = {
    [sym_identifier] = ACTIONS(7191),
    [anon_sym_BSLASH] = ACTIONS(7189),
    [anon_sym_function] = ACTIONS(7191),
    [anon_sym_EQ] = ACTIONS(7191),
    [anon_sym_if] = ACTIONS(7191),
    [anon_sym_for] = ACTIONS(7191),
    [anon_sym_while] = ACTIONS(7191),
    [anon_sym_repeat] = ACTIONS(7191),
    [anon_sym_QMARK] = ACTIONS(7189),
    [anon_sym_TILDE] = ACTIONS(7189),
    [anon_sym_BANG] = ACTIONS(7191),
    [anon_sym_PLUS] = ACTIONS(7189),
    [anon_sym_DASH] = ACTIONS(7191),
    [anon_sym_LT_DASH] = ACTIONS(7189),
    [anon_sym_LT_LT_DASH] = ACTIONS(7189),
    [anon_sym_COLON_EQ] = ACTIONS(7189),
    [anon_sym_DASH_GT] = ACTIONS(7191),
    [anon_sym_DASH_GT_GT] = ACTIONS(7189),
    [anon_sym_PIPE] = ACTIONS(7191),
    [anon_sym_AMP] = ACTIONS(7191),
    [anon_sym_PIPE_PIPE] = ACTIONS(7189),
    [anon_sym_AMP_AMP] = ACTIONS(7189),
    [anon_sym_LT] = ACTIONS(7191),
    [anon_sym_LT_EQ] = ACTIONS(7189),
    [anon_sym_GT] = ACTIONS(7191),
    [anon_sym_GT_EQ] = ACTIONS(7189),
    [anon_sym_EQ_EQ] = ACTIONS(7189),
    [anon_sym_BANG_EQ] = ACTIONS(7189),
    [anon_sym_STAR] = ACTIONS(7191),
    [anon_sym_SLASH] = ACTIONS(7189),
    [anon_sym_STAR_STAR] = ACTIONS(7189),
    [anon_sym_CARET] = ACTIONS(7189),
    [aux_sym_binary_operator_token1] = ACTIONS(7189),
    [anon_sym_PIPE_GT] = ACTIONS(7189),
    [anon_sym_COLON] = ACTIONS(7191),
    [anon_sym_DOLLAR] = ACTIONS(7189),
    [anon_sym_AT] = ACTIONS(7189),
    [anon_sym_COLON_COLON] = ACTIONS(7191),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7189),
    [aux_sym__hex_literal_token1] = ACTIONS(7189),
    [sym__number_literal] = ACTIONS(7191),
    [anon_sym_SQUOTE] = ACTIONS(7189),
    [anon_sym_DQUOTE] = ACTIONS(7189),
    [sym_return] = ACTIONS(7191),
    [sym_next] = ACTIONS(7191),
    [sym_break] = ACTIONS(7191),
    [sym_true] = ACTIONS(7191),
    [sym_false] = ACTIONS(7191),
    [sym_null] = ACTIONS(7191),
    [sym_inf] = ACTIONS(7191),
    [sym_nan] = ACTIONS(7191),
    [anon_sym_NA] = ACTIONS(7191),
    [anon_sym_NA_integer_] = ACTIONS(7191),
    [anon_sym_NA_real_] = ACTIONS(7191),
    [anon_sym_NA_complex_] = ACTIONS(7191),
    [anon_sym_NA_character_] = ACTIONS(7191),
    [sym_dots] = ACTIONS(7191),
    [sym_dot_dot_i] = ACTIONS(7189),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7189),
    [sym__newline] = ACTIONS(7189),
    [sym__semicolon] = ACTIONS(7189),
    [sym__raw_string_literal] = ACTIONS(7189),
    [sym__external_open_parenthesis] = ACTIONS(7189),
    [sym__external_open_brace] = ACTIONS(7189),
    [sym__external_close_brace] = ACTIONS(7189),
    [sym__external_open_bracket] = ACTIONS(7189),
    [sym__external_close_bracket] = ACTIONS(7189),
    [sym__external_open_bracket2] = ACTIONS(7189),
  },
  [2254] = {
    [sym_identifier] = ACTIONS(5325),
    [anon_sym_BSLASH] = ACTIONS(5327),
    [anon_sym_function] = ACTIONS(5325),
    [anon_sym_EQ] = ACTIONS(5325),
    [anon_sym_if] = ACTIONS(5325),
    [anon_sym_for] = ACTIONS(5325),
    [anon_sym_while] = ACTIONS(5325),
    [anon_sym_repeat] = ACTIONS(5325),
    [anon_sym_QMARK] = ACTIONS(5327),
    [anon_sym_TILDE] = ACTIONS(5327),
    [anon_sym_BANG] = ACTIONS(5325),
    [anon_sym_PLUS] = ACTIONS(5327),
    [anon_sym_DASH] = ACTIONS(5325),
    [anon_sym_LT_DASH] = ACTIONS(5327),
    [anon_sym_LT_LT_DASH] = ACTIONS(5327),
    [anon_sym_COLON_EQ] = ACTIONS(5327),
    [anon_sym_DASH_GT] = ACTIONS(5325),
    [anon_sym_DASH_GT_GT] = ACTIONS(5327),
    [anon_sym_PIPE] = ACTIONS(5325),
    [anon_sym_AMP] = ACTIONS(5325),
    [anon_sym_PIPE_PIPE] = ACTIONS(5327),
    [anon_sym_AMP_AMP] = ACTIONS(5327),
    [anon_sym_LT] = ACTIONS(5325),
    [anon_sym_LT_EQ] = ACTIONS(5327),
    [anon_sym_GT] = ACTIONS(5325),
    [anon_sym_GT_EQ] = ACTIONS(5327),
    [anon_sym_EQ_EQ] = ACTIONS(5327),
    [anon_sym_BANG_EQ] = ACTIONS(5327),
    [anon_sym_STAR] = ACTIONS(5325),
    [anon_sym_SLASH] = ACTIONS(5327),
    [anon_sym_STAR_STAR] = ACTIONS(5327),
    [anon_sym_CARET] = ACTIONS(5327),
    [aux_sym_binary_operator_token1] = ACTIONS(5327),
    [anon_sym_PIPE_GT] = ACTIONS(5327),
    [anon_sym_COLON] = ACTIONS(5325),
    [anon_sym_DOLLAR] = ACTIONS(5327),
    [anon_sym_AT] = ACTIONS(5327),
    [aux_sym__hex_literal_token1] = ACTIONS(5327),
    [sym__number_literal] = ACTIONS(5325),
    [anon_sym_SQUOTE] = ACTIONS(5327),
    [anon_sym_DQUOTE] = ACTIONS(5327),
    [sym_return] = ACTIONS(5325),
    [sym_next] = ACTIONS(5325),
    [sym_break] = ACTIONS(5325),
    [sym_true] = ACTIONS(5325),
    [sym_false] = ACTIONS(5325),
    [sym_null] = ACTIONS(5325),
    [sym_inf] = ACTIONS(5325),
    [sym_nan] = ACTIONS(5325),
    [anon_sym_NA] = ACTIONS(5325),
    [anon_sym_NA_integer_] = ACTIONS(5325),
    [anon_sym_NA_real_] = ACTIONS(5325),
    [anon_sym_NA_complex_] = ACTIONS(5325),
    [anon_sym_NA_character_] = ACTIONS(5325),
    [sym_dots] = ACTIONS(5325),
    [sym_dot_dot_i] = ACTIONS(5327),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5327),
    [sym__newline] = ACTIONS(5327),
    [sym__semicolon] = ACTIONS(5327),
    [sym__raw_string_literal] = ACTIONS(5327),
    [sym__external_else] = ACTIONS(5327),
    [sym__external_open_parenthesis] = ACTIONS(5327),
    [sym__external_close_parenthesis] = ACTIONS(5327),
    [sym__external_open_brace] = ACTIONS(5327),
    [sym__external_close_brace] = ACTIONS(5327),
    [sym__external_open_bracket] = ACTIONS(5327),
    [sym__external_open_bracket2] = ACTIONS(5327),
    [sym__external_close_bracket2] = ACTIONS(5327),
  },
  [2255] = {
    [sym_identifier] = ACTIONS(7191),
    [anon_sym_BSLASH] = ACTIONS(7189),
    [anon_sym_function] = ACTIONS(7191),
    [anon_sym_EQ] = ACTIONS(7191),
    [anon_sym_if] = ACTIONS(7191),
    [anon_sym_for] = ACTIONS(7191),
    [anon_sym_while] = ACTIONS(7191),
    [anon_sym_repeat] = ACTIONS(7191),
    [anon_sym_QMARK] = ACTIONS(7189),
    [anon_sym_TILDE] = ACTIONS(7189),
    [anon_sym_BANG] = ACTIONS(7191),
    [anon_sym_PLUS] = ACTIONS(7189),
    [anon_sym_DASH] = ACTIONS(7191),
    [anon_sym_LT_DASH] = ACTIONS(7189),
    [anon_sym_LT_LT_DASH] = ACTIONS(7189),
    [anon_sym_COLON_EQ] = ACTIONS(7189),
    [anon_sym_DASH_GT] = ACTIONS(7191),
    [anon_sym_DASH_GT_GT] = ACTIONS(7189),
    [anon_sym_PIPE] = ACTIONS(7191),
    [anon_sym_AMP] = ACTIONS(7191),
    [anon_sym_PIPE_PIPE] = ACTIONS(7189),
    [anon_sym_AMP_AMP] = ACTIONS(7189),
    [anon_sym_LT] = ACTIONS(7191),
    [anon_sym_LT_EQ] = ACTIONS(7189),
    [anon_sym_GT] = ACTIONS(7191),
    [anon_sym_GT_EQ] = ACTIONS(7189),
    [anon_sym_EQ_EQ] = ACTIONS(7189),
    [anon_sym_BANG_EQ] = ACTIONS(7189),
    [anon_sym_STAR] = ACTIONS(7191),
    [anon_sym_SLASH] = ACTIONS(7189),
    [anon_sym_STAR_STAR] = ACTIONS(7189),
    [anon_sym_CARET] = ACTIONS(7189),
    [aux_sym_binary_operator_token1] = ACTIONS(7189),
    [anon_sym_PIPE_GT] = ACTIONS(7189),
    [anon_sym_COLON] = ACTIONS(7191),
    [anon_sym_DOLLAR] = ACTIONS(7189),
    [anon_sym_AT] = ACTIONS(7189),
    [anon_sym_COLON_COLON] = ACTIONS(7191),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7189),
    [aux_sym__hex_literal_token1] = ACTIONS(7189),
    [sym__number_literal] = ACTIONS(7191),
    [anon_sym_SQUOTE] = ACTIONS(7189),
    [anon_sym_DQUOTE] = ACTIONS(7189),
    [sym_return] = ACTIONS(7191),
    [sym_next] = ACTIONS(7191),
    [sym_break] = ACTIONS(7191),
    [sym_true] = ACTIONS(7191),
    [sym_false] = ACTIONS(7191),
    [sym_null] = ACTIONS(7191),
    [sym_inf] = ACTIONS(7191),
    [sym_nan] = ACTIONS(7191),
    [anon_sym_NA] = ACTIONS(7191),
    [anon_sym_NA_integer_] = ACTIONS(7191),
    [anon_sym_NA_real_] = ACTIONS(7191),
    [anon_sym_NA_complex_] = ACTIONS(7191),
    [anon_sym_NA_character_] = ACTIONS(7191),
    [sym_dots] = ACTIONS(7191),
    [sym_dot_dot_i] = ACTIONS(7189),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7189),
    [sym__newline] = ACTIONS(7189),
    [sym__semicolon] = ACTIONS(7189),
    [sym__raw_string_literal] = ACTIONS(7189),
    [sym__external_open_parenthesis] = ACTIONS(7189),
    [sym__external_open_brace] = ACTIONS(7189),
    [sym__external_close_brace] = ACTIONS(7189),
    [sym__external_open_bracket] = ACTIONS(7189),
    [sym__external_open_bracket2] = ACTIONS(7189),
    [sym__external_close_bracket2] = ACTIONS(7189),
  },
  [2256] = {
    [ts_builtin_sym_end] = ACTIONS(7514),
    [sym_identifier] = ACTIONS(7516),
    [anon_sym_BSLASH] = ACTIONS(7514),
    [anon_sym_function] = ACTIONS(7516),
    [anon_sym_EQ] = ACTIONS(7516),
    [anon_sym_if] = ACTIONS(7516),
    [anon_sym_for] = ACTIONS(7516),
    [anon_sym_while] = ACTIONS(7516),
    [anon_sym_repeat] = ACTIONS(7516),
    [anon_sym_QMARK] = ACTIONS(7514),
    [anon_sym_TILDE] = ACTIONS(7514),
    [anon_sym_BANG] = ACTIONS(7516),
    [anon_sym_PLUS] = ACTIONS(7514),
    [anon_sym_DASH] = ACTIONS(7516),
    [anon_sym_LT_DASH] = ACTIONS(7514),
    [anon_sym_LT_LT_DASH] = ACTIONS(7514),
    [anon_sym_COLON_EQ] = ACTIONS(7514),
    [anon_sym_DASH_GT] = ACTIONS(7516),
    [anon_sym_DASH_GT_GT] = ACTIONS(7514),
    [anon_sym_PIPE] = ACTIONS(7516),
    [anon_sym_AMP] = ACTIONS(7516),
    [anon_sym_PIPE_PIPE] = ACTIONS(7514),
    [anon_sym_AMP_AMP] = ACTIONS(7514),
    [anon_sym_LT] = ACTIONS(7516),
    [anon_sym_LT_EQ] = ACTIONS(7514),
    [anon_sym_GT] = ACTIONS(7516),
    [anon_sym_GT_EQ] = ACTIONS(7514),
    [anon_sym_EQ_EQ] = ACTIONS(7514),
    [anon_sym_BANG_EQ] = ACTIONS(7514),
    [anon_sym_STAR] = ACTIONS(7516),
    [anon_sym_SLASH] = ACTIONS(7514),
    [anon_sym_STAR_STAR] = ACTIONS(7514),
    [anon_sym_CARET] = ACTIONS(7514),
    [aux_sym_binary_operator_token1] = ACTIONS(7514),
    [anon_sym_PIPE_GT] = ACTIONS(7514),
    [anon_sym_COLON] = ACTIONS(7516),
    [anon_sym_DOLLAR] = ACTIONS(7514),
    [anon_sym_AT] = ACTIONS(7514),
    [aux_sym__hex_literal_token1] = ACTIONS(7514),
    [sym__number_literal] = ACTIONS(7516),
    [anon_sym_SQUOTE] = ACTIONS(7514),
    [anon_sym_DQUOTE] = ACTIONS(7514),
    [sym_return] = ACTIONS(7516),
    [sym_next] = ACTIONS(7516),
    [sym_break] = ACTIONS(7516),
    [sym_true] = ACTIONS(7516),
    [sym_false] = ACTIONS(7516),
    [sym_null] = ACTIONS(7516),
    [sym_inf] = ACTIONS(7516),
    [sym_nan] = ACTIONS(7516),
    [anon_sym_NA] = ACTIONS(7516),
    [anon_sym_NA_integer_] = ACTIONS(7516),
    [anon_sym_NA_real_] = ACTIONS(7516),
    [anon_sym_NA_complex_] = ACTIONS(7516),
    [anon_sym_NA_character_] = ACTIONS(7516),
    [sym_dots] = ACTIONS(7516),
    [sym_dot_dot_i] = ACTIONS(7514),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7514),
    [sym__newline] = ACTIONS(7514),
    [sym__semicolon] = ACTIONS(7514),
    [sym__raw_string_literal] = ACTIONS(7514),
    [sym__external_else] = ACTIONS(7514),
    [sym__external_open_parenthesis] = ACTIONS(7514),
    [sym__external_close_parenthesis] = ACTIONS(7514),
    [sym__external_open_brace] = ACTIONS(7514),
    [sym__external_close_brace] = ACTIONS(7514),
    [sym__external_open_bracket] = ACTIONS(7514),
    [sym__external_open_bracket2] = ACTIONS(7514),
  },
  [2257] = {
    [ts_builtin_sym_end] = ACTIONS(7518),
    [sym_identifier] = ACTIONS(7520),
    [anon_sym_BSLASH] = ACTIONS(7518),
    [anon_sym_function] = ACTIONS(7520),
    [anon_sym_EQ] = ACTIONS(7520),
    [anon_sym_if] = ACTIONS(7520),
    [anon_sym_for] = ACTIONS(7520),
    [anon_sym_while] = ACTIONS(7520),
    [anon_sym_repeat] = ACTIONS(7520),
    [anon_sym_QMARK] = ACTIONS(7518),
    [anon_sym_TILDE] = ACTIONS(7518),
    [anon_sym_BANG] = ACTIONS(7520),
    [anon_sym_PLUS] = ACTIONS(7518),
    [anon_sym_DASH] = ACTIONS(7520),
    [anon_sym_LT_DASH] = ACTIONS(7518),
    [anon_sym_LT_LT_DASH] = ACTIONS(7518),
    [anon_sym_COLON_EQ] = ACTIONS(7518),
    [anon_sym_DASH_GT] = ACTIONS(7520),
    [anon_sym_DASH_GT_GT] = ACTIONS(7518),
    [anon_sym_PIPE] = ACTIONS(7520),
    [anon_sym_AMP] = ACTIONS(7520),
    [anon_sym_PIPE_PIPE] = ACTIONS(7518),
    [anon_sym_AMP_AMP] = ACTIONS(7518),
    [anon_sym_LT] = ACTIONS(7520),
    [anon_sym_LT_EQ] = ACTIONS(7518),
    [anon_sym_GT] = ACTIONS(7520),
    [anon_sym_GT_EQ] = ACTIONS(7518),
    [anon_sym_EQ_EQ] = ACTIONS(7518),
    [anon_sym_BANG_EQ] = ACTIONS(7518),
    [anon_sym_STAR] = ACTIONS(7520),
    [anon_sym_SLASH] = ACTIONS(7518),
    [anon_sym_STAR_STAR] = ACTIONS(7518),
    [anon_sym_CARET] = ACTIONS(7518),
    [aux_sym_binary_operator_token1] = ACTIONS(7518),
    [anon_sym_PIPE_GT] = ACTIONS(7518),
    [anon_sym_COLON] = ACTIONS(7520),
    [anon_sym_DOLLAR] = ACTIONS(7518),
    [anon_sym_AT] = ACTIONS(7518),
    [aux_sym__hex_literal_token1] = ACTIONS(7518),
    [sym__number_literal] = ACTIONS(7520),
    [anon_sym_SQUOTE] = ACTIONS(7518),
    [anon_sym_DQUOTE] = ACTIONS(7518),
    [sym_return] = ACTIONS(7520),
    [sym_next] = ACTIONS(7520),
    [sym_break] = ACTIONS(7520),
    [sym_true] = ACTIONS(7520),
    [sym_false] = ACTIONS(7520),
    [sym_null] = ACTIONS(7520),
    [sym_inf] = ACTIONS(7520),
    [sym_nan] = ACTIONS(7520),
    [anon_sym_NA] = ACTIONS(7520),
    [anon_sym_NA_integer_] = ACTIONS(7520),
    [anon_sym_NA_real_] = ACTIONS(7520),
    [anon_sym_NA_complex_] = ACTIONS(7520),
    [anon_sym_NA_character_] = ACTIONS(7520),
    [sym_dots] = ACTIONS(7520),
    [sym_dot_dot_i] = ACTIONS(7518),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7518),
    [sym__newline] = ACTIONS(7518),
    [sym__semicolon] = ACTIONS(7518),
    [sym__raw_string_literal] = ACTIONS(7518),
    [sym__external_else] = ACTIONS(7518),
    [sym__external_open_parenthesis] = ACTIONS(7518),
    [sym__external_close_parenthesis] = ACTIONS(7518),
    [sym__external_open_brace] = ACTIONS(7518),
    [sym__external_close_brace] = ACTIONS(7518),
    [sym__external_open_bracket] = ACTIONS(7518),
    [sym__external_open_bracket2] = ACTIONS(7518),
  },
  [2258] = {
    [sym_identifier] = ACTIONS(7195),
    [anon_sym_BSLASH] = ACTIONS(7193),
    [anon_sym_function] = ACTIONS(7195),
    [anon_sym_EQ] = ACTIONS(7195),
    [anon_sym_if] = ACTIONS(7195),
    [anon_sym_for] = ACTIONS(7195),
    [anon_sym_while] = ACTIONS(7195),
    [anon_sym_repeat] = ACTIONS(7195),
    [anon_sym_QMARK] = ACTIONS(7193),
    [anon_sym_TILDE] = ACTIONS(7193),
    [anon_sym_BANG] = ACTIONS(7195),
    [anon_sym_PLUS] = ACTIONS(7193),
    [anon_sym_DASH] = ACTIONS(7195),
    [anon_sym_LT_DASH] = ACTIONS(7193),
    [anon_sym_LT_LT_DASH] = ACTIONS(7193),
    [anon_sym_COLON_EQ] = ACTIONS(7193),
    [anon_sym_DASH_GT] = ACTIONS(7195),
    [anon_sym_DASH_GT_GT] = ACTIONS(7193),
    [anon_sym_PIPE] = ACTIONS(7195),
    [anon_sym_AMP] = ACTIONS(7195),
    [anon_sym_PIPE_PIPE] = ACTIONS(7193),
    [anon_sym_AMP_AMP] = ACTIONS(7193),
    [anon_sym_LT] = ACTIONS(7195),
    [anon_sym_LT_EQ] = ACTIONS(7193),
    [anon_sym_GT] = ACTIONS(7195),
    [anon_sym_GT_EQ] = ACTIONS(7193),
    [anon_sym_EQ_EQ] = ACTIONS(7193),
    [anon_sym_BANG_EQ] = ACTIONS(7193),
    [anon_sym_STAR] = ACTIONS(7195),
    [anon_sym_SLASH] = ACTIONS(7193),
    [anon_sym_STAR_STAR] = ACTIONS(7193),
    [anon_sym_CARET] = ACTIONS(7193),
    [aux_sym_binary_operator_token1] = ACTIONS(7193),
    [anon_sym_PIPE_GT] = ACTIONS(7193),
    [anon_sym_COLON] = ACTIONS(7195),
    [anon_sym_DOLLAR] = ACTIONS(7193),
    [anon_sym_AT] = ACTIONS(7193),
    [anon_sym_COLON_COLON] = ACTIONS(7195),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7193),
    [aux_sym__hex_literal_token1] = ACTIONS(7193),
    [sym__number_literal] = ACTIONS(7195),
    [anon_sym_SQUOTE] = ACTIONS(7193),
    [anon_sym_DQUOTE] = ACTIONS(7193),
    [sym_return] = ACTIONS(7195),
    [sym_next] = ACTIONS(7195),
    [sym_break] = ACTIONS(7195),
    [sym_true] = ACTIONS(7195),
    [sym_false] = ACTIONS(7195),
    [sym_null] = ACTIONS(7195),
    [sym_inf] = ACTIONS(7195),
    [sym_nan] = ACTIONS(7195),
    [anon_sym_NA] = ACTIONS(7195),
    [anon_sym_NA_integer_] = ACTIONS(7195),
    [anon_sym_NA_real_] = ACTIONS(7195),
    [anon_sym_NA_complex_] = ACTIONS(7195),
    [anon_sym_NA_character_] = ACTIONS(7195),
    [sym_dots] = ACTIONS(7195),
    [sym_dot_dot_i] = ACTIONS(7193),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7193),
    [sym__newline] = ACTIONS(7193),
    [sym__semicolon] = ACTIONS(7193),
    [sym__raw_string_literal] = ACTIONS(7193),
    [sym__external_open_parenthesis] = ACTIONS(7193),
    [sym__external_open_brace] = ACTIONS(7193),
    [sym__external_close_brace] = ACTIONS(7193),
    [sym__external_open_bracket] = ACTIONS(7193),
    [sym__external_open_bracket2] = ACTIONS(7193),
    [sym__external_close_bracket2] = ACTIONS(7193),
  },
  [2259] = {
    [ts_builtin_sym_end] = ACTIONS(7522),
    [sym_identifier] = ACTIONS(7524),
    [anon_sym_BSLASH] = ACTIONS(7522),
    [anon_sym_function] = ACTIONS(7524),
    [anon_sym_EQ] = ACTIONS(7524),
    [anon_sym_if] = ACTIONS(7524),
    [anon_sym_for] = ACTIONS(7524),
    [anon_sym_while] = ACTIONS(7524),
    [anon_sym_repeat] = ACTIONS(7524),
    [anon_sym_QMARK] = ACTIONS(7522),
    [anon_sym_TILDE] = ACTIONS(7522),
    [anon_sym_BANG] = ACTIONS(7524),
    [anon_sym_PLUS] = ACTIONS(7522),
    [anon_sym_DASH] = ACTIONS(7524),
    [anon_sym_LT_DASH] = ACTIONS(7522),
    [anon_sym_LT_LT_DASH] = ACTIONS(7522),
    [anon_sym_COLON_EQ] = ACTIONS(7522),
    [anon_sym_DASH_GT] = ACTIONS(7524),
    [anon_sym_DASH_GT_GT] = ACTIONS(7522),
    [anon_sym_PIPE] = ACTIONS(7524),
    [anon_sym_AMP] = ACTIONS(7524),
    [anon_sym_PIPE_PIPE] = ACTIONS(7522),
    [anon_sym_AMP_AMP] = ACTIONS(7522),
    [anon_sym_LT] = ACTIONS(7524),
    [anon_sym_LT_EQ] = ACTIONS(7522),
    [anon_sym_GT] = ACTIONS(7524),
    [anon_sym_GT_EQ] = ACTIONS(7522),
    [anon_sym_EQ_EQ] = ACTIONS(7522),
    [anon_sym_BANG_EQ] = ACTIONS(7522),
    [anon_sym_STAR] = ACTIONS(7524),
    [anon_sym_SLASH] = ACTIONS(7522),
    [anon_sym_STAR_STAR] = ACTIONS(7522),
    [anon_sym_CARET] = ACTIONS(7522),
    [aux_sym_binary_operator_token1] = ACTIONS(7522),
    [anon_sym_PIPE_GT] = ACTIONS(7522),
    [anon_sym_COLON] = ACTIONS(7524),
    [anon_sym_DOLLAR] = ACTIONS(7522),
    [anon_sym_AT] = ACTIONS(7522),
    [aux_sym__hex_literal_token1] = ACTIONS(7522),
    [sym__number_literal] = ACTIONS(7524),
    [anon_sym_SQUOTE] = ACTIONS(7522),
    [anon_sym_DQUOTE] = ACTIONS(7522),
    [sym_return] = ACTIONS(7524),
    [sym_next] = ACTIONS(7524),
    [sym_break] = ACTIONS(7524),
    [sym_true] = ACTIONS(7524),
    [sym_false] = ACTIONS(7524),
    [sym_null] = ACTIONS(7524),
    [sym_inf] = ACTIONS(7524),
    [sym_nan] = ACTIONS(7524),
    [anon_sym_NA] = ACTIONS(7524),
    [anon_sym_NA_integer_] = ACTIONS(7524),
    [anon_sym_NA_real_] = ACTIONS(7524),
    [anon_sym_NA_complex_] = ACTIONS(7524),
    [anon_sym_NA_character_] = ACTIONS(7524),
    [sym_dots] = ACTIONS(7524),
    [sym_dot_dot_i] = ACTIONS(7522),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7522),
    [sym__newline] = ACTIONS(7522),
    [sym__semicolon] = ACTIONS(7522),
    [sym__raw_string_literal] = ACTIONS(7522),
    [sym__external_else] = ACTIONS(7522),
    [sym__external_open_parenthesis] = ACTIONS(7522),
    [sym__external_close_parenthesis] = ACTIONS(7522),
    [sym__external_open_brace] = ACTIONS(7522),
    [sym__external_close_brace] = ACTIONS(7522),
    [sym__external_open_bracket] = ACTIONS(7522),
    [sym__external_open_bracket2] = ACTIONS(7522),
  },
  [2260] = {
    [ts_builtin_sym_end] = ACTIONS(7526),
    [sym_identifier] = ACTIONS(7528),
    [anon_sym_BSLASH] = ACTIONS(7526),
    [anon_sym_function] = ACTIONS(7528),
    [anon_sym_EQ] = ACTIONS(7528),
    [anon_sym_if] = ACTIONS(7528),
    [anon_sym_for] = ACTIONS(7528),
    [anon_sym_while] = ACTIONS(7528),
    [anon_sym_repeat] = ACTIONS(7528),
    [anon_sym_QMARK] = ACTIONS(7526),
    [anon_sym_TILDE] = ACTIONS(7526),
    [anon_sym_BANG] = ACTIONS(7528),
    [anon_sym_PLUS] = ACTIONS(7526),
    [anon_sym_DASH] = ACTIONS(7528),
    [anon_sym_LT_DASH] = ACTIONS(7526),
    [anon_sym_LT_LT_DASH] = ACTIONS(7526),
    [anon_sym_COLON_EQ] = ACTIONS(7526),
    [anon_sym_DASH_GT] = ACTIONS(7528),
    [anon_sym_DASH_GT_GT] = ACTIONS(7526),
    [anon_sym_PIPE] = ACTIONS(7528),
    [anon_sym_AMP] = ACTIONS(7528),
    [anon_sym_PIPE_PIPE] = ACTIONS(7526),
    [anon_sym_AMP_AMP] = ACTIONS(7526),
    [anon_sym_LT] = ACTIONS(7528),
    [anon_sym_LT_EQ] = ACTIONS(7526),
    [anon_sym_GT] = ACTIONS(7528),
    [anon_sym_GT_EQ] = ACTIONS(7526),
    [anon_sym_EQ_EQ] = ACTIONS(7526),
    [anon_sym_BANG_EQ] = ACTIONS(7526),
    [anon_sym_STAR] = ACTIONS(7528),
    [anon_sym_SLASH] = ACTIONS(7526),
    [anon_sym_STAR_STAR] = ACTIONS(7526),
    [anon_sym_CARET] = ACTIONS(7526),
    [aux_sym_binary_operator_token1] = ACTIONS(7526),
    [anon_sym_PIPE_GT] = ACTIONS(7526),
    [anon_sym_COLON] = ACTIONS(7528),
    [anon_sym_DOLLAR] = ACTIONS(7526),
    [anon_sym_AT] = ACTIONS(7526),
    [aux_sym__hex_literal_token1] = ACTIONS(7526),
    [sym__number_literal] = ACTIONS(7528),
    [anon_sym_SQUOTE] = ACTIONS(7526),
    [anon_sym_DQUOTE] = ACTIONS(7526),
    [sym_return] = ACTIONS(7528),
    [sym_next] = ACTIONS(7528),
    [sym_break] = ACTIONS(7528),
    [sym_true] = ACTIONS(7528),
    [sym_false] = ACTIONS(7528),
    [sym_null] = ACTIONS(7528),
    [sym_inf] = ACTIONS(7528),
    [sym_nan] = ACTIONS(7528),
    [anon_sym_NA] = ACTIONS(7528),
    [anon_sym_NA_integer_] = ACTIONS(7528),
    [anon_sym_NA_real_] = ACTIONS(7528),
    [anon_sym_NA_complex_] = ACTIONS(7528),
    [anon_sym_NA_character_] = ACTIONS(7528),
    [sym_dots] = ACTIONS(7528),
    [sym_dot_dot_i] = ACTIONS(7526),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7526),
    [sym__newline] = ACTIONS(7526),
    [sym__semicolon] = ACTIONS(7526),
    [sym__raw_string_literal] = ACTIONS(7526),
    [sym__external_else] = ACTIONS(7526),
    [sym__external_open_parenthesis] = ACTIONS(7526),
    [sym__external_close_parenthesis] = ACTIONS(7526),
    [sym__external_open_brace] = ACTIONS(7526),
    [sym__external_close_brace] = ACTIONS(7526),
    [sym__external_open_bracket] = ACTIONS(7526),
    [sym__external_open_bracket2] = ACTIONS(7526),
  },
  [2261] = {
    [ts_builtin_sym_end] = ACTIONS(7530),
    [sym_identifier] = ACTIONS(7532),
    [anon_sym_BSLASH] = ACTIONS(7530),
    [anon_sym_function] = ACTIONS(7532),
    [anon_sym_EQ] = ACTIONS(7532),
    [anon_sym_if] = ACTIONS(7532),
    [anon_sym_for] = ACTIONS(7532),
    [anon_sym_while] = ACTIONS(7532),
    [anon_sym_repeat] = ACTIONS(7532),
    [anon_sym_QMARK] = ACTIONS(7530),
    [anon_sym_TILDE] = ACTIONS(7530),
    [anon_sym_BANG] = ACTIONS(7532),
    [anon_sym_PLUS] = ACTIONS(7530),
    [anon_sym_DASH] = ACTIONS(7532),
    [anon_sym_LT_DASH] = ACTIONS(7530),
    [anon_sym_LT_LT_DASH] = ACTIONS(7530),
    [anon_sym_COLON_EQ] = ACTIONS(7530),
    [anon_sym_DASH_GT] = ACTIONS(7532),
    [anon_sym_DASH_GT_GT] = ACTIONS(7530),
    [anon_sym_PIPE] = ACTIONS(7532),
    [anon_sym_AMP] = ACTIONS(7532),
    [anon_sym_PIPE_PIPE] = ACTIONS(7530),
    [anon_sym_AMP_AMP] = ACTIONS(7530),
    [anon_sym_LT] = ACTIONS(7532),
    [anon_sym_LT_EQ] = ACTIONS(7530),
    [anon_sym_GT] = ACTIONS(7532),
    [anon_sym_GT_EQ] = ACTIONS(7530),
    [anon_sym_EQ_EQ] = ACTIONS(7530),
    [anon_sym_BANG_EQ] = ACTIONS(7530),
    [anon_sym_STAR] = ACTIONS(7532),
    [anon_sym_SLASH] = ACTIONS(7530),
    [anon_sym_STAR_STAR] = ACTIONS(7530),
    [anon_sym_CARET] = ACTIONS(7530),
    [aux_sym_binary_operator_token1] = ACTIONS(7530),
    [anon_sym_PIPE_GT] = ACTIONS(7530),
    [anon_sym_COLON] = ACTIONS(7532),
    [anon_sym_DOLLAR] = ACTIONS(7530),
    [anon_sym_AT] = ACTIONS(7530),
    [aux_sym__hex_literal_token1] = ACTIONS(7530),
    [sym__number_literal] = ACTIONS(7532),
    [anon_sym_SQUOTE] = ACTIONS(7530),
    [anon_sym_DQUOTE] = ACTIONS(7530),
    [sym_return] = ACTIONS(7532),
    [sym_next] = ACTIONS(7532),
    [sym_break] = ACTIONS(7532),
    [sym_true] = ACTIONS(7532),
    [sym_false] = ACTIONS(7532),
    [sym_null] = ACTIONS(7532),
    [sym_inf] = ACTIONS(7532),
    [sym_nan] = ACTIONS(7532),
    [anon_sym_NA] = ACTIONS(7532),
    [anon_sym_NA_integer_] = ACTIONS(7532),
    [anon_sym_NA_real_] = ACTIONS(7532),
    [anon_sym_NA_complex_] = ACTIONS(7532),
    [anon_sym_NA_character_] = ACTIONS(7532),
    [sym_dots] = ACTIONS(7532),
    [sym_dot_dot_i] = ACTIONS(7530),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7530),
    [sym__newline] = ACTIONS(7530),
    [sym__semicolon] = ACTIONS(7530),
    [sym__raw_string_literal] = ACTIONS(7530),
    [sym__external_else] = ACTIONS(7530),
    [sym__external_open_parenthesis] = ACTIONS(7530),
    [sym__external_close_parenthesis] = ACTIONS(7530),
    [sym__external_open_brace] = ACTIONS(7530),
    [sym__external_close_brace] = ACTIONS(7530),
    [sym__external_open_bracket] = ACTIONS(7530),
    [sym__external_open_bracket2] = ACTIONS(7530),
  },
  [2262] = {
    [sym_identifier] = ACTIONS(7163),
    [anon_sym_BSLASH] = ACTIONS(7165),
    [anon_sym_function] = ACTIONS(7163),
    [anon_sym_EQ] = ACTIONS(7163),
    [anon_sym_if] = ACTIONS(7163),
    [anon_sym_for] = ACTIONS(7163),
    [anon_sym_while] = ACTIONS(7163),
    [anon_sym_repeat] = ACTIONS(7163),
    [anon_sym_QMARK] = ACTIONS(7165),
    [anon_sym_TILDE] = ACTIONS(7165),
    [anon_sym_BANG] = ACTIONS(7163),
    [anon_sym_PLUS] = ACTIONS(7165),
    [anon_sym_DASH] = ACTIONS(7163),
    [anon_sym_LT_DASH] = ACTIONS(7165),
    [anon_sym_LT_LT_DASH] = ACTIONS(7165),
    [anon_sym_COLON_EQ] = ACTIONS(7165),
    [anon_sym_DASH_GT] = ACTIONS(7163),
    [anon_sym_DASH_GT_GT] = ACTIONS(7165),
    [anon_sym_PIPE] = ACTIONS(7163),
    [anon_sym_AMP] = ACTIONS(7163),
    [anon_sym_PIPE_PIPE] = ACTIONS(7165),
    [anon_sym_AMP_AMP] = ACTIONS(7165),
    [anon_sym_LT] = ACTIONS(7163),
    [anon_sym_LT_EQ] = ACTIONS(7165),
    [anon_sym_GT] = ACTIONS(7163),
    [anon_sym_GT_EQ] = ACTIONS(7165),
    [anon_sym_EQ_EQ] = ACTIONS(7165),
    [anon_sym_BANG_EQ] = ACTIONS(7165),
    [anon_sym_STAR] = ACTIONS(7163),
    [anon_sym_SLASH] = ACTIONS(7165),
    [anon_sym_STAR_STAR] = ACTIONS(7165),
    [anon_sym_CARET] = ACTIONS(7165),
    [aux_sym_binary_operator_token1] = ACTIONS(7165),
    [anon_sym_PIPE_GT] = ACTIONS(7165),
    [anon_sym_COLON] = ACTIONS(7163),
    [anon_sym_DOLLAR] = ACTIONS(7165),
    [anon_sym_AT] = ACTIONS(7165),
    [anon_sym_COLON_COLON] = ACTIONS(7163),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7165),
    [aux_sym__hex_literal_token1] = ACTIONS(7165),
    [sym__number_literal] = ACTIONS(7163),
    [anon_sym_SQUOTE] = ACTIONS(7165),
    [anon_sym_DQUOTE] = ACTIONS(7165),
    [sym_return] = ACTIONS(7163),
    [sym_next] = ACTIONS(7163),
    [sym_break] = ACTIONS(7163),
    [sym_true] = ACTIONS(7163),
    [sym_false] = ACTIONS(7163),
    [sym_null] = ACTIONS(7163),
    [sym_inf] = ACTIONS(7163),
    [sym_nan] = ACTIONS(7163),
    [anon_sym_NA] = ACTIONS(7163),
    [anon_sym_NA_integer_] = ACTIONS(7163),
    [anon_sym_NA_real_] = ACTIONS(7163),
    [anon_sym_NA_complex_] = ACTIONS(7163),
    [anon_sym_NA_character_] = ACTIONS(7163),
    [sym_dots] = ACTIONS(7163),
    [sym_dot_dot_i] = ACTIONS(7165),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7165),
    [sym__newline] = ACTIONS(7165),
    [sym__semicolon] = ACTIONS(7165),
    [sym__raw_string_literal] = ACTIONS(7165),
    [sym__external_open_parenthesis] = ACTIONS(7165),
    [sym__external_open_brace] = ACTIONS(7165),
    [sym__external_close_brace] = ACTIONS(7165),
    [sym__external_open_bracket] = ACTIONS(7165),
    [sym__external_close_bracket] = ACTIONS(7165),
    [sym__external_open_bracket2] = ACTIONS(7165),
  },
  [2263] = {
    [sym_identifier] = ACTIONS(7151),
    [anon_sym_BSLASH] = ACTIONS(7153),
    [anon_sym_function] = ACTIONS(7151),
    [anon_sym_EQ] = ACTIONS(7151),
    [anon_sym_if] = ACTIONS(7151),
    [anon_sym_for] = ACTIONS(7151),
    [anon_sym_while] = ACTIONS(7151),
    [anon_sym_repeat] = ACTIONS(7151),
    [anon_sym_QMARK] = ACTIONS(7153),
    [anon_sym_TILDE] = ACTIONS(7153),
    [anon_sym_BANG] = ACTIONS(7151),
    [anon_sym_PLUS] = ACTIONS(7153),
    [anon_sym_DASH] = ACTIONS(7151),
    [anon_sym_LT_DASH] = ACTIONS(7153),
    [anon_sym_LT_LT_DASH] = ACTIONS(7153),
    [anon_sym_COLON_EQ] = ACTIONS(7153),
    [anon_sym_DASH_GT] = ACTIONS(7151),
    [anon_sym_DASH_GT_GT] = ACTIONS(7153),
    [anon_sym_PIPE] = ACTIONS(7151),
    [anon_sym_AMP] = ACTIONS(7151),
    [anon_sym_PIPE_PIPE] = ACTIONS(7153),
    [anon_sym_AMP_AMP] = ACTIONS(7153),
    [anon_sym_LT] = ACTIONS(7151),
    [anon_sym_LT_EQ] = ACTIONS(7153),
    [anon_sym_GT] = ACTIONS(7151),
    [anon_sym_GT_EQ] = ACTIONS(7153),
    [anon_sym_EQ_EQ] = ACTIONS(7153),
    [anon_sym_BANG_EQ] = ACTIONS(7153),
    [anon_sym_STAR] = ACTIONS(7151),
    [anon_sym_SLASH] = ACTIONS(7153),
    [anon_sym_STAR_STAR] = ACTIONS(7153),
    [anon_sym_CARET] = ACTIONS(7153),
    [aux_sym_binary_operator_token1] = ACTIONS(7153),
    [anon_sym_PIPE_GT] = ACTIONS(7153),
    [anon_sym_COLON] = ACTIONS(7151),
    [anon_sym_DOLLAR] = ACTIONS(7153),
    [anon_sym_AT] = ACTIONS(7153),
    [anon_sym_COLON_COLON] = ACTIONS(7151),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7153),
    [aux_sym__hex_literal_token1] = ACTIONS(7153),
    [sym__number_literal] = ACTIONS(7151),
    [anon_sym_SQUOTE] = ACTIONS(7153),
    [anon_sym_DQUOTE] = ACTIONS(7153),
    [sym_return] = ACTIONS(7151),
    [sym_next] = ACTIONS(7151),
    [sym_break] = ACTIONS(7151),
    [sym_true] = ACTIONS(7151),
    [sym_false] = ACTIONS(7151),
    [sym_null] = ACTIONS(7151),
    [sym_inf] = ACTIONS(7151),
    [sym_nan] = ACTIONS(7151),
    [anon_sym_NA] = ACTIONS(7151),
    [anon_sym_NA_integer_] = ACTIONS(7151),
    [anon_sym_NA_real_] = ACTIONS(7151),
    [anon_sym_NA_complex_] = ACTIONS(7151),
    [anon_sym_NA_character_] = ACTIONS(7151),
    [sym_dots] = ACTIONS(7151),
    [sym_dot_dot_i] = ACTIONS(7153),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7153),
    [sym__newline] = ACTIONS(7153),
    [sym__semicolon] = ACTIONS(7153),
    [sym__raw_string_literal] = ACTIONS(7153),
    [sym__external_open_parenthesis] = ACTIONS(7153),
    [sym__external_open_brace] = ACTIONS(7153),
    [sym__external_close_brace] = ACTIONS(7153),
    [sym__external_open_bracket] = ACTIONS(7153),
    [sym__external_close_bracket] = ACTIONS(7153),
    [sym__external_open_bracket2] = ACTIONS(7153),
  },
  [2264] = {
    [sym_identifier] = ACTIONS(7115),
    [anon_sym_BSLASH] = ACTIONS(7117),
    [anon_sym_function] = ACTIONS(7115),
    [anon_sym_EQ] = ACTIONS(7115),
    [anon_sym_if] = ACTIONS(7115),
    [anon_sym_for] = ACTIONS(7115),
    [anon_sym_while] = ACTIONS(7115),
    [anon_sym_repeat] = ACTIONS(7115),
    [anon_sym_QMARK] = ACTIONS(7117),
    [anon_sym_TILDE] = ACTIONS(7117),
    [anon_sym_BANG] = ACTIONS(7115),
    [anon_sym_PLUS] = ACTIONS(7117),
    [anon_sym_DASH] = ACTIONS(7115),
    [anon_sym_LT_DASH] = ACTIONS(7117),
    [anon_sym_LT_LT_DASH] = ACTIONS(7117),
    [anon_sym_COLON_EQ] = ACTIONS(7117),
    [anon_sym_DASH_GT] = ACTIONS(7115),
    [anon_sym_DASH_GT_GT] = ACTIONS(7117),
    [anon_sym_PIPE] = ACTIONS(7115),
    [anon_sym_AMP] = ACTIONS(7115),
    [anon_sym_PIPE_PIPE] = ACTIONS(7117),
    [anon_sym_AMP_AMP] = ACTIONS(7117),
    [anon_sym_LT] = ACTIONS(7115),
    [anon_sym_LT_EQ] = ACTIONS(7117),
    [anon_sym_GT] = ACTIONS(7115),
    [anon_sym_GT_EQ] = ACTIONS(7117),
    [anon_sym_EQ_EQ] = ACTIONS(7117),
    [anon_sym_BANG_EQ] = ACTIONS(7117),
    [anon_sym_STAR] = ACTIONS(7115),
    [anon_sym_SLASH] = ACTIONS(7117),
    [anon_sym_STAR_STAR] = ACTIONS(7117),
    [anon_sym_CARET] = ACTIONS(7117),
    [aux_sym_binary_operator_token1] = ACTIONS(7117),
    [anon_sym_PIPE_GT] = ACTIONS(7117),
    [anon_sym_COLON] = ACTIONS(7115),
    [anon_sym_DOLLAR] = ACTIONS(7117),
    [anon_sym_AT] = ACTIONS(7117),
    [anon_sym_COLON_COLON] = ACTIONS(7115),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7117),
    [aux_sym__hex_literal_token1] = ACTIONS(7117),
    [sym__number_literal] = ACTIONS(7115),
    [anon_sym_SQUOTE] = ACTIONS(7117),
    [anon_sym_DQUOTE] = ACTIONS(7117),
    [sym_return] = ACTIONS(7115),
    [sym_next] = ACTIONS(7115),
    [sym_break] = ACTIONS(7115),
    [sym_true] = ACTIONS(7115),
    [sym_false] = ACTIONS(7115),
    [sym_null] = ACTIONS(7115),
    [sym_inf] = ACTIONS(7115),
    [sym_nan] = ACTIONS(7115),
    [anon_sym_NA] = ACTIONS(7115),
    [anon_sym_NA_integer_] = ACTIONS(7115),
    [anon_sym_NA_real_] = ACTIONS(7115),
    [anon_sym_NA_complex_] = ACTIONS(7115),
    [anon_sym_NA_character_] = ACTIONS(7115),
    [sym_dots] = ACTIONS(7115),
    [sym_dot_dot_i] = ACTIONS(7117),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7117),
    [sym__newline] = ACTIONS(7117),
    [sym__semicolon] = ACTIONS(7117),
    [sym__raw_string_literal] = ACTIONS(7117),
    [sym__external_open_parenthesis] = ACTIONS(7117),
    [sym__external_open_brace] = ACTIONS(7117),
    [sym__external_close_brace] = ACTIONS(7117),
    [sym__external_open_bracket] = ACTIONS(7117),
    [sym__external_close_bracket] = ACTIONS(7117),
    [sym__external_open_bracket2] = ACTIONS(7117),
  },
  [2265] = {
    [sym_identifier] = ACTIONS(7115),
    [anon_sym_BSLASH] = ACTIONS(7117),
    [anon_sym_function] = ACTIONS(7115),
    [anon_sym_EQ] = ACTIONS(7115),
    [anon_sym_if] = ACTIONS(7115),
    [anon_sym_for] = ACTIONS(7115),
    [anon_sym_while] = ACTIONS(7115),
    [anon_sym_repeat] = ACTIONS(7115),
    [anon_sym_QMARK] = ACTIONS(7117),
    [anon_sym_TILDE] = ACTIONS(7117),
    [anon_sym_BANG] = ACTIONS(7115),
    [anon_sym_PLUS] = ACTIONS(7117),
    [anon_sym_DASH] = ACTIONS(7115),
    [anon_sym_LT_DASH] = ACTIONS(7117),
    [anon_sym_LT_LT_DASH] = ACTIONS(7117),
    [anon_sym_COLON_EQ] = ACTIONS(7117),
    [anon_sym_DASH_GT] = ACTIONS(7115),
    [anon_sym_DASH_GT_GT] = ACTIONS(7117),
    [anon_sym_PIPE] = ACTIONS(7115),
    [anon_sym_AMP] = ACTIONS(7115),
    [anon_sym_PIPE_PIPE] = ACTIONS(7117),
    [anon_sym_AMP_AMP] = ACTIONS(7117),
    [anon_sym_LT] = ACTIONS(7115),
    [anon_sym_LT_EQ] = ACTIONS(7117),
    [anon_sym_GT] = ACTIONS(7115),
    [anon_sym_GT_EQ] = ACTIONS(7117),
    [anon_sym_EQ_EQ] = ACTIONS(7117),
    [anon_sym_BANG_EQ] = ACTIONS(7117),
    [anon_sym_STAR] = ACTIONS(7115),
    [anon_sym_SLASH] = ACTIONS(7117),
    [anon_sym_STAR_STAR] = ACTIONS(7117),
    [anon_sym_CARET] = ACTIONS(7117),
    [aux_sym_binary_operator_token1] = ACTIONS(7117),
    [anon_sym_PIPE_GT] = ACTIONS(7117),
    [anon_sym_COLON] = ACTIONS(7115),
    [anon_sym_DOLLAR] = ACTIONS(7117),
    [anon_sym_AT] = ACTIONS(7117),
    [anon_sym_COLON_COLON] = ACTIONS(7115),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7117),
    [aux_sym__hex_literal_token1] = ACTIONS(7117),
    [sym__number_literal] = ACTIONS(7115),
    [anon_sym_SQUOTE] = ACTIONS(7117),
    [anon_sym_DQUOTE] = ACTIONS(7117),
    [sym_return] = ACTIONS(7115),
    [sym_next] = ACTIONS(7115),
    [sym_break] = ACTIONS(7115),
    [sym_true] = ACTIONS(7115),
    [sym_false] = ACTIONS(7115),
    [sym_null] = ACTIONS(7115),
    [sym_inf] = ACTIONS(7115),
    [sym_nan] = ACTIONS(7115),
    [anon_sym_NA] = ACTIONS(7115),
    [anon_sym_NA_integer_] = ACTIONS(7115),
    [anon_sym_NA_real_] = ACTIONS(7115),
    [anon_sym_NA_complex_] = ACTIONS(7115),
    [anon_sym_NA_character_] = ACTIONS(7115),
    [sym_dots] = ACTIONS(7115),
    [sym_dot_dot_i] = ACTIONS(7117),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7117),
    [sym__newline] = ACTIONS(7117),
    [sym__semicolon] = ACTIONS(7117),
    [sym__raw_string_literal] = ACTIONS(7117),
    [sym__external_open_parenthesis] = ACTIONS(7117),
    [sym__external_open_brace] = ACTIONS(7117),
    [sym__external_close_brace] = ACTIONS(7117),
    [sym__external_open_bracket] = ACTIONS(7117),
    [sym__external_close_bracket] = ACTIONS(7117),
    [sym__external_open_bracket2] = ACTIONS(7117),
  },
  [2266] = {
    [sym_identifier] = ACTIONS(7121),
    [anon_sym_BSLASH] = ACTIONS(7123),
    [anon_sym_function] = ACTIONS(7121),
    [anon_sym_EQ] = ACTIONS(7121),
    [anon_sym_if] = ACTIONS(7121),
    [anon_sym_for] = ACTIONS(7121),
    [anon_sym_while] = ACTIONS(7121),
    [anon_sym_repeat] = ACTIONS(7121),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_TILDE] = ACTIONS(7123),
    [anon_sym_BANG] = ACTIONS(7121),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_DASH] = ACTIONS(7121),
    [anon_sym_LT_DASH] = ACTIONS(7123),
    [anon_sym_LT_LT_DASH] = ACTIONS(7123),
    [anon_sym_COLON_EQ] = ACTIONS(7123),
    [anon_sym_DASH_GT] = ACTIONS(7121),
    [anon_sym_DASH_GT_GT] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_LT_EQ] = ACTIONS(7123),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
    [aux_sym_binary_operator_token1] = ACTIONS(7123),
    [anon_sym_PIPE_GT] = ACTIONS(7123),
    [anon_sym_COLON] = ACTIONS(7121),
    [anon_sym_DOLLAR] = ACTIONS(7123),
    [anon_sym_AT] = ACTIONS(7123),
    [anon_sym_L] = ACTIONS(7534),
    [anon_sym_i] = ACTIONS(7536),
    [aux_sym__hex_literal_token1] = ACTIONS(7123),
    [sym__number_literal] = ACTIONS(7121),
    [anon_sym_SQUOTE] = ACTIONS(7123),
    [anon_sym_DQUOTE] = ACTIONS(7123),
    [sym_return] = ACTIONS(7121),
    [sym_next] = ACTIONS(7121),
    [sym_break] = ACTIONS(7121),
    [sym_true] = ACTIONS(7121),
    [sym_false] = ACTIONS(7121),
    [sym_null] = ACTIONS(7121),
    [sym_inf] = ACTIONS(7121),
    [sym_nan] = ACTIONS(7121),
    [anon_sym_NA] = ACTIONS(7121),
    [anon_sym_NA_integer_] = ACTIONS(7121),
    [anon_sym_NA_real_] = ACTIONS(7121),
    [anon_sym_NA_complex_] = ACTIONS(7121),
    [anon_sym_NA_character_] = ACTIONS(7121),
    [sym_dots] = ACTIONS(7121),
    [sym_dot_dot_i] = ACTIONS(7123),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7123),
    [sym__newline] = ACTIONS(7123),
    [sym__semicolon] = ACTIONS(7123),
    [sym__raw_string_literal] = ACTIONS(7123),
    [sym__external_open_parenthesis] = ACTIONS(7123),
    [sym__external_open_brace] = ACTIONS(7123),
    [sym__external_close_brace] = ACTIONS(7123),
    [sym__external_open_bracket] = ACTIONS(7123),
    [sym__external_close_bracket] = ACTIONS(7123),
    [sym__external_open_bracket2] = ACTIONS(7123),
  },
  [2267] = {
    [ts_builtin_sym_end] = ACTIONS(7538),
    [sym_identifier] = ACTIONS(7540),
    [anon_sym_BSLASH] = ACTIONS(7538),
    [anon_sym_function] = ACTIONS(7540),
    [anon_sym_EQ] = ACTIONS(7540),
    [anon_sym_if] = ACTIONS(7540),
    [anon_sym_for] = ACTIONS(7540),
    [anon_sym_while] = ACTIONS(7540),
    [anon_sym_repeat] = ACTIONS(7540),
    [anon_sym_QMARK] = ACTIONS(7538),
    [anon_sym_TILDE] = ACTIONS(7538),
    [anon_sym_BANG] = ACTIONS(7540),
    [anon_sym_PLUS] = ACTIONS(7538),
    [anon_sym_DASH] = ACTIONS(7540),
    [anon_sym_LT_DASH] = ACTIONS(7538),
    [anon_sym_LT_LT_DASH] = ACTIONS(7538),
    [anon_sym_COLON_EQ] = ACTIONS(7538),
    [anon_sym_DASH_GT] = ACTIONS(7540),
    [anon_sym_DASH_GT_GT] = ACTIONS(7538),
    [anon_sym_PIPE] = ACTIONS(7540),
    [anon_sym_AMP] = ACTIONS(7540),
    [anon_sym_PIPE_PIPE] = ACTIONS(7538),
    [anon_sym_AMP_AMP] = ACTIONS(7538),
    [anon_sym_LT] = ACTIONS(7540),
    [anon_sym_LT_EQ] = ACTIONS(7538),
    [anon_sym_GT] = ACTIONS(7540),
    [anon_sym_GT_EQ] = ACTIONS(7538),
    [anon_sym_EQ_EQ] = ACTIONS(7538),
    [anon_sym_BANG_EQ] = ACTIONS(7538),
    [anon_sym_STAR] = ACTIONS(7540),
    [anon_sym_SLASH] = ACTIONS(7538),
    [anon_sym_STAR_STAR] = ACTIONS(7538),
    [anon_sym_CARET] = ACTIONS(7538),
    [aux_sym_binary_operator_token1] = ACTIONS(7538),
    [anon_sym_PIPE_GT] = ACTIONS(7538),
    [anon_sym_COLON] = ACTIONS(7540),
    [anon_sym_DOLLAR] = ACTIONS(7538),
    [anon_sym_AT] = ACTIONS(7538),
    [aux_sym__hex_literal_token1] = ACTIONS(7538),
    [sym__number_literal] = ACTIONS(7540),
    [anon_sym_SQUOTE] = ACTIONS(7538),
    [anon_sym_DQUOTE] = ACTIONS(7538),
    [sym_return] = ACTIONS(7540),
    [sym_next] = ACTIONS(7540),
    [sym_break] = ACTIONS(7540),
    [sym_true] = ACTIONS(7540),
    [sym_false] = ACTIONS(7540),
    [sym_null] = ACTIONS(7540),
    [sym_inf] = ACTIONS(7540),
    [sym_nan] = ACTIONS(7540),
    [anon_sym_NA] = ACTIONS(7540),
    [anon_sym_NA_integer_] = ACTIONS(7540),
    [anon_sym_NA_real_] = ACTIONS(7540),
    [anon_sym_NA_complex_] = ACTIONS(7540),
    [anon_sym_NA_character_] = ACTIONS(7540),
    [sym_dots] = ACTIONS(7540),
    [sym_dot_dot_i] = ACTIONS(7538),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7538),
    [sym__newline] = ACTIONS(7538),
    [sym__semicolon] = ACTIONS(7538),
    [sym__raw_string_literal] = ACTIONS(7538),
    [sym__external_else] = ACTIONS(7538),
    [sym__external_open_parenthesis] = ACTIONS(7538),
    [sym__external_close_parenthesis] = ACTIONS(7538),
    [sym__external_open_brace] = ACTIONS(7538),
    [sym__external_close_brace] = ACTIONS(7538),
    [sym__external_open_bracket] = ACTIONS(7538),
    [sym__external_open_bracket2] = ACTIONS(7538),
  },
  [2268] = {
    [ts_builtin_sym_end] = ACTIONS(7542),
    [sym_identifier] = ACTIONS(7544),
    [anon_sym_BSLASH] = ACTIONS(7542),
    [anon_sym_function] = ACTIONS(7544),
    [anon_sym_EQ] = ACTIONS(7544),
    [anon_sym_if] = ACTIONS(7544),
    [anon_sym_for] = ACTIONS(7544),
    [anon_sym_while] = ACTIONS(7544),
    [anon_sym_repeat] = ACTIONS(7544),
    [anon_sym_QMARK] = ACTIONS(7542),
    [anon_sym_TILDE] = ACTIONS(7542),
    [anon_sym_BANG] = ACTIONS(7544),
    [anon_sym_PLUS] = ACTIONS(7542),
    [anon_sym_DASH] = ACTIONS(7544),
    [anon_sym_LT_DASH] = ACTIONS(7542),
    [anon_sym_LT_LT_DASH] = ACTIONS(7542),
    [anon_sym_COLON_EQ] = ACTIONS(7542),
    [anon_sym_DASH_GT] = ACTIONS(7544),
    [anon_sym_DASH_GT_GT] = ACTIONS(7542),
    [anon_sym_PIPE] = ACTIONS(7544),
    [anon_sym_AMP] = ACTIONS(7544),
    [anon_sym_PIPE_PIPE] = ACTIONS(7542),
    [anon_sym_AMP_AMP] = ACTIONS(7542),
    [anon_sym_LT] = ACTIONS(7544),
    [anon_sym_LT_EQ] = ACTIONS(7542),
    [anon_sym_GT] = ACTIONS(7544),
    [anon_sym_GT_EQ] = ACTIONS(7542),
    [anon_sym_EQ_EQ] = ACTIONS(7542),
    [anon_sym_BANG_EQ] = ACTIONS(7542),
    [anon_sym_STAR] = ACTIONS(7544),
    [anon_sym_SLASH] = ACTIONS(7542),
    [anon_sym_STAR_STAR] = ACTIONS(7542),
    [anon_sym_CARET] = ACTIONS(7542),
    [aux_sym_binary_operator_token1] = ACTIONS(7542),
    [anon_sym_PIPE_GT] = ACTIONS(7542),
    [anon_sym_COLON] = ACTIONS(7544),
    [anon_sym_DOLLAR] = ACTIONS(7542),
    [anon_sym_AT] = ACTIONS(7542),
    [aux_sym__hex_literal_token1] = ACTIONS(7542),
    [sym__number_literal] = ACTIONS(7544),
    [anon_sym_SQUOTE] = ACTIONS(7542),
    [anon_sym_DQUOTE] = ACTIONS(7542),
    [sym_return] = ACTIONS(7544),
    [sym_next] = ACTIONS(7544),
    [sym_break] = ACTIONS(7544),
    [sym_true] = ACTIONS(7544),
    [sym_false] = ACTIONS(7544),
    [sym_null] = ACTIONS(7544),
    [sym_inf] = ACTIONS(7544),
    [sym_nan] = ACTIONS(7544),
    [anon_sym_NA] = ACTIONS(7544),
    [anon_sym_NA_integer_] = ACTIONS(7544),
    [anon_sym_NA_real_] = ACTIONS(7544),
    [anon_sym_NA_complex_] = ACTIONS(7544),
    [anon_sym_NA_character_] = ACTIONS(7544),
    [sym_dots] = ACTIONS(7544),
    [sym_dot_dot_i] = ACTIONS(7542),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7542),
    [sym__newline] = ACTIONS(7542),
    [sym__semicolon] = ACTIONS(7542),
    [sym__raw_string_literal] = ACTIONS(7542),
    [sym__external_else] = ACTIONS(7542),
    [sym__external_open_parenthesis] = ACTIONS(7542),
    [sym__external_close_parenthesis] = ACTIONS(7542),
    [sym__external_open_brace] = ACTIONS(7542),
    [sym__external_close_brace] = ACTIONS(7542),
    [sym__external_open_bracket] = ACTIONS(7542),
    [sym__external_open_bracket2] = ACTIONS(7542),
  },
  [2269] = {
    [sym_identifier] = ACTIONS(7137),
    [anon_sym_BSLASH] = ACTIONS(7139),
    [anon_sym_function] = ACTIONS(7137),
    [anon_sym_EQ] = ACTIONS(7137),
    [anon_sym_if] = ACTIONS(7137),
    [anon_sym_for] = ACTIONS(7137),
    [anon_sym_while] = ACTIONS(7137),
    [anon_sym_repeat] = ACTIONS(7137),
    [anon_sym_QMARK] = ACTIONS(7139),
    [anon_sym_TILDE] = ACTIONS(7139),
    [anon_sym_BANG] = ACTIONS(7137),
    [anon_sym_PLUS] = ACTIONS(7139),
    [anon_sym_DASH] = ACTIONS(7137),
    [anon_sym_LT_DASH] = ACTIONS(7139),
    [anon_sym_LT_LT_DASH] = ACTIONS(7139),
    [anon_sym_COLON_EQ] = ACTIONS(7139),
    [anon_sym_DASH_GT] = ACTIONS(7137),
    [anon_sym_DASH_GT_GT] = ACTIONS(7139),
    [anon_sym_PIPE] = ACTIONS(7137),
    [anon_sym_AMP] = ACTIONS(7137),
    [anon_sym_PIPE_PIPE] = ACTIONS(7139),
    [anon_sym_AMP_AMP] = ACTIONS(7139),
    [anon_sym_LT] = ACTIONS(7137),
    [anon_sym_LT_EQ] = ACTIONS(7139),
    [anon_sym_GT] = ACTIONS(7137),
    [anon_sym_GT_EQ] = ACTIONS(7139),
    [anon_sym_EQ_EQ] = ACTIONS(7139),
    [anon_sym_BANG_EQ] = ACTIONS(7139),
    [anon_sym_STAR] = ACTIONS(7137),
    [anon_sym_SLASH] = ACTIONS(7139),
    [anon_sym_STAR_STAR] = ACTIONS(7139),
    [anon_sym_CARET] = ACTIONS(7139),
    [aux_sym_binary_operator_token1] = ACTIONS(7139),
    [anon_sym_PIPE_GT] = ACTIONS(7139),
    [anon_sym_COLON] = ACTIONS(7137),
    [anon_sym_DOLLAR] = ACTIONS(7139),
    [anon_sym_AT] = ACTIONS(7139),
    [anon_sym_COLON_COLON] = ACTIONS(7137),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7139),
    [aux_sym__hex_literal_token1] = ACTIONS(7139),
    [sym__number_literal] = ACTIONS(7137),
    [anon_sym_SQUOTE] = ACTIONS(7139),
    [anon_sym_DQUOTE] = ACTIONS(7139),
    [sym_return] = ACTIONS(7137),
    [sym_next] = ACTIONS(7137),
    [sym_break] = ACTIONS(7137),
    [sym_true] = ACTIONS(7137),
    [sym_false] = ACTIONS(7137),
    [sym_null] = ACTIONS(7137),
    [sym_inf] = ACTIONS(7137),
    [sym_nan] = ACTIONS(7137),
    [anon_sym_NA] = ACTIONS(7137),
    [anon_sym_NA_integer_] = ACTIONS(7137),
    [anon_sym_NA_real_] = ACTIONS(7137),
    [anon_sym_NA_complex_] = ACTIONS(7137),
    [anon_sym_NA_character_] = ACTIONS(7137),
    [sym_dots] = ACTIONS(7137),
    [sym_dot_dot_i] = ACTIONS(7139),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7139),
    [sym__newline] = ACTIONS(7139),
    [sym__semicolon] = ACTIONS(7139),
    [sym__raw_string_literal] = ACTIONS(7139),
    [sym__external_open_parenthesis] = ACTIONS(7139),
    [sym__external_open_brace] = ACTIONS(7139),
    [sym__external_close_brace] = ACTIONS(7139),
    [sym__external_open_bracket] = ACTIONS(7139),
    [sym__external_close_bracket] = ACTIONS(7139),
    [sym__external_open_bracket2] = ACTIONS(7139),
  },
  [2270] = {
    [sym_identifier] = ACTIONS(7137),
    [anon_sym_BSLASH] = ACTIONS(7139),
    [anon_sym_function] = ACTIONS(7137),
    [anon_sym_EQ] = ACTIONS(7137),
    [anon_sym_if] = ACTIONS(7137),
    [anon_sym_for] = ACTIONS(7137),
    [anon_sym_while] = ACTIONS(7137),
    [anon_sym_repeat] = ACTIONS(7137),
    [anon_sym_QMARK] = ACTIONS(7139),
    [anon_sym_TILDE] = ACTIONS(7139),
    [anon_sym_BANG] = ACTIONS(7137),
    [anon_sym_PLUS] = ACTIONS(7139),
    [anon_sym_DASH] = ACTIONS(7137),
    [anon_sym_LT_DASH] = ACTIONS(7139),
    [anon_sym_LT_LT_DASH] = ACTIONS(7139),
    [anon_sym_COLON_EQ] = ACTIONS(7139),
    [anon_sym_DASH_GT] = ACTIONS(7137),
    [anon_sym_DASH_GT_GT] = ACTIONS(7139),
    [anon_sym_PIPE] = ACTIONS(7137),
    [anon_sym_AMP] = ACTIONS(7137),
    [anon_sym_PIPE_PIPE] = ACTIONS(7139),
    [anon_sym_AMP_AMP] = ACTIONS(7139),
    [anon_sym_LT] = ACTIONS(7137),
    [anon_sym_LT_EQ] = ACTIONS(7139),
    [anon_sym_GT] = ACTIONS(7137),
    [anon_sym_GT_EQ] = ACTIONS(7139),
    [anon_sym_EQ_EQ] = ACTIONS(7139),
    [anon_sym_BANG_EQ] = ACTIONS(7139),
    [anon_sym_STAR] = ACTIONS(7137),
    [anon_sym_SLASH] = ACTIONS(7139),
    [anon_sym_STAR_STAR] = ACTIONS(7139),
    [anon_sym_CARET] = ACTIONS(7139),
    [aux_sym_binary_operator_token1] = ACTIONS(7139),
    [anon_sym_PIPE_GT] = ACTIONS(7139),
    [anon_sym_COLON] = ACTIONS(7137),
    [anon_sym_DOLLAR] = ACTIONS(7139),
    [anon_sym_AT] = ACTIONS(7139),
    [anon_sym_COLON_COLON] = ACTIONS(7137),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7139),
    [aux_sym__hex_literal_token1] = ACTIONS(7139),
    [sym__number_literal] = ACTIONS(7137),
    [anon_sym_SQUOTE] = ACTIONS(7139),
    [anon_sym_DQUOTE] = ACTIONS(7139),
    [sym_return] = ACTIONS(7137),
    [sym_next] = ACTIONS(7137),
    [sym_break] = ACTIONS(7137),
    [sym_true] = ACTIONS(7137),
    [sym_false] = ACTIONS(7137),
    [sym_null] = ACTIONS(7137),
    [sym_inf] = ACTIONS(7137),
    [sym_nan] = ACTIONS(7137),
    [anon_sym_NA] = ACTIONS(7137),
    [anon_sym_NA_integer_] = ACTIONS(7137),
    [anon_sym_NA_real_] = ACTIONS(7137),
    [anon_sym_NA_complex_] = ACTIONS(7137),
    [anon_sym_NA_character_] = ACTIONS(7137),
    [sym_dots] = ACTIONS(7137),
    [sym_dot_dot_i] = ACTIONS(7139),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7139),
    [sym__newline] = ACTIONS(7139),
    [sym__raw_string_literal] = ACTIONS(7139),
    [sym__external_else] = ACTIONS(7139),
    [sym__external_open_parenthesis] = ACTIONS(7139),
    [sym__external_close_parenthesis] = ACTIONS(7139),
    [sym__external_open_brace] = ACTIONS(7139),
    [sym__external_open_bracket] = ACTIONS(7139),
    [sym__external_close_bracket] = ACTIONS(7139),
    [sym__external_open_bracket2] = ACTIONS(7139),
  },
  [2271] = {
    [sym_identifier] = ACTIONS(7129),
    [anon_sym_BSLASH] = ACTIONS(7131),
    [anon_sym_function] = ACTIONS(7129),
    [anon_sym_EQ] = ACTIONS(7129),
    [anon_sym_if] = ACTIONS(7129),
    [anon_sym_for] = ACTIONS(7129),
    [anon_sym_while] = ACTIONS(7129),
    [anon_sym_repeat] = ACTIONS(7129),
    [anon_sym_QMARK] = ACTIONS(7131),
    [anon_sym_TILDE] = ACTIONS(7131),
    [anon_sym_BANG] = ACTIONS(7129),
    [anon_sym_PLUS] = ACTIONS(7131),
    [anon_sym_DASH] = ACTIONS(7129),
    [anon_sym_LT_DASH] = ACTIONS(7131),
    [anon_sym_LT_LT_DASH] = ACTIONS(7131),
    [anon_sym_COLON_EQ] = ACTIONS(7131),
    [anon_sym_DASH_GT] = ACTIONS(7129),
    [anon_sym_DASH_GT_GT] = ACTIONS(7131),
    [anon_sym_PIPE] = ACTIONS(7129),
    [anon_sym_AMP] = ACTIONS(7129),
    [anon_sym_PIPE_PIPE] = ACTIONS(7131),
    [anon_sym_AMP_AMP] = ACTIONS(7131),
    [anon_sym_LT] = ACTIONS(7129),
    [anon_sym_LT_EQ] = ACTIONS(7131),
    [anon_sym_GT] = ACTIONS(7129),
    [anon_sym_GT_EQ] = ACTIONS(7131),
    [anon_sym_EQ_EQ] = ACTIONS(7131),
    [anon_sym_BANG_EQ] = ACTIONS(7131),
    [anon_sym_STAR] = ACTIONS(7129),
    [anon_sym_SLASH] = ACTIONS(7131),
    [anon_sym_STAR_STAR] = ACTIONS(7131),
    [anon_sym_CARET] = ACTIONS(7131),
    [aux_sym_binary_operator_token1] = ACTIONS(7131),
    [anon_sym_PIPE_GT] = ACTIONS(7131),
    [anon_sym_COLON] = ACTIONS(7129),
    [anon_sym_DOLLAR] = ACTIONS(7131),
    [anon_sym_AT] = ACTIONS(7131),
    [anon_sym_COLON_COLON] = ACTIONS(7133),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7135),
    [aux_sym__hex_literal_token1] = ACTIONS(7131),
    [sym__number_literal] = ACTIONS(7129),
    [anon_sym_SQUOTE] = ACTIONS(7131),
    [anon_sym_DQUOTE] = ACTIONS(7131),
    [sym_return] = ACTIONS(7129),
    [sym_next] = ACTIONS(7129),
    [sym_break] = ACTIONS(7129),
    [sym_true] = ACTIONS(7129),
    [sym_false] = ACTIONS(7129),
    [sym_null] = ACTIONS(7129),
    [sym_inf] = ACTIONS(7129),
    [sym_nan] = ACTIONS(7129),
    [anon_sym_NA] = ACTIONS(7129),
    [anon_sym_NA_integer_] = ACTIONS(7129),
    [anon_sym_NA_real_] = ACTIONS(7129),
    [anon_sym_NA_complex_] = ACTIONS(7129),
    [anon_sym_NA_character_] = ACTIONS(7129),
    [sym_dots] = ACTIONS(7129),
    [sym_dot_dot_i] = ACTIONS(7131),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7131),
    [sym__newline] = ACTIONS(7131),
    [sym__raw_string_literal] = ACTIONS(7131),
    [sym__external_else] = ACTIONS(7131),
    [sym__external_open_parenthesis] = ACTIONS(7131),
    [sym__external_close_parenthesis] = ACTIONS(7131),
    [sym__external_open_brace] = ACTIONS(7131),
    [sym__external_open_bracket] = ACTIONS(7131),
    [sym__external_close_bracket] = ACTIONS(7131),
    [sym__external_open_bracket2] = ACTIONS(7131),
  },
  [2272] = {
    [sym_identifier] = ACTIONS(7121),
    [anon_sym_BSLASH] = ACTIONS(7123),
    [anon_sym_function] = ACTIONS(7121),
    [anon_sym_EQ] = ACTIONS(7121),
    [anon_sym_if] = ACTIONS(7121),
    [anon_sym_for] = ACTIONS(7121),
    [anon_sym_while] = ACTIONS(7121),
    [anon_sym_repeat] = ACTIONS(7121),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_TILDE] = ACTIONS(7123),
    [anon_sym_BANG] = ACTIONS(7121),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_DASH] = ACTIONS(7121),
    [anon_sym_LT_DASH] = ACTIONS(7123),
    [anon_sym_LT_LT_DASH] = ACTIONS(7123),
    [anon_sym_COLON_EQ] = ACTIONS(7123),
    [anon_sym_DASH_GT] = ACTIONS(7121),
    [anon_sym_DASH_GT_GT] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_LT_EQ] = ACTIONS(7123),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
    [aux_sym_binary_operator_token1] = ACTIONS(7123),
    [anon_sym_PIPE_GT] = ACTIONS(7123),
    [anon_sym_COLON] = ACTIONS(7121),
    [anon_sym_DOLLAR] = ACTIONS(7123),
    [anon_sym_AT] = ACTIONS(7123),
    [anon_sym_L] = ACTIONS(7546),
    [anon_sym_i] = ACTIONS(7548),
    [aux_sym__hex_literal_token1] = ACTIONS(7123),
    [sym__number_literal] = ACTIONS(7121),
    [anon_sym_SQUOTE] = ACTIONS(7123),
    [anon_sym_DQUOTE] = ACTIONS(7123),
    [sym_return] = ACTIONS(7121),
    [sym_next] = ACTIONS(7121),
    [sym_break] = ACTIONS(7121),
    [sym_true] = ACTIONS(7121),
    [sym_false] = ACTIONS(7121),
    [sym_null] = ACTIONS(7121),
    [sym_inf] = ACTIONS(7121),
    [sym_nan] = ACTIONS(7121),
    [anon_sym_NA] = ACTIONS(7121),
    [anon_sym_NA_integer_] = ACTIONS(7121),
    [anon_sym_NA_real_] = ACTIONS(7121),
    [anon_sym_NA_complex_] = ACTIONS(7121),
    [anon_sym_NA_character_] = ACTIONS(7121),
    [sym_dots] = ACTIONS(7121),
    [sym_dot_dot_i] = ACTIONS(7123),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7123),
    [sym__newline] = ACTIONS(7123),
    [sym__raw_string_literal] = ACTIONS(7123),
    [sym__external_else] = ACTIONS(7123),
    [sym__external_open_parenthesis] = ACTIONS(7123),
    [sym__external_close_parenthesis] = ACTIONS(7123),
    [sym__external_open_brace] = ACTIONS(7123),
    [sym__external_open_bracket] = ACTIONS(7123),
    [sym__external_close_bracket] = ACTIONS(7123),
    [sym__external_open_bracket2] = ACTIONS(7123),
  },
  [2273] = {
    [sym_identifier] = ACTIONS(7115),
    [anon_sym_BSLASH] = ACTIONS(7117),
    [anon_sym_function] = ACTIONS(7115),
    [anon_sym_EQ] = ACTIONS(7115),
    [anon_sym_if] = ACTIONS(7115),
    [anon_sym_for] = ACTIONS(7115),
    [anon_sym_while] = ACTIONS(7115),
    [anon_sym_repeat] = ACTIONS(7115),
    [anon_sym_QMARK] = ACTIONS(7117),
    [anon_sym_TILDE] = ACTIONS(7117),
    [anon_sym_BANG] = ACTIONS(7115),
    [anon_sym_PLUS] = ACTIONS(7117),
    [anon_sym_DASH] = ACTIONS(7115),
    [anon_sym_LT_DASH] = ACTIONS(7117),
    [anon_sym_LT_LT_DASH] = ACTIONS(7117),
    [anon_sym_COLON_EQ] = ACTIONS(7117),
    [anon_sym_DASH_GT] = ACTIONS(7115),
    [anon_sym_DASH_GT_GT] = ACTIONS(7117),
    [anon_sym_PIPE] = ACTIONS(7115),
    [anon_sym_AMP] = ACTIONS(7115),
    [anon_sym_PIPE_PIPE] = ACTIONS(7117),
    [anon_sym_AMP_AMP] = ACTIONS(7117),
    [anon_sym_LT] = ACTIONS(7115),
    [anon_sym_LT_EQ] = ACTIONS(7117),
    [anon_sym_GT] = ACTIONS(7115),
    [anon_sym_GT_EQ] = ACTIONS(7117),
    [anon_sym_EQ_EQ] = ACTIONS(7117),
    [anon_sym_BANG_EQ] = ACTIONS(7117),
    [anon_sym_STAR] = ACTIONS(7115),
    [anon_sym_SLASH] = ACTIONS(7117),
    [anon_sym_STAR_STAR] = ACTIONS(7117),
    [anon_sym_CARET] = ACTIONS(7117),
    [aux_sym_binary_operator_token1] = ACTIONS(7117),
    [anon_sym_PIPE_GT] = ACTIONS(7117),
    [anon_sym_COLON] = ACTIONS(7115),
    [anon_sym_DOLLAR] = ACTIONS(7117),
    [anon_sym_AT] = ACTIONS(7117),
    [anon_sym_COLON_COLON] = ACTIONS(7115),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7117),
    [aux_sym__hex_literal_token1] = ACTIONS(7117),
    [sym__number_literal] = ACTIONS(7115),
    [anon_sym_SQUOTE] = ACTIONS(7117),
    [anon_sym_DQUOTE] = ACTIONS(7117),
    [sym_return] = ACTIONS(7115),
    [sym_next] = ACTIONS(7115),
    [sym_break] = ACTIONS(7115),
    [sym_true] = ACTIONS(7115),
    [sym_false] = ACTIONS(7115),
    [sym_null] = ACTIONS(7115),
    [sym_inf] = ACTIONS(7115),
    [sym_nan] = ACTIONS(7115),
    [anon_sym_NA] = ACTIONS(7115),
    [anon_sym_NA_integer_] = ACTIONS(7115),
    [anon_sym_NA_real_] = ACTIONS(7115),
    [anon_sym_NA_complex_] = ACTIONS(7115),
    [anon_sym_NA_character_] = ACTIONS(7115),
    [sym_dots] = ACTIONS(7115),
    [sym_dot_dot_i] = ACTIONS(7117),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7117),
    [sym__newline] = ACTIONS(7117),
    [sym__raw_string_literal] = ACTIONS(7117),
    [sym__external_else] = ACTIONS(7117),
    [sym__external_open_parenthesis] = ACTIONS(7117),
    [sym__external_close_parenthesis] = ACTIONS(7117),
    [sym__external_open_brace] = ACTIONS(7117),
    [sym__external_open_bracket] = ACTIONS(7117),
    [sym__external_close_bracket] = ACTIONS(7117),
    [sym__external_open_bracket2] = ACTIONS(7117),
  },
  [2274] = {
    [sym_identifier] = ACTIONS(7115),
    [anon_sym_BSLASH] = ACTIONS(7117),
    [anon_sym_function] = ACTIONS(7115),
    [anon_sym_EQ] = ACTIONS(7115),
    [anon_sym_if] = ACTIONS(7115),
    [anon_sym_for] = ACTIONS(7115),
    [anon_sym_while] = ACTIONS(7115),
    [anon_sym_repeat] = ACTIONS(7115),
    [anon_sym_QMARK] = ACTIONS(7117),
    [anon_sym_TILDE] = ACTIONS(7117),
    [anon_sym_BANG] = ACTIONS(7115),
    [anon_sym_PLUS] = ACTIONS(7117),
    [anon_sym_DASH] = ACTIONS(7115),
    [anon_sym_LT_DASH] = ACTIONS(7117),
    [anon_sym_LT_LT_DASH] = ACTIONS(7117),
    [anon_sym_COLON_EQ] = ACTIONS(7117),
    [anon_sym_DASH_GT] = ACTIONS(7115),
    [anon_sym_DASH_GT_GT] = ACTIONS(7117),
    [anon_sym_PIPE] = ACTIONS(7115),
    [anon_sym_AMP] = ACTIONS(7115),
    [anon_sym_PIPE_PIPE] = ACTIONS(7117),
    [anon_sym_AMP_AMP] = ACTIONS(7117),
    [anon_sym_LT] = ACTIONS(7115),
    [anon_sym_LT_EQ] = ACTIONS(7117),
    [anon_sym_GT] = ACTIONS(7115),
    [anon_sym_GT_EQ] = ACTIONS(7117),
    [anon_sym_EQ_EQ] = ACTIONS(7117),
    [anon_sym_BANG_EQ] = ACTIONS(7117),
    [anon_sym_STAR] = ACTIONS(7115),
    [anon_sym_SLASH] = ACTIONS(7117),
    [anon_sym_STAR_STAR] = ACTIONS(7117),
    [anon_sym_CARET] = ACTIONS(7117),
    [aux_sym_binary_operator_token1] = ACTIONS(7117),
    [anon_sym_PIPE_GT] = ACTIONS(7117),
    [anon_sym_COLON] = ACTIONS(7115),
    [anon_sym_DOLLAR] = ACTIONS(7117),
    [anon_sym_AT] = ACTIONS(7117),
    [anon_sym_COLON_COLON] = ACTIONS(7115),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7117),
    [aux_sym__hex_literal_token1] = ACTIONS(7117),
    [sym__number_literal] = ACTIONS(7115),
    [anon_sym_SQUOTE] = ACTIONS(7117),
    [anon_sym_DQUOTE] = ACTIONS(7117),
    [sym_return] = ACTIONS(7115),
    [sym_next] = ACTIONS(7115),
    [sym_break] = ACTIONS(7115),
    [sym_true] = ACTIONS(7115),
    [sym_false] = ACTIONS(7115),
    [sym_null] = ACTIONS(7115),
    [sym_inf] = ACTIONS(7115),
    [sym_nan] = ACTIONS(7115),
    [anon_sym_NA] = ACTIONS(7115),
    [anon_sym_NA_integer_] = ACTIONS(7115),
    [anon_sym_NA_real_] = ACTIONS(7115),
    [anon_sym_NA_complex_] = ACTIONS(7115),
    [anon_sym_NA_character_] = ACTIONS(7115),
    [sym_dots] = ACTIONS(7115),
    [sym_dot_dot_i] = ACTIONS(7117),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7117),
    [sym__newline] = ACTIONS(7117),
    [sym__raw_string_literal] = ACTIONS(7117),
    [sym__external_else] = ACTIONS(7117),
    [sym__external_open_parenthesis] = ACTIONS(7117),
    [sym__external_close_parenthesis] = ACTIONS(7117),
    [sym__external_open_brace] = ACTIONS(7117),
    [sym__external_open_bracket] = ACTIONS(7117),
    [sym__external_close_bracket] = ACTIONS(7117),
    [sym__external_open_bracket2] = ACTIONS(7117),
  },
  [2275] = {
    [ts_builtin_sym_end] = ACTIONS(7550),
    [sym_identifier] = ACTIONS(7552),
    [anon_sym_BSLASH] = ACTIONS(7550),
    [anon_sym_function] = ACTIONS(7552),
    [anon_sym_EQ] = ACTIONS(7552),
    [anon_sym_if] = ACTIONS(7552),
    [anon_sym_for] = ACTIONS(7552),
    [anon_sym_while] = ACTIONS(7552),
    [anon_sym_repeat] = ACTIONS(7552),
    [anon_sym_QMARK] = ACTIONS(7550),
    [anon_sym_TILDE] = ACTIONS(7550),
    [anon_sym_BANG] = ACTIONS(7552),
    [anon_sym_PLUS] = ACTIONS(7550),
    [anon_sym_DASH] = ACTIONS(7552),
    [anon_sym_LT_DASH] = ACTIONS(7550),
    [anon_sym_LT_LT_DASH] = ACTIONS(7550),
    [anon_sym_COLON_EQ] = ACTIONS(7550),
    [anon_sym_DASH_GT] = ACTIONS(7552),
    [anon_sym_DASH_GT_GT] = ACTIONS(7550),
    [anon_sym_PIPE] = ACTIONS(7552),
    [anon_sym_AMP] = ACTIONS(7552),
    [anon_sym_PIPE_PIPE] = ACTIONS(7550),
    [anon_sym_AMP_AMP] = ACTIONS(7550),
    [anon_sym_LT] = ACTIONS(7552),
    [anon_sym_LT_EQ] = ACTIONS(7550),
    [anon_sym_GT] = ACTIONS(7552),
    [anon_sym_GT_EQ] = ACTIONS(7550),
    [anon_sym_EQ_EQ] = ACTIONS(7550),
    [anon_sym_BANG_EQ] = ACTIONS(7550),
    [anon_sym_STAR] = ACTIONS(7552),
    [anon_sym_SLASH] = ACTIONS(7550),
    [anon_sym_STAR_STAR] = ACTIONS(7550),
    [anon_sym_CARET] = ACTIONS(7550),
    [aux_sym_binary_operator_token1] = ACTIONS(7550),
    [anon_sym_PIPE_GT] = ACTIONS(7550),
    [anon_sym_COLON] = ACTIONS(7552),
    [anon_sym_DOLLAR] = ACTIONS(7550),
    [anon_sym_AT] = ACTIONS(7550),
    [aux_sym__hex_literal_token1] = ACTIONS(7550),
    [sym__number_literal] = ACTIONS(7552),
    [anon_sym_SQUOTE] = ACTIONS(7550),
    [anon_sym_DQUOTE] = ACTIONS(7550),
    [sym_return] = ACTIONS(7552),
    [sym_next] = ACTIONS(7552),
    [sym_break] = ACTIONS(7552),
    [sym_true] = ACTIONS(7552),
    [sym_false] = ACTIONS(7552),
    [sym_null] = ACTIONS(7552),
    [sym_inf] = ACTIONS(7552),
    [sym_nan] = ACTIONS(7552),
    [anon_sym_NA] = ACTIONS(7552),
    [anon_sym_NA_integer_] = ACTIONS(7552),
    [anon_sym_NA_real_] = ACTIONS(7552),
    [anon_sym_NA_complex_] = ACTIONS(7552),
    [anon_sym_NA_character_] = ACTIONS(7552),
    [sym_dots] = ACTIONS(7552),
    [sym_dot_dot_i] = ACTIONS(7550),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7550),
    [sym__newline] = ACTIONS(7550),
    [sym__semicolon] = ACTIONS(7550),
    [sym__raw_string_literal] = ACTIONS(7550),
    [sym__external_else] = ACTIONS(7550),
    [sym__external_open_parenthesis] = ACTIONS(7550),
    [sym__external_close_parenthesis] = ACTIONS(7550),
    [sym__external_open_brace] = ACTIONS(7550),
    [sym__external_close_brace] = ACTIONS(7550),
    [sym__external_open_bracket] = ACTIONS(7550),
    [sym__external_open_bracket2] = ACTIONS(7550),
  },
  [2276] = {
    [sym_identifier] = ACTIONS(7151),
    [anon_sym_BSLASH] = ACTIONS(7153),
    [anon_sym_function] = ACTIONS(7151),
    [anon_sym_EQ] = ACTIONS(7151),
    [anon_sym_if] = ACTIONS(7151),
    [anon_sym_for] = ACTIONS(7151),
    [anon_sym_while] = ACTIONS(7151),
    [anon_sym_repeat] = ACTIONS(7151),
    [anon_sym_QMARK] = ACTIONS(7153),
    [anon_sym_TILDE] = ACTIONS(7153),
    [anon_sym_BANG] = ACTIONS(7151),
    [anon_sym_PLUS] = ACTIONS(7153),
    [anon_sym_DASH] = ACTIONS(7151),
    [anon_sym_LT_DASH] = ACTIONS(7153),
    [anon_sym_LT_LT_DASH] = ACTIONS(7153),
    [anon_sym_COLON_EQ] = ACTIONS(7153),
    [anon_sym_DASH_GT] = ACTIONS(7151),
    [anon_sym_DASH_GT_GT] = ACTIONS(7153),
    [anon_sym_PIPE] = ACTIONS(7151),
    [anon_sym_AMP] = ACTIONS(7151),
    [anon_sym_PIPE_PIPE] = ACTIONS(7153),
    [anon_sym_AMP_AMP] = ACTIONS(7153),
    [anon_sym_LT] = ACTIONS(7151),
    [anon_sym_LT_EQ] = ACTIONS(7153),
    [anon_sym_GT] = ACTIONS(7151),
    [anon_sym_GT_EQ] = ACTIONS(7153),
    [anon_sym_EQ_EQ] = ACTIONS(7153),
    [anon_sym_BANG_EQ] = ACTIONS(7153),
    [anon_sym_STAR] = ACTIONS(7151),
    [anon_sym_SLASH] = ACTIONS(7153),
    [anon_sym_STAR_STAR] = ACTIONS(7153),
    [anon_sym_CARET] = ACTIONS(7153),
    [aux_sym_binary_operator_token1] = ACTIONS(7153),
    [anon_sym_PIPE_GT] = ACTIONS(7153),
    [anon_sym_COLON] = ACTIONS(7151),
    [anon_sym_DOLLAR] = ACTIONS(7153),
    [anon_sym_AT] = ACTIONS(7153),
    [anon_sym_COLON_COLON] = ACTIONS(7151),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7153),
    [aux_sym__hex_literal_token1] = ACTIONS(7153),
    [sym__number_literal] = ACTIONS(7151),
    [anon_sym_SQUOTE] = ACTIONS(7153),
    [anon_sym_DQUOTE] = ACTIONS(7153),
    [sym_return] = ACTIONS(7151),
    [sym_next] = ACTIONS(7151),
    [sym_break] = ACTIONS(7151),
    [sym_true] = ACTIONS(7151),
    [sym_false] = ACTIONS(7151),
    [sym_null] = ACTIONS(7151),
    [sym_inf] = ACTIONS(7151),
    [sym_nan] = ACTIONS(7151),
    [anon_sym_NA] = ACTIONS(7151),
    [anon_sym_NA_integer_] = ACTIONS(7151),
    [anon_sym_NA_real_] = ACTIONS(7151),
    [anon_sym_NA_complex_] = ACTIONS(7151),
    [anon_sym_NA_character_] = ACTIONS(7151),
    [sym_dots] = ACTIONS(7151),
    [sym_dot_dot_i] = ACTIONS(7153),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7153),
    [sym__newline] = ACTIONS(7153),
    [sym__raw_string_literal] = ACTIONS(7153),
    [sym__external_else] = ACTIONS(7153),
    [sym__external_open_parenthesis] = ACTIONS(7153),
    [sym__external_close_parenthesis] = ACTIONS(7153),
    [sym__external_open_brace] = ACTIONS(7153),
    [sym__external_open_bracket] = ACTIONS(7153),
    [sym__external_close_bracket] = ACTIONS(7153),
    [sym__external_open_bracket2] = ACTIONS(7153),
  },
  [2277] = {
    [sym_identifier] = ACTIONS(7163),
    [anon_sym_BSLASH] = ACTIONS(7165),
    [anon_sym_function] = ACTIONS(7163),
    [anon_sym_EQ] = ACTIONS(7163),
    [anon_sym_if] = ACTIONS(7163),
    [anon_sym_for] = ACTIONS(7163),
    [anon_sym_while] = ACTIONS(7163),
    [anon_sym_repeat] = ACTIONS(7163),
    [anon_sym_QMARK] = ACTIONS(7165),
    [anon_sym_TILDE] = ACTIONS(7165),
    [anon_sym_BANG] = ACTIONS(7163),
    [anon_sym_PLUS] = ACTIONS(7165),
    [anon_sym_DASH] = ACTIONS(7163),
    [anon_sym_LT_DASH] = ACTIONS(7165),
    [anon_sym_LT_LT_DASH] = ACTIONS(7165),
    [anon_sym_COLON_EQ] = ACTIONS(7165),
    [anon_sym_DASH_GT] = ACTIONS(7163),
    [anon_sym_DASH_GT_GT] = ACTIONS(7165),
    [anon_sym_PIPE] = ACTIONS(7163),
    [anon_sym_AMP] = ACTIONS(7163),
    [anon_sym_PIPE_PIPE] = ACTIONS(7165),
    [anon_sym_AMP_AMP] = ACTIONS(7165),
    [anon_sym_LT] = ACTIONS(7163),
    [anon_sym_LT_EQ] = ACTIONS(7165),
    [anon_sym_GT] = ACTIONS(7163),
    [anon_sym_GT_EQ] = ACTIONS(7165),
    [anon_sym_EQ_EQ] = ACTIONS(7165),
    [anon_sym_BANG_EQ] = ACTIONS(7165),
    [anon_sym_STAR] = ACTIONS(7163),
    [anon_sym_SLASH] = ACTIONS(7165),
    [anon_sym_STAR_STAR] = ACTIONS(7165),
    [anon_sym_CARET] = ACTIONS(7165),
    [aux_sym_binary_operator_token1] = ACTIONS(7165),
    [anon_sym_PIPE_GT] = ACTIONS(7165),
    [anon_sym_COLON] = ACTIONS(7163),
    [anon_sym_DOLLAR] = ACTIONS(7165),
    [anon_sym_AT] = ACTIONS(7165),
    [anon_sym_COLON_COLON] = ACTIONS(7163),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7165),
    [aux_sym__hex_literal_token1] = ACTIONS(7165),
    [sym__number_literal] = ACTIONS(7163),
    [anon_sym_SQUOTE] = ACTIONS(7165),
    [anon_sym_DQUOTE] = ACTIONS(7165),
    [sym_return] = ACTIONS(7163),
    [sym_next] = ACTIONS(7163),
    [sym_break] = ACTIONS(7163),
    [sym_true] = ACTIONS(7163),
    [sym_false] = ACTIONS(7163),
    [sym_null] = ACTIONS(7163),
    [sym_inf] = ACTIONS(7163),
    [sym_nan] = ACTIONS(7163),
    [anon_sym_NA] = ACTIONS(7163),
    [anon_sym_NA_integer_] = ACTIONS(7163),
    [anon_sym_NA_real_] = ACTIONS(7163),
    [anon_sym_NA_complex_] = ACTIONS(7163),
    [anon_sym_NA_character_] = ACTIONS(7163),
    [sym_dots] = ACTIONS(7163),
    [sym_dot_dot_i] = ACTIONS(7165),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7165),
    [sym__newline] = ACTIONS(7165),
    [sym__raw_string_literal] = ACTIONS(7165),
    [sym__external_else] = ACTIONS(7165),
    [sym__external_open_parenthesis] = ACTIONS(7165),
    [sym__external_close_parenthesis] = ACTIONS(7165),
    [sym__external_open_brace] = ACTIONS(7165),
    [sym__external_open_bracket] = ACTIONS(7165),
    [sym__external_close_bracket] = ACTIONS(7165),
    [sym__external_open_bracket2] = ACTIONS(7165),
  },
  [2278] = {
    [sym_identifier] = ACTIONS(7191),
    [anon_sym_BSLASH] = ACTIONS(7189),
    [anon_sym_function] = ACTIONS(7191),
    [anon_sym_EQ] = ACTIONS(7191),
    [anon_sym_if] = ACTIONS(7191),
    [anon_sym_for] = ACTIONS(7191),
    [anon_sym_while] = ACTIONS(7191),
    [anon_sym_repeat] = ACTIONS(7191),
    [anon_sym_QMARK] = ACTIONS(7189),
    [anon_sym_TILDE] = ACTIONS(7189),
    [anon_sym_BANG] = ACTIONS(7191),
    [anon_sym_PLUS] = ACTIONS(7189),
    [anon_sym_DASH] = ACTIONS(7191),
    [anon_sym_LT_DASH] = ACTIONS(7189),
    [anon_sym_LT_LT_DASH] = ACTIONS(7189),
    [anon_sym_COLON_EQ] = ACTIONS(7189),
    [anon_sym_DASH_GT] = ACTIONS(7191),
    [anon_sym_DASH_GT_GT] = ACTIONS(7189),
    [anon_sym_PIPE] = ACTIONS(7191),
    [anon_sym_AMP] = ACTIONS(7191),
    [anon_sym_PIPE_PIPE] = ACTIONS(7189),
    [anon_sym_AMP_AMP] = ACTIONS(7189),
    [anon_sym_LT] = ACTIONS(7191),
    [anon_sym_LT_EQ] = ACTIONS(7189),
    [anon_sym_GT] = ACTIONS(7191),
    [anon_sym_GT_EQ] = ACTIONS(7189),
    [anon_sym_EQ_EQ] = ACTIONS(7189),
    [anon_sym_BANG_EQ] = ACTIONS(7189),
    [anon_sym_STAR] = ACTIONS(7191),
    [anon_sym_SLASH] = ACTIONS(7189),
    [anon_sym_STAR_STAR] = ACTIONS(7189),
    [anon_sym_CARET] = ACTIONS(7189),
    [aux_sym_binary_operator_token1] = ACTIONS(7189),
    [anon_sym_PIPE_GT] = ACTIONS(7189),
    [anon_sym_COLON] = ACTIONS(7191),
    [anon_sym_DOLLAR] = ACTIONS(7189),
    [anon_sym_AT] = ACTIONS(7189),
    [anon_sym_COLON_COLON] = ACTIONS(7191),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7189),
    [aux_sym__hex_literal_token1] = ACTIONS(7189),
    [sym__number_literal] = ACTIONS(7191),
    [anon_sym_SQUOTE] = ACTIONS(7189),
    [anon_sym_DQUOTE] = ACTIONS(7189),
    [sym_return] = ACTIONS(7191),
    [sym_next] = ACTIONS(7191),
    [sym_break] = ACTIONS(7191),
    [sym_true] = ACTIONS(7191),
    [sym_false] = ACTIONS(7191),
    [sym_null] = ACTIONS(7191),
    [sym_inf] = ACTIONS(7191),
    [sym_nan] = ACTIONS(7191),
    [anon_sym_NA] = ACTIONS(7191),
    [anon_sym_NA_integer_] = ACTIONS(7191),
    [anon_sym_NA_real_] = ACTIONS(7191),
    [anon_sym_NA_complex_] = ACTIONS(7191),
    [anon_sym_NA_character_] = ACTIONS(7191),
    [sym_dots] = ACTIONS(7191),
    [sym_dot_dot_i] = ACTIONS(7189),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7189),
    [sym__newline] = ACTIONS(7189),
    [sym__raw_string_literal] = ACTIONS(7189),
    [sym__external_else] = ACTIONS(7189),
    [sym__external_open_parenthesis] = ACTIONS(7189),
    [sym__external_close_parenthesis] = ACTIONS(7189),
    [sym__external_open_brace] = ACTIONS(7189),
    [sym__external_open_bracket] = ACTIONS(7189),
    [sym__external_close_bracket] = ACTIONS(7189),
    [sym__external_open_bracket2] = ACTIONS(7189),
  },
  [2279] = {
    [sym_identifier] = ACTIONS(7195),
    [anon_sym_BSLASH] = ACTIONS(7193),
    [anon_sym_function] = ACTIONS(7195),
    [anon_sym_EQ] = ACTIONS(7195),
    [anon_sym_if] = ACTIONS(7195),
    [anon_sym_for] = ACTIONS(7195),
    [anon_sym_while] = ACTIONS(7195),
    [anon_sym_repeat] = ACTIONS(7195),
    [anon_sym_QMARK] = ACTIONS(7193),
    [anon_sym_TILDE] = ACTIONS(7193),
    [anon_sym_BANG] = ACTIONS(7195),
    [anon_sym_PLUS] = ACTIONS(7193),
    [anon_sym_DASH] = ACTIONS(7195),
    [anon_sym_LT_DASH] = ACTIONS(7193),
    [anon_sym_LT_LT_DASH] = ACTIONS(7193),
    [anon_sym_COLON_EQ] = ACTIONS(7193),
    [anon_sym_DASH_GT] = ACTIONS(7195),
    [anon_sym_DASH_GT_GT] = ACTIONS(7193),
    [anon_sym_PIPE] = ACTIONS(7195),
    [anon_sym_AMP] = ACTIONS(7195),
    [anon_sym_PIPE_PIPE] = ACTIONS(7193),
    [anon_sym_AMP_AMP] = ACTIONS(7193),
    [anon_sym_LT] = ACTIONS(7195),
    [anon_sym_LT_EQ] = ACTIONS(7193),
    [anon_sym_GT] = ACTIONS(7195),
    [anon_sym_GT_EQ] = ACTIONS(7193),
    [anon_sym_EQ_EQ] = ACTIONS(7193),
    [anon_sym_BANG_EQ] = ACTIONS(7193),
    [anon_sym_STAR] = ACTIONS(7195),
    [anon_sym_SLASH] = ACTIONS(7193),
    [anon_sym_STAR_STAR] = ACTIONS(7193),
    [anon_sym_CARET] = ACTIONS(7193),
    [aux_sym_binary_operator_token1] = ACTIONS(7193),
    [anon_sym_PIPE_GT] = ACTIONS(7193),
    [anon_sym_COLON] = ACTIONS(7195),
    [anon_sym_DOLLAR] = ACTIONS(7193),
    [anon_sym_AT] = ACTIONS(7193),
    [anon_sym_COLON_COLON] = ACTIONS(7195),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7193),
    [aux_sym__hex_literal_token1] = ACTIONS(7193),
    [sym__number_literal] = ACTIONS(7195),
    [anon_sym_SQUOTE] = ACTIONS(7193),
    [anon_sym_DQUOTE] = ACTIONS(7193),
    [sym_return] = ACTIONS(7195),
    [sym_next] = ACTIONS(7195),
    [sym_break] = ACTIONS(7195),
    [sym_true] = ACTIONS(7195),
    [sym_false] = ACTIONS(7195),
    [sym_null] = ACTIONS(7195),
    [sym_inf] = ACTIONS(7195),
    [sym_nan] = ACTIONS(7195),
    [anon_sym_NA] = ACTIONS(7195),
    [anon_sym_NA_integer_] = ACTIONS(7195),
    [anon_sym_NA_real_] = ACTIONS(7195),
    [anon_sym_NA_complex_] = ACTIONS(7195),
    [anon_sym_NA_character_] = ACTIONS(7195),
    [sym_dots] = ACTIONS(7195),
    [sym_dot_dot_i] = ACTIONS(7193),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7193),
    [sym__newline] = ACTIONS(7193),
    [sym__raw_string_literal] = ACTIONS(7193),
    [sym__external_else] = ACTIONS(7193),
    [sym__external_open_parenthesis] = ACTIONS(7193),
    [sym__external_close_parenthesis] = ACTIONS(7193),
    [sym__external_open_brace] = ACTIONS(7193),
    [sym__external_open_bracket] = ACTIONS(7193),
    [sym__external_close_bracket] = ACTIONS(7193),
    [sym__external_open_bracket2] = ACTIONS(7193),
  },
  [2280] = {
    [ts_builtin_sym_end] = ACTIONS(7554),
    [sym_identifier] = ACTIONS(7556),
    [anon_sym_BSLASH] = ACTIONS(7554),
    [anon_sym_function] = ACTIONS(7556),
    [anon_sym_EQ] = ACTIONS(7556),
    [anon_sym_if] = ACTIONS(7556),
    [anon_sym_for] = ACTIONS(7556),
    [anon_sym_while] = ACTIONS(7556),
    [anon_sym_repeat] = ACTIONS(7556),
    [anon_sym_QMARK] = ACTIONS(7554),
    [anon_sym_TILDE] = ACTIONS(7554),
    [anon_sym_BANG] = ACTIONS(7556),
    [anon_sym_PLUS] = ACTIONS(7554),
    [anon_sym_DASH] = ACTIONS(7556),
    [anon_sym_LT_DASH] = ACTIONS(7554),
    [anon_sym_LT_LT_DASH] = ACTIONS(7554),
    [anon_sym_COLON_EQ] = ACTIONS(7554),
    [anon_sym_DASH_GT] = ACTIONS(7556),
    [anon_sym_DASH_GT_GT] = ACTIONS(7554),
    [anon_sym_PIPE] = ACTIONS(7556),
    [anon_sym_AMP] = ACTIONS(7556),
    [anon_sym_PIPE_PIPE] = ACTIONS(7554),
    [anon_sym_AMP_AMP] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(7556),
    [anon_sym_LT_EQ] = ACTIONS(7554),
    [anon_sym_GT] = ACTIONS(7556),
    [anon_sym_GT_EQ] = ACTIONS(7554),
    [anon_sym_EQ_EQ] = ACTIONS(7554),
    [anon_sym_BANG_EQ] = ACTIONS(7554),
    [anon_sym_STAR] = ACTIONS(7556),
    [anon_sym_SLASH] = ACTIONS(7554),
    [anon_sym_STAR_STAR] = ACTIONS(7554),
    [anon_sym_CARET] = ACTIONS(7554),
    [aux_sym_binary_operator_token1] = ACTIONS(7554),
    [anon_sym_PIPE_GT] = ACTIONS(7554),
    [anon_sym_COLON] = ACTIONS(7556),
    [anon_sym_DOLLAR] = ACTIONS(7554),
    [anon_sym_AT] = ACTIONS(7554),
    [aux_sym__hex_literal_token1] = ACTIONS(7554),
    [sym__number_literal] = ACTIONS(7556),
    [anon_sym_SQUOTE] = ACTIONS(7554),
    [anon_sym_DQUOTE] = ACTIONS(7554),
    [sym_return] = ACTIONS(7556),
    [sym_next] = ACTIONS(7556),
    [sym_break] = ACTIONS(7556),
    [sym_true] = ACTIONS(7556),
    [sym_false] = ACTIONS(7556),
    [sym_null] = ACTIONS(7556),
    [sym_inf] = ACTIONS(7556),
    [sym_nan] = ACTIONS(7556),
    [anon_sym_NA] = ACTIONS(7556),
    [anon_sym_NA_integer_] = ACTIONS(7556),
    [anon_sym_NA_real_] = ACTIONS(7556),
    [anon_sym_NA_complex_] = ACTIONS(7556),
    [anon_sym_NA_character_] = ACTIONS(7556),
    [sym_dots] = ACTIONS(7556),
    [sym_dot_dot_i] = ACTIONS(7554),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7554),
    [sym__newline] = ACTIONS(7554),
    [sym__semicolon] = ACTIONS(7554),
    [sym__raw_string_literal] = ACTIONS(7554),
    [sym__external_else] = ACTIONS(7554),
    [sym__external_open_parenthesis] = ACTIONS(7554),
    [sym__external_close_parenthesis] = ACTIONS(7554),
    [sym__external_open_brace] = ACTIONS(7554),
    [sym__external_close_brace] = ACTIONS(7554),
    [sym__external_open_bracket] = ACTIONS(7554),
    [sym__external_open_bracket2] = ACTIONS(7554),
  },
  [2281] = {
    [aux_sym_function_definition_repeat1] = STATE(2281),
    [ts_builtin_sym_end] = ACTIONS(7417),
    [sym_identifier] = ACTIONS(7419),
    [anon_sym_BSLASH] = ACTIONS(7417),
    [anon_sym_function] = ACTIONS(7419),
    [anon_sym_EQ] = ACTIONS(7419),
    [anon_sym_if] = ACTIONS(7419),
    [anon_sym_for] = ACTIONS(7419),
    [anon_sym_while] = ACTIONS(7419),
    [anon_sym_repeat] = ACTIONS(7419),
    [anon_sym_QMARK] = ACTIONS(7417),
    [anon_sym_TILDE] = ACTIONS(7417),
    [anon_sym_BANG] = ACTIONS(7419),
    [anon_sym_PLUS] = ACTIONS(7417),
    [anon_sym_DASH] = ACTIONS(7419),
    [anon_sym_LT_DASH] = ACTIONS(7417),
    [anon_sym_LT_LT_DASH] = ACTIONS(7417),
    [anon_sym_COLON_EQ] = ACTIONS(7417),
    [anon_sym_DASH_GT] = ACTIONS(7419),
    [anon_sym_DASH_GT_GT] = ACTIONS(7417),
    [anon_sym_PIPE] = ACTIONS(7419),
    [anon_sym_AMP] = ACTIONS(7419),
    [anon_sym_PIPE_PIPE] = ACTIONS(7417),
    [anon_sym_AMP_AMP] = ACTIONS(7417),
    [anon_sym_LT] = ACTIONS(7419),
    [anon_sym_LT_EQ] = ACTIONS(7417),
    [anon_sym_GT] = ACTIONS(7419),
    [anon_sym_GT_EQ] = ACTIONS(7417),
    [anon_sym_EQ_EQ] = ACTIONS(7417),
    [anon_sym_BANG_EQ] = ACTIONS(7417),
    [anon_sym_STAR] = ACTIONS(7419),
    [anon_sym_SLASH] = ACTIONS(7417),
    [anon_sym_STAR_STAR] = ACTIONS(7417),
    [anon_sym_CARET] = ACTIONS(7417),
    [aux_sym_binary_operator_token1] = ACTIONS(7417),
    [anon_sym_PIPE_GT] = ACTIONS(7417),
    [anon_sym_COLON] = ACTIONS(7419),
    [anon_sym_DOLLAR] = ACTIONS(7417),
    [anon_sym_AT] = ACTIONS(7417),
    [aux_sym__hex_literal_token1] = ACTIONS(7417),
    [sym__number_literal] = ACTIONS(7419),
    [anon_sym_SQUOTE] = ACTIONS(7417),
    [anon_sym_DQUOTE] = ACTIONS(7417),
    [sym_return] = ACTIONS(7419),
    [sym_next] = ACTIONS(7419),
    [sym_break] = ACTIONS(7419),
    [sym_true] = ACTIONS(7419),
    [sym_false] = ACTIONS(7419),
    [sym_null] = ACTIONS(7419),
    [sym_inf] = ACTIONS(7419),
    [sym_nan] = ACTIONS(7419),
    [anon_sym_NA] = ACTIONS(7419),
    [anon_sym_NA_integer_] = ACTIONS(7419),
    [anon_sym_NA_real_] = ACTIONS(7419),
    [anon_sym_NA_complex_] = ACTIONS(7419),
    [anon_sym_NA_character_] = ACTIONS(7419),
    [sym_dots] = ACTIONS(7419),
    [sym_dot_dot_i] = ACTIONS(7417),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7417),
    [sym__newline] = ACTIONS(7558),
    [sym__semicolon] = ACTIONS(7417),
    [sym__raw_string_literal] = ACTIONS(7417),
    [sym__external_open_parenthesis] = ACTIONS(7417),
    [sym__external_close_parenthesis] = ACTIONS(7417),
    [sym__external_open_brace] = ACTIONS(7417),
    [sym__external_close_brace] = ACTIONS(7417),
    [sym__external_open_bracket] = ACTIONS(7417),
    [sym__external_open_bracket2] = ACTIONS(7417),
  },
  [2282] = {
    [ts_builtin_sym_end] = ACTIONS(7561),
    [sym_identifier] = ACTIONS(7563),
    [anon_sym_BSLASH] = ACTIONS(7561),
    [anon_sym_function] = ACTIONS(7563),
    [anon_sym_EQ] = ACTIONS(7563),
    [anon_sym_if] = ACTIONS(7563),
    [anon_sym_for] = ACTIONS(7563),
    [anon_sym_while] = ACTIONS(7563),
    [anon_sym_repeat] = ACTIONS(7563),
    [anon_sym_QMARK] = ACTIONS(7561),
    [anon_sym_TILDE] = ACTIONS(7561),
    [anon_sym_BANG] = ACTIONS(7563),
    [anon_sym_PLUS] = ACTIONS(7561),
    [anon_sym_DASH] = ACTIONS(7563),
    [anon_sym_LT_DASH] = ACTIONS(7561),
    [anon_sym_LT_LT_DASH] = ACTIONS(7561),
    [anon_sym_COLON_EQ] = ACTIONS(7561),
    [anon_sym_DASH_GT] = ACTIONS(7563),
    [anon_sym_DASH_GT_GT] = ACTIONS(7561),
    [anon_sym_PIPE] = ACTIONS(7563),
    [anon_sym_AMP] = ACTIONS(7563),
    [anon_sym_PIPE_PIPE] = ACTIONS(7561),
    [anon_sym_AMP_AMP] = ACTIONS(7561),
    [anon_sym_LT] = ACTIONS(7563),
    [anon_sym_LT_EQ] = ACTIONS(7561),
    [anon_sym_GT] = ACTIONS(7563),
    [anon_sym_GT_EQ] = ACTIONS(7561),
    [anon_sym_EQ_EQ] = ACTIONS(7561),
    [anon_sym_BANG_EQ] = ACTIONS(7561),
    [anon_sym_STAR] = ACTIONS(7563),
    [anon_sym_SLASH] = ACTIONS(7561),
    [anon_sym_STAR_STAR] = ACTIONS(7561),
    [anon_sym_CARET] = ACTIONS(7561),
    [aux_sym_binary_operator_token1] = ACTIONS(7561),
    [anon_sym_PIPE_GT] = ACTIONS(7561),
    [anon_sym_COLON] = ACTIONS(7563),
    [anon_sym_DOLLAR] = ACTIONS(7561),
    [anon_sym_AT] = ACTIONS(7561),
    [aux_sym__hex_literal_token1] = ACTIONS(7561),
    [sym__number_literal] = ACTIONS(7563),
    [anon_sym_SQUOTE] = ACTIONS(7561),
    [anon_sym_DQUOTE] = ACTIONS(7561),
    [sym_return] = ACTIONS(7563),
    [sym_next] = ACTIONS(7563),
    [sym_break] = ACTIONS(7563),
    [sym_true] = ACTIONS(7563),
    [sym_false] = ACTIONS(7563),
    [sym_null] = ACTIONS(7563),
    [sym_inf] = ACTIONS(7563),
    [sym_nan] = ACTIONS(7563),
    [anon_sym_NA] = ACTIONS(7563),
    [anon_sym_NA_integer_] = ACTIONS(7563),
    [anon_sym_NA_real_] = ACTIONS(7563),
    [anon_sym_NA_complex_] = ACTIONS(7563),
    [anon_sym_NA_character_] = ACTIONS(7563),
    [sym_dots] = ACTIONS(7563),
    [sym_dot_dot_i] = ACTIONS(7561),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7561),
    [sym__newline] = ACTIONS(7561),
    [sym__semicolon] = ACTIONS(7561),
    [sym__raw_string_literal] = ACTIONS(7561),
    [sym__external_else] = ACTIONS(7561),
    [sym__external_open_parenthesis] = ACTIONS(7561),
    [sym__external_close_parenthesis] = ACTIONS(7561),
    [sym__external_open_brace] = ACTIONS(7561),
    [sym__external_close_brace] = ACTIONS(7561),
    [sym__external_open_bracket] = ACTIONS(7561),
    [sym__external_open_bracket2] = ACTIONS(7561),
  },
  [2283] = {
    [ts_builtin_sym_end] = ACTIONS(5313),
    [sym_identifier] = ACTIONS(5311),
    [anon_sym_BSLASH] = ACTIONS(5313),
    [anon_sym_function] = ACTIONS(5311),
    [anon_sym_EQ] = ACTIONS(5311),
    [anon_sym_if] = ACTIONS(5311),
    [anon_sym_for] = ACTIONS(5311),
    [anon_sym_while] = ACTIONS(5311),
    [anon_sym_repeat] = ACTIONS(5311),
    [anon_sym_QMARK] = ACTIONS(5313),
    [anon_sym_TILDE] = ACTIONS(5313),
    [anon_sym_BANG] = ACTIONS(5311),
    [anon_sym_PLUS] = ACTIONS(5313),
    [anon_sym_DASH] = ACTIONS(5311),
    [anon_sym_LT_DASH] = ACTIONS(5313),
    [anon_sym_LT_LT_DASH] = ACTIONS(5313),
    [anon_sym_COLON_EQ] = ACTIONS(5313),
    [anon_sym_DASH_GT] = ACTIONS(5311),
    [anon_sym_DASH_GT_GT] = ACTIONS(5313),
    [anon_sym_PIPE] = ACTIONS(5311),
    [anon_sym_AMP] = ACTIONS(5311),
    [anon_sym_PIPE_PIPE] = ACTIONS(5313),
    [anon_sym_AMP_AMP] = ACTIONS(5313),
    [anon_sym_LT] = ACTIONS(5311),
    [anon_sym_LT_EQ] = ACTIONS(5313),
    [anon_sym_GT] = ACTIONS(5311),
    [anon_sym_GT_EQ] = ACTIONS(5313),
    [anon_sym_EQ_EQ] = ACTIONS(5313),
    [anon_sym_BANG_EQ] = ACTIONS(5313),
    [anon_sym_STAR] = ACTIONS(5311),
    [anon_sym_SLASH] = ACTIONS(5313),
    [anon_sym_STAR_STAR] = ACTIONS(5313),
    [anon_sym_CARET] = ACTIONS(5313),
    [aux_sym_binary_operator_token1] = ACTIONS(5313),
    [anon_sym_PIPE_GT] = ACTIONS(5313),
    [anon_sym_COLON] = ACTIONS(5311),
    [anon_sym_DOLLAR] = ACTIONS(5313),
    [anon_sym_AT] = ACTIONS(5313),
    [aux_sym__hex_literal_token1] = ACTIONS(5313),
    [sym__number_literal] = ACTIONS(5311),
    [anon_sym_SQUOTE] = ACTIONS(5313),
    [anon_sym_DQUOTE] = ACTIONS(5313),
    [sym_return] = ACTIONS(5311),
    [sym_next] = ACTIONS(5311),
    [sym_break] = ACTIONS(5311),
    [sym_true] = ACTIONS(5311),
    [sym_false] = ACTIONS(5311),
    [sym_null] = ACTIONS(5311),
    [sym_inf] = ACTIONS(5311),
    [sym_nan] = ACTIONS(5311),
    [anon_sym_NA] = ACTIONS(5311),
    [anon_sym_NA_integer_] = ACTIONS(5311),
    [anon_sym_NA_real_] = ACTIONS(5311),
    [anon_sym_NA_complex_] = ACTIONS(5311),
    [anon_sym_NA_character_] = ACTIONS(5311),
    [sym_dots] = ACTIONS(5311),
    [sym_dot_dot_i] = ACTIONS(5313),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5313),
    [sym__newline] = ACTIONS(5313),
    [sym__semicolon] = ACTIONS(5313),
    [sym__raw_string_literal] = ACTIONS(5313),
    [sym__external_else] = ACTIONS(5313),
    [sym__external_open_parenthesis] = ACTIONS(5313),
    [sym__external_close_parenthesis] = ACTIONS(5313),
    [sym__external_open_brace] = ACTIONS(5313),
    [sym__external_close_brace] = ACTIONS(5313),
    [sym__external_open_bracket] = ACTIONS(5313),
    [sym__external_open_bracket2] = ACTIONS(5313),
  },
  [2284] = {
    [sym_identifier] = ACTIONS(7129),
    [anon_sym_BSLASH] = ACTIONS(7131),
    [anon_sym_function] = ACTIONS(7129),
    [anon_sym_EQ] = ACTIONS(7129),
    [anon_sym_if] = ACTIONS(7129),
    [anon_sym_for] = ACTIONS(7129),
    [anon_sym_while] = ACTIONS(7129),
    [anon_sym_repeat] = ACTIONS(7129),
    [anon_sym_QMARK] = ACTIONS(7131),
    [anon_sym_TILDE] = ACTIONS(7131),
    [anon_sym_BANG] = ACTIONS(7129),
    [anon_sym_PLUS] = ACTIONS(7131),
    [anon_sym_DASH] = ACTIONS(7129),
    [anon_sym_LT_DASH] = ACTIONS(7131),
    [anon_sym_LT_LT_DASH] = ACTIONS(7131),
    [anon_sym_COLON_EQ] = ACTIONS(7131),
    [anon_sym_DASH_GT] = ACTIONS(7129),
    [anon_sym_DASH_GT_GT] = ACTIONS(7131),
    [anon_sym_PIPE] = ACTIONS(7129),
    [anon_sym_AMP] = ACTIONS(7129),
    [anon_sym_PIPE_PIPE] = ACTIONS(7131),
    [anon_sym_AMP_AMP] = ACTIONS(7131),
    [anon_sym_LT] = ACTIONS(7129),
    [anon_sym_LT_EQ] = ACTIONS(7131),
    [anon_sym_GT] = ACTIONS(7129),
    [anon_sym_GT_EQ] = ACTIONS(7131),
    [anon_sym_EQ_EQ] = ACTIONS(7131),
    [anon_sym_BANG_EQ] = ACTIONS(7131),
    [anon_sym_STAR] = ACTIONS(7129),
    [anon_sym_SLASH] = ACTIONS(7131),
    [anon_sym_STAR_STAR] = ACTIONS(7131),
    [anon_sym_CARET] = ACTIONS(7131),
    [aux_sym_binary_operator_token1] = ACTIONS(7131),
    [anon_sym_PIPE_GT] = ACTIONS(7131),
    [anon_sym_COLON] = ACTIONS(7129),
    [anon_sym_DOLLAR] = ACTIONS(7131),
    [anon_sym_AT] = ACTIONS(7131),
    [anon_sym_COLON_COLON] = ACTIONS(7133),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7135),
    [aux_sym__hex_literal_token1] = ACTIONS(7131),
    [sym__number_literal] = ACTIONS(7129),
    [anon_sym_SQUOTE] = ACTIONS(7131),
    [anon_sym_DQUOTE] = ACTIONS(7131),
    [sym_return] = ACTIONS(7129),
    [sym_next] = ACTIONS(7129),
    [sym_break] = ACTIONS(7129),
    [sym_true] = ACTIONS(7129),
    [sym_false] = ACTIONS(7129),
    [sym_null] = ACTIONS(7129),
    [sym_inf] = ACTIONS(7129),
    [sym_nan] = ACTIONS(7129),
    [anon_sym_NA] = ACTIONS(7129),
    [anon_sym_NA_integer_] = ACTIONS(7129),
    [anon_sym_NA_real_] = ACTIONS(7129),
    [anon_sym_NA_complex_] = ACTIONS(7129),
    [anon_sym_NA_character_] = ACTIONS(7129),
    [sym_dots] = ACTIONS(7129),
    [sym_dot_dot_i] = ACTIONS(7131),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7131),
    [sym__newline] = ACTIONS(7131),
    [sym__semicolon] = ACTIONS(7131),
    [sym__raw_string_literal] = ACTIONS(7131),
    [sym__external_open_parenthesis] = ACTIONS(7131),
    [sym__external_open_brace] = ACTIONS(7131),
    [sym__external_close_brace] = ACTIONS(7131),
    [sym__external_open_bracket] = ACTIONS(7131),
    [sym__external_close_bracket] = ACTIONS(7131),
    [sym__external_open_bracket2] = ACTIONS(7131),
  },
  [2285] = {
    [ts_builtin_sym_end] = ACTIONS(7565),
    [sym_identifier] = ACTIONS(7567),
    [anon_sym_BSLASH] = ACTIONS(7565),
    [anon_sym_function] = ACTIONS(7567),
    [anon_sym_EQ] = ACTIONS(7567),
    [anon_sym_if] = ACTIONS(7567),
    [anon_sym_for] = ACTIONS(7567),
    [anon_sym_while] = ACTIONS(7567),
    [anon_sym_repeat] = ACTIONS(7567),
    [anon_sym_QMARK] = ACTIONS(7565),
    [anon_sym_TILDE] = ACTIONS(7565),
    [anon_sym_BANG] = ACTIONS(7567),
    [anon_sym_PLUS] = ACTIONS(7565),
    [anon_sym_DASH] = ACTIONS(7567),
    [anon_sym_LT_DASH] = ACTIONS(7565),
    [anon_sym_LT_LT_DASH] = ACTIONS(7565),
    [anon_sym_COLON_EQ] = ACTIONS(7565),
    [anon_sym_DASH_GT] = ACTIONS(7567),
    [anon_sym_DASH_GT_GT] = ACTIONS(7565),
    [anon_sym_PIPE] = ACTIONS(7567),
    [anon_sym_AMP] = ACTIONS(7567),
    [anon_sym_PIPE_PIPE] = ACTIONS(7565),
    [anon_sym_AMP_AMP] = ACTIONS(7565),
    [anon_sym_LT] = ACTIONS(7567),
    [anon_sym_LT_EQ] = ACTIONS(7565),
    [anon_sym_GT] = ACTIONS(7567),
    [anon_sym_GT_EQ] = ACTIONS(7565),
    [anon_sym_EQ_EQ] = ACTIONS(7565),
    [anon_sym_BANG_EQ] = ACTIONS(7565),
    [anon_sym_STAR] = ACTIONS(7567),
    [anon_sym_SLASH] = ACTIONS(7565),
    [anon_sym_STAR_STAR] = ACTIONS(7565),
    [anon_sym_CARET] = ACTIONS(7565),
    [aux_sym_binary_operator_token1] = ACTIONS(7565),
    [anon_sym_PIPE_GT] = ACTIONS(7565),
    [anon_sym_COLON] = ACTIONS(7567),
    [anon_sym_DOLLAR] = ACTIONS(7565),
    [anon_sym_AT] = ACTIONS(7565),
    [aux_sym__hex_literal_token1] = ACTIONS(7565),
    [sym__number_literal] = ACTIONS(7567),
    [anon_sym_SQUOTE] = ACTIONS(7565),
    [anon_sym_DQUOTE] = ACTIONS(7565),
    [sym_return] = ACTIONS(7567),
    [sym_next] = ACTIONS(7567),
    [sym_break] = ACTIONS(7567),
    [sym_true] = ACTIONS(7567),
    [sym_false] = ACTIONS(7567),
    [sym_null] = ACTIONS(7567),
    [sym_inf] = ACTIONS(7567),
    [sym_nan] = ACTIONS(7567),
    [anon_sym_NA] = ACTIONS(7567),
    [anon_sym_NA_integer_] = ACTIONS(7567),
    [anon_sym_NA_real_] = ACTIONS(7567),
    [anon_sym_NA_complex_] = ACTIONS(7567),
    [anon_sym_NA_character_] = ACTIONS(7567),
    [sym_dots] = ACTIONS(7567),
    [sym_dot_dot_i] = ACTIONS(7565),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7565),
    [sym__newline] = ACTIONS(7565),
    [sym__semicolon] = ACTIONS(7565),
    [sym__raw_string_literal] = ACTIONS(7565),
    [sym__external_else] = ACTIONS(7565),
    [sym__external_open_parenthesis] = ACTIONS(7565),
    [sym__external_close_parenthesis] = ACTIONS(7565),
    [sym__external_open_brace] = ACTIONS(7565),
    [sym__external_close_brace] = ACTIONS(7565),
    [sym__external_open_bracket] = ACTIONS(7565),
    [sym__external_open_bracket2] = ACTIONS(7565),
  },
  [2286] = {
    [sym_identifier] = ACTIONS(7137),
    [anon_sym_BSLASH] = ACTIONS(7139),
    [anon_sym_function] = ACTIONS(7137),
    [anon_sym_EQ] = ACTIONS(7137),
    [anon_sym_if] = ACTIONS(7137),
    [anon_sym_for] = ACTIONS(7137),
    [anon_sym_while] = ACTIONS(7137),
    [anon_sym_repeat] = ACTIONS(7137),
    [anon_sym_QMARK] = ACTIONS(7139),
    [anon_sym_TILDE] = ACTIONS(7139),
    [anon_sym_BANG] = ACTIONS(7137),
    [anon_sym_PLUS] = ACTIONS(7139),
    [anon_sym_DASH] = ACTIONS(7137),
    [anon_sym_LT_DASH] = ACTIONS(7139),
    [anon_sym_LT_LT_DASH] = ACTIONS(7139),
    [anon_sym_COLON_EQ] = ACTIONS(7139),
    [anon_sym_DASH_GT] = ACTIONS(7137),
    [anon_sym_DASH_GT_GT] = ACTIONS(7139),
    [anon_sym_PIPE] = ACTIONS(7137),
    [anon_sym_AMP] = ACTIONS(7137),
    [anon_sym_PIPE_PIPE] = ACTIONS(7139),
    [anon_sym_AMP_AMP] = ACTIONS(7139),
    [anon_sym_LT] = ACTIONS(7137),
    [anon_sym_LT_EQ] = ACTIONS(7139),
    [anon_sym_GT] = ACTIONS(7137),
    [anon_sym_GT_EQ] = ACTIONS(7139),
    [anon_sym_EQ_EQ] = ACTIONS(7139),
    [anon_sym_BANG_EQ] = ACTIONS(7139),
    [anon_sym_STAR] = ACTIONS(7137),
    [anon_sym_SLASH] = ACTIONS(7139),
    [anon_sym_STAR_STAR] = ACTIONS(7139),
    [anon_sym_CARET] = ACTIONS(7139),
    [aux_sym_binary_operator_token1] = ACTIONS(7139),
    [anon_sym_PIPE_GT] = ACTIONS(7139),
    [anon_sym_COLON] = ACTIONS(7137),
    [anon_sym_DOLLAR] = ACTIONS(7139),
    [anon_sym_AT] = ACTIONS(7139),
    [anon_sym_COLON_COLON] = ACTIONS(7137),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7139),
    [aux_sym__hex_literal_token1] = ACTIONS(7139),
    [sym__number_literal] = ACTIONS(7137),
    [anon_sym_SQUOTE] = ACTIONS(7139),
    [anon_sym_DQUOTE] = ACTIONS(7139),
    [sym_return] = ACTIONS(7137),
    [sym_next] = ACTIONS(7137),
    [sym_break] = ACTIONS(7137),
    [sym_true] = ACTIONS(7137),
    [sym_false] = ACTIONS(7137),
    [sym_null] = ACTIONS(7137),
    [sym_inf] = ACTIONS(7137),
    [sym_nan] = ACTIONS(7137),
    [anon_sym_NA] = ACTIONS(7137),
    [anon_sym_NA_integer_] = ACTIONS(7137),
    [anon_sym_NA_real_] = ACTIONS(7137),
    [anon_sym_NA_complex_] = ACTIONS(7137),
    [anon_sym_NA_character_] = ACTIONS(7137),
    [sym_dots] = ACTIONS(7137),
    [sym_dot_dot_i] = ACTIONS(7139),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7139),
    [sym__newline] = ACTIONS(7139),
    [sym__raw_string_literal] = ACTIONS(7139),
    [sym__external_else] = ACTIONS(7139),
    [sym__external_open_parenthesis] = ACTIONS(7139),
    [sym__external_close_parenthesis] = ACTIONS(7139),
    [sym__external_open_brace] = ACTIONS(7139),
    [sym__external_open_bracket] = ACTIONS(7139),
    [sym__external_open_bracket2] = ACTIONS(7139),
    [sym__external_close_bracket2] = ACTIONS(7139),
  },
  [2287] = {
    [sym_identifier] = ACTIONS(7129),
    [anon_sym_BSLASH] = ACTIONS(7131),
    [anon_sym_function] = ACTIONS(7129),
    [anon_sym_EQ] = ACTIONS(7129),
    [anon_sym_if] = ACTIONS(7129),
    [anon_sym_for] = ACTIONS(7129),
    [anon_sym_while] = ACTIONS(7129),
    [anon_sym_repeat] = ACTIONS(7129),
    [anon_sym_QMARK] = ACTIONS(7131),
    [anon_sym_TILDE] = ACTIONS(7131),
    [anon_sym_BANG] = ACTIONS(7129),
    [anon_sym_PLUS] = ACTIONS(7131),
    [anon_sym_DASH] = ACTIONS(7129),
    [anon_sym_LT_DASH] = ACTIONS(7131),
    [anon_sym_LT_LT_DASH] = ACTIONS(7131),
    [anon_sym_COLON_EQ] = ACTIONS(7131),
    [anon_sym_DASH_GT] = ACTIONS(7129),
    [anon_sym_DASH_GT_GT] = ACTIONS(7131),
    [anon_sym_PIPE] = ACTIONS(7129),
    [anon_sym_AMP] = ACTIONS(7129),
    [anon_sym_PIPE_PIPE] = ACTIONS(7131),
    [anon_sym_AMP_AMP] = ACTIONS(7131),
    [anon_sym_LT] = ACTIONS(7129),
    [anon_sym_LT_EQ] = ACTIONS(7131),
    [anon_sym_GT] = ACTIONS(7129),
    [anon_sym_GT_EQ] = ACTIONS(7131),
    [anon_sym_EQ_EQ] = ACTIONS(7131),
    [anon_sym_BANG_EQ] = ACTIONS(7131),
    [anon_sym_STAR] = ACTIONS(7129),
    [anon_sym_SLASH] = ACTIONS(7131),
    [anon_sym_STAR_STAR] = ACTIONS(7131),
    [anon_sym_CARET] = ACTIONS(7131),
    [aux_sym_binary_operator_token1] = ACTIONS(7131),
    [anon_sym_PIPE_GT] = ACTIONS(7131),
    [anon_sym_COLON] = ACTIONS(7129),
    [anon_sym_DOLLAR] = ACTIONS(7131),
    [anon_sym_AT] = ACTIONS(7131),
    [anon_sym_COLON_COLON] = ACTIONS(7133),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7135),
    [aux_sym__hex_literal_token1] = ACTIONS(7131),
    [sym__number_literal] = ACTIONS(7129),
    [anon_sym_SQUOTE] = ACTIONS(7131),
    [anon_sym_DQUOTE] = ACTIONS(7131),
    [sym_return] = ACTIONS(7129),
    [sym_next] = ACTIONS(7129),
    [sym_break] = ACTIONS(7129),
    [sym_true] = ACTIONS(7129),
    [sym_false] = ACTIONS(7129),
    [sym_null] = ACTIONS(7129),
    [sym_inf] = ACTIONS(7129),
    [sym_nan] = ACTIONS(7129),
    [anon_sym_NA] = ACTIONS(7129),
    [anon_sym_NA_integer_] = ACTIONS(7129),
    [anon_sym_NA_real_] = ACTIONS(7129),
    [anon_sym_NA_complex_] = ACTIONS(7129),
    [anon_sym_NA_character_] = ACTIONS(7129),
    [sym_dots] = ACTIONS(7129),
    [sym_dot_dot_i] = ACTIONS(7131),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7131),
    [sym__newline] = ACTIONS(7131),
    [sym__raw_string_literal] = ACTIONS(7131),
    [sym__external_else] = ACTIONS(7131),
    [sym__external_open_parenthesis] = ACTIONS(7131),
    [sym__external_close_parenthesis] = ACTIONS(7131),
    [sym__external_open_brace] = ACTIONS(7131),
    [sym__external_open_bracket] = ACTIONS(7131),
    [sym__external_open_bracket2] = ACTIONS(7131),
    [sym__external_close_bracket2] = ACTIONS(7131),
  },
  [2288] = {
    [sym_identifier] = ACTIONS(7121),
    [anon_sym_BSLASH] = ACTIONS(7123),
    [anon_sym_function] = ACTIONS(7121),
    [anon_sym_EQ] = ACTIONS(7121),
    [anon_sym_if] = ACTIONS(7121),
    [anon_sym_for] = ACTIONS(7121),
    [anon_sym_while] = ACTIONS(7121),
    [anon_sym_repeat] = ACTIONS(7121),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_TILDE] = ACTIONS(7123),
    [anon_sym_BANG] = ACTIONS(7121),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_DASH] = ACTIONS(7121),
    [anon_sym_LT_DASH] = ACTIONS(7123),
    [anon_sym_LT_LT_DASH] = ACTIONS(7123),
    [anon_sym_COLON_EQ] = ACTIONS(7123),
    [anon_sym_DASH_GT] = ACTIONS(7121),
    [anon_sym_DASH_GT_GT] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_LT_EQ] = ACTIONS(7123),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
    [aux_sym_binary_operator_token1] = ACTIONS(7123),
    [anon_sym_PIPE_GT] = ACTIONS(7123),
    [anon_sym_COLON] = ACTIONS(7121),
    [anon_sym_DOLLAR] = ACTIONS(7123),
    [anon_sym_AT] = ACTIONS(7123),
    [anon_sym_L] = ACTIONS(7569),
    [anon_sym_i] = ACTIONS(7571),
    [aux_sym__hex_literal_token1] = ACTIONS(7123),
    [sym__number_literal] = ACTIONS(7121),
    [anon_sym_SQUOTE] = ACTIONS(7123),
    [anon_sym_DQUOTE] = ACTIONS(7123),
    [sym_return] = ACTIONS(7121),
    [sym_next] = ACTIONS(7121),
    [sym_break] = ACTIONS(7121),
    [sym_true] = ACTIONS(7121),
    [sym_false] = ACTIONS(7121),
    [sym_null] = ACTIONS(7121),
    [sym_inf] = ACTIONS(7121),
    [sym_nan] = ACTIONS(7121),
    [anon_sym_NA] = ACTIONS(7121),
    [anon_sym_NA_integer_] = ACTIONS(7121),
    [anon_sym_NA_real_] = ACTIONS(7121),
    [anon_sym_NA_complex_] = ACTIONS(7121),
    [anon_sym_NA_character_] = ACTIONS(7121),
    [sym_dots] = ACTIONS(7121),
    [sym_dot_dot_i] = ACTIONS(7123),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7123),
    [sym__newline] = ACTIONS(7123),
    [sym__raw_string_literal] = ACTIONS(7123),
    [sym__external_else] = ACTIONS(7123),
    [sym__external_open_parenthesis] = ACTIONS(7123),
    [sym__external_close_parenthesis] = ACTIONS(7123),
    [sym__external_open_brace] = ACTIONS(7123),
    [sym__external_open_bracket] = ACTIONS(7123),
    [sym__external_open_bracket2] = ACTIONS(7123),
    [sym__external_close_bracket2] = ACTIONS(7123),
  },
  [2289] = {
    [sym_identifier] = ACTIONS(7115),
    [anon_sym_BSLASH] = ACTIONS(7117),
    [anon_sym_function] = ACTIONS(7115),
    [anon_sym_EQ] = ACTIONS(7115),
    [anon_sym_if] = ACTIONS(7115),
    [anon_sym_for] = ACTIONS(7115),
    [anon_sym_while] = ACTIONS(7115),
    [anon_sym_repeat] = ACTIONS(7115),
    [anon_sym_QMARK] = ACTIONS(7117),
    [anon_sym_TILDE] = ACTIONS(7117),
    [anon_sym_BANG] = ACTIONS(7115),
    [anon_sym_PLUS] = ACTIONS(7117),
    [anon_sym_DASH] = ACTIONS(7115),
    [anon_sym_LT_DASH] = ACTIONS(7117),
    [anon_sym_LT_LT_DASH] = ACTIONS(7117),
    [anon_sym_COLON_EQ] = ACTIONS(7117),
    [anon_sym_DASH_GT] = ACTIONS(7115),
    [anon_sym_DASH_GT_GT] = ACTIONS(7117),
    [anon_sym_PIPE] = ACTIONS(7115),
    [anon_sym_AMP] = ACTIONS(7115),
    [anon_sym_PIPE_PIPE] = ACTIONS(7117),
    [anon_sym_AMP_AMP] = ACTIONS(7117),
    [anon_sym_LT] = ACTIONS(7115),
    [anon_sym_LT_EQ] = ACTIONS(7117),
    [anon_sym_GT] = ACTIONS(7115),
    [anon_sym_GT_EQ] = ACTIONS(7117),
    [anon_sym_EQ_EQ] = ACTIONS(7117),
    [anon_sym_BANG_EQ] = ACTIONS(7117),
    [anon_sym_STAR] = ACTIONS(7115),
    [anon_sym_SLASH] = ACTIONS(7117),
    [anon_sym_STAR_STAR] = ACTIONS(7117),
    [anon_sym_CARET] = ACTIONS(7117),
    [aux_sym_binary_operator_token1] = ACTIONS(7117),
    [anon_sym_PIPE_GT] = ACTIONS(7117),
    [anon_sym_COLON] = ACTIONS(7115),
    [anon_sym_DOLLAR] = ACTIONS(7117),
    [anon_sym_AT] = ACTIONS(7117),
    [anon_sym_COLON_COLON] = ACTIONS(7115),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7117),
    [aux_sym__hex_literal_token1] = ACTIONS(7117),
    [sym__number_literal] = ACTIONS(7115),
    [anon_sym_SQUOTE] = ACTIONS(7117),
    [anon_sym_DQUOTE] = ACTIONS(7117),
    [sym_return] = ACTIONS(7115),
    [sym_next] = ACTIONS(7115),
    [sym_break] = ACTIONS(7115),
    [sym_true] = ACTIONS(7115),
    [sym_false] = ACTIONS(7115),
    [sym_null] = ACTIONS(7115),
    [sym_inf] = ACTIONS(7115),
    [sym_nan] = ACTIONS(7115),
    [anon_sym_NA] = ACTIONS(7115),
    [anon_sym_NA_integer_] = ACTIONS(7115),
    [anon_sym_NA_real_] = ACTIONS(7115),
    [anon_sym_NA_complex_] = ACTIONS(7115),
    [anon_sym_NA_character_] = ACTIONS(7115),
    [sym_dots] = ACTIONS(7115),
    [sym_dot_dot_i] = ACTIONS(7117),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7117),
    [sym__newline] = ACTIONS(7117),
    [sym__raw_string_literal] = ACTIONS(7117),
    [sym__external_else] = ACTIONS(7117),
    [sym__external_open_parenthesis] = ACTIONS(7117),
    [sym__external_close_parenthesis] = ACTIONS(7117),
    [sym__external_open_brace] = ACTIONS(7117),
    [sym__external_open_bracket] = ACTIONS(7117),
    [sym__external_open_bracket2] = ACTIONS(7117),
    [sym__external_close_bracket2] = ACTIONS(7117),
  },
  [2290] = {
    [sym_identifier] = ACTIONS(7115),
    [anon_sym_BSLASH] = ACTIONS(7117),
    [anon_sym_function] = ACTIONS(7115),
    [anon_sym_EQ] = ACTIONS(7115),
    [anon_sym_if] = ACTIONS(7115),
    [anon_sym_for] = ACTIONS(7115),
    [anon_sym_while] = ACTIONS(7115),
    [anon_sym_repeat] = ACTIONS(7115),
    [anon_sym_QMARK] = ACTIONS(7117),
    [anon_sym_TILDE] = ACTIONS(7117),
    [anon_sym_BANG] = ACTIONS(7115),
    [anon_sym_PLUS] = ACTIONS(7117),
    [anon_sym_DASH] = ACTIONS(7115),
    [anon_sym_LT_DASH] = ACTIONS(7117),
    [anon_sym_LT_LT_DASH] = ACTIONS(7117),
    [anon_sym_COLON_EQ] = ACTIONS(7117),
    [anon_sym_DASH_GT] = ACTIONS(7115),
    [anon_sym_DASH_GT_GT] = ACTIONS(7117),
    [anon_sym_PIPE] = ACTIONS(7115),
    [anon_sym_AMP] = ACTIONS(7115),
    [anon_sym_PIPE_PIPE] = ACTIONS(7117),
    [anon_sym_AMP_AMP] = ACTIONS(7117),
    [anon_sym_LT] = ACTIONS(7115),
    [anon_sym_LT_EQ] = ACTIONS(7117),
    [anon_sym_GT] = ACTIONS(7115),
    [anon_sym_GT_EQ] = ACTIONS(7117),
    [anon_sym_EQ_EQ] = ACTIONS(7117),
    [anon_sym_BANG_EQ] = ACTIONS(7117),
    [anon_sym_STAR] = ACTIONS(7115),
    [anon_sym_SLASH] = ACTIONS(7117),
    [anon_sym_STAR_STAR] = ACTIONS(7117),
    [anon_sym_CARET] = ACTIONS(7117),
    [aux_sym_binary_operator_token1] = ACTIONS(7117),
    [anon_sym_PIPE_GT] = ACTIONS(7117),
    [anon_sym_COLON] = ACTIONS(7115),
    [anon_sym_DOLLAR] = ACTIONS(7117),
    [anon_sym_AT] = ACTIONS(7117),
    [anon_sym_COLON_COLON] = ACTIONS(7115),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7117),
    [aux_sym__hex_literal_token1] = ACTIONS(7117),
    [sym__number_literal] = ACTIONS(7115),
    [anon_sym_SQUOTE] = ACTIONS(7117),
    [anon_sym_DQUOTE] = ACTIONS(7117),
    [sym_return] = ACTIONS(7115),
    [sym_next] = ACTIONS(7115),
    [sym_break] = ACTIONS(7115),
    [sym_true] = ACTIONS(7115),
    [sym_false] = ACTIONS(7115),
    [sym_null] = ACTIONS(7115),
    [sym_inf] = ACTIONS(7115),
    [sym_nan] = ACTIONS(7115),
    [anon_sym_NA] = ACTIONS(7115),
    [anon_sym_NA_integer_] = ACTIONS(7115),
    [anon_sym_NA_real_] = ACTIONS(7115),
    [anon_sym_NA_complex_] = ACTIONS(7115),
    [anon_sym_NA_character_] = ACTIONS(7115),
    [sym_dots] = ACTIONS(7115),
    [sym_dot_dot_i] = ACTIONS(7117),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7117),
    [sym__newline] = ACTIONS(7117),
    [sym__raw_string_literal] = ACTIONS(7117),
    [sym__external_else] = ACTIONS(7117),
    [sym__external_open_parenthesis] = ACTIONS(7117),
    [sym__external_close_parenthesis] = ACTIONS(7117),
    [sym__external_open_brace] = ACTIONS(7117),
    [sym__external_open_bracket] = ACTIONS(7117),
    [sym__external_open_bracket2] = ACTIONS(7117),
    [sym__external_close_bracket2] = ACTIONS(7117),
  },
  [2291] = {
    [sym_identifier] = ACTIONS(7151),
    [anon_sym_BSLASH] = ACTIONS(7153),
    [anon_sym_function] = ACTIONS(7151),
    [anon_sym_EQ] = ACTIONS(7151),
    [anon_sym_if] = ACTIONS(7151),
    [anon_sym_for] = ACTIONS(7151),
    [anon_sym_while] = ACTIONS(7151),
    [anon_sym_repeat] = ACTIONS(7151),
    [anon_sym_QMARK] = ACTIONS(7153),
    [anon_sym_TILDE] = ACTIONS(7153),
    [anon_sym_BANG] = ACTIONS(7151),
    [anon_sym_PLUS] = ACTIONS(7153),
    [anon_sym_DASH] = ACTIONS(7151),
    [anon_sym_LT_DASH] = ACTIONS(7153),
    [anon_sym_LT_LT_DASH] = ACTIONS(7153),
    [anon_sym_COLON_EQ] = ACTIONS(7153),
    [anon_sym_DASH_GT] = ACTIONS(7151),
    [anon_sym_DASH_GT_GT] = ACTIONS(7153),
    [anon_sym_PIPE] = ACTIONS(7151),
    [anon_sym_AMP] = ACTIONS(7151),
    [anon_sym_PIPE_PIPE] = ACTIONS(7153),
    [anon_sym_AMP_AMP] = ACTIONS(7153),
    [anon_sym_LT] = ACTIONS(7151),
    [anon_sym_LT_EQ] = ACTIONS(7153),
    [anon_sym_GT] = ACTIONS(7151),
    [anon_sym_GT_EQ] = ACTIONS(7153),
    [anon_sym_EQ_EQ] = ACTIONS(7153),
    [anon_sym_BANG_EQ] = ACTIONS(7153),
    [anon_sym_STAR] = ACTIONS(7151),
    [anon_sym_SLASH] = ACTIONS(7153),
    [anon_sym_STAR_STAR] = ACTIONS(7153),
    [anon_sym_CARET] = ACTIONS(7153),
    [aux_sym_binary_operator_token1] = ACTIONS(7153),
    [anon_sym_PIPE_GT] = ACTIONS(7153),
    [anon_sym_COLON] = ACTIONS(7151),
    [anon_sym_DOLLAR] = ACTIONS(7153),
    [anon_sym_AT] = ACTIONS(7153),
    [anon_sym_COLON_COLON] = ACTIONS(7151),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7153),
    [aux_sym__hex_literal_token1] = ACTIONS(7153),
    [sym__number_literal] = ACTIONS(7151),
    [anon_sym_SQUOTE] = ACTIONS(7153),
    [anon_sym_DQUOTE] = ACTIONS(7153),
    [sym_return] = ACTIONS(7151),
    [sym_next] = ACTIONS(7151),
    [sym_break] = ACTIONS(7151),
    [sym_true] = ACTIONS(7151),
    [sym_false] = ACTIONS(7151),
    [sym_null] = ACTIONS(7151),
    [sym_inf] = ACTIONS(7151),
    [sym_nan] = ACTIONS(7151),
    [anon_sym_NA] = ACTIONS(7151),
    [anon_sym_NA_integer_] = ACTIONS(7151),
    [anon_sym_NA_real_] = ACTIONS(7151),
    [anon_sym_NA_complex_] = ACTIONS(7151),
    [anon_sym_NA_character_] = ACTIONS(7151),
    [sym_dots] = ACTIONS(7151),
    [sym_dot_dot_i] = ACTIONS(7153),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7153),
    [sym__newline] = ACTIONS(7153),
    [sym__raw_string_literal] = ACTIONS(7153),
    [sym__external_else] = ACTIONS(7153),
    [sym__external_open_parenthesis] = ACTIONS(7153),
    [sym__external_close_parenthesis] = ACTIONS(7153),
    [sym__external_open_brace] = ACTIONS(7153),
    [sym__external_open_bracket] = ACTIONS(7153),
    [sym__external_open_bracket2] = ACTIONS(7153),
    [sym__external_close_bracket2] = ACTIONS(7153),
  },
  [2292] = {
    [sym_identifier] = ACTIONS(7163),
    [anon_sym_BSLASH] = ACTIONS(7165),
    [anon_sym_function] = ACTIONS(7163),
    [anon_sym_EQ] = ACTIONS(7163),
    [anon_sym_if] = ACTIONS(7163),
    [anon_sym_for] = ACTIONS(7163),
    [anon_sym_while] = ACTIONS(7163),
    [anon_sym_repeat] = ACTIONS(7163),
    [anon_sym_QMARK] = ACTIONS(7165),
    [anon_sym_TILDE] = ACTIONS(7165),
    [anon_sym_BANG] = ACTIONS(7163),
    [anon_sym_PLUS] = ACTIONS(7165),
    [anon_sym_DASH] = ACTIONS(7163),
    [anon_sym_LT_DASH] = ACTIONS(7165),
    [anon_sym_LT_LT_DASH] = ACTIONS(7165),
    [anon_sym_COLON_EQ] = ACTIONS(7165),
    [anon_sym_DASH_GT] = ACTIONS(7163),
    [anon_sym_DASH_GT_GT] = ACTIONS(7165),
    [anon_sym_PIPE] = ACTIONS(7163),
    [anon_sym_AMP] = ACTIONS(7163),
    [anon_sym_PIPE_PIPE] = ACTIONS(7165),
    [anon_sym_AMP_AMP] = ACTIONS(7165),
    [anon_sym_LT] = ACTIONS(7163),
    [anon_sym_LT_EQ] = ACTIONS(7165),
    [anon_sym_GT] = ACTIONS(7163),
    [anon_sym_GT_EQ] = ACTIONS(7165),
    [anon_sym_EQ_EQ] = ACTIONS(7165),
    [anon_sym_BANG_EQ] = ACTIONS(7165),
    [anon_sym_STAR] = ACTIONS(7163),
    [anon_sym_SLASH] = ACTIONS(7165),
    [anon_sym_STAR_STAR] = ACTIONS(7165),
    [anon_sym_CARET] = ACTIONS(7165),
    [aux_sym_binary_operator_token1] = ACTIONS(7165),
    [anon_sym_PIPE_GT] = ACTIONS(7165),
    [anon_sym_COLON] = ACTIONS(7163),
    [anon_sym_DOLLAR] = ACTIONS(7165),
    [anon_sym_AT] = ACTIONS(7165),
    [anon_sym_COLON_COLON] = ACTIONS(7163),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7165),
    [aux_sym__hex_literal_token1] = ACTIONS(7165),
    [sym__number_literal] = ACTIONS(7163),
    [anon_sym_SQUOTE] = ACTIONS(7165),
    [anon_sym_DQUOTE] = ACTIONS(7165),
    [sym_return] = ACTIONS(7163),
    [sym_next] = ACTIONS(7163),
    [sym_break] = ACTIONS(7163),
    [sym_true] = ACTIONS(7163),
    [sym_false] = ACTIONS(7163),
    [sym_null] = ACTIONS(7163),
    [sym_inf] = ACTIONS(7163),
    [sym_nan] = ACTIONS(7163),
    [anon_sym_NA] = ACTIONS(7163),
    [anon_sym_NA_integer_] = ACTIONS(7163),
    [anon_sym_NA_real_] = ACTIONS(7163),
    [anon_sym_NA_complex_] = ACTIONS(7163),
    [anon_sym_NA_character_] = ACTIONS(7163),
    [sym_dots] = ACTIONS(7163),
    [sym_dot_dot_i] = ACTIONS(7165),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7165),
    [sym__newline] = ACTIONS(7165),
    [sym__raw_string_literal] = ACTIONS(7165),
    [sym__external_else] = ACTIONS(7165),
    [sym__external_open_parenthesis] = ACTIONS(7165),
    [sym__external_close_parenthesis] = ACTIONS(7165),
    [sym__external_open_brace] = ACTIONS(7165),
    [sym__external_open_bracket] = ACTIONS(7165),
    [sym__external_open_bracket2] = ACTIONS(7165),
    [sym__external_close_bracket2] = ACTIONS(7165),
  },
  [2293] = {
    [ts_builtin_sym_end] = ACTIONS(5327),
    [sym_identifier] = ACTIONS(5325),
    [anon_sym_BSLASH] = ACTIONS(5327),
    [anon_sym_function] = ACTIONS(5325),
    [anon_sym_EQ] = ACTIONS(5325),
    [anon_sym_if] = ACTIONS(5325),
    [anon_sym_for] = ACTIONS(5325),
    [anon_sym_while] = ACTIONS(5325),
    [anon_sym_repeat] = ACTIONS(5325),
    [anon_sym_QMARK] = ACTIONS(5327),
    [anon_sym_TILDE] = ACTIONS(5327),
    [anon_sym_BANG] = ACTIONS(5325),
    [anon_sym_PLUS] = ACTIONS(5327),
    [anon_sym_DASH] = ACTIONS(5325),
    [anon_sym_LT_DASH] = ACTIONS(5327),
    [anon_sym_LT_LT_DASH] = ACTIONS(5327),
    [anon_sym_COLON_EQ] = ACTIONS(5327),
    [anon_sym_DASH_GT] = ACTIONS(5325),
    [anon_sym_DASH_GT_GT] = ACTIONS(5327),
    [anon_sym_PIPE] = ACTIONS(5325),
    [anon_sym_AMP] = ACTIONS(5325),
    [anon_sym_PIPE_PIPE] = ACTIONS(5327),
    [anon_sym_AMP_AMP] = ACTIONS(5327),
    [anon_sym_LT] = ACTIONS(5325),
    [anon_sym_LT_EQ] = ACTIONS(5327),
    [anon_sym_GT] = ACTIONS(5325),
    [anon_sym_GT_EQ] = ACTIONS(5327),
    [anon_sym_EQ_EQ] = ACTIONS(5327),
    [anon_sym_BANG_EQ] = ACTIONS(5327),
    [anon_sym_STAR] = ACTIONS(5325),
    [anon_sym_SLASH] = ACTIONS(5327),
    [anon_sym_STAR_STAR] = ACTIONS(5327),
    [anon_sym_CARET] = ACTIONS(5327),
    [aux_sym_binary_operator_token1] = ACTIONS(5327),
    [anon_sym_PIPE_GT] = ACTIONS(5327),
    [anon_sym_COLON] = ACTIONS(5325),
    [anon_sym_DOLLAR] = ACTIONS(5327),
    [anon_sym_AT] = ACTIONS(5327),
    [aux_sym__hex_literal_token1] = ACTIONS(5327),
    [sym__number_literal] = ACTIONS(5325),
    [anon_sym_SQUOTE] = ACTIONS(5327),
    [anon_sym_DQUOTE] = ACTIONS(5327),
    [sym_return] = ACTIONS(5325),
    [sym_next] = ACTIONS(5325),
    [sym_break] = ACTIONS(5325),
    [sym_true] = ACTIONS(5325),
    [sym_false] = ACTIONS(5325),
    [sym_null] = ACTIONS(5325),
    [sym_inf] = ACTIONS(5325),
    [sym_nan] = ACTIONS(5325),
    [anon_sym_NA] = ACTIONS(5325),
    [anon_sym_NA_integer_] = ACTIONS(5325),
    [anon_sym_NA_real_] = ACTIONS(5325),
    [anon_sym_NA_complex_] = ACTIONS(5325),
    [anon_sym_NA_character_] = ACTIONS(5325),
    [sym_dots] = ACTIONS(5325),
    [sym_dot_dot_i] = ACTIONS(5327),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5327),
    [sym__newline] = ACTIONS(5327),
    [sym__semicolon] = ACTIONS(5327),
    [sym__raw_string_literal] = ACTIONS(5327),
    [sym__external_else] = ACTIONS(5327),
    [sym__external_open_parenthesis] = ACTIONS(5327),
    [sym__external_close_parenthesis] = ACTIONS(5327),
    [sym__external_open_brace] = ACTIONS(5327),
    [sym__external_close_brace] = ACTIONS(5327),
    [sym__external_open_bracket] = ACTIONS(5327),
    [sym__external_open_bracket2] = ACTIONS(5327),
  },
  [2294] = {
    [sym_identifier] = ACTIONS(7567),
    [anon_sym_BSLASH] = ACTIONS(7565),
    [anon_sym_function] = ACTIONS(7567),
    [anon_sym_EQ] = ACTIONS(7567),
    [anon_sym_if] = ACTIONS(7567),
    [anon_sym_for] = ACTIONS(7567),
    [anon_sym_while] = ACTIONS(7567),
    [anon_sym_repeat] = ACTIONS(7567),
    [anon_sym_QMARK] = ACTIONS(7565),
    [anon_sym_TILDE] = ACTIONS(7565),
    [anon_sym_BANG] = ACTIONS(7567),
    [anon_sym_PLUS] = ACTIONS(7565),
    [anon_sym_DASH] = ACTIONS(7567),
    [anon_sym_LT_DASH] = ACTIONS(7565),
    [anon_sym_LT_LT_DASH] = ACTIONS(7565),
    [anon_sym_COLON_EQ] = ACTIONS(7565),
    [anon_sym_DASH_GT] = ACTIONS(7567),
    [anon_sym_DASH_GT_GT] = ACTIONS(7565),
    [anon_sym_PIPE] = ACTIONS(7567),
    [anon_sym_AMP] = ACTIONS(7567),
    [anon_sym_PIPE_PIPE] = ACTIONS(7565),
    [anon_sym_AMP_AMP] = ACTIONS(7565),
    [anon_sym_LT] = ACTIONS(7567),
    [anon_sym_LT_EQ] = ACTIONS(7565),
    [anon_sym_GT] = ACTIONS(7567),
    [anon_sym_GT_EQ] = ACTIONS(7565),
    [anon_sym_EQ_EQ] = ACTIONS(7565),
    [anon_sym_BANG_EQ] = ACTIONS(7565),
    [anon_sym_STAR] = ACTIONS(7567),
    [anon_sym_SLASH] = ACTIONS(7565),
    [anon_sym_STAR_STAR] = ACTIONS(7565),
    [anon_sym_CARET] = ACTIONS(7565),
    [aux_sym_binary_operator_token1] = ACTIONS(7565),
    [anon_sym_PIPE_GT] = ACTIONS(7565),
    [anon_sym_COLON] = ACTIONS(7567),
    [anon_sym_DOLLAR] = ACTIONS(7565),
    [anon_sym_AT] = ACTIONS(7565),
    [aux_sym__hex_literal_token1] = ACTIONS(7565),
    [sym__number_literal] = ACTIONS(7567),
    [anon_sym_SQUOTE] = ACTIONS(7565),
    [anon_sym_DQUOTE] = ACTIONS(7565),
    [sym_return] = ACTIONS(7567),
    [sym_next] = ACTIONS(7567),
    [sym_break] = ACTIONS(7567),
    [sym_true] = ACTIONS(7567),
    [sym_false] = ACTIONS(7567),
    [sym_null] = ACTIONS(7567),
    [sym_inf] = ACTIONS(7567),
    [sym_nan] = ACTIONS(7567),
    [anon_sym_NA] = ACTIONS(7567),
    [anon_sym_NA_integer_] = ACTIONS(7567),
    [anon_sym_NA_real_] = ACTIONS(7567),
    [anon_sym_NA_complex_] = ACTIONS(7567),
    [anon_sym_NA_character_] = ACTIONS(7567),
    [sym_dots] = ACTIONS(7567),
    [sym_dot_dot_i] = ACTIONS(7565),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7565),
    [sym__newline] = ACTIONS(7565),
    [sym__semicolon] = ACTIONS(7565),
    [sym__raw_string_literal] = ACTIONS(7565),
    [sym__external_else] = ACTIONS(7565),
    [sym__external_open_parenthesis] = ACTIONS(7565),
    [sym__external_close_parenthesis] = ACTIONS(7565),
    [sym__external_open_brace] = ACTIONS(7565),
    [sym__external_close_brace] = ACTIONS(7565),
    [sym__external_open_bracket] = ACTIONS(7565),
    [sym__external_close_bracket] = ACTIONS(7565),
    [sym__external_open_bracket2] = ACTIONS(7565),
  },
  [2295] = {
    [sym_identifier] = ACTIONS(7191),
    [anon_sym_BSLASH] = ACTIONS(7189),
    [anon_sym_function] = ACTIONS(7191),
    [anon_sym_EQ] = ACTIONS(7191),
    [anon_sym_if] = ACTIONS(7191),
    [anon_sym_for] = ACTIONS(7191),
    [anon_sym_while] = ACTIONS(7191),
    [anon_sym_repeat] = ACTIONS(7191),
    [anon_sym_QMARK] = ACTIONS(7189),
    [anon_sym_TILDE] = ACTIONS(7189),
    [anon_sym_BANG] = ACTIONS(7191),
    [anon_sym_PLUS] = ACTIONS(7189),
    [anon_sym_DASH] = ACTIONS(7191),
    [anon_sym_LT_DASH] = ACTIONS(7189),
    [anon_sym_LT_LT_DASH] = ACTIONS(7189),
    [anon_sym_COLON_EQ] = ACTIONS(7189),
    [anon_sym_DASH_GT] = ACTIONS(7191),
    [anon_sym_DASH_GT_GT] = ACTIONS(7189),
    [anon_sym_PIPE] = ACTIONS(7191),
    [anon_sym_AMP] = ACTIONS(7191),
    [anon_sym_PIPE_PIPE] = ACTIONS(7189),
    [anon_sym_AMP_AMP] = ACTIONS(7189),
    [anon_sym_LT] = ACTIONS(7191),
    [anon_sym_LT_EQ] = ACTIONS(7189),
    [anon_sym_GT] = ACTIONS(7191),
    [anon_sym_GT_EQ] = ACTIONS(7189),
    [anon_sym_EQ_EQ] = ACTIONS(7189),
    [anon_sym_BANG_EQ] = ACTIONS(7189),
    [anon_sym_STAR] = ACTIONS(7191),
    [anon_sym_SLASH] = ACTIONS(7189),
    [anon_sym_STAR_STAR] = ACTIONS(7189),
    [anon_sym_CARET] = ACTIONS(7189),
    [aux_sym_binary_operator_token1] = ACTIONS(7189),
    [anon_sym_PIPE_GT] = ACTIONS(7189),
    [anon_sym_COLON] = ACTIONS(7191),
    [anon_sym_DOLLAR] = ACTIONS(7189),
    [anon_sym_AT] = ACTIONS(7189),
    [anon_sym_COLON_COLON] = ACTIONS(7191),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7189),
    [aux_sym__hex_literal_token1] = ACTIONS(7189),
    [sym__number_literal] = ACTIONS(7191),
    [anon_sym_SQUOTE] = ACTIONS(7189),
    [anon_sym_DQUOTE] = ACTIONS(7189),
    [sym_return] = ACTIONS(7191),
    [sym_next] = ACTIONS(7191),
    [sym_break] = ACTIONS(7191),
    [sym_true] = ACTIONS(7191),
    [sym_false] = ACTIONS(7191),
    [sym_null] = ACTIONS(7191),
    [sym_inf] = ACTIONS(7191),
    [sym_nan] = ACTIONS(7191),
    [anon_sym_NA] = ACTIONS(7191),
    [anon_sym_NA_integer_] = ACTIONS(7191),
    [anon_sym_NA_real_] = ACTIONS(7191),
    [anon_sym_NA_complex_] = ACTIONS(7191),
    [anon_sym_NA_character_] = ACTIONS(7191),
    [sym_dots] = ACTIONS(7191),
    [sym_dot_dot_i] = ACTIONS(7189),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7189),
    [sym__newline] = ACTIONS(7189),
    [sym__raw_string_literal] = ACTIONS(7189),
    [sym__external_else] = ACTIONS(7189),
    [sym__external_open_parenthesis] = ACTIONS(7189),
    [sym__external_close_parenthesis] = ACTIONS(7189),
    [sym__external_open_brace] = ACTIONS(7189),
    [sym__external_open_bracket] = ACTIONS(7189),
    [sym__external_open_bracket2] = ACTIONS(7189),
    [sym__external_close_bracket2] = ACTIONS(7189),
  },
  [2296] = {
    [sym_identifier] = ACTIONS(7195),
    [anon_sym_BSLASH] = ACTIONS(7193),
    [anon_sym_function] = ACTIONS(7195),
    [anon_sym_EQ] = ACTIONS(7195),
    [anon_sym_if] = ACTIONS(7195),
    [anon_sym_for] = ACTIONS(7195),
    [anon_sym_while] = ACTIONS(7195),
    [anon_sym_repeat] = ACTIONS(7195),
    [anon_sym_QMARK] = ACTIONS(7193),
    [anon_sym_TILDE] = ACTIONS(7193),
    [anon_sym_BANG] = ACTIONS(7195),
    [anon_sym_PLUS] = ACTIONS(7193),
    [anon_sym_DASH] = ACTIONS(7195),
    [anon_sym_LT_DASH] = ACTIONS(7193),
    [anon_sym_LT_LT_DASH] = ACTIONS(7193),
    [anon_sym_COLON_EQ] = ACTIONS(7193),
    [anon_sym_DASH_GT] = ACTIONS(7195),
    [anon_sym_DASH_GT_GT] = ACTIONS(7193),
    [anon_sym_PIPE] = ACTIONS(7195),
    [anon_sym_AMP] = ACTIONS(7195),
    [anon_sym_PIPE_PIPE] = ACTIONS(7193),
    [anon_sym_AMP_AMP] = ACTIONS(7193),
    [anon_sym_LT] = ACTIONS(7195),
    [anon_sym_LT_EQ] = ACTIONS(7193),
    [anon_sym_GT] = ACTIONS(7195),
    [anon_sym_GT_EQ] = ACTIONS(7193),
    [anon_sym_EQ_EQ] = ACTIONS(7193),
    [anon_sym_BANG_EQ] = ACTIONS(7193),
    [anon_sym_STAR] = ACTIONS(7195),
    [anon_sym_SLASH] = ACTIONS(7193),
    [anon_sym_STAR_STAR] = ACTIONS(7193),
    [anon_sym_CARET] = ACTIONS(7193),
    [aux_sym_binary_operator_token1] = ACTIONS(7193),
    [anon_sym_PIPE_GT] = ACTIONS(7193),
    [anon_sym_COLON] = ACTIONS(7195),
    [anon_sym_DOLLAR] = ACTIONS(7193),
    [anon_sym_AT] = ACTIONS(7193),
    [anon_sym_COLON_COLON] = ACTIONS(7195),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7193),
    [aux_sym__hex_literal_token1] = ACTIONS(7193),
    [sym__number_literal] = ACTIONS(7195),
    [anon_sym_SQUOTE] = ACTIONS(7193),
    [anon_sym_DQUOTE] = ACTIONS(7193),
    [sym_return] = ACTIONS(7195),
    [sym_next] = ACTIONS(7195),
    [sym_break] = ACTIONS(7195),
    [sym_true] = ACTIONS(7195),
    [sym_false] = ACTIONS(7195),
    [sym_null] = ACTIONS(7195),
    [sym_inf] = ACTIONS(7195),
    [sym_nan] = ACTIONS(7195),
    [anon_sym_NA] = ACTIONS(7195),
    [anon_sym_NA_integer_] = ACTIONS(7195),
    [anon_sym_NA_real_] = ACTIONS(7195),
    [anon_sym_NA_complex_] = ACTIONS(7195),
    [anon_sym_NA_character_] = ACTIONS(7195),
    [sym_dots] = ACTIONS(7195),
    [sym_dot_dot_i] = ACTIONS(7193),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7193),
    [sym__newline] = ACTIONS(7193),
    [sym__raw_string_literal] = ACTIONS(7193),
    [sym__external_else] = ACTIONS(7193),
    [sym__external_open_parenthesis] = ACTIONS(7193),
    [sym__external_close_parenthesis] = ACTIONS(7193),
    [sym__external_open_brace] = ACTIONS(7193),
    [sym__external_open_bracket] = ACTIONS(7193),
    [sym__external_open_bracket2] = ACTIONS(7193),
    [sym__external_close_bracket2] = ACTIONS(7193),
  },
  [2297] = {
    [sym_identifier] = ACTIONS(7563),
    [anon_sym_BSLASH] = ACTIONS(7561),
    [anon_sym_function] = ACTIONS(7563),
    [anon_sym_EQ] = ACTIONS(7563),
    [anon_sym_if] = ACTIONS(7563),
    [anon_sym_for] = ACTIONS(7563),
    [anon_sym_while] = ACTIONS(7563),
    [anon_sym_repeat] = ACTIONS(7563),
    [anon_sym_QMARK] = ACTIONS(7561),
    [anon_sym_TILDE] = ACTIONS(7561),
    [anon_sym_BANG] = ACTIONS(7563),
    [anon_sym_PLUS] = ACTIONS(7561),
    [anon_sym_DASH] = ACTIONS(7563),
    [anon_sym_LT_DASH] = ACTIONS(7561),
    [anon_sym_LT_LT_DASH] = ACTIONS(7561),
    [anon_sym_COLON_EQ] = ACTIONS(7561),
    [anon_sym_DASH_GT] = ACTIONS(7563),
    [anon_sym_DASH_GT_GT] = ACTIONS(7561),
    [anon_sym_PIPE] = ACTIONS(7563),
    [anon_sym_AMP] = ACTIONS(7563),
    [anon_sym_PIPE_PIPE] = ACTIONS(7561),
    [anon_sym_AMP_AMP] = ACTIONS(7561),
    [anon_sym_LT] = ACTIONS(7563),
    [anon_sym_LT_EQ] = ACTIONS(7561),
    [anon_sym_GT] = ACTIONS(7563),
    [anon_sym_GT_EQ] = ACTIONS(7561),
    [anon_sym_EQ_EQ] = ACTIONS(7561),
    [anon_sym_BANG_EQ] = ACTIONS(7561),
    [anon_sym_STAR] = ACTIONS(7563),
    [anon_sym_SLASH] = ACTIONS(7561),
    [anon_sym_STAR_STAR] = ACTIONS(7561),
    [anon_sym_CARET] = ACTIONS(7561),
    [aux_sym_binary_operator_token1] = ACTIONS(7561),
    [anon_sym_PIPE_GT] = ACTIONS(7561),
    [anon_sym_COLON] = ACTIONS(7563),
    [anon_sym_DOLLAR] = ACTIONS(7561),
    [anon_sym_AT] = ACTIONS(7561),
    [aux_sym__hex_literal_token1] = ACTIONS(7561),
    [sym__number_literal] = ACTIONS(7563),
    [anon_sym_SQUOTE] = ACTIONS(7561),
    [anon_sym_DQUOTE] = ACTIONS(7561),
    [sym_return] = ACTIONS(7563),
    [sym_next] = ACTIONS(7563),
    [sym_break] = ACTIONS(7563),
    [sym_true] = ACTIONS(7563),
    [sym_false] = ACTIONS(7563),
    [sym_null] = ACTIONS(7563),
    [sym_inf] = ACTIONS(7563),
    [sym_nan] = ACTIONS(7563),
    [anon_sym_NA] = ACTIONS(7563),
    [anon_sym_NA_integer_] = ACTIONS(7563),
    [anon_sym_NA_real_] = ACTIONS(7563),
    [anon_sym_NA_complex_] = ACTIONS(7563),
    [anon_sym_NA_character_] = ACTIONS(7563),
    [sym_dots] = ACTIONS(7563),
    [sym_dot_dot_i] = ACTIONS(7561),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7561),
    [sym__newline] = ACTIONS(7561),
    [sym__semicolon] = ACTIONS(7561),
    [sym__raw_string_literal] = ACTIONS(7561),
    [sym__external_else] = ACTIONS(7561),
    [sym__external_open_parenthesis] = ACTIONS(7561),
    [sym__external_close_parenthesis] = ACTIONS(7561),
    [sym__external_open_brace] = ACTIONS(7561),
    [sym__external_close_brace] = ACTIONS(7561),
    [sym__external_open_bracket] = ACTIONS(7561),
    [sym__external_close_bracket] = ACTIONS(7561),
    [sym__external_open_bracket2] = ACTIONS(7561),
  },
  [2298] = {
    [sym_identifier] = ACTIONS(7556),
    [anon_sym_BSLASH] = ACTIONS(7554),
    [anon_sym_function] = ACTIONS(7556),
    [anon_sym_EQ] = ACTIONS(7556),
    [anon_sym_if] = ACTIONS(7556),
    [anon_sym_for] = ACTIONS(7556),
    [anon_sym_while] = ACTIONS(7556),
    [anon_sym_repeat] = ACTIONS(7556),
    [anon_sym_QMARK] = ACTIONS(7554),
    [anon_sym_TILDE] = ACTIONS(7554),
    [anon_sym_BANG] = ACTIONS(7556),
    [anon_sym_PLUS] = ACTIONS(7554),
    [anon_sym_DASH] = ACTIONS(7556),
    [anon_sym_LT_DASH] = ACTIONS(7554),
    [anon_sym_LT_LT_DASH] = ACTIONS(7554),
    [anon_sym_COLON_EQ] = ACTIONS(7554),
    [anon_sym_DASH_GT] = ACTIONS(7556),
    [anon_sym_DASH_GT_GT] = ACTIONS(7554),
    [anon_sym_PIPE] = ACTIONS(7556),
    [anon_sym_AMP] = ACTIONS(7556),
    [anon_sym_PIPE_PIPE] = ACTIONS(7554),
    [anon_sym_AMP_AMP] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(7556),
    [anon_sym_LT_EQ] = ACTIONS(7554),
    [anon_sym_GT] = ACTIONS(7556),
    [anon_sym_GT_EQ] = ACTIONS(7554),
    [anon_sym_EQ_EQ] = ACTIONS(7554),
    [anon_sym_BANG_EQ] = ACTIONS(7554),
    [anon_sym_STAR] = ACTIONS(7556),
    [anon_sym_SLASH] = ACTIONS(7554),
    [anon_sym_STAR_STAR] = ACTIONS(7554),
    [anon_sym_CARET] = ACTIONS(7554),
    [aux_sym_binary_operator_token1] = ACTIONS(7554),
    [anon_sym_PIPE_GT] = ACTIONS(7554),
    [anon_sym_COLON] = ACTIONS(7556),
    [anon_sym_DOLLAR] = ACTIONS(7554),
    [anon_sym_AT] = ACTIONS(7554),
    [aux_sym__hex_literal_token1] = ACTIONS(7554),
    [sym__number_literal] = ACTIONS(7556),
    [anon_sym_SQUOTE] = ACTIONS(7554),
    [anon_sym_DQUOTE] = ACTIONS(7554),
    [sym_return] = ACTIONS(7556),
    [sym_next] = ACTIONS(7556),
    [sym_break] = ACTIONS(7556),
    [sym_true] = ACTIONS(7556),
    [sym_false] = ACTIONS(7556),
    [sym_null] = ACTIONS(7556),
    [sym_inf] = ACTIONS(7556),
    [sym_nan] = ACTIONS(7556),
    [anon_sym_NA] = ACTIONS(7556),
    [anon_sym_NA_integer_] = ACTIONS(7556),
    [anon_sym_NA_real_] = ACTIONS(7556),
    [anon_sym_NA_complex_] = ACTIONS(7556),
    [anon_sym_NA_character_] = ACTIONS(7556),
    [sym_dots] = ACTIONS(7556),
    [sym_dot_dot_i] = ACTIONS(7554),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7554),
    [sym__newline] = ACTIONS(7554),
    [sym__semicolon] = ACTIONS(7554),
    [sym__raw_string_literal] = ACTIONS(7554),
    [sym__external_else] = ACTIONS(7554),
    [sym__external_open_parenthesis] = ACTIONS(7554),
    [sym__external_close_parenthesis] = ACTIONS(7554),
    [sym__external_open_brace] = ACTIONS(7554),
    [sym__external_close_brace] = ACTIONS(7554),
    [sym__external_open_bracket] = ACTIONS(7554),
    [sym__external_close_bracket] = ACTIONS(7554),
    [sym__external_open_bracket2] = ACTIONS(7554),
  },
  [2299] = {
    [ts_builtin_sym_end] = ACTIONS(7193),
    [sym_identifier] = ACTIONS(7195),
    [anon_sym_BSLASH] = ACTIONS(7193),
    [anon_sym_function] = ACTIONS(7195),
    [anon_sym_EQ] = ACTIONS(7195),
    [anon_sym_if] = ACTIONS(7195),
    [anon_sym_for] = ACTIONS(7195),
    [anon_sym_while] = ACTIONS(7195),
    [anon_sym_repeat] = ACTIONS(7195),
    [anon_sym_QMARK] = ACTIONS(7193),
    [anon_sym_TILDE] = ACTIONS(7193),
    [anon_sym_BANG] = ACTIONS(7195),
    [anon_sym_PLUS] = ACTIONS(7193),
    [anon_sym_DASH] = ACTIONS(7195),
    [anon_sym_LT_DASH] = ACTIONS(7193),
    [anon_sym_LT_LT_DASH] = ACTIONS(7193),
    [anon_sym_COLON_EQ] = ACTIONS(7193),
    [anon_sym_DASH_GT] = ACTIONS(7195),
    [anon_sym_DASH_GT_GT] = ACTIONS(7193),
    [anon_sym_PIPE] = ACTIONS(7195),
    [anon_sym_AMP] = ACTIONS(7195),
    [anon_sym_PIPE_PIPE] = ACTIONS(7193),
    [anon_sym_AMP_AMP] = ACTIONS(7193),
    [anon_sym_LT] = ACTIONS(7195),
    [anon_sym_LT_EQ] = ACTIONS(7193),
    [anon_sym_GT] = ACTIONS(7195),
    [anon_sym_GT_EQ] = ACTIONS(7193),
    [anon_sym_EQ_EQ] = ACTIONS(7193),
    [anon_sym_BANG_EQ] = ACTIONS(7193),
    [anon_sym_STAR] = ACTIONS(7195),
    [anon_sym_SLASH] = ACTIONS(7193),
    [anon_sym_STAR_STAR] = ACTIONS(7193),
    [anon_sym_CARET] = ACTIONS(7193),
    [aux_sym_binary_operator_token1] = ACTIONS(7193),
    [anon_sym_PIPE_GT] = ACTIONS(7193),
    [anon_sym_COLON] = ACTIONS(7195),
    [anon_sym_DOLLAR] = ACTIONS(7193),
    [anon_sym_AT] = ACTIONS(7193),
    [anon_sym_COLON_COLON] = ACTIONS(7195),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7193),
    [aux_sym__hex_literal_token1] = ACTIONS(7193),
    [sym__number_literal] = ACTIONS(7195),
    [anon_sym_SQUOTE] = ACTIONS(7193),
    [anon_sym_DQUOTE] = ACTIONS(7193),
    [sym_return] = ACTIONS(7195),
    [sym_next] = ACTIONS(7195),
    [sym_break] = ACTIONS(7195),
    [sym_true] = ACTIONS(7195),
    [sym_false] = ACTIONS(7195),
    [sym_null] = ACTIONS(7195),
    [sym_inf] = ACTIONS(7195),
    [sym_nan] = ACTIONS(7195),
    [anon_sym_NA] = ACTIONS(7195),
    [anon_sym_NA_integer_] = ACTIONS(7195),
    [anon_sym_NA_real_] = ACTIONS(7195),
    [anon_sym_NA_complex_] = ACTIONS(7195),
    [anon_sym_NA_character_] = ACTIONS(7195),
    [sym_dots] = ACTIONS(7195),
    [sym_dot_dot_i] = ACTIONS(7193),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7193),
    [sym__semicolon] = ACTIONS(7193),
    [sym__raw_string_literal] = ACTIONS(7193),
    [sym__external_else] = ACTIONS(7193),
    [sym__external_open_parenthesis] = ACTIONS(7193),
    [sym__external_open_brace] = ACTIONS(7193),
    [sym__external_close_brace] = ACTIONS(7193),
    [sym__external_open_bracket] = ACTIONS(7193),
    [sym__external_open_bracket2] = ACTIONS(7193),
  },
  [2300] = {
    [ts_builtin_sym_end] = ACTIONS(7189),
    [sym_identifier] = ACTIONS(7191),
    [anon_sym_BSLASH] = ACTIONS(7189),
    [anon_sym_function] = ACTIONS(7191),
    [anon_sym_EQ] = ACTIONS(7191),
    [anon_sym_if] = ACTIONS(7191),
    [anon_sym_for] = ACTIONS(7191),
    [anon_sym_while] = ACTIONS(7191),
    [anon_sym_repeat] = ACTIONS(7191),
    [anon_sym_QMARK] = ACTIONS(7189),
    [anon_sym_TILDE] = ACTIONS(7189),
    [anon_sym_BANG] = ACTIONS(7191),
    [anon_sym_PLUS] = ACTIONS(7189),
    [anon_sym_DASH] = ACTIONS(7191),
    [anon_sym_LT_DASH] = ACTIONS(7189),
    [anon_sym_LT_LT_DASH] = ACTIONS(7189),
    [anon_sym_COLON_EQ] = ACTIONS(7189),
    [anon_sym_DASH_GT] = ACTIONS(7191),
    [anon_sym_DASH_GT_GT] = ACTIONS(7189),
    [anon_sym_PIPE] = ACTIONS(7191),
    [anon_sym_AMP] = ACTIONS(7191),
    [anon_sym_PIPE_PIPE] = ACTIONS(7189),
    [anon_sym_AMP_AMP] = ACTIONS(7189),
    [anon_sym_LT] = ACTIONS(7191),
    [anon_sym_LT_EQ] = ACTIONS(7189),
    [anon_sym_GT] = ACTIONS(7191),
    [anon_sym_GT_EQ] = ACTIONS(7189),
    [anon_sym_EQ_EQ] = ACTIONS(7189),
    [anon_sym_BANG_EQ] = ACTIONS(7189),
    [anon_sym_STAR] = ACTIONS(7191),
    [anon_sym_SLASH] = ACTIONS(7189),
    [anon_sym_STAR_STAR] = ACTIONS(7189),
    [anon_sym_CARET] = ACTIONS(7189),
    [aux_sym_binary_operator_token1] = ACTIONS(7189),
    [anon_sym_PIPE_GT] = ACTIONS(7189),
    [anon_sym_COLON] = ACTIONS(7191),
    [anon_sym_DOLLAR] = ACTIONS(7189),
    [anon_sym_AT] = ACTIONS(7189),
    [anon_sym_COLON_COLON] = ACTIONS(7191),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7189),
    [aux_sym__hex_literal_token1] = ACTIONS(7189),
    [sym__number_literal] = ACTIONS(7191),
    [anon_sym_SQUOTE] = ACTIONS(7189),
    [anon_sym_DQUOTE] = ACTIONS(7189),
    [sym_return] = ACTIONS(7191),
    [sym_next] = ACTIONS(7191),
    [sym_break] = ACTIONS(7191),
    [sym_true] = ACTIONS(7191),
    [sym_false] = ACTIONS(7191),
    [sym_null] = ACTIONS(7191),
    [sym_inf] = ACTIONS(7191),
    [sym_nan] = ACTIONS(7191),
    [anon_sym_NA] = ACTIONS(7191),
    [anon_sym_NA_integer_] = ACTIONS(7191),
    [anon_sym_NA_real_] = ACTIONS(7191),
    [anon_sym_NA_complex_] = ACTIONS(7191),
    [anon_sym_NA_character_] = ACTIONS(7191),
    [sym_dots] = ACTIONS(7191),
    [sym_dot_dot_i] = ACTIONS(7189),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7189),
    [sym__semicolon] = ACTIONS(7189),
    [sym__raw_string_literal] = ACTIONS(7189),
    [sym__external_else] = ACTIONS(7189),
    [sym__external_open_parenthesis] = ACTIONS(7189),
    [sym__external_open_brace] = ACTIONS(7189),
    [sym__external_close_brace] = ACTIONS(7189),
    [sym__external_open_bracket] = ACTIONS(7189),
    [sym__external_open_bracket2] = ACTIONS(7189),
  },
  [2301] = {
    [sym_identifier] = ACTIONS(7567),
    [anon_sym_BSLASH] = ACTIONS(7565),
    [anon_sym_function] = ACTIONS(7567),
    [anon_sym_EQ] = ACTIONS(7567),
    [anon_sym_if] = ACTIONS(7567),
    [anon_sym_for] = ACTIONS(7567),
    [anon_sym_while] = ACTIONS(7567),
    [anon_sym_repeat] = ACTIONS(7567),
    [anon_sym_QMARK] = ACTIONS(7565),
    [anon_sym_TILDE] = ACTIONS(7565),
    [anon_sym_BANG] = ACTIONS(7567),
    [anon_sym_PLUS] = ACTIONS(7565),
    [anon_sym_DASH] = ACTIONS(7567),
    [anon_sym_LT_DASH] = ACTIONS(7565),
    [anon_sym_LT_LT_DASH] = ACTIONS(7565),
    [anon_sym_COLON_EQ] = ACTIONS(7565),
    [anon_sym_DASH_GT] = ACTIONS(7567),
    [anon_sym_DASH_GT_GT] = ACTIONS(7565),
    [anon_sym_PIPE] = ACTIONS(7567),
    [anon_sym_AMP] = ACTIONS(7567),
    [anon_sym_PIPE_PIPE] = ACTIONS(7565),
    [anon_sym_AMP_AMP] = ACTIONS(7565),
    [anon_sym_LT] = ACTIONS(7567),
    [anon_sym_LT_EQ] = ACTIONS(7565),
    [anon_sym_GT] = ACTIONS(7567),
    [anon_sym_GT_EQ] = ACTIONS(7565),
    [anon_sym_EQ_EQ] = ACTIONS(7565),
    [anon_sym_BANG_EQ] = ACTIONS(7565),
    [anon_sym_STAR] = ACTIONS(7567),
    [anon_sym_SLASH] = ACTIONS(7565),
    [anon_sym_STAR_STAR] = ACTIONS(7565),
    [anon_sym_CARET] = ACTIONS(7565),
    [aux_sym_binary_operator_token1] = ACTIONS(7565),
    [anon_sym_PIPE_GT] = ACTIONS(7565),
    [anon_sym_COLON] = ACTIONS(7567),
    [anon_sym_DOLLAR] = ACTIONS(7565),
    [anon_sym_AT] = ACTIONS(7565),
    [aux_sym__hex_literal_token1] = ACTIONS(7565),
    [sym__number_literal] = ACTIONS(7567),
    [anon_sym_SQUOTE] = ACTIONS(7565),
    [anon_sym_DQUOTE] = ACTIONS(7565),
    [sym_return] = ACTIONS(7567),
    [sym_next] = ACTIONS(7567),
    [sym_break] = ACTIONS(7567),
    [sym_true] = ACTIONS(7567),
    [sym_false] = ACTIONS(7567),
    [sym_null] = ACTIONS(7567),
    [sym_inf] = ACTIONS(7567),
    [sym_nan] = ACTIONS(7567),
    [anon_sym_NA] = ACTIONS(7567),
    [anon_sym_NA_integer_] = ACTIONS(7567),
    [anon_sym_NA_real_] = ACTIONS(7567),
    [anon_sym_NA_complex_] = ACTIONS(7567),
    [anon_sym_NA_character_] = ACTIONS(7567),
    [sym_dots] = ACTIONS(7567),
    [sym_dot_dot_i] = ACTIONS(7565),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7565),
    [sym__newline] = ACTIONS(7565),
    [sym__semicolon] = ACTIONS(7565),
    [sym__raw_string_literal] = ACTIONS(7565),
    [sym__external_else] = ACTIONS(7565),
    [sym__external_open_parenthesis] = ACTIONS(7565),
    [sym__external_close_parenthesis] = ACTIONS(7565),
    [sym__external_open_brace] = ACTIONS(7565),
    [sym__external_close_brace] = ACTIONS(7565),
    [sym__external_open_bracket] = ACTIONS(7565),
    [sym__external_open_bracket2] = ACTIONS(7565),
    [sym__external_close_bracket2] = ACTIONS(7565),
  },
  [2302] = {
    [aux_sym_function_definition_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(7419),
    [anon_sym_BSLASH] = ACTIONS(7417),
    [anon_sym_function] = ACTIONS(7419),
    [anon_sym_EQ] = ACTIONS(7419),
    [anon_sym_if] = ACTIONS(7419),
    [anon_sym_for] = ACTIONS(7419),
    [anon_sym_while] = ACTIONS(7419),
    [anon_sym_repeat] = ACTIONS(7419),
    [anon_sym_QMARK] = ACTIONS(7417),
    [anon_sym_TILDE] = ACTIONS(7417),
    [anon_sym_BANG] = ACTIONS(7419),
    [anon_sym_PLUS] = ACTIONS(7417),
    [anon_sym_DASH] = ACTIONS(7419),
    [anon_sym_LT_DASH] = ACTIONS(7417),
    [anon_sym_LT_LT_DASH] = ACTIONS(7417),
    [anon_sym_COLON_EQ] = ACTIONS(7417),
    [anon_sym_DASH_GT] = ACTIONS(7419),
    [anon_sym_DASH_GT_GT] = ACTIONS(7417),
    [anon_sym_PIPE] = ACTIONS(7419),
    [anon_sym_AMP] = ACTIONS(7419),
    [anon_sym_PIPE_PIPE] = ACTIONS(7417),
    [anon_sym_AMP_AMP] = ACTIONS(7417),
    [anon_sym_LT] = ACTIONS(7419),
    [anon_sym_LT_EQ] = ACTIONS(7417),
    [anon_sym_GT] = ACTIONS(7419),
    [anon_sym_GT_EQ] = ACTIONS(7417),
    [anon_sym_EQ_EQ] = ACTIONS(7417),
    [anon_sym_BANG_EQ] = ACTIONS(7417),
    [anon_sym_STAR] = ACTIONS(7419),
    [anon_sym_SLASH] = ACTIONS(7417),
    [anon_sym_STAR_STAR] = ACTIONS(7417),
    [anon_sym_CARET] = ACTIONS(7417),
    [aux_sym_binary_operator_token1] = ACTIONS(7417),
    [anon_sym_PIPE_GT] = ACTIONS(7417),
    [anon_sym_COLON] = ACTIONS(7419),
    [anon_sym_DOLLAR] = ACTIONS(7417),
    [anon_sym_AT] = ACTIONS(7417),
    [aux_sym__hex_literal_token1] = ACTIONS(7417),
    [sym__number_literal] = ACTIONS(7419),
    [anon_sym_SQUOTE] = ACTIONS(7417),
    [anon_sym_DQUOTE] = ACTIONS(7417),
    [sym_return] = ACTIONS(7419),
    [sym_next] = ACTIONS(7419),
    [sym_break] = ACTIONS(7419),
    [sym_true] = ACTIONS(7419),
    [sym_false] = ACTIONS(7419),
    [sym_null] = ACTIONS(7419),
    [sym_inf] = ACTIONS(7419),
    [sym_nan] = ACTIONS(7419),
    [anon_sym_NA] = ACTIONS(7419),
    [anon_sym_NA_integer_] = ACTIONS(7419),
    [anon_sym_NA_real_] = ACTIONS(7419),
    [anon_sym_NA_complex_] = ACTIONS(7419),
    [anon_sym_NA_character_] = ACTIONS(7419),
    [sym_dots] = ACTIONS(7419),
    [sym_dot_dot_i] = ACTIONS(7417),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7417),
    [sym__newline] = ACTIONS(7573),
    [sym__semicolon] = ACTIONS(7417),
    [sym__raw_string_literal] = ACTIONS(7417),
    [sym__external_else] = ACTIONS(7417),
    [sym__external_open_parenthesis] = ACTIONS(7417),
    [sym__external_open_brace] = ACTIONS(7417),
    [sym__external_close_brace] = ACTIONS(7417),
    [sym__external_open_bracket] = ACTIONS(7417),
    [sym__external_close_bracket] = ACTIONS(7417),
    [sym__external_open_bracket2] = ACTIONS(7417),
  },
  [2303] = {
    [aux_sym_function_definition_repeat1] = STATE(2303),
    [sym_identifier] = ACTIONS(7419),
    [anon_sym_BSLASH] = ACTIONS(7417),
    [anon_sym_function] = ACTIONS(7419),
    [anon_sym_EQ] = ACTIONS(7419),
    [anon_sym_if] = ACTIONS(7419),
    [anon_sym_for] = ACTIONS(7419),
    [anon_sym_while] = ACTIONS(7419),
    [anon_sym_repeat] = ACTIONS(7419),
    [anon_sym_QMARK] = ACTIONS(7417),
    [anon_sym_TILDE] = ACTIONS(7417),
    [anon_sym_BANG] = ACTIONS(7419),
    [anon_sym_PLUS] = ACTIONS(7417),
    [anon_sym_DASH] = ACTIONS(7419),
    [anon_sym_LT_DASH] = ACTIONS(7417),
    [anon_sym_LT_LT_DASH] = ACTIONS(7417),
    [anon_sym_COLON_EQ] = ACTIONS(7417),
    [anon_sym_DASH_GT] = ACTIONS(7419),
    [anon_sym_DASH_GT_GT] = ACTIONS(7417),
    [anon_sym_PIPE] = ACTIONS(7419),
    [anon_sym_AMP] = ACTIONS(7419),
    [anon_sym_PIPE_PIPE] = ACTIONS(7417),
    [anon_sym_AMP_AMP] = ACTIONS(7417),
    [anon_sym_LT] = ACTIONS(7419),
    [anon_sym_LT_EQ] = ACTIONS(7417),
    [anon_sym_GT] = ACTIONS(7419),
    [anon_sym_GT_EQ] = ACTIONS(7417),
    [anon_sym_EQ_EQ] = ACTIONS(7417),
    [anon_sym_BANG_EQ] = ACTIONS(7417),
    [anon_sym_STAR] = ACTIONS(7419),
    [anon_sym_SLASH] = ACTIONS(7417),
    [anon_sym_STAR_STAR] = ACTIONS(7417),
    [anon_sym_CARET] = ACTIONS(7417),
    [aux_sym_binary_operator_token1] = ACTIONS(7417),
    [anon_sym_PIPE_GT] = ACTIONS(7417),
    [anon_sym_COLON] = ACTIONS(7419),
    [anon_sym_DOLLAR] = ACTIONS(7417),
    [anon_sym_AT] = ACTIONS(7417),
    [aux_sym__hex_literal_token1] = ACTIONS(7417),
    [sym__number_literal] = ACTIONS(7419),
    [anon_sym_SQUOTE] = ACTIONS(7417),
    [anon_sym_DQUOTE] = ACTIONS(7417),
    [sym_return] = ACTIONS(7419),
    [sym_next] = ACTIONS(7419),
    [sym_break] = ACTIONS(7419),
    [sym_true] = ACTIONS(7419),
    [sym_false] = ACTIONS(7419),
    [sym_null] = ACTIONS(7419),
    [sym_inf] = ACTIONS(7419),
    [sym_nan] = ACTIONS(7419),
    [anon_sym_NA] = ACTIONS(7419),
    [anon_sym_NA_integer_] = ACTIONS(7419),
    [anon_sym_NA_real_] = ACTIONS(7419),
    [anon_sym_NA_complex_] = ACTIONS(7419),
    [anon_sym_NA_character_] = ACTIONS(7419),
    [sym_dots] = ACTIONS(7419),
    [sym_dot_dot_i] = ACTIONS(7417),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7417),
    [sym__newline] = ACTIONS(7576),
    [sym__semicolon] = ACTIONS(7417),
    [sym__raw_string_literal] = ACTIONS(7417),
    [sym__external_open_parenthesis] = ACTIONS(7417),
    [sym__external_close_parenthesis] = ACTIONS(7417),
    [sym__external_open_brace] = ACTIONS(7417),
    [sym__external_close_brace] = ACTIONS(7417),
    [sym__external_open_bracket] = ACTIONS(7417),
    [sym__external_open_bracket2] = ACTIONS(7417),
    [sym__external_close_bracket2] = ACTIONS(7417),
  },
  [2304] = {
    [sym_identifier] = ACTIONS(5311),
    [anon_sym_BSLASH] = ACTIONS(5313),
    [anon_sym_function] = ACTIONS(5311),
    [anon_sym_EQ] = ACTIONS(5311),
    [anon_sym_if] = ACTIONS(5311),
    [anon_sym_for] = ACTIONS(5311),
    [anon_sym_while] = ACTIONS(5311),
    [anon_sym_repeat] = ACTIONS(5311),
    [anon_sym_QMARK] = ACTIONS(5313),
    [anon_sym_TILDE] = ACTIONS(5313),
    [anon_sym_BANG] = ACTIONS(5311),
    [anon_sym_PLUS] = ACTIONS(5313),
    [anon_sym_DASH] = ACTIONS(5311),
    [anon_sym_LT_DASH] = ACTIONS(5313),
    [anon_sym_LT_LT_DASH] = ACTIONS(5313),
    [anon_sym_COLON_EQ] = ACTIONS(5313),
    [anon_sym_DASH_GT] = ACTIONS(5311),
    [anon_sym_DASH_GT_GT] = ACTIONS(5313),
    [anon_sym_PIPE] = ACTIONS(5311),
    [anon_sym_AMP] = ACTIONS(5311),
    [anon_sym_PIPE_PIPE] = ACTIONS(5313),
    [anon_sym_AMP_AMP] = ACTIONS(5313),
    [anon_sym_LT] = ACTIONS(5311),
    [anon_sym_LT_EQ] = ACTIONS(5313),
    [anon_sym_GT] = ACTIONS(5311),
    [anon_sym_GT_EQ] = ACTIONS(5313),
    [anon_sym_EQ_EQ] = ACTIONS(5313),
    [anon_sym_BANG_EQ] = ACTIONS(5313),
    [anon_sym_STAR] = ACTIONS(5311),
    [anon_sym_SLASH] = ACTIONS(5313),
    [anon_sym_STAR_STAR] = ACTIONS(5313),
    [anon_sym_CARET] = ACTIONS(5313),
    [aux_sym_binary_operator_token1] = ACTIONS(5313),
    [anon_sym_PIPE_GT] = ACTIONS(5313),
    [anon_sym_COLON] = ACTIONS(5311),
    [anon_sym_DOLLAR] = ACTIONS(5313),
    [anon_sym_AT] = ACTIONS(5313),
    [aux_sym__hex_literal_token1] = ACTIONS(5313),
    [sym__number_literal] = ACTIONS(5311),
    [anon_sym_SQUOTE] = ACTIONS(5313),
    [anon_sym_DQUOTE] = ACTIONS(5313),
    [sym_return] = ACTIONS(5311),
    [sym_next] = ACTIONS(5311),
    [sym_break] = ACTIONS(5311),
    [sym_true] = ACTIONS(5311),
    [sym_false] = ACTIONS(5311),
    [sym_null] = ACTIONS(5311),
    [sym_inf] = ACTIONS(5311),
    [sym_nan] = ACTIONS(5311),
    [anon_sym_NA] = ACTIONS(5311),
    [anon_sym_NA_integer_] = ACTIONS(5311),
    [anon_sym_NA_real_] = ACTIONS(5311),
    [anon_sym_NA_complex_] = ACTIONS(5311),
    [anon_sym_NA_character_] = ACTIONS(5311),
    [sym_dots] = ACTIONS(5311),
    [sym_dot_dot_i] = ACTIONS(5313),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5313),
    [sym__newline] = ACTIONS(5313),
    [sym__semicolon] = ACTIONS(5313),
    [sym__raw_string_literal] = ACTIONS(5313),
    [sym__external_else] = ACTIONS(5313),
    [sym__external_open_parenthesis] = ACTIONS(5313),
    [sym__external_close_parenthesis] = ACTIONS(5313),
    [sym__external_open_brace] = ACTIONS(5313),
    [sym__external_close_brace] = ACTIONS(5313),
    [sym__external_open_bracket] = ACTIONS(5313),
    [sym__external_close_bracket] = ACTIONS(5313),
    [sym__external_open_bracket2] = ACTIONS(5313),
  },
  [2305] = {
    [sym_string] = STATE(2966),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym__string_or_identifier] = STATE(2966),
    [sym_identifier] = ACTIONS(7579),
    [anon_sym_BSLASH] = ACTIONS(5883),
    [anon_sym_function] = ACTIONS(5887),
    [anon_sym_EQ] = ACTIONS(5887),
    [anon_sym_if] = ACTIONS(5887),
    [anon_sym_for] = ACTIONS(5887),
    [anon_sym_while] = ACTIONS(5887),
    [anon_sym_repeat] = ACTIONS(5887),
    [anon_sym_QMARK] = ACTIONS(5883),
    [anon_sym_TILDE] = ACTIONS(5883),
    [anon_sym_BANG] = ACTIONS(5887),
    [anon_sym_PLUS] = ACTIONS(5883),
    [anon_sym_DASH] = ACTIONS(5887),
    [anon_sym_LT_DASH] = ACTIONS(5883),
    [anon_sym_LT_LT_DASH] = ACTIONS(5883),
    [anon_sym_COLON_EQ] = ACTIONS(5883),
    [anon_sym_DASH_GT] = ACTIONS(5887),
    [anon_sym_DASH_GT_GT] = ACTIONS(5883),
    [anon_sym_PIPE] = ACTIONS(5887),
    [anon_sym_AMP] = ACTIONS(5887),
    [anon_sym_PIPE_PIPE] = ACTIONS(5883),
    [anon_sym_AMP_AMP] = ACTIONS(5883),
    [anon_sym_LT] = ACTIONS(5887),
    [anon_sym_LT_EQ] = ACTIONS(5883),
    [anon_sym_GT] = ACTIONS(5887),
    [anon_sym_GT_EQ] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5883),
    [anon_sym_BANG_EQ] = ACTIONS(5883),
    [anon_sym_STAR] = ACTIONS(5887),
    [anon_sym_SLASH] = ACTIONS(5883),
    [anon_sym_STAR_STAR] = ACTIONS(5883),
    [anon_sym_CARET] = ACTIONS(5883),
    [aux_sym_binary_operator_token1] = ACTIONS(5883),
    [anon_sym_PIPE_GT] = ACTIONS(5883),
    [anon_sym_COLON] = ACTIONS(5887),
    [anon_sym_DOLLAR] = ACTIONS(5883),
    [anon_sym_AT] = ACTIONS(5883),
    [aux_sym__hex_literal_token1] = ACTIONS(5883),
    [sym__number_literal] = ACTIONS(5887),
    [anon_sym_SQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4672),
    [sym_return] = ACTIONS(5887),
    [sym_next] = ACTIONS(5887),
    [sym_break] = ACTIONS(5887),
    [sym_true] = ACTIONS(5887),
    [sym_false] = ACTIONS(5887),
    [sym_null] = ACTIONS(5887),
    [sym_inf] = ACTIONS(5887),
    [sym_nan] = ACTIONS(5887),
    [anon_sym_NA] = ACTIONS(5887),
    [anon_sym_NA_integer_] = ACTIONS(5887),
    [anon_sym_NA_real_] = ACTIONS(5887),
    [anon_sym_NA_complex_] = ACTIONS(5887),
    [anon_sym_NA_character_] = ACTIONS(5887),
    [sym_dots] = ACTIONS(5887),
    [sym_dot_dot_i] = ACTIONS(5883),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5883),
    [sym__newline] = ACTIONS(5883),
    [sym__raw_string_literal] = ACTIONS(4680),
    [sym__external_open_parenthesis] = ACTIONS(5883),
    [sym__external_open_brace] = ACTIONS(5883),
    [sym__external_open_bracket] = ACTIONS(5883),
    [sym__external_open_bracket2] = ACTIONS(5883),
    [sym__external_close_bracket2] = ACTIONS(5883),
  },
  [2306] = {
    [ts_builtin_sym_end] = ACTIONS(7165),
    [sym_identifier] = ACTIONS(7163),
    [anon_sym_BSLASH] = ACTIONS(7165),
    [anon_sym_function] = ACTIONS(7163),
    [anon_sym_EQ] = ACTIONS(7163),
    [anon_sym_if] = ACTIONS(7163),
    [anon_sym_for] = ACTIONS(7163),
    [anon_sym_while] = ACTIONS(7163),
    [anon_sym_repeat] = ACTIONS(7163),
    [anon_sym_QMARK] = ACTIONS(7165),
    [anon_sym_TILDE] = ACTIONS(7165),
    [anon_sym_BANG] = ACTIONS(7163),
    [anon_sym_PLUS] = ACTIONS(7165),
    [anon_sym_DASH] = ACTIONS(7163),
    [anon_sym_LT_DASH] = ACTIONS(7165),
    [anon_sym_LT_LT_DASH] = ACTIONS(7165),
    [anon_sym_COLON_EQ] = ACTIONS(7165),
    [anon_sym_DASH_GT] = ACTIONS(7163),
    [anon_sym_DASH_GT_GT] = ACTIONS(7165),
    [anon_sym_PIPE] = ACTIONS(7163),
    [anon_sym_AMP] = ACTIONS(7163),
    [anon_sym_PIPE_PIPE] = ACTIONS(7165),
    [anon_sym_AMP_AMP] = ACTIONS(7165),
    [anon_sym_LT] = ACTIONS(7163),
    [anon_sym_LT_EQ] = ACTIONS(7165),
    [anon_sym_GT] = ACTIONS(7163),
    [anon_sym_GT_EQ] = ACTIONS(7165),
    [anon_sym_EQ_EQ] = ACTIONS(7165),
    [anon_sym_BANG_EQ] = ACTIONS(7165),
    [anon_sym_STAR] = ACTIONS(7163),
    [anon_sym_SLASH] = ACTIONS(7165),
    [anon_sym_STAR_STAR] = ACTIONS(7165),
    [anon_sym_CARET] = ACTIONS(7165),
    [aux_sym_binary_operator_token1] = ACTIONS(7165),
    [anon_sym_PIPE_GT] = ACTIONS(7165),
    [anon_sym_COLON] = ACTIONS(7163),
    [anon_sym_DOLLAR] = ACTIONS(7165),
    [anon_sym_AT] = ACTIONS(7165),
    [anon_sym_COLON_COLON] = ACTIONS(7163),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7165),
    [aux_sym__hex_literal_token1] = ACTIONS(7165),
    [sym__number_literal] = ACTIONS(7163),
    [anon_sym_SQUOTE] = ACTIONS(7165),
    [anon_sym_DQUOTE] = ACTIONS(7165),
    [sym_return] = ACTIONS(7163),
    [sym_next] = ACTIONS(7163),
    [sym_break] = ACTIONS(7163),
    [sym_true] = ACTIONS(7163),
    [sym_false] = ACTIONS(7163),
    [sym_null] = ACTIONS(7163),
    [sym_inf] = ACTIONS(7163),
    [sym_nan] = ACTIONS(7163),
    [anon_sym_NA] = ACTIONS(7163),
    [anon_sym_NA_integer_] = ACTIONS(7163),
    [anon_sym_NA_real_] = ACTIONS(7163),
    [anon_sym_NA_complex_] = ACTIONS(7163),
    [anon_sym_NA_character_] = ACTIONS(7163),
    [sym_dots] = ACTIONS(7163),
    [sym_dot_dot_i] = ACTIONS(7165),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7165),
    [sym__semicolon] = ACTIONS(7165),
    [sym__raw_string_literal] = ACTIONS(7165),
    [sym__external_else] = ACTIONS(7165),
    [sym__external_open_parenthesis] = ACTIONS(7165),
    [sym__external_open_brace] = ACTIONS(7165),
    [sym__external_close_brace] = ACTIONS(7165),
    [sym__external_open_bracket] = ACTIONS(7165),
    [sym__external_open_bracket2] = ACTIONS(7165),
  },
  [2307] = {
    [ts_builtin_sym_end] = ACTIONS(7153),
    [sym_identifier] = ACTIONS(7151),
    [anon_sym_BSLASH] = ACTIONS(7153),
    [anon_sym_function] = ACTIONS(7151),
    [anon_sym_EQ] = ACTIONS(7151),
    [anon_sym_if] = ACTIONS(7151),
    [anon_sym_for] = ACTIONS(7151),
    [anon_sym_while] = ACTIONS(7151),
    [anon_sym_repeat] = ACTIONS(7151),
    [anon_sym_QMARK] = ACTIONS(7153),
    [anon_sym_TILDE] = ACTIONS(7153),
    [anon_sym_BANG] = ACTIONS(7151),
    [anon_sym_PLUS] = ACTIONS(7153),
    [anon_sym_DASH] = ACTIONS(7151),
    [anon_sym_LT_DASH] = ACTIONS(7153),
    [anon_sym_LT_LT_DASH] = ACTIONS(7153),
    [anon_sym_COLON_EQ] = ACTIONS(7153),
    [anon_sym_DASH_GT] = ACTIONS(7151),
    [anon_sym_DASH_GT_GT] = ACTIONS(7153),
    [anon_sym_PIPE] = ACTIONS(7151),
    [anon_sym_AMP] = ACTIONS(7151),
    [anon_sym_PIPE_PIPE] = ACTIONS(7153),
    [anon_sym_AMP_AMP] = ACTIONS(7153),
    [anon_sym_LT] = ACTIONS(7151),
    [anon_sym_LT_EQ] = ACTIONS(7153),
    [anon_sym_GT] = ACTIONS(7151),
    [anon_sym_GT_EQ] = ACTIONS(7153),
    [anon_sym_EQ_EQ] = ACTIONS(7153),
    [anon_sym_BANG_EQ] = ACTIONS(7153),
    [anon_sym_STAR] = ACTIONS(7151),
    [anon_sym_SLASH] = ACTIONS(7153),
    [anon_sym_STAR_STAR] = ACTIONS(7153),
    [anon_sym_CARET] = ACTIONS(7153),
    [aux_sym_binary_operator_token1] = ACTIONS(7153),
    [anon_sym_PIPE_GT] = ACTIONS(7153),
    [anon_sym_COLON] = ACTIONS(7151),
    [anon_sym_DOLLAR] = ACTIONS(7153),
    [anon_sym_AT] = ACTIONS(7153),
    [anon_sym_COLON_COLON] = ACTIONS(7151),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7153),
    [aux_sym__hex_literal_token1] = ACTIONS(7153),
    [sym__number_literal] = ACTIONS(7151),
    [anon_sym_SQUOTE] = ACTIONS(7153),
    [anon_sym_DQUOTE] = ACTIONS(7153),
    [sym_return] = ACTIONS(7151),
    [sym_next] = ACTIONS(7151),
    [sym_break] = ACTIONS(7151),
    [sym_true] = ACTIONS(7151),
    [sym_false] = ACTIONS(7151),
    [sym_null] = ACTIONS(7151),
    [sym_inf] = ACTIONS(7151),
    [sym_nan] = ACTIONS(7151),
    [anon_sym_NA] = ACTIONS(7151),
    [anon_sym_NA_integer_] = ACTIONS(7151),
    [anon_sym_NA_real_] = ACTIONS(7151),
    [anon_sym_NA_complex_] = ACTIONS(7151),
    [anon_sym_NA_character_] = ACTIONS(7151),
    [sym_dots] = ACTIONS(7151),
    [sym_dot_dot_i] = ACTIONS(7153),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7153),
    [sym__semicolon] = ACTIONS(7153),
    [sym__raw_string_literal] = ACTIONS(7153),
    [sym__external_else] = ACTIONS(7153),
    [sym__external_open_parenthesis] = ACTIONS(7153),
    [sym__external_open_brace] = ACTIONS(7153),
    [sym__external_close_brace] = ACTIONS(7153),
    [sym__external_open_bracket] = ACTIONS(7153),
    [sym__external_open_bracket2] = ACTIONS(7153),
  },
  [2308] = {
    [sym_identifier] = ACTIONS(7563),
    [anon_sym_BSLASH] = ACTIONS(7561),
    [anon_sym_function] = ACTIONS(7563),
    [anon_sym_EQ] = ACTIONS(7563),
    [anon_sym_if] = ACTIONS(7563),
    [anon_sym_for] = ACTIONS(7563),
    [anon_sym_while] = ACTIONS(7563),
    [anon_sym_repeat] = ACTIONS(7563),
    [anon_sym_QMARK] = ACTIONS(7561),
    [anon_sym_TILDE] = ACTIONS(7561),
    [anon_sym_BANG] = ACTIONS(7563),
    [anon_sym_PLUS] = ACTIONS(7561),
    [anon_sym_DASH] = ACTIONS(7563),
    [anon_sym_LT_DASH] = ACTIONS(7561),
    [anon_sym_LT_LT_DASH] = ACTIONS(7561),
    [anon_sym_COLON_EQ] = ACTIONS(7561),
    [anon_sym_DASH_GT] = ACTIONS(7563),
    [anon_sym_DASH_GT_GT] = ACTIONS(7561),
    [anon_sym_PIPE] = ACTIONS(7563),
    [anon_sym_AMP] = ACTIONS(7563),
    [anon_sym_PIPE_PIPE] = ACTIONS(7561),
    [anon_sym_AMP_AMP] = ACTIONS(7561),
    [anon_sym_LT] = ACTIONS(7563),
    [anon_sym_LT_EQ] = ACTIONS(7561),
    [anon_sym_GT] = ACTIONS(7563),
    [anon_sym_GT_EQ] = ACTIONS(7561),
    [anon_sym_EQ_EQ] = ACTIONS(7561),
    [anon_sym_BANG_EQ] = ACTIONS(7561),
    [anon_sym_STAR] = ACTIONS(7563),
    [anon_sym_SLASH] = ACTIONS(7561),
    [anon_sym_STAR_STAR] = ACTIONS(7561),
    [anon_sym_CARET] = ACTIONS(7561),
    [aux_sym_binary_operator_token1] = ACTIONS(7561),
    [anon_sym_PIPE_GT] = ACTIONS(7561),
    [anon_sym_COLON] = ACTIONS(7563),
    [anon_sym_DOLLAR] = ACTIONS(7561),
    [anon_sym_AT] = ACTIONS(7561),
    [aux_sym__hex_literal_token1] = ACTIONS(7561),
    [sym__number_literal] = ACTIONS(7563),
    [anon_sym_SQUOTE] = ACTIONS(7561),
    [anon_sym_DQUOTE] = ACTIONS(7561),
    [sym_return] = ACTIONS(7563),
    [sym_next] = ACTIONS(7563),
    [sym_break] = ACTIONS(7563),
    [sym_true] = ACTIONS(7563),
    [sym_false] = ACTIONS(7563),
    [sym_null] = ACTIONS(7563),
    [sym_inf] = ACTIONS(7563),
    [sym_nan] = ACTIONS(7563),
    [anon_sym_NA] = ACTIONS(7563),
    [anon_sym_NA_integer_] = ACTIONS(7563),
    [anon_sym_NA_real_] = ACTIONS(7563),
    [anon_sym_NA_complex_] = ACTIONS(7563),
    [anon_sym_NA_character_] = ACTIONS(7563),
    [sym_dots] = ACTIONS(7563),
    [sym_dot_dot_i] = ACTIONS(7561),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7561),
    [sym__newline] = ACTIONS(7561),
    [sym__semicolon] = ACTIONS(7561),
    [sym__raw_string_literal] = ACTIONS(7561),
    [sym__external_else] = ACTIONS(7561),
    [sym__external_open_parenthesis] = ACTIONS(7561),
    [sym__external_close_parenthesis] = ACTIONS(7561),
    [sym__external_open_brace] = ACTIONS(7561),
    [sym__external_close_brace] = ACTIONS(7561),
    [sym__external_open_bracket] = ACTIONS(7561),
    [sym__external_open_bracket2] = ACTIONS(7561),
    [sym__external_close_bracket2] = ACTIONS(7561),
  },
  [2309] = {
    [ts_builtin_sym_end] = ACTIONS(7117),
    [sym_identifier] = ACTIONS(7115),
    [anon_sym_BSLASH] = ACTIONS(7117),
    [anon_sym_function] = ACTIONS(7115),
    [anon_sym_EQ] = ACTIONS(7115),
    [anon_sym_if] = ACTIONS(7115),
    [anon_sym_for] = ACTIONS(7115),
    [anon_sym_while] = ACTIONS(7115),
    [anon_sym_repeat] = ACTIONS(7115),
    [anon_sym_QMARK] = ACTIONS(7117),
    [anon_sym_TILDE] = ACTIONS(7117),
    [anon_sym_BANG] = ACTIONS(7115),
    [anon_sym_PLUS] = ACTIONS(7117),
    [anon_sym_DASH] = ACTIONS(7115),
    [anon_sym_LT_DASH] = ACTIONS(7117),
    [anon_sym_LT_LT_DASH] = ACTIONS(7117),
    [anon_sym_COLON_EQ] = ACTIONS(7117),
    [anon_sym_DASH_GT] = ACTIONS(7115),
    [anon_sym_DASH_GT_GT] = ACTIONS(7117),
    [anon_sym_PIPE] = ACTIONS(7115),
    [anon_sym_AMP] = ACTIONS(7115),
    [anon_sym_PIPE_PIPE] = ACTIONS(7117),
    [anon_sym_AMP_AMP] = ACTIONS(7117),
    [anon_sym_LT] = ACTIONS(7115),
    [anon_sym_LT_EQ] = ACTIONS(7117),
    [anon_sym_GT] = ACTIONS(7115),
    [anon_sym_GT_EQ] = ACTIONS(7117),
    [anon_sym_EQ_EQ] = ACTIONS(7117),
    [anon_sym_BANG_EQ] = ACTIONS(7117),
    [anon_sym_STAR] = ACTIONS(7115),
    [anon_sym_SLASH] = ACTIONS(7117),
    [anon_sym_STAR_STAR] = ACTIONS(7117),
    [anon_sym_CARET] = ACTIONS(7117),
    [aux_sym_binary_operator_token1] = ACTIONS(7117),
    [anon_sym_PIPE_GT] = ACTIONS(7117),
    [anon_sym_COLON] = ACTIONS(7115),
    [anon_sym_DOLLAR] = ACTIONS(7117),
    [anon_sym_AT] = ACTIONS(7117),
    [anon_sym_COLON_COLON] = ACTIONS(7115),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7117),
    [aux_sym__hex_literal_token1] = ACTIONS(7117),
    [sym__number_literal] = ACTIONS(7115),
    [anon_sym_SQUOTE] = ACTIONS(7117),
    [anon_sym_DQUOTE] = ACTIONS(7117),
    [sym_return] = ACTIONS(7115),
    [sym_next] = ACTIONS(7115),
    [sym_break] = ACTIONS(7115),
    [sym_true] = ACTIONS(7115),
    [sym_false] = ACTIONS(7115),
    [sym_null] = ACTIONS(7115),
    [sym_inf] = ACTIONS(7115),
    [sym_nan] = ACTIONS(7115),
    [anon_sym_NA] = ACTIONS(7115),
    [anon_sym_NA_integer_] = ACTIONS(7115),
    [anon_sym_NA_real_] = ACTIONS(7115),
    [anon_sym_NA_complex_] = ACTIONS(7115),
    [anon_sym_NA_character_] = ACTIONS(7115),
    [sym_dots] = ACTIONS(7115),
    [sym_dot_dot_i] = ACTIONS(7117),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7117),
    [sym__semicolon] = ACTIONS(7117),
    [sym__raw_string_literal] = ACTIONS(7117),
    [sym__external_else] = ACTIONS(7117),
    [sym__external_open_parenthesis] = ACTIONS(7117),
    [sym__external_open_brace] = ACTIONS(7117),
    [sym__external_close_brace] = ACTIONS(7117),
    [sym__external_open_bracket] = ACTIONS(7117),
    [sym__external_open_bracket2] = ACTIONS(7117),
  },
  [2310] = {
    [ts_builtin_sym_end] = ACTIONS(7117),
    [sym_identifier] = ACTIONS(7115),
    [anon_sym_BSLASH] = ACTIONS(7117),
    [anon_sym_function] = ACTIONS(7115),
    [anon_sym_EQ] = ACTIONS(7115),
    [anon_sym_if] = ACTIONS(7115),
    [anon_sym_for] = ACTIONS(7115),
    [anon_sym_while] = ACTIONS(7115),
    [anon_sym_repeat] = ACTIONS(7115),
    [anon_sym_QMARK] = ACTIONS(7117),
    [anon_sym_TILDE] = ACTIONS(7117),
    [anon_sym_BANG] = ACTIONS(7115),
    [anon_sym_PLUS] = ACTIONS(7117),
    [anon_sym_DASH] = ACTIONS(7115),
    [anon_sym_LT_DASH] = ACTIONS(7117),
    [anon_sym_LT_LT_DASH] = ACTIONS(7117),
    [anon_sym_COLON_EQ] = ACTIONS(7117),
    [anon_sym_DASH_GT] = ACTIONS(7115),
    [anon_sym_DASH_GT_GT] = ACTIONS(7117),
    [anon_sym_PIPE] = ACTIONS(7115),
    [anon_sym_AMP] = ACTIONS(7115),
    [anon_sym_PIPE_PIPE] = ACTIONS(7117),
    [anon_sym_AMP_AMP] = ACTIONS(7117),
    [anon_sym_LT] = ACTIONS(7115),
    [anon_sym_LT_EQ] = ACTIONS(7117),
    [anon_sym_GT] = ACTIONS(7115),
    [anon_sym_GT_EQ] = ACTIONS(7117),
    [anon_sym_EQ_EQ] = ACTIONS(7117),
    [anon_sym_BANG_EQ] = ACTIONS(7117),
    [anon_sym_STAR] = ACTIONS(7115),
    [anon_sym_SLASH] = ACTIONS(7117),
    [anon_sym_STAR_STAR] = ACTIONS(7117),
    [anon_sym_CARET] = ACTIONS(7117),
    [aux_sym_binary_operator_token1] = ACTIONS(7117),
    [anon_sym_PIPE_GT] = ACTIONS(7117),
    [anon_sym_COLON] = ACTIONS(7115),
    [anon_sym_DOLLAR] = ACTIONS(7117),
    [anon_sym_AT] = ACTIONS(7117),
    [anon_sym_COLON_COLON] = ACTIONS(7115),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7117),
    [aux_sym__hex_literal_token1] = ACTIONS(7117),
    [sym__number_literal] = ACTIONS(7115),
    [anon_sym_SQUOTE] = ACTIONS(7117),
    [anon_sym_DQUOTE] = ACTIONS(7117),
    [sym_return] = ACTIONS(7115),
    [sym_next] = ACTIONS(7115),
    [sym_break] = ACTIONS(7115),
    [sym_true] = ACTIONS(7115),
    [sym_false] = ACTIONS(7115),
    [sym_null] = ACTIONS(7115),
    [sym_inf] = ACTIONS(7115),
    [sym_nan] = ACTIONS(7115),
    [anon_sym_NA] = ACTIONS(7115),
    [anon_sym_NA_integer_] = ACTIONS(7115),
    [anon_sym_NA_real_] = ACTIONS(7115),
    [anon_sym_NA_complex_] = ACTIONS(7115),
    [anon_sym_NA_character_] = ACTIONS(7115),
    [sym_dots] = ACTIONS(7115),
    [sym_dot_dot_i] = ACTIONS(7117),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7117),
    [sym__semicolon] = ACTIONS(7117),
    [sym__raw_string_literal] = ACTIONS(7117),
    [sym__external_else] = ACTIONS(7117),
    [sym__external_open_parenthesis] = ACTIONS(7117),
    [sym__external_open_brace] = ACTIONS(7117),
    [sym__external_close_brace] = ACTIONS(7117),
    [sym__external_open_bracket] = ACTIONS(7117),
    [sym__external_open_bracket2] = ACTIONS(7117),
  },
  [2311] = {
    [ts_builtin_sym_end] = ACTIONS(7123),
    [sym_identifier] = ACTIONS(7121),
    [anon_sym_BSLASH] = ACTIONS(7123),
    [anon_sym_function] = ACTIONS(7121),
    [anon_sym_EQ] = ACTIONS(7121),
    [anon_sym_if] = ACTIONS(7121),
    [anon_sym_for] = ACTIONS(7121),
    [anon_sym_while] = ACTIONS(7121),
    [anon_sym_repeat] = ACTIONS(7121),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_TILDE] = ACTIONS(7123),
    [anon_sym_BANG] = ACTIONS(7121),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_DASH] = ACTIONS(7121),
    [anon_sym_LT_DASH] = ACTIONS(7123),
    [anon_sym_LT_LT_DASH] = ACTIONS(7123),
    [anon_sym_COLON_EQ] = ACTIONS(7123),
    [anon_sym_DASH_GT] = ACTIONS(7121),
    [anon_sym_DASH_GT_GT] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_LT_EQ] = ACTIONS(7123),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
    [aux_sym_binary_operator_token1] = ACTIONS(7123),
    [anon_sym_PIPE_GT] = ACTIONS(7123),
    [anon_sym_COLON] = ACTIONS(7121),
    [anon_sym_DOLLAR] = ACTIONS(7123),
    [anon_sym_AT] = ACTIONS(7123),
    [anon_sym_L] = ACTIONS(7581),
    [anon_sym_i] = ACTIONS(7583),
    [aux_sym__hex_literal_token1] = ACTIONS(7123),
    [sym__number_literal] = ACTIONS(7121),
    [anon_sym_SQUOTE] = ACTIONS(7123),
    [anon_sym_DQUOTE] = ACTIONS(7123),
    [sym_return] = ACTIONS(7121),
    [sym_next] = ACTIONS(7121),
    [sym_break] = ACTIONS(7121),
    [sym_true] = ACTIONS(7121),
    [sym_false] = ACTIONS(7121),
    [sym_null] = ACTIONS(7121),
    [sym_inf] = ACTIONS(7121),
    [sym_nan] = ACTIONS(7121),
    [anon_sym_NA] = ACTIONS(7121),
    [anon_sym_NA_integer_] = ACTIONS(7121),
    [anon_sym_NA_real_] = ACTIONS(7121),
    [anon_sym_NA_complex_] = ACTIONS(7121),
    [anon_sym_NA_character_] = ACTIONS(7121),
    [sym_dots] = ACTIONS(7121),
    [sym_dot_dot_i] = ACTIONS(7123),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7123),
    [sym__semicolon] = ACTIONS(7123),
    [sym__raw_string_literal] = ACTIONS(7123),
    [sym__external_else] = ACTIONS(7123),
    [sym__external_open_parenthesis] = ACTIONS(7123),
    [sym__external_open_brace] = ACTIONS(7123),
    [sym__external_close_brace] = ACTIONS(7123),
    [sym__external_open_bracket] = ACTIONS(7123),
    [sym__external_open_bracket2] = ACTIONS(7123),
  },
  [2312] = {
    [ts_builtin_sym_end] = ACTIONS(7131),
    [sym_identifier] = ACTIONS(7129),
    [anon_sym_BSLASH] = ACTIONS(7131),
    [anon_sym_function] = ACTIONS(7129),
    [anon_sym_EQ] = ACTIONS(7129),
    [anon_sym_if] = ACTIONS(7129),
    [anon_sym_for] = ACTIONS(7129),
    [anon_sym_while] = ACTIONS(7129),
    [anon_sym_repeat] = ACTIONS(7129),
    [anon_sym_QMARK] = ACTIONS(7131),
    [anon_sym_TILDE] = ACTIONS(7131),
    [anon_sym_BANG] = ACTIONS(7129),
    [anon_sym_PLUS] = ACTIONS(7131),
    [anon_sym_DASH] = ACTIONS(7129),
    [anon_sym_LT_DASH] = ACTIONS(7131),
    [anon_sym_LT_LT_DASH] = ACTIONS(7131),
    [anon_sym_COLON_EQ] = ACTIONS(7131),
    [anon_sym_DASH_GT] = ACTIONS(7129),
    [anon_sym_DASH_GT_GT] = ACTIONS(7131),
    [anon_sym_PIPE] = ACTIONS(7129),
    [anon_sym_AMP] = ACTIONS(7129),
    [anon_sym_PIPE_PIPE] = ACTIONS(7131),
    [anon_sym_AMP_AMP] = ACTIONS(7131),
    [anon_sym_LT] = ACTIONS(7129),
    [anon_sym_LT_EQ] = ACTIONS(7131),
    [anon_sym_GT] = ACTIONS(7129),
    [anon_sym_GT_EQ] = ACTIONS(7131),
    [anon_sym_EQ_EQ] = ACTIONS(7131),
    [anon_sym_BANG_EQ] = ACTIONS(7131),
    [anon_sym_STAR] = ACTIONS(7129),
    [anon_sym_SLASH] = ACTIONS(7131),
    [anon_sym_STAR_STAR] = ACTIONS(7131),
    [anon_sym_CARET] = ACTIONS(7131),
    [aux_sym_binary_operator_token1] = ACTIONS(7131),
    [anon_sym_PIPE_GT] = ACTIONS(7131),
    [anon_sym_COLON] = ACTIONS(7129),
    [anon_sym_DOLLAR] = ACTIONS(7131),
    [anon_sym_AT] = ACTIONS(7131),
    [anon_sym_COLON_COLON] = ACTIONS(7133),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7135),
    [aux_sym__hex_literal_token1] = ACTIONS(7131),
    [sym__number_literal] = ACTIONS(7129),
    [anon_sym_SQUOTE] = ACTIONS(7131),
    [anon_sym_DQUOTE] = ACTIONS(7131),
    [sym_return] = ACTIONS(7129),
    [sym_next] = ACTIONS(7129),
    [sym_break] = ACTIONS(7129),
    [sym_true] = ACTIONS(7129),
    [sym_false] = ACTIONS(7129),
    [sym_null] = ACTIONS(7129),
    [sym_inf] = ACTIONS(7129),
    [sym_nan] = ACTIONS(7129),
    [anon_sym_NA] = ACTIONS(7129),
    [anon_sym_NA_integer_] = ACTIONS(7129),
    [anon_sym_NA_real_] = ACTIONS(7129),
    [anon_sym_NA_complex_] = ACTIONS(7129),
    [anon_sym_NA_character_] = ACTIONS(7129),
    [sym_dots] = ACTIONS(7129),
    [sym_dot_dot_i] = ACTIONS(7131),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7131),
    [sym__semicolon] = ACTIONS(7131),
    [sym__raw_string_literal] = ACTIONS(7131),
    [sym__external_else] = ACTIONS(7131),
    [sym__external_open_parenthesis] = ACTIONS(7131),
    [sym__external_open_brace] = ACTIONS(7131),
    [sym__external_close_brace] = ACTIONS(7131),
    [sym__external_open_bracket] = ACTIONS(7131),
    [sym__external_open_bracket2] = ACTIONS(7131),
  },
  [2313] = {
    [ts_builtin_sym_end] = ACTIONS(7139),
    [sym_identifier] = ACTIONS(7137),
    [anon_sym_BSLASH] = ACTIONS(7139),
    [anon_sym_function] = ACTIONS(7137),
    [anon_sym_EQ] = ACTIONS(7137),
    [anon_sym_if] = ACTIONS(7137),
    [anon_sym_for] = ACTIONS(7137),
    [anon_sym_while] = ACTIONS(7137),
    [anon_sym_repeat] = ACTIONS(7137),
    [anon_sym_QMARK] = ACTIONS(7139),
    [anon_sym_TILDE] = ACTIONS(7139),
    [anon_sym_BANG] = ACTIONS(7137),
    [anon_sym_PLUS] = ACTIONS(7139),
    [anon_sym_DASH] = ACTIONS(7137),
    [anon_sym_LT_DASH] = ACTIONS(7139),
    [anon_sym_LT_LT_DASH] = ACTIONS(7139),
    [anon_sym_COLON_EQ] = ACTIONS(7139),
    [anon_sym_DASH_GT] = ACTIONS(7137),
    [anon_sym_DASH_GT_GT] = ACTIONS(7139),
    [anon_sym_PIPE] = ACTIONS(7137),
    [anon_sym_AMP] = ACTIONS(7137),
    [anon_sym_PIPE_PIPE] = ACTIONS(7139),
    [anon_sym_AMP_AMP] = ACTIONS(7139),
    [anon_sym_LT] = ACTIONS(7137),
    [anon_sym_LT_EQ] = ACTIONS(7139),
    [anon_sym_GT] = ACTIONS(7137),
    [anon_sym_GT_EQ] = ACTIONS(7139),
    [anon_sym_EQ_EQ] = ACTIONS(7139),
    [anon_sym_BANG_EQ] = ACTIONS(7139),
    [anon_sym_STAR] = ACTIONS(7137),
    [anon_sym_SLASH] = ACTIONS(7139),
    [anon_sym_STAR_STAR] = ACTIONS(7139),
    [anon_sym_CARET] = ACTIONS(7139),
    [aux_sym_binary_operator_token1] = ACTIONS(7139),
    [anon_sym_PIPE_GT] = ACTIONS(7139),
    [anon_sym_COLON] = ACTIONS(7137),
    [anon_sym_DOLLAR] = ACTIONS(7139),
    [anon_sym_AT] = ACTIONS(7139),
    [anon_sym_COLON_COLON] = ACTIONS(7137),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7139),
    [aux_sym__hex_literal_token1] = ACTIONS(7139),
    [sym__number_literal] = ACTIONS(7137),
    [anon_sym_SQUOTE] = ACTIONS(7139),
    [anon_sym_DQUOTE] = ACTIONS(7139),
    [sym_return] = ACTIONS(7137),
    [sym_next] = ACTIONS(7137),
    [sym_break] = ACTIONS(7137),
    [sym_true] = ACTIONS(7137),
    [sym_false] = ACTIONS(7137),
    [sym_null] = ACTIONS(7137),
    [sym_inf] = ACTIONS(7137),
    [sym_nan] = ACTIONS(7137),
    [anon_sym_NA] = ACTIONS(7137),
    [anon_sym_NA_integer_] = ACTIONS(7137),
    [anon_sym_NA_real_] = ACTIONS(7137),
    [anon_sym_NA_complex_] = ACTIONS(7137),
    [anon_sym_NA_character_] = ACTIONS(7137),
    [sym_dots] = ACTIONS(7137),
    [sym_dot_dot_i] = ACTIONS(7139),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7139),
    [sym__semicolon] = ACTIONS(7139),
    [sym__raw_string_literal] = ACTIONS(7139),
    [sym__external_else] = ACTIONS(7139),
    [sym__external_open_parenthesis] = ACTIONS(7139),
    [sym__external_open_brace] = ACTIONS(7139),
    [sym__external_close_brace] = ACTIONS(7139),
    [sym__external_open_bracket] = ACTIONS(7139),
    [sym__external_open_bracket2] = ACTIONS(7139),
  },
  [2314] = {
    [sym_identifier] = ACTIONS(7556),
    [anon_sym_BSLASH] = ACTIONS(7554),
    [anon_sym_function] = ACTIONS(7556),
    [anon_sym_EQ] = ACTIONS(7556),
    [anon_sym_if] = ACTIONS(7556),
    [anon_sym_for] = ACTIONS(7556),
    [anon_sym_while] = ACTIONS(7556),
    [anon_sym_repeat] = ACTIONS(7556),
    [anon_sym_QMARK] = ACTIONS(7554),
    [anon_sym_TILDE] = ACTIONS(7554),
    [anon_sym_BANG] = ACTIONS(7556),
    [anon_sym_PLUS] = ACTIONS(7554),
    [anon_sym_DASH] = ACTIONS(7556),
    [anon_sym_LT_DASH] = ACTIONS(7554),
    [anon_sym_LT_LT_DASH] = ACTIONS(7554),
    [anon_sym_COLON_EQ] = ACTIONS(7554),
    [anon_sym_DASH_GT] = ACTIONS(7556),
    [anon_sym_DASH_GT_GT] = ACTIONS(7554),
    [anon_sym_PIPE] = ACTIONS(7556),
    [anon_sym_AMP] = ACTIONS(7556),
    [anon_sym_PIPE_PIPE] = ACTIONS(7554),
    [anon_sym_AMP_AMP] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(7556),
    [anon_sym_LT_EQ] = ACTIONS(7554),
    [anon_sym_GT] = ACTIONS(7556),
    [anon_sym_GT_EQ] = ACTIONS(7554),
    [anon_sym_EQ_EQ] = ACTIONS(7554),
    [anon_sym_BANG_EQ] = ACTIONS(7554),
    [anon_sym_STAR] = ACTIONS(7556),
    [anon_sym_SLASH] = ACTIONS(7554),
    [anon_sym_STAR_STAR] = ACTIONS(7554),
    [anon_sym_CARET] = ACTIONS(7554),
    [aux_sym_binary_operator_token1] = ACTIONS(7554),
    [anon_sym_PIPE_GT] = ACTIONS(7554),
    [anon_sym_COLON] = ACTIONS(7556),
    [anon_sym_DOLLAR] = ACTIONS(7554),
    [anon_sym_AT] = ACTIONS(7554),
    [aux_sym__hex_literal_token1] = ACTIONS(7554),
    [sym__number_literal] = ACTIONS(7556),
    [anon_sym_SQUOTE] = ACTIONS(7554),
    [anon_sym_DQUOTE] = ACTIONS(7554),
    [sym_return] = ACTIONS(7556),
    [sym_next] = ACTIONS(7556),
    [sym_break] = ACTIONS(7556),
    [sym_true] = ACTIONS(7556),
    [sym_false] = ACTIONS(7556),
    [sym_null] = ACTIONS(7556),
    [sym_inf] = ACTIONS(7556),
    [sym_nan] = ACTIONS(7556),
    [anon_sym_NA] = ACTIONS(7556),
    [anon_sym_NA_integer_] = ACTIONS(7556),
    [anon_sym_NA_real_] = ACTIONS(7556),
    [anon_sym_NA_complex_] = ACTIONS(7556),
    [anon_sym_NA_character_] = ACTIONS(7556),
    [sym_dots] = ACTIONS(7556),
    [sym_dot_dot_i] = ACTIONS(7554),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7554),
    [sym__newline] = ACTIONS(7554),
    [sym__semicolon] = ACTIONS(7554),
    [sym__raw_string_literal] = ACTIONS(7554),
    [sym__external_else] = ACTIONS(7554),
    [sym__external_open_parenthesis] = ACTIONS(7554),
    [sym__external_close_parenthesis] = ACTIONS(7554),
    [sym__external_open_brace] = ACTIONS(7554),
    [sym__external_close_brace] = ACTIONS(7554),
    [sym__external_open_bracket] = ACTIONS(7554),
    [sym__external_open_bracket2] = ACTIONS(7554),
    [sym__external_close_bracket2] = ACTIONS(7554),
  },
  [2315] = {
    [sym_identifier] = ACTIONS(7552),
    [anon_sym_BSLASH] = ACTIONS(7550),
    [anon_sym_function] = ACTIONS(7552),
    [anon_sym_EQ] = ACTIONS(7552),
    [anon_sym_if] = ACTIONS(7552),
    [anon_sym_for] = ACTIONS(7552),
    [anon_sym_while] = ACTIONS(7552),
    [anon_sym_repeat] = ACTIONS(7552),
    [anon_sym_QMARK] = ACTIONS(7550),
    [anon_sym_TILDE] = ACTIONS(7550),
    [anon_sym_BANG] = ACTIONS(7552),
    [anon_sym_PLUS] = ACTIONS(7550),
    [anon_sym_DASH] = ACTIONS(7552),
    [anon_sym_LT_DASH] = ACTIONS(7550),
    [anon_sym_LT_LT_DASH] = ACTIONS(7550),
    [anon_sym_COLON_EQ] = ACTIONS(7550),
    [anon_sym_DASH_GT] = ACTIONS(7552),
    [anon_sym_DASH_GT_GT] = ACTIONS(7550),
    [anon_sym_PIPE] = ACTIONS(7552),
    [anon_sym_AMP] = ACTIONS(7552),
    [anon_sym_PIPE_PIPE] = ACTIONS(7550),
    [anon_sym_AMP_AMP] = ACTIONS(7550),
    [anon_sym_LT] = ACTIONS(7552),
    [anon_sym_LT_EQ] = ACTIONS(7550),
    [anon_sym_GT] = ACTIONS(7552),
    [anon_sym_GT_EQ] = ACTIONS(7550),
    [anon_sym_EQ_EQ] = ACTIONS(7550),
    [anon_sym_BANG_EQ] = ACTIONS(7550),
    [anon_sym_STAR] = ACTIONS(7552),
    [anon_sym_SLASH] = ACTIONS(7550),
    [anon_sym_STAR_STAR] = ACTIONS(7550),
    [anon_sym_CARET] = ACTIONS(7550),
    [aux_sym_binary_operator_token1] = ACTIONS(7550),
    [anon_sym_PIPE_GT] = ACTIONS(7550),
    [anon_sym_COLON] = ACTIONS(7552),
    [anon_sym_DOLLAR] = ACTIONS(7550),
    [anon_sym_AT] = ACTIONS(7550),
    [aux_sym__hex_literal_token1] = ACTIONS(7550),
    [sym__number_literal] = ACTIONS(7552),
    [anon_sym_SQUOTE] = ACTIONS(7550),
    [anon_sym_DQUOTE] = ACTIONS(7550),
    [sym_return] = ACTIONS(7552),
    [sym_next] = ACTIONS(7552),
    [sym_break] = ACTIONS(7552),
    [sym_true] = ACTIONS(7552),
    [sym_false] = ACTIONS(7552),
    [sym_null] = ACTIONS(7552),
    [sym_inf] = ACTIONS(7552),
    [sym_nan] = ACTIONS(7552),
    [anon_sym_NA] = ACTIONS(7552),
    [anon_sym_NA_integer_] = ACTIONS(7552),
    [anon_sym_NA_real_] = ACTIONS(7552),
    [anon_sym_NA_complex_] = ACTIONS(7552),
    [anon_sym_NA_character_] = ACTIONS(7552),
    [sym_dots] = ACTIONS(7552),
    [sym_dot_dot_i] = ACTIONS(7550),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7550),
    [sym__newline] = ACTIONS(7550),
    [sym__semicolon] = ACTIONS(7550),
    [sym__raw_string_literal] = ACTIONS(7550),
    [sym__external_else] = ACTIONS(7550),
    [sym__external_open_parenthesis] = ACTIONS(7550),
    [sym__external_close_parenthesis] = ACTIONS(7550),
    [sym__external_open_brace] = ACTIONS(7550),
    [sym__external_close_brace] = ACTIONS(7550),
    [sym__external_open_bracket] = ACTIONS(7550),
    [sym__external_close_bracket] = ACTIONS(7550),
    [sym__external_open_bracket2] = ACTIONS(7550),
  },
  [2316] = {
    [sym_identifier] = ACTIONS(7544),
    [anon_sym_BSLASH] = ACTIONS(7542),
    [anon_sym_function] = ACTIONS(7544),
    [anon_sym_EQ] = ACTIONS(7544),
    [anon_sym_if] = ACTIONS(7544),
    [anon_sym_for] = ACTIONS(7544),
    [anon_sym_while] = ACTIONS(7544),
    [anon_sym_repeat] = ACTIONS(7544),
    [anon_sym_QMARK] = ACTIONS(7542),
    [anon_sym_TILDE] = ACTIONS(7542),
    [anon_sym_BANG] = ACTIONS(7544),
    [anon_sym_PLUS] = ACTIONS(7542),
    [anon_sym_DASH] = ACTIONS(7544),
    [anon_sym_LT_DASH] = ACTIONS(7542),
    [anon_sym_LT_LT_DASH] = ACTIONS(7542),
    [anon_sym_COLON_EQ] = ACTIONS(7542),
    [anon_sym_DASH_GT] = ACTIONS(7544),
    [anon_sym_DASH_GT_GT] = ACTIONS(7542),
    [anon_sym_PIPE] = ACTIONS(7544),
    [anon_sym_AMP] = ACTIONS(7544),
    [anon_sym_PIPE_PIPE] = ACTIONS(7542),
    [anon_sym_AMP_AMP] = ACTIONS(7542),
    [anon_sym_LT] = ACTIONS(7544),
    [anon_sym_LT_EQ] = ACTIONS(7542),
    [anon_sym_GT] = ACTIONS(7544),
    [anon_sym_GT_EQ] = ACTIONS(7542),
    [anon_sym_EQ_EQ] = ACTIONS(7542),
    [anon_sym_BANG_EQ] = ACTIONS(7542),
    [anon_sym_STAR] = ACTIONS(7544),
    [anon_sym_SLASH] = ACTIONS(7542),
    [anon_sym_STAR_STAR] = ACTIONS(7542),
    [anon_sym_CARET] = ACTIONS(7542),
    [aux_sym_binary_operator_token1] = ACTIONS(7542),
    [anon_sym_PIPE_GT] = ACTIONS(7542),
    [anon_sym_COLON] = ACTIONS(7544),
    [anon_sym_DOLLAR] = ACTIONS(7542),
    [anon_sym_AT] = ACTIONS(7542),
    [aux_sym__hex_literal_token1] = ACTIONS(7542),
    [sym__number_literal] = ACTIONS(7544),
    [anon_sym_SQUOTE] = ACTIONS(7542),
    [anon_sym_DQUOTE] = ACTIONS(7542),
    [sym_return] = ACTIONS(7544),
    [sym_next] = ACTIONS(7544),
    [sym_break] = ACTIONS(7544),
    [sym_true] = ACTIONS(7544),
    [sym_false] = ACTIONS(7544),
    [sym_null] = ACTIONS(7544),
    [sym_inf] = ACTIONS(7544),
    [sym_nan] = ACTIONS(7544),
    [anon_sym_NA] = ACTIONS(7544),
    [anon_sym_NA_integer_] = ACTIONS(7544),
    [anon_sym_NA_real_] = ACTIONS(7544),
    [anon_sym_NA_complex_] = ACTIONS(7544),
    [anon_sym_NA_character_] = ACTIONS(7544),
    [sym_dots] = ACTIONS(7544),
    [sym_dot_dot_i] = ACTIONS(7542),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7542),
    [sym__newline] = ACTIONS(7542),
    [sym__semicolon] = ACTIONS(7542),
    [sym__raw_string_literal] = ACTIONS(7542),
    [sym__external_else] = ACTIONS(7542),
    [sym__external_open_parenthesis] = ACTIONS(7542),
    [sym__external_close_parenthesis] = ACTIONS(7542),
    [sym__external_open_brace] = ACTIONS(7542),
    [sym__external_close_brace] = ACTIONS(7542),
    [sym__external_open_bracket] = ACTIONS(7542),
    [sym__external_close_bracket] = ACTIONS(7542),
    [sym__external_open_bracket2] = ACTIONS(7542),
  },
  [2317] = {
    [sym_identifier] = ACTIONS(7540),
    [anon_sym_BSLASH] = ACTIONS(7538),
    [anon_sym_function] = ACTIONS(7540),
    [anon_sym_EQ] = ACTIONS(7540),
    [anon_sym_if] = ACTIONS(7540),
    [anon_sym_for] = ACTIONS(7540),
    [anon_sym_while] = ACTIONS(7540),
    [anon_sym_repeat] = ACTIONS(7540),
    [anon_sym_QMARK] = ACTIONS(7538),
    [anon_sym_TILDE] = ACTIONS(7538),
    [anon_sym_BANG] = ACTIONS(7540),
    [anon_sym_PLUS] = ACTIONS(7538),
    [anon_sym_DASH] = ACTIONS(7540),
    [anon_sym_LT_DASH] = ACTIONS(7538),
    [anon_sym_LT_LT_DASH] = ACTIONS(7538),
    [anon_sym_COLON_EQ] = ACTIONS(7538),
    [anon_sym_DASH_GT] = ACTIONS(7540),
    [anon_sym_DASH_GT_GT] = ACTIONS(7538),
    [anon_sym_PIPE] = ACTIONS(7540),
    [anon_sym_AMP] = ACTIONS(7540),
    [anon_sym_PIPE_PIPE] = ACTIONS(7538),
    [anon_sym_AMP_AMP] = ACTIONS(7538),
    [anon_sym_LT] = ACTIONS(7540),
    [anon_sym_LT_EQ] = ACTIONS(7538),
    [anon_sym_GT] = ACTIONS(7540),
    [anon_sym_GT_EQ] = ACTIONS(7538),
    [anon_sym_EQ_EQ] = ACTIONS(7538),
    [anon_sym_BANG_EQ] = ACTIONS(7538),
    [anon_sym_STAR] = ACTIONS(7540),
    [anon_sym_SLASH] = ACTIONS(7538),
    [anon_sym_STAR_STAR] = ACTIONS(7538),
    [anon_sym_CARET] = ACTIONS(7538),
    [aux_sym_binary_operator_token1] = ACTIONS(7538),
    [anon_sym_PIPE_GT] = ACTIONS(7538),
    [anon_sym_COLON] = ACTIONS(7540),
    [anon_sym_DOLLAR] = ACTIONS(7538),
    [anon_sym_AT] = ACTIONS(7538),
    [aux_sym__hex_literal_token1] = ACTIONS(7538),
    [sym__number_literal] = ACTIONS(7540),
    [anon_sym_SQUOTE] = ACTIONS(7538),
    [anon_sym_DQUOTE] = ACTIONS(7538),
    [sym_return] = ACTIONS(7540),
    [sym_next] = ACTIONS(7540),
    [sym_break] = ACTIONS(7540),
    [sym_true] = ACTIONS(7540),
    [sym_false] = ACTIONS(7540),
    [sym_null] = ACTIONS(7540),
    [sym_inf] = ACTIONS(7540),
    [sym_nan] = ACTIONS(7540),
    [anon_sym_NA] = ACTIONS(7540),
    [anon_sym_NA_integer_] = ACTIONS(7540),
    [anon_sym_NA_real_] = ACTIONS(7540),
    [anon_sym_NA_complex_] = ACTIONS(7540),
    [anon_sym_NA_character_] = ACTIONS(7540),
    [sym_dots] = ACTIONS(7540),
    [sym_dot_dot_i] = ACTIONS(7538),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7538),
    [sym__newline] = ACTIONS(7538),
    [sym__semicolon] = ACTIONS(7538),
    [sym__raw_string_literal] = ACTIONS(7538),
    [sym__external_else] = ACTIONS(7538),
    [sym__external_open_parenthesis] = ACTIONS(7538),
    [sym__external_close_parenthesis] = ACTIONS(7538),
    [sym__external_open_brace] = ACTIONS(7538),
    [sym__external_close_brace] = ACTIONS(7538),
    [sym__external_open_bracket] = ACTIONS(7538),
    [sym__external_close_bracket] = ACTIONS(7538),
    [sym__external_open_bracket2] = ACTIONS(7538),
  },
  [2318] = {
    [sym_identifier] = ACTIONS(7532),
    [anon_sym_BSLASH] = ACTIONS(7530),
    [anon_sym_function] = ACTIONS(7532),
    [anon_sym_EQ] = ACTIONS(7532),
    [anon_sym_if] = ACTIONS(7532),
    [anon_sym_for] = ACTIONS(7532),
    [anon_sym_while] = ACTIONS(7532),
    [anon_sym_repeat] = ACTIONS(7532),
    [anon_sym_QMARK] = ACTIONS(7530),
    [anon_sym_TILDE] = ACTIONS(7530),
    [anon_sym_BANG] = ACTIONS(7532),
    [anon_sym_PLUS] = ACTIONS(7530),
    [anon_sym_DASH] = ACTIONS(7532),
    [anon_sym_LT_DASH] = ACTIONS(7530),
    [anon_sym_LT_LT_DASH] = ACTIONS(7530),
    [anon_sym_COLON_EQ] = ACTIONS(7530),
    [anon_sym_DASH_GT] = ACTIONS(7532),
    [anon_sym_DASH_GT_GT] = ACTIONS(7530),
    [anon_sym_PIPE] = ACTIONS(7532),
    [anon_sym_AMP] = ACTIONS(7532),
    [anon_sym_PIPE_PIPE] = ACTIONS(7530),
    [anon_sym_AMP_AMP] = ACTIONS(7530),
    [anon_sym_LT] = ACTIONS(7532),
    [anon_sym_LT_EQ] = ACTIONS(7530),
    [anon_sym_GT] = ACTIONS(7532),
    [anon_sym_GT_EQ] = ACTIONS(7530),
    [anon_sym_EQ_EQ] = ACTIONS(7530),
    [anon_sym_BANG_EQ] = ACTIONS(7530),
    [anon_sym_STAR] = ACTIONS(7532),
    [anon_sym_SLASH] = ACTIONS(7530),
    [anon_sym_STAR_STAR] = ACTIONS(7530),
    [anon_sym_CARET] = ACTIONS(7530),
    [aux_sym_binary_operator_token1] = ACTIONS(7530),
    [anon_sym_PIPE_GT] = ACTIONS(7530),
    [anon_sym_COLON] = ACTIONS(7532),
    [anon_sym_DOLLAR] = ACTIONS(7530),
    [anon_sym_AT] = ACTIONS(7530),
    [aux_sym__hex_literal_token1] = ACTIONS(7530),
    [sym__number_literal] = ACTIONS(7532),
    [anon_sym_SQUOTE] = ACTIONS(7530),
    [anon_sym_DQUOTE] = ACTIONS(7530),
    [sym_return] = ACTIONS(7532),
    [sym_next] = ACTIONS(7532),
    [sym_break] = ACTIONS(7532),
    [sym_true] = ACTIONS(7532),
    [sym_false] = ACTIONS(7532),
    [sym_null] = ACTIONS(7532),
    [sym_inf] = ACTIONS(7532),
    [sym_nan] = ACTIONS(7532),
    [anon_sym_NA] = ACTIONS(7532),
    [anon_sym_NA_integer_] = ACTIONS(7532),
    [anon_sym_NA_real_] = ACTIONS(7532),
    [anon_sym_NA_complex_] = ACTIONS(7532),
    [anon_sym_NA_character_] = ACTIONS(7532),
    [sym_dots] = ACTIONS(7532),
    [sym_dot_dot_i] = ACTIONS(7530),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7530),
    [sym__newline] = ACTIONS(7530),
    [sym__semicolon] = ACTIONS(7530),
    [sym__raw_string_literal] = ACTIONS(7530),
    [sym__external_else] = ACTIONS(7530),
    [sym__external_open_parenthesis] = ACTIONS(7530),
    [sym__external_close_parenthesis] = ACTIONS(7530),
    [sym__external_open_brace] = ACTIONS(7530),
    [sym__external_close_brace] = ACTIONS(7530),
    [sym__external_open_bracket] = ACTIONS(7530),
    [sym__external_close_bracket] = ACTIONS(7530),
    [sym__external_open_bracket2] = ACTIONS(7530),
  },
  [2319] = {
    [sym_identifier] = ACTIONS(7528),
    [anon_sym_BSLASH] = ACTIONS(7526),
    [anon_sym_function] = ACTIONS(7528),
    [anon_sym_EQ] = ACTIONS(7528),
    [anon_sym_if] = ACTIONS(7528),
    [anon_sym_for] = ACTIONS(7528),
    [anon_sym_while] = ACTIONS(7528),
    [anon_sym_repeat] = ACTIONS(7528),
    [anon_sym_QMARK] = ACTIONS(7526),
    [anon_sym_TILDE] = ACTIONS(7526),
    [anon_sym_BANG] = ACTIONS(7528),
    [anon_sym_PLUS] = ACTIONS(7526),
    [anon_sym_DASH] = ACTIONS(7528),
    [anon_sym_LT_DASH] = ACTIONS(7526),
    [anon_sym_LT_LT_DASH] = ACTIONS(7526),
    [anon_sym_COLON_EQ] = ACTIONS(7526),
    [anon_sym_DASH_GT] = ACTIONS(7528),
    [anon_sym_DASH_GT_GT] = ACTIONS(7526),
    [anon_sym_PIPE] = ACTIONS(7528),
    [anon_sym_AMP] = ACTIONS(7528),
    [anon_sym_PIPE_PIPE] = ACTIONS(7526),
    [anon_sym_AMP_AMP] = ACTIONS(7526),
    [anon_sym_LT] = ACTIONS(7528),
    [anon_sym_LT_EQ] = ACTIONS(7526),
    [anon_sym_GT] = ACTIONS(7528),
    [anon_sym_GT_EQ] = ACTIONS(7526),
    [anon_sym_EQ_EQ] = ACTIONS(7526),
    [anon_sym_BANG_EQ] = ACTIONS(7526),
    [anon_sym_STAR] = ACTIONS(7528),
    [anon_sym_SLASH] = ACTIONS(7526),
    [anon_sym_STAR_STAR] = ACTIONS(7526),
    [anon_sym_CARET] = ACTIONS(7526),
    [aux_sym_binary_operator_token1] = ACTIONS(7526),
    [anon_sym_PIPE_GT] = ACTIONS(7526),
    [anon_sym_COLON] = ACTIONS(7528),
    [anon_sym_DOLLAR] = ACTIONS(7526),
    [anon_sym_AT] = ACTIONS(7526),
    [aux_sym__hex_literal_token1] = ACTIONS(7526),
    [sym__number_literal] = ACTIONS(7528),
    [anon_sym_SQUOTE] = ACTIONS(7526),
    [anon_sym_DQUOTE] = ACTIONS(7526),
    [sym_return] = ACTIONS(7528),
    [sym_next] = ACTIONS(7528),
    [sym_break] = ACTIONS(7528),
    [sym_true] = ACTIONS(7528),
    [sym_false] = ACTIONS(7528),
    [sym_null] = ACTIONS(7528),
    [sym_inf] = ACTIONS(7528),
    [sym_nan] = ACTIONS(7528),
    [anon_sym_NA] = ACTIONS(7528),
    [anon_sym_NA_integer_] = ACTIONS(7528),
    [anon_sym_NA_real_] = ACTIONS(7528),
    [anon_sym_NA_complex_] = ACTIONS(7528),
    [anon_sym_NA_character_] = ACTIONS(7528),
    [sym_dots] = ACTIONS(7528),
    [sym_dot_dot_i] = ACTIONS(7526),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7526),
    [sym__newline] = ACTIONS(7526),
    [sym__semicolon] = ACTIONS(7526),
    [sym__raw_string_literal] = ACTIONS(7526),
    [sym__external_else] = ACTIONS(7526),
    [sym__external_open_parenthesis] = ACTIONS(7526),
    [sym__external_close_parenthesis] = ACTIONS(7526),
    [sym__external_open_brace] = ACTIONS(7526),
    [sym__external_close_brace] = ACTIONS(7526),
    [sym__external_open_bracket] = ACTIONS(7526),
    [sym__external_close_bracket] = ACTIONS(7526),
    [sym__external_open_bracket2] = ACTIONS(7526),
  },
  [2320] = {
    [sym_identifier] = ACTIONS(7524),
    [anon_sym_BSLASH] = ACTIONS(7522),
    [anon_sym_function] = ACTIONS(7524),
    [anon_sym_EQ] = ACTIONS(7524),
    [anon_sym_if] = ACTIONS(7524),
    [anon_sym_for] = ACTIONS(7524),
    [anon_sym_while] = ACTIONS(7524),
    [anon_sym_repeat] = ACTIONS(7524),
    [anon_sym_QMARK] = ACTIONS(7522),
    [anon_sym_TILDE] = ACTIONS(7522),
    [anon_sym_BANG] = ACTIONS(7524),
    [anon_sym_PLUS] = ACTIONS(7522),
    [anon_sym_DASH] = ACTIONS(7524),
    [anon_sym_LT_DASH] = ACTIONS(7522),
    [anon_sym_LT_LT_DASH] = ACTIONS(7522),
    [anon_sym_COLON_EQ] = ACTIONS(7522),
    [anon_sym_DASH_GT] = ACTIONS(7524),
    [anon_sym_DASH_GT_GT] = ACTIONS(7522),
    [anon_sym_PIPE] = ACTIONS(7524),
    [anon_sym_AMP] = ACTIONS(7524),
    [anon_sym_PIPE_PIPE] = ACTIONS(7522),
    [anon_sym_AMP_AMP] = ACTIONS(7522),
    [anon_sym_LT] = ACTIONS(7524),
    [anon_sym_LT_EQ] = ACTIONS(7522),
    [anon_sym_GT] = ACTIONS(7524),
    [anon_sym_GT_EQ] = ACTIONS(7522),
    [anon_sym_EQ_EQ] = ACTIONS(7522),
    [anon_sym_BANG_EQ] = ACTIONS(7522),
    [anon_sym_STAR] = ACTIONS(7524),
    [anon_sym_SLASH] = ACTIONS(7522),
    [anon_sym_STAR_STAR] = ACTIONS(7522),
    [anon_sym_CARET] = ACTIONS(7522),
    [aux_sym_binary_operator_token1] = ACTIONS(7522),
    [anon_sym_PIPE_GT] = ACTIONS(7522),
    [anon_sym_COLON] = ACTIONS(7524),
    [anon_sym_DOLLAR] = ACTIONS(7522),
    [anon_sym_AT] = ACTIONS(7522),
    [aux_sym__hex_literal_token1] = ACTIONS(7522),
    [sym__number_literal] = ACTIONS(7524),
    [anon_sym_SQUOTE] = ACTIONS(7522),
    [anon_sym_DQUOTE] = ACTIONS(7522),
    [sym_return] = ACTIONS(7524),
    [sym_next] = ACTIONS(7524),
    [sym_break] = ACTIONS(7524),
    [sym_true] = ACTIONS(7524),
    [sym_false] = ACTIONS(7524),
    [sym_null] = ACTIONS(7524),
    [sym_inf] = ACTIONS(7524),
    [sym_nan] = ACTIONS(7524),
    [anon_sym_NA] = ACTIONS(7524),
    [anon_sym_NA_integer_] = ACTIONS(7524),
    [anon_sym_NA_real_] = ACTIONS(7524),
    [anon_sym_NA_complex_] = ACTIONS(7524),
    [anon_sym_NA_character_] = ACTIONS(7524),
    [sym_dots] = ACTIONS(7524),
    [sym_dot_dot_i] = ACTIONS(7522),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7522),
    [sym__newline] = ACTIONS(7522),
    [sym__semicolon] = ACTIONS(7522),
    [sym__raw_string_literal] = ACTIONS(7522),
    [sym__external_else] = ACTIONS(7522),
    [sym__external_open_parenthesis] = ACTIONS(7522),
    [sym__external_close_parenthesis] = ACTIONS(7522),
    [sym__external_open_brace] = ACTIONS(7522),
    [sym__external_close_brace] = ACTIONS(7522),
    [sym__external_open_bracket] = ACTIONS(7522),
    [sym__external_close_bracket] = ACTIONS(7522),
    [sym__external_open_bracket2] = ACTIONS(7522),
  },
  [2321] = {
    [sym_identifier] = ACTIONS(7520),
    [anon_sym_BSLASH] = ACTIONS(7518),
    [anon_sym_function] = ACTIONS(7520),
    [anon_sym_EQ] = ACTIONS(7520),
    [anon_sym_if] = ACTIONS(7520),
    [anon_sym_for] = ACTIONS(7520),
    [anon_sym_while] = ACTIONS(7520),
    [anon_sym_repeat] = ACTIONS(7520),
    [anon_sym_QMARK] = ACTIONS(7518),
    [anon_sym_TILDE] = ACTIONS(7518),
    [anon_sym_BANG] = ACTIONS(7520),
    [anon_sym_PLUS] = ACTIONS(7518),
    [anon_sym_DASH] = ACTIONS(7520),
    [anon_sym_LT_DASH] = ACTIONS(7518),
    [anon_sym_LT_LT_DASH] = ACTIONS(7518),
    [anon_sym_COLON_EQ] = ACTIONS(7518),
    [anon_sym_DASH_GT] = ACTIONS(7520),
    [anon_sym_DASH_GT_GT] = ACTIONS(7518),
    [anon_sym_PIPE] = ACTIONS(7520),
    [anon_sym_AMP] = ACTIONS(7520),
    [anon_sym_PIPE_PIPE] = ACTIONS(7518),
    [anon_sym_AMP_AMP] = ACTIONS(7518),
    [anon_sym_LT] = ACTIONS(7520),
    [anon_sym_LT_EQ] = ACTIONS(7518),
    [anon_sym_GT] = ACTIONS(7520),
    [anon_sym_GT_EQ] = ACTIONS(7518),
    [anon_sym_EQ_EQ] = ACTIONS(7518),
    [anon_sym_BANG_EQ] = ACTIONS(7518),
    [anon_sym_STAR] = ACTIONS(7520),
    [anon_sym_SLASH] = ACTIONS(7518),
    [anon_sym_STAR_STAR] = ACTIONS(7518),
    [anon_sym_CARET] = ACTIONS(7518),
    [aux_sym_binary_operator_token1] = ACTIONS(7518),
    [anon_sym_PIPE_GT] = ACTIONS(7518),
    [anon_sym_COLON] = ACTIONS(7520),
    [anon_sym_DOLLAR] = ACTIONS(7518),
    [anon_sym_AT] = ACTIONS(7518),
    [aux_sym__hex_literal_token1] = ACTIONS(7518),
    [sym__number_literal] = ACTIONS(7520),
    [anon_sym_SQUOTE] = ACTIONS(7518),
    [anon_sym_DQUOTE] = ACTIONS(7518),
    [sym_return] = ACTIONS(7520),
    [sym_next] = ACTIONS(7520),
    [sym_break] = ACTIONS(7520),
    [sym_true] = ACTIONS(7520),
    [sym_false] = ACTIONS(7520),
    [sym_null] = ACTIONS(7520),
    [sym_inf] = ACTIONS(7520),
    [sym_nan] = ACTIONS(7520),
    [anon_sym_NA] = ACTIONS(7520),
    [anon_sym_NA_integer_] = ACTIONS(7520),
    [anon_sym_NA_real_] = ACTIONS(7520),
    [anon_sym_NA_complex_] = ACTIONS(7520),
    [anon_sym_NA_character_] = ACTIONS(7520),
    [sym_dots] = ACTIONS(7520),
    [sym_dot_dot_i] = ACTIONS(7518),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7518),
    [sym__newline] = ACTIONS(7518),
    [sym__semicolon] = ACTIONS(7518),
    [sym__raw_string_literal] = ACTIONS(7518),
    [sym__external_else] = ACTIONS(7518),
    [sym__external_open_parenthesis] = ACTIONS(7518),
    [sym__external_close_parenthesis] = ACTIONS(7518),
    [sym__external_open_brace] = ACTIONS(7518),
    [sym__external_close_brace] = ACTIONS(7518),
    [sym__external_open_bracket] = ACTIONS(7518),
    [sym__external_close_bracket] = ACTIONS(7518),
    [sym__external_open_bracket2] = ACTIONS(7518),
  },
  [2322] = {
    [sym_identifier] = ACTIONS(7516),
    [anon_sym_BSLASH] = ACTIONS(7514),
    [anon_sym_function] = ACTIONS(7516),
    [anon_sym_EQ] = ACTIONS(7516),
    [anon_sym_if] = ACTIONS(7516),
    [anon_sym_for] = ACTIONS(7516),
    [anon_sym_while] = ACTIONS(7516),
    [anon_sym_repeat] = ACTIONS(7516),
    [anon_sym_QMARK] = ACTIONS(7514),
    [anon_sym_TILDE] = ACTIONS(7514),
    [anon_sym_BANG] = ACTIONS(7516),
    [anon_sym_PLUS] = ACTIONS(7514),
    [anon_sym_DASH] = ACTIONS(7516),
    [anon_sym_LT_DASH] = ACTIONS(7514),
    [anon_sym_LT_LT_DASH] = ACTIONS(7514),
    [anon_sym_COLON_EQ] = ACTIONS(7514),
    [anon_sym_DASH_GT] = ACTIONS(7516),
    [anon_sym_DASH_GT_GT] = ACTIONS(7514),
    [anon_sym_PIPE] = ACTIONS(7516),
    [anon_sym_AMP] = ACTIONS(7516),
    [anon_sym_PIPE_PIPE] = ACTIONS(7514),
    [anon_sym_AMP_AMP] = ACTIONS(7514),
    [anon_sym_LT] = ACTIONS(7516),
    [anon_sym_LT_EQ] = ACTIONS(7514),
    [anon_sym_GT] = ACTIONS(7516),
    [anon_sym_GT_EQ] = ACTIONS(7514),
    [anon_sym_EQ_EQ] = ACTIONS(7514),
    [anon_sym_BANG_EQ] = ACTIONS(7514),
    [anon_sym_STAR] = ACTIONS(7516),
    [anon_sym_SLASH] = ACTIONS(7514),
    [anon_sym_STAR_STAR] = ACTIONS(7514),
    [anon_sym_CARET] = ACTIONS(7514),
    [aux_sym_binary_operator_token1] = ACTIONS(7514),
    [anon_sym_PIPE_GT] = ACTIONS(7514),
    [anon_sym_COLON] = ACTIONS(7516),
    [anon_sym_DOLLAR] = ACTIONS(7514),
    [anon_sym_AT] = ACTIONS(7514),
    [aux_sym__hex_literal_token1] = ACTIONS(7514),
    [sym__number_literal] = ACTIONS(7516),
    [anon_sym_SQUOTE] = ACTIONS(7514),
    [anon_sym_DQUOTE] = ACTIONS(7514),
    [sym_return] = ACTIONS(7516),
    [sym_next] = ACTIONS(7516),
    [sym_break] = ACTIONS(7516),
    [sym_true] = ACTIONS(7516),
    [sym_false] = ACTIONS(7516),
    [sym_null] = ACTIONS(7516),
    [sym_inf] = ACTIONS(7516),
    [sym_nan] = ACTIONS(7516),
    [anon_sym_NA] = ACTIONS(7516),
    [anon_sym_NA_integer_] = ACTIONS(7516),
    [anon_sym_NA_real_] = ACTIONS(7516),
    [anon_sym_NA_complex_] = ACTIONS(7516),
    [anon_sym_NA_character_] = ACTIONS(7516),
    [sym_dots] = ACTIONS(7516),
    [sym_dot_dot_i] = ACTIONS(7514),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7514),
    [sym__newline] = ACTIONS(7514),
    [sym__semicolon] = ACTIONS(7514),
    [sym__raw_string_literal] = ACTIONS(7514),
    [sym__external_else] = ACTIONS(7514),
    [sym__external_open_parenthesis] = ACTIONS(7514),
    [sym__external_close_parenthesis] = ACTIONS(7514),
    [sym__external_open_brace] = ACTIONS(7514),
    [sym__external_close_brace] = ACTIONS(7514),
    [sym__external_open_bracket] = ACTIONS(7514),
    [sym__external_close_bracket] = ACTIONS(7514),
    [sym__external_open_bracket2] = ACTIONS(7514),
  },
  [2323] = {
    [sym_identifier] = ACTIONS(7512),
    [anon_sym_BSLASH] = ACTIONS(7510),
    [anon_sym_function] = ACTIONS(7512),
    [anon_sym_EQ] = ACTIONS(7512),
    [anon_sym_if] = ACTIONS(7512),
    [anon_sym_for] = ACTIONS(7512),
    [anon_sym_while] = ACTIONS(7512),
    [anon_sym_repeat] = ACTIONS(7512),
    [anon_sym_QMARK] = ACTIONS(7510),
    [anon_sym_TILDE] = ACTIONS(7510),
    [anon_sym_BANG] = ACTIONS(7512),
    [anon_sym_PLUS] = ACTIONS(7510),
    [anon_sym_DASH] = ACTIONS(7512),
    [anon_sym_LT_DASH] = ACTIONS(7510),
    [anon_sym_LT_LT_DASH] = ACTIONS(7510),
    [anon_sym_COLON_EQ] = ACTIONS(7510),
    [anon_sym_DASH_GT] = ACTIONS(7512),
    [anon_sym_DASH_GT_GT] = ACTIONS(7510),
    [anon_sym_PIPE] = ACTIONS(7512),
    [anon_sym_AMP] = ACTIONS(7512),
    [anon_sym_PIPE_PIPE] = ACTIONS(7510),
    [anon_sym_AMP_AMP] = ACTIONS(7510),
    [anon_sym_LT] = ACTIONS(7512),
    [anon_sym_LT_EQ] = ACTIONS(7510),
    [anon_sym_GT] = ACTIONS(7512),
    [anon_sym_GT_EQ] = ACTIONS(7510),
    [anon_sym_EQ_EQ] = ACTIONS(7510),
    [anon_sym_BANG_EQ] = ACTIONS(7510),
    [anon_sym_STAR] = ACTIONS(7512),
    [anon_sym_SLASH] = ACTIONS(7510),
    [anon_sym_STAR_STAR] = ACTIONS(7510),
    [anon_sym_CARET] = ACTIONS(7510),
    [aux_sym_binary_operator_token1] = ACTIONS(7510),
    [anon_sym_PIPE_GT] = ACTIONS(7510),
    [anon_sym_COLON] = ACTIONS(7512),
    [anon_sym_DOLLAR] = ACTIONS(7510),
    [anon_sym_AT] = ACTIONS(7510),
    [aux_sym__hex_literal_token1] = ACTIONS(7510),
    [sym__number_literal] = ACTIONS(7512),
    [anon_sym_SQUOTE] = ACTIONS(7510),
    [anon_sym_DQUOTE] = ACTIONS(7510),
    [sym_return] = ACTIONS(7512),
    [sym_next] = ACTIONS(7512),
    [sym_break] = ACTIONS(7512),
    [sym_true] = ACTIONS(7512),
    [sym_false] = ACTIONS(7512),
    [sym_null] = ACTIONS(7512),
    [sym_inf] = ACTIONS(7512),
    [sym_nan] = ACTIONS(7512),
    [anon_sym_NA] = ACTIONS(7512),
    [anon_sym_NA_integer_] = ACTIONS(7512),
    [anon_sym_NA_real_] = ACTIONS(7512),
    [anon_sym_NA_complex_] = ACTIONS(7512),
    [anon_sym_NA_character_] = ACTIONS(7512),
    [sym_dots] = ACTIONS(7512),
    [sym_dot_dot_i] = ACTIONS(7510),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7510),
    [sym__newline] = ACTIONS(7510),
    [sym__semicolon] = ACTIONS(7510),
    [sym__raw_string_literal] = ACTIONS(7510),
    [sym__external_else] = ACTIONS(7510),
    [sym__external_open_parenthesis] = ACTIONS(7510),
    [sym__external_close_parenthesis] = ACTIONS(7510),
    [sym__external_open_brace] = ACTIONS(7510),
    [sym__external_close_brace] = ACTIONS(7510),
    [sym__external_open_bracket] = ACTIONS(7510),
    [sym__external_close_bracket] = ACTIONS(7510),
    [sym__external_open_bracket2] = ACTIONS(7510),
  },
  [2324] = {
    [sym_identifier] = ACTIONS(7506),
    [anon_sym_BSLASH] = ACTIONS(7504),
    [anon_sym_function] = ACTIONS(7506),
    [anon_sym_EQ] = ACTIONS(7506),
    [anon_sym_if] = ACTIONS(7506),
    [anon_sym_for] = ACTIONS(7506),
    [anon_sym_while] = ACTIONS(7506),
    [anon_sym_repeat] = ACTIONS(7506),
    [anon_sym_QMARK] = ACTIONS(7504),
    [anon_sym_TILDE] = ACTIONS(7504),
    [anon_sym_BANG] = ACTIONS(7506),
    [anon_sym_PLUS] = ACTIONS(7504),
    [anon_sym_DASH] = ACTIONS(7506),
    [anon_sym_LT_DASH] = ACTIONS(7504),
    [anon_sym_LT_LT_DASH] = ACTIONS(7504),
    [anon_sym_COLON_EQ] = ACTIONS(7504),
    [anon_sym_DASH_GT] = ACTIONS(7506),
    [anon_sym_DASH_GT_GT] = ACTIONS(7504),
    [anon_sym_PIPE] = ACTIONS(7506),
    [anon_sym_AMP] = ACTIONS(7506),
    [anon_sym_PIPE_PIPE] = ACTIONS(7504),
    [anon_sym_AMP_AMP] = ACTIONS(7504),
    [anon_sym_LT] = ACTIONS(7506),
    [anon_sym_LT_EQ] = ACTIONS(7504),
    [anon_sym_GT] = ACTIONS(7506),
    [anon_sym_GT_EQ] = ACTIONS(7504),
    [anon_sym_EQ_EQ] = ACTIONS(7504),
    [anon_sym_BANG_EQ] = ACTIONS(7504),
    [anon_sym_STAR] = ACTIONS(7506),
    [anon_sym_SLASH] = ACTIONS(7504),
    [anon_sym_STAR_STAR] = ACTIONS(7504),
    [anon_sym_CARET] = ACTIONS(7504),
    [aux_sym_binary_operator_token1] = ACTIONS(7504),
    [anon_sym_PIPE_GT] = ACTIONS(7504),
    [anon_sym_COLON] = ACTIONS(7506),
    [anon_sym_DOLLAR] = ACTIONS(7504),
    [anon_sym_AT] = ACTIONS(7504),
    [aux_sym__hex_literal_token1] = ACTIONS(7504),
    [sym__number_literal] = ACTIONS(7506),
    [anon_sym_SQUOTE] = ACTIONS(7504),
    [anon_sym_DQUOTE] = ACTIONS(7504),
    [sym_return] = ACTIONS(7506),
    [sym_next] = ACTIONS(7506),
    [sym_break] = ACTIONS(7506),
    [sym_true] = ACTIONS(7506),
    [sym_false] = ACTIONS(7506),
    [sym_null] = ACTIONS(7506),
    [sym_inf] = ACTIONS(7506),
    [sym_nan] = ACTIONS(7506),
    [anon_sym_NA] = ACTIONS(7506),
    [anon_sym_NA_integer_] = ACTIONS(7506),
    [anon_sym_NA_real_] = ACTIONS(7506),
    [anon_sym_NA_complex_] = ACTIONS(7506),
    [anon_sym_NA_character_] = ACTIONS(7506),
    [sym_dots] = ACTIONS(7506),
    [sym_dot_dot_i] = ACTIONS(7504),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7504),
    [sym__newline] = ACTIONS(7504),
    [sym__semicolon] = ACTIONS(7504),
    [sym__raw_string_literal] = ACTIONS(7504),
    [sym__external_else] = ACTIONS(7504),
    [sym__external_open_parenthesis] = ACTIONS(7504),
    [sym__external_close_parenthesis] = ACTIONS(7504),
    [sym__external_open_brace] = ACTIONS(7504),
    [sym__external_close_brace] = ACTIONS(7504),
    [sym__external_open_bracket] = ACTIONS(7504),
    [sym__external_close_bracket] = ACTIONS(7504),
    [sym__external_open_bracket2] = ACTIONS(7504),
  },
  [2325] = {
    [sym_identifier] = ACTIONS(7502),
    [anon_sym_BSLASH] = ACTIONS(7500),
    [anon_sym_function] = ACTIONS(7502),
    [anon_sym_EQ] = ACTIONS(7502),
    [anon_sym_if] = ACTIONS(7502),
    [anon_sym_for] = ACTIONS(7502),
    [anon_sym_while] = ACTIONS(7502),
    [anon_sym_repeat] = ACTIONS(7502),
    [anon_sym_QMARK] = ACTIONS(7500),
    [anon_sym_TILDE] = ACTIONS(7500),
    [anon_sym_BANG] = ACTIONS(7502),
    [anon_sym_PLUS] = ACTIONS(7500),
    [anon_sym_DASH] = ACTIONS(7502),
    [anon_sym_LT_DASH] = ACTIONS(7500),
    [anon_sym_LT_LT_DASH] = ACTIONS(7500),
    [anon_sym_COLON_EQ] = ACTIONS(7500),
    [anon_sym_DASH_GT] = ACTIONS(7502),
    [anon_sym_DASH_GT_GT] = ACTIONS(7500),
    [anon_sym_PIPE] = ACTIONS(7502),
    [anon_sym_AMP] = ACTIONS(7502),
    [anon_sym_PIPE_PIPE] = ACTIONS(7500),
    [anon_sym_AMP_AMP] = ACTIONS(7500),
    [anon_sym_LT] = ACTIONS(7502),
    [anon_sym_LT_EQ] = ACTIONS(7500),
    [anon_sym_GT] = ACTIONS(7502),
    [anon_sym_GT_EQ] = ACTIONS(7500),
    [anon_sym_EQ_EQ] = ACTIONS(7500),
    [anon_sym_BANG_EQ] = ACTIONS(7500),
    [anon_sym_STAR] = ACTIONS(7502),
    [anon_sym_SLASH] = ACTIONS(7500),
    [anon_sym_STAR_STAR] = ACTIONS(7500),
    [anon_sym_CARET] = ACTIONS(7500),
    [aux_sym_binary_operator_token1] = ACTIONS(7500),
    [anon_sym_PIPE_GT] = ACTIONS(7500),
    [anon_sym_COLON] = ACTIONS(7502),
    [anon_sym_DOLLAR] = ACTIONS(7500),
    [anon_sym_AT] = ACTIONS(7500),
    [aux_sym__hex_literal_token1] = ACTIONS(7500),
    [sym__number_literal] = ACTIONS(7502),
    [anon_sym_SQUOTE] = ACTIONS(7500),
    [anon_sym_DQUOTE] = ACTIONS(7500),
    [sym_return] = ACTIONS(7502),
    [sym_next] = ACTIONS(7502),
    [sym_break] = ACTIONS(7502),
    [sym_true] = ACTIONS(7502),
    [sym_false] = ACTIONS(7502),
    [sym_null] = ACTIONS(7502),
    [sym_inf] = ACTIONS(7502),
    [sym_nan] = ACTIONS(7502),
    [anon_sym_NA] = ACTIONS(7502),
    [anon_sym_NA_integer_] = ACTIONS(7502),
    [anon_sym_NA_real_] = ACTIONS(7502),
    [anon_sym_NA_complex_] = ACTIONS(7502),
    [anon_sym_NA_character_] = ACTIONS(7502),
    [sym_dots] = ACTIONS(7502),
    [sym_dot_dot_i] = ACTIONS(7500),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7500),
    [sym__newline] = ACTIONS(7500),
    [sym__semicolon] = ACTIONS(7500),
    [sym__raw_string_literal] = ACTIONS(7500),
    [sym__external_else] = ACTIONS(7500),
    [sym__external_open_parenthesis] = ACTIONS(7500),
    [sym__external_close_parenthesis] = ACTIONS(7500),
    [sym__external_open_brace] = ACTIONS(7500),
    [sym__external_close_brace] = ACTIONS(7500),
    [sym__external_open_bracket] = ACTIONS(7500),
    [sym__external_close_bracket] = ACTIONS(7500),
    [sym__external_open_bracket2] = ACTIONS(7500),
  },
  [2326] = {
    [sym_identifier] = ACTIONS(7498),
    [anon_sym_BSLASH] = ACTIONS(7496),
    [anon_sym_function] = ACTIONS(7498),
    [anon_sym_EQ] = ACTIONS(7498),
    [anon_sym_if] = ACTIONS(7498),
    [anon_sym_for] = ACTIONS(7498),
    [anon_sym_while] = ACTIONS(7498),
    [anon_sym_repeat] = ACTIONS(7498),
    [anon_sym_QMARK] = ACTIONS(7496),
    [anon_sym_TILDE] = ACTIONS(7496),
    [anon_sym_BANG] = ACTIONS(7498),
    [anon_sym_PLUS] = ACTIONS(7496),
    [anon_sym_DASH] = ACTIONS(7498),
    [anon_sym_LT_DASH] = ACTIONS(7496),
    [anon_sym_LT_LT_DASH] = ACTIONS(7496),
    [anon_sym_COLON_EQ] = ACTIONS(7496),
    [anon_sym_DASH_GT] = ACTIONS(7498),
    [anon_sym_DASH_GT_GT] = ACTIONS(7496),
    [anon_sym_PIPE] = ACTIONS(7498),
    [anon_sym_AMP] = ACTIONS(7498),
    [anon_sym_PIPE_PIPE] = ACTIONS(7496),
    [anon_sym_AMP_AMP] = ACTIONS(7496),
    [anon_sym_LT] = ACTIONS(7498),
    [anon_sym_LT_EQ] = ACTIONS(7496),
    [anon_sym_GT] = ACTIONS(7498),
    [anon_sym_GT_EQ] = ACTIONS(7496),
    [anon_sym_EQ_EQ] = ACTIONS(7496),
    [anon_sym_BANG_EQ] = ACTIONS(7496),
    [anon_sym_STAR] = ACTIONS(7498),
    [anon_sym_SLASH] = ACTIONS(7496),
    [anon_sym_STAR_STAR] = ACTIONS(7496),
    [anon_sym_CARET] = ACTIONS(7496),
    [aux_sym_binary_operator_token1] = ACTIONS(7496),
    [anon_sym_PIPE_GT] = ACTIONS(7496),
    [anon_sym_COLON] = ACTIONS(7498),
    [anon_sym_DOLLAR] = ACTIONS(7496),
    [anon_sym_AT] = ACTIONS(7496),
    [aux_sym__hex_literal_token1] = ACTIONS(7496),
    [sym__number_literal] = ACTIONS(7498),
    [anon_sym_SQUOTE] = ACTIONS(7496),
    [anon_sym_DQUOTE] = ACTIONS(7496),
    [sym_return] = ACTIONS(7498),
    [sym_next] = ACTIONS(7498),
    [sym_break] = ACTIONS(7498),
    [sym_true] = ACTIONS(7498),
    [sym_false] = ACTIONS(7498),
    [sym_null] = ACTIONS(7498),
    [sym_inf] = ACTIONS(7498),
    [sym_nan] = ACTIONS(7498),
    [anon_sym_NA] = ACTIONS(7498),
    [anon_sym_NA_integer_] = ACTIONS(7498),
    [anon_sym_NA_real_] = ACTIONS(7498),
    [anon_sym_NA_complex_] = ACTIONS(7498),
    [anon_sym_NA_character_] = ACTIONS(7498),
    [sym_dots] = ACTIONS(7498),
    [sym_dot_dot_i] = ACTIONS(7496),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7496),
    [sym__newline] = ACTIONS(7496),
    [sym__semicolon] = ACTIONS(7496),
    [sym__raw_string_literal] = ACTIONS(7496),
    [sym__external_else] = ACTIONS(7496),
    [sym__external_open_parenthesis] = ACTIONS(7496),
    [sym__external_close_parenthesis] = ACTIONS(7496),
    [sym__external_open_brace] = ACTIONS(7496),
    [sym__external_close_brace] = ACTIONS(7496),
    [sym__external_open_bracket] = ACTIONS(7496),
    [sym__external_close_bracket] = ACTIONS(7496),
    [sym__external_open_bracket2] = ACTIONS(7496),
  },
  [2327] = {
    [sym_identifier] = ACTIONS(7494),
    [anon_sym_BSLASH] = ACTIONS(7492),
    [anon_sym_function] = ACTIONS(7494),
    [anon_sym_EQ] = ACTIONS(7494),
    [anon_sym_if] = ACTIONS(7494),
    [anon_sym_for] = ACTIONS(7494),
    [anon_sym_while] = ACTIONS(7494),
    [anon_sym_repeat] = ACTIONS(7494),
    [anon_sym_QMARK] = ACTIONS(7492),
    [anon_sym_TILDE] = ACTIONS(7492),
    [anon_sym_BANG] = ACTIONS(7494),
    [anon_sym_PLUS] = ACTIONS(7492),
    [anon_sym_DASH] = ACTIONS(7494),
    [anon_sym_LT_DASH] = ACTIONS(7492),
    [anon_sym_LT_LT_DASH] = ACTIONS(7492),
    [anon_sym_COLON_EQ] = ACTIONS(7492),
    [anon_sym_DASH_GT] = ACTIONS(7494),
    [anon_sym_DASH_GT_GT] = ACTIONS(7492),
    [anon_sym_PIPE] = ACTIONS(7494),
    [anon_sym_AMP] = ACTIONS(7494),
    [anon_sym_PIPE_PIPE] = ACTIONS(7492),
    [anon_sym_AMP_AMP] = ACTIONS(7492),
    [anon_sym_LT] = ACTIONS(7494),
    [anon_sym_LT_EQ] = ACTIONS(7492),
    [anon_sym_GT] = ACTIONS(7494),
    [anon_sym_GT_EQ] = ACTIONS(7492),
    [anon_sym_EQ_EQ] = ACTIONS(7492),
    [anon_sym_BANG_EQ] = ACTIONS(7492),
    [anon_sym_STAR] = ACTIONS(7494),
    [anon_sym_SLASH] = ACTIONS(7492),
    [anon_sym_STAR_STAR] = ACTIONS(7492),
    [anon_sym_CARET] = ACTIONS(7492),
    [aux_sym_binary_operator_token1] = ACTIONS(7492),
    [anon_sym_PIPE_GT] = ACTIONS(7492),
    [anon_sym_COLON] = ACTIONS(7494),
    [anon_sym_DOLLAR] = ACTIONS(7492),
    [anon_sym_AT] = ACTIONS(7492),
    [aux_sym__hex_literal_token1] = ACTIONS(7492),
    [sym__number_literal] = ACTIONS(7494),
    [anon_sym_SQUOTE] = ACTIONS(7492),
    [anon_sym_DQUOTE] = ACTIONS(7492),
    [sym_return] = ACTIONS(7494),
    [sym_next] = ACTIONS(7494),
    [sym_break] = ACTIONS(7494),
    [sym_true] = ACTIONS(7494),
    [sym_false] = ACTIONS(7494),
    [sym_null] = ACTIONS(7494),
    [sym_inf] = ACTIONS(7494),
    [sym_nan] = ACTIONS(7494),
    [anon_sym_NA] = ACTIONS(7494),
    [anon_sym_NA_integer_] = ACTIONS(7494),
    [anon_sym_NA_real_] = ACTIONS(7494),
    [anon_sym_NA_complex_] = ACTIONS(7494),
    [anon_sym_NA_character_] = ACTIONS(7494),
    [sym_dots] = ACTIONS(7494),
    [sym_dot_dot_i] = ACTIONS(7492),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7492),
    [sym__newline] = ACTIONS(7492),
    [sym__semicolon] = ACTIONS(7492),
    [sym__raw_string_literal] = ACTIONS(7492),
    [sym__external_else] = ACTIONS(7492),
    [sym__external_open_parenthesis] = ACTIONS(7492),
    [sym__external_close_parenthesis] = ACTIONS(7492),
    [sym__external_open_brace] = ACTIONS(7492),
    [sym__external_close_brace] = ACTIONS(7492),
    [sym__external_open_bracket] = ACTIONS(7492),
    [sym__external_close_bracket] = ACTIONS(7492),
    [sym__external_open_bracket2] = ACTIONS(7492),
  },
  [2328] = {
    [sym_identifier] = ACTIONS(7490),
    [anon_sym_BSLASH] = ACTIONS(7488),
    [anon_sym_function] = ACTIONS(7490),
    [anon_sym_EQ] = ACTIONS(7490),
    [anon_sym_if] = ACTIONS(7490),
    [anon_sym_for] = ACTIONS(7490),
    [anon_sym_while] = ACTIONS(7490),
    [anon_sym_repeat] = ACTIONS(7490),
    [anon_sym_QMARK] = ACTIONS(7488),
    [anon_sym_TILDE] = ACTIONS(7488),
    [anon_sym_BANG] = ACTIONS(7490),
    [anon_sym_PLUS] = ACTIONS(7488),
    [anon_sym_DASH] = ACTIONS(7490),
    [anon_sym_LT_DASH] = ACTIONS(7488),
    [anon_sym_LT_LT_DASH] = ACTIONS(7488),
    [anon_sym_COLON_EQ] = ACTIONS(7488),
    [anon_sym_DASH_GT] = ACTIONS(7490),
    [anon_sym_DASH_GT_GT] = ACTIONS(7488),
    [anon_sym_PIPE] = ACTIONS(7490),
    [anon_sym_AMP] = ACTIONS(7490),
    [anon_sym_PIPE_PIPE] = ACTIONS(7488),
    [anon_sym_AMP_AMP] = ACTIONS(7488),
    [anon_sym_LT] = ACTIONS(7490),
    [anon_sym_LT_EQ] = ACTIONS(7488),
    [anon_sym_GT] = ACTIONS(7490),
    [anon_sym_GT_EQ] = ACTIONS(7488),
    [anon_sym_EQ_EQ] = ACTIONS(7488),
    [anon_sym_BANG_EQ] = ACTIONS(7488),
    [anon_sym_STAR] = ACTIONS(7490),
    [anon_sym_SLASH] = ACTIONS(7488),
    [anon_sym_STAR_STAR] = ACTIONS(7488),
    [anon_sym_CARET] = ACTIONS(7488),
    [aux_sym_binary_operator_token1] = ACTIONS(7488),
    [anon_sym_PIPE_GT] = ACTIONS(7488),
    [anon_sym_COLON] = ACTIONS(7490),
    [anon_sym_DOLLAR] = ACTIONS(7488),
    [anon_sym_AT] = ACTIONS(7488),
    [aux_sym__hex_literal_token1] = ACTIONS(7488),
    [sym__number_literal] = ACTIONS(7490),
    [anon_sym_SQUOTE] = ACTIONS(7488),
    [anon_sym_DQUOTE] = ACTIONS(7488),
    [sym_return] = ACTIONS(7490),
    [sym_next] = ACTIONS(7490),
    [sym_break] = ACTIONS(7490),
    [sym_true] = ACTIONS(7490),
    [sym_false] = ACTIONS(7490),
    [sym_null] = ACTIONS(7490),
    [sym_inf] = ACTIONS(7490),
    [sym_nan] = ACTIONS(7490),
    [anon_sym_NA] = ACTIONS(7490),
    [anon_sym_NA_integer_] = ACTIONS(7490),
    [anon_sym_NA_real_] = ACTIONS(7490),
    [anon_sym_NA_complex_] = ACTIONS(7490),
    [anon_sym_NA_character_] = ACTIONS(7490),
    [sym_dots] = ACTIONS(7490),
    [sym_dot_dot_i] = ACTIONS(7488),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7488),
    [sym__newline] = ACTIONS(7488),
    [sym__semicolon] = ACTIONS(7488),
    [sym__raw_string_literal] = ACTIONS(7488),
    [sym__external_else] = ACTIONS(7488),
    [sym__external_open_parenthesis] = ACTIONS(7488),
    [sym__external_close_parenthesis] = ACTIONS(7488),
    [sym__external_open_brace] = ACTIONS(7488),
    [sym__external_close_brace] = ACTIONS(7488),
    [sym__external_open_bracket] = ACTIONS(7488),
    [sym__external_close_bracket] = ACTIONS(7488),
    [sym__external_open_bracket2] = ACTIONS(7488),
  },
  [2329] = {
    [sym_identifier] = ACTIONS(7486),
    [anon_sym_BSLASH] = ACTIONS(7484),
    [anon_sym_function] = ACTIONS(7486),
    [anon_sym_EQ] = ACTIONS(7486),
    [anon_sym_if] = ACTIONS(7486),
    [anon_sym_for] = ACTIONS(7486),
    [anon_sym_while] = ACTIONS(7486),
    [anon_sym_repeat] = ACTIONS(7486),
    [anon_sym_QMARK] = ACTIONS(7484),
    [anon_sym_TILDE] = ACTIONS(7484),
    [anon_sym_BANG] = ACTIONS(7486),
    [anon_sym_PLUS] = ACTIONS(7484),
    [anon_sym_DASH] = ACTIONS(7486),
    [anon_sym_LT_DASH] = ACTIONS(7484),
    [anon_sym_LT_LT_DASH] = ACTIONS(7484),
    [anon_sym_COLON_EQ] = ACTIONS(7484),
    [anon_sym_DASH_GT] = ACTIONS(7486),
    [anon_sym_DASH_GT_GT] = ACTIONS(7484),
    [anon_sym_PIPE] = ACTIONS(7486),
    [anon_sym_AMP] = ACTIONS(7486),
    [anon_sym_PIPE_PIPE] = ACTIONS(7484),
    [anon_sym_AMP_AMP] = ACTIONS(7484),
    [anon_sym_LT] = ACTIONS(7486),
    [anon_sym_LT_EQ] = ACTIONS(7484),
    [anon_sym_GT] = ACTIONS(7486),
    [anon_sym_GT_EQ] = ACTIONS(7484),
    [anon_sym_EQ_EQ] = ACTIONS(7484),
    [anon_sym_BANG_EQ] = ACTIONS(7484),
    [anon_sym_STAR] = ACTIONS(7486),
    [anon_sym_SLASH] = ACTIONS(7484),
    [anon_sym_STAR_STAR] = ACTIONS(7484),
    [anon_sym_CARET] = ACTIONS(7484),
    [aux_sym_binary_operator_token1] = ACTIONS(7484),
    [anon_sym_PIPE_GT] = ACTIONS(7484),
    [anon_sym_COLON] = ACTIONS(7486),
    [anon_sym_DOLLAR] = ACTIONS(7484),
    [anon_sym_AT] = ACTIONS(7484),
    [aux_sym__hex_literal_token1] = ACTIONS(7484),
    [sym__number_literal] = ACTIONS(7486),
    [anon_sym_SQUOTE] = ACTIONS(7484),
    [anon_sym_DQUOTE] = ACTIONS(7484),
    [sym_return] = ACTIONS(7486),
    [sym_next] = ACTIONS(7486),
    [sym_break] = ACTIONS(7486),
    [sym_true] = ACTIONS(7486),
    [sym_false] = ACTIONS(7486),
    [sym_null] = ACTIONS(7486),
    [sym_inf] = ACTIONS(7486),
    [sym_nan] = ACTIONS(7486),
    [anon_sym_NA] = ACTIONS(7486),
    [anon_sym_NA_integer_] = ACTIONS(7486),
    [anon_sym_NA_real_] = ACTIONS(7486),
    [anon_sym_NA_complex_] = ACTIONS(7486),
    [anon_sym_NA_character_] = ACTIONS(7486),
    [sym_dots] = ACTIONS(7486),
    [sym_dot_dot_i] = ACTIONS(7484),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7484),
    [sym__newline] = ACTIONS(7484),
    [sym__semicolon] = ACTIONS(7484),
    [sym__raw_string_literal] = ACTIONS(7484),
    [sym__external_else] = ACTIONS(7484),
    [sym__external_open_parenthesis] = ACTIONS(7484),
    [sym__external_close_parenthesis] = ACTIONS(7484),
    [sym__external_open_brace] = ACTIONS(7484),
    [sym__external_close_brace] = ACTIONS(7484),
    [sym__external_open_bracket] = ACTIONS(7484),
    [sym__external_close_bracket] = ACTIONS(7484),
    [sym__external_open_bracket2] = ACTIONS(7484),
  },
  [2330] = {
    [sym_identifier] = ACTIONS(7482),
    [anon_sym_BSLASH] = ACTIONS(7480),
    [anon_sym_function] = ACTIONS(7482),
    [anon_sym_EQ] = ACTIONS(7482),
    [anon_sym_if] = ACTIONS(7482),
    [anon_sym_for] = ACTIONS(7482),
    [anon_sym_while] = ACTIONS(7482),
    [anon_sym_repeat] = ACTIONS(7482),
    [anon_sym_QMARK] = ACTIONS(7480),
    [anon_sym_TILDE] = ACTIONS(7480),
    [anon_sym_BANG] = ACTIONS(7482),
    [anon_sym_PLUS] = ACTIONS(7480),
    [anon_sym_DASH] = ACTIONS(7482),
    [anon_sym_LT_DASH] = ACTIONS(7480),
    [anon_sym_LT_LT_DASH] = ACTIONS(7480),
    [anon_sym_COLON_EQ] = ACTIONS(7480),
    [anon_sym_DASH_GT] = ACTIONS(7482),
    [anon_sym_DASH_GT_GT] = ACTIONS(7480),
    [anon_sym_PIPE] = ACTIONS(7482),
    [anon_sym_AMP] = ACTIONS(7482),
    [anon_sym_PIPE_PIPE] = ACTIONS(7480),
    [anon_sym_AMP_AMP] = ACTIONS(7480),
    [anon_sym_LT] = ACTIONS(7482),
    [anon_sym_LT_EQ] = ACTIONS(7480),
    [anon_sym_GT] = ACTIONS(7482),
    [anon_sym_GT_EQ] = ACTIONS(7480),
    [anon_sym_EQ_EQ] = ACTIONS(7480),
    [anon_sym_BANG_EQ] = ACTIONS(7480),
    [anon_sym_STAR] = ACTIONS(7482),
    [anon_sym_SLASH] = ACTIONS(7480),
    [anon_sym_STAR_STAR] = ACTIONS(7480),
    [anon_sym_CARET] = ACTIONS(7480),
    [aux_sym_binary_operator_token1] = ACTIONS(7480),
    [anon_sym_PIPE_GT] = ACTIONS(7480),
    [anon_sym_COLON] = ACTIONS(7482),
    [anon_sym_DOLLAR] = ACTIONS(7480),
    [anon_sym_AT] = ACTIONS(7480),
    [aux_sym__hex_literal_token1] = ACTIONS(7480),
    [sym__number_literal] = ACTIONS(7482),
    [anon_sym_SQUOTE] = ACTIONS(7480),
    [anon_sym_DQUOTE] = ACTIONS(7480),
    [sym_return] = ACTIONS(7482),
    [sym_next] = ACTIONS(7482),
    [sym_break] = ACTIONS(7482),
    [sym_true] = ACTIONS(7482),
    [sym_false] = ACTIONS(7482),
    [sym_null] = ACTIONS(7482),
    [sym_inf] = ACTIONS(7482),
    [sym_nan] = ACTIONS(7482),
    [anon_sym_NA] = ACTIONS(7482),
    [anon_sym_NA_integer_] = ACTIONS(7482),
    [anon_sym_NA_real_] = ACTIONS(7482),
    [anon_sym_NA_complex_] = ACTIONS(7482),
    [anon_sym_NA_character_] = ACTIONS(7482),
    [sym_dots] = ACTIONS(7482),
    [sym_dot_dot_i] = ACTIONS(7480),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7480),
    [sym__newline] = ACTIONS(7480),
    [sym__semicolon] = ACTIONS(7480),
    [sym__raw_string_literal] = ACTIONS(7480),
    [sym__external_else] = ACTIONS(7480),
    [sym__external_open_parenthesis] = ACTIONS(7480),
    [sym__external_close_parenthesis] = ACTIONS(7480),
    [sym__external_open_brace] = ACTIONS(7480),
    [sym__external_close_brace] = ACTIONS(7480),
    [sym__external_open_bracket] = ACTIONS(7480),
    [sym__external_close_bracket] = ACTIONS(7480),
    [sym__external_open_bracket2] = ACTIONS(7480),
  },
  [2331] = {
    [sym_identifier] = ACTIONS(7478),
    [anon_sym_BSLASH] = ACTIONS(7476),
    [anon_sym_function] = ACTIONS(7478),
    [anon_sym_EQ] = ACTIONS(7478),
    [anon_sym_if] = ACTIONS(7478),
    [anon_sym_for] = ACTIONS(7478),
    [anon_sym_while] = ACTIONS(7478),
    [anon_sym_repeat] = ACTIONS(7478),
    [anon_sym_QMARK] = ACTIONS(7476),
    [anon_sym_TILDE] = ACTIONS(7476),
    [anon_sym_BANG] = ACTIONS(7478),
    [anon_sym_PLUS] = ACTIONS(7476),
    [anon_sym_DASH] = ACTIONS(7478),
    [anon_sym_LT_DASH] = ACTIONS(7476),
    [anon_sym_LT_LT_DASH] = ACTIONS(7476),
    [anon_sym_COLON_EQ] = ACTIONS(7476),
    [anon_sym_DASH_GT] = ACTIONS(7478),
    [anon_sym_DASH_GT_GT] = ACTIONS(7476),
    [anon_sym_PIPE] = ACTIONS(7478),
    [anon_sym_AMP] = ACTIONS(7478),
    [anon_sym_PIPE_PIPE] = ACTIONS(7476),
    [anon_sym_AMP_AMP] = ACTIONS(7476),
    [anon_sym_LT] = ACTIONS(7478),
    [anon_sym_LT_EQ] = ACTIONS(7476),
    [anon_sym_GT] = ACTIONS(7478),
    [anon_sym_GT_EQ] = ACTIONS(7476),
    [anon_sym_EQ_EQ] = ACTIONS(7476),
    [anon_sym_BANG_EQ] = ACTIONS(7476),
    [anon_sym_STAR] = ACTIONS(7478),
    [anon_sym_SLASH] = ACTIONS(7476),
    [anon_sym_STAR_STAR] = ACTIONS(7476),
    [anon_sym_CARET] = ACTIONS(7476),
    [aux_sym_binary_operator_token1] = ACTIONS(7476),
    [anon_sym_PIPE_GT] = ACTIONS(7476),
    [anon_sym_COLON] = ACTIONS(7478),
    [anon_sym_DOLLAR] = ACTIONS(7476),
    [anon_sym_AT] = ACTIONS(7476),
    [aux_sym__hex_literal_token1] = ACTIONS(7476),
    [sym__number_literal] = ACTIONS(7478),
    [anon_sym_SQUOTE] = ACTIONS(7476),
    [anon_sym_DQUOTE] = ACTIONS(7476),
    [sym_return] = ACTIONS(7478),
    [sym_next] = ACTIONS(7478),
    [sym_break] = ACTIONS(7478),
    [sym_true] = ACTIONS(7478),
    [sym_false] = ACTIONS(7478),
    [sym_null] = ACTIONS(7478),
    [sym_inf] = ACTIONS(7478),
    [sym_nan] = ACTIONS(7478),
    [anon_sym_NA] = ACTIONS(7478),
    [anon_sym_NA_integer_] = ACTIONS(7478),
    [anon_sym_NA_real_] = ACTIONS(7478),
    [anon_sym_NA_complex_] = ACTIONS(7478),
    [anon_sym_NA_character_] = ACTIONS(7478),
    [sym_dots] = ACTIONS(7478),
    [sym_dot_dot_i] = ACTIONS(7476),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7476),
    [sym__newline] = ACTIONS(7476),
    [sym__semicolon] = ACTIONS(7476),
    [sym__raw_string_literal] = ACTIONS(7476),
    [sym__external_else] = ACTIONS(7476),
    [sym__external_open_parenthesis] = ACTIONS(7476),
    [sym__external_close_parenthesis] = ACTIONS(7476),
    [sym__external_open_brace] = ACTIONS(7476),
    [sym__external_close_brace] = ACTIONS(7476),
    [sym__external_open_bracket] = ACTIONS(7476),
    [sym__external_close_bracket] = ACTIONS(7476),
    [sym__external_open_bracket2] = ACTIONS(7476),
  },
  [2332] = {
    [sym_identifier] = ACTIONS(7464),
    [anon_sym_BSLASH] = ACTIONS(7466),
    [anon_sym_function] = ACTIONS(7464),
    [anon_sym_EQ] = ACTIONS(7464),
    [anon_sym_if] = ACTIONS(7464),
    [anon_sym_for] = ACTIONS(7464),
    [anon_sym_while] = ACTIONS(7464),
    [anon_sym_repeat] = ACTIONS(7464),
    [anon_sym_QMARK] = ACTIONS(7466),
    [anon_sym_TILDE] = ACTIONS(7466),
    [anon_sym_BANG] = ACTIONS(7464),
    [anon_sym_PLUS] = ACTIONS(7466),
    [anon_sym_DASH] = ACTIONS(7464),
    [anon_sym_LT_DASH] = ACTIONS(7466),
    [anon_sym_LT_LT_DASH] = ACTIONS(7466),
    [anon_sym_COLON_EQ] = ACTIONS(7466),
    [anon_sym_DASH_GT] = ACTIONS(7464),
    [anon_sym_DASH_GT_GT] = ACTIONS(7466),
    [anon_sym_PIPE] = ACTIONS(7464),
    [anon_sym_AMP] = ACTIONS(7464),
    [anon_sym_PIPE_PIPE] = ACTIONS(7466),
    [anon_sym_AMP_AMP] = ACTIONS(7466),
    [anon_sym_LT] = ACTIONS(7464),
    [anon_sym_LT_EQ] = ACTIONS(7466),
    [anon_sym_GT] = ACTIONS(7464),
    [anon_sym_GT_EQ] = ACTIONS(7466),
    [anon_sym_EQ_EQ] = ACTIONS(7466),
    [anon_sym_BANG_EQ] = ACTIONS(7466),
    [anon_sym_STAR] = ACTIONS(7464),
    [anon_sym_SLASH] = ACTIONS(7466),
    [anon_sym_STAR_STAR] = ACTIONS(7466),
    [anon_sym_CARET] = ACTIONS(7466),
    [aux_sym_binary_operator_token1] = ACTIONS(7466),
    [anon_sym_PIPE_GT] = ACTIONS(7466),
    [anon_sym_COLON] = ACTIONS(7464),
    [anon_sym_DOLLAR] = ACTIONS(7466),
    [anon_sym_AT] = ACTIONS(7466),
    [aux_sym__hex_literal_token1] = ACTIONS(7466),
    [sym__number_literal] = ACTIONS(7464),
    [anon_sym_SQUOTE] = ACTIONS(7466),
    [anon_sym_DQUOTE] = ACTIONS(7466),
    [sym_return] = ACTIONS(7464),
    [sym_next] = ACTIONS(7464),
    [sym_break] = ACTIONS(7464),
    [sym_true] = ACTIONS(7464),
    [sym_false] = ACTIONS(7464),
    [sym_null] = ACTIONS(7464),
    [sym_inf] = ACTIONS(7464),
    [sym_nan] = ACTIONS(7464),
    [anon_sym_NA] = ACTIONS(7464),
    [anon_sym_NA_integer_] = ACTIONS(7464),
    [anon_sym_NA_real_] = ACTIONS(7464),
    [anon_sym_NA_complex_] = ACTIONS(7464),
    [anon_sym_NA_character_] = ACTIONS(7464),
    [sym_dots] = ACTIONS(7464),
    [sym_dot_dot_i] = ACTIONS(7466),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7466),
    [sym__newline] = ACTIONS(7466),
    [sym__semicolon] = ACTIONS(7466),
    [sym__raw_string_literal] = ACTIONS(7466),
    [sym__external_else] = ACTIONS(7466),
    [sym__external_open_parenthesis] = ACTIONS(7466),
    [sym__external_close_parenthesis] = ACTIONS(7466),
    [sym__external_open_brace] = ACTIONS(7466),
    [sym__external_close_brace] = ACTIONS(7466),
    [sym__external_open_bracket] = ACTIONS(7466),
    [sym__external_close_bracket] = ACTIONS(7466),
    [sym__external_open_bracket2] = ACTIONS(7466),
  },
  [2333] = {
    [sym_identifier] = ACTIONS(7474),
    [anon_sym_BSLASH] = ACTIONS(7472),
    [anon_sym_function] = ACTIONS(7474),
    [anon_sym_EQ] = ACTIONS(7474),
    [anon_sym_if] = ACTIONS(7474),
    [anon_sym_for] = ACTIONS(7474),
    [anon_sym_while] = ACTIONS(7474),
    [anon_sym_repeat] = ACTIONS(7474),
    [anon_sym_QMARK] = ACTIONS(7472),
    [anon_sym_TILDE] = ACTIONS(7472),
    [anon_sym_BANG] = ACTIONS(7474),
    [anon_sym_PLUS] = ACTIONS(7472),
    [anon_sym_DASH] = ACTIONS(7474),
    [anon_sym_LT_DASH] = ACTIONS(7472),
    [anon_sym_LT_LT_DASH] = ACTIONS(7472),
    [anon_sym_COLON_EQ] = ACTIONS(7472),
    [anon_sym_DASH_GT] = ACTIONS(7474),
    [anon_sym_DASH_GT_GT] = ACTIONS(7472),
    [anon_sym_PIPE] = ACTIONS(7474),
    [anon_sym_AMP] = ACTIONS(7474),
    [anon_sym_PIPE_PIPE] = ACTIONS(7472),
    [anon_sym_AMP_AMP] = ACTIONS(7472),
    [anon_sym_LT] = ACTIONS(7474),
    [anon_sym_LT_EQ] = ACTIONS(7472),
    [anon_sym_GT] = ACTIONS(7474),
    [anon_sym_GT_EQ] = ACTIONS(7472),
    [anon_sym_EQ_EQ] = ACTIONS(7472),
    [anon_sym_BANG_EQ] = ACTIONS(7472),
    [anon_sym_STAR] = ACTIONS(7474),
    [anon_sym_SLASH] = ACTIONS(7472),
    [anon_sym_STAR_STAR] = ACTIONS(7472),
    [anon_sym_CARET] = ACTIONS(7472),
    [aux_sym_binary_operator_token1] = ACTIONS(7472),
    [anon_sym_PIPE_GT] = ACTIONS(7472),
    [anon_sym_COLON] = ACTIONS(7474),
    [anon_sym_DOLLAR] = ACTIONS(7472),
    [anon_sym_AT] = ACTIONS(7472),
    [aux_sym__hex_literal_token1] = ACTIONS(7472),
    [sym__number_literal] = ACTIONS(7474),
    [anon_sym_SQUOTE] = ACTIONS(7472),
    [anon_sym_DQUOTE] = ACTIONS(7472),
    [sym_return] = ACTIONS(7474),
    [sym_next] = ACTIONS(7474),
    [sym_break] = ACTIONS(7474),
    [sym_true] = ACTIONS(7474),
    [sym_false] = ACTIONS(7474),
    [sym_null] = ACTIONS(7474),
    [sym_inf] = ACTIONS(7474),
    [sym_nan] = ACTIONS(7474),
    [anon_sym_NA] = ACTIONS(7474),
    [anon_sym_NA_integer_] = ACTIONS(7474),
    [anon_sym_NA_real_] = ACTIONS(7474),
    [anon_sym_NA_complex_] = ACTIONS(7474),
    [anon_sym_NA_character_] = ACTIONS(7474),
    [sym_dots] = ACTIONS(7474),
    [sym_dot_dot_i] = ACTIONS(7472),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7472),
    [sym__newline] = ACTIONS(7472),
    [sym__semicolon] = ACTIONS(7472),
    [sym__raw_string_literal] = ACTIONS(7472),
    [sym__external_else] = ACTIONS(7472),
    [sym__external_open_parenthesis] = ACTIONS(7472),
    [sym__external_close_parenthesis] = ACTIONS(7472),
    [sym__external_open_brace] = ACTIONS(7472),
    [sym__external_close_brace] = ACTIONS(7472),
    [sym__external_open_bracket] = ACTIONS(7472),
    [sym__external_close_bracket] = ACTIONS(7472),
    [sym__external_open_bracket2] = ACTIONS(7472),
  },
  [2334] = {
    [ts_builtin_sym_end] = ACTIONS(7193),
    [sym_identifier] = ACTIONS(7195),
    [anon_sym_BSLASH] = ACTIONS(7193),
    [anon_sym_function] = ACTIONS(7195),
    [anon_sym_EQ] = ACTIONS(7195),
    [anon_sym_if] = ACTIONS(7195),
    [anon_sym_for] = ACTIONS(7195),
    [anon_sym_while] = ACTIONS(7195),
    [anon_sym_repeat] = ACTIONS(7195),
    [anon_sym_QMARK] = ACTIONS(7193),
    [anon_sym_TILDE] = ACTIONS(7193),
    [anon_sym_BANG] = ACTIONS(7195),
    [anon_sym_PLUS] = ACTIONS(7193),
    [anon_sym_DASH] = ACTIONS(7195),
    [anon_sym_LT_DASH] = ACTIONS(7193),
    [anon_sym_LT_LT_DASH] = ACTIONS(7193),
    [anon_sym_COLON_EQ] = ACTIONS(7193),
    [anon_sym_DASH_GT] = ACTIONS(7195),
    [anon_sym_DASH_GT_GT] = ACTIONS(7193),
    [anon_sym_PIPE] = ACTIONS(7195),
    [anon_sym_AMP] = ACTIONS(7195),
    [anon_sym_PIPE_PIPE] = ACTIONS(7193),
    [anon_sym_AMP_AMP] = ACTIONS(7193),
    [anon_sym_LT] = ACTIONS(7195),
    [anon_sym_LT_EQ] = ACTIONS(7193),
    [anon_sym_GT] = ACTIONS(7195),
    [anon_sym_GT_EQ] = ACTIONS(7193),
    [anon_sym_EQ_EQ] = ACTIONS(7193),
    [anon_sym_BANG_EQ] = ACTIONS(7193),
    [anon_sym_STAR] = ACTIONS(7195),
    [anon_sym_SLASH] = ACTIONS(7193),
    [anon_sym_STAR_STAR] = ACTIONS(7193),
    [anon_sym_CARET] = ACTIONS(7193),
    [aux_sym_binary_operator_token1] = ACTIONS(7193),
    [anon_sym_PIPE_GT] = ACTIONS(7193),
    [anon_sym_COLON] = ACTIONS(7195),
    [anon_sym_DOLLAR] = ACTIONS(7193),
    [anon_sym_AT] = ACTIONS(7193),
    [anon_sym_COLON_COLON] = ACTIONS(7195),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7193),
    [aux_sym__hex_literal_token1] = ACTIONS(7193),
    [sym__number_literal] = ACTIONS(7195),
    [anon_sym_SQUOTE] = ACTIONS(7193),
    [anon_sym_DQUOTE] = ACTIONS(7193),
    [sym_return] = ACTIONS(7195),
    [sym_next] = ACTIONS(7195),
    [sym_break] = ACTIONS(7195),
    [sym_true] = ACTIONS(7195),
    [sym_false] = ACTIONS(7195),
    [sym_null] = ACTIONS(7195),
    [sym_inf] = ACTIONS(7195),
    [sym_nan] = ACTIONS(7195),
    [anon_sym_NA] = ACTIONS(7195),
    [anon_sym_NA_integer_] = ACTIONS(7195),
    [anon_sym_NA_real_] = ACTIONS(7195),
    [anon_sym_NA_complex_] = ACTIONS(7195),
    [anon_sym_NA_character_] = ACTIONS(7195),
    [sym_dots] = ACTIONS(7195),
    [sym_dot_dot_i] = ACTIONS(7193),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7193),
    [sym__semicolon] = ACTIONS(7193),
    [sym__raw_string_literal] = ACTIONS(7193),
    [sym__external_else] = ACTIONS(7193),
    [sym__external_open_parenthesis] = ACTIONS(7193),
    [sym__external_close_parenthesis] = ACTIONS(7193),
    [sym__external_open_brace] = ACTIONS(7193),
    [sym__external_open_bracket] = ACTIONS(7193),
    [sym__external_open_bracket2] = ACTIONS(7193),
  },
  [2335] = {
    [ts_builtin_sym_end] = ACTIONS(7189),
    [sym_identifier] = ACTIONS(7191),
    [anon_sym_BSLASH] = ACTIONS(7189),
    [anon_sym_function] = ACTIONS(7191),
    [anon_sym_EQ] = ACTIONS(7191),
    [anon_sym_if] = ACTIONS(7191),
    [anon_sym_for] = ACTIONS(7191),
    [anon_sym_while] = ACTIONS(7191),
    [anon_sym_repeat] = ACTIONS(7191),
    [anon_sym_QMARK] = ACTIONS(7189),
    [anon_sym_TILDE] = ACTIONS(7189),
    [anon_sym_BANG] = ACTIONS(7191),
    [anon_sym_PLUS] = ACTIONS(7189),
    [anon_sym_DASH] = ACTIONS(7191),
    [anon_sym_LT_DASH] = ACTIONS(7189),
    [anon_sym_LT_LT_DASH] = ACTIONS(7189),
    [anon_sym_COLON_EQ] = ACTIONS(7189),
    [anon_sym_DASH_GT] = ACTIONS(7191),
    [anon_sym_DASH_GT_GT] = ACTIONS(7189),
    [anon_sym_PIPE] = ACTIONS(7191),
    [anon_sym_AMP] = ACTIONS(7191),
    [anon_sym_PIPE_PIPE] = ACTIONS(7189),
    [anon_sym_AMP_AMP] = ACTIONS(7189),
    [anon_sym_LT] = ACTIONS(7191),
    [anon_sym_LT_EQ] = ACTIONS(7189),
    [anon_sym_GT] = ACTIONS(7191),
    [anon_sym_GT_EQ] = ACTIONS(7189),
    [anon_sym_EQ_EQ] = ACTIONS(7189),
    [anon_sym_BANG_EQ] = ACTIONS(7189),
    [anon_sym_STAR] = ACTIONS(7191),
    [anon_sym_SLASH] = ACTIONS(7189),
    [anon_sym_STAR_STAR] = ACTIONS(7189),
    [anon_sym_CARET] = ACTIONS(7189),
    [aux_sym_binary_operator_token1] = ACTIONS(7189),
    [anon_sym_PIPE_GT] = ACTIONS(7189),
    [anon_sym_COLON] = ACTIONS(7191),
    [anon_sym_DOLLAR] = ACTIONS(7189),
    [anon_sym_AT] = ACTIONS(7189),
    [anon_sym_COLON_COLON] = ACTIONS(7191),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7189),
    [aux_sym__hex_literal_token1] = ACTIONS(7189),
    [sym__number_literal] = ACTIONS(7191),
    [anon_sym_SQUOTE] = ACTIONS(7189),
    [anon_sym_DQUOTE] = ACTIONS(7189),
    [sym_return] = ACTIONS(7191),
    [sym_next] = ACTIONS(7191),
    [sym_break] = ACTIONS(7191),
    [sym_true] = ACTIONS(7191),
    [sym_false] = ACTIONS(7191),
    [sym_null] = ACTIONS(7191),
    [sym_inf] = ACTIONS(7191),
    [sym_nan] = ACTIONS(7191),
    [anon_sym_NA] = ACTIONS(7191),
    [anon_sym_NA_integer_] = ACTIONS(7191),
    [anon_sym_NA_real_] = ACTIONS(7191),
    [anon_sym_NA_complex_] = ACTIONS(7191),
    [anon_sym_NA_character_] = ACTIONS(7191),
    [sym_dots] = ACTIONS(7191),
    [sym_dot_dot_i] = ACTIONS(7189),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7189),
    [sym__semicolon] = ACTIONS(7189),
    [sym__raw_string_literal] = ACTIONS(7189),
    [sym__external_else] = ACTIONS(7189),
    [sym__external_open_parenthesis] = ACTIONS(7189),
    [sym__external_close_parenthesis] = ACTIONS(7189),
    [sym__external_open_brace] = ACTIONS(7189),
    [sym__external_open_bracket] = ACTIONS(7189),
    [sym__external_open_bracket2] = ACTIONS(7189),
  },
  [2336] = {
    [aux_sym_function_definition_repeat1] = STATE(2336),
    [sym_identifier] = ACTIONS(7419),
    [anon_sym_BSLASH] = ACTIONS(7417),
    [anon_sym_function] = ACTIONS(7419),
    [anon_sym_EQ] = ACTIONS(7419),
    [anon_sym_if] = ACTIONS(7419),
    [anon_sym_for] = ACTIONS(7419),
    [anon_sym_while] = ACTIONS(7419),
    [anon_sym_repeat] = ACTIONS(7419),
    [anon_sym_QMARK] = ACTIONS(7417),
    [anon_sym_TILDE] = ACTIONS(7417),
    [anon_sym_BANG] = ACTIONS(7419),
    [anon_sym_PLUS] = ACTIONS(7417),
    [anon_sym_DASH] = ACTIONS(7419),
    [anon_sym_LT_DASH] = ACTIONS(7417),
    [anon_sym_LT_LT_DASH] = ACTIONS(7417),
    [anon_sym_COLON_EQ] = ACTIONS(7417),
    [anon_sym_DASH_GT] = ACTIONS(7419),
    [anon_sym_DASH_GT_GT] = ACTIONS(7417),
    [anon_sym_PIPE] = ACTIONS(7419),
    [anon_sym_AMP] = ACTIONS(7419),
    [anon_sym_PIPE_PIPE] = ACTIONS(7417),
    [anon_sym_AMP_AMP] = ACTIONS(7417),
    [anon_sym_LT] = ACTIONS(7419),
    [anon_sym_LT_EQ] = ACTIONS(7417),
    [anon_sym_GT] = ACTIONS(7419),
    [anon_sym_GT_EQ] = ACTIONS(7417),
    [anon_sym_EQ_EQ] = ACTIONS(7417),
    [anon_sym_BANG_EQ] = ACTIONS(7417),
    [anon_sym_STAR] = ACTIONS(7419),
    [anon_sym_SLASH] = ACTIONS(7417),
    [anon_sym_STAR_STAR] = ACTIONS(7417),
    [anon_sym_CARET] = ACTIONS(7417),
    [aux_sym_binary_operator_token1] = ACTIONS(7417),
    [anon_sym_PIPE_GT] = ACTIONS(7417),
    [anon_sym_COLON] = ACTIONS(7419),
    [anon_sym_DOLLAR] = ACTIONS(7417),
    [anon_sym_AT] = ACTIONS(7417),
    [aux_sym__hex_literal_token1] = ACTIONS(7417),
    [sym__number_literal] = ACTIONS(7419),
    [anon_sym_SQUOTE] = ACTIONS(7417),
    [anon_sym_DQUOTE] = ACTIONS(7417),
    [sym_return] = ACTIONS(7419),
    [sym_next] = ACTIONS(7419),
    [sym_break] = ACTIONS(7419),
    [sym_true] = ACTIONS(7419),
    [sym_false] = ACTIONS(7419),
    [sym_null] = ACTIONS(7419),
    [sym_inf] = ACTIONS(7419),
    [sym_nan] = ACTIONS(7419),
    [anon_sym_NA] = ACTIONS(7419),
    [anon_sym_NA_integer_] = ACTIONS(7419),
    [anon_sym_NA_real_] = ACTIONS(7419),
    [anon_sym_NA_complex_] = ACTIONS(7419),
    [anon_sym_NA_character_] = ACTIONS(7419),
    [sym_dots] = ACTIONS(7419),
    [sym_dot_dot_i] = ACTIONS(7417),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7417),
    [sym__newline] = ACTIONS(7585),
    [sym__semicolon] = ACTIONS(7417),
    [sym__raw_string_literal] = ACTIONS(7417),
    [sym__external_open_parenthesis] = ACTIONS(7417),
    [sym__external_close_parenthesis] = ACTIONS(7417),
    [sym__external_open_brace] = ACTIONS(7417),
    [sym__external_close_brace] = ACTIONS(7417),
    [sym__external_open_bracket] = ACTIONS(7417),
    [sym__external_close_bracket] = ACTIONS(7417),
    [sym__external_open_bracket2] = ACTIONS(7417),
  },
  [2337] = {
    [sym_identifier] = ACTIONS(7552),
    [anon_sym_BSLASH] = ACTIONS(7550),
    [anon_sym_function] = ACTIONS(7552),
    [anon_sym_EQ] = ACTIONS(7552),
    [anon_sym_if] = ACTIONS(7552),
    [anon_sym_for] = ACTIONS(7552),
    [anon_sym_while] = ACTIONS(7552),
    [anon_sym_repeat] = ACTIONS(7552),
    [anon_sym_QMARK] = ACTIONS(7550),
    [anon_sym_TILDE] = ACTIONS(7550),
    [anon_sym_BANG] = ACTIONS(7552),
    [anon_sym_PLUS] = ACTIONS(7550),
    [anon_sym_DASH] = ACTIONS(7552),
    [anon_sym_LT_DASH] = ACTIONS(7550),
    [anon_sym_LT_LT_DASH] = ACTIONS(7550),
    [anon_sym_COLON_EQ] = ACTIONS(7550),
    [anon_sym_DASH_GT] = ACTIONS(7552),
    [anon_sym_DASH_GT_GT] = ACTIONS(7550),
    [anon_sym_PIPE] = ACTIONS(7552),
    [anon_sym_AMP] = ACTIONS(7552),
    [anon_sym_PIPE_PIPE] = ACTIONS(7550),
    [anon_sym_AMP_AMP] = ACTIONS(7550),
    [anon_sym_LT] = ACTIONS(7552),
    [anon_sym_LT_EQ] = ACTIONS(7550),
    [anon_sym_GT] = ACTIONS(7552),
    [anon_sym_GT_EQ] = ACTIONS(7550),
    [anon_sym_EQ_EQ] = ACTIONS(7550),
    [anon_sym_BANG_EQ] = ACTIONS(7550),
    [anon_sym_STAR] = ACTIONS(7552),
    [anon_sym_SLASH] = ACTIONS(7550),
    [anon_sym_STAR_STAR] = ACTIONS(7550),
    [anon_sym_CARET] = ACTIONS(7550),
    [aux_sym_binary_operator_token1] = ACTIONS(7550),
    [anon_sym_PIPE_GT] = ACTIONS(7550),
    [anon_sym_COLON] = ACTIONS(7552),
    [anon_sym_DOLLAR] = ACTIONS(7550),
    [anon_sym_AT] = ACTIONS(7550),
    [aux_sym__hex_literal_token1] = ACTIONS(7550),
    [sym__number_literal] = ACTIONS(7552),
    [anon_sym_SQUOTE] = ACTIONS(7550),
    [anon_sym_DQUOTE] = ACTIONS(7550),
    [sym_return] = ACTIONS(7552),
    [sym_next] = ACTIONS(7552),
    [sym_break] = ACTIONS(7552),
    [sym_true] = ACTIONS(7552),
    [sym_false] = ACTIONS(7552),
    [sym_null] = ACTIONS(7552),
    [sym_inf] = ACTIONS(7552),
    [sym_nan] = ACTIONS(7552),
    [anon_sym_NA] = ACTIONS(7552),
    [anon_sym_NA_integer_] = ACTIONS(7552),
    [anon_sym_NA_real_] = ACTIONS(7552),
    [anon_sym_NA_complex_] = ACTIONS(7552),
    [anon_sym_NA_character_] = ACTIONS(7552),
    [sym_dots] = ACTIONS(7552),
    [sym_dot_dot_i] = ACTIONS(7550),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7550),
    [sym__newline] = ACTIONS(7550),
    [sym__semicolon] = ACTIONS(7550),
    [sym__raw_string_literal] = ACTIONS(7550),
    [sym__external_else] = ACTIONS(7550),
    [sym__external_open_parenthesis] = ACTIONS(7550),
    [sym__external_close_parenthesis] = ACTIONS(7550),
    [sym__external_open_brace] = ACTIONS(7550),
    [sym__external_close_brace] = ACTIONS(7550),
    [sym__external_open_bracket] = ACTIONS(7550),
    [sym__external_open_bracket2] = ACTIONS(7550),
    [sym__external_close_bracket2] = ACTIONS(7550),
  },
  [2338] = {
    [sym_string] = STATE(3010),
    [sym__single_quoted_string] = STATE(2738),
    [sym__double_quoted_string] = STATE(2737),
    [sym__string_or_identifier] = STATE(3010),
    [ts_builtin_sym_end] = ACTIONS(5883),
    [sym_identifier] = ACTIONS(7588),
    [anon_sym_BSLASH] = ACTIONS(5883),
    [anon_sym_function] = ACTIONS(5887),
    [anon_sym_EQ] = ACTIONS(5887),
    [anon_sym_if] = ACTIONS(5887),
    [anon_sym_for] = ACTIONS(5887),
    [anon_sym_while] = ACTIONS(5887),
    [anon_sym_repeat] = ACTIONS(5887),
    [anon_sym_QMARK] = ACTIONS(5883),
    [anon_sym_TILDE] = ACTIONS(5883),
    [anon_sym_BANG] = ACTIONS(5887),
    [anon_sym_PLUS] = ACTIONS(5883),
    [anon_sym_DASH] = ACTIONS(5887),
    [anon_sym_LT_DASH] = ACTIONS(5883),
    [anon_sym_LT_LT_DASH] = ACTIONS(5883),
    [anon_sym_COLON_EQ] = ACTIONS(5883),
    [anon_sym_DASH_GT] = ACTIONS(5887),
    [anon_sym_DASH_GT_GT] = ACTIONS(5883),
    [anon_sym_PIPE] = ACTIONS(5887),
    [anon_sym_AMP] = ACTIONS(5887),
    [anon_sym_PIPE_PIPE] = ACTIONS(5883),
    [anon_sym_AMP_AMP] = ACTIONS(5883),
    [anon_sym_LT] = ACTIONS(5887),
    [anon_sym_LT_EQ] = ACTIONS(5883),
    [anon_sym_GT] = ACTIONS(5887),
    [anon_sym_GT_EQ] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5883),
    [anon_sym_BANG_EQ] = ACTIONS(5883),
    [anon_sym_STAR] = ACTIONS(5887),
    [anon_sym_SLASH] = ACTIONS(5883),
    [anon_sym_STAR_STAR] = ACTIONS(5883),
    [anon_sym_CARET] = ACTIONS(5883),
    [aux_sym_binary_operator_token1] = ACTIONS(5883),
    [anon_sym_PIPE_GT] = ACTIONS(5883),
    [anon_sym_COLON] = ACTIONS(5887),
    [anon_sym_DOLLAR] = ACTIONS(5883),
    [anon_sym_AT] = ACTIONS(5883),
    [aux_sym__hex_literal_token1] = ACTIONS(5883),
    [sym__number_literal] = ACTIONS(5887),
    [anon_sym_SQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE] = ACTIONS(35),
    [sym_return] = ACTIONS(5887),
    [sym_next] = ACTIONS(5887),
    [sym_break] = ACTIONS(5887),
    [sym_true] = ACTIONS(5887),
    [sym_false] = ACTIONS(5887),
    [sym_null] = ACTIONS(5887),
    [sym_inf] = ACTIONS(5887),
    [sym_nan] = ACTIONS(5887),
    [anon_sym_NA] = ACTIONS(5887),
    [anon_sym_NA_integer_] = ACTIONS(5887),
    [anon_sym_NA_real_] = ACTIONS(5887),
    [anon_sym_NA_complex_] = ACTIONS(5887),
    [anon_sym_NA_character_] = ACTIONS(5887),
    [sym_dots] = ACTIONS(5887),
    [sym_dot_dot_i] = ACTIONS(5883),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5883),
    [sym__semicolon] = ACTIONS(5883),
    [sym__raw_string_literal] = ACTIONS(45),
    [sym__external_open_parenthesis] = ACTIONS(5883),
    [sym__external_open_brace] = ACTIONS(5883),
    [sym__external_open_bracket] = ACTIONS(5883),
    [sym__external_open_bracket2] = ACTIONS(5883),
  },
  [2339] = {
    [sym_identifier] = ACTIONS(7544),
    [anon_sym_BSLASH] = ACTIONS(7542),
    [anon_sym_function] = ACTIONS(7544),
    [anon_sym_EQ] = ACTIONS(7544),
    [anon_sym_if] = ACTIONS(7544),
    [anon_sym_for] = ACTIONS(7544),
    [anon_sym_while] = ACTIONS(7544),
    [anon_sym_repeat] = ACTIONS(7544),
    [anon_sym_QMARK] = ACTIONS(7542),
    [anon_sym_TILDE] = ACTIONS(7542),
    [anon_sym_BANG] = ACTIONS(7544),
    [anon_sym_PLUS] = ACTIONS(7542),
    [anon_sym_DASH] = ACTIONS(7544),
    [anon_sym_LT_DASH] = ACTIONS(7542),
    [anon_sym_LT_LT_DASH] = ACTIONS(7542),
    [anon_sym_COLON_EQ] = ACTIONS(7542),
    [anon_sym_DASH_GT] = ACTIONS(7544),
    [anon_sym_DASH_GT_GT] = ACTIONS(7542),
    [anon_sym_PIPE] = ACTIONS(7544),
    [anon_sym_AMP] = ACTIONS(7544),
    [anon_sym_PIPE_PIPE] = ACTIONS(7542),
    [anon_sym_AMP_AMP] = ACTIONS(7542),
    [anon_sym_LT] = ACTIONS(7544),
    [anon_sym_LT_EQ] = ACTIONS(7542),
    [anon_sym_GT] = ACTIONS(7544),
    [anon_sym_GT_EQ] = ACTIONS(7542),
    [anon_sym_EQ_EQ] = ACTIONS(7542),
    [anon_sym_BANG_EQ] = ACTIONS(7542),
    [anon_sym_STAR] = ACTIONS(7544),
    [anon_sym_SLASH] = ACTIONS(7542),
    [anon_sym_STAR_STAR] = ACTIONS(7542),
    [anon_sym_CARET] = ACTIONS(7542),
    [aux_sym_binary_operator_token1] = ACTIONS(7542),
    [anon_sym_PIPE_GT] = ACTIONS(7542),
    [anon_sym_COLON] = ACTIONS(7544),
    [anon_sym_DOLLAR] = ACTIONS(7542),
    [anon_sym_AT] = ACTIONS(7542),
    [aux_sym__hex_literal_token1] = ACTIONS(7542),
    [sym__number_literal] = ACTIONS(7544),
    [anon_sym_SQUOTE] = ACTIONS(7542),
    [anon_sym_DQUOTE] = ACTIONS(7542),
    [sym_return] = ACTIONS(7544),
    [sym_next] = ACTIONS(7544),
    [sym_break] = ACTIONS(7544),
    [sym_true] = ACTIONS(7544),
    [sym_false] = ACTIONS(7544),
    [sym_null] = ACTIONS(7544),
    [sym_inf] = ACTIONS(7544),
    [sym_nan] = ACTIONS(7544),
    [anon_sym_NA] = ACTIONS(7544),
    [anon_sym_NA_integer_] = ACTIONS(7544),
    [anon_sym_NA_real_] = ACTIONS(7544),
    [anon_sym_NA_complex_] = ACTIONS(7544),
    [anon_sym_NA_character_] = ACTIONS(7544),
    [sym_dots] = ACTIONS(7544),
    [sym_dot_dot_i] = ACTIONS(7542),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7542),
    [sym__newline] = ACTIONS(7542),
    [sym__semicolon] = ACTIONS(7542),
    [sym__raw_string_literal] = ACTIONS(7542),
    [sym__external_else] = ACTIONS(7542),
    [sym__external_open_parenthesis] = ACTIONS(7542),
    [sym__external_close_parenthesis] = ACTIONS(7542),
    [sym__external_open_brace] = ACTIONS(7542),
    [sym__external_close_brace] = ACTIONS(7542),
    [sym__external_open_bracket] = ACTIONS(7542),
    [sym__external_open_bracket2] = ACTIONS(7542),
    [sym__external_close_bracket2] = ACTIONS(7542),
  },
  [2340] = {
    [sym_identifier] = ACTIONS(7540),
    [anon_sym_BSLASH] = ACTIONS(7538),
    [anon_sym_function] = ACTIONS(7540),
    [anon_sym_EQ] = ACTIONS(7540),
    [anon_sym_if] = ACTIONS(7540),
    [anon_sym_for] = ACTIONS(7540),
    [anon_sym_while] = ACTIONS(7540),
    [anon_sym_repeat] = ACTIONS(7540),
    [anon_sym_QMARK] = ACTIONS(7538),
    [anon_sym_TILDE] = ACTIONS(7538),
    [anon_sym_BANG] = ACTIONS(7540),
    [anon_sym_PLUS] = ACTIONS(7538),
    [anon_sym_DASH] = ACTIONS(7540),
    [anon_sym_LT_DASH] = ACTIONS(7538),
    [anon_sym_LT_LT_DASH] = ACTIONS(7538),
    [anon_sym_COLON_EQ] = ACTIONS(7538),
    [anon_sym_DASH_GT] = ACTIONS(7540),
    [anon_sym_DASH_GT_GT] = ACTIONS(7538),
    [anon_sym_PIPE] = ACTIONS(7540),
    [anon_sym_AMP] = ACTIONS(7540),
    [anon_sym_PIPE_PIPE] = ACTIONS(7538),
    [anon_sym_AMP_AMP] = ACTIONS(7538),
    [anon_sym_LT] = ACTIONS(7540),
    [anon_sym_LT_EQ] = ACTIONS(7538),
    [anon_sym_GT] = ACTIONS(7540),
    [anon_sym_GT_EQ] = ACTIONS(7538),
    [anon_sym_EQ_EQ] = ACTIONS(7538),
    [anon_sym_BANG_EQ] = ACTIONS(7538),
    [anon_sym_STAR] = ACTIONS(7540),
    [anon_sym_SLASH] = ACTIONS(7538),
    [anon_sym_STAR_STAR] = ACTIONS(7538),
    [anon_sym_CARET] = ACTIONS(7538),
    [aux_sym_binary_operator_token1] = ACTIONS(7538),
    [anon_sym_PIPE_GT] = ACTIONS(7538),
    [anon_sym_COLON] = ACTIONS(7540),
    [anon_sym_DOLLAR] = ACTIONS(7538),
    [anon_sym_AT] = ACTIONS(7538),
    [aux_sym__hex_literal_token1] = ACTIONS(7538),
    [sym__number_literal] = ACTIONS(7540),
    [anon_sym_SQUOTE] = ACTIONS(7538),
    [anon_sym_DQUOTE] = ACTIONS(7538),
    [sym_return] = ACTIONS(7540),
    [sym_next] = ACTIONS(7540),
    [sym_break] = ACTIONS(7540),
    [sym_true] = ACTIONS(7540),
    [sym_false] = ACTIONS(7540),
    [sym_null] = ACTIONS(7540),
    [sym_inf] = ACTIONS(7540),
    [sym_nan] = ACTIONS(7540),
    [anon_sym_NA] = ACTIONS(7540),
    [anon_sym_NA_integer_] = ACTIONS(7540),
    [anon_sym_NA_real_] = ACTIONS(7540),
    [anon_sym_NA_complex_] = ACTIONS(7540),
    [anon_sym_NA_character_] = ACTIONS(7540),
    [sym_dots] = ACTIONS(7540),
    [sym_dot_dot_i] = ACTIONS(7538),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7538),
    [sym__newline] = ACTIONS(7538),
    [sym__semicolon] = ACTIONS(7538),
    [sym__raw_string_literal] = ACTIONS(7538),
    [sym__external_else] = ACTIONS(7538),
    [sym__external_open_parenthesis] = ACTIONS(7538),
    [sym__external_close_parenthesis] = ACTIONS(7538),
    [sym__external_open_brace] = ACTIONS(7538),
    [sym__external_close_brace] = ACTIONS(7538),
    [sym__external_open_bracket] = ACTIONS(7538),
    [sym__external_open_bracket2] = ACTIONS(7538),
    [sym__external_close_bracket2] = ACTIONS(7538),
  },
  [2341] = {
    [sym_identifier] = ACTIONS(5311),
    [anon_sym_BSLASH] = ACTIONS(5313),
    [anon_sym_function] = ACTIONS(5311),
    [anon_sym_EQ] = ACTIONS(5311),
    [anon_sym_if] = ACTIONS(5311),
    [anon_sym_for] = ACTIONS(5311),
    [anon_sym_while] = ACTIONS(5311),
    [anon_sym_repeat] = ACTIONS(5311),
    [anon_sym_QMARK] = ACTIONS(5313),
    [anon_sym_TILDE] = ACTIONS(5313),
    [anon_sym_BANG] = ACTIONS(5311),
    [anon_sym_PLUS] = ACTIONS(5313),
    [anon_sym_DASH] = ACTIONS(5311),
    [anon_sym_LT_DASH] = ACTIONS(5313),
    [anon_sym_LT_LT_DASH] = ACTIONS(5313),
    [anon_sym_COLON_EQ] = ACTIONS(5313),
    [anon_sym_DASH_GT] = ACTIONS(5311),
    [anon_sym_DASH_GT_GT] = ACTIONS(5313),
    [anon_sym_PIPE] = ACTIONS(5311),
    [anon_sym_AMP] = ACTIONS(5311),
    [anon_sym_PIPE_PIPE] = ACTIONS(5313),
    [anon_sym_AMP_AMP] = ACTIONS(5313),
    [anon_sym_LT] = ACTIONS(5311),
    [anon_sym_LT_EQ] = ACTIONS(5313),
    [anon_sym_GT] = ACTIONS(5311),
    [anon_sym_GT_EQ] = ACTIONS(5313),
    [anon_sym_EQ_EQ] = ACTIONS(5313),
    [anon_sym_BANG_EQ] = ACTIONS(5313),
    [anon_sym_STAR] = ACTIONS(5311),
    [anon_sym_SLASH] = ACTIONS(5313),
    [anon_sym_STAR_STAR] = ACTIONS(5313),
    [anon_sym_CARET] = ACTIONS(5313),
    [aux_sym_binary_operator_token1] = ACTIONS(5313),
    [anon_sym_PIPE_GT] = ACTIONS(5313),
    [anon_sym_COLON] = ACTIONS(5311),
    [anon_sym_DOLLAR] = ACTIONS(5313),
    [anon_sym_AT] = ACTIONS(5313),
    [aux_sym__hex_literal_token1] = ACTIONS(5313),
    [sym__number_literal] = ACTIONS(5311),
    [anon_sym_SQUOTE] = ACTIONS(5313),
    [anon_sym_DQUOTE] = ACTIONS(5313),
    [sym_return] = ACTIONS(5311),
    [sym_next] = ACTIONS(5311),
    [sym_break] = ACTIONS(5311),
    [sym_true] = ACTIONS(5311),
    [sym_false] = ACTIONS(5311),
    [sym_null] = ACTIONS(5311),
    [sym_inf] = ACTIONS(5311),
    [sym_nan] = ACTIONS(5311),
    [anon_sym_NA] = ACTIONS(5311),
    [anon_sym_NA_integer_] = ACTIONS(5311),
    [anon_sym_NA_real_] = ACTIONS(5311),
    [anon_sym_NA_complex_] = ACTIONS(5311),
    [anon_sym_NA_character_] = ACTIONS(5311),
    [sym_dots] = ACTIONS(5311),
    [sym_dot_dot_i] = ACTIONS(5313),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5313),
    [sym__newline] = ACTIONS(5313),
    [sym__semicolon] = ACTIONS(5313),
    [sym__raw_string_literal] = ACTIONS(5313),
    [sym__external_else] = ACTIONS(5313),
    [sym__external_open_parenthesis] = ACTIONS(5313),
    [sym__external_close_parenthesis] = ACTIONS(5313),
    [sym__external_open_brace] = ACTIONS(5313),
    [sym__external_close_brace] = ACTIONS(5313),
    [sym__external_open_bracket] = ACTIONS(5313),
    [sym__external_open_bracket2] = ACTIONS(5313),
    [sym__external_close_bracket2] = ACTIONS(5313),
  },
  [2342] = {
    [sym_identifier] = ACTIONS(7532),
    [anon_sym_BSLASH] = ACTIONS(7530),
    [anon_sym_function] = ACTIONS(7532),
    [anon_sym_EQ] = ACTIONS(7532),
    [anon_sym_if] = ACTIONS(7532),
    [anon_sym_for] = ACTIONS(7532),
    [anon_sym_while] = ACTIONS(7532),
    [anon_sym_repeat] = ACTIONS(7532),
    [anon_sym_QMARK] = ACTIONS(7530),
    [anon_sym_TILDE] = ACTIONS(7530),
    [anon_sym_BANG] = ACTIONS(7532),
    [anon_sym_PLUS] = ACTIONS(7530),
    [anon_sym_DASH] = ACTIONS(7532),
    [anon_sym_LT_DASH] = ACTIONS(7530),
    [anon_sym_LT_LT_DASH] = ACTIONS(7530),
    [anon_sym_COLON_EQ] = ACTIONS(7530),
    [anon_sym_DASH_GT] = ACTIONS(7532),
    [anon_sym_DASH_GT_GT] = ACTIONS(7530),
    [anon_sym_PIPE] = ACTIONS(7532),
    [anon_sym_AMP] = ACTIONS(7532),
    [anon_sym_PIPE_PIPE] = ACTIONS(7530),
    [anon_sym_AMP_AMP] = ACTIONS(7530),
    [anon_sym_LT] = ACTIONS(7532),
    [anon_sym_LT_EQ] = ACTIONS(7530),
    [anon_sym_GT] = ACTIONS(7532),
    [anon_sym_GT_EQ] = ACTIONS(7530),
    [anon_sym_EQ_EQ] = ACTIONS(7530),
    [anon_sym_BANG_EQ] = ACTIONS(7530),
    [anon_sym_STAR] = ACTIONS(7532),
    [anon_sym_SLASH] = ACTIONS(7530),
    [anon_sym_STAR_STAR] = ACTIONS(7530),
    [anon_sym_CARET] = ACTIONS(7530),
    [aux_sym_binary_operator_token1] = ACTIONS(7530),
    [anon_sym_PIPE_GT] = ACTIONS(7530),
    [anon_sym_COLON] = ACTIONS(7532),
    [anon_sym_DOLLAR] = ACTIONS(7530),
    [anon_sym_AT] = ACTIONS(7530),
    [aux_sym__hex_literal_token1] = ACTIONS(7530),
    [sym__number_literal] = ACTIONS(7532),
    [anon_sym_SQUOTE] = ACTIONS(7530),
    [anon_sym_DQUOTE] = ACTIONS(7530),
    [sym_return] = ACTIONS(7532),
    [sym_next] = ACTIONS(7532),
    [sym_break] = ACTIONS(7532),
    [sym_true] = ACTIONS(7532),
    [sym_false] = ACTIONS(7532),
    [sym_null] = ACTIONS(7532),
    [sym_inf] = ACTIONS(7532),
    [sym_nan] = ACTIONS(7532),
    [anon_sym_NA] = ACTIONS(7532),
    [anon_sym_NA_integer_] = ACTIONS(7532),
    [anon_sym_NA_real_] = ACTIONS(7532),
    [anon_sym_NA_complex_] = ACTIONS(7532),
    [anon_sym_NA_character_] = ACTIONS(7532),
    [sym_dots] = ACTIONS(7532),
    [sym_dot_dot_i] = ACTIONS(7530),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7530),
    [sym__newline] = ACTIONS(7530),
    [sym__semicolon] = ACTIONS(7530),
    [sym__raw_string_literal] = ACTIONS(7530),
    [sym__external_else] = ACTIONS(7530),
    [sym__external_open_parenthesis] = ACTIONS(7530),
    [sym__external_close_parenthesis] = ACTIONS(7530),
    [sym__external_open_brace] = ACTIONS(7530),
    [sym__external_close_brace] = ACTIONS(7530),
    [sym__external_open_bracket] = ACTIONS(7530),
    [sym__external_open_bracket2] = ACTIONS(7530),
    [sym__external_close_bracket2] = ACTIONS(7530),
  },
  [2343] = {
    [sym_identifier] = ACTIONS(7528),
    [anon_sym_BSLASH] = ACTIONS(7526),
    [anon_sym_function] = ACTIONS(7528),
    [anon_sym_EQ] = ACTIONS(7528),
    [anon_sym_if] = ACTIONS(7528),
    [anon_sym_for] = ACTIONS(7528),
    [anon_sym_while] = ACTIONS(7528),
    [anon_sym_repeat] = ACTIONS(7528),
    [anon_sym_QMARK] = ACTIONS(7526),
    [anon_sym_TILDE] = ACTIONS(7526),
    [anon_sym_BANG] = ACTIONS(7528),
    [anon_sym_PLUS] = ACTIONS(7526),
    [anon_sym_DASH] = ACTIONS(7528),
    [anon_sym_LT_DASH] = ACTIONS(7526),
    [anon_sym_LT_LT_DASH] = ACTIONS(7526),
    [anon_sym_COLON_EQ] = ACTIONS(7526),
    [anon_sym_DASH_GT] = ACTIONS(7528),
    [anon_sym_DASH_GT_GT] = ACTIONS(7526),
    [anon_sym_PIPE] = ACTIONS(7528),
    [anon_sym_AMP] = ACTIONS(7528),
    [anon_sym_PIPE_PIPE] = ACTIONS(7526),
    [anon_sym_AMP_AMP] = ACTIONS(7526),
    [anon_sym_LT] = ACTIONS(7528),
    [anon_sym_LT_EQ] = ACTIONS(7526),
    [anon_sym_GT] = ACTIONS(7528),
    [anon_sym_GT_EQ] = ACTIONS(7526),
    [anon_sym_EQ_EQ] = ACTIONS(7526),
    [anon_sym_BANG_EQ] = ACTIONS(7526),
    [anon_sym_STAR] = ACTIONS(7528),
    [anon_sym_SLASH] = ACTIONS(7526),
    [anon_sym_STAR_STAR] = ACTIONS(7526),
    [anon_sym_CARET] = ACTIONS(7526),
    [aux_sym_binary_operator_token1] = ACTIONS(7526),
    [anon_sym_PIPE_GT] = ACTIONS(7526),
    [anon_sym_COLON] = ACTIONS(7528),
    [anon_sym_DOLLAR] = ACTIONS(7526),
    [anon_sym_AT] = ACTIONS(7526),
    [aux_sym__hex_literal_token1] = ACTIONS(7526),
    [sym__number_literal] = ACTIONS(7528),
    [anon_sym_SQUOTE] = ACTIONS(7526),
    [anon_sym_DQUOTE] = ACTIONS(7526),
    [sym_return] = ACTIONS(7528),
    [sym_next] = ACTIONS(7528),
    [sym_break] = ACTIONS(7528),
    [sym_true] = ACTIONS(7528),
    [sym_false] = ACTIONS(7528),
    [sym_null] = ACTIONS(7528),
    [sym_inf] = ACTIONS(7528),
    [sym_nan] = ACTIONS(7528),
    [anon_sym_NA] = ACTIONS(7528),
    [anon_sym_NA_integer_] = ACTIONS(7528),
    [anon_sym_NA_real_] = ACTIONS(7528),
    [anon_sym_NA_complex_] = ACTIONS(7528),
    [anon_sym_NA_character_] = ACTIONS(7528),
    [sym_dots] = ACTIONS(7528),
    [sym_dot_dot_i] = ACTIONS(7526),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7526),
    [sym__newline] = ACTIONS(7526),
    [sym__semicolon] = ACTIONS(7526),
    [sym__raw_string_literal] = ACTIONS(7526),
    [sym__external_else] = ACTIONS(7526),
    [sym__external_open_parenthesis] = ACTIONS(7526),
    [sym__external_close_parenthesis] = ACTIONS(7526),
    [sym__external_open_brace] = ACTIONS(7526),
    [sym__external_close_brace] = ACTIONS(7526),
    [sym__external_open_bracket] = ACTIONS(7526),
    [sym__external_open_bracket2] = ACTIONS(7526),
    [sym__external_close_bracket2] = ACTIONS(7526),
  },
  [2344] = {
    [ts_builtin_sym_end] = ACTIONS(7165),
    [sym_identifier] = ACTIONS(7163),
    [anon_sym_BSLASH] = ACTIONS(7165),
    [anon_sym_function] = ACTIONS(7163),
    [anon_sym_EQ] = ACTIONS(7163),
    [anon_sym_if] = ACTIONS(7163),
    [anon_sym_for] = ACTIONS(7163),
    [anon_sym_while] = ACTIONS(7163),
    [anon_sym_repeat] = ACTIONS(7163),
    [anon_sym_QMARK] = ACTIONS(7165),
    [anon_sym_TILDE] = ACTIONS(7165),
    [anon_sym_BANG] = ACTIONS(7163),
    [anon_sym_PLUS] = ACTIONS(7165),
    [anon_sym_DASH] = ACTIONS(7163),
    [anon_sym_LT_DASH] = ACTIONS(7165),
    [anon_sym_LT_LT_DASH] = ACTIONS(7165),
    [anon_sym_COLON_EQ] = ACTIONS(7165),
    [anon_sym_DASH_GT] = ACTIONS(7163),
    [anon_sym_DASH_GT_GT] = ACTIONS(7165),
    [anon_sym_PIPE] = ACTIONS(7163),
    [anon_sym_AMP] = ACTIONS(7163),
    [anon_sym_PIPE_PIPE] = ACTIONS(7165),
    [anon_sym_AMP_AMP] = ACTIONS(7165),
    [anon_sym_LT] = ACTIONS(7163),
    [anon_sym_LT_EQ] = ACTIONS(7165),
    [anon_sym_GT] = ACTIONS(7163),
    [anon_sym_GT_EQ] = ACTIONS(7165),
    [anon_sym_EQ_EQ] = ACTIONS(7165),
    [anon_sym_BANG_EQ] = ACTIONS(7165),
    [anon_sym_STAR] = ACTIONS(7163),
    [anon_sym_SLASH] = ACTIONS(7165),
    [anon_sym_STAR_STAR] = ACTIONS(7165),
    [anon_sym_CARET] = ACTIONS(7165),
    [aux_sym_binary_operator_token1] = ACTIONS(7165),
    [anon_sym_PIPE_GT] = ACTIONS(7165),
    [anon_sym_COLON] = ACTIONS(7163),
    [anon_sym_DOLLAR] = ACTIONS(7165),
    [anon_sym_AT] = ACTIONS(7165),
    [anon_sym_COLON_COLON] = ACTIONS(7163),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7165),
    [aux_sym__hex_literal_token1] = ACTIONS(7165),
    [sym__number_literal] = ACTIONS(7163),
    [anon_sym_SQUOTE] = ACTIONS(7165),
    [anon_sym_DQUOTE] = ACTIONS(7165),
    [sym_return] = ACTIONS(7163),
    [sym_next] = ACTIONS(7163),
    [sym_break] = ACTIONS(7163),
    [sym_true] = ACTIONS(7163),
    [sym_false] = ACTIONS(7163),
    [sym_null] = ACTIONS(7163),
    [sym_inf] = ACTIONS(7163),
    [sym_nan] = ACTIONS(7163),
    [anon_sym_NA] = ACTIONS(7163),
    [anon_sym_NA_integer_] = ACTIONS(7163),
    [anon_sym_NA_real_] = ACTIONS(7163),
    [anon_sym_NA_complex_] = ACTIONS(7163),
    [anon_sym_NA_character_] = ACTIONS(7163),
    [sym_dots] = ACTIONS(7163),
    [sym_dot_dot_i] = ACTIONS(7165),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7165),
    [sym__semicolon] = ACTIONS(7165),
    [sym__raw_string_literal] = ACTIONS(7165),
    [sym__external_else] = ACTIONS(7165),
    [sym__external_open_parenthesis] = ACTIONS(7165),
    [sym__external_close_parenthesis] = ACTIONS(7165),
    [sym__external_open_brace] = ACTIONS(7165),
    [sym__external_open_bracket] = ACTIONS(7165),
    [sym__external_open_bracket2] = ACTIONS(7165),
  },
  [2345] = {
    [ts_builtin_sym_end] = ACTIONS(7153),
    [sym_identifier] = ACTIONS(7151),
    [anon_sym_BSLASH] = ACTIONS(7153),
    [anon_sym_function] = ACTIONS(7151),
    [anon_sym_EQ] = ACTIONS(7151),
    [anon_sym_if] = ACTIONS(7151),
    [anon_sym_for] = ACTIONS(7151),
    [anon_sym_while] = ACTIONS(7151),
    [anon_sym_repeat] = ACTIONS(7151),
    [anon_sym_QMARK] = ACTIONS(7153),
    [anon_sym_TILDE] = ACTIONS(7153),
    [anon_sym_BANG] = ACTIONS(7151),
    [anon_sym_PLUS] = ACTIONS(7153),
    [anon_sym_DASH] = ACTIONS(7151),
    [anon_sym_LT_DASH] = ACTIONS(7153),
    [anon_sym_LT_LT_DASH] = ACTIONS(7153),
    [anon_sym_COLON_EQ] = ACTIONS(7153),
    [anon_sym_DASH_GT] = ACTIONS(7151),
    [anon_sym_DASH_GT_GT] = ACTIONS(7153),
    [anon_sym_PIPE] = ACTIONS(7151),
    [anon_sym_AMP] = ACTIONS(7151),
    [anon_sym_PIPE_PIPE] = ACTIONS(7153),
    [anon_sym_AMP_AMP] = ACTIONS(7153),
    [anon_sym_LT] = ACTIONS(7151),
    [anon_sym_LT_EQ] = ACTIONS(7153),
    [anon_sym_GT] = ACTIONS(7151),
    [anon_sym_GT_EQ] = ACTIONS(7153),
    [anon_sym_EQ_EQ] = ACTIONS(7153),
    [anon_sym_BANG_EQ] = ACTIONS(7153),
    [anon_sym_STAR] = ACTIONS(7151),
    [anon_sym_SLASH] = ACTIONS(7153),
    [anon_sym_STAR_STAR] = ACTIONS(7153),
    [anon_sym_CARET] = ACTIONS(7153),
    [aux_sym_binary_operator_token1] = ACTIONS(7153),
    [anon_sym_PIPE_GT] = ACTIONS(7153),
    [anon_sym_COLON] = ACTIONS(7151),
    [anon_sym_DOLLAR] = ACTIONS(7153),
    [anon_sym_AT] = ACTIONS(7153),
    [anon_sym_COLON_COLON] = ACTIONS(7151),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7153),
    [aux_sym__hex_literal_token1] = ACTIONS(7153),
    [sym__number_literal] = ACTIONS(7151),
    [anon_sym_SQUOTE] = ACTIONS(7153),
    [anon_sym_DQUOTE] = ACTIONS(7153),
    [sym_return] = ACTIONS(7151),
    [sym_next] = ACTIONS(7151),
    [sym_break] = ACTIONS(7151),
    [sym_true] = ACTIONS(7151),
    [sym_false] = ACTIONS(7151),
    [sym_null] = ACTIONS(7151),
    [sym_inf] = ACTIONS(7151),
    [sym_nan] = ACTIONS(7151),
    [anon_sym_NA] = ACTIONS(7151),
    [anon_sym_NA_integer_] = ACTIONS(7151),
    [anon_sym_NA_real_] = ACTIONS(7151),
    [anon_sym_NA_complex_] = ACTIONS(7151),
    [anon_sym_NA_character_] = ACTIONS(7151),
    [sym_dots] = ACTIONS(7151),
    [sym_dot_dot_i] = ACTIONS(7153),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7153),
    [sym__semicolon] = ACTIONS(7153),
    [sym__raw_string_literal] = ACTIONS(7153),
    [sym__external_else] = ACTIONS(7153),
    [sym__external_open_parenthesis] = ACTIONS(7153),
    [sym__external_close_parenthesis] = ACTIONS(7153),
    [sym__external_open_brace] = ACTIONS(7153),
    [sym__external_open_bracket] = ACTIONS(7153),
    [sym__external_open_bracket2] = ACTIONS(7153),
  },
  [2346] = {
    [sym_identifier] = ACTIONS(7524),
    [anon_sym_BSLASH] = ACTIONS(7522),
    [anon_sym_function] = ACTIONS(7524),
    [anon_sym_EQ] = ACTIONS(7524),
    [anon_sym_if] = ACTIONS(7524),
    [anon_sym_for] = ACTIONS(7524),
    [anon_sym_while] = ACTIONS(7524),
    [anon_sym_repeat] = ACTIONS(7524),
    [anon_sym_QMARK] = ACTIONS(7522),
    [anon_sym_TILDE] = ACTIONS(7522),
    [anon_sym_BANG] = ACTIONS(7524),
    [anon_sym_PLUS] = ACTIONS(7522),
    [anon_sym_DASH] = ACTIONS(7524),
    [anon_sym_LT_DASH] = ACTIONS(7522),
    [anon_sym_LT_LT_DASH] = ACTIONS(7522),
    [anon_sym_COLON_EQ] = ACTIONS(7522),
    [anon_sym_DASH_GT] = ACTIONS(7524),
    [anon_sym_DASH_GT_GT] = ACTIONS(7522),
    [anon_sym_PIPE] = ACTIONS(7524),
    [anon_sym_AMP] = ACTIONS(7524),
    [anon_sym_PIPE_PIPE] = ACTIONS(7522),
    [anon_sym_AMP_AMP] = ACTIONS(7522),
    [anon_sym_LT] = ACTIONS(7524),
    [anon_sym_LT_EQ] = ACTIONS(7522),
    [anon_sym_GT] = ACTIONS(7524),
    [anon_sym_GT_EQ] = ACTIONS(7522),
    [anon_sym_EQ_EQ] = ACTIONS(7522),
    [anon_sym_BANG_EQ] = ACTIONS(7522),
    [anon_sym_STAR] = ACTIONS(7524),
    [anon_sym_SLASH] = ACTIONS(7522),
    [anon_sym_STAR_STAR] = ACTIONS(7522),
    [anon_sym_CARET] = ACTIONS(7522),
    [aux_sym_binary_operator_token1] = ACTIONS(7522),
    [anon_sym_PIPE_GT] = ACTIONS(7522),
    [anon_sym_COLON] = ACTIONS(7524),
    [anon_sym_DOLLAR] = ACTIONS(7522),
    [anon_sym_AT] = ACTIONS(7522),
    [aux_sym__hex_literal_token1] = ACTIONS(7522),
    [sym__number_literal] = ACTIONS(7524),
    [anon_sym_SQUOTE] = ACTIONS(7522),
    [anon_sym_DQUOTE] = ACTIONS(7522),
    [sym_return] = ACTIONS(7524),
    [sym_next] = ACTIONS(7524),
    [sym_break] = ACTIONS(7524),
    [sym_true] = ACTIONS(7524),
    [sym_false] = ACTIONS(7524),
    [sym_null] = ACTIONS(7524),
    [sym_inf] = ACTIONS(7524),
    [sym_nan] = ACTIONS(7524),
    [anon_sym_NA] = ACTIONS(7524),
    [anon_sym_NA_integer_] = ACTIONS(7524),
    [anon_sym_NA_real_] = ACTIONS(7524),
    [anon_sym_NA_complex_] = ACTIONS(7524),
    [anon_sym_NA_character_] = ACTIONS(7524),
    [sym_dots] = ACTIONS(7524),
    [sym_dot_dot_i] = ACTIONS(7522),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7522),
    [sym__newline] = ACTIONS(7522),
    [sym__semicolon] = ACTIONS(7522),
    [sym__raw_string_literal] = ACTIONS(7522),
    [sym__external_else] = ACTIONS(7522),
    [sym__external_open_parenthesis] = ACTIONS(7522),
    [sym__external_close_parenthesis] = ACTIONS(7522),
    [sym__external_open_brace] = ACTIONS(7522),
    [sym__external_close_brace] = ACTIONS(7522),
    [sym__external_open_bracket] = ACTIONS(7522),
    [sym__external_open_bracket2] = ACTIONS(7522),
    [sym__external_close_bracket2] = ACTIONS(7522),
  },
  [2347] = {
    [sym_identifier] = ACTIONS(7520),
    [anon_sym_BSLASH] = ACTIONS(7518),
    [anon_sym_function] = ACTIONS(7520),
    [anon_sym_EQ] = ACTIONS(7520),
    [anon_sym_if] = ACTIONS(7520),
    [anon_sym_for] = ACTIONS(7520),
    [anon_sym_while] = ACTIONS(7520),
    [anon_sym_repeat] = ACTIONS(7520),
    [anon_sym_QMARK] = ACTIONS(7518),
    [anon_sym_TILDE] = ACTIONS(7518),
    [anon_sym_BANG] = ACTIONS(7520),
    [anon_sym_PLUS] = ACTIONS(7518),
    [anon_sym_DASH] = ACTIONS(7520),
    [anon_sym_LT_DASH] = ACTIONS(7518),
    [anon_sym_LT_LT_DASH] = ACTIONS(7518),
    [anon_sym_COLON_EQ] = ACTIONS(7518),
    [anon_sym_DASH_GT] = ACTIONS(7520),
    [anon_sym_DASH_GT_GT] = ACTIONS(7518),
    [anon_sym_PIPE] = ACTIONS(7520),
    [anon_sym_AMP] = ACTIONS(7520),
    [anon_sym_PIPE_PIPE] = ACTIONS(7518),
    [anon_sym_AMP_AMP] = ACTIONS(7518),
    [anon_sym_LT] = ACTIONS(7520),
    [anon_sym_LT_EQ] = ACTIONS(7518),
    [anon_sym_GT] = ACTIONS(7520),
    [anon_sym_GT_EQ] = ACTIONS(7518),
    [anon_sym_EQ_EQ] = ACTIONS(7518),
    [anon_sym_BANG_EQ] = ACTIONS(7518),
    [anon_sym_STAR] = ACTIONS(7520),
    [anon_sym_SLASH] = ACTIONS(7518),
    [anon_sym_STAR_STAR] = ACTIONS(7518),
    [anon_sym_CARET] = ACTIONS(7518),
    [aux_sym_binary_operator_token1] = ACTIONS(7518),
    [anon_sym_PIPE_GT] = ACTIONS(7518),
    [anon_sym_COLON] = ACTIONS(7520),
    [anon_sym_DOLLAR] = ACTIONS(7518),
    [anon_sym_AT] = ACTIONS(7518),
    [aux_sym__hex_literal_token1] = ACTIONS(7518),
    [sym__number_literal] = ACTIONS(7520),
    [anon_sym_SQUOTE] = ACTIONS(7518),
    [anon_sym_DQUOTE] = ACTIONS(7518),
    [sym_return] = ACTIONS(7520),
    [sym_next] = ACTIONS(7520),
    [sym_break] = ACTIONS(7520),
    [sym_true] = ACTIONS(7520),
    [sym_false] = ACTIONS(7520),
    [sym_null] = ACTIONS(7520),
    [sym_inf] = ACTIONS(7520),
    [sym_nan] = ACTIONS(7520),
    [anon_sym_NA] = ACTIONS(7520),
    [anon_sym_NA_integer_] = ACTIONS(7520),
    [anon_sym_NA_real_] = ACTIONS(7520),
    [anon_sym_NA_complex_] = ACTIONS(7520),
    [anon_sym_NA_character_] = ACTIONS(7520),
    [sym_dots] = ACTIONS(7520),
    [sym_dot_dot_i] = ACTIONS(7518),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7518),
    [sym__newline] = ACTIONS(7518),
    [sym__semicolon] = ACTIONS(7518),
    [sym__raw_string_literal] = ACTIONS(7518),
    [sym__external_else] = ACTIONS(7518),
    [sym__external_open_parenthesis] = ACTIONS(7518),
    [sym__external_close_parenthesis] = ACTIONS(7518),
    [sym__external_open_brace] = ACTIONS(7518),
    [sym__external_close_brace] = ACTIONS(7518),
    [sym__external_open_bracket] = ACTIONS(7518),
    [sym__external_open_bracket2] = ACTIONS(7518),
    [sym__external_close_bracket2] = ACTIONS(7518),
  },
  [2348] = {
    [sym_identifier] = ACTIONS(7516),
    [anon_sym_BSLASH] = ACTIONS(7514),
    [anon_sym_function] = ACTIONS(7516),
    [anon_sym_EQ] = ACTIONS(7516),
    [anon_sym_if] = ACTIONS(7516),
    [anon_sym_for] = ACTIONS(7516),
    [anon_sym_while] = ACTIONS(7516),
    [anon_sym_repeat] = ACTIONS(7516),
    [anon_sym_QMARK] = ACTIONS(7514),
    [anon_sym_TILDE] = ACTIONS(7514),
    [anon_sym_BANG] = ACTIONS(7516),
    [anon_sym_PLUS] = ACTIONS(7514),
    [anon_sym_DASH] = ACTIONS(7516),
    [anon_sym_LT_DASH] = ACTIONS(7514),
    [anon_sym_LT_LT_DASH] = ACTIONS(7514),
    [anon_sym_COLON_EQ] = ACTIONS(7514),
    [anon_sym_DASH_GT] = ACTIONS(7516),
    [anon_sym_DASH_GT_GT] = ACTIONS(7514),
    [anon_sym_PIPE] = ACTIONS(7516),
    [anon_sym_AMP] = ACTIONS(7516),
    [anon_sym_PIPE_PIPE] = ACTIONS(7514),
    [anon_sym_AMP_AMP] = ACTIONS(7514),
    [anon_sym_LT] = ACTIONS(7516),
    [anon_sym_LT_EQ] = ACTIONS(7514),
    [anon_sym_GT] = ACTIONS(7516),
    [anon_sym_GT_EQ] = ACTIONS(7514),
    [anon_sym_EQ_EQ] = ACTIONS(7514),
    [anon_sym_BANG_EQ] = ACTIONS(7514),
    [anon_sym_STAR] = ACTIONS(7516),
    [anon_sym_SLASH] = ACTIONS(7514),
    [anon_sym_STAR_STAR] = ACTIONS(7514),
    [anon_sym_CARET] = ACTIONS(7514),
    [aux_sym_binary_operator_token1] = ACTIONS(7514),
    [anon_sym_PIPE_GT] = ACTIONS(7514),
    [anon_sym_COLON] = ACTIONS(7516),
    [anon_sym_DOLLAR] = ACTIONS(7514),
    [anon_sym_AT] = ACTIONS(7514),
    [aux_sym__hex_literal_token1] = ACTIONS(7514),
    [sym__number_literal] = ACTIONS(7516),
    [anon_sym_SQUOTE] = ACTIONS(7514),
    [anon_sym_DQUOTE] = ACTIONS(7514),
    [sym_return] = ACTIONS(7516),
    [sym_next] = ACTIONS(7516),
    [sym_break] = ACTIONS(7516),
    [sym_true] = ACTIONS(7516),
    [sym_false] = ACTIONS(7516),
    [sym_null] = ACTIONS(7516),
    [sym_inf] = ACTIONS(7516),
    [sym_nan] = ACTIONS(7516),
    [anon_sym_NA] = ACTIONS(7516),
    [anon_sym_NA_integer_] = ACTIONS(7516),
    [anon_sym_NA_real_] = ACTIONS(7516),
    [anon_sym_NA_complex_] = ACTIONS(7516),
    [anon_sym_NA_character_] = ACTIONS(7516),
    [sym_dots] = ACTIONS(7516),
    [sym_dot_dot_i] = ACTIONS(7514),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7514),
    [sym__newline] = ACTIONS(7514),
    [sym__semicolon] = ACTIONS(7514),
    [sym__raw_string_literal] = ACTIONS(7514),
    [sym__external_else] = ACTIONS(7514),
    [sym__external_open_parenthesis] = ACTIONS(7514),
    [sym__external_close_parenthesis] = ACTIONS(7514),
    [sym__external_open_brace] = ACTIONS(7514),
    [sym__external_close_brace] = ACTIONS(7514),
    [sym__external_open_bracket] = ACTIONS(7514),
    [sym__external_open_bracket2] = ACTIONS(7514),
    [sym__external_close_bracket2] = ACTIONS(7514),
  },
  [2349] = {
    [aux_sym_function_definition_repeat1] = STATE(2349),
    [sym_identifier] = ACTIONS(7419),
    [anon_sym_BSLASH] = ACTIONS(7417),
    [anon_sym_function] = ACTIONS(7419),
    [anon_sym_EQ] = ACTIONS(7419),
    [anon_sym_if] = ACTIONS(7419),
    [anon_sym_for] = ACTIONS(7419),
    [anon_sym_while] = ACTIONS(7419),
    [anon_sym_repeat] = ACTIONS(7419),
    [anon_sym_QMARK] = ACTIONS(7417),
    [anon_sym_TILDE] = ACTIONS(7417),
    [anon_sym_BANG] = ACTIONS(7419),
    [anon_sym_PLUS] = ACTIONS(7417),
    [anon_sym_DASH] = ACTIONS(7419),
    [anon_sym_LT_DASH] = ACTIONS(7417),
    [anon_sym_LT_LT_DASH] = ACTIONS(7417),
    [anon_sym_COLON_EQ] = ACTIONS(7417),
    [anon_sym_DASH_GT] = ACTIONS(7419),
    [anon_sym_DASH_GT_GT] = ACTIONS(7417),
    [anon_sym_PIPE] = ACTIONS(7419),
    [anon_sym_AMP] = ACTIONS(7419),
    [anon_sym_PIPE_PIPE] = ACTIONS(7417),
    [anon_sym_AMP_AMP] = ACTIONS(7417),
    [anon_sym_LT] = ACTIONS(7419),
    [anon_sym_LT_EQ] = ACTIONS(7417),
    [anon_sym_GT] = ACTIONS(7419),
    [anon_sym_GT_EQ] = ACTIONS(7417),
    [anon_sym_EQ_EQ] = ACTIONS(7417),
    [anon_sym_BANG_EQ] = ACTIONS(7417),
    [anon_sym_STAR] = ACTIONS(7419),
    [anon_sym_SLASH] = ACTIONS(7417),
    [anon_sym_STAR_STAR] = ACTIONS(7417),
    [anon_sym_CARET] = ACTIONS(7417),
    [aux_sym_binary_operator_token1] = ACTIONS(7417),
    [anon_sym_PIPE_GT] = ACTIONS(7417),
    [anon_sym_COLON] = ACTIONS(7419),
    [anon_sym_DOLLAR] = ACTIONS(7417),
    [anon_sym_AT] = ACTIONS(7417),
    [aux_sym__hex_literal_token1] = ACTIONS(7417),
    [sym__number_literal] = ACTIONS(7419),
    [anon_sym_SQUOTE] = ACTIONS(7417),
    [anon_sym_DQUOTE] = ACTIONS(7417),
    [sym_return] = ACTIONS(7419),
    [sym_next] = ACTIONS(7419),
    [sym_break] = ACTIONS(7419),
    [sym_true] = ACTIONS(7419),
    [sym_false] = ACTIONS(7419),
    [sym_null] = ACTIONS(7419),
    [sym_inf] = ACTIONS(7419),
    [sym_nan] = ACTIONS(7419),
    [anon_sym_NA] = ACTIONS(7419),
    [anon_sym_NA_integer_] = ACTIONS(7419),
    [anon_sym_NA_real_] = ACTIONS(7419),
    [anon_sym_NA_complex_] = ACTIONS(7419),
    [anon_sym_NA_character_] = ACTIONS(7419),
    [sym_dots] = ACTIONS(7419),
    [sym_dot_dot_i] = ACTIONS(7417),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7417),
    [sym__newline] = ACTIONS(7590),
    [sym__semicolon] = ACTIONS(7417),
    [sym__raw_string_literal] = ACTIONS(7417),
    [sym__external_else] = ACTIONS(7417),
    [sym__external_open_parenthesis] = ACTIONS(7417),
    [sym__external_open_brace] = ACTIONS(7417),
    [sym__external_close_brace] = ACTIONS(7417),
    [sym__external_open_bracket] = ACTIONS(7417),
    [sym__external_open_bracket2] = ACTIONS(7417),
    [sym__external_close_bracket2] = ACTIONS(7417),
  },
  [2350] = {
    [sym_identifier] = ACTIONS(7474),
    [anon_sym_BSLASH] = ACTIONS(7472),
    [anon_sym_function] = ACTIONS(7474),
    [anon_sym_EQ] = ACTIONS(7474),
    [anon_sym_if] = ACTIONS(7474),
    [anon_sym_for] = ACTIONS(7474),
    [anon_sym_while] = ACTIONS(7474),
    [anon_sym_repeat] = ACTIONS(7474),
    [anon_sym_QMARK] = ACTIONS(7472),
    [anon_sym_TILDE] = ACTIONS(7472),
    [anon_sym_BANG] = ACTIONS(7474),
    [anon_sym_PLUS] = ACTIONS(7472),
    [anon_sym_DASH] = ACTIONS(7474),
    [anon_sym_LT_DASH] = ACTIONS(7472),
    [anon_sym_LT_LT_DASH] = ACTIONS(7472),
    [anon_sym_COLON_EQ] = ACTIONS(7472),
    [anon_sym_DASH_GT] = ACTIONS(7474),
    [anon_sym_DASH_GT_GT] = ACTIONS(7472),
    [anon_sym_PIPE] = ACTIONS(7474),
    [anon_sym_AMP] = ACTIONS(7474),
    [anon_sym_PIPE_PIPE] = ACTIONS(7472),
    [anon_sym_AMP_AMP] = ACTIONS(7472),
    [anon_sym_LT] = ACTIONS(7474),
    [anon_sym_LT_EQ] = ACTIONS(7472),
    [anon_sym_GT] = ACTIONS(7474),
    [anon_sym_GT_EQ] = ACTIONS(7472),
    [anon_sym_EQ_EQ] = ACTIONS(7472),
    [anon_sym_BANG_EQ] = ACTIONS(7472),
    [anon_sym_STAR] = ACTIONS(7474),
    [anon_sym_SLASH] = ACTIONS(7472),
    [anon_sym_STAR_STAR] = ACTIONS(7472),
    [anon_sym_CARET] = ACTIONS(7472),
    [aux_sym_binary_operator_token1] = ACTIONS(7472),
    [anon_sym_PIPE_GT] = ACTIONS(7472),
    [anon_sym_COLON] = ACTIONS(7474),
    [anon_sym_DOLLAR] = ACTIONS(7472),
    [anon_sym_AT] = ACTIONS(7472),
    [aux_sym__hex_literal_token1] = ACTIONS(7472),
    [sym__number_literal] = ACTIONS(7474),
    [anon_sym_SQUOTE] = ACTIONS(7472),
    [anon_sym_DQUOTE] = ACTIONS(7472),
    [sym_return] = ACTIONS(7474),
    [sym_next] = ACTIONS(7474),
    [sym_break] = ACTIONS(7474),
    [sym_true] = ACTIONS(7474),
    [sym_false] = ACTIONS(7474),
    [sym_null] = ACTIONS(7474),
    [sym_inf] = ACTIONS(7474),
    [sym_nan] = ACTIONS(7474),
    [anon_sym_NA] = ACTIONS(7474),
    [anon_sym_NA_integer_] = ACTIONS(7474),
    [anon_sym_NA_real_] = ACTIONS(7474),
    [anon_sym_NA_complex_] = ACTIONS(7474),
    [anon_sym_NA_character_] = ACTIONS(7474),
    [sym_dots] = ACTIONS(7474),
    [sym_dot_dot_i] = ACTIONS(7472),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7472),
    [sym__newline] = ACTIONS(7472),
    [sym__semicolon] = ACTIONS(7472),
    [sym__raw_string_literal] = ACTIONS(7472),
    [sym__external_else] = ACTIONS(7472),
    [sym__external_open_parenthesis] = ACTIONS(7472),
    [sym__external_close_parenthesis] = ACTIONS(7472),
    [sym__external_open_brace] = ACTIONS(7472),
    [sym__external_close_brace] = ACTIONS(7472),
    [sym__external_open_bracket] = ACTIONS(7472),
    [sym__external_open_bracket2] = ACTIONS(7472),
    [sym__external_close_bracket2] = ACTIONS(7472),
  },
  [2351] = {
    [sym_identifier] = ACTIONS(7478),
    [anon_sym_BSLASH] = ACTIONS(7476),
    [anon_sym_function] = ACTIONS(7478),
    [anon_sym_EQ] = ACTIONS(7478),
    [anon_sym_if] = ACTIONS(7478),
    [anon_sym_for] = ACTIONS(7478),
    [anon_sym_while] = ACTIONS(7478),
    [anon_sym_repeat] = ACTIONS(7478),
    [anon_sym_QMARK] = ACTIONS(7476),
    [anon_sym_TILDE] = ACTIONS(7476),
    [anon_sym_BANG] = ACTIONS(7478),
    [anon_sym_PLUS] = ACTIONS(7476),
    [anon_sym_DASH] = ACTIONS(7478),
    [anon_sym_LT_DASH] = ACTIONS(7476),
    [anon_sym_LT_LT_DASH] = ACTIONS(7476),
    [anon_sym_COLON_EQ] = ACTIONS(7476),
    [anon_sym_DASH_GT] = ACTIONS(7478),
    [anon_sym_DASH_GT_GT] = ACTIONS(7476),
    [anon_sym_PIPE] = ACTIONS(7478),
    [anon_sym_AMP] = ACTIONS(7478),
    [anon_sym_PIPE_PIPE] = ACTIONS(7476),
    [anon_sym_AMP_AMP] = ACTIONS(7476),
    [anon_sym_LT] = ACTIONS(7478),
    [anon_sym_LT_EQ] = ACTIONS(7476),
    [anon_sym_GT] = ACTIONS(7478),
    [anon_sym_GT_EQ] = ACTIONS(7476),
    [anon_sym_EQ_EQ] = ACTIONS(7476),
    [anon_sym_BANG_EQ] = ACTIONS(7476),
    [anon_sym_STAR] = ACTIONS(7478),
    [anon_sym_SLASH] = ACTIONS(7476),
    [anon_sym_STAR_STAR] = ACTIONS(7476),
    [anon_sym_CARET] = ACTIONS(7476),
    [aux_sym_binary_operator_token1] = ACTIONS(7476),
    [anon_sym_PIPE_GT] = ACTIONS(7476),
    [anon_sym_COLON] = ACTIONS(7478),
    [anon_sym_DOLLAR] = ACTIONS(7476),
    [anon_sym_AT] = ACTIONS(7476),
    [aux_sym__hex_literal_token1] = ACTIONS(7476),
    [sym__number_literal] = ACTIONS(7478),
    [anon_sym_SQUOTE] = ACTIONS(7476),
    [anon_sym_DQUOTE] = ACTIONS(7476),
    [sym_return] = ACTIONS(7478),
    [sym_next] = ACTIONS(7478),
    [sym_break] = ACTIONS(7478),
    [sym_true] = ACTIONS(7478),
    [sym_false] = ACTIONS(7478),
    [sym_null] = ACTIONS(7478),
    [sym_inf] = ACTIONS(7478),
    [sym_nan] = ACTIONS(7478),
    [anon_sym_NA] = ACTIONS(7478),
    [anon_sym_NA_integer_] = ACTIONS(7478),
    [anon_sym_NA_real_] = ACTIONS(7478),
    [anon_sym_NA_complex_] = ACTIONS(7478),
    [anon_sym_NA_character_] = ACTIONS(7478),
    [sym_dots] = ACTIONS(7478),
    [sym_dot_dot_i] = ACTIONS(7476),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7476),
    [sym__newline] = ACTIONS(7476),
    [sym__semicolon] = ACTIONS(7476),
    [sym__raw_string_literal] = ACTIONS(7476),
    [sym__external_else] = ACTIONS(7476),
    [sym__external_open_parenthesis] = ACTIONS(7476),
    [sym__external_close_parenthesis] = ACTIONS(7476),
    [sym__external_open_brace] = ACTIONS(7476),
    [sym__external_close_brace] = ACTIONS(7476),
    [sym__external_open_bracket] = ACTIONS(7476),
    [sym__external_open_bracket2] = ACTIONS(7476),
    [sym__external_close_bracket2] = ACTIONS(7476),
  },
  [2352] = {
    [sym_identifier] = ACTIONS(7482),
    [anon_sym_BSLASH] = ACTIONS(7480),
    [anon_sym_function] = ACTIONS(7482),
    [anon_sym_EQ] = ACTIONS(7482),
    [anon_sym_if] = ACTIONS(7482),
    [anon_sym_for] = ACTIONS(7482),
    [anon_sym_while] = ACTIONS(7482),
    [anon_sym_repeat] = ACTIONS(7482),
    [anon_sym_QMARK] = ACTIONS(7480),
    [anon_sym_TILDE] = ACTIONS(7480),
    [anon_sym_BANG] = ACTIONS(7482),
    [anon_sym_PLUS] = ACTIONS(7480),
    [anon_sym_DASH] = ACTIONS(7482),
    [anon_sym_LT_DASH] = ACTIONS(7480),
    [anon_sym_LT_LT_DASH] = ACTIONS(7480),
    [anon_sym_COLON_EQ] = ACTIONS(7480),
    [anon_sym_DASH_GT] = ACTIONS(7482),
    [anon_sym_DASH_GT_GT] = ACTIONS(7480),
    [anon_sym_PIPE] = ACTIONS(7482),
    [anon_sym_AMP] = ACTIONS(7482),
    [anon_sym_PIPE_PIPE] = ACTIONS(7480),
    [anon_sym_AMP_AMP] = ACTIONS(7480),
    [anon_sym_LT] = ACTIONS(7482),
    [anon_sym_LT_EQ] = ACTIONS(7480),
    [anon_sym_GT] = ACTIONS(7482),
    [anon_sym_GT_EQ] = ACTIONS(7480),
    [anon_sym_EQ_EQ] = ACTIONS(7480),
    [anon_sym_BANG_EQ] = ACTIONS(7480),
    [anon_sym_STAR] = ACTIONS(7482),
    [anon_sym_SLASH] = ACTIONS(7480),
    [anon_sym_STAR_STAR] = ACTIONS(7480),
    [anon_sym_CARET] = ACTIONS(7480),
    [aux_sym_binary_operator_token1] = ACTIONS(7480),
    [anon_sym_PIPE_GT] = ACTIONS(7480),
    [anon_sym_COLON] = ACTIONS(7482),
    [anon_sym_DOLLAR] = ACTIONS(7480),
    [anon_sym_AT] = ACTIONS(7480),
    [aux_sym__hex_literal_token1] = ACTIONS(7480),
    [sym__number_literal] = ACTIONS(7482),
    [anon_sym_SQUOTE] = ACTIONS(7480),
    [anon_sym_DQUOTE] = ACTIONS(7480),
    [sym_return] = ACTIONS(7482),
    [sym_next] = ACTIONS(7482),
    [sym_break] = ACTIONS(7482),
    [sym_true] = ACTIONS(7482),
    [sym_false] = ACTIONS(7482),
    [sym_null] = ACTIONS(7482),
    [sym_inf] = ACTIONS(7482),
    [sym_nan] = ACTIONS(7482),
    [anon_sym_NA] = ACTIONS(7482),
    [anon_sym_NA_integer_] = ACTIONS(7482),
    [anon_sym_NA_real_] = ACTIONS(7482),
    [anon_sym_NA_complex_] = ACTIONS(7482),
    [anon_sym_NA_character_] = ACTIONS(7482),
    [sym_dots] = ACTIONS(7482),
    [sym_dot_dot_i] = ACTIONS(7480),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7480),
    [sym__newline] = ACTIONS(7480),
    [sym__semicolon] = ACTIONS(7480),
    [sym__raw_string_literal] = ACTIONS(7480),
    [sym__external_else] = ACTIONS(7480),
    [sym__external_open_parenthesis] = ACTIONS(7480),
    [sym__external_close_parenthesis] = ACTIONS(7480),
    [sym__external_open_brace] = ACTIONS(7480),
    [sym__external_close_brace] = ACTIONS(7480),
    [sym__external_open_bracket] = ACTIONS(7480),
    [sym__external_open_bracket2] = ACTIONS(7480),
    [sym__external_close_bracket2] = ACTIONS(7480),
  },
  [2353] = {
    [sym_string] = STATE(3002),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym__string_or_identifier] = STATE(3002),
    [sym_identifier] = ACTIONS(7593),
    [anon_sym_BSLASH] = ACTIONS(5883),
    [anon_sym_function] = ACTIONS(5887),
    [anon_sym_EQ] = ACTIONS(5887),
    [anon_sym_if] = ACTIONS(5887),
    [anon_sym_for] = ACTIONS(5887),
    [anon_sym_while] = ACTIONS(5887),
    [anon_sym_repeat] = ACTIONS(5887),
    [anon_sym_QMARK] = ACTIONS(5883),
    [anon_sym_TILDE] = ACTIONS(5883),
    [anon_sym_BANG] = ACTIONS(5887),
    [anon_sym_PLUS] = ACTIONS(5883),
    [anon_sym_DASH] = ACTIONS(5887),
    [anon_sym_LT_DASH] = ACTIONS(5883),
    [anon_sym_LT_LT_DASH] = ACTIONS(5883),
    [anon_sym_COLON_EQ] = ACTIONS(5883),
    [anon_sym_DASH_GT] = ACTIONS(5887),
    [anon_sym_DASH_GT_GT] = ACTIONS(5883),
    [anon_sym_PIPE] = ACTIONS(5887),
    [anon_sym_AMP] = ACTIONS(5887),
    [anon_sym_PIPE_PIPE] = ACTIONS(5883),
    [anon_sym_AMP_AMP] = ACTIONS(5883),
    [anon_sym_LT] = ACTIONS(5887),
    [anon_sym_LT_EQ] = ACTIONS(5883),
    [anon_sym_GT] = ACTIONS(5887),
    [anon_sym_GT_EQ] = ACTIONS(5883),
    [anon_sym_EQ_EQ] = ACTIONS(5883),
    [anon_sym_BANG_EQ] = ACTIONS(5883),
    [anon_sym_STAR] = ACTIONS(5887),
    [anon_sym_SLASH] = ACTIONS(5883),
    [anon_sym_STAR_STAR] = ACTIONS(5883),
    [anon_sym_CARET] = ACTIONS(5883),
    [aux_sym_binary_operator_token1] = ACTIONS(5883),
    [anon_sym_PIPE_GT] = ACTIONS(5883),
    [anon_sym_COLON] = ACTIONS(5887),
    [anon_sym_DOLLAR] = ACTIONS(5883),
    [anon_sym_AT] = ACTIONS(5883),
    [aux_sym__hex_literal_token1] = ACTIONS(5883),
    [sym__number_literal] = ACTIONS(5887),
    [anon_sym_SQUOTE] = ACTIONS(4780),
    [anon_sym_DQUOTE] = ACTIONS(4782),
    [sym_return] = ACTIONS(5887),
    [sym_next] = ACTIONS(5887),
    [sym_break] = ACTIONS(5887),
    [sym_true] = ACTIONS(5887),
    [sym_false] = ACTIONS(5887),
    [sym_null] = ACTIONS(5887),
    [sym_inf] = ACTIONS(5887),
    [sym_nan] = ACTIONS(5887),
    [anon_sym_NA] = ACTIONS(5887),
    [anon_sym_NA_integer_] = ACTIONS(5887),
    [anon_sym_NA_real_] = ACTIONS(5887),
    [anon_sym_NA_complex_] = ACTIONS(5887),
    [anon_sym_NA_character_] = ACTIONS(5887),
    [sym_dots] = ACTIONS(5887),
    [sym_dot_dot_i] = ACTIONS(5883),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5883),
    [sym__newline] = ACTIONS(5883),
    [sym__raw_string_literal] = ACTIONS(4790),
    [sym__external_open_parenthesis] = ACTIONS(5883),
    [sym__external_open_brace] = ACTIONS(5883),
    [sym__external_open_bracket] = ACTIONS(5883),
    [sym__external_close_bracket] = ACTIONS(5883),
    [sym__external_open_bracket2] = ACTIONS(5883),
  },
  [2354] = {
    [ts_builtin_sym_end] = ACTIONS(7117),
    [sym_identifier] = ACTIONS(7115),
    [anon_sym_BSLASH] = ACTIONS(7117),
    [anon_sym_function] = ACTIONS(7115),
    [anon_sym_EQ] = ACTIONS(7115),
    [anon_sym_if] = ACTIONS(7115),
    [anon_sym_for] = ACTIONS(7115),
    [anon_sym_while] = ACTIONS(7115),
    [anon_sym_repeat] = ACTIONS(7115),
    [anon_sym_QMARK] = ACTIONS(7117),
    [anon_sym_TILDE] = ACTIONS(7117),
    [anon_sym_BANG] = ACTIONS(7115),
    [anon_sym_PLUS] = ACTIONS(7117),
    [anon_sym_DASH] = ACTIONS(7115),
    [anon_sym_LT_DASH] = ACTIONS(7117),
    [anon_sym_LT_LT_DASH] = ACTIONS(7117),
    [anon_sym_COLON_EQ] = ACTIONS(7117),
    [anon_sym_DASH_GT] = ACTIONS(7115),
    [anon_sym_DASH_GT_GT] = ACTIONS(7117),
    [anon_sym_PIPE] = ACTIONS(7115),
    [anon_sym_AMP] = ACTIONS(7115),
    [anon_sym_PIPE_PIPE] = ACTIONS(7117),
    [anon_sym_AMP_AMP] = ACTIONS(7117),
    [anon_sym_LT] = ACTIONS(7115),
    [anon_sym_LT_EQ] = ACTIONS(7117),
    [anon_sym_GT] = ACTIONS(7115),
    [anon_sym_GT_EQ] = ACTIONS(7117),
    [anon_sym_EQ_EQ] = ACTIONS(7117),
    [anon_sym_BANG_EQ] = ACTIONS(7117),
    [anon_sym_STAR] = ACTIONS(7115),
    [anon_sym_SLASH] = ACTIONS(7117),
    [anon_sym_STAR_STAR] = ACTIONS(7117),
    [anon_sym_CARET] = ACTIONS(7117),
    [aux_sym_binary_operator_token1] = ACTIONS(7117),
    [anon_sym_PIPE_GT] = ACTIONS(7117),
    [anon_sym_COLON] = ACTIONS(7115),
    [anon_sym_DOLLAR] = ACTIONS(7117),
    [anon_sym_AT] = ACTIONS(7117),
    [anon_sym_COLON_COLON] = ACTIONS(7115),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7117),
    [aux_sym__hex_literal_token1] = ACTIONS(7117),
    [sym__number_literal] = ACTIONS(7115),
    [anon_sym_SQUOTE] = ACTIONS(7117),
    [anon_sym_DQUOTE] = ACTIONS(7117),
    [sym_return] = ACTIONS(7115),
    [sym_next] = ACTIONS(7115),
    [sym_break] = ACTIONS(7115),
    [sym_true] = ACTIONS(7115),
    [sym_false] = ACTIONS(7115),
    [sym_null] = ACTIONS(7115),
    [sym_inf] = ACTIONS(7115),
    [sym_nan] = ACTIONS(7115),
    [anon_sym_NA] = ACTIONS(7115),
    [anon_sym_NA_integer_] = ACTIONS(7115),
    [anon_sym_NA_real_] = ACTIONS(7115),
    [anon_sym_NA_complex_] = ACTIONS(7115),
    [anon_sym_NA_character_] = ACTIONS(7115),
    [sym_dots] = ACTIONS(7115),
    [sym_dot_dot_i] = ACTIONS(7117),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7117),
    [sym__semicolon] = ACTIONS(7117),
    [sym__raw_string_literal] = ACTIONS(7117),
    [sym__external_else] = ACTIONS(7117),
    [sym__external_open_parenthesis] = ACTIONS(7117),
    [sym__external_close_parenthesis] = ACTIONS(7117),
    [sym__external_open_brace] = ACTIONS(7117),
    [sym__external_open_bracket] = ACTIONS(7117),
    [sym__external_open_bracket2] = ACTIONS(7117),
  },
  [2355] = {
    [ts_builtin_sym_end] = ACTIONS(7117),
    [sym_identifier] = ACTIONS(7115),
    [anon_sym_BSLASH] = ACTIONS(7117),
    [anon_sym_function] = ACTIONS(7115),
    [anon_sym_EQ] = ACTIONS(7115),
    [anon_sym_if] = ACTIONS(7115),
    [anon_sym_for] = ACTIONS(7115),
    [anon_sym_while] = ACTIONS(7115),
    [anon_sym_repeat] = ACTIONS(7115),
    [anon_sym_QMARK] = ACTIONS(7117),
    [anon_sym_TILDE] = ACTIONS(7117),
    [anon_sym_BANG] = ACTIONS(7115),
    [anon_sym_PLUS] = ACTIONS(7117),
    [anon_sym_DASH] = ACTIONS(7115),
    [anon_sym_LT_DASH] = ACTIONS(7117),
    [anon_sym_LT_LT_DASH] = ACTIONS(7117),
    [anon_sym_COLON_EQ] = ACTIONS(7117),
    [anon_sym_DASH_GT] = ACTIONS(7115),
    [anon_sym_DASH_GT_GT] = ACTIONS(7117),
    [anon_sym_PIPE] = ACTIONS(7115),
    [anon_sym_AMP] = ACTIONS(7115),
    [anon_sym_PIPE_PIPE] = ACTIONS(7117),
    [anon_sym_AMP_AMP] = ACTIONS(7117),
    [anon_sym_LT] = ACTIONS(7115),
    [anon_sym_LT_EQ] = ACTIONS(7117),
    [anon_sym_GT] = ACTIONS(7115),
    [anon_sym_GT_EQ] = ACTIONS(7117),
    [anon_sym_EQ_EQ] = ACTIONS(7117),
    [anon_sym_BANG_EQ] = ACTIONS(7117),
    [anon_sym_STAR] = ACTIONS(7115),
    [anon_sym_SLASH] = ACTIONS(7117),
    [anon_sym_STAR_STAR] = ACTIONS(7117),
    [anon_sym_CARET] = ACTIONS(7117),
    [aux_sym_binary_operator_token1] = ACTIONS(7117),
    [anon_sym_PIPE_GT] = ACTIONS(7117),
    [anon_sym_COLON] = ACTIONS(7115),
    [anon_sym_DOLLAR] = ACTIONS(7117),
    [anon_sym_AT] = ACTIONS(7117),
    [anon_sym_COLON_COLON] = ACTIONS(7115),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7117),
    [aux_sym__hex_literal_token1] = ACTIONS(7117),
    [sym__number_literal] = ACTIONS(7115),
    [anon_sym_SQUOTE] = ACTIONS(7117),
    [anon_sym_DQUOTE] = ACTIONS(7117),
    [sym_return] = ACTIONS(7115),
    [sym_next] = ACTIONS(7115),
    [sym_break] = ACTIONS(7115),
    [sym_true] = ACTIONS(7115),
    [sym_false] = ACTIONS(7115),
    [sym_null] = ACTIONS(7115),
    [sym_inf] = ACTIONS(7115),
    [sym_nan] = ACTIONS(7115),
    [anon_sym_NA] = ACTIONS(7115),
    [anon_sym_NA_integer_] = ACTIONS(7115),
    [anon_sym_NA_real_] = ACTIONS(7115),
    [anon_sym_NA_complex_] = ACTIONS(7115),
    [anon_sym_NA_character_] = ACTIONS(7115),
    [sym_dots] = ACTIONS(7115),
    [sym_dot_dot_i] = ACTIONS(7117),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7117),
    [sym__semicolon] = ACTIONS(7117),
    [sym__raw_string_literal] = ACTIONS(7117),
    [sym__external_else] = ACTIONS(7117),
    [sym__external_open_parenthesis] = ACTIONS(7117),
    [sym__external_close_parenthesis] = ACTIONS(7117),
    [sym__external_open_brace] = ACTIONS(7117),
    [sym__external_open_bracket] = ACTIONS(7117),
    [sym__external_open_bracket2] = ACTIONS(7117),
  },
  [2356] = {
    [ts_builtin_sym_end] = ACTIONS(7123),
    [sym_identifier] = ACTIONS(7121),
    [anon_sym_BSLASH] = ACTIONS(7123),
    [anon_sym_function] = ACTIONS(7121),
    [anon_sym_EQ] = ACTIONS(7121),
    [anon_sym_if] = ACTIONS(7121),
    [anon_sym_for] = ACTIONS(7121),
    [anon_sym_while] = ACTIONS(7121),
    [anon_sym_repeat] = ACTIONS(7121),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_TILDE] = ACTIONS(7123),
    [anon_sym_BANG] = ACTIONS(7121),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_DASH] = ACTIONS(7121),
    [anon_sym_LT_DASH] = ACTIONS(7123),
    [anon_sym_LT_LT_DASH] = ACTIONS(7123),
    [anon_sym_COLON_EQ] = ACTIONS(7123),
    [anon_sym_DASH_GT] = ACTIONS(7121),
    [anon_sym_DASH_GT_GT] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_LT_EQ] = ACTIONS(7123),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
    [aux_sym_binary_operator_token1] = ACTIONS(7123),
    [anon_sym_PIPE_GT] = ACTIONS(7123),
    [anon_sym_COLON] = ACTIONS(7121),
    [anon_sym_DOLLAR] = ACTIONS(7123),
    [anon_sym_AT] = ACTIONS(7123),
    [anon_sym_L] = ACTIONS(7595),
    [anon_sym_i] = ACTIONS(7597),
    [aux_sym__hex_literal_token1] = ACTIONS(7123),
    [sym__number_literal] = ACTIONS(7121),
    [anon_sym_SQUOTE] = ACTIONS(7123),
    [anon_sym_DQUOTE] = ACTIONS(7123),
    [sym_return] = ACTIONS(7121),
    [sym_next] = ACTIONS(7121),
    [sym_break] = ACTIONS(7121),
    [sym_true] = ACTIONS(7121),
    [sym_false] = ACTIONS(7121),
    [sym_null] = ACTIONS(7121),
    [sym_inf] = ACTIONS(7121),
    [sym_nan] = ACTIONS(7121),
    [anon_sym_NA] = ACTIONS(7121),
    [anon_sym_NA_integer_] = ACTIONS(7121),
    [anon_sym_NA_real_] = ACTIONS(7121),
    [anon_sym_NA_complex_] = ACTIONS(7121),
    [anon_sym_NA_character_] = ACTIONS(7121),
    [sym_dots] = ACTIONS(7121),
    [sym_dot_dot_i] = ACTIONS(7123),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7123),
    [sym__semicolon] = ACTIONS(7123),
    [sym__raw_string_literal] = ACTIONS(7123),
    [sym__external_else] = ACTIONS(7123),
    [sym__external_open_parenthesis] = ACTIONS(7123),
    [sym__external_close_parenthesis] = ACTIONS(7123),
    [sym__external_open_brace] = ACTIONS(7123),
    [sym__external_open_bracket] = ACTIONS(7123),
    [sym__external_open_bracket2] = ACTIONS(7123),
  },
  [2357] = {
    [sym_identifier] = ACTIONS(7486),
    [anon_sym_BSLASH] = ACTIONS(7484),
    [anon_sym_function] = ACTIONS(7486),
    [anon_sym_EQ] = ACTIONS(7486),
    [anon_sym_if] = ACTIONS(7486),
    [anon_sym_for] = ACTIONS(7486),
    [anon_sym_while] = ACTIONS(7486),
    [anon_sym_repeat] = ACTIONS(7486),
    [anon_sym_QMARK] = ACTIONS(7484),
    [anon_sym_TILDE] = ACTIONS(7484),
    [anon_sym_BANG] = ACTIONS(7486),
    [anon_sym_PLUS] = ACTIONS(7484),
    [anon_sym_DASH] = ACTIONS(7486),
    [anon_sym_LT_DASH] = ACTIONS(7484),
    [anon_sym_LT_LT_DASH] = ACTIONS(7484),
    [anon_sym_COLON_EQ] = ACTIONS(7484),
    [anon_sym_DASH_GT] = ACTIONS(7486),
    [anon_sym_DASH_GT_GT] = ACTIONS(7484),
    [anon_sym_PIPE] = ACTIONS(7486),
    [anon_sym_AMP] = ACTIONS(7486),
    [anon_sym_PIPE_PIPE] = ACTIONS(7484),
    [anon_sym_AMP_AMP] = ACTIONS(7484),
    [anon_sym_LT] = ACTIONS(7486),
    [anon_sym_LT_EQ] = ACTIONS(7484),
    [anon_sym_GT] = ACTIONS(7486),
    [anon_sym_GT_EQ] = ACTIONS(7484),
    [anon_sym_EQ_EQ] = ACTIONS(7484),
    [anon_sym_BANG_EQ] = ACTIONS(7484),
    [anon_sym_STAR] = ACTIONS(7486),
    [anon_sym_SLASH] = ACTIONS(7484),
    [anon_sym_STAR_STAR] = ACTIONS(7484),
    [anon_sym_CARET] = ACTIONS(7484),
    [aux_sym_binary_operator_token1] = ACTIONS(7484),
    [anon_sym_PIPE_GT] = ACTIONS(7484),
    [anon_sym_COLON] = ACTIONS(7486),
    [anon_sym_DOLLAR] = ACTIONS(7484),
    [anon_sym_AT] = ACTIONS(7484),
    [aux_sym__hex_literal_token1] = ACTIONS(7484),
    [sym__number_literal] = ACTIONS(7486),
    [anon_sym_SQUOTE] = ACTIONS(7484),
    [anon_sym_DQUOTE] = ACTIONS(7484),
    [sym_return] = ACTIONS(7486),
    [sym_next] = ACTIONS(7486),
    [sym_break] = ACTIONS(7486),
    [sym_true] = ACTIONS(7486),
    [sym_false] = ACTIONS(7486),
    [sym_null] = ACTIONS(7486),
    [sym_inf] = ACTIONS(7486),
    [sym_nan] = ACTIONS(7486),
    [anon_sym_NA] = ACTIONS(7486),
    [anon_sym_NA_integer_] = ACTIONS(7486),
    [anon_sym_NA_real_] = ACTIONS(7486),
    [anon_sym_NA_complex_] = ACTIONS(7486),
    [anon_sym_NA_character_] = ACTIONS(7486),
    [sym_dots] = ACTIONS(7486),
    [sym_dot_dot_i] = ACTIONS(7484),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7484),
    [sym__newline] = ACTIONS(7484),
    [sym__semicolon] = ACTIONS(7484),
    [sym__raw_string_literal] = ACTIONS(7484),
    [sym__external_else] = ACTIONS(7484),
    [sym__external_open_parenthesis] = ACTIONS(7484),
    [sym__external_close_parenthesis] = ACTIONS(7484),
    [sym__external_open_brace] = ACTIONS(7484),
    [sym__external_close_brace] = ACTIONS(7484),
    [sym__external_open_bracket] = ACTIONS(7484),
    [sym__external_open_bracket2] = ACTIONS(7484),
    [sym__external_close_bracket2] = ACTIONS(7484),
  },
  [2358] = {
    [sym_identifier] = ACTIONS(7490),
    [anon_sym_BSLASH] = ACTIONS(7488),
    [anon_sym_function] = ACTIONS(7490),
    [anon_sym_EQ] = ACTIONS(7490),
    [anon_sym_if] = ACTIONS(7490),
    [anon_sym_for] = ACTIONS(7490),
    [anon_sym_while] = ACTIONS(7490),
    [anon_sym_repeat] = ACTIONS(7490),
    [anon_sym_QMARK] = ACTIONS(7488),
    [anon_sym_TILDE] = ACTIONS(7488),
    [anon_sym_BANG] = ACTIONS(7490),
    [anon_sym_PLUS] = ACTIONS(7488),
    [anon_sym_DASH] = ACTIONS(7490),
    [anon_sym_LT_DASH] = ACTIONS(7488),
    [anon_sym_LT_LT_DASH] = ACTIONS(7488),
    [anon_sym_COLON_EQ] = ACTIONS(7488),
    [anon_sym_DASH_GT] = ACTIONS(7490),
    [anon_sym_DASH_GT_GT] = ACTIONS(7488),
    [anon_sym_PIPE] = ACTIONS(7490),
    [anon_sym_AMP] = ACTIONS(7490),
    [anon_sym_PIPE_PIPE] = ACTIONS(7488),
    [anon_sym_AMP_AMP] = ACTIONS(7488),
    [anon_sym_LT] = ACTIONS(7490),
    [anon_sym_LT_EQ] = ACTIONS(7488),
    [anon_sym_GT] = ACTIONS(7490),
    [anon_sym_GT_EQ] = ACTIONS(7488),
    [anon_sym_EQ_EQ] = ACTIONS(7488),
    [anon_sym_BANG_EQ] = ACTIONS(7488),
    [anon_sym_STAR] = ACTIONS(7490),
    [anon_sym_SLASH] = ACTIONS(7488),
    [anon_sym_STAR_STAR] = ACTIONS(7488),
    [anon_sym_CARET] = ACTIONS(7488),
    [aux_sym_binary_operator_token1] = ACTIONS(7488),
    [anon_sym_PIPE_GT] = ACTIONS(7488),
    [anon_sym_COLON] = ACTIONS(7490),
    [anon_sym_DOLLAR] = ACTIONS(7488),
    [anon_sym_AT] = ACTIONS(7488),
    [aux_sym__hex_literal_token1] = ACTIONS(7488),
    [sym__number_literal] = ACTIONS(7490),
    [anon_sym_SQUOTE] = ACTIONS(7488),
    [anon_sym_DQUOTE] = ACTIONS(7488),
    [sym_return] = ACTIONS(7490),
    [sym_next] = ACTIONS(7490),
    [sym_break] = ACTIONS(7490),
    [sym_true] = ACTIONS(7490),
    [sym_false] = ACTIONS(7490),
    [sym_null] = ACTIONS(7490),
    [sym_inf] = ACTIONS(7490),
    [sym_nan] = ACTIONS(7490),
    [anon_sym_NA] = ACTIONS(7490),
    [anon_sym_NA_integer_] = ACTIONS(7490),
    [anon_sym_NA_real_] = ACTIONS(7490),
    [anon_sym_NA_complex_] = ACTIONS(7490),
    [anon_sym_NA_character_] = ACTIONS(7490),
    [sym_dots] = ACTIONS(7490),
    [sym_dot_dot_i] = ACTIONS(7488),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7488),
    [sym__newline] = ACTIONS(7488),
    [sym__semicolon] = ACTIONS(7488),
    [sym__raw_string_literal] = ACTIONS(7488),
    [sym__external_else] = ACTIONS(7488),
    [sym__external_open_parenthesis] = ACTIONS(7488),
    [sym__external_close_parenthesis] = ACTIONS(7488),
    [sym__external_open_brace] = ACTIONS(7488),
    [sym__external_close_brace] = ACTIONS(7488),
    [sym__external_open_bracket] = ACTIONS(7488),
    [sym__external_open_bracket2] = ACTIONS(7488),
    [sym__external_close_bracket2] = ACTIONS(7488),
  },
  [2359] = {
    [ts_builtin_sym_end] = ACTIONS(7139),
    [sym_identifier] = ACTIONS(7137),
    [anon_sym_BSLASH] = ACTIONS(7139),
    [anon_sym_function] = ACTIONS(7137),
    [anon_sym_EQ] = ACTIONS(7137),
    [anon_sym_if] = ACTIONS(7137),
    [anon_sym_for] = ACTIONS(7137),
    [anon_sym_while] = ACTIONS(7137),
    [anon_sym_repeat] = ACTIONS(7137),
    [anon_sym_QMARK] = ACTIONS(7139),
    [anon_sym_TILDE] = ACTIONS(7139),
    [anon_sym_BANG] = ACTIONS(7137),
    [anon_sym_PLUS] = ACTIONS(7139),
    [anon_sym_DASH] = ACTIONS(7137),
    [anon_sym_LT_DASH] = ACTIONS(7139),
    [anon_sym_LT_LT_DASH] = ACTIONS(7139),
    [anon_sym_COLON_EQ] = ACTIONS(7139),
    [anon_sym_DASH_GT] = ACTIONS(7137),
    [anon_sym_DASH_GT_GT] = ACTIONS(7139),
    [anon_sym_PIPE] = ACTIONS(7137),
    [anon_sym_AMP] = ACTIONS(7137),
    [anon_sym_PIPE_PIPE] = ACTIONS(7139),
    [anon_sym_AMP_AMP] = ACTIONS(7139),
    [anon_sym_LT] = ACTIONS(7137),
    [anon_sym_LT_EQ] = ACTIONS(7139),
    [anon_sym_GT] = ACTIONS(7137),
    [anon_sym_GT_EQ] = ACTIONS(7139),
    [anon_sym_EQ_EQ] = ACTIONS(7139),
    [anon_sym_BANG_EQ] = ACTIONS(7139),
    [anon_sym_STAR] = ACTIONS(7137),
    [anon_sym_SLASH] = ACTIONS(7139),
    [anon_sym_STAR_STAR] = ACTIONS(7139),
    [anon_sym_CARET] = ACTIONS(7139),
    [aux_sym_binary_operator_token1] = ACTIONS(7139),
    [anon_sym_PIPE_GT] = ACTIONS(7139),
    [anon_sym_COLON] = ACTIONS(7137),
    [anon_sym_DOLLAR] = ACTIONS(7139),
    [anon_sym_AT] = ACTIONS(7139),
    [anon_sym_COLON_COLON] = ACTIONS(7137),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7139),
    [aux_sym__hex_literal_token1] = ACTIONS(7139),
    [sym__number_literal] = ACTIONS(7137),
    [anon_sym_SQUOTE] = ACTIONS(7139),
    [anon_sym_DQUOTE] = ACTIONS(7139),
    [sym_return] = ACTIONS(7137),
    [sym_next] = ACTIONS(7137),
    [sym_break] = ACTIONS(7137),
    [sym_true] = ACTIONS(7137),
    [sym_false] = ACTIONS(7137),
    [sym_null] = ACTIONS(7137),
    [sym_inf] = ACTIONS(7137),
    [sym_nan] = ACTIONS(7137),
    [anon_sym_NA] = ACTIONS(7137),
    [anon_sym_NA_integer_] = ACTIONS(7137),
    [anon_sym_NA_real_] = ACTIONS(7137),
    [anon_sym_NA_complex_] = ACTIONS(7137),
    [anon_sym_NA_character_] = ACTIONS(7137),
    [sym_dots] = ACTIONS(7137),
    [sym_dot_dot_i] = ACTIONS(7139),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7139),
    [sym__semicolon] = ACTIONS(7139),
    [sym__raw_string_literal] = ACTIONS(7139),
    [sym__external_else] = ACTIONS(7139),
    [sym__external_open_parenthesis] = ACTIONS(7139),
    [sym__external_close_parenthesis] = ACTIONS(7139),
    [sym__external_open_brace] = ACTIONS(7139),
    [sym__external_open_bracket] = ACTIONS(7139),
    [sym__external_open_bracket2] = ACTIONS(7139),
  },
  [2360] = {
    [sym_identifier] = ACTIONS(7494),
    [anon_sym_BSLASH] = ACTIONS(7492),
    [anon_sym_function] = ACTIONS(7494),
    [anon_sym_EQ] = ACTIONS(7494),
    [anon_sym_if] = ACTIONS(7494),
    [anon_sym_for] = ACTIONS(7494),
    [anon_sym_while] = ACTIONS(7494),
    [anon_sym_repeat] = ACTIONS(7494),
    [anon_sym_QMARK] = ACTIONS(7492),
    [anon_sym_TILDE] = ACTIONS(7492),
    [anon_sym_BANG] = ACTIONS(7494),
    [anon_sym_PLUS] = ACTIONS(7492),
    [anon_sym_DASH] = ACTIONS(7494),
    [anon_sym_LT_DASH] = ACTIONS(7492),
    [anon_sym_LT_LT_DASH] = ACTIONS(7492),
    [anon_sym_COLON_EQ] = ACTIONS(7492),
    [anon_sym_DASH_GT] = ACTIONS(7494),
    [anon_sym_DASH_GT_GT] = ACTIONS(7492),
    [anon_sym_PIPE] = ACTIONS(7494),
    [anon_sym_AMP] = ACTIONS(7494),
    [anon_sym_PIPE_PIPE] = ACTIONS(7492),
    [anon_sym_AMP_AMP] = ACTIONS(7492),
    [anon_sym_LT] = ACTIONS(7494),
    [anon_sym_LT_EQ] = ACTIONS(7492),
    [anon_sym_GT] = ACTIONS(7494),
    [anon_sym_GT_EQ] = ACTIONS(7492),
    [anon_sym_EQ_EQ] = ACTIONS(7492),
    [anon_sym_BANG_EQ] = ACTIONS(7492),
    [anon_sym_STAR] = ACTIONS(7494),
    [anon_sym_SLASH] = ACTIONS(7492),
    [anon_sym_STAR_STAR] = ACTIONS(7492),
    [anon_sym_CARET] = ACTIONS(7492),
    [aux_sym_binary_operator_token1] = ACTIONS(7492),
    [anon_sym_PIPE_GT] = ACTIONS(7492),
    [anon_sym_COLON] = ACTIONS(7494),
    [anon_sym_DOLLAR] = ACTIONS(7492),
    [anon_sym_AT] = ACTIONS(7492),
    [aux_sym__hex_literal_token1] = ACTIONS(7492),
    [sym__number_literal] = ACTIONS(7494),
    [anon_sym_SQUOTE] = ACTIONS(7492),
    [anon_sym_DQUOTE] = ACTIONS(7492),
    [sym_return] = ACTIONS(7494),
    [sym_next] = ACTIONS(7494),
    [sym_break] = ACTIONS(7494),
    [sym_true] = ACTIONS(7494),
    [sym_false] = ACTIONS(7494),
    [sym_null] = ACTIONS(7494),
    [sym_inf] = ACTIONS(7494),
    [sym_nan] = ACTIONS(7494),
    [anon_sym_NA] = ACTIONS(7494),
    [anon_sym_NA_integer_] = ACTIONS(7494),
    [anon_sym_NA_real_] = ACTIONS(7494),
    [anon_sym_NA_complex_] = ACTIONS(7494),
    [anon_sym_NA_character_] = ACTIONS(7494),
    [sym_dots] = ACTIONS(7494),
    [sym_dot_dot_i] = ACTIONS(7492),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7492),
    [sym__newline] = ACTIONS(7492),
    [sym__semicolon] = ACTIONS(7492),
    [sym__raw_string_literal] = ACTIONS(7492),
    [sym__external_else] = ACTIONS(7492),
    [sym__external_open_parenthesis] = ACTIONS(7492),
    [sym__external_close_parenthesis] = ACTIONS(7492),
    [sym__external_open_brace] = ACTIONS(7492),
    [sym__external_close_brace] = ACTIONS(7492),
    [sym__external_open_bracket] = ACTIONS(7492),
    [sym__external_open_bracket2] = ACTIONS(7492),
    [sym__external_close_bracket2] = ACTIONS(7492),
  },
  [2361] = {
    [sym_identifier] = ACTIONS(7498),
    [anon_sym_BSLASH] = ACTIONS(7496),
    [anon_sym_function] = ACTIONS(7498),
    [anon_sym_EQ] = ACTIONS(7498),
    [anon_sym_if] = ACTIONS(7498),
    [anon_sym_for] = ACTIONS(7498),
    [anon_sym_while] = ACTIONS(7498),
    [anon_sym_repeat] = ACTIONS(7498),
    [anon_sym_QMARK] = ACTIONS(7496),
    [anon_sym_TILDE] = ACTIONS(7496),
    [anon_sym_BANG] = ACTIONS(7498),
    [anon_sym_PLUS] = ACTIONS(7496),
    [anon_sym_DASH] = ACTIONS(7498),
    [anon_sym_LT_DASH] = ACTIONS(7496),
    [anon_sym_LT_LT_DASH] = ACTIONS(7496),
    [anon_sym_COLON_EQ] = ACTIONS(7496),
    [anon_sym_DASH_GT] = ACTIONS(7498),
    [anon_sym_DASH_GT_GT] = ACTIONS(7496),
    [anon_sym_PIPE] = ACTIONS(7498),
    [anon_sym_AMP] = ACTIONS(7498),
    [anon_sym_PIPE_PIPE] = ACTIONS(7496),
    [anon_sym_AMP_AMP] = ACTIONS(7496),
    [anon_sym_LT] = ACTIONS(7498),
    [anon_sym_LT_EQ] = ACTIONS(7496),
    [anon_sym_GT] = ACTIONS(7498),
    [anon_sym_GT_EQ] = ACTIONS(7496),
    [anon_sym_EQ_EQ] = ACTIONS(7496),
    [anon_sym_BANG_EQ] = ACTIONS(7496),
    [anon_sym_STAR] = ACTIONS(7498),
    [anon_sym_SLASH] = ACTIONS(7496),
    [anon_sym_STAR_STAR] = ACTIONS(7496),
    [anon_sym_CARET] = ACTIONS(7496),
    [aux_sym_binary_operator_token1] = ACTIONS(7496),
    [anon_sym_PIPE_GT] = ACTIONS(7496),
    [anon_sym_COLON] = ACTIONS(7498),
    [anon_sym_DOLLAR] = ACTIONS(7496),
    [anon_sym_AT] = ACTIONS(7496),
    [aux_sym__hex_literal_token1] = ACTIONS(7496),
    [sym__number_literal] = ACTIONS(7498),
    [anon_sym_SQUOTE] = ACTIONS(7496),
    [anon_sym_DQUOTE] = ACTIONS(7496),
    [sym_return] = ACTIONS(7498),
    [sym_next] = ACTIONS(7498),
    [sym_break] = ACTIONS(7498),
    [sym_true] = ACTIONS(7498),
    [sym_false] = ACTIONS(7498),
    [sym_null] = ACTIONS(7498),
    [sym_inf] = ACTIONS(7498),
    [sym_nan] = ACTIONS(7498),
    [anon_sym_NA] = ACTIONS(7498),
    [anon_sym_NA_integer_] = ACTIONS(7498),
    [anon_sym_NA_real_] = ACTIONS(7498),
    [anon_sym_NA_complex_] = ACTIONS(7498),
    [anon_sym_NA_character_] = ACTIONS(7498),
    [sym_dots] = ACTIONS(7498),
    [sym_dot_dot_i] = ACTIONS(7496),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7496),
    [sym__newline] = ACTIONS(7496),
    [sym__semicolon] = ACTIONS(7496),
    [sym__raw_string_literal] = ACTIONS(7496),
    [sym__external_else] = ACTIONS(7496),
    [sym__external_open_parenthesis] = ACTIONS(7496),
    [sym__external_close_parenthesis] = ACTIONS(7496),
    [sym__external_open_brace] = ACTIONS(7496),
    [sym__external_close_brace] = ACTIONS(7496),
    [sym__external_open_bracket] = ACTIONS(7496),
    [sym__external_open_bracket2] = ACTIONS(7496),
    [sym__external_close_bracket2] = ACTIONS(7496),
  },
  [2362] = {
    [sym_identifier] = ACTIONS(7502),
    [anon_sym_BSLASH] = ACTIONS(7500),
    [anon_sym_function] = ACTIONS(7502),
    [anon_sym_EQ] = ACTIONS(7502),
    [anon_sym_if] = ACTIONS(7502),
    [anon_sym_for] = ACTIONS(7502),
    [anon_sym_while] = ACTIONS(7502),
    [anon_sym_repeat] = ACTIONS(7502),
    [anon_sym_QMARK] = ACTIONS(7500),
    [anon_sym_TILDE] = ACTIONS(7500),
    [anon_sym_BANG] = ACTIONS(7502),
    [anon_sym_PLUS] = ACTIONS(7500),
    [anon_sym_DASH] = ACTIONS(7502),
    [anon_sym_LT_DASH] = ACTIONS(7500),
    [anon_sym_LT_LT_DASH] = ACTIONS(7500),
    [anon_sym_COLON_EQ] = ACTIONS(7500),
    [anon_sym_DASH_GT] = ACTIONS(7502),
    [anon_sym_DASH_GT_GT] = ACTIONS(7500),
    [anon_sym_PIPE] = ACTIONS(7502),
    [anon_sym_AMP] = ACTIONS(7502),
    [anon_sym_PIPE_PIPE] = ACTIONS(7500),
    [anon_sym_AMP_AMP] = ACTIONS(7500),
    [anon_sym_LT] = ACTIONS(7502),
    [anon_sym_LT_EQ] = ACTIONS(7500),
    [anon_sym_GT] = ACTIONS(7502),
    [anon_sym_GT_EQ] = ACTIONS(7500),
    [anon_sym_EQ_EQ] = ACTIONS(7500),
    [anon_sym_BANG_EQ] = ACTIONS(7500),
    [anon_sym_STAR] = ACTIONS(7502),
    [anon_sym_SLASH] = ACTIONS(7500),
    [anon_sym_STAR_STAR] = ACTIONS(7500),
    [anon_sym_CARET] = ACTIONS(7500),
    [aux_sym_binary_operator_token1] = ACTIONS(7500),
    [anon_sym_PIPE_GT] = ACTIONS(7500),
    [anon_sym_COLON] = ACTIONS(7502),
    [anon_sym_DOLLAR] = ACTIONS(7500),
    [anon_sym_AT] = ACTIONS(7500),
    [aux_sym__hex_literal_token1] = ACTIONS(7500),
    [sym__number_literal] = ACTIONS(7502),
    [anon_sym_SQUOTE] = ACTIONS(7500),
    [anon_sym_DQUOTE] = ACTIONS(7500),
    [sym_return] = ACTIONS(7502),
    [sym_next] = ACTIONS(7502),
    [sym_break] = ACTIONS(7502),
    [sym_true] = ACTIONS(7502),
    [sym_false] = ACTIONS(7502),
    [sym_null] = ACTIONS(7502),
    [sym_inf] = ACTIONS(7502),
    [sym_nan] = ACTIONS(7502),
    [anon_sym_NA] = ACTIONS(7502),
    [anon_sym_NA_integer_] = ACTIONS(7502),
    [anon_sym_NA_real_] = ACTIONS(7502),
    [anon_sym_NA_complex_] = ACTIONS(7502),
    [anon_sym_NA_character_] = ACTIONS(7502),
    [sym_dots] = ACTIONS(7502),
    [sym_dot_dot_i] = ACTIONS(7500),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7500),
    [sym__newline] = ACTIONS(7500),
    [sym__semicolon] = ACTIONS(7500),
    [sym__raw_string_literal] = ACTIONS(7500),
    [sym__external_else] = ACTIONS(7500),
    [sym__external_open_parenthesis] = ACTIONS(7500),
    [sym__external_close_parenthesis] = ACTIONS(7500),
    [sym__external_open_brace] = ACTIONS(7500),
    [sym__external_close_brace] = ACTIONS(7500),
    [sym__external_open_bracket] = ACTIONS(7500),
    [sym__external_open_bracket2] = ACTIONS(7500),
    [sym__external_close_bracket2] = ACTIONS(7500),
  },
  [2363] = {
    [sym_identifier] = ACTIONS(7506),
    [anon_sym_BSLASH] = ACTIONS(7504),
    [anon_sym_function] = ACTIONS(7506),
    [anon_sym_EQ] = ACTIONS(7506),
    [anon_sym_if] = ACTIONS(7506),
    [anon_sym_for] = ACTIONS(7506),
    [anon_sym_while] = ACTIONS(7506),
    [anon_sym_repeat] = ACTIONS(7506),
    [anon_sym_QMARK] = ACTIONS(7504),
    [anon_sym_TILDE] = ACTIONS(7504),
    [anon_sym_BANG] = ACTIONS(7506),
    [anon_sym_PLUS] = ACTIONS(7504),
    [anon_sym_DASH] = ACTIONS(7506),
    [anon_sym_LT_DASH] = ACTIONS(7504),
    [anon_sym_LT_LT_DASH] = ACTIONS(7504),
    [anon_sym_COLON_EQ] = ACTIONS(7504),
    [anon_sym_DASH_GT] = ACTIONS(7506),
    [anon_sym_DASH_GT_GT] = ACTIONS(7504),
    [anon_sym_PIPE] = ACTIONS(7506),
    [anon_sym_AMP] = ACTIONS(7506),
    [anon_sym_PIPE_PIPE] = ACTIONS(7504),
    [anon_sym_AMP_AMP] = ACTIONS(7504),
    [anon_sym_LT] = ACTIONS(7506),
    [anon_sym_LT_EQ] = ACTIONS(7504),
    [anon_sym_GT] = ACTIONS(7506),
    [anon_sym_GT_EQ] = ACTIONS(7504),
    [anon_sym_EQ_EQ] = ACTIONS(7504),
    [anon_sym_BANG_EQ] = ACTIONS(7504),
    [anon_sym_STAR] = ACTIONS(7506),
    [anon_sym_SLASH] = ACTIONS(7504),
    [anon_sym_STAR_STAR] = ACTIONS(7504),
    [anon_sym_CARET] = ACTIONS(7504),
    [aux_sym_binary_operator_token1] = ACTIONS(7504),
    [anon_sym_PIPE_GT] = ACTIONS(7504),
    [anon_sym_COLON] = ACTIONS(7506),
    [anon_sym_DOLLAR] = ACTIONS(7504),
    [anon_sym_AT] = ACTIONS(7504),
    [aux_sym__hex_literal_token1] = ACTIONS(7504),
    [sym__number_literal] = ACTIONS(7506),
    [anon_sym_SQUOTE] = ACTIONS(7504),
    [anon_sym_DQUOTE] = ACTIONS(7504),
    [sym_return] = ACTIONS(7506),
    [sym_next] = ACTIONS(7506),
    [sym_break] = ACTIONS(7506),
    [sym_true] = ACTIONS(7506),
    [sym_false] = ACTIONS(7506),
    [sym_null] = ACTIONS(7506),
    [sym_inf] = ACTIONS(7506),
    [sym_nan] = ACTIONS(7506),
    [anon_sym_NA] = ACTIONS(7506),
    [anon_sym_NA_integer_] = ACTIONS(7506),
    [anon_sym_NA_real_] = ACTIONS(7506),
    [anon_sym_NA_complex_] = ACTIONS(7506),
    [anon_sym_NA_character_] = ACTIONS(7506),
    [sym_dots] = ACTIONS(7506),
    [sym_dot_dot_i] = ACTIONS(7504),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7504),
    [sym__newline] = ACTIONS(7504),
    [sym__semicolon] = ACTIONS(7504),
    [sym__raw_string_literal] = ACTIONS(7504),
    [sym__external_else] = ACTIONS(7504),
    [sym__external_open_parenthesis] = ACTIONS(7504),
    [sym__external_close_parenthesis] = ACTIONS(7504),
    [sym__external_open_brace] = ACTIONS(7504),
    [sym__external_close_brace] = ACTIONS(7504),
    [sym__external_open_bracket] = ACTIONS(7504),
    [sym__external_open_bracket2] = ACTIONS(7504),
    [sym__external_close_bracket2] = ACTIONS(7504),
  },
  [2364] = {
    [sym_identifier] = ACTIONS(7512),
    [anon_sym_BSLASH] = ACTIONS(7510),
    [anon_sym_function] = ACTIONS(7512),
    [anon_sym_EQ] = ACTIONS(7512),
    [anon_sym_if] = ACTIONS(7512),
    [anon_sym_for] = ACTIONS(7512),
    [anon_sym_while] = ACTIONS(7512),
    [anon_sym_repeat] = ACTIONS(7512),
    [anon_sym_QMARK] = ACTIONS(7510),
    [anon_sym_TILDE] = ACTIONS(7510),
    [anon_sym_BANG] = ACTIONS(7512),
    [anon_sym_PLUS] = ACTIONS(7510),
    [anon_sym_DASH] = ACTIONS(7512),
    [anon_sym_LT_DASH] = ACTIONS(7510),
    [anon_sym_LT_LT_DASH] = ACTIONS(7510),
    [anon_sym_COLON_EQ] = ACTIONS(7510),
    [anon_sym_DASH_GT] = ACTIONS(7512),
    [anon_sym_DASH_GT_GT] = ACTIONS(7510),
    [anon_sym_PIPE] = ACTIONS(7512),
    [anon_sym_AMP] = ACTIONS(7512),
    [anon_sym_PIPE_PIPE] = ACTIONS(7510),
    [anon_sym_AMP_AMP] = ACTIONS(7510),
    [anon_sym_LT] = ACTIONS(7512),
    [anon_sym_LT_EQ] = ACTIONS(7510),
    [anon_sym_GT] = ACTIONS(7512),
    [anon_sym_GT_EQ] = ACTIONS(7510),
    [anon_sym_EQ_EQ] = ACTIONS(7510),
    [anon_sym_BANG_EQ] = ACTIONS(7510),
    [anon_sym_STAR] = ACTIONS(7512),
    [anon_sym_SLASH] = ACTIONS(7510),
    [anon_sym_STAR_STAR] = ACTIONS(7510),
    [anon_sym_CARET] = ACTIONS(7510),
    [aux_sym_binary_operator_token1] = ACTIONS(7510),
    [anon_sym_PIPE_GT] = ACTIONS(7510),
    [anon_sym_COLON] = ACTIONS(7512),
    [anon_sym_DOLLAR] = ACTIONS(7510),
    [anon_sym_AT] = ACTIONS(7510),
    [aux_sym__hex_literal_token1] = ACTIONS(7510),
    [sym__number_literal] = ACTIONS(7512),
    [anon_sym_SQUOTE] = ACTIONS(7510),
    [anon_sym_DQUOTE] = ACTIONS(7510),
    [sym_return] = ACTIONS(7512),
    [sym_next] = ACTIONS(7512),
    [sym_break] = ACTIONS(7512),
    [sym_true] = ACTIONS(7512),
    [sym_false] = ACTIONS(7512),
    [sym_null] = ACTIONS(7512),
    [sym_inf] = ACTIONS(7512),
    [sym_nan] = ACTIONS(7512),
    [anon_sym_NA] = ACTIONS(7512),
    [anon_sym_NA_integer_] = ACTIONS(7512),
    [anon_sym_NA_real_] = ACTIONS(7512),
    [anon_sym_NA_complex_] = ACTIONS(7512),
    [anon_sym_NA_character_] = ACTIONS(7512),
    [sym_dots] = ACTIONS(7512),
    [sym_dot_dot_i] = ACTIONS(7510),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7510),
    [sym__newline] = ACTIONS(7510),
    [sym__semicolon] = ACTIONS(7510),
    [sym__raw_string_literal] = ACTIONS(7510),
    [sym__external_else] = ACTIONS(7510),
    [sym__external_open_parenthesis] = ACTIONS(7510),
    [sym__external_close_parenthesis] = ACTIONS(7510),
    [sym__external_open_brace] = ACTIONS(7510),
    [sym__external_close_brace] = ACTIONS(7510),
    [sym__external_open_bracket] = ACTIONS(7510),
    [sym__external_open_bracket2] = ACTIONS(7510),
    [sym__external_close_bracket2] = ACTIONS(7510),
  },
  [2365] = {
    [ts_builtin_sym_end] = ACTIONS(7538),
    [sym_identifier] = ACTIONS(7540),
    [anon_sym_BSLASH] = ACTIONS(7538),
    [anon_sym_function] = ACTIONS(7540),
    [anon_sym_EQ] = ACTIONS(7540),
    [anon_sym_if] = ACTIONS(7540),
    [anon_sym_for] = ACTIONS(7540),
    [anon_sym_while] = ACTIONS(7540),
    [anon_sym_repeat] = ACTIONS(7540),
    [anon_sym_QMARK] = ACTIONS(7538),
    [anon_sym_TILDE] = ACTIONS(7538),
    [anon_sym_BANG] = ACTIONS(7540),
    [anon_sym_PLUS] = ACTIONS(7538),
    [anon_sym_DASH] = ACTIONS(7540),
    [anon_sym_LT_DASH] = ACTIONS(7538),
    [anon_sym_LT_LT_DASH] = ACTIONS(7538),
    [anon_sym_COLON_EQ] = ACTIONS(7538),
    [anon_sym_DASH_GT] = ACTIONS(7540),
    [anon_sym_DASH_GT_GT] = ACTIONS(7538),
    [anon_sym_PIPE] = ACTIONS(7540),
    [anon_sym_AMP] = ACTIONS(7540),
    [anon_sym_PIPE_PIPE] = ACTIONS(7538),
    [anon_sym_AMP_AMP] = ACTIONS(7538),
    [anon_sym_LT] = ACTIONS(7540),
    [anon_sym_LT_EQ] = ACTIONS(7538),
    [anon_sym_GT] = ACTIONS(7540),
    [anon_sym_GT_EQ] = ACTIONS(7538),
    [anon_sym_EQ_EQ] = ACTIONS(7538),
    [anon_sym_BANG_EQ] = ACTIONS(7538),
    [anon_sym_STAR] = ACTIONS(7540),
    [anon_sym_SLASH] = ACTIONS(7538),
    [anon_sym_STAR_STAR] = ACTIONS(7538),
    [anon_sym_CARET] = ACTIONS(7538),
    [aux_sym_binary_operator_token1] = ACTIONS(7538),
    [anon_sym_PIPE_GT] = ACTIONS(7538),
    [anon_sym_COLON] = ACTIONS(7540),
    [anon_sym_DOLLAR] = ACTIONS(7538),
    [anon_sym_AT] = ACTIONS(7538),
    [aux_sym__hex_literal_token1] = ACTIONS(7538),
    [sym__number_literal] = ACTIONS(7540),
    [anon_sym_SQUOTE] = ACTIONS(7538),
    [anon_sym_DQUOTE] = ACTIONS(7538),
    [sym_return] = ACTIONS(7540),
    [sym_next] = ACTIONS(7540),
    [sym_break] = ACTIONS(7540),
    [sym_true] = ACTIONS(7540),
    [sym_false] = ACTIONS(7540),
    [sym_null] = ACTIONS(7540),
    [sym_inf] = ACTIONS(7540),
    [sym_nan] = ACTIONS(7540),
    [anon_sym_NA] = ACTIONS(7540),
    [anon_sym_NA_integer_] = ACTIONS(7540),
    [anon_sym_NA_real_] = ACTIONS(7540),
    [anon_sym_NA_complex_] = ACTIONS(7540),
    [anon_sym_NA_character_] = ACTIONS(7540),
    [sym_dots] = ACTIONS(7540),
    [sym_dot_dot_i] = ACTIONS(7538),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7538),
    [sym__newline] = ACTIONS(7538),
    [sym__semicolon] = ACTIONS(7538),
    [sym__raw_string_literal] = ACTIONS(7538),
    [sym__external_open_parenthesis] = ACTIONS(7538),
    [sym__external_close_parenthesis] = ACTIONS(7538),
    [sym__external_open_brace] = ACTIONS(7538),
    [sym__external_close_brace] = ACTIONS(7538),
    [sym__external_open_bracket] = ACTIONS(7538),
    [sym__external_open_bracket2] = ACTIONS(7538),
  },
  [2366] = {
    [sym_identifier] = ACTIONS(7151),
    [anon_sym_BSLASH] = ACTIONS(7153),
    [anon_sym_function] = ACTIONS(7151),
    [anon_sym_EQ] = ACTIONS(7151),
    [anon_sym_if] = ACTIONS(7151),
    [anon_sym_for] = ACTIONS(7151),
    [anon_sym_while] = ACTIONS(7151),
    [anon_sym_repeat] = ACTIONS(7151),
    [anon_sym_QMARK] = ACTIONS(7153),
    [anon_sym_TILDE] = ACTIONS(7153),
    [anon_sym_BANG] = ACTIONS(7151),
    [anon_sym_PLUS] = ACTIONS(7153),
    [anon_sym_DASH] = ACTIONS(7151),
    [anon_sym_LT_DASH] = ACTIONS(7153),
    [anon_sym_LT_LT_DASH] = ACTIONS(7153),
    [anon_sym_COLON_EQ] = ACTIONS(7153),
    [anon_sym_DASH_GT] = ACTIONS(7151),
    [anon_sym_DASH_GT_GT] = ACTIONS(7153),
    [anon_sym_PIPE] = ACTIONS(7151),
    [anon_sym_AMP] = ACTIONS(7151),
    [anon_sym_PIPE_PIPE] = ACTIONS(7153),
    [anon_sym_AMP_AMP] = ACTIONS(7153),
    [anon_sym_LT] = ACTIONS(7151),
    [anon_sym_LT_EQ] = ACTIONS(7153),
    [anon_sym_GT] = ACTIONS(7151),
    [anon_sym_GT_EQ] = ACTIONS(7153),
    [anon_sym_EQ_EQ] = ACTIONS(7153),
    [anon_sym_BANG_EQ] = ACTIONS(7153),
    [anon_sym_STAR] = ACTIONS(7151),
    [anon_sym_SLASH] = ACTIONS(7153),
    [anon_sym_STAR_STAR] = ACTIONS(7153),
    [anon_sym_CARET] = ACTIONS(7153),
    [aux_sym_binary_operator_token1] = ACTIONS(7153),
    [anon_sym_PIPE_GT] = ACTIONS(7153),
    [anon_sym_COLON] = ACTIONS(7151),
    [anon_sym_DOLLAR] = ACTIONS(7153),
    [anon_sym_AT] = ACTIONS(7153),
    [anon_sym_COLON_COLON] = ACTIONS(7151),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7153),
    [aux_sym__hex_literal_token1] = ACTIONS(7153),
    [sym__number_literal] = ACTIONS(7151),
    [anon_sym_SQUOTE] = ACTIONS(7153),
    [anon_sym_DQUOTE] = ACTIONS(7153),
    [sym_return] = ACTIONS(7151),
    [sym_next] = ACTIONS(7151),
    [sym_break] = ACTIONS(7151),
    [sym_true] = ACTIONS(7151),
    [sym_false] = ACTIONS(7151),
    [sym_null] = ACTIONS(7151),
    [sym_inf] = ACTIONS(7151),
    [sym_nan] = ACTIONS(7151),
    [anon_sym_NA] = ACTIONS(7151),
    [anon_sym_NA_integer_] = ACTIONS(7151),
    [anon_sym_NA_real_] = ACTIONS(7151),
    [anon_sym_NA_complex_] = ACTIONS(7151),
    [anon_sym_NA_character_] = ACTIONS(7151),
    [sym_dots] = ACTIONS(7151),
    [sym_dot_dot_i] = ACTIONS(7153),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7153),
    [sym__newline] = ACTIONS(7153),
    [sym__raw_string_literal] = ACTIONS(7153),
    [sym__external_open_parenthesis] = ACTIONS(7153),
    [sym__external_close_parenthesis] = ACTIONS(7153),
    [sym__external_open_brace] = ACTIONS(7153),
    [sym__external_open_bracket] = ACTIONS(7153),
    [sym__external_open_bracket2] = ACTIONS(7153),
    [sym__external_close_bracket2] = ACTIONS(7153),
  },
  [2367] = {
    [sym_identifier] = ACTIONS(7163),
    [anon_sym_BSLASH] = ACTIONS(7165),
    [anon_sym_function] = ACTIONS(7163),
    [anon_sym_EQ] = ACTIONS(7163),
    [anon_sym_if] = ACTIONS(7163),
    [anon_sym_for] = ACTIONS(7163),
    [anon_sym_while] = ACTIONS(7163),
    [anon_sym_repeat] = ACTIONS(7163),
    [anon_sym_QMARK] = ACTIONS(7165),
    [anon_sym_TILDE] = ACTIONS(7165),
    [anon_sym_BANG] = ACTIONS(7163),
    [anon_sym_PLUS] = ACTIONS(7165),
    [anon_sym_DASH] = ACTIONS(7163),
    [anon_sym_LT_DASH] = ACTIONS(7165),
    [anon_sym_LT_LT_DASH] = ACTIONS(7165),
    [anon_sym_COLON_EQ] = ACTIONS(7165),
    [anon_sym_DASH_GT] = ACTIONS(7163),
    [anon_sym_DASH_GT_GT] = ACTIONS(7165),
    [anon_sym_PIPE] = ACTIONS(7163),
    [anon_sym_AMP] = ACTIONS(7163),
    [anon_sym_PIPE_PIPE] = ACTIONS(7165),
    [anon_sym_AMP_AMP] = ACTIONS(7165),
    [anon_sym_LT] = ACTIONS(7163),
    [anon_sym_LT_EQ] = ACTIONS(7165),
    [anon_sym_GT] = ACTIONS(7163),
    [anon_sym_GT_EQ] = ACTIONS(7165),
    [anon_sym_EQ_EQ] = ACTIONS(7165),
    [anon_sym_BANG_EQ] = ACTIONS(7165),
    [anon_sym_STAR] = ACTIONS(7163),
    [anon_sym_SLASH] = ACTIONS(7165),
    [anon_sym_STAR_STAR] = ACTIONS(7165),
    [anon_sym_CARET] = ACTIONS(7165),
    [aux_sym_binary_operator_token1] = ACTIONS(7165),
    [anon_sym_PIPE_GT] = ACTIONS(7165),
    [anon_sym_COLON] = ACTIONS(7163),
    [anon_sym_DOLLAR] = ACTIONS(7165),
    [anon_sym_AT] = ACTIONS(7165),
    [anon_sym_COLON_COLON] = ACTIONS(7163),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7165),
    [aux_sym__hex_literal_token1] = ACTIONS(7165),
    [sym__number_literal] = ACTIONS(7163),
    [anon_sym_SQUOTE] = ACTIONS(7165),
    [anon_sym_DQUOTE] = ACTIONS(7165),
    [sym_return] = ACTIONS(7163),
    [sym_next] = ACTIONS(7163),
    [sym_break] = ACTIONS(7163),
    [sym_true] = ACTIONS(7163),
    [sym_false] = ACTIONS(7163),
    [sym_null] = ACTIONS(7163),
    [sym_inf] = ACTIONS(7163),
    [sym_nan] = ACTIONS(7163),
    [anon_sym_NA] = ACTIONS(7163),
    [anon_sym_NA_integer_] = ACTIONS(7163),
    [anon_sym_NA_real_] = ACTIONS(7163),
    [anon_sym_NA_complex_] = ACTIONS(7163),
    [anon_sym_NA_character_] = ACTIONS(7163),
    [sym_dots] = ACTIONS(7163),
    [sym_dot_dot_i] = ACTIONS(7165),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7165),
    [sym__newline] = ACTIONS(7165),
    [sym__raw_string_literal] = ACTIONS(7165),
    [sym__external_else] = ACTIONS(7165),
    [sym__external_open_parenthesis] = ACTIONS(7165),
    [sym__external_close_parenthesis] = ACTIONS(7165),
    [sym__external_open_brace] = ACTIONS(7165),
    [sym__external_open_bracket] = ACTIONS(7165),
    [sym__external_open_bracket2] = ACTIONS(7165),
  },
  [2368] = {
    [sym_identifier] = ACTIONS(7151),
    [anon_sym_BSLASH] = ACTIONS(7153),
    [anon_sym_function] = ACTIONS(7151),
    [anon_sym_EQ] = ACTIONS(7151),
    [anon_sym_if] = ACTIONS(7151),
    [anon_sym_for] = ACTIONS(7151),
    [anon_sym_while] = ACTIONS(7151),
    [anon_sym_repeat] = ACTIONS(7151),
    [anon_sym_QMARK] = ACTIONS(7153),
    [anon_sym_TILDE] = ACTIONS(7153),
    [anon_sym_BANG] = ACTIONS(7151),
    [anon_sym_PLUS] = ACTIONS(7153),
    [anon_sym_DASH] = ACTIONS(7151),
    [anon_sym_LT_DASH] = ACTIONS(7153),
    [anon_sym_LT_LT_DASH] = ACTIONS(7153),
    [anon_sym_COLON_EQ] = ACTIONS(7153),
    [anon_sym_DASH_GT] = ACTIONS(7151),
    [anon_sym_DASH_GT_GT] = ACTIONS(7153),
    [anon_sym_PIPE] = ACTIONS(7151),
    [anon_sym_AMP] = ACTIONS(7151),
    [anon_sym_PIPE_PIPE] = ACTIONS(7153),
    [anon_sym_AMP_AMP] = ACTIONS(7153),
    [anon_sym_LT] = ACTIONS(7151),
    [anon_sym_LT_EQ] = ACTIONS(7153),
    [anon_sym_GT] = ACTIONS(7151),
    [anon_sym_GT_EQ] = ACTIONS(7153),
    [anon_sym_EQ_EQ] = ACTIONS(7153),
    [anon_sym_BANG_EQ] = ACTIONS(7153),
    [anon_sym_STAR] = ACTIONS(7151),
    [anon_sym_SLASH] = ACTIONS(7153),
    [anon_sym_STAR_STAR] = ACTIONS(7153),
    [anon_sym_CARET] = ACTIONS(7153),
    [aux_sym_binary_operator_token1] = ACTIONS(7153),
    [anon_sym_PIPE_GT] = ACTIONS(7153),
    [anon_sym_COLON] = ACTIONS(7151),
    [anon_sym_DOLLAR] = ACTIONS(7153),
    [anon_sym_AT] = ACTIONS(7153),
    [anon_sym_COLON_COLON] = ACTIONS(7151),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7153),
    [aux_sym__hex_literal_token1] = ACTIONS(7153),
    [sym__number_literal] = ACTIONS(7151),
    [anon_sym_SQUOTE] = ACTIONS(7153),
    [anon_sym_DQUOTE] = ACTIONS(7153),
    [sym_return] = ACTIONS(7151),
    [sym_next] = ACTIONS(7151),
    [sym_break] = ACTIONS(7151),
    [sym_true] = ACTIONS(7151),
    [sym_false] = ACTIONS(7151),
    [sym_null] = ACTIONS(7151),
    [sym_inf] = ACTIONS(7151),
    [sym_nan] = ACTIONS(7151),
    [anon_sym_NA] = ACTIONS(7151),
    [anon_sym_NA_integer_] = ACTIONS(7151),
    [anon_sym_NA_real_] = ACTIONS(7151),
    [anon_sym_NA_complex_] = ACTIONS(7151),
    [anon_sym_NA_character_] = ACTIONS(7151),
    [sym_dots] = ACTIONS(7151),
    [sym_dot_dot_i] = ACTIONS(7153),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7153),
    [sym__newline] = ACTIONS(7153),
    [sym__raw_string_literal] = ACTIONS(7153),
    [sym__external_else] = ACTIONS(7153),
    [sym__external_open_parenthesis] = ACTIONS(7153),
    [sym__external_close_parenthesis] = ACTIONS(7153),
    [sym__external_open_brace] = ACTIONS(7153),
    [sym__external_open_bracket] = ACTIONS(7153),
    [sym__external_open_bracket2] = ACTIONS(7153),
  },
  [2369] = {
    [sym_identifier] = ACTIONS(7115),
    [anon_sym_BSLASH] = ACTIONS(7117),
    [anon_sym_function] = ACTIONS(7115),
    [anon_sym_EQ] = ACTIONS(7115),
    [anon_sym_if] = ACTIONS(7115),
    [anon_sym_for] = ACTIONS(7115),
    [anon_sym_while] = ACTIONS(7115),
    [anon_sym_repeat] = ACTIONS(7115),
    [anon_sym_QMARK] = ACTIONS(7117),
    [anon_sym_TILDE] = ACTIONS(7117),
    [anon_sym_BANG] = ACTIONS(7115),
    [anon_sym_PLUS] = ACTIONS(7117),
    [anon_sym_DASH] = ACTIONS(7115),
    [anon_sym_LT_DASH] = ACTIONS(7117),
    [anon_sym_LT_LT_DASH] = ACTIONS(7117),
    [anon_sym_COLON_EQ] = ACTIONS(7117),
    [anon_sym_DASH_GT] = ACTIONS(7115),
    [anon_sym_DASH_GT_GT] = ACTIONS(7117),
    [anon_sym_PIPE] = ACTIONS(7115),
    [anon_sym_AMP] = ACTIONS(7115),
    [anon_sym_PIPE_PIPE] = ACTIONS(7117),
    [anon_sym_AMP_AMP] = ACTIONS(7117),
    [anon_sym_LT] = ACTIONS(7115),
    [anon_sym_LT_EQ] = ACTIONS(7117),
    [anon_sym_GT] = ACTIONS(7115),
    [anon_sym_GT_EQ] = ACTIONS(7117),
    [anon_sym_EQ_EQ] = ACTIONS(7117),
    [anon_sym_BANG_EQ] = ACTIONS(7117),
    [anon_sym_STAR] = ACTIONS(7115),
    [anon_sym_SLASH] = ACTIONS(7117),
    [anon_sym_STAR_STAR] = ACTIONS(7117),
    [anon_sym_CARET] = ACTIONS(7117),
    [aux_sym_binary_operator_token1] = ACTIONS(7117),
    [anon_sym_PIPE_GT] = ACTIONS(7117),
    [anon_sym_COLON] = ACTIONS(7115),
    [anon_sym_DOLLAR] = ACTIONS(7117),
    [anon_sym_AT] = ACTIONS(7117),
    [anon_sym_COLON_COLON] = ACTIONS(7115),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7117),
    [aux_sym__hex_literal_token1] = ACTIONS(7117),
    [sym__number_literal] = ACTIONS(7115),
    [anon_sym_SQUOTE] = ACTIONS(7117),
    [anon_sym_DQUOTE] = ACTIONS(7117),
    [sym_return] = ACTIONS(7115),
    [sym_next] = ACTIONS(7115),
    [sym_break] = ACTIONS(7115),
    [sym_true] = ACTIONS(7115),
    [sym_false] = ACTIONS(7115),
    [sym_null] = ACTIONS(7115),
    [sym_inf] = ACTIONS(7115),
    [sym_nan] = ACTIONS(7115),
    [anon_sym_NA] = ACTIONS(7115),
    [anon_sym_NA_integer_] = ACTIONS(7115),
    [anon_sym_NA_real_] = ACTIONS(7115),
    [anon_sym_NA_complex_] = ACTIONS(7115),
    [anon_sym_NA_character_] = ACTIONS(7115),
    [sym_dots] = ACTIONS(7115),
    [sym_dot_dot_i] = ACTIONS(7117),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7117),
    [sym__newline] = ACTIONS(7117),
    [sym__raw_string_literal] = ACTIONS(7117),
    [sym__external_else] = ACTIONS(7117),
    [sym__external_open_parenthesis] = ACTIONS(7117),
    [sym__external_close_parenthesis] = ACTIONS(7117),
    [sym__external_open_brace] = ACTIONS(7117),
    [sym__external_open_bracket] = ACTIONS(7117),
    [sym__external_open_bracket2] = ACTIONS(7117),
  },
  [2370] = {
    [sym_identifier] = ACTIONS(7115),
    [anon_sym_BSLASH] = ACTIONS(7117),
    [anon_sym_function] = ACTIONS(7115),
    [anon_sym_EQ] = ACTIONS(7115),
    [anon_sym_if] = ACTIONS(7115),
    [anon_sym_for] = ACTIONS(7115),
    [anon_sym_while] = ACTIONS(7115),
    [anon_sym_repeat] = ACTIONS(7115),
    [anon_sym_QMARK] = ACTIONS(7117),
    [anon_sym_TILDE] = ACTIONS(7117),
    [anon_sym_BANG] = ACTIONS(7115),
    [anon_sym_PLUS] = ACTIONS(7117),
    [anon_sym_DASH] = ACTIONS(7115),
    [anon_sym_LT_DASH] = ACTIONS(7117),
    [anon_sym_LT_LT_DASH] = ACTIONS(7117),
    [anon_sym_COLON_EQ] = ACTIONS(7117),
    [anon_sym_DASH_GT] = ACTIONS(7115),
    [anon_sym_DASH_GT_GT] = ACTIONS(7117),
    [anon_sym_PIPE] = ACTIONS(7115),
    [anon_sym_AMP] = ACTIONS(7115),
    [anon_sym_PIPE_PIPE] = ACTIONS(7117),
    [anon_sym_AMP_AMP] = ACTIONS(7117),
    [anon_sym_LT] = ACTIONS(7115),
    [anon_sym_LT_EQ] = ACTIONS(7117),
    [anon_sym_GT] = ACTIONS(7115),
    [anon_sym_GT_EQ] = ACTIONS(7117),
    [anon_sym_EQ_EQ] = ACTIONS(7117),
    [anon_sym_BANG_EQ] = ACTIONS(7117),
    [anon_sym_STAR] = ACTIONS(7115),
    [anon_sym_SLASH] = ACTIONS(7117),
    [anon_sym_STAR_STAR] = ACTIONS(7117),
    [anon_sym_CARET] = ACTIONS(7117),
    [aux_sym_binary_operator_token1] = ACTIONS(7117),
    [anon_sym_PIPE_GT] = ACTIONS(7117),
    [anon_sym_COLON] = ACTIONS(7115),
    [anon_sym_DOLLAR] = ACTIONS(7117),
    [anon_sym_AT] = ACTIONS(7117),
    [anon_sym_COLON_COLON] = ACTIONS(7115),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7117),
    [aux_sym__hex_literal_token1] = ACTIONS(7117),
    [sym__number_literal] = ACTIONS(7115),
    [anon_sym_SQUOTE] = ACTIONS(7117),
    [anon_sym_DQUOTE] = ACTIONS(7117),
    [sym_return] = ACTIONS(7115),
    [sym_next] = ACTIONS(7115),
    [sym_break] = ACTIONS(7115),
    [sym_true] = ACTIONS(7115),
    [sym_false] = ACTIONS(7115),
    [sym_null] = ACTIONS(7115),
    [sym_inf] = ACTIONS(7115),
    [sym_nan] = ACTIONS(7115),
    [anon_sym_NA] = ACTIONS(7115),
    [anon_sym_NA_integer_] = ACTIONS(7115),
    [anon_sym_NA_real_] = ACTIONS(7115),
    [anon_sym_NA_complex_] = ACTIONS(7115),
    [anon_sym_NA_character_] = ACTIONS(7115),
    [sym_dots] = ACTIONS(7115),
    [sym_dot_dot_i] = ACTIONS(7117),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7117),
    [sym__newline] = ACTIONS(7117),
    [sym__raw_string_literal] = ACTIONS(7117),
    [sym__external_else] = ACTIONS(7117),
    [sym__external_open_parenthesis] = ACTIONS(7117),
    [sym__external_close_parenthesis] = ACTIONS(7117),
    [sym__external_open_brace] = ACTIONS(7117),
    [sym__external_open_bracket] = ACTIONS(7117),
    [sym__external_open_bracket2] = ACTIONS(7117),
  },
  [2371] = {
    [sym_identifier] = ACTIONS(7121),
    [anon_sym_BSLASH] = ACTIONS(7123),
    [anon_sym_function] = ACTIONS(7121),
    [anon_sym_EQ] = ACTIONS(7121),
    [anon_sym_if] = ACTIONS(7121),
    [anon_sym_for] = ACTIONS(7121),
    [anon_sym_while] = ACTIONS(7121),
    [anon_sym_repeat] = ACTIONS(7121),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_TILDE] = ACTIONS(7123),
    [anon_sym_BANG] = ACTIONS(7121),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_DASH] = ACTIONS(7121),
    [anon_sym_LT_DASH] = ACTIONS(7123),
    [anon_sym_LT_LT_DASH] = ACTIONS(7123),
    [anon_sym_COLON_EQ] = ACTIONS(7123),
    [anon_sym_DASH_GT] = ACTIONS(7121),
    [anon_sym_DASH_GT_GT] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_LT_EQ] = ACTIONS(7123),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
    [aux_sym_binary_operator_token1] = ACTIONS(7123),
    [anon_sym_PIPE_GT] = ACTIONS(7123),
    [anon_sym_COLON] = ACTIONS(7121),
    [anon_sym_DOLLAR] = ACTIONS(7123),
    [anon_sym_AT] = ACTIONS(7123),
    [anon_sym_L] = ACTIONS(7599),
    [anon_sym_i] = ACTIONS(7601),
    [aux_sym__hex_literal_token1] = ACTIONS(7123),
    [sym__number_literal] = ACTIONS(7121),
    [anon_sym_SQUOTE] = ACTIONS(7123),
    [anon_sym_DQUOTE] = ACTIONS(7123),
    [sym_return] = ACTIONS(7121),
    [sym_next] = ACTIONS(7121),
    [sym_break] = ACTIONS(7121),
    [sym_true] = ACTIONS(7121),
    [sym_false] = ACTIONS(7121),
    [sym_null] = ACTIONS(7121),
    [sym_inf] = ACTIONS(7121),
    [sym_nan] = ACTIONS(7121),
    [anon_sym_NA] = ACTIONS(7121),
    [anon_sym_NA_integer_] = ACTIONS(7121),
    [anon_sym_NA_real_] = ACTIONS(7121),
    [anon_sym_NA_complex_] = ACTIONS(7121),
    [anon_sym_NA_character_] = ACTIONS(7121),
    [sym_dots] = ACTIONS(7121),
    [sym_dot_dot_i] = ACTIONS(7123),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7123),
    [sym__newline] = ACTIONS(7123),
    [sym__raw_string_literal] = ACTIONS(7123),
    [sym__external_else] = ACTIONS(7123),
    [sym__external_open_parenthesis] = ACTIONS(7123),
    [sym__external_close_parenthesis] = ACTIONS(7123),
    [sym__external_open_brace] = ACTIONS(7123),
    [sym__external_open_bracket] = ACTIONS(7123),
    [sym__external_open_bracket2] = ACTIONS(7123),
  },
  [2372] = {
    [sym_identifier] = ACTIONS(7129),
    [anon_sym_BSLASH] = ACTIONS(7131),
    [anon_sym_function] = ACTIONS(7129),
    [anon_sym_EQ] = ACTIONS(7129),
    [anon_sym_if] = ACTIONS(7129),
    [anon_sym_for] = ACTIONS(7129),
    [anon_sym_while] = ACTIONS(7129),
    [anon_sym_repeat] = ACTIONS(7129),
    [anon_sym_QMARK] = ACTIONS(7131),
    [anon_sym_TILDE] = ACTIONS(7131),
    [anon_sym_BANG] = ACTIONS(7129),
    [anon_sym_PLUS] = ACTIONS(7131),
    [anon_sym_DASH] = ACTIONS(7129),
    [anon_sym_LT_DASH] = ACTIONS(7131),
    [anon_sym_LT_LT_DASH] = ACTIONS(7131),
    [anon_sym_COLON_EQ] = ACTIONS(7131),
    [anon_sym_DASH_GT] = ACTIONS(7129),
    [anon_sym_DASH_GT_GT] = ACTIONS(7131),
    [anon_sym_PIPE] = ACTIONS(7129),
    [anon_sym_AMP] = ACTIONS(7129),
    [anon_sym_PIPE_PIPE] = ACTIONS(7131),
    [anon_sym_AMP_AMP] = ACTIONS(7131),
    [anon_sym_LT] = ACTIONS(7129),
    [anon_sym_LT_EQ] = ACTIONS(7131),
    [anon_sym_GT] = ACTIONS(7129),
    [anon_sym_GT_EQ] = ACTIONS(7131),
    [anon_sym_EQ_EQ] = ACTIONS(7131),
    [anon_sym_BANG_EQ] = ACTIONS(7131),
    [anon_sym_STAR] = ACTIONS(7129),
    [anon_sym_SLASH] = ACTIONS(7131),
    [anon_sym_STAR_STAR] = ACTIONS(7131),
    [anon_sym_CARET] = ACTIONS(7131),
    [aux_sym_binary_operator_token1] = ACTIONS(7131),
    [anon_sym_PIPE_GT] = ACTIONS(7131),
    [anon_sym_COLON] = ACTIONS(7129),
    [anon_sym_DOLLAR] = ACTIONS(7131),
    [anon_sym_AT] = ACTIONS(7131),
    [anon_sym_COLON_COLON] = ACTIONS(7133),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7135),
    [aux_sym__hex_literal_token1] = ACTIONS(7131),
    [sym__number_literal] = ACTIONS(7129),
    [anon_sym_SQUOTE] = ACTIONS(7131),
    [anon_sym_DQUOTE] = ACTIONS(7131),
    [sym_return] = ACTIONS(7129),
    [sym_next] = ACTIONS(7129),
    [sym_break] = ACTIONS(7129),
    [sym_true] = ACTIONS(7129),
    [sym_false] = ACTIONS(7129),
    [sym_null] = ACTIONS(7129),
    [sym_inf] = ACTIONS(7129),
    [sym_nan] = ACTIONS(7129),
    [anon_sym_NA] = ACTIONS(7129),
    [anon_sym_NA_integer_] = ACTIONS(7129),
    [anon_sym_NA_real_] = ACTIONS(7129),
    [anon_sym_NA_complex_] = ACTIONS(7129),
    [anon_sym_NA_character_] = ACTIONS(7129),
    [sym_dots] = ACTIONS(7129),
    [sym_dot_dot_i] = ACTIONS(7131),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7131),
    [sym__newline] = ACTIONS(7131),
    [sym__raw_string_literal] = ACTIONS(7131),
    [sym__external_else] = ACTIONS(7131),
    [sym__external_open_parenthesis] = ACTIONS(7131),
    [sym__external_close_parenthesis] = ACTIONS(7131),
    [sym__external_open_brace] = ACTIONS(7131),
    [sym__external_open_bracket] = ACTIONS(7131),
    [sym__external_open_bracket2] = ACTIONS(7131),
  },
  [2373] = {
    [sym_identifier] = ACTIONS(7137),
    [anon_sym_BSLASH] = ACTIONS(7139),
    [anon_sym_function] = ACTIONS(7137),
    [anon_sym_EQ] = ACTIONS(7137),
    [anon_sym_if] = ACTIONS(7137),
    [anon_sym_for] = ACTIONS(7137),
    [anon_sym_while] = ACTIONS(7137),
    [anon_sym_repeat] = ACTIONS(7137),
    [anon_sym_QMARK] = ACTIONS(7139),
    [anon_sym_TILDE] = ACTIONS(7139),
    [anon_sym_BANG] = ACTIONS(7137),
    [anon_sym_PLUS] = ACTIONS(7139),
    [anon_sym_DASH] = ACTIONS(7137),
    [anon_sym_LT_DASH] = ACTIONS(7139),
    [anon_sym_LT_LT_DASH] = ACTIONS(7139),
    [anon_sym_COLON_EQ] = ACTIONS(7139),
    [anon_sym_DASH_GT] = ACTIONS(7137),
    [anon_sym_DASH_GT_GT] = ACTIONS(7139),
    [anon_sym_PIPE] = ACTIONS(7137),
    [anon_sym_AMP] = ACTIONS(7137),
    [anon_sym_PIPE_PIPE] = ACTIONS(7139),
    [anon_sym_AMP_AMP] = ACTIONS(7139),
    [anon_sym_LT] = ACTIONS(7137),
    [anon_sym_LT_EQ] = ACTIONS(7139),
    [anon_sym_GT] = ACTIONS(7137),
    [anon_sym_GT_EQ] = ACTIONS(7139),
    [anon_sym_EQ_EQ] = ACTIONS(7139),
    [anon_sym_BANG_EQ] = ACTIONS(7139),
    [anon_sym_STAR] = ACTIONS(7137),
    [anon_sym_SLASH] = ACTIONS(7139),
    [anon_sym_STAR_STAR] = ACTIONS(7139),
    [anon_sym_CARET] = ACTIONS(7139),
    [aux_sym_binary_operator_token1] = ACTIONS(7139),
    [anon_sym_PIPE_GT] = ACTIONS(7139),
    [anon_sym_COLON] = ACTIONS(7137),
    [anon_sym_DOLLAR] = ACTIONS(7139),
    [anon_sym_AT] = ACTIONS(7139),
    [anon_sym_COLON_COLON] = ACTIONS(7137),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7139),
    [aux_sym__hex_literal_token1] = ACTIONS(7139),
    [sym__number_literal] = ACTIONS(7137),
    [anon_sym_SQUOTE] = ACTIONS(7139),
    [anon_sym_DQUOTE] = ACTIONS(7139),
    [sym_return] = ACTIONS(7137),
    [sym_next] = ACTIONS(7137),
    [sym_break] = ACTIONS(7137),
    [sym_true] = ACTIONS(7137),
    [sym_false] = ACTIONS(7137),
    [sym_null] = ACTIONS(7137),
    [sym_inf] = ACTIONS(7137),
    [sym_nan] = ACTIONS(7137),
    [anon_sym_NA] = ACTIONS(7137),
    [anon_sym_NA_integer_] = ACTIONS(7137),
    [anon_sym_NA_real_] = ACTIONS(7137),
    [anon_sym_NA_complex_] = ACTIONS(7137),
    [anon_sym_NA_character_] = ACTIONS(7137),
    [sym_dots] = ACTIONS(7137),
    [sym_dot_dot_i] = ACTIONS(7139),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7139),
    [sym__newline] = ACTIONS(7139),
    [sym__raw_string_literal] = ACTIONS(7139),
    [sym__external_else] = ACTIONS(7139),
    [sym__external_open_parenthesis] = ACTIONS(7139),
    [sym__external_close_parenthesis] = ACTIONS(7139),
    [sym__external_open_brace] = ACTIONS(7139),
    [sym__external_open_bracket] = ACTIONS(7139),
    [sym__external_open_bracket2] = ACTIONS(7139),
  },
  [2374] = {
    [sym_identifier] = ACTIONS(5311),
    [anon_sym_BSLASH] = ACTIONS(5313),
    [anon_sym_function] = ACTIONS(5311),
    [anon_sym_EQ] = ACTIONS(5311),
    [anon_sym_if] = ACTIONS(5311),
    [anon_sym_for] = ACTIONS(5311),
    [anon_sym_while] = ACTIONS(5311),
    [anon_sym_repeat] = ACTIONS(5311),
    [anon_sym_QMARK] = ACTIONS(5313),
    [anon_sym_TILDE] = ACTIONS(5313),
    [anon_sym_BANG] = ACTIONS(5311),
    [anon_sym_PLUS] = ACTIONS(5313),
    [anon_sym_DASH] = ACTIONS(5311),
    [anon_sym_LT_DASH] = ACTIONS(5313),
    [anon_sym_LT_LT_DASH] = ACTIONS(5313),
    [anon_sym_COLON_EQ] = ACTIONS(5313),
    [anon_sym_DASH_GT] = ACTIONS(5311),
    [anon_sym_DASH_GT_GT] = ACTIONS(5313),
    [anon_sym_PIPE] = ACTIONS(5311),
    [anon_sym_AMP] = ACTIONS(5311),
    [anon_sym_PIPE_PIPE] = ACTIONS(5313),
    [anon_sym_AMP_AMP] = ACTIONS(5313),
    [anon_sym_LT] = ACTIONS(5311),
    [anon_sym_LT_EQ] = ACTIONS(5313),
    [anon_sym_GT] = ACTIONS(5311),
    [anon_sym_GT_EQ] = ACTIONS(5313),
    [anon_sym_EQ_EQ] = ACTIONS(5313),
    [anon_sym_BANG_EQ] = ACTIONS(5313),
    [anon_sym_STAR] = ACTIONS(5311),
    [anon_sym_SLASH] = ACTIONS(5313),
    [anon_sym_STAR_STAR] = ACTIONS(5313),
    [anon_sym_CARET] = ACTIONS(5313),
    [aux_sym_binary_operator_token1] = ACTIONS(5313),
    [anon_sym_PIPE_GT] = ACTIONS(5313),
    [anon_sym_COLON] = ACTIONS(5311),
    [anon_sym_DOLLAR] = ACTIONS(5313),
    [anon_sym_AT] = ACTIONS(5313),
    [aux_sym__hex_literal_token1] = ACTIONS(5313),
    [sym__number_literal] = ACTIONS(5311),
    [anon_sym_SQUOTE] = ACTIONS(5313),
    [anon_sym_DQUOTE] = ACTIONS(5313),
    [sym_return] = ACTIONS(5311),
    [sym_next] = ACTIONS(5311),
    [sym_break] = ACTIONS(5311),
    [sym_true] = ACTIONS(5311),
    [sym_false] = ACTIONS(5311),
    [sym_null] = ACTIONS(5311),
    [sym_inf] = ACTIONS(5311),
    [sym_nan] = ACTIONS(5311),
    [anon_sym_NA] = ACTIONS(5311),
    [anon_sym_NA_integer_] = ACTIONS(5311),
    [anon_sym_NA_real_] = ACTIONS(5311),
    [anon_sym_NA_complex_] = ACTIONS(5311),
    [anon_sym_NA_character_] = ACTIONS(5311),
    [sym_dots] = ACTIONS(5311),
    [sym_dot_dot_i] = ACTIONS(5313),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5313),
    [sym__newline] = ACTIONS(5313),
    [sym__semicolon] = ACTIONS(5313),
    [sym__raw_string_literal] = ACTIONS(5313),
    [sym__external_open_parenthesis] = ACTIONS(5313),
    [sym__external_close_parenthesis] = ACTIONS(5313),
    [sym__external_open_brace] = ACTIONS(5313),
    [sym__external_close_brace] = ACTIONS(5313),
    [sym__external_open_bracket] = ACTIONS(5313),
    [sym__external_close_bracket] = ACTIONS(5313),
    [sym__external_open_bracket2] = ACTIONS(5313),
  },
  [2375] = {
    [ts_builtin_sym_end] = ACTIONS(7193),
    [sym_identifier] = ACTIONS(7195),
    [anon_sym_BSLASH] = ACTIONS(7193),
    [anon_sym_function] = ACTIONS(7195),
    [anon_sym_EQ] = ACTIONS(7195),
    [anon_sym_if] = ACTIONS(7195),
    [anon_sym_for] = ACTIONS(7195),
    [anon_sym_while] = ACTIONS(7195),
    [anon_sym_repeat] = ACTIONS(7195),
    [anon_sym_QMARK] = ACTIONS(7193),
    [anon_sym_TILDE] = ACTIONS(7193),
    [anon_sym_BANG] = ACTIONS(7195),
    [anon_sym_PLUS] = ACTIONS(7193),
    [anon_sym_DASH] = ACTIONS(7195),
    [anon_sym_LT_DASH] = ACTIONS(7193),
    [anon_sym_LT_LT_DASH] = ACTIONS(7193),
    [anon_sym_COLON_EQ] = ACTIONS(7193),
    [anon_sym_DASH_GT] = ACTIONS(7195),
    [anon_sym_DASH_GT_GT] = ACTIONS(7193),
    [anon_sym_PIPE] = ACTIONS(7195),
    [anon_sym_AMP] = ACTIONS(7195),
    [anon_sym_PIPE_PIPE] = ACTIONS(7193),
    [anon_sym_AMP_AMP] = ACTIONS(7193),
    [anon_sym_LT] = ACTIONS(7195),
    [anon_sym_LT_EQ] = ACTIONS(7193),
    [anon_sym_GT] = ACTIONS(7195),
    [anon_sym_GT_EQ] = ACTIONS(7193),
    [anon_sym_EQ_EQ] = ACTIONS(7193),
    [anon_sym_BANG_EQ] = ACTIONS(7193),
    [anon_sym_STAR] = ACTIONS(7195),
    [anon_sym_SLASH] = ACTIONS(7193),
    [anon_sym_STAR_STAR] = ACTIONS(7193),
    [anon_sym_CARET] = ACTIONS(7193),
    [aux_sym_binary_operator_token1] = ACTIONS(7193),
    [anon_sym_PIPE_GT] = ACTIONS(7193),
    [anon_sym_COLON] = ACTIONS(7195),
    [anon_sym_DOLLAR] = ACTIONS(7193),
    [anon_sym_AT] = ACTIONS(7193),
    [anon_sym_COLON_COLON] = ACTIONS(7195),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7193),
    [aux_sym__hex_literal_token1] = ACTIONS(7193),
    [sym__number_literal] = ACTIONS(7195),
    [anon_sym_SQUOTE] = ACTIONS(7193),
    [anon_sym_DQUOTE] = ACTIONS(7193),
    [sym_return] = ACTIONS(7195),
    [sym_next] = ACTIONS(7195),
    [sym_break] = ACTIONS(7195),
    [sym_true] = ACTIONS(7195),
    [sym_false] = ACTIONS(7195),
    [sym_null] = ACTIONS(7195),
    [sym_inf] = ACTIONS(7195),
    [sym_nan] = ACTIONS(7195),
    [anon_sym_NA] = ACTIONS(7195),
    [anon_sym_NA_integer_] = ACTIONS(7195),
    [anon_sym_NA_real_] = ACTIONS(7195),
    [anon_sym_NA_complex_] = ACTIONS(7195),
    [anon_sym_NA_character_] = ACTIONS(7195),
    [sym_dots] = ACTIONS(7195),
    [sym_dot_dot_i] = ACTIONS(7193),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7193),
    [sym__semicolon] = ACTIONS(7193),
    [sym__raw_string_literal] = ACTIONS(7193),
    [sym__external_open_parenthesis] = ACTIONS(7193),
    [sym__external_close_parenthesis] = ACTIONS(7193),
    [sym__external_open_brace] = ACTIONS(7193),
    [sym__external_open_bracket] = ACTIONS(7193),
    [sym__external_open_bracket2] = ACTIONS(7193),
  },
  [2376] = {
    [ts_builtin_sym_end] = ACTIONS(7189),
    [sym_identifier] = ACTIONS(7191),
    [anon_sym_BSLASH] = ACTIONS(7189),
    [anon_sym_function] = ACTIONS(7191),
    [anon_sym_EQ] = ACTIONS(7191),
    [anon_sym_if] = ACTIONS(7191),
    [anon_sym_for] = ACTIONS(7191),
    [anon_sym_while] = ACTIONS(7191),
    [anon_sym_repeat] = ACTIONS(7191),
    [anon_sym_QMARK] = ACTIONS(7189),
    [anon_sym_TILDE] = ACTIONS(7189),
    [anon_sym_BANG] = ACTIONS(7191),
    [anon_sym_PLUS] = ACTIONS(7189),
    [anon_sym_DASH] = ACTIONS(7191),
    [anon_sym_LT_DASH] = ACTIONS(7189),
    [anon_sym_LT_LT_DASH] = ACTIONS(7189),
    [anon_sym_COLON_EQ] = ACTIONS(7189),
    [anon_sym_DASH_GT] = ACTIONS(7191),
    [anon_sym_DASH_GT_GT] = ACTIONS(7189),
    [anon_sym_PIPE] = ACTIONS(7191),
    [anon_sym_AMP] = ACTIONS(7191),
    [anon_sym_PIPE_PIPE] = ACTIONS(7189),
    [anon_sym_AMP_AMP] = ACTIONS(7189),
    [anon_sym_LT] = ACTIONS(7191),
    [anon_sym_LT_EQ] = ACTIONS(7189),
    [anon_sym_GT] = ACTIONS(7191),
    [anon_sym_GT_EQ] = ACTIONS(7189),
    [anon_sym_EQ_EQ] = ACTIONS(7189),
    [anon_sym_BANG_EQ] = ACTIONS(7189),
    [anon_sym_STAR] = ACTIONS(7191),
    [anon_sym_SLASH] = ACTIONS(7189),
    [anon_sym_STAR_STAR] = ACTIONS(7189),
    [anon_sym_CARET] = ACTIONS(7189),
    [aux_sym_binary_operator_token1] = ACTIONS(7189),
    [anon_sym_PIPE_GT] = ACTIONS(7189),
    [anon_sym_COLON] = ACTIONS(7191),
    [anon_sym_DOLLAR] = ACTIONS(7189),
    [anon_sym_AT] = ACTIONS(7189),
    [anon_sym_COLON_COLON] = ACTIONS(7191),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7189),
    [aux_sym__hex_literal_token1] = ACTIONS(7189),
    [sym__number_literal] = ACTIONS(7191),
    [anon_sym_SQUOTE] = ACTIONS(7189),
    [anon_sym_DQUOTE] = ACTIONS(7189),
    [sym_return] = ACTIONS(7191),
    [sym_next] = ACTIONS(7191),
    [sym_break] = ACTIONS(7191),
    [sym_true] = ACTIONS(7191),
    [sym_false] = ACTIONS(7191),
    [sym_null] = ACTIONS(7191),
    [sym_inf] = ACTIONS(7191),
    [sym_nan] = ACTIONS(7191),
    [anon_sym_NA] = ACTIONS(7191),
    [anon_sym_NA_integer_] = ACTIONS(7191),
    [anon_sym_NA_real_] = ACTIONS(7191),
    [anon_sym_NA_complex_] = ACTIONS(7191),
    [anon_sym_NA_character_] = ACTIONS(7191),
    [sym_dots] = ACTIONS(7191),
    [sym_dot_dot_i] = ACTIONS(7189),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7189),
    [sym__semicolon] = ACTIONS(7189),
    [sym__raw_string_literal] = ACTIONS(7189),
    [sym__external_open_parenthesis] = ACTIONS(7189),
    [sym__external_close_parenthesis] = ACTIONS(7189),
    [sym__external_open_brace] = ACTIONS(7189),
    [sym__external_open_bracket] = ACTIONS(7189),
    [sym__external_open_bracket2] = ACTIONS(7189),
  },
  [2377] = {
    [sym_identifier] = ACTIONS(7137),
    [anon_sym_BSLASH] = ACTIONS(7139),
    [anon_sym_function] = ACTIONS(7137),
    [anon_sym_EQ] = ACTIONS(7137),
    [anon_sym_if] = ACTIONS(7137),
    [anon_sym_for] = ACTIONS(7137),
    [anon_sym_while] = ACTIONS(7137),
    [anon_sym_repeat] = ACTIONS(7137),
    [anon_sym_QMARK] = ACTIONS(7139),
    [anon_sym_TILDE] = ACTIONS(7139),
    [anon_sym_BANG] = ACTIONS(7137),
    [anon_sym_PLUS] = ACTIONS(7139),
    [anon_sym_DASH] = ACTIONS(7137),
    [anon_sym_LT_DASH] = ACTIONS(7139),
    [anon_sym_LT_LT_DASH] = ACTIONS(7139),
    [anon_sym_COLON_EQ] = ACTIONS(7139),
    [anon_sym_DASH_GT] = ACTIONS(7137),
    [anon_sym_DASH_GT_GT] = ACTIONS(7139),
    [anon_sym_PIPE] = ACTIONS(7137),
    [anon_sym_AMP] = ACTIONS(7137),
    [anon_sym_PIPE_PIPE] = ACTIONS(7139),
    [anon_sym_AMP_AMP] = ACTIONS(7139),
    [anon_sym_LT] = ACTIONS(7137),
    [anon_sym_LT_EQ] = ACTIONS(7139),
    [anon_sym_GT] = ACTIONS(7137),
    [anon_sym_GT_EQ] = ACTIONS(7139),
    [anon_sym_EQ_EQ] = ACTIONS(7139),
    [anon_sym_BANG_EQ] = ACTIONS(7139),
    [anon_sym_STAR] = ACTIONS(7137),
    [anon_sym_SLASH] = ACTIONS(7139),
    [anon_sym_STAR_STAR] = ACTIONS(7139),
    [anon_sym_CARET] = ACTIONS(7139),
    [aux_sym_binary_operator_token1] = ACTIONS(7139),
    [anon_sym_PIPE_GT] = ACTIONS(7139),
    [anon_sym_COLON] = ACTIONS(7137),
    [anon_sym_DOLLAR] = ACTIONS(7139),
    [anon_sym_AT] = ACTIONS(7139),
    [anon_sym_COLON_COLON] = ACTIONS(7137),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7139),
    [aux_sym__hex_literal_token1] = ACTIONS(7139),
    [sym__number_literal] = ACTIONS(7137),
    [anon_sym_SQUOTE] = ACTIONS(7139),
    [anon_sym_DQUOTE] = ACTIONS(7139),
    [sym_return] = ACTIONS(7137),
    [sym_next] = ACTIONS(7137),
    [sym_break] = ACTIONS(7137),
    [sym_true] = ACTIONS(7137),
    [sym_false] = ACTIONS(7137),
    [sym_null] = ACTIONS(7137),
    [sym_inf] = ACTIONS(7137),
    [sym_nan] = ACTIONS(7137),
    [anon_sym_NA] = ACTIONS(7137),
    [anon_sym_NA_integer_] = ACTIONS(7137),
    [anon_sym_NA_real_] = ACTIONS(7137),
    [anon_sym_NA_complex_] = ACTIONS(7137),
    [anon_sym_NA_character_] = ACTIONS(7137),
    [sym_dots] = ACTIONS(7137),
    [sym_dot_dot_i] = ACTIONS(7139),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7139),
    [sym__newline] = ACTIONS(7139),
    [sym__raw_string_literal] = ACTIONS(7139),
    [sym__external_else] = ACTIONS(7139),
    [sym__external_open_parenthesis] = ACTIONS(7139),
    [sym__external_open_brace] = ACTIONS(7139),
    [sym__external_open_bracket] = ACTIONS(7139),
    [sym__external_open_bracket2] = ACTIONS(7139),
    [sym__external_close_bracket2] = ACTIONS(7139),
  },
  [2378] = {
    [sym_identifier] = ACTIONS(7129),
    [anon_sym_BSLASH] = ACTIONS(7131),
    [anon_sym_function] = ACTIONS(7129),
    [anon_sym_EQ] = ACTIONS(7129),
    [anon_sym_if] = ACTIONS(7129),
    [anon_sym_for] = ACTIONS(7129),
    [anon_sym_while] = ACTIONS(7129),
    [anon_sym_repeat] = ACTIONS(7129),
    [anon_sym_QMARK] = ACTIONS(7131),
    [anon_sym_TILDE] = ACTIONS(7131),
    [anon_sym_BANG] = ACTIONS(7129),
    [anon_sym_PLUS] = ACTIONS(7131),
    [anon_sym_DASH] = ACTIONS(7129),
    [anon_sym_LT_DASH] = ACTIONS(7131),
    [anon_sym_LT_LT_DASH] = ACTIONS(7131),
    [anon_sym_COLON_EQ] = ACTIONS(7131),
    [anon_sym_DASH_GT] = ACTIONS(7129),
    [anon_sym_DASH_GT_GT] = ACTIONS(7131),
    [anon_sym_PIPE] = ACTIONS(7129),
    [anon_sym_AMP] = ACTIONS(7129),
    [anon_sym_PIPE_PIPE] = ACTIONS(7131),
    [anon_sym_AMP_AMP] = ACTIONS(7131),
    [anon_sym_LT] = ACTIONS(7129),
    [anon_sym_LT_EQ] = ACTIONS(7131),
    [anon_sym_GT] = ACTIONS(7129),
    [anon_sym_GT_EQ] = ACTIONS(7131),
    [anon_sym_EQ_EQ] = ACTIONS(7131),
    [anon_sym_BANG_EQ] = ACTIONS(7131),
    [anon_sym_STAR] = ACTIONS(7129),
    [anon_sym_SLASH] = ACTIONS(7131),
    [anon_sym_STAR_STAR] = ACTIONS(7131),
    [anon_sym_CARET] = ACTIONS(7131),
    [aux_sym_binary_operator_token1] = ACTIONS(7131),
    [anon_sym_PIPE_GT] = ACTIONS(7131),
    [anon_sym_COLON] = ACTIONS(7129),
    [anon_sym_DOLLAR] = ACTIONS(7131),
    [anon_sym_AT] = ACTIONS(7131),
    [anon_sym_COLON_COLON] = ACTIONS(7133),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7135),
    [aux_sym__hex_literal_token1] = ACTIONS(7131),
    [sym__number_literal] = ACTIONS(7129),
    [anon_sym_SQUOTE] = ACTIONS(7131),
    [anon_sym_DQUOTE] = ACTIONS(7131),
    [sym_return] = ACTIONS(7129),
    [sym_next] = ACTIONS(7129),
    [sym_break] = ACTIONS(7129),
    [sym_true] = ACTIONS(7129),
    [sym_false] = ACTIONS(7129),
    [sym_null] = ACTIONS(7129),
    [sym_inf] = ACTIONS(7129),
    [sym_nan] = ACTIONS(7129),
    [anon_sym_NA] = ACTIONS(7129),
    [anon_sym_NA_integer_] = ACTIONS(7129),
    [anon_sym_NA_real_] = ACTIONS(7129),
    [anon_sym_NA_complex_] = ACTIONS(7129),
    [anon_sym_NA_character_] = ACTIONS(7129),
    [sym_dots] = ACTIONS(7129),
    [sym_dot_dot_i] = ACTIONS(7131),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7131),
    [sym__newline] = ACTIONS(7131),
    [sym__raw_string_literal] = ACTIONS(7131),
    [sym__external_else] = ACTIONS(7131),
    [sym__external_open_parenthesis] = ACTIONS(7131),
    [sym__external_open_brace] = ACTIONS(7131),
    [sym__external_open_bracket] = ACTIONS(7131),
    [sym__external_open_bracket2] = ACTIONS(7131),
    [sym__external_close_bracket2] = ACTIONS(7131),
  },
  [2379] = {
    [sym_identifier] = ACTIONS(5325),
    [anon_sym_BSLASH] = ACTIONS(5327),
    [anon_sym_function] = ACTIONS(5325),
    [anon_sym_EQ] = ACTIONS(5325),
    [anon_sym_if] = ACTIONS(5325),
    [anon_sym_for] = ACTIONS(5325),
    [anon_sym_while] = ACTIONS(5325),
    [anon_sym_repeat] = ACTIONS(5325),
    [anon_sym_QMARK] = ACTIONS(5327),
    [anon_sym_TILDE] = ACTIONS(5327),
    [anon_sym_BANG] = ACTIONS(5325),
    [anon_sym_PLUS] = ACTIONS(5327),
    [anon_sym_DASH] = ACTIONS(5325),
    [anon_sym_LT_DASH] = ACTIONS(5327),
    [anon_sym_LT_LT_DASH] = ACTIONS(5327),
    [anon_sym_COLON_EQ] = ACTIONS(5327),
    [anon_sym_DASH_GT] = ACTIONS(5325),
    [anon_sym_DASH_GT_GT] = ACTIONS(5327),
    [anon_sym_PIPE] = ACTIONS(5325),
    [anon_sym_AMP] = ACTIONS(5325),
    [anon_sym_PIPE_PIPE] = ACTIONS(5327),
    [anon_sym_AMP_AMP] = ACTIONS(5327),
    [anon_sym_LT] = ACTIONS(5325),
    [anon_sym_LT_EQ] = ACTIONS(5327),
    [anon_sym_GT] = ACTIONS(5325),
    [anon_sym_GT_EQ] = ACTIONS(5327),
    [anon_sym_EQ_EQ] = ACTIONS(5327),
    [anon_sym_BANG_EQ] = ACTIONS(5327),
    [anon_sym_STAR] = ACTIONS(5325),
    [anon_sym_SLASH] = ACTIONS(5327),
    [anon_sym_STAR_STAR] = ACTIONS(5327),
    [anon_sym_CARET] = ACTIONS(5327),
    [aux_sym_binary_operator_token1] = ACTIONS(5327),
    [anon_sym_PIPE_GT] = ACTIONS(5327),
    [anon_sym_COLON] = ACTIONS(5325),
    [anon_sym_DOLLAR] = ACTIONS(5327),
    [anon_sym_AT] = ACTIONS(5327),
    [aux_sym__hex_literal_token1] = ACTIONS(5327),
    [sym__number_literal] = ACTIONS(5325),
    [anon_sym_SQUOTE] = ACTIONS(5327),
    [anon_sym_DQUOTE] = ACTIONS(5327),
    [sym_return] = ACTIONS(5325),
    [sym_next] = ACTIONS(5325),
    [sym_break] = ACTIONS(5325),
    [sym_true] = ACTIONS(5325),
    [sym_false] = ACTIONS(5325),
    [sym_null] = ACTIONS(5325),
    [sym_inf] = ACTIONS(5325),
    [sym_nan] = ACTIONS(5325),
    [anon_sym_NA] = ACTIONS(5325),
    [anon_sym_NA_integer_] = ACTIONS(5325),
    [anon_sym_NA_real_] = ACTIONS(5325),
    [anon_sym_NA_complex_] = ACTIONS(5325),
    [anon_sym_NA_character_] = ACTIONS(5325),
    [sym_dots] = ACTIONS(5325),
    [sym_dot_dot_i] = ACTIONS(5327),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5327),
    [sym__newline] = ACTIONS(5327),
    [sym__semicolon] = ACTIONS(5327),
    [sym__raw_string_literal] = ACTIONS(5327),
    [sym__external_open_parenthesis] = ACTIONS(5327),
    [sym__external_close_parenthesis] = ACTIONS(5327),
    [sym__external_open_brace] = ACTIONS(5327),
    [sym__external_close_brace] = ACTIONS(5327),
    [sym__external_open_bracket] = ACTIONS(5327),
    [sym__external_open_bracket2] = ACTIONS(5327),
    [sym__external_close_bracket2] = ACTIONS(5327),
  },
  [2380] = {
    [sym_identifier] = ACTIONS(7532),
    [anon_sym_BSLASH] = ACTIONS(7530),
    [anon_sym_function] = ACTIONS(7532),
    [anon_sym_EQ] = ACTIONS(7532),
    [anon_sym_if] = ACTIONS(7532),
    [anon_sym_for] = ACTIONS(7532),
    [anon_sym_while] = ACTIONS(7532),
    [anon_sym_repeat] = ACTIONS(7532),
    [anon_sym_QMARK] = ACTIONS(7530),
    [anon_sym_TILDE] = ACTIONS(7530),
    [anon_sym_BANG] = ACTIONS(7532),
    [anon_sym_PLUS] = ACTIONS(7530),
    [anon_sym_DASH] = ACTIONS(7532),
    [anon_sym_LT_DASH] = ACTIONS(7530),
    [anon_sym_LT_LT_DASH] = ACTIONS(7530),
    [anon_sym_COLON_EQ] = ACTIONS(7530),
    [anon_sym_DASH_GT] = ACTIONS(7532),
    [anon_sym_DASH_GT_GT] = ACTIONS(7530),
    [anon_sym_PIPE] = ACTIONS(7532),
    [anon_sym_AMP] = ACTIONS(7532),
    [anon_sym_PIPE_PIPE] = ACTIONS(7530),
    [anon_sym_AMP_AMP] = ACTIONS(7530),
    [anon_sym_LT] = ACTIONS(7532),
    [anon_sym_LT_EQ] = ACTIONS(7530),
    [anon_sym_GT] = ACTIONS(7532),
    [anon_sym_GT_EQ] = ACTIONS(7530),
    [anon_sym_EQ_EQ] = ACTIONS(7530),
    [anon_sym_BANG_EQ] = ACTIONS(7530),
    [anon_sym_STAR] = ACTIONS(7532),
    [anon_sym_SLASH] = ACTIONS(7530),
    [anon_sym_STAR_STAR] = ACTIONS(7530),
    [anon_sym_CARET] = ACTIONS(7530),
    [aux_sym_binary_operator_token1] = ACTIONS(7530),
    [anon_sym_PIPE_GT] = ACTIONS(7530),
    [anon_sym_COLON] = ACTIONS(7532),
    [anon_sym_DOLLAR] = ACTIONS(7530),
    [anon_sym_AT] = ACTIONS(7530),
    [aux_sym__hex_literal_token1] = ACTIONS(7530),
    [sym__number_literal] = ACTIONS(7532),
    [anon_sym_SQUOTE] = ACTIONS(7530),
    [anon_sym_DQUOTE] = ACTIONS(7530),
    [sym_return] = ACTIONS(7532),
    [sym_next] = ACTIONS(7532),
    [sym_break] = ACTIONS(7532),
    [sym_true] = ACTIONS(7532),
    [sym_false] = ACTIONS(7532),
    [sym_null] = ACTIONS(7532),
    [sym_inf] = ACTIONS(7532),
    [sym_nan] = ACTIONS(7532),
    [anon_sym_NA] = ACTIONS(7532),
    [anon_sym_NA_integer_] = ACTIONS(7532),
    [anon_sym_NA_real_] = ACTIONS(7532),
    [anon_sym_NA_complex_] = ACTIONS(7532),
    [anon_sym_NA_character_] = ACTIONS(7532),
    [sym_dots] = ACTIONS(7532),
    [sym_dot_dot_i] = ACTIONS(7530),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7530),
    [sym__newline] = ACTIONS(7530),
    [sym__semicolon] = ACTIONS(7530),
    [sym__raw_string_literal] = ACTIONS(7530),
    [sym__external_open_parenthesis] = ACTIONS(7530),
    [sym__external_close_parenthesis] = ACTIONS(7530),
    [sym__external_open_brace] = ACTIONS(7530),
    [sym__external_close_brace] = ACTIONS(7530),
    [sym__external_open_bracket] = ACTIONS(7530),
    [sym__external_close_bracket] = ACTIONS(7530),
    [sym__external_open_bracket2] = ACTIONS(7530),
  },
  [2381] = {
    [sym_identifier] = ACTIONS(7121),
    [anon_sym_BSLASH] = ACTIONS(7123),
    [anon_sym_function] = ACTIONS(7121),
    [anon_sym_EQ] = ACTIONS(7121),
    [anon_sym_if] = ACTIONS(7121),
    [anon_sym_for] = ACTIONS(7121),
    [anon_sym_while] = ACTIONS(7121),
    [anon_sym_repeat] = ACTIONS(7121),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_TILDE] = ACTIONS(7123),
    [anon_sym_BANG] = ACTIONS(7121),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_DASH] = ACTIONS(7121),
    [anon_sym_LT_DASH] = ACTIONS(7123),
    [anon_sym_LT_LT_DASH] = ACTIONS(7123),
    [anon_sym_COLON_EQ] = ACTIONS(7123),
    [anon_sym_DASH_GT] = ACTIONS(7121),
    [anon_sym_DASH_GT_GT] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_LT_EQ] = ACTIONS(7123),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
    [aux_sym_binary_operator_token1] = ACTIONS(7123),
    [anon_sym_PIPE_GT] = ACTIONS(7123),
    [anon_sym_COLON] = ACTIONS(7121),
    [anon_sym_DOLLAR] = ACTIONS(7123),
    [anon_sym_AT] = ACTIONS(7123),
    [anon_sym_L] = ACTIONS(7603),
    [anon_sym_i] = ACTIONS(7605),
    [aux_sym__hex_literal_token1] = ACTIONS(7123),
    [sym__number_literal] = ACTIONS(7121),
    [anon_sym_SQUOTE] = ACTIONS(7123),
    [anon_sym_DQUOTE] = ACTIONS(7123),
    [sym_return] = ACTIONS(7121),
    [sym_next] = ACTIONS(7121),
    [sym_break] = ACTIONS(7121),
    [sym_true] = ACTIONS(7121),
    [sym_false] = ACTIONS(7121),
    [sym_null] = ACTIONS(7121),
    [sym_inf] = ACTIONS(7121),
    [sym_nan] = ACTIONS(7121),
    [anon_sym_NA] = ACTIONS(7121),
    [anon_sym_NA_integer_] = ACTIONS(7121),
    [anon_sym_NA_real_] = ACTIONS(7121),
    [anon_sym_NA_complex_] = ACTIONS(7121),
    [anon_sym_NA_character_] = ACTIONS(7121),
    [sym_dots] = ACTIONS(7121),
    [sym_dot_dot_i] = ACTIONS(7123),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7123),
    [sym__newline] = ACTIONS(7123),
    [sym__raw_string_literal] = ACTIONS(7123),
    [sym__external_else] = ACTIONS(7123),
    [sym__external_open_parenthesis] = ACTIONS(7123),
    [sym__external_open_brace] = ACTIONS(7123),
    [sym__external_open_bracket] = ACTIONS(7123),
    [sym__external_open_bracket2] = ACTIONS(7123),
    [sym__external_close_bracket2] = ACTIONS(7123),
  },
  [2382] = {
    [sym_identifier] = ACTIONS(7115),
    [anon_sym_BSLASH] = ACTIONS(7117),
    [anon_sym_function] = ACTIONS(7115),
    [anon_sym_EQ] = ACTIONS(7115),
    [anon_sym_if] = ACTIONS(7115),
    [anon_sym_for] = ACTIONS(7115),
    [anon_sym_while] = ACTIONS(7115),
    [anon_sym_repeat] = ACTIONS(7115),
    [anon_sym_QMARK] = ACTIONS(7117),
    [anon_sym_TILDE] = ACTIONS(7117),
    [anon_sym_BANG] = ACTIONS(7115),
    [anon_sym_PLUS] = ACTIONS(7117),
    [anon_sym_DASH] = ACTIONS(7115),
    [anon_sym_LT_DASH] = ACTIONS(7117),
    [anon_sym_LT_LT_DASH] = ACTIONS(7117),
    [anon_sym_COLON_EQ] = ACTIONS(7117),
    [anon_sym_DASH_GT] = ACTIONS(7115),
    [anon_sym_DASH_GT_GT] = ACTIONS(7117),
    [anon_sym_PIPE] = ACTIONS(7115),
    [anon_sym_AMP] = ACTIONS(7115),
    [anon_sym_PIPE_PIPE] = ACTIONS(7117),
    [anon_sym_AMP_AMP] = ACTIONS(7117),
    [anon_sym_LT] = ACTIONS(7115),
    [anon_sym_LT_EQ] = ACTIONS(7117),
    [anon_sym_GT] = ACTIONS(7115),
    [anon_sym_GT_EQ] = ACTIONS(7117),
    [anon_sym_EQ_EQ] = ACTIONS(7117),
    [anon_sym_BANG_EQ] = ACTIONS(7117),
    [anon_sym_STAR] = ACTIONS(7115),
    [anon_sym_SLASH] = ACTIONS(7117),
    [anon_sym_STAR_STAR] = ACTIONS(7117),
    [anon_sym_CARET] = ACTIONS(7117),
    [aux_sym_binary_operator_token1] = ACTIONS(7117),
    [anon_sym_PIPE_GT] = ACTIONS(7117),
    [anon_sym_COLON] = ACTIONS(7115),
    [anon_sym_DOLLAR] = ACTIONS(7117),
    [anon_sym_AT] = ACTIONS(7117),
    [anon_sym_COLON_COLON] = ACTIONS(7115),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7117),
    [aux_sym__hex_literal_token1] = ACTIONS(7117),
    [sym__number_literal] = ACTIONS(7115),
    [anon_sym_SQUOTE] = ACTIONS(7117),
    [anon_sym_DQUOTE] = ACTIONS(7117),
    [sym_return] = ACTIONS(7115),
    [sym_next] = ACTIONS(7115),
    [sym_break] = ACTIONS(7115),
    [sym_true] = ACTIONS(7115),
    [sym_false] = ACTIONS(7115),
    [sym_null] = ACTIONS(7115),
    [sym_inf] = ACTIONS(7115),
    [sym_nan] = ACTIONS(7115),
    [anon_sym_NA] = ACTIONS(7115),
    [anon_sym_NA_integer_] = ACTIONS(7115),
    [anon_sym_NA_real_] = ACTIONS(7115),
    [anon_sym_NA_complex_] = ACTIONS(7115),
    [anon_sym_NA_character_] = ACTIONS(7115),
    [sym_dots] = ACTIONS(7115),
    [sym_dot_dot_i] = ACTIONS(7117),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7117),
    [sym__newline] = ACTIONS(7117),
    [sym__raw_string_literal] = ACTIONS(7117),
    [sym__external_else] = ACTIONS(7117),
    [sym__external_open_parenthesis] = ACTIONS(7117),
    [sym__external_open_brace] = ACTIONS(7117),
    [sym__external_open_bracket] = ACTIONS(7117),
    [sym__external_open_bracket2] = ACTIONS(7117),
    [sym__external_close_bracket2] = ACTIONS(7117),
  },
  [2383] = {
    [sym_identifier] = ACTIONS(7115),
    [anon_sym_BSLASH] = ACTIONS(7117),
    [anon_sym_function] = ACTIONS(7115),
    [anon_sym_EQ] = ACTIONS(7115),
    [anon_sym_if] = ACTIONS(7115),
    [anon_sym_for] = ACTIONS(7115),
    [anon_sym_while] = ACTIONS(7115),
    [anon_sym_repeat] = ACTIONS(7115),
    [anon_sym_QMARK] = ACTIONS(7117),
    [anon_sym_TILDE] = ACTIONS(7117),
    [anon_sym_BANG] = ACTIONS(7115),
    [anon_sym_PLUS] = ACTIONS(7117),
    [anon_sym_DASH] = ACTIONS(7115),
    [anon_sym_LT_DASH] = ACTIONS(7117),
    [anon_sym_LT_LT_DASH] = ACTIONS(7117),
    [anon_sym_COLON_EQ] = ACTIONS(7117),
    [anon_sym_DASH_GT] = ACTIONS(7115),
    [anon_sym_DASH_GT_GT] = ACTIONS(7117),
    [anon_sym_PIPE] = ACTIONS(7115),
    [anon_sym_AMP] = ACTIONS(7115),
    [anon_sym_PIPE_PIPE] = ACTIONS(7117),
    [anon_sym_AMP_AMP] = ACTIONS(7117),
    [anon_sym_LT] = ACTIONS(7115),
    [anon_sym_LT_EQ] = ACTIONS(7117),
    [anon_sym_GT] = ACTIONS(7115),
    [anon_sym_GT_EQ] = ACTIONS(7117),
    [anon_sym_EQ_EQ] = ACTIONS(7117),
    [anon_sym_BANG_EQ] = ACTIONS(7117),
    [anon_sym_STAR] = ACTIONS(7115),
    [anon_sym_SLASH] = ACTIONS(7117),
    [anon_sym_STAR_STAR] = ACTIONS(7117),
    [anon_sym_CARET] = ACTIONS(7117),
    [aux_sym_binary_operator_token1] = ACTIONS(7117),
    [anon_sym_PIPE_GT] = ACTIONS(7117),
    [anon_sym_COLON] = ACTIONS(7115),
    [anon_sym_DOLLAR] = ACTIONS(7117),
    [anon_sym_AT] = ACTIONS(7117),
    [anon_sym_COLON_COLON] = ACTIONS(7115),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7117),
    [aux_sym__hex_literal_token1] = ACTIONS(7117),
    [sym__number_literal] = ACTIONS(7115),
    [anon_sym_SQUOTE] = ACTIONS(7117),
    [anon_sym_DQUOTE] = ACTIONS(7117),
    [sym_return] = ACTIONS(7115),
    [sym_next] = ACTIONS(7115),
    [sym_break] = ACTIONS(7115),
    [sym_true] = ACTIONS(7115),
    [sym_false] = ACTIONS(7115),
    [sym_null] = ACTIONS(7115),
    [sym_inf] = ACTIONS(7115),
    [sym_nan] = ACTIONS(7115),
    [anon_sym_NA] = ACTIONS(7115),
    [anon_sym_NA_integer_] = ACTIONS(7115),
    [anon_sym_NA_real_] = ACTIONS(7115),
    [anon_sym_NA_complex_] = ACTIONS(7115),
    [anon_sym_NA_character_] = ACTIONS(7115),
    [sym_dots] = ACTIONS(7115),
    [sym_dot_dot_i] = ACTIONS(7117),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7117),
    [sym__newline] = ACTIONS(7117),
    [sym__raw_string_literal] = ACTIONS(7117),
    [sym__external_else] = ACTIONS(7117),
    [sym__external_open_parenthesis] = ACTIONS(7117),
    [sym__external_open_brace] = ACTIONS(7117),
    [sym__external_open_bracket] = ACTIONS(7117),
    [sym__external_open_bracket2] = ACTIONS(7117),
    [sym__external_close_bracket2] = ACTIONS(7117),
  },
  [2384] = {
    [sym_identifier] = ACTIONS(7544),
    [anon_sym_BSLASH] = ACTIONS(7542),
    [anon_sym_function] = ACTIONS(7544),
    [anon_sym_EQ] = ACTIONS(7544),
    [anon_sym_if] = ACTIONS(7544),
    [anon_sym_for] = ACTIONS(7544),
    [anon_sym_while] = ACTIONS(7544),
    [anon_sym_repeat] = ACTIONS(7544),
    [anon_sym_QMARK] = ACTIONS(7542),
    [anon_sym_TILDE] = ACTIONS(7542),
    [anon_sym_BANG] = ACTIONS(7544),
    [anon_sym_PLUS] = ACTIONS(7542),
    [anon_sym_DASH] = ACTIONS(7544),
    [anon_sym_LT_DASH] = ACTIONS(7542),
    [anon_sym_LT_LT_DASH] = ACTIONS(7542),
    [anon_sym_COLON_EQ] = ACTIONS(7542),
    [anon_sym_DASH_GT] = ACTIONS(7544),
    [anon_sym_DASH_GT_GT] = ACTIONS(7542),
    [anon_sym_PIPE] = ACTIONS(7544),
    [anon_sym_AMP] = ACTIONS(7544),
    [anon_sym_PIPE_PIPE] = ACTIONS(7542),
    [anon_sym_AMP_AMP] = ACTIONS(7542),
    [anon_sym_LT] = ACTIONS(7544),
    [anon_sym_LT_EQ] = ACTIONS(7542),
    [anon_sym_GT] = ACTIONS(7544),
    [anon_sym_GT_EQ] = ACTIONS(7542),
    [anon_sym_EQ_EQ] = ACTIONS(7542),
    [anon_sym_BANG_EQ] = ACTIONS(7542),
    [anon_sym_STAR] = ACTIONS(7544),
    [anon_sym_SLASH] = ACTIONS(7542),
    [anon_sym_STAR_STAR] = ACTIONS(7542),
    [anon_sym_CARET] = ACTIONS(7542),
    [aux_sym_binary_operator_token1] = ACTIONS(7542),
    [anon_sym_PIPE_GT] = ACTIONS(7542),
    [anon_sym_COLON] = ACTIONS(7544),
    [anon_sym_DOLLAR] = ACTIONS(7542),
    [anon_sym_AT] = ACTIONS(7542),
    [aux_sym__hex_literal_token1] = ACTIONS(7542),
    [sym__number_literal] = ACTIONS(7544),
    [anon_sym_SQUOTE] = ACTIONS(7542),
    [anon_sym_DQUOTE] = ACTIONS(7542),
    [sym_return] = ACTIONS(7544),
    [sym_next] = ACTIONS(7544),
    [sym_break] = ACTIONS(7544),
    [sym_true] = ACTIONS(7544),
    [sym_false] = ACTIONS(7544),
    [sym_null] = ACTIONS(7544),
    [sym_inf] = ACTIONS(7544),
    [sym_nan] = ACTIONS(7544),
    [anon_sym_NA] = ACTIONS(7544),
    [anon_sym_NA_integer_] = ACTIONS(7544),
    [anon_sym_NA_real_] = ACTIONS(7544),
    [anon_sym_NA_complex_] = ACTIONS(7544),
    [anon_sym_NA_character_] = ACTIONS(7544),
    [sym_dots] = ACTIONS(7544),
    [sym_dot_dot_i] = ACTIONS(7542),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7542),
    [sym__newline] = ACTIONS(7542),
    [sym__semicolon] = ACTIONS(7542),
    [sym__raw_string_literal] = ACTIONS(7542),
    [sym__external_open_parenthesis] = ACTIONS(7542),
    [sym__external_close_parenthesis] = ACTIONS(7542),
    [sym__external_open_brace] = ACTIONS(7542),
    [sym__external_close_brace] = ACTIONS(7542),
    [sym__external_open_bracket] = ACTIONS(7542),
    [sym__external_open_bracket2] = ACTIONS(7542),
    [sym__external_close_bracket2] = ACTIONS(7542),
  },
  [2385] = {
    [sym_identifier] = ACTIONS(7528),
    [anon_sym_BSLASH] = ACTIONS(7526),
    [anon_sym_function] = ACTIONS(7528),
    [anon_sym_EQ] = ACTIONS(7528),
    [anon_sym_if] = ACTIONS(7528),
    [anon_sym_for] = ACTIONS(7528),
    [anon_sym_while] = ACTIONS(7528),
    [anon_sym_repeat] = ACTIONS(7528),
    [anon_sym_QMARK] = ACTIONS(7526),
    [anon_sym_TILDE] = ACTIONS(7526),
    [anon_sym_BANG] = ACTIONS(7528),
    [anon_sym_PLUS] = ACTIONS(7526),
    [anon_sym_DASH] = ACTIONS(7528),
    [anon_sym_LT_DASH] = ACTIONS(7526),
    [anon_sym_LT_LT_DASH] = ACTIONS(7526),
    [anon_sym_COLON_EQ] = ACTIONS(7526),
    [anon_sym_DASH_GT] = ACTIONS(7528),
    [anon_sym_DASH_GT_GT] = ACTIONS(7526),
    [anon_sym_PIPE] = ACTIONS(7528),
    [anon_sym_AMP] = ACTIONS(7528),
    [anon_sym_PIPE_PIPE] = ACTIONS(7526),
    [anon_sym_AMP_AMP] = ACTIONS(7526),
    [anon_sym_LT] = ACTIONS(7528),
    [anon_sym_LT_EQ] = ACTIONS(7526),
    [anon_sym_GT] = ACTIONS(7528),
    [anon_sym_GT_EQ] = ACTIONS(7526),
    [anon_sym_EQ_EQ] = ACTIONS(7526),
    [anon_sym_BANG_EQ] = ACTIONS(7526),
    [anon_sym_STAR] = ACTIONS(7528),
    [anon_sym_SLASH] = ACTIONS(7526),
    [anon_sym_STAR_STAR] = ACTIONS(7526),
    [anon_sym_CARET] = ACTIONS(7526),
    [aux_sym_binary_operator_token1] = ACTIONS(7526),
    [anon_sym_PIPE_GT] = ACTIONS(7526),
    [anon_sym_COLON] = ACTIONS(7528),
    [anon_sym_DOLLAR] = ACTIONS(7526),
    [anon_sym_AT] = ACTIONS(7526),
    [aux_sym__hex_literal_token1] = ACTIONS(7526),
    [sym__number_literal] = ACTIONS(7528),
    [anon_sym_SQUOTE] = ACTIONS(7526),
    [anon_sym_DQUOTE] = ACTIONS(7526),
    [sym_return] = ACTIONS(7528),
    [sym_next] = ACTIONS(7528),
    [sym_break] = ACTIONS(7528),
    [sym_true] = ACTIONS(7528),
    [sym_false] = ACTIONS(7528),
    [sym_null] = ACTIONS(7528),
    [sym_inf] = ACTIONS(7528),
    [sym_nan] = ACTIONS(7528),
    [anon_sym_NA] = ACTIONS(7528),
    [anon_sym_NA_integer_] = ACTIONS(7528),
    [anon_sym_NA_real_] = ACTIONS(7528),
    [anon_sym_NA_complex_] = ACTIONS(7528),
    [anon_sym_NA_character_] = ACTIONS(7528),
    [sym_dots] = ACTIONS(7528),
    [sym_dot_dot_i] = ACTIONS(7526),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7526),
    [sym__newline] = ACTIONS(7526),
    [sym__semicolon] = ACTIONS(7526),
    [sym__raw_string_literal] = ACTIONS(7526),
    [sym__external_open_parenthesis] = ACTIONS(7526),
    [sym__external_close_parenthesis] = ACTIONS(7526),
    [sym__external_open_brace] = ACTIONS(7526),
    [sym__external_close_brace] = ACTIONS(7526),
    [sym__external_open_bracket] = ACTIONS(7526),
    [sym__external_close_bracket] = ACTIONS(7526),
    [sym__external_open_bracket2] = ACTIONS(7526),
  },
  [2386] = {
    [sym_identifier] = ACTIONS(7151),
    [anon_sym_BSLASH] = ACTIONS(7153),
    [anon_sym_function] = ACTIONS(7151),
    [anon_sym_EQ] = ACTIONS(7151),
    [anon_sym_if] = ACTIONS(7151),
    [anon_sym_for] = ACTIONS(7151),
    [anon_sym_while] = ACTIONS(7151),
    [anon_sym_repeat] = ACTIONS(7151),
    [anon_sym_QMARK] = ACTIONS(7153),
    [anon_sym_TILDE] = ACTIONS(7153),
    [anon_sym_BANG] = ACTIONS(7151),
    [anon_sym_PLUS] = ACTIONS(7153),
    [anon_sym_DASH] = ACTIONS(7151),
    [anon_sym_LT_DASH] = ACTIONS(7153),
    [anon_sym_LT_LT_DASH] = ACTIONS(7153),
    [anon_sym_COLON_EQ] = ACTIONS(7153),
    [anon_sym_DASH_GT] = ACTIONS(7151),
    [anon_sym_DASH_GT_GT] = ACTIONS(7153),
    [anon_sym_PIPE] = ACTIONS(7151),
    [anon_sym_AMP] = ACTIONS(7151),
    [anon_sym_PIPE_PIPE] = ACTIONS(7153),
    [anon_sym_AMP_AMP] = ACTIONS(7153),
    [anon_sym_LT] = ACTIONS(7151),
    [anon_sym_LT_EQ] = ACTIONS(7153),
    [anon_sym_GT] = ACTIONS(7151),
    [anon_sym_GT_EQ] = ACTIONS(7153),
    [anon_sym_EQ_EQ] = ACTIONS(7153),
    [anon_sym_BANG_EQ] = ACTIONS(7153),
    [anon_sym_STAR] = ACTIONS(7151),
    [anon_sym_SLASH] = ACTIONS(7153),
    [anon_sym_STAR_STAR] = ACTIONS(7153),
    [anon_sym_CARET] = ACTIONS(7153),
    [aux_sym_binary_operator_token1] = ACTIONS(7153),
    [anon_sym_PIPE_GT] = ACTIONS(7153),
    [anon_sym_COLON] = ACTIONS(7151),
    [anon_sym_DOLLAR] = ACTIONS(7153),
    [anon_sym_AT] = ACTIONS(7153),
    [anon_sym_COLON_COLON] = ACTIONS(7151),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7153),
    [aux_sym__hex_literal_token1] = ACTIONS(7153),
    [sym__number_literal] = ACTIONS(7151),
    [anon_sym_SQUOTE] = ACTIONS(7153),
    [anon_sym_DQUOTE] = ACTIONS(7153),
    [sym_return] = ACTIONS(7151),
    [sym_next] = ACTIONS(7151),
    [sym_break] = ACTIONS(7151),
    [sym_true] = ACTIONS(7151),
    [sym_false] = ACTIONS(7151),
    [sym_null] = ACTIONS(7151),
    [sym_inf] = ACTIONS(7151),
    [sym_nan] = ACTIONS(7151),
    [anon_sym_NA] = ACTIONS(7151),
    [anon_sym_NA_integer_] = ACTIONS(7151),
    [anon_sym_NA_real_] = ACTIONS(7151),
    [anon_sym_NA_complex_] = ACTIONS(7151),
    [anon_sym_NA_character_] = ACTIONS(7151),
    [sym_dots] = ACTIONS(7151),
    [sym_dot_dot_i] = ACTIONS(7153),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7153),
    [sym__newline] = ACTIONS(7153),
    [sym__raw_string_literal] = ACTIONS(7153),
    [sym__external_else] = ACTIONS(7153),
    [sym__external_open_parenthesis] = ACTIONS(7153),
    [sym__external_open_brace] = ACTIONS(7153),
    [sym__external_open_bracket] = ACTIONS(7153),
    [sym__external_open_bracket2] = ACTIONS(7153),
    [sym__external_close_bracket2] = ACTIONS(7153),
  },
  [2387] = {
    [sym_identifier] = ACTIONS(7191),
    [anon_sym_BSLASH] = ACTIONS(7189),
    [anon_sym_function] = ACTIONS(7191),
    [anon_sym_EQ] = ACTIONS(7191),
    [anon_sym_if] = ACTIONS(7191),
    [anon_sym_for] = ACTIONS(7191),
    [anon_sym_while] = ACTIONS(7191),
    [anon_sym_repeat] = ACTIONS(7191),
    [anon_sym_QMARK] = ACTIONS(7189),
    [anon_sym_TILDE] = ACTIONS(7189),
    [anon_sym_BANG] = ACTIONS(7191),
    [anon_sym_PLUS] = ACTIONS(7189),
    [anon_sym_DASH] = ACTIONS(7191),
    [anon_sym_LT_DASH] = ACTIONS(7189),
    [anon_sym_LT_LT_DASH] = ACTIONS(7189),
    [anon_sym_COLON_EQ] = ACTIONS(7189),
    [anon_sym_DASH_GT] = ACTIONS(7191),
    [anon_sym_DASH_GT_GT] = ACTIONS(7189),
    [anon_sym_PIPE] = ACTIONS(7191),
    [anon_sym_AMP] = ACTIONS(7191),
    [anon_sym_PIPE_PIPE] = ACTIONS(7189),
    [anon_sym_AMP_AMP] = ACTIONS(7189),
    [anon_sym_LT] = ACTIONS(7191),
    [anon_sym_LT_EQ] = ACTIONS(7189),
    [anon_sym_GT] = ACTIONS(7191),
    [anon_sym_GT_EQ] = ACTIONS(7189),
    [anon_sym_EQ_EQ] = ACTIONS(7189),
    [anon_sym_BANG_EQ] = ACTIONS(7189),
    [anon_sym_STAR] = ACTIONS(7191),
    [anon_sym_SLASH] = ACTIONS(7189),
    [anon_sym_STAR_STAR] = ACTIONS(7189),
    [anon_sym_CARET] = ACTIONS(7189),
    [aux_sym_binary_operator_token1] = ACTIONS(7189),
    [anon_sym_PIPE_GT] = ACTIONS(7189),
    [anon_sym_COLON] = ACTIONS(7191),
    [anon_sym_DOLLAR] = ACTIONS(7189),
    [anon_sym_AT] = ACTIONS(7189),
    [anon_sym_COLON_COLON] = ACTIONS(7191),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7189),
    [aux_sym__hex_literal_token1] = ACTIONS(7189),
    [sym__number_literal] = ACTIONS(7191),
    [anon_sym_SQUOTE] = ACTIONS(7189),
    [anon_sym_DQUOTE] = ACTIONS(7189),
    [sym_return] = ACTIONS(7191),
    [sym_next] = ACTIONS(7191),
    [sym_break] = ACTIONS(7191),
    [sym_true] = ACTIONS(7191),
    [sym_false] = ACTIONS(7191),
    [sym_null] = ACTIONS(7191),
    [sym_inf] = ACTIONS(7191),
    [sym_nan] = ACTIONS(7191),
    [anon_sym_NA] = ACTIONS(7191),
    [anon_sym_NA_integer_] = ACTIONS(7191),
    [anon_sym_NA_real_] = ACTIONS(7191),
    [anon_sym_NA_complex_] = ACTIONS(7191),
    [anon_sym_NA_character_] = ACTIONS(7191),
    [sym_dots] = ACTIONS(7191),
    [sym_dot_dot_i] = ACTIONS(7189),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7189),
    [sym__newline] = ACTIONS(7189),
    [sym__raw_string_literal] = ACTIONS(7189),
    [sym__external_open_parenthesis] = ACTIONS(7189),
    [sym__external_close_parenthesis] = ACTIONS(7189),
    [sym__external_open_brace] = ACTIONS(7189),
    [sym__external_open_bracket] = ACTIONS(7189),
    [sym__external_open_bracket2] = ACTIONS(7189),
    [sym__external_close_bracket2] = ACTIONS(7189),
  },
  [2388] = {
    [sym_identifier] = ACTIONS(7524),
    [anon_sym_BSLASH] = ACTIONS(7522),
    [anon_sym_function] = ACTIONS(7524),
    [anon_sym_EQ] = ACTIONS(7524),
    [anon_sym_if] = ACTIONS(7524),
    [anon_sym_for] = ACTIONS(7524),
    [anon_sym_while] = ACTIONS(7524),
    [anon_sym_repeat] = ACTIONS(7524),
    [anon_sym_QMARK] = ACTIONS(7522),
    [anon_sym_TILDE] = ACTIONS(7522),
    [anon_sym_BANG] = ACTIONS(7524),
    [anon_sym_PLUS] = ACTIONS(7522),
    [anon_sym_DASH] = ACTIONS(7524),
    [anon_sym_LT_DASH] = ACTIONS(7522),
    [anon_sym_LT_LT_DASH] = ACTIONS(7522),
    [anon_sym_COLON_EQ] = ACTIONS(7522),
    [anon_sym_DASH_GT] = ACTIONS(7524),
    [anon_sym_DASH_GT_GT] = ACTIONS(7522),
    [anon_sym_PIPE] = ACTIONS(7524),
    [anon_sym_AMP] = ACTIONS(7524),
    [anon_sym_PIPE_PIPE] = ACTIONS(7522),
    [anon_sym_AMP_AMP] = ACTIONS(7522),
    [anon_sym_LT] = ACTIONS(7524),
    [anon_sym_LT_EQ] = ACTIONS(7522),
    [anon_sym_GT] = ACTIONS(7524),
    [anon_sym_GT_EQ] = ACTIONS(7522),
    [anon_sym_EQ_EQ] = ACTIONS(7522),
    [anon_sym_BANG_EQ] = ACTIONS(7522),
    [anon_sym_STAR] = ACTIONS(7524),
    [anon_sym_SLASH] = ACTIONS(7522),
    [anon_sym_STAR_STAR] = ACTIONS(7522),
    [anon_sym_CARET] = ACTIONS(7522),
    [aux_sym_binary_operator_token1] = ACTIONS(7522),
    [anon_sym_PIPE_GT] = ACTIONS(7522),
    [anon_sym_COLON] = ACTIONS(7524),
    [anon_sym_DOLLAR] = ACTIONS(7522),
    [anon_sym_AT] = ACTIONS(7522),
    [aux_sym__hex_literal_token1] = ACTIONS(7522),
    [sym__number_literal] = ACTIONS(7524),
    [anon_sym_SQUOTE] = ACTIONS(7522),
    [anon_sym_DQUOTE] = ACTIONS(7522),
    [sym_return] = ACTIONS(7524),
    [sym_next] = ACTIONS(7524),
    [sym_break] = ACTIONS(7524),
    [sym_true] = ACTIONS(7524),
    [sym_false] = ACTIONS(7524),
    [sym_null] = ACTIONS(7524),
    [sym_inf] = ACTIONS(7524),
    [sym_nan] = ACTIONS(7524),
    [anon_sym_NA] = ACTIONS(7524),
    [anon_sym_NA_integer_] = ACTIONS(7524),
    [anon_sym_NA_real_] = ACTIONS(7524),
    [anon_sym_NA_complex_] = ACTIONS(7524),
    [anon_sym_NA_character_] = ACTIONS(7524),
    [sym_dots] = ACTIONS(7524),
    [sym_dot_dot_i] = ACTIONS(7522),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7522),
    [sym__newline] = ACTIONS(7522),
    [sym__semicolon] = ACTIONS(7522),
    [sym__raw_string_literal] = ACTIONS(7522),
    [sym__external_open_parenthesis] = ACTIONS(7522),
    [sym__external_close_parenthesis] = ACTIONS(7522),
    [sym__external_open_brace] = ACTIONS(7522),
    [sym__external_close_brace] = ACTIONS(7522),
    [sym__external_open_bracket] = ACTIONS(7522),
    [sym__external_close_bracket] = ACTIONS(7522),
    [sym__external_open_bracket2] = ACTIONS(7522),
  },
  [2389] = {
    [sym_identifier] = ACTIONS(7195),
    [anon_sym_BSLASH] = ACTIONS(7193),
    [anon_sym_function] = ACTIONS(7195),
    [anon_sym_EQ] = ACTIONS(7195),
    [anon_sym_if] = ACTIONS(7195),
    [anon_sym_for] = ACTIONS(7195),
    [anon_sym_while] = ACTIONS(7195),
    [anon_sym_repeat] = ACTIONS(7195),
    [anon_sym_QMARK] = ACTIONS(7193),
    [anon_sym_TILDE] = ACTIONS(7193),
    [anon_sym_BANG] = ACTIONS(7195),
    [anon_sym_PLUS] = ACTIONS(7193),
    [anon_sym_DASH] = ACTIONS(7195),
    [anon_sym_LT_DASH] = ACTIONS(7193),
    [anon_sym_LT_LT_DASH] = ACTIONS(7193),
    [anon_sym_COLON_EQ] = ACTIONS(7193),
    [anon_sym_DASH_GT] = ACTIONS(7195),
    [anon_sym_DASH_GT_GT] = ACTIONS(7193),
    [anon_sym_PIPE] = ACTIONS(7195),
    [anon_sym_AMP] = ACTIONS(7195),
    [anon_sym_PIPE_PIPE] = ACTIONS(7193),
    [anon_sym_AMP_AMP] = ACTIONS(7193),
    [anon_sym_LT] = ACTIONS(7195),
    [anon_sym_LT_EQ] = ACTIONS(7193),
    [anon_sym_GT] = ACTIONS(7195),
    [anon_sym_GT_EQ] = ACTIONS(7193),
    [anon_sym_EQ_EQ] = ACTIONS(7193),
    [anon_sym_BANG_EQ] = ACTIONS(7193),
    [anon_sym_STAR] = ACTIONS(7195),
    [anon_sym_SLASH] = ACTIONS(7193),
    [anon_sym_STAR_STAR] = ACTIONS(7193),
    [anon_sym_CARET] = ACTIONS(7193),
    [aux_sym_binary_operator_token1] = ACTIONS(7193),
    [anon_sym_PIPE_GT] = ACTIONS(7193),
    [anon_sym_COLON] = ACTIONS(7195),
    [anon_sym_DOLLAR] = ACTIONS(7193),
    [anon_sym_AT] = ACTIONS(7193),
    [anon_sym_COLON_COLON] = ACTIONS(7195),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7193),
    [aux_sym__hex_literal_token1] = ACTIONS(7193),
    [sym__number_literal] = ACTIONS(7195),
    [anon_sym_SQUOTE] = ACTIONS(7193),
    [anon_sym_DQUOTE] = ACTIONS(7193),
    [sym_return] = ACTIONS(7195),
    [sym_next] = ACTIONS(7195),
    [sym_break] = ACTIONS(7195),
    [sym_true] = ACTIONS(7195),
    [sym_false] = ACTIONS(7195),
    [sym_null] = ACTIONS(7195),
    [sym_inf] = ACTIONS(7195),
    [sym_nan] = ACTIONS(7195),
    [anon_sym_NA] = ACTIONS(7195),
    [anon_sym_NA_integer_] = ACTIONS(7195),
    [anon_sym_NA_real_] = ACTIONS(7195),
    [anon_sym_NA_complex_] = ACTIONS(7195),
    [anon_sym_NA_character_] = ACTIONS(7195),
    [sym_dots] = ACTIONS(7195),
    [sym_dot_dot_i] = ACTIONS(7193),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7193),
    [sym__newline] = ACTIONS(7193),
    [sym__raw_string_literal] = ACTIONS(7193),
    [sym__external_open_parenthesis] = ACTIONS(7193),
    [sym__external_close_parenthesis] = ACTIONS(7193),
    [sym__external_open_brace] = ACTIONS(7193),
    [sym__external_open_bracket] = ACTIONS(7193),
    [sym__external_open_bracket2] = ACTIONS(7193),
    [sym__external_close_bracket2] = ACTIONS(7193),
  },
  [2390] = {
    [sym_identifier] = ACTIONS(7163),
    [anon_sym_BSLASH] = ACTIONS(7165),
    [anon_sym_function] = ACTIONS(7163),
    [anon_sym_EQ] = ACTIONS(7163),
    [anon_sym_if] = ACTIONS(7163),
    [anon_sym_for] = ACTIONS(7163),
    [anon_sym_while] = ACTIONS(7163),
    [anon_sym_repeat] = ACTIONS(7163),
    [anon_sym_QMARK] = ACTIONS(7165),
    [anon_sym_TILDE] = ACTIONS(7165),
    [anon_sym_BANG] = ACTIONS(7163),
    [anon_sym_PLUS] = ACTIONS(7165),
    [anon_sym_DASH] = ACTIONS(7163),
    [anon_sym_LT_DASH] = ACTIONS(7165),
    [anon_sym_LT_LT_DASH] = ACTIONS(7165),
    [anon_sym_COLON_EQ] = ACTIONS(7165),
    [anon_sym_DASH_GT] = ACTIONS(7163),
    [anon_sym_DASH_GT_GT] = ACTIONS(7165),
    [anon_sym_PIPE] = ACTIONS(7163),
    [anon_sym_AMP] = ACTIONS(7163),
    [anon_sym_PIPE_PIPE] = ACTIONS(7165),
    [anon_sym_AMP_AMP] = ACTIONS(7165),
    [anon_sym_LT] = ACTIONS(7163),
    [anon_sym_LT_EQ] = ACTIONS(7165),
    [anon_sym_GT] = ACTIONS(7163),
    [anon_sym_GT_EQ] = ACTIONS(7165),
    [anon_sym_EQ_EQ] = ACTIONS(7165),
    [anon_sym_BANG_EQ] = ACTIONS(7165),
    [anon_sym_STAR] = ACTIONS(7163),
    [anon_sym_SLASH] = ACTIONS(7165),
    [anon_sym_STAR_STAR] = ACTIONS(7165),
    [anon_sym_CARET] = ACTIONS(7165),
    [aux_sym_binary_operator_token1] = ACTIONS(7165),
    [anon_sym_PIPE_GT] = ACTIONS(7165),
    [anon_sym_COLON] = ACTIONS(7163),
    [anon_sym_DOLLAR] = ACTIONS(7165),
    [anon_sym_AT] = ACTIONS(7165),
    [anon_sym_COLON_COLON] = ACTIONS(7163),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7165),
    [aux_sym__hex_literal_token1] = ACTIONS(7165),
    [sym__number_literal] = ACTIONS(7163),
    [anon_sym_SQUOTE] = ACTIONS(7165),
    [anon_sym_DQUOTE] = ACTIONS(7165),
    [sym_return] = ACTIONS(7163),
    [sym_next] = ACTIONS(7163),
    [sym_break] = ACTIONS(7163),
    [sym_true] = ACTIONS(7163),
    [sym_false] = ACTIONS(7163),
    [sym_null] = ACTIONS(7163),
    [sym_inf] = ACTIONS(7163),
    [sym_nan] = ACTIONS(7163),
    [anon_sym_NA] = ACTIONS(7163),
    [anon_sym_NA_integer_] = ACTIONS(7163),
    [anon_sym_NA_real_] = ACTIONS(7163),
    [anon_sym_NA_complex_] = ACTIONS(7163),
    [anon_sym_NA_character_] = ACTIONS(7163),
    [sym_dots] = ACTIONS(7163),
    [sym_dot_dot_i] = ACTIONS(7165),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7165),
    [sym__newline] = ACTIONS(7165),
    [sym__raw_string_literal] = ACTIONS(7165),
    [sym__external_else] = ACTIONS(7165),
    [sym__external_open_parenthesis] = ACTIONS(7165),
    [sym__external_open_brace] = ACTIONS(7165),
    [sym__external_open_bracket] = ACTIONS(7165),
    [sym__external_open_bracket2] = ACTIONS(7165),
    [sym__external_close_bracket2] = ACTIONS(7165),
  },
  [2391] = {
    [sym_identifier] = ACTIONS(7540),
    [anon_sym_BSLASH] = ACTIONS(7538),
    [anon_sym_function] = ACTIONS(7540),
    [anon_sym_EQ] = ACTIONS(7540),
    [anon_sym_if] = ACTIONS(7540),
    [anon_sym_for] = ACTIONS(7540),
    [anon_sym_while] = ACTIONS(7540),
    [anon_sym_repeat] = ACTIONS(7540),
    [anon_sym_QMARK] = ACTIONS(7538),
    [anon_sym_TILDE] = ACTIONS(7538),
    [anon_sym_BANG] = ACTIONS(7540),
    [anon_sym_PLUS] = ACTIONS(7538),
    [anon_sym_DASH] = ACTIONS(7540),
    [anon_sym_LT_DASH] = ACTIONS(7538),
    [anon_sym_LT_LT_DASH] = ACTIONS(7538),
    [anon_sym_COLON_EQ] = ACTIONS(7538),
    [anon_sym_DASH_GT] = ACTIONS(7540),
    [anon_sym_DASH_GT_GT] = ACTIONS(7538),
    [anon_sym_PIPE] = ACTIONS(7540),
    [anon_sym_AMP] = ACTIONS(7540),
    [anon_sym_PIPE_PIPE] = ACTIONS(7538),
    [anon_sym_AMP_AMP] = ACTIONS(7538),
    [anon_sym_LT] = ACTIONS(7540),
    [anon_sym_LT_EQ] = ACTIONS(7538),
    [anon_sym_GT] = ACTIONS(7540),
    [anon_sym_GT_EQ] = ACTIONS(7538),
    [anon_sym_EQ_EQ] = ACTIONS(7538),
    [anon_sym_BANG_EQ] = ACTIONS(7538),
    [anon_sym_STAR] = ACTIONS(7540),
    [anon_sym_SLASH] = ACTIONS(7538),
    [anon_sym_STAR_STAR] = ACTIONS(7538),
    [anon_sym_CARET] = ACTIONS(7538),
    [aux_sym_binary_operator_token1] = ACTIONS(7538),
    [anon_sym_PIPE_GT] = ACTIONS(7538),
    [anon_sym_COLON] = ACTIONS(7540),
    [anon_sym_DOLLAR] = ACTIONS(7538),
    [anon_sym_AT] = ACTIONS(7538),
    [aux_sym__hex_literal_token1] = ACTIONS(7538),
    [sym__number_literal] = ACTIONS(7540),
    [anon_sym_SQUOTE] = ACTIONS(7538),
    [anon_sym_DQUOTE] = ACTIONS(7538),
    [sym_return] = ACTIONS(7540),
    [sym_next] = ACTIONS(7540),
    [sym_break] = ACTIONS(7540),
    [sym_true] = ACTIONS(7540),
    [sym_false] = ACTIONS(7540),
    [sym_null] = ACTIONS(7540),
    [sym_inf] = ACTIONS(7540),
    [sym_nan] = ACTIONS(7540),
    [anon_sym_NA] = ACTIONS(7540),
    [anon_sym_NA_integer_] = ACTIONS(7540),
    [anon_sym_NA_real_] = ACTIONS(7540),
    [anon_sym_NA_complex_] = ACTIONS(7540),
    [anon_sym_NA_character_] = ACTIONS(7540),
    [sym_dots] = ACTIONS(7540),
    [sym_dot_dot_i] = ACTIONS(7538),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7538),
    [sym__newline] = ACTIONS(7538),
    [sym__semicolon] = ACTIONS(7538),
    [sym__raw_string_literal] = ACTIONS(7538),
    [sym__external_open_parenthesis] = ACTIONS(7538),
    [sym__external_close_parenthesis] = ACTIONS(7538),
    [sym__external_open_brace] = ACTIONS(7538),
    [sym__external_close_brace] = ACTIONS(7538),
    [sym__external_open_bracket] = ACTIONS(7538),
    [sym__external_open_bracket2] = ACTIONS(7538),
    [sym__external_close_bracket2] = ACTIONS(7538),
  },
  [2392] = {
    [sym_identifier] = ACTIONS(7137),
    [anon_sym_BSLASH] = ACTIONS(7139),
    [anon_sym_function] = ACTIONS(7137),
    [anon_sym_EQ] = ACTIONS(7137),
    [anon_sym_if] = ACTIONS(7137),
    [anon_sym_for] = ACTIONS(7137),
    [anon_sym_while] = ACTIONS(7137),
    [anon_sym_repeat] = ACTIONS(7137),
    [anon_sym_QMARK] = ACTIONS(7139),
    [anon_sym_TILDE] = ACTIONS(7139),
    [anon_sym_BANG] = ACTIONS(7137),
    [anon_sym_PLUS] = ACTIONS(7139),
    [anon_sym_DASH] = ACTIONS(7137),
    [anon_sym_LT_DASH] = ACTIONS(7139),
    [anon_sym_LT_LT_DASH] = ACTIONS(7139),
    [anon_sym_COLON_EQ] = ACTIONS(7139),
    [anon_sym_DASH_GT] = ACTIONS(7137),
    [anon_sym_DASH_GT_GT] = ACTIONS(7139),
    [anon_sym_PIPE] = ACTIONS(7137),
    [anon_sym_AMP] = ACTIONS(7137),
    [anon_sym_PIPE_PIPE] = ACTIONS(7139),
    [anon_sym_AMP_AMP] = ACTIONS(7139),
    [anon_sym_LT] = ACTIONS(7137),
    [anon_sym_LT_EQ] = ACTIONS(7139),
    [anon_sym_GT] = ACTIONS(7137),
    [anon_sym_GT_EQ] = ACTIONS(7139),
    [anon_sym_EQ_EQ] = ACTIONS(7139),
    [anon_sym_BANG_EQ] = ACTIONS(7139),
    [anon_sym_STAR] = ACTIONS(7137),
    [anon_sym_SLASH] = ACTIONS(7139),
    [anon_sym_STAR_STAR] = ACTIONS(7139),
    [anon_sym_CARET] = ACTIONS(7139),
    [aux_sym_binary_operator_token1] = ACTIONS(7139),
    [anon_sym_PIPE_GT] = ACTIONS(7139),
    [anon_sym_COLON] = ACTIONS(7137),
    [anon_sym_DOLLAR] = ACTIONS(7139),
    [anon_sym_AT] = ACTIONS(7139),
    [anon_sym_COLON_COLON] = ACTIONS(7137),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7139),
    [aux_sym__hex_literal_token1] = ACTIONS(7139),
    [sym__number_literal] = ACTIONS(7137),
    [anon_sym_SQUOTE] = ACTIONS(7139),
    [anon_sym_DQUOTE] = ACTIONS(7139),
    [sym_return] = ACTIONS(7137),
    [sym_next] = ACTIONS(7137),
    [sym_break] = ACTIONS(7137),
    [sym_true] = ACTIONS(7137),
    [sym_false] = ACTIONS(7137),
    [sym_null] = ACTIONS(7137),
    [sym_inf] = ACTIONS(7137),
    [sym_nan] = ACTIONS(7137),
    [anon_sym_NA] = ACTIONS(7137),
    [anon_sym_NA_integer_] = ACTIONS(7137),
    [anon_sym_NA_real_] = ACTIONS(7137),
    [anon_sym_NA_complex_] = ACTIONS(7137),
    [anon_sym_NA_character_] = ACTIONS(7137),
    [sym_dots] = ACTIONS(7137),
    [sym_dot_dot_i] = ACTIONS(7139),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7139),
    [sym__newline] = ACTIONS(7139),
    [sym__raw_string_literal] = ACTIONS(7139),
    [sym__external_open_parenthesis] = ACTIONS(7139),
    [sym__external_close_parenthesis] = ACTIONS(7139),
    [sym__external_open_brace] = ACTIONS(7139),
    [sym__external_open_bracket] = ACTIONS(7139),
    [sym__external_open_bracket2] = ACTIONS(7139),
    [sym__external_close_bracket2] = ACTIONS(7139),
  },
  [2393] = {
    [sym_identifier] = ACTIONS(7567),
    [anon_sym_BSLASH] = ACTIONS(7565),
    [anon_sym_function] = ACTIONS(7567),
    [anon_sym_EQ] = ACTIONS(7567),
    [anon_sym_if] = ACTIONS(7567),
    [anon_sym_for] = ACTIONS(7567),
    [anon_sym_while] = ACTIONS(7567),
    [anon_sym_repeat] = ACTIONS(7567),
    [anon_sym_QMARK] = ACTIONS(7565),
    [anon_sym_TILDE] = ACTIONS(7565),
    [anon_sym_BANG] = ACTIONS(7567),
    [anon_sym_PLUS] = ACTIONS(7565),
    [anon_sym_DASH] = ACTIONS(7567),
    [anon_sym_LT_DASH] = ACTIONS(7565),
    [anon_sym_LT_LT_DASH] = ACTIONS(7565),
    [anon_sym_COLON_EQ] = ACTIONS(7565),
    [anon_sym_DASH_GT] = ACTIONS(7567),
    [anon_sym_DASH_GT_GT] = ACTIONS(7565),
    [anon_sym_PIPE] = ACTIONS(7567),
    [anon_sym_AMP] = ACTIONS(7567),
    [anon_sym_PIPE_PIPE] = ACTIONS(7565),
    [anon_sym_AMP_AMP] = ACTIONS(7565),
    [anon_sym_LT] = ACTIONS(7567),
    [anon_sym_LT_EQ] = ACTIONS(7565),
    [anon_sym_GT] = ACTIONS(7567),
    [anon_sym_GT_EQ] = ACTIONS(7565),
    [anon_sym_EQ_EQ] = ACTIONS(7565),
    [anon_sym_BANG_EQ] = ACTIONS(7565),
    [anon_sym_STAR] = ACTIONS(7567),
    [anon_sym_SLASH] = ACTIONS(7565),
    [anon_sym_STAR_STAR] = ACTIONS(7565),
    [anon_sym_CARET] = ACTIONS(7565),
    [aux_sym_binary_operator_token1] = ACTIONS(7565),
    [anon_sym_PIPE_GT] = ACTIONS(7565),
    [anon_sym_COLON] = ACTIONS(7567),
    [anon_sym_DOLLAR] = ACTIONS(7565),
    [anon_sym_AT] = ACTIONS(7565),
    [aux_sym__hex_literal_token1] = ACTIONS(7565),
    [sym__number_literal] = ACTIONS(7567),
    [anon_sym_SQUOTE] = ACTIONS(7565),
    [anon_sym_DQUOTE] = ACTIONS(7565),
    [sym_return] = ACTIONS(7567),
    [sym_next] = ACTIONS(7567),
    [sym_break] = ACTIONS(7567),
    [sym_true] = ACTIONS(7567),
    [sym_false] = ACTIONS(7567),
    [sym_null] = ACTIONS(7567),
    [sym_inf] = ACTIONS(7567),
    [sym_nan] = ACTIONS(7567),
    [anon_sym_NA] = ACTIONS(7567),
    [anon_sym_NA_integer_] = ACTIONS(7567),
    [anon_sym_NA_real_] = ACTIONS(7567),
    [anon_sym_NA_complex_] = ACTIONS(7567),
    [anon_sym_NA_character_] = ACTIONS(7567),
    [sym_dots] = ACTIONS(7567),
    [sym_dot_dot_i] = ACTIONS(7565),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7565),
    [sym__newline] = ACTIONS(7565),
    [sym__semicolon] = ACTIONS(7565),
    [sym__raw_string_literal] = ACTIONS(7565),
    [sym__external_else] = ACTIONS(7565),
    [sym__external_open_parenthesis] = ACTIONS(7565),
    [sym__external_open_brace] = ACTIONS(7565),
    [sym__external_close_brace] = ACTIONS(7565),
    [sym__external_open_bracket] = ACTIONS(7565),
    [sym__external_close_bracket] = ACTIONS(7565),
    [sym__external_open_bracket2] = ACTIONS(7565),
  },
  [2394] = {
    [sym_identifier] = ACTIONS(5325),
    [anon_sym_BSLASH] = ACTIONS(5327),
    [anon_sym_function] = ACTIONS(5325),
    [anon_sym_EQ] = ACTIONS(5325),
    [anon_sym_if] = ACTIONS(5325),
    [anon_sym_for] = ACTIONS(5325),
    [anon_sym_while] = ACTIONS(5325),
    [anon_sym_repeat] = ACTIONS(5325),
    [anon_sym_QMARK] = ACTIONS(5327),
    [anon_sym_TILDE] = ACTIONS(5327),
    [anon_sym_BANG] = ACTIONS(5325),
    [anon_sym_PLUS] = ACTIONS(5327),
    [anon_sym_DASH] = ACTIONS(5325),
    [anon_sym_LT_DASH] = ACTIONS(5327),
    [anon_sym_LT_LT_DASH] = ACTIONS(5327),
    [anon_sym_COLON_EQ] = ACTIONS(5327),
    [anon_sym_DASH_GT] = ACTIONS(5325),
    [anon_sym_DASH_GT_GT] = ACTIONS(5327),
    [anon_sym_PIPE] = ACTIONS(5325),
    [anon_sym_AMP] = ACTIONS(5325),
    [anon_sym_PIPE_PIPE] = ACTIONS(5327),
    [anon_sym_AMP_AMP] = ACTIONS(5327),
    [anon_sym_LT] = ACTIONS(5325),
    [anon_sym_LT_EQ] = ACTIONS(5327),
    [anon_sym_GT] = ACTIONS(5325),
    [anon_sym_GT_EQ] = ACTIONS(5327),
    [anon_sym_EQ_EQ] = ACTIONS(5327),
    [anon_sym_BANG_EQ] = ACTIONS(5327),
    [anon_sym_STAR] = ACTIONS(5325),
    [anon_sym_SLASH] = ACTIONS(5327),
    [anon_sym_STAR_STAR] = ACTIONS(5327),
    [anon_sym_CARET] = ACTIONS(5327),
    [aux_sym_binary_operator_token1] = ACTIONS(5327),
    [anon_sym_PIPE_GT] = ACTIONS(5327),
    [anon_sym_COLON] = ACTIONS(5325),
    [anon_sym_DOLLAR] = ACTIONS(5327),
    [anon_sym_AT] = ACTIONS(5327),
    [aux_sym__hex_literal_token1] = ACTIONS(5327),
    [sym__number_literal] = ACTIONS(5325),
    [anon_sym_SQUOTE] = ACTIONS(5327),
    [anon_sym_DQUOTE] = ACTIONS(5327),
    [sym_return] = ACTIONS(5325),
    [sym_next] = ACTIONS(5325),
    [sym_break] = ACTIONS(5325),
    [sym_true] = ACTIONS(5325),
    [sym_false] = ACTIONS(5325),
    [sym_null] = ACTIONS(5325),
    [sym_inf] = ACTIONS(5325),
    [sym_nan] = ACTIONS(5325),
    [anon_sym_NA] = ACTIONS(5325),
    [anon_sym_NA_integer_] = ACTIONS(5325),
    [anon_sym_NA_real_] = ACTIONS(5325),
    [anon_sym_NA_complex_] = ACTIONS(5325),
    [anon_sym_NA_character_] = ACTIONS(5325),
    [sym_dots] = ACTIONS(5325),
    [sym_dot_dot_i] = ACTIONS(5327),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5327),
    [sym__newline] = ACTIONS(5327),
    [sym__semicolon] = ACTIONS(5327),
    [sym__raw_string_literal] = ACTIONS(5327),
    [sym__external_else] = ACTIONS(5327),
    [sym__external_open_parenthesis] = ACTIONS(5327),
    [sym__external_open_brace] = ACTIONS(5327),
    [sym__external_close_brace] = ACTIONS(5327),
    [sym__external_open_bracket] = ACTIONS(5327),
    [sym__external_open_bracket2] = ACTIONS(5327),
    [sym__external_close_bracket2] = ACTIONS(5327),
  },
  [2395] = {
    [sym_identifier] = ACTIONS(7191),
    [anon_sym_BSLASH] = ACTIONS(7189),
    [anon_sym_function] = ACTIONS(7191),
    [anon_sym_EQ] = ACTIONS(7191),
    [anon_sym_if] = ACTIONS(7191),
    [anon_sym_for] = ACTIONS(7191),
    [anon_sym_while] = ACTIONS(7191),
    [anon_sym_repeat] = ACTIONS(7191),
    [anon_sym_QMARK] = ACTIONS(7189),
    [anon_sym_TILDE] = ACTIONS(7189),
    [anon_sym_BANG] = ACTIONS(7191),
    [anon_sym_PLUS] = ACTIONS(7189),
    [anon_sym_DASH] = ACTIONS(7191),
    [anon_sym_LT_DASH] = ACTIONS(7189),
    [anon_sym_LT_LT_DASH] = ACTIONS(7189),
    [anon_sym_COLON_EQ] = ACTIONS(7189),
    [anon_sym_DASH_GT] = ACTIONS(7191),
    [anon_sym_DASH_GT_GT] = ACTIONS(7189),
    [anon_sym_PIPE] = ACTIONS(7191),
    [anon_sym_AMP] = ACTIONS(7191),
    [anon_sym_PIPE_PIPE] = ACTIONS(7189),
    [anon_sym_AMP_AMP] = ACTIONS(7189),
    [anon_sym_LT] = ACTIONS(7191),
    [anon_sym_LT_EQ] = ACTIONS(7189),
    [anon_sym_GT] = ACTIONS(7191),
    [anon_sym_GT_EQ] = ACTIONS(7189),
    [anon_sym_EQ_EQ] = ACTIONS(7189),
    [anon_sym_BANG_EQ] = ACTIONS(7189),
    [anon_sym_STAR] = ACTIONS(7191),
    [anon_sym_SLASH] = ACTIONS(7189),
    [anon_sym_STAR_STAR] = ACTIONS(7189),
    [anon_sym_CARET] = ACTIONS(7189),
    [aux_sym_binary_operator_token1] = ACTIONS(7189),
    [anon_sym_PIPE_GT] = ACTIONS(7189),
    [anon_sym_COLON] = ACTIONS(7191),
    [anon_sym_DOLLAR] = ACTIONS(7189),
    [anon_sym_AT] = ACTIONS(7189),
    [anon_sym_COLON_COLON] = ACTIONS(7191),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7189),
    [aux_sym__hex_literal_token1] = ACTIONS(7189),
    [sym__number_literal] = ACTIONS(7191),
    [anon_sym_SQUOTE] = ACTIONS(7189),
    [anon_sym_DQUOTE] = ACTIONS(7189),
    [sym_return] = ACTIONS(7191),
    [sym_next] = ACTIONS(7191),
    [sym_break] = ACTIONS(7191),
    [sym_true] = ACTIONS(7191),
    [sym_false] = ACTIONS(7191),
    [sym_null] = ACTIONS(7191),
    [sym_inf] = ACTIONS(7191),
    [sym_nan] = ACTIONS(7191),
    [anon_sym_NA] = ACTIONS(7191),
    [anon_sym_NA_integer_] = ACTIONS(7191),
    [anon_sym_NA_real_] = ACTIONS(7191),
    [anon_sym_NA_complex_] = ACTIONS(7191),
    [anon_sym_NA_character_] = ACTIONS(7191),
    [sym_dots] = ACTIONS(7191),
    [sym_dot_dot_i] = ACTIONS(7189),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7189),
    [sym__newline] = ACTIONS(7189),
    [sym__raw_string_literal] = ACTIONS(7189),
    [sym__external_else] = ACTIONS(7189),
    [sym__external_open_parenthesis] = ACTIONS(7189),
    [sym__external_open_brace] = ACTIONS(7189),
    [sym__external_open_bracket] = ACTIONS(7189),
    [sym__external_open_bracket2] = ACTIONS(7189),
    [sym__external_close_bracket2] = ACTIONS(7189),
  },
  [2396] = {
    [sym_identifier] = ACTIONS(7195),
    [anon_sym_BSLASH] = ACTIONS(7193),
    [anon_sym_function] = ACTIONS(7195),
    [anon_sym_EQ] = ACTIONS(7195),
    [anon_sym_if] = ACTIONS(7195),
    [anon_sym_for] = ACTIONS(7195),
    [anon_sym_while] = ACTIONS(7195),
    [anon_sym_repeat] = ACTIONS(7195),
    [anon_sym_QMARK] = ACTIONS(7193),
    [anon_sym_TILDE] = ACTIONS(7193),
    [anon_sym_BANG] = ACTIONS(7195),
    [anon_sym_PLUS] = ACTIONS(7193),
    [anon_sym_DASH] = ACTIONS(7195),
    [anon_sym_LT_DASH] = ACTIONS(7193),
    [anon_sym_LT_LT_DASH] = ACTIONS(7193),
    [anon_sym_COLON_EQ] = ACTIONS(7193),
    [anon_sym_DASH_GT] = ACTIONS(7195),
    [anon_sym_DASH_GT_GT] = ACTIONS(7193),
    [anon_sym_PIPE] = ACTIONS(7195),
    [anon_sym_AMP] = ACTIONS(7195),
    [anon_sym_PIPE_PIPE] = ACTIONS(7193),
    [anon_sym_AMP_AMP] = ACTIONS(7193),
    [anon_sym_LT] = ACTIONS(7195),
    [anon_sym_LT_EQ] = ACTIONS(7193),
    [anon_sym_GT] = ACTIONS(7195),
    [anon_sym_GT_EQ] = ACTIONS(7193),
    [anon_sym_EQ_EQ] = ACTIONS(7193),
    [anon_sym_BANG_EQ] = ACTIONS(7193),
    [anon_sym_STAR] = ACTIONS(7195),
    [anon_sym_SLASH] = ACTIONS(7193),
    [anon_sym_STAR_STAR] = ACTIONS(7193),
    [anon_sym_CARET] = ACTIONS(7193),
    [aux_sym_binary_operator_token1] = ACTIONS(7193),
    [anon_sym_PIPE_GT] = ACTIONS(7193),
    [anon_sym_COLON] = ACTIONS(7195),
    [anon_sym_DOLLAR] = ACTIONS(7193),
    [anon_sym_AT] = ACTIONS(7193),
    [anon_sym_COLON_COLON] = ACTIONS(7195),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7193),
    [aux_sym__hex_literal_token1] = ACTIONS(7193),
    [sym__number_literal] = ACTIONS(7195),
    [anon_sym_SQUOTE] = ACTIONS(7193),
    [anon_sym_DQUOTE] = ACTIONS(7193),
    [sym_return] = ACTIONS(7195),
    [sym_next] = ACTIONS(7195),
    [sym_break] = ACTIONS(7195),
    [sym_true] = ACTIONS(7195),
    [sym_false] = ACTIONS(7195),
    [sym_null] = ACTIONS(7195),
    [sym_inf] = ACTIONS(7195),
    [sym_nan] = ACTIONS(7195),
    [anon_sym_NA] = ACTIONS(7195),
    [anon_sym_NA_integer_] = ACTIONS(7195),
    [anon_sym_NA_real_] = ACTIONS(7195),
    [anon_sym_NA_complex_] = ACTIONS(7195),
    [anon_sym_NA_character_] = ACTIONS(7195),
    [sym_dots] = ACTIONS(7195),
    [sym_dot_dot_i] = ACTIONS(7193),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7193),
    [sym__newline] = ACTIONS(7193),
    [sym__raw_string_literal] = ACTIONS(7193),
    [sym__external_else] = ACTIONS(7193),
    [sym__external_open_parenthesis] = ACTIONS(7193),
    [sym__external_open_brace] = ACTIONS(7193),
    [sym__external_open_bracket] = ACTIONS(7193),
    [sym__external_open_bracket2] = ACTIONS(7193),
    [sym__external_close_bracket2] = ACTIONS(7193),
  },
  [2397] = {
    [sym_identifier] = ACTIONS(7129),
    [anon_sym_BSLASH] = ACTIONS(7131),
    [anon_sym_function] = ACTIONS(7129),
    [anon_sym_EQ] = ACTIONS(7129),
    [anon_sym_if] = ACTIONS(7129),
    [anon_sym_for] = ACTIONS(7129),
    [anon_sym_while] = ACTIONS(7129),
    [anon_sym_repeat] = ACTIONS(7129),
    [anon_sym_QMARK] = ACTIONS(7131),
    [anon_sym_TILDE] = ACTIONS(7131),
    [anon_sym_BANG] = ACTIONS(7129),
    [anon_sym_PLUS] = ACTIONS(7131),
    [anon_sym_DASH] = ACTIONS(7129),
    [anon_sym_LT_DASH] = ACTIONS(7131),
    [anon_sym_LT_LT_DASH] = ACTIONS(7131),
    [anon_sym_COLON_EQ] = ACTIONS(7131),
    [anon_sym_DASH_GT] = ACTIONS(7129),
    [anon_sym_DASH_GT_GT] = ACTIONS(7131),
    [anon_sym_PIPE] = ACTIONS(7129),
    [anon_sym_AMP] = ACTIONS(7129),
    [anon_sym_PIPE_PIPE] = ACTIONS(7131),
    [anon_sym_AMP_AMP] = ACTIONS(7131),
    [anon_sym_LT] = ACTIONS(7129),
    [anon_sym_LT_EQ] = ACTIONS(7131),
    [anon_sym_GT] = ACTIONS(7129),
    [anon_sym_GT_EQ] = ACTIONS(7131),
    [anon_sym_EQ_EQ] = ACTIONS(7131),
    [anon_sym_BANG_EQ] = ACTIONS(7131),
    [anon_sym_STAR] = ACTIONS(7129),
    [anon_sym_SLASH] = ACTIONS(7131),
    [anon_sym_STAR_STAR] = ACTIONS(7131),
    [anon_sym_CARET] = ACTIONS(7131),
    [aux_sym_binary_operator_token1] = ACTIONS(7131),
    [anon_sym_PIPE_GT] = ACTIONS(7131),
    [anon_sym_COLON] = ACTIONS(7129),
    [anon_sym_DOLLAR] = ACTIONS(7131),
    [anon_sym_AT] = ACTIONS(7131),
    [anon_sym_COLON_COLON] = ACTIONS(7133),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7135),
    [aux_sym__hex_literal_token1] = ACTIONS(7131),
    [sym__number_literal] = ACTIONS(7129),
    [anon_sym_SQUOTE] = ACTIONS(7131),
    [anon_sym_DQUOTE] = ACTIONS(7131),
    [sym_return] = ACTIONS(7129),
    [sym_next] = ACTIONS(7129),
    [sym_break] = ACTIONS(7129),
    [sym_true] = ACTIONS(7129),
    [sym_false] = ACTIONS(7129),
    [sym_null] = ACTIONS(7129),
    [sym_inf] = ACTIONS(7129),
    [sym_nan] = ACTIONS(7129),
    [anon_sym_NA] = ACTIONS(7129),
    [anon_sym_NA_integer_] = ACTIONS(7129),
    [anon_sym_NA_real_] = ACTIONS(7129),
    [anon_sym_NA_complex_] = ACTIONS(7129),
    [anon_sym_NA_character_] = ACTIONS(7129),
    [sym_dots] = ACTIONS(7129),
    [sym_dot_dot_i] = ACTIONS(7131),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7131),
    [sym__newline] = ACTIONS(7131),
    [sym__raw_string_literal] = ACTIONS(7131),
    [sym__external_open_parenthesis] = ACTIONS(7131),
    [sym__external_close_parenthesis] = ACTIONS(7131),
    [sym__external_open_brace] = ACTIONS(7131),
    [sym__external_open_bracket] = ACTIONS(7131),
    [sym__external_open_bracket2] = ACTIONS(7131),
    [sym__external_close_bracket2] = ACTIONS(7131),
  },
  [2398] = {
    [aux_sym_function_definition_repeat1] = STATE(2398),
    [sym_identifier] = ACTIONS(7419),
    [anon_sym_BSLASH] = ACTIONS(7417),
    [anon_sym_function] = ACTIONS(7419),
    [anon_sym_EQ] = ACTIONS(7419),
    [anon_sym_if] = ACTIONS(7419),
    [anon_sym_for] = ACTIONS(7419),
    [anon_sym_while] = ACTIONS(7419),
    [anon_sym_repeat] = ACTIONS(7419),
    [anon_sym_QMARK] = ACTIONS(7417),
    [anon_sym_TILDE] = ACTIONS(7417),
    [anon_sym_BANG] = ACTIONS(7419),
    [anon_sym_PLUS] = ACTIONS(7417),
    [anon_sym_DASH] = ACTIONS(7419),
    [anon_sym_LT_DASH] = ACTIONS(7417),
    [anon_sym_LT_LT_DASH] = ACTIONS(7417),
    [anon_sym_COLON_EQ] = ACTIONS(7417),
    [anon_sym_DASH_GT] = ACTIONS(7419),
    [anon_sym_DASH_GT_GT] = ACTIONS(7417),
    [anon_sym_PIPE] = ACTIONS(7419),
    [anon_sym_AMP] = ACTIONS(7419),
    [anon_sym_PIPE_PIPE] = ACTIONS(7417),
    [anon_sym_AMP_AMP] = ACTIONS(7417),
    [anon_sym_LT] = ACTIONS(7419),
    [anon_sym_LT_EQ] = ACTIONS(7417),
    [anon_sym_GT] = ACTIONS(7419),
    [anon_sym_GT_EQ] = ACTIONS(7417),
    [anon_sym_EQ_EQ] = ACTIONS(7417),
    [anon_sym_BANG_EQ] = ACTIONS(7417),
    [anon_sym_STAR] = ACTIONS(7419),
    [anon_sym_SLASH] = ACTIONS(7417),
    [anon_sym_STAR_STAR] = ACTIONS(7417),
    [anon_sym_CARET] = ACTIONS(7417),
    [aux_sym_binary_operator_token1] = ACTIONS(7417),
    [anon_sym_PIPE_GT] = ACTIONS(7417),
    [anon_sym_COLON] = ACTIONS(7419),
    [anon_sym_DOLLAR] = ACTIONS(7417),
    [anon_sym_AT] = ACTIONS(7417),
    [aux_sym__hex_literal_token1] = ACTIONS(7417),
    [sym__number_literal] = ACTIONS(7419),
    [anon_sym_SQUOTE] = ACTIONS(7417),
    [anon_sym_DQUOTE] = ACTIONS(7417),
    [sym_return] = ACTIONS(7419),
    [sym_next] = ACTIONS(7419),
    [sym_break] = ACTIONS(7419),
    [sym_true] = ACTIONS(7419),
    [sym_false] = ACTIONS(7419),
    [sym_null] = ACTIONS(7419),
    [sym_inf] = ACTIONS(7419),
    [sym_nan] = ACTIONS(7419),
    [anon_sym_NA] = ACTIONS(7419),
    [anon_sym_NA_integer_] = ACTIONS(7419),
    [anon_sym_NA_real_] = ACTIONS(7419),
    [anon_sym_NA_complex_] = ACTIONS(7419),
    [anon_sym_NA_character_] = ACTIONS(7419),
    [sym_dots] = ACTIONS(7419),
    [sym_dot_dot_i] = ACTIONS(7417),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7417),
    [sym__newline] = ACTIONS(7607),
    [sym__semicolon] = ACTIONS(7417),
    [sym__raw_string_literal] = ACTIONS(7417),
    [sym__external_open_parenthesis] = ACTIONS(7417),
    [sym__external_open_brace] = ACTIONS(7417),
    [sym__external_close_brace] = ACTIONS(7417),
    [sym__external_open_bracket] = ACTIONS(7417),
    [sym__external_close_bracket] = ACTIONS(7417),
    [sym__external_open_bracket2] = ACTIONS(7417),
  },
  [2399] = {
    [aux_sym_function_definition_repeat1] = STATE(2399),
    [ts_builtin_sym_end] = ACTIONS(7417),
    [sym_identifier] = ACTIONS(7419),
    [anon_sym_BSLASH] = ACTIONS(7417),
    [anon_sym_function] = ACTIONS(7419),
    [anon_sym_EQ] = ACTIONS(7419),
    [anon_sym_if] = ACTIONS(7419),
    [anon_sym_for] = ACTIONS(7419),
    [anon_sym_while] = ACTIONS(7419),
    [anon_sym_repeat] = ACTIONS(7419),
    [anon_sym_QMARK] = ACTIONS(7417),
    [anon_sym_TILDE] = ACTIONS(7417),
    [anon_sym_BANG] = ACTIONS(7419),
    [anon_sym_PLUS] = ACTIONS(7417),
    [anon_sym_DASH] = ACTIONS(7419),
    [anon_sym_LT_DASH] = ACTIONS(7417),
    [anon_sym_LT_LT_DASH] = ACTIONS(7417),
    [anon_sym_COLON_EQ] = ACTIONS(7417),
    [anon_sym_DASH_GT] = ACTIONS(7419),
    [anon_sym_DASH_GT_GT] = ACTIONS(7417),
    [anon_sym_PIPE] = ACTIONS(7419),
    [anon_sym_AMP] = ACTIONS(7419),
    [anon_sym_PIPE_PIPE] = ACTIONS(7417),
    [anon_sym_AMP_AMP] = ACTIONS(7417),
    [anon_sym_LT] = ACTIONS(7419),
    [anon_sym_LT_EQ] = ACTIONS(7417),
    [anon_sym_GT] = ACTIONS(7419),
    [anon_sym_GT_EQ] = ACTIONS(7417),
    [anon_sym_EQ_EQ] = ACTIONS(7417),
    [anon_sym_BANG_EQ] = ACTIONS(7417),
    [anon_sym_STAR] = ACTIONS(7419),
    [anon_sym_SLASH] = ACTIONS(7417),
    [anon_sym_STAR_STAR] = ACTIONS(7417),
    [anon_sym_CARET] = ACTIONS(7417),
    [aux_sym_binary_operator_token1] = ACTIONS(7417),
    [anon_sym_PIPE_GT] = ACTIONS(7417),
    [anon_sym_COLON] = ACTIONS(7419),
    [anon_sym_DOLLAR] = ACTIONS(7417),
    [anon_sym_AT] = ACTIONS(7417),
    [aux_sym__hex_literal_token1] = ACTIONS(7417),
    [sym__number_literal] = ACTIONS(7419),
    [anon_sym_SQUOTE] = ACTIONS(7417),
    [anon_sym_DQUOTE] = ACTIONS(7417),
    [sym_return] = ACTIONS(7419),
    [sym_next] = ACTIONS(7419),
    [sym_break] = ACTIONS(7419),
    [sym_true] = ACTIONS(7419),
    [sym_false] = ACTIONS(7419),
    [sym_null] = ACTIONS(7419),
    [sym_inf] = ACTIONS(7419),
    [sym_nan] = ACTIONS(7419),
    [anon_sym_NA] = ACTIONS(7419),
    [anon_sym_NA_integer_] = ACTIONS(7419),
    [anon_sym_NA_real_] = ACTIONS(7419),
    [anon_sym_NA_complex_] = ACTIONS(7419),
    [anon_sym_NA_character_] = ACTIONS(7419),
    [sym_dots] = ACTIONS(7419),
    [sym_dot_dot_i] = ACTIONS(7417),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7610),
    [sym__semicolon] = ACTIONS(7417),
    [sym__raw_string_literal] = ACTIONS(7417),
    [sym__external_else] = ACTIONS(7417),
    [sym__external_open_parenthesis] = ACTIONS(7417),
    [sym__external_open_brace] = ACTIONS(7417),
    [sym__external_close_brace] = ACTIONS(7417),
    [sym__external_open_bracket] = ACTIONS(7417),
    [sym__external_open_bracket2] = ACTIONS(7417),
  },
  [2400] = {
    [aux_sym_function_definition_repeat1] = STATE(2400),
    [sym_identifier] = ACTIONS(7419),
    [anon_sym_BSLASH] = ACTIONS(7417),
    [anon_sym_function] = ACTIONS(7419),
    [anon_sym_EQ] = ACTIONS(7419),
    [anon_sym_if] = ACTIONS(7419),
    [anon_sym_for] = ACTIONS(7419),
    [anon_sym_while] = ACTIONS(7419),
    [anon_sym_repeat] = ACTIONS(7419),
    [anon_sym_QMARK] = ACTIONS(7417),
    [anon_sym_TILDE] = ACTIONS(7417),
    [anon_sym_BANG] = ACTIONS(7419),
    [anon_sym_PLUS] = ACTIONS(7417),
    [anon_sym_DASH] = ACTIONS(7419),
    [anon_sym_LT_DASH] = ACTIONS(7417),
    [anon_sym_LT_LT_DASH] = ACTIONS(7417),
    [anon_sym_COLON_EQ] = ACTIONS(7417),
    [anon_sym_DASH_GT] = ACTIONS(7419),
    [anon_sym_DASH_GT_GT] = ACTIONS(7417),
    [anon_sym_PIPE] = ACTIONS(7419),
    [anon_sym_AMP] = ACTIONS(7419),
    [anon_sym_PIPE_PIPE] = ACTIONS(7417),
    [anon_sym_AMP_AMP] = ACTIONS(7417),
    [anon_sym_LT] = ACTIONS(7419),
    [anon_sym_LT_EQ] = ACTIONS(7417),
    [anon_sym_GT] = ACTIONS(7419),
    [anon_sym_GT_EQ] = ACTIONS(7417),
    [anon_sym_EQ_EQ] = ACTIONS(7417),
    [anon_sym_BANG_EQ] = ACTIONS(7417),
    [anon_sym_STAR] = ACTIONS(7419),
    [anon_sym_SLASH] = ACTIONS(7417),
    [anon_sym_STAR_STAR] = ACTIONS(7417),
    [anon_sym_CARET] = ACTIONS(7417),
    [aux_sym_binary_operator_token1] = ACTIONS(7417),
    [anon_sym_PIPE_GT] = ACTIONS(7417),
    [anon_sym_COLON] = ACTIONS(7419),
    [anon_sym_DOLLAR] = ACTIONS(7417),
    [anon_sym_AT] = ACTIONS(7417),
    [aux_sym__hex_literal_token1] = ACTIONS(7417),
    [sym__number_literal] = ACTIONS(7419),
    [anon_sym_SQUOTE] = ACTIONS(7417),
    [anon_sym_DQUOTE] = ACTIONS(7417),
    [sym_return] = ACTIONS(7419),
    [sym_next] = ACTIONS(7419),
    [sym_break] = ACTIONS(7419),
    [sym_true] = ACTIONS(7419),
    [sym_false] = ACTIONS(7419),
    [sym_null] = ACTIONS(7419),
    [sym_inf] = ACTIONS(7419),
    [sym_nan] = ACTIONS(7419),
    [anon_sym_NA] = ACTIONS(7419),
    [anon_sym_NA_integer_] = ACTIONS(7419),
    [anon_sym_NA_real_] = ACTIONS(7419),
    [anon_sym_NA_complex_] = ACTIONS(7419),
    [anon_sym_NA_character_] = ACTIONS(7419),
    [sym_dots] = ACTIONS(7419),
    [sym_dot_dot_i] = ACTIONS(7417),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7417),
    [sym__newline] = ACTIONS(7613),
    [sym__semicolon] = ACTIONS(7417),
    [sym__raw_string_literal] = ACTIONS(7417),
    [sym__external_open_parenthesis] = ACTIONS(7417),
    [sym__external_open_brace] = ACTIONS(7417),
    [sym__external_close_brace] = ACTIONS(7417),
    [sym__external_open_bracket] = ACTIONS(7417),
    [sym__external_open_bracket2] = ACTIONS(7417),
    [sym__external_close_bracket2] = ACTIONS(7417),
  },
  [2401] = {
    [sym_identifier] = ACTIONS(7532),
    [anon_sym_BSLASH] = ACTIONS(7530),
    [anon_sym_function] = ACTIONS(7532),
    [anon_sym_EQ] = ACTIONS(7532),
    [anon_sym_if] = ACTIONS(7532),
    [anon_sym_for] = ACTIONS(7532),
    [anon_sym_while] = ACTIONS(7532),
    [anon_sym_repeat] = ACTIONS(7532),
    [anon_sym_QMARK] = ACTIONS(7530),
    [anon_sym_TILDE] = ACTIONS(7530),
    [anon_sym_BANG] = ACTIONS(7532),
    [anon_sym_PLUS] = ACTIONS(7530),
    [anon_sym_DASH] = ACTIONS(7532),
    [anon_sym_LT_DASH] = ACTIONS(7530),
    [anon_sym_LT_LT_DASH] = ACTIONS(7530),
    [anon_sym_COLON_EQ] = ACTIONS(7530),
    [anon_sym_DASH_GT] = ACTIONS(7532),
    [anon_sym_DASH_GT_GT] = ACTIONS(7530),
    [anon_sym_PIPE] = ACTIONS(7532),
    [anon_sym_AMP] = ACTIONS(7532),
    [anon_sym_PIPE_PIPE] = ACTIONS(7530),
    [anon_sym_AMP_AMP] = ACTIONS(7530),
    [anon_sym_LT] = ACTIONS(7532),
    [anon_sym_LT_EQ] = ACTIONS(7530),
    [anon_sym_GT] = ACTIONS(7532),
    [anon_sym_GT_EQ] = ACTIONS(7530),
    [anon_sym_EQ_EQ] = ACTIONS(7530),
    [anon_sym_BANG_EQ] = ACTIONS(7530),
    [anon_sym_STAR] = ACTIONS(7532),
    [anon_sym_SLASH] = ACTIONS(7530),
    [anon_sym_STAR_STAR] = ACTIONS(7530),
    [anon_sym_CARET] = ACTIONS(7530),
    [aux_sym_binary_operator_token1] = ACTIONS(7530),
    [anon_sym_PIPE_GT] = ACTIONS(7530),
    [anon_sym_COLON] = ACTIONS(7532),
    [anon_sym_DOLLAR] = ACTIONS(7530),
    [anon_sym_AT] = ACTIONS(7530),
    [aux_sym__hex_literal_token1] = ACTIONS(7530),
    [sym__number_literal] = ACTIONS(7532),
    [anon_sym_SQUOTE] = ACTIONS(7530),
    [anon_sym_DQUOTE] = ACTIONS(7530),
    [sym_return] = ACTIONS(7532),
    [sym_next] = ACTIONS(7532),
    [sym_break] = ACTIONS(7532),
    [sym_true] = ACTIONS(7532),
    [sym_false] = ACTIONS(7532),
    [sym_null] = ACTIONS(7532),
    [sym_inf] = ACTIONS(7532),
    [sym_nan] = ACTIONS(7532),
    [anon_sym_NA] = ACTIONS(7532),
    [anon_sym_NA_integer_] = ACTIONS(7532),
    [anon_sym_NA_real_] = ACTIONS(7532),
    [anon_sym_NA_complex_] = ACTIONS(7532),
    [anon_sym_NA_character_] = ACTIONS(7532),
    [sym_dots] = ACTIONS(7532),
    [sym_dot_dot_i] = ACTIONS(7530),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7530),
    [sym__newline] = ACTIONS(7530),
    [sym__semicolon] = ACTIONS(7530),
    [sym__raw_string_literal] = ACTIONS(7530),
    [sym__external_open_parenthesis] = ACTIONS(7530),
    [sym__external_close_parenthesis] = ACTIONS(7530),
    [sym__external_open_brace] = ACTIONS(7530),
    [sym__external_close_brace] = ACTIONS(7530),
    [sym__external_open_bracket] = ACTIONS(7530),
    [sym__external_open_bracket2] = ACTIONS(7530),
    [sym__external_close_bracket2] = ACTIONS(7530),
  },
  [2402] = {
    [sym_identifier] = ACTIONS(7540),
    [anon_sym_BSLASH] = ACTIONS(7538),
    [anon_sym_function] = ACTIONS(7540),
    [anon_sym_EQ] = ACTIONS(7540),
    [anon_sym_if] = ACTIONS(7540),
    [anon_sym_for] = ACTIONS(7540),
    [anon_sym_while] = ACTIONS(7540),
    [anon_sym_repeat] = ACTIONS(7540),
    [anon_sym_QMARK] = ACTIONS(7538),
    [anon_sym_TILDE] = ACTIONS(7538),
    [anon_sym_BANG] = ACTIONS(7540),
    [anon_sym_PLUS] = ACTIONS(7538),
    [anon_sym_DASH] = ACTIONS(7540),
    [anon_sym_LT_DASH] = ACTIONS(7538),
    [anon_sym_LT_LT_DASH] = ACTIONS(7538),
    [anon_sym_COLON_EQ] = ACTIONS(7538),
    [anon_sym_DASH_GT] = ACTIONS(7540),
    [anon_sym_DASH_GT_GT] = ACTIONS(7538),
    [anon_sym_PIPE] = ACTIONS(7540),
    [anon_sym_AMP] = ACTIONS(7540),
    [anon_sym_PIPE_PIPE] = ACTIONS(7538),
    [anon_sym_AMP_AMP] = ACTIONS(7538),
    [anon_sym_LT] = ACTIONS(7540),
    [anon_sym_LT_EQ] = ACTIONS(7538),
    [anon_sym_GT] = ACTIONS(7540),
    [anon_sym_GT_EQ] = ACTIONS(7538),
    [anon_sym_EQ_EQ] = ACTIONS(7538),
    [anon_sym_BANG_EQ] = ACTIONS(7538),
    [anon_sym_STAR] = ACTIONS(7540),
    [anon_sym_SLASH] = ACTIONS(7538),
    [anon_sym_STAR_STAR] = ACTIONS(7538),
    [anon_sym_CARET] = ACTIONS(7538),
    [aux_sym_binary_operator_token1] = ACTIONS(7538),
    [anon_sym_PIPE_GT] = ACTIONS(7538),
    [anon_sym_COLON] = ACTIONS(7540),
    [anon_sym_DOLLAR] = ACTIONS(7538),
    [anon_sym_AT] = ACTIONS(7538),
    [aux_sym__hex_literal_token1] = ACTIONS(7538),
    [sym__number_literal] = ACTIONS(7540),
    [anon_sym_SQUOTE] = ACTIONS(7538),
    [anon_sym_DQUOTE] = ACTIONS(7538),
    [sym_return] = ACTIONS(7540),
    [sym_next] = ACTIONS(7540),
    [sym_break] = ACTIONS(7540),
    [sym_true] = ACTIONS(7540),
    [sym_false] = ACTIONS(7540),
    [sym_null] = ACTIONS(7540),
    [sym_inf] = ACTIONS(7540),
    [sym_nan] = ACTIONS(7540),
    [anon_sym_NA] = ACTIONS(7540),
    [anon_sym_NA_integer_] = ACTIONS(7540),
    [anon_sym_NA_real_] = ACTIONS(7540),
    [anon_sym_NA_complex_] = ACTIONS(7540),
    [anon_sym_NA_character_] = ACTIONS(7540),
    [sym_dots] = ACTIONS(7540),
    [sym_dot_dot_i] = ACTIONS(7538),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7538),
    [sym__newline] = ACTIONS(7538),
    [sym__semicolon] = ACTIONS(7538),
    [sym__raw_string_literal] = ACTIONS(7538),
    [sym__external_open_parenthesis] = ACTIONS(7538),
    [sym__external_close_parenthesis] = ACTIONS(7538),
    [sym__external_open_brace] = ACTIONS(7538),
    [sym__external_close_brace] = ACTIONS(7538),
    [sym__external_open_bracket] = ACTIONS(7538),
    [sym__external_close_bracket] = ACTIONS(7538),
    [sym__external_open_bracket2] = ACTIONS(7538),
  },
  [2403] = {
    [sym_identifier] = ACTIONS(7528),
    [anon_sym_BSLASH] = ACTIONS(7526),
    [anon_sym_function] = ACTIONS(7528),
    [anon_sym_EQ] = ACTIONS(7528),
    [anon_sym_if] = ACTIONS(7528),
    [anon_sym_for] = ACTIONS(7528),
    [anon_sym_while] = ACTIONS(7528),
    [anon_sym_repeat] = ACTIONS(7528),
    [anon_sym_QMARK] = ACTIONS(7526),
    [anon_sym_TILDE] = ACTIONS(7526),
    [anon_sym_BANG] = ACTIONS(7528),
    [anon_sym_PLUS] = ACTIONS(7526),
    [anon_sym_DASH] = ACTIONS(7528),
    [anon_sym_LT_DASH] = ACTIONS(7526),
    [anon_sym_LT_LT_DASH] = ACTIONS(7526),
    [anon_sym_COLON_EQ] = ACTIONS(7526),
    [anon_sym_DASH_GT] = ACTIONS(7528),
    [anon_sym_DASH_GT_GT] = ACTIONS(7526),
    [anon_sym_PIPE] = ACTIONS(7528),
    [anon_sym_AMP] = ACTIONS(7528),
    [anon_sym_PIPE_PIPE] = ACTIONS(7526),
    [anon_sym_AMP_AMP] = ACTIONS(7526),
    [anon_sym_LT] = ACTIONS(7528),
    [anon_sym_LT_EQ] = ACTIONS(7526),
    [anon_sym_GT] = ACTIONS(7528),
    [anon_sym_GT_EQ] = ACTIONS(7526),
    [anon_sym_EQ_EQ] = ACTIONS(7526),
    [anon_sym_BANG_EQ] = ACTIONS(7526),
    [anon_sym_STAR] = ACTIONS(7528),
    [anon_sym_SLASH] = ACTIONS(7526),
    [anon_sym_STAR_STAR] = ACTIONS(7526),
    [anon_sym_CARET] = ACTIONS(7526),
    [aux_sym_binary_operator_token1] = ACTIONS(7526),
    [anon_sym_PIPE_GT] = ACTIONS(7526),
    [anon_sym_COLON] = ACTIONS(7528),
    [anon_sym_DOLLAR] = ACTIONS(7526),
    [anon_sym_AT] = ACTIONS(7526),
    [aux_sym__hex_literal_token1] = ACTIONS(7526),
    [sym__number_literal] = ACTIONS(7528),
    [anon_sym_SQUOTE] = ACTIONS(7526),
    [anon_sym_DQUOTE] = ACTIONS(7526),
    [sym_return] = ACTIONS(7528),
    [sym_next] = ACTIONS(7528),
    [sym_break] = ACTIONS(7528),
    [sym_true] = ACTIONS(7528),
    [sym_false] = ACTIONS(7528),
    [sym_null] = ACTIONS(7528),
    [sym_inf] = ACTIONS(7528),
    [sym_nan] = ACTIONS(7528),
    [anon_sym_NA] = ACTIONS(7528),
    [anon_sym_NA_integer_] = ACTIONS(7528),
    [anon_sym_NA_real_] = ACTIONS(7528),
    [anon_sym_NA_complex_] = ACTIONS(7528),
    [anon_sym_NA_character_] = ACTIONS(7528),
    [sym_dots] = ACTIONS(7528),
    [sym_dot_dot_i] = ACTIONS(7526),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7526),
    [sym__newline] = ACTIONS(7526),
    [sym__semicolon] = ACTIONS(7526),
    [sym__raw_string_literal] = ACTIONS(7526),
    [sym__external_open_parenthesis] = ACTIONS(7526),
    [sym__external_close_parenthesis] = ACTIONS(7526),
    [sym__external_open_brace] = ACTIONS(7526),
    [sym__external_close_brace] = ACTIONS(7526),
    [sym__external_open_bracket] = ACTIONS(7526),
    [sym__external_open_bracket2] = ACTIONS(7526),
    [sym__external_close_bracket2] = ACTIONS(7526),
  },
  [2404] = {
    [sym_identifier] = ACTIONS(7524),
    [anon_sym_BSLASH] = ACTIONS(7522),
    [anon_sym_function] = ACTIONS(7524),
    [anon_sym_EQ] = ACTIONS(7524),
    [anon_sym_if] = ACTIONS(7524),
    [anon_sym_for] = ACTIONS(7524),
    [anon_sym_while] = ACTIONS(7524),
    [anon_sym_repeat] = ACTIONS(7524),
    [anon_sym_QMARK] = ACTIONS(7522),
    [anon_sym_TILDE] = ACTIONS(7522),
    [anon_sym_BANG] = ACTIONS(7524),
    [anon_sym_PLUS] = ACTIONS(7522),
    [anon_sym_DASH] = ACTIONS(7524),
    [anon_sym_LT_DASH] = ACTIONS(7522),
    [anon_sym_LT_LT_DASH] = ACTIONS(7522),
    [anon_sym_COLON_EQ] = ACTIONS(7522),
    [anon_sym_DASH_GT] = ACTIONS(7524),
    [anon_sym_DASH_GT_GT] = ACTIONS(7522),
    [anon_sym_PIPE] = ACTIONS(7524),
    [anon_sym_AMP] = ACTIONS(7524),
    [anon_sym_PIPE_PIPE] = ACTIONS(7522),
    [anon_sym_AMP_AMP] = ACTIONS(7522),
    [anon_sym_LT] = ACTIONS(7524),
    [anon_sym_LT_EQ] = ACTIONS(7522),
    [anon_sym_GT] = ACTIONS(7524),
    [anon_sym_GT_EQ] = ACTIONS(7522),
    [anon_sym_EQ_EQ] = ACTIONS(7522),
    [anon_sym_BANG_EQ] = ACTIONS(7522),
    [anon_sym_STAR] = ACTIONS(7524),
    [anon_sym_SLASH] = ACTIONS(7522),
    [anon_sym_STAR_STAR] = ACTIONS(7522),
    [anon_sym_CARET] = ACTIONS(7522),
    [aux_sym_binary_operator_token1] = ACTIONS(7522),
    [anon_sym_PIPE_GT] = ACTIONS(7522),
    [anon_sym_COLON] = ACTIONS(7524),
    [anon_sym_DOLLAR] = ACTIONS(7522),
    [anon_sym_AT] = ACTIONS(7522),
    [aux_sym__hex_literal_token1] = ACTIONS(7522),
    [sym__number_literal] = ACTIONS(7524),
    [anon_sym_SQUOTE] = ACTIONS(7522),
    [anon_sym_DQUOTE] = ACTIONS(7522),
    [sym_return] = ACTIONS(7524),
    [sym_next] = ACTIONS(7524),
    [sym_break] = ACTIONS(7524),
    [sym_true] = ACTIONS(7524),
    [sym_false] = ACTIONS(7524),
    [sym_null] = ACTIONS(7524),
    [sym_inf] = ACTIONS(7524),
    [sym_nan] = ACTIONS(7524),
    [anon_sym_NA] = ACTIONS(7524),
    [anon_sym_NA_integer_] = ACTIONS(7524),
    [anon_sym_NA_real_] = ACTIONS(7524),
    [anon_sym_NA_complex_] = ACTIONS(7524),
    [anon_sym_NA_character_] = ACTIONS(7524),
    [sym_dots] = ACTIONS(7524),
    [sym_dot_dot_i] = ACTIONS(7522),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7522),
    [sym__newline] = ACTIONS(7522),
    [sym__semicolon] = ACTIONS(7522),
    [sym__raw_string_literal] = ACTIONS(7522),
    [sym__external_open_parenthesis] = ACTIONS(7522),
    [sym__external_close_parenthesis] = ACTIONS(7522),
    [sym__external_open_brace] = ACTIONS(7522),
    [sym__external_close_brace] = ACTIONS(7522),
    [sym__external_open_bracket] = ACTIONS(7522),
    [sym__external_open_bracket2] = ACTIONS(7522),
    [sym__external_close_bracket2] = ACTIONS(7522),
  },
  [2405] = {
    [sym_identifier] = ACTIONS(7563),
    [anon_sym_BSLASH] = ACTIONS(7561),
    [anon_sym_function] = ACTIONS(7563),
    [anon_sym_EQ] = ACTIONS(7563),
    [anon_sym_if] = ACTIONS(7563),
    [anon_sym_for] = ACTIONS(7563),
    [anon_sym_while] = ACTIONS(7563),
    [anon_sym_repeat] = ACTIONS(7563),
    [anon_sym_QMARK] = ACTIONS(7561),
    [anon_sym_TILDE] = ACTIONS(7561),
    [anon_sym_BANG] = ACTIONS(7563),
    [anon_sym_PLUS] = ACTIONS(7561),
    [anon_sym_DASH] = ACTIONS(7563),
    [anon_sym_LT_DASH] = ACTIONS(7561),
    [anon_sym_LT_LT_DASH] = ACTIONS(7561),
    [anon_sym_COLON_EQ] = ACTIONS(7561),
    [anon_sym_DASH_GT] = ACTIONS(7563),
    [anon_sym_DASH_GT_GT] = ACTIONS(7561),
    [anon_sym_PIPE] = ACTIONS(7563),
    [anon_sym_AMP] = ACTIONS(7563),
    [anon_sym_PIPE_PIPE] = ACTIONS(7561),
    [anon_sym_AMP_AMP] = ACTIONS(7561),
    [anon_sym_LT] = ACTIONS(7563),
    [anon_sym_LT_EQ] = ACTIONS(7561),
    [anon_sym_GT] = ACTIONS(7563),
    [anon_sym_GT_EQ] = ACTIONS(7561),
    [anon_sym_EQ_EQ] = ACTIONS(7561),
    [anon_sym_BANG_EQ] = ACTIONS(7561),
    [anon_sym_STAR] = ACTIONS(7563),
    [anon_sym_SLASH] = ACTIONS(7561),
    [anon_sym_STAR_STAR] = ACTIONS(7561),
    [anon_sym_CARET] = ACTIONS(7561),
    [aux_sym_binary_operator_token1] = ACTIONS(7561),
    [anon_sym_PIPE_GT] = ACTIONS(7561),
    [anon_sym_COLON] = ACTIONS(7563),
    [anon_sym_DOLLAR] = ACTIONS(7561),
    [anon_sym_AT] = ACTIONS(7561),
    [aux_sym__hex_literal_token1] = ACTIONS(7561),
    [sym__number_literal] = ACTIONS(7563),
    [anon_sym_SQUOTE] = ACTIONS(7561),
    [anon_sym_DQUOTE] = ACTIONS(7561),
    [sym_return] = ACTIONS(7563),
    [sym_next] = ACTIONS(7563),
    [sym_break] = ACTIONS(7563),
    [sym_true] = ACTIONS(7563),
    [sym_false] = ACTIONS(7563),
    [sym_null] = ACTIONS(7563),
    [sym_inf] = ACTIONS(7563),
    [sym_nan] = ACTIONS(7563),
    [anon_sym_NA] = ACTIONS(7563),
    [anon_sym_NA_integer_] = ACTIONS(7563),
    [anon_sym_NA_real_] = ACTIONS(7563),
    [anon_sym_NA_complex_] = ACTIONS(7563),
    [anon_sym_NA_character_] = ACTIONS(7563),
    [sym_dots] = ACTIONS(7563),
    [sym_dot_dot_i] = ACTIONS(7561),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7561),
    [sym__newline] = ACTIONS(7561),
    [sym__semicolon] = ACTIONS(7561),
    [sym__raw_string_literal] = ACTIONS(7561),
    [sym__external_else] = ACTIONS(7561),
    [sym__external_open_parenthesis] = ACTIONS(7561),
    [sym__external_open_brace] = ACTIONS(7561),
    [sym__external_close_brace] = ACTIONS(7561),
    [sym__external_open_bracket] = ACTIONS(7561),
    [sym__external_close_bracket] = ACTIONS(7561),
    [sym__external_open_bracket2] = ACTIONS(7561),
  },
  [2406] = {
    [sym_identifier] = ACTIONS(7520),
    [anon_sym_BSLASH] = ACTIONS(7518),
    [anon_sym_function] = ACTIONS(7520),
    [anon_sym_EQ] = ACTIONS(7520),
    [anon_sym_if] = ACTIONS(7520),
    [anon_sym_for] = ACTIONS(7520),
    [anon_sym_while] = ACTIONS(7520),
    [anon_sym_repeat] = ACTIONS(7520),
    [anon_sym_QMARK] = ACTIONS(7518),
    [anon_sym_TILDE] = ACTIONS(7518),
    [anon_sym_BANG] = ACTIONS(7520),
    [anon_sym_PLUS] = ACTIONS(7518),
    [anon_sym_DASH] = ACTIONS(7520),
    [anon_sym_LT_DASH] = ACTIONS(7518),
    [anon_sym_LT_LT_DASH] = ACTIONS(7518),
    [anon_sym_COLON_EQ] = ACTIONS(7518),
    [anon_sym_DASH_GT] = ACTIONS(7520),
    [anon_sym_DASH_GT_GT] = ACTIONS(7518),
    [anon_sym_PIPE] = ACTIONS(7520),
    [anon_sym_AMP] = ACTIONS(7520),
    [anon_sym_PIPE_PIPE] = ACTIONS(7518),
    [anon_sym_AMP_AMP] = ACTIONS(7518),
    [anon_sym_LT] = ACTIONS(7520),
    [anon_sym_LT_EQ] = ACTIONS(7518),
    [anon_sym_GT] = ACTIONS(7520),
    [anon_sym_GT_EQ] = ACTIONS(7518),
    [anon_sym_EQ_EQ] = ACTIONS(7518),
    [anon_sym_BANG_EQ] = ACTIONS(7518),
    [anon_sym_STAR] = ACTIONS(7520),
    [anon_sym_SLASH] = ACTIONS(7518),
    [anon_sym_STAR_STAR] = ACTIONS(7518),
    [anon_sym_CARET] = ACTIONS(7518),
    [aux_sym_binary_operator_token1] = ACTIONS(7518),
    [anon_sym_PIPE_GT] = ACTIONS(7518),
    [anon_sym_COLON] = ACTIONS(7520),
    [anon_sym_DOLLAR] = ACTIONS(7518),
    [anon_sym_AT] = ACTIONS(7518),
    [aux_sym__hex_literal_token1] = ACTIONS(7518),
    [sym__number_literal] = ACTIONS(7520),
    [anon_sym_SQUOTE] = ACTIONS(7518),
    [anon_sym_DQUOTE] = ACTIONS(7518),
    [sym_return] = ACTIONS(7520),
    [sym_next] = ACTIONS(7520),
    [sym_break] = ACTIONS(7520),
    [sym_true] = ACTIONS(7520),
    [sym_false] = ACTIONS(7520),
    [sym_null] = ACTIONS(7520),
    [sym_inf] = ACTIONS(7520),
    [sym_nan] = ACTIONS(7520),
    [anon_sym_NA] = ACTIONS(7520),
    [anon_sym_NA_integer_] = ACTIONS(7520),
    [anon_sym_NA_real_] = ACTIONS(7520),
    [anon_sym_NA_complex_] = ACTIONS(7520),
    [anon_sym_NA_character_] = ACTIONS(7520),
    [sym_dots] = ACTIONS(7520),
    [sym_dot_dot_i] = ACTIONS(7518),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7518),
    [sym__newline] = ACTIONS(7518),
    [sym__semicolon] = ACTIONS(7518),
    [sym__raw_string_literal] = ACTIONS(7518),
    [sym__external_open_parenthesis] = ACTIONS(7518),
    [sym__external_close_parenthesis] = ACTIONS(7518),
    [sym__external_open_brace] = ACTIONS(7518),
    [sym__external_close_brace] = ACTIONS(7518),
    [sym__external_open_bracket] = ACTIONS(7518),
    [sym__external_open_bracket2] = ACTIONS(7518),
    [sym__external_close_bracket2] = ACTIONS(7518),
  },
  [2407] = {
    [sym_identifier] = ACTIONS(7544),
    [anon_sym_BSLASH] = ACTIONS(7542),
    [anon_sym_function] = ACTIONS(7544),
    [anon_sym_EQ] = ACTIONS(7544),
    [anon_sym_if] = ACTIONS(7544),
    [anon_sym_for] = ACTIONS(7544),
    [anon_sym_while] = ACTIONS(7544),
    [anon_sym_repeat] = ACTIONS(7544),
    [anon_sym_QMARK] = ACTIONS(7542),
    [anon_sym_TILDE] = ACTIONS(7542),
    [anon_sym_BANG] = ACTIONS(7544),
    [anon_sym_PLUS] = ACTIONS(7542),
    [anon_sym_DASH] = ACTIONS(7544),
    [anon_sym_LT_DASH] = ACTIONS(7542),
    [anon_sym_LT_LT_DASH] = ACTIONS(7542),
    [anon_sym_COLON_EQ] = ACTIONS(7542),
    [anon_sym_DASH_GT] = ACTIONS(7544),
    [anon_sym_DASH_GT_GT] = ACTIONS(7542),
    [anon_sym_PIPE] = ACTIONS(7544),
    [anon_sym_AMP] = ACTIONS(7544),
    [anon_sym_PIPE_PIPE] = ACTIONS(7542),
    [anon_sym_AMP_AMP] = ACTIONS(7542),
    [anon_sym_LT] = ACTIONS(7544),
    [anon_sym_LT_EQ] = ACTIONS(7542),
    [anon_sym_GT] = ACTIONS(7544),
    [anon_sym_GT_EQ] = ACTIONS(7542),
    [anon_sym_EQ_EQ] = ACTIONS(7542),
    [anon_sym_BANG_EQ] = ACTIONS(7542),
    [anon_sym_STAR] = ACTIONS(7544),
    [anon_sym_SLASH] = ACTIONS(7542),
    [anon_sym_STAR_STAR] = ACTIONS(7542),
    [anon_sym_CARET] = ACTIONS(7542),
    [aux_sym_binary_operator_token1] = ACTIONS(7542),
    [anon_sym_PIPE_GT] = ACTIONS(7542),
    [anon_sym_COLON] = ACTIONS(7544),
    [anon_sym_DOLLAR] = ACTIONS(7542),
    [anon_sym_AT] = ACTIONS(7542),
    [aux_sym__hex_literal_token1] = ACTIONS(7542),
    [sym__number_literal] = ACTIONS(7544),
    [anon_sym_SQUOTE] = ACTIONS(7542),
    [anon_sym_DQUOTE] = ACTIONS(7542),
    [sym_return] = ACTIONS(7544),
    [sym_next] = ACTIONS(7544),
    [sym_break] = ACTIONS(7544),
    [sym_true] = ACTIONS(7544),
    [sym_false] = ACTIONS(7544),
    [sym_null] = ACTIONS(7544),
    [sym_inf] = ACTIONS(7544),
    [sym_nan] = ACTIONS(7544),
    [anon_sym_NA] = ACTIONS(7544),
    [anon_sym_NA_integer_] = ACTIONS(7544),
    [anon_sym_NA_real_] = ACTIONS(7544),
    [anon_sym_NA_complex_] = ACTIONS(7544),
    [anon_sym_NA_character_] = ACTIONS(7544),
    [sym_dots] = ACTIONS(7544),
    [sym_dot_dot_i] = ACTIONS(7542),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7542),
    [sym__newline] = ACTIONS(7542),
    [sym__semicolon] = ACTIONS(7542),
    [sym__raw_string_literal] = ACTIONS(7542),
    [sym__external_open_parenthesis] = ACTIONS(7542),
    [sym__external_close_parenthesis] = ACTIONS(7542),
    [sym__external_open_brace] = ACTIONS(7542),
    [sym__external_close_brace] = ACTIONS(7542),
    [sym__external_open_bracket] = ACTIONS(7542),
    [sym__external_close_bracket] = ACTIONS(7542),
    [sym__external_open_bracket2] = ACTIONS(7542),
  },
  [2408] = {
    [sym_identifier] = ACTIONS(7516),
    [anon_sym_BSLASH] = ACTIONS(7514),
    [anon_sym_function] = ACTIONS(7516),
    [anon_sym_EQ] = ACTIONS(7516),
    [anon_sym_if] = ACTIONS(7516),
    [anon_sym_for] = ACTIONS(7516),
    [anon_sym_while] = ACTIONS(7516),
    [anon_sym_repeat] = ACTIONS(7516),
    [anon_sym_QMARK] = ACTIONS(7514),
    [anon_sym_TILDE] = ACTIONS(7514),
    [anon_sym_BANG] = ACTIONS(7516),
    [anon_sym_PLUS] = ACTIONS(7514),
    [anon_sym_DASH] = ACTIONS(7516),
    [anon_sym_LT_DASH] = ACTIONS(7514),
    [anon_sym_LT_LT_DASH] = ACTIONS(7514),
    [anon_sym_COLON_EQ] = ACTIONS(7514),
    [anon_sym_DASH_GT] = ACTIONS(7516),
    [anon_sym_DASH_GT_GT] = ACTIONS(7514),
    [anon_sym_PIPE] = ACTIONS(7516),
    [anon_sym_AMP] = ACTIONS(7516),
    [anon_sym_PIPE_PIPE] = ACTIONS(7514),
    [anon_sym_AMP_AMP] = ACTIONS(7514),
    [anon_sym_LT] = ACTIONS(7516),
    [anon_sym_LT_EQ] = ACTIONS(7514),
    [anon_sym_GT] = ACTIONS(7516),
    [anon_sym_GT_EQ] = ACTIONS(7514),
    [anon_sym_EQ_EQ] = ACTIONS(7514),
    [anon_sym_BANG_EQ] = ACTIONS(7514),
    [anon_sym_STAR] = ACTIONS(7516),
    [anon_sym_SLASH] = ACTIONS(7514),
    [anon_sym_STAR_STAR] = ACTIONS(7514),
    [anon_sym_CARET] = ACTIONS(7514),
    [aux_sym_binary_operator_token1] = ACTIONS(7514),
    [anon_sym_PIPE_GT] = ACTIONS(7514),
    [anon_sym_COLON] = ACTIONS(7516),
    [anon_sym_DOLLAR] = ACTIONS(7514),
    [anon_sym_AT] = ACTIONS(7514),
    [aux_sym__hex_literal_token1] = ACTIONS(7514),
    [sym__number_literal] = ACTIONS(7516),
    [anon_sym_SQUOTE] = ACTIONS(7514),
    [anon_sym_DQUOTE] = ACTIONS(7514),
    [sym_return] = ACTIONS(7516),
    [sym_next] = ACTIONS(7516),
    [sym_break] = ACTIONS(7516),
    [sym_true] = ACTIONS(7516),
    [sym_false] = ACTIONS(7516),
    [sym_null] = ACTIONS(7516),
    [sym_inf] = ACTIONS(7516),
    [sym_nan] = ACTIONS(7516),
    [anon_sym_NA] = ACTIONS(7516),
    [anon_sym_NA_integer_] = ACTIONS(7516),
    [anon_sym_NA_real_] = ACTIONS(7516),
    [anon_sym_NA_complex_] = ACTIONS(7516),
    [anon_sym_NA_character_] = ACTIONS(7516),
    [sym_dots] = ACTIONS(7516),
    [sym_dot_dot_i] = ACTIONS(7514),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7514),
    [sym__newline] = ACTIONS(7514),
    [sym__semicolon] = ACTIONS(7514),
    [sym__raw_string_literal] = ACTIONS(7514),
    [sym__external_open_parenthesis] = ACTIONS(7514),
    [sym__external_close_parenthesis] = ACTIONS(7514),
    [sym__external_open_brace] = ACTIONS(7514),
    [sym__external_close_brace] = ACTIONS(7514),
    [sym__external_open_bracket] = ACTIONS(7514),
    [sym__external_open_bracket2] = ACTIONS(7514),
    [sym__external_close_bracket2] = ACTIONS(7514),
  },
  [2409] = {
    [sym_identifier] = ACTIONS(7556),
    [anon_sym_BSLASH] = ACTIONS(7554),
    [anon_sym_function] = ACTIONS(7556),
    [anon_sym_EQ] = ACTIONS(7556),
    [anon_sym_if] = ACTIONS(7556),
    [anon_sym_for] = ACTIONS(7556),
    [anon_sym_while] = ACTIONS(7556),
    [anon_sym_repeat] = ACTIONS(7556),
    [anon_sym_QMARK] = ACTIONS(7554),
    [anon_sym_TILDE] = ACTIONS(7554),
    [anon_sym_BANG] = ACTIONS(7556),
    [anon_sym_PLUS] = ACTIONS(7554),
    [anon_sym_DASH] = ACTIONS(7556),
    [anon_sym_LT_DASH] = ACTIONS(7554),
    [anon_sym_LT_LT_DASH] = ACTIONS(7554),
    [anon_sym_COLON_EQ] = ACTIONS(7554),
    [anon_sym_DASH_GT] = ACTIONS(7556),
    [anon_sym_DASH_GT_GT] = ACTIONS(7554),
    [anon_sym_PIPE] = ACTIONS(7556),
    [anon_sym_AMP] = ACTIONS(7556),
    [anon_sym_PIPE_PIPE] = ACTIONS(7554),
    [anon_sym_AMP_AMP] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(7556),
    [anon_sym_LT_EQ] = ACTIONS(7554),
    [anon_sym_GT] = ACTIONS(7556),
    [anon_sym_GT_EQ] = ACTIONS(7554),
    [anon_sym_EQ_EQ] = ACTIONS(7554),
    [anon_sym_BANG_EQ] = ACTIONS(7554),
    [anon_sym_STAR] = ACTIONS(7556),
    [anon_sym_SLASH] = ACTIONS(7554),
    [anon_sym_STAR_STAR] = ACTIONS(7554),
    [anon_sym_CARET] = ACTIONS(7554),
    [aux_sym_binary_operator_token1] = ACTIONS(7554),
    [anon_sym_PIPE_GT] = ACTIONS(7554),
    [anon_sym_COLON] = ACTIONS(7556),
    [anon_sym_DOLLAR] = ACTIONS(7554),
    [anon_sym_AT] = ACTIONS(7554),
    [aux_sym__hex_literal_token1] = ACTIONS(7554),
    [sym__number_literal] = ACTIONS(7556),
    [anon_sym_SQUOTE] = ACTIONS(7554),
    [anon_sym_DQUOTE] = ACTIONS(7554),
    [sym_return] = ACTIONS(7556),
    [sym_next] = ACTIONS(7556),
    [sym_break] = ACTIONS(7556),
    [sym_true] = ACTIONS(7556),
    [sym_false] = ACTIONS(7556),
    [sym_null] = ACTIONS(7556),
    [sym_inf] = ACTIONS(7556),
    [sym_nan] = ACTIONS(7556),
    [anon_sym_NA] = ACTIONS(7556),
    [anon_sym_NA_integer_] = ACTIONS(7556),
    [anon_sym_NA_real_] = ACTIONS(7556),
    [anon_sym_NA_complex_] = ACTIONS(7556),
    [anon_sym_NA_character_] = ACTIONS(7556),
    [sym_dots] = ACTIONS(7556),
    [sym_dot_dot_i] = ACTIONS(7554),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7554),
    [sym__newline] = ACTIONS(7554),
    [sym__semicolon] = ACTIONS(7554),
    [sym__raw_string_literal] = ACTIONS(7554),
    [sym__external_else] = ACTIONS(7554),
    [sym__external_open_parenthesis] = ACTIONS(7554),
    [sym__external_open_brace] = ACTIONS(7554),
    [sym__external_close_brace] = ACTIONS(7554),
    [sym__external_open_bracket] = ACTIONS(7554),
    [sym__external_close_bracket] = ACTIONS(7554),
    [sym__external_open_bracket2] = ACTIONS(7554),
  },
  [2410] = {
    [ts_builtin_sym_end] = ACTIONS(5327),
    [sym_identifier] = ACTIONS(5325),
    [anon_sym_BSLASH] = ACTIONS(5327),
    [anon_sym_function] = ACTIONS(5325),
    [anon_sym_EQ] = ACTIONS(5325),
    [anon_sym_if] = ACTIONS(5325),
    [anon_sym_for] = ACTIONS(5325),
    [anon_sym_while] = ACTIONS(5325),
    [anon_sym_repeat] = ACTIONS(5325),
    [anon_sym_QMARK] = ACTIONS(5327),
    [anon_sym_TILDE] = ACTIONS(5327),
    [anon_sym_BANG] = ACTIONS(5325),
    [anon_sym_PLUS] = ACTIONS(5327),
    [anon_sym_DASH] = ACTIONS(5325),
    [anon_sym_LT_DASH] = ACTIONS(5327),
    [anon_sym_LT_LT_DASH] = ACTIONS(5327),
    [anon_sym_COLON_EQ] = ACTIONS(5327),
    [anon_sym_DASH_GT] = ACTIONS(5325),
    [anon_sym_DASH_GT_GT] = ACTIONS(5327),
    [anon_sym_PIPE] = ACTIONS(5325),
    [anon_sym_AMP] = ACTIONS(5325),
    [anon_sym_PIPE_PIPE] = ACTIONS(5327),
    [anon_sym_AMP_AMP] = ACTIONS(5327),
    [anon_sym_LT] = ACTIONS(5325),
    [anon_sym_LT_EQ] = ACTIONS(5327),
    [anon_sym_GT] = ACTIONS(5325),
    [anon_sym_GT_EQ] = ACTIONS(5327),
    [anon_sym_EQ_EQ] = ACTIONS(5327),
    [anon_sym_BANG_EQ] = ACTIONS(5327),
    [anon_sym_STAR] = ACTIONS(5325),
    [anon_sym_SLASH] = ACTIONS(5327),
    [anon_sym_STAR_STAR] = ACTIONS(5327),
    [anon_sym_CARET] = ACTIONS(5327),
    [aux_sym_binary_operator_token1] = ACTIONS(5327),
    [anon_sym_PIPE_GT] = ACTIONS(5327),
    [anon_sym_COLON] = ACTIONS(5325),
    [anon_sym_DOLLAR] = ACTIONS(5327),
    [anon_sym_AT] = ACTIONS(5327),
    [aux_sym__hex_literal_token1] = ACTIONS(5327),
    [sym__number_literal] = ACTIONS(5325),
    [anon_sym_SQUOTE] = ACTIONS(5327),
    [anon_sym_DQUOTE] = ACTIONS(5327),
    [sym_return] = ACTIONS(5325),
    [sym_next] = ACTIONS(5325),
    [sym_break] = ACTIONS(5325),
    [sym_true] = ACTIONS(5325),
    [sym_false] = ACTIONS(5325),
    [sym_null] = ACTIONS(5325),
    [sym_inf] = ACTIONS(5325),
    [sym_nan] = ACTIONS(5325),
    [anon_sym_NA] = ACTIONS(5325),
    [anon_sym_NA_integer_] = ACTIONS(5325),
    [anon_sym_NA_real_] = ACTIONS(5325),
    [anon_sym_NA_complex_] = ACTIONS(5325),
    [anon_sym_NA_character_] = ACTIONS(5325),
    [sym_dots] = ACTIONS(5325),
    [sym_dot_dot_i] = ACTIONS(5327),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5327),
    [sym__newline] = ACTIONS(5327),
    [sym__semicolon] = ACTIONS(5327),
    [sym__raw_string_literal] = ACTIONS(5327),
    [sym__external_open_parenthesis] = ACTIONS(5327),
    [sym__external_close_parenthesis] = ACTIONS(5327),
    [sym__external_open_brace] = ACTIONS(5327),
    [sym__external_close_brace] = ACTIONS(5327),
    [sym__external_open_bracket] = ACTIONS(5327),
    [sym__external_open_bracket2] = ACTIONS(5327),
  },
  [2411] = {
    [ts_builtin_sym_end] = ACTIONS(5313),
    [sym_identifier] = ACTIONS(5311),
    [anon_sym_BSLASH] = ACTIONS(5313),
    [anon_sym_function] = ACTIONS(5311),
    [anon_sym_EQ] = ACTIONS(5311),
    [anon_sym_if] = ACTIONS(5311),
    [anon_sym_for] = ACTIONS(5311),
    [anon_sym_while] = ACTIONS(5311),
    [anon_sym_repeat] = ACTIONS(5311),
    [anon_sym_QMARK] = ACTIONS(5313),
    [anon_sym_TILDE] = ACTIONS(5313),
    [anon_sym_BANG] = ACTIONS(5311),
    [anon_sym_PLUS] = ACTIONS(5313),
    [anon_sym_DASH] = ACTIONS(5311),
    [anon_sym_LT_DASH] = ACTIONS(5313),
    [anon_sym_LT_LT_DASH] = ACTIONS(5313),
    [anon_sym_COLON_EQ] = ACTIONS(5313),
    [anon_sym_DASH_GT] = ACTIONS(5311),
    [anon_sym_DASH_GT_GT] = ACTIONS(5313),
    [anon_sym_PIPE] = ACTIONS(5311),
    [anon_sym_AMP] = ACTIONS(5311),
    [anon_sym_PIPE_PIPE] = ACTIONS(5313),
    [anon_sym_AMP_AMP] = ACTIONS(5313),
    [anon_sym_LT] = ACTIONS(5311),
    [anon_sym_LT_EQ] = ACTIONS(5313),
    [anon_sym_GT] = ACTIONS(5311),
    [anon_sym_GT_EQ] = ACTIONS(5313),
    [anon_sym_EQ_EQ] = ACTIONS(5313),
    [anon_sym_BANG_EQ] = ACTIONS(5313),
    [anon_sym_STAR] = ACTIONS(5311),
    [anon_sym_SLASH] = ACTIONS(5313),
    [anon_sym_STAR_STAR] = ACTIONS(5313),
    [anon_sym_CARET] = ACTIONS(5313),
    [aux_sym_binary_operator_token1] = ACTIONS(5313),
    [anon_sym_PIPE_GT] = ACTIONS(5313),
    [anon_sym_COLON] = ACTIONS(5311),
    [anon_sym_DOLLAR] = ACTIONS(5313),
    [anon_sym_AT] = ACTIONS(5313),
    [aux_sym__hex_literal_token1] = ACTIONS(5313),
    [sym__number_literal] = ACTIONS(5311),
    [anon_sym_SQUOTE] = ACTIONS(5313),
    [anon_sym_DQUOTE] = ACTIONS(5313),
    [sym_return] = ACTIONS(5311),
    [sym_next] = ACTIONS(5311),
    [sym_break] = ACTIONS(5311),
    [sym_true] = ACTIONS(5311),
    [sym_false] = ACTIONS(5311),
    [sym_null] = ACTIONS(5311),
    [sym_inf] = ACTIONS(5311),
    [sym_nan] = ACTIONS(5311),
    [anon_sym_NA] = ACTIONS(5311),
    [anon_sym_NA_integer_] = ACTIONS(5311),
    [anon_sym_NA_real_] = ACTIONS(5311),
    [anon_sym_NA_complex_] = ACTIONS(5311),
    [anon_sym_NA_character_] = ACTIONS(5311),
    [sym_dots] = ACTIONS(5311),
    [sym_dot_dot_i] = ACTIONS(5313),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5313),
    [sym__newline] = ACTIONS(5313),
    [sym__semicolon] = ACTIONS(5313),
    [sym__raw_string_literal] = ACTIONS(5313),
    [sym__external_open_parenthesis] = ACTIONS(5313),
    [sym__external_close_parenthesis] = ACTIONS(5313),
    [sym__external_open_brace] = ACTIONS(5313),
    [sym__external_close_brace] = ACTIONS(5313),
    [sym__external_open_bracket] = ACTIONS(5313),
    [sym__external_open_bracket2] = ACTIONS(5313),
  },
  [2412] = {
    [sym_identifier] = ACTIONS(7121),
    [anon_sym_BSLASH] = ACTIONS(7123),
    [anon_sym_function] = ACTIONS(7121),
    [anon_sym_EQ] = ACTIONS(7121),
    [anon_sym_if] = ACTIONS(7121),
    [anon_sym_for] = ACTIONS(7121),
    [anon_sym_while] = ACTIONS(7121),
    [anon_sym_repeat] = ACTIONS(7121),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_TILDE] = ACTIONS(7123),
    [anon_sym_BANG] = ACTIONS(7121),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_DASH] = ACTIONS(7121),
    [anon_sym_LT_DASH] = ACTIONS(7123),
    [anon_sym_LT_LT_DASH] = ACTIONS(7123),
    [anon_sym_COLON_EQ] = ACTIONS(7123),
    [anon_sym_DASH_GT] = ACTIONS(7121),
    [anon_sym_DASH_GT_GT] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_LT_EQ] = ACTIONS(7123),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
    [aux_sym_binary_operator_token1] = ACTIONS(7123),
    [anon_sym_PIPE_GT] = ACTIONS(7123),
    [anon_sym_COLON] = ACTIONS(7121),
    [anon_sym_DOLLAR] = ACTIONS(7123),
    [anon_sym_AT] = ACTIONS(7123),
    [anon_sym_L] = ACTIONS(7616),
    [anon_sym_i] = ACTIONS(7618),
    [aux_sym__hex_literal_token1] = ACTIONS(7123),
    [sym__number_literal] = ACTIONS(7121),
    [anon_sym_SQUOTE] = ACTIONS(7123),
    [anon_sym_DQUOTE] = ACTIONS(7123),
    [sym_return] = ACTIONS(7121),
    [sym_next] = ACTIONS(7121),
    [sym_break] = ACTIONS(7121),
    [sym_true] = ACTIONS(7121),
    [sym_false] = ACTIONS(7121),
    [sym_null] = ACTIONS(7121),
    [sym_inf] = ACTIONS(7121),
    [sym_nan] = ACTIONS(7121),
    [anon_sym_NA] = ACTIONS(7121),
    [anon_sym_NA_integer_] = ACTIONS(7121),
    [anon_sym_NA_real_] = ACTIONS(7121),
    [anon_sym_NA_complex_] = ACTIONS(7121),
    [anon_sym_NA_character_] = ACTIONS(7121),
    [sym_dots] = ACTIONS(7121),
    [sym_dot_dot_i] = ACTIONS(7123),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7123),
    [sym__newline] = ACTIONS(7123),
    [sym__raw_string_literal] = ACTIONS(7123),
    [sym__external_open_parenthesis] = ACTIONS(7123),
    [sym__external_close_parenthesis] = ACTIONS(7123),
    [sym__external_open_brace] = ACTIONS(7123),
    [sym__external_open_bracket] = ACTIONS(7123),
    [sym__external_open_bracket2] = ACTIONS(7123),
    [sym__external_close_bracket2] = ACTIONS(7123),
  },
  [2413] = {
    [sym_identifier] = ACTIONS(7556),
    [anon_sym_BSLASH] = ACTIONS(7554),
    [anon_sym_function] = ACTIONS(7556),
    [anon_sym_EQ] = ACTIONS(7556),
    [anon_sym_if] = ACTIONS(7556),
    [anon_sym_for] = ACTIONS(7556),
    [anon_sym_while] = ACTIONS(7556),
    [anon_sym_repeat] = ACTIONS(7556),
    [anon_sym_QMARK] = ACTIONS(7554),
    [anon_sym_TILDE] = ACTIONS(7554),
    [anon_sym_BANG] = ACTIONS(7556),
    [anon_sym_PLUS] = ACTIONS(7554),
    [anon_sym_DASH] = ACTIONS(7556),
    [anon_sym_LT_DASH] = ACTIONS(7554),
    [anon_sym_LT_LT_DASH] = ACTIONS(7554),
    [anon_sym_COLON_EQ] = ACTIONS(7554),
    [anon_sym_DASH_GT] = ACTIONS(7556),
    [anon_sym_DASH_GT_GT] = ACTIONS(7554),
    [anon_sym_PIPE] = ACTIONS(7556),
    [anon_sym_AMP] = ACTIONS(7556),
    [anon_sym_PIPE_PIPE] = ACTIONS(7554),
    [anon_sym_AMP_AMP] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(7556),
    [anon_sym_LT_EQ] = ACTIONS(7554),
    [anon_sym_GT] = ACTIONS(7556),
    [anon_sym_GT_EQ] = ACTIONS(7554),
    [anon_sym_EQ_EQ] = ACTIONS(7554),
    [anon_sym_BANG_EQ] = ACTIONS(7554),
    [anon_sym_STAR] = ACTIONS(7556),
    [anon_sym_SLASH] = ACTIONS(7554),
    [anon_sym_STAR_STAR] = ACTIONS(7554),
    [anon_sym_CARET] = ACTIONS(7554),
    [aux_sym_binary_operator_token1] = ACTIONS(7554),
    [anon_sym_PIPE_GT] = ACTIONS(7554),
    [anon_sym_COLON] = ACTIONS(7556),
    [anon_sym_DOLLAR] = ACTIONS(7554),
    [anon_sym_AT] = ACTIONS(7554),
    [aux_sym__hex_literal_token1] = ACTIONS(7554),
    [sym__number_literal] = ACTIONS(7556),
    [anon_sym_SQUOTE] = ACTIONS(7554),
    [anon_sym_DQUOTE] = ACTIONS(7554),
    [sym_return] = ACTIONS(7556),
    [sym_next] = ACTIONS(7556),
    [sym_break] = ACTIONS(7556),
    [sym_true] = ACTIONS(7556),
    [sym_false] = ACTIONS(7556),
    [sym_null] = ACTIONS(7556),
    [sym_inf] = ACTIONS(7556),
    [sym_nan] = ACTIONS(7556),
    [anon_sym_NA] = ACTIONS(7556),
    [anon_sym_NA_integer_] = ACTIONS(7556),
    [anon_sym_NA_real_] = ACTIONS(7556),
    [anon_sym_NA_complex_] = ACTIONS(7556),
    [anon_sym_NA_character_] = ACTIONS(7556),
    [sym_dots] = ACTIONS(7556),
    [sym_dot_dot_i] = ACTIONS(7554),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7554),
    [sym__newline] = ACTIONS(7554),
    [sym__semicolon] = ACTIONS(7554),
    [sym__raw_string_literal] = ACTIONS(7554),
    [sym__external_open_parenthesis] = ACTIONS(7554),
    [sym__external_close_parenthesis] = ACTIONS(7554),
    [sym__external_open_brace] = ACTIONS(7554),
    [sym__external_close_brace] = ACTIONS(7554),
    [sym__external_open_bracket] = ACTIONS(7554),
    [sym__external_open_bracket2] = ACTIONS(7554),
    [sym__external_close_bracket2] = ACTIONS(7554),
  },
  [2414] = {
    [sym_identifier] = ACTIONS(7464),
    [anon_sym_BSLASH] = ACTIONS(7466),
    [anon_sym_function] = ACTIONS(7464),
    [anon_sym_EQ] = ACTIONS(7464),
    [anon_sym_if] = ACTIONS(7464),
    [anon_sym_for] = ACTIONS(7464),
    [anon_sym_while] = ACTIONS(7464),
    [anon_sym_repeat] = ACTIONS(7464),
    [anon_sym_QMARK] = ACTIONS(7466),
    [anon_sym_TILDE] = ACTIONS(7466),
    [anon_sym_BANG] = ACTIONS(7464),
    [anon_sym_PLUS] = ACTIONS(7466),
    [anon_sym_DASH] = ACTIONS(7464),
    [anon_sym_LT_DASH] = ACTIONS(7466),
    [anon_sym_LT_LT_DASH] = ACTIONS(7466),
    [anon_sym_COLON_EQ] = ACTIONS(7466),
    [anon_sym_DASH_GT] = ACTIONS(7464),
    [anon_sym_DASH_GT_GT] = ACTIONS(7466),
    [anon_sym_PIPE] = ACTIONS(7464),
    [anon_sym_AMP] = ACTIONS(7464),
    [anon_sym_PIPE_PIPE] = ACTIONS(7466),
    [anon_sym_AMP_AMP] = ACTIONS(7466),
    [anon_sym_LT] = ACTIONS(7464),
    [anon_sym_LT_EQ] = ACTIONS(7466),
    [anon_sym_GT] = ACTIONS(7464),
    [anon_sym_GT_EQ] = ACTIONS(7466),
    [anon_sym_EQ_EQ] = ACTIONS(7466),
    [anon_sym_BANG_EQ] = ACTIONS(7466),
    [anon_sym_STAR] = ACTIONS(7464),
    [anon_sym_SLASH] = ACTIONS(7466),
    [anon_sym_STAR_STAR] = ACTIONS(7466),
    [anon_sym_CARET] = ACTIONS(7466),
    [aux_sym_binary_operator_token1] = ACTIONS(7466),
    [anon_sym_PIPE_GT] = ACTIONS(7466),
    [anon_sym_COLON] = ACTIONS(7464),
    [anon_sym_DOLLAR] = ACTIONS(7466),
    [anon_sym_AT] = ACTIONS(7466),
    [aux_sym__hex_literal_token1] = ACTIONS(7466),
    [sym__number_literal] = ACTIONS(7464),
    [anon_sym_SQUOTE] = ACTIONS(7466),
    [anon_sym_DQUOTE] = ACTIONS(7466),
    [sym_return] = ACTIONS(7464),
    [sym_next] = ACTIONS(7464),
    [sym_break] = ACTIONS(7464),
    [sym_true] = ACTIONS(7464),
    [sym_false] = ACTIONS(7464),
    [sym_null] = ACTIONS(7464),
    [sym_inf] = ACTIONS(7464),
    [sym_nan] = ACTIONS(7464),
    [anon_sym_NA] = ACTIONS(7464),
    [anon_sym_NA_integer_] = ACTIONS(7464),
    [anon_sym_NA_real_] = ACTIONS(7464),
    [anon_sym_NA_complex_] = ACTIONS(7464),
    [anon_sym_NA_character_] = ACTIONS(7464),
    [sym_dots] = ACTIONS(7464),
    [sym_dot_dot_i] = ACTIONS(7466),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7466),
    [sym__newline] = ACTIONS(7466),
    [sym__semicolon] = ACTIONS(7466),
    [sym__raw_string_literal] = ACTIONS(7466),
    [sym__external_open_parenthesis] = ACTIONS(7466),
    [sym__external_close_parenthesis] = ACTIONS(7466),
    [sym__external_open_brace] = ACTIONS(7466),
    [sym__external_close_brace] = ACTIONS(7466),
    [sym__external_open_bracket] = ACTIONS(7466),
    [sym__external_close_bracket] = ACTIONS(7466),
    [sym__external_open_bracket2] = ACTIONS(7466),
  },
  [2415] = {
    [sym_identifier] = ACTIONS(5325),
    [anon_sym_BSLASH] = ACTIONS(5327),
    [anon_sym_function] = ACTIONS(5325),
    [anon_sym_EQ] = ACTIONS(5325),
    [anon_sym_if] = ACTIONS(5325),
    [anon_sym_for] = ACTIONS(5325),
    [anon_sym_while] = ACTIONS(5325),
    [anon_sym_repeat] = ACTIONS(5325),
    [anon_sym_QMARK] = ACTIONS(5327),
    [anon_sym_TILDE] = ACTIONS(5327),
    [anon_sym_BANG] = ACTIONS(5325),
    [anon_sym_PLUS] = ACTIONS(5327),
    [anon_sym_DASH] = ACTIONS(5325),
    [anon_sym_LT_DASH] = ACTIONS(5327),
    [anon_sym_LT_LT_DASH] = ACTIONS(5327),
    [anon_sym_COLON_EQ] = ACTIONS(5327),
    [anon_sym_DASH_GT] = ACTIONS(5325),
    [anon_sym_DASH_GT_GT] = ACTIONS(5327),
    [anon_sym_PIPE] = ACTIONS(5325),
    [anon_sym_AMP] = ACTIONS(5325),
    [anon_sym_PIPE_PIPE] = ACTIONS(5327),
    [anon_sym_AMP_AMP] = ACTIONS(5327),
    [anon_sym_LT] = ACTIONS(5325),
    [anon_sym_LT_EQ] = ACTIONS(5327),
    [anon_sym_GT] = ACTIONS(5325),
    [anon_sym_GT_EQ] = ACTIONS(5327),
    [anon_sym_EQ_EQ] = ACTIONS(5327),
    [anon_sym_BANG_EQ] = ACTIONS(5327),
    [anon_sym_STAR] = ACTIONS(5325),
    [anon_sym_SLASH] = ACTIONS(5327),
    [anon_sym_STAR_STAR] = ACTIONS(5327),
    [anon_sym_CARET] = ACTIONS(5327),
    [aux_sym_binary_operator_token1] = ACTIONS(5327),
    [anon_sym_PIPE_GT] = ACTIONS(5327),
    [anon_sym_COLON] = ACTIONS(5325),
    [anon_sym_DOLLAR] = ACTIONS(5327),
    [anon_sym_AT] = ACTIONS(5327),
    [aux_sym__hex_literal_token1] = ACTIONS(5327),
    [sym__number_literal] = ACTIONS(5325),
    [anon_sym_SQUOTE] = ACTIONS(5327),
    [anon_sym_DQUOTE] = ACTIONS(5327),
    [sym_return] = ACTIONS(5325),
    [sym_next] = ACTIONS(5325),
    [sym_break] = ACTIONS(5325),
    [sym_true] = ACTIONS(5325),
    [sym_false] = ACTIONS(5325),
    [sym_null] = ACTIONS(5325),
    [sym_inf] = ACTIONS(5325),
    [sym_nan] = ACTIONS(5325),
    [anon_sym_NA] = ACTIONS(5325),
    [anon_sym_NA_integer_] = ACTIONS(5325),
    [anon_sym_NA_real_] = ACTIONS(5325),
    [anon_sym_NA_complex_] = ACTIONS(5325),
    [anon_sym_NA_character_] = ACTIONS(5325),
    [sym_dots] = ACTIONS(5325),
    [sym_dot_dot_i] = ACTIONS(5327),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5327),
    [sym__newline] = ACTIONS(5327),
    [sym__semicolon] = ACTIONS(5327),
    [sym__raw_string_literal] = ACTIONS(5327),
    [sym__external_open_parenthesis] = ACTIONS(5327),
    [sym__external_close_parenthesis] = ACTIONS(5327),
    [sym__external_open_brace] = ACTIONS(5327),
    [sym__external_close_brace] = ACTIONS(5327),
    [sym__external_open_bracket] = ACTIONS(5327),
    [sym__external_close_bracket] = ACTIONS(5327),
    [sym__external_open_bracket2] = ACTIONS(5327),
  },
  [2416] = {
    [sym_identifier] = ACTIONS(7520),
    [anon_sym_BSLASH] = ACTIONS(7518),
    [anon_sym_function] = ACTIONS(7520),
    [anon_sym_EQ] = ACTIONS(7520),
    [anon_sym_if] = ACTIONS(7520),
    [anon_sym_for] = ACTIONS(7520),
    [anon_sym_while] = ACTIONS(7520),
    [anon_sym_repeat] = ACTIONS(7520),
    [anon_sym_QMARK] = ACTIONS(7518),
    [anon_sym_TILDE] = ACTIONS(7518),
    [anon_sym_BANG] = ACTIONS(7520),
    [anon_sym_PLUS] = ACTIONS(7518),
    [anon_sym_DASH] = ACTIONS(7520),
    [anon_sym_LT_DASH] = ACTIONS(7518),
    [anon_sym_LT_LT_DASH] = ACTIONS(7518),
    [anon_sym_COLON_EQ] = ACTIONS(7518),
    [anon_sym_DASH_GT] = ACTIONS(7520),
    [anon_sym_DASH_GT_GT] = ACTIONS(7518),
    [anon_sym_PIPE] = ACTIONS(7520),
    [anon_sym_AMP] = ACTIONS(7520),
    [anon_sym_PIPE_PIPE] = ACTIONS(7518),
    [anon_sym_AMP_AMP] = ACTIONS(7518),
    [anon_sym_LT] = ACTIONS(7520),
    [anon_sym_LT_EQ] = ACTIONS(7518),
    [anon_sym_GT] = ACTIONS(7520),
    [anon_sym_GT_EQ] = ACTIONS(7518),
    [anon_sym_EQ_EQ] = ACTIONS(7518),
    [anon_sym_BANG_EQ] = ACTIONS(7518),
    [anon_sym_STAR] = ACTIONS(7520),
    [anon_sym_SLASH] = ACTIONS(7518),
    [anon_sym_STAR_STAR] = ACTIONS(7518),
    [anon_sym_CARET] = ACTIONS(7518),
    [aux_sym_binary_operator_token1] = ACTIONS(7518),
    [anon_sym_PIPE_GT] = ACTIONS(7518),
    [anon_sym_COLON] = ACTIONS(7520),
    [anon_sym_DOLLAR] = ACTIONS(7518),
    [anon_sym_AT] = ACTIONS(7518),
    [aux_sym__hex_literal_token1] = ACTIONS(7518),
    [sym__number_literal] = ACTIONS(7520),
    [anon_sym_SQUOTE] = ACTIONS(7518),
    [anon_sym_DQUOTE] = ACTIONS(7518),
    [sym_return] = ACTIONS(7520),
    [sym_next] = ACTIONS(7520),
    [sym_break] = ACTIONS(7520),
    [sym_true] = ACTIONS(7520),
    [sym_false] = ACTIONS(7520),
    [sym_null] = ACTIONS(7520),
    [sym_inf] = ACTIONS(7520),
    [sym_nan] = ACTIONS(7520),
    [anon_sym_NA] = ACTIONS(7520),
    [anon_sym_NA_integer_] = ACTIONS(7520),
    [anon_sym_NA_real_] = ACTIONS(7520),
    [anon_sym_NA_complex_] = ACTIONS(7520),
    [anon_sym_NA_character_] = ACTIONS(7520),
    [sym_dots] = ACTIONS(7520),
    [sym_dot_dot_i] = ACTIONS(7518),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7518),
    [sym__newline] = ACTIONS(7518),
    [sym__semicolon] = ACTIONS(7518),
    [sym__raw_string_literal] = ACTIONS(7518),
    [sym__external_open_parenthesis] = ACTIONS(7518),
    [sym__external_close_parenthesis] = ACTIONS(7518),
    [sym__external_open_brace] = ACTIONS(7518),
    [sym__external_close_brace] = ACTIONS(7518),
    [sym__external_open_bracket] = ACTIONS(7518),
    [sym__external_close_bracket] = ACTIONS(7518),
    [sym__external_open_bracket2] = ACTIONS(7518),
  },
  [2417] = {
    [sym_identifier] = ACTIONS(7478),
    [anon_sym_BSLASH] = ACTIONS(7476),
    [anon_sym_function] = ACTIONS(7478),
    [anon_sym_EQ] = ACTIONS(7478),
    [anon_sym_if] = ACTIONS(7478),
    [anon_sym_for] = ACTIONS(7478),
    [anon_sym_while] = ACTIONS(7478),
    [anon_sym_repeat] = ACTIONS(7478),
    [anon_sym_QMARK] = ACTIONS(7476),
    [anon_sym_TILDE] = ACTIONS(7476),
    [anon_sym_BANG] = ACTIONS(7478),
    [anon_sym_PLUS] = ACTIONS(7476),
    [anon_sym_DASH] = ACTIONS(7478),
    [anon_sym_LT_DASH] = ACTIONS(7476),
    [anon_sym_LT_LT_DASH] = ACTIONS(7476),
    [anon_sym_COLON_EQ] = ACTIONS(7476),
    [anon_sym_DASH_GT] = ACTIONS(7478),
    [anon_sym_DASH_GT_GT] = ACTIONS(7476),
    [anon_sym_PIPE] = ACTIONS(7478),
    [anon_sym_AMP] = ACTIONS(7478),
    [anon_sym_PIPE_PIPE] = ACTIONS(7476),
    [anon_sym_AMP_AMP] = ACTIONS(7476),
    [anon_sym_LT] = ACTIONS(7478),
    [anon_sym_LT_EQ] = ACTIONS(7476),
    [anon_sym_GT] = ACTIONS(7478),
    [anon_sym_GT_EQ] = ACTIONS(7476),
    [anon_sym_EQ_EQ] = ACTIONS(7476),
    [anon_sym_BANG_EQ] = ACTIONS(7476),
    [anon_sym_STAR] = ACTIONS(7478),
    [anon_sym_SLASH] = ACTIONS(7476),
    [anon_sym_STAR_STAR] = ACTIONS(7476),
    [anon_sym_CARET] = ACTIONS(7476),
    [aux_sym_binary_operator_token1] = ACTIONS(7476),
    [anon_sym_PIPE_GT] = ACTIONS(7476),
    [anon_sym_COLON] = ACTIONS(7478),
    [anon_sym_DOLLAR] = ACTIONS(7476),
    [anon_sym_AT] = ACTIONS(7476),
    [aux_sym__hex_literal_token1] = ACTIONS(7476),
    [sym__number_literal] = ACTIONS(7478),
    [anon_sym_SQUOTE] = ACTIONS(7476),
    [anon_sym_DQUOTE] = ACTIONS(7476),
    [sym_return] = ACTIONS(7478),
    [sym_next] = ACTIONS(7478),
    [sym_break] = ACTIONS(7478),
    [sym_true] = ACTIONS(7478),
    [sym_false] = ACTIONS(7478),
    [sym_null] = ACTIONS(7478),
    [sym_inf] = ACTIONS(7478),
    [sym_nan] = ACTIONS(7478),
    [anon_sym_NA] = ACTIONS(7478),
    [anon_sym_NA_integer_] = ACTIONS(7478),
    [anon_sym_NA_real_] = ACTIONS(7478),
    [anon_sym_NA_complex_] = ACTIONS(7478),
    [anon_sym_NA_character_] = ACTIONS(7478),
    [sym_dots] = ACTIONS(7478),
    [sym_dot_dot_i] = ACTIONS(7476),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7476),
    [sym__newline] = ACTIONS(7476),
    [sym__semicolon] = ACTIONS(7476),
    [sym__raw_string_literal] = ACTIONS(7476),
    [sym__external_open_parenthesis] = ACTIONS(7476),
    [sym__external_close_parenthesis] = ACTIONS(7476),
    [sym__external_open_brace] = ACTIONS(7476),
    [sym__external_close_brace] = ACTIONS(7476),
    [sym__external_open_bracket] = ACTIONS(7476),
    [sym__external_close_bracket] = ACTIONS(7476),
    [sym__external_open_bracket2] = ACTIONS(7476),
  },
  [2418] = {
    [sym_identifier] = ACTIONS(7552),
    [anon_sym_BSLASH] = ACTIONS(7550),
    [anon_sym_function] = ACTIONS(7552),
    [anon_sym_EQ] = ACTIONS(7552),
    [anon_sym_if] = ACTIONS(7552),
    [anon_sym_for] = ACTIONS(7552),
    [anon_sym_while] = ACTIONS(7552),
    [anon_sym_repeat] = ACTIONS(7552),
    [anon_sym_QMARK] = ACTIONS(7550),
    [anon_sym_TILDE] = ACTIONS(7550),
    [anon_sym_BANG] = ACTIONS(7552),
    [anon_sym_PLUS] = ACTIONS(7550),
    [anon_sym_DASH] = ACTIONS(7552),
    [anon_sym_LT_DASH] = ACTIONS(7550),
    [anon_sym_LT_LT_DASH] = ACTIONS(7550),
    [anon_sym_COLON_EQ] = ACTIONS(7550),
    [anon_sym_DASH_GT] = ACTIONS(7552),
    [anon_sym_DASH_GT_GT] = ACTIONS(7550),
    [anon_sym_PIPE] = ACTIONS(7552),
    [anon_sym_AMP] = ACTIONS(7552),
    [anon_sym_PIPE_PIPE] = ACTIONS(7550),
    [anon_sym_AMP_AMP] = ACTIONS(7550),
    [anon_sym_LT] = ACTIONS(7552),
    [anon_sym_LT_EQ] = ACTIONS(7550),
    [anon_sym_GT] = ACTIONS(7552),
    [anon_sym_GT_EQ] = ACTIONS(7550),
    [anon_sym_EQ_EQ] = ACTIONS(7550),
    [anon_sym_BANG_EQ] = ACTIONS(7550),
    [anon_sym_STAR] = ACTIONS(7552),
    [anon_sym_SLASH] = ACTIONS(7550),
    [anon_sym_STAR_STAR] = ACTIONS(7550),
    [anon_sym_CARET] = ACTIONS(7550),
    [aux_sym_binary_operator_token1] = ACTIONS(7550),
    [anon_sym_PIPE_GT] = ACTIONS(7550),
    [anon_sym_COLON] = ACTIONS(7552),
    [anon_sym_DOLLAR] = ACTIONS(7550),
    [anon_sym_AT] = ACTIONS(7550),
    [aux_sym__hex_literal_token1] = ACTIONS(7550),
    [sym__number_literal] = ACTIONS(7552),
    [anon_sym_SQUOTE] = ACTIONS(7550),
    [anon_sym_DQUOTE] = ACTIONS(7550),
    [sym_return] = ACTIONS(7552),
    [sym_next] = ACTIONS(7552),
    [sym_break] = ACTIONS(7552),
    [sym_true] = ACTIONS(7552),
    [sym_false] = ACTIONS(7552),
    [sym_null] = ACTIONS(7552),
    [sym_inf] = ACTIONS(7552),
    [sym_nan] = ACTIONS(7552),
    [anon_sym_NA] = ACTIONS(7552),
    [anon_sym_NA_integer_] = ACTIONS(7552),
    [anon_sym_NA_real_] = ACTIONS(7552),
    [anon_sym_NA_complex_] = ACTIONS(7552),
    [anon_sym_NA_character_] = ACTIONS(7552),
    [sym_dots] = ACTIONS(7552),
    [sym_dot_dot_i] = ACTIONS(7550),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7550),
    [sym__newline] = ACTIONS(7550),
    [sym__semicolon] = ACTIONS(7550),
    [sym__raw_string_literal] = ACTIONS(7550),
    [sym__external_open_parenthesis] = ACTIONS(7550),
    [sym__external_close_parenthesis] = ACTIONS(7550),
    [sym__external_open_brace] = ACTIONS(7550),
    [sym__external_close_brace] = ACTIONS(7550),
    [sym__external_open_bracket] = ACTIONS(7550),
    [sym__external_close_bracket] = ACTIONS(7550),
    [sym__external_open_bracket2] = ACTIONS(7550),
  },
  [2419] = {
    [sym_identifier] = ACTIONS(7474),
    [anon_sym_BSLASH] = ACTIONS(7472),
    [anon_sym_function] = ACTIONS(7474),
    [anon_sym_EQ] = ACTIONS(7474),
    [anon_sym_if] = ACTIONS(7474),
    [anon_sym_for] = ACTIONS(7474),
    [anon_sym_while] = ACTIONS(7474),
    [anon_sym_repeat] = ACTIONS(7474),
    [anon_sym_QMARK] = ACTIONS(7472),
    [anon_sym_TILDE] = ACTIONS(7472),
    [anon_sym_BANG] = ACTIONS(7474),
    [anon_sym_PLUS] = ACTIONS(7472),
    [anon_sym_DASH] = ACTIONS(7474),
    [anon_sym_LT_DASH] = ACTIONS(7472),
    [anon_sym_LT_LT_DASH] = ACTIONS(7472),
    [anon_sym_COLON_EQ] = ACTIONS(7472),
    [anon_sym_DASH_GT] = ACTIONS(7474),
    [anon_sym_DASH_GT_GT] = ACTIONS(7472),
    [anon_sym_PIPE] = ACTIONS(7474),
    [anon_sym_AMP] = ACTIONS(7474),
    [anon_sym_PIPE_PIPE] = ACTIONS(7472),
    [anon_sym_AMP_AMP] = ACTIONS(7472),
    [anon_sym_LT] = ACTIONS(7474),
    [anon_sym_LT_EQ] = ACTIONS(7472),
    [anon_sym_GT] = ACTIONS(7474),
    [anon_sym_GT_EQ] = ACTIONS(7472),
    [anon_sym_EQ_EQ] = ACTIONS(7472),
    [anon_sym_BANG_EQ] = ACTIONS(7472),
    [anon_sym_STAR] = ACTIONS(7474),
    [anon_sym_SLASH] = ACTIONS(7472),
    [anon_sym_STAR_STAR] = ACTIONS(7472),
    [anon_sym_CARET] = ACTIONS(7472),
    [aux_sym_binary_operator_token1] = ACTIONS(7472),
    [anon_sym_PIPE_GT] = ACTIONS(7472),
    [anon_sym_COLON] = ACTIONS(7474),
    [anon_sym_DOLLAR] = ACTIONS(7472),
    [anon_sym_AT] = ACTIONS(7472),
    [aux_sym__hex_literal_token1] = ACTIONS(7472),
    [sym__number_literal] = ACTIONS(7474),
    [anon_sym_SQUOTE] = ACTIONS(7472),
    [anon_sym_DQUOTE] = ACTIONS(7472),
    [sym_return] = ACTIONS(7474),
    [sym_next] = ACTIONS(7474),
    [sym_break] = ACTIONS(7474),
    [sym_true] = ACTIONS(7474),
    [sym_false] = ACTIONS(7474),
    [sym_null] = ACTIONS(7474),
    [sym_inf] = ACTIONS(7474),
    [sym_nan] = ACTIONS(7474),
    [anon_sym_NA] = ACTIONS(7474),
    [anon_sym_NA_integer_] = ACTIONS(7474),
    [anon_sym_NA_real_] = ACTIONS(7474),
    [anon_sym_NA_complex_] = ACTIONS(7474),
    [anon_sym_NA_character_] = ACTIONS(7474),
    [sym_dots] = ACTIONS(7474),
    [sym_dot_dot_i] = ACTIONS(7472),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7472),
    [sym__newline] = ACTIONS(7472),
    [sym__semicolon] = ACTIONS(7472),
    [sym__raw_string_literal] = ACTIONS(7472),
    [sym__external_open_parenthesis] = ACTIONS(7472),
    [sym__external_close_parenthesis] = ACTIONS(7472),
    [sym__external_open_brace] = ACTIONS(7472),
    [sym__external_close_brace] = ACTIONS(7472),
    [sym__external_open_bracket] = ACTIONS(7472),
    [sym__external_open_bracket2] = ACTIONS(7472),
    [sym__external_close_bracket2] = ACTIONS(7472),
  },
  [2420] = {
    [sym_identifier] = ACTIONS(7464),
    [anon_sym_BSLASH] = ACTIONS(7466),
    [anon_sym_function] = ACTIONS(7464),
    [anon_sym_EQ] = ACTIONS(7464),
    [anon_sym_if] = ACTIONS(7464),
    [anon_sym_for] = ACTIONS(7464),
    [anon_sym_while] = ACTIONS(7464),
    [anon_sym_repeat] = ACTIONS(7464),
    [anon_sym_QMARK] = ACTIONS(7466),
    [anon_sym_TILDE] = ACTIONS(7466),
    [anon_sym_BANG] = ACTIONS(7464),
    [anon_sym_PLUS] = ACTIONS(7466),
    [anon_sym_DASH] = ACTIONS(7464),
    [anon_sym_LT_DASH] = ACTIONS(7466),
    [anon_sym_LT_LT_DASH] = ACTIONS(7466),
    [anon_sym_COLON_EQ] = ACTIONS(7466),
    [anon_sym_DASH_GT] = ACTIONS(7464),
    [anon_sym_DASH_GT_GT] = ACTIONS(7466),
    [anon_sym_PIPE] = ACTIONS(7464),
    [anon_sym_AMP] = ACTIONS(7464),
    [anon_sym_PIPE_PIPE] = ACTIONS(7466),
    [anon_sym_AMP_AMP] = ACTIONS(7466),
    [anon_sym_LT] = ACTIONS(7464),
    [anon_sym_LT_EQ] = ACTIONS(7466),
    [anon_sym_GT] = ACTIONS(7464),
    [anon_sym_GT_EQ] = ACTIONS(7466),
    [anon_sym_EQ_EQ] = ACTIONS(7466),
    [anon_sym_BANG_EQ] = ACTIONS(7466),
    [anon_sym_STAR] = ACTIONS(7464),
    [anon_sym_SLASH] = ACTIONS(7466),
    [anon_sym_STAR_STAR] = ACTIONS(7466),
    [anon_sym_CARET] = ACTIONS(7466),
    [aux_sym_binary_operator_token1] = ACTIONS(7466),
    [anon_sym_PIPE_GT] = ACTIONS(7466),
    [anon_sym_COLON] = ACTIONS(7464),
    [anon_sym_DOLLAR] = ACTIONS(7466),
    [anon_sym_AT] = ACTIONS(7466),
    [aux_sym__hex_literal_token1] = ACTIONS(7466),
    [sym__number_literal] = ACTIONS(7464),
    [anon_sym_SQUOTE] = ACTIONS(7466),
    [anon_sym_DQUOTE] = ACTIONS(7466),
    [sym_return] = ACTIONS(7464),
    [sym_next] = ACTIONS(7464),
    [sym_break] = ACTIONS(7464),
    [sym_true] = ACTIONS(7464),
    [sym_false] = ACTIONS(7464),
    [sym_null] = ACTIONS(7464),
    [sym_inf] = ACTIONS(7464),
    [sym_nan] = ACTIONS(7464),
    [anon_sym_NA] = ACTIONS(7464),
    [anon_sym_NA_integer_] = ACTIONS(7464),
    [anon_sym_NA_real_] = ACTIONS(7464),
    [anon_sym_NA_complex_] = ACTIONS(7464),
    [anon_sym_NA_character_] = ACTIONS(7464),
    [sym_dots] = ACTIONS(7464),
    [sym_dot_dot_i] = ACTIONS(7466),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7466),
    [sym__newline] = ACTIONS(7466),
    [sym__semicolon] = ACTIONS(7466),
    [sym__raw_string_literal] = ACTIONS(7466),
    [sym__external_open_parenthesis] = ACTIONS(7466),
    [sym__external_close_parenthesis] = ACTIONS(7466),
    [sym__external_open_brace] = ACTIONS(7466),
    [sym__external_close_brace] = ACTIONS(7466),
    [sym__external_open_bracket] = ACTIONS(7466),
    [sym__external_open_bracket2] = ACTIONS(7466),
    [sym__external_close_bracket2] = ACTIONS(7466),
  },
  [2421] = {
    [sym_identifier] = ACTIONS(7478),
    [anon_sym_BSLASH] = ACTIONS(7476),
    [anon_sym_function] = ACTIONS(7478),
    [anon_sym_EQ] = ACTIONS(7478),
    [anon_sym_if] = ACTIONS(7478),
    [anon_sym_for] = ACTIONS(7478),
    [anon_sym_while] = ACTIONS(7478),
    [anon_sym_repeat] = ACTIONS(7478),
    [anon_sym_QMARK] = ACTIONS(7476),
    [anon_sym_TILDE] = ACTIONS(7476),
    [anon_sym_BANG] = ACTIONS(7478),
    [anon_sym_PLUS] = ACTIONS(7476),
    [anon_sym_DASH] = ACTIONS(7478),
    [anon_sym_LT_DASH] = ACTIONS(7476),
    [anon_sym_LT_LT_DASH] = ACTIONS(7476),
    [anon_sym_COLON_EQ] = ACTIONS(7476),
    [anon_sym_DASH_GT] = ACTIONS(7478),
    [anon_sym_DASH_GT_GT] = ACTIONS(7476),
    [anon_sym_PIPE] = ACTIONS(7478),
    [anon_sym_AMP] = ACTIONS(7478),
    [anon_sym_PIPE_PIPE] = ACTIONS(7476),
    [anon_sym_AMP_AMP] = ACTIONS(7476),
    [anon_sym_LT] = ACTIONS(7478),
    [anon_sym_LT_EQ] = ACTIONS(7476),
    [anon_sym_GT] = ACTIONS(7478),
    [anon_sym_GT_EQ] = ACTIONS(7476),
    [anon_sym_EQ_EQ] = ACTIONS(7476),
    [anon_sym_BANG_EQ] = ACTIONS(7476),
    [anon_sym_STAR] = ACTIONS(7478),
    [anon_sym_SLASH] = ACTIONS(7476),
    [anon_sym_STAR_STAR] = ACTIONS(7476),
    [anon_sym_CARET] = ACTIONS(7476),
    [aux_sym_binary_operator_token1] = ACTIONS(7476),
    [anon_sym_PIPE_GT] = ACTIONS(7476),
    [anon_sym_COLON] = ACTIONS(7478),
    [anon_sym_DOLLAR] = ACTIONS(7476),
    [anon_sym_AT] = ACTIONS(7476),
    [aux_sym__hex_literal_token1] = ACTIONS(7476),
    [sym__number_literal] = ACTIONS(7478),
    [anon_sym_SQUOTE] = ACTIONS(7476),
    [anon_sym_DQUOTE] = ACTIONS(7476),
    [sym_return] = ACTIONS(7478),
    [sym_next] = ACTIONS(7478),
    [sym_break] = ACTIONS(7478),
    [sym_true] = ACTIONS(7478),
    [sym_false] = ACTIONS(7478),
    [sym_null] = ACTIONS(7478),
    [sym_inf] = ACTIONS(7478),
    [sym_nan] = ACTIONS(7478),
    [anon_sym_NA] = ACTIONS(7478),
    [anon_sym_NA_integer_] = ACTIONS(7478),
    [anon_sym_NA_real_] = ACTIONS(7478),
    [anon_sym_NA_complex_] = ACTIONS(7478),
    [anon_sym_NA_character_] = ACTIONS(7478),
    [sym_dots] = ACTIONS(7478),
    [sym_dot_dot_i] = ACTIONS(7476),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7476),
    [sym__newline] = ACTIONS(7476),
    [sym__semicolon] = ACTIONS(7476),
    [sym__raw_string_literal] = ACTIONS(7476),
    [sym__external_open_parenthesis] = ACTIONS(7476),
    [sym__external_close_parenthesis] = ACTIONS(7476),
    [sym__external_open_brace] = ACTIONS(7476),
    [sym__external_close_brace] = ACTIONS(7476),
    [sym__external_open_bracket] = ACTIONS(7476),
    [sym__external_open_bracket2] = ACTIONS(7476),
    [sym__external_close_bracket2] = ACTIONS(7476),
  },
  [2422] = {
    [sym_identifier] = ACTIONS(7482),
    [anon_sym_BSLASH] = ACTIONS(7480),
    [anon_sym_function] = ACTIONS(7482),
    [anon_sym_EQ] = ACTIONS(7482),
    [anon_sym_if] = ACTIONS(7482),
    [anon_sym_for] = ACTIONS(7482),
    [anon_sym_while] = ACTIONS(7482),
    [anon_sym_repeat] = ACTIONS(7482),
    [anon_sym_QMARK] = ACTIONS(7480),
    [anon_sym_TILDE] = ACTIONS(7480),
    [anon_sym_BANG] = ACTIONS(7482),
    [anon_sym_PLUS] = ACTIONS(7480),
    [anon_sym_DASH] = ACTIONS(7482),
    [anon_sym_LT_DASH] = ACTIONS(7480),
    [anon_sym_LT_LT_DASH] = ACTIONS(7480),
    [anon_sym_COLON_EQ] = ACTIONS(7480),
    [anon_sym_DASH_GT] = ACTIONS(7482),
    [anon_sym_DASH_GT_GT] = ACTIONS(7480),
    [anon_sym_PIPE] = ACTIONS(7482),
    [anon_sym_AMP] = ACTIONS(7482),
    [anon_sym_PIPE_PIPE] = ACTIONS(7480),
    [anon_sym_AMP_AMP] = ACTIONS(7480),
    [anon_sym_LT] = ACTIONS(7482),
    [anon_sym_LT_EQ] = ACTIONS(7480),
    [anon_sym_GT] = ACTIONS(7482),
    [anon_sym_GT_EQ] = ACTIONS(7480),
    [anon_sym_EQ_EQ] = ACTIONS(7480),
    [anon_sym_BANG_EQ] = ACTIONS(7480),
    [anon_sym_STAR] = ACTIONS(7482),
    [anon_sym_SLASH] = ACTIONS(7480),
    [anon_sym_STAR_STAR] = ACTIONS(7480),
    [anon_sym_CARET] = ACTIONS(7480),
    [aux_sym_binary_operator_token1] = ACTIONS(7480),
    [anon_sym_PIPE_GT] = ACTIONS(7480),
    [anon_sym_COLON] = ACTIONS(7482),
    [anon_sym_DOLLAR] = ACTIONS(7480),
    [anon_sym_AT] = ACTIONS(7480),
    [aux_sym__hex_literal_token1] = ACTIONS(7480),
    [sym__number_literal] = ACTIONS(7482),
    [anon_sym_SQUOTE] = ACTIONS(7480),
    [anon_sym_DQUOTE] = ACTIONS(7480),
    [sym_return] = ACTIONS(7482),
    [sym_next] = ACTIONS(7482),
    [sym_break] = ACTIONS(7482),
    [sym_true] = ACTIONS(7482),
    [sym_false] = ACTIONS(7482),
    [sym_null] = ACTIONS(7482),
    [sym_inf] = ACTIONS(7482),
    [sym_nan] = ACTIONS(7482),
    [anon_sym_NA] = ACTIONS(7482),
    [anon_sym_NA_integer_] = ACTIONS(7482),
    [anon_sym_NA_real_] = ACTIONS(7482),
    [anon_sym_NA_complex_] = ACTIONS(7482),
    [anon_sym_NA_character_] = ACTIONS(7482),
    [sym_dots] = ACTIONS(7482),
    [sym_dot_dot_i] = ACTIONS(7480),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7480),
    [sym__newline] = ACTIONS(7480),
    [sym__semicolon] = ACTIONS(7480),
    [sym__raw_string_literal] = ACTIONS(7480),
    [sym__external_open_parenthesis] = ACTIONS(7480),
    [sym__external_close_parenthesis] = ACTIONS(7480),
    [sym__external_open_brace] = ACTIONS(7480),
    [sym__external_close_brace] = ACTIONS(7480),
    [sym__external_open_bracket] = ACTIONS(7480),
    [sym__external_open_bracket2] = ACTIONS(7480),
    [sym__external_close_bracket2] = ACTIONS(7480),
  },
  [2423] = {
    [sym_identifier] = ACTIONS(7195),
    [anon_sym_BSLASH] = ACTIONS(7193),
    [anon_sym_function] = ACTIONS(7195),
    [anon_sym_EQ] = ACTIONS(7195),
    [anon_sym_if] = ACTIONS(7195),
    [anon_sym_for] = ACTIONS(7195),
    [anon_sym_while] = ACTIONS(7195),
    [anon_sym_repeat] = ACTIONS(7195),
    [anon_sym_QMARK] = ACTIONS(7193),
    [anon_sym_TILDE] = ACTIONS(7193),
    [anon_sym_BANG] = ACTIONS(7195),
    [anon_sym_PLUS] = ACTIONS(7193),
    [anon_sym_DASH] = ACTIONS(7195),
    [anon_sym_LT_DASH] = ACTIONS(7193),
    [anon_sym_LT_LT_DASH] = ACTIONS(7193),
    [anon_sym_COLON_EQ] = ACTIONS(7193),
    [anon_sym_DASH_GT] = ACTIONS(7195),
    [anon_sym_DASH_GT_GT] = ACTIONS(7193),
    [anon_sym_PIPE] = ACTIONS(7195),
    [anon_sym_AMP] = ACTIONS(7195),
    [anon_sym_PIPE_PIPE] = ACTIONS(7193),
    [anon_sym_AMP_AMP] = ACTIONS(7193),
    [anon_sym_LT] = ACTIONS(7195),
    [anon_sym_LT_EQ] = ACTIONS(7193),
    [anon_sym_GT] = ACTIONS(7195),
    [anon_sym_GT_EQ] = ACTIONS(7193),
    [anon_sym_EQ_EQ] = ACTIONS(7193),
    [anon_sym_BANG_EQ] = ACTIONS(7193),
    [anon_sym_STAR] = ACTIONS(7195),
    [anon_sym_SLASH] = ACTIONS(7193),
    [anon_sym_STAR_STAR] = ACTIONS(7193),
    [anon_sym_CARET] = ACTIONS(7193),
    [aux_sym_binary_operator_token1] = ACTIONS(7193),
    [anon_sym_PIPE_GT] = ACTIONS(7193),
    [anon_sym_COLON] = ACTIONS(7195),
    [anon_sym_DOLLAR] = ACTIONS(7193),
    [anon_sym_AT] = ACTIONS(7193),
    [anon_sym_COLON_COLON] = ACTIONS(7195),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7193),
    [aux_sym__hex_literal_token1] = ACTIONS(7193),
    [sym__number_literal] = ACTIONS(7195),
    [anon_sym_SQUOTE] = ACTIONS(7193),
    [anon_sym_DQUOTE] = ACTIONS(7193),
    [sym_return] = ACTIONS(7195),
    [sym_next] = ACTIONS(7195),
    [sym_break] = ACTIONS(7195),
    [sym_true] = ACTIONS(7195),
    [sym_false] = ACTIONS(7195),
    [sym_null] = ACTIONS(7195),
    [sym_inf] = ACTIONS(7195),
    [sym_nan] = ACTIONS(7195),
    [anon_sym_NA] = ACTIONS(7195),
    [anon_sym_NA_integer_] = ACTIONS(7195),
    [anon_sym_NA_real_] = ACTIONS(7195),
    [anon_sym_NA_complex_] = ACTIONS(7195),
    [anon_sym_NA_character_] = ACTIONS(7195),
    [sym_dots] = ACTIONS(7195),
    [sym_dot_dot_i] = ACTIONS(7193),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7193),
    [sym__newline] = ACTIONS(7193),
    [sym__raw_string_literal] = ACTIONS(7193),
    [sym__external_open_parenthesis] = ACTIONS(7193),
    [sym__external_close_parenthesis] = ACTIONS(7193),
    [sym__external_open_brace] = ACTIONS(7193),
    [sym__external_open_bracket] = ACTIONS(7193),
    [sym__external_close_bracket] = ACTIONS(7193),
    [sym__external_open_bracket2] = ACTIONS(7193),
  },
  [2424] = {
    [sym_identifier] = ACTIONS(7191),
    [anon_sym_BSLASH] = ACTIONS(7189),
    [anon_sym_function] = ACTIONS(7191),
    [anon_sym_EQ] = ACTIONS(7191),
    [anon_sym_if] = ACTIONS(7191),
    [anon_sym_for] = ACTIONS(7191),
    [anon_sym_while] = ACTIONS(7191),
    [anon_sym_repeat] = ACTIONS(7191),
    [anon_sym_QMARK] = ACTIONS(7189),
    [anon_sym_TILDE] = ACTIONS(7189),
    [anon_sym_BANG] = ACTIONS(7191),
    [anon_sym_PLUS] = ACTIONS(7189),
    [anon_sym_DASH] = ACTIONS(7191),
    [anon_sym_LT_DASH] = ACTIONS(7189),
    [anon_sym_LT_LT_DASH] = ACTIONS(7189),
    [anon_sym_COLON_EQ] = ACTIONS(7189),
    [anon_sym_DASH_GT] = ACTIONS(7191),
    [anon_sym_DASH_GT_GT] = ACTIONS(7189),
    [anon_sym_PIPE] = ACTIONS(7191),
    [anon_sym_AMP] = ACTIONS(7191),
    [anon_sym_PIPE_PIPE] = ACTIONS(7189),
    [anon_sym_AMP_AMP] = ACTIONS(7189),
    [anon_sym_LT] = ACTIONS(7191),
    [anon_sym_LT_EQ] = ACTIONS(7189),
    [anon_sym_GT] = ACTIONS(7191),
    [anon_sym_GT_EQ] = ACTIONS(7189),
    [anon_sym_EQ_EQ] = ACTIONS(7189),
    [anon_sym_BANG_EQ] = ACTIONS(7189),
    [anon_sym_STAR] = ACTIONS(7191),
    [anon_sym_SLASH] = ACTIONS(7189),
    [anon_sym_STAR_STAR] = ACTIONS(7189),
    [anon_sym_CARET] = ACTIONS(7189),
    [aux_sym_binary_operator_token1] = ACTIONS(7189),
    [anon_sym_PIPE_GT] = ACTIONS(7189),
    [anon_sym_COLON] = ACTIONS(7191),
    [anon_sym_DOLLAR] = ACTIONS(7189),
    [anon_sym_AT] = ACTIONS(7189),
    [anon_sym_COLON_COLON] = ACTIONS(7191),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7189),
    [aux_sym__hex_literal_token1] = ACTIONS(7189),
    [sym__number_literal] = ACTIONS(7191),
    [anon_sym_SQUOTE] = ACTIONS(7189),
    [anon_sym_DQUOTE] = ACTIONS(7189),
    [sym_return] = ACTIONS(7191),
    [sym_next] = ACTIONS(7191),
    [sym_break] = ACTIONS(7191),
    [sym_true] = ACTIONS(7191),
    [sym_false] = ACTIONS(7191),
    [sym_null] = ACTIONS(7191),
    [sym_inf] = ACTIONS(7191),
    [sym_nan] = ACTIONS(7191),
    [anon_sym_NA] = ACTIONS(7191),
    [anon_sym_NA_integer_] = ACTIONS(7191),
    [anon_sym_NA_real_] = ACTIONS(7191),
    [anon_sym_NA_complex_] = ACTIONS(7191),
    [anon_sym_NA_character_] = ACTIONS(7191),
    [sym_dots] = ACTIONS(7191),
    [sym_dot_dot_i] = ACTIONS(7189),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7189),
    [sym__newline] = ACTIONS(7189),
    [sym__raw_string_literal] = ACTIONS(7189),
    [sym__external_open_parenthesis] = ACTIONS(7189),
    [sym__external_close_parenthesis] = ACTIONS(7189),
    [sym__external_open_brace] = ACTIONS(7189),
    [sym__external_open_bracket] = ACTIONS(7189),
    [sym__external_close_bracket] = ACTIONS(7189),
    [sym__external_open_bracket2] = ACTIONS(7189),
  },
  [2425] = {
    [sym_identifier] = ACTIONS(5325),
    [anon_sym_BSLASH] = ACTIONS(5327),
    [anon_sym_function] = ACTIONS(5325),
    [anon_sym_EQ] = ACTIONS(5325),
    [anon_sym_if] = ACTIONS(5325),
    [anon_sym_for] = ACTIONS(5325),
    [anon_sym_while] = ACTIONS(5325),
    [anon_sym_repeat] = ACTIONS(5325),
    [anon_sym_QMARK] = ACTIONS(5327),
    [anon_sym_TILDE] = ACTIONS(5327),
    [anon_sym_BANG] = ACTIONS(5325),
    [anon_sym_PLUS] = ACTIONS(5327),
    [anon_sym_DASH] = ACTIONS(5325),
    [anon_sym_LT_DASH] = ACTIONS(5327),
    [anon_sym_LT_LT_DASH] = ACTIONS(5327),
    [anon_sym_COLON_EQ] = ACTIONS(5327),
    [anon_sym_DASH_GT] = ACTIONS(5325),
    [anon_sym_DASH_GT_GT] = ACTIONS(5327),
    [anon_sym_PIPE] = ACTIONS(5325),
    [anon_sym_AMP] = ACTIONS(5325),
    [anon_sym_PIPE_PIPE] = ACTIONS(5327),
    [anon_sym_AMP_AMP] = ACTIONS(5327),
    [anon_sym_LT] = ACTIONS(5325),
    [anon_sym_LT_EQ] = ACTIONS(5327),
    [anon_sym_GT] = ACTIONS(5325),
    [anon_sym_GT_EQ] = ACTIONS(5327),
    [anon_sym_EQ_EQ] = ACTIONS(5327),
    [anon_sym_BANG_EQ] = ACTIONS(5327),
    [anon_sym_STAR] = ACTIONS(5325),
    [anon_sym_SLASH] = ACTIONS(5327),
    [anon_sym_STAR_STAR] = ACTIONS(5327),
    [anon_sym_CARET] = ACTIONS(5327),
    [aux_sym_binary_operator_token1] = ACTIONS(5327),
    [anon_sym_PIPE_GT] = ACTIONS(5327),
    [anon_sym_COLON] = ACTIONS(5325),
    [anon_sym_DOLLAR] = ACTIONS(5327),
    [anon_sym_AT] = ACTIONS(5327),
    [aux_sym__hex_literal_token1] = ACTIONS(5327),
    [sym__number_literal] = ACTIONS(5325),
    [anon_sym_SQUOTE] = ACTIONS(5327),
    [anon_sym_DQUOTE] = ACTIONS(5327),
    [sym_return] = ACTIONS(5325),
    [sym_next] = ACTIONS(5325),
    [sym_break] = ACTIONS(5325),
    [sym_true] = ACTIONS(5325),
    [sym_false] = ACTIONS(5325),
    [sym_null] = ACTIONS(5325),
    [sym_inf] = ACTIONS(5325),
    [sym_nan] = ACTIONS(5325),
    [anon_sym_NA] = ACTIONS(5325),
    [anon_sym_NA_integer_] = ACTIONS(5325),
    [anon_sym_NA_real_] = ACTIONS(5325),
    [anon_sym_NA_complex_] = ACTIONS(5325),
    [anon_sym_NA_character_] = ACTIONS(5325),
    [sym_dots] = ACTIONS(5325),
    [sym_dot_dot_i] = ACTIONS(5327),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5327),
    [sym__newline] = ACTIONS(5327),
    [sym__semicolon] = ACTIONS(5327),
    [sym__raw_string_literal] = ACTIONS(5327),
    [sym__external_else] = ACTIONS(5327),
    [sym__external_open_parenthesis] = ACTIONS(5327),
    [sym__external_open_brace] = ACTIONS(5327),
    [sym__external_close_brace] = ACTIONS(5327),
    [sym__external_open_bracket] = ACTIONS(5327),
    [sym__external_close_bracket] = ACTIONS(5327),
    [sym__external_open_bracket2] = ACTIONS(5327),
  },
  [2426] = {
    [sym_identifier] = ACTIONS(7482),
    [anon_sym_BSLASH] = ACTIONS(7480),
    [anon_sym_function] = ACTIONS(7482),
    [anon_sym_EQ] = ACTIONS(7482),
    [anon_sym_if] = ACTIONS(7482),
    [anon_sym_for] = ACTIONS(7482),
    [anon_sym_while] = ACTIONS(7482),
    [anon_sym_repeat] = ACTIONS(7482),
    [anon_sym_QMARK] = ACTIONS(7480),
    [anon_sym_TILDE] = ACTIONS(7480),
    [anon_sym_BANG] = ACTIONS(7482),
    [anon_sym_PLUS] = ACTIONS(7480),
    [anon_sym_DASH] = ACTIONS(7482),
    [anon_sym_LT_DASH] = ACTIONS(7480),
    [anon_sym_LT_LT_DASH] = ACTIONS(7480),
    [anon_sym_COLON_EQ] = ACTIONS(7480),
    [anon_sym_DASH_GT] = ACTIONS(7482),
    [anon_sym_DASH_GT_GT] = ACTIONS(7480),
    [anon_sym_PIPE] = ACTIONS(7482),
    [anon_sym_AMP] = ACTIONS(7482),
    [anon_sym_PIPE_PIPE] = ACTIONS(7480),
    [anon_sym_AMP_AMP] = ACTIONS(7480),
    [anon_sym_LT] = ACTIONS(7482),
    [anon_sym_LT_EQ] = ACTIONS(7480),
    [anon_sym_GT] = ACTIONS(7482),
    [anon_sym_GT_EQ] = ACTIONS(7480),
    [anon_sym_EQ_EQ] = ACTIONS(7480),
    [anon_sym_BANG_EQ] = ACTIONS(7480),
    [anon_sym_STAR] = ACTIONS(7482),
    [anon_sym_SLASH] = ACTIONS(7480),
    [anon_sym_STAR_STAR] = ACTIONS(7480),
    [anon_sym_CARET] = ACTIONS(7480),
    [aux_sym_binary_operator_token1] = ACTIONS(7480),
    [anon_sym_PIPE_GT] = ACTIONS(7480),
    [anon_sym_COLON] = ACTIONS(7482),
    [anon_sym_DOLLAR] = ACTIONS(7480),
    [anon_sym_AT] = ACTIONS(7480),
    [aux_sym__hex_literal_token1] = ACTIONS(7480),
    [sym__number_literal] = ACTIONS(7482),
    [anon_sym_SQUOTE] = ACTIONS(7480),
    [anon_sym_DQUOTE] = ACTIONS(7480),
    [sym_return] = ACTIONS(7482),
    [sym_next] = ACTIONS(7482),
    [sym_break] = ACTIONS(7482),
    [sym_true] = ACTIONS(7482),
    [sym_false] = ACTIONS(7482),
    [sym_null] = ACTIONS(7482),
    [sym_inf] = ACTIONS(7482),
    [sym_nan] = ACTIONS(7482),
    [anon_sym_NA] = ACTIONS(7482),
    [anon_sym_NA_integer_] = ACTIONS(7482),
    [anon_sym_NA_real_] = ACTIONS(7482),
    [anon_sym_NA_complex_] = ACTIONS(7482),
    [anon_sym_NA_character_] = ACTIONS(7482),
    [sym_dots] = ACTIONS(7482),
    [sym_dot_dot_i] = ACTIONS(7480),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7480),
    [sym__newline] = ACTIONS(7480),
    [sym__semicolon] = ACTIONS(7480),
    [sym__raw_string_literal] = ACTIONS(7480),
    [sym__external_open_parenthesis] = ACTIONS(7480),
    [sym__external_close_parenthesis] = ACTIONS(7480),
    [sym__external_open_brace] = ACTIONS(7480),
    [sym__external_close_brace] = ACTIONS(7480),
    [sym__external_open_bracket] = ACTIONS(7480),
    [sym__external_close_bracket] = ACTIONS(7480),
    [sym__external_open_bracket2] = ACTIONS(7480),
  },
  [2427] = {
    [sym_identifier] = ACTIONS(7516),
    [anon_sym_BSLASH] = ACTIONS(7514),
    [anon_sym_function] = ACTIONS(7516),
    [anon_sym_EQ] = ACTIONS(7516),
    [anon_sym_if] = ACTIONS(7516),
    [anon_sym_for] = ACTIONS(7516),
    [anon_sym_while] = ACTIONS(7516),
    [anon_sym_repeat] = ACTIONS(7516),
    [anon_sym_QMARK] = ACTIONS(7514),
    [anon_sym_TILDE] = ACTIONS(7514),
    [anon_sym_BANG] = ACTIONS(7516),
    [anon_sym_PLUS] = ACTIONS(7514),
    [anon_sym_DASH] = ACTIONS(7516),
    [anon_sym_LT_DASH] = ACTIONS(7514),
    [anon_sym_LT_LT_DASH] = ACTIONS(7514),
    [anon_sym_COLON_EQ] = ACTIONS(7514),
    [anon_sym_DASH_GT] = ACTIONS(7516),
    [anon_sym_DASH_GT_GT] = ACTIONS(7514),
    [anon_sym_PIPE] = ACTIONS(7516),
    [anon_sym_AMP] = ACTIONS(7516),
    [anon_sym_PIPE_PIPE] = ACTIONS(7514),
    [anon_sym_AMP_AMP] = ACTIONS(7514),
    [anon_sym_LT] = ACTIONS(7516),
    [anon_sym_LT_EQ] = ACTIONS(7514),
    [anon_sym_GT] = ACTIONS(7516),
    [anon_sym_GT_EQ] = ACTIONS(7514),
    [anon_sym_EQ_EQ] = ACTIONS(7514),
    [anon_sym_BANG_EQ] = ACTIONS(7514),
    [anon_sym_STAR] = ACTIONS(7516),
    [anon_sym_SLASH] = ACTIONS(7514),
    [anon_sym_STAR_STAR] = ACTIONS(7514),
    [anon_sym_CARET] = ACTIONS(7514),
    [aux_sym_binary_operator_token1] = ACTIONS(7514),
    [anon_sym_PIPE_GT] = ACTIONS(7514),
    [anon_sym_COLON] = ACTIONS(7516),
    [anon_sym_DOLLAR] = ACTIONS(7514),
    [anon_sym_AT] = ACTIONS(7514),
    [aux_sym__hex_literal_token1] = ACTIONS(7514),
    [sym__number_literal] = ACTIONS(7516),
    [anon_sym_SQUOTE] = ACTIONS(7514),
    [anon_sym_DQUOTE] = ACTIONS(7514),
    [sym_return] = ACTIONS(7516),
    [sym_next] = ACTIONS(7516),
    [sym_break] = ACTIONS(7516),
    [sym_true] = ACTIONS(7516),
    [sym_false] = ACTIONS(7516),
    [sym_null] = ACTIONS(7516),
    [sym_inf] = ACTIONS(7516),
    [sym_nan] = ACTIONS(7516),
    [anon_sym_NA] = ACTIONS(7516),
    [anon_sym_NA_integer_] = ACTIONS(7516),
    [anon_sym_NA_real_] = ACTIONS(7516),
    [anon_sym_NA_complex_] = ACTIONS(7516),
    [anon_sym_NA_character_] = ACTIONS(7516),
    [sym_dots] = ACTIONS(7516),
    [sym_dot_dot_i] = ACTIONS(7514),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7514),
    [sym__newline] = ACTIONS(7514),
    [sym__semicolon] = ACTIONS(7514),
    [sym__raw_string_literal] = ACTIONS(7514),
    [sym__external_open_parenthesis] = ACTIONS(7514),
    [sym__external_close_parenthesis] = ACTIONS(7514),
    [sym__external_open_brace] = ACTIONS(7514),
    [sym__external_close_brace] = ACTIONS(7514),
    [sym__external_open_bracket] = ACTIONS(7514),
    [sym__external_close_bracket] = ACTIONS(7514),
    [sym__external_open_bracket2] = ACTIONS(7514),
  },
  [2428] = {
    [ts_builtin_sym_end] = ACTIONS(7193),
    [sym_identifier] = ACTIONS(7195),
    [anon_sym_BSLASH] = ACTIONS(7193),
    [anon_sym_function] = ACTIONS(7195),
    [anon_sym_EQ] = ACTIONS(7195),
    [anon_sym_if] = ACTIONS(7195),
    [anon_sym_for] = ACTIONS(7195),
    [anon_sym_while] = ACTIONS(7195),
    [anon_sym_repeat] = ACTIONS(7195),
    [anon_sym_QMARK] = ACTIONS(7193),
    [anon_sym_TILDE] = ACTIONS(7193),
    [anon_sym_BANG] = ACTIONS(7195),
    [anon_sym_PLUS] = ACTIONS(7193),
    [anon_sym_DASH] = ACTIONS(7195),
    [anon_sym_LT_DASH] = ACTIONS(7193),
    [anon_sym_LT_LT_DASH] = ACTIONS(7193),
    [anon_sym_COLON_EQ] = ACTIONS(7193),
    [anon_sym_DASH_GT] = ACTIONS(7195),
    [anon_sym_DASH_GT_GT] = ACTIONS(7193),
    [anon_sym_PIPE] = ACTIONS(7195),
    [anon_sym_AMP] = ACTIONS(7195),
    [anon_sym_PIPE_PIPE] = ACTIONS(7193),
    [anon_sym_AMP_AMP] = ACTIONS(7193),
    [anon_sym_LT] = ACTIONS(7195),
    [anon_sym_LT_EQ] = ACTIONS(7193),
    [anon_sym_GT] = ACTIONS(7195),
    [anon_sym_GT_EQ] = ACTIONS(7193),
    [anon_sym_EQ_EQ] = ACTIONS(7193),
    [anon_sym_BANG_EQ] = ACTIONS(7193),
    [anon_sym_STAR] = ACTIONS(7195),
    [anon_sym_SLASH] = ACTIONS(7193),
    [anon_sym_STAR_STAR] = ACTIONS(7193),
    [anon_sym_CARET] = ACTIONS(7193),
    [aux_sym_binary_operator_token1] = ACTIONS(7193),
    [anon_sym_PIPE_GT] = ACTIONS(7193),
    [anon_sym_COLON] = ACTIONS(7195),
    [anon_sym_DOLLAR] = ACTIONS(7193),
    [anon_sym_AT] = ACTIONS(7193),
    [anon_sym_COLON_COLON] = ACTIONS(7195),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7193),
    [aux_sym__hex_literal_token1] = ACTIONS(7193),
    [sym__number_literal] = ACTIONS(7195),
    [anon_sym_SQUOTE] = ACTIONS(7193),
    [anon_sym_DQUOTE] = ACTIONS(7193),
    [sym_return] = ACTIONS(7195),
    [sym_next] = ACTIONS(7195),
    [sym_break] = ACTIONS(7195),
    [sym_true] = ACTIONS(7195),
    [sym_false] = ACTIONS(7195),
    [sym_null] = ACTIONS(7195),
    [sym_inf] = ACTIONS(7195),
    [sym_nan] = ACTIONS(7195),
    [anon_sym_NA] = ACTIONS(7195),
    [anon_sym_NA_integer_] = ACTIONS(7195),
    [anon_sym_NA_real_] = ACTIONS(7195),
    [anon_sym_NA_complex_] = ACTIONS(7195),
    [anon_sym_NA_character_] = ACTIONS(7195),
    [sym_dots] = ACTIONS(7195),
    [sym_dot_dot_i] = ACTIONS(7193),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7193),
    [sym__semicolon] = ACTIONS(7193),
    [sym__raw_string_literal] = ACTIONS(7193),
    [sym__external_open_parenthesis] = ACTIONS(7193),
    [sym__external_open_brace] = ACTIONS(7193),
    [sym__external_close_brace] = ACTIONS(7193),
    [sym__external_open_bracket] = ACTIONS(7193),
    [sym__external_open_bracket2] = ACTIONS(7193),
  },
  [2429] = {
    [ts_builtin_sym_end] = ACTIONS(7189),
    [sym_identifier] = ACTIONS(7191),
    [anon_sym_BSLASH] = ACTIONS(7189),
    [anon_sym_function] = ACTIONS(7191),
    [anon_sym_EQ] = ACTIONS(7191),
    [anon_sym_if] = ACTIONS(7191),
    [anon_sym_for] = ACTIONS(7191),
    [anon_sym_while] = ACTIONS(7191),
    [anon_sym_repeat] = ACTIONS(7191),
    [anon_sym_QMARK] = ACTIONS(7189),
    [anon_sym_TILDE] = ACTIONS(7189),
    [anon_sym_BANG] = ACTIONS(7191),
    [anon_sym_PLUS] = ACTIONS(7189),
    [anon_sym_DASH] = ACTIONS(7191),
    [anon_sym_LT_DASH] = ACTIONS(7189),
    [anon_sym_LT_LT_DASH] = ACTIONS(7189),
    [anon_sym_COLON_EQ] = ACTIONS(7189),
    [anon_sym_DASH_GT] = ACTIONS(7191),
    [anon_sym_DASH_GT_GT] = ACTIONS(7189),
    [anon_sym_PIPE] = ACTIONS(7191),
    [anon_sym_AMP] = ACTIONS(7191),
    [anon_sym_PIPE_PIPE] = ACTIONS(7189),
    [anon_sym_AMP_AMP] = ACTIONS(7189),
    [anon_sym_LT] = ACTIONS(7191),
    [anon_sym_LT_EQ] = ACTIONS(7189),
    [anon_sym_GT] = ACTIONS(7191),
    [anon_sym_GT_EQ] = ACTIONS(7189),
    [anon_sym_EQ_EQ] = ACTIONS(7189),
    [anon_sym_BANG_EQ] = ACTIONS(7189),
    [anon_sym_STAR] = ACTIONS(7191),
    [anon_sym_SLASH] = ACTIONS(7189),
    [anon_sym_STAR_STAR] = ACTIONS(7189),
    [anon_sym_CARET] = ACTIONS(7189),
    [aux_sym_binary_operator_token1] = ACTIONS(7189),
    [anon_sym_PIPE_GT] = ACTIONS(7189),
    [anon_sym_COLON] = ACTIONS(7191),
    [anon_sym_DOLLAR] = ACTIONS(7189),
    [anon_sym_AT] = ACTIONS(7189),
    [anon_sym_COLON_COLON] = ACTIONS(7191),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7189),
    [aux_sym__hex_literal_token1] = ACTIONS(7189),
    [sym__number_literal] = ACTIONS(7191),
    [anon_sym_SQUOTE] = ACTIONS(7189),
    [anon_sym_DQUOTE] = ACTIONS(7189),
    [sym_return] = ACTIONS(7191),
    [sym_next] = ACTIONS(7191),
    [sym_break] = ACTIONS(7191),
    [sym_true] = ACTIONS(7191),
    [sym_false] = ACTIONS(7191),
    [sym_null] = ACTIONS(7191),
    [sym_inf] = ACTIONS(7191),
    [sym_nan] = ACTIONS(7191),
    [anon_sym_NA] = ACTIONS(7191),
    [anon_sym_NA_integer_] = ACTIONS(7191),
    [anon_sym_NA_real_] = ACTIONS(7191),
    [anon_sym_NA_complex_] = ACTIONS(7191),
    [anon_sym_NA_character_] = ACTIONS(7191),
    [sym_dots] = ACTIONS(7191),
    [sym_dot_dot_i] = ACTIONS(7189),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7189),
    [sym__semicolon] = ACTIONS(7189),
    [sym__raw_string_literal] = ACTIONS(7189),
    [sym__external_open_parenthesis] = ACTIONS(7189),
    [sym__external_open_brace] = ACTIONS(7189),
    [sym__external_close_brace] = ACTIONS(7189),
    [sym__external_open_bracket] = ACTIONS(7189),
    [sym__external_open_bracket2] = ACTIONS(7189),
  },
  [2430] = {
    [sym_identifier] = ACTIONS(7115),
    [anon_sym_BSLASH] = ACTIONS(7117),
    [anon_sym_function] = ACTIONS(7115),
    [anon_sym_EQ] = ACTIONS(7115),
    [anon_sym_if] = ACTIONS(7115),
    [anon_sym_for] = ACTIONS(7115),
    [anon_sym_while] = ACTIONS(7115),
    [anon_sym_repeat] = ACTIONS(7115),
    [anon_sym_QMARK] = ACTIONS(7117),
    [anon_sym_TILDE] = ACTIONS(7117),
    [anon_sym_BANG] = ACTIONS(7115),
    [anon_sym_PLUS] = ACTIONS(7117),
    [anon_sym_DASH] = ACTIONS(7115),
    [anon_sym_LT_DASH] = ACTIONS(7117),
    [anon_sym_LT_LT_DASH] = ACTIONS(7117),
    [anon_sym_COLON_EQ] = ACTIONS(7117),
    [anon_sym_DASH_GT] = ACTIONS(7115),
    [anon_sym_DASH_GT_GT] = ACTIONS(7117),
    [anon_sym_PIPE] = ACTIONS(7115),
    [anon_sym_AMP] = ACTIONS(7115),
    [anon_sym_PIPE_PIPE] = ACTIONS(7117),
    [anon_sym_AMP_AMP] = ACTIONS(7117),
    [anon_sym_LT] = ACTIONS(7115),
    [anon_sym_LT_EQ] = ACTIONS(7117),
    [anon_sym_GT] = ACTIONS(7115),
    [anon_sym_GT_EQ] = ACTIONS(7117),
    [anon_sym_EQ_EQ] = ACTIONS(7117),
    [anon_sym_BANG_EQ] = ACTIONS(7117),
    [anon_sym_STAR] = ACTIONS(7115),
    [anon_sym_SLASH] = ACTIONS(7117),
    [anon_sym_STAR_STAR] = ACTIONS(7117),
    [anon_sym_CARET] = ACTIONS(7117),
    [aux_sym_binary_operator_token1] = ACTIONS(7117),
    [anon_sym_PIPE_GT] = ACTIONS(7117),
    [anon_sym_COLON] = ACTIONS(7115),
    [anon_sym_DOLLAR] = ACTIONS(7117),
    [anon_sym_AT] = ACTIONS(7117),
    [anon_sym_COLON_COLON] = ACTIONS(7115),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7117),
    [aux_sym__hex_literal_token1] = ACTIONS(7117),
    [sym__number_literal] = ACTIONS(7115),
    [anon_sym_SQUOTE] = ACTIONS(7117),
    [anon_sym_DQUOTE] = ACTIONS(7117),
    [sym_return] = ACTIONS(7115),
    [sym_next] = ACTIONS(7115),
    [sym_break] = ACTIONS(7115),
    [sym_true] = ACTIONS(7115),
    [sym_false] = ACTIONS(7115),
    [sym_null] = ACTIONS(7115),
    [sym_inf] = ACTIONS(7115),
    [sym_nan] = ACTIONS(7115),
    [anon_sym_NA] = ACTIONS(7115),
    [anon_sym_NA_integer_] = ACTIONS(7115),
    [anon_sym_NA_real_] = ACTIONS(7115),
    [anon_sym_NA_complex_] = ACTIONS(7115),
    [anon_sym_NA_character_] = ACTIONS(7115),
    [sym_dots] = ACTIONS(7115),
    [sym_dot_dot_i] = ACTIONS(7117),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7117),
    [sym__newline] = ACTIONS(7117),
    [sym__raw_string_literal] = ACTIONS(7117),
    [sym__external_open_parenthesis] = ACTIONS(7117),
    [sym__external_close_parenthesis] = ACTIONS(7117),
    [sym__external_open_brace] = ACTIONS(7117),
    [sym__external_open_bracket] = ACTIONS(7117),
    [sym__external_open_bracket2] = ACTIONS(7117),
    [sym__external_close_bracket2] = ACTIONS(7117),
  },
  [2431] = {
    [sym_identifier] = ACTIONS(7567),
    [anon_sym_BSLASH] = ACTIONS(7565),
    [anon_sym_function] = ACTIONS(7567),
    [anon_sym_EQ] = ACTIONS(7567),
    [anon_sym_if] = ACTIONS(7567),
    [anon_sym_for] = ACTIONS(7567),
    [anon_sym_while] = ACTIONS(7567),
    [anon_sym_repeat] = ACTIONS(7567),
    [anon_sym_QMARK] = ACTIONS(7565),
    [anon_sym_TILDE] = ACTIONS(7565),
    [anon_sym_BANG] = ACTIONS(7567),
    [anon_sym_PLUS] = ACTIONS(7565),
    [anon_sym_DASH] = ACTIONS(7567),
    [anon_sym_LT_DASH] = ACTIONS(7565),
    [anon_sym_LT_LT_DASH] = ACTIONS(7565),
    [anon_sym_COLON_EQ] = ACTIONS(7565),
    [anon_sym_DASH_GT] = ACTIONS(7567),
    [anon_sym_DASH_GT_GT] = ACTIONS(7565),
    [anon_sym_PIPE] = ACTIONS(7567),
    [anon_sym_AMP] = ACTIONS(7567),
    [anon_sym_PIPE_PIPE] = ACTIONS(7565),
    [anon_sym_AMP_AMP] = ACTIONS(7565),
    [anon_sym_LT] = ACTIONS(7567),
    [anon_sym_LT_EQ] = ACTIONS(7565),
    [anon_sym_GT] = ACTIONS(7567),
    [anon_sym_GT_EQ] = ACTIONS(7565),
    [anon_sym_EQ_EQ] = ACTIONS(7565),
    [anon_sym_BANG_EQ] = ACTIONS(7565),
    [anon_sym_STAR] = ACTIONS(7567),
    [anon_sym_SLASH] = ACTIONS(7565),
    [anon_sym_STAR_STAR] = ACTIONS(7565),
    [anon_sym_CARET] = ACTIONS(7565),
    [aux_sym_binary_operator_token1] = ACTIONS(7565),
    [anon_sym_PIPE_GT] = ACTIONS(7565),
    [anon_sym_COLON] = ACTIONS(7567),
    [anon_sym_DOLLAR] = ACTIONS(7565),
    [anon_sym_AT] = ACTIONS(7565),
    [aux_sym__hex_literal_token1] = ACTIONS(7565),
    [sym__number_literal] = ACTIONS(7567),
    [anon_sym_SQUOTE] = ACTIONS(7565),
    [anon_sym_DQUOTE] = ACTIONS(7565),
    [sym_return] = ACTIONS(7567),
    [sym_next] = ACTIONS(7567),
    [sym_break] = ACTIONS(7567),
    [sym_true] = ACTIONS(7567),
    [sym_false] = ACTIONS(7567),
    [sym_null] = ACTIONS(7567),
    [sym_inf] = ACTIONS(7567),
    [sym_nan] = ACTIONS(7567),
    [anon_sym_NA] = ACTIONS(7567),
    [anon_sym_NA_integer_] = ACTIONS(7567),
    [anon_sym_NA_real_] = ACTIONS(7567),
    [anon_sym_NA_complex_] = ACTIONS(7567),
    [anon_sym_NA_character_] = ACTIONS(7567),
    [sym_dots] = ACTIONS(7567),
    [sym_dot_dot_i] = ACTIONS(7565),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7565),
    [sym__newline] = ACTIONS(7565),
    [sym__semicolon] = ACTIONS(7565),
    [sym__raw_string_literal] = ACTIONS(7565),
    [sym__external_open_parenthesis] = ACTIONS(7565),
    [sym__external_close_parenthesis] = ACTIONS(7565),
    [sym__external_open_brace] = ACTIONS(7565),
    [sym__external_close_brace] = ACTIONS(7565),
    [sym__external_open_bracket] = ACTIONS(7565),
    [sym__external_open_bracket2] = ACTIONS(7565),
    [sym__external_close_bracket2] = ACTIONS(7565),
  },
  [2432] = {
    [sym_identifier] = ACTIONS(7552),
    [anon_sym_BSLASH] = ACTIONS(7550),
    [anon_sym_function] = ACTIONS(7552),
    [anon_sym_EQ] = ACTIONS(7552),
    [anon_sym_if] = ACTIONS(7552),
    [anon_sym_for] = ACTIONS(7552),
    [anon_sym_while] = ACTIONS(7552),
    [anon_sym_repeat] = ACTIONS(7552),
    [anon_sym_QMARK] = ACTIONS(7550),
    [anon_sym_TILDE] = ACTIONS(7550),
    [anon_sym_BANG] = ACTIONS(7552),
    [anon_sym_PLUS] = ACTIONS(7550),
    [anon_sym_DASH] = ACTIONS(7552),
    [anon_sym_LT_DASH] = ACTIONS(7550),
    [anon_sym_LT_LT_DASH] = ACTIONS(7550),
    [anon_sym_COLON_EQ] = ACTIONS(7550),
    [anon_sym_DASH_GT] = ACTIONS(7552),
    [anon_sym_DASH_GT_GT] = ACTIONS(7550),
    [anon_sym_PIPE] = ACTIONS(7552),
    [anon_sym_AMP] = ACTIONS(7552),
    [anon_sym_PIPE_PIPE] = ACTIONS(7550),
    [anon_sym_AMP_AMP] = ACTIONS(7550),
    [anon_sym_LT] = ACTIONS(7552),
    [anon_sym_LT_EQ] = ACTIONS(7550),
    [anon_sym_GT] = ACTIONS(7552),
    [anon_sym_GT_EQ] = ACTIONS(7550),
    [anon_sym_EQ_EQ] = ACTIONS(7550),
    [anon_sym_BANG_EQ] = ACTIONS(7550),
    [anon_sym_STAR] = ACTIONS(7552),
    [anon_sym_SLASH] = ACTIONS(7550),
    [anon_sym_STAR_STAR] = ACTIONS(7550),
    [anon_sym_CARET] = ACTIONS(7550),
    [aux_sym_binary_operator_token1] = ACTIONS(7550),
    [anon_sym_PIPE_GT] = ACTIONS(7550),
    [anon_sym_COLON] = ACTIONS(7552),
    [anon_sym_DOLLAR] = ACTIONS(7550),
    [anon_sym_AT] = ACTIONS(7550),
    [aux_sym__hex_literal_token1] = ACTIONS(7550),
    [sym__number_literal] = ACTIONS(7552),
    [anon_sym_SQUOTE] = ACTIONS(7550),
    [anon_sym_DQUOTE] = ACTIONS(7550),
    [sym_return] = ACTIONS(7552),
    [sym_next] = ACTIONS(7552),
    [sym_break] = ACTIONS(7552),
    [sym_true] = ACTIONS(7552),
    [sym_false] = ACTIONS(7552),
    [sym_null] = ACTIONS(7552),
    [sym_inf] = ACTIONS(7552),
    [sym_nan] = ACTIONS(7552),
    [anon_sym_NA] = ACTIONS(7552),
    [anon_sym_NA_integer_] = ACTIONS(7552),
    [anon_sym_NA_real_] = ACTIONS(7552),
    [anon_sym_NA_complex_] = ACTIONS(7552),
    [anon_sym_NA_character_] = ACTIONS(7552),
    [sym_dots] = ACTIONS(7552),
    [sym_dot_dot_i] = ACTIONS(7550),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7550),
    [sym__newline] = ACTIONS(7550),
    [sym__semicolon] = ACTIONS(7550),
    [sym__raw_string_literal] = ACTIONS(7550),
    [sym__external_else] = ACTIONS(7550),
    [sym__external_open_parenthesis] = ACTIONS(7550),
    [sym__external_open_brace] = ACTIONS(7550),
    [sym__external_close_brace] = ACTIONS(7550),
    [sym__external_open_bracket] = ACTIONS(7550),
    [sym__external_close_bracket] = ACTIONS(7550),
    [sym__external_open_bracket2] = ACTIONS(7550),
  },
  [2433] = {
    [sym_identifier] = ACTIONS(7163),
    [anon_sym_BSLASH] = ACTIONS(7165),
    [anon_sym_function] = ACTIONS(7163),
    [anon_sym_EQ] = ACTIONS(7163),
    [anon_sym_if] = ACTIONS(7163),
    [anon_sym_for] = ACTIONS(7163),
    [anon_sym_while] = ACTIONS(7163),
    [anon_sym_repeat] = ACTIONS(7163),
    [anon_sym_QMARK] = ACTIONS(7165),
    [anon_sym_TILDE] = ACTIONS(7165),
    [anon_sym_BANG] = ACTIONS(7163),
    [anon_sym_PLUS] = ACTIONS(7165),
    [anon_sym_DASH] = ACTIONS(7163),
    [anon_sym_LT_DASH] = ACTIONS(7165),
    [anon_sym_LT_LT_DASH] = ACTIONS(7165),
    [anon_sym_COLON_EQ] = ACTIONS(7165),
    [anon_sym_DASH_GT] = ACTIONS(7163),
    [anon_sym_DASH_GT_GT] = ACTIONS(7165),
    [anon_sym_PIPE] = ACTIONS(7163),
    [anon_sym_AMP] = ACTIONS(7163),
    [anon_sym_PIPE_PIPE] = ACTIONS(7165),
    [anon_sym_AMP_AMP] = ACTIONS(7165),
    [anon_sym_LT] = ACTIONS(7163),
    [anon_sym_LT_EQ] = ACTIONS(7165),
    [anon_sym_GT] = ACTIONS(7163),
    [anon_sym_GT_EQ] = ACTIONS(7165),
    [anon_sym_EQ_EQ] = ACTIONS(7165),
    [anon_sym_BANG_EQ] = ACTIONS(7165),
    [anon_sym_STAR] = ACTIONS(7163),
    [anon_sym_SLASH] = ACTIONS(7165),
    [anon_sym_STAR_STAR] = ACTIONS(7165),
    [anon_sym_CARET] = ACTIONS(7165),
    [aux_sym_binary_operator_token1] = ACTIONS(7165),
    [anon_sym_PIPE_GT] = ACTIONS(7165),
    [anon_sym_COLON] = ACTIONS(7163),
    [anon_sym_DOLLAR] = ACTIONS(7165),
    [anon_sym_AT] = ACTIONS(7165),
    [anon_sym_COLON_COLON] = ACTIONS(7163),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7165),
    [aux_sym__hex_literal_token1] = ACTIONS(7165),
    [sym__number_literal] = ACTIONS(7163),
    [anon_sym_SQUOTE] = ACTIONS(7165),
    [anon_sym_DQUOTE] = ACTIONS(7165),
    [sym_return] = ACTIONS(7163),
    [sym_next] = ACTIONS(7163),
    [sym_break] = ACTIONS(7163),
    [sym_true] = ACTIONS(7163),
    [sym_false] = ACTIONS(7163),
    [sym_null] = ACTIONS(7163),
    [sym_inf] = ACTIONS(7163),
    [sym_nan] = ACTIONS(7163),
    [anon_sym_NA] = ACTIONS(7163),
    [anon_sym_NA_integer_] = ACTIONS(7163),
    [anon_sym_NA_real_] = ACTIONS(7163),
    [anon_sym_NA_complex_] = ACTIONS(7163),
    [anon_sym_NA_character_] = ACTIONS(7163),
    [sym_dots] = ACTIONS(7163),
    [sym_dot_dot_i] = ACTIONS(7165),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7165),
    [sym__newline] = ACTIONS(7165),
    [sym__raw_string_literal] = ACTIONS(7165),
    [sym__external_open_parenthesis] = ACTIONS(7165),
    [sym__external_close_parenthesis] = ACTIONS(7165),
    [sym__external_open_brace] = ACTIONS(7165),
    [sym__external_open_bracket] = ACTIONS(7165),
    [sym__external_close_bracket] = ACTIONS(7165),
    [sym__external_open_bracket2] = ACTIONS(7165),
  },
  [2434] = {
    [sym_identifier] = ACTIONS(7151),
    [anon_sym_BSLASH] = ACTIONS(7153),
    [anon_sym_function] = ACTIONS(7151),
    [anon_sym_EQ] = ACTIONS(7151),
    [anon_sym_if] = ACTIONS(7151),
    [anon_sym_for] = ACTIONS(7151),
    [anon_sym_while] = ACTIONS(7151),
    [anon_sym_repeat] = ACTIONS(7151),
    [anon_sym_QMARK] = ACTIONS(7153),
    [anon_sym_TILDE] = ACTIONS(7153),
    [anon_sym_BANG] = ACTIONS(7151),
    [anon_sym_PLUS] = ACTIONS(7153),
    [anon_sym_DASH] = ACTIONS(7151),
    [anon_sym_LT_DASH] = ACTIONS(7153),
    [anon_sym_LT_LT_DASH] = ACTIONS(7153),
    [anon_sym_COLON_EQ] = ACTIONS(7153),
    [anon_sym_DASH_GT] = ACTIONS(7151),
    [anon_sym_DASH_GT_GT] = ACTIONS(7153),
    [anon_sym_PIPE] = ACTIONS(7151),
    [anon_sym_AMP] = ACTIONS(7151),
    [anon_sym_PIPE_PIPE] = ACTIONS(7153),
    [anon_sym_AMP_AMP] = ACTIONS(7153),
    [anon_sym_LT] = ACTIONS(7151),
    [anon_sym_LT_EQ] = ACTIONS(7153),
    [anon_sym_GT] = ACTIONS(7151),
    [anon_sym_GT_EQ] = ACTIONS(7153),
    [anon_sym_EQ_EQ] = ACTIONS(7153),
    [anon_sym_BANG_EQ] = ACTIONS(7153),
    [anon_sym_STAR] = ACTIONS(7151),
    [anon_sym_SLASH] = ACTIONS(7153),
    [anon_sym_STAR_STAR] = ACTIONS(7153),
    [anon_sym_CARET] = ACTIONS(7153),
    [aux_sym_binary_operator_token1] = ACTIONS(7153),
    [anon_sym_PIPE_GT] = ACTIONS(7153),
    [anon_sym_COLON] = ACTIONS(7151),
    [anon_sym_DOLLAR] = ACTIONS(7153),
    [anon_sym_AT] = ACTIONS(7153),
    [anon_sym_COLON_COLON] = ACTIONS(7151),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7153),
    [aux_sym__hex_literal_token1] = ACTIONS(7153),
    [sym__number_literal] = ACTIONS(7151),
    [anon_sym_SQUOTE] = ACTIONS(7153),
    [anon_sym_DQUOTE] = ACTIONS(7153),
    [sym_return] = ACTIONS(7151),
    [sym_next] = ACTIONS(7151),
    [sym_break] = ACTIONS(7151),
    [sym_true] = ACTIONS(7151),
    [sym_false] = ACTIONS(7151),
    [sym_null] = ACTIONS(7151),
    [sym_inf] = ACTIONS(7151),
    [sym_nan] = ACTIONS(7151),
    [anon_sym_NA] = ACTIONS(7151),
    [anon_sym_NA_integer_] = ACTIONS(7151),
    [anon_sym_NA_real_] = ACTIONS(7151),
    [anon_sym_NA_complex_] = ACTIONS(7151),
    [anon_sym_NA_character_] = ACTIONS(7151),
    [sym_dots] = ACTIONS(7151),
    [sym_dot_dot_i] = ACTIONS(7153),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7153),
    [sym__newline] = ACTIONS(7153),
    [sym__raw_string_literal] = ACTIONS(7153),
    [sym__external_open_parenthesis] = ACTIONS(7153),
    [sym__external_close_parenthesis] = ACTIONS(7153),
    [sym__external_open_brace] = ACTIONS(7153),
    [sym__external_open_bracket] = ACTIONS(7153),
    [sym__external_close_bracket] = ACTIONS(7153),
    [sym__external_open_bracket2] = ACTIONS(7153),
  },
  [2435] = {
    [sym_identifier] = ACTIONS(7544),
    [anon_sym_BSLASH] = ACTIONS(7542),
    [anon_sym_function] = ACTIONS(7544),
    [anon_sym_EQ] = ACTIONS(7544),
    [anon_sym_if] = ACTIONS(7544),
    [anon_sym_for] = ACTIONS(7544),
    [anon_sym_while] = ACTIONS(7544),
    [anon_sym_repeat] = ACTIONS(7544),
    [anon_sym_QMARK] = ACTIONS(7542),
    [anon_sym_TILDE] = ACTIONS(7542),
    [anon_sym_BANG] = ACTIONS(7544),
    [anon_sym_PLUS] = ACTIONS(7542),
    [anon_sym_DASH] = ACTIONS(7544),
    [anon_sym_LT_DASH] = ACTIONS(7542),
    [anon_sym_LT_LT_DASH] = ACTIONS(7542),
    [anon_sym_COLON_EQ] = ACTIONS(7542),
    [anon_sym_DASH_GT] = ACTIONS(7544),
    [anon_sym_DASH_GT_GT] = ACTIONS(7542),
    [anon_sym_PIPE] = ACTIONS(7544),
    [anon_sym_AMP] = ACTIONS(7544),
    [anon_sym_PIPE_PIPE] = ACTIONS(7542),
    [anon_sym_AMP_AMP] = ACTIONS(7542),
    [anon_sym_LT] = ACTIONS(7544),
    [anon_sym_LT_EQ] = ACTIONS(7542),
    [anon_sym_GT] = ACTIONS(7544),
    [anon_sym_GT_EQ] = ACTIONS(7542),
    [anon_sym_EQ_EQ] = ACTIONS(7542),
    [anon_sym_BANG_EQ] = ACTIONS(7542),
    [anon_sym_STAR] = ACTIONS(7544),
    [anon_sym_SLASH] = ACTIONS(7542),
    [anon_sym_STAR_STAR] = ACTIONS(7542),
    [anon_sym_CARET] = ACTIONS(7542),
    [aux_sym_binary_operator_token1] = ACTIONS(7542),
    [anon_sym_PIPE_GT] = ACTIONS(7542),
    [anon_sym_COLON] = ACTIONS(7544),
    [anon_sym_DOLLAR] = ACTIONS(7542),
    [anon_sym_AT] = ACTIONS(7542),
    [aux_sym__hex_literal_token1] = ACTIONS(7542),
    [sym__number_literal] = ACTIONS(7544),
    [anon_sym_SQUOTE] = ACTIONS(7542),
    [anon_sym_DQUOTE] = ACTIONS(7542),
    [sym_return] = ACTIONS(7544),
    [sym_next] = ACTIONS(7544),
    [sym_break] = ACTIONS(7544),
    [sym_true] = ACTIONS(7544),
    [sym_false] = ACTIONS(7544),
    [sym_null] = ACTIONS(7544),
    [sym_inf] = ACTIONS(7544),
    [sym_nan] = ACTIONS(7544),
    [anon_sym_NA] = ACTIONS(7544),
    [anon_sym_NA_integer_] = ACTIONS(7544),
    [anon_sym_NA_real_] = ACTIONS(7544),
    [anon_sym_NA_complex_] = ACTIONS(7544),
    [anon_sym_NA_character_] = ACTIONS(7544),
    [sym_dots] = ACTIONS(7544),
    [sym_dot_dot_i] = ACTIONS(7542),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7542),
    [sym__newline] = ACTIONS(7542),
    [sym__semicolon] = ACTIONS(7542),
    [sym__raw_string_literal] = ACTIONS(7542),
    [sym__external_else] = ACTIONS(7542),
    [sym__external_open_parenthesis] = ACTIONS(7542),
    [sym__external_open_brace] = ACTIONS(7542),
    [sym__external_close_brace] = ACTIONS(7542),
    [sym__external_open_bracket] = ACTIONS(7542),
    [sym__external_close_bracket] = ACTIONS(7542),
    [sym__external_open_bracket2] = ACTIONS(7542),
  },
  [2436] = {
    [sym_identifier] = ACTIONS(7540),
    [anon_sym_BSLASH] = ACTIONS(7538),
    [anon_sym_function] = ACTIONS(7540),
    [anon_sym_EQ] = ACTIONS(7540),
    [anon_sym_if] = ACTIONS(7540),
    [anon_sym_for] = ACTIONS(7540),
    [anon_sym_while] = ACTIONS(7540),
    [anon_sym_repeat] = ACTIONS(7540),
    [anon_sym_QMARK] = ACTIONS(7538),
    [anon_sym_TILDE] = ACTIONS(7538),
    [anon_sym_BANG] = ACTIONS(7540),
    [anon_sym_PLUS] = ACTIONS(7538),
    [anon_sym_DASH] = ACTIONS(7540),
    [anon_sym_LT_DASH] = ACTIONS(7538),
    [anon_sym_LT_LT_DASH] = ACTIONS(7538),
    [anon_sym_COLON_EQ] = ACTIONS(7538),
    [anon_sym_DASH_GT] = ACTIONS(7540),
    [anon_sym_DASH_GT_GT] = ACTIONS(7538),
    [anon_sym_PIPE] = ACTIONS(7540),
    [anon_sym_AMP] = ACTIONS(7540),
    [anon_sym_PIPE_PIPE] = ACTIONS(7538),
    [anon_sym_AMP_AMP] = ACTIONS(7538),
    [anon_sym_LT] = ACTIONS(7540),
    [anon_sym_LT_EQ] = ACTIONS(7538),
    [anon_sym_GT] = ACTIONS(7540),
    [anon_sym_GT_EQ] = ACTIONS(7538),
    [anon_sym_EQ_EQ] = ACTIONS(7538),
    [anon_sym_BANG_EQ] = ACTIONS(7538),
    [anon_sym_STAR] = ACTIONS(7540),
    [anon_sym_SLASH] = ACTIONS(7538),
    [anon_sym_STAR_STAR] = ACTIONS(7538),
    [anon_sym_CARET] = ACTIONS(7538),
    [aux_sym_binary_operator_token1] = ACTIONS(7538),
    [anon_sym_PIPE_GT] = ACTIONS(7538),
    [anon_sym_COLON] = ACTIONS(7540),
    [anon_sym_DOLLAR] = ACTIONS(7538),
    [anon_sym_AT] = ACTIONS(7538),
    [aux_sym__hex_literal_token1] = ACTIONS(7538),
    [sym__number_literal] = ACTIONS(7540),
    [anon_sym_SQUOTE] = ACTIONS(7538),
    [anon_sym_DQUOTE] = ACTIONS(7538),
    [sym_return] = ACTIONS(7540),
    [sym_next] = ACTIONS(7540),
    [sym_break] = ACTIONS(7540),
    [sym_true] = ACTIONS(7540),
    [sym_false] = ACTIONS(7540),
    [sym_null] = ACTIONS(7540),
    [sym_inf] = ACTIONS(7540),
    [sym_nan] = ACTIONS(7540),
    [anon_sym_NA] = ACTIONS(7540),
    [anon_sym_NA_integer_] = ACTIONS(7540),
    [anon_sym_NA_real_] = ACTIONS(7540),
    [anon_sym_NA_complex_] = ACTIONS(7540),
    [anon_sym_NA_character_] = ACTIONS(7540),
    [sym_dots] = ACTIONS(7540),
    [sym_dot_dot_i] = ACTIONS(7538),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7538),
    [sym__newline] = ACTIONS(7538),
    [sym__semicolon] = ACTIONS(7538),
    [sym__raw_string_literal] = ACTIONS(7538),
    [sym__external_else] = ACTIONS(7538),
    [sym__external_open_parenthesis] = ACTIONS(7538),
    [sym__external_open_brace] = ACTIONS(7538),
    [sym__external_close_brace] = ACTIONS(7538),
    [sym__external_open_bracket] = ACTIONS(7538),
    [sym__external_close_bracket] = ACTIONS(7538),
    [sym__external_open_bracket2] = ACTIONS(7538),
  },
  [2437] = {
    [sym_identifier] = ACTIONS(7115),
    [anon_sym_BSLASH] = ACTIONS(7117),
    [anon_sym_function] = ACTIONS(7115),
    [anon_sym_EQ] = ACTIONS(7115),
    [anon_sym_if] = ACTIONS(7115),
    [anon_sym_for] = ACTIONS(7115),
    [anon_sym_while] = ACTIONS(7115),
    [anon_sym_repeat] = ACTIONS(7115),
    [anon_sym_QMARK] = ACTIONS(7117),
    [anon_sym_TILDE] = ACTIONS(7117),
    [anon_sym_BANG] = ACTIONS(7115),
    [anon_sym_PLUS] = ACTIONS(7117),
    [anon_sym_DASH] = ACTIONS(7115),
    [anon_sym_LT_DASH] = ACTIONS(7117),
    [anon_sym_LT_LT_DASH] = ACTIONS(7117),
    [anon_sym_COLON_EQ] = ACTIONS(7117),
    [anon_sym_DASH_GT] = ACTIONS(7115),
    [anon_sym_DASH_GT_GT] = ACTIONS(7117),
    [anon_sym_PIPE] = ACTIONS(7115),
    [anon_sym_AMP] = ACTIONS(7115),
    [anon_sym_PIPE_PIPE] = ACTIONS(7117),
    [anon_sym_AMP_AMP] = ACTIONS(7117),
    [anon_sym_LT] = ACTIONS(7115),
    [anon_sym_LT_EQ] = ACTIONS(7117),
    [anon_sym_GT] = ACTIONS(7115),
    [anon_sym_GT_EQ] = ACTIONS(7117),
    [anon_sym_EQ_EQ] = ACTIONS(7117),
    [anon_sym_BANG_EQ] = ACTIONS(7117),
    [anon_sym_STAR] = ACTIONS(7115),
    [anon_sym_SLASH] = ACTIONS(7117),
    [anon_sym_STAR_STAR] = ACTIONS(7117),
    [anon_sym_CARET] = ACTIONS(7117),
    [aux_sym_binary_operator_token1] = ACTIONS(7117),
    [anon_sym_PIPE_GT] = ACTIONS(7117),
    [anon_sym_COLON] = ACTIONS(7115),
    [anon_sym_DOLLAR] = ACTIONS(7117),
    [anon_sym_AT] = ACTIONS(7117),
    [anon_sym_COLON_COLON] = ACTIONS(7115),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7117),
    [aux_sym__hex_literal_token1] = ACTIONS(7117),
    [sym__number_literal] = ACTIONS(7115),
    [anon_sym_SQUOTE] = ACTIONS(7117),
    [anon_sym_DQUOTE] = ACTIONS(7117),
    [sym_return] = ACTIONS(7115),
    [sym_next] = ACTIONS(7115),
    [sym_break] = ACTIONS(7115),
    [sym_true] = ACTIONS(7115),
    [sym_false] = ACTIONS(7115),
    [sym_null] = ACTIONS(7115),
    [sym_inf] = ACTIONS(7115),
    [sym_nan] = ACTIONS(7115),
    [anon_sym_NA] = ACTIONS(7115),
    [anon_sym_NA_integer_] = ACTIONS(7115),
    [anon_sym_NA_real_] = ACTIONS(7115),
    [anon_sym_NA_complex_] = ACTIONS(7115),
    [anon_sym_NA_character_] = ACTIONS(7115),
    [sym_dots] = ACTIONS(7115),
    [sym_dot_dot_i] = ACTIONS(7117),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7117),
    [sym__newline] = ACTIONS(7117),
    [sym__raw_string_literal] = ACTIONS(7117),
    [sym__external_open_parenthesis] = ACTIONS(7117),
    [sym__external_close_parenthesis] = ACTIONS(7117),
    [sym__external_open_brace] = ACTIONS(7117),
    [sym__external_open_bracket] = ACTIONS(7117),
    [sym__external_close_bracket] = ACTIONS(7117),
    [sym__external_open_bracket2] = ACTIONS(7117),
  },
  [2438] = {
    [sym_identifier] = ACTIONS(7532),
    [anon_sym_BSLASH] = ACTIONS(7530),
    [anon_sym_function] = ACTIONS(7532),
    [anon_sym_EQ] = ACTIONS(7532),
    [anon_sym_if] = ACTIONS(7532),
    [anon_sym_for] = ACTIONS(7532),
    [anon_sym_while] = ACTIONS(7532),
    [anon_sym_repeat] = ACTIONS(7532),
    [anon_sym_QMARK] = ACTIONS(7530),
    [anon_sym_TILDE] = ACTIONS(7530),
    [anon_sym_BANG] = ACTIONS(7532),
    [anon_sym_PLUS] = ACTIONS(7530),
    [anon_sym_DASH] = ACTIONS(7532),
    [anon_sym_LT_DASH] = ACTIONS(7530),
    [anon_sym_LT_LT_DASH] = ACTIONS(7530),
    [anon_sym_COLON_EQ] = ACTIONS(7530),
    [anon_sym_DASH_GT] = ACTIONS(7532),
    [anon_sym_DASH_GT_GT] = ACTIONS(7530),
    [anon_sym_PIPE] = ACTIONS(7532),
    [anon_sym_AMP] = ACTIONS(7532),
    [anon_sym_PIPE_PIPE] = ACTIONS(7530),
    [anon_sym_AMP_AMP] = ACTIONS(7530),
    [anon_sym_LT] = ACTIONS(7532),
    [anon_sym_LT_EQ] = ACTIONS(7530),
    [anon_sym_GT] = ACTIONS(7532),
    [anon_sym_GT_EQ] = ACTIONS(7530),
    [anon_sym_EQ_EQ] = ACTIONS(7530),
    [anon_sym_BANG_EQ] = ACTIONS(7530),
    [anon_sym_STAR] = ACTIONS(7532),
    [anon_sym_SLASH] = ACTIONS(7530),
    [anon_sym_STAR_STAR] = ACTIONS(7530),
    [anon_sym_CARET] = ACTIONS(7530),
    [aux_sym_binary_operator_token1] = ACTIONS(7530),
    [anon_sym_PIPE_GT] = ACTIONS(7530),
    [anon_sym_COLON] = ACTIONS(7532),
    [anon_sym_DOLLAR] = ACTIONS(7530),
    [anon_sym_AT] = ACTIONS(7530),
    [aux_sym__hex_literal_token1] = ACTIONS(7530),
    [sym__number_literal] = ACTIONS(7532),
    [anon_sym_SQUOTE] = ACTIONS(7530),
    [anon_sym_DQUOTE] = ACTIONS(7530),
    [sym_return] = ACTIONS(7532),
    [sym_next] = ACTIONS(7532),
    [sym_break] = ACTIONS(7532),
    [sym_true] = ACTIONS(7532),
    [sym_false] = ACTIONS(7532),
    [sym_null] = ACTIONS(7532),
    [sym_inf] = ACTIONS(7532),
    [sym_nan] = ACTIONS(7532),
    [anon_sym_NA] = ACTIONS(7532),
    [anon_sym_NA_integer_] = ACTIONS(7532),
    [anon_sym_NA_real_] = ACTIONS(7532),
    [anon_sym_NA_complex_] = ACTIONS(7532),
    [anon_sym_NA_character_] = ACTIONS(7532),
    [sym_dots] = ACTIONS(7532),
    [sym_dot_dot_i] = ACTIONS(7530),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7530),
    [sym__newline] = ACTIONS(7530),
    [sym__semicolon] = ACTIONS(7530),
    [sym__raw_string_literal] = ACTIONS(7530),
    [sym__external_else] = ACTIONS(7530),
    [sym__external_open_parenthesis] = ACTIONS(7530),
    [sym__external_open_brace] = ACTIONS(7530),
    [sym__external_close_brace] = ACTIONS(7530),
    [sym__external_open_bracket] = ACTIONS(7530),
    [sym__external_close_bracket] = ACTIONS(7530),
    [sym__external_open_bracket2] = ACTIONS(7530),
  },
  [2439] = {
    [sym_identifier] = ACTIONS(7528),
    [anon_sym_BSLASH] = ACTIONS(7526),
    [anon_sym_function] = ACTIONS(7528),
    [anon_sym_EQ] = ACTIONS(7528),
    [anon_sym_if] = ACTIONS(7528),
    [anon_sym_for] = ACTIONS(7528),
    [anon_sym_while] = ACTIONS(7528),
    [anon_sym_repeat] = ACTIONS(7528),
    [anon_sym_QMARK] = ACTIONS(7526),
    [anon_sym_TILDE] = ACTIONS(7526),
    [anon_sym_BANG] = ACTIONS(7528),
    [anon_sym_PLUS] = ACTIONS(7526),
    [anon_sym_DASH] = ACTIONS(7528),
    [anon_sym_LT_DASH] = ACTIONS(7526),
    [anon_sym_LT_LT_DASH] = ACTIONS(7526),
    [anon_sym_COLON_EQ] = ACTIONS(7526),
    [anon_sym_DASH_GT] = ACTIONS(7528),
    [anon_sym_DASH_GT_GT] = ACTIONS(7526),
    [anon_sym_PIPE] = ACTIONS(7528),
    [anon_sym_AMP] = ACTIONS(7528),
    [anon_sym_PIPE_PIPE] = ACTIONS(7526),
    [anon_sym_AMP_AMP] = ACTIONS(7526),
    [anon_sym_LT] = ACTIONS(7528),
    [anon_sym_LT_EQ] = ACTIONS(7526),
    [anon_sym_GT] = ACTIONS(7528),
    [anon_sym_GT_EQ] = ACTIONS(7526),
    [anon_sym_EQ_EQ] = ACTIONS(7526),
    [anon_sym_BANG_EQ] = ACTIONS(7526),
    [anon_sym_STAR] = ACTIONS(7528),
    [anon_sym_SLASH] = ACTIONS(7526),
    [anon_sym_STAR_STAR] = ACTIONS(7526),
    [anon_sym_CARET] = ACTIONS(7526),
    [aux_sym_binary_operator_token1] = ACTIONS(7526),
    [anon_sym_PIPE_GT] = ACTIONS(7526),
    [anon_sym_COLON] = ACTIONS(7528),
    [anon_sym_DOLLAR] = ACTIONS(7526),
    [anon_sym_AT] = ACTIONS(7526),
    [aux_sym__hex_literal_token1] = ACTIONS(7526),
    [sym__number_literal] = ACTIONS(7528),
    [anon_sym_SQUOTE] = ACTIONS(7526),
    [anon_sym_DQUOTE] = ACTIONS(7526),
    [sym_return] = ACTIONS(7528),
    [sym_next] = ACTIONS(7528),
    [sym_break] = ACTIONS(7528),
    [sym_true] = ACTIONS(7528),
    [sym_false] = ACTIONS(7528),
    [sym_null] = ACTIONS(7528),
    [sym_inf] = ACTIONS(7528),
    [sym_nan] = ACTIONS(7528),
    [anon_sym_NA] = ACTIONS(7528),
    [anon_sym_NA_integer_] = ACTIONS(7528),
    [anon_sym_NA_real_] = ACTIONS(7528),
    [anon_sym_NA_complex_] = ACTIONS(7528),
    [anon_sym_NA_character_] = ACTIONS(7528),
    [sym_dots] = ACTIONS(7528),
    [sym_dot_dot_i] = ACTIONS(7526),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7526),
    [sym__newline] = ACTIONS(7526),
    [sym__semicolon] = ACTIONS(7526),
    [sym__raw_string_literal] = ACTIONS(7526),
    [sym__external_else] = ACTIONS(7526),
    [sym__external_open_parenthesis] = ACTIONS(7526),
    [sym__external_open_brace] = ACTIONS(7526),
    [sym__external_close_brace] = ACTIONS(7526),
    [sym__external_open_bracket] = ACTIONS(7526),
    [sym__external_close_bracket] = ACTIONS(7526),
    [sym__external_open_bracket2] = ACTIONS(7526),
  },
  [2440] = {
    [sym_identifier] = ACTIONS(7524),
    [anon_sym_BSLASH] = ACTIONS(7522),
    [anon_sym_function] = ACTIONS(7524),
    [anon_sym_EQ] = ACTIONS(7524),
    [anon_sym_if] = ACTIONS(7524),
    [anon_sym_for] = ACTIONS(7524),
    [anon_sym_while] = ACTIONS(7524),
    [anon_sym_repeat] = ACTIONS(7524),
    [anon_sym_QMARK] = ACTIONS(7522),
    [anon_sym_TILDE] = ACTIONS(7522),
    [anon_sym_BANG] = ACTIONS(7524),
    [anon_sym_PLUS] = ACTIONS(7522),
    [anon_sym_DASH] = ACTIONS(7524),
    [anon_sym_LT_DASH] = ACTIONS(7522),
    [anon_sym_LT_LT_DASH] = ACTIONS(7522),
    [anon_sym_COLON_EQ] = ACTIONS(7522),
    [anon_sym_DASH_GT] = ACTIONS(7524),
    [anon_sym_DASH_GT_GT] = ACTIONS(7522),
    [anon_sym_PIPE] = ACTIONS(7524),
    [anon_sym_AMP] = ACTIONS(7524),
    [anon_sym_PIPE_PIPE] = ACTIONS(7522),
    [anon_sym_AMP_AMP] = ACTIONS(7522),
    [anon_sym_LT] = ACTIONS(7524),
    [anon_sym_LT_EQ] = ACTIONS(7522),
    [anon_sym_GT] = ACTIONS(7524),
    [anon_sym_GT_EQ] = ACTIONS(7522),
    [anon_sym_EQ_EQ] = ACTIONS(7522),
    [anon_sym_BANG_EQ] = ACTIONS(7522),
    [anon_sym_STAR] = ACTIONS(7524),
    [anon_sym_SLASH] = ACTIONS(7522),
    [anon_sym_STAR_STAR] = ACTIONS(7522),
    [anon_sym_CARET] = ACTIONS(7522),
    [aux_sym_binary_operator_token1] = ACTIONS(7522),
    [anon_sym_PIPE_GT] = ACTIONS(7522),
    [anon_sym_COLON] = ACTIONS(7524),
    [anon_sym_DOLLAR] = ACTIONS(7522),
    [anon_sym_AT] = ACTIONS(7522),
    [aux_sym__hex_literal_token1] = ACTIONS(7522),
    [sym__number_literal] = ACTIONS(7524),
    [anon_sym_SQUOTE] = ACTIONS(7522),
    [anon_sym_DQUOTE] = ACTIONS(7522),
    [sym_return] = ACTIONS(7524),
    [sym_next] = ACTIONS(7524),
    [sym_break] = ACTIONS(7524),
    [sym_true] = ACTIONS(7524),
    [sym_false] = ACTIONS(7524),
    [sym_null] = ACTIONS(7524),
    [sym_inf] = ACTIONS(7524),
    [sym_nan] = ACTIONS(7524),
    [anon_sym_NA] = ACTIONS(7524),
    [anon_sym_NA_integer_] = ACTIONS(7524),
    [anon_sym_NA_real_] = ACTIONS(7524),
    [anon_sym_NA_complex_] = ACTIONS(7524),
    [anon_sym_NA_character_] = ACTIONS(7524),
    [sym_dots] = ACTIONS(7524),
    [sym_dot_dot_i] = ACTIONS(7522),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7522),
    [sym__newline] = ACTIONS(7522),
    [sym__semicolon] = ACTIONS(7522),
    [sym__raw_string_literal] = ACTIONS(7522),
    [sym__external_else] = ACTIONS(7522),
    [sym__external_open_parenthesis] = ACTIONS(7522),
    [sym__external_open_brace] = ACTIONS(7522),
    [sym__external_close_brace] = ACTIONS(7522),
    [sym__external_open_bracket] = ACTIONS(7522),
    [sym__external_close_bracket] = ACTIONS(7522),
    [sym__external_open_bracket2] = ACTIONS(7522),
  },
  [2441] = {
    [sym_identifier] = ACTIONS(7129),
    [anon_sym_BSLASH] = ACTIONS(7131),
    [anon_sym_function] = ACTIONS(7129),
    [anon_sym_EQ] = ACTIONS(7129),
    [anon_sym_if] = ACTIONS(7129),
    [anon_sym_for] = ACTIONS(7129),
    [anon_sym_while] = ACTIONS(7129),
    [anon_sym_repeat] = ACTIONS(7129),
    [anon_sym_QMARK] = ACTIONS(7131),
    [anon_sym_TILDE] = ACTIONS(7131),
    [anon_sym_BANG] = ACTIONS(7129),
    [anon_sym_PLUS] = ACTIONS(7131),
    [anon_sym_DASH] = ACTIONS(7129),
    [anon_sym_LT_DASH] = ACTIONS(7131),
    [anon_sym_LT_LT_DASH] = ACTIONS(7131),
    [anon_sym_COLON_EQ] = ACTIONS(7131),
    [anon_sym_DASH_GT] = ACTIONS(7129),
    [anon_sym_DASH_GT_GT] = ACTIONS(7131),
    [anon_sym_PIPE] = ACTIONS(7129),
    [anon_sym_AMP] = ACTIONS(7129),
    [anon_sym_PIPE_PIPE] = ACTIONS(7131),
    [anon_sym_AMP_AMP] = ACTIONS(7131),
    [anon_sym_LT] = ACTIONS(7129),
    [anon_sym_LT_EQ] = ACTIONS(7131),
    [anon_sym_GT] = ACTIONS(7129),
    [anon_sym_GT_EQ] = ACTIONS(7131),
    [anon_sym_EQ_EQ] = ACTIONS(7131),
    [anon_sym_BANG_EQ] = ACTIONS(7131),
    [anon_sym_STAR] = ACTIONS(7129),
    [anon_sym_SLASH] = ACTIONS(7131),
    [anon_sym_STAR_STAR] = ACTIONS(7131),
    [anon_sym_CARET] = ACTIONS(7131),
    [aux_sym_binary_operator_token1] = ACTIONS(7131),
    [anon_sym_PIPE_GT] = ACTIONS(7131),
    [anon_sym_COLON] = ACTIONS(7129),
    [anon_sym_DOLLAR] = ACTIONS(7131),
    [anon_sym_AT] = ACTIONS(7131),
    [anon_sym_COLON_COLON] = ACTIONS(7133),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7135),
    [aux_sym__hex_literal_token1] = ACTIONS(7131),
    [sym__number_literal] = ACTIONS(7129),
    [anon_sym_SQUOTE] = ACTIONS(7131),
    [anon_sym_DQUOTE] = ACTIONS(7131),
    [sym_return] = ACTIONS(7129),
    [sym_next] = ACTIONS(7129),
    [sym_break] = ACTIONS(7129),
    [sym_true] = ACTIONS(7129),
    [sym_false] = ACTIONS(7129),
    [sym_null] = ACTIONS(7129),
    [sym_inf] = ACTIONS(7129),
    [sym_nan] = ACTIONS(7129),
    [anon_sym_NA] = ACTIONS(7129),
    [anon_sym_NA_integer_] = ACTIONS(7129),
    [anon_sym_NA_real_] = ACTIONS(7129),
    [anon_sym_NA_complex_] = ACTIONS(7129),
    [anon_sym_NA_character_] = ACTIONS(7129),
    [sym_dots] = ACTIONS(7129),
    [sym_dot_dot_i] = ACTIONS(7131),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7131),
    [sym__newline] = ACTIONS(7131),
    [sym__raw_string_literal] = ACTIONS(7131),
    [sym__external_else] = ACTIONS(7131),
    [sym__external_open_parenthesis] = ACTIONS(7131),
    [sym__external_open_brace] = ACTIONS(7131),
    [sym__external_open_bracket] = ACTIONS(7131),
    [sym__external_close_bracket] = ACTIONS(7131),
    [sym__external_open_bracket2] = ACTIONS(7131),
  },
  [2442] = {
    [sym_identifier] = ACTIONS(7115),
    [anon_sym_BSLASH] = ACTIONS(7117),
    [anon_sym_function] = ACTIONS(7115),
    [anon_sym_EQ] = ACTIONS(7115),
    [anon_sym_if] = ACTIONS(7115),
    [anon_sym_for] = ACTIONS(7115),
    [anon_sym_while] = ACTIONS(7115),
    [anon_sym_repeat] = ACTIONS(7115),
    [anon_sym_QMARK] = ACTIONS(7117),
    [anon_sym_TILDE] = ACTIONS(7117),
    [anon_sym_BANG] = ACTIONS(7115),
    [anon_sym_PLUS] = ACTIONS(7117),
    [anon_sym_DASH] = ACTIONS(7115),
    [anon_sym_LT_DASH] = ACTIONS(7117),
    [anon_sym_LT_LT_DASH] = ACTIONS(7117),
    [anon_sym_COLON_EQ] = ACTIONS(7117),
    [anon_sym_DASH_GT] = ACTIONS(7115),
    [anon_sym_DASH_GT_GT] = ACTIONS(7117),
    [anon_sym_PIPE] = ACTIONS(7115),
    [anon_sym_AMP] = ACTIONS(7115),
    [anon_sym_PIPE_PIPE] = ACTIONS(7117),
    [anon_sym_AMP_AMP] = ACTIONS(7117),
    [anon_sym_LT] = ACTIONS(7115),
    [anon_sym_LT_EQ] = ACTIONS(7117),
    [anon_sym_GT] = ACTIONS(7115),
    [anon_sym_GT_EQ] = ACTIONS(7117),
    [anon_sym_EQ_EQ] = ACTIONS(7117),
    [anon_sym_BANG_EQ] = ACTIONS(7117),
    [anon_sym_STAR] = ACTIONS(7115),
    [anon_sym_SLASH] = ACTIONS(7117),
    [anon_sym_STAR_STAR] = ACTIONS(7117),
    [anon_sym_CARET] = ACTIONS(7117),
    [aux_sym_binary_operator_token1] = ACTIONS(7117),
    [anon_sym_PIPE_GT] = ACTIONS(7117),
    [anon_sym_COLON] = ACTIONS(7115),
    [anon_sym_DOLLAR] = ACTIONS(7117),
    [anon_sym_AT] = ACTIONS(7117),
    [anon_sym_COLON_COLON] = ACTIONS(7115),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7117),
    [aux_sym__hex_literal_token1] = ACTIONS(7117),
    [sym__number_literal] = ACTIONS(7115),
    [anon_sym_SQUOTE] = ACTIONS(7117),
    [anon_sym_DQUOTE] = ACTIONS(7117),
    [sym_return] = ACTIONS(7115),
    [sym_next] = ACTIONS(7115),
    [sym_break] = ACTIONS(7115),
    [sym_true] = ACTIONS(7115),
    [sym_false] = ACTIONS(7115),
    [sym_null] = ACTIONS(7115),
    [sym_inf] = ACTIONS(7115),
    [sym_nan] = ACTIONS(7115),
    [anon_sym_NA] = ACTIONS(7115),
    [anon_sym_NA_integer_] = ACTIONS(7115),
    [anon_sym_NA_real_] = ACTIONS(7115),
    [anon_sym_NA_complex_] = ACTIONS(7115),
    [anon_sym_NA_character_] = ACTIONS(7115),
    [sym_dots] = ACTIONS(7115),
    [sym_dot_dot_i] = ACTIONS(7117),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7117),
    [sym__newline] = ACTIONS(7117),
    [sym__raw_string_literal] = ACTIONS(7117),
    [sym__external_open_parenthesis] = ACTIONS(7117),
    [sym__external_close_parenthesis] = ACTIONS(7117),
    [sym__external_open_brace] = ACTIONS(7117),
    [sym__external_open_bracket] = ACTIONS(7117),
    [sym__external_close_bracket] = ACTIONS(7117),
    [sym__external_open_bracket2] = ACTIONS(7117),
  },
  [2443] = {
    [sym_identifier] = ACTIONS(7520),
    [anon_sym_BSLASH] = ACTIONS(7518),
    [anon_sym_function] = ACTIONS(7520),
    [anon_sym_EQ] = ACTIONS(7520),
    [anon_sym_if] = ACTIONS(7520),
    [anon_sym_for] = ACTIONS(7520),
    [anon_sym_while] = ACTIONS(7520),
    [anon_sym_repeat] = ACTIONS(7520),
    [anon_sym_QMARK] = ACTIONS(7518),
    [anon_sym_TILDE] = ACTIONS(7518),
    [anon_sym_BANG] = ACTIONS(7520),
    [anon_sym_PLUS] = ACTIONS(7518),
    [anon_sym_DASH] = ACTIONS(7520),
    [anon_sym_LT_DASH] = ACTIONS(7518),
    [anon_sym_LT_LT_DASH] = ACTIONS(7518),
    [anon_sym_COLON_EQ] = ACTIONS(7518),
    [anon_sym_DASH_GT] = ACTIONS(7520),
    [anon_sym_DASH_GT_GT] = ACTIONS(7518),
    [anon_sym_PIPE] = ACTIONS(7520),
    [anon_sym_AMP] = ACTIONS(7520),
    [anon_sym_PIPE_PIPE] = ACTIONS(7518),
    [anon_sym_AMP_AMP] = ACTIONS(7518),
    [anon_sym_LT] = ACTIONS(7520),
    [anon_sym_LT_EQ] = ACTIONS(7518),
    [anon_sym_GT] = ACTIONS(7520),
    [anon_sym_GT_EQ] = ACTIONS(7518),
    [anon_sym_EQ_EQ] = ACTIONS(7518),
    [anon_sym_BANG_EQ] = ACTIONS(7518),
    [anon_sym_STAR] = ACTIONS(7520),
    [anon_sym_SLASH] = ACTIONS(7518),
    [anon_sym_STAR_STAR] = ACTIONS(7518),
    [anon_sym_CARET] = ACTIONS(7518),
    [aux_sym_binary_operator_token1] = ACTIONS(7518),
    [anon_sym_PIPE_GT] = ACTIONS(7518),
    [anon_sym_COLON] = ACTIONS(7520),
    [anon_sym_DOLLAR] = ACTIONS(7518),
    [anon_sym_AT] = ACTIONS(7518),
    [aux_sym__hex_literal_token1] = ACTIONS(7518),
    [sym__number_literal] = ACTIONS(7520),
    [anon_sym_SQUOTE] = ACTIONS(7518),
    [anon_sym_DQUOTE] = ACTIONS(7518),
    [sym_return] = ACTIONS(7520),
    [sym_next] = ACTIONS(7520),
    [sym_break] = ACTIONS(7520),
    [sym_true] = ACTIONS(7520),
    [sym_false] = ACTIONS(7520),
    [sym_null] = ACTIONS(7520),
    [sym_inf] = ACTIONS(7520),
    [sym_nan] = ACTIONS(7520),
    [anon_sym_NA] = ACTIONS(7520),
    [anon_sym_NA_integer_] = ACTIONS(7520),
    [anon_sym_NA_real_] = ACTIONS(7520),
    [anon_sym_NA_complex_] = ACTIONS(7520),
    [anon_sym_NA_character_] = ACTIONS(7520),
    [sym_dots] = ACTIONS(7520),
    [sym_dot_dot_i] = ACTIONS(7518),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7518),
    [sym__newline] = ACTIONS(7518),
    [sym__semicolon] = ACTIONS(7518),
    [sym__raw_string_literal] = ACTIONS(7518),
    [sym__external_else] = ACTIONS(7518),
    [sym__external_open_parenthesis] = ACTIONS(7518),
    [sym__external_open_brace] = ACTIONS(7518),
    [sym__external_close_brace] = ACTIONS(7518),
    [sym__external_open_bracket] = ACTIONS(7518),
    [sym__external_close_bracket] = ACTIONS(7518),
    [sym__external_open_bracket2] = ACTIONS(7518),
  },
  [2444] = {
    [sym_identifier] = ACTIONS(7516),
    [anon_sym_BSLASH] = ACTIONS(7514),
    [anon_sym_function] = ACTIONS(7516),
    [anon_sym_EQ] = ACTIONS(7516),
    [anon_sym_if] = ACTIONS(7516),
    [anon_sym_for] = ACTIONS(7516),
    [anon_sym_while] = ACTIONS(7516),
    [anon_sym_repeat] = ACTIONS(7516),
    [anon_sym_QMARK] = ACTIONS(7514),
    [anon_sym_TILDE] = ACTIONS(7514),
    [anon_sym_BANG] = ACTIONS(7516),
    [anon_sym_PLUS] = ACTIONS(7514),
    [anon_sym_DASH] = ACTIONS(7516),
    [anon_sym_LT_DASH] = ACTIONS(7514),
    [anon_sym_LT_LT_DASH] = ACTIONS(7514),
    [anon_sym_COLON_EQ] = ACTIONS(7514),
    [anon_sym_DASH_GT] = ACTIONS(7516),
    [anon_sym_DASH_GT_GT] = ACTIONS(7514),
    [anon_sym_PIPE] = ACTIONS(7516),
    [anon_sym_AMP] = ACTIONS(7516),
    [anon_sym_PIPE_PIPE] = ACTIONS(7514),
    [anon_sym_AMP_AMP] = ACTIONS(7514),
    [anon_sym_LT] = ACTIONS(7516),
    [anon_sym_LT_EQ] = ACTIONS(7514),
    [anon_sym_GT] = ACTIONS(7516),
    [anon_sym_GT_EQ] = ACTIONS(7514),
    [anon_sym_EQ_EQ] = ACTIONS(7514),
    [anon_sym_BANG_EQ] = ACTIONS(7514),
    [anon_sym_STAR] = ACTIONS(7516),
    [anon_sym_SLASH] = ACTIONS(7514),
    [anon_sym_STAR_STAR] = ACTIONS(7514),
    [anon_sym_CARET] = ACTIONS(7514),
    [aux_sym_binary_operator_token1] = ACTIONS(7514),
    [anon_sym_PIPE_GT] = ACTIONS(7514),
    [anon_sym_COLON] = ACTIONS(7516),
    [anon_sym_DOLLAR] = ACTIONS(7514),
    [anon_sym_AT] = ACTIONS(7514),
    [aux_sym__hex_literal_token1] = ACTIONS(7514),
    [sym__number_literal] = ACTIONS(7516),
    [anon_sym_SQUOTE] = ACTIONS(7514),
    [anon_sym_DQUOTE] = ACTIONS(7514),
    [sym_return] = ACTIONS(7516),
    [sym_next] = ACTIONS(7516),
    [sym_break] = ACTIONS(7516),
    [sym_true] = ACTIONS(7516),
    [sym_false] = ACTIONS(7516),
    [sym_null] = ACTIONS(7516),
    [sym_inf] = ACTIONS(7516),
    [sym_nan] = ACTIONS(7516),
    [anon_sym_NA] = ACTIONS(7516),
    [anon_sym_NA_integer_] = ACTIONS(7516),
    [anon_sym_NA_real_] = ACTIONS(7516),
    [anon_sym_NA_complex_] = ACTIONS(7516),
    [anon_sym_NA_character_] = ACTIONS(7516),
    [sym_dots] = ACTIONS(7516),
    [sym_dot_dot_i] = ACTIONS(7514),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7514),
    [sym__newline] = ACTIONS(7514),
    [sym__semicolon] = ACTIONS(7514),
    [sym__raw_string_literal] = ACTIONS(7514),
    [sym__external_else] = ACTIONS(7514),
    [sym__external_open_parenthesis] = ACTIONS(7514),
    [sym__external_open_brace] = ACTIONS(7514),
    [sym__external_close_brace] = ACTIONS(7514),
    [sym__external_open_bracket] = ACTIONS(7514),
    [sym__external_close_bracket] = ACTIONS(7514),
    [sym__external_open_bracket2] = ACTIONS(7514),
  },
  [2445] = {
    [sym_identifier] = ACTIONS(7121),
    [anon_sym_BSLASH] = ACTIONS(7123),
    [anon_sym_function] = ACTIONS(7121),
    [anon_sym_EQ] = ACTIONS(7121),
    [anon_sym_if] = ACTIONS(7121),
    [anon_sym_for] = ACTIONS(7121),
    [anon_sym_while] = ACTIONS(7121),
    [anon_sym_repeat] = ACTIONS(7121),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_TILDE] = ACTIONS(7123),
    [anon_sym_BANG] = ACTIONS(7121),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_DASH] = ACTIONS(7121),
    [anon_sym_LT_DASH] = ACTIONS(7123),
    [anon_sym_LT_LT_DASH] = ACTIONS(7123),
    [anon_sym_COLON_EQ] = ACTIONS(7123),
    [anon_sym_DASH_GT] = ACTIONS(7121),
    [anon_sym_DASH_GT_GT] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_LT_EQ] = ACTIONS(7123),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
    [aux_sym_binary_operator_token1] = ACTIONS(7123),
    [anon_sym_PIPE_GT] = ACTIONS(7123),
    [anon_sym_COLON] = ACTIONS(7121),
    [anon_sym_DOLLAR] = ACTIONS(7123),
    [anon_sym_AT] = ACTIONS(7123),
    [anon_sym_L] = ACTIONS(7620),
    [anon_sym_i] = ACTIONS(7622),
    [aux_sym__hex_literal_token1] = ACTIONS(7123),
    [sym__number_literal] = ACTIONS(7121),
    [anon_sym_SQUOTE] = ACTIONS(7123),
    [anon_sym_DQUOTE] = ACTIONS(7123),
    [sym_return] = ACTIONS(7121),
    [sym_next] = ACTIONS(7121),
    [sym_break] = ACTIONS(7121),
    [sym_true] = ACTIONS(7121),
    [sym_false] = ACTIONS(7121),
    [sym_null] = ACTIONS(7121),
    [sym_inf] = ACTIONS(7121),
    [sym_nan] = ACTIONS(7121),
    [anon_sym_NA] = ACTIONS(7121),
    [anon_sym_NA_integer_] = ACTIONS(7121),
    [anon_sym_NA_real_] = ACTIONS(7121),
    [anon_sym_NA_complex_] = ACTIONS(7121),
    [anon_sym_NA_character_] = ACTIONS(7121),
    [sym_dots] = ACTIONS(7121),
    [sym_dot_dot_i] = ACTIONS(7123),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7123),
    [sym__newline] = ACTIONS(7123),
    [sym__raw_string_literal] = ACTIONS(7123),
    [sym__external_open_parenthesis] = ACTIONS(7123),
    [sym__external_close_parenthesis] = ACTIONS(7123),
    [sym__external_open_brace] = ACTIONS(7123),
    [sym__external_open_bracket] = ACTIONS(7123),
    [sym__external_close_bracket] = ACTIONS(7123),
    [sym__external_open_bracket2] = ACTIONS(7123),
  },
  [2446] = {
    [sym_identifier] = ACTIONS(7567),
    [anon_sym_BSLASH] = ACTIONS(7565),
    [anon_sym_function] = ACTIONS(7567),
    [anon_sym_EQ] = ACTIONS(7567),
    [anon_sym_if] = ACTIONS(7567),
    [anon_sym_for] = ACTIONS(7567),
    [anon_sym_while] = ACTIONS(7567),
    [anon_sym_repeat] = ACTIONS(7567),
    [anon_sym_QMARK] = ACTIONS(7565),
    [anon_sym_TILDE] = ACTIONS(7565),
    [anon_sym_BANG] = ACTIONS(7567),
    [anon_sym_PLUS] = ACTIONS(7565),
    [anon_sym_DASH] = ACTIONS(7567),
    [anon_sym_LT_DASH] = ACTIONS(7565),
    [anon_sym_LT_LT_DASH] = ACTIONS(7565),
    [anon_sym_COLON_EQ] = ACTIONS(7565),
    [anon_sym_DASH_GT] = ACTIONS(7567),
    [anon_sym_DASH_GT_GT] = ACTIONS(7565),
    [anon_sym_PIPE] = ACTIONS(7567),
    [anon_sym_AMP] = ACTIONS(7567),
    [anon_sym_PIPE_PIPE] = ACTIONS(7565),
    [anon_sym_AMP_AMP] = ACTIONS(7565),
    [anon_sym_LT] = ACTIONS(7567),
    [anon_sym_LT_EQ] = ACTIONS(7565),
    [anon_sym_GT] = ACTIONS(7567),
    [anon_sym_GT_EQ] = ACTIONS(7565),
    [anon_sym_EQ_EQ] = ACTIONS(7565),
    [anon_sym_BANG_EQ] = ACTIONS(7565),
    [anon_sym_STAR] = ACTIONS(7567),
    [anon_sym_SLASH] = ACTIONS(7565),
    [anon_sym_STAR_STAR] = ACTIONS(7565),
    [anon_sym_CARET] = ACTIONS(7565),
    [aux_sym_binary_operator_token1] = ACTIONS(7565),
    [anon_sym_PIPE_GT] = ACTIONS(7565),
    [anon_sym_COLON] = ACTIONS(7567),
    [anon_sym_DOLLAR] = ACTIONS(7565),
    [anon_sym_AT] = ACTIONS(7565),
    [aux_sym__hex_literal_token1] = ACTIONS(7565),
    [sym__number_literal] = ACTIONS(7567),
    [anon_sym_SQUOTE] = ACTIONS(7565),
    [anon_sym_DQUOTE] = ACTIONS(7565),
    [sym_return] = ACTIONS(7567),
    [sym_next] = ACTIONS(7567),
    [sym_break] = ACTIONS(7567),
    [sym_true] = ACTIONS(7567),
    [sym_false] = ACTIONS(7567),
    [sym_null] = ACTIONS(7567),
    [sym_inf] = ACTIONS(7567),
    [sym_nan] = ACTIONS(7567),
    [anon_sym_NA] = ACTIONS(7567),
    [anon_sym_NA_integer_] = ACTIONS(7567),
    [anon_sym_NA_real_] = ACTIONS(7567),
    [anon_sym_NA_complex_] = ACTIONS(7567),
    [anon_sym_NA_character_] = ACTIONS(7567),
    [sym_dots] = ACTIONS(7567),
    [sym_dot_dot_i] = ACTIONS(7565),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7565),
    [sym__newline] = ACTIONS(7565),
    [sym__semicolon] = ACTIONS(7565),
    [sym__raw_string_literal] = ACTIONS(7565),
    [sym__external_else] = ACTIONS(7565),
    [sym__external_open_parenthesis] = ACTIONS(7565),
    [sym__external_open_brace] = ACTIONS(7565),
    [sym__external_close_brace] = ACTIONS(7565),
    [sym__external_open_bracket] = ACTIONS(7565),
    [sym__external_open_bracket2] = ACTIONS(7565),
    [sym__external_close_bracket2] = ACTIONS(7565),
  },
  [2447] = {
    [sym_identifier] = ACTIONS(7563),
    [anon_sym_BSLASH] = ACTIONS(7561),
    [anon_sym_function] = ACTIONS(7563),
    [anon_sym_EQ] = ACTIONS(7563),
    [anon_sym_if] = ACTIONS(7563),
    [anon_sym_for] = ACTIONS(7563),
    [anon_sym_while] = ACTIONS(7563),
    [anon_sym_repeat] = ACTIONS(7563),
    [anon_sym_QMARK] = ACTIONS(7561),
    [anon_sym_TILDE] = ACTIONS(7561),
    [anon_sym_BANG] = ACTIONS(7563),
    [anon_sym_PLUS] = ACTIONS(7561),
    [anon_sym_DASH] = ACTIONS(7563),
    [anon_sym_LT_DASH] = ACTIONS(7561),
    [anon_sym_LT_LT_DASH] = ACTIONS(7561),
    [anon_sym_COLON_EQ] = ACTIONS(7561),
    [anon_sym_DASH_GT] = ACTIONS(7563),
    [anon_sym_DASH_GT_GT] = ACTIONS(7561),
    [anon_sym_PIPE] = ACTIONS(7563),
    [anon_sym_AMP] = ACTIONS(7563),
    [anon_sym_PIPE_PIPE] = ACTIONS(7561),
    [anon_sym_AMP_AMP] = ACTIONS(7561),
    [anon_sym_LT] = ACTIONS(7563),
    [anon_sym_LT_EQ] = ACTIONS(7561),
    [anon_sym_GT] = ACTIONS(7563),
    [anon_sym_GT_EQ] = ACTIONS(7561),
    [anon_sym_EQ_EQ] = ACTIONS(7561),
    [anon_sym_BANG_EQ] = ACTIONS(7561),
    [anon_sym_STAR] = ACTIONS(7563),
    [anon_sym_SLASH] = ACTIONS(7561),
    [anon_sym_STAR_STAR] = ACTIONS(7561),
    [anon_sym_CARET] = ACTIONS(7561),
    [aux_sym_binary_operator_token1] = ACTIONS(7561),
    [anon_sym_PIPE_GT] = ACTIONS(7561),
    [anon_sym_COLON] = ACTIONS(7563),
    [anon_sym_DOLLAR] = ACTIONS(7561),
    [anon_sym_AT] = ACTIONS(7561),
    [aux_sym__hex_literal_token1] = ACTIONS(7561),
    [sym__number_literal] = ACTIONS(7563),
    [anon_sym_SQUOTE] = ACTIONS(7561),
    [anon_sym_DQUOTE] = ACTIONS(7561),
    [sym_return] = ACTIONS(7563),
    [sym_next] = ACTIONS(7563),
    [sym_break] = ACTIONS(7563),
    [sym_true] = ACTIONS(7563),
    [sym_false] = ACTIONS(7563),
    [sym_null] = ACTIONS(7563),
    [sym_inf] = ACTIONS(7563),
    [sym_nan] = ACTIONS(7563),
    [anon_sym_NA] = ACTIONS(7563),
    [anon_sym_NA_integer_] = ACTIONS(7563),
    [anon_sym_NA_real_] = ACTIONS(7563),
    [anon_sym_NA_complex_] = ACTIONS(7563),
    [anon_sym_NA_character_] = ACTIONS(7563),
    [sym_dots] = ACTIONS(7563),
    [sym_dot_dot_i] = ACTIONS(7561),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7561),
    [sym__newline] = ACTIONS(7561),
    [sym__semicolon] = ACTIONS(7561),
    [sym__raw_string_literal] = ACTIONS(7561),
    [sym__external_open_parenthesis] = ACTIONS(7561),
    [sym__external_close_parenthesis] = ACTIONS(7561),
    [sym__external_open_brace] = ACTIONS(7561),
    [sym__external_close_brace] = ACTIONS(7561),
    [sym__external_open_bracket] = ACTIONS(7561),
    [sym__external_open_bracket2] = ACTIONS(7561),
    [sym__external_close_bracket2] = ACTIONS(7561),
  },
  [2448] = {
    [sym_identifier] = ACTIONS(7121),
    [anon_sym_BSLASH] = ACTIONS(7123),
    [anon_sym_function] = ACTIONS(7121),
    [anon_sym_EQ] = ACTIONS(7121),
    [anon_sym_if] = ACTIONS(7121),
    [anon_sym_for] = ACTIONS(7121),
    [anon_sym_while] = ACTIONS(7121),
    [anon_sym_repeat] = ACTIONS(7121),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_TILDE] = ACTIONS(7123),
    [anon_sym_BANG] = ACTIONS(7121),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_DASH] = ACTIONS(7121),
    [anon_sym_LT_DASH] = ACTIONS(7123),
    [anon_sym_LT_LT_DASH] = ACTIONS(7123),
    [anon_sym_COLON_EQ] = ACTIONS(7123),
    [anon_sym_DASH_GT] = ACTIONS(7121),
    [anon_sym_DASH_GT_GT] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_LT_EQ] = ACTIONS(7123),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
    [aux_sym_binary_operator_token1] = ACTIONS(7123),
    [anon_sym_PIPE_GT] = ACTIONS(7123),
    [anon_sym_COLON] = ACTIONS(7121),
    [anon_sym_DOLLAR] = ACTIONS(7123),
    [anon_sym_AT] = ACTIONS(7123),
    [anon_sym_L] = ACTIONS(7624),
    [anon_sym_i] = ACTIONS(7626),
    [aux_sym__hex_literal_token1] = ACTIONS(7123),
    [sym__number_literal] = ACTIONS(7121),
    [anon_sym_SQUOTE] = ACTIONS(7123),
    [anon_sym_DQUOTE] = ACTIONS(7123),
    [sym_return] = ACTIONS(7121),
    [sym_next] = ACTIONS(7121),
    [sym_break] = ACTIONS(7121),
    [sym_true] = ACTIONS(7121),
    [sym_false] = ACTIONS(7121),
    [sym_null] = ACTIONS(7121),
    [sym_inf] = ACTIONS(7121),
    [sym_nan] = ACTIONS(7121),
    [anon_sym_NA] = ACTIONS(7121),
    [anon_sym_NA_integer_] = ACTIONS(7121),
    [anon_sym_NA_real_] = ACTIONS(7121),
    [anon_sym_NA_complex_] = ACTIONS(7121),
    [anon_sym_NA_character_] = ACTIONS(7121),
    [sym_dots] = ACTIONS(7121),
    [sym_dot_dot_i] = ACTIONS(7123),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7123),
    [sym__newline] = ACTIONS(7123),
    [sym__raw_string_literal] = ACTIONS(7123),
    [sym__external_else] = ACTIONS(7123),
    [sym__external_open_parenthesis] = ACTIONS(7123),
    [sym__external_open_brace] = ACTIONS(7123),
    [sym__external_open_bracket] = ACTIONS(7123),
    [sym__external_close_bracket] = ACTIONS(7123),
    [sym__external_open_bracket2] = ACTIONS(7123),
  },
  [2449] = {
    [sym_identifier] = ACTIONS(7137),
    [anon_sym_BSLASH] = ACTIONS(7139),
    [anon_sym_function] = ACTIONS(7137),
    [anon_sym_EQ] = ACTIONS(7137),
    [anon_sym_if] = ACTIONS(7137),
    [anon_sym_for] = ACTIONS(7137),
    [anon_sym_while] = ACTIONS(7137),
    [anon_sym_repeat] = ACTIONS(7137),
    [anon_sym_QMARK] = ACTIONS(7139),
    [anon_sym_TILDE] = ACTIONS(7139),
    [anon_sym_BANG] = ACTIONS(7137),
    [anon_sym_PLUS] = ACTIONS(7139),
    [anon_sym_DASH] = ACTIONS(7137),
    [anon_sym_LT_DASH] = ACTIONS(7139),
    [anon_sym_LT_LT_DASH] = ACTIONS(7139),
    [anon_sym_COLON_EQ] = ACTIONS(7139),
    [anon_sym_DASH_GT] = ACTIONS(7137),
    [anon_sym_DASH_GT_GT] = ACTIONS(7139),
    [anon_sym_PIPE] = ACTIONS(7137),
    [anon_sym_AMP] = ACTIONS(7137),
    [anon_sym_PIPE_PIPE] = ACTIONS(7139),
    [anon_sym_AMP_AMP] = ACTIONS(7139),
    [anon_sym_LT] = ACTIONS(7137),
    [anon_sym_LT_EQ] = ACTIONS(7139),
    [anon_sym_GT] = ACTIONS(7137),
    [anon_sym_GT_EQ] = ACTIONS(7139),
    [anon_sym_EQ_EQ] = ACTIONS(7139),
    [anon_sym_BANG_EQ] = ACTIONS(7139),
    [anon_sym_STAR] = ACTIONS(7137),
    [anon_sym_SLASH] = ACTIONS(7139),
    [anon_sym_STAR_STAR] = ACTIONS(7139),
    [anon_sym_CARET] = ACTIONS(7139),
    [aux_sym_binary_operator_token1] = ACTIONS(7139),
    [anon_sym_PIPE_GT] = ACTIONS(7139),
    [anon_sym_COLON] = ACTIONS(7137),
    [anon_sym_DOLLAR] = ACTIONS(7139),
    [anon_sym_AT] = ACTIONS(7139),
    [anon_sym_COLON_COLON] = ACTIONS(7137),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7139),
    [aux_sym__hex_literal_token1] = ACTIONS(7139),
    [sym__number_literal] = ACTIONS(7137),
    [anon_sym_SQUOTE] = ACTIONS(7139),
    [anon_sym_DQUOTE] = ACTIONS(7139),
    [sym_return] = ACTIONS(7137),
    [sym_next] = ACTIONS(7137),
    [sym_break] = ACTIONS(7137),
    [sym_true] = ACTIONS(7137),
    [sym_false] = ACTIONS(7137),
    [sym_null] = ACTIONS(7137),
    [sym_inf] = ACTIONS(7137),
    [sym_nan] = ACTIONS(7137),
    [anon_sym_NA] = ACTIONS(7137),
    [anon_sym_NA_integer_] = ACTIONS(7137),
    [anon_sym_NA_real_] = ACTIONS(7137),
    [anon_sym_NA_complex_] = ACTIONS(7137),
    [anon_sym_NA_character_] = ACTIONS(7137),
    [sym_dots] = ACTIONS(7137),
    [sym_dot_dot_i] = ACTIONS(7139),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7139),
    [sym__newline] = ACTIONS(7139),
    [sym__raw_string_literal] = ACTIONS(7139),
    [sym__external_open_parenthesis] = ACTIONS(7139),
    [sym__external_close_parenthesis] = ACTIONS(7139),
    [sym__external_open_brace] = ACTIONS(7139),
    [sym__external_open_bracket] = ACTIONS(7139),
    [sym__external_close_bracket] = ACTIONS(7139),
    [sym__external_open_bracket2] = ACTIONS(7139),
  },
  [2450] = {
    [sym_identifier] = ACTIONS(7556),
    [anon_sym_BSLASH] = ACTIONS(7554),
    [anon_sym_function] = ACTIONS(7556),
    [anon_sym_EQ] = ACTIONS(7556),
    [anon_sym_if] = ACTIONS(7556),
    [anon_sym_for] = ACTIONS(7556),
    [anon_sym_while] = ACTIONS(7556),
    [anon_sym_repeat] = ACTIONS(7556),
    [anon_sym_QMARK] = ACTIONS(7554),
    [anon_sym_TILDE] = ACTIONS(7554),
    [anon_sym_BANG] = ACTIONS(7556),
    [anon_sym_PLUS] = ACTIONS(7554),
    [anon_sym_DASH] = ACTIONS(7556),
    [anon_sym_LT_DASH] = ACTIONS(7554),
    [anon_sym_LT_LT_DASH] = ACTIONS(7554),
    [anon_sym_COLON_EQ] = ACTIONS(7554),
    [anon_sym_DASH_GT] = ACTIONS(7556),
    [anon_sym_DASH_GT_GT] = ACTIONS(7554),
    [anon_sym_PIPE] = ACTIONS(7556),
    [anon_sym_AMP] = ACTIONS(7556),
    [anon_sym_PIPE_PIPE] = ACTIONS(7554),
    [anon_sym_AMP_AMP] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(7556),
    [anon_sym_LT_EQ] = ACTIONS(7554),
    [anon_sym_GT] = ACTIONS(7556),
    [anon_sym_GT_EQ] = ACTIONS(7554),
    [anon_sym_EQ_EQ] = ACTIONS(7554),
    [anon_sym_BANG_EQ] = ACTIONS(7554),
    [anon_sym_STAR] = ACTIONS(7556),
    [anon_sym_SLASH] = ACTIONS(7554),
    [anon_sym_STAR_STAR] = ACTIONS(7554),
    [anon_sym_CARET] = ACTIONS(7554),
    [aux_sym_binary_operator_token1] = ACTIONS(7554),
    [anon_sym_PIPE_GT] = ACTIONS(7554),
    [anon_sym_COLON] = ACTIONS(7556),
    [anon_sym_DOLLAR] = ACTIONS(7554),
    [anon_sym_AT] = ACTIONS(7554),
    [aux_sym__hex_literal_token1] = ACTIONS(7554),
    [sym__number_literal] = ACTIONS(7556),
    [anon_sym_SQUOTE] = ACTIONS(7554),
    [anon_sym_DQUOTE] = ACTIONS(7554),
    [sym_return] = ACTIONS(7556),
    [sym_next] = ACTIONS(7556),
    [sym_break] = ACTIONS(7556),
    [sym_true] = ACTIONS(7556),
    [sym_false] = ACTIONS(7556),
    [sym_null] = ACTIONS(7556),
    [sym_inf] = ACTIONS(7556),
    [sym_nan] = ACTIONS(7556),
    [anon_sym_NA] = ACTIONS(7556),
    [anon_sym_NA_integer_] = ACTIONS(7556),
    [anon_sym_NA_real_] = ACTIONS(7556),
    [anon_sym_NA_complex_] = ACTIONS(7556),
    [anon_sym_NA_character_] = ACTIONS(7556),
    [sym_dots] = ACTIONS(7556),
    [sym_dot_dot_i] = ACTIONS(7554),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7554),
    [sym__newline] = ACTIONS(7554),
    [sym__semicolon] = ACTIONS(7554),
    [sym__raw_string_literal] = ACTIONS(7554),
    [sym__external_open_parenthesis] = ACTIONS(7554),
    [sym__external_close_parenthesis] = ACTIONS(7554),
    [sym__external_open_brace] = ACTIONS(7554),
    [sym__external_close_brace] = ACTIONS(7554),
    [sym__external_open_bracket] = ACTIONS(7554),
    [sym__external_close_bracket] = ACTIONS(7554),
    [sym__external_open_bracket2] = ACTIONS(7554),
  },
  [2451] = {
    [sym_identifier] = ACTIONS(7512),
    [anon_sym_BSLASH] = ACTIONS(7510),
    [anon_sym_function] = ACTIONS(7512),
    [anon_sym_EQ] = ACTIONS(7512),
    [anon_sym_if] = ACTIONS(7512),
    [anon_sym_for] = ACTIONS(7512),
    [anon_sym_while] = ACTIONS(7512),
    [anon_sym_repeat] = ACTIONS(7512),
    [anon_sym_QMARK] = ACTIONS(7510),
    [anon_sym_TILDE] = ACTIONS(7510),
    [anon_sym_BANG] = ACTIONS(7512),
    [anon_sym_PLUS] = ACTIONS(7510),
    [anon_sym_DASH] = ACTIONS(7512),
    [anon_sym_LT_DASH] = ACTIONS(7510),
    [anon_sym_LT_LT_DASH] = ACTIONS(7510),
    [anon_sym_COLON_EQ] = ACTIONS(7510),
    [anon_sym_DASH_GT] = ACTIONS(7512),
    [anon_sym_DASH_GT_GT] = ACTIONS(7510),
    [anon_sym_PIPE] = ACTIONS(7512),
    [anon_sym_AMP] = ACTIONS(7512),
    [anon_sym_PIPE_PIPE] = ACTIONS(7510),
    [anon_sym_AMP_AMP] = ACTIONS(7510),
    [anon_sym_LT] = ACTIONS(7512),
    [anon_sym_LT_EQ] = ACTIONS(7510),
    [anon_sym_GT] = ACTIONS(7512),
    [anon_sym_GT_EQ] = ACTIONS(7510),
    [anon_sym_EQ_EQ] = ACTIONS(7510),
    [anon_sym_BANG_EQ] = ACTIONS(7510),
    [anon_sym_STAR] = ACTIONS(7512),
    [anon_sym_SLASH] = ACTIONS(7510),
    [anon_sym_STAR_STAR] = ACTIONS(7510),
    [anon_sym_CARET] = ACTIONS(7510),
    [aux_sym_binary_operator_token1] = ACTIONS(7510),
    [anon_sym_PIPE_GT] = ACTIONS(7510),
    [anon_sym_COLON] = ACTIONS(7512),
    [anon_sym_DOLLAR] = ACTIONS(7510),
    [anon_sym_AT] = ACTIONS(7510),
    [aux_sym__hex_literal_token1] = ACTIONS(7510),
    [sym__number_literal] = ACTIONS(7512),
    [anon_sym_SQUOTE] = ACTIONS(7510),
    [anon_sym_DQUOTE] = ACTIONS(7510),
    [sym_return] = ACTIONS(7512),
    [sym_next] = ACTIONS(7512),
    [sym_break] = ACTIONS(7512),
    [sym_true] = ACTIONS(7512),
    [sym_false] = ACTIONS(7512),
    [sym_null] = ACTIONS(7512),
    [sym_inf] = ACTIONS(7512),
    [sym_nan] = ACTIONS(7512),
    [anon_sym_NA] = ACTIONS(7512),
    [anon_sym_NA_integer_] = ACTIONS(7512),
    [anon_sym_NA_real_] = ACTIONS(7512),
    [anon_sym_NA_complex_] = ACTIONS(7512),
    [anon_sym_NA_character_] = ACTIONS(7512),
    [sym_dots] = ACTIONS(7512),
    [sym_dot_dot_i] = ACTIONS(7510),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7510),
    [sym__newline] = ACTIONS(7510),
    [sym__semicolon] = ACTIONS(7510),
    [sym__raw_string_literal] = ACTIONS(7510),
    [sym__external_else] = ACTIONS(7510),
    [sym__external_open_parenthesis] = ACTIONS(7510),
    [sym__external_open_brace] = ACTIONS(7510),
    [sym__external_close_brace] = ACTIONS(7510),
    [sym__external_open_bracket] = ACTIONS(7510),
    [sym__external_close_bracket] = ACTIONS(7510),
    [sym__external_open_bracket2] = ACTIONS(7510),
  },
  [2452] = {
    [sym_identifier] = ACTIONS(7506),
    [anon_sym_BSLASH] = ACTIONS(7504),
    [anon_sym_function] = ACTIONS(7506),
    [anon_sym_EQ] = ACTIONS(7506),
    [anon_sym_if] = ACTIONS(7506),
    [anon_sym_for] = ACTIONS(7506),
    [anon_sym_while] = ACTIONS(7506),
    [anon_sym_repeat] = ACTIONS(7506),
    [anon_sym_QMARK] = ACTIONS(7504),
    [anon_sym_TILDE] = ACTIONS(7504),
    [anon_sym_BANG] = ACTIONS(7506),
    [anon_sym_PLUS] = ACTIONS(7504),
    [anon_sym_DASH] = ACTIONS(7506),
    [anon_sym_LT_DASH] = ACTIONS(7504),
    [anon_sym_LT_LT_DASH] = ACTIONS(7504),
    [anon_sym_COLON_EQ] = ACTIONS(7504),
    [anon_sym_DASH_GT] = ACTIONS(7506),
    [anon_sym_DASH_GT_GT] = ACTIONS(7504),
    [anon_sym_PIPE] = ACTIONS(7506),
    [anon_sym_AMP] = ACTIONS(7506),
    [anon_sym_PIPE_PIPE] = ACTIONS(7504),
    [anon_sym_AMP_AMP] = ACTIONS(7504),
    [anon_sym_LT] = ACTIONS(7506),
    [anon_sym_LT_EQ] = ACTIONS(7504),
    [anon_sym_GT] = ACTIONS(7506),
    [anon_sym_GT_EQ] = ACTIONS(7504),
    [anon_sym_EQ_EQ] = ACTIONS(7504),
    [anon_sym_BANG_EQ] = ACTIONS(7504),
    [anon_sym_STAR] = ACTIONS(7506),
    [anon_sym_SLASH] = ACTIONS(7504),
    [anon_sym_STAR_STAR] = ACTIONS(7504),
    [anon_sym_CARET] = ACTIONS(7504),
    [aux_sym_binary_operator_token1] = ACTIONS(7504),
    [anon_sym_PIPE_GT] = ACTIONS(7504),
    [anon_sym_COLON] = ACTIONS(7506),
    [anon_sym_DOLLAR] = ACTIONS(7504),
    [anon_sym_AT] = ACTIONS(7504),
    [aux_sym__hex_literal_token1] = ACTIONS(7504),
    [sym__number_literal] = ACTIONS(7506),
    [anon_sym_SQUOTE] = ACTIONS(7504),
    [anon_sym_DQUOTE] = ACTIONS(7504),
    [sym_return] = ACTIONS(7506),
    [sym_next] = ACTIONS(7506),
    [sym_break] = ACTIONS(7506),
    [sym_true] = ACTIONS(7506),
    [sym_false] = ACTIONS(7506),
    [sym_null] = ACTIONS(7506),
    [sym_inf] = ACTIONS(7506),
    [sym_nan] = ACTIONS(7506),
    [anon_sym_NA] = ACTIONS(7506),
    [anon_sym_NA_integer_] = ACTIONS(7506),
    [anon_sym_NA_real_] = ACTIONS(7506),
    [anon_sym_NA_complex_] = ACTIONS(7506),
    [anon_sym_NA_character_] = ACTIONS(7506),
    [sym_dots] = ACTIONS(7506),
    [sym_dot_dot_i] = ACTIONS(7504),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7504),
    [sym__newline] = ACTIONS(7504),
    [sym__semicolon] = ACTIONS(7504),
    [sym__raw_string_literal] = ACTIONS(7504),
    [sym__external_else] = ACTIONS(7504),
    [sym__external_open_parenthesis] = ACTIONS(7504),
    [sym__external_open_brace] = ACTIONS(7504),
    [sym__external_close_brace] = ACTIONS(7504),
    [sym__external_open_bracket] = ACTIONS(7504),
    [sym__external_close_bracket] = ACTIONS(7504),
    [sym__external_open_bracket2] = ACTIONS(7504),
  },
  [2453] = {
    [sym_identifier] = ACTIONS(7502),
    [anon_sym_BSLASH] = ACTIONS(7500),
    [anon_sym_function] = ACTIONS(7502),
    [anon_sym_EQ] = ACTIONS(7502),
    [anon_sym_if] = ACTIONS(7502),
    [anon_sym_for] = ACTIONS(7502),
    [anon_sym_while] = ACTIONS(7502),
    [anon_sym_repeat] = ACTIONS(7502),
    [anon_sym_QMARK] = ACTIONS(7500),
    [anon_sym_TILDE] = ACTIONS(7500),
    [anon_sym_BANG] = ACTIONS(7502),
    [anon_sym_PLUS] = ACTIONS(7500),
    [anon_sym_DASH] = ACTIONS(7502),
    [anon_sym_LT_DASH] = ACTIONS(7500),
    [anon_sym_LT_LT_DASH] = ACTIONS(7500),
    [anon_sym_COLON_EQ] = ACTIONS(7500),
    [anon_sym_DASH_GT] = ACTIONS(7502),
    [anon_sym_DASH_GT_GT] = ACTIONS(7500),
    [anon_sym_PIPE] = ACTIONS(7502),
    [anon_sym_AMP] = ACTIONS(7502),
    [anon_sym_PIPE_PIPE] = ACTIONS(7500),
    [anon_sym_AMP_AMP] = ACTIONS(7500),
    [anon_sym_LT] = ACTIONS(7502),
    [anon_sym_LT_EQ] = ACTIONS(7500),
    [anon_sym_GT] = ACTIONS(7502),
    [anon_sym_GT_EQ] = ACTIONS(7500),
    [anon_sym_EQ_EQ] = ACTIONS(7500),
    [anon_sym_BANG_EQ] = ACTIONS(7500),
    [anon_sym_STAR] = ACTIONS(7502),
    [anon_sym_SLASH] = ACTIONS(7500),
    [anon_sym_STAR_STAR] = ACTIONS(7500),
    [anon_sym_CARET] = ACTIONS(7500),
    [aux_sym_binary_operator_token1] = ACTIONS(7500),
    [anon_sym_PIPE_GT] = ACTIONS(7500),
    [anon_sym_COLON] = ACTIONS(7502),
    [anon_sym_DOLLAR] = ACTIONS(7500),
    [anon_sym_AT] = ACTIONS(7500),
    [aux_sym__hex_literal_token1] = ACTIONS(7500),
    [sym__number_literal] = ACTIONS(7502),
    [anon_sym_SQUOTE] = ACTIONS(7500),
    [anon_sym_DQUOTE] = ACTIONS(7500),
    [sym_return] = ACTIONS(7502),
    [sym_next] = ACTIONS(7502),
    [sym_break] = ACTIONS(7502),
    [sym_true] = ACTIONS(7502),
    [sym_false] = ACTIONS(7502),
    [sym_null] = ACTIONS(7502),
    [sym_inf] = ACTIONS(7502),
    [sym_nan] = ACTIONS(7502),
    [anon_sym_NA] = ACTIONS(7502),
    [anon_sym_NA_integer_] = ACTIONS(7502),
    [anon_sym_NA_real_] = ACTIONS(7502),
    [anon_sym_NA_complex_] = ACTIONS(7502),
    [anon_sym_NA_character_] = ACTIONS(7502),
    [sym_dots] = ACTIONS(7502),
    [sym_dot_dot_i] = ACTIONS(7500),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7500),
    [sym__newline] = ACTIONS(7500),
    [sym__semicolon] = ACTIONS(7500),
    [sym__raw_string_literal] = ACTIONS(7500),
    [sym__external_else] = ACTIONS(7500),
    [sym__external_open_parenthesis] = ACTIONS(7500),
    [sym__external_open_brace] = ACTIONS(7500),
    [sym__external_close_brace] = ACTIONS(7500),
    [sym__external_open_bracket] = ACTIONS(7500),
    [sym__external_close_bracket] = ACTIONS(7500),
    [sym__external_open_bracket2] = ACTIONS(7500),
  },
  [2454] = {
    [sym_identifier] = ACTIONS(7498),
    [anon_sym_BSLASH] = ACTIONS(7496),
    [anon_sym_function] = ACTIONS(7498),
    [anon_sym_EQ] = ACTIONS(7498),
    [anon_sym_if] = ACTIONS(7498),
    [anon_sym_for] = ACTIONS(7498),
    [anon_sym_while] = ACTIONS(7498),
    [anon_sym_repeat] = ACTIONS(7498),
    [anon_sym_QMARK] = ACTIONS(7496),
    [anon_sym_TILDE] = ACTIONS(7496),
    [anon_sym_BANG] = ACTIONS(7498),
    [anon_sym_PLUS] = ACTIONS(7496),
    [anon_sym_DASH] = ACTIONS(7498),
    [anon_sym_LT_DASH] = ACTIONS(7496),
    [anon_sym_LT_LT_DASH] = ACTIONS(7496),
    [anon_sym_COLON_EQ] = ACTIONS(7496),
    [anon_sym_DASH_GT] = ACTIONS(7498),
    [anon_sym_DASH_GT_GT] = ACTIONS(7496),
    [anon_sym_PIPE] = ACTIONS(7498),
    [anon_sym_AMP] = ACTIONS(7498),
    [anon_sym_PIPE_PIPE] = ACTIONS(7496),
    [anon_sym_AMP_AMP] = ACTIONS(7496),
    [anon_sym_LT] = ACTIONS(7498),
    [anon_sym_LT_EQ] = ACTIONS(7496),
    [anon_sym_GT] = ACTIONS(7498),
    [anon_sym_GT_EQ] = ACTIONS(7496),
    [anon_sym_EQ_EQ] = ACTIONS(7496),
    [anon_sym_BANG_EQ] = ACTIONS(7496),
    [anon_sym_STAR] = ACTIONS(7498),
    [anon_sym_SLASH] = ACTIONS(7496),
    [anon_sym_STAR_STAR] = ACTIONS(7496),
    [anon_sym_CARET] = ACTIONS(7496),
    [aux_sym_binary_operator_token1] = ACTIONS(7496),
    [anon_sym_PIPE_GT] = ACTIONS(7496),
    [anon_sym_COLON] = ACTIONS(7498),
    [anon_sym_DOLLAR] = ACTIONS(7496),
    [anon_sym_AT] = ACTIONS(7496),
    [aux_sym__hex_literal_token1] = ACTIONS(7496),
    [sym__number_literal] = ACTIONS(7498),
    [anon_sym_SQUOTE] = ACTIONS(7496),
    [anon_sym_DQUOTE] = ACTIONS(7496),
    [sym_return] = ACTIONS(7498),
    [sym_next] = ACTIONS(7498),
    [sym_break] = ACTIONS(7498),
    [sym_true] = ACTIONS(7498),
    [sym_false] = ACTIONS(7498),
    [sym_null] = ACTIONS(7498),
    [sym_inf] = ACTIONS(7498),
    [sym_nan] = ACTIONS(7498),
    [anon_sym_NA] = ACTIONS(7498),
    [anon_sym_NA_integer_] = ACTIONS(7498),
    [anon_sym_NA_real_] = ACTIONS(7498),
    [anon_sym_NA_complex_] = ACTIONS(7498),
    [anon_sym_NA_character_] = ACTIONS(7498),
    [sym_dots] = ACTIONS(7498),
    [sym_dot_dot_i] = ACTIONS(7496),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7496),
    [sym__newline] = ACTIONS(7496),
    [sym__semicolon] = ACTIONS(7496),
    [sym__raw_string_literal] = ACTIONS(7496),
    [sym__external_else] = ACTIONS(7496),
    [sym__external_open_parenthesis] = ACTIONS(7496),
    [sym__external_open_brace] = ACTIONS(7496),
    [sym__external_close_brace] = ACTIONS(7496),
    [sym__external_open_bracket] = ACTIONS(7496),
    [sym__external_close_bracket] = ACTIONS(7496),
    [sym__external_open_bracket2] = ACTIONS(7496),
  },
  [2455] = {
    [sym_identifier] = ACTIONS(7494),
    [anon_sym_BSLASH] = ACTIONS(7492),
    [anon_sym_function] = ACTIONS(7494),
    [anon_sym_EQ] = ACTIONS(7494),
    [anon_sym_if] = ACTIONS(7494),
    [anon_sym_for] = ACTIONS(7494),
    [anon_sym_while] = ACTIONS(7494),
    [anon_sym_repeat] = ACTIONS(7494),
    [anon_sym_QMARK] = ACTIONS(7492),
    [anon_sym_TILDE] = ACTIONS(7492),
    [anon_sym_BANG] = ACTIONS(7494),
    [anon_sym_PLUS] = ACTIONS(7492),
    [anon_sym_DASH] = ACTIONS(7494),
    [anon_sym_LT_DASH] = ACTIONS(7492),
    [anon_sym_LT_LT_DASH] = ACTIONS(7492),
    [anon_sym_COLON_EQ] = ACTIONS(7492),
    [anon_sym_DASH_GT] = ACTIONS(7494),
    [anon_sym_DASH_GT_GT] = ACTIONS(7492),
    [anon_sym_PIPE] = ACTIONS(7494),
    [anon_sym_AMP] = ACTIONS(7494),
    [anon_sym_PIPE_PIPE] = ACTIONS(7492),
    [anon_sym_AMP_AMP] = ACTIONS(7492),
    [anon_sym_LT] = ACTIONS(7494),
    [anon_sym_LT_EQ] = ACTIONS(7492),
    [anon_sym_GT] = ACTIONS(7494),
    [anon_sym_GT_EQ] = ACTIONS(7492),
    [anon_sym_EQ_EQ] = ACTIONS(7492),
    [anon_sym_BANG_EQ] = ACTIONS(7492),
    [anon_sym_STAR] = ACTIONS(7494),
    [anon_sym_SLASH] = ACTIONS(7492),
    [anon_sym_STAR_STAR] = ACTIONS(7492),
    [anon_sym_CARET] = ACTIONS(7492),
    [aux_sym_binary_operator_token1] = ACTIONS(7492),
    [anon_sym_PIPE_GT] = ACTIONS(7492),
    [anon_sym_COLON] = ACTIONS(7494),
    [anon_sym_DOLLAR] = ACTIONS(7492),
    [anon_sym_AT] = ACTIONS(7492),
    [aux_sym__hex_literal_token1] = ACTIONS(7492),
    [sym__number_literal] = ACTIONS(7494),
    [anon_sym_SQUOTE] = ACTIONS(7492),
    [anon_sym_DQUOTE] = ACTIONS(7492),
    [sym_return] = ACTIONS(7494),
    [sym_next] = ACTIONS(7494),
    [sym_break] = ACTIONS(7494),
    [sym_true] = ACTIONS(7494),
    [sym_false] = ACTIONS(7494),
    [sym_null] = ACTIONS(7494),
    [sym_inf] = ACTIONS(7494),
    [sym_nan] = ACTIONS(7494),
    [anon_sym_NA] = ACTIONS(7494),
    [anon_sym_NA_integer_] = ACTIONS(7494),
    [anon_sym_NA_real_] = ACTIONS(7494),
    [anon_sym_NA_complex_] = ACTIONS(7494),
    [anon_sym_NA_character_] = ACTIONS(7494),
    [sym_dots] = ACTIONS(7494),
    [sym_dot_dot_i] = ACTIONS(7492),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7492),
    [sym__newline] = ACTIONS(7492),
    [sym__semicolon] = ACTIONS(7492),
    [sym__raw_string_literal] = ACTIONS(7492),
    [sym__external_else] = ACTIONS(7492),
    [sym__external_open_parenthesis] = ACTIONS(7492),
    [sym__external_open_brace] = ACTIONS(7492),
    [sym__external_close_brace] = ACTIONS(7492),
    [sym__external_open_bracket] = ACTIONS(7492),
    [sym__external_close_bracket] = ACTIONS(7492),
    [sym__external_open_bracket2] = ACTIONS(7492),
  },
  [2456] = {
    [sym_identifier] = ACTIONS(7115),
    [anon_sym_BSLASH] = ACTIONS(7117),
    [anon_sym_function] = ACTIONS(7115),
    [anon_sym_EQ] = ACTIONS(7115),
    [anon_sym_if] = ACTIONS(7115),
    [anon_sym_for] = ACTIONS(7115),
    [anon_sym_while] = ACTIONS(7115),
    [anon_sym_repeat] = ACTIONS(7115),
    [anon_sym_QMARK] = ACTIONS(7117),
    [anon_sym_TILDE] = ACTIONS(7117),
    [anon_sym_BANG] = ACTIONS(7115),
    [anon_sym_PLUS] = ACTIONS(7117),
    [anon_sym_DASH] = ACTIONS(7115),
    [anon_sym_LT_DASH] = ACTIONS(7117),
    [anon_sym_LT_LT_DASH] = ACTIONS(7117),
    [anon_sym_COLON_EQ] = ACTIONS(7117),
    [anon_sym_DASH_GT] = ACTIONS(7115),
    [anon_sym_DASH_GT_GT] = ACTIONS(7117),
    [anon_sym_PIPE] = ACTIONS(7115),
    [anon_sym_AMP] = ACTIONS(7115),
    [anon_sym_PIPE_PIPE] = ACTIONS(7117),
    [anon_sym_AMP_AMP] = ACTIONS(7117),
    [anon_sym_LT] = ACTIONS(7115),
    [anon_sym_LT_EQ] = ACTIONS(7117),
    [anon_sym_GT] = ACTIONS(7115),
    [anon_sym_GT_EQ] = ACTIONS(7117),
    [anon_sym_EQ_EQ] = ACTIONS(7117),
    [anon_sym_BANG_EQ] = ACTIONS(7117),
    [anon_sym_STAR] = ACTIONS(7115),
    [anon_sym_SLASH] = ACTIONS(7117),
    [anon_sym_STAR_STAR] = ACTIONS(7117),
    [anon_sym_CARET] = ACTIONS(7117),
    [aux_sym_binary_operator_token1] = ACTIONS(7117),
    [anon_sym_PIPE_GT] = ACTIONS(7117),
    [anon_sym_COLON] = ACTIONS(7115),
    [anon_sym_DOLLAR] = ACTIONS(7117),
    [anon_sym_AT] = ACTIONS(7117),
    [anon_sym_COLON_COLON] = ACTIONS(7115),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7117),
    [aux_sym__hex_literal_token1] = ACTIONS(7117),
    [sym__number_literal] = ACTIONS(7115),
    [anon_sym_SQUOTE] = ACTIONS(7117),
    [anon_sym_DQUOTE] = ACTIONS(7117),
    [sym_return] = ACTIONS(7115),
    [sym_next] = ACTIONS(7115),
    [sym_break] = ACTIONS(7115),
    [sym_true] = ACTIONS(7115),
    [sym_false] = ACTIONS(7115),
    [sym_null] = ACTIONS(7115),
    [sym_inf] = ACTIONS(7115),
    [sym_nan] = ACTIONS(7115),
    [anon_sym_NA] = ACTIONS(7115),
    [anon_sym_NA_integer_] = ACTIONS(7115),
    [anon_sym_NA_real_] = ACTIONS(7115),
    [anon_sym_NA_complex_] = ACTIONS(7115),
    [anon_sym_NA_character_] = ACTIONS(7115),
    [sym_dots] = ACTIONS(7115),
    [sym_dot_dot_i] = ACTIONS(7117),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7117),
    [sym__newline] = ACTIONS(7117),
    [sym__raw_string_literal] = ACTIONS(7117),
    [sym__external_else] = ACTIONS(7117),
    [sym__external_open_parenthesis] = ACTIONS(7117),
    [sym__external_open_brace] = ACTIONS(7117),
    [sym__external_open_bracket] = ACTIONS(7117),
    [sym__external_close_bracket] = ACTIONS(7117),
    [sym__external_open_bracket2] = ACTIONS(7117),
  },
  [2457] = {
    [sym_identifier] = ACTIONS(7490),
    [anon_sym_BSLASH] = ACTIONS(7488),
    [anon_sym_function] = ACTIONS(7490),
    [anon_sym_EQ] = ACTIONS(7490),
    [anon_sym_if] = ACTIONS(7490),
    [anon_sym_for] = ACTIONS(7490),
    [anon_sym_while] = ACTIONS(7490),
    [anon_sym_repeat] = ACTIONS(7490),
    [anon_sym_QMARK] = ACTIONS(7488),
    [anon_sym_TILDE] = ACTIONS(7488),
    [anon_sym_BANG] = ACTIONS(7490),
    [anon_sym_PLUS] = ACTIONS(7488),
    [anon_sym_DASH] = ACTIONS(7490),
    [anon_sym_LT_DASH] = ACTIONS(7488),
    [anon_sym_LT_LT_DASH] = ACTIONS(7488),
    [anon_sym_COLON_EQ] = ACTIONS(7488),
    [anon_sym_DASH_GT] = ACTIONS(7490),
    [anon_sym_DASH_GT_GT] = ACTIONS(7488),
    [anon_sym_PIPE] = ACTIONS(7490),
    [anon_sym_AMP] = ACTIONS(7490),
    [anon_sym_PIPE_PIPE] = ACTIONS(7488),
    [anon_sym_AMP_AMP] = ACTIONS(7488),
    [anon_sym_LT] = ACTIONS(7490),
    [anon_sym_LT_EQ] = ACTIONS(7488),
    [anon_sym_GT] = ACTIONS(7490),
    [anon_sym_GT_EQ] = ACTIONS(7488),
    [anon_sym_EQ_EQ] = ACTIONS(7488),
    [anon_sym_BANG_EQ] = ACTIONS(7488),
    [anon_sym_STAR] = ACTIONS(7490),
    [anon_sym_SLASH] = ACTIONS(7488),
    [anon_sym_STAR_STAR] = ACTIONS(7488),
    [anon_sym_CARET] = ACTIONS(7488),
    [aux_sym_binary_operator_token1] = ACTIONS(7488),
    [anon_sym_PIPE_GT] = ACTIONS(7488),
    [anon_sym_COLON] = ACTIONS(7490),
    [anon_sym_DOLLAR] = ACTIONS(7488),
    [anon_sym_AT] = ACTIONS(7488),
    [aux_sym__hex_literal_token1] = ACTIONS(7488),
    [sym__number_literal] = ACTIONS(7490),
    [anon_sym_SQUOTE] = ACTIONS(7488),
    [anon_sym_DQUOTE] = ACTIONS(7488),
    [sym_return] = ACTIONS(7490),
    [sym_next] = ACTIONS(7490),
    [sym_break] = ACTIONS(7490),
    [sym_true] = ACTIONS(7490),
    [sym_false] = ACTIONS(7490),
    [sym_null] = ACTIONS(7490),
    [sym_inf] = ACTIONS(7490),
    [sym_nan] = ACTIONS(7490),
    [anon_sym_NA] = ACTIONS(7490),
    [anon_sym_NA_integer_] = ACTIONS(7490),
    [anon_sym_NA_real_] = ACTIONS(7490),
    [anon_sym_NA_complex_] = ACTIONS(7490),
    [anon_sym_NA_character_] = ACTIONS(7490),
    [sym_dots] = ACTIONS(7490),
    [sym_dot_dot_i] = ACTIONS(7488),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7488),
    [sym__newline] = ACTIONS(7488),
    [sym__semicolon] = ACTIONS(7488),
    [sym__raw_string_literal] = ACTIONS(7488),
    [sym__external_else] = ACTIONS(7488),
    [sym__external_open_parenthesis] = ACTIONS(7488),
    [sym__external_open_brace] = ACTIONS(7488),
    [sym__external_close_brace] = ACTIONS(7488),
    [sym__external_open_bracket] = ACTIONS(7488),
    [sym__external_close_bracket] = ACTIONS(7488),
    [sym__external_open_bracket2] = ACTIONS(7488),
  },
  [2458] = {
    [sym_identifier] = ACTIONS(7486),
    [anon_sym_BSLASH] = ACTIONS(7484),
    [anon_sym_function] = ACTIONS(7486),
    [anon_sym_EQ] = ACTIONS(7486),
    [anon_sym_if] = ACTIONS(7486),
    [anon_sym_for] = ACTIONS(7486),
    [anon_sym_while] = ACTIONS(7486),
    [anon_sym_repeat] = ACTIONS(7486),
    [anon_sym_QMARK] = ACTIONS(7484),
    [anon_sym_TILDE] = ACTIONS(7484),
    [anon_sym_BANG] = ACTIONS(7486),
    [anon_sym_PLUS] = ACTIONS(7484),
    [anon_sym_DASH] = ACTIONS(7486),
    [anon_sym_LT_DASH] = ACTIONS(7484),
    [anon_sym_LT_LT_DASH] = ACTIONS(7484),
    [anon_sym_COLON_EQ] = ACTIONS(7484),
    [anon_sym_DASH_GT] = ACTIONS(7486),
    [anon_sym_DASH_GT_GT] = ACTIONS(7484),
    [anon_sym_PIPE] = ACTIONS(7486),
    [anon_sym_AMP] = ACTIONS(7486),
    [anon_sym_PIPE_PIPE] = ACTIONS(7484),
    [anon_sym_AMP_AMP] = ACTIONS(7484),
    [anon_sym_LT] = ACTIONS(7486),
    [anon_sym_LT_EQ] = ACTIONS(7484),
    [anon_sym_GT] = ACTIONS(7486),
    [anon_sym_GT_EQ] = ACTIONS(7484),
    [anon_sym_EQ_EQ] = ACTIONS(7484),
    [anon_sym_BANG_EQ] = ACTIONS(7484),
    [anon_sym_STAR] = ACTIONS(7486),
    [anon_sym_SLASH] = ACTIONS(7484),
    [anon_sym_STAR_STAR] = ACTIONS(7484),
    [anon_sym_CARET] = ACTIONS(7484),
    [aux_sym_binary_operator_token1] = ACTIONS(7484),
    [anon_sym_PIPE_GT] = ACTIONS(7484),
    [anon_sym_COLON] = ACTIONS(7486),
    [anon_sym_DOLLAR] = ACTIONS(7484),
    [anon_sym_AT] = ACTIONS(7484),
    [aux_sym__hex_literal_token1] = ACTIONS(7484),
    [sym__number_literal] = ACTIONS(7486),
    [anon_sym_SQUOTE] = ACTIONS(7484),
    [anon_sym_DQUOTE] = ACTIONS(7484),
    [sym_return] = ACTIONS(7486),
    [sym_next] = ACTIONS(7486),
    [sym_break] = ACTIONS(7486),
    [sym_true] = ACTIONS(7486),
    [sym_false] = ACTIONS(7486),
    [sym_null] = ACTIONS(7486),
    [sym_inf] = ACTIONS(7486),
    [sym_nan] = ACTIONS(7486),
    [anon_sym_NA] = ACTIONS(7486),
    [anon_sym_NA_integer_] = ACTIONS(7486),
    [anon_sym_NA_real_] = ACTIONS(7486),
    [anon_sym_NA_complex_] = ACTIONS(7486),
    [anon_sym_NA_character_] = ACTIONS(7486),
    [sym_dots] = ACTIONS(7486),
    [sym_dot_dot_i] = ACTIONS(7484),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7484),
    [sym__newline] = ACTIONS(7484),
    [sym__semicolon] = ACTIONS(7484),
    [sym__raw_string_literal] = ACTIONS(7484),
    [sym__external_else] = ACTIONS(7484),
    [sym__external_open_parenthesis] = ACTIONS(7484),
    [sym__external_open_brace] = ACTIONS(7484),
    [sym__external_close_brace] = ACTIONS(7484),
    [sym__external_open_bracket] = ACTIONS(7484),
    [sym__external_close_bracket] = ACTIONS(7484),
    [sym__external_open_bracket2] = ACTIONS(7484),
  },
  [2459] = {
    [sym_identifier] = ACTIONS(7563),
    [anon_sym_BSLASH] = ACTIONS(7561),
    [anon_sym_function] = ACTIONS(7563),
    [anon_sym_EQ] = ACTIONS(7563),
    [anon_sym_if] = ACTIONS(7563),
    [anon_sym_for] = ACTIONS(7563),
    [anon_sym_while] = ACTIONS(7563),
    [anon_sym_repeat] = ACTIONS(7563),
    [anon_sym_QMARK] = ACTIONS(7561),
    [anon_sym_TILDE] = ACTIONS(7561),
    [anon_sym_BANG] = ACTIONS(7563),
    [anon_sym_PLUS] = ACTIONS(7561),
    [anon_sym_DASH] = ACTIONS(7563),
    [anon_sym_LT_DASH] = ACTIONS(7561),
    [anon_sym_LT_LT_DASH] = ACTIONS(7561),
    [anon_sym_COLON_EQ] = ACTIONS(7561),
    [anon_sym_DASH_GT] = ACTIONS(7563),
    [anon_sym_DASH_GT_GT] = ACTIONS(7561),
    [anon_sym_PIPE] = ACTIONS(7563),
    [anon_sym_AMP] = ACTIONS(7563),
    [anon_sym_PIPE_PIPE] = ACTIONS(7561),
    [anon_sym_AMP_AMP] = ACTIONS(7561),
    [anon_sym_LT] = ACTIONS(7563),
    [anon_sym_LT_EQ] = ACTIONS(7561),
    [anon_sym_GT] = ACTIONS(7563),
    [anon_sym_GT_EQ] = ACTIONS(7561),
    [anon_sym_EQ_EQ] = ACTIONS(7561),
    [anon_sym_BANG_EQ] = ACTIONS(7561),
    [anon_sym_STAR] = ACTIONS(7563),
    [anon_sym_SLASH] = ACTIONS(7561),
    [anon_sym_STAR_STAR] = ACTIONS(7561),
    [anon_sym_CARET] = ACTIONS(7561),
    [aux_sym_binary_operator_token1] = ACTIONS(7561),
    [anon_sym_PIPE_GT] = ACTIONS(7561),
    [anon_sym_COLON] = ACTIONS(7563),
    [anon_sym_DOLLAR] = ACTIONS(7561),
    [anon_sym_AT] = ACTIONS(7561),
    [aux_sym__hex_literal_token1] = ACTIONS(7561),
    [sym__number_literal] = ACTIONS(7563),
    [anon_sym_SQUOTE] = ACTIONS(7561),
    [anon_sym_DQUOTE] = ACTIONS(7561),
    [sym_return] = ACTIONS(7563),
    [sym_next] = ACTIONS(7563),
    [sym_break] = ACTIONS(7563),
    [sym_true] = ACTIONS(7563),
    [sym_false] = ACTIONS(7563),
    [sym_null] = ACTIONS(7563),
    [sym_inf] = ACTIONS(7563),
    [sym_nan] = ACTIONS(7563),
    [anon_sym_NA] = ACTIONS(7563),
    [anon_sym_NA_integer_] = ACTIONS(7563),
    [anon_sym_NA_real_] = ACTIONS(7563),
    [anon_sym_NA_complex_] = ACTIONS(7563),
    [anon_sym_NA_character_] = ACTIONS(7563),
    [sym_dots] = ACTIONS(7563),
    [sym_dot_dot_i] = ACTIONS(7561),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7561),
    [sym__newline] = ACTIONS(7561),
    [sym__semicolon] = ACTIONS(7561),
    [sym__raw_string_literal] = ACTIONS(7561),
    [sym__external_else] = ACTIONS(7561),
    [sym__external_open_parenthesis] = ACTIONS(7561),
    [sym__external_open_brace] = ACTIONS(7561),
    [sym__external_close_brace] = ACTIONS(7561),
    [sym__external_open_bracket] = ACTIONS(7561),
    [sym__external_open_bracket2] = ACTIONS(7561),
    [sym__external_close_bracket2] = ACTIONS(7561),
  },
  [2460] = {
    [aux_sym_function_definition_repeat1] = STATE(2460),
    [sym_identifier] = ACTIONS(7419),
    [anon_sym_BSLASH] = ACTIONS(7417),
    [anon_sym_function] = ACTIONS(7419),
    [anon_sym_EQ] = ACTIONS(7419),
    [anon_sym_if] = ACTIONS(7419),
    [anon_sym_for] = ACTIONS(7419),
    [anon_sym_while] = ACTIONS(7419),
    [anon_sym_repeat] = ACTIONS(7419),
    [anon_sym_QMARK] = ACTIONS(7417),
    [anon_sym_TILDE] = ACTIONS(7417),
    [anon_sym_BANG] = ACTIONS(7419),
    [anon_sym_PLUS] = ACTIONS(7417),
    [anon_sym_DASH] = ACTIONS(7419),
    [anon_sym_LT_DASH] = ACTIONS(7417),
    [anon_sym_LT_LT_DASH] = ACTIONS(7417),
    [anon_sym_COLON_EQ] = ACTIONS(7417),
    [anon_sym_DASH_GT] = ACTIONS(7419),
    [anon_sym_DASH_GT_GT] = ACTIONS(7417),
    [anon_sym_PIPE] = ACTIONS(7419),
    [anon_sym_AMP] = ACTIONS(7419),
    [anon_sym_PIPE_PIPE] = ACTIONS(7417),
    [anon_sym_AMP_AMP] = ACTIONS(7417),
    [anon_sym_LT] = ACTIONS(7419),
    [anon_sym_LT_EQ] = ACTIONS(7417),
    [anon_sym_GT] = ACTIONS(7419),
    [anon_sym_GT_EQ] = ACTIONS(7417),
    [anon_sym_EQ_EQ] = ACTIONS(7417),
    [anon_sym_BANG_EQ] = ACTIONS(7417),
    [anon_sym_STAR] = ACTIONS(7419),
    [anon_sym_SLASH] = ACTIONS(7417),
    [anon_sym_STAR_STAR] = ACTIONS(7417),
    [anon_sym_CARET] = ACTIONS(7417),
    [aux_sym_binary_operator_token1] = ACTIONS(7417),
    [anon_sym_PIPE_GT] = ACTIONS(7417),
    [anon_sym_COLON] = ACTIONS(7419),
    [anon_sym_DOLLAR] = ACTIONS(7417),
    [anon_sym_AT] = ACTIONS(7417),
    [aux_sym__hex_literal_token1] = ACTIONS(7417),
    [sym__number_literal] = ACTIONS(7419),
    [anon_sym_SQUOTE] = ACTIONS(7417),
    [anon_sym_DQUOTE] = ACTIONS(7417),
    [sym_return] = ACTIONS(7419),
    [sym_next] = ACTIONS(7419),
    [sym_break] = ACTIONS(7419),
    [sym_true] = ACTIONS(7419),
    [sym_false] = ACTIONS(7419),
    [sym_null] = ACTIONS(7419),
    [sym_inf] = ACTIONS(7419),
    [sym_nan] = ACTIONS(7419),
    [anon_sym_NA] = ACTIONS(7419),
    [anon_sym_NA_integer_] = ACTIONS(7419),
    [anon_sym_NA_real_] = ACTIONS(7419),
    [anon_sym_NA_complex_] = ACTIONS(7419),
    [anon_sym_NA_character_] = ACTIONS(7419),
    [sym_dots] = ACTIONS(7419),
    [sym_dot_dot_i] = ACTIONS(7417),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7417),
    [sym__newline] = ACTIONS(7628),
    [sym__raw_string_literal] = ACTIONS(7417),
    [sym__external_else] = ACTIONS(7417),
    [sym__external_open_parenthesis] = ACTIONS(7417),
    [sym__external_close_parenthesis] = ACTIONS(7417),
    [sym__external_open_brace] = ACTIONS(7417),
    [sym__external_open_bracket] = ACTIONS(7417),
    [sym__external_open_bracket2] = ACTIONS(7417),
    [sym__external_close_bracket2] = ACTIONS(7417),
  },
  [2461] = {
    [sym_identifier] = ACTIONS(7563),
    [anon_sym_BSLASH] = ACTIONS(7561),
    [anon_sym_function] = ACTIONS(7563),
    [anon_sym_EQ] = ACTIONS(7563),
    [anon_sym_if] = ACTIONS(7563),
    [anon_sym_for] = ACTIONS(7563),
    [anon_sym_while] = ACTIONS(7563),
    [anon_sym_repeat] = ACTIONS(7563),
    [anon_sym_QMARK] = ACTIONS(7561),
    [anon_sym_TILDE] = ACTIONS(7561),
    [anon_sym_BANG] = ACTIONS(7563),
    [anon_sym_PLUS] = ACTIONS(7561),
    [anon_sym_DASH] = ACTIONS(7563),
    [anon_sym_LT_DASH] = ACTIONS(7561),
    [anon_sym_LT_LT_DASH] = ACTIONS(7561),
    [anon_sym_COLON_EQ] = ACTIONS(7561),
    [anon_sym_DASH_GT] = ACTIONS(7563),
    [anon_sym_DASH_GT_GT] = ACTIONS(7561),
    [anon_sym_PIPE] = ACTIONS(7563),
    [anon_sym_AMP] = ACTIONS(7563),
    [anon_sym_PIPE_PIPE] = ACTIONS(7561),
    [anon_sym_AMP_AMP] = ACTIONS(7561),
    [anon_sym_LT] = ACTIONS(7563),
    [anon_sym_LT_EQ] = ACTIONS(7561),
    [anon_sym_GT] = ACTIONS(7563),
    [anon_sym_GT_EQ] = ACTIONS(7561),
    [anon_sym_EQ_EQ] = ACTIONS(7561),
    [anon_sym_BANG_EQ] = ACTIONS(7561),
    [anon_sym_STAR] = ACTIONS(7563),
    [anon_sym_SLASH] = ACTIONS(7561),
    [anon_sym_STAR_STAR] = ACTIONS(7561),
    [anon_sym_CARET] = ACTIONS(7561),
    [aux_sym_binary_operator_token1] = ACTIONS(7561),
    [anon_sym_PIPE_GT] = ACTIONS(7561),
    [anon_sym_COLON] = ACTIONS(7563),
    [anon_sym_DOLLAR] = ACTIONS(7561),
    [anon_sym_AT] = ACTIONS(7561),
    [aux_sym__hex_literal_token1] = ACTIONS(7561),
    [sym__number_literal] = ACTIONS(7563),
    [anon_sym_SQUOTE] = ACTIONS(7561),
    [anon_sym_DQUOTE] = ACTIONS(7561),
    [sym_return] = ACTIONS(7563),
    [sym_next] = ACTIONS(7563),
    [sym_break] = ACTIONS(7563),
    [sym_true] = ACTIONS(7563),
    [sym_false] = ACTIONS(7563),
    [sym_null] = ACTIONS(7563),
    [sym_inf] = ACTIONS(7563),
    [sym_nan] = ACTIONS(7563),
    [anon_sym_NA] = ACTIONS(7563),
    [anon_sym_NA_integer_] = ACTIONS(7563),
    [anon_sym_NA_real_] = ACTIONS(7563),
    [anon_sym_NA_complex_] = ACTIONS(7563),
    [anon_sym_NA_character_] = ACTIONS(7563),
    [sym_dots] = ACTIONS(7563),
    [sym_dot_dot_i] = ACTIONS(7561),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7561),
    [sym__newline] = ACTIONS(7561),
    [sym__semicolon] = ACTIONS(7561),
    [sym__raw_string_literal] = ACTIONS(7561),
    [sym__external_open_parenthesis] = ACTIONS(7561),
    [sym__external_close_parenthesis] = ACTIONS(7561),
    [sym__external_open_brace] = ACTIONS(7561),
    [sym__external_close_brace] = ACTIONS(7561),
    [sym__external_open_bracket] = ACTIONS(7561),
    [sym__external_close_bracket] = ACTIONS(7561),
    [sym__external_open_bracket2] = ACTIONS(7561),
  },
  [2462] = {
    [ts_builtin_sym_end] = ACTIONS(7117),
    [sym_identifier] = ACTIONS(7115),
    [anon_sym_BSLASH] = ACTIONS(7117),
    [anon_sym_function] = ACTIONS(7115),
    [anon_sym_EQ] = ACTIONS(7115),
    [anon_sym_if] = ACTIONS(7115),
    [anon_sym_for] = ACTIONS(7115),
    [anon_sym_while] = ACTIONS(7115),
    [anon_sym_repeat] = ACTIONS(7115),
    [anon_sym_QMARK] = ACTIONS(7117),
    [anon_sym_TILDE] = ACTIONS(7117),
    [anon_sym_BANG] = ACTIONS(7115),
    [anon_sym_PLUS] = ACTIONS(7117),
    [anon_sym_DASH] = ACTIONS(7115),
    [anon_sym_LT_DASH] = ACTIONS(7117),
    [anon_sym_LT_LT_DASH] = ACTIONS(7117),
    [anon_sym_COLON_EQ] = ACTIONS(7117),
    [anon_sym_DASH_GT] = ACTIONS(7115),
    [anon_sym_DASH_GT_GT] = ACTIONS(7117),
    [anon_sym_PIPE] = ACTIONS(7115),
    [anon_sym_AMP] = ACTIONS(7115),
    [anon_sym_PIPE_PIPE] = ACTIONS(7117),
    [anon_sym_AMP_AMP] = ACTIONS(7117),
    [anon_sym_LT] = ACTIONS(7115),
    [anon_sym_LT_EQ] = ACTIONS(7117),
    [anon_sym_GT] = ACTIONS(7115),
    [anon_sym_GT_EQ] = ACTIONS(7117),
    [anon_sym_EQ_EQ] = ACTIONS(7117),
    [anon_sym_BANG_EQ] = ACTIONS(7117),
    [anon_sym_STAR] = ACTIONS(7115),
    [anon_sym_SLASH] = ACTIONS(7117),
    [anon_sym_STAR_STAR] = ACTIONS(7117),
    [anon_sym_CARET] = ACTIONS(7117),
    [aux_sym_binary_operator_token1] = ACTIONS(7117),
    [anon_sym_PIPE_GT] = ACTIONS(7117),
    [anon_sym_COLON] = ACTIONS(7115),
    [anon_sym_DOLLAR] = ACTIONS(7117),
    [anon_sym_AT] = ACTIONS(7117),
    [anon_sym_COLON_COLON] = ACTIONS(7115),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7117),
    [aux_sym__hex_literal_token1] = ACTIONS(7117),
    [sym__number_literal] = ACTIONS(7115),
    [anon_sym_SQUOTE] = ACTIONS(7117),
    [anon_sym_DQUOTE] = ACTIONS(7117),
    [sym_return] = ACTIONS(7115),
    [sym_next] = ACTIONS(7115),
    [sym_break] = ACTIONS(7115),
    [sym_true] = ACTIONS(7115),
    [sym_false] = ACTIONS(7115),
    [sym_null] = ACTIONS(7115),
    [sym_inf] = ACTIONS(7115),
    [sym_nan] = ACTIONS(7115),
    [anon_sym_NA] = ACTIONS(7115),
    [anon_sym_NA_integer_] = ACTIONS(7115),
    [anon_sym_NA_real_] = ACTIONS(7115),
    [anon_sym_NA_complex_] = ACTIONS(7115),
    [anon_sym_NA_character_] = ACTIONS(7115),
    [sym_dots] = ACTIONS(7115),
    [sym_dot_dot_i] = ACTIONS(7117),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7117),
    [sym__semicolon] = ACTIONS(7117),
    [sym__raw_string_literal] = ACTIONS(7117),
    [sym__external_open_parenthesis] = ACTIONS(7117),
    [sym__external_close_parenthesis] = ACTIONS(7117),
    [sym__external_open_brace] = ACTIONS(7117),
    [sym__external_open_bracket] = ACTIONS(7117),
    [sym__external_open_bracket2] = ACTIONS(7117),
  },
  [2463] = {
    [ts_builtin_sym_end] = ACTIONS(7472),
    [sym_identifier] = ACTIONS(7474),
    [anon_sym_BSLASH] = ACTIONS(7472),
    [anon_sym_function] = ACTIONS(7474),
    [anon_sym_EQ] = ACTIONS(7474),
    [anon_sym_if] = ACTIONS(7474),
    [anon_sym_for] = ACTIONS(7474),
    [anon_sym_while] = ACTIONS(7474),
    [anon_sym_repeat] = ACTIONS(7474),
    [anon_sym_QMARK] = ACTIONS(7472),
    [anon_sym_TILDE] = ACTIONS(7472),
    [anon_sym_BANG] = ACTIONS(7474),
    [anon_sym_PLUS] = ACTIONS(7472),
    [anon_sym_DASH] = ACTIONS(7474),
    [anon_sym_LT_DASH] = ACTIONS(7472),
    [anon_sym_LT_LT_DASH] = ACTIONS(7472),
    [anon_sym_COLON_EQ] = ACTIONS(7472),
    [anon_sym_DASH_GT] = ACTIONS(7474),
    [anon_sym_DASH_GT_GT] = ACTIONS(7472),
    [anon_sym_PIPE] = ACTIONS(7474),
    [anon_sym_AMP] = ACTIONS(7474),
    [anon_sym_PIPE_PIPE] = ACTIONS(7472),
    [anon_sym_AMP_AMP] = ACTIONS(7472),
    [anon_sym_LT] = ACTIONS(7474),
    [anon_sym_LT_EQ] = ACTIONS(7472),
    [anon_sym_GT] = ACTIONS(7474),
    [anon_sym_GT_EQ] = ACTIONS(7472),
    [anon_sym_EQ_EQ] = ACTIONS(7472),
    [anon_sym_BANG_EQ] = ACTIONS(7472),
    [anon_sym_STAR] = ACTIONS(7474),
    [anon_sym_SLASH] = ACTIONS(7472),
    [anon_sym_STAR_STAR] = ACTIONS(7472),
    [anon_sym_CARET] = ACTIONS(7472),
    [aux_sym_binary_operator_token1] = ACTIONS(7472),
    [anon_sym_PIPE_GT] = ACTIONS(7472),
    [anon_sym_COLON] = ACTIONS(7474),
    [anon_sym_DOLLAR] = ACTIONS(7472),
    [anon_sym_AT] = ACTIONS(7472),
    [aux_sym__hex_literal_token1] = ACTIONS(7472),
    [sym__number_literal] = ACTIONS(7474),
    [anon_sym_SQUOTE] = ACTIONS(7472),
    [anon_sym_DQUOTE] = ACTIONS(7472),
    [sym_return] = ACTIONS(7474),
    [sym_next] = ACTIONS(7474),
    [sym_break] = ACTIONS(7474),
    [sym_true] = ACTIONS(7474),
    [sym_false] = ACTIONS(7474),
    [sym_null] = ACTIONS(7474),
    [sym_inf] = ACTIONS(7474),
    [sym_nan] = ACTIONS(7474),
    [anon_sym_NA] = ACTIONS(7474),
    [anon_sym_NA_integer_] = ACTIONS(7474),
    [anon_sym_NA_real_] = ACTIONS(7474),
    [anon_sym_NA_complex_] = ACTIONS(7474),
    [anon_sym_NA_character_] = ACTIONS(7474),
    [sym_dots] = ACTIONS(7474),
    [sym_dot_dot_i] = ACTIONS(7472),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7472),
    [sym__newline] = ACTIONS(7472),
    [sym__semicolon] = ACTIONS(7472),
    [sym__raw_string_literal] = ACTIONS(7472),
    [sym__external_open_parenthesis] = ACTIONS(7472),
    [sym__external_close_parenthesis] = ACTIONS(7472),
    [sym__external_open_brace] = ACTIONS(7472),
    [sym__external_close_brace] = ACTIONS(7472),
    [sym__external_open_bracket] = ACTIONS(7472),
    [sym__external_open_bracket2] = ACTIONS(7472),
  },
  [2464] = {
    [ts_builtin_sym_end] = ACTIONS(7466),
    [sym_identifier] = ACTIONS(7464),
    [anon_sym_BSLASH] = ACTIONS(7466),
    [anon_sym_function] = ACTIONS(7464),
    [anon_sym_EQ] = ACTIONS(7464),
    [anon_sym_if] = ACTIONS(7464),
    [anon_sym_for] = ACTIONS(7464),
    [anon_sym_while] = ACTIONS(7464),
    [anon_sym_repeat] = ACTIONS(7464),
    [anon_sym_QMARK] = ACTIONS(7466),
    [anon_sym_TILDE] = ACTIONS(7466),
    [anon_sym_BANG] = ACTIONS(7464),
    [anon_sym_PLUS] = ACTIONS(7466),
    [anon_sym_DASH] = ACTIONS(7464),
    [anon_sym_LT_DASH] = ACTIONS(7466),
    [anon_sym_LT_LT_DASH] = ACTIONS(7466),
    [anon_sym_COLON_EQ] = ACTIONS(7466),
    [anon_sym_DASH_GT] = ACTIONS(7464),
    [anon_sym_DASH_GT_GT] = ACTIONS(7466),
    [anon_sym_PIPE] = ACTIONS(7464),
    [anon_sym_AMP] = ACTIONS(7464),
    [anon_sym_PIPE_PIPE] = ACTIONS(7466),
    [anon_sym_AMP_AMP] = ACTIONS(7466),
    [anon_sym_LT] = ACTIONS(7464),
    [anon_sym_LT_EQ] = ACTIONS(7466),
    [anon_sym_GT] = ACTIONS(7464),
    [anon_sym_GT_EQ] = ACTIONS(7466),
    [anon_sym_EQ_EQ] = ACTIONS(7466),
    [anon_sym_BANG_EQ] = ACTIONS(7466),
    [anon_sym_STAR] = ACTIONS(7464),
    [anon_sym_SLASH] = ACTIONS(7466),
    [anon_sym_STAR_STAR] = ACTIONS(7466),
    [anon_sym_CARET] = ACTIONS(7466),
    [aux_sym_binary_operator_token1] = ACTIONS(7466),
    [anon_sym_PIPE_GT] = ACTIONS(7466),
    [anon_sym_COLON] = ACTIONS(7464),
    [anon_sym_DOLLAR] = ACTIONS(7466),
    [anon_sym_AT] = ACTIONS(7466),
    [aux_sym__hex_literal_token1] = ACTIONS(7466),
    [sym__number_literal] = ACTIONS(7464),
    [anon_sym_SQUOTE] = ACTIONS(7466),
    [anon_sym_DQUOTE] = ACTIONS(7466),
    [sym_return] = ACTIONS(7464),
    [sym_next] = ACTIONS(7464),
    [sym_break] = ACTIONS(7464),
    [sym_true] = ACTIONS(7464),
    [sym_false] = ACTIONS(7464),
    [sym_null] = ACTIONS(7464),
    [sym_inf] = ACTIONS(7464),
    [sym_nan] = ACTIONS(7464),
    [anon_sym_NA] = ACTIONS(7464),
    [anon_sym_NA_integer_] = ACTIONS(7464),
    [anon_sym_NA_real_] = ACTIONS(7464),
    [anon_sym_NA_complex_] = ACTIONS(7464),
    [anon_sym_NA_character_] = ACTIONS(7464),
    [sym_dots] = ACTIONS(7464),
    [sym_dot_dot_i] = ACTIONS(7466),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7466),
    [sym__newline] = ACTIONS(7466),
    [sym__semicolon] = ACTIONS(7466),
    [sym__raw_string_literal] = ACTIONS(7466),
    [sym__external_open_parenthesis] = ACTIONS(7466),
    [sym__external_close_parenthesis] = ACTIONS(7466),
    [sym__external_open_brace] = ACTIONS(7466),
    [sym__external_close_brace] = ACTIONS(7466),
    [sym__external_open_bracket] = ACTIONS(7466),
    [sym__external_open_bracket2] = ACTIONS(7466),
  },
  [2465] = {
    [aux_sym_function_definition_repeat1] = STATE(2465),
    [ts_builtin_sym_end] = ACTIONS(7417),
    [sym_identifier] = ACTIONS(7419),
    [anon_sym_BSLASH] = ACTIONS(7417),
    [anon_sym_function] = ACTIONS(7419),
    [anon_sym_EQ] = ACTIONS(7419),
    [anon_sym_if] = ACTIONS(7419),
    [anon_sym_for] = ACTIONS(7419),
    [anon_sym_while] = ACTIONS(7419),
    [anon_sym_repeat] = ACTIONS(7419),
    [anon_sym_QMARK] = ACTIONS(7417),
    [anon_sym_TILDE] = ACTIONS(7417),
    [anon_sym_BANG] = ACTIONS(7419),
    [anon_sym_PLUS] = ACTIONS(7417),
    [anon_sym_DASH] = ACTIONS(7419),
    [anon_sym_LT_DASH] = ACTIONS(7417),
    [anon_sym_LT_LT_DASH] = ACTIONS(7417),
    [anon_sym_COLON_EQ] = ACTIONS(7417),
    [anon_sym_DASH_GT] = ACTIONS(7419),
    [anon_sym_DASH_GT_GT] = ACTIONS(7417),
    [anon_sym_PIPE] = ACTIONS(7419),
    [anon_sym_AMP] = ACTIONS(7419),
    [anon_sym_PIPE_PIPE] = ACTIONS(7417),
    [anon_sym_AMP_AMP] = ACTIONS(7417),
    [anon_sym_LT] = ACTIONS(7419),
    [anon_sym_LT_EQ] = ACTIONS(7417),
    [anon_sym_GT] = ACTIONS(7419),
    [anon_sym_GT_EQ] = ACTIONS(7417),
    [anon_sym_EQ_EQ] = ACTIONS(7417),
    [anon_sym_BANG_EQ] = ACTIONS(7417),
    [anon_sym_STAR] = ACTIONS(7419),
    [anon_sym_SLASH] = ACTIONS(7417),
    [anon_sym_STAR_STAR] = ACTIONS(7417),
    [anon_sym_CARET] = ACTIONS(7417),
    [aux_sym_binary_operator_token1] = ACTIONS(7417),
    [anon_sym_PIPE_GT] = ACTIONS(7417),
    [anon_sym_COLON] = ACTIONS(7419),
    [anon_sym_DOLLAR] = ACTIONS(7417),
    [anon_sym_AT] = ACTIONS(7417),
    [aux_sym__hex_literal_token1] = ACTIONS(7417),
    [sym__number_literal] = ACTIONS(7419),
    [anon_sym_SQUOTE] = ACTIONS(7417),
    [anon_sym_DQUOTE] = ACTIONS(7417),
    [sym_return] = ACTIONS(7419),
    [sym_next] = ACTIONS(7419),
    [sym_break] = ACTIONS(7419),
    [sym_true] = ACTIONS(7419),
    [sym_false] = ACTIONS(7419),
    [sym_null] = ACTIONS(7419),
    [sym_inf] = ACTIONS(7419),
    [sym_nan] = ACTIONS(7419),
    [anon_sym_NA] = ACTIONS(7419),
    [anon_sym_NA_integer_] = ACTIONS(7419),
    [anon_sym_NA_real_] = ACTIONS(7419),
    [anon_sym_NA_complex_] = ACTIONS(7419),
    [anon_sym_NA_character_] = ACTIONS(7419),
    [sym_dots] = ACTIONS(7419),
    [sym_dot_dot_i] = ACTIONS(7417),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7631),
    [sym__semicolon] = ACTIONS(7417),
    [sym__raw_string_literal] = ACTIONS(7417),
    [sym__external_else] = ACTIONS(7417),
    [sym__external_open_parenthesis] = ACTIONS(7417),
    [sym__external_close_parenthesis] = ACTIONS(7417),
    [sym__external_open_brace] = ACTIONS(7417),
    [sym__external_open_bracket] = ACTIONS(7417),
    [sym__external_open_bracket2] = ACTIONS(7417),
  },
  [2466] = {
    [sym_identifier] = ACTIONS(7115),
    [anon_sym_BSLASH] = ACTIONS(7117),
    [anon_sym_function] = ACTIONS(7115),
    [anon_sym_EQ] = ACTIONS(7115),
    [anon_sym_if] = ACTIONS(7115),
    [anon_sym_for] = ACTIONS(7115),
    [anon_sym_while] = ACTIONS(7115),
    [anon_sym_repeat] = ACTIONS(7115),
    [anon_sym_QMARK] = ACTIONS(7117),
    [anon_sym_TILDE] = ACTIONS(7117),
    [anon_sym_BANG] = ACTIONS(7115),
    [anon_sym_PLUS] = ACTIONS(7117),
    [anon_sym_DASH] = ACTIONS(7115),
    [anon_sym_LT_DASH] = ACTIONS(7117),
    [anon_sym_LT_LT_DASH] = ACTIONS(7117),
    [anon_sym_COLON_EQ] = ACTIONS(7117),
    [anon_sym_DASH_GT] = ACTIONS(7115),
    [anon_sym_DASH_GT_GT] = ACTIONS(7117),
    [anon_sym_PIPE] = ACTIONS(7115),
    [anon_sym_AMP] = ACTIONS(7115),
    [anon_sym_PIPE_PIPE] = ACTIONS(7117),
    [anon_sym_AMP_AMP] = ACTIONS(7117),
    [anon_sym_LT] = ACTIONS(7115),
    [anon_sym_LT_EQ] = ACTIONS(7117),
    [anon_sym_GT] = ACTIONS(7115),
    [anon_sym_GT_EQ] = ACTIONS(7117),
    [anon_sym_EQ_EQ] = ACTIONS(7117),
    [anon_sym_BANG_EQ] = ACTIONS(7117),
    [anon_sym_STAR] = ACTIONS(7115),
    [anon_sym_SLASH] = ACTIONS(7117),
    [anon_sym_STAR_STAR] = ACTIONS(7117),
    [anon_sym_CARET] = ACTIONS(7117),
    [aux_sym_binary_operator_token1] = ACTIONS(7117),
    [anon_sym_PIPE_GT] = ACTIONS(7117),
    [anon_sym_COLON] = ACTIONS(7115),
    [anon_sym_DOLLAR] = ACTIONS(7117),
    [anon_sym_AT] = ACTIONS(7117),
    [anon_sym_COLON_COLON] = ACTIONS(7115),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7117),
    [aux_sym__hex_literal_token1] = ACTIONS(7117),
    [sym__number_literal] = ACTIONS(7115),
    [anon_sym_SQUOTE] = ACTIONS(7117),
    [anon_sym_DQUOTE] = ACTIONS(7117),
    [sym_return] = ACTIONS(7115),
    [sym_next] = ACTIONS(7115),
    [sym_break] = ACTIONS(7115),
    [sym_true] = ACTIONS(7115),
    [sym_false] = ACTIONS(7115),
    [sym_null] = ACTIONS(7115),
    [sym_inf] = ACTIONS(7115),
    [sym_nan] = ACTIONS(7115),
    [anon_sym_NA] = ACTIONS(7115),
    [anon_sym_NA_integer_] = ACTIONS(7115),
    [anon_sym_NA_real_] = ACTIONS(7115),
    [anon_sym_NA_complex_] = ACTIONS(7115),
    [anon_sym_NA_character_] = ACTIONS(7115),
    [sym_dots] = ACTIONS(7115),
    [sym_dot_dot_i] = ACTIONS(7117),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7117),
    [sym__newline] = ACTIONS(7117),
    [sym__raw_string_literal] = ACTIONS(7117),
    [sym__external_open_parenthesis] = ACTIONS(7117),
    [sym__external_close_parenthesis] = ACTIONS(7117),
    [sym__external_open_brace] = ACTIONS(7117),
    [sym__external_open_bracket] = ACTIONS(7117),
    [sym__external_open_bracket2] = ACTIONS(7117),
    [sym__external_close_bracket2] = ACTIONS(7117),
  },
  [2467] = {
    [ts_builtin_sym_end] = ACTIONS(7476),
    [sym_identifier] = ACTIONS(7478),
    [anon_sym_BSLASH] = ACTIONS(7476),
    [anon_sym_function] = ACTIONS(7478),
    [anon_sym_EQ] = ACTIONS(7478),
    [anon_sym_if] = ACTIONS(7478),
    [anon_sym_for] = ACTIONS(7478),
    [anon_sym_while] = ACTIONS(7478),
    [anon_sym_repeat] = ACTIONS(7478),
    [anon_sym_QMARK] = ACTIONS(7476),
    [anon_sym_TILDE] = ACTIONS(7476),
    [anon_sym_BANG] = ACTIONS(7478),
    [anon_sym_PLUS] = ACTIONS(7476),
    [anon_sym_DASH] = ACTIONS(7478),
    [anon_sym_LT_DASH] = ACTIONS(7476),
    [anon_sym_LT_LT_DASH] = ACTIONS(7476),
    [anon_sym_COLON_EQ] = ACTIONS(7476),
    [anon_sym_DASH_GT] = ACTIONS(7478),
    [anon_sym_DASH_GT_GT] = ACTIONS(7476),
    [anon_sym_PIPE] = ACTIONS(7478),
    [anon_sym_AMP] = ACTIONS(7478),
    [anon_sym_PIPE_PIPE] = ACTIONS(7476),
    [anon_sym_AMP_AMP] = ACTIONS(7476),
    [anon_sym_LT] = ACTIONS(7478),
    [anon_sym_LT_EQ] = ACTIONS(7476),
    [anon_sym_GT] = ACTIONS(7478),
    [anon_sym_GT_EQ] = ACTIONS(7476),
    [anon_sym_EQ_EQ] = ACTIONS(7476),
    [anon_sym_BANG_EQ] = ACTIONS(7476),
    [anon_sym_STAR] = ACTIONS(7478),
    [anon_sym_SLASH] = ACTIONS(7476),
    [anon_sym_STAR_STAR] = ACTIONS(7476),
    [anon_sym_CARET] = ACTIONS(7476),
    [aux_sym_binary_operator_token1] = ACTIONS(7476),
    [anon_sym_PIPE_GT] = ACTIONS(7476),
    [anon_sym_COLON] = ACTIONS(7478),
    [anon_sym_DOLLAR] = ACTIONS(7476),
    [anon_sym_AT] = ACTIONS(7476),
    [aux_sym__hex_literal_token1] = ACTIONS(7476),
    [sym__number_literal] = ACTIONS(7478),
    [anon_sym_SQUOTE] = ACTIONS(7476),
    [anon_sym_DQUOTE] = ACTIONS(7476),
    [sym_return] = ACTIONS(7478),
    [sym_next] = ACTIONS(7478),
    [sym_break] = ACTIONS(7478),
    [sym_true] = ACTIONS(7478),
    [sym_false] = ACTIONS(7478),
    [sym_null] = ACTIONS(7478),
    [sym_inf] = ACTIONS(7478),
    [sym_nan] = ACTIONS(7478),
    [anon_sym_NA] = ACTIONS(7478),
    [anon_sym_NA_integer_] = ACTIONS(7478),
    [anon_sym_NA_real_] = ACTIONS(7478),
    [anon_sym_NA_complex_] = ACTIONS(7478),
    [anon_sym_NA_character_] = ACTIONS(7478),
    [sym_dots] = ACTIONS(7478),
    [sym_dot_dot_i] = ACTIONS(7476),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7476),
    [sym__newline] = ACTIONS(7476),
    [sym__semicolon] = ACTIONS(7476),
    [sym__raw_string_literal] = ACTIONS(7476),
    [sym__external_open_parenthesis] = ACTIONS(7476),
    [sym__external_close_parenthesis] = ACTIONS(7476),
    [sym__external_open_brace] = ACTIONS(7476),
    [sym__external_close_brace] = ACTIONS(7476),
    [sym__external_open_bracket] = ACTIONS(7476),
    [sym__external_open_bracket2] = ACTIONS(7476),
  },
  [2468] = {
    [ts_builtin_sym_end] = ACTIONS(7480),
    [sym_identifier] = ACTIONS(7482),
    [anon_sym_BSLASH] = ACTIONS(7480),
    [anon_sym_function] = ACTIONS(7482),
    [anon_sym_EQ] = ACTIONS(7482),
    [anon_sym_if] = ACTIONS(7482),
    [anon_sym_for] = ACTIONS(7482),
    [anon_sym_while] = ACTIONS(7482),
    [anon_sym_repeat] = ACTIONS(7482),
    [anon_sym_QMARK] = ACTIONS(7480),
    [anon_sym_TILDE] = ACTIONS(7480),
    [anon_sym_BANG] = ACTIONS(7482),
    [anon_sym_PLUS] = ACTIONS(7480),
    [anon_sym_DASH] = ACTIONS(7482),
    [anon_sym_LT_DASH] = ACTIONS(7480),
    [anon_sym_LT_LT_DASH] = ACTIONS(7480),
    [anon_sym_COLON_EQ] = ACTIONS(7480),
    [anon_sym_DASH_GT] = ACTIONS(7482),
    [anon_sym_DASH_GT_GT] = ACTIONS(7480),
    [anon_sym_PIPE] = ACTIONS(7482),
    [anon_sym_AMP] = ACTIONS(7482),
    [anon_sym_PIPE_PIPE] = ACTIONS(7480),
    [anon_sym_AMP_AMP] = ACTIONS(7480),
    [anon_sym_LT] = ACTIONS(7482),
    [anon_sym_LT_EQ] = ACTIONS(7480),
    [anon_sym_GT] = ACTIONS(7482),
    [anon_sym_GT_EQ] = ACTIONS(7480),
    [anon_sym_EQ_EQ] = ACTIONS(7480),
    [anon_sym_BANG_EQ] = ACTIONS(7480),
    [anon_sym_STAR] = ACTIONS(7482),
    [anon_sym_SLASH] = ACTIONS(7480),
    [anon_sym_STAR_STAR] = ACTIONS(7480),
    [anon_sym_CARET] = ACTIONS(7480),
    [aux_sym_binary_operator_token1] = ACTIONS(7480),
    [anon_sym_PIPE_GT] = ACTIONS(7480),
    [anon_sym_COLON] = ACTIONS(7482),
    [anon_sym_DOLLAR] = ACTIONS(7480),
    [anon_sym_AT] = ACTIONS(7480),
    [aux_sym__hex_literal_token1] = ACTIONS(7480),
    [sym__number_literal] = ACTIONS(7482),
    [anon_sym_SQUOTE] = ACTIONS(7480),
    [anon_sym_DQUOTE] = ACTIONS(7480),
    [sym_return] = ACTIONS(7482),
    [sym_next] = ACTIONS(7482),
    [sym_break] = ACTIONS(7482),
    [sym_true] = ACTIONS(7482),
    [sym_false] = ACTIONS(7482),
    [sym_null] = ACTIONS(7482),
    [sym_inf] = ACTIONS(7482),
    [sym_nan] = ACTIONS(7482),
    [anon_sym_NA] = ACTIONS(7482),
    [anon_sym_NA_integer_] = ACTIONS(7482),
    [anon_sym_NA_real_] = ACTIONS(7482),
    [anon_sym_NA_complex_] = ACTIONS(7482),
    [anon_sym_NA_character_] = ACTIONS(7482),
    [sym_dots] = ACTIONS(7482),
    [sym_dot_dot_i] = ACTIONS(7480),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7480),
    [sym__newline] = ACTIONS(7480),
    [sym__semicolon] = ACTIONS(7480),
    [sym__raw_string_literal] = ACTIONS(7480),
    [sym__external_open_parenthesis] = ACTIONS(7480),
    [sym__external_close_parenthesis] = ACTIONS(7480),
    [sym__external_open_brace] = ACTIONS(7480),
    [sym__external_close_brace] = ACTIONS(7480),
    [sym__external_open_bracket] = ACTIONS(7480),
    [sym__external_open_bracket2] = ACTIONS(7480),
  },
  [2469] = {
    [ts_builtin_sym_end] = ACTIONS(7484),
    [sym_identifier] = ACTIONS(7486),
    [anon_sym_BSLASH] = ACTIONS(7484),
    [anon_sym_function] = ACTIONS(7486),
    [anon_sym_EQ] = ACTIONS(7486),
    [anon_sym_if] = ACTIONS(7486),
    [anon_sym_for] = ACTIONS(7486),
    [anon_sym_while] = ACTIONS(7486),
    [anon_sym_repeat] = ACTIONS(7486),
    [anon_sym_QMARK] = ACTIONS(7484),
    [anon_sym_TILDE] = ACTIONS(7484),
    [anon_sym_BANG] = ACTIONS(7486),
    [anon_sym_PLUS] = ACTIONS(7484),
    [anon_sym_DASH] = ACTIONS(7486),
    [anon_sym_LT_DASH] = ACTIONS(7484),
    [anon_sym_LT_LT_DASH] = ACTIONS(7484),
    [anon_sym_COLON_EQ] = ACTIONS(7484),
    [anon_sym_DASH_GT] = ACTIONS(7486),
    [anon_sym_DASH_GT_GT] = ACTIONS(7484),
    [anon_sym_PIPE] = ACTIONS(7486),
    [anon_sym_AMP] = ACTIONS(7486),
    [anon_sym_PIPE_PIPE] = ACTIONS(7484),
    [anon_sym_AMP_AMP] = ACTIONS(7484),
    [anon_sym_LT] = ACTIONS(7486),
    [anon_sym_LT_EQ] = ACTIONS(7484),
    [anon_sym_GT] = ACTIONS(7486),
    [anon_sym_GT_EQ] = ACTIONS(7484),
    [anon_sym_EQ_EQ] = ACTIONS(7484),
    [anon_sym_BANG_EQ] = ACTIONS(7484),
    [anon_sym_STAR] = ACTIONS(7486),
    [anon_sym_SLASH] = ACTIONS(7484),
    [anon_sym_STAR_STAR] = ACTIONS(7484),
    [anon_sym_CARET] = ACTIONS(7484),
    [aux_sym_binary_operator_token1] = ACTIONS(7484),
    [anon_sym_PIPE_GT] = ACTIONS(7484),
    [anon_sym_COLON] = ACTIONS(7486),
    [anon_sym_DOLLAR] = ACTIONS(7484),
    [anon_sym_AT] = ACTIONS(7484),
    [aux_sym__hex_literal_token1] = ACTIONS(7484),
    [sym__number_literal] = ACTIONS(7486),
    [anon_sym_SQUOTE] = ACTIONS(7484),
    [anon_sym_DQUOTE] = ACTIONS(7484),
    [sym_return] = ACTIONS(7486),
    [sym_next] = ACTIONS(7486),
    [sym_break] = ACTIONS(7486),
    [sym_true] = ACTIONS(7486),
    [sym_false] = ACTIONS(7486),
    [sym_null] = ACTIONS(7486),
    [sym_inf] = ACTIONS(7486),
    [sym_nan] = ACTIONS(7486),
    [anon_sym_NA] = ACTIONS(7486),
    [anon_sym_NA_integer_] = ACTIONS(7486),
    [anon_sym_NA_real_] = ACTIONS(7486),
    [anon_sym_NA_complex_] = ACTIONS(7486),
    [anon_sym_NA_character_] = ACTIONS(7486),
    [sym_dots] = ACTIONS(7486),
    [sym_dot_dot_i] = ACTIONS(7484),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7484),
    [sym__newline] = ACTIONS(7484),
    [sym__semicolon] = ACTIONS(7484),
    [sym__raw_string_literal] = ACTIONS(7484),
    [sym__external_open_parenthesis] = ACTIONS(7484),
    [sym__external_close_parenthesis] = ACTIONS(7484),
    [sym__external_open_brace] = ACTIONS(7484),
    [sym__external_close_brace] = ACTIONS(7484),
    [sym__external_open_bracket] = ACTIONS(7484),
    [sym__external_open_bracket2] = ACTIONS(7484),
  },
  [2470] = {
    [ts_builtin_sym_end] = ACTIONS(7488),
    [sym_identifier] = ACTIONS(7490),
    [anon_sym_BSLASH] = ACTIONS(7488),
    [anon_sym_function] = ACTIONS(7490),
    [anon_sym_EQ] = ACTIONS(7490),
    [anon_sym_if] = ACTIONS(7490),
    [anon_sym_for] = ACTIONS(7490),
    [anon_sym_while] = ACTIONS(7490),
    [anon_sym_repeat] = ACTIONS(7490),
    [anon_sym_QMARK] = ACTIONS(7488),
    [anon_sym_TILDE] = ACTIONS(7488),
    [anon_sym_BANG] = ACTIONS(7490),
    [anon_sym_PLUS] = ACTIONS(7488),
    [anon_sym_DASH] = ACTIONS(7490),
    [anon_sym_LT_DASH] = ACTIONS(7488),
    [anon_sym_LT_LT_DASH] = ACTIONS(7488),
    [anon_sym_COLON_EQ] = ACTIONS(7488),
    [anon_sym_DASH_GT] = ACTIONS(7490),
    [anon_sym_DASH_GT_GT] = ACTIONS(7488),
    [anon_sym_PIPE] = ACTIONS(7490),
    [anon_sym_AMP] = ACTIONS(7490),
    [anon_sym_PIPE_PIPE] = ACTIONS(7488),
    [anon_sym_AMP_AMP] = ACTIONS(7488),
    [anon_sym_LT] = ACTIONS(7490),
    [anon_sym_LT_EQ] = ACTIONS(7488),
    [anon_sym_GT] = ACTIONS(7490),
    [anon_sym_GT_EQ] = ACTIONS(7488),
    [anon_sym_EQ_EQ] = ACTIONS(7488),
    [anon_sym_BANG_EQ] = ACTIONS(7488),
    [anon_sym_STAR] = ACTIONS(7490),
    [anon_sym_SLASH] = ACTIONS(7488),
    [anon_sym_STAR_STAR] = ACTIONS(7488),
    [anon_sym_CARET] = ACTIONS(7488),
    [aux_sym_binary_operator_token1] = ACTIONS(7488),
    [anon_sym_PIPE_GT] = ACTIONS(7488),
    [anon_sym_COLON] = ACTIONS(7490),
    [anon_sym_DOLLAR] = ACTIONS(7488),
    [anon_sym_AT] = ACTIONS(7488),
    [aux_sym__hex_literal_token1] = ACTIONS(7488),
    [sym__number_literal] = ACTIONS(7490),
    [anon_sym_SQUOTE] = ACTIONS(7488),
    [anon_sym_DQUOTE] = ACTIONS(7488),
    [sym_return] = ACTIONS(7490),
    [sym_next] = ACTIONS(7490),
    [sym_break] = ACTIONS(7490),
    [sym_true] = ACTIONS(7490),
    [sym_false] = ACTIONS(7490),
    [sym_null] = ACTIONS(7490),
    [sym_inf] = ACTIONS(7490),
    [sym_nan] = ACTIONS(7490),
    [anon_sym_NA] = ACTIONS(7490),
    [anon_sym_NA_integer_] = ACTIONS(7490),
    [anon_sym_NA_real_] = ACTIONS(7490),
    [anon_sym_NA_complex_] = ACTIONS(7490),
    [anon_sym_NA_character_] = ACTIONS(7490),
    [sym_dots] = ACTIONS(7490),
    [sym_dot_dot_i] = ACTIONS(7488),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7488),
    [sym__newline] = ACTIONS(7488),
    [sym__semicolon] = ACTIONS(7488),
    [sym__raw_string_literal] = ACTIONS(7488),
    [sym__external_open_parenthesis] = ACTIONS(7488),
    [sym__external_close_parenthesis] = ACTIONS(7488),
    [sym__external_open_brace] = ACTIONS(7488),
    [sym__external_close_brace] = ACTIONS(7488),
    [sym__external_open_bracket] = ACTIONS(7488),
    [sym__external_open_bracket2] = ACTIONS(7488),
  },
  [2471] = {
    [ts_builtin_sym_end] = ACTIONS(7492),
    [sym_identifier] = ACTIONS(7494),
    [anon_sym_BSLASH] = ACTIONS(7492),
    [anon_sym_function] = ACTIONS(7494),
    [anon_sym_EQ] = ACTIONS(7494),
    [anon_sym_if] = ACTIONS(7494),
    [anon_sym_for] = ACTIONS(7494),
    [anon_sym_while] = ACTIONS(7494),
    [anon_sym_repeat] = ACTIONS(7494),
    [anon_sym_QMARK] = ACTIONS(7492),
    [anon_sym_TILDE] = ACTIONS(7492),
    [anon_sym_BANG] = ACTIONS(7494),
    [anon_sym_PLUS] = ACTIONS(7492),
    [anon_sym_DASH] = ACTIONS(7494),
    [anon_sym_LT_DASH] = ACTIONS(7492),
    [anon_sym_LT_LT_DASH] = ACTIONS(7492),
    [anon_sym_COLON_EQ] = ACTIONS(7492),
    [anon_sym_DASH_GT] = ACTIONS(7494),
    [anon_sym_DASH_GT_GT] = ACTIONS(7492),
    [anon_sym_PIPE] = ACTIONS(7494),
    [anon_sym_AMP] = ACTIONS(7494),
    [anon_sym_PIPE_PIPE] = ACTIONS(7492),
    [anon_sym_AMP_AMP] = ACTIONS(7492),
    [anon_sym_LT] = ACTIONS(7494),
    [anon_sym_LT_EQ] = ACTIONS(7492),
    [anon_sym_GT] = ACTIONS(7494),
    [anon_sym_GT_EQ] = ACTIONS(7492),
    [anon_sym_EQ_EQ] = ACTIONS(7492),
    [anon_sym_BANG_EQ] = ACTIONS(7492),
    [anon_sym_STAR] = ACTIONS(7494),
    [anon_sym_SLASH] = ACTIONS(7492),
    [anon_sym_STAR_STAR] = ACTIONS(7492),
    [anon_sym_CARET] = ACTIONS(7492),
    [aux_sym_binary_operator_token1] = ACTIONS(7492),
    [anon_sym_PIPE_GT] = ACTIONS(7492),
    [anon_sym_COLON] = ACTIONS(7494),
    [anon_sym_DOLLAR] = ACTIONS(7492),
    [anon_sym_AT] = ACTIONS(7492),
    [aux_sym__hex_literal_token1] = ACTIONS(7492),
    [sym__number_literal] = ACTIONS(7494),
    [anon_sym_SQUOTE] = ACTIONS(7492),
    [anon_sym_DQUOTE] = ACTIONS(7492),
    [sym_return] = ACTIONS(7494),
    [sym_next] = ACTIONS(7494),
    [sym_break] = ACTIONS(7494),
    [sym_true] = ACTIONS(7494),
    [sym_false] = ACTIONS(7494),
    [sym_null] = ACTIONS(7494),
    [sym_inf] = ACTIONS(7494),
    [sym_nan] = ACTIONS(7494),
    [anon_sym_NA] = ACTIONS(7494),
    [anon_sym_NA_integer_] = ACTIONS(7494),
    [anon_sym_NA_real_] = ACTIONS(7494),
    [anon_sym_NA_complex_] = ACTIONS(7494),
    [anon_sym_NA_character_] = ACTIONS(7494),
    [sym_dots] = ACTIONS(7494),
    [sym_dot_dot_i] = ACTIONS(7492),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7492),
    [sym__newline] = ACTIONS(7492),
    [sym__semicolon] = ACTIONS(7492),
    [sym__raw_string_literal] = ACTIONS(7492),
    [sym__external_open_parenthesis] = ACTIONS(7492),
    [sym__external_close_parenthesis] = ACTIONS(7492),
    [sym__external_open_brace] = ACTIONS(7492),
    [sym__external_close_brace] = ACTIONS(7492),
    [sym__external_open_bracket] = ACTIONS(7492),
    [sym__external_open_bracket2] = ACTIONS(7492),
  },
  [2472] = {
    [ts_builtin_sym_end] = ACTIONS(7496),
    [sym_identifier] = ACTIONS(7498),
    [anon_sym_BSLASH] = ACTIONS(7496),
    [anon_sym_function] = ACTIONS(7498),
    [anon_sym_EQ] = ACTIONS(7498),
    [anon_sym_if] = ACTIONS(7498),
    [anon_sym_for] = ACTIONS(7498),
    [anon_sym_while] = ACTIONS(7498),
    [anon_sym_repeat] = ACTIONS(7498),
    [anon_sym_QMARK] = ACTIONS(7496),
    [anon_sym_TILDE] = ACTIONS(7496),
    [anon_sym_BANG] = ACTIONS(7498),
    [anon_sym_PLUS] = ACTIONS(7496),
    [anon_sym_DASH] = ACTIONS(7498),
    [anon_sym_LT_DASH] = ACTIONS(7496),
    [anon_sym_LT_LT_DASH] = ACTIONS(7496),
    [anon_sym_COLON_EQ] = ACTIONS(7496),
    [anon_sym_DASH_GT] = ACTIONS(7498),
    [anon_sym_DASH_GT_GT] = ACTIONS(7496),
    [anon_sym_PIPE] = ACTIONS(7498),
    [anon_sym_AMP] = ACTIONS(7498),
    [anon_sym_PIPE_PIPE] = ACTIONS(7496),
    [anon_sym_AMP_AMP] = ACTIONS(7496),
    [anon_sym_LT] = ACTIONS(7498),
    [anon_sym_LT_EQ] = ACTIONS(7496),
    [anon_sym_GT] = ACTIONS(7498),
    [anon_sym_GT_EQ] = ACTIONS(7496),
    [anon_sym_EQ_EQ] = ACTIONS(7496),
    [anon_sym_BANG_EQ] = ACTIONS(7496),
    [anon_sym_STAR] = ACTIONS(7498),
    [anon_sym_SLASH] = ACTIONS(7496),
    [anon_sym_STAR_STAR] = ACTIONS(7496),
    [anon_sym_CARET] = ACTIONS(7496),
    [aux_sym_binary_operator_token1] = ACTIONS(7496),
    [anon_sym_PIPE_GT] = ACTIONS(7496),
    [anon_sym_COLON] = ACTIONS(7498),
    [anon_sym_DOLLAR] = ACTIONS(7496),
    [anon_sym_AT] = ACTIONS(7496),
    [aux_sym__hex_literal_token1] = ACTIONS(7496),
    [sym__number_literal] = ACTIONS(7498),
    [anon_sym_SQUOTE] = ACTIONS(7496),
    [anon_sym_DQUOTE] = ACTIONS(7496),
    [sym_return] = ACTIONS(7498),
    [sym_next] = ACTIONS(7498),
    [sym_break] = ACTIONS(7498),
    [sym_true] = ACTIONS(7498),
    [sym_false] = ACTIONS(7498),
    [sym_null] = ACTIONS(7498),
    [sym_inf] = ACTIONS(7498),
    [sym_nan] = ACTIONS(7498),
    [anon_sym_NA] = ACTIONS(7498),
    [anon_sym_NA_integer_] = ACTIONS(7498),
    [anon_sym_NA_real_] = ACTIONS(7498),
    [anon_sym_NA_complex_] = ACTIONS(7498),
    [anon_sym_NA_character_] = ACTIONS(7498),
    [sym_dots] = ACTIONS(7498),
    [sym_dot_dot_i] = ACTIONS(7496),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7496),
    [sym__newline] = ACTIONS(7496),
    [sym__semicolon] = ACTIONS(7496),
    [sym__raw_string_literal] = ACTIONS(7496),
    [sym__external_open_parenthesis] = ACTIONS(7496),
    [sym__external_close_parenthesis] = ACTIONS(7496),
    [sym__external_open_brace] = ACTIONS(7496),
    [sym__external_close_brace] = ACTIONS(7496),
    [sym__external_open_bracket] = ACTIONS(7496),
    [sym__external_open_bracket2] = ACTIONS(7496),
  },
  [2473] = {
    [sym_identifier] = ACTIONS(7482),
    [anon_sym_BSLASH] = ACTIONS(7480),
    [anon_sym_function] = ACTIONS(7482),
    [anon_sym_EQ] = ACTIONS(7482),
    [anon_sym_if] = ACTIONS(7482),
    [anon_sym_for] = ACTIONS(7482),
    [anon_sym_while] = ACTIONS(7482),
    [anon_sym_repeat] = ACTIONS(7482),
    [anon_sym_QMARK] = ACTIONS(7480),
    [anon_sym_TILDE] = ACTIONS(7480),
    [anon_sym_BANG] = ACTIONS(7482),
    [anon_sym_PLUS] = ACTIONS(7480),
    [anon_sym_DASH] = ACTIONS(7482),
    [anon_sym_LT_DASH] = ACTIONS(7480),
    [anon_sym_LT_LT_DASH] = ACTIONS(7480),
    [anon_sym_COLON_EQ] = ACTIONS(7480),
    [anon_sym_DASH_GT] = ACTIONS(7482),
    [anon_sym_DASH_GT_GT] = ACTIONS(7480),
    [anon_sym_PIPE] = ACTIONS(7482),
    [anon_sym_AMP] = ACTIONS(7482),
    [anon_sym_PIPE_PIPE] = ACTIONS(7480),
    [anon_sym_AMP_AMP] = ACTIONS(7480),
    [anon_sym_LT] = ACTIONS(7482),
    [anon_sym_LT_EQ] = ACTIONS(7480),
    [anon_sym_GT] = ACTIONS(7482),
    [anon_sym_GT_EQ] = ACTIONS(7480),
    [anon_sym_EQ_EQ] = ACTIONS(7480),
    [anon_sym_BANG_EQ] = ACTIONS(7480),
    [anon_sym_STAR] = ACTIONS(7482),
    [anon_sym_SLASH] = ACTIONS(7480),
    [anon_sym_STAR_STAR] = ACTIONS(7480),
    [anon_sym_CARET] = ACTIONS(7480),
    [aux_sym_binary_operator_token1] = ACTIONS(7480),
    [anon_sym_PIPE_GT] = ACTIONS(7480),
    [anon_sym_COLON] = ACTIONS(7482),
    [anon_sym_DOLLAR] = ACTIONS(7480),
    [anon_sym_AT] = ACTIONS(7480),
    [aux_sym__hex_literal_token1] = ACTIONS(7480),
    [sym__number_literal] = ACTIONS(7482),
    [anon_sym_SQUOTE] = ACTIONS(7480),
    [anon_sym_DQUOTE] = ACTIONS(7480),
    [sym_return] = ACTIONS(7482),
    [sym_next] = ACTIONS(7482),
    [sym_break] = ACTIONS(7482),
    [sym_true] = ACTIONS(7482),
    [sym_false] = ACTIONS(7482),
    [sym_null] = ACTIONS(7482),
    [sym_inf] = ACTIONS(7482),
    [sym_nan] = ACTIONS(7482),
    [anon_sym_NA] = ACTIONS(7482),
    [anon_sym_NA_integer_] = ACTIONS(7482),
    [anon_sym_NA_real_] = ACTIONS(7482),
    [anon_sym_NA_complex_] = ACTIONS(7482),
    [anon_sym_NA_character_] = ACTIONS(7482),
    [sym_dots] = ACTIONS(7482),
    [sym_dot_dot_i] = ACTIONS(7480),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7480),
    [sym__newline] = ACTIONS(7480),
    [sym__semicolon] = ACTIONS(7480),
    [sym__raw_string_literal] = ACTIONS(7480),
    [sym__external_else] = ACTIONS(7480),
    [sym__external_open_parenthesis] = ACTIONS(7480),
    [sym__external_open_brace] = ACTIONS(7480),
    [sym__external_close_brace] = ACTIONS(7480),
    [sym__external_open_bracket] = ACTIONS(7480),
    [sym__external_close_bracket] = ACTIONS(7480),
    [sym__external_open_bracket2] = ACTIONS(7480),
  },
  [2474] = {
    [sym_identifier] = ACTIONS(7478),
    [anon_sym_BSLASH] = ACTIONS(7476),
    [anon_sym_function] = ACTIONS(7478),
    [anon_sym_EQ] = ACTIONS(7478),
    [anon_sym_if] = ACTIONS(7478),
    [anon_sym_for] = ACTIONS(7478),
    [anon_sym_while] = ACTIONS(7478),
    [anon_sym_repeat] = ACTIONS(7478),
    [anon_sym_QMARK] = ACTIONS(7476),
    [anon_sym_TILDE] = ACTIONS(7476),
    [anon_sym_BANG] = ACTIONS(7478),
    [anon_sym_PLUS] = ACTIONS(7476),
    [anon_sym_DASH] = ACTIONS(7478),
    [anon_sym_LT_DASH] = ACTIONS(7476),
    [anon_sym_LT_LT_DASH] = ACTIONS(7476),
    [anon_sym_COLON_EQ] = ACTIONS(7476),
    [anon_sym_DASH_GT] = ACTIONS(7478),
    [anon_sym_DASH_GT_GT] = ACTIONS(7476),
    [anon_sym_PIPE] = ACTIONS(7478),
    [anon_sym_AMP] = ACTIONS(7478),
    [anon_sym_PIPE_PIPE] = ACTIONS(7476),
    [anon_sym_AMP_AMP] = ACTIONS(7476),
    [anon_sym_LT] = ACTIONS(7478),
    [anon_sym_LT_EQ] = ACTIONS(7476),
    [anon_sym_GT] = ACTIONS(7478),
    [anon_sym_GT_EQ] = ACTIONS(7476),
    [anon_sym_EQ_EQ] = ACTIONS(7476),
    [anon_sym_BANG_EQ] = ACTIONS(7476),
    [anon_sym_STAR] = ACTIONS(7478),
    [anon_sym_SLASH] = ACTIONS(7476),
    [anon_sym_STAR_STAR] = ACTIONS(7476),
    [anon_sym_CARET] = ACTIONS(7476),
    [aux_sym_binary_operator_token1] = ACTIONS(7476),
    [anon_sym_PIPE_GT] = ACTIONS(7476),
    [anon_sym_COLON] = ACTIONS(7478),
    [anon_sym_DOLLAR] = ACTIONS(7476),
    [anon_sym_AT] = ACTIONS(7476),
    [aux_sym__hex_literal_token1] = ACTIONS(7476),
    [sym__number_literal] = ACTIONS(7478),
    [anon_sym_SQUOTE] = ACTIONS(7476),
    [anon_sym_DQUOTE] = ACTIONS(7476),
    [sym_return] = ACTIONS(7478),
    [sym_next] = ACTIONS(7478),
    [sym_break] = ACTIONS(7478),
    [sym_true] = ACTIONS(7478),
    [sym_false] = ACTIONS(7478),
    [sym_null] = ACTIONS(7478),
    [sym_inf] = ACTIONS(7478),
    [sym_nan] = ACTIONS(7478),
    [anon_sym_NA] = ACTIONS(7478),
    [anon_sym_NA_integer_] = ACTIONS(7478),
    [anon_sym_NA_real_] = ACTIONS(7478),
    [anon_sym_NA_complex_] = ACTIONS(7478),
    [anon_sym_NA_character_] = ACTIONS(7478),
    [sym_dots] = ACTIONS(7478),
    [sym_dot_dot_i] = ACTIONS(7476),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7476),
    [sym__newline] = ACTIONS(7476),
    [sym__semicolon] = ACTIONS(7476),
    [sym__raw_string_literal] = ACTIONS(7476),
    [sym__external_else] = ACTIONS(7476),
    [sym__external_open_parenthesis] = ACTIONS(7476),
    [sym__external_open_brace] = ACTIONS(7476),
    [sym__external_close_brace] = ACTIONS(7476),
    [sym__external_open_bracket] = ACTIONS(7476),
    [sym__external_close_bracket] = ACTIONS(7476),
    [sym__external_open_bracket2] = ACTIONS(7476),
  },
  [2475] = {
    [sym_identifier] = ACTIONS(7464),
    [anon_sym_BSLASH] = ACTIONS(7466),
    [anon_sym_function] = ACTIONS(7464),
    [anon_sym_EQ] = ACTIONS(7464),
    [anon_sym_if] = ACTIONS(7464),
    [anon_sym_for] = ACTIONS(7464),
    [anon_sym_while] = ACTIONS(7464),
    [anon_sym_repeat] = ACTIONS(7464),
    [anon_sym_QMARK] = ACTIONS(7466),
    [anon_sym_TILDE] = ACTIONS(7466),
    [anon_sym_BANG] = ACTIONS(7464),
    [anon_sym_PLUS] = ACTIONS(7466),
    [anon_sym_DASH] = ACTIONS(7464),
    [anon_sym_LT_DASH] = ACTIONS(7466),
    [anon_sym_LT_LT_DASH] = ACTIONS(7466),
    [anon_sym_COLON_EQ] = ACTIONS(7466),
    [anon_sym_DASH_GT] = ACTIONS(7464),
    [anon_sym_DASH_GT_GT] = ACTIONS(7466),
    [anon_sym_PIPE] = ACTIONS(7464),
    [anon_sym_AMP] = ACTIONS(7464),
    [anon_sym_PIPE_PIPE] = ACTIONS(7466),
    [anon_sym_AMP_AMP] = ACTIONS(7466),
    [anon_sym_LT] = ACTIONS(7464),
    [anon_sym_LT_EQ] = ACTIONS(7466),
    [anon_sym_GT] = ACTIONS(7464),
    [anon_sym_GT_EQ] = ACTIONS(7466),
    [anon_sym_EQ_EQ] = ACTIONS(7466),
    [anon_sym_BANG_EQ] = ACTIONS(7466),
    [anon_sym_STAR] = ACTIONS(7464),
    [anon_sym_SLASH] = ACTIONS(7466),
    [anon_sym_STAR_STAR] = ACTIONS(7466),
    [anon_sym_CARET] = ACTIONS(7466),
    [aux_sym_binary_operator_token1] = ACTIONS(7466),
    [anon_sym_PIPE_GT] = ACTIONS(7466),
    [anon_sym_COLON] = ACTIONS(7464),
    [anon_sym_DOLLAR] = ACTIONS(7466),
    [anon_sym_AT] = ACTIONS(7466),
    [aux_sym__hex_literal_token1] = ACTIONS(7466),
    [sym__number_literal] = ACTIONS(7464),
    [anon_sym_SQUOTE] = ACTIONS(7466),
    [anon_sym_DQUOTE] = ACTIONS(7466),
    [sym_return] = ACTIONS(7464),
    [sym_next] = ACTIONS(7464),
    [sym_break] = ACTIONS(7464),
    [sym_true] = ACTIONS(7464),
    [sym_false] = ACTIONS(7464),
    [sym_null] = ACTIONS(7464),
    [sym_inf] = ACTIONS(7464),
    [sym_nan] = ACTIONS(7464),
    [anon_sym_NA] = ACTIONS(7464),
    [anon_sym_NA_integer_] = ACTIONS(7464),
    [anon_sym_NA_real_] = ACTIONS(7464),
    [anon_sym_NA_complex_] = ACTIONS(7464),
    [anon_sym_NA_character_] = ACTIONS(7464),
    [sym_dots] = ACTIONS(7464),
    [sym_dot_dot_i] = ACTIONS(7466),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7466),
    [sym__newline] = ACTIONS(7466),
    [sym__semicolon] = ACTIONS(7466),
    [sym__raw_string_literal] = ACTIONS(7466),
    [sym__external_else] = ACTIONS(7466),
    [sym__external_open_parenthesis] = ACTIONS(7466),
    [sym__external_open_brace] = ACTIONS(7466),
    [sym__external_close_brace] = ACTIONS(7466),
    [sym__external_open_bracket] = ACTIONS(7466),
    [sym__external_close_bracket] = ACTIONS(7466),
    [sym__external_open_bracket2] = ACTIONS(7466),
  },
  [2476] = {
    [sym_identifier] = ACTIONS(7474),
    [anon_sym_BSLASH] = ACTIONS(7472),
    [anon_sym_function] = ACTIONS(7474),
    [anon_sym_EQ] = ACTIONS(7474),
    [anon_sym_if] = ACTIONS(7474),
    [anon_sym_for] = ACTIONS(7474),
    [anon_sym_while] = ACTIONS(7474),
    [anon_sym_repeat] = ACTIONS(7474),
    [anon_sym_QMARK] = ACTIONS(7472),
    [anon_sym_TILDE] = ACTIONS(7472),
    [anon_sym_BANG] = ACTIONS(7474),
    [anon_sym_PLUS] = ACTIONS(7472),
    [anon_sym_DASH] = ACTIONS(7474),
    [anon_sym_LT_DASH] = ACTIONS(7472),
    [anon_sym_LT_LT_DASH] = ACTIONS(7472),
    [anon_sym_COLON_EQ] = ACTIONS(7472),
    [anon_sym_DASH_GT] = ACTIONS(7474),
    [anon_sym_DASH_GT_GT] = ACTIONS(7472),
    [anon_sym_PIPE] = ACTIONS(7474),
    [anon_sym_AMP] = ACTIONS(7474),
    [anon_sym_PIPE_PIPE] = ACTIONS(7472),
    [anon_sym_AMP_AMP] = ACTIONS(7472),
    [anon_sym_LT] = ACTIONS(7474),
    [anon_sym_LT_EQ] = ACTIONS(7472),
    [anon_sym_GT] = ACTIONS(7474),
    [anon_sym_GT_EQ] = ACTIONS(7472),
    [anon_sym_EQ_EQ] = ACTIONS(7472),
    [anon_sym_BANG_EQ] = ACTIONS(7472),
    [anon_sym_STAR] = ACTIONS(7474),
    [anon_sym_SLASH] = ACTIONS(7472),
    [anon_sym_STAR_STAR] = ACTIONS(7472),
    [anon_sym_CARET] = ACTIONS(7472),
    [aux_sym_binary_operator_token1] = ACTIONS(7472),
    [anon_sym_PIPE_GT] = ACTIONS(7472),
    [anon_sym_COLON] = ACTIONS(7474),
    [anon_sym_DOLLAR] = ACTIONS(7472),
    [anon_sym_AT] = ACTIONS(7472),
    [aux_sym__hex_literal_token1] = ACTIONS(7472),
    [sym__number_literal] = ACTIONS(7474),
    [anon_sym_SQUOTE] = ACTIONS(7472),
    [anon_sym_DQUOTE] = ACTIONS(7472),
    [sym_return] = ACTIONS(7474),
    [sym_next] = ACTIONS(7474),
    [sym_break] = ACTIONS(7474),
    [sym_true] = ACTIONS(7474),
    [sym_false] = ACTIONS(7474),
    [sym_null] = ACTIONS(7474),
    [sym_inf] = ACTIONS(7474),
    [sym_nan] = ACTIONS(7474),
    [anon_sym_NA] = ACTIONS(7474),
    [anon_sym_NA_integer_] = ACTIONS(7474),
    [anon_sym_NA_real_] = ACTIONS(7474),
    [anon_sym_NA_complex_] = ACTIONS(7474),
    [anon_sym_NA_character_] = ACTIONS(7474),
    [sym_dots] = ACTIONS(7474),
    [sym_dot_dot_i] = ACTIONS(7472),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7472),
    [sym__newline] = ACTIONS(7472),
    [sym__semicolon] = ACTIONS(7472),
    [sym__raw_string_literal] = ACTIONS(7472),
    [sym__external_else] = ACTIONS(7472),
    [sym__external_open_parenthesis] = ACTIONS(7472),
    [sym__external_open_brace] = ACTIONS(7472),
    [sym__external_close_brace] = ACTIONS(7472),
    [sym__external_open_bracket] = ACTIONS(7472),
    [sym__external_close_bracket] = ACTIONS(7472),
    [sym__external_open_bracket2] = ACTIONS(7472),
  },
  [2477] = {
    [sym_identifier] = ACTIONS(7556),
    [anon_sym_BSLASH] = ACTIONS(7554),
    [anon_sym_function] = ACTIONS(7556),
    [anon_sym_EQ] = ACTIONS(7556),
    [anon_sym_if] = ACTIONS(7556),
    [anon_sym_for] = ACTIONS(7556),
    [anon_sym_while] = ACTIONS(7556),
    [anon_sym_repeat] = ACTIONS(7556),
    [anon_sym_QMARK] = ACTIONS(7554),
    [anon_sym_TILDE] = ACTIONS(7554),
    [anon_sym_BANG] = ACTIONS(7556),
    [anon_sym_PLUS] = ACTIONS(7554),
    [anon_sym_DASH] = ACTIONS(7556),
    [anon_sym_LT_DASH] = ACTIONS(7554),
    [anon_sym_LT_LT_DASH] = ACTIONS(7554),
    [anon_sym_COLON_EQ] = ACTIONS(7554),
    [anon_sym_DASH_GT] = ACTIONS(7556),
    [anon_sym_DASH_GT_GT] = ACTIONS(7554),
    [anon_sym_PIPE] = ACTIONS(7556),
    [anon_sym_AMP] = ACTIONS(7556),
    [anon_sym_PIPE_PIPE] = ACTIONS(7554),
    [anon_sym_AMP_AMP] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(7556),
    [anon_sym_LT_EQ] = ACTIONS(7554),
    [anon_sym_GT] = ACTIONS(7556),
    [anon_sym_GT_EQ] = ACTIONS(7554),
    [anon_sym_EQ_EQ] = ACTIONS(7554),
    [anon_sym_BANG_EQ] = ACTIONS(7554),
    [anon_sym_STAR] = ACTIONS(7556),
    [anon_sym_SLASH] = ACTIONS(7554),
    [anon_sym_STAR_STAR] = ACTIONS(7554),
    [anon_sym_CARET] = ACTIONS(7554),
    [aux_sym_binary_operator_token1] = ACTIONS(7554),
    [anon_sym_PIPE_GT] = ACTIONS(7554),
    [anon_sym_COLON] = ACTIONS(7556),
    [anon_sym_DOLLAR] = ACTIONS(7554),
    [anon_sym_AT] = ACTIONS(7554),
    [aux_sym__hex_literal_token1] = ACTIONS(7554),
    [sym__number_literal] = ACTIONS(7556),
    [anon_sym_SQUOTE] = ACTIONS(7554),
    [anon_sym_DQUOTE] = ACTIONS(7554),
    [sym_return] = ACTIONS(7556),
    [sym_next] = ACTIONS(7556),
    [sym_break] = ACTIONS(7556),
    [sym_true] = ACTIONS(7556),
    [sym_false] = ACTIONS(7556),
    [sym_null] = ACTIONS(7556),
    [sym_inf] = ACTIONS(7556),
    [sym_nan] = ACTIONS(7556),
    [anon_sym_NA] = ACTIONS(7556),
    [anon_sym_NA_integer_] = ACTIONS(7556),
    [anon_sym_NA_real_] = ACTIONS(7556),
    [anon_sym_NA_complex_] = ACTIONS(7556),
    [anon_sym_NA_character_] = ACTIONS(7556),
    [sym_dots] = ACTIONS(7556),
    [sym_dot_dot_i] = ACTIONS(7554),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7554),
    [sym__newline] = ACTIONS(7554),
    [sym__semicolon] = ACTIONS(7554),
    [sym__raw_string_literal] = ACTIONS(7554),
    [sym__external_else] = ACTIONS(7554),
    [sym__external_open_parenthesis] = ACTIONS(7554),
    [sym__external_open_brace] = ACTIONS(7554),
    [sym__external_close_brace] = ACTIONS(7554),
    [sym__external_open_bracket] = ACTIONS(7554),
    [sym__external_open_bracket2] = ACTIONS(7554),
    [sym__external_close_bracket2] = ACTIONS(7554),
  },
  [2478] = {
    [sym_identifier] = ACTIONS(7115),
    [anon_sym_BSLASH] = ACTIONS(7117),
    [anon_sym_function] = ACTIONS(7115),
    [anon_sym_EQ] = ACTIONS(7115),
    [anon_sym_if] = ACTIONS(7115),
    [anon_sym_for] = ACTIONS(7115),
    [anon_sym_while] = ACTIONS(7115),
    [anon_sym_repeat] = ACTIONS(7115),
    [anon_sym_QMARK] = ACTIONS(7117),
    [anon_sym_TILDE] = ACTIONS(7117),
    [anon_sym_BANG] = ACTIONS(7115),
    [anon_sym_PLUS] = ACTIONS(7117),
    [anon_sym_DASH] = ACTIONS(7115),
    [anon_sym_LT_DASH] = ACTIONS(7117),
    [anon_sym_LT_LT_DASH] = ACTIONS(7117),
    [anon_sym_COLON_EQ] = ACTIONS(7117),
    [anon_sym_DASH_GT] = ACTIONS(7115),
    [anon_sym_DASH_GT_GT] = ACTIONS(7117),
    [anon_sym_PIPE] = ACTIONS(7115),
    [anon_sym_AMP] = ACTIONS(7115),
    [anon_sym_PIPE_PIPE] = ACTIONS(7117),
    [anon_sym_AMP_AMP] = ACTIONS(7117),
    [anon_sym_LT] = ACTIONS(7115),
    [anon_sym_LT_EQ] = ACTIONS(7117),
    [anon_sym_GT] = ACTIONS(7115),
    [anon_sym_GT_EQ] = ACTIONS(7117),
    [anon_sym_EQ_EQ] = ACTIONS(7117),
    [anon_sym_BANG_EQ] = ACTIONS(7117),
    [anon_sym_STAR] = ACTIONS(7115),
    [anon_sym_SLASH] = ACTIONS(7117),
    [anon_sym_STAR_STAR] = ACTIONS(7117),
    [anon_sym_CARET] = ACTIONS(7117),
    [aux_sym_binary_operator_token1] = ACTIONS(7117),
    [anon_sym_PIPE_GT] = ACTIONS(7117),
    [anon_sym_COLON] = ACTIONS(7115),
    [anon_sym_DOLLAR] = ACTIONS(7117),
    [anon_sym_AT] = ACTIONS(7117),
    [anon_sym_COLON_COLON] = ACTIONS(7115),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7117),
    [aux_sym__hex_literal_token1] = ACTIONS(7117),
    [sym__number_literal] = ACTIONS(7115),
    [anon_sym_SQUOTE] = ACTIONS(7117),
    [anon_sym_DQUOTE] = ACTIONS(7117),
    [sym_return] = ACTIONS(7115),
    [sym_next] = ACTIONS(7115),
    [sym_break] = ACTIONS(7115),
    [sym_true] = ACTIONS(7115),
    [sym_false] = ACTIONS(7115),
    [sym_null] = ACTIONS(7115),
    [sym_inf] = ACTIONS(7115),
    [sym_nan] = ACTIONS(7115),
    [anon_sym_NA] = ACTIONS(7115),
    [anon_sym_NA_integer_] = ACTIONS(7115),
    [anon_sym_NA_real_] = ACTIONS(7115),
    [anon_sym_NA_complex_] = ACTIONS(7115),
    [anon_sym_NA_character_] = ACTIONS(7115),
    [sym_dots] = ACTIONS(7115),
    [sym_dot_dot_i] = ACTIONS(7117),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7117),
    [sym__newline] = ACTIONS(7117),
    [sym__raw_string_literal] = ACTIONS(7117),
    [sym__external_else] = ACTIONS(7117),
    [sym__external_open_parenthesis] = ACTIONS(7117),
    [sym__external_open_brace] = ACTIONS(7117),
    [sym__external_open_bracket] = ACTIONS(7117),
    [sym__external_close_bracket] = ACTIONS(7117),
    [sym__external_open_bracket2] = ACTIONS(7117),
  },
  [2479] = {
    [ts_builtin_sym_end] = ACTIONS(7165),
    [sym_identifier] = ACTIONS(7163),
    [anon_sym_BSLASH] = ACTIONS(7165),
    [anon_sym_function] = ACTIONS(7163),
    [anon_sym_EQ] = ACTIONS(7163),
    [anon_sym_if] = ACTIONS(7163),
    [anon_sym_for] = ACTIONS(7163),
    [anon_sym_while] = ACTIONS(7163),
    [anon_sym_repeat] = ACTIONS(7163),
    [anon_sym_QMARK] = ACTIONS(7165),
    [anon_sym_TILDE] = ACTIONS(7165),
    [anon_sym_BANG] = ACTIONS(7163),
    [anon_sym_PLUS] = ACTIONS(7165),
    [anon_sym_DASH] = ACTIONS(7163),
    [anon_sym_LT_DASH] = ACTIONS(7165),
    [anon_sym_LT_LT_DASH] = ACTIONS(7165),
    [anon_sym_COLON_EQ] = ACTIONS(7165),
    [anon_sym_DASH_GT] = ACTIONS(7163),
    [anon_sym_DASH_GT_GT] = ACTIONS(7165),
    [anon_sym_PIPE] = ACTIONS(7163),
    [anon_sym_AMP] = ACTIONS(7163),
    [anon_sym_PIPE_PIPE] = ACTIONS(7165),
    [anon_sym_AMP_AMP] = ACTIONS(7165),
    [anon_sym_LT] = ACTIONS(7163),
    [anon_sym_LT_EQ] = ACTIONS(7165),
    [anon_sym_GT] = ACTIONS(7163),
    [anon_sym_GT_EQ] = ACTIONS(7165),
    [anon_sym_EQ_EQ] = ACTIONS(7165),
    [anon_sym_BANG_EQ] = ACTIONS(7165),
    [anon_sym_STAR] = ACTIONS(7163),
    [anon_sym_SLASH] = ACTIONS(7165),
    [anon_sym_STAR_STAR] = ACTIONS(7165),
    [anon_sym_CARET] = ACTIONS(7165),
    [aux_sym_binary_operator_token1] = ACTIONS(7165),
    [anon_sym_PIPE_GT] = ACTIONS(7165),
    [anon_sym_COLON] = ACTIONS(7163),
    [anon_sym_DOLLAR] = ACTIONS(7165),
    [anon_sym_AT] = ACTIONS(7165),
    [anon_sym_COLON_COLON] = ACTIONS(7163),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7165),
    [aux_sym__hex_literal_token1] = ACTIONS(7165),
    [sym__number_literal] = ACTIONS(7163),
    [anon_sym_SQUOTE] = ACTIONS(7165),
    [anon_sym_DQUOTE] = ACTIONS(7165),
    [sym_return] = ACTIONS(7163),
    [sym_next] = ACTIONS(7163),
    [sym_break] = ACTIONS(7163),
    [sym_true] = ACTIONS(7163),
    [sym_false] = ACTIONS(7163),
    [sym_null] = ACTIONS(7163),
    [sym_inf] = ACTIONS(7163),
    [sym_nan] = ACTIONS(7163),
    [anon_sym_NA] = ACTIONS(7163),
    [anon_sym_NA_integer_] = ACTIONS(7163),
    [anon_sym_NA_real_] = ACTIONS(7163),
    [anon_sym_NA_complex_] = ACTIONS(7163),
    [anon_sym_NA_character_] = ACTIONS(7163),
    [sym_dots] = ACTIONS(7163),
    [sym_dot_dot_i] = ACTIONS(7165),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7165),
    [sym__semicolon] = ACTIONS(7165),
    [sym__raw_string_literal] = ACTIONS(7165),
    [sym__external_open_parenthesis] = ACTIONS(7165),
    [sym__external_open_brace] = ACTIONS(7165),
    [sym__external_close_brace] = ACTIONS(7165),
    [sym__external_open_bracket] = ACTIONS(7165),
    [sym__external_open_bracket2] = ACTIONS(7165),
  },
  [2480] = {
    [ts_builtin_sym_end] = ACTIONS(7500),
    [sym_identifier] = ACTIONS(7502),
    [anon_sym_BSLASH] = ACTIONS(7500),
    [anon_sym_function] = ACTIONS(7502),
    [anon_sym_EQ] = ACTIONS(7502),
    [anon_sym_if] = ACTIONS(7502),
    [anon_sym_for] = ACTIONS(7502),
    [anon_sym_while] = ACTIONS(7502),
    [anon_sym_repeat] = ACTIONS(7502),
    [anon_sym_QMARK] = ACTIONS(7500),
    [anon_sym_TILDE] = ACTIONS(7500),
    [anon_sym_BANG] = ACTIONS(7502),
    [anon_sym_PLUS] = ACTIONS(7500),
    [anon_sym_DASH] = ACTIONS(7502),
    [anon_sym_LT_DASH] = ACTIONS(7500),
    [anon_sym_LT_LT_DASH] = ACTIONS(7500),
    [anon_sym_COLON_EQ] = ACTIONS(7500),
    [anon_sym_DASH_GT] = ACTIONS(7502),
    [anon_sym_DASH_GT_GT] = ACTIONS(7500),
    [anon_sym_PIPE] = ACTIONS(7502),
    [anon_sym_AMP] = ACTIONS(7502),
    [anon_sym_PIPE_PIPE] = ACTIONS(7500),
    [anon_sym_AMP_AMP] = ACTIONS(7500),
    [anon_sym_LT] = ACTIONS(7502),
    [anon_sym_LT_EQ] = ACTIONS(7500),
    [anon_sym_GT] = ACTIONS(7502),
    [anon_sym_GT_EQ] = ACTIONS(7500),
    [anon_sym_EQ_EQ] = ACTIONS(7500),
    [anon_sym_BANG_EQ] = ACTIONS(7500),
    [anon_sym_STAR] = ACTIONS(7502),
    [anon_sym_SLASH] = ACTIONS(7500),
    [anon_sym_STAR_STAR] = ACTIONS(7500),
    [anon_sym_CARET] = ACTIONS(7500),
    [aux_sym_binary_operator_token1] = ACTIONS(7500),
    [anon_sym_PIPE_GT] = ACTIONS(7500),
    [anon_sym_COLON] = ACTIONS(7502),
    [anon_sym_DOLLAR] = ACTIONS(7500),
    [anon_sym_AT] = ACTIONS(7500),
    [aux_sym__hex_literal_token1] = ACTIONS(7500),
    [sym__number_literal] = ACTIONS(7502),
    [anon_sym_SQUOTE] = ACTIONS(7500),
    [anon_sym_DQUOTE] = ACTIONS(7500),
    [sym_return] = ACTIONS(7502),
    [sym_next] = ACTIONS(7502),
    [sym_break] = ACTIONS(7502),
    [sym_true] = ACTIONS(7502),
    [sym_false] = ACTIONS(7502),
    [sym_null] = ACTIONS(7502),
    [sym_inf] = ACTIONS(7502),
    [sym_nan] = ACTIONS(7502),
    [anon_sym_NA] = ACTIONS(7502),
    [anon_sym_NA_integer_] = ACTIONS(7502),
    [anon_sym_NA_real_] = ACTIONS(7502),
    [anon_sym_NA_complex_] = ACTIONS(7502),
    [anon_sym_NA_character_] = ACTIONS(7502),
    [sym_dots] = ACTIONS(7502),
    [sym_dot_dot_i] = ACTIONS(7500),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7500),
    [sym__newline] = ACTIONS(7500),
    [sym__semicolon] = ACTIONS(7500),
    [sym__raw_string_literal] = ACTIONS(7500),
    [sym__external_open_parenthesis] = ACTIONS(7500),
    [sym__external_close_parenthesis] = ACTIONS(7500),
    [sym__external_open_brace] = ACTIONS(7500),
    [sym__external_close_brace] = ACTIONS(7500),
    [sym__external_open_bracket] = ACTIONS(7500),
    [sym__external_open_bracket2] = ACTIONS(7500),
  },
  [2481] = {
    [ts_builtin_sym_end] = ACTIONS(7165),
    [sym_identifier] = ACTIONS(7163),
    [anon_sym_BSLASH] = ACTIONS(7165),
    [anon_sym_function] = ACTIONS(7163),
    [anon_sym_EQ] = ACTIONS(7163),
    [anon_sym_if] = ACTIONS(7163),
    [anon_sym_for] = ACTIONS(7163),
    [anon_sym_while] = ACTIONS(7163),
    [anon_sym_repeat] = ACTIONS(7163),
    [anon_sym_QMARK] = ACTIONS(7165),
    [anon_sym_TILDE] = ACTIONS(7165),
    [anon_sym_BANG] = ACTIONS(7163),
    [anon_sym_PLUS] = ACTIONS(7165),
    [anon_sym_DASH] = ACTIONS(7163),
    [anon_sym_LT_DASH] = ACTIONS(7165),
    [anon_sym_LT_LT_DASH] = ACTIONS(7165),
    [anon_sym_COLON_EQ] = ACTIONS(7165),
    [anon_sym_DASH_GT] = ACTIONS(7163),
    [anon_sym_DASH_GT_GT] = ACTIONS(7165),
    [anon_sym_PIPE] = ACTIONS(7163),
    [anon_sym_AMP] = ACTIONS(7163),
    [anon_sym_PIPE_PIPE] = ACTIONS(7165),
    [anon_sym_AMP_AMP] = ACTIONS(7165),
    [anon_sym_LT] = ACTIONS(7163),
    [anon_sym_LT_EQ] = ACTIONS(7165),
    [anon_sym_GT] = ACTIONS(7163),
    [anon_sym_GT_EQ] = ACTIONS(7165),
    [anon_sym_EQ_EQ] = ACTIONS(7165),
    [anon_sym_BANG_EQ] = ACTIONS(7165),
    [anon_sym_STAR] = ACTIONS(7163),
    [anon_sym_SLASH] = ACTIONS(7165),
    [anon_sym_STAR_STAR] = ACTIONS(7165),
    [anon_sym_CARET] = ACTIONS(7165),
    [aux_sym_binary_operator_token1] = ACTIONS(7165),
    [anon_sym_PIPE_GT] = ACTIONS(7165),
    [anon_sym_COLON] = ACTIONS(7163),
    [anon_sym_DOLLAR] = ACTIONS(7165),
    [anon_sym_AT] = ACTIONS(7165),
    [anon_sym_COLON_COLON] = ACTIONS(7163),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7165),
    [aux_sym__hex_literal_token1] = ACTIONS(7165),
    [sym__number_literal] = ACTIONS(7163),
    [anon_sym_SQUOTE] = ACTIONS(7165),
    [anon_sym_DQUOTE] = ACTIONS(7165),
    [sym_return] = ACTIONS(7163),
    [sym_next] = ACTIONS(7163),
    [sym_break] = ACTIONS(7163),
    [sym_true] = ACTIONS(7163),
    [sym_false] = ACTIONS(7163),
    [sym_null] = ACTIONS(7163),
    [sym_inf] = ACTIONS(7163),
    [sym_nan] = ACTIONS(7163),
    [anon_sym_NA] = ACTIONS(7163),
    [anon_sym_NA_integer_] = ACTIONS(7163),
    [anon_sym_NA_real_] = ACTIONS(7163),
    [anon_sym_NA_complex_] = ACTIONS(7163),
    [anon_sym_NA_character_] = ACTIONS(7163),
    [sym_dots] = ACTIONS(7163),
    [sym_dot_dot_i] = ACTIONS(7165),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7165),
    [sym__semicolon] = ACTIONS(7165),
    [sym__raw_string_literal] = ACTIONS(7165),
    [sym__external_open_parenthesis] = ACTIONS(7165),
    [sym__external_close_parenthesis] = ACTIONS(7165),
    [sym__external_open_brace] = ACTIONS(7165),
    [sym__external_open_bracket] = ACTIONS(7165),
    [sym__external_open_bracket2] = ACTIONS(7165),
  },
  [2482] = {
    [ts_builtin_sym_end] = ACTIONS(7153),
    [sym_identifier] = ACTIONS(7151),
    [anon_sym_BSLASH] = ACTIONS(7153),
    [anon_sym_function] = ACTIONS(7151),
    [anon_sym_EQ] = ACTIONS(7151),
    [anon_sym_if] = ACTIONS(7151),
    [anon_sym_for] = ACTIONS(7151),
    [anon_sym_while] = ACTIONS(7151),
    [anon_sym_repeat] = ACTIONS(7151),
    [anon_sym_QMARK] = ACTIONS(7153),
    [anon_sym_TILDE] = ACTIONS(7153),
    [anon_sym_BANG] = ACTIONS(7151),
    [anon_sym_PLUS] = ACTIONS(7153),
    [anon_sym_DASH] = ACTIONS(7151),
    [anon_sym_LT_DASH] = ACTIONS(7153),
    [anon_sym_LT_LT_DASH] = ACTIONS(7153),
    [anon_sym_COLON_EQ] = ACTIONS(7153),
    [anon_sym_DASH_GT] = ACTIONS(7151),
    [anon_sym_DASH_GT_GT] = ACTIONS(7153),
    [anon_sym_PIPE] = ACTIONS(7151),
    [anon_sym_AMP] = ACTIONS(7151),
    [anon_sym_PIPE_PIPE] = ACTIONS(7153),
    [anon_sym_AMP_AMP] = ACTIONS(7153),
    [anon_sym_LT] = ACTIONS(7151),
    [anon_sym_LT_EQ] = ACTIONS(7153),
    [anon_sym_GT] = ACTIONS(7151),
    [anon_sym_GT_EQ] = ACTIONS(7153),
    [anon_sym_EQ_EQ] = ACTIONS(7153),
    [anon_sym_BANG_EQ] = ACTIONS(7153),
    [anon_sym_STAR] = ACTIONS(7151),
    [anon_sym_SLASH] = ACTIONS(7153),
    [anon_sym_STAR_STAR] = ACTIONS(7153),
    [anon_sym_CARET] = ACTIONS(7153),
    [aux_sym_binary_operator_token1] = ACTIONS(7153),
    [anon_sym_PIPE_GT] = ACTIONS(7153),
    [anon_sym_COLON] = ACTIONS(7151),
    [anon_sym_DOLLAR] = ACTIONS(7153),
    [anon_sym_AT] = ACTIONS(7153),
    [anon_sym_COLON_COLON] = ACTIONS(7151),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7153),
    [aux_sym__hex_literal_token1] = ACTIONS(7153),
    [sym__number_literal] = ACTIONS(7151),
    [anon_sym_SQUOTE] = ACTIONS(7153),
    [anon_sym_DQUOTE] = ACTIONS(7153),
    [sym_return] = ACTIONS(7151),
    [sym_next] = ACTIONS(7151),
    [sym_break] = ACTIONS(7151),
    [sym_true] = ACTIONS(7151),
    [sym_false] = ACTIONS(7151),
    [sym_null] = ACTIONS(7151),
    [sym_inf] = ACTIONS(7151),
    [sym_nan] = ACTIONS(7151),
    [anon_sym_NA] = ACTIONS(7151),
    [anon_sym_NA_integer_] = ACTIONS(7151),
    [anon_sym_NA_real_] = ACTIONS(7151),
    [anon_sym_NA_complex_] = ACTIONS(7151),
    [anon_sym_NA_character_] = ACTIONS(7151),
    [sym_dots] = ACTIONS(7151),
    [sym_dot_dot_i] = ACTIONS(7153),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7153),
    [sym__semicolon] = ACTIONS(7153),
    [sym__raw_string_literal] = ACTIONS(7153),
    [sym__external_open_parenthesis] = ACTIONS(7153),
    [sym__external_open_brace] = ACTIONS(7153),
    [sym__external_close_brace] = ACTIONS(7153),
    [sym__external_open_bracket] = ACTIONS(7153),
    [sym__external_open_bracket2] = ACTIONS(7153),
  },
  [2483] = {
    [sym_identifier] = ACTIONS(7151),
    [anon_sym_BSLASH] = ACTIONS(7153),
    [anon_sym_function] = ACTIONS(7151),
    [anon_sym_EQ] = ACTIONS(7151),
    [anon_sym_if] = ACTIONS(7151),
    [anon_sym_for] = ACTIONS(7151),
    [anon_sym_while] = ACTIONS(7151),
    [anon_sym_repeat] = ACTIONS(7151),
    [anon_sym_QMARK] = ACTIONS(7153),
    [anon_sym_TILDE] = ACTIONS(7153),
    [anon_sym_BANG] = ACTIONS(7151),
    [anon_sym_PLUS] = ACTIONS(7153),
    [anon_sym_DASH] = ACTIONS(7151),
    [anon_sym_LT_DASH] = ACTIONS(7153),
    [anon_sym_LT_LT_DASH] = ACTIONS(7153),
    [anon_sym_COLON_EQ] = ACTIONS(7153),
    [anon_sym_DASH_GT] = ACTIONS(7151),
    [anon_sym_DASH_GT_GT] = ACTIONS(7153),
    [anon_sym_PIPE] = ACTIONS(7151),
    [anon_sym_AMP] = ACTIONS(7151),
    [anon_sym_PIPE_PIPE] = ACTIONS(7153),
    [anon_sym_AMP_AMP] = ACTIONS(7153),
    [anon_sym_LT] = ACTIONS(7151),
    [anon_sym_LT_EQ] = ACTIONS(7153),
    [anon_sym_GT] = ACTIONS(7151),
    [anon_sym_GT_EQ] = ACTIONS(7153),
    [anon_sym_EQ_EQ] = ACTIONS(7153),
    [anon_sym_BANG_EQ] = ACTIONS(7153),
    [anon_sym_STAR] = ACTIONS(7151),
    [anon_sym_SLASH] = ACTIONS(7153),
    [anon_sym_STAR_STAR] = ACTIONS(7153),
    [anon_sym_CARET] = ACTIONS(7153),
    [aux_sym_binary_operator_token1] = ACTIONS(7153),
    [anon_sym_PIPE_GT] = ACTIONS(7153),
    [anon_sym_COLON] = ACTIONS(7151),
    [anon_sym_DOLLAR] = ACTIONS(7153),
    [anon_sym_AT] = ACTIONS(7153),
    [anon_sym_COLON_COLON] = ACTIONS(7151),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7153),
    [aux_sym__hex_literal_token1] = ACTIONS(7153),
    [sym__number_literal] = ACTIONS(7151),
    [anon_sym_SQUOTE] = ACTIONS(7153),
    [anon_sym_DQUOTE] = ACTIONS(7153),
    [sym_return] = ACTIONS(7151),
    [sym_next] = ACTIONS(7151),
    [sym_break] = ACTIONS(7151),
    [sym_true] = ACTIONS(7151),
    [sym_false] = ACTIONS(7151),
    [sym_null] = ACTIONS(7151),
    [sym_inf] = ACTIONS(7151),
    [sym_nan] = ACTIONS(7151),
    [anon_sym_NA] = ACTIONS(7151),
    [anon_sym_NA_integer_] = ACTIONS(7151),
    [anon_sym_NA_real_] = ACTIONS(7151),
    [anon_sym_NA_complex_] = ACTIONS(7151),
    [anon_sym_NA_character_] = ACTIONS(7151),
    [sym_dots] = ACTIONS(7151),
    [sym_dot_dot_i] = ACTIONS(7153),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7153),
    [sym__newline] = ACTIONS(7153),
    [sym__raw_string_literal] = ACTIONS(7153),
    [sym__external_else] = ACTIONS(7153),
    [sym__external_open_parenthesis] = ACTIONS(7153),
    [sym__external_open_brace] = ACTIONS(7153),
    [sym__external_open_bracket] = ACTIONS(7153),
    [sym__external_close_bracket] = ACTIONS(7153),
    [sym__external_open_bracket2] = ACTIONS(7153),
  },
  [2484] = {
    [ts_builtin_sym_end] = ACTIONS(7153),
    [sym_identifier] = ACTIONS(7151),
    [anon_sym_BSLASH] = ACTIONS(7153),
    [anon_sym_function] = ACTIONS(7151),
    [anon_sym_EQ] = ACTIONS(7151),
    [anon_sym_if] = ACTIONS(7151),
    [anon_sym_for] = ACTIONS(7151),
    [anon_sym_while] = ACTIONS(7151),
    [anon_sym_repeat] = ACTIONS(7151),
    [anon_sym_QMARK] = ACTIONS(7153),
    [anon_sym_TILDE] = ACTIONS(7153),
    [anon_sym_BANG] = ACTIONS(7151),
    [anon_sym_PLUS] = ACTIONS(7153),
    [anon_sym_DASH] = ACTIONS(7151),
    [anon_sym_LT_DASH] = ACTIONS(7153),
    [anon_sym_LT_LT_DASH] = ACTIONS(7153),
    [anon_sym_COLON_EQ] = ACTIONS(7153),
    [anon_sym_DASH_GT] = ACTIONS(7151),
    [anon_sym_DASH_GT_GT] = ACTIONS(7153),
    [anon_sym_PIPE] = ACTIONS(7151),
    [anon_sym_AMP] = ACTIONS(7151),
    [anon_sym_PIPE_PIPE] = ACTIONS(7153),
    [anon_sym_AMP_AMP] = ACTIONS(7153),
    [anon_sym_LT] = ACTIONS(7151),
    [anon_sym_LT_EQ] = ACTIONS(7153),
    [anon_sym_GT] = ACTIONS(7151),
    [anon_sym_GT_EQ] = ACTIONS(7153),
    [anon_sym_EQ_EQ] = ACTIONS(7153),
    [anon_sym_BANG_EQ] = ACTIONS(7153),
    [anon_sym_STAR] = ACTIONS(7151),
    [anon_sym_SLASH] = ACTIONS(7153),
    [anon_sym_STAR_STAR] = ACTIONS(7153),
    [anon_sym_CARET] = ACTIONS(7153),
    [aux_sym_binary_operator_token1] = ACTIONS(7153),
    [anon_sym_PIPE_GT] = ACTIONS(7153),
    [anon_sym_COLON] = ACTIONS(7151),
    [anon_sym_DOLLAR] = ACTIONS(7153),
    [anon_sym_AT] = ACTIONS(7153),
    [anon_sym_COLON_COLON] = ACTIONS(7151),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7153),
    [aux_sym__hex_literal_token1] = ACTIONS(7153),
    [sym__number_literal] = ACTIONS(7151),
    [anon_sym_SQUOTE] = ACTIONS(7153),
    [anon_sym_DQUOTE] = ACTIONS(7153),
    [sym_return] = ACTIONS(7151),
    [sym_next] = ACTIONS(7151),
    [sym_break] = ACTIONS(7151),
    [sym_true] = ACTIONS(7151),
    [sym_false] = ACTIONS(7151),
    [sym_null] = ACTIONS(7151),
    [sym_inf] = ACTIONS(7151),
    [sym_nan] = ACTIONS(7151),
    [anon_sym_NA] = ACTIONS(7151),
    [anon_sym_NA_integer_] = ACTIONS(7151),
    [anon_sym_NA_real_] = ACTIONS(7151),
    [anon_sym_NA_complex_] = ACTIONS(7151),
    [anon_sym_NA_character_] = ACTIONS(7151),
    [sym_dots] = ACTIONS(7151),
    [sym_dot_dot_i] = ACTIONS(7153),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7153),
    [sym__semicolon] = ACTIONS(7153),
    [sym__raw_string_literal] = ACTIONS(7153),
    [sym__external_open_parenthesis] = ACTIONS(7153),
    [sym__external_close_parenthesis] = ACTIONS(7153),
    [sym__external_open_brace] = ACTIONS(7153),
    [sym__external_open_bracket] = ACTIONS(7153),
    [sym__external_open_bracket2] = ACTIONS(7153),
  },
  [2485] = {
    [ts_builtin_sym_end] = ACTIONS(7504),
    [sym_identifier] = ACTIONS(7506),
    [anon_sym_BSLASH] = ACTIONS(7504),
    [anon_sym_function] = ACTIONS(7506),
    [anon_sym_EQ] = ACTIONS(7506),
    [anon_sym_if] = ACTIONS(7506),
    [anon_sym_for] = ACTIONS(7506),
    [anon_sym_while] = ACTIONS(7506),
    [anon_sym_repeat] = ACTIONS(7506),
    [anon_sym_QMARK] = ACTIONS(7504),
    [anon_sym_TILDE] = ACTIONS(7504),
    [anon_sym_BANG] = ACTIONS(7506),
    [anon_sym_PLUS] = ACTIONS(7504),
    [anon_sym_DASH] = ACTIONS(7506),
    [anon_sym_LT_DASH] = ACTIONS(7504),
    [anon_sym_LT_LT_DASH] = ACTIONS(7504),
    [anon_sym_COLON_EQ] = ACTIONS(7504),
    [anon_sym_DASH_GT] = ACTIONS(7506),
    [anon_sym_DASH_GT_GT] = ACTIONS(7504),
    [anon_sym_PIPE] = ACTIONS(7506),
    [anon_sym_AMP] = ACTIONS(7506),
    [anon_sym_PIPE_PIPE] = ACTIONS(7504),
    [anon_sym_AMP_AMP] = ACTIONS(7504),
    [anon_sym_LT] = ACTIONS(7506),
    [anon_sym_LT_EQ] = ACTIONS(7504),
    [anon_sym_GT] = ACTIONS(7506),
    [anon_sym_GT_EQ] = ACTIONS(7504),
    [anon_sym_EQ_EQ] = ACTIONS(7504),
    [anon_sym_BANG_EQ] = ACTIONS(7504),
    [anon_sym_STAR] = ACTIONS(7506),
    [anon_sym_SLASH] = ACTIONS(7504),
    [anon_sym_STAR_STAR] = ACTIONS(7504),
    [anon_sym_CARET] = ACTIONS(7504),
    [aux_sym_binary_operator_token1] = ACTIONS(7504),
    [anon_sym_PIPE_GT] = ACTIONS(7504),
    [anon_sym_COLON] = ACTIONS(7506),
    [anon_sym_DOLLAR] = ACTIONS(7504),
    [anon_sym_AT] = ACTIONS(7504),
    [aux_sym__hex_literal_token1] = ACTIONS(7504),
    [sym__number_literal] = ACTIONS(7506),
    [anon_sym_SQUOTE] = ACTIONS(7504),
    [anon_sym_DQUOTE] = ACTIONS(7504),
    [sym_return] = ACTIONS(7506),
    [sym_next] = ACTIONS(7506),
    [sym_break] = ACTIONS(7506),
    [sym_true] = ACTIONS(7506),
    [sym_false] = ACTIONS(7506),
    [sym_null] = ACTIONS(7506),
    [sym_inf] = ACTIONS(7506),
    [sym_nan] = ACTIONS(7506),
    [anon_sym_NA] = ACTIONS(7506),
    [anon_sym_NA_integer_] = ACTIONS(7506),
    [anon_sym_NA_real_] = ACTIONS(7506),
    [anon_sym_NA_complex_] = ACTIONS(7506),
    [anon_sym_NA_character_] = ACTIONS(7506),
    [sym_dots] = ACTIONS(7506),
    [sym_dot_dot_i] = ACTIONS(7504),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7504),
    [sym__newline] = ACTIONS(7504),
    [sym__semicolon] = ACTIONS(7504),
    [sym__raw_string_literal] = ACTIONS(7504),
    [sym__external_open_parenthesis] = ACTIONS(7504),
    [sym__external_close_parenthesis] = ACTIONS(7504),
    [sym__external_open_brace] = ACTIONS(7504),
    [sym__external_close_brace] = ACTIONS(7504),
    [sym__external_open_bracket] = ACTIONS(7504),
    [sym__external_open_bracket2] = ACTIONS(7504),
  },
  [2486] = {
    [sym_identifier] = ACTIONS(7163),
    [anon_sym_BSLASH] = ACTIONS(7165),
    [anon_sym_function] = ACTIONS(7163),
    [anon_sym_EQ] = ACTIONS(7163),
    [anon_sym_if] = ACTIONS(7163),
    [anon_sym_for] = ACTIONS(7163),
    [anon_sym_while] = ACTIONS(7163),
    [anon_sym_repeat] = ACTIONS(7163),
    [anon_sym_QMARK] = ACTIONS(7165),
    [anon_sym_TILDE] = ACTIONS(7165),
    [anon_sym_BANG] = ACTIONS(7163),
    [anon_sym_PLUS] = ACTIONS(7165),
    [anon_sym_DASH] = ACTIONS(7163),
    [anon_sym_LT_DASH] = ACTIONS(7165),
    [anon_sym_LT_LT_DASH] = ACTIONS(7165),
    [anon_sym_COLON_EQ] = ACTIONS(7165),
    [anon_sym_DASH_GT] = ACTIONS(7163),
    [anon_sym_DASH_GT_GT] = ACTIONS(7165),
    [anon_sym_PIPE] = ACTIONS(7163),
    [anon_sym_AMP] = ACTIONS(7163),
    [anon_sym_PIPE_PIPE] = ACTIONS(7165),
    [anon_sym_AMP_AMP] = ACTIONS(7165),
    [anon_sym_LT] = ACTIONS(7163),
    [anon_sym_LT_EQ] = ACTIONS(7165),
    [anon_sym_GT] = ACTIONS(7163),
    [anon_sym_GT_EQ] = ACTIONS(7165),
    [anon_sym_EQ_EQ] = ACTIONS(7165),
    [anon_sym_BANG_EQ] = ACTIONS(7165),
    [anon_sym_STAR] = ACTIONS(7163),
    [anon_sym_SLASH] = ACTIONS(7165),
    [anon_sym_STAR_STAR] = ACTIONS(7165),
    [anon_sym_CARET] = ACTIONS(7165),
    [aux_sym_binary_operator_token1] = ACTIONS(7165),
    [anon_sym_PIPE_GT] = ACTIONS(7165),
    [anon_sym_COLON] = ACTIONS(7163),
    [anon_sym_DOLLAR] = ACTIONS(7165),
    [anon_sym_AT] = ACTIONS(7165),
    [anon_sym_COLON_COLON] = ACTIONS(7163),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7165),
    [aux_sym__hex_literal_token1] = ACTIONS(7165),
    [sym__number_literal] = ACTIONS(7163),
    [anon_sym_SQUOTE] = ACTIONS(7165),
    [anon_sym_DQUOTE] = ACTIONS(7165),
    [sym_return] = ACTIONS(7163),
    [sym_next] = ACTIONS(7163),
    [sym_break] = ACTIONS(7163),
    [sym_true] = ACTIONS(7163),
    [sym_false] = ACTIONS(7163),
    [sym_null] = ACTIONS(7163),
    [sym_inf] = ACTIONS(7163),
    [sym_nan] = ACTIONS(7163),
    [anon_sym_NA] = ACTIONS(7163),
    [anon_sym_NA_integer_] = ACTIONS(7163),
    [anon_sym_NA_real_] = ACTIONS(7163),
    [anon_sym_NA_complex_] = ACTIONS(7163),
    [anon_sym_NA_character_] = ACTIONS(7163),
    [sym_dots] = ACTIONS(7163),
    [sym_dot_dot_i] = ACTIONS(7165),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7165),
    [sym__newline] = ACTIONS(7165),
    [sym__raw_string_literal] = ACTIONS(7165),
    [sym__external_else] = ACTIONS(7165),
    [sym__external_open_parenthesis] = ACTIONS(7165),
    [sym__external_open_brace] = ACTIONS(7165),
    [sym__external_open_bracket] = ACTIONS(7165),
    [sym__external_close_bracket] = ACTIONS(7165),
    [sym__external_open_bracket2] = ACTIONS(7165),
  },
  [2487] = {
    [ts_builtin_sym_end] = ACTIONS(7510),
    [sym_identifier] = ACTIONS(7512),
    [anon_sym_BSLASH] = ACTIONS(7510),
    [anon_sym_function] = ACTIONS(7512),
    [anon_sym_EQ] = ACTIONS(7512),
    [anon_sym_if] = ACTIONS(7512),
    [anon_sym_for] = ACTIONS(7512),
    [anon_sym_while] = ACTIONS(7512),
    [anon_sym_repeat] = ACTIONS(7512),
    [anon_sym_QMARK] = ACTIONS(7510),
    [anon_sym_TILDE] = ACTIONS(7510),
    [anon_sym_BANG] = ACTIONS(7512),
    [anon_sym_PLUS] = ACTIONS(7510),
    [anon_sym_DASH] = ACTIONS(7512),
    [anon_sym_LT_DASH] = ACTIONS(7510),
    [anon_sym_LT_LT_DASH] = ACTIONS(7510),
    [anon_sym_COLON_EQ] = ACTIONS(7510),
    [anon_sym_DASH_GT] = ACTIONS(7512),
    [anon_sym_DASH_GT_GT] = ACTIONS(7510),
    [anon_sym_PIPE] = ACTIONS(7512),
    [anon_sym_AMP] = ACTIONS(7512),
    [anon_sym_PIPE_PIPE] = ACTIONS(7510),
    [anon_sym_AMP_AMP] = ACTIONS(7510),
    [anon_sym_LT] = ACTIONS(7512),
    [anon_sym_LT_EQ] = ACTIONS(7510),
    [anon_sym_GT] = ACTIONS(7512),
    [anon_sym_GT_EQ] = ACTIONS(7510),
    [anon_sym_EQ_EQ] = ACTIONS(7510),
    [anon_sym_BANG_EQ] = ACTIONS(7510),
    [anon_sym_STAR] = ACTIONS(7512),
    [anon_sym_SLASH] = ACTIONS(7510),
    [anon_sym_STAR_STAR] = ACTIONS(7510),
    [anon_sym_CARET] = ACTIONS(7510),
    [aux_sym_binary_operator_token1] = ACTIONS(7510),
    [anon_sym_PIPE_GT] = ACTIONS(7510),
    [anon_sym_COLON] = ACTIONS(7512),
    [anon_sym_DOLLAR] = ACTIONS(7510),
    [anon_sym_AT] = ACTIONS(7510),
    [aux_sym__hex_literal_token1] = ACTIONS(7510),
    [sym__number_literal] = ACTIONS(7512),
    [anon_sym_SQUOTE] = ACTIONS(7510),
    [anon_sym_DQUOTE] = ACTIONS(7510),
    [sym_return] = ACTIONS(7512),
    [sym_next] = ACTIONS(7512),
    [sym_break] = ACTIONS(7512),
    [sym_true] = ACTIONS(7512),
    [sym_false] = ACTIONS(7512),
    [sym_null] = ACTIONS(7512),
    [sym_inf] = ACTIONS(7512),
    [sym_nan] = ACTIONS(7512),
    [anon_sym_NA] = ACTIONS(7512),
    [anon_sym_NA_integer_] = ACTIONS(7512),
    [anon_sym_NA_real_] = ACTIONS(7512),
    [anon_sym_NA_complex_] = ACTIONS(7512),
    [anon_sym_NA_character_] = ACTIONS(7512),
    [sym_dots] = ACTIONS(7512),
    [sym_dot_dot_i] = ACTIONS(7510),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7510),
    [sym__newline] = ACTIONS(7510),
    [sym__semicolon] = ACTIONS(7510),
    [sym__raw_string_literal] = ACTIONS(7510),
    [sym__external_open_parenthesis] = ACTIONS(7510),
    [sym__external_close_parenthesis] = ACTIONS(7510),
    [sym__external_open_brace] = ACTIONS(7510),
    [sym__external_close_brace] = ACTIONS(7510),
    [sym__external_open_bracket] = ACTIONS(7510),
    [sym__external_open_bracket2] = ACTIONS(7510),
  },
  [2488] = {
    [sym_identifier] = ACTIONS(7486),
    [anon_sym_BSLASH] = ACTIONS(7484),
    [anon_sym_function] = ACTIONS(7486),
    [anon_sym_EQ] = ACTIONS(7486),
    [anon_sym_if] = ACTIONS(7486),
    [anon_sym_for] = ACTIONS(7486),
    [anon_sym_while] = ACTIONS(7486),
    [anon_sym_repeat] = ACTIONS(7486),
    [anon_sym_QMARK] = ACTIONS(7484),
    [anon_sym_TILDE] = ACTIONS(7484),
    [anon_sym_BANG] = ACTIONS(7486),
    [anon_sym_PLUS] = ACTIONS(7484),
    [anon_sym_DASH] = ACTIONS(7486),
    [anon_sym_LT_DASH] = ACTIONS(7484),
    [anon_sym_LT_LT_DASH] = ACTIONS(7484),
    [anon_sym_COLON_EQ] = ACTIONS(7484),
    [anon_sym_DASH_GT] = ACTIONS(7486),
    [anon_sym_DASH_GT_GT] = ACTIONS(7484),
    [anon_sym_PIPE] = ACTIONS(7486),
    [anon_sym_AMP] = ACTIONS(7486),
    [anon_sym_PIPE_PIPE] = ACTIONS(7484),
    [anon_sym_AMP_AMP] = ACTIONS(7484),
    [anon_sym_LT] = ACTIONS(7486),
    [anon_sym_LT_EQ] = ACTIONS(7484),
    [anon_sym_GT] = ACTIONS(7486),
    [anon_sym_GT_EQ] = ACTIONS(7484),
    [anon_sym_EQ_EQ] = ACTIONS(7484),
    [anon_sym_BANG_EQ] = ACTIONS(7484),
    [anon_sym_STAR] = ACTIONS(7486),
    [anon_sym_SLASH] = ACTIONS(7484),
    [anon_sym_STAR_STAR] = ACTIONS(7484),
    [anon_sym_CARET] = ACTIONS(7484),
    [aux_sym_binary_operator_token1] = ACTIONS(7484),
    [anon_sym_PIPE_GT] = ACTIONS(7484),
    [anon_sym_COLON] = ACTIONS(7486),
    [anon_sym_DOLLAR] = ACTIONS(7484),
    [anon_sym_AT] = ACTIONS(7484),
    [aux_sym__hex_literal_token1] = ACTIONS(7484),
    [sym__number_literal] = ACTIONS(7486),
    [anon_sym_SQUOTE] = ACTIONS(7484),
    [anon_sym_DQUOTE] = ACTIONS(7484),
    [sym_return] = ACTIONS(7486),
    [sym_next] = ACTIONS(7486),
    [sym_break] = ACTIONS(7486),
    [sym_true] = ACTIONS(7486),
    [sym_false] = ACTIONS(7486),
    [sym_null] = ACTIONS(7486),
    [sym_inf] = ACTIONS(7486),
    [sym_nan] = ACTIONS(7486),
    [anon_sym_NA] = ACTIONS(7486),
    [anon_sym_NA_integer_] = ACTIONS(7486),
    [anon_sym_NA_real_] = ACTIONS(7486),
    [anon_sym_NA_complex_] = ACTIONS(7486),
    [anon_sym_NA_character_] = ACTIONS(7486),
    [sym_dots] = ACTIONS(7486),
    [sym_dot_dot_i] = ACTIONS(7484),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7484),
    [sym__newline] = ACTIONS(7484),
    [sym__semicolon] = ACTIONS(7484),
    [sym__raw_string_literal] = ACTIONS(7484),
    [sym__external_open_parenthesis] = ACTIONS(7484),
    [sym__external_close_parenthesis] = ACTIONS(7484),
    [sym__external_open_brace] = ACTIONS(7484),
    [sym__external_close_brace] = ACTIONS(7484),
    [sym__external_open_bracket] = ACTIONS(7484),
    [sym__external_close_bracket] = ACTIONS(7484),
    [sym__external_open_bracket2] = ACTIONS(7484),
  },
  [2489] = {
    [sym_identifier] = ACTIONS(7490),
    [anon_sym_BSLASH] = ACTIONS(7488),
    [anon_sym_function] = ACTIONS(7490),
    [anon_sym_EQ] = ACTIONS(7490),
    [anon_sym_if] = ACTIONS(7490),
    [anon_sym_for] = ACTIONS(7490),
    [anon_sym_while] = ACTIONS(7490),
    [anon_sym_repeat] = ACTIONS(7490),
    [anon_sym_QMARK] = ACTIONS(7488),
    [anon_sym_TILDE] = ACTIONS(7488),
    [anon_sym_BANG] = ACTIONS(7490),
    [anon_sym_PLUS] = ACTIONS(7488),
    [anon_sym_DASH] = ACTIONS(7490),
    [anon_sym_LT_DASH] = ACTIONS(7488),
    [anon_sym_LT_LT_DASH] = ACTIONS(7488),
    [anon_sym_COLON_EQ] = ACTIONS(7488),
    [anon_sym_DASH_GT] = ACTIONS(7490),
    [anon_sym_DASH_GT_GT] = ACTIONS(7488),
    [anon_sym_PIPE] = ACTIONS(7490),
    [anon_sym_AMP] = ACTIONS(7490),
    [anon_sym_PIPE_PIPE] = ACTIONS(7488),
    [anon_sym_AMP_AMP] = ACTIONS(7488),
    [anon_sym_LT] = ACTIONS(7490),
    [anon_sym_LT_EQ] = ACTIONS(7488),
    [anon_sym_GT] = ACTIONS(7490),
    [anon_sym_GT_EQ] = ACTIONS(7488),
    [anon_sym_EQ_EQ] = ACTIONS(7488),
    [anon_sym_BANG_EQ] = ACTIONS(7488),
    [anon_sym_STAR] = ACTIONS(7490),
    [anon_sym_SLASH] = ACTIONS(7488),
    [anon_sym_STAR_STAR] = ACTIONS(7488),
    [anon_sym_CARET] = ACTIONS(7488),
    [aux_sym_binary_operator_token1] = ACTIONS(7488),
    [anon_sym_PIPE_GT] = ACTIONS(7488),
    [anon_sym_COLON] = ACTIONS(7490),
    [anon_sym_DOLLAR] = ACTIONS(7488),
    [anon_sym_AT] = ACTIONS(7488),
    [aux_sym__hex_literal_token1] = ACTIONS(7488),
    [sym__number_literal] = ACTIONS(7490),
    [anon_sym_SQUOTE] = ACTIONS(7488),
    [anon_sym_DQUOTE] = ACTIONS(7488),
    [sym_return] = ACTIONS(7490),
    [sym_next] = ACTIONS(7490),
    [sym_break] = ACTIONS(7490),
    [sym_true] = ACTIONS(7490),
    [sym_false] = ACTIONS(7490),
    [sym_null] = ACTIONS(7490),
    [sym_inf] = ACTIONS(7490),
    [sym_nan] = ACTIONS(7490),
    [anon_sym_NA] = ACTIONS(7490),
    [anon_sym_NA_integer_] = ACTIONS(7490),
    [anon_sym_NA_real_] = ACTIONS(7490),
    [anon_sym_NA_complex_] = ACTIONS(7490),
    [anon_sym_NA_character_] = ACTIONS(7490),
    [sym_dots] = ACTIONS(7490),
    [sym_dot_dot_i] = ACTIONS(7488),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7488),
    [sym__newline] = ACTIONS(7488),
    [sym__semicolon] = ACTIONS(7488),
    [sym__raw_string_literal] = ACTIONS(7488),
    [sym__external_open_parenthesis] = ACTIONS(7488),
    [sym__external_close_parenthesis] = ACTIONS(7488),
    [sym__external_open_brace] = ACTIONS(7488),
    [sym__external_close_brace] = ACTIONS(7488),
    [sym__external_open_bracket] = ACTIONS(7488),
    [sym__external_close_bracket] = ACTIONS(7488),
    [sym__external_open_bracket2] = ACTIONS(7488),
  },
  [2490] = {
    [ts_builtin_sym_end] = ACTIONS(7514),
    [sym_identifier] = ACTIONS(7516),
    [anon_sym_BSLASH] = ACTIONS(7514),
    [anon_sym_function] = ACTIONS(7516),
    [anon_sym_EQ] = ACTIONS(7516),
    [anon_sym_if] = ACTIONS(7516),
    [anon_sym_for] = ACTIONS(7516),
    [anon_sym_while] = ACTIONS(7516),
    [anon_sym_repeat] = ACTIONS(7516),
    [anon_sym_QMARK] = ACTIONS(7514),
    [anon_sym_TILDE] = ACTIONS(7514),
    [anon_sym_BANG] = ACTIONS(7516),
    [anon_sym_PLUS] = ACTIONS(7514),
    [anon_sym_DASH] = ACTIONS(7516),
    [anon_sym_LT_DASH] = ACTIONS(7514),
    [anon_sym_LT_LT_DASH] = ACTIONS(7514),
    [anon_sym_COLON_EQ] = ACTIONS(7514),
    [anon_sym_DASH_GT] = ACTIONS(7516),
    [anon_sym_DASH_GT_GT] = ACTIONS(7514),
    [anon_sym_PIPE] = ACTIONS(7516),
    [anon_sym_AMP] = ACTIONS(7516),
    [anon_sym_PIPE_PIPE] = ACTIONS(7514),
    [anon_sym_AMP_AMP] = ACTIONS(7514),
    [anon_sym_LT] = ACTIONS(7516),
    [anon_sym_LT_EQ] = ACTIONS(7514),
    [anon_sym_GT] = ACTIONS(7516),
    [anon_sym_GT_EQ] = ACTIONS(7514),
    [anon_sym_EQ_EQ] = ACTIONS(7514),
    [anon_sym_BANG_EQ] = ACTIONS(7514),
    [anon_sym_STAR] = ACTIONS(7516),
    [anon_sym_SLASH] = ACTIONS(7514),
    [anon_sym_STAR_STAR] = ACTIONS(7514),
    [anon_sym_CARET] = ACTIONS(7514),
    [aux_sym_binary_operator_token1] = ACTIONS(7514),
    [anon_sym_PIPE_GT] = ACTIONS(7514),
    [anon_sym_COLON] = ACTIONS(7516),
    [anon_sym_DOLLAR] = ACTIONS(7514),
    [anon_sym_AT] = ACTIONS(7514),
    [aux_sym__hex_literal_token1] = ACTIONS(7514),
    [sym__number_literal] = ACTIONS(7516),
    [anon_sym_SQUOTE] = ACTIONS(7514),
    [anon_sym_DQUOTE] = ACTIONS(7514),
    [sym_return] = ACTIONS(7516),
    [sym_next] = ACTIONS(7516),
    [sym_break] = ACTIONS(7516),
    [sym_true] = ACTIONS(7516),
    [sym_false] = ACTIONS(7516),
    [sym_null] = ACTIONS(7516),
    [sym_inf] = ACTIONS(7516),
    [sym_nan] = ACTIONS(7516),
    [anon_sym_NA] = ACTIONS(7516),
    [anon_sym_NA_integer_] = ACTIONS(7516),
    [anon_sym_NA_real_] = ACTIONS(7516),
    [anon_sym_NA_complex_] = ACTIONS(7516),
    [anon_sym_NA_character_] = ACTIONS(7516),
    [sym_dots] = ACTIONS(7516),
    [sym_dot_dot_i] = ACTIONS(7514),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7514),
    [sym__newline] = ACTIONS(7514),
    [sym__semicolon] = ACTIONS(7514),
    [sym__raw_string_literal] = ACTIONS(7514),
    [sym__external_open_parenthesis] = ACTIONS(7514),
    [sym__external_close_parenthesis] = ACTIONS(7514),
    [sym__external_open_brace] = ACTIONS(7514),
    [sym__external_close_brace] = ACTIONS(7514),
    [sym__external_open_bracket] = ACTIONS(7514),
    [sym__external_open_bracket2] = ACTIONS(7514),
  },
  [2491] = {
    [sym_identifier] = ACTIONS(7494),
    [anon_sym_BSLASH] = ACTIONS(7492),
    [anon_sym_function] = ACTIONS(7494),
    [anon_sym_EQ] = ACTIONS(7494),
    [anon_sym_if] = ACTIONS(7494),
    [anon_sym_for] = ACTIONS(7494),
    [anon_sym_while] = ACTIONS(7494),
    [anon_sym_repeat] = ACTIONS(7494),
    [anon_sym_QMARK] = ACTIONS(7492),
    [anon_sym_TILDE] = ACTIONS(7492),
    [anon_sym_BANG] = ACTIONS(7494),
    [anon_sym_PLUS] = ACTIONS(7492),
    [anon_sym_DASH] = ACTIONS(7494),
    [anon_sym_LT_DASH] = ACTIONS(7492),
    [anon_sym_LT_LT_DASH] = ACTIONS(7492),
    [anon_sym_COLON_EQ] = ACTIONS(7492),
    [anon_sym_DASH_GT] = ACTIONS(7494),
    [anon_sym_DASH_GT_GT] = ACTIONS(7492),
    [anon_sym_PIPE] = ACTIONS(7494),
    [anon_sym_AMP] = ACTIONS(7494),
    [anon_sym_PIPE_PIPE] = ACTIONS(7492),
    [anon_sym_AMP_AMP] = ACTIONS(7492),
    [anon_sym_LT] = ACTIONS(7494),
    [anon_sym_LT_EQ] = ACTIONS(7492),
    [anon_sym_GT] = ACTIONS(7494),
    [anon_sym_GT_EQ] = ACTIONS(7492),
    [anon_sym_EQ_EQ] = ACTIONS(7492),
    [anon_sym_BANG_EQ] = ACTIONS(7492),
    [anon_sym_STAR] = ACTIONS(7494),
    [anon_sym_SLASH] = ACTIONS(7492),
    [anon_sym_STAR_STAR] = ACTIONS(7492),
    [anon_sym_CARET] = ACTIONS(7492),
    [aux_sym_binary_operator_token1] = ACTIONS(7492),
    [anon_sym_PIPE_GT] = ACTIONS(7492),
    [anon_sym_COLON] = ACTIONS(7494),
    [anon_sym_DOLLAR] = ACTIONS(7492),
    [anon_sym_AT] = ACTIONS(7492),
    [aux_sym__hex_literal_token1] = ACTIONS(7492),
    [sym__number_literal] = ACTIONS(7494),
    [anon_sym_SQUOTE] = ACTIONS(7492),
    [anon_sym_DQUOTE] = ACTIONS(7492),
    [sym_return] = ACTIONS(7494),
    [sym_next] = ACTIONS(7494),
    [sym_break] = ACTIONS(7494),
    [sym_true] = ACTIONS(7494),
    [sym_false] = ACTIONS(7494),
    [sym_null] = ACTIONS(7494),
    [sym_inf] = ACTIONS(7494),
    [sym_nan] = ACTIONS(7494),
    [anon_sym_NA] = ACTIONS(7494),
    [anon_sym_NA_integer_] = ACTIONS(7494),
    [anon_sym_NA_real_] = ACTIONS(7494),
    [anon_sym_NA_complex_] = ACTIONS(7494),
    [anon_sym_NA_character_] = ACTIONS(7494),
    [sym_dots] = ACTIONS(7494),
    [sym_dot_dot_i] = ACTIONS(7492),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7492),
    [sym__newline] = ACTIONS(7492),
    [sym__semicolon] = ACTIONS(7492),
    [sym__raw_string_literal] = ACTIONS(7492),
    [sym__external_open_parenthesis] = ACTIONS(7492),
    [sym__external_close_parenthesis] = ACTIONS(7492),
    [sym__external_open_brace] = ACTIONS(7492),
    [sym__external_close_brace] = ACTIONS(7492),
    [sym__external_open_bracket] = ACTIONS(7492),
    [sym__external_close_bracket] = ACTIONS(7492),
    [sym__external_open_bracket2] = ACTIONS(7492),
  },
  [2492] = {
    [ts_builtin_sym_end] = ACTIONS(7139),
    [sym_identifier] = ACTIONS(7137),
    [anon_sym_BSLASH] = ACTIONS(7139),
    [anon_sym_function] = ACTIONS(7137),
    [anon_sym_EQ] = ACTIONS(7137),
    [anon_sym_if] = ACTIONS(7137),
    [anon_sym_for] = ACTIONS(7137),
    [anon_sym_while] = ACTIONS(7137),
    [anon_sym_repeat] = ACTIONS(7137),
    [anon_sym_QMARK] = ACTIONS(7139),
    [anon_sym_TILDE] = ACTIONS(7139),
    [anon_sym_BANG] = ACTIONS(7137),
    [anon_sym_PLUS] = ACTIONS(7139),
    [anon_sym_DASH] = ACTIONS(7137),
    [anon_sym_LT_DASH] = ACTIONS(7139),
    [anon_sym_LT_LT_DASH] = ACTIONS(7139),
    [anon_sym_COLON_EQ] = ACTIONS(7139),
    [anon_sym_DASH_GT] = ACTIONS(7137),
    [anon_sym_DASH_GT_GT] = ACTIONS(7139),
    [anon_sym_PIPE] = ACTIONS(7137),
    [anon_sym_AMP] = ACTIONS(7137),
    [anon_sym_PIPE_PIPE] = ACTIONS(7139),
    [anon_sym_AMP_AMP] = ACTIONS(7139),
    [anon_sym_LT] = ACTIONS(7137),
    [anon_sym_LT_EQ] = ACTIONS(7139),
    [anon_sym_GT] = ACTIONS(7137),
    [anon_sym_GT_EQ] = ACTIONS(7139),
    [anon_sym_EQ_EQ] = ACTIONS(7139),
    [anon_sym_BANG_EQ] = ACTIONS(7139),
    [anon_sym_STAR] = ACTIONS(7137),
    [anon_sym_SLASH] = ACTIONS(7139),
    [anon_sym_STAR_STAR] = ACTIONS(7139),
    [anon_sym_CARET] = ACTIONS(7139),
    [aux_sym_binary_operator_token1] = ACTIONS(7139),
    [anon_sym_PIPE_GT] = ACTIONS(7139),
    [anon_sym_COLON] = ACTIONS(7137),
    [anon_sym_DOLLAR] = ACTIONS(7139),
    [anon_sym_AT] = ACTIONS(7139),
    [anon_sym_COLON_COLON] = ACTIONS(7137),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7139),
    [aux_sym__hex_literal_token1] = ACTIONS(7139),
    [sym__number_literal] = ACTIONS(7137),
    [anon_sym_SQUOTE] = ACTIONS(7139),
    [anon_sym_DQUOTE] = ACTIONS(7139),
    [sym_return] = ACTIONS(7137),
    [sym_next] = ACTIONS(7137),
    [sym_break] = ACTIONS(7137),
    [sym_true] = ACTIONS(7137),
    [sym_false] = ACTIONS(7137),
    [sym_null] = ACTIONS(7137),
    [sym_inf] = ACTIONS(7137),
    [sym_nan] = ACTIONS(7137),
    [anon_sym_NA] = ACTIONS(7137),
    [anon_sym_NA_integer_] = ACTIONS(7137),
    [anon_sym_NA_real_] = ACTIONS(7137),
    [anon_sym_NA_complex_] = ACTIONS(7137),
    [anon_sym_NA_character_] = ACTIONS(7137),
    [sym_dots] = ACTIONS(7137),
    [sym_dot_dot_i] = ACTIONS(7139),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7139),
    [sym__semicolon] = ACTIONS(7139),
    [sym__raw_string_literal] = ACTIONS(7139),
    [sym__external_open_parenthesis] = ACTIONS(7139),
    [sym__external_open_brace] = ACTIONS(7139),
    [sym__external_close_brace] = ACTIONS(7139),
    [sym__external_open_bracket] = ACTIONS(7139),
    [sym__external_open_bracket2] = ACTIONS(7139),
  },
  [2493] = {
    [ts_builtin_sym_end] = ACTIONS(7518),
    [sym_identifier] = ACTIONS(7520),
    [anon_sym_BSLASH] = ACTIONS(7518),
    [anon_sym_function] = ACTIONS(7520),
    [anon_sym_EQ] = ACTIONS(7520),
    [anon_sym_if] = ACTIONS(7520),
    [anon_sym_for] = ACTIONS(7520),
    [anon_sym_while] = ACTIONS(7520),
    [anon_sym_repeat] = ACTIONS(7520),
    [anon_sym_QMARK] = ACTIONS(7518),
    [anon_sym_TILDE] = ACTIONS(7518),
    [anon_sym_BANG] = ACTIONS(7520),
    [anon_sym_PLUS] = ACTIONS(7518),
    [anon_sym_DASH] = ACTIONS(7520),
    [anon_sym_LT_DASH] = ACTIONS(7518),
    [anon_sym_LT_LT_DASH] = ACTIONS(7518),
    [anon_sym_COLON_EQ] = ACTIONS(7518),
    [anon_sym_DASH_GT] = ACTIONS(7520),
    [anon_sym_DASH_GT_GT] = ACTIONS(7518),
    [anon_sym_PIPE] = ACTIONS(7520),
    [anon_sym_AMP] = ACTIONS(7520),
    [anon_sym_PIPE_PIPE] = ACTIONS(7518),
    [anon_sym_AMP_AMP] = ACTIONS(7518),
    [anon_sym_LT] = ACTIONS(7520),
    [anon_sym_LT_EQ] = ACTIONS(7518),
    [anon_sym_GT] = ACTIONS(7520),
    [anon_sym_GT_EQ] = ACTIONS(7518),
    [anon_sym_EQ_EQ] = ACTIONS(7518),
    [anon_sym_BANG_EQ] = ACTIONS(7518),
    [anon_sym_STAR] = ACTIONS(7520),
    [anon_sym_SLASH] = ACTIONS(7518),
    [anon_sym_STAR_STAR] = ACTIONS(7518),
    [anon_sym_CARET] = ACTIONS(7518),
    [aux_sym_binary_operator_token1] = ACTIONS(7518),
    [anon_sym_PIPE_GT] = ACTIONS(7518),
    [anon_sym_COLON] = ACTIONS(7520),
    [anon_sym_DOLLAR] = ACTIONS(7518),
    [anon_sym_AT] = ACTIONS(7518),
    [aux_sym__hex_literal_token1] = ACTIONS(7518),
    [sym__number_literal] = ACTIONS(7520),
    [anon_sym_SQUOTE] = ACTIONS(7518),
    [anon_sym_DQUOTE] = ACTIONS(7518),
    [sym_return] = ACTIONS(7520),
    [sym_next] = ACTIONS(7520),
    [sym_break] = ACTIONS(7520),
    [sym_true] = ACTIONS(7520),
    [sym_false] = ACTIONS(7520),
    [sym_null] = ACTIONS(7520),
    [sym_inf] = ACTIONS(7520),
    [sym_nan] = ACTIONS(7520),
    [anon_sym_NA] = ACTIONS(7520),
    [anon_sym_NA_integer_] = ACTIONS(7520),
    [anon_sym_NA_real_] = ACTIONS(7520),
    [anon_sym_NA_complex_] = ACTIONS(7520),
    [anon_sym_NA_character_] = ACTIONS(7520),
    [sym_dots] = ACTIONS(7520),
    [sym_dot_dot_i] = ACTIONS(7518),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7518),
    [sym__newline] = ACTIONS(7518),
    [sym__semicolon] = ACTIONS(7518),
    [sym__raw_string_literal] = ACTIONS(7518),
    [sym__external_open_parenthesis] = ACTIONS(7518),
    [sym__external_close_parenthesis] = ACTIONS(7518),
    [sym__external_open_brace] = ACTIONS(7518),
    [sym__external_close_brace] = ACTIONS(7518),
    [sym__external_open_bracket] = ACTIONS(7518),
    [sym__external_open_bracket2] = ACTIONS(7518),
  },
  [2494] = {
    [ts_builtin_sym_end] = ACTIONS(7117),
    [sym_identifier] = ACTIONS(7115),
    [anon_sym_BSLASH] = ACTIONS(7117),
    [anon_sym_function] = ACTIONS(7115),
    [anon_sym_EQ] = ACTIONS(7115),
    [anon_sym_if] = ACTIONS(7115),
    [anon_sym_for] = ACTIONS(7115),
    [anon_sym_while] = ACTIONS(7115),
    [anon_sym_repeat] = ACTIONS(7115),
    [anon_sym_QMARK] = ACTIONS(7117),
    [anon_sym_TILDE] = ACTIONS(7117),
    [anon_sym_BANG] = ACTIONS(7115),
    [anon_sym_PLUS] = ACTIONS(7117),
    [anon_sym_DASH] = ACTIONS(7115),
    [anon_sym_LT_DASH] = ACTIONS(7117),
    [anon_sym_LT_LT_DASH] = ACTIONS(7117),
    [anon_sym_COLON_EQ] = ACTIONS(7117),
    [anon_sym_DASH_GT] = ACTIONS(7115),
    [anon_sym_DASH_GT_GT] = ACTIONS(7117),
    [anon_sym_PIPE] = ACTIONS(7115),
    [anon_sym_AMP] = ACTIONS(7115),
    [anon_sym_PIPE_PIPE] = ACTIONS(7117),
    [anon_sym_AMP_AMP] = ACTIONS(7117),
    [anon_sym_LT] = ACTIONS(7115),
    [anon_sym_LT_EQ] = ACTIONS(7117),
    [anon_sym_GT] = ACTIONS(7115),
    [anon_sym_GT_EQ] = ACTIONS(7117),
    [anon_sym_EQ_EQ] = ACTIONS(7117),
    [anon_sym_BANG_EQ] = ACTIONS(7117),
    [anon_sym_STAR] = ACTIONS(7115),
    [anon_sym_SLASH] = ACTIONS(7117),
    [anon_sym_STAR_STAR] = ACTIONS(7117),
    [anon_sym_CARET] = ACTIONS(7117),
    [aux_sym_binary_operator_token1] = ACTIONS(7117),
    [anon_sym_PIPE_GT] = ACTIONS(7117),
    [anon_sym_COLON] = ACTIONS(7115),
    [anon_sym_DOLLAR] = ACTIONS(7117),
    [anon_sym_AT] = ACTIONS(7117),
    [anon_sym_COLON_COLON] = ACTIONS(7115),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7117),
    [aux_sym__hex_literal_token1] = ACTIONS(7117),
    [sym__number_literal] = ACTIONS(7115),
    [anon_sym_SQUOTE] = ACTIONS(7117),
    [anon_sym_DQUOTE] = ACTIONS(7117),
    [sym_return] = ACTIONS(7115),
    [sym_next] = ACTIONS(7115),
    [sym_break] = ACTIONS(7115),
    [sym_true] = ACTIONS(7115),
    [sym_false] = ACTIONS(7115),
    [sym_null] = ACTIONS(7115),
    [sym_inf] = ACTIONS(7115),
    [sym_nan] = ACTIONS(7115),
    [anon_sym_NA] = ACTIONS(7115),
    [anon_sym_NA_integer_] = ACTIONS(7115),
    [anon_sym_NA_real_] = ACTIONS(7115),
    [anon_sym_NA_complex_] = ACTIONS(7115),
    [anon_sym_NA_character_] = ACTIONS(7115),
    [sym_dots] = ACTIONS(7115),
    [sym_dot_dot_i] = ACTIONS(7117),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7117),
    [sym__semicolon] = ACTIONS(7117),
    [sym__raw_string_literal] = ACTIONS(7117),
    [sym__external_open_parenthesis] = ACTIONS(7117),
    [sym__external_close_parenthesis] = ACTIONS(7117),
    [sym__external_open_brace] = ACTIONS(7117),
    [sym__external_open_bracket] = ACTIONS(7117),
    [sym__external_open_bracket2] = ACTIONS(7117),
  },
  [2495] = {
    [sym_identifier] = ACTIONS(7474),
    [anon_sym_BSLASH] = ACTIONS(7472),
    [anon_sym_function] = ACTIONS(7474),
    [anon_sym_EQ] = ACTIONS(7474),
    [anon_sym_if] = ACTIONS(7474),
    [anon_sym_for] = ACTIONS(7474),
    [anon_sym_while] = ACTIONS(7474),
    [anon_sym_repeat] = ACTIONS(7474),
    [anon_sym_QMARK] = ACTIONS(7472),
    [anon_sym_TILDE] = ACTIONS(7472),
    [anon_sym_BANG] = ACTIONS(7474),
    [anon_sym_PLUS] = ACTIONS(7472),
    [anon_sym_DASH] = ACTIONS(7474),
    [anon_sym_LT_DASH] = ACTIONS(7472),
    [anon_sym_LT_LT_DASH] = ACTIONS(7472),
    [anon_sym_COLON_EQ] = ACTIONS(7472),
    [anon_sym_DASH_GT] = ACTIONS(7474),
    [anon_sym_DASH_GT_GT] = ACTIONS(7472),
    [anon_sym_PIPE] = ACTIONS(7474),
    [anon_sym_AMP] = ACTIONS(7474),
    [anon_sym_PIPE_PIPE] = ACTIONS(7472),
    [anon_sym_AMP_AMP] = ACTIONS(7472),
    [anon_sym_LT] = ACTIONS(7474),
    [anon_sym_LT_EQ] = ACTIONS(7472),
    [anon_sym_GT] = ACTIONS(7474),
    [anon_sym_GT_EQ] = ACTIONS(7472),
    [anon_sym_EQ_EQ] = ACTIONS(7472),
    [anon_sym_BANG_EQ] = ACTIONS(7472),
    [anon_sym_STAR] = ACTIONS(7474),
    [anon_sym_SLASH] = ACTIONS(7472),
    [anon_sym_STAR_STAR] = ACTIONS(7472),
    [anon_sym_CARET] = ACTIONS(7472),
    [aux_sym_binary_operator_token1] = ACTIONS(7472),
    [anon_sym_PIPE_GT] = ACTIONS(7472),
    [anon_sym_COLON] = ACTIONS(7474),
    [anon_sym_DOLLAR] = ACTIONS(7472),
    [anon_sym_AT] = ACTIONS(7472),
    [aux_sym__hex_literal_token1] = ACTIONS(7472),
    [sym__number_literal] = ACTIONS(7474),
    [anon_sym_SQUOTE] = ACTIONS(7472),
    [anon_sym_DQUOTE] = ACTIONS(7472),
    [sym_return] = ACTIONS(7474),
    [sym_next] = ACTIONS(7474),
    [sym_break] = ACTIONS(7474),
    [sym_true] = ACTIONS(7474),
    [sym_false] = ACTIONS(7474),
    [sym_null] = ACTIONS(7474),
    [sym_inf] = ACTIONS(7474),
    [sym_nan] = ACTIONS(7474),
    [anon_sym_NA] = ACTIONS(7474),
    [anon_sym_NA_integer_] = ACTIONS(7474),
    [anon_sym_NA_real_] = ACTIONS(7474),
    [anon_sym_NA_complex_] = ACTIONS(7474),
    [anon_sym_NA_character_] = ACTIONS(7474),
    [sym_dots] = ACTIONS(7474),
    [sym_dot_dot_i] = ACTIONS(7472),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7472),
    [sym__newline] = ACTIONS(7472),
    [sym__semicolon] = ACTIONS(7472),
    [sym__raw_string_literal] = ACTIONS(7472),
    [sym__external_open_parenthesis] = ACTIONS(7472),
    [sym__external_close_parenthesis] = ACTIONS(7472),
    [sym__external_open_brace] = ACTIONS(7472),
    [sym__external_close_brace] = ACTIONS(7472),
    [sym__external_open_bracket] = ACTIONS(7472),
    [sym__external_close_bracket] = ACTIONS(7472),
    [sym__external_open_bracket2] = ACTIONS(7472),
  },
  [2496] = {
    [sym_identifier] = ACTIONS(7474),
    [anon_sym_BSLASH] = ACTIONS(7472),
    [anon_sym_function] = ACTIONS(7474),
    [anon_sym_EQ] = ACTIONS(7474),
    [anon_sym_if] = ACTIONS(7474),
    [anon_sym_for] = ACTIONS(7474),
    [anon_sym_while] = ACTIONS(7474),
    [anon_sym_repeat] = ACTIONS(7474),
    [anon_sym_QMARK] = ACTIONS(7472),
    [anon_sym_TILDE] = ACTIONS(7472),
    [anon_sym_BANG] = ACTIONS(7474),
    [anon_sym_PLUS] = ACTIONS(7472),
    [anon_sym_DASH] = ACTIONS(7474),
    [anon_sym_LT_DASH] = ACTIONS(7472),
    [anon_sym_LT_LT_DASH] = ACTIONS(7472),
    [anon_sym_COLON_EQ] = ACTIONS(7472),
    [anon_sym_DASH_GT] = ACTIONS(7474),
    [anon_sym_DASH_GT_GT] = ACTIONS(7472),
    [anon_sym_PIPE] = ACTIONS(7474),
    [anon_sym_AMP] = ACTIONS(7474),
    [anon_sym_PIPE_PIPE] = ACTIONS(7472),
    [anon_sym_AMP_AMP] = ACTIONS(7472),
    [anon_sym_LT] = ACTIONS(7474),
    [anon_sym_LT_EQ] = ACTIONS(7472),
    [anon_sym_GT] = ACTIONS(7474),
    [anon_sym_GT_EQ] = ACTIONS(7472),
    [anon_sym_EQ_EQ] = ACTIONS(7472),
    [anon_sym_BANG_EQ] = ACTIONS(7472),
    [anon_sym_STAR] = ACTIONS(7474),
    [anon_sym_SLASH] = ACTIONS(7472),
    [anon_sym_STAR_STAR] = ACTIONS(7472),
    [anon_sym_CARET] = ACTIONS(7472),
    [aux_sym_binary_operator_token1] = ACTIONS(7472),
    [anon_sym_PIPE_GT] = ACTIONS(7472),
    [anon_sym_COLON] = ACTIONS(7474),
    [anon_sym_DOLLAR] = ACTIONS(7472),
    [anon_sym_AT] = ACTIONS(7472),
    [aux_sym__hex_literal_token1] = ACTIONS(7472),
    [sym__number_literal] = ACTIONS(7474),
    [anon_sym_SQUOTE] = ACTIONS(7472),
    [anon_sym_DQUOTE] = ACTIONS(7472),
    [sym_return] = ACTIONS(7474),
    [sym_next] = ACTIONS(7474),
    [sym_break] = ACTIONS(7474),
    [sym_true] = ACTIONS(7474),
    [sym_false] = ACTIONS(7474),
    [sym_null] = ACTIONS(7474),
    [sym_inf] = ACTIONS(7474),
    [sym_nan] = ACTIONS(7474),
    [anon_sym_NA] = ACTIONS(7474),
    [anon_sym_NA_integer_] = ACTIONS(7474),
    [anon_sym_NA_real_] = ACTIONS(7474),
    [anon_sym_NA_complex_] = ACTIONS(7474),
    [anon_sym_NA_character_] = ACTIONS(7474),
    [sym_dots] = ACTIONS(7474),
    [sym_dot_dot_i] = ACTIONS(7472),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7472),
    [sym__newline] = ACTIONS(7472),
    [sym__semicolon] = ACTIONS(7472),
    [sym__raw_string_literal] = ACTIONS(7472),
    [sym__external_else] = ACTIONS(7472),
    [sym__external_open_parenthesis] = ACTIONS(7472),
    [sym__external_open_brace] = ACTIONS(7472),
    [sym__external_close_brace] = ACTIONS(7472),
    [sym__external_open_bracket] = ACTIONS(7472),
    [sym__external_open_bracket2] = ACTIONS(7472),
    [sym__external_close_bracket2] = ACTIONS(7472),
  },
  [2497] = {
    [ts_builtin_sym_end] = ACTIONS(7193),
    [sym_identifier] = ACTIONS(7195),
    [anon_sym_BSLASH] = ACTIONS(7193),
    [anon_sym_function] = ACTIONS(7195),
    [anon_sym_EQ] = ACTIONS(7195),
    [anon_sym_if] = ACTIONS(7195),
    [anon_sym_for] = ACTIONS(7195),
    [anon_sym_while] = ACTIONS(7195),
    [anon_sym_repeat] = ACTIONS(7195),
    [anon_sym_QMARK] = ACTIONS(7193),
    [anon_sym_TILDE] = ACTIONS(7193),
    [anon_sym_BANG] = ACTIONS(7195),
    [anon_sym_PLUS] = ACTIONS(7193),
    [anon_sym_DASH] = ACTIONS(7195),
    [anon_sym_LT_DASH] = ACTIONS(7193),
    [anon_sym_LT_LT_DASH] = ACTIONS(7193),
    [anon_sym_COLON_EQ] = ACTIONS(7193),
    [anon_sym_DASH_GT] = ACTIONS(7195),
    [anon_sym_DASH_GT_GT] = ACTIONS(7193),
    [anon_sym_PIPE] = ACTIONS(7195),
    [anon_sym_AMP] = ACTIONS(7195),
    [anon_sym_PIPE_PIPE] = ACTIONS(7193),
    [anon_sym_AMP_AMP] = ACTIONS(7193),
    [anon_sym_LT] = ACTIONS(7195),
    [anon_sym_LT_EQ] = ACTIONS(7193),
    [anon_sym_GT] = ACTIONS(7195),
    [anon_sym_GT_EQ] = ACTIONS(7193),
    [anon_sym_EQ_EQ] = ACTIONS(7193),
    [anon_sym_BANG_EQ] = ACTIONS(7193),
    [anon_sym_STAR] = ACTIONS(7195),
    [anon_sym_SLASH] = ACTIONS(7193),
    [anon_sym_STAR_STAR] = ACTIONS(7193),
    [anon_sym_CARET] = ACTIONS(7193),
    [aux_sym_binary_operator_token1] = ACTIONS(7193),
    [anon_sym_PIPE_GT] = ACTIONS(7193),
    [anon_sym_COLON] = ACTIONS(7195),
    [anon_sym_DOLLAR] = ACTIONS(7193),
    [anon_sym_AT] = ACTIONS(7193),
    [anon_sym_COLON_COLON] = ACTIONS(7195),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7193),
    [aux_sym__hex_literal_token1] = ACTIONS(7193),
    [sym__number_literal] = ACTIONS(7195),
    [anon_sym_SQUOTE] = ACTIONS(7193),
    [anon_sym_DQUOTE] = ACTIONS(7193),
    [sym_return] = ACTIONS(7195),
    [sym_next] = ACTIONS(7195),
    [sym_break] = ACTIONS(7195),
    [sym_true] = ACTIONS(7195),
    [sym_false] = ACTIONS(7195),
    [sym_null] = ACTIONS(7195),
    [sym_inf] = ACTIONS(7195),
    [sym_nan] = ACTIONS(7195),
    [anon_sym_NA] = ACTIONS(7195),
    [anon_sym_NA_integer_] = ACTIONS(7195),
    [anon_sym_NA_real_] = ACTIONS(7195),
    [anon_sym_NA_complex_] = ACTIONS(7195),
    [anon_sym_NA_character_] = ACTIONS(7195),
    [sym_dots] = ACTIONS(7195),
    [sym_dot_dot_i] = ACTIONS(7193),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7193),
    [sym__semicolon] = ACTIONS(7193),
    [sym__raw_string_literal] = ACTIONS(7193),
    [sym__external_else] = ACTIONS(7193),
    [sym__external_open_parenthesis] = ACTIONS(7193),
    [sym__external_open_brace] = ACTIONS(7193),
    [sym__external_open_bracket] = ACTIONS(7193),
    [sym__external_open_bracket2] = ACTIONS(7193),
  },
  [2498] = {
    [sym_identifier] = ACTIONS(7486),
    [anon_sym_BSLASH] = ACTIONS(7484),
    [anon_sym_function] = ACTIONS(7486),
    [anon_sym_EQ] = ACTIONS(7486),
    [anon_sym_if] = ACTIONS(7486),
    [anon_sym_for] = ACTIONS(7486),
    [anon_sym_while] = ACTIONS(7486),
    [anon_sym_repeat] = ACTIONS(7486),
    [anon_sym_QMARK] = ACTIONS(7484),
    [anon_sym_TILDE] = ACTIONS(7484),
    [anon_sym_BANG] = ACTIONS(7486),
    [anon_sym_PLUS] = ACTIONS(7484),
    [anon_sym_DASH] = ACTIONS(7486),
    [anon_sym_LT_DASH] = ACTIONS(7484),
    [anon_sym_LT_LT_DASH] = ACTIONS(7484),
    [anon_sym_COLON_EQ] = ACTIONS(7484),
    [anon_sym_DASH_GT] = ACTIONS(7486),
    [anon_sym_DASH_GT_GT] = ACTIONS(7484),
    [anon_sym_PIPE] = ACTIONS(7486),
    [anon_sym_AMP] = ACTIONS(7486),
    [anon_sym_PIPE_PIPE] = ACTIONS(7484),
    [anon_sym_AMP_AMP] = ACTIONS(7484),
    [anon_sym_LT] = ACTIONS(7486),
    [anon_sym_LT_EQ] = ACTIONS(7484),
    [anon_sym_GT] = ACTIONS(7486),
    [anon_sym_GT_EQ] = ACTIONS(7484),
    [anon_sym_EQ_EQ] = ACTIONS(7484),
    [anon_sym_BANG_EQ] = ACTIONS(7484),
    [anon_sym_STAR] = ACTIONS(7486),
    [anon_sym_SLASH] = ACTIONS(7484),
    [anon_sym_STAR_STAR] = ACTIONS(7484),
    [anon_sym_CARET] = ACTIONS(7484),
    [aux_sym_binary_operator_token1] = ACTIONS(7484),
    [anon_sym_PIPE_GT] = ACTIONS(7484),
    [anon_sym_COLON] = ACTIONS(7486),
    [anon_sym_DOLLAR] = ACTIONS(7484),
    [anon_sym_AT] = ACTIONS(7484),
    [aux_sym__hex_literal_token1] = ACTIONS(7484),
    [sym__number_literal] = ACTIONS(7486),
    [anon_sym_SQUOTE] = ACTIONS(7484),
    [anon_sym_DQUOTE] = ACTIONS(7484),
    [sym_return] = ACTIONS(7486),
    [sym_next] = ACTIONS(7486),
    [sym_break] = ACTIONS(7486),
    [sym_true] = ACTIONS(7486),
    [sym_false] = ACTIONS(7486),
    [sym_null] = ACTIONS(7486),
    [sym_inf] = ACTIONS(7486),
    [sym_nan] = ACTIONS(7486),
    [anon_sym_NA] = ACTIONS(7486),
    [anon_sym_NA_integer_] = ACTIONS(7486),
    [anon_sym_NA_real_] = ACTIONS(7486),
    [anon_sym_NA_complex_] = ACTIONS(7486),
    [anon_sym_NA_character_] = ACTIONS(7486),
    [sym_dots] = ACTIONS(7486),
    [sym_dot_dot_i] = ACTIONS(7484),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7484),
    [sym__newline] = ACTIONS(7484),
    [sym__semicolon] = ACTIONS(7484),
    [sym__raw_string_literal] = ACTIONS(7484),
    [sym__external_open_parenthesis] = ACTIONS(7484),
    [sym__external_close_parenthesis] = ACTIONS(7484),
    [sym__external_open_brace] = ACTIONS(7484),
    [sym__external_close_brace] = ACTIONS(7484),
    [sym__external_open_bracket] = ACTIONS(7484),
    [sym__external_open_bracket2] = ACTIONS(7484),
    [sym__external_close_bracket2] = ACTIONS(7484),
  },
  [2499] = {
    [ts_builtin_sym_end] = ACTIONS(7189),
    [sym_identifier] = ACTIONS(7191),
    [anon_sym_BSLASH] = ACTIONS(7189),
    [anon_sym_function] = ACTIONS(7191),
    [anon_sym_EQ] = ACTIONS(7191),
    [anon_sym_if] = ACTIONS(7191),
    [anon_sym_for] = ACTIONS(7191),
    [anon_sym_while] = ACTIONS(7191),
    [anon_sym_repeat] = ACTIONS(7191),
    [anon_sym_QMARK] = ACTIONS(7189),
    [anon_sym_TILDE] = ACTIONS(7189),
    [anon_sym_BANG] = ACTIONS(7191),
    [anon_sym_PLUS] = ACTIONS(7189),
    [anon_sym_DASH] = ACTIONS(7191),
    [anon_sym_LT_DASH] = ACTIONS(7189),
    [anon_sym_LT_LT_DASH] = ACTIONS(7189),
    [anon_sym_COLON_EQ] = ACTIONS(7189),
    [anon_sym_DASH_GT] = ACTIONS(7191),
    [anon_sym_DASH_GT_GT] = ACTIONS(7189),
    [anon_sym_PIPE] = ACTIONS(7191),
    [anon_sym_AMP] = ACTIONS(7191),
    [anon_sym_PIPE_PIPE] = ACTIONS(7189),
    [anon_sym_AMP_AMP] = ACTIONS(7189),
    [anon_sym_LT] = ACTIONS(7191),
    [anon_sym_LT_EQ] = ACTIONS(7189),
    [anon_sym_GT] = ACTIONS(7191),
    [anon_sym_GT_EQ] = ACTIONS(7189),
    [anon_sym_EQ_EQ] = ACTIONS(7189),
    [anon_sym_BANG_EQ] = ACTIONS(7189),
    [anon_sym_STAR] = ACTIONS(7191),
    [anon_sym_SLASH] = ACTIONS(7189),
    [anon_sym_STAR_STAR] = ACTIONS(7189),
    [anon_sym_CARET] = ACTIONS(7189),
    [aux_sym_binary_operator_token1] = ACTIONS(7189),
    [anon_sym_PIPE_GT] = ACTIONS(7189),
    [anon_sym_COLON] = ACTIONS(7191),
    [anon_sym_DOLLAR] = ACTIONS(7189),
    [anon_sym_AT] = ACTIONS(7189),
    [anon_sym_COLON_COLON] = ACTIONS(7191),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7189),
    [aux_sym__hex_literal_token1] = ACTIONS(7189),
    [sym__number_literal] = ACTIONS(7191),
    [anon_sym_SQUOTE] = ACTIONS(7189),
    [anon_sym_DQUOTE] = ACTIONS(7189),
    [sym_return] = ACTIONS(7191),
    [sym_next] = ACTIONS(7191),
    [sym_break] = ACTIONS(7191),
    [sym_true] = ACTIONS(7191),
    [sym_false] = ACTIONS(7191),
    [sym_null] = ACTIONS(7191),
    [sym_inf] = ACTIONS(7191),
    [sym_nan] = ACTIONS(7191),
    [anon_sym_NA] = ACTIONS(7191),
    [anon_sym_NA_integer_] = ACTIONS(7191),
    [anon_sym_NA_real_] = ACTIONS(7191),
    [anon_sym_NA_complex_] = ACTIONS(7191),
    [anon_sym_NA_character_] = ACTIONS(7191),
    [sym_dots] = ACTIONS(7191),
    [sym_dot_dot_i] = ACTIONS(7189),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7189),
    [sym__semicolon] = ACTIONS(7189),
    [sym__raw_string_literal] = ACTIONS(7189),
    [sym__external_else] = ACTIONS(7189),
    [sym__external_open_parenthesis] = ACTIONS(7189),
    [sym__external_open_brace] = ACTIONS(7189),
    [sym__external_open_bracket] = ACTIONS(7189),
    [sym__external_open_bracket2] = ACTIONS(7189),
  },
  [2500] = {
    [sym_identifier] = ACTIONS(7464),
    [anon_sym_BSLASH] = ACTIONS(7466),
    [anon_sym_function] = ACTIONS(7464),
    [anon_sym_EQ] = ACTIONS(7464),
    [anon_sym_if] = ACTIONS(7464),
    [anon_sym_for] = ACTIONS(7464),
    [anon_sym_while] = ACTIONS(7464),
    [anon_sym_repeat] = ACTIONS(7464),
    [anon_sym_QMARK] = ACTIONS(7466),
    [anon_sym_TILDE] = ACTIONS(7466),
    [anon_sym_BANG] = ACTIONS(7464),
    [anon_sym_PLUS] = ACTIONS(7466),
    [anon_sym_DASH] = ACTIONS(7464),
    [anon_sym_LT_DASH] = ACTIONS(7466),
    [anon_sym_LT_LT_DASH] = ACTIONS(7466),
    [anon_sym_COLON_EQ] = ACTIONS(7466),
    [anon_sym_DASH_GT] = ACTIONS(7464),
    [anon_sym_DASH_GT_GT] = ACTIONS(7466),
    [anon_sym_PIPE] = ACTIONS(7464),
    [anon_sym_AMP] = ACTIONS(7464),
    [anon_sym_PIPE_PIPE] = ACTIONS(7466),
    [anon_sym_AMP_AMP] = ACTIONS(7466),
    [anon_sym_LT] = ACTIONS(7464),
    [anon_sym_LT_EQ] = ACTIONS(7466),
    [anon_sym_GT] = ACTIONS(7464),
    [anon_sym_GT_EQ] = ACTIONS(7466),
    [anon_sym_EQ_EQ] = ACTIONS(7466),
    [anon_sym_BANG_EQ] = ACTIONS(7466),
    [anon_sym_STAR] = ACTIONS(7464),
    [anon_sym_SLASH] = ACTIONS(7466),
    [anon_sym_STAR_STAR] = ACTIONS(7466),
    [anon_sym_CARET] = ACTIONS(7466),
    [aux_sym_binary_operator_token1] = ACTIONS(7466),
    [anon_sym_PIPE_GT] = ACTIONS(7466),
    [anon_sym_COLON] = ACTIONS(7464),
    [anon_sym_DOLLAR] = ACTIONS(7466),
    [anon_sym_AT] = ACTIONS(7466),
    [aux_sym__hex_literal_token1] = ACTIONS(7466),
    [sym__number_literal] = ACTIONS(7464),
    [anon_sym_SQUOTE] = ACTIONS(7466),
    [anon_sym_DQUOTE] = ACTIONS(7466),
    [sym_return] = ACTIONS(7464),
    [sym_next] = ACTIONS(7464),
    [sym_break] = ACTIONS(7464),
    [sym_true] = ACTIONS(7464),
    [sym_false] = ACTIONS(7464),
    [sym_null] = ACTIONS(7464),
    [sym_inf] = ACTIONS(7464),
    [sym_nan] = ACTIONS(7464),
    [anon_sym_NA] = ACTIONS(7464),
    [anon_sym_NA_integer_] = ACTIONS(7464),
    [anon_sym_NA_real_] = ACTIONS(7464),
    [anon_sym_NA_complex_] = ACTIONS(7464),
    [anon_sym_NA_character_] = ACTIONS(7464),
    [sym_dots] = ACTIONS(7464),
    [sym_dot_dot_i] = ACTIONS(7466),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7466),
    [sym__newline] = ACTIONS(7466),
    [sym__semicolon] = ACTIONS(7466),
    [sym__raw_string_literal] = ACTIONS(7466),
    [sym__external_else] = ACTIONS(7466),
    [sym__external_open_parenthesis] = ACTIONS(7466),
    [sym__external_open_brace] = ACTIONS(7466),
    [sym__external_close_brace] = ACTIONS(7466),
    [sym__external_open_bracket] = ACTIONS(7466),
    [sym__external_open_bracket2] = ACTIONS(7466),
    [sym__external_close_bracket2] = ACTIONS(7466),
  },
  [2501] = {
    [sym_identifier] = ACTIONS(7478),
    [anon_sym_BSLASH] = ACTIONS(7476),
    [anon_sym_function] = ACTIONS(7478),
    [anon_sym_EQ] = ACTIONS(7478),
    [anon_sym_if] = ACTIONS(7478),
    [anon_sym_for] = ACTIONS(7478),
    [anon_sym_while] = ACTIONS(7478),
    [anon_sym_repeat] = ACTIONS(7478),
    [anon_sym_QMARK] = ACTIONS(7476),
    [anon_sym_TILDE] = ACTIONS(7476),
    [anon_sym_BANG] = ACTIONS(7478),
    [anon_sym_PLUS] = ACTIONS(7476),
    [anon_sym_DASH] = ACTIONS(7478),
    [anon_sym_LT_DASH] = ACTIONS(7476),
    [anon_sym_LT_LT_DASH] = ACTIONS(7476),
    [anon_sym_COLON_EQ] = ACTIONS(7476),
    [anon_sym_DASH_GT] = ACTIONS(7478),
    [anon_sym_DASH_GT_GT] = ACTIONS(7476),
    [anon_sym_PIPE] = ACTIONS(7478),
    [anon_sym_AMP] = ACTIONS(7478),
    [anon_sym_PIPE_PIPE] = ACTIONS(7476),
    [anon_sym_AMP_AMP] = ACTIONS(7476),
    [anon_sym_LT] = ACTIONS(7478),
    [anon_sym_LT_EQ] = ACTIONS(7476),
    [anon_sym_GT] = ACTIONS(7478),
    [anon_sym_GT_EQ] = ACTIONS(7476),
    [anon_sym_EQ_EQ] = ACTIONS(7476),
    [anon_sym_BANG_EQ] = ACTIONS(7476),
    [anon_sym_STAR] = ACTIONS(7478),
    [anon_sym_SLASH] = ACTIONS(7476),
    [anon_sym_STAR_STAR] = ACTIONS(7476),
    [anon_sym_CARET] = ACTIONS(7476),
    [aux_sym_binary_operator_token1] = ACTIONS(7476),
    [anon_sym_PIPE_GT] = ACTIONS(7476),
    [anon_sym_COLON] = ACTIONS(7478),
    [anon_sym_DOLLAR] = ACTIONS(7476),
    [anon_sym_AT] = ACTIONS(7476),
    [aux_sym__hex_literal_token1] = ACTIONS(7476),
    [sym__number_literal] = ACTIONS(7478),
    [anon_sym_SQUOTE] = ACTIONS(7476),
    [anon_sym_DQUOTE] = ACTIONS(7476),
    [sym_return] = ACTIONS(7478),
    [sym_next] = ACTIONS(7478),
    [sym_break] = ACTIONS(7478),
    [sym_true] = ACTIONS(7478),
    [sym_false] = ACTIONS(7478),
    [sym_null] = ACTIONS(7478),
    [sym_inf] = ACTIONS(7478),
    [sym_nan] = ACTIONS(7478),
    [anon_sym_NA] = ACTIONS(7478),
    [anon_sym_NA_integer_] = ACTIONS(7478),
    [anon_sym_NA_real_] = ACTIONS(7478),
    [anon_sym_NA_complex_] = ACTIONS(7478),
    [anon_sym_NA_character_] = ACTIONS(7478),
    [sym_dots] = ACTIONS(7478),
    [sym_dot_dot_i] = ACTIONS(7476),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7476),
    [sym__newline] = ACTIONS(7476),
    [sym__semicolon] = ACTIONS(7476),
    [sym__raw_string_literal] = ACTIONS(7476),
    [sym__external_else] = ACTIONS(7476),
    [sym__external_open_parenthesis] = ACTIONS(7476),
    [sym__external_open_brace] = ACTIONS(7476),
    [sym__external_close_brace] = ACTIONS(7476),
    [sym__external_open_bracket] = ACTIONS(7476),
    [sym__external_open_bracket2] = ACTIONS(7476),
    [sym__external_close_bracket2] = ACTIONS(7476),
  },
  [2502] = {
    [sym_identifier] = ACTIONS(7482),
    [anon_sym_BSLASH] = ACTIONS(7480),
    [anon_sym_function] = ACTIONS(7482),
    [anon_sym_EQ] = ACTIONS(7482),
    [anon_sym_if] = ACTIONS(7482),
    [anon_sym_for] = ACTIONS(7482),
    [anon_sym_while] = ACTIONS(7482),
    [anon_sym_repeat] = ACTIONS(7482),
    [anon_sym_QMARK] = ACTIONS(7480),
    [anon_sym_TILDE] = ACTIONS(7480),
    [anon_sym_BANG] = ACTIONS(7482),
    [anon_sym_PLUS] = ACTIONS(7480),
    [anon_sym_DASH] = ACTIONS(7482),
    [anon_sym_LT_DASH] = ACTIONS(7480),
    [anon_sym_LT_LT_DASH] = ACTIONS(7480),
    [anon_sym_COLON_EQ] = ACTIONS(7480),
    [anon_sym_DASH_GT] = ACTIONS(7482),
    [anon_sym_DASH_GT_GT] = ACTIONS(7480),
    [anon_sym_PIPE] = ACTIONS(7482),
    [anon_sym_AMP] = ACTIONS(7482),
    [anon_sym_PIPE_PIPE] = ACTIONS(7480),
    [anon_sym_AMP_AMP] = ACTIONS(7480),
    [anon_sym_LT] = ACTIONS(7482),
    [anon_sym_LT_EQ] = ACTIONS(7480),
    [anon_sym_GT] = ACTIONS(7482),
    [anon_sym_GT_EQ] = ACTIONS(7480),
    [anon_sym_EQ_EQ] = ACTIONS(7480),
    [anon_sym_BANG_EQ] = ACTIONS(7480),
    [anon_sym_STAR] = ACTIONS(7482),
    [anon_sym_SLASH] = ACTIONS(7480),
    [anon_sym_STAR_STAR] = ACTIONS(7480),
    [anon_sym_CARET] = ACTIONS(7480),
    [aux_sym_binary_operator_token1] = ACTIONS(7480),
    [anon_sym_PIPE_GT] = ACTIONS(7480),
    [anon_sym_COLON] = ACTIONS(7482),
    [anon_sym_DOLLAR] = ACTIONS(7480),
    [anon_sym_AT] = ACTIONS(7480),
    [aux_sym__hex_literal_token1] = ACTIONS(7480),
    [sym__number_literal] = ACTIONS(7482),
    [anon_sym_SQUOTE] = ACTIONS(7480),
    [anon_sym_DQUOTE] = ACTIONS(7480),
    [sym_return] = ACTIONS(7482),
    [sym_next] = ACTIONS(7482),
    [sym_break] = ACTIONS(7482),
    [sym_true] = ACTIONS(7482),
    [sym_false] = ACTIONS(7482),
    [sym_null] = ACTIONS(7482),
    [sym_inf] = ACTIONS(7482),
    [sym_nan] = ACTIONS(7482),
    [anon_sym_NA] = ACTIONS(7482),
    [anon_sym_NA_integer_] = ACTIONS(7482),
    [anon_sym_NA_real_] = ACTIONS(7482),
    [anon_sym_NA_complex_] = ACTIONS(7482),
    [anon_sym_NA_character_] = ACTIONS(7482),
    [sym_dots] = ACTIONS(7482),
    [sym_dot_dot_i] = ACTIONS(7480),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7480),
    [sym__newline] = ACTIONS(7480),
    [sym__semicolon] = ACTIONS(7480),
    [sym__raw_string_literal] = ACTIONS(7480),
    [sym__external_else] = ACTIONS(7480),
    [sym__external_open_parenthesis] = ACTIONS(7480),
    [sym__external_open_brace] = ACTIONS(7480),
    [sym__external_close_brace] = ACTIONS(7480),
    [sym__external_open_bracket] = ACTIONS(7480),
    [sym__external_open_bracket2] = ACTIONS(7480),
    [sym__external_close_bracket2] = ACTIONS(7480),
  },
  [2503] = {
    [aux_sym_function_definition_repeat1] = STATE(2503),
    [sym_identifier] = ACTIONS(7419),
    [anon_sym_BSLASH] = ACTIONS(7417),
    [anon_sym_function] = ACTIONS(7419),
    [anon_sym_EQ] = ACTIONS(7419),
    [anon_sym_if] = ACTIONS(7419),
    [anon_sym_for] = ACTIONS(7419),
    [anon_sym_while] = ACTIONS(7419),
    [anon_sym_repeat] = ACTIONS(7419),
    [anon_sym_QMARK] = ACTIONS(7417),
    [anon_sym_TILDE] = ACTIONS(7417),
    [anon_sym_BANG] = ACTIONS(7419),
    [anon_sym_PLUS] = ACTIONS(7417),
    [anon_sym_DASH] = ACTIONS(7419),
    [anon_sym_LT_DASH] = ACTIONS(7417),
    [anon_sym_LT_LT_DASH] = ACTIONS(7417),
    [anon_sym_COLON_EQ] = ACTIONS(7417),
    [anon_sym_DASH_GT] = ACTIONS(7419),
    [anon_sym_DASH_GT_GT] = ACTIONS(7417),
    [anon_sym_PIPE] = ACTIONS(7419),
    [anon_sym_AMP] = ACTIONS(7419),
    [anon_sym_PIPE_PIPE] = ACTIONS(7417),
    [anon_sym_AMP_AMP] = ACTIONS(7417),
    [anon_sym_LT] = ACTIONS(7419),
    [anon_sym_LT_EQ] = ACTIONS(7417),
    [anon_sym_GT] = ACTIONS(7419),
    [anon_sym_GT_EQ] = ACTIONS(7417),
    [anon_sym_EQ_EQ] = ACTIONS(7417),
    [anon_sym_BANG_EQ] = ACTIONS(7417),
    [anon_sym_STAR] = ACTIONS(7419),
    [anon_sym_SLASH] = ACTIONS(7417),
    [anon_sym_STAR_STAR] = ACTIONS(7417),
    [anon_sym_CARET] = ACTIONS(7417),
    [aux_sym_binary_operator_token1] = ACTIONS(7417),
    [anon_sym_PIPE_GT] = ACTIONS(7417),
    [anon_sym_COLON] = ACTIONS(7419),
    [anon_sym_DOLLAR] = ACTIONS(7417),
    [anon_sym_AT] = ACTIONS(7417),
    [aux_sym__hex_literal_token1] = ACTIONS(7417),
    [sym__number_literal] = ACTIONS(7419),
    [anon_sym_SQUOTE] = ACTIONS(7417),
    [anon_sym_DQUOTE] = ACTIONS(7417),
    [sym_return] = ACTIONS(7419),
    [sym_next] = ACTIONS(7419),
    [sym_break] = ACTIONS(7419),
    [sym_true] = ACTIONS(7419),
    [sym_false] = ACTIONS(7419),
    [sym_null] = ACTIONS(7419),
    [sym_inf] = ACTIONS(7419),
    [sym_nan] = ACTIONS(7419),
    [anon_sym_NA] = ACTIONS(7419),
    [anon_sym_NA_integer_] = ACTIONS(7419),
    [anon_sym_NA_real_] = ACTIONS(7419),
    [anon_sym_NA_complex_] = ACTIONS(7419),
    [anon_sym_NA_character_] = ACTIONS(7419),
    [sym_dots] = ACTIONS(7419),
    [sym_dot_dot_i] = ACTIONS(7417),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7417),
    [sym__newline] = ACTIONS(7634),
    [sym__raw_string_literal] = ACTIONS(7417),
    [sym__external_else] = ACTIONS(7417),
    [sym__external_open_parenthesis] = ACTIONS(7417),
    [sym__external_close_parenthesis] = ACTIONS(7417),
    [sym__external_open_brace] = ACTIONS(7417),
    [sym__external_open_bracket] = ACTIONS(7417),
    [sym__external_close_bracket] = ACTIONS(7417),
    [sym__external_open_bracket2] = ACTIONS(7417),
  },
  [2504] = {
    [sym_identifier] = ACTIONS(7490),
    [anon_sym_BSLASH] = ACTIONS(7488),
    [anon_sym_function] = ACTIONS(7490),
    [anon_sym_EQ] = ACTIONS(7490),
    [anon_sym_if] = ACTIONS(7490),
    [anon_sym_for] = ACTIONS(7490),
    [anon_sym_while] = ACTIONS(7490),
    [anon_sym_repeat] = ACTIONS(7490),
    [anon_sym_QMARK] = ACTIONS(7488),
    [anon_sym_TILDE] = ACTIONS(7488),
    [anon_sym_BANG] = ACTIONS(7490),
    [anon_sym_PLUS] = ACTIONS(7488),
    [anon_sym_DASH] = ACTIONS(7490),
    [anon_sym_LT_DASH] = ACTIONS(7488),
    [anon_sym_LT_LT_DASH] = ACTIONS(7488),
    [anon_sym_COLON_EQ] = ACTIONS(7488),
    [anon_sym_DASH_GT] = ACTIONS(7490),
    [anon_sym_DASH_GT_GT] = ACTIONS(7488),
    [anon_sym_PIPE] = ACTIONS(7490),
    [anon_sym_AMP] = ACTIONS(7490),
    [anon_sym_PIPE_PIPE] = ACTIONS(7488),
    [anon_sym_AMP_AMP] = ACTIONS(7488),
    [anon_sym_LT] = ACTIONS(7490),
    [anon_sym_LT_EQ] = ACTIONS(7488),
    [anon_sym_GT] = ACTIONS(7490),
    [anon_sym_GT_EQ] = ACTIONS(7488),
    [anon_sym_EQ_EQ] = ACTIONS(7488),
    [anon_sym_BANG_EQ] = ACTIONS(7488),
    [anon_sym_STAR] = ACTIONS(7490),
    [anon_sym_SLASH] = ACTIONS(7488),
    [anon_sym_STAR_STAR] = ACTIONS(7488),
    [anon_sym_CARET] = ACTIONS(7488),
    [aux_sym_binary_operator_token1] = ACTIONS(7488),
    [anon_sym_PIPE_GT] = ACTIONS(7488),
    [anon_sym_COLON] = ACTIONS(7490),
    [anon_sym_DOLLAR] = ACTIONS(7488),
    [anon_sym_AT] = ACTIONS(7488),
    [aux_sym__hex_literal_token1] = ACTIONS(7488),
    [sym__number_literal] = ACTIONS(7490),
    [anon_sym_SQUOTE] = ACTIONS(7488),
    [anon_sym_DQUOTE] = ACTIONS(7488),
    [sym_return] = ACTIONS(7490),
    [sym_next] = ACTIONS(7490),
    [sym_break] = ACTIONS(7490),
    [sym_true] = ACTIONS(7490),
    [sym_false] = ACTIONS(7490),
    [sym_null] = ACTIONS(7490),
    [sym_inf] = ACTIONS(7490),
    [sym_nan] = ACTIONS(7490),
    [anon_sym_NA] = ACTIONS(7490),
    [anon_sym_NA_integer_] = ACTIONS(7490),
    [anon_sym_NA_real_] = ACTIONS(7490),
    [anon_sym_NA_complex_] = ACTIONS(7490),
    [anon_sym_NA_character_] = ACTIONS(7490),
    [sym_dots] = ACTIONS(7490),
    [sym_dot_dot_i] = ACTIONS(7488),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7488),
    [sym__newline] = ACTIONS(7488),
    [sym__semicolon] = ACTIONS(7488),
    [sym__raw_string_literal] = ACTIONS(7488),
    [sym__external_open_parenthesis] = ACTIONS(7488),
    [sym__external_close_parenthesis] = ACTIONS(7488),
    [sym__external_open_brace] = ACTIONS(7488),
    [sym__external_close_brace] = ACTIONS(7488),
    [sym__external_open_bracket] = ACTIONS(7488),
    [sym__external_open_bracket2] = ACTIONS(7488),
    [sym__external_close_bracket2] = ACTIONS(7488),
  },
  [2505] = {
    [ts_builtin_sym_end] = ACTIONS(7522),
    [sym_identifier] = ACTIONS(7524),
    [anon_sym_BSLASH] = ACTIONS(7522),
    [anon_sym_function] = ACTIONS(7524),
    [anon_sym_EQ] = ACTIONS(7524),
    [anon_sym_if] = ACTIONS(7524),
    [anon_sym_for] = ACTIONS(7524),
    [anon_sym_while] = ACTIONS(7524),
    [anon_sym_repeat] = ACTIONS(7524),
    [anon_sym_QMARK] = ACTIONS(7522),
    [anon_sym_TILDE] = ACTIONS(7522),
    [anon_sym_BANG] = ACTIONS(7524),
    [anon_sym_PLUS] = ACTIONS(7522),
    [anon_sym_DASH] = ACTIONS(7524),
    [anon_sym_LT_DASH] = ACTIONS(7522),
    [anon_sym_LT_LT_DASH] = ACTIONS(7522),
    [anon_sym_COLON_EQ] = ACTIONS(7522),
    [anon_sym_DASH_GT] = ACTIONS(7524),
    [anon_sym_DASH_GT_GT] = ACTIONS(7522),
    [anon_sym_PIPE] = ACTIONS(7524),
    [anon_sym_AMP] = ACTIONS(7524),
    [anon_sym_PIPE_PIPE] = ACTIONS(7522),
    [anon_sym_AMP_AMP] = ACTIONS(7522),
    [anon_sym_LT] = ACTIONS(7524),
    [anon_sym_LT_EQ] = ACTIONS(7522),
    [anon_sym_GT] = ACTIONS(7524),
    [anon_sym_GT_EQ] = ACTIONS(7522),
    [anon_sym_EQ_EQ] = ACTIONS(7522),
    [anon_sym_BANG_EQ] = ACTIONS(7522),
    [anon_sym_STAR] = ACTIONS(7524),
    [anon_sym_SLASH] = ACTIONS(7522),
    [anon_sym_STAR_STAR] = ACTIONS(7522),
    [anon_sym_CARET] = ACTIONS(7522),
    [aux_sym_binary_operator_token1] = ACTIONS(7522),
    [anon_sym_PIPE_GT] = ACTIONS(7522),
    [anon_sym_COLON] = ACTIONS(7524),
    [anon_sym_DOLLAR] = ACTIONS(7522),
    [anon_sym_AT] = ACTIONS(7522),
    [aux_sym__hex_literal_token1] = ACTIONS(7522),
    [sym__number_literal] = ACTIONS(7524),
    [anon_sym_SQUOTE] = ACTIONS(7522),
    [anon_sym_DQUOTE] = ACTIONS(7522),
    [sym_return] = ACTIONS(7524),
    [sym_next] = ACTIONS(7524),
    [sym_break] = ACTIONS(7524),
    [sym_true] = ACTIONS(7524),
    [sym_false] = ACTIONS(7524),
    [sym_null] = ACTIONS(7524),
    [sym_inf] = ACTIONS(7524),
    [sym_nan] = ACTIONS(7524),
    [anon_sym_NA] = ACTIONS(7524),
    [anon_sym_NA_integer_] = ACTIONS(7524),
    [anon_sym_NA_real_] = ACTIONS(7524),
    [anon_sym_NA_complex_] = ACTIONS(7524),
    [anon_sym_NA_character_] = ACTIONS(7524),
    [sym_dots] = ACTIONS(7524),
    [sym_dot_dot_i] = ACTIONS(7522),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7522),
    [sym__newline] = ACTIONS(7522),
    [sym__semicolon] = ACTIONS(7522),
    [sym__raw_string_literal] = ACTIONS(7522),
    [sym__external_open_parenthesis] = ACTIONS(7522),
    [sym__external_close_parenthesis] = ACTIONS(7522),
    [sym__external_open_brace] = ACTIONS(7522),
    [sym__external_close_brace] = ACTIONS(7522),
    [sym__external_open_bracket] = ACTIONS(7522),
    [sym__external_open_bracket2] = ACTIONS(7522),
  },
  [2506] = {
    [sym_identifier] = ACTIONS(7494),
    [anon_sym_BSLASH] = ACTIONS(7492),
    [anon_sym_function] = ACTIONS(7494),
    [anon_sym_EQ] = ACTIONS(7494),
    [anon_sym_if] = ACTIONS(7494),
    [anon_sym_for] = ACTIONS(7494),
    [anon_sym_while] = ACTIONS(7494),
    [anon_sym_repeat] = ACTIONS(7494),
    [anon_sym_QMARK] = ACTIONS(7492),
    [anon_sym_TILDE] = ACTIONS(7492),
    [anon_sym_BANG] = ACTIONS(7494),
    [anon_sym_PLUS] = ACTIONS(7492),
    [anon_sym_DASH] = ACTIONS(7494),
    [anon_sym_LT_DASH] = ACTIONS(7492),
    [anon_sym_LT_LT_DASH] = ACTIONS(7492),
    [anon_sym_COLON_EQ] = ACTIONS(7492),
    [anon_sym_DASH_GT] = ACTIONS(7494),
    [anon_sym_DASH_GT_GT] = ACTIONS(7492),
    [anon_sym_PIPE] = ACTIONS(7494),
    [anon_sym_AMP] = ACTIONS(7494),
    [anon_sym_PIPE_PIPE] = ACTIONS(7492),
    [anon_sym_AMP_AMP] = ACTIONS(7492),
    [anon_sym_LT] = ACTIONS(7494),
    [anon_sym_LT_EQ] = ACTIONS(7492),
    [anon_sym_GT] = ACTIONS(7494),
    [anon_sym_GT_EQ] = ACTIONS(7492),
    [anon_sym_EQ_EQ] = ACTIONS(7492),
    [anon_sym_BANG_EQ] = ACTIONS(7492),
    [anon_sym_STAR] = ACTIONS(7494),
    [anon_sym_SLASH] = ACTIONS(7492),
    [anon_sym_STAR_STAR] = ACTIONS(7492),
    [anon_sym_CARET] = ACTIONS(7492),
    [aux_sym_binary_operator_token1] = ACTIONS(7492),
    [anon_sym_PIPE_GT] = ACTIONS(7492),
    [anon_sym_COLON] = ACTIONS(7494),
    [anon_sym_DOLLAR] = ACTIONS(7492),
    [anon_sym_AT] = ACTIONS(7492),
    [aux_sym__hex_literal_token1] = ACTIONS(7492),
    [sym__number_literal] = ACTIONS(7494),
    [anon_sym_SQUOTE] = ACTIONS(7492),
    [anon_sym_DQUOTE] = ACTIONS(7492),
    [sym_return] = ACTIONS(7494),
    [sym_next] = ACTIONS(7494),
    [sym_break] = ACTIONS(7494),
    [sym_true] = ACTIONS(7494),
    [sym_false] = ACTIONS(7494),
    [sym_null] = ACTIONS(7494),
    [sym_inf] = ACTIONS(7494),
    [sym_nan] = ACTIONS(7494),
    [anon_sym_NA] = ACTIONS(7494),
    [anon_sym_NA_integer_] = ACTIONS(7494),
    [anon_sym_NA_real_] = ACTIONS(7494),
    [anon_sym_NA_complex_] = ACTIONS(7494),
    [anon_sym_NA_character_] = ACTIONS(7494),
    [sym_dots] = ACTIONS(7494),
    [sym_dot_dot_i] = ACTIONS(7492),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7492),
    [sym__newline] = ACTIONS(7492),
    [sym__semicolon] = ACTIONS(7492),
    [sym__raw_string_literal] = ACTIONS(7492),
    [sym__external_open_parenthesis] = ACTIONS(7492),
    [sym__external_close_parenthesis] = ACTIONS(7492),
    [sym__external_open_brace] = ACTIONS(7492),
    [sym__external_close_brace] = ACTIONS(7492),
    [sym__external_open_bracket] = ACTIONS(7492),
    [sym__external_open_bracket2] = ACTIONS(7492),
    [sym__external_close_bracket2] = ACTIONS(7492),
  },
  [2507] = {
    [ts_builtin_sym_end] = ACTIONS(7526),
    [sym_identifier] = ACTIONS(7528),
    [anon_sym_BSLASH] = ACTIONS(7526),
    [anon_sym_function] = ACTIONS(7528),
    [anon_sym_EQ] = ACTIONS(7528),
    [anon_sym_if] = ACTIONS(7528),
    [anon_sym_for] = ACTIONS(7528),
    [anon_sym_while] = ACTIONS(7528),
    [anon_sym_repeat] = ACTIONS(7528),
    [anon_sym_QMARK] = ACTIONS(7526),
    [anon_sym_TILDE] = ACTIONS(7526),
    [anon_sym_BANG] = ACTIONS(7528),
    [anon_sym_PLUS] = ACTIONS(7526),
    [anon_sym_DASH] = ACTIONS(7528),
    [anon_sym_LT_DASH] = ACTIONS(7526),
    [anon_sym_LT_LT_DASH] = ACTIONS(7526),
    [anon_sym_COLON_EQ] = ACTIONS(7526),
    [anon_sym_DASH_GT] = ACTIONS(7528),
    [anon_sym_DASH_GT_GT] = ACTIONS(7526),
    [anon_sym_PIPE] = ACTIONS(7528),
    [anon_sym_AMP] = ACTIONS(7528),
    [anon_sym_PIPE_PIPE] = ACTIONS(7526),
    [anon_sym_AMP_AMP] = ACTIONS(7526),
    [anon_sym_LT] = ACTIONS(7528),
    [anon_sym_LT_EQ] = ACTIONS(7526),
    [anon_sym_GT] = ACTIONS(7528),
    [anon_sym_GT_EQ] = ACTIONS(7526),
    [anon_sym_EQ_EQ] = ACTIONS(7526),
    [anon_sym_BANG_EQ] = ACTIONS(7526),
    [anon_sym_STAR] = ACTIONS(7528),
    [anon_sym_SLASH] = ACTIONS(7526),
    [anon_sym_STAR_STAR] = ACTIONS(7526),
    [anon_sym_CARET] = ACTIONS(7526),
    [aux_sym_binary_operator_token1] = ACTIONS(7526),
    [anon_sym_PIPE_GT] = ACTIONS(7526),
    [anon_sym_COLON] = ACTIONS(7528),
    [anon_sym_DOLLAR] = ACTIONS(7526),
    [anon_sym_AT] = ACTIONS(7526),
    [aux_sym__hex_literal_token1] = ACTIONS(7526),
    [sym__number_literal] = ACTIONS(7528),
    [anon_sym_SQUOTE] = ACTIONS(7526),
    [anon_sym_DQUOTE] = ACTIONS(7526),
    [sym_return] = ACTIONS(7528),
    [sym_next] = ACTIONS(7528),
    [sym_break] = ACTIONS(7528),
    [sym_true] = ACTIONS(7528),
    [sym_false] = ACTIONS(7528),
    [sym_null] = ACTIONS(7528),
    [sym_inf] = ACTIONS(7528),
    [sym_nan] = ACTIONS(7528),
    [anon_sym_NA] = ACTIONS(7528),
    [anon_sym_NA_integer_] = ACTIONS(7528),
    [anon_sym_NA_real_] = ACTIONS(7528),
    [anon_sym_NA_complex_] = ACTIONS(7528),
    [anon_sym_NA_character_] = ACTIONS(7528),
    [sym_dots] = ACTIONS(7528),
    [sym_dot_dot_i] = ACTIONS(7526),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7526),
    [sym__newline] = ACTIONS(7526),
    [sym__semicolon] = ACTIONS(7526),
    [sym__raw_string_literal] = ACTIONS(7526),
    [sym__external_open_parenthesis] = ACTIONS(7526),
    [sym__external_close_parenthesis] = ACTIONS(7526),
    [sym__external_open_brace] = ACTIONS(7526),
    [sym__external_close_brace] = ACTIONS(7526),
    [sym__external_open_bracket] = ACTIONS(7526),
    [sym__external_open_bracket2] = ACTIONS(7526),
  },
  [2508] = {
    [sym_identifier] = ACTIONS(7498),
    [anon_sym_BSLASH] = ACTIONS(7496),
    [anon_sym_function] = ACTIONS(7498),
    [anon_sym_EQ] = ACTIONS(7498),
    [anon_sym_if] = ACTIONS(7498),
    [anon_sym_for] = ACTIONS(7498),
    [anon_sym_while] = ACTIONS(7498),
    [anon_sym_repeat] = ACTIONS(7498),
    [anon_sym_QMARK] = ACTIONS(7496),
    [anon_sym_TILDE] = ACTIONS(7496),
    [anon_sym_BANG] = ACTIONS(7498),
    [anon_sym_PLUS] = ACTIONS(7496),
    [anon_sym_DASH] = ACTIONS(7498),
    [anon_sym_LT_DASH] = ACTIONS(7496),
    [anon_sym_LT_LT_DASH] = ACTIONS(7496),
    [anon_sym_COLON_EQ] = ACTIONS(7496),
    [anon_sym_DASH_GT] = ACTIONS(7498),
    [anon_sym_DASH_GT_GT] = ACTIONS(7496),
    [anon_sym_PIPE] = ACTIONS(7498),
    [anon_sym_AMP] = ACTIONS(7498),
    [anon_sym_PIPE_PIPE] = ACTIONS(7496),
    [anon_sym_AMP_AMP] = ACTIONS(7496),
    [anon_sym_LT] = ACTIONS(7498),
    [anon_sym_LT_EQ] = ACTIONS(7496),
    [anon_sym_GT] = ACTIONS(7498),
    [anon_sym_GT_EQ] = ACTIONS(7496),
    [anon_sym_EQ_EQ] = ACTIONS(7496),
    [anon_sym_BANG_EQ] = ACTIONS(7496),
    [anon_sym_STAR] = ACTIONS(7498),
    [anon_sym_SLASH] = ACTIONS(7496),
    [anon_sym_STAR_STAR] = ACTIONS(7496),
    [anon_sym_CARET] = ACTIONS(7496),
    [aux_sym_binary_operator_token1] = ACTIONS(7496),
    [anon_sym_PIPE_GT] = ACTIONS(7496),
    [anon_sym_COLON] = ACTIONS(7498),
    [anon_sym_DOLLAR] = ACTIONS(7496),
    [anon_sym_AT] = ACTIONS(7496),
    [aux_sym__hex_literal_token1] = ACTIONS(7496),
    [sym__number_literal] = ACTIONS(7498),
    [anon_sym_SQUOTE] = ACTIONS(7496),
    [anon_sym_DQUOTE] = ACTIONS(7496),
    [sym_return] = ACTIONS(7498),
    [sym_next] = ACTIONS(7498),
    [sym_break] = ACTIONS(7498),
    [sym_true] = ACTIONS(7498),
    [sym_false] = ACTIONS(7498),
    [sym_null] = ACTIONS(7498),
    [sym_inf] = ACTIONS(7498),
    [sym_nan] = ACTIONS(7498),
    [anon_sym_NA] = ACTIONS(7498),
    [anon_sym_NA_integer_] = ACTIONS(7498),
    [anon_sym_NA_real_] = ACTIONS(7498),
    [anon_sym_NA_complex_] = ACTIONS(7498),
    [anon_sym_NA_character_] = ACTIONS(7498),
    [sym_dots] = ACTIONS(7498),
    [sym_dot_dot_i] = ACTIONS(7496),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7496),
    [sym__newline] = ACTIONS(7496),
    [sym__semicolon] = ACTIONS(7496),
    [sym__raw_string_literal] = ACTIONS(7496),
    [sym__external_open_parenthesis] = ACTIONS(7496),
    [sym__external_close_parenthesis] = ACTIONS(7496),
    [sym__external_open_brace] = ACTIONS(7496),
    [sym__external_close_brace] = ACTIONS(7496),
    [sym__external_open_bracket] = ACTIONS(7496),
    [sym__external_open_bracket2] = ACTIONS(7496),
    [sym__external_close_bracket2] = ACTIONS(7496),
  },
  [2509] = {
    [ts_builtin_sym_end] = ACTIONS(7530),
    [sym_identifier] = ACTIONS(7532),
    [anon_sym_BSLASH] = ACTIONS(7530),
    [anon_sym_function] = ACTIONS(7532),
    [anon_sym_EQ] = ACTIONS(7532),
    [anon_sym_if] = ACTIONS(7532),
    [anon_sym_for] = ACTIONS(7532),
    [anon_sym_while] = ACTIONS(7532),
    [anon_sym_repeat] = ACTIONS(7532),
    [anon_sym_QMARK] = ACTIONS(7530),
    [anon_sym_TILDE] = ACTIONS(7530),
    [anon_sym_BANG] = ACTIONS(7532),
    [anon_sym_PLUS] = ACTIONS(7530),
    [anon_sym_DASH] = ACTIONS(7532),
    [anon_sym_LT_DASH] = ACTIONS(7530),
    [anon_sym_LT_LT_DASH] = ACTIONS(7530),
    [anon_sym_COLON_EQ] = ACTIONS(7530),
    [anon_sym_DASH_GT] = ACTIONS(7532),
    [anon_sym_DASH_GT_GT] = ACTIONS(7530),
    [anon_sym_PIPE] = ACTIONS(7532),
    [anon_sym_AMP] = ACTIONS(7532),
    [anon_sym_PIPE_PIPE] = ACTIONS(7530),
    [anon_sym_AMP_AMP] = ACTIONS(7530),
    [anon_sym_LT] = ACTIONS(7532),
    [anon_sym_LT_EQ] = ACTIONS(7530),
    [anon_sym_GT] = ACTIONS(7532),
    [anon_sym_GT_EQ] = ACTIONS(7530),
    [anon_sym_EQ_EQ] = ACTIONS(7530),
    [anon_sym_BANG_EQ] = ACTIONS(7530),
    [anon_sym_STAR] = ACTIONS(7532),
    [anon_sym_SLASH] = ACTIONS(7530),
    [anon_sym_STAR_STAR] = ACTIONS(7530),
    [anon_sym_CARET] = ACTIONS(7530),
    [aux_sym_binary_operator_token1] = ACTIONS(7530),
    [anon_sym_PIPE_GT] = ACTIONS(7530),
    [anon_sym_COLON] = ACTIONS(7532),
    [anon_sym_DOLLAR] = ACTIONS(7530),
    [anon_sym_AT] = ACTIONS(7530),
    [aux_sym__hex_literal_token1] = ACTIONS(7530),
    [sym__number_literal] = ACTIONS(7532),
    [anon_sym_SQUOTE] = ACTIONS(7530),
    [anon_sym_DQUOTE] = ACTIONS(7530),
    [sym_return] = ACTIONS(7532),
    [sym_next] = ACTIONS(7532),
    [sym_break] = ACTIONS(7532),
    [sym_true] = ACTIONS(7532),
    [sym_false] = ACTIONS(7532),
    [sym_null] = ACTIONS(7532),
    [sym_inf] = ACTIONS(7532),
    [sym_nan] = ACTIONS(7532),
    [anon_sym_NA] = ACTIONS(7532),
    [anon_sym_NA_integer_] = ACTIONS(7532),
    [anon_sym_NA_real_] = ACTIONS(7532),
    [anon_sym_NA_complex_] = ACTIONS(7532),
    [anon_sym_NA_character_] = ACTIONS(7532),
    [sym_dots] = ACTIONS(7532),
    [sym_dot_dot_i] = ACTIONS(7530),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7530),
    [sym__newline] = ACTIONS(7530),
    [sym__semicolon] = ACTIONS(7530),
    [sym__raw_string_literal] = ACTIONS(7530),
    [sym__external_open_parenthesis] = ACTIONS(7530),
    [sym__external_close_parenthesis] = ACTIONS(7530),
    [sym__external_open_brace] = ACTIONS(7530),
    [sym__external_close_brace] = ACTIONS(7530),
    [sym__external_open_bracket] = ACTIONS(7530),
    [sym__external_open_bracket2] = ACTIONS(7530),
  },
  [2510] = {
    [sym_identifier] = ACTIONS(7552),
    [anon_sym_BSLASH] = ACTIONS(7550),
    [anon_sym_function] = ACTIONS(7552),
    [anon_sym_EQ] = ACTIONS(7552),
    [anon_sym_if] = ACTIONS(7552),
    [anon_sym_for] = ACTIONS(7552),
    [anon_sym_while] = ACTIONS(7552),
    [anon_sym_repeat] = ACTIONS(7552),
    [anon_sym_QMARK] = ACTIONS(7550),
    [anon_sym_TILDE] = ACTIONS(7550),
    [anon_sym_BANG] = ACTIONS(7552),
    [anon_sym_PLUS] = ACTIONS(7550),
    [anon_sym_DASH] = ACTIONS(7552),
    [anon_sym_LT_DASH] = ACTIONS(7550),
    [anon_sym_LT_LT_DASH] = ACTIONS(7550),
    [anon_sym_COLON_EQ] = ACTIONS(7550),
    [anon_sym_DASH_GT] = ACTIONS(7552),
    [anon_sym_DASH_GT_GT] = ACTIONS(7550),
    [anon_sym_PIPE] = ACTIONS(7552),
    [anon_sym_AMP] = ACTIONS(7552),
    [anon_sym_PIPE_PIPE] = ACTIONS(7550),
    [anon_sym_AMP_AMP] = ACTIONS(7550),
    [anon_sym_LT] = ACTIONS(7552),
    [anon_sym_LT_EQ] = ACTIONS(7550),
    [anon_sym_GT] = ACTIONS(7552),
    [anon_sym_GT_EQ] = ACTIONS(7550),
    [anon_sym_EQ_EQ] = ACTIONS(7550),
    [anon_sym_BANG_EQ] = ACTIONS(7550),
    [anon_sym_STAR] = ACTIONS(7552),
    [anon_sym_SLASH] = ACTIONS(7550),
    [anon_sym_STAR_STAR] = ACTIONS(7550),
    [anon_sym_CARET] = ACTIONS(7550),
    [aux_sym_binary_operator_token1] = ACTIONS(7550),
    [anon_sym_PIPE_GT] = ACTIONS(7550),
    [anon_sym_COLON] = ACTIONS(7552),
    [anon_sym_DOLLAR] = ACTIONS(7550),
    [anon_sym_AT] = ACTIONS(7550),
    [aux_sym__hex_literal_token1] = ACTIONS(7550),
    [sym__number_literal] = ACTIONS(7552),
    [anon_sym_SQUOTE] = ACTIONS(7550),
    [anon_sym_DQUOTE] = ACTIONS(7550),
    [sym_return] = ACTIONS(7552),
    [sym_next] = ACTIONS(7552),
    [sym_break] = ACTIONS(7552),
    [sym_true] = ACTIONS(7552),
    [sym_false] = ACTIONS(7552),
    [sym_null] = ACTIONS(7552),
    [sym_inf] = ACTIONS(7552),
    [sym_nan] = ACTIONS(7552),
    [anon_sym_NA] = ACTIONS(7552),
    [anon_sym_NA_integer_] = ACTIONS(7552),
    [anon_sym_NA_real_] = ACTIONS(7552),
    [anon_sym_NA_complex_] = ACTIONS(7552),
    [anon_sym_NA_character_] = ACTIONS(7552),
    [sym_dots] = ACTIONS(7552),
    [sym_dot_dot_i] = ACTIONS(7550),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7550),
    [sym__newline] = ACTIONS(7550),
    [sym__semicolon] = ACTIONS(7550),
    [sym__raw_string_literal] = ACTIONS(7550),
    [sym__external_open_parenthesis] = ACTIONS(7550),
    [sym__external_close_parenthesis] = ACTIONS(7550),
    [sym__external_open_brace] = ACTIONS(7550),
    [sym__external_close_brace] = ACTIONS(7550),
    [sym__external_open_bracket] = ACTIONS(7550),
    [sym__external_open_bracket2] = ACTIONS(7550),
    [sym__external_close_bracket2] = ACTIONS(7550),
  },
  [2511] = {
    [sym_identifier] = ACTIONS(7567),
    [anon_sym_BSLASH] = ACTIONS(7565),
    [anon_sym_function] = ACTIONS(7567),
    [anon_sym_EQ] = ACTIONS(7567),
    [anon_sym_if] = ACTIONS(7567),
    [anon_sym_for] = ACTIONS(7567),
    [anon_sym_while] = ACTIONS(7567),
    [anon_sym_repeat] = ACTIONS(7567),
    [anon_sym_QMARK] = ACTIONS(7565),
    [anon_sym_TILDE] = ACTIONS(7565),
    [anon_sym_BANG] = ACTIONS(7567),
    [anon_sym_PLUS] = ACTIONS(7565),
    [anon_sym_DASH] = ACTIONS(7567),
    [anon_sym_LT_DASH] = ACTIONS(7565),
    [anon_sym_LT_LT_DASH] = ACTIONS(7565),
    [anon_sym_COLON_EQ] = ACTIONS(7565),
    [anon_sym_DASH_GT] = ACTIONS(7567),
    [anon_sym_DASH_GT_GT] = ACTIONS(7565),
    [anon_sym_PIPE] = ACTIONS(7567),
    [anon_sym_AMP] = ACTIONS(7567),
    [anon_sym_PIPE_PIPE] = ACTIONS(7565),
    [anon_sym_AMP_AMP] = ACTIONS(7565),
    [anon_sym_LT] = ACTIONS(7567),
    [anon_sym_LT_EQ] = ACTIONS(7565),
    [anon_sym_GT] = ACTIONS(7567),
    [anon_sym_GT_EQ] = ACTIONS(7565),
    [anon_sym_EQ_EQ] = ACTIONS(7565),
    [anon_sym_BANG_EQ] = ACTIONS(7565),
    [anon_sym_STAR] = ACTIONS(7567),
    [anon_sym_SLASH] = ACTIONS(7565),
    [anon_sym_STAR_STAR] = ACTIONS(7565),
    [anon_sym_CARET] = ACTIONS(7565),
    [aux_sym_binary_operator_token1] = ACTIONS(7565),
    [anon_sym_PIPE_GT] = ACTIONS(7565),
    [anon_sym_COLON] = ACTIONS(7567),
    [anon_sym_DOLLAR] = ACTIONS(7565),
    [anon_sym_AT] = ACTIONS(7565),
    [aux_sym__hex_literal_token1] = ACTIONS(7565),
    [sym__number_literal] = ACTIONS(7567),
    [anon_sym_SQUOTE] = ACTIONS(7565),
    [anon_sym_DQUOTE] = ACTIONS(7565),
    [sym_return] = ACTIONS(7567),
    [sym_next] = ACTIONS(7567),
    [sym_break] = ACTIONS(7567),
    [sym_true] = ACTIONS(7567),
    [sym_false] = ACTIONS(7567),
    [sym_null] = ACTIONS(7567),
    [sym_inf] = ACTIONS(7567),
    [sym_nan] = ACTIONS(7567),
    [anon_sym_NA] = ACTIONS(7567),
    [anon_sym_NA_integer_] = ACTIONS(7567),
    [anon_sym_NA_real_] = ACTIONS(7567),
    [anon_sym_NA_complex_] = ACTIONS(7567),
    [anon_sym_NA_character_] = ACTIONS(7567),
    [sym_dots] = ACTIONS(7567),
    [sym_dot_dot_i] = ACTIONS(7565),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7565),
    [sym__newline] = ACTIONS(7565),
    [sym__semicolon] = ACTIONS(7565),
    [sym__raw_string_literal] = ACTIONS(7565),
    [sym__external_open_parenthesis] = ACTIONS(7565),
    [sym__external_close_parenthesis] = ACTIONS(7565),
    [sym__external_open_brace] = ACTIONS(7565),
    [sym__external_close_brace] = ACTIONS(7565),
    [sym__external_open_bracket] = ACTIONS(7565),
    [sym__external_close_bracket] = ACTIONS(7565),
    [sym__external_open_bracket2] = ACTIONS(7565),
  },
  [2512] = {
    [sym_identifier] = ACTIONS(7502),
    [anon_sym_BSLASH] = ACTIONS(7500),
    [anon_sym_function] = ACTIONS(7502),
    [anon_sym_EQ] = ACTIONS(7502),
    [anon_sym_if] = ACTIONS(7502),
    [anon_sym_for] = ACTIONS(7502),
    [anon_sym_while] = ACTIONS(7502),
    [anon_sym_repeat] = ACTIONS(7502),
    [anon_sym_QMARK] = ACTIONS(7500),
    [anon_sym_TILDE] = ACTIONS(7500),
    [anon_sym_BANG] = ACTIONS(7502),
    [anon_sym_PLUS] = ACTIONS(7500),
    [anon_sym_DASH] = ACTIONS(7502),
    [anon_sym_LT_DASH] = ACTIONS(7500),
    [anon_sym_LT_LT_DASH] = ACTIONS(7500),
    [anon_sym_COLON_EQ] = ACTIONS(7500),
    [anon_sym_DASH_GT] = ACTIONS(7502),
    [anon_sym_DASH_GT_GT] = ACTIONS(7500),
    [anon_sym_PIPE] = ACTIONS(7502),
    [anon_sym_AMP] = ACTIONS(7502),
    [anon_sym_PIPE_PIPE] = ACTIONS(7500),
    [anon_sym_AMP_AMP] = ACTIONS(7500),
    [anon_sym_LT] = ACTIONS(7502),
    [anon_sym_LT_EQ] = ACTIONS(7500),
    [anon_sym_GT] = ACTIONS(7502),
    [anon_sym_GT_EQ] = ACTIONS(7500),
    [anon_sym_EQ_EQ] = ACTIONS(7500),
    [anon_sym_BANG_EQ] = ACTIONS(7500),
    [anon_sym_STAR] = ACTIONS(7502),
    [anon_sym_SLASH] = ACTIONS(7500),
    [anon_sym_STAR_STAR] = ACTIONS(7500),
    [anon_sym_CARET] = ACTIONS(7500),
    [aux_sym_binary_operator_token1] = ACTIONS(7500),
    [anon_sym_PIPE_GT] = ACTIONS(7500),
    [anon_sym_COLON] = ACTIONS(7502),
    [anon_sym_DOLLAR] = ACTIONS(7500),
    [anon_sym_AT] = ACTIONS(7500),
    [aux_sym__hex_literal_token1] = ACTIONS(7500),
    [sym__number_literal] = ACTIONS(7502),
    [anon_sym_SQUOTE] = ACTIONS(7500),
    [anon_sym_DQUOTE] = ACTIONS(7500),
    [sym_return] = ACTIONS(7502),
    [sym_next] = ACTIONS(7502),
    [sym_break] = ACTIONS(7502),
    [sym_true] = ACTIONS(7502),
    [sym_false] = ACTIONS(7502),
    [sym_null] = ACTIONS(7502),
    [sym_inf] = ACTIONS(7502),
    [sym_nan] = ACTIONS(7502),
    [anon_sym_NA] = ACTIONS(7502),
    [anon_sym_NA_integer_] = ACTIONS(7502),
    [anon_sym_NA_real_] = ACTIONS(7502),
    [anon_sym_NA_complex_] = ACTIONS(7502),
    [anon_sym_NA_character_] = ACTIONS(7502),
    [sym_dots] = ACTIONS(7502),
    [sym_dot_dot_i] = ACTIONS(7500),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7500),
    [sym__newline] = ACTIONS(7500),
    [sym__semicolon] = ACTIONS(7500),
    [sym__raw_string_literal] = ACTIONS(7500),
    [sym__external_open_parenthesis] = ACTIONS(7500),
    [sym__external_close_parenthesis] = ACTIONS(7500),
    [sym__external_open_brace] = ACTIONS(7500),
    [sym__external_close_brace] = ACTIONS(7500),
    [sym__external_open_bracket] = ACTIONS(7500),
    [sym__external_close_bracket] = ACTIONS(7500),
    [sym__external_open_bracket2] = ACTIONS(7500),
  },
  [2513] = {
    [sym_identifier] = ACTIONS(7498),
    [anon_sym_BSLASH] = ACTIONS(7496),
    [anon_sym_function] = ACTIONS(7498),
    [anon_sym_EQ] = ACTIONS(7498),
    [anon_sym_if] = ACTIONS(7498),
    [anon_sym_for] = ACTIONS(7498),
    [anon_sym_while] = ACTIONS(7498),
    [anon_sym_repeat] = ACTIONS(7498),
    [anon_sym_QMARK] = ACTIONS(7496),
    [anon_sym_TILDE] = ACTIONS(7496),
    [anon_sym_BANG] = ACTIONS(7498),
    [anon_sym_PLUS] = ACTIONS(7496),
    [anon_sym_DASH] = ACTIONS(7498),
    [anon_sym_LT_DASH] = ACTIONS(7496),
    [anon_sym_LT_LT_DASH] = ACTIONS(7496),
    [anon_sym_COLON_EQ] = ACTIONS(7496),
    [anon_sym_DASH_GT] = ACTIONS(7498),
    [anon_sym_DASH_GT_GT] = ACTIONS(7496),
    [anon_sym_PIPE] = ACTIONS(7498),
    [anon_sym_AMP] = ACTIONS(7498),
    [anon_sym_PIPE_PIPE] = ACTIONS(7496),
    [anon_sym_AMP_AMP] = ACTIONS(7496),
    [anon_sym_LT] = ACTIONS(7498),
    [anon_sym_LT_EQ] = ACTIONS(7496),
    [anon_sym_GT] = ACTIONS(7498),
    [anon_sym_GT_EQ] = ACTIONS(7496),
    [anon_sym_EQ_EQ] = ACTIONS(7496),
    [anon_sym_BANG_EQ] = ACTIONS(7496),
    [anon_sym_STAR] = ACTIONS(7498),
    [anon_sym_SLASH] = ACTIONS(7496),
    [anon_sym_STAR_STAR] = ACTIONS(7496),
    [anon_sym_CARET] = ACTIONS(7496),
    [aux_sym_binary_operator_token1] = ACTIONS(7496),
    [anon_sym_PIPE_GT] = ACTIONS(7496),
    [anon_sym_COLON] = ACTIONS(7498),
    [anon_sym_DOLLAR] = ACTIONS(7496),
    [anon_sym_AT] = ACTIONS(7496),
    [aux_sym__hex_literal_token1] = ACTIONS(7496),
    [sym__number_literal] = ACTIONS(7498),
    [anon_sym_SQUOTE] = ACTIONS(7496),
    [anon_sym_DQUOTE] = ACTIONS(7496),
    [sym_return] = ACTIONS(7498),
    [sym_next] = ACTIONS(7498),
    [sym_break] = ACTIONS(7498),
    [sym_true] = ACTIONS(7498),
    [sym_false] = ACTIONS(7498),
    [sym_null] = ACTIONS(7498),
    [sym_inf] = ACTIONS(7498),
    [sym_nan] = ACTIONS(7498),
    [anon_sym_NA] = ACTIONS(7498),
    [anon_sym_NA_integer_] = ACTIONS(7498),
    [anon_sym_NA_real_] = ACTIONS(7498),
    [anon_sym_NA_complex_] = ACTIONS(7498),
    [anon_sym_NA_character_] = ACTIONS(7498),
    [sym_dots] = ACTIONS(7498),
    [sym_dot_dot_i] = ACTIONS(7496),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7496),
    [sym__newline] = ACTIONS(7496),
    [sym__semicolon] = ACTIONS(7496),
    [sym__raw_string_literal] = ACTIONS(7496),
    [sym__external_open_parenthesis] = ACTIONS(7496),
    [sym__external_close_parenthesis] = ACTIONS(7496),
    [sym__external_open_brace] = ACTIONS(7496),
    [sym__external_close_brace] = ACTIONS(7496),
    [sym__external_open_bracket] = ACTIONS(7496),
    [sym__external_close_bracket] = ACTIONS(7496),
    [sym__external_open_bracket2] = ACTIONS(7496),
  },
  [2514] = {
    [sym_identifier] = ACTIONS(7137),
    [anon_sym_BSLASH] = ACTIONS(7139),
    [anon_sym_function] = ACTIONS(7137),
    [anon_sym_EQ] = ACTIONS(7137),
    [anon_sym_if] = ACTIONS(7137),
    [anon_sym_for] = ACTIONS(7137),
    [anon_sym_while] = ACTIONS(7137),
    [anon_sym_repeat] = ACTIONS(7137),
    [anon_sym_QMARK] = ACTIONS(7139),
    [anon_sym_TILDE] = ACTIONS(7139),
    [anon_sym_BANG] = ACTIONS(7137),
    [anon_sym_PLUS] = ACTIONS(7139),
    [anon_sym_DASH] = ACTIONS(7137),
    [anon_sym_LT_DASH] = ACTIONS(7139),
    [anon_sym_LT_LT_DASH] = ACTIONS(7139),
    [anon_sym_COLON_EQ] = ACTIONS(7139),
    [anon_sym_DASH_GT] = ACTIONS(7137),
    [anon_sym_DASH_GT_GT] = ACTIONS(7139),
    [anon_sym_PIPE] = ACTIONS(7137),
    [anon_sym_AMP] = ACTIONS(7137),
    [anon_sym_PIPE_PIPE] = ACTIONS(7139),
    [anon_sym_AMP_AMP] = ACTIONS(7139),
    [anon_sym_LT] = ACTIONS(7137),
    [anon_sym_LT_EQ] = ACTIONS(7139),
    [anon_sym_GT] = ACTIONS(7137),
    [anon_sym_GT_EQ] = ACTIONS(7139),
    [anon_sym_EQ_EQ] = ACTIONS(7139),
    [anon_sym_BANG_EQ] = ACTIONS(7139),
    [anon_sym_STAR] = ACTIONS(7137),
    [anon_sym_SLASH] = ACTIONS(7139),
    [anon_sym_STAR_STAR] = ACTIONS(7139),
    [anon_sym_CARET] = ACTIONS(7139),
    [aux_sym_binary_operator_token1] = ACTIONS(7139),
    [anon_sym_PIPE_GT] = ACTIONS(7139),
    [anon_sym_COLON] = ACTIONS(7137),
    [anon_sym_DOLLAR] = ACTIONS(7139),
    [anon_sym_AT] = ACTIONS(7139),
    [anon_sym_COLON_COLON] = ACTIONS(7137),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7139),
    [aux_sym__hex_literal_token1] = ACTIONS(7139),
    [sym__number_literal] = ACTIONS(7137),
    [anon_sym_SQUOTE] = ACTIONS(7139),
    [anon_sym_DQUOTE] = ACTIONS(7139),
    [sym_return] = ACTIONS(7137),
    [sym_next] = ACTIONS(7137),
    [sym_break] = ACTIONS(7137),
    [sym_true] = ACTIONS(7137),
    [sym_false] = ACTIONS(7137),
    [sym_null] = ACTIONS(7137),
    [sym_inf] = ACTIONS(7137),
    [sym_nan] = ACTIONS(7137),
    [anon_sym_NA] = ACTIONS(7137),
    [anon_sym_NA_integer_] = ACTIONS(7137),
    [anon_sym_NA_real_] = ACTIONS(7137),
    [anon_sym_NA_complex_] = ACTIONS(7137),
    [anon_sym_NA_character_] = ACTIONS(7137),
    [sym_dots] = ACTIONS(7137),
    [sym_dot_dot_i] = ACTIONS(7139),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7139),
    [sym__newline] = ACTIONS(7139),
    [sym__raw_string_literal] = ACTIONS(7139),
    [sym__external_else] = ACTIONS(7139),
    [sym__external_open_parenthesis] = ACTIONS(7139),
    [sym__external_open_brace] = ACTIONS(7139),
    [sym__external_open_bracket] = ACTIONS(7139),
    [sym__external_close_bracket] = ACTIONS(7139),
    [sym__external_open_bracket2] = ACTIONS(7139),
  },
  [2515] = {
    [sym_identifier] = ACTIONS(7486),
    [anon_sym_BSLASH] = ACTIONS(7484),
    [anon_sym_function] = ACTIONS(7486),
    [anon_sym_EQ] = ACTIONS(7486),
    [anon_sym_if] = ACTIONS(7486),
    [anon_sym_for] = ACTIONS(7486),
    [anon_sym_while] = ACTIONS(7486),
    [anon_sym_repeat] = ACTIONS(7486),
    [anon_sym_QMARK] = ACTIONS(7484),
    [anon_sym_TILDE] = ACTIONS(7484),
    [anon_sym_BANG] = ACTIONS(7486),
    [anon_sym_PLUS] = ACTIONS(7484),
    [anon_sym_DASH] = ACTIONS(7486),
    [anon_sym_LT_DASH] = ACTIONS(7484),
    [anon_sym_LT_LT_DASH] = ACTIONS(7484),
    [anon_sym_COLON_EQ] = ACTIONS(7484),
    [anon_sym_DASH_GT] = ACTIONS(7486),
    [anon_sym_DASH_GT_GT] = ACTIONS(7484),
    [anon_sym_PIPE] = ACTIONS(7486),
    [anon_sym_AMP] = ACTIONS(7486),
    [anon_sym_PIPE_PIPE] = ACTIONS(7484),
    [anon_sym_AMP_AMP] = ACTIONS(7484),
    [anon_sym_LT] = ACTIONS(7486),
    [anon_sym_LT_EQ] = ACTIONS(7484),
    [anon_sym_GT] = ACTIONS(7486),
    [anon_sym_GT_EQ] = ACTIONS(7484),
    [anon_sym_EQ_EQ] = ACTIONS(7484),
    [anon_sym_BANG_EQ] = ACTIONS(7484),
    [anon_sym_STAR] = ACTIONS(7486),
    [anon_sym_SLASH] = ACTIONS(7484),
    [anon_sym_STAR_STAR] = ACTIONS(7484),
    [anon_sym_CARET] = ACTIONS(7484),
    [aux_sym_binary_operator_token1] = ACTIONS(7484),
    [anon_sym_PIPE_GT] = ACTIONS(7484),
    [anon_sym_COLON] = ACTIONS(7486),
    [anon_sym_DOLLAR] = ACTIONS(7484),
    [anon_sym_AT] = ACTIONS(7484),
    [aux_sym__hex_literal_token1] = ACTIONS(7484),
    [sym__number_literal] = ACTIONS(7486),
    [anon_sym_SQUOTE] = ACTIONS(7484),
    [anon_sym_DQUOTE] = ACTIONS(7484),
    [sym_return] = ACTIONS(7486),
    [sym_next] = ACTIONS(7486),
    [sym_break] = ACTIONS(7486),
    [sym_true] = ACTIONS(7486),
    [sym_false] = ACTIONS(7486),
    [sym_null] = ACTIONS(7486),
    [sym_inf] = ACTIONS(7486),
    [sym_nan] = ACTIONS(7486),
    [anon_sym_NA] = ACTIONS(7486),
    [anon_sym_NA_integer_] = ACTIONS(7486),
    [anon_sym_NA_real_] = ACTIONS(7486),
    [anon_sym_NA_complex_] = ACTIONS(7486),
    [anon_sym_NA_character_] = ACTIONS(7486),
    [sym_dots] = ACTIONS(7486),
    [sym_dot_dot_i] = ACTIONS(7484),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7484),
    [sym__newline] = ACTIONS(7484),
    [sym__semicolon] = ACTIONS(7484),
    [sym__raw_string_literal] = ACTIONS(7484),
    [sym__external_else] = ACTIONS(7484),
    [sym__external_open_parenthesis] = ACTIONS(7484),
    [sym__external_open_brace] = ACTIONS(7484),
    [sym__external_close_brace] = ACTIONS(7484),
    [sym__external_open_bracket] = ACTIONS(7484),
    [sym__external_open_bracket2] = ACTIONS(7484),
    [sym__external_close_bracket2] = ACTIONS(7484),
  },
  [2516] = {
    [sym_identifier] = ACTIONS(7490),
    [anon_sym_BSLASH] = ACTIONS(7488),
    [anon_sym_function] = ACTIONS(7490),
    [anon_sym_EQ] = ACTIONS(7490),
    [anon_sym_if] = ACTIONS(7490),
    [anon_sym_for] = ACTIONS(7490),
    [anon_sym_while] = ACTIONS(7490),
    [anon_sym_repeat] = ACTIONS(7490),
    [anon_sym_QMARK] = ACTIONS(7488),
    [anon_sym_TILDE] = ACTIONS(7488),
    [anon_sym_BANG] = ACTIONS(7490),
    [anon_sym_PLUS] = ACTIONS(7488),
    [anon_sym_DASH] = ACTIONS(7490),
    [anon_sym_LT_DASH] = ACTIONS(7488),
    [anon_sym_LT_LT_DASH] = ACTIONS(7488),
    [anon_sym_COLON_EQ] = ACTIONS(7488),
    [anon_sym_DASH_GT] = ACTIONS(7490),
    [anon_sym_DASH_GT_GT] = ACTIONS(7488),
    [anon_sym_PIPE] = ACTIONS(7490),
    [anon_sym_AMP] = ACTIONS(7490),
    [anon_sym_PIPE_PIPE] = ACTIONS(7488),
    [anon_sym_AMP_AMP] = ACTIONS(7488),
    [anon_sym_LT] = ACTIONS(7490),
    [anon_sym_LT_EQ] = ACTIONS(7488),
    [anon_sym_GT] = ACTIONS(7490),
    [anon_sym_GT_EQ] = ACTIONS(7488),
    [anon_sym_EQ_EQ] = ACTIONS(7488),
    [anon_sym_BANG_EQ] = ACTIONS(7488),
    [anon_sym_STAR] = ACTIONS(7490),
    [anon_sym_SLASH] = ACTIONS(7488),
    [anon_sym_STAR_STAR] = ACTIONS(7488),
    [anon_sym_CARET] = ACTIONS(7488),
    [aux_sym_binary_operator_token1] = ACTIONS(7488),
    [anon_sym_PIPE_GT] = ACTIONS(7488),
    [anon_sym_COLON] = ACTIONS(7490),
    [anon_sym_DOLLAR] = ACTIONS(7488),
    [anon_sym_AT] = ACTIONS(7488),
    [aux_sym__hex_literal_token1] = ACTIONS(7488),
    [sym__number_literal] = ACTIONS(7490),
    [anon_sym_SQUOTE] = ACTIONS(7488),
    [anon_sym_DQUOTE] = ACTIONS(7488),
    [sym_return] = ACTIONS(7490),
    [sym_next] = ACTIONS(7490),
    [sym_break] = ACTIONS(7490),
    [sym_true] = ACTIONS(7490),
    [sym_false] = ACTIONS(7490),
    [sym_null] = ACTIONS(7490),
    [sym_inf] = ACTIONS(7490),
    [sym_nan] = ACTIONS(7490),
    [anon_sym_NA] = ACTIONS(7490),
    [anon_sym_NA_integer_] = ACTIONS(7490),
    [anon_sym_NA_real_] = ACTIONS(7490),
    [anon_sym_NA_complex_] = ACTIONS(7490),
    [anon_sym_NA_character_] = ACTIONS(7490),
    [sym_dots] = ACTIONS(7490),
    [sym_dot_dot_i] = ACTIONS(7488),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7488),
    [sym__newline] = ACTIONS(7488),
    [sym__semicolon] = ACTIONS(7488),
    [sym__raw_string_literal] = ACTIONS(7488),
    [sym__external_else] = ACTIONS(7488),
    [sym__external_open_parenthesis] = ACTIONS(7488),
    [sym__external_open_brace] = ACTIONS(7488),
    [sym__external_close_brace] = ACTIONS(7488),
    [sym__external_open_bracket] = ACTIONS(7488),
    [sym__external_open_bracket2] = ACTIONS(7488),
    [sym__external_close_bracket2] = ACTIONS(7488),
  },
  [2517] = {
    [sym_identifier] = ACTIONS(7494),
    [anon_sym_BSLASH] = ACTIONS(7492),
    [anon_sym_function] = ACTIONS(7494),
    [anon_sym_EQ] = ACTIONS(7494),
    [anon_sym_if] = ACTIONS(7494),
    [anon_sym_for] = ACTIONS(7494),
    [anon_sym_while] = ACTIONS(7494),
    [anon_sym_repeat] = ACTIONS(7494),
    [anon_sym_QMARK] = ACTIONS(7492),
    [anon_sym_TILDE] = ACTIONS(7492),
    [anon_sym_BANG] = ACTIONS(7494),
    [anon_sym_PLUS] = ACTIONS(7492),
    [anon_sym_DASH] = ACTIONS(7494),
    [anon_sym_LT_DASH] = ACTIONS(7492),
    [anon_sym_LT_LT_DASH] = ACTIONS(7492),
    [anon_sym_COLON_EQ] = ACTIONS(7492),
    [anon_sym_DASH_GT] = ACTIONS(7494),
    [anon_sym_DASH_GT_GT] = ACTIONS(7492),
    [anon_sym_PIPE] = ACTIONS(7494),
    [anon_sym_AMP] = ACTIONS(7494),
    [anon_sym_PIPE_PIPE] = ACTIONS(7492),
    [anon_sym_AMP_AMP] = ACTIONS(7492),
    [anon_sym_LT] = ACTIONS(7494),
    [anon_sym_LT_EQ] = ACTIONS(7492),
    [anon_sym_GT] = ACTIONS(7494),
    [anon_sym_GT_EQ] = ACTIONS(7492),
    [anon_sym_EQ_EQ] = ACTIONS(7492),
    [anon_sym_BANG_EQ] = ACTIONS(7492),
    [anon_sym_STAR] = ACTIONS(7494),
    [anon_sym_SLASH] = ACTIONS(7492),
    [anon_sym_STAR_STAR] = ACTIONS(7492),
    [anon_sym_CARET] = ACTIONS(7492),
    [aux_sym_binary_operator_token1] = ACTIONS(7492),
    [anon_sym_PIPE_GT] = ACTIONS(7492),
    [anon_sym_COLON] = ACTIONS(7494),
    [anon_sym_DOLLAR] = ACTIONS(7492),
    [anon_sym_AT] = ACTIONS(7492),
    [aux_sym__hex_literal_token1] = ACTIONS(7492),
    [sym__number_literal] = ACTIONS(7494),
    [anon_sym_SQUOTE] = ACTIONS(7492),
    [anon_sym_DQUOTE] = ACTIONS(7492),
    [sym_return] = ACTIONS(7494),
    [sym_next] = ACTIONS(7494),
    [sym_break] = ACTIONS(7494),
    [sym_true] = ACTIONS(7494),
    [sym_false] = ACTIONS(7494),
    [sym_null] = ACTIONS(7494),
    [sym_inf] = ACTIONS(7494),
    [sym_nan] = ACTIONS(7494),
    [anon_sym_NA] = ACTIONS(7494),
    [anon_sym_NA_integer_] = ACTIONS(7494),
    [anon_sym_NA_real_] = ACTIONS(7494),
    [anon_sym_NA_complex_] = ACTIONS(7494),
    [anon_sym_NA_character_] = ACTIONS(7494),
    [sym_dots] = ACTIONS(7494),
    [sym_dot_dot_i] = ACTIONS(7492),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7492),
    [sym__newline] = ACTIONS(7492),
    [sym__semicolon] = ACTIONS(7492),
    [sym__raw_string_literal] = ACTIONS(7492),
    [sym__external_else] = ACTIONS(7492),
    [sym__external_open_parenthesis] = ACTIONS(7492),
    [sym__external_open_brace] = ACTIONS(7492),
    [sym__external_close_brace] = ACTIONS(7492),
    [sym__external_open_bracket] = ACTIONS(7492),
    [sym__external_open_bracket2] = ACTIONS(7492),
    [sym__external_close_bracket2] = ACTIONS(7492),
  },
  [2518] = {
    [ts_builtin_sym_end] = ACTIONS(7542),
    [sym_identifier] = ACTIONS(7544),
    [anon_sym_BSLASH] = ACTIONS(7542),
    [anon_sym_function] = ACTIONS(7544),
    [anon_sym_EQ] = ACTIONS(7544),
    [anon_sym_if] = ACTIONS(7544),
    [anon_sym_for] = ACTIONS(7544),
    [anon_sym_while] = ACTIONS(7544),
    [anon_sym_repeat] = ACTIONS(7544),
    [anon_sym_QMARK] = ACTIONS(7542),
    [anon_sym_TILDE] = ACTIONS(7542),
    [anon_sym_BANG] = ACTIONS(7544),
    [anon_sym_PLUS] = ACTIONS(7542),
    [anon_sym_DASH] = ACTIONS(7544),
    [anon_sym_LT_DASH] = ACTIONS(7542),
    [anon_sym_LT_LT_DASH] = ACTIONS(7542),
    [anon_sym_COLON_EQ] = ACTIONS(7542),
    [anon_sym_DASH_GT] = ACTIONS(7544),
    [anon_sym_DASH_GT_GT] = ACTIONS(7542),
    [anon_sym_PIPE] = ACTIONS(7544),
    [anon_sym_AMP] = ACTIONS(7544),
    [anon_sym_PIPE_PIPE] = ACTIONS(7542),
    [anon_sym_AMP_AMP] = ACTIONS(7542),
    [anon_sym_LT] = ACTIONS(7544),
    [anon_sym_LT_EQ] = ACTIONS(7542),
    [anon_sym_GT] = ACTIONS(7544),
    [anon_sym_GT_EQ] = ACTIONS(7542),
    [anon_sym_EQ_EQ] = ACTIONS(7542),
    [anon_sym_BANG_EQ] = ACTIONS(7542),
    [anon_sym_STAR] = ACTIONS(7544),
    [anon_sym_SLASH] = ACTIONS(7542),
    [anon_sym_STAR_STAR] = ACTIONS(7542),
    [anon_sym_CARET] = ACTIONS(7542),
    [aux_sym_binary_operator_token1] = ACTIONS(7542),
    [anon_sym_PIPE_GT] = ACTIONS(7542),
    [anon_sym_COLON] = ACTIONS(7544),
    [anon_sym_DOLLAR] = ACTIONS(7542),
    [anon_sym_AT] = ACTIONS(7542),
    [aux_sym__hex_literal_token1] = ACTIONS(7542),
    [sym__number_literal] = ACTIONS(7544),
    [anon_sym_SQUOTE] = ACTIONS(7542),
    [anon_sym_DQUOTE] = ACTIONS(7542),
    [sym_return] = ACTIONS(7544),
    [sym_next] = ACTIONS(7544),
    [sym_break] = ACTIONS(7544),
    [sym_true] = ACTIONS(7544),
    [sym_false] = ACTIONS(7544),
    [sym_null] = ACTIONS(7544),
    [sym_inf] = ACTIONS(7544),
    [sym_nan] = ACTIONS(7544),
    [anon_sym_NA] = ACTIONS(7544),
    [anon_sym_NA_integer_] = ACTIONS(7544),
    [anon_sym_NA_real_] = ACTIONS(7544),
    [anon_sym_NA_complex_] = ACTIONS(7544),
    [anon_sym_NA_character_] = ACTIONS(7544),
    [sym_dots] = ACTIONS(7544),
    [sym_dot_dot_i] = ACTIONS(7542),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7542),
    [sym__newline] = ACTIONS(7542),
    [sym__semicolon] = ACTIONS(7542),
    [sym__raw_string_literal] = ACTIONS(7542),
    [sym__external_open_parenthesis] = ACTIONS(7542),
    [sym__external_close_parenthesis] = ACTIONS(7542),
    [sym__external_open_brace] = ACTIONS(7542),
    [sym__external_close_brace] = ACTIONS(7542),
    [sym__external_open_bracket] = ACTIONS(7542),
    [sym__external_open_bracket2] = ACTIONS(7542),
  },
  [2519] = {
    [sym_identifier] = ACTIONS(7498),
    [anon_sym_BSLASH] = ACTIONS(7496),
    [anon_sym_function] = ACTIONS(7498),
    [anon_sym_EQ] = ACTIONS(7498),
    [anon_sym_if] = ACTIONS(7498),
    [anon_sym_for] = ACTIONS(7498),
    [anon_sym_while] = ACTIONS(7498),
    [anon_sym_repeat] = ACTIONS(7498),
    [anon_sym_QMARK] = ACTIONS(7496),
    [anon_sym_TILDE] = ACTIONS(7496),
    [anon_sym_BANG] = ACTIONS(7498),
    [anon_sym_PLUS] = ACTIONS(7496),
    [anon_sym_DASH] = ACTIONS(7498),
    [anon_sym_LT_DASH] = ACTIONS(7496),
    [anon_sym_LT_LT_DASH] = ACTIONS(7496),
    [anon_sym_COLON_EQ] = ACTIONS(7496),
    [anon_sym_DASH_GT] = ACTIONS(7498),
    [anon_sym_DASH_GT_GT] = ACTIONS(7496),
    [anon_sym_PIPE] = ACTIONS(7498),
    [anon_sym_AMP] = ACTIONS(7498),
    [anon_sym_PIPE_PIPE] = ACTIONS(7496),
    [anon_sym_AMP_AMP] = ACTIONS(7496),
    [anon_sym_LT] = ACTIONS(7498),
    [anon_sym_LT_EQ] = ACTIONS(7496),
    [anon_sym_GT] = ACTIONS(7498),
    [anon_sym_GT_EQ] = ACTIONS(7496),
    [anon_sym_EQ_EQ] = ACTIONS(7496),
    [anon_sym_BANG_EQ] = ACTIONS(7496),
    [anon_sym_STAR] = ACTIONS(7498),
    [anon_sym_SLASH] = ACTIONS(7496),
    [anon_sym_STAR_STAR] = ACTIONS(7496),
    [anon_sym_CARET] = ACTIONS(7496),
    [aux_sym_binary_operator_token1] = ACTIONS(7496),
    [anon_sym_PIPE_GT] = ACTIONS(7496),
    [anon_sym_COLON] = ACTIONS(7498),
    [anon_sym_DOLLAR] = ACTIONS(7496),
    [anon_sym_AT] = ACTIONS(7496),
    [aux_sym__hex_literal_token1] = ACTIONS(7496),
    [sym__number_literal] = ACTIONS(7498),
    [anon_sym_SQUOTE] = ACTIONS(7496),
    [anon_sym_DQUOTE] = ACTIONS(7496),
    [sym_return] = ACTIONS(7498),
    [sym_next] = ACTIONS(7498),
    [sym_break] = ACTIONS(7498),
    [sym_true] = ACTIONS(7498),
    [sym_false] = ACTIONS(7498),
    [sym_null] = ACTIONS(7498),
    [sym_inf] = ACTIONS(7498),
    [sym_nan] = ACTIONS(7498),
    [anon_sym_NA] = ACTIONS(7498),
    [anon_sym_NA_integer_] = ACTIONS(7498),
    [anon_sym_NA_real_] = ACTIONS(7498),
    [anon_sym_NA_complex_] = ACTIONS(7498),
    [anon_sym_NA_character_] = ACTIONS(7498),
    [sym_dots] = ACTIONS(7498),
    [sym_dot_dot_i] = ACTIONS(7496),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7496),
    [sym__newline] = ACTIONS(7496),
    [sym__semicolon] = ACTIONS(7496),
    [sym__raw_string_literal] = ACTIONS(7496),
    [sym__external_else] = ACTIONS(7496),
    [sym__external_open_parenthesis] = ACTIONS(7496),
    [sym__external_open_brace] = ACTIONS(7496),
    [sym__external_close_brace] = ACTIONS(7496),
    [sym__external_open_bracket] = ACTIONS(7496),
    [sym__external_open_bracket2] = ACTIONS(7496),
    [sym__external_close_bracket2] = ACTIONS(7496),
  },
  [2520] = {
    [sym_identifier] = ACTIONS(7502),
    [anon_sym_BSLASH] = ACTIONS(7500),
    [anon_sym_function] = ACTIONS(7502),
    [anon_sym_EQ] = ACTIONS(7502),
    [anon_sym_if] = ACTIONS(7502),
    [anon_sym_for] = ACTIONS(7502),
    [anon_sym_while] = ACTIONS(7502),
    [anon_sym_repeat] = ACTIONS(7502),
    [anon_sym_QMARK] = ACTIONS(7500),
    [anon_sym_TILDE] = ACTIONS(7500),
    [anon_sym_BANG] = ACTIONS(7502),
    [anon_sym_PLUS] = ACTIONS(7500),
    [anon_sym_DASH] = ACTIONS(7502),
    [anon_sym_LT_DASH] = ACTIONS(7500),
    [anon_sym_LT_LT_DASH] = ACTIONS(7500),
    [anon_sym_COLON_EQ] = ACTIONS(7500),
    [anon_sym_DASH_GT] = ACTIONS(7502),
    [anon_sym_DASH_GT_GT] = ACTIONS(7500),
    [anon_sym_PIPE] = ACTIONS(7502),
    [anon_sym_AMP] = ACTIONS(7502),
    [anon_sym_PIPE_PIPE] = ACTIONS(7500),
    [anon_sym_AMP_AMP] = ACTIONS(7500),
    [anon_sym_LT] = ACTIONS(7502),
    [anon_sym_LT_EQ] = ACTIONS(7500),
    [anon_sym_GT] = ACTIONS(7502),
    [anon_sym_GT_EQ] = ACTIONS(7500),
    [anon_sym_EQ_EQ] = ACTIONS(7500),
    [anon_sym_BANG_EQ] = ACTIONS(7500),
    [anon_sym_STAR] = ACTIONS(7502),
    [anon_sym_SLASH] = ACTIONS(7500),
    [anon_sym_STAR_STAR] = ACTIONS(7500),
    [anon_sym_CARET] = ACTIONS(7500),
    [aux_sym_binary_operator_token1] = ACTIONS(7500),
    [anon_sym_PIPE_GT] = ACTIONS(7500),
    [anon_sym_COLON] = ACTIONS(7502),
    [anon_sym_DOLLAR] = ACTIONS(7500),
    [anon_sym_AT] = ACTIONS(7500),
    [aux_sym__hex_literal_token1] = ACTIONS(7500),
    [sym__number_literal] = ACTIONS(7502),
    [anon_sym_SQUOTE] = ACTIONS(7500),
    [anon_sym_DQUOTE] = ACTIONS(7500),
    [sym_return] = ACTIONS(7502),
    [sym_next] = ACTIONS(7502),
    [sym_break] = ACTIONS(7502),
    [sym_true] = ACTIONS(7502),
    [sym_false] = ACTIONS(7502),
    [sym_null] = ACTIONS(7502),
    [sym_inf] = ACTIONS(7502),
    [sym_nan] = ACTIONS(7502),
    [anon_sym_NA] = ACTIONS(7502),
    [anon_sym_NA_integer_] = ACTIONS(7502),
    [anon_sym_NA_real_] = ACTIONS(7502),
    [anon_sym_NA_complex_] = ACTIONS(7502),
    [anon_sym_NA_character_] = ACTIONS(7502),
    [sym_dots] = ACTIONS(7502),
    [sym_dot_dot_i] = ACTIONS(7500),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7500),
    [sym__newline] = ACTIONS(7500),
    [sym__semicolon] = ACTIONS(7500),
    [sym__raw_string_literal] = ACTIONS(7500),
    [sym__external_open_parenthesis] = ACTIONS(7500),
    [sym__external_close_parenthesis] = ACTIONS(7500),
    [sym__external_open_brace] = ACTIONS(7500),
    [sym__external_close_brace] = ACTIONS(7500),
    [sym__external_open_bracket] = ACTIONS(7500),
    [sym__external_open_bracket2] = ACTIONS(7500),
    [sym__external_close_bracket2] = ACTIONS(7500),
  },
  [2521] = {
    [sym_identifier] = ACTIONS(7506),
    [anon_sym_BSLASH] = ACTIONS(7504),
    [anon_sym_function] = ACTIONS(7506),
    [anon_sym_EQ] = ACTIONS(7506),
    [anon_sym_if] = ACTIONS(7506),
    [anon_sym_for] = ACTIONS(7506),
    [anon_sym_while] = ACTIONS(7506),
    [anon_sym_repeat] = ACTIONS(7506),
    [anon_sym_QMARK] = ACTIONS(7504),
    [anon_sym_TILDE] = ACTIONS(7504),
    [anon_sym_BANG] = ACTIONS(7506),
    [anon_sym_PLUS] = ACTIONS(7504),
    [anon_sym_DASH] = ACTIONS(7506),
    [anon_sym_LT_DASH] = ACTIONS(7504),
    [anon_sym_LT_LT_DASH] = ACTIONS(7504),
    [anon_sym_COLON_EQ] = ACTIONS(7504),
    [anon_sym_DASH_GT] = ACTIONS(7506),
    [anon_sym_DASH_GT_GT] = ACTIONS(7504),
    [anon_sym_PIPE] = ACTIONS(7506),
    [anon_sym_AMP] = ACTIONS(7506),
    [anon_sym_PIPE_PIPE] = ACTIONS(7504),
    [anon_sym_AMP_AMP] = ACTIONS(7504),
    [anon_sym_LT] = ACTIONS(7506),
    [anon_sym_LT_EQ] = ACTIONS(7504),
    [anon_sym_GT] = ACTIONS(7506),
    [anon_sym_GT_EQ] = ACTIONS(7504),
    [anon_sym_EQ_EQ] = ACTIONS(7504),
    [anon_sym_BANG_EQ] = ACTIONS(7504),
    [anon_sym_STAR] = ACTIONS(7506),
    [anon_sym_SLASH] = ACTIONS(7504),
    [anon_sym_STAR_STAR] = ACTIONS(7504),
    [anon_sym_CARET] = ACTIONS(7504),
    [aux_sym_binary_operator_token1] = ACTIONS(7504),
    [anon_sym_PIPE_GT] = ACTIONS(7504),
    [anon_sym_COLON] = ACTIONS(7506),
    [anon_sym_DOLLAR] = ACTIONS(7504),
    [anon_sym_AT] = ACTIONS(7504),
    [aux_sym__hex_literal_token1] = ACTIONS(7504),
    [sym__number_literal] = ACTIONS(7506),
    [anon_sym_SQUOTE] = ACTIONS(7504),
    [anon_sym_DQUOTE] = ACTIONS(7504),
    [sym_return] = ACTIONS(7506),
    [sym_next] = ACTIONS(7506),
    [sym_break] = ACTIONS(7506),
    [sym_true] = ACTIONS(7506),
    [sym_false] = ACTIONS(7506),
    [sym_null] = ACTIONS(7506),
    [sym_inf] = ACTIONS(7506),
    [sym_nan] = ACTIONS(7506),
    [anon_sym_NA] = ACTIONS(7506),
    [anon_sym_NA_integer_] = ACTIONS(7506),
    [anon_sym_NA_real_] = ACTIONS(7506),
    [anon_sym_NA_complex_] = ACTIONS(7506),
    [anon_sym_NA_character_] = ACTIONS(7506),
    [sym_dots] = ACTIONS(7506),
    [sym_dot_dot_i] = ACTIONS(7504),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7504),
    [sym__newline] = ACTIONS(7504),
    [sym__semicolon] = ACTIONS(7504),
    [sym__raw_string_literal] = ACTIONS(7504),
    [sym__external_open_parenthesis] = ACTIONS(7504),
    [sym__external_close_parenthesis] = ACTIONS(7504),
    [sym__external_open_brace] = ACTIONS(7504),
    [sym__external_close_brace] = ACTIONS(7504),
    [sym__external_open_bracket] = ACTIONS(7504),
    [sym__external_open_bracket2] = ACTIONS(7504),
    [sym__external_close_bracket2] = ACTIONS(7504),
  },
  [2522] = {
    [ts_builtin_sym_end] = ACTIONS(7131),
    [sym_identifier] = ACTIONS(7129),
    [anon_sym_BSLASH] = ACTIONS(7131),
    [anon_sym_function] = ACTIONS(7129),
    [anon_sym_EQ] = ACTIONS(7129),
    [anon_sym_if] = ACTIONS(7129),
    [anon_sym_for] = ACTIONS(7129),
    [anon_sym_while] = ACTIONS(7129),
    [anon_sym_repeat] = ACTIONS(7129),
    [anon_sym_QMARK] = ACTIONS(7131),
    [anon_sym_TILDE] = ACTIONS(7131),
    [anon_sym_BANG] = ACTIONS(7129),
    [anon_sym_PLUS] = ACTIONS(7131),
    [anon_sym_DASH] = ACTIONS(7129),
    [anon_sym_LT_DASH] = ACTIONS(7131),
    [anon_sym_LT_LT_DASH] = ACTIONS(7131),
    [anon_sym_COLON_EQ] = ACTIONS(7131),
    [anon_sym_DASH_GT] = ACTIONS(7129),
    [anon_sym_DASH_GT_GT] = ACTIONS(7131),
    [anon_sym_PIPE] = ACTIONS(7129),
    [anon_sym_AMP] = ACTIONS(7129),
    [anon_sym_PIPE_PIPE] = ACTIONS(7131),
    [anon_sym_AMP_AMP] = ACTIONS(7131),
    [anon_sym_LT] = ACTIONS(7129),
    [anon_sym_LT_EQ] = ACTIONS(7131),
    [anon_sym_GT] = ACTIONS(7129),
    [anon_sym_GT_EQ] = ACTIONS(7131),
    [anon_sym_EQ_EQ] = ACTIONS(7131),
    [anon_sym_BANG_EQ] = ACTIONS(7131),
    [anon_sym_STAR] = ACTIONS(7129),
    [anon_sym_SLASH] = ACTIONS(7131),
    [anon_sym_STAR_STAR] = ACTIONS(7131),
    [anon_sym_CARET] = ACTIONS(7131),
    [aux_sym_binary_operator_token1] = ACTIONS(7131),
    [anon_sym_PIPE_GT] = ACTIONS(7131),
    [anon_sym_COLON] = ACTIONS(7129),
    [anon_sym_DOLLAR] = ACTIONS(7131),
    [anon_sym_AT] = ACTIONS(7131),
    [anon_sym_COLON_COLON] = ACTIONS(7133),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7135),
    [aux_sym__hex_literal_token1] = ACTIONS(7131),
    [sym__number_literal] = ACTIONS(7129),
    [anon_sym_SQUOTE] = ACTIONS(7131),
    [anon_sym_DQUOTE] = ACTIONS(7131),
    [sym_return] = ACTIONS(7129),
    [sym_next] = ACTIONS(7129),
    [sym_break] = ACTIONS(7129),
    [sym_true] = ACTIONS(7129),
    [sym_false] = ACTIONS(7129),
    [sym_null] = ACTIONS(7129),
    [sym_inf] = ACTIONS(7129),
    [sym_nan] = ACTIONS(7129),
    [anon_sym_NA] = ACTIONS(7129),
    [anon_sym_NA_integer_] = ACTIONS(7129),
    [anon_sym_NA_real_] = ACTIONS(7129),
    [anon_sym_NA_complex_] = ACTIONS(7129),
    [anon_sym_NA_character_] = ACTIONS(7129),
    [sym_dots] = ACTIONS(7129),
    [sym_dot_dot_i] = ACTIONS(7131),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7131),
    [sym__semicolon] = ACTIONS(7131),
    [sym__raw_string_literal] = ACTIONS(7131),
    [sym__external_open_parenthesis] = ACTIONS(7131),
    [sym__external_open_brace] = ACTIONS(7131),
    [sym__external_close_brace] = ACTIONS(7131),
    [sym__external_open_bracket] = ACTIONS(7131),
    [sym__external_open_bracket2] = ACTIONS(7131),
  },
  [2523] = {
    [ts_builtin_sym_end] = ACTIONS(7123),
    [sym_identifier] = ACTIONS(7121),
    [anon_sym_BSLASH] = ACTIONS(7123),
    [anon_sym_function] = ACTIONS(7121),
    [anon_sym_EQ] = ACTIONS(7121),
    [anon_sym_if] = ACTIONS(7121),
    [anon_sym_for] = ACTIONS(7121),
    [anon_sym_while] = ACTIONS(7121),
    [anon_sym_repeat] = ACTIONS(7121),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_TILDE] = ACTIONS(7123),
    [anon_sym_BANG] = ACTIONS(7121),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_DASH] = ACTIONS(7121),
    [anon_sym_LT_DASH] = ACTIONS(7123),
    [anon_sym_LT_LT_DASH] = ACTIONS(7123),
    [anon_sym_COLON_EQ] = ACTIONS(7123),
    [anon_sym_DASH_GT] = ACTIONS(7121),
    [anon_sym_DASH_GT_GT] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_LT_EQ] = ACTIONS(7123),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
    [aux_sym_binary_operator_token1] = ACTIONS(7123),
    [anon_sym_PIPE_GT] = ACTIONS(7123),
    [anon_sym_COLON] = ACTIONS(7121),
    [anon_sym_DOLLAR] = ACTIONS(7123),
    [anon_sym_AT] = ACTIONS(7123),
    [anon_sym_L] = ACTIONS(7637),
    [anon_sym_i] = ACTIONS(7639),
    [aux_sym__hex_literal_token1] = ACTIONS(7123),
    [sym__number_literal] = ACTIONS(7121),
    [anon_sym_SQUOTE] = ACTIONS(7123),
    [anon_sym_DQUOTE] = ACTIONS(7123),
    [sym_return] = ACTIONS(7121),
    [sym_next] = ACTIONS(7121),
    [sym_break] = ACTIONS(7121),
    [sym_true] = ACTIONS(7121),
    [sym_false] = ACTIONS(7121),
    [sym_null] = ACTIONS(7121),
    [sym_inf] = ACTIONS(7121),
    [sym_nan] = ACTIONS(7121),
    [anon_sym_NA] = ACTIONS(7121),
    [anon_sym_NA_integer_] = ACTIONS(7121),
    [anon_sym_NA_real_] = ACTIONS(7121),
    [anon_sym_NA_complex_] = ACTIONS(7121),
    [anon_sym_NA_character_] = ACTIONS(7121),
    [sym_dots] = ACTIONS(7121),
    [sym_dot_dot_i] = ACTIONS(7123),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7123),
    [sym__semicolon] = ACTIONS(7123),
    [sym__raw_string_literal] = ACTIONS(7123),
    [sym__external_open_parenthesis] = ACTIONS(7123),
    [sym__external_open_brace] = ACTIONS(7123),
    [sym__external_close_brace] = ACTIONS(7123),
    [sym__external_open_bracket] = ACTIONS(7123),
    [sym__external_open_bracket2] = ACTIONS(7123),
  },
  [2524] = {
    [sym_identifier] = ACTIONS(7502),
    [anon_sym_BSLASH] = ACTIONS(7500),
    [anon_sym_function] = ACTIONS(7502),
    [anon_sym_EQ] = ACTIONS(7502),
    [anon_sym_if] = ACTIONS(7502),
    [anon_sym_for] = ACTIONS(7502),
    [anon_sym_while] = ACTIONS(7502),
    [anon_sym_repeat] = ACTIONS(7502),
    [anon_sym_QMARK] = ACTIONS(7500),
    [anon_sym_TILDE] = ACTIONS(7500),
    [anon_sym_BANG] = ACTIONS(7502),
    [anon_sym_PLUS] = ACTIONS(7500),
    [anon_sym_DASH] = ACTIONS(7502),
    [anon_sym_LT_DASH] = ACTIONS(7500),
    [anon_sym_LT_LT_DASH] = ACTIONS(7500),
    [anon_sym_COLON_EQ] = ACTIONS(7500),
    [anon_sym_DASH_GT] = ACTIONS(7502),
    [anon_sym_DASH_GT_GT] = ACTIONS(7500),
    [anon_sym_PIPE] = ACTIONS(7502),
    [anon_sym_AMP] = ACTIONS(7502),
    [anon_sym_PIPE_PIPE] = ACTIONS(7500),
    [anon_sym_AMP_AMP] = ACTIONS(7500),
    [anon_sym_LT] = ACTIONS(7502),
    [anon_sym_LT_EQ] = ACTIONS(7500),
    [anon_sym_GT] = ACTIONS(7502),
    [anon_sym_GT_EQ] = ACTIONS(7500),
    [anon_sym_EQ_EQ] = ACTIONS(7500),
    [anon_sym_BANG_EQ] = ACTIONS(7500),
    [anon_sym_STAR] = ACTIONS(7502),
    [anon_sym_SLASH] = ACTIONS(7500),
    [anon_sym_STAR_STAR] = ACTIONS(7500),
    [anon_sym_CARET] = ACTIONS(7500),
    [aux_sym_binary_operator_token1] = ACTIONS(7500),
    [anon_sym_PIPE_GT] = ACTIONS(7500),
    [anon_sym_COLON] = ACTIONS(7502),
    [anon_sym_DOLLAR] = ACTIONS(7500),
    [anon_sym_AT] = ACTIONS(7500),
    [aux_sym__hex_literal_token1] = ACTIONS(7500),
    [sym__number_literal] = ACTIONS(7502),
    [anon_sym_SQUOTE] = ACTIONS(7500),
    [anon_sym_DQUOTE] = ACTIONS(7500),
    [sym_return] = ACTIONS(7502),
    [sym_next] = ACTIONS(7502),
    [sym_break] = ACTIONS(7502),
    [sym_true] = ACTIONS(7502),
    [sym_false] = ACTIONS(7502),
    [sym_null] = ACTIONS(7502),
    [sym_inf] = ACTIONS(7502),
    [sym_nan] = ACTIONS(7502),
    [anon_sym_NA] = ACTIONS(7502),
    [anon_sym_NA_integer_] = ACTIONS(7502),
    [anon_sym_NA_real_] = ACTIONS(7502),
    [anon_sym_NA_complex_] = ACTIONS(7502),
    [anon_sym_NA_character_] = ACTIONS(7502),
    [sym_dots] = ACTIONS(7502),
    [sym_dot_dot_i] = ACTIONS(7500),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7500),
    [sym__newline] = ACTIONS(7500),
    [sym__semicolon] = ACTIONS(7500),
    [sym__raw_string_literal] = ACTIONS(7500),
    [sym__external_else] = ACTIONS(7500),
    [sym__external_open_parenthesis] = ACTIONS(7500),
    [sym__external_open_brace] = ACTIONS(7500),
    [sym__external_close_brace] = ACTIONS(7500),
    [sym__external_open_bracket] = ACTIONS(7500),
    [sym__external_open_bracket2] = ACTIONS(7500),
    [sym__external_close_bracket2] = ACTIONS(7500),
  },
  [2525] = {
    [sym_identifier] = ACTIONS(7506),
    [anon_sym_BSLASH] = ACTIONS(7504),
    [anon_sym_function] = ACTIONS(7506),
    [anon_sym_EQ] = ACTIONS(7506),
    [anon_sym_if] = ACTIONS(7506),
    [anon_sym_for] = ACTIONS(7506),
    [anon_sym_while] = ACTIONS(7506),
    [anon_sym_repeat] = ACTIONS(7506),
    [anon_sym_QMARK] = ACTIONS(7504),
    [anon_sym_TILDE] = ACTIONS(7504),
    [anon_sym_BANG] = ACTIONS(7506),
    [anon_sym_PLUS] = ACTIONS(7504),
    [anon_sym_DASH] = ACTIONS(7506),
    [anon_sym_LT_DASH] = ACTIONS(7504),
    [anon_sym_LT_LT_DASH] = ACTIONS(7504),
    [anon_sym_COLON_EQ] = ACTIONS(7504),
    [anon_sym_DASH_GT] = ACTIONS(7506),
    [anon_sym_DASH_GT_GT] = ACTIONS(7504),
    [anon_sym_PIPE] = ACTIONS(7506),
    [anon_sym_AMP] = ACTIONS(7506),
    [anon_sym_PIPE_PIPE] = ACTIONS(7504),
    [anon_sym_AMP_AMP] = ACTIONS(7504),
    [anon_sym_LT] = ACTIONS(7506),
    [anon_sym_LT_EQ] = ACTIONS(7504),
    [anon_sym_GT] = ACTIONS(7506),
    [anon_sym_GT_EQ] = ACTIONS(7504),
    [anon_sym_EQ_EQ] = ACTIONS(7504),
    [anon_sym_BANG_EQ] = ACTIONS(7504),
    [anon_sym_STAR] = ACTIONS(7506),
    [anon_sym_SLASH] = ACTIONS(7504),
    [anon_sym_STAR_STAR] = ACTIONS(7504),
    [anon_sym_CARET] = ACTIONS(7504),
    [aux_sym_binary_operator_token1] = ACTIONS(7504),
    [anon_sym_PIPE_GT] = ACTIONS(7504),
    [anon_sym_COLON] = ACTIONS(7506),
    [anon_sym_DOLLAR] = ACTIONS(7504),
    [anon_sym_AT] = ACTIONS(7504),
    [aux_sym__hex_literal_token1] = ACTIONS(7504),
    [sym__number_literal] = ACTIONS(7506),
    [anon_sym_SQUOTE] = ACTIONS(7504),
    [anon_sym_DQUOTE] = ACTIONS(7504),
    [sym_return] = ACTIONS(7506),
    [sym_next] = ACTIONS(7506),
    [sym_break] = ACTIONS(7506),
    [sym_true] = ACTIONS(7506),
    [sym_false] = ACTIONS(7506),
    [sym_null] = ACTIONS(7506),
    [sym_inf] = ACTIONS(7506),
    [sym_nan] = ACTIONS(7506),
    [anon_sym_NA] = ACTIONS(7506),
    [anon_sym_NA_integer_] = ACTIONS(7506),
    [anon_sym_NA_real_] = ACTIONS(7506),
    [anon_sym_NA_complex_] = ACTIONS(7506),
    [anon_sym_NA_character_] = ACTIONS(7506),
    [sym_dots] = ACTIONS(7506),
    [sym_dot_dot_i] = ACTIONS(7504),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7504),
    [sym__newline] = ACTIONS(7504),
    [sym__semicolon] = ACTIONS(7504),
    [sym__raw_string_literal] = ACTIONS(7504),
    [sym__external_else] = ACTIONS(7504),
    [sym__external_open_parenthesis] = ACTIONS(7504),
    [sym__external_open_brace] = ACTIONS(7504),
    [sym__external_close_brace] = ACTIONS(7504),
    [sym__external_open_bracket] = ACTIONS(7504),
    [sym__external_open_bracket2] = ACTIONS(7504),
    [sym__external_close_bracket2] = ACTIONS(7504),
  },
  [2526] = {
    [ts_builtin_sym_end] = ACTIONS(7550),
    [sym_identifier] = ACTIONS(7552),
    [anon_sym_BSLASH] = ACTIONS(7550),
    [anon_sym_function] = ACTIONS(7552),
    [anon_sym_EQ] = ACTIONS(7552),
    [anon_sym_if] = ACTIONS(7552),
    [anon_sym_for] = ACTIONS(7552),
    [anon_sym_while] = ACTIONS(7552),
    [anon_sym_repeat] = ACTIONS(7552),
    [anon_sym_QMARK] = ACTIONS(7550),
    [anon_sym_TILDE] = ACTIONS(7550),
    [anon_sym_BANG] = ACTIONS(7552),
    [anon_sym_PLUS] = ACTIONS(7550),
    [anon_sym_DASH] = ACTIONS(7552),
    [anon_sym_LT_DASH] = ACTIONS(7550),
    [anon_sym_LT_LT_DASH] = ACTIONS(7550),
    [anon_sym_COLON_EQ] = ACTIONS(7550),
    [anon_sym_DASH_GT] = ACTIONS(7552),
    [anon_sym_DASH_GT_GT] = ACTIONS(7550),
    [anon_sym_PIPE] = ACTIONS(7552),
    [anon_sym_AMP] = ACTIONS(7552),
    [anon_sym_PIPE_PIPE] = ACTIONS(7550),
    [anon_sym_AMP_AMP] = ACTIONS(7550),
    [anon_sym_LT] = ACTIONS(7552),
    [anon_sym_LT_EQ] = ACTIONS(7550),
    [anon_sym_GT] = ACTIONS(7552),
    [anon_sym_GT_EQ] = ACTIONS(7550),
    [anon_sym_EQ_EQ] = ACTIONS(7550),
    [anon_sym_BANG_EQ] = ACTIONS(7550),
    [anon_sym_STAR] = ACTIONS(7552),
    [anon_sym_SLASH] = ACTIONS(7550),
    [anon_sym_STAR_STAR] = ACTIONS(7550),
    [anon_sym_CARET] = ACTIONS(7550),
    [aux_sym_binary_operator_token1] = ACTIONS(7550),
    [anon_sym_PIPE_GT] = ACTIONS(7550),
    [anon_sym_COLON] = ACTIONS(7552),
    [anon_sym_DOLLAR] = ACTIONS(7550),
    [anon_sym_AT] = ACTIONS(7550),
    [aux_sym__hex_literal_token1] = ACTIONS(7550),
    [sym__number_literal] = ACTIONS(7552),
    [anon_sym_SQUOTE] = ACTIONS(7550),
    [anon_sym_DQUOTE] = ACTIONS(7550),
    [sym_return] = ACTIONS(7552),
    [sym_next] = ACTIONS(7552),
    [sym_break] = ACTIONS(7552),
    [sym_true] = ACTIONS(7552),
    [sym_false] = ACTIONS(7552),
    [sym_null] = ACTIONS(7552),
    [sym_inf] = ACTIONS(7552),
    [sym_nan] = ACTIONS(7552),
    [anon_sym_NA] = ACTIONS(7552),
    [anon_sym_NA_integer_] = ACTIONS(7552),
    [anon_sym_NA_real_] = ACTIONS(7552),
    [anon_sym_NA_complex_] = ACTIONS(7552),
    [anon_sym_NA_character_] = ACTIONS(7552),
    [sym_dots] = ACTIONS(7552),
    [sym_dot_dot_i] = ACTIONS(7550),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7550),
    [sym__newline] = ACTIONS(7550),
    [sym__semicolon] = ACTIONS(7550),
    [sym__raw_string_literal] = ACTIONS(7550),
    [sym__external_open_parenthesis] = ACTIONS(7550),
    [sym__external_close_parenthesis] = ACTIONS(7550),
    [sym__external_open_brace] = ACTIONS(7550),
    [sym__external_close_brace] = ACTIONS(7550),
    [sym__external_open_bracket] = ACTIONS(7550),
    [sym__external_open_bracket2] = ACTIONS(7550),
  },
  [2527] = {
    [sym_identifier] = ACTIONS(7512),
    [anon_sym_BSLASH] = ACTIONS(7510),
    [anon_sym_function] = ACTIONS(7512),
    [anon_sym_EQ] = ACTIONS(7512),
    [anon_sym_if] = ACTIONS(7512),
    [anon_sym_for] = ACTIONS(7512),
    [anon_sym_while] = ACTIONS(7512),
    [anon_sym_repeat] = ACTIONS(7512),
    [anon_sym_QMARK] = ACTIONS(7510),
    [anon_sym_TILDE] = ACTIONS(7510),
    [anon_sym_BANG] = ACTIONS(7512),
    [anon_sym_PLUS] = ACTIONS(7510),
    [anon_sym_DASH] = ACTIONS(7512),
    [anon_sym_LT_DASH] = ACTIONS(7510),
    [anon_sym_LT_LT_DASH] = ACTIONS(7510),
    [anon_sym_COLON_EQ] = ACTIONS(7510),
    [anon_sym_DASH_GT] = ACTIONS(7512),
    [anon_sym_DASH_GT_GT] = ACTIONS(7510),
    [anon_sym_PIPE] = ACTIONS(7512),
    [anon_sym_AMP] = ACTIONS(7512),
    [anon_sym_PIPE_PIPE] = ACTIONS(7510),
    [anon_sym_AMP_AMP] = ACTIONS(7510),
    [anon_sym_LT] = ACTIONS(7512),
    [anon_sym_LT_EQ] = ACTIONS(7510),
    [anon_sym_GT] = ACTIONS(7512),
    [anon_sym_GT_EQ] = ACTIONS(7510),
    [anon_sym_EQ_EQ] = ACTIONS(7510),
    [anon_sym_BANG_EQ] = ACTIONS(7510),
    [anon_sym_STAR] = ACTIONS(7512),
    [anon_sym_SLASH] = ACTIONS(7510),
    [anon_sym_STAR_STAR] = ACTIONS(7510),
    [anon_sym_CARET] = ACTIONS(7510),
    [aux_sym_binary_operator_token1] = ACTIONS(7510),
    [anon_sym_PIPE_GT] = ACTIONS(7510),
    [anon_sym_COLON] = ACTIONS(7512),
    [anon_sym_DOLLAR] = ACTIONS(7510),
    [anon_sym_AT] = ACTIONS(7510),
    [aux_sym__hex_literal_token1] = ACTIONS(7510),
    [sym__number_literal] = ACTIONS(7512),
    [anon_sym_SQUOTE] = ACTIONS(7510),
    [anon_sym_DQUOTE] = ACTIONS(7510),
    [sym_return] = ACTIONS(7512),
    [sym_next] = ACTIONS(7512),
    [sym_break] = ACTIONS(7512),
    [sym_true] = ACTIONS(7512),
    [sym_false] = ACTIONS(7512),
    [sym_null] = ACTIONS(7512),
    [sym_inf] = ACTIONS(7512),
    [sym_nan] = ACTIONS(7512),
    [anon_sym_NA] = ACTIONS(7512),
    [anon_sym_NA_integer_] = ACTIONS(7512),
    [anon_sym_NA_real_] = ACTIONS(7512),
    [anon_sym_NA_complex_] = ACTIONS(7512),
    [anon_sym_NA_character_] = ACTIONS(7512),
    [sym_dots] = ACTIONS(7512),
    [sym_dot_dot_i] = ACTIONS(7510),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7510),
    [sym__newline] = ACTIONS(7510),
    [sym__semicolon] = ACTIONS(7510),
    [sym__raw_string_literal] = ACTIONS(7510),
    [sym__external_else] = ACTIONS(7510),
    [sym__external_open_parenthesis] = ACTIONS(7510),
    [sym__external_open_brace] = ACTIONS(7510),
    [sym__external_close_brace] = ACTIONS(7510),
    [sym__external_open_bracket] = ACTIONS(7510),
    [sym__external_open_bracket2] = ACTIONS(7510),
    [sym__external_close_bracket2] = ACTIONS(7510),
  },
  [2528] = {
    [ts_builtin_sym_end] = ACTIONS(7117),
    [sym_identifier] = ACTIONS(7115),
    [anon_sym_BSLASH] = ACTIONS(7117),
    [anon_sym_function] = ACTIONS(7115),
    [anon_sym_EQ] = ACTIONS(7115),
    [anon_sym_if] = ACTIONS(7115),
    [anon_sym_for] = ACTIONS(7115),
    [anon_sym_while] = ACTIONS(7115),
    [anon_sym_repeat] = ACTIONS(7115),
    [anon_sym_QMARK] = ACTIONS(7117),
    [anon_sym_TILDE] = ACTIONS(7117),
    [anon_sym_BANG] = ACTIONS(7115),
    [anon_sym_PLUS] = ACTIONS(7117),
    [anon_sym_DASH] = ACTIONS(7115),
    [anon_sym_LT_DASH] = ACTIONS(7117),
    [anon_sym_LT_LT_DASH] = ACTIONS(7117),
    [anon_sym_COLON_EQ] = ACTIONS(7117),
    [anon_sym_DASH_GT] = ACTIONS(7115),
    [anon_sym_DASH_GT_GT] = ACTIONS(7117),
    [anon_sym_PIPE] = ACTIONS(7115),
    [anon_sym_AMP] = ACTIONS(7115),
    [anon_sym_PIPE_PIPE] = ACTIONS(7117),
    [anon_sym_AMP_AMP] = ACTIONS(7117),
    [anon_sym_LT] = ACTIONS(7115),
    [anon_sym_LT_EQ] = ACTIONS(7117),
    [anon_sym_GT] = ACTIONS(7115),
    [anon_sym_GT_EQ] = ACTIONS(7117),
    [anon_sym_EQ_EQ] = ACTIONS(7117),
    [anon_sym_BANG_EQ] = ACTIONS(7117),
    [anon_sym_STAR] = ACTIONS(7115),
    [anon_sym_SLASH] = ACTIONS(7117),
    [anon_sym_STAR_STAR] = ACTIONS(7117),
    [anon_sym_CARET] = ACTIONS(7117),
    [aux_sym_binary_operator_token1] = ACTIONS(7117),
    [anon_sym_PIPE_GT] = ACTIONS(7117),
    [anon_sym_COLON] = ACTIONS(7115),
    [anon_sym_DOLLAR] = ACTIONS(7117),
    [anon_sym_AT] = ACTIONS(7117),
    [anon_sym_COLON_COLON] = ACTIONS(7115),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7117),
    [aux_sym__hex_literal_token1] = ACTIONS(7117),
    [sym__number_literal] = ACTIONS(7115),
    [anon_sym_SQUOTE] = ACTIONS(7117),
    [anon_sym_DQUOTE] = ACTIONS(7117),
    [sym_return] = ACTIONS(7115),
    [sym_next] = ACTIONS(7115),
    [sym_break] = ACTIONS(7115),
    [sym_true] = ACTIONS(7115),
    [sym_false] = ACTIONS(7115),
    [sym_null] = ACTIONS(7115),
    [sym_inf] = ACTIONS(7115),
    [sym_nan] = ACTIONS(7115),
    [anon_sym_NA] = ACTIONS(7115),
    [anon_sym_NA_integer_] = ACTIONS(7115),
    [anon_sym_NA_real_] = ACTIONS(7115),
    [anon_sym_NA_complex_] = ACTIONS(7115),
    [anon_sym_NA_character_] = ACTIONS(7115),
    [sym_dots] = ACTIONS(7115),
    [sym_dot_dot_i] = ACTIONS(7117),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7117),
    [sym__semicolon] = ACTIONS(7117),
    [sym__raw_string_literal] = ACTIONS(7117),
    [sym__external_open_parenthesis] = ACTIONS(7117),
    [sym__external_open_brace] = ACTIONS(7117),
    [sym__external_close_brace] = ACTIONS(7117),
    [sym__external_open_bracket] = ACTIONS(7117),
    [sym__external_open_bracket2] = ACTIONS(7117),
  },
  [2529] = {
    [ts_builtin_sym_end] = ACTIONS(7117),
    [sym_identifier] = ACTIONS(7115),
    [anon_sym_BSLASH] = ACTIONS(7117),
    [anon_sym_function] = ACTIONS(7115),
    [anon_sym_EQ] = ACTIONS(7115),
    [anon_sym_if] = ACTIONS(7115),
    [anon_sym_for] = ACTIONS(7115),
    [anon_sym_while] = ACTIONS(7115),
    [anon_sym_repeat] = ACTIONS(7115),
    [anon_sym_QMARK] = ACTIONS(7117),
    [anon_sym_TILDE] = ACTIONS(7117),
    [anon_sym_BANG] = ACTIONS(7115),
    [anon_sym_PLUS] = ACTIONS(7117),
    [anon_sym_DASH] = ACTIONS(7115),
    [anon_sym_LT_DASH] = ACTIONS(7117),
    [anon_sym_LT_LT_DASH] = ACTIONS(7117),
    [anon_sym_COLON_EQ] = ACTIONS(7117),
    [anon_sym_DASH_GT] = ACTIONS(7115),
    [anon_sym_DASH_GT_GT] = ACTIONS(7117),
    [anon_sym_PIPE] = ACTIONS(7115),
    [anon_sym_AMP] = ACTIONS(7115),
    [anon_sym_PIPE_PIPE] = ACTIONS(7117),
    [anon_sym_AMP_AMP] = ACTIONS(7117),
    [anon_sym_LT] = ACTIONS(7115),
    [anon_sym_LT_EQ] = ACTIONS(7117),
    [anon_sym_GT] = ACTIONS(7115),
    [anon_sym_GT_EQ] = ACTIONS(7117),
    [anon_sym_EQ_EQ] = ACTIONS(7117),
    [anon_sym_BANG_EQ] = ACTIONS(7117),
    [anon_sym_STAR] = ACTIONS(7115),
    [anon_sym_SLASH] = ACTIONS(7117),
    [anon_sym_STAR_STAR] = ACTIONS(7117),
    [anon_sym_CARET] = ACTIONS(7117),
    [aux_sym_binary_operator_token1] = ACTIONS(7117),
    [anon_sym_PIPE_GT] = ACTIONS(7117),
    [anon_sym_COLON] = ACTIONS(7115),
    [anon_sym_DOLLAR] = ACTIONS(7117),
    [anon_sym_AT] = ACTIONS(7117),
    [anon_sym_COLON_COLON] = ACTIONS(7115),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7117),
    [aux_sym__hex_literal_token1] = ACTIONS(7117),
    [sym__number_literal] = ACTIONS(7115),
    [anon_sym_SQUOTE] = ACTIONS(7117),
    [anon_sym_DQUOTE] = ACTIONS(7117),
    [sym_return] = ACTIONS(7115),
    [sym_next] = ACTIONS(7115),
    [sym_break] = ACTIONS(7115),
    [sym_true] = ACTIONS(7115),
    [sym_false] = ACTIONS(7115),
    [sym_null] = ACTIONS(7115),
    [sym_inf] = ACTIONS(7115),
    [sym_nan] = ACTIONS(7115),
    [anon_sym_NA] = ACTIONS(7115),
    [anon_sym_NA_integer_] = ACTIONS(7115),
    [anon_sym_NA_real_] = ACTIONS(7115),
    [anon_sym_NA_complex_] = ACTIONS(7115),
    [anon_sym_NA_character_] = ACTIONS(7115),
    [sym_dots] = ACTIONS(7115),
    [sym_dot_dot_i] = ACTIONS(7117),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7117),
    [sym__semicolon] = ACTIONS(7117),
    [sym__raw_string_literal] = ACTIONS(7117),
    [sym__external_open_parenthesis] = ACTIONS(7117),
    [sym__external_open_brace] = ACTIONS(7117),
    [sym__external_close_brace] = ACTIONS(7117),
    [sym__external_open_bracket] = ACTIONS(7117),
    [sym__external_open_bracket2] = ACTIONS(7117),
  },
  [2530] = {
    [sym_identifier] = ACTIONS(7129),
    [anon_sym_BSLASH] = ACTIONS(7131),
    [anon_sym_function] = ACTIONS(7129),
    [anon_sym_EQ] = ACTIONS(7129),
    [anon_sym_if] = ACTIONS(7129),
    [anon_sym_for] = ACTIONS(7129),
    [anon_sym_while] = ACTIONS(7129),
    [anon_sym_repeat] = ACTIONS(7129),
    [anon_sym_QMARK] = ACTIONS(7131),
    [anon_sym_TILDE] = ACTIONS(7131),
    [anon_sym_BANG] = ACTIONS(7129),
    [anon_sym_PLUS] = ACTIONS(7131),
    [anon_sym_DASH] = ACTIONS(7129),
    [anon_sym_LT_DASH] = ACTIONS(7131),
    [anon_sym_LT_LT_DASH] = ACTIONS(7131),
    [anon_sym_COLON_EQ] = ACTIONS(7131),
    [anon_sym_DASH_GT] = ACTIONS(7129),
    [anon_sym_DASH_GT_GT] = ACTIONS(7131),
    [anon_sym_PIPE] = ACTIONS(7129),
    [anon_sym_AMP] = ACTIONS(7129),
    [anon_sym_PIPE_PIPE] = ACTIONS(7131),
    [anon_sym_AMP_AMP] = ACTIONS(7131),
    [anon_sym_LT] = ACTIONS(7129),
    [anon_sym_LT_EQ] = ACTIONS(7131),
    [anon_sym_GT] = ACTIONS(7129),
    [anon_sym_GT_EQ] = ACTIONS(7131),
    [anon_sym_EQ_EQ] = ACTIONS(7131),
    [anon_sym_BANG_EQ] = ACTIONS(7131),
    [anon_sym_STAR] = ACTIONS(7129),
    [anon_sym_SLASH] = ACTIONS(7131),
    [anon_sym_STAR_STAR] = ACTIONS(7131),
    [anon_sym_CARET] = ACTIONS(7131),
    [aux_sym_binary_operator_token1] = ACTIONS(7131),
    [anon_sym_PIPE_GT] = ACTIONS(7131),
    [anon_sym_COLON] = ACTIONS(7129),
    [anon_sym_DOLLAR] = ACTIONS(7131),
    [anon_sym_AT] = ACTIONS(7131),
    [anon_sym_COLON_COLON] = ACTIONS(7133),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7135),
    [aux_sym__hex_literal_token1] = ACTIONS(7131),
    [sym__number_literal] = ACTIONS(7129),
    [anon_sym_SQUOTE] = ACTIONS(7131),
    [anon_sym_DQUOTE] = ACTIONS(7131),
    [sym_return] = ACTIONS(7129),
    [sym_next] = ACTIONS(7129),
    [sym_break] = ACTIONS(7129),
    [sym_true] = ACTIONS(7129),
    [sym_false] = ACTIONS(7129),
    [sym_null] = ACTIONS(7129),
    [sym_inf] = ACTIONS(7129),
    [sym_nan] = ACTIONS(7129),
    [anon_sym_NA] = ACTIONS(7129),
    [anon_sym_NA_integer_] = ACTIONS(7129),
    [anon_sym_NA_real_] = ACTIONS(7129),
    [anon_sym_NA_complex_] = ACTIONS(7129),
    [anon_sym_NA_character_] = ACTIONS(7129),
    [sym_dots] = ACTIONS(7129),
    [sym_dot_dot_i] = ACTIONS(7131),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7131),
    [sym__newline] = ACTIONS(7131),
    [sym__raw_string_literal] = ACTIONS(7131),
    [sym__external_open_parenthesis] = ACTIONS(7131),
    [sym__external_close_parenthesis] = ACTIONS(7131),
    [sym__external_open_brace] = ACTIONS(7131),
    [sym__external_open_bracket] = ACTIONS(7131),
    [sym__external_close_bracket] = ACTIONS(7131),
    [sym__external_open_bracket2] = ACTIONS(7131),
  },
  [2531] = {
    [sym_identifier] = ACTIONS(5311),
    [anon_sym_BSLASH] = ACTIONS(5313),
    [anon_sym_function] = ACTIONS(5311),
    [anon_sym_EQ] = ACTIONS(5311),
    [anon_sym_if] = ACTIONS(5311),
    [anon_sym_for] = ACTIONS(5311),
    [anon_sym_while] = ACTIONS(5311),
    [anon_sym_repeat] = ACTIONS(5311),
    [anon_sym_QMARK] = ACTIONS(5313),
    [anon_sym_TILDE] = ACTIONS(5313),
    [anon_sym_BANG] = ACTIONS(5311),
    [anon_sym_PLUS] = ACTIONS(5313),
    [anon_sym_DASH] = ACTIONS(5311),
    [anon_sym_LT_DASH] = ACTIONS(5313),
    [anon_sym_LT_LT_DASH] = ACTIONS(5313),
    [anon_sym_COLON_EQ] = ACTIONS(5313),
    [anon_sym_DASH_GT] = ACTIONS(5311),
    [anon_sym_DASH_GT_GT] = ACTIONS(5313),
    [anon_sym_PIPE] = ACTIONS(5311),
    [anon_sym_AMP] = ACTIONS(5311),
    [anon_sym_PIPE_PIPE] = ACTIONS(5313),
    [anon_sym_AMP_AMP] = ACTIONS(5313),
    [anon_sym_LT] = ACTIONS(5311),
    [anon_sym_LT_EQ] = ACTIONS(5313),
    [anon_sym_GT] = ACTIONS(5311),
    [anon_sym_GT_EQ] = ACTIONS(5313),
    [anon_sym_EQ_EQ] = ACTIONS(5313),
    [anon_sym_BANG_EQ] = ACTIONS(5313),
    [anon_sym_STAR] = ACTIONS(5311),
    [anon_sym_SLASH] = ACTIONS(5313),
    [anon_sym_STAR_STAR] = ACTIONS(5313),
    [anon_sym_CARET] = ACTIONS(5313),
    [aux_sym_binary_operator_token1] = ACTIONS(5313),
    [anon_sym_PIPE_GT] = ACTIONS(5313),
    [anon_sym_COLON] = ACTIONS(5311),
    [anon_sym_DOLLAR] = ACTIONS(5313),
    [anon_sym_AT] = ACTIONS(5313),
    [aux_sym__hex_literal_token1] = ACTIONS(5313),
    [sym__number_literal] = ACTIONS(5311),
    [anon_sym_SQUOTE] = ACTIONS(5313),
    [anon_sym_DQUOTE] = ACTIONS(5313),
    [sym_return] = ACTIONS(5311),
    [sym_next] = ACTIONS(5311),
    [sym_break] = ACTIONS(5311),
    [sym_true] = ACTIONS(5311),
    [sym_false] = ACTIONS(5311),
    [sym_null] = ACTIONS(5311),
    [sym_inf] = ACTIONS(5311),
    [sym_nan] = ACTIONS(5311),
    [anon_sym_NA] = ACTIONS(5311),
    [anon_sym_NA_integer_] = ACTIONS(5311),
    [anon_sym_NA_real_] = ACTIONS(5311),
    [anon_sym_NA_complex_] = ACTIONS(5311),
    [anon_sym_NA_character_] = ACTIONS(5311),
    [sym_dots] = ACTIONS(5311),
    [sym_dot_dot_i] = ACTIONS(5313),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5313),
    [sym__newline] = ACTIONS(5313),
    [sym__semicolon] = ACTIONS(5313),
    [sym__raw_string_literal] = ACTIONS(5313),
    [sym__external_open_parenthesis] = ACTIONS(5313),
    [sym__external_close_parenthesis] = ACTIONS(5313),
    [sym__external_open_brace] = ACTIONS(5313),
    [sym__external_close_brace] = ACTIONS(5313),
    [sym__external_open_bracket] = ACTIONS(5313),
    [sym__external_open_bracket2] = ACTIONS(5313),
    [sym__external_close_bracket2] = ACTIONS(5313),
  },
  [2532] = {
    [ts_builtin_sym_end] = ACTIONS(7139),
    [sym_identifier] = ACTIONS(7137),
    [anon_sym_BSLASH] = ACTIONS(7139),
    [anon_sym_function] = ACTIONS(7137),
    [anon_sym_EQ] = ACTIONS(7137),
    [anon_sym_if] = ACTIONS(7137),
    [anon_sym_for] = ACTIONS(7137),
    [anon_sym_while] = ACTIONS(7137),
    [anon_sym_repeat] = ACTIONS(7137),
    [anon_sym_QMARK] = ACTIONS(7139),
    [anon_sym_TILDE] = ACTIONS(7139),
    [anon_sym_BANG] = ACTIONS(7137),
    [anon_sym_PLUS] = ACTIONS(7139),
    [anon_sym_DASH] = ACTIONS(7137),
    [anon_sym_LT_DASH] = ACTIONS(7139),
    [anon_sym_LT_LT_DASH] = ACTIONS(7139),
    [anon_sym_COLON_EQ] = ACTIONS(7139),
    [anon_sym_DASH_GT] = ACTIONS(7137),
    [anon_sym_DASH_GT_GT] = ACTIONS(7139),
    [anon_sym_PIPE] = ACTIONS(7137),
    [anon_sym_AMP] = ACTIONS(7137),
    [anon_sym_PIPE_PIPE] = ACTIONS(7139),
    [anon_sym_AMP_AMP] = ACTIONS(7139),
    [anon_sym_LT] = ACTIONS(7137),
    [anon_sym_LT_EQ] = ACTIONS(7139),
    [anon_sym_GT] = ACTIONS(7137),
    [anon_sym_GT_EQ] = ACTIONS(7139),
    [anon_sym_EQ_EQ] = ACTIONS(7139),
    [anon_sym_BANG_EQ] = ACTIONS(7139),
    [anon_sym_STAR] = ACTIONS(7137),
    [anon_sym_SLASH] = ACTIONS(7139),
    [anon_sym_STAR_STAR] = ACTIONS(7139),
    [anon_sym_CARET] = ACTIONS(7139),
    [aux_sym_binary_operator_token1] = ACTIONS(7139),
    [anon_sym_PIPE_GT] = ACTIONS(7139),
    [anon_sym_COLON] = ACTIONS(7137),
    [anon_sym_DOLLAR] = ACTIONS(7139),
    [anon_sym_AT] = ACTIONS(7139),
    [anon_sym_COLON_COLON] = ACTIONS(7137),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7139),
    [aux_sym__hex_literal_token1] = ACTIONS(7139),
    [sym__number_literal] = ACTIONS(7137),
    [anon_sym_SQUOTE] = ACTIONS(7139),
    [anon_sym_DQUOTE] = ACTIONS(7139),
    [sym_return] = ACTIONS(7137),
    [sym_next] = ACTIONS(7137),
    [sym_break] = ACTIONS(7137),
    [sym_true] = ACTIONS(7137),
    [sym_false] = ACTIONS(7137),
    [sym_null] = ACTIONS(7137),
    [sym_inf] = ACTIONS(7137),
    [sym_nan] = ACTIONS(7137),
    [anon_sym_NA] = ACTIONS(7137),
    [anon_sym_NA_integer_] = ACTIONS(7137),
    [anon_sym_NA_real_] = ACTIONS(7137),
    [anon_sym_NA_complex_] = ACTIONS(7137),
    [anon_sym_NA_character_] = ACTIONS(7137),
    [sym_dots] = ACTIONS(7137),
    [sym_dot_dot_i] = ACTIONS(7139),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7139),
    [sym__semicolon] = ACTIONS(7139),
    [sym__raw_string_literal] = ACTIONS(7139),
    [sym__external_else] = ACTIONS(7139),
    [sym__external_open_parenthesis] = ACTIONS(7139),
    [sym__external_open_brace] = ACTIONS(7139),
    [sym__external_open_bracket] = ACTIONS(7139),
    [sym__external_open_bracket2] = ACTIONS(7139),
  },
  [2533] = {
    [sym_identifier] = ACTIONS(7506),
    [anon_sym_BSLASH] = ACTIONS(7504),
    [anon_sym_function] = ACTIONS(7506),
    [anon_sym_EQ] = ACTIONS(7506),
    [anon_sym_if] = ACTIONS(7506),
    [anon_sym_for] = ACTIONS(7506),
    [anon_sym_while] = ACTIONS(7506),
    [anon_sym_repeat] = ACTIONS(7506),
    [anon_sym_QMARK] = ACTIONS(7504),
    [anon_sym_TILDE] = ACTIONS(7504),
    [anon_sym_BANG] = ACTIONS(7506),
    [anon_sym_PLUS] = ACTIONS(7504),
    [anon_sym_DASH] = ACTIONS(7506),
    [anon_sym_LT_DASH] = ACTIONS(7504),
    [anon_sym_LT_LT_DASH] = ACTIONS(7504),
    [anon_sym_COLON_EQ] = ACTIONS(7504),
    [anon_sym_DASH_GT] = ACTIONS(7506),
    [anon_sym_DASH_GT_GT] = ACTIONS(7504),
    [anon_sym_PIPE] = ACTIONS(7506),
    [anon_sym_AMP] = ACTIONS(7506),
    [anon_sym_PIPE_PIPE] = ACTIONS(7504),
    [anon_sym_AMP_AMP] = ACTIONS(7504),
    [anon_sym_LT] = ACTIONS(7506),
    [anon_sym_LT_EQ] = ACTIONS(7504),
    [anon_sym_GT] = ACTIONS(7506),
    [anon_sym_GT_EQ] = ACTIONS(7504),
    [anon_sym_EQ_EQ] = ACTIONS(7504),
    [anon_sym_BANG_EQ] = ACTIONS(7504),
    [anon_sym_STAR] = ACTIONS(7506),
    [anon_sym_SLASH] = ACTIONS(7504),
    [anon_sym_STAR_STAR] = ACTIONS(7504),
    [anon_sym_CARET] = ACTIONS(7504),
    [aux_sym_binary_operator_token1] = ACTIONS(7504),
    [anon_sym_PIPE_GT] = ACTIONS(7504),
    [anon_sym_COLON] = ACTIONS(7506),
    [anon_sym_DOLLAR] = ACTIONS(7504),
    [anon_sym_AT] = ACTIONS(7504),
    [aux_sym__hex_literal_token1] = ACTIONS(7504),
    [sym__number_literal] = ACTIONS(7506),
    [anon_sym_SQUOTE] = ACTIONS(7504),
    [anon_sym_DQUOTE] = ACTIONS(7504),
    [sym_return] = ACTIONS(7506),
    [sym_next] = ACTIONS(7506),
    [sym_break] = ACTIONS(7506),
    [sym_true] = ACTIONS(7506),
    [sym_false] = ACTIONS(7506),
    [sym_null] = ACTIONS(7506),
    [sym_inf] = ACTIONS(7506),
    [sym_nan] = ACTIONS(7506),
    [anon_sym_NA] = ACTIONS(7506),
    [anon_sym_NA_integer_] = ACTIONS(7506),
    [anon_sym_NA_real_] = ACTIONS(7506),
    [anon_sym_NA_complex_] = ACTIONS(7506),
    [anon_sym_NA_character_] = ACTIONS(7506),
    [sym_dots] = ACTIONS(7506),
    [sym_dot_dot_i] = ACTIONS(7504),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7504),
    [sym__newline] = ACTIONS(7504),
    [sym__semicolon] = ACTIONS(7504),
    [sym__raw_string_literal] = ACTIONS(7504),
    [sym__external_open_parenthesis] = ACTIONS(7504),
    [sym__external_close_parenthesis] = ACTIONS(7504),
    [sym__external_open_brace] = ACTIONS(7504),
    [sym__external_close_brace] = ACTIONS(7504),
    [sym__external_open_bracket] = ACTIONS(7504),
    [sym__external_close_bracket] = ACTIONS(7504),
    [sym__external_open_bracket2] = ACTIONS(7504),
  },
  [2534] = {
    [ts_builtin_sym_end] = ACTIONS(7131),
    [sym_identifier] = ACTIONS(7129),
    [anon_sym_BSLASH] = ACTIONS(7131),
    [anon_sym_function] = ACTIONS(7129),
    [anon_sym_EQ] = ACTIONS(7129),
    [anon_sym_if] = ACTIONS(7129),
    [anon_sym_for] = ACTIONS(7129),
    [anon_sym_while] = ACTIONS(7129),
    [anon_sym_repeat] = ACTIONS(7129),
    [anon_sym_QMARK] = ACTIONS(7131),
    [anon_sym_TILDE] = ACTIONS(7131),
    [anon_sym_BANG] = ACTIONS(7129),
    [anon_sym_PLUS] = ACTIONS(7131),
    [anon_sym_DASH] = ACTIONS(7129),
    [anon_sym_LT_DASH] = ACTIONS(7131),
    [anon_sym_LT_LT_DASH] = ACTIONS(7131),
    [anon_sym_COLON_EQ] = ACTIONS(7131),
    [anon_sym_DASH_GT] = ACTIONS(7129),
    [anon_sym_DASH_GT_GT] = ACTIONS(7131),
    [anon_sym_PIPE] = ACTIONS(7129),
    [anon_sym_AMP] = ACTIONS(7129),
    [anon_sym_PIPE_PIPE] = ACTIONS(7131),
    [anon_sym_AMP_AMP] = ACTIONS(7131),
    [anon_sym_LT] = ACTIONS(7129),
    [anon_sym_LT_EQ] = ACTIONS(7131),
    [anon_sym_GT] = ACTIONS(7129),
    [anon_sym_GT_EQ] = ACTIONS(7131),
    [anon_sym_EQ_EQ] = ACTIONS(7131),
    [anon_sym_BANG_EQ] = ACTIONS(7131),
    [anon_sym_STAR] = ACTIONS(7129),
    [anon_sym_SLASH] = ACTIONS(7131),
    [anon_sym_STAR_STAR] = ACTIONS(7131),
    [anon_sym_CARET] = ACTIONS(7131),
    [aux_sym_binary_operator_token1] = ACTIONS(7131),
    [anon_sym_PIPE_GT] = ACTIONS(7131),
    [anon_sym_COLON] = ACTIONS(7129),
    [anon_sym_DOLLAR] = ACTIONS(7131),
    [anon_sym_AT] = ACTIONS(7131),
    [anon_sym_COLON_COLON] = ACTIONS(7133),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7135),
    [aux_sym__hex_literal_token1] = ACTIONS(7131),
    [sym__number_literal] = ACTIONS(7129),
    [anon_sym_SQUOTE] = ACTIONS(7131),
    [anon_sym_DQUOTE] = ACTIONS(7131),
    [sym_return] = ACTIONS(7129),
    [sym_next] = ACTIONS(7129),
    [sym_break] = ACTIONS(7129),
    [sym_true] = ACTIONS(7129),
    [sym_false] = ACTIONS(7129),
    [sym_null] = ACTIONS(7129),
    [sym_inf] = ACTIONS(7129),
    [sym_nan] = ACTIONS(7129),
    [anon_sym_NA] = ACTIONS(7129),
    [anon_sym_NA_integer_] = ACTIONS(7129),
    [anon_sym_NA_real_] = ACTIONS(7129),
    [anon_sym_NA_complex_] = ACTIONS(7129),
    [anon_sym_NA_character_] = ACTIONS(7129),
    [sym_dots] = ACTIONS(7129),
    [sym_dot_dot_i] = ACTIONS(7131),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7131),
    [sym__semicolon] = ACTIONS(7131),
    [sym__raw_string_literal] = ACTIONS(7131),
    [sym__external_else] = ACTIONS(7131),
    [sym__external_open_parenthesis] = ACTIONS(7131),
    [sym__external_open_brace] = ACTIONS(7131),
    [sym__external_open_bracket] = ACTIONS(7131),
    [sym__external_open_bracket2] = ACTIONS(7131),
  },
  [2535] = {
    [ts_builtin_sym_end] = ACTIONS(7565),
    [sym_identifier] = ACTIONS(7567),
    [anon_sym_BSLASH] = ACTIONS(7565),
    [anon_sym_function] = ACTIONS(7567),
    [anon_sym_EQ] = ACTIONS(7567),
    [anon_sym_if] = ACTIONS(7567),
    [anon_sym_for] = ACTIONS(7567),
    [anon_sym_while] = ACTIONS(7567),
    [anon_sym_repeat] = ACTIONS(7567),
    [anon_sym_QMARK] = ACTIONS(7565),
    [anon_sym_TILDE] = ACTIONS(7565),
    [anon_sym_BANG] = ACTIONS(7567),
    [anon_sym_PLUS] = ACTIONS(7565),
    [anon_sym_DASH] = ACTIONS(7567),
    [anon_sym_LT_DASH] = ACTIONS(7565),
    [anon_sym_LT_LT_DASH] = ACTIONS(7565),
    [anon_sym_COLON_EQ] = ACTIONS(7565),
    [anon_sym_DASH_GT] = ACTIONS(7567),
    [anon_sym_DASH_GT_GT] = ACTIONS(7565),
    [anon_sym_PIPE] = ACTIONS(7567),
    [anon_sym_AMP] = ACTIONS(7567),
    [anon_sym_PIPE_PIPE] = ACTIONS(7565),
    [anon_sym_AMP_AMP] = ACTIONS(7565),
    [anon_sym_LT] = ACTIONS(7567),
    [anon_sym_LT_EQ] = ACTIONS(7565),
    [anon_sym_GT] = ACTIONS(7567),
    [anon_sym_GT_EQ] = ACTIONS(7565),
    [anon_sym_EQ_EQ] = ACTIONS(7565),
    [anon_sym_BANG_EQ] = ACTIONS(7565),
    [anon_sym_STAR] = ACTIONS(7567),
    [anon_sym_SLASH] = ACTIONS(7565),
    [anon_sym_STAR_STAR] = ACTIONS(7565),
    [anon_sym_CARET] = ACTIONS(7565),
    [aux_sym_binary_operator_token1] = ACTIONS(7565),
    [anon_sym_PIPE_GT] = ACTIONS(7565),
    [anon_sym_COLON] = ACTIONS(7567),
    [anon_sym_DOLLAR] = ACTIONS(7565),
    [anon_sym_AT] = ACTIONS(7565),
    [aux_sym__hex_literal_token1] = ACTIONS(7565),
    [sym__number_literal] = ACTIONS(7567),
    [anon_sym_SQUOTE] = ACTIONS(7565),
    [anon_sym_DQUOTE] = ACTIONS(7565),
    [sym_return] = ACTIONS(7567),
    [sym_next] = ACTIONS(7567),
    [sym_break] = ACTIONS(7567),
    [sym_true] = ACTIONS(7567),
    [sym_false] = ACTIONS(7567),
    [sym_null] = ACTIONS(7567),
    [sym_inf] = ACTIONS(7567),
    [sym_nan] = ACTIONS(7567),
    [anon_sym_NA] = ACTIONS(7567),
    [anon_sym_NA_integer_] = ACTIONS(7567),
    [anon_sym_NA_real_] = ACTIONS(7567),
    [anon_sym_NA_complex_] = ACTIONS(7567),
    [anon_sym_NA_character_] = ACTIONS(7567),
    [sym_dots] = ACTIONS(7567),
    [sym_dot_dot_i] = ACTIONS(7565),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7565),
    [sym__newline] = ACTIONS(7565),
    [sym__semicolon] = ACTIONS(7565),
    [sym__raw_string_literal] = ACTIONS(7565),
    [sym__external_open_parenthesis] = ACTIONS(7565),
    [sym__external_close_parenthesis] = ACTIONS(7565),
    [sym__external_open_brace] = ACTIONS(7565),
    [sym__external_close_brace] = ACTIONS(7565),
    [sym__external_open_bracket] = ACTIONS(7565),
    [sym__external_open_bracket2] = ACTIONS(7565),
  },
  [2536] = {
    [ts_builtin_sym_end] = ACTIONS(7123),
    [sym_identifier] = ACTIONS(7121),
    [anon_sym_BSLASH] = ACTIONS(7123),
    [anon_sym_function] = ACTIONS(7121),
    [anon_sym_EQ] = ACTIONS(7121),
    [anon_sym_if] = ACTIONS(7121),
    [anon_sym_for] = ACTIONS(7121),
    [anon_sym_while] = ACTIONS(7121),
    [anon_sym_repeat] = ACTIONS(7121),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_TILDE] = ACTIONS(7123),
    [anon_sym_BANG] = ACTIONS(7121),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_DASH] = ACTIONS(7121),
    [anon_sym_LT_DASH] = ACTIONS(7123),
    [anon_sym_LT_LT_DASH] = ACTIONS(7123),
    [anon_sym_COLON_EQ] = ACTIONS(7123),
    [anon_sym_DASH_GT] = ACTIONS(7121),
    [anon_sym_DASH_GT_GT] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_LT_EQ] = ACTIONS(7123),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
    [aux_sym_binary_operator_token1] = ACTIONS(7123),
    [anon_sym_PIPE_GT] = ACTIONS(7123),
    [anon_sym_COLON] = ACTIONS(7121),
    [anon_sym_DOLLAR] = ACTIONS(7123),
    [anon_sym_AT] = ACTIONS(7123),
    [anon_sym_L] = ACTIONS(7641),
    [anon_sym_i] = ACTIONS(7643),
    [aux_sym__hex_literal_token1] = ACTIONS(7123),
    [sym__number_literal] = ACTIONS(7121),
    [anon_sym_SQUOTE] = ACTIONS(7123),
    [anon_sym_DQUOTE] = ACTIONS(7123),
    [sym_return] = ACTIONS(7121),
    [sym_next] = ACTIONS(7121),
    [sym_break] = ACTIONS(7121),
    [sym_true] = ACTIONS(7121),
    [sym_false] = ACTIONS(7121),
    [sym_null] = ACTIONS(7121),
    [sym_inf] = ACTIONS(7121),
    [sym_nan] = ACTIONS(7121),
    [anon_sym_NA] = ACTIONS(7121),
    [anon_sym_NA_integer_] = ACTIONS(7121),
    [anon_sym_NA_real_] = ACTIONS(7121),
    [anon_sym_NA_complex_] = ACTIONS(7121),
    [anon_sym_NA_character_] = ACTIONS(7121),
    [sym_dots] = ACTIONS(7121),
    [sym_dot_dot_i] = ACTIONS(7123),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7123),
    [sym__semicolon] = ACTIONS(7123),
    [sym__raw_string_literal] = ACTIONS(7123),
    [sym__external_else] = ACTIONS(7123),
    [sym__external_open_parenthesis] = ACTIONS(7123),
    [sym__external_open_brace] = ACTIONS(7123),
    [sym__external_open_bracket] = ACTIONS(7123),
    [sym__external_open_bracket2] = ACTIONS(7123),
  },
  [2537] = {
    [sym_identifier] = ACTIONS(7512),
    [anon_sym_BSLASH] = ACTIONS(7510),
    [anon_sym_function] = ACTIONS(7512),
    [anon_sym_EQ] = ACTIONS(7512),
    [anon_sym_if] = ACTIONS(7512),
    [anon_sym_for] = ACTIONS(7512),
    [anon_sym_while] = ACTIONS(7512),
    [anon_sym_repeat] = ACTIONS(7512),
    [anon_sym_QMARK] = ACTIONS(7510),
    [anon_sym_TILDE] = ACTIONS(7510),
    [anon_sym_BANG] = ACTIONS(7512),
    [anon_sym_PLUS] = ACTIONS(7510),
    [anon_sym_DASH] = ACTIONS(7512),
    [anon_sym_LT_DASH] = ACTIONS(7510),
    [anon_sym_LT_LT_DASH] = ACTIONS(7510),
    [anon_sym_COLON_EQ] = ACTIONS(7510),
    [anon_sym_DASH_GT] = ACTIONS(7512),
    [anon_sym_DASH_GT_GT] = ACTIONS(7510),
    [anon_sym_PIPE] = ACTIONS(7512),
    [anon_sym_AMP] = ACTIONS(7512),
    [anon_sym_PIPE_PIPE] = ACTIONS(7510),
    [anon_sym_AMP_AMP] = ACTIONS(7510),
    [anon_sym_LT] = ACTIONS(7512),
    [anon_sym_LT_EQ] = ACTIONS(7510),
    [anon_sym_GT] = ACTIONS(7512),
    [anon_sym_GT_EQ] = ACTIONS(7510),
    [anon_sym_EQ_EQ] = ACTIONS(7510),
    [anon_sym_BANG_EQ] = ACTIONS(7510),
    [anon_sym_STAR] = ACTIONS(7512),
    [anon_sym_SLASH] = ACTIONS(7510),
    [anon_sym_STAR_STAR] = ACTIONS(7510),
    [anon_sym_CARET] = ACTIONS(7510),
    [aux_sym_binary_operator_token1] = ACTIONS(7510),
    [anon_sym_PIPE_GT] = ACTIONS(7510),
    [anon_sym_COLON] = ACTIONS(7512),
    [anon_sym_DOLLAR] = ACTIONS(7510),
    [anon_sym_AT] = ACTIONS(7510),
    [aux_sym__hex_literal_token1] = ACTIONS(7510),
    [sym__number_literal] = ACTIONS(7512),
    [anon_sym_SQUOTE] = ACTIONS(7510),
    [anon_sym_DQUOTE] = ACTIONS(7510),
    [sym_return] = ACTIONS(7512),
    [sym_next] = ACTIONS(7512),
    [sym_break] = ACTIONS(7512),
    [sym_true] = ACTIONS(7512),
    [sym_false] = ACTIONS(7512),
    [sym_null] = ACTIONS(7512),
    [sym_inf] = ACTIONS(7512),
    [sym_nan] = ACTIONS(7512),
    [anon_sym_NA] = ACTIONS(7512),
    [anon_sym_NA_integer_] = ACTIONS(7512),
    [anon_sym_NA_real_] = ACTIONS(7512),
    [anon_sym_NA_complex_] = ACTIONS(7512),
    [anon_sym_NA_character_] = ACTIONS(7512),
    [sym_dots] = ACTIONS(7512),
    [sym_dot_dot_i] = ACTIONS(7510),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7510),
    [sym__newline] = ACTIONS(7510),
    [sym__semicolon] = ACTIONS(7510),
    [sym__raw_string_literal] = ACTIONS(7510),
    [sym__external_open_parenthesis] = ACTIONS(7510),
    [sym__external_close_parenthesis] = ACTIONS(7510),
    [sym__external_open_brace] = ACTIONS(7510),
    [sym__external_close_brace] = ACTIONS(7510),
    [sym__external_open_bracket] = ACTIONS(7510),
    [sym__external_open_bracket2] = ACTIONS(7510),
    [sym__external_close_bracket2] = ACTIONS(7510),
  },
  [2538] = {
    [ts_builtin_sym_end] = ACTIONS(7117),
    [sym_identifier] = ACTIONS(7115),
    [anon_sym_BSLASH] = ACTIONS(7117),
    [anon_sym_function] = ACTIONS(7115),
    [anon_sym_EQ] = ACTIONS(7115),
    [anon_sym_if] = ACTIONS(7115),
    [anon_sym_for] = ACTIONS(7115),
    [anon_sym_while] = ACTIONS(7115),
    [anon_sym_repeat] = ACTIONS(7115),
    [anon_sym_QMARK] = ACTIONS(7117),
    [anon_sym_TILDE] = ACTIONS(7117),
    [anon_sym_BANG] = ACTIONS(7115),
    [anon_sym_PLUS] = ACTIONS(7117),
    [anon_sym_DASH] = ACTIONS(7115),
    [anon_sym_LT_DASH] = ACTIONS(7117),
    [anon_sym_LT_LT_DASH] = ACTIONS(7117),
    [anon_sym_COLON_EQ] = ACTIONS(7117),
    [anon_sym_DASH_GT] = ACTIONS(7115),
    [anon_sym_DASH_GT_GT] = ACTIONS(7117),
    [anon_sym_PIPE] = ACTIONS(7115),
    [anon_sym_AMP] = ACTIONS(7115),
    [anon_sym_PIPE_PIPE] = ACTIONS(7117),
    [anon_sym_AMP_AMP] = ACTIONS(7117),
    [anon_sym_LT] = ACTIONS(7115),
    [anon_sym_LT_EQ] = ACTIONS(7117),
    [anon_sym_GT] = ACTIONS(7115),
    [anon_sym_GT_EQ] = ACTIONS(7117),
    [anon_sym_EQ_EQ] = ACTIONS(7117),
    [anon_sym_BANG_EQ] = ACTIONS(7117),
    [anon_sym_STAR] = ACTIONS(7115),
    [anon_sym_SLASH] = ACTIONS(7117),
    [anon_sym_STAR_STAR] = ACTIONS(7117),
    [anon_sym_CARET] = ACTIONS(7117),
    [aux_sym_binary_operator_token1] = ACTIONS(7117),
    [anon_sym_PIPE_GT] = ACTIONS(7117),
    [anon_sym_COLON] = ACTIONS(7115),
    [anon_sym_DOLLAR] = ACTIONS(7117),
    [anon_sym_AT] = ACTIONS(7117),
    [anon_sym_COLON_COLON] = ACTIONS(7115),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7117),
    [aux_sym__hex_literal_token1] = ACTIONS(7117),
    [sym__number_literal] = ACTIONS(7115),
    [anon_sym_SQUOTE] = ACTIONS(7117),
    [anon_sym_DQUOTE] = ACTIONS(7117),
    [sym_return] = ACTIONS(7115),
    [sym_next] = ACTIONS(7115),
    [sym_break] = ACTIONS(7115),
    [sym_true] = ACTIONS(7115),
    [sym_false] = ACTIONS(7115),
    [sym_null] = ACTIONS(7115),
    [sym_inf] = ACTIONS(7115),
    [sym_nan] = ACTIONS(7115),
    [anon_sym_NA] = ACTIONS(7115),
    [anon_sym_NA_integer_] = ACTIONS(7115),
    [anon_sym_NA_real_] = ACTIONS(7115),
    [anon_sym_NA_complex_] = ACTIONS(7115),
    [anon_sym_NA_character_] = ACTIONS(7115),
    [sym_dots] = ACTIONS(7115),
    [sym_dot_dot_i] = ACTIONS(7117),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7117),
    [sym__semicolon] = ACTIONS(7117),
    [sym__raw_string_literal] = ACTIONS(7117),
    [sym__external_else] = ACTIONS(7117),
    [sym__external_open_parenthesis] = ACTIONS(7117),
    [sym__external_open_brace] = ACTIONS(7117),
    [sym__external_open_bracket] = ACTIONS(7117),
    [sym__external_open_bracket2] = ACTIONS(7117),
  },
  [2539] = {
    [ts_builtin_sym_end] = ACTIONS(7117),
    [sym_identifier] = ACTIONS(7115),
    [anon_sym_BSLASH] = ACTIONS(7117),
    [anon_sym_function] = ACTIONS(7115),
    [anon_sym_EQ] = ACTIONS(7115),
    [anon_sym_if] = ACTIONS(7115),
    [anon_sym_for] = ACTIONS(7115),
    [anon_sym_while] = ACTIONS(7115),
    [anon_sym_repeat] = ACTIONS(7115),
    [anon_sym_QMARK] = ACTIONS(7117),
    [anon_sym_TILDE] = ACTIONS(7117),
    [anon_sym_BANG] = ACTIONS(7115),
    [anon_sym_PLUS] = ACTIONS(7117),
    [anon_sym_DASH] = ACTIONS(7115),
    [anon_sym_LT_DASH] = ACTIONS(7117),
    [anon_sym_LT_LT_DASH] = ACTIONS(7117),
    [anon_sym_COLON_EQ] = ACTIONS(7117),
    [anon_sym_DASH_GT] = ACTIONS(7115),
    [anon_sym_DASH_GT_GT] = ACTIONS(7117),
    [anon_sym_PIPE] = ACTIONS(7115),
    [anon_sym_AMP] = ACTIONS(7115),
    [anon_sym_PIPE_PIPE] = ACTIONS(7117),
    [anon_sym_AMP_AMP] = ACTIONS(7117),
    [anon_sym_LT] = ACTIONS(7115),
    [anon_sym_LT_EQ] = ACTIONS(7117),
    [anon_sym_GT] = ACTIONS(7115),
    [anon_sym_GT_EQ] = ACTIONS(7117),
    [anon_sym_EQ_EQ] = ACTIONS(7117),
    [anon_sym_BANG_EQ] = ACTIONS(7117),
    [anon_sym_STAR] = ACTIONS(7115),
    [anon_sym_SLASH] = ACTIONS(7117),
    [anon_sym_STAR_STAR] = ACTIONS(7117),
    [anon_sym_CARET] = ACTIONS(7117),
    [aux_sym_binary_operator_token1] = ACTIONS(7117),
    [anon_sym_PIPE_GT] = ACTIONS(7117),
    [anon_sym_COLON] = ACTIONS(7115),
    [anon_sym_DOLLAR] = ACTIONS(7117),
    [anon_sym_AT] = ACTIONS(7117),
    [anon_sym_COLON_COLON] = ACTIONS(7115),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7117),
    [aux_sym__hex_literal_token1] = ACTIONS(7117),
    [sym__number_literal] = ACTIONS(7115),
    [anon_sym_SQUOTE] = ACTIONS(7117),
    [anon_sym_DQUOTE] = ACTIONS(7117),
    [sym_return] = ACTIONS(7115),
    [sym_next] = ACTIONS(7115),
    [sym_break] = ACTIONS(7115),
    [sym_true] = ACTIONS(7115),
    [sym_false] = ACTIONS(7115),
    [sym_null] = ACTIONS(7115),
    [sym_inf] = ACTIONS(7115),
    [sym_nan] = ACTIONS(7115),
    [anon_sym_NA] = ACTIONS(7115),
    [anon_sym_NA_integer_] = ACTIONS(7115),
    [anon_sym_NA_real_] = ACTIONS(7115),
    [anon_sym_NA_complex_] = ACTIONS(7115),
    [anon_sym_NA_character_] = ACTIONS(7115),
    [sym_dots] = ACTIONS(7115),
    [sym_dot_dot_i] = ACTIONS(7117),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7117),
    [sym__semicolon] = ACTIONS(7117),
    [sym__raw_string_literal] = ACTIONS(7117),
    [sym__external_else] = ACTIONS(7117),
    [sym__external_open_parenthesis] = ACTIONS(7117),
    [sym__external_open_brace] = ACTIONS(7117),
    [sym__external_open_bracket] = ACTIONS(7117),
    [sym__external_open_bracket2] = ACTIONS(7117),
  },
  [2540] = {
    [ts_builtin_sym_end] = ACTIONS(7123),
    [sym_identifier] = ACTIONS(7121),
    [anon_sym_BSLASH] = ACTIONS(7123),
    [anon_sym_function] = ACTIONS(7121),
    [anon_sym_EQ] = ACTIONS(7121),
    [anon_sym_if] = ACTIONS(7121),
    [anon_sym_for] = ACTIONS(7121),
    [anon_sym_while] = ACTIONS(7121),
    [anon_sym_repeat] = ACTIONS(7121),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_TILDE] = ACTIONS(7123),
    [anon_sym_BANG] = ACTIONS(7121),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_DASH] = ACTIONS(7121),
    [anon_sym_LT_DASH] = ACTIONS(7123),
    [anon_sym_LT_LT_DASH] = ACTIONS(7123),
    [anon_sym_COLON_EQ] = ACTIONS(7123),
    [anon_sym_DASH_GT] = ACTIONS(7121),
    [anon_sym_DASH_GT_GT] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_LT_EQ] = ACTIONS(7123),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
    [aux_sym_binary_operator_token1] = ACTIONS(7123),
    [anon_sym_PIPE_GT] = ACTIONS(7123),
    [anon_sym_COLON] = ACTIONS(7121),
    [anon_sym_DOLLAR] = ACTIONS(7123),
    [anon_sym_AT] = ACTIONS(7123),
    [anon_sym_L] = ACTIONS(7645),
    [anon_sym_i] = ACTIONS(7647),
    [aux_sym__hex_literal_token1] = ACTIONS(7123),
    [sym__number_literal] = ACTIONS(7121),
    [anon_sym_SQUOTE] = ACTIONS(7123),
    [anon_sym_DQUOTE] = ACTIONS(7123),
    [sym_return] = ACTIONS(7121),
    [sym_next] = ACTIONS(7121),
    [sym_break] = ACTIONS(7121),
    [sym_true] = ACTIONS(7121),
    [sym_false] = ACTIONS(7121),
    [sym_null] = ACTIONS(7121),
    [sym_inf] = ACTIONS(7121),
    [sym_nan] = ACTIONS(7121),
    [anon_sym_NA] = ACTIONS(7121),
    [anon_sym_NA_integer_] = ACTIONS(7121),
    [anon_sym_NA_real_] = ACTIONS(7121),
    [anon_sym_NA_complex_] = ACTIONS(7121),
    [anon_sym_NA_character_] = ACTIONS(7121),
    [sym_dots] = ACTIONS(7121),
    [sym_dot_dot_i] = ACTIONS(7123),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7123),
    [sym__semicolon] = ACTIONS(7123),
    [sym__raw_string_literal] = ACTIONS(7123),
    [sym__external_open_parenthesis] = ACTIONS(7123),
    [sym__external_close_parenthesis] = ACTIONS(7123),
    [sym__external_open_brace] = ACTIONS(7123),
    [sym__external_open_bracket] = ACTIONS(7123),
    [sym__external_open_bracket2] = ACTIONS(7123),
  },
  [2541] = {
    [ts_builtin_sym_end] = ACTIONS(7131),
    [sym_identifier] = ACTIONS(7129),
    [anon_sym_BSLASH] = ACTIONS(7131),
    [anon_sym_function] = ACTIONS(7129),
    [anon_sym_EQ] = ACTIONS(7129),
    [anon_sym_if] = ACTIONS(7129),
    [anon_sym_for] = ACTIONS(7129),
    [anon_sym_while] = ACTIONS(7129),
    [anon_sym_repeat] = ACTIONS(7129),
    [anon_sym_QMARK] = ACTIONS(7131),
    [anon_sym_TILDE] = ACTIONS(7131),
    [anon_sym_BANG] = ACTIONS(7129),
    [anon_sym_PLUS] = ACTIONS(7131),
    [anon_sym_DASH] = ACTIONS(7129),
    [anon_sym_LT_DASH] = ACTIONS(7131),
    [anon_sym_LT_LT_DASH] = ACTIONS(7131),
    [anon_sym_COLON_EQ] = ACTIONS(7131),
    [anon_sym_DASH_GT] = ACTIONS(7129),
    [anon_sym_DASH_GT_GT] = ACTIONS(7131),
    [anon_sym_PIPE] = ACTIONS(7129),
    [anon_sym_AMP] = ACTIONS(7129),
    [anon_sym_PIPE_PIPE] = ACTIONS(7131),
    [anon_sym_AMP_AMP] = ACTIONS(7131),
    [anon_sym_LT] = ACTIONS(7129),
    [anon_sym_LT_EQ] = ACTIONS(7131),
    [anon_sym_GT] = ACTIONS(7129),
    [anon_sym_GT_EQ] = ACTIONS(7131),
    [anon_sym_EQ_EQ] = ACTIONS(7131),
    [anon_sym_BANG_EQ] = ACTIONS(7131),
    [anon_sym_STAR] = ACTIONS(7129),
    [anon_sym_SLASH] = ACTIONS(7131),
    [anon_sym_STAR_STAR] = ACTIONS(7131),
    [anon_sym_CARET] = ACTIONS(7131),
    [aux_sym_binary_operator_token1] = ACTIONS(7131),
    [anon_sym_PIPE_GT] = ACTIONS(7131),
    [anon_sym_COLON] = ACTIONS(7129),
    [anon_sym_DOLLAR] = ACTIONS(7131),
    [anon_sym_AT] = ACTIONS(7131),
    [anon_sym_COLON_COLON] = ACTIONS(7133),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7135),
    [aux_sym__hex_literal_token1] = ACTIONS(7131),
    [sym__number_literal] = ACTIONS(7129),
    [anon_sym_SQUOTE] = ACTIONS(7131),
    [anon_sym_DQUOTE] = ACTIONS(7131),
    [sym_return] = ACTIONS(7129),
    [sym_next] = ACTIONS(7129),
    [sym_break] = ACTIONS(7129),
    [sym_true] = ACTIONS(7129),
    [sym_false] = ACTIONS(7129),
    [sym_null] = ACTIONS(7129),
    [sym_inf] = ACTIONS(7129),
    [sym_nan] = ACTIONS(7129),
    [anon_sym_NA] = ACTIONS(7129),
    [anon_sym_NA_integer_] = ACTIONS(7129),
    [anon_sym_NA_real_] = ACTIONS(7129),
    [anon_sym_NA_complex_] = ACTIONS(7129),
    [anon_sym_NA_character_] = ACTIONS(7129),
    [sym_dots] = ACTIONS(7129),
    [sym_dot_dot_i] = ACTIONS(7131),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7131),
    [sym__semicolon] = ACTIONS(7131),
    [sym__raw_string_literal] = ACTIONS(7131),
    [sym__external_open_parenthesis] = ACTIONS(7131),
    [sym__external_close_parenthesis] = ACTIONS(7131),
    [sym__external_open_brace] = ACTIONS(7131),
    [sym__external_open_bracket] = ACTIONS(7131),
    [sym__external_open_bracket2] = ACTIONS(7131),
  },
  [2542] = {
    [ts_builtin_sym_end] = ACTIONS(7554),
    [sym_identifier] = ACTIONS(7556),
    [anon_sym_BSLASH] = ACTIONS(7554),
    [anon_sym_function] = ACTIONS(7556),
    [anon_sym_EQ] = ACTIONS(7556),
    [anon_sym_if] = ACTIONS(7556),
    [anon_sym_for] = ACTIONS(7556),
    [anon_sym_while] = ACTIONS(7556),
    [anon_sym_repeat] = ACTIONS(7556),
    [anon_sym_QMARK] = ACTIONS(7554),
    [anon_sym_TILDE] = ACTIONS(7554),
    [anon_sym_BANG] = ACTIONS(7556),
    [anon_sym_PLUS] = ACTIONS(7554),
    [anon_sym_DASH] = ACTIONS(7556),
    [anon_sym_LT_DASH] = ACTIONS(7554),
    [anon_sym_LT_LT_DASH] = ACTIONS(7554),
    [anon_sym_COLON_EQ] = ACTIONS(7554),
    [anon_sym_DASH_GT] = ACTIONS(7556),
    [anon_sym_DASH_GT_GT] = ACTIONS(7554),
    [anon_sym_PIPE] = ACTIONS(7556),
    [anon_sym_AMP] = ACTIONS(7556),
    [anon_sym_PIPE_PIPE] = ACTIONS(7554),
    [anon_sym_AMP_AMP] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(7556),
    [anon_sym_LT_EQ] = ACTIONS(7554),
    [anon_sym_GT] = ACTIONS(7556),
    [anon_sym_GT_EQ] = ACTIONS(7554),
    [anon_sym_EQ_EQ] = ACTIONS(7554),
    [anon_sym_BANG_EQ] = ACTIONS(7554),
    [anon_sym_STAR] = ACTIONS(7556),
    [anon_sym_SLASH] = ACTIONS(7554),
    [anon_sym_STAR_STAR] = ACTIONS(7554),
    [anon_sym_CARET] = ACTIONS(7554),
    [aux_sym_binary_operator_token1] = ACTIONS(7554),
    [anon_sym_PIPE_GT] = ACTIONS(7554),
    [anon_sym_COLON] = ACTIONS(7556),
    [anon_sym_DOLLAR] = ACTIONS(7554),
    [anon_sym_AT] = ACTIONS(7554),
    [aux_sym__hex_literal_token1] = ACTIONS(7554),
    [sym__number_literal] = ACTIONS(7556),
    [anon_sym_SQUOTE] = ACTIONS(7554),
    [anon_sym_DQUOTE] = ACTIONS(7554),
    [sym_return] = ACTIONS(7556),
    [sym_next] = ACTIONS(7556),
    [sym_break] = ACTIONS(7556),
    [sym_true] = ACTIONS(7556),
    [sym_false] = ACTIONS(7556),
    [sym_null] = ACTIONS(7556),
    [sym_inf] = ACTIONS(7556),
    [sym_nan] = ACTIONS(7556),
    [anon_sym_NA] = ACTIONS(7556),
    [anon_sym_NA_integer_] = ACTIONS(7556),
    [anon_sym_NA_real_] = ACTIONS(7556),
    [anon_sym_NA_complex_] = ACTIONS(7556),
    [anon_sym_NA_character_] = ACTIONS(7556),
    [sym_dots] = ACTIONS(7556),
    [sym_dot_dot_i] = ACTIONS(7554),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7554),
    [sym__newline] = ACTIONS(7554),
    [sym__semicolon] = ACTIONS(7554),
    [sym__raw_string_literal] = ACTIONS(7554),
    [sym__external_open_parenthesis] = ACTIONS(7554),
    [sym__external_close_parenthesis] = ACTIONS(7554),
    [sym__external_open_brace] = ACTIONS(7554),
    [sym__external_close_brace] = ACTIONS(7554),
    [sym__external_open_bracket] = ACTIONS(7554),
    [sym__external_open_bracket2] = ACTIONS(7554),
  },
  [2543] = {
    [ts_builtin_sym_end] = ACTIONS(7139),
    [sym_identifier] = ACTIONS(7137),
    [anon_sym_BSLASH] = ACTIONS(7139),
    [anon_sym_function] = ACTIONS(7137),
    [anon_sym_EQ] = ACTIONS(7137),
    [anon_sym_if] = ACTIONS(7137),
    [anon_sym_for] = ACTIONS(7137),
    [anon_sym_while] = ACTIONS(7137),
    [anon_sym_repeat] = ACTIONS(7137),
    [anon_sym_QMARK] = ACTIONS(7139),
    [anon_sym_TILDE] = ACTIONS(7139),
    [anon_sym_BANG] = ACTIONS(7137),
    [anon_sym_PLUS] = ACTIONS(7139),
    [anon_sym_DASH] = ACTIONS(7137),
    [anon_sym_LT_DASH] = ACTIONS(7139),
    [anon_sym_LT_LT_DASH] = ACTIONS(7139),
    [anon_sym_COLON_EQ] = ACTIONS(7139),
    [anon_sym_DASH_GT] = ACTIONS(7137),
    [anon_sym_DASH_GT_GT] = ACTIONS(7139),
    [anon_sym_PIPE] = ACTIONS(7137),
    [anon_sym_AMP] = ACTIONS(7137),
    [anon_sym_PIPE_PIPE] = ACTIONS(7139),
    [anon_sym_AMP_AMP] = ACTIONS(7139),
    [anon_sym_LT] = ACTIONS(7137),
    [anon_sym_LT_EQ] = ACTIONS(7139),
    [anon_sym_GT] = ACTIONS(7137),
    [anon_sym_GT_EQ] = ACTIONS(7139),
    [anon_sym_EQ_EQ] = ACTIONS(7139),
    [anon_sym_BANG_EQ] = ACTIONS(7139),
    [anon_sym_STAR] = ACTIONS(7137),
    [anon_sym_SLASH] = ACTIONS(7139),
    [anon_sym_STAR_STAR] = ACTIONS(7139),
    [anon_sym_CARET] = ACTIONS(7139),
    [aux_sym_binary_operator_token1] = ACTIONS(7139),
    [anon_sym_PIPE_GT] = ACTIONS(7139),
    [anon_sym_COLON] = ACTIONS(7137),
    [anon_sym_DOLLAR] = ACTIONS(7139),
    [anon_sym_AT] = ACTIONS(7139),
    [anon_sym_COLON_COLON] = ACTIONS(7137),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7139),
    [aux_sym__hex_literal_token1] = ACTIONS(7139),
    [sym__number_literal] = ACTIONS(7137),
    [anon_sym_SQUOTE] = ACTIONS(7139),
    [anon_sym_DQUOTE] = ACTIONS(7139),
    [sym_return] = ACTIONS(7137),
    [sym_next] = ACTIONS(7137),
    [sym_break] = ACTIONS(7137),
    [sym_true] = ACTIONS(7137),
    [sym_false] = ACTIONS(7137),
    [sym_null] = ACTIONS(7137),
    [sym_inf] = ACTIONS(7137),
    [sym_nan] = ACTIONS(7137),
    [anon_sym_NA] = ACTIONS(7137),
    [anon_sym_NA_integer_] = ACTIONS(7137),
    [anon_sym_NA_real_] = ACTIONS(7137),
    [anon_sym_NA_complex_] = ACTIONS(7137),
    [anon_sym_NA_character_] = ACTIONS(7137),
    [sym_dots] = ACTIONS(7137),
    [sym_dot_dot_i] = ACTIONS(7139),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7139),
    [sym__semicolon] = ACTIONS(7139),
    [sym__raw_string_literal] = ACTIONS(7139),
    [sym__external_open_parenthesis] = ACTIONS(7139),
    [sym__external_close_parenthesis] = ACTIONS(7139),
    [sym__external_open_brace] = ACTIONS(7139),
    [sym__external_open_bracket] = ACTIONS(7139),
    [sym__external_open_bracket2] = ACTIONS(7139),
  },
  [2544] = {
    [ts_builtin_sym_end] = ACTIONS(7153),
    [sym_identifier] = ACTIONS(7151),
    [anon_sym_BSLASH] = ACTIONS(7153),
    [anon_sym_function] = ACTIONS(7151),
    [anon_sym_EQ] = ACTIONS(7151),
    [anon_sym_if] = ACTIONS(7151),
    [anon_sym_for] = ACTIONS(7151),
    [anon_sym_while] = ACTIONS(7151),
    [anon_sym_repeat] = ACTIONS(7151),
    [anon_sym_QMARK] = ACTIONS(7153),
    [anon_sym_TILDE] = ACTIONS(7153),
    [anon_sym_BANG] = ACTIONS(7151),
    [anon_sym_PLUS] = ACTIONS(7153),
    [anon_sym_DASH] = ACTIONS(7151),
    [anon_sym_LT_DASH] = ACTIONS(7153),
    [anon_sym_LT_LT_DASH] = ACTIONS(7153),
    [anon_sym_COLON_EQ] = ACTIONS(7153),
    [anon_sym_DASH_GT] = ACTIONS(7151),
    [anon_sym_DASH_GT_GT] = ACTIONS(7153),
    [anon_sym_PIPE] = ACTIONS(7151),
    [anon_sym_AMP] = ACTIONS(7151),
    [anon_sym_PIPE_PIPE] = ACTIONS(7153),
    [anon_sym_AMP_AMP] = ACTIONS(7153),
    [anon_sym_LT] = ACTIONS(7151),
    [anon_sym_LT_EQ] = ACTIONS(7153),
    [anon_sym_GT] = ACTIONS(7151),
    [anon_sym_GT_EQ] = ACTIONS(7153),
    [anon_sym_EQ_EQ] = ACTIONS(7153),
    [anon_sym_BANG_EQ] = ACTIONS(7153),
    [anon_sym_STAR] = ACTIONS(7151),
    [anon_sym_SLASH] = ACTIONS(7153),
    [anon_sym_STAR_STAR] = ACTIONS(7153),
    [anon_sym_CARET] = ACTIONS(7153),
    [aux_sym_binary_operator_token1] = ACTIONS(7153),
    [anon_sym_PIPE_GT] = ACTIONS(7153),
    [anon_sym_COLON] = ACTIONS(7151),
    [anon_sym_DOLLAR] = ACTIONS(7153),
    [anon_sym_AT] = ACTIONS(7153),
    [anon_sym_COLON_COLON] = ACTIONS(7151),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7153),
    [aux_sym__hex_literal_token1] = ACTIONS(7153),
    [sym__number_literal] = ACTIONS(7151),
    [anon_sym_SQUOTE] = ACTIONS(7153),
    [anon_sym_DQUOTE] = ACTIONS(7153),
    [sym_return] = ACTIONS(7151),
    [sym_next] = ACTIONS(7151),
    [sym_break] = ACTIONS(7151),
    [sym_true] = ACTIONS(7151),
    [sym_false] = ACTIONS(7151),
    [sym_null] = ACTIONS(7151),
    [sym_inf] = ACTIONS(7151),
    [sym_nan] = ACTIONS(7151),
    [anon_sym_NA] = ACTIONS(7151),
    [anon_sym_NA_integer_] = ACTIONS(7151),
    [anon_sym_NA_real_] = ACTIONS(7151),
    [anon_sym_NA_complex_] = ACTIONS(7151),
    [anon_sym_NA_character_] = ACTIONS(7151),
    [sym_dots] = ACTIONS(7151),
    [sym_dot_dot_i] = ACTIONS(7153),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7153),
    [sym__semicolon] = ACTIONS(7153),
    [sym__raw_string_literal] = ACTIONS(7153),
    [sym__external_else] = ACTIONS(7153),
    [sym__external_open_parenthesis] = ACTIONS(7153),
    [sym__external_open_brace] = ACTIONS(7153),
    [sym__external_open_bracket] = ACTIONS(7153),
    [sym__external_open_bracket2] = ACTIONS(7153),
  },
  [2545] = {
    [sym_identifier] = ACTIONS(7552),
    [anon_sym_BSLASH] = ACTIONS(7550),
    [anon_sym_function] = ACTIONS(7552),
    [anon_sym_EQ] = ACTIONS(7552),
    [anon_sym_if] = ACTIONS(7552),
    [anon_sym_for] = ACTIONS(7552),
    [anon_sym_while] = ACTIONS(7552),
    [anon_sym_repeat] = ACTIONS(7552),
    [anon_sym_QMARK] = ACTIONS(7550),
    [anon_sym_TILDE] = ACTIONS(7550),
    [anon_sym_BANG] = ACTIONS(7552),
    [anon_sym_PLUS] = ACTIONS(7550),
    [anon_sym_DASH] = ACTIONS(7552),
    [anon_sym_LT_DASH] = ACTIONS(7550),
    [anon_sym_LT_LT_DASH] = ACTIONS(7550),
    [anon_sym_COLON_EQ] = ACTIONS(7550),
    [anon_sym_DASH_GT] = ACTIONS(7552),
    [anon_sym_DASH_GT_GT] = ACTIONS(7550),
    [anon_sym_PIPE] = ACTIONS(7552),
    [anon_sym_AMP] = ACTIONS(7552),
    [anon_sym_PIPE_PIPE] = ACTIONS(7550),
    [anon_sym_AMP_AMP] = ACTIONS(7550),
    [anon_sym_LT] = ACTIONS(7552),
    [anon_sym_LT_EQ] = ACTIONS(7550),
    [anon_sym_GT] = ACTIONS(7552),
    [anon_sym_GT_EQ] = ACTIONS(7550),
    [anon_sym_EQ_EQ] = ACTIONS(7550),
    [anon_sym_BANG_EQ] = ACTIONS(7550),
    [anon_sym_STAR] = ACTIONS(7552),
    [anon_sym_SLASH] = ACTIONS(7550),
    [anon_sym_STAR_STAR] = ACTIONS(7550),
    [anon_sym_CARET] = ACTIONS(7550),
    [aux_sym_binary_operator_token1] = ACTIONS(7550),
    [anon_sym_PIPE_GT] = ACTIONS(7550),
    [anon_sym_COLON] = ACTIONS(7552),
    [anon_sym_DOLLAR] = ACTIONS(7550),
    [anon_sym_AT] = ACTIONS(7550),
    [aux_sym__hex_literal_token1] = ACTIONS(7550),
    [sym__number_literal] = ACTIONS(7552),
    [anon_sym_SQUOTE] = ACTIONS(7550),
    [anon_sym_DQUOTE] = ACTIONS(7550),
    [sym_return] = ACTIONS(7552),
    [sym_next] = ACTIONS(7552),
    [sym_break] = ACTIONS(7552),
    [sym_true] = ACTIONS(7552),
    [sym_false] = ACTIONS(7552),
    [sym_null] = ACTIONS(7552),
    [sym_inf] = ACTIONS(7552),
    [sym_nan] = ACTIONS(7552),
    [anon_sym_NA] = ACTIONS(7552),
    [anon_sym_NA_integer_] = ACTIONS(7552),
    [anon_sym_NA_real_] = ACTIONS(7552),
    [anon_sym_NA_complex_] = ACTIONS(7552),
    [anon_sym_NA_character_] = ACTIONS(7552),
    [sym_dots] = ACTIONS(7552),
    [sym_dot_dot_i] = ACTIONS(7550),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7550),
    [sym__newline] = ACTIONS(7550),
    [sym__semicolon] = ACTIONS(7550),
    [sym__raw_string_literal] = ACTIONS(7550),
    [sym__external_else] = ACTIONS(7550),
    [sym__external_open_parenthesis] = ACTIONS(7550),
    [sym__external_open_brace] = ACTIONS(7550),
    [sym__external_close_brace] = ACTIONS(7550),
    [sym__external_open_bracket] = ACTIONS(7550),
    [sym__external_open_bracket2] = ACTIONS(7550),
    [sym__external_close_bracket2] = ACTIONS(7550),
  },
  [2546] = {
    [ts_builtin_sym_end] = ACTIONS(7165),
    [sym_identifier] = ACTIONS(7163),
    [anon_sym_BSLASH] = ACTIONS(7165),
    [anon_sym_function] = ACTIONS(7163),
    [anon_sym_EQ] = ACTIONS(7163),
    [anon_sym_if] = ACTIONS(7163),
    [anon_sym_for] = ACTIONS(7163),
    [anon_sym_while] = ACTIONS(7163),
    [anon_sym_repeat] = ACTIONS(7163),
    [anon_sym_QMARK] = ACTIONS(7165),
    [anon_sym_TILDE] = ACTIONS(7165),
    [anon_sym_BANG] = ACTIONS(7163),
    [anon_sym_PLUS] = ACTIONS(7165),
    [anon_sym_DASH] = ACTIONS(7163),
    [anon_sym_LT_DASH] = ACTIONS(7165),
    [anon_sym_LT_LT_DASH] = ACTIONS(7165),
    [anon_sym_COLON_EQ] = ACTIONS(7165),
    [anon_sym_DASH_GT] = ACTIONS(7163),
    [anon_sym_DASH_GT_GT] = ACTIONS(7165),
    [anon_sym_PIPE] = ACTIONS(7163),
    [anon_sym_AMP] = ACTIONS(7163),
    [anon_sym_PIPE_PIPE] = ACTIONS(7165),
    [anon_sym_AMP_AMP] = ACTIONS(7165),
    [anon_sym_LT] = ACTIONS(7163),
    [anon_sym_LT_EQ] = ACTIONS(7165),
    [anon_sym_GT] = ACTIONS(7163),
    [anon_sym_GT_EQ] = ACTIONS(7165),
    [anon_sym_EQ_EQ] = ACTIONS(7165),
    [anon_sym_BANG_EQ] = ACTIONS(7165),
    [anon_sym_STAR] = ACTIONS(7163),
    [anon_sym_SLASH] = ACTIONS(7165),
    [anon_sym_STAR_STAR] = ACTIONS(7165),
    [anon_sym_CARET] = ACTIONS(7165),
    [aux_sym_binary_operator_token1] = ACTIONS(7165),
    [anon_sym_PIPE_GT] = ACTIONS(7165),
    [anon_sym_COLON] = ACTIONS(7163),
    [anon_sym_DOLLAR] = ACTIONS(7165),
    [anon_sym_AT] = ACTIONS(7165),
    [anon_sym_COLON_COLON] = ACTIONS(7163),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7165),
    [aux_sym__hex_literal_token1] = ACTIONS(7165),
    [sym__number_literal] = ACTIONS(7163),
    [anon_sym_SQUOTE] = ACTIONS(7165),
    [anon_sym_DQUOTE] = ACTIONS(7165),
    [sym_return] = ACTIONS(7163),
    [sym_next] = ACTIONS(7163),
    [sym_break] = ACTIONS(7163),
    [sym_true] = ACTIONS(7163),
    [sym_false] = ACTIONS(7163),
    [sym_null] = ACTIONS(7163),
    [sym_inf] = ACTIONS(7163),
    [sym_nan] = ACTIONS(7163),
    [anon_sym_NA] = ACTIONS(7163),
    [anon_sym_NA_integer_] = ACTIONS(7163),
    [anon_sym_NA_real_] = ACTIONS(7163),
    [anon_sym_NA_complex_] = ACTIONS(7163),
    [anon_sym_NA_character_] = ACTIONS(7163),
    [sym_dots] = ACTIONS(7163),
    [sym_dot_dot_i] = ACTIONS(7165),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7165),
    [sym__semicolon] = ACTIONS(7165),
    [sym__raw_string_literal] = ACTIONS(7165),
    [sym__external_else] = ACTIONS(7165),
    [sym__external_open_parenthesis] = ACTIONS(7165),
    [sym__external_open_brace] = ACTIONS(7165),
    [sym__external_open_bracket] = ACTIONS(7165),
    [sym__external_open_bracket2] = ACTIONS(7165),
  },
  [2547] = {
    [ts_builtin_sym_end] = ACTIONS(7561),
    [sym_identifier] = ACTIONS(7563),
    [anon_sym_BSLASH] = ACTIONS(7561),
    [anon_sym_function] = ACTIONS(7563),
    [anon_sym_EQ] = ACTIONS(7563),
    [anon_sym_if] = ACTIONS(7563),
    [anon_sym_for] = ACTIONS(7563),
    [anon_sym_while] = ACTIONS(7563),
    [anon_sym_repeat] = ACTIONS(7563),
    [anon_sym_QMARK] = ACTIONS(7561),
    [anon_sym_TILDE] = ACTIONS(7561),
    [anon_sym_BANG] = ACTIONS(7563),
    [anon_sym_PLUS] = ACTIONS(7561),
    [anon_sym_DASH] = ACTIONS(7563),
    [anon_sym_LT_DASH] = ACTIONS(7561),
    [anon_sym_LT_LT_DASH] = ACTIONS(7561),
    [anon_sym_COLON_EQ] = ACTIONS(7561),
    [anon_sym_DASH_GT] = ACTIONS(7563),
    [anon_sym_DASH_GT_GT] = ACTIONS(7561),
    [anon_sym_PIPE] = ACTIONS(7563),
    [anon_sym_AMP] = ACTIONS(7563),
    [anon_sym_PIPE_PIPE] = ACTIONS(7561),
    [anon_sym_AMP_AMP] = ACTIONS(7561),
    [anon_sym_LT] = ACTIONS(7563),
    [anon_sym_LT_EQ] = ACTIONS(7561),
    [anon_sym_GT] = ACTIONS(7563),
    [anon_sym_GT_EQ] = ACTIONS(7561),
    [anon_sym_EQ_EQ] = ACTIONS(7561),
    [anon_sym_BANG_EQ] = ACTIONS(7561),
    [anon_sym_STAR] = ACTIONS(7563),
    [anon_sym_SLASH] = ACTIONS(7561),
    [anon_sym_STAR_STAR] = ACTIONS(7561),
    [anon_sym_CARET] = ACTIONS(7561),
    [aux_sym_binary_operator_token1] = ACTIONS(7561),
    [anon_sym_PIPE_GT] = ACTIONS(7561),
    [anon_sym_COLON] = ACTIONS(7563),
    [anon_sym_DOLLAR] = ACTIONS(7561),
    [anon_sym_AT] = ACTIONS(7561),
    [aux_sym__hex_literal_token1] = ACTIONS(7561),
    [sym__number_literal] = ACTIONS(7563),
    [anon_sym_SQUOTE] = ACTIONS(7561),
    [anon_sym_DQUOTE] = ACTIONS(7561),
    [sym_return] = ACTIONS(7563),
    [sym_next] = ACTIONS(7563),
    [sym_break] = ACTIONS(7563),
    [sym_true] = ACTIONS(7563),
    [sym_false] = ACTIONS(7563),
    [sym_null] = ACTIONS(7563),
    [sym_inf] = ACTIONS(7563),
    [sym_nan] = ACTIONS(7563),
    [anon_sym_NA] = ACTIONS(7563),
    [anon_sym_NA_integer_] = ACTIONS(7563),
    [anon_sym_NA_real_] = ACTIONS(7563),
    [anon_sym_NA_complex_] = ACTIONS(7563),
    [anon_sym_NA_character_] = ACTIONS(7563),
    [sym_dots] = ACTIONS(7563),
    [sym_dot_dot_i] = ACTIONS(7561),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7561),
    [sym__newline] = ACTIONS(7561),
    [sym__semicolon] = ACTIONS(7561),
    [sym__raw_string_literal] = ACTIONS(7561),
    [sym__external_open_parenthesis] = ACTIONS(7561),
    [sym__external_close_parenthesis] = ACTIONS(7561),
    [sym__external_open_brace] = ACTIONS(7561),
    [sym__external_close_brace] = ACTIONS(7561),
    [sym__external_open_bracket] = ACTIONS(7561),
    [sym__external_open_bracket2] = ACTIONS(7561),
  },
  [2548] = {
    [sym_identifier] = ACTIONS(7195),
    [anon_sym_BSLASH] = ACTIONS(7193),
    [anon_sym_function] = ACTIONS(7195),
    [anon_sym_EQ] = ACTIONS(7195),
    [anon_sym_if] = ACTIONS(7195),
    [anon_sym_for] = ACTIONS(7195),
    [anon_sym_while] = ACTIONS(7195),
    [anon_sym_repeat] = ACTIONS(7195),
    [anon_sym_QMARK] = ACTIONS(7193),
    [anon_sym_TILDE] = ACTIONS(7193),
    [anon_sym_BANG] = ACTIONS(7195),
    [anon_sym_PLUS] = ACTIONS(7193),
    [anon_sym_DASH] = ACTIONS(7195),
    [anon_sym_LT_DASH] = ACTIONS(7193),
    [anon_sym_LT_LT_DASH] = ACTIONS(7193),
    [anon_sym_COLON_EQ] = ACTIONS(7193),
    [anon_sym_DASH_GT] = ACTIONS(7195),
    [anon_sym_DASH_GT_GT] = ACTIONS(7193),
    [anon_sym_PIPE] = ACTIONS(7195),
    [anon_sym_AMP] = ACTIONS(7195),
    [anon_sym_PIPE_PIPE] = ACTIONS(7193),
    [anon_sym_AMP_AMP] = ACTIONS(7193),
    [anon_sym_LT] = ACTIONS(7195),
    [anon_sym_LT_EQ] = ACTIONS(7193),
    [anon_sym_GT] = ACTIONS(7195),
    [anon_sym_GT_EQ] = ACTIONS(7193),
    [anon_sym_EQ_EQ] = ACTIONS(7193),
    [anon_sym_BANG_EQ] = ACTIONS(7193),
    [anon_sym_STAR] = ACTIONS(7195),
    [anon_sym_SLASH] = ACTIONS(7193),
    [anon_sym_STAR_STAR] = ACTIONS(7193),
    [anon_sym_CARET] = ACTIONS(7193),
    [aux_sym_binary_operator_token1] = ACTIONS(7193),
    [anon_sym_PIPE_GT] = ACTIONS(7193),
    [anon_sym_COLON] = ACTIONS(7195),
    [anon_sym_DOLLAR] = ACTIONS(7193),
    [anon_sym_AT] = ACTIONS(7193),
    [anon_sym_COLON_COLON] = ACTIONS(7195),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7193),
    [aux_sym__hex_literal_token1] = ACTIONS(7193),
    [sym__number_literal] = ACTIONS(7195),
    [anon_sym_SQUOTE] = ACTIONS(7193),
    [anon_sym_DQUOTE] = ACTIONS(7193),
    [sym_return] = ACTIONS(7195),
    [sym_next] = ACTIONS(7195),
    [sym_break] = ACTIONS(7195),
    [sym_true] = ACTIONS(7195),
    [sym_false] = ACTIONS(7195),
    [sym_null] = ACTIONS(7195),
    [sym_inf] = ACTIONS(7195),
    [sym_nan] = ACTIONS(7195),
    [anon_sym_NA] = ACTIONS(7195),
    [anon_sym_NA_integer_] = ACTIONS(7195),
    [anon_sym_NA_real_] = ACTIONS(7195),
    [anon_sym_NA_complex_] = ACTIONS(7195),
    [anon_sym_NA_character_] = ACTIONS(7195),
    [sym_dots] = ACTIONS(7195),
    [sym_dot_dot_i] = ACTIONS(7193),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7193),
    [sym__newline] = ACTIONS(7193),
    [sym__raw_string_literal] = ACTIONS(7193),
    [sym__external_else] = ACTIONS(7193),
    [sym__external_open_parenthesis] = ACTIONS(7193),
    [sym__external_open_brace] = ACTIONS(7193),
    [sym__external_open_bracket] = ACTIONS(7193),
    [sym__external_close_bracket] = ACTIONS(7193),
    [sym__external_open_bracket2] = ACTIONS(7193),
  },
  [2549] = {
    [sym_identifier] = ACTIONS(7191),
    [anon_sym_BSLASH] = ACTIONS(7189),
    [anon_sym_function] = ACTIONS(7191),
    [anon_sym_EQ] = ACTIONS(7191),
    [anon_sym_if] = ACTIONS(7191),
    [anon_sym_for] = ACTIONS(7191),
    [anon_sym_while] = ACTIONS(7191),
    [anon_sym_repeat] = ACTIONS(7191),
    [anon_sym_QMARK] = ACTIONS(7189),
    [anon_sym_TILDE] = ACTIONS(7189),
    [anon_sym_BANG] = ACTIONS(7191),
    [anon_sym_PLUS] = ACTIONS(7189),
    [anon_sym_DASH] = ACTIONS(7191),
    [anon_sym_LT_DASH] = ACTIONS(7189),
    [anon_sym_LT_LT_DASH] = ACTIONS(7189),
    [anon_sym_COLON_EQ] = ACTIONS(7189),
    [anon_sym_DASH_GT] = ACTIONS(7191),
    [anon_sym_DASH_GT_GT] = ACTIONS(7189),
    [anon_sym_PIPE] = ACTIONS(7191),
    [anon_sym_AMP] = ACTIONS(7191),
    [anon_sym_PIPE_PIPE] = ACTIONS(7189),
    [anon_sym_AMP_AMP] = ACTIONS(7189),
    [anon_sym_LT] = ACTIONS(7191),
    [anon_sym_LT_EQ] = ACTIONS(7189),
    [anon_sym_GT] = ACTIONS(7191),
    [anon_sym_GT_EQ] = ACTIONS(7189),
    [anon_sym_EQ_EQ] = ACTIONS(7189),
    [anon_sym_BANG_EQ] = ACTIONS(7189),
    [anon_sym_STAR] = ACTIONS(7191),
    [anon_sym_SLASH] = ACTIONS(7189),
    [anon_sym_STAR_STAR] = ACTIONS(7189),
    [anon_sym_CARET] = ACTIONS(7189),
    [aux_sym_binary_operator_token1] = ACTIONS(7189),
    [anon_sym_PIPE_GT] = ACTIONS(7189),
    [anon_sym_COLON] = ACTIONS(7191),
    [anon_sym_DOLLAR] = ACTIONS(7189),
    [anon_sym_AT] = ACTIONS(7189),
    [anon_sym_COLON_COLON] = ACTIONS(7191),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7189),
    [aux_sym__hex_literal_token1] = ACTIONS(7189),
    [sym__number_literal] = ACTIONS(7191),
    [anon_sym_SQUOTE] = ACTIONS(7189),
    [anon_sym_DQUOTE] = ACTIONS(7189),
    [sym_return] = ACTIONS(7191),
    [sym_next] = ACTIONS(7191),
    [sym_break] = ACTIONS(7191),
    [sym_true] = ACTIONS(7191),
    [sym_false] = ACTIONS(7191),
    [sym_null] = ACTIONS(7191),
    [sym_inf] = ACTIONS(7191),
    [sym_nan] = ACTIONS(7191),
    [anon_sym_NA] = ACTIONS(7191),
    [anon_sym_NA_integer_] = ACTIONS(7191),
    [anon_sym_NA_real_] = ACTIONS(7191),
    [anon_sym_NA_complex_] = ACTIONS(7191),
    [anon_sym_NA_character_] = ACTIONS(7191),
    [sym_dots] = ACTIONS(7191),
    [sym_dot_dot_i] = ACTIONS(7189),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7189),
    [sym__newline] = ACTIONS(7189),
    [sym__raw_string_literal] = ACTIONS(7189),
    [sym__external_else] = ACTIONS(7189),
    [sym__external_open_parenthesis] = ACTIONS(7189),
    [sym__external_open_brace] = ACTIONS(7189),
    [sym__external_open_bracket] = ACTIONS(7189),
    [sym__external_close_bracket] = ACTIONS(7189),
    [sym__external_open_bracket2] = ACTIONS(7189),
  },
  [2550] = {
    [sym_identifier] = ACTIONS(7516),
    [anon_sym_BSLASH] = ACTIONS(7514),
    [anon_sym_function] = ACTIONS(7516),
    [anon_sym_EQ] = ACTIONS(7516),
    [anon_sym_if] = ACTIONS(7516),
    [anon_sym_for] = ACTIONS(7516),
    [anon_sym_while] = ACTIONS(7516),
    [anon_sym_repeat] = ACTIONS(7516),
    [anon_sym_QMARK] = ACTIONS(7514),
    [anon_sym_TILDE] = ACTIONS(7514),
    [anon_sym_BANG] = ACTIONS(7516),
    [anon_sym_PLUS] = ACTIONS(7514),
    [anon_sym_DASH] = ACTIONS(7516),
    [anon_sym_LT_DASH] = ACTIONS(7514),
    [anon_sym_LT_LT_DASH] = ACTIONS(7514),
    [anon_sym_COLON_EQ] = ACTIONS(7514),
    [anon_sym_DASH_GT] = ACTIONS(7516),
    [anon_sym_DASH_GT_GT] = ACTIONS(7514),
    [anon_sym_PIPE] = ACTIONS(7516),
    [anon_sym_AMP] = ACTIONS(7516),
    [anon_sym_PIPE_PIPE] = ACTIONS(7514),
    [anon_sym_AMP_AMP] = ACTIONS(7514),
    [anon_sym_LT] = ACTIONS(7516),
    [anon_sym_LT_EQ] = ACTIONS(7514),
    [anon_sym_GT] = ACTIONS(7516),
    [anon_sym_GT_EQ] = ACTIONS(7514),
    [anon_sym_EQ_EQ] = ACTIONS(7514),
    [anon_sym_BANG_EQ] = ACTIONS(7514),
    [anon_sym_STAR] = ACTIONS(7516),
    [anon_sym_SLASH] = ACTIONS(7514),
    [anon_sym_STAR_STAR] = ACTIONS(7514),
    [anon_sym_CARET] = ACTIONS(7514),
    [aux_sym_binary_operator_token1] = ACTIONS(7514),
    [anon_sym_PIPE_GT] = ACTIONS(7514),
    [anon_sym_COLON] = ACTIONS(7516),
    [anon_sym_DOLLAR] = ACTIONS(7514),
    [anon_sym_AT] = ACTIONS(7514),
    [aux_sym__hex_literal_token1] = ACTIONS(7514),
    [sym__number_literal] = ACTIONS(7516),
    [anon_sym_SQUOTE] = ACTIONS(7514),
    [anon_sym_DQUOTE] = ACTIONS(7514),
    [sym_return] = ACTIONS(7516),
    [sym_next] = ACTIONS(7516),
    [sym_break] = ACTIONS(7516),
    [sym_true] = ACTIONS(7516),
    [sym_false] = ACTIONS(7516),
    [sym_null] = ACTIONS(7516),
    [sym_inf] = ACTIONS(7516),
    [sym_nan] = ACTIONS(7516),
    [anon_sym_NA] = ACTIONS(7516),
    [anon_sym_NA_integer_] = ACTIONS(7516),
    [anon_sym_NA_real_] = ACTIONS(7516),
    [anon_sym_NA_complex_] = ACTIONS(7516),
    [anon_sym_NA_character_] = ACTIONS(7516),
    [sym_dots] = ACTIONS(7516),
    [sym_dot_dot_i] = ACTIONS(7514),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7514),
    [sym__newline] = ACTIONS(7514),
    [sym__semicolon] = ACTIONS(7514),
    [sym__raw_string_literal] = ACTIONS(7514),
    [sym__external_else] = ACTIONS(7514),
    [sym__external_open_parenthesis] = ACTIONS(7514),
    [sym__external_open_brace] = ACTIONS(7514),
    [sym__external_close_brace] = ACTIONS(7514),
    [sym__external_open_bracket] = ACTIONS(7514),
    [sym__external_open_bracket2] = ACTIONS(7514),
    [sym__external_close_bracket2] = ACTIONS(7514),
  },
  [2551] = {
    [sym_identifier] = ACTIONS(7520),
    [anon_sym_BSLASH] = ACTIONS(7518),
    [anon_sym_function] = ACTIONS(7520),
    [anon_sym_EQ] = ACTIONS(7520),
    [anon_sym_if] = ACTIONS(7520),
    [anon_sym_for] = ACTIONS(7520),
    [anon_sym_while] = ACTIONS(7520),
    [anon_sym_repeat] = ACTIONS(7520),
    [anon_sym_QMARK] = ACTIONS(7518),
    [anon_sym_TILDE] = ACTIONS(7518),
    [anon_sym_BANG] = ACTIONS(7520),
    [anon_sym_PLUS] = ACTIONS(7518),
    [anon_sym_DASH] = ACTIONS(7520),
    [anon_sym_LT_DASH] = ACTIONS(7518),
    [anon_sym_LT_LT_DASH] = ACTIONS(7518),
    [anon_sym_COLON_EQ] = ACTIONS(7518),
    [anon_sym_DASH_GT] = ACTIONS(7520),
    [anon_sym_DASH_GT_GT] = ACTIONS(7518),
    [anon_sym_PIPE] = ACTIONS(7520),
    [anon_sym_AMP] = ACTIONS(7520),
    [anon_sym_PIPE_PIPE] = ACTIONS(7518),
    [anon_sym_AMP_AMP] = ACTIONS(7518),
    [anon_sym_LT] = ACTIONS(7520),
    [anon_sym_LT_EQ] = ACTIONS(7518),
    [anon_sym_GT] = ACTIONS(7520),
    [anon_sym_GT_EQ] = ACTIONS(7518),
    [anon_sym_EQ_EQ] = ACTIONS(7518),
    [anon_sym_BANG_EQ] = ACTIONS(7518),
    [anon_sym_STAR] = ACTIONS(7520),
    [anon_sym_SLASH] = ACTIONS(7518),
    [anon_sym_STAR_STAR] = ACTIONS(7518),
    [anon_sym_CARET] = ACTIONS(7518),
    [aux_sym_binary_operator_token1] = ACTIONS(7518),
    [anon_sym_PIPE_GT] = ACTIONS(7518),
    [anon_sym_COLON] = ACTIONS(7520),
    [anon_sym_DOLLAR] = ACTIONS(7518),
    [anon_sym_AT] = ACTIONS(7518),
    [aux_sym__hex_literal_token1] = ACTIONS(7518),
    [sym__number_literal] = ACTIONS(7520),
    [anon_sym_SQUOTE] = ACTIONS(7518),
    [anon_sym_DQUOTE] = ACTIONS(7518),
    [sym_return] = ACTIONS(7520),
    [sym_next] = ACTIONS(7520),
    [sym_break] = ACTIONS(7520),
    [sym_true] = ACTIONS(7520),
    [sym_false] = ACTIONS(7520),
    [sym_null] = ACTIONS(7520),
    [sym_inf] = ACTIONS(7520),
    [sym_nan] = ACTIONS(7520),
    [anon_sym_NA] = ACTIONS(7520),
    [anon_sym_NA_integer_] = ACTIONS(7520),
    [anon_sym_NA_real_] = ACTIONS(7520),
    [anon_sym_NA_complex_] = ACTIONS(7520),
    [anon_sym_NA_character_] = ACTIONS(7520),
    [sym_dots] = ACTIONS(7520),
    [sym_dot_dot_i] = ACTIONS(7518),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7518),
    [sym__newline] = ACTIONS(7518),
    [sym__semicolon] = ACTIONS(7518),
    [sym__raw_string_literal] = ACTIONS(7518),
    [sym__external_else] = ACTIONS(7518),
    [sym__external_open_parenthesis] = ACTIONS(7518),
    [sym__external_open_brace] = ACTIONS(7518),
    [sym__external_close_brace] = ACTIONS(7518),
    [sym__external_open_bracket] = ACTIONS(7518),
    [sym__external_open_bracket2] = ACTIONS(7518),
    [sym__external_close_bracket2] = ACTIONS(7518),
  },
  [2552] = {
    [sym_identifier] = ACTIONS(7512),
    [anon_sym_BSLASH] = ACTIONS(7510),
    [anon_sym_function] = ACTIONS(7512),
    [anon_sym_EQ] = ACTIONS(7512),
    [anon_sym_if] = ACTIONS(7512),
    [anon_sym_for] = ACTIONS(7512),
    [anon_sym_while] = ACTIONS(7512),
    [anon_sym_repeat] = ACTIONS(7512),
    [anon_sym_QMARK] = ACTIONS(7510),
    [anon_sym_TILDE] = ACTIONS(7510),
    [anon_sym_BANG] = ACTIONS(7512),
    [anon_sym_PLUS] = ACTIONS(7510),
    [anon_sym_DASH] = ACTIONS(7512),
    [anon_sym_LT_DASH] = ACTIONS(7510),
    [anon_sym_LT_LT_DASH] = ACTIONS(7510),
    [anon_sym_COLON_EQ] = ACTIONS(7510),
    [anon_sym_DASH_GT] = ACTIONS(7512),
    [anon_sym_DASH_GT_GT] = ACTIONS(7510),
    [anon_sym_PIPE] = ACTIONS(7512),
    [anon_sym_AMP] = ACTIONS(7512),
    [anon_sym_PIPE_PIPE] = ACTIONS(7510),
    [anon_sym_AMP_AMP] = ACTIONS(7510),
    [anon_sym_LT] = ACTIONS(7512),
    [anon_sym_LT_EQ] = ACTIONS(7510),
    [anon_sym_GT] = ACTIONS(7512),
    [anon_sym_GT_EQ] = ACTIONS(7510),
    [anon_sym_EQ_EQ] = ACTIONS(7510),
    [anon_sym_BANG_EQ] = ACTIONS(7510),
    [anon_sym_STAR] = ACTIONS(7512),
    [anon_sym_SLASH] = ACTIONS(7510),
    [anon_sym_STAR_STAR] = ACTIONS(7510),
    [anon_sym_CARET] = ACTIONS(7510),
    [aux_sym_binary_operator_token1] = ACTIONS(7510),
    [anon_sym_PIPE_GT] = ACTIONS(7510),
    [anon_sym_COLON] = ACTIONS(7512),
    [anon_sym_DOLLAR] = ACTIONS(7510),
    [anon_sym_AT] = ACTIONS(7510),
    [aux_sym__hex_literal_token1] = ACTIONS(7510),
    [sym__number_literal] = ACTIONS(7512),
    [anon_sym_SQUOTE] = ACTIONS(7510),
    [anon_sym_DQUOTE] = ACTIONS(7510),
    [sym_return] = ACTIONS(7512),
    [sym_next] = ACTIONS(7512),
    [sym_break] = ACTIONS(7512),
    [sym_true] = ACTIONS(7512),
    [sym_false] = ACTIONS(7512),
    [sym_null] = ACTIONS(7512),
    [sym_inf] = ACTIONS(7512),
    [sym_nan] = ACTIONS(7512),
    [anon_sym_NA] = ACTIONS(7512),
    [anon_sym_NA_integer_] = ACTIONS(7512),
    [anon_sym_NA_real_] = ACTIONS(7512),
    [anon_sym_NA_complex_] = ACTIONS(7512),
    [anon_sym_NA_character_] = ACTIONS(7512),
    [sym_dots] = ACTIONS(7512),
    [sym_dot_dot_i] = ACTIONS(7510),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7510),
    [sym__newline] = ACTIONS(7510),
    [sym__semicolon] = ACTIONS(7510),
    [sym__raw_string_literal] = ACTIONS(7510),
    [sym__external_open_parenthesis] = ACTIONS(7510),
    [sym__external_close_parenthesis] = ACTIONS(7510),
    [sym__external_open_brace] = ACTIONS(7510),
    [sym__external_close_brace] = ACTIONS(7510),
    [sym__external_open_bracket] = ACTIONS(7510),
    [sym__external_close_bracket] = ACTIONS(7510),
    [sym__external_open_bracket2] = ACTIONS(7510),
  },
  [2553] = {
    [sym_identifier] = ACTIONS(7524),
    [anon_sym_BSLASH] = ACTIONS(7522),
    [anon_sym_function] = ACTIONS(7524),
    [anon_sym_EQ] = ACTIONS(7524),
    [anon_sym_if] = ACTIONS(7524),
    [anon_sym_for] = ACTIONS(7524),
    [anon_sym_while] = ACTIONS(7524),
    [anon_sym_repeat] = ACTIONS(7524),
    [anon_sym_QMARK] = ACTIONS(7522),
    [anon_sym_TILDE] = ACTIONS(7522),
    [anon_sym_BANG] = ACTIONS(7524),
    [anon_sym_PLUS] = ACTIONS(7522),
    [anon_sym_DASH] = ACTIONS(7524),
    [anon_sym_LT_DASH] = ACTIONS(7522),
    [anon_sym_LT_LT_DASH] = ACTIONS(7522),
    [anon_sym_COLON_EQ] = ACTIONS(7522),
    [anon_sym_DASH_GT] = ACTIONS(7524),
    [anon_sym_DASH_GT_GT] = ACTIONS(7522),
    [anon_sym_PIPE] = ACTIONS(7524),
    [anon_sym_AMP] = ACTIONS(7524),
    [anon_sym_PIPE_PIPE] = ACTIONS(7522),
    [anon_sym_AMP_AMP] = ACTIONS(7522),
    [anon_sym_LT] = ACTIONS(7524),
    [anon_sym_LT_EQ] = ACTIONS(7522),
    [anon_sym_GT] = ACTIONS(7524),
    [anon_sym_GT_EQ] = ACTIONS(7522),
    [anon_sym_EQ_EQ] = ACTIONS(7522),
    [anon_sym_BANG_EQ] = ACTIONS(7522),
    [anon_sym_STAR] = ACTIONS(7524),
    [anon_sym_SLASH] = ACTIONS(7522),
    [anon_sym_STAR_STAR] = ACTIONS(7522),
    [anon_sym_CARET] = ACTIONS(7522),
    [aux_sym_binary_operator_token1] = ACTIONS(7522),
    [anon_sym_PIPE_GT] = ACTIONS(7522),
    [anon_sym_COLON] = ACTIONS(7524),
    [anon_sym_DOLLAR] = ACTIONS(7522),
    [anon_sym_AT] = ACTIONS(7522),
    [aux_sym__hex_literal_token1] = ACTIONS(7522),
    [sym__number_literal] = ACTIONS(7524),
    [anon_sym_SQUOTE] = ACTIONS(7522),
    [anon_sym_DQUOTE] = ACTIONS(7522),
    [sym_return] = ACTIONS(7524),
    [sym_next] = ACTIONS(7524),
    [sym_break] = ACTIONS(7524),
    [sym_true] = ACTIONS(7524),
    [sym_false] = ACTIONS(7524),
    [sym_null] = ACTIONS(7524),
    [sym_inf] = ACTIONS(7524),
    [sym_nan] = ACTIONS(7524),
    [anon_sym_NA] = ACTIONS(7524),
    [anon_sym_NA_integer_] = ACTIONS(7524),
    [anon_sym_NA_real_] = ACTIONS(7524),
    [anon_sym_NA_complex_] = ACTIONS(7524),
    [anon_sym_NA_character_] = ACTIONS(7524),
    [sym_dots] = ACTIONS(7524),
    [sym_dot_dot_i] = ACTIONS(7522),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7522),
    [sym__newline] = ACTIONS(7522),
    [sym__semicolon] = ACTIONS(7522),
    [sym__raw_string_literal] = ACTIONS(7522),
    [sym__external_else] = ACTIONS(7522),
    [sym__external_open_parenthesis] = ACTIONS(7522),
    [sym__external_open_brace] = ACTIONS(7522),
    [sym__external_close_brace] = ACTIONS(7522),
    [sym__external_open_bracket] = ACTIONS(7522),
    [sym__external_open_bracket2] = ACTIONS(7522),
    [sym__external_close_bracket2] = ACTIONS(7522),
  },
  [2554] = {
    [sym_identifier] = ACTIONS(7528),
    [anon_sym_BSLASH] = ACTIONS(7526),
    [anon_sym_function] = ACTIONS(7528),
    [anon_sym_EQ] = ACTIONS(7528),
    [anon_sym_if] = ACTIONS(7528),
    [anon_sym_for] = ACTIONS(7528),
    [anon_sym_while] = ACTIONS(7528),
    [anon_sym_repeat] = ACTIONS(7528),
    [anon_sym_QMARK] = ACTIONS(7526),
    [anon_sym_TILDE] = ACTIONS(7526),
    [anon_sym_BANG] = ACTIONS(7528),
    [anon_sym_PLUS] = ACTIONS(7526),
    [anon_sym_DASH] = ACTIONS(7528),
    [anon_sym_LT_DASH] = ACTIONS(7526),
    [anon_sym_LT_LT_DASH] = ACTIONS(7526),
    [anon_sym_COLON_EQ] = ACTIONS(7526),
    [anon_sym_DASH_GT] = ACTIONS(7528),
    [anon_sym_DASH_GT_GT] = ACTIONS(7526),
    [anon_sym_PIPE] = ACTIONS(7528),
    [anon_sym_AMP] = ACTIONS(7528),
    [anon_sym_PIPE_PIPE] = ACTIONS(7526),
    [anon_sym_AMP_AMP] = ACTIONS(7526),
    [anon_sym_LT] = ACTIONS(7528),
    [anon_sym_LT_EQ] = ACTIONS(7526),
    [anon_sym_GT] = ACTIONS(7528),
    [anon_sym_GT_EQ] = ACTIONS(7526),
    [anon_sym_EQ_EQ] = ACTIONS(7526),
    [anon_sym_BANG_EQ] = ACTIONS(7526),
    [anon_sym_STAR] = ACTIONS(7528),
    [anon_sym_SLASH] = ACTIONS(7526),
    [anon_sym_STAR_STAR] = ACTIONS(7526),
    [anon_sym_CARET] = ACTIONS(7526),
    [aux_sym_binary_operator_token1] = ACTIONS(7526),
    [anon_sym_PIPE_GT] = ACTIONS(7526),
    [anon_sym_COLON] = ACTIONS(7528),
    [anon_sym_DOLLAR] = ACTIONS(7526),
    [anon_sym_AT] = ACTIONS(7526),
    [aux_sym__hex_literal_token1] = ACTIONS(7526),
    [sym__number_literal] = ACTIONS(7528),
    [anon_sym_SQUOTE] = ACTIONS(7526),
    [anon_sym_DQUOTE] = ACTIONS(7526),
    [sym_return] = ACTIONS(7528),
    [sym_next] = ACTIONS(7528),
    [sym_break] = ACTIONS(7528),
    [sym_true] = ACTIONS(7528),
    [sym_false] = ACTIONS(7528),
    [sym_null] = ACTIONS(7528),
    [sym_inf] = ACTIONS(7528),
    [sym_nan] = ACTIONS(7528),
    [anon_sym_NA] = ACTIONS(7528),
    [anon_sym_NA_integer_] = ACTIONS(7528),
    [anon_sym_NA_real_] = ACTIONS(7528),
    [anon_sym_NA_complex_] = ACTIONS(7528),
    [anon_sym_NA_character_] = ACTIONS(7528),
    [sym_dots] = ACTIONS(7528),
    [sym_dot_dot_i] = ACTIONS(7526),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7526),
    [sym__newline] = ACTIONS(7526),
    [sym__semicolon] = ACTIONS(7526),
    [sym__raw_string_literal] = ACTIONS(7526),
    [sym__external_else] = ACTIONS(7526),
    [sym__external_open_parenthesis] = ACTIONS(7526),
    [sym__external_open_brace] = ACTIONS(7526),
    [sym__external_close_brace] = ACTIONS(7526),
    [sym__external_open_bracket] = ACTIONS(7526),
    [sym__external_open_bracket2] = ACTIONS(7526),
    [sym__external_close_bracket2] = ACTIONS(7526),
  },
  [2555] = {
    [sym_identifier] = ACTIONS(7532),
    [anon_sym_BSLASH] = ACTIONS(7530),
    [anon_sym_function] = ACTIONS(7532),
    [anon_sym_EQ] = ACTIONS(7532),
    [anon_sym_if] = ACTIONS(7532),
    [anon_sym_for] = ACTIONS(7532),
    [anon_sym_while] = ACTIONS(7532),
    [anon_sym_repeat] = ACTIONS(7532),
    [anon_sym_QMARK] = ACTIONS(7530),
    [anon_sym_TILDE] = ACTIONS(7530),
    [anon_sym_BANG] = ACTIONS(7532),
    [anon_sym_PLUS] = ACTIONS(7530),
    [anon_sym_DASH] = ACTIONS(7532),
    [anon_sym_LT_DASH] = ACTIONS(7530),
    [anon_sym_LT_LT_DASH] = ACTIONS(7530),
    [anon_sym_COLON_EQ] = ACTIONS(7530),
    [anon_sym_DASH_GT] = ACTIONS(7532),
    [anon_sym_DASH_GT_GT] = ACTIONS(7530),
    [anon_sym_PIPE] = ACTIONS(7532),
    [anon_sym_AMP] = ACTIONS(7532),
    [anon_sym_PIPE_PIPE] = ACTIONS(7530),
    [anon_sym_AMP_AMP] = ACTIONS(7530),
    [anon_sym_LT] = ACTIONS(7532),
    [anon_sym_LT_EQ] = ACTIONS(7530),
    [anon_sym_GT] = ACTIONS(7532),
    [anon_sym_GT_EQ] = ACTIONS(7530),
    [anon_sym_EQ_EQ] = ACTIONS(7530),
    [anon_sym_BANG_EQ] = ACTIONS(7530),
    [anon_sym_STAR] = ACTIONS(7532),
    [anon_sym_SLASH] = ACTIONS(7530),
    [anon_sym_STAR_STAR] = ACTIONS(7530),
    [anon_sym_CARET] = ACTIONS(7530),
    [aux_sym_binary_operator_token1] = ACTIONS(7530),
    [anon_sym_PIPE_GT] = ACTIONS(7530),
    [anon_sym_COLON] = ACTIONS(7532),
    [anon_sym_DOLLAR] = ACTIONS(7530),
    [anon_sym_AT] = ACTIONS(7530),
    [aux_sym__hex_literal_token1] = ACTIONS(7530),
    [sym__number_literal] = ACTIONS(7532),
    [anon_sym_SQUOTE] = ACTIONS(7530),
    [anon_sym_DQUOTE] = ACTIONS(7530),
    [sym_return] = ACTIONS(7532),
    [sym_next] = ACTIONS(7532),
    [sym_break] = ACTIONS(7532),
    [sym_true] = ACTIONS(7532),
    [sym_false] = ACTIONS(7532),
    [sym_null] = ACTIONS(7532),
    [sym_inf] = ACTIONS(7532),
    [sym_nan] = ACTIONS(7532),
    [anon_sym_NA] = ACTIONS(7532),
    [anon_sym_NA_integer_] = ACTIONS(7532),
    [anon_sym_NA_real_] = ACTIONS(7532),
    [anon_sym_NA_complex_] = ACTIONS(7532),
    [anon_sym_NA_character_] = ACTIONS(7532),
    [sym_dots] = ACTIONS(7532),
    [sym_dot_dot_i] = ACTIONS(7530),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7530),
    [sym__newline] = ACTIONS(7530),
    [sym__semicolon] = ACTIONS(7530),
    [sym__raw_string_literal] = ACTIONS(7530),
    [sym__external_else] = ACTIONS(7530),
    [sym__external_open_parenthesis] = ACTIONS(7530),
    [sym__external_open_brace] = ACTIONS(7530),
    [sym__external_close_brace] = ACTIONS(7530),
    [sym__external_open_bracket] = ACTIONS(7530),
    [sym__external_open_bracket2] = ACTIONS(7530),
    [sym__external_close_bracket2] = ACTIONS(7530),
  },
  [2556] = {
    [sym_identifier] = ACTIONS(7540),
    [anon_sym_BSLASH] = ACTIONS(7538),
    [anon_sym_function] = ACTIONS(7540),
    [anon_sym_EQ] = ACTIONS(7540),
    [anon_sym_if] = ACTIONS(7540),
    [anon_sym_for] = ACTIONS(7540),
    [anon_sym_while] = ACTIONS(7540),
    [anon_sym_repeat] = ACTIONS(7540),
    [anon_sym_QMARK] = ACTIONS(7538),
    [anon_sym_TILDE] = ACTIONS(7538),
    [anon_sym_BANG] = ACTIONS(7540),
    [anon_sym_PLUS] = ACTIONS(7538),
    [anon_sym_DASH] = ACTIONS(7540),
    [anon_sym_LT_DASH] = ACTIONS(7538),
    [anon_sym_LT_LT_DASH] = ACTIONS(7538),
    [anon_sym_COLON_EQ] = ACTIONS(7538),
    [anon_sym_DASH_GT] = ACTIONS(7540),
    [anon_sym_DASH_GT_GT] = ACTIONS(7538),
    [anon_sym_PIPE] = ACTIONS(7540),
    [anon_sym_AMP] = ACTIONS(7540),
    [anon_sym_PIPE_PIPE] = ACTIONS(7538),
    [anon_sym_AMP_AMP] = ACTIONS(7538),
    [anon_sym_LT] = ACTIONS(7540),
    [anon_sym_LT_EQ] = ACTIONS(7538),
    [anon_sym_GT] = ACTIONS(7540),
    [anon_sym_GT_EQ] = ACTIONS(7538),
    [anon_sym_EQ_EQ] = ACTIONS(7538),
    [anon_sym_BANG_EQ] = ACTIONS(7538),
    [anon_sym_STAR] = ACTIONS(7540),
    [anon_sym_SLASH] = ACTIONS(7538),
    [anon_sym_STAR_STAR] = ACTIONS(7538),
    [anon_sym_CARET] = ACTIONS(7538),
    [aux_sym_binary_operator_token1] = ACTIONS(7538),
    [anon_sym_PIPE_GT] = ACTIONS(7538),
    [anon_sym_COLON] = ACTIONS(7540),
    [anon_sym_DOLLAR] = ACTIONS(7538),
    [anon_sym_AT] = ACTIONS(7538),
    [aux_sym__hex_literal_token1] = ACTIONS(7538),
    [sym__number_literal] = ACTIONS(7540),
    [anon_sym_SQUOTE] = ACTIONS(7538),
    [anon_sym_DQUOTE] = ACTIONS(7538),
    [sym_return] = ACTIONS(7540),
    [sym_next] = ACTIONS(7540),
    [sym_break] = ACTIONS(7540),
    [sym_true] = ACTIONS(7540),
    [sym_false] = ACTIONS(7540),
    [sym_null] = ACTIONS(7540),
    [sym_inf] = ACTIONS(7540),
    [sym_nan] = ACTIONS(7540),
    [anon_sym_NA] = ACTIONS(7540),
    [anon_sym_NA_integer_] = ACTIONS(7540),
    [anon_sym_NA_real_] = ACTIONS(7540),
    [anon_sym_NA_complex_] = ACTIONS(7540),
    [anon_sym_NA_character_] = ACTIONS(7540),
    [sym_dots] = ACTIONS(7540),
    [sym_dot_dot_i] = ACTIONS(7538),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7538),
    [sym__newline] = ACTIONS(7538),
    [sym__semicolon] = ACTIONS(7538),
    [sym__raw_string_literal] = ACTIONS(7538),
    [sym__external_else] = ACTIONS(7538),
    [sym__external_open_parenthesis] = ACTIONS(7538),
    [sym__external_open_brace] = ACTIONS(7538),
    [sym__external_close_brace] = ACTIONS(7538),
    [sym__external_open_bracket] = ACTIONS(7538),
    [sym__external_open_bracket2] = ACTIONS(7538),
    [sym__external_close_bracket2] = ACTIONS(7538),
  },
  [2557] = {
    [sym_identifier] = ACTIONS(7544),
    [anon_sym_BSLASH] = ACTIONS(7542),
    [anon_sym_function] = ACTIONS(7544),
    [anon_sym_EQ] = ACTIONS(7544),
    [anon_sym_if] = ACTIONS(7544),
    [anon_sym_for] = ACTIONS(7544),
    [anon_sym_while] = ACTIONS(7544),
    [anon_sym_repeat] = ACTIONS(7544),
    [anon_sym_QMARK] = ACTIONS(7542),
    [anon_sym_TILDE] = ACTIONS(7542),
    [anon_sym_BANG] = ACTIONS(7544),
    [anon_sym_PLUS] = ACTIONS(7542),
    [anon_sym_DASH] = ACTIONS(7544),
    [anon_sym_LT_DASH] = ACTIONS(7542),
    [anon_sym_LT_LT_DASH] = ACTIONS(7542),
    [anon_sym_COLON_EQ] = ACTIONS(7542),
    [anon_sym_DASH_GT] = ACTIONS(7544),
    [anon_sym_DASH_GT_GT] = ACTIONS(7542),
    [anon_sym_PIPE] = ACTIONS(7544),
    [anon_sym_AMP] = ACTIONS(7544),
    [anon_sym_PIPE_PIPE] = ACTIONS(7542),
    [anon_sym_AMP_AMP] = ACTIONS(7542),
    [anon_sym_LT] = ACTIONS(7544),
    [anon_sym_LT_EQ] = ACTIONS(7542),
    [anon_sym_GT] = ACTIONS(7544),
    [anon_sym_GT_EQ] = ACTIONS(7542),
    [anon_sym_EQ_EQ] = ACTIONS(7542),
    [anon_sym_BANG_EQ] = ACTIONS(7542),
    [anon_sym_STAR] = ACTIONS(7544),
    [anon_sym_SLASH] = ACTIONS(7542),
    [anon_sym_STAR_STAR] = ACTIONS(7542),
    [anon_sym_CARET] = ACTIONS(7542),
    [aux_sym_binary_operator_token1] = ACTIONS(7542),
    [anon_sym_PIPE_GT] = ACTIONS(7542),
    [anon_sym_COLON] = ACTIONS(7544),
    [anon_sym_DOLLAR] = ACTIONS(7542),
    [anon_sym_AT] = ACTIONS(7542),
    [aux_sym__hex_literal_token1] = ACTIONS(7542),
    [sym__number_literal] = ACTIONS(7544),
    [anon_sym_SQUOTE] = ACTIONS(7542),
    [anon_sym_DQUOTE] = ACTIONS(7542),
    [sym_return] = ACTIONS(7544),
    [sym_next] = ACTIONS(7544),
    [sym_break] = ACTIONS(7544),
    [sym_true] = ACTIONS(7544),
    [sym_false] = ACTIONS(7544),
    [sym_null] = ACTIONS(7544),
    [sym_inf] = ACTIONS(7544),
    [sym_nan] = ACTIONS(7544),
    [anon_sym_NA] = ACTIONS(7544),
    [anon_sym_NA_integer_] = ACTIONS(7544),
    [anon_sym_NA_real_] = ACTIONS(7544),
    [anon_sym_NA_complex_] = ACTIONS(7544),
    [anon_sym_NA_character_] = ACTIONS(7544),
    [sym_dots] = ACTIONS(7544),
    [sym_dot_dot_i] = ACTIONS(7542),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7542),
    [sym__newline] = ACTIONS(7542),
    [sym__semicolon] = ACTIONS(7542),
    [sym__raw_string_literal] = ACTIONS(7542),
    [sym__external_else] = ACTIONS(7542),
    [sym__external_open_parenthesis] = ACTIONS(7542),
    [sym__external_open_brace] = ACTIONS(7542),
    [sym__external_close_brace] = ACTIONS(7542),
    [sym__external_open_bracket] = ACTIONS(7542),
    [sym__external_open_bracket2] = ACTIONS(7542),
    [sym__external_close_bracket2] = ACTIONS(7542),
  },
  [2558] = {
    [sym_identifier] = ACTIONS(7163),
    [anon_sym_BSLASH] = ACTIONS(7165),
    [anon_sym_function] = ACTIONS(7163),
    [anon_sym_EQ] = ACTIONS(7163),
    [anon_sym_if] = ACTIONS(7163),
    [anon_sym_for] = ACTIONS(7163),
    [anon_sym_while] = ACTIONS(7163),
    [anon_sym_repeat] = ACTIONS(7163),
    [anon_sym_QMARK] = ACTIONS(7165),
    [anon_sym_TILDE] = ACTIONS(7165),
    [anon_sym_BANG] = ACTIONS(7163),
    [anon_sym_PLUS] = ACTIONS(7165),
    [anon_sym_DASH] = ACTIONS(7163),
    [anon_sym_LT_DASH] = ACTIONS(7165),
    [anon_sym_LT_LT_DASH] = ACTIONS(7165),
    [anon_sym_COLON_EQ] = ACTIONS(7165),
    [anon_sym_DASH_GT] = ACTIONS(7163),
    [anon_sym_DASH_GT_GT] = ACTIONS(7165),
    [anon_sym_PIPE] = ACTIONS(7163),
    [anon_sym_AMP] = ACTIONS(7163),
    [anon_sym_PIPE_PIPE] = ACTIONS(7165),
    [anon_sym_AMP_AMP] = ACTIONS(7165),
    [anon_sym_LT] = ACTIONS(7163),
    [anon_sym_LT_EQ] = ACTIONS(7165),
    [anon_sym_GT] = ACTIONS(7163),
    [anon_sym_GT_EQ] = ACTIONS(7165),
    [anon_sym_EQ_EQ] = ACTIONS(7165),
    [anon_sym_BANG_EQ] = ACTIONS(7165),
    [anon_sym_STAR] = ACTIONS(7163),
    [anon_sym_SLASH] = ACTIONS(7165),
    [anon_sym_STAR_STAR] = ACTIONS(7165),
    [anon_sym_CARET] = ACTIONS(7165),
    [aux_sym_binary_operator_token1] = ACTIONS(7165),
    [anon_sym_PIPE_GT] = ACTIONS(7165),
    [anon_sym_COLON] = ACTIONS(7163),
    [anon_sym_DOLLAR] = ACTIONS(7165),
    [anon_sym_AT] = ACTIONS(7165),
    [anon_sym_COLON_COLON] = ACTIONS(7163),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7165),
    [aux_sym__hex_literal_token1] = ACTIONS(7165),
    [sym__number_literal] = ACTIONS(7163),
    [anon_sym_SQUOTE] = ACTIONS(7165),
    [anon_sym_DQUOTE] = ACTIONS(7165),
    [sym_return] = ACTIONS(7163),
    [sym_next] = ACTIONS(7163),
    [sym_break] = ACTIONS(7163),
    [sym_true] = ACTIONS(7163),
    [sym_false] = ACTIONS(7163),
    [sym_null] = ACTIONS(7163),
    [sym_inf] = ACTIONS(7163),
    [sym_nan] = ACTIONS(7163),
    [anon_sym_NA] = ACTIONS(7163),
    [anon_sym_NA_integer_] = ACTIONS(7163),
    [anon_sym_NA_real_] = ACTIONS(7163),
    [anon_sym_NA_complex_] = ACTIONS(7163),
    [anon_sym_NA_character_] = ACTIONS(7163),
    [sym_dots] = ACTIONS(7163),
    [sym_dot_dot_i] = ACTIONS(7165),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7165),
    [sym__newline] = ACTIONS(7165),
    [sym__raw_string_literal] = ACTIONS(7165),
    [sym__external_open_parenthesis] = ACTIONS(7165),
    [sym__external_close_parenthesis] = ACTIONS(7165),
    [sym__external_open_brace] = ACTIONS(7165),
    [sym__external_open_bracket] = ACTIONS(7165),
    [sym__external_open_bracket2] = ACTIONS(7165),
    [sym__external_close_bracket2] = ACTIONS(7165),
  },
  [2559] = {
    [sym_identifier] = ACTIONS(7195),
    [anon_sym_BSLASH] = ACTIONS(7193),
    [anon_sym_function] = ACTIONS(7195),
    [anon_sym_EQ] = ACTIONS(7195),
    [anon_sym_if] = ACTIONS(7195),
    [anon_sym_for] = ACTIONS(7195),
    [anon_sym_while] = ACTIONS(7195),
    [anon_sym_repeat] = ACTIONS(7195),
    [anon_sym_QMARK] = ACTIONS(7193),
    [anon_sym_TILDE] = ACTIONS(7193),
    [anon_sym_BANG] = ACTIONS(7195),
    [anon_sym_PLUS] = ACTIONS(7193),
    [anon_sym_DASH] = ACTIONS(7195),
    [anon_sym_LT_DASH] = ACTIONS(7193),
    [anon_sym_LT_LT_DASH] = ACTIONS(7193),
    [anon_sym_COLON_EQ] = ACTIONS(7193),
    [anon_sym_DASH_GT] = ACTIONS(7195),
    [anon_sym_DASH_GT_GT] = ACTIONS(7193),
    [anon_sym_PIPE] = ACTIONS(7195),
    [anon_sym_AMP] = ACTIONS(7195),
    [anon_sym_PIPE_PIPE] = ACTIONS(7193),
    [anon_sym_AMP_AMP] = ACTIONS(7193),
    [anon_sym_LT] = ACTIONS(7195),
    [anon_sym_LT_EQ] = ACTIONS(7193),
    [anon_sym_GT] = ACTIONS(7195),
    [anon_sym_GT_EQ] = ACTIONS(7193),
    [anon_sym_EQ_EQ] = ACTIONS(7193),
    [anon_sym_BANG_EQ] = ACTIONS(7193),
    [anon_sym_STAR] = ACTIONS(7195),
    [anon_sym_SLASH] = ACTIONS(7193),
    [anon_sym_STAR_STAR] = ACTIONS(7193),
    [anon_sym_CARET] = ACTIONS(7193),
    [aux_sym_binary_operator_token1] = ACTIONS(7193),
    [anon_sym_PIPE_GT] = ACTIONS(7193),
    [anon_sym_COLON] = ACTIONS(7195),
    [anon_sym_DOLLAR] = ACTIONS(7193),
    [anon_sym_AT] = ACTIONS(7193),
    [anon_sym_COLON_COLON] = ACTIONS(7195),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7193),
    [aux_sym__hex_literal_token1] = ACTIONS(7193),
    [sym__number_literal] = ACTIONS(7195),
    [anon_sym_SQUOTE] = ACTIONS(7193),
    [anon_sym_DQUOTE] = ACTIONS(7193),
    [sym_return] = ACTIONS(7195),
    [sym_next] = ACTIONS(7195),
    [sym_break] = ACTIONS(7195),
    [sym_true] = ACTIONS(7195),
    [sym_false] = ACTIONS(7195),
    [sym_null] = ACTIONS(7195),
    [sym_inf] = ACTIONS(7195),
    [sym_nan] = ACTIONS(7195),
    [anon_sym_NA] = ACTIONS(7195),
    [anon_sym_NA_integer_] = ACTIONS(7195),
    [anon_sym_NA_real_] = ACTIONS(7195),
    [anon_sym_NA_complex_] = ACTIONS(7195),
    [anon_sym_NA_character_] = ACTIONS(7195),
    [sym_dots] = ACTIONS(7195),
    [sym_dot_dot_i] = ACTIONS(7193),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7193),
    [sym__newline] = ACTIONS(7193),
    [sym__raw_string_literal] = ACTIONS(7193),
    [sym__external_else] = ACTIONS(7193),
    [sym__external_open_parenthesis] = ACTIONS(7193),
    [sym__external_close_parenthesis] = ACTIONS(7193),
    [sym__external_open_brace] = ACTIONS(7193),
    [sym__external_open_bracket] = ACTIONS(7193),
    [sym__external_open_bracket2] = ACTIONS(7193),
  },
  [2560] = {
    [sym_identifier] = ACTIONS(7191),
    [anon_sym_BSLASH] = ACTIONS(7189),
    [anon_sym_function] = ACTIONS(7191),
    [anon_sym_EQ] = ACTIONS(7191),
    [anon_sym_if] = ACTIONS(7191),
    [anon_sym_for] = ACTIONS(7191),
    [anon_sym_while] = ACTIONS(7191),
    [anon_sym_repeat] = ACTIONS(7191),
    [anon_sym_QMARK] = ACTIONS(7189),
    [anon_sym_TILDE] = ACTIONS(7189),
    [anon_sym_BANG] = ACTIONS(7191),
    [anon_sym_PLUS] = ACTIONS(7189),
    [anon_sym_DASH] = ACTIONS(7191),
    [anon_sym_LT_DASH] = ACTIONS(7189),
    [anon_sym_LT_LT_DASH] = ACTIONS(7189),
    [anon_sym_COLON_EQ] = ACTIONS(7189),
    [anon_sym_DASH_GT] = ACTIONS(7191),
    [anon_sym_DASH_GT_GT] = ACTIONS(7189),
    [anon_sym_PIPE] = ACTIONS(7191),
    [anon_sym_AMP] = ACTIONS(7191),
    [anon_sym_PIPE_PIPE] = ACTIONS(7189),
    [anon_sym_AMP_AMP] = ACTIONS(7189),
    [anon_sym_LT] = ACTIONS(7191),
    [anon_sym_LT_EQ] = ACTIONS(7189),
    [anon_sym_GT] = ACTIONS(7191),
    [anon_sym_GT_EQ] = ACTIONS(7189),
    [anon_sym_EQ_EQ] = ACTIONS(7189),
    [anon_sym_BANG_EQ] = ACTIONS(7189),
    [anon_sym_STAR] = ACTIONS(7191),
    [anon_sym_SLASH] = ACTIONS(7189),
    [anon_sym_STAR_STAR] = ACTIONS(7189),
    [anon_sym_CARET] = ACTIONS(7189),
    [aux_sym_binary_operator_token1] = ACTIONS(7189),
    [anon_sym_PIPE_GT] = ACTIONS(7189),
    [anon_sym_COLON] = ACTIONS(7191),
    [anon_sym_DOLLAR] = ACTIONS(7189),
    [anon_sym_AT] = ACTIONS(7189),
    [anon_sym_COLON_COLON] = ACTIONS(7191),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7189),
    [aux_sym__hex_literal_token1] = ACTIONS(7189),
    [sym__number_literal] = ACTIONS(7191),
    [anon_sym_SQUOTE] = ACTIONS(7189),
    [anon_sym_DQUOTE] = ACTIONS(7189),
    [sym_return] = ACTIONS(7191),
    [sym_next] = ACTIONS(7191),
    [sym_break] = ACTIONS(7191),
    [sym_true] = ACTIONS(7191),
    [sym_false] = ACTIONS(7191),
    [sym_null] = ACTIONS(7191),
    [sym_inf] = ACTIONS(7191),
    [sym_nan] = ACTIONS(7191),
    [anon_sym_NA] = ACTIONS(7191),
    [anon_sym_NA_integer_] = ACTIONS(7191),
    [anon_sym_NA_real_] = ACTIONS(7191),
    [anon_sym_NA_complex_] = ACTIONS(7191),
    [anon_sym_NA_character_] = ACTIONS(7191),
    [sym_dots] = ACTIONS(7191),
    [sym_dot_dot_i] = ACTIONS(7189),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7189),
    [sym__newline] = ACTIONS(7189),
    [sym__raw_string_literal] = ACTIONS(7189),
    [sym__external_else] = ACTIONS(7189),
    [sym__external_open_parenthesis] = ACTIONS(7189),
    [sym__external_close_parenthesis] = ACTIONS(7189),
    [sym__external_open_brace] = ACTIONS(7189),
    [sym__external_open_bracket] = ACTIONS(7189),
    [sym__external_open_bracket2] = ACTIONS(7189),
  },
  [2561] = {
    [sym_identifier] = ACTIONS(7528),
    [anon_sym_BSLASH] = ACTIONS(7526),
    [anon_sym_function] = ACTIONS(7528),
    [anon_sym_EQ] = ACTIONS(7528),
    [anon_sym_if] = ACTIONS(7528),
    [anon_sym_for] = ACTIONS(7528),
    [anon_sym_while] = ACTIONS(7528),
    [anon_sym_repeat] = ACTIONS(7528),
    [anon_sym_QMARK] = ACTIONS(7526),
    [anon_sym_TILDE] = ACTIONS(7526),
    [anon_sym_BANG] = ACTIONS(7528),
    [anon_sym_PLUS] = ACTIONS(7526),
    [anon_sym_DASH] = ACTIONS(7528),
    [anon_sym_LT_DASH] = ACTIONS(7526),
    [anon_sym_LT_LT_DASH] = ACTIONS(7526),
    [anon_sym_COLON_EQ] = ACTIONS(7526),
    [anon_sym_DASH_GT] = ACTIONS(7528),
    [anon_sym_DASH_GT_GT] = ACTIONS(7526),
    [anon_sym_PIPE] = ACTIONS(7528),
    [anon_sym_AMP] = ACTIONS(7528),
    [anon_sym_PIPE_PIPE] = ACTIONS(7526),
    [anon_sym_AMP_AMP] = ACTIONS(7526),
    [anon_sym_LT] = ACTIONS(7528),
    [anon_sym_LT_EQ] = ACTIONS(7526),
    [anon_sym_GT] = ACTIONS(7528),
    [anon_sym_GT_EQ] = ACTIONS(7526),
    [anon_sym_EQ_EQ] = ACTIONS(7526),
    [anon_sym_BANG_EQ] = ACTIONS(7526),
    [anon_sym_STAR] = ACTIONS(7528),
    [anon_sym_SLASH] = ACTIONS(7526),
    [anon_sym_STAR_STAR] = ACTIONS(7526),
    [anon_sym_CARET] = ACTIONS(7526),
    [aux_sym_binary_operator_token1] = ACTIONS(7526),
    [anon_sym_PIPE_GT] = ACTIONS(7526),
    [anon_sym_COLON] = ACTIONS(7528),
    [anon_sym_DOLLAR] = ACTIONS(7526),
    [anon_sym_AT] = ACTIONS(7526),
    [aux_sym__hex_literal_token1] = ACTIONS(7526),
    [sym__number_literal] = ACTIONS(7528),
    [anon_sym_SQUOTE] = ACTIONS(7526),
    [anon_sym_DQUOTE] = ACTIONS(7526),
    [sym_return] = ACTIONS(7528),
    [sym_next] = ACTIONS(7528),
    [sym_break] = ACTIONS(7528),
    [sym_true] = ACTIONS(7528),
    [sym_false] = ACTIONS(7528),
    [sym_null] = ACTIONS(7528),
    [sym_inf] = ACTIONS(7528),
    [sym_nan] = ACTIONS(7528),
    [anon_sym_NA] = ACTIONS(7528),
    [anon_sym_NA_integer_] = ACTIONS(7528),
    [anon_sym_NA_real_] = ACTIONS(7528),
    [anon_sym_NA_complex_] = ACTIONS(7528),
    [anon_sym_NA_character_] = ACTIONS(7528),
    [sym_dots] = ACTIONS(7528),
    [sym_dot_dot_i] = ACTIONS(7526),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7526),
    [sym__newline] = ACTIONS(7526),
    [sym__raw_string_literal] = ACTIONS(7526),
    [sym__external_else] = ACTIONS(7526),
    [sym__external_open_parenthesis] = ACTIONS(7526),
    [sym__external_close_parenthesis] = ACTIONS(7526),
    [sym__external_open_brace] = ACTIONS(7526),
    [sym__external_open_bracket] = ACTIONS(7526),
    [sym__external_open_bracket2] = ACTIONS(7526),
    [sym__external_close_bracket2] = ACTIONS(7526),
  },
  [2562] = {
    [ts_builtin_sym_end] = ACTIONS(7131),
    [sym_identifier] = ACTIONS(7129),
    [anon_sym_BSLASH] = ACTIONS(7131),
    [anon_sym_function] = ACTIONS(7129),
    [anon_sym_EQ] = ACTIONS(7129),
    [anon_sym_if] = ACTIONS(7129),
    [anon_sym_for] = ACTIONS(7129),
    [anon_sym_while] = ACTIONS(7129),
    [anon_sym_repeat] = ACTIONS(7129),
    [anon_sym_QMARK] = ACTIONS(7131),
    [anon_sym_TILDE] = ACTIONS(7131),
    [anon_sym_BANG] = ACTIONS(7129),
    [anon_sym_PLUS] = ACTIONS(7131),
    [anon_sym_DASH] = ACTIONS(7129),
    [anon_sym_LT_DASH] = ACTIONS(7131),
    [anon_sym_LT_LT_DASH] = ACTIONS(7131),
    [anon_sym_COLON_EQ] = ACTIONS(7131),
    [anon_sym_DASH_GT] = ACTIONS(7129),
    [anon_sym_DASH_GT_GT] = ACTIONS(7131),
    [anon_sym_PIPE] = ACTIONS(7129),
    [anon_sym_AMP] = ACTIONS(7129),
    [anon_sym_PIPE_PIPE] = ACTIONS(7131),
    [anon_sym_AMP_AMP] = ACTIONS(7131),
    [anon_sym_LT] = ACTIONS(7129),
    [anon_sym_LT_EQ] = ACTIONS(7131),
    [anon_sym_GT] = ACTIONS(7129),
    [anon_sym_GT_EQ] = ACTIONS(7131),
    [anon_sym_EQ_EQ] = ACTIONS(7131),
    [anon_sym_BANG_EQ] = ACTIONS(7131),
    [anon_sym_STAR] = ACTIONS(7129),
    [anon_sym_SLASH] = ACTIONS(7131),
    [anon_sym_STAR_STAR] = ACTIONS(7131),
    [anon_sym_CARET] = ACTIONS(7131),
    [aux_sym_binary_operator_token1] = ACTIONS(7131),
    [anon_sym_PIPE_GT] = ACTIONS(7131),
    [anon_sym_COLON] = ACTIONS(7129),
    [anon_sym_DOLLAR] = ACTIONS(7131),
    [anon_sym_AT] = ACTIONS(7131),
    [anon_sym_COLON_COLON] = ACTIONS(7133),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7135),
    [aux_sym__hex_literal_token1] = ACTIONS(7131),
    [sym__number_literal] = ACTIONS(7129),
    [anon_sym_SQUOTE] = ACTIONS(7131),
    [anon_sym_DQUOTE] = ACTIONS(7131),
    [sym_return] = ACTIONS(7129),
    [sym_next] = ACTIONS(7129),
    [sym_break] = ACTIONS(7129),
    [sym_true] = ACTIONS(7129),
    [sym_false] = ACTIONS(7129),
    [sym_null] = ACTIONS(7129),
    [sym_inf] = ACTIONS(7129),
    [sym_nan] = ACTIONS(7129),
    [anon_sym_NA] = ACTIONS(7129),
    [anon_sym_NA_integer_] = ACTIONS(7129),
    [anon_sym_NA_real_] = ACTIONS(7129),
    [anon_sym_NA_complex_] = ACTIONS(7129),
    [anon_sym_NA_character_] = ACTIONS(7129),
    [sym_dots] = ACTIONS(7129),
    [sym_dot_dot_i] = ACTIONS(7131),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7131),
    [sym__semicolon] = ACTIONS(7131),
    [sym__raw_string_literal] = ACTIONS(7131),
    [sym__external_open_parenthesis] = ACTIONS(7131),
    [sym__external_open_brace] = ACTIONS(7131),
    [sym__external_open_bracket] = ACTIONS(7131),
    [sym__external_open_bracket2] = ACTIONS(7131),
  },
  [2563] = {
    [ts_builtin_sym_end] = ACTIONS(7193),
    [sym_identifier] = ACTIONS(7195),
    [anon_sym_BSLASH] = ACTIONS(7193),
    [anon_sym_function] = ACTIONS(7195),
    [anon_sym_EQ] = ACTIONS(7195),
    [anon_sym_if] = ACTIONS(7195),
    [anon_sym_for] = ACTIONS(7195),
    [anon_sym_while] = ACTIONS(7195),
    [anon_sym_repeat] = ACTIONS(7195),
    [anon_sym_QMARK] = ACTIONS(7193),
    [anon_sym_TILDE] = ACTIONS(7193),
    [anon_sym_BANG] = ACTIONS(7195),
    [anon_sym_PLUS] = ACTIONS(7193),
    [anon_sym_DASH] = ACTIONS(7195),
    [anon_sym_LT_DASH] = ACTIONS(7193),
    [anon_sym_LT_LT_DASH] = ACTIONS(7193),
    [anon_sym_COLON_EQ] = ACTIONS(7193),
    [anon_sym_DASH_GT] = ACTIONS(7195),
    [anon_sym_DASH_GT_GT] = ACTIONS(7193),
    [anon_sym_PIPE] = ACTIONS(7195),
    [anon_sym_AMP] = ACTIONS(7195),
    [anon_sym_PIPE_PIPE] = ACTIONS(7193),
    [anon_sym_AMP_AMP] = ACTIONS(7193),
    [anon_sym_LT] = ACTIONS(7195),
    [anon_sym_LT_EQ] = ACTIONS(7193),
    [anon_sym_GT] = ACTIONS(7195),
    [anon_sym_GT_EQ] = ACTIONS(7193),
    [anon_sym_EQ_EQ] = ACTIONS(7193),
    [anon_sym_BANG_EQ] = ACTIONS(7193),
    [anon_sym_STAR] = ACTIONS(7195),
    [anon_sym_SLASH] = ACTIONS(7193),
    [anon_sym_STAR_STAR] = ACTIONS(7193),
    [anon_sym_CARET] = ACTIONS(7193),
    [aux_sym_binary_operator_token1] = ACTIONS(7193),
    [anon_sym_PIPE_GT] = ACTIONS(7193),
    [anon_sym_COLON] = ACTIONS(7195),
    [anon_sym_DOLLAR] = ACTIONS(7193),
    [anon_sym_AT] = ACTIONS(7193),
    [anon_sym_COLON_COLON] = ACTIONS(7195),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7193),
    [aux_sym__hex_literal_token1] = ACTIONS(7193),
    [sym__number_literal] = ACTIONS(7195),
    [anon_sym_SQUOTE] = ACTIONS(7193),
    [anon_sym_DQUOTE] = ACTIONS(7193),
    [sym_return] = ACTIONS(7195),
    [sym_next] = ACTIONS(7195),
    [sym_break] = ACTIONS(7195),
    [sym_true] = ACTIONS(7195),
    [sym_false] = ACTIONS(7195),
    [sym_null] = ACTIONS(7195),
    [sym_inf] = ACTIONS(7195),
    [sym_nan] = ACTIONS(7195),
    [anon_sym_NA] = ACTIONS(7195),
    [anon_sym_NA_integer_] = ACTIONS(7195),
    [anon_sym_NA_real_] = ACTIONS(7195),
    [anon_sym_NA_complex_] = ACTIONS(7195),
    [anon_sym_NA_character_] = ACTIONS(7195),
    [sym_dots] = ACTIONS(7195),
    [sym_dot_dot_i] = ACTIONS(7193),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7193),
    [sym__semicolon] = ACTIONS(7193),
    [sym__raw_string_literal] = ACTIONS(7193),
    [sym__external_open_parenthesis] = ACTIONS(7193),
    [sym__external_open_brace] = ACTIONS(7193),
    [sym__external_open_bracket] = ACTIONS(7193),
    [sym__external_open_bracket2] = ACTIONS(7193),
  },
  [2564] = {
    [ts_builtin_sym_end] = ACTIONS(7153),
    [sym_identifier] = ACTIONS(7151),
    [anon_sym_BSLASH] = ACTIONS(7153),
    [anon_sym_function] = ACTIONS(7151),
    [anon_sym_EQ] = ACTIONS(7151),
    [anon_sym_if] = ACTIONS(7151),
    [anon_sym_for] = ACTIONS(7151),
    [anon_sym_while] = ACTIONS(7151),
    [anon_sym_repeat] = ACTIONS(7151),
    [anon_sym_QMARK] = ACTIONS(7153),
    [anon_sym_TILDE] = ACTIONS(7153),
    [anon_sym_BANG] = ACTIONS(7151),
    [anon_sym_PLUS] = ACTIONS(7153),
    [anon_sym_DASH] = ACTIONS(7151),
    [anon_sym_LT_DASH] = ACTIONS(7153),
    [anon_sym_LT_LT_DASH] = ACTIONS(7153),
    [anon_sym_COLON_EQ] = ACTIONS(7153),
    [anon_sym_DASH_GT] = ACTIONS(7151),
    [anon_sym_DASH_GT_GT] = ACTIONS(7153),
    [anon_sym_PIPE] = ACTIONS(7151),
    [anon_sym_AMP] = ACTIONS(7151),
    [anon_sym_PIPE_PIPE] = ACTIONS(7153),
    [anon_sym_AMP_AMP] = ACTIONS(7153),
    [anon_sym_LT] = ACTIONS(7151),
    [anon_sym_LT_EQ] = ACTIONS(7153),
    [anon_sym_GT] = ACTIONS(7151),
    [anon_sym_GT_EQ] = ACTIONS(7153),
    [anon_sym_EQ_EQ] = ACTIONS(7153),
    [anon_sym_BANG_EQ] = ACTIONS(7153),
    [anon_sym_STAR] = ACTIONS(7151),
    [anon_sym_SLASH] = ACTIONS(7153),
    [anon_sym_STAR_STAR] = ACTIONS(7153),
    [anon_sym_CARET] = ACTIONS(7153),
    [aux_sym_binary_operator_token1] = ACTIONS(7153),
    [anon_sym_PIPE_GT] = ACTIONS(7153),
    [anon_sym_COLON] = ACTIONS(7151),
    [anon_sym_DOLLAR] = ACTIONS(7153),
    [anon_sym_AT] = ACTIONS(7153),
    [anon_sym_COLON_COLON] = ACTIONS(7151),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7153),
    [aux_sym__hex_literal_token1] = ACTIONS(7153),
    [sym__number_literal] = ACTIONS(7151),
    [anon_sym_SQUOTE] = ACTIONS(7153),
    [anon_sym_DQUOTE] = ACTIONS(7153),
    [sym_return] = ACTIONS(7151),
    [sym_next] = ACTIONS(7151),
    [sym_break] = ACTIONS(7151),
    [sym_true] = ACTIONS(7151),
    [sym_false] = ACTIONS(7151),
    [sym_null] = ACTIONS(7151),
    [sym_inf] = ACTIONS(7151),
    [sym_nan] = ACTIONS(7151),
    [anon_sym_NA] = ACTIONS(7151),
    [anon_sym_NA_integer_] = ACTIONS(7151),
    [anon_sym_NA_real_] = ACTIONS(7151),
    [anon_sym_NA_complex_] = ACTIONS(7151),
    [anon_sym_NA_character_] = ACTIONS(7151),
    [sym_dots] = ACTIONS(7151),
    [sym_dot_dot_i] = ACTIONS(7153),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7153),
    [sym__semicolon] = ACTIONS(7153),
    [sym__raw_string_literal] = ACTIONS(7153),
    [sym__external_open_parenthesis] = ACTIONS(7153),
    [sym__external_open_brace] = ACTIONS(7153),
    [sym__external_open_bracket] = ACTIONS(7153),
    [sym__external_open_bracket2] = ACTIONS(7153),
  },
  [2565] = {
    [ts_builtin_sym_end] = ACTIONS(7189),
    [sym_identifier] = ACTIONS(7191),
    [anon_sym_BSLASH] = ACTIONS(7189),
    [anon_sym_function] = ACTIONS(7191),
    [anon_sym_EQ] = ACTIONS(7191),
    [anon_sym_if] = ACTIONS(7191),
    [anon_sym_for] = ACTIONS(7191),
    [anon_sym_while] = ACTIONS(7191),
    [anon_sym_repeat] = ACTIONS(7191),
    [anon_sym_QMARK] = ACTIONS(7189),
    [anon_sym_TILDE] = ACTIONS(7189),
    [anon_sym_BANG] = ACTIONS(7191),
    [anon_sym_PLUS] = ACTIONS(7189),
    [anon_sym_DASH] = ACTIONS(7191),
    [anon_sym_LT_DASH] = ACTIONS(7189),
    [anon_sym_LT_LT_DASH] = ACTIONS(7189),
    [anon_sym_COLON_EQ] = ACTIONS(7189),
    [anon_sym_DASH_GT] = ACTIONS(7191),
    [anon_sym_DASH_GT_GT] = ACTIONS(7189),
    [anon_sym_PIPE] = ACTIONS(7191),
    [anon_sym_AMP] = ACTIONS(7191),
    [anon_sym_PIPE_PIPE] = ACTIONS(7189),
    [anon_sym_AMP_AMP] = ACTIONS(7189),
    [anon_sym_LT] = ACTIONS(7191),
    [anon_sym_LT_EQ] = ACTIONS(7189),
    [anon_sym_GT] = ACTIONS(7191),
    [anon_sym_GT_EQ] = ACTIONS(7189),
    [anon_sym_EQ_EQ] = ACTIONS(7189),
    [anon_sym_BANG_EQ] = ACTIONS(7189),
    [anon_sym_STAR] = ACTIONS(7191),
    [anon_sym_SLASH] = ACTIONS(7189),
    [anon_sym_STAR_STAR] = ACTIONS(7189),
    [anon_sym_CARET] = ACTIONS(7189),
    [aux_sym_binary_operator_token1] = ACTIONS(7189),
    [anon_sym_PIPE_GT] = ACTIONS(7189),
    [anon_sym_COLON] = ACTIONS(7191),
    [anon_sym_DOLLAR] = ACTIONS(7189),
    [anon_sym_AT] = ACTIONS(7189),
    [anon_sym_COLON_COLON] = ACTIONS(7191),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7189),
    [aux_sym__hex_literal_token1] = ACTIONS(7189),
    [sym__number_literal] = ACTIONS(7191),
    [anon_sym_SQUOTE] = ACTIONS(7189),
    [anon_sym_DQUOTE] = ACTIONS(7189),
    [sym_return] = ACTIONS(7191),
    [sym_next] = ACTIONS(7191),
    [sym_break] = ACTIONS(7191),
    [sym_true] = ACTIONS(7191),
    [sym_false] = ACTIONS(7191),
    [sym_null] = ACTIONS(7191),
    [sym_inf] = ACTIONS(7191),
    [sym_nan] = ACTIONS(7191),
    [anon_sym_NA] = ACTIONS(7191),
    [anon_sym_NA_integer_] = ACTIONS(7191),
    [anon_sym_NA_real_] = ACTIONS(7191),
    [anon_sym_NA_complex_] = ACTIONS(7191),
    [anon_sym_NA_character_] = ACTIONS(7191),
    [sym_dots] = ACTIONS(7191),
    [sym_dot_dot_i] = ACTIONS(7189),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7189),
    [sym__semicolon] = ACTIONS(7189),
    [sym__raw_string_literal] = ACTIONS(7189),
    [sym__external_open_parenthesis] = ACTIONS(7189),
    [sym__external_open_brace] = ACTIONS(7189),
    [sym__external_open_bracket] = ACTIONS(7189),
    [sym__external_open_bracket2] = ACTIONS(7189),
  },
  [2566] = {
    [sym_identifier] = ACTIONS(7195),
    [anon_sym_BSLASH] = ACTIONS(7193),
    [anon_sym_function] = ACTIONS(7195),
    [anon_sym_EQ] = ACTIONS(7195),
    [anon_sym_if] = ACTIONS(7195),
    [anon_sym_for] = ACTIONS(7195),
    [anon_sym_while] = ACTIONS(7195),
    [anon_sym_repeat] = ACTIONS(7195),
    [anon_sym_QMARK] = ACTIONS(7193),
    [anon_sym_TILDE] = ACTIONS(7193),
    [anon_sym_BANG] = ACTIONS(7195),
    [anon_sym_PLUS] = ACTIONS(7193),
    [anon_sym_DASH] = ACTIONS(7195),
    [anon_sym_LT_DASH] = ACTIONS(7193),
    [anon_sym_LT_LT_DASH] = ACTIONS(7193),
    [anon_sym_COLON_EQ] = ACTIONS(7193),
    [anon_sym_DASH_GT] = ACTIONS(7195),
    [anon_sym_DASH_GT_GT] = ACTIONS(7193),
    [anon_sym_PIPE] = ACTIONS(7195),
    [anon_sym_AMP] = ACTIONS(7195),
    [anon_sym_PIPE_PIPE] = ACTIONS(7193),
    [anon_sym_AMP_AMP] = ACTIONS(7193),
    [anon_sym_LT] = ACTIONS(7195),
    [anon_sym_LT_EQ] = ACTIONS(7193),
    [anon_sym_GT] = ACTIONS(7195),
    [anon_sym_GT_EQ] = ACTIONS(7193),
    [anon_sym_EQ_EQ] = ACTIONS(7193),
    [anon_sym_BANG_EQ] = ACTIONS(7193),
    [anon_sym_STAR] = ACTIONS(7195),
    [anon_sym_SLASH] = ACTIONS(7193),
    [anon_sym_STAR_STAR] = ACTIONS(7193),
    [anon_sym_CARET] = ACTIONS(7193),
    [aux_sym_binary_operator_token1] = ACTIONS(7193),
    [anon_sym_PIPE_GT] = ACTIONS(7193),
    [anon_sym_COLON] = ACTIONS(7195),
    [anon_sym_DOLLAR] = ACTIONS(7193),
    [anon_sym_AT] = ACTIONS(7193),
    [anon_sym_COLON_COLON] = ACTIONS(7195),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7193),
    [aux_sym__hex_literal_token1] = ACTIONS(7193),
    [sym__number_literal] = ACTIONS(7195),
    [anon_sym_SQUOTE] = ACTIONS(7193),
    [anon_sym_DQUOTE] = ACTIONS(7193),
    [sym_return] = ACTIONS(7195),
    [sym_next] = ACTIONS(7195),
    [sym_break] = ACTIONS(7195),
    [sym_true] = ACTIONS(7195),
    [sym_false] = ACTIONS(7195),
    [sym_null] = ACTIONS(7195),
    [sym_inf] = ACTIONS(7195),
    [sym_nan] = ACTIONS(7195),
    [anon_sym_NA] = ACTIONS(7195),
    [anon_sym_NA_integer_] = ACTIONS(7195),
    [anon_sym_NA_real_] = ACTIONS(7195),
    [anon_sym_NA_complex_] = ACTIONS(7195),
    [anon_sym_NA_character_] = ACTIONS(7195),
    [sym_dots] = ACTIONS(7195),
    [sym_dot_dot_i] = ACTIONS(7193),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7193),
    [sym__newline] = ACTIONS(7193),
    [sym__raw_string_literal] = ACTIONS(7193),
    [sym__external_open_parenthesis] = ACTIONS(7193),
    [sym__external_open_brace] = ACTIONS(7193),
    [sym__external_open_bracket] = ACTIONS(7193),
    [sym__external_open_bracket2] = ACTIONS(7193),
    [sym__external_close_bracket2] = ACTIONS(7193),
  },
  [2567] = {
    [sym_identifier] = ACTIONS(7137),
    [anon_sym_BSLASH] = ACTIONS(7139),
    [anon_sym_function] = ACTIONS(7137),
    [anon_sym_EQ] = ACTIONS(7137),
    [anon_sym_if] = ACTIONS(7137),
    [anon_sym_for] = ACTIONS(7137),
    [anon_sym_while] = ACTIONS(7137),
    [anon_sym_repeat] = ACTIONS(7137),
    [anon_sym_QMARK] = ACTIONS(7139),
    [anon_sym_TILDE] = ACTIONS(7139),
    [anon_sym_BANG] = ACTIONS(7137),
    [anon_sym_PLUS] = ACTIONS(7139),
    [anon_sym_DASH] = ACTIONS(7137),
    [anon_sym_LT_DASH] = ACTIONS(7139),
    [anon_sym_LT_LT_DASH] = ACTIONS(7139),
    [anon_sym_COLON_EQ] = ACTIONS(7139),
    [anon_sym_DASH_GT] = ACTIONS(7137),
    [anon_sym_DASH_GT_GT] = ACTIONS(7139),
    [anon_sym_PIPE] = ACTIONS(7137),
    [anon_sym_AMP] = ACTIONS(7137),
    [anon_sym_PIPE_PIPE] = ACTIONS(7139),
    [anon_sym_AMP_AMP] = ACTIONS(7139),
    [anon_sym_LT] = ACTIONS(7137),
    [anon_sym_LT_EQ] = ACTIONS(7139),
    [anon_sym_GT] = ACTIONS(7137),
    [anon_sym_GT_EQ] = ACTIONS(7139),
    [anon_sym_EQ_EQ] = ACTIONS(7139),
    [anon_sym_BANG_EQ] = ACTIONS(7139),
    [anon_sym_STAR] = ACTIONS(7137),
    [anon_sym_SLASH] = ACTIONS(7139),
    [anon_sym_STAR_STAR] = ACTIONS(7139),
    [anon_sym_CARET] = ACTIONS(7139),
    [aux_sym_binary_operator_token1] = ACTIONS(7139),
    [anon_sym_PIPE_GT] = ACTIONS(7139),
    [anon_sym_COLON] = ACTIONS(7137),
    [anon_sym_DOLLAR] = ACTIONS(7139),
    [anon_sym_AT] = ACTIONS(7139),
    [anon_sym_COLON_COLON] = ACTIONS(7137),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7139),
    [aux_sym__hex_literal_token1] = ACTIONS(7139),
    [sym__number_literal] = ACTIONS(7137),
    [anon_sym_SQUOTE] = ACTIONS(7139),
    [anon_sym_DQUOTE] = ACTIONS(7139),
    [sym_return] = ACTIONS(7137),
    [sym_next] = ACTIONS(7137),
    [sym_break] = ACTIONS(7137),
    [sym_true] = ACTIONS(7137),
    [sym_false] = ACTIONS(7137),
    [sym_null] = ACTIONS(7137),
    [sym_inf] = ACTIONS(7137),
    [sym_nan] = ACTIONS(7137),
    [anon_sym_NA] = ACTIONS(7137),
    [anon_sym_NA_integer_] = ACTIONS(7137),
    [anon_sym_NA_real_] = ACTIONS(7137),
    [anon_sym_NA_complex_] = ACTIONS(7137),
    [anon_sym_NA_character_] = ACTIONS(7137),
    [sym_dots] = ACTIONS(7137),
    [sym_dot_dot_i] = ACTIONS(7139),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7139),
    [sym__newline] = ACTIONS(7139),
    [sym__raw_string_literal] = ACTIONS(7139),
    [sym__external_open_parenthesis] = ACTIONS(7139),
    [sym__external_close_parenthesis] = ACTIONS(7139),
    [sym__external_open_brace] = ACTIONS(7139),
    [sym__external_open_bracket] = ACTIONS(7139),
    [sym__external_open_bracket2] = ACTIONS(7139),
  },
  [2568] = {
    [sym_identifier] = ACTIONS(7563),
    [anon_sym_BSLASH] = ACTIONS(7561),
    [anon_sym_function] = ACTIONS(7563),
    [anon_sym_EQ] = ACTIONS(7563),
    [anon_sym_if] = ACTIONS(7563),
    [anon_sym_for] = ACTIONS(7563),
    [anon_sym_while] = ACTIONS(7563),
    [anon_sym_repeat] = ACTIONS(7563),
    [anon_sym_QMARK] = ACTIONS(7561),
    [anon_sym_TILDE] = ACTIONS(7561),
    [anon_sym_BANG] = ACTIONS(7563),
    [anon_sym_PLUS] = ACTIONS(7561),
    [anon_sym_DASH] = ACTIONS(7563),
    [anon_sym_LT_DASH] = ACTIONS(7561),
    [anon_sym_LT_LT_DASH] = ACTIONS(7561),
    [anon_sym_COLON_EQ] = ACTIONS(7561),
    [anon_sym_DASH_GT] = ACTIONS(7563),
    [anon_sym_DASH_GT_GT] = ACTIONS(7561),
    [anon_sym_PIPE] = ACTIONS(7563),
    [anon_sym_AMP] = ACTIONS(7563),
    [anon_sym_PIPE_PIPE] = ACTIONS(7561),
    [anon_sym_AMP_AMP] = ACTIONS(7561),
    [anon_sym_LT] = ACTIONS(7563),
    [anon_sym_LT_EQ] = ACTIONS(7561),
    [anon_sym_GT] = ACTIONS(7563),
    [anon_sym_GT_EQ] = ACTIONS(7561),
    [anon_sym_EQ_EQ] = ACTIONS(7561),
    [anon_sym_BANG_EQ] = ACTIONS(7561),
    [anon_sym_STAR] = ACTIONS(7563),
    [anon_sym_SLASH] = ACTIONS(7561),
    [anon_sym_STAR_STAR] = ACTIONS(7561),
    [anon_sym_CARET] = ACTIONS(7561),
    [aux_sym_binary_operator_token1] = ACTIONS(7561),
    [anon_sym_PIPE_GT] = ACTIONS(7561),
    [anon_sym_COLON] = ACTIONS(7563),
    [anon_sym_DOLLAR] = ACTIONS(7561),
    [anon_sym_AT] = ACTIONS(7561),
    [aux_sym__hex_literal_token1] = ACTIONS(7561),
    [sym__number_literal] = ACTIONS(7563),
    [anon_sym_SQUOTE] = ACTIONS(7561),
    [anon_sym_DQUOTE] = ACTIONS(7561),
    [sym_return] = ACTIONS(7563),
    [sym_next] = ACTIONS(7563),
    [sym_break] = ACTIONS(7563),
    [sym_true] = ACTIONS(7563),
    [sym_false] = ACTIONS(7563),
    [sym_null] = ACTIONS(7563),
    [sym_inf] = ACTIONS(7563),
    [sym_nan] = ACTIONS(7563),
    [anon_sym_NA] = ACTIONS(7563),
    [anon_sym_NA_integer_] = ACTIONS(7563),
    [anon_sym_NA_real_] = ACTIONS(7563),
    [anon_sym_NA_complex_] = ACTIONS(7563),
    [anon_sym_NA_character_] = ACTIONS(7563),
    [sym_dots] = ACTIONS(7563),
    [sym_dot_dot_i] = ACTIONS(7561),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7561),
    [sym__newline] = ACTIONS(7561),
    [sym__raw_string_literal] = ACTIONS(7561),
    [sym__external_else] = ACTIONS(7561),
    [sym__external_open_parenthesis] = ACTIONS(7561),
    [sym__external_close_parenthesis] = ACTIONS(7561),
    [sym__external_open_brace] = ACTIONS(7561),
    [sym__external_open_bracket] = ACTIONS(7561),
    [sym__external_close_bracket] = ACTIONS(7561),
    [sym__external_open_bracket2] = ACTIONS(7561),
  },
  [2569] = {
    [sym_identifier] = ACTIONS(7552),
    [anon_sym_BSLASH] = ACTIONS(7550),
    [anon_sym_function] = ACTIONS(7552),
    [anon_sym_EQ] = ACTIONS(7552),
    [anon_sym_if] = ACTIONS(7552),
    [anon_sym_for] = ACTIONS(7552),
    [anon_sym_while] = ACTIONS(7552),
    [anon_sym_repeat] = ACTIONS(7552),
    [anon_sym_QMARK] = ACTIONS(7550),
    [anon_sym_TILDE] = ACTIONS(7550),
    [anon_sym_BANG] = ACTIONS(7552),
    [anon_sym_PLUS] = ACTIONS(7550),
    [anon_sym_DASH] = ACTIONS(7552),
    [anon_sym_LT_DASH] = ACTIONS(7550),
    [anon_sym_LT_LT_DASH] = ACTIONS(7550),
    [anon_sym_COLON_EQ] = ACTIONS(7550),
    [anon_sym_DASH_GT] = ACTIONS(7552),
    [anon_sym_DASH_GT_GT] = ACTIONS(7550),
    [anon_sym_PIPE] = ACTIONS(7552),
    [anon_sym_AMP] = ACTIONS(7552),
    [anon_sym_PIPE_PIPE] = ACTIONS(7550),
    [anon_sym_AMP_AMP] = ACTIONS(7550),
    [anon_sym_LT] = ACTIONS(7552),
    [anon_sym_LT_EQ] = ACTIONS(7550),
    [anon_sym_GT] = ACTIONS(7552),
    [anon_sym_GT_EQ] = ACTIONS(7550),
    [anon_sym_EQ_EQ] = ACTIONS(7550),
    [anon_sym_BANG_EQ] = ACTIONS(7550),
    [anon_sym_STAR] = ACTIONS(7552),
    [anon_sym_SLASH] = ACTIONS(7550),
    [anon_sym_STAR_STAR] = ACTIONS(7550),
    [anon_sym_CARET] = ACTIONS(7550),
    [aux_sym_binary_operator_token1] = ACTIONS(7550),
    [anon_sym_PIPE_GT] = ACTIONS(7550),
    [anon_sym_COLON] = ACTIONS(7552),
    [anon_sym_DOLLAR] = ACTIONS(7550),
    [anon_sym_AT] = ACTIONS(7550),
    [aux_sym__hex_literal_token1] = ACTIONS(7550),
    [sym__number_literal] = ACTIONS(7552),
    [anon_sym_SQUOTE] = ACTIONS(7550),
    [anon_sym_DQUOTE] = ACTIONS(7550),
    [sym_return] = ACTIONS(7552),
    [sym_next] = ACTIONS(7552),
    [sym_break] = ACTIONS(7552),
    [sym_true] = ACTIONS(7552),
    [sym_false] = ACTIONS(7552),
    [sym_null] = ACTIONS(7552),
    [sym_inf] = ACTIONS(7552),
    [sym_nan] = ACTIONS(7552),
    [anon_sym_NA] = ACTIONS(7552),
    [anon_sym_NA_integer_] = ACTIONS(7552),
    [anon_sym_NA_real_] = ACTIONS(7552),
    [anon_sym_NA_complex_] = ACTIONS(7552),
    [anon_sym_NA_character_] = ACTIONS(7552),
    [sym_dots] = ACTIONS(7552),
    [sym_dot_dot_i] = ACTIONS(7550),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7550),
    [sym__newline] = ACTIONS(7550),
    [sym__semicolon] = ACTIONS(7550),
    [sym__raw_string_literal] = ACTIONS(7550),
    [sym__external_open_parenthesis] = ACTIONS(7550),
    [sym__external_open_brace] = ACTIONS(7550),
    [sym__external_close_brace] = ACTIONS(7550),
    [sym__external_open_bracket] = ACTIONS(7550),
    [sym__external_open_bracket2] = ACTIONS(7550),
    [sym__external_close_bracket2] = ACTIONS(7550),
  },
  [2570] = {
    [sym_identifier] = ACTIONS(7474),
    [anon_sym_BSLASH] = ACTIONS(7472),
    [anon_sym_function] = ACTIONS(7474),
    [anon_sym_EQ] = ACTIONS(7474),
    [anon_sym_if] = ACTIONS(7474),
    [anon_sym_for] = ACTIONS(7474),
    [anon_sym_while] = ACTIONS(7474),
    [anon_sym_repeat] = ACTIONS(7474),
    [anon_sym_QMARK] = ACTIONS(7472),
    [anon_sym_TILDE] = ACTIONS(7472),
    [anon_sym_BANG] = ACTIONS(7474),
    [anon_sym_PLUS] = ACTIONS(7472),
    [anon_sym_DASH] = ACTIONS(7474),
    [anon_sym_LT_DASH] = ACTIONS(7472),
    [anon_sym_LT_LT_DASH] = ACTIONS(7472),
    [anon_sym_COLON_EQ] = ACTIONS(7472),
    [anon_sym_DASH_GT] = ACTIONS(7474),
    [anon_sym_DASH_GT_GT] = ACTIONS(7472),
    [anon_sym_PIPE] = ACTIONS(7474),
    [anon_sym_AMP] = ACTIONS(7474),
    [anon_sym_PIPE_PIPE] = ACTIONS(7472),
    [anon_sym_AMP_AMP] = ACTIONS(7472),
    [anon_sym_LT] = ACTIONS(7474),
    [anon_sym_LT_EQ] = ACTIONS(7472),
    [anon_sym_GT] = ACTIONS(7474),
    [anon_sym_GT_EQ] = ACTIONS(7472),
    [anon_sym_EQ_EQ] = ACTIONS(7472),
    [anon_sym_BANG_EQ] = ACTIONS(7472),
    [anon_sym_STAR] = ACTIONS(7474),
    [anon_sym_SLASH] = ACTIONS(7472),
    [anon_sym_STAR_STAR] = ACTIONS(7472),
    [anon_sym_CARET] = ACTIONS(7472),
    [aux_sym_binary_operator_token1] = ACTIONS(7472),
    [anon_sym_PIPE_GT] = ACTIONS(7472),
    [anon_sym_COLON] = ACTIONS(7474),
    [anon_sym_DOLLAR] = ACTIONS(7472),
    [anon_sym_AT] = ACTIONS(7472),
    [aux_sym__hex_literal_token1] = ACTIONS(7472),
    [sym__number_literal] = ACTIONS(7474),
    [anon_sym_SQUOTE] = ACTIONS(7472),
    [anon_sym_DQUOTE] = ACTIONS(7472),
    [sym_return] = ACTIONS(7474),
    [sym_next] = ACTIONS(7474),
    [sym_break] = ACTIONS(7474),
    [sym_true] = ACTIONS(7474),
    [sym_false] = ACTIONS(7474),
    [sym_null] = ACTIONS(7474),
    [sym_inf] = ACTIONS(7474),
    [sym_nan] = ACTIONS(7474),
    [anon_sym_NA] = ACTIONS(7474),
    [anon_sym_NA_integer_] = ACTIONS(7474),
    [anon_sym_NA_real_] = ACTIONS(7474),
    [anon_sym_NA_complex_] = ACTIONS(7474),
    [anon_sym_NA_character_] = ACTIONS(7474),
    [sym_dots] = ACTIONS(7474),
    [sym_dot_dot_i] = ACTIONS(7472),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7472),
    [sym__newline] = ACTIONS(7472),
    [sym__semicolon] = ACTIONS(7472),
    [sym__raw_string_literal] = ACTIONS(7472),
    [sym__external_open_parenthesis] = ACTIONS(7472),
    [sym__external_open_brace] = ACTIONS(7472),
    [sym__external_close_brace] = ACTIONS(7472),
    [sym__external_open_bracket] = ACTIONS(7472),
    [sym__external_close_bracket] = ACTIONS(7472),
    [sym__external_open_bracket2] = ACTIONS(7472),
  },
  [2571] = {
    [sym_identifier] = ACTIONS(7464),
    [anon_sym_BSLASH] = ACTIONS(7466),
    [anon_sym_function] = ACTIONS(7464),
    [anon_sym_EQ] = ACTIONS(7464),
    [anon_sym_if] = ACTIONS(7464),
    [anon_sym_for] = ACTIONS(7464),
    [anon_sym_while] = ACTIONS(7464),
    [anon_sym_repeat] = ACTIONS(7464),
    [anon_sym_QMARK] = ACTIONS(7466),
    [anon_sym_TILDE] = ACTIONS(7466),
    [anon_sym_BANG] = ACTIONS(7464),
    [anon_sym_PLUS] = ACTIONS(7466),
    [anon_sym_DASH] = ACTIONS(7464),
    [anon_sym_LT_DASH] = ACTIONS(7466),
    [anon_sym_LT_LT_DASH] = ACTIONS(7466),
    [anon_sym_COLON_EQ] = ACTIONS(7466),
    [anon_sym_DASH_GT] = ACTIONS(7464),
    [anon_sym_DASH_GT_GT] = ACTIONS(7466),
    [anon_sym_PIPE] = ACTIONS(7464),
    [anon_sym_AMP] = ACTIONS(7464),
    [anon_sym_PIPE_PIPE] = ACTIONS(7466),
    [anon_sym_AMP_AMP] = ACTIONS(7466),
    [anon_sym_LT] = ACTIONS(7464),
    [anon_sym_LT_EQ] = ACTIONS(7466),
    [anon_sym_GT] = ACTIONS(7464),
    [anon_sym_GT_EQ] = ACTIONS(7466),
    [anon_sym_EQ_EQ] = ACTIONS(7466),
    [anon_sym_BANG_EQ] = ACTIONS(7466),
    [anon_sym_STAR] = ACTIONS(7464),
    [anon_sym_SLASH] = ACTIONS(7466),
    [anon_sym_STAR_STAR] = ACTIONS(7466),
    [anon_sym_CARET] = ACTIONS(7466),
    [aux_sym_binary_operator_token1] = ACTIONS(7466),
    [anon_sym_PIPE_GT] = ACTIONS(7466),
    [anon_sym_COLON] = ACTIONS(7464),
    [anon_sym_DOLLAR] = ACTIONS(7466),
    [anon_sym_AT] = ACTIONS(7466),
    [aux_sym__hex_literal_token1] = ACTIONS(7466),
    [sym__number_literal] = ACTIONS(7464),
    [anon_sym_SQUOTE] = ACTIONS(7466),
    [anon_sym_DQUOTE] = ACTIONS(7466),
    [sym_return] = ACTIONS(7464),
    [sym_next] = ACTIONS(7464),
    [sym_break] = ACTIONS(7464),
    [sym_true] = ACTIONS(7464),
    [sym_false] = ACTIONS(7464),
    [sym_null] = ACTIONS(7464),
    [sym_inf] = ACTIONS(7464),
    [sym_nan] = ACTIONS(7464),
    [anon_sym_NA] = ACTIONS(7464),
    [anon_sym_NA_integer_] = ACTIONS(7464),
    [anon_sym_NA_real_] = ACTIONS(7464),
    [anon_sym_NA_complex_] = ACTIONS(7464),
    [anon_sym_NA_character_] = ACTIONS(7464),
    [sym_dots] = ACTIONS(7464),
    [sym_dot_dot_i] = ACTIONS(7466),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7466),
    [sym__newline] = ACTIONS(7466),
    [sym__semicolon] = ACTIONS(7466),
    [sym__raw_string_literal] = ACTIONS(7466),
    [sym__external_open_parenthesis] = ACTIONS(7466),
    [sym__external_open_brace] = ACTIONS(7466),
    [sym__external_close_brace] = ACTIONS(7466),
    [sym__external_open_bracket] = ACTIONS(7466),
    [sym__external_close_bracket] = ACTIONS(7466),
    [sym__external_open_bracket2] = ACTIONS(7466),
  },
  [2572] = {
    [sym_identifier] = ACTIONS(7478),
    [anon_sym_BSLASH] = ACTIONS(7476),
    [anon_sym_function] = ACTIONS(7478),
    [anon_sym_EQ] = ACTIONS(7478),
    [anon_sym_if] = ACTIONS(7478),
    [anon_sym_for] = ACTIONS(7478),
    [anon_sym_while] = ACTIONS(7478),
    [anon_sym_repeat] = ACTIONS(7478),
    [anon_sym_QMARK] = ACTIONS(7476),
    [anon_sym_TILDE] = ACTIONS(7476),
    [anon_sym_BANG] = ACTIONS(7478),
    [anon_sym_PLUS] = ACTIONS(7476),
    [anon_sym_DASH] = ACTIONS(7478),
    [anon_sym_LT_DASH] = ACTIONS(7476),
    [anon_sym_LT_LT_DASH] = ACTIONS(7476),
    [anon_sym_COLON_EQ] = ACTIONS(7476),
    [anon_sym_DASH_GT] = ACTIONS(7478),
    [anon_sym_DASH_GT_GT] = ACTIONS(7476),
    [anon_sym_PIPE] = ACTIONS(7478),
    [anon_sym_AMP] = ACTIONS(7478),
    [anon_sym_PIPE_PIPE] = ACTIONS(7476),
    [anon_sym_AMP_AMP] = ACTIONS(7476),
    [anon_sym_LT] = ACTIONS(7478),
    [anon_sym_LT_EQ] = ACTIONS(7476),
    [anon_sym_GT] = ACTIONS(7478),
    [anon_sym_GT_EQ] = ACTIONS(7476),
    [anon_sym_EQ_EQ] = ACTIONS(7476),
    [anon_sym_BANG_EQ] = ACTIONS(7476),
    [anon_sym_STAR] = ACTIONS(7478),
    [anon_sym_SLASH] = ACTIONS(7476),
    [anon_sym_STAR_STAR] = ACTIONS(7476),
    [anon_sym_CARET] = ACTIONS(7476),
    [aux_sym_binary_operator_token1] = ACTIONS(7476),
    [anon_sym_PIPE_GT] = ACTIONS(7476),
    [anon_sym_COLON] = ACTIONS(7478),
    [anon_sym_DOLLAR] = ACTIONS(7476),
    [anon_sym_AT] = ACTIONS(7476),
    [aux_sym__hex_literal_token1] = ACTIONS(7476),
    [sym__number_literal] = ACTIONS(7478),
    [anon_sym_SQUOTE] = ACTIONS(7476),
    [anon_sym_DQUOTE] = ACTIONS(7476),
    [sym_return] = ACTIONS(7478),
    [sym_next] = ACTIONS(7478),
    [sym_break] = ACTIONS(7478),
    [sym_true] = ACTIONS(7478),
    [sym_false] = ACTIONS(7478),
    [sym_null] = ACTIONS(7478),
    [sym_inf] = ACTIONS(7478),
    [sym_nan] = ACTIONS(7478),
    [anon_sym_NA] = ACTIONS(7478),
    [anon_sym_NA_integer_] = ACTIONS(7478),
    [anon_sym_NA_real_] = ACTIONS(7478),
    [anon_sym_NA_complex_] = ACTIONS(7478),
    [anon_sym_NA_character_] = ACTIONS(7478),
    [sym_dots] = ACTIONS(7478),
    [sym_dot_dot_i] = ACTIONS(7476),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7476),
    [sym__newline] = ACTIONS(7476),
    [sym__semicolon] = ACTIONS(7476),
    [sym__raw_string_literal] = ACTIONS(7476),
    [sym__external_open_parenthesis] = ACTIONS(7476),
    [sym__external_open_brace] = ACTIONS(7476),
    [sym__external_close_brace] = ACTIONS(7476),
    [sym__external_open_bracket] = ACTIONS(7476),
    [sym__external_close_bracket] = ACTIONS(7476),
    [sym__external_open_bracket2] = ACTIONS(7476),
  },
  [2573] = {
    [sym_identifier] = ACTIONS(7191),
    [anon_sym_BSLASH] = ACTIONS(7189),
    [anon_sym_function] = ACTIONS(7191),
    [anon_sym_EQ] = ACTIONS(7191),
    [anon_sym_if] = ACTIONS(7191),
    [anon_sym_for] = ACTIONS(7191),
    [anon_sym_while] = ACTIONS(7191),
    [anon_sym_repeat] = ACTIONS(7191),
    [anon_sym_QMARK] = ACTIONS(7189),
    [anon_sym_TILDE] = ACTIONS(7189),
    [anon_sym_BANG] = ACTIONS(7191),
    [anon_sym_PLUS] = ACTIONS(7189),
    [anon_sym_DASH] = ACTIONS(7191),
    [anon_sym_LT_DASH] = ACTIONS(7189),
    [anon_sym_LT_LT_DASH] = ACTIONS(7189),
    [anon_sym_COLON_EQ] = ACTIONS(7189),
    [anon_sym_DASH_GT] = ACTIONS(7191),
    [anon_sym_DASH_GT_GT] = ACTIONS(7189),
    [anon_sym_PIPE] = ACTIONS(7191),
    [anon_sym_AMP] = ACTIONS(7191),
    [anon_sym_PIPE_PIPE] = ACTIONS(7189),
    [anon_sym_AMP_AMP] = ACTIONS(7189),
    [anon_sym_LT] = ACTIONS(7191),
    [anon_sym_LT_EQ] = ACTIONS(7189),
    [anon_sym_GT] = ACTIONS(7191),
    [anon_sym_GT_EQ] = ACTIONS(7189),
    [anon_sym_EQ_EQ] = ACTIONS(7189),
    [anon_sym_BANG_EQ] = ACTIONS(7189),
    [anon_sym_STAR] = ACTIONS(7191),
    [anon_sym_SLASH] = ACTIONS(7189),
    [anon_sym_STAR_STAR] = ACTIONS(7189),
    [anon_sym_CARET] = ACTIONS(7189),
    [aux_sym_binary_operator_token1] = ACTIONS(7189),
    [anon_sym_PIPE_GT] = ACTIONS(7189),
    [anon_sym_COLON] = ACTIONS(7191),
    [anon_sym_DOLLAR] = ACTIONS(7189),
    [anon_sym_AT] = ACTIONS(7189),
    [anon_sym_COLON_COLON] = ACTIONS(7191),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7189),
    [aux_sym__hex_literal_token1] = ACTIONS(7189),
    [sym__number_literal] = ACTIONS(7191),
    [anon_sym_SQUOTE] = ACTIONS(7189),
    [anon_sym_DQUOTE] = ACTIONS(7189),
    [sym_return] = ACTIONS(7191),
    [sym_next] = ACTIONS(7191),
    [sym_break] = ACTIONS(7191),
    [sym_true] = ACTIONS(7191),
    [sym_false] = ACTIONS(7191),
    [sym_null] = ACTIONS(7191),
    [sym_inf] = ACTIONS(7191),
    [sym_nan] = ACTIONS(7191),
    [anon_sym_NA] = ACTIONS(7191),
    [anon_sym_NA_integer_] = ACTIONS(7191),
    [anon_sym_NA_real_] = ACTIONS(7191),
    [anon_sym_NA_complex_] = ACTIONS(7191),
    [anon_sym_NA_character_] = ACTIONS(7191),
    [sym_dots] = ACTIONS(7191),
    [sym_dot_dot_i] = ACTIONS(7189),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7189),
    [sym__newline] = ACTIONS(7189),
    [sym__raw_string_literal] = ACTIONS(7189),
    [sym__external_open_parenthesis] = ACTIONS(7189),
    [sym__external_open_brace] = ACTIONS(7189),
    [sym__external_open_bracket] = ACTIONS(7189),
    [sym__external_open_bracket2] = ACTIONS(7189),
    [sym__external_close_bracket2] = ACTIONS(7189),
  },
  [2574] = {
    [sym_identifier] = ACTIONS(7482),
    [anon_sym_BSLASH] = ACTIONS(7480),
    [anon_sym_function] = ACTIONS(7482),
    [anon_sym_EQ] = ACTIONS(7482),
    [anon_sym_if] = ACTIONS(7482),
    [anon_sym_for] = ACTIONS(7482),
    [anon_sym_while] = ACTIONS(7482),
    [anon_sym_repeat] = ACTIONS(7482),
    [anon_sym_QMARK] = ACTIONS(7480),
    [anon_sym_TILDE] = ACTIONS(7480),
    [anon_sym_BANG] = ACTIONS(7482),
    [anon_sym_PLUS] = ACTIONS(7480),
    [anon_sym_DASH] = ACTIONS(7482),
    [anon_sym_LT_DASH] = ACTIONS(7480),
    [anon_sym_LT_LT_DASH] = ACTIONS(7480),
    [anon_sym_COLON_EQ] = ACTIONS(7480),
    [anon_sym_DASH_GT] = ACTIONS(7482),
    [anon_sym_DASH_GT_GT] = ACTIONS(7480),
    [anon_sym_PIPE] = ACTIONS(7482),
    [anon_sym_AMP] = ACTIONS(7482),
    [anon_sym_PIPE_PIPE] = ACTIONS(7480),
    [anon_sym_AMP_AMP] = ACTIONS(7480),
    [anon_sym_LT] = ACTIONS(7482),
    [anon_sym_LT_EQ] = ACTIONS(7480),
    [anon_sym_GT] = ACTIONS(7482),
    [anon_sym_GT_EQ] = ACTIONS(7480),
    [anon_sym_EQ_EQ] = ACTIONS(7480),
    [anon_sym_BANG_EQ] = ACTIONS(7480),
    [anon_sym_STAR] = ACTIONS(7482),
    [anon_sym_SLASH] = ACTIONS(7480),
    [anon_sym_STAR_STAR] = ACTIONS(7480),
    [anon_sym_CARET] = ACTIONS(7480),
    [aux_sym_binary_operator_token1] = ACTIONS(7480),
    [anon_sym_PIPE_GT] = ACTIONS(7480),
    [anon_sym_COLON] = ACTIONS(7482),
    [anon_sym_DOLLAR] = ACTIONS(7480),
    [anon_sym_AT] = ACTIONS(7480),
    [aux_sym__hex_literal_token1] = ACTIONS(7480),
    [sym__number_literal] = ACTIONS(7482),
    [anon_sym_SQUOTE] = ACTIONS(7480),
    [anon_sym_DQUOTE] = ACTIONS(7480),
    [sym_return] = ACTIONS(7482),
    [sym_next] = ACTIONS(7482),
    [sym_break] = ACTIONS(7482),
    [sym_true] = ACTIONS(7482),
    [sym_false] = ACTIONS(7482),
    [sym_null] = ACTIONS(7482),
    [sym_inf] = ACTIONS(7482),
    [sym_nan] = ACTIONS(7482),
    [anon_sym_NA] = ACTIONS(7482),
    [anon_sym_NA_integer_] = ACTIONS(7482),
    [anon_sym_NA_real_] = ACTIONS(7482),
    [anon_sym_NA_complex_] = ACTIONS(7482),
    [anon_sym_NA_character_] = ACTIONS(7482),
    [sym_dots] = ACTIONS(7482),
    [sym_dot_dot_i] = ACTIONS(7480),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7480),
    [sym__newline] = ACTIONS(7480),
    [sym__semicolon] = ACTIONS(7480),
    [sym__raw_string_literal] = ACTIONS(7480),
    [sym__external_open_parenthesis] = ACTIONS(7480),
    [sym__external_open_brace] = ACTIONS(7480),
    [sym__external_close_brace] = ACTIONS(7480),
    [sym__external_open_bracket] = ACTIONS(7480),
    [sym__external_close_bracket] = ACTIONS(7480),
    [sym__external_open_bracket2] = ACTIONS(7480),
  },
  [2575] = {
    [sym_identifier] = ACTIONS(5311),
    [anon_sym_BSLASH] = ACTIONS(5313),
    [anon_sym_function] = ACTIONS(5311),
    [anon_sym_EQ] = ACTIONS(5311),
    [anon_sym_if] = ACTIONS(5311),
    [anon_sym_for] = ACTIONS(5311),
    [anon_sym_while] = ACTIONS(5311),
    [anon_sym_repeat] = ACTIONS(5311),
    [anon_sym_QMARK] = ACTIONS(5313),
    [anon_sym_TILDE] = ACTIONS(5313),
    [anon_sym_BANG] = ACTIONS(5311),
    [anon_sym_PLUS] = ACTIONS(5313),
    [anon_sym_DASH] = ACTIONS(5311),
    [anon_sym_LT_DASH] = ACTIONS(5313),
    [anon_sym_LT_LT_DASH] = ACTIONS(5313),
    [anon_sym_COLON_EQ] = ACTIONS(5313),
    [anon_sym_DASH_GT] = ACTIONS(5311),
    [anon_sym_DASH_GT_GT] = ACTIONS(5313),
    [anon_sym_PIPE] = ACTIONS(5311),
    [anon_sym_AMP] = ACTIONS(5311),
    [anon_sym_PIPE_PIPE] = ACTIONS(5313),
    [anon_sym_AMP_AMP] = ACTIONS(5313),
    [anon_sym_LT] = ACTIONS(5311),
    [anon_sym_LT_EQ] = ACTIONS(5313),
    [anon_sym_GT] = ACTIONS(5311),
    [anon_sym_GT_EQ] = ACTIONS(5313),
    [anon_sym_EQ_EQ] = ACTIONS(5313),
    [anon_sym_BANG_EQ] = ACTIONS(5313),
    [anon_sym_STAR] = ACTIONS(5311),
    [anon_sym_SLASH] = ACTIONS(5313),
    [anon_sym_STAR_STAR] = ACTIONS(5313),
    [anon_sym_CARET] = ACTIONS(5313),
    [aux_sym_binary_operator_token1] = ACTIONS(5313),
    [anon_sym_PIPE_GT] = ACTIONS(5313),
    [anon_sym_COLON] = ACTIONS(5311),
    [anon_sym_DOLLAR] = ACTIONS(5313),
    [anon_sym_AT] = ACTIONS(5313),
    [aux_sym__hex_literal_token1] = ACTIONS(5313),
    [sym__number_literal] = ACTIONS(5311),
    [anon_sym_SQUOTE] = ACTIONS(5313),
    [anon_sym_DQUOTE] = ACTIONS(5313),
    [sym_return] = ACTIONS(5311),
    [sym_next] = ACTIONS(5311),
    [sym_break] = ACTIONS(5311),
    [sym_true] = ACTIONS(5311),
    [sym_false] = ACTIONS(5311),
    [sym_null] = ACTIONS(5311),
    [sym_inf] = ACTIONS(5311),
    [sym_nan] = ACTIONS(5311),
    [anon_sym_NA] = ACTIONS(5311),
    [anon_sym_NA_integer_] = ACTIONS(5311),
    [anon_sym_NA_real_] = ACTIONS(5311),
    [anon_sym_NA_complex_] = ACTIONS(5311),
    [anon_sym_NA_character_] = ACTIONS(5311),
    [sym_dots] = ACTIONS(5311),
    [sym_dot_dot_i] = ACTIONS(5313),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5313),
    [sym__newline] = ACTIONS(5313),
    [sym__raw_string_literal] = ACTIONS(5313),
    [sym__external_else] = ACTIONS(5313),
    [sym__external_open_parenthesis] = ACTIONS(5313),
    [sym__external_close_parenthesis] = ACTIONS(5313),
    [sym__external_open_brace] = ACTIONS(5313),
    [sym__external_open_bracket] = ACTIONS(5313),
    [sym__external_close_bracket] = ACTIONS(5313),
    [sym__external_open_bracket2] = ACTIONS(5313),
  },
  [2576] = {
    [aux_sym_function_definition_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(7419),
    [anon_sym_BSLASH] = ACTIONS(7417),
    [anon_sym_function] = ACTIONS(7419),
    [anon_sym_EQ] = ACTIONS(7419),
    [anon_sym_if] = ACTIONS(7419),
    [anon_sym_for] = ACTIONS(7419),
    [anon_sym_while] = ACTIONS(7419),
    [anon_sym_repeat] = ACTIONS(7419),
    [anon_sym_QMARK] = ACTIONS(7417),
    [anon_sym_TILDE] = ACTIONS(7417),
    [anon_sym_BANG] = ACTIONS(7419),
    [anon_sym_PLUS] = ACTIONS(7417),
    [anon_sym_DASH] = ACTIONS(7419),
    [anon_sym_LT_DASH] = ACTIONS(7417),
    [anon_sym_LT_LT_DASH] = ACTIONS(7417),
    [anon_sym_COLON_EQ] = ACTIONS(7417),
    [anon_sym_DASH_GT] = ACTIONS(7419),
    [anon_sym_DASH_GT_GT] = ACTIONS(7417),
    [anon_sym_PIPE] = ACTIONS(7419),
    [anon_sym_AMP] = ACTIONS(7419),
    [anon_sym_PIPE_PIPE] = ACTIONS(7417),
    [anon_sym_AMP_AMP] = ACTIONS(7417),
    [anon_sym_LT] = ACTIONS(7419),
    [anon_sym_LT_EQ] = ACTIONS(7417),
    [anon_sym_GT] = ACTIONS(7419),
    [anon_sym_GT_EQ] = ACTIONS(7417),
    [anon_sym_EQ_EQ] = ACTIONS(7417),
    [anon_sym_BANG_EQ] = ACTIONS(7417),
    [anon_sym_STAR] = ACTIONS(7419),
    [anon_sym_SLASH] = ACTIONS(7417),
    [anon_sym_STAR_STAR] = ACTIONS(7417),
    [anon_sym_CARET] = ACTIONS(7417),
    [aux_sym_binary_operator_token1] = ACTIONS(7417),
    [anon_sym_PIPE_GT] = ACTIONS(7417),
    [anon_sym_COLON] = ACTIONS(7419),
    [anon_sym_DOLLAR] = ACTIONS(7417),
    [anon_sym_AT] = ACTIONS(7417),
    [aux_sym__hex_literal_token1] = ACTIONS(7417),
    [sym__number_literal] = ACTIONS(7419),
    [anon_sym_SQUOTE] = ACTIONS(7417),
    [anon_sym_DQUOTE] = ACTIONS(7417),
    [sym_return] = ACTIONS(7419),
    [sym_next] = ACTIONS(7419),
    [sym_break] = ACTIONS(7419),
    [sym_true] = ACTIONS(7419),
    [sym_false] = ACTIONS(7419),
    [sym_null] = ACTIONS(7419),
    [sym_inf] = ACTIONS(7419),
    [sym_nan] = ACTIONS(7419),
    [anon_sym_NA] = ACTIONS(7419),
    [anon_sym_NA_integer_] = ACTIONS(7419),
    [anon_sym_NA_real_] = ACTIONS(7419),
    [anon_sym_NA_complex_] = ACTIONS(7419),
    [anon_sym_NA_character_] = ACTIONS(7419),
    [sym_dots] = ACTIONS(7419),
    [sym_dot_dot_i] = ACTIONS(7417),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7417),
    [sym__newline] = ACTIONS(7649),
    [sym__raw_string_literal] = ACTIONS(7417),
    [sym__external_else] = ACTIONS(7417),
    [sym__external_open_parenthesis] = ACTIONS(7417),
    [sym__external_close_parenthesis] = ACTIONS(7417),
    [sym__external_open_brace] = ACTIONS(7417),
    [sym__external_open_bracket] = ACTIONS(7417),
    [sym__external_open_bracket2] = ACTIONS(7417),
  },
  [2577] = {
    [sym_identifier] = ACTIONS(7556),
    [anon_sym_BSLASH] = ACTIONS(7554),
    [anon_sym_function] = ACTIONS(7556),
    [anon_sym_EQ] = ACTIONS(7556),
    [anon_sym_if] = ACTIONS(7556),
    [anon_sym_for] = ACTIONS(7556),
    [anon_sym_while] = ACTIONS(7556),
    [anon_sym_repeat] = ACTIONS(7556),
    [anon_sym_QMARK] = ACTIONS(7554),
    [anon_sym_TILDE] = ACTIONS(7554),
    [anon_sym_BANG] = ACTIONS(7556),
    [anon_sym_PLUS] = ACTIONS(7554),
    [anon_sym_DASH] = ACTIONS(7556),
    [anon_sym_LT_DASH] = ACTIONS(7554),
    [anon_sym_LT_LT_DASH] = ACTIONS(7554),
    [anon_sym_COLON_EQ] = ACTIONS(7554),
    [anon_sym_DASH_GT] = ACTIONS(7556),
    [anon_sym_DASH_GT_GT] = ACTIONS(7554),
    [anon_sym_PIPE] = ACTIONS(7556),
    [anon_sym_AMP] = ACTIONS(7556),
    [anon_sym_PIPE_PIPE] = ACTIONS(7554),
    [anon_sym_AMP_AMP] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(7556),
    [anon_sym_LT_EQ] = ACTIONS(7554),
    [anon_sym_GT] = ACTIONS(7556),
    [anon_sym_GT_EQ] = ACTIONS(7554),
    [anon_sym_EQ_EQ] = ACTIONS(7554),
    [anon_sym_BANG_EQ] = ACTIONS(7554),
    [anon_sym_STAR] = ACTIONS(7556),
    [anon_sym_SLASH] = ACTIONS(7554),
    [anon_sym_STAR_STAR] = ACTIONS(7554),
    [anon_sym_CARET] = ACTIONS(7554),
    [aux_sym_binary_operator_token1] = ACTIONS(7554),
    [anon_sym_PIPE_GT] = ACTIONS(7554),
    [anon_sym_COLON] = ACTIONS(7556),
    [anon_sym_DOLLAR] = ACTIONS(7554),
    [anon_sym_AT] = ACTIONS(7554),
    [aux_sym__hex_literal_token1] = ACTIONS(7554),
    [sym__number_literal] = ACTIONS(7556),
    [anon_sym_SQUOTE] = ACTIONS(7554),
    [anon_sym_DQUOTE] = ACTIONS(7554),
    [sym_return] = ACTIONS(7556),
    [sym_next] = ACTIONS(7556),
    [sym_break] = ACTIONS(7556),
    [sym_true] = ACTIONS(7556),
    [sym_false] = ACTIONS(7556),
    [sym_null] = ACTIONS(7556),
    [sym_inf] = ACTIONS(7556),
    [sym_nan] = ACTIONS(7556),
    [anon_sym_NA] = ACTIONS(7556),
    [anon_sym_NA_integer_] = ACTIONS(7556),
    [anon_sym_NA_real_] = ACTIONS(7556),
    [anon_sym_NA_complex_] = ACTIONS(7556),
    [anon_sym_NA_character_] = ACTIONS(7556),
    [sym_dots] = ACTIONS(7556),
    [sym_dot_dot_i] = ACTIONS(7554),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7554),
    [sym__newline] = ACTIONS(7554),
    [sym__raw_string_literal] = ACTIONS(7554),
    [sym__external_else] = ACTIONS(7554),
    [sym__external_open_parenthesis] = ACTIONS(7554),
    [sym__external_close_parenthesis] = ACTIONS(7554),
    [sym__external_open_brace] = ACTIONS(7554),
    [sym__external_open_bracket] = ACTIONS(7554),
    [sym__external_close_bracket] = ACTIONS(7554),
    [sym__external_open_bracket2] = ACTIONS(7554),
  },
  [2578] = {
    [sym_identifier] = ACTIONS(7121),
    [anon_sym_BSLASH] = ACTIONS(7123),
    [anon_sym_function] = ACTIONS(7121),
    [anon_sym_EQ] = ACTIONS(7121),
    [anon_sym_if] = ACTIONS(7121),
    [anon_sym_for] = ACTIONS(7121),
    [anon_sym_while] = ACTIONS(7121),
    [anon_sym_repeat] = ACTIONS(7121),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_TILDE] = ACTIONS(7123),
    [anon_sym_BANG] = ACTIONS(7121),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_DASH] = ACTIONS(7121),
    [anon_sym_LT_DASH] = ACTIONS(7123),
    [anon_sym_LT_LT_DASH] = ACTIONS(7123),
    [anon_sym_COLON_EQ] = ACTIONS(7123),
    [anon_sym_DASH_GT] = ACTIONS(7121),
    [anon_sym_DASH_GT_GT] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_LT_EQ] = ACTIONS(7123),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
    [aux_sym_binary_operator_token1] = ACTIONS(7123),
    [anon_sym_PIPE_GT] = ACTIONS(7123),
    [anon_sym_COLON] = ACTIONS(7121),
    [anon_sym_DOLLAR] = ACTIONS(7123),
    [anon_sym_AT] = ACTIONS(7123),
    [anon_sym_L] = ACTIONS(7652),
    [anon_sym_i] = ACTIONS(7654),
    [aux_sym__hex_literal_token1] = ACTIONS(7123),
    [sym__number_literal] = ACTIONS(7121),
    [anon_sym_SQUOTE] = ACTIONS(7123),
    [anon_sym_DQUOTE] = ACTIONS(7123),
    [sym_return] = ACTIONS(7121),
    [sym_next] = ACTIONS(7121),
    [sym_break] = ACTIONS(7121),
    [sym_true] = ACTIONS(7121),
    [sym_false] = ACTIONS(7121),
    [sym_null] = ACTIONS(7121),
    [sym_inf] = ACTIONS(7121),
    [sym_nan] = ACTIONS(7121),
    [anon_sym_NA] = ACTIONS(7121),
    [anon_sym_NA_integer_] = ACTIONS(7121),
    [anon_sym_NA_real_] = ACTIONS(7121),
    [anon_sym_NA_complex_] = ACTIONS(7121),
    [anon_sym_NA_character_] = ACTIONS(7121),
    [sym_dots] = ACTIONS(7121),
    [sym_dot_dot_i] = ACTIONS(7123),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7123),
    [sym__newline] = ACTIONS(7123),
    [sym__raw_string_literal] = ACTIONS(7123),
    [sym__external_open_parenthesis] = ACTIONS(7123),
    [sym__external_close_parenthesis] = ACTIONS(7123),
    [sym__external_open_brace] = ACTIONS(7123),
    [sym__external_open_bracket] = ACTIONS(7123),
    [sym__external_open_bracket2] = ACTIONS(7123),
  },
  [2579] = {
    [ts_builtin_sym_end] = ACTIONS(7514),
    [sym_identifier] = ACTIONS(7516),
    [anon_sym_BSLASH] = ACTIONS(7514),
    [anon_sym_function] = ACTIONS(7516),
    [anon_sym_EQ] = ACTIONS(7516),
    [anon_sym_if] = ACTIONS(7516),
    [anon_sym_for] = ACTIONS(7516),
    [anon_sym_while] = ACTIONS(7516),
    [anon_sym_repeat] = ACTIONS(7516),
    [anon_sym_QMARK] = ACTIONS(7514),
    [anon_sym_TILDE] = ACTIONS(7514),
    [anon_sym_BANG] = ACTIONS(7516),
    [anon_sym_PLUS] = ACTIONS(7514),
    [anon_sym_DASH] = ACTIONS(7516),
    [anon_sym_LT_DASH] = ACTIONS(7514),
    [anon_sym_LT_LT_DASH] = ACTIONS(7514),
    [anon_sym_COLON_EQ] = ACTIONS(7514),
    [anon_sym_DASH_GT] = ACTIONS(7516),
    [anon_sym_DASH_GT_GT] = ACTIONS(7514),
    [anon_sym_PIPE] = ACTIONS(7516),
    [anon_sym_AMP] = ACTIONS(7516),
    [anon_sym_PIPE_PIPE] = ACTIONS(7514),
    [anon_sym_AMP_AMP] = ACTIONS(7514),
    [anon_sym_LT] = ACTIONS(7516),
    [anon_sym_LT_EQ] = ACTIONS(7514),
    [anon_sym_GT] = ACTIONS(7516),
    [anon_sym_GT_EQ] = ACTIONS(7514),
    [anon_sym_EQ_EQ] = ACTIONS(7514),
    [anon_sym_BANG_EQ] = ACTIONS(7514),
    [anon_sym_STAR] = ACTIONS(7516),
    [anon_sym_SLASH] = ACTIONS(7514),
    [anon_sym_STAR_STAR] = ACTIONS(7514),
    [anon_sym_CARET] = ACTIONS(7514),
    [aux_sym_binary_operator_token1] = ACTIONS(7514),
    [anon_sym_PIPE_GT] = ACTIONS(7514),
    [anon_sym_COLON] = ACTIONS(7516),
    [anon_sym_DOLLAR] = ACTIONS(7514),
    [anon_sym_AT] = ACTIONS(7514),
    [aux_sym__hex_literal_token1] = ACTIONS(7514),
    [sym__number_literal] = ACTIONS(7516),
    [anon_sym_SQUOTE] = ACTIONS(7514),
    [anon_sym_DQUOTE] = ACTIONS(7514),
    [sym_return] = ACTIONS(7516),
    [sym_next] = ACTIONS(7516),
    [sym_break] = ACTIONS(7516),
    [sym_true] = ACTIONS(7516),
    [sym_false] = ACTIONS(7516),
    [sym_null] = ACTIONS(7516),
    [sym_inf] = ACTIONS(7516),
    [sym_nan] = ACTIONS(7516),
    [anon_sym_NA] = ACTIONS(7516),
    [anon_sym_NA_integer_] = ACTIONS(7516),
    [anon_sym_NA_real_] = ACTIONS(7516),
    [anon_sym_NA_complex_] = ACTIONS(7516),
    [anon_sym_NA_character_] = ACTIONS(7516),
    [sym_dots] = ACTIONS(7516),
    [sym_dot_dot_i] = ACTIONS(7514),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7514),
    [sym__semicolon] = ACTIONS(7514),
    [sym__raw_string_literal] = ACTIONS(7514),
    [sym__external_else] = ACTIONS(7514),
    [sym__external_open_parenthesis] = ACTIONS(7514),
    [sym__external_open_brace] = ACTIONS(7514),
    [sym__external_close_brace] = ACTIONS(7514),
    [sym__external_open_bracket] = ACTIONS(7514),
    [sym__external_open_bracket2] = ACTIONS(7514),
  },
  [2580] = {
    [sym_identifier] = ACTIONS(5325),
    [anon_sym_BSLASH] = ACTIONS(5327),
    [anon_sym_function] = ACTIONS(5325),
    [anon_sym_EQ] = ACTIONS(5325),
    [anon_sym_if] = ACTIONS(5325),
    [anon_sym_for] = ACTIONS(5325),
    [anon_sym_while] = ACTIONS(5325),
    [anon_sym_repeat] = ACTIONS(5325),
    [anon_sym_QMARK] = ACTIONS(5327),
    [anon_sym_TILDE] = ACTIONS(5327),
    [anon_sym_BANG] = ACTIONS(5325),
    [anon_sym_PLUS] = ACTIONS(5327),
    [anon_sym_DASH] = ACTIONS(5325),
    [anon_sym_LT_DASH] = ACTIONS(5327),
    [anon_sym_LT_LT_DASH] = ACTIONS(5327),
    [anon_sym_COLON_EQ] = ACTIONS(5327),
    [anon_sym_DASH_GT] = ACTIONS(5325),
    [anon_sym_DASH_GT_GT] = ACTIONS(5327),
    [anon_sym_PIPE] = ACTIONS(5325),
    [anon_sym_AMP] = ACTIONS(5325),
    [anon_sym_PIPE_PIPE] = ACTIONS(5327),
    [anon_sym_AMP_AMP] = ACTIONS(5327),
    [anon_sym_LT] = ACTIONS(5325),
    [anon_sym_LT_EQ] = ACTIONS(5327),
    [anon_sym_GT] = ACTIONS(5325),
    [anon_sym_GT_EQ] = ACTIONS(5327),
    [anon_sym_EQ_EQ] = ACTIONS(5327),
    [anon_sym_BANG_EQ] = ACTIONS(5327),
    [anon_sym_STAR] = ACTIONS(5325),
    [anon_sym_SLASH] = ACTIONS(5327),
    [anon_sym_STAR_STAR] = ACTIONS(5327),
    [anon_sym_CARET] = ACTIONS(5327),
    [aux_sym_binary_operator_token1] = ACTIONS(5327),
    [anon_sym_PIPE_GT] = ACTIONS(5327),
    [anon_sym_COLON] = ACTIONS(5325),
    [anon_sym_DOLLAR] = ACTIONS(5327),
    [anon_sym_AT] = ACTIONS(5327),
    [aux_sym__hex_literal_token1] = ACTIONS(5327),
    [sym__number_literal] = ACTIONS(5325),
    [anon_sym_SQUOTE] = ACTIONS(5327),
    [anon_sym_DQUOTE] = ACTIONS(5327),
    [sym_return] = ACTIONS(5325),
    [sym_next] = ACTIONS(5325),
    [sym_break] = ACTIONS(5325),
    [sym_true] = ACTIONS(5325),
    [sym_false] = ACTIONS(5325),
    [sym_null] = ACTIONS(5325),
    [sym_inf] = ACTIONS(5325),
    [sym_nan] = ACTIONS(5325),
    [anon_sym_NA] = ACTIONS(5325),
    [anon_sym_NA_integer_] = ACTIONS(5325),
    [anon_sym_NA_real_] = ACTIONS(5325),
    [anon_sym_NA_complex_] = ACTIONS(5325),
    [anon_sym_NA_character_] = ACTIONS(5325),
    [sym_dots] = ACTIONS(5325),
    [sym_dot_dot_i] = ACTIONS(5327),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5327),
    [sym__newline] = ACTIONS(5327),
    [sym__semicolon] = ACTIONS(5327),
    [sym__raw_string_literal] = ACTIONS(5327),
    [sym__external_open_parenthesis] = ACTIONS(5327),
    [sym__external_open_brace] = ACTIONS(5327),
    [sym__external_close_brace] = ACTIONS(5327),
    [sym__external_open_bracket] = ACTIONS(5327),
    [sym__external_open_bracket2] = ACTIONS(5327),
    [sym__external_close_bracket2] = ACTIONS(5327),
  },
  [2581] = {
    [ts_builtin_sym_end] = ACTIONS(7518),
    [sym_identifier] = ACTIONS(7520),
    [anon_sym_BSLASH] = ACTIONS(7518),
    [anon_sym_function] = ACTIONS(7520),
    [anon_sym_EQ] = ACTIONS(7520),
    [anon_sym_if] = ACTIONS(7520),
    [anon_sym_for] = ACTIONS(7520),
    [anon_sym_while] = ACTIONS(7520),
    [anon_sym_repeat] = ACTIONS(7520),
    [anon_sym_QMARK] = ACTIONS(7518),
    [anon_sym_TILDE] = ACTIONS(7518),
    [anon_sym_BANG] = ACTIONS(7520),
    [anon_sym_PLUS] = ACTIONS(7518),
    [anon_sym_DASH] = ACTIONS(7520),
    [anon_sym_LT_DASH] = ACTIONS(7518),
    [anon_sym_LT_LT_DASH] = ACTIONS(7518),
    [anon_sym_COLON_EQ] = ACTIONS(7518),
    [anon_sym_DASH_GT] = ACTIONS(7520),
    [anon_sym_DASH_GT_GT] = ACTIONS(7518),
    [anon_sym_PIPE] = ACTIONS(7520),
    [anon_sym_AMP] = ACTIONS(7520),
    [anon_sym_PIPE_PIPE] = ACTIONS(7518),
    [anon_sym_AMP_AMP] = ACTIONS(7518),
    [anon_sym_LT] = ACTIONS(7520),
    [anon_sym_LT_EQ] = ACTIONS(7518),
    [anon_sym_GT] = ACTIONS(7520),
    [anon_sym_GT_EQ] = ACTIONS(7518),
    [anon_sym_EQ_EQ] = ACTIONS(7518),
    [anon_sym_BANG_EQ] = ACTIONS(7518),
    [anon_sym_STAR] = ACTIONS(7520),
    [anon_sym_SLASH] = ACTIONS(7518),
    [anon_sym_STAR_STAR] = ACTIONS(7518),
    [anon_sym_CARET] = ACTIONS(7518),
    [aux_sym_binary_operator_token1] = ACTIONS(7518),
    [anon_sym_PIPE_GT] = ACTIONS(7518),
    [anon_sym_COLON] = ACTIONS(7520),
    [anon_sym_DOLLAR] = ACTIONS(7518),
    [anon_sym_AT] = ACTIONS(7518),
    [aux_sym__hex_literal_token1] = ACTIONS(7518),
    [sym__number_literal] = ACTIONS(7520),
    [anon_sym_SQUOTE] = ACTIONS(7518),
    [anon_sym_DQUOTE] = ACTIONS(7518),
    [sym_return] = ACTIONS(7520),
    [sym_next] = ACTIONS(7520),
    [sym_break] = ACTIONS(7520),
    [sym_true] = ACTIONS(7520),
    [sym_false] = ACTIONS(7520),
    [sym_null] = ACTIONS(7520),
    [sym_inf] = ACTIONS(7520),
    [sym_nan] = ACTIONS(7520),
    [anon_sym_NA] = ACTIONS(7520),
    [anon_sym_NA_integer_] = ACTIONS(7520),
    [anon_sym_NA_real_] = ACTIONS(7520),
    [anon_sym_NA_complex_] = ACTIONS(7520),
    [anon_sym_NA_character_] = ACTIONS(7520),
    [sym_dots] = ACTIONS(7520),
    [sym_dot_dot_i] = ACTIONS(7518),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7518),
    [sym__semicolon] = ACTIONS(7518),
    [sym__raw_string_literal] = ACTIONS(7518),
    [sym__external_else] = ACTIONS(7518),
    [sym__external_open_parenthesis] = ACTIONS(7518),
    [sym__external_open_brace] = ACTIONS(7518),
    [sym__external_close_brace] = ACTIONS(7518),
    [sym__external_open_bracket] = ACTIONS(7518),
    [sym__external_open_bracket2] = ACTIONS(7518),
  },
  [2582] = {
    [ts_builtin_sym_end] = ACTIONS(7510),
    [sym_identifier] = ACTIONS(7512),
    [anon_sym_BSLASH] = ACTIONS(7510),
    [anon_sym_function] = ACTIONS(7512),
    [anon_sym_EQ] = ACTIONS(7512),
    [anon_sym_if] = ACTIONS(7512),
    [anon_sym_for] = ACTIONS(7512),
    [anon_sym_while] = ACTIONS(7512),
    [anon_sym_repeat] = ACTIONS(7512),
    [anon_sym_QMARK] = ACTIONS(7510),
    [anon_sym_TILDE] = ACTIONS(7510),
    [anon_sym_BANG] = ACTIONS(7512),
    [anon_sym_PLUS] = ACTIONS(7510),
    [anon_sym_DASH] = ACTIONS(7512),
    [anon_sym_LT_DASH] = ACTIONS(7510),
    [anon_sym_LT_LT_DASH] = ACTIONS(7510),
    [anon_sym_COLON_EQ] = ACTIONS(7510),
    [anon_sym_DASH_GT] = ACTIONS(7512),
    [anon_sym_DASH_GT_GT] = ACTIONS(7510),
    [anon_sym_PIPE] = ACTIONS(7512),
    [anon_sym_AMP] = ACTIONS(7512),
    [anon_sym_PIPE_PIPE] = ACTIONS(7510),
    [anon_sym_AMP_AMP] = ACTIONS(7510),
    [anon_sym_LT] = ACTIONS(7512),
    [anon_sym_LT_EQ] = ACTIONS(7510),
    [anon_sym_GT] = ACTIONS(7512),
    [anon_sym_GT_EQ] = ACTIONS(7510),
    [anon_sym_EQ_EQ] = ACTIONS(7510),
    [anon_sym_BANG_EQ] = ACTIONS(7510),
    [anon_sym_STAR] = ACTIONS(7512),
    [anon_sym_SLASH] = ACTIONS(7510),
    [anon_sym_STAR_STAR] = ACTIONS(7510),
    [anon_sym_CARET] = ACTIONS(7510),
    [aux_sym_binary_operator_token1] = ACTIONS(7510),
    [anon_sym_PIPE_GT] = ACTIONS(7510),
    [anon_sym_COLON] = ACTIONS(7512),
    [anon_sym_DOLLAR] = ACTIONS(7510),
    [anon_sym_AT] = ACTIONS(7510),
    [aux_sym__hex_literal_token1] = ACTIONS(7510),
    [sym__number_literal] = ACTIONS(7512),
    [anon_sym_SQUOTE] = ACTIONS(7510),
    [anon_sym_DQUOTE] = ACTIONS(7510),
    [sym_return] = ACTIONS(7512),
    [sym_next] = ACTIONS(7512),
    [sym_break] = ACTIONS(7512),
    [sym_true] = ACTIONS(7512),
    [sym_false] = ACTIONS(7512),
    [sym_null] = ACTIONS(7512),
    [sym_inf] = ACTIONS(7512),
    [sym_nan] = ACTIONS(7512),
    [anon_sym_NA] = ACTIONS(7512),
    [anon_sym_NA_integer_] = ACTIONS(7512),
    [anon_sym_NA_real_] = ACTIONS(7512),
    [anon_sym_NA_complex_] = ACTIONS(7512),
    [anon_sym_NA_character_] = ACTIONS(7512),
    [sym_dots] = ACTIONS(7512),
    [sym_dot_dot_i] = ACTIONS(7510),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7510),
    [sym__semicolon] = ACTIONS(7510),
    [sym__raw_string_literal] = ACTIONS(7510),
    [sym__external_else] = ACTIONS(7510),
    [sym__external_open_parenthesis] = ACTIONS(7510),
    [sym__external_open_brace] = ACTIONS(7510),
    [sym__external_close_brace] = ACTIONS(7510),
    [sym__external_open_bracket] = ACTIONS(7510),
    [sym__external_open_bracket2] = ACTIONS(7510),
  },
  [2583] = {
    [sym_identifier] = ACTIONS(7567),
    [anon_sym_BSLASH] = ACTIONS(7565),
    [anon_sym_function] = ACTIONS(7567),
    [anon_sym_EQ] = ACTIONS(7567),
    [anon_sym_if] = ACTIONS(7567),
    [anon_sym_for] = ACTIONS(7567),
    [anon_sym_while] = ACTIONS(7567),
    [anon_sym_repeat] = ACTIONS(7567),
    [anon_sym_QMARK] = ACTIONS(7565),
    [anon_sym_TILDE] = ACTIONS(7565),
    [anon_sym_BANG] = ACTIONS(7567),
    [anon_sym_PLUS] = ACTIONS(7565),
    [anon_sym_DASH] = ACTIONS(7567),
    [anon_sym_LT_DASH] = ACTIONS(7565),
    [anon_sym_LT_LT_DASH] = ACTIONS(7565),
    [anon_sym_COLON_EQ] = ACTIONS(7565),
    [anon_sym_DASH_GT] = ACTIONS(7567),
    [anon_sym_DASH_GT_GT] = ACTIONS(7565),
    [anon_sym_PIPE] = ACTIONS(7567),
    [anon_sym_AMP] = ACTIONS(7567),
    [anon_sym_PIPE_PIPE] = ACTIONS(7565),
    [anon_sym_AMP_AMP] = ACTIONS(7565),
    [anon_sym_LT] = ACTIONS(7567),
    [anon_sym_LT_EQ] = ACTIONS(7565),
    [anon_sym_GT] = ACTIONS(7567),
    [anon_sym_GT_EQ] = ACTIONS(7565),
    [anon_sym_EQ_EQ] = ACTIONS(7565),
    [anon_sym_BANG_EQ] = ACTIONS(7565),
    [anon_sym_STAR] = ACTIONS(7567),
    [anon_sym_SLASH] = ACTIONS(7565),
    [anon_sym_STAR_STAR] = ACTIONS(7565),
    [anon_sym_CARET] = ACTIONS(7565),
    [aux_sym_binary_operator_token1] = ACTIONS(7565),
    [anon_sym_PIPE_GT] = ACTIONS(7565),
    [anon_sym_COLON] = ACTIONS(7567),
    [anon_sym_DOLLAR] = ACTIONS(7565),
    [anon_sym_AT] = ACTIONS(7565),
    [aux_sym__hex_literal_token1] = ACTIONS(7565),
    [sym__number_literal] = ACTIONS(7567),
    [anon_sym_SQUOTE] = ACTIONS(7565),
    [anon_sym_DQUOTE] = ACTIONS(7565),
    [sym_return] = ACTIONS(7567),
    [sym_next] = ACTIONS(7567),
    [sym_break] = ACTIONS(7567),
    [sym_true] = ACTIONS(7567),
    [sym_false] = ACTIONS(7567),
    [sym_null] = ACTIONS(7567),
    [sym_inf] = ACTIONS(7567),
    [sym_nan] = ACTIONS(7567),
    [anon_sym_NA] = ACTIONS(7567),
    [anon_sym_NA_integer_] = ACTIONS(7567),
    [anon_sym_NA_real_] = ACTIONS(7567),
    [anon_sym_NA_complex_] = ACTIONS(7567),
    [anon_sym_NA_character_] = ACTIONS(7567),
    [sym_dots] = ACTIONS(7567),
    [sym_dot_dot_i] = ACTIONS(7565),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7565),
    [sym__newline] = ACTIONS(7565),
    [sym__semicolon] = ACTIONS(7565),
    [sym__raw_string_literal] = ACTIONS(7565),
    [sym__external_open_parenthesis] = ACTIONS(7565),
    [sym__external_open_brace] = ACTIONS(7565),
    [sym__external_close_brace] = ACTIONS(7565),
    [sym__external_open_bracket] = ACTIONS(7565),
    [sym__external_open_bracket2] = ACTIONS(7565),
    [sym__external_close_bracket2] = ACTIONS(7565),
  },
  [2584] = {
    [ts_builtin_sym_end] = ACTIONS(7504),
    [sym_identifier] = ACTIONS(7506),
    [anon_sym_BSLASH] = ACTIONS(7504),
    [anon_sym_function] = ACTIONS(7506),
    [anon_sym_EQ] = ACTIONS(7506),
    [anon_sym_if] = ACTIONS(7506),
    [anon_sym_for] = ACTIONS(7506),
    [anon_sym_while] = ACTIONS(7506),
    [anon_sym_repeat] = ACTIONS(7506),
    [anon_sym_QMARK] = ACTIONS(7504),
    [anon_sym_TILDE] = ACTIONS(7504),
    [anon_sym_BANG] = ACTIONS(7506),
    [anon_sym_PLUS] = ACTIONS(7504),
    [anon_sym_DASH] = ACTIONS(7506),
    [anon_sym_LT_DASH] = ACTIONS(7504),
    [anon_sym_LT_LT_DASH] = ACTIONS(7504),
    [anon_sym_COLON_EQ] = ACTIONS(7504),
    [anon_sym_DASH_GT] = ACTIONS(7506),
    [anon_sym_DASH_GT_GT] = ACTIONS(7504),
    [anon_sym_PIPE] = ACTIONS(7506),
    [anon_sym_AMP] = ACTIONS(7506),
    [anon_sym_PIPE_PIPE] = ACTIONS(7504),
    [anon_sym_AMP_AMP] = ACTIONS(7504),
    [anon_sym_LT] = ACTIONS(7506),
    [anon_sym_LT_EQ] = ACTIONS(7504),
    [anon_sym_GT] = ACTIONS(7506),
    [anon_sym_GT_EQ] = ACTIONS(7504),
    [anon_sym_EQ_EQ] = ACTIONS(7504),
    [anon_sym_BANG_EQ] = ACTIONS(7504),
    [anon_sym_STAR] = ACTIONS(7506),
    [anon_sym_SLASH] = ACTIONS(7504),
    [anon_sym_STAR_STAR] = ACTIONS(7504),
    [anon_sym_CARET] = ACTIONS(7504),
    [aux_sym_binary_operator_token1] = ACTIONS(7504),
    [anon_sym_PIPE_GT] = ACTIONS(7504),
    [anon_sym_COLON] = ACTIONS(7506),
    [anon_sym_DOLLAR] = ACTIONS(7504),
    [anon_sym_AT] = ACTIONS(7504),
    [aux_sym__hex_literal_token1] = ACTIONS(7504),
    [sym__number_literal] = ACTIONS(7506),
    [anon_sym_SQUOTE] = ACTIONS(7504),
    [anon_sym_DQUOTE] = ACTIONS(7504),
    [sym_return] = ACTIONS(7506),
    [sym_next] = ACTIONS(7506),
    [sym_break] = ACTIONS(7506),
    [sym_true] = ACTIONS(7506),
    [sym_false] = ACTIONS(7506),
    [sym_null] = ACTIONS(7506),
    [sym_inf] = ACTIONS(7506),
    [sym_nan] = ACTIONS(7506),
    [anon_sym_NA] = ACTIONS(7506),
    [anon_sym_NA_integer_] = ACTIONS(7506),
    [anon_sym_NA_real_] = ACTIONS(7506),
    [anon_sym_NA_complex_] = ACTIONS(7506),
    [anon_sym_NA_character_] = ACTIONS(7506),
    [sym_dots] = ACTIONS(7506),
    [sym_dot_dot_i] = ACTIONS(7504),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7504),
    [sym__semicolon] = ACTIONS(7504),
    [sym__raw_string_literal] = ACTIONS(7504),
    [sym__external_else] = ACTIONS(7504),
    [sym__external_open_parenthesis] = ACTIONS(7504),
    [sym__external_open_brace] = ACTIONS(7504),
    [sym__external_close_brace] = ACTIONS(7504),
    [sym__external_open_bracket] = ACTIONS(7504),
    [sym__external_open_bracket2] = ACTIONS(7504),
  },
  [2585] = {
    [ts_builtin_sym_end] = ACTIONS(7500),
    [sym_identifier] = ACTIONS(7502),
    [anon_sym_BSLASH] = ACTIONS(7500),
    [anon_sym_function] = ACTIONS(7502),
    [anon_sym_EQ] = ACTIONS(7502),
    [anon_sym_if] = ACTIONS(7502),
    [anon_sym_for] = ACTIONS(7502),
    [anon_sym_while] = ACTIONS(7502),
    [anon_sym_repeat] = ACTIONS(7502),
    [anon_sym_QMARK] = ACTIONS(7500),
    [anon_sym_TILDE] = ACTIONS(7500),
    [anon_sym_BANG] = ACTIONS(7502),
    [anon_sym_PLUS] = ACTIONS(7500),
    [anon_sym_DASH] = ACTIONS(7502),
    [anon_sym_LT_DASH] = ACTIONS(7500),
    [anon_sym_LT_LT_DASH] = ACTIONS(7500),
    [anon_sym_COLON_EQ] = ACTIONS(7500),
    [anon_sym_DASH_GT] = ACTIONS(7502),
    [anon_sym_DASH_GT_GT] = ACTIONS(7500),
    [anon_sym_PIPE] = ACTIONS(7502),
    [anon_sym_AMP] = ACTIONS(7502),
    [anon_sym_PIPE_PIPE] = ACTIONS(7500),
    [anon_sym_AMP_AMP] = ACTIONS(7500),
    [anon_sym_LT] = ACTIONS(7502),
    [anon_sym_LT_EQ] = ACTIONS(7500),
    [anon_sym_GT] = ACTIONS(7502),
    [anon_sym_GT_EQ] = ACTIONS(7500),
    [anon_sym_EQ_EQ] = ACTIONS(7500),
    [anon_sym_BANG_EQ] = ACTIONS(7500),
    [anon_sym_STAR] = ACTIONS(7502),
    [anon_sym_SLASH] = ACTIONS(7500),
    [anon_sym_STAR_STAR] = ACTIONS(7500),
    [anon_sym_CARET] = ACTIONS(7500),
    [aux_sym_binary_operator_token1] = ACTIONS(7500),
    [anon_sym_PIPE_GT] = ACTIONS(7500),
    [anon_sym_COLON] = ACTIONS(7502),
    [anon_sym_DOLLAR] = ACTIONS(7500),
    [anon_sym_AT] = ACTIONS(7500),
    [aux_sym__hex_literal_token1] = ACTIONS(7500),
    [sym__number_literal] = ACTIONS(7502),
    [anon_sym_SQUOTE] = ACTIONS(7500),
    [anon_sym_DQUOTE] = ACTIONS(7500),
    [sym_return] = ACTIONS(7502),
    [sym_next] = ACTIONS(7502),
    [sym_break] = ACTIONS(7502),
    [sym_true] = ACTIONS(7502),
    [sym_false] = ACTIONS(7502),
    [sym_null] = ACTIONS(7502),
    [sym_inf] = ACTIONS(7502),
    [sym_nan] = ACTIONS(7502),
    [anon_sym_NA] = ACTIONS(7502),
    [anon_sym_NA_integer_] = ACTIONS(7502),
    [anon_sym_NA_real_] = ACTIONS(7502),
    [anon_sym_NA_complex_] = ACTIONS(7502),
    [anon_sym_NA_character_] = ACTIONS(7502),
    [sym_dots] = ACTIONS(7502),
    [sym_dot_dot_i] = ACTIONS(7500),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7500),
    [sym__semicolon] = ACTIONS(7500),
    [sym__raw_string_literal] = ACTIONS(7500),
    [sym__external_else] = ACTIONS(7500),
    [sym__external_open_parenthesis] = ACTIONS(7500),
    [sym__external_open_brace] = ACTIONS(7500),
    [sym__external_close_brace] = ACTIONS(7500),
    [sym__external_open_bracket] = ACTIONS(7500),
    [sym__external_open_bracket2] = ACTIONS(7500),
  },
  [2586] = {
    [sym_identifier] = ACTIONS(7544),
    [anon_sym_BSLASH] = ACTIONS(7542),
    [anon_sym_function] = ACTIONS(7544),
    [anon_sym_EQ] = ACTIONS(7544),
    [anon_sym_if] = ACTIONS(7544),
    [anon_sym_for] = ACTIONS(7544),
    [anon_sym_while] = ACTIONS(7544),
    [anon_sym_repeat] = ACTIONS(7544),
    [anon_sym_QMARK] = ACTIONS(7542),
    [anon_sym_TILDE] = ACTIONS(7542),
    [anon_sym_BANG] = ACTIONS(7544),
    [anon_sym_PLUS] = ACTIONS(7542),
    [anon_sym_DASH] = ACTIONS(7544),
    [anon_sym_LT_DASH] = ACTIONS(7542),
    [anon_sym_LT_LT_DASH] = ACTIONS(7542),
    [anon_sym_COLON_EQ] = ACTIONS(7542),
    [anon_sym_DASH_GT] = ACTIONS(7544),
    [anon_sym_DASH_GT_GT] = ACTIONS(7542),
    [anon_sym_PIPE] = ACTIONS(7544),
    [anon_sym_AMP] = ACTIONS(7544),
    [anon_sym_PIPE_PIPE] = ACTIONS(7542),
    [anon_sym_AMP_AMP] = ACTIONS(7542),
    [anon_sym_LT] = ACTIONS(7544),
    [anon_sym_LT_EQ] = ACTIONS(7542),
    [anon_sym_GT] = ACTIONS(7544),
    [anon_sym_GT_EQ] = ACTIONS(7542),
    [anon_sym_EQ_EQ] = ACTIONS(7542),
    [anon_sym_BANG_EQ] = ACTIONS(7542),
    [anon_sym_STAR] = ACTIONS(7544),
    [anon_sym_SLASH] = ACTIONS(7542),
    [anon_sym_STAR_STAR] = ACTIONS(7542),
    [anon_sym_CARET] = ACTIONS(7542),
    [aux_sym_binary_operator_token1] = ACTIONS(7542),
    [anon_sym_PIPE_GT] = ACTIONS(7542),
    [anon_sym_COLON] = ACTIONS(7544),
    [anon_sym_DOLLAR] = ACTIONS(7542),
    [anon_sym_AT] = ACTIONS(7542),
    [aux_sym__hex_literal_token1] = ACTIONS(7542),
    [sym__number_literal] = ACTIONS(7544),
    [anon_sym_SQUOTE] = ACTIONS(7542),
    [anon_sym_DQUOTE] = ACTIONS(7542),
    [sym_return] = ACTIONS(7544),
    [sym_next] = ACTIONS(7544),
    [sym_break] = ACTIONS(7544),
    [sym_true] = ACTIONS(7544),
    [sym_false] = ACTIONS(7544),
    [sym_null] = ACTIONS(7544),
    [sym_inf] = ACTIONS(7544),
    [sym_nan] = ACTIONS(7544),
    [anon_sym_NA] = ACTIONS(7544),
    [anon_sym_NA_integer_] = ACTIONS(7544),
    [anon_sym_NA_real_] = ACTIONS(7544),
    [anon_sym_NA_complex_] = ACTIONS(7544),
    [anon_sym_NA_character_] = ACTIONS(7544),
    [sym_dots] = ACTIONS(7544),
    [sym_dot_dot_i] = ACTIONS(7542),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7542),
    [sym__newline] = ACTIONS(7542),
    [sym__semicolon] = ACTIONS(7542),
    [sym__raw_string_literal] = ACTIONS(7542),
    [sym__external_open_parenthesis] = ACTIONS(7542),
    [sym__external_open_brace] = ACTIONS(7542),
    [sym__external_close_brace] = ACTIONS(7542),
    [sym__external_open_bracket] = ACTIONS(7542),
    [sym__external_open_bracket2] = ACTIONS(7542),
    [sym__external_close_bracket2] = ACTIONS(7542),
  },
  [2587] = {
    [ts_builtin_sym_end] = ACTIONS(7496),
    [sym_identifier] = ACTIONS(7498),
    [anon_sym_BSLASH] = ACTIONS(7496),
    [anon_sym_function] = ACTIONS(7498),
    [anon_sym_EQ] = ACTIONS(7498),
    [anon_sym_if] = ACTIONS(7498),
    [anon_sym_for] = ACTIONS(7498),
    [anon_sym_while] = ACTIONS(7498),
    [anon_sym_repeat] = ACTIONS(7498),
    [anon_sym_QMARK] = ACTIONS(7496),
    [anon_sym_TILDE] = ACTIONS(7496),
    [anon_sym_BANG] = ACTIONS(7498),
    [anon_sym_PLUS] = ACTIONS(7496),
    [anon_sym_DASH] = ACTIONS(7498),
    [anon_sym_LT_DASH] = ACTIONS(7496),
    [anon_sym_LT_LT_DASH] = ACTIONS(7496),
    [anon_sym_COLON_EQ] = ACTIONS(7496),
    [anon_sym_DASH_GT] = ACTIONS(7498),
    [anon_sym_DASH_GT_GT] = ACTIONS(7496),
    [anon_sym_PIPE] = ACTIONS(7498),
    [anon_sym_AMP] = ACTIONS(7498),
    [anon_sym_PIPE_PIPE] = ACTIONS(7496),
    [anon_sym_AMP_AMP] = ACTIONS(7496),
    [anon_sym_LT] = ACTIONS(7498),
    [anon_sym_LT_EQ] = ACTIONS(7496),
    [anon_sym_GT] = ACTIONS(7498),
    [anon_sym_GT_EQ] = ACTIONS(7496),
    [anon_sym_EQ_EQ] = ACTIONS(7496),
    [anon_sym_BANG_EQ] = ACTIONS(7496),
    [anon_sym_STAR] = ACTIONS(7498),
    [anon_sym_SLASH] = ACTIONS(7496),
    [anon_sym_STAR_STAR] = ACTIONS(7496),
    [anon_sym_CARET] = ACTIONS(7496),
    [aux_sym_binary_operator_token1] = ACTIONS(7496),
    [anon_sym_PIPE_GT] = ACTIONS(7496),
    [anon_sym_COLON] = ACTIONS(7498),
    [anon_sym_DOLLAR] = ACTIONS(7496),
    [anon_sym_AT] = ACTIONS(7496),
    [aux_sym__hex_literal_token1] = ACTIONS(7496),
    [sym__number_literal] = ACTIONS(7498),
    [anon_sym_SQUOTE] = ACTIONS(7496),
    [anon_sym_DQUOTE] = ACTIONS(7496),
    [sym_return] = ACTIONS(7498),
    [sym_next] = ACTIONS(7498),
    [sym_break] = ACTIONS(7498),
    [sym_true] = ACTIONS(7498),
    [sym_false] = ACTIONS(7498),
    [sym_null] = ACTIONS(7498),
    [sym_inf] = ACTIONS(7498),
    [sym_nan] = ACTIONS(7498),
    [anon_sym_NA] = ACTIONS(7498),
    [anon_sym_NA_integer_] = ACTIONS(7498),
    [anon_sym_NA_real_] = ACTIONS(7498),
    [anon_sym_NA_complex_] = ACTIONS(7498),
    [anon_sym_NA_character_] = ACTIONS(7498),
    [sym_dots] = ACTIONS(7498),
    [sym_dot_dot_i] = ACTIONS(7496),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7496),
    [sym__semicolon] = ACTIONS(7496),
    [sym__raw_string_literal] = ACTIONS(7496),
    [sym__external_else] = ACTIONS(7496),
    [sym__external_open_parenthesis] = ACTIONS(7496),
    [sym__external_open_brace] = ACTIONS(7496),
    [sym__external_close_brace] = ACTIONS(7496),
    [sym__external_open_bracket] = ACTIONS(7496),
    [sym__external_open_bracket2] = ACTIONS(7496),
  },
  [2588] = {
    [sym_identifier] = ACTIONS(7486),
    [anon_sym_BSLASH] = ACTIONS(7484),
    [anon_sym_function] = ACTIONS(7486),
    [anon_sym_EQ] = ACTIONS(7486),
    [anon_sym_if] = ACTIONS(7486),
    [anon_sym_for] = ACTIONS(7486),
    [anon_sym_while] = ACTIONS(7486),
    [anon_sym_repeat] = ACTIONS(7486),
    [anon_sym_QMARK] = ACTIONS(7484),
    [anon_sym_TILDE] = ACTIONS(7484),
    [anon_sym_BANG] = ACTIONS(7486),
    [anon_sym_PLUS] = ACTIONS(7484),
    [anon_sym_DASH] = ACTIONS(7486),
    [anon_sym_LT_DASH] = ACTIONS(7484),
    [anon_sym_LT_LT_DASH] = ACTIONS(7484),
    [anon_sym_COLON_EQ] = ACTIONS(7484),
    [anon_sym_DASH_GT] = ACTIONS(7486),
    [anon_sym_DASH_GT_GT] = ACTIONS(7484),
    [anon_sym_PIPE] = ACTIONS(7486),
    [anon_sym_AMP] = ACTIONS(7486),
    [anon_sym_PIPE_PIPE] = ACTIONS(7484),
    [anon_sym_AMP_AMP] = ACTIONS(7484),
    [anon_sym_LT] = ACTIONS(7486),
    [anon_sym_LT_EQ] = ACTIONS(7484),
    [anon_sym_GT] = ACTIONS(7486),
    [anon_sym_GT_EQ] = ACTIONS(7484),
    [anon_sym_EQ_EQ] = ACTIONS(7484),
    [anon_sym_BANG_EQ] = ACTIONS(7484),
    [anon_sym_STAR] = ACTIONS(7486),
    [anon_sym_SLASH] = ACTIONS(7484),
    [anon_sym_STAR_STAR] = ACTIONS(7484),
    [anon_sym_CARET] = ACTIONS(7484),
    [aux_sym_binary_operator_token1] = ACTIONS(7484),
    [anon_sym_PIPE_GT] = ACTIONS(7484),
    [anon_sym_COLON] = ACTIONS(7486),
    [anon_sym_DOLLAR] = ACTIONS(7484),
    [anon_sym_AT] = ACTIONS(7484),
    [aux_sym__hex_literal_token1] = ACTIONS(7484),
    [sym__number_literal] = ACTIONS(7486),
    [anon_sym_SQUOTE] = ACTIONS(7484),
    [anon_sym_DQUOTE] = ACTIONS(7484),
    [sym_return] = ACTIONS(7486),
    [sym_next] = ACTIONS(7486),
    [sym_break] = ACTIONS(7486),
    [sym_true] = ACTIONS(7486),
    [sym_false] = ACTIONS(7486),
    [sym_null] = ACTIONS(7486),
    [sym_inf] = ACTIONS(7486),
    [sym_nan] = ACTIONS(7486),
    [anon_sym_NA] = ACTIONS(7486),
    [anon_sym_NA_integer_] = ACTIONS(7486),
    [anon_sym_NA_real_] = ACTIONS(7486),
    [anon_sym_NA_complex_] = ACTIONS(7486),
    [anon_sym_NA_character_] = ACTIONS(7486),
    [sym_dots] = ACTIONS(7486),
    [sym_dot_dot_i] = ACTIONS(7484),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7484),
    [sym__newline] = ACTIONS(7484),
    [sym__semicolon] = ACTIONS(7484),
    [sym__raw_string_literal] = ACTIONS(7484),
    [sym__external_open_parenthesis] = ACTIONS(7484),
    [sym__external_open_brace] = ACTIONS(7484),
    [sym__external_close_brace] = ACTIONS(7484),
    [sym__external_open_bracket] = ACTIONS(7484),
    [sym__external_close_bracket] = ACTIONS(7484),
    [sym__external_open_bracket2] = ACTIONS(7484),
  },
  [2589] = {
    [ts_builtin_sym_end] = ACTIONS(7492),
    [sym_identifier] = ACTIONS(7494),
    [anon_sym_BSLASH] = ACTIONS(7492),
    [anon_sym_function] = ACTIONS(7494),
    [anon_sym_EQ] = ACTIONS(7494),
    [anon_sym_if] = ACTIONS(7494),
    [anon_sym_for] = ACTIONS(7494),
    [anon_sym_while] = ACTIONS(7494),
    [anon_sym_repeat] = ACTIONS(7494),
    [anon_sym_QMARK] = ACTIONS(7492),
    [anon_sym_TILDE] = ACTIONS(7492),
    [anon_sym_BANG] = ACTIONS(7494),
    [anon_sym_PLUS] = ACTIONS(7492),
    [anon_sym_DASH] = ACTIONS(7494),
    [anon_sym_LT_DASH] = ACTIONS(7492),
    [anon_sym_LT_LT_DASH] = ACTIONS(7492),
    [anon_sym_COLON_EQ] = ACTIONS(7492),
    [anon_sym_DASH_GT] = ACTIONS(7494),
    [anon_sym_DASH_GT_GT] = ACTIONS(7492),
    [anon_sym_PIPE] = ACTIONS(7494),
    [anon_sym_AMP] = ACTIONS(7494),
    [anon_sym_PIPE_PIPE] = ACTIONS(7492),
    [anon_sym_AMP_AMP] = ACTIONS(7492),
    [anon_sym_LT] = ACTIONS(7494),
    [anon_sym_LT_EQ] = ACTIONS(7492),
    [anon_sym_GT] = ACTIONS(7494),
    [anon_sym_GT_EQ] = ACTIONS(7492),
    [anon_sym_EQ_EQ] = ACTIONS(7492),
    [anon_sym_BANG_EQ] = ACTIONS(7492),
    [anon_sym_STAR] = ACTIONS(7494),
    [anon_sym_SLASH] = ACTIONS(7492),
    [anon_sym_STAR_STAR] = ACTIONS(7492),
    [anon_sym_CARET] = ACTIONS(7492),
    [aux_sym_binary_operator_token1] = ACTIONS(7492),
    [anon_sym_PIPE_GT] = ACTIONS(7492),
    [anon_sym_COLON] = ACTIONS(7494),
    [anon_sym_DOLLAR] = ACTIONS(7492),
    [anon_sym_AT] = ACTIONS(7492),
    [aux_sym__hex_literal_token1] = ACTIONS(7492),
    [sym__number_literal] = ACTIONS(7494),
    [anon_sym_SQUOTE] = ACTIONS(7492),
    [anon_sym_DQUOTE] = ACTIONS(7492),
    [sym_return] = ACTIONS(7494),
    [sym_next] = ACTIONS(7494),
    [sym_break] = ACTIONS(7494),
    [sym_true] = ACTIONS(7494),
    [sym_false] = ACTIONS(7494),
    [sym_null] = ACTIONS(7494),
    [sym_inf] = ACTIONS(7494),
    [sym_nan] = ACTIONS(7494),
    [anon_sym_NA] = ACTIONS(7494),
    [anon_sym_NA_integer_] = ACTIONS(7494),
    [anon_sym_NA_real_] = ACTIONS(7494),
    [anon_sym_NA_complex_] = ACTIONS(7494),
    [anon_sym_NA_character_] = ACTIONS(7494),
    [sym_dots] = ACTIONS(7494),
    [sym_dot_dot_i] = ACTIONS(7492),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7492),
    [sym__semicolon] = ACTIONS(7492),
    [sym__raw_string_literal] = ACTIONS(7492),
    [sym__external_else] = ACTIONS(7492),
    [sym__external_open_parenthesis] = ACTIONS(7492),
    [sym__external_open_brace] = ACTIONS(7492),
    [sym__external_close_brace] = ACTIONS(7492),
    [sym__external_open_bracket] = ACTIONS(7492),
    [sym__external_open_bracket2] = ACTIONS(7492),
  },
  [2590] = {
    [ts_builtin_sym_end] = ACTIONS(7488),
    [sym_identifier] = ACTIONS(7490),
    [anon_sym_BSLASH] = ACTIONS(7488),
    [anon_sym_function] = ACTIONS(7490),
    [anon_sym_EQ] = ACTIONS(7490),
    [anon_sym_if] = ACTIONS(7490),
    [anon_sym_for] = ACTIONS(7490),
    [anon_sym_while] = ACTIONS(7490),
    [anon_sym_repeat] = ACTIONS(7490),
    [anon_sym_QMARK] = ACTIONS(7488),
    [anon_sym_TILDE] = ACTIONS(7488),
    [anon_sym_BANG] = ACTIONS(7490),
    [anon_sym_PLUS] = ACTIONS(7488),
    [anon_sym_DASH] = ACTIONS(7490),
    [anon_sym_LT_DASH] = ACTIONS(7488),
    [anon_sym_LT_LT_DASH] = ACTIONS(7488),
    [anon_sym_COLON_EQ] = ACTIONS(7488),
    [anon_sym_DASH_GT] = ACTIONS(7490),
    [anon_sym_DASH_GT_GT] = ACTIONS(7488),
    [anon_sym_PIPE] = ACTIONS(7490),
    [anon_sym_AMP] = ACTIONS(7490),
    [anon_sym_PIPE_PIPE] = ACTIONS(7488),
    [anon_sym_AMP_AMP] = ACTIONS(7488),
    [anon_sym_LT] = ACTIONS(7490),
    [anon_sym_LT_EQ] = ACTIONS(7488),
    [anon_sym_GT] = ACTIONS(7490),
    [anon_sym_GT_EQ] = ACTIONS(7488),
    [anon_sym_EQ_EQ] = ACTIONS(7488),
    [anon_sym_BANG_EQ] = ACTIONS(7488),
    [anon_sym_STAR] = ACTIONS(7490),
    [anon_sym_SLASH] = ACTIONS(7488),
    [anon_sym_STAR_STAR] = ACTIONS(7488),
    [anon_sym_CARET] = ACTIONS(7488),
    [aux_sym_binary_operator_token1] = ACTIONS(7488),
    [anon_sym_PIPE_GT] = ACTIONS(7488),
    [anon_sym_COLON] = ACTIONS(7490),
    [anon_sym_DOLLAR] = ACTIONS(7488),
    [anon_sym_AT] = ACTIONS(7488),
    [aux_sym__hex_literal_token1] = ACTIONS(7488),
    [sym__number_literal] = ACTIONS(7490),
    [anon_sym_SQUOTE] = ACTIONS(7488),
    [anon_sym_DQUOTE] = ACTIONS(7488),
    [sym_return] = ACTIONS(7490),
    [sym_next] = ACTIONS(7490),
    [sym_break] = ACTIONS(7490),
    [sym_true] = ACTIONS(7490),
    [sym_false] = ACTIONS(7490),
    [sym_null] = ACTIONS(7490),
    [sym_inf] = ACTIONS(7490),
    [sym_nan] = ACTIONS(7490),
    [anon_sym_NA] = ACTIONS(7490),
    [anon_sym_NA_integer_] = ACTIONS(7490),
    [anon_sym_NA_real_] = ACTIONS(7490),
    [anon_sym_NA_complex_] = ACTIONS(7490),
    [anon_sym_NA_character_] = ACTIONS(7490),
    [sym_dots] = ACTIONS(7490),
    [sym_dot_dot_i] = ACTIONS(7488),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7488),
    [sym__semicolon] = ACTIONS(7488),
    [sym__raw_string_literal] = ACTIONS(7488),
    [sym__external_else] = ACTIONS(7488),
    [sym__external_open_parenthesis] = ACTIONS(7488),
    [sym__external_open_brace] = ACTIONS(7488),
    [sym__external_close_brace] = ACTIONS(7488),
    [sym__external_open_bracket] = ACTIONS(7488),
    [sym__external_open_bracket2] = ACTIONS(7488),
  },
  [2591] = {
    [ts_builtin_sym_end] = ACTIONS(7484),
    [sym_identifier] = ACTIONS(7486),
    [anon_sym_BSLASH] = ACTIONS(7484),
    [anon_sym_function] = ACTIONS(7486),
    [anon_sym_EQ] = ACTIONS(7486),
    [anon_sym_if] = ACTIONS(7486),
    [anon_sym_for] = ACTIONS(7486),
    [anon_sym_while] = ACTIONS(7486),
    [anon_sym_repeat] = ACTIONS(7486),
    [anon_sym_QMARK] = ACTIONS(7484),
    [anon_sym_TILDE] = ACTIONS(7484),
    [anon_sym_BANG] = ACTIONS(7486),
    [anon_sym_PLUS] = ACTIONS(7484),
    [anon_sym_DASH] = ACTIONS(7486),
    [anon_sym_LT_DASH] = ACTIONS(7484),
    [anon_sym_LT_LT_DASH] = ACTIONS(7484),
    [anon_sym_COLON_EQ] = ACTIONS(7484),
    [anon_sym_DASH_GT] = ACTIONS(7486),
    [anon_sym_DASH_GT_GT] = ACTIONS(7484),
    [anon_sym_PIPE] = ACTIONS(7486),
    [anon_sym_AMP] = ACTIONS(7486),
    [anon_sym_PIPE_PIPE] = ACTIONS(7484),
    [anon_sym_AMP_AMP] = ACTIONS(7484),
    [anon_sym_LT] = ACTIONS(7486),
    [anon_sym_LT_EQ] = ACTIONS(7484),
    [anon_sym_GT] = ACTIONS(7486),
    [anon_sym_GT_EQ] = ACTIONS(7484),
    [anon_sym_EQ_EQ] = ACTIONS(7484),
    [anon_sym_BANG_EQ] = ACTIONS(7484),
    [anon_sym_STAR] = ACTIONS(7486),
    [anon_sym_SLASH] = ACTIONS(7484),
    [anon_sym_STAR_STAR] = ACTIONS(7484),
    [anon_sym_CARET] = ACTIONS(7484),
    [aux_sym_binary_operator_token1] = ACTIONS(7484),
    [anon_sym_PIPE_GT] = ACTIONS(7484),
    [anon_sym_COLON] = ACTIONS(7486),
    [anon_sym_DOLLAR] = ACTIONS(7484),
    [anon_sym_AT] = ACTIONS(7484),
    [aux_sym__hex_literal_token1] = ACTIONS(7484),
    [sym__number_literal] = ACTIONS(7486),
    [anon_sym_SQUOTE] = ACTIONS(7484),
    [anon_sym_DQUOTE] = ACTIONS(7484),
    [sym_return] = ACTIONS(7486),
    [sym_next] = ACTIONS(7486),
    [sym_break] = ACTIONS(7486),
    [sym_true] = ACTIONS(7486),
    [sym_false] = ACTIONS(7486),
    [sym_null] = ACTIONS(7486),
    [sym_inf] = ACTIONS(7486),
    [sym_nan] = ACTIONS(7486),
    [anon_sym_NA] = ACTIONS(7486),
    [anon_sym_NA_integer_] = ACTIONS(7486),
    [anon_sym_NA_real_] = ACTIONS(7486),
    [anon_sym_NA_complex_] = ACTIONS(7486),
    [anon_sym_NA_character_] = ACTIONS(7486),
    [sym_dots] = ACTIONS(7486),
    [sym_dot_dot_i] = ACTIONS(7484),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7484),
    [sym__semicolon] = ACTIONS(7484),
    [sym__raw_string_literal] = ACTIONS(7484),
    [sym__external_else] = ACTIONS(7484),
    [sym__external_open_parenthesis] = ACTIONS(7484),
    [sym__external_open_brace] = ACTIONS(7484),
    [sym__external_close_brace] = ACTIONS(7484),
    [sym__external_open_bracket] = ACTIONS(7484),
    [sym__external_open_bracket2] = ACTIONS(7484),
  },
  [2592] = {
    [ts_builtin_sym_end] = ACTIONS(7522),
    [sym_identifier] = ACTIONS(7524),
    [anon_sym_BSLASH] = ACTIONS(7522),
    [anon_sym_function] = ACTIONS(7524),
    [anon_sym_EQ] = ACTIONS(7524),
    [anon_sym_if] = ACTIONS(7524),
    [anon_sym_for] = ACTIONS(7524),
    [anon_sym_while] = ACTIONS(7524),
    [anon_sym_repeat] = ACTIONS(7524),
    [anon_sym_QMARK] = ACTIONS(7522),
    [anon_sym_TILDE] = ACTIONS(7522),
    [anon_sym_BANG] = ACTIONS(7524),
    [anon_sym_PLUS] = ACTIONS(7522),
    [anon_sym_DASH] = ACTIONS(7524),
    [anon_sym_LT_DASH] = ACTIONS(7522),
    [anon_sym_LT_LT_DASH] = ACTIONS(7522),
    [anon_sym_COLON_EQ] = ACTIONS(7522),
    [anon_sym_DASH_GT] = ACTIONS(7524),
    [anon_sym_DASH_GT_GT] = ACTIONS(7522),
    [anon_sym_PIPE] = ACTIONS(7524),
    [anon_sym_AMP] = ACTIONS(7524),
    [anon_sym_PIPE_PIPE] = ACTIONS(7522),
    [anon_sym_AMP_AMP] = ACTIONS(7522),
    [anon_sym_LT] = ACTIONS(7524),
    [anon_sym_LT_EQ] = ACTIONS(7522),
    [anon_sym_GT] = ACTIONS(7524),
    [anon_sym_GT_EQ] = ACTIONS(7522),
    [anon_sym_EQ_EQ] = ACTIONS(7522),
    [anon_sym_BANG_EQ] = ACTIONS(7522),
    [anon_sym_STAR] = ACTIONS(7524),
    [anon_sym_SLASH] = ACTIONS(7522),
    [anon_sym_STAR_STAR] = ACTIONS(7522),
    [anon_sym_CARET] = ACTIONS(7522),
    [aux_sym_binary_operator_token1] = ACTIONS(7522),
    [anon_sym_PIPE_GT] = ACTIONS(7522),
    [anon_sym_COLON] = ACTIONS(7524),
    [anon_sym_DOLLAR] = ACTIONS(7522),
    [anon_sym_AT] = ACTIONS(7522),
    [aux_sym__hex_literal_token1] = ACTIONS(7522),
    [sym__number_literal] = ACTIONS(7524),
    [anon_sym_SQUOTE] = ACTIONS(7522),
    [anon_sym_DQUOTE] = ACTIONS(7522),
    [sym_return] = ACTIONS(7524),
    [sym_next] = ACTIONS(7524),
    [sym_break] = ACTIONS(7524),
    [sym_true] = ACTIONS(7524),
    [sym_false] = ACTIONS(7524),
    [sym_null] = ACTIONS(7524),
    [sym_inf] = ACTIONS(7524),
    [sym_nan] = ACTIONS(7524),
    [anon_sym_NA] = ACTIONS(7524),
    [anon_sym_NA_integer_] = ACTIONS(7524),
    [anon_sym_NA_real_] = ACTIONS(7524),
    [anon_sym_NA_complex_] = ACTIONS(7524),
    [anon_sym_NA_character_] = ACTIONS(7524),
    [sym_dots] = ACTIONS(7524),
    [sym_dot_dot_i] = ACTIONS(7522),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7522),
    [sym__semicolon] = ACTIONS(7522),
    [sym__raw_string_literal] = ACTIONS(7522),
    [sym__external_else] = ACTIONS(7522),
    [sym__external_open_parenthesis] = ACTIONS(7522),
    [sym__external_open_brace] = ACTIONS(7522),
    [sym__external_close_brace] = ACTIONS(7522),
    [sym__external_open_bracket] = ACTIONS(7522),
    [sym__external_open_bracket2] = ACTIONS(7522),
  },
  [2593] = {
    [sym_identifier] = ACTIONS(7540),
    [anon_sym_BSLASH] = ACTIONS(7538),
    [anon_sym_function] = ACTIONS(7540),
    [anon_sym_EQ] = ACTIONS(7540),
    [anon_sym_if] = ACTIONS(7540),
    [anon_sym_for] = ACTIONS(7540),
    [anon_sym_while] = ACTIONS(7540),
    [anon_sym_repeat] = ACTIONS(7540),
    [anon_sym_QMARK] = ACTIONS(7538),
    [anon_sym_TILDE] = ACTIONS(7538),
    [anon_sym_BANG] = ACTIONS(7540),
    [anon_sym_PLUS] = ACTIONS(7538),
    [anon_sym_DASH] = ACTIONS(7540),
    [anon_sym_LT_DASH] = ACTIONS(7538),
    [anon_sym_LT_LT_DASH] = ACTIONS(7538),
    [anon_sym_COLON_EQ] = ACTIONS(7538),
    [anon_sym_DASH_GT] = ACTIONS(7540),
    [anon_sym_DASH_GT_GT] = ACTIONS(7538),
    [anon_sym_PIPE] = ACTIONS(7540),
    [anon_sym_AMP] = ACTIONS(7540),
    [anon_sym_PIPE_PIPE] = ACTIONS(7538),
    [anon_sym_AMP_AMP] = ACTIONS(7538),
    [anon_sym_LT] = ACTIONS(7540),
    [anon_sym_LT_EQ] = ACTIONS(7538),
    [anon_sym_GT] = ACTIONS(7540),
    [anon_sym_GT_EQ] = ACTIONS(7538),
    [anon_sym_EQ_EQ] = ACTIONS(7538),
    [anon_sym_BANG_EQ] = ACTIONS(7538),
    [anon_sym_STAR] = ACTIONS(7540),
    [anon_sym_SLASH] = ACTIONS(7538),
    [anon_sym_STAR_STAR] = ACTIONS(7538),
    [anon_sym_CARET] = ACTIONS(7538),
    [aux_sym_binary_operator_token1] = ACTIONS(7538),
    [anon_sym_PIPE_GT] = ACTIONS(7538),
    [anon_sym_COLON] = ACTIONS(7540),
    [anon_sym_DOLLAR] = ACTIONS(7538),
    [anon_sym_AT] = ACTIONS(7538),
    [aux_sym__hex_literal_token1] = ACTIONS(7538),
    [sym__number_literal] = ACTIONS(7540),
    [anon_sym_SQUOTE] = ACTIONS(7538),
    [anon_sym_DQUOTE] = ACTIONS(7538),
    [sym_return] = ACTIONS(7540),
    [sym_next] = ACTIONS(7540),
    [sym_break] = ACTIONS(7540),
    [sym_true] = ACTIONS(7540),
    [sym_false] = ACTIONS(7540),
    [sym_null] = ACTIONS(7540),
    [sym_inf] = ACTIONS(7540),
    [sym_nan] = ACTIONS(7540),
    [anon_sym_NA] = ACTIONS(7540),
    [anon_sym_NA_integer_] = ACTIONS(7540),
    [anon_sym_NA_real_] = ACTIONS(7540),
    [anon_sym_NA_complex_] = ACTIONS(7540),
    [anon_sym_NA_character_] = ACTIONS(7540),
    [sym_dots] = ACTIONS(7540),
    [sym_dot_dot_i] = ACTIONS(7538),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7538),
    [sym__newline] = ACTIONS(7538),
    [sym__semicolon] = ACTIONS(7538),
    [sym__raw_string_literal] = ACTIONS(7538),
    [sym__external_open_parenthesis] = ACTIONS(7538),
    [sym__external_open_brace] = ACTIONS(7538),
    [sym__external_close_brace] = ACTIONS(7538),
    [sym__external_open_bracket] = ACTIONS(7538),
    [sym__external_open_bracket2] = ACTIONS(7538),
    [sym__external_close_bracket2] = ACTIONS(7538),
  },
  [2594] = {
    [ts_builtin_sym_end] = ACTIONS(7526),
    [sym_identifier] = ACTIONS(7528),
    [anon_sym_BSLASH] = ACTIONS(7526),
    [anon_sym_function] = ACTIONS(7528),
    [anon_sym_EQ] = ACTIONS(7528),
    [anon_sym_if] = ACTIONS(7528),
    [anon_sym_for] = ACTIONS(7528),
    [anon_sym_while] = ACTIONS(7528),
    [anon_sym_repeat] = ACTIONS(7528),
    [anon_sym_QMARK] = ACTIONS(7526),
    [anon_sym_TILDE] = ACTIONS(7526),
    [anon_sym_BANG] = ACTIONS(7528),
    [anon_sym_PLUS] = ACTIONS(7526),
    [anon_sym_DASH] = ACTIONS(7528),
    [anon_sym_LT_DASH] = ACTIONS(7526),
    [anon_sym_LT_LT_DASH] = ACTIONS(7526),
    [anon_sym_COLON_EQ] = ACTIONS(7526),
    [anon_sym_DASH_GT] = ACTIONS(7528),
    [anon_sym_DASH_GT_GT] = ACTIONS(7526),
    [anon_sym_PIPE] = ACTIONS(7528),
    [anon_sym_AMP] = ACTIONS(7528),
    [anon_sym_PIPE_PIPE] = ACTIONS(7526),
    [anon_sym_AMP_AMP] = ACTIONS(7526),
    [anon_sym_LT] = ACTIONS(7528),
    [anon_sym_LT_EQ] = ACTIONS(7526),
    [anon_sym_GT] = ACTIONS(7528),
    [anon_sym_GT_EQ] = ACTIONS(7526),
    [anon_sym_EQ_EQ] = ACTIONS(7526),
    [anon_sym_BANG_EQ] = ACTIONS(7526),
    [anon_sym_STAR] = ACTIONS(7528),
    [anon_sym_SLASH] = ACTIONS(7526),
    [anon_sym_STAR_STAR] = ACTIONS(7526),
    [anon_sym_CARET] = ACTIONS(7526),
    [aux_sym_binary_operator_token1] = ACTIONS(7526),
    [anon_sym_PIPE_GT] = ACTIONS(7526),
    [anon_sym_COLON] = ACTIONS(7528),
    [anon_sym_DOLLAR] = ACTIONS(7526),
    [anon_sym_AT] = ACTIONS(7526),
    [aux_sym__hex_literal_token1] = ACTIONS(7526),
    [sym__number_literal] = ACTIONS(7528),
    [anon_sym_SQUOTE] = ACTIONS(7526),
    [anon_sym_DQUOTE] = ACTIONS(7526),
    [sym_return] = ACTIONS(7528),
    [sym_next] = ACTIONS(7528),
    [sym_break] = ACTIONS(7528),
    [sym_true] = ACTIONS(7528),
    [sym_false] = ACTIONS(7528),
    [sym_null] = ACTIONS(7528),
    [sym_inf] = ACTIONS(7528),
    [sym_nan] = ACTIONS(7528),
    [anon_sym_NA] = ACTIONS(7528),
    [anon_sym_NA_integer_] = ACTIONS(7528),
    [anon_sym_NA_real_] = ACTIONS(7528),
    [anon_sym_NA_complex_] = ACTIONS(7528),
    [anon_sym_NA_character_] = ACTIONS(7528),
    [sym_dots] = ACTIONS(7528),
    [sym_dot_dot_i] = ACTIONS(7526),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7526),
    [sym__semicolon] = ACTIONS(7526),
    [sym__raw_string_literal] = ACTIONS(7526),
    [sym__external_else] = ACTIONS(7526),
    [sym__external_open_parenthesis] = ACTIONS(7526),
    [sym__external_open_brace] = ACTIONS(7526),
    [sym__external_close_brace] = ACTIONS(7526),
    [sym__external_open_bracket] = ACTIONS(7526),
    [sym__external_open_bracket2] = ACTIONS(7526),
  },
  [2595] = {
    [ts_builtin_sym_end] = ACTIONS(7530),
    [sym_identifier] = ACTIONS(7532),
    [anon_sym_BSLASH] = ACTIONS(7530),
    [anon_sym_function] = ACTIONS(7532),
    [anon_sym_EQ] = ACTIONS(7532),
    [anon_sym_if] = ACTIONS(7532),
    [anon_sym_for] = ACTIONS(7532),
    [anon_sym_while] = ACTIONS(7532),
    [anon_sym_repeat] = ACTIONS(7532),
    [anon_sym_QMARK] = ACTIONS(7530),
    [anon_sym_TILDE] = ACTIONS(7530),
    [anon_sym_BANG] = ACTIONS(7532),
    [anon_sym_PLUS] = ACTIONS(7530),
    [anon_sym_DASH] = ACTIONS(7532),
    [anon_sym_LT_DASH] = ACTIONS(7530),
    [anon_sym_LT_LT_DASH] = ACTIONS(7530),
    [anon_sym_COLON_EQ] = ACTIONS(7530),
    [anon_sym_DASH_GT] = ACTIONS(7532),
    [anon_sym_DASH_GT_GT] = ACTIONS(7530),
    [anon_sym_PIPE] = ACTIONS(7532),
    [anon_sym_AMP] = ACTIONS(7532),
    [anon_sym_PIPE_PIPE] = ACTIONS(7530),
    [anon_sym_AMP_AMP] = ACTIONS(7530),
    [anon_sym_LT] = ACTIONS(7532),
    [anon_sym_LT_EQ] = ACTIONS(7530),
    [anon_sym_GT] = ACTIONS(7532),
    [anon_sym_GT_EQ] = ACTIONS(7530),
    [anon_sym_EQ_EQ] = ACTIONS(7530),
    [anon_sym_BANG_EQ] = ACTIONS(7530),
    [anon_sym_STAR] = ACTIONS(7532),
    [anon_sym_SLASH] = ACTIONS(7530),
    [anon_sym_STAR_STAR] = ACTIONS(7530),
    [anon_sym_CARET] = ACTIONS(7530),
    [aux_sym_binary_operator_token1] = ACTIONS(7530),
    [anon_sym_PIPE_GT] = ACTIONS(7530),
    [anon_sym_COLON] = ACTIONS(7532),
    [anon_sym_DOLLAR] = ACTIONS(7530),
    [anon_sym_AT] = ACTIONS(7530),
    [aux_sym__hex_literal_token1] = ACTIONS(7530),
    [sym__number_literal] = ACTIONS(7532),
    [anon_sym_SQUOTE] = ACTIONS(7530),
    [anon_sym_DQUOTE] = ACTIONS(7530),
    [sym_return] = ACTIONS(7532),
    [sym_next] = ACTIONS(7532),
    [sym_break] = ACTIONS(7532),
    [sym_true] = ACTIONS(7532),
    [sym_false] = ACTIONS(7532),
    [sym_null] = ACTIONS(7532),
    [sym_inf] = ACTIONS(7532),
    [sym_nan] = ACTIONS(7532),
    [anon_sym_NA] = ACTIONS(7532),
    [anon_sym_NA_integer_] = ACTIONS(7532),
    [anon_sym_NA_real_] = ACTIONS(7532),
    [anon_sym_NA_complex_] = ACTIONS(7532),
    [anon_sym_NA_character_] = ACTIONS(7532),
    [sym_dots] = ACTIONS(7532),
    [sym_dot_dot_i] = ACTIONS(7530),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7530),
    [sym__semicolon] = ACTIONS(7530),
    [sym__raw_string_literal] = ACTIONS(7530),
    [sym__external_else] = ACTIONS(7530),
    [sym__external_open_parenthesis] = ACTIONS(7530),
    [sym__external_open_brace] = ACTIONS(7530),
    [sym__external_close_brace] = ACTIONS(7530),
    [sym__external_open_bracket] = ACTIONS(7530),
    [sym__external_open_bracket2] = ACTIONS(7530),
  },
  [2596] = {
    [sym_identifier] = ACTIONS(7490),
    [anon_sym_BSLASH] = ACTIONS(7488),
    [anon_sym_function] = ACTIONS(7490),
    [anon_sym_EQ] = ACTIONS(7490),
    [anon_sym_if] = ACTIONS(7490),
    [anon_sym_for] = ACTIONS(7490),
    [anon_sym_while] = ACTIONS(7490),
    [anon_sym_repeat] = ACTIONS(7490),
    [anon_sym_QMARK] = ACTIONS(7488),
    [anon_sym_TILDE] = ACTIONS(7488),
    [anon_sym_BANG] = ACTIONS(7490),
    [anon_sym_PLUS] = ACTIONS(7488),
    [anon_sym_DASH] = ACTIONS(7490),
    [anon_sym_LT_DASH] = ACTIONS(7488),
    [anon_sym_LT_LT_DASH] = ACTIONS(7488),
    [anon_sym_COLON_EQ] = ACTIONS(7488),
    [anon_sym_DASH_GT] = ACTIONS(7490),
    [anon_sym_DASH_GT_GT] = ACTIONS(7488),
    [anon_sym_PIPE] = ACTIONS(7490),
    [anon_sym_AMP] = ACTIONS(7490),
    [anon_sym_PIPE_PIPE] = ACTIONS(7488),
    [anon_sym_AMP_AMP] = ACTIONS(7488),
    [anon_sym_LT] = ACTIONS(7490),
    [anon_sym_LT_EQ] = ACTIONS(7488),
    [anon_sym_GT] = ACTIONS(7490),
    [anon_sym_GT_EQ] = ACTIONS(7488),
    [anon_sym_EQ_EQ] = ACTIONS(7488),
    [anon_sym_BANG_EQ] = ACTIONS(7488),
    [anon_sym_STAR] = ACTIONS(7490),
    [anon_sym_SLASH] = ACTIONS(7488),
    [anon_sym_STAR_STAR] = ACTIONS(7488),
    [anon_sym_CARET] = ACTIONS(7488),
    [aux_sym_binary_operator_token1] = ACTIONS(7488),
    [anon_sym_PIPE_GT] = ACTIONS(7488),
    [anon_sym_COLON] = ACTIONS(7490),
    [anon_sym_DOLLAR] = ACTIONS(7488),
    [anon_sym_AT] = ACTIONS(7488),
    [aux_sym__hex_literal_token1] = ACTIONS(7488),
    [sym__number_literal] = ACTIONS(7490),
    [anon_sym_SQUOTE] = ACTIONS(7488),
    [anon_sym_DQUOTE] = ACTIONS(7488),
    [sym_return] = ACTIONS(7490),
    [sym_next] = ACTIONS(7490),
    [sym_break] = ACTIONS(7490),
    [sym_true] = ACTIONS(7490),
    [sym_false] = ACTIONS(7490),
    [sym_null] = ACTIONS(7490),
    [sym_inf] = ACTIONS(7490),
    [sym_nan] = ACTIONS(7490),
    [anon_sym_NA] = ACTIONS(7490),
    [anon_sym_NA_integer_] = ACTIONS(7490),
    [anon_sym_NA_real_] = ACTIONS(7490),
    [anon_sym_NA_complex_] = ACTIONS(7490),
    [anon_sym_NA_character_] = ACTIONS(7490),
    [sym_dots] = ACTIONS(7490),
    [sym_dot_dot_i] = ACTIONS(7488),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7488),
    [sym__newline] = ACTIONS(7488),
    [sym__semicolon] = ACTIONS(7488),
    [sym__raw_string_literal] = ACTIONS(7488),
    [sym__external_open_parenthesis] = ACTIONS(7488),
    [sym__external_open_brace] = ACTIONS(7488),
    [sym__external_close_brace] = ACTIONS(7488),
    [sym__external_open_bracket] = ACTIONS(7488),
    [sym__external_close_bracket] = ACTIONS(7488),
    [sym__external_open_bracket2] = ACTIONS(7488),
  },
  [2597] = {
    [sym_identifier] = ACTIONS(7129),
    [anon_sym_BSLASH] = ACTIONS(7131),
    [anon_sym_function] = ACTIONS(7129),
    [anon_sym_EQ] = ACTIONS(7656),
    [anon_sym_if] = ACTIONS(7129),
    [anon_sym_for] = ACTIONS(7129),
    [anon_sym_while] = ACTIONS(7129),
    [anon_sym_repeat] = ACTIONS(7129),
    [anon_sym_QMARK] = ACTIONS(7131),
    [anon_sym_TILDE] = ACTIONS(7131),
    [anon_sym_BANG] = ACTIONS(7129),
    [anon_sym_PLUS] = ACTIONS(7131),
    [anon_sym_DASH] = ACTIONS(7129),
    [anon_sym_LT_DASH] = ACTIONS(7131),
    [anon_sym_LT_LT_DASH] = ACTIONS(7131),
    [anon_sym_COLON_EQ] = ACTIONS(7131),
    [anon_sym_DASH_GT] = ACTIONS(7129),
    [anon_sym_DASH_GT_GT] = ACTIONS(7131),
    [anon_sym_PIPE] = ACTIONS(7129),
    [anon_sym_AMP] = ACTIONS(7129),
    [anon_sym_PIPE_PIPE] = ACTIONS(7131),
    [anon_sym_AMP_AMP] = ACTIONS(7131),
    [anon_sym_LT] = ACTIONS(7129),
    [anon_sym_LT_EQ] = ACTIONS(7131),
    [anon_sym_GT] = ACTIONS(7129),
    [anon_sym_GT_EQ] = ACTIONS(7131),
    [anon_sym_EQ_EQ] = ACTIONS(7131),
    [anon_sym_BANG_EQ] = ACTIONS(7131),
    [anon_sym_STAR] = ACTIONS(7129),
    [anon_sym_SLASH] = ACTIONS(7131),
    [anon_sym_STAR_STAR] = ACTIONS(7131),
    [anon_sym_CARET] = ACTIONS(7131),
    [aux_sym_binary_operator_token1] = ACTIONS(7131),
    [anon_sym_PIPE_GT] = ACTIONS(7131),
    [anon_sym_COLON] = ACTIONS(7129),
    [anon_sym_DOLLAR] = ACTIONS(7131),
    [anon_sym_AT] = ACTIONS(7131),
    [anon_sym_COLON_COLON] = ACTIONS(7133),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7135),
    [aux_sym__hex_literal_token1] = ACTIONS(7131),
    [sym__number_literal] = ACTIONS(7129),
    [anon_sym_SQUOTE] = ACTIONS(7131),
    [anon_sym_DQUOTE] = ACTIONS(7131),
    [sym_return] = ACTIONS(7129),
    [sym_next] = ACTIONS(7129),
    [sym_break] = ACTIONS(7129),
    [sym_true] = ACTIONS(7129),
    [sym_false] = ACTIONS(7129),
    [sym_null] = ACTIONS(7129),
    [sym_inf] = ACTIONS(7129),
    [sym_nan] = ACTIONS(7129),
    [anon_sym_NA] = ACTIONS(7129),
    [anon_sym_NA_integer_] = ACTIONS(7129),
    [anon_sym_NA_real_] = ACTIONS(7129),
    [anon_sym_NA_complex_] = ACTIONS(7129),
    [anon_sym_NA_character_] = ACTIONS(7129),
    [sym_dots] = ACTIONS(7129),
    [sym_dot_dot_i] = ACTIONS(7131),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7131),
    [sym__newline] = ACTIONS(7131),
    [sym__raw_string_literal] = ACTIONS(7131),
    [sym__external_open_parenthesis] = ACTIONS(7131),
    [sym__external_open_brace] = ACTIONS(7131),
    [sym__external_open_bracket] = ACTIONS(7131),
    [sym__external_close_bracket] = ACTIONS(7131),
    [sym__external_open_bracket2] = ACTIONS(7131),
  },
  [2598] = {
    [sym_identifier] = ACTIONS(7567),
    [anon_sym_BSLASH] = ACTIONS(7565),
    [anon_sym_function] = ACTIONS(7567),
    [anon_sym_EQ] = ACTIONS(7567),
    [anon_sym_if] = ACTIONS(7567),
    [anon_sym_for] = ACTIONS(7567),
    [anon_sym_while] = ACTIONS(7567),
    [anon_sym_repeat] = ACTIONS(7567),
    [anon_sym_QMARK] = ACTIONS(7565),
    [anon_sym_TILDE] = ACTIONS(7565),
    [anon_sym_BANG] = ACTIONS(7567),
    [anon_sym_PLUS] = ACTIONS(7565),
    [anon_sym_DASH] = ACTIONS(7567),
    [anon_sym_LT_DASH] = ACTIONS(7565),
    [anon_sym_LT_LT_DASH] = ACTIONS(7565),
    [anon_sym_COLON_EQ] = ACTIONS(7565),
    [anon_sym_DASH_GT] = ACTIONS(7567),
    [anon_sym_DASH_GT_GT] = ACTIONS(7565),
    [anon_sym_PIPE] = ACTIONS(7567),
    [anon_sym_AMP] = ACTIONS(7567),
    [anon_sym_PIPE_PIPE] = ACTIONS(7565),
    [anon_sym_AMP_AMP] = ACTIONS(7565),
    [anon_sym_LT] = ACTIONS(7567),
    [anon_sym_LT_EQ] = ACTIONS(7565),
    [anon_sym_GT] = ACTIONS(7567),
    [anon_sym_GT_EQ] = ACTIONS(7565),
    [anon_sym_EQ_EQ] = ACTIONS(7565),
    [anon_sym_BANG_EQ] = ACTIONS(7565),
    [anon_sym_STAR] = ACTIONS(7567),
    [anon_sym_SLASH] = ACTIONS(7565),
    [anon_sym_STAR_STAR] = ACTIONS(7565),
    [anon_sym_CARET] = ACTIONS(7565),
    [aux_sym_binary_operator_token1] = ACTIONS(7565),
    [anon_sym_PIPE_GT] = ACTIONS(7565),
    [anon_sym_COLON] = ACTIONS(7567),
    [anon_sym_DOLLAR] = ACTIONS(7565),
    [anon_sym_AT] = ACTIONS(7565),
    [aux_sym__hex_literal_token1] = ACTIONS(7565),
    [sym__number_literal] = ACTIONS(7567),
    [anon_sym_SQUOTE] = ACTIONS(7565),
    [anon_sym_DQUOTE] = ACTIONS(7565),
    [sym_return] = ACTIONS(7567),
    [sym_next] = ACTIONS(7567),
    [sym_break] = ACTIONS(7567),
    [sym_true] = ACTIONS(7567),
    [sym_false] = ACTIONS(7567),
    [sym_null] = ACTIONS(7567),
    [sym_inf] = ACTIONS(7567),
    [sym_nan] = ACTIONS(7567),
    [anon_sym_NA] = ACTIONS(7567),
    [anon_sym_NA_integer_] = ACTIONS(7567),
    [anon_sym_NA_real_] = ACTIONS(7567),
    [anon_sym_NA_complex_] = ACTIONS(7567),
    [anon_sym_NA_character_] = ACTIONS(7567),
    [sym_dots] = ACTIONS(7567),
    [sym_dot_dot_i] = ACTIONS(7565),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7565),
    [sym__newline] = ACTIONS(7565),
    [sym__raw_string_literal] = ACTIONS(7565),
    [sym__external_else] = ACTIONS(7565),
    [sym__external_open_parenthesis] = ACTIONS(7565),
    [sym__external_close_parenthesis] = ACTIONS(7565),
    [sym__external_open_brace] = ACTIONS(7565),
    [sym__external_open_bracket] = ACTIONS(7565),
    [sym__external_close_bracket] = ACTIONS(7565),
    [sym__external_open_bracket2] = ACTIONS(7565),
  },
  [2599] = {
    [sym_identifier] = ACTIONS(7474),
    [anon_sym_BSLASH] = ACTIONS(7472),
    [anon_sym_function] = ACTIONS(7474),
    [anon_sym_EQ] = ACTIONS(7474),
    [anon_sym_if] = ACTIONS(7474),
    [anon_sym_for] = ACTIONS(7474),
    [anon_sym_while] = ACTIONS(7474),
    [anon_sym_repeat] = ACTIONS(7474),
    [anon_sym_QMARK] = ACTIONS(7472),
    [anon_sym_TILDE] = ACTIONS(7472),
    [anon_sym_BANG] = ACTIONS(7474),
    [anon_sym_PLUS] = ACTIONS(7472),
    [anon_sym_DASH] = ACTIONS(7474),
    [anon_sym_LT_DASH] = ACTIONS(7472),
    [anon_sym_LT_LT_DASH] = ACTIONS(7472),
    [anon_sym_COLON_EQ] = ACTIONS(7472),
    [anon_sym_DASH_GT] = ACTIONS(7474),
    [anon_sym_DASH_GT_GT] = ACTIONS(7472),
    [anon_sym_PIPE] = ACTIONS(7474),
    [anon_sym_AMP] = ACTIONS(7474),
    [anon_sym_PIPE_PIPE] = ACTIONS(7472),
    [anon_sym_AMP_AMP] = ACTIONS(7472),
    [anon_sym_LT] = ACTIONS(7474),
    [anon_sym_LT_EQ] = ACTIONS(7472),
    [anon_sym_GT] = ACTIONS(7474),
    [anon_sym_GT_EQ] = ACTIONS(7472),
    [anon_sym_EQ_EQ] = ACTIONS(7472),
    [anon_sym_BANG_EQ] = ACTIONS(7472),
    [anon_sym_STAR] = ACTIONS(7474),
    [anon_sym_SLASH] = ACTIONS(7472),
    [anon_sym_STAR_STAR] = ACTIONS(7472),
    [anon_sym_CARET] = ACTIONS(7472),
    [aux_sym_binary_operator_token1] = ACTIONS(7472),
    [anon_sym_PIPE_GT] = ACTIONS(7472),
    [anon_sym_COLON] = ACTIONS(7474),
    [anon_sym_DOLLAR] = ACTIONS(7472),
    [anon_sym_AT] = ACTIONS(7472),
    [aux_sym__hex_literal_token1] = ACTIONS(7472),
    [sym__number_literal] = ACTIONS(7474),
    [anon_sym_SQUOTE] = ACTIONS(7472),
    [anon_sym_DQUOTE] = ACTIONS(7472),
    [sym_return] = ACTIONS(7474),
    [sym_next] = ACTIONS(7474),
    [sym_break] = ACTIONS(7474),
    [sym_true] = ACTIONS(7474),
    [sym_false] = ACTIONS(7474),
    [sym_null] = ACTIONS(7474),
    [sym_inf] = ACTIONS(7474),
    [sym_nan] = ACTIONS(7474),
    [anon_sym_NA] = ACTIONS(7474),
    [anon_sym_NA_integer_] = ACTIONS(7474),
    [anon_sym_NA_real_] = ACTIONS(7474),
    [anon_sym_NA_complex_] = ACTIONS(7474),
    [anon_sym_NA_character_] = ACTIONS(7474),
    [sym_dots] = ACTIONS(7474),
    [sym_dot_dot_i] = ACTIONS(7472),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7472),
    [sym__newline] = ACTIONS(7472),
    [sym__raw_string_literal] = ACTIONS(7472),
    [sym__external_else] = ACTIONS(7472),
    [sym__external_open_parenthesis] = ACTIONS(7472),
    [sym__external_close_parenthesis] = ACTIONS(7472),
    [sym__external_open_brace] = ACTIONS(7472),
    [sym__external_open_bracket] = ACTIONS(7472),
    [sym__external_open_bracket2] = ACTIONS(7472),
    [sym__external_close_bracket2] = ACTIONS(7472),
  },
  [2600] = {
    [sym_identifier] = ACTIONS(7464),
    [anon_sym_BSLASH] = ACTIONS(7466),
    [anon_sym_function] = ACTIONS(7464),
    [anon_sym_EQ] = ACTIONS(7464),
    [anon_sym_if] = ACTIONS(7464),
    [anon_sym_for] = ACTIONS(7464),
    [anon_sym_while] = ACTIONS(7464),
    [anon_sym_repeat] = ACTIONS(7464),
    [anon_sym_QMARK] = ACTIONS(7466),
    [anon_sym_TILDE] = ACTIONS(7466),
    [anon_sym_BANG] = ACTIONS(7464),
    [anon_sym_PLUS] = ACTIONS(7466),
    [anon_sym_DASH] = ACTIONS(7464),
    [anon_sym_LT_DASH] = ACTIONS(7466),
    [anon_sym_LT_LT_DASH] = ACTIONS(7466),
    [anon_sym_COLON_EQ] = ACTIONS(7466),
    [anon_sym_DASH_GT] = ACTIONS(7464),
    [anon_sym_DASH_GT_GT] = ACTIONS(7466),
    [anon_sym_PIPE] = ACTIONS(7464),
    [anon_sym_AMP] = ACTIONS(7464),
    [anon_sym_PIPE_PIPE] = ACTIONS(7466),
    [anon_sym_AMP_AMP] = ACTIONS(7466),
    [anon_sym_LT] = ACTIONS(7464),
    [anon_sym_LT_EQ] = ACTIONS(7466),
    [anon_sym_GT] = ACTIONS(7464),
    [anon_sym_GT_EQ] = ACTIONS(7466),
    [anon_sym_EQ_EQ] = ACTIONS(7466),
    [anon_sym_BANG_EQ] = ACTIONS(7466),
    [anon_sym_STAR] = ACTIONS(7464),
    [anon_sym_SLASH] = ACTIONS(7466),
    [anon_sym_STAR_STAR] = ACTIONS(7466),
    [anon_sym_CARET] = ACTIONS(7466),
    [aux_sym_binary_operator_token1] = ACTIONS(7466),
    [anon_sym_PIPE_GT] = ACTIONS(7466),
    [anon_sym_COLON] = ACTIONS(7464),
    [anon_sym_DOLLAR] = ACTIONS(7466),
    [anon_sym_AT] = ACTIONS(7466),
    [aux_sym__hex_literal_token1] = ACTIONS(7466),
    [sym__number_literal] = ACTIONS(7464),
    [anon_sym_SQUOTE] = ACTIONS(7466),
    [anon_sym_DQUOTE] = ACTIONS(7466),
    [sym_return] = ACTIONS(7464),
    [sym_next] = ACTIONS(7464),
    [sym_break] = ACTIONS(7464),
    [sym_true] = ACTIONS(7464),
    [sym_false] = ACTIONS(7464),
    [sym_null] = ACTIONS(7464),
    [sym_inf] = ACTIONS(7464),
    [sym_nan] = ACTIONS(7464),
    [anon_sym_NA] = ACTIONS(7464),
    [anon_sym_NA_integer_] = ACTIONS(7464),
    [anon_sym_NA_real_] = ACTIONS(7464),
    [anon_sym_NA_complex_] = ACTIONS(7464),
    [anon_sym_NA_character_] = ACTIONS(7464),
    [sym_dots] = ACTIONS(7464),
    [sym_dot_dot_i] = ACTIONS(7466),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7466),
    [sym__newline] = ACTIONS(7466),
    [sym__raw_string_literal] = ACTIONS(7466),
    [sym__external_else] = ACTIONS(7466),
    [sym__external_open_parenthesis] = ACTIONS(7466),
    [sym__external_close_parenthesis] = ACTIONS(7466),
    [sym__external_open_brace] = ACTIONS(7466),
    [sym__external_open_bracket] = ACTIONS(7466),
    [sym__external_open_bracket2] = ACTIONS(7466),
    [sym__external_close_bracket2] = ACTIONS(7466),
  },
  [2601] = {
    [sym_identifier] = ACTIONS(7478),
    [anon_sym_BSLASH] = ACTIONS(7476),
    [anon_sym_function] = ACTIONS(7478),
    [anon_sym_EQ] = ACTIONS(7478),
    [anon_sym_if] = ACTIONS(7478),
    [anon_sym_for] = ACTIONS(7478),
    [anon_sym_while] = ACTIONS(7478),
    [anon_sym_repeat] = ACTIONS(7478),
    [anon_sym_QMARK] = ACTIONS(7476),
    [anon_sym_TILDE] = ACTIONS(7476),
    [anon_sym_BANG] = ACTIONS(7478),
    [anon_sym_PLUS] = ACTIONS(7476),
    [anon_sym_DASH] = ACTIONS(7478),
    [anon_sym_LT_DASH] = ACTIONS(7476),
    [anon_sym_LT_LT_DASH] = ACTIONS(7476),
    [anon_sym_COLON_EQ] = ACTIONS(7476),
    [anon_sym_DASH_GT] = ACTIONS(7478),
    [anon_sym_DASH_GT_GT] = ACTIONS(7476),
    [anon_sym_PIPE] = ACTIONS(7478),
    [anon_sym_AMP] = ACTIONS(7478),
    [anon_sym_PIPE_PIPE] = ACTIONS(7476),
    [anon_sym_AMP_AMP] = ACTIONS(7476),
    [anon_sym_LT] = ACTIONS(7478),
    [anon_sym_LT_EQ] = ACTIONS(7476),
    [anon_sym_GT] = ACTIONS(7478),
    [anon_sym_GT_EQ] = ACTIONS(7476),
    [anon_sym_EQ_EQ] = ACTIONS(7476),
    [anon_sym_BANG_EQ] = ACTIONS(7476),
    [anon_sym_STAR] = ACTIONS(7478),
    [anon_sym_SLASH] = ACTIONS(7476),
    [anon_sym_STAR_STAR] = ACTIONS(7476),
    [anon_sym_CARET] = ACTIONS(7476),
    [aux_sym_binary_operator_token1] = ACTIONS(7476),
    [anon_sym_PIPE_GT] = ACTIONS(7476),
    [anon_sym_COLON] = ACTIONS(7478),
    [anon_sym_DOLLAR] = ACTIONS(7476),
    [anon_sym_AT] = ACTIONS(7476),
    [aux_sym__hex_literal_token1] = ACTIONS(7476),
    [sym__number_literal] = ACTIONS(7478),
    [anon_sym_SQUOTE] = ACTIONS(7476),
    [anon_sym_DQUOTE] = ACTIONS(7476),
    [sym_return] = ACTIONS(7478),
    [sym_next] = ACTIONS(7478),
    [sym_break] = ACTIONS(7478),
    [sym_true] = ACTIONS(7478),
    [sym_false] = ACTIONS(7478),
    [sym_null] = ACTIONS(7478),
    [sym_inf] = ACTIONS(7478),
    [sym_nan] = ACTIONS(7478),
    [anon_sym_NA] = ACTIONS(7478),
    [anon_sym_NA_integer_] = ACTIONS(7478),
    [anon_sym_NA_real_] = ACTIONS(7478),
    [anon_sym_NA_complex_] = ACTIONS(7478),
    [anon_sym_NA_character_] = ACTIONS(7478),
    [sym_dots] = ACTIONS(7478),
    [sym_dot_dot_i] = ACTIONS(7476),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7476),
    [sym__newline] = ACTIONS(7476),
    [sym__raw_string_literal] = ACTIONS(7476),
    [sym__external_else] = ACTIONS(7476),
    [sym__external_open_parenthesis] = ACTIONS(7476),
    [sym__external_close_parenthesis] = ACTIONS(7476),
    [sym__external_open_brace] = ACTIONS(7476),
    [sym__external_open_bracket] = ACTIONS(7476),
    [sym__external_open_bracket2] = ACTIONS(7476),
    [sym__external_close_bracket2] = ACTIONS(7476),
  },
  [2602] = {
    [sym_identifier] = ACTIONS(7494),
    [anon_sym_BSLASH] = ACTIONS(7492),
    [anon_sym_function] = ACTIONS(7494),
    [anon_sym_EQ] = ACTIONS(7494),
    [anon_sym_if] = ACTIONS(7494),
    [anon_sym_for] = ACTIONS(7494),
    [anon_sym_while] = ACTIONS(7494),
    [anon_sym_repeat] = ACTIONS(7494),
    [anon_sym_QMARK] = ACTIONS(7492),
    [anon_sym_TILDE] = ACTIONS(7492),
    [anon_sym_BANG] = ACTIONS(7494),
    [anon_sym_PLUS] = ACTIONS(7492),
    [anon_sym_DASH] = ACTIONS(7494),
    [anon_sym_LT_DASH] = ACTIONS(7492),
    [anon_sym_LT_LT_DASH] = ACTIONS(7492),
    [anon_sym_COLON_EQ] = ACTIONS(7492),
    [anon_sym_DASH_GT] = ACTIONS(7494),
    [anon_sym_DASH_GT_GT] = ACTIONS(7492),
    [anon_sym_PIPE] = ACTIONS(7494),
    [anon_sym_AMP] = ACTIONS(7494),
    [anon_sym_PIPE_PIPE] = ACTIONS(7492),
    [anon_sym_AMP_AMP] = ACTIONS(7492),
    [anon_sym_LT] = ACTIONS(7494),
    [anon_sym_LT_EQ] = ACTIONS(7492),
    [anon_sym_GT] = ACTIONS(7494),
    [anon_sym_GT_EQ] = ACTIONS(7492),
    [anon_sym_EQ_EQ] = ACTIONS(7492),
    [anon_sym_BANG_EQ] = ACTIONS(7492),
    [anon_sym_STAR] = ACTIONS(7494),
    [anon_sym_SLASH] = ACTIONS(7492),
    [anon_sym_STAR_STAR] = ACTIONS(7492),
    [anon_sym_CARET] = ACTIONS(7492),
    [aux_sym_binary_operator_token1] = ACTIONS(7492),
    [anon_sym_PIPE_GT] = ACTIONS(7492),
    [anon_sym_COLON] = ACTIONS(7494),
    [anon_sym_DOLLAR] = ACTIONS(7492),
    [anon_sym_AT] = ACTIONS(7492),
    [aux_sym__hex_literal_token1] = ACTIONS(7492),
    [sym__number_literal] = ACTIONS(7494),
    [anon_sym_SQUOTE] = ACTIONS(7492),
    [anon_sym_DQUOTE] = ACTIONS(7492),
    [sym_return] = ACTIONS(7494),
    [sym_next] = ACTIONS(7494),
    [sym_break] = ACTIONS(7494),
    [sym_true] = ACTIONS(7494),
    [sym_false] = ACTIONS(7494),
    [sym_null] = ACTIONS(7494),
    [sym_inf] = ACTIONS(7494),
    [sym_nan] = ACTIONS(7494),
    [anon_sym_NA] = ACTIONS(7494),
    [anon_sym_NA_integer_] = ACTIONS(7494),
    [anon_sym_NA_real_] = ACTIONS(7494),
    [anon_sym_NA_complex_] = ACTIONS(7494),
    [anon_sym_NA_character_] = ACTIONS(7494),
    [sym_dots] = ACTIONS(7494),
    [sym_dot_dot_i] = ACTIONS(7492),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7492),
    [sym__newline] = ACTIONS(7492),
    [sym__semicolon] = ACTIONS(7492),
    [sym__raw_string_literal] = ACTIONS(7492),
    [sym__external_open_parenthesis] = ACTIONS(7492),
    [sym__external_open_brace] = ACTIONS(7492),
    [sym__external_close_brace] = ACTIONS(7492),
    [sym__external_open_bracket] = ACTIONS(7492),
    [sym__external_close_bracket] = ACTIONS(7492),
    [sym__external_open_bracket2] = ACTIONS(7492),
  },
  [2603] = {
    [ts_builtin_sym_end] = ACTIONS(5327),
    [sym_identifier] = ACTIONS(5325),
    [anon_sym_BSLASH] = ACTIONS(5327),
    [anon_sym_function] = ACTIONS(5325),
    [anon_sym_EQ] = ACTIONS(5325),
    [anon_sym_if] = ACTIONS(5325),
    [anon_sym_for] = ACTIONS(5325),
    [anon_sym_while] = ACTIONS(5325),
    [anon_sym_repeat] = ACTIONS(5325),
    [anon_sym_QMARK] = ACTIONS(5327),
    [anon_sym_TILDE] = ACTIONS(5327),
    [anon_sym_BANG] = ACTIONS(5325),
    [anon_sym_PLUS] = ACTIONS(5327),
    [anon_sym_DASH] = ACTIONS(5325),
    [anon_sym_LT_DASH] = ACTIONS(5327),
    [anon_sym_LT_LT_DASH] = ACTIONS(5327),
    [anon_sym_COLON_EQ] = ACTIONS(5327),
    [anon_sym_DASH_GT] = ACTIONS(5325),
    [anon_sym_DASH_GT_GT] = ACTIONS(5327),
    [anon_sym_PIPE] = ACTIONS(5325),
    [anon_sym_AMP] = ACTIONS(5325),
    [anon_sym_PIPE_PIPE] = ACTIONS(5327),
    [anon_sym_AMP_AMP] = ACTIONS(5327),
    [anon_sym_LT] = ACTIONS(5325),
    [anon_sym_LT_EQ] = ACTIONS(5327),
    [anon_sym_GT] = ACTIONS(5325),
    [anon_sym_GT_EQ] = ACTIONS(5327),
    [anon_sym_EQ_EQ] = ACTIONS(5327),
    [anon_sym_BANG_EQ] = ACTIONS(5327),
    [anon_sym_STAR] = ACTIONS(5325),
    [anon_sym_SLASH] = ACTIONS(5327),
    [anon_sym_STAR_STAR] = ACTIONS(5327),
    [anon_sym_CARET] = ACTIONS(5327),
    [aux_sym_binary_operator_token1] = ACTIONS(5327),
    [anon_sym_PIPE_GT] = ACTIONS(5327),
    [anon_sym_COLON] = ACTIONS(5325),
    [anon_sym_DOLLAR] = ACTIONS(5327),
    [anon_sym_AT] = ACTIONS(5327),
    [aux_sym__hex_literal_token1] = ACTIONS(5327),
    [sym__number_literal] = ACTIONS(5325),
    [anon_sym_SQUOTE] = ACTIONS(5327),
    [anon_sym_DQUOTE] = ACTIONS(5327),
    [sym_return] = ACTIONS(5325),
    [sym_next] = ACTIONS(5325),
    [sym_break] = ACTIONS(5325),
    [sym_true] = ACTIONS(5325),
    [sym_false] = ACTIONS(5325),
    [sym_null] = ACTIONS(5325),
    [sym_inf] = ACTIONS(5325),
    [sym_nan] = ACTIONS(5325),
    [anon_sym_NA] = ACTIONS(5325),
    [anon_sym_NA_integer_] = ACTIONS(5325),
    [anon_sym_NA_real_] = ACTIONS(5325),
    [anon_sym_NA_complex_] = ACTIONS(5325),
    [anon_sym_NA_character_] = ACTIONS(5325),
    [sym_dots] = ACTIONS(5325),
    [sym_dot_dot_i] = ACTIONS(5327),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5327),
    [sym__semicolon] = ACTIONS(5327),
    [sym__raw_string_literal] = ACTIONS(5327),
    [sym__external_else] = ACTIONS(5327),
    [sym__external_open_parenthesis] = ACTIONS(5327),
    [sym__external_open_brace] = ACTIONS(5327),
    [sym__external_close_brace] = ACTIONS(5327),
    [sym__external_open_bracket] = ACTIONS(5327),
    [sym__external_open_bracket2] = ACTIONS(5327),
  },
  [2604] = {
    [sym_identifier] = ACTIONS(7482),
    [anon_sym_BSLASH] = ACTIONS(7480),
    [anon_sym_function] = ACTIONS(7482),
    [anon_sym_EQ] = ACTIONS(7482),
    [anon_sym_if] = ACTIONS(7482),
    [anon_sym_for] = ACTIONS(7482),
    [anon_sym_while] = ACTIONS(7482),
    [anon_sym_repeat] = ACTIONS(7482),
    [anon_sym_QMARK] = ACTIONS(7480),
    [anon_sym_TILDE] = ACTIONS(7480),
    [anon_sym_BANG] = ACTIONS(7482),
    [anon_sym_PLUS] = ACTIONS(7480),
    [anon_sym_DASH] = ACTIONS(7482),
    [anon_sym_LT_DASH] = ACTIONS(7480),
    [anon_sym_LT_LT_DASH] = ACTIONS(7480),
    [anon_sym_COLON_EQ] = ACTIONS(7480),
    [anon_sym_DASH_GT] = ACTIONS(7482),
    [anon_sym_DASH_GT_GT] = ACTIONS(7480),
    [anon_sym_PIPE] = ACTIONS(7482),
    [anon_sym_AMP] = ACTIONS(7482),
    [anon_sym_PIPE_PIPE] = ACTIONS(7480),
    [anon_sym_AMP_AMP] = ACTIONS(7480),
    [anon_sym_LT] = ACTIONS(7482),
    [anon_sym_LT_EQ] = ACTIONS(7480),
    [anon_sym_GT] = ACTIONS(7482),
    [anon_sym_GT_EQ] = ACTIONS(7480),
    [anon_sym_EQ_EQ] = ACTIONS(7480),
    [anon_sym_BANG_EQ] = ACTIONS(7480),
    [anon_sym_STAR] = ACTIONS(7482),
    [anon_sym_SLASH] = ACTIONS(7480),
    [anon_sym_STAR_STAR] = ACTIONS(7480),
    [anon_sym_CARET] = ACTIONS(7480),
    [aux_sym_binary_operator_token1] = ACTIONS(7480),
    [anon_sym_PIPE_GT] = ACTIONS(7480),
    [anon_sym_COLON] = ACTIONS(7482),
    [anon_sym_DOLLAR] = ACTIONS(7480),
    [anon_sym_AT] = ACTIONS(7480),
    [aux_sym__hex_literal_token1] = ACTIONS(7480),
    [sym__number_literal] = ACTIONS(7482),
    [anon_sym_SQUOTE] = ACTIONS(7480),
    [anon_sym_DQUOTE] = ACTIONS(7480),
    [sym_return] = ACTIONS(7482),
    [sym_next] = ACTIONS(7482),
    [sym_break] = ACTIONS(7482),
    [sym_true] = ACTIONS(7482),
    [sym_false] = ACTIONS(7482),
    [sym_null] = ACTIONS(7482),
    [sym_inf] = ACTIONS(7482),
    [sym_nan] = ACTIONS(7482),
    [anon_sym_NA] = ACTIONS(7482),
    [anon_sym_NA_integer_] = ACTIONS(7482),
    [anon_sym_NA_real_] = ACTIONS(7482),
    [anon_sym_NA_complex_] = ACTIONS(7482),
    [anon_sym_NA_character_] = ACTIONS(7482),
    [sym_dots] = ACTIONS(7482),
    [sym_dot_dot_i] = ACTIONS(7480),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7480),
    [sym__newline] = ACTIONS(7480),
    [sym__raw_string_literal] = ACTIONS(7480),
    [sym__external_else] = ACTIONS(7480),
    [sym__external_open_parenthesis] = ACTIONS(7480),
    [sym__external_close_parenthesis] = ACTIONS(7480),
    [sym__external_open_brace] = ACTIONS(7480),
    [sym__external_open_bracket] = ACTIONS(7480),
    [sym__external_open_bracket2] = ACTIONS(7480),
    [sym__external_close_bracket2] = ACTIONS(7480),
  },
  [2605] = {
    [sym_identifier] = ACTIONS(7502),
    [anon_sym_BSLASH] = ACTIONS(7500),
    [anon_sym_function] = ACTIONS(7502),
    [anon_sym_EQ] = ACTIONS(7502),
    [anon_sym_if] = ACTIONS(7502),
    [anon_sym_for] = ACTIONS(7502),
    [anon_sym_while] = ACTIONS(7502),
    [anon_sym_repeat] = ACTIONS(7502),
    [anon_sym_QMARK] = ACTIONS(7500),
    [anon_sym_TILDE] = ACTIONS(7500),
    [anon_sym_BANG] = ACTIONS(7502),
    [anon_sym_PLUS] = ACTIONS(7500),
    [anon_sym_DASH] = ACTIONS(7502),
    [anon_sym_LT_DASH] = ACTIONS(7500),
    [anon_sym_LT_LT_DASH] = ACTIONS(7500),
    [anon_sym_COLON_EQ] = ACTIONS(7500),
    [anon_sym_DASH_GT] = ACTIONS(7502),
    [anon_sym_DASH_GT_GT] = ACTIONS(7500),
    [anon_sym_PIPE] = ACTIONS(7502),
    [anon_sym_AMP] = ACTIONS(7502),
    [anon_sym_PIPE_PIPE] = ACTIONS(7500),
    [anon_sym_AMP_AMP] = ACTIONS(7500),
    [anon_sym_LT] = ACTIONS(7502),
    [anon_sym_LT_EQ] = ACTIONS(7500),
    [anon_sym_GT] = ACTIONS(7502),
    [anon_sym_GT_EQ] = ACTIONS(7500),
    [anon_sym_EQ_EQ] = ACTIONS(7500),
    [anon_sym_BANG_EQ] = ACTIONS(7500),
    [anon_sym_STAR] = ACTIONS(7502),
    [anon_sym_SLASH] = ACTIONS(7500),
    [anon_sym_STAR_STAR] = ACTIONS(7500),
    [anon_sym_CARET] = ACTIONS(7500),
    [aux_sym_binary_operator_token1] = ACTIONS(7500),
    [anon_sym_PIPE_GT] = ACTIONS(7500),
    [anon_sym_COLON] = ACTIONS(7502),
    [anon_sym_DOLLAR] = ACTIONS(7500),
    [anon_sym_AT] = ACTIONS(7500),
    [aux_sym__hex_literal_token1] = ACTIONS(7500),
    [sym__number_literal] = ACTIONS(7502),
    [anon_sym_SQUOTE] = ACTIONS(7500),
    [anon_sym_DQUOTE] = ACTIONS(7500),
    [sym_return] = ACTIONS(7502),
    [sym_next] = ACTIONS(7502),
    [sym_break] = ACTIONS(7502),
    [sym_true] = ACTIONS(7502),
    [sym_false] = ACTIONS(7502),
    [sym_null] = ACTIONS(7502),
    [sym_inf] = ACTIONS(7502),
    [sym_nan] = ACTIONS(7502),
    [anon_sym_NA] = ACTIONS(7502),
    [anon_sym_NA_integer_] = ACTIONS(7502),
    [anon_sym_NA_real_] = ACTIONS(7502),
    [anon_sym_NA_complex_] = ACTIONS(7502),
    [anon_sym_NA_character_] = ACTIONS(7502),
    [sym_dots] = ACTIONS(7502),
    [sym_dot_dot_i] = ACTIONS(7500),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7500),
    [sym__newline] = ACTIONS(7500),
    [sym__semicolon] = ACTIONS(7500),
    [sym__raw_string_literal] = ACTIONS(7500),
    [sym__external_open_parenthesis] = ACTIONS(7500),
    [sym__external_open_brace] = ACTIONS(7500),
    [sym__external_close_brace] = ACTIONS(7500),
    [sym__external_open_bracket] = ACTIONS(7500),
    [sym__external_close_bracket] = ACTIONS(7500),
    [sym__external_open_bracket2] = ACTIONS(7500),
  },
  [2606] = {
    [sym_identifier] = ACTIONS(7129),
    [anon_sym_BSLASH] = ACTIONS(7131),
    [anon_sym_function] = ACTIONS(7129),
    [anon_sym_EQ] = ACTIONS(7658),
    [anon_sym_if] = ACTIONS(7129),
    [anon_sym_for] = ACTIONS(7129),
    [anon_sym_while] = ACTIONS(7129),
    [anon_sym_repeat] = ACTIONS(7129),
    [anon_sym_QMARK] = ACTIONS(7131),
    [anon_sym_TILDE] = ACTIONS(7131),
    [anon_sym_BANG] = ACTIONS(7129),
    [anon_sym_PLUS] = ACTIONS(7131),
    [anon_sym_DASH] = ACTIONS(7129),
    [anon_sym_LT_DASH] = ACTIONS(7131),
    [anon_sym_LT_LT_DASH] = ACTIONS(7131),
    [anon_sym_COLON_EQ] = ACTIONS(7131),
    [anon_sym_DASH_GT] = ACTIONS(7129),
    [anon_sym_DASH_GT_GT] = ACTIONS(7131),
    [anon_sym_PIPE] = ACTIONS(7129),
    [anon_sym_AMP] = ACTIONS(7129),
    [anon_sym_PIPE_PIPE] = ACTIONS(7131),
    [anon_sym_AMP_AMP] = ACTIONS(7131),
    [anon_sym_LT] = ACTIONS(7129),
    [anon_sym_LT_EQ] = ACTIONS(7131),
    [anon_sym_GT] = ACTIONS(7129),
    [anon_sym_GT_EQ] = ACTIONS(7131),
    [anon_sym_EQ_EQ] = ACTIONS(7131),
    [anon_sym_BANG_EQ] = ACTIONS(7131),
    [anon_sym_STAR] = ACTIONS(7129),
    [anon_sym_SLASH] = ACTIONS(7131),
    [anon_sym_STAR_STAR] = ACTIONS(7131),
    [anon_sym_CARET] = ACTIONS(7131),
    [aux_sym_binary_operator_token1] = ACTIONS(7131),
    [anon_sym_PIPE_GT] = ACTIONS(7131),
    [anon_sym_COLON] = ACTIONS(7129),
    [anon_sym_DOLLAR] = ACTIONS(7131),
    [anon_sym_AT] = ACTIONS(7131),
    [anon_sym_COLON_COLON] = ACTIONS(7133),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7135),
    [aux_sym__hex_literal_token1] = ACTIONS(7131),
    [sym__number_literal] = ACTIONS(7129),
    [anon_sym_SQUOTE] = ACTIONS(7131),
    [anon_sym_DQUOTE] = ACTIONS(7131),
    [sym_return] = ACTIONS(7129),
    [sym_next] = ACTIONS(7129),
    [sym_break] = ACTIONS(7129),
    [sym_true] = ACTIONS(7129),
    [sym_false] = ACTIONS(7129),
    [sym_null] = ACTIONS(7129),
    [sym_inf] = ACTIONS(7129),
    [sym_nan] = ACTIONS(7129),
    [anon_sym_NA] = ACTIONS(7129),
    [anon_sym_NA_integer_] = ACTIONS(7129),
    [anon_sym_NA_real_] = ACTIONS(7129),
    [anon_sym_NA_complex_] = ACTIONS(7129),
    [anon_sym_NA_character_] = ACTIONS(7129),
    [sym_dots] = ACTIONS(7129),
    [sym_dot_dot_i] = ACTIONS(7131),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7131),
    [sym__newline] = ACTIONS(7131),
    [sym__raw_string_literal] = ACTIONS(7131),
    [sym__external_open_parenthesis] = ACTIONS(7131),
    [sym__external_open_brace] = ACTIONS(7131),
    [sym__external_open_bracket] = ACTIONS(7131),
    [sym__external_open_bracket2] = ACTIONS(7131),
    [sym__external_close_bracket2] = ACTIONS(7131),
  },
  [2607] = {
    [sym_identifier] = ACTIONS(5325),
    [anon_sym_BSLASH] = ACTIONS(5327),
    [anon_sym_function] = ACTIONS(5325),
    [anon_sym_EQ] = ACTIONS(5325),
    [anon_sym_if] = ACTIONS(5325),
    [anon_sym_for] = ACTIONS(5325),
    [anon_sym_while] = ACTIONS(5325),
    [anon_sym_repeat] = ACTIONS(5325),
    [anon_sym_QMARK] = ACTIONS(5327),
    [anon_sym_TILDE] = ACTIONS(5327),
    [anon_sym_BANG] = ACTIONS(5325),
    [anon_sym_PLUS] = ACTIONS(5327),
    [anon_sym_DASH] = ACTIONS(5325),
    [anon_sym_LT_DASH] = ACTIONS(5327),
    [anon_sym_LT_LT_DASH] = ACTIONS(5327),
    [anon_sym_COLON_EQ] = ACTIONS(5327),
    [anon_sym_DASH_GT] = ACTIONS(5325),
    [anon_sym_DASH_GT_GT] = ACTIONS(5327),
    [anon_sym_PIPE] = ACTIONS(5325),
    [anon_sym_AMP] = ACTIONS(5325),
    [anon_sym_PIPE_PIPE] = ACTIONS(5327),
    [anon_sym_AMP_AMP] = ACTIONS(5327),
    [anon_sym_LT] = ACTIONS(5325),
    [anon_sym_LT_EQ] = ACTIONS(5327),
    [anon_sym_GT] = ACTIONS(5325),
    [anon_sym_GT_EQ] = ACTIONS(5327),
    [anon_sym_EQ_EQ] = ACTIONS(5327),
    [anon_sym_BANG_EQ] = ACTIONS(5327),
    [anon_sym_STAR] = ACTIONS(5325),
    [anon_sym_SLASH] = ACTIONS(5327),
    [anon_sym_STAR_STAR] = ACTIONS(5327),
    [anon_sym_CARET] = ACTIONS(5327),
    [aux_sym_binary_operator_token1] = ACTIONS(5327),
    [anon_sym_PIPE_GT] = ACTIONS(5327),
    [anon_sym_COLON] = ACTIONS(5325),
    [anon_sym_DOLLAR] = ACTIONS(5327),
    [anon_sym_AT] = ACTIONS(5327),
    [aux_sym__hex_literal_token1] = ACTIONS(5327),
    [sym__number_literal] = ACTIONS(5325),
    [anon_sym_SQUOTE] = ACTIONS(5327),
    [anon_sym_DQUOTE] = ACTIONS(5327),
    [sym_return] = ACTIONS(5325),
    [sym_next] = ACTIONS(5325),
    [sym_break] = ACTIONS(5325),
    [sym_true] = ACTIONS(5325),
    [sym_false] = ACTIONS(5325),
    [sym_null] = ACTIONS(5325),
    [sym_inf] = ACTIONS(5325),
    [sym_nan] = ACTIONS(5325),
    [anon_sym_NA] = ACTIONS(5325),
    [anon_sym_NA_integer_] = ACTIONS(5325),
    [anon_sym_NA_real_] = ACTIONS(5325),
    [anon_sym_NA_complex_] = ACTIONS(5325),
    [anon_sym_NA_character_] = ACTIONS(5325),
    [sym_dots] = ACTIONS(5325),
    [sym_dot_dot_i] = ACTIONS(5327),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5327),
    [sym__newline] = ACTIONS(5327),
    [sym__semicolon] = ACTIONS(5327),
    [sym__raw_string_literal] = ACTIONS(5327),
    [sym__external_open_parenthesis] = ACTIONS(5327),
    [sym__external_open_brace] = ACTIONS(5327),
    [sym__external_close_brace] = ACTIONS(5327),
    [sym__external_open_bracket] = ACTIONS(5327),
    [sym__external_close_bracket] = ACTIONS(5327),
    [sym__external_open_bracket2] = ACTIONS(5327),
  },
  [2608] = {
    [ts_builtin_sym_end] = ACTIONS(7480),
    [sym_identifier] = ACTIONS(7482),
    [anon_sym_BSLASH] = ACTIONS(7480),
    [anon_sym_function] = ACTIONS(7482),
    [anon_sym_EQ] = ACTIONS(7482),
    [anon_sym_if] = ACTIONS(7482),
    [anon_sym_for] = ACTIONS(7482),
    [anon_sym_while] = ACTIONS(7482),
    [anon_sym_repeat] = ACTIONS(7482),
    [anon_sym_QMARK] = ACTIONS(7480),
    [anon_sym_TILDE] = ACTIONS(7480),
    [anon_sym_BANG] = ACTIONS(7482),
    [anon_sym_PLUS] = ACTIONS(7480),
    [anon_sym_DASH] = ACTIONS(7482),
    [anon_sym_LT_DASH] = ACTIONS(7480),
    [anon_sym_LT_LT_DASH] = ACTIONS(7480),
    [anon_sym_COLON_EQ] = ACTIONS(7480),
    [anon_sym_DASH_GT] = ACTIONS(7482),
    [anon_sym_DASH_GT_GT] = ACTIONS(7480),
    [anon_sym_PIPE] = ACTIONS(7482),
    [anon_sym_AMP] = ACTIONS(7482),
    [anon_sym_PIPE_PIPE] = ACTIONS(7480),
    [anon_sym_AMP_AMP] = ACTIONS(7480),
    [anon_sym_LT] = ACTIONS(7482),
    [anon_sym_LT_EQ] = ACTIONS(7480),
    [anon_sym_GT] = ACTIONS(7482),
    [anon_sym_GT_EQ] = ACTIONS(7480),
    [anon_sym_EQ_EQ] = ACTIONS(7480),
    [anon_sym_BANG_EQ] = ACTIONS(7480),
    [anon_sym_STAR] = ACTIONS(7482),
    [anon_sym_SLASH] = ACTIONS(7480),
    [anon_sym_STAR_STAR] = ACTIONS(7480),
    [anon_sym_CARET] = ACTIONS(7480),
    [aux_sym_binary_operator_token1] = ACTIONS(7480),
    [anon_sym_PIPE_GT] = ACTIONS(7480),
    [anon_sym_COLON] = ACTIONS(7482),
    [anon_sym_DOLLAR] = ACTIONS(7480),
    [anon_sym_AT] = ACTIONS(7480),
    [aux_sym__hex_literal_token1] = ACTIONS(7480),
    [sym__number_literal] = ACTIONS(7482),
    [anon_sym_SQUOTE] = ACTIONS(7480),
    [anon_sym_DQUOTE] = ACTIONS(7480),
    [sym_return] = ACTIONS(7482),
    [sym_next] = ACTIONS(7482),
    [sym_break] = ACTIONS(7482),
    [sym_true] = ACTIONS(7482),
    [sym_false] = ACTIONS(7482),
    [sym_null] = ACTIONS(7482),
    [sym_inf] = ACTIONS(7482),
    [sym_nan] = ACTIONS(7482),
    [anon_sym_NA] = ACTIONS(7482),
    [anon_sym_NA_integer_] = ACTIONS(7482),
    [anon_sym_NA_real_] = ACTIONS(7482),
    [anon_sym_NA_complex_] = ACTIONS(7482),
    [anon_sym_NA_character_] = ACTIONS(7482),
    [sym_dots] = ACTIONS(7482),
    [sym_dot_dot_i] = ACTIONS(7480),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7480),
    [sym__semicolon] = ACTIONS(7480),
    [sym__raw_string_literal] = ACTIONS(7480),
    [sym__external_else] = ACTIONS(7480),
    [sym__external_open_parenthesis] = ACTIONS(7480),
    [sym__external_open_brace] = ACTIONS(7480),
    [sym__external_close_brace] = ACTIONS(7480),
    [sym__external_open_bracket] = ACTIONS(7480),
    [sym__external_open_bracket2] = ACTIONS(7480),
  },
  [2609] = {
    [ts_builtin_sym_end] = ACTIONS(7476),
    [sym_identifier] = ACTIONS(7478),
    [anon_sym_BSLASH] = ACTIONS(7476),
    [anon_sym_function] = ACTIONS(7478),
    [anon_sym_EQ] = ACTIONS(7478),
    [anon_sym_if] = ACTIONS(7478),
    [anon_sym_for] = ACTIONS(7478),
    [anon_sym_while] = ACTIONS(7478),
    [anon_sym_repeat] = ACTIONS(7478),
    [anon_sym_QMARK] = ACTIONS(7476),
    [anon_sym_TILDE] = ACTIONS(7476),
    [anon_sym_BANG] = ACTIONS(7478),
    [anon_sym_PLUS] = ACTIONS(7476),
    [anon_sym_DASH] = ACTIONS(7478),
    [anon_sym_LT_DASH] = ACTIONS(7476),
    [anon_sym_LT_LT_DASH] = ACTIONS(7476),
    [anon_sym_COLON_EQ] = ACTIONS(7476),
    [anon_sym_DASH_GT] = ACTIONS(7478),
    [anon_sym_DASH_GT_GT] = ACTIONS(7476),
    [anon_sym_PIPE] = ACTIONS(7478),
    [anon_sym_AMP] = ACTIONS(7478),
    [anon_sym_PIPE_PIPE] = ACTIONS(7476),
    [anon_sym_AMP_AMP] = ACTIONS(7476),
    [anon_sym_LT] = ACTIONS(7478),
    [anon_sym_LT_EQ] = ACTIONS(7476),
    [anon_sym_GT] = ACTIONS(7478),
    [anon_sym_GT_EQ] = ACTIONS(7476),
    [anon_sym_EQ_EQ] = ACTIONS(7476),
    [anon_sym_BANG_EQ] = ACTIONS(7476),
    [anon_sym_STAR] = ACTIONS(7478),
    [anon_sym_SLASH] = ACTIONS(7476),
    [anon_sym_STAR_STAR] = ACTIONS(7476),
    [anon_sym_CARET] = ACTIONS(7476),
    [aux_sym_binary_operator_token1] = ACTIONS(7476),
    [anon_sym_PIPE_GT] = ACTIONS(7476),
    [anon_sym_COLON] = ACTIONS(7478),
    [anon_sym_DOLLAR] = ACTIONS(7476),
    [anon_sym_AT] = ACTIONS(7476),
    [aux_sym__hex_literal_token1] = ACTIONS(7476),
    [sym__number_literal] = ACTIONS(7478),
    [anon_sym_SQUOTE] = ACTIONS(7476),
    [anon_sym_DQUOTE] = ACTIONS(7476),
    [sym_return] = ACTIONS(7478),
    [sym_next] = ACTIONS(7478),
    [sym_break] = ACTIONS(7478),
    [sym_true] = ACTIONS(7478),
    [sym_false] = ACTIONS(7478),
    [sym_null] = ACTIONS(7478),
    [sym_inf] = ACTIONS(7478),
    [sym_nan] = ACTIONS(7478),
    [anon_sym_NA] = ACTIONS(7478),
    [anon_sym_NA_integer_] = ACTIONS(7478),
    [anon_sym_NA_real_] = ACTIONS(7478),
    [anon_sym_NA_complex_] = ACTIONS(7478),
    [anon_sym_NA_character_] = ACTIONS(7478),
    [sym_dots] = ACTIONS(7478),
    [sym_dot_dot_i] = ACTIONS(7476),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7476),
    [sym__semicolon] = ACTIONS(7476),
    [sym__raw_string_literal] = ACTIONS(7476),
    [sym__external_else] = ACTIONS(7476),
    [sym__external_open_parenthesis] = ACTIONS(7476),
    [sym__external_open_brace] = ACTIONS(7476),
    [sym__external_close_brace] = ACTIONS(7476),
    [sym__external_open_bracket] = ACTIONS(7476),
    [sym__external_open_bracket2] = ACTIONS(7476),
  },
  [2610] = {
    [ts_builtin_sym_end] = ACTIONS(7466),
    [sym_identifier] = ACTIONS(7464),
    [anon_sym_BSLASH] = ACTIONS(7466),
    [anon_sym_function] = ACTIONS(7464),
    [anon_sym_EQ] = ACTIONS(7464),
    [anon_sym_if] = ACTIONS(7464),
    [anon_sym_for] = ACTIONS(7464),
    [anon_sym_while] = ACTIONS(7464),
    [anon_sym_repeat] = ACTIONS(7464),
    [anon_sym_QMARK] = ACTIONS(7466),
    [anon_sym_TILDE] = ACTIONS(7466),
    [anon_sym_BANG] = ACTIONS(7464),
    [anon_sym_PLUS] = ACTIONS(7466),
    [anon_sym_DASH] = ACTIONS(7464),
    [anon_sym_LT_DASH] = ACTIONS(7466),
    [anon_sym_LT_LT_DASH] = ACTIONS(7466),
    [anon_sym_COLON_EQ] = ACTIONS(7466),
    [anon_sym_DASH_GT] = ACTIONS(7464),
    [anon_sym_DASH_GT_GT] = ACTIONS(7466),
    [anon_sym_PIPE] = ACTIONS(7464),
    [anon_sym_AMP] = ACTIONS(7464),
    [anon_sym_PIPE_PIPE] = ACTIONS(7466),
    [anon_sym_AMP_AMP] = ACTIONS(7466),
    [anon_sym_LT] = ACTIONS(7464),
    [anon_sym_LT_EQ] = ACTIONS(7466),
    [anon_sym_GT] = ACTIONS(7464),
    [anon_sym_GT_EQ] = ACTIONS(7466),
    [anon_sym_EQ_EQ] = ACTIONS(7466),
    [anon_sym_BANG_EQ] = ACTIONS(7466),
    [anon_sym_STAR] = ACTIONS(7464),
    [anon_sym_SLASH] = ACTIONS(7466),
    [anon_sym_STAR_STAR] = ACTIONS(7466),
    [anon_sym_CARET] = ACTIONS(7466),
    [aux_sym_binary_operator_token1] = ACTIONS(7466),
    [anon_sym_PIPE_GT] = ACTIONS(7466),
    [anon_sym_COLON] = ACTIONS(7464),
    [anon_sym_DOLLAR] = ACTIONS(7466),
    [anon_sym_AT] = ACTIONS(7466),
    [aux_sym__hex_literal_token1] = ACTIONS(7466),
    [sym__number_literal] = ACTIONS(7464),
    [anon_sym_SQUOTE] = ACTIONS(7466),
    [anon_sym_DQUOTE] = ACTIONS(7466),
    [sym_return] = ACTIONS(7464),
    [sym_next] = ACTIONS(7464),
    [sym_break] = ACTIONS(7464),
    [sym_true] = ACTIONS(7464),
    [sym_false] = ACTIONS(7464),
    [sym_null] = ACTIONS(7464),
    [sym_inf] = ACTIONS(7464),
    [sym_nan] = ACTIONS(7464),
    [anon_sym_NA] = ACTIONS(7464),
    [anon_sym_NA_integer_] = ACTIONS(7464),
    [anon_sym_NA_real_] = ACTIONS(7464),
    [anon_sym_NA_complex_] = ACTIONS(7464),
    [anon_sym_NA_character_] = ACTIONS(7464),
    [sym_dots] = ACTIONS(7464),
    [sym_dot_dot_i] = ACTIONS(7466),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7466),
    [sym__semicolon] = ACTIONS(7466),
    [sym__raw_string_literal] = ACTIONS(7466),
    [sym__external_else] = ACTIONS(7466),
    [sym__external_open_parenthesis] = ACTIONS(7466),
    [sym__external_open_brace] = ACTIONS(7466),
    [sym__external_close_brace] = ACTIONS(7466),
    [sym__external_open_bracket] = ACTIONS(7466),
    [sym__external_open_bracket2] = ACTIONS(7466),
  },
  [2611] = {
    [ts_builtin_sym_end] = ACTIONS(7472),
    [sym_identifier] = ACTIONS(7474),
    [anon_sym_BSLASH] = ACTIONS(7472),
    [anon_sym_function] = ACTIONS(7474),
    [anon_sym_EQ] = ACTIONS(7474),
    [anon_sym_if] = ACTIONS(7474),
    [anon_sym_for] = ACTIONS(7474),
    [anon_sym_while] = ACTIONS(7474),
    [anon_sym_repeat] = ACTIONS(7474),
    [anon_sym_QMARK] = ACTIONS(7472),
    [anon_sym_TILDE] = ACTIONS(7472),
    [anon_sym_BANG] = ACTIONS(7474),
    [anon_sym_PLUS] = ACTIONS(7472),
    [anon_sym_DASH] = ACTIONS(7474),
    [anon_sym_LT_DASH] = ACTIONS(7472),
    [anon_sym_LT_LT_DASH] = ACTIONS(7472),
    [anon_sym_COLON_EQ] = ACTIONS(7472),
    [anon_sym_DASH_GT] = ACTIONS(7474),
    [anon_sym_DASH_GT_GT] = ACTIONS(7472),
    [anon_sym_PIPE] = ACTIONS(7474),
    [anon_sym_AMP] = ACTIONS(7474),
    [anon_sym_PIPE_PIPE] = ACTIONS(7472),
    [anon_sym_AMP_AMP] = ACTIONS(7472),
    [anon_sym_LT] = ACTIONS(7474),
    [anon_sym_LT_EQ] = ACTIONS(7472),
    [anon_sym_GT] = ACTIONS(7474),
    [anon_sym_GT_EQ] = ACTIONS(7472),
    [anon_sym_EQ_EQ] = ACTIONS(7472),
    [anon_sym_BANG_EQ] = ACTIONS(7472),
    [anon_sym_STAR] = ACTIONS(7474),
    [anon_sym_SLASH] = ACTIONS(7472),
    [anon_sym_STAR_STAR] = ACTIONS(7472),
    [anon_sym_CARET] = ACTIONS(7472),
    [aux_sym_binary_operator_token1] = ACTIONS(7472),
    [anon_sym_PIPE_GT] = ACTIONS(7472),
    [anon_sym_COLON] = ACTIONS(7474),
    [anon_sym_DOLLAR] = ACTIONS(7472),
    [anon_sym_AT] = ACTIONS(7472),
    [aux_sym__hex_literal_token1] = ACTIONS(7472),
    [sym__number_literal] = ACTIONS(7474),
    [anon_sym_SQUOTE] = ACTIONS(7472),
    [anon_sym_DQUOTE] = ACTIONS(7472),
    [sym_return] = ACTIONS(7474),
    [sym_next] = ACTIONS(7474),
    [sym_break] = ACTIONS(7474),
    [sym_true] = ACTIONS(7474),
    [sym_false] = ACTIONS(7474),
    [sym_null] = ACTIONS(7474),
    [sym_inf] = ACTIONS(7474),
    [sym_nan] = ACTIONS(7474),
    [anon_sym_NA] = ACTIONS(7474),
    [anon_sym_NA_integer_] = ACTIONS(7474),
    [anon_sym_NA_real_] = ACTIONS(7474),
    [anon_sym_NA_complex_] = ACTIONS(7474),
    [anon_sym_NA_character_] = ACTIONS(7474),
    [sym_dots] = ACTIONS(7474),
    [sym_dot_dot_i] = ACTIONS(7472),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7472),
    [sym__semicolon] = ACTIONS(7472),
    [sym__raw_string_literal] = ACTIONS(7472),
    [sym__external_else] = ACTIONS(7472),
    [sym__external_open_parenthesis] = ACTIONS(7472),
    [sym__external_open_brace] = ACTIONS(7472),
    [sym__external_close_brace] = ACTIONS(7472),
    [sym__external_open_bracket] = ACTIONS(7472),
    [sym__external_open_bracket2] = ACTIONS(7472),
  },
  [2612] = {
    [sym_identifier] = ACTIONS(7506),
    [anon_sym_BSLASH] = ACTIONS(7504),
    [anon_sym_function] = ACTIONS(7506),
    [anon_sym_EQ] = ACTIONS(7506),
    [anon_sym_if] = ACTIONS(7506),
    [anon_sym_for] = ACTIONS(7506),
    [anon_sym_while] = ACTIONS(7506),
    [anon_sym_repeat] = ACTIONS(7506),
    [anon_sym_QMARK] = ACTIONS(7504),
    [anon_sym_TILDE] = ACTIONS(7504),
    [anon_sym_BANG] = ACTIONS(7506),
    [anon_sym_PLUS] = ACTIONS(7504),
    [anon_sym_DASH] = ACTIONS(7506),
    [anon_sym_LT_DASH] = ACTIONS(7504),
    [anon_sym_LT_LT_DASH] = ACTIONS(7504),
    [anon_sym_COLON_EQ] = ACTIONS(7504),
    [anon_sym_DASH_GT] = ACTIONS(7506),
    [anon_sym_DASH_GT_GT] = ACTIONS(7504),
    [anon_sym_PIPE] = ACTIONS(7506),
    [anon_sym_AMP] = ACTIONS(7506),
    [anon_sym_PIPE_PIPE] = ACTIONS(7504),
    [anon_sym_AMP_AMP] = ACTIONS(7504),
    [anon_sym_LT] = ACTIONS(7506),
    [anon_sym_LT_EQ] = ACTIONS(7504),
    [anon_sym_GT] = ACTIONS(7506),
    [anon_sym_GT_EQ] = ACTIONS(7504),
    [anon_sym_EQ_EQ] = ACTIONS(7504),
    [anon_sym_BANG_EQ] = ACTIONS(7504),
    [anon_sym_STAR] = ACTIONS(7506),
    [anon_sym_SLASH] = ACTIONS(7504),
    [anon_sym_STAR_STAR] = ACTIONS(7504),
    [anon_sym_CARET] = ACTIONS(7504),
    [aux_sym_binary_operator_token1] = ACTIONS(7504),
    [anon_sym_PIPE_GT] = ACTIONS(7504),
    [anon_sym_COLON] = ACTIONS(7506),
    [anon_sym_DOLLAR] = ACTIONS(7504),
    [anon_sym_AT] = ACTIONS(7504),
    [aux_sym__hex_literal_token1] = ACTIONS(7504),
    [sym__number_literal] = ACTIONS(7506),
    [anon_sym_SQUOTE] = ACTIONS(7504),
    [anon_sym_DQUOTE] = ACTIONS(7504),
    [sym_return] = ACTIONS(7506),
    [sym_next] = ACTIONS(7506),
    [sym_break] = ACTIONS(7506),
    [sym_true] = ACTIONS(7506),
    [sym_false] = ACTIONS(7506),
    [sym_null] = ACTIONS(7506),
    [sym_inf] = ACTIONS(7506),
    [sym_nan] = ACTIONS(7506),
    [anon_sym_NA] = ACTIONS(7506),
    [anon_sym_NA_integer_] = ACTIONS(7506),
    [anon_sym_NA_real_] = ACTIONS(7506),
    [anon_sym_NA_complex_] = ACTIONS(7506),
    [anon_sym_NA_character_] = ACTIONS(7506),
    [sym_dots] = ACTIONS(7506),
    [sym_dot_dot_i] = ACTIONS(7504),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7504),
    [sym__newline] = ACTIONS(7504),
    [sym__semicolon] = ACTIONS(7504),
    [sym__raw_string_literal] = ACTIONS(7504),
    [sym__external_open_parenthesis] = ACTIONS(7504),
    [sym__external_open_brace] = ACTIONS(7504),
    [sym__external_close_brace] = ACTIONS(7504),
    [sym__external_open_bracket] = ACTIONS(7504),
    [sym__external_close_bracket] = ACTIONS(7504),
    [sym__external_open_bracket2] = ACTIONS(7504),
  },
  [2613] = {
    [sym_identifier] = ACTIONS(7498),
    [anon_sym_BSLASH] = ACTIONS(7496),
    [anon_sym_function] = ACTIONS(7498),
    [anon_sym_EQ] = ACTIONS(7498),
    [anon_sym_if] = ACTIONS(7498),
    [anon_sym_for] = ACTIONS(7498),
    [anon_sym_while] = ACTIONS(7498),
    [anon_sym_repeat] = ACTIONS(7498),
    [anon_sym_QMARK] = ACTIONS(7496),
    [anon_sym_TILDE] = ACTIONS(7496),
    [anon_sym_BANG] = ACTIONS(7498),
    [anon_sym_PLUS] = ACTIONS(7496),
    [anon_sym_DASH] = ACTIONS(7498),
    [anon_sym_LT_DASH] = ACTIONS(7496),
    [anon_sym_LT_LT_DASH] = ACTIONS(7496),
    [anon_sym_COLON_EQ] = ACTIONS(7496),
    [anon_sym_DASH_GT] = ACTIONS(7498),
    [anon_sym_DASH_GT_GT] = ACTIONS(7496),
    [anon_sym_PIPE] = ACTIONS(7498),
    [anon_sym_AMP] = ACTIONS(7498),
    [anon_sym_PIPE_PIPE] = ACTIONS(7496),
    [anon_sym_AMP_AMP] = ACTIONS(7496),
    [anon_sym_LT] = ACTIONS(7498),
    [anon_sym_LT_EQ] = ACTIONS(7496),
    [anon_sym_GT] = ACTIONS(7498),
    [anon_sym_GT_EQ] = ACTIONS(7496),
    [anon_sym_EQ_EQ] = ACTIONS(7496),
    [anon_sym_BANG_EQ] = ACTIONS(7496),
    [anon_sym_STAR] = ACTIONS(7498),
    [anon_sym_SLASH] = ACTIONS(7496),
    [anon_sym_STAR_STAR] = ACTIONS(7496),
    [anon_sym_CARET] = ACTIONS(7496),
    [aux_sym_binary_operator_token1] = ACTIONS(7496),
    [anon_sym_PIPE_GT] = ACTIONS(7496),
    [anon_sym_COLON] = ACTIONS(7498),
    [anon_sym_DOLLAR] = ACTIONS(7496),
    [anon_sym_AT] = ACTIONS(7496),
    [aux_sym__hex_literal_token1] = ACTIONS(7496),
    [sym__number_literal] = ACTIONS(7498),
    [anon_sym_SQUOTE] = ACTIONS(7496),
    [anon_sym_DQUOTE] = ACTIONS(7496),
    [sym_return] = ACTIONS(7498),
    [sym_next] = ACTIONS(7498),
    [sym_break] = ACTIONS(7498),
    [sym_true] = ACTIONS(7498),
    [sym_false] = ACTIONS(7498),
    [sym_null] = ACTIONS(7498),
    [sym_inf] = ACTIONS(7498),
    [sym_nan] = ACTIONS(7498),
    [anon_sym_NA] = ACTIONS(7498),
    [anon_sym_NA_integer_] = ACTIONS(7498),
    [anon_sym_NA_real_] = ACTIONS(7498),
    [anon_sym_NA_complex_] = ACTIONS(7498),
    [anon_sym_NA_character_] = ACTIONS(7498),
    [sym_dots] = ACTIONS(7498),
    [sym_dot_dot_i] = ACTIONS(7496),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7496),
    [sym__newline] = ACTIONS(7496),
    [sym__semicolon] = ACTIONS(7496),
    [sym__raw_string_literal] = ACTIONS(7496),
    [sym__external_open_parenthesis] = ACTIONS(7496),
    [sym__external_open_brace] = ACTIONS(7496),
    [sym__external_close_brace] = ACTIONS(7496),
    [sym__external_open_bracket] = ACTIONS(7496),
    [sym__external_close_bracket] = ACTIONS(7496),
    [sym__external_open_bracket2] = ACTIONS(7496),
  },
  [2614] = {
    [ts_builtin_sym_end] = ACTIONS(7550),
    [sym_identifier] = ACTIONS(7552),
    [anon_sym_BSLASH] = ACTIONS(7550),
    [anon_sym_function] = ACTIONS(7552),
    [anon_sym_EQ] = ACTIONS(7552),
    [anon_sym_if] = ACTIONS(7552),
    [anon_sym_for] = ACTIONS(7552),
    [anon_sym_while] = ACTIONS(7552),
    [anon_sym_repeat] = ACTIONS(7552),
    [anon_sym_QMARK] = ACTIONS(7550),
    [anon_sym_TILDE] = ACTIONS(7550),
    [anon_sym_BANG] = ACTIONS(7552),
    [anon_sym_PLUS] = ACTIONS(7550),
    [anon_sym_DASH] = ACTIONS(7552),
    [anon_sym_LT_DASH] = ACTIONS(7550),
    [anon_sym_LT_LT_DASH] = ACTIONS(7550),
    [anon_sym_COLON_EQ] = ACTIONS(7550),
    [anon_sym_DASH_GT] = ACTIONS(7552),
    [anon_sym_DASH_GT_GT] = ACTIONS(7550),
    [anon_sym_PIPE] = ACTIONS(7552),
    [anon_sym_AMP] = ACTIONS(7552),
    [anon_sym_PIPE_PIPE] = ACTIONS(7550),
    [anon_sym_AMP_AMP] = ACTIONS(7550),
    [anon_sym_LT] = ACTIONS(7552),
    [anon_sym_LT_EQ] = ACTIONS(7550),
    [anon_sym_GT] = ACTIONS(7552),
    [anon_sym_GT_EQ] = ACTIONS(7550),
    [anon_sym_EQ_EQ] = ACTIONS(7550),
    [anon_sym_BANG_EQ] = ACTIONS(7550),
    [anon_sym_STAR] = ACTIONS(7552),
    [anon_sym_SLASH] = ACTIONS(7550),
    [anon_sym_STAR_STAR] = ACTIONS(7550),
    [anon_sym_CARET] = ACTIONS(7550),
    [aux_sym_binary_operator_token1] = ACTIONS(7550),
    [anon_sym_PIPE_GT] = ACTIONS(7550),
    [anon_sym_COLON] = ACTIONS(7552),
    [anon_sym_DOLLAR] = ACTIONS(7550),
    [anon_sym_AT] = ACTIONS(7550),
    [aux_sym__hex_literal_token1] = ACTIONS(7550),
    [sym__number_literal] = ACTIONS(7552),
    [anon_sym_SQUOTE] = ACTIONS(7550),
    [anon_sym_DQUOTE] = ACTIONS(7550),
    [sym_return] = ACTIONS(7552),
    [sym_next] = ACTIONS(7552),
    [sym_break] = ACTIONS(7552),
    [sym_true] = ACTIONS(7552),
    [sym_false] = ACTIONS(7552),
    [sym_null] = ACTIONS(7552),
    [sym_inf] = ACTIONS(7552),
    [sym_nan] = ACTIONS(7552),
    [anon_sym_NA] = ACTIONS(7552),
    [anon_sym_NA_integer_] = ACTIONS(7552),
    [anon_sym_NA_real_] = ACTIONS(7552),
    [anon_sym_NA_complex_] = ACTIONS(7552),
    [anon_sym_NA_character_] = ACTIONS(7552),
    [sym_dots] = ACTIONS(7552),
    [sym_dot_dot_i] = ACTIONS(7550),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7550),
    [sym__semicolon] = ACTIONS(7550),
    [sym__raw_string_literal] = ACTIONS(7550),
    [sym__external_else] = ACTIONS(7550),
    [sym__external_open_parenthesis] = ACTIONS(7550),
    [sym__external_close_parenthesis] = ACTIONS(7550),
    [sym__external_open_brace] = ACTIONS(7550),
    [sym__external_open_bracket] = ACTIONS(7550),
    [sym__external_open_bracket2] = ACTIONS(7550),
  },
  [2615] = {
    [sym_identifier] = ACTIONS(7512),
    [anon_sym_BSLASH] = ACTIONS(7510),
    [anon_sym_function] = ACTIONS(7512),
    [anon_sym_EQ] = ACTIONS(7512),
    [anon_sym_if] = ACTIONS(7512),
    [anon_sym_for] = ACTIONS(7512),
    [anon_sym_while] = ACTIONS(7512),
    [anon_sym_repeat] = ACTIONS(7512),
    [anon_sym_QMARK] = ACTIONS(7510),
    [anon_sym_TILDE] = ACTIONS(7510),
    [anon_sym_BANG] = ACTIONS(7512),
    [anon_sym_PLUS] = ACTIONS(7510),
    [anon_sym_DASH] = ACTIONS(7512),
    [anon_sym_LT_DASH] = ACTIONS(7510),
    [anon_sym_LT_LT_DASH] = ACTIONS(7510),
    [anon_sym_COLON_EQ] = ACTIONS(7510),
    [anon_sym_DASH_GT] = ACTIONS(7512),
    [anon_sym_DASH_GT_GT] = ACTIONS(7510),
    [anon_sym_PIPE] = ACTIONS(7512),
    [anon_sym_AMP] = ACTIONS(7512),
    [anon_sym_PIPE_PIPE] = ACTIONS(7510),
    [anon_sym_AMP_AMP] = ACTIONS(7510),
    [anon_sym_LT] = ACTIONS(7512),
    [anon_sym_LT_EQ] = ACTIONS(7510),
    [anon_sym_GT] = ACTIONS(7512),
    [anon_sym_GT_EQ] = ACTIONS(7510),
    [anon_sym_EQ_EQ] = ACTIONS(7510),
    [anon_sym_BANG_EQ] = ACTIONS(7510),
    [anon_sym_STAR] = ACTIONS(7512),
    [anon_sym_SLASH] = ACTIONS(7510),
    [anon_sym_STAR_STAR] = ACTIONS(7510),
    [anon_sym_CARET] = ACTIONS(7510),
    [aux_sym_binary_operator_token1] = ACTIONS(7510),
    [anon_sym_PIPE_GT] = ACTIONS(7510),
    [anon_sym_COLON] = ACTIONS(7512),
    [anon_sym_DOLLAR] = ACTIONS(7510),
    [anon_sym_AT] = ACTIONS(7510),
    [aux_sym__hex_literal_token1] = ACTIONS(7510),
    [sym__number_literal] = ACTIONS(7512),
    [anon_sym_SQUOTE] = ACTIONS(7510),
    [anon_sym_DQUOTE] = ACTIONS(7510),
    [sym_return] = ACTIONS(7512),
    [sym_next] = ACTIONS(7512),
    [sym_break] = ACTIONS(7512),
    [sym_true] = ACTIONS(7512),
    [sym_false] = ACTIONS(7512),
    [sym_null] = ACTIONS(7512),
    [sym_inf] = ACTIONS(7512),
    [sym_nan] = ACTIONS(7512),
    [anon_sym_NA] = ACTIONS(7512),
    [anon_sym_NA_integer_] = ACTIONS(7512),
    [anon_sym_NA_real_] = ACTIONS(7512),
    [anon_sym_NA_complex_] = ACTIONS(7512),
    [anon_sym_NA_character_] = ACTIONS(7512),
    [sym_dots] = ACTIONS(7512),
    [sym_dot_dot_i] = ACTIONS(7510),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7510),
    [sym__newline] = ACTIONS(7510),
    [sym__semicolon] = ACTIONS(7510),
    [sym__raw_string_literal] = ACTIONS(7510),
    [sym__external_open_parenthesis] = ACTIONS(7510),
    [sym__external_open_brace] = ACTIONS(7510),
    [sym__external_close_brace] = ACTIONS(7510),
    [sym__external_open_bracket] = ACTIONS(7510),
    [sym__external_close_bracket] = ACTIONS(7510),
    [sym__external_open_bracket2] = ACTIONS(7510),
  },
  [2616] = {
    [sym_identifier] = ACTIONS(7151),
    [anon_sym_BSLASH] = ACTIONS(7153),
    [anon_sym_function] = ACTIONS(7151),
    [anon_sym_EQ] = ACTIONS(7151),
    [anon_sym_if] = ACTIONS(7151),
    [anon_sym_for] = ACTIONS(7151),
    [anon_sym_while] = ACTIONS(7151),
    [anon_sym_repeat] = ACTIONS(7151),
    [anon_sym_QMARK] = ACTIONS(7153),
    [anon_sym_TILDE] = ACTIONS(7153),
    [anon_sym_BANG] = ACTIONS(7151),
    [anon_sym_PLUS] = ACTIONS(7153),
    [anon_sym_DASH] = ACTIONS(7151),
    [anon_sym_LT_DASH] = ACTIONS(7153),
    [anon_sym_LT_LT_DASH] = ACTIONS(7153),
    [anon_sym_COLON_EQ] = ACTIONS(7153),
    [anon_sym_DASH_GT] = ACTIONS(7151),
    [anon_sym_DASH_GT_GT] = ACTIONS(7153),
    [anon_sym_PIPE] = ACTIONS(7151),
    [anon_sym_AMP] = ACTIONS(7151),
    [anon_sym_PIPE_PIPE] = ACTIONS(7153),
    [anon_sym_AMP_AMP] = ACTIONS(7153),
    [anon_sym_LT] = ACTIONS(7151),
    [anon_sym_LT_EQ] = ACTIONS(7153),
    [anon_sym_GT] = ACTIONS(7151),
    [anon_sym_GT_EQ] = ACTIONS(7153),
    [anon_sym_EQ_EQ] = ACTIONS(7153),
    [anon_sym_BANG_EQ] = ACTIONS(7153),
    [anon_sym_STAR] = ACTIONS(7151),
    [anon_sym_SLASH] = ACTIONS(7153),
    [anon_sym_STAR_STAR] = ACTIONS(7153),
    [anon_sym_CARET] = ACTIONS(7153),
    [aux_sym_binary_operator_token1] = ACTIONS(7153),
    [anon_sym_PIPE_GT] = ACTIONS(7153),
    [anon_sym_COLON] = ACTIONS(7151),
    [anon_sym_DOLLAR] = ACTIONS(7153),
    [anon_sym_AT] = ACTIONS(7153),
    [anon_sym_COLON_COLON] = ACTIONS(7151),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7153),
    [aux_sym__hex_literal_token1] = ACTIONS(7153),
    [sym__number_literal] = ACTIONS(7151),
    [anon_sym_SQUOTE] = ACTIONS(7153),
    [anon_sym_DQUOTE] = ACTIONS(7153),
    [sym_return] = ACTIONS(7151),
    [sym_next] = ACTIONS(7151),
    [sym_break] = ACTIONS(7151),
    [sym_true] = ACTIONS(7151),
    [sym_false] = ACTIONS(7151),
    [sym_null] = ACTIONS(7151),
    [sym_inf] = ACTIONS(7151),
    [sym_nan] = ACTIONS(7151),
    [anon_sym_NA] = ACTIONS(7151),
    [anon_sym_NA_integer_] = ACTIONS(7151),
    [anon_sym_NA_real_] = ACTIONS(7151),
    [anon_sym_NA_complex_] = ACTIONS(7151),
    [anon_sym_NA_character_] = ACTIONS(7151),
    [sym_dots] = ACTIONS(7151),
    [sym_dot_dot_i] = ACTIONS(7153),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7153),
    [sym__newline] = ACTIONS(7153),
    [sym__raw_string_literal] = ACTIONS(7153),
    [sym__external_open_parenthesis] = ACTIONS(7153),
    [sym__external_open_brace] = ACTIONS(7153),
    [sym__external_open_bracket] = ACTIONS(7153),
    [sym__external_close_bracket] = ACTIONS(7153),
    [sym__external_open_bracket2] = ACTIONS(7153),
  },
  [2617] = {
    [aux_sym_function_definition_repeat1] = STATE(2617),
    [sym_identifier] = ACTIONS(7419),
    [anon_sym_BSLASH] = ACTIONS(7417),
    [anon_sym_function] = ACTIONS(7419),
    [anon_sym_EQ] = ACTIONS(7419),
    [anon_sym_if] = ACTIONS(7419),
    [anon_sym_for] = ACTIONS(7419),
    [anon_sym_while] = ACTIONS(7419),
    [anon_sym_repeat] = ACTIONS(7419),
    [anon_sym_QMARK] = ACTIONS(7417),
    [anon_sym_TILDE] = ACTIONS(7417),
    [anon_sym_BANG] = ACTIONS(7419),
    [anon_sym_PLUS] = ACTIONS(7417),
    [anon_sym_DASH] = ACTIONS(7419),
    [anon_sym_LT_DASH] = ACTIONS(7417),
    [anon_sym_LT_LT_DASH] = ACTIONS(7417),
    [anon_sym_COLON_EQ] = ACTIONS(7417),
    [anon_sym_DASH_GT] = ACTIONS(7419),
    [anon_sym_DASH_GT_GT] = ACTIONS(7417),
    [anon_sym_PIPE] = ACTIONS(7419),
    [anon_sym_AMP] = ACTIONS(7419),
    [anon_sym_PIPE_PIPE] = ACTIONS(7417),
    [anon_sym_AMP_AMP] = ACTIONS(7417),
    [anon_sym_LT] = ACTIONS(7419),
    [anon_sym_LT_EQ] = ACTIONS(7417),
    [anon_sym_GT] = ACTIONS(7419),
    [anon_sym_GT_EQ] = ACTIONS(7417),
    [anon_sym_EQ_EQ] = ACTIONS(7417),
    [anon_sym_BANG_EQ] = ACTIONS(7417),
    [anon_sym_STAR] = ACTIONS(7419),
    [anon_sym_SLASH] = ACTIONS(7417),
    [anon_sym_STAR_STAR] = ACTIONS(7417),
    [anon_sym_CARET] = ACTIONS(7417),
    [aux_sym_binary_operator_token1] = ACTIONS(7417),
    [anon_sym_PIPE_GT] = ACTIONS(7417),
    [anon_sym_COLON] = ACTIONS(7419),
    [anon_sym_DOLLAR] = ACTIONS(7417),
    [anon_sym_AT] = ACTIONS(7417),
    [aux_sym__hex_literal_token1] = ACTIONS(7417),
    [sym__number_literal] = ACTIONS(7419),
    [anon_sym_SQUOTE] = ACTIONS(7417),
    [anon_sym_DQUOTE] = ACTIONS(7417),
    [sym_return] = ACTIONS(7419),
    [sym_next] = ACTIONS(7419),
    [sym_break] = ACTIONS(7419),
    [sym_true] = ACTIONS(7419),
    [sym_false] = ACTIONS(7419),
    [sym_null] = ACTIONS(7419),
    [sym_inf] = ACTIONS(7419),
    [sym_nan] = ACTIONS(7419),
    [anon_sym_NA] = ACTIONS(7419),
    [anon_sym_NA_integer_] = ACTIONS(7419),
    [anon_sym_NA_real_] = ACTIONS(7419),
    [anon_sym_NA_complex_] = ACTIONS(7419),
    [anon_sym_NA_character_] = ACTIONS(7419),
    [sym_dots] = ACTIONS(7419),
    [sym_dot_dot_i] = ACTIONS(7417),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7417),
    [sym__newline] = ACTIONS(7660),
    [sym__raw_string_literal] = ACTIONS(7417),
    [sym__external_open_parenthesis] = ACTIONS(7417),
    [sym__external_close_parenthesis] = ACTIONS(7417),
    [sym__external_open_brace] = ACTIONS(7417),
    [sym__external_open_bracket] = ACTIONS(7417),
    [sym__external_close_bracket] = ACTIONS(7417),
    [sym__external_open_bracket2] = ACTIONS(7417),
  },
  [2618] = {
    [ts_builtin_sym_end] = ACTIONS(7542),
    [sym_identifier] = ACTIONS(7544),
    [anon_sym_BSLASH] = ACTIONS(7542),
    [anon_sym_function] = ACTIONS(7544),
    [anon_sym_EQ] = ACTIONS(7544),
    [anon_sym_if] = ACTIONS(7544),
    [anon_sym_for] = ACTIONS(7544),
    [anon_sym_while] = ACTIONS(7544),
    [anon_sym_repeat] = ACTIONS(7544),
    [anon_sym_QMARK] = ACTIONS(7542),
    [anon_sym_TILDE] = ACTIONS(7542),
    [anon_sym_BANG] = ACTIONS(7544),
    [anon_sym_PLUS] = ACTIONS(7542),
    [anon_sym_DASH] = ACTIONS(7544),
    [anon_sym_LT_DASH] = ACTIONS(7542),
    [anon_sym_LT_LT_DASH] = ACTIONS(7542),
    [anon_sym_COLON_EQ] = ACTIONS(7542),
    [anon_sym_DASH_GT] = ACTIONS(7544),
    [anon_sym_DASH_GT_GT] = ACTIONS(7542),
    [anon_sym_PIPE] = ACTIONS(7544),
    [anon_sym_AMP] = ACTIONS(7544),
    [anon_sym_PIPE_PIPE] = ACTIONS(7542),
    [anon_sym_AMP_AMP] = ACTIONS(7542),
    [anon_sym_LT] = ACTIONS(7544),
    [anon_sym_LT_EQ] = ACTIONS(7542),
    [anon_sym_GT] = ACTIONS(7544),
    [anon_sym_GT_EQ] = ACTIONS(7542),
    [anon_sym_EQ_EQ] = ACTIONS(7542),
    [anon_sym_BANG_EQ] = ACTIONS(7542),
    [anon_sym_STAR] = ACTIONS(7544),
    [anon_sym_SLASH] = ACTIONS(7542),
    [anon_sym_STAR_STAR] = ACTIONS(7542),
    [anon_sym_CARET] = ACTIONS(7542),
    [aux_sym_binary_operator_token1] = ACTIONS(7542),
    [anon_sym_PIPE_GT] = ACTIONS(7542),
    [anon_sym_COLON] = ACTIONS(7544),
    [anon_sym_DOLLAR] = ACTIONS(7542),
    [anon_sym_AT] = ACTIONS(7542),
    [aux_sym__hex_literal_token1] = ACTIONS(7542),
    [sym__number_literal] = ACTIONS(7544),
    [anon_sym_SQUOTE] = ACTIONS(7542),
    [anon_sym_DQUOTE] = ACTIONS(7542),
    [sym_return] = ACTIONS(7544),
    [sym_next] = ACTIONS(7544),
    [sym_break] = ACTIONS(7544),
    [sym_true] = ACTIONS(7544),
    [sym_false] = ACTIONS(7544),
    [sym_null] = ACTIONS(7544),
    [sym_inf] = ACTIONS(7544),
    [sym_nan] = ACTIONS(7544),
    [anon_sym_NA] = ACTIONS(7544),
    [anon_sym_NA_integer_] = ACTIONS(7544),
    [anon_sym_NA_real_] = ACTIONS(7544),
    [anon_sym_NA_complex_] = ACTIONS(7544),
    [anon_sym_NA_character_] = ACTIONS(7544),
    [sym_dots] = ACTIONS(7544),
    [sym_dot_dot_i] = ACTIONS(7542),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7542),
    [sym__semicolon] = ACTIONS(7542),
    [sym__raw_string_literal] = ACTIONS(7542),
    [sym__external_else] = ACTIONS(7542),
    [sym__external_open_parenthesis] = ACTIONS(7542),
    [sym__external_close_parenthesis] = ACTIONS(7542),
    [sym__external_open_brace] = ACTIONS(7542),
    [sym__external_open_bracket] = ACTIONS(7542),
    [sym__external_open_bracket2] = ACTIONS(7542),
  },
  [2619] = {
    [ts_builtin_sym_end] = ACTIONS(7538),
    [sym_identifier] = ACTIONS(7540),
    [anon_sym_BSLASH] = ACTIONS(7538),
    [anon_sym_function] = ACTIONS(7540),
    [anon_sym_EQ] = ACTIONS(7540),
    [anon_sym_if] = ACTIONS(7540),
    [anon_sym_for] = ACTIONS(7540),
    [anon_sym_while] = ACTIONS(7540),
    [anon_sym_repeat] = ACTIONS(7540),
    [anon_sym_QMARK] = ACTIONS(7538),
    [anon_sym_TILDE] = ACTIONS(7538),
    [anon_sym_BANG] = ACTIONS(7540),
    [anon_sym_PLUS] = ACTIONS(7538),
    [anon_sym_DASH] = ACTIONS(7540),
    [anon_sym_LT_DASH] = ACTIONS(7538),
    [anon_sym_LT_LT_DASH] = ACTIONS(7538),
    [anon_sym_COLON_EQ] = ACTIONS(7538),
    [anon_sym_DASH_GT] = ACTIONS(7540),
    [anon_sym_DASH_GT_GT] = ACTIONS(7538),
    [anon_sym_PIPE] = ACTIONS(7540),
    [anon_sym_AMP] = ACTIONS(7540),
    [anon_sym_PIPE_PIPE] = ACTIONS(7538),
    [anon_sym_AMP_AMP] = ACTIONS(7538),
    [anon_sym_LT] = ACTIONS(7540),
    [anon_sym_LT_EQ] = ACTIONS(7538),
    [anon_sym_GT] = ACTIONS(7540),
    [anon_sym_GT_EQ] = ACTIONS(7538),
    [anon_sym_EQ_EQ] = ACTIONS(7538),
    [anon_sym_BANG_EQ] = ACTIONS(7538),
    [anon_sym_STAR] = ACTIONS(7540),
    [anon_sym_SLASH] = ACTIONS(7538),
    [anon_sym_STAR_STAR] = ACTIONS(7538),
    [anon_sym_CARET] = ACTIONS(7538),
    [aux_sym_binary_operator_token1] = ACTIONS(7538),
    [anon_sym_PIPE_GT] = ACTIONS(7538),
    [anon_sym_COLON] = ACTIONS(7540),
    [anon_sym_DOLLAR] = ACTIONS(7538),
    [anon_sym_AT] = ACTIONS(7538),
    [aux_sym__hex_literal_token1] = ACTIONS(7538),
    [sym__number_literal] = ACTIONS(7540),
    [anon_sym_SQUOTE] = ACTIONS(7538),
    [anon_sym_DQUOTE] = ACTIONS(7538),
    [sym_return] = ACTIONS(7540),
    [sym_next] = ACTIONS(7540),
    [sym_break] = ACTIONS(7540),
    [sym_true] = ACTIONS(7540),
    [sym_false] = ACTIONS(7540),
    [sym_null] = ACTIONS(7540),
    [sym_inf] = ACTIONS(7540),
    [sym_nan] = ACTIONS(7540),
    [anon_sym_NA] = ACTIONS(7540),
    [anon_sym_NA_integer_] = ACTIONS(7540),
    [anon_sym_NA_real_] = ACTIONS(7540),
    [anon_sym_NA_complex_] = ACTIONS(7540),
    [anon_sym_NA_character_] = ACTIONS(7540),
    [sym_dots] = ACTIONS(7540),
    [sym_dot_dot_i] = ACTIONS(7538),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7538),
    [sym__semicolon] = ACTIONS(7538),
    [sym__raw_string_literal] = ACTIONS(7538),
    [sym__external_else] = ACTIONS(7538),
    [sym__external_open_parenthesis] = ACTIONS(7538),
    [sym__external_close_parenthesis] = ACTIONS(7538),
    [sym__external_open_brace] = ACTIONS(7538),
    [sym__external_open_bracket] = ACTIONS(7538),
    [sym__external_open_bracket2] = ACTIONS(7538),
  },
  [2620] = {
    [sym_identifier] = ACTIONS(7115),
    [anon_sym_BSLASH] = ACTIONS(7117),
    [anon_sym_function] = ACTIONS(7115),
    [anon_sym_EQ] = ACTIONS(7115),
    [anon_sym_if] = ACTIONS(7115),
    [anon_sym_for] = ACTIONS(7115),
    [anon_sym_while] = ACTIONS(7115),
    [anon_sym_repeat] = ACTIONS(7115),
    [anon_sym_QMARK] = ACTIONS(7117),
    [anon_sym_TILDE] = ACTIONS(7117),
    [anon_sym_BANG] = ACTIONS(7115),
    [anon_sym_PLUS] = ACTIONS(7117),
    [anon_sym_DASH] = ACTIONS(7115),
    [anon_sym_LT_DASH] = ACTIONS(7117),
    [anon_sym_LT_LT_DASH] = ACTIONS(7117),
    [anon_sym_COLON_EQ] = ACTIONS(7117),
    [anon_sym_DASH_GT] = ACTIONS(7115),
    [anon_sym_DASH_GT_GT] = ACTIONS(7117),
    [anon_sym_PIPE] = ACTIONS(7115),
    [anon_sym_AMP] = ACTIONS(7115),
    [anon_sym_PIPE_PIPE] = ACTIONS(7117),
    [anon_sym_AMP_AMP] = ACTIONS(7117),
    [anon_sym_LT] = ACTIONS(7115),
    [anon_sym_LT_EQ] = ACTIONS(7117),
    [anon_sym_GT] = ACTIONS(7115),
    [anon_sym_GT_EQ] = ACTIONS(7117),
    [anon_sym_EQ_EQ] = ACTIONS(7117),
    [anon_sym_BANG_EQ] = ACTIONS(7117),
    [anon_sym_STAR] = ACTIONS(7115),
    [anon_sym_SLASH] = ACTIONS(7117),
    [anon_sym_STAR_STAR] = ACTIONS(7117),
    [anon_sym_CARET] = ACTIONS(7117),
    [aux_sym_binary_operator_token1] = ACTIONS(7117),
    [anon_sym_PIPE_GT] = ACTIONS(7117),
    [anon_sym_COLON] = ACTIONS(7115),
    [anon_sym_DOLLAR] = ACTIONS(7117),
    [anon_sym_AT] = ACTIONS(7117),
    [anon_sym_COLON_COLON] = ACTIONS(7115),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7117),
    [aux_sym__hex_literal_token1] = ACTIONS(7117),
    [sym__number_literal] = ACTIONS(7115),
    [anon_sym_SQUOTE] = ACTIONS(7117),
    [anon_sym_DQUOTE] = ACTIONS(7117),
    [sym_return] = ACTIONS(7115),
    [sym_next] = ACTIONS(7115),
    [sym_break] = ACTIONS(7115),
    [sym_true] = ACTIONS(7115),
    [sym_false] = ACTIONS(7115),
    [sym_null] = ACTIONS(7115),
    [sym_inf] = ACTIONS(7115),
    [sym_nan] = ACTIONS(7115),
    [anon_sym_NA] = ACTIONS(7115),
    [anon_sym_NA_integer_] = ACTIONS(7115),
    [anon_sym_NA_real_] = ACTIONS(7115),
    [anon_sym_NA_complex_] = ACTIONS(7115),
    [anon_sym_NA_character_] = ACTIONS(7115),
    [sym_dots] = ACTIONS(7115),
    [sym_dot_dot_i] = ACTIONS(7117),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7117),
    [sym__newline] = ACTIONS(7117),
    [sym__raw_string_literal] = ACTIONS(7117),
    [sym__external_open_parenthesis] = ACTIONS(7117),
    [sym__external_close_parenthesis] = ACTIONS(7117),
    [sym__external_open_brace] = ACTIONS(7117),
    [sym__external_open_bracket] = ACTIONS(7117),
    [sym__external_open_bracket2] = ACTIONS(7117),
  },
  [2621] = {
    [sym_identifier] = ACTIONS(7486),
    [anon_sym_BSLASH] = ACTIONS(7484),
    [anon_sym_function] = ACTIONS(7486),
    [anon_sym_EQ] = ACTIONS(7486),
    [anon_sym_if] = ACTIONS(7486),
    [anon_sym_for] = ACTIONS(7486),
    [anon_sym_while] = ACTIONS(7486),
    [anon_sym_repeat] = ACTIONS(7486),
    [anon_sym_QMARK] = ACTIONS(7484),
    [anon_sym_TILDE] = ACTIONS(7484),
    [anon_sym_BANG] = ACTIONS(7486),
    [anon_sym_PLUS] = ACTIONS(7484),
    [anon_sym_DASH] = ACTIONS(7486),
    [anon_sym_LT_DASH] = ACTIONS(7484),
    [anon_sym_LT_LT_DASH] = ACTIONS(7484),
    [anon_sym_COLON_EQ] = ACTIONS(7484),
    [anon_sym_DASH_GT] = ACTIONS(7486),
    [anon_sym_DASH_GT_GT] = ACTIONS(7484),
    [anon_sym_PIPE] = ACTIONS(7486),
    [anon_sym_AMP] = ACTIONS(7486),
    [anon_sym_PIPE_PIPE] = ACTIONS(7484),
    [anon_sym_AMP_AMP] = ACTIONS(7484),
    [anon_sym_LT] = ACTIONS(7486),
    [anon_sym_LT_EQ] = ACTIONS(7484),
    [anon_sym_GT] = ACTIONS(7486),
    [anon_sym_GT_EQ] = ACTIONS(7484),
    [anon_sym_EQ_EQ] = ACTIONS(7484),
    [anon_sym_BANG_EQ] = ACTIONS(7484),
    [anon_sym_STAR] = ACTIONS(7486),
    [anon_sym_SLASH] = ACTIONS(7484),
    [anon_sym_STAR_STAR] = ACTIONS(7484),
    [anon_sym_CARET] = ACTIONS(7484),
    [aux_sym_binary_operator_token1] = ACTIONS(7484),
    [anon_sym_PIPE_GT] = ACTIONS(7484),
    [anon_sym_COLON] = ACTIONS(7486),
    [anon_sym_DOLLAR] = ACTIONS(7484),
    [anon_sym_AT] = ACTIONS(7484),
    [aux_sym__hex_literal_token1] = ACTIONS(7484),
    [sym__number_literal] = ACTIONS(7486),
    [anon_sym_SQUOTE] = ACTIONS(7484),
    [anon_sym_DQUOTE] = ACTIONS(7484),
    [sym_return] = ACTIONS(7486),
    [sym_next] = ACTIONS(7486),
    [sym_break] = ACTIONS(7486),
    [sym_true] = ACTIONS(7486),
    [sym_false] = ACTIONS(7486),
    [sym_null] = ACTIONS(7486),
    [sym_inf] = ACTIONS(7486),
    [sym_nan] = ACTIONS(7486),
    [anon_sym_NA] = ACTIONS(7486),
    [anon_sym_NA_integer_] = ACTIONS(7486),
    [anon_sym_NA_real_] = ACTIONS(7486),
    [anon_sym_NA_complex_] = ACTIONS(7486),
    [anon_sym_NA_character_] = ACTIONS(7486),
    [sym_dots] = ACTIONS(7486),
    [sym_dot_dot_i] = ACTIONS(7484),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7484),
    [sym__newline] = ACTIONS(7484),
    [sym__raw_string_literal] = ACTIONS(7484),
    [sym__external_else] = ACTIONS(7484),
    [sym__external_open_parenthesis] = ACTIONS(7484),
    [sym__external_close_parenthesis] = ACTIONS(7484),
    [sym__external_open_brace] = ACTIONS(7484),
    [sym__external_open_bracket] = ACTIONS(7484),
    [sym__external_open_bracket2] = ACTIONS(7484),
    [sym__external_close_bracket2] = ACTIONS(7484),
  },
  [2622] = {
    [sym_identifier] = ACTIONS(7490),
    [anon_sym_BSLASH] = ACTIONS(7488),
    [anon_sym_function] = ACTIONS(7490),
    [anon_sym_EQ] = ACTIONS(7490),
    [anon_sym_if] = ACTIONS(7490),
    [anon_sym_for] = ACTIONS(7490),
    [anon_sym_while] = ACTIONS(7490),
    [anon_sym_repeat] = ACTIONS(7490),
    [anon_sym_QMARK] = ACTIONS(7488),
    [anon_sym_TILDE] = ACTIONS(7488),
    [anon_sym_BANG] = ACTIONS(7490),
    [anon_sym_PLUS] = ACTIONS(7488),
    [anon_sym_DASH] = ACTIONS(7490),
    [anon_sym_LT_DASH] = ACTIONS(7488),
    [anon_sym_LT_LT_DASH] = ACTIONS(7488),
    [anon_sym_COLON_EQ] = ACTIONS(7488),
    [anon_sym_DASH_GT] = ACTIONS(7490),
    [anon_sym_DASH_GT_GT] = ACTIONS(7488),
    [anon_sym_PIPE] = ACTIONS(7490),
    [anon_sym_AMP] = ACTIONS(7490),
    [anon_sym_PIPE_PIPE] = ACTIONS(7488),
    [anon_sym_AMP_AMP] = ACTIONS(7488),
    [anon_sym_LT] = ACTIONS(7490),
    [anon_sym_LT_EQ] = ACTIONS(7488),
    [anon_sym_GT] = ACTIONS(7490),
    [anon_sym_GT_EQ] = ACTIONS(7488),
    [anon_sym_EQ_EQ] = ACTIONS(7488),
    [anon_sym_BANG_EQ] = ACTIONS(7488),
    [anon_sym_STAR] = ACTIONS(7490),
    [anon_sym_SLASH] = ACTIONS(7488),
    [anon_sym_STAR_STAR] = ACTIONS(7488),
    [anon_sym_CARET] = ACTIONS(7488),
    [aux_sym_binary_operator_token1] = ACTIONS(7488),
    [anon_sym_PIPE_GT] = ACTIONS(7488),
    [anon_sym_COLON] = ACTIONS(7490),
    [anon_sym_DOLLAR] = ACTIONS(7488),
    [anon_sym_AT] = ACTIONS(7488),
    [aux_sym__hex_literal_token1] = ACTIONS(7488),
    [sym__number_literal] = ACTIONS(7490),
    [anon_sym_SQUOTE] = ACTIONS(7488),
    [anon_sym_DQUOTE] = ACTIONS(7488),
    [sym_return] = ACTIONS(7490),
    [sym_next] = ACTIONS(7490),
    [sym_break] = ACTIONS(7490),
    [sym_true] = ACTIONS(7490),
    [sym_false] = ACTIONS(7490),
    [sym_null] = ACTIONS(7490),
    [sym_inf] = ACTIONS(7490),
    [sym_nan] = ACTIONS(7490),
    [anon_sym_NA] = ACTIONS(7490),
    [anon_sym_NA_integer_] = ACTIONS(7490),
    [anon_sym_NA_real_] = ACTIONS(7490),
    [anon_sym_NA_complex_] = ACTIONS(7490),
    [anon_sym_NA_character_] = ACTIONS(7490),
    [sym_dots] = ACTIONS(7490),
    [sym_dot_dot_i] = ACTIONS(7488),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7488),
    [sym__newline] = ACTIONS(7488),
    [sym__raw_string_literal] = ACTIONS(7488),
    [sym__external_else] = ACTIONS(7488),
    [sym__external_open_parenthesis] = ACTIONS(7488),
    [sym__external_close_parenthesis] = ACTIONS(7488),
    [sym__external_open_brace] = ACTIONS(7488),
    [sym__external_open_bracket] = ACTIONS(7488),
    [sym__external_open_bracket2] = ACTIONS(7488),
    [sym__external_close_bracket2] = ACTIONS(7488),
  },
  [2623] = {
    [sym_identifier] = ACTIONS(7494),
    [anon_sym_BSLASH] = ACTIONS(7492),
    [anon_sym_function] = ACTIONS(7494),
    [anon_sym_EQ] = ACTIONS(7494),
    [anon_sym_if] = ACTIONS(7494),
    [anon_sym_for] = ACTIONS(7494),
    [anon_sym_while] = ACTIONS(7494),
    [anon_sym_repeat] = ACTIONS(7494),
    [anon_sym_QMARK] = ACTIONS(7492),
    [anon_sym_TILDE] = ACTIONS(7492),
    [anon_sym_BANG] = ACTIONS(7494),
    [anon_sym_PLUS] = ACTIONS(7492),
    [anon_sym_DASH] = ACTIONS(7494),
    [anon_sym_LT_DASH] = ACTIONS(7492),
    [anon_sym_LT_LT_DASH] = ACTIONS(7492),
    [anon_sym_COLON_EQ] = ACTIONS(7492),
    [anon_sym_DASH_GT] = ACTIONS(7494),
    [anon_sym_DASH_GT_GT] = ACTIONS(7492),
    [anon_sym_PIPE] = ACTIONS(7494),
    [anon_sym_AMP] = ACTIONS(7494),
    [anon_sym_PIPE_PIPE] = ACTIONS(7492),
    [anon_sym_AMP_AMP] = ACTIONS(7492),
    [anon_sym_LT] = ACTIONS(7494),
    [anon_sym_LT_EQ] = ACTIONS(7492),
    [anon_sym_GT] = ACTIONS(7494),
    [anon_sym_GT_EQ] = ACTIONS(7492),
    [anon_sym_EQ_EQ] = ACTIONS(7492),
    [anon_sym_BANG_EQ] = ACTIONS(7492),
    [anon_sym_STAR] = ACTIONS(7494),
    [anon_sym_SLASH] = ACTIONS(7492),
    [anon_sym_STAR_STAR] = ACTIONS(7492),
    [anon_sym_CARET] = ACTIONS(7492),
    [aux_sym_binary_operator_token1] = ACTIONS(7492),
    [anon_sym_PIPE_GT] = ACTIONS(7492),
    [anon_sym_COLON] = ACTIONS(7494),
    [anon_sym_DOLLAR] = ACTIONS(7492),
    [anon_sym_AT] = ACTIONS(7492),
    [aux_sym__hex_literal_token1] = ACTIONS(7492),
    [sym__number_literal] = ACTIONS(7494),
    [anon_sym_SQUOTE] = ACTIONS(7492),
    [anon_sym_DQUOTE] = ACTIONS(7492),
    [sym_return] = ACTIONS(7494),
    [sym_next] = ACTIONS(7494),
    [sym_break] = ACTIONS(7494),
    [sym_true] = ACTIONS(7494),
    [sym_false] = ACTIONS(7494),
    [sym_null] = ACTIONS(7494),
    [sym_inf] = ACTIONS(7494),
    [sym_nan] = ACTIONS(7494),
    [anon_sym_NA] = ACTIONS(7494),
    [anon_sym_NA_integer_] = ACTIONS(7494),
    [anon_sym_NA_real_] = ACTIONS(7494),
    [anon_sym_NA_complex_] = ACTIONS(7494),
    [anon_sym_NA_character_] = ACTIONS(7494),
    [sym_dots] = ACTIONS(7494),
    [sym_dot_dot_i] = ACTIONS(7492),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7492),
    [sym__newline] = ACTIONS(7492),
    [sym__raw_string_literal] = ACTIONS(7492),
    [sym__external_else] = ACTIONS(7492),
    [sym__external_open_parenthesis] = ACTIONS(7492),
    [sym__external_close_parenthesis] = ACTIONS(7492),
    [sym__external_open_brace] = ACTIONS(7492),
    [sym__external_open_bracket] = ACTIONS(7492),
    [sym__external_open_bracket2] = ACTIONS(7492),
    [sym__external_close_bracket2] = ACTIONS(7492),
  },
  [2624] = {
    [sym_identifier] = ACTIONS(7498),
    [anon_sym_BSLASH] = ACTIONS(7496),
    [anon_sym_function] = ACTIONS(7498),
    [anon_sym_EQ] = ACTIONS(7498),
    [anon_sym_if] = ACTIONS(7498),
    [anon_sym_for] = ACTIONS(7498),
    [anon_sym_while] = ACTIONS(7498),
    [anon_sym_repeat] = ACTIONS(7498),
    [anon_sym_QMARK] = ACTIONS(7496),
    [anon_sym_TILDE] = ACTIONS(7496),
    [anon_sym_BANG] = ACTIONS(7498),
    [anon_sym_PLUS] = ACTIONS(7496),
    [anon_sym_DASH] = ACTIONS(7498),
    [anon_sym_LT_DASH] = ACTIONS(7496),
    [anon_sym_LT_LT_DASH] = ACTIONS(7496),
    [anon_sym_COLON_EQ] = ACTIONS(7496),
    [anon_sym_DASH_GT] = ACTIONS(7498),
    [anon_sym_DASH_GT_GT] = ACTIONS(7496),
    [anon_sym_PIPE] = ACTIONS(7498),
    [anon_sym_AMP] = ACTIONS(7498),
    [anon_sym_PIPE_PIPE] = ACTIONS(7496),
    [anon_sym_AMP_AMP] = ACTIONS(7496),
    [anon_sym_LT] = ACTIONS(7498),
    [anon_sym_LT_EQ] = ACTIONS(7496),
    [anon_sym_GT] = ACTIONS(7498),
    [anon_sym_GT_EQ] = ACTIONS(7496),
    [anon_sym_EQ_EQ] = ACTIONS(7496),
    [anon_sym_BANG_EQ] = ACTIONS(7496),
    [anon_sym_STAR] = ACTIONS(7498),
    [anon_sym_SLASH] = ACTIONS(7496),
    [anon_sym_STAR_STAR] = ACTIONS(7496),
    [anon_sym_CARET] = ACTIONS(7496),
    [aux_sym_binary_operator_token1] = ACTIONS(7496),
    [anon_sym_PIPE_GT] = ACTIONS(7496),
    [anon_sym_COLON] = ACTIONS(7498),
    [anon_sym_DOLLAR] = ACTIONS(7496),
    [anon_sym_AT] = ACTIONS(7496),
    [aux_sym__hex_literal_token1] = ACTIONS(7496),
    [sym__number_literal] = ACTIONS(7498),
    [anon_sym_SQUOTE] = ACTIONS(7496),
    [anon_sym_DQUOTE] = ACTIONS(7496),
    [sym_return] = ACTIONS(7498),
    [sym_next] = ACTIONS(7498),
    [sym_break] = ACTIONS(7498),
    [sym_true] = ACTIONS(7498),
    [sym_false] = ACTIONS(7498),
    [sym_null] = ACTIONS(7498),
    [sym_inf] = ACTIONS(7498),
    [sym_nan] = ACTIONS(7498),
    [anon_sym_NA] = ACTIONS(7498),
    [anon_sym_NA_integer_] = ACTIONS(7498),
    [anon_sym_NA_real_] = ACTIONS(7498),
    [anon_sym_NA_complex_] = ACTIONS(7498),
    [anon_sym_NA_character_] = ACTIONS(7498),
    [sym_dots] = ACTIONS(7498),
    [sym_dot_dot_i] = ACTIONS(7496),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7496),
    [sym__newline] = ACTIONS(7496),
    [sym__raw_string_literal] = ACTIONS(7496),
    [sym__external_else] = ACTIONS(7496),
    [sym__external_open_parenthesis] = ACTIONS(7496),
    [sym__external_close_parenthesis] = ACTIONS(7496),
    [sym__external_open_brace] = ACTIONS(7496),
    [sym__external_open_bracket] = ACTIONS(7496),
    [sym__external_open_bracket2] = ACTIONS(7496),
    [sym__external_close_bracket2] = ACTIONS(7496),
  },
  [2625] = {
    [ts_builtin_sym_end] = ACTIONS(7538),
    [sym_identifier] = ACTIONS(7540),
    [anon_sym_BSLASH] = ACTIONS(7538),
    [anon_sym_function] = ACTIONS(7540),
    [anon_sym_EQ] = ACTIONS(7540),
    [anon_sym_if] = ACTIONS(7540),
    [anon_sym_for] = ACTIONS(7540),
    [anon_sym_while] = ACTIONS(7540),
    [anon_sym_repeat] = ACTIONS(7540),
    [anon_sym_QMARK] = ACTIONS(7538),
    [anon_sym_TILDE] = ACTIONS(7538),
    [anon_sym_BANG] = ACTIONS(7540),
    [anon_sym_PLUS] = ACTIONS(7538),
    [anon_sym_DASH] = ACTIONS(7540),
    [anon_sym_LT_DASH] = ACTIONS(7538),
    [anon_sym_LT_LT_DASH] = ACTIONS(7538),
    [anon_sym_COLON_EQ] = ACTIONS(7538),
    [anon_sym_DASH_GT] = ACTIONS(7540),
    [anon_sym_DASH_GT_GT] = ACTIONS(7538),
    [anon_sym_PIPE] = ACTIONS(7540),
    [anon_sym_AMP] = ACTIONS(7540),
    [anon_sym_PIPE_PIPE] = ACTIONS(7538),
    [anon_sym_AMP_AMP] = ACTIONS(7538),
    [anon_sym_LT] = ACTIONS(7540),
    [anon_sym_LT_EQ] = ACTIONS(7538),
    [anon_sym_GT] = ACTIONS(7540),
    [anon_sym_GT_EQ] = ACTIONS(7538),
    [anon_sym_EQ_EQ] = ACTIONS(7538),
    [anon_sym_BANG_EQ] = ACTIONS(7538),
    [anon_sym_STAR] = ACTIONS(7540),
    [anon_sym_SLASH] = ACTIONS(7538),
    [anon_sym_STAR_STAR] = ACTIONS(7538),
    [anon_sym_CARET] = ACTIONS(7538),
    [aux_sym_binary_operator_token1] = ACTIONS(7538),
    [anon_sym_PIPE_GT] = ACTIONS(7538),
    [anon_sym_COLON] = ACTIONS(7540),
    [anon_sym_DOLLAR] = ACTIONS(7538),
    [anon_sym_AT] = ACTIONS(7538),
    [aux_sym__hex_literal_token1] = ACTIONS(7538),
    [sym__number_literal] = ACTIONS(7540),
    [anon_sym_SQUOTE] = ACTIONS(7538),
    [anon_sym_DQUOTE] = ACTIONS(7538),
    [sym_return] = ACTIONS(7540),
    [sym_next] = ACTIONS(7540),
    [sym_break] = ACTIONS(7540),
    [sym_true] = ACTIONS(7540),
    [sym_false] = ACTIONS(7540),
    [sym_null] = ACTIONS(7540),
    [sym_inf] = ACTIONS(7540),
    [sym_nan] = ACTIONS(7540),
    [anon_sym_NA] = ACTIONS(7540),
    [anon_sym_NA_integer_] = ACTIONS(7540),
    [anon_sym_NA_real_] = ACTIONS(7540),
    [anon_sym_NA_complex_] = ACTIONS(7540),
    [anon_sym_NA_character_] = ACTIONS(7540),
    [sym_dots] = ACTIONS(7540),
    [sym_dot_dot_i] = ACTIONS(7538),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7538),
    [sym__semicolon] = ACTIONS(7538),
    [sym__raw_string_literal] = ACTIONS(7538),
    [sym__external_else] = ACTIONS(7538),
    [sym__external_open_parenthesis] = ACTIONS(7538),
    [sym__external_open_brace] = ACTIONS(7538),
    [sym__external_close_brace] = ACTIONS(7538),
    [sym__external_open_bracket] = ACTIONS(7538),
    [sym__external_open_bracket2] = ACTIONS(7538),
  },
  [2626] = {
    [sym_identifier] = ACTIONS(7502),
    [anon_sym_BSLASH] = ACTIONS(7500),
    [anon_sym_function] = ACTIONS(7502),
    [anon_sym_EQ] = ACTIONS(7502),
    [anon_sym_if] = ACTIONS(7502),
    [anon_sym_for] = ACTIONS(7502),
    [anon_sym_while] = ACTIONS(7502),
    [anon_sym_repeat] = ACTIONS(7502),
    [anon_sym_QMARK] = ACTIONS(7500),
    [anon_sym_TILDE] = ACTIONS(7500),
    [anon_sym_BANG] = ACTIONS(7502),
    [anon_sym_PLUS] = ACTIONS(7500),
    [anon_sym_DASH] = ACTIONS(7502),
    [anon_sym_LT_DASH] = ACTIONS(7500),
    [anon_sym_LT_LT_DASH] = ACTIONS(7500),
    [anon_sym_COLON_EQ] = ACTIONS(7500),
    [anon_sym_DASH_GT] = ACTIONS(7502),
    [anon_sym_DASH_GT_GT] = ACTIONS(7500),
    [anon_sym_PIPE] = ACTIONS(7502),
    [anon_sym_AMP] = ACTIONS(7502),
    [anon_sym_PIPE_PIPE] = ACTIONS(7500),
    [anon_sym_AMP_AMP] = ACTIONS(7500),
    [anon_sym_LT] = ACTIONS(7502),
    [anon_sym_LT_EQ] = ACTIONS(7500),
    [anon_sym_GT] = ACTIONS(7502),
    [anon_sym_GT_EQ] = ACTIONS(7500),
    [anon_sym_EQ_EQ] = ACTIONS(7500),
    [anon_sym_BANG_EQ] = ACTIONS(7500),
    [anon_sym_STAR] = ACTIONS(7502),
    [anon_sym_SLASH] = ACTIONS(7500),
    [anon_sym_STAR_STAR] = ACTIONS(7500),
    [anon_sym_CARET] = ACTIONS(7500),
    [aux_sym_binary_operator_token1] = ACTIONS(7500),
    [anon_sym_PIPE_GT] = ACTIONS(7500),
    [anon_sym_COLON] = ACTIONS(7502),
    [anon_sym_DOLLAR] = ACTIONS(7500),
    [anon_sym_AT] = ACTIONS(7500),
    [aux_sym__hex_literal_token1] = ACTIONS(7500),
    [sym__number_literal] = ACTIONS(7502),
    [anon_sym_SQUOTE] = ACTIONS(7500),
    [anon_sym_DQUOTE] = ACTIONS(7500),
    [sym_return] = ACTIONS(7502),
    [sym_next] = ACTIONS(7502),
    [sym_break] = ACTIONS(7502),
    [sym_true] = ACTIONS(7502),
    [sym_false] = ACTIONS(7502),
    [sym_null] = ACTIONS(7502),
    [sym_inf] = ACTIONS(7502),
    [sym_nan] = ACTIONS(7502),
    [anon_sym_NA] = ACTIONS(7502),
    [anon_sym_NA_integer_] = ACTIONS(7502),
    [anon_sym_NA_real_] = ACTIONS(7502),
    [anon_sym_NA_complex_] = ACTIONS(7502),
    [anon_sym_NA_character_] = ACTIONS(7502),
    [sym_dots] = ACTIONS(7502),
    [sym_dot_dot_i] = ACTIONS(7500),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7500),
    [sym__newline] = ACTIONS(7500),
    [sym__raw_string_literal] = ACTIONS(7500),
    [sym__external_else] = ACTIONS(7500),
    [sym__external_open_parenthesis] = ACTIONS(7500),
    [sym__external_close_parenthesis] = ACTIONS(7500),
    [sym__external_open_brace] = ACTIONS(7500),
    [sym__external_open_bracket] = ACTIONS(7500),
    [sym__external_open_bracket2] = ACTIONS(7500),
    [sym__external_close_bracket2] = ACTIONS(7500),
  },
  [2627] = {
    [sym_identifier] = ACTIONS(7506),
    [anon_sym_BSLASH] = ACTIONS(7504),
    [anon_sym_function] = ACTIONS(7506),
    [anon_sym_EQ] = ACTIONS(7506),
    [anon_sym_if] = ACTIONS(7506),
    [anon_sym_for] = ACTIONS(7506),
    [anon_sym_while] = ACTIONS(7506),
    [anon_sym_repeat] = ACTIONS(7506),
    [anon_sym_QMARK] = ACTIONS(7504),
    [anon_sym_TILDE] = ACTIONS(7504),
    [anon_sym_BANG] = ACTIONS(7506),
    [anon_sym_PLUS] = ACTIONS(7504),
    [anon_sym_DASH] = ACTIONS(7506),
    [anon_sym_LT_DASH] = ACTIONS(7504),
    [anon_sym_LT_LT_DASH] = ACTIONS(7504),
    [anon_sym_COLON_EQ] = ACTIONS(7504),
    [anon_sym_DASH_GT] = ACTIONS(7506),
    [anon_sym_DASH_GT_GT] = ACTIONS(7504),
    [anon_sym_PIPE] = ACTIONS(7506),
    [anon_sym_AMP] = ACTIONS(7506),
    [anon_sym_PIPE_PIPE] = ACTIONS(7504),
    [anon_sym_AMP_AMP] = ACTIONS(7504),
    [anon_sym_LT] = ACTIONS(7506),
    [anon_sym_LT_EQ] = ACTIONS(7504),
    [anon_sym_GT] = ACTIONS(7506),
    [anon_sym_GT_EQ] = ACTIONS(7504),
    [anon_sym_EQ_EQ] = ACTIONS(7504),
    [anon_sym_BANG_EQ] = ACTIONS(7504),
    [anon_sym_STAR] = ACTIONS(7506),
    [anon_sym_SLASH] = ACTIONS(7504),
    [anon_sym_STAR_STAR] = ACTIONS(7504),
    [anon_sym_CARET] = ACTIONS(7504),
    [aux_sym_binary_operator_token1] = ACTIONS(7504),
    [anon_sym_PIPE_GT] = ACTIONS(7504),
    [anon_sym_COLON] = ACTIONS(7506),
    [anon_sym_DOLLAR] = ACTIONS(7504),
    [anon_sym_AT] = ACTIONS(7504),
    [aux_sym__hex_literal_token1] = ACTIONS(7504),
    [sym__number_literal] = ACTIONS(7506),
    [anon_sym_SQUOTE] = ACTIONS(7504),
    [anon_sym_DQUOTE] = ACTIONS(7504),
    [sym_return] = ACTIONS(7506),
    [sym_next] = ACTIONS(7506),
    [sym_break] = ACTIONS(7506),
    [sym_true] = ACTIONS(7506),
    [sym_false] = ACTIONS(7506),
    [sym_null] = ACTIONS(7506),
    [sym_inf] = ACTIONS(7506),
    [sym_nan] = ACTIONS(7506),
    [anon_sym_NA] = ACTIONS(7506),
    [anon_sym_NA_integer_] = ACTIONS(7506),
    [anon_sym_NA_real_] = ACTIONS(7506),
    [anon_sym_NA_complex_] = ACTIONS(7506),
    [anon_sym_NA_character_] = ACTIONS(7506),
    [sym_dots] = ACTIONS(7506),
    [sym_dot_dot_i] = ACTIONS(7504),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7504),
    [sym__newline] = ACTIONS(7504),
    [sym__raw_string_literal] = ACTIONS(7504),
    [sym__external_else] = ACTIONS(7504),
    [sym__external_open_parenthesis] = ACTIONS(7504),
    [sym__external_close_parenthesis] = ACTIONS(7504),
    [sym__external_open_brace] = ACTIONS(7504),
    [sym__external_open_bracket] = ACTIONS(7504),
    [sym__external_open_bracket2] = ACTIONS(7504),
    [sym__external_close_bracket2] = ACTIONS(7504),
  },
  [2628] = {
    [ts_builtin_sym_end] = ACTIONS(7542),
    [sym_identifier] = ACTIONS(7544),
    [anon_sym_BSLASH] = ACTIONS(7542),
    [anon_sym_function] = ACTIONS(7544),
    [anon_sym_EQ] = ACTIONS(7544),
    [anon_sym_if] = ACTIONS(7544),
    [anon_sym_for] = ACTIONS(7544),
    [anon_sym_while] = ACTIONS(7544),
    [anon_sym_repeat] = ACTIONS(7544),
    [anon_sym_QMARK] = ACTIONS(7542),
    [anon_sym_TILDE] = ACTIONS(7542),
    [anon_sym_BANG] = ACTIONS(7544),
    [anon_sym_PLUS] = ACTIONS(7542),
    [anon_sym_DASH] = ACTIONS(7544),
    [anon_sym_LT_DASH] = ACTIONS(7542),
    [anon_sym_LT_LT_DASH] = ACTIONS(7542),
    [anon_sym_COLON_EQ] = ACTIONS(7542),
    [anon_sym_DASH_GT] = ACTIONS(7544),
    [anon_sym_DASH_GT_GT] = ACTIONS(7542),
    [anon_sym_PIPE] = ACTIONS(7544),
    [anon_sym_AMP] = ACTIONS(7544),
    [anon_sym_PIPE_PIPE] = ACTIONS(7542),
    [anon_sym_AMP_AMP] = ACTIONS(7542),
    [anon_sym_LT] = ACTIONS(7544),
    [anon_sym_LT_EQ] = ACTIONS(7542),
    [anon_sym_GT] = ACTIONS(7544),
    [anon_sym_GT_EQ] = ACTIONS(7542),
    [anon_sym_EQ_EQ] = ACTIONS(7542),
    [anon_sym_BANG_EQ] = ACTIONS(7542),
    [anon_sym_STAR] = ACTIONS(7544),
    [anon_sym_SLASH] = ACTIONS(7542),
    [anon_sym_STAR_STAR] = ACTIONS(7542),
    [anon_sym_CARET] = ACTIONS(7542),
    [aux_sym_binary_operator_token1] = ACTIONS(7542),
    [anon_sym_PIPE_GT] = ACTIONS(7542),
    [anon_sym_COLON] = ACTIONS(7544),
    [anon_sym_DOLLAR] = ACTIONS(7542),
    [anon_sym_AT] = ACTIONS(7542),
    [aux_sym__hex_literal_token1] = ACTIONS(7542),
    [sym__number_literal] = ACTIONS(7544),
    [anon_sym_SQUOTE] = ACTIONS(7542),
    [anon_sym_DQUOTE] = ACTIONS(7542),
    [sym_return] = ACTIONS(7544),
    [sym_next] = ACTIONS(7544),
    [sym_break] = ACTIONS(7544),
    [sym_true] = ACTIONS(7544),
    [sym_false] = ACTIONS(7544),
    [sym_null] = ACTIONS(7544),
    [sym_inf] = ACTIONS(7544),
    [sym_nan] = ACTIONS(7544),
    [anon_sym_NA] = ACTIONS(7544),
    [anon_sym_NA_integer_] = ACTIONS(7544),
    [anon_sym_NA_real_] = ACTIONS(7544),
    [anon_sym_NA_complex_] = ACTIONS(7544),
    [anon_sym_NA_character_] = ACTIONS(7544),
    [sym_dots] = ACTIONS(7544),
    [sym_dot_dot_i] = ACTIONS(7542),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7542),
    [sym__semicolon] = ACTIONS(7542),
    [sym__raw_string_literal] = ACTIONS(7542),
    [sym__external_else] = ACTIONS(7542),
    [sym__external_open_parenthesis] = ACTIONS(7542),
    [sym__external_open_brace] = ACTIONS(7542),
    [sym__external_close_brace] = ACTIONS(7542),
    [sym__external_open_bracket] = ACTIONS(7542),
    [sym__external_open_bracket2] = ACTIONS(7542),
  },
  [2629] = {
    [sym_identifier] = ACTIONS(7512),
    [anon_sym_BSLASH] = ACTIONS(7510),
    [anon_sym_function] = ACTIONS(7512),
    [anon_sym_EQ] = ACTIONS(7512),
    [anon_sym_if] = ACTIONS(7512),
    [anon_sym_for] = ACTIONS(7512),
    [anon_sym_while] = ACTIONS(7512),
    [anon_sym_repeat] = ACTIONS(7512),
    [anon_sym_QMARK] = ACTIONS(7510),
    [anon_sym_TILDE] = ACTIONS(7510),
    [anon_sym_BANG] = ACTIONS(7512),
    [anon_sym_PLUS] = ACTIONS(7510),
    [anon_sym_DASH] = ACTIONS(7512),
    [anon_sym_LT_DASH] = ACTIONS(7510),
    [anon_sym_LT_LT_DASH] = ACTIONS(7510),
    [anon_sym_COLON_EQ] = ACTIONS(7510),
    [anon_sym_DASH_GT] = ACTIONS(7512),
    [anon_sym_DASH_GT_GT] = ACTIONS(7510),
    [anon_sym_PIPE] = ACTIONS(7512),
    [anon_sym_AMP] = ACTIONS(7512),
    [anon_sym_PIPE_PIPE] = ACTIONS(7510),
    [anon_sym_AMP_AMP] = ACTIONS(7510),
    [anon_sym_LT] = ACTIONS(7512),
    [anon_sym_LT_EQ] = ACTIONS(7510),
    [anon_sym_GT] = ACTIONS(7512),
    [anon_sym_GT_EQ] = ACTIONS(7510),
    [anon_sym_EQ_EQ] = ACTIONS(7510),
    [anon_sym_BANG_EQ] = ACTIONS(7510),
    [anon_sym_STAR] = ACTIONS(7512),
    [anon_sym_SLASH] = ACTIONS(7510),
    [anon_sym_STAR_STAR] = ACTIONS(7510),
    [anon_sym_CARET] = ACTIONS(7510),
    [aux_sym_binary_operator_token1] = ACTIONS(7510),
    [anon_sym_PIPE_GT] = ACTIONS(7510),
    [anon_sym_COLON] = ACTIONS(7512),
    [anon_sym_DOLLAR] = ACTIONS(7510),
    [anon_sym_AT] = ACTIONS(7510),
    [aux_sym__hex_literal_token1] = ACTIONS(7510),
    [sym__number_literal] = ACTIONS(7512),
    [anon_sym_SQUOTE] = ACTIONS(7510),
    [anon_sym_DQUOTE] = ACTIONS(7510),
    [sym_return] = ACTIONS(7512),
    [sym_next] = ACTIONS(7512),
    [sym_break] = ACTIONS(7512),
    [sym_true] = ACTIONS(7512),
    [sym_false] = ACTIONS(7512),
    [sym_null] = ACTIONS(7512),
    [sym_inf] = ACTIONS(7512),
    [sym_nan] = ACTIONS(7512),
    [anon_sym_NA] = ACTIONS(7512),
    [anon_sym_NA_integer_] = ACTIONS(7512),
    [anon_sym_NA_real_] = ACTIONS(7512),
    [anon_sym_NA_complex_] = ACTIONS(7512),
    [anon_sym_NA_character_] = ACTIONS(7512),
    [sym_dots] = ACTIONS(7512),
    [sym_dot_dot_i] = ACTIONS(7510),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7510),
    [sym__newline] = ACTIONS(7510),
    [sym__raw_string_literal] = ACTIONS(7510),
    [sym__external_else] = ACTIONS(7510),
    [sym__external_open_parenthesis] = ACTIONS(7510),
    [sym__external_close_parenthesis] = ACTIONS(7510),
    [sym__external_open_brace] = ACTIONS(7510),
    [sym__external_open_bracket] = ACTIONS(7510),
    [sym__external_open_bracket2] = ACTIONS(7510),
    [sym__external_close_bracket2] = ACTIONS(7510),
  },
  [2630] = {
    [sym_identifier] = ACTIONS(7151),
    [anon_sym_BSLASH] = ACTIONS(7153),
    [anon_sym_function] = ACTIONS(7151),
    [anon_sym_EQ] = ACTIONS(7151),
    [anon_sym_if] = ACTIONS(7151),
    [anon_sym_for] = ACTIONS(7151),
    [anon_sym_while] = ACTIONS(7151),
    [anon_sym_repeat] = ACTIONS(7151),
    [anon_sym_QMARK] = ACTIONS(7153),
    [anon_sym_TILDE] = ACTIONS(7153),
    [anon_sym_BANG] = ACTIONS(7151),
    [anon_sym_PLUS] = ACTIONS(7153),
    [anon_sym_DASH] = ACTIONS(7151),
    [anon_sym_LT_DASH] = ACTIONS(7153),
    [anon_sym_LT_LT_DASH] = ACTIONS(7153),
    [anon_sym_COLON_EQ] = ACTIONS(7153),
    [anon_sym_DASH_GT] = ACTIONS(7151),
    [anon_sym_DASH_GT_GT] = ACTIONS(7153),
    [anon_sym_PIPE] = ACTIONS(7151),
    [anon_sym_AMP] = ACTIONS(7151),
    [anon_sym_PIPE_PIPE] = ACTIONS(7153),
    [anon_sym_AMP_AMP] = ACTIONS(7153),
    [anon_sym_LT] = ACTIONS(7151),
    [anon_sym_LT_EQ] = ACTIONS(7153),
    [anon_sym_GT] = ACTIONS(7151),
    [anon_sym_GT_EQ] = ACTIONS(7153),
    [anon_sym_EQ_EQ] = ACTIONS(7153),
    [anon_sym_BANG_EQ] = ACTIONS(7153),
    [anon_sym_STAR] = ACTIONS(7151),
    [anon_sym_SLASH] = ACTIONS(7153),
    [anon_sym_STAR_STAR] = ACTIONS(7153),
    [anon_sym_CARET] = ACTIONS(7153),
    [aux_sym_binary_operator_token1] = ACTIONS(7153),
    [anon_sym_PIPE_GT] = ACTIONS(7153),
    [anon_sym_COLON] = ACTIONS(7151),
    [anon_sym_DOLLAR] = ACTIONS(7153),
    [anon_sym_AT] = ACTIONS(7153),
    [anon_sym_COLON_COLON] = ACTIONS(7151),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7153),
    [aux_sym__hex_literal_token1] = ACTIONS(7153),
    [sym__number_literal] = ACTIONS(7151),
    [anon_sym_SQUOTE] = ACTIONS(7153),
    [anon_sym_DQUOTE] = ACTIONS(7153),
    [sym_return] = ACTIONS(7151),
    [sym_next] = ACTIONS(7151),
    [sym_break] = ACTIONS(7151),
    [sym_true] = ACTIONS(7151),
    [sym_false] = ACTIONS(7151),
    [sym_null] = ACTIONS(7151),
    [sym_inf] = ACTIONS(7151),
    [sym_nan] = ACTIONS(7151),
    [anon_sym_NA] = ACTIONS(7151),
    [anon_sym_NA_integer_] = ACTIONS(7151),
    [anon_sym_NA_real_] = ACTIONS(7151),
    [anon_sym_NA_complex_] = ACTIONS(7151),
    [anon_sym_NA_character_] = ACTIONS(7151),
    [sym_dots] = ACTIONS(7151),
    [sym_dot_dot_i] = ACTIONS(7153),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7153),
    [sym__newline] = ACTIONS(7153),
    [sym__raw_string_literal] = ACTIONS(7153),
    [sym__external_open_parenthesis] = ACTIONS(7153),
    [sym__external_close_parenthesis] = ACTIONS(7153),
    [sym__external_open_brace] = ACTIONS(7153),
    [sym__external_open_bracket] = ACTIONS(7153),
    [sym__external_open_bracket2] = ACTIONS(7153),
  },
  [2631] = {
    [sym_identifier] = ACTIONS(7163),
    [anon_sym_BSLASH] = ACTIONS(7165),
    [anon_sym_function] = ACTIONS(7163),
    [anon_sym_EQ] = ACTIONS(7163),
    [anon_sym_if] = ACTIONS(7163),
    [anon_sym_for] = ACTIONS(7163),
    [anon_sym_while] = ACTIONS(7163),
    [anon_sym_repeat] = ACTIONS(7163),
    [anon_sym_QMARK] = ACTIONS(7165),
    [anon_sym_TILDE] = ACTIONS(7165),
    [anon_sym_BANG] = ACTIONS(7163),
    [anon_sym_PLUS] = ACTIONS(7165),
    [anon_sym_DASH] = ACTIONS(7163),
    [anon_sym_LT_DASH] = ACTIONS(7165),
    [anon_sym_LT_LT_DASH] = ACTIONS(7165),
    [anon_sym_COLON_EQ] = ACTIONS(7165),
    [anon_sym_DASH_GT] = ACTIONS(7163),
    [anon_sym_DASH_GT_GT] = ACTIONS(7165),
    [anon_sym_PIPE] = ACTIONS(7163),
    [anon_sym_AMP] = ACTIONS(7163),
    [anon_sym_PIPE_PIPE] = ACTIONS(7165),
    [anon_sym_AMP_AMP] = ACTIONS(7165),
    [anon_sym_LT] = ACTIONS(7163),
    [anon_sym_LT_EQ] = ACTIONS(7165),
    [anon_sym_GT] = ACTIONS(7163),
    [anon_sym_GT_EQ] = ACTIONS(7165),
    [anon_sym_EQ_EQ] = ACTIONS(7165),
    [anon_sym_BANG_EQ] = ACTIONS(7165),
    [anon_sym_STAR] = ACTIONS(7163),
    [anon_sym_SLASH] = ACTIONS(7165),
    [anon_sym_STAR_STAR] = ACTIONS(7165),
    [anon_sym_CARET] = ACTIONS(7165),
    [aux_sym_binary_operator_token1] = ACTIONS(7165),
    [anon_sym_PIPE_GT] = ACTIONS(7165),
    [anon_sym_COLON] = ACTIONS(7163),
    [anon_sym_DOLLAR] = ACTIONS(7165),
    [anon_sym_AT] = ACTIONS(7165),
    [anon_sym_COLON_COLON] = ACTIONS(7163),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7165),
    [aux_sym__hex_literal_token1] = ACTIONS(7165),
    [sym__number_literal] = ACTIONS(7163),
    [anon_sym_SQUOTE] = ACTIONS(7165),
    [anon_sym_DQUOTE] = ACTIONS(7165),
    [sym_return] = ACTIONS(7163),
    [sym_next] = ACTIONS(7163),
    [sym_break] = ACTIONS(7163),
    [sym_true] = ACTIONS(7163),
    [sym_false] = ACTIONS(7163),
    [sym_null] = ACTIONS(7163),
    [sym_inf] = ACTIONS(7163),
    [sym_nan] = ACTIONS(7163),
    [anon_sym_NA] = ACTIONS(7163),
    [anon_sym_NA_integer_] = ACTIONS(7163),
    [anon_sym_NA_real_] = ACTIONS(7163),
    [anon_sym_NA_complex_] = ACTIONS(7163),
    [anon_sym_NA_character_] = ACTIONS(7163),
    [sym_dots] = ACTIONS(7163),
    [sym_dot_dot_i] = ACTIONS(7165),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7165),
    [sym__newline] = ACTIONS(7165),
    [sym__raw_string_literal] = ACTIONS(7165),
    [sym__external_open_parenthesis] = ACTIONS(7165),
    [sym__external_close_parenthesis] = ACTIONS(7165),
    [sym__external_open_brace] = ACTIONS(7165),
    [sym__external_open_bracket] = ACTIONS(7165),
    [sym__external_open_bracket2] = ACTIONS(7165),
  },
  [2632] = {
    [sym_identifier] = ACTIONS(7474),
    [anon_sym_BSLASH] = ACTIONS(7472),
    [anon_sym_function] = ACTIONS(7474),
    [anon_sym_EQ] = ACTIONS(7474),
    [anon_sym_if] = ACTIONS(7474),
    [anon_sym_for] = ACTIONS(7474),
    [anon_sym_while] = ACTIONS(7474),
    [anon_sym_repeat] = ACTIONS(7474),
    [anon_sym_QMARK] = ACTIONS(7472),
    [anon_sym_TILDE] = ACTIONS(7472),
    [anon_sym_BANG] = ACTIONS(7474),
    [anon_sym_PLUS] = ACTIONS(7472),
    [anon_sym_DASH] = ACTIONS(7474),
    [anon_sym_LT_DASH] = ACTIONS(7472),
    [anon_sym_LT_LT_DASH] = ACTIONS(7472),
    [anon_sym_COLON_EQ] = ACTIONS(7472),
    [anon_sym_DASH_GT] = ACTIONS(7474),
    [anon_sym_DASH_GT_GT] = ACTIONS(7472),
    [anon_sym_PIPE] = ACTIONS(7474),
    [anon_sym_AMP] = ACTIONS(7474),
    [anon_sym_PIPE_PIPE] = ACTIONS(7472),
    [anon_sym_AMP_AMP] = ACTIONS(7472),
    [anon_sym_LT] = ACTIONS(7474),
    [anon_sym_LT_EQ] = ACTIONS(7472),
    [anon_sym_GT] = ACTIONS(7474),
    [anon_sym_GT_EQ] = ACTIONS(7472),
    [anon_sym_EQ_EQ] = ACTIONS(7472),
    [anon_sym_BANG_EQ] = ACTIONS(7472),
    [anon_sym_STAR] = ACTIONS(7474),
    [anon_sym_SLASH] = ACTIONS(7472),
    [anon_sym_STAR_STAR] = ACTIONS(7472),
    [anon_sym_CARET] = ACTIONS(7472),
    [aux_sym_binary_operator_token1] = ACTIONS(7472),
    [anon_sym_PIPE_GT] = ACTIONS(7472),
    [anon_sym_COLON] = ACTIONS(7474),
    [anon_sym_DOLLAR] = ACTIONS(7472),
    [anon_sym_AT] = ACTIONS(7472),
    [aux_sym__hex_literal_token1] = ACTIONS(7472),
    [sym__number_literal] = ACTIONS(7474),
    [anon_sym_SQUOTE] = ACTIONS(7472),
    [anon_sym_DQUOTE] = ACTIONS(7472),
    [sym_return] = ACTIONS(7474),
    [sym_next] = ACTIONS(7474),
    [sym_break] = ACTIONS(7474),
    [sym_true] = ACTIONS(7474),
    [sym_false] = ACTIONS(7474),
    [sym_null] = ACTIONS(7474),
    [sym_inf] = ACTIONS(7474),
    [sym_nan] = ACTIONS(7474),
    [anon_sym_NA] = ACTIONS(7474),
    [anon_sym_NA_integer_] = ACTIONS(7474),
    [anon_sym_NA_real_] = ACTIONS(7474),
    [anon_sym_NA_complex_] = ACTIONS(7474),
    [anon_sym_NA_character_] = ACTIONS(7474),
    [sym_dots] = ACTIONS(7474),
    [sym_dot_dot_i] = ACTIONS(7472),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7472),
    [sym__newline] = ACTIONS(7472),
    [sym__semicolon] = ACTIONS(7472),
    [sym__raw_string_literal] = ACTIONS(7472),
    [sym__external_open_parenthesis] = ACTIONS(7472),
    [sym__external_open_brace] = ACTIONS(7472),
    [sym__external_close_brace] = ACTIONS(7472),
    [sym__external_open_bracket] = ACTIONS(7472),
    [sym__external_open_bracket2] = ACTIONS(7472),
    [sym__external_close_bracket2] = ACTIONS(7472),
  },
  [2633] = {
    [sym_identifier] = ACTIONS(7129),
    [anon_sym_BSLASH] = ACTIONS(7131),
    [anon_sym_function] = ACTIONS(7129),
    [anon_sym_EQ] = ACTIONS(7663),
    [anon_sym_if] = ACTIONS(7129),
    [anon_sym_for] = ACTIONS(7129),
    [anon_sym_while] = ACTIONS(7129),
    [anon_sym_repeat] = ACTIONS(7129),
    [anon_sym_QMARK] = ACTIONS(7131),
    [anon_sym_TILDE] = ACTIONS(7131),
    [anon_sym_BANG] = ACTIONS(7129),
    [anon_sym_PLUS] = ACTIONS(7131),
    [anon_sym_DASH] = ACTIONS(7129),
    [anon_sym_LT_DASH] = ACTIONS(7131),
    [anon_sym_LT_LT_DASH] = ACTIONS(7131),
    [anon_sym_COLON_EQ] = ACTIONS(7131),
    [anon_sym_DASH_GT] = ACTIONS(7129),
    [anon_sym_DASH_GT_GT] = ACTIONS(7131),
    [anon_sym_PIPE] = ACTIONS(7129),
    [anon_sym_AMP] = ACTIONS(7129),
    [anon_sym_PIPE_PIPE] = ACTIONS(7131),
    [anon_sym_AMP_AMP] = ACTIONS(7131),
    [anon_sym_LT] = ACTIONS(7129),
    [anon_sym_LT_EQ] = ACTIONS(7131),
    [anon_sym_GT] = ACTIONS(7129),
    [anon_sym_GT_EQ] = ACTIONS(7131),
    [anon_sym_EQ_EQ] = ACTIONS(7131),
    [anon_sym_BANG_EQ] = ACTIONS(7131),
    [anon_sym_STAR] = ACTIONS(7129),
    [anon_sym_SLASH] = ACTIONS(7131),
    [anon_sym_STAR_STAR] = ACTIONS(7131),
    [anon_sym_CARET] = ACTIONS(7131),
    [aux_sym_binary_operator_token1] = ACTIONS(7131),
    [anon_sym_PIPE_GT] = ACTIONS(7131),
    [anon_sym_COLON] = ACTIONS(7129),
    [anon_sym_DOLLAR] = ACTIONS(7131),
    [anon_sym_AT] = ACTIONS(7131),
    [anon_sym_COLON_COLON] = ACTIONS(7133),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7135),
    [aux_sym__hex_literal_token1] = ACTIONS(7131),
    [sym__number_literal] = ACTIONS(7129),
    [anon_sym_SQUOTE] = ACTIONS(7131),
    [anon_sym_DQUOTE] = ACTIONS(7131),
    [sym_return] = ACTIONS(7129),
    [sym_next] = ACTIONS(7129),
    [sym_break] = ACTIONS(7129),
    [sym_true] = ACTIONS(7129),
    [sym_false] = ACTIONS(7129),
    [sym_null] = ACTIONS(7129),
    [sym_inf] = ACTIONS(7129),
    [sym_nan] = ACTIONS(7129),
    [anon_sym_NA] = ACTIONS(7129),
    [anon_sym_NA_integer_] = ACTIONS(7129),
    [anon_sym_NA_real_] = ACTIONS(7129),
    [anon_sym_NA_complex_] = ACTIONS(7129),
    [anon_sym_NA_character_] = ACTIONS(7129),
    [sym_dots] = ACTIONS(7129),
    [sym_dot_dot_i] = ACTIONS(7131),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7131),
    [sym__newline] = ACTIONS(7131),
    [sym__raw_string_literal] = ACTIONS(7131),
    [sym__external_open_parenthesis] = ACTIONS(7131),
    [sym__external_close_parenthesis] = ACTIONS(7131),
    [sym__external_open_brace] = ACTIONS(7131),
    [sym__external_open_bracket] = ACTIONS(7131),
    [sym__external_open_bracket2] = ACTIONS(7131),
  },
  [2634] = {
    [sym_identifier] = ACTIONS(7464),
    [anon_sym_BSLASH] = ACTIONS(7466),
    [anon_sym_function] = ACTIONS(7464),
    [anon_sym_EQ] = ACTIONS(7464),
    [anon_sym_if] = ACTIONS(7464),
    [anon_sym_for] = ACTIONS(7464),
    [anon_sym_while] = ACTIONS(7464),
    [anon_sym_repeat] = ACTIONS(7464),
    [anon_sym_QMARK] = ACTIONS(7466),
    [anon_sym_TILDE] = ACTIONS(7466),
    [anon_sym_BANG] = ACTIONS(7464),
    [anon_sym_PLUS] = ACTIONS(7466),
    [anon_sym_DASH] = ACTIONS(7464),
    [anon_sym_LT_DASH] = ACTIONS(7466),
    [anon_sym_LT_LT_DASH] = ACTIONS(7466),
    [anon_sym_COLON_EQ] = ACTIONS(7466),
    [anon_sym_DASH_GT] = ACTIONS(7464),
    [anon_sym_DASH_GT_GT] = ACTIONS(7466),
    [anon_sym_PIPE] = ACTIONS(7464),
    [anon_sym_AMP] = ACTIONS(7464),
    [anon_sym_PIPE_PIPE] = ACTIONS(7466),
    [anon_sym_AMP_AMP] = ACTIONS(7466),
    [anon_sym_LT] = ACTIONS(7464),
    [anon_sym_LT_EQ] = ACTIONS(7466),
    [anon_sym_GT] = ACTIONS(7464),
    [anon_sym_GT_EQ] = ACTIONS(7466),
    [anon_sym_EQ_EQ] = ACTIONS(7466),
    [anon_sym_BANG_EQ] = ACTIONS(7466),
    [anon_sym_STAR] = ACTIONS(7464),
    [anon_sym_SLASH] = ACTIONS(7466),
    [anon_sym_STAR_STAR] = ACTIONS(7466),
    [anon_sym_CARET] = ACTIONS(7466),
    [aux_sym_binary_operator_token1] = ACTIONS(7466),
    [anon_sym_PIPE_GT] = ACTIONS(7466),
    [anon_sym_COLON] = ACTIONS(7464),
    [anon_sym_DOLLAR] = ACTIONS(7466),
    [anon_sym_AT] = ACTIONS(7466),
    [aux_sym__hex_literal_token1] = ACTIONS(7466),
    [sym__number_literal] = ACTIONS(7464),
    [anon_sym_SQUOTE] = ACTIONS(7466),
    [anon_sym_DQUOTE] = ACTIONS(7466),
    [sym_return] = ACTIONS(7464),
    [sym_next] = ACTIONS(7464),
    [sym_break] = ACTIONS(7464),
    [sym_true] = ACTIONS(7464),
    [sym_false] = ACTIONS(7464),
    [sym_null] = ACTIONS(7464),
    [sym_inf] = ACTIONS(7464),
    [sym_nan] = ACTIONS(7464),
    [anon_sym_NA] = ACTIONS(7464),
    [anon_sym_NA_integer_] = ACTIONS(7464),
    [anon_sym_NA_real_] = ACTIONS(7464),
    [anon_sym_NA_complex_] = ACTIONS(7464),
    [anon_sym_NA_character_] = ACTIONS(7464),
    [sym_dots] = ACTIONS(7464),
    [sym_dot_dot_i] = ACTIONS(7466),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7466),
    [sym__newline] = ACTIONS(7466),
    [sym__semicolon] = ACTIONS(7466),
    [sym__raw_string_literal] = ACTIONS(7466),
    [sym__external_open_parenthesis] = ACTIONS(7466),
    [sym__external_open_brace] = ACTIONS(7466),
    [sym__external_close_brace] = ACTIONS(7466),
    [sym__external_open_bracket] = ACTIONS(7466),
    [sym__external_open_bracket2] = ACTIONS(7466),
    [sym__external_close_bracket2] = ACTIONS(7466),
  },
  [2635] = {
    [sym_identifier] = ACTIONS(7478),
    [anon_sym_BSLASH] = ACTIONS(7476),
    [anon_sym_function] = ACTIONS(7478),
    [anon_sym_EQ] = ACTIONS(7478),
    [anon_sym_if] = ACTIONS(7478),
    [anon_sym_for] = ACTIONS(7478),
    [anon_sym_while] = ACTIONS(7478),
    [anon_sym_repeat] = ACTIONS(7478),
    [anon_sym_QMARK] = ACTIONS(7476),
    [anon_sym_TILDE] = ACTIONS(7476),
    [anon_sym_BANG] = ACTIONS(7478),
    [anon_sym_PLUS] = ACTIONS(7476),
    [anon_sym_DASH] = ACTIONS(7478),
    [anon_sym_LT_DASH] = ACTIONS(7476),
    [anon_sym_LT_LT_DASH] = ACTIONS(7476),
    [anon_sym_COLON_EQ] = ACTIONS(7476),
    [anon_sym_DASH_GT] = ACTIONS(7478),
    [anon_sym_DASH_GT_GT] = ACTIONS(7476),
    [anon_sym_PIPE] = ACTIONS(7478),
    [anon_sym_AMP] = ACTIONS(7478),
    [anon_sym_PIPE_PIPE] = ACTIONS(7476),
    [anon_sym_AMP_AMP] = ACTIONS(7476),
    [anon_sym_LT] = ACTIONS(7478),
    [anon_sym_LT_EQ] = ACTIONS(7476),
    [anon_sym_GT] = ACTIONS(7478),
    [anon_sym_GT_EQ] = ACTIONS(7476),
    [anon_sym_EQ_EQ] = ACTIONS(7476),
    [anon_sym_BANG_EQ] = ACTIONS(7476),
    [anon_sym_STAR] = ACTIONS(7478),
    [anon_sym_SLASH] = ACTIONS(7476),
    [anon_sym_STAR_STAR] = ACTIONS(7476),
    [anon_sym_CARET] = ACTIONS(7476),
    [aux_sym_binary_operator_token1] = ACTIONS(7476),
    [anon_sym_PIPE_GT] = ACTIONS(7476),
    [anon_sym_COLON] = ACTIONS(7478),
    [anon_sym_DOLLAR] = ACTIONS(7476),
    [anon_sym_AT] = ACTIONS(7476),
    [aux_sym__hex_literal_token1] = ACTIONS(7476),
    [sym__number_literal] = ACTIONS(7478),
    [anon_sym_SQUOTE] = ACTIONS(7476),
    [anon_sym_DQUOTE] = ACTIONS(7476),
    [sym_return] = ACTIONS(7478),
    [sym_next] = ACTIONS(7478),
    [sym_break] = ACTIONS(7478),
    [sym_true] = ACTIONS(7478),
    [sym_false] = ACTIONS(7478),
    [sym_null] = ACTIONS(7478),
    [sym_inf] = ACTIONS(7478),
    [sym_nan] = ACTIONS(7478),
    [anon_sym_NA] = ACTIONS(7478),
    [anon_sym_NA_integer_] = ACTIONS(7478),
    [anon_sym_NA_real_] = ACTIONS(7478),
    [anon_sym_NA_complex_] = ACTIONS(7478),
    [anon_sym_NA_character_] = ACTIONS(7478),
    [sym_dots] = ACTIONS(7478),
    [sym_dot_dot_i] = ACTIONS(7476),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7476),
    [sym__newline] = ACTIONS(7476),
    [sym__semicolon] = ACTIONS(7476),
    [sym__raw_string_literal] = ACTIONS(7476),
    [sym__external_open_parenthesis] = ACTIONS(7476),
    [sym__external_open_brace] = ACTIONS(7476),
    [sym__external_close_brace] = ACTIONS(7476),
    [sym__external_open_bracket] = ACTIONS(7476),
    [sym__external_open_bracket2] = ACTIONS(7476),
    [sym__external_close_bracket2] = ACTIONS(7476),
  },
  [2636] = {
    [sym_identifier] = ACTIONS(7163),
    [anon_sym_BSLASH] = ACTIONS(7165),
    [anon_sym_function] = ACTIONS(7163),
    [anon_sym_EQ] = ACTIONS(7163),
    [anon_sym_if] = ACTIONS(7163),
    [anon_sym_for] = ACTIONS(7163),
    [anon_sym_while] = ACTIONS(7163),
    [anon_sym_repeat] = ACTIONS(7163),
    [anon_sym_QMARK] = ACTIONS(7165),
    [anon_sym_TILDE] = ACTIONS(7165),
    [anon_sym_BANG] = ACTIONS(7163),
    [anon_sym_PLUS] = ACTIONS(7165),
    [anon_sym_DASH] = ACTIONS(7163),
    [anon_sym_LT_DASH] = ACTIONS(7165),
    [anon_sym_LT_LT_DASH] = ACTIONS(7165),
    [anon_sym_COLON_EQ] = ACTIONS(7165),
    [anon_sym_DASH_GT] = ACTIONS(7163),
    [anon_sym_DASH_GT_GT] = ACTIONS(7165),
    [anon_sym_PIPE] = ACTIONS(7163),
    [anon_sym_AMP] = ACTIONS(7163),
    [anon_sym_PIPE_PIPE] = ACTIONS(7165),
    [anon_sym_AMP_AMP] = ACTIONS(7165),
    [anon_sym_LT] = ACTIONS(7163),
    [anon_sym_LT_EQ] = ACTIONS(7165),
    [anon_sym_GT] = ACTIONS(7163),
    [anon_sym_GT_EQ] = ACTIONS(7165),
    [anon_sym_EQ_EQ] = ACTIONS(7165),
    [anon_sym_BANG_EQ] = ACTIONS(7165),
    [anon_sym_STAR] = ACTIONS(7163),
    [anon_sym_SLASH] = ACTIONS(7165),
    [anon_sym_STAR_STAR] = ACTIONS(7165),
    [anon_sym_CARET] = ACTIONS(7165),
    [aux_sym_binary_operator_token1] = ACTIONS(7165),
    [anon_sym_PIPE_GT] = ACTIONS(7165),
    [anon_sym_COLON] = ACTIONS(7163),
    [anon_sym_DOLLAR] = ACTIONS(7165),
    [anon_sym_AT] = ACTIONS(7165),
    [anon_sym_COLON_COLON] = ACTIONS(7163),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7165),
    [aux_sym__hex_literal_token1] = ACTIONS(7165),
    [sym__number_literal] = ACTIONS(7163),
    [anon_sym_SQUOTE] = ACTIONS(7165),
    [anon_sym_DQUOTE] = ACTIONS(7165),
    [sym_return] = ACTIONS(7163),
    [sym_next] = ACTIONS(7163),
    [sym_break] = ACTIONS(7163),
    [sym_true] = ACTIONS(7163),
    [sym_false] = ACTIONS(7163),
    [sym_null] = ACTIONS(7163),
    [sym_inf] = ACTIONS(7163),
    [sym_nan] = ACTIONS(7163),
    [anon_sym_NA] = ACTIONS(7163),
    [anon_sym_NA_integer_] = ACTIONS(7163),
    [anon_sym_NA_real_] = ACTIONS(7163),
    [anon_sym_NA_complex_] = ACTIONS(7163),
    [anon_sym_NA_character_] = ACTIONS(7163),
    [sym_dots] = ACTIONS(7163),
    [sym_dot_dot_i] = ACTIONS(7165),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7165),
    [sym__newline] = ACTIONS(7165),
    [sym__raw_string_literal] = ACTIONS(7165),
    [sym__external_open_parenthesis] = ACTIONS(7165),
    [sym__external_open_brace] = ACTIONS(7165),
    [sym__external_open_bracket] = ACTIONS(7165),
    [sym__external_close_bracket] = ACTIONS(7165),
    [sym__external_open_bracket2] = ACTIONS(7165),
  },
  [2637] = {
    [aux_sym_function_definition_repeat1] = STATE(2637),
    [sym_identifier] = ACTIONS(7419),
    [anon_sym_BSLASH] = ACTIONS(7417),
    [anon_sym_function] = ACTIONS(7419),
    [anon_sym_EQ] = ACTIONS(7419),
    [anon_sym_if] = ACTIONS(7419),
    [anon_sym_for] = ACTIONS(7419),
    [anon_sym_while] = ACTIONS(7419),
    [anon_sym_repeat] = ACTIONS(7419),
    [anon_sym_QMARK] = ACTIONS(7417),
    [anon_sym_TILDE] = ACTIONS(7417),
    [anon_sym_BANG] = ACTIONS(7419),
    [anon_sym_PLUS] = ACTIONS(7417),
    [anon_sym_DASH] = ACTIONS(7419),
    [anon_sym_LT_DASH] = ACTIONS(7417),
    [anon_sym_LT_LT_DASH] = ACTIONS(7417),
    [anon_sym_COLON_EQ] = ACTIONS(7417),
    [anon_sym_DASH_GT] = ACTIONS(7419),
    [anon_sym_DASH_GT_GT] = ACTIONS(7417),
    [anon_sym_PIPE] = ACTIONS(7419),
    [anon_sym_AMP] = ACTIONS(7419),
    [anon_sym_PIPE_PIPE] = ACTIONS(7417),
    [anon_sym_AMP_AMP] = ACTIONS(7417),
    [anon_sym_LT] = ACTIONS(7419),
    [anon_sym_LT_EQ] = ACTIONS(7417),
    [anon_sym_GT] = ACTIONS(7419),
    [anon_sym_GT_EQ] = ACTIONS(7417),
    [anon_sym_EQ_EQ] = ACTIONS(7417),
    [anon_sym_BANG_EQ] = ACTIONS(7417),
    [anon_sym_STAR] = ACTIONS(7419),
    [anon_sym_SLASH] = ACTIONS(7417),
    [anon_sym_STAR_STAR] = ACTIONS(7417),
    [anon_sym_CARET] = ACTIONS(7417),
    [aux_sym_binary_operator_token1] = ACTIONS(7417),
    [anon_sym_PIPE_GT] = ACTIONS(7417),
    [anon_sym_COLON] = ACTIONS(7419),
    [anon_sym_DOLLAR] = ACTIONS(7417),
    [anon_sym_AT] = ACTIONS(7417),
    [aux_sym__hex_literal_token1] = ACTIONS(7417),
    [sym__number_literal] = ACTIONS(7419),
    [anon_sym_SQUOTE] = ACTIONS(7417),
    [anon_sym_DQUOTE] = ACTIONS(7417),
    [sym_return] = ACTIONS(7419),
    [sym_next] = ACTIONS(7419),
    [sym_break] = ACTIONS(7419),
    [sym_true] = ACTIONS(7419),
    [sym_false] = ACTIONS(7419),
    [sym_null] = ACTIONS(7419),
    [sym_inf] = ACTIONS(7419),
    [sym_nan] = ACTIONS(7419),
    [anon_sym_NA] = ACTIONS(7419),
    [anon_sym_NA_integer_] = ACTIONS(7419),
    [anon_sym_NA_real_] = ACTIONS(7419),
    [anon_sym_NA_complex_] = ACTIONS(7419),
    [anon_sym_NA_character_] = ACTIONS(7419),
    [sym_dots] = ACTIONS(7419),
    [sym_dot_dot_i] = ACTIONS(7417),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7417),
    [sym__newline] = ACTIONS(7665),
    [sym__raw_string_literal] = ACTIONS(7417),
    [sym__external_open_parenthesis] = ACTIONS(7417),
    [sym__external_close_parenthesis] = ACTIONS(7417),
    [sym__external_open_brace] = ACTIONS(7417),
    [sym__external_open_bracket] = ACTIONS(7417),
    [sym__external_open_bracket2] = ACTIONS(7417),
    [sym__external_close_bracket2] = ACTIONS(7417),
  },
  [2638] = {
    [sym_identifier] = ACTIONS(7532),
    [anon_sym_BSLASH] = ACTIONS(7530),
    [anon_sym_function] = ACTIONS(7532),
    [anon_sym_EQ] = ACTIONS(7532),
    [anon_sym_if] = ACTIONS(7532),
    [anon_sym_for] = ACTIONS(7532),
    [anon_sym_while] = ACTIONS(7532),
    [anon_sym_repeat] = ACTIONS(7532),
    [anon_sym_QMARK] = ACTIONS(7530),
    [anon_sym_TILDE] = ACTIONS(7530),
    [anon_sym_BANG] = ACTIONS(7532),
    [anon_sym_PLUS] = ACTIONS(7530),
    [anon_sym_DASH] = ACTIONS(7532),
    [anon_sym_LT_DASH] = ACTIONS(7530),
    [anon_sym_LT_LT_DASH] = ACTIONS(7530),
    [anon_sym_COLON_EQ] = ACTIONS(7530),
    [anon_sym_DASH_GT] = ACTIONS(7532),
    [anon_sym_DASH_GT_GT] = ACTIONS(7530),
    [anon_sym_PIPE] = ACTIONS(7532),
    [anon_sym_AMP] = ACTIONS(7532),
    [anon_sym_PIPE_PIPE] = ACTIONS(7530),
    [anon_sym_AMP_AMP] = ACTIONS(7530),
    [anon_sym_LT] = ACTIONS(7532),
    [anon_sym_LT_EQ] = ACTIONS(7530),
    [anon_sym_GT] = ACTIONS(7532),
    [anon_sym_GT_EQ] = ACTIONS(7530),
    [anon_sym_EQ_EQ] = ACTIONS(7530),
    [anon_sym_BANG_EQ] = ACTIONS(7530),
    [anon_sym_STAR] = ACTIONS(7532),
    [anon_sym_SLASH] = ACTIONS(7530),
    [anon_sym_STAR_STAR] = ACTIONS(7530),
    [anon_sym_CARET] = ACTIONS(7530),
    [aux_sym_binary_operator_token1] = ACTIONS(7530),
    [anon_sym_PIPE_GT] = ACTIONS(7530),
    [anon_sym_COLON] = ACTIONS(7532),
    [anon_sym_DOLLAR] = ACTIONS(7530),
    [anon_sym_AT] = ACTIONS(7530),
    [aux_sym__hex_literal_token1] = ACTIONS(7530),
    [sym__number_literal] = ACTIONS(7532),
    [anon_sym_SQUOTE] = ACTIONS(7530),
    [anon_sym_DQUOTE] = ACTIONS(7530),
    [sym_return] = ACTIONS(7532),
    [sym_next] = ACTIONS(7532),
    [sym_break] = ACTIONS(7532),
    [sym_true] = ACTIONS(7532),
    [sym_false] = ACTIONS(7532),
    [sym_null] = ACTIONS(7532),
    [sym_inf] = ACTIONS(7532),
    [sym_nan] = ACTIONS(7532),
    [anon_sym_NA] = ACTIONS(7532),
    [anon_sym_NA_integer_] = ACTIONS(7532),
    [anon_sym_NA_real_] = ACTIONS(7532),
    [anon_sym_NA_complex_] = ACTIONS(7532),
    [anon_sym_NA_character_] = ACTIONS(7532),
    [sym_dots] = ACTIONS(7532),
    [sym_dot_dot_i] = ACTIONS(7530),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7530),
    [sym__newline] = ACTIONS(7530),
    [sym__semicolon] = ACTIONS(7530),
    [sym__raw_string_literal] = ACTIONS(7530),
    [sym__external_open_parenthesis] = ACTIONS(7530),
    [sym__external_open_brace] = ACTIONS(7530),
    [sym__external_close_brace] = ACTIONS(7530),
    [sym__external_open_bracket] = ACTIONS(7530),
    [sym__external_open_bracket2] = ACTIONS(7530),
    [sym__external_close_bracket2] = ACTIONS(7530),
  },
  [2639] = {
    [aux_sym_function_definition_repeat1] = STATE(2639),
    [sym_identifier] = ACTIONS(7419),
    [anon_sym_BSLASH] = ACTIONS(7417),
    [anon_sym_function] = ACTIONS(7419),
    [anon_sym_EQ] = ACTIONS(7419),
    [anon_sym_if] = ACTIONS(7419),
    [anon_sym_for] = ACTIONS(7419),
    [anon_sym_while] = ACTIONS(7419),
    [anon_sym_repeat] = ACTIONS(7419),
    [anon_sym_QMARK] = ACTIONS(7417),
    [anon_sym_TILDE] = ACTIONS(7417),
    [anon_sym_BANG] = ACTIONS(7419),
    [anon_sym_PLUS] = ACTIONS(7417),
    [anon_sym_DASH] = ACTIONS(7419),
    [anon_sym_LT_DASH] = ACTIONS(7417),
    [anon_sym_LT_LT_DASH] = ACTIONS(7417),
    [anon_sym_COLON_EQ] = ACTIONS(7417),
    [anon_sym_DASH_GT] = ACTIONS(7419),
    [anon_sym_DASH_GT_GT] = ACTIONS(7417),
    [anon_sym_PIPE] = ACTIONS(7419),
    [anon_sym_AMP] = ACTIONS(7419),
    [anon_sym_PIPE_PIPE] = ACTIONS(7417),
    [anon_sym_AMP_AMP] = ACTIONS(7417),
    [anon_sym_LT] = ACTIONS(7419),
    [anon_sym_LT_EQ] = ACTIONS(7417),
    [anon_sym_GT] = ACTIONS(7419),
    [anon_sym_GT_EQ] = ACTIONS(7417),
    [anon_sym_EQ_EQ] = ACTIONS(7417),
    [anon_sym_BANG_EQ] = ACTIONS(7417),
    [anon_sym_STAR] = ACTIONS(7419),
    [anon_sym_SLASH] = ACTIONS(7417),
    [anon_sym_STAR_STAR] = ACTIONS(7417),
    [anon_sym_CARET] = ACTIONS(7417),
    [aux_sym_binary_operator_token1] = ACTIONS(7417),
    [anon_sym_PIPE_GT] = ACTIONS(7417),
    [anon_sym_COLON] = ACTIONS(7419),
    [anon_sym_DOLLAR] = ACTIONS(7417),
    [anon_sym_AT] = ACTIONS(7417),
    [aux_sym__hex_literal_token1] = ACTIONS(7417),
    [sym__number_literal] = ACTIONS(7419),
    [anon_sym_SQUOTE] = ACTIONS(7417),
    [anon_sym_DQUOTE] = ACTIONS(7417),
    [sym_return] = ACTIONS(7419),
    [sym_next] = ACTIONS(7419),
    [sym_break] = ACTIONS(7419),
    [sym_true] = ACTIONS(7419),
    [sym_false] = ACTIONS(7419),
    [sym_null] = ACTIONS(7419),
    [sym_inf] = ACTIONS(7419),
    [sym_nan] = ACTIONS(7419),
    [anon_sym_NA] = ACTIONS(7419),
    [anon_sym_NA_integer_] = ACTIONS(7419),
    [anon_sym_NA_real_] = ACTIONS(7419),
    [anon_sym_NA_complex_] = ACTIONS(7419),
    [anon_sym_NA_character_] = ACTIONS(7419),
    [sym_dots] = ACTIONS(7419),
    [sym_dot_dot_i] = ACTIONS(7417),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7417),
    [sym__newline] = ACTIONS(7668),
    [sym__raw_string_literal] = ACTIONS(7417),
    [sym__external_else] = ACTIONS(7417),
    [sym__external_open_parenthesis] = ACTIONS(7417),
    [sym__external_open_brace] = ACTIONS(7417),
    [sym__external_open_bracket] = ACTIONS(7417),
    [sym__external_close_bracket] = ACTIONS(7417),
    [sym__external_open_bracket2] = ACTIONS(7417),
  },
  [2640] = {
    [ts_builtin_sym_end] = ACTIONS(5313),
    [sym_identifier] = ACTIONS(5311),
    [anon_sym_BSLASH] = ACTIONS(5313),
    [anon_sym_function] = ACTIONS(5311),
    [anon_sym_EQ] = ACTIONS(5311),
    [anon_sym_if] = ACTIONS(5311),
    [anon_sym_for] = ACTIONS(5311),
    [anon_sym_while] = ACTIONS(5311),
    [anon_sym_repeat] = ACTIONS(5311),
    [anon_sym_QMARK] = ACTIONS(5313),
    [anon_sym_TILDE] = ACTIONS(5313),
    [anon_sym_BANG] = ACTIONS(5311),
    [anon_sym_PLUS] = ACTIONS(5313),
    [anon_sym_DASH] = ACTIONS(5311),
    [anon_sym_LT_DASH] = ACTIONS(5313),
    [anon_sym_LT_LT_DASH] = ACTIONS(5313),
    [anon_sym_COLON_EQ] = ACTIONS(5313),
    [anon_sym_DASH_GT] = ACTIONS(5311),
    [anon_sym_DASH_GT_GT] = ACTIONS(5313),
    [anon_sym_PIPE] = ACTIONS(5311),
    [anon_sym_AMP] = ACTIONS(5311),
    [anon_sym_PIPE_PIPE] = ACTIONS(5313),
    [anon_sym_AMP_AMP] = ACTIONS(5313),
    [anon_sym_LT] = ACTIONS(5311),
    [anon_sym_LT_EQ] = ACTIONS(5313),
    [anon_sym_GT] = ACTIONS(5311),
    [anon_sym_GT_EQ] = ACTIONS(5313),
    [anon_sym_EQ_EQ] = ACTIONS(5313),
    [anon_sym_BANG_EQ] = ACTIONS(5313),
    [anon_sym_STAR] = ACTIONS(5311),
    [anon_sym_SLASH] = ACTIONS(5313),
    [anon_sym_STAR_STAR] = ACTIONS(5313),
    [anon_sym_CARET] = ACTIONS(5313),
    [aux_sym_binary_operator_token1] = ACTIONS(5313),
    [anon_sym_PIPE_GT] = ACTIONS(5313),
    [anon_sym_COLON] = ACTIONS(5311),
    [anon_sym_DOLLAR] = ACTIONS(5313),
    [anon_sym_AT] = ACTIONS(5313),
    [aux_sym__hex_literal_token1] = ACTIONS(5313),
    [sym__number_literal] = ACTIONS(5311),
    [anon_sym_SQUOTE] = ACTIONS(5313),
    [anon_sym_DQUOTE] = ACTIONS(5313),
    [sym_return] = ACTIONS(5311),
    [sym_next] = ACTIONS(5311),
    [sym_break] = ACTIONS(5311),
    [sym_true] = ACTIONS(5311),
    [sym_false] = ACTIONS(5311),
    [sym_null] = ACTIONS(5311),
    [sym_inf] = ACTIONS(5311),
    [sym_nan] = ACTIONS(5311),
    [anon_sym_NA] = ACTIONS(5311),
    [anon_sym_NA_integer_] = ACTIONS(5311),
    [anon_sym_NA_real_] = ACTIONS(5311),
    [anon_sym_NA_complex_] = ACTIONS(5311),
    [anon_sym_NA_character_] = ACTIONS(5311),
    [sym_dots] = ACTIONS(5311),
    [sym_dot_dot_i] = ACTIONS(5313),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5313),
    [sym__semicolon] = ACTIONS(5313),
    [sym__raw_string_literal] = ACTIONS(5313),
    [sym__external_else] = ACTIONS(5313),
    [sym__external_open_parenthesis] = ACTIONS(5313),
    [sym__external_close_parenthesis] = ACTIONS(5313),
    [sym__external_open_brace] = ACTIONS(5313),
    [sym__external_open_bracket] = ACTIONS(5313),
    [sym__external_open_bracket2] = ACTIONS(5313),
  },
  [2641] = {
    [ts_builtin_sym_end] = ACTIONS(7550),
    [sym_identifier] = ACTIONS(7552),
    [anon_sym_BSLASH] = ACTIONS(7550),
    [anon_sym_function] = ACTIONS(7552),
    [anon_sym_EQ] = ACTIONS(7552),
    [anon_sym_if] = ACTIONS(7552),
    [anon_sym_for] = ACTIONS(7552),
    [anon_sym_while] = ACTIONS(7552),
    [anon_sym_repeat] = ACTIONS(7552),
    [anon_sym_QMARK] = ACTIONS(7550),
    [anon_sym_TILDE] = ACTIONS(7550),
    [anon_sym_BANG] = ACTIONS(7552),
    [anon_sym_PLUS] = ACTIONS(7550),
    [anon_sym_DASH] = ACTIONS(7552),
    [anon_sym_LT_DASH] = ACTIONS(7550),
    [anon_sym_LT_LT_DASH] = ACTIONS(7550),
    [anon_sym_COLON_EQ] = ACTIONS(7550),
    [anon_sym_DASH_GT] = ACTIONS(7552),
    [anon_sym_DASH_GT_GT] = ACTIONS(7550),
    [anon_sym_PIPE] = ACTIONS(7552),
    [anon_sym_AMP] = ACTIONS(7552),
    [anon_sym_PIPE_PIPE] = ACTIONS(7550),
    [anon_sym_AMP_AMP] = ACTIONS(7550),
    [anon_sym_LT] = ACTIONS(7552),
    [anon_sym_LT_EQ] = ACTIONS(7550),
    [anon_sym_GT] = ACTIONS(7552),
    [anon_sym_GT_EQ] = ACTIONS(7550),
    [anon_sym_EQ_EQ] = ACTIONS(7550),
    [anon_sym_BANG_EQ] = ACTIONS(7550),
    [anon_sym_STAR] = ACTIONS(7552),
    [anon_sym_SLASH] = ACTIONS(7550),
    [anon_sym_STAR_STAR] = ACTIONS(7550),
    [anon_sym_CARET] = ACTIONS(7550),
    [aux_sym_binary_operator_token1] = ACTIONS(7550),
    [anon_sym_PIPE_GT] = ACTIONS(7550),
    [anon_sym_COLON] = ACTIONS(7552),
    [anon_sym_DOLLAR] = ACTIONS(7550),
    [anon_sym_AT] = ACTIONS(7550),
    [aux_sym__hex_literal_token1] = ACTIONS(7550),
    [sym__number_literal] = ACTIONS(7552),
    [anon_sym_SQUOTE] = ACTIONS(7550),
    [anon_sym_DQUOTE] = ACTIONS(7550),
    [sym_return] = ACTIONS(7552),
    [sym_next] = ACTIONS(7552),
    [sym_break] = ACTIONS(7552),
    [sym_true] = ACTIONS(7552),
    [sym_false] = ACTIONS(7552),
    [sym_null] = ACTIONS(7552),
    [sym_inf] = ACTIONS(7552),
    [sym_nan] = ACTIONS(7552),
    [anon_sym_NA] = ACTIONS(7552),
    [anon_sym_NA_integer_] = ACTIONS(7552),
    [anon_sym_NA_real_] = ACTIONS(7552),
    [anon_sym_NA_complex_] = ACTIONS(7552),
    [anon_sym_NA_character_] = ACTIONS(7552),
    [sym_dots] = ACTIONS(7552),
    [sym_dot_dot_i] = ACTIONS(7550),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7550),
    [sym__semicolon] = ACTIONS(7550),
    [sym__raw_string_literal] = ACTIONS(7550),
    [sym__external_else] = ACTIONS(7550),
    [sym__external_open_parenthesis] = ACTIONS(7550),
    [sym__external_open_brace] = ACTIONS(7550),
    [sym__external_close_brace] = ACTIONS(7550),
    [sym__external_open_bracket] = ACTIONS(7550),
    [sym__external_open_bracket2] = ACTIONS(7550),
  },
  [2642] = {
    [sym_identifier] = ACTIONS(7163),
    [anon_sym_BSLASH] = ACTIONS(7165),
    [anon_sym_function] = ACTIONS(7163),
    [anon_sym_EQ] = ACTIONS(7163),
    [anon_sym_if] = ACTIONS(7163),
    [anon_sym_for] = ACTIONS(7163),
    [anon_sym_while] = ACTIONS(7163),
    [anon_sym_repeat] = ACTIONS(7163),
    [anon_sym_QMARK] = ACTIONS(7165),
    [anon_sym_TILDE] = ACTIONS(7165),
    [anon_sym_BANG] = ACTIONS(7163),
    [anon_sym_PLUS] = ACTIONS(7165),
    [anon_sym_DASH] = ACTIONS(7163),
    [anon_sym_LT_DASH] = ACTIONS(7165),
    [anon_sym_LT_LT_DASH] = ACTIONS(7165),
    [anon_sym_COLON_EQ] = ACTIONS(7165),
    [anon_sym_DASH_GT] = ACTIONS(7163),
    [anon_sym_DASH_GT_GT] = ACTIONS(7165),
    [anon_sym_PIPE] = ACTIONS(7163),
    [anon_sym_AMP] = ACTIONS(7163),
    [anon_sym_PIPE_PIPE] = ACTIONS(7165),
    [anon_sym_AMP_AMP] = ACTIONS(7165),
    [anon_sym_LT] = ACTIONS(7163),
    [anon_sym_LT_EQ] = ACTIONS(7165),
    [anon_sym_GT] = ACTIONS(7163),
    [anon_sym_GT_EQ] = ACTIONS(7165),
    [anon_sym_EQ_EQ] = ACTIONS(7165),
    [anon_sym_BANG_EQ] = ACTIONS(7165),
    [anon_sym_STAR] = ACTIONS(7163),
    [anon_sym_SLASH] = ACTIONS(7165),
    [anon_sym_STAR_STAR] = ACTIONS(7165),
    [anon_sym_CARET] = ACTIONS(7165),
    [aux_sym_binary_operator_token1] = ACTIONS(7165),
    [anon_sym_PIPE_GT] = ACTIONS(7165),
    [anon_sym_COLON] = ACTIONS(7163),
    [anon_sym_DOLLAR] = ACTIONS(7165),
    [anon_sym_AT] = ACTIONS(7165),
    [anon_sym_COLON_COLON] = ACTIONS(7163),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7165),
    [aux_sym__hex_literal_token1] = ACTIONS(7165),
    [sym__number_literal] = ACTIONS(7163),
    [anon_sym_SQUOTE] = ACTIONS(7165),
    [anon_sym_DQUOTE] = ACTIONS(7165),
    [sym_return] = ACTIONS(7163),
    [sym_next] = ACTIONS(7163),
    [sym_break] = ACTIONS(7163),
    [sym_true] = ACTIONS(7163),
    [sym_false] = ACTIONS(7163),
    [sym_null] = ACTIONS(7163),
    [sym_inf] = ACTIONS(7163),
    [sym_nan] = ACTIONS(7163),
    [anon_sym_NA] = ACTIONS(7163),
    [anon_sym_NA_integer_] = ACTIONS(7163),
    [anon_sym_NA_real_] = ACTIONS(7163),
    [anon_sym_NA_complex_] = ACTIONS(7163),
    [anon_sym_NA_character_] = ACTIONS(7163),
    [sym_dots] = ACTIONS(7163),
    [sym_dot_dot_i] = ACTIONS(7165),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7165),
    [sym__newline] = ACTIONS(7165),
    [sym__raw_string_literal] = ACTIONS(7165),
    [sym__external_open_parenthesis] = ACTIONS(7165),
    [sym__external_open_brace] = ACTIONS(7165),
    [sym__external_open_bracket] = ACTIONS(7165),
    [sym__external_open_bracket2] = ACTIONS(7165),
    [sym__external_close_bracket2] = ACTIONS(7165),
  },
  [2643] = {
    [ts_builtin_sym_end] = ACTIONS(7480),
    [sym_identifier] = ACTIONS(7482),
    [anon_sym_BSLASH] = ACTIONS(7480),
    [anon_sym_function] = ACTIONS(7482),
    [anon_sym_EQ] = ACTIONS(7482),
    [anon_sym_if] = ACTIONS(7482),
    [anon_sym_for] = ACTIONS(7482),
    [anon_sym_while] = ACTIONS(7482),
    [anon_sym_repeat] = ACTIONS(7482),
    [anon_sym_QMARK] = ACTIONS(7480),
    [anon_sym_TILDE] = ACTIONS(7480),
    [anon_sym_BANG] = ACTIONS(7482),
    [anon_sym_PLUS] = ACTIONS(7480),
    [anon_sym_DASH] = ACTIONS(7482),
    [anon_sym_LT_DASH] = ACTIONS(7480),
    [anon_sym_LT_LT_DASH] = ACTIONS(7480),
    [anon_sym_COLON_EQ] = ACTIONS(7480),
    [anon_sym_DASH_GT] = ACTIONS(7482),
    [anon_sym_DASH_GT_GT] = ACTIONS(7480),
    [anon_sym_PIPE] = ACTIONS(7482),
    [anon_sym_AMP] = ACTIONS(7482),
    [anon_sym_PIPE_PIPE] = ACTIONS(7480),
    [anon_sym_AMP_AMP] = ACTIONS(7480),
    [anon_sym_LT] = ACTIONS(7482),
    [anon_sym_LT_EQ] = ACTIONS(7480),
    [anon_sym_GT] = ACTIONS(7482),
    [anon_sym_GT_EQ] = ACTIONS(7480),
    [anon_sym_EQ_EQ] = ACTIONS(7480),
    [anon_sym_BANG_EQ] = ACTIONS(7480),
    [anon_sym_STAR] = ACTIONS(7482),
    [anon_sym_SLASH] = ACTIONS(7480),
    [anon_sym_STAR_STAR] = ACTIONS(7480),
    [anon_sym_CARET] = ACTIONS(7480),
    [aux_sym_binary_operator_token1] = ACTIONS(7480),
    [anon_sym_PIPE_GT] = ACTIONS(7480),
    [anon_sym_COLON] = ACTIONS(7482),
    [anon_sym_DOLLAR] = ACTIONS(7480),
    [anon_sym_AT] = ACTIONS(7480),
    [aux_sym__hex_literal_token1] = ACTIONS(7480),
    [sym__number_literal] = ACTIONS(7482),
    [anon_sym_SQUOTE] = ACTIONS(7480),
    [anon_sym_DQUOTE] = ACTIONS(7480),
    [sym_return] = ACTIONS(7482),
    [sym_next] = ACTIONS(7482),
    [sym_break] = ACTIONS(7482),
    [sym_true] = ACTIONS(7482),
    [sym_false] = ACTIONS(7482),
    [sym_null] = ACTIONS(7482),
    [sym_inf] = ACTIONS(7482),
    [sym_nan] = ACTIONS(7482),
    [anon_sym_NA] = ACTIONS(7482),
    [anon_sym_NA_integer_] = ACTIONS(7482),
    [anon_sym_NA_real_] = ACTIONS(7482),
    [anon_sym_NA_complex_] = ACTIONS(7482),
    [anon_sym_NA_character_] = ACTIONS(7482),
    [sym_dots] = ACTIONS(7482),
    [sym_dot_dot_i] = ACTIONS(7480),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7480),
    [sym__semicolon] = ACTIONS(7480),
    [sym__raw_string_literal] = ACTIONS(7480),
    [sym__external_else] = ACTIONS(7480),
    [sym__external_open_parenthesis] = ACTIONS(7480),
    [sym__external_close_parenthesis] = ACTIONS(7480),
    [sym__external_open_brace] = ACTIONS(7480),
    [sym__external_open_bracket] = ACTIONS(7480),
    [sym__external_open_bracket2] = ACTIONS(7480),
  },
  [2644] = {
    [sym_identifier] = ACTIONS(7151),
    [anon_sym_BSLASH] = ACTIONS(7153),
    [anon_sym_function] = ACTIONS(7151),
    [anon_sym_EQ] = ACTIONS(7151),
    [anon_sym_if] = ACTIONS(7151),
    [anon_sym_for] = ACTIONS(7151),
    [anon_sym_while] = ACTIONS(7151),
    [anon_sym_repeat] = ACTIONS(7151),
    [anon_sym_QMARK] = ACTIONS(7153),
    [anon_sym_TILDE] = ACTIONS(7153),
    [anon_sym_BANG] = ACTIONS(7151),
    [anon_sym_PLUS] = ACTIONS(7153),
    [anon_sym_DASH] = ACTIONS(7151),
    [anon_sym_LT_DASH] = ACTIONS(7153),
    [anon_sym_LT_LT_DASH] = ACTIONS(7153),
    [anon_sym_COLON_EQ] = ACTIONS(7153),
    [anon_sym_DASH_GT] = ACTIONS(7151),
    [anon_sym_DASH_GT_GT] = ACTIONS(7153),
    [anon_sym_PIPE] = ACTIONS(7151),
    [anon_sym_AMP] = ACTIONS(7151),
    [anon_sym_PIPE_PIPE] = ACTIONS(7153),
    [anon_sym_AMP_AMP] = ACTIONS(7153),
    [anon_sym_LT] = ACTIONS(7151),
    [anon_sym_LT_EQ] = ACTIONS(7153),
    [anon_sym_GT] = ACTIONS(7151),
    [anon_sym_GT_EQ] = ACTIONS(7153),
    [anon_sym_EQ_EQ] = ACTIONS(7153),
    [anon_sym_BANG_EQ] = ACTIONS(7153),
    [anon_sym_STAR] = ACTIONS(7151),
    [anon_sym_SLASH] = ACTIONS(7153),
    [anon_sym_STAR_STAR] = ACTIONS(7153),
    [anon_sym_CARET] = ACTIONS(7153),
    [aux_sym_binary_operator_token1] = ACTIONS(7153),
    [anon_sym_PIPE_GT] = ACTIONS(7153),
    [anon_sym_COLON] = ACTIONS(7151),
    [anon_sym_DOLLAR] = ACTIONS(7153),
    [anon_sym_AT] = ACTIONS(7153),
    [anon_sym_COLON_COLON] = ACTIONS(7151),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7153),
    [aux_sym__hex_literal_token1] = ACTIONS(7153),
    [sym__number_literal] = ACTIONS(7151),
    [anon_sym_SQUOTE] = ACTIONS(7153),
    [anon_sym_DQUOTE] = ACTIONS(7153),
    [sym_return] = ACTIONS(7151),
    [sym_next] = ACTIONS(7151),
    [sym_break] = ACTIONS(7151),
    [sym_true] = ACTIONS(7151),
    [sym_false] = ACTIONS(7151),
    [sym_null] = ACTIONS(7151),
    [sym_inf] = ACTIONS(7151),
    [sym_nan] = ACTIONS(7151),
    [anon_sym_NA] = ACTIONS(7151),
    [anon_sym_NA_integer_] = ACTIONS(7151),
    [anon_sym_NA_real_] = ACTIONS(7151),
    [anon_sym_NA_complex_] = ACTIONS(7151),
    [anon_sym_NA_character_] = ACTIONS(7151),
    [sym_dots] = ACTIONS(7151),
    [sym_dot_dot_i] = ACTIONS(7153),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7153),
    [sym__newline] = ACTIONS(7153),
    [sym__raw_string_literal] = ACTIONS(7153),
    [sym__external_open_parenthesis] = ACTIONS(7153),
    [sym__external_open_brace] = ACTIONS(7153),
    [sym__external_open_bracket] = ACTIONS(7153),
    [sym__external_open_bracket2] = ACTIONS(7153),
    [sym__external_close_bracket2] = ACTIONS(7153),
  },
  [2645] = {
    [sym_identifier] = ACTIONS(7516),
    [anon_sym_BSLASH] = ACTIONS(7514),
    [anon_sym_function] = ACTIONS(7516),
    [anon_sym_EQ] = ACTIONS(7516),
    [anon_sym_if] = ACTIONS(7516),
    [anon_sym_for] = ACTIONS(7516),
    [anon_sym_while] = ACTIONS(7516),
    [anon_sym_repeat] = ACTIONS(7516),
    [anon_sym_QMARK] = ACTIONS(7514),
    [anon_sym_TILDE] = ACTIONS(7514),
    [anon_sym_BANG] = ACTIONS(7516),
    [anon_sym_PLUS] = ACTIONS(7514),
    [anon_sym_DASH] = ACTIONS(7516),
    [anon_sym_LT_DASH] = ACTIONS(7514),
    [anon_sym_LT_LT_DASH] = ACTIONS(7514),
    [anon_sym_COLON_EQ] = ACTIONS(7514),
    [anon_sym_DASH_GT] = ACTIONS(7516),
    [anon_sym_DASH_GT_GT] = ACTIONS(7514),
    [anon_sym_PIPE] = ACTIONS(7516),
    [anon_sym_AMP] = ACTIONS(7516),
    [anon_sym_PIPE_PIPE] = ACTIONS(7514),
    [anon_sym_AMP_AMP] = ACTIONS(7514),
    [anon_sym_LT] = ACTIONS(7516),
    [anon_sym_LT_EQ] = ACTIONS(7514),
    [anon_sym_GT] = ACTIONS(7516),
    [anon_sym_GT_EQ] = ACTIONS(7514),
    [anon_sym_EQ_EQ] = ACTIONS(7514),
    [anon_sym_BANG_EQ] = ACTIONS(7514),
    [anon_sym_STAR] = ACTIONS(7516),
    [anon_sym_SLASH] = ACTIONS(7514),
    [anon_sym_STAR_STAR] = ACTIONS(7514),
    [anon_sym_CARET] = ACTIONS(7514),
    [aux_sym_binary_operator_token1] = ACTIONS(7514),
    [anon_sym_PIPE_GT] = ACTIONS(7514),
    [anon_sym_COLON] = ACTIONS(7516),
    [anon_sym_DOLLAR] = ACTIONS(7514),
    [anon_sym_AT] = ACTIONS(7514),
    [aux_sym__hex_literal_token1] = ACTIONS(7514),
    [sym__number_literal] = ACTIONS(7516),
    [anon_sym_SQUOTE] = ACTIONS(7514),
    [anon_sym_DQUOTE] = ACTIONS(7514),
    [sym_return] = ACTIONS(7516),
    [sym_next] = ACTIONS(7516),
    [sym_break] = ACTIONS(7516),
    [sym_true] = ACTIONS(7516),
    [sym_false] = ACTIONS(7516),
    [sym_null] = ACTIONS(7516),
    [sym_inf] = ACTIONS(7516),
    [sym_nan] = ACTIONS(7516),
    [anon_sym_NA] = ACTIONS(7516),
    [anon_sym_NA_integer_] = ACTIONS(7516),
    [anon_sym_NA_real_] = ACTIONS(7516),
    [anon_sym_NA_complex_] = ACTIONS(7516),
    [anon_sym_NA_character_] = ACTIONS(7516),
    [sym_dots] = ACTIONS(7516),
    [sym_dot_dot_i] = ACTIONS(7514),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7514),
    [sym__newline] = ACTIONS(7514),
    [sym__raw_string_literal] = ACTIONS(7514),
    [sym__external_else] = ACTIONS(7514),
    [sym__external_open_parenthesis] = ACTIONS(7514),
    [sym__external_close_parenthesis] = ACTIONS(7514),
    [sym__external_open_brace] = ACTIONS(7514),
    [sym__external_open_bracket] = ACTIONS(7514),
    [sym__external_open_bracket2] = ACTIONS(7514),
    [sym__external_close_bracket2] = ACTIONS(7514),
  },
  [2646] = {
    [sym_identifier] = ACTIONS(7520),
    [anon_sym_BSLASH] = ACTIONS(7518),
    [anon_sym_function] = ACTIONS(7520),
    [anon_sym_EQ] = ACTIONS(7520),
    [anon_sym_if] = ACTIONS(7520),
    [anon_sym_for] = ACTIONS(7520),
    [anon_sym_while] = ACTIONS(7520),
    [anon_sym_repeat] = ACTIONS(7520),
    [anon_sym_QMARK] = ACTIONS(7518),
    [anon_sym_TILDE] = ACTIONS(7518),
    [anon_sym_BANG] = ACTIONS(7520),
    [anon_sym_PLUS] = ACTIONS(7518),
    [anon_sym_DASH] = ACTIONS(7520),
    [anon_sym_LT_DASH] = ACTIONS(7518),
    [anon_sym_LT_LT_DASH] = ACTIONS(7518),
    [anon_sym_COLON_EQ] = ACTIONS(7518),
    [anon_sym_DASH_GT] = ACTIONS(7520),
    [anon_sym_DASH_GT_GT] = ACTIONS(7518),
    [anon_sym_PIPE] = ACTIONS(7520),
    [anon_sym_AMP] = ACTIONS(7520),
    [anon_sym_PIPE_PIPE] = ACTIONS(7518),
    [anon_sym_AMP_AMP] = ACTIONS(7518),
    [anon_sym_LT] = ACTIONS(7520),
    [anon_sym_LT_EQ] = ACTIONS(7518),
    [anon_sym_GT] = ACTIONS(7520),
    [anon_sym_GT_EQ] = ACTIONS(7518),
    [anon_sym_EQ_EQ] = ACTIONS(7518),
    [anon_sym_BANG_EQ] = ACTIONS(7518),
    [anon_sym_STAR] = ACTIONS(7520),
    [anon_sym_SLASH] = ACTIONS(7518),
    [anon_sym_STAR_STAR] = ACTIONS(7518),
    [anon_sym_CARET] = ACTIONS(7518),
    [aux_sym_binary_operator_token1] = ACTIONS(7518),
    [anon_sym_PIPE_GT] = ACTIONS(7518),
    [anon_sym_COLON] = ACTIONS(7520),
    [anon_sym_DOLLAR] = ACTIONS(7518),
    [anon_sym_AT] = ACTIONS(7518),
    [aux_sym__hex_literal_token1] = ACTIONS(7518),
    [sym__number_literal] = ACTIONS(7520),
    [anon_sym_SQUOTE] = ACTIONS(7518),
    [anon_sym_DQUOTE] = ACTIONS(7518),
    [sym_return] = ACTIONS(7520),
    [sym_next] = ACTIONS(7520),
    [sym_break] = ACTIONS(7520),
    [sym_true] = ACTIONS(7520),
    [sym_false] = ACTIONS(7520),
    [sym_null] = ACTIONS(7520),
    [sym_inf] = ACTIONS(7520),
    [sym_nan] = ACTIONS(7520),
    [anon_sym_NA] = ACTIONS(7520),
    [anon_sym_NA_integer_] = ACTIONS(7520),
    [anon_sym_NA_real_] = ACTIONS(7520),
    [anon_sym_NA_complex_] = ACTIONS(7520),
    [anon_sym_NA_character_] = ACTIONS(7520),
    [sym_dots] = ACTIONS(7520),
    [sym_dot_dot_i] = ACTIONS(7518),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7518),
    [sym__newline] = ACTIONS(7518),
    [sym__raw_string_literal] = ACTIONS(7518),
    [sym__external_else] = ACTIONS(7518),
    [sym__external_open_parenthesis] = ACTIONS(7518),
    [sym__external_close_parenthesis] = ACTIONS(7518),
    [sym__external_open_brace] = ACTIONS(7518),
    [sym__external_open_bracket] = ACTIONS(7518),
    [sym__external_open_bracket2] = ACTIONS(7518),
    [sym__external_close_bracket2] = ACTIONS(7518),
  },
  [2647] = {
    [sym_identifier] = ACTIONS(7528),
    [anon_sym_BSLASH] = ACTIONS(7526),
    [anon_sym_function] = ACTIONS(7528),
    [anon_sym_EQ] = ACTIONS(7528),
    [anon_sym_if] = ACTIONS(7528),
    [anon_sym_for] = ACTIONS(7528),
    [anon_sym_while] = ACTIONS(7528),
    [anon_sym_repeat] = ACTIONS(7528),
    [anon_sym_QMARK] = ACTIONS(7526),
    [anon_sym_TILDE] = ACTIONS(7526),
    [anon_sym_BANG] = ACTIONS(7528),
    [anon_sym_PLUS] = ACTIONS(7526),
    [anon_sym_DASH] = ACTIONS(7528),
    [anon_sym_LT_DASH] = ACTIONS(7526),
    [anon_sym_LT_LT_DASH] = ACTIONS(7526),
    [anon_sym_COLON_EQ] = ACTIONS(7526),
    [anon_sym_DASH_GT] = ACTIONS(7528),
    [anon_sym_DASH_GT_GT] = ACTIONS(7526),
    [anon_sym_PIPE] = ACTIONS(7528),
    [anon_sym_AMP] = ACTIONS(7528),
    [anon_sym_PIPE_PIPE] = ACTIONS(7526),
    [anon_sym_AMP_AMP] = ACTIONS(7526),
    [anon_sym_LT] = ACTIONS(7528),
    [anon_sym_LT_EQ] = ACTIONS(7526),
    [anon_sym_GT] = ACTIONS(7528),
    [anon_sym_GT_EQ] = ACTIONS(7526),
    [anon_sym_EQ_EQ] = ACTIONS(7526),
    [anon_sym_BANG_EQ] = ACTIONS(7526),
    [anon_sym_STAR] = ACTIONS(7528),
    [anon_sym_SLASH] = ACTIONS(7526),
    [anon_sym_STAR_STAR] = ACTIONS(7526),
    [anon_sym_CARET] = ACTIONS(7526),
    [aux_sym_binary_operator_token1] = ACTIONS(7526),
    [anon_sym_PIPE_GT] = ACTIONS(7526),
    [anon_sym_COLON] = ACTIONS(7528),
    [anon_sym_DOLLAR] = ACTIONS(7526),
    [anon_sym_AT] = ACTIONS(7526),
    [aux_sym__hex_literal_token1] = ACTIONS(7526),
    [sym__number_literal] = ACTIONS(7528),
    [anon_sym_SQUOTE] = ACTIONS(7526),
    [anon_sym_DQUOTE] = ACTIONS(7526),
    [sym_return] = ACTIONS(7528),
    [sym_next] = ACTIONS(7528),
    [sym_break] = ACTIONS(7528),
    [sym_true] = ACTIONS(7528),
    [sym_false] = ACTIONS(7528),
    [sym_null] = ACTIONS(7528),
    [sym_inf] = ACTIONS(7528),
    [sym_nan] = ACTIONS(7528),
    [anon_sym_NA] = ACTIONS(7528),
    [anon_sym_NA_integer_] = ACTIONS(7528),
    [anon_sym_NA_real_] = ACTIONS(7528),
    [anon_sym_NA_complex_] = ACTIONS(7528),
    [anon_sym_NA_character_] = ACTIONS(7528),
    [sym_dots] = ACTIONS(7528),
    [sym_dot_dot_i] = ACTIONS(7526),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7526),
    [sym__newline] = ACTIONS(7526),
    [sym__semicolon] = ACTIONS(7526),
    [sym__raw_string_literal] = ACTIONS(7526),
    [sym__external_open_parenthesis] = ACTIONS(7526),
    [sym__external_open_brace] = ACTIONS(7526),
    [sym__external_close_brace] = ACTIONS(7526),
    [sym__external_open_bracket] = ACTIONS(7526),
    [sym__external_open_bracket2] = ACTIONS(7526),
    [sym__external_close_bracket2] = ACTIONS(7526),
  },
  [2648] = {
    [sym_identifier] = ACTIONS(7524),
    [anon_sym_BSLASH] = ACTIONS(7522),
    [anon_sym_function] = ACTIONS(7524),
    [anon_sym_EQ] = ACTIONS(7524),
    [anon_sym_if] = ACTIONS(7524),
    [anon_sym_for] = ACTIONS(7524),
    [anon_sym_while] = ACTIONS(7524),
    [anon_sym_repeat] = ACTIONS(7524),
    [anon_sym_QMARK] = ACTIONS(7522),
    [anon_sym_TILDE] = ACTIONS(7522),
    [anon_sym_BANG] = ACTIONS(7524),
    [anon_sym_PLUS] = ACTIONS(7522),
    [anon_sym_DASH] = ACTIONS(7524),
    [anon_sym_LT_DASH] = ACTIONS(7522),
    [anon_sym_LT_LT_DASH] = ACTIONS(7522),
    [anon_sym_COLON_EQ] = ACTIONS(7522),
    [anon_sym_DASH_GT] = ACTIONS(7524),
    [anon_sym_DASH_GT_GT] = ACTIONS(7522),
    [anon_sym_PIPE] = ACTIONS(7524),
    [anon_sym_AMP] = ACTIONS(7524),
    [anon_sym_PIPE_PIPE] = ACTIONS(7522),
    [anon_sym_AMP_AMP] = ACTIONS(7522),
    [anon_sym_LT] = ACTIONS(7524),
    [anon_sym_LT_EQ] = ACTIONS(7522),
    [anon_sym_GT] = ACTIONS(7524),
    [anon_sym_GT_EQ] = ACTIONS(7522),
    [anon_sym_EQ_EQ] = ACTIONS(7522),
    [anon_sym_BANG_EQ] = ACTIONS(7522),
    [anon_sym_STAR] = ACTIONS(7524),
    [anon_sym_SLASH] = ACTIONS(7522),
    [anon_sym_STAR_STAR] = ACTIONS(7522),
    [anon_sym_CARET] = ACTIONS(7522),
    [aux_sym_binary_operator_token1] = ACTIONS(7522),
    [anon_sym_PIPE_GT] = ACTIONS(7522),
    [anon_sym_COLON] = ACTIONS(7524),
    [anon_sym_DOLLAR] = ACTIONS(7522),
    [anon_sym_AT] = ACTIONS(7522),
    [aux_sym__hex_literal_token1] = ACTIONS(7522),
    [sym__number_literal] = ACTIONS(7524),
    [anon_sym_SQUOTE] = ACTIONS(7522),
    [anon_sym_DQUOTE] = ACTIONS(7522),
    [sym_return] = ACTIONS(7524),
    [sym_next] = ACTIONS(7524),
    [sym_break] = ACTIONS(7524),
    [sym_true] = ACTIONS(7524),
    [sym_false] = ACTIONS(7524),
    [sym_null] = ACTIONS(7524),
    [sym_inf] = ACTIONS(7524),
    [sym_nan] = ACTIONS(7524),
    [anon_sym_NA] = ACTIONS(7524),
    [anon_sym_NA_integer_] = ACTIONS(7524),
    [anon_sym_NA_real_] = ACTIONS(7524),
    [anon_sym_NA_complex_] = ACTIONS(7524),
    [anon_sym_NA_character_] = ACTIONS(7524),
    [sym_dots] = ACTIONS(7524),
    [sym_dot_dot_i] = ACTIONS(7522),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7522),
    [sym__newline] = ACTIONS(7522),
    [sym__raw_string_literal] = ACTIONS(7522),
    [sym__external_else] = ACTIONS(7522),
    [sym__external_open_parenthesis] = ACTIONS(7522),
    [sym__external_close_parenthesis] = ACTIONS(7522),
    [sym__external_open_brace] = ACTIONS(7522),
    [sym__external_open_bracket] = ACTIONS(7522),
    [sym__external_open_bracket2] = ACTIONS(7522),
    [sym__external_close_bracket2] = ACTIONS(7522),
  },
  [2649] = {
    [sym_identifier] = ACTIONS(7115),
    [anon_sym_BSLASH] = ACTIONS(7117),
    [anon_sym_function] = ACTIONS(7115),
    [anon_sym_EQ] = ACTIONS(7115),
    [anon_sym_if] = ACTIONS(7115),
    [anon_sym_for] = ACTIONS(7115),
    [anon_sym_while] = ACTIONS(7115),
    [anon_sym_repeat] = ACTIONS(7115),
    [anon_sym_QMARK] = ACTIONS(7117),
    [anon_sym_TILDE] = ACTIONS(7117),
    [anon_sym_BANG] = ACTIONS(7115),
    [anon_sym_PLUS] = ACTIONS(7117),
    [anon_sym_DASH] = ACTIONS(7115),
    [anon_sym_LT_DASH] = ACTIONS(7117),
    [anon_sym_LT_LT_DASH] = ACTIONS(7117),
    [anon_sym_COLON_EQ] = ACTIONS(7117),
    [anon_sym_DASH_GT] = ACTIONS(7115),
    [anon_sym_DASH_GT_GT] = ACTIONS(7117),
    [anon_sym_PIPE] = ACTIONS(7115),
    [anon_sym_AMP] = ACTIONS(7115),
    [anon_sym_PIPE_PIPE] = ACTIONS(7117),
    [anon_sym_AMP_AMP] = ACTIONS(7117),
    [anon_sym_LT] = ACTIONS(7115),
    [anon_sym_LT_EQ] = ACTIONS(7117),
    [anon_sym_GT] = ACTIONS(7115),
    [anon_sym_GT_EQ] = ACTIONS(7117),
    [anon_sym_EQ_EQ] = ACTIONS(7117),
    [anon_sym_BANG_EQ] = ACTIONS(7117),
    [anon_sym_STAR] = ACTIONS(7115),
    [anon_sym_SLASH] = ACTIONS(7117),
    [anon_sym_STAR_STAR] = ACTIONS(7117),
    [anon_sym_CARET] = ACTIONS(7117),
    [aux_sym_binary_operator_token1] = ACTIONS(7117),
    [anon_sym_PIPE_GT] = ACTIONS(7117),
    [anon_sym_COLON] = ACTIONS(7115),
    [anon_sym_DOLLAR] = ACTIONS(7117),
    [anon_sym_AT] = ACTIONS(7117),
    [anon_sym_COLON_COLON] = ACTIONS(7115),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7117),
    [aux_sym__hex_literal_token1] = ACTIONS(7117),
    [sym__number_literal] = ACTIONS(7115),
    [anon_sym_SQUOTE] = ACTIONS(7117),
    [anon_sym_DQUOTE] = ACTIONS(7117),
    [sym_return] = ACTIONS(7115),
    [sym_next] = ACTIONS(7115),
    [sym_break] = ACTIONS(7115),
    [sym_true] = ACTIONS(7115),
    [sym_false] = ACTIONS(7115),
    [sym_null] = ACTIONS(7115),
    [sym_inf] = ACTIONS(7115),
    [sym_nan] = ACTIONS(7115),
    [anon_sym_NA] = ACTIONS(7115),
    [anon_sym_NA_integer_] = ACTIONS(7115),
    [anon_sym_NA_real_] = ACTIONS(7115),
    [anon_sym_NA_complex_] = ACTIONS(7115),
    [anon_sym_NA_character_] = ACTIONS(7115),
    [sym_dots] = ACTIONS(7115),
    [sym_dot_dot_i] = ACTIONS(7117),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7117),
    [sym__newline] = ACTIONS(7117),
    [sym__raw_string_literal] = ACTIONS(7117),
    [sym__external_open_parenthesis] = ACTIONS(7117),
    [sym__external_open_brace] = ACTIONS(7117),
    [sym__external_open_bracket] = ACTIONS(7117),
    [sym__external_open_bracket2] = ACTIONS(7117),
    [sym__external_close_bracket2] = ACTIONS(7117),
  },
  [2650] = {
    [sym_identifier] = ACTIONS(7524),
    [anon_sym_BSLASH] = ACTIONS(7522),
    [anon_sym_function] = ACTIONS(7524),
    [anon_sym_EQ] = ACTIONS(7524),
    [anon_sym_if] = ACTIONS(7524),
    [anon_sym_for] = ACTIONS(7524),
    [anon_sym_while] = ACTIONS(7524),
    [anon_sym_repeat] = ACTIONS(7524),
    [anon_sym_QMARK] = ACTIONS(7522),
    [anon_sym_TILDE] = ACTIONS(7522),
    [anon_sym_BANG] = ACTIONS(7524),
    [anon_sym_PLUS] = ACTIONS(7522),
    [anon_sym_DASH] = ACTIONS(7524),
    [anon_sym_LT_DASH] = ACTIONS(7522),
    [anon_sym_LT_LT_DASH] = ACTIONS(7522),
    [anon_sym_COLON_EQ] = ACTIONS(7522),
    [anon_sym_DASH_GT] = ACTIONS(7524),
    [anon_sym_DASH_GT_GT] = ACTIONS(7522),
    [anon_sym_PIPE] = ACTIONS(7524),
    [anon_sym_AMP] = ACTIONS(7524),
    [anon_sym_PIPE_PIPE] = ACTIONS(7522),
    [anon_sym_AMP_AMP] = ACTIONS(7522),
    [anon_sym_LT] = ACTIONS(7524),
    [anon_sym_LT_EQ] = ACTIONS(7522),
    [anon_sym_GT] = ACTIONS(7524),
    [anon_sym_GT_EQ] = ACTIONS(7522),
    [anon_sym_EQ_EQ] = ACTIONS(7522),
    [anon_sym_BANG_EQ] = ACTIONS(7522),
    [anon_sym_STAR] = ACTIONS(7524),
    [anon_sym_SLASH] = ACTIONS(7522),
    [anon_sym_STAR_STAR] = ACTIONS(7522),
    [anon_sym_CARET] = ACTIONS(7522),
    [aux_sym_binary_operator_token1] = ACTIONS(7522),
    [anon_sym_PIPE_GT] = ACTIONS(7522),
    [anon_sym_COLON] = ACTIONS(7524),
    [anon_sym_DOLLAR] = ACTIONS(7522),
    [anon_sym_AT] = ACTIONS(7522),
    [aux_sym__hex_literal_token1] = ACTIONS(7522),
    [sym__number_literal] = ACTIONS(7524),
    [anon_sym_SQUOTE] = ACTIONS(7522),
    [anon_sym_DQUOTE] = ACTIONS(7522),
    [sym_return] = ACTIONS(7524),
    [sym_next] = ACTIONS(7524),
    [sym_break] = ACTIONS(7524),
    [sym_true] = ACTIONS(7524),
    [sym_false] = ACTIONS(7524),
    [sym_null] = ACTIONS(7524),
    [sym_inf] = ACTIONS(7524),
    [sym_nan] = ACTIONS(7524),
    [anon_sym_NA] = ACTIONS(7524),
    [anon_sym_NA_integer_] = ACTIONS(7524),
    [anon_sym_NA_real_] = ACTIONS(7524),
    [anon_sym_NA_complex_] = ACTIONS(7524),
    [anon_sym_NA_character_] = ACTIONS(7524),
    [sym_dots] = ACTIONS(7524),
    [sym_dot_dot_i] = ACTIONS(7522),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7522),
    [sym__newline] = ACTIONS(7522),
    [sym__semicolon] = ACTIONS(7522),
    [sym__raw_string_literal] = ACTIONS(7522),
    [sym__external_open_parenthesis] = ACTIONS(7522),
    [sym__external_open_brace] = ACTIONS(7522),
    [sym__external_close_brace] = ACTIONS(7522),
    [sym__external_open_bracket] = ACTIONS(7522),
    [sym__external_open_bracket2] = ACTIONS(7522),
    [sym__external_close_bracket2] = ACTIONS(7522),
  },
  [2651] = {
    [sym_identifier] = ACTIONS(7532),
    [anon_sym_BSLASH] = ACTIONS(7530),
    [anon_sym_function] = ACTIONS(7532),
    [anon_sym_EQ] = ACTIONS(7532),
    [anon_sym_if] = ACTIONS(7532),
    [anon_sym_for] = ACTIONS(7532),
    [anon_sym_while] = ACTIONS(7532),
    [anon_sym_repeat] = ACTIONS(7532),
    [anon_sym_QMARK] = ACTIONS(7530),
    [anon_sym_TILDE] = ACTIONS(7530),
    [anon_sym_BANG] = ACTIONS(7532),
    [anon_sym_PLUS] = ACTIONS(7530),
    [anon_sym_DASH] = ACTIONS(7532),
    [anon_sym_LT_DASH] = ACTIONS(7530),
    [anon_sym_LT_LT_DASH] = ACTIONS(7530),
    [anon_sym_COLON_EQ] = ACTIONS(7530),
    [anon_sym_DASH_GT] = ACTIONS(7532),
    [anon_sym_DASH_GT_GT] = ACTIONS(7530),
    [anon_sym_PIPE] = ACTIONS(7532),
    [anon_sym_AMP] = ACTIONS(7532),
    [anon_sym_PIPE_PIPE] = ACTIONS(7530),
    [anon_sym_AMP_AMP] = ACTIONS(7530),
    [anon_sym_LT] = ACTIONS(7532),
    [anon_sym_LT_EQ] = ACTIONS(7530),
    [anon_sym_GT] = ACTIONS(7532),
    [anon_sym_GT_EQ] = ACTIONS(7530),
    [anon_sym_EQ_EQ] = ACTIONS(7530),
    [anon_sym_BANG_EQ] = ACTIONS(7530),
    [anon_sym_STAR] = ACTIONS(7532),
    [anon_sym_SLASH] = ACTIONS(7530),
    [anon_sym_STAR_STAR] = ACTIONS(7530),
    [anon_sym_CARET] = ACTIONS(7530),
    [aux_sym_binary_operator_token1] = ACTIONS(7530),
    [anon_sym_PIPE_GT] = ACTIONS(7530),
    [anon_sym_COLON] = ACTIONS(7532),
    [anon_sym_DOLLAR] = ACTIONS(7530),
    [anon_sym_AT] = ACTIONS(7530),
    [aux_sym__hex_literal_token1] = ACTIONS(7530),
    [sym__number_literal] = ACTIONS(7532),
    [anon_sym_SQUOTE] = ACTIONS(7530),
    [anon_sym_DQUOTE] = ACTIONS(7530),
    [sym_return] = ACTIONS(7532),
    [sym_next] = ACTIONS(7532),
    [sym_break] = ACTIONS(7532),
    [sym_true] = ACTIONS(7532),
    [sym_false] = ACTIONS(7532),
    [sym_null] = ACTIONS(7532),
    [sym_inf] = ACTIONS(7532),
    [sym_nan] = ACTIONS(7532),
    [anon_sym_NA] = ACTIONS(7532),
    [anon_sym_NA_integer_] = ACTIONS(7532),
    [anon_sym_NA_real_] = ACTIONS(7532),
    [anon_sym_NA_complex_] = ACTIONS(7532),
    [anon_sym_NA_character_] = ACTIONS(7532),
    [sym_dots] = ACTIONS(7532),
    [sym_dot_dot_i] = ACTIONS(7530),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7530),
    [sym__newline] = ACTIONS(7530),
    [sym__raw_string_literal] = ACTIONS(7530),
    [sym__external_else] = ACTIONS(7530),
    [sym__external_open_parenthesis] = ACTIONS(7530),
    [sym__external_close_parenthesis] = ACTIONS(7530),
    [sym__external_open_brace] = ACTIONS(7530),
    [sym__external_open_bracket] = ACTIONS(7530),
    [sym__external_open_bracket2] = ACTIONS(7530),
    [sym__external_close_bracket2] = ACTIONS(7530),
  },
  [2652] = {
    [sym_identifier] = ACTIONS(7540),
    [anon_sym_BSLASH] = ACTIONS(7538),
    [anon_sym_function] = ACTIONS(7540),
    [anon_sym_EQ] = ACTIONS(7540),
    [anon_sym_if] = ACTIONS(7540),
    [anon_sym_for] = ACTIONS(7540),
    [anon_sym_while] = ACTIONS(7540),
    [anon_sym_repeat] = ACTIONS(7540),
    [anon_sym_QMARK] = ACTIONS(7538),
    [anon_sym_TILDE] = ACTIONS(7538),
    [anon_sym_BANG] = ACTIONS(7540),
    [anon_sym_PLUS] = ACTIONS(7538),
    [anon_sym_DASH] = ACTIONS(7540),
    [anon_sym_LT_DASH] = ACTIONS(7538),
    [anon_sym_LT_LT_DASH] = ACTIONS(7538),
    [anon_sym_COLON_EQ] = ACTIONS(7538),
    [anon_sym_DASH_GT] = ACTIONS(7540),
    [anon_sym_DASH_GT_GT] = ACTIONS(7538),
    [anon_sym_PIPE] = ACTIONS(7540),
    [anon_sym_AMP] = ACTIONS(7540),
    [anon_sym_PIPE_PIPE] = ACTIONS(7538),
    [anon_sym_AMP_AMP] = ACTIONS(7538),
    [anon_sym_LT] = ACTIONS(7540),
    [anon_sym_LT_EQ] = ACTIONS(7538),
    [anon_sym_GT] = ACTIONS(7540),
    [anon_sym_GT_EQ] = ACTIONS(7538),
    [anon_sym_EQ_EQ] = ACTIONS(7538),
    [anon_sym_BANG_EQ] = ACTIONS(7538),
    [anon_sym_STAR] = ACTIONS(7540),
    [anon_sym_SLASH] = ACTIONS(7538),
    [anon_sym_STAR_STAR] = ACTIONS(7538),
    [anon_sym_CARET] = ACTIONS(7538),
    [aux_sym_binary_operator_token1] = ACTIONS(7538),
    [anon_sym_PIPE_GT] = ACTIONS(7538),
    [anon_sym_COLON] = ACTIONS(7540),
    [anon_sym_DOLLAR] = ACTIONS(7538),
    [anon_sym_AT] = ACTIONS(7538),
    [aux_sym__hex_literal_token1] = ACTIONS(7538),
    [sym__number_literal] = ACTIONS(7540),
    [anon_sym_SQUOTE] = ACTIONS(7538),
    [anon_sym_DQUOTE] = ACTIONS(7538),
    [sym_return] = ACTIONS(7540),
    [sym_next] = ACTIONS(7540),
    [sym_break] = ACTIONS(7540),
    [sym_true] = ACTIONS(7540),
    [sym_false] = ACTIONS(7540),
    [sym_null] = ACTIONS(7540),
    [sym_inf] = ACTIONS(7540),
    [sym_nan] = ACTIONS(7540),
    [anon_sym_NA] = ACTIONS(7540),
    [anon_sym_NA_integer_] = ACTIONS(7540),
    [anon_sym_NA_real_] = ACTIONS(7540),
    [anon_sym_NA_complex_] = ACTIONS(7540),
    [anon_sym_NA_character_] = ACTIONS(7540),
    [sym_dots] = ACTIONS(7540),
    [sym_dot_dot_i] = ACTIONS(7538),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7538),
    [sym__newline] = ACTIONS(7538),
    [sym__raw_string_literal] = ACTIONS(7538),
    [sym__external_else] = ACTIONS(7538),
    [sym__external_open_parenthesis] = ACTIONS(7538),
    [sym__external_close_parenthesis] = ACTIONS(7538),
    [sym__external_open_brace] = ACTIONS(7538),
    [sym__external_open_bracket] = ACTIONS(7538),
    [sym__external_open_bracket2] = ACTIONS(7538),
    [sym__external_close_bracket2] = ACTIONS(7538),
  },
  [2653] = {
    [sym_identifier] = ACTIONS(7544),
    [anon_sym_BSLASH] = ACTIONS(7542),
    [anon_sym_function] = ACTIONS(7544),
    [anon_sym_EQ] = ACTIONS(7544),
    [anon_sym_if] = ACTIONS(7544),
    [anon_sym_for] = ACTIONS(7544),
    [anon_sym_while] = ACTIONS(7544),
    [anon_sym_repeat] = ACTIONS(7544),
    [anon_sym_QMARK] = ACTIONS(7542),
    [anon_sym_TILDE] = ACTIONS(7542),
    [anon_sym_BANG] = ACTIONS(7544),
    [anon_sym_PLUS] = ACTIONS(7542),
    [anon_sym_DASH] = ACTIONS(7544),
    [anon_sym_LT_DASH] = ACTIONS(7542),
    [anon_sym_LT_LT_DASH] = ACTIONS(7542),
    [anon_sym_COLON_EQ] = ACTIONS(7542),
    [anon_sym_DASH_GT] = ACTIONS(7544),
    [anon_sym_DASH_GT_GT] = ACTIONS(7542),
    [anon_sym_PIPE] = ACTIONS(7544),
    [anon_sym_AMP] = ACTIONS(7544),
    [anon_sym_PIPE_PIPE] = ACTIONS(7542),
    [anon_sym_AMP_AMP] = ACTIONS(7542),
    [anon_sym_LT] = ACTIONS(7544),
    [anon_sym_LT_EQ] = ACTIONS(7542),
    [anon_sym_GT] = ACTIONS(7544),
    [anon_sym_GT_EQ] = ACTIONS(7542),
    [anon_sym_EQ_EQ] = ACTIONS(7542),
    [anon_sym_BANG_EQ] = ACTIONS(7542),
    [anon_sym_STAR] = ACTIONS(7544),
    [anon_sym_SLASH] = ACTIONS(7542),
    [anon_sym_STAR_STAR] = ACTIONS(7542),
    [anon_sym_CARET] = ACTIONS(7542),
    [aux_sym_binary_operator_token1] = ACTIONS(7542),
    [anon_sym_PIPE_GT] = ACTIONS(7542),
    [anon_sym_COLON] = ACTIONS(7544),
    [anon_sym_DOLLAR] = ACTIONS(7542),
    [anon_sym_AT] = ACTIONS(7542),
    [aux_sym__hex_literal_token1] = ACTIONS(7542),
    [sym__number_literal] = ACTIONS(7544),
    [anon_sym_SQUOTE] = ACTIONS(7542),
    [anon_sym_DQUOTE] = ACTIONS(7542),
    [sym_return] = ACTIONS(7544),
    [sym_next] = ACTIONS(7544),
    [sym_break] = ACTIONS(7544),
    [sym_true] = ACTIONS(7544),
    [sym_false] = ACTIONS(7544),
    [sym_null] = ACTIONS(7544),
    [sym_inf] = ACTIONS(7544),
    [sym_nan] = ACTIONS(7544),
    [anon_sym_NA] = ACTIONS(7544),
    [anon_sym_NA_integer_] = ACTIONS(7544),
    [anon_sym_NA_real_] = ACTIONS(7544),
    [anon_sym_NA_complex_] = ACTIONS(7544),
    [anon_sym_NA_character_] = ACTIONS(7544),
    [sym_dots] = ACTIONS(7544),
    [sym_dot_dot_i] = ACTIONS(7542),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7542),
    [sym__newline] = ACTIONS(7542),
    [sym__raw_string_literal] = ACTIONS(7542),
    [sym__external_else] = ACTIONS(7542),
    [sym__external_open_parenthesis] = ACTIONS(7542),
    [sym__external_close_parenthesis] = ACTIONS(7542),
    [sym__external_open_brace] = ACTIONS(7542),
    [sym__external_open_bracket] = ACTIONS(7542),
    [sym__external_open_bracket2] = ACTIONS(7542),
    [sym__external_close_bracket2] = ACTIONS(7542),
  },
  [2654] = {
    [sym_identifier] = ACTIONS(7115),
    [anon_sym_BSLASH] = ACTIONS(7117),
    [anon_sym_function] = ACTIONS(7115),
    [anon_sym_EQ] = ACTIONS(7115),
    [anon_sym_if] = ACTIONS(7115),
    [anon_sym_for] = ACTIONS(7115),
    [anon_sym_while] = ACTIONS(7115),
    [anon_sym_repeat] = ACTIONS(7115),
    [anon_sym_QMARK] = ACTIONS(7117),
    [anon_sym_TILDE] = ACTIONS(7117),
    [anon_sym_BANG] = ACTIONS(7115),
    [anon_sym_PLUS] = ACTIONS(7117),
    [anon_sym_DASH] = ACTIONS(7115),
    [anon_sym_LT_DASH] = ACTIONS(7117),
    [anon_sym_LT_LT_DASH] = ACTIONS(7117),
    [anon_sym_COLON_EQ] = ACTIONS(7117),
    [anon_sym_DASH_GT] = ACTIONS(7115),
    [anon_sym_DASH_GT_GT] = ACTIONS(7117),
    [anon_sym_PIPE] = ACTIONS(7115),
    [anon_sym_AMP] = ACTIONS(7115),
    [anon_sym_PIPE_PIPE] = ACTIONS(7117),
    [anon_sym_AMP_AMP] = ACTIONS(7117),
    [anon_sym_LT] = ACTIONS(7115),
    [anon_sym_LT_EQ] = ACTIONS(7117),
    [anon_sym_GT] = ACTIONS(7115),
    [anon_sym_GT_EQ] = ACTIONS(7117),
    [anon_sym_EQ_EQ] = ACTIONS(7117),
    [anon_sym_BANG_EQ] = ACTIONS(7117),
    [anon_sym_STAR] = ACTIONS(7115),
    [anon_sym_SLASH] = ACTIONS(7117),
    [anon_sym_STAR_STAR] = ACTIONS(7117),
    [anon_sym_CARET] = ACTIONS(7117),
    [aux_sym_binary_operator_token1] = ACTIONS(7117),
    [anon_sym_PIPE_GT] = ACTIONS(7117),
    [anon_sym_COLON] = ACTIONS(7115),
    [anon_sym_DOLLAR] = ACTIONS(7117),
    [anon_sym_AT] = ACTIONS(7117),
    [anon_sym_COLON_COLON] = ACTIONS(7115),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7117),
    [aux_sym__hex_literal_token1] = ACTIONS(7117),
    [sym__number_literal] = ACTIONS(7115),
    [anon_sym_SQUOTE] = ACTIONS(7117),
    [anon_sym_DQUOTE] = ACTIONS(7117),
    [sym_return] = ACTIONS(7115),
    [sym_next] = ACTIONS(7115),
    [sym_break] = ACTIONS(7115),
    [sym_true] = ACTIONS(7115),
    [sym_false] = ACTIONS(7115),
    [sym_null] = ACTIONS(7115),
    [sym_inf] = ACTIONS(7115),
    [sym_nan] = ACTIONS(7115),
    [anon_sym_NA] = ACTIONS(7115),
    [anon_sym_NA_integer_] = ACTIONS(7115),
    [anon_sym_NA_real_] = ACTIONS(7115),
    [anon_sym_NA_complex_] = ACTIONS(7115),
    [anon_sym_NA_character_] = ACTIONS(7115),
    [sym_dots] = ACTIONS(7115),
    [sym_dot_dot_i] = ACTIONS(7117),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7117),
    [sym__newline] = ACTIONS(7117),
    [sym__raw_string_literal] = ACTIONS(7117),
    [sym__external_open_parenthesis] = ACTIONS(7117),
    [sym__external_open_brace] = ACTIONS(7117),
    [sym__external_open_bracket] = ACTIONS(7117),
    [sym__external_open_bracket2] = ACTIONS(7117),
    [sym__external_close_bracket2] = ACTIONS(7117),
  },
  [2655] = {
    [sym_identifier] = ACTIONS(7516),
    [anon_sym_BSLASH] = ACTIONS(7514),
    [anon_sym_function] = ACTIONS(7516),
    [anon_sym_EQ] = ACTIONS(7516),
    [anon_sym_if] = ACTIONS(7516),
    [anon_sym_for] = ACTIONS(7516),
    [anon_sym_while] = ACTIONS(7516),
    [anon_sym_repeat] = ACTIONS(7516),
    [anon_sym_QMARK] = ACTIONS(7514),
    [anon_sym_TILDE] = ACTIONS(7514),
    [anon_sym_BANG] = ACTIONS(7516),
    [anon_sym_PLUS] = ACTIONS(7514),
    [anon_sym_DASH] = ACTIONS(7516),
    [anon_sym_LT_DASH] = ACTIONS(7514),
    [anon_sym_LT_LT_DASH] = ACTIONS(7514),
    [anon_sym_COLON_EQ] = ACTIONS(7514),
    [anon_sym_DASH_GT] = ACTIONS(7516),
    [anon_sym_DASH_GT_GT] = ACTIONS(7514),
    [anon_sym_PIPE] = ACTIONS(7516),
    [anon_sym_AMP] = ACTIONS(7516),
    [anon_sym_PIPE_PIPE] = ACTIONS(7514),
    [anon_sym_AMP_AMP] = ACTIONS(7514),
    [anon_sym_LT] = ACTIONS(7516),
    [anon_sym_LT_EQ] = ACTIONS(7514),
    [anon_sym_GT] = ACTIONS(7516),
    [anon_sym_GT_EQ] = ACTIONS(7514),
    [anon_sym_EQ_EQ] = ACTIONS(7514),
    [anon_sym_BANG_EQ] = ACTIONS(7514),
    [anon_sym_STAR] = ACTIONS(7516),
    [anon_sym_SLASH] = ACTIONS(7514),
    [anon_sym_STAR_STAR] = ACTIONS(7514),
    [anon_sym_CARET] = ACTIONS(7514),
    [aux_sym_binary_operator_token1] = ACTIONS(7514),
    [anon_sym_PIPE_GT] = ACTIONS(7514),
    [anon_sym_COLON] = ACTIONS(7516),
    [anon_sym_DOLLAR] = ACTIONS(7514),
    [anon_sym_AT] = ACTIONS(7514),
    [aux_sym__hex_literal_token1] = ACTIONS(7514),
    [sym__number_literal] = ACTIONS(7516),
    [anon_sym_SQUOTE] = ACTIONS(7514),
    [anon_sym_DQUOTE] = ACTIONS(7514),
    [sym_return] = ACTIONS(7516),
    [sym_next] = ACTIONS(7516),
    [sym_break] = ACTIONS(7516),
    [sym_true] = ACTIONS(7516),
    [sym_false] = ACTIONS(7516),
    [sym_null] = ACTIONS(7516),
    [sym_inf] = ACTIONS(7516),
    [sym_nan] = ACTIONS(7516),
    [anon_sym_NA] = ACTIONS(7516),
    [anon_sym_NA_integer_] = ACTIONS(7516),
    [anon_sym_NA_real_] = ACTIONS(7516),
    [anon_sym_NA_complex_] = ACTIONS(7516),
    [anon_sym_NA_character_] = ACTIONS(7516),
    [sym_dots] = ACTIONS(7516),
    [sym_dot_dot_i] = ACTIONS(7514),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7514),
    [sym__newline] = ACTIONS(7514),
    [sym__semicolon] = ACTIONS(7514),
    [sym__raw_string_literal] = ACTIONS(7514),
    [sym__external_open_parenthesis] = ACTIONS(7514),
    [sym__external_open_brace] = ACTIONS(7514),
    [sym__external_close_brace] = ACTIONS(7514),
    [sym__external_open_bracket] = ACTIONS(7514),
    [sym__external_close_bracket] = ACTIONS(7514),
    [sym__external_open_bracket2] = ACTIONS(7514),
  },
  [2656] = {
    [sym_identifier] = ACTIONS(7121),
    [anon_sym_BSLASH] = ACTIONS(7123),
    [anon_sym_function] = ACTIONS(7121),
    [anon_sym_EQ] = ACTIONS(7121),
    [anon_sym_if] = ACTIONS(7121),
    [anon_sym_for] = ACTIONS(7121),
    [anon_sym_while] = ACTIONS(7121),
    [anon_sym_repeat] = ACTIONS(7121),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_TILDE] = ACTIONS(7123),
    [anon_sym_BANG] = ACTIONS(7121),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_DASH] = ACTIONS(7121),
    [anon_sym_LT_DASH] = ACTIONS(7123),
    [anon_sym_LT_LT_DASH] = ACTIONS(7123),
    [anon_sym_COLON_EQ] = ACTIONS(7123),
    [anon_sym_DASH_GT] = ACTIONS(7121),
    [anon_sym_DASH_GT_GT] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_LT_EQ] = ACTIONS(7123),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
    [aux_sym_binary_operator_token1] = ACTIONS(7123),
    [anon_sym_PIPE_GT] = ACTIONS(7123),
    [anon_sym_COLON] = ACTIONS(7121),
    [anon_sym_DOLLAR] = ACTIONS(7123),
    [anon_sym_AT] = ACTIONS(7123),
    [anon_sym_L] = ACTIONS(7671),
    [anon_sym_i] = ACTIONS(7673),
    [aux_sym__hex_literal_token1] = ACTIONS(7123),
    [sym__number_literal] = ACTIONS(7121),
    [anon_sym_SQUOTE] = ACTIONS(7123),
    [anon_sym_DQUOTE] = ACTIONS(7123),
    [sym_return] = ACTIONS(7121),
    [sym_next] = ACTIONS(7121),
    [sym_break] = ACTIONS(7121),
    [sym_true] = ACTIONS(7121),
    [sym_false] = ACTIONS(7121),
    [sym_null] = ACTIONS(7121),
    [sym_inf] = ACTIONS(7121),
    [sym_nan] = ACTIONS(7121),
    [anon_sym_NA] = ACTIONS(7121),
    [anon_sym_NA_integer_] = ACTIONS(7121),
    [anon_sym_NA_real_] = ACTIONS(7121),
    [anon_sym_NA_complex_] = ACTIONS(7121),
    [anon_sym_NA_character_] = ACTIONS(7121),
    [sym_dots] = ACTIONS(7121),
    [sym_dot_dot_i] = ACTIONS(7123),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7123),
    [sym__newline] = ACTIONS(7123),
    [sym__raw_string_literal] = ACTIONS(7123),
    [sym__external_open_parenthesis] = ACTIONS(7123),
    [sym__external_open_brace] = ACTIONS(7123),
    [sym__external_open_bracket] = ACTIONS(7123),
    [sym__external_open_bracket2] = ACTIONS(7123),
    [sym__external_close_bracket2] = ACTIONS(7123),
  },
  [2657] = {
    [sym_identifier] = ACTIONS(5311),
    [anon_sym_BSLASH] = ACTIONS(5313),
    [anon_sym_function] = ACTIONS(5311),
    [anon_sym_EQ] = ACTIONS(5311),
    [anon_sym_if] = ACTIONS(5311),
    [anon_sym_for] = ACTIONS(5311),
    [anon_sym_while] = ACTIONS(5311),
    [anon_sym_repeat] = ACTIONS(5311),
    [anon_sym_QMARK] = ACTIONS(5313),
    [anon_sym_TILDE] = ACTIONS(5313),
    [anon_sym_BANG] = ACTIONS(5311),
    [anon_sym_PLUS] = ACTIONS(5313),
    [anon_sym_DASH] = ACTIONS(5311),
    [anon_sym_LT_DASH] = ACTIONS(5313),
    [anon_sym_LT_LT_DASH] = ACTIONS(5313),
    [anon_sym_COLON_EQ] = ACTIONS(5313),
    [anon_sym_DASH_GT] = ACTIONS(5311),
    [anon_sym_DASH_GT_GT] = ACTIONS(5313),
    [anon_sym_PIPE] = ACTIONS(5311),
    [anon_sym_AMP] = ACTIONS(5311),
    [anon_sym_PIPE_PIPE] = ACTIONS(5313),
    [anon_sym_AMP_AMP] = ACTIONS(5313),
    [anon_sym_LT] = ACTIONS(5311),
    [anon_sym_LT_EQ] = ACTIONS(5313),
    [anon_sym_GT] = ACTIONS(5311),
    [anon_sym_GT_EQ] = ACTIONS(5313),
    [anon_sym_EQ_EQ] = ACTIONS(5313),
    [anon_sym_BANG_EQ] = ACTIONS(5313),
    [anon_sym_STAR] = ACTIONS(5311),
    [anon_sym_SLASH] = ACTIONS(5313),
    [anon_sym_STAR_STAR] = ACTIONS(5313),
    [anon_sym_CARET] = ACTIONS(5313),
    [aux_sym_binary_operator_token1] = ACTIONS(5313),
    [anon_sym_PIPE_GT] = ACTIONS(5313),
    [anon_sym_COLON] = ACTIONS(5311),
    [anon_sym_DOLLAR] = ACTIONS(5313),
    [anon_sym_AT] = ACTIONS(5313),
    [aux_sym__hex_literal_token1] = ACTIONS(5313),
    [sym__number_literal] = ACTIONS(5311),
    [anon_sym_SQUOTE] = ACTIONS(5313),
    [anon_sym_DQUOTE] = ACTIONS(5313),
    [sym_return] = ACTIONS(5311),
    [sym_next] = ACTIONS(5311),
    [sym_break] = ACTIONS(5311),
    [sym_true] = ACTIONS(5311),
    [sym_false] = ACTIONS(5311),
    [sym_null] = ACTIONS(5311),
    [sym_inf] = ACTIONS(5311),
    [sym_nan] = ACTIONS(5311),
    [anon_sym_NA] = ACTIONS(5311),
    [anon_sym_NA_integer_] = ACTIONS(5311),
    [anon_sym_NA_real_] = ACTIONS(5311),
    [anon_sym_NA_complex_] = ACTIONS(5311),
    [anon_sym_NA_character_] = ACTIONS(5311),
    [sym_dots] = ACTIONS(5311),
    [sym_dot_dot_i] = ACTIONS(5313),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5313),
    [sym__newline] = ACTIONS(5313),
    [sym__raw_string_literal] = ACTIONS(5313),
    [sym__external_else] = ACTIONS(5313),
    [sym__external_open_parenthesis] = ACTIONS(5313),
    [sym__external_close_parenthesis] = ACTIONS(5313),
    [sym__external_open_brace] = ACTIONS(5313),
    [sym__external_open_bracket] = ACTIONS(5313),
    [sym__external_open_bracket2] = ACTIONS(5313),
    [sym__external_close_bracket2] = ACTIONS(5313),
  },
  [2658] = {
    [sym_identifier] = ACTIONS(7195),
    [anon_sym_BSLASH] = ACTIONS(7193),
    [anon_sym_function] = ACTIONS(7195),
    [anon_sym_EQ] = ACTIONS(7195),
    [anon_sym_if] = ACTIONS(7195),
    [anon_sym_for] = ACTIONS(7195),
    [anon_sym_while] = ACTIONS(7195),
    [anon_sym_repeat] = ACTIONS(7195),
    [anon_sym_QMARK] = ACTIONS(7193),
    [anon_sym_TILDE] = ACTIONS(7193),
    [anon_sym_BANG] = ACTIONS(7195),
    [anon_sym_PLUS] = ACTIONS(7193),
    [anon_sym_DASH] = ACTIONS(7195),
    [anon_sym_LT_DASH] = ACTIONS(7193),
    [anon_sym_LT_LT_DASH] = ACTIONS(7193),
    [anon_sym_COLON_EQ] = ACTIONS(7193),
    [anon_sym_DASH_GT] = ACTIONS(7195),
    [anon_sym_DASH_GT_GT] = ACTIONS(7193),
    [anon_sym_PIPE] = ACTIONS(7195),
    [anon_sym_AMP] = ACTIONS(7195),
    [anon_sym_PIPE_PIPE] = ACTIONS(7193),
    [anon_sym_AMP_AMP] = ACTIONS(7193),
    [anon_sym_LT] = ACTIONS(7195),
    [anon_sym_LT_EQ] = ACTIONS(7193),
    [anon_sym_GT] = ACTIONS(7195),
    [anon_sym_GT_EQ] = ACTIONS(7193),
    [anon_sym_EQ_EQ] = ACTIONS(7193),
    [anon_sym_BANG_EQ] = ACTIONS(7193),
    [anon_sym_STAR] = ACTIONS(7195),
    [anon_sym_SLASH] = ACTIONS(7193),
    [anon_sym_STAR_STAR] = ACTIONS(7193),
    [anon_sym_CARET] = ACTIONS(7193),
    [aux_sym_binary_operator_token1] = ACTIONS(7193),
    [anon_sym_PIPE_GT] = ACTIONS(7193),
    [anon_sym_COLON] = ACTIONS(7195),
    [anon_sym_DOLLAR] = ACTIONS(7193),
    [anon_sym_AT] = ACTIONS(7193),
    [anon_sym_COLON_COLON] = ACTIONS(7195),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7193),
    [aux_sym__hex_literal_token1] = ACTIONS(7193),
    [sym__number_literal] = ACTIONS(7195),
    [anon_sym_SQUOTE] = ACTIONS(7193),
    [anon_sym_DQUOTE] = ACTIONS(7193),
    [sym_return] = ACTIONS(7195),
    [sym_next] = ACTIONS(7195),
    [sym_break] = ACTIONS(7195),
    [sym_true] = ACTIONS(7195),
    [sym_false] = ACTIONS(7195),
    [sym_null] = ACTIONS(7195),
    [sym_inf] = ACTIONS(7195),
    [sym_nan] = ACTIONS(7195),
    [anon_sym_NA] = ACTIONS(7195),
    [anon_sym_NA_integer_] = ACTIONS(7195),
    [anon_sym_NA_real_] = ACTIONS(7195),
    [anon_sym_NA_complex_] = ACTIONS(7195),
    [anon_sym_NA_character_] = ACTIONS(7195),
    [sym_dots] = ACTIONS(7195),
    [sym_dot_dot_i] = ACTIONS(7193),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7193),
    [sym__newline] = ACTIONS(7193),
    [sym__raw_string_literal] = ACTIONS(7193),
    [sym__external_open_parenthesis] = ACTIONS(7193),
    [sym__external_open_brace] = ACTIONS(7193),
    [sym__external_open_bracket] = ACTIONS(7193),
    [sym__external_close_bracket] = ACTIONS(7193),
    [sym__external_open_bracket2] = ACTIONS(7193),
  },
  [2659] = {
    [sym_identifier] = ACTIONS(7520),
    [anon_sym_BSLASH] = ACTIONS(7518),
    [anon_sym_function] = ACTIONS(7520),
    [anon_sym_EQ] = ACTIONS(7520),
    [anon_sym_if] = ACTIONS(7520),
    [anon_sym_for] = ACTIONS(7520),
    [anon_sym_while] = ACTIONS(7520),
    [anon_sym_repeat] = ACTIONS(7520),
    [anon_sym_QMARK] = ACTIONS(7518),
    [anon_sym_TILDE] = ACTIONS(7518),
    [anon_sym_BANG] = ACTIONS(7520),
    [anon_sym_PLUS] = ACTIONS(7518),
    [anon_sym_DASH] = ACTIONS(7520),
    [anon_sym_LT_DASH] = ACTIONS(7518),
    [anon_sym_LT_LT_DASH] = ACTIONS(7518),
    [anon_sym_COLON_EQ] = ACTIONS(7518),
    [anon_sym_DASH_GT] = ACTIONS(7520),
    [anon_sym_DASH_GT_GT] = ACTIONS(7518),
    [anon_sym_PIPE] = ACTIONS(7520),
    [anon_sym_AMP] = ACTIONS(7520),
    [anon_sym_PIPE_PIPE] = ACTIONS(7518),
    [anon_sym_AMP_AMP] = ACTIONS(7518),
    [anon_sym_LT] = ACTIONS(7520),
    [anon_sym_LT_EQ] = ACTIONS(7518),
    [anon_sym_GT] = ACTIONS(7520),
    [anon_sym_GT_EQ] = ACTIONS(7518),
    [anon_sym_EQ_EQ] = ACTIONS(7518),
    [anon_sym_BANG_EQ] = ACTIONS(7518),
    [anon_sym_STAR] = ACTIONS(7520),
    [anon_sym_SLASH] = ACTIONS(7518),
    [anon_sym_STAR_STAR] = ACTIONS(7518),
    [anon_sym_CARET] = ACTIONS(7518),
    [aux_sym_binary_operator_token1] = ACTIONS(7518),
    [anon_sym_PIPE_GT] = ACTIONS(7518),
    [anon_sym_COLON] = ACTIONS(7520),
    [anon_sym_DOLLAR] = ACTIONS(7518),
    [anon_sym_AT] = ACTIONS(7518),
    [aux_sym__hex_literal_token1] = ACTIONS(7518),
    [sym__number_literal] = ACTIONS(7520),
    [anon_sym_SQUOTE] = ACTIONS(7518),
    [anon_sym_DQUOTE] = ACTIONS(7518),
    [sym_return] = ACTIONS(7520),
    [sym_next] = ACTIONS(7520),
    [sym_break] = ACTIONS(7520),
    [sym_true] = ACTIONS(7520),
    [sym_false] = ACTIONS(7520),
    [sym_null] = ACTIONS(7520),
    [sym_inf] = ACTIONS(7520),
    [sym_nan] = ACTIONS(7520),
    [anon_sym_NA] = ACTIONS(7520),
    [anon_sym_NA_integer_] = ACTIONS(7520),
    [anon_sym_NA_real_] = ACTIONS(7520),
    [anon_sym_NA_complex_] = ACTIONS(7520),
    [anon_sym_NA_character_] = ACTIONS(7520),
    [sym_dots] = ACTIONS(7520),
    [sym_dot_dot_i] = ACTIONS(7518),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7518),
    [sym__newline] = ACTIONS(7518),
    [sym__semicolon] = ACTIONS(7518),
    [sym__raw_string_literal] = ACTIONS(7518),
    [sym__external_open_parenthesis] = ACTIONS(7518),
    [sym__external_open_brace] = ACTIONS(7518),
    [sym__external_close_brace] = ACTIONS(7518),
    [sym__external_open_bracket] = ACTIONS(7518),
    [sym__external_open_bracket2] = ACTIONS(7518),
    [sym__external_close_bracket2] = ACTIONS(7518),
  },
  [2660] = {
    [sym_identifier] = ACTIONS(7520),
    [anon_sym_BSLASH] = ACTIONS(7518),
    [anon_sym_function] = ACTIONS(7520),
    [anon_sym_EQ] = ACTIONS(7520),
    [anon_sym_if] = ACTIONS(7520),
    [anon_sym_for] = ACTIONS(7520),
    [anon_sym_while] = ACTIONS(7520),
    [anon_sym_repeat] = ACTIONS(7520),
    [anon_sym_QMARK] = ACTIONS(7518),
    [anon_sym_TILDE] = ACTIONS(7518),
    [anon_sym_BANG] = ACTIONS(7520),
    [anon_sym_PLUS] = ACTIONS(7518),
    [anon_sym_DASH] = ACTIONS(7520),
    [anon_sym_LT_DASH] = ACTIONS(7518),
    [anon_sym_LT_LT_DASH] = ACTIONS(7518),
    [anon_sym_COLON_EQ] = ACTIONS(7518),
    [anon_sym_DASH_GT] = ACTIONS(7520),
    [anon_sym_DASH_GT_GT] = ACTIONS(7518),
    [anon_sym_PIPE] = ACTIONS(7520),
    [anon_sym_AMP] = ACTIONS(7520),
    [anon_sym_PIPE_PIPE] = ACTIONS(7518),
    [anon_sym_AMP_AMP] = ACTIONS(7518),
    [anon_sym_LT] = ACTIONS(7520),
    [anon_sym_LT_EQ] = ACTIONS(7518),
    [anon_sym_GT] = ACTIONS(7520),
    [anon_sym_GT_EQ] = ACTIONS(7518),
    [anon_sym_EQ_EQ] = ACTIONS(7518),
    [anon_sym_BANG_EQ] = ACTIONS(7518),
    [anon_sym_STAR] = ACTIONS(7520),
    [anon_sym_SLASH] = ACTIONS(7518),
    [anon_sym_STAR_STAR] = ACTIONS(7518),
    [anon_sym_CARET] = ACTIONS(7518),
    [aux_sym_binary_operator_token1] = ACTIONS(7518),
    [anon_sym_PIPE_GT] = ACTIONS(7518),
    [anon_sym_COLON] = ACTIONS(7520),
    [anon_sym_DOLLAR] = ACTIONS(7518),
    [anon_sym_AT] = ACTIONS(7518),
    [aux_sym__hex_literal_token1] = ACTIONS(7518),
    [sym__number_literal] = ACTIONS(7520),
    [anon_sym_SQUOTE] = ACTIONS(7518),
    [anon_sym_DQUOTE] = ACTIONS(7518),
    [sym_return] = ACTIONS(7520),
    [sym_next] = ACTIONS(7520),
    [sym_break] = ACTIONS(7520),
    [sym_true] = ACTIONS(7520),
    [sym_false] = ACTIONS(7520),
    [sym_null] = ACTIONS(7520),
    [sym_inf] = ACTIONS(7520),
    [sym_nan] = ACTIONS(7520),
    [anon_sym_NA] = ACTIONS(7520),
    [anon_sym_NA_integer_] = ACTIONS(7520),
    [anon_sym_NA_real_] = ACTIONS(7520),
    [anon_sym_NA_complex_] = ACTIONS(7520),
    [anon_sym_NA_character_] = ACTIONS(7520),
    [sym_dots] = ACTIONS(7520),
    [sym_dot_dot_i] = ACTIONS(7518),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7518),
    [sym__newline] = ACTIONS(7518),
    [sym__semicolon] = ACTIONS(7518),
    [sym__raw_string_literal] = ACTIONS(7518),
    [sym__external_open_parenthesis] = ACTIONS(7518),
    [sym__external_open_brace] = ACTIONS(7518),
    [sym__external_close_brace] = ACTIONS(7518),
    [sym__external_open_bracket] = ACTIONS(7518),
    [sym__external_close_bracket] = ACTIONS(7518),
    [sym__external_open_bracket2] = ACTIONS(7518),
  },
  [2661] = {
    [sym_identifier] = ACTIONS(7524),
    [anon_sym_BSLASH] = ACTIONS(7522),
    [anon_sym_function] = ACTIONS(7524),
    [anon_sym_EQ] = ACTIONS(7524),
    [anon_sym_if] = ACTIONS(7524),
    [anon_sym_for] = ACTIONS(7524),
    [anon_sym_while] = ACTIONS(7524),
    [anon_sym_repeat] = ACTIONS(7524),
    [anon_sym_QMARK] = ACTIONS(7522),
    [anon_sym_TILDE] = ACTIONS(7522),
    [anon_sym_BANG] = ACTIONS(7524),
    [anon_sym_PLUS] = ACTIONS(7522),
    [anon_sym_DASH] = ACTIONS(7524),
    [anon_sym_LT_DASH] = ACTIONS(7522),
    [anon_sym_LT_LT_DASH] = ACTIONS(7522),
    [anon_sym_COLON_EQ] = ACTIONS(7522),
    [anon_sym_DASH_GT] = ACTIONS(7524),
    [anon_sym_DASH_GT_GT] = ACTIONS(7522),
    [anon_sym_PIPE] = ACTIONS(7524),
    [anon_sym_AMP] = ACTIONS(7524),
    [anon_sym_PIPE_PIPE] = ACTIONS(7522),
    [anon_sym_AMP_AMP] = ACTIONS(7522),
    [anon_sym_LT] = ACTIONS(7524),
    [anon_sym_LT_EQ] = ACTIONS(7522),
    [anon_sym_GT] = ACTIONS(7524),
    [anon_sym_GT_EQ] = ACTIONS(7522),
    [anon_sym_EQ_EQ] = ACTIONS(7522),
    [anon_sym_BANG_EQ] = ACTIONS(7522),
    [anon_sym_STAR] = ACTIONS(7524),
    [anon_sym_SLASH] = ACTIONS(7522),
    [anon_sym_STAR_STAR] = ACTIONS(7522),
    [anon_sym_CARET] = ACTIONS(7522),
    [aux_sym_binary_operator_token1] = ACTIONS(7522),
    [anon_sym_PIPE_GT] = ACTIONS(7522),
    [anon_sym_COLON] = ACTIONS(7524),
    [anon_sym_DOLLAR] = ACTIONS(7522),
    [anon_sym_AT] = ACTIONS(7522),
    [aux_sym__hex_literal_token1] = ACTIONS(7522),
    [sym__number_literal] = ACTIONS(7524),
    [anon_sym_SQUOTE] = ACTIONS(7522),
    [anon_sym_DQUOTE] = ACTIONS(7522),
    [sym_return] = ACTIONS(7524),
    [sym_next] = ACTIONS(7524),
    [sym_break] = ACTIONS(7524),
    [sym_true] = ACTIONS(7524),
    [sym_false] = ACTIONS(7524),
    [sym_null] = ACTIONS(7524),
    [sym_inf] = ACTIONS(7524),
    [sym_nan] = ACTIONS(7524),
    [anon_sym_NA] = ACTIONS(7524),
    [anon_sym_NA_integer_] = ACTIONS(7524),
    [anon_sym_NA_real_] = ACTIONS(7524),
    [anon_sym_NA_complex_] = ACTIONS(7524),
    [anon_sym_NA_character_] = ACTIONS(7524),
    [sym_dots] = ACTIONS(7524),
    [sym_dot_dot_i] = ACTIONS(7522),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7522),
    [sym__newline] = ACTIONS(7522),
    [sym__semicolon] = ACTIONS(7522),
    [sym__raw_string_literal] = ACTIONS(7522),
    [sym__external_open_parenthesis] = ACTIONS(7522),
    [sym__external_open_brace] = ACTIONS(7522),
    [sym__external_close_brace] = ACTIONS(7522),
    [sym__external_open_bracket] = ACTIONS(7522),
    [sym__external_close_bracket] = ACTIONS(7522),
    [sym__external_open_bracket2] = ACTIONS(7522),
  },
  [2662] = {
    [sym_identifier] = ACTIONS(7552),
    [anon_sym_BSLASH] = ACTIONS(7550),
    [anon_sym_function] = ACTIONS(7552),
    [anon_sym_EQ] = ACTIONS(7552),
    [anon_sym_if] = ACTIONS(7552),
    [anon_sym_for] = ACTIONS(7552),
    [anon_sym_while] = ACTIONS(7552),
    [anon_sym_repeat] = ACTIONS(7552),
    [anon_sym_QMARK] = ACTIONS(7550),
    [anon_sym_TILDE] = ACTIONS(7550),
    [anon_sym_BANG] = ACTIONS(7552),
    [anon_sym_PLUS] = ACTIONS(7550),
    [anon_sym_DASH] = ACTIONS(7552),
    [anon_sym_LT_DASH] = ACTIONS(7550),
    [anon_sym_LT_LT_DASH] = ACTIONS(7550),
    [anon_sym_COLON_EQ] = ACTIONS(7550),
    [anon_sym_DASH_GT] = ACTIONS(7552),
    [anon_sym_DASH_GT_GT] = ACTIONS(7550),
    [anon_sym_PIPE] = ACTIONS(7552),
    [anon_sym_AMP] = ACTIONS(7552),
    [anon_sym_PIPE_PIPE] = ACTIONS(7550),
    [anon_sym_AMP_AMP] = ACTIONS(7550),
    [anon_sym_LT] = ACTIONS(7552),
    [anon_sym_LT_EQ] = ACTIONS(7550),
    [anon_sym_GT] = ACTIONS(7552),
    [anon_sym_GT_EQ] = ACTIONS(7550),
    [anon_sym_EQ_EQ] = ACTIONS(7550),
    [anon_sym_BANG_EQ] = ACTIONS(7550),
    [anon_sym_STAR] = ACTIONS(7552),
    [anon_sym_SLASH] = ACTIONS(7550),
    [anon_sym_STAR_STAR] = ACTIONS(7550),
    [anon_sym_CARET] = ACTIONS(7550),
    [aux_sym_binary_operator_token1] = ACTIONS(7550),
    [anon_sym_PIPE_GT] = ACTIONS(7550),
    [anon_sym_COLON] = ACTIONS(7552),
    [anon_sym_DOLLAR] = ACTIONS(7550),
    [anon_sym_AT] = ACTIONS(7550),
    [aux_sym__hex_literal_token1] = ACTIONS(7550),
    [sym__number_literal] = ACTIONS(7552),
    [anon_sym_SQUOTE] = ACTIONS(7550),
    [anon_sym_DQUOTE] = ACTIONS(7550),
    [sym_return] = ACTIONS(7552),
    [sym_next] = ACTIONS(7552),
    [sym_break] = ACTIONS(7552),
    [sym_true] = ACTIONS(7552),
    [sym_false] = ACTIONS(7552),
    [sym_null] = ACTIONS(7552),
    [sym_inf] = ACTIONS(7552),
    [sym_nan] = ACTIONS(7552),
    [anon_sym_NA] = ACTIONS(7552),
    [anon_sym_NA_integer_] = ACTIONS(7552),
    [anon_sym_NA_real_] = ACTIONS(7552),
    [anon_sym_NA_complex_] = ACTIONS(7552),
    [anon_sym_NA_character_] = ACTIONS(7552),
    [sym_dots] = ACTIONS(7552),
    [sym_dot_dot_i] = ACTIONS(7550),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7550),
    [sym__newline] = ACTIONS(7550),
    [sym__raw_string_literal] = ACTIONS(7550),
    [sym__external_else] = ACTIONS(7550),
    [sym__external_open_parenthesis] = ACTIONS(7550),
    [sym__external_close_parenthesis] = ACTIONS(7550),
    [sym__external_open_brace] = ACTIONS(7550),
    [sym__external_open_bracket] = ACTIONS(7550),
    [sym__external_open_bracket2] = ACTIONS(7550),
    [sym__external_close_bracket2] = ACTIONS(7550),
  },
  [2663] = {
    [sym_identifier] = ACTIONS(7528),
    [anon_sym_BSLASH] = ACTIONS(7526),
    [anon_sym_function] = ACTIONS(7528),
    [anon_sym_EQ] = ACTIONS(7528),
    [anon_sym_if] = ACTIONS(7528),
    [anon_sym_for] = ACTIONS(7528),
    [anon_sym_while] = ACTIONS(7528),
    [anon_sym_repeat] = ACTIONS(7528),
    [anon_sym_QMARK] = ACTIONS(7526),
    [anon_sym_TILDE] = ACTIONS(7526),
    [anon_sym_BANG] = ACTIONS(7528),
    [anon_sym_PLUS] = ACTIONS(7526),
    [anon_sym_DASH] = ACTIONS(7528),
    [anon_sym_LT_DASH] = ACTIONS(7526),
    [anon_sym_LT_LT_DASH] = ACTIONS(7526),
    [anon_sym_COLON_EQ] = ACTIONS(7526),
    [anon_sym_DASH_GT] = ACTIONS(7528),
    [anon_sym_DASH_GT_GT] = ACTIONS(7526),
    [anon_sym_PIPE] = ACTIONS(7528),
    [anon_sym_AMP] = ACTIONS(7528),
    [anon_sym_PIPE_PIPE] = ACTIONS(7526),
    [anon_sym_AMP_AMP] = ACTIONS(7526),
    [anon_sym_LT] = ACTIONS(7528),
    [anon_sym_LT_EQ] = ACTIONS(7526),
    [anon_sym_GT] = ACTIONS(7528),
    [anon_sym_GT_EQ] = ACTIONS(7526),
    [anon_sym_EQ_EQ] = ACTIONS(7526),
    [anon_sym_BANG_EQ] = ACTIONS(7526),
    [anon_sym_STAR] = ACTIONS(7528),
    [anon_sym_SLASH] = ACTIONS(7526),
    [anon_sym_STAR_STAR] = ACTIONS(7526),
    [anon_sym_CARET] = ACTIONS(7526),
    [aux_sym_binary_operator_token1] = ACTIONS(7526),
    [anon_sym_PIPE_GT] = ACTIONS(7526),
    [anon_sym_COLON] = ACTIONS(7528),
    [anon_sym_DOLLAR] = ACTIONS(7526),
    [anon_sym_AT] = ACTIONS(7526),
    [aux_sym__hex_literal_token1] = ACTIONS(7526),
    [sym__number_literal] = ACTIONS(7528),
    [anon_sym_SQUOTE] = ACTIONS(7526),
    [anon_sym_DQUOTE] = ACTIONS(7526),
    [sym_return] = ACTIONS(7528),
    [sym_next] = ACTIONS(7528),
    [sym_break] = ACTIONS(7528),
    [sym_true] = ACTIONS(7528),
    [sym_false] = ACTIONS(7528),
    [sym_null] = ACTIONS(7528),
    [sym_inf] = ACTIONS(7528),
    [sym_nan] = ACTIONS(7528),
    [anon_sym_NA] = ACTIONS(7528),
    [anon_sym_NA_integer_] = ACTIONS(7528),
    [anon_sym_NA_real_] = ACTIONS(7528),
    [anon_sym_NA_complex_] = ACTIONS(7528),
    [anon_sym_NA_character_] = ACTIONS(7528),
    [sym_dots] = ACTIONS(7528),
    [sym_dot_dot_i] = ACTIONS(7526),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7526),
    [sym__newline] = ACTIONS(7526),
    [sym__semicolon] = ACTIONS(7526),
    [sym__raw_string_literal] = ACTIONS(7526),
    [sym__external_open_parenthesis] = ACTIONS(7526),
    [sym__external_open_brace] = ACTIONS(7526),
    [sym__external_close_brace] = ACTIONS(7526),
    [sym__external_open_bracket] = ACTIONS(7526),
    [sym__external_close_bracket] = ACTIONS(7526),
    [sym__external_open_bracket2] = ACTIONS(7526),
  },
  [2664] = {
    [sym_identifier] = ACTIONS(7129),
    [anon_sym_BSLASH] = ACTIONS(7131),
    [anon_sym_function] = ACTIONS(7129),
    [anon_sym_EQ] = ACTIONS(7129),
    [anon_sym_if] = ACTIONS(7129),
    [anon_sym_for] = ACTIONS(7129),
    [anon_sym_while] = ACTIONS(7129),
    [anon_sym_repeat] = ACTIONS(7129),
    [anon_sym_QMARK] = ACTIONS(7131),
    [anon_sym_TILDE] = ACTIONS(7131),
    [anon_sym_BANG] = ACTIONS(7129),
    [anon_sym_PLUS] = ACTIONS(7131),
    [anon_sym_DASH] = ACTIONS(7129),
    [anon_sym_LT_DASH] = ACTIONS(7131),
    [anon_sym_LT_LT_DASH] = ACTIONS(7131),
    [anon_sym_COLON_EQ] = ACTIONS(7131),
    [anon_sym_DASH_GT] = ACTIONS(7129),
    [anon_sym_DASH_GT_GT] = ACTIONS(7131),
    [anon_sym_PIPE] = ACTIONS(7129),
    [anon_sym_AMP] = ACTIONS(7129),
    [anon_sym_PIPE_PIPE] = ACTIONS(7131),
    [anon_sym_AMP_AMP] = ACTIONS(7131),
    [anon_sym_LT] = ACTIONS(7129),
    [anon_sym_LT_EQ] = ACTIONS(7131),
    [anon_sym_GT] = ACTIONS(7129),
    [anon_sym_GT_EQ] = ACTIONS(7131),
    [anon_sym_EQ_EQ] = ACTIONS(7131),
    [anon_sym_BANG_EQ] = ACTIONS(7131),
    [anon_sym_STAR] = ACTIONS(7129),
    [anon_sym_SLASH] = ACTIONS(7131),
    [anon_sym_STAR_STAR] = ACTIONS(7131),
    [anon_sym_CARET] = ACTIONS(7131),
    [aux_sym_binary_operator_token1] = ACTIONS(7131),
    [anon_sym_PIPE_GT] = ACTIONS(7131),
    [anon_sym_COLON] = ACTIONS(7129),
    [anon_sym_DOLLAR] = ACTIONS(7131),
    [anon_sym_AT] = ACTIONS(7131),
    [anon_sym_COLON_COLON] = ACTIONS(7133),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7135),
    [aux_sym__hex_literal_token1] = ACTIONS(7131),
    [sym__number_literal] = ACTIONS(7129),
    [anon_sym_SQUOTE] = ACTIONS(7131),
    [anon_sym_DQUOTE] = ACTIONS(7131),
    [sym_return] = ACTIONS(7129),
    [sym_next] = ACTIONS(7129),
    [sym_break] = ACTIONS(7129),
    [sym_true] = ACTIONS(7129),
    [sym_false] = ACTIONS(7129),
    [sym_null] = ACTIONS(7129),
    [sym_inf] = ACTIONS(7129),
    [sym_nan] = ACTIONS(7129),
    [anon_sym_NA] = ACTIONS(7129),
    [anon_sym_NA_integer_] = ACTIONS(7129),
    [anon_sym_NA_real_] = ACTIONS(7129),
    [anon_sym_NA_complex_] = ACTIONS(7129),
    [anon_sym_NA_character_] = ACTIONS(7129),
    [sym_dots] = ACTIONS(7129),
    [sym_dot_dot_i] = ACTIONS(7131),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7131),
    [sym__newline] = ACTIONS(7131),
    [sym__raw_string_literal] = ACTIONS(7131),
    [sym__external_open_parenthesis] = ACTIONS(7131),
    [sym__external_open_brace] = ACTIONS(7131),
    [sym__external_open_bracket] = ACTIONS(7131),
    [sym__external_close_bracket] = ACTIONS(7131),
    [sym__external_open_bracket2] = ACTIONS(7131),
  },
  [2665] = {
    [sym_identifier] = ACTIONS(7137),
    [anon_sym_BSLASH] = ACTIONS(7139),
    [anon_sym_function] = ACTIONS(7137),
    [anon_sym_EQ] = ACTIONS(7137),
    [anon_sym_if] = ACTIONS(7137),
    [anon_sym_for] = ACTIONS(7137),
    [anon_sym_while] = ACTIONS(7137),
    [anon_sym_repeat] = ACTIONS(7137),
    [anon_sym_QMARK] = ACTIONS(7139),
    [anon_sym_TILDE] = ACTIONS(7139),
    [anon_sym_BANG] = ACTIONS(7137),
    [anon_sym_PLUS] = ACTIONS(7139),
    [anon_sym_DASH] = ACTIONS(7137),
    [anon_sym_LT_DASH] = ACTIONS(7139),
    [anon_sym_LT_LT_DASH] = ACTIONS(7139),
    [anon_sym_COLON_EQ] = ACTIONS(7139),
    [anon_sym_DASH_GT] = ACTIONS(7137),
    [anon_sym_DASH_GT_GT] = ACTIONS(7139),
    [anon_sym_PIPE] = ACTIONS(7137),
    [anon_sym_AMP] = ACTIONS(7137),
    [anon_sym_PIPE_PIPE] = ACTIONS(7139),
    [anon_sym_AMP_AMP] = ACTIONS(7139),
    [anon_sym_LT] = ACTIONS(7137),
    [anon_sym_LT_EQ] = ACTIONS(7139),
    [anon_sym_GT] = ACTIONS(7137),
    [anon_sym_GT_EQ] = ACTIONS(7139),
    [anon_sym_EQ_EQ] = ACTIONS(7139),
    [anon_sym_BANG_EQ] = ACTIONS(7139),
    [anon_sym_STAR] = ACTIONS(7137),
    [anon_sym_SLASH] = ACTIONS(7139),
    [anon_sym_STAR_STAR] = ACTIONS(7139),
    [anon_sym_CARET] = ACTIONS(7139),
    [aux_sym_binary_operator_token1] = ACTIONS(7139),
    [anon_sym_PIPE_GT] = ACTIONS(7139),
    [anon_sym_COLON] = ACTIONS(7137),
    [anon_sym_DOLLAR] = ACTIONS(7139),
    [anon_sym_AT] = ACTIONS(7139),
    [anon_sym_COLON_COLON] = ACTIONS(7137),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7139),
    [aux_sym__hex_literal_token1] = ACTIONS(7139),
    [sym__number_literal] = ACTIONS(7137),
    [anon_sym_SQUOTE] = ACTIONS(7139),
    [anon_sym_DQUOTE] = ACTIONS(7139),
    [sym_return] = ACTIONS(7137),
    [sym_next] = ACTIONS(7137),
    [sym_break] = ACTIONS(7137),
    [sym_true] = ACTIONS(7137),
    [sym_false] = ACTIONS(7137),
    [sym_null] = ACTIONS(7137),
    [sym_inf] = ACTIONS(7137),
    [sym_nan] = ACTIONS(7137),
    [anon_sym_NA] = ACTIONS(7137),
    [anon_sym_NA_integer_] = ACTIONS(7137),
    [anon_sym_NA_real_] = ACTIONS(7137),
    [anon_sym_NA_complex_] = ACTIONS(7137),
    [anon_sym_NA_character_] = ACTIONS(7137),
    [sym_dots] = ACTIONS(7137),
    [sym_dot_dot_i] = ACTIONS(7139),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7139),
    [sym__newline] = ACTIONS(7139),
    [sym__raw_string_literal] = ACTIONS(7139),
    [sym__external_open_parenthesis] = ACTIONS(7139),
    [sym__external_open_brace] = ACTIONS(7139),
    [sym__external_open_bracket] = ACTIONS(7139),
    [sym__external_open_bracket2] = ACTIONS(7139),
    [sym__external_close_bracket2] = ACTIONS(7139),
  },
  [2666] = {
    [ts_builtin_sym_end] = ACTIONS(7561),
    [sym_identifier] = ACTIONS(7563),
    [anon_sym_BSLASH] = ACTIONS(7561),
    [anon_sym_function] = ACTIONS(7563),
    [anon_sym_EQ] = ACTIONS(7563),
    [anon_sym_if] = ACTIONS(7563),
    [anon_sym_for] = ACTIONS(7563),
    [anon_sym_while] = ACTIONS(7563),
    [anon_sym_repeat] = ACTIONS(7563),
    [anon_sym_QMARK] = ACTIONS(7561),
    [anon_sym_TILDE] = ACTIONS(7561),
    [anon_sym_BANG] = ACTIONS(7563),
    [anon_sym_PLUS] = ACTIONS(7561),
    [anon_sym_DASH] = ACTIONS(7563),
    [anon_sym_LT_DASH] = ACTIONS(7561),
    [anon_sym_LT_LT_DASH] = ACTIONS(7561),
    [anon_sym_COLON_EQ] = ACTIONS(7561),
    [anon_sym_DASH_GT] = ACTIONS(7563),
    [anon_sym_DASH_GT_GT] = ACTIONS(7561),
    [anon_sym_PIPE] = ACTIONS(7563),
    [anon_sym_AMP] = ACTIONS(7563),
    [anon_sym_PIPE_PIPE] = ACTIONS(7561),
    [anon_sym_AMP_AMP] = ACTIONS(7561),
    [anon_sym_LT] = ACTIONS(7563),
    [anon_sym_LT_EQ] = ACTIONS(7561),
    [anon_sym_GT] = ACTIONS(7563),
    [anon_sym_GT_EQ] = ACTIONS(7561),
    [anon_sym_EQ_EQ] = ACTIONS(7561),
    [anon_sym_BANG_EQ] = ACTIONS(7561),
    [anon_sym_STAR] = ACTIONS(7563),
    [anon_sym_SLASH] = ACTIONS(7561),
    [anon_sym_STAR_STAR] = ACTIONS(7561),
    [anon_sym_CARET] = ACTIONS(7561),
    [aux_sym_binary_operator_token1] = ACTIONS(7561),
    [anon_sym_PIPE_GT] = ACTIONS(7561),
    [anon_sym_COLON] = ACTIONS(7563),
    [anon_sym_DOLLAR] = ACTIONS(7561),
    [anon_sym_AT] = ACTIONS(7561),
    [aux_sym__hex_literal_token1] = ACTIONS(7561),
    [sym__number_literal] = ACTIONS(7563),
    [anon_sym_SQUOTE] = ACTIONS(7561),
    [anon_sym_DQUOTE] = ACTIONS(7561),
    [sym_return] = ACTIONS(7563),
    [sym_next] = ACTIONS(7563),
    [sym_break] = ACTIONS(7563),
    [sym_true] = ACTIONS(7563),
    [sym_false] = ACTIONS(7563),
    [sym_null] = ACTIONS(7563),
    [sym_inf] = ACTIONS(7563),
    [sym_nan] = ACTIONS(7563),
    [anon_sym_NA] = ACTIONS(7563),
    [anon_sym_NA_integer_] = ACTIONS(7563),
    [anon_sym_NA_real_] = ACTIONS(7563),
    [anon_sym_NA_complex_] = ACTIONS(7563),
    [anon_sym_NA_character_] = ACTIONS(7563),
    [sym_dots] = ACTIONS(7563),
    [sym_dot_dot_i] = ACTIONS(7561),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7561),
    [sym__semicolon] = ACTIONS(7561),
    [sym__raw_string_literal] = ACTIONS(7561),
    [sym__external_else] = ACTIONS(7561),
    [sym__external_open_parenthesis] = ACTIONS(7561),
    [sym__external_close_parenthesis] = ACTIONS(7561),
    [sym__external_open_brace] = ACTIONS(7561),
    [sym__external_open_bracket] = ACTIONS(7561),
    [sym__external_open_bracket2] = ACTIONS(7561),
  },
  [2667] = {
    [ts_builtin_sym_end] = ACTIONS(7139),
    [sym_identifier] = ACTIONS(7137),
    [anon_sym_BSLASH] = ACTIONS(7139),
    [anon_sym_function] = ACTIONS(7137),
    [anon_sym_EQ] = ACTIONS(7137),
    [anon_sym_if] = ACTIONS(7137),
    [anon_sym_for] = ACTIONS(7137),
    [anon_sym_while] = ACTIONS(7137),
    [anon_sym_repeat] = ACTIONS(7137),
    [anon_sym_QMARK] = ACTIONS(7139),
    [anon_sym_TILDE] = ACTIONS(7139),
    [anon_sym_BANG] = ACTIONS(7137),
    [anon_sym_PLUS] = ACTIONS(7139),
    [anon_sym_DASH] = ACTIONS(7137),
    [anon_sym_LT_DASH] = ACTIONS(7139),
    [anon_sym_LT_LT_DASH] = ACTIONS(7139),
    [anon_sym_COLON_EQ] = ACTIONS(7139),
    [anon_sym_DASH_GT] = ACTIONS(7137),
    [anon_sym_DASH_GT_GT] = ACTIONS(7139),
    [anon_sym_PIPE] = ACTIONS(7137),
    [anon_sym_AMP] = ACTIONS(7137),
    [anon_sym_PIPE_PIPE] = ACTIONS(7139),
    [anon_sym_AMP_AMP] = ACTIONS(7139),
    [anon_sym_LT] = ACTIONS(7137),
    [anon_sym_LT_EQ] = ACTIONS(7139),
    [anon_sym_GT] = ACTIONS(7137),
    [anon_sym_GT_EQ] = ACTIONS(7139),
    [anon_sym_EQ_EQ] = ACTIONS(7139),
    [anon_sym_BANG_EQ] = ACTIONS(7139),
    [anon_sym_STAR] = ACTIONS(7137),
    [anon_sym_SLASH] = ACTIONS(7139),
    [anon_sym_STAR_STAR] = ACTIONS(7139),
    [anon_sym_CARET] = ACTIONS(7139),
    [aux_sym_binary_operator_token1] = ACTIONS(7139),
    [anon_sym_PIPE_GT] = ACTIONS(7139),
    [anon_sym_COLON] = ACTIONS(7137),
    [anon_sym_DOLLAR] = ACTIONS(7139),
    [anon_sym_AT] = ACTIONS(7139),
    [anon_sym_COLON_COLON] = ACTIONS(7137),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7139),
    [aux_sym__hex_literal_token1] = ACTIONS(7139),
    [sym__number_literal] = ACTIONS(7137),
    [anon_sym_SQUOTE] = ACTIONS(7139),
    [anon_sym_DQUOTE] = ACTIONS(7139),
    [sym_return] = ACTIONS(7137),
    [sym_next] = ACTIONS(7137),
    [sym_break] = ACTIONS(7137),
    [sym_true] = ACTIONS(7137),
    [sym_false] = ACTIONS(7137),
    [sym_null] = ACTIONS(7137),
    [sym_inf] = ACTIONS(7137),
    [sym_nan] = ACTIONS(7137),
    [anon_sym_NA] = ACTIONS(7137),
    [anon_sym_NA_integer_] = ACTIONS(7137),
    [anon_sym_NA_real_] = ACTIONS(7137),
    [anon_sym_NA_complex_] = ACTIONS(7137),
    [anon_sym_NA_character_] = ACTIONS(7137),
    [sym_dots] = ACTIONS(7137),
    [sym_dot_dot_i] = ACTIONS(7139),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7139),
    [sym__semicolon] = ACTIONS(7139),
    [sym__raw_string_literal] = ACTIONS(7139),
    [sym__external_open_parenthesis] = ACTIONS(7139),
    [sym__external_open_brace] = ACTIONS(7139),
    [sym__external_open_bracket] = ACTIONS(7139),
    [sym__external_open_bracket2] = ACTIONS(7139),
  },
  [2668] = {
    [sym_identifier] = ACTIONS(7137),
    [anon_sym_BSLASH] = ACTIONS(7139),
    [anon_sym_function] = ACTIONS(7137),
    [anon_sym_EQ] = ACTIONS(7137),
    [anon_sym_if] = ACTIONS(7137),
    [anon_sym_for] = ACTIONS(7137),
    [anon_sym_while] = ACTIONS(7137),
    [anon_sym_repeat] = ACTIONS(7137),
    [anon_sym_QMARK] = ACTIONS(7139),
    [anon_sym_TILDE] = ACTIONS(7139),
    [anon_sym_BANG] = ACTIONS(7137),
    [anon_sym_PLUS] = ACTIONS(7139),
    [anon_sym_DASH] = ACTIONS(7137),
    [anon_sym_LT_DASH] = ACTIONS(7139),
    [anon_sym_LT_LT_DASH] = ACTIONS(7139),
    [anon_sym_COLON_EQ] = ACTIONS(7139),
    [anon_sym_DASH_GT] = ACTIONS(7137),
    [anon_sym_DASH_GT_GT] = ACTIONS(7139),
    [anon_sym_PIPE] = ACTIONS(7137),
    [anon_sym_AMP] = ACTIONS(7137),
    [anon_sym_PIPE_PIPE] = ACTIONS(7139),
    [anon_sym_AMP_AMP] = ACTIONS(7139),
    [anon_sym_LT] = ACTIONS(7137),
    [anon_sym_LT_EQ] = ACTIONS(7139),
    [anon_sym_GT] = ACTIONS(7137),
    [anon_sym_GT_EQ] = ACTIONS(7139),
    [anon_sym_EQ_EQ] = ACTIONS(7139),
    [anon_sym_BANG_EQ] = ACTIONS(7139),
    [anon_sym_STAR] = ACTIONS(7137),
    [anon_sym_SLASH] = ACTIONS(7139),
    [anon_sym_STAR_STAR] = ACTIONS(7139),
    [anon_sym_CARET] = ACTIONS(7139),
    [aux_sym_binary_operator_token1] = ACTIONS(7139),
    [anon_sym_PIPE_GT] = ACTIONS(7139),
    [anon_sym_COLON] = ACTIONS(7137),
    [anon_sym_DOLLAR] = ACTIONS(7139),
    [anon_sym_AT] = ACTIONS(7139),
    [anon_sym_COLON_COLON] = ACTIONS(7137),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7139),
    [aux_sym__hex_literal_token1] = ACTIONS(7139),
    [sym__number_literal] = ACTIONS(7137),
    [anon_sym_SQUOTE] = ACTIONS(7139),
    [anon_sym_DQUOTE] = ACTIONS(7139),
    [sym_return] = ACTIONS(7137),
    [sym_next] = ACTIONS(7137),
    [sym_break] = ACTIONS(7137),
    [sym_true] = ACTIONS(7137),
    [sym_false] = ACTIONS(7137),
    [sym_null] = ACTIONS(7137),
    [sym_inf] = ACTIONS(7137),
    [sym_nan] = ACTIONS(7137),
    [anon_sym_NA] = ACTIONS(7137),
    [anon_sym_NA_integer_] = ACTIONS(7137),
    [anon_sym_NA_real_] = ACTIONS(7137),
    [anon_sym_NA_complex_] = ACTIONS(7137),
    [anon_sym_NA_character_] = ACTIONS(7137),
    [sym_dots] = ACTIONS(7137),
    [sym_dot_dot_i] = ACTIONS(7139),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7139),
    [sym__newline] = ACTIONS(7139),
    [sym__raw_string_literal] = ACTIONS(7139),
    [sym__external_open_parenthesis] = ACTIONS(7139),
    [sym__external_open_brace] = ACTIONS(7139),
    [sym__external_open_bracket] = ACTIONS(7139),
    [sym__external_close_bracket] = ACTIONS(7139),
    [sym__external_open_bracket2] = ACTIONS(7139),
  },
  [2669] = {
    [sym_identifier] = ACTIONS(7556),
    [anon_sym_BSLASH] = ACTIONS(7554),
    [anon_sym_function] = ACTIONS(7556),
    [anon_sym_EQ] = ACTIONS(7556),
    [anon_sym_if] = ACTIONS(7556),
    [anon_sym_for] = ACTIONS(7556),
    [anon_sym_while] = ACTIONS(7556),
    [anon_sym_repeat] = ACTIONS(7556),
    [anon_sym_QMARK] = ACTIONS(7554),
    [anon_sym_TILDE] = ACTIONS(7554),
    [anon_sym_BANG] = ACTIONS(7556),
    [anon_sym_PLUS] = ACTIONS(7554),
    [anon_sym_DASH] = ACTIONS(7556),
    [anon_sym_LT_DASH] = ACTIONS(7554),
    [anon_sym_LT_LT_DASH] = ACTIONS(7554),
    [anon_sym_COLON_EQ] = ACTIONS(7554),
    [anon_sym_DASH_GT] = ACTIONS(7556),
    [anon_sym_DASH_GT_GT] = ACTIONS(7554),
    [anon_sym_PIPE] = ACTIONS(7556),
    [anon_sym_AMP] = ACTIONS(7556),
    [anon_sym_PIPE_PIPE] = ACTIONS(7554),
    [anon_sym_AMP_AMP] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(7556),
    [anon_sym_LT_EQ] = ACTIONS(7554),
    [anon_sym_GT] = ACTIONS(7556),
    [anon_sym_GT_EQ] = ACTIONS(7554),
    [anon_sym_EQ_EQ] = ACTIONS(7554),
    [anon_sym_BANG_EQ] = ACTIONS(7554),
    [anon_sym_STAR] = ACTIONS(7556),
    [anon_sym_SLASH] = ACTIONS(7554),
    [anon_sym_STAR_STAR] = ACTIONS(7554),
    [anon_sym_CARET] = ACTIONS(7554),
    [aux_sym_binary_operator_token1] = ACTIONS(7554),
    [anon_sym_PIPE_GT] = ACTIONS(7554),
    [anon_sym_COLON] = ACTIONS(7556),
    [anon_sym_DOLLAR] = ACTIONS(7554),
    [anon_sym_AT] = ACTIONS(7554),
    [aux_sym__hex_literal_token1] = ACTIONS(7554),
    [sym__number_literal] = ACTIONS(7556),
    [anon_sym_SQUOTE] = ACTIONS(7554),
    [anon_sym_DQUOTE] = ACTIONS(7554),
    [sym_return] = ACTIONS(7556),
    [sym_next] = ACTIONS(7556),
    [sym_break] = ACTIONS(7556),
    [sym_true] = ACTIONS(7556),
    [sym_false] = ACTIONS(7556),
    [sym_null] = ACTIONS(7556),
    [sym_inf] = ACTIONS(7556),
    [sym_nan] = ACTIONS(7556),
    [anon_sym_NA] = ACTIONS(7556),
    [anon_sym_NA_integer_] = ACTIONS(7556),
    [anon_sym_NA_real_] = ACTIONS(7556),
    [anon_sym_NA_complex_] = ACTIONS(7556),
    [anon_sym_NA_character_] = ACTIONS(7556),
    [sym_dots] = ACTIONS(7556),
    [sym_dot_dot_i] = ACTIONS(7554),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7554),
    [sym__newline] = ACTIONS(7554),
    [sym__semicolon] = ACTIONS(7554),
    [sym__raw_string_literal] = ACTIONS(7554),
    [sym__external_open_parenthesis] = ACTIONS(7554),
    [sym__external_open_brace] = ACTIONS(7554),
    [sym__external_close_brace] = ACTIONS(7554),
    [sym__external_open_bracket] = ACTIONS(7554),
    [sym__external_open_bracket2] = ACTIONS(7554),
    [sym__external_close_bracket2] = ACTIONS(7554),
  },
  [2670] = {
    [aux_sym_function_definition_repeat1] = STATE(2670),
    [ts_builtin_sym_end] = ACTIONS(7417),
    [sym_identifier] = ACTIONS(7419),
    [anon_sym_BSLASH] = ACTIONS(7417),
    [anon_sym_function] = ACTIONS(7419),
    [anon_sym_EQ] = ACTIONS(7419),
    [anon_sym_if] = ACTIONS(7419),
    [anon_sym_for] = ACTIONS(7419),
    [anon_sym_while] = ACTIONS(7419),
    [anon_sym_repeat] = ACTIONS(7419),
    [anon_sym_QMARK] = ACTIONS(7417),
    [anon_sym_TILDE] = ACTIONS(7417),
    [anon_sym_BANG] = ACTIONS(7419),
    [anon_sym_PLUS] = ACTIONS(7417),
    [anon_sym_DASH] = ACTIONS(7419),
    [anon_sym_LT_DASH] = ACTIONS(7417),
    [anon_sym_LT_LT_DASH] = ACTIONS(7417),
    [anon_sym_COLON_EQ] = ACTIONS(7417),
    [anon_sym_DASH_GT] = ACTIONS(7419),
    [anon_sym_DASH_GT_GT] = ACTIONS(7417),
    [anon_sym_PIPE] = ACTIONS(7419),
    [anon_sym_AMP] = ACTIONS(7419),
    [anon_sym_PIPE_PIPE] = ACTIONS(7417),
    [anon_sym_AMP_AMP] = ACTIONS(7417),
    [anon_sym_LT] = ACTIONS(7419),
    [anon_sym_LT_EQ] = ACTIONS(7417),
    [anon_sym_GT] = ACTIONS(7419),
    [anon_sym_GT_EQ] = ACTIONS(7417),
    [anon_sym_EQ_EQ] = ACTIONS(7417),
    [anon_sym_BANG_EQ] = ACTIONS(7417),
    [anon_sym_STAR] = ACTIONS(7419),
    [anon_sym_SLASH] = ACTIONS(7417),
    [anon_sym_STAR_STAR] = ACTIONS(7417),
    [anon_sym_CARET] = ACTIONS(7417),
    [aux_sym_binary_operator_token1] = ACTIONS(7417),
    [anon_sym_PIPE_GT] = ACTIONS(7417),
    [anon_sym_COLON] = ACTIONS(7419),
    [anon_sym_DOLLAR] = ACTIONS(7417),
    [anon_sym_AT] = ACTIONS(7417),
    [aux_sym__hex_literal_token1] = ACTIONS(7417),
    [sym__number_literal] = ACTIONS(7419),
    [anon_sym_SQUOTE] = ACTIONS(7417),
    [anon_sym_DQUOTE] = ACTIONS(7417),
    [sym_return] = ACTIONS(7419),
    [sym_next] = ACTIONS(7419),
    [sym_break] = ACTIONS(7419),
    [sym_true] = ACTIONS(7419),
    [sym_false] = ACTIONS(7419),
    [sym_null] = ACTIONS(7419),
    [sym_inf] = ACTIONS(7419),
    [sym_nan] = ACTIONS(7419),
    [anon_sym_NA] = ACTIONS(7419),
    [anon_sym_NA_integer_] = ACTIONS(7419),
    [anon_sym_NA_real_] = ACTIONS(7419),
    [anon_sym_NA_complex_] = ACTIONS(7419),
    [anon_sym_NA_character_] = ACTIONS(7419),
    [sym_dots] = ACTIONS(7419),
    [sym_dot_dot_i] = ACTIONS(7417),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7675),
    [sym__semicolon] = ACTIONS(7417),
    [sym__raw_string_literal] = ACTIONS(7417),
    [sym__external_open_parenthesis] = ACTIONS(7417),
    [sym__external_close_parenthesis] = ACTIONS(7417),
    [sym__external_open_brace] = ACTIONS(7417),
    [sym__external_open_bracket] = ACTIONS(7417),
    [sym__external_open_bracket2] = ACTIONS(7417),
  },
  [2671] = {
    [sym_identifier] = ACTIONS(7532),
    [anon_sym_BSLASH] = ACTIONS(7530),
    [anon_sym_function] = ACTIONS(7532),
    [anon_sym_EQ] = ACTIONS(7532),
    [anon_sym_if] = ACTIONS(7532),
    [anon_sym_for] = ACTIONS(7532),
    [anon_sym_while] = ACTIONS(7532),
    [anon_sym_repeat] = ACTIONS(7532),
    [anon_sym_QMARK] = ACTIONS(7530),
    [anon_sym_TILDE] = ACTIONS(7530),
    [anon_sym_BANG] = ACTIONS(7532),
    [anon_sym_PLUS] = ACTIONS(7530),
    [anon_sym_DASH] = ACTIONS(7532),
    [anon_sym_LT_DASH] = ACTIONS(7530),
    [anon_sym_LT_LT_DASH] = ACTIONS(7530),
    [anon_sym_COLON_EQ] = ACTIONS(7530),
    [anon_sym_DASH_GT] = ACTIONS(7532),
    [anon_sym_DASH_GT_GT] = ACTIONS(7530),
    [anon_sym_PIPE] = ACTIONS(7532),
    [anon_sym_AMP] = ACTIONS(7532),
    [anon_sym_PIPE_PIPE] = ACTIONS(7530),
    [anon_sym_AMP_AMP] = ACTIONS(7530),
    [anon_sym_LT] = ACTIONS(7532),
    [anon_sym_LT_EQ] = ACTIONS(7530),
    [anon_sym_GT] = ACTIONS(7532),
    [anon_sym_GT_EQ] = ACTIONS(7530),
    [anon_sym_EQ_EQ] = ACTIONS(7530),
    [anon_sym_BANG_EQ] = ACTIONS(7530),
    [anon_sym_STAR] = ACTIONS(7532),
    [anon_sym_SLASH] = ACTIONS(7530),
    [anon_sym_STAR_STAR] = ACTIONS(7530),
    [anon_sym_CARET] = ACTIONS(7530),
    [aux_sym_binary_operator_token1] = ACTIONS(7530),
    [anon_sym_PIPE_GT] = ACTIONS(7530),
    [anon_sym_COLON] = ACTIONS(7532),
    [anon_sym_DOLLAR] = ACTIONS(7530),
    [anon_sym_AT] = ACTIONS(7530),
    [aux_sym__hex_literal_token1] = ACTIONS(7530),
    [sym__number_literal] = ACTIONS(7532),
    [anon_sym_SQUOTE] = ACTIONS(7530),
    [anon_sym_DQUOTE] = ACTIONS(7530),
    [sym_return] = ACTIONS(7532),
    [sym_next] = ACTIONS(7532),
    [sym_break] = ACTIONS(7532),
    [sym_true] = ACTIONS(7532),
    [sym_false] = ACTIONS(7532),
    [sym_null] = ACTIONS(7532),
    [sym_inf] = ACTIONS(7532),
    [sym_nan] = ACTIONS(7532),
    [anon_sym_NA] = ACTIONS(7532),
    [anon_sym_NA_integer_] = ACTIONS(7532),
    [anon_sym_NA_real_] = ACTIONS(7532),
    [anon_sym_NA_complex_] = ACTIONS(7532),
    [anon_sym_NA_character_] = ACTIONS(7532),
    [sym_dots] = ACTIONS(7532),
    [sym_dot_dot_i] = ACTIONS(7530),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7530),
    [sym__newline] = ACTIONS(7530),
    [sym__semicolon] = ACTIONS(7530),
    [sym__raw_string_literal] = ACTIONS(7530),
    [sym__external_open_parenthesis] = ACTIONS(7530),
    [sym__external_open_brace] = ACTIONS(7530),
    [sym__external_close_brace] = ACTIONS(7530),
    [sym__external_open_bracket] = ACTIONS(7530),
    [sym__external_close_bracket] = ACTIONS(7530),
    [sym__external_open_bracket2] = ACTIONS(7530),
  },
  [2672] = {
    [sym_identifier] = ACTIONS(7516),
    [anon_sym_BSLASH] = ACTIONS(7514),
    [anon_sym_function] = ACTIONS(7516),
    [anon_sym_EQ] = ACTIONS(7516),
    [anon_sym_if] = ACTIONS(7516),
    [anon_sym_for] = ACTIONS(7516),
    [anon_sym_while] = ACTIONS(7516),
    [anon_sym_repeat] = ACTIONS(7516),
    [anon_sym_QMARK] = ACTIONS(7514),
    [anon_sym_TILDE] = ACTIONS(7514),
    [anon_sym_BANG] = ACTIONS(7516),
    [anon_sym_PLUS] = ACTIONS(7514),
    [anon_sym_DASH] = ACTIONS(7516),
    [anon_sym_LT_DASH] = ACTIONS(7514),
    [anon_sym_LT_LT_DASH] = ACTIONS(7514),
    [anon_sym_COLON_EQ] = ACTIONS(7514),
    [anon_sym_DASH_GT] = ACTIONS(7516),
    [anon_sym_DASH_GT_GT] = ACTIONS(7514),
    [anon_sym_PIPE] = ACTIONS(7516),
    [anon_sym_AMP] = ACTIONS(7516),
    [anon_sym_PIPE_PIPE] = ACTIONS(7514),
    [anon_sym_AMP_AMP] = ACTIONS(7514),
    [anon_sym_LT] = ACTIONS(7516),
    [anon_sym_LT_EQ] = ACTIONS(7514),
    [anon_sym_GT] = ACTIONS(7516),
    [anon_sym_GT_EQ] = ACTIONS(7514),
    [anon_sym_EQ_EQ] = ACTIONS(7514),
    [anon_sym_BANG_EQ] = ACTIONS(7514),
    [anon_sym_STAR] = ACTIONS(7516),
    [anon_sym_SLASH] = ACTIONS(7514),
    [anon_sym_STAR_STAR] = ACTIONS(7514),
    [anon_sym_CARET] = ACTIONS(7514),
    [aux_sym_binary_operator_token1] = ACTIONS(7514),
    [anon_sym_PIPE_GT] = ACTIONS(7514),
    [anon_sym_COLON] = ACTIONS(7516),
    [anon_sym_DOLLAR] = ACTIONS(7514),
    [anon_sym_AT] = ACTIONS(7514),
    [aux_sym__hex_literal_token1] = ACTIONS(7514),
    [sym__number_literal] = ACTIONS(7516),
    [anon_sym_SQUOTE] = ACTIONS(7514),
    [anon_sym_DQUOTE] = ACTIONS(7514),
    [sym_return] = ACTIONS(7516),
    [sym_next] = ACTIONS(7516),
    [sym_break] = ACTIONS(7516),
    [sym_true] = ACTIONS(7516),
    [sym_false] = ACTIONS(7516),
    [sym_null] = ACTIONS(7516),
    [sym_inf] = ACTIONS(7516),
    [sym_nan] = ACTIONS(7516),
    [anon_sym_NA] = ACTIONS(7516),
    [anon_sym_NA_integer_] = ACTIONS(7516),
    [anon_sym_NA_real_] = ACTIONS(7516),
    [anon_sym_NA_complex_] = ACTIONS(7516),
    [anon_sym_NA_character_] = ACTIONS(7516),
    [sym_dots] = ACTIONS(7516),
    [sym_dot_dot_i] = ACTIONS(7514),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7514),
    [sym__newline] = ACTIONS(7514),
    [sym__semicolon] = ACTIONS(7514),
    [sym__raw_string_literal] = ACTIONS(7514),
    [sym__external_open_parenthesis] = ACTIONS(7514),
    [sym__external_open_brace] = ACTIONS(7514),
    [sym__external_close_brace] = ACTIONS(7514),
    [sym__external_open_bracket] = ACTIONS(7514),
    [sym__external_open_bracket2] = ACTIONS(7514),
    [sym__external_close_bracket2] = ACTIONS(7514),
  },
  [2673] = {
    [sym_identifier] = ACTIONS(7129),
    [anon_sym_BSLASH] = ACTIONS(7131),
    [anon_sym_function] = ACTIONS(7129),
    [anon_sym_EQ] = ACTIONS(7129),
    [anon_sym_if] = ACTIONS(7129),
    [anon_sym_for] = ACTIONS(7129),
    [anon_sym_while] = ACTIONS(7129),
    [anon_sym_repeat] = ACTIONS(7129),
    [anon_sym_QMARK] = ACTIONS(7131),
    [anon_sym_TILDE] = ACTIONS(7131),
    [anon_sym_BANG] = ACTIONS(7129),
    [anon_sym_PLUS] = ACTIONS(7131),
    [anon_sym_DASH] = ACTIONS(7129),
    [anon_sym_LT_DASH] = ACTIONS(7131),
    [anon_sym_LT_LT_DASH] = ACTIONS(7131),
    [anon_sym_COLON_EQ] = ACTIONS(7131),
    [anon_sym_DASH_GT] = ACTIONS(7129),
    [anon_sym_DASH_GT_GT] = ACTIONS(7131),
    [anon_sym_PIPE] = ACTIONS(7129),
    [anon_sym_AMP] = ACTIONS(7129),
    [anon_sym_PIPE_PIPE] = ACTIONS(7131),
    [anon_sym_AMP_AMP] = ACTIONS(7131),
    [anon_sym_LT] = ACTIONS(7129),
    [anon_sym_LT_EQ] = ACTIONS(7131),
    [anon_sym_GT] = ACTIONS(7129),
    [anon_sym_GT_EQ] = ACTIONS(7131),
    [anon_sym_EQ_EQ] = ACTIONS(7131),
    [anon_sym_BANG_EQ] = ACTIONS(7131),
    [anon_sym_STAR] = ACTIONS(7129),
    [anon_sym_SLASH] = ACTIONS(7131),
    [anon_sym_STAR_STAR] = ACTIONS(7131),
    [anon_sym_CARET] = ACTIONS(7131),
    [aux_sym_binary_operator_token1] = ACTIONS(7131),
    [anon_sym_PIPE_GT] = ACTIONS(7131),
    [anon_sym_COLON] = ACTIONS(7129),
    [anon_sym_DOLLAR] = ACTIONS(7131),
    [anon_sym_AT] = ACTIONS(7131),
    [anon_sym_COLON_COLON] = ACTIONS(7133),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7135),
    [aux_sym__hex_literal_token1] = ACTIONS(7131),
    [sym__number_literal] = ACTIONS(7129),
    [anon_sym_SQUOTE] = ACTIONS(7131),
    [anon_sym_DQUOTE] = ACTIONS(7131),
    [sym_return] = ACTIONS(7129),
    [sym_next] = ACTIONS(7129),
    [sym_break] = ACTIONS(7129),
    [sym_true] = ACTIONS(7129),
    [sym_false] = ACTIONS(7129),
    [sym_null] = ACTIONS(7129),
    [sym_inf] = ACTIONS(7129),
    [sym_nan] = ACTIONS(7129),
    [anon_sym_NA] = ACTIONS(7129),
    [anon_sym_NA_integer_] = ACTIONS(7129),
    [anon_sym_NA_real_] = ACTIONS(7129),
    [anon_sym_NA_complex_] = ACTIONS(7129),
    [anon_sym_NA_character_] = ACTIONS(7129),
    [sym_dots] = ACTIONS(7129),
    [sym_dot_dot_i] = ACTIONS(7131),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7131),
    [sym__newline] = ACTIONS(7131),
    [sym__raw_string_literal] = ACTIONS(7131),
    [sym__external_open_parenthesis] = ACTIONS(7131),
    [sym__external_close_parenthesis] = ACTIONS(7131),
    [sym__external_open_brace] = ACTIONS(7131),
    [sym__external_open_bracket] = ACTIONS(7131),
    [sym__external_open_bracket2] = ACTIONS(7131),
  },
  [2674] = {
    [ts_builtin_sym_end] = ACTIONS(7554),
    [sym_identifier] = ACTIONS(7556),
    [anon_sym_BSLASH] = ACTIONS(7554),
    [anon_sym_function] = ACTIONS(7556),
    [anon_sym_EQ] = ACTIONS(7556),
    [anon_sym_if] = ACTIONS(7556),
    [anon_sym_for] = ACTIONS(7556),
    [anon_sym_while] = ACTIONS(7556),
    [anon_sym_repeat] = ACTIONS(7556),
    [anon_sym_QMARK] = ACTIONS(7554),
    [anon_sym_TILDE] = ACTIONS(7554),
    [anon_sym_BANG] = ACTIONS(7556),
    [anon_sym_PLUS] = ACTIONS(7554),
    [anon_sym_DASH] = ACTIONS(7556),
    [anon_sym_LT_DASH] = ACTIONS(7554),
    [anon_sym_LT_LT_DASH] = ACTIONS(7554),
    [anon_sym_COLON_EQ] = ACTIONS(7554),
    [anon_sym_DASH_GT] = ACTIONS(7556),
    [anon_sym_DASH_GT_GT] = ACTIONS(7554),
    [anon_sym_PIPE] = ACTIONS(7556),
    [anon_sym_AMP] = ACTIONS(7556),
    [anon_sym_PIPE_PIPE] = ACTIONS(7554),
    [anon_sym_AMP_AMP] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(7556),
    [anon_sym_LT_EQ] = ACTIONS(7554),
    [anon_sym_GT] = ACTIONS(7556),
    [anon_sym_GT_EQ] = ACTIONS(7554),
    [anon_sym_EQ_EQ] = ACTIONS(7554),
    [anon_sym_BANG_EQ] = ACTIONS(7554),
    [anon_sym_STAR] = ACTIONS(7556),
    [anon_sym_SLASH] = ACTIONS(7554),
    [anon_sym_STAR_STAR] = ACTIONS(7554),
    [anon_sym_CARET] = ACTIONS(7554),
    [aux_sym_binary_operator_token1] = ACTIONS(7554),
    [anon_sym_PIPE_GT] = ACTIONS(7554),
    [anon_sym_COLON] = ACTIONS(7556),
    [anon_sym_DOLLAR] = ACTIONS(7554),
    [anon_sym_AT] = ACTIONS(7554),
    [aux_sym__hex_literal_token1] = ACTIONS(7554),
    [sym__number_literal] = ACTIONS(7556),
    [anon_sym_SQUOTE] = ACTIONS(7554),
    [anon_sym_DQUOTE] = ACTIONS(7554),
    [sym_return] = ACTIONS(7556),
    [sym_next] = ACTIONS(7556),
    [sym_break] = ACTIONS(7556),
    [sym_true] = ACTIONS(7556),
    [sym_false] = ACTIONS(7556),
    [sym_null] = ACTIONS(7556),
    [sym_inf] = ACTIONS(7556),
    [sym_nan] = ACTIONS(7556),
    [anon_sym_NA] = ACTIONS(7556),
    [anon_sym_NA_integer_] = ACTIONS(7556),
    [anon_sym_NA_real_] = ACTIONS(7556),
    [anon_sym_NA_complex_] = ACTIONS(7556),
    [anon_sym_NA_character_] = ACTIONS(7556),
    [sym_dots] = ACTIONS(7556),
    [sym_dot_dot_i] = ACTIONS(7554),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7554),
    [sym__semicolon] = ACTIONS(7554),
    [sym__raw_string_literal] = ACTIONS(7554),
    [sym__external_else] = ACTIONS(7554),
    [sym__external_open_parenthesis] = ACTIONS(7554),
    [sym__external_open_brace] = ACTIONS(7554),
    [sym__external_close_brace] = ACTIONS(7554),
    [sym__external_open_bracket] = ACTIONS(7554),
    [sym__external_open_bracket2] = ACTIONS(7554),
  },
  [2675] = {
    [ts_builtin_sym_end] = ACTIONS(7472),
    [sym_identifier] = ACTIONS(7474),
    [anon_sym_BSLASH] = ACTIONS(7472),
    [anon_sym_function] = ACTIONS(7474),
    [anon_sym_EQ] = ACTIONS(7474),
    [anon_sym_if] = ACTIONS(7474),
    [anon_sym_for] = ACTIONS(7474),
    [anon_sym_while] = ACTIONS(7474),
    [anon_sym_repeat] = ACTIONS(7474),
    [anon_sym_QMARK] = ACTIONS(7472),
    [anon_sym_TILDE] = ACTIONS(7472),
    [anon_sym_BANG] = ACTIONS(7474),
    [anon_sym_PLUS] = ACTIONS(7472),
    [anon_sym_DASH] = ACTIONS(7474),
    [anon_sym_LT_DASH] = ACTIONS(7472),
    [anon_sym_LT_LT_DASH] = ACTIONS(7472),
    [anon_sym_COLON_EQ] = ACTIONS(7472),
    [anon_sym_DASH_GT] = ACTIONS(7474),
    [anon_sym_DASH_GT_GT] = ACTIONS(7472),
    [anon_sym_PIPE] = ACTIONS(7474),
    [anon_sym_AMP] = ACTIONS(7474),
    [anon_sym_PIPE_PIPE] = ACTIONS(7472),
    [anon_sym_AMP_AMP] = ACTIONS(7472),
    [anon_sym_LT] = ACTIONS(7474),
    [anon_sym_LT_EQ] = ACTIONS(7472),
    [anon_sym_GT] = ACTIONS(7474),
    [anon_sym_GT_EQ] = ACTIONS(7472),
    [anon_sym_EQ_EQ] = ACTIONS(7472),
    [anon_sym_BANG_EQ] = ACTIONS(7472),
    [anon_sym_STAR] = ACTIONS(7474),
    [anon_sym_SLASH] = ACTIONS(7472),
    [anon_sym_STAR_STAR] = ACTIONS(7472),
    [anon_sym_CARET] = ACTIONS(7472),
    [aux_sym_binary_operator_token1] = ACTIONS(7472),
    [anon_sym_PIPE_GT] = ACTIONS(7472),
    [anon_sym_COLON] = ACTIONS(7474),
    [anon_sym_DOLLAR] = ACTIONS(7472),
    [anon_sym_AT] = ACTIONS(7472),
    [aux_sym__hex_literal_token1] = ACTIONS(7472),
    [sym__number_literal] = ACTIONS(7474),
    [anon_sym_SQUOTE] = ACTIONS(7472),
    [anon_sym_DQUOTE] = ACTIONS(7472),
    [sym_return] = ACTIONS(7474),
    [sym_next] = ACTIONS(7474),
    [sym_break] = ACTIONS(7474),
    [sym_true] = ACTIONS(7474),
    [sym_false] = ACTIONS(7474),
    [sym_null] = ACTIONS(7474),
    [sym_inf] = ACTIONS(7474),
    [sym_nan] = ACTIONS(7474),
    [anon_sym_NA] = ACTIONS(7474),
    [anon_sym_NA_integer_] = ACTIONS(7474),
    [anon_sym_NA_real_] = ACTIONS(7474),
    [anon_sym_NA_complex_] = ACTIONS(7474),
    [anon_sym_NA_character_] = ACTIONS(7474),
    [sym_dots] = ACTIONS(7474),
    [sym_dot_dot_i] = ACTIONS(7472),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7472),
    [sym__semicolon] = ACTIONS(7472),
    [sym__raw_string_literal] = ACTIONS(7472),
    [sym__external_else] = ACTIONS(7472),
    [sym__external_open_parenthesis] = ACTIONS(7472),
    [sym__external_close_parenthesis] = ACTIONS(7472),
    [sym__external_open_brace] = ACTIONS(7472),
    [sym__external_open_bracket] = ACTIONS(7472),
    [sym__external_open_bracket2] = ACTIONS(7472),
  },
  [2676] = {
    [ts_builtin_sym_end] = ACTIONS(7466),
    [sym_identifier] = ACTIONS(7464),
    [anon_sym_BSLASH] = ACTIONS(7466),
    [anon_sym_function] = ACTIONS(7464),
    [anon_sym_EQ] = ACTIONS(7464),
    [anon_sym_if] = ACTIONS(7464),
    [anon_sym_for] = ACTIONS(7464),
    [anon_sym_while] = ACTIONS(7464),
    [anon_sym_repeat] = ACTIONS(7464),
    [anon_sym_QMARK] = ACTIONS(7466),
    [anon_sym_TILDE] = ACTIONS(7466),
    [anon_sym_BANG] = ACTIONS(7464),
    [anon_sym_PLUS] = ACTIONS(7466),
    [anon_sym_DASH] = ACTIONS(7464),
    [anon_sym_LT_DASH] = ACTIONS(7466),
    [anon_sym_LT_LT_DASH] = ACTIONS(7466),
    [anon_sym_COLON_EQ] = ACTIONS(7466),
    [anon_sym_DASH_GT] = ACTIONS(7464),
    [anon_sym_DASH_GT_GT] = ACTIONS(7466),
    [anon_sym_PIPE] = ACTIONS(7464),
    [anon_sym_AMP] = ACTIONS(7464),
    [anon_sym_PIPE_PIPE] = ACTIONS(7466),
    [anon_sym_AMP_AMP] = ACTIONS(7466),
    [anon_sym_LT] = ACTIONS(7464),
    [anon_sym_LT_EQ] = ACTIONS(7466),
    [anon_sym_GT] = ACTIONS(7464),
    [anon_sym_GT_EQ] = ACTIONS(7466),
    [anon_sym_EQ_EQ] = ACTIONS(7466),
    [anon_sym_BANG_EQ] = ACTIONS(7466),
    [anon_sym_STAR] = ACTIONS(7464),
    [anon_sym_SLASH] = ACTIONS(7466),
    [anon_sym_STAR_STAR] = ACTIONS(7466),
    [anon_sym_CARET] = ACTIONS(7466),
    [aux_sym_binary_operator_token1] = ACTIONS(7466),
    [anon_sym_PIPE_GT] = ACTIONS(7466),
    [anon_sym_COLON] = ACTIONS(7464),
    [anon_sym_DOLLAR] = ACTIONS(7466),
    [anon_sym_AT] = ACTIONS(7466),
    [aux_sym__hex_literal_token1] = ACTIONS(7466),
    [sym__number_literal] = ACTIONS(7464),
    [anon_sym_SQUOTE] = ACTIONS(7466),
    [anon_sym_DQUOTE] = ACTIONS(7466),
    [sym_return] = ACTIONS(7464),
    [sym_next] = ACTIONS(7464),
    [sym_break] = ACTIONS(7464),
    [sym_true] = ACTIONS(7464),
    [sym_false] = ACTIONS(7464),
    [sym_null] = ACTIONS(7464),
    [sym_inf] = ACTIONS(7464),
    [sym_nan] = ACTIONS(7464),
    [anon_sym_NA] = ACTIONS(7464),
    [anon_sym_NA_integer_] = ACTIONS(7464),
    [anon_sym_NA_real_] = ACTIONS(7464),
    [anon_sym_NA_complex_] = ACTIONS(7464),
    [anon_sym_NA_character_] = ACTIONS(7464),
    [sym_dots] = ACTIONS(7464),
    [sym_dot_dot_i] = ACTIONS(7466),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7466),
    [sym__semicolon] = ACTIONS(7466),
    [sym__raw_string_literal] = ACTIONS(7466),
    [sym__external_else] = ACTIONS(7466),
    [sym__external_open_parenthesis] = ACTIONS(7466),
    [sym__external_close_parenthesis] = ACTIONS(7466),
    [sym__external_open_brace] = ACTIONS(7466),
    [sym__external_open_bracket] = ACTIONS(7466),
    [sym__external_open_bracket2] = ACTIONS(7466),
  },
  [2677] = {
    [ts_builtin_sym_end] = ACTIONS(7476),
    [sym_identifier] = ACTIONS(7478),
    [anon_sym_BSLASH] = ACTIONS(7476),
    [anon_sym_function] = ACTIONS(7478),
    [anon_sym_EQ] = ACTIONS(7478),
    [anon_sym_if] = ACTIONS(7478),
    [anon_sym_for] = ACTIONS(7478),
    [anon_sym_while] = ACTIONS(7478),
    [anon_sym_repeat] = ACTIONS(7478),
    [anon_sym_QMARK] = ACTIONS(7476),
    [anon_sym_TILDE] = ACTIONS(7476),
    [anon_sym_BANG] = ACTIONS(7478),
    [anon_sym_PLUS] = ACTIONS(7476),
    [anon_sym_DASH] = ACTIONS(7478),
    [anon_sym_LT_DASH] = ACTIONS(7476),
    [anon_sym_LT_LT_DASH] = ACTIONS(7476),
    [anon_sym_COLON_EQ] = ACTIONS(7476),
    [anon_sym_DASH_GT] = ACTIONS(7478),
    [anon_sym_DASH_GT_GT] = ACTIONS(7476),
    [anon_sym_PIPE] = ACTIONS(7478),
    [anon_sym_AMP] = ACTIONS(7478),
    [anon_sym_PIPE_PIPE] = ACTIONS(7476),
    [anon_sym_AMP_AMP] = ACTIONS(7476),
    [anon_sym_LT] = ACTIONS(7478),
    [anon_sym_LT_EQ] = ACTIONS(7476),
    [anon_sym_GT] = ACTIONS(7478),
    [anon_sym_GT_EQ] = ACTIONS(7476),
    [anon_sym_EQ_EQ] = ACTIONS(7476),
    [anon_sym_BANG_EQ] = ACTIONS(7476),
    [anon_sym_STAR] = ACTIONS(7478),
    [anon_sym_SLASH] = ACTIONS(7476),
    [anon_sym_STAR_STAR] = ACTIONS(7476),
    [anon_sym_CARET] = ACTIONS(7476),
    [aux_sym_binary_operator_token1] = ACTIONS(7476),
    [anon_sym_PIPE_GT] = ACTIONS(7476),
    [anon_sym_COLON] = ACTIONS(7478),
    [anon_sym_DOLLAR] = ACTIONS(7476),
    [anon_sym_AT] = ACTIONS(7476),
    [aux_sym__hex_literal_token1] = ACTIONS(7476),
    [sym__number_literal] = ACTIONS(7478),
    [anon_sym_SQUOTE] = ACTIONS(7476),
    [anon_sym_DQUOTE] = ACTIONS(7476),
    [sym_return] = ACTIONS(7478),
    [sym_next] = ACTIONS(7478),
    [sym_break] = ACTIONS(7478),
    [sym_true] = ACTIONS(7478),
    [sym_false] = ACTIONS(7478),
    [sym_null] = ACTIONS(7478),
    [sym_inf] = ACTIONS(7478),
    [sym_nan] = ACTIONS(7478),
    [anon_sym_NA] = ACTIONS(7478),
    [anon_sym_NA_integer_] = ACTIONS(7478),
    [anon_sym_NA_real_] = ACTIONS(7478),
    [anon_sym_NA_complex_] = ACTIONS(7478),
    [anon_sym_NA_character_] = ACTIONS(7478),
    [sym_dots] = ACTIONS(7478),
    [sym_dot_dot_i] = ACTIONS(7476),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7476),
    [sym__semicolon] = ACTIONS(7476),
    [sym__raw_string_literal] = ACTIONS(7476),
    [sym__external_else] = ACTIONS(7476),
    [sym__external_open_parenthesis] = ACTIONS(7476),
    [sym__external_close_parenthesis] = ACTIONS(7476),
    [sym__external_open_brace] = ACTIONS(7476),
    [sym__external_open_bracket] = ACTIONS(7476),
    [sym__external_open_bracket2] = ACTIONS(7476),
  },
  [2678] = {
    [ts_builtin_sym_end] = ACTIONS(7530),
    [sym_identifier] = ACTIONS(7532),
    [anon_sym_BSLASH] = ACTIONS(7530),
    [anon_sym_function] = ACTIONS(7532),
    [anon_sym_EQ] = ACTIONS(7532),
    [anon_sym_if] = ACTIONS(7532),
    [anon_sym_for] = ACTIONS(7532),
    [anon_sym_while] = ACTIONS(7532),
    [anon_sym_repeat] = ACTIONS(7532),
    [anon_sym_QMARK] = ACTIONS(7530),
    [anon_sym_TILDE] = ACTIONS(7530),
    [anon_sym_BANG] = ACTIONS(7532),
    [anon_sym_PLUS] = ACTIONS(7530),
    [anon_sym_DASH] = ACTIONS(7532),
    [anon_sym_LT_DASH] = ACTIONS(7530),
    [anon_sym_LT_LT_DASH] = ACTIONS(7530),
    [anon_sym_COLON_EQ] = ACTIONS(7530),
    [anon_sym_DASH_GT] = ACTIONS(7532),
    [anon_sym_DASH_GT_GT] = ACTIONS(7530),
    [anon_sym_PIPE] = ACTIONS(7532),
    [anon_sym_AMP] = ACTIONS(7532),
    [anon_sym_PIPE_PIPE] = ACTIONS(7530),
    [anon_sym_AMP_AMP] = ACTIONS(7530),
    [anon_sym_LT] = ACTIONS(7532),
    [anon_sym_LT_EQ] = ACTIONS(7530),
    [anon_sym_GT] = ACTIONS(7532),
    [anon_sym_GT_EQ] = ACTIONS(7530),
    [anon_sym_EQ_EQ] = ACTIONS(7530),
    [anon_sym_BANG_EQ] = ACTIONS(7530),
    [anon_sym_STAR] = ACTIONS(7532),
    [anon_sym_SLASH] = ACTIONS(7530),
    [anon_sym_STAR_STAR] = ACTIONS(7530),
    [anon_sym_CARET] = ACTIONS(7530),
    [aux_sym_binary_operator_token1] = ACTIONS(7530),
    [anon_sym_PIPE_GT] = ACTIONS(7530),
    [anon_sym_COLON] = ACTIONS(7532),
    [anon_sym_DOLLAR] = ACTIONS(7530),
    [anon_sym_AT] = ACTIONS(7530),
    [aux_sym__hex_literal_token1] = ACTIONS(7530),
    [sym__number_literal] = ACTIONS(7532),
    [anon_sym_SQUOTE] = ACTIONS(7530),
    [anon_sym_DQUOTE] = ACTIONS(7530),
    [sym_return] = ACTIONS(7532),
    [sym_next] = ACTIONS(7532),
    [sym_break] = ACTIONS(7532),
    [sym_true] = ACTIONS(7532),
    [sym_false] = ACTIONS(7532),
    [sym_null] = ACTIONS(7532),
    [sym_inf] = ACTIONS(7532),
    [sym_nan] = ACTIONS(7532),
    [anon_sym_NA] = ACTIONS(7532),
    [anon_sym_NA_integer_] = ACTIONS(7532),
    [anon_sym_NA_real_] = ACTIONS(7532),
    [anon_sym_NA_complex_] = ACTIONS(7532),
    [anon_sym_NA_character_] = ACTIONS(7532),
    [sym_dots] = ACTIONS(7532),
    [sym_dot_dot_i] = ACTIONS(7530),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7530),
    [sym__semicolon] = ACTIONS(7530),
    [sym__raw_string_literal] = ACTIONS(7530),
    [sym__external_else] = ACTIONS(7530),
    [sym__external_open_parenthesis] = ACTIONS(7530),
    [sym__external_close_parenthesis] = ACTIONS(7530),
    [sym__external_open_brace] = ACTIONS(7530),
    [sym__external_open_bracket] = ACTIONS(7530),
    [sym__external_open_bracket2] = ACTIONS(7530),
  },
  [2679] = {
    [ts_builtin_sym_end] = ACTIONS(7526),
    [sym_identifier] = ACTIONS(7528),
    [anon_sym_BSLASH] = ACTIONS(7526),
    [anon_sym_function] = ACTIONS(7528),
    [anon_sym_EQ] = ACTIONS(7528),
    [anon_sym_if] = ACTIONS(7528),
    [anon_sym_for] = ACTIONS(7528),
    [anon_sym_while] = ACTIONS(7528),
    [anon_sym_repeat] = ACTIONS(7528),
    [anon_sym_QMARK] = ACTIONS(7526),
    [anon_sym_TILDE] = ACTIONS(7526),
    [anon_sym_BANG] = ACTIONS(7528),
    [anon_sym_PLUS] = ACTIONS(7526),
    [anon_sym_DASH] = ACTIONS(7528),
    [anon_sym_LT_DASH] = ACTIONS(7526),
    [anon_sym_LT_LT_DASH] = ACTIONS(7526),
    [anon_sym_COLON_EQ] = ACTIONS(7526),
    [anon_sym_DASH_GT] = ACTIONS(7528),
    [anon_sym_DASH_GT_GT] = ACTIONS(7526),
    [anon_sym_PIPE] = ACTIONS(7528),
    [anon_sym_AMP] = ACTIONS(7528),
    [anon_sym_PIPE_PIPE] = ACTIONS(7526),
    [anon_sym_AMP_AMP] = ACTIONS(7526),
    [anon_sym_LT] = ACTIONS(7528),
    [anon_sym_LT_EQ] = ACTIONS(7526),
    [anon_sym_GT] = ACTIONS(7528),
    [anon_sym_GT_EQ] = ACTIONS(7526),
    [anon_sym_EQ_EQ] = ACTIONS(7526),
    [anon_sym_BANG_EQ] = ACTIONS(7526),
    [anon_sym_STAR] = ACTIONS(7528),
    [anon_sym_SLASH] = ACTIONS(7526),
    [anon_sym_STAR_STAR] = ACTIONS(7526),
    [anon_sym_CARET] = ACTIONS(7526),
    [aux_sym_binary_operator_token1] = ACTIONS(7526),
    [anon_sym_PIPE_GT] = ACTIONS(7526),
    [anon_sym_COLON] = ACTIONS(7528),
    [anon_sym_DOLLAR] = ACTIONS(7526),
    [anon_sym_AT] = ACTIONS(7526),
    [aux_sym__hex_literal_token1] = ACTIONS(7526),
    [sym__number_literal] = ACTIONS(7528),
    [anon_sym_SQUOTE] = ACTIONS(7526),
    [anon_sym_DQUOTE] = ACTIONS(7526),
    [sym_return] = ACTIONS(7528),
    [sym_next] = ACTIONS(7528),
    [sym_break] = ACTIONS(7528),
    [sym_true] = ACTIONS(7528),
    [sym_false] = ACTIONS(7528),
    [sym_null] = ACTIONS(7528),
    [sym_inf] = ACTIONS(7528),
    [sym_nan] = ACTIONS(7528),
    [anon_sym_NA] = ACTIONS(7528),
    [anon_sym_NA_integer_] = ACTIONS(7528),
    [anon_sym_NA_real_] = ACTIONS(7528),
    [anon_sym_NA_complex_] = ACTIONS(7528),
    [anon_sym_NA_character_] = ACTIONS(7528),
    [sym_dots] = ACTIONS(7528),
    [sym_dot_dot_i] = ACTIONS(7526),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7526),
    [sym__semicolon] = ACTIONS(7526),
    [sym__raw_string_literal] = ACTIONS(7526),
    [sym__external_else] = ACTIONS(7526),
    [sym__external_open_parenthesis] = ACTIONS(7526),
    [sym__external_close_parenthesis] = ACTIONS(7526),
    [sym__external_open_brace] = ACTIONS(7526),
    [sym__external_open_bracket] = ACTIONS(7526),
    [sym__external_open_bracket2] = ACTIONS(7526),
  },
  [2680] = {
    [aux_sym_function_definition_repeat1] = STATE(2680),
    [ts_builtin_sym_end] = ACTIONS(7417),
    [sym_identifier] = ACTIONS(7419),
    [anon_sym_BSLASH] = ACTIONS(7417),
    [anon_sym_function] = ACTIONS(7419),
    [anon_sym_EQ] = ACTIONS(7419),
    [anon_sym_if] = ACTIONS(7419),
    [anon_sym_for] = ACTIONS(7419),
    [anon_sym_while] = ACTIONS(7419),
    [anon_sym_repeat] = ACTIONS(7419),
    [anon_sym_QMARK] = ACTIONS(7417),
    [anon_sym_TILDE] = ACTIONS(7417),
    [anon_sym_BANG] = ACTIONS(7419),
    [anon_sym_PLUS] = ACTIONS(7417),
    [anon_sym_DASH] = ACTIONS(7419),
    [anon_sym_LT_DASH] = ACTIONS(7417),
    [anon_sym_LT_LT_DASH] = ACTIONS(7417),
    [anon_sym_COLON_EQ] = ACTIONS(7417),
    [anon_sym_DASH_GT] = ACTIONS(7419),
    [anon_sym_DASH_GT_GT] = ACTIONS(7417),
    [anon_sym_PIPE] = ACTIONS(7419),
    [anon_sym_AMP] = ACTIONS(7419),
    [anon_sym_PIPE_PIPE] = ACTIONS(7417),
    [anon_sym_AMP_AMP] = ACTIONS(7417),
    [anon_sym_LT] = ACTIONS(7419),
    [anon_sym_LT_EQ] = ACTIONS(7417),
    [anon_sym_GT] = ACTIONS(7419),
    [anon_sym_GT_EQ] = ACTIONS(7417),
    [anon_sym_EQ_EQ] = ACTIONS(7417),
    [anon_sym_BANG_EQ] = ACTIONS(7417),
    [anon_sym_STAR] = ACTIONS(7419),
    [anon_sym_SLASH] = ACTIONS(7417),
    [anon_sym_STAR_STAR] = ACTIONS(7417),
    [anon_sym_CARET] = ACTIONS(7417),
    [aux_sym_binary_operator_token1] = ACTIONS(7417),
    [anon_sym_PIPE_GT] = ACTIONS(7417),
    [anon_sym_COLON] = ACTIONS(7419),
    [anon_sym_DOLLAR] = ACTIONS(7417),
    [anon_sym_AT] = ACTIONS(7417),
    [aux_sym__hex_literal_token1] = ACTIONS(7417),
    [sym__number_literal] = ACTIONS(7419),
    [anon_sym_SQUOTE] = ACTIONS(7417),
    [anon_sym_DQUOTE] = ACTIONS(7417),
    [sym_return] = ACTIONS(7419),
    [sym_next] = ACTIONS(7419),
    [sym_break] = ACTIONS(7419),
    [sym_true] = ACTIONS(7419),
    [sym_false] = ACTIONS(7419),
    [sym_null] = ACTIONS(7419),
    [sym_inf] = ACTIONS(7419),
    [sym_nan] = ACTIONS(7419),
    [anon_sym_NA] = ACTIONS(7419),
    [anon_sym_NA_integer_] = ACTIONS(7419),
    [anon_sym_NA_real_] = ACTIONS(7419),
    [anon_sym_NA_complex_] = ACTIONS(7419),
    [anon_sym_NA_character_] = ACTIONS(7419),
    [sym_dots] = ACTIONS(7419),
    [sym_dot_dot_i] = ACTIONS(7417),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7678),
    [sym__semicolon] = ACTIONS(7417),
    [sym__raw_string_literal] = ACTIONS(7417),
    [sym__external_open_parenthesis] = ACTIONS(7417),
    [sym__external_open_brace] = ACTIONS(7417),
    [sym__external_close_brace] = ACTIONS(7417),
    [sym__external_open_bracket] = ACTIONS(7417),
    [sym__external_open_bracket2] = ACTIONS(7417),
  },
  [2681] = {
    [sym_identifier] = ACTIONS(7482),
    [anon_sym_BSLASH] = ACTIONS(7480),
    [anon_sym_function] = ACTIONS(7482),
    [anon_sym_EQ] = ACTIONS(7482),
    [anon_sym_if] = ACTIONS(7482),
    [anon_sym_for] = ACTIONS(7482),
    [anon_sym_while] = ACTIONS(7482),
    [anon_sym_repeat] = ACTIONS(7482),
    [anon_sym_QMARK] = ACTIONS(7480),
    [anon_sym_TILDE] = ACTIONS(7480),
    [anon_sym_BANG] = ACTIONS(7482),
    [anon_sym_PLUS] = ACTIONS(7480),
    [anon_sym_DASH] = ACTIONS(7482),
    [anon_sym_LT_DASH] = ACTIONS(7480),
    [anon_sym_LT_LT_DASH] = ACTIONS(7480),
    [anon_sym_COLON_EQ] = ACTIONS(7480),
    [anon_sym_DASH_GT] = ACTIONS(7482),
    [anon_sym_DASH_GT_GT] = ACTIONS(7480),
    [anon_sym_PIPE] = ACTIONS(7482),
    [anon_sym_AMP] = ACTIONS(7482),
    [anon_sym_PIPE_PIPE] = ACTIONS(7480),
    [anon_sym_AMP_AMP] = ACTIONS(7480),
    [anon_sym_LT] = ACTIONS(7482),
    [anon_sym_LT_EQ] = ACTIONS(7480),
    [anon_sym_GT] = ACTIONS(7482),
    [anon_sym_GT_EQ] = ACTIONS(7480),
    [anon_sym_EQ_EQ] = ACTIONS(7480),
    [anon_sym_BANG_EQ] = ACTIONS(7480),
    [anon_sym_STAR] = ACTIONS(7482),
    [anon_sym_SLASH] = ACTIONS(7480),
    [anon_sym_STAR_STAR] = ACTIONS(7480),
    [anon_sym_CARET] = ACTIONS(7480),
    [aux_sym_binary_operator_token1] = ACTIONS(7480),
    [anon_sym_PIPE_GT] = ACTIONS(7480),
    [anon_sym_COLON] = ACTIONS(7482),
    [anon_sym_DOLLAR] = ACTIONS(7480),
    [anon_sym_AT] = ACTIONS(7480),
    [aux_sym__hex_literal_token1] = ACTIONS(7480),
    [sym__number_literal] = ACTIONS(7482),
    [anon_sym_SQUOTE] = ACTIONS(7480),
    [anon_sym_DQUOTE] = ACTIONS(7480),
    [sym_return] = ACTIONS(7482),
    [sym_next] = ACTIONS(7482),
    [sym_break] = ACTIONS(7482),
    [sym_true] = ACTIONS(7482),
    [sym_false] = ACTIONS(7482),
    [sym_null] = ACTIONS(7482),
    [sym_inf] = ACTIONS(7482),
    [sym_nan] = ACTIONS(7482),
    [anon_sym_NA] = ACTIONS(7482),
    [anon_sym_NA_integer_] = ACTIONS(7482),
    [anon_sym_NA_real_] = ACTIONS(7482),
    [anon_sym_NA_complex_] = ACTIONS(7482),
    [anon_sym_NA_character_] = ACTIONS(7482),
    [sym_dots] = ACTIONS(7482),
    [sym_dot_dot_i] = ACTIONS(7480),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7480),
    [sym__newline] = ACTIONS(7480),
    [sym__semicolon] = ACTIONS(7480),
    [sym__raw_string_literal] = ACTIONS(7480),
    [sym__external_open_parenthesis] = ACTIONS(7480),
    [sym__external_open_brace] = ACTIONS(7480),
    [sym__external_close_brace] = ACTIONS(7480),
    [sym__external_open_bracket] = ACTIONS(7480),
    [sym__external_open_bracket2] = ACTIONS(7480),
    [sym__external_close_bracket2] = ACTIONS(7480),
  },
  [2682] = {
    [sym_identifier] = ACTIONS(7191),
    [anon_sym_BSLASH] = ACTIONS(7189),
    [anon_sym_function] = ACTIONS(7191),
    [anon_sym_EQ] = ACTIONS(7191),
    [anon_sym_if] = ACTIONS(7191),
    [anon_sym_for] = ACTIONS(7191),
    [anon_sym_while] = ACTIONS(7191),
    [anon_sym_repeat] = ACTIONS(7191),
    [anon_sym_QMARK] = ACTIONS(7189),
    [anon_sym_TILDE] = ACTIONS(7189),
    [anon_sym_BANG] = ACTIONS(7191),
    [anon_sym_PLUS] = ACTIONS(7189),
    [anon_sym_DASH] = ACTIONS(7191),
    [anon_sym_LT_DASH] = ACTIONS(7189),
    [anon_sym_LT_LT_DASH] = ACTIONS(7189),
    [anon_sym_COLON_EQ] = ACTIONS(7189),
    [anon_sym_DASH_GT] = ACTIONS(7191),
    [anon_sym_DASH_GT_GT] = ACTIONS(7189),
    [anon_sym_PIPE] = ACTIONS(7191),
    [anon_sym_AMP] = ACTIONS(7191),
    [anon_sym_PIPE_PIPE] = ACTIONS(7189),
    [anon_sym_AMP_AMP] = ACTIONS(7189),
    [anon_sym_LT] = ACTIONS(7191),
    [anon_sym_LT_EQ] = ACTIONS(7189),
    [anon_sym_GT] = ACTIONS(7191),
    [anon_sym_GT_EQ] = ACTIONS(7189),
    [anon_sym_EQ_EQ] = ACTIONS(7189),
    [anon_sym_BANG_EQ] = ACTIONS(7189),
    [anon_sym_STAR] = ACTIONS(7191),
    [anon_sym_SLASH] = ACTIONS(7189),
    [anon_sym_STAR_STAR] = ACTIONS(7189),
    [anon_sym_CARET] = ACTIONS(7189),
    [aux_sym_binary_operator_token1] = ACTIONS(7189),
    [anon_sym_PIPE_GT] = ACTIONS(7189),
    [anon_sym_COLON] = ACTIONS(7191),
    [anon_sym_DOLLAR] = ACTIONS(7189),
    [anon_sym_AT] = ACTIONS(7189),
    [anon_sym_COLON_COLON] = ACTIONS(7191),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7189),
    [aux_sym__hex_literal_token1] = ACTIONS(7189),
    [sym__number_literal] = ACTIONS(7191),
    [anon_sym_SQUOTE] = ACTIONS(7189),
    [anon_sym_DQUOTE] = ACTIONS(7189),
    [sym_return] = ACTIONS(7191),
    [sym_next] = ACTIONS(7191),
    [sym_break] = ACTIONS(7191),
    [sym_true] = ACTIONS(7191),
    [sym_false] = ACTIONS(7191),
    [sym_null] = ACTIONS(7191),
    [sym_inf] = ACTIONS(7191),
    [sym_nan] = ACTIONS(7191),
    [anon_sym_NA] = ACTIONS(7191),
    [anon_sym_NA_integer_] = ACTIONS(7191),
    [anon_sym_NA_real_] = ACTIONS(7191),
    [anon_sym_NA_complex_] = ACTIONS(7191),
    [anon_sym_NA_character_] = ACTIONS(7191),
    [sym_dots] = ACTIONS(7191),
    [sym_dot_dot_i] = ACTIONS(7189),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7189),
    [sym__newline] = ACTIONS(7189),
    [sym__raw_string_literal] = ACTIONS(7189),
    [sym__external_open_parenthesis] = ACTIONS(7189),
    [sym__external_close_parenthesis] = ACTIONS(7189),
    [sym__external_open_brace] = ACTIONS(7189),
    [sym__external_open_bracket] = ACTIONS(7189),
    [sym__external_open_bracket2] = ACTIONS(7189),
  },
  [2683] = {
    [ts_builtin_sym_end] = ACTIONS(7522),
    [sym_identifier] = ACTIONS(7524),
    [anon_sym_BSLASH] = ACTIONS(7522),
    [anon_sym_function] = ACTIONS(7524),
    [anon_sym_EQ] = ACTIONS(7524),
    [anon_sym_if] = ACTIONS(7524),
    [anon_sym_for] = ACTIONS(7524),
    [anon_sym_while] = ACTIONS(7524),
    [anon_sym_repeat] = ACTIONS(7524),
    [anon_sym_QMARK] = ACTIONS(7522),
    [anon_sym_TILDE] = ACTIONS(7522),
    [anon_sym_BANG] = ACTIONS(7524),
    [anon_sym_PLUS] = ACTIONS(7522),
    [anon_sym_DASH] = ACTIONS(7524),
    [anon_sym_LT_DASH] = ACTIONS(7522),
    [anon_sym_LT_LT_DASH] = ACTIONS(7522),
    [anon_sym_COLON_EQ] = ACTIONS(7522),
    [anon_sym_DASH_GT] = ACTIONS(7524),
    [anon_sym_DASH_GT_GT] = ACTIONS(7522),
    [anon_sym_PIPE] = ACTIONS(7524),
    [anon_sym_AMP] = ACTIONS(7524),
    [anon_sym_PIPE_PIPE] = ACTIONS(7522),
    [anon_sym_AMP_AMP] = ACTIONS(7522),
    [anon_sym_LT] = ACTIONS(7524),
    [anon_sym_LT_EQ] = ACTIONS(7522),
    [anon_sym_GT] = ACTIONS(7524),
    [anon_sym_GT_EQ] = ACTIONS(7522),
    [anon_sym_EQ_EQ] = ACTIONS(7522),
    [anon_sym_BANG_EQ] = ACTIONS(7522),
    [anon_sym_STAR] = ACTIONS(7524),
    [anon_sym_SLASH] = ACTIONS(7522),
    [anon_sym_STAR_STAR] = ACTIONS(7522),
    [anon_sym_CARET] = ACTIONS(7522),
    [aux_sym_binary_operator_token1] = ACTIONS(7522),
    [anon_sym_PIPE_GT] = ACTIONS(7522),
    [anon_sym_COLON] = ACTIONS(7524),
    [anon_sym_DOLLAR] = ACTIONS(7522),
    [anon_sym_AT] = ACTIONS(7522),
    [aux_sym__hex_literal_token1] = ACTIONS(7522),
    [sym__number_literal] = ACTIONS(7524),
    [anon_sym_SQUOTE] = ACTIONS(7522),
    [anon_sym_DQUOTE] = ACTIONS(7522),
    [sym_return] = ACTIONS(7524),
    [sym_next] = ACTIONS(7524),
    [sym_break] = ACTIONS(7524),
    [sym_true] = ACTIONS(7524),
    [sym_false] = ACTIONS(7524),
    [sym_null] = ACTIONS(7524),
    [sym_inf] = ACTIONS(7524),
    [sym_nan] = ACTIONS(7524),
    [anon_sym_NA] = ACTIONS(7524),
    [anon_sym_NA_integer_] = ACTIONS(7524),
    [anon_sym_NA_real_] = ACTIONS(7524),
    [anon_sym_NA_complex_] = ACTIONS(7524),
    [anon_sym_NA_character_] = ACTIONS(7524),
    [sym_dots] = ACTIONS(7524),
    [sym_dot_dot_i] = ACTIONS(7522),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7522),
    [sym__semicolon] = ACTIONS(7522),
    [sym__raw_string_literal] = ACTIONS(7522),
    [sym__external_else] = ACTIONS(7522),
    [sym__external_open_parenthesis] = ACTIONS(7522),
    [sym__external_close_parenthesis] = ACTIONS(7522),
    [sym__external_open_brace] = ACTIONS(7522),
    [sym__external_open_bracket] = ACTIONS(7522),
    [sym__external_open_bracket2] = ACTIONS(7522),
  },
  [2684] = {
    [ts_builtin_sym_end] = ACTIONS(7518),
    [sym_identifier] = ACTIONS(7520),
    [anon_sym_BSLASH] = ACTIONS(7518),
    [anon_sym_function] = ACTIONS(7520),
    [anon_sym_EQ] = ACTIONS(7520),
    [anon_sym_if] = ACTIONS(7520),
    [anon_sym_for] = ACTIONS(7520),
    [anon_sym_while] = ACTIONS(7520),
    [anon_sym_repeat] = ACTIONS(7520),
    [anon_sym_QMARK] = ACTIONS(7518),
    [anon_sym_TILDE] = ACTIONS(7518),
    [anon_sym_BANG] = ACTIONS(7520),
    [anon_sym_PLUS] = ACTIONS(7518),
    [anon_sym_DASH] = ACTIONS(7520),
    [anon_sym_LT_DASH] = ACTIONS(7518),
    [anon_sym_LT_LT_DASH] = ACTIONS(7518),
    [anon_sym_COLON_EQ] = ACTIONS(7518),
    [anon_sym_DASH_GT] = ACTIONS(7520),
    [anon_sym_DASH_GT_GT] = ACTIONS(7518),
    [anon_sym_PIPE] = ACTIONS(7520),
    [anon_sym_AMP] = ACTIONS(7520),
    [anon_sym_PIPE_PIPE] = ACTIONS(7518),
    [anon_sym_AMP_AMP] = ACTIONS(7518),
    [anon_sym_LT] = ACTIONS(7520),
    [anon_sym_LT_EQ] = ACTIONS(7518),
    [anon_sym_GT] = ACTIONS(7520),
    [anon_sym_GT_EQ] = ACTIONS(7518),
    [anon_sym_EQ_EQ] = ACTIONS(7518),
    [anon_sym_BANG_EQ] = ACTIONS(7518),
    [anon_sym_STAR] = ACTIONS(7520),
    [anon_sym_SLASH] = ACTIONS(7518),
    [anon_sym_STAR_STAR] = ACTIONS(7518),
    [anon_sym_CARET] = ACTIONS(7518),
    [aux_sym_binary_operator_token1] = ACTIONS(7518),
    [anon_sym_PIPE_GT] = ACTIONS(7518),
    [anon_sym_COLON] = ACTIONS(7520),
    [anon_sym_DOLLAR] = ACTIONS(7518),
    [anon_sym_AT] = ACTIONS(7518),
    [aux_sym__hex_literal_token1] = ACTIONS(7518),
    [sym__number_literal] = ACTIONS(7520),
    [anon_sym_SQUOTE] = ACTIONS(7518),
    [anon_sym_DQUOTE] = ACTIONS(7518),
    [sym_return] = ACTIONS(7520),
    [sym_next] = ACTIONS(7520),
    [sym_break] = ACTIONS(7520),
    [sym_true] = ACTIONS(7520),
    [sym_false] = ACTIONS(7520),
    [sym_null] = ACTIONS(7520),
    [sym_inf] = ACTIONS(7520),
    [sym_nan] = ACTIONS(7520),
    [anon_sym_NA] = ACTIONS(7520),
    [anon_sym_NA_integer_] = ACTIONS(7520),
    [anon_sym_NA_real_] = ACTIONS(7520),
    [anon_sym_NA_complex_] = ACTIONS(7520),
    [anon_sym_NA_character_] = ACTIONS(7520),
    [sym_dots] = ACTIONS(7520),
    [sym_dot_dot_i] = ACTIONS(7518),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7518),
    [sym__semicolon] = ACTIONS(7518),
    [sym__raw_string_literal] = ACTIONS(7518),
    [sym__external_else] = ACTIONS(7518),
    [sym__external_open_parenthesis] = ACTIONS(7518),
    [sym__external_close_parenthesis] = ACTIONS(7518),
    [sym__external_open_brace] = ACTIONS(7518),
    [sym__external_open_bracket] = ACTIONS(7518),
    [sym__external_open_bracket2] = ACTIONS(7518),
  },
  [2685] = {
    [ts_builtin_sym_end] = ACTIONS(7514),
    [sym_identifier] = ACTIONS(7516),
    [anon_sym_BSLASH] = ACTIONS(7514),
    [anon_sym_function] = ACTIONS(7516),
    [anon_sym_EQ] = ACTIONS(7516),
    [anon_sym_if] = ACTIONS(7516),
    [anon_sym_for] = ACTIONS(7516),
    [anon_sym_while] = ACTIONS(7516),
    [anon_sym_repeat] = ACTIONS(7516),
    [anon_sym_QMARK] = ACTIONS(7514),
    [anon_sym_TILDE] = ACTIONS(7514),
    [anon_sym_BANG] = ACTIONS(7516),
    [anon_sym_PLUS] = ACTIONS(7514),
    [anon_sym_DASH] = ACTIONS(7516),
    [anon_sym_LT_DASH] = ACTIONS(7514),
    [anon_sym_LT_LT_DASH] = ACTIONS(7514),
    [anon_sym_COLON_EQ] = ACTIONS(7514),
    [anon_sym_DASH_GT] = ACTIONS(7516),
    [anon_sym_DASH_GT_GT] = ACTIONS(7514),
    [anon_sym_PIPE] = ACTIONS(7516),
    [anon_sym_AMP] = ACTIONS(7516),
    [anon_sym_PIPE_PIPE] = ACTIONS(7514),
    [anon_sym_AMP_AMP] = ACTIONS(7514),
    [anon_sym_LT] = ACTIONS(7516),
    [anon_sym_LT_EQ] = ACTIONS(7514),
    [anon_sym_GT] = ACTIONS(7516),
    [anon_sym_GT_EQ] = ACTIONS(7514),
    [anon_sym_EQ_EQ] = ACTIONS(7514),
    [anon_sym_BANG_EQ] = ACTIONS(7514),
    [anon_sym_STAR] = ACTIONS(7516),
    [anon_sym_SLASH] = ACTIONS(7514),
    [anon_sym_STAR_STAR] = ACTIONS(7514),
    [anon_sym_CARET] = ACTIONS(7514),
    [aux_sym_binary_operator_token1] = ACTIONS(7514),
    [anon_sym_PIPE_GT] = ACTIONS(7514),
    [anon_sym_COLON] = ACTIONS(7516),
    [anon_sym_DOLLAR] = ACTIONS(7514),
    [anon_sym_AT] = ACTIONS(7514),
    [aux_sym__hex_literal_token1] = ACTIONS(7514),
    [sym__number_literal] = ACTIONS(7516),
    [anon_sym_SQUOTE] = ACTIONS(7514),
    [anon_sym_DQUOTE] = ACTIONS(7514),
    [sym_return] = ACTIONS(7516),
    [sym_next] = ACTIONS(7516),
    [sym_break] = ACTIONS(7516),
    [sym_true] = ACTIONS(7516),
    [sym_false] = ACTIONS(7516),
    [sym_null] = ACTIONS(7516),
    [sym_inf] = ACTIONS(7516),
    [sym_nan] = ACTIONS(7516),
    [anon_sym_NA] = ACTIONS(7516),
    [anon_sym_NA_integer_] = ACTIONS(7516),
    [anon_sym_NA_real_] = ACTIONS(7516),
    [anon_sym_NA_complex_] = ACTIONS(7516),
    [anon_sym_NA_character_] = ACTIONS(7516),
    [sym_dots] = ACTIONS(7516),
    [sym_dot_dot_i] = ACTIONS(7514),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7514),
    [sym__semicolon] = ACTIONS(7514),
    [sym__raw_string_literal] = ACTIONS(7514),
    [sym__external_else] = ACTIONS(7514),
    [sym__external_open_parenthesis] = ACTIONS(7514),
    [sym__external_close_parenthesis] = ACTIONS(7514),
    [sym__external_open_brace] = ACTIONS(7514),
    [sym__external_open_bracket] = ACTIONS(7514),
    [sym__external_open_bracket2] = ACTIONS(7514),
  },
  [2686] = {
    [sym_identifier] = ACTIONS(7540),
    [anon_sym_BSLASH] = ACTIONS(7538),
    [anon_sym_function] = ACTIONS(7540),
    [anon_sym_EQ] = ACTIONS(7540),
    [anon_sym_if] = ACTIONS(7540),
    [anon_sym_for] = ACTIONS(7540),
    [anon_sym_while] = ACTIONS(7540),
    [anon_sym_repeat] = ACTIONS(7540),
    [anon_sym_QMARK] = ACTIONS(7538),
    [anon_sym_TILDE] = ACTIONS(7538),
    [anon_sym_BANG] = ACTIONS(7540),
    [anon_sym_PLUS] = ACTIONS(7538),
    [anon_sym_DASH] = ACTIONS(7540),
    [anon_sym_LT_DASH] = ACTIONS(7538),
    [anon_sym_LT_LT_DASH] = ACTIONS(7538),
    [anon_sym_COLON_EQ] = ACTIONS(7538),
    [anon_sym_DASH_GT] = ACTIONS(7540),
    [anon_sym_DASH_GT_GT] = ACTIONS(7538),
    [anon_sym_PIPE] = ACTIONS(7540),
    [anon_sym_AMP] = ACTIONS(7540),
    [anon_sym_PIPE_PIPE] = ACTIONS(7538),
    [anon_sym_AMP_AMP] = ACTIONS(7538),
    [anon_sym_LT] = ACTIONS(7540),
    [anon_sym_LT_EQ] = ACTIONS(7538),
    [anon_sym_GT] = ACTIONS(7540),
    [anon_sym_GT_EQ] = ACTIONS(7538),
    [anon_sym_EQ_EQ] = ACTIONS(7538),
    [anon_sym_BANG_EQ] = ACTIONS(7538),
    [anon_sym_STAR] = ACTIONS(7540),
    [anon_sym_SLASH] = ACTIONS(7538),
    [anon_sym_STAR_STAR] = ACTIONS(7538),
    [anon_sym_CARET] = ACTIONS(7538),
    [aux_sym_binary_operator_token1] = ACTIONS(7538),
    [anon_sym_PIPE_GT] = ACTIONS(7538),
    [anon_sym_COLON] = ACTIONS(7540),
    [anon_sym_DOLLAR] = ACTIONS(7538),
    [anon_sym_AT] = ACTIONS(7538),
    [aux_sym__hex_literal_token1] = ACTIONS(7538),
    [sym__number_literal] = ACTIONS(7540),
    [anon_sym_SQUOTE] = ACTIONS(7538),
    [anon_sym_DQUOTE] = ACTIONS(7538),
    [sym_return] = ACTIONS(7540),
    [sym_next] = ACTIONS(7540),
    [sym_break] = ACTIONS(7540),
    [sym_true] = ACTIONS(7540),
    [sym_false] = ACTIONS(7540),
    [sym_null] = ACTIONS(7540),
    [sym_inf] = ACTIONS(7540),
    [sym_nan] = ACTIONS(7540),
    [anon_sym_NA] = ACTIONS(7540),
    [anon_sym_NA_integer_] = ACTIONS(7540),
    [anon_sym_NA_real_] = ACTIONS(7540),
    [anon_sym_NA_complex_] = ACTIONS(7540),
    [anon_sym_NA_character_] = ACTIONS(7540),
    [sym_dots] = ACTIONS(7540),
    [sym_dot_dot_i] = ACTIONS(7538),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7538),
    [sym__newline] = ACTIONS(7538),
    [sym__semicolon] = ACTIONS(7538),
    [sym__raw_string_literal] = ACTIONS(7538),
    [sym__external_open_parenthesis] = ACTIONS(7538),
    [sym__external_open_brace] = ACTIONS(7538),
    [sym__external_close_brace] = ACTIONS(7538),
    [sym__external_open_bracket] = ACTIONS(7538),
    [sym__external_close_bracket] = ACTIONS(7538),
    [sym__external_open_bracket2] = ACTIONS(7538),
  },
  [2687] = {
    [sym_identifier] = ACTIONS(7544),
    [anon_sym_BSLASH] = ACTIONS(7542),
    [anon_sym_function] = ACTIONS(7544),
    [anon_sym_EQ] = ACTIONS(7544),
    [anon_sym_if] = ACTIONS(7544),
    [anon_sym_for] = ACTIONS(7544),
    [anon_sym_while] = ACTIONS(7544),
    [anon_sym_repeat] = ACTIONS(7544),
    [anon_sym_QMARK] = ACTIONS(7542),
    [anon_sym_TILDE] = ACTIONS(7542),
    [anon_sym_BANG] = ACTIONS(7544),
    [anon_sym_PLUS] = ACTIONS(7542),
    [anon_sym_DASH] = ACTIONS(7544),
    [anon_sym_LT_DASH] = ACTIONS(7542),
    [anon_sym_LT_LT_DASH] = ACTIONS(7542),
    [anon_sym_COLON_EQ] = ACTIONS(7542),
    [anon_sym_DASH_GT] = ACTIONS(7544),
    [anon_sym_DASH_GT_GT] = ACTIONS(7542),
    [anon_sym_PIPE] = ACTIONS(7544),
    [anon_sym_AMP] = ACTIONS(7544),
    [anon_sym_PIPE_PIPE] = ACTIONS(7542),
    [anon_sym_AMP_AMP] = ACTIONS(7542),
    [anon_sym_LT] = ACTIONS(7544),
    [anon_sym_LT_EQ] = ACTIONS(7542),
    [anon_sym_GT] = ACTIONS(7544),
    [anon_sym_GT_EQ] = ACTIONS(7542),
    [anon_sym_EQ_EQ] = ACTIONS(7542),
    [anon_sym_BANG_EQ] = ACTIONS(7542),
    [anon_sym_STAR] = ACTIONS(7544),
    [anon_sym_SLASH] = ACTIONS(7542),
    [anon_sym_STAR_STAR] = ACTIONS(7542),
    [anon_sym_CARET] = ACTIONS(7542),
    [aux_sym_binary_operator_token1] = ACTIONS(7542),
    [anon_sym_PIPE_GT] = ACTIONS(7542),
    [anon_sym_COLON] = ACTIONS(7544),
    [anon_sym_DOLLAR] = ACTIONS(7542),
    [anon_sym_AT] = ACTIONS(7542),
    [aux_sym__hex_literal_token1] = ACTIONS(7542),
    [sym__number_literal] = ACTIONS(7544),
    [anon_sym_SQUOTE] = ACTIONS(7542),
    [anon_sym_DQUOTE] = ACTIONS(7542),
    [sym_return] = ACTIONS(7544),
    [sym_next] = ACTIONS(7544),
    [sym_break] = ACTIONS(7544),
    [sym_true] = ACTIONS(7544),
    [sym_false] = ACTIONS(7544),
    [sym_null] = ACTIONS(7544),
    [sym_inf] = ACTIONS(7544),
    [sym_nan] = ACTIONS(7544),
    [anon_sym_NA] = ACTIONS(7544),
    [anon_sym_NA_integer_] = ACTIONS(7544),
    [anon_sym_NA_real_] = ACTIONS(7544),
    [anon_sym_NA_complex_] = ACTIONS(7544),
    [anon_sym_NA_character_] = ACTIONS(7544),
    [sym_dots] = ACTIONS(7544),
    [sym_dot_dot_i] = ACTIONS(7542),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7542),
    [sym__newline] = ACTIONS(7542),
    [sym__semicolon] = ACTIONS(7542),
    [sym__raw_string_literal] = ACTIONS(7542),
    [sym__external_open_parenthesis] = ACTIONS(7542),
    [sym__external_open_brace] = ACTIONS(7542),
    [sym__external_close_brace] = ACTIONS(7542),
    [sym__external_open_bracket] = ACTIONS(7542),
    [sym__external_close_bracket] = ACTIONS(7542),
    [sym__external_open_bracket2] = ACTIONS(7542),
  },
  [2688] = {
    [sym_identifier] = ACTIONS(7195),
    [anon_sym_BSLASH] = ACTIONS(7193),
    [anon_sym_function] = ACTIONS(7195),
    [anon_sym_EQ] = ACTIONS(7195),
    [anon_sym_if] = ACTIONS(7195),
    [anon_sym_for] = ACTIONS(7195),
    [anon_sym_while] = ACTIONS(7195),
    [anon_sym_repeat] = ACTIONS(7195),
    [anon_sym_QMARK] = ACTIONS(7193),
    [anon_sym_TILDE] = ACTIONS(7193),
    [anon_sym_BANG] = ACTIONS(7195),
    [anon_sym_PLUS] = ACTIONS(7193),
    [anon_sym_DASH] = ACTIONS(7195),
    [anon_sym_LT_DASH] = ACTIONS(7193),
    [anon_sym_LT_LT_DASH] = ACTIONS(7193),
    [anon_sym_COLON_EQ] = ACTIONS(7193),
    [anon_sym_DASH_GT] = ACTIONS(7195),
    [anon_sym_DASH_GT_GT] = ACTIONS(7193),
    [anon_sym_PIPE] = ACTIONS(7195),
    [anon_sym_AMP] = ACTIONS(7195),
    [anon_sym_PIPE_PIPE] = ACTIONS(7193),
    [anon_sym_AMP_AMP] = ACTIONS(7193),
    [anon_sym_LT] = ACTIONS(7195),
    [anon_sym_LT_EQ] = ACTIONS(7193),
    [anon_sym_GT] = ACTIONS(7195),
    [anon_sym_GT_EQ] = ACTIONS(7193),
    [anon_sym_EQ_EQ] = ACTIONS(7193),
    [anon_sym_BANG_EQ] = ACTIONS(7193),
    [anon_sym_STAR] = ACTIONS(7195),
    [anon_sym_SLASH] = ACTIONS(7193),
    [anon_sym_STAR_STAR] = ACTIONS(7193),
    [anon_sym_CARET] = ACTIONS(7193),
    [aux_sym_binary_operator_token1] = ACTIONS(7193),
    [anon_sym_PIPE_GT] = ACTIONS(7193),
    [anon_sym_COLON] = ACTIONS(7195),
    [anon_sym_DOLLAR] = ACTIONS(7193),
    [anon_sym_AT] = ACTIONS(7193),
    [anon_sym_COLON_COLON] = ACTIONS(7195),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7193),
    [aux_sym__hex_literal_token1] = ACTIONS(7193),
    [sym__number_literal] = ACTIONS(7195),
    [anon_sym_SQUOTE] = ACTIONS(7193),
    [anon_sym_DQUOTE] = ACTIONS(7193),
    [sym_return] = ACTIONS(7195),
    [sym_next] = ACTIONS(7195),
    [sym_break] = ACTIONS(7195),
    [sym_true] = ACTIONS(7195),
    [sym_false] = ACTIONS(7195),
    [sym_null] = ACTIONS(7195),
    [sym_inf] = ACTIONS(7195),
    [sym_nan] = ACTIONS(7195),
    [anon_sym_NA] = ACTIONS(7195),
    [anon_sym_NA_integer_] = ACTIONS(7195),
    [anon_sym_NA_real_] = ACTIONS(7195),
    [anon_sym_NA_complex_] = ACTIONS(7195),
    [anon_sym_NA_character_] = ACTIONS(7195),
    [sym_dots] = ACTIONS(7195),
    [sym_dot_dot_i] = ACTIONS(7193),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7193),
    [sym__newline] = ACTIONS(7193),
    [sym__raw_string_literal] = ACTIONS(7193),
    [sym__external_open_parenthesis] = ACTIONS(7193),
    [sym__external_close_parenthesis] = ACTIONS(7193),
    [sym__external_open_brace] = ACTIONS(7193),
    [sym__external_open_bracket] = ACTIONS(7193),
    [sym__external_open_bracket2] = ACTIONS(7193),
  },
  [2689] = {
    [ts_builtin_sym_end] = ACTIONS(7565),
    [sym_identifier] = ACTIONS(7567),
    [anon_sym_BSLASH] = ACTIONS(7565),
    [anon_sym_function] = ACTIONS(7567),
    [anon_sym_EQ] = ACTIONS(7567),
    [anon_sym_if] = ACTIONS(7567),
    [anon_sym_for] = ACTIONS(7567),
    [anon_sym_while] = ACTIONS(7567),
    [anon_sym_repeat] = ACTIONS(7567),
    [anon_sym_QMARK] = ACTIONS(7565),
    [anon_sym_TILDE] = ACTIONS(7565),
    [anon_sym_BANG] = ACTIONS(7567),
    [anon_sym_PLUS] = ACTIONS(7565),
    [anon_sym_DASH] = ACTIONS(7567),
    [anon_sym_LT_DASH] = ACTIONS(7565),
    [anon_sym_LT_LT_DASH] = ACTIONS(7565),
    [anon_sym_COLON_EQ] = ACTIONS(7565),
    [anon_sym_DASH_GT] = ACTIONS(7567),
    [anon_sym_DASH_GT_GT] = ACTIONS(7565),
    [anon_sym_PIPE] = ACTIONS(7567),
    [anon_sym_AMP] = ACTIONS(7567),
    [anon_sym_PIPE_PIPE] = ACTIONS(7565),
    [anon_sym_AMP_AMP] = ACTIONS(7565),
    [anon_sym_LT] = ACTIONS(7567),
    [anon_sym_LT_EQ] = ACTIONS(7565),
    [anon_sym_GT] = ACTIONS(7567),
    [anon_sym_GT_EQ] = ACTIONS(7565),
    [anon_sym_EQ_EQ] = ACTIONS(7565),
    [anon_sym_BANG_EQ] = ACTIONS(7565),
    [anon_sym_STAR] = ACTIONS(7567),
    [anon_sym_SLASH] = ACTIONS(7565),
    [anon_sym_STAR_STAR] = ACTIONS(7565),
    [anon_sym_CARET] = ACTIONS(7565),
    [aux_sym_binary_operator_token1] = ACTIONS(7565),
    [anon_sym_PIPE_GT] = ACTIONS(7565),
    [anon_sym_COLON] = ACTIONS(7567),
    [anon_sym_DOLLAR] = ACTIONS(7565),
    [anon_sym_AT] = ACTIONS(7565),
    [aux_sym__hex_literal_token1] = ACTIONS(7565),
    [sym__number_literal] = ACTIONS(7567),
    [anon_sym_SQUOTE] = ACTIONS(7565),
    [anon_sym_DQUOTE] = ACTIONS(7565),
    [sym_return] = ACTIONS(7567),
    [sym_next] = ACTIONS(7567),
    [sym_break] = ACTIONS(7567),
    [sym_true] = ACTIONS(7567),
    [sym_false] = ACTIONS(7567),
    [sym_null] = ACTIONS(7567),
    [sym_inf] = ACTIONS(7567),
    [sym_nan] = ACTIONS(7567),
    [anon_sym_NA] = ACTIONS(7567),
    [anon_sym_NA_integer_] = ACTIONS(7567),
    [anon_sym_NA_real_] = ACTIONS(7567),
    [anon_sym_NA_complex_] = ACTIONS(7567),
    [anon_sym_NA_character_] = ACTIONS(7567),
    [sym_dots] = ACTIONS(7567),
    [sym_dot_dot_i] = ACTIONS(7565),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7565),
    [sym__semicolon] = ACTIONS(7565),
    [sym__raw_string_literal] = ACTIONS(7565),
    [sym__external_else] = ACTIONS(7565),
    [sym__external_open_parenthesis] = ACTIONS(7565),
    [sym__external_open_brace] = ACTIONS(7565),
    [sym__external_close_brace] = ACTIONS(7565),
    [sym__external_open_bracket] = ACTIONS(7565),
    [sym__external_open_bracket2] = ACTIONS(7565),
  },
  [2690] = {
    [sym_identifier] = ACTIONS(7552),
    [anon_sym_BSLASH] = ACTIONS(7550),
    [anon_sym_function] = ACTIONS(7552),
    [anon_sym_EQ] = ACTIONS(7552),
    [anon_sym_if] = ACTIONS(7552),
    [anon_sym_for] = ACTIONS(7552),
    [anon_sym_while] = ACTIONS(7552),
    [anon_sym_repeat] = ACTIONS(7552),
    [anon_sym_QMARK] = ACTIONS(7550),
    [anon_sym_TILDE] = ACTIONS(7550),
    [anon_sym_BANG] = ACTIONS(7552),
    [anon_sym_PLUS] = ACTIONS(7550),
    [anon_sym_DASH] = ACTIONS(7552),
    [anon_sym_LT_DASH] = ACTIONS(7550),
    [anon_sym_LT_LT_DASH] = ACTIONS(7550),
    [anon_sym_COLON_EQ] = ACTIONS(7550),
    [anon_sym_DASH_GT] = ACTIONS(7552),
    [anon_sym_DASH_GT_GT] = ACTIONS(7550),
    [anon_sym_PIPE] = ACTIONS(7552),
    [anon_sym_AMP] = ACTIONS(7552),
    [anon_sym_PIPE_PIPE] = ACTIONS(7550),
    [anon_sym_AMP_AMP] = ACTIONS(7550),
    [anon_sym_LT] = ACTIONS(7552),
    [anon_sym_LT_EQ] = ACTIONS(7550),
    [anon_sym_GT] = ACTIONS(7552),
    [anon_sym_GT_EQ] = ACTIONS(7550),
    [anon_sym_EQ_EQ] = ACTIONS(7550),
    [anon_sym_BANG_EQ] = ACTIONS(7550),
    [anon_sym_STAR] = ACTIONS(7552),
    [anon_sym_SLASH] = ACTIONS(7550),
    [anon_sym_STAR_STAR] = ACTIONS(7550),
    [anon_sym_CARET] = ACTIONS(7550),
    [aux_sym_binary_operator_token1] = ACTIONS(7550),
    [anon_sym_PIPE_GT] = ACTIONS(7550),
    [anon_sym_COLON] = ACTIONS(7552),
    [anon_sym_DOLLAR] = ACTIONS(7550),
    [anon_sym_AT] = ACTIONS(7550),
    [aux_sym__hex_literal_token1] = ACTIONS(7550),
    [sym__number_literal] = ACTIONS(7552),
    [anon_sym_SQUOTE] = ACTIONS(7550),
    [anon_sym_DQUOTE] = ACTIONS(7550),
    [sym_return] = ACTIONS(7552),
    [sym_next] = ACTIONS(7552),
    [sym_break] = ACTIONS(7552),
    [sym_true] = ACTIONS(7552),
    [sym_false] = ACTIONS(7552),
    [sym_null] = ACTIONS(7552),
    [sym_inf] = ACTIONS(7552),
    [sym_nan] = ACTIONS(7552),
    [anon_sym_NA] = ACTIONS(7552),
    [anon_sym_NA_integer_] = ACTIONS(7552),
    [anon_sym_NA_real_] = ACTIONS(7552),
    [anon_sym_NA_complex_] = ACTIONS(7552),
    [anon_sym_NA_character_] = ACTIONS(7552),
    [sym_dots] = ACTIONS(7552),
    [sym_dot_dot_i] = ACTIONS(7550),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7550),
    [sym__newline] = ACTIONS(7550),
    [sym__semicolon] = ACTIONS(7550),
    [sym__raw_string_literal] = ACTIONS(7550),
    [sym__external_open_parenthesis] = ACTIONS(7550),
    [sym__external_open_brace] = ACTIONS(7550),
    [sym__external_close_brace] = ACTIONS(7550),
    [sym__external_open_bracket] = ACTIONS(7550),
    [sym__external_close_bracket] = ACTIONS(7550),
    [sym__external_open_bracket2] = ACTIONS(7550),
  },
  [2691] = {
    [ts_builtin_sym_end] = ACTIONS(7561),
    [sym_identifier] = ACTIONS(7563),
    [anon_sym_BSLASH] = ACTIONS(7561),
    [anon_sym_function] = ACTIONS(7563),
    [anon_sym_EQ] = ACTIONS(7563),
    [anon_sym_if] = ACTIONS(7563),
    [anon_sym_for] = ACTIONS(7563),
    [anon_sym_while] = ACTIONS(7563),
    [anon_sym_repeat] = ACTIONS(7563),
    [anon_sym_QMARK] = ACTIONS(7561),
    [anon_sym_TILDE] = ACTIONS(7561),
    [anon_sym_BANG] = ACTIONS(7563),
    [anon_sym_PLUS] = ACTIONS(7561),
    [anon_sym_DASH] = ACTIONS(7563),
    [anon_sym_LT_DASH] = ACTIONS(7561),
    [anon_sym_LT_LT_DASH] = ACTIONS(7561),
    [anon_sym_COLON_EQ] = ACTIONS(7561),
    [anon_sym_DASH_GT] = ACTIONS(7563),
    [anon_sym_DASH_GT_GT] = ACTIONS(7561),
    [anon_sym_PIPE] = ACTIONS(7563),
    [anon_sym_AMP] = ACTIONS(7563),
    [anon_sym_PIPE_PIPE] = ACTIONS(7561),
    [anon_sym_AMP_AMP] = ACTIONS(7561),
    [anon_sym_LT] = ACTIONS(7563),
    [anon_sym_LT_EQ] = ACTIONS(7561),
    [anon_sym_GT] = ACTIONS(7563),
    [anon_sym_GT_EQ] = ACTIONS(7561),
    [anon_sym_EQ_EQ] = ACTIONS(7561),
    [anon_sym_BANG_EQ] = ACTIONS(7561),
    [anon_sym_STAR] = ACTIONS(7563),
    [anon_sym_SLASH] = ACTIONS(7561),
    [anon_sym_STAR_STAR] = ACTIONS(7561),
    [anon_sym_CARET] = ACTIONS(7561),
    [aux_sym_binary_operator_token1] = ACTIONS(7561),
    [anon_sym_PIPE_GT] = ACTIONS(7561),
    [anon_sym_COLON] = ACTIONS(7563),
    [anon_sym_DOLLAR] = ACTIONS(7561),
    [anon_sym_AT] = ACTIONS(7561),
    [aux_sym__hex_literal_token1] = ACTIONS(7561),
    [sym__number_literal] = ACTIONS(7563),
    [anon_sym_SQUOTE] = ACTIONS(7561),
    [anon_sym_DQUOTE] = ACTIONS(7561),
    [sym_return] = ACTIONS(7563),
    [sym_next] = ACTIONS(7563),
    [sym_break] = ACTIONS(7563),
    [sym_true] = ACTIONS(7563),
    [sym_false] = ACTIONS(7563),
    [sym_null] = ACTIONS(7563),
    [sym_inf] = ACTIONS(7563),
    [sym_nan] = ACTIONS(7563),
    [anon_sym_NA] = ACTIONS(7563),
    [anon_sym_NA_integer_] = ACTIONS(7563),
    [anon_sym_NA_real_] = ACTIONS(7563),
    [anon_sym_NA_complex_] = ACTIONS(7563),
    [anon_sym_NA_character_] = ACTIONS(7563),
    [sym_dots] = ACTIONS(7563),
    [sym_dot_dot_i] = ACTIONS(7561),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7561),
    [sym__semicolon] = ACTIONS(7561),
    [sym__raw_string_literal] = ACTIONS(7561),
    [sym__external_else] = ACTIONS(7561),
    [sym__external_open_parenthesis] = ACTIONS(7561),
    [sym__external_open_brace] = ACTIONS(7561),
    [sym__external_close_brace] = ACTIONS(7561),
    [sym__external_open_bracket] = ACTIONS(7561),
    [sym__external_open_bracket2] = ACTIONS(7561),
  },
  [2692] = {
    [ts_builtin_sym_end] = ACTIONS(7484),
    [sym_identifier] = ACTIONS(7486),
    [anon_sym_BSLASH] = ACTIONS(7484),
    [anon_sym_function] = ACTIONS(7486),
    [anon_sym_EQ] = ACTIONS(7486),
    [anon_sym_if] = ACTIONS(7486),
    [anon_sym_for] = ACTIONS(7486),
    [anon_sym_while] = ACTIONS(7486),
    [anon_sym_repeat] = ACTIONS(7486),
    [anon_sym_QMARK] = ACTIONS(7484),
    [anon_sym_TILDE] = ACTIONS(7484),
    [anon_sym_BANG] = ACTIONS(7486),
    [anon_sym_PLUS] = ACTIONS(7484),
    [anon_sym_DASH] = ACTIONS(7486),
    [anon_sym_LT_DASH] = ACTIONS(7484),
    [anon_sym_LT_LT_DASH] = ACTIONS(7484),
    [anon_sym_COLON_EQ] = ACTIONS(7484),
    [anon_sym_DASH_GT] = ACTIONS(7486),
    [anon_sym_DASH_GT_GT] = ACTIONS(7484),
    [anon_sym_PIPE] = ACTIONS(7486),
    [anon_sym_AMP] = ACTIONS(7486),
    [anon_sym_PIPE_PIPE] = ACTIONS(7484),
    [anon_sym_AMP_AMP] = ACTIONS(7484),
    [anon_sym_LT] = ACTIONS(7486),
    [anon_sym_LT_EQ] = ACTIONS(7484),
    [anon_sym_GT] = ACTIONS(7486),
    [anon_sym_GT_EQ] = ACTIONS(7484),
    [anon_sym_EQ_EQ] = ACTIONS(7484),
    [anon_sym_BANG_EQ] = ACTIONS(7484),
    [anon_sym_STAR] = ACTIONS(7486),
    [anon_sym_SLASH] = ACTIONS(7484),
    [anon_sym_STAR_STAR] = ACTIONS(7484),
    [anon_sym_CARET] = ACTIONS(7484),
    [aux_sym_binary_operator_token1] = ACTIONS(7484),
    [anon_sym_PIPE_GT] = ACTIONS(7484),
    [anon_sym_COLON] = ACTIONS(7486),
    [anon_sym_DOLLAR] = ACTIONS(7484),
    [anon_sym_AT] = ACTIONS(7484),
    [aux_sym__hex_literal_token1] = ACTIONS(7484),
    [sym__number_literal] = ACTIONS(7486),
    [anon_sym_SQUOTE] = ACTIONS(7484),
    [anon_sym_DQUOTE] = ACTIONS(7484),
    [sym_return] = ACTIONS(7486),
    [sym_next] = ACTIONS(7486),
    [sym_break] = ACTIONS(7486),
    [sym_true] = ACTIONS(7486),
    [sym_false] = ACTIONS(7486),
    [sym_null] = ACTIONS(7486),
    [sym_inf] = ACTIONS(7486),
    [sym_nan] = ACTIONS(7486),
    [anon_sym_NA] = ACTIONS(7486),
    [anon_sym_NA_integer_] = ACTIONS(7486),
    [anon_sym_NA_real_] = ACTIONS(7486),
    [anon_sym_NA_complex_] = ACTIONS(7486),
    [anon_sym_NA_character_] = ACTIONS(7486),
    [sym_dots] = ACTIONS(7486),
    [sym_dot_dot_i] = ACTIONS(7484),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7484),
    [sym__semicolon] = ACTIONS(7484),
    [sym__raw_string_literal] = ACTIONS(7484),
    [sym__external_else] = ACTIONS(7484),
    [sym__external_open_parenthesis] = ACTIONS(7484),
    [sym__external_close_parenthesis] = ACTIONS(7484),
    [sym__external_open_brace] = ACTIONS(7484),
    [sym__external_open_bracket] = ACTIONS(7484),
    [sym__external_open_bracket2] = ACTIONS(7484),
  },
  [2693] = {
    [ts_builtin_sym_end] = ACTIONS(7488),
    [sym_identifier] = ACTIONS(7490),
    [anon_sym_BSLASH] = ACTIONS(7488),
    [anon_sym_function] = ACTIONS(7490),
    [anon_sym_EQ] = ACTIONS(7490),
    [anon_sym_if] = ACTIONS(7490),
    [anon_sym_for] = ACTIONS(7490),
    [anon_sym_while] = ACTIONS(7490),
    [anon_sym_repeat] = ACTIONS(7490),
    [anon_sym_QMARK] = ACTIONS(7488),
    [anon_sym_TILDE] = ACTIONS(7488),
    [anon_sym_BANG] = ACTIONS(7490),
    [anon_sym_PLUS] = ACTIONS(7488),
    [anon_sym_DASH] = ACTIONS(7490),
    [anon_sym_LT_DASH] = ACTIONS(7488),
    [anon_sym_LT_LT_DASH] = ACTIONS(7488),
    [anon_sym_COLON_EQ] = ACTIONS(7488),
    [anon_sym_DASH_GT] = ACTIONS(7490),
    [anon_sym_DASH_GT_GT] = ACTIONS(7488),
    [anon_sym_PIPE] = ACTIONS(7490),
    [anon_sym_AMP] = ACTIONS(7490),
    [anon_sym_PIPE_PIPE] = ACTIONS(7488),
    [anon_sym_AMP_AMP] = ACTIONS(7488),
    [anon_sym_LT] = ACTIONS(7490),
    [anon_sym_LT_EQ] = ACTIONS(7488),
    [anon_sym_GT] = ACTIONS(7490),
    [anon_sym_GT_EQ] = ACTIONS(7488),
    [anon_sym_EQ_EQ] = ACTIONS(7488),
    [anon_sym_BANG_EQ] = ACTIONS(7488),
    [anon_sym_STAR] = ACTIONS(7490),
    [anon_sym_SLASH] = ACTIONS(7488),
    [anon_sym_STAR_STAR] = ACTIONS(7488),
    [anon_sym_CARET] = ACTIONS(7488),
    [aux_sym_binary_operator_token1] = ACTIONS(7488),
    [anon_sym_PIPE_GT] = ACTIONS(7488),
    [anon_sym_COLON] = ACTIONS(7490),
    [anon_sym_DOLLAR] = ACTIONS(7488),
    [anon_sym_AT] = ACTIONS(7488),
    [aux_sym__hex_literal_token1] = ACTIONS(7488),
    [sym__number_literal] = ACTIONS(7490),
    [anon_sym_SQUOTE] = ACTIONS(7488),
    [anon_sym_DQUOTE] = ACTIONS(7488),
    [sym_return] = ACTIONS(7490),
    [sym_next] = ACTIONS(7490),
    [sym_break] = ACTIONS(7490),
    [sym_true] = ACTIONS(7490),
    [sym_false] = ACTIONS(7490),
    [sym_null] = ACTIONS(7490),
    [sym_inf] = ACTIONS(7490),
    [sym_nan] = ACTIONS(7490),
    [anon_sym_NA] = ACTIONS(7490),
    [anon_sym_NA_integer_] = ACTIONS(7490),
    [anon_sym_NA_real_] = ACTIONS(7490),
    [anon_sym_NA_complex_] = ACTIONS(7490),
    [anon_sym_NA_character_] = ACTIONS(7490),
    [sym_dots] = ACTIONS(7490),
    [sym_dot_dot_i] = ACTIONS(7488),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7488),
    [sym__semicolon] = ACTIONS(7488),
    [sym__raw_string_literal] = ACTIONS(7488),
    [sym__external_else] = ACTIONS(7488),
    [sym__external_open_parenthesis] = ACTIONS(7488),
    [sym__external_close_parenthesis] = ACTIONS(7488),
    [sym__external_open_brace] = ACTIONS(7488),
    [sym__external_open_bracket] = ACTIONS(7488),
    [sym__external_open_bracket2] = ACTIONS(7488),
  },
  [2694] = {
    [ts_builtin_sym_end] = ACTIONS(7492),
    [sym_identifier] = ACTIONS(7494),
    [anon_sym_BSLASH] = ACTIONS(7492),
    [anon_sym_function] = ACTIONS(7494),
    [anon_sym_EQ] = ACTIONS(7494),
    [anon_sym_if] = ACTIONS(7494),
    [anon_sym_for] = ACTIONS(7494),
    [anon_sym_while] = ACTIONS(7494),
    [anon_sym_repeat] = ACTIONS(7494),
    [anon_sym_QMARK] = ACTIONS(7492),
    [anon_sym_TILDE] = ACTIONS(7492),
    [anon_sym_BANG] = ACTIONS(7494),
    [anon_sym_PLUS] = ACTIONS(7492),
    [anon_sym_DASH] = ACTIONS(7494),
    [anon_sym_LT_DASH] = ACTIONS(7492),
    [anon_sym_LT_LT_DASH] = ACTIONS(7492),
    [anon_sym_COLON_EQ] = ACTIONS(7492),
    [anon_sym_DASH_GT] = ACTIONS(7494),
    [anon_sym_DASH_GT_GT] = ACTIONS(7492),
    [anon_sym_PIPE] = ACTIONS(7494),
    [anon_sym_AMP] = ACTIONS(7494),
    [anon_sym_PIPE_PIPE] = ACTIONS(7492),
    [anon_sym_AMP_AMP] = ACTIONS(7492),
    [anon_sym_LT] = ACTIONS(7494),
    [anon_sym_LT_EQ] = ACTIONS(7492),
    [anon_sym_GT] = ACTIONS(7494),
    [anon_sym_GT_EQ] = ACTIONS(7492),
    [anon_sym_EQ_EQ] = ACTIONS(7492),
    [anon_sym_BANG_EQ] = ACTIONS(7492),
    [anon_sym_STAR] = ACTIONS(7494),
    [anon_sym_SLASH] = ACTIONS(7492),
    [anon_sym_STAR_STAR] = ACTIONS(7492),
    [anon_sym_CARET] = ACTIONS(7492),
    [aux_sym_binary_operator_token1] = ACTIONS(7492),
    [anon_sym_PIPE_GT] = ACTIONS(7492),
    [anon_sym_COLON] = ACTIONS(7494),
    [anon_sym_DOLLAR] = ACTIONS(7492),
    [anon_sym_AT] = ACTIONS(7492),
    [aux_sym__hex_literal_token1] = ACTIONS(7492),
    [sym__number_literal] = ACTIONS(7494),
    [anon_sym_SQUOTE] = ACTIONS(7492),
    [anon_sym_DQUOTE] = ACTIONS(7492),
    [sym_return] = ACTIONS(7494),
    [sym_next] = ACTIONS(7494),
    [sym_break] = ACTIONS(7494),
    [sym_true] = ACTIONS(7494),
    [sym_false] = ACTIONS(7494),
    [sym_null] = ACTIONS(7494),
    [sym_inf] = ACTIONS(7494),
    [sym_nan] = ACTIONS(7494),
    [anon_sym_NA] = ACTIONS(7494),
    [anon_sym_NA_integer_] = ACTIONS(7494),
    [anon_sym_NA_real_] = ACTIONS(7494),
    [anon_sym_NA_complex_] = ACTIONS(7494),
    [anon_sym_NA_character_] = ACTIONS(7494),
    [sym_dots] = ACTIONS(7494),
    [sym_dot_dot_i] = ACTIONS(7492),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7492),
    [sym__semicolon] = ACTIONS(7492),
    [sym__raw_string_literal] = ACTIONS(7492),
    [sym__external_else] = ACTIONS(7492),
    [sym__external_open_parenthesis] = ACTIONS(7492),
    [sym__external_close_parenthesis] = ACTIONS(7492),
    [sym__external_open_brace] = ACTIONS(7492),
    [sym__external_open_bracket] = ACTIONS(7492),
    [sym__external_open_bracket2] = ACTIONS(7492),
  },
  [2695] = {
    [ts_builtin_sym_end] = ACTIONS(7496),
    [sym_identifier] = ACTIONS(7498),
    [anon_sym_BSLASH] = ACTIONS(7496),
    [anon_sym_function] = ACTIONS(7498),
    [anon_sym_EQ] = ACTIONS(7498),
    [anon_sym_if] = ACTIONS(7498),
    [anon_sym_for] = ACTIONS(7498),
    [anon_sym_while] = ACTIONS(7498),
    [anon_sym_repeat] = ACTIONS(7498),
    [anon_sym_QMARK] = ACTIONS(7496),
    [anon_sym_TILDE] = ACTIONS(7496),
    [anon_sym_BANG] = ACTIONS(7498),
    [anon_sym_PLUS] = ACTIONS(7496),
    [anon_sym_DASH] = ACTIONS(7498),
    [anon_sym_LT_DASH] = ACTIONS(7496),
    [anon_sym_LT_LT_DASH] = ACTIONS(7496),
    [anon_sym_COLON_EQ] = ACTIONS(7496),
    [anon_sym_DASH_GT] = ACTIONS(7498),
    [anon_sym_DASH_GT_GT] = ACTIONS(7496),
    [anon_sym_PIPE] = ACTIONS(7498),
    [anon_sym_AMP] = ACTIONS(7498),
    [anon_sym_PIPE_PIPE] = ACTIONS(7496),
    [anon_sym_AMP_AMP] = ACTIONS(7496),
    [anon_sym_LT] = ACTIONS(7498),
    [anon_sym_LT_EQ] = ACTIONS(7496),
    [anon_sym_GT] = ACTIONS(7498),
    [anon_sym_GT_EQ] = ACTIONS(7496),
    [anon_sym_EQ_EQ] = ACTIONS(7496),
    [anon_sym_BANG_EQ] = ACTIONS(7496),
    [anon_sym_STAR] = ACTIONS(7498),
    [anon_sym_SLASH] = ACTIONS(7496),
    [anon_sym_STAR_STAR] = ACTIONS(7496),
    [anon_sym_CARET] = ACTIONS(7496),
    [aux_sym_binary_operator_token1] = ACTIONS(7496),
    [anon_sym_PIPE_GT] = ACTIONS(7496),
    [anon_sym_COLON] = ACTIONS(7498),
    [anon_sym_DOLLAR] = ACTIONS(7496),
    [anon_sym_AT] = ACTIONS(7496),
    [aux_sym__hex_literal_token1] = ACTIONS(7496),
    [sym__number_literal] = ACTIONS(7498),
    [anon_sym_SQUOTE] = ACTIONS(7496),
    [anon_sym_DQUOTE] = ACTIONS(7496),
    [sym_return] = ACTIONS(7498),
    [sym_next] = ACTIONS(7498),
    [sym_break] = ACTIONS(7498),
    [sym_true] = ACTIONS(7498),
    [sym_false] = ACTIONS(7498),
    [sym_null] = ACTIONS(7498),
    [sym_inf] = ACTIONS(7498),
    [sym_nan] = ACTIONS(7498),
    [anon_sym_NA] = ACTIONS(7498),
    [anon_sym_NA_integer_] = ACTIONS(7498),
    [anon_sym_NA_real_] = ACTIONS(7498),
    [anon_sym_NA_complex_] = ACTIONS(7498),
    [anon_sym_NA_character_] = ACTIONS(7498),
    [sym_dots] = ACTIONS(7498),
    [sym_dot_dot_i] = ACTIONS(7496),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7496),
    [sym__semicolon] = ACTIONS(7496),
    [sym__raw_string_literal] = ACTIONS(7496),
    [sym__external_else] = ACTIONS(7496),
    [sym__external_open_parenthesis] = ACTIONS(7496),
    [sym__external_close_parenthesis] = ACTIONS(7496),
    [sym__external_open_brace] = ACTIONS(7496),
    [sym__external_open_bracket] = ACTIONS(7496),
    [sym__external_open_bracket2] = ACTIONS(7496),
  },
  [2696] = {
    [ts_builtin_sym_end] = ACTIONS(7500),
    [sym_identifier] = ACTIONS(7502),
    [anon_sym_BSLASH] = ACTIONS(7500),
    [anon_sym_function] = ACTIONS(7502),
    [anon_sym_EQ] = ACTIONS(7502),
    [anon_sym_if] = ACTIONS(7502),
    [anon_sym_for] = ACTIONS(7502),
    [anon_sym_while] = ACTIONS(7502),
    [anon_sym_repeat] = ACTIONS(7502),
    [anon_sym_QMARK] = ACTIONS(7500),
    [anon_sym_TILDE] = ACTIONS(7500),
    [anon_sym_BANG] = ACTIONS(7502),
    [anon_sym_PLUS] = ACTIONS(7500),
    [anon_sym_DASH] = ACTIONS(7502),
    [anon_sym_LT_DASH] = ACTIONS(7500),
    [anon_sym_LT_LT_DASH] = ACTIONS(7500),
    [anon_sym_COLON_EQ] = ACTIONS(7500),
    [anon_sym_DASH_GT] = ACTIONS(7502),
    [anon_sym_DASH_GT_GT] = ACTIONS(7500),
    [anon_sym_PIPE] = ACTIONS(7502),
    [anon_sym_AMP] = ACTIONS(7502),
    [anon_sym_PIPE_PIPE] = ACTIONS(7500),
    [anon_sym_AMP_AMP] = ACTIONS(7500),
    [anon_sym_LT] = ACTIONS(7502),
    [anon_sym_LT_EQ] = ACTIONS(7500),
    [anon_sym_GT] = ACTIONS(7502),
    [anon_sym_GT_EQ] = ACTIONS(7500),
    [anon_sym_EQ_EQ] = ACTIONS(7500),
    [anon_sym_BANG_EQ] = ACTIONS(7500),
    [anon_sym_STAR] = ACTIONS(7502),
    [anon_sym_SLASH] = ACTIONS(7500),
    [anon_sym_STAR_STAR] = ACTIONS(7500),
    [anon_sym_CARET] = ACTIONS(7500),
    [aux_sym_binary_operator_token1] = ACTIONS(7500),
    [anon_sym_PIPE_GT] = ACTIONS(7500),
    [anon_sym_COLON] = ACTIONS(7502),
    [anon_sym_DOLLAR] = ACTIONS(7500),
    [anon_sym_AT] = ACTIONS(7500),
    [aux_sym__hex_literal_token1] = ACTIONS(7500),
    [sym__number_literal] = ACTIONS(7502),
    [anon_sym_SQUOTE] = ACTIONS(7500),
    [anon_sym_DQUOTE] = ACTIONS(7500),
    [sym_return] = ACTIONS(7502),
    [sym_next] = ACTIONS(7502),
    [sym_break] = ACTIONS(7502),
    [sym_true] = ACTIONS(7502),
    [sym_false] = ACTIONS(7502),
    [sym_null] = ACTIONS(7502),
    [sym_inf] = ACTIONS(7502),
    [sym_nan] = ACTIONS(7502),
    [anon_sym_NA] = ACTIONS(7502),
    [anon_sym_NA_integer_] = ACTIONS(7502),
    [anon_sym_NA_real_] = ACTIONS(7502),
    [anon_sym_NA_complex_] = ACTIONS(7502),
    [anon_sym_NA_character_] = ACTIONS(7502),
    [sym_dots] = ACTIONS(7502),
    [sym_dot_dot_i] = ACTIONS(7500),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7500),
    [sym__semicolon] = ACTIONS(7500),
    [sym__raw_string_literal] = ACTIONS(7500),
    [sym__external_else] = ACTIONS(7500),
    [sym__external_open_parenthesis] = ACTIONS(7500),
    [sym__external_close_parenthesis] = ACTIONS(7500),
    [sym__external_open_brace] = ACTIONS(7500),
    [sym__external_open_bracket] = ACTIONS(7500),
    [sym__external_open_bracket2] = ACTIONS(7500),
  },
  [2697] = {
    [ts_builtin_sym_end] = ACTIONS(7504),
    [sym_identifier] = ACTIONS(7506),
    [anon_sym_BSLASH] = ACTIONS(7504),
    [anon_sym_function] = ACTIONS(7506),
    [anon_sym_EQ] = ACTIONS(7506),
    [anon_sym_if] = ACTIONS(7506),
    [anon_sym_for] = ACTIONS(7506),
    [anon_sym_while] = ACTIONS(7506),
    [anon_sym_repeat] = ACTIONS(7506),
    [anon_sym_QMARK] = ACTIONS(7504),
    [anon_sym_TILDE] = ACTIONS(7504),
    [anon_sym_BANG] = ACTIONS(7506),
    [anon_sym_PLUS] = ACTIONS(7504),
    [anon_sym_DASH] = ACTIONS(7506),
    [anon_sym_LT_DASH] = ACTIONS(7504),
    [anon_sym_LT_LT_DASH] = ACTIONS(7504),
    [anon_sym_COLON_EQ] = ACTIONS(7504),
    [anon_sym_DASH_GT] = ACTIONS(7506),
    [anon_sym_DASH_GT_GT] = ACTIONS(7504),
    [anon_sym_PIPE] = ACTIONS(7506),
    [anon_sym_AMP] = ACTIONS(7506),
    [anon_sym_PIPE_PIPE] = ACTIONS(7504),
    [anon_sym_AMP_AMP] = ACTIONS(7504),
    [anon_sym_LT] = ACTIONS(7506),
    [anon_sym_LT_EQ] = ACTIONS(7504),
    [anon_sym_GT] = ACTIONS(7506),
    [anon_sym_GT_EQ] = ACTIONS(7504),
    [anon_sym_EQ_EQ] = ACTIONS(7504),
    [anon_sym_BANG_EQ] = ACTIONS(7504),
    [anon_sym_STAR] = ACTIONS(7506),
    [anon_sym_SLASH] = ACTIONS(7504),
    [anon_sym_STAR_STAR] = ACTIONS(7504),
    [anon_sym_CARET] = ACTIONS(7504),
    [aux_sym_binary_operator_token1] = ACTIONS(7504),
    [anon_sym_PIPE_GT] = ACTIONS(7504),
    [anon_sym_COLON] = ACTIONS(7506),
    [anon_sym_DOLLAR] = ACTIONS(7504),
    [anon_sym_AT] = ACTIONS(7504),
    [aux_sym__hex_literal_token1] = ACTIONS(7504),
    [sym__number_literal] = ACTIONS(7506),
    [anon_sym_SQUOTE] = ACTIONS(7504),
    [anon_sym_DQUOTE] = ACTIONS(7504),
    [sym_return] = ACTIONS(7506),
    [sym_next] = ACTIONS(7506),
    [sym_break] = ACTIONS(7506),
    [sym_true] = ACTIONS(7506),
    [sym_false] = ACTIONS(7506),
    [sym_null] = ACTIONS(7506),
    [sym_inf] = ACTIONS(7506),
    [sym_nan] = ACTIONS(7506),
    [anon_sym_NA] = ACTIONS(7506),
    [anon_sym_NA_integer_] = ACTIONS(7506),
    [anon_sym_NA_real_] = ACTIONS(7506),
    [anon_sym_NA_complex_] = ACTIONS(7506),
    [anon_sym_NA_character_] = ACTIONS(7506),
    [sym_dots] = ACTIONS(7506),
    [sym_dot_dot_i] = ACTIONS(7504),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7504),
    [sym__semicolon] = ACTIONS(7504),
    [sym__raw_string_literal] = ACTIONS(7504),
    [sym__external_else] = ACTIONS(7504),
    [sym__external_open_parenthesis] = ACTIONS(7504),
    [sym__external_close_parenthesis] = ACTIONS(7504),
    [sym__external_open_brace] = ACTIONS(7504),
    [sym__external_open_bracket] = ACTIONS(7504),
    [sym__external_open_bracket2] = ACTIONS(7504),
  },
  [2698] = {
    [ts_builtin_sym_end] = ACTIONS(7510),
    [sym_identifier] = ACTIONS(7512),
    [anon_sym_BSLASH] = ACTIONS(7510),
    [anon_sym_function] = ACTIONS(7512),
    [anon_sym_EQ] = ACTIONS(7512),
    [anon_sym_if] = ACTIONS(7512),
    [anon_sym_for] = ACTIONS(7512),
    [anon_sym_while] = ACTIONS(7512),
    [anon_sym_repeat] = ACTIONS(7512),
    [anon_sym_QMARK] = ACTIONS(7510),
    [anon_sym_TILDE] = ACTIONS(7510),
    [anon_sym_BANG] = ACTIONS(7512),
    [anon_sym_PLUS] = ACTIONS(7510),
    [anon_sym_DASH] = ACTIONS(7512),
    [anon_sym_LT_DASH] = ACTIONS(7510),
    [anon_sym_LT_LT_DASH] = ACTIONS(7510),
    [anon_sym_COLON_EQ] = ACTIONS(7510),
    [anon_sym_DASH_GT] = ACTIONS(7512),
    [anon_sym_DASH_GT_GT] = ACTIONS(7510),
    [anon_sym_PIPE] = ACTIONS(7512),
    [anon_sym_AMP] = ACTIONS(7512),
    [anon_sym_PIPE_PIPE] = ACTIONS(7510),
    [anon_sym_AMP_AMP] = ACTIONS(7510),
    [anon_sym_LT] = ACTIONS(7512),
    [anon_sym_LT_EQ] = ACTIONS(7510),
    [anon_sym_GT] = ACTIONS(7512),
    [anon_sym_GT_EQ] = ACTIONS(7510),
    [anon_sym_EQ_EQ] = ACTIONS(7510),
    [anon_sym_BANG_EQ] = ACTIONS(7510),
    [anon_sym_STAR] = ACTIONS(7512),
    [anon_sym_SLASH] = ACTIONS(7510),
    [anon_sym_STAR_STAR] = ACTIONS(7510),
    [anon_sym_CARET] = ACTIONS(7510),
    [aux_sym_binary_operator_token1] = ACTIONS(7510),
    [anon_sym_PIPE_GT] = ACTIONS(7510),
    [anon_sym_COLON] = ACTIONS(7512),
    [anon_sym_DOLLAR] = ACTIONS(7510),
    [anon_sym_AT] = ACTIONS(7510),
    [aux_sym__hex_literal_token1] = ACTIONS(7510),
    [sym__number_literal] = ACTIONS(7512),
    [anon_sym_SQUOTE] = ACTIONS(7510),
    [anon_sym_DQUOTE] = ACTIONS(7510),
    [sym_return] = ACTIONS(7512),
    [sym_next] = ACTIONS(7512),
    [sym_break] = ACTIONS(7512),
    [sym_true] = ACTIONS(7512),
    [sym_false] = ACTIONS(7512),
    [sym_null] = ACTIONS(7512),
    [sym_inf] = ACTIONS(7512),
    [sym_nan] = ACTIONS(7512),
    [anon_sym_NA] = ACTIONS(7512),
    [anon_sym_NA_integer_] = ACTIONS(7512),
    [anon_sym_NA_real_] = ACTIONS(7512),
    [anon_sym_NA_complex_] = ACTIONS(7512),
    [anon_sym_NA_character_] = ACTIONS(7512),
    [sym_dots] = ACTIONS(7512),
    [sym_dot_dot_i] = ACTIONS(7510),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7510),
    [sym__semicolon] = ACTIONS(7510),
    [sym__raw_string_literal] = ACTIONS(7510),
    [sym__external_else] = ACTIONS(7510),
    [sym__external_open_parenthesis] = ACTIONS(7510),
    [sym__external_close_parenthesis] = ACTIONS(7510),
    [sym__external_open_brace] = ACTIONS(7510),
    [sym__external_open_bracket] = ACTIONS(7510),
    [sym__external_open_bracket2] = ACTIONS(7510),
  },
  [2699] = {
    [sym_identifier] = ACTIONS(7563),
    [anon_sym_BSLASH] = ACTIONS(7561),
    [anon_sym_function] = ACTIONS(7563),
    [anon_sym_EQ] = ACTIONS(7563),
    [anon_sym_if] = ACTIONS(7563),
    [anon_sym_for] = ACTIONS(7563),
    [anon_sym_while] = ACTIONS(7563),
    [anon_sym_repeat] = ACTIONS(7563),
    [anon_sym_QMARK] = ACTIONS(7561),
    [anon_sym_TILDE] = ACTIONS(7561),
    [anon_sym_BANG] = ACTIONS(7563),
    [anon_sym_PLUS] = ACTIONS(7561),
    [anon_sym_DASH] = ACTIONS(7563),
    [anon_sym_LT_DASH] = ACTIONS(7561),
    [anon_sym_LT_LT_DASH] = ACTIONS(7561),
    [anon_sym_COLON_EQ] = ACTIONS(7561),
    [anon_sym_DASH_GT] = ACTIONS(7563),
    [anon_sym_DASH_GT_GT] = ACTIONS(7561),
    [anon_sym_PIPE] = ACTIONS(7563),
    [anon_sym_AMP] = ACTIONS(7563),
    [anon_sym_PIPE_PIPE] = ACTIONS(7561),
    [anon_sym_AMP_AMP] = ACTIONS(7561),
    [anon_sym_LT] = ACTIONS(7563),
    [anon_sym_LT_EQ] = ACTIONS(7561),
    [anon_sym_GT] = ACTIONS(7563),
    [anon_sym_GT_EQ] = ACTIONS(7561),
    [anon_sym_EQ_EQ] = ACTIONS(7561),
    [anon_sym_BANG_EQ] = ACTIONS(7561),
    [anon_sym_STAR] = ACTIONS(7563),
    [anon_sym_SLASH] = ACTIONS(7561),
    [anon_sym_STAR_STAR] = ACTIONS(7561),
    [anon_sym_CARET] = ACTIONS(7561),
    [aux_sym_binary_operator_token1] = ACTIONS(7561),
    [anon_sym_PIPE_GT] = ACTIONS(7561),
    [anon_sym_COLON] = ACTIONS(7563),
    [anon_sym_DOLLAR] = ACTIONS(7561),
    [anon_sym_AT] = ACTIONS(7561),
    [aux_sym__hex_literal_token1] = ACTIONS(7561),
    [sym__number_literal] = ACTIONS(7563),
    [anon_sym_SQUOTE] = ACTIONS(7561),
    [anon_sym_DQUOTE] = ACTIONS(7561),
    [sym_return] = ACTIONS(7563),
    [sym_next] = ACTIONS(7563),
    [sym_break] = ACTIONS(7563),
    [sym_true] = ACTIONS(7563),
    [sym_false] = ACTIONS(7563),
    [sym_null] = ACTIONS(7563),
    [sym_inf] = ACTIONS(7563),
    [sym_nan] = ACTIONS(7563),
    [anon_sym_NA] = ACTIONS(7563),
    [anon_sym_NA_integer_] = ACTIONS(7563),
    [anon_sym_NA_real_] = ACTIONS(7563),
    [anon_sym_NA_complex_] = ACTIONS(7563),
    [anon_sym_NA_character_] = ACTIONS(7563),
    [sym_dots] = ACTIONS(7563),
    [sym_dot_dot_i] = ACTIONS(7561),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7561),
    [sym__newline] = ACTIONS(7561),
    [sym__semicolon] = ACTIONS(7561),
    [sym__raw_string_literal] = ACTIONS(7561),
    [sym__external_open_parenthesis] = ACTIONS(7561),
    [sym__external_open_brace] = ACTIONS(7561),
    [sym__external_close_brace] = ACTIONS(7561),
    [sym__external_open_bracket] = ACTIONS(7561),
    [sym__external_open_bracket2] = ACTIONS(7561),
    [sym__external_close_bracket2] = ACTIONS(7561),
  },
  [2700] = {
    [sym_identifier] = ACTIONS(7121),
    [anon_sym_BSLASH] = ACTIONS(7123),
    [anon_sym_function] = ACTIONS(7121),
    [anon_sym_EQ] = ACTIONS(7121),
    [anon_sym_if] = ACTIONS(7121),
    [anon_sym_for] = ACTIONS(7121),
    [anon_sym_while] = ACTIONS(7121),
    [anon_sym_repeat] = ACTIONS(7121),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_TILDE] = ACTIONS(7123),
    [anon_sym_BANG] = ACTIONS(7121),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_DASH] = ACTIONS(7121),
    [anon_sym_LT_DASH] = ACTIONS(7123),
    [anon_sym_LT_LT_DASH] = ACTIONS(7123),
    [anon_sym_COLON_EQ] = ACTIONS(7123),
    [anon_sym_DASH_GT] = ACTIONS(7121),
    [anon_sym_DASH_GT_GT] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_LT_EQ] = ACTIONS(7123),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
    [aux_sym_binary_operator_token1] = ACTIONS(7123),
    [anon_sym_PIPE_GT] = ACTIONS(7123),
    [anon_sym_COLON] = ACTIONS(7121),
    [anon_sym_DOLLAR] = ACTIONS(7123),
    [anon_sym_AT] = ACTIONS(7123),
    [anon_sym_L] = ACTIONS(7681),
    [anon_sym_i] = ACTIONS(7683),
    [aux_sym__hex_literal_token1] = ACTIONS(7123),
    [sym__number_literal] = ACTIONS(7121),
    [anon_sym_SQUOTE] = ACTIONS(7123),
    [anon_sym_DQUOTE] = ACTIONS(7123),
    [sym_return] = ACTIONS(7121),
    [sym_next] = ACTIONS(7121),
    [sym_break] = ACTIONS(7121),
    [sym_true] = ACTIONS(7121),
    [sym_false] = ACTIONS(7121),
    [sym_null] = ACTIONS(7121),
    [sym_inf] = ACTIONS(7121),
    [sym_nan] = ACTIONS(7121),
    [anon_sym_NA] = ACTIONS(7121),
    [anon_sym_NA_integer_] = ACTIONS(7121),
    [anon_sym_NA_real_] = ACTIONS(7121),
    [anon_sym_NA_complex_] = ACTIONS(7121),
    [anon_sym_NA_character_] = ACTIONS(7121),
    [sym_dots] = ACTIONS(7121),
    [sym_dot_dot_i] = ACTIONS(7123),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7123),
    [sym__newline] = ACTIONS(7123),
    [sym__raw_string_literal] = ACTIONS(7123),
    [sym__external_open_parenthesis] = ACTIONS(7123),
    [sym__external_open_brace] = ACTIONS(7123),
    [sym__external_open_bracket] = ACTIONS(7123),
    [sym__external_close_bracket] = ACTIONS(7123),
    [sym__external_open_bracket2] = ACTIONS(7123),
  },
  [2701] = {
    [sym_identifier] = ACTIONS(7115),
    [anon_sym_BSLASH] = ACTIONS(7117),
    [anon_sym_function] = ACTIONS(7115),
    [anon_sym_EQ] = ACTIONS(7115),
    [anon_sym_if] = ACTIONS(7115),
    [anon_sym_for] = ACTIONS(7115),
    [anon_sym_while] = ACTIONS(7115),
    [anon_sym_repeat] = ACTIONS(7115),
    [anon_sym_QMARK] = ACTIONS(7117),
    [anon_sym_TILDE] = ACTIONS(7117),
    [anon_sym_BANG] = ACTIONS(7115),
    [anon_sym_PLUS] = ACTIONS(7117),
    [anon_sym_DASH] = ACTIONS(7115),
    [anon_sym_LT_DASH] = ACTIONS(7117),
    [anon_sym_LT_LT_DASH] = ACTIONS(7117),
    [anon_sym_COLON_EQ] = ACTIONS(7117),
    [anon_sym_DASH_GT] = ACTIONS(7115),
    [anon_sym_DASH_GT_GT] = ACTIONS(7117),
    [anon_sym_PIPE] = ACTIONS(7115),
    [anon_sym_AMP] = ACTIONS(7115),
    [anon_sym_PIPE_PIPE] = ACTIONS(7117),
    [anon_sym_AMP_AMP] = ACTIONS(7117),
    [anon_sym_LT] = ACTIONS(7115),
    [anon_sym_LT_EQ] = ACTIONS(7117),
    [anon_sym_GT] = ACTIONS(7115),
    [anon_sym_GT_EQ] = ACTIONS(7117),
    [anon_sym_EQ_EQ] = ACTIONS(7117),
    [anon_sym_BANG_EQ] = ACTIONS(7117),
    [anon_sym_STAR] = ACTIONS(7115),
    [anon_sym_SLASH] = ACTIONS(7117),
    [anon_sym_STAR_STAR] = ACTIONS(7117),
    [anon_sym_CARET] = ACTIONS(7117),
    [aux_sym_binary_operator_token1] = ACTIONS(7117),
    [anon_sym_PIPE_GT] = ACTIONS(7117),
    [anon_sym_COLON] = ACTIONS(7115),
    [anon_sym_DOLLAR] = ACTIONS(7117),
    [anon_sym_AT] = ACTIONS(7117),
    [anon_sym_COLON_COLON] = ACTIONS(7115),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7117),
    [aux_sym__hex_literal_token1] = ACTIONS(7117),
    [sym__number_literal] = ACTIONS(7115),
    [anon_sym_SQUOTE] = ACTIONS(7117),
    [anon_sym_DQUOTE] = ACTIONS(7117),
    [sym_return] = ACTIONS(7115),
    [sym_next] = ACTIONS(7115),
    [sym_break] = ACTIONS(7115),
    [sym_true] = ACTIONS(7115),
    [sym_false] = ACTIONS(7115),
    [sym_null] = ACTIONS(7115),
    [sym_inf] = ACTIONS(7115),
    [sym_nan] = ACTIONS(7115),
    [anon_sym_NA] = ACTIONS(7115),
    [anon_sym_NA_integer_] = ACTIONS(7115),
    [anon_sym_NA_real_] = ACTIONS(7115),
    [anon_sym_NA_complex_] = ACTIONS(7115),
    [anon_sym_NA_character_] = ACTIONS(7115),
    [sym_dots] = ACTIONS(7115),
    [sym_dot_dot_i] = ACTIONS(7117),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7117),
    [sym__newline] = ACTIONS(7117),
    [sym__raw_string_literal] = ACTIONS(7117),
    [sym__external_open_parenthesis] = ACTIONS(7117),
    [sym__external_open_brace] = ACTIONS(7117),
    [sym__external_open_bracket] = ACTIONS(7117),
    [sym__external_close_bracket] = ACTIONS(7117),
    [sym__external_open_bracket2] = ACTIONS(7117),
  },
  [2702] = {
    [sym_identifier] = ACTIONS(7556),
    [anon_sym_BSLASH] = ACTIONS(7554),
    [anon_sym_function] = ACTIONS(7556),
    [anon_sym_EQ] = ACTIONS(7556),
    [anon_sym_if] = ACTIONS(7556),
    [anon_sym_for] = ACTIONS(7556),
    [anon_sym_while] = ACTIONS(7556),
    [anon_sym_repeat] = ACTIONS(7556),
    [anon_sym_QMARK] = ACTIONS(7554),
    [anon_sym_TILDE] = ACTIONS(7554),
    [anon_sym_BANG] = ACTIONS(7556),
    [anon_sym_PLUS] = ACTIONS(7554),
    [anon_sym_DASH] = ACTIONS(7556),
    [anon_sym_LT_DASH] = ACTIONS(7554),
    [anon_sym_LT_LT_DASH] = ACTIONS(7554),
    [anon_sym_COLON_EQ] = ACTIONS(7554),
    [anon_sym_DASH_GT] = ACTIONS(7556),
    [anon_sym_DASH_GT_GT] = ACTIONS(7554),
    [anon_sym_PIPE] = ACTIONS(7556),
    [anon_sym_AMP] = ACTIONS(7556),
    [anon_sym_PIPE_PIPE] = ACTIONS(7554),
    [anon_sym_AMP_AMP] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(7556),
    [anon_sym_LT_EQ] = ACTIONS(7554),
    [anon_sym_GT] = ACTIONS(7556),
    [anon_sym_GT_EQ] = ACTIONS(7554),
    [anon_sym_EQ_EQ] = ACTIONS(7554),
    [anon_sym_BANG_EQ] = ACTIONS(7554),
    [anon_sym_STAR] = ACTIONS(7556),
    [anon_sym_SLASH] = ACTIONS(7554),
    [anon_sym_STAR_STAR] = ACTIONS(7554),
    [anon_sym_CARET] = ACTIONS(7554),
    [aux_sym_binary_operator_token1] = ACTIONS(7554),
    [anon_sym_PIPE_GT] = ACTIONS(7554),
    [anon_sym_COLON] = ACTIONS(7556),
    [anon_sym_DOLLAR] = ACTIONS(7554),
    [anon_sym_AT] = ACTIONS(7554),
    [aux_sym__hex_literal_token1] = ACTIONS(7554),
    [sym__number_literal] = ACTIONS(7556),
    [anon_sym_SQUOTE] = ACTIONS(7554),
    [anon_sym_DQUOTE] = ACTIONS(7554),
    [sym_return] = ACTIONS(7556),
    [sym_next] = ACTIONS(7556),
    [sym_break] = ACTIONS(7556),
    [sym_true] = ACTIONS(7556),
    [sym_false] = ACTIONS(7556),
    [sym_null] = ACTIONS(7556),
    [sym_inf] = ACTIONS(7556),
    [sym_nan] = ACTIONS(7556),
    [anon_sym_NA] = ACTIONS(7556),
    [anon_sym_NA_integer_] = ACTIONS(7556),
    [anon_sym_NA_real_] = ACTIONS(7556),
    [anon_sym_NA_complex_] = ACTIONS(7556),
    [anon_sym_NA_character_] = ACTIONS(7556),
    [sym_dots] = ACTIONS(7556),
    [sym_dot_dot_i] = ACTIONS(7554),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7554),
    [sym__newline] = ACTIONS(7554),
    [sym__raw_string_literal] = ACTIONS(7554),
    [sym__external_else] = ACTIONS(7554),
    [sym__external_open_parenthesis] = ACTIONS(7554),
    [sym__external_close_parenthesis] = ACTIONS(7554),
    [sym__external_open_brace] = ACTIONS(7554),
    [sym__external_open_bracket] = ACTIONS(7554),
    [sym__external_open_bracket2] = ACTIONS(7554),
    [sym__external_close_bracket2] = ACTIONS(7554),
  },
  [2703] = {
    [sym_identifier] = ACTIONS(7474),
    [anon_sym_BSLASH] = ACTIONS(7472),
    [anon_sym_function] = ACTIONS(7474),
    [anon_sym_EQ] = ACTIONS(7474),
    [anon_sym_if] = ACTIONS(7474),
    [anon_sym_for] = ACTIONS(7474),
    [anon_sym_while] = ACTIONS(7474),
    [anon_sym_repeat] = ACTIONS(7474),
    [anon_sym_QMARK] = ACTIONS(7472),
    [anon_sym_TILDE] = ACTIONS(7472),
    [anon_sym_BANG] = ACTIONS(7474),
    [anon_sym_PLUS] = ACTIONS(7472),
    [anon_sym_DASH] = ACTIONS(7474),
    [anon_sym_LT_DASH] = ACTIONS(7472),
    [anon_sym_LT_LT_DASH] = ACTIONS(7472),
    [anon_sym_COLON_EQ] = ACTIONS(7472),
    [anon_sym_DASH_GT] = ACTIONS(7474),
    [anon_sym_DASH_GT_GT] = ACTIONS(7472),
    [anon_sym_PIPE] = ACTIONS(7474),
    [anon_sym_AMP] = ACTIONS(7474),
    [anon_sym_PIPE_PIPE] = ACTIONS(7472),
    [anon_sym_AMP_AMP] = ACTIONS(7472),
    [anon_sym_LT] = ACTIONS(7474),
    [anon_sym_LT_EQ] = ACTIONS(7472),
    [anon_sym_GT] = ACTIONS(7474),
    [anon_sym_GT_EQ] = ACTIONS(7472),
    [anon_sym_EQ_EQ] = ACTIONS(7472),
    [anon_sym_BANG_EQ] = ACTIONS(7472),
    [anon_sym_STAR] = ACTIONS(7474),
    [anon_sym_SLASH] = ACTIONS(7472),
    [anon_sym_STAR_STAR] = ACTIONS(7472),
    [anon_sym_CARET] = ACTIONS(7472),
    [aux_sym_binary_operator_token1] = ACTIONS(7472),
    [anon_sym_PIPE_GT] = ACTIONS(7472),
    [anon_sym_COLON] = ACTIONS(7474),
    [anon_sym_DOLLAR] = ACTIONS(7472),
    [anon_sym_AT] = ACTIONS(7472),
    [aux_sym__hex_literal_token1] = ACTIONS(7472),
    [sym__number_literal] = ACTIONS(7474),
    [anon_sym_SQUOTE] = ACTIONS(7472),
    [anon_sym_DQUOTE] = ACTIONS(7472),
    [sym_return] = ACTIONS(7474),
    [sym_next] = ACTIONS(7474),
    [sym_break] = ACTIONS(7474),
    [sym_true] = ACTIONS(7474),
    [sym_false] = ACTIONS(7474),
    [sym_null] = ACTIONS(7474),
    [sym_inf] = ACTIONS(7474),
    [sym_nan] = ACTIONS(7474),
    [anon_sym_NA] = ACTIONS(7474),
    [anon_sym_NA_integer_] = ACTIONS(7474),
    [anon_sym_NA_real_] = ACTIONS(7474),
    [anon_sym_NA_complex_] = ACTIONS(7474),
    [anon_sym_NA_character_] = ACTIONS(7474),
    [sym_dots] = ACTIONS(7474),
    [sym_dot_dot_i] = ACTIONS(7472),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7472),
    [sym__newline] = ACTIONS(7472),
    [sym__raw_string_literal] = ACTIONS(7472),
    [sym__external_else] = ACTIONS(7472),
    [sym__external_open_parenthesis] = ACTIONS(7472),
    [sym__external_close_parenthesis] = ACTIONS(7472),
    [sym__external_open_brace] = ACTIONS(7472),
    [sym__external_open_bracket] = ACTIONS(7472),
    [sym__external_close_bracket] = ACTIONS(7472),
    [sym__external_open_bracket2] = ACTIONS(7472),
  },
  [2704] = {
    [sym_identifier] = ACTIONS(7464),
    [anon_sym_BSLASH] = ACTIONS(7466),
    [anon_sym_function] = ACTIONS(7464),
    [anon_sym_EQ] = ACTIONS(7464),
    [anon_sym_if] = ACTIONS(7464),
    [anon_sym_for] = ACTIONS(7464),
    [anon_sym_while] = ACTIONS(7464),
    [anon_sym_repeat] = ACTIONS(7464),
    [anon_sym_QMARK] = ACTIONS(7466),
    [anon_sym_TILDE] = ACTIONS(7466),
    [anon_sym_BANG] = ACTIONS(7464),
    [anon_sym_PLUS] = ACTIONS(7466),
    [anon_sym_DASH] = ACTIONS(7464),
    [anon_sym_LT_DASH] = ACTIONS(7466),
    [anon_sym_LT_LT_DASH] = ACTIONS(7466),
    [anon_sym_COLON_EQ] = ACTIONS(7466),
    [anon_sym_DASH_GT] = ACTIONS(7464),
    [anon_sym_DASH_GT_GT] = ACTIONS(7466),
    [anon_sym_PIPE] = ACTIONS(7464),
    [anon_sym_AMP] = ACTIONS(7464),
    [anon_sym_PIPE_PIPE] = ACTIONS(7466),
    [anon_sym_AMP_AMP] = ACTIONS(7466),
    [anon_sym_LT] = ACTIONS(7464),
    [anon_sym_LT_EQ] = ACTIONS(7466),
    [anon_sym_GT] = ACTIONS(7464),
    [anon_sym_GT_EQ] = ACTIONS(7466),
    [anon_sym_EQ_EQ] = ACTIONS(7466),
    [anon_sym_BANG_EQ] = ACTIONS(7466),
    [anon_sym_STAR] = ACTIONS(7464),
    [anon_sym_SLASH] = ACTIONS(7466),
    [anon_sym_STAR_STAR] = ACTIONS(7466),
    [anon_sym_CARET] = ACTIONS(7466),
    [aux_sym_binary_operator_token1] = ACTIONS(7466),
    [anon_sym_PIPE_GT] = ACTIONS(7466),
    [anon_sym_COLON] = ACTIONS(7464),
    [anon_sym_DOLLAR] = ACTIONS(7466),
    [anon_sym_AT] = ACTIONS(7466),
    [aux_sym__hex_literal_token1] = ACTIONS(7466),
    [sym__number_literal] = ACTIONS(7464),
    [anon_sym_SQUOTE] = ACTIONS(7466),
    [anon_sym_DQUOTE] = ACTIONS(7466),
    [sym_return] = ACTIONS(7464),
    [sym_next] = ACTIONS(7464),
    [sym_break] = ACTIONS(7464),
    [sym_true] = ACTIONS(7464),
    [sym_false] = ACTIONS(7464),
    [sym_null] = ACTIONS(7464),
    [sym_inf] = ACTIONS(7464),
    [sym_nan] = ACTIONS(7464),
    [anon_sym_NA] = ACTIONS(7464),
    [anon_sym_NA_integer_] = ACTIONS(7464),
    [anon_sym_NA_real_] = ACTIONS(7464),
    [anon_sym_NA_complex_] = ACTIONS(7464),
    [anon_sym_NA_character_] = ACTIONS(7464),
    [sym_dots] = ACTIONS(7464),
    [sym_dot_dot_i] = ACTIONS(7466),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7466),
    [sym__newline] = ACTIONS(7466),
    [sym__raw_string_literal] = ACTIONS(7466),
    [sym__external_else] = ACTIONS(7466),
    [sym__external_open_parenthesis] = ACTIONS(7466),
    [sym__external_close_parenthesis] = ACTIONS(7466),
    [sym__external_open_brace] = ACTIONS(7466),
    [sym__external_open_bracket] = ACTIONS(7466),
    [sym__external_close_bracket] = ACTIONS(7466),
    [sym__external_open_bracket2] = ACTIONS(7466),
  },
  [2705] = {
    [sym_identifier] = ACTIONS(7478),
    [anon_sym_BSLASH] = ACTIONS(7476),
    [anon_sym_function] = ACTIONS(7478),
    [anon_sym_EQ] = ACTIONS(7478),
    [anon_sym_if] = ACTIONS(7478),
    [anon_sym_for] = ACTIONS(7478),
    [anon_sym_while] = ACTIONS(7478),
    [anon_sym_repeat] = ACTIONS(7478),
    [anon_sym_QMARK] = ACTIONS(7476),
    [anon_sym_TILDE] = ACTIONS(7476),
    [anon_sym_BANG] = ACTIONS(7478),
    [anon_sym_PLUS] = ACTIONS(7476),
    [anon_sym_DASH] = ACTIONS(7478),
    [anon_sym_LT_DASH] = ACTIONS(7476),
    [anon_sym_LT_LT_DASH] = ACTIONS(7476),
    [anon_sym_COLON_EQ] = ACTIONS(7476),
    [anon_sym_DASH_GT] = ACTIONS(7478),
    [anon_sym_DASH_GT_GT] = ACTIONS(7476),
    [anon_sym_PIPE] = ACTIONS(7478),
    [anon_sym_AMP] = ACTIONS(7478),
    [anon_sym_PIPE_PIPE] = ACTIONS(7476),
    [anon_sym_AMP_AMP] = ACTIONS(7476),
    [anon_sym_LT] = ACTIONS(7478),
    [anon_sym_LT_EQ] = ACTIONS(7476),
    [anon_sym_GT] = ACTIONS(7478),
    [anon_sym_GT_EQ] = ACTIONS(7476),
    [anon_sym_EQ_EQ] = ACTIONS(7476),
    [anon_sym_BANG_EQ] = ACTIONS(7476),
    [anon_sym_STAR] = ACTIONS(7478),
    [anon_sym_SLASH] = ACTIONS(7476),
    [anon_sym_STAR_STAR] = ACTIONS(7476),
    [anon_sym_CARET] = ACTIONS(7476),
    [aux_sym_binary_operator_token1] = ACTIONS(7476),
    [anon_sym_PIPE_GT] = ACTIONS(7476),
    [anon_sym_COLON] = ACTIONS(7478),
    [anon_sym_DOLLAR] = ACTIONS(7476),
    [anon_sym_AT] = ACTIONS(7476),
    [aux_sym__hex_literal_token1] = ACTIONS(7476),
    [sym__number_literal] = ACTIONS(7478),
    [anon_sym_SQUOTE] = ACTIONS(7476),
    [anon_sym_DQUOTE] = ACTIONS(7476),
    [sym_return] = ACTIONS(7478),
    [sym_next] = ACTIONS(7478),
    [sym_break] = ACTIONS(7478),
    [sym_true] = ACTIONS(7478),
    [sym_false] = ACTIONS(7478),
    [sym_null] = ACTIONS(7478),
    [sym_inf] = ACTIONS(7478),
    [sym_nan] = ACTIONS(7478),
    [anon_sym_NA] = ACTIONS(7478),
    [anon_sym_NA_integer_] = ACTIONS(7478),
    [anon_sym_NA_real_] = ACTIONS(7478),
    [anon_sym_NA_complex_] = ACTIONS(7478),
    [anon_sym_NA_character_] = ACTIONS(7478),
    [sym_dots] = ACTIONS(7478),
    [sym_dot_dot_i] = ACTIONS(7476),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7476),
    [sym__newline] = ACTIONS(7476),
    [sym__raw_string_literal] = ACTIONS(7476),
    [sym__external_else] = ACTIONS(7476),
    [sym__external_open_parenthesis] = ACTIONS(7476),
    [sym__external_close_parenthesis] = ACTIONS(7476),
    [sym__external_open_brace] = ACTIONS(7476),
    [sym__external_open_bracket] = ACTIONS(7476),
    [sym__external_close_bracket] = ACTIONS(7476),
    [sym__external_open_bracket2] = ACTIONS(7476),
  },
  [2706] = {
    [sym_identifier] = ACTIONS(7482),
    [anon_sym_BSLASH] = ACTIONS(7480),
    [anon_sym_function] = ACTIONS(7482),
    [anon_sym_EQ] = ACTIONS(7482),
    [anon_sym_if] = ACTIONS(7482),
    [anon_sym_for] = ACTIONS(7482),
    [anon_sym_while] = ACTIONS(7482),
    [anon_sym_repeat] = ACTIONS(7482),
    [anon_sym_QMARK] = ACTIONS(7480),
    [anon_sym_TILDE] = ACTIONS(7480),
    [anon_sym_BANG] = ACTIONS(7482),
    [anon_sym_PLUS] = ACTIONS(7480),
    [anon_sym_DASH] = ACTIONS(7482),
    [anon_sym_LT_DASH] = ACTIONS(7480),
    [anon_sym_LT_LT_DASH] = ACTIONS(7480),
    [anon_sym_COLON_EQ] = ACTIONS(7480),
    [anon_sym_DASH_GT] = ACTIONS(7482),
    [anon_sym_DASH_GT_GT] = ACTIONS(7480),
    [anon_sym_PIPE] = ACTIONS(7482),
    [anon_sym_AMP] = ACTIONS(7482),
    [anon_sym_PIPE_PIPE] = ACTIONS(7480),
    [anon_sym_AMP_AMP] = ACTIONS(7480),
    [anon_sym_LT] = ACTIONS(7482),
    [anon_sym_LT_EQ] = ACTIONS(7480),
    [anon_sym_GT] = ACTIONS(7482),
    [anon_sym_GT_EQ] = ACTIONS(7480),
    [anon_sym_EQ_EQ] = ACTIONS(7480),
    [anon_sym_BANG_EQ] = ACTIONS(7480),
    [anon_sym_STAR] = ACTIONS(7482),
    [anon_sym_SLASH] = ACTIONS(7480),
    [anon_sym_STAR_STAR] = ACTIONS(7480),
    [anon_sym_CARET] = ACTIONS(7480),
    [aux_sym_binary_operator_token1] = ACTIONS(7480),
    [anon_sym_PIPE_GT] = ACTIONS(7480),
    [anon_sym_COLON] = ACTIONS(7482),
    [anon_sym_DOLLAR] = ACTIONS(7480),
    [anon_sym_AT] = ACTIONS(7480),
    [aux_sym__hex_literal_token1] = ACTIONS(7480),
    [sym__number_literal] = ACTIONS(7482),
    [anon_sym_SQUOTE] = ACTIONS(7480),
    [anon_sym_DQUOTE] = ACTIONS(7480),
    [sym_return] = ACTIONS(7482),
    [sym_next] = ACTIONS(7482),
    [sym_break] = ACTIONS(7482),
    [sym_true] = ACTIONS(7482),
    [sym_false] = ACTIONS(7482),
    [sym_null] = ACTIONS(7482),
    [sym_inf] = ACTIONS(7482),
    [sym_nan] = ACTIONS(7482),
    [anon_sym_NA] = ACTIONS(7482),
    [anon_sym_NA_integer_] = ACTIONS(7482),
    [anon_sym_NA_real_] = ACTIONS(7482),
    [anon_sym_NA_complex_] = ACTIONS(7482),
    [anon_sym_NA_character_] = ACTIONS(7482),
    [sym_dots] = ACTIONS(7482),
    [sym_dot_dot_i] = ACTIONS(7480),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7480),
    [sym__newline] = ACTIONS(7480),
    [sym__raw_string_literal] = ACTIONS(7480),
    [sym__external_else] = ACTIONS(7480),
    [sym__external_open_parenthesis] = ACTIONS(7480),
    [sym__external_close_parenthesis] = ACTIONS(7480),
    [sym__external_open_brace] = ACTIONS(7480),
    [sym__external_open_bracket] = ACTIONS(7480),
    [sym__external_close_bracket] = ACTIONS(7480),
    [sym__external_open_bracket2] = ACTIONS(7480),
  },
  [2707] = {
    [sym_identifier] = ACTIONS(7486),
    [anon_sym_BSLASH] = ACTIONS(7484),
    [anon_sym_function] = ACTIONS(7486),
    [anon_sym_EQ] = ACTIONS(7486),
    [anon_sym_if] = ACTIONS(7486),
    [anon_sym_for] = ACTIONS(7486),
    [anon_sym_while] = ACTIONS(7486),
    [anon_sym_repeat] = ACTIONS(7486),
    [anon_sym_QMARK] = ACTIONS(7484),
    [anon_sym_TILDE] = ACTIONS(7484),
    [anon_sym_BANG] = ACTIONS(7486),
    [anon_sym_PLUS] = ACTIONS(7484),
    [anon_sym_DASH] = ACTIONS(7486),
    [anon_sym_LT_DASH] = ACTIONS(7484),
    [anon_sym_LT_LT_DASH] = ACTIONS(7484),
    [anon_sym_COLON_EQ] = ACTIONS(7484),
    [anon_sym_DASH_GT] = ACTIONS(7486),
    [anon_sym_DASH_GT_GT] = ACTIONS(7484),
    [anon_sym_PIPE] = ACTIONS(7486),
    [anon_sym_AMP] = ACTIONS(7486),
    [anon_sym_PIPE_PIPE] = ACTIONS(7484),
    [anon_sym_AMP_AMP] = ACTIONS(7484),
    [anon_sym_LT] = ACTIONS(7486),
    [anon_sym_LT_EQ] = ACTIONS(7484),
    [anon_sym_GT] = ACTIONS(7486),
    [anon_sym_GT_EQ] = ACTIONS(7484),
    [anon_sym_EQ_EQ] = ACTIONS(7484),
    [anon_sym_BANG_EQ] = ACTIONS(7484),
    [anon_sym_STAR] = ACTIONS(7486),
    [anon_sym_SLASH] = ACTIONS(7484),
    [anon_sym_STAR_STAR] = ACTIONS(7484),
    [anon_sym_CARET] = ACTIONS(7484),
    [aux_sym_binary_operator_token1] = ACTIONS(7484),
    [anon_sym_PIPE_GT] = ACTIONS(7484),
    [anon_sym_COLON] = ACTIONS(7486),
    [anon_sym_DOLLAR] = ACTIONS(7484),
    [anon_sym_AT] = ACTIONS(7484),
    [aux_sym__hex_literal_token1] = ACTIONS(7484),
    [sym__number_literal] = ACTIONS(7486),
    [anon_sym_SQUOTE] = ACTIONS(7484),
    [anon_sym_DQUOTE] = ACTIONS(7484),
    [sym_return] = ACTIONS(7486),
    [sym_next] = ACTIONS(7486),
    [sym_break] = ACTIONS(7486),
    [sym_true] = ACTIONS(7486),
    [sym_false] = ACTIONS(7486),
    [sym_null] = ACTIONS(7486),
    [sym_inf] = ACTIONS(7486),
    [sym_nan] = ACTIONS(7486),
    [anon_sym_NA] = ACTIONS(7486),
    [anon_sym_NA_integer_] = ACTIONS(7486),
    [anon_sym_NA_real_] = ACTIONS(7486),
    [anon_sym_NA_complex_] = ACTIONS(7486),
    [anon_sym_NA_character_] = ACTIONS(7486),
    [sym_dots] = ACTIONS(7486),
    [sym_dot_dot_i] = ACTIONS(7484),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7484),
    [sym__newline] = ACTIONS(7484),
    [sym__semicolon] = ACTIONS(7484),
    [sym__raw_string_literal] = ACTIONS(7484),
    [sym__external_open_parenthesis] = ACTIONS(7484),
    [sym__external_open_brace] = ACTIONS(7484),
    [sym__external_close_brace] = ACTIONS(7484),
    [sym__external_open_bracket] = ACTIONS(7484),
    [sym__external_open_bracket2] = ACTIONS(7484),
    [sym__external_close_bracket2] = ACTIONS(7484),
  },
  [2708] = {
    [sym_identifier] = ACTIONS(7490),
    [anon_sym_BSLASH] = ACTIONS(7488),
    [anon_sym_function] = ACTIONS(7490),
    [anon_sym_EQ] = ACTIONS(7490),
    [anon_sym_if] = ACTIONS(7490),
    [anon_sym_for] = ACTIONS(7490),
    [anon_sym_while] = ACTIONS(7490),
    [anon_sym_repeat] = ACTIONS(7490),
    [anon_sym_QMARK] = ACTIONS(7488),
    [anon_sym_TILDE] = ACTIONS(7488),
    [anon_sym_BANG] = ACTIONS(7490),
    [anon_sym_PLUS] = ACTIONS(7488),
    [anon_sym_DASH] = ACTIONS(7490),
    [anon_sym_LT_DASH] = ACTIONS(7488),
    [anon_sym_LT_LT_DASH] = ACTIONS(7488),
    [anon_sym_COLON_EQ] = ACTIONS(7488),
    [anon_sym_DASH_GT] = ACTIONS(7490),
    [anon_sym_DASH_GT_GT] = ACTIONS(7488),
    [anon_sym_PIPE] = ACTIONS(7490),
    [anon_sym_AMP] = ACTIONS(7490),
    [anon_sym_PIPE_PIPE] = ACTIONS(7488),
    [anon_sym_AMP_AMP] = ACTIONS(7488),
    [anon_sym_LT] = ACTIONS(7490),
    [anon_sym_LT_EQ] = ACTIONS(7488),
    [anon_sym_GT] = ACTIONS(7490),
    [anon_sym_GT_EQ] = ACTIONS(7488),
    [anon_sym_EQ_EQ] = ACTIONS(7488),
    [anon_sym_BANG_EQ] = ACTIONS(7488),
    [anon_sym_STAR] = ACTIONS(7490),
    [anon_sym_SLASH] = ACTIONS(7488),
    [anon_sym_STAR_STAR] = ACTIONS(7488),
    [anon_sym_CARET] = ACTIONS(7488),
    [aux_sym_binary_operator_token1] = ACTIONS(7488),
    [anon_sym_PIPE_GT] = ACTIONS(7488),
    [anon_sym_COLON] = ACTIONS(7490),
    [anon_sym_DOLLAR] = ACTIONS(7488),
    [anon_sym_AT] = ACTIONS(7488),
    [aux_sym__hex_literal_token1] = ACTIONS(7488),
    [sym__number_literal] = ACTIONS(7490),
    [anon_sym_SQUOTE] = ACTIONS(7488),
    [anon_sym_DQUOTE] = ACTIONS(7488),
    [sym_return] = ACTIONS(7490),
    [sym_next] = ACTIONS(7490),
    [sym_break] = ACTIONS(7490),
    [sym_true] = ACTIONS(7490),
    [sym_false] = ACTIONS(7490),
    [sym_null] = ACTIONS(7490),
    [sym_inf] = ACTIONS(7490),
    [sym_nan] = ACTIONS(7490),
    [anon_sym_NA] = ACTIONS(7490),
    [anon_sym_NA_integer_] = ACTIONS(7490),
    [anon_sym_NA_real_] = ACTIONS(7490),
    [anon_sym_NA_complex_] = ACTIONS(7490),
    [anon_sym_NA_character_] = ACTIONS(7490),
    [sym_dots] = ACTIONS(7490),
    [sym_dot_dot_i] = ACTIONS(7488),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7488),
    [sym__newline] = ACTIONS(7488),
    [sym__semicolon] = ACTIONS(7488),
    [sym__raw_string_literal] = ACTIONS(7488),
    [sym__external_open_parenthesis] = ACTIONS(7488),
    [sym__external_open_brace] = ACTIONS(7488),
    [sym__external_close_brace] = ACTIONS(7488),
    [sym__external_open_bracket] = ACTIONS(7488),
    [sym__external_open_bracket2] = ACTIONS(7488),
    [sym__external_close_bracket2] = ACTIONS(7488),
  },
  [2709] = {
    [sym_identifier] = ACTIONS(7567),
    [anon_sym_BSLASH] = ACTIONS(7565),
    [anon_sym_function] = ACTIONS(7567),
    [anon_sym_EQ] = ACTIONS(7567),
    [anon_sym_if] = ACTIONS(7567),
    [anon_sym_for] = ACTIONS(7567),
    [anon_sym_while] = ACTIONS(7567),
    [anon_sym_repeat] = ACTIONS(7567),
    [anon_sym_QMARK] = ACTIONS(7565),
    [anon_sym_TILDE] = ACTIONS(7565),
    [anon_sym_BANG] = ACTIONS(7567),
    [anon_sym_PLUS] = ACTIONS(7565),
    [anon_sym_DASH] = ACTIONS(7567),
    [anon_sym_LT_DASH] = ACTIONS(7565),
    [anon_sym_LT_LT_DASH] = ACTIONS(7565),
    [anon_sym_COLON_EQ] = ACTIONS(7565),
    [anon_sym_DASH_GT] = ACTIONS(7567),
    [anon_sym_DASH_GT_GT] = ACTIONS(7565),
    [anon_sym_PIPE] = ACTIONS(7567),
    [anon_sym_AMP] = ACTIONS(7567),
    [anon_sym_PIPE_PIPE] = ACTIONS(7565),
    [anon_sym_AMP_AMP] = ACTIONS(7565),
    [anon_sym_LT] = ACTIONS(7567),
    [anon_sym_LT_EQ] = ACTIONS(7565),
    [anon_sym_GT] = ACTIONS(7567),
    [anon_sym_GT_EQ] = ACTIONS(7565),
    [anon_sym_EQ_EQ] = ACTIONS(7565),
    [anon_sym_BANG_EQ] = ACTIONS(7565),
    [anon_sym_STAR] = ACTIONS(7567),
    [anon_sym_SLASH] = ACTIONS(7565),
    [anon_sym_STAR_STAR] = ACTIONS(7565),
    [anon_sym_CARET] = ACTIONS(7565),
    [aux_sym_binary_operator_token1] = ACTIONS(7565),
    [anon_sym_PIPE_GT] = ACTIONS(7565),
    [anon_sym_COLON] = ACTIONS(7567),
    [anon_sym_DOLLAR] = ACTIONS(7565),
    [anon_sym_AT] = ACTIONS(7565),
    [aux_sym__hex_literal_token1] = ACTIONS(7565),
    [sym__number_literal] = ACTIONS(7567),
    [anon_sym_SQUOTE] = ACTIONS(7565),
    [anon_sym_DQUOTE] = ACTIONS(7565),
    [sym_return] = ACTIONS(7567),
    [sym_next] = ACTIONS(7567),
    [sym_break] = ACTIONS(7567),
    [sym_true] = ACTIONS(7567),
    [sym_false] = ACTIONS(7567),
    [sym_null] = ACTIONS(7567),
    [sym_inf] = ACTIONS(7567),
    [sym_nan] = ACTIONS(7567),
    [anon_sym_NA] = ACTIONS(7567),
    [anon_sym_NA_integer_] = ACTIONS(7567),
    [anon_sym_NA_real_] = ACTIONS(7567),
    [anon_sym_NA_complex_] = ACTIONS(7567),
    [anon_sym_NA_character_] = ACTIONS(7567),
    [sym_dots] = ACTIONS(7567),
    [sym_dot_dot_i] = ACTIONS(7565),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7565),
    [sym__newline] = ACTIONS(7565),
    [sym__semicolon] = ACTIONS(7565),
    [sym__raw_string_literal] = ACTIONS(7565),
    [sym__external_open_parenthesis] = ACTIONS(7565),
    [sym__external_open_brace] = ACTIONS(7565),
    [sym__external_close_brace] = ACTIONS(7565),
    [sym__external_open_bracket] = ACTIONS(7565),
    [sym__external_close_bracket] = ACTIONS(7565),
    [sym__external_open_bracket2] = ACTIONS(7565),
  },
  [2710] = {
    [sym_identifier] = ACTIONS(7563),
    [anon_sym_BSLASH] = ACTIONS(7561),
    [anon_sym_function] = ACTIONS(7563),
    [anon_sym_EQ] = ACTIONS(7563),
    [anon_sym_if] = ACTIONS(7563),
    [anon_sym_for] = ACTIONS(7563),
    [anon_sym_while] = ACTIONS(7563),
    [anon_sym_repeat] = ACTIONS(7563),
    [anon_sym_QMARK] = ACTIONS(7561),
    [anon_sym_TILDE] = ACTIONS(7561),
    [anon_sym_BANG] = ACTIONS(7563),
    [anon_sym_PLUS] = ACTIONS(7561),
    [anon_sym_DASH] = ACTIONS(7563),
    [anon_sym_LT_DASH] = ACTIONS(7561),
    [anon_sym_LT_LT_DASH] = ACTIONS(7561),
    [anon_sym_COLON_EQ] = ACTIONS(7561),
    [anon_sym_DASH_GT] = ACTIONS(7563),
    [anon_sym_DASH_GT_GT] = ACTIONS(7561),
    [anon_sym_PIPE] = ACTIONS(7563),
    [anon_sym_AMP] = ACTIONS(7563),
    [anon_sym_PIPE_PIPE] = ACTIONS(7561),
    [anon_sym_AMP_AMP] = ACTIONS(7561),
    [anon_sym_LT] = ACTIONS(7563),
    [anon_sym_LT_EQ] = ACTIONS(7561),
    [anon_sym_GT] = ACTIONS(7563),
    [anon_sym_GT_EQ] = ACTIONS(7561),
    [anon_sym_EQ_EQ] = ACTIONS(7561),
    [anon_sym_BANG_EQ] = ACTIONS(7561),
    [anon_sym_STAR] = ACTIONS(7563),
    [anon_sym_SLASH] = ACTIONS(7561),
    [anon_sym_STAR_STAR] = ACTIONS(7561),
    [anon_sym_CARET] = ACTIONS(7561),
    [aux_sym_binary_operator_token1] = ACTIONS(7561),
    [anon_sym_PIPE_GT] = ACTIONS(7561),
    [anon_sym_COLON] = ACTIONS(7563),
    [anon_sym_DOLLAR] = ACTIONS(7561),
    [anon_sym_AT] = ACTIONS(7561),
    [aux_sym__hex_literal_token1] = ACTIONS(7561),
    [sym__number_literal] = ACTIONS(7563),
    [anon_sym_SQUOTE] = ACTIONS(7561),
    [anon_sym_DQUOTE] = ACTIONS(7561),
    [sym_return] = ACTIONS(7563),
    [sym_next] = ACTIONS(7563),
    [sym_break] = ACTIONS(7563),
    [sym_true] = ACTIONS(7563),
    [sym_false] = ACTIONS(7563),
    [sym_null] = ACTIONS(7563),
    [sym_inf] = ACTIONS(7563),
    [sym_nan] = ACTIONS(7563),
    [anon_sym_NA] = ACTIONS(7563),
    [anon_sym_NA_integer_] = ACTIONS(7563),
    [anon_sym_NA_real_] = ACTIONS(7563),
    [anon_sym_NA_complex_] = ACTIONS(7563),
    [anon_sym_NA_character_] = ACTIONS(7563),
    [sym_dots] = ACTIONS(7563),
    [sym_dot_dot_i] = ACTIONS(7561),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7561),
    [sym__newline] = ACTIONS(7561),
    [sym__raw_string_literal] = ACTIONS(7561),
    [sym__external_else] = ACTIONS(7561),
    [sym__external_open_parenthesis] = ACTIONS(7561),
    [sym__external_close_parenthesis] = ACTIONS(7561),
    [sym__external_open_brace] = ACTIONS(7561),
    [sym__external_open_bracket] = ACTIONS(7561),
    [sym__external_open_bracket2] = ACTIONS(7561),
    [sym__external_close_bracket2] = ACTIONS(7561),
  },
  [2711] = {
    [sym_identifier] = ACTIONS(7486),
    [anon_sym_BSLASH] = ACTIONS(7484),
    [anon_sym_function] = ACTIONS(7486),
    [anon_sym_EQ] = ACTIONS(7486),
    [anon_sym_if] = ACTIONS(7486),
    [anon_sym_for] = ACTIONS(7486),
    [anon_sym_while] = ACTIONS(7486),
    [anon_sym_repeat] = ACTIONS(7486),
    [anon_sym_QMARK] = ACTIONS(7484),
    [anon_sym_TILDE] = ACTIONS(7484),
    [anon_sym_BANG] = ACTIONS(7486),
    [anon_sym_PLUS] = ACTIONS(7484),
    [anon_sym_DASH] = ACTIONS(7486),
    [anon_sym_LT_DASH] = ACTIONS(7484),
    [anon_sym_LT_LT_DASH] = ACTIONS(7484),
    [anon_sym_COLON_EQ] = ACTIONS(7484),
    [anon_sym_DASH_GT] = ACTIONS(7486),
    [anon_sym_DASH_GT_GT] = ACTIONS(7484),
    [anon_sym_PIPE] = ACTIONS(7486),
    [anon_sym_AMP] = ACTIONS(7486),
    [anon_sym_PIPE_PIPE] = ACTIONS(7484),
    [anon_sym_AMP_AMP] = ACTIONS(7484),
    [anon_sym_LT] = ACTIONS(7486),
    [anon_sym_LT_EQ] = ACTIONS(7484),
    [anon_sym_GT] = ACTIONS(7486),
    [anon_sym_GT_EQ] = ACTIONS(7484),
    [anon_sym_EQ_EQ] = ACTIONS(7484),
    [anon_sym_BANG_EQ] = ACTIONS(7484),
    [anon_sym_STAR] = ACTIONS(7486),
    [anon_sym_SLASH] = ACTIONS(7484),
    [anon_sym_STAR_STAR] = ACTIONS(7484),
    [anon_sym_CARET] = ACTIONS(7484),
    [aux_sym_binary_operator_token1] = ACTIONS(7484),
    [anon_sym_PIPE_GT] = ACTIONS(7484),
    [anon_sym_COLON] = ACTIONS(7486),
    [anon_sym_DOLLAR] = ACTIONS(7484),
    [anon_sym_AT] = ACTIONS(7484),
    [aux_sym__hex_literal_token1] = ACTIONS(7484),
    [sym__number_literal] = ACTIONS(7486),
    [anon_sym_SQUOTE] = ACTIONS(7484),
    [anon_sym_DQUOTE] = ACTIONS(7484),
    [sym_return] = ACTIONS(7486),
    [sym_next] = ACTIONS(7486),
    [sym_break] = ACTIONS(7486),
    [sym_true] = ACTIONS(7486),
    [sym_false] = ACTIONS(7486),
    [sym_null] = ACTIONS(7486),
    [sym_inf] = ACTIONS(7486),
    [sym_nan] = ACTIONS(7486),
    [anon_sym_NA] = ACTIONS(7486),
    [anon_sym_NA_integer_] = ACTIONS(7486),
    [anon_sym_NA_real_] = ACTIONS(7486),
    [anon_sym_NA_complex_] = ACTIONS(7486),
    [anon_sym_NA_character_] = ACTIONS(7486),
    [sym_dots] = ACTIONS(7486),
    [sym_dot_dot_i] = ACTIONS(7484),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7484),
    [sym__newline] = ACTIONS(7484),
    [sym__raw_string_literal] = ACTIONS(7484),
    [sym__external_else] = ACTIONS(7484),
    [sym__external_open_parenthesis] = ACTIONS(7484),
    [sym__external_close_parenthesis] = ACTIONS(7484),
    [sym__external_open_brace] = ACTIONS(7484),
    [sym__external_open_bracket] = ACTIONS(7484),
    [sym__external_close_bracket] = ACTIONS(7484),
    [sym__external_open_bracket2] = ACTIONS(7484),
  },
  [2712] = {
    [sym_identifier] = ACTIONS(7490),
    [anon_sym_BSLASH] = ACTIONS(7488),
    [anon_sym_function] = ACTIONS(7490),
    [anon_sym_EQ] = ACTIONS(7490),
    [anon_sym_if] = ACTIONS(7490),
    [anon_sym_for] = ACTIONS(7490),
    [anon_sym_while] = ACTIONS(7490),
    [anon_sym_repeat] = ACTIONS(7490),
    [anon_sym_QMARK] = ACTIONS(7488),
    [anon_sym_TILDE] = ACTIONS(7488),
    [anon_sym_BANG] = ACTIONS(7490),
    [anon_sym_PLUS] = ACTIONS(7488),
    [anon_sym_DASH] = ACTIONS(7490),
    [anon_sym_LT_DASH] = ACTIONS(7488),
    [anon_sym_LT_LT_DASH] = ACTIONS(7488),
    [anon_sym_COLON_EQ] = ACTIONS(7488),
    [anon_sym_DASH_GT] = ACTIONS(7490),
    [anon_sym_DASH_GT_GT] = ACTIONS(7488),
    [anon_sym_PIPE] = ACTIONS(7490),
    [anon_sym_AMP] = ACTIONS(7490),
    [anon_sym_PIPE_PIPE] = ACTIONS(7488),
    [anon_sym_AMP_AMP] = ACTIONS(7488),
    [anon_sym_LT] = ACTIONS(7490),
    [anon_sym_LT_EQ] = ACTIONS(7488),
    [anon_sym_GT] = ACTIONS(7490),
    [anon_sym_GT_EQ] = ACTIONS(7488),
    [anon_sym_EQ_EQ] = ACTIONS(7488),
    [anon_sym_BANG_EQ] = ACTIONS(7488),
    [anon_sym_STAR] = ACTIONS(7490),
    [anon_sym_SLASH] = ACTIONS(7488),
    [anon_sym_STAR_STAR] = ACTIONS(7488),
    [anon_sym_CARET] = ACTIONS(7488),
    [aux_sym_binary_operator_token1] = ACTIONS(7488),
    [anon_sym_PIPE_GT] = ACTIONS(7488),
    [anon_sym_COLON] = ACTIONS(7490),
    [anon_sym_DOLLAR] = ACTIONS(7488),
    [anon_sym_AT] = ACTIONS(7488),
    [aux_sym__hex_literal_token1] = ACTIONS(7488),
    [sym__number_literal] = ACTIONS(7490),
    [anon_sym_SQUOTE] = ACTIONS(7488),
    [anon_sym_DQUOTE] = ACTIONS(7488),
    [sym_return] = ACTIONS(7490),
    [sym_next] = ACTIONS(7490),
    [sym_break] = ACTIONS(7490),
    [sym_true] = ACTIONS(7490),
    [sym_false] = ACTIONS(7490),
    [sym_null] = ACTIONS(7490),
    [sym_inf] = ACTIONS(7490),
    [sym_nan] = ACTIONS(7490),
    [anon_sym_NA] = ACTIONS(7490),
    [anon_sym_NA_integer_] = ACTIONS(7490),
    [anon_sym_NA_real_] = ACTIONS(7490),
    [anon_sym_NA_complex_] = ACTIONS(7490),
    [anon_sym_NA_character_] = ACTIONS(7490),
    [sym_dots] = ACTIONS(7490),
    [sym_dot_dot_i] = ACTIONS(7488),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7488),
    [sym__newline] = ACTIONS(7488),
    [sym__raw_string_literal] = ACTIONS(7488),
    [sym__external_else] = ACTIONS(7488),
    [sym__external_open_parenthesis] = ACTIONS(7488),
    [sym__external_close_parenthesis] = ACTIONS(7488),
    [sym__external_open_brace] = ACTIONS(7488),
    [sym__external_open_bracket] = ACTIONS(7488),
    [sym__external_close_bracket] = ACTIONS(7488),
    [sym__external_open_bracket2] = ACTIONS(7488),
  },
  [2713] = {
    [sym_identifier] = ACTIONS(7494),
    [anon_sym_BSLASH] = ACTIONS(7492),
    [anon_sym_function] = ACTIONS(7494),
    [anon_sym_EQ] = ACTIONS(7494),
    [anon_sym_if] = ACTIONS(7494),
    [anon_sym_for] = ACTIONS(7494),
    [anon_sym_while] = ACTIONS(7494),
    [anon_sym_repeat] = ACTIONS(7494),
    [anon_sym_QMARK] = ACTIONS(7492),
    [anon_sym_TILDE] = ACTIONS(7492),
    [anon_sym_BANG] = ACTIONS(7494),
    [anon_sym_PLUS] = ACTIONS(7492),
    [anon_sym_DASH] = ACTIONS(7494),
    [anon_sym_LT_DASH] = ACTIONS(7492),
    [anon_sym_LT_LT_DASH] = ACTIONS(7492),
    [anon_sym_COLON_EQ] = ACTIONS(7492),
    [anon_sym_DASH_GT] = ACTIONS(7494),
    [anon_sym_DASH_GT_GT] = ACTIONS(7492),
    [anon_sym_PIPE] = ACTIONS(7494),
    [anon_sym_AMP] = ACTIONS(7494),
    [anon_sym_PIPE_PIPE] = ACTIONS(7492),
    [anon_sym_AMP_AMP] = ACTIONS(7492),
    [anon_sym_LT] = ACTIONS(7494),
    [anon_sym_LT_EQ] = ACTIONS(7492),
    [anon_sym_GT] = ACTIONS(7494),
    [anon_sym_GT_EQ] = ACTIONS(7492),
    [anon_sym_EQ_EQ] = ACTIONS(7492),
    [anon_sym_BANG_EQ] = ACTIONS(7492),
    [anon_sym_STAR] = ACTIONS(7494),
    [anon_sym_SLASH] = ACTIONS(7492),
    [anon_sym_STAR_STAR] = ACTIONS(7492),
    [anon_sym_CARET] = ACTIONS(7492),
    [aux_sym_binary_operator_token1] = ACTIONS(7492),
    [anon_sym_PIPE_GT] = ACTIONS(7492),
    [anon_sym_COLON] = ACTIONS(7494),
    [anon_sym_DOLLAR] = ACTIONS(7492),
    [anon_sym_AT] = ACTIONS(7492),
    [aux_sym__hex_literal_token1] = ACTIONS(7492),
    [sym__number_literal] = ACTIONS(7494),
    [anon_sym_SQUOTE] = ACTIONS(7492),
    [anon_sym_DQUOTE] = ACTIONS(7492),
    [sym_return] = ACTIONS(7494),
    [sym_next] = ACTIONS(7494),
    [sym_break] = ACTIONS(7494),
    [sym_true] = ACTIONS(7494),
    [sym_false] = ACTIONS(7494),
    [sym_null] = ACTIONS(7494),
    [sym_inf] = ACTIONS(7494),
    [sym_nan] = ACTIONS(7494),
    [anon_sym_NA] = ACTIONS(7494),
    [anon_sym_NA_integer_] = ACTIONS(7494),
    [anon_sym_NA_real_] = ACTIONS(7494),
    [anon_sym_NA_complex_] = ACTIONS(7494),
    [anon_sym_NA_character_] = ACTIONS(7494),
    [sym_dots] = ACTIONS(7494),
    [sym_dot_dot_i] = ACTIONS(7492),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7492),
    [sym__newline] = ACTIONS(7492),
    [sym__raw_string_literal] = ACTIONS(7492),
    [sym__external_else] = ACTIONS(7492),
    [sym__external_open_parenthesis] = ACTIONS(7492),
    [sym__external_close_parenthesis] = ACTIONS(7492),
    [sym__external_open_brace] = ACTIONS(7492),
    [sym__external_open_bracket] = ACTIONS(7492),
    [sym__external_close_bracket] = ACTIONS(7492),
    [sym__external_open_bracket2] = ACTIONS(7492),
  },
  [2714] = {
    [sym_identifier] = ACTIONS(7498),
    [anon_sym_BSLASH] = ACTIONS(7496),
    [anon_sym_function] = ACTIONS(7498),
    [anon_sym_EQ] = ACTIONS(7498),
    [anon_sym_if] = ACTIONS(7498),
    [anon_sym_for] = ACTIONS(7498),
    [anon_sym_while] = ACTIONS(7498),
    [anon_sym_repeat] = ACTIONS(7498),
    [anon_sym_QMARK] = ACTIONS(7496),
    [anon_sym_TILDE] = ACTIONS(7496),
    [anon_sym_BANG] = ACTIONS(7498),
    [anon_sym_PLUS] = ACTIONS(7496),
    [anon_sym_DASH] = ACTIONS(7498),
    [anon_sym_LT_DASH] = ACTIONS(7496),
    [anon_sym_LT_LT_DASH] = ACTIONS(7496),
    [anon_sym_COLON_EQ] = ACTIONS(7496),
    [anon_sym_DASH_GT] = ACTIONS(7498),
    [anon_sym_DASH_GT_GT] = ACTIONS(7496),
    [anon_sym_PIPE] = ACTIONS(7498),
    [anon_sym_AMP] = ACTIONS(7498),
    [anon_sym_PIPE_PIPE] = ACTIONS(7496),
    [anon_sym_AMP_AMP] = ACTIONS(7496),
    [anon_sym_LT] = ACTIONS(7498),
    [anon_sym_LT_EQ] = ACTIONS(7496),
    [anon_sym_GT] = ACTIONS(7498),
    [anon_sym_GT_EQ] = ACTIONS(7496),
    [anon_sym_EQ_EQ] = ACTIONS(7496),
    [anon_sym_BANG_EQ] = ACTIONS(7496),
    [anon_sym_STAR] = ACTIONS(7498),
    [anon_sym_SLASH] = ACTIONS(7496),
    [anon_sym_STAR_STAR] = ACTIONS(7496),
    [anon_sym_CARET] = ACTIONS(7496),
    [aux_sym_binary_operator_token1] = ACTIONS(7496),
    [anon_sym_PIPE_GT] = ACTIONS(7496),
    [anon_sym_COLON] = ACTIONS(7498),
    [anon_sym_DOLLAR] = ACTIONS(7496),
    [anon_sym_AT] = ACTIONS(7496),
    [aux_sym__hex_literal_token1] = ACTIONS(7496),
    [sym__number_literal] = ACTIONS(7498),
    [anon_sym_SQUOTE] = ACTIONS(7496),
    [anon_sym_DQUOTE] = ACTIONS(7496),
    [sym_return] = ACTIONS(7498),
    [sym_next] = ACTIONS(7498),
    [sym_break] = ACTIONS(7498),
    [sym_true] = ACTIONS(7498),
    [sym_false] = ACTIONS(7498),
    [sym_null] = ACTIONS(7498),
    [sym_inf] = ACTIONS(7498),
    [sym_nan] = ACTIONS(7498),
    [anon_sym_NA] = ACTIONS(7498),
    [anon_sym_NA_integer_] = ACTIONS(7498),
    [anon_sym_NA_real_] = ACTIONS(7498),
    [anon_sym_NA_complex_] = ACTIONS(7498),
    [anon_sym_NA_character_] = ACTIONS(7498),
    [sym_dots] = ACTIONS(7498),
    [sym_dot_dot_i] = ACTIONS(7496),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7496),
    [sym__newline] = ACTIONS(7496),
    [sym__raw_string_literal] = ACTIONS(7496),
    [sym__external_else] = ACTIONS(7496),
    [sym__external_open_parenthesis] = ACTIONS(7496),
    [sym__external_close_parenthesis] = ACTIONS(7496),
    [sym__external_open_brace] = ACTIONS(7496),
    [sym__external_open_bracket] = ACTIONS(7496),
    [sym__external_close_bracket] = ACTIONS(7496),
    [sym__external_open_bracket2] = ACTIONS(7496),
  },
  [2715] = {
    [sym_identifier] = ACTIONS(7502),
    [anon_sym_BSLASH] = ACTIONS(7500),
    [anon_sym_function] = ACTIONS(7502),
    [anon_sym_EQ] = ACTIONS(7502),
    [anon_sym_if] = ACTIONS(7502),
    [anon_sym_for] = ACTIONS(7502),
    [anon_sym_while] = ACTIONS(7502),
    [anon_sym_repeat] = ACTIONS(7502),
    [anon_sym_QMARK] = ACTIONS(7500),
    [anon_sym_TILDE] = ACTIONS(7500),
    [anon_sym_BANG] = ACTIONS(7502),
    [anon_sym_PLUS] = ACTIONS(7500),
    [anon_sym_DASH] = ACTIONS(7502),
    [anon_sym_LT_DASH] = ACTIONS(7500),
    [anon_sym_LT_LT_DASH] = ACTIONS(7500),
    [anon_sym_COLON_EQ] = ACTIONS(7500),
    [anon_sym_DASH_GT] = ACTIONS(7502),
    [anon_sym_DASH_GT_GT] = ACTIONS(7500),
    [anon_sym_PIPE] = ACTIONS(7502),
    [anon_sym_AMP] = ACTIONS(7502),
    [anon_sym_PIPE_PIPE] = ACTIONS(7500),
    [anon_sym_AMP_AMP] = ACTIONS(7500),
    [anon_sym_LT] = ACTIONS(7502),
    [anon_sym_LT_EQ] = ACTIONS(7500),
    [anon_sym_GT] = ACTIONS(7502),
    [anon_sym_GT_EQ] = ACTIONS(7500),
    [anon_sym_EQ_EQ] = ACTIONS(7500),
    [anon_sym_BANG_EQ] = ACTIONS(7500),
    [anon_sym_STAR] = ACTIONS(7502),
    [anon_sym_SLASH] = ACTIONS(7500),
    [anon_sym_STAR_STAR] = ACTIONS(7500),
    [anon_sym_CARET] = ACTIONS(7500),
    [aux_sym_binary_operator_token1] = ACTIONS(7500),
    [anon_sym_PIPE_GT] = ACTIONS(7500),
    [anon_sym_COLON] = ACTIONS(7502),
    [anon_sym_DOLLAR] = ACTIONS(7500),
    [anon_sym_AT] = ACTIONS(7500),
    [aux_sym__hex_literal_token1] = ACTIONS(7500),
    [sym__number_literal] = ACTIONS(7502),
    [anon_sym_SQUOTE] = ACTIONS(7500),
    [anon_sym_DQUOTE] = ACTIONS(7500),
    [sym_return] = ACTIONS(7502),
    [sym_next] = ACTIONS(7502),
    [sym_break] = ACTIONS(7502),
    [sym_true] = ACTIONS(7502),
    [sym_false] = ACTIONS(7502),
    [sym_null] = ACTIONS(7502),
    [sym_inf] = ACTIONS(7502),
    [sym_nan] = ACTIONS(7502),
    [anon_sym_NA] = ACTIONS(7502),
    [anon_sym_NA_integer_] = ACTIONS(7502),
    [anon_sym_NA_real_] = ACTIONS(7502),
    [anon_sym_NA_complex_] = ACTIONS(7502),
    [anon_sym_NA_character_] = ACTIONS(7502),
    [sym_dots] = ACTIONS(7502),
    [sym_dot_dot_i] = ACTIONS(7500),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7500),
    [sym__newline] = ACTIONS(7500),
    [sym__raw_string_literal] = ACTIONS(7500),
    [sym__external_else] = ACTIONS(7500),
    [sym__external_open_parenthesis] = ACTIONS(7500),
    [sym__external_close_parenthesis] = ACTIONS(7500),
    [sym__external_open_brace] = ACTIONS(7500),
    [sym__external_open_bracket] = ACTIONS(7500),
    [sym__external_close_bracket] = ACTIONS(7500),
    [sym__external_open_bracket2] = ACTIONS(7500),
  },
  [2716] = {
    [sym_identifier] = ACTIONS(7506),
    [anon_sym_BSLASH] = ACTIONS(7504),
    [anon_sym_function] = ACTIONS(7506),
    [anon_sym_EQ] = ACTIONS(7506),
    [anon_sym_if] = ACTIONS(7506),
    [anon_sym_for] = ACTIONS(7506),
    [anon_sym_while] = ACTIONS(7506),
    [anon_sym_repeat] = ACTIONS(7506),
    [anon_sym_QMARK] = ACTIONS(7504),
    [anon_sym_TILDE] = ACTIONS(7504),
    [anon_sym_BANG] = ACTIONS(7506),
    [anon_sym_PLUS] = ACTIONS(7504),
    [anon_sym_DASH] = ACTIONS(7506),
    [anon_sym_LT_DASH] = ACTIONS(7504),
    [anon_sym_LT_LT_DASH] = ACTIONS(7504),
    [anon_sym_COLON_EQ] = ACTIONS(7504),
    [anon_sym_DASH_GT] = ACTIONS(7506),
    [anon_sym_DASH_GT_GT] = ACTIONS(7504),
    [anon_sym_PIPE] = ACTIONS(7506),
    [anon_sym_AMP] = ACTIONS(7506),
    [anon_sym_PIPE_PIPE] = ACTIONS(7504),
    [anon_sym_AMP_AMP] = ACTIONS(7504),
    [anon_sym_LT] = ACTIONS(7506),
    [anon_sym_LT_EQ] = ACTIONS(7504),
    [anon_sym_GT] = ACTIONS(7506),
    [anon_sym_GT_EQ] = ACTIONS(7504),
    [anon_sym_EQ_EQ] = ACTIONS(7504),
    [anon_sym_BANG_EQ] = ACTIONS(7504),
    [anon_sym_STAR] = ACTIONS(7506),
    [anon_sym_SLASH] = ACTIONS(7504),
    [anon_sym_STAR_STAR] = ACTIONS(7504),
    [anon_sym_CARET] = ACTIONS(7504),
    [aux_sym_binary_operator_token1] = ACTIONS(7504),
    [anon_sym_PIPE_GT] = ACTIONS(7504),
    [anon_sym_COLON] = ACTIONS(7506),
    [anon_sym_DOLLAR] = ACTIONS(7504),
    [anon_sym_AT] = ACTIONS(7504),
    [aux_sym__hex_literal_token1] = ACTIONS(7504),
    [sym__number_literal] = ACTIONS(7506),
    [anon_sym_SQUOTE] = ACTIONS(7504),
    [anon_sym_DQUOTE] = ACTIONS(7504),
    [sym_return] = ACTIONS(7506),
    [sym_next] = ACTIONS(7506),
    [sym_break] = ACTIONS(7506),
    [sym_true] = ACTIONS(7506),
    [sym_false] = ACTIONS(7506),
    [sym_null] = ACTIONS(7506),
    [sym_inf] = ACTIONS(7506),
    [sym_nan] = ACTIONS(7506),
    [anon_sym_NA] = ACTIONS(7506),
    [anon_sym_NA_integer_] = ACTIONS(7506),
    [anon_sym_NA_real_] = ACTIONS(7506),
    [anon_sym_NA_complex_] = ACTIONS(7506),
    [anon_sym_NA_character_] = ACTIONS(7506),
    [sym_dots] = ACTIONS(7506),
    [sym_dot_dot_i] = ACTIONS(7504),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7504),
    [sym__newline] = ACTIONS(7504),
    [sym__raw_string_literal] = ACTIONS(7504),
    [sym__external_else] = ACTIONS(7504),
    [sym__external_open_parenthesis] = ACTIONS(7504),
    [sym__external_close_parenthesis] = ACTIONS(7504),
    [sym__external_open_brace] = ACTIONS(7504),
    [sym__external_open_bracket] = ACTIONS(7504),
    [sym__external_close_bracket] = ACTIONS(7504),
    [sym__external_open_bracket2] = ACTIONS(7504),
  },
  [2717] = {
    [sym_identifier] = ACTIONS(7512),
    [anon_sym_BSLASH] = ACTIONS(7510),
    [anon_sym_function] = ACTIONS(7512),
    [anon_sym_EQ] = ACTIONS(7512),
    [anon_sym_if] = ACTIONS(7512),
    [anon_sym_for] = ACTIONS(7512),
    [anon_sym_while] = ACTIONS(7512),
    [anon_sym_repeat] = ACTIONS(7512),
    [anon_sym_QMARK] = ACTIONS(7510),
    [anon_sym_TILDE] = ACTIONS(7510),
    [anon_sym_BANG] = ACTIONS(7512),
    [anon_sym_PLUS] = ACTIONS(7510),
    [anon_sym_DASH] = ACTIONS(7512),
    [anon_sym_LT_DASH] = ACTIONS(7510),
    [anon_sym_LT_LT_DASH] = ACTIONS(7510),
    [anon_sym_COLON_EQ] = ACTIONS(7510),
    [anon_sym_DASH_GT] = ACTIONS(7512),
    [anon_sym_DASH_GT_GT] = ACTIONS(7510),
    [anon_sym_PIPE] = ACTIONS(7512),
    [anon_sym_AMP] = ACTIONS(7512),
    [anon_sym_PIPE_PIPE] = ACTIONS(7510),
    [anon_sym_AMP_AMP] = ACTIONS(7510),
    [anon_sym_LT] = ACTIONS(7512),
    [anon_sym_LT_EQ] = ACTIONS(7510),
    [anon_sym_GT] = ACTIONS(7512),
    [anon_sym_GT_EQ] = ACTIONS(7510),
    [anon_sym_EQ_EQ] = ACTIONS(7510),
    [anon_sym_BANG_EQ] = ACTIONS(7510),
    [anon_sym_STAR] = ACTIONS(7512),
    [anon_sym_SLASH] = ACTIONS(7510),
    [anon_sym_STAR_STAR] = ACTIONS(7510),
    [anon_sym_CARET] = ACTIONS(7510),
    [aux_sym_binary_operator_token1] = ACTIONS(7510),
    [anon_sym_PIPE_GT] = ACTIONS(7510),
    [anon_sym_COLON] = ACTIONS(7512),
    [anon_sym_DOLLAR] = ACTIONS(7510),
    [anon_sym_AT] = ACTIONS(7510),
    [aux_sym__hex_literal_token1] = ACTIONS(7510),
    [sym__number_literal] = ACTIONS(7512),
    [anon_sym_SQUOTE] = ACTIONS(7510),
    [anon_sym_DQUOTE] = ACTIONS(7510),
    [sym_return] = ACTIONS(7512),
    [sym_next] = ACTIONS(7512),
    [sym_break] = ACTIONS(7512),
    [sym_true] = ACTIONS(7512),
    [sym_false] = ACTIONS(7512),
    [sym_null] = ACTIONS(7512),
    [sym_inf] = ACTIONS(7512),
    [sym_nan] = ACTIONS(7512),
    [anon_sym_NA] = ACTIONS(7512),
    [anon_sym_NA_integer_] = ACTIONS(7512),
    [anon_sym_NA_real_] = ACTIONS(7512),
    [anon_sym_NA_complex_] = ACTIONS(7512),
    [anon_sym_NA_character_] = ACTIONS(7512),
    [sym_dots] = ACTIONS(7512),
    [sym_dot_dot_i] = ACTIONS(7510),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7510),
    [sym__newline] = ACTIONS(7510),
    [sym__raw_string_literal] = ACTIONS(7510),
    [sym__external_else] = ACTIONS(7510),
    [sym__external_open_parenthesis] = ACTIONS(7510),
    [sym__external_close_parenthesis] = ACTIONS(7510),
    [sym__external_open_brace] = ACTIONS(7510),
    [sym__external_open_bracket] = ACTIONS(7510),
    [sym__external_close_bracket] = ACTIONS(7510),
    [sym__external_open_bracket2] = ACTIONS(7510),
  },
  [2718] = {
    [ts_builtin_sym_end] = ACTIONS(7165),
    [sym_identifier] = ACTIONS(7163),
    [anon_sym_BSLASH] = ACTIONS(7165),
    [anon_sym_function] = ACTIONS(7163),
    [anon_sym_EQ] = ACTIONS(7163),
    [anon_sym_if] = ACTIONS(7163),
    [anon_sym_for] = ACTIONS(7163),
    [anon_sym_while] = ACTIONS(7163),
    [anon_sym_repeat] = ACTIONS(7163),
    [anon_sym_QMARK] = ACTIONS(7165),
    [anon_sym_TILDE] = ACTIONS(7165),
    [anon_sym_BANG] = ACTIONS(7163),
    [anon_sym_PLUS] = ACTIONS(7165),
    [anon_sym_DASH] = ACTIONS(7163),
    [anon_sym_LT_DASH] = ACTIONS(7165),
    [anon_sym_LT_LT_DASH] = ACTIONS(7165),
    [anon_sym_COLON_EQ] = ACTIONS(7165),
    [anon_sym_DASH_GT] = ACTIONS(7163),
    [anon_sym_DASH_GT_GT] = ACTIONS(7165),
    [anon_sym_PIPE] = ACTIONS(7163),
    [anon_sym_AMP] = ACTIONS(7163),
    [anon_sym_PIPE_PIPE] = ACTIONS(7165),
    [anon_sym_AMP_AMP] = ACTIONS(7165),
    [anon_sym_LT] = ACTIONS(7163),
    [anon_sym_LT_EQ] = ACTIONS(7165),
    [anon_sym_GT] = ACTIONS(7163),
    [anon_sym_GT_EQ] = ACTIONS(7165),
    [anon_sym_EQ_EQ] = ACTIONS(7165),
    [anon_sym_BANG_EQ] = ACTIONS(7165),
    [anon_sym_STAR] = ACTIONS(7163),
    [anon_sym_SLASH] = ACTIONS(7165),
    [anon_sym_STAR_STAR] = ACTIONS(7165),
    [anon_sym_CARET] = ACTIONS(7165),
    [aux_sym_binary_operator_token1] = ACTIONS(7165),
    [anon_sym_PIPE_GT] = ACTIONS(7165),
    [anon_sym_COLON] = ACTIONS(7163),
    [anon_sym_DOLLAR] = ACTIONS(7165),
    [anon_sym_AT] = ACTIONS(7165),
    [anon_sym_COLON_COLON] = ACTIONS(7163),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7165),
    [aux_sym__hex_literal_token1] = ACTIONS(7165),
    [sym__number_literal] = ACTIONS(7163),
    [anon_sym_SQUOTE] = ACTIONS(7165),
    [anon_sym_DQUOTE] = ACTIONS(7165),
    [sym_return] = ACTIONS(7163),
    [sym_next] = ACTIONS(7163),
    [sym_break] = ACTIONS(7163),
    [sym_true] = ACTIONS(7163),
    [sym_false] = ACTIONS(7163),
    [sym_null] = ACTIONS(7163),
    [sym_inf] = ACTIONS(7163),
    [sym_nan] = ACTIONS(7163),
    [anon_sym_NA] = ACTIONS(7163),
    [anon_sym_NA_integer_] = ACTIONS(7163),
    [anon_sym_NA_real_] = ACTIONS(7163),
    [anon_sym_NA_complex_] = ACTIONS(7163),
    [anon_sym_NA_character_] = ACTIONS(7163),
    [sym_dots] = ACTIONS(7163),
    [sym_dot_dot_i] = ACTIONS(7165),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7165),
    [sym__semicolon] = ACTIONS(7165),
    [sym__raw_string_literal] = ACTIONS(7165),
    [sym__external_open_parenthesis] = ACTIONS(7165),
    [sym__external_open_brace] = ACTIONS(7165),
    [sym__external_open_bracket] = ACTIONS(7165),
    [sym__external_open_bracket2] = ACTIONS(7165),
  },
  [2719] = {
    [ts_builtin_sym_end] = ACTIONS(7554),
    [sym_identifier] = ACTIONS(7556),
    [anon_sym_BSLASH] = ACTIONS(7554),
    [anon_sym_function] = ACTIONS(7556),
    [anon_sym_EQ] = ACTIONS(7556),
    [anon_sym_if] = ACTIONS(7556),
    [anon_sym_for] = ACTIONS(7556),
    [anon_sym_while] = ACTIONS(7556),
    [anon_sym_repeat] = ACTIONS(7556),
    [anon_sym_QMARK] = ACTIONS(7554),
    [anon_sym_TILDE] = ACTIONS(7554),
    [anon_sym_BANG] = ACTIONS(7556),
    [anon_sym_PLUS] = ACTIONS(7554),
    [anon_sym_DASH] = ACTIONS(7556),
    [anon_sym_LT_DASH] = ACTIONS(7554),
    [anon_sym_LT_LT_DASH] = ACTIONS(7554),
    [anon_sym_COLON_EQ] = ACTIONS(7554),
    [anon_sym_DASH_GT] = ACTIONS(7556),
    [anon_sym_DASH_GT_GT] = ACTIONS(7554),
    [anon_sym_PIPE] = ACTIONS(7556),
    [anon_sym_AMP] = ACTIONS(7556),
    [anon_sym_PIPE_PIPE] = ACTIONS(7554),
    [anon_sym_AMP_AMP] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(7556),
    [anon_sym_LT_EQ] = ACTIONS(7554),
    [anon_sym_GT] = ACTIONS(7556),
    [anon_sym_GT_EQ] = ACTIONS(7554),
    [anon_sym_EQ_EQ] = ACTIONS(7554),
    [anon_sym_BANG_EQ] = ACTIONS(7554),
    [anon_sym_STAR] = ACTIONS(7556),
    [anon_sym_SLASH] = ACTIONS(7554),
    [anon_sym_STAR_STAR] = ACTIONS(7554),
    [anon_sym_CARET] = ACTIONS(7554),
    [aux_sym_binary_operator_token1] = ACTIONS(7554),
    [anon_sym_PIPE_GT] = ACTIONS(7554),
    [anon_sym_COLON] = ACTIONS(7556),
    [anon_sym_DOLLAR] = ACTIONS(7554),
    [anon_sym_AT] = ACTIONS(7554),
    [aux_sym__hex_literal_token1] = ACTIONS(7554),
    [sym__number_literal] = ACTIONS(7556),
    [anon_sym_SQUOTE] = ACTIONS(7554),
    [anon_sym_DQUOTE] = ACTIONS(7554),
    [sym_return] = ACTIONS(7556),
    [sym_next] = ACTIONS(7556),
    [sym_break] = ACTIONS(7556),
    [sym_true] = ACTIONS(7556),
    [sym_false] = ACTIONS(7556),
    [sym_null] = ACTIONS(7556),
    [sym_inf] = ACTIONS(7556),
    [sym_nan] = ACTIONS(7556),
    [anon_sym_NA] = ACTIONS(7556),
    [anon_sym_NA_integer_] = ACTIONS(7556),
    [anon_sym_NA_real_] = ACTIONS(7556),
    [anon_sym_NA_complex_] = ACTIONS(7556),
    [anon_sym_NA_character_] = ACTIONS(7556),
    [sym_dots] = ACTIONS(7556),
    [sym_dot_dot_i] = ACTIONS(7554),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7554),
    [sym__semicolon] = ACTIONS(7554),
    [sym__raw_string_literal] = ACTIONS(7554),
    [sym__external_else] = ACTIONS(7554),
    [sym__external_open_parenthesis] = ACTIONS(7554),
    [sym__external_close_parenthesis] = ACTIONS(7554),
    [sym__external_open_brace] = ACTIONS(7554),
    [sym__external_open_bracket] = ACTIONS(7554),
    [sym__external_open_bracket2] = ACTIONS(7554),
  },
  [2720] = {
    [sym_identifier] = ACTIONS(7494),
    [anon_sym_BSLASH] = ACTIONS(7492),
    [anon_sym_function] = ACTIONS(7494),
    [anon_sym_EQ] = ACTIONS(7494),
    [anon_sym_if] = ACTIONS(7494),
    [anon_sym_for] = ACTIONS(7494),
    [anon_sym_while] = ACTIONS(7494),
    [anon_sym_repeat] = ACTIONS(7494),
    [anon_sym_QMARK] = ACTIONS(7492),
    [anon_sym_TILDE] = ACTIONS(7492),
    [anon_sym_BANG] = ACTIONS(7494),
    [anon_sym_PLUS] = ACTIONS(7492),
    [anon_sym_DASH] = ACTIONS(7494),
    [anon_sym_LT_DASH] = ACTIONS(7492),
    [anon_sym_LT_LT_DASH] = ACTIONS(7492),
    [anon_sym_COLON_EQ] = ACTIONS(7492),
    [anon_sym_DASH_GT] = ACTIONS(7494),
    [anon_sym_DASH_GT_GT] = ACTIONS(7492),
    [anon_sym_PIPE] = ACTIONS(7494),
    [anon_sym_AMP] = ACTIONS(7494),
    [anon_sym_PIPE_PIPE] = ACTIONS(7492),
    [anon_sym_AMP_AMP] = ACTIONS(7492),
    [anon_sym_LT] = ACTIONS(7494),
    [anon_sym_LT_EQ] = ACTIONS(7492),
    [anon_sym_GT] = ACTIONS(7494),
    [anon_sym_GT_EQ] = ACTIONS(7492),
    [anon_sym_EQ_EQ] = ACTIONS(7492),
    [anon_sym_BANG_EQ] = ACTIONS(7492),
    [anon_sym_STAR] = ACTIONS(7494),
    [anon_sym_SLASH] = ACTIONS(7492),
    [anon_sym_STAR_STAR] = ACTIONS(7492),
    [anon_sym_CARET] = ACTIONS(7492),
    [aux_sym_binary_operator_token1] = ACTIONS(7492),
    [anon_sym_PIPE_GT] = ACTIONS(7492),
    [anon_sym_COLON] = ACTIONS(7494),
    [anon_sym_DOLLAR] = ACTIONS(7492),
    [anon_sym_AT] = ACTIONS(7492),
    [aux_sym__hex_literal_token1] = ACTIONS(7492),
    [sym__number_literal] = ACTIONS(7494),
    [anon_sym_SQUOTE] = ACTIONS(7492),
    [anon_sym_DQUOTE] = ACTIONS(7492),
    [sym_return] = ACTIONS(7494),
    [sym_next] = ACTIONS(7494),
    [sym_break] = ACTIONS(7494),
    [sym_true] = ACTIONS(7494),
    [sym_false] = ACTIONS(7494),
    [sym_null] = ACTIONS(7494),
    [sym_inf] = ACTIONS(7494),
    [sym_nan] = ACTIONS(7494),
    [anon_sym_NA] = ACTIONS(7494),
    [anon_sym_NA_integer_] = ACTIONS(7494),
    [anon_sym_NA_real_] = ACTIONS(7494),
    [anon_sym_NA_complex_] = ACTIONS(7494),
    [anon_sym_NA_character_] = ACTIONS(7494),
    [sym_dots] = ACTIONS(7494),
    [sym_dot_dot_i] = ACTIONS(7492),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7492),
    [sym__newline] = ACTIONS(7492),
    [sym__semicolon] = ACTIONS(7492),
    [sym__raw_string_literal] = ACTIONS(7492),
    [sym__external_open_parenthesis] = ACTIONS(7492),
    [sym__external_open_brace] = ACTIONS(7492),
    [sym__external_close_brace] = ACTIONS(7492),
    [sym__external_open_bracket] = ACTIONS(7492),
    [sym__external_open_bracket2] = ACTIONS(7492),
    [sym__external_close_bracket2] = ACTIONS(7492),
  },
  [2721] = {
    [sym_identifier] = ACTIONS(7498),
    [anon_sym_BSLASH] = ACTIONS(7496),
    [anon_sym_function] = ACTIONS(7498),
    [anon_sym_EQ] = ACTIONS(7498),
    [anon_sym_if] = ACTIONS(7498),
    [anon_sym_for] = ACTIONS(7498),
    [anon_sym_while] = ACTIONS(7498),
    [anon_sym_repeat] = ACTIONS(7498),
    [anon_sym_QMARK] = ACTIONS(7496),
    [anon_sym_TILDE] = ACTIONS(7496),
    [anon_sym_BANG] = ACTIONS(7498),
    [anon_sym_PLUS] = ACTIONS(7496),
    [anon_sym_DASH] = ACTIONS(7498),
    [anon_sym_LT_DASH] = ACTIONS(7496),
    [anon_sym_LT_LT_DASH] = ACTIONS(7496),
    [anon_sym_COLON_EQ] = ACTIONS(7496),
    [anon_sym_DASH_GT] = ACTIONS(7498),
    [anon_sym_DASH_GT_GT] = ACTIONS(7496),
    [anon_sym_PIPE] = ACTIONS(7498),
    [anon_sym_AMP] = ACTIONS(7498),
    [anon_sym_PIPE_PIPE] = ACTIONS(7496),
    [anon_sym_AMP_AMP] = ACTIONS(7496),
    [anon_sym_LT] = ACTIONS(7498),
    [anon_sym_LT_EQ] = ACTIONS(7496),
    [anon_sym_GT] = ACTIONS(7498),
    [anon_sym_GT_EQ] = ACTIONS(7496),
    [anon_sym_EQ_EQ] = ACTIONS(7496),
    [anon_sym_BANG_EQ] = ACTIONS(7496),
    [anon_sym_STAR] = ACTIONS(7498),
    [anon_sym_SLASH] = ACTIONS(7496),
    [anon_sym_STAR_STAR] = ACTIONS(7496),
    [anon_sym_CARET] = ACTIONS(7496),
    [aux_sym_binary_operator_token1] = ACTIONS(7496),
    [anon_sym_PIPE_GT] = ACTIONS(7496),
    [anon_sym_COLON] = ACTIONS(7498),
    [anon_sym_DOLLAR] = ACTIONS(7496),
    [anon_sym_AT] = ACTIONS(7496),
    [aux_sym__hex_literal_token1] = ACTIONS(7496),
    [sym__number_literal] = ACTIONS(7498),
    [anon_sym_SQUOTE] = ACTIONS(7496),
    [anon_sym_DQUOTE] = ACTIONS(7496),
    [sym_return] = ACTIONS(7498),
    [sym_next] = ACTIONS(7498),
    [sym_break] = ACTIONS(7498),
    [sym_true] = ACTIONS(7498),
    [sym_false] = ACTIONS(7498),
    [sym_null] = ACTIONS(7498),
    [sym_inf] = ACTIONS(7498),
    [sym_nan] = ACTIONS(7498),
    [anon_sym_NA] = ACTIONS(7498),
    [anon_sym_NA_integer_] = ACTIONS(7498),
    [anon_sym_NA_real_] = ACTIONS(7498),
    [anon_sym_NA_complex_] = ACTIONS(7498),
    [anon_sym_NA_character_] = ACTIONS(7498),
    [sym_dots] = ACTIONS(7498),
    [sym_dot_dot_i] = ACTIONS(7496),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7496),
    [sym__newline] = ACTIONS(7496),
    [sym__semicolon] = ACTIONS(7496),
    [sym__raw_string_literal] = ACTIONS(7496),
    [sym__external_open_parenthesis] = ACTIONS(7496),
    [sym__external_open_brace] = ACTIONS(7496),
    [sym__external_close_brace] = ACTIONS(7496),
    [sym__external_open_bracket] = ACTIONS(7496),
    [sym__external_open_bracket2] = ACTIONS(7496),
    [sym__external_close_bracket2] = ACTIONS(7496),
  },
  [2722] = {
    [aux_sym_function_definition_repeat1] = STATE(2722),
    [sym_identifier] = ACTIONS(7419),
    [anon_sym_BSLASH] = ACTIONS(7417),
    [anon_sym_function] = ACTIONS(7419),
    [anon_sym_EQ] = ACTIONS(7419),
    [anon_sym_if] = ACTIONS(7419),
    [anon_sym_for] = ACTIONS(7419),
    [anon_sym_while] = ACTIONS(7419),
    [anon_sym_repeat] = ACTIONS(7419),
    [anon_sym_QMARK] = ACTIONS(7417),
    [anon_sym_TILDE] = ACTIONS(7417),
    [anon_sym_BANG] = ACTIONS(7419),
    [anon_sym_PLUS] = ACTIONS(7417),
    [anon_sym_DASH] = ACTIONS(7419),
    [anon_sym_LT_DASH] = ACTIONS(7417),
    [anon_sym_LT_LT_DASH] = ACTIONS(7417),
    [anon_sym_COLON_EQ] = ACTIONS(7417),
    [anon_sym_DASH_GT] = ACTIONS(7419),
    [anon_sym_DASH_GT_GT] = ACTIONS(7417),
    [anon_sym_PIPE] = ACTIONS(7419),
    [anon_sym_AMP] = ACTIONS(7419),
    [anon_sym_PIPE_PIPE] = ACTIONS(7417),
    [anon_sym_AMP_AMP] = ACTIONS(7417),
    [anon_sym_LT] = ACTIONS(7419),
    [anon_sym_LT_EQ] = ACTIONS(7417),
    [anon_sym_GT] = ACTIONS(7419),
    [anon_sym_GT_EQ] = ACTIONS(7417),
    [anon_sym_EQ_EQ] = ACTIONS(7417),
    [anon_sym_BANG_EQ] = ACTIONS(7417),
    [anon_sym_STAR] = ACTIONS(7419),
    [anon_sym_SLASH] = ACTIONS(7417),
    [anon_sym_STAR_STAR] = ACTIONS(7417),
    [anon_sym_CARET] = ACTIONS(7417),
    [aux_sym_binary_operator_token1] = ACTIONS(7417),
    [anon_sym_PIPE_GT] = ACTIONS(7417),
    [anon_sym_COLON] = ACTIONS(7419),
    [anon_sym_DOLLAR] = ACTIONS(7417),
    [anon_sym_AT] = ACTIONS(7417),
    [aux_sym__hex_literal_token1] = ACTIONS(7417),
    [sym__number_literal] = ACTIONS(7419),
    [anon_sym_SQUOTE] = ACTIONS(7417),
    [anon_sym_DQUOTE] = ACTIONS(7417),
    [sym_return] = ACTIONS(7419),
    [sym_next] = ACTIONS(7419),
    [sym_break] = ACTIONS(7419),
    [sym_true] = ACTIONS(7419),
    [sym_false] = ACTIONS(7419),
    [sym_null] = ACTIONS(7419),
    [sym_inf] = ACTIONS(7419),
    [sym_nan] = ACTIONS(7419),
    [anon_sym_NA] = ACTIONS(7419),
    [anon_sym_NA_integer_] = ACTIONS(7419),
    [anon_sym_NA_real_] = ACTIONS(7419),
    [anon_sym_NA_complex_] = ACTIONS(7419),
    [anon_sym_NA_character_] = ACTIONS(7419),
    [sym_dots] = ACTIONS(7419),
    [sym_dot_dot_i] = ACTIONS(7417),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7417),
    [sym__newline] = ACTIONS(7685),
    [sym__raw_string_literal] = ACTIONS(7417),
    [sym__external_else] = ACTIONS(7417),
    [sym__external_open_parenthesis] = ACTIONS(7417),
    [sym__external_open_brace] = ACTIONS(7417),
    [sym__external_open_bracket] = ACTIONS(7417),
    [sym__external_open_bracket2] = ACTIONS(7417),
    [sym__external_close_bracket2] = ACTIONS(7417),
  },
  [2723] = {
    [sym_identifier] = ACTIONS(7567),
    [anon_sym_BSLASH] = ACTIONS(7565),
    [anon_sym_function] = ACTIONS(7567),
    [anon_sym_EQ] = ACTIONS(7567),
    [anon_sym_if] = ACTIONS(7567),
    [anon_sym_for] = ACTIONS(7567),
    [anon_sym_while] = ACTIONS(7567),
    [anon_sym_repeat] = ACTIONS(7567),
    [anon_sym_QMARK] = ACTIONS(7565),
    [anon_sym_TILDE] = ACTIONS(7565),
    [anon_sym_BANG] = ACTIONS(7567),
    [anon_sym_PLUS] = ACTIONS(7565),
    [anon_sym_DASH] = ACTIONS(7567),
    [anon_sym_LT_DASH] = ACTIONS(7565),
    [anon_sym_LT_LT_DASH] = ACTIONS(7565),
    [anon_sym_COLON_EQ] = ACTIONS(7565),
    [anon_sym_DASH_GT] = ACTIONS(7567),
    [anon_sym_DASH_GT_GT] = ACTIONS(7565),
    [anon_sym_PIPE] = ACTIONS(7567),
    [anon_sym_AMP] = ACTIONS(7567),
    [anon_sym_PIPE_PIPE] = ACTIONS(7565),
    [anon_sym_AMP_AMP] = ACTIONS(7565),
    [anon_sym_LT] = ACTIONS(7567),
    [anon_sym_LT_EQ] = ACTIONS(7565),
    [anon_sym_GT] = ACTIONS(7567),
    [anon_sym_GT_EQ] = ACTIONS(7565),
    [anon_sym_EQ_EQ] = ACTIONS(7565),
    [anon_sym_BANG_EQ] = ACTIONS(7565),
    [anon_sym_STAR] = ACTIONS(7567),
    [anon_sym_SLASH] = ACTIONS(7565),
    [anon_sym_STAR_STAR] = ACTIONS(7565),
    [anon_sym_CARET] = ACTIONS(7565),
    [aux_sym_binary_operator_token1] = ACTIONS(7565),
    [anon_sym_PIPE_GT] = ACTIONS(7565),
    [anon_sym_COLON] = ACTIONS(7567),
    [anon_sym_DOLLAR] = ACTIONS(7565),
    [anon_sym_AT] = ACTIONS(7565),
    [aux_sym__hex_literal_token1] = ACTIONS(7565),
    [sym__number_literal] = ACTIONS(7567),
    [anon_sym_SQUOTE] = ACTIONS(7565),
    [anon_sym_DQUOTE] = ACTIONS(7565),
    [sym_return] = ACTIONS(7567),
    [sym_next] = ACTIONS(7567),
    [sym_break] = ACTIONS(7567),
    [sym_true] = ACTIONS(7567),
    [sym_false] = ACTIONS(7567),
    [sym_null] = ACTIONS(7567),
    [sym_inf] = ACTIONS(7567),
    [sym_nan] = ACTIONS(7567),
    [anon_sym_NA] = ACTIONS(7567),
    [anon_sym_NA_integer_] = ACTIONS(7567),
    [anon_sym_NA_real_] = ACTIONS(7567),
    [anon_sym_NA_complex_] = ACTIONS(7567),
    [anon_sym_NA_character_] = ACTIONS(7567),
    [sym_dots] = ACTIONS(7567),
    [sym_dot_dot_i] = ACTIONS(7565),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7565),
    [sym__newline] = ACTIONS(7565),
    [sym__raw_string_literal] = ACTIONS(7565),
    [sym__external_else] = ACTIONS(7565),
    [sym__external_open_parenthesis] = ACTIONS(7565),
    [sym__external_close_parenthesis] = ACTIONS(7565),
    [sym__external_open_brace] = ACTIONS(7565),
    [sym__external_open_bracket] = ACTIONS(7565),
    [sym__external_open_bracket2] = ACTIONS(7565),
    [sym__external_close_bracket2] = ACTIONS(7565),
  },
  [2724] = {
    [sym_identifier] = ACTIONS(7516),
    [anon_sym_BSLASH] = ACTIONS(7514),
    [anon_sym_function] = ACTIONS(7516),
    [anon_sym_EQ] = ACTIONS(7516),
    [anon_sym_if] = ACTIONS(7516),
    [anon_sym_for] = ACTIONS(7516),
    [anon_sym_while] = ACTIONS(7516),
    [anon_sym_repeat] = ACTIONS(7516),
    [anon_sym_QMARK] = ACTIONS(7514),
    [anon_sym_TILDE] = ACTIONS(7514),
    [anon_sym_BANG] = ACTIONS(7516),
    [anon_sym_PLUS] = ACTIONS(7514),
    [anon_sym_DASH] = ACTIONS(7516),
    [anon_sym_LT_DASH] = ACTIONS(7514),
    [anon_sym_LT_LT_DASH] = ACTIONS(7514),
    [anon_sym_COLON_EQ] = ACTIONS(7514),
    [anon_sym_DASH_GT] = ACTIONS(7516),
    [anon_sym_DASH_GT_GT] = ACTIONS(7514),
    [anon_sym_PIPE] = ACTIONS(7516),
    [anon_sym_AMP] = ACTIONS(7516),
    [anon_sym_PIPE_PIPE] = ACTIONS(7514),
    [anon_sym_AMP_AMP] = ACTIONS(7514),
    [anon_sym_LT] = ACTIONS(7516),
    [anon_sym_LT_EQ] = ACTIONS(7514),
    [anon_sym_GT] = ACTIONS(7516),
    [anon_sym_GT_EQ] = ACTIONS(7514),
    [anon_sym_EQ_EQ] = ACTIONS(7514),
    [anon_sym_BANG_EQ] = ACTIONS(7514),
    [anon_sym_STAR] = ACTIONS(7516),
    [anon_sym_SLASH] = ACTIONS(7514),
    [anon_sym_STAR_STAR] = ACTIONS(7514),
    [anon_sym_CARET] = ACTIONS(7514),
    [aux_sym_binary_operator_token1] = ACTIONS(7514),
    [anon_sym_PIPE_GT] = ACTIONS(7514),
    [anon_sym_COLON] = ACTIONS(7516),
    [anon_sym_DOLLAR] = ACTIONS(7514),
    [anon_sym_AT] = ACTIONS(7514),
    [aux_sym__hex_literal_token1] = ACTIONS(7514),
    [sym__number_literal] = ACTIONS(7516),
    [anon_sym_SQUOTE] = ACTIONS(7514),
    [anon_sym_DQUOTE] = ACTIONS(7514),
    [sym_return] = ACTIONS(7516),
    [sym_next] = ACTIONS(7516),
    [sym_break] = ACTIONS(7516),
    [sym_true] = ACTIONS(7516),
    [sym_false] = ACTIONS(7516),
    [sym_null] = ACTIONS(7516),
    [sym_inf] = ACTIONS(7516),
    [sym_nan] = ACTIONS(7516),
    [anon_sym_NA] = ACTIONS(7516),
    [anon_sym_NA_integer_] = ACTIONS(7516),
    [anon_sym_NA_real_] = ACTIONS(7516),
    [anon_sym_NA_complex_] = ACTIONS(7516),
    [anon_sym_NA_character_] = ACTIONS(7516),
    [sym_dots] = ACTIONS(7516),
    [sym_dot_dot_i] = ACTIONS(7514),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7514),
    [sym__newline] = ACTIONS(7514),
    [sym__raw_string_literal] = ACTIONS(7514),
    [sym__external_else] = ACTIONS(7514),
    [sym__external_open_parenthesis] = ACTIONS(7514),
    [sym__external_close_parenthesis] = ACTIONS(7514),
    [sym__external_open_brace] = ACTIONS(7514),
    [sym__external_open_bracket] = ACTIONS(7514),
    [sym__external_close_bracket] = ACTIONS(7514),
    [sym__external_open_bracket2] = ACTIONS(7514),
  },
  [2725] = {
    [sym_identifier] = ACTIONS(7502),
    [anon_sym_BSLASH] = ACTIONS(7500),
    [anon_sym_function] = ACTIONS(7502),
    [anon_sym_EQ] = ACTIONS(7502),
    [anon_sym_if] = ACTIONS(7502),
    [anon_sym_for] = ACTIONS(7502),
    [anon_sym_while] = ACTIONS(7502),
    [anon_sym_repeat] = ACTIONS(7502),
    [anon_sym_QMARK] = ACTIONS(7500),
    [anon_sym_TILDE] = ACTIONS(7500),
    [anon_sym_BANG] = ACTIONS(7502),
    [anon_sym_PLUS] = ACTIONS(7500),
    [anon_sym_DASH] = ACTIONS(7502),
    [anon_sym_LT_DASH] = ACTIONS(7500),
    [anon_sym_LT_LT_DASH] = ACTIONS(7500),
    [anon_sym_COLON_EQ] = ACTIONS(7500),
    [anon_sym_DASH_GT] = ACTIONS(7502),
    [anon_sym_DASH_GT_GT] = ACTIONS(7500),
    [anon_sym_PIPE] = ACTIONS(7502),
    [anon_sym_AMP] = ACTIONS(7502),
    [anon_sym_PIPE_PIPE] = ACTIONS(7500),
    [anon_sym_AMP_AMP] = ACTIONS(7500),
    [anon_sym_LT] = ACTIONS(7502),
    [anon_sym_LT_EQ] = ACTIONS(7500),
    [anon_sym_GT] = ACTIONS(7502),
    [anon_sym_GT_EQ] = ACTIONS(7500),
    [anon_sym_EQ_EQ] = ACTIONS(7500),
    [anon_sym_BANG_EQ] = ACTIONS(7500),
    [anon_sym_STAR] = ACTIONS(7502),
    [anon_sym_SLASH] = ACTIONS(7500),
    [anon_sym_STAR_STAR] = ACTIONS(7500),
    [anon_sym_CARET] = ACTIONS(7500),
    [aux_sym_binary_operator_token1] = ACTIONS(7500),
    [anon_sym_PIPE_GT] = ACTIONS(7500),
    [anon_sym_COLON] = ACTIONS(7502),
    [anon_sym_DOLLAR] = ACTIONS(7500),
    [anon_sym_AT] = ACTIONS(7500),
    [aux_sym__hex_literal_token1] = ACTIONS(7500),
    [sym__number_literal] = ACTIONS(7502),
    [anon_sym_SQUOTE] = ACTIONS(7500),
    [anon_sym_DQUOTE] = ACTIONS(7500),
    [sym_return] = ACTIONS(7502),
    [sym_next] = ACTIONS(7502),
    [sym_break] = ACTIONS(7502),
    [sym_true] = ACTIONS(7502),
    [sym_false] = ACTIONS(7502),
    [sym_null] = ACTIONS(7502),
    [sym_inf] = ACTIONS(7502),
    [sym_nan] = ACTIONS(7502),
    [anon_sym_NA] = ACTIONS(7502),
    [anon_sym_NA_integer_] = ACTIONS(7502),
    [anon_sym_NA_real_] = ACTIONS(7502),
    [anon_sym_NA_complex_] = ACTIONS(7502),
    [anon_sym_NA_character_] = ACTIONS(7502),
    [sym_dots] = ACTIONS(7502),
    [sym_dot_dot_i] = ACTIONS(7500),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7500),
    [sym__newline] = ACTIONS(7500),
    [sym__semicolon] = ACTIONS(7500),
    [sym__raw_string_literal] = ACTIONS(7500),
    [sym__external_open_parenthesis] = ACTIONS(7500),
    [sym__external_open_brace] = ACTIONS(7500),
    [sym__external_close_brace] = ACTIONS(7500),
    [sym__external_open_bracket] = ACTIONS(7500),
    [sym__external_open_bracket2] = ACTIONS(7500),
    [sym__external_close_bracket2] = ACTIONS(7500),
  },
  [2726] = {
    [sym_identifier] = ACTIONS(7506),
    [anon_sym_BSLASH] = ACTIONS(7504),
    [anon_sym_function] = ACTIONS(7506),
    [anon_sym_EQ] = ACTIONS(7506),
    [anon_sym_if] = ACTIONS(7506),
    [anon_sym_for] = ACTIONS(7506),
    [anon_sym_while] = ACTIONS(7506),
    [anon_sym_repeat] = ACTIONS(7506),
    [anon_sym_QMARK] = ACTIONS(7504),
    [anon_sym_TILDE] = ACTIONS(7504),
    [anon_sym_BANG] = ACTIONS(7506),
    [anon_sym_PLUS] = ACTIONS(7504),
    [anon_sym_DASH] = ACTIONS(7506),
    [anon_sym_LT_DASH] = ACTIONS(7504),
    [anon_sym_LT_LT_DASH] = ACTIONS(7504),
    [anon_sym_COLON_EQ] = ACTIONS(7504),
    [anon_sym_DASH_GT] = ACTIONS(7506),
    [anon_sym_DASH_GT_GT] = ACTIONS(7504),
    [anon_sym_PIPE] = ACTIONS(7506),
    [anon_sym_AMP] = ACTIONS(7506),
    [anon_sym_PIPE_PIPE] = ACTIONS(7504),
    [anon_sym_AMP_AMP] = ACTIONS(7504),
    [anon_sym_LT] = ACTIONS(7506),
    [anon_sym_LT_EQ] = ACTIONS(7504),
    [anon_sym_GT] = ACTIONS(7506),
    [anon_sym_GT_EQ] = ACTIONS(7504),
    [anon_sym_EQ_EQ] = ACTIONS(7504),
    [anon_sym_BANG_EQ] = ACTIONS(7504),
    [anon_sym_STAR] = ACTIONS(7506),
    [anon_sym_SLASH] = ACTIONS(7504),
    [anon_sym_STAR_STAR] = ACTIONS(7504),
    [anon_sym_CARET] = ACTIONS(7504),
    [aux_sym_binary_operator_token1] = ACTIONS(7504),
    [anon_sym_PIPE_GT] = ACTIONS(7504),
    [anon_sym_COLON] = ACTIONS(7506),
    [anon_sym_DOLLAR] = ACTIONS(7504),
    [anon_sym_AT] = ACTIONS(7504),
    [aux_sym__hex_literal_token1] = ACTIONS(7504),
    [sym__number_literal] = ACTIONS(7506),
    [anon_sym_SQUOTE] = ACTIONS(7504),
    [anon_sym_DQUOTE] = ACTIONS(7504),
    [sym_return] = ACTIONS(7506),
    [sym_next] = ACTIONS(7506),
    [sym_break] = ACTIONS(7506),
    [sym_true] = ACTIONS(7506),
    [sym_false] = ACTIONS(7506),
    [sym_null] = ACTIONS(7506),
    [sym_inf] = ACTIONS(7506),
    [sym_nan] = ACTIONS(7506),
    [anon_sym_NA] = ACTIONS(7506),
    [anon_sym_NA_integer_] = ACTIONS(7506),
    [anon_sym_NA_real_] = ACTIONS(7506),
    [anon_sym_NA_complex_] = ACTIONS(7506),
    [anon_sym_NA_character_] = ACTIONS(7506),
    [sym_dots] = ACTIONS(7506),
    [sym_dot_dot_i] = ACTIONS(7504),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7504),
    [sym__newline] = ACTIONS(7504),
    [sym__semicolon] = ACTIONS(7504),
    [sym__raw_string_literal] = ACTIONS(7504),
    [sym__external_open_parenthesis] = ACTIONS(7504),
    [sym__external_open_brace] = ACTIONS(7504),
    [sym__external_close_brace] = ACTIONS(7504),
    [sym__external_open_bracket] = ACTIONS(7504),
    [sym__external_open_bracket2] = ACTIONS(7504),
    [sym__external_close_bracket2] = ACTIONS(7504),
  },
  [2727] = {
    [sym_identifier] = ACTIONS(7520),
    [anon_sym_BSLASH] = ACTIONS(7518),
    [anon_sym_function] = ACTIONS(7520),
    [anon_sym_EQ] = ACTIONS(7520),
    [anon_sym_if] = ACTIONS(7520),
    [anon_sym_for] = ACTIONS(7520),
    [anon_sym_while] = ACTIONS(7520),
    [anon_sym_repeat] = ACTIONS(7520),
    [anon_sym_QMARK] = ACTIONS(7518),
    [anon_sym_TILDE] = ACTIONS(7518),
    [anon_sym_BANG] = ACTIONS(7520),
    [anon_sym_PLUS] = ACTIONS(7518),
    [anon_sym_DASH] = ACTIONS(7520),
    [anon_sym_LT_DASH] = ACTIONS(7518),
    [anon_sym_LT_LT_DASH] = ACTIONS(7518),
    [anon_sym_COLON_EQ] = ACTIONS(7518),
    [anon_sym_DASH_GT] = ACTIONS(7520),
    [anon_sym_DASH_GT_GT] = ACTIONS(7518),
    [anon_sym_PIPE] = ACTIONS(7520),
    [anon_sym_AMP] = ACTIONS(7520),
    [anon_sym_PIPE_PIPE] = ACTIONS(7518),
    [anon_sym_AMP_AMP] = ACTIONS(7518),
    [anon_sym_LT] = ACTIONS(7520),
    [anon_sym_LT_EQ] = ACTIONS(7518),
    [anon_sym_GT] = ACTIONS(7520),
    [anon_sym_GT_EQ] = ACTIONS(7518),
    [anon_sym_EQ_EQ] = ACTIONS(7518),
    [anon_sym_BANG_EQ] = ACTIONS(7518),
    [anon_sym_STAR] = ACTIONS(7520),
    [anon_sym_SLASH] = ACTIONS(7518),
    [anon_sym_STAR_STAR] = ACTIONS(7518),
    [anon_sym_CARET] = ACTIONS(7518),
    [aux_sym_binary_operator_token1] = ACTIONS(7518),
    [anon_sym_PIPE_GT] = ACTIONS(7518),
    [anon_sym_COLON] = ACTIONS(7520),
    [anon_sym_DOLLAR] = ACTIONS(7518),
    [anon_sym_AT] = ACTIONS(7518),
    [aux_sym__hex_literal_token1] = ACTIONS(7518),
    [sym__number_literal] = ACTIONS(7520),
    [anon_sym_SQUOTE] = ACTIONS(7518),
    [anon_sym_DQUOTE] = ACTIONS(7518),
    [sym_return] = ACTIONS(7520),
    [sym_next] = ACTIONS(7520),
    [sym_break] = ACTIONS(7520),
    [sym_true] = ACTIONS(7520),
    [sym_false] = ACTIONS(7520),
    [sym_null] = ACTIONS(7520),
    [sym_inf] = ACTIONS(7520),
    [sym_nan] = ACTIONS(7520),
    [anon_sym_NA] = ACTIONS(7520),
    [anon_sym_NA_integer_] = ACTIONS(7520),
    [anon_sym_NA_real_] = ACTIONS(7520),
    [anon_sym_NA_complex_] = ACTIONS(7520),
    [anon_sym_NA_character_] = ACTIONS(7520),
    [sym_dots] = ACTIONS(7520),
    [sym_dot_dot_i] = ACTIONS(7518),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7518),
    [sym__newline] = ACTIONS(7518),
    [sym__raw_string_literal] = ACTIONS(7518),
    [sym__external_else] = ACTIONS(7518),
    [sym__external_open_parenthesis] = ACTIONS(7518),
    [sym__external_close_parenthesis] = ACTIONS(7518),
    [sym__external_open_brace] = ACTIONS(7518),
    [sym__external_open_bracket] = ACTIONS(7518),
    [sym__external_close_bracket] = ACTIONS(7518),
    [sym__external_open_bracket2] = ACTIONS(7518),
  },
  [2728] = {
    [sym_identifier] = ACTIONS(7563),
    [anon_sym_BSLASH] = ACTIONS(7561),
    [anon_sym_function] = ACTIONS(7563),
    [anon_sym_EQ] = ACTIONS(7563),
    [anon_sym_if] = ACTIONS(7563),
    [anon_sym_for] = ACTIONS(7563),
    [anon_sym_while] = ACTIONS(7563),
    [anon_sym_repeat] = ACTIONS(7563),
    [anon_sym_QMARK] = ACTIONS(7561),
    [anon_sym_TILDE] = ACTIONS(7561),
    [anon_sym_BANG] = ACTIONS(7563),
    [anon_sym_PLUS] = ACTIONS(7561),
    [anon_sym_DASH] = ACTIONS(7563),
    [anon_sym_LT_DASH] = ACTIONS(7561),
    [anon_sym_LT_LT_DASH] = ACTIONS(7561),
    [anon_sym_COLON_EQ] = ACTIONS(7561),
    [anon_sym_DASH_GT] = ACTIONS(7563),
    [anon_sym_DASH_GT_GT] = ACTIONS(7561),
    [anon_sym_PIPE] = ACTIONS(7563),
    [anon_sym_AMP] = ACTIONS(7563),
    [anon_sym_PIPE_PIPE] = ACTIONS(7561),
    [anon_sym_AMP_AMP] = ACTIONS(7561),
    [anon_sym_LT] = ACTIONS(7563),
    [anon_sym_LT_EQ] = ACTIONS(7561),
    [anon_sym_GT] = ACTIONS(7563),
    [anon_sym_GT_EQ] = ACTIONS(7561),
    [anon_sym_EQ_EQ] = ACTIONS(7561),
    [anon_sym_BANG_EQ] = ACTIONS(7561),
    [anon_sym_STAR] = ACTIONS(7563),
    [anon_sym_SLASH] = ACTIONS(7561),
    [anon_sym_STAR_STAR] = ACTIONS(7561),
    [anon_sym_CARET] = ACTIONS(7561),
    [aux_sym_binary_operator_token1] = ACTIONS(7561),
    [anon_sym_PIPE_GT] = ACTIONS(7561),
    [anon_sym_COLON] = ACTIONS(7563),
    [anon_sym_DOLLAR] = ACTIONS(7561),
    [anon_sym_AT] = ACTIONS(7561),
    [aux_sym__hex_literal_token1] = ACTIONS(7561),
    [sym__number_literal] = ACTIONS(7563),
    [anon_sym_SQUOTE] = ACTIONS(7561),
    [anon_sym_DQUOTE] = ACTIONS(7561),
    [sym_return] = ACTIONS(7563),
    [sym_next] = ACTIONS(7563),
    [sym_break] = ACTIONS(7563),
    [sym_true] = ACTIONS(7563),
    [sym_false] = ACTIONS(7563),
    [sym_null] = ACTIONS(7563),
    [sym_inf] = ACTIONS(7563),
    [sym_nan] = ACTIONS(7563),
    [anon_sym_NA] = ACTIONS(7563),
    [anon_sym_NA_integer_] = ACTIONS(7563),
    [anon_sym_NA_real_] = ACTIONS(7563),
    [anon_sym_NA_complex_] = ACTIONS(7563),
    [anon_sym_NA_character_] = ACTIONS(7563),
    [sym_dots] = ACTIONS(7563),
    [sym_dot_dot_i] = ACTIONS(7561),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7561),
    [sym__newline] = ACTIONS(7561),
    [sym__semicolon] = ACTIONS(7561),
    [sym__raw_string_literal] = ACTIONS(7561),
    [sym__external_open_parenthesis] = ACTIONS(7561),
    [sym__external_open_brace] = ACTIONS(7561),
    [sym__external_close_brace] = ACTIONS(7561),
    [sym__external_open_bracket] = ACTIONS(7561),
    [sym__external_close_bracket] = ACTIONS(7561),
    [sym__external_open_bracket2] = ACTIONS(7561),
  },
  [2729] = {
    [sym_identifier] = ACTIONS(7524),
    [anon_sym_BSLASH] = ACTIONS(7522),
    [anon_sym_function] = ACTIONS(7524),
    [anon_sym_EQ] = ACTIONS(7524),
    [anon_sym_if] = ACTIONS(7524),
    [anon_sym_for] = ACTIONS(7524),
    [anon_sym_while] = ACTIONS(7524),
    [anon_sym_repeat] = ACTIONS(7524),
    [anon_sym_QMARK] = ACTIONS(7522),
    [anon_sym_TILDE] = ACTIONS(7522),
    [anon_sym_BANG] = ACTIONS(7524),
    [anon_sym_PLUS] = ACTIONS(7522),
    [anon_sym_DASH] = ACTIONS(7524),
    [anon_sym_LT_DASH] = ACTIONS(7522),
    [anon_sym_LT_LT_DASH] = ACTIONS(7522),
    [anon_sym_COLON_EQ] = ACTIONS(7522),
    [anon_sym_DASH_GT] = ACTIONS(7524),
    [anon_sym_DASH_GT_GT] = ACTIONS(7522),
    [anon_sym_PIPE] = ACTIONS(7524),
    [anon_sym_AMP] = ACTIONS(7524),
    [anon_sym_PIPE_PIPE] = ACTIONS(7522),
    [anon_sym_AMP_AMP] = ACTIONS(7522),
    [anon_sym_LT] = ACTIONS(7524),
    [anon_sym_LT_EQ] = ACTIONS(7522),
    [anon_sym_GT] = ACTIONS(7524),
    [anon_sym_GT_EQ] = ACTIONS(7522),
    [anon_sym_EQ_EQ] = ACTIONS(7522),
    [anon_sym_BANG_EQ] = ACTIONS(7522),
    [anon_sym_STAR] = ACTIONS(7524),
    [anon_sym_SLASH] = ACTIONS(7522),
    [anon_sym_STAR_STAR] = ACTIONS(7522),
    [anon_sym_CARET] = ACTIONS(7522),
    [aux_sym_binary_operator_token1] = ACTIONS(7522),
    [anon_sym_PIPE_GT] = ACTIONS(7522),
    [anon_sym_COLON] = ACTIONS(7524),
    [anon_sym_DOLLAR] = ACTIONS(7522),
    [anon_sym_AT] = ACTIONS(7522),
    [aux_sym__hex_literal_token1] = ACTIONS(7522),
    [sym__number_literal] = ACTIONS(7524),
    [anon_sym_SQUOTE] = ACTIONS(7522),
    [anon_sym_DQUOTE] = ACTIONS(7522),
    [sym_return] = ACTIONS(7524),
    [sym_next] = ACTIONS(7524),
    [sym_break] = ACTIONS(7524),
    [sym_true] = ACTIONS(7524),
    [sym_false] = ACTIONS(7524),
    [sym_null] = ACTIONS(7524),
    [sym_inf] = ACTIONS(7524),
    [sym_nan] = ACTIONS(7524),
    [anon_sym_NA] = ACTIONS(7524),
    [anon_sym_NA_integer_] = ACTIONS(7524),
    [anon_sym_NA_real_] = ACTIONS(7524),
    [anon_sym_NA_complex_] = ACTIONS(7524),
    [anon_sym_NA_character_] = ACTIONS(7524),
    [sym_dots] = ACTIONS(7524),
    [sym_dot_dot_i] = ACTIONS(7522),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7522),
    [sym__newline] = ACTIONS(7522),
    [sym__raw_string_literal] = ACTIONS(7522),
    [sym__external_else] = ACTIONS(7522),
    [sym__external_open_parenthesis] = ACTIONS(7522),
    [sym__external_close_parenthesis] = ACTIONS(7522),
    [sym__external_open_brace] = ACTIONS(7522),
    [sym__external_open_bracket] = ACTIONS(7522),
    [sym__external_close_bracket] = ACTIONS(7522),
    [sym__external_open_bracket2] = ACTIONS(7522),
  },
  [2730] = {
    [sym_identifier] = ACTIONS(7528),
    [anon_sym_BSLASH] = ACTIONS(7526),
    [anon_sym_function] = ACTIONS(7528),
    [anon_sym_EQ] = ACTIONS(7528),
    [anon_sym_if] = ACTIONS(7528),
    [anon_sym_for] = ACTIONS(7528),
    [anon_sym_while] = ACTIONS(7528),
    [anon_sym_repeat] = ACTIONS(7528),
    [anon_sym_QMARK] = ACTIONS(7526),
    [anon_sym_TILDE] = ACTIONS(7526),
    [anon_sym_BANG] = ACTIONS(7528),
    [anon_sym_PLUS] = ACTIONS(7526),
    [anon_sym_DASH] = ACTIONS(7528),
    [anon_sym_LT_DASH] = ACTIONS(7526),
    [anon_sym_LT_LT_DASH] = ACTIONS(7526),
    [anon_sym_COLON_EQ] = ACTIONS(7526),
    [anon_sym_DASH_GT] = ACTIONS(7528),
    [anon_sym_DASH_GT_GT] = ACTIONS(7526),
    [anon_sym_PIPE] = ACTIONS(7528),
    [anon_sym_AMP] = ACTIONS(7528),
    [anon_sym_PIPE_PIPE] = ACTIONS(7526),
    [anon_sym_AMP_AMP] = ACTIONS(7526),
    [anon_sym_LT] = ACTIONS(7528),
    [anon_sym_LT_EQ] = ACTIONS(7526),
    [anon_sym_GT] = ACTIONS(7528),
    [anon_sym_GT_EQ] = ACTIONS(7526),
    [anon_sym_EQ_EQ] = ACTIONS(7526),
    [anon_sym_BANG_EQ] = ACTIONS(7526),
    [anon_sym_STAR] = ACTIONS(7528),
    [anon_sym_SLASH] = ACTIONS(7526),
    [anon_sym_STAR_STAR] = ACTIONS(7526),
    [anon_sym_CARET] = ACTIONS(7526),
    [aux_sym_binary_operator_token1] = ACTIONS(7526),
    [anon_sym_PIPE_GT] = ACTIONS(7526),
    [anon_sym_COLON] = ACTIONS(7528),
    [anon_sym_DOLLAR] = ACTIONS(7526),
    [anon_sym_AT] = ACTIONS(7526),
    [aux_sym__hex_literal_token1] = ACTIONS(7526),
    [sym__number_literal] = ACTIONS(7528),
    [anon_sym_SQUOTE] = ACTIONS(7526),
    [anon_sym_DQUOTE] = ACTIONS(7526),
    [sym_return] = ACTIONS(7528),
    [sym_next] = ACTIONS(7528),
    [sym_break] = ACTIONS(7528),
    [sym_true] = ACTIONS(7528),
    [sym_false] = ACTIONS(7528),
    [sym_null] = ACTIONS(7528),
    [sym_inf] = ACTIONS(7528),
    [sym_nan] = ACTIONS(7528),
    [anon_sym_NA] = ACTIONS(7528),
    [anon_sym_NA_integer_] = ACTIONS(7528),
    [anon_sym_NA_real_] = ACTIONS(7528),
    [anon_sym_NA_complex_] = ACTIONS(7528),
    [anon_sym_NA_character_] = ACTIONS(7528),
    [sym_dots] = ACTIONS(7528),
    [sym_dot_dot_i] = ACTIONS(7526),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7526),
    [sym__newline] = ACTIONS(7526),
    [sym__raw_string_literal] = ACTIONS(7526),
    [sym__external_else] = ACTIONS(7526),
    [sym__external_open_parenthesis] = ACTIONS(7526),
    [sym__external_close_parenthesis] = ACTIONS(7526),
    [sym__external_open_brace] = ACTIONS(7526),
    [sym__external_open_bracket] = ACTIONS(7526),
    [sym__external_close_bracket] = ACTIONS(7526),
    [sym__external_open_bracket2] = ACTIONS(7526),
  },
  [2731] = {
    [sym_identifier] = ACTIONS(7532),
    [anon_sym_BSLASH] = ACTIONS(7530),
    [anon_sym_function] = ACTIONS(7532),
    [anon_sym_EQ] = ACTIONS(7532),
    [anon_sym_if] = ACTIONS(7532),
    [anon_sym_for] = ACTIONS(7532),
    [anon_sym_while] = ACTIONS(7532),
    [anon_sym_repeat] = ACTIONS(7532),
    [anon_sym_QMARK] = ACTIONS(7530),
    [anon_sym_TILDE] = ACTIONS(7530),
    [anon_sym_BANG] = ACTIONS(7532),
    [anon_sym_PLUS] = ACTIONS(7530),
    [anon_sym_DASH] = ACTIONS(7532),
    [anon_sym_LT_DASH] = ACTIONS(7530),
    [anon_sym_LT_LT_DASH] = ACTIONS(7530),
    [anon_sym_COLON_EQ] = ACTIONS(7530),
    [anon_sym_DASH_GT] = ACTIONS(7532),
    [anon_sym_DASH_GT_GT] = ACTIONS(7530),
    [anon_sym_PIPE] = ACTIONS(7532),
    [anon_sym_AMP] = ACTIONS(7532),
    [anon_sym_PIPE_PIPE] = ACTIONS(7530),
    [anon_sym_AMP_AMP] = ACTIONS(7530),
    [anon_sym_LT] = ACTIONS(7532),
    [anon_sym_LT_EQ] = ACTIONS(7530),
    [anon_sym_GT] = ACTIONS(7532),
    [anon_sym_GT_EQ] = ACTIONS(7530),
    [anon_sym_EQ_EQ] = ACTIONS(7530),
    [anon_sym_BANG_EQ] = ACTIONS(7530),
    [anon_sym_STAR] = ACTIONS(7532),
    [anon_sym_SLASH] = ACTIONS(7530),
    [anon_sym_STAR_STAR] = ACTIONS(7530),
    [anon_sym_CARET] = ACTIONS(7530),
    [aux_sym_binary_operator_token1] = ACTIONS(7530),
    [anon_sym_PIPE_GT] = ACTIONS(7530),
    [anon_sym_COLON] = ACTIONS(7532),
    [anon_sym_DOLLAR] = ACTIONS(7530),
    [anon_sym_AT] = ACTIONS(7530),
    [aux_sym__hex_literal_token1] = ACTIONS(7530),
    [sym__number_literal] = ACTIONS(7532),
    [anon_sym_SQUOTE] = ACTIONS(7530),
    [anon_sym_DQUOTE] = ACTIONS(7530),
    [sym_return] = ACTIONS(7532),
    [sym_next] = ACTIONS(7532),
    [sym_break] = ACTIONS(7532),
    [sym_true] = ACTIONS(7532),
    [sym_false] = ACTIONS(7532),
    [sym_null] = ACTIONS(7532),
    [sym_inf] = ACTIONS(7532),
    [sym_nan] = ACTIONS(7532),
    [anon_sym_NA] = ACTIONS(7532),
    [anon_sym_NA_integer_] = ACTIONS(7532),
    [anon_sym_NA_real_] = ACTIONS(7532),
    [anon_sym_NA_complex_] = ACTIONS(7532),
    [anon_sym_NA_character_] = ACTIONS(7532),
    [sym_dots] = ACTIONS(7532),
    [sym_dot_dot_i] = ACTIONS(7530),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7530),
    [sym__newline] = ACTIONS(7530),
    [sym__raw_string_literal] = ACTIONS(7530),
    [sym__external_else] = ACTIONS(7530),
    [sym__external_open_parenthesis] = ACTIONS(7530),
    [sym__external_close_parenthesis] = ACTIONS(7530),
    [sym__external_open_brace] = ACTIONS(7530),
    [sym__external_open_bracket] = ACTIONS(7530),
    [sym__external_close_bracket] = ACTIONS(7530),
    [sym__external_open_bracket2] = ACTIONS(7530),
  },
  [2732] = {
    [sym_identifier] = ACTIONS(7540),
    [anon_sym_BSLASH] = ACTIONS(7538),
    [anon_sym_function] = ACTIONS(7540),
    [anon_sym_EQ] = ACTIONS(7540),
    [anon_sym_if] = ACTIONS(7540),
    [anon_sym_for] = ACTIONS(7540),
    [anon_sym_while] = ACTIONS(7540),
    [anon_sym_repeat] = ACTIONS(7540),
    [anon_sym_QMARK] = ACTIONS(7538),
    [anon_sym_TILDE] = ACTIONS(7538),
    [anon_sym_BANG] = ACTIONS(7540),
    [anon_sym_PLUS] = ACTIONS(7538),
    [anon_sym_DASH] = ACTIONS(7540),
    [anon_sym_LT_DASH] = ACTIONS(7538),
    [anon_sym_LT_LT_DASH] = ACTIONS(7538),
    [anon_sym_COLON_EQ] = ACTIONS(7538),
    [anon_sym_DASH_GT] = ACTIONS(7540),
    [anon_sym_DASH_GT_GT] = ACTIONS(7538),
    [anon_sym_PIPE] = ACTIONS(7540),
    [anon_sym_AMP] = ACTIONS(7540),
    [anon_sym_PIPE_PIPE] = ACTIONS(7538),
    [anon_sym_AMP_AMP] = ACTIONS(7538),
    [anon_sym_LT] = ACTIONS(7540),
    [anon_sym_LT_EQ] = ACTIONS(7538),
    [anon_sym_GT] = ACTIONS(7540),
    [anon_sym_GT_EQ] = ACTIONS(7538),
    [anon_sym_EQ_EQ] = ACTIONS(7538),
    [anon_sym_BANG_EQ] = ACTIONS(7538),
    [anon_sym_STAR] = ACTIONS(7540),
    [anon_sym_SLASH] = ACTIONS(7538),
    [anon_sym_STAR_STAR] = ACTIONS(7538),
    [anon_sym_CARET] = ACTIONS(7538),
    [aux_sym_binary_operator_token1] = ACTIONS(7538),
    [anon_sym_PIPE_GT] = ACTIONS(7538),
    [anon_sym_COLON] = ACTIONS(7540),
    [anon_sym_DOLLAR] = ACTIONS(7538),
    [anon_sym_AT] = ACTIONS(7538),
    [aux_sym__hex_literal_token1] = ACTIONS(7538),
    [sym__number_literal] = ACTIONS(7540),
    [anon_sym_SQUOTE] = ACTIONS(7538),
    [anon_sym_DQUOTE] = ACTIONS(7538),
    [sym_return] = ACTIONS(7540),
    [sym_next] = ACTIONS(7540),
    [sym_break] = ACTIONS(7540),
    [sym_true] = ACTIONS(7540),
    [sym_false] = ACTIONS(7540),
    [sym_null] = ACTIONS(7540),
    [sym_inf] = ACTIONS(7540),
    [sym_nan] = ACTIONS(7540),
    [anon_sym_NA] = ACTIONS(7540),
    [anon_sym_NA_integer_] = ACTIONS(7540),
    [anon_sym_NA_real_] = ACTIONS(7540),
    [anon_sym_NA_complex_] = ACTIONS(7540),
    [anon_sym_NA_character_] = ACTIONS(7540),
    [sym_dots] = ACTIONS(7540),
    [sym_dot_dot_i] = ACTIONS(7538),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7538),
    [sym__newline] = ACTIONS(7538),
    [sym__raw_string_literal] = ACTIONS(7538),
    [sym__external_else] = ACTIONS(7538),
    [sym__external_open_parenthesis] = ACTIONS(7538),
    [sym__external_close_parenthesis] = ACTIONS(7538),
    [sym__external_open_brace] = ACTIONS(7538),
    [sym__external_open_bracket] = ACTIONS(7538),
    [sym__external_close_bracket] = ACTIONS(7538),
    [sym__external_open_bracket2] = ACTIONS(7538),
  },
  [2733] = {
    [sym_identifier] = ACTIONS(7512),
    [anon_sym_BSLASH] = ACTIONS(7510),
    [anon_sym_function] = ACTIONS(7512),
    [anon_sym_EQ] = ACTIONS(7512),
    [anon_sym_if] = ACTIONS(7512),
    [anon_sym_for] = ACTIONS(7512),
    [anon_sym_while] = ACTIONS(7512),
    [anon_sym_repeat] = ACTIONS(7512),
    [anon_sym_QMARK] = ACTIONS(7510),
    [anon_sym_TILDE] = ACTIONS(7510),
    [anon_sym_BANG] = ACTIONS(7512),
    [anon_sym_PLUS] = ACTIONS(7510),
    [anon_sym_DASH] = ACTIONS(7512),
    [anon_sym_LT_DASH] = ACTIONS(7510),
    [anon_sym_LT_LT_DASH] = ACTIONS(7510),
    [anon_sym_COLON_EQ] = ACTIONS(7510),
    [anon_sym_DASH_GT] = ACTIONS(7512),
    [anon_sym_DASH_GT_GT] = ACTIONS(7510),
    [anon_sym_PIPE] = ACTIONS(7512),
    [anon_sym_AMP] = ACTIONS(7512),
    [anon_sym_PIPE_PIPE] = ACTIONS(7510),
    [anon_sym_AMP_AMP] = ACTIONS(7510),
    [anon_sym_LT] = ACTIONS(7512),
    [anon_sym_LT_EQ] = ACTIONS(7510),
    [anon_sym_GT] = ACTIONS(7512),
    [anon_sym_GT_EQ] = ACTIONS(7510),
    [anon_sym_EQ_EQ] = ACTIONS(7510),
    [anon_sym_BANG_EQ] = ACTIONS(7510),
    [anon_sym_STAR] = ACTIONS(7512),
    [anon_sym_SLASH] = ACTIONS(7510),
    [anon_sym_STAR_STAR] = ACTIONS(7510),
    [anon_sym_CARET] = ACTIONS(7510),
    [aux_sym_binary_operator_token1] = ACTIONS(7510),
    [anon_sym_PIPE_GT] = ACTIONS(7510),
    [anon_sym_COLON] = ACTIONS(7512),
    [anon_sym_DOLLAR] = ACTIONS(7510),
    [anon_sym_AT] = ACTIONS(7510),
    [aux_sym__hex_literal_token1] = ACTIONS(7510),
    [sym__number_literal] = ACTIONS(7512),
    [anon_sym_SQUOTE] = ACTIONS(7510),
    [anon_sym_DQUOTE] = ACTIONS(7510),
    [sym_return] = ACTIONS(7512),
    [sym_next] = ACTIONS(7512),
    [sym_break] = ACTIONS(7512),
    [sym_true] = ACTIONS(7512),
    [sym_false] = ACTIONS(7512),
    [sym_null] = ACTIONS(7512),
    [sym_inf] = ACTIONS(7512),
    [sym_nan] = ACTIONS(7512),
    [anon_sym_NA] = ACTIONS(7512),
    [anon_sym_NA_integer_] = ACTIONS(7512),
    [anon_sym_NA_real_] = ACTIONS(7512),
    [anon_sym_NA_complex_] = ACTIONS(7512),
    [anon_sym_NA_character_] = ACTIONS(7512),
    [sym_dots] = ACTIONS(7512),
    [sym_dot_dot_i] = ACTIONS(7510),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7510),
    [sym__newline] = ACTIONS(7510),
    [sym__semicolon] = ACTIONS(7510),
    [sym__raw_string_literal] = ACTIONS(7510),
    [sym__external_open_parenthesis] = ACTIONS(7510),
    [sym__external_open_brace] = ACTIONS(7510),
    [sym__external_close_brace] = ACTIONS(7510),
    [sym__external_open_bracket] = ACTIONS(7510),
    [sym__external_open_bracket2] = ACTIONS(7510),
    [sym__external_close_bracket2] = ACTIONS(7510),
  },
  [2734] = {
    [sym_identifier] = ACTIONS(7544),
    [anon_sym_BSLASH] = ACTIONS(7542),
    [anon_sym_function] = ACTIONS(7544),
    [anon_sym_EQ] = ACTIONS(7544),
    [anon_sym_if] = ACTIONS(7544),
    [anon_sym_for] = ACTIONS(7544),
    [anon_sym_while] = ACTIONS(7544),
    [anon_sym_repeat] = ACTIONS(7544),
    [anon_sym_QMARK] = ACTIONS(7542),
    [anon_sym_TILDE] = ACTIONS(7542),
    [anon_sym_BANG] = ACTIONS(7544),
    [anon_sym_PLUS] = ACTIONS(7542),
    [anon_sym_DASH] = ACTIONS(7544),
    [anon_sym_LT_DASH] = ACTIONS(7542),
    [anon_sym_LT_LT_DASH] = ACTIONS(7542),
    [anon_sym_COLON_EQ] = ACTIONS(7542),
    [anon_sym_DASH_GT] = ACTIONS(7544),
    [anon_sym_DASH_GT_GT] = ACTIONS(7542),
    [anon_sym_PIPE] = ACTIONS(7544),
    [anon_sym_AMP] = ACTIONS(7544),
    [anon_sym_PIPE_PIPE] = ACTIONS(7542),
    [anon_sym_AMP_AMP] = ACTIONS(7542),
    [anon_sym_LT] = ACTIONS(7544),
    [anon_sym_LT_EQ] = ACTIONS(7542),
    [anon_sym_GT] = ACTIONS(7544),
    [anon_sym_GT_EQ] = ACTIONS(7542),
    [anon_sym_EQ_EQ] = ACTIONS(7542),
    [anon_sym_BANG_EQ] = ACTIONS(7542),
    [anon_sym_STAR] = ACTIONS(7544),
    [anon_sym_SLASH] = ACTIONS(7542),
    [anon_sym_STAR_STAR] = ACTIONS(7542),
    [anon_sym_CARET] = ACTIONS(7542),
    [aux_sym_binary_operator_token1] = ACTIONS(7542),
    [anon_sym_PIPE_GT] = ACTIONS(7542),
    [anon_sym_COLON] = ACTIONS(7544),
    [anon_sym_DOLLAR] = ACTIONS(7542),
    [anon_sym_AT] = ACTIONS(7542),
    [aux_sym__hex_literal_token1] = ACTIONS(7542),
    [sym__number_literal] = ACTIONS(7544),
    [anon_sym_SQUOTE] = ACTIONS(7542),
    [anon_sym_DQUOTE] = ACTIONS(7542),
    [sym_return] = ACTIONS(7544),
    [sym_next] = ACTIONS(7544),
    [sym_break] = ACTIONS(7544),
    [sym_true] = ACTIONS(7544),
    [sym_false] = ACTIONS(7544),
    [sym_null] = ACTIONS(7544),
    [sym_inf] = ACTIONS(7544),
    [sym_nan] = ACTIONS(7544),
    [anon_sym_NA] = ACTIONS(7544),
    [anon_sym_NA_integer_] = ACTIONS(7544),
    [anon_sym_NA_real_] = ACTIONS(7544),
    [anon_sym_NA_complex_] = ACTIONS(7544),
    [anon_sym_NA_character_] = ACTIONS(7544),
    [sym_dots] = ACTIONS(7544),
    [sym_dot_dot_i] = ACTIONS(7542),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7542),
    [sym__newline] = ACTIONS(7542),
    [sym__raw_string_literal] = ACTIONS(7542),
    [sym__external_else] = ACTIONS(7542),
    [sym__external_open_parenthesis] = ACTIONS(7542),
    [sym__external_close_parenthesis] = ACTIONS(7542),
    [sym__external_open_brace] = ACTIONS(7542),
    [sym__external_open_bracket] = ACTIONS(7542),
    [sym__external_close_bracket] = ACTIONS(7542),
    [sym__external_open_bracket2] = ACTIONS(7542),
  },
  [2735] = {
    [sym_identifier] = ACTIONS(7115),
    [anon_sym_BSLASH] = ACTIONS(7117),
    [anon_sym_function] = ACTIONS(7115),
    [anon_sym_EQ] = ACTIONS(7115),
    [anon_sym_if] = ACTIONS(7115),
    [anon_sym_for] = ACTIONS(7115),
    [anon_sym_while] = ACTIONS(7115),
    [anon_sym_repeat] = ACTIONS(7115),
    [anon_sym_QMARK] = ACTIONS(7117),
    [anon_sym_TILDE] = ACTIONS(7117),
    [anon_sym_BANG] = ACTIONS(7115),
    [anon_sym_PLUS] = ACTIONS(7117),
    [anon_sym_DASH] = ACTIONS(7115),
    [anon_sym_LT_DASH] = ACTIONS(7117),
    [anon_sym_LT_LT_DASH] = ACTIONS(7117),
    [anon_sym_COLON_EQ] = ACTIONS(7117),
    [anon_sym_DASH_GT] = ACTIONS(7115),
    [anon_sym_DASH_GT_GT] = ACTIONS(7117),
    [anon_sym_PIPE] = ACTIONS(7115),
    [anon_sym_AMP] = ACTIONS(7115),
    [anon_sym_PIPE_PIPE] = ACTIONS(7117),
    [anon_sym_AMP_AMP] = ACTIONS(7117),
    [anon_sym_LT] = ACTIONS(7115),
    [anon_sym_LT_EQ] = ACTIONS(7117),
    [anon_sym_GT] = ACTIONS(7115),
    [anon_sym_GT_EQ] = ACTIONS(7117),
    [anon_sym_EQ_EQ] = ACTIONS(7117),
    [anon_sym_BANG_EQ] = ACTIONS(7117),
    [anon_sym_STAR] = ACTIONS(7115),
    [anon_sym_SLASH] = ACTIONS(7117),
    [anon_sym_STAR_STAR] = ACTIONS(7117),
    [anon_sym_CARET] = ACTIONS(7117),
    [aux_sym_binary_operator_token1] = ACTIONS(7117),
    [anon_sym_PIPE_GT] = ACTIONS(7117),
    [anon_sym_COLON] = ACTIONS(7115),
    [anon_sym_DOLLAR] = ACTIONS(7117),
    [anon_sym_AT] = ACTIONS(7117),
    [anon_sym_COLON_COLON] = ACTIONS(7115),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7117),
    [aux_sym__hex_literal_token1] = ACTIONS(7117),
    [sym__number_literal] = ACTIONS(7115),
    [anon_sym_SQUOTE] = ACTIONS(7117),
    [anon_sym_DQUOTE] = ACTIONS(7117),
    [sym_return] = ACTIONS(7115),
    [sym_next] = ACTIONS(7115),
    [sym_break] = ACTIONS(7115),
    [sym_true] = ACTIONS(7115),
    [sym_false] = ACTIONS(7115),
    [sym_null] = ACTIONS(7115),
    [sym_inf] = ACTIONS(7115),
    [sym_nan] = ACTIONS(7115),
    [anon_sym_NA] = ACTIONS(7115),
    [anon_sym_NA_integer_] = ACTIONS(7115),
    [anon_sym_NA_real_] = ACTIONS(7115),
    [anon_sym_NA_complex_] = ACTIONS(7115),
    [anon_sym_NA_character_] = ACTIONS(7115),
    [sym_dots] = ACTIONS(7115),
    [sym_dot_dot_i] = ACTIONS(7117),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7117),
    [sym__newline] = ACTIONS(7117),
    [sym__raw_string_literal] = ACTIONS(7117),
    [sym__external_open_parenthesis] = ACTIONS(7117),
    [sym__external_close_parenthesis] = ACTIONS(7117),
    [sym__external_open_brace] = ACTIONS(7117),
    [sym__external_open_bracket] = ACTIONS(7117),
    [sym__external_open_bracket2] = ACTIONS(7117),
  },
  [2736] = {
    [sym_identifier] = ACTIONS(7556),
    [anon_sym_BSLASH] = ACTIONS(7554),
    [anon_sym_function] = ACTIONS(7556),
    [anon_sym_EQ] = ACTIONS(7556),
    [anon_sym_if] = ACTIONS(7556),
    [anon_sym_for] = ACTIONS(7556),
    [anon_sym_while] = ACTIONS(7556),
    [anon_sym_repeat] = ACTIONS(7556),
    [anon_sym_QMARK] = ACTIONS(7554),
    [anon_sym_TILDE] = ACTIONS(7554),
    [anon_sym_BANG] = ACTIONS(7556),
    [anon_sym_PLUS] = ACTIONS(7554),
    [anon_sym_DASH] = ACTIONS(7556),
    [anon_sym_LT_DASH] = ACTIONS(7554),
    [anon_sym_LT_LT_DASH] = ACTIONS(7554),
    [anon_sym_COLON_EQ] = ACTIONS(7554),
    [anon_sym_DASH_GT] = ACTIONS(7556),
    [anon_sym_DASH_GT_GT] = ACTIONS(7554),
    [anon_sym_PIPE] = ACTIONS(7556),
    [anon_sym_AMP] = ACTIONS(7556),
    [anon_sym_PIPE_PIPE] = ACTIONS(7554),
    [anon_sym_AMP_AMP] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(7556),
    [anon_sym_LT_EQ] = ACTIONS(7554),
    [anon_sym_GT] = ACTIONS(7556),
    [anon_sym_GT_EQ] = ACTIONS(7554),
    [anon_sym_EQ_EQ] = ACTIONS(7554),
    [anon_sym_BANG_EQ] = ACTIONS(7554),
    [anon_sym_STAR] = ACTIONS(7556),
    [anon_sym_SLASH] = ACTIONS(7554),
    [anon_sym_STAR_STAR] = ACTIONS(7554),
    [anon_sym_CARET] = ACTIONS(7554),
    [aux_sym_binary_operator_token1] = ACTIONS(7554),
    [anon_sym_PIPE_GT] = ACTIONS(7554),
    [anon_sym_COLON] = ACTIONS(7556),
    [anon_sym_DOLLAR] = ACTIONS(7554),
    [anon_sym_AT] = ACTIONS(7554),
    [aux_sym__hex_literal_token1] = ACTIONS(7554),
    [sym__number_literal] = ACTIONS(7556),
    [anon_sym_SQUOTE] = ACTIONS(7554),
    [anon_sym_DQUOTE] = ACTIONS(7554),
    [sym_return] = ACTIONS(7556),
    [sym_next] = ACTIONS(7556),
    [sym_break] = ACTIONS(7556),
    [sym_true] = ACTIONS(7556),
    [sym_false] = ACTIONS(7556),
    [sym_null] = ACTIONS(7556),
    [sym_inf] = ACTIONS(7556),
    [sym_nan] = ACTIONS(7556),
    [anon_sym_NA] = ACTIONS(7556),
    [anon_sym_NA_integer_] = ACTIONS(7556),
    [anon_sym_NA_real_] = ACTIONS(7556),
    [anon_sym_NA_complex_] = ACTIONS(7556),
    [anon_sym_NA_character_] = ACTIONS(7556),
    [sym_dots] = ACTIONS(7556),
    [sym_dot_dot_i] = ACTIONS(7554),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7554),
    [sym__newline] = ACTIONS(7554),
    [sym__semicolon] = ACTIONS(7554),
    [sym__raw_string_literal] = ACTIONS(7554),
    [sym__external_open_parenthesis] = ACTIONS(7554),
    [sym__external_open_brace] = ACTIONS(7554),
    [sym__external_close_brace] = ACTIONS(7554),
    [sym__external_open_bracket] = ACTIONS(7554),
    [sym__external_close_bracket] = ACTIONS(7554),
    [sym__external_open_bracket2] = ACTIONS(7554),
  },
  [2737] = {
    [ts_builtin_sym_end] = ACTIONS(7117),
    [sym_identifier] = ACTIONS(7115),
    [anon_sym_BSLASH] = ACTIONS(7117),
    [anon_sym_function] = ACTIONS(7115),
    [anon_sym_EQ] = ACTIONS(7115),
    [anon_sym_if] = ACTIONS(7115),
    [anon_sym_for] = ACTIONS(7115),
    [anon_sym_while] = ACTIONS(7115),
    [anon_sym_repeat] = ACTIONS(7115),
    [anon_sym_QMARK] = ACTIONS(7117),
    [anon_sym_TILDE] = ACTIONS(7117),
    [anon_sym_BANG] = ACTIONS(7115),
    [anon_sym_PLUS] = ACTIONS(7117),
    [anon_sym_DASH] = ACTIONS(7115),
    [anon_sym_LT_DASH] = ACTIONS(7117),
    [anon_sym_LT_LT_DASH] = ACTIONS(7117),
    [anon_sym_COLON_EQ] = ACTIONS(7117),
    [anon_sym_DASH_GT] = ACTIONS(7115),
    [anon_sym_DASH_GT_GT] = ACTIONS(7117),
    [anon_sym_PIPE] = ACTIONS(7115),
    [anon_sym_AMP] = ACTIONS(7115),
    [anon_sym_PIPE_PIPE] = ACTIONS(7117),
    [anon_sym_AMP_AMP] = ACTIONS(7117),
    [anon_sym_LT] = ACTIONS(7115),
    [anon_sym_LT_EQ] = ACTIONS(7117),
    [anon_sym_GT] = ACTIONS(7115),
    [anon_sym_GT_EQ] = ACTIONS(7117),
    [anon_sym_EQ_EQ] = ACTIONS(7117),
    [anon_sym_BANG_EQ] = ACTIONS(7117),
    [anon_sym_STAR] = ACTIONS(7115),
    [anon_sym_SLASH] = ACTIONS(7117),
    [anon_sym_STAR_STAR] = ACTIONS(7117),
    [anon_sym_CARET] = ACTIONS(7117),
    [aux_sym_binary_operator_token1] = ACTIONS(7117),
    [anon_sym_PIPE_GT] = ACTIONS(7117),
    [anon_sym_COLON] = ACTIONS(7115),
    [anon_sym_DOLLAR] = ACTIONS(7117),
    [anon_sym_AT] = ACTIONS(7117),
    [anon_sym_COLON_COLON] = ACTIONS(7115),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7117),
    [aux_sym__hex_literal_token1] = ACTIONS(7117),
    [sym__number_literal] = ACTIONS(7115),
    [anon_sym_SQUOTE] = ACTIONS(7117),
    [anon_sym_DQUOTE] = ACTIONS(7117),
    [sym_return] = ACTIONS(7115),
    [sym_next] = ACTIONS(7115),
    [sym_break] = ACTIONS(7115),
    [sym_true] = ACTIONS(7115),
    [sym_false] = ACTIONS(7115),
    [sym_null] = ACTIONS(7115),
    [sym_inf] = ACTIONS(7115),
    [sym_nan] = ACTIONS(7115),
    [anon_sym_NA] = ACTIONS(7115),
    [anon_sym_NA_integer_] = ACTIONS(7115),
    [anon_sym_NA_real_] = ACTIONS(7115),
    [anon_sym_NA_complex_] = ACTIONS(7115),
    [anon_sym_NA_character_] = ACTIONS(7115),
    [sym_dots] = ACTIONS(7115),
    [sym_dot_dot_i] = ACTIONS(7117),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7117),
    [sym__semicolon] = ACTIONS(7117),
    [sym__raw_string_literal] = ACTIONS(7117),
    [sym__external_open_parenthesis] = ACTIONS(7117),
    [sym__external_open_brace] = ACTIONS(7117),
    [sym__external_open_bracket] = ACTIONS(7117),
    [sym__external_open_bracket2] = ACTIONS(7117),
  },
  [2738] = {
    [ts_builtin_sym_end] = ACTIONS(7117),
    [sym_identifier] = ACTIONS(7115),
    [anon_sym_BSLASH] = ACTIONS(7117),
    [anon_sym_function] = ACTIONS(7115),
    [anon_sym_EQ] = ACTIONS(7115),
    [anon_sym_if] = ACTIONS(7115),
    [anon_sym_for] = ACTIONS(7115),
    [anon_sym_while] = ACTIONS(7115),
    [anon_sym_repeat] = ACTIONS(7115),
    [anon_sym_QMARK] = ACTIONS(7117),
    [anon_sym_TILDE] = ACTIONS(7117),
    [anon_sym_BANG] = ACTIONS(7115),
    [anon_sym_PLUS] = ACTIONS(7117),
    [anon_sym_DASH] = ACTIONS(7115),
    [anon_sym_LT_DASH] = ACTIONS(7117),
    [anon_sym_LT_LT_DASH] = ACTIONS(7117),
    [anon_sym_COLON_EQ] = ACTIONS(7117),
    [anon_sym_DASH_GT] = ACTIONS(7115),
    [anon_sym_DASH_GT_GT] = ACTIONS(7117),
    [anon_sym_PIPE] = ACTIONS(7115),
    [anon_sym_AMP] = ACTIONS(7115),
    [anon_sym_PIPE_PIPE] = ACTIONS(7117),
    [anon_sym_AMP_AMP] = ACTIONS(7117),
    [anon_sym_LT] = ACTIONS(7115),
    [anon_sym_LT_EQ] = ACTIONS(7117),
    [anon_sym_GT] = ACTIONS(7115),
    [anon_sym_GT_EQ] = ACTIONS(7117),
    [anon_sym_EQ_EQ] = ACTIONS(7117),
    [anon_sym_BANG_EQ] = ACTIONS(7117),
    [anon_sym_STAR] = ACTIONS(7115),
    [anon_sym_SLASH] = ACTIONS(7117),
    [anon_sym_STAR_STAR] = ACTIONS(7117),
    [anon_sym_CARET] = ACTIONS(7117),
    [aux_sym_binary_operator_token1] = ACTIONS(7117),
    [anon_sym_PIPE_GT] = ACTIONS(7117),
    [anon_sym_COLON] = ACTIONS(7115),
    [anon_sym_DOLLAR] = ACTIONS(7117),
    [anon_sym_AT] = ACTIONS(7117),
    [anon_sym_COLON_COLON] = ACTIONS(7115),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7117),
    [aux_sym__hex_literal_token1] = ACTIONS(7117),
    [sym__number_literal] = ACTIONS(7115),
    [anon_sym_SQUOTE] = ACTIONS(7117),
    [anon_sym_DQUOTE] = ACTIONS(7117),
    [sym_return] = ACTIONS(7115),
    [sym_next] = ACTIONS(7115),
    [sym_break] = ACTIONS(7115),
    [sym_true] = ACTIONS(7115),
    [sym_false] = ACTIONS(7115),
    [sym_null] = ACTIONS(7115),
    [sym_inf] = ACTIONS(7115),
    [sym_nan] = ACTIONS(7115),
    [anon_sym_NA] = ACTIONS(7115),
    [anon_sym_NA_integer_] = ACTIONS(7115),
    [anon_sym_NA_real_] = ACTIONS(7115),
    [anon_sym_NA_complex_] = ACTIONS(7115),
    [anon_sym_NA_character_] = ACTIONS(7115),
    [sym_dots] = ACTIONS(7115),
    [sym_dot_dot_i] = ACTIONS(7117),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7117),
    [sym__semicolon] = ACTIONS(7117),
    [sym__raw_string_literal] = ACTIONS(7117),
    [sym__external_open_parenthesis] = ACTIONS(7117),
    [sym__external_open_brace] = ACTIONS(7117),
    [sym__external_open_bracket] = ACTIONS(7117),
    [sym__external_open_bracket2] = ACTIONS(7117),
  },
  [2739] = {
    [ts_builtin_sym_end] = ACTIONS(7123),
    [sym_identifier] = ACTIONS(7121),
    [anon_sym_BSLASH] = ACTIONS(7123),
    [anon_sym_function] = ACTIONS(7121),
    [anon_sym_EQ] = ACTIONS(7121),
    [anon_sym_if] = ACTIONS(7121),
    [anon_sym_for] = ACTIONS(7121),
    [anon_sym_while] = ACTIONS(7121),
    [anon_sym_repeat] = ACTIONS(7121),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_TILDE] = ACTIONS(7123),
    [anon_sym_BANG] = ACTIONS(7121),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_DASH] = ACTIONS(7121),
    [anon_sym_LT_DASH] = ACTIONS(7123),
    [anon_sym_LT_LT_DASH] = ACTIONS(7123),
    [anon_sym_COLON_EQ] = ACTIONS(7123),
    [anon_sym_DASH_GT] = ACTIONS(7121),
    [anon_sym_DASH_GT_GT] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_LT_EQ] = ACTIONS(7123),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
    [aux_sym_binary_operator_token1] = ACTIONS(7123),
    [anon_sym_PIPE_GT] = ACTIONS(7123),
    [anon_sym_COLON] = ACTIONS(7121),
    [anon_sym_DOLLAR] = ACTIONS(7123),
    [anon_sym_AT] = ACTIONS(7123),
    [anon_sym_L] = ACTIONS(7688),
    [anon_sym_i] = ACTIONS(7690),
    [aux_sym__hex_literal_token1] = ACTIONS(7123),
    [sym__number_literal] = ACTIONS(7121),
    [anon_sym_SQUOTE] = ACTIONS(7123),
    [anon_sym_DQUOTE] = ACTIONS(7123),
    [sym_return] = ACTIONS(7121),
    [sym_next] = ACTIONS(7121),
    [sym_break] = ACTIONS(7121),
    [sym_true] = ACTIONS(7121),
    [sym_false] = ACTIONS(7121),
    [sym_null] = ACTIONS(7121),
    [sym_inf] = ACTIONS(7121),
    [sym_nan] = ACTIONS(7121),
    [anon_sym_NA] = ACTIONS(7121),
    [anon_sym_NA_integer_] = ACTIONS(7121),
    [anon_sym_NA_real_] = ACTIONS(7121),
    [anon_sym_NA_complex_] = ACTIONS(7121),
    [anon_sym_NA_character_] = ACTIONS(7121),
    [sym_dots] = ACTIONS(7121),
    [sym_dot_dot_i] = ACTIONS(7123),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7123),
    [sym__semicolon] = ACTIONS(7123),
    [sym__raw_string_literal] = ACTIONS(7123),
    [sym__external_open_parenthesis] = ACTIONS(7123),
    [sym__external_open_brace] = ACTIONS(7123),
    [sym__external_open_bracket] = ACTIONS(7123),
    [sym__external_open_bracket2] = ACTIONS(7123),
  },
  [2740] = {
    [sym_identifier] = ACTIONS(7552),
    [anon_sym_BSLASH] = ACTIONS(7550),
    [anon_sym_function] = ACTIONS(7552),
    [anon_sym_EQ] = ACTIONS(7552),
    [anon_sym_if] = ACTIONS(7552),
    [anon_sym_for] = ACTIONS(7552),
    [anon_sym_while] = ACTIONS(7552),
    [anon_sym_repeat] = ACTIONS(7552),
    [anon_sym_QMARK] = ACTIONS(7550),
    [anon_sym_TILDE] = ACTIONS(7550),
    [anon_sym_BANG] = ACTIONS(7552),
    [anon_sym_PLUS] = ACTIONS(7550),
    [anon_sym_DASH] = ACTIONS(7552),
    [anon_sym_LT_DASH] = ACTIONS(7550),
    [anon_sym_LT_LT_DASH] = ACTIONS(7550),
    [anon_sym_COLON_EQ] = ACTIONS(7550),
    [anon_sym_DASH_GT] = ACTIONS(7552),
    [anon_sym_DASH_GT_GT] = ACTIONS(7550),
    [anon_sym_PIPE] = ACTIONS(7552),
    [anon_sym_AMP] = ACTIONS(7552),
    [anon_sym_PIPE_PIPE] = ACTIONS(7550),
    [anon_sym_AMP_AMP] = ACTIONS(7550),
    [anon_sym_LT] = ACTIONS(7552),
    [anon_sym_LT_EQ] = ACTIONS(7550),
    [anon_sym_GT] = ACTIONS(7552),
    [anon_sym_GT_EQ] = ACTIONS(7550),
    [anon_sym_EQ_EQ] = ACTIONS(7550),
    [anon_sym_BANG_EQ] = ACTIONS(7550),
    [anon_sym_STAR] = ACTIONS(7552),
    [anon_sym_SLASH] = ACTIONS(7550),
    [anon_sym_STAR_STAR] = ACTIONS(7550),
    [anon_sym_CARET] = ACTIONS(7550),
    [aux_sym_binary_operator_token1] = ACTIONS(7550),
    [anon_sym_PIPE_GT] = ACTIONS(7550),
    [anon_sym_COLON] = ACTIONS(7552),
    [anon_sym_DOLLAR] = ACTIONS(7550),
    [anon_sym_AT] = ACTIONS(7550),
    [aux_sym__hex_literal_token1] = ACTIONS(7550),
    [sym__number_literal] = ACTIONS(7552),
    [anon_sym_SQUOTE] = ACTIONS(7550),
    [anon_sym_DQUOTE] = ACTIONS(7550),
    [sym_return] = ACTIONS(7552),
    [sym_next] = ACTIONS(7552),
    [sym_break] = ACTIONS(7552),
    [sym_true] = ACTIONS(7552),
    [sym_false] = ACTIONS(7552),
    [sym_null] = ACTIONS(7552),
    [sym_inf] = ACTIONS(7552),
    [sym_nan] = ACTIONS(7552),
    [anon_sym_NA] = ACTIONS(7552),
    [anon_sym_NA_integer_] = ACTIONS(7552),
    [anon_sym_NA_real_] = ACTIONS(7552),
    [anon_sym_NA_complex_] = ACTIONS(7552),
    [anon_sym_NA_character_] = ACTIONS(7552),
    [sym_dots] = ACTIONS(7552),
    [sym_dot_dot_i] = ACTIONS(7550),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7550),
    [sym__newline] = ACTIONS(7550),
    [sym__raw_string_literal] = ACTIONS(7550),
    [sym__external_else] = ACTIONS(7550),
    [sym__external_open_parenthesis] = ACTIONS(7550),
    [sym__external_close_parenthesis] = ACTIONS(7550),
    [sym__external_open_brace] = ACTIONS(7550),
    [sym__external_open_bracket] = ACTIONS(7550),
    [sym__external_close_bracket] = ACTIONS(7550),
    [sym__external_open_bracket2] = ACTIONS(7550),
  },
  [2741] = {
    [sym_identifier] = ACTIONS(7191),
    [anon_sym_BSLASH] = ACTIONS(7189),
    [anon_sym_function] = ACTIONS(7191),
    [anon_sym_EQ] = ACTIONS(7191),
    [anon_sym_if] = ACTIONS(7191),
    [anon_sym_for] = ACTIONS(7191),
    [anon_sym_while] = ACTIONS(7191),
    [anon_sym_repeat] = ACTIONS(7191),
    [anon_sym_QMARK] = ACTIONS(7189),
    [anon_sym_TILDE] = ACTIONS(7189),
    [anon_sym_BANG] = ACTIONS(7191),
    [anon_sym_PLUS] = ACTIONS(7189),
    [anon_sym_DASH] = ACTIONS(7191),
    [anon_sym_LT_DASH] = ACTIONS(7189),
    [anon_sym_LT_LT_DASH] = ACTIONS(7189),
    [anon_sym_COLON_EQ] = ACTIONS(7189),
    [anon_sym_DASH_GT] = ACTIONS(7191),
    [anon_sym_DASH_GT_GT] = ACTIONS(7189),
    [anon_sym_PIPE] = ACTIONS(7191),
    [anon_sym_AMP] = ACTIONS(7191),
    [anon_sym_PIPE_PIPE] = ACTIONS(7189),
    [anon_sym_AMP_AMP] = ACTIONS(7189),
    [anon_sym_LT] = ACTIONS(7191),
    [anon_sym_LT_EQ] = ACTIONS(7189),
    [anon_sym_GT] = ACTIONS(7191),
    [anon_sym_GT_EQ] = ACTIONS(7189),
    [anon_sym_EQ_EQ] = ACTIONS(7189),
    [anon_sym_BANG_EQ] = ACTIONS(7189),
    [anon_sym_STAR] = ACTIONS(7191),
    [anon_sym_SLASH] = ACTIONS(7189),
    [anon_sym_STAR_STAR] = ACTIONS(7189),
    [anon_sym_CARET] = ACTIONS(7189),
    [aux_sym_binary_operator_token1] = ACTIONS(7189),
    [anon_sym_PIPE_GT] = ACTIONS(7189),
    [anon_sym_COLON] = ACTIONS(7191),
    [anon_sym_DOLLAR] = ACTIONS(7189),
    [anon_sym_AT] = ACTIONS(7189),
    [anon_sym_COLON_COLON] = ACTIONS(7191),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7189),
    [aux_sym__hex_literal_token1] = ACTIONS(7189),
    [sym__number_literal] = ACTIONS(7191),
    [anon_sym_SQUOTE] = ACTIONS(7189),
    [anon_sym_DQUOTE] = ACTIONS(7189),
    [sym_return] = ACTIONS(7191),
    [sym_next] = ACTIONS(7191),
    [sym_break] = ACTIONS(7191),
    [sym_true] = ACTIONS(7191),
    [sym_false] = ACTIONS(7191),
    [sym_null] = ACTIONS(7191),
    [sym_inf] = ACTIONS(7191),
    [sym_nan] = ACTIONS(7191),
    [anon_sym_NA] = ACTIONS(7191),
    [anon_sym_NA_integer_] = ACTIONS(7191),
    [anon_sym_NA_real_] = ACTIONS(7191),
    [anon_sym_NA_complex_] = ACTIONS(7191),
    [anon_sym_NA_character_] = ACTIONS(7191),
    [sym_dots] = ACTIONS(7191),
    [sym_dot_dot_i] = ACTIONS(7189),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7189),
    [sym__newline] = ACTIONS(7189),
    [sym__raw_string_literal] = ACTIONS(7189),
    [sym__external_open_parenthesis] = ACTIONS(7189),
    [sym__external_open_brace] = ACTIONS(7189),
    [sym__external_open_bracket] = ACTIONS(7189),
    [sym__external_close_bracket] = ACTIONS(7189),
    [sym__external_open_bracket2] = ACTIONS(7189),
  },
  [2742] = {
    [aux_sym_function_definition_repeat1] = STATE(2742),
    [ts_builtin_sym_end] = ACTIONS(7417),
    [sym_identifier] = ACTIONS(7419),
    [anon_sym_BSLASH] = ACTIONS(7417),
    [anon_sym_function] = ACTIONS(7419),
    [anon_sym_EQ] = ACTIONS(7419),
    [anon_sym_if] = ACTIONS(7419),
    [anon_sym_for] = ACTIONS(7419),
    [anon_sym_while] = ACTIONS(7419),
    [anon_sym_repeat] = ACTIONS(7419),
    [anon_sym_QMARK] = ACTIONS(7417),
    [anon_sym_TILDE] = ACTIONS(7417),
    [anon_sym_BANG] = ACTIONS(7419),
    [anon_sym_PLUS] = ACTIONS(7417),
    [anon_sym_DASH] = ACTIONS(7419),
    [anon_sym_LT_DASH] = ACTIONS(7417),
    [anon_sym_LT_LT_DASH] = ACTIONS(7417),
    [anon_sym_COLON_EQ] = ACTIONS(7417),
    [anon_sym_DASH_GT] = ACTIONS(7419),
    [anon_sym_DASH_GT_GT] = ACTIONS(7417),
    [anon_sym_PIPE] = ACTIONS(7419),
    [anon_sym_AMP] = ACTIONS(7419),
    [anon_sym_PIPE_PIPE] = ACTIONS(7417),
    [anon_sym_AMP_AMP] = ACTIONS(7417),
    [anon_sym_LT] = ACTIONS(7419),
    [anon_sym_LT_EQ] = ACTIONS(7417),
    [anon_sym_GT] = ACTIONS(7419),
    [anon_sym_GT_EQ] = ACTIONS(7417),
    [anon_sym_EQ_EQ] = ACTIONS(7417),
    [anon_sym_BANG_EQ] = ACTIONS(7417),
    [anon_sym_STAR] = ACTIONS(7419),
    [anon_sym_SLASH] = ACTIONS(7417),
    [anon_sym_STAR_STAR] = ACTIONS(7417),
    [anon_sym_CARET] = ACTIONS(7417),
    [aux_sym_binary_operator_token1] = ACTIONS(7417),
    [anon_sym_PIPE_GT] = ACTIONS(7417),
    [anon_sym_COLON] = ACTIONS(7419),
    [anon_sym_DOLLAR] = ACTIONS(7417),
    [anon_sym_AT] = ACTIONS(7417),
    [aux_sym__hex_literal_token1] = ACTIONS(7417),
    [sym__number_literal] = ACTIONS(7419),
    [anon_sym_SQUOTE] = ACTIONS(7417),
    [anon_sym_DQUOTE] = ACTIONS(7417),
    [sym_return] = ACTIONS(7419),
    [sym_next] = ACTIONS(7419),
    [sym_break] = ACTIONS(7419),
    [sym_true] = ACTIONS(7419),
    [sym_false] = ACTIONS(7419),
    [sym_null] = ACTIONS(7419),
    [sym_inf] = ACTIONS(7419),
    [sym_nan] = ACTIONS(7419),
    [anon_sym_NA] = ACTIONS(7419),
    [anon_sym_NA_integer_] = ACTIONS(7419),
    [anon_sym_NA_real_] = ACTIONS(7419),
    [anon_sym_NA_complex_] = ACTIONS(7419),
    [anon_sym_NA_character_] = ACTIONS(7419),
    [sym_dots] = ACTIONS(7419),
    [sym_dot_dot_i] = ACTIONS(7417),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7692),
    [sym__semicolon] = ACTIONS(7417),
    [sym__raw_string_literal] = ACTIONS(7417),
    [sym__external_else] = ACTIONS(7417),
    [sym__external_open_parenthesis] = ACTIONS(7417),
    [sym__external_open_brace] = ACTIONS(7417),
    [sym__external_open_bracket] = ACTIONS(7417),
    [sym__external_open_bracket2] = ACTIONS(7417),
  },
  [2743] = {
    [ts_builtin_sym_end] = ACTIONS(7565),
    [sym_identifier] = ACTIONS(7567),
    [anon_sym_BSLASH] = ACTIONS(7565),
    [anon_sym_function] = ACTIONS(7567),
    [anon_sym_EQ] = ACTIONS(7567),
    [anon_sym_if] = ACTIONS(7567),
    [anon_sym_for] = ACTIONS(7567),
    [anon_sym_while] = ACTIONS(7567),
    [anon_sym_repeat] = ACTIONS(7567),
    [anon_sym_QMARK] = ACTIONS(7565),
    [anon_sym_TILDE] = ACTIONS(7565),
    [anon_sym_BANG] = ACTIONS(7567),
    [anon_sym_PLUS] = ACTIONS(7565),
    [anon_sym_DASH] = ACTIONS(7567),
    [anon_sym_LT_DASH] = ACTIONS(7565),
    [anon_sym_LT_LT_DASH] = ACTIONS(7565),
    [anon_sym_COLON_EQ] = ACTIONS(7565),
    [anon_sym_DASH_GT] = ACTIONS(7567),
    [anon_sym_DASH_GT_GT] = ACTIONS(7565),
    [anon_sym_PIPE] = ACTIONS(7567),
    [anon_sym_AMP] = ACTIONS(7567),
    [anon_sym_PIPE_PIPE] = ACTIONS(7565),
    [anon_sym_AMP_AMP] = ACTIONS(7565),
    [anon_sym_LT] = ACTIONS(7567),
    [anon_sym_LT_EQ] = ACTIONS(7565),
    [anon_sym_GT] = ACTIONS(7567),
    [anon_sym_GT_EQ] = ACTIONS(7565),
    [anon_sym_EQ_EQ] = ACTIONS(7565),
    [anon_sym_BANG_EQ] = ACTIONS(7565),
    [anon_sym_STAR] = ACTIONS(7567),
    [anon_sym_SLASH] = ACTIONS(7565),
    [anon_sym_STAR_STAR] = ACTIONS(7565),
    [anon_sym_CARET] = ACTIONS(7565),
    [aux_sym_binary_operator_token1] = ACTIONS(7565),
    [anon_sym_PIPE_GT] = ACTIONS(7565),
    [anon_sym_COLON] = ACTIONS(7567),
    [anon_sym_DOLLAR] = ACTIONS(7565),
    [anon_sym_AT] = ACTIONS(7565),
    [aux_sym__hex_literal_token1] = ACTIONS(7565),
    [sym__number_literal] = ACTIONS(7567),
    [anon_sym_SQUOTE] = ACTIONS(7565),
    [anon_sym_DQUOTE] = ACTIONS(7565),
    [sym_return] = ACTIONS(7567),
    [sym_next] = ACTIONS(7567),
    [sym_break] = ACTIONS(7567),
    [sym_true] = ACTIONS(7567),
    [sym_false] = ACTIONS(7567),
    [sym_null] = ACTIONS(7567),
    [sym_inf] = ACTIONS(7567),
    [sym_nan] = ACTIONS(7567),
    [anon_sym_NA] = ACTIONS(7567),
    [anon_sym_NA_integer_] = ACTIONS(7567),
    [anon_sym_NA_real_] = ACTIONS(7567),
    [anon_sym_NA_complex_] = ACTIONS(7567),
    [anon_sym_NA_character_] = ACTIONS(7567),
    [sym_dots] = ACTIONS(7567),
    [sym_dot_dot_i] = ACTIONS(7565),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7565),
    [sym__semicolon] = ACTIONS(7565),
    [sym__raw_string_literal] = ACTIONS(7565),
    [sym__external_else] = ACTIONS(7565),
    [sym__external_open_parenthesis] = ACTIONS(7565),
    [sym__external_close_parenthesis] = ACTIONS(7565),
    [sym__external_open_brace] = ACTIONS(7565),
    [sym__external_open_bracket] = ACTIONS(7565),
    [sym__external_open_bracket2] = ACTIONS(7565),
  },
  [2744] = {
    [sym_identifier] = ACTIONS(7129),
    [anon_sym_BSLASH] = ACTIONS(7131),
    [anon_sym_function] = ACTIONS(7129),
    [anon_sym_EQ] = ACTIONS(7129),
    [anon_sym_if] = ACTIONS(7129),
    [anon_sym_for] = ACTIONS(7129),
    [anon_sym_while] = ACTIONS(7129),
    [anon_sym_repeat] = ACTIONS(7129),
    [anon_sym_QMARK] = ACTIONS(7131),
    [anon_sym_TILDE] = ACTIONS(7131),
    [anon_sym_BANG] = ACTIONS(7129),
    [anon_sym_PLUS] = ACTIONS(7131),
    [anon_sym_DASH] = ACTIONS(7129),
    [anon_sym_LT_DASH] = ACTIONS(7131),
    [anon_sym_LT_LT_DASH] = ACTIONS(7131),
    [anon_sym_COLON_EQ] = ACTIONS(7131),
    [anon_sym_DASH_GT] = ACTIONS(7129),
    [anon_sym_DASH_GT_GT] = ACTIONS(7131),
    [anon_sym_PIPE] = ACTIONS(7129),
    [anon_sym_AMP] = ACTIONS(7129),
    [anon_sym_PIPE_PIPE] = ACTIONS(7131),
    [anon_sym_AMP_AMP] = ACTIONS(7131),
    [anon_sym_LT] = ACTIONS(7129),
    [anon_sym_LT_EQ] = ACTIONS(7131),
    [anon_sym_GT] = ACTIONS(7129),
    [anon_sym_GT_EQ] = ACTIONS(7131),
    [anon_sym_EQ_EQ] = ACTIONS(7131),
    [anon_sym_BANG_EQ] = ACTIONS(7131),
    [anon_sym_STAR] = ACTIONS(7129),
    [anon_sym_SLASH] = ACTIONS(7131),
    [anon_sym_STAR_STAR] = ACTIONS(7131),
    [anon_sym_CARET] = ACTIONS(7131),
    [aux_sym_binary_operator_token1] = ACTIONS(7131),
    [anon_sym_PIPE_GT] = ACTIONS(7131),
    [anon_sym_COLON] = ACTIONS(7129),
    [anon_sym_DOLLAR] = ACTIONS(7131),
    [anon_sym_AT] = ACTIONS(7131),
    [anon_sym_COLON_COLON] = ACTIONS(7133),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7135),
    [aux_sym__hex_literal_token1] = ACTIONS(7131),
    [sym__number_literal] = ACTIONS(7129),
    [anon_sym_SQUOTE] = ACTIONS(7131),
    [anon_sym_DQUOTE] = ACTIONS(7131),
    [sym_return] = ACTIONS(7129),
    [sym_next] = ACTIONS(7129),
    [sym_break] = ACTIONS(7129),
    [sym_true] = ACTIONS(7129),
    [sym_false] = ACTIONS(7129),
    [sym_null] = ACTIONS(7129),
    [sym_inf] = ACTIONS(7129),
    [sym_nan] = ACTIONS(7129),
    [anon_sym_NA] = ACTIONS(7129),
    [anon_sym_NA_integer_] = ACTIONS(7129),
    [anon_sym_NA_real_] = ACTIONS(7129),
    [anon_sym_NA_complex_] = ACTIONS(7129),
    [anon_sym_NA_character_] = ACTIONS(7129),
    [sym_dots] = ACTIONS(7129),
    [sym_dot_dot_i] = ACTIONS(7131),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7131),
    [sym__newline] = ACTIONS(7131),
    [sym__raw_string_literal] = ACTIONS(7131),
    [sym__external_open_parenthesis] = ACTIONS(7131),
    [sym__external_open_brace] = ACTIONS(7131),
    [sym__external_open_bracket] = ACTIONS(7131),
    [sym__external_open_bracket2] = ACTIONS(7131),
    [sym__external_close_bracket2] = ACTIONS(7131),
  },
  [2745] = {
    [sym_identifier] = ACTIONS(7115),
    [anon_sym_BSLASH] = ACTIONS(7117),
    [anon_sym_function] = ACTIONS(7115),
    [anon_sym_EQ] = ACTIONS(7115),
    [anon_sym_if] = ACTIONS(7115),
    [anon_sym_for] = ACTIONS(7115),
    [anon_sym_while] = ACTIONS(7115),
    [anon_sym_repeat] = ACTIONS(7115),
    [anon_sym_QMARK] = ACTIONS(7117),
    [anon_sym_TILDE] = ACTIONS(7117),
    [anon_sym_BANG] = ACTIONS(7115),
    [anon_sym_PLUS] = ACTIONS(7117),
    [anon_sym_DASH] = ACTIONS(7115),
    [anon_sym_LT_DASH] = ACTIONS(7117),
    [anon_sym_LT_LT_DASH] = ACTIONS(7117),
    [anon_sym_COLON_EQ] = ACTIONS(7117),
    [anon_sym_DASH_GT] = ACTIONS(7115),
    [anon_sym_DASH_GT_GT] = ACTIONS(7117),
    [anon_sym_PIPE] = ACTIONS(7115),
    [anon_sym_AMP] = ACTIONS(7115),
    [anon_sym_PIPE_PIPE] = ACTIONS(7117),
    [anon_sym_AMP_AMP] = ACTIONS(7117),
    [anon_sym_LT] = ACTIONS(7115),
    [anon_sym_LT_EQ] = ACTIONS(7117),
    [anon_sym_GT] = ACTIONS(7115),
    [anon_sym_GT_EQ] = ACTIONS(7117),
    [anon_sym_EQ_EQ] = ACTIONS(7117),
    [anon_sym_BANG_EQ] = ACTIONS(7117),
    [anon_sym_STAR] = ACTIONS(7115),
    [anon_sym_SLASH] = ACTIONS(7117),
    [anon_sym_STAR_STAR] = ACTIONS(7117),
    [anon_sym_CARET] = ACTIONS(7117),
    [aux_sym_binary_operator_token1] = ACTIONS(7117),
    [anon_sym_PIPE_GT] = ACTIONS(7117),
    [anon_sym_COLON] = ACTIONS(7115),
    [anon_sym_DOLLAR] = ACTIONS(7117),
    [anon_sym_AT] = ACTIONS(7117),
    [anon_sym_COLON_COLON] = ACTIONS(7115),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(7117),
    [aux_sym__hex_literal_token1] = ACTIONS(7117),
    [sym__number_literal] = ACTIONS(7115),
    [anon_sym_SQUOTE] = ACTIONS(7117),
    [anon_sym_DQUOTE] = ACTIONS(7117),
    [sym_return] = ACTIONS(7115),
    [sym_next] = ACTIONS(7115),
    [sym_break] = ACTIONS(7115),
    [sym_true] = ACTIONS(7115),
    [sym_false] = ACTIONS(7115),
    [sym_null] = ACTIONS(7115),
    [sym_inf] = ACTIONS(7115),
    [sym_nan] = ACTIONS(7115),
    [anon_sym_NA] = ACTIONS(7115),
    [anon_sym_NA_integer_] = ACTIONS(7115),
    [anon_sym_NA_real_] = ACTIONS(7115),
    [anon_sym_NA_complex_] = ACTIONS(7115),
    [anon_sym_NA_character_] = ACTIONS(7115),
    [sym_dots] = ACTIONS(7115),
    [sym_dot_dot_i] = ACTIONS(7117),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7117),
    [sym__newline] = ACTIONS(7117),
    [sym__raw_string_literal] = ACTIONS(7117),
    [sym__external_open_parenthesis] = ACTIONS(7117),
    [sym__external_open_brace] = ACTIONS(7117),
    [sym__external_open_bracket] = ACTIONS(7117),
    [sym__external_close_bracket] = ACTIONS(7117),
    [sym__external_open_bracket2] = ACTIONS(7117),
  },
  [2746] = {
    [sym_identifier] = ACTIONS(7506),
    [anon_sym_BSLASH] = ACTIONS(7504),
    [anon_sym_function] = ACTIONS(7506),
    [anon_sym_EQ] = ACTIONS(7506),
    [anon_sym_if] = ACTIONS(7506),
    [anon_sym_for] = ACTIONS(7506),
    [anon_sym_while] = ACTIONS(7506),
    [anon_sym_repeat] = ACTIONS(7506),
    [anon_sym_QMARK] = ACTIONS(7504),
    [anon_sym_TILDE] = ACTIONS(7504),
    [anon_sym_BANG] = ACTIONS(7506),
    [anon_sym_PLUS] = ACTIONS(7504),
    [anon_sym_DASH] = ACTIONS(7506),
    [anon_sym_LT_DASH] = ACTIONS(7504),
    [anon_sym_LT_LT_DASH] = ACTIONS(7504),
    [anon_sym_COLON_EQ] = ACTIONS(7504),
    [anon_sym_DASH_GT] = ACTIONS(7506),
    [anon_sym_DASH_GT_GT] = ACTIONS(7504),
    [anon_sym_PIPE] = ACTIONS(7506),
    [anon_sym_AMP] = ACTIONS(7506),
    [anon_sym_PIPE_PIPE] = ACTIONS(7504),
    [anon_sym_AMP_AMP] = ACTIONS(7504),
    [anon_sym_LT] = ACTIONS(7506),
    [anon_sym_LT_EQ] = ACTIONS(7504),
    [anon_sym_GT] = ACTIONS(7506),
    [anon_sym_GT_EQ] = ACTIONS(7504),
    [anon_sym_EQ_EQ] = ACTIONS(7504),
    [anon_sym_BANG_EQ] = ACTIONS(7504),
    [anon_sym_STAR] = ACTIONS(7506),
    [anon_sym_SLASH] = ACTIONS(7504),
    [anon_sym_STAR_STAR] = ACTIONS(7504),
    [anon_sym_CARET] = ACTIONS(7504),
    [aux_sym_binary_operator_token1] = ACTIONS(7504),
    [anon_sym_PIPE_GT] = ACTIONS(7504),
    [anon_sym_COLON] = ACTIONS(7506),
    [anon_sym_DOLLAR] = ACTIONS(7504),
    [anon_sym_AT] = ACTIONS(7504),
    [aux_sym__hex_literal_token1] = ACTIONS(7504),
    [sym__number_literal] = ACTIONS(7506),
    [anon_sym_SQUOTE] = ACTIONS(7504),
    [anon_sym_DQUOTE] = ACTIONS(7504),
    [sym_return] = ACTIONS(7506),
    [sym_next] = ACTIONS(7506),
    [sym_break] = ACTIONS(7506),
    [sym_true] = ACTIONS(7506),
    [sym_false] = ACTIONS(7506),
    [sym_null] = ACTIONS(7506),
    [sym_inf] = ACTIONS(7506),
    [sym_nan] = ACTIONS(7506),
    [anon_sym_NA] = ACTIONS(7506),
    [anon_sym_NA_integer_] = ACTIONS(7506),
    [anon_sym_NA_real_] = ACTIONS(7506),
    [anon_sym_NA_complex_] = ACTIONS(7506),
    [anon_sym_NA_character_] = ACTIONS(7506),
    [sym_dots] = ACTIONS(7506),
    [sym_dot_dot_i] = ACTIONS(7504),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7504),
    [sym__newline] = ACTIONS(7504),
    [sym__raw_string_literal] = ACTIONS(7504),
    [sym__external_open_parenthesis] = ACTIONS(7504),
    [sym__external_close_parenthesis] = ACTIONS(7504),
    [sym__external_open_brace] = ACTIONS(7504),
    [sym__external_open_bracket] = ACTIONS(7504),
    [sym__external_close_bracket] = ACTIONS(7504),
    [sym__external_open_bracket2] = ACTIONS(7504),
  },
  [2747] = {
    [sym_identifier] = ACTIONS(7464),
    [anon_sym_BSLASH] = ACTIONS(7466),
    [anon_sym_function] = ACTIONS(7464),
    [anon_sym_EQ] = ACTIONS(7464),
    [anon_sym_if] = ACTIONS(7464),
    [anon_sym_for] = ACTIONS(7464),
    [anon_sym_while] = ACTIONS(7464),
    [anon_sym_repeat] = ACTIONS(7464),
    [anon_sym_QMARK] = ACTIONS(7466),
    [anon_sym_TILDE] = ACTIONS(7466),
    [anon_sym_BANG] = ACTIONS(7464),
    [anon_sym_PLUS] = ACTIONS(7466),
    [anon_sym_DASH] = ACTIONS(7464),
    [anon_sym_LT_DASH] = ACTIONS(7466),
    [anon_sym_LT_LT_DASH] = ACTIONS(7466),
    [anon_sym_COLON_EQ] = ACTIONS(7466),
    [anon_sym_DASH_GT] = ACTIONS(7464),
    [anon_sym_DASH_GT_GT] = ACTIONS(7466),
    [anon_sym_PIPE] = ACTIONS(7464),
    [anon_sym_AMP] = ACTIONS(7464),
    [anon_sym_PIPE_PIPE] = ACTIONS(7466),
    [anon_sym_AMP_AMP] = ACTIONS(7466),
    [anon_sym_LT] = ACTIONS(7464),
    [anon_sym_LT_EQ] = ACTIONS(7466),
    [anon_sym_GT] = ACTIONS(7464),
    [anon_sym_GT_EQ] = ACTIONS(7466),
    [anon_sym_EQ_EQ] = ACTIONS(7466),
    [anon_sym_BANG_EQ] = ACTIONS(7466),
    [anon_sym_STAR] = ACTIONS(7464),
    [anon_sym_SLASH] = ACTIONS(7466),
    [anon_sym_STAR_STAR] = ACTIONS(7466),
    [anon_sym_CARET] = ACTIONS(7466),
    [aux_sym_binary_operator_token1] = ACTIONS(7466),
    [anon_sym_PIPE_GT] = ACTIONS(7466),
    [anon_sym_COLON] = ACTIONS(7464),
    [anon_sym_DOLLAR] = ACTIONS(7466),
    [anon_sym_AT] = ACTIONS(7466),
    [aux_sym__hex_literal_token1] = ACTIONS(7466),
    [sym__number_literal] = ACTIONS(7464),
    [anon_sym_SQUOTE] = ACTIONS(7466),
    [anon_sym_DQUOTE] = ACTIONS(7466),
    [sym_return] = ACTIONS(7464),
    [sym_next] = ACTIONS(7464),
    [sym_break] = ACTIONS(7464),
    [sym_true] = ACTIONS(7464),
    [sym_false] = ACTIONS(7464),
    [sym_null] = ACTIONS(7464),
    [sym_inf] = ACTIONS(7464),
    [sym_nan] = ACTIONS(7464),
    [anon_sym_NA] = ACTIONS(7464),
    [anon_sym_NA_integer_] = ACTIONS(7464),
    [anon_sym_NA_real_] = ACTIONS(7464),
    [anon_sym_NA_complex_] = ACTIONS(7464),
    [anon_sym_NA_character_] = ACTIONS(7464),
    [sym_dots] = ACTIONS(7464),
    [sym_dot_dot_i] = ACTIONS(7466),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7466),
    [sym__newline] = ACTIONS(7466),
    [sym__raw_string_literal] = ACTIONS(7466),
    [sym__external_else] = ACTIONS(7466),
    [sym__external_open_parenthesis] = ACTIONS(7466),
    [sym__external_close_parenthesis] = ACTIONS(7466),
    [sym__external_open_brace] = ACTIONS(7466),
    [sym__external_open_bracket] = ACTIONS(7466),
    [sym__external_open_bracket2] = ACTIONS(7466),
  },
  [2748] = {
    [ts_builtin_sym_end] = ACTIONS(7542),
    [sym_identifier] = ACTIONS(7544),
    [anon_sym_BSLASH] = ACTIONS(7542),
    [anon_sym_function] = ACTIONS(7544),
    [anon_sym_EQ] = ACTIONS(7544),
    [anon_sym_if] = ACTIONS(7544),
    [anon_sym_for] = ACTIONS(7544),
    [anon_sym_while] = ACTIONS(7544),
    [anon_sym_repeat] = ACTIONS(7544),
    [anon_sym_QMARK] = ACTIONS(7542),
    [anon_sym_TILDE] = ACTIONS(7542),
    [anon_sym_BANG] = ACTIONS(7544),
    [anon_sym_PLUS] = ACTIONS(7542),
    [anon_sym_DASH] = ACTIONS(7544),
    [anon_sym_LT_DASH] = ACTIONS(7542),
    [anon_sym_LT_LT_DASH] = ACTIONS(7542),
    [anon_sym_COLON_EQ] = ACTIONS(7542),
    [anon_sym_DASH_GT] = ACTIONS(7544),
    [anon_sym_DASH_GT_GT] = ACTIONS(7542),
    [anon_sym_PIPE] = ACTIONS(7544),
    [anon_sym_AMP] = ACTIONS(7544),
    [anon_sym_PIPE_PIPE] = ACTIONS(7542),
    [anon_sym_AMP_AMP] = ACTIONS(7542),
    [anon_sym_LT] = ACTIONS(7544),
    [anon_sym_LT_EQ] = ACTIONS(7542),
    [anon_sym_GT] = ACTIONS(7544),
    [anon_sym_GT_EQ] = ACTIONS(7542),
    [anon_sym_EQ_EQ] = ACTIONS(7542),
    [anon_sym_BANG_EQ] = ACTIONS(7542),
    [anon_sym_STAR] = ACTIONS(7544),
    [anon_sym_SLASH] = ACTIONS(7542),
    [anon_sym_STAR_STAR] = ACTIONS(7542),
    [anon_sym_CARET] = ACTIONS(7542),
    [aux_sym_binary_operator_token1] = ACTIONS(7542),
    [anon_sym_PIPE_GT] = ACTIONS(7542),
    [anon_sym_COLON] = ACTIONS(7544),
    [anon_sym_DOLLAR] = ACTIONS(7542),
    [anon_sym_AT] = ACTIONS(7542),
    [aux_sym__hex_literal_token1] = ACTIONS(7542),
    [sym__number_literal] = ACTIONS(7544),
    [anon_sym_SQUOTE] = ACTIONS(7542),
    [anon_sym_DQUOTE] = ACTIONS(7542),
    [sym_return] = ACTIONS(7544),
    [sym_next] = ACTIONS(7544),
    [sym_break] = ACTIONS(7544),
    [sym_true] = ACTIONS(7544),
    [sym_false] = ACTIONS(7544),
    [sym_null] = ACTIONS(7544),
    [sym_inf] = ACTIONS(7544),
    [sym_nan] = ACTIONS(7544),
    [anon_sym_NA] = ACTIONS(7544),
    [anon_sym_NA_integer_] = ACTIONS(7544),
    [anon_sym_NA_real_] = ACTIONS(7544),
    [anon_sym_NA_complex_] = ACTIONS(7544),
    [anon_sym_NA_character_] = ACTIONS(7544),
    [sym_dots] = ACTIONS(7544),
    [sym_dot_dot_i] = ACTIONS(7542),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7542),
    [sym__semicolon] = ACTIONS(7542),
    [sym__raw_string_literal] = ACTIONS(7542),
    [sym__external_open_parenthesis] = ACTIONS(7542),
    [sym__external_close_parenthesis] = ACTIONS(7542),
    [sym__external_open_brace] = ACTIONS(7542),
    [sym__external_open_bracket] = ACTIONS(7542),
    [sym__external_open_bracket2] = ACTIONS(7542),
  },
  [2749] = {
    [sym_identifier] = ACTIONS(7494),
    [anon_sym_BSLASH] = ACTIONS(7492),
    [anon_sym_function] = ACTIONS(7494),
    [anon_sym_EQ] = ACTIONS(7494),
    [anon_sym_if] = ACTIONS(7494),
    [anon_sym_for] = ACTIONS(7494),
    [anon_sym_while] = ACTIONS(7494),
    [anon_sym_repeat] = ACTIONS(7494),
    [anon_sym_QMARK] = ACTIONS(7492),
    [anon_sym_TILDE] = ACTIONS(7492),
    [anon_sym_BANG] = ACTIONS(7494),
    [anon_sym_PLUS] = ACTIONS(7492),
    [anon_sym_DASH] = ACTIONS(7494),
    [anon_sym_LT_DASH] = ACTIONS(7492),
    [anon_sym_LT_LT_DASH] = ACTIONS(7492),
    [anon_sym_COLON_EQ] = ACTIONS(7492),
    [anon_sym_DASH_GT] = ACTIONS(7494),
    [anon_sym_DASH_GT_GT] = ACTIONS(7492),
    [anon_sym_PIPE] = ACTIONS(7494),
    [anon_sym_AMP] = ACTIONS(7494),
    [anon_sym_PIPE_PIPE] = ACTIONS(7492),
    [anon_sym_AMP_AMP] = ACTIONS(7492),
    [anon_sym_LT] = ACTIONS(7494),
    [anon_sym_LT_EQ] = ACTIONS(7492),
    [anon_sym_GT] = ACTIONS(7494),
    [anon_sym_GT_EQ] = ACTIONS(7492),
    [anon_sym_EQ_EQ] = ACTIONS(7492),
    [anon_sym_BANG_EQ] = ACTIONS(7492),
    [anon_sym_STAR] = ACTIONS(7494),
    [anon_sym_SLASH] = ACTIONS(7492),
    [anon_sym_STAR_STAR] = ACTIONS(7492),
    [anon_sym_CARET] = ACTIONS(7492),
    [aux_sym_binary_operator_token1] = ACTIONS(7492),
    [anon_sym_PIPE_GT] = ACTIONS(7492),
    [anon_sym_COLON] = ACTIONS(7494),
    [anon_sym_DOLLAR] = ACTIONS(7492),
    [anon_sym_AT] = ACTIONS(7492),
    [aux_sym__hex_literal_token1] = ACTIONS(7492),
    [sym__number_literal] = ACTIONS(7494),
    [anon_sym_SQUOTE] = ACTIONS(7492),
    [anon_sym_DQUOTE] = ACTIONS(7492),
    [sym_return] = ACTIONS(7494),
    [sym_next] = ACTIONS(7494),
    [sym_break] = ACTIONS(7494),
    [sym_true] = ACTIONS(7494),
    [sym_false] = ACTIONS(7494),
    [sym_null] = ACTIONS(7494),
    [sym_inf] = ACTIONS(7494),
    [sym_nan] = ACTIONS(7494),
    [anon_sym_NA] = ACTIONS(7494),
    [anon_sym_NA_integer_] = ACTIONS(7494),
    [anon_sym_NA_real_] = ACTIONS(7494),
    [anon_sym_NA_complex_] = ACTIONS(7494),
    [anon_sym_NA_character_] = ACTIONS(7494),
    [sym_dots] = ACTIONS(7494),
    [sym_dot_dot_i] = ACTIONS(7492),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7492),
    [sym__newline] = ACTIONS(7492),
    [sym__raw_string_literal] = ACTIONS(7492),
    [sym__external_open_parenthesis] = ACTIONS(7492),
    [sym__external_close_parenthesis] = ACTIONS(7492),
    [sym__external_open_brace] = ACTIONS(7492),
    [sym__external_open_bracket] = ACTIONS(7492),
    [sym__external_open_bracket2] = ACTIONS(7492),
    [sym__external_close_bracket2] = ACTIONS(7492),
  },
  [2750] = {
    [ts_builtin_sym_end] = ACTIONS(7538),
    [sym_identifier] = ACTIONS(7540),
    [anon_sym_BSLASH] = ACTIONS(7538),
    [anon_sym_function] = ACTIONS(7540),
    [anon_sym_EQ] = ACTIONS(7540),
    [anon_sym_if] = ACTIONS(7540),
    [anon_sym_for] = ACTIONS(7540),
    [anon_sym_while] = ACTIONS(7540),
    [anon_sym_repeat] = ACTIONS(7540),
    [anon_sym_QMARK] = ACTIONS(7538),
    [anon_sym_TILDE] = ACTIONS(7538),
    [anon_sym_BANG] = ACTIONS(7540),
    [anon_sym_PLUS] = ACTIONS(7538),
    [anon_sym_DASH] = ACTIONS(7540),
    [anon_sym_LT_DASH] = ACTIONS(7538),
    [anon_sym_LT_LT_DASH] = ACTIONS(7538),
    [anon_sym_COLON_EQ] = ACTIONS(7538),
    [anon_sym_DASH_GT] = ACTIONS(7540),
    [anon_sym_DASH_GT_GT] = ACTIONS(7538),
    [anon_sym_PIPE] = ACTIONS(7540),
    [anon_sym_AMP] = ACTIONS(7540),
    [anon_sym_PIPE_PIPE] = ACTIONS(7538),
    [anon_sym_AMP_AMP] = ACTIONS(7538),
    [anon_sym_LT] = ACTIONS(7540),
    [anon_sym_LT_EQ] = ACTIONS(7538),
    [anon_sym_GT] = ACTIONS(7540),
    [anon_sym_GT_EQ] = ACTIONS(7538),
    [anon_sym_EQ_EQ] = ACTIONS(7538),
    [anon_sym_BANG_EQ] = ACTIONS(7538),
    [anon_sym_STAR] = ACTIONS(7540),
    [anon_sym_SLASH] = ACTIONS(7538),
    [anon_sym_STAR_STAR] = ACTIONS(7538),
    [anon_sym_CARET] = ACTIONS(7538),
    [aux_sym_binary_operator_token1] = ACTIONS(7538),
    [anon_sym_PIPE_GT] = ACTIONS(7538),
    [anon_sym_COLON] = ACTIONS(7540),
    [anon_sym_DOLLAR] = ACTIONS(7538),
    [anon_sym_AT] = ACTIONS(7538),
    [aux_sym__hex_literal_token1] = ACTIONS(7538),
    [sym__number_literal] = ACTIONS(7540),
    [anon_sym_SQUOTE] = ACTIONS(7538),
    [anon_sym_DQUOTE] = ACTIONS(7538),
    [sym_return] = ACTIONS(7540),
    [sym_next] = ACTIONS(7540),
    [sym_break] = ACTIONS(7540),
    [sym_true] = ACTIONS(7540),
    [sym_false] = ACTIONS(7540),
    [sym_null] = ACTIONS(7540),
    [sym_inf] = ACTIONS(7540),
    [sym_nan] = ACTIONS(7540),
    [anon_sym_NA] = ACTIONS(7540),
    [anon_sym_NA_integer_] = ACTIONS(7540),
    [anon_sym_NA_real_] = ACTIONS(7540),
    [anon_sym_NA_complex_] = ACTIONS(7540),
    [anon_sym_NA_character_] = ACTIONS(7540),
    [sym_dots] = ACTIONS(7540),
    [sym_dot_dot_i] = ACTIONS(7538),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7538),
    [sym__semicolon] = ACTIONS(7538),
    [sym__raw_string_literal] = ACTIONS(7538),
    [sym__external_open_parenthesis] = ACTIONS(7538),
    [sym__external_close_parenthesis] = ACTIONS(7538),
    [sym__external_open_brace] = ACTIONS(7538),
    [sym__external_open_bracket] = ACTIONS(7538),
    [sym__external_open_bracket2] = ACTIONS(7538),
  },
  [2751] = {
    [ts_builtin_sym_end] = ACTIONS(7472),
    [sym_identifier] = ACTIONS(7474),
    [anon_sym_BSLASH] = ACTIONS(7472),
    [anon_sym_function] = ACTIONS(7474),
    [anon_sym_EQ] = ACTIONS(7474),
    [anon_sym_if] = ACTIONS(7474),
    [anon_sym_for] = ACTIONS(7474),
    [anon_sym_while] = ACTIONS(7474),
    [anon_sym_repeat] = ACTIONS(7474),
    [anon_sym_QMARK] = ACTIONS(7472),
    [anon_sym_TILDE] = ACTIONS(7472),
    [anon_sym_BANG] = ACTIONS(7474),
    [anon_sym_PLUS] = ACTIONS(7472),
    [anon_sym_DASH] = ACTIONS(7474),
    [anon_sym_LT_DASH] = ACTIONS(7472),
    [anon_sym_LT_LT_DASH] = ACTIONS(7472),
    [anon_sym_COLON_EQ] = ACTIONS(7472),
    [anon_sym_DASH_GT] = ACTIONS(7474),
    [anon_sym_DASH_GT_GT] = ACTIONS(7472),
    [anon_sym_PIPE] = ACTIONS(7474),
    [anon_sym_AMP] = ACTIONS(7474),
    [anon_sym_PIPE_PIPE] = ACTIONS(7472),
    [anon_sym_AMP_AMP] = ACTIONS(7472),
    [anon_sym_LT] = ACTIONS(7474),
    [anon_sym_LT_EQ] = ACTIONS(7472),
    [anon_sym_GT] = ACTIONS(7474),
    [anon_sym_GT_EQ] = ACTIONS(7472),
    [anon_sym_EQ_EQ] = ACTIONS(7472),
    [anon_sym_BANG_EQ] = ACTIONS(7472),
    [anon_sym_STAR] = ACTIONS(7474),
    [anon_sym_SLASH] = ACTIONS(7472),
    [anon_sym_STAR_STAR] = ACTIONS(7472),
    [anon_sym_CARET] = ACTIONS(7472),
    [aux_sym_binary_operator_token1] = ACTIONS(7472),
    [anon_sym_PIPE_GT] = ACTIONS(7472),
    [anon_sym_COLON] = ACTIONS(7474),
    [anon_sym_DOLLAR] = ACTIONS(7472),
    [anon_sym_AT] = ACTIONS(7472),
    [aux_sym__hex_literal_token1] = ACTIONS(7472),
    [sym__number_literal] = ACTIONS(7474),
    [anon_sym_SQUOTE] = ACTIONS(7472),
    [anon_sym_DQUOTE] = ACTIONS(7472),
    [sym_return] = ACTIONS(7474),
    [sym_next] = ACTIONS(7474),
    [sym_break] = ACTIONS(7474),
    [sym_true] = ACTIONS(7474),
    [sym_false] = ACTIONS(7474),
    [sym_null] = ACTIONS(7474),
    [sym_inf] = ACTIONS(7474),
    [sym_nan] = ACTIONS(7474),
    [anon_sym_NA] = ACTIONS(7474),
    [anon_sym_NA_integer_] = ACTIONS(7474),
    [anon_sym_NA_real_] = ACTIONS(7474),
    [anon_sym_NA_complex_] = ACTIONS(7474),
    [anon_sym_NA_character_] = ACTIONS(7474),
    [sym_dots] = ACTIONS(7474),
    [sym_dot_dot_i] = ACTIONS(7472),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7472),
    [sym__semicolon] = ACTIONS(7472),
    [sym__raw_string_literal] = ACTIONS(7472),
    [sym__external_else] = ACTIONS(7472),
    [sym__external_open_parenthesis] = ACTIONS(7472),
    [sym__external_open_brace] = ACTIONS(7472),
    [sym__external_open_bracket] = ACTIONS(7472),
    [sym__external_open_bracket2] = ACTIONS(7472),
  },
  [2752] = {
    [sym_identifier] = ACTIONS(7502),
    [anon_sym_BSLASH] = ACTIONS(7500),
    [anon_sym_function] = ACTIONS(7502),
    [anon_sym_EQ] = ACTIONS(7502),
    [anon_sym_if] = ACTIONS(7502),
    [anon_sym_for] = ACTIONS(7502),
    [anon_sym_while] = ACTIONS(7502),
    [anon_sym_repeat] = ACTIONS(7502),
    [anon_sym_QMARK] = ACTIONS(7500),
    [anon_sym_TILDE] = ACTIONS(7500),
    [anon_sym_BANG] = ACTIONS(7502),
    [anon_sym_PLUS] = ACTIONS(7500),
    [anon_sym_DASH] = ACTIONS(7502),
    [anon_sym_LT_DASH] = ACTIONS(7500),
    [anon_sym_LT_LT_DASH] = ACTIONS(7500),
    [anon_sym_COLON_EQ] = ACTIONS(7500),
    [anon_sym_DASH_GT] = ACTIONS(7502),
    [anon_sym_DASH_GT_GT] = ACTIONS(7500),
    [anon_sym_PIPE] = ACTIONS(7502),
    [anon_sym_AMP] = ACTIONS(7502),
    [anon_sym_PIPE_PIPE] = ACTIONS(7500),
    [anon_sym_AMP_AMP] = ACTIONS(7500),
    [anon_sym_LT] = ACTIONS(7502),
    [anon_sym_LT_EQ] = ACTIONS(7500),
    [anon_sym_GT] = ACTIONS(7502),
    [anon_sym_GT_EQ] = ACTIONS(7500),
    [anon_sym_EQ_EQ] = ACTIONS(7500),
    [anon_sym_BANG_EQ] = ACTIONS(7500),
    [anon_sym_STAR] = ACTIONS(7502),
    [anon_sym_SLASH] = ACTIONS(7500),
    [anon_sym_STAR_STAR] = ACTIONS(7500),
    [anon_sym_CARET] = ACTIONS(7500),
    [aux_sym_binary_operator_token1] = ACTIONS(7500),
    [anon_sym_PIPE_GT] = ACTIONS(7500),
    [anon_sym_COLON] = ACTIONS(7502),
    [anon_sym_DOLLAR] = ACTIONS(7500),
    [anon_sym_AT] = ACTIONS(7500),
    [aux_sym__hex_literal_token1] = ACTIONS(7500),
    [sym__number_literal] = ACTIONS(7502),
    [anon_sym_SQUOTE] = ACTIONS(7500),
    [anon_sym_DQUOTE] = ACTIONS(7500),
    [sym_return] = ACTIONS(7502),
    [sym_next] = ACTIONS(7502),
    [sym_break] = ACTIONS(7502),
    [sym_true] = ACTIONS(7502),
    [sym_false] = ACTIONS(7502),
    [sym_null] = ACTIONS(7502),
    [sym_inf] = ACTIONS(7502),
    [sym_nan] = ACTIONS(7502),
    [anon_sym_NA] = ACTIONS(7502),
    [anon_sym_NA_integer_] = ACTIONS(7502),
    [anon_sym_NA_real_] = ACTIONS(7502),
    [anon_sym_NA_complex_] = ACTIONS(7502),
    [anon_sym_NA_character_] = ACTIONS(7502),
    [sym_dots] = ACTIONS(7502),
    [sym_dot_dot_i] = ACTIONS(7500),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7500),
    [sym__newline] = ACTIONS(7500),
    [sym__raw_string_literal] = ACTIONS(7500),
    [sym__external_open_parenthesis] = ACTIONS(7500),
    [sym__external_close_parenthesis] = ACTIONS(7500),
    [sym__external_open_brace] = ACTIONS(7500),
    [sym__external_open_bracket] = ACTIONS(7500),
    [sym__external_close_bracket] = ACTIONS(7500),
    [sym__external_open_bracket2] = ACTIONS(7500),
  },
  [2753] = {
    [sym_identifier] = ACTIONS(7498),
    [anon_sym_BSLASH] = ACTIONS(7496),
    [anon_sym_function] = ACTIONS(7498),
    [anon_sym_EQ] = ACTIONS(7498),
    [anon_sym_if] = ACTIONS(7498),
    [anon_sym_for] = ACTIONS(7498),
    [anon_sym_while] = ACTIONS(7498),
    [anon_sym_repeat] = ACTIONS(7498),
    [anon_sym_QMARK] = ACTIONS(7496),
    [anon_sym_TILDE] = ACTIONS(7496),
    [anon_sym_BANG] = ACTIONS(7498),
    [anon_sym_PLUS] = ACTIONS(7496),
    [anon_sym_DASH] = ACTIONS(7498),
    [anon_sym_LT_DASH] = ACTIONS(7496),
    [anon_sym_LT_LT_DASH] = ACTIONS(7496),
    [anon_sym_COLON_EQ] = ACTIONS(7496),
    [anon_sym_DASH_GT] = ACTIONS(7498),
    [anon_sym_DASH_GT_GT] = ACTIONS(7496),
    [anon_sym_PIPE] = ACTIONS(7498),
    [anon_sym_AMP] = ACTIONS(7498),
    [anon_sym_PIPE_PIPE] = ACTIONS(7496),
    [anon_sym_AMP_AMP] = ACTIONS(7496),
    [anon_sym_LT] = ACTIONS(7498),
    [anon_sym_LT_EQ] = ACTIONS(7496),
    [anon_sym_GT] = ACTIONS(7498),
    [anon_sym_GT_EQ] = ACTIONS(7496),
    [anon_sym_EQ_EQ] = ACTIONS(7496),
    [anon_sym_BANG_EQ] = ACTIONS(7496),
    [anon_sym_STAR] = ACTIONS(7498),
    [anon_sym_SLASH] = ACTIONS(7496),
    [anon_sym_STAR_STAR] = ACTIONS(7496),
    [anon_sym_CARET] = ACTIONS(7496),
    [aux_sym_binary_operator_token1] = ACTIONS(7496),
    [anon_sym_PIPE_GT] = ACTIONS(7496),
    [anon_sym_COLON] = ACTIONS(7498),
    [anon_sym_DOLLAR] = ACTIONS(7496),
    [anon_sym_AT] = ACTIONS(7496),
    [aux_sym__hex_literal_token1] = ACTIONS(7496),
    [sym__number_literal] = ACTIONS(7498),
    [anon_sym_SQUOTE] = ACTIONS(7496),
    [anon_sym_DQUOTE] = ACTIONS(7496),
    [sym_return] = ACTIONS(7498),
    [sym_next] = ACTIONS(7498),
    [sym_break] = ACTIONS(7498),
    [sym_true] = ACTIONS(7498),
    [sym_false] = ACTIONS(7498),
    [sym_null] = ACTIONS(7498),
    [sym_inf] = ACTIONS(7498),
    [sym_nan] = ACTIONS(7498),
    [anon_sym_NA] = ACTIONS(7498),
    [anon_sym_NA_integer_] = ACTIONS(7498),
    [anon_sym_NA_real_] = ACTIONS(7498),
    [anon_sym_NA_complex_] = ACTIONS(7498),
    [anon_sym_NA_character_] = ACTIONS(7498),
    [sym_dots] = ACTIONS(7498),
    [sym_dot_dot_i] = ACTIONS(7496),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7496),
    [sym__newline] = ACTIONS(7496),
    [sym__raw_string_literal] = ACTIONS(7496),
    [sym__external_open_parenthesis] = ACTIONS(7496),
    [sym__external_close_parenthesis] = ACTIONS(7496),
    [sym__external_open_brace] = ACTIONS(7496),
    [sym__external_open_bracket] = ACTIONS(7496),
    [sym__external_close_bracket] = ACTIONS(7496),
    [sym__external_open_bracket2] = ACTIONS(7496),
  },
  [2754] = {
    [ts_builtin_sym_end] = ACTIONS(7466),
    [sym_identifier] = ACTIONS(7464),
    [anon_sym_BSLASH] = ACTIONS(7466),
    [anon_sym_function] = ACTIONS(7464),
    [anon_sym_EQ] = ACTIONS(7464),
    [anon_sym_if] = ACTIONS(7464),
    [anon_sym_for] = ACTIONS(7464),
    [anon_sym_while] = ACTIONS(7464),
    [anon_sym_repeat] = ACTIONS(7464),
    [anon_sym_QMARK] = ACTIONS(7466),
    [anon_sym_TILDE] = ACTIONS(7466),
    [anon_sym_BANG] = ACTIONS(7464),
    [anon_sym_PLUS] = ACTIONS(7466),
    [anon_sym_DASH] = ACTIONS(7464),
    [anon_sym_LT_DASH] = ACTIONS(7466),
    [anon_sym_LT_LT_DASH] = ACTIONS(7466),
    [anon_sym_COLON_EQ] = ACTIONS(7466),
    [anon_sym_DASH_GT] = ACTIONS(7464),
    [anon_sym_DASH_GT_GT] = ACTIONS(7466),
    [anon_sym_PIPE] = ACTIONS(7464),
    [anon_sym_AMP] = ACTIONS(7464),
    [anon_sym_PIPE_PIPE] = ACTIONS(7466),
    [anon_sym_AMP_AMP] = ACTIONS(7466),
    [anon_sym_LT] = ACTIONS(7464),
    [anon_sym_LT_EQ] = ACTIONS(7466),
    [anon_sym_GT] = ACTIONS(7464),
    [anon_sym_GT_EQ] = ACTIONS(7466),
    [anon_sym_EQ_EQ] = ACTIONS(7466),
    [anon_sym_BANG_EQ] = ACTIONS(7466),
    [anon_sym_STAR] = ACTIONS(7464),
    [anon_sym_SLASH] = ACTIONS(7466),
    [anon_sym_STAR_STAR] = ACTIONS(7466),
    [anon_sym_CARET] = ACTIONS(7466),
    [aux_sym_binary_operator_token1] = ACTIONS(7466),
    [anon_sym_PIPE_GT] = ACTIONS(7466),
    [anon_sym_COLON] = ACTIONS(7464),
    [anon_sym_DOLLAR] = ACTIONS(7466),
    [anon_sym_AT] = ACTIONS(7466),
    [aux_sym__hex_literal_token1] = ACTIONS(7466),
    [sym__number_literal] = ACTIONS(7464),
    [anon_sym_SQUOTE] = ACTIONS(7466),
    [anon_sym_DQUOTE] = ACTIONS(7466),
    [sym_return] = ACTIONS(7464),
    [sym_next] = ACTIONS(7464),
    [sym_break] = ACTIONS(7464),
    [sym_true] = ACTIONS(7464),
    [sym_false] = ACTIONS(7464),
    [sym_null] = ACTIONS(7464),
    [sym_inf] = ACTIONS(7464),
    [sym_nan] = ACTIONS(7464),
    [anon_sym_NA] = ACTIONS(7464),
    [anon_sym_NA_integer_] = ACTIONS(7464),
    [anon_sym_NA_real_] = ACTIONS(7464),
    [anon_sym_NA_complex_] = ACTIONS(7464),
    [anon_sym_NA_character_] = ACTIONS(7464),
    [sym_dots] = ACTIONS(7464),
    [sym_dot_dot_i] = ACTIONS(7466),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7466),
    [sym__semicolon] = ACTIONS(7466),
    [sym__raw_string_literal] = ACTIONS(7466),
    [sym__external_else] = ACTIONS(7466),
    [sym__external_open_parenthesis] = ACTIONS(7466),
    [sym__external_open_brace] = ACTIONS(7466),
    [sym__external_open_bracket] = ACTIONS(7466),
    [sym__external_open_bracket2] = ACTIONS(7466),
  },
  [2755] = {
    [sym_identifier] = ACTIONS(7494),
    [anon_sym_BSLASH] = ACTIONS(7492),
    [anon_sym_function] = ACTIONS(7494),
    [anon_sym_EQ] = ACTIONS(7494),
    [anon_sym_if] = ACTIONS(7494),
    [anon_sym_for] = ACTIONS(7494),
    [anon_sym_while] = ACTIONS(7494),
    [anon_sym_repeat] = ACTIONS(7494),
    [anon_sym_QMARK] = ACTIONS(7492),
    [anon_sym_TILDE] = ACTIONS(7492),
    [anon_sym_BANG] = ACTIONS(7494),
    [anon_sym_PLUS] = ACTIONS(7492),
    [anon_sym_DASH] = ACTIONS(7494),
    [anon_sym_LT_DASH] = ACTIONS(7492),
    [anon_sym_LT_LT_DASH] = ACTIONS(7492),
    [anon_sym_COLON_EQ] = ACTIONS(7492),
    [anon_sym_DASH_GT] = ACTIONS(7494),
    [anon_sym_DASH_GT_GT] = ACTIONS(7492),
    [anon_sym_PIPE] = ACTIONS(7494),
    [anon_sym_AMP] = ACTIONS(7494),
    [anon_sym_PIPE_PIPE] = ACTIONS(7492),
    [anon_sym_AMP_AMP] = ACTIONS(7492),
    [anon_sym_LT] = ACTIONS(7494),
    [anon_sym_LT_EQ] = ACTIONS(7492),
    [anon_sym_GT] = ACTIONS(7494),
    [anon_sym_GT_EQ] = ACTIONS(7492),
    [anon_sym_EQ_EQ] = ACTIONS(7492),
    [anon_sym_BANG_EQ] = ACTIONS(7492),
    [anon_sym_STAR] = ACTIONS(7494),
    [anon_sym_SLASH] = ACTIONS(7492),
    [anon_sym_STAR_STAR] = ACTIONS(7492),
    [anon_sym_CARET] = ACTIONS(7492),
    [aux_sym_binary_operator_token1] = ACTIONS(7492),
    [anon_sym_PIPE_GT] = ACTIONS(7492),
    [anon_sym_COLON] = ACTIONS(7494),
    [anon_sym_DOLLAR] = ACTIONS(7492),
    [anon_sym_AT] = ACTIONS(7492),
    [aux_sym__hex_literal_token1] = ACTIONS(7492),
    [sym__number_literal] = ACTIONS(7494),
    [anon_sym_SQUOTE] = ACTIONS(7492),
    [anon_sym_DQUOTE] = ACTIONS(7492),
    [sym_return] = ACTIONS(7494),
    [sym_next] = ACTIONS(7494),
    [sym_break] = ACTIONS(7494),
    [sym_true] = ACTIONS(7494),
    [sym_false] = ACTIONS(7494),
    [sym_null] = ACTIONS(7494),
    [sym_inf] = ACTIONS(7494),
    [sym_nan] = ACTIONS(7494),
    [anon_sym_NA] = ACTIONS(7494),
    [anon_sym_NA_integer_] = ACTIONS(7494),
    [anon_sym_NA_real_] = ACTIONS(7494),
    [anon_sym_NA_complex_] = ACTIONS(7494),
    [anon_sym_NA_character_] = ACTIONS(7494),
    [sym_dots] = ACTIONS(7494),
    [sym_dot_dot_i] = ACTIONS(7492),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7492),
    [sym__newline] = ACTIONS(7492),
    [sym__raw_string_literal] = ACTIONS(7492),
    [sym__external_open_parenthesis] = ACTIONS(7492),
    [sym__external_close_parenthesis] = ACTIONS(7492),
    [sym__external_open_brace] = ACTIONS(7492),
    [sym__external_open_bracket] = ACTIONS(7492),
    [sym__external_close_bracket] = ACTIONS(7492),
    [sym__external_open_bracket2] = ACTIONS(7492),
  },
  [2756] = {
    [sym_identifier] = ACTIONS(7490),
    [anon_sym_BSLASH] = ACTIONS(7488),
    [anon_sym_function] = ACTIONS(7490),
    [anon_sym_EQ] = ACTIONS(7490),
    [anon_sym_if] = ACTIONS(7490),
    [anon_sym_for] = ACTIONS(7490),
    [anon_sym_while] = ACTIONS(7490),
    [anon_sym_repeat] = ACTIONS(7490),
    [anon_sym_QMARK] = ACTIONS(7488),
    [anon_sym_TILDE] = ACTIONS(7488),
    [anon_sym_BANG] = ACTIONS(7490),
    [anon_sym_PLUS] = ACTIONS(7488),
    [anon_sym_DASH] = ACTIONS(7490),
    [anon_sym_LT_DASH] = ACTIONS(7488),
    [anon_sym_LT_LT_DASH] = ACTIONS(7488),
    [anon_sym_COLON_EQ] = ACTIONS(7488),
    [anon_sym_DASH_GT] = ACTIONS(7490),
    [anon_sym_DASH_GT_GT] = ACTIONS(7488),
    [anon_sym_PIPE] = ACTIONS(7490),
    [anon_sym_AMP] = ACTIONS(7490),
    [anon_sym_PIPE_PIPE] = ACTIONS(7488),
    [anon_sym_AMP_AMP] = ACTIONS(7488),
    [anon_sym_LT] = ACTIONS(7490),
    [anon_sym_LT_EQ] = ACTIONS(7488),
    [anon_sym_GT] = ACTIONS(7490),
    [anon_sym_GT_EQ] = ACTIONS(7488),
    [anon_sym_EQ_EQ] = ACTIONS(7488),
    [anon_sym_BANG_EQ] = ACTIONS(7488),
    [anon_sym_STAR] = ACTIONS(7490),
    [anon_sym_SLASH] = ACTIONS(7488),
    [anon_sym_STAR_STAR] = ACTIONS(7488),
    [anon_sym_CARET] = ACTIONS(7488),
    [aux_sym_binary_operator_token1] = ACTIONS(7488),
    [anon_sym_PIPE_GT] = ACTIONS(7488),
    [anon_sym_COLON] = ACTIONS(7490),
    [anon_sym_DOLLAR] = ACTIONS(7488),
    [anon_sym_AT] = ACTIONS(7488),
    [aux_sym__hex_literal_token1] = ACTIONS(7488),
    [sym__number_literal] = ACTIONS(7490),
    [anon_sym_SQUOTE] = ACTIONS(7488),
    [anon_sym_DQUOTE] = ACTIONS(7488),
    [sym_return] = ACTIONS(7490),
    [sym_next] = ACTIONS(7490),
    [sym_break] = ACTIONS(7490),
    [sym_true] = ACTIONS(7490),
    [sym_false] = ACTIONS(7490),
    [sym_null] = ACTIONS(7490),
    [sym_inf] = ACTIONS(7490),
    [sym_nan] = ACTIONS(7490),
    [anon_sym_NA] = ACTIONS(7490),
    [anon_sym_NA_integer_] = ACTIONS(7490),
    [anon_sym_NA_real_] = ACTIONS(7490),
    [anon_sym_NA_complex_] = ACTIONS(7490),
    [anon_sym_NA_character_] = ACTIONS(7490),
    [sym_dots] = ACTIONS(7490),
    [sym_dot_dot_i] = ACTIONS(7488),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7488),
    [sym__newline] = ACTIONS(7488),
    [sym__raw_string_literal] = ACTIONS(7488),
    [sym__external_open_parenthesis] = ACTIONS(7488),
    [sym__external_close_parenthesis] = ACTIONS(7488),
    [sym__external_open_brace] = ACTIONS(7488),
    [sym__external_open_bracket] = ACTIONS(7488),
    [sym__external_close_bracket] = ACTIONS(7488),
    [sym__external_open_bracket2] = ACTIONS(7488),
  },
  [2757] = {
    [sym_identifier] = ACTIONS(7478),
    [anon_sym_BSLASH] = ACTIONS(7476),
    [anon_sym_function] = ACTIONS(7478),
    [anon_sym_EQ] = ACTIONS(7478),
    [anon_sym_if] = ACTIONS(7478),
    [anon_sym_for] = ACTIONS(7478),
    [anon_sym_while] = ACTIONS(7478),
    [anon_sym_repeat] = ACTIONS(7478),
    [anon_sym_QMARK] = ACTIONS(7476),
    [anon_sym_TILDE] = ACTIONS(7476),
    [anon_sym_BANG] = ACTIONS(7478),
    [anon_sym_PLUS] = ACTIONS(7476),
    [anon_sym_DASH] = ACTIONS(7478),
    [anon_sym_LT_DASH] = ACTIONS(7476),
    [anon_sym_LT_LT_DASH] = ACTIONS(7476),
    [anon_sym_COLON_EQ] = ACTIONS(7476),
    [anon_sym_DASH_GT] = ACTIONS(7478),
    [anon_sym_DASH_GT_GT] = ACTIONS(7476),
    [anon_sym_PIPE] = ACTIONS(7478),
    [anon_sym_AMP] = ACTIONS(7478),
    [anon_sym_PIPE_PIPE] = ACTIONS(7476),
    [anon_sym_AMP_AMP] = ACTIONS(7476),
    [anon_sym_LT] = ACTIONS(7478),
    [anon_sym_LT_EQ] = ACTIONS(7476),
    [anon_sym_GT] = ACTIONS(7478),
    [anon_sym_GT_EQ] = ACTIONS(7476),
    [anon_sym_EQ_EQ] = ACTIONS(7476),
    [anon_sym_BANG_EQ] = ACTIONS(7476),
    [anon_sym_STAR] = ACTIONS(7478),
    [anon_sym_SLASH] = ACTIONS(7476),
    [anon_sym_STAR_STAR] = ACTIONS(7476),
    [anon_sym_CARET] = ACTIONS(7476),
    [aux_sym_binary_operator_token1] = ACTIONS(7476),
    [anon_sym_PIPE_GT] = ACTIONS(7476),
    [anon_sym_COLON] = ACTIONS(7478),
    [anon_sym_DOLLAR] = ACTIONS(7476),
    [anon_sym_AT] = ACTIONS(7476),
    [aux_sym__hex_literal_token1] = ACTIONS(7476),
    [sym__number_literal] = ACTIONS(7478),
    [anon_sym_SQUOTE] = ACTIONS(7476),
    [anon_sym_DQUOTE] = ACTIONS(7476),
    [sym_return] = ACTIONS(7478),
    [sym_next] = ACTIONS(7478),
    [sym_break] = ACTIONS(7478),
    [sym_true] = ACTIONS(7478),
    [sym_false] = ACTIONS(7478),
    [sym_null] = ACTIONS(7478),
    [sym_inf] = ACTIONS(7478),
    [sym_nan] = ACTIONS(7478),
    [anon_sym_NA] = ACTIONS(7478),
    [anon_sym_NA_integer_] = ACTIONS(7478),
    [anon_sym_NA_real_] = ACTIONS(7478),
    [anon_sym_NA_complex_] = ACTIONS(7478),
    [anon_sym_NA_character_] = ACTIONS(7478),
    [sym_dots] = ACTIONS(7478),
    [sym_dot_dot_i] = ACTIONS(7476),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7476),
    [sym__newline] = ACTIONS(7476),
    [sym__raw_string_literal] = ACTIONS(7476),
    [sym__external_open_parenthesis] = ACTIONS(7476),
    [sym__external_close_parenthesis] = ACTIONS(7476),
    [sym__external_open_brace] = ACTIONS(7476),
    [sym__external_open_bracket] = ACTIONS(7476),
    [sym__external_open_bracket2] = ACTIONS(7476),
    [sym__external_close_bracket2] = ACTIONS(7476),
  },
  [2758] = {
    [ts_builtin_sym_end] = ACTIONS(7480),
    [sym_identifier] = ACTIONS(7482),
    [anon_sym_BSLASH] = ACTIONS(7480),
    [anon_sym_function] = ACTIONS(7482),
    [anon_sym_EQ] = ACTIONS(7482),
    [anon_sym_if] = ACTIONS(7482),
    [anon_sym_for] = ACTIONS(7482),
    [anon_sym_while] = ACTIONS(7482),
    [anon_sym_repeat] = ACTIONS(7482),
    [anon_sym_QMARK] = ACTIONS(7480),
    [anon_sym_TILDE] = ACTIONS(7480),
    [anon_sym_BANG] = ACTIONS(7482),
    [anon_sym_PLUS] = ACTIONS(7480),
    [anon_sym_DASH] = ACTIONS(7482),
    [anon_sym_LT_DASH] = ACTIONS(7480),
    [anon_sym_LT_LT_DASH] = ACTIONS(7480),
    [anon_sym_COLON_EQ] = ACTIONS(7480),
    [anon_sym_DASH_GT] = ACTIONS(7482),
    [anon_sym_DASH_GT_GT] = ACTIONS(7480),
    [anon_sym_PIPE] = ACTIONS(7482),
    [anon_sym_AMP] = ACTIONS(7482),
    [anon_sym_PIPE_PIPE] = ACTIONS(7480),
    [anon_sym_AMP_AMP] = ACTIONS(7480),
    [anon_sym_LT] = ACTIONS(7482),
    [anon_sym_LT_EQ] = ACTIONS(7480),
    [anon_sym_GT] = ACTIONS(7482),
    [anon_sym_GT_EQ] = ACTIONS(7480),
    [anon_sym_EQ_EQ] = ACTIONS(7480),
    [anon_sym_BANG_EQ] = ACTIONS(7480),
    [anon_sym_STAR] = ACTIONS(7482),
    [anon_sym_SLASH] = ACTIONS(7480),
    [anon_sym_STAR_STAR] = ACTIONS(7480),
    [anon_sym_CARET] = ACTIONS(7480),
    [aux_sym_binary_operator_token1] = ACTIONS(7480),
    [anon_sym_PIPE_GT] = ACTIONS(7480),
    [anon_sym_COLON] = ACTIONS(7482),
    [anon_sym_DOLLAR] = ACTIONS(7480),
    [anon_sym_AT] = ACTIONS(7480),
    [aux_sym__hex_literal_token1] = ACTIONS(7480),
    [sym__number_literal] = ACTIONS(7482),
    [anon_sym_SQUOTE] = ACTIONS(7480),
    [anon_sym_DQUOTE] = ACTIONS(7480),
    [sym_return] = ACTIONS(7482),
    [sym_next] = ACTIONS(7482),
    [sym_break] = ACTIONS(7482),
    [sym_true] = ACTIONS(7482),
    [sym_false] = ACTIONS(7482),
    [sym_null] = ACTIONS(7482),
    [sym_inf] = ACTIONS(7482),
    [sym_nan] = ACTIONS(7482),
    [anon_sym_NA] = ACTIONS(7482),
    [anon_sym_NA_integer_] = ACTIONS(7482),
    [anon_sym_NA_real_] = ACTIONS(7482),
    [anon_sym_NA_complex_] = ACTIONS(7482),
    [anon_sym_NA_character_] = ACTIONS(7482),
    [sym_dots] = ACTIONS(7482),
    [sym_dot_dot_i] = ACTIONS(7480),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7480),
    [sym__semicolon] = ACTIONS(7480),
    [sym__raw_string_literal] = ACTIONS(7480),
    [sym__external_else] = ACTIONS(7480),
    [sym__external_open_parenthesis] = ACTIONS(7480),
    [sym__external_open_brace] = ACTIONS(7480),
    [sym__external_open_bracket] = ACTIONS(7480),
    [sym__external_open_bracket2] = ACTIONS(7480),
  },
  [2759] = {
    [ts_builtin_sym_end] = ACTIONS(7492),
    [sym_identifier] = ACTIONS(7494),
    [anon_sym_BSLASH] = ACTIONS(7492),
    [anon_sym_function] = ACTIONS(7494),
    [anon_sym_EQ] = ACTIONS(7494),
    [anon_sym_if] = ACTIONS(7494),
    [anon_sym_for] = ACTIONS(7494),
    [anon_sym_while] = ACTIONS(7494),
    [anon_sym_repeat] = ACTIONS(7494),
    [anon_sym_QMARK] = ACTIONS(7492),
    [anon_sym_TILDE] = ACTIONS(7492),
    [anon_sym_BANG] = ACTIONS(7494),
    [anon_sym_PLUS] = ACTIONS(7492),
    [anon_sym_DASH] = ACTIONS(7494),
    [anon_sym_LT_DASH] = ACTIONS(7492),
    [anon_sym_LT_LT_DASH] = ACTIONS(7492),
    [anon_sym_COLON_EQ] = ACTIONS(7492),
    [anon_sym_DASH_GT] = ACTIONS(7494),
    [anon_sym_DASH_GT_GT] = ACTIONS(7492),
    [anon_sym_PIPE] = ACTIONS(7494),
    [anon_sym_AMP] = ACTIONS(7494),
    [anon_sym_PIPE_PIPE] = ACTIONS(7492),
    [anon_sym_AMP_AMP] = ACTIONS(7492),
    [anon_sym_LT] = ACTIONS(7494),
    [anon_sym_LT_EQ] = ACTIONS(7492),
    [anon_sym_GT] = ACTIONS(7494),
    [anon_sym_GT_EQ] = ACTIONS(7492),
    [anon_sym_EQ_EQ] = ACTIONS(7492),
    [anon_sym_BANG_EQ] = ACTIONS(7492),
    [anon_sym_STAR] = ACTIONS(7494),
    [anon_sym_SLASH] = ACTIONS(7492),
    [anon_sym_STAR_STAR] = ACTIONS(7492),
    [anon_sym_CARET] = ACTIONS(7492),
    [aux_sym_binary_operator_token1] = ACTIONS(7492),
    [anon_sym_PIPE_GT] = ACTIONS(7492),
    [anon_sym_COLON] = ACTIONS(7494),
    [anon_sym_DOLLAR] = ACTIONS(7492),
    [anon_sym_AT] = ACTIONS(7492),
    [aux_sym__hex_literal_token1] = ACTIONS(7492),
    [sym__number_literal] = ACTIONS(7494),
    [anon_sym_SQUOTE] = ACTIONS(7492),
    [anon_sym_DQUOTE] = ACTIONS(7492),
    [sym_return] = ACTIONS(7494),
    [sym_next] = ACTIONS(7494),
    [sym_break] = ACTIONS(7494),
    [sym_true] = ACTIONS(7494),
    [sym_false] = ACTIONS(7494),
    [sym_null] = ACTIONS(7494),
    [sym_inf] = ACTIONS(7494),
    [sym_nan] = ACTIONS(7494),
    [anon_sym_NA] = ACTIONS(7494),
    [anon_sym_NA_integer_] = ACTIONS(7494),
    [anon_sym_NA_real_] = ACTIONS(7494),
    [anon_sym_NA_complex_] = ACTIONS(7494),
    [anon_sym_NA_character_] = ACTIONS(7494),
    [sym_dots] = ACTIONS(7494),
    [sym_dot_dot_i] = ACTIONS(7492),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7492),
    [sym__semicolon] = ACTIONS(7492),
    [sym__raw_string_literal] = ACTIONS(7492),
    [sym__external_open_parenthesis] = ACTIONS(7492),
    [sym__external_open_brace] = ACTIONS(7492),
    [sym__external_close_brace] = ACTIONS(7492),
    [sym__external_open_bracket] = ACTIONS(7492),
    [sym__external_open_bracket2] = ACTIONS(7492),
  },
  [2760] = {
    [sym_identifier] = ACTIONS(7486),
    [anon_sym_BSLASH] = ACTIONS(7484),
    [anon_sym_function] = ACTIONS(7486),
    [anon_sym_EQ] = ACTIONS(7486),
    [anon_sym_if] = ACTIONS(7486),
    [anon_sym_for] = ACTIONS(7486),
    [anon_sym_while] = ACTIONS(7486),
    [anon_sym_repeat] = ACTIONS(7486),
    [anon_sym_QMARK] = ACTIONS(7484),
    [anon_sym_TILDE] = ACTIONS(7484),
    [anon_sym_BANG] = ACTIONS(7486),
    [anon_sym_PLUS] = ACTIONS(7484),
    [anon_sym_DASH] = ACTIONS(7486),
    [anon_sym_LT_DASH] = ACTIONS(7484),
    [anon_sym_LT_LT_DASH] = ACTIONS(7484),
    [anon_sym_COLON_EQ] = ACTIONS(7484),
    [anon_sym_DASH_GT] = ACTIONS(7486),
    [anon_sym_DASH_GT_GT] = ACTIONS(7484),
    [anon_sym_PIPE] = ACTIONS(7486),
    [anon_sym_AMP] = ACTIONS(7486),
    [anon_sym_PIPE_PIPE] = ACTIONS(7484),
    [anon_sym_AMP_AMP] = ACTIONS(7484),
    [anon_sym_LT] = ACTIONS(7486),
    [anon_sym_LT_EQ] = ACTIONS(7484),
    [anon_sym_GT] = ACTIONS(7486),
    [anon_sym_GT_EQ] = ACTIONS(7484),
    [anon_sym_EQ_EQ] = ACTIONS(7484),
    [anon_sym_BANG_EQ] = ACTIONS(7484),
    [anon_sym_STAR] = ACTIONS(7486),
    [anon_sym_SLASH] = ACTIONS(7484),
    [anon_sym_STAR_STAR] = ACTIONS(7484),
    [anon_sym_CARET] = ACTIONS(7484),
    [aux_sym_binary_operator_token1] = ACTIONS(7484),
    [anon_sym_PIPE_GT] = ACTIONS(7484),
    [anon_sym_COLON] = ACTIONS(7486),
    [anon_sym_DOLLAR] = ACTIONS(7484),
    [anon_sym_AT] = ACTIONS(7484),
    [aux_sym__hex_literal_token1] = ACTIONS(7484),
    [sym__number_literal] = ACTIONS(7486),
    [anon_sym_SQUOTE] = ACTIONS(7484),
    [anon_sym_DQUOTE] = ACTIONS(7484),
    [sym_return] = ACTIONS(7486),
    [sym_next] = ACTIONS(7486),
    [sym_break] = ACTIONS(7486),
    [sym_true] = ACTIONS(7486),
    [sym_false] = ACTIONS(7486),
    [sym_null] = ACTIONS(7486),
    [sym_inf] = ACTIONS(7486),
    [sym_nan] = ACTIONS(7486),
    [anon_sym_NA] = ACTIONS(7486),
    [anon_sym_NA_integer_] = ACTIONS(7486),
    [anon_sym_NA_real_] = ACTIONS(7486),
    [anon_sym_NA_complex_] = ACTIONS(7486),
    [anon_sym_NA_character_] = ACTIONS(7486),
    [sym_dots] = ACTIONS(7486),
    [sym_dot_dot_i] = ACTIONS(7484),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7484),
    [sym__newline] = ACTIONS(7484),
    [sym__raw_string_literal] = ACTIONS(7484),
    [sym__external_open_parenthesis] = ACTIONS(7484),
    [sym__external_close_parenthesis] = ACTIONS(7484),
    [sym__external_open_brace] = ACTIONS(7484),
    [sym__external_open_bracket] = ACTIONS(7484),
    [sym__external_close_bracket] = ACTIONS(7484),
    [sym__external_open_bracket2] = ACTIONS(7484),
  },
  [2761] = {
    [sym_identifier] = ACTIONS(7552),
    [anon_sym_BSLASH] = ACTIONS(7550),
    [anon_sym_function] = ACTIONS(7552),
    [anon_sym_EQ] = ACTIONS(7552),
    [anon_sym_if] = ACTIONS(7552),
    [anon_sym_for] = ACTIONS(7552),
    [anon_sym_while] = ACTIONS(7552),
    [anon_sym_repeat] = ACTIONS(7552),
    [anon_sym_QMARK] = ACTIONS(7550),
    [anon_sym_TILDE] = ACTIONS(7550),
    [anon_sym_BANG] = ACTIONS(7552),
    [anon_sym_PLUS] = ACTIONS(7550),
    [anon_sym_DASH] = ACTIONS(7552),
    [anon_sym_LT_DASH] = ACTIONS(7550),
    [anon_sym_LT_LT_DASH] = ACTIONS(7550),
    [anon_sym_COLON_EQ] = ACTIONS(7550),
    [anon_sym_DASH_GT] = ACTIONS(7552),
    [anon_sym_DASH_GT_GT] = ACTIONS(7550),
    [anon_sym_PIPE] = ACTIONS(7552),
    [anon_sym_AMP] = ACTIONS(7552),
    [anon_sym_PIPE_PIPE] = ACTIONS(7550),
    [anon_sym_AMP_AMP] = ACTIONS(7550),
    [anon_sym_LT] = ACTIONS(7552),
    [anon_sym_LT_EQ] = ACTIONS(7550),
    [anon_sym_GT] = ACTIONS(7552),
    [anon_sym_GT_EQ] = ACTIONS(7550),
    [anon_sym_EQ_EQ] = ACTIONS(7550),
    [anon_sym_BANG_EQ] = ACTIONS(7550),
    [anon_sym_STAR] = ACTIONS(7552),
    [anon_sym_SLASH] = ACTIONS(7550),
    [anon_sym_STAR_STAR] = ACTIONS(7550),
    [anon_sym_CARET] = ACTIONS(7550),
    [aux_sym_binary_operator_token1] = ACTIONS(7550),
    [anon_sym_PIPE_GT] = ACTIONS(7550),
    [anon_sym_COLON] = ACTIONS(7552),
    [anon_sym_DOLLAR] = ACTIONS(7550),
    [anon_sym_AT] = ACTIONS(7550),
    [aux_sym__hex_literal_token1] = ACTIONS(7550),
    [sym__number_literal] = ACTIONS(7552),
    [anon_sym_SQUOTE] = ACTIONS(7550),
    [anon_sym_DQUOTE] = ACTIONS(7550),
    [sym_return] = ACTIONS(7552),
    [sym_next] = ACTIONS(7552),
    [sym_break] = ACTIONS(7552),
    [sym_true] = ACTIONS(7552),
    [sym_false] = ACTIONS(7552),
    [sym_null] = ACTIONS(7552),
    [sym_inf] = ACTIONS(7552),
    [sym_nan] = ACTIONS(7552),
    [anon_sym_NA] = ACTIONS(7552),
    [anon_sym_NA_integer_] = ACTIONS(7552),
    [anon_sym_NA_real_] = ACTIONS(7552),
    [anon_sym_NA_complex_] = ACTIONS(7552),
    [anon_sym_NA_character_] = ACTIONS(7552),
    [sym_dots] = ACTIONS(7552),
    [sym_dot_dot_i] = ACTIONS(7550),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7550),
    [sym__newline] = ACTIONS(7550),
    [sym__raw_string_literal] = ACTIONS(7550),
    [sym__external_else] = ACTIONS(7550),
    [sym__external_open_parenthesis] = ACTIONS(7550),
    [sym__external_open_brace] = ACTIONS(7550),
    [sym__external_open_bracket] = ACTIONS(7550),
    [sym__external_close_bracket] = ACTIONS(7550),
    [sym__external_open_bracket2] = ACTIONS(7550),
  },
  [2762] = {
    [sym_identifier] = ACTIONS(7482),
    [anon_sym_BSLASH] = ACTIONS(7480),
    [anon_sym_function] = ACTIONS(7482),
    [anon_sym_EQ] = ACTIONS(7482),
    [anon_sym_if] = ACTIONS(7482),
    [anon_sym_for] = ACTIONS(7482),
    [anon_sym_while] = ACTIONS(7482),
    [anon_sym_repeat] = ACTIONS(7482),
    [anon_sym_QMARK] = ACTIONS(7480),
    [anon_sym_TILDE] = ACTIONS(7480),
    [anon_sym_BANG] = ACTIONS(7482),
    [anon_sym_PLUS] = ACTIONS(7480),
    [anon_sym_DASH] = ACTIONS(7482),
    [anon_sym_LT_DASH] = ACTIONS(7480),
    [anon_sym_LT_LT_DASH] = ACTIONS(7480),
    [anon_sym_COLON_EQ] = ACTIONS(7480),
    [anon_sym_DASH_GT] = ACTIONS(7482),
    [anon_sym_DASH_GT_GT] = ACTIONS(7480),
    [anon_sym_PIPE] = ACTIONS(7482),
    [anon_sym_AMP] = ACTIONS(7482),
    [anon_sym_PIPE_PIPE] = ACTIONS(7480),
    [anon_sym_AMP_AMP] = ACTIONS(7480),
    [anon_sym_LT] = ACTIONS(7482),
    [anon_sym_LT_EQ] = ACTIONS(7480),
    [anon_sym_GT] = ACTIONS(7482),
    [anon_sym_GT_EQ] = ACTIONS(7480),
    [anon_sym_EQ_EQ] = ACTIONS(7480),
    [anon_sym_BANG_EQ] = ACTIONS(7480),
    [anon_sym_STAR] = ACTIONS(7482),
    [anon_sym_SLASH] = ACTIONS(7480),
    [anon_sym_STAR_STAR] = ACTIONS(7480),
    [anon_sym_CARET] = ACTIONS(7480),
    [aux_sym_binary_operator_token1] = ACTIONS(7480),
    [anon_sym_PIPE_GT] = ACTIONS(7480),
    [anon_sym_COLON] = ACTIONS(7482),
    [anon_sym_DOLLAR] = ACTIONS(7480),
    [anon_sym_AT] = ACTIONS(7480),
    [aux_sym__hex_literal_token1] = ACTIONS(7480),
    [sym__number_literal] = ACTIONS(7482),
    [anon_sym_SQUOTE] = ACTIONS(7480),
    [anon_sym_DQUOTE] = ACTIONS(7480),
    [sym_return] = ACTIONS(7482),
    [sym_next] = ACTIONS(7482),
    [sym_break] = ACTIONS(7482),
    [sym_true] = ACTIONS(7482),
    [sym_false] = ACTIONS(7482),
    [sym_null] = ACTIONS(7482),
    [sym_inf] = ACTIONS(7482),
    [sym_nan] = ACTIONS(7482),
    [anon_sym_NA] = ACTIONS(7482),
    [anon_sym_NA_integer_] = ACTIONS(7482),
    [anon_sym_NA_real_] = ACTIONS(7482),
    [anon_sym_NA_complex_] = ACTIONS(7482),
    [anon_sym_NA_character_] = ACTIONS(7482),
    [sym_dots] = ACTIONS(7482),
    [sym_dot_dot_i] = ACTIONS(7480),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7480),
    [sym__newline] = ACTIONS(7480),
    [sym__raw_string_literal] = ACTIONS(7480),
    [sym__external_open_parenthesis] = ACTIONS(7480),
    [sym__external_close_parenthesis] = ACTIONS(7480),
    [sym__external_open_brace] = ACTIONS(7480),
    [sym__external_open_bracket] = ACTIONS(7480),
    [sym__external_open_bracket2] = ACTIONS(7480),
    [sym__external_close_bracket2] = ACTIONS(7480),
  },
  [2763] = {
    [sym_identifier] = ACTIONS(7532),
    [anon_sym_BSLASH] = ACTIONS(7530),
    [anon_sym_function] = ACTIONS(7532),
    [anon_sym_EQ] = ACTIONS(7532),
    [anon_sym_if] = ACTIONS(7532),
    [anon_sym_for] = ACTIONS(7532),
    [anon_sym_while] = ACTIONS(7532),
    [anon_sym_repeat] = ACTIONS(7532),
    [anon_sym_QMARK] = ACTIONS(7530),
    [anon_sym_TILDE] = ACTIONS(7530),
    [anon_sym_BANG] = ACTIONS(7532),
    [anon_sym_PLUS] = ACTIONS(7530),
    [anon_sym_DASH] = ACTIONS(7532),
    [anon_sym_LT_DASH] = ACTIONS(7530),
    [anon_sym_LT_LT_DASH] = ACTIONS(7530),
    [anon_sym_COLON_EQ] = ACTIONS(7530),
    [anon_sym_DASH_GT] = ACTIONS(7532),
    [anon_sym_DASH_GT_GT] = ACTIONS(7530),
    [anon_sym_PIPE] = ACTIONS(7532),
    [anon_sym_AMP] = ACTIONS(7532),
    [anon_sym_PIPE_PIPE] = ACTIONS(7530),
    [anon_sym_AMP_AMP] = ACTIONS(7530),
    [anon_sym_LT] = ACTIONS(7532),
    [anon_sym_LT_EQ] = ACTIONS(7530),
    [anon_sym_GT] = ACTIONS(7532),
    [anon_sym_GT_EQ] = ACTIONS(7530),
    [anon_sym_EQ_EQ] = ACTIONS(7530),
    [anon_sym_BANG_EQ] = ACTIONS(7530),
    [anon_sym_STAR] = ACTIONS(7532),
    [anon_sym_SLASH] = ACTIONS(7530),
    [anon_sym_STAR_STAR] = ACTIONS(7530),
    [anon_sym_CARET] = ACTIONS(7530),
    [aux_sym_binary_operator_token1] = ACTIONS(7530),
    [anon_sym_PIPE_GT] = ACTIONS(7530),
    [anon_sym_COLON] = ACTIONS(7532),
    [anon_sym_DOLLAR] = ACTIONS(7530),
    [anon_sym_AT] = ACTIONS(7530),
    [aux_sym__hex_literal_token1] = ACTIONS(7530),
    [sym__number_literal] = ACTIONS(7532),
    [anon_sym_SQUOTE] = ACTIONS(7530),
    [anon_sym_DQUOTE] = ACTIONS(7530),
    [sym_return] = ACTIONS(7532),
    [sym_next] = ACTIONS(7532),
    [sym_break] = ACTIONS(7532),
    [sym_true] = ACTIONS(7532),
    [sym_false] = ACTIONS(7532),
    [sym_null] = ACTIONS(7532),
    [sym_inf] = ACTIONS(7532),
    [sym_nan] = ACTIONS(7532),
    [anon_sym_NA] = ACTIONS(7532),
    [anon_sym_NA_integer_] = ACTIONS(7532),
    [anon_sym_NA_real_] = ACTIONS(7532),
    [anon_sym_NA_complex_] = ACTIONS(7532),
    [anon_sym_NA_character_] = ACTIONS(7532),
    [sym_dots] = ACTIONS(7532),
    [sym_dot_dot_i] = ACTIONS(7530),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7530),
    [sym__newline] = ACTIONS(7530),
    [sym__raw_string_literal] = ACTIONS(7530),
    [sym__external_open_parenthesis] = ACTIONS(7530),
    [sym__external_close_parenthesis] = ACTIONS(7530),
    [sym__external_open_brace] = ACTIONS(7530),
    [sym__external_open_bracket] = ACTIONS(7530),
    [sym__external_close_bracket] = ACTIONS(7530),
    [sym__external_open_bracket2] = ACTIONS(7530),
  },
  [2764] = {
    [sym_identifier] = ACTIONS(7528),
    [anon_sym_BSLASH] = ACTIONS(7526),
    [anon_sym_function] = ACTIONS(7528),
    [anon_sym_EQ] = ACTIONS(7528),
    [anon_sym_if] = ACTIONS(7528),
    [anon_sym_for] = ACTIONS(7528),
    [anon_sym_while] = ACTIONS(7528),
    [anon_sym_repeat] = ACTIONS(7528),
    [anon_sym_QMARK] = ACTIONS(7526),
    [anon_sym_TILDE] = ACTIONS(7526),
    [anon_sym_BANG] = ACTIONS(7528),
    [anon_sym_PLUS] = ACTIONS(7526),
    [anon_sym_DASH] = ACTIONS(7528),
    [anon_sym_LT_DASH] = ACTIONS(7526),
    [anon_sym_LT_LT_DASH] = ACTIONS(7526),
    [anon_sym_COLON_EQ] = ACTIONS(7526),
    [anon_sym_DASH_GT] = ACTIONS(7528),
    [anon_sym_DASH_GT_GT] = ACTIONS(7526),
    [anon_sym_PIPE] = ACTIONS(7528),
    [anon_sym_AMP] = ACTIONS(7528),
    [anon_sym_PIPE_PIPE] = ACTIONS(7526),
    [anon_sym_AMP_AMP] = ACTIONS(7526),
    [anon_sym_LT] = ACTIONS(7528),
    [anon_sym_LT_EQ] = ACTIONS(7526),
    [anon_sym_GT] = ACTIONS(7528),
    [anon_sym_GT_EQ] = ACTIONS(7526),
    [anon_sym_EQ_EQ] = ACTIONS(7526),
    [anon_sym_BANG_EQ] = ACTIONS(7526),
    [anon_sym_STAR] = ACTIONS(7528),
    [anon_sym_SLASH] = ACTIONS(7526),
    [anon_sym_STAR_STAR] = ACTIONS(7526),
    [anon_sym_CARET] = ACTIONS(7526),
    [aux_sym_binary_operator_token1] = ACTIONS(7526),
    [anon_sym_PIPE_GT] = ACTIONS(7526),
    [anon_sym_COLON] = ACTIONS(7528),
    [anon_sym_DOLLAR] = ACTIONS(7526),
    [anon_sym_AT] = ACTIONS(7526),
    [aux_sym__hex_literal_token1] = ACTIONS(7526),
    [sym__number_literal] = ACTIONS(7528),
    [anon_sym_SQUOTE] = ACTIONS(7526),
    [anon_sym_DQUOTE] = ACTIONS(7526),
    [sym_return] = ACTIONS(7528),
    [sym_next] = ACTIONS(7528),
    [sym_break] = ACTIONS(7528),
    [sym_true] = ACTIONS(7528),
    [sym_false] = ACTIONS(7528),
    [sym_null] = ACTIONS(7528),
    [sym_inf] = ACTIONS(7528),
    [sym_nan] = ACTIONS(7528),
    [anon_sym_NA] = ACTIONS(7528),
    [anon_sym_NA_integer_] = ACTIONS(7528),
    [anon_sym_NA_real_] = ACTIONS(7528),
    [anon_sym_NA_complex_] = ACTIONS(7528),
    [anon_sym_NA_character_] = ACTIONS(7528),
    [sym_dots] = ACTIONS(7528),
    [sym_dot_dot_i] = ACTIONS(7526),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7526),
    [sym__newline] = ACTIONS(7526),
    [sym__raw_string_literal] = ACTIONS(7526),
    [sym__external_open_parenthesis] = ACTIONS(7526),
    [sym__external_close_parenthesis] = ACTIONS(7526),
    [sym__external_open_brace] = ACTIONS(7526),
    [sym__external_open_bracket] = ACTIONS(7526),
    [sym__external_close_bracket] = ACTIONS(7526),
    [sym__external_open_bracket2] = ACTIONS(7526),
  },
  [2765] = {
    [sym_identifier] = ACTIONS(7524),
    [anon_sym_BSLASH] = ACTIONS(7522),
    [anon_sym_function] = ACTIONS(7524),
    [anon_sym_EQ] = ACTIONS(7524),
    [anon_sym_if] = ACTIONS(7524),
    [anon_sym_for] = ACTIONS(7524),
    [anon_sym_while] = ACTIONS(7524),
    [anon_sym_repeat] = ACTIONS(7524),
    [anon_sym_QMARK] = ACTIONS(7522),
    [anon_sym_TILDE] = ACTIONS(7522),
    [anon_sym_BANG] = ACTIONS(7524),
    [anon_sym_PLUS] = ACTIONS(7522),
    [anon_sym_DASH] = ACTIONS(7524),
    [anon_sym_LT_DASH] = ACTIONS(7522),
    [anon_sym_LT_LT_DASH] = ACTIONS(7522),
    [anon_sym_COLON_EQ] = ACTIONS(7522),
    [anon_sym_DASH_GT] = ACTIONS(7524),
    [anon_sym_DASH_GT_GT] = ACTIONS(7522),
    [anon_sym_PIPE] = ACTIONS(7524),
    [anon_sym_AMP] = ACTIONS(7524),
    [anon_sym_PIPE_PIPE] = ACTIONS(7522),
    [anon_sym_AMP_AMP] = ACTIONS(7522),
    [anon_sym_LT] = ACTIONS(7524),
    [anon_sym_LT_EQ] = ACTIONS(7522),
    [anon_sym_GT] = ACTIONS(7524),
    [anon_sym_GT_EQ] = ACTIONS(7522),
    [anon_sym_EQ_EQ] = ACTIONS(7522),
    [anon_sym_BANG_EQ] = ACTIONS(7522),
    [anon_sym_STAR] = ACTIONS(7524),
    [anon_sym_SLASH] = ACTIONS(7522),
    [anon_sym_STAR_STAR] = ACTIONS(7522),
    [anon_sym_CARET] = ACTIONS(7522),
    [aux_sym_binary_operator_token1] = ACTIONS(7522),
    [anon_sym_PIPE_GT] = ACTIONS(7522),
    [anon_sym_COLON] = ACTIONS(7524),
    [anon_sym_DOLLAR] = ACTIONS(7522),
    [anon_sym_AT] = ACTIONS(7522),
    [aux_sym__hex_literal_token1] = ACTIONS(7522),
    [sym__number_literal] = ACTIONS(7524),
    [anon_sym_SQUOTE] = ACTIONS(7522),
    [anon_sym_DQUOTE] = ACTIONS(7522),
    [sym_return] = ACTIONS(7524),
    [sym_next] = ACTIONS(7524),
    [sym_break] = ACTIONS(7524),
    [sym_true] = ACTIONS(7524),
    [sym_false] = ACTIONS(7524),
    [sym_null] = ACTIONS(7524),
    [sym_inf] = ACTIONS(7524),
    [sym_nan] = ACTIONS(7524),
    [anon_sym_NA] = ACTIONS(7524),
    [anon_sym_NA_integer_] = ACTIONS(7524),
    [anon_sym_NA_real_] = ACTIONS(7524),
    [anon_sym_NA_complex_] = ACTIONS(7524),
    [anon_sym_NA_character_] = ACTIONS(7524),
    [sym_dots] = ACTIONS(7524),
    [sym_dot_dot_i] = ACTIONS(7522),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7522),
    [sym__newline] = ACTIONS(7522),
    [sym__raw_string_literal] = ACTIONS(7522),
    [sym__external_open_parenthesis] = ACTIONS(7522),
    [sym__external_close_parenthesis] = ACTIONS(7522),
    [sym__external_open_brace] = ACTIONS(7522),
    [sym__external_open_bracket] = ACTIONS(7522),
    [sym__external_close_bracket] = ACTIONS(7522),
    [sym__external_open_bracket2] = ACTIONS(7522),
  },
  [2766] = {
    [sym_identifier] = ACTIONS(7498),
    [anon_sym_BSLASH] = ACTIONS(7496),
    [anon_sym_function] = ACTIONS(7498),
    [anon_sym_EQ] = ACTIONS(7498),
    [anon_sym_if] = ACTIONS(7498),
    [anon_sym_for] = ACTIONS(7498),
    [anon_sym_while] = ACTIONS(7498),
    [anon_sym_repeat] = ACTIONS(7498),
    [anon_sym_QMARK] = ACTIONS(7496),
    [anon_sym_TILDE] = ACTIONS(7496),
    [anon_sym_BANG] = ACTIONS(7498),
    [anon_sym_PLUS] = ACTIONS(7496),
    [anon_sym_DASH] = ACTIONS(7498),
    [anon_sym_LT_DASH] = ACTIONS(7496),
    [anon_sym_LT_LT_DASH] = ACTIONS(7496),
    [anon_sym_COLON_EQ] = ACTIONS(7496),
    [anon_sym_DASH_GT] = ACTIONS(7498),
    [anon_sym_DASH_GT_GT] = ACTIONS(7496),
    [anon_sym_PIPE] = ACTIONS(7498),
    [anon_sym_AMP] = ACTIONS(7498),
    [anon_sym_PIPE_PIPE] = ACTIONS(7496),
    [anon_sym_AMP_AMP] = ACTIONS(7496),
    [anon_sym_LT] = ACTIONS(7498),
    [anon_sym_LT_EQ] = ACTIONS(7496),
    [anon_sym_GT] = ACTIONS(7498),
    [anon_sym_GT_EQ] = ACTIONS(7496),
    [anon_sym_EQ_EQ] = ACTIONS(7496),
    [anon_sym_BANG_EQ] = ACTIONS(7496),
    [anon_sym_STAR] = ACTIONS(7498),
    [anon_sym_SLASH] = ACTIONS(7496),
    [anon_sym_STAR_STAR] = ACTIONS(7496),
    [anon_sym_CARET] = ACTIONS(7496),
    [aux_sym_binary_operator_token1] = ACTIONS(7496),
    [anon_sym_PIPE_GT] = ACTIONS(7496),
    [anon_sym_COLON] = ACTIONS(7498),
    [anon_sym_DOLLAR] = ACTIONS(7496),
    [anon_sym_AT] = ACTIONS(7496),
    [aux_sym__hex_literal_token1] = ACTIONS(7496),
    [sym__number_literal] = ACTIONS(7498),
    [anon_sym_SQUOTE] = ACTIONS(7496),
    [anon_sym_DQUOTE] = ACTIONS(7496),
    [sym_return] = ACTIONS(7498),
    [sym_next] = ACTIONS(7498),
    [sym_break] = ACTIONS(7498),
    [sym_true] = ACTIONS(7498),
    [sym_false] = ACTIONS(7498),
    [sym_null] = ACTIONS(7498),
    [sym_inf] = ACTIONS(7498),
    [sym_nan] = ACTIONS(7498),
    [anon_sym_NA] = ACTIONS(7498),
    [anon_sym_NA_integer_] = ACTIONS(7498),
    [anon_sym_NA_real_] = ACTIONS(7498),
    [anon_sym_NA_complex_] = ACTIONS(7498),
    [anon_sym_NA_character_] = ACTIONS(7498),
    [sym_dots] = ACTIONS(7498),
    [sym_dot_dot_i] = ACTIONS(7496),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7496),
    [sym__newline] = ACTIONS(7496),
    [sym__raw_string_literal] = ACTIONS(7496),
    [sym__external_else] = ACTIONS(7496),
    [sym__external_open_parenthesis] = ACTIONS(7496),
    [sym__external_close_parenthesis] = ACTIONS(7496),
    [sym__external_open_brace] = ACTIONS(7496),
    [sym__external_open_bracket] = ACTIONS(7496),
    [sym__external_open_bracket2] = ACTIONS(7496),
  },
  [2767] = {
    [sym_identifier] = ACTIONS(7490),
    [anon_sym_BSLASH] = ACTIONS(7488),
    [anon_sym_function] = ACTIONS(7490),
    [anon_sym_EQ] = ACTIONS(7490),
    [anon_sym_if] = ACTIONS(7490),
    [anon_sym_for] = ACTIONS(7490),
    [anon_sym_while] = ACTIONS(7490),
    [anon_sym_repeat] = ACTIONS(7490),
    [anon_sym_QMARK] = ACTIONS(7488),
    [anon_sym_TILDE] = ACTIONS(7488),
    [anon_sym_BANG] = ACTIONS(7490),
    [anon_sym_PLUS] = ACTIONS(7488),
    [anon_sym_DASH] = ACTIONS(7490),
    [anon_sym_LT_DASH] = ACTIONS(7488),
    [anon_sym_LT_LT_DASH] = ACTIONS(7488),
    [anon_sym_COLON_EQ] = ACTIONS(7488),
    [anon_sym_DASH_GT] = ACTIONS(7490),
    [anon_sym_DASH_GT_GT] = ACTIONS(7488),
    [anon_sym_PIPE] = ACTIONS(7490),
    [anon_sym_AMP] = ACTIONS(7490),
    [anon_sym_PIPE_PIPE] = ACTIONS(7488),
    [anon_sym_AMP_AMP] = ACTIONS(7488),
    [anon_sym_LT] = ACTIONS(7490),
    [anon_sym_LT_EQ] = ACTIONS(7488),
    [anon_sym_GT] = ACTIONS(7490),
    [anon_sym_GT_EQ] = ACTIONS(7488),
    [anon_sym_EQ_EQ] = ACTIONS(7488),
    [anon_sym_BANG_EQ] = ACTIONS(7488),
    [anon_sym_STAR] = ACTIONS(7490),
    [anon_sym_SLASH] = ACTIONS(7488),
    [anon_sym_STAR_STAR] = ACTIONS(7488),
    [anon_sym_CARET] = ACTIONS(7488),
    [aux_sym_binary_operator_token1] = ACTIONS(7488),
    [anon_sym_PIPE_GT] = ACTIONS(7488),
    [anon_sym_COLON] = ACTIONS(7490),
    [anon_sym_DOLLAR] = ACTIONS(7488),
    [anon_sym_AT] = ACTIONS(7488),
    [aux_sym__hex_literal_token1] = ACTIONS(7488),
    [sym__number_literal] = ACTIONS(7490),
    [anon_sym_SQUOTE] = ACTIONS(7488),
    [anon_sym_DQUOTE] = ACTIONS(7488),
    [sym_return] = ACTIONS(7490),
    [sym_next] = ACTIONS(7490),
    [sym_break] = ACTIONS(7490),
    [sym_true] = ACTIONS(7490),
    [sym_false] = ACTIONS(7490),
    [sym_null] = ACTIONS(7490),
    [sym_inf] = ACTIONS(7490),
    [sym_nan] = ACTIONS(7490),
    [anon_sym_NA] = ACTIONS(7490),
    [anon_sym_NA_integer_] = ACTIONS(7490),
    [anon_sym_NA_real_] = ACTIONS(7490),
    [anon_sym_NA_complex_] = ACTIONS(7490),
    [anon_sym_NA_character_] = ACTIONS(7490),
    [sym_dots] = ACTIONS(7490),
    [sym_dot_dot_i] = ACTIONS(7488),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7488),
    [sym__newline] = ACTIONS(7488),
    [sym__raw_string_literal] = ACTIONS(7488),
    [sym__external_open_parenthesis] = ACTIONS(7488),
    [sym__external_close_parenthesis] = ACTIONS(7488),
    [sym__external_open_brace] = ACTIONS(7488),
    [sym__external_open_bracket] = ACTIONS(7488),
    [sym__external_open_bracket2] = ACTIONS(7488),
    [sym__external_close_bracket2] = ACTIONS(7488),
  },
  [2768] = {
    [sym_identifier] = ACTIONS(7512),
    [anon_sym_BSLASH] = ACTIONS(7510),
    [anon_sym_function] = ACTIONS(7512),
    [anon_sym_EQ] = ACTIONS(7512),
    [anon_sym_if] = ACTIONS(7512),
    [anon_sym_for] = ACTIONS(7512),
    [anon_sym_while] = ACTIONS(7512),
    [anon_sym_repeat] = ACTIONS(7512),
    [anon_sym_QMARK] = ACTIONS(7510),
    [anon_sym_TILDE] = ACTIONS(7510),
    [anon_sym_BANG] = ACTIONS(7512),
    [anon_sym_PLUS] = ACTIONS(7510),
    [anon_sym_DASH] = ACTIONS(7512),
    [anon_sym_LT_DASH] = ACTIONS(7510),
    [anon_sym_LT_LT_DASH] = ACTIONS(7510),
    [anon_sym_COLON_EQ] = ACTIONS(7510),
    [anon_sym_DASH_GT] = ACTIONS(7512),
    [anon_sym_DASH_GT_GT] = ACTIONS(7510),
    [anon_sym_PIPE] = ACTIONS(7512),
    [anon_sym_AMP] = ACTIONS(7512),
    [anon_sym_PIPE_PIPE] = ACTIONS(7510),
    [anon_sym_AMP_AMP] = ACTIONS(7510),
    [anon_sym_LT] = ACTIONS(7512),
    [anon_sym_LT_EQ] = ACTIONS(7510),
    [anon_sym_GT] = ACTIONS(7512),
    [anon_sym_GT_EQ] = ACTIONS(7510),
    [anon_sym_EQ_EQ] = ACTIONS(7510),
    [anon_sym_BANG_EQ] = ACTIONS(7510),
    [anon_sym_STAR] = ACTIONS(7512),
    [anon_sym_SLASH] = ACTIONS(7510),
    [anon_sym_STAR_STAR] = ACTIONS(7510),
    [anon_sym_CARET] = ACTIONS(7510),
    [aux_sym_binary_operator_token1] = ACTIONS(7510),
    [anon_sym_PIPE_GT] = ACTIONS(7510),
    [anon_sym_COLON] = ACTIONS(7512),
    [anon_sym_DOLLAR] = ACTIONS(7510),
    [anon_sym_AT] = ACTIONS(7510),
    [aux_sym__hex_literal_token1] = ACTIONS(7510),
    [sym__number_literal] = ACTIONS(7512),
    [anon_sym_SQUOTE] = ACTIONS(7510),
    [anon_sym_DQUOTE] = ACTIONS(7510),
    [sym_return] = ACTIONS(7512),
    [sym_next] = ACTIONS(7512),
    [sym_break] = ACTIONS(7512),
    [sym_true] = ACTIONS(7512),
    [sym_false] = ACTIONS(7512),
    [sym_null] = ACTIONS(7512),
    [sym_inf] = ACTIONS(7512),
    [sym_nan] = ACTIONS(7512),
    [anon_sym_NA] = ACTIONS(7512),
    [anon_sym_NA_integer_] = ACTIONS(7512),
    [anon_sym_NA_real_] = ACTIONS(7512),
    [anon_sym_NA_complex_] = ACTIONS(7512),
    [anon_sym_NA_character_] = ACTIONS(7512),
    [sym_dots] = ACTIONS(7512),
    [sym_dot_dot_i] = ACTIONS(7510),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7510),
    [sym__newline] = ACTIONS(7510),
    [sym__raw_string_literal] = ACTIONS(7510),
    [sym__external_else] = ACTIONS(7510),
    [sym__external_open_parenthesis] = ACTIONS(7510),
    [sym__external_close_parenthesis] = ACTIONS(7510),
    [sym__external_open_brace] = ACTIONS(7510),
    [sym__external_open_bracket] = ACTIONS(7510),
    [sym__external_open_bracket2] = ACTIONS(7510),
  },
  [2769] = {
    [sym_identifier] = ACTIONS(7520),
    [anon_sym_BSLASH] = ACTIONS(7518),
    [anon_sym_function] = ACTIONS(7520),
    [anon_sym_EQ] = ACTIONS(7520),
    [anon_sym_if] = ACTIONS(7520),
    [anon_sym_for] = ACTIONS(7520),
    [anon_sym_while] = ACTIONS(7520),
    [anon_sym_repeat] = ACTIONS(7520),
    [anon_sym_QMARK] = ACTIONS(7518),
    [anon_sym_TILDE] = ACTIONS(7518),
    [anon_sym_BANG] = ACTIONS(7520),
    [anon_sym_PLUS] = ACTIONS(7518),
    [anon_sym_DASH] = ACTIONS(7520),
    [anon_sym_LT_DASH] = ACTIONS(7518),
    [anon_sym_LT_LT_DASH] = ACTIONS(7518),
    [anon_sym_COLON_EQ] = ACTIONS(7518),
    [anon_sym_DASH_GT] = ACTIONS(7520),
    [anon_sym_DASH_GT_GT] = ACTIONS(7518),
    [anon_sym_PIPE] = ACTIONS(7520),
    [anon_sym_AMP] = ACTIONS(7520),
    [anon_sym_PIPE_PIPE] = ACTIONS(7518),
    [anon_sym_AMP_AMP] = ACTIONS(7518),
    [anon_sym_LT] = ACTIONS(7520),
    [anon_sym_LT_EQ] = ACTIONS(7518),
    [anon_sym_GT] = ACTIONS(7520),
    [anon_sym_GT_EQ] = ACTIONS(7518),
    [anon_sym_EQ_EQ] = ACTIONS(7518),
    [anon_sym_BANG_EQ] = ACTIONS(7518),
    [anon_sym_STAR] = ACTIONS(7520),
    [anon_sym_SLASH] = ACTIONS(7518),
    [anon_sym_STAR_STAR] = ACTIONS(7518),
    [anon_sym_CARET] = ACTIONS(7518),
    [aux_sym_binary_operator_token1] = ACTIONS(7518),
    [anon_sym_PIPE_GT] = ACTIONS(7518),
    [anon_sym_COLON] = ACTIONS(7520),
    [anon_sym_DOLLAR] = ACTIONS(7518),
    [anon_sym_AT] = ACTIONS(7518),
    [aux_sym__hex_literal_token1] = ACTIONS(7518),
    [sym__number_literal] = ACTIONS(7520),
    [anon_sym_SQUOTE] = ACTIONS(7518),
    [anon_sym_DQUOTE] = ACTIONS(7518),
    [sym_return] = ACTIONS(7520),
    [sym_next] = ACTIONS(7520),
    [sym_break] = ACTIONS(7520),
    [sym_true] = ACTIONS(7520),
    [sym_false] = ACTIONS(7520),
    [sym_null] = ACTIONS(7520),
    [sym_inf] = ACTIONS(7520),
    [sym_nan] = ACTIONS(7520),
    [anon_sym_NA] = ACTIONS(7520),
    [anon_sym_NA_integer_] = ACTIONS(7520),
    [anon_sym_NA_real_] = ACTIONS(7520),
    [anon_sym_NA_complex_] = ACTIONS(7520),
    [anon_sym_NA_character_] = ACTIONS(7520),
    [sym_dots] = ACTIONS(7520),
    [sym_dot_dot_i] = ACTIONS(7518),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7518),
    [sym__newline] = ACTIONS(7518),
    [sym__raw_string_literal] = ACTIONS(7518),
    [sym__external_open_parenthesis] = ACTIONS(7518),
    [sym__external_close_parenthesis] = ACTIONS(7518),
    [sym__external_open_brace] = ACTIONS(7518),
    [sym__external_open_bracket] = ACTIONS(7518),
    [sym__external_close_bracket] = ACTIONS(7518),
    [sym__external_open_bracket2] = ACTIONS(7518),
  },
  [2770] = {
    [sym_identifier] = ACTIONS(7494),
    [anon_sym_BSLASH] = ACTIONS(7492),
    [anon_sym_function] = ACTIONS(7494),
    [anon_sym_EQ] = ACTIONS(7494),
    [anon_sym_if] = ACTIONS(7494),
    [anon_sym_for] = ACTIONS(7494),
    [anon_sym_while] = ACTIONS(7494),
    [anon_sym_repeat] = ACTIONS(7494),
    [anon_sym_QMARK] = ACTIONS(7492),
    [anon_sym_TILDE] = ACTIONS(7492),
    [anon_sym_BANG] = ACTIONS(7494),
    [anon_sym_PLUS] = ACTIONS(7492),
    [anon_sym_DASH] = ACTIONS(7494),
    [anon_sym_LT_DASH] = ACTIONS(7492),
    [anon_sym_LT_LT_DASH] = ACTIONS(7492),
    [anon_sym_COLON_EQ] = ACTIONS(7492),
    [anon_sym_DASH_GT] = ACTIONS(7494),
    [anon_sym_DASH_GT_GT] = ACTIONS(7492),
    [anon_sym_PIPE] = ACTIONS(7494),
    [anon_sym_AMP] = ACTIONS(7494),
    [anon_sym_PIPE_PIPE] = ACTIONS(7492),
    [anon_sym_AMP_AMP] = ACTIONS(7492),
    [anon_sym_LT] = ACTIONS(7494),
    [anon_sym_LT_EQ] = ACTIONS(7492),
    [anon_sym_GT] = ACTIONS(7494),
    [anon_sym_GT_EQ] = ACTIONS(7492),
    [anon_sym_EQ_EQ] = ACTIONS(7492),
    [anon_sym_BANG_EQ] = ACTIONS(7492),
    [anon_sym_STAR] = ACTIONS(7494),
    [anon_sym_SLASH] = ACTIONS(7492),
    [anon_sym_STAR_STAR] = ACTIONS(7492),
    [anon_sym_CARET] = ACTIONS(7492),
    [aux_sym_binary_operator_token1] = ACTIONS(7492),
    [anon_sym_PIPE_GT] = ACTIONS(7492),
    [anon_sym_COLON] = ACTIONS(7494),
    [anon_sym_DOLLAR] = ACTIONS(7492),
    [anon_sym_AT] = ACTIONS(7492),
    [aux_sym__hex_literal_token1] = ACTIONS(7492),
    [sym__number_literal] = ACTIONS(7494),
    [anon_sym_SQUOTE] = ACTIONS(7492),
    [anon_sym_DQUOTE] = ACTIONS(7492),
    [sym_return] = ACTIONS(7494),
    [sym_next] = ACTIONS(7494),
    [sym_break] = ACTIONS(7494),
    [sym_true] = ACTIONS(7494),
    [sym_false] = ACTIONS(7494),
    [sym_null] = ACTIONS(7494),
    [sym_inf] = ACTIONS(7494),
    [sym_nan] = ACTIONS(7494),
    [anon_sym_NA] = ACTIONS(7494),
    [anon_sym_NA_integer_] = ACTIONS(7494),
    [anon_sym_NA_real_] = ACTIONS(7494),
    [anon_sym_NA_complex_] = ACTIONS(7494),
    [anon_sym_NA_character_] = ACTIONS(7494),
    [sym_dots] = ACTIONS(7494),
    [sym_dot_dot_i] = ACTIONS(7492),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7492),
    [sym__newline] = ACTIONS(7492),
    [sym__raw_string_literal] = ACTIONS(7492),
    [sym__external_else] = ACTIONS(7492),
    [sym__external_open_parenthesis] = ACTIONS(7492),
    [sym__external_close_parenthesis] = ACTIONS(7492),
    [sym__external_open_brace] = ACTIONS(7492),
    [sym__external_open_bracket] = ACTIONS(7492),
    [sym__external_open_bracket2] = ACTIONS(7492),
  },
  [2771] = {
    [sym_identifier] = ACTIONS(7516),
    [anon_sym_BSLASH] = ACTIONS(7514),
    [anon_sym_function] = ACTIONS(7516),
    [anon_sym_EQ] = ACTIONS(7516),
    [anon_sym_if] = ACTIONS(7516),
    [anon_sym_for] = ACTIONS(7516),
    [anon_sym_while] = ACTIONS(7516),
    [anon_sym_repeat] = ACTIONS(7516),
    [anon_sym_QMARK] = ACTIONS(7514),
    [anon_sym_TILDE] = ACTIONS(7514),
    [anon_sym_BANG] = ACTIONS(7516),
    [anon_sym_PLUS] = ACTIONS(7514),
    [anon_sym_DASH] = ACTIONS(7516),
    [anon_sym_LT_DASH] = ACTIONS(7514),
    [anon_sym_LT_LT_DASH] = ACTIONS(7514),
    [anon_sym_COLON_EQ] = ACTIONS(7514),
    [anon_sym_DASH_GT] = ACTIONS(7516),
    [anon_sym_DASH_GT_GT] = ACTIONS(7514),
    [anon_sym_PIPE] = ACTIONS(7516),
    [anon_sym_AMP] = ACTIONS(7516),
    [anon_sym_PIPE_PIPE] = ACTIONS(7514),
    [anon_sym_AMP_AMP] = ACTIONS(7514),
    [anon_sym_LT] = ACTIONS(7516),
    [anon_sym_LT_EQ] = ACTIONS(7514),
    [anon_sym_GT] = ACTIONS(7516),
    [anon_sym_GT_EQ] = ACTIONS(7514),
    [anon_sym_EQ_EQ] = ACTIONS(7514),
    [anon_sym_BANG_EQ] = ACTIONS(7514),
    [anon_sym_STAR] = ACTIONS(7516),
    [anon_sym_SLASH] = ACTIONS(7514),
    [anon_sym_STAR_STAR] = ACTIONS(7514),
    [anon_sym_CARET] = ACTIONS(7514),
    [aux_sym_binary_operator_token1] = ACTIONS(7514),
    [anon_sym_PIPE_GT] = ACTIONS(7514),
    [anon_sym_COLON] = ACTIONS(7516),
    [anon_sym_DOLLAR] = ACTIONS(7514),
    [anon_sym_AT] = ACTIONS(7514),
    [aux_sym__hex_literal_token1] = ACTIONS(7514),
    [sym__number_literal] = ACTIONS(7516),
    [anon_sym_SQUOTE] = ACTIONS(7514),
    [anon_sym_DQUOTE] = ACTIONS(7514),
    [sym_return] = ACTIONS(7516),
    [sym_next] = ACTIONS(7516),
    [sym_break] = ACTIONS(7516),
    [sym_true] = ACTIONS(7516),
    [sym_false] = ACTIONS(7516),
    [sym_null] = ACTIONS(7516),
    [sym_inf] = ACTIONS(7516),
    [sym_nan] = ACTIONS(7516),
    [anon_sym_NA] = ACTIONS(7516),
    [anon_sym_NA_integer_] = ACTIONS(7516),
    [anon_sym_NA_real_] = ACTIONS(7516),
    [anon_sym_NA_complex_] = ACTIONS(7516),
    [anon_sym_NA_character_] = ACTIONS(7516),
    [sym_dots] = ACTIONS(7516),
    [sym_dot_dot_i] = ACTIONS(7514),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7514),
    [sym__newline] = ACTIONS(7514),
    [sym__raw_string_literal] = ACTIONS(7514),
    [sym__external_open_parenthesis] = ACTIONS(7514),
    [sym__external_close_parenthesis] = ACTIONS(7514),
    [sym__external_open_brace] = ACTIONS(7514),
    [sym__external_open_bracket] = ACTIONS(7514),
    [sym__external_close_bracket] = ACTIONS(7514),
    [sym__external_open_bracket2] = ACTIONS(7514),
  },
  [2772] = {
    [sym_function_definition] = STATE(1931),
    [sym_if_statement] = STATE(1931),
    [sym_for_statement] = STATE(1931),
    [sym_while_statement] = STATE(1931),
    [sym_repeat_statement] = STATE(1931),
    [sym_braced_expression] = STATE(1931),
    [sym_parenthesized_expression] = STATE(1931),
    [sym_call] = STATE(1931),
    [sym_subset] = STATE(1931),
    [sym_subset2] = STATE(1931),
    [sym__argument_value] = STATE(4667),
    [sym_unary_operator] = STATE(1931),
    [sym_binary_operator] = STATE(1931),
    [sym_extract_operator] = STATE(1931),
    [sym_namespace_operator] = STATE(1931),
    [sym_integer] = STATE(1931),
    [sym_complex] = STATE(1931),
    [sym_float] = STATE(1931),
    [sym__hex_literal] = STATE(2578),
    [sym__float_literal] = STATE(2578),
    [sym_string] = STATE(2673),
    [sym__single_quoted_string] = STATE(2735),
    [sym__double_quoted_string] = STATE(2620),
    [sym_na] = STATE(1931),
    [sym__expression] = STATE(1931),
    [sym__string_or_identifier] = STATE(5135),
    [sym__open_parenthesis] = STATE(350),
    [sym__open_brace] = STATE(154),
    [sym_identifier] = ACTIONS(3845),
    [anon_sym_BSLASH] = ACTIONS(3847),
    [anon_sym_function] = ACTIONS(3849),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_repeat] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(6389),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3865),
    [aux_sym__hex_literal_token1] = ACTIONS(3869),
    [sym__number_literal] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_return] = ACTIONS(6391),
    [sym_next] = ACTIONS(6391),
    [sym_break] = ACTIONS(6391),
    [sym_true] = ACTIONS(6391),
    [sym_false] = ACTIONS(6391),
    [sym_null] = ACTIONS(6391),
    [sym_inf] = ACTIONS(6391),
    [sym_nan] = ACTIONS(6391),
    [anon_sym_NA] = ACTIONS(3879),
    [anon_sym_NA_integer_] = ACTIONS(3879),
    [anon_sym_NA_real_] = ACTIONS(3879),
    [anon_sym_NA_complex_] = ACTIONS(3879),
    [anon_sym_NA_character_] = ACTIONS(3879),
    [sym_dots] = ACTIONS(6391),
    [sym_dot_dot_i] = ACTIONS(6395),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7695),
    [sym__newline] = ACTIONS(6399),
    [sym__raw_string_literal] = ACTIONS(3885),
    [sym__external_open_parenthesis] = ACTIONS(3887),
    [sym__external_close_parenthesis] = ACTIONS(7695),
    [sym__external_open_brace] = ACTIONS(3891),
  },
  [2773] = {
    [sym_identifier] = ACTIONS(7563),
    [anon_sym_BSLASH] = ACTIONS(7561),
    [anon_sym_function] = ACTIONS(7563),
    [anon_sym_EQ] = ACTIONS(7563),
    [anon_sym_if] = ACTIONS(7563),
    [anon_sym_for] = ACTIONS(7563),
    [anon_sym_while] = ACTIONS(7563),
    [anon_sym_repeat] = ACTIONS(7563),
    [anon_sym_QMARK] = ACTIONS(7561),
    [anon_sym_TILDE] = ACTIONS(7561),
    [anon_sym_BANG] = ACTIONS(7563),
    [anon_sym_PLUS] = ACTIONS(7561),
    [anon_sym_DASH] = ACTIONS(7563),
    [anon_sym_LT_DASH] = ACTIONS(7561),
    [anon_sym_LT_LT_DASH] = ACTIONS(7561),
    [anon_sym_COLON_EQ] = ACTIONS(7561),
    [anon_sym_DASH_GT] = ACTIONS(7563),
    [anon_sym_DASH_GT_GT] = ACTIONS(7561),
    [anon_sym_PIPE] = ACTIONS(7563),
    [anon_sym_AMP] = ACTIONS(7563),
    [anon_sym_PIPE_PIPE] = ACTIONS(7561),
    [anon_sym_AMP_AMP] = ACTIONS(7561),
    [anon_sym_LT] = ACTIONS(7563),
    [anon_sym_LT_EQ] = ACTIONS(7561),
    [anon_sym_GT] = ACTIONS(7563),
    [anon_sym_GT_EQ] = ACTIONS(7561),
    [anon_sym_EQ_EQ] = ACTIONS(7561),
    [anon_sym_BANG_EQ] = ACTIONS(7561),
    [anon_sym_STAR] = ACTIONS(7563),
    [anon_sym_SLASH] = ACTIONS(7561),
    [anon_sym_STAR_STAR] = ACTIONS(7561),
    [anon_sym_CARET] = ACTIONS(7561),
    [aux_sym_binary_operator_token1] = ACTIONS(7561),
    [anon_sym_PIPE_GT] = ACTIONS(7561),
    [anon_sym_COLON] = ACTIONS(7563),
    [anon_sym_DOLLAR] = ACTIONS(7561),
    [anon_sym_AT] = ACTIONS(7561),
    [aux_sym__hex_literal_token1] = ACTIONS(7561),
    [sym__number_literal] = ACTIONS(7563),
    [anon_sym_SQUOTE] = ACTIONS(7561),
    [anon_sym_DQUOTE] = ACTIONS(7561),
    [sym_return] = ACTIONS(7563),
    [sym_next] = ACTIONS(7563),
    [sym_break] = ACTIONS(7563),
    [sym_true] = ACTIONS(7563),
    [sym_false] = ACTIONS(7563),
    [sym_null] = ACTIONS(7563),
    [sym_inf] = ACTIONS(7563),
    [sym_nan] = ACTIONS(7563),
    [anon_sym_NA] = ACTIONS(7563),
    [anon_sym_NA_integer_] = ACTIONS(7563),
    [anon_sym_NA_real_] = ACTIONS(7563),
    [anon_sym_NA_complex_] = ACTIONS(7563),
    [anon_sym_NA_character_] = ACTIONS(7563),
    [sym_dots] = ACTIONS(7563),
    [sym_dot_dot_i] = ACTIONS(7561),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7561),
    [sym__newline] = ACTIONS(7561),
    [sym__raw_string_literal] = ACTIONS(7561),
    [sym__external_else] = ACTIONS(7561),
    [sym__external_open_parenthesis] = ACTIONS(7561),
    [sym__external_open_brace] = ACTIONS(7561),
    [sym__external_open_bracket] = ACTIONS(7561),
    [sym__external_open_bracket2] = ACTIONS(7561),
    [sym__external_close_bracket2] = ACTIONS(7561),
  },
  [2774] = {
    [sym_identifier] = ACTIONS(7478),
    [anon_sym_BSLASH] = ACTIONS(7476),
    [anon_sym_function] = ACTIONS(7478),
    [anon_sym_EQ] = ACTIONS(7478),
    [anon_sym_if] = ACTIONS(7478),
    [anon_sym_for] = ACTIONS(7478),
    [anon_sym_while] = ACTIONS(7478),
    [anon_sym_repeat] = ACTIONS(7478),
    [anon_sym_QMARK] = ACTIONS(7476),
    [anon_sym_TILDE] = ACTIONS(7476),
    [anon_sym_BANG] = ACTIONS(7478),
    [anon_sym_PLUS] = ACTIONS(7476),
    [anon_sym_DASH] = ACTIONS(7478),
    [anon_sym_LT_DASH] = ACTIONS(7476),
    [anon_sym_LT_LT_DASH] = ACTIONS(7476),
    [anon_sym_COLON_EQ] = ACTIONS(7476),
    [anon_sym_DASH_GT] = ACTIONS(7478),
    [anon_sym_DASH_GT_GT] = ACTIONS(7476),
    [anon_sym_PIPE] = ACTIONS(7478),
    [anon_sym_AMP] = ACTIONS(7478),
    [anon_sym_PIPE_PIPE] = ACTIONS(7476),
    [anon_sym_AMP_AMP] = ACTIONS(7476),
    [anon_sym_LT] = ACTIONS(7478),
    [anon_sym_LT_EQ] = ACTIONS(7476),
    [anon_sym_GT] = ACTIONS(7478),
    [anon_sym_GT_EQ] = ACTIONS(7476),
    [anon_sym_EQ_EQ] = ACTIONS(7476),
    [anon_sym_BANG_EQ] = ACTIONS(7476),
    [anon_sym_STAR] = ACTIONS(7478),
    [anon_sym_SLASH] = ACTIONS(7476),
    [anon_sym_STAR_STAR] = ACTIONS(7476),
    [anon_sym_CARET] = ACTIONS(7476),
    [aux_sym_binary_operator_token1] = ACTIONS(7476),
    [anon_sym_PIPE_GT] = ACTIONS(7476),
    [anon_sym_COLON] = ACTIONS(7478),
    [anon_sym_DOLLAR] = ACTIONS(7476),
    [anon_sym_AT] = ACTIONS(7476),
    [aux_sym__hex_literal_token1] = ACTIONS(7476),
    [sym__number_literal] = ACTIONS(7478),
    [anon_sym_SQUOTE] = ACTIONS(7476),
    [anon_sym_DQUOTE] = ACTIONS(7476),
    [sym_return] = ACTIONS(7478),
    [sym_next] = ACTIONS(7478),
    [sym_break] = ACTIONS(7478),
    [sym_true] = ACTIONS(7478),
    [sym_false] = ACTIONS(7478),
    [sym_null] = ACTIONS(7478),
    [sym_inf] = ACTIONS(7478),
    [sym_nan] = ACTIONS(7478),
    [anon_sym_NA] = ACTIONS(7478),
    [anon_sym_NA_integer_] = ACTIONS(7478),
    [anon_sym_NA_real_] = ACTIONS(7478),
    [anon_sym_NA_complex_] = ACTIONS(7478),
    [anon_sym_NA_character_] = ACTIONS(7478),
    [sym_dots] = ACTIONS(7478),
    [sym_dot_dot_i] = ACTIONS(7476),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7476),
    [sym__newline] = ACTIONS(7476),
    [sym__raw_string_literal] = ACTIONS(7476),
    [sym__external_open_parenthesis] = ACTIONS(7476),
    [sym__external_close_parenthesis] = ACTIONS(7476),
    [sym__external_open_brace] = ACTIONS(7476),
    [sym__external_open_bracket] = ACTIONS(7476),
    [sym__external_close_bracket] = ACTIONS(7476),
    [sym__external_open_bracket2] = ACTIONS(7476),
  },
  [2775] = {
    [sym_identifier] = ACTIONS(7464),
    [anon_sym_BSLASH] = ACTIONS(7466),
    [anon_sym_function] = ACTIONS(7464),
    [anon_sym_EQ] = ACTIONS(7464),
    [anon_sym_if] = ACTIONS(7464),
    [anon_sym_for] = ACTIONS(7464),
    [anon_sym_while] = ACTIONS(7464),
    [anon_sym_repeat] = ACTIONS(7464),
    [anon_sym_QMARK] = ACTIONS(7466),
    [anon_sym_TILDE] = ACTIONS(7466),
    [anon_sym_BANG] = ACTIONS(7464),
    [anon_sym_PLUS] = ACTIONS(7466),
    [anon_sym_DASH] = ACTIONS(7464),
    [anon_sym_LT_DASH] = ACTIONS(7466),
    [anon_sym_LT_LT_DASH] = ACTIONS(7466),
    [anon_sym_COLON_EQ] = ACTIONS(7466),
    [anon_sym_DASH_GT] = ACTIONS(7464),
    [anon_sym_DASH_GT_GT] = ACTIONS(7466),
    [anon_sym_PIPE] = ACTIONS(7464),
    [anon_sym_AMP] = ACTIONS(7464),
    [anon_sym_PIPE_PIPE] = ACTIONS(7466),
    [anon_sym_AMP_AMP] = ACTIONS(7466),
    [anon_sym_LT] = ACTIONS(7464),
    [anon_sym_LT_EQ] = ACTIONS(7466),
    [anon_sym_GT] = ACTIONS(7464),
    [anon_sym_GT_EQ] = ACTIONS(7466),
    [anon_sym_EQ_EQ] = ACTIONS(7466),
    [anon_sym_BANG_EQ] = ACTIONS(7466),
    [anon_sym_STAR] = ACTIONS(7464),
    [anon_sym_SLASH] = ACTIONS(7466),
    [anon_sym_STAR_STAR] = ACTIONS(7466),
    [anon_sym_CARET] = ACTIONS(7466),
    [aux_sym_binary_operator_token1] = ACTIONS(7466),
    [anon_sym_PIPE_GT] = ACTIONS(7466),
    [anon_sym_COLON] = ACTIONS(7464),
    [anon_sym_DOLLAR] = ACTIONS(7466),
    [anon_sym_AT] = ACTIONS(7466),
    [aux_sym__hex_literal_token1] = ACTIONS(7466),
    [sym__number_literal] = ACTIONS(7464),
    [anon_sym_SQUOTE] = ACTIONS(7466),
    [anon_sym_DQUOTE] = ACTIONS(7466),
    [sym_return] = ACTIONS(7464),
    [sym_next] = ACTIONS(7464),
    [sym_break] = ACTIONS(7464),
    [sym_true] = ACTIONS(7464),
    [sym_false] = ACTIONS(7464),
    [sym_null] = ACTIONS(7464),
    [sym_inf] = ACTIONS(7464),
    [sym_nan] = ACTIONS(7464),
    [anon_sym_NA] = ACTIONS(7464),
    [anon_sym_NA_integer_] = ACTIONS(7464),
    [anon_sym_NA_real_] = ACTIONS(7464),
    [anon_sym_NA_complex_] = ACTIONS(7464),
    [anon_sym_NA_character_] = ACTIONS(7464),
    [sym_dots] = ACTIONS(7464),
    [sym_dot_dot_i] = ACTIONS(7466),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7466),
    [sym__newline] = ACTIONS(7466),
    [sym__raw_string_literal] = ACTIONS(7466),
    [sym__external_open_parenthesis] = ACTIONS(7466),
    [sym__external_close_parenthesis] = ACTIONS(7466),
    [sym__external_open_brace] = ACTIONS(7466),
    [sym__external_open_bracket] = ACTIONS(7466),
    [sym__external_close_bracket] = ACTIONS(7466),
    [sym__external_open_bracket2] = ACTIONS(7466),
  },
  [2776] = {
    [sym_identifier] = ACTIONS(7474),
    [anon_sym_BSLASH] = ACTIONS(7472),
    [anon_sym_function] = ACTIONS(7474),
    [anon_sym_EQ] = ACTIONS(7474),
    [anon_sym_if] = ACTIONS(7474),
    [anon_sym_for] = ACTIONS(7474),
    [anon_sym_while] = ACTIONS(7474),
    [anon_sym_repeat] = ACTIONS(7474),
    [anon_sym_QMARK] = ACTIONS(7472),
    [anon_sym_TILDE] = ACTIONS(7472),
    [anon_sym_BANG] = ACTIONS(7474),
    [anon_sym_PLUS] = ACTIONS(7472),
    [anon_sym_DASH] = ACTIONS(7474),
    [anon_sym_LT_DASH] = ACTIONS(7472),
    [anon_sym_LT_LT_DASH] = ACTIONS(7472),
    [anon_sym_COLON_EQ] = ACTIONS(7472),
    [anon_sym_DASH_GT] = ACTIONS(7474),
    [anon_sym_DASH_GT_GT] = ACTIONS(7472),
    [anon_sym_PIPE] = ACTIONS(7474),
    [anon_sym_AMP] = ACTIONS(7474),
    [anon_sym_PIPE_PIPE] = ACTIONS(7472),
    [anon_sym_AMP_AMP] = ACTIONS(7472),
    [anon_sym_LT] = ACTIONS(7474),
    [anon_sym_LT_EQ] = ACTIONS(7472),
    [anon_sym_GT] = ACTIONS(7474),
    [anon_sym_GT_EQ] = ACTIONS(7472),
    [anon_sym_EQ_EQ] = ACTIONS(7472),
    [anon_sym_BANG_EQ] = ACTIONS(7472),
    [anon_sym_STAR] = ACTIONS(7474),
    [anon_sym_SLASH] = ACTIONS(7472),
    [anon_sym_STAR_STAR] = ACTIONS(7472),
    [anon_sym_CARET] = ACTIONS(7472),
    [aux_sym_binary_operator_token1] = ACTIONS(7472),
    [anon_sym_PIPE_GT] = ACTIONS(7472),
    [anon_sym_COLON] = ACTIONS(7474),
    [anon_sym_DOLLAR] = ACTIONS(7472),
    [anon_sym_AT] = ACTIONS(7472),
    [aux_sym__hex_literal_token1] = ACTIONS(7472),
    [sym__number_literal] = ACTIONS(7474),
    [anon_sym_SQUOTE] = ACTIONS(7472),
    [anon_sym_DQUOTE] = ACTIONS(7472),
    [sym_return] = ACTIONS(7474),
    [sym_next] = ACTIONS(7474),
    [sym_break] = ACTIONS(7474),
    [sym_true] = ACTIONS(7474),
    [sym_false] = ACTIONS(7474),
    [sym_null] = ACTIONS(7474),
    [sym_inf] = ACTIONS(7474),
    [sym_nan] = ACTIONS(7474),
    [anon_sym_NA] = ACTIONS(7474),
    [anon_sym_NA_integer_] = ACTIONS(7474),
    [anon_sym_NA_real_] = ACTIONS(7474),
    [anon_sym_NA_complex_] = ACTIONS(7474),
    [anon_sym_NA_character_] = ACTIONS(7474),
    [sym_dots] = ACTIONS(7474),
    [sym_dot_dot_i] = ACTIONS(7472),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7472),
    [sym__newline] = ACTIONS(7472),
    [sym__raw_string_literal] = ACTIONS(7472),
    [sym__external_open_parenthesis] = ACTIONS(7472),
    [sym__external_close_parenthesis] = ACTIONS(7472),
    [sym__external_open_brace] = ACTIONS(7472),
    [sym__external_open_bracket] = ACTIONS(7472),
    [sym__external_close_bracket] = ACTIONS(7472),
    [sym__external_open_bracket2] = ACTIONS(7472),
  },
  [2777] = {
    [ts_builtin_sym_end] = ACTIONS(7530),
    [sym_identifier] = ACTIONS(7532),
    [anon_sym_BSLASH] = ACTIONS(7530),
    [anon_sym_function] = ACTIONS(7532),
    [anon_sym_EQ] = ACTIONS(7532),
    [anon_sym_if] = ACTIONS(7532),
    [anon_sym_for] = ACTIONS(7532),
    [anon_sym_while] = ACTIONS(7532),
    [anon_sym_repeat] = ACTIONS(7532),
    [anon_sym_QMARK] = ACTIONS(7530),
    [anon_sym_TILDE] = ACTIONS(7530),
    [anon_sym_BANG] = ACTIONS(7532),
    [anon_sym_PLUS] = ACTIONS(7530),
    [anon_sym_DASH] = ACTIONS(7532),
    [anon_sym_LT_DASH] = ACTIONS(7530),
    [anon_sym_LT_LT_DASH] = ACTIONS(7530),
    [anon_sym_COLON_EQ] = ACTIONS(7530),
    [anon_sym_DASH_GT] = ACTIONS(7532),
    [anon_sym_DASH_GT_GT] = ACTIONS(7530),
    [anon_sym_PIPE] = ACTIONS(7532),
    [anon_sym_AMP] = ACTIONS(7532),
    [anon_sym_PIPE_PIPE] = ACTIONS(7530),
    [anon_sym_AMP_AMP] = ACTIONS(7530),
    [anon_sym_LT] = ACTIONS(7532),
    [anon_sym_LT_EQ] = ACTIONS(7530),
    [anon_sym_GT] = ACTIONS(7532),
    [anon_sym_GT_EQ] = ACTIONS(7530),
    [anon_sym_EQ_EQ] = ACTIONS(7530),
    [anon_sym_BANG_EQ] = ACTIONS(7530),
    [anon_sym_STAR] = ACTIONS(7532),
    [anon_sym_SLASH] = ACTIONS(7530),
    [anon_sym_STAR_STAR] = ACTIONS(7530),
    [anon_sym_CARET] = ACTIONS(7530),
    [aux_sym_binary_operator_token1] = ACTIONS(7530),
    [anon_sym_PIPE_GT] = ACTIONS(7530),
    [anon_sym_COLON] = ACTIONS(7532),
    [anon_sym_DOLLAR] = ACTIONS(7530),
    [anon_sym_AT] = ACTIONS(7530),
    [aux_sym__hex_literal_token1] = ACTIONS(7530),
    [sym__number_literal] = ACTIONS(7532),
    [anon_sym_SQUOTE] = ACTIONS(7530),
    [anon_sym_DQUOTE] = ACTIONS(7530),
    [sym_return] = ACTIONS(7532),
    [sym_next] = ACTIONS(7532),
    [sym_break] = ACTIONS(7532),
    [sym_true] = ACTIONS(7532),
    [sym_false] = ACTIONS(7532),
    [sym_null] = ACTIONS(7532),
    [sym_inf] = ACTIONS(7532),
    [sym_nan] = ACTIONS(7532),
    [anon_sym_NA] = ACTIONS(7532),
    [anon_sym_NA_integer_] = ACTIONS(7532),
    [anon_sym_NA_real_] = ACTIONS(7532),
    [anon_sym_NA_complex_] = ACTIONS(7532),
    [anon_sym_NA_character_] = ACTIONS(7532),
    [sym_dots] = ACTIONS(7532),
    [sym_dot_dot_i] = ACTIONS(7530),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7530),
    [sym__semicolon] = ACTIONS(7530),
    [sym__raw_string_literal] = ACTIONS(7530),
    [sym__external_open_parenthesis] = ACTIONS(7530),
    [sym__external_close_parenthesis] = ACTIONS(7530),
    [sym__external_open_brace] = ACTIONS(7530),
    [sym__external_open_bracket] = ACTIONS(7530),
    [sym__external_open_bracket2] = ACTIONS(7530),
  },
  [2778] = {
    [sym_function_definition] = STATE(2018),
    [sym_if_statement] = STATE(2018),
    [sym_for_statement] = STATE(2018),
    [sym_while_statement] = STATE(2018),
    [sym_repeat_statement] = STATE(2018),
    [sym_braced_expression] = STATE(2018),
    [sym_parenthesized_expression] = STATE(2018),
    [sym_call] = STATE(2018),
    [sym_subset] = STATE(2018),
    [sym_subset2] = STATE(2018),
    [sym_unary_operator] = STATE(2018),
    [sym_binary_operator] = STATE(2018),
    [sym_extract_operator] = STATE(2018),
    [sym_namespace_operator] = STATE(2018),
    [sym_integer] = STATE(2018),
    [sym_complex] = STATE(2018),
    [sym_float] = STATE(2018),
    [sym__hex_literal] = STATE(2739),
    [sym__float_literal] = STATE(2739),
    [sym_string] = STATE(2562),
    [sym__single_quoted_string] = STATE(2738),
    [sym__double_quoted_string] = STATE(2737),
    [sym_na] = STATE(2018),
    [sym__expression] = STATE(2018),
    [sym__string_or_identifier] = STATE(5152),
    [sym__open_parenthesis] = STATE(293),
    [sym__open_brace] = STATE(292),
    [aux_sym_program_repeat1] = STATE(2893),
    [ts_builtin_sym_end] = ACTIONS(7697),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(9),
    [anon_sym_function] = ACTIONS(11),
    [anon_sym_if] = ACTIONS(13),
    [anon_sym_for] = ACTIONS(15),
    [anon_sym_while] = ACTIONS(17),
    [anon_sym_repeat] = ACTIONS(19),
    [anon_sym_QMARK] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_DASH] = ACTIONS(27),
    [aux_sym__hex_literal_token1] = ACTIONS(29),
    [sym__number_literal] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE] = ACTIONS(35),
    [sym_return] = ACTIONS(37),
    [sym_next] = ACTIONS(37),
    [sym_break] = ACTIONS(37),
    [sym_true] = ACTIONS(37),
    [sym_false] = ACTIONS(37),
    [sym_null] = ACTIONS(37),
    [sym_inf] = ACTIONS(37),
    [sym_nan] = ACTIONS(37),
    [anon_sym_NA] = ACTIONS(39),
    [anon_sym_NA_integer_] = ACTIONS(39),
    [anon_sym_NA_real_] = ACTIONS(39),
    [anon_sym_NA_complex_] = ACTIONS(39),
    [anon_sym_NA_character_] = ACTIONS(39),
    [sym_dots] = ACTIONS(37),
    [sym_dot_dot_i] = ACTIONS(41),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7699),
    [sym__semicolon] = ACTIONS(7699),
    [sym__raw_string_literal] = ACTIONS(45),
    [sym__external_open_parenthesis] = ACTIONS(47),
    [sym__external_open_brace] = ACTIONS(49),
  },
  [2779] = {
    [ts_builtin_sym_end] = ACTIONS(7526),
    [sym_identifier] = ACTIONS(7528),
    [anon_sym_BSLASH] = ACTIONS(7526),
    [anon_sym_function] = ACTIONS(7528),
    [anon_sym_EQ] = ACTIONS(7528),
    [anon_sym_if] = ACTIONS(7528),
    [anon_sym_for] = ACTIONS(7528),
    [anon_sym_while] = ACTIONS(7528),
    [anon_sym_repeat] = ACTIONS(7528),
    [anon_sym_QMARK] = ACTIONS(7526),
    [anon_sym_TILDE] = ACTIONS(7526),
    [anon_sym_BANG] = ACTIONS(7528),
    [anon_sym_PLUS] = ACTIONS(7526),
    [anon_sym_DASH] = ACTIONS(7528),
    [anon_sym_LT_DASH] = ACTIONS(7526),
    [anon_sym_LT_LT_DASH] = ACTIONS(7526),
    [anon_sym_COLON_EQ] = ACTIONS(7526),
    [anon_sym_DASH_GT] = ACTIONS(7528),
    [anon_sym_DASH_GT_GT] = ACTIONS(7526),
    [anon_sym_PIPE] = ACTIONS(7528),
    [anon_sym_AMP] = ACTIONS(7528),
    [anon_sym_PIPE_PIPE] = ACTIONS(7526),
    [anon_sym_AMP_AMP] = ACTIONS(7526),
    [anon_sym_LT] = ACTIONS(7528),
    [anon_sym_LT_EQ] = ACTIONS(7526),
    [anon_sym_GT] = ACTIONS(7528),
    [anon_sym_GT_EQ] = ACTIONS(7526),
    [anon_sym_EQ_EQ] = ACTIONS(7526),
    [anon_sym_BANG_EQ] = ACTIONS(7526),
    [anon_sym_STAR] = ACTIONS(7528),
    [anon_sym_SLASH] = ACTIONS(7526),
    [anon_sym_STAR_STAR] = ACTIONS(7526),
    [anon_sym_CARET] = ACTIONS(7526),
    [aux_sym_binary_operator_token1] = ACTIONS(7526),
    [anon_sym_PIPE_GT] = ACTIONS(7526),
    [anon_sym_COLON] = ACTIONS(7528),
    [anon_sym_DOLLAR] = ACTIONS(7526),
    [anon_sym_AT] = ACTIONS(7526),
    [aux_sym__hex_literal_token1] = ACTIONS(7526),
    [sym__number_literal] = ACTIONS(7528),
    [anon_sym_SQUOTE] = ACTIONS(7526),
    [anon_sym_DQUOTE] = ACTIONS(7526),
    [sym_return] = ACTIONS(7528),
    [sym_next] = ACTIONS(7528),
    [sym_break] = ACTIONS(7528),
    [sym_true] = ACTIONS(7528),
    [sym_false] = ACTIONS(7528),
    [sym_null] = ACTIONS(7528),
    [sym_inf] = ACTIONS(7528),
    [sym_nan] = ACTIONS(7528),
    [anon_sym_NA] = ACTIONS(7528),
    [anon_sym_NA_integer_] = ACTIONS(7528),
    [anon_sym_NA_real_] = ACTIONS(7528),
    [anon_sym_NA_complex_] = ACTIONS(7528),
    [anon_sym_NA_character_] = ACTIONS(7528),
    [sym_dots] = ACTIONS(7528),
    [sym_dot_dot_i] = ACTIONS(7526),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7526),
    [sym__semicolon] = ACTIONS(7526),
    [sym__raw_string_literal] = ACTIONS(7526),
    [sym__external_open_parenthesis] = ACTIONS(7526),
    [sym__external_close_parenthesis] = ACTIONS(7526),
    [sym__external_open_brace] = ACTIONS(7526),
    [sym__external_open_bracket] = ACTIONS(7526),
    [sym__external_open_bracket2] = ACTIONS(7526),
  },
  [2780] = {
    [sym_identifier] = ACTIONS(7464),
    [anon_sym_BSLASH] = ACTIONS(7466),
    [anon_sym_function] = ACTIONS(7464),
    [anon_sym_EQ] = ACTIONS(7464),
    [anon_sym_if] = ACTIONS(7464),
    [anon_sym_for] = ACTIONS(7464),
    [anon_sym_while] = ACTIONS(7464),
    [anon_sym_repeat] = ACTIONS(7464),
    [anon_sym_QMARK] = ACTIONS(7466),
    [anon_sym_TILDE] = ACTIONS(7466),
    [anon_sym_BANG] = ACTIONS(7464),
    [anon_sym_PLUS] = ACTIONS(7466),
    [anon_sym_DASH] = ACTIONS(7464),
    [anon_sym_LT_DASH] = ACTIONS(7466),
    [anon_sym_LT_LT_DASH] = ACTIONS(7466),
    [anon_sym_COLON_EQ] = ACTIONS(7466),
    [anon_sym_DASH_GT] = ACTIONS(7464),
    [anon_sym_DASH_GT_GT] = ACTIONS(7466),
    [anon_sym_PIPE] = ACTIONS(7464),
    [anon_sym_AMP] = ACTIONS(7464),
    [anon_sym_PIPE_PIPE] = ACTIONS(7466),
    [anon_sym_AMP_AMP] = ACTIONS(7466),
    [anon_sym_LT] = ACTIONS(7464),
    [anon_sym_LT_EQ] = ACTIONS(7466),
    [anon_sym_GT] = ACTIONS(7464),
    [anon_sym_GT_EQ] = ACTIONS(7466),
    [anon_sym_EQ_EQ] = ACTIONS(7466),
    [anon_sym_BANG_EQ] = ACTIONS(7466),
    [anon_sym_STAR] = ACTIONS(7464),
    [anon_sym_SLASH] = ACTIONS(7466),
    [anon_sym_STAR_STAR] = ACTIONS(7466),
    [anon_sym_CARET] = ACTIONS(7466),
    [aux_sym_binary_operator_token1] = ACTIONS(7466),
    [anon_sym_PIPE_GT] = ACTIONS(7466),
    [anon_sym_COLON] = ACTIONS(7464),
    [anon_sym_DOLLAR] = ACTIONS(7466),
    [anon_sym_AT] = ACTIONS(7466),
    [aux_sym__hex_literal_token1] = ACTIONS(7466),
    [sym__number_literal] = ACTIONS(7464),
    [anon_sym_SQUOTE] = ACTIONS(7466),
    [anon_sym_DQUOTE] = ACTIONS(7466),
    [sym_return] = ACTIONS(7464),
    [sym_next] = ACTIONS(7464),
    [sym_break] = ACTIONS(7464),
    [sym_true] = ACTIONS(7464),
    [sym_false] = ACTIONS(7464),
    [sym_null] = ACTIONS(7464),
    [sym_inf] = ACTIONS(7464),
    [sym_nan] = ACTIONS(7464),
    [anon_sym_NA] = ACTIONS(7464),
    [anon_sym_NA_integer_] = ACTIONS(7464),
    [anon_sym_NA_real_] = ACTIONS(7464),
    [anon_sym_NA_complex_] = ACTIONS(7464),
    [anon_sym_NA_character_] = ACTIONS(7464),
    [sym_dots] = ACTIONS(7464),
    [sym_dot_dot_i] = ACTIONS(7466),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7466),
    [sym__newline] = ACTIONS(7466),
    [sym__raw_string_literal] = ACTIONS(7466),
    [sym__external_open_parenthesis] = ACTIONS(7466),
    [sym__external_close_parenthesis] = ACTIONS(7466),
    [sym__external_open_brace] = ACTIONS(7466),
    [sym__external_open_bracket] = ACTIONS(7466),
    [sym__external_open_bracket2] = ACTIONS(7466),
    [sym__external_close_bracket2] = ACTIONS(7466),
  },
  [2781] = {
    [sym_identifier] = ACTIONS(7490),
    [anon_sym_BSLASH] = ACTIONS(7488),
    [anon_sym_function] = ACTIONS(7490),
    [anon_sym_EQ] = ACTIONS(7490),
    [anon_sym_if] = ACTIONS(7490),
    [anon_sym_for] = ACTIONS(7490),
    [anon_sym_while] = ACTIONS(7490),
    [anon_sym_repeat] = ACTIONS(7490),
    [anon_sym_QMARK] = ACTIONS(7488),
    [anon_sym_TILDE] = ACTIONS(7488),
    [anon_sym_BANG] = ACTIONS(7490),
    [anon_sym_PLUS] = ACTIONS(7488),
    [anon_sym_DASH] = ACTIONS(7490),
    [anon_sym_LT_DASH] = ACTIONS(7488),
    [anon_sym_LT_LT_DASH] = ACTIONS(7488),
    [anon_sym_COLON_EQ] = ACTIONS(7488),
    [anon_sym_DASH_GT] = ACTIONS(7490),
    [anon_sym_DASH_GT_GT] = ACTIONS(7488),
    [anon_sym_PIPE] = ACTIONS(7490),
    [anon_sym_AMP] = ACTIONS(7490),
    [anon_sym_PIPE_PIPE] = ACTIONS(7488),
    [anon_sym_AMP_AMP] = ACTIONS(7488),
    [anon_sym_LT] = ACTIONS(7490),
    [anon_sym_LT_EQ] = ACTIONS(7488),
    [anon_sym_GT] = ACTIONS(7490),
    [anon_sym_GT_EQ] = ACTIONS(7488),
    [anon_sym_EQ_EQ] = ACTIONS(7488),
    [anon_sym_BANG_EQ] = ACTIONS(7488),
    [anon_sym_STAR] = ACTIONS(7490),
    [anon_sym_SLASH] = ACTIONS(7488),
    [anon_sym_STAR_STAR] = ACTIONS(7488),
    [anon_sym_CARET] = ACTIONS(7488),
    [aux_sym_binary_operator_token1] = ACTIONS(7488),
    [anon_sym_PIPE_GT] = ACTIONS(7488),
    [anon_sym_COLON] = ACTIONS(7490),
    [anon_sym_DOLLAR] = ACTIONS(7488),
    [anon_sym_AT] = ACTIONS(7488),
    [aux_sym__hex_literal_token1] = ACTIONS(7488),
    [sym__number_literal] = ACTIONS(7490),
    [anon_sym_SQUOTE] = ACTIONS(7488),
    [anon_sym_DQUOTE] = ACTIONS(7488),
    [sym_return] = ACTIONS(7490),
    [sym_next] = ACTIONS(7490),
    [sym_break] = ACTIONS(7490),
    [sym_true] = ACTIONS(7490),
    [sym_false] = ACTIONS(7490),
    [sym_null] = ACTIONS(7490),
    [sym_inf] = ACTIONS(7490),
    [sym_nan] = ACTIONS(7490),
    [anon_sym_NA] = ACTIONS(7490),
    [anon_sym_NA_integer_] = ACTIONS(7490),
    [anon_sym_NA_real_] = ACTIONS(7490),
    [anon_sym_NA_complex_] = ACTIONS(7490),
    [anon_sym_NA_character_] = ACTIONS(7490),
    [sym_dots] = ACTIONS(7490),
    [sym_dot_dot_i] = ACTIONS(7488),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7488),
    [sym__newline] = ACTIONS(7488),
    [sym__raw_string_literal] = ACTIONS(7488),
    [sym__external_else] = ACTIONS(7488),
    [sym__external_open_parenthesis] = ACTIONS(7488),
    [sym__external_close_parenthesis] = ACTIONS(7488),
    [sym__external_open_brace] = ACTIONS(7488),
    [sym__external_open_bracket] = ACTIONS(7488),
    [sym__external_open_bracket2] = ACTIONS(7488),
  },
  [2782] = {
    [sym_identifier] = ACTIONS(7506),
    [anon_sym_BSLASH] = ACTIONS(7504),
    [anon_sym_function] = ACTIONS(7506),
    [anon_sym_EQ] = ACTIONS(7506),
    [anon_sym_if] = ACTIONS(7506),
    [anon_sym_for] = ACTIONS(7506),
    [anon_sym_while] = ACTIONS(7506),
    [anon_sym_repeat] = ACTIONS(7506),
    [anon_sym_QMARK] = ACTIONS(7504),
    [anon_sym_TILDE] = ACTIONS(7504),
    [anon_sym_BANG] = ACTIONS(7506),
    [anon_sym_PLUS] = ACTIONS(7504),
    [anon_sym_DASH] = ACTIONS(7506),
    [anon_sym_LT_DASH] = ACTIONS(7504),
    [anon_sym_LT_LT_DASH] = ACTIONS(7504),
    [anon_sym_COLON_EQ] = ACTIONS(7504),
    [anon_sym_DASH_GT] = ACTIONS(7506),
    [anon_sym_DASH_GT_GT] = ACTIONS(7504),
    [anon_sym_PIPE] = ACTIONS(7506),
    [anon_sym_AMP] = ACTIONS(7506),
    [anon_sym_PIPE_PIPE] = ACTIONS(7504),
    [anon_sym_AMP_AMP] = ACTIONS(7504),
    [anon_sym_LT] = ACTIONS(7506),
    [anon_sym_LT_EQ] = ACTIONS(7504),
    [anon_sym_GT] = ACTIONS(7506),
    [anon_sym_GT_EQ] = ACTIONS(7504),
    [anon_sym_EQ_EQ] = ACTIONS(7504),
    [anon_sym_BANG_EQ] = ACTIONS(7504),
    [anon_sym_STAR] = ACTIONS(7506),
    [anon_sym_SLASH] = ACTIONS(7504),
    [anon_sym_STAR_STAR] = ACTIONS(7504),
    [anon_sym_CARET] = ACTIONS(7504),
    [aux_sym_binary_operator_token1] = ACTIONS(7504),
    [anon_sym_PIPE_GT] = ACTIONS(7504),
    [anon_sym_COLON] = ACTIONS(7506),
    [anon_sym_DOLLAR] = ACTIONS(7504),
    [anon_sym_AT] = ACTIONS(7504),
    [aux_sym__hex_literal_token1] = ACTIONS(7504),
    [sym__number_literal] = ACTIONS(7506),
    [anon_sym_SQUOTE] = ACTIONS(7504),
    [anon_sym_DQUOTE] = ACTIONS(7504),
    [sym_return] = ACTIONS(7506),
    [sym_next] = ACTIONS(7506),
    [sym_break] = ACTIONS(7506),
    [sym_true] = ACTIONS(7506),
    [sym_false] = ACTIONS(7506),
    [sym_null] = ACTIONS(7506),
    [sym_inf] = ACTIONS(7506),
    [sym_nan] = ACTIONS(7506),
    [anon_sym_NA] = ACTIONS(7506),
    [anon_sym_NA_integer_] = ACTIONS(7506),
    [anon_sym_NA_real_] = ACTIONS(7506),
    [anon_sym_NA_complex_] = ACTIONS(7506),
    [anon_sym_NA_character_] = ACTIONS(7506),
    [sym_dots] = ACTIONS(7506),
    [sym_dot_dot_i] = ACTIONS(7504),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7504),
    [sym__newline] = ACTIONS(7504),
    [sym__raw_string_literal] = ACTIONS(7504),
    [sym__external_else] = ACTIONS(7504),
    [sym__external_open_parenthesis] = ACTIONS(7504),
    [sym__external_close_parenthesis] = ACTIONS(7504),
    [sym__external_open_brace] = ACTIONS(7504),
    [sym__external_open_bracket] = ACTIONS(7504),
    [sym__external_open_bracket2] = ACTIONS(7504),
  },
  [2783] = {
    [ts_builtin_sym_end] = ACTIONS(7565),
    [sym_identifier] = ACTIONS(7567),
    [anon_sym_BSLASH] = ACTIONS(7565),
    [anon_sym_function] = ACTIONS(7567),
    [anon_sym_EQ] = ACTIONS(7567),
    [anon_sym_if] = ACTIONS(7567),
    [anon_sym_for] = ACTIONS(7567),
    [anon_sym_while] = ACTIONS(7567),
    [anon_sym_repeat] = ACTIONS(7567),
    [anon_sym_QMARK] = ACTIONS(7565),
    [anon_sym_TILDE] = ACTIONS(7565),
    [anon_sym_BANG] = ACTIONS(7567),
    [anon_sym_PLUS] = ACTIONS(7565),
    [anon_sym_DASH] = ACTIONS(7567),
    [anon_sym_LT_DASH] = ACTIONS(7565),
    [anon_sym_LT_LT_DASH] = ACTIONS(7565),
    [anon_sym_COLON_EQ] = ACTIONS(7565),
    [anon_sym_DASH_GT] = ACTIONS(7567),
    [anon_sym_DASH_GT_GT] = ACTIONS(7565),
    [anon_sym_PIPE] = ACTIONS(7567),
    [anon_sym_AMP] = ACTIONS(7567),
    [anon_sym_PIPE_PIPE] = ACTIONS(7565),
    [anon_sym_AMP_AMP] = ACTIONS(7565),
    [anon_sym_LT] = ACTIONS(7567),
    [anon_sym_LT_EQ] = ACTIONS(7565),
    [anon_sym_GT] = ACTIONS(7567),
    [anon_sym_GT_EQ] = ACTIONS(7565),
    [anon_sym_EQ_EQ] = ACTIONS(7565),
    [anon_sym_BANG_EQ] = ACTIONS(7565),
    [anon_sym_STAR] = ACTIONS(7567),
    [anon_sym_SLASH] = ACTIONS(7565),
    [anon_sym_STAR_STAR] = ACTIONS(7565),
    [anon_sym_CARET] = ACTIONS(7565),
    [aux_sym_binary_operator_token1] = ACTIONS(7565),
    [anon_sym_PIPE_GT] = ACTIONS(7565),
    [anon_sym_COLON] = ACTIONS(7567),
    [anon_sym_DOLLAR] = ACTIONS(7565),
    [anon_sym_AT] = ACTIONS(7565),
    [aux_sym__hex_literal_token1] = ACTIONS(7565),
    [sym__number_literal] = ACTIONS(7567),
    [anon_sym_SQUOTE] = ACTIONS(7565),
    [anon_sym_DQUOTE] = ACTIONS(7565),
    [sym_return] = ACTIONS(7567),
    [sym_next] = ACTIONS(7567),
    [sym_break] = ACTIONS(7567),
    [sym_true] = ACTIONS(7567),
    [sym_false] = ACTIONS(7567),
    [sym_null] = ACTIONS(7567),
    [sym_inf] = ACTIONS(7567),
    [sym_nan] = ACTIONS(7567),
    [anon_sym_NA] = ACTIONS(7567),
    [anon_sym_NA_integer_] = ACTIONS(7567),
    [anon_sym_NA_real_] = ACTIONS(7567),
    [anon_sym_NA_complex_] = ACTIONS(7567),
    [anon_sym_NA_character_] = ACTIONS(7567),
    [sym_dots] = ACTIONS(7567),
    [sym_dot_dot_i] = ACTIONS(7565),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7565),
    [sym__semicolon] = ACTIONS(7565),
    [sym__raw_string_literal] = ACTIONS(7565),
    [sym__external_open_parenthesis] = ACTIONS(7565),
    [sym__external_open_brace] = ACTIONS(7565),
    [sym__external_close_brace] = ACTIONS(7565),
    [sym__external_open_bracket] = ACTIONS(7565),
    [sym__external_open_bracket2] = ACTIONS(7565),
  },
  [2784] = {
    [sym_identifier] = ACTIONS(7502),
    [anon_sym_BSLASH] = ACTIONS(7500),
    [anon_sym_function] = ACTIONS(7502),
    [anon_sym_EQ] = ACTIONS(7502),
    [anon_sym_if] = ACTIONS(7502),
    [anon_sym_for] = ACTIONS(7502),
    [anon_sym_while] = ACTIONS(7502),
    [anon_sym_repeat] = ACTIONS(7502),
    [anon_sym_QMARK] = ACTIONS(7500),
    [anon_sym_TILDE] = ACTIONS(7500),
    [anon_sym_BANG] = ACTIONS(7502),
    [anon_sym_PLUS] = ACTIONS(7500),
    [anon_sym_DASH] = ACTIONS(7502),
    [anon_sym_LT_DASH] = ACTIONS(7500),
    [anon_sym_LT_LT_DASH] = ACTIONS(7500),
    [anon_sym_COLON_EQ] = ACTIONS(7500),
    [anon_sym_DASH_GT] = ACTIONS(7502),
    [anon_sym_DASH_GT_GT] = ACTIONS(7500),
    [anon_sym_PIPE] = ACTIONS(7502),
    [anon_sym_AMP] = ACTIONS(7502),
    [anon_sym_PIPE_PIPE] = ACTIONS(7500),
    [anon_sym_AMP_AMP] = ACTIONS(7500),
    [anon_sym_LT] = ACTIONS(7502),
    [anon_sym_LT_EQ] = ACTIONS(7500),
    [anon_sym_GT] = ACTIONS(7502),
    [anon_sym_GT_EQ] = ACTIONS(7500),
    [anon_sym_EQ_EQ] = ACTIONS(7500),
    [anon_sym_BANG_EQ] = ACTIONS(7500),
    [anon_sym_STAR] = ACTIONS(7502),
    [anon_sym_SLASH] = ACTIONS(7500),
    [anon_sym_STAR_STAR] = ACTIONS(7500),
    [anon_sym_CARET] = ACTIONS(7500),
    [aux_sym_binary_operator_token1] = ACTIONS(7500),
    [anon_sym_PIPE_GT] = ACTIONS(7500),
    [anon_sym_COLON] = ACTIONS(7502),
    [anon_sym_DOLLAR] = ACTIONS(7500),
    [anon_sym_AT] = ACTIONS(7500),
    [aux_sym__hex_literal_token1] = ACTIONS(7500),
    [sym__number_literal] = ACTIONS(7502),
    [anon_sym_SQUOTE] = ACTIONS(7500),
    [anon_sym_DQUOTE] = ACTIONS(7500),
    [sym_return] = ACTIONS(7502),
    [sym_next] = ACTIONS(7502),
    [sym_break] = ACTIONS(7502),
    [sym_true] = ACTIONS(7502),
    [sym_false] = ACTIONS(7502),
    [sym_null] = ACTIONS(7502),
    [sym_inf] = ACTIONS(7502),
    [sym_nan] = ACTIONS(7502),
    [anon_sym_NA] = ACTIONS(7502),
    [anon_sym_NA_integer_] = ACTIONS(7502),
    [anon_sym_NA_real_] = ACTIONS(7502),
    [anon_sym_NA_complex_] = ACTIONS(7502),
    [anon_sym_NA_character_] = ACTIONS(7502),
    [sym_dots] = ACTIONS(7502),
    [sym_dot_dot_i] = ACTIONS(7500),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7500),
    [sym__newline] = ACTIONS(7500),
    [sym__raw_string_literal] = ACTIONS(7500),
    [sym__external_else] = ACTIONS(7500),
    [sym__external_open_parenthesis] = ACTIONS(7500),
    [sym__external_close_parenthesis] = ACTIONS(7500),
    [sym__external_open_brace] = ACTIONS(7500),
    [sym__external_open_bracket] = ACTIONS(7500),
    [sym__external_open_bracket2] = ACTIONS(7500),
  },
  [2785] = {
    [sym_identifier] = ACTIONS(7486),
    [anon_sym_BSLASH] = ACTIONS(7484),
    [anon_sym_function] = ACTIONS(7486),
    [anon_sym_EQ] = ACTIONS(7486),
    [anon_sym_if] = ACTIONS(7486),
    [anon_sym_for] = ACTIONS(7486),
    [anon_sym_while] = ACTIONS(7486),
    [anon_sym_repeat] = ACTIONS(7486),
    [anon_sym_QMARK] = ACTIONS(7484),
    [anon_sym_TILDE] = ACTIONS(7484),
    [anon_sym_BANG] = ACTIONS(7486),
    [anon_sym_PLUS] = ACTIONS(7484),
    [anon_sym_DASH] = ACTIONS(7486),
    [anon_sym_LT_DASH] = ACTIONS(7484),
    [anon_sym_LT_LT_DASH] = ACTIONS(7484),
    [anon_sym_COLON_EQ] = ACTIONS(7484),
    [anon_sym_DASH_GT] = ACTIONS(7486),
    [anon_sym_DASH_GT_GT] = ACTIONS(7484),
    [anon_sym_PIPE] = ACTIONS(7486),
    [anon_sym_AMP] = ACTIONS(7486),
    [anon_sym_PIPE_PIPE] = ACTIONS(7484),
    [anon_sym_AMP_AMP] = ACTIONS(7484),
    [anon_sym_LT] = ACTIONS(7486),
    [anon_sym_LT_EQ] = ACTIONS(7484),
    [anon_sym_GT] = ACTIONS(7486),
    [anon_sym_GT_EQ] = ACTIONS(7484),
    [anon_sym_EQ_EQ] = ACTIONS(7484),
    [anon_sym_BANG_EQ] = ACTIONS(7484),
    [anon_sym_STAR] = ACTIONS(7486),
    [anon_sym_SLASH] = ACTIONS(7484),
    [anon_sym_STAR_STAR] = ACTIONS(7484),
    [anon_sym_CARET] = ACTIONS(7484),
    [aux_sym_binary_operator_token1] = ACTIONS(7484),
    [anon_sym_PIPE_GT] = ACTIONS(7484),
    [anon_sym_COLON] = ACTIONS(7486),
    [anon_sym_DOLLAR] = ACTIONS(7484),
    [anon_sym_AT] = ACTIONS(7484),
    [aux_sym__hex_literal_token1] = ACTIONS(7484),
    [sym__number_literal] = ACTIONS(7486),
    [anon_sym_SQUOTE] = ACTIONS(7484),
    [anon_sym_DQUOTE] = ACTIONS(7484),
    [sym_return] = ACTIONS(7486),
    [sym_next] = ACTIONS(7486),
    [sym_break] = ACTIONS(7486),
    [sym_true] = ACTIONS(7486),
    [sym_false] = ACTIONS(7486),
    [sym_null] = ACTIONS(7486),
    [sym_inf] = ACTIONS(7486),
    [sym_nan] = ACTIONS(7486),
    [anon_sym_NA] = ACTIONS(7486),
    [anon_sym_NA_integer_] = ACTIONS(7486),
    [anon_sym_NA_real_] = ACTIONS(7486),
    [anon_sym_NA_complex_] = ACTIONS(7486),
    [anon_sym_NA_character_] = ACTIONS(7486),
    [sym_dots] = ACTIONS(7486),
    [sym_dot_dot_i] = ACTIONS(7484),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7484),
    [sym__newline] = ACTIONS(7484),
    [sym__raw_string_literal] = ACTIONS(7484),
    [sym__external_open_parenthesis] = ACTIONS(7484),
    [sym__external_close_parenthesis] = ACTIONS(7484),
    [sym__external_open_brace] = ACTIONS(7484),
    [sym__external_open_bracket] = ACTIONS(7484),
    [sym__external_open_bracket2] = ACTIONS(7484),
    [sym__external_close_bracket2] = ACTIONS(7484),
  },
  [2786] = {
    [ts_builtin_sym_end] = ACTIONS(7522),
    [sym_identifier] = ACTIONS(7524),
    [anon_sym_BSLASH] = ACTIONS(7522),
    [anon_sym_function] = ACTIONS(7524),
    [anon_sym_EQ] = ACTIONS(7524),
    [anon_sym_if] = ACTIONS(7524),
    [anon_sym_for] = ACTIONS(7524),
    [anon_sym_while] = ACTIONS(7524),
    [anon_sym_repeat] = ACTIONS(7524),
    [anon_sym_QMARK] = ACTIONS(7522),
    [anon_sym_TILDE] = ACTIONS(7522),
    [anon_sym_BANG] = ACTIONS(7524),
    [anon_sym_PLUS] = ACTIONS(7522),
    [anon_sym_DASH] = ACTIONS(7524),
    [anon_sym_LT_DASH] = ACTIONS(7522),
    [anon_sym_LT_LT_DASH] = ACTIONS(7522),
    [anon_sym_COLON_EQ] = ACTIONS(7522),
    [anon_sym_DASH_GT] = ACTIONS(7524),
    [anon_sym_DASH_GT_GT] = ACTIONS(7522),
    [anon_sym_PIPE] = ACTIONS(7524),
    [anon_sym_AMP] = ACTIONS(7524),
    [anon_sym_PIPE_PIPE] = ACTIONS(7522),
    [anon_sym_AMP_AMP] = ACTIONS(7522),
    [anon_sym_LT] = ACTIONS(7524),
    [anon_sym_LT_EQ] = ACTIONS(7522),
    [anon_sym_GT] = ACTIONS(7524),
    [anon_sym_GT_EQ] = ACTIONS(7522),
    [anon_sym_EQ_EQ] = ACTIONS(7522),
    [anon_sym_BANG_EQ] = ACTIONS(7522),
    [anon_sym_STAR] = ACTIONS(7524),
    [anon_sym_SLASH] = ACTIONS(7522),
    [anon_sym_STAR_STAR] = ACTIONS(7522),
    [anon_sym_CARET] = ACTIONS(7522),
    [aux_sym_binary_operator_token1] = ACTIONS(7522),
    [anon_sym_PIPE_GT] = ACTIONS(7522),
    [anon_sym_COLON] = ACTIONS(7524),
    [anon_sym_DOLLAR] = ACTIONS(7522),
    [anon_sym_AT] = ACTIONS(7522),
    [aux_sym__hex_literal_token1] = ACTIONS(7522),
    [sym__number_literal] = ACTIONS(7524),
    [anon_sym_SQUOTE] = ACTIONS(7522),
    [anon_sym_DQUOTE] = ACTIONS(7522),
    [sym_return] = ACTIONS(7524),
    [sym_next] = ACTIONS(7524),
    [sym_break] = ACTIONS(7524),
    [sym_true] = ACTIONS(7524),
    [sym_false] = ACTIONS(7524),
    [sym_null] = ACTIONS(7524),
    [sym_inf] = ACTIONS(7524),
    [sym_nan] = ACTIONS(7524),
    [anon_sym_NA] = ACTIONS(7524),
    [anon_sym_NA_integer_] = ACTIONS(7524),
    [anon_sym_NA_real_] = ACTIONS(7524),
    [anon_sym_NA_complex_] = ACTIONS(7524),
    [anon_sym_NA_character_] = ACTIONS(7524),
    [sym_dots] = ACTIONS(7524),
    [sym_dot_dot_i] = ACTIONS(7522),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7522),
    [sym__semicolon] = ACTIONS(7522),
    [sym__raw_string_literal] = ACTIONS(7522),
    [sym__external_open_parenthesis] = ACTIONS(7522),
    [sym__external_close_parenthesis] = ACTIONS(7522),
    [sym__external_open_brace] = ACTIONS(7522),
    [sym__external_open_bracket] = ACTIONS(7522),
    [sym__external_open_bracket2] = ACTIONS(7522),
  },
  [2787] = {
    [sym_identifier] = ACTIONS(7486),
    [anon_sym_BSLASH] = ACTIONS(7484),
    [anon_sym_function] = ACTIONS(7486),
    [anon_sym_EQ] = ACTIONS(7486),
    [anon_sym_if] = ACTIONS(7486),
    [anon_sym_for] = ACTIONS(7486),
    [anon_sym_while] = ACTIONS(7486),
    [anon_sym_repeat] = ACTIONS(7486),
    [anon_sym_QMARK] = ACTIONS(7484),
    [anon_sym_TILDE] = ACTIONS(7484),
    [anon_sym_BANG] = ACTIONS(7486),
    [anon_sym_PLUS] = ACTIONS(7484),
    [anon_sym_DASH] = ACTIONS(7486),
    [anon_sym_LT_DASH] = ACTIONS(7484),
    [anon_sym_LT_LT_DASH] = ACTIONS(7484),
    [anon_sym_COLON_EQ] = ACTIONS(7484),
    [anon_sym_DASH_GT] = ACTIONS(7486),
    [anon_sym_DASH_GT_GT] = ACTIONS(7484),
    [anon_sym_PIPE] = ACTIONS(7486),
    [anon_sym_AMP] = ACTIONS(7486),
    [anon_sym_PIPE_PIPE] = ACTIONS(7484),
    [anon_sym_AMP_AMP] = ACTIONS(7484),
    [anon_sym_LT] = ACTIONS(7486),
    [anon_sym_LT_EQ] = ACTIONS(7484),
    [anon_sym_GT] = ACTIONS(7486),
    [anon_sym_GT_EQ] = ACTIONS(7484),
    [anon_sym_EQ_EQ] = ACTIONS(7484),
    [anon_sym_BANG_EQ] = ACTIONS(7484),
    [anon_sym_STAR] = ACTIONS(7486),
    [anon_sym_SLASH] = ACTIONS(7484),
    [anon_sym_STAR_STAR] = ACTIONS(7484),
    [anon_sym_CARET] = ACTIONS(7484),
    [aux_sym_binary_operator_token1] = ACTIONS(7484),
    [anon_sym_PIPE_GT] = ACTIONS(7484),
    [anon_sym_COLON] = ACTIONS(7486),
    [anon_sym_DOLLAR] = ACTIONS(7484),
    [anon_sym_AT] = ACTIONS(7484),
    [aux_sym__hex_literal_token1] = ACTIONS(7484),
    [sym__number_literal] = ACTIONS(7486),
    [anon_sym_SQUOTE] = ACTIONS(7484),
    [anon_sym_DQUOTE] = ACTIONS(7484),
    [sym_return] = ACTIONS(7486),
    [sym_next] = ACTIONS(7486),
    [sym_break] = ACTIONS(7486),
    [sym_true] = ACTIONS(7486),
    [sym_false] = ACTIONS(7486),
    [sym_null] = ACTIONS(7486),
    [sym_inf] = ACTIONS(7486),
    [sym_nan] = ACTIONS(7486),
    [anon_sym_NA] = ACTIONS(7486),
    [anon_sym_NA_integer_] = ACTIONS(7486),
    [anon_sym_NA_real_] = ACTIONS(7486),
    [anon_sym_NA_complex_] = ACTIONS(7486),
    [anon_sym_NA_character_] = ACTIONS(7486),
    [sym_dots] = ACTIONS(7486),
    [sym_dot_dot_i] = ACTIONS(7484),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7484),
    [sym__newline] = ACTIONS(7484),
    [sym__raw_string_literal] = ACTIONS(7484),
    [sym__external_else] = ACTIONS(7484),
    [sym__external_open_parenthesis] = ACTIONS(7484),
    [sym__external_close_parenthesis] = ACTIONS(7484),
    [sym__external_open_brace] = ACTIONS(7484),
    [sym__external_open_bracket] = ACTIONS(7484),
    [sym__external_open_bracket2] = ACTIONS(7484),
  },
  [2788] = {
    [sym_identifier] = ACTIONS(7498),
    [anon_sym_BSLASH] = ACTIONS(7496),
    [anon_sym_function] = ACTIONS(7498),
    [anon_sym_EQ] = ACTIONS(7498),
    [anon_sym_if] = ACTIONS(7498),
    [anon_sym_for] = ACTIONS(7498),
    [anon_sym_while] = ACTIONS(7498),
    [anon_sym_repeat] = ACTIONS(7498),
    [anon_sym_QMARK] = ACTIONS(7496),
    [anon_sym_TILDE] = ACTIONS(7496),
    [anon_sym_BANG] = ACTIONS(7498),
    [anon_sym_PLUS] = ACTIONS(7496),
    [anon_sym_DASH] = ACTIONS(7498),
    [anon_sym_LT_DASH] = ACTIONS(7496),
    [anon_sym_LT_LT_DASH] = ACTIONS(7496),
    [anon_sym_COLON_EQ] = ACTIONS(7496),
    [anon_sym_DASH_GT] = ACTIONS(7498),
    [anon_sym_DASH_GT_GT] = ACTIONS(7496),
    [anon_sym_PIPE] = ACTIONS(7498),
    [anon_sym_AMP] = ACTIONS(7498),
    [anon_sym_PIPE_PIPE] = ACTIONS(7496),
    [anon_sym_AMP_AMP] = ACTIONS(7496),
    [anon_sym_LT] = ACTIONS(7498),
    [anon_sym_LT_EQ] = ACTIONS(7496),
    [anon_sym_GT] = ACTIONS(7498),
    [anon_sym_GT_EQ] = ACTIONS(7496),
    [anon_sym_EQ_EQ] = ACTIONS(7496),
    [anon_sym_BANG_EQ] = ACTIONS(7496),
    [anon_sym_STAR] = ACTIONS(7498),
    [anon_sym_SLASH] = ACTIONS(7496),
    [anon_sym_STAR_STAR] = ACTIONS(7496),
    [anon_sym_CARET] = ACTIONS(7496),
    [aux_sym_binary_operator_token1] = ACTIONS(7496),
    [anon_sym_PIPE_GT] = ACTIONS(7496),
    [anon_sym_COLON] = ACTIONS(7498),
    [anon_sym_DOLLAR] = ACTIONS(7496),
    [anon_sym_AT] = ACTIONS(7496),
    [aux_sym__hex_literal_token1] = ACTIONS(7496),
    [sym__number_literal] = ACTIONS(7498),
    [anon_sym_SQUOTE] = ACTIONS(7496),
    [anon_sym_DQUOTE] = ACTIONS(7496),
    [sym_return] = ACTIONS(7498),
    [sym_next] = ACTIONS(7498),
    [sym_break] = ACTIONS(7498),
    [sym_true] = ACTIONS(7498),
    [sym_false] = ACTIONS(7498),
    [sym_null] = ACTIONS(7498),
    [sym_inf] = ACTIONS(7498),
    [sym_nan] = ACTIONS(7498),
    [anon_sym_NA] = ACTIONS(7498),
    [anon_sym_NA_integer_] = ACTIONS(7498),
    [anon_sym_NA_real_] = ACTIONS(7498),
    [anon_sym_NA_complex_] = ACTIONS(7498),
    [anon_sym_NA_character_] = ACTIONS(7498),
    [sym_dots] = ACTIONS(7498),
    [sym_dot_dot_i] = ACTIONS(7496),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7496),
    [sym__newline] = ACTIONS(7496),
    [sym__raw_string_literal] = ACTIONS(7496),
    [sym__external_open_parenthesis] = ACTIONS(7496),
    [sym__external_close_parenthesis] = ACTIONS(7496),
    [sym__external_open_brace] = ACTIONS(7496),
    [sym__external_open_bracket] = ACTIONS(7496),
    [sym__external_open_bracket2] = ACTIONS(7496),
    [sym__external_close_bracket2] = ACTIONS(7496),
  },
  [2789] = {
    [sym_identifier] = ACTIONS(7552),
    [anon_sym_BSLASH] = ACTIONS(7550),
    [anon_sym_function] = ACTIONS(7552),
    [anon_sym_EQ] = ACTIONS(7552),
    [anon_sym_if] = ACTIONS(7552),
    [anon_sym_for] = ACTIONS(7552),
    [anon_sym_while] = ACTIONS(7552),
    [anon_sym_repeat] = ACTIONS(7552),
    [anon_sym_QMARK] = ACTIONS(7550),
    [anon_sym_TILDE] = ACTIONS(7550),
    [anon_sym_BANG] = ACTIONS(7552),
    [anon_sym_PLUS] = ACTIONS(7550),
    [anon_sym_DASH] = ACTIONS(7552),
    [anon_sym_LT_DASH] = ACTIONS(7550),
    [anon_sym_LT_LT_DASH] = ACTIONS(7550),
    [anon_sym_COLON_EQ] = ACTIONS(7550),
    [anon_sym_DASH_GT] = ACTIONS(7552),
    [anon_sym_DASH_GT_GT] = ACTIONS(7550),
    [anon_sym_PIPE] = ACTIONS(7552),
    [anon_sym_AMP] = ACTIONS(7552),
    [anon_sym_PIPE_PIPE] = ACTIONS(7550),
    [anon_sym_AMP_AMP] = ACTIONS(7550),
    [anon_sym_LT] = ACTIONS(7552),
    [anon_sym_LT_EQ] = ACTIONS(7550),
    [anon_sym_GT] = ACTIONS(7552),
    [anon_sym_GT_EQ] = ACTIONS(7550),
    [anon_sym_EQ_EQ] = ACTIONS(7550),
    [anon_sym_BANG_EQ] = ACTIONS(7550),
    [anon_sym_STAR] = ACTIONS(7552),
    [anon_sym_SLASH] = ACTIONS(7550),
    [anon_sym_STAR_STAR] = ACTIONS(7550),
    [anon_sym_CARET] = ACTIONS(7550),
    [aux_sym_binary_operator_token1] = ACTIONS(7550),
    [anon_sym_PIPE_GT] = ACTIONS(7550),
    [anon_sym_COLON] = ACTIONS(7552),
    [anon_sym_DOLLAR] = ACTIONS(7550),
    [anon_sym_AT] = ACTIONS(7550),
    [aux_sym__hex_literal_token1] = ACTIONS(7550),
    [sym__number_literal] = ACTIONS(7552),
    [anon_sym_SQUOTE] = ACTIONS(7550),
    [anon_sym_DQUOTE] = ACTIONS(7550),
    [sym_return] = ACTIONS(7552),
    [sym_next] = ACTIONS(7552),
    [sym_break] = ACTIONS(7552),
    [sym_true] = ACTIONS(7552),
    [sym_false] = ACTIONS(7552),
    [sym_null] = ACTIONS(7552),
    [sym_inf] = ACTIONS(7552),
    [sym_nan] = ACTIONS(7552),
    [anon_sym_NA] = ACTIONS(7552),
    [anon_sym_NA_integer_] = ACTIONS(7552),
    [anon_sym_NA_real_] = ACTIONS(7552),
    [anon_sym_NA_complex_] = ACTIONS(7552),
    [anon_sym_NA_character_] = ACTIONS(7552),
    [sym_dots] = ACTIONS(7552),
    [sym_dot_dot_i] = ACTIONS(7550),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7550),
    [sym__newline] = ACTIONS(7550),
    [sym__raw_string_literal] = ACTIONS(7550),
    [sym__external_open_parenthesis] = ACTIONS(7550),
    [sym__external_close_parenthesis] = ACTIONS(7550),
    [sym__external_open_brace] = ACTIONS(7550),
    [sym__external_open_bracket] = ACTIONS(7550),
    [sym__external_close_bracket] = ACTIONS(7550),
    [sym__external_open_bracket2] = ACTIONS(7550),
  },
  [2790] = {
    [ts_builtin_sym_end] = ACTIONS(7518),
    [sym_identifier] = ACTIONS(7520),
    [anon_sym_BSLASH] = ACTIONS(7518),
    [anon_sym_function] = ACTIONS(7520),
    [anon_sym_EQ] = ACTIONS(7520),
    [anon_sym_if] = ACTIONS(7520),
    [anon_sym_for] = ACTIONS(7520),
    [anon_sym_while] = ACTIONS(7520),
    [anon_sym_repeat] = ACTIONS(7520),
    [anon_sym_QMARK] = ACTIONS(7518),
    [anon_sym_TILDE] = ACTIONS(7518),
    [anon_sym_BANG] = ACTIONS(7520),
    [anon_sym_PLUS] = ACTIONS(7518),
    [anon_sym_DASH] = ACTIONS(7520),
    [anon_sym_LT_DASH] = ACTIONS(7518),
    [anon_sym_LT_LT_DASH] = ACTIONS(7518),
    [anon_sym_COLON_EQ] = ACTIONS(7518),
    [anon_sym_DASH_GT] = ACTIONS(7520),
    [anon_sym_DASH_GT_GT] = ACTIONS(7518),
    [anon_sym_PIPE] = ACTIONS(7520),
    [anon_sym_AMP] = ACTIONS(7520),
    [anon_sym_PIPE_PIPE] = ACTIONS(7518),
    [anon_sym_AMP_AMP] = ACTIONS(7518),
    [anon_sym_LT] = ACTIONS(7520),
    [anon_sym_LT_EQ] = ACTIONS(7518),
    [anon_sym_GT] = ACTIONS(7520),
    [anon_sym_GT_EQ] = ACTIONS(7518),
    [anon_sym_EQ_EQ] = ACTIONS(7518),
    [anon_sym_BANG_EQ] = ACTIONS(7518),
    [anon_sym_STAR] = ACTIONS(7520),
    [anon_sym_SLASH] = ACTIONS(7518),
    [anon_sym_STAR_STAR] = ACTIONS(7518),
    [anon_sym_CARET] = ACTIONS(7518),
    [aux_sym_binary_operator_token1] = ACTIONS(7518),
    [anon_sym_PIPE_GT] = ACTIONS(7518),
    [anon_sym_COLON] = ACTIONS(7520),
    [anon_sym_DOLLAR] = ACTIONS(7518),
    [anon_sym_AT] = ACTIONS(7518),
    [aux_sym__hex_literal_token1] = ACTIONS(7518),
    [sym__number_literal] = ACTIONS(7520),
    [anon_sym_SQUOTE] = ACTIONS(7518),
    [anon_sym_DQUOTE] = ACTIONS(7518),
    [sym_return] = ACTIONS(7520),
    [sym_next] = ACTIONS(7520),
    [sym_break] = ACTIONS(7520),
    [sym_true] = ACTIONS(7520),
    [sym_false] = ACTIONS(7520),
    [sym_null] = ACTIONS(7520),
    [sym_inf] = ACTIONS(7520),
    [sym_nan] = ACTIONS(7520),
    [anon_sym_NA] = ACTIONS(7520),
    [anon_sym_NA_integer_] = ACTIONS(7520),
    [anon_sym_NA_real_] = ACTIONS(7520),
    [anon_sym_NA_complex_] = ACTIONS(7520),
    [anon_sym_NA_character_] = ACTIONS(7520),
    [sym_dots] = ACTIONS(7520),
    [sym_dot_dot_i] = ACTIONS(7518),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7518),
    [sym__semicolon] = ACTIONS(7518),
    [sym__raw_string_literal] = ACTIONS(7518),
    [sym__external_open_parenthesis] = ACTIONS(7518),
    [sym__external_close_parenthesis] = ACTIONS(7518),
    [sym__external_open_brace] = ACTIONS(7518),
    [sym__external_open_bracket] = ACTIONS(7518),
    [sym__external_open_bracket2] = ACTIONS(7518),
  },
  [2791] = {
    [sym_identifier] = ACTIONS(7502),
    [anon_sym_BSLASH] = ACTIONS(7500),
    [anon_sym_function] = ACTIONS(7502),
    [anon_sym_EQ] = ACTIONS(7502),
    [anon_sym_if] = ACTIONS(7502),
    [anon_sym_for] = ACTIONS(7502),
    [anon_sym_while] = ACTIONS(7502),
    [anon_sym_repeat] = ACTIONS(7502),
    [anon_sym_QMARK] = ACTIONS(7500),
    [anon_sym_TILDE] = ACTIONS(7500),
    [anon_sym_BANG] = ACTIONS(7502),
    [anon_sym_PLUS] = ACTIONS(7500),
    [anon_sym_DASH] = ACTIONS(7502),
    [anon_sym_LT_DASH] = ACTIONS(7500),
    [anon_sym_LT_LT_DASH] = ACTIONS(7500),
    [anon_sym_COLON_EQ] = ACTIONS(7500),
    [anon_sym_DASH_GT] = ACTIONS(7502),
    [anon_sym_DASH_GT_GT] = ACTIONS(7500),
    [anon_sym_PIPE] = ACTIONS(7502),
    [anon_sym_AMP] = ACTIONS(7502),
    [anon_sym_PIPE_PIPE] = ACTIONS(7500),
    [anon_sym_AMP_AMP] = ACTIONS(7500),
    [anon_sym_LT] = ACTIONS(7502),
    [anon_sym_LT_EQ] = ACTIONS(7500),
    [anon_sym_GT] = ACTIONS(7502),
    [anon_sym_GT_EQ] = ACTIONS(7500),
    [anon_sym_EQ_EQ] = ACTIONS(7500),
    [anon_sym_BANG_EQ] = ACTIONS(7500),
    [anon_sym_STAR] = ACTIONS(7502),
    [anon_sym_SLASH] = ACTIONS(7500),
    [anon_sym_STAR_STAR] = ACTIONS(7500),
    [anon_sym_CARET] = ACTIONS(7500),
    [aux_sym_binary_operator_token1] = ACTIONS(7500),
    [anon_sym_PIPE_GT] = ACTIONS(7500),
    [anon_sym_COLON] = ACTIONS(7502),
    [anon_sym_DOLLAR] = ACTIONS(7500),
    [anon_sym_AT] = ACTIONS(7500),
    [aux_sym__hex_literal_token1] = ACTIONS(7500),
    [sym__number_literal] = ACTIONS(7502),
    [anon_sym_SQUOTE] = ACTIONS(7500),
    [anon_sym_DQUOTE] = ACTIONS(7500),
    [sym_return] = ACTIONS(7502),
    [sym_next] = ACTIONS(7502),
    [sym_break] = ACTIONS(7502),
    [sym_true] = ACTIONS(7502),
    [sym_false] = ACTIONS(7502),
    [sym_null] = ACTIONS(7502),
    [sym_inf] = ACTIONS(7502),
    [sym_nan] = ACTIONS(7502),
    [anon_sym_NA] = ACTIONS(7502),
    [anon_sym_NA_integer_] = ACTIONS(7502),
    [anon_sym_NA_real_] = ACTIONS(7502),
    [anon_sym_NA_complex_] = ACTIONS(7502),
    [anon_sym_NA_character_] = ACTIONS(7502),
    [sym_dots] = ACTIONS(7502),
    [sym_dot_dot_i] = ACTIONS(7500),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7500),
    [sym__newline] = ACTIONS(7500),
    [sym__raw_string_literal] = ACTIONS(7500),
    [sym__external_open_parenthesis] = ACTIONS(7500),
    [sym__external_close_parenthesis] = ACTIONS(7500),
    [sym__external_open_brace] = ACTIONS(7500),
    [sym__external_open_bracket] = ACTIONS(7500),
    [sym__external_open_bracket2] = ACTIONS(7500),
    [sym__external_close_bracket2] = ACTIONS(7500),
  },
  [2792] = {
    [ts_builtin_sym_end] = ACTIONS(7476),
    [sym_identifier] = ACTIONS(7478),
    [anon_sym_BSLASH] = ACTIONS(7476),
    [anon_sym_function] = ACTIONS(7478),
    [anon_sym_EQ] = ACTIONS(7478),
    [anon_sym_if] = ACTIONS(7478),
    [anon_sym_for] = ACTIONS(7478),
    [anon_sym_while] = ACTIONS(7478),
    [anon_sym_repeat] = ACTIONS(7478),
    [anon_sym_QMARK] = ACTIONS(7476),
    [anon_sym_TILDE] = ACTIONS(7476),
    [anon_sym_BANG] = ACTIONS(7478),
    [anon_sym_PLUS] = ACTIONS(7476),
    [anon_sym_DASH] = ACTIONS(7478),
    [anon_sym_LT_DASH] = ACTIONS(7476),
    [anon_sym_LT_LT_DASH] = ACTIONS(7476),
    [anon_sym_COLON_EQ] = ACTIONS(7476),
    [anon_sym_DASH_GT] = ACTIONS(7478),
    [anon_sym_DASH_GT_GT] = ACTIONS(7476),
    [anon_sym_PIPE] = ACTIONS(7478),
    [anon_sym_AMP] = ACTIONS(7478),
    [anon_sym_PIPE_PIPE] = ACTIONS(7476),
    [anon_sym_AMP_AMP] = ACTIONS(7476),
    [anon_sym_LT] = ACTIONS(7478),
    [anon_sym_LT_EQ] = ACTIONS(7476),
    [anon_sym_GT] = ACTIONS(7478),
    [anon_sym_GT_EQ] = ACTIONS(7476),
    [anon_sym_EQ_EQ] = ACTIONS(7476),
    [anon_sym_BANG_EQ] = ACTIONS(7476),
    [anon_sym_STAR] = ACTIONS(7478),
    [anon_sym_SLASH] = ACTIONS(7476),
    [anon_sym_STAR_STAR] = ACTIONS(7476),
    [anon_sym_CARET] = ACTIONS(7476),
    [aux_sym_binary_operator_token1] = ACTIONS(7476),
    [anon_sym_PIPE_GT] = ACTIONS(7476),
    [anon_sym_COLON] = ACTIONS(7478),
    [anon_sym_DOLLAR] = ACTIONS(7476),
    [anon_sym_AT] = ACTIONS(7476),
    [aux_sym__hex_literal_token1] = ACTIONS(7476),
    [sym__number_literal] = ACTIONS(7478),
    [anon_sym_SQUOTE] = ACTIONS(7476),
    [anon_sym_DQUOTE] = ACTIONS(7476),
    [sym_return] = ACTIONS(7478),
    [sym_next] = ACTIONS(7478),
    [sym_break] = ACTIONS(7478),
    [sym_true] = ACTIONS(7478),
    [sym_false] = ACTIONS(7478),
    [sym_null] = ACTIONS(7478),
    [sym_inf] = ACTIONS(7478),
    [sym_nan] = ACTIONS(7478),
    [anon_sym_NA] = ACTIONS(7478),
    [anon_sym_NA_integer_] = ACTIONS(7478),
    [anon_sym_NA_real_] = ACTIONS(7478),
    [anon_sym_NA_complex_] = ACTIONS(7478),
    [anon_sym_NA_character_] = ACTIONS(7478),
    [sym_dots] = ACTIONS(7478),
    [sym_dot_dot_i] = ACTIONS(7476),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7476),
    [sym__semicolon] = ACTIONS(7476),
    [sym__raw_string_literal] = ACTIONS(7476),
    [sym__external_else] = ACTIONS(7476),
    [sym__external_open_parenthesis] = ACTIONS(7476),
    [sym__external_open_brace] = ACTIONS(7476),
    [sym__external_open_bracket] = ACTIONS(7476),
    [sym__external_open_bracket2] = ACTIONS(7476),
  },
  [2793] = {
    [sym_identifier] = ACTIONS(7544),
    [anon_sym_BSLASH] = ACTIONS(7542),
    [anon_sym_function] = ACTIONS(7544),
    [anon_sym_EQ] = ACTIONS(7544),
    [anon_sym_if] = ACTIONS(7544),
    [anon_sym_for] = ACTIONS(7544),
    [anon_sym_while] = ACTIONS(7544),
    [anon_sym_repeat] = ACTIONS(7544),
    [anon_sym_QMARK] = ACTIONS(7542),
    [anon_sym_TILDE] = ACTIONS(7542),
    [anon_sym_BANG] = ACTIONS(7544),
    [anon_sym_PLUS] = ACTIONS(7542),
    [anon_sym_DASH] = ACTIONS(7544),
    [anon_sym_LT_DASH] = ACTIONS(7542),
    [anon_sym_LT_LT_DASH] = ACTIONS(7542),
    [anon_sym_COLON_EQ] = ACTIONS(7542),
    [anon_sym_DASH_GT] = ACTIONS(7544),
    [anon_sym_DASH_GT_GT] = ACTIONS(7542),
    [anon_sym_PIPE] = ACTIONS(7544),
    [anon_sym_AMP] = ACTIONS(7544),
    [anon_sym_PIPE_PIPE] = ACTIONS(7542),
    [anon_sym_AMP_AMP] = ACTIONS(7542),
    [anon_sym_LT] = ACTIONS(7544),
    [anon_sym_LT_EQ] = ACTIONS(7542),
    [anon_sym_GT] = ACTIONS(7544),
    [anon_sym_GT_EQ] = ACTIONS(7542),
    [anon_sym_EQ_EQ] = ACTIONS(7542),
    [anon_sym_BANG_EQ] = ACTIONS(7542),
    [anon_sym_STAR] = ACTIONS(7544),
    [anon_sym_SLASH] = ACTIONS(7542),
    [anon_sym_STAR_STAR] = ACTIONS(7542),
    [anon_sym_CARET] = ACTIONS(7542),
    [aux_sym_binary_operator_token1] = ACTIONS(7542),
    [anon_sym_PIPE_GT] = ACTIONS(7542),
    [anon_sym_COLON] = ACTIONS(7544),
    [anon_sym_DOLLAR] = ACTIONS(7542),
    [anon_sym_AT] = ACTIONS(7542),
    [aux_sym__hex_literal_token1] = ACTIONS(7542),
    [sym__number_literal] = ACTIONS(7544),
    [anon_sym_SQUOTE] = ACTIONS(7542),
    [anon_sym_DQUOTE] = ACTIONS(7542),
    [sym_return] = ACTIONS(7544),
    [sym_next] = ACTIONS(7544),
    [sym_break] = ACTIONS(7544),
    [sym_true] = ACTIONS(7544),
    [sym_false] = ACTIONS(7544),
    [sym_null] = ACTIONS(7544),
    [sym_inf] = ACTIONS(7544),
    [sym_nan] = ACTIONS(7544),
    [anon_sym_NA] = ACTIONS(7544),
    [anon_sym_NA_integer_] = ACTIONS(7544),
    [anon_sym_NA_real_] = ACTIONS(7544),
    [anon_sym_NA_complex_] = ACTIONS(7544),
    [anon_sym_NA_character_] = ACTIONS(7544),
    [sym_dots] = ACTIONS(7544),
    [sym_dot_dot_i] = ACTIONS(7542),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7542),
    [sym__newline] = ACTIONS(7542),
    [sym__raw_string_literal] = ACTIONS(7542),
    [sym__external_open_parenthesis] = ACTIONS(7542),
    [sym__external_close_parenthesis] = ACTIONS(7542),
    [sym__external_open_brace] = ACTIONS(7542),
    [sym__external_open_bracket] = ACTIONS(7542),
    [sym__external_close_bracket] = ACTIONS(7542),
    [sym__external_open_bracket2] = ACTIONS(7542),
  },
  [2794] = {
    [sym_identifier] = ACTIONS(7474),
    [anon_sym_BSLASH] = ACTIONS(7472),
    [anon_sym_function] = ACTIONS(7474),
    [anon_sym_EQ] = ACTIONS(7474),
    [anon_sym_if] = ACTIONS(7474),
    [anon_sym_for] = ACTIONS(7474),
    [anon_sym_while] = ACTIONS(7474),
    [anon_sym_repeat] = ACTIONS(7474),
    [anon_sym_QMARK] = ACTIONS(7472),
    [anon_sym_TILDE] = ACTIONS(7472),
    [anon_sym_BANG] = ACTIONS(7474),
    [anon_sym_PLUS] = ACTIONS(7472),
    [anon_sym_DASH] = ACTIONS(7474),
    [anon_sym_LT_DASH] = ACTIONS(7472),
    [anon_sym_LT_LT_DASH] = ACTIONS(7472),
    [anon_sym_COLON_EQ] = ACTIONS(7472),
    [anon_sym_DASH_GT] = ACTIONS(7474),
    [anon_sym_DASH_GT_GT] = ACTIONS(7472),
    [anon_sym_PIPE] = ACTIONS(7474),
    [anon_sym_AMP] = ACTIONS(7474),
    [anon_sym_PIPE_PIPE] = ACTIONS(7472),
    [anon_sym_AMP_AMP] = ACTIONS(7472),
    [anon_sym_LT] = ACTIONS(7474),
    [anon_sym_LT_EQ] = ACTIONS(7472),
    [anon_sym_GT] = ACTIONS(7474),
    [anon_sym_GT_EQ] = ACTIONS(7472),
    [anon_sym_EQ_EQ] = ACTIONS(7472),
    [anon_sym_BANG_EQ] = ACTIONS(7472),
    [anon_sym_STAR] = ACTIONS(7474),
    [anon_sym_SLASH] = ACTIONS(7472),
    [anon_sym_STAR_STAR] = ACTIONS(7472),
    [anon_sym_CARET] = ACTIONS(7472),
    [aux_sym_binary_operator_token1] = ACTIONS(7472),
    [anon_sym_PIPE_GT] = ACTIONS(7472),
    [anon_sym_COLON] = ACTIONS(7474),
    [anon_sym_DOLLAR] = ACTIONS(7472),
    [anon_sym_AT] = ACTIONS(7472),
    [aux_sym__hex_literal_token1] = ACTIONS(7472),
    [sym__number_literal] = ACTIONS(7474),
    [anon_sym_SQUOTE] = ACTIONS(7472),
    [anon_sym_DQUOTE] = ACTIONS(7472),
    [sym_return] = ACTIONS(7474),
    [sym_next] = ACTIONS(7474),
    [sym_break] = ACTIONS(7474),
    [sym_true] = ACTIONS(7474),
    [sym_false] = ACTIONS(7474),
    [sym_null] = ACTIONS(7474),
    [sym_inf] = ACTIONS(7474),
    [sym_nan] = ACTIONS(7474),
    [anon_sym_NA] = ACTIONS(7474),
    [anon_sym_NA_integer_] = ACTIONS(7474),
    [anon_sym_NA_real_] = ACTIONS(7474),
    [anon_sym_NA_complex_] = ACTIONS(7474),
    [anon_sym_NA_character_] = ACTIONS(7474),
    [sym_dots] = ACTIONS(7474),
    [sym_dot_dot_i] = ACTIONS(7472),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7472),
    [sym__newline] = ACTIONS(7472),
    [sym__raw_string_literal] = ACTIONS(7472),
    [sym__external_else] = ACTIONS(7472),
    [sym__external_open_parenthesis] = ACTIONS(7472),
    [sym__external_open_brace] = ACTIONS(7472),
    [sym__external_open_bracket] = ACTIONS(7472),
    [sym__external_open_bracket2] = ACTIONS(7472),
    [sym__external_close_bracket2] = ACTIONS(7472),
  },
  [2795] = {
    [sym_identifier] = ACTIONS(7464),
    [anon_sym_BSLASH] = ACTIONS(7466),
    [anon_sym_function] = ACTIONS(7464),
    [anon_sym_EQ] = ACTIONS(7464),
    [anon_sym_if] = ACTIONS(7464),
    [anon_sym_for] = ACTIONS(7464),
    [anon_sym_while] = ACTIONS(7464),
    [anon_sym_repeat] = ACTIONS(7464),
    [anon_sym_QMARK] = ACTIONS(7466),
    [anon_sym_TILDE] = ACTIONS(7466),
    [anon_sym_BANG] = ACTIONS(7464),
    [anon_sym_PLUS] = ACTIONS(7466),
    [anon_sym_DASH] = ACTIONS(7464),
    [anon_sym_LT_DASH] = ACTIONS(7466),
    [anon_sym_LT_LT_DASH] = ACTIONS(7466),
    [anon_sym_COLON_EQ] = ACTIONS(7466),
    [anon_sym_DASH_GT] = ACTIONS(7464),
    [anon_sym_DASH_GT_GT] = ACTIONS(7466),
    [anon_sym_PIPE] = ACTIONS(7464),
    [anon_sym_AMP] = ACTIONS(7464),
    [anon_sym_PIPE_PIPE] = ACTIONS(7466),
    [anon_sym_AMP_AMP] = ACTIONS(7466),
    [anon_sym_LT] = ACTIONS(7464),
    [anon_sym_LT_EQ] = ACTIONS(7466),
    [anon_sym_GT] = ACTIONS(7464),
    [anon_sym_GT_EQ] = ACTIONS(7466),
    [anon_sym_EQ_EQ] = ACTIONS(7466),
    [anon_sym_BANG_EQ] = ACTIONS(7466),
    [anon_sym_STAR] = ACTIONS(7464),
    [anon_sym_SLASH] = ACTIONS(7466),
    [anon_sym_STAR_STAR] = ACTIONS(7466),
    [anon_sym_CARET] = ACTIONS(7466),
    [aux_sym_binary_operator_token1] = ACTIONS(7466),
    [anon_sym_PIPE_GT] = ACTIONS(7466),
    [anon_sym_COLON] = ACTIONS(7464),
    [anon_sym_DOLLAR] = ACTIONS(7466),
    [anon_sym_AT] = ACTIONS(7466),
    [aux_sym__hex_literal_token1] = ACTIONS(7466),
    [sym__number_literal] = ACTIONS(7464),
    [anon_sym_SQUOTE] = ACTIONS(7466),
    [anon_sym_DQUOTE] = ACTIONS(7466),
    [sym_return] = ACTIONS(7464),
    [sym_next] = ACTIONS(7464),
    [sym_break] = ACTIONS(7464),
    [sym_true] = ACTIONS(7464),
    [sym_false] = ACTIONS(7464),
    [sym_null] = ACTIONS(7464),
    [sym_inf] = ACTIONS(7464),
    [sym_nan] = ACTIONS(7464),
    [anon_sym_NA] = ACTIONS(7464),
    [anon_sym_NA_integer_] = ACTIONS(7464),
    [anon_sym_NA_real_] = ACTIONS(7464),
    [anon_sym_NA_complex_] = ACTIONS(7464),
    [anon_sym_NA_character_] = ACTIONS(7464),
    [sym_dots] = ACTIONS(7464),
    [sym_dot_dot_i] = ACTIONS(7466),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7466),
    [sym__newline] = ACTIONS(7466),
    [sym__raw_string_literal] = ACTIONS(7466),
    [sym__external_else] = ACTIONS(7466),
    [sym__external_open_parenthesis] = ACTIONS(7466),
    [sym__external_open_brace] = ACTIONS(7466),
    [sym__external_open_bracket] = ACTIONS(7466),
    [sym__external_open_bracket2] = ACTIONS(7466),
    [sym__external_close_bracket2] = ACTIONS(7466),
  },
  [2796] = {
    [sym_identifier] = ACTIONS(7478),
    [anon_sym_BSLASH] = ACTIONS(7476),
    [anon_sym_function] = ACTIONS(7478),
    [anon_sym_EQ] = ACTIONS(7478),
    [anon_sym_if] = ACTIONS(7478),
    [anon_sym_for] = ACTIONS(7478),
    [anon_sym_while] = ACTIONS(7478),
    [anon_sym_repeat] = ACTIONS(7478),
    [anon_sym_QMARK] = ACTIONS(7476),
    [anon_sym_TILDE] = ACTIONS(7476),
    [anon_sym_BANG] = ACTIONS(7478),
    [anon_sym_PLUS] = ACTIONS(7476),
    [anon_sym_DASH] = ACTIONS(7478),
    [anon_sym_LT_DASH] = ACTIONS(7476),
    [anon_sym_LT_LT_DASH] = ACTIONS(7476),
    [anon_sym_COLON_EQ] = ACTIONS(7476),
    [anon_sym_DASH_GT] = ACTIONS(7478),
    [anon_sym_DASH_GT_GT] = ACTIONS(7476),
    [anon_sym_PIPE] = ACTIONS(7478),
    [anon_sym_AMP] = ACTIONS(7478),
    [anon_sym_PIPE_PIPE] = ACTIONS(7476),
    [anon_sym_AMP_AMP] = ACTIONS(7476),
    [anon_sym_LT] = ACTIONS(7478),
    [anon_sym_LT_EQ] = ACTIONS(7476),
    [anon_sym_GT] = ACTIONS(7478),
    [anon_sym_GT_EQ] = ACTIONS(7476),
    [anon_sym_EQ_EQ] = ACTIONS(7476),
    [anon_sym_BANG_EQ] = ACTIONS(7476),
    [anon_sym_STAR] = ACTIONS(7478),
    [anon_sym_SLASH] = ACTIONS(7476),
    [anon_sym_STAR_STAR] = ACTIONS(7476),
    [anon_sym_CARET] = ACTIONS(7476),
    [aux_sym_binary_operator_token1] = ACTIONS(7476),
    [anon_sym_PIPE_GT] = ACTIONS(7476),
    [anon_sym_COLON] = ACTIONS(7478),
    [anon_sym_DOLLAR] = ACTIONS(7476),
    [anon_sym_AT] = ACTIONS(7476),
    [aux_sym__hex_literal_token1] = ACTIONS(7476),
    [sym__number_literal] = ACTIONS(7478),
    [anon_sym_SQUOTE] = ACTIONS(7476),
    [anon_sym_DQUOTE] = ACTIONS(7476),
    [sym_return] = ACTIONS(7478),
    [sym_next] = ACTIONS(7478),
    [sym_break] = ACTIONS(7478),
    [sym_true] = ACTIONS(7478),
    [sym_false] = ACTIONS(7478),
    [sym_null] = ACTIONS(7478),
    [sym_inf] = ACTIONS(7478),
    [sym_nan] = ACTIONS(7478),
    [anon_sym_NA] = ACTIONS(7478),
    [anon_sym_NA_integer_] = ACTIONS(7478),
    [anon_sym_NA_real_] = ACTIONS(7478),
    [anon_sym_NA_complex_] = ACTIONS(7478),
    [anon_sym_NA_character_] = ACTIONS(7478),
    [sym_dots] = ACTIONS(7478),
    [sym_dot_dot_i] = ACTIONS(7476),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7476),
    [sym__newline] = ACTIONS(7476),
    [sym__raw_string_literal] = ACTIONS(7476),
    [sym__external_else] = ACTIONS(7476),
    [sym__external_open_parenthesis] = ACTIONS(7476),
    [sym__external_open_brace] = ACTIONS(7476),
    [sym__external_open_bracket] = ACTIONS(7476),
    [sym__external_open_bracket2] = ACTIONS(7476),
    [sym__external_close_bracket2] = ACTIONS(7476),
  },
  [2797] = {
    [ts_builtin_sym_end] = ACTIONS(7526),
    [sym_identifier] = ACTIONS(7528),
    [anon_sym_BSLASH] = ACTIONS(7526),
    [anon_sym_function] = ACTIONS(7528),
    [anon_sym_EQ] = ACTIONS(7528),
    [anon_sym_if] = ACTIONS(7528),
    [anon_sym_for] = ACTIONS(7528),
    [anon_sym_while] = ACTIONS(7528),
    [anon_sym_repeat] = ACTIONS(7528),
    [anon_sym_QMARK] = ACTIONS(7526),
    [anon_sym_TILDE] = ACTIONS(7526),
    [anon_sym_BANG] = ACTIONS(7528),
    [anon_sym_PLUS] = ACTIONS(7526),
    [anon_sym_DASH] = ACTIONS(7528),
    [anon_sym_LT_DASH] = ACTIONS(7526),
    [anon_sym_LT_LT_DASH] = ACTIONS(7526),
    [anon_sym_COLON_EQ] = ACTIONS(7526),
    [anon_sym_DASH_GT] = ACTIONS(7528),
    [anon_sym_DASH_GT_GT] = ACTIONS(7526),
    [anon_sym_PIPE] = ACTIONS(7528),
    [anon_sym_AMP] = ACTIONS(7528),
    [anon_sym_PIPE_PIPE] = ACTIONS(7526),
    [anon_sym_AMP_AMP] = ACTIONS(7526),
    [anon_sym_LT] = ACTIONS(7528),
    [anon_sym_LT_EQ] = ACTIONS(7526),
    [anon_sym_GT] = ACTIONS(7528),
    [anon_sym_GT_EQ] = ACTIONS(7526),
    [anon_sym_EQ_EQ] = ACTIONS(7526),
    [anon_sym_BANG_EQ] = ACTIONS(7526),
    [anon_sym_STAR] = ACTIONS(7528),
    [anon_sym_SLASH] = ACTIONS(7526),
    [anon_sym_STAR_STAR] = ACTIONS(7526),
    [anon_sym_CARET] = ACTIONS(7526),
    [aux_sym_binary_operator_token1] = ACTIONS(7526),
    [anon_sym_PIPE_GT] = ACTIONS(7526),
    [anon_sym_COLON] = ACTIONS(7528),
    [anon_sym_DOLLAR] = ACTIONS(7526),
    [anon_sym_AT] = ACTIONS(7526),
    [aux_sym__hex_literal_token1] = ACTIONS(7526),
    [sym__number_literal] = ACTIONS(7528),
    [anon_sym_SQUOTE] = ACTIONS(7526),
    [anon_sym_DQUOTE] = ACTIONS(7526),
    [sym_return] = ACTIONS(7528),
    [sym_next] = ACTIONS(7528),
    [sym_break] = ACTIONS(7528),
    [sym_true] = ACTIONS(7528),
    [sym_false] = ACTIONS(7528),
    [sym_null] = ACTIONS(7528),
    [sym_inf] = ACTIONS(7528),
    [sym_nan] = ACTIONS(7528),
    [anon_sym_NA] = ACTIONS(7528),
    [anon_sym_NA_integer_] = ACTIONS(7528),
    [anon_sym_NA_real_] = ACTIONS(7528),
    [anon_sym_NA_complex_] = ACTIONS(7528),
    [anon_sym_NA_character_] = ACTIONS(7528),
    [sym_dots] = ACTIONS(7528),
    [sym_dot_dot_i] = ACTIONS(7526),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7526),
    [sym__semicolon] = ACTIONS(7526),
    [sym__raw_string_literal] = ACTIONS(7526),
    [sym__external_open_parenthesis] = ACTIONS(7526),
    [sym__external_open_brace] = ACTIONS(7526),
    [sym__external_close_brace] = ACTIONS(7526),
    [sym__external_open_bracket] = ACTIONS(7526),
    [sym__external_open_bracket2] = ACTIONS(7526),
  },
  [2798] = {
    [sym_identifier] = ACTIONS(7540),
    [anon_sym_BSLASH] = ACTIONS(7538),
    [anon_sym_function] = ACTIONS(7540),
    [anon_sym_EQ] = ACTIONS(7540),
    [anon_sym_if] = ACTIONS(7540),
    [anon_sym_for] = ACTIONS(7540),
    [anon_sym_while] = ACTIONS(7540),
    [anon_sym_repeat] = ACTIONS(7540),
    [anon_sym_QMARK] = ACTIONS(7538),
    [anon_sym_TILDE] = ACTIONS(7538),
    [anon_sym_BANG] = ACTIONS(7540),
    [anon_sym_PLUS] = ACTIONS(7538),
    [anon_sym_DASH] = ACTIONS(7540),
    [anon_sym_LT_DASH] = ACTIONS(7538),
    [anon_sym_LT_LT_DASH] = ACTIONS(7538),
    [anon_sym_COLON_EQ] = ACTIONS(7538),
    [anon_sym_DASH_GT] = ACTIONS(7540),
    [anon_sym_DASH_GT_GT] = ACTIONS(7538),
    [anon_sym_PIPE] = ACTIONS(7540),
    [anon_sym_AMP] = ACTIONS(7540),
    [anon_sym_PIPE_PIPE] = ACTIONS(7538),
    [anon_sym_AMP_AMP] = ACTIONS(7538),
    [anon_sym_LT] = ACTIONS(7540),
    [anon_sym_LT_EQ] = ACTIONS(7538),
    [anon_sym_GT] = ACTIONS(7540),
    [anon_sym_GT_EQ] = ACTIONS(7538),
    [anon_sym_EQ_EQ] = ACTIONS(7538),
    [anon_sym_BANG_EQ] = ACTIONS(7538),
    [anon_sym_STAR] = ACTIONS(7540),
    [anon_sym_SLASH] = ACTIONS(7538),
    [anon_sym_STAR_STAR] = ACTIONS(7538),
    [anon_sym_CARET] = ACTIONS(7538),
    [aux_sym_binary_operator_token1] = ACTIONS(7538),
    [anon_sym_PIPE_GT] = ACTIONS(7538),
    [anon_sym_COLON] = ACTIONS(7540),
    [anon_sym_DOLLAR] = ACTIONS(7538),
    [anon_sym_AT] = ACTIONS(7538),
    [aux_sym__hex_literal_token1] = ACTIONS(7538),
    [sym__number_literal] = ACTIONS(7540),
    [anon_sym_SQUOTE] = ACTIONS(7538),
    [anon_sym_DQUOTE] = ACTIONS(7538),
    [sym_return] = ACTIONS(7540),
    [sym_next] = ACTIONS(7540),
    [sym_break] = ACTIONS(7540),
    [sym_true] = ACTIONS(7540),
    [sym_false] = ACTIONS(7540),
    [sym_null] = ACTIONS(7540),
    [sym_inf] = ACTIONS(7540),
    [sym_nan] = ACTIONS(7540),
    [anon_sym_NA] = ACTIONS(7540),
    [anon_sym_NA_integer_] = ACTIONS(7540),
    [anon_sym_NA_real_] = ACTIONS(7540),
    [anon_sym_NA_complex_] = ACTIONS(7540),
    [anon_sym_NA_character_] = ACTIONS(7540),
    [sym_dots] = ACTIONS(7540),
    [sym_dot_dot_i] = ACTIONS(7538),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7538),
    [sym__newline] = ACTIONS(7538),
    [sym__raw_string_literal] = ACTIONS(7538),
    [sym__external_open_parenthesis] = ACTIONS(7538),
    [sym__external_close_parenthesis] = ACTIONS(7538),
    [sym__external_open_brace] = ACTIONS(7538),
    [sym__external_open_bracket] = ACTIONS(7538),
    [sym__external_close_bracket] = ACTIONS(7538),
    [sym__external_open_bracket2] = ACTIONS(7538),
  },
  [2799] = {
    [sym_identifier] = ACTIONS(7482),
    [anon_sym_BSLASH] = ACTIONS(7480),
    [anon_sym_function] = ACTIONS(7482),
    [anon_sym_EQ] = ACTIONS(7482),
    [anon_sym_if] = ACTIONS(7482),
    [anon_sym_for] = ACTIONS(7482),
    [anon_sym_while] = ACTIONS(7482),
    [anon_sym_repeat] = ACTIONS(7482),
    [anon_sym_QMARK] = ACTIONS(7480),
    [anon_sym_TILDE] = ACTIONS(7480),
    [anon_sym_BANG] = ACTIONS(7482),
    [anon_sym_PLUS] = ACTIONS(7480),
    [anon_sym_DASH] = ACTIONS(7482),
    [anon_sym_LT_DASH] = ACTIONS(7480),
    [anon_sym_LT_LT_DASH] = ACTIONS(7480),
    [anon_sym_COLON_EQ] = ACTIONS(7480),
    [anon_sym_DASH_GT] = ACTIONS(7482),
    [anon_sym_DASH_GT_GT] = ACTIONS(7480),
    [anon_sym_PIPE] = ACTIONS(7482),
    [anon_sym_AMP] = ACTIONS(7482),
    [anon_sym_PIPE_PIPE] = ACTIONS(7480),
    [anon_sym_AMP_AMP] = ACTIONS(7480),
    [anon_sym_LT] = ACTIONS(7482),
    [anon_sym_LT_EQ] = ACTIONS(7480),
    [anon_sym_GT] = ACTIONS(7482),
    [anon_sym_GT_EQ] = ACTIONS(7480),
    [anon_sym_EQ_EQ] = ACTIONS(7480),
    [anon_sym_BANG_EQ] = ACTIONS(7480),
    [anon_sym_STAR] = ACTIONS(7482),
    [anon_sym_SLASH] = ACTIONS(7480),
    [anon_sym_STAR_STAR] = ACTIONS(7480),
    [anon_sym_CARET] = ACTIONS(7480),
    [aux_sym_binary_operator_token1] = ACTIONS(7480),
    [anon_sym_PIPE_GT] = ACTIONS(7480),
    [anon_sym_COLON] = ACTIONS(7482),
    [anon_sym_DOLLAR] = ACTIONS(7480),
    [anon_sym_AT] = ACTIONS(7480),
    [aux_sym__hex_literal_token1] = ACTIONS(7480),
    [sym__number_literal] = ACTIONS(7482),
    [anon_sym_SQUOTE] = ACTIONS(7480),
    [anon_sym_DQUOTE] = ACTIONS(7480),
    [sym_return] = ACTIONS(7482),
    [sym_next] = ACTIONS(7482),
    [sym_break] = ACTIONS(7482),
    [sym_true] = ACTIONS(7482),
    [sym_false] = ACTIONS(7482),
    [sym_null] = ACTIONS(7482),
    [sym_inf] = ACTIONS(7482),
    [sym_nan] = ACTIONS(7482),
    [anon_sym_NA] = ACTIONS(7482),
    [anon_sym_NA_integer_] = ACTIONS(7482),
    [anon_sym_NA_real_] = ACTIONS(7482),
    [anon_sym_NA_complex_] = ACTIONS(7482),
    [anon_sym_NA_character_] = ACTIONS(7482),
    [sym_dots] = ACTIONS(7482),
    [sym_dot_dot_i] = ACTIONS(7480),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7480),
    [sym__newline] = ACTIONS(7480),
    [sym__raw_string_literal] = ACTIONS(7480),
    [sym__external_else] = ACTIONS(7480),
    [sym__external_open_parenthesis] = ACTIONS(7480),
    [sym__external_open_brace] = ACTIONS(7480),
    [sym__external_open_bracket] = ACTIONS(7480),
    [sym__external_open_bracket2] = ACTIONS(7480),
    [sym__external_close_bracket2] = ACTIONS(7480),
  },
  [2800] = {
    [sym_identifier] = ACTIONS(7556),
    [anon_sym_BSLASH] = ACTIONS(7554),
    [anon_sym_function] = ACTIONS(7556),
    [anon_sym_EQ] = ACTIONS(7556),
    [anon_sym_if] = ACTIONS(7556),
    [anon_sym_for] = ACTIONS(7556),
    [anon_sym_while] = ACTIONS(7556),
    [anon_sym_repeat] = ACTIONS(7556),
    [anon_sym_QMARK] = ACTIONS(7554),
    [anon_sym_TILDE] = ACTIONS(7554),
    [anon_sym_BANG] = ACTIONS(7556),
    [anon_sym_PLUS] = ACTIONS(7554),
    [anon_sym_DASH] = ACTIONS(7556),
    [anon_sym_LT_DASH] = ACTIONS(7554),
    [anon_sym_LT_LT_DASH] = ACTIONS(7554),
    [anon_sym_COLON_EQ] = ACTIONS(7554),
    [anon_sym_DASH_GT] = ACTIONS(7556),
    [anon_sym_DASH_GT_GT] = ACTIONS(7554),
    [anon_sym_PIPE] = ACTIONS(7556),
    [anon_sym_AMP] = ACTIONS(7556),
    [anon_sym_PIPE_PIPE] = ACTIONS(7554),
    [anon_sym_AMP_AMP] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(7556),
    [anon_sym_LT_EQ] = ACTIONS(7554),
    [anon_sym_GT] = ACTIONS(7556),
    [anon_sym_GT_EQ] = ACTIONS(7554),
    [anon_sym_EQ_EQ] = ACTIONS(7554),
    [anon_sym_BANG_EQ] = ACTIONS(7554),
    [anon_sym_STAR] = ACTIONS(7556),
    [anon_sym_SLASH] = ACTIONS(7554),
    [anon_sym_STAR_STAR] = ACTIONS(7554),
    [anon_sym_CARET] = ACTIONS(7554),
    [aux_sym_binary_operator_token1] = ACTIONS(7554),
    [anon_sym_PIPE_GT] = ACTIONS(7554),
    [anon_sym_COLON] = ACTIONS(7556),
    [anon_sym_DOLLAR] = ACTIONS(7554),
    [anon_sym_AT] = ACTIONS(7554),
    [aux_sym__hex_literal_token1] = ACTIONS(7554),
    [sym__number_literal] = ACTIONS(7556),
    [anon_sym_SQUOTE] = ACTIONS(7554),
    [anon_sym_DQUOTE] = ACTIONS(7554),
    [sym_return] = ACTIONS(7556),
    [sym_next] = ACTIONS(7556),
    [sym_break] = ACTIONS(7556),
    [sym_true] = ACTIONS(7556),
    [sym_false] = ACTIONS(7556),
    [sym_null] = ACTIONS(7556),
    [sym_inf] = ACTIONS(7556),
    [sym_nan] = ACTIONS(7556),
    [anon_sym_NA] = ACTIONS(7556),
    [anon_sym_NA_integer_] = ACTIONS(7556),
    [anon_sym_NA_real_] = ACTIONS(7556),
    [anon_sym_NA_complex_] = ACTIONS(7556),
    [anon_sym_NA_character_] = ACTIONS(7556),
    [sym_dots] = ACTIONS(7556),
    [sym_dot_dot_i] = ACTIONS(7554),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7554),
    [sym__newline] = ACTIONS(7554),
    [sym__raw_string_literal] = ACTIONS(7554),
    [sym__external_open_parenthesis] = ACTIONS(7554),
    [sym__external_close_parenthesis] = ACTIONS(7554),
    [sym__external_open_brace] = ACTIONS(7554),
    [sym__external_open_bracket] = ACTIONS(7554),
    [sym__external_close_bracket] = ACTIONS(7554),
    [sym__external_open_bracket2] = ACTIONS(7554),
  },
  [2801] = {
    [ts_builtin_sym_end] = ACTIONS(7522),
    [sym_identifier] = ACTIONS(7524),
    [anon_sym_BSLASH] = ACTIONS(7522),
    [anon_sym_function] = ACTIONS(7524),
    [anon_sym_EQ] = ACTIONS(7524),
    [anon_sym_if] = ACTIONS(7524),
    [anon_sym_for] = ACTIONS(7524),
    [anon_sym_while] = ACTIONS(7524),
    [anon_sym_repeat] = ACTIONS(7524),
    [anon_sym_QMARK] = ACTIONS(7522),
    [anon_sym_TILDE] = ACTIONS(7522),
    [anon_sym_BANG] = ACTIONS(7524),
    [anon_sym_PLUS] = ACTIONS(7522),
    [anon_sym_DASH] = ACTIONS(7524),
    [anon_sym_LT_DASH] = ACTIONS(7522),
    [anon_sym_LT_LT_DASH] = ACTIONS(7522),
    [anon_sym_COLON_EQ] = ACTIONS(7522),
    [anon_sym_DASH_GT] = ACTIONS(7524),
    [anon_sym_DASH_GT_GT] = ACTIONS(7522),
    [anon_sym_PIPE] = ACTIONS(7524),
    [anon_sym_AMP] = ACTIONS(7524),
    [anon_sym_PIPE_PIPE] = ACTIONS(7522),
    [anon_sym_AMP_AMP] = ACTIONS(7522),
    [anon_sym_LT] = ACTIONS(7524),
    [anon_sym_LT_EQ] = ACTIONS(7522),
    [anon_sym_GT] = ACTIONS(7524),
    [anon_sym_GT_EQ] = ACTIONS(7522),
    [anon_sym_EQ_EQ] = ACTIONS(7522),
    [anon_sym_BANG_EQ] = ACTIONS(7522),
    [anon_sym_STAR] = ACTIONS(7524),
    [anon_sym_SLASH] = ACTIONS(7522),
    [anon_sym_STAR_STAR] = ACTIONS(7522),
    [anon_sym_CARET] = ACTIONS(7522),
    [aux_sym_binary_operator_token1] = ACTIONS(7522),
    [anon_sym_PIPE_GT] = ACTIONS(7522),
    [anon_sym_COLON] = ACTIONS(7524),
    [anon_sym_DOLLAR] = ACTIONS(7522),
    [anon_sym_AT] = ACTIONS(7522),
    [aux_sym__hex_literal_token1] = ACTIONS(7522),
    [sym__number_literal] = ACTIONS(7524),
    [anon_sym_SQUOTE] = ACTIONS(7522),
    [anon_sym_DQUOTE] = ACTIONS(7522),
    [sym_return] = ACTIONS(7524),
    [sym_next] = ACTIONS(7524),
    [sym_break] = ACTIONS(7524),
    [sym_true] = ACTIONS(7524),
    [sym_false] = ACTIONS(7524),
    [sym_null] = ACTIONS(7524),
    [sym_inf] = ACTIONS(7524),
    [sym_nan] = ACTIONS(7524),
    [anon_sym_NA] = ACTIONS(7524),
    [anon_sym_NA_integer_] = ACTIONS(7524),
    [anon_sym_NA_real_] = ACTIONS(7524),
    [anon_sym_NA_complex_] = ACTIONS(7524),
    [anon_sym_NA_character_] = ACTIONS(7524),
    [sym_dots] = ACTIONS(7524),
    [sym_dot_dot_i] = ACTIONS(7522),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7522),
    [sym__semicolon] = ACTIONS(7522),
    [sym__raw_string_literal] = ACTIONS(7522),
    [sym__external_open_parenthesis] = ACTIONS(7522),
    [sym__external_open_brace] = ACTIONS(7522),
    [sym__external_close_brace] = ACTIONS(7522),
    [sym__external_open_bracket] = ACTIONS(7522),
    [sym__external_open_bracket2] = ACTIONS(7522),
  },
  [2802] = {
    [ts_builtin_sym_end] = ACTIONS(7484),
    [sym_identifier] = ACTIONS(7486),
    [anon_sym_BSLASH] = ACTIONS(7484),
    [anon_sym_function] = ACTIONS(7486),
    [anon_sym_EQ] = ACTIONS(7486),
    [anon_sym_if] = ACTIONS(7486),
    [anon_sym_for] = ACTIONS(7486),
    [anon_sym_while] = ACTIONS(7486),
    [anon_sym_repeat] = ACTIONS(7486),
    [anon_sym_QMARK] = ACTIONS(7484),
    [anon_sym_TILDE] = ACTIONS(7484),
    [anon_sym_BANG] = ACTIONS(7486),
    [anon_sym_PLUS] = ACTIONS(7484),
    [anon_sym_DASH] = ACTIONS(7486),
    [anon_sym_LT_DASH] = ACTIONS(7484),
    [anon_sym_LT_LT_DASH] = ACTIONS(7484),
    [anon_sym_COLON_EQ] = ACTIONS(7484),
    [anon_sym_DASH_GT] = ACTIONS(7486),
    [anon_sym_DASH_GT_GT] = ACTIONS(7484),
    [anon_sym_PIPE] = ACTIONS(7486),
    [anon_sym_AMP] = ACTIONS(7486),
    [anon_sym_PIPE_PIPE] = ACTIONS(7484),
    [anon_sym_AMP_AMP] = ACTIONS(7484),
    [anon_sym_LT] = ACTIONS(7486),
    [anon_sym_LT_EQ] = ACTIONS(7484),
    [anon_sym_GT] = ACTIONS(7486),
    [anon_sym_GT_EQ] = ACTIONS(7484),
    [anon_sym_EQ_EQ] = ACTIONS(7484),
    [anon_sym_BANG_EQ] = ACTIONS(7484),
    [anon_sym_STAR] = ACTIONS(7486),
    [anon_sym_SLASH] = ACTIONS(7484),
    [anon_sym_STAR_STAR] = ACTIONS(7484),
    [anon_sym_CARET] = ACTIONS(7484),
    [aux_sym_binary_operator_token1] = ACTIONS(7484),
    [anon_sym_PIPE_GT] = ACTIONS(7484),
    [anon_sym_COLON] = ACTIONS(7486),
    [anon_sym_DOLLAR] = ACTIONS(7484),
    [anon_sym_AT] = ACTIONS(7484),
    [aux_sym__hex_literal_token1] = ACTIONS(7484),
    [sym__number_literal] = ACTIONS(7486),
    [anon_sym_SQUOTE] = ACTIONS(7484),
    [anon_sym_DQUOTE] = ACTIONS(7484),
    [sym_return] = ACTIONS(7486),
    [sym_next] = ACTIONS(7486),
    [sym_break] = ACTIONS(7486),
    [sym_true] = ACTIONS(7486),
    [sym_false] = ACTIONS(7486),
    [sym_null] = ACTIONS(7486),
    [sym_inf] = ACTIONS(7486),
    [sym_nan] = ACTIONS(7486),
    [anon_sym_NA] = ACTIONS(7486),
    [anon_sym_NA_integer_] = ACTIONS(7486),
    [anon_sym_NA_real_] = ACTIONS(7486),
    [anon_sym_NA_complex_] = ACTIONS(7486),
    [anon_sym_NA_character_] = ACTIONS(7486),
    [sym_dots] = ACTIONS(7486),
    [sym_dot_dot_i] = ACTIONS(7484),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7484),
    [sym__semicolon] = ACTIONS(7484),
    [sym__raw_string_literal] = ACTIONS(7484),
    [sym__external_else] = ACTIONS(7484),
    [sym__external_open_parenthesis] = ACTIONS(7484),
    [sym__external_open_brace] = ACTIONS(7484),
    [sym__external_open_bracket] = ACTIONS(7484),
    [sym__external_open_bracket2] = ACTIONS(7484),
  },
  [2803] = {
    [ts_builtin_sym_end] = ACTIONS(7488),
    [sym_identifier] = ACTIONS(7490),
    [anon_sym_BSLASH] = ACTIONS(7488),
    [anon_sym_function] = ACTIONS(7490),
    [anon_sym_EQ] = ACTIONS(7490),
    [anon_sym_if] = ACTIONS(7490),
    [anon_sym_for] = ACTIONS(7490),
    [anon_sym_while] = ACTIONS(7490),
    [anon_sym_repeat] = ACTIONS(7490),
    [anon_sym_QMARK] = ACTIONS(7488),
    [anon_sym_TILDE] = ACTIONS(7488),
    [anon_sym_BANG] = ACTIONS(7490),
    [anon_sym_PLUS] = ACTIONS(7488),
    [anon_sym_DASH] = ACTIONS(7490),
    [anon_sym_LT_DASH] = ACTIONS(7488),
    [anon_sym_LT_LT_DASH] = ACTIONS(7488),
    [anon_sym_COLON_EQ] = ACTIONS(7488),
    [anon_sym_DASH_GT] = ACTIONS(7490),
    [anon_sym_DASH_GT_GT] = ACTIONS(7488),
    [anon_sym_PIPE] = ACTIONS(7490),
    [anon_sym_AMP] = ACTIONS(7490),
    [anon_sym_PIPE_PIPE] = ACTIONS(7488),
    [anon_sym_AMP_AMP] = ACTIONS(7488),
    [anon_sym_LT] = ACTIONS(7490),
    [anon_sym_LT_EQ] = ACTIONS(7488),
    [anon_sym_GT] = ACTIONS(7490),
    [anon_sym_GT_EQ] = ACTIONS(7488),
    [anon_sym_EQ_EQ] = ACTIONS(7488),
    [anon_sym_BANG_EQ] = ACTIONS(7488),
    [anon_sym_STAR] = ACTIONS(7490),
    [anon_sym_SLASH] = ACTIONS(7488),
    [anon_sym_STAR_STAR] = ACTIONS(7488),
    [anon_sym_CARET] = ACTIONS(7488),
    [aux_sym_binary_operator_token1] = ACTIONS(7488),
    [anon_sym_PIPE_GT] = ACTIONS(7488),
    [anon_sym_COLON] = ACTIONS(7490),
    [anon_sym_DOLLAR] = ACTIONS(7488),
    [anon_sym_AT] = ACTIONS(7488),
    [aux_sym__hex_literal_token1] = ACTIONS(7488),
    [sym__number_literal] = ACTIONS(7490),
    [anon_sym_SQUOTE] = ACTIONS(7488),
    [anon_sym_DQUOTE] = ACTIONS(7488),
    [sym_return] = ACTIONS(7490),
    [sym_next] = ACTIONS(7490),
    [sym_break] = ACTIONS(7490),
    [sym_true] = ACTIONS(7490),
    [sym_false] = ACTIONS(7490),
    [sym_null] = ACTIONS(7490),
    [sym_inf] = ACTIONS(7490),
    [sym_nan] = ACTIONS(7490),
    [anon_sym_NA] = ACTIONS(7490),
    [anon_sym_NA_integer_] = ACTIONS(7490),
    [anon_sym_NA_real_] = ACTIONS(7490),
    [anon_sym_NA_complex_] = ACTIONS(7490),
    [anon_sym_NA_character_] = ACTIONS(7490),
    [sym_dots] = ACTIONS(7490),
    [sym_dot_dot_i] = ACTIONS(7488),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7488),
    [sym__semicolon] = ACTIONS(7488),
    [sym__raw_string_literal] = ACTIONS(7488),
    [sym__external_else] = ACTIONS(7488),
    [sym__external_open_parenthesis] = ACTIONS(7488),
    [sym__external_open_brace] = ACTIONS(7488),
    [sym__external_open_bracket] = ACTIONS(7488),
    [sym__external_open_bracket2] = ACTIONS(7488),
  },
  [2804] = {
    [sym_identifier] = ACTIONS(7506),
    [anon_sym_BSLASH] = ACTIONS(7504),
    [anon_sym_function] = ACTIONS(7506),
    [anon_sym_EQ] = ACTIONS(7506),
    [anon_sym_if] = ACTIONS(7506),
    [anon_sym_for] = ACTIONS(7506),
    [anon_sym_while] = ACTIONS(7506),
    [anon_sym_repeat] = ACTIONS(7506),
    [anon_sym_QMARK] = ACTIONS(7504),
    [anon_sym_TILDE] = ACTIONS(7504),
    [anon_sym_BANG] = ACTIONS(7506),
    [anon_sym_PLUS] = ACTIONS(7504),
    [anon_sym_DASH] = ACTIONS(7506),
    [anon_sym_LT_DASH] = ACTIONS(7504),
    [anon_sym_LT_LT_DASH] = ACTIONS(7504),
    [anon_sym_COLON_EQ] = ACTIONS(7504),
    [anon_sym_DASH_GT] = ACTIONS(7506),
    [anon_sym_DASH_GT_GT] = ACTIONS(7504),
    [anon_sym_PIPE] = ACTIONS(7506),
    [anon_sym_AMP] = ACTIONS(7506),
    [anon_sym_PIPE_PIPE] = ACTIONS(7504),
    [anon_sym_AMP_AMP] = ACTIONS(7504),
    [anon_sym_LT] = ACTIONS(7506),
    [anon_sym_LT_EQ] = ACTIONS(7504),
    [anon_sym_GT] = ACTIONS(7506),
    [anon_sym_GT_EQ] = ACTIONS(7504),
    [anon_sym_EQ_EQ] = ACTIONS(7504),
    [anon_sym_BANG_EQ] = ACTIONS(7504),
    [anon_sym_STAR] = ACTIONS(7506),
    [anon_sym_SLASH] = ACTIONS(7504),
    [anon_sym_STAR_STAR] = ACTIONS(7504),
    [anon_sym_CARET] = ACTIONS(7504),
    [aux_sym_binary_operator_token1] = ACTIONS(7504),
    [anon_sym_PIPE_GT] = ACTIONS(7504),
    [anon_sym_COLON] = ACTIONS(7506),
    [anon_sym_DOLLAR] = ACTIONS(7504),
    [anon_sym_AT] = ACTIONS(7504),
    [aux_sym__hex_literal_token1] = ACTIONS(7504),
    [sym__number_literal] = ACTIONS(7506),
    [anon_sym_SQUOTE] = ACTIONS(7504),
    [anon_sym_DQUOTE] = ACTIONS(7504),
    [sym_return] = ACTIONS(7506),
    [sym_next] = ACTIONS(7506),
    [sym_break] = ACTIONS(7506),
    [sym_true] = ACTIONS(7506),
    [sym_false] = ACTIONS(7506),
    [sym_null] = ACTIONS(7506),
    [sym_inf] = ACTIONS(7506),
    [sym_nan] = ACTIONS(7506),
    [anon_sym_NA] = ACTIONS(7506),
    [anon_sym_NA_integer_] = ACTIONS(7506),
    [anon_sym_NA_real_] = ACTIONS(7506),
    [anon_sym_NA_complex_] = ACTIONS(7506),
    [anon_sym_NA_character_] = ACTIONS(7506),
    [sym_dots] = ACTIONS(7506),
    [sym_dot_dot_i] = ACTIONS(7504),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7504),
    [sym__newline] = ACTIONS(7504),
    [sym__raw_string_literal] = ACTIONS(7504),
    [sym__external_open_parenthesis] = ACTIONS(7504),
    [sym__external_close_parenthesis] = ACTIONS(7504),
    [sym__external_open_brace] = ACTIONS(7504),
    [sym__external_open_bracket] = ACTIONS(7504),
    [sym__external_open_bracket2] = ACTIONS(7504),
    [sym__external_close_bracket2] = ACTIONS(7504),
  },
  [2805] = {
    [ts_builtin_sym_end] = ACTIONS(7514),
    [sym_identifier] = ACTIONS(7516),
    [anon_sym_BSLASH] = ACTIONS(7514),
    [anon_sym_function] = ACTIONS(7516),
    [anon_sym_EQ] = ACTIONS(7516),
    [anon_sym_if] = ACTIONS(7516),
    [anon_sym_for] = ACTIONS(7516),
    [anon_sym_while] = ACTIONS(7516),
    [anon_sym_repeat] = ACTIONS(7516),
    [anon_sym_QMARK] = ACTIONS(7514),
    [anon_sym_TILDE] = ACTIONS(7514),
    [anon_sym_BANG] = ACTIONS(7516),
    [anon_sym_PLUS] = ACTIONS(7514),
    [anon_sym_DASH] = ACTIONS(7516),
    [anon_sym_LT_DASH] = ACTIONS(7514),
    [anon_sym_LT_LT_DASH] = ACTIONS(7514),
    [anon_sym_COLON_EQ] = ACTIONS(7514),
    [anon_sym_DASH_GT] = ACTIONS(7516),
    [anon_sym_DASH_GT_GT] = ACTIONS(7514),
    [anon_sym_PIPE] = ACTIONS(7516),
    [anon_sym_AMP] = ACTIONS(7516),
    [anon_sym_PIPE_PIPE] = ACTIONS(7514),
    [anon_sym_AMP_AMP] = ACTIONS(7514),
    [anon_sym_LT] = ACTIONS(7516),
    [anon_sym_LT_EQ] = ACTIONS(7514),
    [anon_sym_GT] = ACTIONS(7516),
    [anon_sym_GT_EQ] = ACTIONS(7514),
    [anon_sym_EQ_EQ] = ACTIONS(7514),
    [anon_sym_BANG_EQ] = ACTIONS(7514),
    [anon_sym_STAR] = ACTIONS(7516),
    [anon_sym_SLASH] = ACTIONS(7514),
    [anon_sym_STAR_STAR] = ACTIONS(7514),
    [anon_sym_CARET] = ACTIONS(7514),
    [aux_sym_binary_operator_token1] = ACTIONS(7514),
    [anon_sym_PIPE_GT] = ACTIONS(7514),
    [anon_sym_COLON] = ACTIONS(7516),
    [anon_sym_DOLLAR] = ACTIONS(7514),
    [anon_sym_AT] = ACTIONS(7514),
    [aux_sym__hex_literal_token1] = ACTIONS(7514),
    [sym__number_literal] = ACTIONS(7516),
    [anon_sym_SQUOTE] = ACTIONS(7514),
    [anon_sym_DQUOTE] = ACTIONS(7514),
    [sym_return] = ACTIONS(7516),
    [sym_next] = ACTIONS(7516),
    [sym_break] = ACTIONS(7516),
    [sym_true] = ACTIONS(7516),
    [sym_false] = ACTIONS(7516),
    [sym_null] = ACTIONS(7516),
    [sym_inf] = ACTIONS(7516),
    [sym_nan] = ACTIONS(7516),
    [anon_sym_NA] = ACTIONS(7516),
    [anon_sym_NA_integer_] = ACTIONS(7516),
    [anon_sym_NA_real_] = ACTIONS(7516),
    [anon_sym_NA_complex_] = ACTIONS(7516),
    [anon_sym_NA_character_] = ACTIONS(7516),
    [sym_dots] = ACTIONS(7516),
    [sym_dot_dot_i] = ACTIONS(7514),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7514),
    [sym__semicolon] = ACTIONS(7514),
    [sym__raw_string_literal] = ACTIONS(7514),
    [sym__external_open_parenthesis] = ACTIONS(7514),
    [sym__external_open_brace] = ACTIONS(7514),
    [sym__external_close_brace] = ACTIONS(7514),
    [sym__external_open_bracket] = ACTIONS(7514),
    [sym__external_open_bracket2] = ACTIONS(7514),
  },
  [2806] = {
    [sym_identifier] = ACTIONS(7544),
    [anon_sym_BSLASH] = ACTIONS(7542),
    [anon_sym_function] = ACTIONS(7544),
    [anon_sym_EQ] = ACTIONS(7544),
    [anon_sym_if] = ACTIONS(7544),
    [anon_sym_for] = ACTIONS(7544),
    [anon_sym_while] = ACTIONS(7544),
    [anon_sym_repeat] = ACTIONS(7544),
    [anon_sym_QMARK] = ACTIONS(7542),
    [anon_sym_TILDE] = ACTIONS(7542),
    [anon_sym_BANG] = ACTIONS(7544),
    [anon_sym_PLUS] = ACTIONS(7542),
    [anon_sym_DASH] = ACTIONS(7544),
    [anon_sym_LT_DASH] = ACTIONS(7542),
    [anon_sym_LT_LT_DASH] = ACTIONS(7542),
    [anon_sym_COLON_EQ] = ACTIONS(7542),
    [anon_sym_DASH_GT] = ACTIONS(7544),
    [anon_sym_DASH_GT_GT] = ACTIONS(7542),
    [anon_sym_PIPE] = ACTIONS(7544),
    [anon_sym_AMP] = ACTIONS(7544),
    [anon_sym_PIPE_PIPE] = ACTIONS(7542),
    [anon_sym_AMP_AMP] = ACTIONS(7542),
    [anon_sym_LT] = ACTIONS(7544),
    [anon_sym_LT_EQ] = ACTIONS(7542),
    [anon_sym_GT] = ACTIONS(7544),
    [anon_sym_GT_EQ] = ACTIONS(7542),
    [anon_sym_EQ_EQ] = ACTIONS(7542),
    [anon_sym_BANG_EQ] = ACTIONS(7542),
    [anon_sym_STAR] = ACTIONS(7544),
    [anon_sym_SLASH] = ACTIONS(7542),
    [anon_sym_STAR_STAR] = ACTIONS(7542),
    [anon_sym_CARET] = ACTIONS(7542),
    [aux_sym_binary_operator_token1] = ACTIONS(7542),
    [anon_sym_PIPE_GT] = ACTIONS(7542),
    [anon_sym_COLON] = ACTIONS(7544),
    [anon_sym_DOLLAR] = ACTIONS(7542),
    [anon_sym_AT] = ACTIONS(7542),
    [aux_sym__hex_literal_token1] = ACTIONS(7542),
    [sym__number_literal] = ACTIONS(7544),
    [anon_sym_SQUOTE] = ACTIONS(7542),
    [anon_sym_DQUOTE] = ACTIONS(7542),
    [sym_return] = ACTIONS(7544),
    [sym_next] = ACTIONS(7544),
    [sym_break] = ACTIONS(7544),
    [sym_true] = ACTIONS(7544),
    [sym_false] = ACTIONS(7544),
    [sym_null] = ACTIONS(7544),
    [sym_inf] = ACTIONS(7544),
    [sym_nan] = ACTIONS(7544),
    [anon_sym_NA] = ACTIONS(7544),
    [anon_sym_NA_integer_] = ACTIONS(7544),
    [anon_sym_NA_real_] = ACTIONS(7544),
    [anon_sym_NA_complex_] = ACTIONS(7544),
    [anon_sym_NA_character_] = ACTIONS(7544),
    [sym_dots] = ACTIONS(7544),
    [sym_dot_dot_i] = ACTIONS(7542),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7542),
    [sym__newline] = ACTIONS(7542),
    [sym__raw_string_literal] = ACTIONS(7542),
    [sym__external_open_parenthesis] = ACTIONS(7542),
    [sym__external_close_parenthesis] = ACTIONS(7542),
    [sym__external_open_brace] = ACTIONS(7542),
    [sym__external_open_bracket] = ACTIONS(7542),
    [sym__external_open_bracket2] = ACTIONS(7542),
    [sym__external_close_bracket2] = ACTIONS(7542),
  },
  [2807] = {
    [ts_builtin_sym_end] = ACTIONS(7492),
    [sym_identifier] = ACTIONS(7494),
    [anon_sym_BSLASH] = ACTIONS(7492),
    [anon_sym_function] = ACTIONS(7494),
    [anon_sym_EQ] = ACTIONS(7494),
    [anon_sym_if] = ACTIONS(7494),
    [anon_sym_for] = ACTIONS(7494),
    [anon_sym_while] = ACTIONS(7494),
    [anon_sym_repeat] = ACTIONS(7494),
    [anon_sym_QMARK] = ACTIONS(7492),
    [anon_sym_TILDE] = ACTIONS(7492),
    [anon_sym_BANG] = ACTIONS(7494),
    [anon_sym_PLUS] = ACTIONS(7492),
    [anon_sym_DASH] = ACTIONS(7494),
    [anon_sym_LT_DASH] = ACTIONS(7492),
    [anon_sym_LT_LT_DASH] = ACTIONS(7492),
    [anon_sym_COLON_EQ] = ACTIONS(7492),
    [anon_sym_DASH_GT] = ACTIONS(7494),
    [anon_sym_DASH_GT_GT] = ACTIONS(7492),
    [anon_sym_PIPE] = ACTIONS(7494),
    [anon_sym_AMP] = ACTIONS(7494),
    [anon_sym_PIPE_PIPE] = ACTIONS(7492),
    [anon_sym_AMP_AMP] = ACTIONS(7492),
    [anon_sym_LT] = ACTIONS(7494),
    [anon_sym_LT_EQ] = ACTIONS(7492),
    [anon_sym_GT] = ACTIONS(7494),
    [anon_sym_GT_EQ] = ACTIONS(7492),
    [anon_sym_EQ_EQ] = ACTIONS(7492),
    [anon_sym_BANG_EQ] = ACTIONS(7492),
    [anon_sym_STAR] = ACTIONS(7494),
    [anon_sym_SLASH] = ACTIONS(7492),
    [anon_sym_STAR_STAR] = ACTIONS(7492),
    [anon_sym_CARET] = ACTIONS(7492),
    [aux_sym_binary_operator_token1] = ACTIONS(7492),
    [anon_sym_PIPE_GT] = ACTIONS(7492),
    [anon_sym_COLON] = ACTIONS(7494),
    [anon_sym_DOLLAR] = ACTIONS(7492),
    [anon_sym_AT] = ACTIONS(7492),
    [aux_sym__hex_literal_token1] = ACTIONS(7492),
    [sym__number_literal] = ACTIONS(7494),
    [anon_sym_SQUOTE] = ACTIONS(7492),
    [anon_sym_DQUOTE] = ACTIONS(7492),
    [sym_return] = ACTIONS(7494),
    [sym_next] = ACTIONS(7494),
    [sym_break] = ACTIONS(7494),
    [sym_true] = ACTIONS(7494),
    [sym_false] = ACTIONS(7494),
    [sym_null] = ACTIONS(7494),
    [sym_inf] = ACTIONS(7494),
    [sym_nan] = ACTIONS(7494),
    [anon_sym_NA] = ACTIONS(7494),
    [anon_sym_NA_integer_] = ACTIONS(7494),
    [anon_sym_NA_real_] = ACTIONS(7494),
    [anon_sym_NA_complex_] = ACTIONS(7494),
    [anon_sym_NA_character_] = ACTIONS(7494),
    [sym_dots] = ACTIONS(7494),
    [sym_dot_dot_i] = ACTIONS(7492),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7492),
    [sym__semicolon] = ACTIONS(7492),
    [sym__raw_string_literal] = ACTIONS(7492),
    [sym__external_else] = ACTIONS(7492),
    [sym__external_open_parenthesis] = ACTIONS(7492),
    [sym__external_open_brace] = ACTIONS(7492),
    [sym__external_open_bracket] = ACTIONS(7492),
    [sym__external_open_bracket2] = ACTIONS(7492),
  },
  [2808] = {
    [sym_identifier] = ACTIONS(7532),
    [anon_sym_BSLASH] = ACTIONS(7530),
    [anon_sym_function] = ACTIONS(7532),
    [anon_sym_EQ] = ACTIONS(7532),
    [anon_sym_if] = ACTIONS(7532),
    [anon_sym_for] = ACTIONS(7532),
    [anon_sym_while] = ACTIONS(7532),
    [anon_sym_repeat] = ACTIONS(7532),
    [anon_sym_QMARK] = ACTIONS(7530),
    [anon_sym_TILDE] = ACTIONS(7530),
    [anon_sym_BANG] = ACTIONS(7532),
    [anon_sym_PLUS] = ACTIONS(7530),
    [anon_sym_DASH] = ACTIONS(7532),
    [anon_sym_LT_DASH] = ACTIONS(7530),
    [anon_sym_LT_LT_DASH] = ACTIONS(7530),
    [anon_sym_COLON_EQ] = ACTIONS(7530),
    [anon_sym_DASH_GT] = ACTIONS(7532),
    [anon_sym_DASH_GT_GT] = ACTIONS(7530),
    [anon_sym_PIPE] = ACTIONS(7532),
    [anon_sym_AMP] = ACTIONS(7532),
    [anon_sym_PIPE_PIPE] = ACTIONS(7530),
    [anon_sym_AMP_AMP] = ACTIONS(7530),
    [anon_sym_LT] = ACTIONS(7532),
    [anon_sym_LT_EQ] = ACTIONS(7530),
    [anon_sym_GT] = ACTIONS(7532),
    [anon_sym_GT_EQ] = ACTIONS(7530),
    [anon_sym_EQ_EQ] = ACTIONS(7530),
    [anon_sym_BANG_EQ] = ACTIONS(7530),
    [anon_sym_STAR] = ACTIONS(7532),
    [anon_sym_SLASH] = ACTIONS(7530),
    [anon_sym_STAR_STAR] = ACTIONS(7530),
    [anon_sym_CARET] = ACTIONS(7530),
    [aux_sym_binary_operator_token1] = ACTIONS(7530),
    [anon_sym_PIPE_GT] = ACTIONS(7530),
    [anon_sym_COLON] = ACTIONS(7532),
    [anon_sym_DOLLAR] = ACTIONS(7530),
    [anon_sym_AT] = ACTIONS(7530),
    [aux_sym__hex_literal_token1] = ACTIONS(7530),
    [sym__number_literal] = ACTIONS(7532),
    [anon_sym_SQUOTE] = ACTIONS(7530),
    [anon_sym_DQUOTE] = ACTIONS(7530),
    [sym_return] = ACTIONS(7532),
    [sym_next] = ACTIONS(7532),
    [sym_break] = ACTIONS(7532),
    [sym_true] = ACTIONS(7532),
    [sym_false] = ACTIONS(7532),
    [sym_null] = ACTIONS(7532),
    [sym_inf] = ACTIONS(7532),
    [sym_nan] = ACTIONS(7532),
    [anon_sym_NA] = ACTIONS(7532),
    [anon_sym_NA_integer_] = ACTIONS(7532),
    [anon_sym_NA_real_] = ACTIONS(7532),
    [anon_sym_NA_complex_] = ACTIONS(7532),
    [anon_sym_NA_character_] = ACTIONS(7532),
    [sym_dots] = ACTIONS(7532),
    [sym_dot_dot_i] = ACTIONS(7530),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7530),
    [sym__newline] = ACTIONS(7530),
    [sym__raw_string_literal] = ACTIONS(7530),
    [sym__external_open_parenthesis] = ACTIONS(7530),
    [sym__external_close_parenthesis] = ACTIONS(7530),
    [sym__external_open_brace] = ACTIONS(7530),
    [sym__external_open_bracket] = ACTIONS(7530),
    [sym__external_open_bracket2] = ACTIONS(7530),
    [sym__external_close_bracket2] = ACTIONS(7530),
  },
  [2809] = {
    [sym_identifier] = ACTIONS(7486),
    [anon_sym_BSLASH] = ACTIONS(7484),
    [anon_sym_function] = ACTIONS(7486),
    [anon_sym_EQ] = ACTIONS(7486),
    [anon_sym_if] = ACTIONS(7486),
    [anon_sym_for] = ACTIONS(7486),
    [anon_sym_while] = ACTIONS(7486),
    [anon_sym_repeat] = ACTIONS(7486),
    [anon_sym_QMARK] = ACTIONS(7484),
    [anon_sym_TILDE] = ACTIONS(7484),
    [anon_sym_BANG] = ACTIONS(7486),
    [anon_sym_PLUS] = ACTIONS(7484),
    [anon_sym_DASH] = ACTIONS(7486),
    [anon_sym_LT_DASH] = ACTIONS(7484),
    [anon_sym_LT_LT_DASH] = ACTIONS(7484),
    [anon_sym_COLON_EQ] = ACTIONS(7484),
    [anon_sym_DASH_GT] = ACTIONS(7486),
    [anon_sym_DASH_GT_GT] = ACTIONS(7484),
    [anon_sym_PIPE] = ACTIONS(7486),
    [anon_sym_AMP] = ACTIONS(7486),
    [anon_sym_PIPE_PIPE] = ACTIONS(7484),
    [anon_sym_AMP_AMP] = ACTIONS(7484),
    [anon_sym_LT] = ACTIONS(7486),
    [anon_sym_LT_EQ] = ACTIONS(7484),
    [anon_sym_GT] = ACTIONS(7486),
    [anon_sym_GT_EQ] = ACTIONS(7484),
    [anon_sym_EQ_EQ] = ACTIONS(7484),
    [anon_sym_BANG_EQ] = ACTIONS(7484),
    [anon_sym_STAR] = ACTIONS(7486),
    [anon_sym_SLASH] = ACTIONS(7484),
    [anon_sym_STAR_STAR] = ACTIONS(7484),
    [anon_sym_CARET] = ACTIONS(7484),
    [aux_sym_binary_operator_token1] = ACTIONS(7484),
    [anon_sym_PIPE_GT] = ACTIONS(7484),
    [anon_sym_COLON] = ACTIONS(7486),
    [anon_sym_DOLLAR] = ACTIONS(7484),
    [anon_sym_AT] = ACTIONS(7484),
    [aux_sym__hex_literal_token1] = ACTIONS(7484),
    [sym__number_literal] = ACTIONS(7486),
    [anon_sym_SQUOTE] = ACTIONS(7484),
    [anon_sym_DQUOTE] = ACTIONS(7484),
    [sym_return] = ACTIONS(7486),
    [sym_next] = ACTIONS(7486),
    [sym_break] = ACTIONS(7486),
    [sym_true] = ACTIONS(7486),
    [sym_false] = ACTIONS(7486),
    [sym_null] = ACTIONS(7486),
    [sym_inf] = ACTIONS(7486),
    [sym_nan] = ACTIONS(7486),
    [anon_sym_NA] = ACTIONS(7486),
    [anon_sym_NA_integer_] = ACTIONS(7486),
    [anon_sym_NA_real_] = ACTIONS(7486),
    [anon_sym_NA_complex_] = ACTIONS(7486),
    [anon_sym_NA_character_] = ACTIONS(7486),
    [sym_dots] = ACTIONS(7486),
    [sym_dot_dot_i] = ACTIONS(7484),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7484),
    [sym__newline] = ACTIONS(7484),
    [sym__raw_string_literal] = ACTIONS(7484),
    [sym__external_else] = ACTIONS(7484),
    [sym__external_open_parenthesis] = ACTIONS(7484),
    [sym__external_open_brace] = ACTIONS(7484),
    [sym__external_open_bracket] = ACTIONS(7484),
    [sym__external_open_bracket2] = ACTIONS(7484),
    [sym__external_close_bracket2] = ACTIONS(7484),
  },
  [2810] = {
    [sym_identifier] = ACTIONS(7490),
    [anon_sym_BSLASH] = ACTIONS(7488),
    [anon_sym_function] = ACTIONS(7490),
    [anon_sym_EQ] = ACTIONS(7490),
    [anon_sym_if] = ACTIONS(7490),
    [anon_sym_for] = ACTIONS(7490),
    [anon_sym_while] = ACTIONS(7490),
    [anon_sym_repeat] = ACTIONS(7490),
    [anon_sym_QMARK] = ACTIONS(7488),
    [anon_sym_TILDE] = ACTIONS(7488),
    [anon_sym_BANG] = ACTIONS(7490),
    [anon_sym_PLUS] = ACTIONS(7488),
    [anon_sym_DASH] = ACTIONS(7490),
    [anon_sym_LT_DASH] = ACTIONS(7488),
    [anon_sym_LT_LT_DASH] = ACTIONS(7488),
    [anon_sym_COLON_EQ] = ACTIONS(7488),
    [anon_sym_DASH_GT] = ACTIONS(7490),
    [anon_sym_DASH_GT_GT] = ACTIONS(7488),
    [anon_sym_PIPE] = ACTIONS(7490),
    [anon_sym_AMP] = ACTIONS(7490),
    [anon_sym_PIPE_PIPE] = ACTIONS(7488),
    [anon_sym_AMP_AMP] = ACTIONS(7488),
    [anon_sym_LT] = ACTIONS(7490),
    [anon_sym_LT_EQ] = ACTIONS(7488),
    [anon_sym_GT] = ACTIONS(7490),
    [anon_sym_GT_EQ] = ACTIONS(7488),
    [anon_sym_EQ_EQ] = ACTIONS(7488),
    [anon_sym_BANG_EQ] = ACTIONS(7488),
    [anon_sym_STAR] = ACTIONS(7490),
    [anon_sym_SLASH] = ACTIONS(7488),
    [anon_sym_STAR_STAR] = ACTIONS(7488),
    [anon_sym_CARET] = ACTIONS(7488),
    [aux_sym_binary_operator_token1] = ACTIONS(7488),
    [anon_sym_PIPE_GT] = ACTIONS(7488),
    [anon_sym_COLON] = ACTIONS(7490),
    [anon_sym_DOLLAR] = ACTIONS(7488),
    [anon_sym_AT] = ACTIONS(7488),
    [aux_sym__hex_literal_token1] = ACTIONS(7488),
    [sym__number_literal] = ACTIONS(7490),
    [anon_sym_SQUOTE] = ACTIONS(7488),
    [anon_sym_DQUOTE] = ACTIONS(7488),
    [sym_return] = ACTIONS(7490),
    [sym_next] = ACTIONS(7490),
    [sym_break] = ACTIONS(7490),
    [sym_true] = ACTIONS(7490),
    [sym_false] = ACTIONS(7490),
    [sym_null] = ACTIONS(7490),
    [sym_inf] = ACTIONS(7490),
    [sym_nan] = ACTIONS(7490),
    [anon_sym_NA] = ACTIONS(7490),
    [anon_sym_NA_integer_] = ACTIONS(7490),
    [anon_sym_NA_real_] = ACTIONS(7490),
    [anon_sym_NA_complex_] = ACTIONS(7490),
    [anon_sym_NA_character_] = ACTIONS(7490),
    [sym_dots] = ACTIONS(7490),
    [sym_dot_dot_i] = ACTIONS(7488),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7488),
    [sym__newline] = ACTIONS(7488),
    [sym__raw_string_literal] = ACTIONS(7488),
    [sym__external_else] = ACTIONS(7488),
    [sym__external_open_parenthesis] = ACTIONS(7488),
    [sym__external_open_brace] = ACTIONS(7488),
    [sym__external_open_bracket] = ACTIONS(7488),
    [sym__external_open_bracket2] = ACTIONS(7488),
    [sym__external_close_bracket2] = ACTIONS(7488),
  },
  [2811] = {
    [sym_identifier] = ACTIONS(7494),
    [anon_sym_BSLASH] = ACTIONS(7492),
    [anon_sym_function] = ACTIONS(7494),
    [anon_sym_EQ] = ACTIONS(7494),
    [anon_sym_if] = ACTIONS(7494),
    [anon_sym_for] = ACTIONS(7494),
    [anon_sym_while] = ACTIONS(7494),
    [anon_sym_repeat] = ACTIONS(7494),
    [anon_sym_QMARK] = ACTIONS(7492),
    [anon_sym_TILDE] = ACTIONS(7492),
    [anon_sym_BANG] = ACTIONS(7494),
    [anon_sym_PLUS] = ACTIONS(7492),
    [anon_sym_DASH] = ACTIONS(7494),
    [anon_sym_LT_DASH] = ACTIONS(7492),
    [anon_sym_LT_LT_DASH] = ACTIONS(7492),
    [anon_sym_COLON_EQ] = ACTIONS(7492),
    [anon_sym_DASH_GT] = ACTIONS(7494),
    [anon_sym_DASH_GT_GT] = ACTIONS(7492),
    [anon_sym_PIPE] = ACTIONS(7494),
    [anon_sym_AMP] = ACTIONS(7494),
    [anon_sym_PIPE_PIPE] = ACTIONS(7492),
    [anon_sym_AMP_AMP] = ACTIONS(7492),
    [anon_sym_LT] = ACTIONS(7494),
    [anon_sym_LT_EQ] = ACTIONS(7492),
    [anon_sym_GT] = ACTIONS(7494),
    [anon_sym_GT_EQ] = ACTIONS(7492),
    [anon_sym_EQ_EQ] = ACTIONS(7492),
    [anon_sym_BANG_EQ] = ACTIONS(7492),
    [anon_sym_STAR] = ACTIONS(7494),
    [anon_sym_SLASH] = ACTIONS(7492),
    [anon_sym_STAR_STAR] = ACTIONS(7492),
    [anon_sym_CARET] = ACTIONS(7492),
    [aux_sym_binary_operator_token1] = ACTIONS(7492),
    [anon_sym_PIPE_GT] = ACTIONS(7492),
    [anon_sym_COLON] = ACTIONS(7494),
    [anon_sym_DOLLAR] = ACTIONS(7492),
    [anon_sym_AT] = ACTIONS(7492),
    [aux_sym__hex_literal_token1] = ACTIONS(7492),
    [sym__number_literal] = ACTIONS(7494),
    [anon_sym_SQUOTE] = ACTIONS(7492),
    [anon_sym_DQUOTE] = ACTIONS(7492),
    [sym_return] = ACTIONS(7494),
    [sym_next] = ACTIONS(7494),
    [sym_break] = ACTIONS(7494),
    [sym_true] = ACTIONS(7494),
    [sym_false] = ACTIONS(7494),
    [sym_null] = ACTIONS(7494),
    [sym_inf] = ACTIONS(7494),
    [sym_nan] = ACTIONS(7494),
    [anon_sym_NA] = ACTIONS(7494),
    [anon_sym_NA_integer_] = ACTIONS(7494),
    [anon_sym_NA_real_] = ACTIONS(7494),
    [anon_sym_NA_complex_] = ACTIONS(7494),
    [anon_sym_NA_character_] = ACTIONS(7494),
    [sym_dots] = ACTIONS(7494),
    [sym_dot_dot_i] = ACTIONS(7492),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7492),
    [sym__newline] = ACTIONS(7492),
    [sym__raw_string_literal] = ACTIONS(7492),
    [sym__external_else] = ACTIONS(7492),
    [sym__external_open_parenthesis] = ACTIONS(7492),
    [sym__external_open_brace] = ACTIONS(7492),
    [sym__external_open_bracket] = ACTIONS(7492),
    [sym__external_open_bracket2] = ACTIONS(7492),
    [sym__external_close_bracket2] = ACTIONS(7492),
  },
  [2812] = {
    [sym_identifier] = ACTIONS(7498),
    [anon_sym_BSLASH] = ACTIONS(7496),
    [anon_sym_function] = ACTIONS(7498),
    [anon_sym_EQ] = ACTIONS(7498),
    [anon_sym_if] = ACTIONS(7498),
    [anon_sym_for] = ACTIONS(7498),
    [anon_sym_while] = ACTIONS(7498),
    [anon_sym_repeat] = ACTIONS(7498),
    [anon_sym_QMARK] = ACTIONS(7496),
    [anon_sym_TILDE] = ACTIONS(7496),
    [anon_sym_BANG] = ACTIONS(7498),
    [anon_sym_PLUS] = ACTIONS(7496),
    [anon_sym_DASH] = ACTIONS(7498),
    [anon_sym_LT_DASH] = ACTIONS(7496),
    [anon_sym_LT_LT_DASH] = ACTIONS(7496),
    [anon_sym_COLON_EQ] = ACTIONS(7496),
    [anon_sym_DASH_GT] = ACTIONS(7498),
    [anon_sym_DASH_GT_GT] = ACTIONS(7496),
    [anon_sym_PIPE] = ACTIONS(7498),
    [anon_sym_AMP] = ACTIONS(7498),
    [anon_sym_PIPE_PIPE] = ACTIONS(7496),
    [anon_sym_AMP_AMP] = ACTIONS(7496),
    [anon_sym_LT] = ACTIONS(7498),
    [anon_sym_LT_EQ] = ACTIONS(7496),
    [anon_sym_GT] = ACTIONS(7498),
    [anon_sym_GT_EQ] = ACTIONS(7496),
    [anon_sym_EQ_EQ] = ACTIONS(7496),
    [anon_sym_BANG_EQ] = ACTIONS(7496),
    [anon_sym_STAR] = ACTIONS(7498),
    [anon_sym_SLASH] = ACTIONS(7496),
    [anon_sym_STAR_STAR] = ACTIONS(7496),
    [anon_sym_CARET] = ACTIONS(7496),
    [aux_sym_binary_operator_token1] = ACTIONS(7496),
    [anon_sym_PIPE_GT] = ACTIONS(7496),
    [anon_sym_COLON] = ACTIONS(7498),
    [anon_sym_DOLLAR] = ACTIONS(7496),
    [anon_sym_AT] = ACTIONS(7496),
    [aux_sym__hex_literal_token1] = ACTIONS(7496),
    [sym__number_literal] = ACTIONS(7498),
    [anon_sym_SQUOTE] = ACTIONS(7496),
    [anon_sym_DQUOTE] = ACTIONS(7496),
    [sym_return] = ACTIONS(7498),
    [sym_next] = ACTIONS(7498),
    [sym_break] = ACTIONS(7498),
    [sym_true] = ACTIONS(7498),
    [sym_false] = ACTIONS(7498),
    [sym_null] = ACTIONS(7498),
    [sym_inf] = ACTIONS(7498),
    [sym_nan] = ACTIONS(7498),
    [anon_sym_NA] = ACTIONS(7498),
    [anon_sym_NA_integer_] = ACTIONS(7498),
    [anon_sym_NA_real_] = ACTIONS(7498),
    [anon_sym_NA_complex_] = ACTIONS(7498),
    [anon_sym_NA_character_] = ACTIONS(7498),
    [sym_dots] = ACTIONS(7498),
    [sym_dot_dot_i] = ACTIONS(7496),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7496),
    [sym__newline] = ACTIONS(7496),
    [sym__raw_string_literal] = ACTIONS(7496),
    [sym__external_else] = ACTIONS(7496),
    [sym__external_open_parenthesis] = ACTIONS(7496),
    [sym__external_open_brace] = ACTIONS(7496),
    [sym__external_open_bracket] = ACTIONS(7496),
    [sym__external_open_bracket2] = ACTIONS(7496),
    [sym__external_close_bracket2] = ACTIONS(7496),
  },
  [2813] = {
    [ts_builtin_sym_end] = ACTIONS(7496),
    [sym_identifier] = ACTIONS(7498),
    [anon_sym_BSLASH] = ACTIONS(7496),
    [anon_sym_function] = ACTIONS(7498),
    [anon_sym_EQ] = ACTIONS(7498),
    [anon_sym_if] = ACTIONS(7498),
    [anon_sym_for] = ACTIONS(7498),
    [anon_sym_while] = ACTIONS(7498),
    [anon_sym_repeat] = ACTIONS(7498),
    [anon_sym_QMARK] = ACTIONS(7496),
    [anon_sym_TILDE] = ACTIONS(7496),
    [anon_sym_BANG] = ACTIONS(7498),
    [anon_sym_PLUS] = ACTIONS(7496),
    [anon_sym_DASH] = ACTIONS(7498),
    [anon_sym_LT_DASH] = ACTIONS(7496),
    [anon_sym_LT_LT_DASH] = ACTIONS(7496),
    [anon_sym_COLON_EQ] = ACTIONS(7496),
    [anon_sym_DASH_GT] = ACTIONS(7498),
    [anon_sym_DASH_GT_GT] = ACTIONS(7496),
    [anon_sym_PIPE] = ACTIONS(7498),
    [anon_sym_AMP] = ACTIONS(7498),
    [anon_sym_PIPE_PIPE] = ACTIONS(7496),
    [anon_sym_AMP_AMP] = ACTIONS(7496),
    [anon_sym_LT] = ACTIONS(7498),
    [anon_sym_LT_EQ] = ACTIONS(7496),
    [anon_sym_GT] = ACTIONS(7498),
    [anon_sym_GT_EQ] = ACTIONS(7496),
    [anon_sym_EQ_EQ] = ACTIONS(7496),
    [anon_sym_BANG_EQ] = ACTIONS(7496),
    [anon_sym_STAR] = ACTIONS(7498),
    [anon_sym_SLASH] = ACTIONS(7496),
    [anon_sym_STAR_STAR] = ACTIONS(7496),
    [anon_sym_CARET] = ACTIONS(7496),
    [aux_sym_binary_operator_token1] = ACTIONS(7496),
    [anon_sym_PIPE_GT] = ACTIONS(7496),
    [anon_sym_COLON] = ACTIONS(7498),
    [anon_sym_DOLLAR] = ACTIONS(7496),
    [anon_sym_AT] = ACTIONS(7496),
    [aux_sym__hex_literal_token1] = ACTIONS(7496),
    [sym__number_literal] = ACTIONS(7498),
    [anon_sym_SQUOTE] = ACTIONS(7496),
    [anon_sym_DQUOTE] = ACTIONS(7496),
    [sym_return] = ACTIONS(7498),
    [sym_next] = ACTIONS(7498),
    [sym_break] = ACTIONS(7498),
    [sym_true] = ACTIONS(7498),
    [sym_false] = ACTIONS(7498),
    [sym_null] = ACTIONS(7498),
    [sym_inf] = ACTIONS(7498),
    [sym_nan] = ACTIONS(7498),
    [anon_sym_NA] = ACTIONS(7498),
    [anon_sym_NA_integer_] = ACTIONS(7498),
    [anon_sym_NA_real_] = ACTIONS(7498),
    [anon_sym_NA_complex_] = ACTIONS(7498),
    [anon_sym_NA_character_] = ACTIONS(7498),
    [sym_dots] = ACTIONS(7498),
    [sym_dot_dot_i] = ACTIONS(7496),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7496),
    [sym__semicolon] = ACTIONS(7496),
    [sym__raw_string_literal] = ACTIONS(7496),
    [sym__external_else] = ACTIONS(7496),
    [sym__external_open_parenthesis] = ACTIONS(7496),
    [sym__external_open_brace] = ACTIONS(7496),
    [sym__external_open_bracket] = ACTIONS(7496),
    [sym__external_open_bracket2] = ACTIONS(7496),
  },
  [2814] = {
    [sym_identifier] = ACTIONS(7482),
    [anon_sym_BSLASH] = ACTIONS(7480),
    [anon_sym_function] = ACTIONS(7482),
    [anon_sym_EQ] = ACTIONS(7482),
    [anon_sym_if] = ACTIONS(7482),
    [anon_sym_for] = ACTIONS(7482),
    [anon_sym_while] = ACTIONS(7482),
    [anon_sym_repeat] = ACTIONS(7482),
    [anon_sym_QMARK] = ACTIONS(7480),
    [anon_sym_TILDE] = ACTIONS(7480),
    [anon_sym_BANG] = ACTIONS(7482),
    [anon_sym_PLUS] = ACTIONS(7480),
    [anon_sym_DASH] = ACTIONS(7482),
    [anon_sym_LT_DASH] = ACTIONS(7480),
    [anon_sym_LT_LT_DASH] = ACTIONS(7480),
    [anon_sym_COLON_EQ] = ACTIONS(7480),
    [anon_sym_DASH_GT] = ACTIONS(7482),
    [anon_sym_DASH_GT_GT] = ACTIONS(7480),
    [anon_sym_PIPE] = ACTIONS(7482),
    [anon_sym_AMP] = ACTIONS(7482),
    [anon_sym_PIPE_PIPE] = ACTIONS(7480),
    [anon_sym_AMP_AMP] = ACTIONS(7480),
    [anon_sym_LT] = ACTIONS(7482),
    [anon_sym_LT_EQ] = ACTIONS(7480),
    [anon_sym_GT] = ACTIONS(7482),
    [anon_sym_GT_EQ] = ACTIONS(7480),
    [anon_sym_EQ_EQ] = ACTIONS(7480),
    [anon_sym_BANG_EQ] = ACTIONS(7480),
    [anon_sym_STAR] = ACTIONS(7482),
    [anon_sym_SLASH] = ACTIONS(7480),
    [anon_sym_STAR_STAR] = ACTIONS(7480),
    [anon_sym_CARET] = ACTIONS(7480),
    [aux_sym_binary_operator_token1] = ACTIONS(7480),
    [anon_sym_PIPE_GT] = ACTIONS(7480),
    [anon_sym_COLON] = ACTIONS(7482),
    [anon_sym_DOLLAR] = ACTIONS(7480),
    [anon_sym_AT] = ACTIONS(7480),
    [aux_sym__hex_literal_token1] = ACTIONS(7480),
    [sym__number_literal] = ACTIONS(7482),
    [anon_sym_SQUOTE] = ACTIONS(7480),
    [anon_sym_DQUOTE] = ACTIONS(7480),
    [sym_return] = ACTIONS(7482),
    [sym_next] = ACTIONS(7482),
    [sym_break] = ACTIONS(7482),
    [sym_true] = ACTIONS(7482),
    [sym_false] = ACTIONS(7482),
    [sym_null] = ACTIONS(7482),
    [sym_inf] = ACTIONS(7482),
    [sym_nan] = ACTIONS(7482),
    [anon_sym_NA] = ACTIONS(7482),
    [anon_sym_NA_integer_] = ACTIONS(7482),
    [anon_sym_NA_real_] = ACTIONS(7482),
    [anon_sym_NA_complex_] = ACTIONS(7482),
    [anon_sym_NA_character_] = ACTIONS(7482),
    [sym_dots] = ACTIONS(7482),
    [sym_dot_dot_i] = ACTIONS(7480),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7480),
    [sym__newline] = ACTIONS(7480),
    [sym__raw_string_literal] = ACTIONS(7480),
    [sym__external_else] = ACTIONS(7480),
    [sym__external_open_parenthesis] = ACTIONS(7480),
    [sym__external_close_parenthesis] = ACTIONS(7480),
    [sym__external_open_brace] = ACTIONS(7480),
    [sym__external_open_bracket] = ACTIONS(7480),
    [sym__external_open_bracket2] = ACTIONS(7480),
  },
  [2815] = {
    [ts_builtin_sym_end] = ACTIONS(7500),
    [sym_identifier] = ACTIONS(7502),
    [anon_sym_BSLASH] = ACTIONS(7500),
    [anon_sym_function] = ACTIONS(7502),
    [anon_sym_EQ] = ACTIONS(7502),
    [anon_sym_if] = ACTIONS(7502),
    [anon_sym_for] = ACTIONS(7502),
    [anon_sym_while] = ACTIONS(7502),
    [anon_sym_repeat] = ACTIONS(7502),
    [anon_sym_QMARK] = ACTIONS(7500),
    [anon_sym_TILDE] = ACTIONS(7500),
    [anon_sym_BANG] = ACTIONS(7502),
    [anon_sym_PLUS] = ACTIONS(7500),
    [anon_sym_DASH] = ACTIONS(7502),
    [anon_sym_LT_DASH] = ACTIONS(7500),
    [anon_sym_LT_LT_DASH] = ACTIONS(7500),
    [anon_sym_COLON_EQ] = ACTIONS(7500),
    [anon_sym_DASH_GT] = ACTIONS(7502),
    [anon_sym_DASH_GT_GT] = ACTIONS(7500),
    [anon_sym_PIPE] = ACTIONS(7502),
    [anon_sym_AMP] = ACTIONS(7502),
    [anon_sym_PIPE_PIPE] = ACTIONS(7500),
    [anon_sym_AMP_AMP] = ACTIONS(7500),
    [anon_sym_LT] = ACTIONS(7502),
    [anon_sym_LT_EQ] = ACTIONS(7500),
    [anon_sym_GT] = ACTIONS(7502),
    [anon_sym_GT_EQ] = ACTIONS(7500),
    [anon_sym_EQ_EQ] = ACTIONS(7500),
    [anon_sym_BANG_EQ] = ACTIONS(7500),
    [anon_sym_STAR] = ACTIONS(7502),
    [anon_sym_SLASH] = ACTIONS(7500),
    [anon_sym_STAR_STAR] = ACTIONS(7500),
    [anon_sym_CARET] = ACTIONS(7500),
    [aux_sym_binary_operator_token1] = ACTIONS(7500),
    [anon_sym_PIPE_GT] = ACTIONS(7500),
    [anon_sym_COLON] = ACTIONS(7502),
    [anon_sym_DOLLAR] = ACTIONS(7500),
    [anon_sym_AT] = ACTIONS(7500),
    [aux_sym__hex_literal_token1] = ACTIONS(7500),
    [sym__number_literal] = ACTIONS(7502),
    [anon_sym_SQUOTE] = ACTIONS(7500),
    [anon_sym_DQUOTE] = ACTIONS(7500),
    [sym_return] = ACTIONS(7502),
    [sym_next] = ACTIONS(7502),
    [sym_break] = ACTIONS(7502),
    [sym_true] = ACTIONS(7502),
    [sym_false] = ACTIONS(7502),
    [sym_null] = ACTIONS(7502),
    [sym_inf] = ACTIONS(7502),
    [sym_nan] = ACTIONS(7502),
    [anon_sym_NA] = ACTIONS(7502),
    [anon_sym_NA_integer_] = ACTIONS(7502),
    [anon_sym_NA_real_] = ACTIONS(7502),
    [anon_sym_NA_complex_] = ACTIONS(7502),
    [anon_sym_NA_character_] = ACTIONS(7502),
    [sym_dots] = ACTIONS(7502),
    [sym_dot_dot_i] = ACTIONS(7500),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7500),
    [sym__semicolon] = ACTIONS(7500),
    [sym__raw_string_literal] = ACTIONS(7500),
    [sym__external_else] = ACTIONS(7500),
    [sym__external_open_parenthesis] = ACTIONS(7500),
    [sym__external_open_brace] = ACTIONS(7500),
    [sym__external_open_bracket] = ACTIONS(7500),
    [sym__external_open_bracket2] = ACTIONS(7500),
  },
  [2816] = {
    [ts_builtin_sym_end] = ACTIONS(7504),
    [sym_identifier] = ACTIONS(7506),
    [anon_sym_BSLASH] = ACTIONS(7504),
    [anon_sym_function] = ACTIONS(7506),
    [anon_sym_EQ] = ACTIONS(7506),
    [anon_sym_if] = ACTIONS(7506),
    [anon_sym_for] = ACTIONS(7506),
    [anon_sym_while] = ACTIONS(7506),
    [anon_sym_repeat] = ACTIONS(7506),
    [anon_sym_QMARK] = ACTIONS(7504),
    [anon_sym_TILDE] = ACTIONS(7504),
    [anon_sym_BANG] = ACTIONS(7506),
    [anon_sym_PLUS] = ACTIONS(7504),
    [anon_sym_DASH] = ACTIONS(7506),
    [anon_sym_LT_DASH] = ACTIONS(7504),
    [anon_sym_LT_LT_DASH] = ACTIONS(7504),
    [anon_sym_COLON_EQ] = ACTIONS(7504),
    [anon_sym_DASH_GT] = ACTIONS(7506),
    [anon_sym_DASH_GT_GT] = ACTIONS(7504),
    [anon_sym_PIPE] = ACTIONS(7506),
    [anon_sym_AMP] = ACTIONS(7506),
    [anon_sym_PIPE_PIPE] = ACTIONS(7504),
    [anon_sym_AMP_AMP] = ACTIONS(7504),
    [anon_sym_LT] = ACTIONS(7506),
    [anon_sym_LT_EQ] = ACTIONS(7504),
    [anon_sym_GT] = ACTIONS(7506),
    [anon_sym_GT_EQ] = ACTIONS(7504),
    [anon_sym_EQ_EQ] = ACTIONS(7504),
    [anon_sym_BANG_EQ] = ACTIONS(7504),
    [anon_sym_STAR] = ACTIONS(7506),
    [anon_sym_SLASH] = ACTIONS(7504),
    [anon_sym_STAR_STAR] = ACTIONS(7504),
    [anon_sym_CARET] = ACTIONS(7504),
    [aux_sym_binary_operator_token1] = ACTIONS(7504),
    [anon_sym_PIPE_GT] = ACTIONS(7504),
    [anon_sym_COLON] = ACTIONS(7506),
    [anon_sym_DOLLAR] = ACTIONS(7504),
    [anon_sym_AT] = ACTIONS(7504),
    [aux_sym__hex_literal_token1] = ACTIONS(7504),
    [sym__number_literal] = ACTIONS(7506),
    [anon_sym_SQUOTE] = ACTIONS(7504),
    [anon_sym_DQUOTE] = ACTIONS(7504),
    [sym_return] = ACTIONS(7506),
    [sym_next] = ACTIONS(7506),
    [sym_break] = ACTIONS(7506),
    [sym_true] = ACTIONS(7506),
    [sym_false] = ACTIONS(7506),
    [sym_null] = ACTIONS(7506),
    [sym_inf] = ACTIONS(7506),
    [sym_nan] = ACTIONS(7506),
    [anon_sym_NA] = ACTIONS(7506),
    [anon_sym_NA_integer_] = ACTIONS(7506),
    [anon_sym_NA_real_] = ACTIONS(7506),
    [anon_sym_NA_complex_] = ACTIONS(7506),
    [anon_sym_NA_character_] = ACTIONS(7506),
    [sym_dots] = ACTIONS(7506),
    [sym_dot_dot_i] = ACTIONS(7504),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7504),
    [sym__semicolon] = ACTIONS(7504),
    [sym__raw_string_literal] = ACTIONS(7504),
    [sym__external_else] = ACTIONS(7504),
    [sym__external_open_parenthesis] = ACTIONS(7504),
    [sym__external_open_brace] = ACTIONS(7504),
    [sym__external_open_bracket] = ACTIONS(7504),
    [sym__external_open_bracket2] = ACTIONS(7504),
  },
  [2817] = {
    [ts_builtin_sym_end] = ACTIONS(7561),
    [sym_identifier] = ACTIONS(7563),
    [anon_sym_BSLASH] = ACTIONS(7561),
    [anon_sym_function] = ACTIONS(7563),
    [anon_sym_EQ] = ACTIONS(7563),
    [anon_sym_if] = ACTIONS(7563),
    [anon_sym_for] = ACTIONS(7563),
    [anon_sym_while] = ACTIONS(7563),
    [anon_sym_repeat] = ACTIONS(7563),
    [anon_sym_QMARK] = ACTIONS(7561),
    [anon_sym_TILDE] = ACTIONS(7561),
    [anon_sym_BANG] = ACTIONS(7563),
    [anon_sym_PLUS] = ACTIONS(7561),
    [anon_sym_DASH] = ACTIONS(7563),
    [anon_sym_LT_DASH] = ACTIONS(7561),
    [anon_sym_LT_LT_DASH] = ACTIONS(7561),
    [anon_sym_COLON_EQ] = ACTIONS(7561),
    [anon_sym_DASH_GT] = ACTIONS(7563),
    [anon_sym_DASH_GT_GT] = ACTIONS(7561),
    [anon_sym_PIPE] = ACTIONS(7563),
    [anon_sym_AMP] = ACTIONS(7563),
    [anon_sym_PIPE_PIPE] = ACTIONS(7561),
    [anon_sym_AMP_AMP] = ACTIONS(7561),
    [anon_sym_LT] = ACTIONS(7563),
    [anon_sym_LT_EQ] = ACTIONS(7561),
    [anon_sym_GT] = ACTIONS(7563),
    [anon_sym_GT_EQ] = ACTIONS(7561),
    [anon_sym_EQ_EQ] = ACTIONS(7561),
    [anon_sym_BANG_EQ] = ACTIONS(7561),
    [anon_sym_STAR] = ACTIONS(7563),
    [anon_sym_SLASH] = ACTIONS(7561),
    [anon_sym_STAR_STAR] = ACTIONS(7561),
    [anon_sym_CARET] = ACTIONS(7561),
    [aux_sym_binary_operator_token1] = ACTIONS(7561),
    [anon_sym_PIPE_GT] = ACTIONS(7561),
    [anon_sym_COLON] = ACTIONS(7563),
    [anon_sym_DOLLAR] = ACTIONS(7561),
    [anon_sym_AT] = ACTIONS(7561),
    [aux_sym__hex_literal_token1] = ACTIONS(7561),
    [sym__number_literal] = ACTIONS(7563),
    [anon_sym_SQUOTE] = ACTIONS(7561),
    [anon_sym_DQUOTE] = ACTIONS(7561),
    [sym_return] = ACTIONS(7563),
    [sym_next] = ACTIONS(7563),
    [sym_break] = ACTIONS(7563),
    [sym_true] = ACTIONS(7563),
    [sym_false] = ACTIONS(7563),
    [sym_null] = ACTIONS(7563),
    [sym_inf] = ACTIONS(7563),
    [sym_nan] = ACTIONS(7563),
    [anon_sym_NA] = ACTIONS(7563),
    [anon_sym_NA_integer_] = ACTIONS(7563),
    [anon_sym_NA_real_] = ACTIONS(7563),
    [anon_sym_NA_complex_] = ACTIONS(7563),
    [anon_sym_NA_character_] = ACTIONS(7563),
    [sym_dots] = ACTIONS(7563),
    [sym_dot_dot_i] = ACTIONS(7561),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7561),
    [sym__semicolon] = ACTIONS(7561),
    [sym__raw_string_literal] = ACTIONS(7561),
    [sym__external_else] = ACTIONS(7561),
    [sym__external_open_parenthesis] = ACTIONS(7561),
    [sym__external_open_brace] = ACTIONS(7561),
    [sym__external_open_bracket] = ACTIONS(7561),
    [sym__external_open_bracket2] = ACTIONS(7561),
  },
  [2818] = {
    [ts_builtin_sym_end] = ACTIONS(7510),
    [sym_identifier] = ACTIONS(7512),
    [anon_sym_BSLASH] = ACTIONS(7510),
    [anon_sym_function] = ACTIONS(7512),
    [anon_sym_EQ] = ACTIONS(7512),
    [anon_sym_if] = ACTIONS(7512),
    [anon_sym_for] = ACTIONS(7512),
    [anon_sym_while] = ACTIONS(7512),
    [anon_sym_repeat] = ACTIONS(7512),
    [anon_sym_QMARK] = ACTIONS(7510),
    [anon_sym_TILDE] = ACTIONS(7510),
    [anon_sym_BANG] = ACTIONS(7512),
    [anon_sym_PLUS] = ACTIONS(7510),
    [anon_sym_DASH] = ACTIONS(7512),
    [anon_sym_LT_DASH] = ACTIONS(7510),
    [anon_sym_LT_LT_DASH] = ACTIONS(7510),
    [anon_sym_COLON_EQ] = ACTIONS(7510),
    [anon_sym_DASH_GT] = ACTIONS(7512),
    [anon_sym_DASH_GT_GT] = ACTIONS(7510),
    [anon_sym_PIPE] = ACTIONS(7512),
    [anon_sym_AMP] = ACTIONS(7512),
    [anon_sym_PIPE_PIPE] = ACTIONS(7510),
    [anon_sym_AMP_AMP] = ACTIONS(7510),
    [anon_sym_LT] = ACTIONS(7512),
    [anon_sym_LT_EQ] = ACTIONS(7510),
    [anon_sym_GT] = ACTIONS(7512),
    [anon_sym_GT_EQ] = ACTIONS(7510),
    [anon_sym_EQ_EQ] = ACTIONS(7510),
    [anon_sym_BANG_EQ] = ACTIONS(7510),
    [anon_sym_STAR] = ACTIONS(7512),
    [anon_sym_SLASH] = ACTIONS(7510),
    [anon_sym_STAR_STAR] = ACTIONS(7510),
    [anon_sym_CARET] = ACTIONS(7510),
    [aux_sym_binary_operator_token1] = ACTIONS(7510),
    [anon_sym_PIPE_GT] = ACTIONS(7510),
    [anon_sym_COLON] = ACTIONS(7512),
    [anon_sym_DOLLAR] = ACTIONS(7510),
    [anon_sym_AT] = ACTIONS(7510),
    [aux_sym__hex_literal_token1] = ACTIONS(7510),
    [sym__number_literal] = ACTIONS(7512),
    [anon_sym_SQUOTE] = ACTIONS(7510),
    [anon_sym_DQUOTE] = ACTIONS(7510),
    [sym_return] = ACTIONS(7512),
    [sym_next] = ACTIONS(7512),
    [sym_break] = ACTIONS(7512),
    [sym_true] = ACTIONS(7512),
    [sym_false] = ACTIONS(7512),
    [sym_null] = ACTIONS(7512),
    [sym_inf] = ACTIONS(7512),
    [sym_nan] = ACTIONS(7512),
    [anon_sym_NA] = ACTIONS(7512),
    [anon_sym_NA_integer_] = ACTIONS(7512),
    [anon_sym_NA_real_] = ACTIONS(7512),
    [anon_sym_NA_complex_] = ACTIONS(7512),
    [anon_sym_NA_character_] = ACTIONS(7512),
    [sym_dots] = ACTIONS(7512),
    [sym_dot_dot_i] = ACTIONS(7510),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7510),
    [sym__semicolon] = ACTIONS(7510),
    [sym__raw_string_literal] = ACTIONS(7510),
    [sym__external_else] = ACTIONS(7510),
    [sym__external_open_parenthesis] = ACTIONS(7510),
    [sym__external_open_brace] = ACTIONS(7510),
    [sym__external_open_bracket] = ACTIONS(7510),
    [sym__external_open_bracket2] = ACTIONS(7510),
  },
  [2819] = {
    [sym_identifier] = ACTIONS(7502),
    [anon_sym_BSLASH] = ACTIONS(7500),
    [anon_sym_function] = ACTIONS(7502),
    [anon_sym_EQ] = ACTIONS(7502),
    [anon_sym_if] = ACTIONS(7502),
    [anon_sym_for] = ACTIONS(7502),
    [anon_sym_while] = ACTIONS(7502),
    [anon_sym_repeat] = ACTIONS(7502),
    [anon_sym_QMARK] = ACTIONS(7500),
    [anon_sym_TILDE] = ACTIONS(7500),
    [anon_sym_BANG] = ACTIONS(7502),
    [anon_sym_PLUS] = ACTIONS(7500),
    [anon_sym_DASH] = ACTIONS(7502),
    [anon_sym_LT_DASH] = ACTIONS(7500),
    [anon_sym_LT_LT_DASH] = ACTIONS(7500),
    [anon_sym_COLON_EQ] = ACTIONS(7500),
    [anon_sym_DASH_GT] = ACTIONS(7502),
    [anon_sym_DASH_GT_GT] = ACTIONS(7500),
    [anon_sym_PIPE] = ACTIONS(7502),
    [anon_sym_AMP] = ACTIONS(7502),
    [anon_sym_PIPE_PIPE] = ACTIONS(7500),
    [anon_sym_AMP_AMP] = ACTIONS(7500),
    [anon_sym_LT] = ACTIONS(7502),
    [anon_sym_LT_EQ] = ACTIONS(7500),
    [anon_sym_GT] = ACTIONS(7502),
    [anon_sym_GT_EQ] = ACTIONS(7500),
    [anon_sym_EQ_EQ] = ACTIONS(7500),
    [anon_sym_BANG_EQ] = ACTIONS(7500),
    [anon_sym_STAR] = ACTIONS(7502),
    [anon_sym_SLASH] = ACTIONS(7500),
    [anon_sym_STAR_STAR] = ACTIONS(7500),
    [anon_sym_CARET] = ACTIONS(7500),
    [aux_sym_binary_operator_token1] = ACTIONS(7500),
    [anon_sym_PIPE_GT] = ACTIONS(7500),
    [anon_sym_COLON] = ACTIONS(7502),
    [anon_sym_DOLLAR] = ACTIONS(7500),
    [anon_sym_AT] = ACTIONS(7500),
    [aux_sym__hex_literal_token1] = ACTIONS(7500),
    [sym__number_literal] = ACTIONS(7502),
    [anon_sym_SQUOTE] = ACTIONS(7500),
    [anon_sym_DQUOTE] = ACTIONS(7500),
    [sym_return] = ACTIONS(7502),
    [sym_next] = ACTIONS(7502),
    [sym_break] = ACTIONS(7502),
    [sym_true] = ACTIONS(7502),
    [sym_false] = ACTIONS(7502),
    [sym_null] = ACTIONS(7502),
    [sym_inf] = ACTIONS(7502),
    [sym_nan] = ACTIONS(7502),
    [anon_sym_NA] = ACTIONS(7502),
    [anon_sym_NA_integer_] = ACTIONS(7502),
    [anon_sym_NA_real_] = ACTIONS(7502),
    [anon_sym_NA_complex_] = ACTIONS(7502),
    [anon_sym_NA_character_] = ACTIONS(7502),
    [sym_dots] = ACTIONS(7502),
    [sym_dot_dot_i] = ACTIONS(7500),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7500),
    [sym__newline] = ACTIONS(7500),
    [sym__raw_string_literal] = ACTIONS(7500),
    [sym__external_else] = ACTIONS(7500),
    [sym__external_open_parenthesis] = ACTIONS(7500),
    [sym__external_open_brace] = ACTIONS(7500),
    [sym__external_open_bracket] = ACTIONS(7500),
    [sym__external_open_bracket2] = ACTIONS(7500),
    [sym__external_close_bracket2] = ACTIONS(7500),
  },
  [2820] = {
    [sym_identifier] = ACTIONS(7506),
    [anon_sym_BSLASH] = ACTIONS(7504),
    [anon_sym_function] = ACTIONS(7506),
    [anon_sym_EQ] = ACTIONS(7506),
    [anon_sym_if] = ACTIONS(7506),
    [anon_sym_for] = ACTIONS(7506),
    [anon_sym_while] = ACTIONS(7506),
    [anon_sym_repeat] = ACTIONS(7506),
    [anon_sym_QMARK] = ACTIONS(7504),
    [anon_sym_TILDE] = ACTIONS(7504),
    [anon_sym_BANG] = ACTIONS(7506),
    [anon_sym_PLUS] = ACTIONS(7504),
    [anon_sym_DASH] = ACTIONS(7506),
    [anon_sym_LT_DASH] = ACTIONS(7504),
    [anon_sym_LT_LT_DASH] = ACTIONS(7504),
    [anon_sym_COLON_EQ] = ACTIONS(7504),
    [anon_sym_DASH_GT] = ACTIONS(7506),
    [anon_sym_DASH_GT_GT] = ACTIONS(7504),
    [anon_sym_PIPE] = ACTIONS(7506),
    [anon_sym_AMP] = ACTIONS(7506),
    [anon_sym_PIPE_PIPE] = ACTIONS(7504),
    [anon_sym_AMP_AMP] = ACTIONS(7504),
    [anon_sym_LT] = ACTIONS(7506),
    [anon_sym_LT_EQ] = ACTIONS(7504),
    [anon_sym_GT] = ACTIONS(7506),
    [anon_sym_GT_EQ] = ACTIONS(7504),
    [anon_sym_EQ_EQ] = ACTIONS(7504),
    [anon_sym_BANG_EQ] = ACTIONS(7504),
    [anon_sym_STAR] = ACTIONS(7506),
    [anon_sym_SLASH] = ACTIONS(7504),
    [anon_sym_STAR_STAR] = ACTIONS(7504),
    [anon_sym_CARET] = ACTIONS(7504),
    [aux_sym_binary_operator_token1] = ACTIONS(7504),
    [anon_sym_PIPE_GT] = ACTIONS(7504),
    [anon_sym_COLON] = ACTIONS(7506),
    [anon_sym_DOLLAR] = ACTIONS(7504),
    [anon_sym_AT] = ACTIONS(7504),
    [aux_sym__hex_literal_token1] = ACTIONS(7504),
    [sym__number_literal] = ACTIONS(7506),
    [anon_sym_SQUOTE] = ACTIONS(7504),
    [anon_sym_DQUOTE] = ACTIONS(7504),
    [sym_return] = ACTIONS(7506),
    [sym_next] = ACTIONS(7506),
    [sym_break] = ACTIONS(7506),
    [sym_true] = ACTIONS(7506),
    [sym_false] = ACTIONS(7506),
    [sym_null] = ACTIONS(7506),
    [sym_inf] = ACTIONS(7506),
    [sym_nan] = ACTIONS(7506),
    [anon_sym_NA] = ACTIONS(7506),
    [anon_sym_NA_integer_] = ACTIONS(7506),
    [anon_sym_NA_real_] = ACTIONS(7506),
    [anon_sym_NA_complex_] = ACTIONS(7506),
    [anon_sym_NA_character_] = ACTIONS(7506),
    [sym_dots] = ACTIONS(7506),
    [sym_dot_dot_i] = ACTIONS(7504),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7504),
    [sym__newline] = ACTIONS(7504),
    [sym__raw_string_literal] = ACTIONS(7504),
    [sym__external_else] = ACTIONS(7504),
    [sym__external_open_parenthesis] = ACTIONS(7504),
    [sym__external_open_brace] = ACTIONS(7504),
    [sym__external_open_bracket] = ACTIONS(7504),
    [sym__external_open_bracket2] = ACTIONS(7504),
    [sym__external_close_bracket2] = ACTIONS(7504),
  },
  [2821] = {
    [sym_identifier] = ACTIONS(7552),
    [anon_sym_BSLASH] = ACTIONS(7550),
    [anon_sym_function] = ACTIONS(7552),
    [anon_sym_EQ] = ACTIONS(7552),
    [anon_sym_if] = ACTIONS(7552),
    [anon_sym_for] = ACTIONS(7552),
    [anon_sym_while] = ACTIONS(7552),
    [anon_sym_repeat] = ACTIONS(7552),
    [anon_sym_QMARK] = ACTIONS(7550),
    [anon_sym_TILDE] = ACTIONS(7550),
    [anon_sym_BANG] = ACTIONS(7552),
    [anon_sym_PLUS] = ACTIONS(7550),
    [anon_sym_DASH] = ACTIONS(7552),
    [anon_sym_LT_DASH] = ACTIONS(7550),
    [anon_sym_LT_LT_DASH] = ACTIONS(7550),
    [anon_sym_COLON_EQ] = ACTIONS(7550),
    [anon_sym_DASH_GT] = ACTIONS(7552),
    [anon_sym_DASH_GT_GT] = ACTIONS(7550),
    [anon_sym_PIPE] = ACTIONS(7552),
    [anon_sym_AMP] = ACTIONS(7552),
    [anon_sym_PIPE_PIPE] = ACTIONS(7550),
    [anon_sym_AMP_AMP] = ACTIONS(7550),
    [anon_sym_LT] = ACTIONS(7552),
    [anon_sym_LT_EQ] = ACTIONS(7550),
    [anon_sym_GT] = ACTIONS(7552),
    [anon_sym_GT_EQ] = ACTIONS(7550),
    [anon_sym_EQ_EQ] = ACTIONS(7550),
    [anon_sym_BANG_EQ] = ACTIONS(7550),
    [anon_sym_STAR] = ACTIONS(7552),
    [anon_sym_SLASH] = ACTIONS(7550),
    [anon_sym_STAR_STAR] = ACTIONS(7550),
    [anon_sym_CARET] = ACTIONS(7550),
    [aux_sym_binary_operator_token1] = ACTIONS(7550),
    [anon_sym_PIPE_GT] = ACTIONS(7550),
    [anon_sym_COLON] = ACTIONS(7552),
    [anon_sym_DOLLAR] = ACTIONS(7550),
    [anon_sym_AT] = ACTIONS(7550),
    [aux_sym__hex_literal_token1] = ACTIONS(7550),
    [sym__number_literal] = ACTIONS(7552),
    [anon_sym_SQUOTE] = ACTIONS(7550),
    [anon_sym_DQUOTE] = ACTIONS(7550),
    [sym_return] = ACTIONS(7552),
    [sym_next] = ACTIONS(7552),
    [sym_break] = ACTIONS(7552),
    [sym_true] = ACTIONS(7552),
    [sym_false] = ACTIONS(7552),
    [sym_null] = ACTIONS(7552),
    [sym_inf] = ACTIONS(7552),
    [sym_nan] = ACTIONS(7552),
    [anon_sym_NA] = ACTIONS(7552),
    [anon_sym_NA_integer_] = ACTIONS(7552),
    [anon_sym_NA_real_] = ACTIONS(7552),
    [anon_sym_NA_complex_] = ACTIONS(7552),
    [anon_sym_NA_character_] = ACTIONS(7552),
    [sym_dots] = ACTIONS(7552),
    [sym_dot_dot_i] = ACTIONS(7550),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7550),
    [sym__newline] = ACTIONS(7550),
    [sym__raw_string_literal] = ACTIONS(7550),
    [sym__external_open_parenthesis] = ACTIONS(7550),
    [sym__external_close_parenthesis] = ACTIONS(7550),
    [sym__external_open_brace] = ACTIONS(7550),
    [sym__external_open_bracket] = ACTIONS(7550),
    [sym__external_open_bracket2] = ACTIONS(7550),
    [sym__external_close_bracket2] = ACTIONS(7550),
  },
  [2822] = {
    [sym_identifier] = ACTIONS(7567),
    [anon_sym_BSLASH] = ACTIONS(7565),
    [anon_sym_function] = ACTIONS(7567),
    [anon_sym_EQ] = ACTIONS(7567),
    [anon_sym_if] = ACTIONS(7567),
    [anon_sym_for] = ACTIONS(7567),
    [anon_sym_while] = ACTIONS(7567),
    [anon_sym_repeat] = ACTIONS(7567),
    [anon_sym_QMARK] = ACTIONS(7565),
    [anon_sym_TILDE] = ACTIONS(7565),
    [anon_sym_BANG] = ACTIONS(7567),
    [anon_sym_PLUS] = ACTIONS(7565),
    [anon_sym_DASH] = ACTIONS(7567),
    [anon_sym_LT_DASH] = ACTIONS(7565),
    [anon_sym_LT_LT_DASH] = ACTIONS(7565),
    [anon_sym_COLON_EQ] = ACTIONS(7565),
    [anon_sym_DASH_GT] = ACTIONS(7567),
    [anon_sym_DASH_GT_GT] = ACTIONS(7565),
    [anon_sym_PIPE] = ACTIONS(7567),
    [anon_sym_AMP] = ACTIONS(7567),
    [anon_sym_PIPE_PIPE] = ACTIONS(7565),
    [anon_sym_AMP_AMP] = ACTIONS(7565),
    [anon_sym_LT] = ACTIONS(7567),
    [anon_sym_LT_EQ] = ACTIONS(7565),
    [anon_sym_GT] = ACTIONS(7567),
    [anon_sym_GT_EQ] = ACTIONS(7565),
    [anon_sym_EQ_EQ] = ACTIONS(7565),
    [anon_sym_BANG_EQ] = ACTIONS(7565),
    [anon_sym_STAR] = ACTIONS(7567),
    [anon_sym_SLASH] = ACTIONS(7565),
    [anon_sym_STAR_STAR] = ACTIONS(7565),
    [anon_sym_CARET] = ACTIONS(7565),
    [aux_sym_binary_operator_token1] = ACTIONS(7565),
    [anon_sym_PIPE_GT] = ACTIONS(7565),
    [anon_sym_COLON] = ACTIONS(7567),
    [anon_sym_DOLLAR] = ACTIONS(7565),
    [anon_sym_AT] = ACTIONS(7565),
    [aux_sym__hex_literal_token1] = ACTIONS(7565),
    [sym__number_literal] = ACTIONS(7567),
    [anon_sym_SQUOTE] = ACTIONS(7565),
    [anon_sym_DQUOTE] = ACTIONS(7565),
    [sym_return] = ACTIONS(7567),
    [sym_next] = ACTIONS(7567),
    [sym_break] = ACTIONS(7567),
    [sym_true] = ACTIONS(7567),
    [sym_false] = ACTIONS(7567),
    [sym_null] = ACTIONS(7567),
    [sym_inf] = ACTIONS(7567),
    [sym_nan] = ACTIONS(7567),
    [anon_sym_NA] = ACTIONS(7567),
    [anon_sym_NA_integer_] = ACTIONS(7567),
    [anon_sym_NA_real_] = ACTIONS(7567),
    [anon_sym_NA_complex_] = ACTIONS(7567),
    [anon_sym_NA_character_] = ACTIONS(7567),
    [sym_dots] = ACTIONS(7567),
    [sym_dot_dot_i] = ACTIONS(7565),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7565),
    [sym__newline] = ACTIONS(7565),
    [sym__raw_string_literal] = ACTIONS(7565),
    [sym__external_else] = ACTIONS(7565),
    [sym__external_open_parenthesis] = ACTIONS(7565),
    [sym__external_open_brace] = ACTIONS(7565),
    [sym__external_open_bracket] = ACTIONS(7565),
    [sym__external_close_bracket] = ACTIONS(7565),
    [sym__external_open_bracket2] = ACTIONS(7565),
  },
  [2823] = {
    [sym_identifier] = ACTIONS(7474),
    [anon_sym_BSLASH] = ACTIONS(7472),
    [anon_sym_function] = ACTIONS(7474),
    [anon_sym_EQ] = ACTIONS(7474),
    [anon_sym_if] = ACTIONS(7474),
    [anon_sym_for] = ACTIONS(7474),
    [anon_sym_while] = ACTIONS(7474),
    [anon_sym_repeat] = ACTIONS(7474),
    [anon_sym_QMARK] = ACTIONS(7472),
    [anon_sym_TILDE] = ACTIONS(7472),
    [anon_sym_BANG] = ACTIONS(7474),
    [anon_sym_PLUS] = ACTIONS(7472),
    [anon_sym_DASH] = ACTIONS(7474),
    [anon_sym_LT_DASH] = ACTIONS(7472),
    [anon_sym_LT_LT_DASH] = ACTIONS(7472),
    [anon_sym_COLON_EQ] = ACTIONS(7472),
    [anon_sym_DASH_GT] = ACTIONS(7474),
    [anon_sym_DASH_GT_GT] = ACTIONS(7472),
    [anon_sym_PIPE] = ACTIONS(7474),
    [anon_sym_AMP] = ACTIONS(7474),
    [anon_sym_PIPE_PIPE] = ACTIONS(7472),
    [anon_sym_AMP_AMP] = ACTIONS(7472),
    [anon_sym_LT] = ACTIONS(7474),
    [anon_sym_LT_EQ] = ACTIONS(7472),
    [anon_sym_GT] = ACTIONS(7474),
    [anon_sym_GT_EQ] = ACTIONS(7472),
    [anon_sym_EQ_EQ] = ACTIONS(7472),
    [anon_sym_BANG_EQ] = ACTIONS(7472),
    [anon_sym_STAR] = ACTIONS(7474),
    [anon_sym_SLASH] = ACTIONS(7472),
    [anon_sym_STAR_STAR] = ACTIONS(7472),
    [anon_sym_CARET] = ACTIONS(7472),
    [aux_sym_binary_operator_token1] = ACTIONS(7472),
    [anon_sym_PIPE_GT] = ACTIONS(7472),
    [anon_sym_COLON] = ACTIONS(7474),
    [anon_sym_DOLLAR] = ACTIONS(7472),
    [anon_sym_AT] = ACTIONS(7472),
    [aux_sym__hex_literal_token1] = ACTIONS(7472),
    [sym__number_literal] = ACTIONS(7474),
    [anon_sym_SQUOTE] = ACTIONS(7472),
    [anon_sym_DQUOTE] = ACTIONS(7472),
    [sym_return] = ACTIONS(7474),
    [sym_next] = ACTIONS(7474),
    [sym_break] = ACTIONS(7474),
    [sym_true] = ACTIONS(7474),
    [sym_false] = ACTIONS(7474),
    [sym_null] = ACTIONS(7474),
    [sym_inf] = ACTIONS(7474),
    [sym_nan] = ACTIONS(7474),
    [anon_sym_NA] = ACTIONS(7474),
    [anon_sym_NA_integer_] = ACTIONS(7474),
    [anon_sym_NA_real_] = ACTIONS(7474),
    [anon_sym_NA_complex_] = ACTIONS(7474),
    [anon_sym_NA_character_] = ACTIONS(7474),
    [sym_dots] = ACTIONS(7474),
    [sym_dot_dot_i] = ACTIONS(7472),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7472),
    [sym__newline] = ACTIONS(7472),
    [sym__raw_string_literal] = ACTIONS(7472),
    [sym__external_open_parenthesis] = ACTIONS(7472),
    [sym__external_close_parenthesis] = ACTIONS(7472),
    [sym__external_open_brace] = ACTIONS(7472),
    [sym__external_open_bracket] = ACTIONS(7472),
    [sym__external_open_bracket2] = ACTIONS(7472),
    [sym__external_close_bracket2] = ACTIONS(7472),
  },
  [2824] = {
    [sym_identifier] = ACTIONS(7512),
    [anon_sym_BSLASH] = ACTIONS(7510),
    [anon_sym_function] = ACTIONS(7512),
    [anon_sym_EQ] = ACTIONS(7512),
    [anon_sym_if] = ACTIONS(7512),
    [anon_sym_for] = ACTIONS(7512),
    [anon_sym_while] = ACTIONS(7512),
    [anon_sym_repeat] = ACTIONS(7512),
    [anon_sym_QMARK] = ACTIONS(7510),
    [anon_sym_TILDE] = ACTIONS(7510),
    [anon_sym_BANG] = ACTIONS(7512),
    [anon_sym_PLUS] = ACTIONS(7510),
    [anon_sym_DASH] = ACTIONS(7512),
    [anon_sym_LT_DASH] = ACTIONS(7510),
    [anon_sym_LT_LT_DASH] = ACTIONS(7510),
    [anon_sym_COLON_EQ] = ACTIONS(7510),
    [anon_sym_DASH_GT] = ACTIONS(7512),
    [anon_sym_DASH_GT_GT] = ACTIONS(7510),
    [anon_sym_PIPE] = ACTIONS(7512),
    [anon_sym_AMP] = ACTIONS(7512),
    [anon_sym_PIPE_PIPE] = ACTIONS(7510),
    [anon_sym_AMP_AMP] = ACTIONS(7510),
    [anon_sym_LT] = ACTIONS(7512),
    [anon_sym_LT_EQ] = ACTIONS(7510),
    [anon_sym_GT] = ACTIONS(7512),
    [anon_sym_GT_EQ] = ACTIONS(7510),
    [anon_sym_EQ_EQ] = ACTIONS(7510),
    [anon_sym_BANG_EQ] = ACTIONS(7510),
    [anon_sym_STAR] = ACTIONS(7512),
    [anon_sym_SLASH] = ACTIONS(7510),
    [anon_sym_STAR_STAR] = ACTIONS(7510),
    [anon_sym_CARET] = ACTIONS(7510),
    [aux_sym_binary_operator_token1] = ACTIONS(7510),
    [anon_sym_PIPE_GT] = ACTIONS(7510),
    [anon_sym_COLON] = ACTIONS(7512),
    [anon_sym_DOLLAR] = ACTIONS(7510),
    [anon_sym_AT] = ACTIONS(7510),
    [aux_sym__hex_literal_token1] = ACTIONS(7510),
    [sym__number_literal] = ACTIONS(7512),
    [anon_sym_SQUOTE] = ACTIONS(7510),
    [anon_sym_DQUOTE] = ACTIONS(7510),
    [sym_return] = ACTIONS(7512),
    [sym_next] = ACTIONS(7512),
    [sym_break] = ACTIONS(7512),
    [sym_true] = ACTIONS(7512),
    [sym_false] = ACTIONS(7512),
    [sym_null] = ACTIONS(7512),
    [sym_inf] = ACTIONS(7512),
    [sym_nan] = ACTIONS(7512),
    [anon_sym_NA] = ACTIONS(7512),
    [anon_sym_NA_integer_] = ACTIONS(7512),
    [anon_sym_NA_real_] = ACTIONS(7512),
    [anon_sym_NA_complex_] = ACTIONS(7512),
    [anon_sym_NA_character_] = ACTIONS(7512),
    [sym_dots] = ACTIONS(7512),
    [sym_dot_dot_i] = ACTIONS(7510),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7510),
    [sym__newline] = ACTIONS(7510),
    [sym__raw_string_literal] = ACTIONS(7510),
    [sym__external_else] = ACTIONS(7510),
    [sym__external_open_parenthesis] = ACTIONS(7510),
    [sym__external_open_brace] = ACTIONS(7510),
    [sym__external_open_bracket] = ACTIONS(7510),
    [sym__external_open_bracket2] = ACTIONS(7510),
    [sym__external_close_bracket2] = ACTIONS(7510),
  },
  [2825] = {
    [sym_identifier] = ACTIONS(7563),
    [anon_sym_BSLASH] = ACTIONS(7561),
    [anon_sym_function] = ACTIONS(7563),
    [anon_sym_EQ] = ACTIONS(7563),
    [anon_sym_if] = ACTIONS(7563),
    [anon_sym_for] = ACTIONS(7563),
    [anon_sym_while] = ACTIONS(7563),
    [anon_sym_repeat] = ACTIONS(7563),
    [anon_sym_QMARK] = ACTIONS(7561),
    [anon_sym_TILDE] = ACTIONS(7561),
    [anon_sym_BANG] = ACTIONS(7563),
    [anon_sym_PLUS] = ACTIONS(7561),
    [anon_sym_DASH] = ACTIONS(7563),
    [anon_sym_LT_DASH] = ACTIONS(7561),
    [anon_sym_LT_LT_DASH] = ACTIONS(7561),
    [anon_sym_COLON_EQ] = ACTIONS(7561),
    [anon_sym_DASH_GT] = ACTIONS(7563),
    [anon_sym_DASH_GT_GT] = ACTIONS(7561),
    [anon_sym_PIPE] = ACTIONS(7563),
    [anon_sym_AMP] = ACTIONS(7563),
    [anon_sym_PIPE_PIPE] = ACTIONS(7561),
    [anon_sym_AMP_AMP] = ACTIONS(7561),
    [anon_sym_LT] = ACTIONS(7563),
    [anon_sym_LT_EQ] = ACTIONS(7561),
    [anon_sym_GT] = ACTIONS(7563),
    [anon_sym_GT_EQ] = ACTIONS(7561),
    [anon_sym_EQ_EQ] = ACTIONS(7561),
    [anon_sym_BANG_EQ] = ACTIONS(7561),
    [anon_sym_STAR] = ACTIONS(7563),
    [anon_sym_SLASH] = ACTIONS(7561),
    [anon_sym_STAR_STAR] = ACTIONS(7561),
    [anon_sym_CARET] = ACTIONS(7561),
    [aux_sym_binary_operator_token1] = ACTIONS(7561),
    [anon_sym_PIPE_GT] = ACTIONS(7561),
    [anon_sym_COLON] = ACTIONS(7563),
    [anon_sym_DOLLAR] = ACTIONS(7561),
    [anon_sym_AT] = ACTIONS(7561),
    [aux_sym__hex_literal_token1] = ACTIONS(7561),
    [sym__number_literal] = ACTIONS(7563),
    [anon_sym_SQUOTE] = ACTIONS(7561),
    [anon_sym_DQUOTE] = ACTIONS(7561),
    [sym_return] = ACTIONS(7563),
    [sym_next] = ACTIONS(7563),
    [sym_break] = ACTIONS(7563),
    [sym_true] = ACTIONS(7563),
    [sym_false] = ACTIONS(7563),
    [sym_null] = ACTIONS(7563),
    [sym_inf] = ACTIONS(7563),
    [sym_nan] = ACTIONS(7563),
    [anon_sym_NA] = ACTIONS(7563),
    [anon_sym_NA_integer_] = ACTIONS(7563),
    [anon_sym_NA_real_] = ACTIONS(7563),
    [anon_sym_NA_complex_] = ACTIONS(7563),
    [anon_sym_NA_character_] = ACTIONS(7563),
    [sym_dots] = ACTIONS(7563),
    [sym_dot_dot_i] = ACTIONS(7561),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7561),
    [sym__newline] = ACTIONS(7561),
    [sym__raw_string_literal] = ACTIONS(7561),
    [sym__external_open_parenthesis] = ACTIONS(7561),
    [sym__external_close_parenthesis] = ACTIONS(7561),
    [sym__external_open_brace] = ACTIONS(7561),
    [sym__external_open_bracket] = ACTIONS(7561),
    [sym__external_close_bracket] = ACTIONS(7561),
    [sym__external_open_bracket2] = ACTIONS(7561),
  },
  [2826] = {
    [ts_builtin_sym_end] = ACTIONS(7554),
    [sym_identifier] = ACTIONS(7556),
    [anon_sym_BSLASH] = ACTIONS(7554),
    [anon_sym_function] = ACTIONS(7556),
    [anon_sym_EQ] = ACTIONS(7556),
    [anon_sym_if] = ACTIONS(7556),
    [anon_sym_for] = ACTIONS(7556),
    [anon_sym_while] = ACTIONS(7556),
    [anon_sym_repeat] = ACTIONS(7556),
    [anon_sym_QMARK] = ACTIONS(7554),
    [anon_sym_TILDE] = ACTIONS(7554),
    [anon_sym_BANG] = ACTIONS(7556),
    [anon_sym_PLUS] = ACTIONS(7554),
    [anon_sym_DASH] = ACTIONS(7556),
    [anon_sym_LT_DASH] = ACTIONS(7554),
    [anon_sym_LT_LT_DASH] = ACTIONS(7554),
    [anon_sym_COLON_EQ] = ACTIONS(7554),
    [anon_sym_DASH_GT] = ACTIONS(7556),
    [anon_sym_DASH_GT_GT] = ACTIONS(7554),
    [anon_sym_PIPE] = ACTIONS(7556),
    [anon_sym_AMP] = ACTIONS(7556),
    [anon_sym_PIPE_PIPE] = ACTIONS(7554),
    [anon_sym_AMP_AMP] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(7556),
    [anon_sym_LT_EQ] = ACTIONS(7554),
    [anon_sym_GT] = ACTIONS(7556),
    [anon_sym_GT_EQ] = ACTIONS(7554),
    [anon_sym_EQ_EQ] = ACTIONS(7554),
    [anon_sym_BANG_EQ] = ACTIONS(7554),
    [anon_sym_STAR] = ACTIONS(7556),
    [anon_sym_SLASH] = ACTIONS(7554),
    [anon_sym_STAR_STAR] = ACTIONS(7554),
    [anon_sym_CARET] = ACTIONS(7554),
    [aux_sym_binary_operator_token1] = ACTIONS(7554),
    [anon_sym_PIPE_GT] = ACTIONS(7554),
    [anon_sym_COLON] = ACTIONS(7556),
    [anon_sym_DOLLAR] = ACTIONS(7554),
    [anon_sym_AT] = ACTIONS(7554),
    [aux_sym__hex_literal_token1] = ACTIONS(7554),
    [sym__number_literal] = ACTIONS(7556),
    [anon_sym_SQUOTE] = ACTIONS(7554),
    [anon_sym_DQUOTE] = ACTIONS(7554),
    [sym_return] = ACTIONS(7556),
    [sym_next] = ACTIONS(7556),
    [sym_break] = ACTIONS(7556),
    [sym_true] = ACTIONS(7556),
    [sym_false] = ACTIONS(7556),
    [sym_null] = ACTIONS(7556),
    [sym_inf] = ACTIONS(7556),
    [sym_nan] = ACTIONS(7556),
    [anon_sym_NA] = ACTIONS(7556),
    [anon_sym_NA_integer_] = ACTIONS(7556),
    [anon_sym_NA_real_] = ACTIONS(7556),
    [anon_sym_NA_complex_] = ACTIONS(7556),
    [anon_sym_NA_character_] = ACTIONS(7556),
    [sym_dots] = ACTIONS(7556),
    [sym_dot_dot_i] = ACTIONS(7554),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7554),
    [sym__semicolon] = ACTIONS(7554),
    [sym__raw_string_literal] = ACTIONS(7554),
    [sym__external_open_parenthesis] = ACTIONS(7554),
    [sym__external_close_parenthesis] = ACTIONS(7554),
    [sym__external_open_brace] = ACTIONS(7554),
    [sym__external_open_bracket] = ACTIONS(7554),
    [sym__external_open_bracket2] = ACTIONS(7554),
  },
  [2827] = {
    [ts_builtin_sym_end] = ACTIONS(7472),
    [sym_identifier] = ACTIONS(7474),
    [anon_sym_BSLASH] = ACTIONS(7472),
    [anon_sym_function] = ACTIONS(7474),
    [anon_sym_EQ] = ACTIONS(7474),
    [anon_sym_if] = ACTIONS(7474),
    [anon_sym_for] = ACTIONS(7474),
    [anon_sym_while] = ACTIONS(7474),
    [anon_sym_repeat] = ACTIONS(7474),
    [anon_sym_QMARK] = ACTIONS(7472),
    [anon_sym_TILDE] = ACTIONS(7472),
    [anon_sym_BANG] = ACTIONS(7474),
    [anon_sym_PLUS] = ACTIONS(7472),
    [anon_sym_DASH] = ACTIONS(7474),
    [anon_sym_LT_DASH] = ACTIONS(7472),
    [anon_sym_LT_LT_DASH] = ACTIONS(7472),
    [anon_sym_COLON_EQ] = ACTIONS(7472),
    [anon_sym_DASH_GT] = ACTIONS(7474),
    [anon_sym_DASH_GT_GT] = ACTIONS(7472),
    [anon_sym_PIPE] = ACTIONS(7474),
    [anon_sym_AMP] = ACTIONS(7474),
    [anon_sym_PIPE_PIPE] = ACTIONS(7472),
    [anon_sym_AMP_AMP] = ACTIONS(7472),
    [anon_sym_LT] = ACTIONS(7474),
    [anon_sym_LT_EQ] = ACTIONS(7472),
    [anon_sym_GT] = ACTIONS(7474),
    [anon_sym_GT_EQ] = ACTIONS(7472),
    [anon_sym_EQ_EQ] = ACTIONS(7472),
    [anon_sym_BANG_EQ] = ACTIONS(7472),
    [anon_sym_STAR] = ACTIONS(7474),
    [anon_sym_SLASH] = ACTIONS(7472),
    [anon_sym_STAR_STAR] = ACTIONS(7472),
    [anon_sym_CARET] = ACTIONS(7472),
    [aux_sym_binary_operator_token1] = ACTIONS(7472),
    [anon_sym_PIPE_GT] = ACTIONS(7472),
    [anon_sym_COLON] = ACTIONS(7474),
    [anon_sym_DOLLAR] = ACTIONS(7472),
    [anon_sym_AT] = ACTIONS(7472),
    [aux_sym__hex_literal_token1] = ACTIONS(7472),
    [sym__number_literal] = ACTIONS(7474),
    [anon_sym_SQUOTE] = ACTIONS(7472),
    [anon_sym_DQUOTE] = ACTIONS(7472),
    [sym_return] = ACTIONS(7474),
    [sym_next] = ACTIONS(7474),
    [sym_break] = ACTIONS(7474),
    [sym_true] = ACTIONS(7474),
    [sym_false] = ACTIONS(7474),
    [sym_null] = ACTIONS(7474),
    [sym_inf] = ACTIONS(7474),
    [sym_nan] = ACTIONS(7474),
    [anon_sym_NA] = ACTIONS(7474),
    [anon_sym_NA_integer_] = ACTIONS(7474),
    [anon_sym_NA_real_] = ACTIONS(7474),
    [anon_sym_NA_complex_] = ACTIONS(7474),
    [anon_sym_NA_character_] = ACTIONS(7474),
    [sym_dots] = ACTIONS(7474),
    [sym_dot_dot_i] = ACTIONS(7472),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7472),
    [sym__semicolon] = ACTIONS(7472),
    [sym__raw_string_literal] = ACTIONS(7472),
    [sym__external_open_parenthesis] = ACTIONS(7472),
    [sym__external_close_parenthesis] = ACTIONS(7472),
    [sym__external_open_brace] = ACTIONS(7472),
    [sym__external_open_bracket] = ACTIONS(7472),
    [sym__external_open_bracket2] = ACTIONS(7472),
  },
  [2828] = {
    [ts_builtin_sym_end] = ACTIONS(7466),
    [sym_identifier] = ACTIONS(7464),
    [anon_sym_BSLASH] = ACTIONS(7466),
    [anon_sym_function] = ACTIONS(7464),
    [anon_sym_EQ] = ACTIONS(7464),
    [anon_sym_if] = ACTIONS(7464),
    [anon_sym_for] = ACTIONS(7464),
    [anon_sym_while] = ACTIONS(7464),
    [anon_sym_repeat] = ACTIONS(7464),
    [anon_sym_QMARK] = ACTIONS(7466),
    [anon_sym_TILDE] = ACTIONS(7466),
    [anon_sym_BANG] = ACTIONS(7464),
    [anon_sym_PLUS] = ACTIONS(7466),
    [anon_sym_DASH] = ACTIONS(7464),
    [anon_sym_LT_DASH] = ACTIONS(7466),
    [anon_sym_LT_LT_DASH] = ACTIONS(7466),
    [anon_sym_COLON_EQ] = ACTIONS(7466),
    [anon_sym_DASH_GT] = ACTIONS(7464),
    [anon_sym_DASH_GT_GT] = ACTIONS(7466),
    [anon_sym_PIPE] = ACTIONS(7464),
    [anon_sym_AMP] = ACTIONS(7464),
    [anon_sym_PIPE_PIPE] = ACTIONS(7466),
    [anon_sym_AMP_AMP] = ACTIONS(7466),
    [anon_sym_LT] = ACTIONS(7464),
    [anon_sym_LT_EQ] = ACTIONS(7466),
    [anon_sym_GT] = ACTIONS(7464),
    [anon_sym_GT_EQ] = ACTIONS(7466),
    [anon_sym_EQ_EQ] = ACTIONS(7466),
    [anon_sym_BANG_EQ] = ACTIONS(7466),
    [anon_sym_STAR] = ACTIONS(7464),
    [anon_sym_SLASH] = ACTIONS(7466),
    [anon_sym_STAR_STAR] = ACTIONS(7466),
    [anon_sym_CARET] = ACTIONS(7466),
    [aux_sym_binary_operator_token1] = ACTIONS(7466),
    [anon_sym_PIPE_GT] = ACTIONS(7466),
    [anon_sym_COLON] = ACTIONS(7464),
    [anon_sym_DOLLAR] = ACTIONS(7466),
    [anon_sym_AT] = ACTIONS(7466),
    [aux_sym__hex_literal_token1] = ACTIONS(7466),
    [sym__number_literal] = ACTIONS(7464),
    [anon_sym_SQUOTE] = ACTIONS(7466),
    [anon_sym_DQUOTE] = ACTIONS(7466),
    [sym_return] = ACTIONS(7464),
    [sym_next] = ACTIONS(7464),
    [sym_break] = ACTIONS(7464),
    [sym_true] = ACTIONS(7464),
    [sym_false] = ACTIONS(7464),
    [sym_null] = ACTIONS(7464),
    [sym_inf] = ACTIONS(7464),
    [sym_nan] = ACTIONS(7464),
    [anon_sym_NA] = ACTIONS(7464),
    [anon_sym_NA_integer_] = ACTIONS(7464),
    [anon_sym_NA_real_] = ACTIONS(7464),
    [anon_sym_NA_complex_] = ACTIONS(7464),
    [anon_sym_NA_character_] = ACTIONS(7464),
    [sym_dots] = ACTIONS(7464),
    [sym_dot_dot_i] = ACTIONS(7466),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7466),
    [sym__semicolon] = ACTIONS(7466),
    [sym__raw_string_literal] = ACTIONS(7466),
    [sym__external_open_parenthesis] = ACTIONS(7466),
    [sym__external_close_parenthesis] = ACTIONS(7466),
    [sym__external_open_brace] = ACTIONS(7466),
    [sym__external_open_bracket] = ACTIONS(7466),
    [sym__external_open_bracket2] = ACTIONS(7466),
  },
  [2829] = {
    [ts_builtin_sym_end] = ACTIONS(7565),
    [sym_identifier] = ACTIONS(7567),
    [anon_sym_BSLASH] = ACTIONS(7565),
    [anon_sym_function] = ACTIONS(7567),
    [anon_sym_EQ] = ACTIONS(7567),
    [anon_sym_if] = ACTIONS(7567),
    [anon_sym_for] = ACTIONS(7567),
    [anon_sym_while] = ACTIONS(7567),
    [anon_sym_repeat] = ACTIONS(7567),
    [anon_sym_QMARK] = ACTIONS(7565),
    [anon_sym_TILDE] = ACTIONS(7565),
    [anon_sym_BANG] = ACTIONS(7567),
    [anon_sym_PLUS] = ACTIONS(7565),
    [anon_sym_DASH] = ACTIONS(7567),
    [anon_sym_LT_DASH] = ACTIONS(7565),
    [anon_sym_LT_LT_DASH] = ACTIONS(7565),
    [anon_sym_COLON_EQ] = ACTIONS(7565),
    [anon_sym_DASH_GT] = ACTIONS(7567),
    [anon_sym_DASH_GT_GT] = ACTIONS(7565),
    [anon_sym_PIPE] = ACTIONS(7567),
    [anon_sym_AMP] = ACTIONS(7567),
    [anon_sym_PIPE_PIPE] = ACTIONS(7565),
    [anon_sym_AMP_AMP] = ACTIONS(7565),
    [anon_sym_LT] = ACTIONS(7567),
    [anon_sym_LT_EQ] = ACTIONS(7565),
    [anon_sym_GT] = ACTIONS(7567),
    [anon_sym_GT_EQ] = ACTIONS(7565),
    [anon_sym_EQ_EQ] = ACTIONS(7565),
    [anon_sym_BANG_EQ] = ACTIONS(7565),
    [anon_sym_STAR] = ACTIONS(7567),
    [anon_sym_SLASH] = ACTIONS(7565),
    [anon_sym_STAR_STAR] = ACTIONS(7565),
    [anon_sym_CARET] = ACTIONS(7565),
    [aux_sym_binary_operator_token1] = ACTIONS(7565),
    [anon_sym_PIPE_GT] = ACTIONS(7565),
    [anon_sym_COLON] = ACTIONS(7567),
    [anon_sym_DOLLAR] = ACTIONS(7565),
    [anon_sym_AT] = ACTIONS(7565),
    [aux_sym__hex_literal_token1] = ACTIONS(7565),
    [sym__number_literal] = ACTIONS(7567),
    [anon_sym_SQUOTE] = ACTIONS(7565),
    [anon_sym_DQUOTE] = ACTIONS(7565),
    [sym_return] = ACTIONS(7567),
    [sym_next] = ACTIONS(7567),
    [sym_break] = ACTIONS(7567),
    [sym_true] = ACTIONS(7567),
    [sym_false] = ACTIONS(7567),
    [sym_null] = ACTIONS(7567),
    [sym_inf] = ACTIONS(7567),
    [sym_nan] = ACTIONS(7567),
    [anon_sym_NA] = ACTIONS(7567),
    [anon_sym_NA_integer_] = ACTIONS(7567),
    [anon_sym_NA_real_] = ACTIONS(7567),
    [anon_sym_NA_complex_] = ACTIONS(7567),
    [anon_sym_NA_character_] = ACTIONS(7567),
    [sym_dots] = ACTIONS(7567),
    [sym_dot_dot_i] = ACTIONS(7565),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7565),
    [sym__semicolon] = ACTIONS(7565),
    [sym__raw_string_literal] = ACTIONS(7565),
    [sym__external_else] = ACTIONS(7565),
    [sym__external_open_parenthesis] = ACTIONS(7565),
    [sym__external_open_brace] = ACTIONS(7565),
    [sym__external_open_bracket] = ACTIONS(7565),
    [sym__external_open_bracket2] = ACTIONS(7565),
  },
  [2830] = {
    [ts_builtin_sym_end] = ACTIONS(7496),
    [sym_identifier] = ACTIONS(7498),
    [anon_sym_BSLASH] = ACTIONS(7496),
    [anon_sym_function] = ACTIONS(7498),
    [anon_sym_EQ] = ACTIONS(7498),
    [anon_sym_if] = ACTIONS(7498),
    [anon_sym_for] = ACTIONS(7498),
    [anon_sym_while] = ACTIONS(7498),
    [anon_sym_repeat] = ACTIONS(7498),
    [anon_sym_QMARK] = ACTIONS(7496),
    [anon_sym_TILDE] = ACTIONS(7496),
    [anon_sym_BANG] = ACTIONS(7498),
    [anon_sym_PLUS] = ACTIONS(7496),
    [anon_sym_DASH] = ACTIONS(7498),
    [anon_sym_LT_DASH] = ACTIONS(7496),
    [anon_sym_LT_LT_DASH] = ACTIONS(7496),
    [anon_sym_COLON_EQ] = ACTIONS(7496),
    [anon_sym_DASH_GT] = ACTIONS(7498),
    [anon_sym_DASH_GT_GT] = ACTIONS(7496),
    [anon_sym_PIPE] = ACTIONS(7498),
    [anon_sym_AMP] = ACTIONS(7498),
    [anon_sym_PIPE_PIPE] = ACTIONS(7496),
    [anon_sym_AMP_AMP] = ACTIONS(7496),
    [anon_sym_LT] = ACTIONS(7498),
    [anon_sym_LT_EQ] = ACTIONS(7496),
    [anon_sym_GT] = ACTIONS(7498),
    [anon_sym_GT_EQ] = ACTIONS(7496),
    [anon_sym_EQ_EQ] = ACTIONS(7496),
    [anon_sym_BANG_EQ] = ACTIONS(7496),
    [anon_sym_STAR] = ACTIONS(7498),
    [anon_sym_SLASH] = ACTIONS(7496),
    [anon_sym_STAR_STAR] = ACTIONS(7496),
    [anon_sym_CARET] = ACTIONS(7496),
    [aux_sym_binary_operator_token1] = ACTIONS(7496),
    [anon_sym_PIPE_GT] = ACTIONS(7496),
    [anon_sym_COLON] = ACTIONS(7498),
    [anon_sym_DOLLAR] = ACTIONS(7496),
    [anon_sym_AT] = ACTIONS(7496),
    [aux_sym__hex_literal_token1] = ACTIONS(7496),
    [sym__number_literal] = ACTIONS(7498),
    [anon_sym_SQUOTE] = ACTIONS(7496),
    [anon_sym_DQUOTE] = ACTIONS(7496),
    [sym_return] = ACTIONS(7498),
    [sym_next] = ACTIONS(7498),
    [sym_break] = ACTIONS(7498),
    [sym_true] = ACTIONS(7498),
    [sym_false] = ACTIONS(7498),
    [sym_null] = ACTIONS(7498),
    [sym_inf] = ACTIONS(7498),
    [sym_nan] = ACTIONS(7498),
    [anon_sym_NA] = ACTIONS(7498),
    [anon_sym_NA_integer_] = ACTIONS(7498),
    [anon_sym_NA_real_] = ACTIONS(7498),
    [anon_sym_NA_complex_] = ACTIONS(7498),
    [anon_sym_NA_character_] = ACTIONS(7498),
    [sym_dots] = ACTIONS(7498),
    [sym_dot_dot_i] = ACTIONS(7496),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7496),
    [sym__semicolon] = ACTIONS(7496),
    [sym__raw_string_literal] = ACTIONS(7496),
    [sym__external_open_parenthesis] = ACTIONS(7496),
    [sym__external_open_brace] = ACTIONS(7496),
    [sym__external_close_brace] = ACTIONS(7496),
    [sym__external_open_bracket] = ACTIONS(7496),
    [sym__external_open_bracket2] = ACTIONS(7496),
  },
  [2831] = {
    [sym_identifier] = ACTIONS(7512),
    [anon_sym_BSLASH] = ACTIONS(7510),
    [anon_sym_function] = ACTIONS(7512),
    [anon_sym_EQ] = ACTIONS(7512),
    [anon_sym_if] = ACTIONS(7512),
    [anon_sym_for] = ACTIONS(7512),
    [anon_sym_while] = ACTIONS(7512),
    [anon_sym_repeat] = ACTIONS(7512),
    [anon_sym_QMARK] = ACTIONS(7510),
    [anon_sym_TILDE] = ACTIONS(7510),
    [anon_sym_BANG] = ACTIONS(7512),
    [anon_sym_PLUS] = ACTIONS(7510),
    [anon_sym_DASH] = ACTIONS(7512),
    [anon_sym_LT_DASH] = ACTIONS(7510),
    [anon_sym_LT_LT_DASH] = ACTIONS(7510),
    [anon_sym_COLON_EQ] = ACTIONS(7510),
    [anon_sym_DASH_GT] = ACTIONS(7512),
    [anon_sym_DASH_GT_GT] = ACTIONS(7510),
    [anon_sym_PIPE] = ACTIONS(7512),
    [anon_sym_AMP] = ACTIONS(7512),
    [anon_sym_PIPE_PIPE] = ACTIONS(7510),
    [anon_sym_AMP_AMP] = ACTIONS(7510),
    [anon_sym_LT] = ACTIONS(7512),
    [anon_sym_LT_EQ] = ACTIONS(7510),
    [anon_sym_GT] = ACTIONS(7512),
    [anon_sym_GT_EQ] = ACTIONS(7510),
    [anon_sym_EQ_EQ] = ACTIONS(7510),
    [anon_sym_BANG_EQ] = ACTIONS(7510),
    [anon_sym_STAR] = ACTIONS(7512),
    [anon_sym_SLASH] = ACTIONS(7510),
    [anon_sym_STAR_STAR] = ACTIONS(7510),
    [anon_sym_CARET] = ACTIONS(7510),
    [aux_sym_binary_operator_token1] = ACTIONS(7510),
    [anon_sym_PIPE_GT] = ACTIONS(7510),
    [anon_sym_COLON] = ACTIONS(7512),
    [anon_sym_DOLLAR] = ACTIONS(7510),
    [anon_sym_AT] = ACTIONS(7510),
    [aux_sym__hex_literal_token1] = ACTIONS(7510),
    [sym__number_literal] = ACTIONS(7512),
    [anon_sym_SQUOTE] = ACTIONS(7510),
    [anon_sym_DQUOTE] = ACTIONS(7510),
    [sym_return] = ACTIONS(7512),
    [sym_next] = ACTIONS(7512),
    [sym_break] = ACTIONS(7512),
    [sym_true] = ACTIONS(7512),
    [sym_false] = ACTIONS(7512),
    [sym_null] = ACTIONS(7512),
    [sym_inf] = ACTIONS(7512),
    [sym_nan] = ACTIONS(7512),
    [anon_sym_NA] = ACTIONS(7512),
    [anon_sym_NA_integer_] = ACTIONS(7512),
    [anon_sym_NA_real_] = ACTIONS(7512),
    [anon_sym_NA_complex_] = ACTIONS(7512),
    [anon_sym_NA_character_] = ACTIONS(7512),
    [sym_dots] = ACTIONS(7512),
    [sym_dot_dot_i] = ACTIONS(7510),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7510),
    [sym__newline] = ACTIONS(7510),
    [sym__raw_string_literal] = ACTIONS(7510),
    [sym__external_open_parenthesis] = ACTIONS(7510),
    [sym__external_close_parenthesis] = ACTIONS(7510),
    [sym__external_open_brace] = ACTIONS(7510),
    [sym__external_open_bracket] = ACTIONS(7510),
    [sym__external_open_bracket2] = ACTIONS(7510),
    [sym__external_close_bracket2] = ACTIONS(7510),
  },
  [2832] = {
    [ts_builtin_sym_end] = ACTIONS(7538),
    [sym_identifier] = ACTIONS(7540),
    [anon_sym_BSLASH] = ACTIONS(7538),
    [anon_sym_function] = ACTIONS(7540),
    [anon_sym_EQ] = ACTIONS(7540),
    [anon_sym_if] = ACTIONS(7540),
    [anon_sym_for] = ACTIONS(7540),
    [anon_sym_while] = ACTIONS(7540),
    [anon_sym_repeat] = ACTIONS(7540),
    [anon_sym_QMARK] = ACTIONS(7538),
    [anon_sym_TILDE] = ACTIONS(7538),
    [anon_sym_BANG] = ACTIONS(7540),
    [anon_sym_PLUS] = ACTIONS(7538),
    [anon_sym_DASH] = ACTIONS(7540),
    [anon_sym_LT_DASH] = ACTIONS(7538),
    [anon_sym_LT_LT_DASH] = ACTIONS(7538),
    [anon_sym_COLON_EQ] = ACTIONS(7538),
    [anon_sym_DASH_GT] = ACTIONS(7540),
    [anon_sym_DASH_GT_GT] = ACTIONS(7538),
    [anon_sym_PIPE] = ACTIONS(7540),
    [anon_sym_AMP] = ACTIONS(7540),
    [anon_sym_PIPE_PIPE] = ACTIONS(7538),
    [anon_sym_AMP_AMP] = ACTIONS(7538),
    [anon_sym_LT] = ACTIONS(7540),
    [anon_sym_LT_EQ] = ACTIONS(7538),
    [anon_sym_GT] = ACTIONS(7540),
    [anon_sym_GT_EQ] = ACTIONS(7538),
    [anon_sym_EQ_EQ] = ACTIONS(7538),
    [anon_sym_BANG_EQ] = ACTIONS(7538),
    [anon_sym_STAR] = ACTIONS(7540),
    [anon_sym_SLASH] = ACTIONS(7538),
    [anon_sym_STAR_STAR] = ACTIONS(7538),
    [anon_sym_CARET] = ACTIONS(7538),
    [aux_sym_binary_operator_token1] = ACTIONS(7538),
    [anon_sym_PIPE_GT] = ACTIONS(7538),
    [anon_sym_COLON] = ACTIONS(7540),
    [anon_sym_DOLLAR] = ACTIONS(7538),
    [anon_sym_AT] = ACTIONS(7538),
    [aux_sym__hex_literal_token1] = ACTIONS(7538),
    [sym__number_literal] = ACTIONS(7540),
    [anon_sym_SQUOTE] = ACTIONS(7538),
    [anon_sym_DQUOTE] = ACTIONS(7538),
    [sym_return] = ACTIONS(7540),
    [sym_next] = ACTIONS(7540),
    [sym_break] = ACTIONS(7540),
    [sym_true] = ACTIONS(7540),
    [sym_false] = ACTIONS(7540),
    [sym_null] = ACTIONS(7540),
    [sym_inf] = ACTIONS(7540),
    [sym_nan] = ACTIONS(7540),
    [anon_sym_NA] = ACTIONS(7540),
    [anon_sym_NA_integer_] = ACTIONS(7540),
    [anon_sym_NA_real_] = ACTIONS(7540),
    [anon_sym_NA_complex_] = ACTIONS(7540),
    [anon_sym_NA_character_] = ACTIONS(7540),
    [sym_dots] = ACTIONS(7540),
    [sym_dot_dot_i] = ACTIONS(7538),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7538),
    [sym__semicolon] = ACTIONS(7538),
    [sym__raw_string_literal] = ACTIONS(7538),
    [sym__external_open_parenthesis] = ACTIONS(7538),
    [sym__external_open_brace] = ACTIONS(7538),
    [sym__external_close_brace] = ACTIONS(7538),
    [sym__external_open_bracket] = ACTIONS(7538),
    [sym__external_open_bracket2] = ACTIONS(7538),
  },
  [2833] = {
    [ts_builtin_sym_end] = ACTIONS(7476),
    [sym_identifier] = ACTIONS(7478),
    [anon_sym_BSLASH] = ACTIONS(7476),
    [anon_sym_function] = ACTIONS(7478),
    [anon_sym_EQ] = ACTIONS(7478),
    [anon_sym_if] = ACTIONS(7478),
    [anon_sym_for] = ACTIONS(7478),
    [anon_sym_while] = ACTIONS(7478),
    [anon_sym_repeat] = ACTIONS(7478),
    [anon_sym_QMARK] = ACTIONS(7476),
    [anon_sym_TILDE] = ACTIONS(7476),
    [anon_sym_BANG] = ACTIONS(7478),
    [anon_sym_PLUS] = ACTIONS(7476),
    [anon_sym_DASH] = ACTIONS(7478),
    [anon_sym_LT_DASH] = ACTIONS(7476),
    [anon_sym_LT_LT_DASH] = ACTIONS(7476),
    [anon_sym_COLON_EQ] = ACTIONS(7476),
    [anon_sym_DASH_GT] = ACTIONS(7478),
    [anon_sym_DASH_GT_GT] = ACTIONS(7476),
    [anon_sym_PIPE] = ACTIONS(7478),
    [anon_sym_AMP] = ACTIONS(7478),
    [anon_sym_PIPE_PIPE] = ACTIONS(7476),
    [anon_sym_AMP_AMP] = ACTIONS(7476),
    [anon_sym_LT] = ACTIONS(7478),
    [anon_sym_LT_EQ] = ACTIONS(7476),
    [anon_sym_GT] = ACTIONS(7478),
    [anon_sym_GT_EQ] = ACTIONS(7476),
    [anon_sym_EQ_EQ] = ACTIONS(7476),
    [anon_sym_BANG_EQ] = ACTIONS(7476),
    [anon_sym_STAR] = ACTIONS(7478),
    [anon_sym_SLASH] = ACTIONS(7476),
    [anon_sym_STAR_STAR] = ACTIONS(7476),
    [anon_sym_CARET] = ACTIONS(7476),
    [aux_sym_binary_operator_token1] = ACTIONS(7476),
    [anon_sym_PIPE_GT] = ACTIONS(7476),
    [anon_sym_COLON] = ACTIONS(7478),
    [anon_sym_DOLLAR] = ACTIONS(7476),
    [anon_sym_AT] = ACTIONS(7476),
    [aux_sym__hex_literal_token1] = ACTIONS(7476),
    [sym__number_literal] = ACTIONS(7478),
    [anon_sym_SQUOTE] = ACTIONS(7476),
    [anon_sym_DQUOTE] = ACTIONS(7476),
    [sym_return] = ACTIONS(7478),
    [sym_next] = ACTIONS(7478),
    [sym_break] = ACTIONS(7478),
    [sym_true] = ACTIONS(7478),
    [sym_false] = ACTIONS(7478),
    [sym_null] = ACTIONS(7478),
    [sym_inf] = ACTIONS(7478),
    [sym_nan] = ACTIONS(7478),
    [anon_sym_NA] = ACTIONS(7478),
    [anon_sym_NA_integer_] = ACTIONS(7478),
    [anon_sym_NA_real_] = ACTIONS(7478),
    [anon_sym_NA_complex_] = ACTIONS(7478),
    [anon_sym_NA_character_] = ACTIONS(7478),
    [sym_dots] = ACTIONS(7478),
    [sym_dot_dot_i] = ACTIONS(7476),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7476),
    [sym__semicolon] = ACTIONS(7476),
    [sym__raw_string_literal] = ACTIONS(7476),
    [sym__external_open_parenthesis] = ACTIONS(7476),
    [sym__external_close_parenthesis] = ACTIONS(7476),
    [sym__external_open_brace] = ACTIONS(7476),
    [sym__external_open_bracket] = ACTIONS(7476),
    [sym__external_open_bracket2] = ACTIONS(7476),
  },
  [2834] = {
    [ts_builtin_sym_end] = ACTIONS(7542),
    [sym_identifier] = ACTIONS(7544),
    [anon_sym_BSLASH] = ACTIONS(7542),
    [anon_sym_function] = ACTIONS(7544),
    [anon_sym_EQ] = ACTIONS(7544),
    [anon_sym_if] = ACTIONS(7544),
    [anon_sym_for] = ACTIONS(7544),
    [anon_sym_while] = ACTIONS(7544),
    [anon_sym_repeat] = ACTIONS(7544),
    [anon_sym_QMARK] = ACTIONS(7542),
    [anon_sym_TILDE] = ACTIONS(7542),
    [anon_sym_BANG] = ACTIONS(7544),
    [anon_sym_PLUS] = ACTIONS(7542),
    [anon_sym_DASH] = ACTIONS(7544),
    [anon_sym_LT_DASH] = ACTIONS(7542),
    [anon_sym_LT_LT_DASH] = ACTIONS(7542),
    [anon_sym_COLON_EQ] = ACTIONS(7542),
    [anon_sym_DASH_GT] = ACTIONS(7544),
    [anon_sym_DASH_GT_GT] = ACTIONS(7542),
    [anon_sym_PIPE] = ACTIONS(7544),
    [anon_sym_AMP] = ACTIONS(7544),
    [anon_sym_PIPE_PIPE] = ACTIONS(7542),
    [anon_sym_AMP_AMP] = ACTIONS(7542),
    [anon_sym_LT] = ACTIONS(7544),
    [anon_sym_LT_EQ] = ACTIONS(7542),
    [anon_sym_GT] = ACTIONS(7544),
    [anon_sym_GT_EQ] = ACTIONS(7542),
    [anon_sym_EQ_EQ] = ACTIONS(7542),
    [anon_sym_BANG_EQ] = ACTIONS(7542),
    [anon_sym_STAR] = ACTIONS(7544),
    [anon_sym_SLASH] = ACTIONS(7542),
    [anon_sym_STAR_STAR] = ACTIONS(7542),
    [anon_sym_CARET] = ACTIONS(7542),
    [aux_sym_binary_operator_token1] = ACTIONS(7542),
    [anon_sym_PIPE_GT] = ACTIONS(7542),
    [anon_sym_COLON] = ACTIONS(7544),
    [anon_sym_DOLLAR] = ACTIONS(7542),
    [anon_sym_AT] = ACTIONS(7542),
    [aux_sym__hex_literal_token1] = ACTIONS(7542),
    [sym__number_literal] = ACTIONS(7544),
    [anon_sym_SQUOTE] = ACTIONS(7542),
    [anon_sym_DQUOTE] = ACTIONS(7542),
    [sym_return] = ACTIONS(7544),
    [sym_next] = ACTIONS(7544),
    [sym_break] = ACTIONS(7544),
    [sym_true] = ACTIONS(7544),
    [sym_false] = ACTIONS(7544),
    [sym_null] = ACTIONS(7544),
    [sym_inf] = ACTIONS(7544),
    [sym_nan] = ACTIONS(7544),
    [anon_sym_NA] = ACTIONS(7544),
    [anon_sym_NA_integer_] = ACTIONS(7544),
    [anon_sym_NA_real_] = ACTIONS(7544),
    [anon_sym_NA_complex_] = ACTIONS(7544),
    [anon_sym_NA_character_] = ACTIONS(7544),
    [sym_dots] = ACTIONS(7544),
    [sym_dot_dot_i] = ACTIONS(7542),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7542),
    [sym__semicolon] = ACTIONS(7542),
    [sym__raw_string_literal] = ACTIONS(7542),
    [sym__external_open_parenthesis] = ACTIONS(7542),
    [sym__external_open_brace] = ACTIONS(7542),
    [sym__external_close_brace] = ACTIONS(7542),
    [sym__external_open_bracket] = ACTIONS(7542),
    [sym__external_open_bracket2] = ACTIONS(7542),
  },
  [2835] = {
    [sym_function_definition] = STATE(2038),
    [sym_if_statement] = STATE(2038),
    [sym_for_statement] = STATE(2038),
    [sym_while_statement] = STATE(2038),
    [sym_repeat_statement] = STATE(2038),
    [sym_braced_expression] = STATE(2038),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_call] = STATE(2038),
    [sym_subset] = STATE(2038),
    [sym_subset2] = STATE(2038),
    [sym__argument_value] = STATE(4682),
    [sym_unary_operator] = STATE(2038),
    [sym_binary_operator] = STATE(2038),
    [sym_extract_operator] = STATE(2038),
    [sym_namespace_operator] = STATE(2038),
    [sym_integer] = STATE(2038),
    [sym_complex] = STATE(2038),
    [sym_float] = STATE(2038),
    [sym__hex_literal] = STATE(2700),
    [sym__float_literal] = STATE(2700),
    [sym_string] = STATE(2664),
    [sym__single_quoted_string] = STATE(2701),
    [sym__double_quoted_string] = STATE(2745),
    [sym_na] = STATE(2038),
    [sym__expression] = STATE(2038),
    [sym__string_or_identifier] = STATE(5148),
    [sym__open_parenthesis] = STATE(214),
    [sym__open_brace] = STATE(192),
    [sym_identifier] = ACTIONS(4752),
    [anon_sym_BSLASH] = ACTIONS(4754),
    [anon_sym_function] = ACTIONS(4756),
    [anon_sym_if] = ACTIONS(4758),
    [anon_sym_for] = ACTIONS(4760),
    [anon_sym_while] = ACTIONS(4762),
    [anon_sym_repeat] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4766),
    [anon_sym_TILDE] = ACTIONS(4768),
    [anon_sym_BANG] = ACTIONS(6353),
    [anon_sym_PLUS] = ACTIONS(4772),
    [anon_sym_DASH] = ACTIONS(4772),
    [aux_sym__hex_literal_token1] = ACTIONS(4776),
    [sym__number_literal] = ACTIONS(4778),
    [anon_sym_SQUOTE] = ACTIONS(4780),
    [anon_sym_DQUOTE] = ACTIONS(4782),
    [sym_return] = ACTIONS(6355),
    [sym_next] = ACTIONS(6355),
    [sym_break] = ACTIONS(6355),
    [sym_true] = ACTIONS(6355),
    [sym_false] = ACTIONS(6355),
    [sym_null] = ACTIONS(6355),
    [sym_inf] = ACTIONS(6355),
    [sym_nan] = ACTIONS(6355),
    [anon_sym_NA] = ACTIONS(4786),
    [anon_sym_NA_integer_] = ACTIONS(4786),
    [anon_sym_NA_real_] = ACTIONS(4786),
    [anon_sym_NA_complex_] = ACTIONS(4786),
    [anon_sym_NA_character_] = ACTIONS(4786),
    [sym_dots] = ACTIONS(6355),
    [sym_dot_dot_i] = ACTIONS(6359),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7695),
    [sym__newline] = ACTIONS(6363),
    [sym__raw_string_literal] = ACTIONS(4790),
    [sym__external_open_parenthesis] = ACTIONS(4792),
    [sym__external_open_brace] = ACTIONS(4794),
    [sym__external_close_bracket] = ACTIONS(7695),
  },
  [2836] = {
    [ts_builtin_sym_end] = ACTIONS(7476),
    [sym_identifier] = ACTIONS(7478),
    [anon_sym_BSLASH] = ACTIONS(7476),
    [anon_sym_function] = ACTIONS(7478),
    [anon_sym_EQ] = ACTIONS(7478),
    [anon_sym_if] = ACTIONS(7478),
    [anon_sym_for] = ACTIONS(7478),
    [anon_sym_while] = ACTIONS(7478),
    [anon_sym_repeat] = ACTIONS(7478),
    [anon_sym_QMARK] = ACTIONS(7476),
    [anon_sym_TILDE] = ACTIONS(7476),
    [anon_sym_BANG] = ACTIONS(7478),
    [anon_sym_PLUS] = ACTIONS(7476),
    [anon_sym_DASH] = ACTIONS(7478),
    [anon_sym_LT_DASH] = ACTIONS(7476),
    [anon_sym_LT_LT_DASH] = ACTIONS(7476),
    [anon_sym_COLON_EQ] = ACTIONS(7476),
    [anon_sym_DASH_GT] = ACTIONS(7478),
    [anon_sym_DASH_GT_GT] = ACTIONS(7476),
    [anon_sym_PIPE] = ACTIONS(7478),
    [anon_sym_AMP] = ACTIONS(7478),
    [anon_sym_PIPE_PIPE] = ACTIONS(7476),
    [anon_sym_AMP_AMP] = ACTIONS(7476),
    [anon_sym_LT] = ACTIONS(7478),
    [anon_sym_LT_EQ] = ACTIONS(7476),
    [anon_sym_GT] = ACTIONS(7478),
    [anon_sym_GT_EQ] = ACTIONS(7476),
    [anon_sym_EQ_EQ] = ACTIONS(7476),
    [anon_sym_BANG_EQ] = ACTIONS(7476),
    [anon_sym_STAR] = ACTIONS(7478),
    [anon_sym_SLASH] = ACTIONS(7476),
    [anon_sym_STAR_STAR] = ACTIONS(7476),
    [anon_sym_CARET] = ACTIONS(7476),
    [aux_sym_binary_operator_token1] = ACTIONS(7476),
    [anon_sym_PIPE_GT] = ACTIONS(7476),
    [anon_sym_COLON] = ACTIONS(7478),
    [anon_sym_DOLLAR] = ACTIONS(7476),
    [anon_sym_AT] = ACTIONS(7476),
    [aux_sym__hex_literal_token1] = ACTIONS(7476),
    [sym__number_literal] = ACTIONS(7478),
    [anon_sym_SQUOTE] = ACTIONS(7476),
    [anon_sym_DQUOTE] = ACTIONS(7476),
    [sym_return] = ACTIONS(7478),
    [sym_next] = ACTIONS(7478),
    [sym_break] = ACTIONS(7478),
    [sym_true] = ACTIONS(7478),
    [sym_false] = ACTIONS(7478),
    [sym_null] = ACTIONS(7478),
    [sym_inf] = ACTIONS(7478),
    [sym_nan] = ACTIONS(7478),
    [anon_sym_NA] = ACTIONS(7478),
    [anon_sym_NA_integer_] = ACTIONS(7478),
    [anon_sym_NA_real_] = ACTIONS(7478),
    [anon_sym_NA_complex_] = ACTIONS(7478),
    [anon_sym_NA_character_] = ACTIONS(7478),
    [sym_dots] = ACTIONS(7478),
    [sym_dot_dot_i] = ACTIONS(7476),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7476),
    [sym__semicolon] = ACTIONS(7476),
    [sym__raw_string_literal] = ACTIONS(7476),
    [sym__external_open_parenthesis] = ACTIONS(7476),
    [sym__external_open_brace] = ACTIONS(7476),
    [sym__external_close_brace] = ACTIONS(7476),
    [sym__external_open_bracket] = ACTIONS(7476),
    [sym__external_open_bracket2] = ACTIONS(7476),
  },
  [2837] = {
    [ts_builtin_sym_end] = ACTIONS(7480),
    [sym_identifier] = ACTIONS(7482),
    [anon_sym_BSLASH] = ACTIONS(7480),
    [anon_sym_function] = ACTIONS(7482),
    [anon_sym_EQ] = ACTIONS(7482),
    [anon_sym_if] = ACTIONS(7482),
    [anon_sym_for] = ACTIONS(7482),
    [anon_sym_while] = ACTIONS(7482),
    [anon_sym_repeat] = ACTIONS(7482),
    [anon_sym_QMARK] = ACTIONS(7480),
    [anon_sym_TILDE] = ACTIONS(7480),
    [anon_sym_BANG] = ACTIONS(7482),
    [anon_sym_PLUS] = ACTIONS(7480),
    [anon_sym_DASH] = ACTIONS(7482),
    [anon_sym_LT_DASH] = ACTIONS(7480),
    [anon_sym_LT_LT_DASH] = ACTIONS(7480),
    [anon_sym_COLON_EQ] = ACTIONS(7480),
    [anon_sym_DASH_GT] = ACTIONS(7482),
    [anon_sym_DASH_GT_GT] = ACTIONS(7480),
    [anon_sym_PIPE] = ACTIONS(7482),
    [anon_sym_AMP] = ACTIONS(7482),
    [anon_sym_PIPE_PIPE] = ACTIONS(7480),
    [anon_sym_AMP_AMP] = ACTIONS(7480),
    [anon_sym_LT] = ACTIONS(7482),
    [anon_sym_LT_EQ] = ACTIONS(7480),
    [anon_sym_GT] = ACTIONS(7482),
    [anon_sym_GT_EQ] = ACTIONS(7480),
    [anon_sym_EQ_EQ] = ACTIONS(7480),
    [anon_sym_BANG_EQ] = ACTIONS(7480),
    [anon_sym_STAR] = ACTIONS(7482),
    [anon_sym_SLASH] = ACTIONS(7480),
    [anon_sym_STAR_STAR] = ACTIONS(7480),
    [anon_sym_CARET] = ACTIONS(7480),
    [aux_sym_binary_operator_token1] = ACTIONS(7480),
    [anon_sym_PIPE_GT] = ACTIONS(7480),
    [anon_sym_COLON] = ACTIONS(7482),
    [anon_sym_DOLLAR] = ACTIONS(7480),
    [anon_sym_AT] = ACTIONS(7480),
    [aux_sym__hex_literal_token1] = ACTIONS(7480),
    [sym__number_literal] = ACTIONS(7482),
    [anon_sym_SQUOTE] = ACTIONS(7480),
    [anon_sym_DQUOTE] = ACTIONS(7480),
    [sym_return] = ACTIONS(7482),
    [sym_next] = ACTIONS(7482),
    [sym_break] = ACTIONS(7482),
    [sym_true] = ACTIONS(7482),
    [sym_false] = ACTIONS(7482),
    [sym_null] = ACTIONS(7482),
    [sym_inf] = ACTIONS(7482),
    [sym_nan] = ACTIONS(7482),
    [anon_sym_NA] = ACTIONS(7482),
    [anon_sym_NA_integer_] = ACTIONS(7482),
    [anon_sym_NA_real_] = ACTIONS(7482),
    [anon_sym_NA_complex_] = ACTIONS(7482),
    [anon_sym_NA_character_] = ACTIONS(7482),
    [sym_dots] = ACTIONS(7482),
    [sym_dot_dot_i] = ACTIONS(7480),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7480),
    [sym__semicolon] = ACTIONS(7480),
    [sym__raw_string_literal] = ACTIONS(7480),
    [sym__external_open_parenthesis] = ACTIONS(7480),
    [sym__external_close_parenthesis] = ACTIONS(7480),
    [sym__external_open_brace] = ACTIONS(7480),
    [sym__external_open_bracket] = ACTIONS(7480),
    [sym__external_open_bracket2] = ACTIONS(7480),
  },
  [2838] = {
    [sym_identifier] = ACTIONS(5311),
    [anon_sym_BSLASH] = ACTIONS(5313),
    [anon_sym_function] = ACTIONS(5311),
    [anon_sym_EQ] = ACTIONS(5311),
    [anon_sym_if] = ACTIONS(5311),
    [anon_sym_for] = ACTIONS(5311),
    [anon_sym_while] = ACTIONS(5311),
    [anon_sym_repeat] = ACTIONS(5311),
    [anon_sym_QMARK] = ACTIONS(5313),
    [anon_sym_TILDE] = ACTIONS(5313),
    [anon_sym_BANG] = ACTIONS(5311),
    [anon_sym_PLUS] = ACTIONS(5313),
    [anon_sym_DASH] = ACTIONS(5311),
    [anon_sym_LT_DASH] = ACTIONS(5313),
    [anon_sym_LT_LT_DASH] = ACTIONS(5313),
    [anon_sym_COLON_EQ] = ACTIONS(5313),
    [anon_sym_DASH_GT] = ACTIONS(5311),
    [anon_sym_DASH_GT_GT] = ACTIONS(5313),
    [anon_sym_PIPE] = ACTIONS(5311),
    [anon_sym_AMP] = ACTIONS(5311),
    [anon_sym_PIPE_PIPE] = ACTIONS(5313),
    [anon_sym_AMP_AMP] = ACTIONS(5313),
    [anon_sym_LT] = ACTIONS(5311),
    [anon_sym_LT_EQ] = ACTIONS(5313),
    [anon_sym_GT] = ACTIONS(5311),
    [anon_sym_GT_EQ] = ACTIONS(5313),
    [anon_sym_EQ_EQ] = ACTIONS(5313),
    [anon_sym_BANG_EQ] = ACTIONS(5313),
    [anon_sym_STAR] = ACTIONS(5311),
    [anon_sym_SLASH] = ACTIONS(5313),
    [anon_sym_STAR_STAR] = ACTIONS(5313),
    [anon_sym_CARET] = ACTIONS(5313),
    [aux_sym_binary_operator_token1] = ACTIONS(5313),
    [anon_sym_PIPE_GT] = ACTIONS(5313),
    [anon_sym_COLON] = ACTIONS(5311),
    [anon_sym_DOLLAR] = ACTIONS(5313),
    [anon_sym_AT] = ACTIONS(5313),
    [aux_sym__hex_literal_token1] = ACTIONS(5313),
    [sym__number_literal] = ACTIONS(5311),
    [anon_sym_SQUOTE] = ACTIONS(5313),
    [anon_sym_DQUOTE] = ACTIONS(5313),
    [sym_return] = ACTIONS(5311),
    [sym_next] = ACTIONS(5311),
    [sym_break] = ACTIONS(5311),
    [sym_true] = ACTIONS(5311),
    [sym_false] = ACTIONS(5311),
    [sym_null] = ACTIONS(5311),
    [sym_inf] = ACTIONS(5311),
    [sym_nan] = ACTIONS(5311),
    [anon_sym_NA] = ACTIONS(5311),
    [anon_sym_NA_integer_] = ACTIONS(5311),
    [anon_sym_NA_real_] = ACTIONS(5311),
    [anon_sym_NA_complex_] = ACTIONS(5311),
    [anon_sym_NA_character_] = ACTIONS(5311),
    [sym_dots] = ACTIONS(5311),
    [sym_dot_dot_i] = ACTIONS(5313),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5313),
    [sym__newline] = ACTIONS(5313),
    [sym__raw_string_literal] = ACTIONS(5313),
    [sym__external_else] = ACTIONS(5313),
    [sym__external_open_parenthesis] = ACTIONS(5313),
    [sym__external_close_parenthesis] = ACTIONS(5313),
    [sym__external_open_brace] = ACTIONS(5313),
    [sym__external_open_bracket] = ACTIONS(5313),
    [sym__external_open_bracket2] = ACTIONS(5313),
  },
  [2839] = {
    [sym_identifier] = ACTIONS(7478),
    [anon_sym_BSLASH] = ACTIONS(7476),
    [anon_sym_function] = ACTIONS(7478),
    [anon_sym_EQ] = ACTIONS(7478),
    [anon_sym_if] = ACTIONS(7478),
    [anon_sym_for] = ACTIONS(7478),
    [anon_sym_while] = ACTIONS(7478),
    [anon_sym_repeat] = ACTIONS(7478),
    [anon_sym_QMARK] = ACTIONS(7476),
    [anon_sym_TILDE] = ACTIONS(7476),
    [anon_sym_BANG] = ACTIONS(7478),
    [anon_sym_PLUS] = ACTIONS(7476),
    [anon_sym_DASH] = ACTIONS(7478),
    [anon_sym_LT_DASH] = ACTIONS(7476),
    [anon_sym_LT_LT_DASH] = ACTIONS(7476),
    [anon_sym_COLON_EQ] = ACTIONS(7476),
    [anon_sym_DASH_GT] = ACTIONS(7478),
    [anon_sym_DASH_GT_GT] = ACTIONS(7476),
    [anon_sym_PIPE] = ACTIONS(7478),
    [anon_sym_AMP] = ACTIONS(7478),
    [anon_sym_PIPE_PIPE] = ACTIONS(7476),
    [anon_sym_AMP_AMP] = ACTIONS(7476),
    [anon_sym_LT] = ACTIONS(7478),
    [anon_sym_LT_EQ] = ACTIONS(7476),
    [anon_sym_GT] = ACTIONS(7478),
    [anon_sym_GT_EQ] = ACTIONS(7476),
    [anon_sym_EQ_EQ] = ACTIONS(7476),
    [anon_sym_BANG_EQ] = ACTIONS(7476),
    [anon_sym_STAR] = ACTIONS(7478),
    [anon_sym_SLASH] = ACTIONS(7476),
    [anon_sym_STAR_STAR] = ACTIONS(7476),
    [anon_sym_CARET] = ACTIONS(7476),
    [aux_sym_binary_operator_token1] = ACTIONS(7476),
    [anon_sym_PIPE_GT] = ACTIONS(7476),
    [anon_sym_COLON] = ACTIONS(7478),
    [anon_sym_DOLLAR] = ACTIONS(7476),
    [anon_sym_AT] = ACTIONS(7476),
    [aux_sym__hex_literal_token1] = ACTIONS(7476),
    [sym__number_literal] = ACTIONS(7478),
    [anon_sym_SQUOTE] = ACTIONS(7476),
    [anon_sym_DQUOTE] = ACTIONS(7476),
    [sym_return] = ACTIONS(7478),
    [sym_next] = ACTIONS(7478),
    [sym_break] = ACTIONS(7478),
    [sym_true] = ACTIONS(7478),
    [sym_false] = ACTIONS(7478),
    [sym_null] = ACTIONS(7478),
    [sym_inf] = ACTIONS(7478),
    [sym_nan] = ACTIONS(7478),
    [anon_sym_NA] = ACTIONS(7478),
    [anon_sym_NA_integer_] = ACTIONS(7478),
    [anon_sym_NA_real_] = ACTIONS(7478),
    [anon_sym_NA_complex_] = ACTIONS(7478),
    [anon_sym_NA_character_] = ACTIONS(7478),
    [sym_dots] = ACTIONS(7478),
    [sym_dot_dot_i] = ACTIONS(7476),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7476),
    [sym__newline] = ACTIONS(7476),
    [sym__raw_string_literal] = ACTIONS(7476),
    [sym__external_else] = ACTIONS(7476),
    [sym__external_open_parenthesis] = ACTIONS(7476),
    [sym__external_close_parenthesis] = ACTIONS(7476),
    [sym__external_open_brace] = ACTIONS(7476),
    [sym__external_open_bracket] = ACTIONS(7476),
    [sym__external_open_bracket2] = ACTIONS(7476),
  },
  [2840] = {
    [ts_builtin_sym_end] = ACTIONS(7530),
    [sym_identifier] = ACTIONS(7532),
    [anon_sym_BSLASH] = ACTIONS(7530),
    [anon_sym_function] = ACTIONS(7532),
    [anon_sym_EQ] = ACTIONS(7532),
    [anon_sym_if] = ACTIONS(7532),
    [anon_sym_for] = ACTIONS(7532),
    [anon_sym_while] = ACTIONS(7532),
    [anon_sym_repeat] = ACTIONS(7532),
    [anon_sym_QMARK] = ACTIONS(7530),
    [anon_sym_TILDE] = ACTIONS(7530),
    [anon_sym_BANG] = ACTIONS(7532),
    [anon_sym_PLUS] = ACTIONS(7530),
    [anon_sym_DASH] = ACTIONS(7532),
    [anon_sym_LT_DASH] = ACTIONS(7530),
    [anon_sym_LT_LT_DASH] = ACTIONS(7530),
    [anon_sym_COLON_EQ] = ACTIONS(7530),
    [anon_sym_DASH_GT] = ACTIONS(7532),
    [anon_sym_DASH_GT_GT] = ACTIONS(7530),
    [anon_sym_PIPE] = ACTIONS(7532),
    [anon_sym_AMP] = ACTIONS(7532),
    [anon_sym_PIPE_PIPE] = ACTIONS(7530),
    [anon_sym_AMP_AMP] = ACTIONS(7530),
    [anon_sym_LT] = ACTIONS(7532),
    [anon_sym_LT_EQ] = ACTIONS(7530),
    [anon_sym_GT] = ACTIONS(7532),
    [anon_sym_GT_EQ] = ACTIONS(7530),
    [anon_sym_EQ_EQ] = ACTIONS(7530),
    [anon_sym_BANG_EQ] = ACTIONS(7530),
    [anon_sym_STAR] = ACTIONS(7532),
    [anon_sym_SLASH] = ACTIONS(7530),
    [anon_sym_STAR_STAR] = ACTIONS(7530),
    [anon_sym_CARET] = ACTIONS(7530),
    [aux_sym_binary_operator_token1] = ACTIONS(7530),
    [anon_sym_PIPE_GT] = ACTIONS(7530),
    [anon_sym_COLON] = ACTIONS(7532),
    [anon_sym_DOLLAR] = ACTIONS(7530),
    [anon_sym_AT] = ACTIONS(7530),
    [aux_sym__hex_literal_token1] = ACTIONS(7530),
    [sym__number_literal] = ACTIONS(7532),
    [anon_sym_SQUOTE] = ACTIONS(7530),
    [anon_sym_DQUOTE] = ACTIONS(7530),
    [sym_return] = ACTIONS(7532),
    [sym_next] = ACTIONS(7532),
    [sym_break] = ACTIONS(7532),
    [sym_true] = ACTIONS(7532),
    [sym_false] = ACTIONS(7532),
    [sym_null] = ACTIONS(7532),
    [sym_inf] = ACTIONS(7532),
    [sym_nan] = ACTIONS(7532),
    [anon_sym_NA] = ACTIONS(7532),
    [anon_sym_NA_integer_] = ACTIONS(7532),
    [anon_sym_NA_real_] = ACTIONS(7532),
    [anon_sym_NA_complex_] = ACTIONS(7532),
    [anon_sym_NA_character_] = ACTIONS(7532),
    [sym_dots] = ACTIONS(7532),
    [sym_dot_dot_i] = ACTIONS(7530),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7530),
    [sym__semicolon] = ACTIONS(7530),
    [sym__raw_string_literal] = ACTIONS(7530),
    [sym__external_open_parenthesis] = ACTIONS(7530),
    [sym__external_open_brace] = ACTIONS(7530),
    [sym__external_close_brace] = ACTIONS(7530),
    [sym__external_open_bracket] = ACTIONS(7530),
    [sym__external_open_bracket2] = ACTIONS(7530),
  },
  [2841] = {
    [sym_identifier] = ACTIONS(7512),
    [anon_sym_BSLASH] = ACTIONS(7510),
    [anon_sym_function] = ACTIONS(7512),
    [anon_sym_EQ] = ACTIONS(7512),
    [anon_sym_if] = ACTIONS(7512),
    [anon_sym_for] = ACTIONS(7512),
    [anon_sym_while] = ACTIONS(7512),
    [anon_sym_repeat] = ACTIONS(7512),
    [anon_sym_QMARK] = ACTIONS(7510),
    [anon_sym_TILDE] = ACTIONS(7510),
    [anon_sym_BANG] = ACTIONS(7512),
    [anon_sym_PLUS] = ACTIONS(7510),
    [anon_sym_DASH] = ACTIONS(7512),
    [anon_sym_LT_DASH] = ACTIONS(7510),
    [anon_sym_LT_LT_DASH] = ACTIONS(7510),
    [anon_sym_COLON_EQ] = ACTIONS(7510),
    [anon_sym_DASH_GT] = ACTIONS(7512),
    [anon_sym_DASH_GT_GT] = ACTIONS(7510),
    [anon_sym_PIPE] = ACTIONS(7512),
    [anon_sym_AMP] = ACTIONS(7512),
    [anon_sym_PIPE_PIPE] = ACTIONS(7510),
    [anon_sym_AMP_AMP] = ACTIONS(7510),
    [anon_sym_LT] = ACTIONS(7512),
    [anon_sym_LT_EQ] = ACTIONS(7510),
    [anon_sym_GT] = ACTIONS(7512),
    [anon_sym_GT_EQ] = ACTIONS(7510),
    [anon_sym_EQ_EQ] = ACTIONS(7510),
    [anon_sym_BANG_EQ] = ACTIONS(7510),
    [anon_sym_STAR] = ACTIONS(7512),
    [anon_sym_SLASH] = ACTIONS(7510),
    [anon_sym_STAR_STAR] = ACTIONS(7510),
    [anon_sym_CARET] = ACTIONS(7510),
    [aux_sym_binary_operator_token1] = ACTIONS(7510),
    [anon_sym_PIPE_GT] = ACTIONS(7510),
    [anon_sym_COLON] = ACTIONS(7512),
    [anon_sym_DOLLAR] = ACTIONS(7510),
    [anon_sym_AT] = ACTIONS(7510),
    [aux_sym__hex_literal_token1] = ACTIONS(7510),
    [sym__number_literal] = ACTIONS(7512),
    [anon_sym_SQUOTE] = ACTIONS(7510),
    [anon_sym_DQUOTE] = ACTIONS(7510),
    [sym_return] = ACTIONS(7512),
    [sym_next] = ACTIONS(7512),
    [sym_break] = ACTIONS(7512),
    [sym_true] = ACTIONS(7512),
    [sym_false] = ACTIONS(7512),
    [sym_null] = ACTIONS(7512),
    [sym_inf] = ACTIONS(7512),
    [sym_nan] = ACTIONS(7512),
    [anon_sym_NA] = ACTIONS(7512),
    [anon_sym_NA_integer_] = ACTIONS(7512),
    [anon_sym_NA_real_] = ACTIONS(7512),
    [anon_sym_NA_complex_] = ACTIONS(7512),
    [anon_sym_NA_character_] = ACTIONS(7512),
    [sym_dots] = ACTIONS(7512),
    [sym_dot_dot_i] = ACTIONS(7510),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7510),
    [sym__newline] = ACTIONS(7510),
    [sym__raw_string_literal] = ACTIONS(7510),
    [sym__external_open_parenthesis] = ACTIONS(7510),
    [sym__external_close_parenthesis] = ACTIONS(7510),
    [sym__external_open_brace] = ACTIONS(7510),
    [sym__external_open_bracket] = ACTIONS(7510),
    [sym__external_close_bracket] = ACTIONS(7510),
    [sym__external_open_bracket2] = ACTIONS(7510),
  },
  [2842] = {
    [ts_builtin_sym_end] = ACTIONS(5313),
    [sym_identifier] = ACTIONS(5311),
    [anon_sym_BSLASH] = ACTIONS(5313),
    [anon_sym_function] = ACTIONS(5311),
    [anon_sym_EQ] = ACTIONS(5311),
    [anon_sym_if] = ACTIONS(5311),
    [anon_sym_for] = ACTIONS(5311),
    [anon_sym_while] = ACTIONS(5311),
    [anon_sym_repeat] = ACTIONS(5311),
    [anon_sym_QMARK] = ACTIONS(5313),
    [anon_sym_TILDE] = ACTIONS(5313),
    [anon_sym_BANG] = ACTIONS(5311),
    [anon_sym_PLUS] = ACTIONS(5313),
    [anon_sym_DASH] = ACTIONS(5311),
    [anon_sym_LT_DASH] = ACTIONS(5313),
    [anon_sym_LT_LT_DASH] = ACTIONS(5313),
    [anon_sym_COLON_EQ] = ACTIONS(5313),
    [anon_sym_DASH_GT] = ACTIONS(5311),
    [anon_sym_DASH_GT_GT] = ACTIONS(5313),
    [anon_sym_PIPE] = ACTIONS(5311),
    [anon_sym_AMP] = ACTIONS(5311),
    [anon_sym_PIPE_PIPE] = ACTIONS(5313),
    [anon_sym_AMP_AMP] = ACTIONS(5313),
    [anon_sym_LT] = ACTIONS(5311),
    [anon_sym_LT_EQ] = ACTIONS(5313),
    [anon_sym_GT] = ACTIONS(5311),
    [anon_sym_GT_EQ] = ACTIONS(5313),
    [anon_sym_EQ_EQ] = ACTIONS(5313),
    [anon_sym_BANG_EQ] = ACTIONS(5313),
    [anon_sym_STAR] = ACTIONS(5311),
    [anon_sym_SLASH] = ACTIONS(5313),
    [anon_sym_STAR_STAR] = ACTIONS(5313),
    [anon_sym_CARET] = ACTIONS(5313),
    [aux_sym_binary_operator_token1] = ACTIONS(5313),
    [anon_sym_PIPE_GT] = ACTIONS(5313),
    [anon_sym_COLON] = ACTIONS(5311),
    [anon_sym_DOLLAR] = ACTIONS(5313),
    [anon_sym_AT] = ACTIONS(5313),
    [aux_sym__hex_literal_token1] = ACTIONS(5313),
    [sym__number_literal] = ACTIONS(5311),
    [anon_sym_SQUOTE] = ACTIONS(5313),
    [anon_sym_DQUOTE] = ACTIONS(5313),
    [sym_return] = ACTIONS(5311),
    [sym_next] = ACTIONS(5311),
    [sym_break] = ACTIONS(5311),
    [sym_true] = ACTIONS(5311),
    [sym_false] = ACTIONS(5311),
    [sym_null] = ACTIONS(5311),
    [sym_inf] = ACTIONS(5311),
    [sym_nan] = ACTIONS(5311),
    [anon_sym_NA] = ACTIONS(5311),
    [anon_sym_NA_integer_] = ACTIONS(5311),
    [anon_sym_NA_real_] = ACTIONS(5311),
    [anon_sym_NA_complex_] = ACTIONS(5311),
    [anon_sym_NA_character_] = ACTIONS(5311),
    [sym_dots] = ACTIONS(5311),
    [sym_dot_dot_i] = ACTIONS(5313),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5313),
    [sym__semicolon] = ACTIONS(5313),
    [sym__raw_string_literal] = ACTIONS(5313),
    [sym__external_open_parenthesis] = ACTIONS(5313),
    [sym__external_close_parenthesis] = ACTIONS(5313),
    [sym__external_open_brace] = ACTIONS(5313),
    [sym__external_open_bracket] = ACTIONS(5313),
    [sym__external_open_bracket2] = ACTIONS(5313),
  },
  [2843] = {
    [ts_builtin_sym_end] = ACTIONS(7488),
    [sym_identifier] = ACTIONS(7490),
    [anon_sym_BSLASH] = ACTIONS(7488),
    [anon_sym_function] = ACTIONS(7490),
    [anon_sym_EQ] = ACTIONS(7490),
    [anon_sym_if] = ACTIONS(7490),
    [anon_sym_for] = ACTIONS(7490),
    [anon_sym_while] = ACTIONS(7490),
    [anon_sym_repeat] = ACTIONS(7490),
    [anon_sym_QMARK] = ACTIONS(7488),
    [anon_sym_TILDE] = ACTIONS(7488),
    [anon_sym_BANG] = ACTIONS(7490),
    [anon_sym_PLUS] = ACTIONS(7488),
    [anon_sym_DASH] = ACTIONS(7490),
    [anon_sym_LT_DASH] = ACTIONS(7488),
    [anon_sym_LT_LT_DASH] = ACTIONS(7488),
    [anon_sym_COLON_EQ] = ACTIONS(7488),
    [anon_sym_DASH_GT] = ACTIONS(7490),
    [anon_sym_DASH_GT_GT] = ACTIONS(7488),
    [anon_sym_PIPE] = ACTIONS(7490),
    [anon_sym_AMP] = ACTIONS(7490),
    [anon_sym_PIPE_PIPE] = ACTIONS(7488),
    [anon_sym_AMP_AMP] = ACTIONS(7488),
    [anon_sym_LT] = ACTIONS(7490),
    [anon_sym_LT_EQ] = ACTIONS(7488),
    [anon_sym_GT] = ACTIONS(7490),
    [anon_sym_GT_EQ] = ACTIONS(7488),
    [anon_sym_EQ_EQ] = ACTIONS(7488),
    [anon_sym_BANG_EQ] = ACTIONS(7488),
    [anon_sym_STAR] = ACTIONS(7490),
    [anon_sym_SLASH] = ACTIONS(7488),
    [anon_sym_STAR_STAR] = ACTIONS(7488),
    [anon_sym_CARET] = ACTIONS(7488),
    [aux_sym_binary_operator_token1] = ACTIONS(7488),
    [anon_sym_PIPE_GT] = ACTIONS(7488),
    [anon_sym_COLON] = ACTIONS(7490),
    [anon_sym_DOLLAR] = ACTIONS(7488),
    [anon_sym_AT] = ACTIONS(7488),
    [aux_sym__hex_literal_token1] = ACTIONS(7488),
    [sym__number_literal] = ACTIONS(7490),
    [anon_sym_SQUOTE] = ACTIONS(7488),
    [anon_sym_DQUOTE] = ACTIONS(7488),
    [sym_return] = ACTIONS(7490),
    [sym_next] = ACTIONS(7490),
    [sym_break] = ACTIONS(7490),
    [sym_true] = ACTIONS(7490),
    [sym_false] = ACTIONS(7490),
    [sym_null] = ACTIONS(7490),
    [sym_inf] = ACTIONS(7490),
    [sym_nan] = ACTIONS(7490),
    [anon_sym_NA] = ACTIONS(7490),
    [anon_sym_NA_integer_] = ACTIONS(7490),
    [anon_sym_NA_real_] = ACTIONS(7490),
    [anon_sym_NA_complex_] = ACTIONS(7490),
    [anon_sym_NA_character_] = ACTIONS(7490),
    [sym_dots] = ACTIONS(7490),
    [sym_dot_dot_i] = ACTIONS(7488),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7488),
    [sym__semicolon] = ACTIONS(7488),
    [sym__raw_string_literal] = ACTIONS(7488),
    [sym__external_open_parenthesis] = ACTIONS(7488),
    [sym__external_open_brace] = ACTIONS(7488),
    [sym__external_close_brace] = ACTIONS(7488),
    [sym__external_open_bracket] = ACTIONS(7488),
    [sym__external_open_bracket2] = ACTIONS(7488),
  },
  [2844] = {
    [ts_builtin_sym_end] = ACTIONS(7466),
    [sym_identifier] = ACTIONS(7464),
    [anon_sym_BSLASH] = ACTIONS(7466),
    [anon_sym_function] = ACTIONS(7464),
    [anon_sym_EQ] = ACTIONS(7464),
    [anon_sym_if] = ACTIONS(7464),
    [anon_sym_for] = ACTIONS(7464),
    [anon_sym_while] = ACTIONS(7464),
    [anon_sym_repeat] = ACTIONS(7464),
    [anon_sym_QMARK] = ACTIONS(7466),
    [anon_sym_TILDE] = ACTIONS(7466),
    [anon_sym_BANG] = ACTIONS(7464),
    [anon_sym_PLUS] = ACTIONS(7466),
    [anon_sym_DASH] = ACTIONS(7464),
    [anon_sym_LT_DASH] = ACTIONS(7466),
    [anon_sym_LT_LT_DASH] = ACTIONS(7466),
    [anon_sym_COLON_EQ] = ACTIONS(7466),
    [anon_sym_DASH_GT] = ACTIONS(7464),
    [anon_sym_DASH_GT_GT] = ACTIONS(7466),
    [anon_sym_PIPE] = ACTIONS(7464),
    [anon_sym_AMP] = ACTIONS(7464),
    [anon_sym_PIPE_PIPE] = ACTIONS(7466),
    [anon_sym_AMP_AMP] = ACTIONS(7466),
    [anon_sym_LT] = ACTIONS(7464),
    [anon_sym_LT_EQ] = ACTIONS(7466),
    [anon_sym_GT] = ACTIONS(7464),
    [anon_sym_GT_EQ] = ACTIONS(7466),
    [anon_sym_EQ_EQ] = ACTIONS(7466),
    [anon_sym_BANG_EQ] = ACTIONS(7466),
    [anon_sym_STAR] = ACTIONS(7464),
    [anon_sym_SLASH] = ACTIONS(7466),
    [anon_sym_STAR_STAR] = ACTIONS(7466),
    [anon_sym_CARET] = ACTIONS(7466),
    [aux_sym_binary_operator_token1] = ACTIONS(7466),
    [anon_sym_PIPE_GT] = ACTIONS(7466),
    [anon_sym_COLON] = ACTIONS(7464),
    [anon_sym_DOLLAR] = ACTIONS(7466),
    [anon_sym_AT] = ACTIONS(7466),
    [aux_sym__hex_literal_token1] = ACTIONS(7466),
    [sym__number_literal] = ACTIONS(7464),
    [anon_sym_SQUOTE] = ACTIONS(7466),
    [anon_sym_DQUOTE] = ACTIONS(7466),
    [sym_return] = ACTIONS(7464),
    [sym_next] = ACTIONS(7464),
    [sym_break] = ACTIONS(7464),
    [sym_true] = ACTIONS(7464),
    [sym_false] = ACTIONS(7464),
    [sym_null] = ACTIONS(7464),
    [sym_inf] = ACTIONS(7464),
    [sym_nan] = ACTIONS(7464),
    [anon_sym_NA] = ACTIONS(7464),
    [anon_sym_NA_integer_] = ACTIONS(7464),
    [anon_sym_NA_real_] = ACTIONS(7464),
    [anon_sym_NA_complex_] = ACTIONS(7464),
    [anon_sym_NA_character_] = ACTIONS(7464),
    [sym_dots] = ACTIONS(7464),
    [sym_dot_dot_i] = ACTIONS(7466),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7466),
    [sym__semicolon] = ACTIONS(7466),
    [sym__raw_string_literal] = ACTIONS(7466),
    [sym__external_open_parenthesis] = ACTIONS(7466),
    [sym__external_open_brace] = ACTIONS(7466),
    [sym__external_close_brace] = ACTIONS(7466),
    [sym__external_open_bracket] = ACTIONS(7466),
    [sym__external_open_bracket2] = ACTIONS(7466),
  },
  [2845] = {
    [sym_identifier] = ACTIONS(7532),
    [anon_sym_BSLASH] = ACTIONS(7530),
    [anon_sym_function] = ACTIONS(7532),
    [anon_sym_EQ] = ACTIONS(7532),
    [anon_sym_if] = ACTIONS(7532),
    [anon_sym_for] = ACTIONS(7532),
    [anon_sym_while] = ACTIONS(7532),
    [anon_sym_repeat] = ACTIONS(7532),
    [anon_sym_QMARK] = ACTIONS(7530),
    [anon_sym_TILDE] = ACTIONS(7530),
    [anon_sym_BANG] = ACTIONS(7532),
    [anon_sym_PLUS] = ACTIONS(7530),
    [anon_sym_DASH] = ACTIONS(7532),
    [anon_sym_LT_DASH] = ACTIONS(7530),
    [anon_sym_LT_LT_DASH] = ACTIONS(7530),
    [anon_sym_COLON_EQ] = ACTIONS(7530),
    [anon_sym_DASH_GT] = ACTIONS(7532),
    [anon_sym_DASH_GT_GT] = ACTIONS(7530),
    [anon_sym_PIPE] = ACTIONS(7532),
    [anon_sym_AMP] = ACTIONS(7532),
    [anon_sym_PIPE_PIPE] = ACTIONS(7530),
    [anon_sym_AMP_AMP] = ACTIONS(7530),
    [anon_sym_LT] = ACTIONS(7532),
    [anon_sym_LT_EQ] = ACTIONS(7530),
    [anon_sym_GT] = ACTIONS(7532),
    [anon_sym_GT_EQ] = ACTIONS(7530),
    [anon_sym_EQ_EQ] = ACTIONS(7530),
    [anon_sym_BANG_EQ] = ACTIONS(7530),
    [anon_sym_STAR] = ACTIONS(7532),
    [anon_sym_SLASH] = ACTIONS(7530),
    [anon_sym_STAR_STAR] = ACTIONS(7530),
    [anon_sym_CARET] = ACTIONS(7530),
    [aux_sym_binary_operator_token1] = ACTIONS(7530),
    [anon_sym_PIPE_GT] = ACTIONS(7530),
    [anon_sym_COLON] = ACTIONS(7532),
    [anon_sym_DOLLAR] = ACTIONS(7530),
    [anon_sym_AT] = ACTIONS(7530),
    [aux_sym__hex_literal_token1] = ACTIONS(7530),
    [sym__number_literal] = ACTIONS(7532),
    [anon_sym_SQUOTE] = ACTIONS(7530),
    [anon_sym_DQUOTE] = ACTIONS(7530),
    [sym_return] = ACTIONS(7532),
    [sym_next] = ACTIONS(7532),
    [sym_break] = ACTIONS(7532),
    [sym_true] = ACTIONS(7532),
    [sym_false] = ACTIONS(7532),
    [sym_null] = ACTIONS(7532),
    [sym_inf] = ACTIONS(7532),
    [sym_nan] = ACTIONS(7532),
    [anon_sym_NA] = ACTIONS(7532),
    [anon_sym_NA_integer_] = ACTIONS(7532),
    [anon_sym_NA_real_] = ACTIONS(7532),
    [anon_sym_NA_complex_] = ACTIONS(7532),
    [anon_sym_NA_character_] = ACTIONS(7532),
    [sym_dots] = ACTIONS(7532),
    [sym_dot_dot_i] = ACTIONS(7530),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7530),
    [sym__newline] = ACTIONS(7530),
    [sym__raw_string_literal] = ACTIONS(7530),
    [sym__external_else] = ACTIONS(7530),
    [sym__external_open_parenthesis] = ACTIONS(7530),
    [sym__external_close_parenthesis] = ACTIONS(7530),
    [sym__external_open_brace] = ACTIONS(7530),
    [sym__external_open_bracket] = ACTIONS(7530),
    [sym__external_open_bracket2] = ACTIONS(7530),
  },
  [2846] = {
    [sym_identifier] = ACTIONS(7544),
    [anon_sym_BSLASH] = ACTIONS(7542),
    [anon_sym_function] = ACTIONS(7544),
    [anon_sym_EQ] = ACTIONS(7544),
    [anon_sym_if] = ACTIONS(7544),
    [anon_sym_for] = ACTIONS(7544),
    [anon_sym_while] = ACTIONS(7544),
    [anon_sym_repeat] = ACTIONS(7544),
    [anon_sym_QMARK] = ACTIONS(7542),
    [anon_sym_TILDE] = ACTIONS(7542),
    [anon_sym_BANG] = ACTIONS(7544),
    [anon_sym_PLUS] = ACTIONS(7542),
    [anon_sym_DASH] = ACTIONS(7544),
    [anon_sym_LT_DASH] = ACTIONS(7542),
    [anon_sym_LT_LT_DASH] = ACTIONS(7542),
    [anon_sym_COLON_EQ] = ACTIONS(7542),
    [anon_sym_DASH_GT] = ACTIONS(7544),
    [anon_sym_DASH_GT_GT] = ACTIONS(7542),
    [anon_sym_PIPE] = ACTIONS(7544),
    [anon_sym_AMP] = ACTIONS(7544),
    [anon_sym_PIPE_PIPE] = ACTIONS(7542),
    [anon_sym_AMP_AMP] = ACTIONS(7542),
    [anon_sym_LT] = ACTIONS(7544),
    [anon_sym_LT_EQ] = ACTIONS(7542),
    [anon_sym_GT] = ACTIONS(7544),
    [anon_sym_GT_EQ] = ACTIONS(7542),
    [anon_sym_EQ_EQ] = ACTIONS(7542),
    [anon_sym_BANG_EQ] = ACTIONS(7542),
    [anon_sym_STAR] = ACTIONS(7544),
    [anon_sym_SLASH] = ACTIONS(7542),
    [anon_sym_STAR_STAR] = ACTIONS(7542),
    [anon_sym_CARET] = ACTIONS(7542),
    [aux_sym_binary_operator_token1] = ACTIONS(7542),
    [anon_sym_PIPE_GT] = ACTIONS(7542),
    [anon_sym_COLON] = ACTIONS(7544),
    [anon_sym_DOLLAR] = ACTIONS(7542),
    [anon_sym_AT] = ACTIONS(7542),
    [aux_sym__hex_literal_token1] = ACTIONS(7542),
    [sym__number_literal] = ACTIONS(7544),
    [anon_sym_SQUOTE] = ACTIONS(7542),
    [anon_sym_DQUOTE] = ACTIONS(7542),
    [sym_return] = ACTIONS(7544),
    [sym_next] = ACTIONS(7544),
    [sym_break] = ACTIONS(7544),
    [sym_true] = ACTIONS(7544),
    [sym_false] = ACTIONS(7544),
    [sym_null] = ACTIONS(7544),
    [sym_inf] = ACTIONS(7544),
    [sym_nan] = ACTIONS(7544),
    [anon_sym_NA] = ACTIONS(7544),
    [anon_sym_NA_integer_] = ACTIONS(7544),
    [anon_sym_NA_real_] = ACTIONS(7544),
    [anon_sym_NA_complex_] = ACTIONS(7544),
    [anon_sym_NA_character_] = ACTIONS(7544),
    [sym_dots] = ACTIONS(7544),
    [sym_dot_dot_i] = ACTIONS(7542),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7542),
    [sym__newline] = ACTIONS(7542),
    [sym__raw_string_literal] = ACTIONS(7542),
    [sym__external_else] = ACTIONS(7542),
    [sym__external_open_parenthesis] = ACTIONS(7542),
    [sym__external_open_brace] = ACTIONS(7542),
    [sym__external_open_bracket] = ACTIONS(7542),
    [sym__external_close_bracket] = ACTIONS(7542),
    [sym__external_open_bracket2] = ACTIONS(7542),
  },
  [2847] = {
    [aux_sym_function_definition_repeat1] = STATE(2847),
    [sym_identifier] = ACTIONS(7419),
    [anon_sym_BSLASH] = ACTIONS(7417),
    [anon_sym_function] = ACTIONS(7419),
    [anon_sym_EQ] = ACTIONS(7419),
    [anon_sym_if] = ACTIONS(7419),
    [anon_sym_for] = ACTIONS(7419),
    [anon_sym_while] = ACTIONS(7419),
    [anon_sym_repeat] = ACTIONS(7419),
    [anon_sym_QMARK] = ACTIONS(7417),
    [anon_sym_TILDE] = ACTIONS(7417),
    [anon_sym_BANG] = ACTIONS(7419),
    [anon_sym_PLUS] = ACTIONS(7417),
    [anon_sym_DASH] = ACTIONS(7419),
    [anon_sym_LT_DASH] = ACTIONS(7417),
    [anon_sym_LT_LT_DASH] = ACTIONS(7417),
    [anon_sym_COLON_EQ] = ACTIONS(7417),
    [anon_sym_DASH_GT] = ACTIONS(7419),
    [anon_sym_DASH_GT_GT] = ACTIONS(7417),
    [anon_sym_PIPE] = ACTIONS(7419),
    [anon_sym_AMP] = ACTIONS(7419),
    [anon_sym_PIPE_PIPE] = ACTIONS(7417),
    [anon_sym_AMP_AMP] = ACTIONS(7417),
    [anon_sym_LT] = ACTIONS(7419),
    [anon_sym_LT_EQ] = ACTIONS(7417),
    [anon_sym_GT] = ACTIONS(7419),
    [anon_sym_GT_EQ] = ACTIONS(7417),
    [anon_sym_EQ_EQ] = ACTIONS(7417),
    [anon_sym_BANG_EQ] = ACTIONS(7417),
    [anon_sym_STAR] = ACTIONS(7419),
    [anon_sym_SLASH] = ACTIONS(7417),
    [anon_sym_STAR_STAR] = ACTIONS(7417),
    [anon_sym_CARET] = ACTIONS(7417),
    [aux_sym_binary_operator_token1] = ACTIONS(7417),
    [anon_sym_PIPE_GT] = ACTIONS(7417),
    [anon_sym_COLON] = ACTIONS(7419),
    [anon_sym_DOLLAR] = ACTIONS(7417),
    [anon_sym_AT] = ACTIONS(7417),
    [aux_sym__hex_literal_token1] = ACTIONS(7417),
    [sym__number_literal] = ACTIONS(7419),
    [anon_sym_SQUOTE] = ACTIONS(7417),
    [anon_sym_DQUOTE] = ACTIONS(7417),
    [sym_return] = ACTIONS(7419),
    [sym_next] = ACTIONS(7419),
    [sym_break] = ACTIONS(7419),
    [sym_true] = ACTIONS(7419),
    [sym_false] = ACTIONS(7419),
    [sym_null] = ACTIONS(7419),
    [sym_inf] = ACTIONS(7419),
    [sym_nan] = ACTIONS(7419),
    [anon_sym_NA] = ACTIONS(7419),
    [anon_sym_NA_integer_] = ACTIONS(7419),
    [anon_sym_NA_real_] = ACTIONS(7419),
    [anon_sym_NA_complex_] = ACTIONS(7419),
    [anon_sym_NA_character_] = ACTIONS(7419),
    [sym_dots] = ACTIONS(7419),
    [sym_dot_dot_i] = ACTIONS(7417),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7417),
    [sym__newline] = ACTIONS(7701),
    [sym__raw_string_literal] = ACTIONS(7417),
    [sym__external_open_parenthesis] = ACTIONS(7417),
    [sym__external_open_brace] = ACTIONS(7417),
    [sym__external_open_bracket] = ACTIONS(7417),
    [sym__external_open_bracket2] = ACTIONS(7417),
    [sym__external_close_bracket2] = ACTIONS(7417),
  },
  [2848] = {
    [sym_identifier] = ACTIONS(7567),
    [anon_sym_BSLASH] = ACTIONS(7565),
    [anon_sym_function] = ACTIONS(7567),
    [anon_sym_EQ] = ACTIONS(7567),
    [anon_sym_if] = ACTIONS(7567),
    [anon_sym_for] = ACTIONS(7567),
    [anon_sym_while] = ACTIONS(7567),
    [anon_sym_repeat] = ACTIONS(7567),
    [anon_sym_QMARK] = ACTIONS(7565),
    [anon_sym_TILDE] = ACTIONS(7565),
    [anon_sym_BANG] = ACTIONS(7567),
    [anon_sym_PLUS] = ACTIONS(7565),
    [anon_sym_DASH] = ACTIONS(7567),
    [anon_sym_LT_DASH] = ACTIONS(7565),
    [anon_sym_LT_LT_DASH] = ACTIONS(7565),
    [anon_sym_COLON_EQ] = ACTIONS(7565),
    [anon_sym_DASH_GT] = ACTIONS(7567),
    [anon_sym_DASH_GT_GT] = ACTIONS(7565),
    [anon_sym_PIPE] = ACTIONS(7567),
    [anon_sym_AMP] = ACTIONS(7567),
    [anon_sym_PIPE_PIPE] = ACTIONS(7565),
    [anon_sym_AMP_AMP] = ACTIONS(7565),
    [anon_sym_LT] = ACTIONS(7567),
    [anon_sym_LT_EQ] = ACTIONS(7565),
    [anon_sym_GT] = ACTIONS(7567),
    [anon_sym_GT_EQ] = ACTIONS(7565),
    [anon_sym_EQ_EQ] = ACTIONS(7565),
    [anon_sym_BANG_EQ] = ACTIONS(7565),
    [anon_sym_STAR] = ACTIONS(7567),
    [anon_sym_SLASH] = ACTIONS(7565),
    [anon_sym_STAR_STAR] = ACTIONS(7565),
    [anon_sym_CARET] = ACTIONS(7565),
    [aux_sym_binary_operator_token1] = ACTIONS(7565),
    [anon_sym_PIPE_GT] = ACTIONS(7565),
    [anon_sym_COLON] = ACTIONS(7567),
    [anon_sym_DOLLAR] = ACTIONS(7565),
    [anon_sym_AT] = ACTIONS(7565),
    [aux_sym__hex_literal_token1] = ACTIONS(7565),
    [sym__number_literal] = ACTIONS(7567),
    [anon_sym_SQUOTE] = ACTIONS(7565),
    [anon_sym_DQUOTE] = ACTIONS(7565),
    [sym_return] = ACTIONS(7567),
    [sym_next] = ACTIONS(7567),
    [sym_break] = ACTIONS(7567),
    [sym_true] = ACTIONS(7567),
    [sym_false] = ACTIONS(7567),
    [sym_null] = ACTIONS(7567),
    [sym_inf] = ACTIONS(7567),
    [sym_nan] = ACTIONS(7567),
    [anon_sym_NA] = ACTIONS(7567),
    [anon_sym_NA_integer_] = ACTIONS(7567),
    [anon_sym_NA_real_] = ACTIONS(7567),
    [anon_sym_NA_complex_] = ACTIONS(7567),
    [anon_sym_NA_character_] = ACTIONS(7567),
    [sym_dots] = ACTIONS(7567),
    [sym_dot_dot_i] = ACTIONS(7565),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7565),
    [sym__newline] = ACTIONS(7565),
    [sym__raw_string_literal] = ACTIONS(7565),
    [sym__external_open_parenthesis] = ACTIONS(7565),
    [sym__external_close_parenthesis] = ACTIONS(7565),
    [sym__external_open_brace] = ACTIONS(7565),
    [sym__external_open_bracket] = ACTIONS(7565),
    [sym__external_close_bracket] = ACTIONS(7565),
    [sym__external_open_bracket2] = ACTIONS(7565),
  },
  [2849] = {
    [sym_identifier] = ACTIONS(7528),
    [anon_sym_BSLASH] = ACTIONS(7526),
    [anon_sym_function] = ACTIONS(7528),
    [anon_sym_EQ] = ACTIONS(7528),
    [anon_sym_if] = ACTIONS(7528),
    [anon_sym_for] = ACTIONS(7528),
    [anon_sym_while] = ACTIONS(7528),
    [anon_sym_repeat] = ACTIONS(7528),
    [anon_sym_QMARK] = ACTIONS(7526),
    [anon_sym_TILDE] = ACTIONS(7526),
    [anon_sym_BANG] = ACTIONS(7528),
    [anon_sym_PLUS] = ACTIONS(7526),
    [anon_sym_DASH] = ACTIONS(7528),
    [anon_sym_LT_DASH] = ACTIONS(7526),
    [anon_sym_LT_LT_DASH] = ACTIONS(7526),
    [anon_sym_COLON_EQ] = ACTIONS(7526),
    [anon_sym_DASH_GT] = ACTIONS(7528),
    [anon_sym_DASH_GT_GT] = ACTIONS(7526),
    [anon_sym_PIPE] = ACTIONS(7528),
    [anon_sym_AMP] = ACTIONS(7528),
    [anon_sym_PIPE_PIPE] = ACTIONS(7526),
    [anon_sym_AMP_AMP] = ACTIONS(7526),
    [anon_sym_LT] = ACTIONS(7528),
    [anon_sym_LT_EQ] = ACTIONS(7526),
    [anon_sym_GT] = ACTIONS(7528),
    [anon_sym_GT_EQ] = ACTIONS(7526),
    [anon_sym_EQ_EQ] = ACTIONS(7526),
    [anon_sym_BANG_EQ] = ACTIONS(7526),
    [anon_sym_STAR] = ACTIONS(7528),
    [anon_sym_SLASH] = ACTIONS(7526),
    [anon_sym_STAR_STAR] = ACTIONS(7526),
    [anon_sym_CARET] = ACTIONS(7526),
    [aux_sym_binary_operator_token1] = ACTIONS(7526),
    [anon_sym_PIPE_GT] = ACTIONS(7526),
    [anon_sym_COLON] = ACTIONS(7528),
    [anon_sym_DOLLAR] = ACTIONS(7526),
    [anon_sym_AT] = ACTIONS(7526),
    [aux_sym__hex_literal_token1] = ACTIONS(7526),
    [sym__number_literal] = ACTIONS(7528),
    [anon_sym_SQUOTE] = ACTIONS(7526),
    [anon_sym_DQUOTE] = ACTIONS(7526),
    [sym_return] = ACTIONS(7528),
    [sym_next] = ACTIONS(7528),
    [sym_break] = ACTIONS(7528),
    [sym_true] = ACTIONS(7528),
    [sym_false] = ACTIONS(7528),
    [sym_null] = ACTIONS(7528),
    [sym_inf] = ACTIONS(7528),
    [sym_nan] = ACTIONS(7528),
    [anon_sym_NA] = ACTIONS(7528),
    [anon_sym_NA_integer_] = ACTIONS(7528),
    [anon_sym_NA_real_] = ACTIONS(7528),
    [anon_sym_NA_complex_] = ACTIONS(7528),
    [anon_sym_NA_character_] = ACTIONS(7528),
    [sym_dots] = ACTIONS(7528),
    [sym_dot_dot_i] = ACTIONS(7526),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7526),
    [sym__newline] = ACTIONS(7526),
    [sym__raw_string_literal] = ACTIONS(7526),
    [sym__external_else] = ACTIONS(7526),
    [sym__external_open_parenthesis] = ACTIONS(7526),
    [sym__external_close_parenthesis] = ACTIONS(7526),
    [sym__external_open_brace] = ACTIONS(7526),
    [sym__external_open_bracket] = ACTIONS(7526),
    [sym__external_open_bracket2] = ACTIONS(7526),
  },
  [2850] = {
    [sym_identifier] = ACTIONS(7567),
    [anon_sym_BSLASH] = ACTIONS(7565),
    [anon_sym_function] = ACTIONS(7567),
    [anon_sym_EQ] = ACTIONS(7567),
    [anon_sym_if] = ACTIONS(7567),
    [anon_sym_for] = ACTIONS(7567),
    [anon_sym_while] = ACTIONS(7567),
    [anon_sym_repeat] = ACTIONS(7567),
    [anon_sym_QMARK] = ACTIONS(7565),
    [anon_sym_TILDE] = ACTIONS(7565),
    [anon_sym_BANG] = ACTIONS(7567),
    [anon_sym_PLUS] = ACTIONS(7565),
    [anon_sym_DASH] = ACTIONS(7567),
    [anon_sym_LT_DASH] = ACTIONS(7565),
    [anon_sym_LT_LT_DASH] = ACTIONS(7565),
    [anon_sym_COLON_EQ] = ACTIONS(7565),
    [anon_sym_DASH_GT] = ACTIONS(7567),
    [anon_sym_DASH_GT_GT] = ACTIONS(7565),
    [anon_sym_PIPE] = ACTIONS(7567),
    [anon_sym_AMP] = ACTIONS(7567),
    [anon_sym_PIPE_PIPE] = ACTIONS(7565),
    [anon_sym_AMP_AMP] = ACTIONS(7565),
    [anon_sym_LT] = ACTIONS(7567),
    [anon_sym_LT_EQ] = ACTIONS(7565),
    [anon_sym_GT] = ACTIONS(7567),
    [anon_sym_GT_EQ] = ACTIONS(7565),
    [anon_sym_EQ_EQ] = ACTIONS(7565),
    [anon_sym_BANG_EQ] = ACTIONS(7565),
    [anon_sym_STAR] = ACTIONS(7567),
    [anon_sym_SLASH] = ACTIONS(7565),
    [anon_sym_STAR_STAR] = ACTIONS(7565),
    [anon_sym_CARET] = ACTIONS(7565),
    [aux_sym_binary_operator_token1] = ACTIONS(7565),
    [anon_sym_PIPE_GT] = ACTIONS(7565),
    [anon_sym_COLON] = ACTIONS(7567),
    [anon_sym_DOLLAR] = ACTIONS(7565),
    [anon_sym_AT] = ACTIONS(7565),
    [aux_sym__hex_literal_token1] = ACTIONS(7565),
    [sym__number_literal] = ACTIONS(7567),
    [anon_sym_SQUOTE] = ACTIONS(7565),
    [anon_sym_DQUOTE] = ACTIONS(7565),
    [sym_return] = ACTIONS(7567),
    [sym_next] = ACTIONS(7567),
    [sym_break] = ACTIONS(7567),
    [sym_true] = ACTIONS(7567),
    [sym_false] = ACTIONS(7567),
    [sym_null] = ACTIONS(7567),
    [sym_inf] = ACTIONS(7567),
    [sym_nan] = ACTIONS(7567),
    [anon_sym_NA] = ACTIONS(7567),
    [anon_sym_NA_integer_] = ACTIONS(7567),
    [anon_sym_NA_real_] = ACTIONS(7567),
    [anon_sym_NA_complex_] = ACTIONS(7567),
    [anon_sym_NA_character_] = ACTIONS(7567),
    [sym_dots] = ACTIONS(7567),
    [sym_dot_dot_i] = ACTIONS(7565),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7565),
    [sym__newline] = ACTIONS(7565),
    [sym__raw_string_literal] = ACTIONS(7565),
    [sym__external_open_parenthesis] = ACTIONS(7565),
    [sym__external_close_parenthesis] = ACTIONS(7565),
    [sym__external_open_brace] = ACTIONS(7565),
    [sym__external_open_bracket] = ACTIONS(7565),
    [sym__external_open_bracket2] = ACTIONS(7565),
    [sym__external_close_bracket2] = ACTIONS(7565),
  },
  [2851] = {
    [sym_identifier] = ACTIONS(7490),
    [anon_sym_BSLASH] = ACTIONS(7488),
    [anon_sym_function] = ACTIONS(7490),
    [anon_sym_EQ] = ACTIONS(7490),
    [anon_sym_if] = ACTIONS(7490),
    [anon_sym_for] = ACTIONS(7490),
    [anon_sym_while] = ACTIONS(7490),
    [anon_sym_repeat] = ACTIONS(7490),
    [anon_sym_QMARK] = ACTIONS(7488),
    [anon_sym_TILDE] = ACTIONS(7488),
    [anon_sym_BANG] = ACTIONS(7490),
    [anon_sym_PLUS] = ACTIONS(7488),
    [anon_sym_DASH] = ACTIONS(7490),
    [anon_sym_LT_DASH] = ACTIONS(7488),
    [anon_sym_LT_LT_DASH] = ACTIONS(7488),
    [anon_sym_COLON_EQ] = ACTIONS(7488),
    [anon_sym_DASH_GT] = ACTIONS(7490),
    [anon_sym_DASH_GT_GT] = ACTIONS(7488),
    [anon_sym_PIPE] = ACTIONS(7490),
    [anon_sym_AMP] = ACTIONS(7490),
    [anon_sym_PIPE_PIPE] = ACTIONS(7488),
    [anon_sym_AMP_AMP] = ACTIONS(7488),
    [anon_sym_LT] = ACTIONS(7490),
    [anon_sym_LT_EQ] = ACTIONS(7488),
    [anon_sym_GT] = ACTIONS(7490),
    [anon_sym_GT_EQ] = ACTIONS(7488),
    [anon_sym_EQ_EQ] = ACTIONS(7488),
    [anon_sym_BANG_EQ] = ACTIONS(7488),
    [anon_sym_STAR] = ACTIONS(7490),
    [anon_sym_SLASH] = ACTIONS(7488),
    [anon_sym_STAR_STAR] = ACTIONS(7488),
    [anon_sym_CARET] = ACTIONS(7488),
    [aux_sym_binary_operator_token1] = ACTIONS(7488),
    [anon_sym_PIPE_GT] = ACTIONS(7488),
    [anon_sym_COLON] = ACTIONS(7490),
    [anon_sym_DOLLAR] = ACTIONS(7488),
    [anon_sym_AT] = ACTIONS(7488),
    [aux_sym__hex_literal_token1] = ACTIONS(7488),
    [sym__number_literal] = ACTIONS(7490),
    [anon_sym_SQUOTE] = ACTIONS(7488),
    [anon_sym_DQUOTE] = ACTIONS(7488),
    [sym_return] = ACTIONS(7490),
    [sym_next] = ACTIONS(7490),
    [sym_break] = ACTIONS(7490),
    [sym_true] = ACTIONS(7490),
    [sym_false] = ACTIONS(7490),
    [sym_null] = ACTIONS(7490),
    [sym_inf] = ACTIONS(7490),
    [sym_nan] = ACTIONS(7490),
    [anon_sym_NA] = ACTIONS(7490),
    [anon_sym_NA_integer_] = ACTIONS(7490),
    [anon_sym_NA_real_] = ACTIONS(7490),
    [anon_sym_NA_complex_] = ACTIONS(7490),
    [anon_sym_NA_character_] = ACTIONS(7490),
    [sym_dots] = ACTIONS(7490),
    [sym_dot_dot_i] = ACTIONS(7488),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7488),
    [sym__newline] = ACTIONS(7488),
    [sym__raw_string_literal] = ACTIONS(7488),
    [sym__external_else] = ACTIONS(7488),
    [sym__external_open_parenthesis] = ACTIONS(7488),
    [sym__external_open_brace] = ACTIONS(7488),
    [sym__external_open_bracket] = ACTIONS(7488),
    [sym__external_close_bracket] = ACTIONS(7488),
    [sym__external_open_bracket2] = ACTIONS(7488),
  },
  [2852] = {
    [sym_identifier] = ACTIONS(7524),
    [anon_sym_BSLASH] = ACTIONS(7522),
    [anon_sym_function] = ACTIONS(7524),
    [anon_sym_EQ] = ACTIONS(7524),
    [anon_sym_if] = ACTIONS(7524),
    [anon_sym_for] = ACTIONS(7524),
    [anon_sym_while] = ACTIONS(7524),
    [anon_sym_repeat] = ACTIONS(7524),
    [anon_sym_QMARK] = ACTIONS(7522),
    [anon_sym_TILDE] = ACTIONS(7522),
    [anon_sym_BANG] = ACTIONS(7524),
    [anon_sym_PLUS] = ACTIONS(7522),
    [anon_sym_DASH] = ACTIONS(7524),
    [anon_sym_LT_DASH] = ACTIONS(7522),
    [anon_sym_LT_LT_DASH] = ACTIONS(7522),
    [anon_sym_COLON_EQ] = ACTIONS(7522),
    [anon_sym_DASH_GT] = ACTIONS(7524),
    [anon_sym_DASH_GT_GT] = ACTIONS(7522),
    [anon_sym_PIPE] = ACTIONS(7524),
    [anon_sym_AMP] = ACTIONS(7524),
    [anon_sym_PIPE_PIPE] = ACTIONS(7522),
    [anon_sym_AMP_AMP] = ACTIONS(7522),
    [anon_sym_LT] = ACTIONS(7524),
    [anon_sym_LT_EQ] = ACTIONS(7522),
    [anon_sym_GT] = ACTIONS(7524),
    [anon_sym_GT_EQ] = ACTIONS(7522),
    [anon_sym_EQ_EQ] = ACTIONS(7522),
    [anon_sym_BANG_EQ] = ACTIONS(7522),
    [anon_sym_STAR] = ACTIONS(7524),
    [anon_sym_SLASH] = ACTIONS(7522),
    [anon_sym_STAR_STAR] = ACTIONS(7522),
    [anon_sym_CARET] = ACTIONS(7522),
    [aux_sym_binary_operator_token1] = ACTIONS(7522),
    [anon_sym_PIPE_GT] = ACTIONS(7522),
    [anon_sym_COLON] = ACTIONS(7524),
    [anon_sym_DOLLAR] = ACTIONS(7522),
    [anon_sym_AT] = ACTIONS(7522),
    [aux_sym__hex_literal_token1] = ACTIONS(7522),
    [sym__number_literal] = ACTIONS(7524),
    [anon_sym_SQUOTE] = ACTIONS(7522),
    [anon_sym_DQUOTE] = ACTIONS(7522),
    [sym_return] = ACTIONS(7524),
    [sym_next] = ACTIONS(7524),
    [sym_break] = ACTIONS(7524),
    [sym_true] = ACTIONS(7524),
    [sym_false] = ACTIONS(7524),
    [sym_null] = ACTIONS(7524),
    [sym_inf] = ACTIONS(7524),
    [sym_nan] = ACTIONS(7524),
    [anon_sym_NA] = ACTIONS(7524),
    [anon_sym_NA_integer_] = ACTIONS(7524),
    [anon_sym_NA_real_] = ACTIONS(7524),
    [anon_sym_NA_complex_] = ACTIONS(7524),
    [anon_sym_NA_character_] = ACTIONS(7524),
    [sym_dots] = ACTIONS(7524),
    [sym_dot_dot_i] = ACTIONS(7522),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7522),
    [sym__newline] = ACTIONS(7522),
    [sym__raw_string_literal] = ACTIONS(7522),
    [sym__external_else] = ACTIONS(7522),
    [sym__external_open_parenthesis] = ACTIONS(7522),
    [sym__external_close_parenthesis] = ACTIONS(7522),
    [sym__external_open_brace] = ACTIONS(7522),
    [sym__external_open_bracket] = ACTIONS(7522),
    [sym__external_open_bracket2] = ACTIONS(7522),
  },
  [2853] = {
    [sym_identifier] = ACTIONS(7532),
    [anon_sym_BSLASH] = ACTIONS(7530),
    [anon_sym_function] = ACTIONS(7532),
    [anon_sym_EQ] = ACTIONS(7532),
    [anon_sym_if] = ACTIONS(7532),
    [anon_sym_for] = ACTIONS(7532),
    [anon_sym_while] = ACTIONS(7532),
    [anon_sym_repeat] = ACTIONS(7532),
    [anon_sym_QMARK] = ACTIONS(7530),
    [anon_sym_TILDE] = ACTIONS(7530),
    [anon_sym_BANG] = ACTIONS(7532),
    [anon_sym_PLUS] = ACTIONS(7530),
    [anon_sym_DASH] = ACTIONS(7532),
    [anon_sym_LT_DASH] = ACTIONS(7530),
    [anon_sym_LT_LT_DASH] = ACTIONS(7530),
    [anon_sym_COLON_EQ] = ACTIONS(7530),
    [anon_sym_DASH_GT] = ACTIONS(7532),
    [anon_sym_DASH_GT_GT] = ACTIONS(7530),
    [anon_sym_PIPE] = ACTIONS(7532),
    [anon_sym_AMP] = ACTIONS(7532),
    [anon_sym_PIPE_PIPE] = ACTIONS(7530),
    [anon_sym_AMP_AMP] = ACTIONS(7530),
    [anon_sym_LT] = ACTIONS(7532),
    [anon_sym_LT_EQ] = ACTIONS(7530),
    [anon_sym_GT] = ACTIONS(7532),
    [anon_sym_GT_EQ] = ACTIONS(7530),
    [anon_sym_EQ_EQ] = ACTIONS(7530),
    [anon_sym_BANG_EQ] = ACTIONS(7530),
    [anon_sym_STAR] = ACTIONS(7532),
    [anon_sym_SLASH] = ACTIONS(7530),
    [anon_sym_STAR_STAR] = ACTIONS(7530),
    [anon_sym_CARET] = ACTIONS(7530),
    [aux_sym_binary_operator_token1] = ACTIONS(7530),
    [anon_sym_PIPE_GT] = ACTIONS(7530),
    [anon_sym_COLON] = ACTIONS(7532),
    [anon_sym_DOLLAR] = ACTIONS(7530),
    [anon_sym_AT] = ACTIONS(7530),
    [aux_sym__hex_literal_token1] = ACTIONS(7530),
    [sym__number_literal] = ACTIONS(7532),
    [anon_sym_SQUOTE] = ACTIONS(7530),
    [anon_sym_DQUOTE] = ACTIONS(7530),
    [sym_return] = ACTIONS(7532),
    [sym_next] = ACTIONS(7532),
    [sym_break] = ACTIONS(7532),
    [sym_true] = ACTIONS(7532),
    [sym_false] = ACTIONS(7532),
    [sym_null] = ACTIONS(7532),
    [sym_inf] = ACTIONS(7532),
    [sym_nan] = ACTIONS(7532),
    [anon_sym_NA] = ACTIONS(7532),
    [anon_sym_NA_integer_] = ACTIONS(7532),
    [anon_sym_NA_real_] = ACTIONS(7532),
    [anon_sym_NA_complex_] = ACTIONS(7532),
    [anon_sym_NA_character_] = ACTIONS(7532),
    [sym_dots] = ACTIONS(7532),
    [sym_dot_dot_i] = ACTIONS(7530),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7530),
    [sym__newline] = ACTIONS(7530),
    [sym__raw_string_literal] = ACTIONS(7530),
    [sym__external_else] = ACTIONS(7530),
    [sym__external_open_parenthesis] = ACTIONS(7530),
    [sym__external_open_brace] = ACTIONS(7530),
    [sym__external_open_bracket] = ACTIONS(7530),
    [sym__external_close_bracket] = ACTIONS(7530),
    [sym__external_open_bracket2] = ACTIONS(7530),
  },
  [2854] = {
    [sym_identifier] = ACTIONS(7528),
    [anon_sym_BSLASH] = ACTIONS(7526),
    [anon_sym_function] = ACTIONS(7528),
    [anon_sym_EQ] = ACTIONS(7528),
    [anon_sym_if] = ACTIONS(7528),
    [anon_sym_for] = ACTIONS(7528),
    [anon_sym_while] = ACTIONS(7528),
    [anon_sym_repeat] = ACTIONS(7528),
    [anon_sym_QMARK] = ACTIONS(7526),
    [anon_sym_TILDE] = ACTIONS(7526),
    [anon_sym_BANG] = ACTIONS(7528),
    [anon_sym_PLUS] = ACTIONS(7526),
    [anon_sym_DASH] = ACTIONS(7528),
    [anon_sym_LT_DASH] = ACTIONS(7526),
    [anon_sym_LT_LT_DASH] = ACTIONS(7526),
    [anon_sym_COLON_EQ] = ACTIONS(7526),
    [anon_sym_DASH_GT] = ACTIONS(7528),
    [anon_sym_DASH_GT_GT] = ACTIONS(7526),
    [anon_sym_PIPE] = ACTIONS(7528),
    [anon_sym_AMP] = ACTIONS(7528),
    [anon_sym_PIPE_PIPE] = ACTIONS(7526),
    [anon_sym_AMP_AMP] = ACTIONS(7526),
    [anon_sym_LT] = ACTIONS(7528),
    [anon_sym_LT_EQ] = ACTIONS(7526),
    [anon_sym_GT] = ACTIONS(7528),
    [anon_sym_GT_EQ] = ACTIONS(7526),
    [anon_sym_EQ_EQ] = ACTIONS(7526),
    [anon_sym_BANG_EQ] = ACTIONS(7526),
    [anon_sym_STAR] = ACTIONS(7528),
    [anon_sym_SLASH] = ACTIONS(7526),
    [anon_sym_STAR_STAR] = ACTIONS(7526),
    [anon_sym_CARET] = ACTIONS(7526),
    [aux_sym_binary_operator_token1] = ACTIONS(7526),
    [anon_sym_PIPE_GT] = ACTIONS(7526),
    [anon_sym_COLON] = ACTIONS(7528),
    [anon_sym_DOLLAR] = ACTIONS(7526),
    [anon_sym_AT] = ACTIONS(7526),
    [aux_sym__hex_literal_token1] = ACTIONS(7526),
    [sym__number_literal] = ACTIONS(7528),
    [anon_sym_SQUOTE] = ACTIONS(7526),
    [anon_sym_DQUOTE] = ACTIONS(7526),
    [sym_return] = ACTIONS(7528),
    [sym_next] = ACTIONS(7528),
    [sym_break] = ACTIONS(7528),
    [sym_true] = ACTIONS(7528),
    [sym_false] = ACTIONS(7528),
    [sym_null] = ACTIONS(7528),
    [sym_inf] = ACTIONS(7528),
    [sym_nan] = ACTIONS(7528),
    [anon_sym_NA] = ACTIONS(7528),
    [anon_sym_NA_integer_] = ACTIONS(7528),
    [anon_sym_NA_real_] = ACTIONS(7528),
    [anon_sym_NA_complex_] = ACTIONS(7528),
    [anon_sym_NA_character_] = ACTIONS(7528),
    [sym_dots] = ACTIONS(7528),
    [sym_dot_dot_i] = ACTIONS(7526),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7526),
    [sym__newline] = ACTIONS(7526),
    [sym__raw_string_literal] = ACTIONS(7526),
    [sym__external_else] = ACTIONS(7526),
    [sym__external_open_parenthesis] = ACTIONS(7526),
    [sym__external_open_brace] = ACTIONS(7526),
    [sym__external_open_bracket] = ACTIONS(7526),
    [sym__external_close_bracket] = ACTIONS(7526),
    [sym__external_open_bracket2] = ACTIONS(7526),
  },
  [2855] = {
    [sym_identifier] = ACTIONS(7512),
    [anon_sym_BSLASH] = ACTIONS(7510),
    [anon_sym_function] = ACTIONS(7512),
    [anon_sym_EQ] = ACTIONS(7512),
    [anon_sym_if] = ACTIONS(7512),
    [anon_sym_for] = ACTIONS(7512),
    [anon_sym_while] = ACTIONS(7512),
    [anon_sym_repeat] = ACTIONS(7512),
    [anon_sym_QMARK] = ACTIONS(7510),
    [anon_sym_TILDE] = ACTIONS(7510),
    [anon_sym_BANG] = ACTIONS(7512),
    [anon_sym_PLUS] = ACTIONS(7510),
    [anon_sym_DASH] = ACTIONS(7512),
    [anon_sym_LT_DASH] = ACTIONS(7510),
    [anon_sym_LT_LT_DASH] = ACTIONS(7510),
    [anon_sym_COLON_EQ] = ACTIONS(7510),
    [anon_sym_DASH_GT] = ACTIONS(7512),
    [anon_sym_DASH_GT_GT] = ACTIONS(7510),
    [anon_sym_PIPE] = ACTIONS(7512),
    [anon_sym_AMP] = ACTIONS(7512),
    [anon_sym_PIPE_PIPE] = ACTIONS(7510),
    [anon_sym_AMP_AMP] = ACTIONS(7510),
    [anon_sym_LT] = ACTIONS(7512),
    [anon_sym_LT_EQ] = ACTIONS(7510),
    [anon_sym_GT] = ACTIONS(7512),
    [anon_sym_GT_EQ] = ACTIONS(7510),
    [anon_sym_EQ_EQ] = ACTIONS(7510),
    [anon_sym_BANG_EQ] = ACTIONS(7510),
    [anon_sym_STAR] = ACTIONS(7512),
    [anon_sym_SLASH] = ACTIONS(7510),
    [anon_sym_STAR_STAR] = ACTIONS(7510),
    [anon_sym_CARET] = ACTIONS(7510),
    [aux_sym_binary_operator_token1] = ACTIONS(7510),
    [anon_sym_PIPE_GT] = ACTIONS(7510),
    [anon_sym_COLON] = ACTIONS(7512),
    [anon_sym_DOLLAR] = ACTIONS(7510),
    [anon_sym_AT] = ACTIONS(7510),
    [aux_sym__hex_literal_token1] = ACTIONS(7510),
    [sym__number_literal] = ACTIONS(7512),
    [anon_sym_SQUOTE] = ACTIONS(7510),
    [anon_sym_DQUOTE] = ACTIONS(7510),
    [sym_return] = ACTIONS(7512),
    [sym_next] = ACTIONS(7512),
    [sym_break] = ACTIONS(7512),
    [sym_true] = ACTIONS(7512),
    [sym_false] = ACTIONS(7512),
    [sym_null] = ACTIONS(7512),
    [sym_inf] = ACTIONS(7512),
    [sym_nan] = ACTIONS(7512),
    [anon_sym_NA] = ACTIONS(7512),
    [anon_sym_NA_integer_] = ACTIONS(7512),
    [anon_sym_NA_real_] = ACTIONS(7512),
    [anon_sym_NA_complex_] = ACTIONS(7512),
    [anon_sym_NA_character_] = ACTIONS(7512),
    [sym_dots] = ACTIONS(7512),
    [sym_dot_dot_i] = ACTIONS(7510),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7510),
    [sym__newline] = ACTIONS(7510),
    [sym__raw_string_literal] = ACTIONS(7510),
    [sym__external_else] = ACTIONS(7510),
    [sym__external_open_parenthesis] = ACTIONS(7510),
    [sym__external_open_brace] = ACTIONS(7510),
    [sym__external_open_bracket] = ACTIONS(7510),
    [sym__external_close_bracket] = ACTIONS(7510),
    [sym__external_open_bracket2] = ACTIONS(7510),
  },
  [2856] = {
    [ts_builtin_sym_end] = ACTIONS(7565),
    [sym_identifier] = ACTIONS(7567),
    [anon_sym_BSLASH] = ACTIONS(7565),
    [anon_sym_function] = ACTIONS(7567),
    [anon_sym_EQ] = ACTIONS(7567),
    [anon_sym_if] = ACTIONS(7567),
    [anon_sym_for] = ACTIONS(7567),
    [anon_sym_while] = ACTIONS(7567),
    [anon_sym_repeat] = ACTIONS(7567),
    [anon_sym_QMARK] = ACTIONS(7565),
    [anon_sym_TILDE] = ACTIONS(7565),
    [anon_sym_BANG] = ACTIONS(7567),
    [anon_sym_PLUS] = ACTIONS(7565),
    [anon_sym_DASH] = ACTIONS(7567),
    [anon_sym_LT_DASH] = ACTIONS(7565),
    [anon_sym_LT_LT_DASH] = ACTIONS(7565),
    [anon_sym_COLON_EQ] = ACTIONS(7565),
    [anon_sym_DASH_GT] = ACTIONS(7567),
    [anon_sym_DASH_GT_GT] = ACTIONS(7565),
    [anon_sym_PIPE] = ACTIONS(7567),
    [anon_sym_AMP] = ACTIONS(7567),
    [anon_sym_PIPE_PIPE] = ACTIONS(7565),
    [anon_sym_AMP_AMP] = ACTIONS(7565),
    [anon_sym_LT] = ACTIONS(7567),
    [anon_sym_LT_EQ] = ACTIONS(7565),
    [anon_sym_GT] = ACTIONS(7567),
    [anon_sym_GT_EQ] = ACTIONS(7565),
    [anon_sym_EQ_EQ] = ACTIONS(7565),
    [anon_sym_BANG_EQ] = ACTIONS(7565),
    [anon_sym_STAR] = ACTIONS(7567),
    [anon_sym_SLASH] = ACTIONS(7565),
    [anon_sym_STAR_STAR] = ACTIONS(7565),
    [anon_sym_CARET] = ACTIONS(7565),
    [aux_sym_binary_operator_token1] = ACTIONS(7565),
    [anon_sym_PIPE_GT] = ACTIONS(7565),
    [anon_sym_COLON] = ACTIONS(7567),
    [anon_sym_DOLLAR] = ACTIONS(7565),
    [anon_sym_AT] = ACTIONS(7565),
    [aux_sym__hex_literal_token1] = ACTIONS(7565),
    [sym__number_literal] = ACTIONS(7567),
    [anon_sym_SQUOTE] = ACTIONS(7565),
    [anon_sym_DQUOTE] = ACTIONS(7565),
    [sym_return] = ACTIONS(7567),
    [sym_next] = ACTIONS(7567),
    [sym_break] = ACTIONS(7567),
    [sym_true] = ACTIONS(7567),
    [sym_false] = ACTIONS(7567),
    [sym_null] = ACTIONS(7567),
    [sym_inf] = ACTIONS(7567),
    [sym_nan] = ACTIONS(7567),
    [anon_sym_NA] = ACTIONS(7567),
    [anon_sym_NA_integer_] = ACTIONS(7567),
    [anon_sym_NA_real_] = ACTIONS(7567),
    [anon_sym_NA_complex_] = ACTIONS(7567),
    [anon_sym_NA_character_] = ACTIONS(7567),
    [sym_dots] = ACTIONS(7567),
    [sym_dot_dot_i] = ACTIONS(7565),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7565),
    [sym__semicolon] = ACTIONS(7565),
    [sym__raw_string_literal] = ACTIONS(7565),
    [sym__external_open_parenthesis] = ACTIONS(7565),
    [sym__external_close_parenthesis] = ACTIONS(7565),
    [sym__external_open_brace] = ACTIONS(7565),
    [sym__external_open_bracket] = ACTIONS(7565),
    [sym__external_open_bracket2] = ACTIONS(7565),
  },
  [2857] = {
    [sym_identifier] = ACTIONS(7506),
    [anon_sym_BSLASH] = ACTIONS(7504),
    [anon_sym_function] = ACTIONS(7506),
    [anon_sym_EQ] = ACTIONS(7506),
    [anon_sym_if] = ACTIONS(7506),
    [anon_sym_for] = ACTIONS(7506),
    [anon_sym_while] = ACTIONS(7506),
    [anon_sym_repeat] = ACTIONS(7506),
    [anon_sym_QMARK] = ACTIONS(7504),
    [anon_sym_TILDE] = ACTIONS(7504),
    [anon_sym_BANG] = ACTIONS(7506),
    [anon_sym_PLUS] = ACTIONS(7504),
    [anon_sym_DASH] = ACTIONS(7506),
    [anon_sym_LT_DASH] = ACTIONS(7504),
    [anon_sym_LT_LT_DASH] = ACTIONS(7504),
    [anon_sym_COLON_EQ] = ACTIONS(7504),
    [anon_sym_DASH_GT] = ACTIONS(7506),
    [anon_sym_DASH_GT_GT] = ACTIONS(7504),
    [anon_sym_PIPE] = ACTIONS(7506),
    [anon_sym_AMP] = ACTIONS(7506),
    [anon_sym_PIPE_PIPE] = ACTIONS(7504),
    [anon_sym_AMP_AMP] = ACTIONS(7504),
    [anon_sym_LT] = ACTIONS(7506),
    [anon_sym_LT_EQ] = ACTIONS(7504),
    [anon_sym_GT] = ACTIONS(7506),
    [anon_sym_GT_EQ] = ACTIONS(7504),
    [anon_sym_EQ_EQ] = ACTIONS(7504),
    [anon_sym_BANG_EQ] = ACTIONS(7504),
    [anon_sym_STAR] = ACTIONS(7506),
    [anon_sym_SLASH] = ACTIONS(7504),
    [anon_sym_STAR_STAR] = ACTIONS(7504),
    [anon_sym_CARET] = ACTIONS(7504),
    [aux_sym_binary_operator_token1] = ACTIONS(7504),
    [anon_sym_PIPE_GT] = ACTIONS(7504),
    [anon_sym_COLON] = ACTIONS(7506),
    [anon_sym_DOLLAR] = ACTIONS(7504),
    [anon_sym_AT] = ACTIONS(7504),
    [aux_sym__hex_literal_token1] = ACTIONS(7504),
    [sym__number_literal] = ACTIONS(7506),
    [anon_sym_SQUOTE] = ACTIONS(7504),
    [anon_sym_DQUOTE] = ACTIONS(7504),
    [sym_return] = ACTIONS(7506),
    [sym_next] = ACTIONS(7506),
    [sym_break] = ACTIONS(7506),
    [sym_true] = ACTIONS(7506),
    [sym_false] = ACTIONS(7506),
    [sym_null] = ACTIONS(7506),
    [sym_inf] = ACTIONS(7506),
    [sym_nan] = ACTIONS(7506),
    [anon_sym_NA] = ACTIONS(7506),
    [anon_sym_NA_integer_] = ACTIONS(7506),
    [anon_sym_NA_real_] = ACTIONS(7506),
    [anon_sym_NA_complex_] = ACTIONS(7506),
    [anon_sym_NA_character_] = ACTIONS(7506),
    [sym_dots] = ACTIONS(7506),
    [sym_dot_dot_i] = ACTIONS(7504),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7504),
    [sym__newline] = ACTIONS(7504),
    [sym__raw_string_literal] = ACTIONS(7504),
    [sym__external_else] = ACTIONS(7504),
    [sym__external_open_parenthesis] = ACTIONS(7504),
    [sym__external_open_brace] = ACTIONS(7504),
    [sym__external_open_bracket] = ACTIONS(7504),
    [sym__external_close_bracket] = ACTIONS(7504),
    [sym__external_open_bracket2] = ACTIONS(7504),
  },
  [2858] = {
    [sym_identifier] = ACTIONS(7516),
    [anon_sym_BSLASH] = ACTIONS(7514),
    [anon_sym_function] = ACTIONS(7516),
    [anon_sym_EQ] = ACTIONS(7516),
    [anon_sym_if] = ACTIONS(7516),
    [anon_sym_for] = ACTIONS(7516),
    [anon_sym_while] = ACTIONS(7516),
    [anon_sym_repeat] = ACTIONS(7516),
    [anon_sym_QMARK] = ACTIONS(7514),
    [anon_sym_TILDE] = ACTIONS(7514),
    [anon_sym_BANG] = ACTIONS(7516),
    [anon_sym_PLUS] = ACTIONS(7514),
    [anon_sym_DASH] = ACTIONS(7516),
    [anon_sym_LT_DASH] = ACTIONS(7514),
    [anon_sym_LT_LT_DASH] = ACTIONS(7514),
    [anon_sym_COLON_EQ] = ACTIONS(7514),
    [anon_sym_DASH_GT] = ACTIONS(7516),
    [anon_sym_DASH_GT_GT] = ACTIONS(7514),
    [anon_sym_PIPE] = ACTIONS(7516),
    [anon_sym_AMP] = ACTIONS(7516),
    [anon_sym_PIPE_PIPE] = ACTIONS(7514),
    [anon_sym_AMP_AMP] = ACTIONS(7514),
    [anon_sym_LT] = ACTIONS(7516),
    [anon_sym_LT_EQ] = ACTIONS(7514),
    [anon_sym_GT] = ACTIONS(7516),
    [anon_sym_GT_EQ] = ACTIONS(7514),
    [anon_sym_EQ_EQ] = ACTIONS(7514),
    [anon_sym_BANG_EQ] = ACTIONS(7514),
    [anon_sym_STAR] = ACTIONS(7516),
    [anon_sym_SLASH] = ACTIONS(7514),
    [anon_sym_STAR_STAR] = ACTIONS(7514),
    [anon_sym_CARET] = ACTIONS(7514),
    [aux_sym_binary_operator_token1] = ACTIONS(7514),
    [anon_sym_PIPE_GT] = ACTIONS(7514),
    [anon_sym_COLON] = ACTIONS(7516),
    [anon_sym_DOLLAR] = ACTIONS(7514),
    [anon_sym_AT] = ACTIONS(7514),
    [aux_sym__hex_literal_token1] = ACTIONS(7514),
    [sym__number_literal] = ACTIONS(7516),
    [anon_sym_SQUOTE] = ACTIONS(7514),
    [anon_sym_DQUOTE] = ACTIONS(7514),
    [sym_return] = ACTIONS(7516),
    [sym_next] = ACTIONS(7516),
    [sym_break] = ACTIONS(7516),
    [sym_true] = ACTIONS(7516),
    [sym_false] = ACTIONS(7516),
    [sym_null] = ACTIONS(7516),
    [sym_inf] = ACTIONS(7516),
    [sym_nan] = ACTIONS(7516),
    [anon_sym_NA] = ACTIONS(7516),
    [anon_sym_NA_integer_] = ACTIONS(7516),
    [anon_sym_NA_real_] = ACTIONS(7516),
    [anon_sym_NA_complex_] = ACTIONS(7516),
    [anon_sym_NA_character_] = ACTIONS(7516),
    [sym_dots] = ACTIONS(7516),
    [sym_dot_dot_i] = ACTIONS(7514),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7514),
    [sym__newline] = ACTIONS(7514),
    [sym__raw_string_literal] = ACTIONS(7514),
    [sym__external_else] = ACTIONS(7514),
    [sym__external_open_parenthesis] = ACTIONS(7514),
    [sym__external_open_brace] = ACTIONS(7514),
    [sym__external_open_bracket] = ACTIONS(7514),
    [sym__external_open_bracket2] = ACTIONS(7514),
    [sym__external_close_bracket2] = ACTIONS(7514),
  },
  [2859] = {
    [sym_identifier] = ACTIONS(5311),
    [anon_sym_BSLASH] = ACTIONS(5313),
    [anon_sym_function] = ACTIONS(5311),
    [anon_sym_EQ] = ACTIONS(5311),
    [anon_sym_if] = ACTIONS(5311),
    [anon_sym_for] = ACTIONS(5311),
    [anon_sym_while] = ACTIONS(5311),
    [anon_sym_repeat] = ACTIONS(5311),
    [anon_sym_QMARK] = ACTIONS(5313),
    [anon_sym_TILDE] = ACTIONS(5313),
    [anon_sym_BANG] = ACTIONS(5311),
    [anon_sym_PLUS] = ACTIONS(5313),
    [anon_sym_DASH] = ACTIONS(5311),
    [anon_sym_LT_DASH] = ACTIONS(5313),
    [anon_sym_LT_LT_DASH] = ACTIONS(5313),
    [anon_sym_COLON_EQ] = ACTIONS(5313),
    [anon_sym_DASH_GT] = ACTIONS(5311),
    [anon_sym_DASH_GT_GT] = ACTIONS(5313),
    [anon_sym_PIPE] = ACTIONS(5311),
    [anon_sym_AMP] = ACTIONS(5311),
    [anon_sym_PIPE_PIPE] = ACTIONS(5313),
    [anon_sym_AMP_AMP] = ACTIONS(5313),
    [anon_sym_LT] = ACTIONS(5311),
    [anon_sym_LT_EQ] = ACTIONS(5313),
    [anon_sym_GT] = ACTIONS(5311),
    [anon_sym_GT_EQ] = ACTIONS(5313),
    [anon_sym_EQ_EQ] = ACTIONS(5313),
    [anon_sym_BANG_EQ] = ACTIONS(5313),
    [anon_sym_STAR] = ACTIONS(5311),
    [anon_sym_SLASH] = ACTIONS(5313),
    [anon_sym_STAR_STAR] = ACTIONS(5313),
    [anon_sym_CARET] = ACTIONS(5313),
    [aux_sym_binary_operator_token1] = ACTIONS(5313),
    [anon_sym_PIPE_GT] = ACTIONS(5313),
    [anon_sym_COLON] = ACTIONS(5311),
    [anon_sym_DOLLAR] = ACTIONS(5313),
    [anon_sym_AT] = ACTIONS(5313),
    [aux_sym__hex_literal_token1] = ACTIONS(5313),
    [sym__number_literal] = ACTIONS(5311),
    [anon_sym_SQUOTE] = ACTIONS(5313),
    [anon_sym_DQUOTE] = ACTIONS(5313),
    [sym_return] = ACTIONS(5311),
    [sym_next] = ACTIONS(5311),
    [sym_break] = ACTIONS(5311),
    [sym_true] = ACTIONS(5311),
    [sym_false] = ACTIONS(5311),
    [sym_null] = ACTIONS(5311),
    [sym_inf] = ACTIONS(5311),
    [sym_nan] = ACTIONS(5311),
    [anon_sym_NA] = ACTIONS(5311),
    [anon_sym_NA_integer_] = ACTIONS(5311),
    [anon_sym_NA_real_] = ACTIONS(5311),
    [anon_sym_NA_complex_] = ACTIONS(5311),
    [anon_sym_NA_character_] = ACTIONS(5311),
    [sym_dots] = ACTIONS(5311),
    [sym_dot_dot_i] = ACTIONS(5313),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5313),
    [sym__newline] = ACTIONS(5313),
    [sym__raw_string_literal] = ACTIONS(5313),
    [sym__external_open_parenthesis] = ACTIONS(5313),
    [sym__external_close_parenthesis] = ACTIONS(5313),
    [sym__external_open_brace] = ACTIONS(5313),
    [sym__external_open_bracket] = ACTIONS(5313),
    [sym__external_open_bracket2] = ACTIONS(5313),
    [sym__external_close_bracket2] = ACTIONS(5313),
  },
  [2860] = {
    [sym_identifier] = ACTIONS(7502),
    [anon_sym_BSLASH] = ACTIONS(7500),
    [anon_sym_function] = ACTIONS(7502),
    [anon_sym_EQ] = ACTIONS(7502),
    [anon_sym_if] = ACTIONS(7502),
    [anon_sym_for] = ACTIONS(7502),
    [anon_sym_while] = ACTIONS(7502),
    [anon_sym_repeat] = ACTIONS(7502),
    [anon_sym_QMARK] = ACTIONS(7500),
    [anon_sym_TILDE] = ACTIONS(7500),
    [anon_sym_BANG] = ACTIONS(7502),
    [anon_sym_PLUS] = ACTIONS(7500),
    [anon_sym_DASH] = ACTIONS(7502),
    [anon_sym_LT_DASH] = ACTIONS(7500),
    [anon_sym_LT_LT_DASH] = ACTIONS(7500),
    [anon_sym_COLON_EQ] = ACTIONS(7500),
    [anon_sym_DASH_GT] = ACTIONS(7502),
    [anon_sym_DASH_GT_GT] = ACTIONS(7500),
    [anon_sym_PIPE] = ACTIONS(7502),
    [anon_sym_AMP] = ACTIONS(7502),
    [anon_sym_PIPE_PIPE] = ACTIONS(7500),
    [anon_sym_AMP_AMP] = ACTIONS(7500),
    [anon_sym_LT] = ACTIONS(7502),
    [anon_sym_LT_EQ] = ACTIONS(7500),
    [anon_sym_GT] = ACTIONS(7502),
    [anon_sym_GT_EQ] = ACTIONS(7500),
    [anon_sym_EQ_EQ] = ACTIONS(7500),
    [anon_sym_BANG_EQ] = ACTIONS(7500),
    [anon_sym_STAR] = ACTIONS(7502),
    [anon_sym_SLASH] = ACTIONS(7500),
    [anon_sym_STAR_STAR] = ACTIONS(7500),
    [anon_sym_CARET] = ACTIONS(7500),
    [aux_sym_binary_operator_token1] = ACTIONS(7500),
    [anon_sym_PIPE_GT] = ACTIONS(7500),
    [anon_sym_COLON] = ACTIONS(7502),
    [anon_sym_DOLLAR] = ACTIONS(7500),
    [anon_sym_AT] = ACTIONS(7500),
    [aux_sym__hex_literal_token1] = ACTIONS(7500),
    [sym__number_literal] = ACTIONS(7502),
    [anon_sym_SQUOTE] = ACTIONS(7500),
    [anon_sym_DQUOTE] = ACTIONS(7500),
    [sym_return] = ACTIONS(7502),
    [sym_next] = ACTIONS(7502),
    [sym_break] = ACTIONS(7502),
    [sym_true] = ACTIONS(7502),
    [sym_false] = ACTIONS(7502),
    [sym_null] = ACTIONS(7502),
    [sym_inf] = ACTIONS(7502),
    [sym_nan] = ACTIONS(7502),
    [anon_sym_NA] = ACTIONS(7502),
    [anon_sym_NA_integer_] = ACTIONS(7502),
    [anon_sym_NA_real_] = ACTIONS(7502),
    [anon_sym_NA_complex_] = ACTIONS(7502),
    [anon_sym_NA_character_] = ACTIONS(7502),
    [sym_dots] = ACTIONS(7502),
    [sym_dot_dot_i] = ACTIONS(7500),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7500),
    [sym__newline] = ACTIONS(7500),
    [sym__raw_string_literal] = ACTIONS(7500),
    [sym__external_else] = ACTIONS(7500),
    [sym__external_open_parenthesis] = ACTIONS(7500),
    [sym__external_open_brace] = ACTIONS(7500),
    [sym__external_open_bracket] = ACTIONS(7500),
    [sym__external_close_bracket] = ACTIONS(7500),
    [sym__external_open_bracket2] = ACTIONS(7500),
  },
  [2861] = {
    [sym_identifier] = ACTIONS(7520),
    [anon_sym_BSLASH] = ACTIONS(7518),
    [anon_sym_function] = ACTIONS(7520),
    [anon_sym_EQ] = ACTIONS(7520),
    [anon_sym_if] = ACTIONS(7520),
    [anon_sym_for] = ACTIONS(7520),
    [anon_sym_while] = ACTIONS(7520),
    [anon_sym_repeat] = ACTIONS(7520),
    [anon_sym_QMARK] = ACTIONS(7518),
    [anon_sym_TILDE] = ACTIONS(7518),
    [anon_sym_BANG] = ACTIONS(7520),
    [anon_sym_PLUS] = ACTIONS(7518),
    [anon_sym_DASH] = ACTIONS(7520),
    [anon_sym_LT_DASH] = ACTIONS(7518),
    [anon_sym_LT_LT_DASH] = ACTIONS(7518),
    [anon_sym_COLON_EQ] = ACTIONS(7518),
    [anon_sym_DASH_GT] = ACTIONS(7520),
    [anon_sym_DASH_GT_GT] = ACTIONS(7518),
    [anon_sym_PIPE] = ACTIONS(7520),
    [anon_sym_AMP] = ACTIONS(7520),
    [anon_sym_PIPE_PIPE] = ACTIONS(7518),
    [anon_sym_AMP_AMP] = ACTIONS(7518),
    [anon_sym_LT] = ACTIONS(7520),
    [anon_sym_LT_EQ] = ACTIONS(7518),
    [anon_sym_GT] = ACTIONS(7520),
    [anon_sym_GT_EQ] = ACTIONS(7518),
    [anon_sym_EQ_EQ] = ACTIONS(7518),
    [anon_sym_BANG_EQ] = ACTIONS(7518),
    [anon_sym_STAR] = ACTIONS(7520),
    [anon_sym_SLASH] = ACTIONS(7518),
    [anon_sym_STAR_STAR] = ACTIONS(7518),
    [anon_sym_CARET] = ACTIONS(7518),
    [aux_sym_binary_operator_token1] = ACTIONS(7518),
    [anon_sym_PIPE_GT] = ACTIONS(7518),
    [anon_sym_COLON] = ACTIONS(7520),
    [anon_sym_DOLLAR] = ACTIONS(7518),
    [anon_sym_AT] = ACTIONS(7518),
    [aux_sym__hex_literal_token1] = ACTIONS(7518),
    [sym__number_literal] = ACTIONS(7520),
    [anon_sym_SQUOTE] = ACTIONS(7518),
    [anon_sym_DQUOTE] = ACTIONS(7518),
    [sym_return] = ACTIONS(7520),
    [sym_next] = ACTIONS(7520),
    [sym_break] = ACTIONS(7520),
    [sym_true] = ACTIONS(7520),
    [sym_false] = ACTIONS(7520),
    [sym_null] = ACTIONS(7520),
    [sym_inf] = ACTIONS(7520),
    [sym_nan] = ACTIONS(7520),
    [anon_sym_NA] = ACTIONS(7520),
    [anon_sym_NA_integer_] = ACTIONS(7520),
    [anon_sym_NA_real_] = ACTIONS(7520),
    [anon_sym_NA_complex_] = ACTIONS(7520),
    [anon_sym_NA_character_] = ACTIONS(7520),
    [sym_dots] = ACTIONS(7520),
    [sym_dot_dot_i] = ACTIONS(7518),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7518),
    [sym__newline] = ACTIONS(7518),
    [sym__raw_string_literal] = ACTIONS(7518),
    [sym__external_else] = ACTIONS(7518),
    [sym__external_open_parenthesis] = ACTIONS(7518),
    [sym__external_open_brace] = ACTIONS(7518),
    [sym__external_open_bracket] = ACTIONS(7518),
    [sym__external_open_bracket2] = ACTIONS(7518),
    [sym__external_close_bracket2] = ACTIONS(7518),
  },
  [2862] = {
    [ts_builtin_sym_end] = ACTIONS(7472),
    [sym_identifier] = ACTIONS(7474),
    [anon_sym_BSLASH] = ACTIONS(7472),
    [anon_sym_function] = ACTIONS(7474),
    [anon_sym_EQ] = ACTIONS(7474),
    [anon_sym_if] = ACTIONS(7474),
    [anon_sym_for] = ACTIONS(7474),
    [anon_sym_while] = ACTIONS(7474),
    [anon_sym_repeat] = ACTIONS(7474),
    [anon_sym_QMARK] = ACTIONS(7472),
    [anon_sym_TILDE] = ACTIONS(7472),
    [anon_sym_BANG] = ACTIONS(7474),
    [anon_sym_PLUS] = ACTIONS(7472),
    [anon_sym_DASH] = ACTIONS(7474),
    [anon_sym_LT_DASH] = ACTIONS(7472),
    [anon_sym_LT_LT_DASH] = ACTIONS(7472),
    [anon_sym_COLON_EQ] = ACTIONS(7472),
    [anon_sym_DASH_GT] = ACTIONS(7474),
    [anon_sym_DASH_GT_GT] = ACTIONS(7472),
    [anon_sym_PIPE] = ACTIONS(7474),
    [anon_sym_AMP] = ACTIONS(7474),
    [anon_sym_PIPE_PIPE] = ACTIONS(7472),
    [anon_sym_AMP_AMP] = ACTIONS(7472),
    [anon_sym_LT] = ACTIONS(7474),
    [anon_sym_LT_EQ] = ACTIONS(7472),
    [anon_sym_GT] = ACTIONS(7474),
    [anon_sym_GT_EQ] = ACTIONS(7472),
    [anon_sym_EQ_EQ] = ACTIONS(7472),
    [anon_sym_BANG_EQ] = ACTIONS(7472),
    [anon_sym_STAR] = ACTIONS(7474),
    [anon_sym_SLASH] = ACTIONS(7472),
    [anon_sym_STAR_STAR] = ACTIONS(7472),
    [anon_sym_CARET] = ACTIONS(7472),
    [aux_sym_binary_operator_token1] = ACTIONS(7472),
    [anon_sym_PIPE_GT] = ACTIONS(7472),
    [anon_sym_COLON] = ACTIONS(7474),
    [anon_sym_DOLLAR] = ACTIONS(7472),
    [anon_sym_AT] = ACTIONS(7472),
    [aux_sym__hex_literal_token1] = ACTIONS(7472),
    [sym__number_literal] = ACTIONS(7474),
    [anon_sym_SQUOTE] = ACTIONS(7472),
    [anon_sym_DQUOTE] = ACTIONS(7472),
    [sym_return] = ACTIONS(7474),
    [sym_next] = ACTIONS(7474),
    [sym_break] = ACTIONS(7474),
    [sym_true] = ACTIONS(7474),
    [sym_false] = ACTIONS(7474),
    [sym_null] = ACTIONS(7474),
    [sym_inf] = ACTIONS(7474),
    [sym_nan] = ACTIONS(7474),
    [anon_sym_NA] = ACTIONS(7474),
    [anon_sym_NA_integer_] = ACTIONS(7474),
    [anon_sym_NA_real_] = ACTIONS(7474),
    [anon_sym_NA_complex_] = ACTIONS(7474),
    [anon_sym_NA_character_] = ACTIONS(7474),
    [sym_dots] = ACTIONS(7474),
    [sym_dot_dot_i] = ACTIONS(7472),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7472),
    [sym__semicolon] = ACTIONS(7472),
    [sym__raw_string_literal] = ACTIONS(7472),
    [sym__external_open_parenthesis] = ACTIONS(7472),
    [sym__external_open_brace] = ACTIONS(7472),
    [sym__external_close_brace] = ACTIONS(7472),
    [sym__external_open_bracket] = ACTIONS(7472),
    [sym__external_open_bracket2] = ACTIONS(7472),
  },
  [2863] = {
    [sym_identifier] = ACTIONS(7498),
    [anon_sym_BSLASH] = ACTIONS(7496),
    [anon_sym_function] = ACTIONS(7498),
    [anon_sym_EQ] = ACTIONS(7498),
    [anon_sym_if] = ACTIONS(7498),
    [anon_sym_for] = ACTIONS(7498),
    [anon_sym_while] = ACTIONS(7498),
    [anon_sym_repeat] = ACTIONS(7498),
    [anon_sym_QMARK] = ACTIONS(7496),
    [anon_sym_TILDE] = ACTIONS(7496),
    [anon_sym_BANG] = ACTIONS(7498),
    [anon_sym_PLUS] = ACTIONS(7496),
    [anon_sym_DASH] = ACTIONS(7498),
    [anon_sym_LT_DASH] = ACTIONS(7496),
    [anon_sym_LT_LT_DASH] = ACTIONS(7496),
    [anon_sym_COLON_EQ] = ACTIONS(7496),
    [anon_sym_DASH_GT] = ACTIONS(7498),
    [anon_sym_DASH_GT_GT] = ACTIONS(7496),
    [anon_sym_PIPE] = ACTIONS(7498),
    [anon_sym_AMP] = ACTIONS(7498),
    [anon_sym_PIPE_PIPE] = ACTIONS(7496),
    [anon_sym_AMP_AMP] = ACTIONS(7496),
    [anon_sym_LT] = ACTIONS(7498),
    [anon_sym_LT_EQ] = ACTIONS(7496),
    [anon_sym_GT] = ACTIONS(7498),
    [anon_sym_GT_EQ] = ACTIONS(7496),
    [anon_sym_EQ_EQ] = ACTIONS(7496),
    [anon_sym_BANG_EQ] = ACTIONS(7496),
    [anon_sym_STAR] = ACTIONS(7498),
    [anon_sym_SLASH] = ACTIONS(7496),
    [anon_sym_STAR_STAR] = ACTIONS(7496),
    [anon_sym_CARET] = ACTIONS(7496),
    [aux_sym_binary_operator_token1] = ACTIONS(7496),
    [anon_sym_PIPE_GT] = ACTIONS(7496),
    [anon_sym_COLON] = ACTIONS(7498),
    [anon_sym_DOLLAR] = ACTIONS(7496),
    [anon_sym_AT] = ACTIONS(7496),
    [aux_sym__hex_literal_token1] = ACTIONS(7496),
    [sym__number_literal] = ACTIONS(7498),
    [anon_sym_SQUOTE] = ACTIONS(7496),
    [anon_sym_DQUOTE] = ACTIONS(7496),
    [sym_return] = ACTIONS(7498),
    [sym_next] = ACTIONS(7498),
    [sym_break] = ACTIONS(7498),
    [sym_true] = ACTIONS(7498),
    [sym_false] = ACTIONS(7498),
    [sym_null] = ACTIONS(7498),
    [sym_inf] = ACTIONS(7498),
    [sym_nan] = ACTIONS(7498),
    [anon_sym_NA] = ACTIONS(7498),
    [anon_sym_NA_integer_] = ACTIONS(7498),
    [anon_sym_NA_real_] = ACTIONS(7498),
    [anon_sym_NA_complex_] = ACTIONS(7498),
    [anon_sym_NA_character_] = ACTIONS(7498),
    [sym_dots] = ACTIONS(7498),
    [sym_dot_dot_i] = ACTIONS(7496),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7496),
    [sym__newline] = ACTIONS(7496),
    [sym__raw_string_literal] = ACTIONS(7496),
    [sym__external_else] = ACTIONS(7496),
    [sym__external_open_parenthesis] = ACTIONS(7496),
    [sym__external_open_brace] = ACTIONS(7496),
    [sym__external_open_bracket] = ACTIONS(7496),
    [sym__external_close_bracket] = ACTIONS(7496),
    [sym__external_open_bracket2] = ACTIONS(7496),
  },
  [2864] = {
    [sym_identifier] = ACTIONS(7524),
    [anon_sym_BSLASH] = ACTIONS(7522),
    [anon_sym_function] = ACTIONS(7524),
    [anon_sym_EQ] = ACTIONS(7524),
    [anon_sym_if] = ACTIONS(7524),
    [anon_sym_for] = ACTIONS(7524),
    [anon_sym_while] = ACTIONS(7524),
    [anon_sym_repeat] = ACTIONS(7524),
    [anon_sym_QMARK] = ACTIONS(7522),
    [anon_sym_TILDE] = ACTIONS(7522),
    [anon_sym_BANG] = ACTIONS(7524),
    [anon_sym_PLUS] = ACTIONS(7522),
    [anon_sym_DASH] = ACTIONS(7524),
    [anon_sym_LT_DASH] = ACTIONS(7522),
    [anon_sym_LT_LT_DASH] = ACTIONS(7522),
    [anon_sym_COLON_EQ] = ACTIONS(7522),
    [anon_sym_DASH_GT] = ACTIONS(7524),
    [anon_sym_DASH_GT_GT] = ACTIONS(7522),
    [anon_sym_PIPE] = ACTIONS(7524),
    [anon_sym_AMP] = ACTIONS(7524),
    [anon_sym_PIPE_PIPE] = ACTIONS(7522),
    [anon_sym_AMP_AMP] = ACTIONS(7522),
    [anon_sym_LT] = ACTIONS(7524),
    [anon_sym_LT_EQ] = ACTIONS(7522),
    [anon_sym_GT] = ACTIONS(7524),
    [anon_sym_GT_EQ] = ACTIONS(7522),
    [anon_sym_EQ_EQ] = ACTIONS(7522),
    [anon_sym_BANG_EQ] = ACTIONS(7522),
    [anon_sym_STAR] = ACTIONS(7524),
    [anon_sym_SLASH] = ACTIONS(7522),
    [anon_sym_STAR_STAR] = ACTIONS(7522),
    [anon_sym_CARET] = ACTIONS(7522),
    [aux_sym_binary_operator_token1] = ACTIONS(7522),
    [anon_sym_PIPE_GT] = ACTIONS(7522),
    [anon_sym_COLON] = ACTIONS(7524),
    [anon_sym_DOLLAR] = ACTIONS(7522),
    [anon_sym_AT] = ACTIONS(7522),
    [aux_sym__hex_literal_token1] = ACTIONS(7522),
    [sym__number_literal] = ACTIONS(7524),
    [anon_sym_SQUOTE] = ACTIONS(7522),
    [anon_sym_DQUOTE] = ACTIONS(7522),
    [sym_return] = ACTIONS(7524),
    [sym_next] = ACTIONS(7524),
    [sym_break] = ACTIONS(7524),
    [sym_true] = ACTIONS(7524),
    [sym_false] = ACTIONS(7524),
    [sym_null] = ACTIONS(7524),
    [sym_inf] = ACTIONS(7524),
    [sym_nan] = ACTIONS(7524),
    [anon_sym_NA] = ACTIONS(7524),
    [anon_sym_NA_integer_] = ACTIONS(7524),
    [anon_sym_NA_real_] = ACTIONS(7524),
    [anon_sym_NA_complex_] = ACTIONS(7524),
    [anon_sym_NA_character_] = ACTIONS(7524),
    [sym_dots] = ACTIONS(7524),
    [sym_dot_dot_i] = ACTIONS(7522),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7522),
    [sym__newline] = ACTIONS(7522),
    [sym__raw_string_literal] = ACTIONS(7522),
    [sym__external_else] = ACTIONS(7522),
    [sym__external_open_parenthesis] = ACTIONS(7522),
    [sym__external_open_brace] = ACTIONS(7522),
    [sym__external_open_bracket] = ACTIONS(7522),
    [sym__external_close_bracket] = ACTIONS(7522),
    [sym__external_open_bracket2] = ACTIONS(7522),
  },
  [2865] = {
    [ts_builtin_sym_end] = ACTIONS(7514),
    [sym_identifier] = ACTIONS(7516),
    [anon_sym_BSLASH] = ACTIONS(7514),
    [anon_sym_function] = ACTIONS(7516),
    [anon_sym_EQ] = ACTIONS(7516),
    [anon_sym_if] = ACTIONS(7516),
    [anon_sym_for] = ACTIONS(7516),
    [anon_sym_while] = ACTIONS(7516),
    [anon_sym_repeat] = ACTIONS(7516),
    [anon_sym_QMARK] = ACTIONS(7514),
    [anon_sym_TILDE] = ACTIONS(7514),
    [anon_sym_BANG] = ACTIONS(7516),
    [anon_sym_PLUS] = ACTIONS(7514),
    [anon_sym_DASH] = ACTIONS(7516),
    [anon_sym_LT_DASH] = ACTIONS(7514),
    [anon_sym_LT_LT_DASH] = ACTIONS(7514),
    [anon_sym_COLON_EQ] = ACTIONS(7514),
    [anon_sym_DASH_GT] = ACTIONS(7516),
    [anon_sym_DASH_GT_GT] = ACTIONS(7514),
    [anon_sym_PIPE] = ACTIONS(7516),
    [anon_sym_AMP] = ACTIONS(7516),
    [anon_sym_PIPE_PIPE] = ACTIONS(7514),
    [anon_sym_AMP_AMP] = ACTIONS(7514),
    [anon_sym_LT] = ACTIONS(7516),
    [anon_sym_LT_EQ] = ACTIONS(7514),
    [anon_sym_GT] = ACTIONS(7516),
    [anon_sym_GT_EQ] = ACTIONS(7514),
    [anon_sym_EQ_EQ] = ACTIONS(7514),
    [anon_sym_BANG_EQ] = ACTIONS(7514),
    [anon_sym_STAR] = ACTIONS(7516),
    [anon_sym_SLASH] = ACTIONS(7514),
    [anon_sym_STAR_STAR] = ACTIONS(7514),
    [anon_sym_CARET] = ACTIONS(7514),
    [aux_sym_binary_operator_token1] = ACTIONS(7514),
    [anon_sym_PIPE_GT] = ACTIONS(7514),
    [anon_sym_COLON] = ACTIONS(7516),
    [anon_sym_DOLLAR] = ACTIONS(7514),
    [anon_sym_AT] = ACTIONS(7514),
    [aux_sym__hex_literal_token1] = ACTIONS(7514),
    [sym__number_literal] = ACTIONS(7516),
    [anon_sym_SQUOTE] = ACTIONS(7514),
    [anon_sym_DQUOTE] = ACTIONS(7514),
    [sym_return] = ACTIONS(7516),
    [sym_next] = ACTIONS(7516),
    [sym_break] = ACTIONS(7516),
    [sym_true] = ACTIONS(7516),
    [sym_false] = ACTIONS(7516),
    [sym_null] = ACTIONS(7516),
    [sym_inf] = ACTIONS(7516),
    [sym_nan] = ACTIONS(7516),
    [anon_sym_NA] = ACTIONS(7516),
    [anon_sym_NA_integer_] = ACTIONS(7516),
    [anon_sym_NA_real_] = ACTIONS(7516),
    [anon_sym_NA_complex_] = ACTIONS(7516),
    [anon_sym_NA_character_] = ACTIONS(7516),
    [sym_dots] = ACTIONS(7516),
    [sym_dot_dot_i] = ACTIONS(7514),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7514),
    [sym__semicolon] = ACTIONS(7514),
    [sym__raw_string_literal] = ACTIONS(7514),
    [sym__external_else] = ACTIONS(7514),
    [sym__external_open_parenthesis] = ACTIONS(7514),
    [sym__external_open_brace] = ACTIONS(7514),
    [sym__external_open_bracket] = ACTIONS(7514),
    [sym__external_open_bracket2] = ACTIONS(7514),
  },
  [2866] = {
    [aux_sym_function_definition_repeat1] = STATE(2866),
    [sym_identifier] = ACTIONS(7419),
    [anon_sym_BSLASH] = ACTIONS(7417),
    [anon_sym_function] = ACTIONS(7419),
    [anon_sym_EQ] = ACTIONS(7419),
    [anon_sym_if] = ACTIONS(7419),
    [anon_sym_for] = ACTIONS(7419),
    [anon_sym_while] = ACTIONS(7419),
    [anon_sym_repeat] = ACTIONS(7419),
    [anon_sym_QMARK] = ACTIONS(7417),
    [anon_sym_TILDE] = ACTIONS(7417),
    [anon_sym_BANG] = ACTIONS(7419),
    [anon_sym_PLUS] = ACTIONS(7417),
    [anon_sym_DASH] = ACTIONS(7419),
    [anon_sym_LT_DASH] = ACTIONS(7417),
    [anon_sym_LT_LT_DASH] = ACTIONS(7417),
    [anon_sym_COLON_EQ] = ACTIONS(7417),
    [anon_sym_DASH_GT] = ACTIONS(7419),
    [anon_sym_DASH_GT_GT] = ACTIONS(7417),
    [anon_sym_PIPE] = ACTIONS(7419),
    [anon_sym_AMP] = ACTIONS(7419),
    [anon_sym_PIPE_PIPE] = ACTIONS(7417),
    [anon_sym_AMP_AMP] = ACTIONS(7417),
    [anon_sym_LT] = ACTIONS(7419),
    [anon_sym_LT_EQ] = ACTIONS(7417),
    [anon_sym_GT] = ACTIONS(7419),
    [anon_sym_GT_EQ] = ACTIONS(7417),
    [anon_sym_EQ_EQ] = ACTIONS(7417),
    [anon_sym_BANG_EQ] = ACTIONS(7417),
    [anon_sym_STAR] = ACTIONS(7419),
    [anon_sym_SLASH] = ACTIONS(7417),
    [anon_sym_STAR_STAR] = ACTIONS(7417),
    [anon_sym_CARET] = ACTIONS(7417),
    [aux_sym_binary_operator_token1] = ACTIONS(7417),
    [anon_sym_PIPE_GT] = ACTIONS(7417),
    [anon_sym_COLON] = ACTIONS(7419),
    [anon_sym_DOLLAR] = ACTIONS(7417),
    [anon_sym_AT] = ACTIONS(7417),
    [aux_sym__hex_literal_token1] = ACTIONS(7417),
    [sym__number_literal] = ACTIONS(7419),
    [anon_sym_SQUOTE] = ACTIONS(7417),
    [anon_sym_DQUOTE] = ACTIONS(7417),
    [sym_return] = ACTIONS(7419),
    [sym_next] = ACTIONS(7419),
    [sym_break] = ACTIONS(7419),
    [sym_true] = ACTIONS(7419),
    [sym_false] = ACTIONS(7419),
    [sym_null] = ACTIONS(7419),
    [sym_inf] = ACTIONS(7419),
    [sym_nan] = ACTIONS(7419),
    [anon_sym_NA] = ACTIONS(7419),
    [anon_sym_NA_integer_] = ACTIONS(7419),
    [anon_sym_NA_real_] = ACTIONS(7419),
    [anon_sym_NA_complex_] = ACTIONS(7419),
    [anon_sym_NA_character_] = ACTIONS(7419),
    [sym_dots] = ACTIONS(7419),
    [sym_dot_dot_i] = ACTIONS(7417),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7417),
    [sym__newline] = ACTIONS(7704),
    [sym__raw_string_literal] = ACTIONS(7417),
    [sym__external_open_parenthesis] = ACTIONS(7417),
    [sym__external_close_parenthesis] = ACTIONS(7417),
    [sym__external_open_brace] = ACTIONS(7417),
    [sym__external_open_bracket] = ACTIONS(7417),
    [sym__external_open_bracket2] = ACTIONS(7417),
  },
  [2867] = {
    [sym_identifier] = ACTIONS(7524),
    [anon_sym_BSLASH] = ACTIONS(7522),
    [anon_sym_function] = ACTIONS(7524),
    [anon_sym_EQ] = ACTIONS(7524),
    [anon_sym_if] = ACTIONS(7524),
    [anon_sym_for] = ACTIONS(7524),
    [anon_sym_while] = ACTIONS(7524),
    [anon_sym_repeat] = ACTIONS(7524),
    [anon_sym_QMARK] = ACTIONS(7522),
    [anon_sym_TILDE] = ACTIONS(7522),
    [anon_sym_BANG] = ACTIONS(7524),
    [anon_sym_PLUS] = ACTIONS(7522),
    [anon_sym_DASH] = ACTIONS(7524),
    [anon_sym_LT_DASH] = ACTIONS(7522),
    [anon_sym_LT_LT_DASH] = ACTIONS(7522),
    [anon_sym_COLON_EQ] = ACTIONS(7522),
    [anon_sym_DASH_GT] = ACTIONS(7524),
    [anon_sym_DASH_GT_GT] = ACTIONS(7522),
    [anon_sym_PIPE] = ACTIONS(7524),
    [anon_sym_AMP] = ACTIONS(7524),
    [anon_sym_PIPE_PIPE] = ACTIONS(7522),
    [anon_sym_AMP_AMP] = ACTIONS(7522),
    [anon_sym_LT] = ACTIONS(7524),
    [anon_sym_LT_EQ] = ACTIONS(7522),
    [anon_sym_GT] = ACTIONS(7524),
    [anon_sym_GT_EQ] = ACTIONS(7522),
    [anon_sym_EQ_EQ] = ACTIONS(7522),
    [anon_sym_BANG_EQ] = ACTIONS(7522),
    [anon_sym_STAR] = ACTIONS(7524),
    [anon_sym_SLASH] = ACTIONS(7522),
    [anon_sym_STAR_STAR] = ACTIONS(7522),
    [anon_sym_CARET] = ACTIONS(7522),
    [aux_sym_binary_operator_token1] = ACTIONS(7522),
    [anon_sym_PIPE_GT] = ACTIONS(7522),
    [anon_sym_COLON] = ACTIONS(7524),
    [anon_sym_DOLLAR] = ACTIONS(7522),
    [anon_sym_AT] = ACTIONS(7522),
    [aux_sym__hex_literal_token1] = ACTIONS(7522),
    [sym__number_literal] = ACTIONS(7524),
    [anon_sym_SQUOTE] = ACTIONS(7522),
    [anon_sym_DQUOTE] = ACTIONS(7522),
    [sym_return] = ACTIONS(7524),
    [sym_next] = ACTIONS(7524),
    [sym_break] = ACTIONS(7524),
    [sym_true] = ACTIONS(7524),
    [sym_false] = ACTIONS(7524),
    [sym_null] = ACTIONS(7524),
    [sym_inf] = ACTIONS(7524),
    [sym_nan] = ACTIONS(7524),
    [anon_sym_NA] = ACTIONS(7524),
    [anon_sym_NA_integer_] = ACTIONS(7524),
    [anon_sym_NA_real_] = ACTIONS(7524),
    [anon_sym_NA_complex_] = ACTIONS(7524),
    [anon_sym_NA_character_] = ACTIONS(7524),
    [sym_dots] = ACTIONS(7524),
    [sym_dot_dot_i] = ACTIONS(7522),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7522),
    [sym__newline] = ACTIONS(7522),
    [sym__raw_string_literal] = ACTIONS(7522),
    [sym__external_else] = ACTIONS(7522),
    [sym__external_open_parenthesis] = ACTIONS(7522),
    [sym__external_open_brace] = ACTIONS(7522),
    [sym__external_open_bracket] = ACTIONS(7522),
    [sym__external_open_bracket2] = ACTIONS(7522),
    [sym__external_close_bracket2] = ACTIONS(7522),
  },
  [2868] = {
    [sym_identifier] = ACTIONS(7563),
    [anon_sym_BSLASH] = ACTIONS(7561),
    [anon_sym_function] = ACTIONS(7563),
    [anon_sym_EQ] = ACTIONS(7563),
    [anon_sym_if] = ACTIONS(7563),
    [anon_sym_for] = ACTIONS(7563),
    [anon_sym_while] = ACTIONS(7563),
    [anon_sym_repeat] = ACTIONS(7563),
    [anon_sym_QMARK] = ACTIONS(7561),
    [anon_sym_TILDE] = ACTIONS(7561),
    [anon_sym_BANG] = ACTIONS(7563),
    [anon_sym_PLUS] = ACTIONS(7561),
    [anon_sym_DASH] = ACTIONS(7563),
    [anon_sym_LT_DASH] = ACTIONS(7561),
    [anon_sym_LT_LT_DASH] = ACTIONS(7561),
    [anon_sym_COLON_EQ] = ACTIONS(7561),
    [anon_sym_DASH_GT] = ACTIONS(7563),
    [anon_sym_DASH_GT_GT] = ACTIONS(7561),
    [anon_sym_PIPE] = ACTIONS(7563),
    [anon_sym_AMP] = ACTIONS(7563),
    [anon_sym_PIPE_PIPE] = ACTIONS(7561),
    [anon_sym_AMP_AMP] = ACTIONS(7561),
    [anon_sym_LT] = ACTIONS(7563),
    [anon_sym_LT_EQ] = ACTIONS(7561),
    [anon_sym_GT] = ACTIONS(7563),
    [anon_sym_GT_EQ] = ACTIONS(7561),
    [anon_sym_EQ_EQ] = ACTIONS(7561),
    [anon_sym_BANG_EQ] = ACTIONS(7561),
    [anon_sym_STAR] = ACTIONS(7563),
    [anon_sym_SLASH] = ACTIONS(7561),
    [anon_sym_STAR_STAR] = ACTIONS(7561),
    [anon_sym_CARET] = ACTIONS(7561),
    [aux_sym_binary_operator_token1] = ACTIONS(7561),
    [anon_sym_PIPE_GT] = ACTIONS(7561),
    [anon_sym_COLON] = ACTIONS(7563),
    [anon_sym_DOLLAR] = ACTIONS(7561),
    [anon_sym_AT] = ACTIONS(7561),
    [aux_sym__hex_literal_token1] = ACTIONS(7561),
    [sym__number_literal] = ACTIONS(7563),
    [anon_sym_SQUOTE] = ACTIONS(7561),
    [anon_sym_DQUOTE] = ACTIONS(7561),
    [sym_return] = ACTIONS(7563),
    [sym_next] = ACTIONS(7563),
    [sym_break] = ACTIONS(7563),
    [sym_true] = ACTIONS(7563),
    [sym_false] = ACTIONS(7563),
    [sym_null] = ACTIONS(7563),
    [sym_inf] = ACTIONS(7563),
    [sym_nan] = ACTIONS(7563),
    [anon_sym_NA] = ACTIONS(7563),
    [anon_sym_NA_integer_] = ACTIONS(7563),
    [anon_sym_NA_real_] = ACTIONS(7563),
    [anon_sym_NA_complex_] = ACTIONS(7563),
    [anon_sym_NA_character_] = ACTIONS(7563),
    [sym_dots] = ACTIONS(7563),
    [sym_dot_dot_i] = ACTIONS(7561),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7561),
    [sym__newline] = ACTIONS(7561),
    [sym__raw_string_literal] = ACTIONS(7561),
    [sym__external_else] = ACTIONS(7561),
    [sym__external_open_parenthesis] = ACTIONS(7561),
    [sym__external_open_brace] = ACTIONS(7561),
    [sym__external_open_bracket] = ACTIONS(7561),
    [sym__external_close_bracket] = ACTIONS(7561),
    [sym__external_open_bracket2] = ACTIONS(7561),
  },
  [2869] = {
    [sym_identifier] = ACTIONS(7528),
    [anon_sym_BSLASH] = ACTIONS(7526),
    [anon_sym_function] = ACTIONS(7528),
    [anon_sym_EQ] = ACTIONS(7528),
    [anon_sym_if] = ACTIONS(7528),
    [anon_sym_for] = ACTIONS(7528),
    [anon_sym_while] = ACTIONS(7528),
    [anon_sym_repeat] = ACTIONS(7528),
    [anon_sym_QMARK] = ACTIONS(7526),
    [anon_sym_TILDE] = ACTIONS(7526),
    [anon_sym_BANG] = ACTIONS(7528),
    [anon_sym_PLUS] = ACTIONS(7526),
    [anon_sym_DASH] = ACTIONS(7528),
    [anon_sym_LT_DASH] = ACTIONS(7526),
    [anon_sym_LT_LT_DASH] = ACTIONS(7526),
    [anon_sym_COLON_EQ] = ACTIONS(7526),
    [anon_sym_DASH_GT] = ACTIONS(7528),
    [anon_sym_DASH_GT_GT] = ACTIONS(7526),
    [anon_sym_PIPE] = ACTIONS(7528),
    [anon_sym_AMP] = ACTIONS(7528),
    [anon_sym_PIPE_PIPE] = ACTIONS(7526),
    [anon_sym_AMP_AMP] = ACTIONS(7526),
    [anon_sym_LT] = ACTIONS(7528),
    [anon_sym_LT_EQ] = ACTIONS(7526),
    [anon_sym_GT] = ACTIONS(7528),
    [anon_sym_GT_EQ] = ACTIONS(7526),
    [anon_sym_EQ_EQ] = ACTIONS(7526),
    [anon_sym_BANG_EQ] = ACTIONS(7526),
    [anon_sym_STAR] = ACTIONS(7528),
    [anon_sym_SLASH] = ACTIONS(7526),
    [anon_sym_STAR_STAR] = ACTIONS(7526),
    [anon_sym_CARET] = ACTIONS(7526),
    [aux_sym_binary_operator_token1] = ACTIONS(7526),
    [anon_sym_PIPE_GT] = ACTIONS(7526),
    [anon_sym_COLON] = ACTIONS(7528),
    [anon_sym_DOLLAR] = ACTIONS(7526),
    [anon_sym_AT] = ACTIONS(7526),
    [aux_sym__hex_literal_token1] = ACTIONS(7526),
    [sym__number_literal] = ACTIONS(7528),
    [anon_sym_SQUOTE] = ACTIONS(7526),
    [anon_sym_DQUOTE] = ACTIONS(7526),
    [sym_return] = ACTIONS(7528),
    [sym_next] = ACTIONS(7528),
    [sym_break] = ACTIONS(7528),
    [sym_true] = ACTIONS(7528),
    [sym_false] = ACTIONS(7528),
    [sym_null] = ACTIONS(7528),
    [sym_inf] = ACTIONS(7528),
    [sym_nan] = ACTIONS(7528),
    [anon_sym_NA] = ACTIONS(7528),
    [anon_sym_NA_integer_] = ACTIONS(7528),
    [anon_sym_NA_real_] = ACTIONS(7528),
    [anon_sym_NA_complex_] = ACTIONS(7528),
    [anon_sym_NA_character_] = ACTIONS(7528),
    [sym_dots] = ACTIONS(7528),
    [sym_dot_dot_i] = ACTIONS(7526),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7526),
    [sym__newline] = ACTIONS(7526),
    [sym__raw_string_literal] = ACTIONS(7526),
    [sym__external_else] = ACTIONS(7526),
    [sym__external_open_parenthesis] = ACTIONS(7526),
    [sym__external_open_brace] = ACTIONS(7526),
    [sym__external_open_bracket] = ACTIONS(7526),
    [sym__external_open_bracket2] = ACTIONS(7526),
    [sym__external_close_bracket2] = ACTIONS(7526),
  },
  [2870] = {
    [sym_identifier] = ACTIONS(7532),
    [anon_sym_BSLASH] = ACTIONS(7530),
    [anon_sym_function] = ACTIONS(7532),
    [anon_sym_EQ] = ACTIONS(7532),
    [anon_sym_if] = ACTIONS(7532),
    [anon_sym_for] = ACTIONS(7532),
    [anon_sym_while] = ACTIONS(7532),
    [anon_sym_repeat] = ACTIONS(7532),
    [anon_sym_QMARK] = ACTIONS(7530),
    [anon_sym_TILDE] = ACTIONS(7530),
    [anon_sym_BANG] = ACTIONS(7532),
    [anon_sym_PLUS] = ACTIONS(7530),
    [anon_sym_DASH] = ACTIONS(7532),
    [anon_sym_LT_DASH] = ACTIONS(7530),
    [anon_sym_LT_LT_DASH] = ACTIONS(7530),
    [anon_sym_COLON_EQ] = ACTIONS(7530),
    [anon_sym_DASH_GT] = ACTIONS(7532),
    [anon_sym_DASH_GT_GT] = ACTIONS(7530),
    [anon_sym_PIPE] = ACTIONS(7532),
    [anon_sym_AMP] = ACTIONS(7532),
    [anon_sym_PIPE_PIPE] = ACTIONS(7530),
    [anon_sym_AMP_AMP] = ACTIONS(7530),
    [anon_sym_LT] = ACTIONS(7532),
    [anon_sym_LT_EQ] = ACTIONS(7530),
    [anon_sym_GT] = ACTIONS(7532),
    [anon_sym_GT_EQ] = ACTIONS(7530),
    [anon_sym_EQ_EQ] = ACTIONS(7530),
    [anon_sym_BANG_EQ] = ACTIONS(7530),
    [anon_sym_STAR] = ACTIONS(7532),
    [anon_sym_SLASH] = ACTIONS(7530),
    [anon_sym_STAR_STAR] = ACTIONS(7530),
    [anon_sym_CARET] = ACTIONS(7530),
    [aux_sym_binary_operator_token1] = ACTIONS(7530),
    [anon_sym_PIPE_GT] = ACTIONS(7530),
    [anon_sym_COLON] = ACTIONS(7532),
    [anon_sym_DOLLAR] = ACTIONS(7530),
    [anon_sym_AT] = ACTIONS(7530),
    [aux_sym__hex_literal_token1] = ACTIONS(7530),
    [sym__number_literal] = ACTIONS(7532),
    [anon_sym_SQUOTE] = ACTIONS(7530),
    [anon_sym_DQUOTE] = ACTIONS(7530),
    [sym_return] = ACTIONS(7532),
    [sym_next] = ACTIONS(7532),
    [sym_break] = ACTIONS(7532),
    [sym_true] = ACTIONS(7532),
    [sym_false] = ACTIONS(7532),
    [sym_null] = ACTIONS(7532),
    [sym_inf] = ACTIONS(7532),
    [sym_nan] = ACTIONS(7532),
    [anon_sym_NA] = ACTIONS(7532),
    [anon_sym_NA_integer_] = ACTIONS(7532),
    [anon_sym_NA_real_] = ACTIONS(7532),
    [anon_sym_NA_complex_] = ACTIONS(7532),
    [anon_sym_NA_character_] = ACTIONS(7532),
    [sym_dots] = ACTIONS(7532),
    [sym_dot_dot_i] = ACTIONS(7530),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7530),
    [sym__newline] = ACTIONS(7530),
    [sym__raw_string_literal] = ACTIONS(7530),
    [sym__external_else] = ACTIONS(7530),
    [sym__external_open_parenthesis] = ACTIONS(7530),
    [sym__external_open_brace] = ACTIONS(7530),
    [sym__external_open_bracket] = ACTIONS(7530),
    [sym__external_open_bracket2] = ACTIONS(7530),
    [sym__external_close_bracket2] = ACTIONS(7530),
  },
  [2871] = {
    [sym_identifier] = ACTIONS(7482),
    [anon_sym_BSLASH] = ACTIONS(7480),
    [anon_sym_function] = ACTIONS(7482),
    [anon_sym_EQ] = ACTIONS(7482),
    [anon_sym_if] = ACTIONS(7482),
    [anon_sym_for] = ACTIONS(7482),
    [anon_sym_while] = ACTIONS(7482),
    [anon_sym_repeat] = ACTIONS(7482),
    [anon_sym_QMARK] = ACTIONS(7480),
    [anon_sym_TILDE] = ACTIONS(7480),
    [anon_sym_BANG] = ACTIONS(7482),
    [anon_sym_PLUS] = ACTIONS(7480),
    [anon_sym_DASH] = ACTIONS(7482),
    [anon_sym_LT_DASH] = ACTIONS(7480),
    [anon_sym_LT_LT_DASH] = ACTIONS(7480),
    [anon_sym_COLON_EQ] = ACTIONS(7480),
    [anon_sym_DASH_GT] = ACTIONS(7482),
    [anon_sym_DASH_GT_GT] = ACTIONS(7480),
    [anon_sym_PIPE] = ACTIONS(7482),
    [anon_sym_AMP] = ACTIONS(7482),
    [anon_sym_PIPE_PIPE] = ACTIONS(7480),
    [anon_sym_AMP_AMP] = ACTIONS(7480),
    [anon_sym_LT] = ACTIONS(7482),
    [anon_sym_LT_EQ] = ACTIONS(7480),
    [anon_sym_GT] = ACTIONS(7482),
    [anon_sym_GT_EQ] = ACTIONS(7480),
    [anon_sym_EQ_EQ] = ACTIONS(7480),
    [anon_sym_BANG_EQ] = ACTIONS(7480),
    [anon_sym_STAR] = ACTIONS(7482),
    [anon_sym_SLASH] = ACTIONS(7480),
    [anon_sym_STAR_STAR] = ACTIONS(7480),
    [anon_sym_CARET] = ACTIONS(7480),
    [aux_sym_binary_operator_token1] = ACTIONS(7480),
    [anon_sym_PIPE_GT] = ACTIONS(7480),
    [anon_sym_COLON] = ACTIONS(7482),
    [anon_sym_DOLLAR] = ACTIONS(7480),
    [anon_sym_AT] = ACTIONS(7480),
    [aux_sym__hex_literal_token1] = ACTIONS(7480),
    [sym__number_literal] = ACTIONS(7482),
    [anon_sym_SQUOTE] = ACTIONS(7480),
    [anon_sym_DQUOTE] = ACTIONS(7480),
    [sym_return] = ACTIONS(7482),
    [sym_next] = ACTIONS(7482),
    [sym_break] = ACTIONS(7482),
    [sym_true] = ACTIONS(7482),
    [sym_false] = ACTIONS(7482),
    [sym_null] = ACTIONS(7482),
    [sym_inf] = ACTIONS(7482),
    [sym_nan] = ACTIONS(7482),
    [anon_sym_NA] = ACTIONS(7482),
    [anon_sym_NA_integer_] = ACTIONS(7482),
    [anon_sym_NA_real_] = ACTIONS(7482),
    [anon_sym_NA_complex_] = ACTIONS(7482),
    [anon_sym_NA_character_] = ACTIONS(7482),
    [sym_dots] = ACTIONS(7482),
    [sym_dot_dot_i] = ACTIONS(7480),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7480),
    [sym__newline] = ACTIONS(7480),
    [sym__raw_string_literal] = ACTIONS(7480),
    [sym__external_open_parenthesis] = ACTIONS(7480),
    [sym__external_close_parenthesis] = ACTIONS(7480),
    [sym__external_open_brace] = ACTIONS(7480),
    [sym__external_open_bracket] = ACTIONS(7480),
    [sym__external_close_bracket] = ACTIONS(7480),
    [sym__external_open_bracket2] = ACTIONS(7480),
  },
  [2872] = {
    [sym_identifier] = ACTIONS(7540),
    [anon_sym_BSLASH] = ACTIONS(7538),
    [anon_sym_function] = ACTIONS(7540),
    [anon_sym_EQ] = ACTIONS(7540),
    [anon_sym_if] = ACTIONS(7540),
    [anon_sym_for] = ACTIONS(7540),
    [anon_sym_while] = ACTIONS(7540),
    [anon_sym_repeat] = ACTIONS(7540),
    [anon_sym_QMARK] = ACTIONS(7538),
    [anon_sym_TILDE] = ACTIONS(7538),
    [anon_sym_BANG] = ACTIONS(7540),
    [anon_sym_PLUS] = ACTIONS(7538),
    [anon_sym_DASH] = ACTIONS(7540),
    [anon_sym_LT_DASH] = ACTIONS(7538),
    [anon_sym_LT_LT_DASH] = ACTIONS(7538),
    [anon_sym_COLON_EQ] = ACTIONS(7538),
    [anon_sym_DASH_GT] = ACTIONS(7540),
    [anon_sym_DASH_GT_GT] = ACTIONS(7538),
    [anon_sym_PIPE] = ACTIONS(7540),
    [anon_sym_AMP] = ACTIONS(7540),
    [anon_sym_PIPE_PIPE] = ACTIONS(7538),
    [anon_sym_AMP_AMP] = ACTIONS(7538),
    [anon_sym_LT] = ACTIONS(7540),
    [anon_sym_LT_EQ] = ACTIONS(7538),
    [anon_sym_GT] = ACTIONS(7540),
    [anon_sym_GT_EQ] = ACTIONS(7538),
    [anon_sym_EQ_EQ] = ACTIONS(7538),
    [anon_sym_BANG_EQ] = ACTIONS(7538),
    [anon_sym_STAR] = ACTIONS(7540),
    [anon_sym_SLASH] = ACTIONS(7538),
    [anon_sym_STAR_STAR] = ACTIONS(7538),
    [anon_sym_CARET] = ACTIONS(7538),
    [aux_sym_binary_operator_token1] = ACTIONS(7538),
    [anon_sym_PIPE_GT] = ACTIONS(7538),
    [anon_sym_COLON] = ACTIONS(7540),
    [anon_sym_DOLLAR] = ACTIONS(7538),
    [anon_sym_AT] = ACTIONS(7538),
    [aux_sym__hex_literal_token1] = ACTIONS(7538),
    [sym__number_literal] = ACTIONS(7540),
    [anon_sym_SQUOTE] = ACTIONS(7538),
    [anon_sym_DQUOTE] = ACTIONS(7538),
    [sym_return] = ACTIONS(7540),
    [sym_next] = ACTIONS(7540),
    [sym_break] = ACTIONS(7540),
    [sym_true] = ACTIONS(7540),
    [sym_false] = ACTIONS(7540),
    [sym_null] = ACTIONS(7540),
    [sym_inf] = ACTIONS(7540),
    [sym_nan] = ACTIONS(7540),
    [anon_sym_NA] = ACTIONS(7540),
    [anon_sym_NA_integer_] = ACTIONS(7540),
    [anon_sym_NA_real_] = ACTIONS(7540),
    [anon_sym_NA_complex_] = ACTIONS(7540),
    [anon_sym_NA_character_] = ACTIONS(7540),
    [sym_dots] = ACTIONS(7540),
    [sym_dot_dot_i] = ACTIONS(7538),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7538),
    [sym__newline] = ACTIONS(7538),
    [sym__raw_string_literal] = ACTIONS(7538),
    [sym__external_else] = ACTIONS(7538),
    [sym__external_open_parenthesis] = ACTIONS(7538),
    [sym__external_open_brace] = ACTIONS(7538),
    [sym__external_open_bracket] = ACTIONS(7538),
    [sym__external_open_bracket2] = ACTIONS(7538),
    [sym__external_close_bracket2] = ACTIONS(7538),
  },
  [2873] = {
    [sym_identifier] = ACTIONS(7544),
    [anon_sym_BSLASH] = ACTIONS(7542),
    [anon_sym_function] = ACTIONS(7544),
    [anon_sym_EQ] = ACTIONS(7544),
    [anon_sym_if] = ACTIONS(7544),
    [anon_sym_for] = ACTIONS(7544),
    [anon_sym_while] = ACTIONS(7544),
    [anon_sym_repeat] = ACTIONS(7544),
    [anon_sym_QMARK] = ACTIONS(7542),
    [anon_sym_TILDE] = ACTIONS(7542),
    [anon_sym_BANG] = ACTIONS(7544),
    [anon_sym_PLUS] = ACTIONS(7542),
    [anon_sym_DASH] = ACTIONS(7544),
    [anon_sym_LT_DASH] = ACTIONS(7542),
    [anon_sym_LT_LT_DASH] = ACTIONS(7542),
    [anon_sym_COLON_EQ] = ACTIONS(7542),
    [anon_sym_DASH_GT] = ACTIONS(7544),
    [anon_sym_DASH_GT_GT] = ACTIONS(7542),
    [anon_sym_PIPE] = ACTIONS(7544),
    [anon_sym_AMP] = ACTIONS(7544),
    [anon_sym_PIPE_PIPE] = ACTIONS(7542),
    [anon_sym_AMP_AMP] = ACTIONS(7542),
    [anon_sym_LT] = ACTIONS(7544),
    [anon_sym_LT_EQ] = ACTIONS(7542),
    [anon_sym_GT] = ACTIONS(7544),
    [anon_sym_GT_EQ] = ACTIONS(7542),
    [anon_sym_EQ_EQ] = ACTIONS(7542),
    [anon_sym_BANG_EQ] = ACTIONS(7542),
    [anon_sym_STAR] = ACTIONS(7544),
    [anon_sym_SLASH] = ACTIONS(7542),
    [anon_sym_STAR_STAR] = ACTIONS(7542),
    [anon_sym_CARET] = ACTIONS(7542),
    [aux_sym_binary_operator_token1] = ACTIONS(7542),
    [anon_sym_PIPE_GT] = ACTIONS(7542),
    [anon_sym_COLON] = ACTIONS(7544),
    [anon_sym_DOLLAR] = ACTIONS(7542),
    [anon_sym_AT] = ACTIONS(7542),
    [aux_sym__hex_literal_token1] = ACTIONS(7542),
    [sym__number_literal] = ACTIONS(7544),
    [anon_sym_SQUOTE] = ACTIONS(7542),
    [anon_sym_DQUOTE] = ACTIONS(7542),
    [sym_return] = ACTIONS(7544),
    [sym_next] = ACTIONS(7544),
    [sym_break] = ACTIONS(7544),
    [sym_true] = ACTIONS(7544),
    [sym_false] = ACTIONS(7544),
    [sym_null] = ACTIONS(7544),
    [sym_inf] = ACTIONS(7544),
    [sym_nan] = ACTIONS(7544),
    [anon_sym_NA] = ACTIONS(7544),
    [anon_sym_NA_integer_] = ACTIONS(7544),
    [anon_sym_NA_real_] = ACTIONS(7544),
    [anon_sym_NA_complex_] = ACTIONS(7544),
    [anon_sym_NA_character_] = ACTIONS(7544),
    [sym_dots] = ACTIONS(7544),
    [sym_dot_dot_i] = ACTIONS(7542),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7542),
    [sym__newline] = ACTIONS(7542),
    [sym__raw_string_literal] = ACTIONS(7542),
    [sym__external_else] = ACTIONS(7542),
    [sym__external_open_parenthesis] = ACTIONS(7542),
    [sym__external_open_brace] = ACTIONS(7542),
    [sym__external_open_bracket] = ACTIONS(7542),
    [sym__external_open_bracket2] = ACTIONS(7542),
    [sym__external_close_bracket2] = ACTIONS(7542),
  },
  [2874] = {
    [ts_builtin_sym_end] = ACTIONS(7561),
    [sym_identifier] = ACTIONS(7563),
    [anon_sym_BSLASH] = ACTIONS(7561),
    [anon_sym_function] = ACTIONS(7563),
    [anon_sym_EQ] = ACTIONS(7563),
    [anon_sym_if] = ACTIONS(7563),
    [anon_sym_for] = ACTIONS(7563),
    [anon_sym_while] = ACTIONS(7563),
    [anon_sym_repeat] = ACTIONS(7563),
    [anon_sym_QMARK] = ACTIONS(7561),
    [anon_sym_TILDE] = ACTIONS(7561),
    [anon_sym_BANG] = ACTIONS(7563),
    [anon_sym_PLUS] = ACTIONS(7561),
    [anon_sym_DASH] = ACTIONS(7563),
    [anon_sym_LT_DASH] = ACTIONS(7561),
    [anon_sym_LT_LT_DASH] = ACTIONS(7561),
    [anon_sym_COLON_EQ] = ACTIONS(7561),
    [anon_sym_DASH_GT] = ACTIONS(7563),
    [anon_sym_DASH_GT_GT] = ACTIONS(7561),
    [anon_sym_PIPE] = ACTIONS(7563),
    [anon_sym_AMP] = ACTIONS(7563),
    [anon_sym_PIPE_PIPE] = ACTIONS(7561),
    [anon_sym_AMP_AMP] = ACTIONS(7561),
    [anon_sym_LT] = ACTIONS(7563),
    [anon_sym_LT_EQ] = ACTIONS(7561),
    [anon_sym_GT] = ACTIONS(7563),
    [anon_sym_GT_EQ] = ACTIONS(7561),
    [anon_sym_EQ_EQ] = ACTIONS(7561),
    [anon_sym_BANG_EQ] = ACTIONS(7561),
    [anon_sym_STAR] = ACTIONS(7563),
    [anon_sym_SLASH] = ACTIONS(7561),
    [anon_sym_STAR_STAR] = ACTIONS(7561),
    [anon_sym_CARET] = ACTIONS(7561),
    [aux_sym_binary_operator_token1] = ACTIONS(7561),
    [anon_sym_PIPE_GT] = ACTIONS(7561),
    [anon_sym_COLON] = ACTIONS(7563),
    [anon_sym_DOLLAR] = ACTIONS(7561),
    [anon_sym_AT] = ACTIONS(7561),
    [aux_sym__hex_literal_token1] = ACTIONS(7561),
    [sym__number_literal] = ACTIONS(7563),
    [anon_sym_SQUOTE] = ACTIONS(7561),
    [anon_sym_DQUOTE] = ACTIONS(7561),
    [sym_return] = ACTIONS(7563),
    [sym_next] = ACTIONS(7563),
    [sym_break] = ACTIONS(7563),
    [sym_true] = ACTIONS(7563),
    [sym_false] = ACTIONS(7563),
    [sym_null] = ACTIONS(7563),
    [sym_inf] = ACTIONS(7563),
    [sym_nan] = ACTIONS(7563),
    [anon_sym_NA] = ACTIONS(7563),
    [anon_sym_NA_integer_] = ACTIONS(7563),
    [anon_sym_NA_real_] = ACTIONS(7563),
    [anon_sym_NA_complex_] = ACTIONS(7563),
    [anon_sym_NA_character_] = ACTIONS(7563),
    [sym_dots] = ACTIONS(7563),
    [sym_dot_dot_i] = ACTIONS(7561),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7561),
    [sym__semicolon] = ACTIONS(7561),
    [sym__raw_string_literal] = ACTIONS(7561),
    [sym__external_open_parenthesis] = ACTIONS(7561),
    [sym__external_close_parenthesis] = ACTIONS(7561),
    [sym__external_open_brace] = ACTIONS(7561),
    [sym__external_open_bracket] = ACTIONS(7561),
    [sym__external_open_bracket2] = ACTIONS(7561),
  },
  [2875] = {
    [sym_identifier] = ACTIONS(7474),
    [anon_sym_BSLASH] = ACTIONS(7472),
    [anon_sym_function] = ACTIONS(7474),
    [anon_sym_EQ] = ACTIONS(7474),
    [anon_sym_if] = ACTIONS(7474),
    [anon_sym_for] = ACTIONS(7474),
    [anon_sym_while] = ACTIONS(7474),
    [anon_sym_repeat] = ACTIONS(7474),
    [anon_sym_QMARK] = ACTIONS(7472),
    [anon_sym_TILDE] = ACTIONS(7472),
    [anon_sym_BANG] = ACTIONS(7474),
    [anon_sym_PLUS] = ACTIONS(7472),
    [anon_sym_DASH] = ACTIONS(7474),
    [anon_sym_LT_DASH] = ACTIONS(7472),
    [anon_sym_LT_LT_DASH] = ACTIONS(7472),
    [anon_sym_COLON_EQ] = ACTIONS(7472),
    [anon_sym_DASH_GT] = ACTIONS(7474),
    [anon_sym_DASH_GT_GT] = ACTIONS(7472),
    [anon_sym_PIPE] = ACTIONS(7474),
    [anon_sym_AMP] = ACTIONS(7474),
    [anon_sym_PIPE_PIPE] = ACTIONS(7472),
    [anon_sym_AMP_AMP] = ACTIONS(7472),
    [anon_sym_LT] = ACTIONS(7474),
    [anon_sym_LT_EQ] = ACTIONS(7472),
    [anon_sym_GT] = ACTIONS(7474),
    [anon_sym_GT_EQ] = ACTIONS(7472),
    [anon_sym_EQ_EQ] = ACTIONS(7472),
    [anon_sym_BANG_EQ] = ACTIONS(7472),
    [anon_sym_STAR] = ACTIONS(7474),
    [anon_sym_SLASH] = ACTIONS(7472),
    [anon_sym_STAR_STAR] = ACTIONS(7472),
    [anon_sym_CARET] = ACTIONS(7472),
    [aux_sym_binary_operator_token1] = ACTIONS(7472),
    [anon_sym_PIPE_GT] = ACTIONS(7472),
    [anon_sym_COLON] = ACTIONS(7474),
    [anon_sym_DOLLAR] = ACTIONS(7472),
    [anon_sym_AT] = ACTIONS(7472),
    [aux_sym__hex_literal_token1] = ACTIONS(7472),
    [sym__number_literal] = ACTIONS(7474),
    [anon_sym_SQUOTE] = ACTIONS(7472),
    [anon_sym_DQUOTE] = ACTIONS(7472),
    [sym_return] = ACTIONS(7474),
    [sym_next] = ACTIONS(7474),
    [sym_break] = ACTIONS(7474),
    [sym_true] = ACTIONS(7474),
    [sym_false] = ACTIONS(7474),
    [sym_null] = ACTIONS(7474),
    [sym_inf] = ACTIONS(7474),
    [sym_nan] = ACTIONS(7474),
    [anon_sym_NA] = ACTIONS(7474),
    [anon_sym_NA_integer_] = ACTIONS(7474),
    [anon_sym_NA_real_] = ACTIONS(7474),
    [anon_sym_NA_complex_] = ACTIONS(7474),
    [anon_sym_NA_character_] = ACTIONS(7474),
    [sym_dots] = ACTIONS(7474),
    [sym_dot_dot_i] = ACTIONS(7472),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7472),
    [sym__newline] = ACTIONS(7472),
    [sym__raw_string_literal] = ACTIONS(7472),
    [sym__external_else] = ACTIONS(7472),
    [sym__external_open_parenthesis] = ACTIONS(7472),
    [sym__external_close_parenthesis] = ACTIONS(7472),
    [sym__external_open_brace] = ACTIONS(7472),
    [sym__external_open_bracket] = ACTIONS(7472),
    [sym__external_open_bracket2] = ACTIONS(7472),
  },
  [2876] = {
    [ts_builtin_sym_end] = ACTIONS(7484),
    [sym_identifier] = ACTIONS(7486),
    [anon_sym_BSLASH] = ACTIONS(7484),
    [anon_sym_function] = ACTIONS(7486),
    [anon_sym_EQ] = ACTIONS(7486),
    [anon_sym_if] = ACTIONS(7486),
    [anon_sym_for] = ACTIONS(7486),
    [anon_sym_while] = ACTIONS(7486),
    [anon_sym_repeat] = ACTIONS(7486),
    [anon_sym_QMARK] = ACTIONS(7484),
    [anon_sym_TILDE] = ACTIONS(7484),
    [anon_sym_BANG] = ACTIONS(7486),
    [anon_sym_PLUS] = ACTIONS(7484),
    [anon_sym_DASH] = ACTIONS(7486),
    [anon_sym_LT_DASH] = ACTIONS(7484),
    [anon_sym_LT_LT_DASH] = ACTIONS(7484),
    [anon_sym_COLON_EQ] = ACTIONS(7484),
    [anon_sym_DASH_GT] = ACTIONS(7486),
    [anon_sym_DASH_GT_GT] = ACTIONS(7484),
    [anon_sym_PIPE] = ACTIONS(7486),
    [anon_sym_AMP] = ACTIONS(7486),
    [anon_sym_PIPE_PIPE] = ACTIONS(7484),
    [anon_sym_AMP_AMP] = ACTIONS(7484),
    [anon_sym_LT] = ACTIONS(7486),
    [anon_sym_LT_EQ] = ACTIONS(7484),
    [anon_sym_GT] = ACTIONS(7486),
    [anon_sym_GT_EQ] = ACTIONS(7484),
    [anon_sym_EQ_EQ] = ACTIONS(7484),
    [anon_sym_BANG_EQ] = ACTIONS(7484),
    [anon_sym_STAR] = ACTIONS(7486),
    [anon_sym_SLASH] = ACTIONS(7484),
    [anon_sym_STAR_STAR] = ACTIONS(7484),
    [anon_sym_CARET] = ACTIONS(7484),
    [aux_sym_binary_operator_token1] = ACTIONS(7484),
    [anon_sym_PIPE_GT] = ACTIONS(7484),
    [anon_sym_COLON] = ACTIONS(7486),
    [anon_sym_DOLLAR] = ACTIONS(7484),
    [anon_sym_AT] = ACTIONS(7484),
    [aux_sym__hex_literal_token1] = ACTIONS(7484),
    [sym__number_literal] = ACTIONS(7486),
    [anon_sym_SQUOTE] = ACTIONS(7484),
    [anon_sym_DQUOTE] = ACTIONS(7484),
    [sym_return] = ACTIONS(7486),
    [sym_next] = ACTIONS(7486),
    [sym_break] = ACTIONS(7486),
    [sym_true] = ACTIONS(7486),
    [sym_false] = ACTIONS(7486),
    [sym_null] = ACTIONS(7486),
    [sym_inf] = ACTIONS(7486),
    [sym_nan] = ACTIONS(7486),
    [anon_sym_NA] = ACTIONS(7486),
    [anon_sym_NA_integer_] = ACTIONS(7486),
    [anon_sym_NA_real_] = ACTIONS(7486),
    [anon_sym_NA_complex_] = ACTIONS(7486),
    [anon_sym_NA_character_] = ACTIONS(7486),
    [sym_dots] = ACTIONS(7486),
    [sym_dot_dot_i] = ACTIONS(7484),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7484),
    [sym__semicolon] = ACTIONS(7484),
    [sym__raw_string_literal] = ACTIONS(7484),
    [sym__external_open_parenthesis] = ACTIONS(7484),
    [sym__external_close_parenthesis] = ACTIONS(7484),
    [sym__external_open_brace] = ACTIONS(7484),
    [sym__external_open_bracket] = ACTIONS(7484),
    [sym__external_open_bracket2] = ACTIONS(7484),
  },
  [2877] = {
    [ts_builtin_sym_end] = ACTIONS(7488),
    [sym_identifier] = ACTIONS(7490),
    [anon_sym_BSLASH] = ACTIONS(7488),
    [anon_sym_function] = ACTIONS(7490),
    [anon_sym_EQ] = ACTIONS(7490),
    [anon_sym_if] = ACTIONS(7490),
    [anon_sym_for] = ACTIONS(7490),
    [anon_sym_while] = ACTIONS(7490),
    [anon_sym_repeat] = ACTIONS(7490),
    [anon_sym_QMARK] = ACTIONS(7488),
    [anon_sym_TILDE] = ACTIONS(7488),
    [anon_sym_BANG] = ACTIONS(7490),
    [anon_sym_PLUS] = ACTIONS(7488),
    [anon_sym_DASH] = ACTIONS(7490),
    [anon_sym_LT_DASH] = ACTIONS(7488),
    [anon_sym_LT_LT_DASH] = ACTIONS(7488),
    [anon_sym_COLON_EQ] = ACTIONS(7488),
    [anon_sym_DASH_GT] = ACTIONS(7490),
    [anon_sym_DASH_GT_GT] = ACTIONS(7488),
    [anon_sym_PIPE] = ACTIONS(7490),
    [anon_sym_AMP] = ACTIONS(7490),
    [anon_sym_PIPE_PIPE] = ACTIONS(7488),
    [anon_sym_AMP_AMP] = ACTIONS(7488),
    [anon_sym_LT] = ACTIONS(7490),
    [anon_sym_LT_EQ] = ACTIONS(7488),
    [anon_sym_GT] = ACTIONS(7490),
    [anon_sym_GT_EQ] = ACTIONS(7488),
    [anon_sym_EQ_EQ] = ACTIONS(7488),
    [anon_sym_BANG_EQ] = ACTIONS(7488),
    [anon_sym_STAR] = ACTIONS(7490),
    [anon_sym_SLASH] = ACTIONS(7488),
    [anon_sym_STAR_STAR] = ACTIONS(7488),
    [anon_sym_CARET] = ACTIONS(7488),
    [aux_sym_binary_operator_token1] = ACTIONS(7488),
    [anon_sym_PIPE_GT] = ACTIONS(7488),
    [anon_sym_COLON] = ACTIONS(7490),
    [anon_sym_DOLLAR] = ACTIONS(7488),
    [anon_sym_AT] = ACTIONS(7488),
    [aux_sym__hex_literal_token1] = ACTIONS(7488),
    [sym__number_literal] = ACTIONS(7490),
    [anon_sym_SQUOTE] = ACTIONS(7488),
    [anon_sym_DQUOTE] = ACTIONS(7488),
    [sym_return] = ACTIONS(7490),
    [sym_next] = ACTIONS(7490),
    [sym_break] = ACTIONS(7490),
    [sym_true] = ACTIONS(7490),
    [sym_false] = ACTIONS(7490),
    [sym_null] = ACTIONS(7490),
    [sym_inf] = ACTIONS(7490),
    [sym_nan] = ACTIONS(7490),
    [anon_sym_NA] = ACTIONS(7490),
    [anon_sym_NA_integer_] = ACTIONS(7490),
    [anon_sym_NA_real_] = ACTIONS(7490),
    [anon_sym_NA_complex_] = ACTIONS(7490),
    [anon_sym_NA_character_] = ACTIONS(7490),
    [sym_dots] = ACTIONS(7490),
    [sym_dot_dot_i] = ACTIONS(7488),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7488),
    [sym__semicolon] = ACTIONS(7488),
    [sym__raw_string_literal] = ACTIONS(7488),
    [sym__external_open_parenthesis] = ACTIONS(7488),
    [sym__external_close_parenthesis] = ACTIONS(7488),
    [sym__external_open_brace] = ACTIONS(7488),
    [sym__external_open_bracket] = ACTIONS(7488),
    [sym__external_open_bracket2] = ACTIONS(7488),
  },
  [2878] = {
    [ts_builtin_sym_end] = ACTIONS(7492),
    [sym_identifier] = ACTIONS(7494),
    [anon_sym_BSLASH] = ACTIONS(7492),
    [anon_sym_function] = ACTIONS(7494),
    [anon_sym_EQ] = ACTIONS(7494),
    [anon_sym_if] = ACTIONS(7494),
    [anon_sym_for] = ACTIONS(7494),
    [anon_sym_while] = ACTIONS(7494),
    [anon_sym_repeat] = ACTIONS(7494),
    [anon_sym_QMARK] = ACTIONS(7492),
    [anon_sym_TILDE] = ACTIONS(7492),
    [anon_sym_BANG] = ACTIONS(7494),
    [anon_sym_PLUS] = ACTIONS(7492),
    [anon_sym_DASH] = ACTIONS(7494),
    [anon_sym_LT_DASH] = ACTIONS(7492),
    [anon_sym_LT_LT_DASH] = ACTIONS(7492),
    [anon_sym_COLON_EQ] = ACTIONS(7492),
    [anon_sym_DASH_GT] = ACTIONS(7494),
    [anon_sym_DASH_GT_GT] = ACTIONS(7492),
    [anon_sym_PIPE] = ACTIONS(7494),
    [anon_sym_AMP] = ACTIONS(7494),
    [anon_sym_PIPE_PIPE] = ACTIONS(7492),
    [anon_sym_AMP_AMP] = ACTIONS(7492),
    [anon_sym_LT] = ACTIONS(7494),
    [anon_sym_LT_EQ] = ACTIONS(7492),
    [anon_sym_GT] = ACTIONS(7494),
    [anon_sym_GT_EQ] = ACTIONS(7492),
    [anon_sym_EQ_EQ] = ACTIONS(7492),
    [anon_sym_BANG_EQ] = ACTIONS(7492),
    [anon_sym_STAR] = ACTIONS(7494),
    [anon_sym_SLASH] = ACTIONS(7492),
    [anon_sym_STAR_STAR] = ACTIONS(7492),
    [anon_sym_CARET] = ACTIONS(7492),
    [aux_sym_binary_operator_token1] = ACTIONS(7492),
    [anon_sym_PIPE_GT] = ACTIONS(7492),
    [anon_sym_COLON] = ACTIONS(7494),
    [anon_sym_DOLLAR] = ACTIONS(7492),
    [anon_sym_AT] = ACTIONS(7492),
    [aux_sym__hex_literal_token1] = ACTIONS(7492),
    [sym__number_literal] = ACTIONS(7494),
    [anon_sym_SQUOTE] = ACTIONS(7492),
    [anon_sym_DQUOTE] = ACTIONS(7492),
    [sym_return] = ACTIONS(7494),
    [sym_next] = ACTIONS(7494),
    [sym_break] = ACTIONS(7494),
    [sym_true] = ACTIONS(7494),
    [sym_false] = ACTIONS(7494),
    [sym_null] = ACTIONS(7494),
    [sym_inf] = ACTIONS(7494),
    [sym_nan] = ACTIONS(7494),
    [anon_sym_NA] = ACTIONS(7494),
    [anon_sym_NA_integer_] = ACTIONS(7494),
    [anon_sym_NA_real_] = ACTIONS(7494),
    [anon_sym_NA_complex_] = ACTIONS(7494),
    [anon_sym_NA_character_] = ACTIONS(7494),
    [sym_dots] = ACTIONS(7494),
    [sym_dot_dot_i] = ACTIONS(7492),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7492),
    [sym__semicolon] = ACTIONS(7492),
    [sym__raw_string_literal] = ACTIONS(7492),
    [sym__external_open_parenthesis] = ACTIONS(7492),
    [sym__external_close_parenthesis] = ACTIONS(7492),
    [sym__external_open_brace] = ACTIONS(7492),
    [sym__external_open_bracket] = ACTIONS(7492),
    [sym__external_open_bracket2] = ACTIONS(7492),
  },
  [2879] = {
    [sym_identifier] = ACTIONS(7556),
    [anon_sym_BSLASH] = ACTIONS(7554),
    [anon_sym_function] = ACTIONS(7556),
    [anon_sym_EQ] = ACTIONS(7556),
    [anon_sym_if] = ACTIONS(7556),
    [anon_sym_for] = ACTIONS(7556),
    [anon_sym_while] = ACTIONS(7556),
    [anon_sym_repeat] = ACTIONS(7556),
    [anon_sym_QMARK] = ACTIONS(7554),
    [anon_sym_TILDE] = ACTIONS(7554),
    [anon_sym_BANG] = ACTIONS(7556),
    [anon_sym_PLUS] = ACTIONS(7554),
    [anon_sym_DASH] = ACTIONS(7556),
    [anon_sym_LT_DASH] = ACTIONS(7554),
    [anon_sym_LT_LT_DASH] = ACTIONS(7554),
    [anon_sym_COLON_EQ] = ACTIONS(7554),
    [anon_sym_DASH_GT] = ACTIONS(7556),
    [anon_sym_DASH_GT_GT] = ACTIONS(7554),
    [anon_sym_PIPE] = ACTIONS(7556),
    [anon_sym_AMP] = ACTIONS(7556),
    [anon_sym_PIPE_PIPE] = ACTIONS(7554),
    [anon_sym_AMP_AMP] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(7556),
    [anon_sym_LT_EQ] = ACTIONS(7554),
    [anon_sym_GT] = ACTIONS(7556),
    [anon_sym_GT_EQ] = ACTIONS(7554),
    [anon_sym_EQ_EQ] = ACTIONS(7554),
    [anon_sym_BANG_EQ] = ACTIONS(7554),
    [anon_sym_STAR] = ACTIONS(7556),
    [anon_sym_SLASH] = ACTIONS(7554),
    [anon_sym_STAR_STAR] = ACTIONS(7554),
    [anon_sym_CARET] = ACTIONS(7554),
    [aux_sym_binary_operator_token1] = ACTIONS(7554),
    [anon_sym_PIPE_GT] = ACTIONS(7554),
    [anon_sym_COLON] = ACTIONS(7556),
    [anon_sym_DOLLAR] = ACTIONS(7554),
    [anon_sym_AT] = ACTIONS(7554),
    [aux_sym__hex_literal_token1] = ACTIONS(7554),
    [sym__number_literal] = ACTIONS(7556),
    [anon_sym_SQUOTE] = ACTIONS(7554),
    [anon_sym_DQUOTE] = ACTIONS(7554),
    [sym_return] = ACTIONS(7556),
    [sym_next] = ACTIONS(7556),
    [sym_break] = ACTIONS(7556),
    [sym_true] = ACTIONS(7556),
    [sym_false] = ACTIONS(7556),
    [sym_null] = ACTIONS(7556),
    [sym_inf] = ACTIONS(7556),
    [sym_nan] = ACTIONS(7556),
    [anon_sym_NA] = ACTIONS(7556),
    [anon_sym_NA_integer_] = ACTIONS(7556),
    [anon_sym_NA_real_] = ACTIONS(7556),
    [anon_sym_NA_complex_] = ACTIONS(7556),
    [anon_sym_NA_character_] = ACTIONS(7556),
    [sym_dots] = ACTIONS(7556),
    [sym_dot_dot_i] = ACTIONS(7554),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7554),
    [sym__newline] = ACTIONS(7554),
    [sym__raw_string_literal] = ACTIONS(7554),
    [sym__external_else] = ACTIONS(7554),
    [sym__external_open_parenthesis] = ACTIONS(7554),
    [sym__external_open_brace] = ACTIONS(7554),
    [sym__external_open_bracket] = ACTIONS(7554),
    [sym__external_open_bracket2] = ACTIONS(7554),
    [sym__external_close_bracket2] = ACTIONS(7554),
  },
  [2880] = {
    [ts_builtin_sym_end] = ACTIONS(7496),
    [sym_identifier] = ACTIONS(7498),
    [anon_sym_BSLASH] = ACTIONS(7496),
    [anon_sym_function] = ACTIONS(7498),
    [anon_sym_EQ] = ACTIONS(7498),
    [anon_sym_if] = ACTIONS(7498),
    [anon_sym_for] = ACTIONS(7498),
    [anon_sym_while] = ACTIONS(7498),
    [anon_sym_repeat] = ACTIONS(7498),
    [anon_sym_QMARK] = ACTIONS(7496),
    [anon_sym_TILDE] = ACTIONS(7496),
    [anon_sym_BANG] = ACTIONS(7498),
    [anon_sym_PLUS] = ACTIONS(7496),
    [anon_sym_DASH] = ACTIONS(7498),
    [anon_sym_LT_DASH] = ACTIONS(7496),
    [anon_sym_LT_LT_DASH] = ACTIONS(7496),
    [anon_sym_COLON_EQ] = ACTIONS(7496),
    [anon_sym_DASH_GT] = ACTIONS(7498),
    [anon_sym_DASH_GT_GT] = ACTIONS(7496),
    [anon_sym_PIPE] = ACTIONS(7498),
    [anon_sym_AMP] = ACTIONS(7498),
    [anon_sym_PIPE_PIPE] = ACTIONS(7496),
    [anon_sym_AMP_AMP] = ACTIONS(7496),
    [anon_sym_LT] = ACTIONS(7498),
    [anon_sym_LT_EQ] = ACTIONS(7496),
    [anon_sym_GT] = ACTIONS(7498),
    [anon_sym_GT_EQ] = ACTIONS(7496),
    [anon_sym_EQ_EQ] = ACTIONS(7496),
    [anon_sym_BANG_EQ] = ACTIONS(7496),
    [anon_sym_STAR] = ACTIONS(7498),
    [anon_sym_SLASH] = ACTIONS(7496),
    [anon_sym_STAR_STAR] = ACTIONS(7496),
    [anon_sym_CARET] = ACTIONS(7496),
    [aux_sym_binary_operator_token1] = ACTIONS(7496),
    [anon_sym_PIPE_GT] = ACTIONS(7496),
    [anon_sym_COLON] = ACTIONS(7498),
    [anon_sym_DOLLAR] = ACTIONS(7496),
    [anon_sym_AT] = ACTIONS(7496),
    [aux_sym__hex_literal_token1] = ACTIONS(7496),
    [sym__number_literal] = ACTIONS(7498),
    [anon_sym_SQUOTE] = ACTIONS(7496),
    [anon_sym_DQUOTE] = ACTIONS(7496),
    [sym_return] = ACTIONS(7498),
    [sym_next] = ACTIONS(7498),
    [sym_break] = ACTIONS(7498),
    [sym_true] = ACTIONS(7498),
    [sym_false] = ACTIONS(7498),
    [sym_null] = ACTIONS(7498),
    [sym_inf] = ACTIONS(7498),
    [sym_nan] = ACTIONS(7498),
    [anon_sym_NA] = ACTIONS(7498),
    [anon_sym_NA_integer_] = ACTIONS(7498),
    [anon_sym_NA_real_] = ACTIONS(7498),
    [anon_sym_NA_complex_] = ACTIONS(7498),
    [anon_sym_NA_character_] = ACTIONS(7498),
    [sym_dots] = ACTIONS(7498),
    [sym_dot_dot_i] = ACTIONS(7496),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7496),
    [sym__semicolon] = ACTIONS(7496),
    [sym__raw_string_literal] = ACTIONS(7496),
    [sym__external_open_parenthesis] = ACTIONS(7496),
    [sym__external_close_parenthesis] = ACTIONS(7496),
    [sym__external_open_brace] = ACTIONS(7496),
    [sym__external_open_bracket] = ACTIONS(7496),
    [sym__external_open_bracket2] = ACTIONS(7496),
  },
  [2881] = {
    [aux_sym_function_definition_repeat1] = STATE(2881),
    [ts_builtin_sym_end] = ACTIONS(7417),
    [sym_identifier] = ACTIONS(7419),
    [anon_sym_BSLASH] = ACTIONS(7417),
    [anon_sym_function] = ACTIONS(7419),
    [anon_sym_EQ] = ACTIONS(7419),
    [anon_sym_if] = ACTIONS(7419),
    [anon_sym_for] = ACTIONS(7419),
    [anon_sym_while] = ACTIONS(7419),
    [anon_sym_repeat] = ACTIONS(7419),
    [anon_sym_QMARK] = ACTIONS(7417),
    [anon_sym_TILDE] = ACTIONS(7417),
    [anon_sym_BANG] = ACTIONS(7419),
    [anon_sym_PLUS] = ACTIONS(7417),
    [anon_sym_DASH] = ACTIONS(7419),
    [anon_sym_LT_DASH] = ACTIONS(7417),
    [anon_sym_LT_LT_DASH] = ACTIONS(7417),
    [anon_sym_COLON_EQ] = ACTIONS(7417),
    [anon_sym_DASH_GT] = ACTIONS(7419),
    [anon_sym_DASH_GT_GT] = ACTIONS(7417),
    [anon_sym_PIPE] = ACTIONS(7419),
    [anon_sym_AMP] = ACTIONS(7419),
    [anon_sym_PIPE_PIPE] = ACTIONS(7417),
    [anon_sym_AMP_AMP] = ACTIONS(7417),
    [anon_sym_LT] = ACTIONS(7419),
    [anon_sym_LT_EQ] = ACTIONS(7417),
    [anon_sym_GT] = ACTIONS(7419),
    [anon_sym_GT_EQ] = ACTIONS(7417),
    [anon_sym_EQ_EQ] = ACTIONS(7417),
    [anon_sym_BANG_EQ] = ACTIONS(7417),
    [anon_sym_STAR] = ACTIONS(7419),
    [anon_sym_SLASH] = ACTIONS(7417),
    [anon_sym_STAR_STAR] = ACTIONS(7417),
    [anon_sym_CARET] = ACTIONS(7417),
    [aux_sym_binary_operator_token1] = ACTIONS(7417),
    [anon_sym_PIPE_GT] = ACTIONS(7417),
    [anon_sym_COLON] = ACTIONS(7419),
    [anon_sym_DOLLAR] = ACTIONS(7417),
    [anon_sym_AT] = ACTIONS(7417),
    [aux_sym__hex_literal_token1] = ACTIONS(7417),
    [sym__number_literal] = ACTIONS(7419),
    [anon_sym_SQUOTE] = ACTIONS(7417),
    [anon_sym_DQUOTE] = ACTIONS(7417),
    [sym_return] = ACTIONS(7419),
    [sym_next] = ACTIONS(7419),
    [sym_break] = ACTIONS(7419),
    [sym_true] = ACTIONS(7419),
    [sym_false] = ACTIONS(7419),
    [sym_null] = ACTIONS(7419),
    [sym_inf] = ACTIONS(7419),
    [sym_nan] = ACTIONS(7419),
    [anon_sym_NA] = ACTIONS(7419),
    [anon_sym_NA_integer_] = ACTIONS(7419),
    [anon_sym_NA_real_] = ACTIONS(7419),
    [anon_sym_NA_complex_] = ACTIONS(7419),
    [anon_sym_NA_character_] = ACTIONS(7419),
    [sym_dots] = ACTIONS(7419),
    [sym_dot_dot_i] = ACTIONS(7417),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7707),
    [sym__semicolon] = ACTIONS(7417),
    [sym__raw_string_literal] = ACTIONS(7417),
    [sym__external_open_parenthesis] = ACTIONS(7417),
    [sym__external_open_brace] = ACTIONS(7417),
    [sym__external_open_bracket] = ACTIONS(7417),
    [sym__external_open_bracket2] = ACTIONS(7417),
  },
  [2882] = {
    [ts_builtin_sym_end] = ACTIONS(7500),
    [sym_identifier] = ACTIONS(7502),
    [anon_sym_BSLASH] = ACTIONS(7500),
    [anon_sym_function] = ACTIONS(7502),
    [anon_sym_EQ] = ACTIONS(7502),
    [anon_sym_if] = ACTIONS(7502),
    [anon_sym_for] = ACTIONS(7502),
    [anon_sym_while] = ACTIONS(7502),
    [anon_sym_repeat] = ACTIONS(7502),
    [anon_sym_QMARK] = ACTIONS(7500),
    [anon_sym_TILDE] = ACTIONS(7500),
    [anon_sym_BANG] = ACTIONS(7502),
    [anon_sym_PLUS] = ACTIONS(7500),
    [anon_sym_DASH] = ACTIONS(7502),
    [anon_sym_LT_DASH] = ACTIONS(7500),
    [anon_sym_LT_LT_DASH] = ACTIONS(7500),
    [anon_sym_COLON_EQ] = ACTIONS(7500),
    [anon_sym_DASH_GT] = ACTIONS(7502),
    [anon_sym_DASH_GT_GT] = ACTIONS(7500),
    [anon_sym_PIPE] = ACTIONS(7502),
    [anon_sym_AMP] = ACTIONS(7502),
    [anon_sym_PIPE_PIPE] = ACTIONS(7500),
    [anon_sym_AMP_AMP] = ACTIONS(7500),
    [anon_sym_LT] = ACTIONS(7502),
    [anon_sym_LT_EQ] = ACTIONS(7500),
    [anon_sym_GT] = ACTIONS(7502),
    [anon_sym_GT_EQ] = ACTIONS(7500),
    [anon_sym_EQ_EQ] = ACTIONS(7500),
    [anon_sym_BANG_EQ] = ACTIONS(7500),
    [anon_sym_STAR] = ACTIONS(7502),
    [anon_sym_SLASH] = ACTIONS(7500),
    [anon_sym_STAR_STAR] = ACTIONS(7500),
    [anon_sym_CARET] = ACTIONS(7500),
    [aux_sym_binary_operator_token1] = ACTIONS(7500),
    [anon_sym_PIPE_GT] = ACTIONS(7500),
    [anon_sym_COLON] = ACTIONS(7502),
    [anon_sym_DOLLAR] = ACTIONS(7500),
    [anon_sym_AT] = ACTIONS(7500),
    [aux_sym__hex_literal_token1] = ACTIONS(7500),
    [sym__number_literal] = ACTIONS(7502),
    [anon_sym_SQUOTE] = ACTIONS(7500),
    [anon_sym_DQUOTE] = ACTIONS(7500),
    [sym_return] = ACTIONS(7502),
    [sym_next] = ACTIONS(7502),
    [sym_break] = ACTIONS(7502),
    [sym_true] = ACTIONS(7502),
    [sym_false] = ACTIONS(7502),
    [sym_null] = ACTIONS(7502),
    [sym_inf] = ACTIONS(7502),
    [sym_nan] = ACTIONS(7502),
    [anon_sym_NA] = ACTIONS(7502),
    [anon_sym_NA_integer_] = ACTIONS(7502),
    [anon_sym_NA_real_] = ACTIONS(7502),
    [anon_sym_NA_complex_] = ACTIONS(7502),
    [anon_sym_NA_character_] = ACTIONS(7502),
    [sym_dots] = ACTIONS(7502),
    [sym_dot_dot_i] = ACTIONS(7500),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7500),
    [sym__semicolon] = ACTIONS(7500),
    [sym__raw_string_literal] = ACTIONS(7500),
    [sym__external_open_parenthesis] = ACTIONS(7500),
    [sym__external_close_parenthesis] = ACTIONS(7500),
    [sym__external_open_brace] = ACTIONS(7500),
    [sym__external_open_bracket] = ACTIONS(7500),
    [sym__external_open_bracket2] = ACTIONS(7500),
  },
  [2883] = {
    [ts_builtin_sym_end] = ACTIONS(5327),
    [sym_identifier] = ACTIONS(5325),
    [anon_sym_BSLASH] = ACTIONS(5327),
    [anon_sym_function] = ACTIONS(5325),
    [anon_sym_EQ] = ACTIONS(5325),
    [anon_sym_if] = ACTIONS(5325),
    [anon_sym_for] = ACTIONS(5325),
    [anon_sym_while] = ACTIONS(5325),
    [anon_sym_repeat] = ACTIONS(5325),
    [anon_sym_QMARK] = ACTIONS(5327),
    [anon_sym_TILDE] = ACTIONS(5327),
    [anon_sym_BANG] = ACTIONS(5325),
    [anon_sym_PLUS] = ACTIONS(5327),
    [anon_sym_DASH] = ACTIONS(5325),
    [anon_sym_LT_DASH] = ACTIONS(5327),
    [anon_sym_LT_LT_DASH] = ACTIONS(5327),
    [anon_sym_COLON_EQ] = ACTIONS(5327),
    [anon_sym_DASH_GT] = ACTIONS(5325),
    [anon_sym_DASH_GT_GT] = ACTIONS(5327),
    [anon_sym_PIPE] = ACTIONS(5325),
    [anon_sym_AMP] = ACTIONS(5325),
    [anon_sym_PIPE_PIPE] = ACTIONS(5327),
    [anon_sym_AMP_AMP] = ACTIONS(5327),
    [anon_sym_LT] = ACTIONS(5325),
    [anon_sym_LT_EQ] = ACTIONS(5327),
    [anon_sym_GT] = ACTIONS(5325),
    [anon_sym_GT_EQ] = ACTIONS(5327),
    [anon_sym_EQ_EQ] = ACTIONS(5327),
    [anon_sym_BANG_EQ] = ACTIONS(5327),
    [anon_sym_STAR] = ACTIONS(5325),
    [anon_sym_SLASH] = ACTIONS(5327),
    [anon_sym_STAR_STAR] = ACTIONS(5327),
    [anon_sym_CARET] = ACTIONS(5327),
    [aux_sym_binary_operator_token1] = ACTIONS(5327),
    [anon_sym_PIPE_GT] = ACTIONS(5327),
    [anon_sym_COLON] = ACTIONS(5325),
    [anon_sym_DOLLAR] = ACTIONS(5327),
    [anon_sym_AT] = ACTIONS(5327),
    [aux_sym__hex_literal_token1] = ACTIONS(5327),
    [sym__number_literal] = ACTIONS(5325),
    [anon_sym_SQUOTE] = ACTIONS(5327),
    [anon_sym_DQUOTE] = ACTIONS(5327),
    [sym_return] = ACTIONS(5325),
    [sym_next] = ACTIONS(5325),
    [sym_break] = ACTIONS(5325),
    [sym_true] = ACTIONS(5325),
    [sym_false] = ACTIONS(5325),
    [sym_null] = ACTIONS(5325),
    [sym_inf] = ACTIONS(5325),
    [sym_nan] = ACTIONS(5325),
    [anon_sym_NA] = ACTIONS(5325),
    [anon_sym_NA_integer_] = ACTIONS(5325),
    [anon_sym_NA_real_] = ACTIONS(5325),
    [anon_sym_NA_complex_] = ACTIONS(5325),
    [anon_sym_NA_character_] = ACTIONS(5325),
    [sym_dots] = ACTIONS(5325),
    [sym_dot_dot_i] = ACTIONS(5327),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5327),
    [sym__semicolon] = ACTIONS(5327),
    [sym__raw_string_literal] = ACTIONS(5327),
    [sym__external_open_parenthesis] = ACTIONS(5327),
    [sym__external_open_brace] = ACTIONS(5327),
    [sym__external_close_brace] = ACTIONS(5327),
    [sym__external_open_bracket] = ACTIONS(5327),
    [sym__external_open_bracket2] = ACTIONS(5327),
  },
  [2884] = {
    [ts_builtin_sym_end] = ACTIONS(7554),
    [sym_identifier] = ACTIONS(7556),
    [anon_sym_BSLASH] = ACTIONS(7554),
    [anon_sym_function] = ACTIONS(7556),
    [anon_sym_EQ] = ACTIONS(7556),
    [anon_sym_if] = ACTIONS(7556),
    [anon_sym_for] = ACTIONS(7556),
    [anon_sym_while] = ACTIONS(7556),
    [anon_sym_repeat] = ACTIONS(7556),
    [anon_sym_QMARK] = ACTIONS(7554),
    [anon_sym_TILDE] = ACTIONS(7554),
    [anon_sym_BANG] = ACTIONS(7556),
    [anon_sym_PLUS] = ACTIONS(7554),
    [anon_sym_DASH] = ACTIONS(7556),
    [anon_sym_LT_DASH] = ACTIONS(7554),
    [anon_sym_LT_LT_DASH] = ACTIONS(7554),
    [anon_sym_COLON_EQ] = ACTIONS(7554),
    [anon_sym_DASH_GT] = ACTIONS(7556),
    [anon_sym_DASH_GT_GT] = ACTIONS(7554),
    [anon_sym_PIPE] = ACTIONS(7556),
    [anon_sym_AMP] = ACTIONS(7556),
    [anon_sym_PIPE_PIPE] = ACTIONS(7554),
    [anon_sym_AMP_AMP] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(7556),
    [anon_sym_LT_EQ] = ACTIONS(7554),
    [anon_sym_GT] = ACTIONS(7556),
    [anon_sym_GT_EQ] = ACTIONS(7554),
    [anon_sym_EQ_EQ] = ACTIONS(7554),
    [anon_sym_BANG_EQ] = ACTIONS(7554),
    [anon_sym_STAR] = ACTIONS(7556),
    [anon_sym_SLASH] = ACTIONS(7554),
    [anon_sym_STAR_STAR] = ACTIONS(7554),
    [anon_sym_CARET] = ACTIONS(7554),
    [aux_sym_binary_operator_token1] = ACTIONS(7554),
    [anon_sym_PIPE_GT] = ACTIONS(7554),
    [anon_sym_COLON] = ACTIONS(7556),
    [anon_sym_DOLLAR] = ACTIONS(7554),
    [anon_sym_AT] = ACTIONS(7554),
    [aux_sym__hex_literal_token1] = ACTIONS(7554),
    [sym__number_literal] = ACTIONS(7556),
    [anon_sym_SQUOTE] = ACTIONS(7554),
    [anon_sym_DQUOTE] = ACTIONS(7554),
    [sym_return] = ACTIONS(7556),
    [sym_next] = ACTIONS(7556),
    [sym_break] = ACTIONS(7556),
    [sym_true] = ACTIONS(7556),
    [sym_false] = ACTIONS(7556),
    [sym_null] = ACTIONS(7556),
    [sym_inf] = ACTIONS(7556),
    [sym_nan] = ACTIONS(7556),
    [anon_sym_NA] = ACTIONS(7556),
    [anon_sym_NA_integer_] = ACTIONS(7556),
    [anon_sym_NA_real_] = ACTIONS(7556),
    [anon_sym_NA_complex_] = ACTIONS(7556),
    [anon_sym_NA_character_] = ACTIONS(7556),
    [sym_dots] = ACTIONS(7556),
    [sym_dot_dot_i] = ACTIONS(7554),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7554),
    [sym__semicolon] = ACTIONS(7554),
    [sym__raw_string_literal] = ACTIONS(7554),
    [sym__external_else] = ACTIONS(7554),
    [sym__external_open_parenthesis] = ACTIONS(7554),
    [sym__external_open_brace] = ACTIONS(7554),
    [sym__external_open_bracket] = ACTIONS(7554),
    [sym__external_open_bracket2] = ACTIONS(7554),
  },
  [2885] = {
    [ts_builtin_sym_end] = ACTIONS(7518),
    [sym_identifier] = ACTIONS(7520),
    [anon_sym_BSLASH] = ACTIONS(7518),
    [anon_sym_function] = ACTIONS(7520),
    [anon_sym_EQ] = ACTIONS(7520),
    [anon_sym_if] = ACTIONS(7520),
    [anon_sym_for] = ACTIONS(7520),
    [anon_sym_while] = ACTIONS(7520),
    [anon_sym_repeat] = ACTIONS(7520),
    [anon_sym_QMARK] = ACTIONS(7518),
    [anon_sym_TILDE] = ACTIONS(7518),
    [anon_sym_BANG] = ACTIONS(7520),
    [anon_sym_PLUS] = ACTIONS(7518),
    [anon_sym_DASH] = ACTIONS(7520),
    [anon_sym_LT_DASH] = ACTIONS(7518),
    [anon_sym_LT_LT_DASH] = ACTIONS(7518),
    [anon_sym_COLON_EQ] = ACTIONS(7518),
    [anon_sym_DASH_GT] = ACTIONS(7520),
    [anon_sym_DASH_GT_GT] = ACTIONS(7518),
    [anon_sym_PIPE] = ACTIONS(7520),
    [anon_sym_AMP] = ACTIONS(7520),
    [anon_sym_PIPE_PIPE] = ACTIONS(7518),
    [anon_sym_AMP_AMP] = ACTIONS(7518),
    [anon_sym_LT] = ACTIONS(7520),
    [anon_sym_LT_EQ] = ACTIONS(7518),
    [anon_sym_GT] = ACTIONS(7520),
    [anon_sym_GT_EQ] = ACTIONS(7518),
    [anon_sym_EQ_EQ] = ACTIONS(7518),
    [anon_sym_BANG_EQ] = ACTIONS(7518),
    [anon_sym_STAR] = ACTIONS(7520),
    [anon_sym_SLASH] = ACTIONS(7518),
    [anon_sym_STAR_STAR] = ACTIONS(7518),
    [anon_sym_CARET] = ACTIONS(7518),
    [aux_sym_binary_operator_token1] = ACTIONS(7518),
    [anon_sym_PIPE_GT] = ACTIONS(7518),
    [anon_sym_COLON] = ACTIONS(7520),
    [anon_sym_DOLLAR] = ACTIONS(7518),
    [anon_sym_AT] = ACTIONS(7518),
    [aux_sym__hex_literal_token1] = ACTIONS(7518),
    [sym__number_literal] = ACTIONS(7520),
    [anon_sym_SQUOTE] = ACTIONS(7518),
    [anon_sym_DQUOTE] = ACTIONS(7518),
    [sym_return] = ACTIONS(7520),
    [sym_next] = ACTIONS(7520),
    [sym_break] = ACTIONS(7520),
    [sym_true] = ACTIONS(7520),
    [sym_false] = ACTIONS(7520),
    [sym_null] = ACTIONS(7520),
    [sym_inf] = ACTIONS(7520),
    [sym_nan] = ACTIONS(7520),
    [anon_sym_NA] = ACTIONS(7520),
    [anon_sym_NA_integer_] = ACTIONS(7520),
    [anon_sym_NA_real_] = ACTIONS(7520),
    [anon_sym_NA_complex_] = ACTIONS(7520),
    [anon_sym_NA_character_] = ACTIONS(7520),
    [sym_dots] = ACTIONS(7520),
    [sym_dot_dot_i] = ACTIONS(7518),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7518),
    [sym__semicolon] = ACTIONS(7518),
    [sym__raw_string_literal] = ACTIONS(7518),
    [sym__external_open_parenthesis] = ACTIONS(7518),
    [sym__external_open_brace] = ACTIONS(7518),
    [sym__external_close_brace] = ACTIONS(7518),
    [sym__external_open_bracket] = ACTIONS(7518),
    [sym__external_open_bracket2] = ACTIONS(7518),
  },
  [2886] = {
    [ts_builtin_sym_end] = ACTIONS(7518),
    [sym_identifier] = ACTIONS(7520),
    [anon_sym_BSLASH] = ACTIONS(7518),
    [anon_sym_function] = ACTIONS(7520),
    [anon_sym_EQ] = ACTIONS(7520),
    [anon_sym_if] = ACTIONS(7520),
    [anon_sym_for] = ACTIONS(7520),
    [anon_sym_while] = ACTIONS(7520),
    [anon_sym_repeat] = ACTIONS(7520),
    [anon_sym_QMARK] = ACTIONS(7518),
    [anon_sym_TILDE] = ACTIONS(7518),
    [anon_sym_BANG] = ACTIONS(7520),
    [anon_sym_PLUS] = ACTIONS(7518),
    [anon_sym_DASH] = ACTIONS(7520),
    [anon_sym_LT_DASH] = ACTIONS(7518),
    [anon_sym_LT_LT_DASH] = ACTIONS(7518),
    [anon_sym_COLON_EQ] = ACTIONS(7518),
    [anon_sym_DASH_GT] = ACTIONS(7520),
    [anon_sym_DASH_GT_GT] = ACTIONS(7518),
    [anon_sym_PIPE] = ACTIONS(7520),
    [anon_sym_AMP] = ACTIONS(7520),
    [anon_sym_PIPE_PIPE] = ACTIONS(7518),
    [anon_sym_AMP_AMP] = ACTIONS(7518),
    [anon_sym_LT] = ACTIONS(7520),
    [anon_sym_LT_EQ] = ACTIONS(7518),
    [anon_sym_GT] = ACTIONS(7520),
    [anon_sym_GT_EQ] = ACTIONS(7518),
    [anon_sym_EQ_EQ] = ACTIONS(7518),
    [anon_sym_BANG_EQ] = ACTIONS(7518),
    [anon_sym_STAR] = ACTIONS(7520),
    [anon_sym_SLASH] = ACTIONS(7518),
    [anon_sym_STAR_STAR] = ACTIONS(7518),
    [anon_sym_CARET] = ACTIONS(7518),
    [aux_sym_binary_operator_token1] = ACTIONS(7518),
    [anon_sym_PIPE_GT] = ACTIONS(7518),
    [anon_sym_COLON] = ACTIONS(7520),
    [anon_sym_DOLLAR] = ACTIONS(7518),
    [anon_sym_AT] = ACTIONS(7518),
    [aux_sym__hex_literal_token1] = ACTIONS(7518),
    [sym__number_literal] = ACTIONS(7520),
    [anon_sym_SQUOTE] = ACTIONS(7518),
    [anon_sym_DQUOTE] = ACTIONS(7518),
    [sym_return] = ACTIONS(7520),
    [sym_next] = ACTIONS(7520),
    [sym_break] = ACTIONS(7520),
    [sym_true] = ACTIONS(7520),
    [sym_false] = ACTIONS(7520),
    [sym_null] = ACTIONS(7520),
    [sym_inf] = ACTIONS(7520),
    [sym_nan] = ACTIONS(7520),
    [anon_sym_NA] = ACTIONS(7520),
    [anon_sym_NA_integer_] = ACTIONS(7520),
    [anon_sym_NA_real_] = ACTIONS(7520),
    [anon_sym_NA_complex_] = ACTIONS(7520),
    [anon_sym_NA_character_] = ACTIONS(7520),
    [sym_dots] = ACTIONS(7520),
    [sym_dot_dot_i] = ACTIONS(7518),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7518),
    [sym__semicolon] = ACTIONS(7518),
    [sym__raw_string_literal] = ACTIONS(7518),
    [sym__external_else] = ACTIONS(7518),
    [sym__external_open_parenthesis] = ACTIONS(7518),
    [sym__external_open_brace] = ACTIONS(7518),
    [sym__external_open_bracket] = ACTIONS(7518),
    [sym__external_open_bracket2] = ACTIONS(7518),
  },
  [2887] = {
    [sym_identifier] = ACTIONS(7556),
    [anon_sym_BSLASH] = ACTIONS(7554),
    [anon_sym_function] = ACTIONS(7556),
    [anon_sym_EQ] = ACTIONS(7556),
    [anon_sym_if] = ACTIONS(7556),
    [anon_sym_for] = ACTIONS(7556),
    [anon_sym_while] = ACTIONS(7556),
    [anon_sym_repeat] = ACTIONS(7556),
    [anon_sym_QMARK] = ACTIONS(7554),
    [anon_sym_TILDE] = ACTIONS(7554),
    [anon_sym_BANG] = ACTIONS(7556),
    [anon_sym_PLUS] = ACTIONS(7554),
    [anon_sym_DASH] = ACTIONS(7556),
    [anon_sym_LT_DASH] = ACTIONS(7554),
    [anon_sym_LT_LT_DASH] = ACTIONS(7554),
    [anon_sym_COLON_EQ] = ACTIONS(7554),
    [anon_sym_DASH_GT] = ACTIONS(7556),
    [anon_sym_DASH_GT_GT] = ACTIONS(7554),
    [anon_sym_PIPE] = ACTIONS(7556),
    [anon_sym_AMP] = ACTIONS(7556),
    [anon_sym_PIPE_PIPE] = ACTIONS(7554),
    [anon_sym_AMP_AMP] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(7556),
    [anon_sym_LT_EQ] = ACTIONS(7554),
    [anon_sym_GT] = ACTIONS(7556),
    [anon_sym_GT_EQ] = ACTIONS(7554),
    [anon_sym_EQ_EQ] = ACTIONS(7554),
    [anon_sym_BANG_EQ] = ACTIONS(7554),
    [anon_sym_STAR] = ACTIONS(7556),
    [anon_sym_SLASH] = ACTIONS(7554),
    [anon_sym_STAR_STAR] = ACTIONS(7554),
    [anon_sym_CARET] = ACTIONS(7554),
    [aux_sym_binary_operator_token1] = ACTIONS(7554),
    [anon_sym_PIPE_GT] = ACTIONS(7554),
    [anon_sym_COLON] = ACTIONS(7556),
    [anon_sym_DOLLAR] = ACTIONS(7554),
    [anon_sym_AT] = ACTIONS(7554),
    [aux_sym__hex_literal_token1] = ACTIONS(7554),
    [sym__number_literal] = ACTIONS(7556),
    [anon_sym_SQUOTE] = ACTIONS(7554),
    [anon_sym_DQUOTE] = ACTIONS(7554),
    [sym_return] = ACTIONS(7556),
    [sym_next] = ACTIONS(7556),
    [sym_break] = ACTIONS(7556),
    [sym_true] = ACTIONS(7556),
    [sym_false] = ACTIONS(7556),
    [sym_null] = ACTIONS(7556),
    [sym_inf] = ACTIONS(7556),
    [sym_nan] = ACTIONS(7556),
    [anon_sym_NA] = ACTIONS(7556),
    [anon_sym_NA_integer_] = ACTIONS(7556),
    [anon_sym_NA_real_] = ACTIONS(7556),
    [anon_sym_NA_complex_] = ACTIONS(7556),
    [anon_sym_NA_character_] = ACTIONS(7556),
    [sym_dots] = ACTIONS(7556),
    [sym_dot_dot_i] = ACTIONS(7554),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7554),
    [sym__newline] = ACTIONS(7554),
    [sym__raw_string_literal] = ACTIONS(7554),
    [sym__external_else] = ACTIONS(7554),
    [sym__external_open_parenthesis] = ACTIONS(7554),
    [sym__external_open_brace] = ACTIONS(7554),
    [sym__external_open_bracket] = ACTIONS(7554),
    [sym__external_close_bracket] = ACTIONS(7554),
    [sym__external_open_bracket2] = ACTIONS(7554),
  },
  [2888] = {
    [ts_builtin_sym_end] = ACTIONS(7550),
    [sym_identifier] = ACTIONS(7552),
    [anon_sym_BSLASH] = ACTIONS(7550),
    [anon_sym_function] = ACTIONS(7552),
    [anon_sym_EQ] = ACTIONS(7552),
    [anon_sym_if] = ACTIONS(7552),
    [anon_sym_for] = ACTIONS(7552),
    [anon_sym_while] = ACTIONS(7552),
    [anon_sym_repeat] = ACTIONS(7552),
    [anon_sym_QMARK] = ACTIONS(7550),
    [anon_sym_TILDE] = ACTIONS(7550),
    [anon_sym_BANG] = ACTIONS(7552),
    [anon_sym_PLUS] = ACTIONS(7550),
    [anon_sym_DASH] = ACTIONS(7552),
    [anon_sym_LT_DASH] = ACTIONS(7550),
    [anon_sym_LT_LT_DASH] = ACTIONS(7550),
    [anon_sym_COLON_EQ] = ACTIONS(7550),
    [anon_sym_DASH_GT] = ACTIONS(7552),
    [anon_sym_DASH_GT_GT] = ACTIONS(7550),
    [anon_sym_PIPE] = ACTIONS(7552),
    [anon_sym_AMP] = ACTIONS(7552),
    [anon_sym_PIPE_PIPE] = ACTIONS(7550),
    [anon_sym_AMP_AMP] = ACTIONS(7550),
    [anon_sym_LT] = ACTIONS(7552),
    [anon_sym_LT_EQ] = ACTIONS(7550),
    [anon_sym_GT] = ACTIONS(7552),
    [anon_sym_GT_EQ] = ACTIONS(7550),
    [anon_sym_EQ_EQ] = ACTIONS(7550),
    [anon_sym_BANG_EQ] = ACTIONS(7550),
    [anon_sym_STAR] = ACTIONS(7552),
    [anon_sym_SLASH] = ACTIONS(7550),
    [anon_sym_STAR_STAR] = ACTIONS(7550),
    [anon_sym_CARET] = ACTIONS(7550),
    [aux_sym_binary_operator_token1] = ACTIONS(7550),
    [anon_sym_PIPE_GT] = ACTIONS(7550),
    [anon_sym_COLON] = ACTIONS(7552),
    [anon_sym_DOLLAR] = ACTIONS(7550),
    [anon_sym_AT] = ACTIONS(7550),
    [aux_sym__hex_literal_token1] = ACTIONS(7550),
    [sym__number_literal] = ACTIONS(7552),
    [anon_sym_SQUOTE] = ACTIONS(7550),
    [anon_sym_DQUOTE] = ACTIONS(7550),
    [sym_return] = ACTIONS(7552),
    [sym_next] = ACTIONS(7552),
    [sym_break] = ACTIONS(7552),
    [sym_true] = ACTIONS(7552),
    [sym_false] = ACTIONS(7552),
    [sym_null] = ACTIONS(7552),
    [sym_inf] = ACTIONS(7552),
    [sym_nan] = ACTIONS(7552),
    [anon_sym_NA] = ACTIONS(7552),
    [anon_sym_NA_integer_] = ACTIONS(7552),
    [anon_sym_NA_real_] = ACTIONS(7552),
    [anon_sym_NA_complex_] = ACTIONS(7552),
    [anon_sym_NA_character_] = ACTIONS(7552),
    [sym_dots] = ACTIONS(7552),
    [sym_dot_dot_i] = ACTIONS(7550),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7550),
    [sym__semicolon] = ACTIONS(7550),
    [sym__raw_string_literal] = ACTIONS(7550),
    [sym__external_open_parenthesis] = ACTIONS(7550),
    [sym__external_open_brace] = ACTIONS(7550),
    [sym__external_close_brace] = ACTIONS(7550),
    [sym__external_open_bracket] = ACTIONS(7550),
    [sym__external_open_bracket2] = ACTIONS(7550),
  },
  [2889] = {
    [ts_builtin_sym_end] = ACTIONS(7504),
    [sym_identifier] = ACTIONS(7506),
    [anon_sym_BSLASH] = ACTIONS(7504),
    [anon_sym_function] = ACTIONS(7506),
    [anon_sym_EQ] = ACTIONS(7506),
    [anon_sym_if] = ACTIONS(7506),
    [anon_sym_for] = ACTIONS(7506),
    [anon_sym_while] = ACTIONS(7506),
    [anon_sym_repeat] = ACTIONS(7506),
    [anon_sym_QMARK] = ACTIONS(7504),
    [anon_sym_TILDE] = ACTIONS(7504),
    [anon_sym_BANG] = ACTIONS(7506),
    [anon_sym_PLUS] = ACTIONS(7504),
    [anon_sym_DASH] = ACTIONS(7506),
    [anon_sym_LT_DASH] = ACTIONS(7504),
    [anon_sym_LT_LT_DASH] = ACTIONS(7504),
    [anon_sym_COLON_EQ] = ACTIONS(7504),
    [anon_sym_DASH_GT] = ACTIONS(7506),
    [anon_sym_DASH_GT_GT] = ACTIONS(7504),
    [anon_sym_PIPE] = ACTIONS(7506),
    [anon_sym_AMP] = ACTIONS(7506),
    [anon_sym_PIPE_PIPE] = ACTIONS(7504),
    [anon_sym_AMP_AMP] = ACTIONS(7504),
    [anon_sym_LT] = ACTIONS(7506),
    [anon_sym_LT_EQ] = ACTIONS(7504),
    [anon_sym_GT] = ACTIONS(7506),
    [anon_sym_GT_EQ] = ACTIONS(7504),
    [anon_sym_EQ_EQ] = ACTIONS(7504),
    [anon_sym_BANG_EQ] = ACTIONS(7504),
    [anon_sym_STAR] = ACTIONS(7506),
    [anon_sym_SLASH] = ACTIONS(7504),
    [anon_sym_STAR_STAR] = ACTIONS(7504),
    [anon_sym_CARET] = ACTIONS(7504),
    [aux_sym_binary_operator_token1] = ACTIONS(7504),
    [anon_sym_PIPE_GT] = ACTIONS(7504),
    [anon_sym_COLON] = ACTIONS(7506),
    [anon_sym_DOLLAR] = ACTIONS(7504),
    [anon_sym_AT] = ACTIONS(7504),
    [aux_sym__hex_literal_token1] = ACTIONS(7504),
    [sym__number_literal] = ACTIONS(7506),
    [anon_sym_SQUOTE] = ACTIONS(7504),
    [anon_sym_DQUOTE] = ACTIONS(7504),
    [sym_return] = ACTIONS(7506),
    [sym_next] = ACTIONS(7506),
    [sym_break] = ACTIONS(7506),
    [sym_true] = ACTIONS(7506),
    [sym_false] = ACTIONS(7506),
    [sym_null] = ACTIONS(7506),
    [sym_inf] = ACTIONS(7506),
    [sym_nan] = ACTIONS(7506),
    [anon_sym_NA] = ACTIONS(7506),
    [anon_sym_NA_integer_] = ACTIONS(7506),
    [anon_sym_NA_real_] = ACTIONS(7506),
    [anon_sym_NA_complex_] = ACTIONS(7506),
    [anon_sym_NA_character_] = ACTIONS(7506),
    [sym_dots] = ACTIONS(7506),
    [sym_dot_dot_i] = ACTIONS(7504),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7504),
    [sym__semicolon] = ACTIONS(7504),
    [sym__raw_string_literal] = ACTIONS(7504),
    [sym__external_open_parenthesis] = ACTIONS(7504),
    [sym__external_close_parenthesis] = ACTIONS(7504),
    [sym__external_open_brace] = ACTIONS(7504),
    [sym__external_open_bracket] = ACTIONS(7504),
    [sym__external_open_bracket2] = ACTIONS(7504),
  },
  [2890] = {
    [sym_identifier] = ACTIONS(7520),
    [anon_sym_BSLASH] = ACTIONS(7518),
    [anon_sym_function] = ACTIONS(7520),
    [anon_sym_EQ] = ACTIONS(7520),
    [anon_sym_if] = ACTIONS(7520),
    [anon_sym_for] = ACTIONS(7520),
    [anon_sym_while] = ACTIONS(7520),
    [anon_sym_repeat] = ACTIONS(7520),
    [anon_sym_QMARK] = ACTIONS(7518),
    [anon_sym_TILDE] = ACTIONS(7518),
    [anon_sym_BANG] = ACTIONS(7520),
    [anon_sym_PLUS] = ACTIONS(7518),
    [anon_sym_DASH] = ACTIONS(7520),
    [anon_sym_LT_DASH] = ACTIONS(7518),
    [anon_sym_LT_LT_DASH] = ACTIONS(7518),
    [anon_sym_COLON_EQ] = ACTIONS(7518),
    [anon_sym_DASH_GT] = ACTIONS(7520),
    [anon_sym_DASH_GT_GT] = ACTIONS(7518),
    [anon_sym_PIPE] = ACTIONS(7520),
    [anon_sym_AMP] = ACTIONS(7520),
    [anon_sym_PIPE_PIPE] = ACTIONS(7518),
    [anon_sym_AMP_AMP] = ACTIONS(7518),
    [anon_sym_LT] = ACTIONS(7520),
    [anon_sym_LT_EQ] = ACTIONS(7518),
    [anon_sym_GT] = ACTIONS(7520),
    [anon_sym_GT_EQ] = ACTIONS(7518),
    [anon_sym_EQ_EQ] = ACTIONS(7518),
    [anon_sym_BANG_EQ] = ACTIONS(7518),
    [anon_sym_STAR] = ACTIONS(7520),
    [anon_sym_SLASH] = ACTIONS(7518),
    [anon_sym_STAR_STAR] = ACTIONS(7518),
    [anon_sym_CARET] = ACTIONS(7518),
    [aux_sym_binary_operator_token1] = ACTIONS(7518),
    [anon_sym_PIPE_GT] = ACTIONS(7518),
    [anon_sym_COLON] = ACTIONS(7520),
    [anon_sym_DOLLAR] = ACTIONS(7518),
    [anon_sym_AT] = ACTIONS(7518),
    [aux_sym__hex_literal_token1] = ACTIONS(7518),
    [sym__number_literal] = ACTIONS(7520),
    [anon_sym_SQUOTE] = ACTIONS(7518),
    [anon_sym_DQUOTE] = ACTIONS(7518),
    [sym_return] = ACTIONS(7520),
    [sym_next] = ACTIONS(7520),
    [sym_break] = ACTIONS(7520),
    [sym_true] = ACTIONS(7520),
    [sym_false] = ACTIONS(7520),
    [sym_null] = ACTIONS(7520),
    [sym_inf] = ACTIONS(7520),
    [sym_nan] = ACTIONS(7520),
    [anon_sym_NA] = ACTIONS(7520),
    [anon_sym_NA_integer_] = ACTIONS(7520),
    [anon_sym_NA_real_] = ACTIONS(7520),
    [anon_sym_NA_complex_] = ACTIONS(7520),
    [anon_sym_NA_character_] = ACTIONS(7520),
    [sym_dots] = ACTIONS(7520),
    [sym_dot_dot_i] = ACTIONS(7518),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7518),
    [sym__newline] = ACTIONS(7518),
    [sym__raw_string_literal] = ACTIONS(7518),
    [sym__external_else] = ACTIONS(7518),
    [sym__external_open_parenthesis] = ACTIONS(7518),
    [sym__external_close_parenthesis] = ACTIONS(7518),
    [sym__external_open_brace] = ACTIONS(7518),
    [sym__external_open_bracket] = ACTIONS(7518),
    [sym__external_open_bracket2] = ACTIONS(7518),
  },
  [2891] = {
    [sym_identifier] = ACTIONS(7516),
    [anon_sym_BSLASH] = ACTIONS(7514),
    [anon_sym_function] = ACTIONS(7516),
    [anon_sym_EQ] = ACTIONS(7516),
    [anon_sym_if] = ACTIONS(7516),
    [anon_sym_for] = ACTIONS(7516),
    [anon_sym_while] = ACTIONS(7516),
    [anon_sym_repeat] = ACTIONS(7516),
    [anon_sym_QMARK] = ACTIONS(7514),
    [anon_sym_TILDE] = ACTIONS(7514),
    [anon_sym_BANG] = ACTIONS(7516),
    [anon_sym_PLUS] = ACTIONS(7514),
    [anon_sym_DASH] = ACTIONS(7516),
    [anon_sym_LT_DASH] = ACTIONS(7514),
    [anon_sym_LT_LT_DASH] = ACTIONS(7514),
    [anon_sym_COLON_EQ] = ACTIONS(7514),
    [anon_sym_DASH_GT] = ACTIONS(7516),
    [anon_sym_DASH_GT_GT] = ACTIONS(7514),
    [anon_sym_PIPE] = ACTIONS(7516),
    [anon_sym_AMP] = ACTIONS(7516),
    [anon_sym_PIPE_PIPE] = ACTIONS(7514),
    [anon_sym_AMP_AMP] = ACTIONS(7514),
    [anon_sym_LT] = ACTIONS(7516),
    [anon_sym_LT_EQ] = ACTIONS(7514),
    [anon_sym_GT] = ACTIONS(7516),
    [anon_sym_GT_EQ] = ACTIONS(7514),
    [anon_sym_EQ_EQ] = ACTIONS(7514),
    [anon_sym_BANG_EQ] = ACTIONS(7514),
    [anon_sym_STAR] = ACTIONS(7516),
    [anon_sym_SLASH] = ACTIONS(7514),
    [anon_sym_STAR_STAR] = ACTIONS(7514),
    [anon_sym_CARET] = ACTIONS(7514),
    [aux_sym_binary_operator_token1] = ACTIONS(7514),
    [anon_sym_PIPE_GT] = ACTIONS(7514),
    [anon_sym_COLON] = ACTIONS(7516),
    [anon_sym_DOLLAR] = ACTIONS(7514),
    [anon_sym_AT] = ACTIONS(7514),
    [aux_sym__hex_literal_token1] = ACTIONS(7514),
    [sym__number_literal] = ACTIONS(7516),
    [anon_sym_SQUOTE] = ACTIONS(7514),
    [anon_sym_DQUOTE] = ACTIONS(7514),
    [sym_return] = ACTIONS(7516),
    [sym_next] = ACTIONS(7516),
    [sym_break] = ACTIONS(7516),
    [sym_true] = ACTIONS(7516),
    [sym_false] = ACTIONS(7516),
    [sym_null] = ACTIONS(7516),
    [sym_inf] = ACTIONS(7516),
    [sym_nan] = ACTIONS(7516),
    [anon_sym_NA] = ACTIONS(7516),
    [anon_sym_NA_integer_] = ACTIONS(7516),
    [anon_sym_NA_real_] = ACTIONS(7516),
    [anon_sym_NA_complex_] = ACTIONS(7516),
    [anon_sym_NA_character_] = ACTIONS(7516),
    [sym_dots] = ACTIONS(7516),
    [sym_dot_dot_i] = ACTIONS(7514),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7514),
    [sym__newline] = ACTIONS(7514),
    [sym__raw_string_literal] = ACTIONS(7514),
    [sym__external_else] = ACTIONS(7514),
    [sym__external_open_parenthesis] = ACTIONS(7514),
    [sym__external_close_parenthesis] = ACTIONS(7514),
    [sym__external_open_brace] = ACTIONS(7514),
    [sym__external_open_bracket] = ACTIONS(7514),
    [sym__external_open_bracket2] = ACTIONS(7514),
  },
  [2892] = {
    [sym_identifier] = ACTIONS(7552),
    [anon_sym_BSLASH] = ACTIONS(7550),
    [anon_sym_function] = ACTIONS(7552),
    [anon_sym_EQ] = ACTIONS(7552),
    [anon_sym_if] = ACTIONS(7552),
    [anon_sym_for] = ACTIONS(7552),
    [anon_sym_while] = ACTIONS(7552),
    [anon_sym_repeat] = ACTIONS(7552),
    [anon_sym_QMARK] = ACTIONS(7550),
    [anon_sym_TILDE] = ACTIONS(7550),
    [anon_sym_BANG] = ACTIONS(7552),
    [anon_sym_PLUS] = ACTIONS(7550),
    [anon_sym_DASH] = ACTIONS(7552),
    [anon_sym_LT_DASH] = ACTIONS(7550),
    [anon_sym_LT_LT_DASH] = ACTIONS(7550),
    [anon_sym_COLON_EQ] = ACTIONS(7550),
    [anon_sym_DASH_GT] = ACTIONS(7552),
    [anon_sym_DASH_GT_GT] = ACTIONS(7550),
    [anon_sym_PIPE] = ACTIONS(7552),
    [anon_sym_AMP] = ACTIONS(7552),
    [anon_sym_PIPE_PIPE] = ACTIONS(7550),
    [anon_sym_AMP_AMP] = ACTIONS(7550),
    [anon_sym_LT] = ACTIONS(7552),
    [anon_sym_LT_EQ] = ACTIONS(7550),
    [anon_sym_GT] = ACTIONS(7552),
    [anon_sym_GT_EQ] = ACTIONS(7550),
    [anon_sym_EQ_EQ] = ACTIONS(7550),
    [anon_sym_BANG_EQ] = ACTIONS(7550),
    [anon_sym_STAR] = ACTIONS(7552),
    [anon_sym_SLASH] = ACTIONS(7550),
    [anon_sym_STAR_STAR] = ACTIONS(7550),
    [anon_sym_CARET] = ACTIONS(7550),
    [aux_sym_binary_operator_token1] = ACTIONS(7550),
    [anon_sym_PIPE_GT] = ACTIONS(7550),
    [anon_sym_COLON] = ACTIONS(7552),
    [anon_sym_DOLLAR] = ACTIONS(7550),
    [anon_sym_AT] = ACTIONS(7550),
    [aux_sym__hex_literal_token1] = ACTIONS(7550),
    [sym__number_literal] = ACTIONS(7552),
    [anon_sym_SQUOTE] = ACTIONS(7550),
    [anon_sym_DQUOTE] = ACTIONS(7550),
    [sym_return] = ACTIONS(7552),
    [sym_next] = ACTIONS(7552),
    [sym_break] = ACTIONS(7552),
    [sym_true] = ACTIONS(7552),
    [sym_false] = ACTIONS(7552),
    [sym_null] = ACTIONS(7552),
    [sym_inf] = ACTIONS(7552),
    [sym_nan] = ACTIONS(7552),
    [anon_sym_NA] = ACTIONS(7552),
    [anon_sym_NA_integer_] = ACTIONS(7552),
    [anon_sym_NA_real_] = ACTIONS(7552),
    [anon_sym_NA_complex_] = ACTIONS(7552),
    [anon_sym_NA_character_] = ACTIONS(7552),
    [sym_dots] = ACTIONS(7552),
    [sym_dot_dot_i] = ACTIONS(7550),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7550),
    [sym__newline] = ACTIONS(7550),
    [sym__raw_string_literal] = ACTIONS(7550),
    [sym__external_else] = ACTIONS(7550),
    [sym__external_open_parenthesis] = ACTIONS(7550),
    [sym__external_open_brace] = ACTIONS(7550),
    [sym__external_open_bracket] = ACTIONS(7550),
    [sym__external_open_bracket2] = ACTIONS(7550),
    [sym__external_close_bracket2] = ACTIONS(7550),
  },
  [2893] = {
    [sym_function_definition] = STATE(2018),
    [sym_if_statement] = STATE(2018),
    [sym_for_statement] = STATE(2018),
    [sym_while_statement] = STATE(2018),
    [sym_repeat_statement] = STATE(2018),
    [sym_braced_expression] = STATE(2018),
    [sym_parenthesized_expression] = STATE(2018),
    [sym_call] = STATE(2018),
    [sym_subset] = STATE(2018),
    [sym_subset2] = STATE(2018),
    [sym_unary_operator] = STATE(2018),
    [sym_binary_operator] = STATE(2018),
    [sym_extract_operator] = STATE(2018),
    [sym_namespace_operator] = STATE(2018),
    [sym_integer] = STATE(2018),
    [sym_complex] = STATE(2018),
    [sym_float] = STATE(2018),
    [sym__hex_literal] = STATE(2739),
    [sym__float_literal] = STATE(2739),
    [sym_string] = STATE(2562),
    [sym__single_quoted_string] = STATE(2738),
    [sym__double_quoted_string] = STATE(2737),
    [sym_na] = STATE(2018),
    [sym__expression] = STATE(2018),
    [sym__string_or_identifier] = STATE(5152),
    [sym__open_parenthesis] = STATE(293),
    [sym__open_brace] = STATE(292),
    [aux_sym_program_repeat1] = STATE(2893),
    [ts_builtin_sym_end] = ACTIONS(7710),
    [sym_identifier] = ACTIONS(7712),
    [anon_sym_BSLASH] = ACTIONS(7715),
    [anon_sym_function] = ACTIONS(7718),
    [anon_sym_if] = ACTIONS(7721),
    [anon_sym_for] = ACTIONS(7724),
    [anon_sym_while] = ACTIONS(7727),
    [anon_sym_repeat] = ACTIONS(7730),
    [anon_sym_QMARK] = ACTIONS(7733),
    [anon_sym_TILDE] = ACTIONS(7736),
    [anon_sym_BANG] = ACTIONS(7739),
    [anon_sym_PLUS] = ACTIONS(7742),
    [anon_sym_DASH] = ACTIONS(7742),
    [aux_sym__hex_literal_token1] = ACTIONS(7745),
    [sym__number_literal] = ACTIONS(7748),
    [anon_sym_SQUOTE] = ACTIONS(7751),
    [anon_sym_DQUOTE] = ACTIONS(7754),
    [sym_return] = ACTIONS(7757),
    [sym_next] = ACTIONS(7757),
    [sym_break] = ACTIONS(7757),
    [sym_true] = ACTIONS(7757),
    [sym_false] = ACTIONS(7757),
    [sym_null] = ACTIONS(7757),
    [sym_inf] = ACTIONS(7757),
    [sym_nan] = ACTIONS(7757),
    [anon_sym_NA] = ACTIONS(7760),
    [anon_sym_NA_integer_] = ACTIONS(7760),
    [anon_sym_NA_real_] = ACTIONS(7760),
    [anon_sym_NA_complex_] = ACTIONS(7760),
    [anon_sym_NA_character_] = ACTIONS(7760),
    [sym_dots] = ACTIONS(7757),
    [sym_dot_dot_i] = ACTIONS(7763),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7766),
    [sym__semicolon] = ACTIONS(7766),
    [sym__raw_string_literal] = ACTIONS(7769),
    [sym__external_open_parenthesis] = ACTIONS(7772),
    [sym__external_open_brace] = ACTIONS(7775),
  },
  [2894] = {
    [ts_builtin_sym_end] = ACTIONS(7504),
    [sym_identifier] = ACTIONS(7506),
    [anon_sym_BSLASH] = ACTIONS(7504),
    [anon_sym_function] = ACTIONS(7506),
    [anon_sym_EQ] = ACTIONS(7506),
    [anon_sym_if] = ACTIONS(7506),
    [anon_sym_for] = ACTIONS(7506),
    [anon_sym_while] = ACTIONS(7506),
    [anon_sym_repeat] = ACTIONS(7506),
    [anon_sym_QMARK] = ACTIONS(7504),
    [anon_sym_TILDE] = ACTIONS(7504),
    [anon_sym_BANG] = ACTIONS(7506),
    [anon_sym_PLUS] = ACTIONS(7504),
    [anon_sym_DASH] = ACTIONS(7506),
    [anon_sym_LT_DASH] = ACTIONS(7504),
    [anon_sym_LT_LT_DASH] = ACTIONS(7504),
    [anon_sym_COLON_EQ] = ACTIONS(7504),
    [anon_sym_DASH_GT] = ACTIONS(7506),
    [anon_sym_DASH_GT_GT] = ACTIONS(7504),
    [anon_sym_PIPE] = ACTIONS(7506),
    [anon_sym_AMP] = ACTIONS(7506),
    [anon_sym_PIPE_PIPE] = ACTIONS(7504),
    [anon_sym_AMP_AMP] = ACTIONS(7504),
    [anon_sym_LT] = ACTIONS(7506),
    [anon_sym_LT_EQ] = ACTIONS(7504),
    [anon_sym_GT] = ACTIONS(7506),
    [anon_sym_GT_EQ] = ACTIONS(7504),
    [anon_sym_EQ_EQ] = ACTIONS(7504),
    [anon_sym_BANG_EQ] = ACTIONS(7504),
    [anon_sym_STAR] = ACTIONS(7506),
    [anon_sym_SLASH] = ACTIONS(7504),
    [anon_sym_STAR_STAR] = ACTIONS(7504),
    [anon_sym_CARET] = ACTIONS(7504),
    [aux_sym_binary_operator_token1] = ACTIONS(7504),
    [anon_sym_PIPE_GT] = ACTIONS(7504),
    [anon_sym_COLON] = ACTIONS(7506),
    [anon_sym_DOLLAR] = ACTIONS(7504),
    [anon_sym_AT] = ACTIONS(7504),
    [aux_sym__hex_literal_token1] = ACTIONS(7504),
    [sym__number_literal] = ACTIONS(7506),
    [anon_sym_SQUOTE] = ACTIONS(7504),
    [anon_sym_DQUOTE] = ACTIONS(7504),
    [sym_return] = ACTIONS(7506),
    [sym_next] = ACTIONS(7506),
    [sym_break] = ACTIONS(7506),
    [sym_true] = ACTIONS(7506),
    [sym_false] = ACTIONS(7506),
    [sym_null] = ACTIONS(7506),
    [sym_inf] = ACTIONS(7506),
    [sym_nan] = ACTIONS(7506),
    [anon_sym_NA] = ACTIONS(7506),
    [anon_sym_NA_integer_] = ACTIONS(7506),
    [anon_sym_NA_real_] = ACTIONS(7506),
    [anon_sym_NA_complex_] = ACTIONS(7506),
    [anon_sym_NA_character_] = ACTIONS(7506),
    [sym_dots] = ACTIONS(7506),
    [sym_dot_dot_i] = ACTIONS(7504),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7504),
    [sym__semicolon] = ACTIONS(7504),
    [sym__raw_string_literal] = ACTIONS(7504),
    [sym__external_open_parenthesis] = ACTIONS(7504),
    [sym__external_open_brace] = ACTIONS(7504),
    [sym__external_close_brace] = ACTIONS(7504),
    [sym__external_open_bracket] = ACTIONS(7504),
    [sym__external_open_bracket2] = ACTIONS(7504),
  },
  [2895] = {
    [sym_identifier] = ACTIONS(7520),
    [anon_sym_BSLASH] = ACTIONS(7518),
    [anon_sym_function] = ACTIONS(7520),
    [anon_sym_EQ] = ACTIONS(7520),
    [anon_sym_if] = ACTIONS(7520),
    [anon_sym_for] = ACTIONS(7520),
    [anon_sym_while] = ACTIONS(7520),
    [anon_sym_repeat] = ACTIONS(7520),
    [anon_sym_QMARK] = ACTIONS(7518),
    [anon_sym_TILDE] = ACTIONS(7518),
    [anon_sym_BANG] = ACTIONS(7520),
    [anon_sym_PLUS] = ACTIONS(7518),
    [anon_sym_DASH] = ACTIONS(7520),
    [anon_sym_LT_DASH] = ACTIONS(7518),
    [anon_sym_LT_LT_DASH] = ACTIONS(7518),
    [anon_sym_COLON_EQ] = ACTIONS(7518),
    [anon_sym_DASH_GT] = ACTIONS(7520),
    [anon_sym_DASH_GT_GT] = ACTIONS(7518),
    [anon_sym_PIPE] = ACTIONS(7520),
    [anon_sym_AMP] = ACTIONS(7520),
    [anon_sym_PIPE_PIPE] = ACTIONS(7518),
    [anon_sym_AMP_AMP] = ACTIONS(7518),
    [anon_sym_LT] = ACTIONS(7520),
    [anon_sym_LT_EQ] = ACTIONS(7518),
    [anon_sym_GT] = ACTIONS(7520),
    [anon_sym_GT_EQ] = ACTIONS(7518),
    [anon_sym_EQ_EQ] = ACTIONS(7518),
    [anon_sym_BANG_EQ] = ACTIONS(7518),
    [anon_sym_STAR] = ACTIONS(7520),
    [anon_sym_SLASH] = ACTIONS(7518),
    [anon_sym_STAR_STAR] = ACTIONS(7518),
    [anon_sym_CARET] = ACTIONS(7518),
    [aux_sym_binary_operator_token1] = ACTIONS(7518),
    [anon_sym_PIPE_GT] = ACTIONS(7518),
    [anon_sym_COLON] = ACTIONS(7520),
    [anon_sym_DOLLAR] = ACTIONS(7518),
    [anon_sym_AT] = ACTIONS(7518),
    [aux_sym__hex_literal_token1] = ACTIONS(7518),
    [sym__number_literal] = ACTIONS(7520),
    [anon_sym_SQUOTE] = ACTIONS(7518),
    [anon_sym_DQUOTE] = ACTIONS(7518),
    [sym_return] = ACTIONS(7520),
    [sym_next] = ACTIONS(7520),
    [sym_break] = ACTIONS(7520),
    [sym_true] = ACTIONS(7520),
    [sym_false] = ACTIONS(7520),
    [sym_null] = ACTIONS(7520),
    [sym_inf] = ACTIONS(7520),
    [sym_nan] = ACTIONS(7520),
    [anon_sym_NA] = ACTIONS(7520),
    [anon_sym_NA_integer_] = ACTIONS(7520),
    [anon_sym_NA_real_] = ACTIONS(7520),
    [anon_sym_NA_complex_] = ACTIONS(7520),
    [anon_sym_NA_character_] = ACTIONS(7520),
    [sym_dots] = ACTIONS(7520),
    [sym_dot_dot_i] = ACTIONS(7518),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7518),
    [sym__newline] = ACTIONS(7518),
    [sym__raw_string_literal] = ACTIONS(7518),
    [sym__external_else] = ACTIONS(7518),
    [sym__external_open_parenthesis] = ACTIONS(7518),
    [sym__external_open_brace] = ACTIONS(7518),
    [sym__external_open_bracket] = ACTIONS(7518),
    [sym__external_close_bracket] = ACTIONS(7518),
    [sym__external_open_bracket2] = ACTIONS(7518),
  },
  [2896] = {
    [sym_identifier] = ACTIONS(7516),
    [anon_sym_BSLASH] = ACTIONS(7514),
    [anon_sym_function] = ACTIONS(7516),
    [anon_sym_EQ] = ACTIONS(7516),
    [anon_sym_if] = ACTIONS(7516),
    [anon_sym_for] = ACTIONS(7516),
    [anon_sym_while] = ACTIONS(7516),
    [anon_sym_repeat] = ACTIONS(7516),
    [anon_sym_QMARK] = ACTIONS(7514),
    [anon_sym_TILDE] = ACTIONS(7514),
    [anon_sym_BANG] = ACTIONS(7516),
    [anon_sym_PLUS] = ACTIONS(7514),
    [anon_sym_DASH] = ACTIONS(7516),
    [anon_sym_LT_DASH] = ACTIONS(7514),
    [anon_sym_LT_LT_DASH] = ACTIONS(7514),
    [anon_sym_COLON_EQ] = ACTIONS(7514),
    [anon_sym_DASH_GT] = ACTIONS(7516),
    [anon_sym_DASH_GT_GT] = ACTIONS(7514),
    [anon_sym_PIPE] = ACTIONS(7516),
    [anon_sym_AMP] = ACTIONS(7516),
    [anon_sym_PIPE_PIPE] = ACTIONS(7514),
    [anon_sym_AMP_AMP] = ACTIONS(7514),
    [anon_sym_LT] = ACTIONS(7516),
    [anon_sym_LT_EQ] = ACTIONS(7514),
    [anon_sym_GT] = ACTIONS(7516),
    [anon_sym_GT_EQ] = ACTIONS(7514),
    [anon_sym_EQ_EQ] = ACTIONS(7514),
    [anon_sym_BANG_EQ] = ACTIONS(7514),
    [anon_sym_STAR] = ACTIONS(7516),
    [anon_sym_SLASH] = ACTIONS(7514),
    [anon_sym_STAR_STAR] = ACTIONS(7514),
    [anon_sym_CARET] = ACTIONS(7514),
    [aux_sym_binary_operator_token1] = ACTIONS(7514),
    [anon_sym_PIPE_GT] = ACTIONS(7514),
    [anon_sym_COLON] = ACTIONS(7516),
    [anon_sym_DOLLAR] = ACTIONS(7514),
    [anon_sym_AT] = ACTIONS(7514),
    [aux_sym__hex_literal_token1] = ACTIONS(7514),
    [sym__number_literal] = ACTIONS(7516),
    [anon_sym_SQUOTE] = ACTIONS(7514),
    [anon_sym_DQUOTE] = ACTIONS(7514),
    [sym_return] = ACTIONS(7516),
    [sym_next] = ACTIONS(7516),
    [sym_break] = ACTIONS(7516),
    [sym_true] = ACTIONS(7516),
    [sym_false] = ACTIONS(7516),
    [sym_null] = ACTIONS(7516),
    [sym_inf] = ACTIONS(7516),
    [sym_nan] = ACTIONS(7516),
    [anon_sym_NA] = ACTIONS(7516),
    [anon_sym_NA_integer_] = ACTIONS(7516),
    [anon_sym_NA_real_] = ACTIONS(7516),
    [anon_sym_NA_complex_] = ACTIONS(7516),
    [anon_sym_NA_character_] = ACTIONS(7516),
    [sym_dots] = ACTIONS(7516),
    [sym_dot_dot_i] = ACTIONS(7514),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7514),
    [sym__newline] = ACTIONS(7514),
    [sym__raw_string_literal] = ACTIONS(7514),
    [sym__external_else] = ACTIONS(7514),
    [sym__external_open_parenthesis] = ACTIONS(7514),
    [sym__external_open_brace] = ACTIONS(7514),
    [sym__external_open_bracket] = ACTIONS(7514),
    [sym__external_close_bracket] = ACTIONS(7514),
    [sym__external_open_bracket2] = ACTIONS(7514),
  },
  [2897] = {
    [sym_identifier] = ACTIONS(7556),
    [anon_sym_BSLASH] = ACTIONS(7554),
    [anon_sym_function] = ACTIONS(7556),
    [anon_sym_EQ] = ACTIONS(7556),
    [anon_sym_if] = ACTIONS(7556),
    [anon_sym_for] = ACTIONS(7556),
    [anon_sym_while] = ACTIONS(7556),
    [anon_sym_repeat] = ACTIONS(7556),
    [anon_sym_QMARK] = ACTIONS(7554),
    [anon_sym_TILDE] = ACTIONS(7554),
    [anon_sym_BANG] = ACTIONS(7556),
    [anon_sym_PLUS] = ACTIONS(7554),
    [anon_sym_DASH] = ACTIONS(7556),
    [anon_sym_LT_DASH] = ACTIONS(7554),
    [anon_sym_LT_LT_DASH] = ACTIONS(7554),
    [anon_sym_COLON_EQ] = ACTIONS(7554),
    [anon_sym_DASH_GT] = ACTIONS(7556),
    [anon_sym_DASH_GT_GT] = ACTIONS(7554),
    [anon_sym_PIPE] = ACTIONS(7556),
    [anon_sym_AMP] = ACTIONS(7556),
    [anon_sym_PIPE_PIPE] = ACTIONS(7554),
    [anon_sym_AMP_AMP] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(7556),
    [anon_sym_LT_EQ] = ACTIONS(7554),
    [anon_sym_GT] = ACTIONS(7556),
    [anon_sym_GT_EQ] = ACTIONS(7554),
    [anon_sym_EQ_EQ] = ACTIONS(7554),
    [anon_sym_BANG_EQ] = ACTIONS(7554),
    [anon_sym_STAR] = ACTIONS(7556),
    [anon_sym_SLASH] = ACTIONS(7554),
    [anon_sym_STAR_STAR] = ACTIONS(7554),
    [anon_sym_CARET] = ACTIONS(7554),
    [aux_sym_binary_operator_token1] = ACTIONS(7554),
    [anon_sym_PIPE_GT] = ACTIONS(7554),
    [anon_sym_COLON] = ACTIONS(7556),
    [anon_sym_DOLLAR] = ACTIONS(7554),
    [anon_sym_AT] = ACTIONS(7554),
    [aux_sym__hex_literal_token1] = ACTIONS(7554),
    [sym__number_literal] = ACTIONS(7556),
    [anon_sym_SQUOTE] = ACTIONS(7554),
    [anon_sym_DQUOTE] = ACTIONS(7554),
    [sym_return] = ACTIONS(7556),
    [sym_next] = ACTIONS(7556),
    [sym_break] = ACTIONS(7556),
    [sym_true] = ACTIONS(7556),
    [sym_false] = ACTIONS(7556),
    [sym_null] = ACTIONS(7556),
    [sym_inf] = ACTIONS(7556),
    [sym_nan] = ACTIONS(7556),
    [anon_sym_NA] = ACTIONS(7556),
    [anon_sym_NA_integer_] = ACTIONS(7556),
    [anon_sym_NA_real_] = ACTIONS(7556),
    [anon_sym_NA_complex_] = ACTIONS(7556),
    [anon_sym_NA_character_] = ACTIONS(7556),
    [sym_dots] = ACTIONS(7556),
    [sym_dot_dot_i] = ACTIONS(7554),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7554),
    [sym__newline] = ACTIONS(7554),
    [sym__raw_string_literal] = ACTIONS(7554),
    [sym__external_else] = ACTIONS(7554),
    [sym__external_open_parenthesis] = ACTIONS(7554),
    [sym__external_close_parenthesis] = ACTIONS(7554),
    [sym__external_open_brace] = ACTIONS(7554),
    [sym__external_open_bracket] = ACTIONS(7554),
    [sym__external_open_bracket2] = ACTIONS(7554),
  },
  [2898] = {
    [sym_identifier] = ACTIONS(5311),
    [anon_sym_BSLASH] = ACTIONS(5313),
    [anon_sym_function] = ACTIONS(5311),
    [anon_sym_EQ] = ACTIONS(5311),
    [anon_sym_if] = ACTIONS(5311),
    [anon_sym_for] = ACTIONS(5311),
    [anon_sym_while] = ACTIONS(5311),
    [anon_sym_repeat] = ACTIONS(5311),
    [anon_sym_QMARK] = ACTIONS(5313),
    [anon_sym_TILDE] = ACTIONS(5313),
    [anon_sym_BANG] = ACTIONS(5311),
    [anon_sym_PLUS] = ACTIONS(5313),
    [anon_sym_DASH] = ACTIONS(5311),
    [anon_sym_LT_DASH] = ACTIONS(5313),
    [anon_sym_LT_LT_DASH] = ACTIONS(5313),
    [anon_sym_COLON_EQ] = ACTIONS(5313),
    [anon_sym_DASH_GT] = ACTIONS(5311),
    [anon_sym_DASH_GT_GT] = ACTIONS(5313),
    [anon_sym_PIPE] = ACTIONS(5311),
    [anon_sym_AMP] = ACTIONS(5311),
    [anon_sym_PIPE_PIPE] = ACTIONS(5313),
    [anon_sym_AMP_AMP] = ACTIONS(5313),
    [anon_sym_LT] = ACTIONS(5311),
    [anon_sym_LT_EQ] = ACTIONS(5313),
    [anon_sym_GT] = ACTIONS(5311),
    [anon_sym_GT_EQ] = ACTIONS(5313),
    [anon_sym_EQ_EQ] = ACTIONS(5313),
    [anon_sym_BANG_EQ] = ACTIONS(5313),
    [anon_sym_STAR] = ACTIONS(5311),
    [anon_sym_SLASH] = ACTIONS(5313),
    [anon_sym_STAR_STAR] = ACTIONS(5313),
    [anon_sym_CARET] = ACTIONS(5313),
    [aux_sym_binary_operator_token1] = ACTIONS(5313),
    [anon_sym_PIPE_GT] = ACTIONS(5313),
    [anon_sym_COLON] = ACTIONS(5311),
    [anon_sym_DOLLAR] = ACTIONS(5313),
    [anon_sym_AT] = ACTIONS(5313),
    [aux_sym__hex_literal_token1] = ACTIONS(5313),
    [sym__number_literal] = ACTIONS(5311),
    [anon_sym_SQUOTE] = ACTIONS(5313),
    [anon_sym_DQUOTE] = ACTIONS(5313),
    [sym_return] = ACTIONS(5311),
    [sym_next] = ACTIONS(5311),
    [sym_break] = ACTIONS(5311),
    [sym_true] = ACTIONS(5311),
    [sym_false] = ACTIONS(5311),
    [sym_null] = ACTIONS(5311),
    [sym_inf] = ACTIONS(5311),
    [sym_nan] = ACTIONS(5311),
    [anon_sym_NA] = ACTIONS(5311),
    [anon_sym_NA_integer_] = ACTIONS(5311),
    [anon_sym_NA_real_] = ACTIONS(5311),
    [anon_sym_NA_complex_] = ACTIONS(5311),
    [anon_sym_NA_character_] = ACTIONS(5311),
    [sym_dots] = ACTIONS(5311),
    [sym_dot_dot_i] = ACTIONS(5313),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5313),
    [sym__newline] = ACTIONS(5313),
    [sym__raw_string_literal] = ACTIONS(5313),
    [sym__external_open_parenthesis] = ACTIONS(5313),
    [sym__external_close_parenthesis] = ACTIONS(5313),
    [sym__external_open_brace] = ACTIONS(5313),
    [sym__external_open_bracket] = ACTIONS(5313),
    [sym__external_close_bracket] = ACTIONS(5313),
    [sym__external_open_bracket2] = ACTIONS(5313),
  },
  [2899] = {
    [sym_identifier] = ACTIONS(7494),
    [anon_sym_BSLASH] = ACTIONS(7492),
    [anon_sym_function] = ACTIONS(7494),
    [anon_sym_EQ] = ACTIONS(7494),
    [anon_sym_if] = ACTIONS(7494),
    [anon_sym_for] = ACTIONS(7494),
    [anon_sym_while] = ACTIONS(7494),
    [anon_sym_repeat] = ACTIONS(7494),
    [anon_sym_QMARK] = ACTIONS(7492),
    [anon_sym_TILDE] = ACTIONS(7492),
    [anon_sym_BANG] = ACTIONS(7494),
    [anon_sym_PLUS] = ACTIONS(7492),
    [anon_sym_DASH] = ACTIONS(7494),
    [anon_sym_LT_DASH] = ACTIONS(7492),
    [anon_sym_LT_LT_DASH] = ACTIONS(7492),
    [anon_sym_COLON_EQ] = ACTIONS(7492),
    [anon_sym_DASH_GT] = ACTIONS(7494),
    [anon_sym_DASH_GT_GT] = ACTIONS(7492),
    [anon_sym_PIPE] = ACTIONS(7494),
    [anon_sym_AMP] = ACTIONS(7494),
    [anon_sym_PIPE_PIPE] = ACTIONS(7492),
    [anon_sym_AMP_AMP] = ACTIONS(7492),
    [anon_sym_LT] = ACTIONS(7494),
    [anon_sym_LT_EQ] = ACTIONS(7492),
    [anon_sym_GT] = ACTIONS(7494),
    [anon_sym_GT_EQ] = ACTIONS(7492),
    [anon_sym_EQ_EQ] = ACTIONS(7492),
    [anon_sym_BANG_EQ] = ACTIONS(7492),
    [anon_sym_STAR] = ACTIONS(7494),
    [anon_sym_SLASH] = ACTIONS(7492),
    [anon_sym_STAR_STAR] = ACTIONS(7492),
    [anon_sym_CARET] = ACTIONS(7492),
    [aux_sym_binary_operator_token1] = ACTIONS(7492),
    [anon_sym_PIPE_GT] = ACTIONS(7492),
    [anon_sym_COLON] = ACTIONS(7494),
    [anon_sym_DOLLAR] = ACTIONS(7492),
    [anon_sym_AT] = ACTIONS(7492),
    [aux_sym__hex_literal_token1] = ACTIONS(7492),
    [sym__number_literal] = ACTIONS(7494),
    [anon_sym_SQUOTE] = ACTIONS(7492),
    [anon_sym_DQUOTE] = ACTIONS(7492),
    [sym_return] = ACTIONS(7494),
    [sym_next] = ACTIONS(7494),
    [sym_break] = ACTIONS(7494),
    [sym_true] = ACTIONS(7494),
    [sym_false] = ACTIONS(7494),
    [sym_null] = ACTIONS(7494),
    [sym_inf] = ACTIONS(7494),
    [sym_nan] = ACTIONS(7494),
    [anon_sym_NA] = ACTIONS(7494),
    [anon_sym_NA_integer_] = ACTIONS(7494),
    [anon_sym_NA_real_] = ACTIONS(7494),
    [anon_sym_NA_complex_] = ACTIONS(7494),
    [anon_sym_NA_character_] = ACTIONS(7494),
    [sym_dots] = ACTIONS(7494),
    [sym_dot_dot_i] = ACTIONS(7492),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7492),
    [sym__newline] = ACTIONS(7492),
    [sym__raw_string_literal] = ACTIONS(7492),
    [sym__external_else] = ACTIONS(7492),
    [sym__external_open_parenthesis] = ACTIONS(7492),
    [sym__external_open_brace] = ACTIONS(7492),
    [sym__external_open_bracket] = ACTIONS(7492),
    [sym__external_close_bracket] = ACTIONS(7492),
    [sym__external_open_bracket2] = ACTIONS(7492),
  },
  [2900] = {
    [ts_builtin_sym_end] = ACTIONS(7510),
    [sym_identifier] = ACTIONS(7512),
    [anon_sym_BSLASH] = ACTIONS(7510),
    [anon_sym_function] = ACTIONS(7512),
    [anon_sym_EQ] = ACTIONS(7512),
    [anon_sym_if] = ACTIONS(7512),
    [anon_sym_for] = ACTIONS(7512),
    [anon_sym_while] = ACTIONS(7512),
    [anon_sym_repeat] = ACTIONS(7512),
    [anon_sym_QMARK] = ACTIONS(7510),
    [anon_sym_TILDE] = ACTIONS(7510),
    [anon_sym_BANG] = ACTIONS(7512),
    [anon_sym_PLUS] = ACTIONS(7510),
    [anon_sym_DASH] = ACTIONS(7512),
    [anon_sym_LT_DASH] = ACTIONS(7510),
    [anon_sym_LT_LT_DASH] = ACTIONS(7510),
    [anon_sym_COLON_EQ] = ACTIONS(7510),
    [anon_sym_DASH_GT] = ACTIONS(7512),
    [anon_sym_DASH_GT_GT] = ACTIONS(7510),
    [anon_sym_PIPE] = ACTIONS(7512),
    [anon_sym_AMP] = ACTIONS(7512),
    [anon_sym_PIPE_PIPE] = ACTIONS(7510),
    [anon_sym_AMP_AMP] = ACTIONS(7510),
    [anon_sym_LT] = ACTIONS(7512),
    [anon_sym_LT_EQ] = ACTIONS(7510),
    [anon_sym_GT] = ACTIONS(7512),
    [anon_sym_GT_EQ] = ACTIONS(7510),
    [anon_sym_EQ_EQ] = ACTIONS(7510),
    [anon_sym_BANG_EQ] = ACTIONS(7510),
    [anon_sym_STAR] = ACTIONS(7512),
    [anon_sym_SLASH] = ACTIONS(7510),
    [anon_sym_STAR_STAR] = ACTIONS(7510),
    [anon_sym_CARET] = ACTIONS(7510),
    [aux_sym_binary_operator_token1] = ACTIONS(7510),
    [anon_sym_PIPE_GT] = ACTIONS(7510),
    [anon_sym_COLON] = ACTIONS(7512),
    [anon_sym_DOLLAR] = ACTIONS(7510),
    [anon_sym_AT] = ACTIONS(7510),
    [aux_sym__hex_literal_token1] = ACTIONS(7510),
    [sym__number_literal] = ACTIONS(7512),
    [anon_sym_SQUOTE] = ACTIONS(7510),
    [anon_sym_DQUOTE] = ACTIONS(7510),
    [sym_return] = ACTIONS(7512),
    [sym_next] = ACTIONS(7512),
    [sym_break] = ACTIONS(7512),
    [sym_true] = ACTIONS(7512),
    [sym_false] = ACTIONS(7512),
    [sym_null] = ACTIONS(7512),
    [sym_inf] = ACTIONS(7512),
    [sym_nan] = ACTIONS(7512),
    [anon_sym_NA] = ACTIONS(7512),
    [anon_sym_NA_integer_] = ACTIONS(7512),
    [anon_sym_NA_real_] = ACTIONS(7512),
    [anon_sym_NA_complex_] = ACTIONS(7512),
    [anon_sym_NA_character_] = ACTIONS(7512),
    [sym_dots] = ACTIONS(7512),
    [sym_dot_dot_i] = ACTIONS(7510),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7510),
    [sym__semicolon] = ACTIONS(7510),
    [sym__raw_string_literal] = ACTIONS(7510),
    [sym__external_open_parenthesis] = ACTIONS(7510),
    [sym__external_open_brace] = ACTIONS(7510),
    [sym__external_close_brace] = ACTIONS(7510),
    [sym__external_open_bracket] = ACTIONS(7510),
    [sym__external_open_bracket2] = ACTIONS(7510),
  },
  [2901] = {
    [aux_sym_function_definition_repeat1] = STATE(2901),
    [sym_identifier] = ACTIONS(7419),
    [anon_sym_BSLASH] = ACTIONS(7417),
    [anon_sym_function] = ACTIONS(7419),
    [anon_sym_EQ] = ACTIONS(7419),
    [anon_sym_if] = ACTIONS(7419),
    [anon_sym_for] = ACTIONS(7419),
    [anon_sym_while] = ACTIONS(7419),
    [anon_sym_repeat] = ACTIONS(7419),
    [anon_sym_QMARK] = ACTIONS(7417),
    [anon_sym_TILDE] = ACTIONS(7417),
    [anon_sym_BANG] = ACTIONS(7419),
    [anon_sym_PLUS] = ACTIONS(7417),
    [anon_sym_DASH] = ACTIONS(7419),
    [anon_sym_LT_DASH] = ACTIONS(7417),
    [anon_sym_LT_LT_DASH] = ACTIONS(7417),
    [anon_sym_COLON_EQ] = ACTIONS(7417),
    [anon_sym_DASH_GT] = ACTIONS(7419),
    [anon_sym_DASH_GT_GT] = ACTIONS(7417),
    [anon_sym_PIPE] = ACTIONS(7419),
    [anon_sym_AMP] = ACTIONS(7419),
    [anon_sym_PIPE_PIPE] = ACTIONS(7417),
    [anon_sym_AMP_AMP] = ACTIONS(7417),
    [anon_sym_LT] = ACTIONS(7419),
    [anon_sym_LT_EQ] = ACTIONS(7417),
    [anon_sym_GT] = ACTIONS(7419),
    [anon_sym_GT_EQ] = ACTIONS(7417),
    [anon_sym_EQ_EQ] = ACTIONS(7417),
    [anon_sym_BANG_EQ] = ACTIONS(7417),
    [anon_sym_STAR] = ACTIONS(7419),
    [anon_sym_SLASH] = ACTIONS(7417),
    [anon_sym_STAR_STAR] = ACTIONS(7417),
    [anon_sym_CARET] = ACTIONS(7417),
    [aux_sym_binary_operator_token1] = ACTIONS(7417),
    [anon_sym_PIPE_GT] = ACTIONS(7417),
    [anon_sym_COLON] = ACTIONS(7419),
    [anon_sym_DOLLAR] = ACTIONS(7417),
    [anon_sym_AT] = ACTIONS(7417),
    [aux_sym__hex_literal_token1] = ACTIONS(7417),
    [sym__number_literal] = ACTIONS(7419),
    [anon_sym_SQUOTE] = ACTIONS(7417),
    [anon_sym_DQUOTE] = ACTIONS(7417),
    [sym_return] = ACTIONS(7419),
    [sym_next] = ACTIONS(7419),
    [sym_break] = ACTIONS(7419),
    [sym_true] = ACTIONS(7419),
    [sym_false] = ACTIONS(7419),
    [sym_null] = ACTIONS(7419),
    [sym_inf] = ACTIONS(7419),
    [sym_nan] = ACTIONS(7419),
    [anon_sym_NA] = ACTIONS(7419),
    [anon_sym_NA_integer_] = ACTIONS(7419),
    [anon_sym_NA_real_] = ACTIONS(7419),
    [anon_sym_NA_complex_] = ACTIONS(7419),
    [anon_sym_NA_character_] = ACTIONS(7419),
    [sym_dots] = ACTIONS(7419),
    [sym_dot_dot_i] = ACTIONS(7417),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7417),
    [sym__newline] = ACTIONS(7778),
    [sym__raw_string_literal] = ACTIONS(7417),
    [sym__external_open_parenthesis] = ACTIONS(7417),
    [sym__external_open_brace] = ACTIONS(7417),
    [sym__external_open_bracket] = ACTIONS(7417),
    [sym__external_close_bracket] = ACTIONS(7417),
    [sym__external_open_bracket2] = ACTIONS(7417),
  },
  [2902] = {
    [ts_builtin_sym_end] = ACTIONS(7550),
    [sym_identifier] = ACTIONS(7552),
    [anon_sym_BSLASH] = ACTIONS(7550),
    [anon_sym_function] = ACTIONS(7552),
    [anon_sym_EQ] = ACTIONS(7552),
    [anon_sym_if] = ACTIONS(7552),
    [anon_sym_for] = ACTIONS(7552),
    [anon_sym_while] = ACTIONS(7552),
    [anon_sym_repeat] = ACTIONS(7552),
    [anon_sym_QMARK] = ACTIONS(7550),
    [anon_sym_TILDE] = ACTIONS(7550),
    [anon_sym_BANG] = ACTIONS(7552),
    [anon_sym_PLUS] = ACTIONS(7550),
    [anon_sym_DASH] = ACTIONS(7552),
    [anon_sym_LT_DASH] = ACTIONS(7550),
    [anon_sym_LT_LT_DASH] = ACTIONS(7550),
    [anon_sym_COLON_EQ] = ACTIONS(7550),
    [anon_sym_DASH_GT] = ACTIONS(7552),
    [anon_sym_DASH_GT_GT] = ACTIONS(7550),
    [anon_sym_PIPE] = ACTIONS(7552),
    [anon_sym_AMP] = ACTIONS(7552),
    [anon_sym_PIPE_PIPE] = ACTIONS(7550),
    [anon_sym_AMP_AMP] = ACTIONS(7550),
    [anon_sym_LT] = ACTIONS(7552),
    [anon_sym_LT_EQ] = ACTIONS(7550),
    [anon_sym_GT] = ACTIONS(7552),
    [anon_sym_GT_EQ] = ACTIONS(7550),
    [anon_sym_EQ_EQ] = ACTIONS(7550),
    [anon_sym_BANG_EQ] = ACTIONS(7550),
    [anon_sym_STAR] = ACTIONS(7552),
    [anon_sym_SLASH] = ACTIONS(7550),
    [anon_sym_STAR_STAR] = ACTIONS(7550),
    [anon_sym_CARET] = ACTIONS(7550),
    [aux_sym_binary_operator_token1] = ACTIONS(7550),
    [anon_sym_PIPE_GT] = ACTIONS(7550),
    [anon_sym_COLON] = ACTIONS(7552),
    [anon_sym_DOLLAR] = ACTIONS(7550),
    [anon_sym_AT] = ACTIONS(7550),
    [aux_sym__hex_literal_token1] = ACTIONS(7550),
    [sym__number_literal] = ACTIONS(7552),
    [anon_sym_SQUOTE] = ACTIONS(7550),
    [anon_sym_DQUOTE] = ACTIONS(7550),
    [sym_return] = ACTIONS(7552),
    [sym_next] = ACTIONS(7552),
    [sym_break] = ACTIONS(7552),
    [sym_true] = ACTIONS(7552),
    [sym_false] = ACTIONS(7552),
    [sym_null] = ACTIONS(7552),
    [sym_inf] = ACTIONS(7552),
    [sym_nan] = ACTIONS(7552),
    [anon_sym_NA] = ACTIONS(7552),
    [anon_sym_NA_integer_] = ACTIONS(7552),
    [anon_sym_NA_real_] = ACTIONS(7552),
    [anon_sym_NA_complex_] = ACTIONS(7552),
    [anon_sym_NA_character_] = ACTIONS(7552),
    [sym_dots] = ACTIONS(7552),
    [sym_dot_dot_i] = ACTIONS(7550),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7550),
    [sym__semicolon] = ACTIONS(7550),
    [sym__raw_string_literal] = ACTIONS(7550),
    [sym__external_else] = ACTIONS(7550),
    [sym__external_open_parenthesis] = ACTIONS(7550),
    [sym__external_open_brace] = ACTIONS(7550),
    [sym__external_open_bracket] = ACTIONS(7550),
    [sym__external_open_bracket2] = ACTIONS(7550),
  },
  [2903] = {
    [ts_builtin_sym_end] = ACTIONS(7510),
    [sym_identifier] = ACTIONS(7512),
    [anon_sym_BSLASH] = ACTIONS(7510),
    [anon_sym_function] = ACTIONS(7512),
    [anon_sym_EQ] = ACTIONS(7512),
    [anon_sym_if] = ACTIONS(7512),
    [anon_sym_for] = ACTIONS(7512),
    [anon_sym_while] = ACTIONS(7512),
    [anon_sym_repeat] = ACTIONS(7512),
    [anon_sym_QMARK] = ACTIONS(7510),
    [anon_sym_TILDE] = ACTIONS(7510),
    [anon_sym_BANG] = ACTIONS(7512),
    [anon_sym_PLUS] = ACTIONS(7510),
    [anon_sym_DASH] = ACTIONS(7512),
    [anon_sym_LT_DASH] = ACTIONS(7510),
    [anon_sym_LT_LT_DASH] = ACTIONS(7510),
    [anon_sym_COLON_EQ] = ACTIONS(7510),
    [anon_sym_DASH_GT] = ACTIONS(7512),
    [anon_sym_DASH_GT_GT] = ACTIONS(7510),
    [anon_sym_PIPE] = ACTIONS(7512),
    [anon_sym_AMP] = ACTIONS(7512),
    [anon_sym_PIPE_PIPE] = ACTIONS(7510),
    [anon_sym_AMP_AMP] = ACTIONS(7510),
    [anon_sym_LT] = ACTIONS(7512),
    [anon_sym_LT_EQ] = ACTIONS(7510),
    [anon_sym_GT] = ACTIONS(7512),
    [anon_sym_GT_EQ] = ACTIONS(7510),
    [anon_sym_EQ_EQ] = ACTIONS(7510),
    [anon_sym_BANG_EQ] = ACTIONS(7510),
    [anon_sym_STAR] = ACTIONS(7512),
    [anon_sym_SLASH] = ACTIONS(7510),
    [anon_sym_STAR_STAR] = ACTIONS(7510),
    [anon_sym_CARET] = ACTIONS(7510),
    [aux_sym_binary_operator_token1] = ACTIONS(7510),
    [anon_sym_PIPE_GT] = ACTIONS(7510),
    [anon_sym_COLON] = ACTIONS(7512),
    [anon_sym_DOLLAR] = ACTIONS(7510),
    [anon_sym_AT] = ACTIONS(7510),
    [aux_sym__hex_literal_token1] = ACTIONS(7510),
    [sym__number_literal] = ACTIONS(7512),
    [anon_sym_SQUOTE] = ACTIONS(7510),
    [anon_sym_DQUOTE] = ACTIONS(7510),
    [sym_return] = ACTIONS(7512),
    [sym_next] = ACTIONS(7512),
    [sym_break] = ACTIONS(7512),
    [sym_true] = ACTIONS(7512),
    [sym_false] = ACTIONS(7512),
    [sym_null] = ACTIONS(7512),
    [sym_inf] = ACTIONS(7512),
    [sym_nan] = ACTIONS(7512),
    [anon_sym_NA] = ACTIONS(7512),
    [anon_sym_NA_integer_] = ACTIONS(7512),
    [anon_sym_NA_real_] = ACTIONS(7512),
    [anon_sym_NA_complex_] = ACTIONS(7512),
    [anon_sym_NA_character_] = ACTIONS(7512),
    [sym_dots] = ACTIONS(7512),
    [sym_dot_dot_i] = ACTIONS(7510),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7510),
    [sym__semicolon] = ACTIONS(7510),
    [sym__raw_string_literal] = ACTIONS(7510),
    [sym__external_open_parenthesis] = ACTIONS(7510),
    [sym__external_close_parenthesis] = ACTIONS(7510),
    [sym__external_open_brace] = ACTIONS(7510),
    [sym__external_open_bracket] = ACTIONS(7510),
    [sym__external_open_bracket2] = ACTIONS(7510),
  },
  [2904] = {
    [ts_builtin_sym_end] = ACTIONS(7514),
    [sym_identifier] = ACTIONS(7516),
    [anon_sym_BSLASH] = ACTIONS(7514),
    [anon_sym_function] = ACTIONS(7516),
    [anon_sym_EQ] = ACTIONS(7516),
    [anon_sym_if] = ACTIONS(7516),
    [anon_sym_for] = ACTIONS(7516),
    [anon_sym_while] = ACTIONS(7516),
    [anon_sym_repeat] = ACTIONS(7516),
    [anon_sym_QMARK] = ACTIONS(7514),
    [anon_sym_TILDE] = ACTIONS(7514),
    [anon_sym_BANG] = ACTIONS(7516),
    [anon_sym_PLUS] = ACTIONS(7514),
    [anon_sym_DASH] = ACTIONS(7516),
    [anon_sym_LT_DASH] = ACTIONS(7514),
    [anon_sym_LT_LT_DASH] = ACTIONS(7514),
    [anon_sym_COLON_EQ] = ACTIONS(7514),
    [anon_sym_DASH_GT] = ACTIONS(7516),
    [anon_sym_DASH_GT_GT] = ACTIONS(7514),
    [anon_sym_PIPE] = ACTIONS(7516),
    [anon_sym_AMP] = ACTIONS(7516),
    [anon_sym_PIPE_PIPE] = ACTIONS(7514),
    [anon_sym_AMP_AMP] = ACTIONS(7514),
    [anon_sym_LT] = ACTIONS(7516),
    [anon_sym_LT_EQ] = ACTIONS(7514),
    [anon_sym_GT] = ACTIONS(7516),
    [anon_sym_GT_EQ] = ACTIONS(7514),
    [anon_sym_EQ_EQ] = ACTIONS(7514),
    [anon_sym_BANG_EQ] = ACTIONS(7514),
    [anon_sym_STAR] = ACTIONS(7516),
    [anon_sym_SLASH] = ACTIONS(7514),
    [anon_sym_STAR_STAR] = ACTIONS(7514),
    [anon_sym_CARET] = ACTIONS(7514),
    [aux_sym_binary_operator_token1] = ACTIONS(7514),
    [anon_sym_PIPE_GT] = ACTIONS(7514),
    [anon_sym_COLON] = ACTIONS(7516),
    [anon_sym_DOLLAR] = ACTIONS(7514),
    [anon_sym_AT] = ACTIONS(7514),
    [aux_sym__hex_literal_token1] = ACTIONS(7514),
    [sym__number_literal] = ACTIONS(7516),
    [anon_sym_SQUOTE] = ACTIONS(7514),
    [anon_sym_DQUOTE] = ACTIONS(7514),
    [sym_return] = ACTIONS(7516),
    [sym_next] = ACTIONS(7516),
    [sym_break] = ACTIONS(7516),
    [sym_true] = ACTIONS(7516),
    [sym_false] = ACTIONS(7516),
    [sym_null] = ACTIONS(7516),
    [sym_inf] = ACTIONS(7516),
    [sym_nan] = ACTIONS(7516),
    [anon_sym_NA] = ACTIONS(7516),
    [anon_sym_NA_integer_] = ACTIONS(7516),
    [anon_sym_NA_real_] = ACTIONS(7516),
    [anon_sym_NA_complex_] = ACTIONS(7516),
    [anon_sym_NA_character_] = ACTIONS(7516),
    [sym_dots] = ACTIONS(7516),
    [sym_dot_dot_i] = ACTIONS(7514),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7514),
    [sym__semicolon] = ACTIONS(7514),
    [sym__raw_string_literal] = ACTIONS(7514),
    [sym__external_open_parenthesis] = ACTIONS(7514),
    [sym__external_close_parenthesis] = ACTIONS(7514),
    [sym__external_open_brace] = ACTIONS(7514),
    [sym__external_open_bracket] = ACTIONS(7514),
    [sym__external_open_bracket2] = ACTIONS(7514),
  },
  [2905] = {
    [sym_identifier] = ACTIONS(7563),
    [anon_sym_BSLASH] = ACTIONS(7561),
    [anon_sym_function] = ACTIONS(7563),
    [anon_sym_EQ] = ACTIONS(7563),
    [anon_sym_if] = ACTIONS(7563),
    [anon_sym_for] = ACTIONS(7563),
    [anon_sym_while] = ACTIONS(7563),
    [anon_sym_repeat] = ACTIONS(7563),
    [anon_sym_QMARK] = ACTIONS(7561),
    [anon_sym_TILDE] = ACTIONS(7561),
    [anon_sym_BANG] = ACTIONS(7563),
    [anon_sym_PLUS] = ACTIONS(7561),
    [anon_sym_DASH] = ACTIONS(7563),
    [anon_sym_LT_DASH] = ACTIONS(7561),
    [anon_sym_LT_LT_DASH] = ACTIONS(7561),
    [anon_sym_COLON_EQ] = ACTIONS(7561),
    [anon_sym_DASH_GT] = ACTIONS(7563),
    [anon_sym_DASH_GT_GT] = ACTIONS(7561),
    [anon_sym_PIPE] = ACTIONS(7563),
    [anon_sym_AMP] = ACTIONS(7563),
    [anon_sym_PIPE_PIPE] = ACTIONS(7561),
    [anon_sym_AMP_AMP] = ACTIONS(7561),
    [anon_sym_LT] = ACTIONS(7563),
    [anon_sym_LT_EQ] = ACTIONS(7561),
    [anon_sym_GT] = ACTIONS(7563),
    [anon_sym_GT_EQ] = ACTIONS(7561),
    [anon_sym_EQ_EQ] = ACTIONS(7561),
    [anon_sym_BANG_EQ] = ACTIONS(7561),
    [anon_sym_STAR] = ACTIONS(7563),
    [anon_sym_SLASH] = ACTIONS(7561),
    [anon_sym_STAR_STAR] = ACTIONS(7561),
    [anon_sym_CARET] = ACTIONS(7561),
    [aux_sym_binary_operator_token1] = ACTIONS(7561),
    [anon_sym_PIPE_GT] = ACTIONS(7561),
    [anon_sym_COLON] = ACTIONS(7563),
    [anon_sym_DOLLAR] = ACTIONS(7561),
    [anon_sym_AT] = ACTIONS(7561),
    [aux_sym__hex_literal_token1] = ACTIONS(7561),
    [sym__number_literal] = ACTIONS(7563),
    [anon_sym_SQUOTE] = ACTIONS(7561),
    [anon_sym_DQUOTE] = ACTIONS(7561),
    [sym_return] = ACTIONS(7563),
    [sym_next] = ACTIONS(7563),
    [sym_break] = ACTIONS(7563),
    [sym_true] = ACTIONS(7563),
    [sym_false] = ACTIONS(7563),
    [sym_null] = ACTIONS(7563),
    [sym_inf] = ACTIONS(7563),
    [sym_nan] = ACTIONS(7563),
    [anon_sym_NA] = ACTIONS(7563),
    [anon_sym_NA_integer_] = ACTIONS(7563),
    [anon_sym_NA_real_] = ACTIONS(7563),
    [anon_sym_NA_complex_] = ACTIONS(7563),
    [anon_sym_NA_character_] = ACTIONS(7563),
    [sym_dots] = ACTIONS(7563),
    [sym_dot_dot_i] = ACTIONS(7561),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7561),
    [sym__newline] = ACTIONS(7561),
    [sym__raw_string_literal] = ACTIONS(7561),
    [sym__external_else] = ACTIONS(7561),
    [sym__external_open_parenthesis] = ACTIONS(7561),
    [sym__external_close_parenthesis] = ACTIONS(7561),
    [sym__external_open_brace] = ACTIONS(7561),
    [sym__external_open_bracket] = ACTIONS(7561),
    [sym__external_open_bracket2] = ACTIONS(7561),
  },
  [2906] = {
    [ts_builtin_sym_end] = ACTIONS(7522),
    [sym_identifier] = ACTIONS(7524),
    [anon_sym_BSLASH] = ACTIONS(7522),
    [anon_sym_function] = ACTIONS(7524),
    [anon_sym_EQ] = ACTIONS(7524),
    [anon_sym_if] = ACTIONS(7524),
    [anon_sym_for] = ACTIONS(7524),
    [anon_sym_while] = ACTIONS(7524),
    [anon_sym_repeat] = ACTIONS(7524),
    [anon_sym_QMARK] = ACTIONS(7522),
    [anon_sym_TILDE] = ACTIONS(7522),
    [anon_sym_BANG] = ACTIONS(7524),
    [anon_sym_PLUS] = ACTIONS(7522),
    [anon_sym_DASH] = ACTIONS(7524),
    [anon_sym_LT_DASH] = ACTIONS(7522),
    [anon_sym_LT_LT_DASH] = ACTIONS(7522),
    [anon_sym_COLON_EQ] = ACTIONS(7522),
    [anon_sym_DASH_GT] = ACTIONS(7524),
    [anon_sym_DASH_GT_GT] = ACTIONS(7522),
    [anon_sym_PIPE] = ACTIONS(7524),
    [anon_sym_AMP] = ACTIONS(7524),
    [anon_sym_PIPE_PIPE] = ACTIONS(7522),
    [anon_sym_AMP_AMP] = ACTIONS(7522),
    [anon_sym_LT] = ACTIONS(7524),
    [anon_sym_LT_EQ] = ACTIONS(7522),
    [anon_sym_GT] = ACTIONS(7524),
    [anon_sym_GT_EQ] = ACTIONS(7522),
    [anon_sym_EQ_EQ] = ACTIONS(7522),
    [anon_sym_BANG_EQ] = ACTIONS(7522),
    [anon_sym_STAR] = ACTIONS(7524),
    [anon_sym_SLASH] = ACTIONS(7522),
    [anon_sym_STAR_STAR] = ACTIONS(7522),
    [anon_sym_CARET] = ACTIONS(7522),
    [aux_sym_binary_operator_token1] = ACTIONS(7522),
    [anon_sym_PIPE_GT] = ACTIONS(7522),
    [anon_sym_COLON] = ACTIONS(7524),
    [anon_sym_DOLLAR] = ACTIONS(7522),
    [anon_sym_AT] = ACTIONS(7522),
    [aux_sym__hex_literal_token1] = ACTIONS(7522),
    [sym__number_literal] = ACTIONS(7524),
    [anon_sym_SQUOTE] = ACTIONS(7522),
    [anon_sym_DQUOTE] = ACTIONS(7522),
    [sym_return] = ACTIONS(7524),
    [sym_next] = ACTIONS(7524),
    [sym_break] = ACTIONS(7524),
    [sym_true] = ACTIONS(7524),
    [sym_false] = ACTIONS(7524),
    [sym_null] = ACTIONS(7524),
    [sym_inf] = ACTIONS(7524),
    [sym_nan] = ACTIONS(7524),
    [anon_sym_NA] = ACTIONS(7524),
    [anon_sym_NA_integer_] = ACTIONS(7524),
    [anon_sym_NA_real_] = ACTIONS(7524),
    [anon_sym_NA_complex_] = ACTIONS(7524),
    [anon_sym_NA_character_] = ACTIONS(7524),
    [sym_dots] = ACTIONS(7524),
    [sym_dot_dot_i] = ACTIONS(7522),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7522),
    [sym__semicolon] = ACTIONS(7522),
    [sym__raw_string_literal] = ACTIONS(7522),
    [sym__external_else] = ACTIONS(7522),
    [sym__external_open_parenthesis] = ACTIONS(7522),
    [sym__external_open_brace] = ACTIONS(7522),
    [sym__external_open_bracket] = ACTIONS(7522),
    [sym__external_open_bracket2] = ACTIONS(7522),
  },
  [2907] = {
    [ts_builtin_sym_end] = ACTIONS(7550),
    [sym_identifier] = ACTIONS(7552),
    [anon_sym_BSLASH] = ACTIONS(7550),
    [anon_sym_function] = ACTIONS(7552),
    [anon_sym_EQ] = ACTIONS(7552),
    [anon_sym_if] = ACTIONS(7552),
    [anon_sym_for] = ACTIONS(7552),
    [anon_sym_while] = ACTIONS(7552),
    [anon_sym_repeat] = ACTIONS(7552),
    [anon_sym_QMARK] = ACTIONS(7550),
    [anon_sym_TILDE] = ACTIONS(7550),
    [anon_sym_BANG] = ACTIONS(7552),
    [anon_sym_PLUS] = ACTIONS(7550),
    [anon_sym_DASH] = ACTIONS(7552),
    [anon_sym_LT_DASH] = ACTIONS(7550),
    [anon_sym_LT_LT_DASH] = ACTIONS(7550),
    [anon_sym_COLON_EQ] = ACTIONS(7550),
    [anon_sym_DASH_GT] = ACTIONS(7552),
    [anon_sym_DASH_GT_GT] = ACTIONS(7550),
    [anon_sym_PIPE] = ACTIONS(7552),
    [anon_sym_AMP] = ACTIONS(7552),
    [anon_sym_PIPE_PIPE] = ACTIONS(7550),
    [anon_sym_AMP_AMP] = ACTIONS(7550),
    [anon_sym_LT] = ACTIONS(7552),
    [anon_sym_LT_EQ] = ACTIONS(7550),
    [anon_sym_GT] = ACTIONS(7552),
    [anon_sym_GT_EQ] = ACTIONS(7550),
    [anon_sym_EQ_EQ] = ACTIONS(7550),
    [anon_sym_BANG_EQ] = ACTIONS(7550),
    [anon_sym_STAR] = ACTIONS(7552),
    [anon_sym_SLASH] = ACTIONS(7550),
    [anon_sym_STAR_STAR] = ACTIONS(7550),
    [anon_sym_CARET] = ACTIONS(7550),
    [aux_sym_binary_operator_token1] = ACTIONS(7550),
    [anon_sym_PIPE_GT] = ACTIONS(7550),
    [anon_sym_COLON] = ACTIONS(7552),
    [anon_sym_DOLLAR] = ACTIONS(7550),
    [anon_sym_AT] = ACTIONS(7550),
    [aux_sym__hex_literal_token1] = ACTIONS(7550),
    [sym__number_literal] = ACTIONS(7552),
    [anon_sym_SQUOTE] = ACTIONS(7550),
    [anon_sym_DQUOTE] = ACTIONS(7550),
    [sym_return] = ACTIONS(7552),
    [sym_next] = ACTIONS(7552),
    [sym_break] = ACTIONS(7552),
    [sym_true] = ACTIONS(7552),
    [sym_false] = ACTIONS(7552),
    [sym_null] = ACTIONS(7552),
    [sym_inf] = ACTIONS(7552),
    [sym_nan] = ACTIONS(7552),
    [anon_sym_NA] = ACTIONS(7552),
    [anon_sym_NA_integer_] = ACTIONS(7552),
    [anon_sym_NA_real_] = ACTIONS(7552),
    [anon_sym_NA_complex_] = ACTIONS(7552),
    [anon_sym_NA_character_] = ACTIONS(7552),
    [sym_dots] = ACTIONS(7552),
    [sym_dot_dot_i] = ACTIONS(7550),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7550),
    [sym__semicolon] = ACTIONS(7550),
    [sym__raw_string_literal] = ACTIONS(7550),
    [sym__external_open_parenthesis] = ACTIONS(7550),
    [sym__external_close_parenthesis] = ACTIONS(7550),
    [sym__external_open_brace] = ACTIONS(7550),
    [sym__external_open_bracket] = ACTIONS(7550),
    [sym__external_open_bracket2] = ACTIONS(7550),
  },
  [2908] = {
    [sym_identifier] = ACTIONS(7516),
    [anon_sym_BSLASH] = ACTIONS(7514),
    [anon_sym_function] = ACTIONS(7516),
    [anon_sym_EQ] = ACTIONS(7516),
    [anon_sym_if] = ACTIONS(7516),
    [anon_sym_for] = ACTIONS(7516),
    [anon_sym_while] = ACTIONS(7516),
    [anon_sym_repeat] = ACTIONS(7516),
    [anon_sym_QMARK] = ACTIONS(7514),
    [anon_sym_TILDE] = ACTIONS(7514),
    [anon_sym_BANG] = ACTIONS(7516),
    [anon_sym_PLUS] = ACTIONS(7514),
    [anon_sym_DASH] = ACTIONS(7516),
    [anon_sym_LT_DASH] = ACTIONS(7514),
    [anon_sym_LT_LT_DASH] = ACTIONS(7514),
    [anon_sym_COLON_EQ] = ACTIONS(7514),
    [anon_sym_DASH_GT] = ACTIONS(7516),
    [anon_sym_DASH_GT_GT] = ACTIONS(7514),
    [anon_sym_PIPE] = ACTIONS(7516),
    [anon_sym_AMP] = ACTIONS(7516),
    [anon_sym_PIPE_PIPE] = ACTIONS(7514),
    [anon_sym_AMP_AMP] = ACTIONS(7514),
    [anon_sym_LT] = ACTIONS(7516),
    [anon_sym_LT_EQ] = ACTIONS(7514),
    [anon_sym_GT] = ACTIONS(7516),
    [anon_sym_GT_EQ] = ACTIONS(7514),
    [anon_sym_EQ_EQ] = ACTIONS(7514),
    [anon_sym_BANG_EQ] = ACTIONS(7514),
    [anon_sym_STAR] = ACTIONS(7516),
    [anon_sym_SLASH] = ACTIONS(7514),
    [anon_sym_STAR_STAR] = ACTIONS(7514),
    [anon_sym_CARET] = ACTIONS(7514),
    [aux_sym_binary_operator_token1] = ACTIONS(7514),
    [anon_sym_PIPE_GT] = ACTIONS(7514),
    [anon_sym_COLON] = ACTIONS(7516),
    [anon_sym_DOLLAR] = ACTIONS(7514),
    [anon_sym_AT] = ACTIONS(7514),
    [aux_sym__hex_literal_token1] = ACTIONS(7514),
    [sym__number_literal] = ACTIONS(7516),
    [anon_sym_SQUOTE] = ACTIONS(7514),
    [anon_sym_DQUOTE] = ACTIONS(7514),
    [sym_return] = ACTIONS(7516),
    [sym_next] = ACTIONS(7516),
    [sym_break] = ACTIONS(7516),
    [sym_true] = ACTIONS(7516),
    [sym_false] = ACTIONS(7516),
    [sym_null] = ACTIONS(7516),
    [sym_inf] = ACTIONS(7516),
    [sym_nan] = ACTIONS(7516),
    [anon_sym_NA] = ACTIONS(7516),
    [anon_sym_NA_integer_] = ACTIONS(7516),
    [anon_sym_NA_real_] = ACTIONS(7516),
    [anon_sym_NA_complex_] = ACTIONS(7516),
    [anon_sym_NA_character_] = ACTIONS(7516),
    [sym_dots] = ACTIONS(7516),
    [sym_dot_dot_i] = ACTIONS(7514),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7514),
    [sym__newline] = ACTIONS(7514),
    [sym__raw_string_literal] = ACTIONS(7514),
    [sym__external_open_parenthesis] = ACTIONS(7514),
    [sym__external_close_parenthesis] = ACTIONS(7514),
    [sym__external_open_brace] = ACTIONS(7514),
    [sym__external_open_bracket] = ACTIONS(7514),
    [sym__external_open_bracket2] = ACTIONS(7514),
    [sym__external_close_bracket2] = ACTIONS(7514),
  },
  [2909] = {
    [ts_builtin_sym_end] = ACTIONS(7500),
    [sym_identifier] = ACTIONS(7502),
    [anon_sym_BSLASH] = ACTIONS(7500),
    [anon_sym_function] = ACTIONS(7502),
    [anon_sym_EQ] = ACTIONS(7502),
    [anon_sym_if] = ACTIONS(7502),
    [anon_sym_for] = ACTIONS(7502),
    [anon_sym_while] = ACTIONS(7502),
    [anon_sym_repeat] = ACTIONS(7502),
    [anon_sym_QMARK] = ACTIONS(7500),
    [anon_sym_TILDE] = ACTIONS(7500),
    [anon_sym_BANG] = ACTIONS(7502),
    [anon_sym_PLUS] = ACTIONS(7500),
    [anon_sym_DASH] = ACTIONS(7502),
    [anon_sym_LT_DASH] = ACTIONS(7500),
    [anon_sym_LT_LT_DASH] = ACTIONS(7500),
    [anon_sym_COLON_EQ] = ACTIONS(7500),
    [anon_sym_DASH_GT] = ACTIONS(7502),
    [anon_sym_DASH_GT_GT] = ACTIONS(7500),
    [anon_sym_PIPE] = ACTIONS(7502),
    [anon_sym_AMP] = ACTIONS(7502),
    [anon_sym_PIPE_PIPE] = ACTIONS(7500),
    [anon_sym_AMP_AMP] = ACTIONS(7500),
    [anon_sym_LT] = ACTIONS(7502),
    [anon_sym_LT_EQ] = ACTIONS(7500),
    [anon_sym_GT] = ACTIONS(7502),
    [anon_sym_GT_EQ] = ACTIONS(7500),
    [anon_sym_EQ_EQ] = ACTIONS(7500),
    [anon_sym_BANG_EQ] = ACTIONS(7500),
    [anon_sym_STAR] = ACTIONS(7502),
    [anon_sym_SLASH] = ACTIONS(7500),
    [anon_sym_STAR_STAR] = ACTIONS(7500),
    [anon_sym_CARET] = ACTIONS(7500),
    [aux_sym_binary_operator_token1] = ACTIONS(7500),
    [anon_sym_PIPE_GT] = ACTIONS(7500),
    [anon_sym_COLON] = ACTIONS(7502),
    [anon_sym_DOLLAR] = ACTIONS(7500),
    [anon_sym_AT] = ACTIONS(7500),
    [aux_sym__hex_literal_token1] = ACTIONS(7500),
    [sym__number_literal] = ACTIONS(7502),
    [anon_sym_SQUOTE] = ACTIONS(7500),
    [anon_sym_DQUOTE] = ACTIONS(7500),
    [sym_return] = ACTIONS(7502),
    [sym_next] = ACTIONS(7502),
    [sym_break] = ACTIONS(7502),
    [sym_true] = ACTIONS(7502),
    [sym_false] = ACTIONS(7502),
    [sym_null] = ACTIONS(7502),
    [sym_inf] = ACTIONS(7502),
    [sym_nan] = ACTIONS(7502),
    [anon_sym_NA] = ACTIONS(7502),
    [anon_sym_NA_integer_] = ACTIONS(7502),
    [anon_sym_NA_real_] = ACTIONS(7502),
    [anon_sym_NA_complex_] = ACTIONS(7502),
    [anon_sym_NA_character_] = ACTIONS(7502),
    [sym_dots] = ACTIONS(7502),
    [sym_dot_dot_i] = ACTIONS(7500),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7500),
    [sym__semicolon] = ACTIONS(7500),
    [sym__raw_string_literal] = ACTIONS(7500),
    [sym__external_open_parenthesis] = ACTIONS(7500),
    [sym__external_open_brace] = ACTIONS(7500),
    [sym__external_close_brace] = ACTIONS(7500),
    [sym__external_open_bracket] = ACTIONS(7500),
    [sym__external_open_bracket2] = ACTIONS(7500),
  },
  [2910] = {
    [ts_builtin_sym_end] = ACTIONS(7480),
    [sym_identifier] = ACTIONS(7482),
    [anon_sym_BSLASH] = ACTIONS(7480),
    [anon_sym_function] = ACTIONS(7482),
    [anon_sym_EQ] = ACTIONS(7482),
    [anon_sym_if] = ACTIONS(7482),
    [anon_sym_for] = ACTIONS(7482),
    [anon_sym_while] = ACTIONS(7482),
    [anon_sym_repeat] = ACTIONS(7482),
    [anon_sym_QMARK] = ACTIONS(7480),
    [anon_sym_TILDE] = ACTIONS(7480),
    [anon_sym_BANG] = ACTIONS(7482),
    [anon_sym_PLUS] = ACTIONS(7480),
    [anon_sym_DASH] = ACTIONS(7482),
    [anon_sym_LT_DASH] = ACTIONS(7480),
    [anon_sym_LT_LT_DASH] = ACTIONS(7480),
    [anon_sym_COLON_EQ] = ACTIONS(7480),
    [anon_sym_DASH_GT] = ACTIONS(7482),
    [anon_sym_DASH_GT_GT] = ACTIONS(7480),
    [anon_sym_PIPE] = ACTIONS(7482),
    [anon_sym_AMP] = ACTIONS(7482),
    [anon_sym_PIPE_PIPE] = ACTIONS(7480),
    [anon_sym_AMP_AMP] = ACTIONS(7480),
    [anon_sym_LT] = ACTIONS(7482),
    [anon_sym_LT_EQ] = ACTIONS(7480),
    [anon_sym_GT] = ACTIONS(7482),
    [anon_sym_GT_EQ] = ACTIONS(7480),
    [anon_sym_EQ_EQ] = ACTIONS(7480),
    [anon_sym_BANG_EQ] = ACTIONS(7480),
    [anon_sym_STAR] = ACTIONS(7482),
    [anon_sym_SLASH] = ACTIONS(7480),
    [anon_sym_STAR_STAR] = ACTIONS(7480),
    [anon_sym_CARET] = ACTIONS(7480),
    [aux_sym_binary_operator_token1] = ACTIONS(7480),
    [anon_sym_PIPE_GT] = ACTIONS(7480),
    [anon_sym_COLON] = ACTIONS(7482),
    [anon_sym_DOLLAR] = ACTIONS(7480),
    [anon_sym_AT] = ACTIONS(7480),
    [aux_sym__hex_literal_token1] = ACTIONS(7480),
    [sym__number_literal] = ACTIONS(7482),
    [anon_sym_SQUOTE] = ACTIONS(7480),
    [anon_sym_DQUOTE] = ACTIONS(7480),
    [sym_return] = ACTIONS(7482),
    [sym_next] = ACTIONS(7482),
    [sym_break] = ACTIONS(7482),
    [sym_true] = ACTIONS(7482),
    [sym_false] = ACTIONS(7482),
    [sym_null] = ACTIONS(7482),
    [sym_inf] = ACTIONS(7482),
    [sym_nan] = ACTIONS(7482),
    [anon_sym_NA] = ACTIONS(7482),
    [anon_sym_NA_integer_] = ACTIONS(7482),
    [anon_sym_NA_real_] = ACTIONS(7482),
    [anon_sym_NA_complex_] = ACTIONS(7482),
    [anon_sym_NA_character_] = ACTIONS(7482),
    [sym_dots] = ACTIONS(7482),
    [sym_dot_dot_i] = ACTIONS(7480),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7480),
    [sym__semicolon] = ACTIONS(7480),
    [sym__raw_string_literal] = ACTIONS(7480),
    [sym__external_open_parenthesis] = ACTIONS(7480),
    [sym__external_open_brace] = ACTIONS(7480),
    [sym__external_close_brace] = ACTIONS(7480),
    [sym__external_open_bracket] = ACTIONS(7480),
    [sym__external_open_bracket2] = ACTIONS(7480),
  },
  [2911] = {
    [sym_identifier] = ACTIONS(7563),
    [anon_sym_BSLASH] = ACTIONS(7561),
    [anon_sym_function] = ACTIONS(7563),
    [anon_sym_EQ] = ACTIONS(7563),
    [anon_sym_if] = ACTIONS(7563),
    [anon_sym_for] = ACTIONS(7563),
    [anon_sym_while] = ACTIONS(7563),
    [anon_sym_repeat] = ACTIONS(7563),
    [anon_sym_QMARK] = ACTIONS(7561),
    [anon_sym_TILDE] = ACTIONS(7561),
    [anon_sym_BANG] = ACTIONS(7563),
    [anon_sym_PLUS] = ACTIONS(7561),
    [anon_sym_DASH] = ACTIONS(7563),
    [anon_sym_LT_DASH] = ACTIONS(7561),
    [anon_sym_LT_LT_DASH] = ACTIONS(7561),
    [anon_sym_COLON_EQ] = ACTIONS(7561),
    [anon_sym_DASH_GT] = ACTIONS(7563),
    [anon_sym_DASH_GT_GT] = ACTIONS(7561),
    [anon_sym_PIPE] = ACTIONS(7563),
    [anon_sym_AMP] = ACTIONS(7563),
    [anon_sym_PIPE_PIPE] = ACTIONS(7561),
    [anon_sym_AMP_AMP] = ACTIONS(7561),
    [anon_sym_LT] = ACTIONS(7563),
    [anon_sym_LT_EQ] = ACTIONS(7561),
    [anon_sym_GT] = ACTIONS(7563),
    [anon_sym_GT_EQ] = ACTIONS(7561),
    [anon_sym_EQ_EQ] = ACTIONS(7561),
    [anon_sym_BANG_EQ] = ACTIONS(7561),
    [anon_sym_STAR] = ACTIONS(7563),
    [anon_sym_SLASH] = ACTIONS(7561),
    [anon_sym_STAR_STAR] = ACTIONS(7561),
    [anon_sym_CARET] = ACTIONS(7561),
    [aux_sym_binary_operator_token1] = ACTIONS(7561),
    [anon_sym_PIPE_GT] = ACTIONS(7561),
    [anon_sym_COLON] = ACTIONS(7563),
    [anon_sym_DOLLAR] = ACTIONS(7561),
    [anon_sym_AT] = ACTIONS(7561),
    [aux_sym__hex_literal_token1] = ACTIONS(7561),
    [sym__number_literal] = ACTIONS(7563),
    [anon_sym_SQUOTE] = ACTIONS(7561),
    [anon_sym_DQUOTE] = ACTIONS(7561),
    [sym_return] = ACTIONS(7563),
    [sym_next] = ACTIONS(7563),
    [sym_break] = ACTIONS(7563),
    [sym_true] = ACTIONS(7563),
    [sym_false] = ACTIONS(7563),
    [sym_null] = ACTIONS(7563),
    [sym_inf] = ACTIONS(7563),
    [sym_nan] = ACTIONS(7563),
    [anon_sym_NA] = ACTIONS(7563),
    [anon_sym_NA_integer_] = ACTIONS(7563),
    [anon_sym_NA_real_] = ACTIONS(7563),
    [anon_sym_NA_complex_] = ACTIONS(7563),
    [anon_sym_NA_character_] = ACTIONS(7563),
    [sym_dots] = ACTIONS(7563),
    [sym_dot_dot_i] = ACTIONS(7561),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7561),
    [sym__newline] = ACTIONS(7561),
    [sym__raw_string_literal] = ACTIONS(7561),
    [sym__external_open_parenthesis] = ACTIONS(7561),
    [sym__external_close_parenthesis] = ACTIONS(7561),
    [sym__external_open_brace] = ACTIONS(7561),
    [sym__external_open_bracket] = ACTIONS(7561),
    [sym__external_open_bracket2] = ACTIONS(7561),
    [sym__external_close_bracket2] = ACTIONS(7561),
  },
  [2912] = {
    [sym_function_definition] = STATE(1940),
    [sym_if_statement] = STATE(1940),
    [sym_for_statement] = STATE(1940),
    [sym_while_statement] = STATE(1940),
    [sym_repeat_statement] = STATE(1940),
    [sym_braced_expression] = STATE(1940),
    [sym_parenthesized_expression] = STATE(1940),
    [sym_call] = STATE(1940),
    [sym_subset] = STATE(1940),
    [sym_subset2] = STATE(1940),
    [sym__argument_value] = STATE(4671),
    [sym_unary_operator] = STATE(1940),
    [sym_binary_operator] = STATE(1940),
    [sym_extract_operator] = STATE(1940),
    [sym_namespace_operator] = STATE(1940),
    [sym_integer] = STATE(1940),
    [sym_complex] = STATE(1940),
    [sym_float] = STATE(1940),
    [sym__hex_literal] = STATE(2656),
    [sym__float_literal] = STATE(2656),
    [sym_string] = STATE(2744),
    [sym__single_quoted_string] = STATE(2654),
    [sym__double_quoted_string] = STATE(2649),
    [sym_na] = STATE(1940),
    [sym__expression] = STATE(1940),
    [sym__string_or_identifier] = STATE(5141),
    [sym__open_parenthesis] = STATE(218),
    [sym__open_brace] = STATE(185),
    [sym_identifier] = ACTIONS(4642),
    [anon_sym_BSLASH] = ACTIONS(4644),
    [anon_sym_function] = ACTIONS(4646),
    [anon_sym_if] = ACTIONS(4648),
    [anon_sym_for] = ACTIONS(4650),
    [anon_sym_while] = ACTIONS(4652),
    [anon_sym_repeat] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(6371),
    [anon_sym_PLUS] = ACTIONS(4662),
    [anon_sym_DASH] = ACTIONS(4662),
    [aux_sym__hex_literal_token1] = ACTIONS(4666),
    [sym__number_literal] = ACTIONS(4668),
    [anon_sym_SQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4672),
    [sym_return] = ACTIONS(6373),
    [sym_next] = ACTIONS(6373),
    [sym_break] = ACTIONS(6373),
    [sym_true] = ACTIONS(6373),
    [sym_false] = ACTIONS(6373),
    [sym_null] = ACTIONS(6373),
    [sym_inf] = ACTIONS(6373),
    [sym_nan] = ACTIONS(6373),
    [anon_sym_NA] = ACTIONS(4676),
    [anon_sym_NA_integer_] = ACTIONS(4676),
    [anon_sym_NA_real_] = ACTIONS(4676),
    [anon_sym_NA_complex_] = ACTIONS(4676),
    [anon_sym_NA_character_] = ACTIONS(4676),
    [sym_dots] = ACTIONS(6373),
    [sym_dot_dot_i] = ACTIONS(6377),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7695),
    [sym__newline] = ACTIONS(6381),
    [sym__raw_string_literal] = ACTIONS(4680),
    [sym__external_open_parenthesis] = ACTIONS(4682),
    [sym__external_open_brace] = ACTIONS(4684),
    [sym__external_close_bracket2] = ACTIONS(7695),
  },
  [2913] = {
    [sym_identifier] = ACTIONS(7474),
    [anon_sym_BSLASH] = ACTIONS(7472),
    [anon_sym_function] = ACTIONS(7474),
    [anon_sym_EQ] = ACTIONS(7474),
    [anon_sym_if] = ACTIONS(7474),
    [anon_sym_for] = ACTIONS(7474),
    [anon_sym_while] = ACTIONS(7474),
    [anon_sym_repeat] = ACTIONS(7474),
    [anon_sym_QMARK] = ACTIONS(7472),
    [anon_sym_TILDE] = ACTIONS(7472),
    [anon_sym_BANG] = ACTIONS(7474),
    [anon_sym_PLUS] = ACTIONS(7472),
    [anon_sym_DASH] = ACTIONS(7474),
    [anon_sym_LT_DASH] = ACTIONS(7472),
    [anon_sym_LT_LT_DASH] = ACTIONS(7472),
    [anon_sym_COLON_EQ] = ACTIONS(7472),
    [anon_sym_DASH_GT] = ACTIONS(7474),
    [anon_sym_DASH_GT_GT] = ACTIONS(7472),
    [anon_sym_PIPE] = ACTIONS(7474),
    [anon_sym_AMP] = ACTIONS(7474),
    [anon_sym_PIPE_PIPE] = ACTIONS(7472),
    [anon_sym_AMP_AMP] = ACTIONS(7472),
    [anon_sym_LT] = ACTIONS(7474),
    [anon_sym_LT_EQ] = ACTIONS(7472),
    [anon_sym_GT] = ACTIONS(7474),
    [anon_sym_GT_EQ] = ACTIONS(7472),
    [anon_sym_EQ_EQ] = ACTIONS(7472),
    [anon_sym_BANG_EQ] = ACTIONS(7472),
    [anon_sym_STAR] = ACTIONS(7474),
    [anon_sym_SLASH] = ACTIONS(7472),
    [anon_sym_STAR_STAR] = ACTIONS(7472),
    [anon_sym_CARET] = ACTIONS(7472),
    [aux_sym_binary_operator_token1] = ACTIONS(7472),
    [anon_sym_PIPE_GT] = ACTIONS(7472),
    [anon_sym_COLON] = ACTIONS(7474),
    [anon_sym_DOLLAR] = ACTIONS(7472),
    [anon_sym_AT] = ACTIONS(7472),
    [aux_sym__hex_literal_token1] = ACTIONS(7472),
    [sym__number_literal] = ACTIONS(7474),
    [anon_sym_SQUOTE] = ACTIONS(7472),
    [anon_sym_DQUOTE] = ACTIONS(7472),
    [sym_return] = ACTIONS(7474),
    [sym_next] = ACTIONS(7474),
    [sym_break] = ACTIONS(7474),
    [sym_true] = ACTIONS(7474),
    [sym_false] = ACTIONS(7474),
    [sym_null] = ACTIONS(7474),
    [sym_inf] = ACTIONS(7474),
    [sym_nan] = ACTIONS(7474),
    [anon_sym_NA] = ACTIONS(7474),
    [anon_sym_NA_integer_] = ACTIONS(7474),
    [anon_sym_NA_real_] = ACTIONS(7474),
    [anon_sym_NA_complex_] = ACTIONS(7474),
    [anon_sym_NA_character_] = ACTIONS(7474),
    [sym_dots] = ACTIONS(7474),
    [sym_dot_dot_i] = ACTIONS(7472),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7472),
    [sym__newline] = ACTIONS(7472),
    [sym__raw_string_literal] = ACTIONS(7472),
    [sym__external_else] = ACTIONS(7472),
    [sym__external_open_parenthesis] = ACTIONS(7472),
    [sym__external_open_brace] = ACTIONS(7472),
    [sym__external_open_bracket] = ACTIONS(7472),
    [sym__external_close_bracket] = ACTIONS(7472),
    [sym__external_open_bracket2] = ACTIONS(7472),
  },
  [2914] = {
    [sym_identifier] = ACTIONS(7464),
    [anon_sym_BSLASH] = ACTIONS(7466),
    [anon_sym_function] = ACTIONS(7464),
    [anon_sym_EQ] = ACTIONS(7464),
    [anon_sym_if] = ACTIONS(7464),
    [anon_sym_for] = ACTIONS(7464),
    [anon_sym_while] = ACTIONS(7464),
    [anon_sym_repeat] = ACTIONS(7464),
    [anon_sym_QMARK] = ACTIONS(7466),
    [anon_sym_TILDE] = ACTIONS(7466),
    [anon_sym_BANG] = ACTIONS(7464),
    [anon_sym_PLUS] = ACTIONS(7466),
    [anon_sym_DASH] = ACTIONS(7464),
    [anon_sym_LT_DASH] = ACTIONS(7466),
    [anon_sym_LT_LT_DASH] = ACTIONS(7466),
    [anon_sym_COLON_EQ] = ACTIONS(7466),
    [anon_sym_DASH_GT] = ACTIONS(7464),
    [anon_sym_DASH_GT_GT] = ACTIONS(7466),
    [anon_sym_PIPE] = ACTIONS(7464),
    [anon_sym_AMP] = ACTIONS(7464),
    [anon_sym_PIPE_PIPE] = ACTIONS(7466),
    [anon_sym_AMP_AMP] = ACTIONS(7466),
    [anon_sym_LT] = ACTIONS(7464),
    [anon_sym_LT_EQ] = ACTIONS(7466),
    [anon_sym_GT] = ACTIONS(7464),
    [anon_sym_GT_EQ] = ACTIONS(7466),
    [anon_sym_EQ_EQ] = ACTIONS(7466),
    [anon_sym_BANG_EQ] = ACTIONS(7466),
    [anon_sym_STAR] = ACTIONS(7464),
    [anon_sym_SLASH] = ACTIONS(7466),
    [anon_sym_STAR_STAR] = ACTIONS(7466),
    [anon_sym_CARET] = ACTIONS(7466),
    [aux_sym_binary_operator_token1] = ACTIONS(7466),
    [anon_sym_PIPE_GT] = ACTIONS(7466),
    [anon_sym_COLON] = ACTIONS(7464),
    [anon_sym_DOLLAR] = ACTIONS(7466),
    [anon_sym_AT] = ACTIONS(7466),
    [aux_sym__hex_literal_token1] = ACTIONS(7466),
    [sym__number_literal] = ACTIONS(7464),
    [anon_sym_SQUOTE] = ACTIONS(7466),
    [anon_sym_DQUOTE] = ACTIONS(7466),
    [sym_return] = ACTIONS(7464),
    [sym_next] = ACTIONS(7464),
    [sym_break] = ACTIONS(7464),
    [sym_true] = ACTIONS(7464),
    [sym_false] = ACTIONS(7464),
    [sym_null] = ACTIONS(7464),
    [sym_inf] = ACTIONS(7464),
    [sym_nan] = ACTIONS(7464),
    [anon_sym_NA] = ACTIONS(7464),
    [anon_sym_NA_integer_] = ACTIONS(7464),
    [anon_sym_NA_real_] = ACTIONS(7464),
    [anon_sym_NA_complex_] = ACTIONS(7464),
    [anon_sym_NA_character_] = ACTIONS(7464),
    [sym_dots] = ACTIONS(7464),
    [sym_dot_dot_i] = ACTIONS(7466),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7466),
    [sym__newline] = ACTIONS(7466),
    [sym__raw_string_literal] = ACTIONS(7466),
    [sym__external_else] = ACTIONS(7466),
    [sym__external_open_parenthesis] = ACTIONS(7466),
    [sym__external_open_brace] = ACTIONS(7466),
    [sym__external_open_bracket] = ACTIONS(7466),
    [sym__external_close_bracket] = ACTIONS(7466),
    [sym__external_open_bracket2] = ACTIONS(7466),
  },
  [2915] = {
    [sym_identifier] = ACTIONS(7478),
    [anon_sym_BSLASH] = ACTIONS(7476),
    [anon_sym_function] = ACTIONS(7478),
    [anon_sym_EQ] = ACTIONS(7478),
    [anon_sym_if] = ACTIONS(7478),
    [anon_sym_for] = ACTIONS(7478),
    [anon_sym_while] = ACTIONS(7478),
    [anon_sym_repeat] = ACTIONS(7478),
    [anon_sym_QMARK] = ACTIONS(7476),
    [anon_sym_TILDE] = ACTIONS(7476),
    [anon_sym_BANG] = ACTIONS(7478),
    [anon_sym_PLUS] = ACTIONS(7476),
    [anon_sym_DASH] = ACTIONS(7478),
    [anon_sym_LT_DASH] = ACTIONS(7476),
    [anon_sym_LT_LT_DASH] = ACTIONS(7476),
    [anon_sym_COLON_EQ] = ACTIONS(7476),
    [anon_sym_DASH_GT] = ACTIONS(7478),
    [anon_sym_DASH_GT_GT] = ACTIONS(7476),
    [anon_sym_PIPE] = ACTIONS(7478),
    [anon_sym_AMP] = ACTIONS(7478),
    [anon_sym_PIPE_PIPE] = ACTIONS(7476),
    [anon_sym_AMP_AMP] = ACTIONS(7476),
    [anon_sym_LT] = ACTIONS(7478),
    [anon_sym_LT_EQ] = ACTIONS(7476),
    [anon_sym_GT] = ACTIONS(7478),
    [anon_sym_GT_EQ] = ACTIONS(7476),
    [anon_sym_EQ_EQ] = ACTIONS(7476),
    [anon_sym_BANG_EQ] = ACTIONS(7476),
    [anon_sym_STAR] = ACTIONS(7478),
    [anon_sym_SLASH] = ACTIONS(7476),
    [anon_sym_STAR_STAR] = ACTIONS(7476),
    [anon_sym_CARET] = ACTIONS(7476),
    [aux_sym_binary_operator_token1] = ACTIONS(7476),
    [anon_sym_PIPE_GT] = ACTIONS(7476),
    [anon_sym_COLON] = ACTIONS(7478),
    [anon_sym_DOLLAR] = ACTIONS(7476),
    [anon_sym_AT] = ACTIONS(7476),
    [aux_sym__hex_literal_token1] = ACTIONS(7476),
    [sym__number_literal] = ACTIONS(7478),
    [anon_sym_SQUOTE] = ACTIONS(7476),
    [anon_sym_DQUOTE] = ACTIONS(7476),
    [sym_return] = ACTIONS(7478),
    [sym_next] = ACTIONS(7478),
    [sym_break] = ACTIONS(7478),
    [sym_true] = ACTIONS(7478),
    [sym_false] = ACTIONS(7478),
    [sym_null] = ACTIONS(7478),
    [sym_inf] = ACTIONS(7478),
    [sym_nan] = ACTIONS(7478),
    [anon_sym_NA] = ACTIONS(7478),
    [anon_sym_NA_integer_] = ACTIONS(7478),
    [anon_sym_NA_real_] = ACTIONS(7478),
    [anon_sym_NA_complex_] = ACTIONS(7478),
    [anon_sym_NA_character_] = ACTIONS(7478),
    [sym_dots] = ACTIONS(7478),
    [sym_dot_dot_i] = ACTIONS(7476),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7476),
    [sym__newline] = ACTIONS(7476),
    [sym__raw_string_literal] = ACTIONS(7476),
    [sym__external_else] = ACTIONS(7476),
    [sym__external_open_parenthesis] = ACTIONS(7476),
    [sym__external_open_brace] = ACTIONS(7476),
    [sym__external_open_bracket] = ACTIONS(7476),
    [sym__external_close_bracket] = ACTIONS(7476),
    [sym__external_open_bracket2] = ACTIONS(7476),
  },
  [2916] = {
    [sym_identifier] = ACTIONS(7520),
    [anon_sym_BSLASH] = ACTIONS(7518),
    [anon_sym_function] = ACTIONS(7520),
    [anon_sym_EQ] = ACTIONS(7520),
    [anon_sym_if] = ACTIONS(7520),
    [anon_sym_for] = ACTIONS(7520),
    [anon_sym_while] = ACTIONS(7520),
    [anon_sym_repeat] = ACTIONS(7520),
    [anon_sym_QMARK] = ACTIONS(7518),
    [anon_sym_TILDE] = ACTIONS(7518),
    [anon_sym_BANG] = ACTIONS(7520),
    [anon_sym_PLUS] = ACTIONS(7518),
    [anon_sym_DASH] = ACTIONS(7520),
    [anon_sym_LT_DASH] = ACTIONS(7518),
    [anon_sym_LT_LT_DASH] = ACTIONS(7518),
    [anon_sym_COLON_EQ] = ACTIONS(7518),
    [anon_sym_DASH_GT] = ACTIONS(7520),
    [anon_sym_DASH_GT_GT] = ACTIONS(7518),
    [anon_sym_PIPE] = ACTIONS(7520),
    [anon_sym_AMP] = ACTIONS(7520),
    [anon_sym_PIPE_PIPE] = ACTIONS(7518),
    [anon_sym_AMP_AMP] = ACTIONS(7518),
    [anon_sym_LT] = ACTIONS(7520),
    [anon_sym_LT_EQ] = ACTIONS(7518),
    [anon_sym_GT] = ACTIONS(7520),
    [anon_sym_GT_EQ] = ACTIONS(7518),
    [anon_sym_EQ_EQ] = ACTIONS(7518),
    [anon_sym_BANG_EQ] = ACTIONS(7518),
    [anon_sym_STAR] = ACTIONS(7520),
    [anon_sym_SLASH] = ACTIONS(7518),
    [anon_sym_STAR_STAR] = ACTIONS(7518),
    [anon_sym_CARET] = ACTIONS(7518),
    [aux_sym_binary_operator_token1] = ACTIONS(7518),
    [anon_sym_PIPE_GT] = ACTIONS(7518),
    [anon_sym_COLON] = ACTIONS(7520),
    [anon_sym_DOLLAR] = ACTIONS(7518),
    [anon_sym_AT] = ACTIONS(7518),
    [aux_sym__hex_literal_token1] = ACTIONS(7518),
    [sym__number_literal] = ACTIONS(7520),
    [anon_sym_SQUOTE] = ACTIONS(7518),
    [anon_sym_DQUOTE] = ACTIONS(7518),
    [sym_return] = ACTIONS(7520),
    [sym_next] = ACTIONS(7520),
    [sym_break] = ACTIONS(7520),
    [sym_true] = ACTIONS(7520),
    [sym_false] = ACTIONS(7520),
    [sym_null] = ACTIONS(7520),
    [sym_inf] = ACTIONS(7520),
    [sym_nan] = ACTIONS(7520),
    [anon_sym_NA] = ACTIONS(7520),
    [anon_sym_NA_integer_] = ACTIONS(7520),
    [anon_sym_NA_real_] = ACTIONS(7520),
    [anon_sym_NA_complex_] = ACTIONS(7520),
    [anon_sym_NA_character_] = ACTIONS(7520),
    [sym_dots] = ACTIONS(7520),
    [sym_dot_dot_i] = ACTIONS(7518),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7518),
    [sym__newline] = ACTIONS(7518),
    [sym__raw_string_literal] = ACTIONS(7518),
    [sym__external_open_parenthesis] = ACTIONS(7518),
    [sym__external_close_parenthesis] = ACTIONS(7518),
    [sym__external_open_brace] = ACTIONS(7518),
    [sym__external_open_bracket] = ACTIONS(7518),
    [sym__external_open_bracket2] = ACTIONS(7518),
    [sym__external_close_bracket2] = ACTIONS(7518),
  },
  [2917] = {
    [sym_identifier] = ACTIONS(7552),
    [anon_sym_BSLASH] = ACTIONS(7550),
    [anon_sym_function] = ACTIONS(7552),
    [anon_sym_EQ] = ACTIONS(7552),
    [anon_sym_if] = ACTIONS(7552),
    [anon_sym_for] = ACTIONS(7552),
    [anon_sym_while] = ACTIONS(7552),
    [anon_sym_repeat] = ACTIONS(7552),
    [anon_sym_QMARK] = ACTIONS(7550),
    [anon_sym_TILDE] = ACTIONS(7550),
    [anon_sym_BANG] = ACTIONS(7552),
    [anon_sym_PLUS] = ACTIONS(7550),
    [anon_sym_DASH] = ACTIONS(7552),
    [anon_sym_LT_DASH] = ACTIONS(7550),
    [anon_sym_LT_LT_DASH] = ACTIONS(7550),
    [anon_sym_COLON_EQ] = ACTIONS(7550),
    [anon_sym_DASH_GT] = ACTIONS(7552),
    [anon_sym_DASH_GT_GT] = ACTIONS(7550),
    [anon_sym_PIPE] = ACTIONS(7552),
    [anon_sym_AMP] = ACTIONS(7552),
    [anon_sym_PIPE_PIPE] = ACTIONS(7550),
    [anon_sym_AMP_AMP] = ACTIONS(7550),
    [anon_sym_LT] = ACTIONS(7552),
    [anon_sym_LT_EQ] = ACTIONS(7550),
    [anon_sym_GT] = ACTIONS(7552),
    [anon_sym_GT_EQ] = ACTIONS(7550),
    [anon_sym_EQ_EQ] = ACTIONS(7550),
    [anon_sym_BANG_EQ] = ACTIONS(7550),
    [anon_sym_STAR] = ACTIONS(7552),
    [anon_sym_SLASH] = ACTIONS(7550),
    [anon_sym_STAR_STAR] = ACTIONS(7550),
    [anon_sym_CARET] = ACTIONS(7550),
    [aux_sym_binary_operator_token1] = ACTIONS(7550),
    [anon_sym_PIPE_GT] = ACTIONS(7550),
    [anon_sym_COLON] = ACTIONS(7552),
    [anon_sym_DOLLAR] = ACTIONS(7550),
    [anon_sym_AT] = ACTIONS(7550),
    [aux_sym__hex_literal_token1] = ACTIONS(7550),
    [sym__number_literal] = ACTIONS(7552),
    [anon_sym_SQUOTE] = ACTIONS(7550),
    [anon_sym_DQUOTE] = ACTIONS(7550),
    [sym_return] = ACTIONS(7552),
    [sym_next] = ACTIONS(7552),
    [sym_break] = ACTIONS(7552),
    [sym_true] = ACTIONS(7552),
    [sym_false] = ACTIONS(7552),
    [sym_null] = ACTIONS(7552),
    [sym_inf] = ACTIONS(7552),
    [sym_nan] = ACTIONS(7552),
    [anon_sym_NA] = ACTIONS(7552),
    [anon_sym_NA_integer_] = ACTIONS(7552),
    [anon_sym_NA_real_] = ACTIONS(7552),
    [anon_sym_NA_complex_] = ACTIONS(7552),
    [anon_sym_NA_character_] = ACTIONS(7552),
    [sym_dots] = ACTIONS(7552),
    [sym_dot_dot_i] = ACTIONS(7550),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7550),
    [sym__newline] = ACTIONS(7550),
    [sym__raw_string_literal] = ACTIONS(7550),
    [sym__external_else] = ACTIONS(7550),
    [sym__external_open_parenthesis] = ACTIONS(7550),
    [sym__external_close_parenthesis] = ACTIONS(7550),
    [sym__external_open_brace] = ACTIONS(7550),
    [sym__external_open_bracket] = ACTIONS(7550),
    [sym__external_open_bracket2] = ACTIONS(7550),
  },
  [2918] = {
    [sym_identifier] = ACTIONS(7567),
    [anon_sym_BSLASH] = ACTIONS(7565),
    [anon_sym_function] = ACTIONS(7567),
    [anon_sym_EQ] = ACTIONS(7567),
    [anon_sym_if] = ACTIONS(7567),
    [anon_sym_for] = ACTIONS(7567),
    [anon_sym_while] = ACTIONS(7567),
    [anon_sym_repeat] = ACTIONS(7567),
    [anon_sym_QMARK] = ACTIONS(7565),
    [anon_sym_TILDE] = ACTIONS(7565),
    [anon_sym_BANG] = ACTIONS(7567),
    [anon_sym_PLUS] = ACTIONS(7565),
    [anon_sym_DASH] = ACTIONS(7567),
    [anon_sym_LT_DASH] = ACTIONS(7565),
    [anon_sym_LT_LT_DASH] = ACTIONS(7565),
    [anon_sym_COLON_EQ] = ACTIONS(7565),
    [anon_sym_DASH_GT] = ACTIONS(7567),
    [anon_sym_DASH_GT_GT] = ACTIONS(7565),
    [anon_sym_PIPE] = ACTIONS(7567),
    [anon_sym_AMP] = ACTIONS(7567),
    [anon_sym_PIPE_PIPE] = ACTIONS(7565),
    [anon_sym_AMP_AMP] = ACTIONS(7565),
    [anon_sym_LT] = ACTIONS(7567),
    [anon_sym_LT_EQ] = ACTIONS(7565),
    [anon_sym_GT] = ACTIONS(7567),
    [anon_sym_GT_EQ] = ACTIONS(7565),
    [anon_sym_EQ_EQ] = ACTIONS(7565),
    [anon_sym_BANG_EQ] = ACTIONS(7565),
    [anon_sym_STAR] = ACTIONS(7567),
    [anon_sym_SLASH] = ACTIONS(7565),
    [anon_sym_STAR_STAR] = ACTIONS(7565),
    [anon_sym_CARET] = ACTIONS(7565),
    [aux_sym_binary_operator_token1] = ACTIONS(7565),
    [anon_sym_PIPE_GT] = ACTIONS(7565),
    [anon_sym_COLON] = ACTIONS(7567),
    [anon_sym_DOLLAR] = ACTIONS(7565),
    [anon_sym_AT] = ACTIONS(7565),
    [aux_sym__hex_literal_token1] = ACTIONS(7565),
    [sym__number_literal] = ACTIONS(7567),
    [anon_sym_SQUOTE] = ACTIONS(7565),
    [anon_sym_DQUOTE] = ACTIONS(7565),
    [sym_return] = ACTIONS(7567),
    [sym_next] = ACTIONS(7567),
    [sym_break] = ACTIONS(7567),
    [sym_true] = ACTIONS(7567),
    [sym_false] = ACTIONS(7567),
    [sym_null] = ACTIONS(7567),
    [sym_inf] = ACTIONS(7567),
    [sym_nan] = ACTIONS(7567),
    [anon_sym_NA] = ACTIONS(7567),
    [anon_sym_NA_integer_] = ACTIONS(7567),
    [anon_sym_NA_real_] = ACTIONS(7567),
    [anon_sym_NA_complex_] = ACTIONS(7567),
    [anon_sym_NA_character_] = ACTIONS(7567),
    [sym_dots] = ACTIONS(7567),
    [sym_dot_dot_i] = ACTIONS(7565),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7565),
    [sym__newline] = ACTIONS(7565),
    [sym__raw_string_literal] = ACTIONS(7565),
    [sym__external_else] = ACTIONS(7565),
    [sym__external_open_parenthesis] = ACTIONS(7565),
    [sym__external_open_brace] = ACTIONS(7565),
    [sym__external_open_bracket] = ACTIONS(7565),
    [sym__external_open_bracket2] = ACTIONS(7565),
    [sym__external_close_bracket2] = ACTIONS(7565),
  },
  [2919] = {
    [sym_identifier] = ACTIONS(7524),
    [anon_sym_BSLASH] = ACTIONS(7522),
    [anon_sym_function] = ACTIONS(7524),
    [anon_sym_EQ] = ACTIONS(7524),
    [anon_sym_if] = ACTIONS(7524),
    [anon_sym_for] = ACTIONS(7524),
    [anon_sym_while] = ACTIONS(7524),
    [anon_sym_repeat] = ACTIONS(7524),
    [anon_sym_QMARK] = ACTIONS(7522),
    [anon_sym_TILDE] = ACTIONS(7522),
    [anon_sym_BANG] = ACTIONS(7524),
    [anon_sym_PLUS] = ACTIONS(7522),
    [anon_sym_DASH] = ACTIONS(7524),
    [anon_sym_LT_DASH] = ACTIONS(7522),
    [anon_sym_LT_LT_DASH] = ACTIONS(7522),
    [anon_sym_COLON_EQ] = ACTIONS(7522),
    [anon_sym_DASH_GT] = ACTIONS(7524),
    [anon_sym_DASH_GT_GT] = ACTIONS(7522),
    [anon_sym_PIPE] = ACTIONS(7524),
    [anon_sym_AMP] = ACTIONS(7524),
    [anon_sym_PIPE_PIPE] = ACTIONS(7522),
    [anon_sym_AMP_AMP] = ACTIONS(7522),
    [anon_sym_LT] = ACTIONS(7524),
    [anon_sym_LT_EQ] = ACTIONS(7522),
    [anon_sym_GT] = ACTIONS(7524),
    [anon_sym_GT_EQ] = ACTIONS(7522),
    [anon_sym_EQ_EQ] = ACTIONS(7522),
    [anon_sym_BANG_EQ] = ACTIONS(7522),
    [anon_sym_STAR] = ACTIONS(7524),
    [anon_sym_SLASH] = ACTIONS(7522),
    [anon_sym_STAR_STAR] = ACTIONS(7522),
    [anon_sym_CARET] = ACTIONS(7522),
    [aux_sym_binary_operator_token1] = ACTIONS(7522),
    [anon_sym_PIPE_GT] = ACTIONS(7522),
    [anon_sym_COLON] = ACTIONS(7524),
    [anon_sym_DOLLAR] = ACTIONS(7522),
    [anon_sym_AT] = ACTIONS(7522),
    [aux_sym__hex_literal_token1] = ACTIONS(7522),
    [sym__number_literal] = ACTIONS(7524),
    [anon_sym_SQUOTE] = ACTIONS(7522),
    [anon_sym_DQUOTE] = ACTIONS(7522),
    [sym_return] = ACTIONS(7524),
    [sym_next] = ACTIONS(7524),
    [sym_break] = ACTIONS(7524),
    [sym_true] = ACTIONS(7524),
    [sym_false] = ACTIONS(7524),
    [sym_null] = ACTIONS(7524),
    [sym_inf] = ACTIONS(7524),
    [sym_nan] = ACTIONS(7524),
    [anon_sym_NA] = ACTIONS(7524),
    [anon_sym_NA_integer_] = ACTIONS(7524),
    [anon_sym_NA_real_] = ACTIONS(7524),
    [anon_sym_NA_complex_] = ACTIONS(7524),
    [anon_sym_NA_character_] = ACTIONS(7524),
    [sym_dots] = ACTIONS(7524),
    [sym_dot_dot_i] = ACTIONS(7522),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7522),
    [sym__newline] = ACTIONS(7522),
    [sym__raw_string_literal] = ACTIONS(7522),
    [sym__external_open_parenthesis] = ACTIONS(7522),
    [sym__external_close_parenthesis] = ACTIONS(7522),
    [sym__external_open_brace] = ACTIONS(7522),
    [sym__external_open_bracket] = ACTIONS(7522),
    [sym__external_open_bracket2] = ACTIONS(7522),
    [sym__external_close_bracket2] = ACTIONS(7522),
  },
  [2920] = {
    [sym_identifier] = ACTIONS(7528),
    [anon_sym_BSLASH] = ACTIONS(7526),
    [anon_sym_function] = ACTIONS(7528),
    [anon_sym_EQ] = ACTIONS(7528),
    [anon_sym_if] = ACTIONS(7528),
    [anon_sym_for] = ACTIONS(7528),
    [anon_sym_while] = ACTIONS(7528),
    [anon_sym_repeat] = ACTIONS(7528),
    [anon_sym_QMARK] = ACTIONS(7526),
    [anon_sym_TILDE] = ACTIONS(7526),
    [anon_sym_BANG] = ACTIONS(7528),
    [anon_sym_PLUS] = ACTIONS(7526),
    [anon_sym_DASH] = ACTIONS(7528),
    [anon_sym_LT_DASH] = ACTIONS(7526),
    [anon_sym_LT_LT_DASH] = ACTIONS(7526),
    [anon_sym_COLON_EQ] = ACTIONS(7526),
    [anon_sym_DASH_GT] = ACTIONS(7528),
    [anon_sym_DASH_GT_GT] = ACTIONS(7526),
    [anon_sym_PIPE] = ACTIONS(7528),
    [anon_sym_AMP] = ACTIONS(7528),
    [anon_sym_PIPE_PIPE] = ACTIONS(7526),
    [anon_sym_AMP_AMP] = ACTIONS(7526),
    [anon_sym_LT] = ACTIONS(7528),
    [anon_sym_LT_EQ] = ACTIONS(7526),
    [anon_sym_GT] = ACTIONS(7528),
    [anon_sym_GT_EQ] = ACTIONS(7526),
    [anon_sym_EQ_EQ] = ACTIONS(7526),
    [anon_sym_BANG_EQ] = ACTIONS(7526),
    [anon_sym_STAR] = ACTIONS(7528),
    [anon_sym_SLASH] = ACTIONS(7526),
    [anon_sym_STAR_STAR] = ACTIONS(7526),
    [anon_sym_CARET] = ACTIONS(7526),
    [aux_sym_binary_operator_token1] = ACTIONS(7526),
    [anon_sym_PIPE_GT] = ACTIONS(7526),
    [anon_sym_COLON] = ACTIONS(7528),
    [anon_sym_DOLLAR] = ACTIONS(7526),
    [anon_sym_AT] = ACTIONS(7526),
    [aux_sym__hex_literal_token1] = ACTIONS(7526),
    [sym__number_literal] = ACTIONS(7528),
    [anon_sym_SQUOTE] = ACTIONS(7526),
    [anon_sym_DQUOTE] = ACTIONS(7526),
    [sym_return] = ACTIONS(7528),
    [sym_next] = ACTIONS(7528),
    [sym_break] = ACTIONS(7528),
    [sym_true] = ACTIONS(7528),
    [sym_false] = ACTIONS(7528),
    [sym_null] = ACTIONS(7528),
    [sym_inf] = ACTIONS(7528),
    [sym_nan] = ACTIONS(7528),
    [anon_sym_NA] = ACTIONS(7528),
    [anon_sym_NA_integer_] = ACTIONS(7528),
    [anon_sym_NA_real_] = ACTIONS(7528),
    [anon_sym_NA_complex_] = ACTIONS(7528),
    [anon_sym_NA_character_] = ACTIONS(7528),
    [sym_dots] = ACTIONS(7528),
    [sym_dot_dot_i] = ACTIONS(7526),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7526),
    [sym__newline] = ACTIONS(7526),
    [sym__raw_string_literal] = ACTIONS(7526),
    [sym__external_open_parenthesis] = ACTIONS(7526),
    [sym__external_close_parenthesis] = ACTIONS(7526),
    [sym__external_open_brace] = ACTIONS(7526),
    [sym__external_open_bracket] = ACTIONS(7526),
    [sym__external_open_bracket2] = ACTIONS(7526),
    [sym__external_close_bracket2] = ACTIONS(7526),
  },
  [2921] = {
    [sym_identifier] = ACTIONS(7482),
    [anon_sym_BSLASH] = ACTIONS(7480),
    [anon_sym_function] = ACTIONS(7482),
    [anon_sym_EQ] = ACTIONS(7482),
    [anon_sym_if] = ACTIONS(7482),
    [anon_sym_for] = ACTIONS(7482),
    [anon_sym_while] = ACTIONS(7482),
    [anon_sym_repeat] = ACTIONS(7482),
    [anon_sym_QMARK] = ACTIONS(7480),
    [anon_sym_TILDE] = ACTIONS(7480),
    [anon_sym_BANG] = ACTIONS(7482),
    [anon_sym_PLUS] = ACTIONS(7480),
    [anon_sym_DASH] = ACTIONS(7482),
    [anon_sym_LT_DASH] = ACTIONS(7480),
    [anon_sym_LT_LT_DASH] = ACTIONS(7480),
    [anon_sym_COLON_EQ] = ACTIONS(7480),
    [anon_sym_DASH_GT] = ACTIONS(7482),
    [anon_sym_DASH_GT_GT] = ACTIONS(7480),
    [anon_sym_PIPE] = ACTIONS(7482),
    [anon_sym_AMP] = ACTIONS(7482),
    [anon_sym_PIPE_PIPE] = ACTIONS(7480),
    [anon_sym_AMP_AMP] = ACTIONS(7480),
    [anon_sym_LT] = ACTIONS(7482),
    [anon_sym_LT_EQ] = ACTIONS(7480),
    [anon_sym_GT] = ACTIONS(7482),
    [anon_sym_GT_EQ] = ACTIONS(7480),
    [anon_sym_EQ_EQ] = ACTIONS(7480),
    [anon_sym_BANG_EQ] = ACTIONS(7480),
    [anon_sym_STAR] = ACTIONS(7482),
    [anon_sym_SLASH] = ACTIONS(7480),
    [anon_sym_STAR_STAR] = ACTIONS(7480),
    [anon_sym_CARET] = ACTIONS(7480),
    [aux_sym_binary_operator_token1] = ACTIONS(7480),
    [anon_sym_PIPE_GT] = ACTIONS(7480),
    [anon_sym_COLON] = ACTIONS(7482),
    [anon_sym_DOLLAR] = ACTIONS(7480),
    [anon_sym_AT] = ACTIONS(7480),
    [aux_sym__hex_literal_token1] = ACTIONS(7480),
    [sym__number_literal] = ACTIONS(7482),
    [anon_sym_SQUOTE] = ACTIONS(7480),
    [anon_sym_DQUOTE] = ACTIONS(7480),
    [sym_return] = ACTIONS(7482),
    [sym_next] = ACTIONS(7482),
    [sym_break] = ACTIONS(7482),
    [sym_true] = ACTIONS(7482),
    [sym_false] = ACTIONS(7482),
    [sym_null] = ACTIONS(7482),
    [sym_inf] = ACTIONS(7482),
    [sym_nan] = ACTIONS(7482),
    [anon_sym_NA] = ACTIONS(7482),
    [anon_sym_NA_integer_] = ACTIONS(7482),
    [anon_sym_NA_real_] = ACTIONS(7482),
    [anon_sym_NA_complex_] = ACTIONS(7482),
    [anon_sym_NA_character_] = ACTIONS(7482),
    [sym_dots] = ACTIONS(7482),
    [sym_dot_dot_i] = ACTIONS(7480),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7480),
    [sym__newline] = ACTIONS(7480),
    [sym__raw_string_literal] = ACTIONS(7480),
    [sym__external_else] = ACTIONS(7480),
    [sym__external_open_parenthesis] = ACTIONS(7480),
    [sym__external_open_brace] = ACTIONS(7480),
    [sym__external_open_bracket] = ACTIONS(7480),
    [sym__external_close_bracket] = ACTIONS(7480),
    [sym__external_open_bracket2] = ACTIONS(7480),
  },
  [2922] = {
    [ts_builtin_sym_end] = ACTIONS(7526),
    [sym_identifier] = ACTIONS(7528),
    [anon_sym_BSLASH] = ACTIONS(7526),
    [anon_sym_function] = ACTIONS(7528),
    [anon_sym_EQ] = ACTIONS(7528),
    [anon_sym_if] = ACTIONS(7528),
    [anon_sym_for] = ACTIONS(7528),
    [anon_sym_while] = ACTIONS(7528),
    [anon_sym_repeat] = ACTIONS(7528),
    [anon_sym_QMARK] = ACTIONS(7526),
    [anon_sym_TILDE] = ACTIONS(7526),
    [anon_sym_BANG] = ACTIONS(7528),
    [anon_sym_PLUS] = ACTIONS(7526),
    [anon_sym_DASH] = ACTIONS(7528),
    [anon_sym_LT_DASH] = ACTIONS(7526),
    [anon_sym_LT_LT_DASH] = ACTIONS(7526),
    [anon_sym_COLON_EQ] = ACTIONS(7526),
    [anon_sym_DASH_GT] = ACTIONS(7528),
    [anon_sym_DASH_GT_GT] = ACTIONS(7526),
    [anon_sym_PIPE] = ACTIONS(7528),
    [anon_sym_AMP] = ACTIONS(7528),
    [anon_sym_PIPE_PIPE] = ACTIONS(7526),
    [anon_sym_AMP_AMP] = ACTIONS(7526),
    [anon_sym_LT] = ACTIONS(7528),
    [anon_sym_LT_EQ] = ACTIONS(7526),
    [anon_sym_GT] = ACTIONS(7528),
    [anon_sym_GT_EQ] = ACTIONS(7526),
    [anon_sym_EQ_EQ] = ACTIONS(7526),
    [anon_sym_BANG_EQ] = ACTIONS(7526),
    [anon_sym_STAR] = ACTIONS(7528),
    [anon_sym_SLASH] = ACTIONS(7526),
    [anon_sym_STAR_STAR] = ACTIONS(7526),
    [anon_sym_CARET] = ACTIONS(7526),
    [aux_sym_binary_operator_token1] = ACTIONS(7526),
    [anon_sym_PIPE_GT] = ACTIONS(7526),
    [anon_sym_COLON] = ACTIONS(7528),
    [anon_sym_DOLLAR] = ACTIONS(7526),
    [anon_sym_AT] = ACTIONS(7526),
    [aux_sym__hex_literal_token1] = ACTIONS(7526),
    [sym__number_literal] = ACTIONS(7528),
    [anon_sym_SQUOTE] = ACTIONS(7526),
    [anon_sym_DQUOTE] = ACTIONS(7526),
    [sym_return] = ACTIONS(7528),
    [sym_next] = ACTIONS(7528),
    [sym_break] = ACTIONS(7528),
    [sym_true] = ACTIONS(7528),
    [sym_false] = ACTIONS(7528),
    [sym_null] = ACTIONS(7528),
    [sym_inf] = ACTIONS(7528),
    [sym_nan] = ACTIONS(7528),
    [anon_sym_NA] = ACTIONS(7528),
    [anon_sym_NA_integer_] = ACTIONS(7528),
    [anon_sym_NA_real_] = ACTIONS(7528),
    [anon_sym_NA_complex_] = ACTIONS(7528),
    [anon_sym_NA_character_] = ACTIONS(7528),
    [sym_dots] = ACTIONS(7528),
    [sym_dot_dot_i] = ACTIONS(7526),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7526),
    [sym__semicolon] = ACTIONS(7526),
    [sym__raw_string_literal] = ACTIONS(7526),
    [sym__external_else] = ACTIONS(7526),
    [sym__external_open_parenthesis] = ACTIONS(7526),
    [sym__external_open_brace] = ACTIONS(7526),
    [sym__external_open_bracket] = ACTIONS(7526),
    [sym__external_open_bracket2] = ACTIONS(7526),
  },
  [2923] = {
    [ts_builtin_sym_end] = ACTIONS(7530),
    [sym_identifier] = ACTIONS(7532),
    [anon_sym_BSLASH] = ACTIONS(7530),
    [anon_sym_function] = ACTIONS(7532),
    [anon_sym_EQ] = ACTIONS(7532),
    [anon_sym_if] = ACTIONS(7532),
    [anon_sym_for] = ACTIONS(7532),
    [anon_sym_while] = ACTIONS(7532),
    [anon_sym_repeat] = ACTIONS(7532),
    [anon_sym_QMARK] = ACTIONS(7530),
    [anon_sym_TILDE] = ACTIONS(7530),
    [anon_sym_BANG] = ACTIONS(7532),
    [anon_sym_PLUS] = ACTIONS(7530),
    [anon_sym_DASH] = ACTIONS(7532),
    [anon_sym_LT_DASH] = ACTIONS(7530),
    [anon_sym_LT_LT_DASH] = ACTIONS(7530),
    [anon_sym_COLON_EQ] = ACTIONS(7530),
    [anon_sym_DASH_GT] = ACTIONS(7532),
    [anon_sym_DASH_GT_GT] = ACTIONS(7530),
    [anon_sym_PIPE] = ACTIONS(7532),
    [anon_sym_AMP] = ACTIONS(7532),
    [anon_sym_PIPE_PIPE] = ACTIONS(7530),
    [anon_sym_AMP_AMP] = ACTIONS(7530),
    [anon_sym_LT] = ACTIONS(7532),
    [anon_sym_LT_EQ] = ACTIONS(7530),
    [anon_sym_GT] = ACTIONS(7532),
    [anon_sym_GT_EQ] = ACTIONS(7530),
    [anon_sym_EQ_EQ] = ACTIONS(7530),
    [anon_sym_BANG_EQ] = ACTIONS(7530),
    [anon_sym_STAR] = ACTIONS(7532),
    [anon_sym_SLASH] = ACTIONS(7530),
    [anon_sym_STAR_STAR] = ACTIONS(7530),
    [anon_sym_CARET] = ACTIONS(7530),
    [aux_sym_binary_operator_token1] = ACTIONS(7530),
    [anon_sym_PIPE_GT] = ACTIONS(7530),
    [anon_sym_COLON] = ACTIONS(7532),
    [anon_sym_DOLLAR] = ACTIONS(7530),
    [anon_sym_AT] = ACTIONS(7530),
    [aux_sym__hex_literal_token1] = ACTIONS(7530),
    [sym__number_literal] = ACTIONS(7532),
    [anon_sym_SQUOTE] = ACTIONS(7530),
    [anon_sym_DQUOTE] = ACTIONS(7530),
    [sym_return] = ACTIONS(7532),
    [sym_next] = ACTIONS(7532),
    [sym_break] = ACTIONS(7532),
    [sym_true] = ACTIONS(7532),
    [sym_false] = ACTIONS(7532),
    [sym_null] = ACTIONS(7532),
    [sym_inf] = ACTIONS(7532),
    [sym_nan] = ACTIONS(7532),
    [anon_sym_NA] = ACTIONS(7532),
    [anon_sym_NA_integer_] = ACTIONS(7532),
    [anon_sym_NA_real_] = ACTIONS(7532),
    [anon_sym_NA_complex_] = ACTIONS(7532),
    [anon_sym_NA_character_] = ACTIONS(7532),
    [sym_dots] = ACTIONS(7532),
    [sym_dot_dot_i] = ACTIONS(7530),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7530),
    [sym__semicolon] = ACTIONS(7530),
    [sym__raw_string_literal] = ACTIONS(7530),
    [sym__external_else] = ACTIONS(7530),
    [sym__external_open_parenthesis] = ACTIONS(7530),
    [sym__external_open_brace] = ACTIONS(7530),
    [sym__external_open_bracket] = ACTIONS(7530),
    [sym__external_open_bracket2] = ACTIONS(7530),
  },
  [2924] = {
    [sym_identifier] = ACTIONS(7567),
    [anon_sym_BSLASH] = ACTIONS(7565),
    [anon_sym_function] = ACTIONS(7567),
    [anon_sym_EQ] = ACTIONS(7567),
    [anon_sym_if] = ACTIONS(7567),
    [anon_sym_for] = ACTIONS(7567),
    [anon_sym_while] = ACTIONS(7567),
    [anon_sym_repeat] = ACTIONS(7567),
    [anon_sym_QMARK] = ACTIONS(7565),
    [anon_sym_TILDE] = ACTIONS(7565),
    [anon_sym_BANG] = ACTIONS(7567),
    [anon_sym_PLUS] = ACTIONS(7565),
    [anon_sym_DASH] = ACTIONS(7567),
    [anon_sym_LT_DASH] = ACTIONS(7565),
    [anon_sym_LT_LT_DASH] = ACTIONS(7565),
    [anon_sym_COLON_EQ] = ACTIONS(7565),
    [anon_sym_DASH_GT] = ACTIONS(7567),
    [anon_sym_DASH_GT_GT] = ACTIONS(7565),
    [anon_sym_PIPE] = ACTIONS(7567),
    [anon_sym_AMP] = ACTIONS(7567),
    [anon_sym_PIPE_PIPE] = ACTIONS(7565),
    [anon_sym_AMP_AMP] = ACTIONS(7565),
    [anon_sym_LT] = ACTIONS(7567),
    [anon_sym_LT_EQ] = ACTIONS(7565),
    [anon_sym_GT] = ACTIONS(7567),
    [anon_sym_GT_EQ] = ACTIONS(7565),
    [anon_sym_EQ_EQ] = ACTIONS(7565),
    [anon_sym_BANG_EQ] = ACTIONS(7565),
    [anon_sym_STAR] = ACTIONS(7567),
    [anon_sym_SLASH] = ACTIONS(7565),
    [anon_sym_STAR_STAR] = ACTIONS(7565),
    [anon_sym_CARET] = ACTIONS(7565),
    [aux_sym_binary_operator_token1] = ACTIONS(7565),
    [anon_sym_PIPE_GT] = ACTIONS(7565),
    [anon_sym_COLON] = ACTIONS(7567),
    [anon_sym_DOLLAR] = ACTIONS(7565),
    [anon_sym_AT] = ACTIONS(7565),
    [aux_sym__hex_literal_token1] = ACTIONS(7565),
    [sym__number_literal] = ACTIONS(7567),
    [anon_sym_SQUOTE] = ACTIONS(7565),
    [anon_sym_DQUOTE] = ACTIONS(7565),
    [sym_return] = ACTIONS(7567),
    [sym_next] = ACTIONS(7567),
    [sym_break] = ACTIONS(7567),
    [sym_true] = ACTIONS(7567),
    [sym_false] = ACTIONS(7567),
    [sym_null] = ACTIONS(7567),
    [sym_inf] = ACTIONS(7567),
    [sym_nan] = ACTIONS(7567),
    [anon_sym_NA] = ACTIONS(7567),
    [anon_sym_NA_integer_] = ACTIONS(7567),
    [anon_sym_NA_real_] = ACTIONS(7567),
    [anon_sym_NA_complex_] = ACTIONS(7567),
    [anon_sym_NA_character_] = ACTIONS(7567),
    [sym_dots] = ACTIONS(7567),
    [sym_dot_dot_i] = ACTIONS(7565),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7565),
    [sym__newline] = ACTIONS(7565),
    [sym__raw_string_literal] = ACTIONS(7565),
    [sym__external_else] = ACTIONS(7565),
    [sym__external_open_parenthesis] = ACTIONS(7565),
    [sym__external_close_parenthesis] = ACTIONS(7565),
    [sym__external_open_brace] = ACTIONS(7565),
    [sym__external_open_bracket] = ACTIONS(7565),
    [sym__external_open_bracket2] = ACTIONS(7565),
  },
  [2925] = {
    [sym_identifier] = ACTIONS(7540),
    [anon_sym_BSLASH] = ACTIONS(7538),
    [anon_sym_function] = ACTIONS(7540),
    [anon_sym_EQ] = ACTIONS(7540),
    [anon_sym_if] = ACTIONS(7540),
    [anon_sym_for] = ACTIONS(7540),
    [anon_sym_while] = ACTIONS(7540),
    [anon_sym_repeat] = ACTIONS(7540),
    [anon_sym_QMARK] = ACTIONS(7538),
    [anon_sym_TILDE] = ACTIONS(7538),
    [anon_sym_BANG] = ACTIONS(7540),
    [anon_sym_PLUS] = ACTIONS(7538),
    [anon_sym_DASH] = ACTIONS(7540),
    [anon_sym_LT_DASH] = ACTIONS(7538),
    [anon_sym_LT_LT_DASH] = ACTIONS(7538),
    [anon_sym_COLON_EQ] = ACTIONS(7538),
    [anon_sym_DASH_GT] = ACTIONS(7540),
    [anon_sym_DASH_GT_GT] = ACTIONS(7538),
    [anon_sym_PIPE] = ACTIONS(7540),
    [anon_sym_AMP] = ACTIONS(7540),
    [anon_sym_PIPE_PIPE] = ACTIONS(7538),
    [anon_sym_AMP_AMP] = ACTIONS(7538),
    [anon_sym_LT] = ACTIONS(7540),
    [anon_sym_LT_EQ] = ACTIONS(7538),
    [anon_sym_GT] = ACTIONS(7540),
    [anon_sym_GT_EQ] = ACTIONS(7538),
    [anon_sym_EQ_EQ] = ACTIONS(7538),
    [anon_sym_BANG_EQ] = ACTIONS(7538),
    [anon_sym_STAR] = ACTIONS(7540),
    [anon_sym_SLASH] = ACTIONS(7538),
    [anon_sym_STAR_STAR] = ACTIONS(7538),
    [anon_sym_CARET] = ACTIONS(7538),
    [aux_sym_binary_operator_token1] = ACTIONS(7538),
    [anon_sym_PIPE_GT] = ACTIONS(7538),
    [anon_sym_COLON] = ACTIONS(7540),
    [anon_sym_DOLLAR] = ACTIONS(7538),
    [anon_sym_AT] = ACTIONS(7538),
    [aux_sym__hex_literal_token1] = ACTIONS(7538),
    [sym__number_literal] = ACTIONS(7540),
    [anon_sym_SQUOTE] = ACTIONS(7538),
    [anon_sym_DQUOTE] = ACTIONS(7538),
    [sym_return] = ACTIONS(7540),
    [sym_next] = ACTIONS(7540),
    [sym_break] = ACTIONS(7540),
    [sym_true] = ACTIONS(7540),
    [sym_false] = ACTIONS(7540),
    [sym_null] = ACTIONS(7540),
    [sym_inf] = ACTIONS(7540),
    [sym_nan] = ACTIONS(7540),
    [anon_sym_NA] = ACTIONS(7540),
    [anon_sym_NA_integer_] = ACTIONS(7540),
    [anon_sym_NA_real_] = ACTIONS(7540),
    [anon_sym_NA_complex_] = ACTIONS(7540),
    [anon_sym_NA_character_] = ACTIONS(7540),
    [sym_dots] = ACTIONS(7540),
    [sym_dot_dot_i] = ACTIONS(7538),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7538),
    [sym__newline] = ACTIONS(7538),
    [sym__raw_string_literal] = ACTIONS(7538),
    [sym__external_open_parenthesis] = ACTIONS(7538),
    [sym__external_close_parenthesis] = ACTIONS(7538),
    [sym__external_open_brace] = ACTIONS(7538),
    [sym__external_open_bracket] = ACTIONS(7538),
    [sym__external_open_bracket2] = ACTIONS(7538),
    [sym__external_close_bracket2] = ACTIONS(7538),
  },
  [2926] = {
    [sym_identifier] = ACTIONS(7556),
    [anon_sym_BSLASH] = ACTIONS(7554),
    [anon_sym_function] = ACTIONS(7556),
    [anon_sym_EQ] = ACTIONS(7556),
    [anon_sym_if] = ACTIONS(7556),
    [anon_sym_for] = ACTIONS(7556),
    [anon_sym_while] = ACTIONS(7556),
    [anon_sym_repeat] = ACTIONS(7556),
    [anon_sym_QMARK] = ACTIONS(7554),
    [anon_sym_TILDE] = ACTIONS(7554),
    [anon_sym_BANG] = ACTIONS(7556),
    [anon_sym_PLUS] = ACTIONS(7554),
    [anon_sym_DASH] = ACTIONS(7556),
    [anon_sym_LT_DASH] = ACTIONS(7554),
    [anon_sym_LT_LT_DASH] = ACTIONS(7554),
    [anon_sym_COLON_EQ] = ACTIONS(7554),
    [anon_sym_DASH_GT] = ACTIONS(7556),
    [anon_sym_DASH_GT_GT] = ACTIONS(7554),
    [anon_sym_PIPE] = ACTIONS(7556),
    [anon_sym_AMP] = ACTIONS(7556),
    [anon_sym_PIPE_PIPE] = ACTIONS(7554),
    [anon_sym_AMP_AMP] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(7556),
    [anon_sym_LT_EQ] = ACTIONS(7554),
    [anon_sym_GT] = ACTIONS(7556),
    [anon_sym_GT_EQ] = ACTIONS(7554),
    [anon_sym_EQ_EQ] = ACTIONS(7554),
    [anon_sym_BANG_EQ] = ACTIONS(7554),
    [anon_sym_STAR] = ACTIONS(7556),
    [anon_sym_SLASH] = ACTIONS(7554),
    [anon_sym_STAR_STAR] = ACTIONS(7554),
    [anon_sym_CARET] = ACTIONS(7554),
    [aux_sym_binary_operator_token1] = ACTIONS(7554),
    [anon_sym_PIPE_GT] = ACTIONS(7554),
    [anon_sym_COLON] = ACTIONS(7556),
    [anon_sym_DOLLAR] = ACTIONS(7554),
    [anon_sym_AT] = ACTIONS(7554),
    [aux_sym__hex_literal_token1] = ACTIONS(7554),
    [sym__number_literal] = ACTIONS(7556),
    [anon_sym_SQUOTE] = ACTIONS(7554),
    [anon_sym_DQUOTE] = ACTIONS(7554),
    [sym_return] = ACTIONS(7556),
    [sym_next] = ACTIONS(7556),
    [sym_break] = ACTIONS(7556),
    [sym_true] = ACTIONS(7556),
    [sym_false] = ACTIONS(7556),
    [sym_null] = ACTIONS(7556),
    [sym_inf] = ACTIONS(7556),
    [sym_nan] = ACTIONS(7556),
    [anon_sym_NA] = ACTIONS(7556),
    [anon_sym_NA_integer_] = ACTIONS(7556),
    [anon_sym_NA_real_] = ACTIONS(7556),
    [anon_sym_NA_complex_] = ACTIONS(7556),
    [anon_sym_NA_character_] = ACTIONS(7556),
    [sym_dots] = ACTIONS(7556),
    [sym_dot_dot_i] = ACTIONS(7554),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7554),
    [sym__newline] = ACTIONS(7554),
    [sym__raw_string_literal] = ACTIONS(7554),
    [sym__external_open_parenthesis] = ACTIONS(7554),
    [sym__external_close_parenthesis] = ACTIONS(7554),
    [sym__external_open_brace] = ACTIONS(7554),
    [sym__external_open_bracket] = ACTIONS(7554),
    [sym__external_open_bracket2] = ACTIONS(7554),
    [sym__external_close_bracket2] = ACTIONS(7554),
  },
  [2927] = {
    [ts_builtin_sym_end] = ACTIONS(7542),
    [sym_identifier] = ACTIONS(7544),
    [anon_sym_BSLASH] = ACTIONS(7542),
    [anon_sym_function] = ACTIONS(7544),
    [anon_sym_EQ] = ACTIONS(7544),
    [anon_sym_if] = ACTIONS(7544),
    [anon_sym_for] = ACTIONS(7544),
    [anon_sym_while] = ACTIONS(7544),
    [anon_sym_repeat] = ACTIONS(7544),
    [anon_sym_QMARK] = ACTIONS(7542),
    [anon_sym_TILDE] = ACTIONS(7542),
    [anon_sym_BANG] = ACTIONS(7544),
    [anon_sym_PLUS] = ACTIONS(7542),
    [anon_sym_DASH] = ACTIONS(7544),
    [anon_sym_LT_DASH] = ACTIONS(7542),
    [anon_sym_LT_LT_DASH] = ACTIONS(7542),
    [anon_sym_COLON_EQ] = ACTIONS(7542),
    [anon_sym_DASH_GT] = ACTIONS(7544),
    [anon_sym_DASH_GT_GT] = ACTIONS(7542),
    [anon_sym_PIPE] = ACTIONS(7544),
    [anon_sym_AMP] = ACTIONS(7544),
    [anon_sym_PIPE_PIPE] = ACTIONS(7542),
    [anon_sym_AMP_AMP] = ACTIONS(7542),
    [anon_sym_LT] = ACTIONS(7544),
    [anon_sym_LT_EQ] = ACTIONS(7542),
    [anon_sym_GT] = ACTIONS(7544),
    [anon_sym_GT_EQ] = ACTIONS(7542),
    [anon_sym_EQ_EQ] = ACTIONS(7542),
    [anon_sym_BANG_EQ] = ACTIONS(7542),
    [anon_sym_STAR] = ACTIONS(7544),
    [anon_sym_SLASH] = ACTIONS(7542),
    [anon_sym_STAR_STAR] = ACTIONS(7542),
    [anon_sym_CARET] = ACTIONS(7542),
    [aux_sym_binary_operator_token1] = ACTIONS(7542),
    [anon_sym_PIPE_GT] = ACTIONS(7542),
    [anon_sym_COLON] = ACTIONS(7544),
    [anon_sym_DOLLAR] = ACTIONS(7542),
    [anon_sym_AT] = ACTIONS(7542),
    [aux_sym__hex_literal_token1] = ACTIONS(7542),
    [sym__number_literal] = ACTIONS(7544),
    [anon_sym_SQUOTE] = ACTIONS(7542),
    [anon_sym_DQUOTE] = ACTIONS(7542),
    [sym_return] = ACTIONS(7544),
    [sym_next] = ACTIONS(7544),
    [sym_break] = ACTIONS(7544),
    [sym_true] = ACTIONS(7544),
    [sym_false] = ACTIONS(7544),
    [sym_null] = ACTIONS(7544),
    [sym_inf] = ACTIONS(7544),
    [sym_nan] = ACTIONS(7544),
    [anon_sym_NA] = ACTIONS(7544),
    [anon_sym_NA_integer_] = ACTIONS(7544),
    [anon_sym_NA_real_] = ACTIONS(7544),
    [anon_sym_NA_complex_] = ACTIONS(7544),
    [anon_sym_NA_character_] = ACTIONS(7544),
    [sym_dots] = ACTIONS(7544),
    [sym_dot_dot_i] = ACTIONS(7542),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7542),
    [sym__semicolon] = ACTIONS(7542),
    [sym__raw_string_literal] = ACTIONS(7542),
    [sym__external_else] = ACTIONS(7542),
    [sym__external_open_parenthesis] = ACTIONS(7542),
    [sym__external_open_brace] = ACTIONS(7542),
    [sym__external_open_bracket] = ACTIONS(7542),
    [sym__external_open_bracket2] = ACTIONS(7542),
  },
  [2928] = {
    [ts_builtin_sym_end] = ACTIONS(7484),
    [sym_identifier] = ACTIONS(7486),
    [anon_sym_BSLASH] = ACTIONS(7484),
    [anon_sym_function] = ACTIONS(7486),
    [anon_sym_EQ] = ACTIONS(7486),
    [anon_sym_if] = ACTIONS(7486),
    [anon_sym_for] = ACTIONS(7486),
    [anon_sym_while] = ACTIONS(7486),
    [anon_sym_repeat] = ACTIONS(7486),
    [anon_sym_QMARK] = ACTIONS(7484),
    [anon_sym_TILDE] = ACTIONS(7484),
    [anon_sym_BANG] = ACTIONS(7486),
    [anon_sym_PLUS] = ACTIONS(7484),
    [anon_sym_DASH] = ACTIONS(7486),
    [anon_sym_LT_DASH] = ACTIONS(7484),
    [anon_sym_LT_LT_DASH] = ACTIONS(7484),
    [anon_sym_COLON_EQ] = ACTIONS(7484),
    [anon_sym_DASH_GT] = ACTIONS(7486),
    [anon_sym_DASH_GT_GT] = ACTIONS(7484),
    [anon_sym_PIPE] = ACTIONS(7486),
    [anon_sym_AMP] = ACTIONS(7486),
    [anon_sym_PIPE_PIPE] = ACTIONS(7484),
    [anon_sym_AMP_AMP] = ACTIONS(7484),
    [anon_sym_LT] = ACTIONS(7486),
    [anon_sym_LT_EQ] = ACTIONS(7484),
    [anon_sym_GT] = ACTIONS(7486),
    [anon_sym_GT_EQ] = ACTIONS(7484),
    [anon_sym_EQ_EQ] = ACTIONS(7484),
    [anon_sym_BANG_EQ] = ACTIONS(7484),
    [anon_sym_STAR] = ACTIONS(7486),
    [anon_sym_SLASH] = ACTIONS(7484),
    [anon_sym_STAR_STAR] = ACTIONS(7484),
    [anon_sym_CARET] = ACTIONS(7484),
    [aux_sym_binary_operator_token1] = ACTIONS(7484),
    [anon_sym_PIPE_GT] = ACTIONS(7484),
    [anon_sym_COLON] = ACTIONS(7486),
    [anon_sym_DOLLAR] = ACTIONS(7484),
    [anon_sym_AT] = ACTIONS(7484),
    [aux_sym__hex_literal_token1] = ACTIONS(7484),
    [sym__number_literal] = ACTIONS(7486),
    [anon_sym_SQUOTE] = ACTIONS(7484),
    [anon_sym_DQUOTE] = ACTIONS(7484),
    [sym_return] = ACTIONS(7486),
    [sym_next] = ACTIONS(7486),
    [sym_break] = ACTIONS(7486),
    [sym_true] = ACTIONS(7486),
    [sym_false] = ACTIONS(7486),
    [sym_null] = ACTIONS(7486),
    [sym_inf] = ACTIONS(7486),
    [sym_nan] = ACTIONS(7486),
    [anon_sym_NA] = ACTIONS(7486),
    [anon_sym_NA_integer_] = ACTIONS(7486),
    [anon_sym_NA_real_] = ACTIONS(7486),
    [anon_sym_NA_complex_] = ACTIONS(7486),
    [anon_sym_NA_character_] = ACTIONS(7486),
    [sym_dots] = ACTIONS(7486),
    [sym_dot_dot_i] = ACTIONS(7484),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7484),
    [sym__semicolon] = ACTIONS(7484),
    [sym__raw_string_literal] = ACTIONS(7484),
    [sym__external_open_parenthesis] = ACTIONS(7484),
    [sym__external_open_brace] = ACTIONS(7484),
    [sym__external_close_brace] = ACTIONS(7484),
    [sym__external_open_bracket] = ACTIONS(7484),
    [sym__external_open_bracket2] = ACTIONS(7484),
  },
  [2929] = {
    [ts_builtin_sym_end] = ACTIONS(7554),
    [sym_identifier] = ACTIONS(7556),
    [anon_sym_BSLASH] = ACTIONS(7554),
    [anon_sym_function] = ACTIONS(7556),
    [anon_sym_EQ] = ACTIONS(7556),
    [anon_sym_if] = ACTIONS(7556),
    [anon_sym_for] = ACTIONS(7556),
    [anon_sym_while] = ACTIONS(7556),
    [anon_sym_repeat] = ACTIONS(7556),
    [anon_sym_QMARK] = ACTIONS(7554),
    [anon_sym_TILDE] = ACTIONS(7554),
    [anon_sym_BANG] = ACTIONS(7556),
    [anon_sym_PLUS] = ACTIONS(7554),
    [anon_sym_DASH] = ACTIONS(7556),
    [anon_sym_LT_DASH] = ACTIONS(7554),
    [anon_sym_LT_LT_DASH] = ACTIONS(7554),
    [anon_sym_COLON_EQ] = ACTIONS(7554),
    [anon_sym_DASH_GT] = ACTIONS(7556),
    [anon_sym_DASH_GT_GT] = ACTIONS(7554),
    [anon_sym_PIPE] = ACTIONS(7556),
    [anon_sym_AMP] = ACTIONS(7556),
    [anon_sym_PIPE_PIPE] = ACTIONS(7554),
    [anon_sym_AMP_AMP] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(7556),
    [anon_sym_LT_EQ] = ACTIONS(7554),
    [anon_sym_GT] = ACTIONS(7556),
    [anon_sym_GT_EQ] = ACTIONS(7554),
    [anon_sym_EQ_EQ] = ACTIONS(7554),
    [anon_sym_BANG_EQ] = ACTIONS(7554),
    [anon_sym_STAR] = ACTIONS(7556),
    [anon_sym_SLASH] = ACTIONS(7554),
    [anon_sym_STAR_STAR] = ACTIONS(7554),
    [anon_sym_CARET] = ACTIONS(7554),
    [aux_sym_binary_operator_token1] = ACTIONS(7554),
    [anon_sym_PIPE_GT] = ACTIONS(7554),
    [anon_sym_COLON] = ACTIONS(7556),
    [anon_sym_DOLLAR] = ACTIONS(7554),
    [anon_sym_AT] = ACTIONS(7554),
    [aux_sym__hex_literal_token1] = ACTIONS(7554),
    [sym__number_literal] = ACTIONS(7556),
    [anon_sym_SQUOTE] = ACTIONS(7554),
    [anon_sym_DQUOTE] = ACTIONS(7554),
    [sym_return] = ACTIONS(7556),
    [sym_next] = ACTIONS(7556),
    [sym_break] = ACTIONS(7556),
    [sym_true] = ACTIONS(7556),
    [sym_false] = ACTIONS(7556),
    [sym_null] = ACTIONS(7556),
    [sym_inf] = ACTIONS(7556),
    [sym_nan] = ACTIONS(7556),
    [anon_sym_NA] = ACTIONS(7556),
    [anon_sym_NA_integer_] = ACTIONS(7556),
    [anon_sym_NA_real_] = ACTIONS(7556),
    [anon_sym_NA_complex_] = ACTIONS(7556),
    [anon_sym_NA_character_] = ACTIONS(7556),
    [sym_dots] = ACTIONS(7556),
    [sym_dot_dot_i] = ACTIONS(7554),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7554),
    [sym__semicolon] = ACTIONS(7554),
    [sym__raw_string_literal] = ACTIONS(7554),
    [sym__external_open_parenthesis] = ACTIONS(7554),
    [sym__external_open_brace] = ACTIONS(7554),
    [sym__external_close_brace] = ACTIONS(7554),
    [sym__external_open_bracket] = ACTIONS(7554),
    [sym__external_open_bracket2] = ACTIONS(7554),
  },
  [2930] = {
    [ts_builtin_sym_end] = ACTIONS(7561),
    [sym_identifier] = ACTIONS(7563),
    [anon_sym_BSLASH] = ACTIONS(7561),
    [anon_sym_function] = ACTIONS(7563),
    [anon_sym_EQ] = ACTIONS(7563),
    [anon_sym_if] = ACTIONS(7563),
    [anon_sym_for] = ACTIONS(7563),
    [anon_sym_while] = ACTIONS(7563),
    [anon_sym_repeat] = ACTIONS(7563),
    [anon_sym_QMARK] = ACTIONS(7561),
    [anon_sym_TILDE] = ACTIONS(7561),
    [anon_sym_BANG] = ACTIONS(7563),
    [anon_sym_PLUS] = ACTIONS(7561),
    [anon_sym_DASH] = ACTIONS(7563),
    [anon_sym_LT_DASH] = ACTIONS(7561),
    [anon_sym_LT_LT_DASH] = ACTIONS(7561),
    [anon_sym_COLON_EQ] = ACTIONS(7561),
    [anon_sym_DASH_GT] = ACTIONS(7563),
    [anon_sym_DASH_GT_GT] = ACTIONS(7561),
    [anon_sym_PIPE] = ACTIONS(7563),
    [anon_sym_AMP] = ACTIONS(7563),
    [anon_sym_PIPE_PIPE] = ACTIONS(7561),
    [anon_sym_AMP_AMP] = ACTIONS(7561),
    [anon_sym_LT] = ACTIONS(7563),
    [anon_sym_LT_EQ] = ACTIONS(7561),
    [anon_sym_GT] = ACTIONS(7563),
    [anon_sym_GT_EQ] = ACTIONS(7561),
    [anon_sym_EQ_EQ] = ACTIONS(7561),
    [anon_sym_BANG_EQ] = ACTIONS(7561),
    [anon_sym_STAR] = ACTIONS(7563),
    [anon_sym_SLASH] = ACTIONS(7561),
    [anon_sym_STAR_STAR] = ACTIONS(7561),
    [anon_sym_CARET] = ACTIONS(7561),
    [aux_sym_binary_operator_token1] = ACTIONS(7561),
    [anon_sym_PIPE_GT] = ACTIONS(7561),
    [anon_sym_COLON] = ACTIONS(7563),
    [anon_sym_DOLLAR] = ACTIONS(7561),
    [anon_sym_AT] = ACTIONS(7561),
    [aux_sym__hex_literal_token1] = ACTIONS(7561),
    [sym__number_literal] = ACTIONS(7563),
    [anon_sym_SQUOTE] = ACTIONS(7561),
    [anon_sym_DQUOTE] = ACTIONS(7561),
    [sym_return] = ACTIONS(7563),
    [sym_next] = ACTIONS(7563),
    [sym_break] = ACTIONS(7563),
    [sym_true] = ACTIONS(7563),
    [sym_false] = ACTIONS(7563),
    [sym_null] = ACTIONS(7563),
    [sym_inf] = ACTIONS(7563),
    [sym_nan] = ACTIONS(7563),
    [anon_sym_NA] = ACTIONS(7563),
    [anon_sym_NA_integer_] = ACTIONS(7563),
    [anon_sym_NA_real_] = ACTIONS(7563),
    [anon_sym_NA_complex_] = ACTIONS(7563),
    [anon_sym_NA_character_] = ACTIONS(7563),
    [sym_dots] = ACTIONS(7563),
    [sym_dot_dot_i] = ACTIONS(7561),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7561),
    [sym__semicolon] = ACTIONS(7561),
    [sym__raw_string_literal] = ACTIONS(7561),
    [sym__external_open_parenthesis] = ACTIONS(7561),
    [sym__external_open_brace] = ACTIONS(7561),
    [sym__external_close_brace] = ACTIONS(7561),
    [sym__external_open_bracket] = ACTIONS(7561),
    [sym__external_open_bracket2] = ACTIONS(7561),
  },
  [2931] = {
    [sym_identifier] = ACTIONS(7486),
    [anon_sym_BSLASH] = ACTIONS(7484),
    [anon_sym_function] = ACTIONS(7486),
    [anon_sym_EQ] = ACTIONS(7486),
    [anon_sym_if] = ACTIONS(7486),
    [anon_sym_for] = ACTIONS(7486),
    [anon_sym_while] = ACTIONS(7486),
    [anon_sym_repeat] = ACTIONS(7486),
    [anon_sym_QMARK] = ACTIONS(7484),
    [anon_sym_TILDE] = ACTIONS(7484),
    [anon_sym_BANG] = ACTIONS(7486),
    [anon_sym_PLUS] = ACTIONS(7484),
    [anon_sym_DASH] = ACTIONS(7486),
    [anon_sym_LT_DASH] = ACTIONS(7484),
    [anon_sym_LT_LT_DASH] = ACTIONS(7484),
    [anon_sym_COLON_EQ] = ACTIONS(7484),
    [anon_sym_DASH_GT] = ACTIONS(7486),
    [anon_sym_DASH_GT_GT] = ACTIONS(7484),
    [anon_sym_PIPE] = ACTIONS(7486),
    [anon_sym_AMP] = ACTIONS(7486),
    [anon_sym_PIPE_PIPE] = ACTIONS(7484),
    [anon_sym_AMP_AMP] = ACTIONS(7484),
    [anon_sym_LT] = ACTIONS(7486),
    [anon_sym_LT_EQ] = ACTIONS(7484),
    [anon_sym_GT] = ACTIONS(7486),
    [anon_sym_GT_EQ] = ACTIONS(7484),
    [anon_sym_EQ_EQ] = ACTIONS(7484),
    [anon_sym_BANG_EQ] = ACTIONS(7484),
    [anon_sym_STAR] = ACTIONS(7486),
    [anon_sym_SLASH] = ACTIONS(7484),
    [anon_sym_STAR_STAR] = ACTIONS(7484),
    [anon_sym_CARET] = ACTIONS(7484),
    [aux_sym_binary_operator_token1] = ACTIONS(7484),
    [anon_sym_PIPE_GT] = ACTIONS(7484),
    [anon_sym_COLON] = ACTIONS(7486),
    [anon_sym_DOLLAR] = ACTIONS(7484),
    [anon_sym_AT] = ACTIONS(7484),
    [aux_sym__hex_literal_token1] = ACTIONS(7484),
    [sym__number_literal] = ACTIONS(7486),
    [anon_sym_SQUOTE] = ACTIONS(7484),
    [anon_sym_DQUOTE] = ACTIONS(7484),
    [sym_return] = ACTIONS(7486),
    [sym_next] = ACTIONS(7486),
    [sym_break] = ACTIONS(7486),
    [sym_true] = ACTIONS(7486),
    [sym_false] = ACTIONS(7486),
    [sym_null] = ACTIONS(7486),
    [sym_inf] = ACTIONS(7486),
    [sym_nan] = ACTIONS(7486),
    [anon_sym_NA] = ACTIONS(7486),
    [anon_sym_NA_integer_] = ACTIONS(7486),
    [anon_sym_NA_real_] = ACTIONS(7486),
    [anon_sym_NA_complex_] = ACTIONS(7486),
    [anon_sym_NA_character_] = ACTIONS(7486),
    [sym_dots] = ACTIONS(7486),
    [sym_dot_dot_i] = ACTIONS(7484),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7484),
    [sym__newline] = ACTIONS(7484),
    [sym__raw_string_literal] = ACTIONS(7484),
    [sym__external_else] = ACTIONS(7484),
    [sym__external_open_parenthesis] = ACTIONS(7484),
    [sym__external_open_brace] = ACTIONS(7484),
    [sym__external_open_bracket] = ACTIONS(7484),
    [sym__external_close_bracket] = ACTIONS(7484),
    [sym__external_open_bracket2] = ACTIONS(7484),
  },
  [2932] = {
    [ts_builtin_sym_end] = ACTIONS(7538),
    [sym_identifier] = ACTIONS(7540),
    [anon_sym_BSLASH] = ACTIONS(7538),
    [anon_sym_function] = ACTIONS(7540),
    [anon_sym_EQ] = ACTIONS(7540),
    [anon_sym_if] = ACTIONS(7540),
    [anon_sym_for] = ACTIONS(7540),
    [anon_sym_while] = ACTIONS(7540),
    [anon_sym_repeat] = ACTIONS(7540),
    [anon_sym_QMARK] = ACTIONS(7538),
    [anon_sym_TILDE] = ACTIONS(7538),
    [anon_sym_BANG] = ACTIONS(7540),
    [anon_sym_PLUS] = ACTIONS(7538),
    [anon_sym_DASH] = ACTIONS(7540),
    [anon_sym_LT_DASH] = ACTIONS(7538),
    [anon_sym_LT_LT_DASH] = ACTIONS(7538),
    [anon_sym_COLON_EQ] = ACTIONS(7538),
    [anon_sym_DASH_GT] = ACTIONS(7540),
    [anon_sym_DASH_GT_GT] = ACTIONS(7538),
    [anon_sym_PIPE] = ACTIONS(7540),
    [anon_sym_AMP] = ACTIONS(7540),
    [anon_sym_PIPE_PIPE] = ACTIONS(7538),
    [anon_sym_AMP_AMP] = ACTIONS(7538),
    [anon_sym_LT] = ACTIONS(7540),
    [anon_sym_LT_EQ] = ACTIONS(7538),
    [anon_sym_GT] = ACTIONS(7540),
    [anon_sym_GT_EQ] = ACTIONS(7538),
    [anon_sym_EQ_EQ] = ACTIONS(7538),
    [anon_sym_BANG_EQ] = ACTIONS(7538),
    [anon_sym_STAR] = ACTIONS(7540),
    [anon_sym_SLASH] = ACTIONS(7538),
    [anon_sym_STAR_STAR] = ACTIONS(7538),
    [anon_sym_CARET] = ACTIONS(7538),
    [aux_sym_binary_operator_token1] = ACTIONS(7538),
    [anon_sym_PIPE_GT] = ACTIONS(7538),
    [anon_sym_COLON] = ACTIONS(7540),
    [anon_sym_DOLLAR] = ACTIONS(7538),
    [anon_sym_AT] = ACTIONS(7538),
    [aux_sym__hex_literal_token1] = ACTIONS(7538),
    [sym__number_literal] = ACTIONS(7540),
    [anon_sym_SQUOTE] = ACTIONS(7538),
    [anon_sym_DQUOTE] = ACTIONS(7538),
    [sym_return] = ACTIONS(7540),
    [sym_next] = ACTIONS(7540),
    [sym_break] = ACTIONS(7540),
    [sym_true] = ACTIONS(7540),
    [sym_false] = ACTIONS(7540),
    [sym_null] = ACTIONS(7540),
    [sym_inf] = ACTIONS(7540),
    [sym_nan] = ACTIONS(7540),
    [anon_sym_NA] = ACTIONS(7540),
    [anon_sym_NA_integer_] = ACTIONS(7540),
    [anon_sym_NA_real_] = ACTIONS(7540),
    [anon_sym_NA_complex_] = ACTIONS(7540),
    [anon_sym_NA_character_] = ACTIONS(7540),
    [sym_dots] = ACTIONS(7540),
    [sym_dot_dot_i] = ACTIONS(7538),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7538),
    [sym__semicolon] = ACTIONS(7538),
    [sym__raw_string_literal] = ACTIONS(7538),
    [sym__external_else] = ACTIONS(7538),
    [sym__external_open_parenthesis] = ACTIONS(7538),
    [sym__external_open_brace] = ACTIONS(7538),
    [sym__external_open_bracket] = ACTIONS(7538),
    [sym__external_open_bracket2] = ACTIONS(7538),
  },
  [2933] = {
    [sym_identifier] = ACTIONS(7540),
    [anon_sym_BSLASH] = ACTIONS(7538),
    [anon_sym_function] = ACTIONS(7540),
    [anon_sym_EQ] = ACTIONS(7540),
    [anon_sym_if] = ACTIONS(7540),
    [anon_sym_for] = ACTIONS(7540),
    [anon_sym_while] = ACTIONS(7540),
    [anon_sym_repeat] = ACTIONS(7540),
    [anon_sym_QMARK] = ACTIONS(7538),
    [anon_sym_TILDE] = ACTIONS(7538),
    [anon_sym_BANG] = ACTIONS(7540),
    [anon_sym_PLUS] = ACTIONS(7538),
    [anon_sym_DASH] = ACTIONS(7540),
    [anon_sym_LT_DASH] = ACTIONS(7538),
    [anon_sym_LT_LT_DASH] = ACTIONS(7538),
    [anon_sym_COLON_EQ] = ACTIONS(7538),
    [anon_sym_DASH_GT] = ACTIONS(7540),
    [anon_sym_DASH_GT_GT] = ACTIONS(7538),
    [anon_sym_PIPE] = ACTIONS(7540),
    [anon_sym_AMP] = ACTIONS(7540),
    [anon_sym_PIPE_PIPE] = ACTIONS(7538),
    [anon_sym_AMP_AMP] = ACTIONS(7538),
    [anon_sym_LT] = ACTIONS(7540),
    [anon_sym_LT_EQ] = ACTIONS(7538),
    [anon_sym_GT] = ACTIONS(7540),
    [anon_sym_GT_EQ] = ACTIONS(7538),
    [anon_sym_EQ_EQ] = ACTIONS(7538),
    [anon_sym_BANG_EQ] = ACTIONS(7538),
    [anon_sym_STAR] = ACTIONS(7540),
    [anon_sym_SLASH] = ACTIONS(7538),
    [anon_sym_STAR_STAR] = ACTIONS(7538),
    [anon_sym_CARET] = ACTIONS(7538),
    [aux_sym_binary_operator_token1] = ACTIONS(7538),
    [anon_sym_PIPE_GT] = ACTIONS(7538),
    [anon_sym_COLON] = ACTIONS(7540),
    [anon_sym_DOLLAR] = ACTIONS(7538),
    [anon_sym_AT] = ACTIONS(7538),
    [aux_sym__hex_literal_token1] = ACTIONS(7538),
    [sym__number_literal] = ACTIONS(7540),
    [anon_sym_SQUOTE] = ACTIONS(7538),
    [anon_sym_DQUOTE] = ACTIONS(7538),
    [sym_return] = ACTIONS(7540),
    [sym_next] = ACTIONS(7540),
    [sym_break] = ACTIONS(7540),
    [sym_true] = ACTIONS(7540),
    [sym_false] = ACTIONS(7540),
    [sym_null] = ACTIONS(7540),
    [sym_inf] = ACTIONS(7540),
    [sym_nan] = ACTIONS(7540),
    [anon_sym_NA] = ACTIONS(7540),
    [anon_sym_NA_integer_] = ACTIONS(7540),
    [anon_sym_NA_real_] = ACTIONS(7540),
    [anon_sym_NA_complex_] = ACTIONS(7540),
    [anon_sym_NA_character_] = ACTIONS(7540),
    [sym_dots] = ACTIONS(7540),
    [sym_dot_dot_i] = ACTIONS(7538),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7538),
    [sym__newline] = ACTIONS(7538),
    [sym__raw_string_literal] = ACTIONS(7538),
    [sym__external_else] = ACTIONS(7538),
    [sym__external_open_parenthesis] = ACTIONS(7538),
    [sym__external_open_brace] = ACTIONS(7538),
    [sym__external_open_bracket] = ACTIONS(7538),
    [sym__external_close_bracket] = ACTIONS(7538),
    [sym__external_open_bracket2] = ACTIONS(7538),
  },
  [2934] = {
    [sym_identifier] = ACTIONS(7544),
    [anon_sym_BSLASH] = ACTIONS(7542),
    [anon_sym_function] = ACTIONS(7544),
    [anon_sym_EQ] = ACTIONS(7544),
    [anon_sym_if] = ACTIONS(7544),
    [anon_sym_for] = ACTIONS(7544),
    [anon_sym_while] = ACTIONS(7544),
    [anon_sym_repeat] = ACTIONS(7544),
    [anon_sym_QMARK] = ACTIONS(7542),
    [anon_sym_TILDE] = ACTIONS(7542),
    [anon_sym_BANG] = ACTIONS(7544),
    [anon_sym_PLUS] = ACTIONS(7542),
    [anon_sym_DASH] = ACTIONS(7544),
    [anon_sym_LT_DASH] = ACTIONS(7542),
    [anon_sym_LT_LT_DASH] = ACTIONS(7542),
    [anon_sym_COLON_EQ] = ACTIONS(7542),
    [anon_sym_DASH_GT] = ACTIONS(7544),
    [anon_sym_DASH_GT_GT] = ACTIONS(7542),
    [anon_sym_PIPE] = ACTIONS(7544),
    [anon_sym_AMP] = ACTIONS(7544),
    [anon_sym_PIPE_PIPE] = ACTIONS(7542),
    [anon_sym_AMP_AMP] = ACTIONS(7542),
    [anon_sym_LT] = ACTIONS(7544),
    [anon_sym_LT_EQ] = ACTIONS(7542),
    [anon_sym_GT] = ACTIONS(7544),
    [anon_sym_GT_EQ] = ACTIONS(7542),
    [anon_sym_EQ_EQ] = ACTIONS(7542),
    [anon_sym_BANG_EQ] = ACTIONS(7542),
    [anon_sym_STAR] = ACTIONS(7544),
    [anon_sym_SLASH] = ACTIONS(7542),
    [anon_sym_STAR_STAR] = ACTIONS(7542),
    [anon_sym_CARET] = ACTIONS(7542),
    [aux_sym_binary_operator_token1] = ACTIONS(7542),
    [anon_sym_PIPE_GT] = ACTIONS(7542),
    [anon_sym_COLON] = ACTIONS(7544),
    [anon_sym_DOLLAR] = ACTIONS(7542),
    [anon_sym_AT] = ACTIONS(7542),
    [aux_sym__hex_literal_token1] = ACTIONS(7542),
    [sym__number_literal] = ACTIONS(7544),
    [anon_sym_SQUOTE] = ACTIONS(7542),
    [anon_sym_DQUOTE] = ACTIONS(7542),
    [sym_return] = ACTIONS(7544),
    [sym_next] = ACTIONS(7544),
    [sym_break] = ACTIONS(7544),
    [sym_true] = ACTIONS(7544),
    [sym_false] = ACTIONS(7544),
    [sym_null] = ACTIONS(7544),
    [sym_inf] = ACTIONS(7544),
    [sym_nan] = ACTIONS(7544),
    [anon_sym_NA] = ACTIONS(7544),
    [anon_sym_NA_integer_] = ACTIONS(7544),
    [anon_sym_NA_real_] = ACTIONS(7544),
    [anon_sym_NA_complex_] = ACTIONS(7544),
    [anon_sym_NA_character_] = ACTIONS(7544),
    [sym_dots] = ACTIONS(7544),
    [sym_dot_dot_i] = ACTIONS(7542),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7542),
    [sym__newline] = ACTIONS(7542),
    [sym__raw_string_literal] = ACTIONS(7542),
    [sym__external_else] = ACTIONS(7542),
    [sym__external_open_parenthesis] = ACTIONS(7542),
    [sym__external_close_parenthesis] = ACTIONS(7542),
    [sym__external_open_brace] = ACTIONS(7542),
    [sym__external_open_bracket] = ACTIONS(7542),
    [sym__external_open_bracket2] = ACTIONS(7542),
  },
  [2935] = {
    [sym_identifier] = ACTIONS(7540),
    [anon_sym_BSLASH] = ACTIONS(7538),
    [anon_sym_function] = ACTIONS(7540),
    [anon_sym_EQ] = ACTIONS(7540),
    [anon_sym_if] = ACTIONS(7540),
    [anon_sym_for] = ACTIONS(7540),
    [anon_sym_while] = ACTIONS(7540),
    [anon_sym_repeat] = ACTIONS(7540),
    [anon_sym_QMARK] = ACTIONS(7538),
    [anon_sym_TILDE] = ACTIONS(7538),
    [anon_sym_BANG] = ACTIONS(7540),
    [anon_sym_PLUS] = ACTIONS(7538),
    [anon_sym_DASH] = ACTIONS(7540),
    [anon_sym_LT_DASH] = ACTIONS(7538),
    [anon_sym_LT_LT_DASH] = ACTIONS(7538),
    [anon_sym_COLON_EQ] = ACTIONS(7538),
    [anon_sym_DASH_GT] = ACTIONS(7540),
    [anon_sym_DASH_GT_GT] = ACTIONS(7538),
    [anon_sym_PIPE] = ACTIONS(7540),
    [anon_sym_AMP] = ACTIONS(7540),
    [anon_sym_PIPE_PIPE] = ACTIONS(7538),
    [anon_sym_AMP_AMP] = ACTIONS(7538),
    [anon_sym_LT] = ACTIONS(7540),
    [anon_sym_LT_EQ] = ACTIONS(7538),
    [anon_sym_GT] = ACTIONS(7540),
    [anon_sym_GT_EQ] = ACTIONS(7538),
    [anon_sym_EQ_EQ] = ACTIONS(7538),
    [anon_sym_BANG_EQ] = ACTIONS(7538),
    [anon_sym_STAR] = ACTIONS(7540),
    [anon_sym_SLASH] = ACTIONS(7538),
    [anon_sym_STAR_STAR] = ACTIONS(7538),
    [anon_sym_CARET] = ACTIONS(7538),
    [aux_sym_binary_operator_token1] = ACTIONS(7538),
    [anon_sym_PIPE_GT] = ACTIONS(7538),
    [anon_sym_COLON] = ACTIONS(7540),
    [anon_sym_DOLLAR] = ACTIONS(7538),
    [anon_sym_AT] = ACTIONS(7538),
    [aux_sym__hex_literal_token1] = ACTIONS(7538),
    [sym__number_literal] = ACTIONS(7540),
    [anon_sym_SQUOTE] = ACTIONS(7538),
    [anon_sym_DQUOTE] = ACTIONS(7538),
    [sym_return] = ACTIONS(7540),
    [sym_next] = ACTIONS(7540),
    [sym_break] = ACTIONS(7540),
    [sym_true] = ACTIONS(7540),
    [sym_false] = ACTIONS(7540),
    [sym_null] = ACTIONS(7540),
    [sym_inf] = ACTIONS(7540),
    [sym_nan] = ACTIONS(7540),
    [anon_sym_NA] = ACTIONS(7540),
    [anon_sym_NA_integer_] = ACTIONS(7540),
    [anon_sym_NA_real_] = ACTIONS(7540),
    [anon_sym_NA_complex_] = ACTIONS(7540),
    [anon_sym_NA_character_] = ACTIONS(7540),
    [sym_dots] = ACTIONS(7540),
    [sym_dot_dot_i] = ACTIONS(7538),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7538),
    [sym__newline] = ACTIONS(7538),
    [sym__raw_string_literal] = ACTIONS(7538),
    [sym__external_else] = ACTIONS(7538),
    [sym__external_open_parenthesis] = ACTIONS(7538),
    [sym__external_close_parenthesis] = ACTIONS(7538),
    [sym__external_open_brace] = ACTIONS(7538),
    [sym__external_open_bracket] = ACTIONS(7538),
    [sym__external_open_bracket2] = ACTIONS(7538),
  },
  [2936] = {
    [sym_identifier] = ACTIONS(7482),
    [anon_sym_BSLASH] = ACTIONS(7480),
    [anon_sym_function] = ACTIONS(7482),
    [anon_sym_EQ] = ACTIONS(7482),
    [anon_sym_if] = ACTIONS(7482),
    [anon_sym_for] = ACTIONS(7482),
    [anon_sym_while] = ACTIONS(7482),
    [anon_sym_repeat] = ACTIONS(7482),
    [anon_sym_QMARK] = ACTIONS(7480),
    [anon_sym_TILDE] = ACTIONS(7480),
    [anon_sym_BANG] = ACTIONS(7482),
    [anon_sym_PLUS] = ACTIONS(7480),
    [anon_sym_DASH] = ACTIONS(7482),
    [anon_sym_LT_DASH] = ACTIONS(7480),
    [anon_sym_LT_LT_DASH] = ACTIONS(7480),
    [anon_sym_COLON_EQ] = ACTIONS(7480),
    [anon_sym_DASH_GT] = ACTIONS(7482),
    [anon_sym_DASH_GT_GT] = ACTIONS(7480),
    [anon_sym_PIPE] = ACTIONS(7482),
    [anon_sym_AMP] = ACTIONS(7482),
    [anon_sym_PIPE_PIPE] = ACTIONS(7480),
    [anon_sym_AMP_AMP] = ACTIONS(7480),
    [anon_sym_LT] = ACTIONS(7482),
    [anon_sym_LT_EQ] = ACTIONS(7480),
    [anon_sym_GT] = ACTIONS(7482),
    [anon_sym_GT_EQ] = ACTIONS(7480),
    [anon_sym_EQ_EQ] = ACTIONS(7480),
    [anon_sym_BANG_EQ] = ACTIONS(7480),
    [anon_sym_STAR] = ACTIONS(7482),
    [anon_sym_SLASH] = ACTIONS(7480),
    [anon_sym_STAR_STAR] = ACTIONS(7480),
    [anon_sym_CARET] = ACTIONS(7480),
    [aux_sym_binary_operator_token1] = ACTIONS(7480),
    [anon_sym_PIPE_GT] = ACTIONS(7480),
    [anon_sym_COLON] = ACTIONS(7482),
    [anon_sym_DOLLAR] = ACTIONS(7480),
    [anon_sym_AT] = ACTIONS(7480),
    [aux_sym__hex_literal_token1] = ACTIONS(7480),
    [sym__number_literal] = ACTIONS(7482),
    [anon_sym_SQUOTE] = ACTIONS(7480),
    [anon_sym_DQUOTE] = ACTIONS(7480),
    [sym_return] = ACTIONS(7482),
    [sym_next] = ACTIONS(7482),
    [sym_break] = ACTIONS(7482),
    [sym_true] = ACTIONS(7482),
    [sym_false] = ACTIONS(7482),
    [sym_null] = ACTIONS(7482),
    [sym_inf] = ACTIONS(7482),
    [sym_nan] = ACTIONS(7482),
    [anon_sym_NA] = ACTIONS(7482),
    [anon_sym_NA_integer_] = ACTIONS(7482),
    [anon_sym_NA_real_] = ACTIONS(7482),
    [anon_sym_NA_complex_] = ACTIONS(7482),
    [anon_sym_NA_character_] = ACTIONS(7482),
    [sym_dots] = ACTIONS(7482),
    [sym_dot_dot_i] = ACTIONS(7480),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7480),
    [sym__newline] = ACTIONS(7480),
    [sym__raw_string_literal] = ACTIONS(7480),
    [sym__external_open_parenthesis] = ACTIONS(7480),
    [sym__external_close_parenthesis] = ACTIONS(7480),
    [sym__external_open_brace] = ACTIONS(7480),
    [sym__external_open_bracket] = ACTIONS(7480),
    [sym__external_open_bracket2] = ACTIONS(7480),
  },
  [2937] = {
    [sym_identifier] = ACTIONS(7563),
    [anon_sym_BSLASH] = ACTIONS(7561),
    [anon_sym_function] = ACTIONS(7563),
    [anon_sym_EQ] = ACTIONS(7563),
    [anon_sym_if] = ACTIONS(7563),
    [anon_sym_for] = ACTIONS(7563),
    [anon_sym_while] = ACTIONS(7563),
    [anon_sym_repeat] = ACTIONS(7563),
    [anon_sym_QMARK] = ACTIONS(7561),
    [anon_sym_TILDE] = ACTIONS(7561),
    [anon_sym_BANG] = ACTIONS(7563),
    [anon_sym_PLUS] = ACTIONS(7561),
    [anon_sym_DASH] = ACTIONS(7563),
    [anon_sym_LT_DASH] = ACTIONS(7561),
    [anon_sym_LT_LT_DASH] = ACTIONS(7561),
    [anon_sym_COLON_EQ] = ACTIONS(7561),
    [anon_sym_DASH_GT] = ACTIONS(7563),
    [anon_sym_DASH_GT_GT] = ACTIONS(7561),
    [anon_sym_PIPE] = ACTIONS(7563),
    [anon_sym_AMP] = ACTIONS(7563),
    [anon_sym_PIPE_PIPE] = ACTIONS(7561),
    [anon_sym_AMP_AMP] = ACTIONS(7561),
    [anon_sym_LT] = ACTIONS(7563),
    [anon_sym_LT_EQ] = ACTIONS(7561),
    [anon_sym_GT] = ACTIONS(7563),
    [anon_sym_GT_EQ] = ACTIONS(7561),
    [anon_sym_EQ_EQ] = ACTIONS(7561),
    [anon_sym_BANG_EQ] = ACTIONS(7561),
    [anon_sym_STAR] = ACTIONS(7563),
    [anon_sym_SLASH] = ACTIONS(7561),
    [anon_sym_STAR_STAR] = ACTIONS(7561),
    [anon_sym_CARET] = ACTIONS(7561),
    [aux_sym_binary_operator_token1] = ACTIONS(7561),
    [anon_sym_PIPE_GT] = ACTIONS(7561),
    [anon_sym_COLON] = ACTIONS(7563),
    [anon_sym_DOLLAR] = ACTIONS(7561),
    [anon_sym_AT] = ACTIONS(7561),
    [aux_sym__hex_literal_token1] = ACTIONS(7561),
    [sym__number_literal] = ACTIONS(7563),
    [anon_sym_SQUOTE] = ACTIONS(7561),
    [anon_sym_DQUOTE] = ACTIONS(7561),
    [sym_return] = ACTIONS(7563),
    [sym_next] = ACTIONS(7563),
    [sym_break] = ACTIONS(7563),
    [sym_true] = ACTIONS(7563),
    [sym_false] = ACTIONS(7563),
    [sym_null] = ACTIONS(7563),
    [sym_inf] = ACTIONS(7563),
    [sym_nan] = ACTIONS(7563),
    [anon_sym_NA] = ACTIONS(7563),
    [anon_sym_NA_integer_] = ACTIONS(7563),
    [anon_sym_NA_real_] = ACTIONS(7563),
    [anon_sym_NA_complex_] = ACTIONS(7563),
    [anon_sym_NA_character_] = ACTIONS(7563),
    [sym_dots] = ACTIONS(7563),
    [sym_dot_dot_i] = ACTIONS(7561),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7561),
    [sym__newline] = ACTIONS(7561),
    [sym__raw_string_literal] = ACTIONS(7561),
    [sym__external_open_parenthesis] = ACTIONS(7561),
    [sym__external_close_parenthesis] = ACTIONS(7561),
    [sym__external_open_brace] = ACTIONS(7561),
    [sym__external_open_bracket] = ACTIONS(7561),
    [sym__external_open_bracket2] = ACTIONS(7561),
  },
  [2938] = {
    [sym_identifier] = ACTIONS(7129),
    [anon_sym_BSLASH] = ACTIONS(7131),
    [anon_sym_function] = ACTIONS(7129),
    [anon_sym_EQ] = ACTIONS(7656),
    [anon_sym_if] = ACTIONS(7129),
    [anon_sym_for] = ACTIONS(7129),
    [anon_sym_while] = ACTIONS(7129),
    [anon_sym_repeat] = ACTIONS(7129),
    [anon_sym_QMARK] = ACTIONS(7131),
    [anon_sym_TILDE] = ACTIONS(7131),
    [anon_sym_BANG] = ACTIONS(7129),
    [anon_sym_PLUS] = ACTIONS(7131),
    [anon_sym_DASH] = ACTIONS(7129),
    [anon_sym_LT_DASH] = ACTIONS(7131),
    [anon_sym_LT_LT_DASH] = ACTIONS(7131),
    [anon_sym_COLON_EQ] = ACTIONS(7131),
    [anon_sym_DASH_GT] = ACTIONS(7129),
    [anon_sym_DASH_GT_GT] = ACTIONS(7131),
    [anon_sym_PIPE] = ACTIONS(7129),
    [anon_sym_AMP] = ACTIONS(7129),
    [anon_sym_PIPE_PIPE] = ACTIONS(7131),
    [anon_sym_AMP_AMP] = ACTIONS(7131),
    [anon_sym_LT] = ACTIONS(7129),
    [anon_sym_LT_EQ] = ACTIONS(7131),
    [anon_sym_GT] = ACTIONS(7129),
    [anon_sym_GT_EQ] = ACTIONS(7131),
    [anon_sym_EQ_EQ] = ACTIONS(7131),
    [anon_sym_BANG_EQ] = ACTIONS(7131),
    [anon_sym_STAR] = ACTIONS(7129),
    [anon_sym_SLASH] = ACTIONS(7131),
    [anon_sym_STAR_STAR] = ACTIONS(7131),
    [anon_sym_CARET] = ACTIONS(7131),
    [aux_sym_binary_operator_token1] = ACTIONS(7131),
    [anon_sym_PIPE_GT] = ACTIONS(7131),
    [anon_sym_COLON] = ACTIONS(7129),
    [anon_sym_DOLLAR] = ACTIONS(7131),
    [anon_sym_AT] = ACTIONS(7131),
    [aux_sym__hex_literal_token1] = ACTIONS(7131),
    [sym__number_literal] = ACTIONS(7129),
    [anon_sym_SQUOTE] = ACTIONS(7131),
    [anon_sym_DQUOTE] = ACTIONS(7131),
    [sym_return] = ACTIONS(7129),
    [sym_next] = ACTIONS(7129),
    [sym_break] = ACTIONS(7129),
    [sym_true] = ACTIONS(7129),
    [sym_false] = ACTIONS(7129),
    [sym_null] = ACTIONS(7129),
    [sym_inf] = ACTIONS(7129),
    [sym_nan] = ACTIONS(7129),
    [anon_sym_NA] = ACTIONS(7129),
    [anon_sym_NA_integer_] = ACTIONS(7129),
    [anon_sym_NA_real_] = ACTIONS(7129),
    [anon_sym_NA_complex_] = ACTIONS(7129),
    [anon_sym_NA_character_] = ACTIONS(7129),
    [sym_dots] = ACTIONS(7129),
    [sym_dot_dot_i] = ACTIONS(7131),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7131),
    [sym__newline] = ACTIONS(7131),
    [sym__raw_string_literal] = ACTIONS(7131),
    [sym__external_open_parenthesis] = ACTIONS(7131),
    [sym__external_open_brace] = ACTIONS(7131),
    [sym__external_open_bracket] = ACTIONS(7131),
    [sym__external_close_bracket] = ACTIONS(7131),
    [sym__external_open_bracket2] = ACTIONS(7131),
  },
  [2939] = {
    [ts_builtin_sym_end] = ACTIONS(7550),
    [sym_identifier] = ACTIONS(7552),
    [anon_sym_BSLASH] = ACTIONS(7550),
    [anon_sym_function] = ACTIONS(7552),
    [anon_sym_EQ] = ACTIONS(7552),
    [anon_sym_if] = ACTIONS(7552),
    [anon_sym_for] = ACTIONS(7552),
    [anon_sym_while] = ACTIONS(7552),
    [anon_sym_repeat] = ACTIONS(7552),
    [anon_sym_QMARK] = ACTIONS(7550),
    [anon_sym_TILDE] = ACTIONS(7550),
    [anon_sym_BANG] = ACTIONS(7552),
    [anon_sym_PLUS] = ACTIONS(7550),
    [anon_sym_DASH] = ACTIONS(7552),
    [anon_sym_LT_DASH] = ACTIONS(7550),
    [anon_sym_LT_LT_DASH] = ACTIONS(7550),
    [anon_sym_COLON_EQ] = ACTIONS(7550),
    [anon_sym_DASH_GT] = ACTIONS(7552),
    [anon_sym_DASH_GT_GT] = ACTIONS(7550),
    [anon_sym_PIPE] = ACTIONS(7552),
    [anon_sym_AMP] = ACTIONS(7552),
    [anon_sym_PIPE_PIPE] = ACTIONS(7550),
    [anon_sym_AMP_AMP] = ACTIONS(7550),
    [anon_sym_LT] = ACTIONS(7552),
    [anon_sym_LT_EQ] = ACTIONS(7550),
    [anon_sym_GT] = ACTIONS(7552),
    [anon_sym_GT_EQ] = ACTIONS(7550),
    [anon_sym_EQ_EQ] = ACTIONS(7550),
    [anon_sym_BANG_EQ] = ACTIONS(7550),
    [anon_sym_STAR] = ACTIONS(7552),
    [anon_sym_SLASH] = ACTIONS(7550),
    [anon_sym_STAR_STAR] = ACTIONS(7550),
    [anon_sym_CARET] = ACTIONS(7550),
    [aux_sym_binary_operator_token1] = ACTIONS(7550),
    [anon_sym_PIPE_GT] = ACTIONS(7550),
    [anon_sym_COLON] = ACTIONS(7552),
    [anon_sym_DOLLAR] = ACTIONS(7550),
    [anon_sym_AT] = ACTIONS(7550),
    [aux_sym__hex_literal_token1] = ACTIONS(7550),
    [sym__number_literal] = ACTIONS(7552),
    [anon_sym_SQUOTE] = ACTIONS(7550),
    [anon_sym_DQUOTE] = ACTIONS(7550),
    [sym_return] = ACTIONS(7552),
    [sym_next] = ACTIONS(7552),
    [sym_break] = ACTIONS(7552),
    [sym_true] = ACTIONS(7552),
    [sym_false] = ACTIONS(7552),
    [sym_null] = ACTIONS(7552),
    [sym_inf] = ACTIONS(7552),
    [sym_nan] = ACTIONS(7552),
    [anon_sym_NA] = ACTIONS(7552),
    [anon_sym_NA_integer_] = ACTIONS(7552),
    [anon_sym_NA_real_] = ACTIONS(7552),
    [anon_sym_NA_complex_] = ACTIONS(7552),
    [anon_sym_NA_character_] = ACTIONS(7552),
    [sym_dots] = ACTIONS(7552),
    [sym_dot_dot_i] = ACTIONS(7550),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7550),
    [sym__semicolon] = ACTIONS(7550),
    [sym__raw_string_literal] = ACTIONS(7550),
    [sym__external_open_parenthesis] = ACTIONS(7550),
    [sym__external_open_brace] = ACTIONS(7550),
    [sym__external_open_bracket] = ACTIONS(7550),
    [sym__external_open_bracket2] = ACTIONS(7550),
  },
  [2940] = {
    [sym_identifier] = ACTIONS(7544),
    [anon_sym_BSLASH] = ACTIONS(7542),
    [anon_sym_function] = ACTIONS(7544),
    [anon_sym_EQ] = ACTIONS(7544),
    [anon_sym_if] = ACTIONS(7544),
    [anon_sym_for] = ACTIONS(7544),
    [anon_sym_while] = ACTIONS(7544),
    [anon_sym_repeat] = ACTIONS(7544),
    [anon_sym_QMARK] = ACTIONS(7542),
    [anon_sym_TILDE] = ACTIONS(7542),
    [anon_sym_BANG] = ACTIONS(7544),
    [anon_sym_PLUS] = ACTIONS(7542),
    [anon_sym_DASH] = ACTIONS(7544),
    [anon_sym_LT_DASH] = ACTIONS(7542),
    [anon_sym_LT_LT_DASH] = ACTIONS(7542),
    [anon_sym_COLON_EQ] = ACTIONS(7542),
    [anon_sym_DASH_GT] = ACTIONS(7544),
    [anon_sym_DASH_GT_GT] = ACTIONS(7542),
    [anon_sym_PIPE] = ACTIONS(7544),
    [anon_sym_AMP] = ACTIONS(7544),
    [anon_sym_PIPE_PIPE] = ACTIONS(7542),
    [anon_sym_AMP_AMP] = ACTIONS(7542),
    [anon_sym_LT] = ACTIONS(7544),
    [anon_sym_LT_EQ] = ACTIONS(7542),
    [anon_sym_GT] = ACTIONS(7544),
    [anon_sym_GT_EQ] = ACTIONS(7542),
    [anon_sym_EQ_EQ] = ACTIONS(7542),
    [anon_sym_BANG_EQ] = ACTIONS(7542),
    [anon_sym_STAR] = ACTIONS(7544),
    [anon_sym_SLASH] = ACTIONS(7542),
    [anon_sym_STAR_STAR] = ACTIONS(7542),
    [anon_sym_CARET] = ACTIONS(7542),
    [aux_sym_binary_operator_token1] = ACTIONS(7542),
    [anon_sym_PIPE_GT] = ACTIONS(7542),
    [anon_sym_COLON] = ACTIONS(7544),
    [anon_sym_DOLLAR] = ACTIONS(7542),
    [anon_sym_AT] = ACTIONS(7542),
    [aux_sym__hex_literal_token1] = ACTIONS(7542),
    [sym__number_literal] = ACTIONS(7544),
    [anon_sym_SQUOTE] = ACTIONS(7542),
    [anon_sym_DQUOTE] = ACTIONS(7542),
    [sym_return] = ACTIONS(7544),
    [sym_next] = ACTIONS(7544),
    [sym_break] = ACTIONS(7544),
    [sym_true] = ACTIONS(7544),
    [sym_false] = ACTIONS(7544),
    [sym_null] = ACTIONS(7544),
    [sym_inf] = ACTIONS(7544),
    [sym_nan] = ACTIONS(7544),
    [anon_sym_NA] = ACTIONS(7544),
    [anon_sym_NA_integer_] = ACTIONS(7544),
    [anon_sym_NA_real_] = ACTIONS(7544),
    [anon_sym_NA_complex_] = ACTIONS(7544),
    [anon_sym_NA_character_] = ACTIONS(7544),
    [sym_dots] = ACTIONS(7544),
    [sym_dot_dot_i] = ACTIONS(7542),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7542),
    [sym__newline] = ACTIONS(7542),
    [sym__raw_string_literal] = ACTIONS(7542),
    [sym__external_open_parenthesis] = ACTIONS(7542),
    [sym__external_close_parenthesis] = ACTIONS(7542),
    [sym__external_open_brace] = ACTIONS(7542),
    [sym__external_open_bracket] = ACTIONS(7542),
    [sym__external_open_bracket2] = ACTIONS(7542),
  },
  [2941] = {
    [sym_identifier] = ACTIONS(7532),
    [anon_sym_BSLASH] = ACTIONS(7530),
    [anon_sym_function] = ACTIONS(7532),
    [anon_sym_EQ] = ACTIONS(7532),
    [anon_sym_if] = ACTIONS(7532),
    [anon_sym_for] = ACTIONS(7532),
    [anon_sym_while] = ACTIONS(7532),
    [anon_sym_repeat] = ACTIONS(7532),
    [anon_sym_QMARK] = ACTIONS(7530),
    [anon_sym_TILDE] = ACTIONS(7530),
    [anon_sym_BANG] = ACTIONS(7532),
    [anon_sym_PLUS] = ACTIONS(7530),
    [anon_sym_DASH] = ACTIONS(7532),
    [anon_sym_LT_DASH] = ACTIONS(7530),
    [anon_sym_LT_LT_DASH] = ACTIONS(7530),
    [anon_sym_COLON_EQ] = ACTIONS(7530),
    [anon_sym_DASH_GT] = ACTIONS(7532),
    [anon_sym_DASH_GT_GT] = ACTIONS(7530),
    [anon_sym_PIPE] = ACTIONS(7532),
    [anon_sym_AMP] = ACTIONS(7532),
    [anon_sym_PIPE_PIPE] = ACTIONS(7530),
    [anon_sym_AMP_AMP] = ACTIONS(7530),
    [anon_sym_LT] = ACTIONS(7532),
    [anon_sym_LT_EQ] = ACTIONS(7530),
    [anon_sym_GT] = ACTIONS(7532),
    [anon_sym_GT_EQ] = ACTIONS(7530),
    [anon_sym_EQ_EQ] = ACTIONS(7530),
    [anon_sym_BANG_EQ] = ACTIONS(7530),
    [anon_sym_STAR] = ACTIONS(7532),
    [anon_sym_SLASH] = ACTIONS(7530),
    [anon_sym_STAR_STAR] = ACTIONS(7530),
    [anon_sym_CARET] = ACTIONS(7530),
    [aux_sym_binary_operator_token1] = ACTIONS(7530),
    [anon_sym_PIPE_GT] = ACTIONS(7530),
    [anon_sym_COLON] = ACTIONS(7532),
    [anon_sym_DOLLAR] = ACTIONS(7530),
    [anon_sym_AT] = ACTIONS(7530),
    [aux_sym__hex_literal_token1] = ACTIONS(7530),
    [sym__number_literal] = ACTIONS(7532),
    [anon_sym_SQUOTE] = ACTIONS(7530),
    [anon_sym_DQUOTE] = ACTIONS(7530),
    [sym_return] = ACTIONS(7532),
    [sym_next] = ACTIONS(7532),
    [sym_break] = ACTIONS(7532),
    [sym_true] = ACTIONS(7532),
    [sym_false] = ACTIONS(7532),
    [sym_null] = ACTIONS(7532),
    [sym_inf] = ACTIONS(7532),
    [sym_nan] = ACTIONS(7532),
    [anon_sym_NA] = ACTIONS(7532),
    [anon_sym_NA_integer_] = ACTIONS(7532),
    [anon_sym_NA_real_] = ACTIONS(7532),
    [anon_sym_NA_complex_] = ACTIONS(7532),
    [anon_sym_NA_character_] = ACTIONS(7532),
    [sym_dots] = ACTIONS(7532),
    [sym_dot_dot_i] = ACTIONS(7530),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7530),
    [sym__newline] = ACTIONS(7530),
    [sym__raw_string_literal] = ACTIONS(7530),
    [sym__external_open_parenthesis] = ACTIONS(7530),
    [sym__external_close_parenthesis] = ACTIONS(7530),
    [sym__external_open_brace] = ACTIONS(7530),
    [sym__external_open_bracket] = ACTIONS(7530),
    [sym__external_open_bracket2] = ACTIONS(7530),
  },
  [2942] = {
    [sym_identifier] = ACTIONS(7528),
    [anon_sym_BSLASH] = ACTIONS(7526),
    [anon_sym_function] = ACTIONS(7528),
    [anon_sym_EQ] = ACTIONS(7528),
    [anon_sym_if] = ACTIONS(7528),
    [anon_sym_for] = ACTIONS(7528),
    [anon_sym_while] = ACTIONS(7528),
    [anon_sym_repeat] = ACTIONS(7528),
    [anon_sym_QMARK] = ACTIONS(7526),
    [anon_sym_TILDE] = ACTIONS(7526),
    [anon_sym_BANG] = ACTIONS(7528),
    [anon_sym_PLUS] = ACTIONS(7526),
    [anon_sym_DASH] = ACTIONS(7528),
    [anon_sym_LT_DASH] = ACTIONS(7526),
    [anon_sym_LT_LT_DASH] = ACTIONS(7526),
    [anon_sym_COLON_EQ] = ACTIONS(7526),
    [anon_sym_DASH_GT] = ACTIONS(7528),
    [anon_sym_DASH_GT_GT] = ACTIONS(7526),
    [anon_sym_PIPE] = ACTIONS(7528),
    [anon_sym_AMP] = ACTIONS(7528),
    [anon_sym_PIPE_PIPE] = ACTIONS(7526),
    [anon_sym_AMP_AMP] = ACTIONS(7526),
    [anon_sym_LT] = ACTIONS(7528),
    [anon_sym_LT_EQ] = ACTIONS(7526),
    [anon_sym_GT] = ACTIONS(7528),
    [anon_sym_GT_EQ] = ACTIONS(7526),
    [anon_sym_EQ_EQ] = ACTIONS(7526),
    [anon_sym_BANG_EQ] = ACTIONS(7526),
    [anon_sym_STAR] = ACTIONS(7528),
    [anon_sym_SLASH] = ACTIONS(7526),
    [anon_sym_STAR_STAR] = ACTIONS(7526),
    [anon_sym_CARET] = ACTIONS(7526),
    [aux_sym_binary_operator_token1] = ACTIONS(7526),
    [anon_sym_PIPE_GT] = ACTIONS(7526),
    [anon_sym_COLON] = ACTIONS(7528),
    [anon_sym_DOLLAR] = ACTIONS(7526),
    [anon_sym_AT] = ACTIONS(7526),
    [aux_sym__hex_literal_token1] = ACTIONS(7526),
    [sym__number_literal] = ACTIONS(7528),
    [anon_sym_SQUOTE] = ACTIONS(7526),
    [anon_sym_DQUOTE] = ACTIONS(7526),
    [sym_return] = ACTIONS(7528),
    [sym_next] = ACTIONS(7528),
    [sym_break] = ACTIONS(7528),
    [sym_true] = ACTIONS(7528),
    [sym_false] = ACTIONS(7528),
    [sym_null] = ACTIONS(7528),
    [sym_inf] = ACTIONS(7528),
    [sym_nan] = ACTIONS(7528),
    [anon_sym_NA] = ACTIONS(7528),
    [anon_sym_NA_integer_] = ACTIONS(7528),
    [anon_sym_NA_real_] = ACTIONS(7528),
    [anon_sym_NA_complex_] = ACTIONS(7528),
    [anon_sym_NA_character_] = ACTIONS(7528),
    [sym_dots] = ACTIONS(7528),
    [sym_dot_dot_i] = ACTIONS(7526),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7526),
    [sym__newline] = ACTIONS(7526),
    [sym__raw_string_literal] = ACTIONS(7526),
    [sym__external_open_parenthesis] = ACTIONS(7526),
    [sym__external_close_parenthesis] = ACTIONS(7526),
    [sym__external_open_brace] = ACTIONS(7526),
    [sym__external_open_bracket] = ACTIONS(7526),
    [sym__external_open_bracket2] = ACTIONS(7526),
  },
  [2943] = {
    [sym_identifier] = ACTIONS(7524),
    [anon_sym_BSLASH] = ACTIONS(7522),
    [anon_sym_function] = ACTIONS(7524),
    [anon_sym_EQ] = ACTIONS(7524),
    [anon_sym_if] = ACTIONS(7524),
    [anon_sym_for] = ACTIONS(7524),
    [anon_sym_while] = ACTIONS(7524),
    [anon_sym_repeat] = ACTIONS(7524),
    [anon_sym_QMARK] = ACTIONS(7522),
    [anon_sym_TILDE] = ACTIONS(7522),
    [anon_sym_BANG] = ACTIONS(7524),
    [anon_sym_PLUS] = ACTIONS(7522),
    [anon_sym_DASH] = ACTIONS(7524),
    [anon_sym_LT_DASH] = ACTIONS(7522),
    [anon_sym_LT_LT_DASH] = ACTIONS(7522),
    [anon_sym_COLON_EQ] = ACTIONS(7522),
    [anon_sym_DASH_GT] = ACTIONS(7524),
    [anon_sym_DASH_GT_GT] = ACTIONS(7522),
    [anon_sym_PIPE] = ACTIONS(7524),
    [anon_sym_AMP] = ACTIONS(7524),
    [anon_sym_PIPE_PIPE] = ACTIONS(7522),
    [anon_sym_AMP_AMP] = ACTIONS(7522),
    [anon_sym_LT] = ACTIONS(7524),
    [anon_sym_LT_EQ] = ACTIONS(7522),
    [anon_sym_GT] = ACTIONS(7524),
    [anon_sym_GT_EQ] = ACTIONS(7522),
    [anon_sym_EQ_EQ] = ACTIONS(7522),
    [anon_sym_BANG_EQ] = ACTIONS(7522),
    [anon_sym_STAR] = ACTIONS(7524),
    [anon_sym_SLASH] = ACTIONS(7522),
    [anon_sym_STAR_STAR] = ACTIONS(7522),
    [anon_sym_CARET] = ACTIONS(7522),
    [aux_sym_binary_operator_token1] = ACTIONS(7522),
    [anon_sym_PIPE_GT] = ACTIONS(7522),
    [anon_sym_COLON] = ACTIONS(7524),
    [anon_sym_DOLLAR] = ACTIONS(7522),
    [anon_sym_AT] = ACTIONS(7522),
    [aux_sym__hex_literal_token1] = ACTIONS(7522),
    [sym__number_literal] = ACTIONS(7524),
    [anon_sym_SQUOTE] = ACTIONS(7522),
    [anon_sym_DQUOTE] = ACTIONS(7522),
    [sym_return] = ACTIONS(7524),
    [sym_next] = ACTIONS(7524),
    [sym_break] = ACTIONS(7524),
    [sym_true] = ACTIONS(7524),
    [sym_false] = ACTIONS(7524),
    [sym_null] = ACTIONS(7524),
    [sym_inf] = ACTIONS(7524),
    [sym_nan] = ACTIONS(7524),
    [anon_sym_NA] = ACTIONS(7524),
    [anon_sym_NA_integer_] = ACTIONS(7524),
    [anon_sym_NA_real_] = ACTIONS(7524),
    [anon_sym_NA_complex_] = ACTIONS(7524),
    [anon_sym_NA_character_] = ACTIONS(7524),
    [sym_dots] = ACTIONS(7524),
    [sym_dot_dot_i] = ACTIONS(7522),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7522),
    [sym__newline] = ACTIONS(7522),
    [sym__raw_string_literal] = ACTIONS(7522),
    [sym__external_open_parenthesis] = ACTIONS(7522),
    [sym__external_close_parenthesis] = ACTIONS(7522),
    [sym__external_open_brace] = ACTIONS(7522),
    [sym__external_open_bracket] = ACTIONS(7522),
    [sym__external_open_bracket2] = ACTIONS(7522),
  },
  [2944] = {
    [sym_identifier] = ACTIONS(7520),
    [anon_sym_BSLASH] = ACTIONS(7518),
    [anon_sym_function] = ACTIONS(7520),
    [anon_sym_EQ] = ACTIONS(7520),
    [anon_sym_if] = ACTIONS(7520),
    [anon_sym_for] = ACTIONS(7520),
    [anon_sym_while] = ACTIONS(7520),
    [anon_sym_repeat] = ACTIONS(7520),
    [anon_sym_QMARK] = ACTIONS(7518),
    [anon_sym_TILDE] = ACTIONS(7518),
    [anon_sym_BANG] = ACTIONS(7520),
    [anon_sym_PLUS] = ACTIONS(7518),
    [anon_sym_DASH] = ACTIONS(7520),
    [anon_sym_LT_DASH] = ACTIONS(7518),
    [anon_sym_LT_LT_DASH] = ACTIONS(7518),
    [anon_sym_COLON_EQ] = ACTIONS(7518),
    [anon_sym_DASH_GT] = ACTIONS(7520),
    [anon_sym_DASH_GT_GT] = ACTIONS(7518),
    [anon_sym_PIPE] = ACTIONS(7520),
    [anon_sym_AMP] = ACTIONS(7520),
    [anon_sym_PIPE_PIPE] = ACTIONS(7518),
    [anon_sym_AMP_AMP] = ACTIONS(7518),
    [anon_sym_LT] = ACTIONS(7520),
    [anon_sym_LT_EQ] = ACTIONS(7518),
    [anon_sym_GT] = ACTIONS(7520),
    [anon_sym_GT_EQ] = ACTIONS(7518),
    [anon_sym_EQ_EQ] = ACTIONS(7518),
    [anon_sym_BANG_EQ] = ACTIONS(7518),
    [anon_sym_STAR] = ACTIONS(7520),
    [anon_sym_SLASH] = ACTIONS(7518),
    [anon_sym_STAR_STAR] = ACTIONS(7518),
    [anon_sym_CARET] = ACTIONS(7518),
    [aux_sym_binary_operator_token1] = ACTIONS(7518),
    [anon_sym_PIPE_GT] = ACTIONS(7518),
    [anon_sym_COLON] = ACTIONS(7520),
    [anon_sym_DOLLAR] = ACTIONS(7518),
    [anon_sym_AT] = ACTIONS(7518),
    [aux_sym__hex_literal_token1] = ACTIONS(7518),
    [sym__number_literal] = ACTIONS(7520),
    [anon_sym_SQUOTE] = ACTIONS(7518),
    [anon_sym_DQUOTE] = ACTIONS(7518),
    [sym_return] = ACTIONS(7520),
    [sym_next] = ACTIONS(7520),
    [sym_break] = ACTIONS(7520),
    [sym_true] = ACTIONS(7520),
    [sym_false] = ACTIONS(7520),
    [sym_null] = ACTIONS(7520),
    [sym_inf] = ACTIONS(7520),
    [sym_nan] = ACTIONS(7520),
    [anon_sym_NA] = ACTIONS(7520),
    [anon_sym_NA_integer_] = ACTIONS(7520),
    [anon_sym_NA_real_] = ACTIONS(7520),
    [anon_sym_NA_complex_] = ACTIONS(7520),
    [anon_sym_NA_character_] = ACTIONS(7520),
    [sym_dots] = ACTIONS(7520),
    [sym_dot_dot_i] = ACTIONS(7518),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7518),
    [sym__newline] = ACTIONS(7518),
    [sym__raw_string_literal] = ACTIONS(7518),
    [sym__external_open_parenthesis] = ACTIONS(7518),
    [sym__external_close_parenthesis] = ACTIONS(7518),
    [sym__external_open_brace] = ACTIONS(7518),
    [sym__external_open_bracket] = ACTIONS(7518),
    [sym__external_open_bracket2] = ACTIONS(7518),
  },
  [2945] = {
    [sym_identifier] = ACTIONS(7540),
    [anon_sym_BSLASH] = ACTIONS(7538),
    [anon_sym_function] = ACTIONS(7540),
    [anon_sym_EQ] = ACTIONS(7540),
    [anon_sym_if] = ACTIONS(7540),
    [anon_sym_for] = ACTIONS(7540),
    [anon_sym_while] = ACTIONS(7540),
    [anon_sym_repeat] = ACTIONS(7540),
    [anon_sym_QMARK] = ACTIONS(7538),
    [anon_sym_TILDE] = ACTIONS(7538),
    [anon_sym_BANG] = ACTIONS(7540),
    [anon_sym_PLUS] = ACTIONS(7538),
    [anon_sym_DASH] = ACTIONS(7540),
    [anon_sym_LT_DASH] = ACTIONS(7538),
    [anon_sym_LT_LT_DASH] = ACTIONS(7538),
    [anon_sym_COLON_EQ] = ACTIONS(7538),
    [anon_sym_DASH_GT] = ACTIONS(7540),
    [anon_sym_DASH_GT_GT] = ACTIONS(7538),
    [anon_sym_PIPE] = ACTIONS(7540),
    [anon_sym_AMP] = ACTIONS(7540),
    [anon_sym_PIPE_PIPE] = ACTIONS(7538),
    [anon_sym_AMP_AMP] = ACTIONS(7538),
    [anon_sym_LT] = ACTIONS(7540),
    [anon_sym_LT_EQ] = ACTIONS(7538),
    [anon_sym_GT] = ACTIONS(7540),
    [anon_sym_GT_EQ] = ACTIONS(7538),
    [anon_sym_EQ_EQ] = ACTIONS(7538),
    [anon_sym_BANG_EQ] = ACTIONS(7538),
    [anon_sym_STAR] = ACTIONS(7540),
    [anon_sym_SLASH] = ACTIONS(7538),
    [anon_sym_STAR_STAR] = ACTIONS(7538),
    [anon_sym_CARET] = ACTIONS(7538),
    [aux_sym_binary_operator_token1] = ACTIONS(7538),
    [anon_sym_PIPE_GT] = ACTIONS(7538),
    [anon_sym_COLON] = ACTIONS(7540),
    [anon_sym_DOLLAR] = ACTIONS(7538),
    [anon_sym_AT] = ACTIONS(7538),
    [aux_sym__hex_literal_token1] = ACTIONS(7538),
    [sym__number_literal] = ACTIONS(7540),
    [anon_sym_SQUOTE] = ACTIONS(7538),
    [anon_sym_DQUOTE] = ACTIONS(7538),
    [sym_return] = ACTIONS(7540),
    [sym_next] = ACTIONS(7540),
    [sym_break] = ACTIONS(7540),
    [sym_true] = ACTIONS(7540),
    [sym_false] = ACTIONS(7540),
    [sym_null] = ACTIONS(7540),
    [sym_inf] = ACTIONS(7540),
    [sym_nan] = ACTIONS(7540),
    [anon_sym_NA] = ACTIONS(7540),
    [anon_sym_NA_integer_] = ACTIONS(7540),
    [anon_sym_NA_real_] = ACTIONS(7540),
    [anon_sym_NA_complex_] = ACTIONS(7540),
    [anon_sym_NA_character_] = ACTIONS(7540),
    [sym_dots] = ACTIONS(7540),
    [sym_dot_dot_i] = ACTIONS(7538),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7538),
    [sym__newline] = ACTIONS(7538),
    [sym__raw_string_literal] = ACTIONS(7538),
    [sym__external_open_parenthesis] = ACTIONS(7538),
    [sym__external_close_parenthesis] = ACTIONS(7538),
    [sym__external_open_brace] = ACTIONS(7538),
    [sym__external_open_bracket] = ACTIONS(7538),
    [sym__external_open_bracket2] = ACTIONS(7538),
  },
  [2946] = {
    [sym_identifier] = ACTIONS(7516),
    [anon_sym_BSLASH] = ACTIONS(7514),
    [anon_sym_function] = ACTIONS(7516),
    [anon_sym_EQ] = ACTIONS(7516),
    [anon_sym_if] = ACTIONS(7516),
    [anon_sym_for] = ACTIONS(7516),
    [anon_sym_while] = ACTIONS(7516),
    [anon_sym_repeat] = ACTIONS(7516),
    [anon_sym_QMARK] = ACTIONS(7514),
    [anon_sym_TILDE] = ACTIONS(7514),
    [anon_sym_BANG] = ACTIONS(7516),
    [anon_sym_PLUS] = ACTIONS(7514),
    [anon_sym_DASH] = ACTIONS(7516),
    [anon_sym_LT_DASH] = ACTIONS(7514),
    [anon_sym_LT_LT_DASH] = ACTIONS(7514),
    [anon_sym_COLON_EQ] = ACTIONS(7514),
    [anon_sym_DASH_GT] = ACTIONS(7516),
    [anon_sym_DASH_GT_GT] = ACTIONS(7514),
    [anon_sym_PIPE] = ACTIONS(7516),
    [anon_sym_AMP] = ACTIONS(7516),
    [anon_sym_PIPE_PIPE] = ACTIONS(7514),
    [anon_sym_AMP_AMP] = ACTIONS(7514),
    [anon_sym_LT] = ACTIONS(7516),
    [anon_sym_LT_EQ] = ACTIONS(7514),
    [anon_sym_GT] = ACTIONS(7516),
    [anon_sym_GT_EQ] = ACTIONS(7514),
    [anon_sym_EQ_EQ] = ACTIONS(7514),
    [anon_sym_BANG_EQ] = ACTIONS(7514),
    [anon_sym_STAR] = ACTIONS(7516),
    [anon_sym_SLASH] = ACTIONS(7514),
    [anon_sym_STAR_STAR] = ACTIONS(7514),
    [anon_sym_CARET] = ACTIONS(7514),
    [aux_sym_binary_operator_token1] = ACTIONS(7514),
    [anon_sym_PIPE_GT] = ACTIONS(7514),
    [anon_sym_COLON] = ACTIONS(7516),
    [anon_sym_DOLLAR] = ACTIONS(7514),
    [anon_sym_AT] = ACTIONS(7514),
    [aux_sym__hex_literal_token1] = ACTIONS(7514),
    [sym__number_literal] = ACTIONS(7516),
    [anon_sym_SQUOTE] = ACTIONS(7514),
    [anon_sym_DQUOTE] = ACTIONS(7514),
    [sym_return] = ACTIONS(7516),
    [sym_next] = ACTIONS(7516),
    [sym_break] = ACTIONS(7516),
    [sym_true] = ACTIONS(7516),
    [sym_false] = ACTIONS(7516),
    [sym_null] = ACTIONS(7516),
    [sym_inf] = ACTIONS(7516),
    [sym_nan] = ACTIONS(7516),
    [anon_sym_NA] = ACTIONS(7516),
    [anon_sym_NA_integer_] = ACTIONS(7516),
    [anon_sym_NA_real_] = ACTIONS(7516),
    [anon_sym_NA_complex_] = ACTIONS(7516),
    [anon_sym_NA_character_] = ACTIONS(7516),
    [sym_dots] = ACTIONS(7516),
    [sym_dot_dot_i] = ACTIONS(7514),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7514),
    [sym__newline] = ACTIONS(7514),
    [sym__raw_string_literal] = ACTIONS(7514),
    [sym__external_open_parenthesis] = ACTIONS(7514),
    [sym__external_close_parenthesis] = ACTIONS(7514),
    [sym__external_open_brace] = ACTIONS(7514),
    [sym__external_open_bracket] = ACTIONS(7514),
    [sym__external_open_bracket2] = ACTIONS(7514),
  },
  [2947] = {
    [sym_identifier] = ACTIONS(7567),
    [anon_sym_BSLASH] = ACTIONS(7565),
    [anon_sym_function] = ACTIONS(7567),
    [anon_sym_EQ] = ACTIONS(7567),
    [anon_sym_if] = ACTIONS(7567),
    [anon_sym_for] = ACTIONS(7567),
    [anon_sym_while] = ACTIONS(7567),
    [anon_sym_repeat] = ACTIONS(7567),
    [anon_sym_QMARK] = ACTIONS(7565),
    [anon_sym_TILDE] = ACTIONS(7565),
    [anon_sym_BANG] = ACTIONS(7567),
    [anon_sym_PLUS] = ACTIONS(7565),
    [anon_sym_DASH] = ACTIONS(7567),
    [anon_sym_LT_DASH] = ACTIONS(7565),
    [anon_sym_LT_LT_DASH] = ACTIONS(7565),
    [anon_sym_COLON_EQ] = ACTIONS(7565),
    [anon_sym_DASH_GT] = ACTIONS(7567),
    [anon_sym_DASH_GT_GT] = ACTIONS(7565),
    [anon_sym_PIPE] = ACTIONS(7567),
    [anon_sym_AMP] = ACTIONS(7567),
    [anon_sym_PIPE_PIPE] = ACTIONS(7565),
    [anon_sym_AMP_AMP] = ACTIONS(7565),
    [anon_sym_LT] = ACTIONS(7567),
    [anon_sym_LT_EQ] = ACTIONS(7565),
    [anon_sym_GT] = ACTIONS(7567),
    [anon_sym_GT_EQ] = ACTIONS(7565),
    [anon_sym_EQ_EQ] = ACTIONS(7565),
    [anon_sym_BANG_EQ] = ACTIONS(7565),
    [anon_sym_STAR] = ACTIONS(7567),
    [anon_sym_SLASH] = ACTIONS(7565),
    [anon_sym_STAR_STAR] = ACTIONS(7565),
    [anon_sym_CARET] = ACTIONS(7565),
    [aux_sym_binary_operator_token1] = ACTIONS(7565),
    [anon_sym_PIPE_GT] = ACTIONS(7565),
    [anon_sym_COLON] = ACTIONS(7567),
    [anon_sym_DOLLAR] = ACTIONS(7565),
    [anon_sym_AT] = ACTIONS(7565),
    [aux_sym__hex_literal_token1] = ACTIONS(7565),
    [sym__number_literal] = ACTIONS(7567),
    [anon_sym_SQUOTE] = ACTIONS(7565),
    [anon_sym_DQUOTE] = ACTIONS(7565),
    [sym_return] = ACTIONS(7567),
    [sym_next] = ACTIONS(7567),
    [sym_break] = ACTIONS(7567),
    [sym_true] = ACTIONS(7567),
    [sym_false] = ACTIONS(7567),
    [sym_null] = ACTIONS(7567),
    [sym_inf] = ACTIONS(7567),
    [sym_nan] = ACTIONS(7567),
    [anon_sym_NA] = ACTIONS(7567),
    [anon_sym_NA_integer_] = ACTIONS(7567),
    [anon_sym_NA_real_] = ACTIONS(7567),
    [anon_sym_NA_complex_] = ACTIONS(7567),
    [anon_sym_NA_character_] = ACTIONS(7567),
    [sym_dots] = ACTIONS(7567),
    [sym_dot_dot_i] = ACTIONS(7565),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7565),
    [sym__newline] = ACTIONS(7565),
    [sym__raw_string_literal] = ACTIONS(7565),
    [sym__external_open_parenthesis] = ACTIONS(7565),
    [sym__external_open_brace] = ACTIONS(7565),
    [sym__external_open_bracket] = ACTIONS(7565),
    [sym__external_close_bracket] = ACTIONS(7565),
    [sym__external_open_bracket2] = ACTIONS(7565),
  },
  [2948] = {
    [sym_identifier] = ACTIONS(7486),
    [anon_sym_BSLASH] = ACTIONS(7484),
    [anon_sym_function] = ACTIONS(7486),
    [anon_sym_EQ] = ACTIONS(7486),
    [anon_sym_if] = ACTIONS(7486),
    [anon_sym_for] = ACTIONS(7486),
    [anon_sym_while] = ACTIONS(7486),
    [anon_sym_repeat] = ACTIONS(7486),
    [anon_sym_QMARK] = ACTIONS(7484),
    [anon_sym_TILDE] = ACTIONS(7484),
    [anon_sym_BANG] = ACTIONS(7486),
    [anon_sym_PLUS] = ACTIONS(7484),
    [anon_sym_DASH] = ACTIONS(7486),
    [anon_sym_LT_DASH] = ACTIONS(7484),
    [anon_sym_LT_LT_DASH] = ACTIONS(7484),
    [anon_sym_COLON_EQ] = ACTIONS(7484),
    [anon_sym_DASH_GT] = ACTIONS(7486),
    [anon_sym_DASH_GT_GT] = ACTIONS(7484),
    [anon_sym_PIPE] = ACTIONS(7486),
    [anon_sym_AMP] = ACTIONS(7486),
    [anon_sym_PIPE_PIPE] = ACTIONS(7484),
    [anon_sym_AMP_AMP] = ACTIONS(7484),
    [anon_sym_LT] = ACTIONS(7486),
    [anon_sym_LT_EQ] = ACTIONS(7484),
    [anon_sym_GT] = ACTIONS(7486),
    [anon_sym_GT_EQ] = ACTIONS(7484),
    [anon_sym_EQ_EQ] = ACTIONS(7484),
    [anon_sym_BANG_EQ] = ACTIONS(7484),
    [anon_sym_STAR] = ACTIONS(7486),
    [anon_sym_SLASH] = ACTIONS(7484),
    [anon_sym_STAR_STAR] = ACTIONS(7484),
    [anon_sym_CARET] = ACTIONS(7484),
    [aux_sym_binary_operator_token1] = ACTIONS(7484),
    [anon_sym_PIPE_GT] = ACTIONS(7484),
    [anon_sym_COLON] = ACTIONS(7486),
    [anon_sym_DOLLAR] = ACTIONS(7484),
    [anon_sym_AT] = ACTIONS(7484),
    [aux_sym__hex_literal_token1] = ACTIONS(7484),
    [sym__number_literal] = ACTIONS(7486),
    [anon_sym_SQUOTE] = ACTIONS(7484),
    [anon_sym_DQUOTE] = ACTIONS(7484),
    [sym_return] = ACTIONS(7486),
    [sym_next] = ACTIONS(7486),
    [sym_break] = ACTIONS(7486),
    [sym_true] = ACTIONS(7486),
    [sym_false] = ACTIONS(7486),
    [sym_null] = ACTIONS(7486),
    [sym_inf] = ACTIONS(7486),
    [sym_nan] = ACTIONS(7486),
    [anon_sym_NA] = ACTIONS(7486),
    [anon_sym_NA_integer_] = ACTIONS(7486),
    [anon_sym_NA_real_] = ACTIONS(7486),
    [anon_sym_NA_complex_] = ACTIONS(7486),
    [anon_sym_NA_character_] = ACTIONS(7486),
    [sym_dots] = ACTIONS(7486),
    [sym_dot_dot_i] = ACTIONS(7484),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7484),
    [sym__newline] = ACTIONS(7484),
    [sym__raw_string_literal] = ACTIONS(7484),
    [sym__external_open_parenthesis] = ACTIONS(7484),
    [sym__external_close_parenthesis] = ACTIONS(7484),
    [sym__external_open_brace] = ACTIONS(7484),
    [sym__external_open_bracket] = ACTIONS(7484),
    [sym__external_open_bracket2] = ACTIONS(7484),
  },
  [2949] = {
    [sym_identifier] = ACTIONS(7512),
    [anon_sym_BSLASH] = ACTIONS(7510),
    [anon_sym_function] = ACTIONS(7512),
    [anon_sym_EQ] = ACTIONS(7512),
    [anon_sym_if] = ACTIONS(7512),
    [anon_sym_for] = ACTIONS(7512),
    [anon_sym_while] = ACTIONS(7512),
    [anon_sym_repeat] = ACTIONS(7512),
    [anon_sym_QMARK] = ACTIONS(7510),
    [anon_sym_TILDE] = ACTIONS(7510),
    [anon_sym_BANG] = ACTIONS(7512),
    [anon_sym_PLUS] = ACTIONS(7510),
    [anon_sym_DASH] = ACTIONS(7512),
    [anon_sym_LT_DASH] = ACTIONS(7510),
    [anon_sym_LT_LT_DASH] = ACTIONS(7510),
    [anon_sym_COLON_EQ] = ACTIONS(7510),
    [anon_sym_DASH_GT] = ACTIONS(7512),
    [anon_sym_DASH_GT_GT] = ACTIONS(7510),
    [anon_sym_PIPE] = ACTIONS(7512),
    [anon_sym_AMP] = ACTIONS(7512),
    [anon_sym_PIPE_PIPE] = ACTIONS(7510),
    [anon_sym_AMP_AMP] = ACTIONS(7510),
    [anon_sym_LT] = ACTIONS(7512),
    [anon_sym_LT_EQ] = ACTIONS(7510),
    [anon_sym_GT] = ACTIONS(7512),
    [anon_sym_GT_EQ] = ACTIONS(7510),
    [anon_sym_EQ_EQ] = ACTIONS(7510),
    [anon_sym_BANG_EQ] = ACTIONS(7510),
    [anon_sym_STAR] = ACTIONS(7512),
    [anon_sym_SLASH] = ACTIONS(7510),
    [anon_sym_STAR_STAR] = ACTIONS(7510),
    [anon_sym_CARET] = ACTIONS(7510),
    [aux_sym_binary_operator_token1] = ACTIONS(7510),
    [anon_sym_PIPE_GT] = ACTIONS(7510),
    [anon_sym_COLON] = ACTIONS(7512),
    [anon_sym_DOLLAR] = ACTIONS(7510),
    [anon_sym_AT] = ACTIONS(7510),
    [aux_sym__hex_literal_token1] = ACTIONS(7510),
    [sym__number_literal] = ACTIONS(7512),
    [anon_sym_SQUOTE] = ACTIONS(7510),
    [anon_sym_DQUOTE] = ACTIONS(7510),
    [sym_return] = ACTIONS(7512),
    [sym_next] = ACTIONS(7512),
    [sym_break] = ACTIONS(7512),
    [sym_true] = ACTIONS(7512),
    [sym_false] = ACTIONS(7512),
    [sym_null] = ACTIONS(7512),
    [sym_inf] = ACTIONS(7512),
    [sym_nan] = ACTIONS(7512),
    [anon_sym_NA] = ACTIONS(7512),
    [anon_sym_NA_integer_] = ACTIONS(7512),
    [anon_sym_NA_real_] = ACTIONS(7512),
    [anon_sym_NA_complex_] = ACTIONS(7512),
    [anon_sym_NA_character_] = ACTIONS(7512),
    [sym_dots] = ACTIONS(7512),
    [sym_dot_dot_i] = ACTIONS(7510),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7510),
    [sym__newline] = ACTIONS(7510),
    [sym__raw_string_literal] = ACTIONS(7510),
    [sym__external_open_parenthesis] = ACTIONS(7510),
    [sym__external_close_parenthesis] = ACTIONS(7510),
    [sym__external_open_brace] = ACTIONS(7510),
    [sym__external_open_bracket] = ACTIONS(7510),
    [sym__external_open_bracket2] = ACTIONS(7510),
  },
  [2950] = {
    [sym_identifier] = ACTIONS(7506),
    [anon_sym_BSLASH] = ACTIONS(7504),
    [anon_sym_function] = ACTIONS(7506),
    [anon_sym_EQ] = ACTIONS(7506),
    [anon_sym_if] = ACTIONS(7506),
    [anon_sym_for] = ACTIONS(7506),
    [anon_sym_while] = ACTIONS(7506),
    [anon_sym_repeat] = ACTIONS(7506),
    [anon_sym_QMARK] = ACTIONS(7504),
    [anon_sym_TILDE] = ACTIONS(7504),
    [anon_sym_BANG] = ACTIONS(7506),
    [anon_sym_PLUS] = ACTIONS(7504),
    [anon_sym_DASH] = ACTIONS(7506),
    [anon_sym_LT_DASH] = ACTIONS(7504),
    [anon_sym_LT_LT_DASH] = ACTIONS(7504),
    [anon_sym_COLON_EQ] = ACTIONS(7504),
    [anon_sym_DASH_GT] = ACTIONS(7506),
    [anon_sym_DASH_GT_GT] = ACTIONS(7504),
    [anon_sym_PIPE] = ACTIONS(7506),
    [anon_sym_AMP] = ACTIONS(7506),
    [anon_sym_PIPE_PIPE] = ACTIONS(7504),
    [anon_sym_AMP_AMP] = ACTIONS(7504),
    [anon_sym_LT] = ACTIONS(7506),
    [anon_sym_LT_EQ] = ACTIONS(7504),
    [anon_sym_GT] = ACTIONS(7506),
    [anon_sym_GT_EQ] = ACTIONS(7504),
    [anon_sym_EQ_EQ] = ACTIONS(7504),
    [anon_sym_BANG_EQ] = ACTIONS(7504),
    [anon_sym_STAR] = ACTIONS(7506),
    [anon_sym_SLASH] = ACTIONS(7504),
    [anon_sym_STAR_STAR] = ACTIONS(7504),
    [anon_sym_CARET] = ACTIONS(7504),
    [aux_sym_binary_operator_token1] = ACTIONS(7504),
    [anon_sym_PIPE_GT] = ACTIONS(7504),
    [anon_sym_COLON] = ACTIONS(7506),
    [anon_sym_DOLLAR] = ACTIONS(7504),
    [anon_sym_AT] = ACTIONS(7504),
    [aux_sym__hex_literal_token1] = ACTIONS(7504),
    [sym__number_literal] = ACTIONS(7506),
    [anon_sym_SQUOTE] = ACTIONS(7504),
    [anon_sym_DQUOTE] = ACTIONS(7504),
    [sym_return] = ACTIONS(7506),
    [sym_next] = ACTIONS(7506),
    [sym_break] = ACTIONS(7506),
    [sym_true] = ACTIONS(7506),
    [sym_false] = ACTIONS(7506),
    [sym_null] = ACTIONS(7506),
    [sym_inf] = ACTIONS(7506),
    [sym_nan] = ACTIONS(7506),
    [anon_sym_NA] = ACTIONS(7506),
    [anon_sym_NA_integer_] = ACTIONS(7506),
    [anon_sym_NA_real_] = ACTIONS(7506),
    [anon_sym_NA_complex_] = ACTIONS(7506),
    [anon_sym_NA_character_] = ACTIONS(7506),
    [sym_dots] = ACTIONS(7506),
    [sym_dot_dot_i] = ACTIONS(7504),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7504),
    [sym__newline] = ACTIONS(7504),
    [sym__raw_string_literal] = ACTIONS(7504),
    [sym__external_open_parenthesis] = ACTIONS(7504),
    [sym__external_close_parenthesis] = ACTIONS(7504),
    [sym__external_open_brace] = ACTIONS(7504),
    [sym__external_open_bracket] = ACTIONS(7504),
    [sym__external_open_bracket2] = ACTIONS(7504),
  },
  [2951] = {
    [sym_identifier] = ACTIONS(7502),
    [anon_sym_BSLASH] = ACTIONS(7500),
    [anon_sym_function] = ACTIONS(7502),
    [anon_sym_EQ] = ACTIONS(7502),
    [anon_sym_if] = ACTIONS(7502),
    [anon_sym_for] = ACTIONS(7502),
    [anon_sym_while] = ACTIONS(7502),
    [anon_sym_repeat] = ACTIONS(7502),
    [anon_sym_QMARK] = ACTIONS(7500),
    [anon_sym_TILDE] = ACTIONS(7500),
    [anon_sym_BANG] = ACTIONS(7502),
    [anon_sym_PLUS] = ACTIONS(7500),
    [anon_sym_DASH] = ACTIONS(7502),
    [anon_sym_LT_DASH] = ACTIONS(7500),
    [anon_sym_LT_LT_DASH] = ACTIONS(7500),
    [anon_sym_COLON_EQ] = ACTIONS(7500),
    [anon_sym_DASH_GT] = ACTIONS(7502),
    [anon_sym_DASH_GT_GT] = ACTIONS(7500),
    [anon_sym_PIPE] = ACTIONS(7502),
    [anon_sym_AMP] = ACTIONS(7502),
    [anon_sym_PIPE_PIPE] = ACTIONS(7500),
    [anon_sym_AMP_AMP] = ACTIONS(7500),
    [anon_sym_LT] = ACTIONS(7502),
    [anon_sym_LT_EQ] = ACTIONS(7500),
    [anon_sym_GT] = ACTIONS(7502),
    [anon_sym_GT_EQ] = ACTIONS(7500),
    [anon_sym_EQ_EQ] = ACTIONS(7500),
    [anon_sym_BANG_EQ] = ACTIONS(7500),
    [anon_sym_STAR] = ACTIONS(7502),
    [anon_sym_SLASH] = ACTIONS(7500),
    [anon_sym_STAR_STAR] = ACTIONS(7500),
    [anon_sym_CARET] = ACTIONS(7500),
    [aux_sym_binary_operator_token1] = ACTIONS(7500),
    [anon_sym_PIPE_GT] = ACTIONS(7500),
    [anon_sym_COLON] = ACTIONS(7502),
    [anon_sym_DOLLAR] = ACTIONS(7500),
    [anon_sym_AT] = ACTIONS(7500),
    [aux_sym__hex_literal_token1] = ACTIONS(7500),
    [sym__number_literal] = ACTIONS(7502),
    [anon_sym_SQUOTE] = ACTIONS(7500),
    [anon_sym_DQUOTE] = ACTIONS(7500),
    [sym_return] = ACTIONS(7502),
    [sym_next] = ACTIONS(7502),
    [sym_break] = ACTIONS(7502),
    [sym_true] = ACTIONS(7502),
    [sym_false] = ACTIONS(7502),
    [sym_null] = ACTIONS(7502),
    [sym_inf] = ACTIONS(7502),
    [sym_nan] = ACTIONS(7502),
    [anon_sym_NA] = ACTIONS(7502),
    [anon_sym_NA_integer_] = ACTIONS(7502),
    [anon_sym_NA_real_] = ACTIONS(7502),
    [anon_sym_NA_complex_] = ACTIONS(7502),
    [anon_sym_NA_character_] = ACTIONS(7502),
    [sym_dots] = ACTIONS(7502),
    [sym_dot_dot_i] = ACTIONS(7500),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7500),
    [sym__newline] = ACTIONS(7500),
    [sym__raw_string_literal] = ACTIONS(7500),
    [sym__external_open_parenthesis] = ACTIONS(7500),
    [sym__external_close_parenthesis] = ACTIONS(7500),
    [sym__external_open_brace] = ACTIONS(7500),
    [sym__external_open_bracket] = ACTIONS(7500),
    [sym__external_open_bracket2] = ACTIONS(7500),
  },
  [2952] = {
    [sym_identifier] = ACTIONS(7498),
    [anon_sym_BSLASH] = ACTIONS(7496),
    [anon_sym_function] = ACTIONS(7498),
    [anon_sym_EQ] = ACTIONS(7498),
    [anon_sym_if] = ACTIONS(7498),
    [anon_sym_for] = ACTIONS(7498),
    [anon_sym_while] = ACTIONS(7498),
    [anon_sym_repeat] = ACTIONS(7498),
    [anon_sym_QMARK] = ACTIONS(7496),
    [anon_sym_TILDE] = ACTIONS(7496),
    [anon_sym_BANG] = ACTIONS(7498),
    [anon_sym_PLUS] = ACTIONS(7496),
    [anon_sym_DASH] = ACTIONS(7498),
    [anon_sym_LT_DASH] = ACTIONS(7496),
    [anon_sym_LT_LT_DASH] = ACTIONS(7496),
    [anon_sym_COLON_EQ] = ACTIONS(7496),
    [anon_sym_DASH_GT] = ACTIONS(7498),
    [anon_sym_DASH_GT_GT] = ACTIONS(7496),
    [anon_sym_PIPE] = ACTIONS(7498),
    [anon_sym_AMP] = ACTIONS(7498),
    [anon_sym_PIPE_PIPE] = ACTIONS(7496),
    [anon_sym_AMP_AMP] = ACTIONS(7496),
    [anon_sym_LT] = ACTIONS(7498),
    [anon_sym_LT_EQ] = ACTIONS(7496),
    [anon_sym_GT] = ACTIONS(7498),
    [anon_sym_GT_EQ] = ACTIONS(7496),
    [anon_sym_EQ_EQ] = ACTIONS(7496),
    [anon_sym_BANG_EQ] = ACTIONS(7496),
    [anon_sym_STAR] = ACTIONS(7498),
    [anon_sym_SLASH] = ACTIONS(7496),
    [anon_sym_STAR_STAR] = ACTIONS(7496),
    [anon_sym_CARET] = ACTIONS(7496),
    [aux_sym_binary_operator_token1] = ACTIONS(7496),
    [anon_sym_PIPE_GT] = ACTIONS(7496),
    [anon_sym_COLON] = ACTIONS(7498),
    [anon_sym_DOLLAR] = ACTIONS(7496),
    [anon_sym_AT] = ACTIONS(7496),
    [aux_sym__hex_literal_token1] = ACTIONS(7496),
    [sym__number_literal] = ACTIONS(7498),
    [anon_sym_SQUOTE] = ACTIONS(7496),
    [anon_sym_DQUOTE] = ACTIONS(7496),
    [sym_return] = ACTIONS(7498),
    [sym_next] = ACTIONS(7498),
    [sym_break] = ACTIONS(7498),
    [sym_true] = ACTIONS(7498),
    [sym_false] = ACTIONS(7498),
    [sym_null] = ACTIONS(7498),
    [sym_inf] = ACTIONS(7498),
    [sym_nan] = ACTIONS(7498),
    [anon_sym_NA] = ACTIONS(7498),
    [anon_sym_NA_integer_] = ACTIONS(7498),
    [anon_sym_NA_real_] = ACTIONS(7498),
    [anon_sym_NA_complex_] = ACTIONS(7498),
    [anon_sym_NA_character_] = ACTIONS(7498),
    [sym_dots] = ACTIONS(7498),
    [sym_dot_dot_i] = ACTIONS(7496),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7496),
    [sym__newline] = ACTIONS(7496),
    [sym__raw_string_literal] = ACTIONS(7496),
    [sym__external_open_parenthesis] = ACTIONS(7496),
    [sym__external_close_parenthesis] = ACTIONS(7496),
    [sym__external_open_brace] = ACTIONS(7496),
    [sym__external_open_bracket] = ACTIONS(7496),
    [sym__external_open_bracket2] = ACTIONS(7496),
  },
  [2953] = {
    [sym_identifier] = ACTIONS(7494),
    [anon_sym_BSLASH] = ACTIONS(7492),
    [anon_sym_function] = ACTIONS(7494),
    [anon_sym_EQ] = ACTIONS(7494),
    [anon_sym_if] = ACTIONS(7494),
    [anon_sym_for] = ACTIONS(7494),
    [anon_sym_while] = ACTIONS(7494),
    [anon_sym_repeat] = ACTIONS(7494),
    [anon_sym_QMARK] = ACTIONS(7492),
    [anon_sym_TILDE] = ACTIONS(7492),
    [anon_sym_BANG] = ACTIONS(7494),
    [anon_sym_PLUS] = ACTIONS(7492),
    [anon_sym_DASH] = ACTIONS(7494),
    [anon_sym_LT_DASH] = ACTIONS(7492),
    [anon_sym_LT_LT_DASH] = ACTIONS(7492),
    [anon_sym_COLON_EQ] = ACTIONS(7492),
    [anon_sym_DASH_GT] = ACTIONS(7494),
    [anon_sym_DASH_GT_GT] = ACTIONS(7492),
    [anon_sym_PIPE] = ACTIONS(7494),
    [anon_sym_AMP] = ACTIONS(7494),
    [anon_sym_PIPE_PIPE] = ACTIONS(7492),
    [anon_sym_AMP_AMP] = ACTIONS(7492),
    [anon_sym_LT] = ACTIONS(7494),
    [anon_sym_LT_EQ] = ACTIONS(7492),
    [anon_sym_GT] = ACTIONS(7494),
    [anon_sym_GT_EQ] = ACTIONS(7492),
    [anon_sym_EQ_EQ] = ACTIONS(7492),
    [anon_sym_BANG_EQ] = ACTIONS(7492),
    [anon_sym_STAR] = ACTIONS(7494),
    [anon_sym_SLASH] = ACTIONS(7492),
    [anon_sym_STAR_STAR] = ACTIONS(7492),
    [anon_sym_CARET] = ACTIONS(7492),
    [aux_sym_binary_operator_token1] = ACTIONS(7492),
    [anon_sym_PIPE_GT] = ACTIONS(7492),
    [anon_sym_COLON] = ACTIONS(7494),
    [anon_sym_DOLLAR] = ACTIONS(7492),
    [anon_sym_AT] = ACTIONS(7492),
    [aux_sym__hex_literal_token1] = ACTIONS(7492),
    [sym__number_literal] = ACTIONS(7494),
    [anon_sym_SQUOTE] = ACTIONS(7492),
    [anon_sym_DQUOTE] = ACTIONS(7492),
    [sym_return] = ACTIONS(7494),
    [sym_next] = ACTIONS(7494),
    [sym_break] = ACTIONS(7494),
    [sym_true] = ACTIONS(7494),
    [sym_false] = ACTIONS(7494),
    [sym_null] = ACTIONS(7494),
    [sym_inf] = ACTIONS(7494),
    [sym_nan] = ACTIONS(7494),
    [anon_sym_NA] = ACTIONS(7494),
    [anon_sym_NA_integer_] = ACTIONS(7494),
    [anon_sym_NA_real_] = ACTIONS(7494),
    [anon_sym_NA_complex_] = ACTIONS(7494),
    [anon_sym_NA_character_] = ACTIONS(7494),
    [sym_dots] = ACTIONS(7494),
    [sym_dot_dot_i] = ACTIONS(7492),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7492),
    [sym__newline] = ACTIONS(7492),
    [sym__raw_string_literal] = ACTIONS(7492),
    [sym__external_open_parenthesis] = ACTIONS(7492),
    [sym__external_close_parenthesis] = ACTIONS(7492),
    [sym__external_open_brace] = ACTIONS(7492),
    [sym__external_open_bracket] = ACTIONS(7492),
    [sym__external_open_bracket2] = ACTIONS(7492),
  },
  [2954] = {
    [sym_identifier] = ACTIONS(7490),
    [anon_sym_BSLASH] = ACTIONS(7488),
    [anon_sym_function] = ACTIONS(7490),
    [anon_sym_EQ] = ACTIONS(7490),
    [anon_sym_if] = ACTIONS(7490),
    [anon_sym_for] = ACTIONS(7490),
    [anon_sym_while] = ACTIONS(7490),
    [anon_sym_repeat] = ACTIONS(7490),
    [anon_sym_QMARK] = ACTIONS(7488),
    [anon_sym_TILDE] = ACTIONS(7488),
    [anon_sym_BANG] = ACTIONS(7490),
    [anon_sym_PLUS] = ACTIONS(7488),
    [anon_sym_DASH] = ACTIONS(7490),
    [anon_sym_LT_DASH] = ACTIONS(7488),
    [anon_sym_LT_LT_DASH] = ACTIONS(7488),
    [anon_sym_COLON_EQ] = ACTIONS(7488),
    [anon_sym_DASH_GT] = ACTIONS(7490),
    [anon_sym_DASH_GT_GT] = ACTIONS(7488),
    [anon_sym_PIPE] = ACTIONS(7490),
    [anon_sym_AMP] = ACTIONS(7490),
    [anon_sym_PIPE_PIPE] = ACTIONS(7488),
    [anon_sym_AMP_AMP] = ACTIONS(7488),
    [anon_sym_LT] = ACTIONS(7490),
    [anon_sym_LT_EQ] = ACTIONS(7488),
    [anon_sym_GT] = ACTIONS(7490),
    [anon_sym_GT_EQ] = ACTIONS(7488),
    [anon_sym_EQ_EQ] = ACTIONS(7488),
    [anon_sym_BANG_EQ] = ACTIONS(7488),
    [anon_sym_STAR] = ACTIONS(7490),
    [anon_sym_SLASH] = ACTIONS(7488),
    [anon_sym_STAR_STAR] = ACTIONS(7488),
    [anon_sym_CARET] = ACTIONS(7488),
    [aux_sym_binary_operator_token1] = ACTIONS(7488),
    [anon_sym_PIPE_GT] = ACTIONS(7488),
    [anon_sym_COLON] = ACTIONS(7490),
    [anon_sym_DOLLAR] = ACTIONS(7488),
    [anon_sym_AT] = ACTIONS(7488),
    [aux_sym__hex_literal_token1] = ACTIONS(7488),
    [sym__number_literal] = ACTIONS(7490),
    [anon_sym_SQUOTE] = ACTIONS(7488),
    [anon_sym_DQUOTE] = ACTIONS(7488),
    [sym_return] = ACTIONS(7490),
    [sym_next] = ACTIONS(7490),
    [sym_break] = ACTIONS(7490),
    [sym_true] = ACTIONS(7490),
    [sym_false] = ACTIONS(7490),
    [sym_null] = ACTIONS(7490),
    [sym_inf] = ACTIONS(7490),
    [sym_nan] = ACTIONS(7490),
    [anon_sym_NA] = ACTIONS(7490),
    [anon_sym_NA_integer_] = ACTIONS(7490),
    [anon_sym_NA_real_] = ACTIONS(7490),
    [anon_sym_NA_complex_] = ACTIONS(7490),
    [anon_sym_NA_character_] = ACTIONS(7490),
    [sym_dots] = ACTIONS(7490),
    [sym_dot_dot_i] = ACTIONS(7488),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7488),
    [sym__newline] = ACTIONS(7488),
    [sym__raw_string_literal] = ACTIONS(7488),
    [sym__external_open_parenthesis] = ACTIONS(7488),
    [sym__external_close_parenthesis] = ACTIONS(7488),
    [sym__external_open_brace] = ACTIONS(7488),
    [sym__external_open_bracket] = ACTIONS(7488),
    [sym__external_open_bracket2] = ACTIONS(7488),
  },
  [2955] = {
    [sym_identifier] = ACTIONS(7474),
    [anon_sym_BSLASH] = ACTIONS(7472),
    [anon_sym_function] = ACTIONS(7474),
    [anon_sym_EQ] = ACTIONS(7474),
    [anon_sym_if] = ACTIONS(7474),
    [anon_sym_for] = ACTIONS(7474),
    [anon_sym_while] = ACTIONS(7474),
    [anon_sym_repeat] = ACTIONS(7474),
    [anon_sym_QMARK] = ACTIONS(7472),
    [anon_sym_TILDE] = ACTIONS(7472),
    [anon_sym_BANG] = ACTIONS(7474),
    [anon_sym_PLUS] = ACTIONS(7472),
    [anon_sym_DASH] = ACTIONS(7474),
    [anon_sym_LT_DASH] = ACTIONS(7472),
    [anon_sym_LT_LT_DASH] = ACTIONS(7472),
    [anon_sym_COLON_EQ] = ACTIONS(7472),
    [anon_sym_DASH_GT] = ACTIONS(7474),
    [anon_sym_DASH_GT_GT] = ACTIONS(7472),
    [anon_sym_PIPE] = ACTIONS(7474),
    [anon_sym_AMP] = ACTIONS(7474),
    [anon_sym_PIPE_PIPE] = ACTIONS(7472),
    [anon_sym_AMP_AMP] = ACTIONS(7472),
    [anon_sym_LT] = ACTIONS(7474),
    [anon_sym_LT_EQ] = ACTIONS(7472),
    [anon_sym_GT] = ACTIONS(7474),
    [anon_sym_GT_EQ] = ACTIONS(7472),
    [anon_sym_EQ_EQ] = ACTIONS(7472),
    [anon_sym_BANG_EQ] = ACTIONS(7472),
    [anon_sym_STAR] = ACTIONS(7474),
    [anon_sym_SLASH] = ACTIONS(7472),
    [anon_sym_STAR_STAR] = ACTIONS(7472),
    [anon_sym_CARET] = ACTIONS(7472),
    [aux_sym_binary_operator_token1] = ACTIONS(7472),
    [anon_sym_PIPE_GT] = ACTIONS(7472),
    [anon_sym_COLON] = ACTIONS(7474),
    [anon_sym_DOLLAR] = ACTIONS(7472),
    [anon_sym_AT] = ACTIONS(7472),
    [aux_sym__hex_literal_token1] = ACTIONS(7472),
    [sym__number_literal] = ACTIONS(7474),
    [anon_sym_SQUOTE] = ACTIONS(7472),
    [anon_sym_DQUOTE] = ACTIONS(7472),
    [sym_return] = ACTIONS(7474),
    [sym_next] = ACTIONS(7474),
    [sym_break] = ACTIONS(7474),
    [sym_true] = ACTIONS(7474),
    [sym_false] = ACTIONS(7474),
    [sym_null] = ACTIONS(7474),
    [sym_inf] = ACTIONS(7474),
    [sym_nan] = ACTIONS(7474),
    [anon_sym_NA] = ACTIONS(7474),
    [anon_sym_NA_integer_] = ACTIONS(7474),
    [anon_sym_NA_real_] = ACTIONS(7474),
    [anon_sym_NA_complex_] = ACTIONS(7474),
    [anon_sym_NA_character_] = ACTIONS(7474),
    [sym_dots] = ACTIONS(7474),
    [sym_dot_dot_i] = ACTIONS(7472),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7472),
    [sym__newline] = ACTIONS(7472),
    [sym__raw_string_literal] = ACTIONS(7472),
    [sym__external_open_parenthesis] = ACTIONS(7472),
    [sym__external_close_parenthesis] = ACTIONS(7472),
    [sym__external_open_brace] = ACTIONS(7472),
    [sym__external_open_bracket] = ACTIONS(7472),
    [sym__external_open_bracket2] = ACTIONS(7472),
  },
  [2956] = {
    [sym_identifier] = ACTIONS(7563),
    [anon_sym_BSLASH] = ACTIONS(7561),
    [anon_sym_function] = ACTIONS(7563),
    [anon_sym_EQ] = ACTIONS(7563),
    [anon_sym_if] = ACTIONS(7563),
    [anon_sym_for] = ACTIONS(7563),
    [anon_sym_while] = ACTIONS(7563),
    [anon_sym_repeat] = ACTIONS(7563),
    [anon_sym_QMARK] = ACTIONS(7561),
    [anon_sym_TILDE] = ACTIONS(7561),
    [anon_sym_BANG] = ACTIONS(7563),
    [anon_sym_PLUS] = ACTIONS(7561),
    [anon_sym_DASH] = ACTIONS(7563),
    [anon_sym_LT_DASH] = ACTIONS(7561),
    [anon_sym_LT_LT_DASH] = ACTIONS(7561),
    [anon_sym_COLON_EQ] = ACTIONS(7561),
    [anon_sym_DASH_GT] = ACTIONS(7563),
    [anon_sym_DASH_GT_GT] = ACTIONS(7561),
    [anon_sym_PIPE] = ACTIONS(7563),
    [anon_sym_AMP] = ACTIONS(7563),
    [anon_sym_PIPE_PIPE] = ACTIONS(7561),
    [anon_sym_AMP_AMP] = ACTIONS(7561),
    [anon_sym_LT] = ACTIONS(7563),
    [anon_sym_LT_EQ] = ACTIONS(7561),
    [anon_sym_GT] = ACTIONS(7563),
    [anon_sym_GT_EQ] = ACTIONS(7561),
    [anon_sym_EQ_EQ] = ACTIONS(7561),
    [anon_sym_BANG_EQ] = ACTIONS(7561),
    [anon_sym_STAR] = ACTIONS(7563),
    [anon_sym_SLASH] = ACTIONS(7561),
    [anon_sym_STAR_STAR] = ACTIONS(7561),
    [anon_sym_CARET] = ACTIONS(7561),
    [aux_sym_binary_operator_token1] = ACTIONS(7561),
    [anon_sym_PIPE_GT] = ACTIONS(7561),
    [anon_sym_COLON] = ACTIONS(7563),
    [anon_sym_DOLLAR] = ACTIONS(7561),
    [anon_sym_AT] = ACTIONS(7561),
    [aux_sym__hex_literal_token1] = ACTIONS(7561),
    [sym__number_literal] = ACTIONS(7563),
    [anon_sym_SQUOTE] = ACTIONS(7561),
    [anon_sym_DQUOTE] = ACTIONS(7561),
    [sym_return] = ACTIONS(7563),
    [sym_next] = ACTIONS(7563),
    [sym_break] = ACTIONS(7563),
    [sym_true] = ACTIONS(7563),
    [sym_false] = ACTIONS(7563),
    [sym_null] = ACTIONS(7563),
    [sym_inf] = ACTIONS(7563),
    [sym_nan] = ACTIONS(7563),
    [anon_sym_NA] = ACTIONS(7563),
    [anon_sym_NA_integer_] = ACTIONS(7563),
    [anon_sym_NA_real_] = ACTIONS(7563),
    [anon_sym_NA_complex_] = ACTIONS(7563),
    [anon_sym_NA_character_] = ACTIONS(7563),
    [sym_dots] = ACTIONS(7563),
    [sym_dot_dot_i] = ACTIONS(7561),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7561),
    [sym__newline] = ACTIONS(7561),
    [sym__raw_string_literal] = ACTIONS(7561),
    [sym__external_open_parenthesis] = ACTIONS(7561),
    [sym__external_open_brace] = ACTIONS(7561),
    [sym__external_open_bracket] = ACTIONS(7561),
    [sym__external_close_bracket] = ACTIONS(7561),
    [sym__external_open_bracket2] = ACTIONS(7561),
  },
  [2957] = {
    [sym_identifier] = ACTIONS(7552),
    [anon_sym_BSLASH] = ACTIONS(7550),
    [anon_sym_function] = ACTIONS(7552),
    [anon_sym_EQ] = ACTIONS(7552),
    [anon_sym_if] = ACTIONS(7552),
    [anon_sym_for] = ACTIONS(7552),
    [anon_sym_while] = ACTIONS(7552),
    [anon_sym_repeat] = ACTIONS(7552),
    [anon_sym_QMARK] = ACTIONS(7550),
    [anon_sym_TILDE] = ACTIONS(7550),
    [anon_sym_BANG] = ACTIONS(7552),
    [anon_sym_PLUS] = ACTIONS(7550),
    [anon_sym_DASH] = ACTIONS(7552),
    [anon_sym_LT_DASH] = ACTIONS(7550),
    [anon_sym_LT_LT_DASH] = ACTIONS(7550),
    [anon_sym_COLON_EQ] = ACTIONS(7550),
    [anon_sym_DASH_GT] = ACTIONS(7552),
    [anon_sym_DASH_GT_GT] = ACTIONS(7550),
    [anon_sym_PIPE] = ACTIONS(7552),
    [anon_sym_AMP] = ACTIONS(7552),
    [anon_sym_PIPE_PIPE] = ACTIONS(7550),
    [anon_sym_AMP_AMP] = ACTIONS(7550),
    [anon_sym_LT] = ACTIONS(7552),
    [anon_sym_LT_EQ] = ACTIONS(7550),
    [anon_sym_GT] = ACTIONS(7552),
    [anon_sym_GT_EQ] = ACTIONS(7550),
    [anon_sym_EQ_EQ] = ACTIONS(7550),
    [anon_sym_BANG_EQ] = ACTIONS(7550),
    [anon_sym_STAR] = ACTIONS(7552),
    [anon_sym_SLASH] = ACTIONS(7550),
    [anon_sym_STAR_STAR] = ACTIONS(7550),
    [anon_sym_CARET] = ACTIONS(7550),
    [aux_sym_binary_operator_token1] = ACTIONS(7550),
    [anon_sym_PIPE_GT] = ACTIONS(7550),
    [anon_sym_COLON] = ACTIONS(7552),
    [anon_sym_DOLLAR] = ACTIONS(7550),
    [anon_sym_AT] = ACTIONS(7550),
    [aux_sym__hex_literal_token1] = ACTIONS(7550),
    [sym__number_literal] = ACTIONS(7552),
    [anon_sym_SQUOTE] = ACTIONS(7550),
    [anon_sym_DQUOTE] = ACTIONS(7550),
    [sym_return] = ACTIONS(7552),
    [sym_next] = ACTIONS(7552),
    [sym_break] = ACTIONS(7552),
    [sym_true] = ACTIONS(7552),
    [sym_false] = ACTIONS(7552),
    [sym_null] = ACTIONS(7552),
    [sym_inf] = ACTIONS(7552),
    [sym_nan] = ACTIONS(7552),
    [anon_sym_NA] = ACTIONS(7552),
    [anon_sym_NA_integer_] = ACTIONS(7552),
    [anon_sym_NA_real_] = ACTIONS(7552),
    [anon_sym_NA_complex_] = ACTIONS(7552),
    [anon_sym_NA_character_] = ACTIONS(7552),
    [sym_dots] = ACTIONS(7552),
    [sym_dot_dot_i] = ACTIONS(7550),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7550),
    [sym__newline] = ACTIONS(7550),
    [sym__raw_string_literal] = ACTIONS(7550),
    [sym__external_open_parenthesis] = ACTIONS(7550),
    [sym__external_close_parenthesis] = ACTIONS(7550),
    [sym__external_open_brace] = ACTIONS(7550),
    [sym__external_open_bracket] = ACTIONS(7550),
    [sym__external_open_bracket2] = ACTIONS(7550),
  },
  [2958] = {
    [sym_identifier] = ACTIONS(7464),
    [anon_sym_BSLASH] = ACTIONS(7466),
    [anon_sym_function] = ACTIONS(7464),
    [anon_sym_EQ] = ACTIONS(7464),
    [anon_sym_if] = ACTIONS(7464),
    [anon_sym_for] = ACTIONS(7464),
    [anon_sym_while] = ACTIONS(7464),
    [anon_sym_repeat] = ACTIONS(7464),
    [anon_sym_QMARK] = ACTIONS(7466),
    [anon_sym_TILDE] = ACTIONS(7466),
    [anon_sym_BANG] = ACTIONS(7464),
    [anon_sym_PLUS] = ACTIONS(7466),
    [anon_sym_DASH] = ACTIONS(7464),
    [anon_sym_LT_DASH] = ACTIONS(7466),
    [anon_sym_LT_LT_DASH] = ACTIONS(7466),
    [anon_sym_COLON_EQ] = ACTIONS(7466),
    [anon_sym_DASH_GT] = ACTIONS(7464),
    [anon_sym_DASH_GT_GT] = ACTIONS(7466),
    [anon_sym_PIPE] = ACTIONS(7464),
    [anon_sym_AMP] = ACTIONS(7464),
    [anon_sym_PIPE_PIPE] = ACTIONS(7466),
    [anon_sym_AMP_AMP] = ACTIONS(7466),
    [anon_sym_LT] = ACTIONS(7464),
    [anon_sym_LT_EQ] = ACTIONS(7466),
    [anon_sym_GT] = ACTIONS(7464),
    [anon_sym_GT_EQ] = ACTIONS(7466),
    [anon_sym_EQ_EQ] = ACTIONS(7466),
    [anon_sym_BANG_EQ] = ACTIONS(7466),
    [anon_sym_STAR] = ACTIONS(7464),
    [anon_sym_SLASH] = ACTIONS(7466),
    [anon_sym_STAR_STAR] = ACTIONS(7466),
    [anon_sym_CARET] = ACTIONS(7466),
    [aux_sym_binary_operator_token1] = ACTIONS(7466),
    [anon_sym_PIPE_GT] = ACTIONS(7466),
    [anon_sym_COLON] = ACTIONS(7464),
    [anon_sym_DOLLAR] = ACTIONS(7466),
    [anon_sym_AT] = ACTIONS(7466),
    [aux_sym__hex_literal_token1] = ACTIONS(7466),
    [sym__number_literal] = ACTIONS(7464),
    [anon_sym_SQUOTE] = ACTIONS(7466),
    [anon_sym_DQUOTE] = ACTIONS(7466),
    [sym_return] = ACTIONS(7464),
    [sym_next] = ACTIONS(7464),
    [sym_break] = ACTIONS(7464),
    [sym_true] = ACTIONS(7464),
    [sym_false] = ACTIONS(7464),
    [sym_null] = ACTIONS(7464),
    [sym_inf] = ACTIONS(7464),
    [sym_nan] = ACTIONS(7464),
    [anon_sym_NA] = ACTIONS(7464),
    [anon_sym_NA_integer_] = ACTIONS(7464),
    [anon_sym_NA_real_] = ACTIONS(7464),
    [anon_sym_NA_complex_] = ACTIONS(7464),
    [anon_sym_NA_character_] = ACTIONS(7464),
    [sym_dots] = ACTIONS(7464),
    [sym_dot_dot_i] = ACTIONS(7466),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7466),
    [sym__newline] = ACTIONS(7466),
    [sym__raw_string_literal] = ACTIONS(7466),
    [sym__external_open_parenthesis] = ACTIONS(7466),
    [sym__external_open_brace] = ACTIONS(7466),
    [sym__external_open_bracket] = ACTIONS(7466),
    [sym__external_open_bracket2] = ACTIONS(7466),
    [sym__external_close_bracket2] = ACTIONS(7466),
  },
  [2959] = {
    [sym_identifier] = ACTIONS(7129),
    [anon_sym_BSLASH] = ACTIONS(7131),
    [anon_sym_function] = ACTIONS(7129),
    [anon_sym_EQ] = ACTIONS(7658),
    [anon_sym_if] = ACTIONS(7129),
    [anon_sym_for] = ACTIONS(7129),
    [anon_sym_while] = ACTIONS(7129),
    [anon_sym_repeat] = ACTIONS(7129),
    [anon_sym_QMARK] = ACTIONS(7131),
    [anon_sym_TILDE] = ACTIONS(7131),
    [anon_sym_BANG] = ACTIONS(7129),
    [anon_sym_PLUS] = ACTIONS(7131),
    [anon_sym_DASH] = ACTIONS(7129),
    [anon_sym_LT_DASH] = ACTIONS(7131),
    [anon_sym_LT_LT_DASH] = ACTIONS(7131),
    [anon_sym_COLON_EQ] = ACTIONS(7131),
    [anon_sym_DASH_GT] = ACTIONS(7129),
    [anon_sym_DASH_GT_GT] = ACTIONS(7131),
    [anon_sym_PIPE] = ACTIONS(7129),
    [anon_sym_AMP] = ACTIONS(7129),
    [anon_sym_PIPE_PIPE] = ACTIONS(7131),
    [anon_sym_AMP_AMP] = ACTIONS(7131),
    [anon_sym_LT] = ACTIONS(7129),
    [anon_sym_LT_EQ] = ACTIONS(7131),
    [anon_sym_GT] = ACTIONS(7129),
    [anon_sym_GT_EQ] = ACTIONS(7131),
    [anon_sym_EQ_EQ] = ACTIONS(7131),
    [anon_sym_BANG_EQ] = ACTIONS(7131),
    [anon_sym_STAR] = ACTIONS(7129),
    [anon_sym_SLASH] = ACTIONS(7131),
    [anon_sym_STAR_STAR] = ACTIONS(7131),
    [anon_sym_CARET] = ACTIONS(7131),
    [aux_sym_binary_operator_token1] = ACTIONS(7131),
    [anon_sym_PIPE_GT] = ACTIONS(7131),
    [anon_sym_COLON] = ACTIONS(7129),
    [anon_sym_DOLLAR] = ACTIONS(7131),
    [anon_sym_AT] = ACTIONS(7131),
    [aux_sym__hex_literal_token1] = ACTIONS(7131),
    [sym__number_literal] = ACTIONS(7129),
    [anon_sym_SQUOTE] = ACTIONS(7131),
    [anon_sym_DQUOTE] = ACTIONS(7131),
    [sym_return] = ACTIONS(7129),
    [sym_next] = ACTIONS(7129),
    [sym_break] = ACTIONS(7129),
    [sym_true] = ACTIONS(7129),
    [sym_false] = ACTIONS(7129),
    [sym_null] = ACTIONS(7129),
    [sym_inf] = ACTIONS(7129),
    [sym_nan] = ACTIONS(7129),
    [anon_sym_NA] = ACTIONS(7129),
    [anon_sym_NA_integer_] = ACTIONS(7129),
    [anon_sym_NA_real_] = ACTIONS(7129),
    [anon_sym_NA_complex_] = ACTIONS(7129),
    [anon_sym_NA_character_] = ACTIONS(7129),
    [sym_dots] = ACTIONS(7129),
    [sym_dot_dot_i] = ACTIONS(7131),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7131),
    [sym__newline] = ACTIONS(7131),
    [sym__raw_string_literal] = ACTIONS(7131),
    [sym__external_open_parenthesis] = ACTIONS(7131),
    [sym__external_open_brace] = ACTIONS(7131),
    [sym__external_open_bracket] = ACTIONS(7131),
    [sym__external_open_bracket2] = ACTIONS(7131),
    [sym__external_close_bracket2] = ACTIONS(7131),
  },
  [2960] = {
    [sym_identifier] = ACTIONS(7474),
    [anon_sym_BSLASH] = ACTIONS(7472),
    [anon_sym_function] = ACTIONS(7474),
    [anon_sym_EQ] = ACTIONS(7474),
    [anon_sym_if] = ACTIONS(7474),
    [anon_sym_for] = ACTIONS(7474),
    [anon_sym_while] = ACTIONS(7474),
    [anon_sym_repeat] = ACTIONS(7474),
    [anon_sym_QMARK] = ACTIONS(7472),
    [anon_sym_TILDE] = ACTIONS(7472),
    [anon_sym_BANG] = ACTIONS(7474),
    [anon_sym_PLUS] = ACTIONS(7472),
    [anon_sym_DASH] = ACTIONS(7474),
    [anon_sym_LT_DASH] = ACTIONS(7472),
    [anon_sym_LT_LT_DASH] = ACTIONS(7472),
    [anon_sym_COLON_EQ] = ACTIONS(7472),
    [anon_sym_DASH_GT] = ACTIONS(7474),
    [anon_sym_DASH_GT_GT] = ACTIONS(7472),
    [anon_sym_PIPE] = ACTIONS(7474),
    [anon_sym_AMP] = ACTIONS(7474),
    [anon_sym_PIPE_PIPE] = ACTIONS(7472),
    [anon_sym_AMP_AMP] = ACTIONS(7472),
    [anon_sym_LT] = ACTIONS(7474),
    [anon_sym_LT_EQ] = ACTIONS(7472),
    [anon_sym_GT] = ACTIONS(7474),
    [anon_sym_GT_EQ] = ACTIONS(7472),
    [anon_sym_EQ_EQ] = ACTIONS(7472),
    [anon_sym_BANG_EQ] = ACTIONS(7472),
    [anon_sym_STAR] = ACTIONS(7474),
    [anon_sym_SLASH] = ACTIONS(7472),
    [anon_sym_STAR_STAR] = ACTIONS(7472),
    [anon_sym_CARET] = ACTIONS(7472),
    [aux_sym_binary_operator_token1] = ACTIONS(7472),
    [anon_sym_PIPE_GT] = ACTIONS(7472),
    [anon_sym_COLON] = ACTIONS(7474),
    [anon_sym_DOLLAR] = ACTIONS(7472),
    [anon_sym_AT] = ACTIONS(7472),
    [aux_sym__hex_literal_token1] = ACTIONS(7472),
    [sym__number_literal] = ACTIONS(7474),
    [anon_sym_SQUOTE] = ACTIONS(7472),
    [anon_sym_DQUOTE] = ACTIONS(7472),
    [sym_return] = ACTIONS(7474),
    [sym_next] = ACTIONS(7474),
    [sym_break] = ACTIONS(7474),
    [sym_true] = ACTIONS(7474),
    [sym_false] = ACTIONS(7474),
    [sym_null] = ACTIONS(7474),
    [sym_inf] = ACTIONS(7474),
    [sym_nan] = ACTIONS(7474),
    [anon_sym_NA] = ACTIONS(7474),
    [anon_sym_NA_integer_] = ACTIONS(7474),
    [anon_sym_NA_real_] = ACTIONS(7474),
    [anon_sym_NA_complex_] = ACTIONS(7474),
    [anon_sym_NA_character_] = ACTIONS(7474),
    [sym_dots] = ACTIONS(7474),
    [sym_dot_dot_i] = ACTIONS(7472),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7472),
    [sym__newline] = ACTIONS(7472),
    [sym__raw_string_literal] = ACTIONS(7472),
    [sym__external_open_parenthesis] = ACTIONS(7472),
    [sym__external_open_brace] = ACTIONS(7472),
    [sym__external_open_bracket] = ACTIONS(7472),
    [sym__external_open_bracket2] = ACTIONS(7472),
    [sym__external_close_bracket2] = ACTIONS(7472),
  },
  [2961] = {
    [sym_identifier] = ACTIONS(7478),
    [anon_sym_BSLASH] = ACTIONS(7476),
    [anon_sym_function] = ACTIONS(7478),
    [anon_sym_EQ] = ACTIONS(7478),
    [anon_sym_if] = ACTIONS(7478),
    [anon_sym_for] = ACTIONS(7478),
    [anon_sym_while] = ACTIONS(7478),
    [anon_sym_repeat] = ACTIONS(7478),
    [anon_sym_QMARK] = ACTIONS(7476),
    [anon_sym_TILDE] = ACTIONS(7476),
    [anon_sym_BANG] = ACTIONS(7478),
    [anon_sym_PLUS] = ACTIONS(7476),
    [anon_sym_DASH] = ACTIONS(7478),
    [anon_sym_LT_DASH] = ACTIONS(7476),
    [anon_sym_LT_LT_DASH] = ACTIONS(7476),
    [anon_sym_COLON_EQ] = ACTIONS(7476),
    [anon_sym_DASH_GT] = ACTIONS(7478),
    [anon_sym_DASH_GT_GT] = ACTIONS(7476),
    [anon_sym_PIPE] = ACTIONS(7478),
    [anon_sym_AMP] = ACTIONS(7478),
    [anon_sym_PIPE_PIPE] = ACTIONS(7476),
    [anon_sym_AMP_AMP] = ACTIONS(7476),
    [anon_sym_LT] = ACTIONS(7478),
    [anon_sym_LT_EQ] = ACTIONS(7476),
    [anon_sym_GT] = ACTIONS(7478),
    [anon_sym_GT_EQ] = ACTIONS(7476),
    [anon_sym_EQ_EQ] = ACTIONS(7476),
    [anon_sym_BANG_EQ] = ACTIONS(7476),
    [anon_sym_STAR] = ACTIONS(7478),
    [anon_sym_SLASH] = ACTIONS(7476),
    [anon_sym_STAR_STAR] = ACTIONS(7476),
    [anon_sym_CARET] = ACTIONS(7476),
    [aux_sym_binary_operator_token1] = ACTIONS(7476),
    [anon_sym_PIPE_GT] = ACTIONS(7476),
    [anon_sym_COLON] = ACTIONS(7478),
    [anon_sym_DOLLAR] = ACTIONS(7476),
    [anon_sym_AT] = ACTIONS(7476),
    [aux_sym__hex_literal_token1] = ACTIONS(7476),
    [sym__number_literal] = ACTIONS(7478),
    [anon_sym_SQUOTE] = ACTIONS(7476),
    [anon_sym_DQUOTE] = ACTIONS(7476),
    [sym_return] = ACTIONS(7478),
    [sym_next] = ACTIONS(7478),
    [sym_break] = ACTIONS(7478),
    [sym_true] = ACTIONS(7478),
    [sym_false] = ACTIONS(7478),
    [sym_null] = ACTIONS(7478),
    [sym_inf] = ACTIONS(7478),
    [sym_nan] = ACTIONS(7478),
    [anon_sym_NA] = ACTIONS(7478),
    [anon_sym_NA_integer_] = ACTIONS(7478),
    [anon_sym_NA_real_] = ACTIONS(7478),
    [anon_sym_NA_complex_] = ACTIONS(7478),
    [anon_sym_NA_character_] = ACTIONS(7478),
    [sym_dots] = ACTIONS(7478),
    [sym_dot_dot_i] = ACTIONS(7476),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7476),
    [sym__newline] = ACTIONS(7476),
    [sym__raw_string_literal] = ACTIONS(7476),
    [sym__external_open_parenthesis] = ACTIONS(7476),
    [sym__external_open_brace] = ACTIONS(7476),
    [sym__external_open_bracket] = ACTIONS(7476),
    [sym__external_open_bracket2] = ACTIONS(7476),
    [sym__external_close_bracket2] = ACTIONS(7476),
  },
  [2962] = {
    [sym_identifier] = ACTIONS(7482),
    [anon_sym_BSLASH] = ACTIONS(7480),
    [anon_sym_function] = ACTIONS(7482),
    [anon_sym_EQ] = ACTIONS(7482),
    [anon_sym_if] = ACTIONS(7482),
    [anon_sym_for] = ACTIONS(7482),
    [anon_sym_while] = ACTIONS(7482),
    [anon_sym_repeat] = ACTIONS(7482),
    [anon_sym_QMARK] = ACTIONS(7480),
    [anon_sym_TILDE] = ACTIONS(7480),
    [anon_sym_BANG] = ACTIONS(7482),
    [anon_sym_PLUS] = ACTIONS(7480),
    [anon_sym_DASH] = ACTIONS(7482),
    [anon_sym_LT_DASH] = ACTIONS(7480),
    [anon_sym_LT_LT_DASH] = ACTIONS(7480),
    [anon_sym_COLON_EQ] = ACTIONS(7480),
    [anon_sym_DASH_GT] = ACTIONS(7482),
    [anon_sym_DASH_GT_GT] = ACTIONS(7480),
    [anon_sym_PIPE] = ACTIONS(7482),
    [anon_sym_AMP] = ACTIONS(7482),
    [anon_sym_PIPE_PIPE] = ACTIONS(7480),
    [anon_sym_AMP_AMP] = ACTIONS(7480),
    [anon_sym_LT] = ACTIONS(7482),
    [anon_sym_LT_EQ] = ACTIONS(7480),
    [anon_sym_GT] = ACTIONS(7482),
    [anon_sym_GT_EQ] = ACTIONS(7480),
    [anon_sym_EQ_EQ] = ACTIONS(7480),
    [anon_sym_BANG_EQ] = ACTIONS(7480),
    [anon_sym_STAR] = ACTIONS(7482),
    [anon_sym_SLASH] = ACTIONS(7480),
    [anon_sym_STAR_STAR] = ACTIONS(7480),
    [anon_sym_CARET] = ACTIONS(7480),
    [aux_sym_binary_operator_token1] = ACTIONS(7480),
    [anon_sym_PIPE_GT] = ACTIONS(7480),
    [anon_sym_COLON] = ACTIONS(7482),
    [anon_sym_DOLLAR] = ACTIONS(7480),
    [anon_sym_AT] = ACTIONS(7480),
    [aux_sym__hex_literal_token1] = ACTIONS(7480),
    [sym__number_literal] = ACTIONS(7482),
    [anon_sym_SQUOTE] = ACTIONS(7480),
    [anon_sym_DQUOTE] = ACTIONS(7480),
    [sym_return] = ACTIONS(7482),
    [sym_next] = ACTIONS(7482),
    [sym_break] = ACTIONS(7482),
    [sym_true] = ACTIONS(7482),
    [sym_false] = ACTIONS(7482),
    [sym_null] = ACTIONS(7482),
    [sym_inf] = ACTIONS(7482),
    [sym_nan] = ACTIONS(7482),
    [anon_sym_NA] = ACTIONS(7482),
    [anon_sym_NA_integer_] = ACTIONS(7482),
    [anon_sym_NA_real_] = ACTIONS(7482),
    [anon_sym_NA_complex_] = ACTIONS(7482),
    [anon_sym_NA_character_] = ACTIONS(7482),
    [sym_dots] = ACTIONS(7482),
    [sym_dot_dot_i] = ACTIONS(7480),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7480),
    [sym__newline] = ACTIONS(7480),
    [sym__raw_string_literal] = ACTIONS(7480),
    [sym__external_open_parenthesis] = ACTIONS(7480),
    [sym__external_open_brace] = ACTIONS(7480),
    [sym__external_open_bracket] = ACTIONS(7480),
    [sym__external_open_bracket2] = ACTIONS(7480),
    [sym__external_close_bracket2] = ACTIONS(7480),
  },
  [2963] = {
    [sym_identifier] = ACTIONS(7567),
    [anon_sym_BSLASH] = ACTIONS(7565),
    [anon_sym_function] = ACTIONS(7567),
    [anon_sym_EQ] = ACTIONS(7567),
    [anon_sym_if] = ACTIONS(7567),
    [anon_sym_for] = ACTIONS(7567),
    [anon_sym_while] = ACTIONS(7567),
    [anon_sym_repeat] = ACTIONS(7567),
    [anon_sym_QMARK] = ACTIONS(7565),
    [anon_sym_TILDE] = ACTIONS(7565),
    [anon_sym_BANG] = ACTIONS(7567),
    [anon_sym_PLUS] = ACTIONS(7565),
    [anon_sym_DASH] = ACTIONS(7567),
    [anon_sym_LT_DASH] = ACTIONS(7565),
    [anon_sym_LT_LT_DASH] = ACTIONS(7565),
    [anon_sym_COLON_EQ] = ACTIONS(7565),
    [anon_sym_DASH_GT] = ACTIONS(7567),
    [anon_sym_DASH_GT_GT] = ACTIONS(7565),
    [anon_sym_PIPE] = ACTIONS(7567),
    [anon_sym_AMP] = ACTIONS(7567),
    [anon_sym_PIPE_PIPE] = ACTIONS(7565),
    [anon_sym_AMP_AMP] = ACTIONS(7565),
    [anon_sym_LT] = ACTIONS(7567),
    [anon_sym_LT_EQ] = ACTIONS(7565),
    [anon_sym_GT] = ACTIONS(7567),
    [anon_sym_GT_EQ] = ACTIONS(7565),
    [anon_sym_EQ_EQ] = ACTIONS(7565),
    [anon_sym_BANG_EQ] = ACTIONS(7565),
    [anon_sym_STAR] = ACTIONS(7567),
    [anon_sym_SLASH] = ACTIONS(7565),
    [anon_sym_STAR_STAR] = ACTIONS(7565),
    [anon_sym_CARET] = ACTIONS(7565),
    [aux_sym_binary_operator_token1] = ACTIONS(7565),
    [anon_sym_PIPE_GT] = ACTIONS(7565),
    [anon_sym_COLON] = ACTIONS(7567),
    [anon_sym_DOLLAR] = ACTIONS(7565),
    [anon_sym_AT] = ACTIONS(7565),
    [aux_sym__hex_literal_token1] = ACTIONS(7565),
    [sym__number_literal] = ACTIONS(7567),
    [anon_sym_SQUOTE] = ACTIONS(7565),
    [anon_sym_DQUOTE] = ACTIONS(7565),
    [sym_return] = ACTIONS(7567),
    [sym_next] = ACTIONS(7567),
    [sym_break] = ACTIONS(7567),
    [sym_true] = ACTIONS(7567),
    [sym_false] = ACTIONS(7567),
    [sym_null] = ACTIONS(7567),
    [sym_inf] = ACTIONS(7567),
    [sym_nan] = ACTIONS(7567),
    [anon_sym_NA] = ACTIONS(7567),
    [anon_sym_NA_integer_] = ACTIONS(7567),
    [anon_sym_NA_real_] = ACTIONS(7567),
    [anon_sym_NA_complex_] = ACTIONS(7567),
    [anon_sym_NA_character_] = ACTIONS(7567),
    [sym_dots] = ACTIONS(7567),
    [sym_dot_dot_i] = ACTIONS(7565),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7565),
    [sym__newline] = ACTIONS(7565),
    [sym__raw_string_literal] = ACTIONS(7565),
    [sym__external_open_parenthesis] = ACTIONS(7565),
    [sym__external_close_parenthesis] = ACTIONS(7565),
    [sym__external_open_brace] = ACTIONS(7565),
    [sym__external_open_bracket] = ACTIONS(7565),
    [sym__external_open_bracket2] = ACTIONS(7565),
  },
  [2964] = {
    [sym_identifier] = ACTIONS(7486),
    [anon_sym_BSLASH] = ACTIONS(7484),
    [anon_sym_function] = ACTIONS(7486),
    [anon_sym_EQ] = ACTIONS(7486),
    [anon_sym_if] = ACTIONS(7486),
    [anon_sym_for] = ACTIONS(7486),
    [anon_sym_while] = ACTIONS(7486),
    [anon_sym_repeat] = ACTIONS(7486),
    [anon_sym_QMARK] = ACTIONS(7484),
    [anon_sym_TILDE] = ACTIONS(7484),
    [anon_sym_BANG] = ACTIONS(7486),
    [anon_sym_PLUS] = ACTIONS(7484),
    [anon_sym_DASH] = ACTIONS(7486),
    [anon_sym_LT_DASH] = ACTIONS(7484),
    [anon_sym_LT_LT_DASH] = ACTIONS(7484),
    [anon_sym_COLON_EQ] = ACTIONS(7484),
    [anon_sym_DASH_GT] = ACTIONS(7486),
    [anon_sym_DASH_GT_GT] = ACTIONS(7484),
    [anon_sym_PIPE] = ACTIONS(7486),
    [anon_sym_AMP] = ACTIONS(7486),
    [anon_sym_PIPE_PIPE] = ACTIONS(7484),
    [anon_sym_AMP_AMP] = ACTIONS(7484),
    [anon_sym_LT] = ACTIONS(7486),
    [anon_sym_LT_EQ] = ACTIONS(7484),
    [anon_sym_GT] = ACTIONS(7486),
    [anon_sym_GT_EQ] = ACTIONS(7484),
    [anon_sym_EQ_EQ] = ACTIONS(7484),
    [anon_sym_BANG_EQ] = ACTIONS(7484),
    [anon_sym_STAR] = ACTIONS(7486),
    [anon_sym_SLASH] = ACTIONS(7484),
    [anon_sym_STAR_STAR] = ACTIONS(7484),
    [anon_sym_CARET] = ACTIONS(7484),
    [aux_sym_binary_operator_token1] = ACTIONS(7484),
    [anon_sym_PIPE_GT] = ACTIONS(7484),
    [anon_sym_COLON] = ACTIONS(7486),
    [anon_sym_DOLLAR] = ACTIONS(7484),
    [anon_sym_AT] = ACTIONS(7484),
    [aux_sym__hex_literal_token1] = ACTIONS(7484),
    [sym__number_literal] = ACTIONS(7486),
    [anon_sym_SQUOTE] = ACTIONS(7484),
    [anon_sym_DQUOTE] = ACTIONS(7484),
    [sym_return] = ACTIONS(7486),
    [sym_next] = ACTIONS(7486),
    [sym_break] = ACTIONS(7486),
    [sym_true] = ACTIONS(7486),
    [sym_false] = ACTIONS(7486),
    [sym_null] = ACTIONS(7486),
    [sym_inf] = ACTIONS(7486),
    [sym_nan] = ACTIONS(7486),
    [anon_sym_NA] = ACTIONS(7486),
    [anon_sym_NA_integer_] = ACTIONS(7486),
    [anon_sym_NA_real_] = ACTIONS(7486),
    [anon_sym_NA_complex_] = ACTIONS(7486),
    [anon_sym_NA_character_] = ACTIONS(7486),
    [sym_dots] = ACTIONS(7486),
    [sym_dot_dot_i] = ACTIONS(7484),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7484),
    [sym__newline] = ACTIONS(7484),
    [sym__raw_string_literal] = ACTIONS(7484),
    [sym__external_open_parenthesis] = ACTIONS(7484),
    [sym__external_open_brace] = ACTIONS(7484),
    [sym__external_open_bracket] = ACTIONS(7484),
    [sym__external_open_bracket2] = ACTIONS(7484),
    [sym__external_close_bracket2] = ACTIONS(7484),
  },
  [2965] = {
    [sym_identifier] = ACTIONS(7490),
    [anon_sym_BSLASH] = ACTIONS(7488),
    [anon_sym_function] = ACTIONS(7490),
    [anon_sym_EQ] = ACTIONS(7490),
    [anon_sym_if] = ACTIONS(7490),
    [anon_sym_for] = ACTIONS(7490),
    [anon_sym_while] = ACTIONS(7490),
    [anon_sym_repeat] = ACTIONS(7490),
    [anon_sym_QMARK] = ACTIONS(7488),
    [anon_sym_TILDE] = ACTIONS(7488),
    [anon_sym_BANG] = ACTIONS(7490),
    [anon_sym_PLUS] = ACTIONS(7488),
    [anon_sym_DASH] = ACTIONS(7490),
    [anon_sym_LT_DASH] = ACTIONS(7488),
    [anon_sym_LT_LT_DASH] = ACTIONS(7488),
    [anon_sym_COLON_EQ] = ACTIONS(7488),
    [anon_sym_DASH_GT] = ACTIONS(7490),
    [anon_sym_DASH_GT_GT] = ACTIONS(7488),
    [anon_sym_PIPE] = ACTIONS(7490),
    [anon_sym_AMP] = ACTIONS(7490),
    [anon_sym_PIPE_PIPE] = ACTIONS(7488),
    [anon_sym_AMP_AMP] = ACTIONS(7488),
    [anon_sym_LT] = ACTIONS(7490),
    [anon_sym_LT_EQ] = ACTIONS(7488),
    [anon_sym_GT] = ACTIONS(7490),
    [anon_sym_GT_EQ] = ACTIONS(7488),
    [anon_sym_EQ_EQ] = ACTIONS(7488),
    [anon_sym_BANG_EQ] = ACTIONS(7488),
    [anon_sym_STAR] = ACTIONS(7490),
    [anon_sym_SLASH] = ACTIONS(7488),
    [anon_sym_STAR_STAR] = ACTIONS(7488),
    [anon_sym_CARET] = ACTIONS(7488),
    [aux_sym_binary_operator_token1] = ACTIONS(7488),
    [anon_sym_PIPE_GT] = ACTIONS(7488),
    [anon_sym_COLON] = ACTIONS(7490),
    [anon_sym_DOLLAR] = ACTIONS(7488),
    [anon_sym_AT] = ACTIONS(7488),
    [aux_sym__hex_literal_token1] = ACTIONS(7488),
    [sym__number_literal] = ACTIONS(7490),
    [anon_sym_SQUOTE] = ACTIONS(7488),
    [anon_sym_DQUOTE] = ACTIONS(7488),
    [sym_return] = ACTIONS(7490),
    [sym_next] = ACTIONS(7490),
    [sym_break] = ACTIONS(7490),
    [sym_true] = ACTIONS(7490),
    [sym_false] = ACTIONS(7490),
    [sym_null] = ACTIONS(7490),
    [sym_inf] = ACTIONS(7490),
    [sym_nan] = ACTIONS(7490),
    [anon_sym_NA] = ACTIONS(7490),
    [anon_sym_NA_integer_] = ACTIONS(7490),
    [anon_sym_NA_real_] = ACTIONS(7490),
    [anon_sym_NA_complex_] = ACTIONS(7490),
    [anon_sym_NA_character_] = ACTIONS(7490),
    [sym_dots] = ACTIONS(7490),
    [sym_dot_dot_i] = ACTIONS(7488),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7488),
    [sym__newline] = ACTIONS(7488),
    [sym__raw_string_literal] = ACTIONS(7488),
    [sym__external_open_parenthesis] = ACTIONS(7488),
    [sym__external_open_brace] = ACTIONS(7488),
    [sym__external_open_bracket] = ACTIONS(7488),
    [sym__external_open_bracket2] = ACTIONS(7488),
    [sym__external_close_bracket2] = ACTIONS(7488),
  },
  [2966] = {
    [sym_identifier] = ACTIONS(7494),
    [anon_sym_BSLASH] = ACTIONS(7492),
    [anon_sym_function] = ACTIONS(7494),
    [anon_sym_EQ] = ACTIONS(7494),
    [anon_sym_if] = ACTIONS(7494),
    [anon_sym_for] = ACTIONS(7494),
    [anon_sym_while] = ACTIONS(7494),
    [anon_sym_repeat] = ACTIONS(7494),
    [anon_sym_QMARK] = ACTIONS(7492),
    [anon_sym_TILDE] = ACTIONS(7492),
    [anon_sym_BANG] = ACTIONS(7494),
    [anon_sym_PLUS] = ACTIONS(7492),
    [anon_sym_DASH] = ACTIONS(7494),
    [anon_sym_LT_DASH] = ACTIONS(7492),
    [anon_sym_LT_LT_DASH] = ACTIONS(7492),
    [anon_sym_COLON_EQ] = ACTIONS(7492),
    [anon_sym_DASH_GT] = ACTIONS(7494),
    [anon_sym_DASH_GT_GT] = ACTIONS(7492),
    [anon_sym_PIPE] = ACTIONS(7494),
    [anon_sym_AMP] = ACTIONS(7494),
    [anon_sym_PIPE_PIPE] = ACTIONS(7492),
    [anon_sym_AMP_AMP] = ACTIONS(7492),
    [anon_sym_LT] = ACTIONS(7494),
    [anon_sym_LT_EQ] = ACTIONS(7492),
    [anon_sym_GT] = ACTIONS(7494),
    [anon_sym_GT_EQ] = ACTIONS(7492),
    [anon_sym_EQ_EQ] = ACTIONS(7492),
    [anon_sym_BANG_EQ] = ACTIONS(7492),
    [anon_sym_STAR] = ACTIONS(7494),
    [anon_sym_SLASH] = ACTIONS(7492),
    [anon_sym_STAR_STAR] = ACTIONS(7492),
    [anon_sym_CARET] = ACTIONS(7492),
    [aux_sym_binary_operator_token1] = ACTIONS(7492),
    [anon_sym_PIPE_GT] = ACTIONS(7492),
    [anon_sym_COLON] = ACTIONS(7494),
    [anon_sym_DOLLAR] = ACTIONS(7492),
    [anon_sym_AT] = ACTIONS(7492),
    [aux_sym__hex_literal_token1] = ACTIONS(7492),
    [sym__number_literal] = ACTIONS(7494),
    [anon_sym_SQUOTE] = ACTIONS(7492),
    [anon_sym_DQUOTE] = ACTIONS(7492),
    [sym_return] = ACTIONS(7494),
    [sym_next] = ACTIONS(7494),
    [sym_break] = ACTIONS(7494),
    [sym_true] = ACTIONS(7494),
    [sym_false] = ACTIONS(7494),
    [sym_null] = ACTIONS(7494),
    [sym_inf] = ACTIONS(7494),
    [sym_nan] = ACTIONS(7494),
    [anon_sym_NA] = ACTIONS(7494),
    [anon_sym_NA_integer_] = ACTIONS(7494),
    [anon_sym_NA_real_] = ACTIONS(7494),
    [anon_sym_NA_complex_] = ACTIONS(7494),
    [anon_sym_NA_character_] = ACTIONS(7494),
    [sym_dots] = ACTIONS(7494),
    [sym_dot_dot_i] = ACTIONS(7492),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7492),
    [sym__newline] = ACTIONS(7492),
    [sym__raw_string_literal] = ACTIONS(7492),
    [sym__external_open_parenthesis] = ACTIONS(7492),
    [sym__external_open_brace] = ACTIONS(7492),
    [sym__external_open_bracket] = ACTIONS(7492),
    [sym__external_open_bracket2] = ACTIONS(7492),
    [sym__external_close_bracket2] = ACTIONS(7492),
  },
  [2967] = {
    [sym_identifier] = ACTIONS(7498),
    [anon_sym_BSLASH] = ACTIONS(7496),
    [anon_sym_function] = ACTIONS(7498),
    [anon_sym_EQ] = ACTIONS(7498),
    [anon_sym_if] = ACTIONS(7498),
    [anon_sym_for] = ACTIONS(7498),
    [anon_sym_while] = ACTIONS(7498),
    [anon_sym_repeat] = ACTIONS(7498),
    [anon_sym_QMARK] = ACTIONS(7496),
    [anon_sym_TILDE] = ACTIONS(7496),
    [anon_sym_BANG] = ACTIONS(7498),
    [anon_sym_PLUS] = ACTIONS(7496),
    [anon_sym_DASH] = ACTIONS(7498),
    [anon_sym_LT_DASH] = ACTIONS(7496),
    [anon_sym_LT_LT_DASH] = ACTIONS(7496),
    [anon_sym_COLON_EQ] = ACTIONS(7496),
    [anon_sym_DASH_GT] = ACTIONS(7498),
    [anon_sym_DASH_GT_GT] = ACTIONS(7496),
    [anon_sym_PIPE] = ACTIONS(7498),
    [anon_sym_AMP] = ACTIONS(7498),
    [anon_sym_PIPE_PIPE] = ACTIONS(7496),
    [anon_sym_AMP_AMP] = ACTIONS(7496),
    [anon_sym_LT] = ACTIONS(7498),
    [anon_sym_LT_EQ] = ACTIONS(7496),
    [anon_sym_GT] = ACTIONS(7498),
    [anon_sym_GT_EQ] = ACTIONS(7496),
    [anon_sym_EQ_EQ] = ACTIONS(7496),
    [anon_sym_BANG_EQ] = ACTIONS(7496),
    [anon_sym_STAR] = ACTIONS(7498),
    [anon_sym_SLASH] = ACTIONS(7496),
    [anon_sym_STAR_STAR] = ACTIONS(7496),
    [anon_sym_CARET] = ACTIONS(7496),
    [aux_sym_binary_operator_token1] = ACTIONS(7496),
    [anon_sym_PIPE_GT] = ACTIONS(7496),
    [anon_sym_COLON] = ACTIONS(7498),
    [anon_sym_DOLLAR] = ACTIONS(7496),
    [anon_sym_AT] = ACTIONS(7496),
    [aux_sym__hex_literal_token1] = ACTIONS(7496),
    [sym__number_literal] = ACTIONS(7498),
    [anon_sym_SQUOTE] = ACTIONS(7496),
    [anon_sym_DQUOTE] = ACTIONS(7496),
    [sym_return] = ACTIONS(7498),
    [sym_next] = ACTIONS(7498),
    [sym_break] = ACTIONS(7498),
    [sym_true] = ACTIONS(7498),
    [sym_false] = ACTIONS(7498),
    [sym_null] = ACTIONS(7498),
    [sym_inf] = ACTIONS(7498),
    [sym_nan] = ACTIONS(7498),
    [anon_sym_NA] = ACTIONS(7498),
    [anon_sym_NA_integer_] = ACTIONS(7498),
    [anon_sym_NA_real_] = ACTIONS(7498),
    [anon_sym_NA_complex_] = ACTIONS(7498),
    [anon_sym_NA_character_] = ACTIONS(7498),
    [sym_dots] = ACTIONS(7498),
    [sym_dot_dot_i] = ACTIONS(7496),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7496),
    [sym__newline] = ACTIONS(7496),
    [sym__raw_string_literal] = ACTIONS(7496),
    [sym__external_open_parenthesis] = ACTIONS(7496),
    [sym__external_open_brace] = ACTIONS(7496),
    [sym__external_open_bracket] = ACTIONS(7496),
    [sym__external_open_bracket2] = ACTIONS(7496),
    [sym__external_close_bracket2] = ACTIONS(7496),
  },
  [2968] = {
    [sym_identifier] = ACTIONS(7502),
    [anon_sym_BSLASH] = ACTIONS(7500),
    [anon_sym_function] = ACTIONS(7502),
    [anon_sym_EQ] = ACTIONS(7502),
    [anon_sym_if] = ACTIONS(7502),
    [anon_sym_for] = ACTIONS(7502),
    [anon_sym_while] = ACTIONS(7502),
    [anon_sym_repeat] = ACTIONS(7502),
    [anon_sym_QMARK] = ACTIONS(7500),
    [anon_sym_TILDE] = ACTIONS(7500),
    [anon_sym_BANG] = ACTIONS(7502),
    [anon_sym_PLUS] = ACTIONS(7500),
    [anon_sym_DASH] = ACTIONS(7502),
    [anon_sym_LT_DASH] = ACTIONS(7500),
    [anon_sym_LT_LT_DASH] = ACTIONS(7500),
    [anon_sym_COLON_EQ] = ACTIONS(7500),
    [anon_sym_DASH_GT] = ACTIONS(7502),
    [anon_sym_DASH_GT_GT] = ACTIONS(7500),
    [anon_sym_PIPE] = ACTIONS(7502),
    [anon_sym_AMP] = ACTIONS(7502),
    [anon_sym_PIPE_PIPE] = ACTIONS(7500),
    [anon_sym_AMP_AMP] = ACTIONS(7500),
    [anon_sym_LT] = ACTIONS(7502),
    [anon_sym_LT_EQ] = ACTIONS(7500),
    [anon_sym_GT] = ACTIONS(7502),
    [anon_sym_GT_EQ] = ACTIONS(7500),
    [anon_sym_EQ_EQ] = ACTIONS(7500),
    [anon_sym_BANG_EQ] = ACTIONS(7500),
    [anon_sym_STAR] = ACTIONS(7502),
    [anon_sym_SLASH] = ACTIONS(7500),
    [anon_sym_STAR_STAR] = ACTIONS(7500),
    [anon_sym_CARET] = ACTIONS(7500),
    [aux_sym_binary_operator_token1] = ACTIONS(7500),
    [anon_sym_PIPE_GT] = ACTIONS(7500),
    [anon_sym_COLON] = ACTIONS(7502),
    [anon_sym_DOLLAR] = ACTIONS(7500),
    [anon_sym_AT] = ACTIONS(7500),
    [aux_sym__hex_literal_token1] = ACTIONS(7500),
    [sym__number_literal] = ACTIONS(7502),
    [anon_sym_SQUOTE] = ACTIONS(7500),
    [anon_sym_DQUOTE] = ACTIONS(7500),
    [sym_return] = ACTIONS(7502),
    [sym_next] = ACTIONS(7502),
    [sym_break] = ACTIONS(7502),
    [sym_true] = ACTIONS(7502),
    [sym_false] = ACTIONS(7502),
    [sym_null] = ACTIONS(7502),
    [sym_inf] = ACTIONS(7502),
    [sym_nan] = ACTIONS(7502),
    [anon_sym_NA] = ACTIONS(7502),
    [anon_sym_NA_integer_] = ACTIONS(7502),
    [anon_sym_NA_real_] = ACTIONS(7502),
    [anon_sym_NA_complex_] = ACTIONS(7502),
    [anon_sym_NA_character_] = ACTIONS(7502),
    [sym_dots] = ACTIONS(7502),
    [sym_dot_dot_i] = ACTIONS(7500),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7500),
    [sym__newline] = ACTIONS(7500),
    [sym__raw_string_literal] = ACTIONS(7500),
    [sym__external_open_parenthesis] = ACTIONS(7500),
    [sym__external_open_brace] = ACTIONS(7500),
    [sym__external_open_bracket] = ACTIONS(7500),
    [sym__external_open_bracket2] = ACTIONS(7500),
    [sym__external_close_bracket2] = ACTIONS(7500),
  },
  [2969] = {
    [sym_identifier] = ACTIONS(7506),
    [anon_sym_BSLASH] = ACTIONS(7504),
    [anon_sym_function] = ACTIONS(7506),
    [anon_sym_EQ] = ACTIONS(7506),
    [anon_sym_if] = ACTIONS(7506),
    [anon_sym_for] = ACTIONS(7506),
    [anon_sym_while] = ACTIONS(7506),
    [anon_sym_repeat] = ACTIONS(7506),
    [anon_sym_QMARK] = ACTIONS(7504),
    [anon_sym_TILDE] = ACTIONS(7504),
    [anon_sym_BANG] = ACTIONS(7506),
    [anon_sym_PLUS] = ACTIONS(7504),
    [anon_sym_DASH] = ACTIONS(7506),
    [anon_sym_LT_DASH] = ACTIONS(7504),
    [anon_sym_LT_LT_DASH] = ACTIONS(7504),
    [anon_sym_COLON_EQ] = ACTIONS(7504),
    [anon_sym_DASH_GT] = ACTIONS(7506),
    [anon_sym_DASH_GT_GT] = ACTIONS(7504),
    [anon_sym_PIPE] = ACTIONS(7506),
    [anon_sym_AMP] = ACTIONS(7506),
    [anon_sym_PIPE_PIPE] = ACTIONS(7504),
    [anon_sym_AMP_AMP] = ACTIONS(7504),
    [anon_sym_LT] = ACTIONS(7506),
    [anon_sym_LT_EQ] = ACTIONS(7504),
    [anon_sym_GT] = ACTIONS(7506),
    [anon_sym_GT_EQ] = ACTIONS(7504),
    [anon_sym_EQ_EQ] = ACTIONS(7504),
    [anon_sym_BANG_EQ] = ACTIONS(7504),
    [anon_sym_STAR] = ACTIONS(7506),
    [anon_sym_SLASH] = ACTIONS(7504),
    [anon_sym_STAR_STAR] = ACTIONS(7504),
    [anon_sym_CARET] = ACTIONS(7504),
    [aux_sym_binary_operator_token1] = ACTIONS(7504),
    [anon_sym_PIPE_GT] = ACTIONS(7504),
    [anon_sym_COLON] = ACTIONS(7506),
    [anon_sym_DOLLAR] = ACTIONS(7504),
    [anon_sym_AT] = ACTIONS(7504),
    [aux_sym__hex_literal_token1] = ACTIONS(7504),
    [sym__number_literal] = ACTIONS(7506),
    [anon_sym_SQUOTE] = ACTIONS(7504),
    [anon_sym_DQUOTE] = ACTIONS(7504),
    [sym_return] = ACTIONS(7506),
    [sym_next] = ACTIONS(7506),
    [sym_break] = ACTIONS(7506),
    [sym_true] = ACTIONS(7506),
    [sym_false] = ACTIONS(7506),
    [sym_null] = ACTIONS(7506),
    [sym_inf] = ACTIONS(7506),
    [sym_nan] = ACTIONS(7506),
    [anon_sym_NA] = ACTIONS(7506),
    [anon_sym_NA_integer_] = ACTIONS(7506),
    [anon_sym_NA_real_] = ACTIONS(7506),
    [anon_sym_NA_complex_] = ACTIONS(7506),
    [anon_sym_NA_character_] = ACTIONS(7506),
    [sym_dots] = ACTIONS(7506),
    [sym_dot_dot_i] = ACTIONS(7504),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7504),
    [sym__newline] = ACTIONS(7504),
    [sym__raw_string_literal] = ACTIONS(7504),
    [sym__external_open_parenthesis] = ACTIONS(7504),
    [sym__external_open_brace] = ACTIONS(7504),
    [sym__external_open_bracket] = ACTIONS(7504),
    [sym__external_open_bracket2] = ACTIONS(7504),
    [sym__external_close_bracket2] = ACTIONS(7504),
  },
  [2970] = {
    [sym_identifier] = ACTIONS(7512),
    [anon_sym_BSLASH] = ACTIONS(7510),
    [anon_sym_function] = ACTIONS(7512),
    [anon_sym_EQ] = ACTIONS(7512),
    [anon_sym_if] = ACTIONS(7512),
    [anon_sym_for] = ACTIONS(7512),
    [anon_sym_while] = ACTIONS(7512),
    [anon_sym_repeat] = ACTIONS(7512),
    [anon_sym_QMARK] = ACTIONS(7510),
    [anon_sym_TILDE] = ACTIONS(7510),
    [anon_sym_BANG] = ACTIONS(7512),
    [anon_sym_PLUS] = ACTIONS(7510),
    [anon_sym_DASH] = ACTIONS(7512),
    [anon_sym_LT_DASH] = ACTIONS(7510),
    [anon_sym_LT_LT_DASH] = ACTIONS(7510),
    [anon_sym_COLON_EQ] = ACTIONS(7510),
    [anon_sym_DASH_GT] = ACTIONS(7512),
    [anon_sym_DASH_GT_GT] = ACTIONS(7510),
    [anon_sym_PIPE] = ACTIONS(7512),
    [anon_sym_AMP] = ACTIONS(7512),
    [anon_sym_PIPE_PIPE] = ACTIONS(7510),
    [anon_sym_AMP_AMP] = ACTIONS(7510),
    [anon_sym_LT] = ACTIONS(7512),
    [anon_sym_LT_EQ] = ACTIONS(7510),
    [anon_sym_GT] = ACTIONS(7512),
    [anon_sym_GT_EQ] = ACTIONS(7510),
    [anon_sym_EQ_EQ] = ACTIONS(7510),
    [anon_sym_BANG_EQ] = ACTIONS(7510),
    [anon_sym_STAR] = ACTIONS(7512),
    [anon_sym_SLASH] = ACTIONS(7510),
    [anon_sym_STAR_STAR] = ACTIONS(7510),
    [anon_sym_CARET] = ACTIONS(7510),
    [aux_sym_binary_operator_token1] = ACTIONS(7510),
    [anon_sym_PIPE_GT] = ACTIONS(7510),
    [anon_sym_COLON] = ACTIONS(7512),
    [anon_sym_DOLLAR] = ACTIONS(7510),
    [anon_sym_AT] = ACTIONS(7510),
    [aux_sym__hex_literal_token1] = ACTIONS(7510),
    [sym__number_literal] = ACTIONS(7512),
    [anon_sym_SQUOTE] = ACTIONS(7510),
    [anon_sym_DQUOTE] = ACTIONS(7510),
    [sym_return] = ACTIONS(7512),
    [sym_next] = ACTIONS(7512),
    [sym_break] = ACTIONS(7512),
    [sym_true] = ACTIONS(7512),
    [sym_false] = ACTIONS(7512),
    [sym_null] = ACTIONS(7512),
    [sym_inf] = ACTIONS(7512),
    [sym_nan] = ACTIONS(7512),
    [anon_sym_NA] = ACTIONS(7512),
    [anon_sym_NA_integer_] = ACTIONS(7512),
    [anon_sym_NA_real_] = ACTIONS(7512),
    [anon_sym_NA_complex_] = ACTIONS(7512),
    [anon_sym_NA_character_] = ACTIONS(7512),
    [sym_dots] = ACTIONS(7512),
    [sym_dot_dot_i] = ACTIONS(7510),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7510),
    [sym__newline] = ACTIONS(7510),
    [sym__raw_string_literal] = ACTIONS(7510),
    [sym__external_open_parenthesis] = ACTIONS(7510),
    [sym__external_open_brace] = ACTIONS(7510),
    [sym__external_open_bracket] = ACTIONS(7510),
    [sym__external_open_bracket2] = ACTIONS(7510),
    [sym__external_close_bracket2] = ACTIONS(7510),
  },
  [2971] = {
    [ts_builtin_sym_end] = ACTIONS(7542),
    [sym_identifier] = ACTIONS(7544),
    [anon_sym_BSLASH] = ACTIONS(7542),
    [anon_sym_function] = ACTIONS(7544),
    [anon_sym_EQ] = ACTIONS(7544),
    [anon_sym_if] = ACTIONS(7544),
    [anon_sym_for] = ACTIONS(7544),
    [anon_sym_while] = ACTIONS(7544),
    [anon_sym_repeat] = ACTIONS(7544),
    [anon_sym_QMARK] = ACTIONS(7542),
    [anon_sym_TILDE] = ACTIONS(7542),
    [anon_sym_BANG] = ACTIONS(7544),
    [anon_sym_PLUS] = ACTIONS(7542),
    [anon_sym_DASH] = ACTIONS(7544),
    [anon_sym_LT_DASH] = ACTIONS(7542),
    [anon_sym_LT_LT_DASH] = ACTIONS(7542),
    [anon_sym_COLON_EQ] = ACTIONS(7542),
    [anon_sym_DASH_GT] = ACTIONS(7544),
    [anon_sym_DASH_GT_GT] = ACTIONS(7542),
    [anon_sym_PIPE] = ACTIONS(7544),
    [anon_sym_AMP] = ACTIONS(7544),
    [anon_sym_PIPE_PIPE] = ACTIONS(7542),
    [anon_sym_AMP_AMP] = ACTIONS(7542),
    [anon_sym_LT] = ACTIONS(7544),
    [anon_sym_LT_EQ] = ACTIONS(7542),
    [anon_sym_GT] = ACTIONS(7544),
    [anon_sym_GT_EQ] = ACTIONS(7542),
    [anon_sym_EQ_EQ] = ACTIONS(7542),
    [anon_sym_BANG_EQ] = ACTIONS(7542),
    [anon_sym_STAR] = ACTIONS(7544),
    [anon_sym_SLASH] = ACTIONS(7542),
    [anon_sym_STAR_STAR] = ACTIONS(7542),
    [anon_sym_CARET] = ACTIONS(7542),
    [aux_sym_binary_operator_token1] = ACTIONS(7542),
    [anon_sym_PIPE_GT] = ACTIONS(7542),
    [anon_sym_COLON] = ACTIONS(7544),
    [anon_sym_DOLLAR] = ACTIONS(7542),
    [anon_sym_AT] = ACTIONS(7542),
    [aux_sym__hex_literal_token1] = ACTIONS(7542),
    [sym__number_literal] = ACTIONS(7544),
    [anon_sym_SQUOTE] = ACTIONS(7542),
    [anon_sym_DQUOTE] = ACTIONS(7542),
    [sym_return] = ACTIONS(7544),
    [sym_next] = ACTIONS(7544),
    [sym_break] = ACTIONS(7544),
    [sym_true] = ACTIONS(7544),
    [sym_false] = ACTIONS(7544),
    [sym_null] = ACTIONS(7544),
    [sym_inf] = ACTIONS(7544),
    [sym_nan] = ACTIONS(7544),
    [anon_sym_NA] = ACTIONS(7544),
    [anon_sym_NA_integer_] = ACTIONS(7544),
    [anon_sym_NA_real_] = ACTIONS(7544),
    [anon_sym_NA_complex_] = ACTIONS(7544),
    [anon_sym_NA_character_] = ACTIONS(7544),
    [sym_dots] = ACTIONS(7544),
    [sym_dot_dot_i] = ACTIONS(7542),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7542),
    [sym__semicolon] = ACTIONS(7542),
    [sym__raw_string_literal] = ACTIONS(7542),
    [sym__external_open_parenthesis] = ACTIONS(7542),
    [sym__external_open_brace] = ACTIONS(7542),
    [sym__external_open_bracket] = ACTIONS(7542),
    [sym__external_open_bracket2] = ACTIONS(7542),
  },
  [2972] = {
    [ts_builtin_sym_end] = ACTIONS(7538),
    [sym_identifier] = ACTIONS(7540),
    [anon_sym_BSLASH] = ACTIONS(7538),
    [anon_sym_function] = ACTIONS(7540),
    [anon_sym_EQ] = ACTIONS(7540),
    [anon_sym_if] = ACTIONS(7540),
    [anon_sym_for] = ACTIONS(7540),
    [anon_sym_while] = ACTIONS(7540),
    [anon_sym_repeat] = ACTIONS(7540),
    [anon_sym_QMARK] = ACTIONS(7538),
    [anon_sym_TILDE] = ACTIONS(7538),
    [anon_sym_BANG] = ACTIONS(7540),
    [anon_sym_PLUS] = ACTIONS(7538),
    [anon_sym_DASH] = ACTIONS(7540),
    [anon_sym_LT_DASH] = ACTIONS(7538),
    [anon_sym_LT_LT_DASH] = ACTIONS(7538),
    [anon_sym_COLON_EQ] = ACTIONS(7538),
    [anon_sym_DASH_GT] = ACTIONS(7540),
    [anon_sym_DASH_GT_GT] = ACTIONS(7538),
    [anon_sym_PIPE] = ACTIONS(7540),
    [anon_sym_AMP] = ACTIONS(7540),
    [anon_sym_PIPE_PIPE] = ACTIONS(7538),
    [anon_sym_AMP_AMP] = ACTIONS(7538),
    [anon_sym_LT] = ACTIONS(7540),
    [anon_sym_LT_EQ] = ACTIONS(7538),
    [anon_sym_GT] = ACTIONS(7540),
    [anon_sym_GT_EQ] = ACTIONS(7538),
    [anon_sym_EQ_EQ] = ACTIONS(7538),
    [anon_sym_BANG_EQ] = ACTIONS(7538),
    [anon_sym_STAR] = ACTIONS(7540),
    [anon_sym_SLASH] = ACTIONS(7538),
    [anon_sym_STAR_STAR] = ACTIONS(7538),
    [anon_sym_CARET] = ACTIONS(7538),
    [aux_sym_binary_operator_token1] = ACTIONS(7538),
    [anon_sym_PIPE_GT] = ACTIONS(7538),
    [anon_sym_COLON] = ACTIONS(7540),
    [anon_sym_DOLLAR] = ACTIONS(7538),
    [anon_sym_AT] = ACTIONS(7538),
    [aux_sym__hex_literal_token1] = ACTIONS(7538),
    [sym__number_literal] = ACTIONS(7540),
    [anon_sym_SQUOTE] = ACTIONS(7538),
    [anon_sym_DQUOTE] = ACTIONS(7538),
    [sym_return] = ACTIONS(7540),
    [sym_next] = ACTIONS(7540),
    [sym_break] = ACTIONS(7540),
    [sym_true] = ACTIONS(7540),
    [sym_false] = ACTIONS(7540),
    [sym_null] = ACTIONS(7540),
    [sym_inf] = ACTIONS(7540),
    [sym_nan] = ACTIONS(7540),
    [anon_sym_NA] = ACTIONS(7540),
    [anon_sym_NA_integer_] = ACTIONS(7540),
    [anon_sym_NA_real_] = ACTIONS(7540),
    [anon_sym_NA_complex_] = ACTIONS(7540),
    [anon_sym_NA_character_] = ACTIONS(7540),
    [sym_dots] = ACTIONS(7540),
    [sym_dot_dot_i] = ACTIONS(7538),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7538),
    [sym__semicolon] = ACTIONS(7538),
    [sym__raw_string_literal] = ACTIONS(7538),
    [sym__external_open_parenthesis] = ACTIONS(7538),
    [sym__external_open_brace] = ACTIONS(7538),
    [sym__external_open_bracket] = ACTIONS(7538),
    [sym__external_open_bracket2] = ACTIONS(7538),
  },
  [2973] = {
    [sym_identifier] = ACTIONS(7556),
    [anon_sym_BSLASH] = ACTIONS(7554),
    [anon_sym_function] = ACTIONS(7556),
    [anon_sym_EQ] = ACTIONS(7556),
    [anon_sym_if] = ACTIONS(7556),
    [anon_sym_for] = ACTIONS(7556),
    [anon_sym_while] = ACTIONS(7556),
    [anon_sym_repeat] = ACTIONS(7556),
    [anon_sym_QMARK] = ACTIONS(7554),
    [anon_sym_TILDE] = ACTIONS(7554),
    [anon_sym_BANG] = ACTIONS(7556),
    [anon_sym_PLUS] = ACTIONS(7554),
    [anon_sym_DASH] = ACTIONS(7556),
    [anon_sym_LT_DASH] = ACTIONS(7554),
    [anon_sym_LT_LT_DASH] = ACTIONS(7554),
    [anon_sym_COLON_EQ] = ACTIONS(7554),
    [anon_sym_DASH_GT] = ACTIONS(7556),
    [anon_sym_DASH_GT_GT] = ACTIONS(7554),
    [anon_sym_PIPE] = ACTIONS(7556),
    [anon_sym_AMP] = ACTIONS(7556),
    [anon_sym_PIPE_PIPE] = ACTIONS(7554),
    [anon_sym_AMP_AMP] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(7556),
    [anon_sym_LT_EQ] = ACTIONS(7554),
    [anon_sym_GT] = ACTIONS(7556),
    [anon_sym_GT_EQ] = ACTIONS(7554),
    [anon_sym_EQ_EQ] = ACTIONS(7554),
    [anon_sym_BANG_EQ] = ACTIONS(7554),
    [anon_sym_STAR] = ACTIONS(7556),
    [anon_sym_SLASH] = ACTIONS(7554),
    [anon_sym_STAR_STAR] = ACTIONS(7554),
    [anon_sym_CARET] = ACTIONS(7554),
    [aux_sym_binary_operator_token1] = ACTIONS(7554),
    [anon_sym_PIPE_GT] = ACTIONS(7554),
    [anon_sym_COLON] = ACTIONS(7556),
    [anon_sym_DOLLAR] = ACTIONS(7554),
    [anon_sym_AT] = ACTIONS(7554),
    [aux_sym__hex_literal_token1] = ACTIONS(7554),
    [sym__number_literal] = ACTIONS(7556),
    [anon_sym_SQUOTE] = ACTIONS(7554),
    [anon_sym_DQUOTE] = ACTIONS(7554),
    [sym_return] = ACTIONS(7556),
    [sym_next] = ACTIONS(7556),
    [sym_break] = ACTIONS(7556),
    [sym_true] = ACTIONS(7556),
    [sym_false] = ACTIONS(7556),
    [sym_null] = ACTIONS(7556),
    [sym_inf] = ACTIONS(7556),
    [sym_nan] = ACTIONS(7556),
    [anon_sym_NA] = ACTIONS(7556),
    [anon_sym_NA_integer_] = ACTIONS(7556),
    [anon_sym_NA_real_] = ACTIONS(7556),
    [anon_sym_NA_complex_] = ACTIONS(7556),
    [anon_sym_NA_character_] = ACTIONS(7556),
    [sym_dots] = ACTIONS(7556),
    [sym_dot_dot_i] = ACTIONS(7554),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7554),
    [sym__newline] = ACTIONS(7554),
    [sym__raw_string_literal] = ACTIONS(7554),
    [sym__external_open_parenthesis] = ACTIONS(7554),
    [sym__external_close_parenthesis] = ACTIONS(7554),
    [sym__external_open_brace] = ACTIONS(7554),
    [sym__external_open_bracket] = ACTIONS(7554),
    [sym__external_open_bracket2] = ACTIONS(7554),
  },
  [2974] = {
    [sym_identifier] = ACTIONS(7516),
    [anon_sym_BSLASH] = ACTIONS(7514),
    [anon_sym_function] = ACTIONS(7516),
    [anon_sym_EQ] = ACTIONS(7516),
    [anon_sym_if] = ACTIONS(7516),
    [anon_sym_for] = ACTIONS(7516),
    [anon_sym_while] = ACTIONS(7516),
    [anon_sym_repeat] = ACTIONS(7516),
    [anon_sym_QMARK] = ACTIONS(7514),
    [anon_sym_TILDE] = ACTIONS(7514),
    [anon_sym_BANG] = ACTIONS(7516),
    [anon_sym_PLUS] = ACTIONS(7514),
    [anon_sym_DASH] = ACTIONS(7516),
    [anon_sym_LT_DASH] = ACTIONS(7514),
    [anon_sym_LT_LT_DASH] = ACTIONS(7514),
    [anon_sym_COLON_EQ] = ACTIONS(7514),
    [anon_sym_DASH_GT] = ACTIONS(7516),
    [anon_sym_DASH_GT_GT] = ACTIONS(7514),
    [anon_sym_PIPE] = ACTIONS(7516),
    [anon_sym_AMP] = ACTIONS(7516),
    [anon_sym_PIPE_PIPE] = ACTIONS(7514),
    [anon_sym_AMP_AMP] = ACTIONS(7514),
    [anon_sym_LT] = ACTIONS(7516),
    [anon_sym_LT_EQ] = ACTIONS(7514),
    [anon_sym_GT] = ACTIONS(7516),
    [anon_sym_GT_EQ] = ACTIONS(7514),
    [anon_sym_EQ_EQ] = ACTIONS(7514),
    [anon_sym_BANG_EQ] = ACTIONS(7514),
    [anon_sym_STAR] = ACTIONS(7516),
    [anon_sym_SLASH] = ACTIONS(7514),
    [anon_sym_STAR_STAR] = ACTIONS(7514),
    [anon_sym_CARET] = ACTIONS(7514),
    [aux_sym_binary_operator_token1] = ACTIONS(7514),
    [anon_sym_PIPE_GT] = ACTIONS(7514),
    [anon_sym_COLON] = ACTIONS(7516),
    [anon_sym_DOLLAR] = ACTIONS(7514),
    [anon_sym_AT] = ACTIONS(7514),
    [aux_sym__hex_literal_token1] = ACTIONS(7514),
    [sym__number_literal] = ACTIONS(7516),
    [anon_sym_SQUOTE] = ACTIONS(7514),
    [anon_sym_DQUOTE] = ACTIONS(7514),
    [sym_return] = ACTIONS(7516),
    [sym_next] = ACTIONS(7516),
    [sym_break] = ACTIONS(7516),
    [sym_true] = ACTIONS(7516),
    [sym_false] = ACTIONS(7516),
    [sym_null] = ACTIONS(7516),
    [sym_inf] = ACTIONS(7516),
    [sym_nan] = ACTIONS(7516),
    [anon_sym_NA] = ACTIONS(7516),
    [anon_sym_NA_integer_] = ACTIONS(7516),
    [anon_sym_NA_real_] = ACTIONS(7516),
    [anon_sym_NA_complex_] = ACTIONS(7516),
    [anon_sym_NA_character_] = ACTIONS(7516),
    [sym_dots] = ACTIONS(7516),
    [sym_dot_dot_i] = ACTIONS(7514),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7514),
    [sym__newline] = ACTIONS(7514),
    [sym__raw_string_literal] = ACTIONS(7514),
    [sym__external_open_parenthesis] = ACTIONS(7514),
    [sym__external_open_brace] = ACTIONS(7514),
    [sym__external_open_bracket] = ACTIONS(7514),
    [sym__external_open_bracket2] = ACTIONS(7514),
    [sym__external_close_bracket2] = ACTIONS(7514),
  },
  [2975] = {
    [sym_identifier] = ACTIONS(7520),
    [anon_sym_BSLASH] = ACTIONS(7518),
    [anon_sym_function] = ACTIONS(7520),
    [anon_sym_EQ] = ACTIONS(7520),
    [anon_sym_if] = ACTIONS(7520),
    [anon_sym_for] = ACTIONS(7520),
    [anon_sym_while] = ACTIONS(7520),
    [anon_sym_repeat] = ACTIONS(7520),
    [anon_sym_QMARK] = ACTIONS(7518),
    [anon_sym_TILDE] = ACTIONS(7518),
    [anon_sym_BANG] = ACTIONS(7520),
    [anon_sym_PLUS] = ACTIONS(7518),
    [anon_sym_DASH] = ACTIONS(7520),
    [anon_sym_LT_DASH] = ACTIONS(7518),
    [anon_sym_LT_LT_DASH] = ACTIONS(7518),
    [anon_sym_COLON_EQ] = ACTIONS(7518),
    [anon_sym_DASH_GT] = ACTIONS(7520),
    [anon_sym_DASH_GT_GT] = ACTIONS(7518),
    [anon_sym_PIPE] = ACTIONS(7520),
    [anon_sym_AMP] = ACTIONS(7520),
    [anon_sym_PIPE_PIPE] = ACTIONS(7518),
    [anon_sym_AMP_AMP] = ACTIONS(7518),
    [anon_sym_LT] = ACTIONS(7520),
    [anon_sym_LT_EQ] = ACTIONS(7518),
    [anon_sym_GT] = ACTIONS(7520),
    [anon_sym_GT_EQ] = ACTIONS(7518),
    [anon_sym_EQ_EQ] = ACTIONS(7518),
    [anon_sym_BANG_EQ] = ACTIONS(7518),
    [anon_sym_STAR] = ACTIONS(7520),
    [anon_sym_SLASH] = ACTIONS(7518),
    [anon_sym_STAR_STAR] = ACTIONS(7518),
    [anon_sym_CARET] = ACTIONS(7518),
    [aux_sym_binary_operator_token1] = ACTIONS(7518),
    [anon_sym_PIPE_GT] = ACTIONS(7518),
    [anon_sym_COLON] = ACTIONS(7520),
    [anon_sym_DOLLAR] = ACTIONS(7518),
    [anon_sym_AT] = ACTIONS(7518),
    [aux_sym__hex_literal_token1] = ACTIONS(7518),
    [sym__number_literal] = ACTIONS(7520),
    [anon_sym_SQUOTE] = ACTIONS(7518),
    [anon_sym_DQUOTE] = ACTIONS(7518),
    [sym_return] = ACTIONS(7520),
    [sym_next] = ACTIONS(7520),
    [sym_break] = ACTIONS(7520),
    [sym_true] = ACTIONS(7520),
    [sym_false] = ACTIONS(7520),
    [sym_null] = ACTIONS(7520),
    [sym_inf] = ACTIONS(7520),
    [sym_nan] = ACTIONS(7520),
    [anon_sym_NA] = ACTIONS(7520),
    [anon_sym_NA_integer_] = ACTIONS(7520),
    [anon_sym_NA_real_] = ACTIONS(7520),
    [anon_sym_NA_complex_] = ACTIONS(7520),
    [anon_sym_NA_character_] = ACTIONS(7520),
    [sym_dots] = ACTIONS(7520),
    [sym_dot_dot_i] = ACTIONS(7518),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7518),
    [sym__newline] = ACTIONS(7518),
    [sym__raw_string_literal] = ACTIONS(7518),
    [sym__external_open_parenthesis] = ACTIONS(7518),
    [sym__external_open_brace] = ACTIONS(7518),
    [sym__external_open_bracket] = ACTIONS(7518),
    [sym__external_open_bracket2] = ACTIONS(7518),
    [sym__external_close_bracket2] = ACTIONS(7518),
  },
  [2976] = {
    [sym_identifier] = ACTIONS(7524),
    [anon_sym_BSLASH] = ACTIONS(7522),
    [anon_sym_function] = ACTIONS(7524),
    [anon_sym_EQ] = ACTIONS(7524),
    [anon_sym_if] = ACTIONS(7524),
    [anon_sym_for] = ACTIONS(7524),
    [anon_sym_while] = ACTIONS(7524),
    [anon_sym_repeat] = ACTIONS(7524),
    [anon_sym_QMARK] = ACTIONS(7522),
    [anon_sym_TILDE] = ACTIONS(7522),
    [anon_sym_BANG] = ACTIONS(7524),
    [anon_sym_PLUS] = ACTIONS(7522),
    [anon_sym_DASH] = ACTIONS(7524),
    [anon_sym_LT_DASH] = ACTIONS(7522),
    [anon_sym_LT_LT_DASH] = ACTIONS(7522),
    [anon_sym_COLON_EQ] = ACTIONS(7522),
    [anon_sym_DASH_GT] = ACTIONS(7524),
    [anon_sym_DASH_GT_GT] = ACTIONS(7522),
    [anon_sym_PIPE] = ACTIONS(7524),
    [anon_sym_AMP] = ACTIONS(7524),
    [anon_sym_PIPE_PIPE] = ACTIONS(7522),
    [anon_sym_AMP_AMP] = ACTIONS(7522),
    [anon_sym_LT] = ACTIONS(7524),
    [anon_sym_LT_EQ] = ACTIONS(7522),
    [anon_sym_GT] = ACTIONS(7524),
    [anon_sym_GT_EQ] = ACTIONS(7522),
    [anon_sym_EQ_EQ] = ACTIONS(7522),
    [anon_sym_BANG_EQ] = ACTIONS(7522),
    [anon_sym_STAR] = ACTIONS(7524),
    [anon_sym_SLASH] = ACTIONS(7522),
    [anon_sym_STAR_STAR] = ACTIONS(7522),
    [anon_sym_CARET] = ACTIONS(7522),
    [aux_sym_binary_operator_token1] = ACTIONS(7522),
    [anon_sym_PIPE_GT] = ACTIONS(7522),
    [anon_sym_COLON] = ACTIONS(7524),
    [anon_sym_DOLLAR] = ACTIONS(7522),
    [anon_sym_AT] = ACTIONS(7522),
    [aux_sym__hex_literal_token1] = ACTIONS(7522),
    [sym__number_literal] = ACTIONS(7524),
    [anon_sym_SQUOTE] = ACTIONS(7522),
    [anon_sym_DQUOTE] = ACTIONS(7522),
    [sym_return] = ACTIONS(7524),
    [sym_next] = ACTIONS(7524),
    [sym_break] = ACTIONS(7524),
    [sym_true] = ACTIONS(7524),
    [sym_false] = ACTIONS(7524),
    [sym_null] = ACTIONS(7524),
    [sym_inf] = ACTIONS(7524),
    [sym_nan] = ACTIONS(7524),
    [anon_sym_NA] = ACTIONS(7524),
    [anon_sym_NA_integer_] = ACTIONS(7524),
    [anon_sym_NA_real_] = ACTIONS(7524),
    [anon_sym_NA_complex_] = ACTIONS(7524),
    [anon_sym_NA_character_] = ACTIONS(7524),
    [sym_dots] = ACTIONS(7524),
    [sym_dot_dot_i] = ACTIONS(7522),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7522),
    [sym__newline] = ACTIONS(7522),
    [sym__raw_string_literal] = ACTIONS(7522),
    [sym__external_open_parenthesis] = ACTIONS(7522),
    [sym__external_open_brace] = ACTIONS(7522),
    [sym__external_open_bracket] = ACTIONS(7522),
    [sym__external_open_bracket2] = ACTIONS(7522),
    [sym__external_close_bracket2] = ACTIONS(7522),
  },
  [2977] = {
    [sym_identifier] = ACTIONS(7528),
    [anon_sym_BSLASH] = ACTIONS(7526),
    [anon_sym_function] = ACTIONS(7528),
    [anon_sym_EQ] = ACTIONS(7528),
    [anon_sym_if] = ACTIONS(7528),
    [anon_sym_for] = ACTIONS(7528),
    [anon_sym_while] = ACTIONS(7528),
    [anon_sym_repeat] = ACTIONS(7528),
    [anon_sym_QMARK] = ACTIONS(7526),
    [anon_sym_TILDE] = ACTIONS(7526),
    [anon_sym_BANG] = ACTIONS(7528),
    [anon_sym_PLUS] = ACTIONS(7526),
    [anon_sym_DASH] = ACTIONS(7528),
    [anon_sym_LT_DASH] = ACTIONS(7526),
    [anon_sym_LT_LT_DASH] = ACTIONS(7526),
    [anon_sym_COLON_EQ] = ACTIONS(7526),
    [anon_sym_DASH_GT] = ACTIONS(7528),
    [anon_sym_DASH_GT_GT] = ACTIONS(7526),
    [anon_sym_PIPE] = ACTIONS(7528),
    [anon_sym_AMP] = ACTIONS(7528),
    [anon_sym_PIPE_PIPE] = ACTIONS(7526),
    [anon_sym_AMP_AMP] = ACTIONS(7526),
    [anon_sym_LT] = ACTIONS(7528),
    [anon_sym_LT_EQ] = ACTIONS(7526),
    [anon_sym_GT] = ACTIONS(7528),
    [anon_sym_GT_EQ] = ACTIONS(7526),
    [anon_sym_EQ_EQ] = ACTIONS(7526),
    [anon_sym_BANG_EQ] = ACTIONS(7526),
    [anon_sym_STAR] = ACTIONS(7528),
    [anon_sym_SLASH] = ACTIONS(7526),
    [anon_sym_STAR_STAR] = ACTIONS(7526),
    [anon_sym_CARET] = ACTIONS(7526),
    [aux_sym_binary_operator_token1] = ACTIONS(7526),
    [anon_sym_PIPE_GT] = ACTIONS(7526),
    [anon_sym_COLON] = ACTIONS(7528),
    [anon_sym_DOLLAR] = ACTIONS(7526),
    [anon_sym_AT] = ACTIONS(7526),
    [aux_sym__hex_literal_token1] = ACTIONS(7526),
    [sym__number_literal] = ACTIONS(7528),
    [anon_sym_SQUOTE] = ACTIONS(7526),
    [anon_sym_DQUOTE] = ACTIONS(7526),
    [sym_return] = ACTIONS(7528),
    [sym_next] = ACTIONS(7528),
    [sym_break] = ACTIONS(7528),
    [sym_true] = ACTIONS(7528),
    [sym_false] = ACTIONS(7528),
    [sym_null] = ACTIONS(7528),
    [sym_inf] = ACTIONS(7528),
    [sym_nan] = ACTIONS(7528),
    [anon_sym_NA] = ACTIONS(7528),
    [anon_sym_NA_integer_] = ACTIONS(7528),
    [anon_sym_NA_real_] = ACTIONS(7528),
    [anon_sym_NA_complex_] = ACTIONS(7528),
    [anon_sym_NA_character_] = ACTIONS(7528),
    [sym_dots] = ACTIONS(7528),
    [sym_dot_dot_i] = ACTIONS(7526),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7526),
    [sym__newline] = ACTIONS(7526),
    [sym__raw_string_literal] = ACTIONS(7526),
    [sym__external_open_parenthesis] = ACTIONS(7526),
    [sym__external_open_brace] = ACTIONS(7526),
    [sym__external_open_bracket] = ACTIONS(7526),
    [sym__external_open_bracket2] = ACTIONS(7526),
    [sym__external_close_bracket2] = ACTIONS(7526),
  },
  [2978] = {
    [sym_identifier] = ACTIONS(7532),
    [anon_sym_BSLASH] = ACTIONS(7530),
    [anon_sym_function] = ACTIONS(7532),
    [anon_sym_EQ] = ACTIONS(7532),
    [anon_sym_if] = ACTIONS(7532),
    [anon_sym_for] = ACTIONS(7532),
    [anon_sym_while] = ACTIONS(7532),
    [anon_sym_repeat] = ACTIONS(7532),
    [anon_sym_QMARK] = ACTIONS(7530),
    [anon_sym_TILDE] = ACTIONS(7530),
    [anon_sym_BANG] = ACTIONS(7532),
    [anon_sym_PLUS] = ACTIONS(7530),
    [anon_sym_DASH] = ACTIONS(7532),
    [anon_sym_LT_DASH] = ACTIONS(7530),
    [anon_sym_LT_LT_DASH] = ACTIONS(7530),
    [anon_sym_COLON_EQ] = ACTIONS(7530),
    [anon_sym_DASH_GT] = ACTIONS(7532),
    [anon_sym_DASH_GT_GT] = ACTIONS(7530),
    [anon_sym_PIPE] = ACTIONS(7532),
    [anon_sym_AMP] = ACTIONS(7532),
    [anon_sym_PIPE_PIPE] = ACTIONS(7530),
    [anon_sym_AMP_AMP] = ACTIONS(7530),
    [anon_sym_LT] = ACTIONS(7532),
    [anon_sym_LT_EQ] = ACTIONS(7530),
    [anon_sym_GT] = ACTIONS(7532),
    [anon_sym_GT_EQ] = ACTIONS(7530),
    [anon_sym_EQ_EQ] = ACTIONS(7530),
    [anon_sym_BANG_EQ] = ACTIONS(7530),
    [anon_sym_STAR] = ACTIONS(7532),
    [anon_sym_SLASH] = ACTIONS(7530),
    [anon_sym_STAR_STAR] = ACTIONS(7530),
    [anon_sym_CARET] = ACTIONS(7530),
    [aux_sym_binary_operator_token1] = ACTIONS(7530),
    [anon_sym_PIPE_GT] = ACTIONS(7530),
    [anon_sym_COLON] = ACTIONS(7532),
    [anon_sym_DOLLAR] = ACTIONS(7530),
    [anon_sym_AT] = ACTIONS(7530),
    [aux_sym__hex_literal_token1] = ACTIONS(7530),
    [sym__number_literal] = ACTIONS(7532),
    [anon_sym_SQUOTE] = ACTIONS(7530),
    [anon_sym_DQUOTE] = ACTIONS(7530),
    [sym_return] = ACTIONS(7532),
    [sym_next] = ACTIONS(7532),
    [sym_break] = ACTIONS(7532),
    [sym_true] = ACTIONS(7532),
    [sym_false] = ACTIONS(7532),
    [sym_null] = ACTIONS(7532),
    [sym_inf] = ACTIONS(7532),
    [sym_nan] = ACTIONS(7532),
    [anon_sym_NA] = ACTIONS(7532),
    [anon_sym_NA_integer_] = ACTIONS(7532),
    [anon_sym_NA_real_] = ACTIONS(7532),
    [anon_sym_NA_complex_] = ACTIONS(7532),
    [anon_sym_NA_character_] = ACTIONS(7532),
    [sym_dots] = ACTIONS(7532),
    [sym_dot_dot_i] = ACTIONS(7530),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7530),
    [sym__newline] = ACTIONS(7530),
    [sym__raw_string_literal] = ACTIONS(7530),
    [sym__external_open_parenthesis] = ACTIONS(7530),
    [sym__external_open_brace] = ACTIONS(7530),
    [sym__external_open_bracket] = ACTIONS(7530),
    [sym__external_open_bracket2] = ACTIONS(7530),
    [sym__external_close_bracket2] = ACTIONS(7530),
  },
  [2979] = {
    [sym_identifier] = ACTIONS(7540),
    [anon_sym_BSLASH] = ACTIONS(7538),
    [anon_sym_function] = ACTIONS(7540),
    [anon_sym_EQ] = ACTIONS(7540),
    [anon_sym_if] = ACTIONS(7540),
    [anon_sym_for] = ACTIONS(7540),
    [anon_sym_while] = ACTIONS(7540),
    [anon_sym_repeat] = ACTIONS(7540),
    [anon_sym_QMARK] = ACTIONS(7538),
    [anon_sym_TILDE] = ACTIONS(7538),
    [anon_sym_BANG] = ACTIONS(7540),
    [anon_sym_PLUS] = ACTIONS(7538),
    [anon_sym_DASH] = ACTIONS(7540),
    [anon_sym_LT_DASH] = ACTIONS(7538),
    [anon_sym_LT_LT_DASH] = ACTIONS(7538),
    [anon_sym_COLON_EQ] = ACTIONS(7538),
    [anon_sym_DASH_GT] = ACTIONS(7540),
    [anon_sym_DASH_GT_GT] = ACTIONS(7538),
    [anon_sym_PIPE] = ACTIONS(7540),
    [anon_sym_AMP] = ACTIONS(7540),
    [anon_sym_PIPE_PIPE] = ACTIONS(7538),
    [anon_sym_AMP_AMP] = ACTIONS(7538),
    [anon_sym_LT] = ACTIONS(7540),
    [anon_sym_LT_EQ] = ACTIONS(7538),
    [anon_sym_GT] = ACTIONS(7540),
    [anon_sym_GT_EQ] = ACTIONS(7538),
    [anon_sym_EQ_EQ] = ACTIONS(7538),
    [anon_sym_BANG_EQ] = ACTIONS(7538),
    [anon_sym_STAR] = ACTIONS(7540),
    [anon_sym_SLASH] = ACTIONS(7538),
    [anon_sym_STAR_STAR] = ACTIONS(7538),
    [anon_sym_CARET] = ACTIONS(7538),
    [aux_sym_binary_operator_token1] = ACTIONS(7538),
    [anon_sym_PIPE_GT] = ACTIONS(7538),
    [anon_sym_COLON] = ACTIONS(7540),
    [anon_sym_DOLLAR] = ACTIONS(7538),
    [anon_sym_AT] = ACTIONS(7538),
    [aux_sym__hex_literal_token1] = ACTIONS(7538),
    [sym__number_literal] = ACTIONS(7540),
    [anon_sym_SQUOTE] = ACTIONS(7538),
    [anon_sym_DQUOTE] = ACTIONS(7538),
    [sym_return] = ACTIONS(7540),
    [sym_next] = ACTIONS(7540),
    [sym_break] = ACTIONS(7540),
    [sym_true] = ACTIONS(7540),
    [sym_false] = ACTIONS(7540),
    [sym_null] = ACTIONS(7540),
    [sym_inf] = ACTIONS(7540),
    [sym_nan] = ACTIONS(7540),
    [anon_sym_NA] = ACTIONS(7540),
    [anon_sym_NA_integer_] = ACTIONS(7540),
    [anon_sym_NA_real_] = ACTIONS(7540),
    [anon_sym_NA_complex_] = ACTIONS(7540),
    [anon_sym_NA_character_] = ACTIONS(7540),
    [sym_dots] = ACTIONS(7540),
    [sym_dot_dot_i] = ACTIONS(7538),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7538),
    [sym__newline] = ACTIONS(7538),
    [sym__raw_string_literal] = ACTIONS(7538),
    [sym__external_open_parenthesis] = ACTIONS(7538),
    [sym__external_open_brace] = ACTIONS(7538),
    [sym__external_open_bracket] = ACTIONS(7538),
    [sym__external_open_bracket2] = ACTIONS(7538),
    [sym__external_close_bracket2] = ACTIONS(7538),
  },
  [2980] = {
    [sym_identifier] = ACTIONS(7544),
    [anon_sym_BSLASH] = ACTIONS(7542),
    [anon_sym_function] = ACTIONS(7544),
    [anon_sym_EQ] = ACTIONS(7544),
    [anon_sym_if] = ACTIONS(7544),
    [anon_sym_for] = ACTIONS(7544),
    [anon_sym_while] = ACTIONS(7544),
    [anon_sym_repeat] = ACTIONS(7544),
    [anon_sym_QMARK] = ACTIONS(7542),
    [anon_sym_TILDE] = ACTIONS(7542),
    [anon_sym_BANG] = ACTIONS(7544),
    [anon_sym_PLUS] = ACTIONS(7542),
    [anon_sym_DASH] = ACTIONS(7544),
    [anon_sym_LT_DASH] = ACTIONS(7542),
    [anon_sym_LT_LT_DASH] = ACTIONS(7542),
    [anon_sym_COLON_EQ] = ACTIONS(7542),
    [anon_sym_DASH_GT] = ACTIONS(7544),
    [anon_sym_DASH_GT_GT] = ACTIONS(7542),
    [anon_sym_PIPE] = ACTIONS(7544),
    [anon_sym_AMP] = ACTIONS(7544),
    [anon_sym_PIPE_PIPE] = ACTIONS(7542),
    [anon_sym_AMP_AMP] = ACTIONS(7542),
    [anon_sym_LT] = ACTIONS(7544),
    [anon_sym_LT_EQ] = ACTIONS(7542),
    [anon_sym_GT] = ACTIONS(7544),
    [anon_sym_GT_EQ] = ACTIONS(7542),
    [anon_sym_EQ_EQ] = ACTIONS(7542),
    [anon_sym_BANG_EQ] = ACTIONS(7542),
    [anon_sym_STAR] = ACTIONS(7544),
    [anon_sym_SLASH] = ACTIONS(7542),
    [anon_sym_STAR_STAR] = ACTIONS(7542),
    [anon_sym_CARET] = ACTIONS(7542),
    [aux_sym_binary_operator_token1] = ACTIONS(7542),
    [anon_sym_PIPE_GT] = ACTIONS(7542),
    [anon_sym_COLON] = ACTIONS(7544),
    [anon_sym_DOLLAR] = ACTIONS(7542),
    [anon_sym_AT] = ACTIONS(7542),
    [aux_sym__hex_literal_token1] = ACTIONS(7542),
    [sym__number_literal] = ACTIONS(7544),
    [anon_sym_SQUOTE] = ACTIONS(7542),
    [anon_sym_DQUOTE] = ACTIONS(7542),
    [sym_return] = ACTIONS(7544),
    [sym_next] = ACTIONS(7544),
    [sym_break] = ACTIONS(7544),
    [sym_true] = ACTIONS(7544),
    [sym_false] = ACTIONS(7544),
    [sym_null] = ACTIONS(7544),
    [sym_inf] = ACTIONS(7544),
    [sym_nan] = ACTIONS(7544),
    [anon_sym_NA] = ACTIONS(7544),
    [anon_sym_NA_integer_] = ACTIONS(7544),
    [anon_sym_NA_real_] = ACTIONS(7544),
    [anon_sym_NA_complex_] = ACTIONS(7544),
    [anon_sym_NA_character_] = ACTIONS(7544),
    [sym_dots] = ACTIONS(7544),
    [sym_dot_dot_i] = ACTIONS(7542),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7542),
    [sym__newline] = ACTIONS(7542),
    [sym__raw_string_literal] = ACTIONS(7542),
    [sym__external_open_parenthesis] = ACTIONS(7542),
    [sym__external_open_brace] = ACTIONS(7542),
    [sym__external_open_bracket] = ACTIONS(7542),
    [sym__external_open_bracket2] = ACTIONS(7542),
    [sym__external_close_bracket2] = ACTIONS(7542),
  },
  [2981] = {
    [sym_identifier] = ACTIONS(7464),
    [anon_sym_BSLASH] = ACTIONS(7466),
    [anon_sym_function] = ACTIONS(7464),
    [anon_sym_EQ] = ACTIONS(7464),
    [anon_sym_if] = ACTIONS(7464),
    [anon_sym_for] = ACTIONS(7464),
    [anon_sym_while] = ACTIONS(7464),
    [anon_sym_repeat] = ACTIONS(7464),
    [anon_sym_QMARK] = ACTIONS(7466),
    [anon_sym_TILDE] = ACTIONS(7466),
    [anon_sym_BANG] = ACTIONS(7464),
    [anon_sym_PLUS] = ACTIONS(7466),
    [anon_sym_DASH] = ACTIONS(7464),
    [anon_sym_LT_DASH] = ACTIONS(7466),
    [anon_sym_LT_LT_DASH] = ACTIONS(7466),
    [anon_sym_COLON_EQ] = ACTIONS(7466),
    [anon_sym_DASH_GT] = ACTIONS(7464),
    [anon_sym_DASH_GT_GT] = ACTIONS(7466),
    [anon_sym_PIPE] = ACTIONS(7464),
    [anon_sym_AMP] = ACTIONS(7464),
    [anon_sym_PIPE_PIPE] = ACTIONS(7466),
    [anon_sym_AMP_AMP] = ACTIONS(7466),
    [anon_sym_LT] = ACTIONS(7464),
    [anon_sym_LT_EQ] = ACTIONS(7466),
    [anon_sym_GT] = ACTIONS(7464),
    [anon_sym_GT_EQ] = ACTIONS(7466),
    [anon_sym_EQ_EQ] = ACTIONS(7466),
    [anon_sym_BANG_EQ] = ACTIONS(7466),
    [anon_sym_STAR] = ACTIONS(7464),
    [anon_sym_SLASH] = ACTIONS(7466),
    [anon_sym_STAR_STAR] = ACTIONS(7466),
    [anon_sym_CARET] = ACTIONS(7466),
    [aux_sym_binary_operator_token1] = ACTIONS(7466),
    [anon_sym_PIPE_GT] = ACTIONS(7466),
    [anon_sym_COLON] = ACTIONS(7464),
    [anon_sym_DOLLAR] = ACTIONS(7466),
    [anon_sym_AT] = ACTIONS(7466),
    [aux_sym__hex_literal_token1] = ACTIONS(7466),
    [sym__number_literal] = ACTIONS(7464),
    [anon_sym_SQUOTE] = ACTIONS(7466),
    [anon_sym_DQUOTE] = ACTIONS(7466),
    [sym_return] = ACTIONS(7464),
    [sym_next] = ACTIONS(7464),
    [sym_break] = ACTIONS(7464),
    [sym_true] = ACTIONS(7464),
    [sym_false] = ACTIONS(7464),
    [sym_null] = ACTIONS(7464),
    [sym_inf] = ACTIONS(7464),
    [sym_nan] = ACTIONS(7464),
    [anon_sym_NA] = ACTIONS(7464),
    [anon_sym_NA_integer_] = ACTIONS(7464),
    [anon_sym_NA_real_] = ACTIONS(7464),
    [anon_sym_NA_complex_] = ACTIONS(7464),
    [anon_sym_NA_character_] = ACTIONS(7464),
    [sym_dots] = ACTIONS(7464),
    [sym_dot_dot_i] = ACTIONS(7466),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7466),
    [sym__newline] = ACTIONS(7466),
    [sym__raw_string_literal] = ACTIONS(7466),
    [sym__external_open_parenthesis] = ACTIONS(7466),
    [sym__external_close_parenthesis] = ACTIONS(7466),
    [sym__external_open_brace] = ACTIONS(7466),
    [sym__external_open_bracket] = ACTIONS(7466),
    [sym__external_open_bracket2] = ACTIONS(7466),
  },
  [2982] = {
    [ts_builtin_sym_end] = ACTIONS(7514),
    [sym_identifier] = ACTIONS(7516),
    [anon_sym_BSLASH] = ACTIONS(7514),
    [anon_sym_function] = ACTIONS(7516),
    [anon_sym_EQ] = ACTIONS(7516),
    [anon_sym_if] = ACTIONS(7516),
    [anon_sym_for] = ACTIONS(7516),
    [anon_sym_while] = ACTIONS(7516),
    [anon_sym_repeat] = ACTIONS(7516),
    [anon_sym_QMARK] = ACTIONS(7514),
    [anon_sym_TILDE] = ACTIONS(7514),
    [anon_sym_BANG] = ACTIONS(7516),
    [anon_sym_PLUS] = ACTIONS(7514),
    [anon_sym_DASH] = ACTIONS(7516),
    [anon_sym_LT_DASH] = ACTIONS(7514),
    [anon_sym_LT_LT_DASH] = ACTIONS(7514),
    [anon_sym_COLON_EQ] = ACTIONS(7514),
    [anon_sym_DASH_GT] = ACTIONS(7516),
    [anon_sym_DASH_GT_GT] = ACTIONS(7514),
    [anon_sym_PIPE] = ACTIONS(7516),
    [anon_sym_AMP] = ACTIONS(7516),
    [anon_sym_PIPE_PIPE] = ACTIONS(7514),
    [anon_sym_AMP_AMP] = ACTIONS(7514),
    [anon_sym_LT] = ACTIONS(7516),
    [anon_sym_LT_EQ] = ACTIONS(7514),
    [anon_sym_GT] = ACTIONS(7516),
    [anon_sym_GT_EQ] = ACTIONS(7514),
    [anon_sym_EQ_EQ] = ACTIONS(7514),
    [anon_sym_BANG_EQ] = ACTIONS(7514),
    [anon_sym_STAR] = ACTIONS(7516),
    [anon_sym_SLASH] = ACTIONS(7514),
    [anon_sym_STAR_STAR] = ACTIONS(7514),
    [anon_sym_CARET] = ACTIONS(7514),
    [aux_sym_binary_operator_token1] = ACTIONS(7514),
    [anon_sym_PIPE_GT] = ACTIONS(7514),
    [anon_sym_COLON] = ACTIONS(7516),
    [anon_sym_DOLLAR] = ACTIONS(7514),
    [anon_sym_AT] = ACTIONS(7514),
    [aux_sym__hex_literal_token1] = ACTIONS(7514),
    [sym__number_literal] = ACTIONS(7516),
    [anon_sym_SQUOTE] = ACTIONS(7514),
    [anon_sym_DQUOTE] = ACTIONS(7514),
    [sym_return] = ACTIONS(7516),
    [sym_next] = ACTIONS(7516),
    [sym_break] = ACTIONS(7516),
    [sym_true] = ACTIONS(7516),
    [sym_false] = ACTIONS(7516),
    [sym_null] = ACTIONS(7516),
    [sym_inf] = ACTIONS(7516),
    [sym_nan] = ACTIONS(7516),
    [anon_sym_NA] = ACTIONS(7516),
    [anon_sym_NA_integer_] = ACTIONS(7516),
    [anon_sym_NA_real_] = ACTIONS(7516),
    [anon_sym_NA_complex_] = ACTIONS(7516),
    [anon_sym_NA_character_] = ACTIONS(7516),
    [sym_dots] = ACTIONS(7516),
    [sym_dot_dot_i] = ACTIONS(7514),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7514),
    [sym__semicolon] = ACTIONS(7514),
    [sym__raw_string_literal] = ACTIONS(7514),
    [sym__external_open_parenthesis] = ACTIONS(7514),
    [sym__external_open_brace] = ACTIONS(7514),
    [sym__external_open_bracket] = ACTIONS(7514),
    [sym__external_open_bracket2] = ACTIONS(7514),
  },
  [2983] = {
    [sym_identifier] = ACTIONS(7552),
    [anon_sym_BSLASH] = ACTIONS(7550),
    [anon_sym_function] = ACTIONS(7552),
    [anon_sym_EQ] = ACTIONS(7552),
    [anon_sym_if] = ACTIONS(7552),
    [anon_sym_for] = ACTIONS(7552),
    [anon_sym_while] = ACTIONS(7552),
    [anon_sym_repeat] = ACTIONS(7552),
    [anon_sym_QMARK] = ACTIONS(7550),
    [anon_sym_TILDE] = ACTIONS(7550),
    [anon_sym_BANG] = ACTIONS(7552),
    [anon_sym_PLUS] = ACTIONS(7550),
    [anon_sym_DASH] = ACTIONS(7552),
    [anon_sym_LT_DASH] = ACTIONS(7550),
    [anon_sym_LT_LT_DASH] = ACTIONS(7550),
    [anon_sym_COLON_EQ] = ACTIONS(7550),
    [anon_sym_DASH_GT] = ACTIONS(7552),
    [anon_sym_DASH_GT_GT] = ACTIONS(7550),
    [anon_sym_PIPE] = ACTIONS(7552),
    [anon_sym_AMP] = ACTIONS(7552),
    [anon_sym_PIPE_PIPE] = ACTIONS(7550),
    [anon_sym_AMP_AMP] = ACTIONS(7550),
    [anon_sym_LT] = ACTIONS(7552),
    [anon_sym_LT_EQ] = ACTIONS(7550),
    [anon_sym_GT] = ACTIONS(7552),
    [anon_sym_GT_EQ] = ACTIONS(7550),
    [anon_sym_EQ_EQ] = ACTIONS(7550),
    [anon_sym_BANG_EQ] = ACTIONS(7550),
    [anon_sym_STAR] = ACTIONS(7552),
    [anon_sym_SLASH] = ACTIONS(7550),
    [anon_sym_STAR_STAR] = ACTIONS(7550),
    [anon_sym_CARET] = ACTIONS(7550),
    [aux_sym_binary_operator_token1] = ACTIONS(7550),
    [anon_sym_PIPE_GT] = ACTIONS(7550),
    [anon_sym_COLON] = ACTIONS(7552),
    [anon_sym_DOLLAR] = ACTIONS(7550),
    [anon_sym_AT] = ACTIONS(7550),
    [aux_sym__hex_literal_token1] = ACTIONS(7550),
    [sym__number_literal] = ACTIONS(7552),
    [anon_sym_SQUOTE] = ACTIONS(7550),
    [anon_sym_DQUOTE] = ACTIONS(7550),
    [sym_return] = ACTIONS(7552),
    [sym_next] = ACTIONS(7552),
    [sym_break] = ACTIONS(7552),
    [sym_true] = ACTIONS(7552),
    [sym_false] = ACTIONS(7552),
    [sym_null] = ACTIONS(7552),
    [sym_inf] = ACTIONS(7552),
    [sym_nan] = ACTIONS(7552),
    [anon_sym_NA] = ACTIONS(7552),
    [anon_sym_NA_integer_] = ACTIONS(7552),
    [anon_sym_NA_real_] = ACTIONS(7552),
    [anon_sym_NA_complex_] = ACTIONS(7552),
    [anon_sym_NA_character_] = ACTIONS(7552),
    [sym_dots] = ACTIONS(7552),
    [sym_dot_dot_i] = ACTIONS(7550),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7550),
    [sym__newline] = ACTIONS(7550),
    [sym__raw_string_literal] = ACTIONS(7550),
    [sym__external_open_parenthesis] = ACTIONS(7550),
    [sym__external_open_brace] = ACTIONS(7550),
    [sym__external_open_bracket] = ACTIONS(7550),
    [sym__external_open_bracket2] = ACTIONS(7550),
    [sym__external_close_bracket2] = ACTIONS(7550),
  },
  [2984] = {
    [sym_identifier] = ACTIONS(7556),
    [anon_sym_BSLASH] = ACTIONS(7554),
    [anon_sym_function] = ACTIONS(7556),
    [anon_sym_EQ] = ACTIONS(7556),
    [anon_sym_if] = ACTIONS(7556),
    [anon_sym_for] = ACTIONS(7556),
    [anon_sym_while] = ACTIONS(7556),
    [anon_sym_repeat] = ACTIONS(7556),
    [anon_sym_QMARK] = ACTIONS(7554),
    [anon_sym_TILDE] = ACTIONS(7554),
    [anon_sym_BANG] = ACTIONS(7556),
    [anon_sym_PLUS] = ACTIONS(7554),
    [anon_sym_DASH] = ACTIONS(7556),
    [anon_sym_LT_DASH] = ACTIONS(7554),
    [anon_sym_LT_LT_DASH] = ACTIONS(7554),
    [anon_sym_COLON_EQ] = ACTIONS(7554),
    [anon_sym_DASH_GT] = ACTIONS(7556),
    [anon_sym_DASH_GT_GT] = ACTIONS(7554),
    [anon_sym_PIPE] = ACTIONS(7556),
    [anon_sym_AMP] = ACTIONS(7556),
    [anon_sym_PIPE_PIPE] = ACTIONS(7554),
    [anon_sym_AMP_AMP] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(7556),
    [anon_sym_LT_EQ] = ACTIONS(7554),
    [anon_sym_GT] = ACTIONS(7556),
    [anon_sym_GT_EQ] = ACTIONS(7554),
    [anon_sym_EQ_EQ] = ACTIONS(7554),
    [anon_sym_BANG_EQ] = ACTIONS(7554),
    [anon_sym_STAR] = ACTIONS(7556),
    [anon_sym_SLASH] = ACTIONS(7554),
    [anon_sym_STAR_STAR] = ACTIONS(7554),
    [anon_sym_CARET] = ACTIONS(7554),
    [aux_sym_binary_operator_token1] = ACTIONS(7554),
    [anon_sym_PIPE_GT] = ACTIONS(7554),
    [anon_sym_COLON] = ACTIONS(7556),
    [anon_sym_DOLLAR] = ACTIONS(7554),
    [anon_sym_AT] = ACTIONS(7554),
    [aux_sym__hex_literal_token1] = ACTIONS(7554),
    [sym__number_literal] = ACTIONS(7556),
    [anon_sym_SQUOTE] = ACTIONS(7554),
    [anon_sym_DQUOTE] = ACTIONS(7554),
    [sym_return] = ACTIONS(7556),
    [sym_next] = ACTIONS(7556),
    [sym_break] = ACTIONS(7556),
    [sym_true] = ACTIONS(7556),
    [sym_false] = ACTIONS(7556),
    [sym_null] = ACTIONS(7556),
    [sym_inf] = ACTIONS(7556),
    [sym_nan] = ACTIONS(7556),
    [anon_sym_NA] = ACTIONS(7556),
    [anon_sym_NA_integer_] = ACTIONS(7556),
    [anon_sym_NA_real_] = ACTIONS(7556),
    [anon_sym_NA_complex_] = ACTIONS(7556),
    [anon_sym_NA_character_] = ACTIONS(7556),
    [sym_dots] = ACTIONS(7556),
    [sym_dot_dot_i] = ACTIONS(7554),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7554),
    [sym__newline] = ACTIONS(7554),
    [sym__raw_string_literal] = ACTIONS(7554),
    [sym__external_open_parenthesis] = ACTIONS(7554),
    [sym__external_open_brace] = ACTIONS(7554),
    [sym__external_open_bracket] = ACTIONS(7554),
    [sym__external_close_bracket] = ACTIONS(7554),
    [sym__external_open_bracket2] = ACTIONS(7554),
  },
  [2985] = {
    [ts_builtin_sym_end] = ACTIONS(7530),
    [sym_identifier] = ACTIONS(7532),
    [anon_sym_BSLASH] = ACTIONS(7530),
    [anon_sym_function] = ACTIONS(7532),
    [anon_sym_EQ] = ACTIONS(7532),
    [anon_sym_if] = ACTIONS(7532),
    [anon_sym_for] = ACTIONS(7532),
    [anon_sym_while] = ACTIONS(7532),
    [anon_sym_repeat] = ACTIONS(7532),
    [anon_sym_QMARK] = ACTIONS(7530),
    [anon_sym_TILDE] = ACTIONS(7530),
    [anon_sym_BANG] = ACTIONS(7532),
    [anon_sym_PLUS] = ACTIONS(7530),
    [anon_sym_DASH] = ACTIONS(7532),
    [anon_sym_LT_DASH] = ACTIONS(7530),
    [anon_sym_LT_LT_DASH] = ACTIONS(7530),
    [anon_sym_COLON_EQ] = ACTIONS(7530),
    [anon_sym_DASH_GT] = ACTIONS(7532),
    [anon_sym_DASH_GT_GT] = ACTIONS(7530),
    [anon_sym_PIPE] = ACTIONS(7532),
    [anon_sym_AMP] = ACTIONS(7532),
    [anon_sym_PIPE_PIPE] = ACTIONS(7530),
    [anon_sym_AMP_AMP] = ACTIONS(7530),
    [anon_sym_LT] = ACTIONS(7532),
    [anon_sym_LT_EQ] = ACTIONS(7530),
    [anon_sym_GT] = ACTIONS(7532),
    [anon_sym_GT_EQ] = ACTIONS(7530),
    [anon_sym_EQ_EQ] = ACTIONS(7530),
    [anon_sym_BANG_EQ] = ACTIONS(7530),
    [anon_sym_STAR] = ACTIONS(7532),
    [anon_sym_SLASH] = ACTIONS(7530),
    [anon_sym_STAR_STAR] = ACTIONS(7530),
    [anon_sym_CARET] = ACTIONS(7530),
    [aux_sym_binary_operator_token1] = ACTIONS(7530),
    [anon_sym_PIPE_GT] = ACTIONS(7530),
    [anon_sym_COLON] = ACTIONS(7532),
    [anon_sym_DOLLAR] = ACTIONS(7530),
    [anon_sym_AT] = ACTIONS(7530),
    [aux_sym__hex_literal_token1] = ACTIONS(7530),
    [sym__number_literal] = ACTIONS(7532),
    [anon_sym_SQUOTE] = ACTIONS(7530),
    [anon_sym_DQUOTE] = ACTIONS(7530),
    [sym_return] = ACTIONS(7532),
    [sym_next] = ACTIONS(7532),
    [sym_break] = ACTIONS(7532),
    [sym_true] = ACTIONS(7532),
    [sym_false] = ACTIONS(7532),
    [sym_null] = ACTIONS(7532),
    [sym_inf] = ACTIONS(7532),
    [sym_nan] = ACTIONS(7532),
    [anon_sym_NA] = ACTIONS(7532),
    [anon_sym_NA_integer_] = ACTIONS(7532),
    [anon_sym_NA_real_] = ACTIONS(7532),
    [anon_sym_NA_complex_] = ACTIONS(7532),
    [anon_sym_NA_character_] = ACTIONS(7532),
    [sym_dots] = ACTIONS(7532),
    [sym_dot_dot_i] = ACTIONS(7530),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7530),
    [sym__semicolon] = ACTIONS(7530),
    [sym__raw_string_literal] = ACTIONS(7530),
    [sym__external_open_parenthesis] = ACTIONS(7530),
    [sym__external_open_brace] = ACTIONS(7530),
    [sym__external_open_bracket] = ACTIONS(7530),
    [sym__external_open_bracket2] = ACTIONS(7530),
  },
  [2986] = {
    [ts_builtin_sym_end] = ACTIONS(7526),
    [sym_identifier] = ACTIONS(7528),
    [anon_sym_BSLASH] = ACTIONS(7526),
    [anon_sym_function] = ACTIONS(7528),
    [anon_sym_EQ] = ACTIONS(7528),
    [anon_sym_if] = ACTIONS(7528),
    [anon_sym_for] = ACTIONS(7528),
    [anon_sym_while] = ACTIONS(7528),
    [anon_sym_repeat] = ACTIONS(7528),
    [anon_sym_QMARK] = ACTIONS(7526),
    [anon_sym_TILDE] = ACTIONS(7526),
    [anon_sym_BANG] = ACTIONS(7528),
    [anon_sym_PLUS] = ACTIONS(7526),
    [anon_sym_DASH] = ACTIONS(7528),
    [anon_sym_LT_DASH] = ACTIONS(7526),
    [anon_sym_LT_LT_DASH] = ACTIONS(7526),
    [anon_sym_COLON_EQ] = ACTIONS(7526),
    [anon_sym_DASH_GT] = ACTIONS(7528),
    [anon_sym_DASH_GT_GT] = ACTIONS(7526),
    [anon_sym_PIPE] = ACTIONS(7528),
    [anon_sym_AMP] = ACTIONS(7528),
    [anon_sym_PIPE_PIPE] = ACTIONS(7526),
    [anon_sym_AMP_AMP] = ACTIONS(7526),
    [anon_sym_LT] = ACTIONS(7528),
    [anon_sym_LT_EQ] = ACTIONS(7526),
    [anon_sym_GT] = ACTIONS(7528),
    [anon_sym_GT_EQ] = ACTIONS(7526),
    [anon_sym_EQ_EQ] = ACTIONS(7526),
    [anon_sym_BANG_EQ] = ACTIONS(7526),
    [anon_sym_STAR] = ACTIONS(7528),
    [anon_sym_SLASH] = ACTIONS(7526),
    [anon_sym_STAR_STAR] = ACTIONS(7526),
    [anon_sym_CARET] = ACTIONS(7526),
    [aux_sym_binary_operator_token1] = ACTIONS(7526),
    [anon_sym_PIPE_GT] = ACTIONS(7526),
    [anon_sym_COLON] = ACTIONS(7528),
    [anon_sym_DOLLAR] = ACTIONS(7526),
    [anon_sym_AT] = ACTIONS(7526),
    [aux_sym__hex_literal_token1] = ACTIONS(7526),
    [sym__number_literal] = ACTIONS(7528),
    [anon_sym_SQUOTE] = ACTIONS(7526),
    [anon_sym_DQUOTE] = ACTIONS(7526),
    [sym_return] = ACTIONS(7528),
    [sym_next] = ACTIONS(7528),
    [sym_break] = ACTIONS(7528),
    [sym_true] = ACTIONS(7528),
    [sym_false] = ACTIONS(7528),
    [sym_null] = ACTIONS(7528),
    [sym_inf] = ACTIONS(7528),
    [sym_nan] = ACTIONS(7528),
    [anon_sym_NA] = ACTIONS(7528),
    [anon_sym_NA_integer_] = ACTIONS(7528),
    [anon_sym_NA_real_] = ACTIONS(7528),
    [anon_sym_NA_complex_] = ACTIONS(7528),
    [anon_sym_NA_character_] = ACTIONS(7528),
    [sym_dots] = ACTIONS(7528),
    [sym_dot_dot_i] = ACTIONS(7526),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7526),
    [sym__semicolon] = ACTIONS(7526),
    [sym__raw_string_literal] = ACTIONS(7526),
    [sym__external_open_parenthesis] = ACTIONS(7526),
    [sym__external_open_brace] = ACTIONS(7526),
    [sym__external_open_bracket] = ACTIONS(7526),
    [sym__external_open_bracket2] = ACTIONS(7526),
  },
  [2987] = {
    [ts_builtin_sym_end] = ACTIONS(7522),
    [sym_identifier] = ACTIONS(7524),
    [anon_sym_BSLASH] = ACTIONS(7522),
    [anon_sym_function] = ACTIONS(7524),
    [anon_sym_EQ] = ACTIONS(7524),
    [anon_sym_if] = ACTIONS(7524),
    [anon_sym_for] = ACTIONS(7524),
    [anon_sym_while] = ACTIONS(7524),
    [anon_sym_repeat] = ACTIONS(7524),
    [anon_sym_QMARK] = ACTIONS(7522),
    [anon_sym_TILDE] = ACTIONS(7522),
    [anon_sym_BANG] = ACTIONS(7524),
    [anon_sym_PLUS] = ACTIONS(7522),
    [anon_sym_DASH] = ACTIONS(7524),
    [anon_sym_LT_DASH] = ACTIONS(7522),
    [anon_sym_LT_LT_DASH] = ACTIONS(7522),
    [anon_sym_COLON_EQ] = ACTIONS(7522),
    [anon_sym_DASH_GT] = ACTIONS(7524),
    [anon_sym_DASH_GT_GT] = ACTIONS(7522),
    [anon_sym_PIPE] = ACTIONS(7524),
    [anon_sym_AMP] = ACTIONS(7524),
    [anon_sym_PIPE_PIPE] = ACTIONS(7522),
    [anon_sym_AMP_AMP] = ACTIONS(7522),
    [anon_sym_LT] = ACTIONS(7524),
    [anon_sym_LT_EQ] = ACTIONS(7522),
    [anon_sym_GT] = ACTIONS(7524),
    [anon_sym_GT_EQ] = ACTIONS(7522),
    [anon_sym_EQ_EQ] = ACTIONS(7522),
    [anon_sym_BANG_EQ] = ACTIONS(7522),
    [anon_sym_STAR] = ACTIONS(7524),
    [anon_sym_SLASH] = ACTIONS(7522),
    [anon_sym_STAR_STAR] = ACTIONS(7522),
    [anon_sym_CARET] = ACTIONS(7522),
    [aux_sym_binary_operator_token1] = ACTIONS(7522),
    [anon_sym_PIPE_GT] = ACTIONS(7522),
    [anon_sym_COLON] = ACTIONS(7524),
    [anon_sym_DOLLAR] = ACTIONS(7522),
    [anon_sym_AT] = ACTIONS(7522),
    [aux_sym__hex_literal_token1] = ACTIONS(7522),
    [sym__number_literal] = ACTIONS(7524),
    [anon_sym_SQUOTE] = ACTIONS(7522),
    [anon_sym_DQUOTE] = ACTIONS(7522),
    [sym_return] = ACTIONS(7524),
    [sym_next] = ACTIONS(7524),
    [sym_break] = ACTIONS(7524),
    [sym_true] = ACTIONS(7524),
    [sym_false] = ACTIONS(7524),
    [sym_null] = ACTIONS(7524),
    [sym_inf] = ACTIONS(7524),
    [sym_nan] = ACTIONS(7524),
    [anon_sym_NA] = ACTIONS(7524),
    [anon_sym_NA_integer_] = ACTIONS(7524),
    [anon_sym_NA_real_] = ACTIONS(7524),
    [anon_sym_NA_complex_] = ACTIONS(7524),
    [anon_sym_NA_character_] = ACTIONS(7524),
    [sym_dots] = ACTIONS(7524),
    [sym_dot_dot_i] = ACTIONS(7522),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7522),
    [sym__semicolon] = ACTIONS(7522),
    [sym__raw_string_literal] = ACTIONS(7522),
    [sym__external_open_parenthesis] = ACTIONS(7522),
    [sym__external_open_brace] = ACTIONS(7522),
    [sym__external_open_bracket] = ACTIONS(7522),
    [sym__external_open_bracket2] = ACTIONS(7522),
  },
  [2988] = {
    [sym_identifier] = ACTIONS(7556),
    [anon_sym_BSLASH] = ACTIONS(7554),
    [anon_sym_function] = ACTIONS(7556),
    [anon_sym_EQ] = ACTIONS(7556),
    [anon_sym_if] = ACTIONS(7556),
    [anon_sym_for] = ACTIONS(7556),
    [anon_sym_while] = ACTIONS(7556),
    [anon_sym_repeat] = ACTIONS(7556),
    [anon_sym_QMARK] = ACTIONS(7554),
    [anon_sym_TILDE] = ACTIONS(7554),
    [anon_sym_BANG] = ACTIONS(7556),
    [anon_sym_PLUS] = ACTIONS(7554),
    [anon_sym_DASH] = ACTIONS(7556),
    [anon_sym_LT_DASH] = ACTIONS(7554),
    [anon_sym_LT_LT_DASH] = ACTIONS(7554),
    [anon_sym_COLON_EQ] = ACTIONS(7554),
    [anon_sym_DASH_GT] = ACTIONS(7556),
    [anon_sym_DASH_GT_GT] = ACTIONS(7554),
    [anon_sym_PIPE] = ACTIONS(7556),
    [anon_sym_AMP] = ACTIONS(7556),
    [anon_sym_PIPE_PIPE] = ACTIONS(7554),
    [anon_sym_AMP_AMP] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(7556),
    [anon_sym_LT_EQ] = ACTIONS(7554),
    [anon_sym_GT] = ACTIONS(7556),
    [anon_sym_GT_EQ] = ACTIONS(7554),
    [anon_sym_EQ_EQ] = ACTIONS(7554),
    [anon_sym_BANG_EQ] = ACTIONS(7554),
    [anon_sym_STAR] = ACTIONS(7556),
    [anon_sym_SLASH] = ACTIONS(7554),
    [anon_sym_STAR_STAR] = ACTIONS(7554),
    [anon_sym_CARET] = ACTIONS(7554),
    [aux_sym_binary_operator_token1] = ACTIONS(7554),
    [anon_sym_PIPE_GT] = ACTIONS(7554),
    [anon_sym_COLON] = ACTIONS(7556),
    [anon_sym_DOLLAR] = ACTIONS(7554),
    [anon_sym_AT] = ACTIONS(7554),
    [aux_sym__hex_literal_token1] = ACTIONS(7554),
    [sym__number_literal] = ACTIONS(7556),
    [anon_sym_SQUOTE] = ACTIONS(7554),
    [anon_sym_DQUOTE] = ACTIONS(7554),
    [sym_return] = ACTIONS(7556),
    [sym_next] = ACTIONS(7556),
    [sym_break] = ACTIONS(7556),
    [sym_true] = ACTIONS(7556),
    [sym_false] = ACTIONS(7556),
    [sym_null] = ACTIONS(7556),
    [sym_inf] = ACTIONS(7556),
    [sym_nan] = ACTIONS(7556),
    [anon_sym_NA] = ACTIONS(7556),
    [anon_sym_NA_integer_] = ACTIONS(7556),
    [anon_sym_NA_real_] = ACTIONS(7556),
    [anon_sym_NA_complex_] = ACTIONS(7556),
    [anon_sym_NA_character_] = ACTIONS(7556),
    [sym_dots] = ACTIONS(7556),
    [sym_dot_dot_i] = ACTIONS(7554),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7554),
    [sym__newline] = ACTIONS(7554),
    [sym__raw_string_literal] = ACTIONS(7554),
    [sym__external_open_parenthesis] = ACTIONS(7554),
    [sym__external_open_brace] = ACTIONS(7554),
    [sym__external_open_bracket] = ACTIONS(7554),
    [sym__external_open_bracket2] = ACTIONS(7554),
    [sym__external_close_bracket2] = ACTIONS(7554),
  },
  [2989] = {
    [sym_identifier] = ACTIONS(7474),
    [anon_sym_BSLASH] = ACTIONS(7472),
    [anon_sym_function] = ACTIONS(7474),
    [anon_sym_EQ] = ACTIONS(7474),
    [anon_sym_if] = ACTIONS(7474),
    [anon_sym_for] = ACTIONS(7474),
    [anon_sym_while] = ACTIONS(7474),
    [anon_sym_repeat] = ACTIONS(7474),
    [anon_sym_QMARK] = ACTIONS(7472),
    [anon_sym_TILDE] = ACTIONS(7472),
    [anon_sym_BANG] = ACTIONS(7474),
    [anon_sym_PLUS] = ACTIONS(7472),
    [anon_sym_DASH] = ACTIONS(7474),
    [anon_sym_LT_DASH] = ACTIONS(7472),
    [anon_sym_LT_LT_DASH] = ACTIONS(7472),
    [anon_sym_COLON_EQ] = ACTIONS(7472),
    [anon_sym_DASH_GT] = ACTIONS(7474),
    [anon_sym_DASH_GT_GT] = ACTIONS(7472),
    [anon_sym_PIPE] = ACTIONS(7474),
    [anon_sym_AMP] = ACTIONS(7474),
    [anon_sym_PIPE_PIPE] = ACTIONS(7472),
    [anon_sym_AMP_AMP] = ACTIONS(7472),
    [anon_sym_LT] = ACTIONS(7474),
    [anon_sym_LT_EQ] = ACTIONS(7472),
    [anon_sym_GT] = ACTIONS(7474),
    [anon_sym_GT_EQ] = ACTIONS(7472),
    [anon_sym_EQ_EQ] = ACTIONS(7472),
    [anon_sym_BANG_EQ] = ACTIONS(7472),
    [anon_sym_STAR] = ACTIONS(7474),
    [anon_sym_SLASH] = ACTIONS(7472),
    [anon_sym_STAR_STAR] = ACTIONS(7472),
    [anon_sym_CARET] = ACTIONS(7472),
    [aux_sym_binary_operator_token1] = ACTIONS(7472),
    [anon_sym_PIPE_GT] = ACTIONS(7472),
    [anon_sym_COLON] = ACTIONS(7474),
    [anon_sym_DOLLAR] = ACTIONS(7472),
    [anon_sym_AT] = ACTIONS(7472),
    [aux_sym__hex_literal_token1] = ACTIONS(7472),
    [sym__number_literal] = ACTIONS(7474),
    [anon_sym_SQUOTE] = ACTIONS(7472),
    [anon_sym_DQUOTE] = ACTIONS(7472),
    [sym_return] = ACTIONS(7474),
    [sym_next] = ACTIONS(7474),
    [sym_break] = ACTIONS(7474),
    [sym_true] = ACTIONS(7474),
    [sym_false] = ACTIONS(7474),
    [sym_null] = ACTIONS(7474),
    [sym_inf] = ACTIONS(7474),
    [sym_nan] = ACTIONS(7474),
    [anon_sym_NA] = ACTIONS(7474),
    [anon_sym_NA_integer_] = ACTIONS(7474),
    [anon_sym_NA_real_] = ACTIONS(7474),
    [anon_sym_NA_complex_] = ACTIONS(7474),
    [anon_sym_NA_character_] = ACTIONS(7474),
    [sym_dots] = ACTIONS(7474),
    [sym_dot_dot_i] = ACTIONS(7472),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7472),
    [sym__newline] = ACTIONS(7472),
    [sym__raw_string_literal] = ACTIONS(7472),
    [sym__external_open_parenthesis] = ACTIONS(7472),
    [sym__external_open_brace] = ACTIONS(7472),
    [sym__external_open_bracket] = ACTIONS(7472),
    [sym__external_close_bracket] = ACTIONS(7472),
    [sym__external_open_bracket2] = ACTIONS(7472),
  },
  [2990] = {
    [sym_identifier] = ACTIONS(7464),
    [anon_sym_BSLASH] = ACTIONS(7466),
    [anon_sym_function] = ACTIONS(7464),
    [anon_sym_EQ] = ACTIONS(7464),
    [anon_sym_if] = ACTIONS(7464),
    [anon_sym_for] = ACTIONS(7464),
    [anon_sym_while] = ACTIONS(7464),
    [anon_sym_repeat] = ACTIONS(7464),
    [anon_sym_QMARK] = ACTIONS(7466),
    [anon_sym_TILDE] = ACTIONS(7466),
    [anon_sym_BANG] = ACTIONS(7464),
    [anon_sym_PLUS] = ACTIONS(7466),
    [anon_sym_DASH] = ACTIONS(7464),
    [anon_sym_LT_DASH] = ACTIONS(7466),
    [anon_sym_LT_LT_DASH] = ACTIONS(7466),
    [anon_sym_COLON_EQ] = ACTIONS(7466),
    [anon_sym_DASH_GT] = ACTIONS(7464),
    [anon_sym_DASH_GT_GT] = ACTIONS(7466),
    [anon_sym_PIPE] = ACTIONS(7464),
    [anon_sym_AMP] = ACTIONS(7464),
    [anon_sym_PIPE_PIPE] = ACTIONS(7466),
    [anon_sym_AMP_AMP] = ACTIONS(7466),
    [anon_sym_LT] = ACTIONS(7464),
    [anon_sym_LT_EQ] = ACTIONS(7466),
    [anon_sym_GT] = ACTIONS(7464),
    [anon_sym_GT_EQ] = ACTIONS(7466),
    [anon_sym_EQ_EQ] = ACTIONS(7466),
    [anon_sym_BANG_EQ] = ACTIONS(7466),
    [anon_sym_STAR] = ACTIONS(7464),
    [anon_sym_SLASH] = ACTIONS(7466),
    [anon_sym_STAR_STAR] = ACTIONS(7466),
    [anon_sym_CARET] = ACTIONS(7466),
    [aux_sym_binary_operator_token1] = ACTIONS(7466),
    [anon_sym_PIPE_GT] = ACTIONS(7466),
    [anon_sym_COLON] = ACTIONS(7464),
    [anon_sym_DOLLAR] = ACTIONS(7466),
    [anon_sym_AT] = ACTIONS(7466),
    [aux_sym__hex_literal_token1] = ACTIONS(7466),
    [sym__number_literal] = ACTIONS(7464),
    [anon_sym_SQUOTE] = ACTIONS(7466),
    [anon_sym_DQUOTE] = ACTIONS(7466),
    [sym_return] = ACTIONS(7464),
    [sym_next] = ACTIONS(7464),
    [sym_break] = ACTIONS(7464),
    [sym_true] = ACTIONS(7464),
    [sym_false] = ACTIONS(7464),
    [sym_null] = ACTIONS(7464),
    [sym_inf] = ACTIONS(7464),
    [sym_nan] = ACTIONS(7464),
    [anon_sym_NA] = ACTIONS(7464),
    [anon_sym_NA_integer_] = ACTIONS(7464),
    [anon_sym_NA_real_] = ACTIONS(7464),
    [anon_sym_NA_complex_] = ACTIONS(7464),
    [anon_sym_NA_character_] = ACTIONS(7464),
    [sym_dots] = ACTIONS(7464),
    [sym_dot_dot_i] = ACTIONS(7466),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7466),
    [sym__newline] = ACTIONS(7466),
    [sym__raw_string_literal] = ACTIONS(7466),
    [sym__external_open_parenthesis] = ACTIONS(7466),
    [sym__external_open_brace] = ACTIONS(7466),
    [sym__external_open_bracket] = ACTIONS(7466),
    [sym__external_close_bracket] = ACTIONS(7466),
    [sym__external_open_bracket2] = ACTIONS(7466),
  },
  [2991] = {
    [sym_identifier] = ACTIONS(7478),
    [anon_sym_BSLASH] = ACTIONS(7476),
    [anon_sym_function] = ACTIONS(7478),
    [anon_sym_EQ] = ACTIONS(7478),
    [anon_sym_if] = ACTIONS(7478),
    [anon_sym_for] = ACTIONS(7478),
    [anon_sym_while] = ACTIONS(7478),
    [anon_sym_repeat] = ACTIONS(7478),
    [anon_sym_QMARK] = ACTIONS(7476),
    [anon_sym_TILDE] = ACTIONS(7476),
    [anon_sym_BANG] = ACTIONS(7478),
    [anon_sym_PLUS] = ACTIONS(7476),
    [anon_sym_DASH] = ACTIONS(7478),
    [anon_sym_LT_DASH] = ACTIONS(7476),
    [anon_sym_LT_LT_DASH] = ACTIONS(7476),
    [anon_sym_COLON_EQ] = ACTIONS(7476),
    [anon_sym_DASH_GT] = ACTIONS(7478),
    [anon_sym_DASH_GT_GT] = ACTIONS(7476),
    [anon_sym_PIPE] = ACTIONS(7478),
    [anon_sym_AMP] = ACTIONS(7478),
    [anon_sym_PIPE_PIPE] = ACTIONS(7476),
    [anon_sym_AMP_AMP] = ACTIONS(7476),
    [anon_sym_LT] = ACTIONS(7478),
    [anon_sym_LT_EQ] = ACTIONS(7476),
    [anon_sym_GT] = ACTIONS(7478),
    [anon_sym_GT_EQ] = ACTIONS(7476),
    [anon_sym_EQ_EQ] = ACTIONS(7476),
    [anon_sym_BANG_EQ] = ACTIONS(7476),
    [anon_sym_STAR] = ACTIONS(7478),
    [anon_sym_SLASH] = ACTIONS(7476),
    [anon_sym_STAR_STAR] = ACTIONS(7476),
    [anon_sym_CARET] = ACTIONS(7476),
    [aux_sym_binary_operator_token1] = ACTIONS(7476),
    [anon_sym_PIPE_GT] = ACTIONS(7476),
    [anon_sym_COLON] = ACTIONS(7478),
    [anon_sym_DOLLAR] = ACTIONS(7476),
    [anon_sym_AT] = ACTIONS(7476),
    [aux_sym__hex_literal_token1] = ACTIONS(7476),
    [sym__number_literal] = ACTIONS(7478),
    [anon_sym_SQUOTE] = ACTIONS(7476),
    [anon_sym_DQUOTE] = ACTIONS(7476),
    [sym_return] = ACTIONS(7478),
    [sym_next] = ACTIONS(7478),
    [sym_break] = ACTIONS(7478),
    [sym_true] = ACTIONS(7478),
    [sym_false] = ACTIONS(7478),
    [sym_null] = ACTIONS(7478),
    [sym_inf] = ACTIONS(7478),
    [sym_nan] = ACTIONS(7478),
    [anon_sym_NA] = ACTIONS(7478),
    [anon_sym_NA_integer_] = ACTIONS(7478),
    [anon_sym_NA_real_] = ACTIONS(7478),
    [anon_sym_NA_complex_] = ACTIONS(7478),
    [anon_sym_NA_character_] = ACTIONS(7478),
    [sym_dots] = ACTIONS(7478),
    [sym_dot_dot_i] = ACTIONS(7476),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7476),
    [sym__newline] = ACTIONS(7476),
    [sym__raw_string_literal] = ACTIONS(7476),
    [sym__external_open_parenthesis] = ACTIONS(7476),
    [sym__external_open_brace] = ACTIONS(7476),
    [sym__external_open_bracket] = ACTIONS(7476),
    [sym__external_close_bracket] = ACTIONS(7476),
    [sym__external_open_bracket2] = ACTIONS(7476),
  },
  [2992] = {
    [ts_builtin_sym_end] = ACTIONS(7554),
    [sym_identifier] = ACTIONS(7556),
    [anon_sym_BSLASH] = ACTIONS(7554),
    [anon_sym_function] = ACTIONS(7556),
    [anon_sym_EQ] = ACTIONS(7556),
    [anon_sym_if] = ACTIONS(7556),
    [anon_sym_for] = ACTIONS(7556),
    [anon_sym_while] = ACTIONS(7556),
    [anon_sym_repeat] = ACTIONS(7556),
    [anon_sym_QMARK] = ACTIONS(7554),
    [anon_sym_TILDE] = ACTIONS(7554),
    [anon_sym_BANG] = ACTIONS(7556),
    [anon_sym_PLUS] = ACTIONS(7554),
    [anon_sym_DASH] = ACTIONS(7556),
    [anon_sym_LT_DASH] = ACTIONS(7554),
    [anon_sym_LT_LT_DASH] = ACTIONS(7554),
    [anon_sym_COLON_EQ] = ACTIONS(7554),
    [anon_sym_DASH_GT] = ACTIONS(7556),
    [anon_sym_DASH_GT_GT] = ACTIONS(7554),
    [anon_sym_PIPE] = ACTIONS(7556),
    [anon_sym_AMP] = ACTIONS(7556),
    [anon_sym_PIPE_PIPE] = ACTIONS(7554),
    [anon_sym_AMP_AMP] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(7556),
    [anon_sym_LT_EQ] = ACTIONS(7554),
    [anon_sym_GT] = ACTIONS(7556),
    [anon_sym_GT_EQ] = ACTIONS(7554),
    [anon_sym_EQ_EQ] = ACTIONS(7554),
    [anon_sym_BANG_EQ] = ACTIONS(7554),
    [anon_sym_STAR] = ACTIONS(7556),
    [anon_sym_SLASH] = ACTIONS(7554),
    [anon_sym_STAR_STAR] = ACTIONS(7554),
    [anon_sym_CARET] = ACTIONS(7554),
    [aux_sym_binary_operator_token1] = ACTIONS(7554),
    [anon_sym_PIPE_GT] = ACTIONS(7554),
    [anon_sym_COLON] = ACTIONS(7556),
    [anon_sym_DOLLAR] = ACTIONS(7554),
    [anon_sym_AT] = ACTIONS(7554),
    [aux_sym__hex_literal_token1] = ACTIONS(7554),
    [sym__number_literal] = ACTIONS(7556),
    [anon_sym_SQUOTE] = ACTIONS(7554),
    [anon_sym_DQUOTE] = ACTIONS(7554),
    [sym_return] = ACTIONS(7556),
    [sym_next] = ACTIONS(7556),
    [sym_break] = ACTIONS(7556),
    [sym_true] = ACTIONS(7556),
    [sym_false] = ACTIONS(7556),
    [sym_null] = ACTIONS(7556),
    [sym_inf] = ACTIONS(7556),
    [sym_nan] = ACTIONS(7556),
    [anon_sym_NA] = ACTIONS(7556),
    [anon_sym_NA_integer_] = ACTIONS(7556),
    [anon_sym_NA_real_] = ACTIONS(7556),
    [anon_sym_NA_complex_] = ACTIONS(7556),
    [anon_sym_NA_character_] = ACTIONS(7556),
    [sym_dots] = ACTIONS(7556),
    [sym_dot_dot_i] = ACTIONS(7554),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7554),
    [sym__semicolon] = ACTIONS(7554),
    [sym__raw_string_literal] = ACTIONS(7554),
    [sym__external_open_parenthesis] = ACTIONS(7554),
    [sym__external_open_brace] = ACTIONS(7554),
    [sym__external_open_bracket] = ACTIONS(7554),
    [sym__external_open_bracket2] = ACTIONS(7554),
  },
  [2993] = {
    [ts_builtin_sym_end] = ACTIONS(7472),
    [sym_identifier] = ACTIONS(7474),
    [anon_sym_BSLASH] = ACTIONS(7472),
    [anon_sym_function] = ACTIONS(7474),
    [anon_sym_EQ] = ACTIONS(7474),
    [anon_sym_if] = ACTIONS(7474),
    [anon_sym_for] = ACTIONS(7474),
    [anon_sym_while] = ACTIONS(7474),
    [anon_sym_repeat] = ACTIONS(7474),
    [anon_sym_QMARK] = ACTIONS(7472),
    [anon_sym_TILDE] = ACTIONS(7472),
    [anon_sym_BANG] = ACTIONS(7474),
    [anon_sym_PLUS] = ACTIONS(7472),
    [anon_sym_DASH] = ACTIONS(7474),
    [anon_sym_LT_DASH] = ACTIONS(7472),
    [anon_sym_LT_LT_DASH] = ACTIONS(7472),
    [anon_sym_COLON_EQ] = ACTIONS(7472),
    [anon_sym_DASH_GT] = ACTIONS(7474),
    [anon_sym_DASH_GT_GT] = ACTIONS(7472),
    [anon_sym_PIPE] = ACTIONS(7474),
    [anon_sym_AMP] = ACTIONS(7474),
    [anon_sym_PIPE_PIPE] = ACTIONS(7472),
    [anon_sym_AMP_AMP] = ACTIONS(7472),
    [anon_sym_LT] = ACTIONS(7474),
    [anon_sym_LT_EQ] = ACTIONS(7472),
    [anon_sym_GT] = ACTIONS(7474),
    [anon_sym_GT_EQ] = ACTIONS(7472),
    [anon_sym_EQ_EQ] = ACTIONS(7472),
    [anon_sym_BANG_EQ] = ACTIONS(7472),
    [anon_sym_STAR] = ACTIONS(7474),
    [anon_sym_SLASH] = ACTIONS(7472),
    [anon_sym_STAR_STAR] = ACTIONS(7472),
    [anon_sym_CARET] = ACTIONS(7472),
    [aux_sym_binary_operator_token1] = ACTIONS(7472),
    [anon_sym_PIPE_GT] = ACTIONS(7472),
    [anon_sym_COLON] = ACTIONS(7474),
    [anon_sym_DOLLAR] = ACTIONS(7472),
    [anon_sym_AT] = ACTIONS(7472),
    [aux_sym__hex_literal_token1] = ACTIONS(7472),
    [sym__number_literal] = ACTIONS(7474),
    [anon_sym_SQUOTE] = ACTIONS(7472),
    [anon_sym_DQUOTE] = ACTIONS(7472),
    [sym_return] = ACTIONS(7474),
    [sym_next] = ACTIONS(7474),
    [sym_break] = ACTIONS(7474),
    [sym_true] = ACTIONS(7474),
    [sym_false] = ACTIONS(7474),
    [sym_null] = ACTIONS(7474),
    [sym_inf] = ACTIONS(7474),
    [sym_nan] = ACTIONS(7474),
    [anon_sym_NA] = ACTIONS(7474),
    [anon_sym_NA_integer_] = ACTIONS(7474),
    [anon_sym_NA_real_] = ACTIONS(7474),
    [anon_sym_NA_complex_] = ACTIONS(7474),
    [anon_sym_NA_character_] = ACTIONS(7474),
    [sym_dots] = ACTIONS(7474),
    [sym_dot_dot_i] = ACTIONS(7472),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7472),
    [sym__semicolon] = ACTIONS(7472),
    [sym__raw_string_literal] = ACTIONS(7472),
    [sym__external_open_parenthesis] = ACTIONS(7472),
    [sym__external_open_brace] = ACTIONS(7472),
    [sym__external_open_bracket] = ACTIONS(7472),
    [sym__external_open_bracket2] = ACTIONS(7472),
  },
  [2994] = {
    [ts_builtin_sym_end] = ACTIONS(7466),
    [sym_identifier] = ACTIONS(7464),
    [anon_sym_BSLASH] = ACTIONS(7466),
    [anon_sym_function] = ACTIONS(7464),
    [anon_sym_EQ] = ACTIONS(7464),
    [anon_sym_if] = ACTIONS(7464),
    [anon_sym_for] = ACTIONS(7464),
    [anon_sym_while] = ACTIONS(7464),
    [anon_sym_repeat] = ACTIONS(7464),
    [anon_sym_QMARK] = ACTIONS(7466),
    [anon_sym_TILDE] = ACTIONS(7466),
    [anon_sym_BANG] = ACTIONS(7464),
    [anon_sym_PLUS] = ACTIONS(7466),
    [anon_sym_DASH] = ACTIONS(7464),
    [anon_sym_LT_DASH] = ACTIONS(7466),
    [anon_sym_LT_LT_DASH] = ACTIONS(7466),
    [anon_sym_COLON_EQ] = ACTIONS(7466),
    [anon_sym_DASH_GT] = ACTIONS(7464),
    [anon_sym_DASH_GT_GT] = ACTIONS(7466),
    [anon_sym_PIPE] = ACTIONS(7464),
    [anon_sym_AMP] = ACTIONS(7464),
    [anon_sym_PIPE_PIPE] = ACTIONS(7466),
    [anon_sym_AMP_AMP] = ACTIONS(7466),
    [anon_sym_LT] = ACTIONS(7464),
    [anon_sym_LT_EQ] = ACTIONS(7466),
    [anon_sym_GT] = ACTIONS(7464),
    [anon_sym_GT_EQ] = ACTIONS(7466),
    [anon_sym_EQ_EQ] = ACTIONS(7466),
    [anon_sym_BANG_EQ] = ACTIONS(7466),
    [anon_sym_STAR] = ACTIONS(7464),
    [anon_sym_SLASH] = ACTIONS(7466),
    [anon_sym_STAR_STAR] = ACTIONS(7466),
    [anon_sym_CARET] = ACTIONS(7466),
    [aux_sym_binary_operator_token1] = ACTIONS(7466),
    [anon_sym_PIPE_GT] = ACTIONS(7466),
    [anon_sym_COLON] = ACTIONS(7464),
    [anon_sym_DOLLAR] = ACTIONS(7466),
    [anon_sym_AT] = ACTIONS(7466),
    [aux_sym__hex_literal_token1] = ACTIONS(7466),
    [sym__number_literal] = ACTIONS(7464),
    [anon_sym_SQUOTE] = ACTIONS(7466),
    [anon_sym_DQUOTE] = ACTIONS(7466),
    [sym_return] = ACTIONS(7464),
    [sym_next] = ACTIONS(7464),
    [sym_break] = ACTIONS(7464),
    [sym_true] = ACTIONS(7464),
    [sym_false] = ACTIONS(7464),
    [sym_null] = ACTIONS(7464),
    [sym_inf] = ACTIONS(7464),
    [sym_nan] = ACTIONS(7464),
    [anon_sym_NA] = ACTIONS(7464),
    [anon_sym_NA_integer_] = ACTIONS(7464),
    [anon_sym_NA_real_] = ACTIONS(7464),
    [anon_sym_NA_complex_] = ACTIONS(7464),
    [anon_sym_NA_character_] = ACTIONS(7464),
    [sym_dots] = ACTIONS(7464),
    [sym_dot_dot_i] = ACTIONS(7466),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7466),
    [sym__semicolon] = ACTIONS(7466),
    [sym__raw_string_literal] = ACTIONS(7466),
    [sym__external_open_parenthesis] = ACTIONS(7466),
    [sym__external_open_brace] = ACTIONS(7466),
    [sym__external_open_bracket] = ACTIONS(7466),
    [sym__external_open_bracket2] = ACTIONS(7466),
  },
  [2995] = {
    [sym_identifier] = ACTIONS(7482),
    [anon_sym_BSLASH] = ACTIONS(7480),
    [anon_sym_function] = ACTIONS(7482),
    [anon_sym_EQ] = ACTIONS(7482),
    [anon_sym_if] = ACTIONS(7482),
    [anon_sym_for] = ACTIONS(7482),
    [anon_sym_while] = ACTIONS(7482),
    [anon_sym_repeat] = ACTIONS(7482),
    [anon_sym_QMARK] = ACTIONS(7480),
    [anon_sym_TILDE] = ACTIONS(7480),
    [anon_sym_BANG] = ACTIONS(7482),
    [anon_sym_PLUS] = ACTIONS(7480),
    [anon_sym_DASH] = ACTIONS(7482),
    [anon_sym_LT_DASH] = ACTIONS(7480),
    [anon_sym_LT_LT_DASH] = ACTIONS(7480),
    [anon_sym_COLON_EQ] = ACTIONS(7480),
    [anon_sym_DASH_GT] = ACTIONS(7482),
    [anon_sym_DASH_GT_GT] = ACTIONS(7480),
    [anon_sym_PIPE] = ACTIONS(7482),
    [anon_sym_AMP] = ACTIONS(7482),
    [anon_sym_PIPE_PIPE] = ACTIONS(7480),
    [anon_sym_AMP_AMP] = ACTIONS(7480),
    [anon_sym_LT] = ACTIONS(7482),
    [anon_sym_LT_EQ] = ACTIONS(7480),
    [anon_sym_GT] = ACTIONS(7482),
    [anon_sym_GT_EQ] = ACTIONS(7480),
    [anon_sym_EQ_EQ] = ACTIONS(7480),
    [anon_sym_BANG_EQ] = ACTIONS(7480),
    [anon_sym_STAR] = ACTIONS(7482),
    [anon_sym_SLASH] = ACTIONS(7480),
    [anon_sym_STAR_STAR] = ACTIONS(7480),
    [anon_sym_CARET] = ACTIONS(7480),
    [aux_sym_binary_operator_token1] = ACTIONS(7480),
    [anon_sym_PIPE_GT] = ACTIONS(7480),
    [anon_sym_COLON] = ACTIONS(7482),
    [anon_sym_DOLLAR] = ACTIONS(7480),
    [anon_sym_AT] = ACTIONS(7480),
    [aux_sym__hex_literal_token1] = ACTIONS(7480),
    [sym__number_literal] = ACTIONS(7482),
    [anon_sym_SQUOTE] = ACTIONS(7480),
    [anon_sym_DQUOTE] = ACTIONS(7480),
    [sym_return] = ACTIONS(7482),
    [sym_next] = ACTIONS(7482),
    [sym_break] = ACTIONS(7482),
    [sym_true] = ACTIONS(7482),
    [sym_false] = ACTIONS(7482),
    [sym_null] = ACTIONS(7482),
    [sym_inf] = ACTIONS(7482),
    [sym_nan] = ACTIONS(7482),
    [anon_sym_NA] = ACTIONS(7482),
    [anon_sym_NA_integer_] = ACTIONS(7482),
    [anon_sym_NA_real_] = ACTIONS(7482),
    [anon_sym_NA_complex_] = ACTIONS(7482),
    [anon_sym_NA_character_] = ACTIONS(7482),
    [sym_dots] = ACTIONS(7482),
    [sym_dot_dot_i] = ACTIONS(7480),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7480),
    [sym__newline] = ACTIONS(7480),
    [sym__raw_string_literal] = ACTIONS(7480),
    [sym__external_open_parenthesis] = ACTIONS(7480),
    [sym__external_open_brace] = ACTIONS(7480),
    [sym__external_open_bracket] = ACTIONS(7480),
    [sym__external_close_bracket] = ACTIONS(7480),
    [sym__external_open_bracket2] = ACTIONS(7480),
  },
  [2996] = {
    [ts_builtin_sym_end] = ACTIONS(7476),
    [sym_identifier] = ACTIONS(7478),
    [anon_sym_BSLASH] = ACTIONS(7476),
    [anon_sym_function] = ACTIONS(7478),
    [anon_sym_EQ] = ACTIONS(7478),
    [anon_sym_if] = ACTIONS(7478),
    [anon_sym_for] = ACTIONS(7478),
    [anon_sym_while] = ACTIONS(7478),
    [anon_sym_repeat] = ACTIONS(7478),
    [anon_sym_QMARK] = ACTIONS(7476),
    [anon_sym_TILDE] = ACTIONS(7476),
    [anon_sym_BANG] = ACTIONS(7478),
    [anon_sym_PLUS] = ACTIONS(7476),
    [anon_sym_DASH] = ACTIONS(7478),
    [anon_sym_LT_DASH] = ACTIONS(7476),
    [anon_sym_LT_LT_DASH] = ACTIONS(7476),
    [anon_sym_COLON_EQ] = ACTIONS(7476),
    [anon_sym_DASH_GT] = ACTIONS(7478),
    [anon_sym_DASH_GT_GT] = ACTIONS(7476),
    [anon_sym_PIPE] = ACTIONS(7478),
    [anon_sym_AMP] = ACTIONS(7478),
    [anon_sym_PIPE_PIPE] = ACTIONS(7476),
    [anon_sym_AMP_AMP] = ACTIONS(7476),
    [anon_sym_LT] = ACTIONS(7478),
    [anon_sym_LT_EQ] = ACTIONS(7476),
    [anon_sym_GT] = ACTIONS(7478),
    [anon_sym_GT_EQ] = ACTIONS(7476),
    [anon_sym_EQ_EQ] = ACTIONS(7476),
    [anon_sym_BANG_EQ] = ACTIONS(7476),
    [anon_sym_STAR] = ACTIONS(7478),
    [anon_sym_SLASH] = ACTIONS(7476),
    [anon_sym_STAR_STAR] = ACTIONS(7476),
    [anon_sym_CARET] = ACTIONS(7476),
    [aux_sym_binary_operator_token1] = ACTIONS(7476),
    [anon_sym_PIPE_GT] = ACTIONS(7476),
    [anon_sym_COLON] = ACTIONS(7478),
    [anon_sym_DOLLAR] = ACTIONS(7476),
    [anon_sym_AT] = ACTIONS(7476),
    [aux_sym__hex_literal_token1] = ACTIONS(7476),
    [sym__number_literal] = ACTIONS(7478),
    [anon_sym_SQUOTE] = ACTIONS(7476),
    [anon_sym_DQUOTE] = ACTIONS(7476),
    [sym_return] = ACTIONS(7478),
    [sym_next] = ACTIONS(7478),
    [sym_break] = ACTIONS(7478),
    [sym_true] = ACTIONS(7478),
    [sym_false] = ACTIONS(7478),
    [sym_null] = ACTIONS(7478),
    [sym_inf] = ACTIONS(7478),
    [sym_nan] = ACTIONS(7478),
    [anon_sym_NA] = ACTIONS(7478),
    [anon_sym_NA_integer_] = ACTIONS(7478),
    [anon_sym_NA_real_] = ACTIONS(7478),
    [anon_sym_NA_complex_] = ACTIONS(7478),
    [anon_sym_NA_character_] = ACTIONS(7478),
    [sym_dots] = ACTIONS(7478),
    [sym_dot_dot_i] = ACTIONS(7476),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7476),
    [sym__semicolon] = ACTIONS(7476),
    [sym__raw_string_literal] = ACTIONS(7476),
    [sym__external_open_parenthesis] = ACTIONS(7476),
    [sym__external_open_brace] = ACTIONS(7476),
    [sym__external_open_bracket] = ACTIONS(7476),
    [sym__external_open_bracket2] = ACTIONS(7476),
  },
  [2997] = {
    [ts_builtin_sym_end] = ACTIONS(7480),
    [sym_identifier] = ACTIONS(7482),
    [anon_sym_BSLASH] = ACTIONS(7480),
    [anon_sym_function] = ACTIONS(7482),
    [anon_sym_EQ] = ACTIONS(7482),
    [anon_sym_if] = ACTIONS(7482),
    [anon_sym_for] = ACTIONS(7482),
    [anon_sym_while] = ACTIONS(7482),
    [anon_sym_repeat] = ACTIONS(7482),
    [anon_sym_QMARK] = ACTIONS(7480),
    [anon_sym_TILDE] = ACTIONS(7480),
    [anon_sym_BANG] = ACTIONS(7482),
    [anon_sym_PLUS] = ACTIONS(7480),
    [anon_sym_DASH] = ACTIONS(7482),
    [anon_sym_LT_DASH] = ACTIONS(7480),
    [anon_sym_LT_LT_DASH] = ACTIONS(7480),
    [anon_sym_COLON_EQ] = ACTIONS(7480),
    [anon_sym_DASH_GT] = ACTIONS(7482),
    [anon_sym_DASH_GT_GT] = ACTIONS(7480),
    [anon_sym_PIPE] = ACTIONS(7482),
    [anon_sym_AMP] = ACTIONS(7482),
    [anon_sym_PIPE_PIPE] = ACTIONS(7480),
    [anon_sym_AMP_AMP] = ACTIONS(7480),
    [anon_sym_LT] = ACTIONS(7482),
    [anon_sym_LT_EQ] = ACTIONS(7480),
    [anon_sym_GT] = ACTIONS(7482),
    [anon_sym_GT_EQ] = ACTIONS(7480),
    [anon_sym_EQ_EQ] = ACTIONS(7480),
    [anon_sym_BANG_EQ] = ACTIONS(7480),
    [anon_sym_STAR] = ACTIONS(7482),
    [anon_sym_SLASH] = ACTIONS(7480),
    [anon_sym_STAR_STAR] = ACTIONS(7480),
    [anon_sym_CARET] = ACTIONS(7480),
    [aux_sym_binary_operator_token1] = ACTIONS(7480),
    [anon_sym_PIPE_GT] = ACTIONS(7480),
    [anon_sym_COLON] = ACTIONS(7482),
    [anon_sym_DOLLAR] = ACTIONS(7480),
    [anon_sym_AT] = ACTIONS(7480),
    [aux_sym__hex_literal_token1] = ACTIONS(7480),
    [sym__number_literal] = ACTIONS(7482),
    [anon_sym_SQUOTE] = ACTIONS(7480),
    [anon_sym_DQUOTE] = ACTIONS(7480),
    [sym_return] = ACTIONS(7482),
    [sym_next] = ACTIONS(7482),
    [sym_break] = ACTIONS(7482),
    [sym_true] = ACTIONS(7482),
    [sym_false] = ACTIONS(7482),
    [sym_null] = ACTIONS(7482),
    [sym_inf] = ACTIONS(7482),
    [sym_nan] = ACTIONS(7482),
    [anon_sym_NA] = ACTIONS(7482),
    [anon_sym_NA_integer_] = ACTIONS(7482),
    [anon_sym_NA_real_] = ACTIONS(7482),
    [anon_sym_NA_complex_] = ACTIONS(7482),
    [anon_sym_NA_character_] = ACTIONS(7482),
    [sym_dots] = ACTIONS(7482),
    [sym_dot_dot_i] = ACTIONS(7480),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7480),
    [sym__semicolon] = ACTIONS(7480),
    [sym__raw_string_literal] = ACTIONS(7480),
    [sym__external_open_parenthesis] = ACTIONS(7480),
    [sym__external_open_brace] = ACTIONS(7480),
    [sym__external_open_bracket] = ACTIONS(7480),
    [sym__external_open_bracket2] = ACTIONS(7480),
  },
  [2998] = {
    [sym_identifier] = ACTIONS(7563),
    [anon_sym_BSLASH] = ACTIONS(7561),
    [anon_sym_function] = ACTIONS(7563),
    [anon_sym_EQ] = ACTIONS(7563),
    [anon_sym_if] = ACTIONS(7563),
    [anon_sym_for] = ACTIONS(7563),
    [anon_sym_while] = ACTIONS(7563),
    [anon_sym_repeat] = ACTIONS(7563),
    [anon_sym_QMARK] = ACTIONS(7561),
    [anon_sym_TILDE] = ACTIONS(7561),
    [anon_sym_BANG] = ACTIONS(7563),
    [anon_sym_PLUS] = ACTIONS(7561),
    [anon_sym_DASH] = ACTIONS(7563),
    [anon_sym_LT_DASH] = ACTIONS(7561),
    [anon_sym_LT_LT_DASH] = ACTIONS(7561),
    [anon_sym_COLON_EQ] = ACTIONS(7561),
    [anon_sym_DASH_GT] = ACTIONS(7563),
    [anon_sym_DASH_GT_GT] = ACTIONS(7561),
    [anon_sym_PIPE] = ACTIONS(7563),
    [anon_sym_AMP] = ACTIONS(7563),
    [anon_sym_PIPE_PIPE] = ACTIONS(7561),
    [anon_sym_AMP_AMP] = ACTIONS(7561),
    [anon_sym_LT] = ACTIONS(7563),
    [anon_sym_LT_EQ] = ACTIONS(7561),
    [anon_sym_GT] = ACTIONS(7563),
    [anon_sym_GT_EQ] = ACTIONS(7561),
    [anon_sym_EQ_EQ] = ACTIONS(7561),
    [anon_sym_BANG_EQ] = ACTIONS(7561),
    [anon_sym_STAR] = ACTIONS(7563),
    [anon_sym_SLASH] = ACTIONS(7561),
    [anon_sym_STAR_STAR] = ACTIONS(7561),
    [anon_sym_CARET] = ACTIONS(7561),
    [aux_sym_binary_operator_token1] = ACTIONS(7561),
    [anon_sym_PIPE_GT] = ACTIONS(7561),
    [anon_sym_COLON] = ACTIONS(7563),
    [anon_sym_DOLLAR] = ACTIONS(7561),
    [anon_sym_AT] = ACTIONS(7561),
    [aux_sym__hex_literal_token1] = ACTIONS(7561),
    [sym__number_literal] = ACTIONS(7563),
    [anon_sym_SQUOTE] = ACTIONS(7561),
    [anon_sym_DQUOTE] = ACTIONS(7561),
    [sym_return] = ACTIONS(7563),
    [sym_next] = ACTIONS(7563),
    [sym_break] = ACTIONS(7563),
    [sym_true] = ACTIONS(7563),
    [sym_false] = ACTIONS(7563),
    [sym_null] = ACTIONS(7563),
    [sym_inf] = ACTIONS(7563),
    [sym_nan] = ACTIONS(7563),
    [anon_sym_NA] = ACTIONS(7563),
    [anon_sym_NA_integer_] = ACTIONS(7563),
    [anon_sym_NA_real_] = ACTIONS(7563),
    [anon_sym_NA_complex_] = ACTIONS(7563),
    [anon_sym_NA_character_] = ACTIONS(7563),
    [sym_dots] = ACTIONS(7563),
    [sym_dot_dot_i] = ACTIONS(7561),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7561),
    [sym__newline] = ACTIONS(7561),
    [sym__raw_string_literal] = ACTIONS(7561),
    [sym__external_open_parenthesis] = ACTIONS(7561),
    [sym__external_open_brace] = ACTIONS(7561),
    [sym__external_open_bracket] = ACTIONS(7561),
    [sym__external_open_bracket2] = ACTIONS(7561),
    [sym__external_close_bracket2] = ACTIONS(7561),
  },
  [2999] = {
    [sym_identifier] = ACTIONS(7486),
    [anon_sym_BSLASH] = ACTIONS(7484),
    [anon_sym_function] = ACTIONS(7486),
    [anon_sym_EQ] = ACTIONS(7486),
    [anon_sym_if] = ACTIONS(7486),
    [anon_sym_for] = ACTIONS(7486),
    [anon_sym_while] = ACTIONS(7486),
    [anon_sym_repeat] = ACTIONS(7486),
    [anon_sym_QMARK] = ACTIONS(7484),
    [anon_sym_TILDE] = ACTIONS(7484),
    [anon_sym_BANG] = ACTIONS(7486),
    [anon_sym_PLUS] = ACTIONS(7484),
    [anon_sym_DASH] = ACTIONS(7486),
    [anon_sym_LT_DASH] = ACTIONS(7484),
    [anon_sym_LT_LT_DASH] = ACTIONS(7484),
    [anon_sym_COLON_EQ] = ACTIONS(7484),
    [anon_sym_DASH_GT] = ACTIONS(7486),
    [anon_sym_DASH_GT_GT] = ACTIONS(7484),
    [anon_sym_PIPE] = ACTIONS(7486),
    [anon_sym_AMP] = ACTIONS(7486),
    [anon_sym_PIPE_PIPE] = ACTIONS(7484),
    [anon_sym_AMP_AMP] = ACTIONS(7484),
    [anon_sym_LT] = ACTIONS(7486),
    [anon_sym_LT_EQ] = ACTIONS(7484),
    [anon_sym_GT] = ACTIONS(7486),
    [anon_sym_GT_EQ] = ACTIONS(7484),
    [anon_sym_EQ_EQ] = ACTIONS(7484),
    [anon_sym_BANG_EQ] = ACTIONS(7484),
    [anon_sym_STAR] = ACTIONS(7486),
    [anon_sym_SLASH] = ACTIONS(7484),
    [anon_sym_STAR_STAR] = ACTIONS(7484),
    [anon_sym_CARET] = ACTIONS(7484),
    [aux_sym_binary_operator_token1] = ACTIONS(7484),
    [anon_sym_PIPE_GT] = ACTIONS(7484),
    [anon_sym_COLON] = ACTIONS(7486),
    [anon_sym_DOLLAR] = ACTIONS(7484),
    [anon_sym_AT] = ACTIONS(7484),
    [aux_sym__hex_literal_token1] = ACTIONS(7484),
    [sym__number_literal] = ACTIONS(7486),
    [anon_sym_SQUOTE] = ACTIONS(7484),
    [anon_sym_DQUOTE] = ACTIONS(7484),
    [sym_return] = ACTIONS(7486),
    [sym_next] = ACTIONS(7486),
    [sym_break] = ACTIONS(7486),
    [sym_true] = ACTIONS(7486),
    [sym_false] = ACTIONS(7486),
    [sym_null] = ACTIONS(7486),
    [sym_inf] = ACTIONS(7486),
    [sym_nan] = ACTIONS(7486),
    [anon_sym_NA] = ACTIONS(7486),
    [anon_sym_NA_integer_] = ACTIONS(7486),
    [anon_sym_NA_real_] = ACTIONS(7486),
    [anon_sym_NA_complex_] = ACTIONS(7486),
    [anon_sym_NA_character_] = ACTIONS(7486),
    [sym_dots] = ACTIONS(7486),
    [sym_dot_dot_i] = ACTIONS(7484),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7484),
    [sym__newline] = ACTIONS(7484),
    [sym__raw_string_literal] = ACTIONS(7484),
    [sym__external_open_parenthesis] = ACTIONS(7484),
    [sym__external_open_brace] = ACTIONS(7484),
    [sym__external_open_bracket] = ACTIONS(7484),
    [sym__external_close_bracket] = ACTIONS(7484),
    [sym__external_open_bracket2] = ACTIONS(7484),
  },
  [3000] = {
    [sym_identifier] = ACTIONS(7552),
    [anon_sym_BSLASH] = ACTIONS(7550),
    [anon_sym_function] = ACTIONS(7552),
    [anon_sym_EQ] = ACTIONS(7552),
    [anon_sym_if] = ACTIONS(7552),
    [anon_sym_for] = ACTIONS(7552),
    [anon_sym_while] = ACTIONS(7552),
    [anon_sym_repeat] = ACTIONS(7552),
    [anon_sym_QMARK] = ACTIONS(7550),
    [anon_sym_TILDE] = ACTIONS(7550),
    [anon_sym_BANG] = ACTIONS(7552),
    [anon_sym_PLUS] = ACTIONS(7550),
    [anon_sym_DASH] = ACTIONS(7552),
    [anon_sym_LT_DASH] = ACTIONS(7550),
    [anon_sym_LT_LT_DASH] = ACTIONS(7550),
    [anon_sym_COLON_EQ] = ACTIONS(7550),
    [anon_sym_DASH_GT] = ACTIONS(7552),
    [anon_sym_DASH_GT_GT] = ACTIONS(7550),
    [anon_sym_PIPE] = ACTIONS(7552),
    [anon_sym_AMP] = ACTIONS(7552),
    [anon_sym_PIPE_PIPE] = ACTIONS(7550),
    [anon_sym_AMP_AMP] = ACTIONS(7550),
    [anon_sym_LT] = ACTIONS(7552),
    [anon_sym_LT_EQ] = ACTIONS(7550),
    [anon_sym_GT] = ACTIONS(7552),
    [anon_sym_GT_EQ] = ACTIONS(7550),
    [anon_sym_EQ_EQ] = ACTIONS(7550),
    [anon_sym_BANG_EQ] = ACTIONS(7550),
    [anon_sym_STAR] = ACTIONS(7552),
    [anon_sym_SLASH] = ACTIONS(7550),
    [anon_sym_STAR_STAR] = ACTIONS(7550),
    [anon_sym_CARET] = ACTIONS(7550),
    [aux_sym_binary_operator_token1] = ACTIONS(7550),
    [anon_sym_PIPE_GT] = ACTIONS(7550),
    [anon_sym_COLON] = ACTIONS(7552),
    [anon_sym_DOLLAR] = ACTIONS(7550),
    [anon_sym_AT] = ACTIONS(7550),
    [aux_sym__hex_literal_token1] = ACTIONS(7550),
    [sym__number_literal] = ACTIONS(7552),
    [anon_sym_SQUOTE] = ACTIONS(7550),
    [anon_sym_DQUOTE] = ACTIONS(7550),
    [sym_return] = ACTIONS(7552),
    [sym_next] = ACTIONS(7552),
    [sym_break] = ACTIONS(7552),
    [sym_true] = ACTIONS(7552),
    [sym_false] = ACTIONS(7552),
    [sym_null] = ACTIONS(7552),
    [sym_inf] = ACTIONS(7552),
    [sym_nan] = ACTIONS(7552),
    [anon_sym_NA] = ACTIONS(7552),
    [anon_sym_NA_integer_] = ACTIONS(7552),
    [anon_sym_NA_real_] = ACTIONS(7552),
    [anon_sym_NA_complex_] = ACTIONS(7552),
    [anon_sym_NA_character_] = ACTIONS(7552),
    [sym_dots] = ACTIONS(7552),
    [sym_dot_dot_i] = ACTIONS(7550),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7550),
    [sym__newline] = ACTIONS(7550),
    [sym__raw_string_literal] = ACTIONS(7550),
    [sym__external_open_parenthesis] = ACTIONS(7550),
    [sym__external_open_brace] = ACTIONS(7550),
    [sym__external_open_bracket] = ACTIONS(7550),
    [sym__external_close_bracket] = ACTIONS(7550),
    [sym__external_open_bracket2] = ACTIONS(7550),
  },
  [3001] = {
    [sym_identifier] = ACTIONS(7490),
    [anon_sym_BSLASH] = ACTIONS(7488),
    [anon_sym_function] = ACTIONS(7490),
    [anon_sym_EQ] = ACTIONS(7490),
    [anon_sym_if] = ACTIONS(7490),
    [anon_sym_for] = ACTIONS(7490),
    [anon_sym_while] = ACTIONS(7490),
    [anon_sym_repeat] = ACTIONS(7490),
    [anon_sym_QMARK] = ACTIONS(7488),
    [anon_sym_TILDE] = ACTIONS(7488),
    [anon_sym_BANG] = ACTIONS(7490),
    [anon_sym_PLUS] = ACTIONS(7488),
    [anon_sym_DASH] = ACTIONS(7490),
    [anon_sym_LT_DASH] = ACTIONS(7488),
    [anon_sym_LT_LT_DASH] = ACTIONS(7488),
    [anon_sym_COLON_EQ] = ACTIONS(7488),
    [anon_sym_DASH_GT] = ACTIONS(7490),
    [anon_sym_DASH_GT_GT] = ACTIONS(7488),
    [anon_sym_PIPE] = ACTIONS(7490),
    [anon_sym_AMP] = ACTIONS(7490),
    [anon_sym_PIPE_PIPE] = ACTIONS(7488),
    [anon_sym_AMP_AMP] = ACTIONS(7488),
    [anon_sym_LT] = ACTIONS(7490),
    [anon_sym_LT_EQ] = ACTIONS(7488),
    [anon_sym_GT] = ACTIONS(7490),
    [anon_sym_GT_EQ] = ACTIONS(7488),
    [anon_sym_EQ_EQ] = ACTIONS(7488),
    [anon_sym_BANG_EQ] = ACTIONS(7488),
    [anon_sym_STAR] = ACTIONS(7490),
    [anon_sym_SLASH] = ACTIONS(7488),
    [anon_sym_STAR_STAR] = ACTIONS(7488),
    [anon_sym_CARET] = ACTIONS(7488),
    [aux_sym_binary_operator_token1] = ACTIONS(7488),
    [anon_sym_PIPE_GT] = ACTIONS(7488),
    [anon_sym_COLON] = ACTIONS(7490),
    [anon_sym_DOLLAR] = ACTIONS(7488),
    [anon_sym_AT] = ACTIONS(7488),
    [aux_sym__hex_literal_token1] = ACTIONS(7488),
    [sym__number_literal] = ACTIONS(7490),
    [anon_sym_SQUOTE] = ACTIONS(7488),
    [anon_sym_DQUOTE] = ACTIONS(7488),
    [sym_return] = ACTIONS(7490),
    [sym_next] = ACTIONS(7490),
    [sym_break] = ACTIONS(7490),
    [sym_true] = ACTIONS(7490),
    [sym_false] = ACTIONS(7490),
    [sym_null] = ACTIONS(7490),
    [sym_inf] = ACTIONS(7490),
    [sym_nan] = ACTIONS(7490),
    [anon_sym_NA] = ACTIONS(7490),
    [anon_sym_NA_integer_] = ACTIONS(7490),
    [anon_sym_NA_real_] = ACTIONS(7490),
    [anon_sym_NA_complex_] = ACTIONS(7490),
    [anon_sym_NA_character_] = ACTIONS(7490),
    [sym_dots] = ACTIONS(7490),
    [sym_dot_dot_i] = ACTIONS(7488),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7488),
    [sym__newline] = ACTIONS(7488),
    [sym__raw_string_literal] = ACTIONS(7488),
    [sym__external_open_parenthesis] = ACTIONS(7488),
    [sym__external_open_brace] = ACTIONS(7488),
    [sym__external_open_bracket] = ACTIONS(7488),
    [sym__external_close_bracket] = ACTIONS(7488),
    [sym__external_open_bracket2] = ACTIONS(7488),
  },
  [3002] = {
    [sym_identifier] = ACTIONS(7494),
    [anon_sym_BSLASH] = ACTIONS(7492),
    [anon_sym_function] = ACTIONS(7494),
    [anon_sym_EQ] = ACTIONS(7494),
    [anon_sym_if] = ACTIONS(7494),
    [anon_sym_for] = ACTIONS(7494),
    [anon_sym_while] = ACTIONS(7494),
    [anon_sym_repeat] = ACTIONS(7494),
    [anon_sym_QMARK] = ACTIONS(7492),
    [anon_sym_TILDE] = ACTIONS(7492),
    [anon_sym_BANG] = ACTIONS(7494),
    [anon_sym_PLUS] = ACTIONS(7492),
    [anon_sym_DASH] = ACTIONS(7494),
    [anon_sym_LT_DASH] = ACTIONS(7492),
    [anon_sym_LT_LT_DASH] = ACTIONS(7492),
    [anon_sym_COLON_EQ] = ACTIONS(7492),
    [anon_sym_DASH_GT] = ACTIONS(7494),
    [anon_sym_DASH_GT_GT] = ACTIONS(7492),
    [anon_sym_PIPE] = ACTIONS(7494),
    [anon_sym_AMP] = ACTIONS(7494),
    [anon_sym_PIPE_PIPE] = ACTIONS(7492),
    [anon_sym_AMP_AMP] = ACTIONS(7492),
    [anon_sym_LT] = ACTIONS(7494),
    [anon_sym_LT_EQ] = ACTIONS(7492),
    [anon_sym_GT] = ACTIONS(7494),
    [anon_sym_GT_EQ] = ACTIONS(7492),
    [anon_sym_EQ_EQ] = ACTIONS(7492),
    [anon_sym_BANG_EQ] = ACTIONS(7492),
    [anon_sym_STAR] = ACTIONS(7494),
    [anon_sym_SLASH] = ACTIONS(7492),
    [anon_sym_STAR_STAR] = ACTIONS(7492),
    [anon_sym_CARET] = ACTIONS(7492),
    [aux_sym_binary_operator_token1] = ACTIONS(7492),
    [anon_sym_PIPE_GT] = ACTIONS(7492),
    [anon_sym_COLON] = ACTIONS(7494),
    [anon_sym_DOLLAR] = ACTIONS(7492),
    [anon_sym_AT] = ACTIONS(7492),
    [aux_sym__hex_literal_token1] = ACTIONS(7492),
    [sym__number_literal] = ACTIONS(7494),
    [anon_sym_SQUOTE] = ACTIONS(7492),
    [anon_sym_DQUOTE] = ACTIONS(7492),
    [sym_return] = ACTIONS(7494),
    [sym_next] = ACTIONS(7494),
    [sym_break] = ACTIONS(7494),
    [sym_true] = ACTIONS(7494),
    [sym_false] = ACTIONS(7494),
    [sym_null] = ACTIONS(7494),
    [sym_inf] = ACTIONS(7494),
    [sym_nan] = ACTIONS(7494),
    [anon_sym_NA] = ACTIONS(7494),
    [anon_sym_NA_integer_] = ACTIONS(7494),
    [anon_sym_NA_real_] = ACTIONS(7494),
    [anon_sym_NA_complex_] = ACTIONS(7494),
    [anon_sym_NA_character_] = ACTIONS(7494),
    [sym_dots] = ACTIONS(7494),
    [sym_dot_dot_i] = ACTIONS(7492),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7492),
    [sym__newline] = ACTIONS(7492),
    [sym__raw_string_literal] = ACTIONS(7492),
    [sym__external_open_parenthesis] = ACTIONS(7492),
    [sym__external_open_brace] = ACTIONS(7492),
    [sym__external_open_bracket] = ACTIONS(7492),
    [sym__external_close_bracket] = ACTIONS(7492),
    [sym__external_open_bracket2] = ACTIONS(7492),
  },
  [3003] = {
    [sym_identifier] = ACTIONS(7498),
    [anon_sym_BSLASH] = ACTIONS(7496),
    [anon_sym_function] = ACTIONS(7498),
    [anon_sym_EQ] = ACTIONS(7498),
    [anon_sym_if] = ACTIONS(7498),
    [anon_sym_for] = ACTIONS(7498),
    [anon_sym_while] = ACTIONS(7498),
    [anon_sym_repeat] = ACTIONS(7498),
    [anon_sym_QMARK] = ACTIONS(7496),
    [anon_sym_TILDE] = ACTIONS(7496),
    [anon_sym_BANG] = ACTIONS(7498),
    [anon_sym_PLUS] = ACTIONS(7496),
    [anon_sym_DASH] = ACTIONS(7498),
    [anon_sym_LT_DASH] = ACTIONS(7496),
    [anon_sym_LT_LT_DASH] = ACTIONS(7496),
    [anon_sym_COLON_EQ] = ACTIONS(7496),
    [anon_sym_DASH_GT] = ACTIONS(7498),
    [anon_sym_DASH_GT_GT] = ACTIONS(7496),
    [anon_sym_PIPE] = ACTIONS(7498),
    [anon_sym_AMP] = ACTIONS(7498),
    [anon_sym_PIPE_PIPE] = ACTIONS(7496),
    [anon_sym_AMP_AMP] = ACTIONS(7496),
    [anon_sym_LT] = ACTIONS(7498),
    [anon_sym_LT_EQ] = ACTIONS(7496),
    [anon_sym_GT] = ACTIONS(7498),
    [anon_sym_GT_EQ] = ACTIONS(7496),
    [anon_sym_EQ_EQ] = ACTIONS(7496),
    [anon_sym_BANG_EQ] = ACTIONS(7496),
    [anon_sym_STAR] = ACTIONS(7498),
    [anon_sym_SLASH] = ACTIONS(7496),
    [anon_sym_STAR_STAR] = ACTIONS(7496),
    [anon_sym_CARET] = ACTIONS(7496),
    [aux_sym_binary_operator_token1] = ACTIONS(7496),
    [anon_sym_PIPE_GT] = ACTIONS(7496),
    [anon_sym_COLON] = ACTIONS(7498),
    [anon_sym_DOLLAR] = ACTIONS(7496),
    [anon_sym_AT] = ACTIONS(7496),
    [aux_sym__hex_literal_token1] = ACTIONS(7496),
    [sym__number_literal] = ACTIONS(7498),
    [anon_sym_SQUOTE] = ACTIONS(7496),
    [anon_sym_DQUOTE] = ACTIONS(7496),
    [sym_return] = ACTIONS(7498),
    [sym_next] = ACTIONS(7498),
    [sym_break] = ACTIONS(7498),
    [sym_true] = ACTIONS(7498),
    [sym_false] = ACTIONS(7498),
    [sym_null] = ACTIONS(7498),
    [sym_inf] = ACTIONS(7498),
    [sym_nan] = ACTIONS(7498),
    [anon_sym_NA] = ACTIONS(7498),
    [anon_sym_NA_integer_] = ACTIONS(7498),
    [anon_sym_NA_real_] = ACTIONS(7498),
    [anon_sym_NA_complex_] = ACTIONS(7498),
    [anon_sym_NA_character_] = ACTIONS(7498),
    [sym_dots] = ACTIONS(7498),
    [sym_dot_dot_i] = ACTIONS(7496),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7496),
    [sym__newline] = ACTIONS(7496),
    [sym__raw_string_literal] = ACTIONS(7496),
    [sym__external_open_parenthesis] = ACTIONS(7496),
    [sym__external_open_brace] = ACTIONS(7496),
    [sym__external_open_bracket] = ACTIONS(7496),
    [sym__external_close_bracket] = ACTIONS(7496),
    [sym__external_open_bracket2] = ACTIONS(7496),
  },
  [3004] = {
    [sym_identifier] = ACTIONS(7502),
    [anon_sym_BSLASH] = ACTIONS(7500),
    [anon_sym_function] = ACTIONS(7502),
    [anon_sym_EQ] = ACTIONS(7502),
    [anon_sym_if] = ACTIONS(7502),
    [anon_sym_for] = ACTIONS(7502),
    [anon_sym_while] = ACTIONS(7502),
    [anon_sym_repeat] = ACTIONS(7502),
    [anon_sym_QMARK] = ACTIONS(7500),
    [anon_sym_TILDE] = ACTIONS(7500),
    [anon_sym_BANG] = ACTIONS(7502),
    [anon_sym_PLUS] = ACTIONS(7500),
    [anon_sym_DASH] = ACTIONS(7502),
    [anon_sym_LT_DASH] = ACTIONS(7500),
    [anon_sym_LT_LT_DASH] = ACTIONS(7500),
    [anon_sym_COLON_EQ] = ACTIONS(7500),
    [anon_sym_DASH_GT] = ACTIONS(7502),
    [anon_sym_DASH_GT_GT] = ACTIONS(7500),
    [anon_sym_PIPE] = ACTIONS(7502),
    [anon_sym_AMP] = ACTIONS(7502),
    [anon_sym_PIPE_PIPE] = ACTIONS(7500),
    [anon_sym_AMP_AMP] = ACTIONS(7500),
    [anon_sym_LT] = ACTIONS(7502),
    [anon_sym_LT_EQ] = ACTIONS(7500),
    [anon_sym_GT] = ACTIONS(7502),
    [anon_sym_GT_EQ] = ACTIONS(7500),
    [anon_sym_EQ_EQ] = ACTIONS(7500),
    [anon_sym_BANG_EQ] = ACTIONS(7500),
    [anon_sym_STAR] = ACTIONS(7502),
    [anon_sym_SLASH] = ACTIONS(7500),
    [anon_sym_STAR_STAR] = ACTIONS(7500),
    [anon_sym_CARET] = ACTIONS(7500),
    [aux_sym_binary_operator_token1] = ACTIONS(7500),
    [anon_sym_PIPE_GT] = ACTIONS(7500),
    [anon_sym_COLON] = ACTIONS(7502),
    [anon_sym_DOLLAR] = ACTIONS(7500),
    [anon_sym_AT] = ACTIONS(7500),
    [aux_sym__hex_literal_token1] = ACTIONS(7500),
    [sym__number_literal] = ACTIONS(7502),
    [anon_sym_SQUOTE] = ACTIONS(7500),
    [anon_sym_DQUOTE] = ACTIONS(7500),
    [sym_return] = ACTIONS(7502),
    [sym_next] = ACTIONS(7502),
    [sym_break] = ACTIONS(7502),
    [sym_true] = ACTIONS(7502),
    [sym_false] = ACTIONS(7502),
    [sym_null] = ACTIONS(7502),
    [sym_inf] = ACTIONS(7502),
    [sym_nan] = ACTIONS(7502),
    [anon_sym_NA] = ACTIONS(7502),
    [anon_sym_NA_integer_] = ACTIONS(7502),
    [anon_sym_NA_real_] = ACTIONS(7502),
    [anon_sym_NA_complex_] = ACTIONS(7502),
    [anon_sym_NA_character_] = ACTIONS(7502),
    [sym_dots] = ACTIONS(7502),
    [sym_dot_dot_i] = ACTIONS(7500),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7500),
    [sym__newline] = ACTIONS(7500),
    [sym__raw_string_literal] = ACTIONS(7500),
    [sym__external_open_parenthesis] = ACTIONS(7500),
    [sym__external_open_brace] = ACTIONS(7500),
    [sym__external_open_bracket] = ACTIONS(7500),
    [sym__external_close_bracket] = ACTIONS(7500),
    [sym__external_open_bracket2] = ACTIONS(7500),
  },
  [3005] = {
    [sym_identifier] = ACTIONS(7506),
    [anon_sym_BSLASH] = ACTIONS(7504),
    [anon_sym_function] = ACTIONS(7506),
    [anon_sym_EQ] = ACTIONS(7506),
    [anon_sym_if] = ACTIONS(7506),
    [anon_sym_for] = ACTIONS(7506),
    [anon_sym_while] = ACTIONS(7506),
    [anon_sym_repeat] = ACTIONS(7506),
    [anon_sym_QMARK] = ACTIONS(7504),
    [anon_sym_TILDE] = ACTIONS(7504),
    [anon_sym_BANG] = ACTIONS(7506),
    [anon_sym_PLUS] = ACTIONS(7504),
    [anon_sym_DASH] = ACTIONS(7506),
    [anon_sym_LT_DASH] = ACTIONS(7504),
    [anon_sym_LT_LT_DASH] = ACTIONS(7504),
    [anon_sym_COLON_EQ] = ACTIONS(7504),
    [anon_sym_DASH_GT] = ACTIONS(7506),
    [anon_sym_DASH_GT_GT] = ACTIONS(7504),
    [anon_sym_PIPE] = ACTIONS(7506),
    [anon_sym_AMP] = ACTIONS(7506),
    [anon_sym_PIPE_PIPE] = ACTIONS(7504),
    [anon_sym_AMP_AMP] = ACTIONS(7504),
    [anon_sym_LT] = ACTIONS(7506),
    [anon_sym_LT_EQ] = ACTIONS(7504),
    [anon_sym_GT] = ACTIONS(7506),
    [anon_sym_GT_EQ] = ACTIONS(7504),
    [anon_sym_EQ_EQ] = ACTIONS(7504),
    [anon_sym_BANG_EQ] = ACTIONS(7504),
    [anon_sym_STAR] = ACTIONS(7506),
    [anon_sym_SLASH] = ACTIONS(7504),
    [anon_sym_STAR_STAR] = ACTIONS(7504),
    [anon_sym_CARET] = ACTIONS(7504),
    [aux_sym_binary_operator_token1] = ACTIONS(7504),
    [anon_sym_PIPE_GT] = ACTIONS(7504),
    [anon_sym_COLON] = ACTIONS(7506),
    [anon_sym_DOLLAR] = ACTIONS(7504),
    [anon_sym_AT] = ACTIONS(7504),
    [aux_sym__hex_literal_token1] = ACTIONS(7504),
    [sym__number_literal] = ACTIONS(7506),
    [anon_sym_SQUOTE] = ACTIONS(7504),
    [anon_sym_DQUOTE] = ACTIONS(7504),
    [sym_return] = ACTIONS(7506),
    [sym_next] = ACTIONS(7506),
    [sym_break] = ACTIONS(7506),
    [sym_true] = ACTIONS(7506),
    [sym_false] = ACTIONS(7506),
    [sym_null] = ACTIONS(7506),
    [sym_inf] = ACTIONS(7506),
    [sym_nan] = ACTIONS(7506),
    [anon_sym_NA] = ACTIONS(7506),
    [anon_sym_NA_integer_] = ACTIONS(7506),
    [anon_sym_NA_real_] = ACTIONS(7506),
    [anon_sym_NA_complex_] = ACTIONS(7506),
    [anon_sym_NA_character_] = ACTIONS(7506),
    [sym_dots] = ACTIONS(7506),
    [sym_dot_dot_i] = ACTIONS(7504),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7504),
    [sym__newline] = ACTIONS(7504),
    [sym__raw_string_literal] = ACTIONS(7504),
    [sym__external_open_parenthesis] = ACTIONS(7504),
    [sym__external_open_brace] = ACTIONS(7504),
    [sym__external_open_bracket] = ACTIONS(7504),
    [sym__external_close_bracket] = ACTIONS(7504),
    [sym__external_open_bracket2] = ACTIONS(7504),
  },
  [3006] = {
    [sym_identifier] = ACTIONS(7512),
    [anon_sym_BSLASH] = ACTIONS(7510),
    [anon_sym_function] = ACTIONS(7512),
    [anon_sym_EQ] = ACTIONS(7512),
    [anon_sym_if] = ACTIONS(7512),
    [anon_sym_for] = ACTIONS(7512),
    [anon_sym_while] = ACTIONS(7512),
    [anon_sym_repeat] = ACTIONS(7512),
    [anon_sym_QMARK] = ACTIONS(7510),
    [anon_sym_TILDE] = ACTIONS(7510),
    [anon_sym_BANG] = ACTIONS(7512),
    [anon_sym_PLUS] = ACTIONS(7510),
    [anon_sym_DASH] = ACTIONS(7512),
    [anon_sym_LT_DASH] = ACTIONS(7510),
    [anon_sym_LT_LT_DASH] = ACTIONS(7510),
    [anon_sym_COLON_EQ] = ACTIONS(7510),
    [anon_sym_DASH_GT] = ACTIONS(7512),
    [anon_sym_DASH_GT_GT] = ACTIONS(7510),
    [anon_sym_PIPE] = ACTIONS(7512),
    [anon_sym_AMP] = ACTIONS(7512),
    [anon_sym_PIPE_PIPE] = ACTIONS(7510),
    [anon_sym_AMP_AMP] = ACTIONS(7510),
    [anon_sym_LT] = ACTIONS(7512),
    [anon_sym_LT_EQ] = ACTIONS(7510),
    [anon_sym_GT] = ACTIONS(7512),
    [anon_sym_GT_EQ] = ACTIONS(7510),
    [anon_sym_EQ_EQ] = ACTIONS(7510),
    [anon_sym_BANG_EQ] = ACTIONS(7510),
    [anon_sym_STAR] = ACTIONS(7512),
    [anon_sym_SLASH] = ACTIONS(7510),
    [anon_sym_STAR_STAR] = ACTIONS(7510),
    [anon_sym_CARET] = ACTIONS(7510),
    [aux_sym_binary_operator_token1] = ACTIONS(7510),
    [anon_sym_PIPE_GT] = ACTIONS(7510),
    [anon_sym_COLON] = ACTIONS(7512),
    [anon_sym_DOLLAR] = ACTIONS(7510),
    [anon_sym_AT] = ACTIONS(7510),
    [aux_sym__hex_literal_token1] = ACTIONS(7510),
    [sym__number_literal] = ACTIONS(7512),
    [anon_sym_SQUOTE] = ACTIONS(7510),
    [anon_sym_DQUOTE] = ACTIONS(7510),
    [sym_return] = ACTIONS(7512),
    [sym_next] = ACTIONS(7512),
    [sym_break] = ACTIONS(7512),
    [sym_true] = ACTIONS(7512),
    [sym_false] = ACTIONS(7512),
    [sym_null] = ACTIONS(7512),
    [sym_inf] = ACTIONS(7512),
    [sym_nan] = ACTIONS(7512),
    [anon_sym_NA] = ACTIONS(7512),
    [anon_sym_NA_integer_] = ACTIONS(7512),
    [anon_sym_NA_real_] = ACTIONS(7512),
    [anon_sym_NA_complex_] = ACTIONS(7512),
    [anon_sym_NA_character_] = ACTIONS(7512),
    [sym_dots] = ACTIONS(7512),
    [sym_dot_dot_i] = ACTIONS(7510),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7510),
    [sym__newline] = ACTIONS(7510),
    [sym__raw_string_literal] = ACTIONS(7510),
    [sym__external_open_parenthesis] = ACTIONS(7510),
    [sym__external_open_brace] = ACTIONS(7510),
    [sym__external_open_bracket] = ACTIONS(7510),
    [sym__external_close_bracket] = ACTIONS(7510),
    [sym__external_open_bracket2] = ACTIONS(7510),
  },
  [3007] = {
    [ts_builtin_sym_end] = ACTIONS(7561),
    [sym_identifier] = ACTIONS(7563),
    [anon_sym_BSLASH] = ACTIONS(7561),
    [anon_sym_function] = ACTIONS(7563),
    [anon_sym_EQ] = ACTIONS(7563),
    [anon_sym_if] = ACTIONS(7563),
    [anon_sym_for] = ACTIONS(7563),
    [anon_sym_while] = ACTIONS(7563),
    [anon_sym_repeat] = ACTIONS(7563),
    [anon_sym_QMARK] = ACTIONS(7561),
    [anon_sym_TILDE] = ACTIONS(7561),
    [anon_sym_BANG] = ACTIONS(7563),
    [anon_sym_PLUS] = ACTIONS(7561),
    [anon_sym_DASH] = ACTIONS(7563),
    [anon_sym_LT_DASH] = ACTIONS(7561),
    [anon_sym_LT_LT_DASH] = ACTIONS(7561),
    [anon_sym_COLON_EQ] = ACTIONS(7561),
    [anon_sym_DASH_GT] = ACTIONS(7563),
    [anon_sym_DASH_GT_GT] = ACTIONS(7561),
    [anon_sym_PIPE] = ACTIONS(7563),
    [anon_sym_AMP] = ACTIONS(7563),
    [anon_sym_PIPE_PIPE] = ACTIONS(7561),
    [anon_sym_AMP_AMP] = ACTIONS(7561),
    [anon_sym_LT] = ACTIONS(7563),
    [anon_sym_LT_EQ] = ACTIONS(7561),
    [anon_sym_GT] = ACTIONS(7563),
    [anon_sym_GT_EQ] = ACTIONS(7561),
    [anon_sym_EQ_EQ] = ACTIONS(7561),
    [anon_sym_BANG_EQ] = ACTIONS(7561),
    [anon_sym_STAR] = ACTIONS(7563),
    [anon_sym_SLASH] = ACTIONS(7561),
    [anon_sym_STAR_STAR] = ACTIONS(7561),
    [anon_sym_CARET] = ACTIONS(7561),
    [aux_sym_binary_operator_token1] = ACTIONS(7561),
    [anon_sym_PIPE_GT] = ACTIONS(7561),
    [anon_sym_COLON] = ACTIONS(7563),
    [anon_sym_DOLLAR] = ACTIONS(7561),
    [anon_sym_AT] = ACTIONS(7561),
    [aux_sym__hex_literal_token1] = ACTIONS(7561),
    [sym__number_literal] = ACTIONS(7563),
    [anon_sym_SQUOTE] = ACTIONS(7561),
    [anon_sym_DQUOTE] = ACTIONS(7561),
    [sym_return] = ACTIONS(7563),
    [sym_next] = ACTIONS(7563),
    [sym_break] = ACTIONS(7563),
    [sym_true] = ACTIONS(7563),
    [sym_false] = ACTIONS(7563),
    [sym_null] = ACTIONS(7563),
    [sym_inf] = ACTIONS(7563),
    [sym_nan] = ACTIONS(7563),
    [anon_sym_NA] = ACTIONS(7563),
    [anon_sym_NA_integer_] = ACTIONS(7563),
    [anon_sym_NA_real_] = ACTIONS(7563),
    [anon_sym_NA_complex_] = ACTIONS(7563),
    [anon_sym_NA_character_] = ACTIONS(7563),
    [sym_dots] = ACTIONS(7563),
    [sym_dot_dot_i] = ACTIONS(7561),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7561),
    [sym__semicolon] = ACTIONS(7561),
    [sym__raw_string_literal] = ACTIONS(7561),
    [sym__external_open_parenthesis] = ACTIONS(7561),
    [sym__external_open_brace] = ACTIONS(7561),
    [sym__external_open_bracket] = ACTIONS(7561),
    [sym__external_open_bracket2] = ACTIONS(7561),
  },
  [3008] = {
    [ts_builtin_sym_end] = ACTIONS(7484),
    [sym_identifier] = ACTIONS(7486),
    [anon_sym_BSLASH] = ACTIONS(7484),
    [anon_sym_function] = ACTIONS(7486),
    [anon_sym_EQ] = ACTIONS(7486),
    [anon_sym_if] = ACTIONS(7486),
    [anon_sym_for] = ACTIONS(7486),
    [anon_sym_while] = ACTIONS(7486),
    [anon_sym_repeat] = ACTIONS(7486),
    [anon_sym_QMARK] = ACTIONS(7484),
    [anon_sym_TILDE] = ACTIONS(7484),
    [anon_sym_BANG] = ACTIONS(7486),
    [anon_sym_PLUS] = ACTIONS(7484),
    [anon_sym_DASH] = ACTIONS(7486),
    [anon_sym_LT_DASH] = ACTIONS(7484),
    [anon_sym_LT_LT_DASH] = ACTIONS(7484),
    [anon_sym_COLON_EQ] = ACTIONS(7484),
    [anon_sym_DASH_GT] = ACTIONS(7486),
    [anon_sym_DASH_GT_GT] = ACTIONS(7484),
    [anon_sym_PIPE] = ACTIONS(7486),
    [anon_sym_AMP] = ACTIONS(7486),
    [anon_sym_PIPE_PIPE] = ACTIONS(7484),
    [anon_sym_AMP_AMP] = ACTIONS(7484),
    [anon_sym_LT] = ACTIONS(7486),
    [anon_sym_LT_EQ] = ACTIONS(7484),
    [anon_sym_GT] = ACTIONS(7486),
    [anon_sym_GT_EQ] = ACTIONS(7484),
    [anon_sym_EQ_EQ] = ACTIONS(7484),
    [anon_sym_BANG_EQ] = ACTIONS(7484),
    [anon_sym_STAR] = ACTIONS(7486),
    [anon_sym_SLASH] = ACTIONS(7484),
    [anon_sym_STAR_STAR] = ACTIONS(7484),
    [anon_sym_CARET] = ACTIONS(7484),
    [aux_sym_binary_operator_token1] = ACTIONS(7484),
    [anon_sym_PIPE_GT] = ACTIONS(7484),
    [anon_sym_COLON] = ACTIONS(7486),
    [anon_sym_DOLLAR] = ACTIONS(7484),
    [anon_sym_AT] = ACTIONS(7484),
    [aux_sym__hex_literal_token1] = ACTIONS(7484),
    [sym__number_literal] = ACTIONS(7486),
    [anon_sym_SQUOTE] = ACTIONS(7484),
    [anon_sym_DQUOTE] = ACTIONS(7484),
    [sym_return] = ACTIONS(7486),
    [sym_next] = ACTIONS(7486),
    [sym_break] = ACTIONS(7486),
    [sym_true] = ACTIONS(7486),
    [sym_false] = ACTIONS(7486),
    [sym_null] = ACTIONS(7486),
    [sym_inf] = ACTIONS(7486),
    [sym_nan] = ACTIONS(7486),
    [anon_sym_NA] = ACTIONS(7486),
    [anon_sym_NA_integer_] = ACTIONS(7486),
    [anon_sym_NA_real_] = ACTIONS(7486),
    [anon_sym_NA_complex_] = ACTIONS(7486),
    [anon_sym_NA_character_] = ACTIONS(7486),
    [sym_dots] = ACTIONS(7486),
    [sym_dot_dot_i] = ACTIONS(7484),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7484),
    [sym__semicolon] = ACTIONS(7484),
    [sym__raw_string_literal] = ACTIONS(7484),
    [sym__external_open_parenthesis] = ACTIONS(7484),
    [sym__external_open_brace] = ACTIONS(7484),
    [sym__external_open_bracket] = ACTIONS(7484),
    [sym__external_open_bracket2] = ACTIONS(7484),
  },
  [3009] = {
    [ts_builtin_sym_end] = ACTIONS(7488),
    [sym_identifier] = ACTIONS(7490),
    [anon_sym_BSLASH] = ACTIONS(7488),
    [anon_sym_function] = ACTIONS(7490),
    [anon_sym_EQ] = ACTIONS(7490),
    [anon_sym_if] = ACTIONS(7490),
    [anon_sym_for] = ACTIONS(7490),
    [anon_sym_while] = ACTIONS(7490),
    [anon_sym_repeat] = ACTIONS(7490),
    [anon_sym_QMARK] = ACTIONS(7488),
    [anon_sym_TILDE] = ACTIONS(7488),
    [anon_sym_BANG] = ACTIONS(7490),
    [anon_sym_PLUS] = ACTIONS(7488),
    [anon_sym_DASH] = ACTIONS(7490),
    [anon_sym_LT_DASH] = ACTIONS(7488),
    [anon_sym_LT_LT_DASH] = ACTIONS(7488),
    [anon_sym_COLON_EQ] = ACTIONS(7488),
    [anon_sym_DASH_GT] = ACTIONS(7490),
    [anon_sym_DASH_GT_GT] = ACTIONS(7488),
    [anon_sym_PIPE] = ACTIONS(7490),
    [anon_sym_AMP] = ACTIONS(7490),
    [anon_sym_PIPE_PIPE] = ACTIONS(7488),
    [anon_sym_AMP_AMP] = ACTIONS(7488),
    [anon_sym_LT] = ACTIONS(7490),
    [anon_sym_LT_EQ] = ACTIONS(7488),
    [anon_sym_GT] = ACTIONS(7490),
    [anon_sym_GT_EQ] = ACTIONS(7488),
    [anon_sym_EQ_EQ] = ACTIONS(7488),
    [anon_sym_BANG_EQ] = ACTIONS(7488),
    [anon_sym_STAR] = ACTIONS(7490),
    [anon_sym_SLASH] = ACTIONS(7488),
    [anon_sym_STAR_STAR] = ACTIONS(7488),
    [anon_sym_CARET] = ACTIONS(7488),
    [aux_sym_binary_operator_token1] = ACTIONS(7488),
    [anon_sym_PIPE_GT] = ACTIONS(7488),
    [anon_sym_COLON] = ACTIONS(7490),
    [anon_sym_DOLLAR] = ACTIONS(7488),
    [anon_sym_AT] = ACTIONS(7488),
    [aux_sym__hex_literal_token1] = ACTIONS(7488),
    [sym__number_literal] = ACTIONS(7490),
    [anon_sym_SQUOTE] = ACTIONS(7488),
    [anon_sym_DQUOTE] = ACTIONS(7488),
    [sym_return] = ACTIONS(7490),
    [sym_next] = ACTIONS(7490),
    [sym_break] = ACTIONS(7490),
    [sym_true] = ACTIONS(7490),
    [sym_false] = ACTIONS(7490),
    [sym_null] = ACTIONS(7490),
    [sym_inf] = ACTIONS(7490),
    [sym_nan] = ACTIONS(7490),
    [anon_sym_NA] = ACTIONS(7490),
    [anon_sym_NA_integer_] = ACTIONS(7490),
    [anon_sym_NA_real_] = ACTIONS(7490),
    [anon_sym_NA_complex_] = ACTIONS(7490),
    [anon_sym_NA_character_] = ACTIONS(7490),
    [sym_dots] = ACTIONS(7490),
    [sym_dot_dot_i] = ACTIONS(7488),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7488),
    [sym__semicolon] = ACTIONS(7488),
    [sym__raw_string_literal] = ACTIONS(7488),
    [sym__external_open_parenthesis] = ACTIONS(7488),
    [sym__external_open_brace] = ACTIONS(7488),
    [sym__external_open_bracket] = ACTIONS(7488),
    [sym__external_open_bracket2] = ACTIONS(7488),
  },
  [3010] = {
    [ts_builtin_sym_end] = ACTIONS(7492),
    [sym_identifier] = ACTIONS(7494),
    [anon_sym_BSLASH] = ACTIONS(7492),
    [anon_sym_function] = ACTIONS(7494),
    [anon_sym_EQ] = ACTIONS(7494),
    [anon_sym_if] = ACTIONS(7494),
    [anon_sym_for] = ACTIONS(7494),
    [anon_sym_while] = ACTIONS(7494),
    [anon_sym_repeat] = ACTIONS(7494),
    [anon_sym_QMARK] = ACTIONS(7492),
    [anon_sym_TILDE] = ACTIONS(7492),
    [anon_sym_BANG] = ACTIONS(7494),
    [anon_sym_PLUS] = ACTIONS(7492),
    [anon_sym_DASH] = ACTIONS(7494),
    [anon_sym_LT_DASH] = ACTIONS(7492),
    [anon_sym_LT_LT_DASH] = ACTIONS(7492),
    [anon_sym_COLON_EQ] = ACTIONS(7492),
    [anon_sym_DASH_GT] = ACTIONS(7494),
    [anon_sym_DASH_GT_GT] = ACTIONS(7492),
    [anon_sym_PIPE] = ACTIONS(7494),
    [anon_sym_AMP] = ACTIONS(7494),
    [anon_sym_PIPE_PIPE] = ACTIONS(7492),
    [anon_sym_AMP_AMP] = ACTIONS(7492),
    [anon_sym_LT] = ACTIONS(7494),
    [anon_sym_LT_EQ] = ACTIONS(7492),
    [anon_sym_GT] = ACTIONS(7494),
    [anon_sym_GT_EQ] = ACTIONS(7492),
    [anon_sym_EQ_EQ] = ACTIONS(7492),
    [anon_sym_BANG_EQ] = ACTIONS(7492),
    [anon_sym_STAR] = ACTIONS(7494),
    [anon_sym_SLASH] = ACTIONS(7492),
    [anon_sym_STAR_STAR] = ACTIONS(7492),
    [anon_sym_CARET] = ACTIONS(7492),
    [aux_sym_binary_operator_token1] = ACTIONS(7492),
    [anon_sym_PIPE_GT] = ACTIONS(7492),
    [anon_sym_COLON] = ACTIONS(7494),
    [anon_sym_DOLLAR] = ACTIONS(7492),
    [anon_sym_AT] = ACTIONS(7492),
    [aux_sym__hex_literal_token1] = ACTIONS(7492),
    [sym__number_literal] = ACTIONS(7494),
    [anon_sym_SQUOTE] = ACTIONS(7492),
    [anon_sym_DQUOTE] = ACTIONS(7492),
    [sym_return] = ACTIONS(7494),
    [sym_next] = ACTIONS(7494),
    [sym_break] = ACTIONS(7494),
    [sym_true] = ACTIONS(7494),
    [sym_false] = ACTIONS(7494),
    [sym_null] = ACTIONS(7494),
    [sym_inf] = ACTIONS(7494),
    [sym_nan] = ACTIONS(7494),
    [anon_sym_NA] = ACTIONS(7494),
    [anon_sym_NA_integer_] = ACTIONS(7494),
    [anon_sym_NA_real_] = ACTIONS(7494),
    [anon_sym_NA_complex_] = ACTIONS(7494),
    [anon_sym_NA_character_] = ACTIONS(7494),
    [sym_dots] = ACTIONS(7494),
    [sym_dot_dot_i] = ACTIONS(7492),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7492),
    [sym__semicolon] = ACTIONS(7492),
    [sym__raw_string_literal] = ACTIONS(7492),
    [sym__external_open_parenthesis] = ACTIONS(7492),
    [sym__external_open_brace] = ACTIONS(7492),
    [sym__external_open_bracket] = ACTIONS(7492),
    [sym__external_open_bracket2] = ACTIONS(7492),
  },
  [3011] = {
    [ts_builtin_sym_end] = ACTIONS(7496),
    [sym_identifier] = ACTIONS(7498),
    [anon_sym_BSLASH] = ACTIONS(7496),
    [anon_sym_function] = ACTIONS(7498),
    [anon_sym_EQ] = ACTIONS(7498),
    [anon_sym_if] = ACTIONS(7498),
    [anon_sym_for] = ACTIONS(7498),
    [anon_sym_while] = ACTIONS(7498),
    [anon_sym_repeat] = ACTIONS(7498),
    [anon_sym_QMARK] = ACTIONS(7496),
    [anon_sym_TILDE] = ACTIONS(7496),
    [anon_sym_BANG] = ACTIONS(7498),
    [anon_sym_PLUS] = ACTIONS(7496),
    [anon_sym_DASH] = ACTIONS(7498),
    [anon_sym_LT_DASH] = ACTIONS(7496),
    [anon_sym_LT_LT_DASH] = ACTIONS(7496),
    [anon_sym_COLON_EQ] = ACTIONS(7496),
    [anon_sym_DASH_GT] = ACTIONS(7498),
    [anon_sym_DASH_GT_GT] = ACTIONS(7496),
    [anon_sym_PIPE] = ACTIONS(7498),
    [anon_sym_AMP] = ACTIONS(7498),
    [anon_sym_PIPE_PIPE] = ACTIONS(7496),
    [anon_sym_AMP_AMP] = ACTIONS(7496),
    [anon_sym_LT] = ACTIONS(7498),
    [anon_sym_LT_EQ] = ACTIONS(7496),
    [anon_sym_GT] = ACTIONS(7498),
    [anon_sym_GT_EQ] = ACTIONS(7496),
    [anon_sym_EQ_EQ] = ACTIONS(7496),
    [anon_sym_BANG_EQ] = ACTIONS(7496),
    [anon_sym_STAR] = ACTIONS(7498),
    [anon_sym_SLASH] = ACTIONS(7496),
    [anon_sym_STAR_STAR] = ACTIONS(7496),
    [anon_sym_CARET] = ACTIONS(7496),
    [aux_sym_binary_operator_token1] = ACTIONS(7496),
    [anon_sym_PIPE_GT] = ACTIONS(7496),
    [anon_sym_COLON] = ACTIONS(7498),
    [anon_sym_DOLLAR] = ACTIONS(7496),
    [anon_sym_AT] = ACTIONS(7496),
    [aux_sym__hex_literal_token1] = ACTIONS(7496),
    [sym__number_literal] = ACTIONS(7498),
    [anon_sym_SQUOTE] = ACTIONS(7496),
    [anon_sym_DQUOTE] = ACTIONS(7496),
    [sym_return] = ACTIONS(7498),
    [sym_next] = ACTIONS(7498),
    [sym_break] = ACTIONS(7498),
    [sym_true] = ACTIONS(7498),
    [sym_false] = ACTIONS(7498),
    [sym_null] = ACTIONS(7498),
    [sym_inf] = ACTIONS(7498),
    [sym_nan] = ACTIONS(7498),
    [anon_sym_NA] = ACTIONS(7498),
    [anon_sym_NA_integer_] = ACTIONS(7498),
    [anon_sym_NA_real_] = ACTIONS(7498),
    [anon_sym_NA_complex_] = ACTIONS(7498),
    [anon_sym_NA_character_] = ACTIONS(7498),
    [sym_dots] = ACTIONS(7498),
    [sym_dot_dot_i] = ACTIONS(7496),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7496),
    [sym__semicolon] = ACTIONS(7496),
    [sym__raw_string_literal] = ACTIONS(7496),
    [sym__external_open_parenthesis] = ACTIONS(7496),
    [sym__external_open_brace] = ACTIONS(7496),
    [sym__external_open_bracket] = ACTIONS(7496),
    [sym__external_open_bracket2] = ACTIONS(7496),
  },
  [3012] = {
    [ts_builtin_sym_end] = ACTIONS(7500),
    [sym_identifier] = ACTIONS(7502),
    [anon_sym_BSLASH] = ACTIONS(7500),
    [anon_sym_function] = ACTIONS(7502),
    [anon_sym_EQ] = ACTIONS(7502),
    [anon_sym_if] = ACTIONS(7502),
    [anon_sym_for] = ACTIONS(7502),
    [anon_sym_while] = ACTIONS(7502),
    [anon_sym_repeat] = ACTIONS(7502),
    [anon_sym_QMARK] = ACTIONS(7500),
    [anon_sym_TILDE] = ACTIONS(7500),
    [anon_sym_BANG] = ACTIONS(7502),
    [anon_sym_PLUS] = ACTIONS(7500),
    [anon_sym_DASH] = ACTIONS(7502),
    [anon_sym_LT_DASH] = ACTIONS(7500),
    [anon_sym_LT_LT_DASH] = ACTIONS(7500),
    [anon_sym_COLON_EQ] = ACTIONS(7500),
    [anon_sym_DASH_GT] = ACTIONS(7502),
    [anon_sym_DASH_GT_GT] = ACTIONS(7500),
    [anon_sym_PIPE] = ACTIONS(7502),
    [anon_sym_AMP] = ACTIONS(7502),
    [anon_sym_PIPE_PIPE] = ACTIONS(7500),
    [anon_sym_AMP_AMP] = ACTIONS(7500),
    [anon_sym_LT] = ACTIONS(7502),
    [anon_sym_LT_EQ] = ACTIONS(7500),
    [anon_sym_GT] = ACTIONS(7502),
    [anon_sym_GT_EQ] = ACTIONS(7500),
    [anon_sym_EQ_EQ] = ACTIONS(7500),
    [anon_sym_BANG_EQ] = ACTIONS(7500),
    [anon_sym_STAR] = ACTIONS(7502),
    [anon_sym_SLASH] = ACTIONS(7500),
    [anon_sym_STAR_STAR] = ACTIONS(7500),
    [anon_sym_CARET] = ACTIONS(7500),
    [aux_sym_binary_operator_token1] = ACTIONS(7500),
    [anon_sym_PIPE_GT] = ACTIONS(7500),
    [anon_sym_COLON] = ACTIONS(7502),
    [anon_sym_DOLLAR] = ACTIONS(7500),
    [anon_sym_AT] = ACTIONS(7500),
    [aux_sym__hex_literal_token1] = ACTIONS(7500),
    [sym__number_literal] = ACTIONS(7502),
    [anon_sym_SQUOTE] = ACTIONS(7500),
    [anon_sym_DQUOTE] = ACTIONS(7500),
    [sym_return] = ACTIONS(7502),
    [sym_next] = ACTIONS(7502),
    [sym_break] = ACTIONS(7502),
    [sym_true] = ACTIONS(7502),
    [sym_false] = ACTIONS(7502),
    [sym_null] = ACTIONS(7502),
    [sym_inf] = ACTIONS(7502),
    [sym_nan] = ACTIONS(7502),
    [anon_sym_NA] = ACTIONS(7502),
    [anon_sym_NA_integer_] = ACTIONS(7502),
    [anon_sym_NA_real_] = ACTIONS(7502),
    [anon_sym_NA_complex_] = ACTIONS(7502),
    [anon_sym_NA_character_] = ACTIONS(7502),
    [sym_dots] = ACTIONS(7502),
    [sym_dot_dot_i] = ACTIONS(7500),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7500),
    [sym__semicolon] = ACTIONS(7500),
    [sym__raw_string_literal] = ACTIONS(7500),
    [sym__external_open_parenthesis] = ACTIONS(7500),
    [sym__external_open_brace] = ACTIONS(7500),
    [sym__external_open_bracket] = ACTIONS(7500),
    [sym__external_open_bracket2] = ACTIONS(7500),
  },
  [3013] = {
    [ts_builtin_sym_end] = ACTIONS(7504),
    [sym_identifier] = ACTIONS(7506),
    [anon_sym_BSLASH] = ACTIONS(7504),
    [anon_sym_function] = ACTIONS(7506),
    [anon_sym_EQ] = ACTIONS(7506),
    [anon_sym_if] = ACTIONS(7506),
    [anon_sym_for] = ACTIONS(7506),
    [anon_sym_while] = ACTIONS(7506),
    [anon_sym_repeat] = ACTIONS(7506),
    [anon_sym_QMARK] = ACTIONS(7504),
    [anon_sym_TILDE] = ACTIONS(7504),
    [anon_sym_BANG] = ACTIONS(7506),
    [anon_sym_PLUS] = ACTIONS(7504),
    [anon_sym_DASH] = ACTIONS(7506),
    [anon_sym_LT_DASH] = ACTIONS(7504),
    [anon_sym_LT_LT_DASH] = ACTIONS(7504),
    [anon_sym_COLON_EQ] = ACTIONS(7504),
    [anon_sym_DASH_GT] = ACTIONS(7506),
    [anon_sym_DASH_GT_GT] = ACTIONS(7504),
    [anon_sym_PIPE] = ACTIONS(7506),
    [anon_sym_AMP] = ACTIONS(7506),
    [anon_sym_PIPE_PIPE] = ACTIONS(7504),
    [anon_sym_AMP_AMP] = ACTIONS(7504),
    [anon_sym_LT] = ACTIONS(7506),
    [anon_sym_LT_EQ] = ACTIONS(7504),
    [anon_sym_GT] = ACTIONS(7506),
    [anon_sym_GT_EQ] = ACTIONS(7504),
    [anon_sym_EQ_EQ] = ACTIONS(7504),
    [anon_sym_BANG_EQ] = ACTIONS(7504),
    [anon_sym_STAR] = ACTIONS(7506),
    [anon_sym_SLASH] = ACTIONS(7504),
    [anon_sym_STAR_STAR] = ACTIONS(7504),
    [anon_sym_CARET] = ACTIONS(7504),
    [aux_sym_binary_operator_token1] = ACTIONS(7504),
    [anon_sym_PIPE_GT] = ACTIONS(7504),
    [anon_sym_COLON] = ACTIONS(7506),
    [anon_sym_DOLLAR] = ACTIONS(7504),
    [anon_sym_AT] = ACTIONS(7504),
    [aux_sym__hex_literal_token1] = ACTIONS(7504),
    [sym__number_literal] = ACTIONS(7506),
    [anon_sym_SQUOTE] = ACTIONS(7504),
    [anon_sym_DQUOTE] = ACTIONS(7504),
    [sym_return] = ACTIONS(7506),
    [sym_next] = ACTIONS(7506),
    [sym_break] = ACTIONS(7506),
    [sym_true] = ACTIONS(7506),
    [sym_false] = ACTIONS(7506),
    [sym_null] = ACTIONS(7506),
    [sym_inf] = ACTIONS(7506),
    [sym_nan] = ACTIONS(7506),
    [anon_sym_NA] = ACTIONS(7506),
    [anon_sym_NA_integer_] = ACTIONS(7506),
    [anon_sym_NA_real_] = ACTIONS(7506),
    [anon_sym_NA_complex_] = ACTIONS(7506),
    [anon_sym_NA_character_] = ACTIONS(7506),
    [sym_dots] = ACTIONS(7506),
    [sym_dot_dot_i] = ACTIONS(7504),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7504),
    [sym__semicolon] = ACTIONS(7504),
    [sym__raw_string_literal] = ACTIONS(7504),
    [sym__external_open_parenthesis] = ACTIONS(7504),
    [sym__external_open_brace] = ACTIONS(7504),
    [sym__external_open_bracket] = ACTIONS(7504),
    [sym__external_open_bracket2] = ACTIONS(7504),
  },
  [3014] = {
    [sym_identifier] = ACTIONS(7129),
    [anon_sym_BSLASH] = ACTIONS(7131),
    [anon_sym_function] = ACTIONS(7129),
    [anon_sym_EQ] = ACTIONS(7663),
    [anon_sym_if] = ACTIONS(7129),
    [anon_sym_for] = ACTIONS(7129),
    [anon_sym_while] = ACTIONS(7129),
    [anon_sym_repeat] = ACTIONS(7129),
    [anon_sym_QMARK] = ACTIONS(7131),
    [anon_sym_TILDE] = ACTIONS(7131),
    [anon_sym_BANG] = ACTIONS(7129),
    [anon_sym_PLUS] = ACTIONS(7131),
    [anon_sym_DASH] = ACTIONS(7129),
    [anon_sym_LT_DASH] = ACTIONS(7131),
    [anon_sym_LT_LT_DASH] = ACTIONS(7131),
    [anon_sym_COLON_EQ] = ACTIONS(7131),
    [anon_sym_DASH_GT] = ACTIONS(7129),
    [anon_sym_DASH_GT_GT] = ACTIONS(7131),
    [anon_sym_PIPE] = ACTIONS(7129),
    [anon_sym_AMP] = ACTIONS(7129),
    [anon_sym_PIPE_PIPE] = ACTIONS(7131),
    [anon_sym_AMP_AMP] = ACTIONS(7131),
    [anon_sym_LT] = ACTIONS(7129),
    [anon_sym_LT_EQ] = ACTIONS(7131),
    [anon_sym_GT] = ACTIONS(7129),
    [anon_sym_GT_EQ] = ACTIONS(7131),
    [anon_sym_EQ_EQ] = ACTIONS(7131),
    [anon_sym_BANG_EQ] = ACTIONS(7131),
    [anon_sym_STAR] = ACTIONS(7129),
    [anon_sym_SLASH] = ACTIONS(7131),
    [anon_sym_STAR_STAR] = ACTIONS(7131),
    [anon_sym_CARET] = ACTIONS(7131),
    [aux_sym_binary_operator_token1] = ACTIONS(7131),
    [anon_sym_PIPE_GT] = ACTIONS(7131),
    [anon_sym_COLON] = ACTIONS(7129),
    [anon_sym_DOLLAR] = ACTIONS(7131),
    [anon_sym_AT] = ACTIONS(7131),
    [aux_sym__hex_literal_token1] = ACTIONS(7131),
    [sym__number_literal] = ACTIONS(7129),
    [anon_sym_SQUOTE] = ACTIONS(7131),
    [anon_sym_DQUOTE] = ACTIONS(7131),
    [sym_return] = ACTIONS(7129),
    [sym_next] = ACTIONS(7129),
    [sym_break] = ACTIONS(7129),
    [sym_true] = ACTIONS(7129),
    [sym_false] = ACTIONS(7129),
    [sym_null] = ACTIONS(7129),
    [sym_inf] = ACTIONS(7129),
    [sym_nan] = ACTIONS(7129),
    [anon_sym_NA] = ACTIONS(7129),
    [anon_sym_NA_integer_] = ACTIONS(7129),
    [anon_sym_NA_real_] = ACTIONS(7129),
    [anon_sym_NA_complex_] = ACTIONS(7129),
    [anon_sym_NA_character_] = ACTIONS(7129),
    [sym_dots] = ACTIONS(7129),
    [sym_dot_dot_i] = ACTIONS(7131),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7131),
    [sym__newline] = ACTIONS(7131),
    [sym__raw_string_literal] = ACTIONS(7131),
    [sym__external_open_parenthesis] = ACTIONS(7131),
    [sym__external_close_parenthesis] = ACTIONS(7131),
    [sym__external_open_brace] = ACTIONS(7131),
    [sym__external_open_bracket] = ACTIONS(7131),
    [sym__external_open_bracket2] = ACTIONS(7131),
  },
  [3015] = {
    [ts_builtin_sym_end] = ACTIONS(7510),
    [sym_identifier] = ACTIONS(7512),
    [anon_sym_BSLASH] = ACTIONS(7510),
    [anon_sym_function] = ACTIONS(7512),
    [anon_sym_EQ] = ACTIONS(7512),
    [anon_sym_if] = ACTIONS(7512),
    [anon_sym_for] = ACTIONS(7512),
    [anon_sym_while] = ACTIONS(7512),
    [anon_sym_repeat] = ACTIONS(7512),
    [anon_sym_QMARK] = ACTIONS(7510),
    [anon_sym_TILDE] = ACTIONS(7510),
    [anon_sym_BANG] = ACTIONS(7512),
    [anon_sym_PLUS] = ACTIONS(7510),
    [anon_sym_DASH] = ACTIONS(7512),
    [anon_sym_LT_DASH] = ACTIONS(7510),
    [anon_sym_LT_LT_DASH] = ACTIONS(7510),
    [anon_sym_COLON_EQ] = ACTIONS(7510),
    [anon_sym_DASH_GT] = ACTIONS(7512),
    [anon_sym_DASH_GT_GT] = ACTIONS(7510),
    [anon_sym_PIPE] = ACTIONS(7512),
    [anon_sym_AMP] = ACTIONS(7512),
    [anon_sym_PIPE_PIPE] = ACTIONS(7510),
    [anon_sym_AMP_AMP] = ACTIONS(7510),
    [anon_sym_LT] = ACTIONS(7512),
    [anon_sym_LT_EQ] = ACTIONS(7510),
    [anon_sym_GT] = ACTIONS(7512),
    [anon_sym_GT_EQ] = ACTIONS(7510),
    [anon_sym_EQ_EQ] = ACTIONS(7510),
    [anon_sym_BANG_EQ] = ACTIONS(7510),
    [anon_sym_STAR] = ACTIONS(7512),
    [anon_sym_SLASH] = ACTIONS(7510),
    [anon_sym_STAR_STAR] = ACTIONS(7510),
    [anon_sym_CARET] = ACTIONS(7510),
    [aux_sym_binary_operator_token1] = ACTIONS(7510),
    [anon_sym_PIPE_GT] = ACTIONS(7510),
    [anon_sym_COLON] = ACTIONS(7512),
    [anon_sym_DOLLAR] = ACTIONS(7510),
    [anon_sym_AT] = ACTIONS(7510),
    [aux_sym__hex_literal_token1] = ACTIONS(7510),
    [sym__number_literal] = ACTIONS(7512),
    [anon_sym_SQUOTE] = ACTIONS(7510),
    [anon_sym_DQUOTE] = ACTIONS(7510),
    [sym_return] = ACTIONS(7512),
    [sym_next] = ACTIONS(7512),
    [sym_break] = ACTIONS(7512),
    [sym_true] = ACTIONS(7512),
    [sym_false] = ACTIONS(7512),
    [sym_null] = ACTIONS(7512),
    [sym_inf] = ACTIONS(7512),
    [sym_nan] = ACTIONS(7512),
    [anon_sym_NA] = ACTIONS(7512),
    [anon_sym_NA_integer_] = ACTIONS(7512),
    [anon_sym_NA_real_] = ACTIONS(7512),
    [anon_sym_NA_complex_] = ACTIONS(7512),
    [anon_sym_NA_character_] = ACTIONS(7512),
    [sym_dots] = ACTIONS(7512),
    [sym_dot_dot_i] = ACTIONS(7510),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7510),
    [sym__semicolon] = ACTIONS(7510),
    [sym__raw_string_literal] = ACTIONS(7510),
    [sym__external_open_parenthesis] = ACTIONS(7510),
    [sym__external_open_brace] = ACTIONS(7510),
    [sym__external_open_bracket] = ACTIONS(7510),
    [sym__external_open_bracket2] = ACTIONS(7510),
  },
  [3016] = {
    [sym_identifier] = ACTIONS(7567),
    [anon_sym_BSLASH] = ACTIONS(7565),
    [anon_sym_function] = ACTIONS(7567),
    [anon_sym_EQ] = ACTIONS(7567),
    [anon_sym_if] = ACTIONS(7567),
    [anon_sym_for] = ACTIONS(7567),
    [anon_sym_while] = ACTIONS(7567),
    [anon_sym_repeat] = ACTIONS(7567),
    [anon_sym_QMARK] = ACTIONS(7565),
    [anon_sym_TILDE] = ACTIONS(7565),
    [anon_sym_BANG] = ACTIONS(7567),
    [anon_sym_PLUS] = ACTIONS(7565),
    [anon_sym_DASH] = ACTIONS(7567),
    [anon_sym_LT_DASH] = ACTIONS(7565),
    [anon_sym_LT_LT_DASH] = ACTIONS(7565),
    [anon_sym_COLON_EQ] = ACTIONS(7565),
    [anon_sym_DASH_GT] = ACTIONS(7567),
    [anon_sym_DASH_GT_GT] = ACTIONS(7565),
    [anon_sym_PIPE] = ACTIONS(7567),
    [anon_sym_AMP] = ACTIONS(7567),
    [anon_sym_PIPE_PIPE] = ACTIONS(7565),
    [anon_sym_AMP_AMP] = ACTIONS(7565),
    [anon_sym_LT] = ACTIONS(7567),
    [anon_sym_LT_EQ] = ACTIONS(7565),
    [anon_sym_GT] = ACTIONS(7567),
    [anon_sym_GT_EQ] = ACTIONS(7565),
    [anon_sym_EQ_EQ] = ACTIONS(7565),
    [anon_sym_BANG_EQ] = ACTIONS(7565),
    [anon_sym_STAR] = ACTIONS(7567),
    [anon_sym_SLASH] = ACTIONS(7565),
    [anon_sym_STAR_STAR] = ACTIONS(7565),
    [anon_sym_CARET] = ACTIONS(7565),
    [aux_sym_binary_operator_token1] = ACTIONS(7565),
    [anon_sym_PIPE_GT] = ACTIONS(7565),
    [anon_sym_COLON] = ACTIONS(7567),
    [anon_sym_DOLLAR] = ACTIONS(7565),
    [anon_sym_AT] = ACTIONS(7565),
    [aux_sym__hex_literal_token1] = ACTIONS(7565),
    [sym__number_literal] = ACTIONS(7567),
    [anon_sym_SQUOTE] = ACTIONS(7565),
    [anon_sym_DQUOTE] = ACTIONS(7565),
    [sym_return] = ACTIONS(7567),
    [sym_next] = ACTIONS(7567),
    [sym_break] = ACTIONS(7567),
    [sym_true] = ACTIONS(7567),
    [sym_false] = ACTIONS(7567),
    [sym_null] = ACTIONS(7567),
    [sym_inf] = ACTIONS(7567),
    [sym_nan] = ACTIONS(7567),
    [anon_sym_NA] = ACTIONS(7567),
    [anon_sym_NA_integer_] = ACTIONS(7567),
    [anon_sym_NA_real_] = ACTIONS(7567),
    [anon_sym_NA_complex_] = ACTIONS(7567),
    [anon_sym_NA_character_] = ACTIONS(7567),
    [sym_dots] = ACTIONS(7567),
    [sym_dot_dot_i] = ACTIONS(7565),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7565),
    [sym__newline] = ACTIONS(7565),
    [sym__raw_string_literal] = ACTIONS(7565),
    [sym__external_open_parenthesis] = ACTIONS(7565),
    [sym__external_open_brace] = ACTIONS(7565),
    [sym__external_open_bracket] = ACTIONS(7565),
    [sym__external_open_bracket2] = ACTIONS(7565),
    [sym__external_close_bracket2] = ACTIONS(7565),
  },
  [3017] = {
    [ts_builtin_sym_end] = ACTIONS(7518),
    [sym_identifier] = ACTIONS(7520),
    [anon_sym_BSLASH] = ACTIONS(7518),
    [anon_sym_function] = ACTIONS(7520),
    [anon_sym_EQ] = ACTIONS(7520),
    [anon_sym_if] = ACTIONS(7520),
    [anon_sym_for] = ACTIONS(7520),
    [anon_sym_while] = ACTIONS(7520),
    [anon_sym_repeat] = ACTIONS(7520),
    [anon_sym_QMARK] = ACTIONS(7518),
    [anon_sym_TILDE] = ACTIONS(7518),
    [anon_sym_BANG] = ACTIONS(7520),
    [anon_sym_PLUS] = ACTIONS(7518),
    [anon_sym_DASH] = ACTIONS(7520),
    [anon_sym_LT_DASH] = ACTIONS(7518),
    [anon_sym_LT_LT_DASH] = ACTIONS(7518),
    [anon_sym_COLON_EQ] = ACTIONS(7518),
    [anon_sym_DASH_GT] = ACTIONS(7520),
    [anon_sym_DASH_GT_GT] = ACTIONS(7518),
    [anon_sym_PIPE] = ACTIONS(7520),
    [anon_sym_AMP] = ACTIONS(7520),
    [anon_sym_PIPE_PIPE] = ACTIONS(7518),
    [anon_sym_AMP_AMP] = ACTIONS(7518),
    [anon_sym_LT] = ACTIONS(7520),
    [anon_sym_LT_EQ] = ACTIONS(7518),
    [anon_sym_GT] = ACTIONS(7520),
    [anon_sym_GT_EQ] = ACTIONS(7518),
    [anon_sym_EQ_EQ] = ACTIONS(7518),
    [anon_sym_BANG_EQ] = ACTIONS(7518),
    [anon_sym_STAR] = ACTIONS(7520),
    [anon_sym_SLASH] = ACTIONS(7518),
    [anon_sym_STAR_STAR] = ACTIONS(7518),
    [anon_sym_CARET] = ACTIONS(7518),
    [aux_sym_binary_operator_token1] = ACTIONS(7518),
    [anon_sym_PIPE_GT] = ACTIONS(7518),
    [anon_sym_COLON] = ACTIONS(7520),
    [anon_sym_DOLLAR] = ACTIONS(7518),
    [anon_sym_AT] = ACTIONS(7518),
    [aux_sym__hex_literal_token1] = ACTIONS(7518),
    [sym__number_literal] = ACTIONS(7520),
    [anon_sym_SQUOTE] = ACTIONS(7518),
    [anon_sym_DQUOTE] = ACTIONS(7518),
    [sym_return] = ACTIONS(7520),
    [sym_next] = ACTIONS(7520),
    [sym_break] = ACTIONS(7520),
    [sym_true] = ACTIONS(7520),
    [sym_false] = ACTIONS(7520),
    [sym_null] = ACTIONS(7520),
    [sym_inf] = ACTIONS(7520),
    [sym_nan] = ACTIONS(7520),
    [anon_sym_NA] = ACTIONS(7520),
    [anon_sym_NA_integer_] = ACTIONS(7520),
    [anon_sym_NA_real_] = ACTIONS(7520),
    [anon_sym_NA_complex_] = ACTIONS(7520),
    [anon_sym_NA_character_] = ACTIONS(7520),
    [sym_dots] = ACTIONS(7520),
    [sym_dot_dot_i] = ACTIONS(7518),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7518),
    [sym__semicolon] = ACTIONS(7518),
    [sym__raw_string_literal] = ACTIONS(7518),
    [sym__external_open_parenthesis] = ACTIONS(7518),
    [sym__external_open_brace] = ACTIONS(7518),
    [sym__external_open_bracket] = ACTIONS(7518),
    [sym__external_open_bracket2] = ACTIONS(7518),
  },
  [3018] = {
    [sym_identifier] = ACTIONS(7516),
    [anon_sym_BSLASH] = ACTIONS(7514),
    [anon_sym_function] = ACTIONS(7516),
    [anon_sym_EQ] = ACTIONS(7516),
    [anon_sym_if] = ACTIONS(7516),
    [anon_sym_for] = ACTIONS(7516),
    [anon_sym_while] = ACTIONS(7516),
    [anon_sym_repeat] = ACTIONS(7516),
    [anon_sym_QMARK] = ACTIONS(7514),
    [anon_sym_TILDE] = ACTIONS(7514),
    [anon_sym_BANG] = ACTIONS(7516),
    [anon_sym_PLUS] = ACTIONS(7514),
    [anon_sym_DASH] = ACTIONS(7516),
    [anon_sym_LT_DASH] = ACTIONS(7514),
    [anon_sym_LT_LT_DASH] = ACTIONS(7514),
    [anon_sym_COLON_EQ] = ACTIONS(7514),
    [anon_sym_DASH_GT] = ACTIONS(7516),
    [anon_sym_DASH_GT_GT] = ACTIONS(7514),
    [anon_sym_PIPE] = ACTIONS(7516),
    [anon_sym_AMP] = ACTIONS(7516),
    [anon_sym_PIPE_PIPE] = ACTIONS(7514),
    [anon_sym_AMP_AMP] = ACTIONS(7514),
    [anon_sym_LT] = ACTIONS(7516),
    [anon_sym_LT_EQ] = ACTIONS(7514),
    [anon_sym_GT] = ACTIONS(7516),
    [anon_sym_GT_EQ] = ACTIONS(7514),
    [anon_sym_EQ_EQ] = ACTIONS(7514),
    [anon_sym_BANG_EQ] = ACTIONS(7514),
    [anon_sym_STAR] = ACTIONS(7516),
    [anon_sym_SLASH] = ACTIONS(7514),
    [anon_sym_STAR_STAR] = ACTIONS(7514),
    [anon_sym_CARET] = ACTIONS(7514),
    [aux_sym_binary_operator_token1] = ACTIONS(7514),
    [anon_sym_PIPE_GT] = ACTIONS(7514),
    [anon_sym_COLON] = ACTIONS(7516),
    [anon_sym_DOLLAR] = ACTIONS(7514),
    [anon_sym_AT] = ACTIONS(7514),
    [aux_sym__hex_literal_token1] = ACTIONS(7514),
    [sym__number_literal] = ACTIONS(7516),
    [anon_sym_SQUOTE] = ACTIONS(7514),
    [anon_sym_DQUOTE] = ACTIONS(7514),
    [sym_return] = ACTIONS(7516),
    [sym_next] = ACTIONS(7516),
    [sym_break] = ACTIONS(7516),
    [sym_true] = ACTIONS(7516),
    [sym_false] = ACTIONS(7516),
    [sym_null] = ACTIONS(7516),
    [sym_inf] = ACTIONS(7516),
    [sym_nan] = ACTIONS(7516),
    [anon_sym_NA] = ACTIONS(7516),
    [anon_sym_NA_integer_] = ACTIONS(7516),
    [anon_sym_NA_real_] = ACTIONS(7516),
    [anon_sym_NA_complex_] = ACTIONS(7516),
    [anon_sym_NA_character_] = ACTIONS(7516),
    [sym_dots] = ACTIONS(7516),
    [sym_dot_dot_i] = ACTIONS(7514),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7514),
    [sym__newline] = ACTIONS(7514),
    [sym__raw_string_literal] = ACTIONS(7514),
    [sym__external_open_parenthesis] = ACTIONS(7514),
    [sym__external_open_brace] = ACTIONS(7514),
    [sym__external_open_bracket] = ACTIONS(7514),
    [sym__external_close_bracket] = ACTIONS(7514),
    [sym__external_open_bracket2] = ACTIONS(7514),
  },
  [3019] = {
    [sym_identifier] = ACTIONS(7478),
    [anon_sym_BSLASH] = ACTIONS(7476),
    [anon_sym_function] = ACTIONS(7478),
    [anon_sym_EQ] = ACTIONS(7478),
    [anon_sym_if] = ACTIONS(7478),
    [anon_sym_for] = ACTIONS(7478),
    [anon_sym_while] = ACTIONS(7478),
    [anon_sym_repeat] = ACTIONS(7478),
    [anon_sym_QMARK] = ACTIONS(7476),
    [anon_sym_TILDE] = ACTIONS(7476),
    [anon_sym_BANG] = ACTIONS(7478),
    [anon_sym_PLUS] = ACTIONS(7476),
    [anon_sym_DASH] = ACTIONS(7478),
    [anon_sym_LT_DASH] = ACTIONS(7476),
    [anon_sym_LT_LT_DASH] = ACTIONS(7476),
    [anon_sym_COLON_EQ] = ACTIONS(7476),
    [anon_sym_DASH_GT] = ACTIONS(7478),
    [anon_sym_DASH_GT_GT] = ACTIONS(7476),
    [anon_sym_PIPE] = ACTIONS(7478),
    [anon_sym_AMP] = ACTIONS(7478),
    [anon_sym_PIPE_PIPE] = ACTIONS(7476),
    [anon_sym_AMP_AMP] = ACTIONS(7476),
    [anon_sym_LT] = ACTIONS(7478),
    [anon_sym_LT_EQ] = ACTIONS(7476),
    [anon_sym_GT] = ACTIONS(7478),
    [anon_sym_GT_EQ] = ACTIONS(7476),
    [anon_sym_EQ_EQ] = ACTIONS(7476),
    [anon_sym_BANG_EQ] = ACTIONS(7476),
    [anon_sym_STAR] = ACTIONS(7478),
    [anon_sym_SLASH] = ACTIONS(7476),
    [anon_sym_STAR_STAR] = ACTIONS(7476),
    [anon_sym_CARET] = ACTIONS(7476),
    [aux_sym_binary_operator_token1] = ACTIONS(7476),
    [anon_sym_PIPE_GT] = ACTIONS(7476),
    [anon_sym_COLON] = ACTIONS(7478),
    [anon_sym_DOLLAR] = ACTIONS(7476),
    [anon_sym_AT] = ACTIONS(7476),
    [aux_sym__hex_literal_token1] = ACTIONS(7476),
    [sym__number_literal] = ACTIONS(7478),
    [anon_sym_SQUOTE] = ACTIONS(7476),
    [anon_sym_DQUOTE] = ACTIONS(7476),
    [sym_return] = ACTIONS(7478),
    [sym_next] = ACTIONS(7478),
    [sym_break] = ACTIONS(7478),
    [sym_true] = ACTIONS(7478),
    [sym_false] = ACTIONS(7478),
    [sym_null] = ACTIONS(7478),
    [sym_inf] = ACTIONS(7478),
    [sym_nan] = ACTIONS(7478),
    [anon_sym_NA] = ACTIONS(7478),
    [anon_sym_NA_integer_] = ACTIONS(7478),
    [anon_sym_NA_real_] = ACTIONS(7478),
    [anon_sym_NA_complex_] = ACTIONS(7478),
    [anon_sym_NA_character_] = ACTIONS(7478),
    [sym_dots] = ACTIONS(7478),
    [sym_dot_dot_i] = ACTIONS(7476),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7476),
    [sym__newline] = ACTIONS(7476),
    [sym__raw_string_literal] = ACTIONS(7476),
    [sym__external_open_parenthesis] = ACTIONS(7476),
    [sym__external_close_parenthesis] = ACTIONS(7476),
    [sym__external_open_brace] = ACTIONS(7476),
    [sym__external_open_bracket] = ACTIONS(7476),
    [sym__external_open_bracket2] = ACTIONS(7476),
  },
  [3020] = {
    [ts_builtin_sym_end] = ACTIONS(7565),
    [sym_identifier] = ACTIONS(7567),
    [anon_sym_BSLASH] = ACTIONS(7565),
    [anon_sym_function] = ACTIONS(7567),
    [anon_sym_EQ] = ACTIONS(7567),
    [anon_sym_if] = ACTIONS(7567),
    [anon_sym_for] = ACTIONS(7567),
    [anon_sym_while] = ACTIONS(7567),
    [anon_sym_repeat] = ACTIONS(7567),
    [anon_sym_QMARK] = ACTIONS(7565),
    [anon_sym_TILDE] = ACTIONS(7565),
    [anon_sym_BANG] = ACTIONS(7567),
    [anon_sym_PLUS] = ACTIONS(7565),
    [anon_sym_DASH] = ACTIONS(7567),
    [anon_sym_LT_DASH] = ACTIONS(7565),
    [anon_sym_LT_LT_DASH] = ACTIONS(7565),
    [anon_sym_COLON_EQ] = ACTIONS(7565),
    [anon_sym_DASH_GT] = ACTIONS(7567),
    [anon_sym_DASH_GT_GT] = ACTIONS(7565),
    [anon_sym_PIPE] = ACTIONS(7567),
    [anon_sym_AMP] = ACTIONS(7567),
    [anon_sym_PIPE_PIPE] = ACTIONS(7565),
    [anon_sym_AMP_AMP] = ACTIONS(7565),
    [anon_sym_LT] = ACTIONS(7567),
    [anon_sym_LT_EQ] = ACTIONS(7565),
    [anon_sym_GT] = ACTIONS(7567),
    [anon_sym_GT_EQ] = ACTIONS(7565),
    [anon_sym_EQ_EQ] = ACTIONS(7565),
    [anon_sym_BANG_EQ] = ACTIONS(7565),
    [anon_sym_STAR] = ACTIONS(7567),
    [anon_sym_SLASH] = ACTIONS(7565),
    [anon_sym_STAR_STAR] = ACTIONS(7565),
    [anon_sym_CARET] = ACTIONS(7565),
    [aux_sym_binary_operator_token1] = ACTIONS(7565),
    [anon_sym_PIPE_GT] = ACTIONS(7565),
    [anon_sym_COLON] = ACTIONS(7567),
    [anon_sym_DOLLAR] = ACTIONS(7565),
    [anon_sym_AT] = ACTIONS(7565),
    [aux_sym__hex_literal_token1] = ACTIONS(7565),
    [sym__number_literal] = ACTIONS(7567),
    [anon_sym_SQUOTE] = ACTIONS(7565),
    [anon_sym_DQUOTE] = ACTIONS(7565),
    [sym_return] = ACTIONS(7567),
    [sym_next] = ACTIONS(7567),
    [sym_break] = ACTIONS(7567),
    [sym_true] = ACTIONS(7567),
    [sym_false] = ACTIONS(7567),
    [sym_null] = ACTIONS(7567),
    [sym_inf] = ACTIONS(7567),
    [sym_nan] = ACTIONS(7567),
    [anon_sym_NA] = ACTIONS(7567),
    [anon_sym_NA_integer_] = ACTIONS(7567),
    [anon_sym_NA_real_] = ACTIONS(7567),
    [anon_sym_NA_complex_] = ACTIONS(7567),
    [anon_sym_NA_character_] = ACTIONS(7567),
    [sym_dots] = ACTIONS(7567),
    [sym_dot_dot_i] = ACTIONS(7565),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(7565),
    [sym__semicolon] = ACTIONS(7565),
    [sym__raw_string_literal] = ACTIONS(7565),
    [sym__external_open_parenthesis] = ACTIONS(7565),
    [sym__external_open_brace] = ACTIONS(7565),
    [sym__external_open_bracket] = ACTIONS(7565),
    [sym__external_open_bracket2] = ACTIONS(7565),
  },
  [3021] = {
    [sym_identifier] = ACTIONS(5311),
    [anon_sym_BSLASH] = ACTIONS(5313),
    [anon_sym_function] = ACTIONS(5311),
    [anon_sym_EQ] = ACTIONS(5311),
    [anon_sym_if] = ACTIONS(5311),
    [anon_sym_for] = ACTIONS(5311),
    [anon_sym_while] = ACTIONS(5311),
    [anon_sym_repeat] = ACTIONS(5311),
    [anon_sym_QMARK] = ACTIONS(5313),
    [anon_sym_TILDE] = ACTIONS(5313),
    [anon_sym_BANG] = ACTIONS(5311),
    [anon_sym_PLUS] = ACTIONS(5313),
    [anon_sym_DASH] = ACTIONS(5311),
    [anon_sym_LT_DASH] = ACTIONS(5313),
    [anon_sym_LT_LT_DASH] = ACTIONS(5313),
    [anon_sym_COLON_EQ] = ACTIONS(5313),
    [anon_sym_DASH_GT] = ACTIONS(5311),
    [anon_sym_DASH_GT_GT] = ACTIONS(5313),
    [anon_sym_PIPE] = ACTIONS(5311),
    [anon_sym_AMP] = ACTIONS(5311),
    [anon_sym_PIPE_PIPE] = ACTIONS(5313),
    [anon_sym_AMP_AMP] = ACTIONS(5313),
    [anon_sym_LT] = ACTIONS(5311),
    [anon_sym_LT_EQ] = ACTIONS(5313),
    [anon_sym_GT] = ACTIONS(5311),
    [anon_sym_GT_EQ] = ACTIONS(5313),
    [anon_sym_EQ_EQ] = ACTIONS(5313),
    [anon_sym_BANG_EQ] = ACTIONS(5313),
    [anon_sym_STAR] = ACTIONS(5311),
    [anon_sym_SLASH] = ACTIONS(5313),
    [anon_sym_STAR_STAR] = ACTIONS(5313),
    [anon_sym_CARET] = ACTIONS(5313),
    [aux_sym_binary_operator_token1] = ACTIONS(5313),
    [anon_sym_PIPE_GT] = ACTIONS(5313),
    [anon_sym_COLON] = ACTIONS(5311),
    [anon_sym_DOLLAR] = ACTIONS(5313),
    [anon_sym_AT] = ACTIONS(5313),
    [aux_sym__hex_literal_token1] = ACTIONS(5313),
    [sym__number_literal] = ACTIONS(5311),
    [anon_sym_SQUOTE] = ACTIONS(5313),
    [anon_sym_DQUOTE] = ACTIONS(5313),
    [sym_return] = ACTIONS(5311),
    [sym_next] = ACTIONS(5311),
    [sym_break] = ACTIONS(5311),
    [sym_true] = ACTIONS(5311),
    [sym_false] = ACTIONS(5311),
    [sym_null] = ACTIONS(5311),
    [sym_inf] = ACTIONS(5311),
    [sym_nan] = ACTIONS(5311),
    [anon_sym_NA] = ACTIONS(5311),
    [anon_sym_NA_integer_] = ACTIONS(5311),
    [anon_sym_NA_real_] = ACTIONS(5311),
    [anon_sym_NA_complex_] = ACTIONS(5311),
    [anon_sym_NA_character_] = ACTIONS(5311),
    [sym_dots] = ACTIONS(5311),
    [sym_dot_dot_i] = ACTIONS(5313),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(5313),
    [sym__newline] = ACTIONS(5313),
    [sym__raw_string_literal] = ACTIONS(5313),
    [sym__external_open_parenthesis] = ACTIONS(5313),
    [sym__external_close_parenthesis] = ACTIONS(5313),
    [sym__external_open_brace] = ACTIONS(5313),
    [sym__external_open_bracket] = ACTIONS(5313),
    [sym__external_open_bracket2] = ACTIONS(5313),
  },
  [3022] = {
    [sym_identifier] = ACTIONS(7520),
    [anon_sym_BSLASH] = ACTIONS(7518),
    [anon_sym_function] = ACTIONS(7520),
    [anon_sym_EQ] = ACTIONS(7520),
    [anon_sym_if] = ACTIONS(7520),
    [anon_sym_for] = ACTIONS(7520),
    [anon_sym_while] = ACTIONS(7520),
    [anon_sym_repeat] = ACTIONS(7520),
    [anon_sym_QMARK] = ACTIONS(7518),
    [anon_sym_TILDE] = ACTIONS(7518),
    [anon_sym_BANG] = ACTIONS(7520),
    [anon_sym_PLUS] = ACTIONS(7518),
    [anon_sym_DASH] = ACTIONS(7520),
    [anon_sym_LT_DASH] = ACTIONS(7518),
    [anon_sym_LT_LT_DASH] = ACTIONS(7518),
    [anon_sym_COLON_EQ] = ACTIONS(7518),
    [anon_sym_DASH_GT] = ACTIONS(7520),
    [anon_sym_DASH_GT_GT] = ACTIONS(7518),
    [anon_sym_PIPE] = ACTIONS(7520),
    [anon_sym_AMP] = ACTIONS(7520),
    [anon_sym_PIPE_PIPE] = ACTIONS(7518),
    [anon_sym_AMP_AMP] = ACTIONS(7518),
    [anon_sym_LT] = ACTIONS(7520),
    [anon_sym_LT_EQ] = ACTIONS(7518),
    [anon_sym_GT] = ACTIONS(7520),
    [anon_sym_GT_EQ] = ACTIONS(7518),
    [anon_sym_EQ_EQ] = ACTIONS(7518),
    [anon_sym_BANG_EQ] = ACTIONS(7518),
    [anon_sym_STAR] = ACTIONS(7520),
    [anon_sym_SLASH] = ACTIONS(7518),
    [anon_sym_STAR_STAR] = ACTIONS(7518),
    [anon_sym_CARET] = ACTIONS(7518),
    [aux_sym_binary_operator_token1] = ACTIONS(7518),
    [anon_sym_PIPE_GT] = ACTIONS(7518),
    [anon_sym_COLON] = ACTIONS(7520),
    [anon_sym_DOLLAR] = ACTIONS(7518),
    [anon_sym_AT] = ACTIONS(7518),
    [aux_sym__hex_literal_token1] = ACTIONS(7518),
    [sym__number_literal] = ACTIONS(7520),
    [anon_sym_SQUOTE] = ACTIONS(7518),
    [anon_sym_DQUOTE] = ACTIONS(7518),
    [sym_return] = ACTIONS(7520),
    [sym_next] = ACTIONS(7520),
    [sym_break] = ACTIONS(7520),
    [sym_true] = ACTIONS(7520),
    [sym_false] = ACTIONS(7520),
    [sym_null] = ACTIONS(7520),
    [sym_inf] = ACTIONS(7520),
    [sym_nan] = ACTIONS(7520),
    [anon_sym_NA] = ACTIONS(7520),
    [anon_sym_NA_integer_] = ACTIONS(7520),
    [anon_sym_NA_real_] = ACTIONS(7520),
    [anon_sym_NA_complex_] = ACTIONS(7520),
    [anon_sym_NA_character_] = ACTIONS(7520),
    [sym_dots] = ACTIONS(7520),
    [sym_dot_dot_i] = ACTIONS(7518),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7518),
    [sym__newline] = ACTIONS(7518),
    [sym__raw_string_literal] = ACTIONS(7518),
    [sym__external_open_parenthesis] = ACTIONS(7518),
    [sym__external_open_brace] = ACTIONS(7518),
    [sym__external_open_bracket] = ACTIONS(7518),
    [sym__external_close_bracket] = ACTIONS(7518),
    [sym__external_open_bracket2] = ACTIONS(7518),
  },
  [3023] = {
    [sym_identifier] = ACTIONS(7544),
    [anon_sym_BSLASH] = ACTIONS(7542),
    [anon_sym_function] = ACTIONS(7544),
    [anon_sym_EQ] = ACTIONS(7544),
    [anon_sym_if] = ACTIONS(7544),
    [anon_sym_for] = ACTIONS(7544),
    [anon_sym_while] = ACTIONS(7544),
    [anon_sym_repeat] = ACTIONS(7544),
    [anon_sym_QMARK] = ACTIONS(7542),
    [anon_sym_TILDE] = ACTIONS(7542),
    [anon_sym_BANG] = ACTIONS(7544),
    [anon_sym_PLUS] = ACTIONS(7542),
    [anon_sym_DASH] = ACTIONS(7544),
    [anon_sym_LT_DASH] = ACTIONS(7542),
    [anon_sym_LT_LT_DASH] = ACTIONS(7542),
    [anon_sym_COLON_EQ] = ACTIONS(7542),
    [anon_sym_DASH_GT] = ACTIONS(7544),
    [anon_sym_DASH_GT_GT] = ACTIONS(7542),
    [anon_sym_PIPE] = ACTIONS(7544),
    [anon_sym_AMP] = ACTIONS(7544),
    [anon_sym_PIPE_PIPE] = ACTIONS(7542),
    [anon_sym_AMP_AMP] = ACTIONS(7542),
    [anon_sym_LT] = ACTIONS(7544),
    [anon_sym_LT_EQ] = ACTIONS(7542),
    [anon_sym_GT] = ACTIONS(7544),
    [anon_sym_GT_EQ] = ACTIONS(7542),
    [anon_sym_EQ_EQ] = ACTIONS(7542),
    [anon_sym_BANG_EQ] = ACTIONS(7542),
    [anon_sym_STAR] = ACTIONS(7544),
    [anon_sym_SLASH] = ACTIONS(7542),
    [anon_sym_STAR_STAR] = ACTIONS(7542),
    [anon_sym_CARET] = ACTIONS(7542),
    [aux_sym_binary_operator_token1] = ACTIONS(7542),
    [anon_sym_PIPE_GT] = ACTIONS(7542),
    [anon_sym_COLON] = ACTIONS(7544),
    [anon_sym_DOLLAR] = ACTIONS(7542),
    [anon_sym_AT] = ACTIONS(7542),
    [aux_sym__hex_literal_token1] = ACTIONS(7542),
    [sym__number_literal] = ACTIONS(7544),
    [anon_sym_SQUOTE] = ACTIONS(7542),
    [anon_sym_DQUOTE] = ACTIONS(7542),
    [sym_return] = ACTIONS(7544),
    [sym_next] = ACTIONS(7544),
    [sym_break] = ACTIONS(7544),
    [sym_true] = ACTIONS(7544),
    [sym_false] = ACTIONS(7544),
    [sym_null] = ACTIONS(7544),
    [sym_inf] = ACTIONS(7544),
    [sym_nan] = ACTIONS(7544),
    [anon_sym_NA] = ACTIONS(7544),
    [anon_sym_NA_integer_] = ACTIONS(7544),
    [anon_sym_NA_real_] = ACTIONS(7544),
    [anon_sym_NA_complex_] = ACTIONS(7544),
    [anon_sym_NA_character_] = ACTIONS(7544),
    [sym_dots] = ACTIONS(7544),
    [sym_dot_dot_i] = ACTIONS(7542),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7542),
    [sym__newline] = ACTIONS(7542),
    [sym__raw_string_literal] = ACTIONS(7542),
    [sym__external_open_parenthesis] = ACTIONS(7542),
    [sym__external_open_brace] = ACTIONS(7542),
    [sym__external_open_bracket] = ACTIONS(7542),
    [sym__external_close_bracket] = ACTIONS(7542),
    [sym__external_open_bracket2] = ACTIONS(7542),
  },
  [3024] = {
    [sym_identifier] = ACTIONS(7540),
    [anon_sym_BSLASH] = ACTIONS(7538),
    [anon_sym_function] = ACTIONS(7540),
    [anon_sym_EQ] = ACTIONS(7540),
    [anon_sym_if] = ACTIONS(7540),
    [anon_sym_for] = ACTIONS(7540),
    [anon_sym_while] = ACTIONS(7540),
    [anon_sym_repeat] = ACTIONS(7540),
    [anon_sym_QMARK] = ACTIONS(7538),
    [anon_sym_TILDE] = ACTIONS(7538),
    [anon_sym_BANG] = ACTIONS(7540),
    [anon_sym_PLUS] = ACTIONS(7538),
    [anon_sym_DASH] = ACTIONS(7540),
    [anon_sym_LT_DASH] = ACTIONS(7538),
    [anon_sym_LT_LT_DASH] = ACTIONS(7538),
    [anon_sym_COLON_EQ] = ACTIONS(7538),
    [anon_sym_DASH_GT] = ACTIONS(7540),
    [anon_sym_DASH_GT_GT] = ACTIONS(7538),
    [anon_sym_PIPE] = ACTIONS(7540),
    [anon_sym_AMP] = ACTIONS(7540),
    [anon_sym_PIPE_PIPE] = ACTIONS(7538),
    [anon_sym_AMP_AMP] = ACTIONS(7538),
    [anon_sym_LT] = ACTIONS(7540),
    [anon_sym_LT_EQ] = ACTIONS(7538),
    [anon_sym_GT] = ACTIONS(7540),
    [anon_sym_GT_EQ] = ACTIONS(7538),
    [anon_sym_EQ_EQ] = ACTIONS(7538),
    [anon_sym_BANG_EQ] = ACTIONS(7538),
    [anon_sym_STAR] = ACTIONS(7540),
    [anon_sym_SLASH] = ACTIONS(7538),
    [anon_sym_STAR_STAR] = ACTIONS(7538),
    [anon_sym_CARET] = ACTIONS(7538),
    [aux_sym_binary_operator_token1] = ACTIONS(7538),
    [anon_sym_PIPE_GT] = ACTIONS(7538),
    [anon_sym_COLON] = ACTIONS(7540),
    [anon_sym_DOLLAR] = ACTIONS(7538),
    [anon_sym_AT] = ACTIONS(7538),
    [aux_sym__hex_literal_token1] = ACTIONS(7538),
    [sym__number_literal] = ACTIONS(7540),
    [anon_sym_SQUOTE] = ACTIONS(7538),
    [anon_sym_DQUOTE] = ACTIONS(7538),
    [sym_return] = ACTIONS(7540),
    [sym_next] = ACTIONS(7540),
    [sym_break] = ACTIONS(7540),
    [sym_true] = ACTIONS(7540),
    [sym_false] = ACTIONS(7540),
    [sym_null] = ACTIONS(7540),
    [sym_inf] = ACTIONS(7540),
    [sym_nan] = ACTIONS(7540),
    [anon_sym_NA] = ACTIONS(7540),
    [anon_sym_NA_integer_] = ACTIONS(7540),
    [anon_sym_NA_real_] = ACTIONS(7540),
    [anon_sym_NA_complex_] = ACTIONS(7540),
    [anon_sym_NA_character_] = ACTIONS(7540),
    [sym_dots] = ACTIONS(7540),
    [sym_dot_dot_i] = ACTIONS(7538),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7538),
    [sym__newline] = ACTIONS(7538),
    [sym__raw_string_literal] = ACTIONS(7538),
    [sym__external_open_parenthesis] = ACTIONS(7538),
    [sym__external_open_brace] = ACTIONS(7538),
    [sym__external_open_bracket] = ACTIONS(7538),
    [sym__external_close_bracket] = ACTIONS(7538),
    [sym__external_open_bracket2] = ACTIONS(7538),
  },
  [3025] = {
    [sym_identifier] = ACTIONS(7524),
    [anon_sym_BSLASH] = ACTIONS(7522),
    [anon_sym_function] = ACTIONS(7524),
    [anon_sym_EQ] = ACTIONS(7524),
    [anon_sym_if] = ACTIONS(7524),
    [anon_sym_for] = ACTIONS(7524),
    [anon_sym_while] = ACTIONS(7524),
    [anon_sym_repeat] = ACTIONS(7524),
    [anon_sym_QMARK] = ACTIONS(7522),
    [anon_sym_TILDE] = ACTIONS(7522),
    [anon_sym_BANG] = ACTIONS(7524),
    [anon_sym_PLUS] = ACTIONS(7522),
    [anon_sym_DASH] = ACTIONS(7524),
    [anon_sym_LT_DASH] = ACTIONS(7522),
    [anon_sym_LT_LT_DASH] = ACTIONS(7522),
    [anon_sym_COLON_EQ] = ACTIONS(7522),
    [anon_sym_DASH_GT] = ACTIONS(7524),
    [anon_sym_DASH_GT_GT] = ACTIONS(7522),
    [anon_sym_PIPE] = ACTIONS(7524),
    [anon_sym_AMP] = ACTIONS(7524),
    [anon_sym_PIPE_PIPE] = ACTIONS(7522),
    [anon_sym_AMP_AMP] = ACTIONS(7522),
    [anon_sym_LT] = ACTIONS(7524),
    [anon_sym_LT_EQ] = ACTIONS(7522),
    [anon_sym_GT] = ACTIONS(7524),
    [anon_sym_GT_EQ] = ACTIONS(7522),
    [anon_sym_EQ_EQ] = ACTIONS(7522),
    [anon_sym_BANG_EQ] = ACTIONS(7522),
    [anon_sym_STAR] = ACTIONS(7524),
    [anon_sym_SLASH] = ACTIONS(7522),
    [anon_sym_STAR_STAR] = ACTIONS(7522),
    [anon_sym_CARET] = ACTIONS(7522),
    [aux_sym_binary_operator_token1] = ACTIONS(7522),
    [anon_sym_PIPE_GT] = ACTIONS(7522),
    [anon_sym_COLON] = ACTIONS(7524),
    [anon_sym_DOLLAR] = ACTIONS(7522),
    [anon_sym_AT] = ACTIONS(7522),
    [aux_sym__hex_literal_token1] = ACTIONS(7522),
    [sym__number_literal] = ACTIONS(7524),
    [anon_sym_SQUOTE] = ACTIONS(7522),
    [anon_sym_DQUOTE] = ACTIONS(7522),
    [sym_return] = ACTIONS(7524),
    [sym_next] = ACTIONS(7524),
    [sym_break] = ACTIONS(7524),
    [sym_true] = ACTIONS(7524),
    [sym_false] = ACTIONS(7524),
    [sym_null] = ACTIONS(7524),
    [sym_inf] = ACTIONS(7524),
    [sym_nan] = ACTIONS(7524),
    [anon_sym_NA] = ACTIONS(7524),
    [anon_sym_NA_integer_] = ACTIONS(7524),
    [anon_sym_NA_real_] = ACTIONS(7524),
    [anon_sym_NA_complex_] = ACTIONS(7524),
    [anon_sym_NA_character_] = ACTIONS(7524),
    [sym_dots] = ACTIONS(7524),
    [sym_dot_dot_i] = ACTIONS(7522),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7522),
    [sym__newline] = ACTIONS(7522),
    [sym__raw_string_literal] = ACTIONS(7522),
    [sym__external_open_parenthesis] = ACTIONS(7522),
    [sym__external_open_brace] = ACTIONS(7522),
    [sym__external_open_bracket] = ACTIONS(7522),
    [sym__external_close_bracket] = ACTIONS(7522),
    [sym__external_open_bracket2] = ACTIONS(7522),
  },
  [3026] = {
    [sym_identifier] = ACTIONS(7528),
    [anon_sym_BSLASH] = ACTIONS(7526),
    [anon_sym_function] = ACTIONS(7528),
    [anon_sym_EQ] = ACTIONS(7528),
    [anon_sym_if] = ACTIONS(7528),
    [anon_sym_for] = ACTIONS(7528),
    [anon_sym_while] = ACTIONS(7528),
    [anon_sym_repeat] = ACTIONS(7528),
    [anon_sym_QMARK] = ACTIONS(7526),
    [anon_sym_TILDE] = ACTIONS(7526),
    [anon_sym_BANG] = ACTIONS(7528),
    [anon_sym_PLUS] = ACTIONS(7526),
    [anon_sym_DASH] = ACTIONS(7528),
    [anon_sym_LT_DASH] = ACTIONS(7526),
    [anon_sym_LT_LT_DASH] = ACTIONS(7526),
    [anon_sym_COLON_EQ] = ACTIONS(7526),
    [anon_sym_DASH_GT] = ACTIONS(7528),
    [anon_sym_DASH_GT_GT] = ACTIONS(7526),
    [anon_sym_PIPE] = ACTIONS(7528),
    [anon_sym_AMP] = ACTIONS(7528),
    [anon_sym_PIPE_PIPE] = ACTIONS(7526),
    [anon_sym_AMP_AMP] = ACTIONS(7526),
    [anon_sym_LT] = ACTIONS(7528),
    [anon_sym_LT_EQ] = ACTIONS(7526),
    [anon_sym_GT] = ACTIONS(7528),
    [anon_sym_GT_EQ] = ACTIONS(7526),
    [anon_sym_EQ_EQ] = ACTIONS(7526),
    [anon_sym_BANG_EQ] = ACTIONS(7526),
    [anon_sym_STAR] = ACTIONS(7528),
    [anon_sym_SLASH] = ACTIONS(7526),
    [anon_sym_STAR_STAR] = ACTIONS(7526),
    [anon_sym_CARET] = ACTIONS(7526),
    [aux_sym_binary_operator_token1] = ACTIONS(7526),
    [anon_sym_PIPE_GT] = ACTIONS(7526),
    [anon_sym_COLON] = ACTIONS(7528),
    [anon_sym_DOLLAR] = ACTIONS(7526),
    [anon_sym_AT] = ACTIONS(7526),
    [aux_sym__hex_literal_token1] = ACTIONS(7526),
    [sym__number_literal] = ACTIONS(7528),
    [anon_sym_SQUOTE] = ACTIONS(7526),
    [anon_sym_DQUOTE] = ACTIONS(7526),
    [sym_return] = ACTIONS(7528),
    [sym_next] = ACTIONS(7528),
    [sym_break] = ACTIONS(7528),
    [sym_true] = ACTIONS(7528),
    [sym_false] = ACTIONS(7528),
    [sym_null] = ACTIONS(7528),
    [sym_inf] = ACTIONS(7528),
    [sym_nan] = ACTIONS(7528),
    [anon_sym_NA] = ACTIONS(7528),
    [anon_sym_NA_integer_] = ACTIONS(7528),
    [anon_sym_NA_real_] = ACTIONS(7528),
    [anon_sym_NA_complex_] = ACTIONS(7528),
    [anon_sym_NA_character_] = ACTIONS(7528),
    [sym_dots] = ACTIONS(7528),
    [sym_dot_dot_i] = ACTIONS(7526),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7526),
    [sym__newline] = ACTIONS(7526),
    [sym__raw_string_literal] = ACTIONS(7526),
    [sym__external_open_parenthesis] = ACTIONS(7526),
    [sym__external_open_brace] = ACTIONS(7526),
    [sym__external_open_bracket] = ACTIONS(7526),
    [sym__external_close_bracket] = ACTIONS(7526),
    [sym__external_open_bracket2] = ACTIONS(7526),
  },
  [3027] = {
    [sym_identifier] = ACTIONS(7532),
    [anon_sym_BSLASH] = ACTIONS(7530),
    [anon_sym_function] = ACTIONS(7532),
    [anon_sym_EQ] = ACTIONS(7532),
    [anon_sym_if] = ACTIONS(7532),
    [anon_sym_for] = ACTIONS(7532),
    [anon_sym_while] = ACTIONS(7532),
    [anon_sym_repeat] = ACTIONS(7532),
    [anon_sym_QMARK] = ACTIONS(7530),
    [anon_sym_TILDE] = ACTIONS(7530),
    [anon_sym_BANG] = ACTIONS(7532),
    [anon_sym_PLUS] = ACTIONS(7530),
    [anon_sym_DASH] = ACTIONS(7532),
    [anon_sym_LT_DASH] = ACTIONS(7530),
    [anon_sym_LT_LT_DASH] = ACTIONS(7530),
    [anon_sym_COLON_EQ] = ACTIONS(7530),
    [anon_sym_DASH_GT] = ACTIONS(7532),
    [anon_sym_DASH_GT_GT] = ACTIONS(7530),
    [anon_sym_PIPE] = ACTIONS(7532),
    [anon_sym_AMP] = ACTIONS(7532),
    [anon_sym_PIPE_PIPE] = ACTIONS(7530),
    [anon_sym_AMP_AMP] = ACTIONS(7530),
    [anon_sym_LT] = ACTIONS(7532),
    [anon_sym_LT_EQ] = ACTIONS(7530),
    [anon_sym_GT] = ACTIONS(7532),
    [anon_sym_GT_EQ] = ACTIONS(7530),
    [anon_sym_EQ_EQ] = ACTIONS(7530),
    [anon_sym_BANG_EQ] = ACTIONS(7530),
    [anon_sym_STAR] = ACTIONS(7532),
    [anon_sym_SLASH] = ACTIONS(7530),
    [anon_sym_STAR_STAR] = ACTIONS(7530),
    [anon_sym_CARET] = ACTIONS(7530),
    [aux_sym_binary_operator_token1] = ACTIONS(7530),
    [anon_sym_PIPE_GT] = ACTIONS(7530),
    [anon_sym_COLON] = ACTIONS(7532),
    [anon_sym_DOLLAR] = ACTIONS(7530),
    [anon_sym_AT] = ACTIONS(7530),
    [aux_sym__hex_literal_token1] = ACTIONS(7530),
    [sym__number_literal] = ACTIONS(7532),
    [anon_sym_SQUOTE] = ACTIONS(7530),
    [anon_sym_DQUOTE] = ACTIONS(7530),
    [sym_return] = ACTIONS(7532),
    [sym_next] = ACTIONS(7532),
    [sym_break] = ACTIONS(7532),
    [sym_true] = ACTIONS(7532),
    [sym_false] = ACTIONS(7532),
    [sym_null] = ACTIONS(7532),
    [sym_inf] = ACTIONS(7532),
    [sym_nan] = ACTIONS(7532),
    [anon_sym_NA] = ACTIONS(7532),
    [anon_sym_NA_integer_] = ACTIONS(7532),
    [anon_sym_NA_real_] = ACTIONS(7532),
    [anon_sym_NA_complex_] = ACTIONS(7532),
    [anon_sym_NA_character_] = ACTIONS(7532),
    [sym_dots] = ACTIONS(7532),
    [sym_dot_dot_i] = ACTIONS(7530),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(7530),
    [sym__newline] = ACTIONS(7530),
    [sym__raw_string_literal] = ACTIONS(7530),
    [sym__external_open_parenthesis] = ACTIONS(7530),
    [sym__external_open_brace] = ACTIONS(7530),
    [sym__external_open_bracket] = ACTIONS(7530),
    [sym__external_close_bracket] = ACTIONS(7530),
    [sym__external_open_bracket2] = ACTIONS(7530),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2425), 1,
      sym_identifier,
    ACTIONS(2427), 1,
      anon_sym_BSLASH,
    ACTIONS(2429), 1,
      anon_sym_function,
    ACTIONS(2431), 1,
      anon_sym_if,
    ACTIONS(2433), 1,
      anon_sym_for,
    ACTIONS(2435), 1,
      anon_sym_while,
    ACTIONS(2437), 1,
      anon_sym_repeat,
    ACTIONS(2439), 1,
      anon_sym_QMARK,
    ACTIONS(2441), 1,
      anon_sym_TILDE,
    ACTIONS(2449), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2451), 1,
      sym__number_literal,
    ACTIONS(2453), 1,
      anon_sym_SQUOTE,
    ACTIONS(2455), 1,
      anon_sym_DQUOTE,
    ACTIONS(2465), 1,
      sym__raw_string_literal,
    ACTIONS(2467), 1,
      sym__external_open_parenthesis,
    ACTIONS(2471), 1,
      sym__external_open_brace,
    ACTIONS(7781), 1,
      anon_sym_BANG,
    ACTIONS(7785), 1,
      sym_dot_dot_i,
    ACTIONS(7787), 1,
      sym__newline,
    STATE(97), 1,
      sym__open_brace,
    STATE(200), 1,
      sym__open_parenthesis,
    STATE(2369), 1,
      sym__double_quoted_string,
    STATE(2370), 1,
      sym__single_quoted_string,
    STATE(2372), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5138), 1,
      sym__string_or_identifier,
    ACTIONS(2445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2371), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(7783), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1699), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [129] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3491), 1,
      sym_identifier,
    ACTIONS(3493), 1,
      anon_sym_BSLASH,
    ACTIONS(3495), 1,
      anon_sym_function,
    ACTIONS(3497), 1,
      anon_sym_if,
    ACTIONS(3499), 1,
      anon_sym_for,
    ACTIONS(3501), 1,
      anon_sym_while,
    ACTIONS(3503), 1,
      anon_sym_repeat,
    ACTIONS(3505), 1,
      anon_sym_QMARK,
    ACTIONS(3507), 1,
      anon_sym_TILDE,
    ACTIONS(3515), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3517), 1,
      sym__number_literal,
    ACTIONS(3519), 1,
      anon_sym_SQUOTE,
    ACTIONS(3521), 1,
      anon_sym_DQUOTE,
    ACTIONS(3531), 1,
      sym__raw_string_literal,
    ACTIONS(3533), 1,
      sym__external_open_parenthesis,
    ACTIONS(3535), 1,
      sym__external_open_brace,
    ACTIONS(7789), 1,
      anon_sym_BANG,
    ACTIONS(7793), 1,
      sym_dot_dot_i,
    ACTIONS(7795), 1,
      sym__newline,
    STATE(63), 1,
      sym__open_brace,
    STATE(147), 1,
      sym__open_parenthesis,
    STATE(2441), 1,
      sym_string,
    STATE(2456), 1,
      sym__single_quoted_string,
    STATE(2478), 1,
      sym__double_quoted_string,
    STATE(3208), 1,
      aux_sym_function_definition_repeat1,
    STATE(5130), 1,
      sym__string_or_identifier,
    ACTIONS(3511), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2448), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3525), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(7791), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1295), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [258] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2943), 1,
      sym_identifier,
    ACTIONS(2945), 1,
      anon_sym_BSLASH,
    ACTIONS(2947), 1,
      anon_sym_function,
    ACTIONS(2949), 1,
      anon_sym_if,
    ACTIONS(2951), 1,
      anon_sym_for,
    ACTIONS(2953), 1,
      anon_sym_while,
    ACTIONS(2955), 1,
      anon_sym_repeat,
    ACTIONS(2957), 1,
      anon_sym_QMARK,
    ACTIONS(2959), 1,
      anon_sym_TILDE,
    ACTIONS(2967), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2969), 1,
      sym__number_literal,
    ACTIONS(2971), 1,
      anon_sym_SQUOTE,
    ACTIONS(2973), 1,
      anon_sym_DQUOTE,
    ACTIONS(2983), 1,
      sym__raw_string_literal,
    ACTIONS(2985), 1,
      sym__external_open_parenthesis,
    ACTIONS(2989), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7797), 1,
      anon_sym_BANG,
    ACTIONS(7801), 1,
      sym_dot_dot_i,
    STATE(173), 1,
      sym__open_brace,
    STATE(246), 1,
      sym__open_parenthesis,
    STATE(2462), 1,
      sym__single_quoted_string,
    STATE(2494), 1,
      sym__double_quoted_string,
    STATE(2541), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5128), 1,
      sym__string_or_identifier,
    ACTIONS(2963), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2540), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2977), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(7799), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1816), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [387] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2483), 1,
      sym_identifier,
    ACTIONS(2485), 1,
      anon_sym_BSLASH,
    ACTIONS(2487), 1,
      anon_sym_function,
    ACTIONS(2489), 1,
      anon_sym_if,
    ACTIONS(2491), 1,
      anon_sym_for,
    ACTIONS(2493), 1,
      anon_sym_while,
    ACTIONS(2495), 1,
      anon_sym_repeat,
    ACTIONS(2497), 1,
      anon_sym_QMARK,
    ACTIONS(2499), 1,
      anon_sym_TILDE,
    ACTIONS(2507), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2509), 1,
      sym__number_literal,
    ACTIONS(2511), 1,
      anon_sym_SQUOTE,
    ACTIONS(2513), 1,
      anon_sym_DQUOTE,
    ACTIONS(2523), 1,
      sym__raw_string_literal,
    ACTIONS(2525), 1,
      sym__external_open_parenthesis,
    ACTIONS(2529), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7803), 1,
      anon_sym_BANG,
    ACTIONS(7807), 1,
      sym_dot_dot_i,
    STATE(74), 1,
      sym__open_brace,
    STATE(210), 1,
      sym__open_parenthesis,
    STATE(2397), 1,
      sym_string,
    STATE(2430), 1,
      sym__single_quoted_string,
    STATE(2466), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5142), 1,
      sym__string_or_identifier,
    ACTIONS(2503), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2412), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2517), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(7805), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1731), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [516] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2483), 1,
      sym_identifier,
    ACTIONS(2485), 1,
      anon_sym_BSLASH,
    ACTIONS(2487), 1,
      anon_sym_function,
    ACTIONS(2489), 1,
      anon_sym_if,
    ACTIONS(2491), 1,
      anon_sym_for,
    ACTIONS(2493), 1,
      anon_sym_while,
    ACTIONS(2495), 1,
      anon_sym_repeat,
    ACTIONS(2497), 1,
      anon_sym_QMARK,
    ACTIONS(2499), 1,
      anon_sym_TILDE,
    ACTIONS(2507), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2509), 1,
      sym__number_literal,
    ACTIONS(2511), 1,
      anon_sym_SQUOTE,
    ACTIONS(2513), 1,
      anon_sym_DQUOTE,
    ACTIONS(2523), 1,
      sym__raw_string_literal,
    ACTIONS(2525), 1,
      sym__external_open_parenthesis,
    ACTIONS(2529), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7803), 1,
      anon_sym_BANG,
    ACTIONS(7811), 1,
      sym_dot_dot_i,
    STATE(74), 1,
      sym__open_brace,
    STATE(210), 1,
      sym__open_parenthesis,
    STATE(2397), 1,
      sym_string,
    STATE(2430), 1,
      sym__single_quoted_string,
    STATE(2466), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5142), 1,
      sym__string_or_identifier,
    ACTIONS(2503), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2412), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2517), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(7809), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1738), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [645] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2483), 1,
      sym_identifier,
    ACTIONS(2485), 1,
      anon_sym_BSLASH,
    ACTIONS(2487), 1,
      anon_sym_function,
    ACTIONS(2489), 1,
      anon_sym_if,
    ACTIONS(2491), 1,
      anon_sym_for,
    ACTIONS(2493), 1,
      anon_sym_while,
    ACTIONS(2495), 1,
      anon_sym_repeat,
    ACTIONS(2497), 1,
      anon_sym_QMARK,
    ACTIONS(2499), 1,
      anon_sym_TILDE,
    ACTIONS(2507), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2509), 1,
      sym__number_literal,
    ACTIONS(2511), 1,
      anon_sym_SQUOTE,
    ACTIONS(2513), 1,
      anon_sym_DQUOTE,
    ACTIONS(2523), 1,
      sym__raw_string_literal,
    ACTIONS(2525), 1,
      sym__external_open_parenthesis,
    ACTIONS(2529), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7803), 1,
      anon_sym_BANG,
    ACTIONS(7815), 1,
      sym_dot_dot_i,
    STATE(74), 1,
      sym__open_brace,
    STATE(210), 1,
      sym__open_parenthesis,
    STATE(2397), 1,
      sym_string,
    STATE(2430), 1,
      sym__single_quoted_string,
    STATE(2466), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5142), 1,
      sym__string_or_identifier,
    ACTIONS(2503), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2412), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2517), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(7813), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1737), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [774] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2483), 1,
      sym_identifier,
    ACTIONS(2485), 1,
      anon_sym_BSLASH,
    ACTIONS(2487), 1,
      anon_sym_function,
    ACTIONS(2489), 1,
      anon_sym_if,
    ACTIONS(2491), 1,
      anon_sym_for,
    ACTIONS(2493), 1,
      anon_sym_while,
    ACTIONS(2495), 1,
      anon_sym_repeat,
    ACTIONS(2497), 1,
      anon_sym_QMARK,
    ACTIONS(2499), 1,
      anon_sym_TILDE,
    ACTIONS(2507), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2509), 1,
      sym__number_literal,
    ACTIONS(2511), 1,
      anon_sym_SQUOTE,
    ACTIONS(2513), 1,
      anon_sym_DQUOTE,
    ACTIONS(2523), 1,
      sym__raw_string_literal,
    ACTIONS(2525), 1,
      sym__external_open_parenthesis,
    ACTIONS(2529), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7803), 1,
      anon_sym_BANG,
    ACTIONS(7819), 1,
      sym_dot_dot_i,
    STATE(74), 1,
      sym__open_brace,
    STATE(210), 1,
      sym__open_parenthesis,
    STATE(2397), 1,
      sym_string,
    STATE(2430), 1,
      sym__single_quoted_string,
    STATE(2466), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5142), 1,
      sym__string_or_identifier,
    ACTIONS(2503), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2412), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2517), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(7817), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1736), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [903] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4053), 1,
      sym_identifier,
    ACTIONS(4055), 1,
      anon_sym_BSLASH,
    ACTIONS(4057), 1,
      anon_sym_function,
    ACTIONS(4059), 1,
      anon_sym_if,
    ACTIONS(4061), 1,
      anon_sym_for,
    ACTIONS(4063), 1,
      anon_sym_while,
    ACTIONS(4065), 1,
      anon_sym_repeat,
    ACTIONS(4067), 1,
      anon_sym_QMARK,
    ACTIONS(4069), 1,
      anon_sym_TILDE,
    ACTIONS(4077), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4079), 1,
      sym__number_literal,
    ACTIONS(4081), 1,
      anon_sym_SQUOTE,
    ACTIONS(4083), 1,
      anon_sym_DQUOTE,
    ACTIONS(4093), 1,
      sym__raw_string_literal,
    ACTIONS(4095), 1,
      sym__external_open_parenthesis,
    ACTIONS(4097), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7821), 1,
      anon_sym_BANG,
    ACTIONS(7825), 1,
      sym_dot_dot_i,
    STATE(133), 1,
      sym__open_brace,
    STATE(150), 1,
      sym__open_parenthesis,
    STATE(2534), 1,
      sym_string,
    STATE(2538), 1,
      sym__single_quoted_string,
    STATE(2539), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5143), 1,
      sym__string_or_identifier,
    ACTIONS(4073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2536), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4087), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(7823), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1270), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [1032] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4053), 1,
      sym_identifier,
    ACTIONS(4055), 1,
      anon_sym_BSLASH,
    ACTIONS(4057), 1,
      anon_sym_function,
    ACTIONS(4059), 1,
      anon_sym_if,
    ACTIONS(4061), 1,
      anon_sym_for,
    ACTIONS(4063), 1,
      anon_sym_while,
    ACTIONS(4065), 1,
      anon_sym_repeat,
    ACTIONS(4067), 1,
      anon_sym_QMARK,
    ACTIONS(4069), 1,
      anon_sym_TILDE,
    ACTIONS(4077), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4079), 1,
      sym__number_literal,
    ACTIONS(4081), 1,
      anon_sym_SQUOTE,
    ACTIONS(4083), 1,
      anon_sym_DQUOTE,
    ACTIONS(4093), 1,
      sym__raw_string_literal,
    ACTIONS(4095), 1,
      sym__external_open_parenthesis,
    ACTIONS(4097), 1,
      sym__external_open_brace,
    ACTIONS(7821), 1,
      anon_sym_BANG,
    ACTIONS(7829), 1,
      sym_dot_dot_i,
    ACTIONS(7831), 1,
      sym__newline,
    STATE(133), 1,
      sym__open_brace,
    STATE(150), 1,
      sym__open_parenthesis,
    STATE(2534), 1,
      sym_string,
    STATE(2538), 1,
      sym__single_quoted_string,
    STATE(2539), 1,
      sym__double_quoted_string,
    STATE(3035), 1,
      aux_sym_function_definition_repeat1,
    STATE(5143), 1,
      sym__string_or_identifier,
    ACTIONS(4073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2536), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4087), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(7827), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1268), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [1161] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2483), 1,
      sym_identifier,
    ACTIONS(2485), 1,
      anon_sym_BSLASH,
    ACTIONS(2487), 1,
      anon_sym_function,
    ACTIONS(2489), 1,
      anon_sym_if,
    ACTIONS(2491), 1,
      anon_sym_for,
    ACTIONS(2493), 1,
      anon_sym_while,
    ACTIONS(2495), 1,
      anon_sym_repeat,
    ACTIONS(2497), 1,
      anon_sym_QMARK,
    ACTIONS(2499), 1,
      anon_sym_TILDE,
    ACTIONS(2507), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2509), 1,
      sym__number_literal,
    ACTIONS(2511), 1,
      anon_sym_SQUOTE,
    ACTIONS(2513), 1,
      anon_sym_DQUOTE,
    ACTIONS(2523), 1,
      sym__raw_string_literal,
    ACTIONS(2525), 1,
      sym__external_open_parenthesis,
    ACTIONS(2529), 1,
      sym__external_open_brace,
    ACTIONS(7803), 1,
      anon_sym_BANG,
    ACTIONS(7835), 1,
      sym_dot_dot_i,
    ACTIONS(7837), 1,
      sym__newline,
    STATE(74), 1,
      sym__open_brace,
    STATE(210), 1,
      sym__open_parenthesis,
    STATE(2397), 1,
      sym_string,
    STATE(2430), 1,
      sym__single_quoted_string,
    STATE(2466), 1,
      sym__double_quoted_string,
    STATE(3046), 1,
      aux_sym_function_definition_repeat1,
    STATE(5142), 1,
      sym__string_or_identifier,
    ACTIONS(2503), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2412), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2517), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(7833), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1694), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [1290] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2943), 1,
      sym_identifier,
    ACTIONS(2945), 1,
      anon_sym_BSLASH,
    ACTIONS(2947), 1,
      anon_sym_function,
    ACTIONS(2949), 1,
      anon_sym_if,
    ACTIONS(2951), 1,
      anon_sym_for,
    ACTIONS(2953), 1,
      anon_sym_while,
    ACTIONS(2955), 1,
      anon_sym_repeat,
    ACTIONS(2957), 1,
      anon_sym_QMARK,
    ACTIONS(2959), 1,
      anon_sym_TILDE,
    ACTIONS(2967), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2969), 1,
      sym__number_literal,
    ACTIONS(2971), 1,
      anon_sym_SQUOTE,
    ACTIONS(2973), 1,
      anon_sym_DQUOTE,
    ACTIONS(2983), 1,
      sym__raw_string_literal,
    ACTIONS(2985), 1,
      sym__external_open_parenthesis,
    ACTIONS(2989), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7797), 1,
      anon_sym_BANG,
    ACTIONS(7841), 1,
      sym_dot_dot_i,
    STATE(173), 1,
      sym__open_brace,
    STATE(246), 1,
      sym__open_parenthesis,
    STATE(2462), 1,
      sym__single_quoted_string,
    STATE(2494), 1,
      sym__double_quoted_string,
    STATE(2541), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5128), 1,
      sym__string_or_identifier,
    ACTIONS(2963), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2540), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2977), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(7839), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1815), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [1419] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2483), 1,
      sym_identifier,
    ACTIONS(2485), 1,
      anon_sym_BSLASH,
    ACTIONS(2487), 1,
      anon_sym_function,
    ACTIONS(2489), 1,
      anon_sym_if,
    ACTIONS(2491), 1,
      anon_sym_for,
    ACTIONS(2493), 1,
      anon_sym_while,
    ACTIONS(2495), 1,
      anon_sym_repeat,
    ACTIONS(2497), 1,
      anon_sym_QMARK,
    ACTIONS(2499), 1,
      anon_sym_TILDE,
    ACTIONS(2507), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2509), 1,
      sym__number_literal,
    ACTIONS(2511), 1,
      anon_sym_SQUOTE,
    ACTIONS(2513), 1,
      anon_sym_DQUOTE,
    ACTIONS(2523), 1,
      sym__raw_string_literal,
    ACTIONS(2525), 1,
      sym__external_open_parenthesis,
    ACTIONS(2529), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7803), 1,
      anon_sym_BANG,
    ACTIONS(7845), 1,
      sym_dot_dot_i,
    STATE(74), 1,
      sym__open_brace,
    STATE(210), 1,
      sym__open_parenthesis,
    STATE(2397), 1,
      sym_string,
    STATE(2430), 1,
      sym__single_quoted_string,
    STATE(2466), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5142), 1,
      sym__string_or_identifier,
    ACTIONS(2503), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2412), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2517), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(7843), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1734), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [1548] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2483), 1,
      sym_identifier,
    ACTIONS(2485), 1,
      anon_sym_BSLASH,
    ACTIONS(2487), 1,
      anon_sym_function,
    ACTIONS(2489), 1,
      anon_sym_if,
    ACTIONS(2491), 1,
      anon_sym_for,
    ACTIONS(2493), 1,
      anon_sym_while,
    ACTIONS(2495), 1,
      anon_sym_repeat,
    ACTIONS(2497), 1,
      anon_sym_QMARK,
    ACTIONS(2499), 1,
      anon_sym_TILDE,
    ACTIONS(2507), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2509), 1,
      sym__number_literal,
    ACTIONS(2511), 1,
      anon_sym_SQUOTE,
    ACTIONS(2513), 1,
      anon_sym_DQUOTE,
    ACTIONS(2523), 1,
      sym__raw_string_literal,
    ACTIONS(2525), 1,
      sym__external_open_parenthesis,
    ACTIONS(2529), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7803), 1,
      anon_sym_BANG,
    ACTIONS(7849), 1,
      sym_dot_dot_i,
    STATE(74), 1,
      sym__open_brace,
    STATE(210), 1,
      sym__open_parenthesis,
    STATE(2397), 1,
      sym_string,
    STATE(2430), 1,
      sym__single_quoted_string,
    STATE(2466), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5142), 1,
      sym__string_or_identifier,
    ACTIONS(2503), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2412), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2517), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(7847), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1743), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [1677] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2483), 1,
      sym_identifier,
    ACTIONS(2485), 1,
      anon_sym_BSLASH,
    ACTIONS(2487), 1,
      anon_sym_function,
    ACTIONS(2489), 1,
      anon_sym_if,
    ACTIONS(2491), 1,
      anon_sym_for,
    ACTIONS(2493), 1,
      anon_sym_while,
    ACTIONS(2495), 1,
      anon_sym_repeat,
    ACTIONS(2497), 1,
      anon_sym_QMARK,
    ACTIONS(2499), 1,
      anon_sym_TILDE,
    ACTIONS(2507), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2509), 1,
      sym__number_literal,
    ACTIONS(2511), 1,
      anon_sym_SQUOTE,
    ACTIONS(2513), 1,
      anon_sym_DQUOTE,
    ACTIONS(2523), 1,
      sym__raw_string_literal,
    ACTIONS(2525), 1,
      sym__external_open_parenthesis,
    ACTIONS(2529), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7803), 1,
      anon_sym_BANG,
    ACTIONS(7853), 1,
      sym_dot_dot_i,
    STATE(74), 1,
      sym__open_brace,
    STATE(210), 1,
      sym__open_parenthesis,
    STATE(2397), 1,
      sym_string,
    STATE(2430), 1,
      sym__single_quoted_string,
    STATE(2466), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5142), 1,
      sym__string_or_identifier,
    ACTIONS(2503), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2412), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2517), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(7851), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1742), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [1806] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2483), 1,
      sym_identifier,
    ACTIONS(2485), 1,
      anon_sym_BSLASH,
    ACTIONS(2487), 1,
      anon_sym_function,
    ACTIONS(2489), 1,
      anon_sym_if,
    ACTIONS(2491), 1,
      anon_sym_for,
    ACTIONS(2493), 1,
      anon_sym_while,
    ACTIONS(2495), 1,
      anon_sym_repeat,
    ACTIONS(2497), 1,
      anon_sym_QMARK,
    ACTIONS(2499), 1,
      anon_sym_TILDE,
    ACTIONS(2507), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2509), 1,
      sym__number_literal,
    ACTIONS(2511), 1,
      anon_sym_SQUOTE,
    ACTIONS(2513), 1,
      anon_sym_DQUOTE,
    ACTIONS(2523), 1,
      sym__raw_string_literal,
    ACTIONS(2525), 1,
      sym__external_open_parenthesis,
    ACTIONS(2529), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7803), 1,
      anon_sym_BANG,
    ACTIONS(7857), 1,
      sym_dot_dot_i,
    STATE(74), 1,
      sym__open_brace,
    STATE(210), 1,
      sym__open_parenthesis,
    STATE(2397), 1,
      sym_string,
    STATE(2430), 1,
      sym__single_quoted_string,
    STATE(2466), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5142), 1,
      sym__string_or_identifier,
    ACTIONS(2503), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2412), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2517), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(7855), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1741), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [1935] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4053), 1,
      sym_identifier,
    ACTIONS(4055), 1,
      anon_sym_BSLASH,
    ACTIONS(4057), 1,
      anon_sym_function,
    ACTIONS(4059), 1,
      anon_sym_if,
    ACTIONS(4061), 1,
      anon_sym_for,
    ACTIONS(4063), 1,
      anon_sym_while,
    ACTIONS(4065), 1,
      anon_sym_repeat,
    ACTIONS(4067), 1,
      anon_sym_QMARK,
    ACTIONS(4069), 1,
      anon_sym_TILDE,
    ACTIONS(4077), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4079), 1,
      sym__number_literal,
    ACTIONS(4081), 1,
      anon_sym_SQUOTE,
    ACTIONS(4083), 1,
      anon_sym_DQUOTE,
    ACTIONS(4093), 1,
      sym__raw_string_literal,
    ACTIONS(4095), 1,
      sym__external_open_parenthesis,
    ACTIONS(4097), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7821), 1,
      anon_sym_BANG,
    ACTIONS(7861), 1,
      sym_dot_dot_i,
    STATE(133), 1,
      sym__open_brace,
    STATE(150), 1,
      sym__open_parenthesis,
    STATE(2534), 1,
      sym_string,
    STATE(2538), 1,
      sym__single_quoted_string,
    STATE(2539), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5143), 1,
      sym__string_or_identifier,
    ACTIONS(4073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2536), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4087), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(7859), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1266), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [2064] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2483), 1,
      sym_identifier,
    ACTIONS(2485), 1,
      anon_sym_BSLASH,
    ACTIONS(2487), 1,
      anon_sym_function,
    ACTIONS(2489), 1,
      anon_sym_if,
    ACTIONS(2491), 1,
      anon_sym_for,
    ACTIONS(2493), 1,
      anon_sym_while,
    ACTIONS(2495), 1,
      anon_sym_repeat,
    ACTIONS(2497), 1,
      anon_sym_QMARK,
    ACTIONS(2499), 1,
      anon_sym_TILDE,
    ACTIONS(2507), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2509), 1,
      sym__number_literal,
    ACTIONS(2511), 1,
      anon_sym_SQUOTE,
    ACTIONS(2513), 1,
      anon_sym_DQUOTE,
    ACTIONS(2523), 1,
      sym__raw_string_literal,
    ACTIONS(2525), 1,
      sym__external_open_parenthesis,
    ACTIONS(2529), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7803), 1,
      anon_sym_BANG,
    ACTIONS(7865), 1,
      sym_dot_dot_i,
    STATE(74), 1,
      sym__open_brace,
    STATE(210), 1,
      sym__open_parenthesis,
    STATE(2397), 1,
      sym_string,
    STATE(2430), 1,
      sym__single_quoted_string,
    STATE(2466), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5142), 1,
      sym__string_or_identifier,
    ACTIONS(2503), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2412), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2517), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(7863), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1740), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [2193] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2483), 1,
      sym_identifier,
    ACTIONS(2485), 1,
      anon_sym_BSLASH,
    ACTIONS(2487), 1,
      anon_sym_function,
    ACTIONS(2489), 1,
      anon_sym_if,
    ACTIONS(2491), 1,
      anon_sym_for,
    ACTIONS(2493), 1,
      anon_sym_while,
    ACTIONS(2495), 1,
      anon_sym_repeat,
    ACTIONS(2497), 1,
      anon_sym_QMARK,
    ACTIONS(2499), 1,
      anon_sym_TILDE,
    ACTIONS(2507), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2509), 1,
      sym__number_literal,
    ACTIONS(2511), 1,
      anon_sym_SQUOTE,
    ACTIONS(2513), 1,
      anon_sym_DQUOTE,
    ACTIONS(2523), 1,
      sym__raw_string_literal,
    ACTIONS(2525), 1,
      sym__external_open_parenthesis,
    ACTIONS(2529), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7803), 1,
      anon_sym_BANG,
    ACTIONS(7869), 1,
      sym_dot_dot_i,
    STATE(74), 1,
      sym__open_brace,
    STATE(210), 1,
      sym__open_parenthesis,
    STATE(2397), 1,
      sym_string,
    STATE(2430), 1,
      sym__single_quoted_string,
    STATE(2466), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5142), 1,
      sym__string_or_identifier,
    ACTIONS(2503), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2412), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2517), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(7867), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1739), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [2322] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2483), 1,
      sym_identifier,
    ACTIONS(2485), 1,
      anon_sym_BSLASH,
    ACTIONS(2487), 1,
      anon_sym_function,
    ACTIONS(2489), 1,
      anon_sym_if,
    ACTIONS(2491), 1,
      anon_sym_for,
    ACTIONS(2493), 1,
      anon_sym_while,
    ACTIONS(2495), 1,
      anon_sym_repeat,
    ACTIONS(2497), 1,
      anon_sym_QMARK,
    ACTIONS(2499), 1,
      anon_sym_TILDE,
    ACTIONS(2507), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2509), 1,
      sym__number_literal,
    ACTIONS(2511), 1,
      anon_sym_SQUOTE,
    ACTIONS(2513), 1,
      anon_sym_DQUOTE,
    ACTIONS(2523), 1,
      sym__raw_string_literal,
    ACTIONS(2525), 1,
      sym__external_open_parenthesis,
    ACTIONS(2529), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7803), 1,
      anon_sym_BANG,
    ACTIONS(7873), 1,
      sym_dot_dot_i,
    STATE(74), 1,
      sym__open_brace,
    STATE(210), 1,
      sym__open_parenthesis,
    STATE(2397), 1,
      sym_string,
    STATE(2430), 1,
      sym__single_quoted_string,
    STATE(2466), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5142), 1,
      sym__string_or_identifier,
    ACTIONS(2503), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2412), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2517), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(7871), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1733), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [2451] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2943), 1,
      sym_identifier,
    ACTIONS(2945), 1,
      anon_sym_BSLASH,
    ACTIONS(2947), 1,
      anon_sym_function,
    ACTIONS(2949), 1,
      anon_sym_if,
    ACTIONS(2951), 1,
      anon_sym_for,
    ACTIONS(2953), 1,
      anon_sym_while,
    ACTIONS(2955), 1,
      anon_sym_repeat,
    ACTIONS(2957), 1,
      anon_sym_QMARK,
    ACTIONS(2959), 1,
      anon_sym_TILDE,
    ACTIONS(2967), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2969), 1,
      sym__number_literal,
    ACTIONS(2971), 1,
      anon_sym_SQUOTE,
    ACTIONS(2973), 1,
      anon_sym_DQUOTE,
    ACTIONS(2983), 1,
      sym__raw_string_literal,
    ACTIONS(2985), 1,
      sym__external_open_parenthesis,
    ACTIONS(2989), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7797), 1,
      anon_sym_BANG,
    ACTIONS(7877), 1,
      sym_dot_dot_i,
    STATE(173), 1,
      sym__open_brace,
    STATE(246), 1,
      sym__open_parenthesis,
    STATE(2462), 1,
      sym__single_quoted_string,
    STATE(2494), 1,
      sym__double_quoted_string,
    STATE(2541), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5128), 1,
      sym__string_or_identifier,
    ACTIONS(2963), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2540), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2977), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(7875), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1818), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [2580] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2483), 1,
      sym_identifier,
    ACTIONS(2485), 1,
      anon_sym_BSLASH,
    ACTIONS(2487), 1,
      anon_sym_function,
    ACTIONS(2489), 1,
      anon_sym_if,
    ACTIONS(2491), 1,
      anon_sym_for,
    ACTIONS(2493), 1,
      anon_sym_while,
    ACTIONS(2495), 1,
      anon_sym_repeat,
    ACTIONS(2497), 1,
      anon_sym_QMARK,
    ACTIONS(2499), 1,
      anon_sym_TILDE,
    ACTIONS(2507), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2509), 1,
      sym__number_literal,
    ACTIONS(2511), 1,
      anon_sym_SQUOTE,
    ACTIONS(2513), 1,
      anon_sym_DQUOTE,
    ACTIONS(2523), 1,
      sym__raw_string_literal,
    ACTIONS(2525), 1,
      sym__external_open_parenthesis,
    ACTIONS(2529), 1,
      sym__external_open_brace,
    ACTIONS(7803), 1,
      anon_sym_BANG,
    ACTIONS(7881), 1,
      sym_dot_dot_i,
    ACTIONS(7883), 1,
      sym__newline,
    STATE(74), 1,
      sym__open_brace,
    STATE(210), 1,
      sym__open_parenthesis,
    STATE(2397), 1,
      sym_string,
    STATE(2430), 1,
      sym__single_quoted_string,
    STATE(2466), 1,
      sym__double_quoted_string,
    STATE(3040), 1,
      aux_sym_function_definition_repeat1,
    STATE(5142), 1,
      sym__string_or_identifier,
    ACTIONS(2503), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2412), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2517), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(7879), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1714), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [2709] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2483), 1,
      sym_identifier,
    ACTIONS(2485), 1,
      anon_sym_BSLASH,
    ACTIONS(2487), 1,
      anon_sym_function,
    ACTIONS(2489), 1,
      anon_sym_if,
    ACTIONS(2491), 1,
      anon_sym_for,
    ACTIONS(2493), 1,
      anon_sym_while,
    ACTIONS(2495), 1,
      anon_sym_repeat,
    ACTIONS(2497), 1,
      anon_sym_QMARK,
    ACTIONS(2499), 1,
      anon_sym_TILDE,
    ACTIONS(2507), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2509), 1,
      sym__number_literal,
    ACTIONS(2511), 1,
      anon_sym_SQUOTE,
    ACTIONS(2513), 1,
      anon_sym_DQUOTE,
    ACTIONS(2523), 1,
      sym__raw_string_literal,
    ACTIONS(2525), 1,
      sym__external_open_parenthesis,
    ACTIONS(2529), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7803), 1,
      anon_sym_BANG,
    ACTIONS(7887), 1,
      sym_dot_dot_i,
    STATE(74), 1,
      sym__open_brace,
    STATE(210), 1,
      sym__open_parenthesis,
    STATE(2397), 1,
      sym_string,
    STATE(2430), 1,
      sym__single_quoted_string,
    STATE(2466), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5142), 1,
      sym__string_or_identifier,
    ACTIONS(2503), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2412), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2517), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(7885), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1732), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [2838] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2483), 1,
      sym_identifier,
    ACTIONS(2485), 1,
      anon_sym_BSLASH,
    ACTIONS(2487), 1,
      anon_sym_function,
    ACTIONS(2489), 1,
      anon_sym_if,
    ACTIONS(2491), 1,
      anon_sym_for,
    ACTIONS(2493), 1,
      anon_sym_while,
    ACTIONS(2495), 1,
      anon_sym_repeat,
    ACTIONS(2497), 1,
      anon_sym_QMARK,
    ACTIONS(2499), 1,
      anon_sym_TILDE,
    ACTIONS(2507), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2509), 1,
      sym__number_literal,
    ACTIONS(2511), 1,
      anon_sym_SQUOTE,
    ACTIONS(2513), 1,
      anon_sym_DQUOTE,
    ACTIONS(2523), 1,
      sym__raw_string_literal,
    ACTIONS(2525), 1,
      sym__external_open_parenthesis,
    ACTIONS(2529), 1,
      sym__external_open_brace,
    ACTIONS(7803), 1,
      anon_sym_BANG,
    ACTIONS(7891), 1,
      sym_dot_dot_i,
    ACTIONS(7893), 1,
      sym__newline,
    STATE(74), 1,
      sym__open_brace,
    STATE(210), 1,
      sym__open_parenthesis,
    STATE(2397), 1,
      sym_string,
    STATE(2430), 1,
      sym__single_quoted_string,
    STATE(2466), 1,
      sym__double_quoted_string,
    STATE(3041), 1,
      aux_sym_function_definition_repeat1,
    STATE(5142), 1,
      sym__string_or_identifier,
    ACTIONS(2503), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2412), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2517), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(7889), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1712), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [2967] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3491), 1,
      sym_identifier,
    ACTIONS(3493), 1,
      anon_sym_BSLASH,
    ACTIONS(3495), 1,
      anon_sym_function,
    ACTIONS(3497), 1,
      anon_sym_if,
    ACTIONS(3499), 1,
      anon_sym_for,
    ACTIONS(3501), 1,
      anon_sym_while,
    ACTIONS(3503), 1,
      anon_sym_repeat,
    ACTIONS(3505), 1,
      anon_sym_QMARK,
    ACTIONS(3507), 1,
      anon_sym_TILDE,
    ACTIONS(3515), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3517), 1,
      sym__number_literal,
    ACTIONS(3519), 1,
      anon_sym_SQUOTE,
    ACTIONS(3521), 1,
      anon_sym_DQUOTE,
    ACTIONS(3531), 1,
      sym__raw_string_literal,
    ACTIONS(3533), 1,
      sym__external_open_parenthesis,
    ACTIONS(3535), 1,
      sym__external_open_brace,
    ACTIONS(7789), 1,
      anon_sym_BANG,
    ACTIONS(7897), 1,
      sym_dot_dot_i,
    ACTIONS(7899), 1,
      sym__newline,
    STATE(63), 1,
      sym__open_brace,
    STATE(147), 1,
      sym__open_parenthesis,
    STATE(2441), 1,
      sym_string,
    STATE(2456), 1,
      sym__single_quoted_string,
    STATE(2478), 1,
      sym__double_quoted_string,
    STATE(3064), 1,
      aux_sym_function_definition_repeat1,
    STATE(5130), 1,
      sym__string_or_identifier,
    ACTIONS(3511), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2448), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3525), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(7895), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1660), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [3096] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3491), 1,
      sym_identifier,
    ACTIONS(3493), 1,
      anon_sym_BSLASH,
    ACTIONS(3495), 1,
      anon_sym_function,
    ACTIONS(3497), 1,
      anon_sym_if,
    ACTIONS(3499), 1,
      anon_sym_for,
    ACTIONS(3501), 1,
      anon_sym_while,
    ACTIONS(3503), 1,
      anon_sym_repeat,
    ACTIONS(3505), 1,
      anon_sym_QMARK,
    ACTIONS(3507), 1,
      anon_sym_TILDE,
    ACTIONS(3515), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3517), 1,
      sym__number_literal,
    ACTIONS(3519), 1,
      anon_sym_SQUOTE,
    ACTIONS(3521), 1,
      anon_sym_DQUOTE,
    ACTIONS(3531), 1,
      sym__raw_string_literal,
    ACTIONS(3533), 1,
      sym__external_open_parenthesis,
    ACTIONS(3535), 1,
      sym__external_open_brace,
    ACTIONS(7789), 1,
      anon_sym_BANG,
    ACTIONS(7903), 1,
      sym_dot_dot_i,
    ACTIONS(7905), 1,
      sym__newline,
    STATE(63), 1,
      sym__open_brace,
    STATE(147), 1,
      sym__open_parenthesis,
    STATE(2441), 1,
      sym_string,
    STATE(2456), 1,
      sym__single_quoted_string,
    STATE(2478), 1,
      sym__double_quoted_string,
    STATE(3066), 1,
      aux_sym_function_definition_repeat1,
    STATE(5130), 1,
      sym__string_or_identifier,
    ACTIONS(3511), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2448), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3525), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(7901), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1659), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [3225] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3491), 1,
      sym_identifier,
    ACTIONS(3493), 1,
      anon_sym_BSLASH,
    ACTIONS(3495), 1,
      anon_sym_function,
    ACTIONS(3497), 1,
      anon_sym_if,
    ACTIONS(3499), 1,
      anon_sym_for,
    ACTIONS(3501), 1,
      anon_sym_while,
    ACTIONS(3503), 1,
      anon_sym_repeat,
    ACTIONS(3505), 1,
      anon_sym_QMARK,
    ACTIONS(3507), 1,
      anon_sym_TILDE,
    ACTIONS(3515), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3517), 1,
      sym__number_literal,
    ACTIONS(3519), 1,
      anon_sym_SQUOTE,
    ACTIONS(3521), 1,
      anon_sym_DQUOTE,
    ACTIONS(3531), 1,
      sym__raw_string_literal,
    ACTIONS(3533), 1,
      sym__external_open_parenthesis,
    ACTIONS(3535), 1,
      sym__external_open_brace,
    ACTIONS(7789), 1,
      anon_sym_BANG,
    ACTIONS(7909), 1,
      sym_dot_dot_i,
    ACTIONS(7911), 1,
      sym__newline,
    STATE(63), 1,
      sym__open_brace,
    STATE(147), 1,
      sym__open_parenthesis,
    STATE(2441), 1,
      sym_string,
    STATE(2456), 1,
      sym__single_quoted_string,
    STATE(2478), 1,
      sym__double_quoted_string,
    STATE(3068), 1,
      aux_sym_function_definition_repeat1,
    STATE(5130), 1,
      sym__string_or_identifier,
    ACTIONS(3511), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2448), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3525), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(7907), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1658), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [3354] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3491), 1,
      sym_identifier,
    ACTIONS(3493), 1,
      anon_sym_BSLASH,
    ACTIONS(3495), 1,
      anon_sym_function,
    ACTIONS(3497), 1,
      anon_sym_if,
    ACTIONS(3499), 1,
      anon_sym_for,
    ACTIONS(3501), 1,
      anon_sym_while,
    ACTIONS(3503), 1,
      anon_sym_repeat,
    ACTIONS(3505), 1,
      anon_sym_QMARK,
    ACTIONS(3507), 1,
      anon_sym_TILDE,
    ACTIONS(3515), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3517), 1,
      sym__number_literal,
    ACTIONS(3519), 1,
      anon_sym_SQUOTE,
    ACTIONS(3521), 1,
      anon_sym_DQUOTE,
    ACTIONS(3531), 1,
      sym__raw_string_literal,
    ACTIONS(3533), 1,
      sym__external_open_parenthesis,
    ACTIONS(3535), 1,
      sym__external_open_brace,
    ACTIONS(7789), 1,
      anon_sym_BANG,
    ACTIONS(7915), 1,
      sym_dot_dot_i,
    ACTIONS(7917), 1,
      sym__newline,
    STATE(63), 1,
      sym__open_brace,
    STATE(147), 1,
      sym__open_parenthesis,
    STATE(2441), 1,
      sym_string,
    STATE(2456), 1,
      sym__single_quoted_string,
    STATE(2478), 1,
      sym__double_quoted_string,
    STATE(3070), 1,
      aux_sym_function_definition_repeat1,
    STATE(5130), 1,
      sym__string_or_identifier,
    ACTIONS(3511), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2448), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3525), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(7913), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1657), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [3483] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4053), 1,
      sym_identifier,
    ACTIONS(4055), 1,
      anon_sym_BSLASH,
    ACTIONS(4057), 1,
      anon_sym_function,
    ACTIONS(4059), 1,
      anon_sym_if,
    ACTIONS(4061), 1,
      anon_sym_for,
    ACTIONS(4063), 1,
      anon_sym_while,
    ACTIONS(4065), 1,
      anon_sym_repeat,
    ACTIONS(4067), 1,
      anon_sym_QMARK,
    ACTIONS(4069), 1,
      anon_sym_TILDE,
    ACTIONS(4077), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4079), 1,
      sym__number_literal,
    ACTIONS(4081), 1,
      anon_sym_SQUOTE,
    ACTIONS(4083), 1,
      anon_sym_DQUOTE,
    ACTIONS(4093), 1,
      sym__raw_string_literal,
    ACTIONS(4095), 1,
      sym__external_open_parenthesis,
    ACTIONS(4097), 1,
      sym__external_open_brace,
    ACTIONS(7821), 1,
      anon_sym_BANG,
    ACTIONS(7921), 1,
      sym_dot_dot_i,
    ACTIONS(7923), 1,
      sym__newline,
    STATE(133), 1,
      sym__open_brace,
    STATE(150), 1,
      sym__open_parenthesis,
    STATE(2534), 1,
      sym_string,
    STATE(2538), 1,
      sym__single_quoted_string,
    STATE(2539), 1,
      sym__double_quoted_string,
    STATE(3043), 1,
      aux_sym_function_definition_repeat1,
    STATE(5143), 1,
      sym__string_or_identifier,
    ACTIONS(4073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2536), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4087), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(7919), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1265), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [3612] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2425), 1,
      sym_identifier,
    ACTIONS(2427), 1,
      anon_sym_BSLASH,
    ACTIONS(2429), 1,
      anon_sym_function,
    ACTIONS(2431), 1,
      anon_sym_if,
    ACTIONS(2433), 1,
      anon_sym_for,
    ACTIONS(2435), 1,
      anon_sym_while,
    ACTIONS(2437), 1,
      anon_sym_repeat,
    ACTIONS(2439), 1,
      anon_sym_QMARK,
    ACTIONS(2441), 1,
      anon_sym_TILDE,
    ACTIONS(2449), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2451), 1,
      sym__number_literal,
    ACTIONS(2453), 1,
      anon_sym_SQUOTE,
    ACTIONS(2455), 1,
      anon_sym_DQUOTE,
    ACTIONS(2465), 1,
      sym__raw_string_literal,
    ACTIONS(2467), 1,
      sym__external_open_parenthesis,
    ACTIONS(2471), 1,
      sym__external_open_brace,
    ACTIONS(7781), 1,
      anon_sym_BANG,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7927), 1,
      sym_dot_dot_i,
    STATE(97), 1,
      sym__open_brace,
    STATE(200), 1,
      sym__open_parenthesis,
    STATE(2369), 1,
      sym__double_quoted_string,
    STATE(2370), 1,
      sym__single_quoted_string,
    STATE(2372), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5138), 1,
      sym__string_or_identifier,
    ACTIONS(2445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2371), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(7925), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1695), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [3741] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2425), 1,
      sym_identifier,
    ACTIONS(2427), 1,
      anon_sym_BSLASH,
    ACTIONS(2429), 1,
      anon_sym_function,
    ACTIONS(2431), 1,
      anon_sym_if,
    ACTIONS(2433), 1,
      anon_sym_for,
    ACTIONS(2435), 1,
      anon_sym_while,
    ACTIONS(2437), 1,
      anon_sym_repeat,
    ACTIONS(2439), 1,
      anon_sym_QMARK,
    ACTIONS(2441), 1,
      anon_sym_TILDE,
    ACTIONS(2449), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2451), 1,
      sym__number_literal,
    ACTIONS(2453), 1,
      anon_sym_SQUOTE,
    ACTIONS(2455), 1,
      anon_sym_DQUOTE,
    ACTIONS(2465), 1,
      sym__raw_string_literal,
    ACTIONS(2467), 1,
      sym__external_open_parenthesis,
    ACTIONS(2471), 1,
      sym__external_open_brace,
    ACTIONS(7781), 1,
      anon_sym_BANG,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7931), 1,
      sym_dot_dot_i,
    STATE(97), 1,
      sym__open_brace,
    STATE(200), 1,
      sym__open_parenthesis,
    STATE(2369), 1,
      sym__double_quoted_string,
    STATE(2370), 1,
      sym__single_quoted_string,
    STATE(2372), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5138), 1,
      sym__string_or_identifier,
    ACTIONS(2445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2371), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(7929), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1697), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [3870] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(626), 1,
      sym_identifier,
    ACTIONS(628), 1,
      anon_sym_BSLASH,
    ACTIONS(630), 1,
      anon_sym_function,
    ACTIONS(632), 1,
      anon_sym_if,
    ACTIONS(634), 1,
      anon_sym_for,
    ACTIONS(636), 1,
      anon_sym_while,
    ACTIONS(638), 1,
      anon_sym_repeat,
    ACTIONS(640), 1,
      anon_sym_QMARK,
    ACTIONS(642), 1,
      anon_sym_TILDE,
    ACTIONS(650), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(652), 1,
      sym__number_literal,
    ACTIONS(654), 1,
      anon_sym_SQUOTE,
    ACTIONS(656), 1,
      anon_sym_DQUOTE,
    ACTIONS(666), 1,
      sym__raw_string_literal,
    ACTIONS(668), 1,
      sym__external_open_parenthesis,
    ACTIONS(670), 1,
      sym__external_open_brace,
    ACTIONS(7933), 1,
      anon_sym_BANG,
    ACTIONS(7937), 1,
      sym_dot_dot_i,
    ACTIONS(7939), 1,
      sym__newline,
    STATE(54), 1,
      sym__open_parenthesis,
    STATE(56), 1,
      sym__open_brace,
    STATE(2219), 1,
      sym_string,
    STATE(2221), 1,
      sym__single_quoted_string,
    STATE(2222), 1,
      sym__double_quoted_string,
    STATE(3343), 1,
      aux_sym_function_definition_repeat1,
    STATE(5140), 1,
      sym__string_or_identifier,
    ACTIONS(646), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2220), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(660), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(7935), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(676), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [3999] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2425), 1,
      sym_identifier,
    ACTIONS(2427), 1,
      anon_sym_BSLASH,
    ACTIONS(2429), 1,
      anon_sym_function,
    ACTIONS(2431), 1,
      anon_sym_if,
    ACTIONS(2433), 1,
      anon_sym_for,
    ACTIONS(2435), 1,
      anon_sym_while,
    ACTIONS(2437), 1,
      anon_sym_repeat,
    ACTIONS(2439), 1,
      anon_sym_QMARK,
    ACTIONS(2441), 1,
      anon_sym_TILDE,
    ACTIONS(2449), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2451), 1,
      sym__number_literal,
    ACTIONS(2453), 1,
      anon_sym_SQUOTE,
    ACTIONS(2455), 1,
      anon_sym_DQUOTE,
    ACTIONS(2465), 1,
      sym__raw_string_literal,
    ACTIONS(2467), 1,
      sym__external_open_parenthesis,
    ACTIONS(2471), 1,
      sym__external_open_brace,
    ACTIONS(7781), 1,
      anon_sym_BANG,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7943), 1,
      sym_dot_dot_i,
    STATE(97), 1,
      sym__open_brace,
    STATE(200), 1,
      sym__open_parenthesis,
    STATE(2369), 1,
      sym__double_quoted_string,
    STATE(2370), 1,
      sym__single_quoted_string,
    STATE(2372), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5138), 1,
      sym__string_or_identifier,
    ACTIONS(2445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2371), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(7941), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1701), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [4128] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2943), 1,
      sym_identifier,
    ACTIONS(2945), 1,
      anon_sym_BSLASH,
    ACTIONS(2947), 1,
      anon_sym_function,
    ACTIONS(2949), 1,
      anon_sym_if,
    ACTIONS(2951), 1,
      anon_sym_for,
    ACTIONS(2953), 1,
      anon_sym_while,
    ACTIONS(2955), 1,
      anon_sym_repeat,
    ACTIONS(2957), 1,
      anon_sym_QMARK,
    ACTIONS(2959), 1,
      anon_sym_TILDE,
    ACTIONS(2967), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2969), 1,
      sym__number_literal,
    ACTIONS(2971), 1,
      anon_sym_SQUOTE,
    ACTIONS(2973), 1,
      anon_sym_DQUOTE,
    ACTIONS(2983), 1,
      sym__raw_string_literal,
    ACTIONS(2985), 1,
      sym__external_open_parenthesis,
    ACTIONS(2989), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7797), 1,
      anon_sym_BANG,
    ACTIONS(7947), 1,
      sym_dot_dot_i,
    STATE(173), 1,
      sym__open_brace,
    STATE(246), 1,
      sym__open_parenthesis,
    STATE(2462), 1,
      sym__single_quoted_string,
    STATE(2494), 1,
      sym__double_quoted_string,
    STATE(2541), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5128), 1,
      sym__string_or_identifier,
    ACTIONS(2963), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2540), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2977), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(7945), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1810), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [4257] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2483), 1,
      sym_identifier,
    ACTIONS(2485), 1,
      anon_sym_BSLASH,
    ACTIONS(2487), 1,
      anon_sym_function,
    ACTIONS(2489), 1,
      anon_sym_if,
    ACTIONS(2491), 1,
      anon_sym_for,
    ACTIONS(2493), 1,
      anon_sym_while,
    ACTIONS(2495), 1,
      anon_sym_repeat,
    ACTIONS(2497), 1,
      anon_sym_QMARK,
    ACTIONS(2499), 1,
      anon_sym_TILDE,
    ACTIONS(2507), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2509), 1,
      sym__number_literal,
    ACTIONS(2511), 1,
      anon_sym_SQUOTE,
    ACTIONS(2513), 1,
      anon_sym_DQUOTE,
    ACTIONS(2523), 1,
      sym__raw_string_literal,
    ACTIONS(2525), 1,
      sym__external_open_parenthesis,
    ACTIONS(2529), 1,
      sym__external_open_brace,
    ACTIONS(7803), 1,
      anon_sym_BANG,
    ACTIONS(7951), 1,
      sym_dot_dot_i,
    ACTIONS(7953), 1,
      sym__newline,
    STATE(74), 1,
      sym__open_brace,
    STATE(210), 1,
      sym__open_parenthesis,
    STATE(2397), 1,
      sym_string,
    STATE(2430), 1,
      sym__single_quoted_string,
    STATE(2466), 1,
      sym__double_quoted_string,
    STATE(3042), 1,
      aux_sym_function_definition_repeat1,
    STATE(5142), 1,
      sym__string_or_identifier,
    ACTIONS(2503), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2412), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2517), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(7949), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1710), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [4386] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2483), 1,
      sym_identifier,
    ACTIONS(2485), 1,
      anon_sym_BSLASH,
    ACTIONS(2487), 1,
      anon_sym_function,
    ACTIONS(2489), 1,
      anon_sym_if,
    ACTIONS(2491), 1,
      anon_sym_for,
    ACTIONS(2493), 1,
      anon_sym_while,
    ACTIONS(2495), 1,
      anon_sym_repeat,
    ACTIONS(2497), 1,
      anon_sym_QMARK,
    ACTIONS(2499), 1,
      anon_sym_TILDE,
    ACTIONS(2507), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2509), 1,
      sym__number_literal,
    ACTIONS(2511), 1,
      anon_sym_SQUOTE,
    ACTIONS(2513), 1,
      anon_sym_DQUOTE,
    ACTIONS(2523), 1,
      sym__raw_string_literal,
    ACTIONS(2525), 1,
      sym__external_open_parenthesis,
    ACTIONS(2529), 1,
      sym__external_open_brace,
    ACTIONS(7803), 1,
      anon_sym_BANG,
    ACTIONS(7957), 1,
      sym_dot_dot_i,
    ACTIONS(7959), 1,
      sym__newline,
    STATE(74), 1,
      sym__open_brace,
    STATE(210), 1,
      sym__open_parenthesis,
    STATE(2397), 1,
      sym_string,
    STATE(2430), 1,
      sym__single_quoted_string,
    STATE(2466), 1,
      sym__double_quoted_string,
    STATE(3044), 1,
      aux_sym_function_definition_repeat1,
    STATE(5142), 1,
      sym__string_or_identifier,
    ACTIONS(2503), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2412), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2517), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(7955), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1708), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [4515] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2483), 1,
      sym_identifier,
    ACTIONS(2485), 1,
      anon_sym_BSLASH,
    ACTIONS(2487), 1,
      anon_sym_function,
    ACTIONS(2489), 1,
      anon_sym_if,
    ACTIONS(2491), 1,
      anon_sym_for,
    ACTIONS(2493), 1,
      anon_sym_while,
    ACTIONS(2495), 1,
      anon_sym_repeat,
    ACTIONS(2497), 1,
      anon_sym_QMARK,
    ACTIONS(2499), 1,
      anon_sym_TILDE,
    ACTIONS(2507), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2509), 1,
      sym__number_literal,
    ACTIONS(2511), 1,
      anon_sym_SQUOTE,
    ACTIONS(2513), 1,
      anon_sym_DQUOTE,
    ACTIONS(2523), 1,
      sym__raw_string_literal,
    ACTIONS(2525), 1,
      sym__external_open_parenthesis,
    ACTIONS(2529), 1,
      sym__external_open_brace,
    ACTIONS(7803), 1,
      anon_sym_BANG,
    ACTIONS(7963), 1,
      sym_dot_dot_i,
    ACTIONS(7965), 1,
      sym__newline,
    STATE(74), 1,
      sym__open_brace,
    STATE(210), 1,
      sym__open_parenthesis,
    STATE(2397), 1,
      sym_string,
    STATE(2430), 1,
      sym__single_quoted_string,
    STATE(2466), 1,
      sym__double_quoted_string,
    STATE(3045), 1,
      aux_sym_function_definition_repeat1,
    STATE(5142), 1,
      sym__string_or_identifier,
    ACTIONS(2503), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2412), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2517), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(7961), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1706), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [4644] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3491), 1,
      sym_identifier,
    ACTIONS(3493), 1,
      anon_sym_BSLASH,
    ACTIONS(3495), 1,
      anon_sym_function,
    ACTIONS(3497), 1,
      anon_sym_if,
    ACTIONS(3499), 1,
      anon_sym_for,
    ACTIONS(3501), 1,
      anon_sym_while,
    ACTIONS(3503), 1,
      anon_sym_repeat,
    ACTIONS(3505), 1,
      anon_sym_QMARK,
    ACTIONS(3507), 1,
      anon_sym_TILDE,
    ACTIONS(3515), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3517), 1,
      sym__number_literal,
    ACTIONS(3519), 1,
      anon_sym_SQUOTE,
    ACTIONS(3521), 1,
      anon_sym_DQUOTE,
    ACTIONS(3531), 1,
      sym__raw_string_literal,
    ACTIONS(3533), 1,
      sym__external_open_parenthesis,
    ACTIONS(3535), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7789), 1,
      anon_sym_BANG,
    ACTIONS(7969), 1,
      sym_dot_dot_i,
    STATE(63), 1,
      sym__open_brace,
    STATE(147), 1,
      sym__open_parenthesis,
    STATE(2441), 1,
      sym_string,
    STATE(2456), 1,
      sym__single_quoted_string,
    STATE(2478), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5130), 1,
      sym__string_or_identifier,
    ACTIONS(3511), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2448), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3525), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(7967), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1650), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [4773] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2483), 1,
      sym_identifier,
    ACTIONS(2485), 1,
      anon_sym_BSLASH,
    ACTIONS(2487), 1,
      anon_sym_function,
    ACTIONS(2489), 1,
      anon_sym_if,
    ACTIONS(2491), 1,
      anon_sym_for,
    ACTIONS(2493), 1,
      anon_sym_while,
    ACTIONS(2495), 1,
      anon_sym_repeat,
    ACTIONS(2497), 1,
      anon_sym_QMARK,
    ACTIONS(2499), 1,
      anon_sym_TILDE,
    ACTIONS(2507), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2509), 1,
      sym__number_literal,
    ACTIONS(2511), 1,
      anon_sym_SQUOTE,
    ACTIONS(2513), 1,
      anon_sym_DQUOTE,
    ACTIONS(2523), 1,
      sym__raw_string_literal,
    ACTIONS(2525), 1,
      sym__external_open_parenthesis,
    ACTIONS(2529), 1,
      sym__external_open_brace,
    ACTIONS(7803), 1,
      anon_sym_BANG,
    ACTIONS(7973), 1,
      sym_dot_dot_i,
    ACTIONS(7975), 1,
      sym__newline,
    STATE(74), 1,
      sym__open_brace,
    STATE(210), 1,
      sym__open_parenthesis,
    STATE(2397), 1,
      sym_string,
    STATE(2430), 1,
      sym__single_quoted_string,
    STATE(2466), 1,
      sym__double_quoted_string,
    STATE(3032), 1,
      aux_sym_function_definition_repeat1,
    STATE(5142), 1,
      sym__string_or_identifier,
    ACTIONS(2503), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2412), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2517), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(7971), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1704), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [4902] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3491), 1,
      sym_identifier,
    ACTIONS(3493), 1,
      anon_sym_BSLASH,
    ACTIONS(3495), 1,
      anon_sym_function,
    ACTIONS(3497), 1,
      anon_sym_if,
    ACTIONS(3499), 1,
      anon_sym_for,
    ACTIONS(3501), 1,
      anon_sym_while,
    ACTIONS(3503), 1,
      anon_sym_repeat,
    ACTIONS(3505), 1,
      anon_sym_QMARK,
    ACTIONS(3507), 1,
      anon_sym_TILDE,
    ACTIONS(3515), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3517), 1,
      sym__number_literal,
    ACTIONS(3519), 1,
      anon_sym_SQUOTE,
    ACTIONS(3521), 1,
      anon_sym_DQUOTE,
    ACTIONS(3531), 1,
      sym__raw_string_literal,
    ACTIONS(3533), 1,
      sym__external_open_parenthesis,
    ACTIONS(3535), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7789), 1,
      anon_sym_BANG,
    ACTIONS(7979), 1,
      sym_dot_dot_i,
    STATE(63), 1,
      sym__open_brace,
    STATE(147), 1,
      sym__open_parenthesis,
    STATE(2441), 1,
      sym_string,
    STATE(2456), 1,
      sym__single_quoted_string,
    STATE(2478), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5130), 1,
      sym__string_or_identifier,
    ACTIONS(3511), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2448), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3525), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(7977), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1649), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [5031] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2483), 1,
      sym_identifier,
    ACTIONS(2485), 1,
      anon_sym_BSLASH,
    ACTIONS(2487), 1,
      anon_sym_function,
    ACTIONS(2489), 1,
      anon_sym_if,
    ACTIONS(2491), 1,
      anon_sym_for,
    ACTIONS(2493), 1,
      anon_sym_while,
    ACTIONS(2495), 1,
      anon_sym_repeat,
    ACTIONS(2497), 1,
      anon_sym_QMARK,
    ACTIONS(2499), 1,
      anon_sym_TILDE,
    ACTIONS(2507), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2509), 1,
      sym__number_literal,
    ACTIONS(2511), 1,
      anon_sym_SQUOTE,
    ACTIONS(2513), 1,
      anon_sym_DQUOTE,
    ACTIONS(2523), 1,
      sym__raw_string_literal,
    ACTIONS(2525), 1,
      sym__external_open_parenthesis,
    ACTIONS(2529), 1,
      sym__external_open_brace,
    ACTIONS(7803), 1,
      anon_sym_BANG,
    ACTIONS(7983), 1,
      sym_dot_dot_i,
    ACTIONS(7985), 1,
      sym__newline,
    STATE(74), 1,
      sym__open_brace,
    STATE(210), 1,
      sym__open_parenthesis,
    STATE(2397), 1,
      sym_string,
    STATE(2430), 1,
      sym__single_quoted_string,
    STATE(2466), 1,
      sym__double_quoted_string,
    STATE(3033), 1,
      aux_sym_function_definition_repeat1,
    STATE(5142), 1,
      sym__string_or_identifier,
    ACTIONS(2503), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2412), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2517), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(7981), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1702), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [5160] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3491), 1,
      sym_identifier,
    ACTIONS(3493), 1,
      anon_sym_BSLASH,
    ACTIONS(3495), 1,
      anon_sym_function,
    ACTIONS(3497), 1,
      anon_sym_if,
    ACTIONS(3499), 1,
      anon_sym_for,
    ACTIONS(3501), 1,
      anon_sym_while,
    ACTIONS(3503), 1,
      anon_sym_repeat,
    ACTIONS(3505), 1,
      anon_sym_QMARK,
    ACTIONS(3507), 1,
      anon_sym_TILDE,
    ACTIONS(3515), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3517), 1,
      sym__number_literal,
    ACTIONS(3519), 1,
      anon_sym_SQUOTE,
    ACTIONS(3521), 1,
      anon_sym_DQUOTE,
    ACTIONS(3531), 1,
      sym__raw_string_literal,
    ACTIONS(3533), 1,
      sym__external_open_parenthesis,
    ACTIONS(3535), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7789), 1,
      anon_sym_BANG,
    ACTIONS(7989), 1,
      sym_dot_dot_i,
    STATE(63), 1,
      sym__open_brace,
    STATE(147), 1,
      sym__open_parenthesis,
    STATE(2441), 1,
      sym_string,
    STATE(2456), 1,
      sym__single_quoted_string,
    STATE(2478), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5130), 1,
      sym__string_or_identifier,
    ACTIONS(3511), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2448), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3525), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(7987), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1648), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [5289] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2483), 1,
      sym_identifier,
    ACTIONS(2485), 1,
      anon_sym_BSLASH,
    ACTIONS(2487), 1,
      anon_sym_function,
    ACTIONS(2489), 1,
      anon_sym_if,
    ACTIONS(2491), 1,
      anon_sym_for,
    ACTIONS(2493), 1,
      anon_sym_while,
    ACTIONS(2495), 1,
      anon_sym_repeat,
    ACTIONS(2497), 1,
      anon_sym_QMARK,
    ACTIONS(2499), 1,
      anon_sym_TILDE,
    ACTIONS(2507), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2509), 1,
      sym__number_literal,
    ACTIONS(2511), 1,
      anon_sym_SQUOTE,
    ACTIONS(2513), 1,
      anon_sym_DQUOTE,
    ACTIONS(2523), 1,
      sym__raw_string_literal,
    ACTIONS(2525), 1,
      sym__external_open_parenthesis,
    ACTIONS(2529), 1,
      sym__external_open_brace,
    ACTIONS(7803), 1,
      anon_sym_BANG,
    ACTIONS(7993), 1,
      sym_dot_dot_i,
    ACTIONS(7995), 1,
      sym__newline,
    STATE(74), 1,
      sym__open_brace,
    STATE(210), 1,
      sym__open_parenthesis,
    STATE(2397), 1,
      sym_string,
    STATE(2430), 1,
      sym__single_quoted_string,
    STATE(2466), 1,
      sym__double_quoted_string,
    STATE(3034), 1,
      aux_sym_function_definition_repeat1,
    STATE(5142), 1,
      sym__string_or_identifier,
    ACTIONS(2503), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2412), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2517), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(7991), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1700), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [5418] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3491), 1,
      sym_identifier,
    ACTIONS(3493), 1,
      anon_sym_BSLASH,
    ACTIONS(3495), 1,
      anon_sym_function,
    ACTIONS(3497), 1,
      anon_sym_if,
    ACTIONS(3499), 1,
      anon_sym_for,
    ACTIONS(3501), 1,
      anon_sym_while,
    ACTIONS(3503), 1,
      anon_sym_repeat,
    ACTIONS(3505), 1,
      anon_sym_QMARK,
    ACTIONS(3507), 1,
      anon_sym_TILDE,
    ACTIONS(3515), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3517), 1,
      sym__number_literal,
    ACTIONS(3519), 1,
      anon_sym_SQUOTE,
    ACTIONS(3521), 1,
      anon_sym_DQUOTE,
    ACTIONS(3531), 1,
      sym__raw_string_literal,
    ACTIONS(3533), 1,
      sym__external_open_parenthesis,
    ACTIONS(3535), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7789), 1,
      anon_sym_BANG,
    ACTIONS(7999), 1,
      sym_dot_dot_i,
    STATE(63), 1,
      sym__open_brace,
    STATE(147), 1,
      sym__open_parenthesis,
    STATE(2441), 1,
      sym_string,
    STATE(2456), 1,
      sym__single_quoted_string,
    STATE(2478), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5130), 1,
      sym__string_or_identifier,
    ACTIONS(3511), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2448), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3525), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(7997), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1646), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [5547] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2425), 1,
      sym_identifier,
    ACTIONS(2427), 1,
      anon_sym_BSLASH,
    ACTIONS(2429), 1,
      anon_sym_function,
    ACTIONS(2431), 1,
      anon_sym_if,
    ACTIONS(2433), 1,
      anon_sym_for,
    ACTIONS(2435), 1,
      anon_sym_while,
    ACTIONS(2437), 1,
      anon_sym_repeat,
    ACTIONS(2439), 1,
      anon_sym_QMARK,
    ACTIONS(2441), 1,
      anon_sym_TILDE,
    ACTIONS(2449), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2451), 1,
      sym__number_literal,
    ACTIONS(2453), 1,
      anon_sym_SQUOTE,
    ACTIONS(2455), 1,
      anon_sym_DQUOTE,
    ACTIONS(2465), 1,
      sym__raw_string_literal,
    ACTIONS(2467), 1,
      sym__external_open_parenthesis,
    ACTIONS(2471), 1,
      sym__external_open_brace,
    ACTIONS(7781), 1,
      anon_sym_BANG,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8003), 1,
      sym_dot_dot_i,
    STATE(97), 1,
      sym__open_brace,
    STATE(200), 1,
      sym__open_parenthesis,
    STATE(2369), 1,
      sym__double_quoted_string,
    STATE(2370), 1,
      sym__single_quoted_string,
    STATE(2372), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5138), 1,
      sym__string_or_identifier,
    ACTIONS(2445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2371), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8001), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1703), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [5676] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2425), 1,
      sym_identifier,
    ACTIONS(2427), 1,
      anon_sym_BSLASH,
    ACTIONS(2429), 1,
      anon_sym_function,
    ACTIONS(2431), 1,
      anon_sym_if,
    ACTIONS(2433), 1,
      anon_sym_for,
    ACTIONS(2435), 1,
      anon_sym_while,
    ACTIONS(2437), 1,
      anon_sym_repeat,
    ACTIONS(2439), 1,
      anon_sym_QMARK,
    ACTIONS(2441), 1,
      anon_sym_TILDE,
    ACTIONS(2449), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2451), 1,
      sym__number_literal,
    ACTIONS(2453), 1,
      anon_sym_SQUOTE,
    ACTIONS(2455), 1,
      anon_sym_DQUOTE,
    ACTIONS(2465), 1,
      sym__raw_string_literal,
    ACTIONS(2467), 1,
      sym__external_open_parenthesis,
    ACTIONS(2471), 1,
      sym__external_open_brace,
    ACTIONS(7781), 1,
      anon_sym_BANG,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8007), 1,
      sym_dot_dot_i,
    STATE(97), 1,
      sym__open_brace,
    STATE(200), 1,
      sym__open_parenthesis,
    STATE(2369), 1,
      sym__double_quoted_string,
    STATE(2370), 1,
      sym__single_quoted_string,
    STATE(2372), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5138), 1,
      sym__string_or_identifier,
    ACTIONS(2445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2371), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8005), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1705), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [5805] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(161), 1,
      sym_identifier,
    ACTIONS(163), 1,
      anon_sym_BSLASH,
    ACTIONS(165), 1,
      anon_sym_function,
    ACTIONS(167), 1,
      anon_sym_if,
    ACTIONS(169), 1,
      anon_sym_for,
    ACTIONS(171), 1,
      anon_sym_while,
    ACTIONS(173), 1,
      anon_sym_repeat,
    ACTIONS(175), 1,
      anon_sym_QMARK,
    ACTIONS(177), 1,
      anon_sym_TILDE,
    ACTIONS(185), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(187), 1,
      sym__number_literal,
    ACTIONS(189), 1,
      anon_sym_SQUOTE,
    ACTIONS(191), 1,
      anon_sym_DQUOTE,
    ACTIONS(201), 1,
      sym__raw_string_literal,
    ACTIONS(203), 1,
      sym__external_open_parenthesis,
    ACTIONS(207), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8009), 1,
      anon_sym_BANG,
    ACTIONS(8013), 1,
      sym_dot_dot_i,
    STATE(14), 1,
      sym__open_parenthesis,
    STATE(18), 1,
      sym__open_brace,
    STATE(1923), 1,
      sym__single_quoted_string,
    STATE(1927), 1,
      sym_string,
    STATE(1934), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5137), 1,
      sym__string_or_identifier,
    ACTIONS(181), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1925), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(195), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8011), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(497), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [5934] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2425), 1,
      sym_identifier,
    ACTIONS(2427), 1,
      anon_sym_BSLASH,
    ACTIONS(2429), 1,
      anon_sym_function,
    ACTIONS(2431), 1,
      anon_sym_if,
    ACTIONS(2433), 1,
      anon_sym_for,
    ACTIONS(2435), 1,
      anon_sym_while,
    ACTIONS(2437), 1,
      anon_sym_repeat,
    ACTIONS(2439), 1,
      anon_sym_QMARK,
    ACTIONS(2441), 1,
      anon_sym_TILDE,
    ACTIONS(2449), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2451), 1,
      sym__number_literal,
    ACTIONS(2453), 1,
      anon_sym_SQUOTE,
    ACTIONS(2455), 1,
      anon_sym_DQUOTE,
    ACTIONS(2465), 1,
      sym__raw_string_literal,
    ACTIONS(2467), 1,
      sym__external_open_parenthesis,
    ACTIONS(2471), 1,
      sym__external_open_brace,
    ACTIONS(7781), 1,
      anon_sym_BANG,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8017), 1,
      sym_dot_dot_i,
    STATE(97), 1,
      sym__open_brace,
    STATE(200), 1,
      sym__open_parenthesis,
    STATE(2369), 1,
      sym__double_quoted_string,
    STATE(2370), 1,
      sym__single_quoted_string,
    STATE(2372), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5138), 1,
      sym__string_or_identifier,
    ACTIONS(2445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2371), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8015), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1707), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [6063] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3491), 1,
      sym_identifier,
    ACTIONS(3493), 1,
      anon_sym_BSLASH,
    ACTIONS(3495), 1,
      anon_sym_function,
    ACTIONS(3497), 1,
      anon_sym_if,
    ACTIONS(3499), 1,
      anon_sym_for,
    ACTIONS(3501), 1,
      anon_sym_while,
    ACTIONS(3503), 1,
      anon_sym_repeat,
    ACTIONS(3505), 1,
      anon_sym_QMARK,
    ACTIONS(3507), 1,
      anon_sym_TILDE,
    ACTIONS(3515), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3517), 1,
      sym__number_literal,
    ACTIONS(3519), 1,
      anon_sym_SQUOTE,
    ACTIONS(3521), 1,
      anon_sym_DQUOTE,
    ACTIONS(3531), 1,
      sym__raw_string_literal,
    ACTIONS(3533), 1,
      sym__external_open_parenthesis,
    ACTIONS(3535), 1,
      sym__external_open_brace,
    ACTIONS(7789), 1,
      anon_sym_BANG,
    ACTIONS(8021), 1,
      sym_dot_dot_i,
    ACTIONS(8023), 1,
      sym__newline,
    STATE(63), 1,
      sym__open_brace,
    STATE(147), 1,
      sym__open_parenthesis,
    STATE(2441), 1,
      sym_string,
    STATE(2456), 1,
      sym__single_quoted_string,
    STATE(2478), 1,
      sym__double_quoted_string,
    STATE(3107), 1,
      aux_sym_function_definition_repeat1,
    STATE(5130), 1,
      sym__string_or_identifier,
    ACTIONS(3511), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2448), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3525), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8019), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1644), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [6192] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3491), 1,
      sym_identifier,
    ACTIONS(3493), 1,
      anon_sym_BSLASH,
    ACTIONS(3495), 1,
      anon_sym_function,
    ACTIONS(3497), 1,
      anon_sym_if,
    ACTIONS(3499), 1,
      anon_sym_for,
    ACTIONS(3501), 1,
      anon_sym_while,
    ACTIONS(3503), 1,
      anon_sym_repeat,
    ACTIONS(3505), 1,
      anon_sym_QMARK,
    ACTIONS(3507), 1,
      anon_sym_TILDE,
    ACTIONS(3515), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3517), 1,
      sym__number_literal,
    ACTIONS(3519), 1,
      anon_sym_SQUOTE,
    ACTIONS(3521), 1,
      anon_sym_DQUOTE,
    ACTIONS(3531), 1,
      sym__raw_string_literal,
    ACTIONS(3533), 1,
      sym__external_open_parenthesis,
    ACTIONS(3535), 1,
      sym__external_open_brace,
    ACTIONS(7789), 1,
      anon_sym_BANG,
    ACTIONS(8027), 1,
      sym_dot_dot_i,
    ACTIONS(8029), 1,
      sym__newline,
    STATE(63), 1,
      sym__open_brace,
    STATE(147), 1,
      sym__open_parenthesis,
    STATE(2441), 1,
      sym_string,
    STATE(2456), 1,
      sym__single_quoted_string,
    STATE(2478), 1,
      sym__double_quoted_string,
    STATE(3111), 1,
      aux_sym_function_definition_repeat1,
    STATE(5130), 1,
      sym__string_or_identifier,
    ACTIONS(3511), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2448), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3525), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8025), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1640), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [6321] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3491), 1,
      sym_identifier,
    ACTIONS(3493), 1,
      anon_sym_BSLASH,
    ACTIONS(3495), 1,
      anon_sym_function,
    ACTIONS(3497), 1,
      anon_sym_if,
    ACTIONS(3499), 1,
      anon_sym_for,
    ACTIONS(3501), 1,
      anon_sym_while,
    ACTIONS(3503), 1,
      anon_sym_repeat,
    ACTIONS(3505), 1,
      anon_sym_QMARK,
    ACTIONS(3507), 1,
      anon_sym_TILDE,
    ACTIONS(3515), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3517), 1,
      sym__number_literal,
    ACTIONS(3519), 1,
      anon_sym_SQUOTE,
    ACTIONS(3521), 1,
      anon_sym_DQUOTE,
    ACTIONS(3531), 1,
      sym__raw_string_literal,
    ACTIONS(3533), 1,
      sym__external_open_parenthesis,
    ACTIONS(3535), 1,
      sym__external_open_brace,
    ACTIONS(7789), 1,
      anon_sym_BANG,
    ACTIONS(8033), 1,
      sym_dot_dot_i,
    ACTIONS(8035), 1,
      sym__newline,
    STATE(63), 1,
      sym__open_brace,
    STATE(147), 1,
      sym__open_parenthesis,
    STATE(2441), 1,
      sym_string,
    STATE(2456), 1,
      sym__single_quoted_string,
    STATE(2478), 1,
      sym__double_quoted_string,
    STATE(3113), 1,
      aux_sym_function_definition_repeat1,
    STATE(5130), 1,
      sym__string_or_identifier,
    ACTIONS(3511), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2448), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3525), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8031), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1638), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [6450] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3491), 1,
      sym_identifier,
    ACTIONS(3493), 1,
      anon_sym_BSLASH,
    ACTIONS(3495), 1,
      anon_sym_function,
    ACTIONS(3497), 1,
      anon_sym_if,
    ACTIONS(3499), 1,
      anon_sym_for,
    ACTIONS(3501), 1,
      anon_sym_while,
    ACTIONS(3503), 1,
      anon_sym_repeat,
    ACTIONS(3505), 1,
      anon_sym_QMARK,
    ACTIONS(3507), 1,
      anon_sym_TILDE,
    ACTIONS(3515), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3517), 1,
      sym__number_literal,
    ACTIONS(3519), 1,
      anon_sym_SQUOTE,
    ACTIONS(3521), 1,
      anon_sym_DQUOTE,
    ACTIONS(3531), 1,
      sym__raw_string_literal,
    ACTIONS(3533), 1,
      sym__external_open_parenthesis,
    ACTIONS(3535), 1,
      sym__external_open_brace,
    ACTIONS(7789), 1,
      anon_sym_BANG,
    ACTIONS(8039), 1,
      sym_dot_dot_i,
    ACTIONS(8041), 1,
      sym__newline,
    STATE(63), 1,
      sym__open_brace,
    STATE(147), 1,
      sym__open_parenthesis,
    STATE(2441), 1,
      sym_string,
    STATE(2456), 1,
      sym__single_quoted_string,
    STATE(2478), 1,
      sym__double_quoted_string,
    STATE(3115), 1,
      aux_sym_function_definition_repeat1,
    STATE(5130), 1,
      sym__string_or_identifier,
    ACTIONS(3511), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2448), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3525), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8037), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1635), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [6579] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3491), 1,
      sym_identifier,
    ACTIONS(3493), 1,
      anon_sym_BSLASH,
    ACTIONS(3495), 1,
      anon_sym_function,
    ACTIONS(3497), 1,
      anon_sym_if,
    ACTIONS(3499), 1,
      anon_sym_for,
    ACTIONS(3501), 1,
      anon_sym_while,
    ACTIONS(3503), 1,
      anon_sym_repeat,
    ACTIONS(3505), 1,
      anon_sym_QMARK,
    ACTIONS(3507), 1,
      anon_sym_TILDE,
    ACTIONS(3515), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3517), 1,
      sym__number_literal,
    ACTIONS(3519), 1,
      anon_sym_SQUOTE,
    ACTIONS(3521), 1,
      anon_sym_DQUOTE,
    ACTIONS(3531), 1,
      sym__raw_string_literal,
    ACTIONS(3533), 1,
      sym__external_open_parenthesis,
    ACTIONS(3535), 1,
      sym__external_open_brace,
    ACTIONS(7789), 1,
      anon_sym_BANG,
    ACTIONS(8045), 1,
      sym_dot_dot_i,
    ACTIONS(8047), 1,
      sym__newline,
    STATE(63), 1,
      sym__open_brace,
    STATE(147), 1,
      sym__open_parenthesis,
    STATE(2441), 1,
      sym_string,
    STATE(2456), 1,
      sym__single_quoted_string,
    STATE(2478), 1,
      sym__double_quoted_string,
    STATE(3117), 1,
      aux_sym_function_definition_repeat1,
    STATE(5130), 1,
      sym__string_or_identifier,
    ACTIONS(3511), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2448), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3525), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8043), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1634), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [6708] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3491), 1,
      sym_identifier,
    ACTIONS(3493), 1,
      anon_sym_BSLASH,
    ACTIONS(3495), 1,
      anon_sym_function,
    ACTIONS(3497), 1,
      anon_sym_if,
    ACTIONS(3499), 1,
      anon_sym_for,
    ACTIONS(3501), 1,
      anon_sym_while,
    ACTIONS(3503), 1,
      anon_sym_repeat,
    ACTIONS(3505), 1,
      anon_sym_QMARK,
    ACTIONS(3507), 1,
      anon_sym_TILDE,
    ACTIONS(3515), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3517), 1,
      sym__number_literal,
    ACTIONS(3519), 1,
      anon_sym_SQUOTE,
    ACTIONS(3521), 1,
      anon_sym_DQUOTE,
    ACTIONS(3531), 1,
      sym__raw_string_literal,
    ACTIONS(3533), 1,
      sym__external_open_parenthesis,
    ACTIONS(3535), 1,
      sym__external_open_brace,
    ACTIONS(7789), 1,
      anon_sym_BANG,
    ACTIONS(8051), 1,
      sym_dot_dot_i,
    ACTIONS(8053), 1,
      sym__newline,
    STATE(63), 1,
      sym__open_brace,
    STATE(147), 1,
      sym__open_parenthesis,
    STATE(2441), 1,
      sym_string,
    STATE(2456), 1,
      sym__single_quoted_string,
    STATE(2478), 1,
      sym__double_quoted_string,
    STATE(3119), 1,
      aux_sym_function_definition_repeat1,
    STATE(5130), 1,
      sym__string_or_identifier,
    ACTIONS(3511), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2448), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3525), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8049), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1633), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [6837] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3491), 1,
      sym_identifier,
    ACTIONS(3493), 1,
      anon_sym_BSLASH,
    ACTIONS(3495), 1,
      anon_sym_function,
    ACTIONS(3497), 1,
      anon_sym_if,
    ACTIONS(3499), 1,
      anon_sym_for,
    ACTIONS(3501), 1,
      anon_sym_while,
    ACTIONS(3503), 1,
      anon_sym_repeat,
    ACTIONS(3505), 1,
      anon_sym_QMARK,
    ACTIONS(3507), 1,
      anon_sym_TILDE,
    ACTIONS(3515), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3517), 1,
      sym__number_literal,
    ACTIONS(3519), 1,
      anon_sym_SQUOTE,
    ACTIONS(3521), 1,
      anon_sym_DQUOTE,
    ACTIONS(3531), 1,
      sym__raw_string_literal,
    ACTIONS(3533), 1,
      sym__external_open_parenthesis,
    ACTIONS(3535), 1,
      sym__external_open_brace,
    ACTIONS(7789), 1,
      anon_sym_BANG,
    ACTIONS(8057), 1,
      sym_dot_dot_i,
    ACTIONS(8059), 1,
      sym__newline,
    STATE(63), 1,
      sym__open_brace,
    STATE(147), 1,
      sym__open_parenthesis,
    STATE(2441), 1,
      sym_string,
    STATE(2456), 1,
      sym__single_quoted_string,
    STATE(2478), 1,
      sym__double_quoted_string,
    STATE(3121), 1,
      aux_sym_function_definition_repeat1,
    STATE(5130), 1,
      sym__string_or_identifier,
    ACTIONS(3511), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2448), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3525), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8055), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1632), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [6966] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3491), 1,
      sym_identifier,
    ACTIONS(3493), 1,
      anon_sym_BSLASH,
    ACTIONS(3495), 1,
      anon_sym_function,
    ACTIONS(3497), 1,
      anon_sym_if,
    ACTIONS(3499), 1,
      anon_sym_for,
    ACTIONS(3501), 1,
      anon_sym_while,
    ACTIONS(3503), 1,
      anon_sym_repeat,
    ACTIONS(3505), 1,
      anon_sym_QMARK,
    ACTIONS(3507), 1,
      anon_sym_TILDE,
    ACTIONS(3515), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3517), 1,
      sym__number_literal,
    ACTIONS(3519), 1,
      anon_sym_SQUOTE,
    ACTIONS(3521), 1,
      anon_sym_DQUOTE,
    ACTIONS(3531), 1,
      sym__raw_string_literal,
    ACTIONS(3533), 1,
      sym__external_open_parenthesis,
    ACTIONS(3535), 1,
      sym__external_open_brace,
    ACTIONS(7789), 1,
      anon_sym_BANG,
    ACTIONS(8063), 1,
      sym_dot_dot_i,
    ACTIONS(8065), 1,
      sym__newline,
    STATE(63), 1,
      sym__open_brace,
    STATE(147), 1,
      sym__open_parenthesis,
    STATE(2441), 1,
      sym_string,
    STATE(2456), 1,
      sym__single_quoted_string,
    STATE(2478), 1,
      sym__double_quoted_string,
    STATE(3123), 1,
      aux_sym_function_definition_repeat1,
    STATE(5130), 1,
      sym__string_or_identifier,
    ACTIONS(3511), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2448), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3525), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8061), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1631), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [7095] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3491), 1,
      sym_identifier,
    ACTIONS(3493), 1,
      anon_sym_BSLASH,
    ACTIONS(3495), 1,
      anon_sym_function,
    ACTIONS(3497), 1,
      anon_sym_if,
    ACTIONS(3499), 1,
      anon_sym_for,
    ACTIONS(3501), 1,
      anon_sym_while,
    ACTIONS(3503), 1,
      anon_sym_repeat,
    ACTIONS(3505), 1,
      anon_sym_QMARK,
    ACTIONS(3507), 1,
      anon_sym_TILDE,
    ACTIONS(3515), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3517), 1,
      sym__number_literal,
    ACTIONS(3519), 1,
      anon_sym_SQUOTE,
    ACTIONS(3521), 1,
      anon_sym_DQUOTE,
    ACTIONS(3531), 1,
      sym__raw_string_literal,
    ACTIONS(3533), 1,
      sym__external_open_parenthesis,
    ACTIONS(3535), 1,
      sym__external_open_brace,
    ACTIONS(7789), 1,
      anon_sym_BANG,
    ACTIONS(8069), 1,
      sym_dot_dot_i,
    ACTIONS(8071), 1,
      sym__newline,
    STATE(63), 1,
      sym__open_brace,
    STATE(147), 1,
      sym__open_parenthesis,
    STATE(2441), 1,
      sym_string,
    STATE(2456), 1,
      sym__single_quoted_string,
    STATE(2478), 1,
      sym__double_quoted_string,
    STATE(3125), 1,
      aux_sym_function_definition_repeat1,
    STATE(5130), 1,
      sym__string_or_identifier,
    ACTIONS(3511), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2448), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3525), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8067), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1630), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [7224] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3491), 1,
      sym_identifier,
    ACTIONS(3493), 1,
      anon_sym_BSLASH,
    ACTIONS(3495), 1,
      anon_sym_function,
    ACTIONS(3497), 1,
      anon_sym_if,
    ACTIONS(3499), 1,
      anon_sym_for,
    ACTIONS(3501), 1,
      anon_sym_while,
    ACTIONS(3503), 1,
      anon_sym_repeat,
    ACTIONS(3505), 1,
      anon_sym_QMARK,
    ACTIONS(3507), 1,
      anon_sym_TILDE,
    ACTIONS(3515), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3517), 1,
      sym__number_literal,
    ACTIONS(3519), 1,
      anon_sym_SQUOTE,
    ACTIONS(3521), 1,
      anon_sym_DQUOTE,
    ACTIONS(3531), 1,
      sym__raw_string_literal,
    ACTIONS(3533), 1,
      sym__external_open_parenthesis,
    ACTIONS(3535), 1,
      sym__external_open_brace,
    ACTIONS(7789), 1,
      anon_sym_BANG,
    ACTIONS(8075), 1,
      sym_dot_dot_i,
    ACTIONS(8077), 1,
      sym__newline,
    STATE(63), 1,
      sym__open_brace,
    STATE(147), 1,
      sym__open_parenthesis,
    STATE(2441), 1,
      sym_string,
    STATE(2456), 1,
      sym__single_quoted_string,
    STATE(2478), 1,
      sym__double_quoted_string,
    STATE(3127), 1,
      aux_sym_function_definition_repeat1,
    STATE(5130), 1,
      sym__string_or_identifier,
    ACTIONS(3511), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2448), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3525), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8073), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1629), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [7353] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3491), 1,
      sym_identifier,
    ACTIONS(3493), 1,
      anon_sym_BSLASH,
    ACTIONS(3495), 1,
      anon_sym_function,
    ACTIONS(3497), 1,
      anon_sym_if,
    ACTIONS(3499), 1,
      anon_sym_for,
    ACTIONS(3501), 1,
      anon_sym_while,
    ACTIONS(3503), 1,
      anon_sym_repeat,
    ACTIONS(3505), 1,
      anon_sym_QMARK,
    ACTIONS(3507), 1,
      anon_sym_TILDE,
    ACTIONS(3515), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3517), 1,
      sym__number_literal,
    ACTIONS(3519), 1,
      anon_sym_SQUOTE,
    ACTIONS(3521), 1,
      anon_sym_DQUOTE,
    ACTIONS(3531), 1,
      sym__raw_string_literal,
    ACTIONS(3533), 1,
      sym__external_open_parenthesis,
    ACTIONS(3535), 1,
      sym__external_open_brace,
    ACTIONS(7789), 1,
      anon_sym_BANG,
    ACTIONS(8081), 1,
      sym_dot_dot_i,
    ACTIONS(8083), 1,
      sym__newline,
    STATE(63), 1,
      sym__open_brace,
    STATE(147), 1,
      sym__open_parenthesis,
    STATE(2441), 1,
      sym_string,
    STATE(2456), 1,
      sym__single_quoted_string,
    STATE(2478), 1,
      sym__double_quoted_string,
    STATE(3129), 1,
      aux_sym_function_definition_repeat1,
    STATE(5130), 1,
      sym__string_or_identifier,
    ACTIONS(3511), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2448), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3525), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8079), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1628), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [7482] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3491), 1,
      sym_identifier,
    ACTIONS(3493), 1,
      anon_sym_BSLASH,
    ACTIONS(3495), 1,
      anon_sym_function,
    ACTIONS(3497), 1,
      anon_sym_if,
    ACTIONS(3499), 1,
      anon_sym_for,
    ACTIONS(3501), 1,
      anon_sym_while,
    ACTIONS(3503), 1,
      anon_sym_repeat,
    ACTIONS(3505), 1,
      anon_sym_QMARK,
    ACTIONS(3507), 1,
      anon_sym_TILDE,
    ACTIONS(3515), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3517), 1,
      sym__number_literal,
    ACTIONS(3519), 1,
      anon_sym_SQUOTE,
    ACTIONS(3521), 1,
      anon_sym_DQUOTE,
    ACTIONS(3531), 1,
      sym__raw_string_literal,
    ACTIONS(3533), 1,
      sym__external_open_parenthesis,
    ACTIONS(3535), 1,
      sym__external_open_brace,
    ACTIONS(7789), 1,
      anon_sym_BANG,
    ACTIONS(8087), 1,
      sym_dot_dot_i,
    ACTIONS(8089), 1,
      sym__newline,
    STATE(63), 1,
      sym__open_brace,
    STATE(147), 1,
      sym__open_parenthesis,
    STATE(2441), 1,
      sym_string,
    STATE(2456), 1,
      sym__single_quoted_string,
    STATE(2478), 1,
      sym__double_quoted_string,
    STATE(3131), 1,
      aux_sym_function_definition_repeat1,
    STATE(5130), 1,
      sym__string_or_identifier,
    ACTIONS(3511), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2448), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3525), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8085), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1627), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [7611] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2483), 1,
      sym_identifier,
    ACTIONS(2485), 1,
      anon_sym_BSLASH,
    ACTIONS(2487), 1,
      anon_sym_function,
    ACTIONS(2489), 1,
      anon_sym_if,
    ACTIONS(2491), 1,
      anon_sym_for,
    ACTIONS(2493), 1,
      anon_sym_while,
    ACTIONS(2495), 1,
      anon_sym_repeat,
    ACTIONS(2497), 1,
      anon_sym_QMARK,
    ACTIONS(2499), 1,
      anon_sym_TILDE,
    ACTIONS(2507), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2509), 1,
      sym__number_literal,
    ACTIONS(2511), 1,
      anon_sym_SQUOTE,
    ACTIONS(2513), 1,
      anon_sym_DQUOTE,
    ACTIONS(2523), 1,
      sym__raw_string_literal,
    ACTIONS(2525), 1,
      sym__external_open_parenthesis,
    ACTIONS(2529), 1,
      sym__external_open_brace,
    ACTIONS(7803), 1,
      anon_sym_BANG,
    ACTIONS(8093), 1,
      sym_dot_dot_i,
    ACTIONS(8095), 1,
      sym__newline,
    STATE(74), 1,
      sym__open_brace,
    STATE(210), 1,
      sym__open_parenthesis,
    STATE(2397), 1,
      sym_string,
    STATE(2430), 1,
      sym__single_quoted_string,
    STATE(2466), 1,
      sym__double_quoted_string,
    STATE(3104), 1,
      aux_sym_function_definition_repeat1,
    STATE(5142), 1,
      sym__string_or_identifier,
    ACTIONS(2503), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2412), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2517), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8091), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1698), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [7740] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1433), 1,
      sym_identifier,
    ACTIONS(1435), 1,
      anon_sym_BSLASH,
    ACTIONS(1437), 1,
      anon_sym_function,
    ACTIONS(1439), 1,
      anon_sym_if,
    ACTIONS(1441), 1,
      anon_sym_for,
    ACTIONS(1443), 1,
      anon_sym_while,
    ACTIONS(1445), 1,
      anon_sym_repeat,
    ACTIONS(1447), 1,
      anon_sym_QMARK,
    ACTIONS(1449), 1,
      anon_sym_TILDE,
    ACTIONS(1457), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1459), 1,
      sym__number_literal,
    ACTIONS(1461), 1,
      anon_sym_SQUOTE,
    ACTIONS(1463), 1,
      anon_sym_DQUOTE,
    ACTIONS(1473), 1,
      sym__raw_string_literal,
    ACTIONS(1475), 1,
      sym__external_open_parenthesis,
    ACTIONS(1477), 1,
      sym__external_open_brace,
    ACTIONS(8097), 1,
      anon_sym_BANG,
    ACTIONS(8101), 1,
      sym_dot_dot_i,
    ACTIONS(8103), 1,
      sym__newline,
    STATE(76), 1,
      sym__open_parenthesis,
    STATE(188), 1,
      sym__open_brace,
    STATE(2234), 1,
      sym_string,
    STATE(2236), 1,
      sym__single_quoted_string,
    STATE(2237), 1,
      sym__double_quoted_string,
    STATE(3298), 1,
      aux_sym_function_definition_repeat1,
    STATE(5150), 1,
      sym__string_or_identifier,
    ACTIONS(1453), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2235), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1467), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8099), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1124), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [7869] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2425), 1,
      sym_identifier,
    ACTIONS(2427), 1,
      anon_sym_BSLASH,
    ACTIONS(2429), 1,
      anon_sym_function,
    ACTIONS(2431), 1,
      anon_sym_if,
    ACTIONS(2433), 1,
      anon_sym_for,
    ACTIONS(2435), 1,
      anon_sym_while,
    ACTIONS(2437), 1,
      anon_sym_repeat,
    ACTIONS(2439), 1,
      anon_sym_QMARK,
    ACTIONS(2441), 1,
      anon_sym_TILDE,
    ACTIONS(2449), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2451), 1,
      sym__number_literal,
    ACTIONS(2453), 1,
      anon_sym_SQUOTE,
    ACTIONS(2455), 1,
      anon_sym_DQUOTE,
    ACTIONS(2465), 1,
      sym__raw_string_literal,
    ACTIONS(2467), 1,
      sym__external_open_parenthesis,
    ACTIONS(2471), 1,
      sym__external_open_brace,
    ACTIONS(7781), 1,
      anon_sym_BANG,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8107), 1,
      sym_dot_dot_i,
    STATE(97), 1,
      sym__open_brace,
    STATE(200), 1,
      sym__open_parenthesis,
    STATE(2369), 1,
      sym__double_quoted_string,
    STATE(2370), 1,
      sym__single_quoted_string,
    STATE(2372), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5138), 1,
      sym__string_or_identifier,
    ACTIONS(2445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2371), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8105), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1709), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [7998] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(161), 1,
      sym_identifier,
    ACTIONS(163), 1,
      anon_sym_BSLASH,
    ACTIONS(165), 1,
      anon_sym_function,
    ACTIONS(167), 1,
      anon_sym_if,
    ACTIONS(169), 1,
      anon_sym_for,
    ACTIONS(171), 1,
      anon_sym_while,
    ACTIONS(173), 1,
      anon_sym_repeat,
    ACTIONS(175), 1,
      anon_sym_QMARK,
    ACTIONS(177), 1,
      anon_sym_TILDE,
    ACTIONS(185), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(187), 1,
      sym__number_literal,
    ACTIONS(189), 1,
      anon_sym_SQUOTE,
    ACTIONS(191), 1,
      anon_sym_DQUOTE,
    ACTIONS(201), 1,
      sym__raw_string_literal,
    ACTIONS(203), 1,
      sym__external_open_parenthesis,
    ACTIONS(207), 1,
      sym__external_open_brace,
    ACTIONS(8009), 1,
      anon_sym_BANG,
    ACTIONS(8111), 1,
      sym_dot_dot_i,
    ACTIONS(8113), 1,
      sym__newline,
    STATE(14), 1,
      sym__open_parenthesis,
    STATE(18), 1,
      sym__open_brace,
    STATE(1923), 1,
      sym__single_quoted_string,
    STATE(1927), 1,
      sym_string,
    STATE(1934), 1,
      sym__double_quoted_string,
    STATE(3073), 1,
      aux_sym_function_definition_repeat1,
    STATE(5137), 1,
      sym__string_or_identifier,
    ACTIONS(181), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1925), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(195), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8109), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(478), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [8127] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2483), 1,
      sym_identifier,
    ACTIONS(2485), 1,
      anon_sym_BSLASH,
    ACTIONS(2487), 1,
      anon_sym_function,
    ACTIONS(2489), 1,
      anon_sym_if,
    ACTIONS(2491), 1,
      anon_sym_for,
    ACTIONS(2493), 1,
      anon_sym_while,
    ACTIONS(2495), 1,
      anon_sym_repeat,
    ACTIONS(2497), 1,
      anon_sym_QMARK,
    ACTIONS(2499), 1,
      anon_sym_TILDE,
    ACTIONS(2507), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2509), 1,
      sym__number_literal,
    ACTIONS(2511), 1,
      anon_sym_SQUOTE,
    ACTIONS(2513), 1,
      anon_sym_DQUOTE,
    ACTIONS(2523), 1,
      sym__raw_string_literal,
    ACTIONS(2525), 1,
      sym__external_open_parenthesis,
    ACTIONS(2529), 1,
      sym__external_open_brace,
    ACTIONS(7803), 1,
      anon_sym_BANG,
    ACTIONS(8117), 1,
      sym_dot_dot_i,
    ACTIONS(8119), 1,
      sym__newline,
    STATE(74), 1,
      sym__open_brace,
    STATE(210), 1,
      sym__open_parenthesis,
    STATE(2397), 1,
      sym_string,
    STATE(2430), 1,
      sym__single_quoted_string,
    STATE(2466), 1,
      sym__double_quoted_string,
    STATE(3039), 1,
      aux_sym_function_definition_repeat1,
    STATE(5142), 1,
      sym__string_or_identifier,
    ACTIONS(2503), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2412), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2517), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8115), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1696), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [8256] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2425), 1,
      sym_identifier,
    ACTIONS(2427), 1,
      anon_sym_BSLASH,
    ACTIONS(2429), 1,
      anon_sym_function,
    ACTIONS(2431), 1,
      anon_sym_if,
    ACTIONS(2433), 1,
      anon_sym_for,
    ACTIONS(2435), 1,
      anon_sym_while,
    ACTIONS(2437), 1,
      anon_sym_repeat,
    ACTIONS(2439), 1,
      anon_sym_QMARK,
    ACTIONS(2441), 1,
      anon_sym_TILDE,
    ACTIONS(2449), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2451), 1,
      sym__number_literal,
    ACTIONS(2453), 1,
      anon_sym_SQUOTE,
    ACTIONS(2455), 1,
      anon_sym_DQUOTE,
    ACTIONS(2465), 1,
      sym__raw_string_literal,
    ACTIONS(2467), 1,
      sym__external_open_parenthesis,
    ACTIONS(2471), 1,
      sym__external_open_brace,
    ACTIONS(7781), 1,
      anon_sym_BANG,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8123), 1,
      sym_dot_dot_i,
    STATE(97), 1,
      sym__open_brace,
    STATE(200), 1,
      sym__open_parenthesis,
    STATE(2369), 1,
      sym__double_quoted_string,
    STATE(2370), 1,
      sym__single_quoted_string,
    STATE(2372), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5138), 1,
      sym__string_or_identifier,
    ACTIONS(2445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2371), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8121), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1711), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [8385] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2425), 1,
      sym_identifier,
    ACTIONS(2427), 1,
      anon_sym_BSLASH,
    ACTIONS(2429), 1,
      anon_sym_function,
    ACTIONS(2431), 1,
      anon_sym_if,
    ACTIONS(2433), 1,
      anon_sym_for,
    ACTIONS(2435), 1,
      anon_sym_while,
    ACTIONS(2437), 1,
      anon_sym_repeat,
    ACTIONS(2439), 1,
      anon_sym_QMARK,
    ACTIONS(2441), 1,
      anon_sym_TILDE,
    ACTIONS(2449), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2451), 1,
      sym__number_literal,
    ACTIONS(2453), 1,
      anon_sym_SQUOTE,
    ACTIONS(2455), 1,
      anon_sym_DQUOTE,
    ACTIONS(2465), 1,
      sym__raw_string_literal,
    ACTIONS(2467), 1,
      sym__external_open_parenthesis,
    ACTIONS(2471), 1,
      sym__external_open_brace,
    ACTIONS(7781), 1,
      anon_sym_BANG,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8127), 1,
      sym_dot_dot_i,
    STATE(97), 1,
      sym__open_brace,
    STATE(200), 1,
      sym__open_parenthesis,
    STATE(2369), 1,
      sym__double_quoted_string,
    STATE(2370), 1,
      sym__single_quoted_string,
    STATE(2372), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5138), 1,
      sym__string_or_identifier,
    ACTIONS(2445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2371), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8125), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1713), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [8514] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2943), 1,
      sym_identifier,
    ACTIONS(2945), 1,
      anon_sym_BSLASH,
    ACTIONS(2947), 1,
      anon_sym_function,
    ACTIONS(2949), 1,
      anon_sym_if,
    ACTIONS(2951), 1,
      anon_sym_for,
    ACTIONS(2953), 1,
      anon_sym_while,
    ACTIONS(2955), 1,
      anon_sym_repeat,
    ACTIONS(2957), 1,
      anon_sym_QMARK,
    ACTIONS(2959), 1,
      anon_sym_TILDE,
    ACTIONS(2967), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2969), 1,
      sym__number_literal,
    ACTIONS(2971), 1,
      anon_sym_SQUOTE,
    ACTIONS(2973), 1,
      anon_sym_DQUOTE,
    ACTIONS(2983), 1,
      sym__raw_string_literal,
    ACTIONS(2985), 1,
      sym__external_open_parenthesis,
    ACTIONS(2989), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7797), 1,
      anon_sym_BANG,
    ACTIONS(8131), 1,
      sym_dot_dot_i,
    STATE(173), 1,
      sym__open_brace,
    STATE(246), 1,
      sym__open_parenthesis,
    STATE(2462), 1,
      sym__single_quoted_string,
    STATE(2494), 1,
      sym__double_quoted_string,
    STATE(2541), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5128), 1,
      sym__string_or_identifier,
    ACTIONS(2963), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2540), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2977), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8129), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1809), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [8643] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(161), 1,
      sym_identifier,
    ACTIONS(163), 1,
      anon_sym_BSLASH,
    ACTIONS(165), 1,
      anon_sym_function,
    ACTIONS(167), 1,
      anon_sym_if,
    ACTIONS(169), 1,
      anon_sym_for,
    ACTIONS(171), 1,
      anon_sym_while,
    ACTIONS(173), 1,
      anon_sym_repeat,
    ACTIONS(175), 1,
      anon_sym_QMARK,
    ACTIONS(177), 1,
      anon_sym_TILDE,
    ACTIONS(185), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(187), 1,
      sym__number_literal,
    ACTIONS(189), 1,
      anon_sym_SQUOTE,
    ACTIONS(191), 1,
      anon_sym_DQUOTE,
    ACTIONS(201), 1,
      sym__raw_string_literal,
    ACTIONS(203), 1,
      sym__external_open_parenthesis,
    ACTIONS(207), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8009), 1,
      anon_sym_BANG,
    ACTIONS(8135), 1,
      sym_dot_dot_i,
    STATE(14), 1,
      sym__open_parenthesis,
    STATE(18), 1,
      sym__open_brace,
    STATE(1923), 1,
      sym__single_quoted_string,
    STATE(1927), 1,
      sym_string,
    STATE(1934), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5137), 1,
      sym__string_or_identifier,
    ACTIONS(181), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1925), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(195), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8133), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(481), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [8772] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2483), 1,
      sym_identifier,
    ACTIONS(2485), 1,
      anon_sym_BSLASH,
    ACTIONS(2487), 1,
      anon_sym_function,
    ACTIONS(2489), 1,
      anon_sym_if,
    ACTIONS(2491), 1,
      anon_sym_for,
    ACTIONS(2493), 1,
      anon_sym_while,
    ACTIONS(2495), 1,
      anon_sym_repeat,
    ACTIONS(2497), 1,
      anon_sym_QMARK,
    ACTIONS(2499), 1,
      anon_sym_TILDE,
    ACTIONS(2507), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2509), 1,
      sym__number_literal,
    ACTIONS(2511), 1,
      anon_sym_SQUOTE,
    ACTIONS(2513), 1,
      anon_sym_DQUOTE,
    ACTIONS(2523), 1,
      sym__raw_string_literal,
    ACTIONS(2525), 1,
      sym__external_open_parenthesis,
    ACTIONS(2529), 1,
      sym__external_open_brace,
    ACTIONS(7803), 1,
      anon_sym_BANG,
    ACTIONS(8139), 1,
      sym_dot_dot_i,
    ACTIONS(8141), 1,
      sym__newline,
    STATE(74), 1,
      sym__open_brace,
    STATE(210), 1,
      sym__open_parenthesis,
    STATE(2397), 1,
      sym_string,
    STATE(2430), 1,
      sym__single_quoted_string,
    STATE(2466), 1,
      sym__double_quoted_string,
    STATE(3049), 1,
      aux_sym_function_definition_repeat1,
    STATE(5142), 1,
      sym__string_or_identifier,
    ACTIONS(2503), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2412), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2517), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8137), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1692), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [8901] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2425), 1,
      sym_identifier,
    ACTIONS(2427), 1,
      anon_sym_BSLASH,
    ACTIONS(2429), 1,
      anon_sym_function,
    ACTIONS(2431), 1,
      anon_sym_if,
    ACTIONS(2433), 1,
      anon_sym_for,
    ACTIONS(2435), 1,
      anon_sym_while,
    ACTIONS(2437), 1,
      anon_sym_repeat,
    ACTIONS(2439), 1,
      anon_sym_QMARK,
    ACTIONS(2441), 1,
      anon_sym_TILDE,
    ACTIONS(2449), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2451), 1,
      sym__number_literal,
    ACTIONS(2453), 1,
      anon_sym_SQUOTE,
    ACTIONS(2455), 1,
      anon_sym_DQUOTE,
    ACTIONS(2465), 1,
      sym__raw_string_literal,
    ACTIONS(2467), 1,
      sym__external_open_parenthesis,
    ACTIONS(2471), 1,
      sym__external_open_brace,
    ACTIONS(7781), 1,
      anon_sym_BANG,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8145), 1,
      sym_dot_dot_i,
    STATE(97), 1,
      sym__open_brace,
    STATE(200), 1,
      sym__open_parenthesis,
    STATE(2369), 1,
      sym__double_quoted_string,
    STATE(2370), 1,
      sym__single_quoted_string,
    STATE(2372), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5138), 1,
      sym__string_or_identifier,
    ACTIONS(2445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2371), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8143), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1715), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [9030] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2483), 1,
      sym_identifier,
    ACTIONS(2485), 1,
      anon_sym_BSLASH,
    ACTIONS(2487), 1,
      anon_sym_function,
    ACTIONS(2489), 1,
      anon_sym_if,
    ACTIONS(2491), 1,
      anon_sym_for,
    ACTIONS(2493), 1,
      anon_sym_while,
    ACTIONS(2495), 1,
      anon_sym_repeat,
    ACTIONS(2497), 1,
      anon_sym_QMARK,
    ACTIONS(2499), 1,
      anon_sym_TILDE,
    ACTIONS(2507), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2509), 1,
      sym__number_literal,
    ACTIONS(2511), 1,
      anon_sym_SQUOTE,
    ACTIONS(2513), 1,
      anon_sym_DQUOTE,
    ACTIONS(2523), 1,
      sym__raw_string_literal,
    ACTIONS(2525), 1,
      sym__external_open_parenthesis,
    ACTIONS(2529), 1,
      sym__external_open_brace,
    ACTIONS(7803), 1,
      anon_sym_BANG,
    ACTIONS(8149), 1,
      sym_dot_dot_i,
    ACTIONS(8151), 1,
      sym__newline,
    STATE(74), 1,
      sym__open_brace,
    STATE(210), 1,
      sym__open_parenthesis,
    STATE(2397), 1,
      sym_string,
    STATE(2430), 1,
      sym__single_quoted_string,
    STATE(2466), 1,
      sym__double_quoted_string,
    STATE(3031), 1,
      aux_sym_function_definition_repeat1,
    STATE(5142), 1,
      sym__string_or_identifier,
    ACTIONS(2503), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2412), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2517), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8147), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1690), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [9159] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2425), 1,
      sym_identifier,
    ACTIONS(2427), 1,
      anon_sym_BSLASH,
    ACTIONS(2429), 1,
      anon_sym_function,
    ACTIONS(2431), 1,
      anon_sym_if,
    ACTIONS(2433), 1,
      anon_sym_for,
    ACTIONS(2435), 1,
      anon_sym_while,
    ACTIONS(2437), 1,
      anon_sym_repeat,
    ACTIONS(2439), 1,
      anon_sym_QMARK,
    ACTIONS(2441), 1,
      anon_sym_TILDE,
    ACTIONS(2449), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2451), 1,
      sym__number_literal,
    ACTIONS(2453), 1,
      anon_sym_SQUOTE,
    ACTIONS(2455), 1,
      anon_sym_DQUOTE,
    ACTIONS(2465), 1,
      sym__raw_string_literal,
    ACTIONS(2467), 1,
      sym__external_open_parenthesis,
    ACTIONS(2471), 1,
      sym__external_open_brace,
    ACTIONS(7781), 1,
      anon_sym_BANG,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8155), 1,
      sym_dot_dot_i,
    STATE(97), 1,
      sym__open_brace,
    STATE(200), 1,
      sym__open_parenthesis,
    STATE(2369), 1,
      sym__double_quoted_string,
    STATE(2370), 1,
      sym__single_quoted_string,
    STATE(2372), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5138), 1,
      sym__string_or_identifier,
    ACTIONS(2445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2371), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8153), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1716), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [9288] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(161), 1,
      sym_identifier,
    ACTIONS(163), 1,
      anon_sym_BSLASH,
    ACTIONS(165), 1,
      anon_sym_function,
    ACTIONS(167), 1,
      anon_sym_if,
    ACTIONS(169), 1,
      anon_sym_for,
    ACTIONS(171), 1,
      anon_sym_while,
    ACTIONS(173), 1,
      anon_sym_repeat,
    ACTIONS(175), 1,
      anon_sym_QMARK,
    ACTIONS(177), 1,
      anon_sym_TILDE,
    ACTIONS(185), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(187), 1,
      sym__number_literal,
    ACTIONS(189), 1,
      anon_sym_SQUOTE,
    ACTIONS(191), 1,
      anon_sym_DQUOTE,
    ACTIONS(201), 1,
      sym__raw_string_literal,
    ACTIONS(203), 1,
      sym__external_open_parenthesis,
    ACTIONS(207), 1,
      sym__external_open_brace,
    ACTIONS(8009), 1,
      anon_sym_BANG,
    ACTIONS(8159), 1,
      sym_dot_dot_i,
    ACTIONS(8161), 1,
      sym__newline,
    STATE(14), 1,
      sym__open_parenthesis,
    STATE(18), 1,
      sym__open_brace,
    STATE(1923), 1,
      sym__single_quoted_string,
    STATE(1927), 1,
      sym_string,
    STATE(1934), 1,
      sym__double_quoted_string,
    STATE(3095), 1,
      aux_sym_function_definition_repeat1,
    STATE(5137), 1,
      sym__string_or_identifier,
    ACTIONS(181), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1925), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(195), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8157), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(484), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [9417] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2425), 1,
      sym_identifier,
    ACTIONS(2427), 1,
      anon_sym_BSLASH,
    ACTIONS(2429), 1,
      anon_sym_function,
    ACTIONS(2431), 1,
      anon_sym_if,
    ACTIONS(2433), 1,
      anon_sym_for,
    ACTIONS(2435), 1,
      anon_sym_while,
    ACTIONS(2437), 1,
      anon_sym_repeat,
    ACTIONS(2439), 1,
      anon_sym_QMARK,
    ACTIONS(2441), 1,
      anon_sym_TILDE,
    ACTIONS(2449), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2451), 1,
      sym__number_literal,
    ACTIONS(2453), 1,
      anon_sym_SQUOTE,
    ACTIONS(2455), 1,
      anon_sym_DQUOTE,
    ACTIONS(2465), 1,
      sym__raw_string_literal,
    ACTIONS(2467), 1,
      sym__external_open_parenthesis,
    ACTIONS(2471), 1,
      sym__external_open_brace,
    ACTIONS(7781), 1,
      anon_sym_BANG,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8165), 1,
      sym_dot_dot_i,
    STATE(97), 1,
      sym__open_brace,
    STATE(200), 1,
      sym__open_parenthesis,
    STATE(2369), 1,
      sym__double_quoted_string,
    STATE(2370), 1,
      sym__single_quoted_string,
    STATE(2372), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5138), 1,
      sym__string_or_identifier,
    ACTIONS(2445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2371), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8163), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1718), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [9546] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1433), 1,
      sym_identifier,
    ACTIONS(1435), 1,
      anon_sym_BSLASH,
    ACTIONS(1437), 1,
      anon_sym_function,
    ACTIONS(1439), 1,
      anon_sym_if,
    ACTIONS(1441), 1,
      anon_sym_for,
    ACTIONS(1443), 1,
      anon_sym_while,
    ACTIONS(1445), 1,
      anon_sym_repeat,
    ACTIONS(1447), 1,
      anon_sym_QMARK,
    ACTIONS(1449), 1,
      anon_sym_TILDE,
    ACTIONS(1457), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1459), 1,
      sym__number_literal,
    ACTIONS(1461), 1,
      anon_sym_SQUOTE,
    ACTIONS(1463), 1,
      anon_sym_DQUOTE,
    ACTIONS(1473), 1,
      sym__raw_string_literal,
    ACTIONS(1475), 1,
      sym__external_open_parenthesis,
    ACTIONS(1477), 1,
      sym__external_open_brace,
    ACTIONS(8097), 1,
      anon_sym_BANG,
    ACTIONS(8169), 1,
      sym_dot_dot_i,
    ACTIONS(8171), 1,
      sym__newline,
    STATE(76), 1,
      sym__open_parenthesis,
    STATE(188), 1,
      sym__open_brace,
    STATE(2234), 1,
      sym_string,
    STATE(2236), 1,
      sym__single_quoted_string,
    STATE(2237), 1,
      sym__double_quoted_string,
    STATE(3154), 1,
      aux_sym_function_definition_repeat1,
    STATE(5150), 1,
      sym__string_or_identifier,
    ACTIONS(1453), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2235), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1467), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8167), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1137), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [9675] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2483), 1,
      sym_identifier,
    ACTIONS(2485), 1,
      anon_sym_BSLASH,
    ACTIONS(2487), 1,
      anon_sym_function,
    ACTIONS(2489), 1,
      anon_sym_if,
    ACTIONS(2491), 1,
      anon_sym_for,
    ACTIONS(2493), 1,
      anon_sym_while,
    ACTIONS(2495), 1,
      anon_sym_repeat,
    ACTIONS(2497), 1,
      anon_sym_QMARK,
    ACTIONS(2499), 1,
      anon_sym_TILDE,
    ACTIONS(2507), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2509), 1,
      sym__number_literal,
    ACTIONS(2511), 1,
      anon_sym_SQUOTE,
    ACTIONS(2513), 1,
      anon_sym_DQUOTE,
    ACTIONS(2523), 1,
      sym__raw_string_literal,
    ACTIONS(2525), 1,
      sym__external_open_parenthesis,
    ACTIONS(2529), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7803), 1,
      anon_sym_BANG,
    ACTIONS(8175), 1,
      sym_dot_dot_i,
    STATE(74), 1,
      sym__open_brace,
    STATE(210), 1,
      sym__open_parenthesis,
    STATE(2397), 1,
      sym_string,
    STATE(2430), 1,
      sym__single_quoted_string,
    STATE(2466), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5142), 1,
      sym__string_or_identifier,
    ACTIONS(2503), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2412), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2517), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8173), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1687), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [9804] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2483), 1,
      sym_identifier,
    ACTIONS(2485), 1,
      anon_sym_BSLASH,
    ACTIONS(2487), 1,
      anon_sym_function,
    ACTIONS(2489), 1,
      anon_sym_if,
    ACTIONS(2491), 1,
      anon_sym_for,
    ACTIONS(2493), 1,
      anon_sym_while,
    ACTIONS(2495), 1,
      anon_sym_repeat,
    ACTIONS(2497), 1,
      anon_sym_QMARK,
    ACTIONS(2499), 1,
      anon_sym_TILDE,
    ACTIONS(2507), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2509), 1,
      sym__number_literal,
    ACTIONS(2511), 1,
      anon_sym_SQUOTE,
    ACTIONS(2513), 1,
      anon_sym_DQUOTE,
    ACTIONS(2523), 1,
      sym__raw_string_literal,
    ACTIONS(2525), 1,
      sym__external_open_parenthesis,
    ACTIONS(2529), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7803), 1,
      anon_sym_BANG,
    ACTIONS(8179), 1,
      sym_dot_dot_i,
    STATE(74), 1,
      sym__open_brace,
    STATE(210), 1,
      sym__open_parenthesis,
    STATE(2397), 1,
      sym_string,
    STATE(2430), 1,
      sym__single_quoted_string,
    STATE(2466), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5142), 1,
      sym__string_or_identifier,
    ACTIONS(2503), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2412), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2517), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8177), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1735), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [9933] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1433), 1,
      sym_identifier,
    ACTIONS(1435), 1,
      anon_sym_BSLASH,
    ACTIONS(1437), 1,
      anon_sym_function,
    ACTIONS(1439), 1,
      anon_sym_if,
    ACTIONS(1441), 1,
      anon_sym_for,
    ACTIONS(1443), 1,
      anon_sym_while,
    ACTIONS(1445), 1,
      anon_sym_repeat,
    ACTIONS(1447), 1,
      anon_sym_QMARK,
    ACTIONS(1449), 1,
      anon_sym_TILDE,
    ACTIONS(1457), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1459), 1,
      sym__number_literal,
    ACTIONS(1461), 1,
      anon_sym_SQUOTE,
    ACTIONS(1463), 1,
      anon_sym_DQUOTE,
    ACTIONS(1473), 1,
      sym__raw_string_literal,
    ACTIONS(1475), 1,
      sym__external_open_parenthesis,
    ACTIONS(1477), 1,
      sym__external_open_brace,
    ACTIONS(8097), 1,
      anon_sym_BANG,
    ACTIONS(8183), 1,
      sym_dot_dot_i,
    ACTIONS(8185), 1,
      sym__newline,
    STATE(76), 1,
      sym__open_parenthesis,
    STATE(188), 1,
      sym__open_brace,
    STATE(2234), 1,
      sym_string,
    STATE(2236), 1,
      sym__single_quoted_string,
    STATE(2237), 1,
      sym__double_quoted_string,
    STATE(3158), 1,
      aux_sym_function_definition_repeat1,
    STATE(5150), 1,
      sym__string_or_identifier,
    ACTIONS(1453), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2235), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1467), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8181), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1135), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [10062] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2483), 1,
      sym_identifier,
    ACTIONS(2485), 1,
      anon_sym_BSLASH,
    ACTIONS(2487), 1,
      anon_sym_function,
    ACTIONS(2489), 1,
      anon_sym_if,
    ACTIONS(2491), 1,
      anon_sym_for,
    ACTIONS(2493), 1,
      anon_sym_while,
    ACTIONS(2495), 1,
      anon_sym_repeat,
    ACTIONS(2497), 1,
      anon_sym_QMARK,
    ACTIONS(2499), 1,
      anon_sym_TILDE,
    ACTIONS(2507), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2509), 1,
      sym__number_literal,
    ACTIONS(2511), 1,
      anon_sym_SQUOTE,
    ACTIONS(2513), 1,
      anon_sym_DQUOTE,
    ACTIONS(2523), 1,
      sym__raw_string_literal,
    ACTIONS(2525), 1,
      sym__external_open_parenthesis,
    ACTIONS(2529), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7803), 1,
      anon_sym_BANG,
    ACTIONS(8189), 1,
      sym_dot_dot_i,
    STATE(74), 1,
      sym__open_brace,
    STATE(210), 1,
      sym__open_parenthesis,
    STATE(2397), 1,
      sym_string,
    STATE(2430), 1,
      sym__single_quoted_string,
    STATE(2466), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5142), 1,
      sym__string_or_identifier,
    ACTIONS(2503), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2412), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2517), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8187), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1686), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [10191] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3491), 1,
      sym_identifier,
    ACTIONS(3493), 1,
      anon_sym_BSLASH,
    ACTIONS(3495), 1,
      anon_sym_function,
    ACTIONS(3497), 1,
      anon_sym_if,
    ACTIONS(3499), 1,
      anon_sym_for,
    ACTIONS(3501), 1,
      anon_sym_while,
    ACTIONS(3503), 1,
      anon_sym_repeat,
    ACTIONS(3505), 1,
      anon_sym_QMARK,
    ACTIONS(3507), 1,
      anon_sym_TILDE,
    ACTIONS(3515), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3517), 1,
      sym__number_literal,
    ACTIONS(3519), 1,
      anon_sym_SQUOTE,
    ACTIONS(3521), 1,
      anon_sym_DQUOTE,
    ACTIONS(3531), 1,
      sym__raw_string_literal,
    ACTIONS(3533), 1,
      sym__external_open_parenthesis,
    ACTIONS(3535), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7789), 1,
      anon_sym_BANG,
    ACTIONS(8193), 1,
      sym_dot_dot_i,
    STATE(63), 1,
      sym__open_brace,
    STATE(147), 1,
      sym__open_parenthesis,
    STATE(2441), 1,
      sym_string,
    STATE(2456), 1,
      sym__single_quoted_string,
    STATE(2478), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5130), 1,
      sym__string_or_identifier,
    ACTIONS(3511), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2448), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3525), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8191), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1614), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [10320] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2483), 1,
      sym_identifier,
    ACTIONS(2485), 1,
      anon_sym_BSLASH,
    ACTIONS(2487), 1,
      anon_sym_function,
    ACTIONS(2489), 1,
      anon_sym_if,
    ACTIONS(2491), 1,
      anon_sym_for,
    ACTIONS(2493), 1,
      anon_sym_while,
    ACTIONS(2495), 1,
      anon_sym_repeat,
    ACTIONS(2497), 1,
      anon_sym_QMARK,
    ACTIONS(2499), 1,
      anon_sym_TILDE,
    ACTIONS(2507), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2509), 1,
      sym__number_literal,
    ACTIONS(2511), 1,
      anon_sym_SQUOTE,
    ACTIONS(2513), 1,
      anon_sym_DQUOTE,
    ACTIONS(2523), 1,
      sym__raw_string_literal,
    ACTIONS(2525), 1,
      sym__external_open_parenthesis,
    ACTIONS(2529), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7803), 1,
      anon_sym_BANG,
    ACTIONS(8197), 1,
      sym_dot_dot_i,
    STATE(74), 1,
      sym__open_brace,
    STATE(210), 1,
      sym__open_parenthesis,
    STATE(2397), 1,
      sym_string,
    STATE(2430), 1,
      sym__single_quoted_string,
    STATE(2466), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5142), 1,
      sym__string_or_identifier,
    ACTIONS(2503), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2412), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2517), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8195), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1685), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [10449] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3491), 1,
      sym_identifier,
    ACTIONS(3493), 1,
      anon_sym_BSLASH,
    ACTIONS(3495), 1,
      anon_sym_function,
    ACTIONS(3497), 1,
      anon_sym_if,
    ACTIONS(3499), 1,
      anon_sym_for,
    ACTIONS(3501), 1,
      anon_sym_while,
    ACTIONS(3503), 1,
      anon_sym_repeat,
    ACTIONS(3505), 1,
      anon_sym_QMARK,
    ACTIONS(3507), 1,
      anon_sym_TILDE,
    ACTIONS(3515), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3517), 1,
      sym__number_literal,
    ACTIONS(3519), 1,
      anon_sym_SQUOTE,
    ACTIONS(3521), 1,
      anon_sym_DQUOTE,
    ACTIONS(3531), 1,
      sym__raw_string_literal,
    ACTIONS(3533), 1,
      sym__external_open_parenthesis,
    ACTIONS(3535), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7789), 1,
      anon_sym_BANG,
    ACTIONS(8201), 1,
      sym_dot_dot_i,
    STATE(63), 1,
      sym__open_brace,
    STATE(147), 1,
      sym__open_parenthesis,
    STATE(2441), 1,
      sym_string,
    STATE(2456), 1,
      sym__single_quoted_string,
    STATE(2478), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5130), 1,
      sym__string_or_identifier,
    ACTIONS(3511), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2448), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3525), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8199), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1611), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [10578] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2483), 1,
      sym_identifier,
    ACTIONS(2485), 1,
      anon_sym_BSLASH,
    ACTIONS(2487), 1,
      anon_sym_function,
    ACTIONS(2489), 1,
      anon_sym_if,
    ACTIONS(2491), 1,
      anon_sym_for,
    ACTIONS(2493), 1,
      anon_sym_while,
    ACTIONS(2495), 1,
      anon_sym_repeat,
    ACTIONS(2497), 1,
      anon_sym_QMARK,
    ACTIONS(2499), 1,
      anon_sym_TILDE,
    ACTIONS(2507), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2509), 1,
      sym__number_literal,
    ACTIONS(2511), 1,
      anon_sym_SQUOTE,
    ACTIONS(2513), 1,
      anon_sym_DQUOTE,
    ACTIONS(2523), 1,
      sym__raw_string_literal,
    ACTIONS(2525), 1,
      sym__external_open_parenthesis,
    ACTIONS(2529), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7803), 1,
      anon_sym_BANG,
    ACTIONS(8205), 1,
      sym_dot_dot_i,
    STATE(74), 1,
      sym__open_brace,
    STATE(210), 1,
      sym__open_parenthesis,
    STATE(2397), 1,
      sym_string,
    STATE(2430), 1,
      sym__single_quoted_string,
    STATE(2466), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5142), 1,
      sym__string_or_identifier,
    ACTIONS(2503), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2412), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2517), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8203), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1684), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [10707] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3491), 1,
      sym_identifier,
    ACTIONS(3493), 1,
      anon_sym_BSLASH,
    ACTIONS(3495), 1,
      anon_sym_function,
    ACTIONS(3497), 1,
      anon_sym_if,
    ACTIONS(3499), 1,
      anon_sym_for,
    ACTIONS(3501), 1,
      anon_sym_while,
    ACTIONS(3503), 1,
      anon_sym_repeat,
    ACTIONS(3505), 1,
      anon_sym_QMARK,
    ACTIONS(3507), 1,
      anon_sym_TILDE,
    ACTIONS(3515), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3517), 1,
      sym__number_literal,
    ACTIONS(3519), 1,
      anon_sym_SQUOTE,
    ACTIONS(3521), 1,
      anon_sym_DQUOTE,
    ACTIONS(3531), 1,
      sym__raw_string_literal,
    ACTIONS(3533), 1,
      sym__external_open_parenthesis,
    ACTIONS(3535), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7789), 1,
      anon_sym_BANG,
    ACTIONS(8209), 1,
      sym_dot_dot_i,
    STATE(63), 1,
      sym__open_brace,
    STATE(147), 1,
      sym__open_parenthesis,
    STATE(2441), 1,
      sym_string,
    STATE(2456), 1,
      sym__single_quoted_string,
    STATE(2478), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5130), 1,
      sym__string_or_identifier,
    ACTIONS(3511), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2448), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3525), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8207), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1610), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [10836] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1433), 1,
      sym_identifier,
    ACTIONS(1435), 1,
      anon_sym_BSLASH,
    ACTIONS(1437), 1,
      anon_sym_function,
    ACTIONS(1439), 1,
      anon_sym_if,
    ACTIONS(1441), 1,
      anon_sym_for,
    ACTIONS(1443), 1,
      anon_sym_while,
    ACTIONS(1445), 1,
      anon_sym_repeat,
    ACTIONS(1447), 1,
      anon_sym_QMARK,
    ACTIONS(1449), 1,
      anon_sym_TILDE,
    ACTIONS(1457), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1459), 1,
      sym__number_literal,
    ACTIONS(1461), 1,
      anon_sym_SQUOTE,
    ACTIONS(1463), 1,
      anon_sym_DQUOTE,
    ACTIONS(1473), 1,
      sym__raw_string_literal,
    ACTIONS(1475), 1,
      sym__external_open_parenthesis,
    ACTIONS(1477), 1,
      sym__external_open_brace,
    ACTIONS(8097), 1,
      anon_sym_BANG,
    ACTIONS(8213), 1,
      sym_dot_dot_i,
    ACTIONS(8215), 1,
      sym__newline,
    STATE(76), 1,
      sym__open_parenthesis,
    STATE(188), 1,
      sym__open_brace,
    STATE(2234), 1,
      sym_string,
    STATE(2236), 1,
      sym__single_quoted_string,
    STATE(2237), 1,
      sym__double_quoted_string,
    STATE(3159), 1,
      aux_sym_function_definition_repeat1,
    STATE(5150), 1,
      sym__string_or_identifier,
    ACTIONS(1453), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2235), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1467), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8211), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1134), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [10965] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3491), 1,
      sym_identifier,
    ACTIONS(3493), 1,
      anon_sym_BSLASH,
    ACTIONS(3495), 1,
      anon_sym_function,
    ACTIONS(3497), 1,
      anon_sym_if,
    ACTIONS(3499), 1,
      anon_sym_for,
    ACTIONS(3501), 1,
      anon_sym_while,
    ACTIONS(3503), 1,
      anon_sym_repeat,
    ACTIONS(3505), 1,
      anon_sym_QMARK,
    ACTIONS(3507), 1,
      anon_sym_TILDE,
    ACTIONS(3515), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3517), 1,
      sym__number_literal,
    ACTIONS(3519), 1,
      anon_sym_SQUOTE,
    ACTIONS(3521), 1,
      anon_sym_DQUOTE,
    ACTIONS(3531), 1,
      sym__raw_string_literal,
    ACTIONS(3533), 1,
      sym__external_open_parenthesis,
    ACTIONS(3535), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7789), 1,
      anon_sym_BANG,
    ACTIONS(8219), 1,
      sym_dot_dot_i,
    STATE(63), 1,
      sym__open_brace,
    STATE(147), 1,
      sym__open_parenthesis,
    STATE(2441), 1,
      sym_string,
    STATE(2456), 1,
      sym__single_quoted_string,
    STATE(2478), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5130), 1,
      sym__string_or_identifier,
    ACTIONS(3511), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2448), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3525), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8217), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1608), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [11094] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2943), 1,
      sym_identifier,
    ACTIONS(2945), 1,
      anon_sym_BSLASH,
    ACTIONS(2947), 1,
      anon_sym_function,
    ACTIONS(2949), 1,
      anon_sym_if,
    ACTIONS(2951), 1,
      anon_sym_for,
    ACTIONS(2953), 1,
      anon_sym_while,
    ACTIONS(2955), 1,
      anon_sym_repeat,
    ACTIONS(2957), 1,
      anon_sym_QMARK,
    ACTIONS(2959), 1,
      anon_sym_TILDE,
    ACTIONS(2967), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2969), 1,
      sym__number_literal,
    ACTIONS(2971), 1,
      anon_sym_SQUOTE,
    ACTIONS(2973), 1,
      anon_sym_DQUOTE,
    ACTIONS(2983), 1,
      sym__raw_string_literal,
    ACTIONS(2985), 1,
      sym__external_open_parenthesis,
    ACTIONS(2989), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7797), 1,
      anon_sym_BANG,
    ACTIONS(8223), 1,
      sym_dot_dot_i,
    STATE(173), 1,
      sym__open_brace,
    STATE(246), 1,
      sym__open_parenthesis,
    STATE(2462), 1,
      sym__single_quoted_string,
    STATE(2494), 1,
      sym__double_quoted_string,
    STATE(2541), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5128), 1,
      sym__string_or_identifier,
    ACTIONS(2963), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2540), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2977), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8221), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1819), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [11223] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3491), 1,
      sym_identifier,
    ACTIONS(3493), 1,
      anon_sym_BSLASH,
    ACTIONS(3495), 1,
      anon_sym_function,
    ACTIONS(3497), 1,
      anon_sym_if,
    ACTIONS(3499), 1,
      anon_sym_for,
    ACTIONS(3501), 1,
      anon_sym_while,
    ACTIONS(3503), 1,
      anon_sym_repeat,
    ACTIONS(3505), 1,
      anon_sym_QMARK,
    ACTIONS(3507), 1,
      anon_sym_TILDE,
    ACTIONS(3515), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3517), 1,
      sym__number_literal,
    ACTIONS(3519), 1,
      anon_sym_SQUOTE,
    ACTIONS(3521), 1,
      anon_sym_DQUOTE,
    ACTIONS(3531), 1,
      sym__raw_string_literal,
    ACTIONS(3533), 1,
      sym__external_open_parenthesis,
    ACTIONS(3535), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7789), 1,
      anon_sym_BANG,
    ACTIONS(8227), 1,
      sym_dot_dot_i,
    STATE(63), 1,
      sym__open_brace,
    STATE(147), 1,
      sym__open_parenthesis,
    STATE(2441), 1,
      sym_string,
    STATE(2456), 1,
      sym__single_quoted_string,
    STATE(2478), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5130), 1,
      sym__string_or_identifier,
    ACTIONS(3511), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2448), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3525), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8225), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1605), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [11352] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(626), 1,
      sym_identifier,
    ACTIONS(628), 1,
      anon_sym_BSLASH,
    ACTIONS(630), 1,
      anon_sym_function,
    ACTIONS(632), 1,
      anon_sym_if,
    ACTIONS(634), 1,
      anon_sym_for,
    ACTIONS(636), 1,
      anon_sym_while,
    ACTIONS(638), 1,
      anon_sym_repeat,
    ACTIONS(640), 1,
      anon_sym_QMARK,
    ACTIONS(642), 1,
      anon_sym_TILDE,
    ACTIONS(650), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(652), 1,
      sym__number_literal,
    ACTIONS(654), 1,
      anon_sym_SQUOTE,
    ACTIONS(656), 1,
      anon_sym_DQUOTE,
    ACTIONS(666), 1,
      sym__raw_string_literal,
    ACTIONS(668), 1,
      sym__external_open_parenthesis,
    ACTIONS(670), 1,
      sym__external_open_brace,
    ACTIONS(7933), 1,
      anon_sym_BANG,
    ACTIONS(8231), 1,
      sym_dot_dot_i,
    ACTIONS(8233), 1,
      sym__newline,
    STATE(54), 1,
      sym__open_parenthesis,
    STATE(56), 1,
      sym__open_brace,
    STATE(2219), 1,
      sym_string,
    STATE(2221), 1,
      sym__single_quoted_string,
    STATE(2222), 1,
      sym__double_quoted_string,
    STATE(3374), 1,
      aux_sym_function_definition_repeat1,
    STATE(5140), 1,
      sym__string_or_identifier,
    ACTIONS(646), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2220), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(660), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8229), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(674), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [11481] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3491), 1,
      sym_identifier,
    ACTIONS(3493), 1,
      anon_sym_BSLASH,
    ACTIONS(3495), 1,
      anon_sym_function,
    ACTIONS(3497), 1,
      anon_sym_if,
    ACTIONS(3499), 1,
      anon_sym_for,
    ACTIONS(3501), 1,
      anon_sym_while,
    ACTIONS(3503), 1,
      anon_sym_repeat,
    ACTIONS(3505), 1,
      anon_sym_QMARK,
    ACTIONS(3507), 1,
      anon_sym_TILDE,
    ACTIONS(3515), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3517), 1,
      sym__number_literal,
    ACTIONS(3519), 1,
      anon_sym_SQUOTE,
    ACTIONS(3521), 1,
      anon_sym_DQUOTE,
    ACTIONS(3531), 1,
      sym__raw_string_literal,
    ACTIONS(3533), 1,
      sym__external_open_parenthesis,
    ACTIONS(3535), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7789), 1,
      anon_sym_BANG,
    ACTIONS(8237), 1,
      sym_dot_dot_i,
    STATE(63), 1,
      sym__open_brace,
    STATE(147), 1,
      sym__open_parenthesis,
    STATE(2441), 1,
      sym_string,
    STATE(2456), 1,
      sym__single_quoted_string,
    STATE(2478), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5130), 1,
      sym__string_or_identifier,
    ACTIONS(3511), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2448), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3525), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8235), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1602), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [11610] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2425), 1,
      sym_identifier,
    ACTIONS(2427), 1,
      anon_sym_BSLASH,
    ACTIONS(2429), 1,
      anon_sym_function,
    ACTIONS(2431), 1,
      anon_sym_if,
    ACTIONS(2433), 1,
      anon_sym_for,
    ACTIONS(2435), 1,
      anon_sym_while,
    ACTIONS(2437), 1,
      anon_sym_repeat,
    ACTIONS(2439), 1,
      anon_sym_QMARK,
    ACTIONS(2441), 1,
      anon_sym_TILDE,
    ACTIONS(2449), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2451), 1,
      sym__number_literal,
    ACTIONS(2453), 1,
      anon_sym_SQUOTE,
    ACTIONS(2455), 1,
      anon_sym_DQUOTE,
    ACTIONS(2465), 1,
      sym__raw_string_literal,
    ACTIONS(2467), 1,
      sym__external_open_parenthesis,
    ACTIONS(2471), 1,
      sym__external_open_brace,
    ACTIONS(7781), 1,
      anon_sym_BANG,
    ACTIONS(8241), 1,
      sym_dot_dot_i,
    ACTIONS(8243), 1,
      sym__newline,
    STATE(97), 1,
      sym__open_brace,
    STATE(200), 1,
      sym__open_parenthesis,
    STATE(2369), 1,
      sym__double_quoted_string,
    STATE(2370), 1,
      sym__single_quoted_string,
    STATE(2372), 1,
      sym_string,
    STATE(3056), 1,
      aux_sym_function_definition_repeat1,
    STATE(5138), 1,
      sym__string_or_identifier,
    ACTIONS(2445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2371), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8239), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1729), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [11739] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3491), 1,
      sym_identifier,
    ACTIONS(3493), 1,
      anon_sym_BSLASH,
    ACTIONS(3495), 1,
      anon_sym_function,
    ACTIONS(3497), 1,
      anon_sym_if,
    ACTIONS(3499), 1,
      anon_sym_for,
    ACTIONS(3501), 1,
      anon_sym_while,
    ACTIONS(3503), 1,
      anon_sym_repeat,
    ACTIONS(3505), 1,
      anon_sym_QMARK,
    ACTIONS(3507), 1,
      anon_sym_TILDE,
    ACTIONS(3515), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3517), 1,
      sym__number_literal,
    ACTIONS(3519), 1,
      anon_sym_SQUOTE,
    ACTIONS(3521), 1,
      anon_sym_DQUOTE,
    ACTIONS(3531), 1,
      sym__raw_string_literal,
    ACTIONS(3533), 1,
      sym__external_open_parenthesis,
    ACTIONS(3535), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7789), 1,
      anon_sym_BANG,
    ACTIONS(8247), 1,
      sym_dot_dot_i,
    STATE(63), 1,
      sym__open_brace,
    STATE(147), 1,
      sym__open_parenthesis,
    STATE(2441), 1,
      sym_string,
    STATE(2456), 1,
      sym__single_quoted_string,
    STATE(2478), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5130), 1,
      sym__string_or_identifier,
    ACTIONS(3511), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2448), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3525), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8245), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1601), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [11868] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2425), 1,
      sym_identifier,
    ACTIONS(2427), 1,
      anon_sym_BSLASH,
    ACTIONS(2429), 1,
      anon_sym_function,
    ACTIONS(2431), 1,
      anon_sym_if,
    ACTIONS(2433), 1,
      anon_sym_for,
    ACTIONS(2435), 1,
      anon_sym_while,
    ACTIONS(2437), 1,
      anon_sym_repeat,
    ACTIONS(2439), 1,
      anon_sym_QMARK,
    ACTIONS(2441), 1,
      anon_sym_TILDE,
    ACTIONS(2449), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2451), 1,
      sym__number_literal,
    ACTIONS(2453), 1,
      anon_sym_SQUOTE,
    ACTIONS(2455), 1,
      anon_sym_DQUOTE,
    ACTIONS(2465), 1,
      sym__raw_string_literal,
    ACTIONS(2467), 1,
      sym__external_open_parenthesis,
    ACTIONS(2471), 1,
      sym__external_open_brace,
    ACTIONS(7781), 1,
      anon_sym_BANG,
    ACTIONS(8251), 1,
      sym_dot_dot_i,
    ACTIONS(8253), 1,
      sym__newline,
    STATE(97), 1,
      sym__open_brace,
    STATE(200), 1,
      sym__open_parenthesis,
    STATE(2369), 1,
      sym__double_quoted_string,
    STATE(2370), 1,
      sym__single_quoted_string,
    STATE(2372), 1,
      sym_string,
    STATE(3057), 1,
      aux_sym_function_definition_repeat1,
    STATE(5138), 1,
      sym__string_or_identifier,
    ACTIONS(2445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2371), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8249), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1744), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [11997] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3491), 1,
      sym_identifier,
    ACTIONS(3493), 1,
      anon_sym_BSLASH,
    ACTIONS(3495), 1,
      anon_sym_function,
    ACTIONS(3497), 1,
      anon_sym_if,
    ACTIONS(3499), 1,
      anon_sym_for,
    ACTIONS(3501), 1,
      anon_sym_while,
    ACTIONS(3503), 1,
      anon_sym_repeat,
    ACTIONS(3505), 1,
      anon_sym_QMARK,
    ACTIONS(3507), 1,
      anon_sym_TILDE,
    ACTIONS(3515), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3517), 1,
      sym__number_literal,
    ACTIONS(3519), 1,
      anon_sym_SQUOTE,
    ACTIONS(3521), 1,
      anon_sym_DQUOTE,
    ACTIONS(3531), 1,
      sym__raw_string_literal,
    ACTIONS(3533), 1,
      sym__external_open_parenthesis,
    ACTIONS(3535), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7789), 1,
      anon_sym_BANG,
    ACTIONS(8257), 1,
      sym_dot_dot_i,
    STATE(63), 1,
      sym__open_brace,
    STATE(147), 1,
      sym__open_parenthesis,
    STATE(2441), 1,
      sym_string,
    STATE(2456), 1,
      sym__single_quoted_string,
    STATE(2478), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5130), 1,
      sym__string_or_identifier,
    ACTIONS(3511), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2448), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3525), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8255), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1597), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [12126] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2425), 1,
      sym_identifier,
    ACTIONS(2427), 1,
      anon_sym_BSLASH,
    ACTIONS(2429), 1,
      anon_sym_function,
    ACTIONS(2431), 1,
      anon_sym_if,
    ACTIONS(2433), 1,
      anon_sym_for,
    ACTIONS(2435), 1,
      anon_sym_while,
    ACTIONS(2437), 1,
      anon_sym_repeat,
    ACTIONS(2439), 1,
      anon_sym_QMARK,
    ACTIONS(2441), 1,
      anon_sym_TILDE,
    ACTIONS(2449), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2451), 1,
      sym__number_literal,
    ACTIONS(2453), 1,
      anon_sym_SQUOTE,
    ACTIONS(2455), 1,
      anon_sym_DQUOTE,
    ACTIONS(2465), 1,
      sym__raw_string_literal,
    ACTIONS(2467), 1,
      sym__external_open_parenthesis,
    ACTIONS(2471), 1,
      sym__external_open_brace,
    ACTIONS(7781), 1,
      anon_sym_BANG,
    ACTIONS(8261), 1,
      sym_dot_dot_i,
    ACTIONS(8263), 1,
      sym__newline,
    STATE(97), 1,
      sym__open_brace,
    STATE(200), 1,
      sym__open_parenthesis,
    STATE(2369), 1,
      sym__double_quoted_string,
    STATE(2370), 1,
      sym__single_quoted_string,
    STATE(2372), 1,
      sym_string,
    STATE(3028), 1,
      aux_sym_function_definition_repeat1,
    STATE(5138), 1,
      sym__string_or_identifier,
    ACTIONS(2445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2371), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8259), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1745), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [12255] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3491), 1,
      sym_identifier,
    ACTIONS(3493), 1,
      anon_sym_BSLASH,
    ACTIONS(3495), 1,
      anon_sym_function,
    ACTIONS(3497), 1,
      anon_sym_if,
    ACTIONS(3499), 1,
      anon_sym_for,
    ACTIONS(3501), 1,
      anon_sym_while,
    ACTIONS(3503), 1,
      anon_sym_repeat,
    ACTIONS(3505), 1,
      anon_sym_QMARK,
    ACTIONS(3507), 1,
      anon_sym_TILDE,
    ACTIONS(3515), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3517), 1,
      sym__number_literal,
    ACTIONS(3519), 1,
      anon_sym_SQUOTE,
    ACTIONS(3521), 1,
      anon_sym_DQUOTE,
    ACTIONS(3531), 1,
      sym__raw_string_literal,
    ACTIONS(3533), 1,
      sym__external_open_parenthesis,
    ACTIONS(3535), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7789), 1,
      anon_sym_BANG,
    ACTIONS(8267), 1,
      sym_dot_dot_i,
    STATE(63), 1,
      sym__open_brace,
    STATE(147), 1,
      sym__open_parenthesis,
    STATE(2441), 1,
      sym_string,
    STATE(2456), 1,
      sym__single_quoted_string,
    STATE(2478), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5130), 1,
      sym__string_or_identifier,
    ACTIONS(3511), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2448), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3525), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8265), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1596), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [12384] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2425), 1,
      sym_identifier,
    ACTIONS(2427), 1,
      anon_sym_BSLASH,
    ACTIONS(2429), 1,
      anon_sym_function,
    ACTIONS(2431), 1,
      anon_sym_if,
    ACTIONS(2433), 1,
      anon_sym_for,
    ACTIONS(2435), 1,
      anon_sym_while,
    ACTIONS(2437), 1,
      anon_sym_repeat,
    ACTIONS(2439), 1,
      anon_sym_QMARK,
    ACTIONS(2441), 1,
      anon_sym_TILDE,
    ACTIONS(2449), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2451), 1,
      sym__number_literal,
    ACTIONS(2453), 1,
      anon_sym_SQUOTE,
    ACTIONS(2455), 1,
      anon_sym_DQUOTE,
    ACTIONS(2465), 1,
      sym__raw_string_literal,
    ACTIONS(2467), 1,
      sym__external_open_parenthesis,
    ACTIONS(2471), 1,
      sym__external_open_brace,
    ACTIONS(7781), 1,
      anon_sym_BANG,
    ACTIONS(8271), 1,
      sym_dot_dot_i,
    ACTIONS(8273), 1,
      sym__newline,
    STATE(97), 1,
      sym__open_brace,
    STATE(200), 1,
      sym__open_parenthesis,
    STATE(2369), 1,
      sym__double_quoted_string,
    STATE(2370), 1,
      sym__single_quoted_string,
    STATE(2372), 1,
      sym_string,
    STATE(3059), 1,
      aux_sym_function_definition_repeat1,
    STATE(5138), 1,
      sym__string_or_identifier,
    ACTIONS(2445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2371), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8269), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1746), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [12513] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3491), 1,
      sym_identifier,
    ACTIONS(3493), 1,
      anon_sym_BSLASH,
    ACTIONS(3495), 1,
      anon_sym_function,
    ACTIONS(3497), 1,
      anon_sym_if,
    ACTIONS(3499), 1,
      anon_sym_for,
    ACTIONS(3501), 1,
      anon_sym_while,
    ACTIONS(3503), 1,
      anon_sym_repeat,
    ACTIONS(3505), 1,
      anon_sym_QMARK,
    ACTIONS(3507), 1,
      anon_sym_TILDE,
    ACTIONS(3515), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3517), 1,
      sym__number_literal,
    ACTIONS(3519), 1,
      anon_sym_SQUOTE,
    ACTIONS(3521), 1,
      anon_sym_DQUOTE,
    ACTIONS(3531), 1,
      sym__raw_string_literal,
    ACTIONS(3533), 1,
      sym__external_open_parenthesis,
    ACTIONS(3535), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7789), 1,
      anon_sym_BANG,
    ACTIONS(8277), 1,
      sym_dot_dot_i,
    STATE(63), 1,
      sym__open_brace,
    STATE(147), 1,
      sym__open_parenthesis,
    STATE(2441), 1,
      sym_string,
    STATE(2456), 1,
      sym__single_quoted_string,
    STATE(2478), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5130), 1,
      sym__string_or_identifier,
    ACTIONS(3511), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2448), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3525), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8275), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1595), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [12642] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2483), 1,
      sym_identifier,
    ACTIONS(2485), 1,
      anon_sym_BSLASH,
    ACTIONS(2487), 1,
      anon_sym_function,
    ACTIONS(2489), 1,
      anon_sym_if,
    ACTIONS(2491), 1,
      anon_sym_for,
    ACTIONS(2493), 1,
      anon_sym_while,
    ACTIONS(2495), 1,
      anon_sym_repeat,
    ACTIONS(2497), 1,
      anon_sym_QMARK,
    ACTIONS(2499), 1,
      anon_sym_TILDE,
    ACTIONS(2507), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2509), 1,
      sym__number_literal,
    ACTIONS(2511), 1,
      anon_sym_SQUOTE,
    ACTIONS(2513), 1,
      anon_sym_DQUOTE,
    ACTIONS(2523), 1,
      sym__raw_string_literal,
    ACTIONS(2525), 1,
      sym__external_open_parenthesis,
    ACTIONS(2529), 1,
      sym__external_open_brace,
    ACTIONS(7803), 1,
      anon_sym_BANG,
    ACTIONS(8281), 1,
      sym_dot_dot_i,
    ACTIONS(8283), 1,
      sym__newline,
    STATE(74), 1,
      sym__open_brace,
    STATE(210), 1,
      sym__open_parenthesis,
    STATE(2397), 1,
      sym_string,
    STATE(2430), 1,
      sym__single_quoted_string,
    STATE(2466), 1,
      sym__double_quoted_string,
    STATE(3103), 1,
      aux_sym_function_definition_repeat1,
    STATE(5142), 1,
      sym__string_or_identifier,
    ACTIONS(2503), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2412), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2517), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8279), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1647), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [12771] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3491), 1,
      sym_identifier,
    ACTIONS(3493), 1,
      anon_sym_BSLASH,
    ACTIONS(3495), 1,
      anon_sym_function,
    ACTIONS(3497), 1,
      anon_sym_if,
    ACTIONS(3499), 1,
      anon_sym_for,
    ACTIONS(3501), 1,
      anon_sym_while,
    ACTIONS(3503), 1,
      anon_sym_repeat,
    ACTIONS(3505), 1,
      anon_sym_QMARK,
    ACTIONS(3507), 1,
      anon_sym_TILDE,
    ACTIONS(3515), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3517), 1,
      sym__number_literal,
    ACTIONS(3519), 1,
      anon_sym_SQUOTE,
    ACTIONS(3521), 1,
      anon_sym_DQUOTE,
    ACTIONS(3531), 1,
      sym__raw_string_literal,
    ACTIONS(3533), 1,
      sym__external_open_parenthesis,
    ACTIONS(3535), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7789), 1,
      anon_sym_BANG,
    ACTIONS(8287), 1,
      sym_dot_dot_i,
    STATE(63), 1,
      sym__open_brace,
    STATE(147), 1,
      sym__open_parenthesis,
    STATE(2441), 1,
      sym_string,
    STATE(2456), 1,
      sym__single_quoted_string,
    STATE(2478), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5130), 1,
      sym__string_or_identifier,
    ACTIONS(3511), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2448), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3525), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8285), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1594), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [12900] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2483), 1,
      sym_identifier,
    ACTIONS(2485), 1,
      anon_sym_BSLASH,
    ACTIONS(2487), 1,
      anon_sym_function,
    ACTIONS(2489), 1,
      anon_sym_if,
    ACTIONS(2491), 1,
      anon_sym_for,
    ACTIONS(2493), 1,
      anon_sym_while,
    ACTIONS(2495), 1,
      anon_sym_repeat,
    ACTIONS(2497), 1,
      anon_sym_QMARK,
    ACTIONS(2499), 1,
      anon_sym_TILDE,
    ACTIONS(2507), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2509), 1,
      sym__number_literal,
    ACTIONS(2511), 1,
      anon_sym_SQUOTE,
    ACTIONS(2513), 1,
      anon_sym_DQUOTE,
    ACTIONS(2523), 1,
      sym__raw_string_literal,
    ACTIONS(2525), 1,
      sym__external_open_parenthesis,
    ACTIONS(2529), 1,
      sym__external_open_brace,
    ACTIONS(7803), 1,
      anon_sym_BANG,
    ACTIONS(8291), 1,
      sym_dot_dot_i,
    ACTIONS(8293), 1,
      sym__newline,
    STATE(74), 1,
      sym__open_brace,
    STATE(210), 1,
      sym__open_parenthesis,
    STATE(2397), 1,
      sym_string,
    STATE(2430), 1,
      sym__single_quoted_string,
    STATE(2466), 1,
      sym__double_quoted_string,
    STATE(3106), 1,
      aux_sym_function_definition_repeat1,
    STATE(5142), 1,
      sym__string_or_identifier,
    ACTIONS(2503), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2412), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2517), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8289), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1645), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [13029] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3491), 1,
      sym_identifier,
    ACTIONS(3493), 1,
      anon_sym_BSLASH,
    ACTIONS(3495), 1,
      anon_sym_function,
    ACTIONS(3497), 1,
      anon_sym_if,
    ACTIONS(3499), 1,
      anon_sym_for,
    ACTIONS(3501), 1,
      anon_sym_while,
    ACTIONS(3503), 1,
      anon_sym_repeat,
    ACTIONS(3505), 1,
      anon_sym_QMARK,
    ACTIONS(3507), 1,
      anon_sym_TILDE,
    ACTIONS(3515), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3517), 1,
      sym__number_literal,
    ACTIONS(3519), 1,
      anon_sym_SQUOTE,
    ACTIONS(3521), 1,
      anon_sym_DQUOTE,
    ACTIONS(3531), 1,
      sym__raw_string_literal,
    ACTIONS(3533), 1,
      sym__external_open_parenthesis,
    ACTIONS(3535), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7789), 1,
      anon_sym_BANG,
    ACTIONS(8297), 1,
      sym_dot_dot_i,
    STATE(63), 1,
      sym__open_brace,
    STATE(147), 1,
      sym__open_parenthesis,
    STATE(2441), 1,
      sym_string,
    STATE(2456), 1,
      sym__single_quoted_string,
    STATE(2478), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5130), 1,
      sym__string_or_identifier,
    ACTIONS(3511), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2448), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3525), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8295), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1593), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [13158] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2483), 1,
      sym_identifier,
    ACTIONS(2485), 1,
      anon_sym_BSLASH,
    ACTIONS(2487), 1,
      anon_sym_function,
    ACTIONS(2489), 1,
      anon_sym_if,
    ACTIONS(2491), 1,
      anon_sym_for,
    ACTIONS(2493), 1,
      anon_sym_while,
    ACTIONS(2495), 1,
      anon_sym_repeat,
    ACTIONS(2497), 1,
      anon_sym_QMARK,
    ACTIONS(2499), 1,
      anon_sym_TILDE,
    ACTIONS(2507), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2509), 1,
      sym__number_literal,
    ACTIONS(2511), 1,
      anon_sym_SQUOTE,
    ACTIONS(2513), 1,
      anon_sym_DQUOTE,
    ACTIONS(2523), 1,
      sym__raw_string_literal,
    ACTIONS(2525), 1,
      sym__external_open_parenthesis,
    ACTIONS(2529), 1,
      sym__external_open_brace,
    ACTIONS(7803), 1,
      anon_sym_BANG,
    ACTIONS(8301), 1,
      sym_dot_dot_i,
    ACTIONS(8303), 1,
      sym__newline,
    STATE(74), 1,
      sym__open_brace,
    STATE(210), 1,
      sym__open_parenthesis,
    STATE(2397), 1,
      sym_string,
    STATE(2430), 1,
      sym__single_quoted_string,
    STATE(2466), 1,
      sym__double_quoted_string,
    STATE(3108), 1,
      aux_sym_function_definition_repeat1,
    STATE(5142), 1,
      sym__string_or_identifier,
    ACTIONS(2503), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2412), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2517), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8299), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1643), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [13287] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3491), 1,
      sym_identifier,
    ACTIONS(3493), 1,
      anon_sym_BSLASH,
    ACTIONS(3495), 1,
      anon_sym_function,
    ACTIONS(3497), 1,
      anon_sym_if,
    ACTIONS(3499), 1,
      anon_sym_for,
    ACTIONS(3501), 1,
      anon_sym_while,
    ACTIONS(3503), 1,
      anon_sym_repeat,
    ACTIONS(3505), 1,
      anon_sym_QMARK,
    ACTIONS(3507), 1,
      anon_sym_TILDE,
    ACTIONS(3515), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3517), 1,
      sym__number_literal,
    ACTIONS(3519), 1,
      anon_sym_SQUOTE,
    ACTIONS(3521), 1,
      anon_sym_DQUOTE,
    ACTIONS(3531), 1,
      sym__raw_string_literal,
    ACTIONS(3533), 1,
      sym__external_open_parenthesis,
    ACTIONS(3535), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7789), 1,
      anon_sym_BANG,
    ACTIONS(8307), 1,
      sym_dot_dot_i,
    STATE(63), 1,
      sym__open_brace,
    STATE(147), 1,
      sym__open_parenthesis,
    STATE(2441), 1,
      sym_string,
    STATE(2456), 1,
      sym__single_quoted_string,
    STATE(2478), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5130), 1,
      sym__string_or_identifier,
    ACTIONS(3511), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2448), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3525), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8305), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1578), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [13416] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2425), 1,
      sym_identifier,
    ACTIONS(2427), 1,
      anon_sym_BSLASH,
    ACTIONS(2429), 1,
      anon_sym_function,
    ACTIONS(2431), 1,
      anon_sym_if,
    ACTIONS(2433), 1,
      anon_sym_for,
    ACTIONS(2435), 1,
      anon_sym_while,
    ACTIONS(2437), 1,
      anon_sym_repeat,
    ACTIONS(2439), 1,
      anon_sym_QMARK,
    ACTIONS(2441), 1,
      anon_sym_TILDE,
    ACTIONS(2449), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2451), 1,
      sym__number_literal,
    ACTIONS(2453), 1,
      anon_sym_SQUOTE,
    ACTIONS(2455), 1,
      anon_sym_DQUOTE,
    ACTIONS(2465), 1,
      sym__raw_string_literal,
    ACTIONS(2467), 1,
      sym__external_open_parenthesis,
    ACTIONS(2471), 1,
      sym__external_open_brace,
    ACTIONS(7781), 1,
      anon_sym_BANG,
    ACTIONS(8311), 1,
      sym_dot_dot_i,
    ACTIONS(8313), 1,
      sym__newline,
    STATE(97), 1,
      sym__open_brace,
    STATE(200), 1,
      sym__open_parenthesis,
    STATE(2369), 1,
      sym__double_quoted_string,
    STATE(2370), 1,
      sym__single_quoted_string,
    STATE(2372), 1,
      sym_string,
    STATE(3071), 1,
      aux_sym_function_definition_repeat1,
    STATE(5138), 1,
      sym__string_or_identifier,
    ACTIONS(2445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2371), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8309), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1747), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [13545] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2483), 1,
      sym_identifier,
    ACTIONS(2485), 1,
      anon_sym_BSLASH,
    ACTIONS(2487), 1,
      anon_sym_function,
    ACTIONS(2489), 1,
      anon_sym_if,
    ACTIONS(2491), 1,
      anon_sym_for,
    ACTIONS(2493), 1,
      anon_sym_while,
    ACTIONS(2495), 1,
      anon_sym_repeat,
    ACTIONS(2497), 1,
      anon_sym_QMARK,
    ACTIONS(2499), 1,
      anon_sym_TILDE,
    ACTIONS(2507), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2509), 1,
      sym__number_literal,
    ACTIONS(2511), 1,
      anon_sym_SQUOTE,
    ACTIONS(2513), 1,
      anon_sym_DQUOTE,
    ACTIONS(2523), 1,
      sym__raw_string_literal,
    ACTIONS(2525), 1,
      sym__external_open_parenthesis,
    ACTIONS(2529), 1,
      sym__external_open_brace,
    ACTIONS(7803), 1,
      anon_sym_BANG,
    ACTIONS(8317), 1,
      sym_dot_dot_i,
    ACTIONS(8319), 1,
      sym__newline,
    STATE(74), 1,
      sym__open_brace,
    STATE(210), 1,
      sym__open_parenthesis,
    STATE(2397), 1,
      sym_string,
    STATE(2430), 1,
      sym__single_quoted_string,
    STATE(2466), 1,
      sym__double_quoted_string,
    STATE(3110), 1,
      aux_sym_function_definition_repeat1,
    STATE(5142), 1,
      sym__string_or_identifier,
    ACTIONS(2503), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2412), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2517), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8315), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1641), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [13674] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2425), 1,
      sym_identifier,
    ACTIONS(2427), 1,
      anon_sym_BSLASH,
    ACTIONS(2429), 1,
      anon_sym_function,
    ACTIONS(2431), 1,
      anon_sym_if,
    ACTIONS(2433), 1,
      anon_sym_for,
    ACTIONS(2435), 1,
      anon_sym_while,
    ACTIONS(2437), 1,
      anon_sym_repeat,
    ACTIONS(2439), 1,
      anon_sym_QMARK,
    ACTIONS(2441), 1,
      anon_sym_TILDE,
    ACTIONS(2449), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2451), 1,
      sym__number_literal,
    ACTIONS(2453), 1,
      anon_sym_SQUOTE,
    ACTIONS(2455), 1,
      anon_sym_DQUOTE,
    ACTIONS(2465), 1,
      sym__raw_string_literal,
    ACTIONS(2467), 1,
      sym__external_open_parenthesis,
    ACTIONS(2471), 1,
      sym__external_open_brace,
    ACTIONS(7781), 1,
      anon_sym_BANG,
    ACTIONS(8323), 1,
      sym_dot_dot_i,
    ACTIONS(8325), 1,
      sym__newline,
    STATE(97), 1,
      sym__open_brace,
    STATE(200), 1,
      sym__open_parenthesis,
    STATE(2369), 1,
      sym__double_quoted_string,
    STATE(2370), 1,
      sym__single_quoted_string,
    STATE(2372), 1,
      sym_string,
    STATE(3072), 1,
      aux_sym_function_definition_repeat1,
    STATE(5138), 1,
      sym__string_or_identifier,
    ACTIONS(2445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2371), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8321), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1748), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [13803] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2425), 1,
      sym_identifier,
    ACTIONS(2427), 1,
      anon_sym_BSLASH,
    ACTIONS(2429), 1,
      anon_sym_function,
    ACTIONS(2431), 1,
      anon_sym_if,
    ACTIONS(2433), 1,
      anon_sym_for,
    ACTIONS(2435), 1,
      anon_sym_while,
    ACTIONS(2437), 1,
      anon_sym_repeat,
    ACTIONS(2439), 1,
      anon_sym_QMARK,
    ACTIONS(2441), 1,
      anon_sym_TILDE,
    ACTIONS(2449), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2451), 1,
      sym__number_literal,
    ACTIONS(2453), 1,
      anon_sym_SQUOTE,
    ACTIONS(2455), 1,
      anon_sym_DQUOTE,
    ACTIONS(2465), 1,
      sym__raw_string_literal,
    ACTIONS(2467), 1,
      sym__external_open_parenthesis,
    ACTIONS(2471), 1,
      sym__external_open_brace,
    ACTIONS(7781), 1,
      anon_sym_BANG,
    ACTIONS(8329), 1,
      sym_dot_dot_i,
    ACTIONS(8331), 1,
      sym__newline,
    STATE(97), 1,
      sym__open_brace,
    STATE(200), 1,
      sym__open_parenthesis,
    STATE(2369), 1,
      sym__double_quoted_string,
    STATE(2370), 1,
      sym__single_quoted_string,
    STATE(2372), 1,
      sym_string,
    STATE(3074), 1,
      aux_sym_function_definition_repeat1,
    STATE(5138), 1,
      sym__string_or_identifier,
    ACTIONS(2445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2371), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8327), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1753), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [13932] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2425), 1,
      sym_identifier,
    ACTIONS(2427), 1,
      anon_sym_BSLASH,
    ACTIONS(2429), 1,
      anon_sym_function,
    ACTIONS(2431), 1,
      anon_sym_if,
    ACTIONS(2433), 1,
      anon_sym_for,
    ACTIONS(2435), 1,
      anon_sym_while,
    ACTIONS(2437), 1,
      anon_sym_repeat,
    ACTIONS(2439), 1,
      anon_sym_QMARK,
    ACTIONS(2441), 1,
      anon_sym_TILDE,
    ACTIONS(2449), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2451), 1,
      sym__number_literal,
    ACTIONS(2453), 1,
      anon_sym_SQUOTE,
    ACTIONS(2455), 1,
      anon_sym_DQUOTE,
    ACTIONS(2465), 1,
      sym__raw_string_literal,
    ACTIONS(2467), 1,
      sym__external_open_parenthesis,
    ACTIONS(2471), 1,
      sym__external_open_brace,
    ACTIONS(7781), 1,
      anon_sym_BANG,
    ACTIONS(8335), 1,
      sym_dot_dot_i,
    ACTIONS(8337), 1,
      sym__newline,
    STATE(97), 1,
      sym__open_brace,
    STATE(200), 1,
      sym__open_parenthesis,
    STATE(2369), 1,
      sym__double_quoted_string,
    STATE(2370), 1,
      sym__single_quoted_string,
    STATE(2372), 1,
      sym_string,
    STATE(3089), 1,
      aux_sym_function_definition_repeat1,
    STATE(5138), 1,
      sym__string_or_identifier,
    ACTIONS(2445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2371), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8333), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1761), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [14061] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2425), 1,
      sym_identifier,
    ACTIONS(2427), 1,
      anon_sym_BSLASH,
    ACTIONS(2429), 1,
      anon_sym_function,
    ACTIONS(2431), 1,
      anon_sym_if,
    ACTIONS(2433), 1,
      anon_sym_for,
    ACTIONS(2435), 1,
      anon_sym_while,
    ACTIONS(2437), 1,
      anon_sym_repeat,
    ACTIONS(2439), 1,
      anon_sym_QMARK,
    ACTIONS(2441), 1,
      anon_sym_TILDE,
    ACTIONS(2449), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2451), 1,
      sym__number_literal,
    ACTIONS(2453), 1,
      anon_sym_SQUOTE,
    ACTIONS(2455), 1,
      anon_sym_DQUOTE,
    ACTIONS(2465), 1,
      sym__raw_string_literal,
    ACTIONS(2467), 1,
      sym__external_open_parenthesis,
    ACTIONS(2471), 1,
      sym__external_open_brace,
    ACTIONS(7781), 1,
      anon_sym_BANG,
    ACTIONS(8341), 1,
      sym_dot_dot_i,
    ACTIONS(8343), 1,
      sym__newline,
    STATE(97), 1,
      sym__open_brace,
    STATE(200), 1,
      sym__open_parenthesis,
    STATE(2369), 1,
      sym__double_quoted_string,
    STATE(2370), 1,
      sym__single_quoted_string,
    STATE(2372), 1,
      sym_string,
    STATE(3092), 1,
      aux_sym_function_definition_repeat1,
    STATE(5138), 1,
      sym__string_or_identifier,
    ACTIONS(2445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2371), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8339), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1762), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [14190] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2425), 1,
      sym_identifier,
    ACTIONS(2427), 1,
      anon_sym_BSLASH,
    ACTIONS(2429), 1,
      anon_sym_function,
    ACTIONS(2431), 1,
      anon_sym_if,
    ACTIONS(2433), 1,
      anon_sym_for,
    ACTIONS(2435), 1,
      anon_sym_while,
    ACTIONS(2437), 1,
      anon_sym_repeat,
    ACTIONS(2439), 1,
      anon_sym_QMARK,
    ACTIONS(2441), 1,
      anon_sym_TILDE,
    ACTIONS(2449), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2451), 1,
      sym__number_literal,
    ACTIONS(2453), 1,
      anon_sym_SQUOTE,
    ACTIONS(2455), 1,
      anon_sym_DQUOTE,
    ACTIONS(2465), 1,
      sym__raw_string_literal,
    ACTIONS(2467), 1,
      sym__external_open_parenthesis,
    ACTIONS(2471), 1,
      sym__external_open_brace,
    ACTIONS(7781), 1,
      anon_sym_BANG,
    ACTIONS(8347), 1,
      sym_dot_dot_i,
    ACTIONS(8349), 1,
      sym__newline,
    STATE(97), 1,
      sym__open_brace,
    STATE(200), 1,
      sym__open_parenthesis,
    STATE(2369), 1,
      sym__double_quoted_string,
    STATE(2370), 1,
      sym__single_quoted_string,
    STATE(2372), 1,
      sym_string,
    STATE(3093), 1,
      aux_sym_function_definition_repeat1,
    STATE(5138), 1,
      sym__string_or_identifier,
    ACTIONS(2445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2371), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8345), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1765), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [14319] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2425), 1,
      sym_identifier,
    ACTIONS(2427), 1,
      anon_sym_BSLASH,
    ACTIONS(2429), 1,
      anon_sym_function,
    ACTIONS(2431), 1,
      anon_sym_if,
    ACTIONS(2433), 1,
      anon_sym_for,
    ACTIONS(2435), 1,
      anon_sym_while,
    ACTIONS(2437), 1,
      anon_sym_repeat,
    ACTIONS(2439), 1,
      anon_sym_QMARK,
    ACTIONS(2441), 1,
      anon_sym_TILDE,
    ACTIONS(2449), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2451), 1,
      sym__number_literal,
    ACTIONS(2453), 1,
      anon_sym_SQUOTE,
    ACTIONS(2455), 1,
      anon_sym_DQUOTE,
    ACTIONS(2465), 1,
      sym__raw_string_literal,
    ACTIONS(2467), 1,
      sym__external_open_parenthesis,
    ACTIONS(2471), 1,
      sym__external_open_brace,
    ACTIONS(7781), 1,
      anon_sym_BANG,
    ACTIONS(8353), 1,
      sym_dot_dot_i,
    ACTIONS(8355), 1,
      sym__newline,
    STATE(97), 1,
      sym__open_brace,
    STATE(200), 1,
      sym__open_parenthesis,
    STATE(2369), 1,
      sym__double_quoted_string,
    STATE(2370), 1,
      sym__single_quoted_string,
    STATE(2372), 1,
      sym_string,
    STATE(3097), 1,
      aux_sym_function_definition_repeat1,
    STATE(5138), 1,
      sym__string_or_identifier,
    ACTIONS(2445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2371), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8351), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1770), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [14448] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2425), 1,
      sym_identifier,
    ACTIONS(2427), 1,
      anon_sym_BSLASH,
    ACTIONS(2429), 1,
      anon_sym_function,
    ACTIONS(2431), 1,
      anon_sym_if,
    ACTIONS(2433), 1,
      anon_sym_for,
    ACTIONS(2435), 1,
      anon_sym_while,
    ACTIONS(2437), 1,
      anon_sym_repeat,
    ACTIONS(2439), 1,
      anon_sym_QMARK,
    ACTIONS(2441), 1,
      anon_sym_TILDE,
    ACTIONS(2449), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2451), 1,
      sym__number_literal,
    ACTIONS(2453), 1,
      anon_sym_SQUOTE,
    ACTIONS(2455), 1,
      anon_sym_DQUOTE,
    ACTIONS(2465), 1,
      sym__raw_string_literal,
    ACTIONS(2467), 1,
      sym__external_open_parenthesis,
    ACTIONS(2471), 1,
      sym__external_open_brace,
    ACTIONS(7781), 1,
      anon_sym_BANG,
    ACTIONS(8359), 1,
      sym_dot_dot_i,
    ACTIONS(8361), 1,
      sym__newline,
    STATE(97), 1,
      sym__open_brace,
    STATE(200), 1,
      sym__open_parenthesis,
    STATE(2369), 1,
      sym__double_quoted_string,
    STATE(2370), 1,
      sym__single_quoted_string,
    STATE(2372), 1,
      sym_string,
    STATE(3099), 1,
      aux_sym_function_definition_repeat1,
    STATE(5138), 1,
      sym__string_or_identifier,
    ACTIONS(2445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2371), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8357), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1776), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [14577] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2425), 1,
      sym_identifier,
    ACTIONS(2427), 1,
      anon_sym_BSLASH,
    ACTIONS(2429), 1,
      anon_sym_function,
    ACTIONS(2431), 1,
      anon_sym_if,
    ACTIONS(2433), 1,
      anon_sym_for,
    ACTIONS(2435), 1,
      anon_sym_while,
    ACTIONS(2437), 1,
      anon_sym_repeat,
    ACTIONS(2439), 1,
      anon_sym_QMARK,
    ACTIONS(2441), 1,
      anon_sym_TILDE,
    ACTIONS(2449), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2451), 1,
      sym__number_literal,
    ACTIONS(2453), 1,
      anon_sym_SQUOTE,
    ACTIONS(2455), 1,
      anon_sym_DQUOTE,
    ACTIONS(2465), 1,
      sym__raw_string_literal,
    ACTIONS(2467), 1,
      sym__external_open_parenthesis,
    ACTIONS(2471), 1,
      sym__external_open_brace,
    ACTIONS(7781), 1,
      anon_sym_BANG,
    ACTIONS(8365), 1,
      sym_dot_dot_i,
    ACTIONS(8367), 1,
      sym__newline,
    STATE(97), 1,
      sym__open_brace,
    STATE(200), 1,
      sym__open_parenthesis,
    STATE(2369), 1,
      sym__double_quoted_string,
    STATE(2370), 1,
      sym__single_quoted_string,
    STATE(2372), 1,
      sym_string,
    STATE(3101), 1,
      aux_sym_function_definition_repeat1,
    STATE(5138), 1,
      sym__string_or_identifier,
    ACTIONS(2445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2371), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8363), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1777), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [14706] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2425), 1,
      sym_identifier,
    ACTIONS(2427), 1,
      anon_sym_BSLASH,
    ACTIONS(2429), 1,
      anon_sym_function,
    ACTIONS(2431), 1,
      anon_sym_if,
    ACTIONS(2433), 1,
      anon_sym_for,
    ACTIONS(2435), 1,
      anon_sym_while,
    ACTIONS(2437), 1,
      anon_sym_repeat,
    ACTIONS(2439), 1,
      anon_sym_QMARK,
    ACTIONS(2441), 1,
      anon_sym_TILDE,
    ACTIONS(2449), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2451), 1,
      sym__number_literal,
    ACTIONS(2453), 1,
      anon_sym_SQUOTE,
    ACTIONS(2455), 1,
      anon_sym_DQUOTE,
    ACTIONS(2465), 1,
      sym__raw_string_literal,
    ACTIONS(2467), 1,
      sym__external_open_parenthesis,
    ACTIONS(2471), 1,
      sym__external_open_brace,
    ACTIONS(7781), 1,
      anon_sym_BANG,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8371), 1,
      sym_dot_dot_i,
    STATE(97), 1,
      sym__open_brace,
    STATE(200), 1,
      sym__open_parenthesis,
    STATE(2369), 1,
      sym__double_quoted_string,
    STATE(2370), 1,
      sym__single_quoted_string,
    STATE(2372), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5138), 1,
      sym__string_or_identifier,
    ACTIONS(2445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2371), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8369), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1778), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [14835] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2425), 1,
      sym_identifier,
    ACTIONS(2427), 1,
      anon_sym_BSLASH,
    ACTIONS(2429), 1,
      anon_sym_function,
    ACTIONS(2431), 1,
      anon_sym_if,
    ACTIONS(2433), 1,
      anon_sym_for,
    ACTIONS(2435), 1,
      anon_sym_while,
    ACTIONS(2437), 1,
      anon_sym_repeat,
    ACTIONS(2439), 1,
      anon_sym_QMARK,
    ACTIONS(2441), 1,
      anon_sym_TILDE,
    ACTIONS(2449), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2451), 1,
      sym__number_literal,
    ACTIONS(2453), 1,
      anon_sym_SQUOTE,
    ACTIONS(2455), 1,
      anon_sym_DQUOTE,
    ACTIONS(2465), 1,
      sym__raw_string_literal,
    ACTIONS(2467), 1,
      sym__external_open_parenthesis,
    ACTIONS(2471), 1,
      sym__external_open_brace,
    ACTIONS(7781), 1,
      anon_sym_BANG,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8375), 1,
      sym_dot_dot_i,
    STATE(97), 1,
      sym__open_brace,
    STATE(200), 1,
      sym__open_parenthesis,
    STATE(2369), 1,
      sym__double_quoted_string,
    STATE(2370), 1,
      sym__single_quoted_string,
    STATE(2372), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5138), 1,
      sym__string_or_identifier,
    ACTIONS(2445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2371), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8373), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1779), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [14964] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2943), 1,
      sym_identifier,
    ACTIONS(2945), 1,
      anon_sym_BSLASH,
    ACTIONS(2947), 1,
      anon_sym_function,
    ACTIONS(2949), 1,
      anon_sym_if,
    ACTIONS(2951), 1,
      anon_sym_for,
    ACTIONS(2953), 1,
      anon_sym_while,
    ACTIONS(2955), 1,
      anon_sym_repeat,
    ACTIONS(2957), 1,
      anon_sym_QMARK,
    ACTIONS(2959), 1,
      anon_sym_TILDE,
    ACTIONS(2967), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2969), 1,
      sym__number_literal,
    ACTIONS(2971), 1,
      anon_sym_SQUOTE,
    ACTIONS(2973), 1,
      anon_sym_DQUOTE,
    ACTIONS(2983), 1,
      sym__raw_string_literal,
    ACTIONS(2985), 1,
      sym__external_open_parenthesis,
    ACTIONS(2989), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7797), 1,
      anon_sym_BANG,
    ACTIONS(8379), 1,
      sym_dot_dot_i,
    STATE(173), 1,
      sym__open_brace,
    STATE(246), 1,
      sym__open_parenthesis,
    STATE(2462), 1,
      sym__single_quoted_string,
    STATE(2494), 1,
      sym__double_quoted_string,
    STATE(2541), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5128), 1,
      sym__string_or_identifier,
    ACTIONS(2963), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2540), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2977), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8377), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1808), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [15093] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      sym_identifier,
    ACTIONS(105), 1,
      anon_sym_BSLASH,
    ACTIONS(107), 1,
      anon_sym_function,
    ACTIONS(111), 1,
      anon_sym_if,
    ACTIONS(113), 1,
      anon_sym_for,
    ACTIONS(115), 1,
      anon_sym_while,
    ACTIONS(117), 1,
      anon_sym_repeat,
    ACTIONS(119), 1,
      anon_sym_QMARK,
    ACTIONS(121), 1,
      anon_sym_TILDE,
    ACTIONS(131), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(133), 1,
      sym__number_literal,
    ACTIONS(135), 1,
      anon_sym_SQUOTE,
    ACTIONS(137), 1,
      anon_sym_DQUOTE,
    ACTIONS(147), 1,
      sym__raw_string_literal,
    ACTIONS(149), 1,
      sym__external_open_parenthesis,
    ACTIONS(153), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8381), 1,
      anon_sym_BANG,
    ACTIONS(8385), 1,
      sym_dot_dot_i,
    STATE(10), 1,
      sym__open_brace,
    STATE(20), 1,
      sym__open_parenthesis,
    STATE(2016), 1,
      sym_string,
    STATE(2027), 1,
      sym__single_quoted_string,
    STATE(2041), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5131), 1,
      sym__string_or_identifier,
    ACTIONS(125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2021), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(141), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8383), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(485), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [15222] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      sym_identifier,
    ACTIONS(105), 1,
      anon_sym_BSLASH,
    ACTIONS(107), 1,
      anon_sym_function,
    ACTIONS(111), 1,
      anon_sym_if,
    ACTIONS(113), 1,
      anon_sym_for,
    ACTIONS(115), 1,
      anon_sym_while,
    ACTIONS(117), 1,
      anon_sym_repeat,
    ACTIONS(119), 1,
      anon_sym_QMARK,
    ACTIONS(121), 1,
      anon_sym_TILDE,
    ACTIONS(131), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(133), 1,
      sym__number_literal,
    ACTIONS(135), 1,
      anon_sym_SQUOTE,
    ACTIONS(137), 1,
      anon_sym_DQUOTE,
    ACTIONS(147), 1,
      sym__raw_string_literal,
    ACTIONS(149), 1,
      sym__external_open_parenthesis,
    ACTIONS(153), 1,
      sym__external_open_brace,
    ACTIONS(8381), 1,
      anon_sym_BANG,
    ACTIONS(8389), 1,
      sym_dot_dot_i,
    ACTIONS(8391), 1,
      sym__newline,
    STATE(10), 1,
      sym__open_brace,
    STATE(20), 1,
      sym__open_parenthesis,
    STATE(2016), 1,
      sym_string,
    STATE(2027), 1,
      sym__single_quoted_string,
    STATE(2041), 1,
      sym__double_quoted_string,
    STATE(3145), 1,
      aux_sym_function_definition_repeat1,
    STATE(5131), 1,
      sym__string_or_identifier,
    ACTIONS(125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2021), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(141), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8387), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(490), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [15351] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      sym_identifier,
    ACTIONS(105), 1,
      anon_sym_BSLASH,
    ACTIONS(107), 1,
      anon_sym_function,
    ACTIONS(111), 1,
      anon_sym_if,
    ACTIONS(113), 1,
      anon_sym_for,
    ACTIONS(115), 1,
      anon_sym_while,
    ACTIONS(117), 1,
      anon_sym_repeat,
    ACTIONS(119), 1,
      anon_sym_QMARK,
    ACTIONS(121), 1,
      anon_sym_TILDE,
    ACTIONS(131), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(133), 1,
      sym__number_literal,
    ACTIONS(135), 1,
      anon_sym_SQUOTE,
    ACTIONS(137), 1,
      anon_sym_DQUOTE,
    ACTIONS(147), 1,
      sym__raw_string_literal,
    ACTIONS(149), 1,
      sym__external_open_parenthesis,
    ACTIONS(153), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8381), 1,
      anon_sym_BANG,
    ACTIONS(8395), 1,
      sym_dot_dot_i,
    STATE(10), 1,
      sym__open_brace,
    STATE(20), 1,
      sym__open_parenthesis,
    STATE(2016), 1,
      sym_string,
    STATE(2027), 1,
      sym__single_quoted_string,
    STATE(2041), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5131), 1,
      sym__string_or_identifier,
    ACTIONS(125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2021), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(141), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8393), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(482), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [15480] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      sym_identifier,
    ACTIONS(105), 1,
      anon_sym_BSLASH,
    ACTIONS(107), 1,
      anon_sym_function,
    ACTIONS(111), 1,
      anon_sym_if,
    ACTIONS(113), 1,
      anon_sym_for,
    ACTIONS(115), 1,
      anon_sym_while,
    ACTIONS(117), 1,
      anon_sym_repeat,
    ACTIONS(119), 1,
      anon_sym_QMARK,
    ACTIONS(121), 1,
      anon_sym_TILDE,
    ACTIONS(131), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(133), 1,
      sym__number_literal,
    ACTIONS(135), 1,
      anon_sym_SQUOTE,
    ACTIONS(137), 1,
      anon_sym_DQUOTE,
    ACTIONS(147), 1,
      sym__raw_string_literal,
    ACTIONS(149), 1,
      sym__external_open_parenthesis,
    ACTIONS(153), 1,
      sym__external_open_brace,
    ACTIONS(8381), 1,
      anon_sym_BANG,
    ACTIONS(8399), 1,
      sym_dot_dot_i,
    ACTIONS(8401), 1,
      sym__newline,
    STATE(10), 1,
      sym__open_brace,
    STATE(20), 1,
      sym__open_parenthesis,
    STATE(2016), 1,
      sym_string,
    STATE(2027), 1,
      sym__single_quoted_string,
    STATE(2041), 1,
      sym__double_quoted_string,
    STATE(3147), 1,
      aux_sym_function_definition_repeat1,
    STATE(5131), 1,
      sym__string_or_identifier,
    ACTIONS(125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2021), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(141), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8397), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(499), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [15609] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(405), 1,
      sym_identifier,
    ACTIONS(407), 1,
      anon_sym_BSLASH,
    ACTIONS(409), 1,
      anon_sym_function,
    ACTIONS(411), 1,
      anon_sym_if,
    ACTIONS(413), 1,
      anon_sym_for,
    ACTIONS(415), 1,
      anon_sym_while,
    ACTIONS(417), 1,
      anon_sym_repeat,
    ACTIONS(419), 1,
      anon_sym_QMARK,
    ACTIONS(421), 1,
      anon_sym_TILDE,
    ACTIONS(429), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(431), 1,
      sym__number_literal,
    ACTIONS(433), 1,
      anon_sym_SQUOTE,
    ACTIONS(435), 1,
      anon_sym_DQUOTE,
    ACTIONS(445), 1,
      sym__raw_string_literal,
    ACTIONS(447), 1,
      sym__external_open_parenthesis,
    ACTIONS(449), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8403), 1,
      anon_sym_BANG,
    ACTIONS(8407), 1,
      sym_dot_dot_i,
    STATE(5), 1,
      sym__open_parenthesis,
    STATE(42), 1,
      sym__open_brace,
    STATE(2209), 1,
      sym_string,
    STATE(2211), 1,
      sym__single_quoted_string,
    STATE(2212), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5127), 1,
      sym__string_or_identifier,
    ACTIONS(425), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2210), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(439), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8405), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(604), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [15738] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(405), 1,
      sym_identifier,
    ACTIONS(407), 1,
      anon_sym_BSLASH,
    ACTIONS(409), 1,
      anon_sym_function,
    ACTIONS(411), 1,
      anon_sym_if,
    ACTIONS(413), 1,
      anon_sym_for,
    ACTIONS(415), 1,
      anon_sym_while,
    ACTIONS(417), 1,
      anon_sym_repeat,
    ACTIONS(419), 1,
      anon_sym_QMARK,
    ACTIONS(421), 1,
      anon_sym_TILDE,
    ACTIONS(429), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(431), 1,
      sym__number_literal,
    ACTIONS(433), 1,
      anon_sym_SQUOTE,
    ACTIONS(435), 1,
      anon_sym_DQUOTE,
    ACTIONS(445), 1,
      sym__raw_string_literal,
    ACTIONS(447), 1,
      sym__external_open_parenthesis,
    ACTIONS(449), 1,
      sym__external_open_brace,
    ACTIONS(8403), 1,
      anon_sym_BANG,
    ACTIONS(8411), 1,
      sym_dot_dot_i,
    ACTIONS(8413), 1,
      sym__newline,
    STATE(5), 1,
      sym__open_parenthesis,
    STATE(42), 1,
      sym__open_brace,
    STATE(2209), 1,
      sym_string,
    STATE(2211), 1,
      sym__single_quoted_string,
    STATE(2212), 1,
      sym__double_quoted_string,
    STATE(3149), 1,
      aux_sym_function_definition_repeat1,
    STATE(5127), 1,
      sym__string_or_identifier,
    ACTIONS(425), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2210), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(439), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8409), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(671), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [15867] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(405), 1,
      sym_identifier,
    ACTIONS(407), 1,
      anon_sym_BSLASH,
    ACTIONS(409), 1,
      anon_sym_function,
    ACTIONS(411), 1,
      anon_sym_if,
    ACTIONS(413), 1,
      anon_sym_for,
    ACTIONS(415), 1,
      anon_sym_while,
    ACTIONS(417), 1,
      anon_sym_repeat,
    ACTIONS(419), 1,
      anon_sym_QMARK,
    ACTIONS(421), 1,
      anon_sym_TILDE,
    ACTIONS(429), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(431), 1,
      sym__number_literal,
    ACTIONS(433), 1,
      anon_sym_SQUOTE,
    ACTIONS(435), 1,
      anon_sym_DQUOTE,
    ACTIONS(445), 1,
      sym__raw_string_literal,
    ACTIONS(447), 1,
      sym__external_open_parenthesis,
    ACTIONS(449), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8403), 1,
      anon_sym_BANG,
    ACTIONS(8417), 1,
      sym_dot_dot_i,
    STATE(5), 1,
      sym__open_parenthesis,
    STATE(42), 1,
      sym__open_brace,
    STATE(2209), 1,
      sym_string,
    STATE(2211), 1,
      sym__single_quoted_string,
    STATE(2212), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5127), 1,
      sym__string_or_identifier,
    ACTIONS(425), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2210), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(439), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8415), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(670), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [15996] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(405), 1,
      sym_identifier,
    ACTIONS(407), 1,
      anon_sym_BSLASH,
    ACTIONS(409), 1,
      anon_sym_function,
    ACTIONS(411), 1,
      anon_sym_if,
    ACTIONS(413), 1,
      anon_sym_for,
    ACTIONS(415), 1,
      anon_sym_while,
    ACTIONS(417), 1,
      anon_sym_repeat,
    ACTIONS(419), 1,
      anon_sym_QMARK,
    ACTIONS(421), 1,
      anon_sym_TILDE,
    ACTIONS(429), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(431), 1,
      sym__number_literal,
    ACTIONS(433), 1,
      anon_sym_SQUOTE,
    ACTIONS(435), 1,
      anon_sym_DQUOTE,
    ACTIONS(445), 1,
      sym__raw_string_literal,
    ACTIONS(447), 1,
      sym__external_open_parenthesis,
    ACTIONS(449), 1,
      sym__external_open_brace,
    ACTIONS(8403), 1,
      anon_sym_BANG,
    ACTIONS(8421), 1,
      sym_dot_dot_i,
    ACTIONS(8423), 1,
      sym__newline,
    STATE(5), 1,
      sym__open_parenthesis,
    STATE(42), 1,
      sym__open_brace,
    STATE(2209), 1,
      sym_string,
    STATE(2211), 1,
      sym__single_quoted_string,
    STATE(2212), 1,
      sym__double_quoted_string,
    STATE(3151), 1,
      aux_sym_function_definition_repeat1,
    STATE(5127), 1,
      sym__string_or_identifier,
    ACTIONS(425), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2210), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(439), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8419), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(669), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [16125] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2425), 1,
      sym_identifier,
    ACTIONS(2427), 1,
      anon_sym_BSLASH,
    ACTIONS(2429), 1,
      anon_sym_function,
    ACTIONS(2431), 1,
      anon_sym_if,
    ACTIONS(2433), 1,
      anon_sym_for,
    ACTIONS(2435), 1,
      anon_sym_while,
    ACTIONS(2437), 1,
      anon_sym_repeat,
    ACTIONS(2439), 1,
      anon_sym_QMARK,
    ACTIONS(2441), 1,
      anon_sym_TILDE,
    ACTIONS(2449), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2451), 1,
      sym__number_literal,
    ACTIONS(2453), 1,
      anon_sym_SQUOTE,
    ACTIONS(2455), 1,
      anon_sym_DQUOTE,
    ACTIONS(2465), 1,
      sym__raw_string_literal,
    ACTIONS(2467), 1,
      sym__external_open_parenthesis,
    ACTIONS(2471), 1,
      sym__external_open_brace,
    ACTIONS(7781), 1,
      anon_sym_BANG,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8427), 1,
      sym_dot_dot_i,
    STATE(97), 1,
      sym__open_brace,
    STATE(200), 1,
      sym__open_parenthesis,
    STATE(2369), 1,
      sym__double_quoted_string,
    STATE(2370), 1,
      sym__single_quoted_string,
    STATE(2372), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5138), 1,
      sym__string_or_identifier,
    ACTIONS(2445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2371), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8425), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1780), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [16254] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1433), 1,
      sym_identifier,
    ACTIONS(1435), 1,
      anon_sym_BSLASH,
    ACTIONS(1437), 1,
      anon_sym_function,
    ACTIONS(1439), 1,
      anon_sym_if,
    ACTIONS(1441), 1,
      anon_sym_for,
    ACTIONS(1443), 1,
      anon_sym_while,
    ACTIONS(1445), 1,
      anon_sym_repeat,
    ACTIONS(1447), 1,
      anon_sym_QMARK,
    ACTIONS(1449), 1,
      anon_sym_TILDE,
    ACTIONS(1457), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1459), 1,
      sym__number_literal,
    ACTIONS(1461), 1,
      anon_sym_SQUOTE,
    ACTIONS(1463), 1,
      anon_sym_DQUOTE,
    ACTIONS(1473), 1,
      sym__raw_string_literal,
    ACTIONS(1475), 1,
      sym__external_open_parenthesis,
    ACTIONS(1477), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8097), 1,
      anon_sym_BANG,
    ACTIONS(8431), 1,
      sym_dot_dot_i,
    STATE(76), 1,
      sym__open_parenthesis,
    STATE(188), 1,
      sym__open_brace,
    STATE(2234), 1,
      sym_string,
    STATE(2236), 1,
      sym__single_quoted_string,
    STATE(2237), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5150), 1,
      sym__string_or_identifier,
    ACTIONS(1453), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2235), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1467), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8429), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1130), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [16383] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2425), 1,
      sym_identifier,
    ACTIONS(2427), 1,
      anon_sym_BSLASH,
    ACTIONS(2429), 1,
      anon_sym_function,
    ACTIONS(2431), 1,
      anon_sym_if,
    ACTIONS(2433), 1,
      anon_sym_for,
    ACTIONS(2435), 1,
      anon_sym_while,
    ACTIONS(2437), 1,
      anon_sym_repeat,
    ACTIONS(2439), 1,
      anon_sym_QMARK,
    ACTIONS(2441), 1,
      anon_sym_TILDE,
    ACTIONS(2449), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2451), 1,
      sym__number_literal,
    ACTIONS(2453), 1,
      anon_sym_SQUOTE,
    ACTIONS(2455), 1,
      anon_sym_DQUOTE,
    ACTIONS(2465), 1,
      sym__raw_string_literal,
    ACTIONS(2467), 1,
      sym__external_open_parenthesis,
    ACTIONS(2471), 1,
      sym__external_open_brace,
    ACTIONS(7781), 1,
      anon_sym_BANG,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8435), 1,
      sym_dot_dot_i,
    STATE(97), 1,
      sym__open_brace,
    STATE(200), 1,
      sym__open_parenthesis,
    STATE(2369), 1,
      sym__double_quoted_string,
    STATE(2370), 1,
      sym__single_quoted_string,
    STATE(2372), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5138), 1,
      sym__string_or_identifier,
    ACTIONS(2445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2371), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8433), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1781), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [16512] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1433), 1,
      sym_identifier,
    ACTIONS(1435), 1,
      anon_sym_BSLASH,
    ACTIONS(1437), 1,
      anon_sym_function,
    ACTIONS(1439), 1,
      anon_sym_if,
    ACTIONS(1441), 1,
      anon_sym_for,
    ACTIONS(1443), 1,
      anon_sym_while,
    ACTIONS(1445), 1,
      anon_sym_repeat,
    ACTIONS(1447), 1,
      anon_sym_QMARK,
    ACTIONS(1449), 1,
      anon_sym_TILDE,
    ACTIONS(1457), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1459), 1,
      sym__number_literal,
    ACTIONS(1461), 1,
      anon_sym_SQUOTE,
    ACTIONS(1463), 1,
      anon_sym_DQUOTE,
    ACTIONS(1473), 1,
      sym__raw_string_literal,
    ACTIONS(1475), 1,
      sym__external_open_parenthesis,
    ACTIONS(1477), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8097), 1,
      anon_sym_BANG,
    ACTIONS(8439), 1,
      sym_dot_dot_i,
    STATE(76), 1,
      sym__open_parenthesis,
    STATE(188), 1,
      sym__open_brace,
    STATE(2234), 1,
      sym_string,
    STATE(2236), 1,
      sym__single_quoted_string,
    STATE(2237), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5150), 1,
      sym__string_or_identifier,
    ACTIONS(1453), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2235), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1467), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8437), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1129), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [16641] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2943), 1,
      sym_identifier,
    ACTIONS(2945), 1,
      anon_sym_BSLASH,
    ACTIONS(2947), 1,
      anon_sym_function,
    ACTIONS(2949), 1,
      anon_sym_if,
    ACTIONS(2951), 1,
      anon_sym_for,
    ACTIONS(2953), 1,
      anon_sym_while,
    ACTIONS(2955), 1,
      anon_sym_repeat,
    ACTIONS(2957), 1,
      anon_sym_QMARK,
    ACTIONS(2959), 1,
      anon_sym_TILDE,
    ACTIONS(2967), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2969), 1,
      sym__number_literal,
    ACTIONS(2971), 1,
      anon_sym_SQUOTE,
    ACTIONS(2973), 1,
      anon_sym_DQUOTE,
    ACTIONS(2983), 1,
      sym__raw_string_literal,
    ACTIONS(2985), 1,
      sym__external_open_parenthesis,
    ACTIONS(2989), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7797), 1,
      anon_sym_BANG,
    ACTIONS(8443), 1,
      sym_dot_dot_i,
    STATE(173), 1,
      sym__open_brace,
    STATE(246), 1,
      sym__open_parenthesis,
    STATE(2462), 1,
      sym__single_quoted_string,
    STATE(2494), 1,
      sym__double_quoted_string,
    STATE(2541), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5128), 1,
      sym__string_or_identifier,
    ACTIONS(2963), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2540), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2977), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8441), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1820), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [16770] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1433), 1,
      sym_identifier,
    ACTIONS(1435), 1,
      anon_sym_BSLASH,
    ACTIONS(1437), 1,
      anon_sym_function,
    ACTIONS(1439), 1,
      anon_sym_if,
    ACTIONS(1441), 1,
      anon_sym_for,
    ACTIONS(1443), 1,
      anon_sym_while,
    ACTIONS(1445), 1,
      anon_sym_repeat,
    ACTIONS(1447), 1,
      anon_sym_QMARK,
    ACTIONS(1449), 1,
      anon_sym_TILDE,
    ACTIONS(1457), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1459), 1,
      sym__number_literal,
    ACTIONS(1461), 1,
      anon_sym_SQUOTE,
    ACTIONS(1463), 1,
      anon_sym_DQUOTE,
    ACTIONS(1473), 1,
      sym__raw_string_literal,
    ACTIONS(1475), 1,
      sym__external_open_parenthesis,
    ACTIONS(1477), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8097), 1,
      anon_sym_BANG,
    ACTIONS(8447), 1,
      sym_dot_dot_i,
    STATE(76), 1,
      sym__open_parenthesis,
    STATE(188), 1,
      sym__open_brace,
    STATE(2234), 1,
      sym_string,
    STATE(2236), 1,
      sym__single_quoted_string,
    STATE(2237), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5150), 1,
      sym__string_or_identifier,
    ACTIONS(1453), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2235), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1467), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8445), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1128), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [16899] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1433), 1,
      sym_identifier,
    ACTIONS(1435), 1,
      anon_sym_BSLASH,
    ACTIONS(1437), 1,
      anon_sym_function,
    ACTIONS(1439), 1,
      anon_sym_if,
    ACTIONS(1441), 1,
      anon_sym_for,
    ACTIONS(1443), 1,
      anon_sym_while,
    ACTIONS(1445), 1,
      anon_sym_repeat,
    ACTIONS(1447), 1,
      anon_sym_QMARK,
    ACTIONS(1449), 1,
      anon_sym_TILDE,
    ACTIONS(1457), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1459), 1,
      sym__number_literal,
    ACTIONS(1461), 1,
      anon_sym_SQUOTE,
    ACTIONS(1463), 1,
      anon_sym_DQUOTE,
    ACTIONS(1473), 1,
      sym__raw_string_literal,
    ACTIONS(1475), 1,
      sym__external_open_parenthesis,
    ACTIONS(1477), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8097), 1,
      anon_sym_BANG,
    ACTIONS(8451), 1,
      sym_dot_dot_i,
    STATE(76), 1,
      sym__open_parenthesis,
    STATE(188), 1,
      sym__open_brace,
    STATE(2234), 1,
      sym_string,
    STATE(2236), 1,
      sym__single_quoted_string,
    STATE(2237), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5150), 1,
      sym__string_or_identifier,
    ACTIONS(1453), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2235), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1467), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8449), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1127), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [17028] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2425), 1,
      sym_identifier,
    ACTIONS(2427), 1,
      anon_sym_BSLASH,
    ACTIONS(2429), 1,
      anon_sym_function,
    ACTIONS(2431), 1,
      anon_sym_if,
    ACTIONS(2433), 1,
      anon_sym_for,
    ACTIONS(2435), 1,
      anon_sym_while,
    ACTIONS(2437), 1,
      anon_sym_repeat,
    ACTIONS(2439), 1,
      anon_sym_QMARK,
    ACTIONS(2441), 1,
      anon_sym_TILDE,
    ACTIONS(2449), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2451), 1,
      sym__number_literal,
    ACTIONS(2453), 1,
      anon_sym_SQUOTE,
    ACTIONS(2455), 1,
      anon_sym_DQUOTE,
    ACTIONS(2465), 1,
      sym__raw_string_literal,
    ACTIONS(2467), 1,
      sym__external_open_parenthesis,
    ACTIONS(2471), 1,
      sym__external_open_brace,
    ACTIONS(7781), 1,
      anon_sym_BANG,
    ACTIONS(8455), 1,
      sym_dot_dot_i,
    ACTIONS(8457), 1,
      sym__newline,
    STATE(97), 1,
      sym__open_brace,
    STATE(200), 1,
      sym__open_parenthesis,
    STATE(2369), 1,
      sym__double_quoted_string,
    STATE(2370), 1,
      sym__single_quoted_string,
    STATE(2372), 1,
      sym_string,
    STATE(3142), 1,
      aux_sym_function_definition_repeat1,
    STATE(5138), 1,
      sym__string_or_identifier,
    ACTIONS(2445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2371), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8453), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1787), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [17157] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2425), 1,
      sym_identifier,
    ACTIONS(2427), 1,
      anon_sym_BSLASH,
    ACTIONS(2429), 1,
      anon_sym_function,
    ACTIONS(2431), 1,
      anon_sym_if,
    ACTIONS(2433), 1,
      anon_sym_for,
    ACTIONS(2435), 1,
      anon_sym_while,
    ACTIONS(2437), 1,
      anon_sym_repeat,
    ACTIONS(2439), 1,
      anon_sym_QMARK,
    ACTIONS(2441), 1,
      anon_sym_TILDE,
    ACTIONS(2449), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2451), 1,
      sym__number_literal,
    ACTIONS(2453), 1,
      anon_sym_SQUOTE,
    ACTIONS(2455), 1,
      anon_sym_DQUOTE,
    ACTIONS(2465), 1,
      sym__raw_string_literal,
    ACTIONS(2467), 1,
      sym__external_open_parenthesis,
    ACTIONS(2471), 1,
      sym__external_open_brace,
    ACTIONS(7781), 1,
      anon_sym_BANG,
    ACTIONS(8461), 1,
      sym_dot_dot_i,
    ACTIONS(8463), 1,
      sym__newline,
    STATE(97), 1,
      sym__open_brace,
    STATE(200), 1,
      sym__open_parenthesis,
    STATE(2369), 1,
      sym__double_quoted_string,
    STATE(2370), 1,
      sym__single_quoted_string,
    STATE(2372), 1,
      sym_string,
    STATE(3143), 1,
      aux_sym_function_definition_repeat1,
    STATE(5138), 1,
      sym__string_or_identifier,
    ACTIONS(2445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2371), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8459), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1788), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [17286] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2425), 1,
      sym_identifier,
    ACTIONS(2427), 1,
      anon_sym_BSLASH,
    ACTIONS(2429), 1,
      anon_sym_function,
    ACTIONS(2431), 1,
      anon_sym_if,
    ACTIONS(2433), 1,
      anon_sym_for,
    ACTIONS(2435), 1,
      anon_sym_while,
    ACTIONS(2437), 1,
      anon_sym_repeat,
    ACTIONS(2439), 1,
      anon_sym_QMARK,
    ACTIONS(2441), 1,
      anon_sym_TILDE,
    ACTIONS(2449), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2451), 1,
      sym__number_literal,
    ACTIONS(2453), 1,
      anon_sym_SQUOTE,
    ACTIONS(2455), 1,
      anon_sym_DQUOTE,
    ACTIONS(2465), 1,
      sym__raw_string_literal,
    ACTIONS(2467), 1,
      sym__external_open_parenthesis,
    ACTIONS(2471), 1,
      sym__external_open_brace,
    ACTIONS(7781), 1,
      anon_sym_BANG,
    ACTIONS(8467), 1,
      sym_dot_dot_i,
    ACTIONS(8469), 1,
      sym__newline,
    STATE(97), 1,
      sym__open_brace,
    STATE(200), 1,
      sym__open_parenthesis,
    STATE(2369), 1,
      sym__double_quoted_string,
    STATE(2370), 1,
      sym__single_quoted_string,
    STATE(2372), 1,
      sym_string,
    STATE(3153), 1,
      aux_sym_function_definition_repeat1,
    STATE(5138), 1,
      sym__string_or_identifier,
    ACTIONS(2445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2371), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8465), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1791), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [17415] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2425), 1,
      sym_identifier,
    ACTIONS(2427), 1,
      anon_sym_BSLASH,
    ACTIONS(2429), 1,
      anon_sym_function,
    ACTIONS(2431), 1,
      anon_sym_if,
    ACTIONS(2433), 1,
      anon_sym_for,
    ACTIONS(2435), 1,
      anon_sym_while,
    ACTIONS(2437), 1,
      anon_sym_repeat,
    ACTIONS(2439), 1,
      anon_sym_QMARK,
    ACTIONS(2441), 1,
      anon_sym_TILDE,
    ACTIONS(2449), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2451), 1,
      sym__number_literal,
    ACTIONS(2453), 1,
      anon_sym_SQUOTE,
    ACTIONS(2455), 1,
      anon_sym_DQUOTE,
    ACTIONS(2465), 1,
      sym__raw_string_literal,
    ACTIONS(2467), 1,
      sym__external_open_parenthesis,
    ACTIONS(2471), 1,
      sym__external_open_brace,
    ACTIONS(7781), 1,
      anon_sym_BANG,
    ACTIONS(8473), 1,
      sym_dot_dot_i,
    ACTIONS(8475), 1,
      sym__newline,
    STATE(97), 1,
      sym__open_brace,
    STATE(200), 1,
      sym__open_parenthesis,
    STATE(2369), 1,
      sym__double_quoted_string,
    STATE(2370), 1,
      sym__single_quoted_string,
    STATE(2372), 1,
      sym_string,
    STATE(3155), 1,
      aux_sym_function_definition_repeat1,
    STATE(5138), 1,
      sym__string_or_identifier,
    ACTIONS(2445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2371), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8471), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1793), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [17544] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1568), 1,
      sym_identifier,
    ACTIONS(1570), 1,
      anon_sym_BSLASH,
    ACTIONS(1572), 1,
      anon_sym_function,
    ACTIONS(1574), 1,
      anon_sym_if,
    ACTIONS(1576), 1,
      anon_sym_for,
    ACTIONS(1578), 1,
      anon_sym_while,
    ACTIONS(1580), 1,
      anon_sym_repeat,
    ACTIONS(1582), 1,
      anon_sym_QMARK,
    ACTIONS(1584), 1,
      anon_sym_TILDE,
    ACTIONS(1592), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1594), 1,
      sym__number_literal,
    ACTIONS(1596), 1,
      anon_sym_SQUOTE,
    ACTIONS(1598), 1,
      anon_sym_DQUOTE,
    ACTIONS(1608), 1,
      sym__raw_string_literal,
    ACTIONS(1610), 1,
      sym__external_open_parenthesis,
    ACTIONS(1614), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8477), 1,
      anon_sym_BANG,
    ACTIONS(8481), 1,
      sym_dot_dot_i,
    STATE(16), 1,
      sym__open_brace,
    STATE(119), 1,
      sym__open_parenthesis,
    STATE(2287), 1,
      sym_string,
    STATE(2289), 1,
      sym__single_quoted_string,
    STATE(2290), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5144), 1,
      sym__string_or_identifier,
    ACTIONS(1588), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2288), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1602), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8479), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(803), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [17673] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2943), 1,
      sym_identifier,
    ACTIONS(2945), 1,
      anon_sym_BSLASH,
    ACTIONS(2947), 1,
      anon_sym_function,
    ACTIONS(2949), 1,
      anon_sym_if,
    ACTIONS(2951), 1,
      anon_sym_for,
    ACTIONS(2953), 1,
      anon_sym_while,
    ACTIONS(2955), 1,
      anon_sym_repeat,
    ACTIONS(2957), 1,
      anon_sym_QMARK,
    ACTIONS(2959), 1,
      anon_sym_TILDE,
    ACTIONS(2967), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2969), 1,
      sym__number_literal,
    ACTIONS(2971), 1,
      anon_sym_SQUOTE,
    ACTIONS(2973), 1,
      anon_sym_DQUOTE,
    ACTIONS(2983), 1,
      sym__raw_string_literal,
    ACTIONS(2985), 1,
      sym__external_open_parenthesis,
    ACTIONS(2989), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7797), 1,
      anon_sym_BANG,
    ACTIONS(8485), 1,
      sym_dot_dot_i,
    STATE(173), 1,
      sym__open_brace,
    STATE(246), 1,
      sym__open_parenthesis,
    STATE(2462), 1,
      sym__single_quoted_string,
    STATE(2494), 1,
      sym__double_quoted_string,
    STATE(2541), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5128), 1,
      sym__string_or_identifier,
    ACTIONS(2963), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2540), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2977), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8483), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1811), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [17802] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1568), 1,
      sym_identifier,
    ACTIONS(1570), 1,
      anon_sym_BSLASH,
    ACTIONS(1572), 1,
      anon_sym_function,
    ACTIONS(1574), 1,
      anon_sym_if,
    ACTIONS(1576), 1,
      anon_sym_for,
    ACTIONS(1578), 1,
      anon_sym_while,
    ACTIONS(1580), 1,
      anon_sym_repeat,
    ACTIONS(1582), 1,
      anon_sym_QMARK,
    ACTIONS(1584), 1,
      anon_sym_TILDE,
    ACTIONS(1592), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1594), 1,
      sym__number_literal,
    ACTIONS(1596), 1,
      anon_sym_SQUOTE,
    ACTIONS(1598), 1,
      anon_sym_DQUOTE,
    ACTIONS(1608), 1,
      sym__raw_string_literal,
    ACTIONS(1610), 1,
      sym__external_open_parenthesis,
    ACTIONS(1614), 1,
      sym__external_open_brace,
    ACTIONS(8477), 1,
      anon_sym_BANG,
    ACTIONS(8489), 1,
      sym_dot_dot_i,
    ACTIONS(8491), 1,
      sym__newline,
    STATE(16), 1,
      sym__open_brace,
    STATE(119), 1,
      sym__open_parenthesis,
    STATE(2287), 1,
      sym_string,
    STATE(2289), 1,
      sym__single_quoted_string,
    STATE(2290), 1,
      sym__double_quoted_string,
    STATE(3164), 1,
      aux_sym_function_definition_repeat1,
    STATE(5144), 1,
      sym__string_or_identifier,
    ACTIONS(1588), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2288), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1602), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8487), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(805), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [17931] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2943), 1,
      sym_identifier,
    ACTIONS(2945), 1,
      anon_sym_BSLASH,
    ACTIONS(2947), 1,
      anon_sym_function,
    ACTIONS(2949), 1,
      anon_sym_if,
    ACTIONS(2951), 1,
      anon_sym_for,
    ACTIONS(2953), 1,
      anon_sym_while,
    ACTIONS(2955), 1,
      anon_sym_repeat,
    ACTIONS(2957), 1,
      anon_sym_QMARK,
    ACTIONS(2959), 1,
      anon_sym_TILDE,
    ACTIONS(2967), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2969), 1,
      sym__number_literal,
    ACTIONS(2971), 1,
      anon_sym_SQUOTE,
    ACTIONS(2973), 1,
      anon_sym_DQUOTE,
    ACTIONS(2983), 1,
      sym__raw_string_literal,
    ACTIONS(2985), 1,
      sym__external_open_parenthesis,
    ACTIONS(2989), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7797), 1,
      anon_sym_BANG,
    ACTIONS(8495), 1,
      sym_dot_dot_i,
    STATE(173), 1,
      sym__open_brace,
    STATE(246), 1,
      sym__open_parenthesis,
    STATE(2462), 1,
      sym__single_quoted_string,
    STATE(2494), 1,
      sym__double_quoted_string,
    STATE(2541), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5128), 1,
      sym__string_or_identifier,
    ACTIONS(2963), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2540), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2977), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8493), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1824), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [18060] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2943), 1,
      sym_identifier,
    ACTIONS(2945), 1,
      anon_sym_BSLASH,
    ACTIONS(2947), 1,
      anon_sym_function,
    ACTIONS(2949), 1,
      anon_sym_if,
    ACTIONS(2951), 1,
      anon_sym_for,
    ACTIONS(2953), 1,
      anon_sym_while,
    ACTIONS(2955), 1,
      anon_sym_repeat,
    ACTIONS(2957), 1,
      anon_sym_QMARK,
    ACTIONS(2959), 1,
      anon_sym_TILDE,
    ACTIONS(2967), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2969), 1,
      sym__number_literal,
    ACTIONS(2971), 1,
      anon_sym_SQUOTE,
    ACTIONS(2973), 1,
      anon_sym_DQUOTE,
    ACTIONS(2983), 1,
      sym__raw_string_literal,
    ACTIONS(2985), 1,
      sym__external_open_parenthesis,
    ACTIONS(2989), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7797), 1,
      anon_sym_BANG,
    ACTIONS(8499), 1,
      sym_dot_dot_i,
    STATE(173), 1,
      sym__open_brace,
    STATE(246), 1,
      sym__open_parenthesis,
    STATE(2462), 1,
      sym__single_quoted_string,
    STATE(2494), 1,
      sym__double_quoted_string,
    STATE(2541), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5128), 1,
      sym__string_or_identifier,
    ACTIONS(2963), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2540), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2977), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8497), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1825), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [18189] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1568), 1,
      sym_identifier,
    ACTIONS(1570), 1,
      anon_sym_BSLASH,
    ACTIONS(1572), 1,
      anon_sym_function,
    ACTIONS(1574), 1,
      anon_sym_if,
    ACTIONS(1576), 1,
      anon_sym_for,
    ACTIONS(1578), 1,
      anon_sym_while,
    ACTIONS(1580), 1,
      anon_sym_repeat,
    ACTIONS(1582), 1,
      anon_sym_QMARK,
    ACTIONS(1584), 1,
      anon_sym_TILDE,
    ACTIONS(1592), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1594), 1,
      sym__number_literal,
    ACTIONS(1596), 1,
      anon_sym_SQUOTE,
    ACTIONS(1598), 1,
      anon_sym_DQUOTE,
    ACTIONS(1608), 1,
      sym__raw_string_literal,
    ACTIONS(1610), 1,
      sym__external_open_parenthesis,
    ACTIONS(1614), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8477), 1,
      anon_sym_BANG,
    ACTIONS(8503), 1,
      sym_dot_dot_i,
    STATE(16), 1,
      sym__open_brace,
    STATE(119), 1,
      sym__open_parenthesis,
    STATE(2287), 1,
      sym_string,
    STATE(2289), 1,
      sym__single_quoted_string,
    STATE(2290), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5144), 1,
      sym__string_or_identifier,
    ACTIONS(1588), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2288), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1602), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8501), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(807), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [18318] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1568), 1,
      sym_identifier,
    ACTIONS(1570), 1,
      anon_sym_BSLASH,
    ACTIONS(1572), 1,
      anon_sym_function,
    ACTIONS(1574), 1,
      anon_sym_if,
    ACTIONS(1576), 1,
      anon_sym_for,
    ACTIONS(1578), 1,
      anon_sym_while,
    ACTIONS(1580), 1,
      anon_sym_repeat,
    ACTIONS(1582), 1,
      anon_sym_QMARK,
    ACTIONS(1584), 1,
      anon_sym_TILDE,
    ACTIONS(1592), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1594), 1,
      sym__number_literal,
    ACTIONS(1596), 1,
      anon_sym_SQUOTE,
    ACTIONS(1598), 1,
      anon_sym_DQUOTE,
    ACTIONS(1608), 1,
      sym__raw_string_literal,
    ACTIONS(1610), 1,
      sym__external_open_parenthesis,
    ACTIONS(1614), 1,
      sym__external_open_brace,
    ACTIONS(8477), 1,
      anon_sym_BANG,
    ACTIONS(8507), 1,
      sym_dot_dot_i,
    ACTIONS(8509), 1,
      sym__newline,
    STATE(16), 1,
      sym__open_brace,
    STATE(119), 1,
      sym__open_parenthesis,
    STATE(2287), 1,
      sym_string,
    STATE(2289), 1,
      sym__single_quoted_string,
    STATE(2290), 1,
      sym__double_quoted_string,
    STATE(3169), 1,
      aux_sym_function_definition_repeat1,
    STATE(5144), 1,
      sym__string_or_identifier,
    ACTIONS(1588), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2288), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1602), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8505), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(809), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [18447] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2943), 1,
      sym_identifier,
    ACTIONS(2945), 1,
      anon_sym_BSLASH,
    ACTIONS(2947), 1,
      anon_sym_function,
    ACTIONS(2949), 1,
      anon_sym_if,
    ACTIONS(2951), 1,
      anon_sym_for,
    ACTIONS(2953), 1,
      anon_sym_while,
    ACTIONS(2955), 1,
      anon_sym_repeat,
    ACTIONS(2957), 1,
      anon_sym_QMARK,
    ACTIONS(2959), 1,
      anon_sym_TILDE,
    ACTIONS(2967), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2969), 1,
      sym__number_literal,
    ACTIONS(2971), 1,
      anon_sym_SQUOTE,
    ACTIONS(2973), 1,
      anon_sym_DQUOTE,
    ACTIONS(2983), 1,
      sym__raw_string_literal,
    ACTIONS(2985), 1,
      sym__external_open_parenthesis,
    ACTIONS(2989), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7797), 1,
      anon_sym_BANG,
    ACTIONS(8513), 1,
      sym_dot_dot_i,
    STATE(173), 1,
      sym__open_brace,
    STATE(246), 1,
      sym__open_parenthesis,
    STATE(2462), 1,
      sym__single_quoted_string,
    STATE(2494), 1,
      sym__double_quoted_string,
    STATE(2541), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5128), 1,
      sym__string_or_identifier,
    ACTIONS(2963), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2540), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2977), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8511), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1826), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [18576] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      sym_identifier,
    ACTIONS(483), 1,
      anon_sym_BSLASH,
    ACTIONS(485), 1,
      anon_sym_function,
    ACTIONS(487), 1,
      anon_sym_if,
    ACTIONS(489), 1,
      anon_sym_for,
    ACTIONS(491), 1,
      anon_sym_while,
    ACTIONS(493), 1,
      anon_sym_repeat,
    ACTIONS(495), 1,
      anon_sym_QMARK,
    ACTIONS(497), 1,
      anon_sym_TILDE,
    ACTIONS(505), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(507), 1,
      sym__number_literal,
    ACTIONS(509), 1,
      anon_sym_SQUOTE,
    ACTIONS(511), 1,
      anon_sym_DQUOTE,
    ACTIONS(521), 1,
      sym__raw_string_literal,
    ACTIONS(523), 1,
      sym__external_open_parenthesis,
    ACTIONS(525), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8515), 1,
      anon_sym_BANG,
    ACTIONS(8519), 1,
      sym_dot_dot_i,
    STATE(3), 1,
      sym__open_parenthesis,
    STATE(45), 1,
      sym__open_brace,
    STATE(2166), 1,
      sym_string,
    STATE(2200), 1,
      sym__single_quoted_string,
    STATE(2201), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5154), 1,
      sym__string_or_identifier,
    ACTIONS(501), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2206), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(515), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8517), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(668), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [18705] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      sym_identifier,
    ACTIONS(483), 1,
      anon_sym_BSLASH,
    ACTIONS(485), 1,
      anon_sym_function,
    ACTIONS(487), 1,
      anon_sym_if,
    ACTIONS(489), 1,
      anon_sym_for,
    ACTIONS(491), 1,
      anon_sym_while,
    ACTIONS(493), 1,
      anon_sym_repeat,
    ACTIONS(495), 1,
      anon_sym_QMARK,
    ACTIONS(497), 1,
      anon_sym_TILDE,
    ACTIONS(505), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(507), 1,
      sym__number_literal,
    ACTIONS(509), 1,
      anon_sym_SQUOTE,
    ACTIONS(511), 1,
      anon_sym_DQUOTE,
    ACTIONS(521), 1,
      sym__raw_string_literal,
    ACTIONS(523), 1,
      sym__external_open_parenthesis,
    ACTIONS(525), 1,
      sym__external_open_brace,
    ACTIONS(8515), 1,
      anon_sym_BANG,
    ACTIONS(8523), 1,
      sym_dot_dot_i,
    ACTIONS(8525), 1,
      sym__newline,
    STATE(3), 1,
      sym__open_parenthesis,
    STATE(45), 1,
      sym__open_brace,
    STATE(2166), 1,
      sym_string,
    STATE(2200), 1,
      sym__single_quoted_string,
    STATE(2201), 1,
      sym__double_quoted_string,
    STATE(3172), 1,
      aux_sym_function_definition_repeat1,
    STATE(5154), 1,
      sym__string_or_identifier,
    ACTIONS(501), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2206), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(515), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8521), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(667), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [18834] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      sym_identifier,
    ACTIONS(483), 1,
      anon_sym_BSLASH,
    ACTIONS(485), 1,
      anon_sym_function,
    ACTIONS(487), 1,
      anon_sym_if,
    ACTIONS(489), 1,
      anon_sym_for,
    ACTIONS(491), 1,
      anon_sym_while,
    ACTIONS(493), 1,
      anon_sym_repeat,
    ACTIONS(495), 1,
      anon_sym_QMARK,
    ACTIONS(497), 1,
      anon_sym_TILDE,
    ACTIONS(505), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(507), 1,
      sym__number_literal,
    ACTIONS(509), 1,
      anon_sym_SQUOTE,
    ACTIONS(511), 1,
      anon_sym_DQUOTE,
    ACTIONS(521), 1,
      sym__raw_string_literal,
    ACTIONS(523), 1,
      sym__external_open_parenthesis,
    ACTIONS(525), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8515), 1,
      anon_sym_BANG,
    ACTIONS(8529), 1,
      sym_dot_dot_i,
    STATE(3), 1,
      sym__open_parenthesis,
    STATE(45), 1,
      sym__open_brace,
    STATE(2166), 1,
      sym_string,
    STATE(2200), 1,
      sym__single_quoted_string,
    STATE(2201), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5154), 1,
      sym__string_or_identifier,
    ACTIONS(501), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2206), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(515), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8527), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(666), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [18963] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1289), 1,
      sym_identifier,
    ACTIONS(1291), 1,
      anon_sym_BSLASH,
    ACTIONS(1293), 1,
      anon_sym_function,
    ACTIONS(1295), 1,
      anon_sym_if,
    ACTIONS(1297), 1,
      anon_sym_for,
    ACTIONS(1299), 1,
      anon_sym_while,
    ACTIONS(1301), 1,
      anon_sym_repeat,
    ACTIONS(1303), 1,
      anon_sym_QMARK,
    ACTIONS(1305), 1,
      anon_sym_TILDE,
    ACTIONS(1313), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1315), 1,
      sym__number_literal,
    ACTIONS(1317), 1,
      anon_sym_SQUOTE,
    ACTIONS(1319), 1,
      anon_sym_DQUOTE,
    ACTIONS(1329), 1,
      sym__raw_string_literal,
    ACTIONS(1331), 1,
      sym__external_open_parenthesis,
    ACTIONS(1333), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8531), 1,
      anon_sym_BANG,
    ACTIONS(8535), 1,
      sym_dot_dot_i,
    STATE(23), 1,
      sym__open_parenthesis,
    STATE(180), 1,
      sym__open_brace,
    STATE(2264), 1,
      sym__double_quoted_string,
    STATE(2265), 1,
      sym__single_quoted_string,
    STATE(2284), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5147), 1,
      sym__string_or_identifier,
    ACTIONS(1309), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2266), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1323), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8533), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1195), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [19092] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      sym_identifier,
    ACTIONS(483), 1,
      anon_sym_BSLASH,
    ACTIONS(485), 1,
      anon_sym_function,
    ACTIONS(487), 1,
      anon_sym_if,
    ACTIONS(489), 1,
      anon_sym_for,
    ACTIONS(491), 1,
      anon_sym_while,
    ACTIONS(493), 1,
      anon_sym_repeat,
    ACTIONS(495), 1,
      anon_sym_QMARK,
    ACTIONS(497), 1,
      anon_sym_TILDE,
    ACTIONS(505), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(507), 1,
      sym__number_literal,
    ACTIONS(509), 1,
      anon_sym_SQUOTE,
    ACTIONS(511), 1,
      anon_sym_DQUOTE,
    ACTIONS(521), 1,
      sym__raw_string_literal,
    ACTIONS(523), 1,
      sym__external_open_parenthesis,
    ACTIONS(525), 1,
      sym__external_open_brace,
    ACTIONS(8515), 1,
      anon_sym_BANG,
    ACTIONS(8539), 1,
      sym_dot_dot_i,
    ACTIONS(8541), 1,
      sym__newline,
    STATE(3), 1,
      sym__open_parenthesis,
    STATE(45), 1,
      sym__open_brace,
    STATE(2166), 1,
      sym_string,
    STATE(2200), 1,
      sym__single_quoted_string,
    STATE(2201), 1,
      sym__double_quoted_string,
    STATE(3174), 1,
      aux_sym_function_definition_repeat1,
    STATE(5154), 1,
      sym__string_or_identifier,
    ACTIONS(501), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2206), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(515), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8537), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(665), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [19221] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1241), 1,
      sym_identifier,
    ACTIONS(1243), 1,
      anon_sym_BSLASH,
    ACTIONS(1245), 1,
      anon_sym_function,
    ACTIONS(1247), 1,
      anon_sym_if,
    ACTIONS(1249), 1,
      anon_sym_for,
    ACTIONS(1251), 1,
      anon_sym_while,
    ACTIONS(1253), 1,
      anon_sym_repeat,
    ACTIONS(1255), 1,
      anon_sym_QMARK,
    ACTIONS(1257), 1,
      anon_sym_TILDE,
    ACTIONS(1265), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1267), 1,
      sym__number_literal,
    ACTIONS(1269), 1,
      anon_sym_SQUOTE,
    ACTIONS(1271), 1,
      anon_sym_DQUOTE,
    ACTIONS(1281), 1,
      sym__raw_string_literal,
    ACTIONS(1283), 1,
      sym__external_open_parenthesis,
    ACTIONS(1287), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8543), 1,
      anon_sym_BANG,
    ACTIONS(8547), 1,
      sym_dot_dot_i,
    STATE(11), 1,
      sym__open_brace,
    STATE(120), 1,
      sym__open_parenthesis,
    STATE(2271), 1,
      sym_string,
    STATE(2273), 1,
      sym__single_quoted_string,
    STATE(2274), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5157), 1,
      sym__string_or_identifier,
    ACTIONS(1261), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2272), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1275), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8545), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(818), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [19350] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1241), 1,
      sym_identifier,
    ACTIONS(1243), 1,
      anon_sym_BSLASH,
    ACTIONS(1245), 1,
      anon_sym_function,
    ACTIONS(1247), 1,
      anon_sym_if,
    ACTIONS(1249), 1,
      anon_sym_for,
    ACTIONS(1251), 1,
      anon_sym_while,
    ACTIONS(1253), 1,
      anon_sym_repeat,
    ACTIONS(1255), 1,
      anon_sym_QMARK,
    ACTIONS(1257), 1,
      anon_sym_TILDE,
    ACTIONS(1265), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1267), 1,
      sym__number_literal,
    ACTIONS(1269), 1,
      anon_sym_SQUOTE,
    ACTIONS(1271), 1,
      anon_sym_DQUOTE,
    ACTIONS(1281), 1,
      sym__raw_string_literal,
    ACTIONS(1283), 1,
      sym__external_open_parenthesis,
    ACTIONS(1287), 1,
      sym__external_open_brace,
    ACTIONS(8543), 1,
      anon_sym_BANG,
    ACTIONS(8551), 1,
      sym_dot_dot_i,
    ACTIONS(8553), 1,
      sym__newline,
    STATE(11), 1,
      sym__open_brace,
    STATE(120), 1,
      sym__open_parenthesis,
    STATE(2271), 1,
      sym_string,
    STATE(2273), 1,
      sym__single_quoted_string,
    STATE(2274), 1,
      sym__double_quoted_string,
    STATE(3177), 1,
      aux_sym_function_definition_repeat1,
    STATE(5157), 1,
      sym__string_or_identifier,
    ACTIONS(1261), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2272), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1275), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8549), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(819), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [19479] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1289), 1,
      sym_identifier,
    ACTIONS(1291), 1,
      anon_sym_BSLASH,
    ACTIONS(1293), 1,
      anon_sym_function,
    ACTIONS(1295), 1,
      anon_sym_if,
    ACTIONS(1297), 1,
      anon_sym_for,
    ACTIONS(1299), 1,
      anon_sym_while,
    ACTIONS(1301), 1,
      anon_sym_repeat,
    ACTIONS(1303), 1,
      anon_sym_QMARK,
    ACTIONS(1305), 1,
      anon_sym_TILDE,
    ACTIONS(1313), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1315), 1,
      sym__number_literal,
    ACTIONS(1317), 1,
      anon_sym_SQUOTE,
    ACTIONS(1319), 1,
      anon_sym_DQUOTE,
    ACTIONS(1329), 1,
      sym__raw_string_literal,
    ACTIONS(1331), 1,
      sym__external_open_parenthesis,
    ACTIONS(1333), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8531), 1,
      anon_sym_BANG,
    ACTIONS(8557), 1,
      sym_dot_dot_i,
    STATE(23), 1,
      sym__open_parenthesis,
    STATE(180), 1,
      sym__open_brace,
    STATE(2264), 1,
      sym__double_quoted_string,
    STATE(2265), 1,
      sym__single_quoted_string,
    STATE(2284), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5147), 1,
      sym__string_or_identifier,
    ACTIONS(1309), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2266), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1323), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8555), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1171), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [19608] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1241), 1,
      sym_identifier,
    ACTIONS(1243), 1,
      anon_sym_BSLASH,
    ACTIONS(1245), 1,
      anon_sym_function,
    ACTIONS(1247), 1,
      anon_sym_if,
    ACTIONS(1249), 1,
      anon_sym_for,
    ACTIONS(1251), 1,
      anon_sym_while,
    ACTIONS(1253), 1,
      anon_sym_repeat,
    ACTIONS(1255), 1,
      anon_sym_QMARK,
    ACTIONS(1257), 1,
      anon_sym_TILDE,
    ACTIONS(1265), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1267), 1,
      sym__number_literal,
    ACTIONS(1269), 1,
      anon_sym_SQUOTE,
    ACTIONS(1271), 1,
      anon_sym_DQUOTE,
    ACTIONS(1281), 1,
      sym__raw_string_literal,
    ACTIONS(1283), 1,
      sym__external_open_parenthesis,
    ACTIONS(1287), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8543), 1,
      anon_sym_BANG,
    ACTIONS(8561), 1,
      sym_dot_dot_i,
    STATE(11), 1,
      sym__open_brace,
    STATE(120), 1,
      sym__open_parenthesis,
    STATE(2271), 1,
      sym_string,
    STATE(2273), 1,
      sym__single_quoted_string,
    STATE(2274), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5157), 1,
      sym__string_or_identifier,
    ACTIONS(1261), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2272), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1275), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8559), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(820), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [19737] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1289), 1,
      sym_identifier,
    ACTIONS(1291), 1,
      anon_sym_BSLASH,
    ACTIONS(1293), 1,
      anon_sym_function,
    ACTIONS(1295), 1,
      anon_sym_if,
    ACTIONS(1297), 1,
      anon_sym_for,
    ACTIONS(1299), 1,
      anon_sym_while,
    ACTIONS(1301), 1,
      anon_sym_repeat,
    ACTIONS(1303), 1,
      anon_sym_QMARK,
    ACTIONS(1305), 1,
      anon_sym_TILDE,
    ACTIONS(1313), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1315), 1,
      sym__number_literal,
    ACTIONS(1317), 1,
      anon_sym_SQUOTE,
    ACTIONS(1319), 1,
      anon_sym_DQUOTE,
    ACTIONS(1329), 1,
      sym__raw_string_literal,
    ACTIONS(1331), 1,
      sym__external_open_parenthesis,
    ACTIONS(1333), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8531), 1,
      anon_sym_BANG,
    ACTIONS(8565), 1,
      sym_dot_dot_i,
    STATE(23), 1,
      sym__open_parenthesis,
    STATE(180), 1,
      sym__open_brace,
    STATE(2264), 1,
      sym__double_quoted_string,
    STATE(2265), 1,
      sym__single_quoted_string,
    STATE(2284), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5147), 1,
      sym__string_or_identifier,
    ACTIONS(1309), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2266), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1323), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8563), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1172), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [19866] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1289), 1,
      sym_identifier,
    ACTIONS(1291), 1,
      anon_sym_BSLASH,
    ACTIONS(1293), 1,
      anon_sym_function,
    ACTIONS(1295), 1,
      anon_sym_if,
    ACTIONS(1297), 1,
      anon_sym_for,
    ACTIONS(1299), 1,
      anon_sym_while,
    ACTIONS(1301), 1,
      anon_sym_repeat,
    ACTIONS(1303), 1,
      anon_sym_QMARK,
    ACTIONS(1305), 1,
      anon_sym_TILDE,
    ACTIONS(1313), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1315), 1,
      sym__number_literal,
    ACTIONS(1317), 1,
      anon_sym_SQUOTE,
    ACTIONS(1319), 1,
      anon_sym_DQUOTE,
    ACTIONS(1329), 1,
      sym__raw_string_literal,
    ACTIONS(1331), 1,
      sym__external_open_parenthesis,
    ACTIONS(1333), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8531), 1,
      anon_sym_BANG,
    ACTIONS(8569), 1,
      sym_dot_dot_i,
    STATE(23), 1,
      sym__open_parenthesis,
    STATE(180), 1,
      sym__open_brace,
    STATE(2264), 1,
      sym__double_quoted_string,
    STATE(2265), 1,
      sym__single_quoted_string,
    STATE(2284), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5147), 1,
      sym__string_or_identifier,
    ACTIONS(1309), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2266), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1323), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8567), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1180), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [19995] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1289), 1,
      sym_identifier,
    ACTIONS(1291), 1,
      anon_sym_BSLASH,
    ACTIONS(1293), 1,
      anon_sym_function,
    ACTIONS(1295), 1,
      anon_sym_if,
    ACTIONS(1297), 1,
      anon_sym_for,
    ACTIONS(1299), 1,
      anon_sym_while,
    ACTIONS(1301), 1,
      anon_sym_repeat,
    ACTIONS(1303), 1,
      anon_sym_QMARK,
    ACTIONS(1305), 1,
      anon_sym_TILDE,
    ACTIONS(1313), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1315), 1,
      sym__number_literal,
    ACTIONS(1317), 1,
      anon_sym_SQUOTE,
    ACTIONS(1319), 1,
      anon_sym_DQUOTE,
    ACTIONS(1329), 1,
      sym__raw_string_literal,
    ACTIONS(1331), 1,
      sym__external_open_parenthesis,
    ACTIONS(1333), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8531), 1,
      anon_sym_BANG,
    ACTIONS(8573), 1,
      sym_dot_dot_i,
    STATE(23), 1,
      sym__open_parenthesis,
    STATE(180), 1,
      sym__open_brace,
    STATE(2264), 1,
      sym__double_quoted_string,
    STATE(2265), 1,
      sym__single_quoted_string,
    STATE(2284), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5147), 1,
      sym__string_or_identifier,
    ACTIONS(1309), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2266), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1323), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8571), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1181), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [20124] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1289), 1,
      sym_identifier,
    ACTIONS(1291), 1,
      anon_sym_BSLASH,
    ACTIONS(1293), 1,
      anon_sym_function,
    ACTIONS(1295), 1,
      anon_sym_if,
    ACTIONS(1297), 1,
      anon_sym_for,
    ACTIONS(1299), 1,
      anon_sym_while,
    ACTIONS(1301), 1,
      anon_sym_repeat,
    ACTIONS(1303), 1,
      anon_sym_QMARK,
    ACTIONS(1305), 1,
      anon_sym_TILDE,
    ACTIONS(1313), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1315), 1,
      sym__number_literal,
    ACTIONS(1317), 1,
      anon_sym_SQUOTE,
    ACTIONS(1319), 1,
      anon_sym_DQUOTE,
    ACTIONS(1329), 1,
      sym__raw_string_literal,
    ACTIONS(1331), 1,
      sym__external_open_parenthesis,
    ACTIONS(1333), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8531), 1,
      anon_sym_BANG,
    ACTIONS(8577), 1,
      sym_dot_dot_i,
    STATE(23), 1,
      sym__open_parenthesis,
    STATE(180), 1,
      sym__open_brace,
    STATE(2264), 1,
      sym__double_quoted_string,
    STATE(2265), 1,
      sym__single_quoted_string,
    STATE(2284), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5147), 1,
      sym__string_or_identifier,
    ACTIONS(1309), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2266), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1323), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8575), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1182), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [20253] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1289), 1,
      sym_identifier,
    ACTIONS(1291), 1,
      anon_sym_BSLASH,
    ACTIONS(1293), 1,
      anon_sym_function,
    ACTIONS(1295), 1,
      anon_sym_if,
    ACTIONS(1297), 1,
      anon_sym_for,
    ACTIONS(1299), 1,
      anon_sym_while,
    ACTIONS(1301), 1,
      anon_sym_repeat,
    ACTIONS(1303), 1,
      anon_sym_QMARK,
    ACTIONS(1305), 1,
      anon_sym_TILDE,
    ACTIONS(1313), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1315), 1,
      sym__number_literal,
    ACTIONS(1317), 1,
      anon_sym_SQUOTE,
    ACTIONS(1319), 1,
      anon_sym_DQUOTE,
    ACTIONS(1329), 1,
      sym__raw_string_literal,
    ACTIONS(1331), 1,
      sym__external_open_parenthesis,
    ACTIONS(1333), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8531), 1,
      anon_sym_BANG,
    ACTIONS(8581), 1,
      sym_dot_dot_i,
    STATE(23), 1,
      sym__open_parenthesis,
    STATE(180), 1,
      sym__open_brace,
    STATE(2264), 1,
      sym__double_quoted_string,
    STATE(2265), 1,
      sym__single_quoted_string,
    STATE(2284), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5147), 1,
      sym__string_or_identifier,
    ACTIONS(1309), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2266), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1323), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8579), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1186), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [20382] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1241), 1,
      sym_identifier,
    ACTIONS(1243), 1,
      anon_sym_BSLASH,
    ACTIONS(1245), 1,
      anon_sym_function,
    ACTIONS(1247), 1,
      anon_sym_if,
    ACTIONS(1249), 1,
      anon_sym_for,
    ACTIONS(1251), 1,
      anon_sym_while,
    ACTIONS(1253), 1,
      anon_sym_repeat,
    ACTIONS(1255), 1,
      anon_sym_QMARK,
    ACTIONS(1257), 1,
      anon_sym_TILDE,
    ACTIONS(1265), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1267), 1,
      sym__number_literal,
    ACTIONS(1269), 1,
      anon_sym_SQUOTE,
    ACTIONS(1271), 1,
      anon_sym_DQUOTE,
    ACTIONS(1281), 1,
      sym__raw_string_literal,
    ACTIONS(1283), 1,
      sym__external_open_parenthesis,
    ACTIONS(1287), 1,
      sym__external_open_brace,
    ACTIONS(8543), 1,
      anon_sym_BANG,
    ACTIONS(8585), 1,
      sym_dot_dot_i,
    ACTIONS(8587), 1,
      sym__newline,
    STATE(11), 1,
      sym__open_brace,
    STATE(120), 1,
      sym__open_parenthesis,
    STATE(2271), 1,
      sym_string,
    STATE(2273), 1,
      sym__single_quoted_string,
    STATE(2274), 1,
      sym__double_quoted_string,
    STATE(3180), 1,
      aux_sym_function_definition_repeat1,
    STATE(5157), 1,
      sym__string_or_identifier,
    ACTIONS(1261), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2272), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1275), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8583), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(821), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [20511] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1289), 1,
      sym_identifier,
    ACTIONS(1291), 1,
      anon_sym_BSLASH,
    ACTIONS(1293), 1,
      anon_sym_function,
    ACTIONS(1295), 1,
      anon_sym_if,
    ACTIONS(1297), 1,
      anon_sym_for,
    ACTIONS(1299), 1,
      anon_sym_while,
    ACTIONS(1301), 1,
      anon_sym_repeat,
    ACTIONS(1303), 1,
      anon_sym_QMARK,
    ACTIONS(1305), 1,
      anon_sym_TILDE,
    ACTIONS(1313), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1315), 1,
      sym__number_literal,
    ACTIONS(1317), 1,
      anon_sym_SQUOTE,
    ACTIONS(1319), 1,
      anon_sym_DQUOTE,
    ACTIONS(1329), 1,
      sym__raw_string_literal,
    ACTIONS(1331), 1,
      sym__external_open_parenthesis,
    ACTIONS(1333), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8531), 1,
      anon_sym_BANG,
    ACTIONS(8591), 1,
      sym_dot_dot_i,
    STATE(23), 1,
      sym__open_parenthesis,
    STATE(180), 1,
      sym__open_brace,
    STATE(2264), 1,
      sym__double_quoted_string,
    STATE(2265), 1,
      sym__single_quoted_string,
    STATE(2284), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5147), 1,
      sym__string_or_identifier,
    ACTIONS(1309), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2266), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1323), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8589), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1188), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [20640] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3678), 1,
      sym_identifier,
    ACTIONS(3680), 1,
      anon_sym_BSLASH,
    ACTIONS(3682), 1,
      anon_sym_function,
    ACTIONS(3684), 1,
      anon_sym_if,
    ACTIONS(3686), 1,
      anon_sym_for,
    ACTIONS(3688), 1,
      anon_sym_while,
    ACTIONS(3690), 1,
      anon_sym_repeat,
    ACTIONS(3692), 1,
      anon_sym_QMARK,
    ACTIONS(3694), 1,
      anon_sym_TILDE,
    ACTIONS(3702), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3704), 1,
      sym__number_literal,
    ACTIONS(3706), 1,
      anon_sym_SQUOTE,
    ACTIONS(3708), 1,
      anon_sym_DQUOTE,
    ACTIONS(3718), 1,
      sym__raw_string_literal,
    ACTIONS(3720), 1,
      sym__external_open_parenthesis,
    ACTIONS(3722), 1,
      sym__external_open_brace,
    ACTIONS(8593), 1,
      anon_sym_BANG,
    ACTIONS(8597), 1,
      sym_dot_dot_i,
    ACTIONS(8599), 1,
      sym__newline,
    STATE(29), 1,
      sym__open_brace,
    STATE(191), 1,
      sym__open_parenthesis,
    STATE(2378), 1,
      sym_string,
    STATE(2382), 1,
      sym__single_quoted_string,
    STATE(2383), 1,
      sym__double_quoted_string,
    STATE(3201), 1,
      aux_sym_function_definition_repeat1,
    STATE(5153), 1,
      sym__string_or_identifier,
    ACTIONS(3698), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2381), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3712), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8595), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1546), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [20769] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3678), 1,
      sym_identifier,
    ACTIONS(3680), 1,
      anon_sym_BSLASH,
    ACTIONS(3682), 1,
      anon_sym_function,
    ACTIONS(3684), 1,
      anon_sym_if,
    ACTIONS(3686), 1,
      anon_sym_for,
    ACTIONS(3688), 1,
      anon_sym_while,
    ACTIONS(3690), 1,
      anon_sym_repeat,
    ACTIONS(3692), 1,
      anon_sym_QMARK,
    ACTIONS(3694), 1,
      anon_sym_TILDE,
    ACTIONS(3702), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3704), 1,
      sym__number_literal,
    ACTIONS(3706), 1,
      anon_sym_SQUOTE,
    ACTIONS(3708), 1,
      anon_sym_DQUOTE,
    ACTIONS(3718), 1,
      sym__raw_string_literal,
    ACTIONS(3720), 1,
      sym__external_open_parenthesis,
    ACTIONS(3722), 1,
      sym__external_open_brace,
    ACTIONS(8593), 1,
      anon_sym_BANG,
    ACTIONS(8603), 1,
      sym_dot_dot_i,
    ACTIONS(8605), 1,
      sym__newline,
    STATE(29), 1,
      sym__open_brace,
    STATE(191), 1,
      sym__open_parenthesis,
    STATE(2378), 1,
      sym_string,
    STATE(2382), 1,
      sym__single_quoted_string,
    STATE(2383), 1,
      sym__double_quoted_string,
    STATE(3203), 1,
      aux_sym_function_definition_repeat1,
    STATE(5153), 1,
      sym__string_or_identifier,
    ACTIONS(3698), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2381), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3712), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8601), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1544), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [20898] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3678), 1,
      sym_identifier,
    ACTIONS(3680), 1,
      anon_sym_BSLASH,
    ACTIONS(3682), 1,
      anon_sym_function,
    ACTIONS(3684), 1,
      anon_sym_if,
    ACTIONS(3686), 1,
      anon_sym_for,
    ACTIONS(3688), 1,
      anon_sym_while,
    ACTIONS(3690), 1,
      anon_sym_repeat,
    ACTIONS(3692), 1,
      anon_sym_QMARK,
    ACTIONS(3694), 1,
      anon_sym_TILDE,
    ACTIONS(3702), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3704), 1,
      sym__number_literal,
    ACTIONS(3706), 1,
      anon_sym_SQUOTE,
    ACTIONS(3708), 1,
      anon_sym_DQUOTE,
    ACTIONS(3718), 1,
      sym__raw_string_literal,
    ACTIONS(3720), 1,
      sym__external_open_parenthesis,
    ACTIONS(3722), 1,
      sym__external_open_brace,
    ACTIONS(8593), 1,
      anon_sym_BANG,
    ACTIONS(8609), 1,
      sym_dot_dot_i,
    ACTIONS(8611), 1,
      sym__newline,
    STATE(29), 1,
      sym__open_brace,
    STATE(191), 1,
      sym__open_parenthesis,
    STATE(2378), 1,
      sym_string,
    STATE(2382), 1,
      sym__single_quoted_string,
    STATE(2383), 1,
      sym__double_quoted_string,
    STATE(3205), 1,
      aux_sym_function_definition_repeat1,
    STATE(5153), 1,
      sym__string_or_identifier,
    ACTIONS(3698), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2381), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3712), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8607), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1542), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [21027] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3678), 1,
      sym_identifier,
    ACTIONS(3680), 1,
      anon_sym_BSLASH,
    ACTIONS(3682), 1,
      anon_sym_function,
    ACTIONS(3684), 1,
      anon_sym_if,
    ACTIONS(3686), 1,
      anon_sym_for,
    ACTIONS(3688), 1,
      anon_sym_while,
    ACTIONS(3690), 1,
      anon_sym_repeat,
    ACTIONS(3692), 1,
      anon_sym_QMARK,
    ACTIONS(3694), 1,
      anon_sym_TILDE,
    ACTIONS(3702), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3704), 1,
      sym__number_literal,
    ACTIONS(3706), 1,
      anon_sym_SQUOTE,
    ACTIONS(3708), 1,
      anon_sym_DQUOTE,
    ACTIONS(3718), 1,
      sym__raw_string_literal,
    ACTIONS(3720), 1,
      sym__external_open_parenthesis,
    ACTIONS(3722), 1,
      sym__external_open_brace,
    ACTIONS(8593), 1,
      anon_sym_BANG,
    ACTIONS(8615), 1,
      sym_dot_dot_i,
    ACTIONS(8617), 1,
      sym__newline,
    STATE(29), 1,
      sym__open_brace,
    STATE(191), 1,
      sym__open_parenthesis,
    STATE(2378), 1,
      sym_string,
    STATE(2382), 1,
      sym__single_quoted_string,
    STATE(2383), 1,
      sym__double_quoted_string,
    STATE(3207), 1,
      aux_sym_function_definition_repeat1,
    STATE(5153), 1,
      sym__string_or_identifier,
    ACTIONS(3698), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2381), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3712), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8613), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1540), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [21156] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(626), 1,
      sym_identifier,
    ACTIONS(628), 1,
      anon_sym_BSLASH,
    ACTIONS(630), 1,
      anon_sym_function,
    ACTIONS(632), 1,
      anon_sym_if,
    ACTIONS(634), 1,
      anon_sym_for,
    ACTIONS(636), 1,
      anon_sym_while,
    ACTIONS(638), 1,
      anon_sym_repeat,
    ACTIONS(640), 1,
      anon_sym_QMARK,
    ACTIONS(642), 1,
      anon_sym_TILDE,
    ACTIONS(650), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(652), 1,
      sym__number_literal,
    ACTIONS(654), 1,
      anon_sym_SQUOTE,
    ACTIONS(656), 1,
      anon_sym_DQUOTE,
    ACTIONS(666), 1,
      sym__raw_string_literal,
    ACTIONS(668), 1,
      sym__external_open_parenthesis,
    ACTIONS(670), 1,
      sym__external_open_brace,
    ACTIONS(7933), 1,
      anon_sym_BANG,
    ACTIONS(8621), 1,
      sym_dot_dot_i,
    ACTIONS(8623), 1,
      sym__newline,
    STATE(54), 1,
      sym__open_parenthesis,
    STATE(56), 1,
      sym__open_brace,
    STATE(2219), 1,
      sym_string,
    STATE(2221), 1,
      sym__single_quoted_string,
    STATE(2222), 1,
      sym__double_quoted_string,
    STATE(3368), 1,
      aux_sym_function_definition_repeat1,
    STATE(5140), 1,
      sym__string_or_identifier,
    ACTIONS(646), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2220), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(660), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8619), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(675), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [21285] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3678), 1,
      sym_identifier,
    ACTIONS(3680), 1,
      anon_sym_BSLASH,
    ACTIONS(3682), 1,
      anon_sym_function,
    ACTIONS(3684), 1,
      anon_sym_if,
    ACTIONS(3686), 1,
      anon_sym_for,
    ACTIONS(3688), 1,
      anon_sym_while,
    ACTIONS(3690), 1,
      anon_sym_repeat,
    ACTIONS(3692), 1,
      anon_sym_QMARK,
    ACTIONS(3694), 1,
      anon_sym_TILDE,
    ACTIONS(3702), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3704), 1,
      sym__number_literal,
    ACTIONS(3706), 1,
      anon_sym_SQUOTE,
    ACTIONS(3708), 1,
      anon_sym_DQUOTE,
    ACTIONS(3718), 1,
      sym__raw_string_literal,
    ACTIONS(3720), 1,
      sym__external_open_parenthesis,
    ACTIONS(3722), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8593), 1,
      anon_sym_BANG,
    ACTIONS(8627), 1,
      sym_dot_dot_i,
    STATE(29), 1,
      sym__open_brace,
    STATE(191), 1,
      sym__open_parenthesis,
    STATE(2378), 1,
      sym_string,
    STATE(2382), 1,
      sym__single_quoted_string,
    STATE(2383), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5153), 1,
      sym__string_or_identifier,
    ACTIONS(3698), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2381), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3712), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8625), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1316), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [21414] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3678), 1,
      sym_identifier,
    ACTIONS(3680), 1,
      anon_sym_BSLASH,
    ACTIONS(3682), 1,
      anon_sym_function,
    ACTIONS(3684), 1,
      anon_sym_if,
    ACTIONS(3686), 1,
      anon_sym_for,
    ACTIONS(3688), 1,
      anon_sym_while,
    ACTIONS(3690), 1,
      anon_sym_repeat,
    ACTIONS(3692), 1,
      anon_sym_QMARK,
    ACTIONS(3694), 1,
      anon_sym_TILDE,
    ACTIONS(3702), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3704), 1,
      sym__number_literal,
    ACTIONS(3706), 1,
      anon_sym_SQUOTE,
    ACTIONS(3708), 1,
      anon_sym_DQUOTE,
    ACTIONS(3718), 1,
      sym__raw_string_literal,
    ACTIONS(3720), 1,
      sym__external_open_parenthesis,
    ACTIONS(3722), 1,
      sym__external_open_brace,
    ACTIONS(8593), 1,
      anon_sym_BANG,
    ACTIONS(8631), 1,
      sym_dot_dot_i,
    ACTIONS(8633), 1,
      sym__newline,
    STATE(29), 1,
      sym__open_brace,
    STATE(191), 1,
      sym__open_parenthesis,
    STATE(2378), 1,
      sym_string,
    STATE(2382), 1,
      sym__single_quoted_string,
    STATE(2383), 1,
      sym__double_quoted_string,
    STATE(3193), 1,
      aux_sym_function_definition_repeat1,
    STATE(5153), 1,
      sym__string_or_identifier,
    ACTIONS(3698), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2381), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3712), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8629), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1315), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [21543] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3678), 1,
      sym_identifier,
    ACTIONS(3680), 1,
      anon_sym_BSLASH,
    ACTIONS(3682), 1,
      anon_sym_function,
    ACTIONS(3684), 1,
      anon_sym_if,
    ACTIONS(3686), 1,
      anon_sym_for,
    ACTIONS(3688), 1,
      anon_sym_while,
    ACTIONS(3690), 1,
      anon_sym_repeat,
    ACTIONS(3692), 1,
      anon_sym_QMARK,
    ACTIONS(3694), 1,
      anon_sym_TILDE,
    ACTIONS(3702), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3704), 1,
      sym__number_literal,
    ACTIONS(3706), 1,
      anon_sym_SQUOTE,
    ACTIONS(3708), 1,
      anon_sym_DQUOTE,
    ACTIONS(3718), 1,
      sym__raw_string_literal,
    ACTIONS(3720), 1,
      sym__external_open_parenthesis,
    ACTIONS(3722), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8593), 1,
      anon_sym_BANG,
    ACTIONS(8637), 1,
      sym_dot_dot_i,
    STATE(29), 1,
      sym__open_brace,
    STATE(191), 1,
      sym__open_parenthesis,
    STATE(2378), 1,
      sym_string,
    STATE(2382), 1,
      sym__single_quoted_string,
    STATE(2383), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5153), 1,
      sym__string_or_identifier,
    ACTIONS(3698), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2381), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3712), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8635), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1301), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [21672] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1433), 1,
      sym_identifier,
    ACTIONS(1435), 1,
      anon_sym_BSLASH,
    ACTIONS(1437), 1,
      anon_sym_function,
    ACTIONS(1439), 1,
      anon_sym_if,
    ACTIONS(1441), 1,
      anon_sym_for,
    ACTIONS(1443), 1,
      anon_sym_while,
    ACTIONS(1445), 1,
      anon_sym_repeat,
    ACTIONS(1447), 1,
      anon_sym_QMARK,
    ACTIONS(1449), 1,
      anon_sym_TILDE,
    ACTIONS(1457), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1459), 1,
      sym__number_literal,
    ACTIONS(1461), 1,
      anon_sym_SQUOTE,
    ACTIONS(1463), 1,
      anon_sym_DQUOTE,
    ACTIONS(1473), 1,
      sym__raw_string_literal,
    ACTIONS(1475), 1,
      sym__external_open_parenthesis,
    ACTIONS(1477), 1,
      sym__external_open_brace,
    ACTIONS(8097), 1,
      anon_sym_BANG,
    ACTIONS(8641), 1,
      sym_dot_dot_i,
    ACTIONS(8643), 1,
      sym__newline,
    STATE(76), 1,
      sym__open_parenthesis,
    STATE(188), 1,
      sym__open_brace,
    STATE(2234), 1,
      sym_string,
    STATE(2236), 1,
      sym__single_quoted_string,
    STATE(2237), 1,
      sym__double_quoted_string,
    STATE(3276), 1,
      aux_sym_function_definition_repeat1,
    STATE(5150), 1,
      sym__string_or_identifier,
    ACTIONS(1453), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2235), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1467), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8639), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1126), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [21801] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3678), 1,
      sym_identifier,
    ACTIONS(3680), 1,
      anon_sym_BSLASH,
    ACTIONS(3682), 1,
      anon_sym_function,
    ACTIONS(3684), 1,
      anon_sym_if,
    ACTIONS(3686), 1,
      anon_sym_for,
    ACTIONS(3688), 1,
      anon_sym_while,
    ACTIONS(3690), 1,
      anon_sym_repeat,
    ACTIONS(3692), 1,
      anon_sym_QMARK,
    ACTIONS(3694), 1,
      anon_sym_TILDE,
    ACTIONS(3702), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3704), 1,
      sym__number_literal,
    ACTIONS(3706), 1,
      anon_sym_SQUOTE,
    ACTIONS(3708), 1,
      anon_sym_DQUOTE,
    ACTIONS(3718), 1,
      sym__raw_string_literal,
    ACTIONS(3720), 1,
      sym__external_open_parenthesis,
    ACTIONS(3722), 1,
      sym__external_open_brace,
    ACTIONS(8593), 1,
      anon_sym_BANG,
    ACTIONS(8647), 1,
      sym_dot_dot_i,
    ACTIONS(8649), 1,
      sym__newline,
    STATE(29), 1,
      sym__open_brace,
    STATE(191), 1,
      sym__open_parenthesis,
    STATE(2378), 1,
      sym_string,
    STATE(2382), 1,
      sym__single_quoted_string,
    STATE(2383), 1,
      sym__double_quoted_string,
    STATE(3195), 1,
      aux_sym_function_definition_repeat1,
    STATE(5153), 1,
      sym__string_or_identifier,
    ACTIONS(3698), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2381), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3712), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8645), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1300), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [21930] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1289), 1,
      sym_identifier,
    ACTIONS(1291), 1,
      anon_sym_BSLASH,
    ACTIONS(1293), 1,
      anon_sym_function,
    ACTIONS(1295), 1,
      anon_sym_if,
    ACTIONS(1297), 1,
      anon_sym_for,
    ACTIONS(1299), 1,
      anon_sym_while,
    ACTIONS(1301), 1,
      anon_sym_repeat,
    ACTIONS(1303), 1,
      anon_sym_QMARK,
    ACTIONS(1305), 1,
      anon_sym_TILDE,
    ACTIONS(1313), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1315), 1,
      sym__number_literal,
    ACTIONS(1317), 1,
      anon_sym_SQUOTE,
    ACTIONS(1319), 1,
      anon_sym_DQUOTE,
    ACTIONS(1329), 1,
      sym__raw_string_literal,
    ACTIONS(1331), 1,
      sym__external_open_parenthesis,
    ACTIONS(1333), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8531), 1,
      anon_sym_BANG,
    ACTIONS(8653), 1,
      sym_dot_dot_i,
    STATE(23), 1,
      sym__open_parenthesis,
    STATE(180), 1,
      sym__open_brace,
    STATE(2264), 1,
      sym__double_quoted_string,
    STATE(2265), 1,
      sym__single_quoted_string,
    STATE(2284), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5147), 1,
      sym__string_or_identifier,
    ACTIONS(1309), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2266), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1323), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8651), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1190), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [22059] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1433), 1,
      sym_identifier,
    ACTIONS(1435), 1,
      anon_sym_BSLASH,
    ACTIONS(1437), 1,
      anon_sym_function,
    ACTIONS(1439), 1,
      anon_sym_if,
    ACTIONS(1441), 1,
      anon_sym_for,
    ACTIONS(1443), 1,
      anon_sym_while,
    ACTIONS(1445), 1,
      anon_sym_repeat,
    ACTIONS(1447), 1,
      anon_sym_QMARK,
    ACTIONS(1449), 1,
      anon_sym_TILDE,
    ACTIONS(1457), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1459), 1,
      sym__number_literal,
    ACTIONS(1461), 1,
      anon_sym_SQUOTE,
    ACTIONS(1463), 1,
      anon_sym_DQUOTE,
    ACTIONS(1473), 1,
      sym__raw_string_literal,
    ACTIONS(1475), 1,
      sym__external_open_parenthesis,
    ACTIONS(1477), 1,
      sym__external_open_brace,
    ACTIONS(8097), 1,
      anon_sym_BANG,
    ACTIONS(8657), 1,
      sym_dot_dot_i,
    ACTIONS(8659), 1,
      sym__newline,
    STATE(76), 1,
      sym__open_parenthesis,
    STATE(188), 1,
      sym__open_brace,
    STATE(2234), 1,
      sym_string,
    STATE(2236), 1,
      sym__single_quoted_string,
    STATE(2237), 1,
      sym__double_quoted_string,
    STATE(3297), 1,
      aux_sym_function_definition_repeat1,
    STATE(5150), 1,
      sym__string_or_identifier,
    ACTIONS(1453), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2235), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1467), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8655), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1125), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [22188] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1289), 1,
      sym_identifier,
    ACTIONS(1291), 1,
      anon_sym_BSLASH,
    ACTIONS(1293), 1,
      anon_sym_function,
    ACTIONS(1295), 1,
      anon_sym_if,
    ACTIONS(1297), 1,
      anon_sym_for,
    ACTIONS(1299), 1,
      anon_sym_while,
    ACTIONS(1301), 1,
      anon_sym_repeat,
    ACTIONS(1303), 1,
      anon_sym_QMARK,
    ACTIONS(1305), 1,
      anon_sym_TILDE,
    ACTIONS(1313), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1315), 1,
      sym__number_literal,
    ACTIONS(1317), 1,
      anon_sym_SQUOTE,
    ACTIONS(1319), 1,
      anon_sym_DQUOTE,
    ACTIONS(1329), 1,
      sym__raw_string_literal,
    ACTIONS(1331), 1,
      sym__external_open_parenthesis,
    ACTIONS(1333), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8531), 1,
      anon_sym_BANG,
    ACTIONS(8663), 1,
      sym_dot_dot_i,
    STATE(23), 1,
      sym__open_parenthesis,
    STATE(180), 1,
      sym__open_brace,
    STATE(2264), 1,
      sym__double_quoted_string,
    STATE(2265), 1,
      sym__single_quoted_string,
    STATE(2284), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5147), 1,
      sym__string_or_identifier,
    ACTIONS(1309), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2266), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1323), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8661), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1191), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [22317] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3678), 1,
      sym_identifier,
    ACTIONS(3680), 1,
      anon_sym_BSLASH,
    ACTIONS(3682), 1,
      anon_sym_function,
    ACTIONS(3684), 1,
      anon_sym_if,
    ACTIONS(3686), 1,
      anon_sym_for,
    ACTIONS(3688), 1,
      anon_sym_while,
    ACTIONS(3690), 1,
      anon_sym_repeat,
    ACTIONS(3692), 1,
      anon_sym_QMARK,
    ACTIONS(3694), 1,
      anon_sym_TILDE,
    ACTIONS(3702), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3704), 1,
      sym__number_literal,
    ACTIONS(3706), 1,
      anon_sym_SQUOTE,
    ACTIONS(3708), 1,
      anon_sym_DQUOTE,
    ACTIONS(3718), 1,
      sym__raw_string_literal,
    ACTIONS(3720), 1,
      sym__external_open_parenthesis,
    ACTIONS(3722), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8593), 1,
      anon_sym_BANG,
    ACTIONS(8667), 1,
      sym_dot_dot_i,
    STATE(29), 1,
      sym__open_brace,
    STATE(191), 1,
      sym__open_parenthesis,
    STATE(2378), 1,
      sym_string,
    STATE(2382), 1,
      sym__single_quoted_string,
    STATE(2383), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5153), 1,
      sym__string_or_identifier,
    ACTIONS(3698), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2381), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3712), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8665), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1526), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [22446] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1289), 1,
      sym_identifier,
    ACTIONS(1291), 1,
      anon_sym_BSLASH,
    ACTIONS(1293), 1,
      anon_sym_function,
    ACTIONS(1295), 1,
      anon_sym_if,
    ACTIONS(1297), 1,
      anon_sym_for,
    ACTIONS(1299), 1,
      anon_sym_while,
    ACTIONS(1301), 1,
      anon_sym_repeat,
    ACTIONS(1303), 1,
      anon_sym_QMARK,
    ACTIONS(1305), 1,
      anon_sym_TILDE,
    ACTIONS(1313), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1315), 1,
      sym__number_literal,
    ACTIONS(1317), 1,
      anon_sym_SQUOTE,
    ACTIONS(1319), 1,
      anon_sym_DQUOTE,
    ACTIONS(1329), 1,
      sym__raw_string_literal,
    ACTIONS(1331), 1,
      sym__external_open_parenthesis,
    ACTIONS(1333), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8531), 1,
      anon_sym_BANG,
    ACTIONS(8671), 1,
      sym_dot_dot_i,
    STATE(23), 1,
      sym__open_parenthesis,
    STATE(180), 1,
      sym__open_brace,
    STATE(2264), 1,
      sym__double_quoted_string,
    STATE(2265), 1,
      sym__single_quoted_string,
    STATE(2284), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5147), 1,
      sym__string_or_identifier,
    ACTIONS(1309), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2266), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1323), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8669), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1192), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [22575] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3678), 1,
      sym_identifier,
    ACTIONS(3680), 1,
      anon_sym_BSLASH,
    ACTIONS(3682), 1,
      anon_sym_function,
    ACTIONS(3684), 1,
      anon_sym_if,
    ACTIONS(3686), 1,
      anon_sym_for,
    ACTIONS(3688), 1,
      anon_sym_while,
    ACTIONS(3690), 1,
      anon_sym_repeat,
    ACTIONS(3692), 1,
      anon_sym_QMARK,
    ACTIONS(3694), 1,
      anon_sym_TILDE,
    ACTIONS(3702), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3704), 1,
      sym__number_literal,
    ACTIONS(3706), 1,
      anon_sym_SQUOTE,
    ACTIONS(3708), 1,
      anon_sym_DQUOTE,
    ACTIONS(3718), 1,
      sym__raw_string_literal,
    ACTIONS(3720), 1,
      sym__external_open_parenthesis,
    ACTIONS(3722), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8593), 1,
      anon_sym_BANG,
    ACTIONS(8675), 1,
      sym_dot_dot_i,
    STATE(29), 1,
      sym__open_brace,
    STATE(191), 1,
      sym__open_parenthesis,
    STATE(2378), 1,
      sym_string,
    STATE(2382), 1,
      sym__single_quoted_string,
    STATE(2383), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5153), 1,
      sym__string_or_identifier,
    ACTIONS(3698), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2381), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3712), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8673), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1524), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [22704] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1289), 1,
      sym_identifier,
    ACTIONS(1291), 1,
      anon_sym_BSLASH,
    ACTIONS(1293), 1,
      anon_sym_function,
    ACTIONS(1295), 1,
      anon_sym_if,
    ACTIONS(1297), 1,
      anon_sym_for,
    ACTIONS(1299), 1,
      anon_sym_while,
    ACTIONS(1301), 1,
      anon_sym_repeat,
    ACTIONS(1303), 1,
      anon_sym_QMARK,
    ACTIONS(1305), 1,
      anon_sym_TILDE,
    ACTIONS(1313), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1315), 1,
      sym__number_literal,
    ACTIONS(1317), 1,
      anon_sym_SQUOTE,
    ACTIONS(1319), 1,
      anon_sym_DQUOTE,
    ACTIONS(1329), 1,
      sym__raw_string_literal,
    ACTIONS(1331), 1,
      sym__external_open_parenthesis,
    ACTIONS(1333), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8531), 1,
      anon_sym_BANG,
    ACTIONS(8679), 1,
      sym_dot_dot_i,
    STATE(23), 1,
      sym__open_parenthesis,
    STATE(180), 1,
      sym__open_brace,
    STATE(2264), 1,
      sym__double_quoted_string,
    STATE(2265), 1,
      sym__single_quoted_string,
    STATE(2284), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5147), 1,
      sym__string_or_identifier,
    ACTIONS(1309), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2266), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1323), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8677), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1193), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [22833] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3678), 1,
      sym_identifier,
    ACTIONS(3680), 1,
      anon_sym_BSLASH,
    ACTIONS(3682), 1,
      anon_sym_function,
    ACTIONS(3684), 1,
      anon_sym_if,
    ACTIONS(3686), 1,
      anon_sym_for,
    ACTIONS(3688), 1,
      anon_sym_while,
    ACTIONS(3690), 1,
      anon_sym_repeat,
    ACTIONS(3692), 1,
      anon_sym_QMARK,
    ACTIONS(3694), 1,
      anon_sym_TILDE,
    ACTIONS(3702), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3704), 1,
      sym__number_literal,
    ACTIONS(3706), 1,
      anon_sym_SQUOTE,
    ACTIONS(3708), 1,
      anon_sym_DQUOTE,
    ACTIONS(3718), 1,
      sym__raw_string_literal,
    ACTIONS(3720), 1,
      sym__external_open_parenthesis,
    ACTIONS(3722), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8593), 1,
      anon_sym_BANG,
    ACTIONS(8683), 1,
      sym_dot_dot_i,
    STATE(29), 1,
      sym__open_brace,
    STATE(191), 1,
      sym__open_parenthesis,
    STATE(2378), 1,
      sym_string,
    STATE(2382), 1,
      sym__single_quoted_string,
    STATE(2383), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5153), 1,
      sym__string_or_identifier,
    ACTIONS(3698), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2381), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3712), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8681), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1523), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [22962] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1289), 1,
      sym_identifier,
    ACTIONS(1291), 1,
      anon_sym_BSLASH,
    ACTIONS(1293), 1,
      anon_sym_function,
    ACTIONS(1295), 1,
      anon_sym_if,
    ACTIONS(1297), 1,
      anon_sym_for,
    ACTIONS(1299), 1,
      anon_sym_while,
    ACTIONS(1301), 1,
      anon_sym_repeat,
    ACTIONS(1303), 1,
      anon_sym_QMARK,
    ACTIONS(1305), 1,
      anon_sym_TILDE,
    ACTIONS(1313), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1315), 1,
      sym__number_literal,
    ACTIONS(1317), 1,
      anon_sym_SQUOTE,
    ACTIONS(1319), 1,
      anon_sym_DQUOTE,
    ACTIONS(1329), 1,
      sym__raw_string_literal,
    ACTIONS(1331), 1,
      sym__external_open_parenthesis,
    ACTIONS(1333), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8531), 1,
      anon_sym_BANG,
    ACTIONS(8687), 1,
      sym_dot_dot_i,
    STATE(23), 1,
      sym__open_parenthesis,
    STATE(180), 1,
      sym__open_brace,
    STATE(2264), 1,
      sym__double_quoted_string,
    STATE(2265), 1,
      sym__single_quoted_string,
    STATE(2284), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5147), 1,
      sym__string_or_identifier,
    ACTIONS(1309), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2266), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1323), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8685), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1194), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [23091] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3678), 1,
      sym_identifier,
    ACTIONS(3680), 1,
      anon_sym_BSLASH,
    ACTIONS(3682), 1,
      anon_sym_function,
    ACTIONS(3684), 1,
      anon_sym_if,
    ACTIONS(3686), 1,
      anon_sym_for,
    ACTIONS(3688), 1,
      anon_sym_while,
    ACTIONS(3690), 1,
      anon_sym_repeat,
    ACTIONS(3692), 1,
      anon_sym_QMARK,
    ACTIONS(3694), 1,
      anon_sym_TILDE,
    ACTIONS(3702), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3704), 1,
      sym__number_literal,
    ACTIONS(3706), 1,
      anon_sym_SQUOTE,
    ACTIONS(3708), 1,
      anon_sym_DQUOTE,
    ACTIONS(3718), 1,
      sym__raw_string_literal,
    ACTIONS(3720), 1,
      sym__external_open_parenthesis,
    ACTIONS(3722), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8593), 1,
      anon_sym_BANG,
    ACTIONS(8691), 1,
      sym_dot_dot_i,
    STATE(29), 1,
      sym__open_brace,
    STATE(191), 1,
      sym__open_parenthesis,
    STATE(2378), 1,
      sym_string,
    STATE(2382), 1,
      sym__single_quoted_string,
    STATE(2383), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5153), 1,
      sym__string_or_identifier,
    ACTIONS(3698), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2381), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3712), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8689), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1522), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [23220] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3491), 1,
      sym_identifier,
    ACTIONS(3493), 1,
      anon_sym_BSLASH,
    ACTIONS(3495), 1,
      anon_sym_function,
    ACTIONS(3497), 1,
      anon_sym_if,
    ACTIONS(3499), 1,
      anon_sym_for,
    ACTIONS(3501), 1,
      anon_sym_while,
    ACTIONS(3503), 1,
      anon_sym_repeat,
    ACTIONS(3505), 1,
      anon_sym_QMARK,
    ACTIONS(3507), 1,
      anon_sym_TILDE,
    ACTIONS(3515), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3517), 1,
      sym__number_literal,
    ACTIONS(3519), 1,
      anon_sym_SQUOTE,
    ACTIONS(3521), 1,
      anon_sym_DQUOTE,
    ACTIONS(3531), 1,
      sym__raw_string_literal,
    ACTIONS(3533), 1,
      sym__external_open_parenthesis,
    ACTIONS(3535), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7789), 1,
      anon_sym_BANG,
    ACTIONS(8695), 1,
      sym_dot_dot_i,
    STATE(63), 1,
      sym__open_brace,
    STATE(147), 1,
      sym__open_parenthesis,
    STATE(2441), 1,
      sym_string,
    STATE(2456), 1,
      sym__single_quoted_string,
    STATE(2478), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5130), 1,
      sym__string_or_identifier,
    ACTIONS(3511), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2448), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3525), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8693), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1297), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [23349] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1433), 1,
      sym_identifier,
    ACTIONS(1435), 1,
      anon_sym_BSLASH,
    ACTIONS(1437), 1,
      anon_sym_function,
    ACTIONS(1439), 1,
      anon_sym_if,
    ACTIONS(1441), 1,
      anon_sym_for,
    ACTIONS(1443), 1,
      anon_sym_while,
    ACTIONS(1445), 1,
      anon_sym_repeat,
    ACTIONS(1447), 1,
      anon_sym_QMARK,
    ACTIONS(1449), 1,
      anon_sym_TILDE,
    ACTIONS(1457), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1459), 1,
      sym__number_literal,
    ACTIONS(1461), 1,
      anon_sym_SQUOTE,
    ACTIONS(1463), 1,
      anon_sym_DQUOTE,
    ACTIONS(1473), 1,
      sym__raw_string_literal,
    ACTIONS(1475), 1,
      sym__external_open_parenthesis,
    ACTIONS(1477), 1,
      sym__external_open_brace,
    ACTIONS(8097), 1,
      anon_sym_BANG,
    ACTIONS(8699), 1,
      sym_dot_dot_i,
    ACTIONS(8701), 1,
      sym__newline,
    STATE(76), 1,
      sym__open_parenthesis,
    STATE(188), 1,
      sym__open_brace,
    STATE(2234), 1,
      sym_string,
    STATE(2236), 1,
      sym__single_quoted_string,
    STATE(2237), 1,
      sym__double_quoted_string,
    STATE(3300), 1,
      aux_sym_function_definition_repeat1,
    STATE(5150), 1,
      sym__string_or_identifier,
    ACTIONS(1453), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2235), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1467), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8697), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1123), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [23478] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1433), 1,
      sym_identifier,
    ACTIONS(1435), 1,
      anon_sym_BSLASH,
    ACTIONS(1437), 1,
      anon_sym_function,
    ACTIONS(1439), 1,
      anon_sym_if,
    ACTIONS(1441), 1,
      anon_sym_for,
    ACTIONS(1443), 1,
      anon_sym_while,
    ACTIONS(1445), 1,
      anon_sym_repeat,
    ACTIONS(1447), 1,
      anon_sym_QMARK,
    ACTIONS(1449), 1,
      anon_sym_TILDE,
    ACTIONS(1457), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1459), 1,
      sym__number_literal,
    ACTIONS(1461), 1,
      anon_sym_SQUOTE,
    ACTIONS(1463), 1,
      anon_sym_DQUOTE,
    ACTIONS(1473), 1,
      sym__raw_string_literal,
    ACTIONS(1475), 1,
      sym__external_open_parenthesis,
    ACTIONS(1477), 1,
      sym__external_open_brace,
    ACTIONS(8097), 1,
      anon_sym_BANG,
    ACTIONS(8705), 1,
      sym_dot_dot_i,
    ACTIONS(8707), 1,
      sym__newline,
    STATE(76), 1,
      sym__open_parenthesis,
    STATE(188), 1,
      sym__open_brace,
    STATE(2234), 1,
      sym_string,
    STATE(2236), 1,
      sym__single_quoted_string,
    STATE(2237), 1,
      sym__double_quoted_string,
    STATE(3307), 1,
      aux_sym_function_definition_repeat1,
    STATE(5150), 1,
      sym__string_or_identifier,
    ACTIONS(1453), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2235), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1467), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8703), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1122), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [23607] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3491), 1,
      sym_identifier,
    ACTIONS(3493), 1,
      anon_sym_BSLASH,
    ACTIONS(3495), 1,
      anon_sym_function,
    ACTIONS(3497), 1,
      anon_sym_if,
    ACTIONS(3499), 1,
      anon_sym_for,
    ACTIONS(3501), 1,
      anon_sym_while,
    ACTIONS(3503), 1,
      anon_sym_repeat,
    ACTIONS(3505), 1,
      anon_sym_QMARK,
    ACTIONS(3507), 1,
      anon_sym_TILDE,
    ACTIONS(3515), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3517), 1,
      sym__number_literal,
    ACTIONS(3519), 1,
      anon_sym_SQUOTE,
    ACTIONS(3521), 1,
      anon_sym_DQUOTE,
    ACTIONS(3531), 1,
      sym__raw_string_literal,
    ACTIONS(3533), 1,
      sym__external_open_parenthesis,
    ACTIONS(3535), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7789), 1,
      anon_sym_BANG,
    ACTIONS(8711), 1,
      sym_dot_dot_i,
    STATE(63), 1,
      sym__open_brace,
    STATE(147), 1,
      sym__open_parenthesis,
    STATE(2441), 1,
      sym_string,
    STATE(2456), 1,
      sym__single_quoted_string,
    STATE(2478), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5130), 1,
      sym__string_or_identifier,
    ACTIONS(3511), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2448), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3525), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8709), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1294), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [23736] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3678), 1,
      sym_identifier,
    ACTIONS(3680), 1,
      anon_sym_BSLASH,
    ACTIONS(3682), 1,
      anon_sym_function,
    ACTIONS(3684), 1,
      anon_sym_if,
    ACTIONS(3686), 1,
      anon_sym_for,
    ACTIONS(3688), 1,
      anon_sym_while,
    ACTIONS(3690), 1,
      anon_sym_repeat,
    ACTIONS(3692), 1,
      anon_sym_QMARK,
    ACTIONS(3694), 1,
      anon_sym_TILDE,
    ACTIONS(3702), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3704), 1,
      sym__number_literal,
    ACTIONS(3706), 1,
      anon_sym_SQUOTE,
    ACTIONS(3708), 1,
      anon_sym_DQUOTE,
    ACTIONS(3718), 1,
      sym__raw_string_literal,
    ACTIONS(3720), 1,
      sym__external_open_parenthesis,
    ACTIONS(3722), 1,
      sym__external_open_brace,
    ACTIONS(8593), 1,
      anon_sym_BANG,
    ACTIONS(8715), 1,
      sym_dot_dot_i,
    ACTIONS(8717), 1,
      sym__newline,
    STATE(29), 1,
      sym__open_brace,
    STATE(191), 1,
      sym__open_parenthesis,
    STATE(2378), 1,
      sym_string,
    STATE(2382), 1,
      sym__single_quoted_string,
    STATE(2383), 1,
      sym__double_quoted_string,
    STATE(3244), 1,
      aux_sym_function_definition_repeat1,
    STATE(5153), 1,
      sym__string_or_identifier,
    ACTIONS(3698), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2381), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3712), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8713), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1520), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [23865] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3678), 1,
      sym_identifier,
    ACTIONS(3680), 1,
      anon_sym_BSLASH,
    ACTIONS(3682), 1,
      anon_sym_function,
    ACTIONS(3684), 1,
      anon_sym_if,
    ACTIONS(3686), 1,
      anon_sym_for,
    ACTIONS(3688), 1,
      anon_sym_while,
    ACTIONS(3690), 1,
      anon_sym_repeat,
    ACTIONS(3692), 1,
      anon_sym_QMARK,
    ACTIONS(3694), 1,
      anon_sym_TILDE,
    ACTIONS(3702), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3704), 1,
      sym__number_literal,
    ACTIONS(3706), 1,
      anon_sym_SQUOTE,
    ACTIONS(3708), 1,
      anon_sym_DQUOTE,
    ACTIONS(3718), 1,
      sym__raw_string_literal,
    ACTIONS(3720), 1,
      sym__external_open_parenthesis,
    ACTIONS(3722), 1,
      sym__external_open_brace,
    ACTIONS(8593), 1,
      anon_sym_BANG,
    ACTIONS(8721), 1,
      sym_dot_dot_i,
    ACTIONS(8723), 1,
      sym__newline,
    STATE(29), 1,
      sym__open_brace,
    STATE(191), 1,
      sym__open_parenthesis,
    STATE(2378), 1,
      sym_string,
    STATE(2382), 1,
      sym__single_quoted_string,
    STATE(2383), 1,
      sym__double_quoted_string,
    STATE(3248), 1,
      aux_sym_function_definition_repeat1,
    STATE(5153), 1,
      sym__string_or_identifier,
    ACTIONS(3698), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2381), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3712), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8719), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1517), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [23994] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3678), 1,
      sym_identifier,
    ACTIONS(3680), 1,
      anon_sym_BSLASH,
    ACTIONS(3682), 1,
      anon_sym_function,
    ACTIONS(3684), 1,
      anon_sym_if,
    ACTIONS(3686), 1,
      anon_sym_for,
    ACTIONS(3688), 1,
      anon_sym_while,
    ACTIONS(3690), 1,
      anon_sym_repeat,
    ACTIONS(3692), 1,
      anon_sym_QMARK,
    ACTIONS(3694), 1,
      anon_sym_TILDE,
    ACTIONS(3702), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3704), 1,
      sym__number_literal,
    ACTIONS(3706), 1,
      anon_sym_SQUOTE,
    ACTIONS(3708), 1,
      anon_sym_DQUOTE,
    ACTIONS(3718), 1,
      sym__raw_string_literal,
    ACTIONS(3720), 1,
      sym__external_open_parenthesis,
    ACTIONS(3722), 1,
      sym__external_open_brace,
    ACTIONS(8593), 1,
      anon_sym_BANG,
    ACTIONS(8727), 1,
      sym_dot_dot_i,
    ACTIONS(8729), 1,
      sym__newline,
    STATE(29), 1,
      sym__open_brace,
    STATE(191), 1,
      sym__open_parenthesis,
    STATE(2378), 1,
      sym_string,
    STATE(2382), 1,
      sym__single_quoted_string,
    STATE(2383), 1,
      sym__double_quoted_string,
    STATE(3250), 1,
      aux_sym_function_definition_repeat1,
    STATE(5153), 1,
      sym__string_or_identifier,
    ACTIONS(3698), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2381), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3712), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8725), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1516), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [24123] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3678), 1,
      sym_identifier,
    ACTIONS(3680), 1,
      anon_sym_BSLASH,
    ACTIONS(3682), 1,
      anon_sym_function,
    ACTIONS(3684), 1,
      anon_sym_if,
    ACTIONS(3686), 1,
      anon_sym_for,
    ACTIONS(3688), 1,
      anon_sym_while,
    ACTIONS(3690), 1,
      anon_sym_repeat,
    ACTIONS(3692), 1,
      anon_sym_QMARK,
    ACTIONS(3694), 1,
      anon_sym_TILDE,
    ACTIONS(3702), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3704), 1,
      sym__number_literal,
    ACTIONS(3706), 1,
      anon_sym_SQUOTE,
    ACTIONS(3708), 1,
      anon_sym_DQUOTE,
    ACTIONS(3718), 1,
      sym__raw_string_literal,
    ACTIONS(3720), 1,
      sym__external_open_parenthesis,
    ACTIONS(3722), 1,
      sym__external_open_brace,
    ACTIONS(8593), 1,
      anon_sym_BANG,
    ACTIONS(8733), 1,
      sym_dot_dot_i,
    ACTIONS(8735), 1,
      sym__newline,
    STATE(29), 1,
      sym__open_brace,
    STATE(191), 1,
      sym__open_parenthesis,
    STATE(2378), 1,
      sym_string,
    STATE(2382), 1,
      sym__single_quoted_string,
    STATE(2383), 1,
      sym__double_quoted_string,
    STATE(3252), 1,
      aux_sym_function_definition_repeat1,
    STATE(5153), 1,
      sym__string_or_identifier,
    ACTIONS(3698), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2381), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3712), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8731), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1514), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [24252] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3678), 1,
      sym_identifier,
    ACTIONS(3680), 1,
      anon_sym_BSLASH,
    ACTIONS(3682), 1,
      anon_sym_function,
    ACTIONS(3684), 1,
      anon_sym_if,
    ACTIONS(3686), 1,
      anon_sym_for,
    ACTIONS(3688), 1,
      anon_sym_while,
    ACTIONS(3690), 1,
      anon_sym_repeat,
    ACTIONS(3692), 1,
      anon_sym_QMARK,
    ACTIONS(3694), 1,
      anon_sym_TILDE,
    ACTIONS(3702), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3704), 1,
      sym__number_literal,
    ACTIONS(3706), 1,
      anon_sym_SQUOTE,
    ACTIONS(3708), 1,
      anon_sym_DQUOTE,
    ACTIONS(3718), 1,
      sym__raw_string_literal,
    ACTIONS(3720), 1,
      sym__external_open_parenthesis,
    ACTIONS(3722), 1,
      sym__external_open_brace,
    ACTIONS(8593), 1,
      anon_sym_BANG,
    ACTIONS(8739), 1,
      sym_dot_dot_i,
    ACTIONS(8741), 1,
      sym__newline,
    STATE(29), 1,
      sym__open_brace,
    STATE(191), 1,
      sym__open_parenthesis,
    STATE(2378), 1,
      sym_string,
    STATE(2382), 1,
      sym__single_quoted_string,
    STATE(2383), 1,
      sym__double_quoted_string,
    STATE(3254), 1,
      aux_sym_function_definition_repeat1,
    STATE(5153), 1,
      sym__string_or_identifier,
    ACTIONS(3698), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2381), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3712), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8737), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1513), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [24381] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3678), 1,
      sym_identifier,
    ACTIONS(3680), 1,
      anon_sym_BSLASH,
    ACTIONS(3682), 1,
      anon_sym_function,
    ACTIONS(3684), 1,
      anon_sym_if,
    ACTIONS(3686), 1,
      anon_sym_for,
    ACTIONS(3688), 1,
      anon_sym_while,
    ACTIONS(3690), 1,
      anon_sym_repeat,
    ACTIONS(3692), 1,
      anon_sym_QMARK,
    ACTIONS(3694), 1,
      anon_sym_TILDE,
    ACTIONS(3702), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3704), 1,
      sym__number_literal,
    ACTIONS(3706), 1,
      anon_sym_SQUOTE,
    ACTIONS(3708), 1,
      anon_sym_DQUOTE,
    ACTIONS(3718), 1,
      sym__raw_string_literal,
    ACTIONS(3720), 1,
      sym__external_open_parenthesis,
    ACTIONS(3722), 1,
      sym__external_open_brace,
    ACTIONS(8593), 1,
      anon_sym_BANG,
    ACTIONS(8745), 1,
      sym_dot_dot_i,
    ACTIONS(8747), 1,
      sym__newline,
    STATE(29), 1,
      sym__open_brace,
    STATE(191), 1,
      sym__open_parenthesis,
    STATE(2378), 1,
      sym_string,
    STATE(2382), 1,
      sym__single_quoted_string,
    STATE(2383), 1,
      sym__double_quoted_string,
    STATE(3256), 1,
      aux_sym_function_definition_repeat1,
    STATE(5153), 1,
      sym__string_or_identifier,
    ACTIONS(3698), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2381), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3712), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8743), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1512), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [24510] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3678), 1,
      sym_identifier,
    ACTIONS(3680), 1,
      anon_sym_BSLASH,
    ACTIONS(3682), 1,
      anon_sym_function,
    ACTIONS(3684), 1,
      anon_sym_if,
    ACTIONS(3686), 1,
      anon_sym_for,
    ACTIONS(3688), 1,
      anon_sym_while,
    ACTIONS(3690), 1,
      anon_sym_repeat,
    ACTIONS(3692), 1,
      anon_sym_QMARK,
    ACTIONS(3694), 1,
      anon_sym_TILDE,
    ACTIONS(3702), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3704), 1,
      sym__number_literal,
    ACTIONS(3706), 1,
      anon_sym_SQUOTE,
    ACTIONS(3708), 1,
      anon_sym_DQUOTE,
    ACTIONS(3718), 1,
      sym__raw_string_literal,
    ACTIONS(3720), 1,
      sym__external_open_parenthesis,
    ACTIONS(3722), 1,
      sym__external_open_brace,
    ACTIONS(8593), 1,
      anon_sym_BANG,
    ACTIONS(8751), 1,
      sym_dot_dot_i,
    ACTIONS(8753), 1,
      sym__newline,
    STATE(29), 1,
      sym__open_brace,
    STATE(191), 1,
      sym__open_parenthesis,
    STATE(2378), 1,
      sym_string,
    STATE(2382), 1,
      sym__single_quoted_string,
    STATE(2383), 1,
      sym__double_quoted_string,
    STATE(3258), 1,
      aux_sym_function_definition_repeat1,
    STATE(5153), 1,
      sym__string_or_identifier,
    ACTIONS(3698), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2381), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3712), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8749), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1511), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [24639] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3678), 1,
      sym_identifier,
    ACTIONS(3680), 1,
      anon_sym_BSLASH,
    ACTIONS(3682), 1,
      anon_sym_function,
    ACTIONS(3684), 1,
      anon_sym_if,
    ACTIONS(3686), 1,
      anon_sym_for,
    ACTIONS(3688), 1,
      anon_sym_while,
    ACTIONS(3690), 1,
      anon_sym_repeat,
    ACTIONS(3692), 1,
      anon_sym_QMARK,
    ACTIONS(3694), 1,
      anon_sym_TILDE,
    ACTIONS(3702), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3704), 1,
      sym__number_literal,
    ACTIONS(3706), 1,
      anon_sym_SQUOTE,
    ACTIONS(3708), 1,
      anon_sym_DQUOTE,
    ACTIONS(3718), 1,
      sym__raw_string_literal,
    ACTIONS(3720), 1,
      sym__external_open_parenthesis,
    ACTIONS(3722), 1,
      sym__external_open_brace,
    ACTIONS(8593), 1,
      anon_sym_BANG,
    ACTIONS(8757), 1,
      sym_dot_dot_i,
    ACTIONS(8759), 1,
      sym__newline,
    STATE(29), 1,
      sym__open_brace,
    STATE(191), 1,
      sym__open_parenthesis,
    STATE(2378), 1,
      sym_string,
    STATE(2382), 1,
      sym__single_quoted_string,
    STATE(2383), 1,
      sym__double_quoted_string,
    STATE(3260), 1,
      aux_sym_function_definition_repeat1,
    STATE(5153), 1,
      sym__string_or_identifier,
    ACTIONS(3698), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2381), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3712), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8755), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1510), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [24768] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3678), 1,
      sym_identifier,
    ACTIONS(3680), 1,
      anon_sym_BSLASH,
    ACTIONS(3682), 1,
      anon_sym_function,
    ACTIONS(3684), 1,
      anon_sym_if,
    ACTIONS(3686), 1,
      anon_sym_for,
    ACTIONS(3688), 1,
      anon_sym_while,
    ACTIONS(3690), 1,
      anon_sym_repeat,
    ACTIONS(3692), 1,
      anon_sym_QMARK,
    ACTIONS(3694), 1,
      anon_sym_TILDE,
    ACTIONS(3702), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3704), 1,
      sym__number_literal,
    ACTIONS(3706), 1,
      anon_sym_SQUOTE,
    ACTIONS(3708), 1,
      anon_sym_DQUOTE,
    ACTIONS(3718), 1,
      sym__raw_string_literal,
    ACTIONS(3720), 1,
      sym__external_open_parenthesis,
    ACTIONS(3722), 1,
      sym__external_open_brace,
    ACTIONS(8593), 1,
      anon_sym_BANG,
    ACTIONS(8763), 1,
      sym_dot_dot_i,
    ACTIONS(8765), 1,
      sym__newline,
    STATE(29), 1,
      sym__open_brace,
    STATE(191), 1,
      sym__open_parenthesis,
    STATE(2378), 1,
      sym_string,
    STATE(2382), 1,
      sym__single_quoted_string,
    STATE(2383), 1,
      sym__double_quoted_string,
    STATE(3262), 1,
      aux_sym_function_definition_repeat1,
    STATE(5153), 1,
      sym__string_or_identifier,
    ACTIONS(3698), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2381), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3712), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8761), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1509), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [24897] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3678), 1,
      sym_identifier,
    ACTIONS(3680), 1,
      anon_sym_BSLASH,
    ACTIONS(3682), 1,
      anon_sym_function,
    ACTIONS(3684), 1,
      anon_sym_if,
    ACTIONS(3686), 1,
      anon_sym_for,
    ACTIONS(3688), 1,
      anon_sym_while,
    ACTIONS(3690), 1,
      anon_sym_repeat,
    ACTIONS(3692), 1,
      anon_sym_QMARK,
    ACTIONS(3694), 1,
      anon_sym_TILDE,
    ACTIONS(3702), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3704), 1,
      sym__number_literal,
    ACTIONS(3706), 1,
      anon_sym_SQUOTE,
    ACTIONS(3708), 1,
      anon_sym_DQUOTE,
    ACTIONS(3718), 1,
      sym__raw_string_literal,
    ACTIONS(3720), 1,
      sym__external_open_parenthesis,
    ACTIONS(3722), 1,
      sym__external_open_brace,
    ACTIONS(8593), 1,
      anon_sym_BANG,
    ACTIONS(8769), 1,
      sym_dot_dot_i,
    ACTIONS(8771), 1,
      sym__newline,
    STATE(29), 1,
      sym__open_brace,
    STATE(191), 1,
      sym__open_parenthesis,
    STATE(2378), 1,
      sym_string,
    STATE(2382), 1,
      sym__single_quoted_string,
    STATE(2383), 1,
      sym__double_quoted_string,
    STATE(3264), 1,
      aux_sym_function_definition_repeat1,
    STATE(5153), 1,
      sym__string_or_identifier,
    ACTIONS(3698), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2381), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3712), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8767), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1508), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [25026] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3678), 1,
      sym_identifier,
    ACTIONS(3680), 1,
      anon_sym_BSLASH,
    ACTIONS(3682), 1,
      anon_sym_function,
    ACTIONS(3684), 1,
      anon_sym_if,
    ACTIONS(3686), 1,
      anon_sym_for,
    ACTIONS(3688), 1,
      anon_sym_while,
    ACTIONS(3690), 1,
      anon_sym_repeat,
    ACTIONS(3692), 1,
      anon_sym_QMARK,
    ACTIONS(3694), 1,
      anon_sym_TILDE,
    ACTIONS(3702), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3704), 1,
      sym__number_literal,
    ACTIONS(3706), 1,
      anon_sym_SQUOTE,
    ACTIONS(3708), 1,
      anon_sym_DQUOTE,
    ACTIONS(3718), 1,
      sym__raw_string_literal,
    ACTIONS(3720), 1,
      sym__external_open_parenthesis,
    ACTIONS(3722), 1,
      sym__external_open_brace,
    ACTIONS(8593), 1,
      anon_sym_BANG,
    ACTIONS(8775), 1,
      sym_dot_dot_i,
    ACTIONS(8777), 1,
      sym__newline,
    STATE(29), 1,
      sym__open_brace,
    STATE(191), 1,
      sym__open_parenthesis,
    STATE(2378), 1,
      sym_string,
    STATE(2382), 1,
      sym__single_quoted_string,
    STATE(2383), 1,
      sym__double_quoted_string,
    STATE(3266), 1,
      aux_sym_function_definition_repeat1,
    STATE(5153), 1,
      sym__string_or_identifier,
    ACTIONS(3698), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2381), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3712), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8773), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1507), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [25155] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3678), 1,
      sym_identifier,
    ACTIONS(3680), 1,
      anon_sym_BSLASH,
    ACTIONS(3682), 1,
      anon_sym_function,
    ACTIONS(3684), 1,
      anon_sym_if,
    ACTIONS(3686), 1,
      anon_sym_for,
    ACTIONS(3688), 1,
      anon_sym_while,
    ACTIONS(3690), 1,
      anon_sym_repeat,
    ACTIONS(3692), 1,
      anon_sym_QMARK,
    ACTIONS(3694), 1,
      anon_sym_TILDE,
    ACTIONS(3702), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3704), 1,
      sym__number_literal,
    ACTIONS(3706), 1,
      anon_sym_SQUOTE,
    ACTIONS(3708), 1,
      anon_sym_DQUOTE,
    ACTIONS(3718), 1,
      sym__raw_string_literal,
    ACTIONS(3720), 1,
      sym__external_open_parenthesis,
    ACTIONS(3722), 1,
      sym__external_open_brace,
    ACTIONS(8593), 1,
      anon_sym_BANG,
    ACTIONS(8781), 1,
      sym_dot_dot_i,
    ACTIONS(8783), 1,
      sym__newline,
    STATE(29), 1,
      sym__open_brace,
    STATE(191), 1,
      sym__open_parenthesis,
    STATE(2378), 1,
      sym_string,
    STATE(2382), 1,
      sym__single_quoted_string,
    STATE(2383), 1,
      sym__double_quoted_string,
    STATE(3268), 1,
      aux_sym_function_definition_repeat1,
    STATE(5153), 1,
      sym__string_or_identifier,
    ACTIONS(3698), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2381), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3712), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8779), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1506), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [25284] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2943), 1,
      sym_identifier,
    ACTIONS(2945), 1,
      anon_sym_BSLASH,
    ACTIONS(2947), 1,
      anon_sym_function,
    ACTIONS(2949), 1,
      anon_sym_if,
    ACTIONS(2951), 1,
      anon_sym_for,
    ACTIONS(2953), 1,
      anon_sym_while,
    ACTIONS(2955), 1,
      anon_sym_repeat,
    ACTIONS(2957), 1,
      anon_sym_QMARK,
    ACTIONS(2959), 1,
      anon_sym_TILDE,
    ACTIONS(2967), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2969), 1,
      sym__number_literal,
    ACTIONS(2971), 1,
      anon_sym_SQUOTE,
    ACTIONS(2973), 1,
      anon_sym_DQUOTE,
    ACTIONS(2983), 1,
      sym__raw_string_literal,
    ACTIONS(2985), 1,
      sym__external_open_parenthesis,
    ACTIONS(2989), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7797), 1,
      anon_sym_BANG,
    ACTIONS(8787), 1,
      sym_dot_dot_i,
    STATE(173), 1,
      sym__open_brace,
    STATE(246), 1,
      sym__open_parenthesis,
    STATE(2462), 1,
      sym__single_quoted_string,
    STATE(2494), 1,
      sym__double_quoted_string,
    STATE(2541), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5128), 1,
      sym__string_or_identifier,
    ACTIONS(2963), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2540), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2977), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8785), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1822), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [25413] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1433), 1,
      sym_identifier,
    ACTIONS(1435), 1,
      anon_sym_BSLASH,
    ACTIONS(1437), 1,
      anon_sym_function,
    ACTIONS(1439), 1,
      anon_sym_if,
    ACTIONS(1441), 1,
      anon_sym_for,
    ACTIONS(1443), 1,
      anon_sym_while,
    ACTIONS(1445), 1,
      anon_sym_repeat,
    ACTIONS(1447), 1,
      anon_sym_QMARK,
    ACTIONS(1449), 1,
      anon_sym_TILDE,
    ACTIONS(1457), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1459), 1,
      sym__number_literal,
    ACTIONS(1461), 1,
      anon_sym_SQUOTE,
    ACTIONS(1463), 1,
      anon_sym_DQUOTE,
    ACTIONS(1473), 1,
      sym__raw_string_literal,
    ACTIONS(1475), 1,
      sym__external_open_parenthesis,
    ACTIONS(1477), 1,
      sym__external_open_brace,
    ACTIONS(8097), 1,
      anon_sym_BANG,
    ACTIONS(8791), 1,
      sym_dot_dot_i,
    ACTIONS(8793), 1,
      sym__newline,
    STATE(76), 1,
      sym__open_parenthesis,
    STATE(188), 1,
      sym__open_brace,
    STATE(2234), 1,
      sym_string,
    STATE(2236), 1,
      sym__single_quoted_string,
    STATE(2237), 1,
      sym__double_quoted_string,
    STATE(3324), 1,
      aux_sym_function_definition_repeat1,
    STATE(5150), 1,
      sym__string_or_identifier,
    ACTIONS(1453), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2235), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1467), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8789), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1121), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [25542] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1433), 1,
      sym_identifier,
    ACTIONS(1435), 1,
      anon_sym_BSLASH,
    ACTIONS(1437), 1,
      anon_sym_function,
    ACTIONS(1439), 1,
      anon_sym_if,
    ACTIONS(1441), 1,
      anon_sym_for,
    ACTIONS(1443), 1,
      anon_sym_while,
    ACTIONS(1445), 1,
      anon_sym_repeat,
    ACTIONS(1447), 1,
      anon_sym_QMARK,
    ACTIONS(1449), 1,
      anon_sym_TILDE,
    ACTIONS(1457), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1459), 1,
      sym__number_literal,
    ACTIONS(1461), 1,
      anon_sym_SQUOTE,
    ACTIONS(1463), 1,
      anon_sym_DQUOTE,
    ACTIONS(1473), 1,
      sym__raw_string_literal,
    ACTIONS(1475), 1,
      sym__external_open_parenthesis,
    ACTIONS(1477), 1,
      sym__external_open_brace,
    ACTIONS(8097), 1,
      anon_sym_BANG,
    ACTIONS(8797), 1,
      sym_dot_dot_i,
    ACTIONS(8799), 1,
      sym__newline,
    STATE(76), 1,
      sym__open_parenthesis,
    STATE(188), 1,
      sym__open_brace,
    STATE(2234), 1,
      sym_string,
    STATE(2236), 1,
      sym__single_quoted_string,
    STATE(2237), 1,
      sym__double_quoted_string,
    STATE(3329), 1,
      aux_sym_function_definition_repeat1,
    STATE(5150), 1,
      sym__string_or_identifier,
    ACTIONS(1453), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2235), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1467), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8795), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1120), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [25671] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1433), 1,
      sym_identifier,
    ACTIONS(1435), 1,
      anon_sym_BSLASH,
    ACTIONS(1437), 1,
      anon_sym_function,
    ACTIONS(1439), 1,
      anon_sym_if,
    ACTIONS(1441), 1,
      anon_sym_for,
    ACTIONS(1443), 1,
      anon_sym_while,
    ACTIONS(1445), 1,
      anon_sym_repeat,
    ACTIONS(1447), 1,
      anon_sym_QMARK,
    ACTIONS(1449), 1,
      anon_sym_TILDE,
    ACTIONS(1457), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1459), 1,
      sym__number_literal,
    ACTIONS(1461), 1,
      anon_sym_SQUOTE,
    ACTIONS(1463), 1,
      anon_sym_DQUOTE,
    ACTIONS(1473), 1,
      sym__raw_string_literal,
    ACTIONS(1475), 1,
      sym__external_open_parenthesis,
    ACTIONS(1477), 1,
      sym__external_open_brace,
    ACTIONS(8097), 1,
      anon_sym_BANG,
    ACTIONS(8803), 1,
      sym_dot_dot_i,
    ACTIONS(8805), 1,
      sym__newline,
    STATE(76), 1,
      sym__open_parenthesis,
    STATE(188), 1,
      sym__open_brace,
    STATE(2234), 1,
      sym_string,
    STATE(2236), 1,
      sym__single_quoted_string,
    STATE(2237), 1,
      sym__double_quoted_string,
    STATE(3330), 1,
      aux_sym_function_definition_repeat1,
    STATE(5150), 1,
      sym__string_or_identifier,
    ACTIONS(1453), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2235), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1467), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8801), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1119), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [25800] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1433), 1,
      sym_identifier,
    ACTIONS(1435), 1,
      anon_sym_BSLASH,
    ACTIONS(1437), 1,
      anon_sym_function,
    ACTIONS(1439), 1,
      anon_sym_if,
    ACTIONS(1441), 1,
      anon_sym_for,
    ACTIONS(1443), 1,
      anon_sym_while,
    ACTIONS(1445), 1,
      anon_sym_repeat,
    ACTIONS(1447), 1,
      anon_sym_QMARK,
    ACTIONS(1449), 1,
      anon_sym_TILDE,
    ACTIONS(1457), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1459), 1,
      sym__number_literal,
    ACTIONS(1461), 1,
      anon_sym_SQUOTE,
    ACTIONS(1463), 1,
      anon_sym_DQUOTE,
    ACTIONS(1473), 1,
      sym__raw_string_literal,
    ACTIONS(1475), 1,
      sym__external_open_parenthesis,
    ACTIONS(1477), 1,
      sym__external_open_brace,
    ACTIONS(8097), 1,
      anon_sym_BANG,
    ACTIONS(8809), 1,
      sym_dot_dot_i,
    ACTIONS(8811), 1,
      sym__newline,
    STATE(76), 1,
      sym__open_parenthesis,
    STATE(188), 1,
      sym__open_brace,
    STATE(2234), 1,
      sym_string,
    STATE(2236), 1,
      sym__single_quoted_string,
    STATE(2237), 1,
      sym__double_quoted_string,
    STATE(3332), 1,
      aux_sym_function_definition_repeat1,
    STATE(5150), 1,
      sym__string_or_identifier,
    ACTIONS(1453), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2235), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1467), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8807), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1118), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [25929] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1433), 1,
      sym_identifier,
    ACTIONS(1435), 1,
      anon_sym_BSLASH,
    ACTIONS(1437), 1,
      anon_sym_function,
    ACTIONS(1439), 1,
      anon_sym_if,
    ACTIONS(1441), 1,
      anon_sym_for,
    ACTIONS(1443), 1,
      anon_sym_while,
    ACTIONS(1445), 1,
      anon_sym_repeat,
    ACTIONS(1447), 1,
      anon_sym_QMARK,
    ACTIONS(1449), 1,
      anon_sym_TILDE,
    ACTIONS(1457), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1459), 1,
      sym__number_literal,
    ACTIONS(1461), 1,
      anon_sym_SQUOTE,
    ACTIONS(1463), 1,
      anon_sym_DQUOTE,
    ACTIONS(1473), 1,
      sym__raw_string_literal,
    ACTIONS(1475), 1,
      sym__external_open_parenthesis,
    ACTIONS(1477), 1,
      sym__external_open_brace,
    ACTIONS(8097), 1,
      anon_sym_BANG,
    ACTIONS(8815), 1,
      sym_dot_dot_i,
    ACTIONS(8817), 1,
      sym__newline,
    STATE(76), 1,
      sym__open_parenthesis,
    STATE(188), 1,
      sym__open_brace,
    STATE(2234), 1,
      sym_string,
    STATE(2236), 1,
      sym__single_quoted_string,
    STATE(2237), 1,
      sym__double_quoted_string,
    STATE(3333), 1,
      aux_sym_function_definition_repeat1,
    STATE(5150), 1,
      sym__string_or_identifier,
    ACTIONS(1453), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2235), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1467), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8813), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1117), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [26058] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1433), 1,
      sym_identifier,
    ACTIONS(1435), 1,
      anon_sym_BSLASH,
    ACTIONS(1437), 1,
      anon_sym_function,
    ACTIONS(1439), 1,
      anon_sym_if,
    ACTIONS(1441), 1,
      anon_sym_for,
    ACTIONS(1443), 1,
      anon_sym_while,
    ACTIONS(1445), 1,
      anon_sym_repeat,
    ACTIONS(1447), 1,
      anon_sym_QMARK,
    ACTIONS(1449), 1,
      anon_sym_TILDE,
    ACTIONS(1457), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1459), 1,
      sym__number_literal,
    ACTIONS(1461), 1,
      anon_sym_SQUOTE,
    ACTIONS(1463), 1,
      anon_sym_DQUOTE,
    ACTIONS(1473), 1,
      sym__raw_string_literal,
    ACTIONS(1475), 1,
      sym__external_open_parenthesis,
    ACTIONS(1477), 1,
      sym__external_open_brace,
    ACTIONS(8097), 1,
      anon_sym_BANG,
    ACTIONS(8821), 1,
      sym_dot_dot_i,
    ACTIONS(8823), 1,
      sym__newline,
    STATE(76), 1,
      sym__open_parenthesis,
    STATE(188), 1,
      sym__open_brace,
    STATE(2234), 1,
      sym_string,
    STATE(2236), 1,
      sym__single_quoted_string,
    STATE(2237), 1,
      sym__double_quoted_string,
    STATE(3334), 1,
      aux_sym_function_definition_repeat1,
    STATE(5150), 1,
      sym__string_or_identifier,
    ACTIONS(1453), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2235), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1467), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8819), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1116), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [26187] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1433), 1,
      sym_identifier,
    ACTIONS(1435), 1,
      anon_sym_BSLASH,
    ACTIONS(1437), 1,
      anon_sym_function,
    ACTIONS(1439), 1,
      anon_sym_if,
    ACTIONS(1441), 1,
      anon_sym_for,
    ACTIONS(1443), 1,
      anon_sym_while,
    ACTIONS(1445), 1,
      anon_sym_repeat,
    ACTIONS(1447), 1,
      anon_sym_QMARK,
    ACTIONS(1449), 1,
      anon_sym_TILDE,
    ACTIONS(1457), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1459), 1,
      sym__number_literal,
    ACTIONS(1461), 1,
      anon_sym_SQUOTE,
    ACTIONS(1463), 1,
      anon_sym_DQUOTE,
    ACTIONS(1473), 1,
      sym__raw_string_literal,
    ACTIONS(1475), 1,
      sym__external_open_parenthesis,
    ACTIONS(1477), 1,
      sym__external_open_brace,
    ACTIONS(8097), 1,
      anon_sym_BANG,
    ACTIONS(8827), 1,
      sym_dot_dot_i,
    ACTIONS(8829), 1,
      sym__newline,
    STATE(76), 1,
      sym__open_parenthesis,
    STATE(188), 1,
      sym__open_brace,
    STATE(2234), 1,
      sym_string,
    STATE(2236), 1,
      sym__single_quoted_string,
    STATE(2237), 1,
      sym__double_quoted_string,
    STATE(3335), 1,
      aux_sym_function_definition_repeat1,
    STATE(5150), 1,
      sym__string_or_identifier,
    ACTIONS(1453), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2235), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1467), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8825), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1115), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [26316] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      sym_identifier,
    ACTIONS(55), 1,
      anon_sym_BSLASH,
    ACTIONS(57), 1,
      anon_sym_function,
    ACTIONS(61), 1,
      anon_sym_if,
    ACTIONS(63), 1,
      anon_sym_for,
    ACTIONS(65), 1,
      anon_sym_while,
    ACTIONS(67), 1,
      anon_sym_repeat,
    ACTIONS(69), 1,
      anon_sym_QMARK,
    ACTIONS(71), 1,
      anon_sym_TILDE,
    ACTIONS(79), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(81), 1,
      sym__number_literal,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE,
    ACTIONS(95), 1,
      sym__raw_string_literal,
    ACTIONS(97), 1,
      sym__external_open_parenthesis,
    ACTIONS(99), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8831), 1,
      anon_sym_BANG,
    ACTIONS(8835), 1,
      sym_dot_dot_i,
    STATE(4), 1,
      sym__open_brace,
    STATE(19), 1,
      sym__open_parenthesis,
    STATE(1982), 1,
      sym_string,
    STATE(1985), 1,
      sym__single_quoted_string,
    STATE(1990), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5151), 1,
      sym__string_or_identifier,
    ACTIONS(75), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1984), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(89), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8833), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(551), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [26445] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3491), 1,
      sym_identifier,
    ACTIONS(3493), 1,
      anon_sym_BSLASH,
    ACTIONS(3495), 1,
      anon_sym_function,
    ACTIONS(3497), 1,
      anon_sym_if,
    ACTIONS(3499), 1,
      anon_sym_for,
    ACTIONS(3501), 1,
      anon_sym_while,
    ACTIONS(3503), 1,
      anon_sym_repeat,
    ACTIONS(3505), 1,
      anon_sym_QMARK,
    ACTIONS(3507), 1,
      anon_sym_TILDE,
    ACTIONS(3515), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3517), 1,
      sym__number_literal,
    ACTIONS(3519), 1,
      anon_sym_SQUOTE,
    ACTIONS(3521), 1,
      anon_sym_DQUOTE,
    ACTIONS(3531), 1,
      sym__raw_string_literal,
    ACTIONS(3533), 1,
      sym__external_open_parenthesis,
    ACTIONS(3535), 1,
      sym__external_open_brace,
    ACTIONS(7789), 1,
      anon_sym_BANG,
    ACTIONS(8839), 1,
      sym_dot_dot_i,
    ACTIONS(8841), 1,
      sym__newline,
    STATE(63), 1,
      sym__open_brace,
    STATE(147), 1,
      sym__open_parenthesis,
    STATE(2441), 1,
      sym_string,
    STATE(2456), 1,
      sym__single_quoted_string,
    STATE(2478), 1,
      sym__double_quoted_string,
    STATE(3211), 1,
      aux_sym_function_definition_repeat1,
    STATE(5130), 1,
      sym__string_or_identifier,
    ACTIONS(3511), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2448), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3525), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8837), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1291), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [26574] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1433), 1,
      sym_identifier,
    ACTIONS(1435), 1,
      anon_sym_BSLASH,
    ACTIONS(1437), 1,
      anon_sym_function,
    ACTIONS(1439), 1,
      anon_sym_if,
    ACTIONS(1441), 1,
      anon_sym_for,
    ACTIONS(1443), 1,
      anon_sym_while,
    ACTIONS(1445), 1,
      anon_sym_repeat,
    ACTIONS(1447), 1,
      anon_sym_QMARK,
    ACTIONS(1449), 1,
      anon_sym_TILDE,
    ACTIONS(1457), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1459), 1,
      sym__number_literal,
    ACTIONS(1461), 1,
      anon_sym_SQUOTE,
    ACTIONS(1463), 1,
      anon_sym_DQUOTE,
    ACTIONS(1473), 1,
      sym__raw_string_literal,
    ACTIONS(1475), 1,
      sym__external_open_parenthesis,
    ACTIONS(1477), 1,
      sym__external_open_brace,
    ACTIONS(8097), 1,
      anon_sym_BANG,
    ACTIONS(8845), 1,
      sym_dot_dot_i,
    ACTIONS(8847), 1,
      sym__newline,
    STATE(76), 1,
      sym__open_parenthesis,
    STATE(188), 1,
      sym__open_brace,
    STATE(2234), 1,
      sym_string,
    STATE(2236), 1,
      sym__single_quoted_string,
    STATE(2237), 1,
      sym__double_quoted_string,
    STATE(3346), 1,
      aux_sym_function_definition_repeat1,
    STATE(5150), 1,
      sym__string_or_identifier,
    ACTIONS(1453), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2235), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1467), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8843), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1114), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [26703] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      sym_identifier,
    ACTIONS(55), 1,
      anon_sym_BSLASH,
    ACTIONS(57), 1,
      anon_sym_function,
    ACTIONS(61), 1,
      anon_sym_if,
    ACTIONS(63), 1,
      anon_sym_for,
    ACTIONS(65), 1,
      anon_sym_while,
    ACTIONS(67), 1,
      anon_sym_repeat,
    ACTIONS(69), 1,
      anon_sym_QMARK,
    ACTIONS(71), 1,
      anon_sym_TILDE,
    ACTIONS(79), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(81), 1,
      sym__number_literal,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE,
    ACTIONS(95), 1,
      sym__raw_string_literal,
    ACTIONS(97), 1,
      sym__external_open_parenthesis,
    ACTIONS(99), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8831), 1,
      anon_sym_BANG,
    ACTIONS(8851), 1,
      sym_dot_dot_i,
    STATE(4), 1,
      sym__open_brace,
    STATE(19), 1,
      sym__open_parenthesis,
    STATE(1982), 1,
      sym_string,
    STATE(1985), 1,
      sym__single_quoted_string,
    STATE(1990), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5151), 1,
      sym__string_or_identifier,
    ACTIONS(75), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1984), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(89), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8849), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(550), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [26832] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2425), 1,
      sym_identifier,
    ACTIONS(2427), 1,
      anon_sym_BSLASH,
    ACTIONS(2429), 1,
      anon_sym_function,
    ACTIONS(2431), 1,
      anon_sym_if,
    ACTIONS(2433), 1,
      anon_sym_for,
    ACTIONS(2435), 1,
      anon_sym_while,
    ACTIONS(2437), 1,
      anon_sym_repeat,
    ACTIONS(2439), 1,
      anon_sym_QMARK,
    ACTIONS(2441), 1,
      anon_sym_TILDE,
    ACTIONS(2449), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2451), 1,
      sym__number_literal,
    ACTIONS(2453), 1,
      anon_sym_SQUOTE,
    ACTIONS(2455), 1,
      anon_sym_DQUOTE,
    ACTIONS(2465), 1,
      sym__raw_string_literal,
    ACTIONS(2467), 1,
      sym__external_open_parenthesis,
    ACTIONS(2471), 1,
      sym__external_open_brace,
    ACTIONS(7781), 1,
      anon_sym_BANG,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8855), 1,
      sym_dot_dot_i,
    STATE(97), 1,
      sym__open_brace,
    STATE(200), 1,
      sym__open_parenthesis,
    STATE(2369), 1,
      sym__double_quoted_string,
    STATE(2370), 1,
      sym__single_quoted_string,
    STATE(2372), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5138), 1,
      sym__string_or_identifier,
    ACTIONS(2445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2371), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8853), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1290), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [26961] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      sym_identifier,
    ACTIONS(55), 1,
      anon_sym_BSLASH,
    ACTIONS(57), 1,
      anon_sym_function,
    ACTIONS(61), 1,
      anon_sym_if,
    ACTIONS(63), 1,
      anon_sym_for,
    ACTIONS(65), 1,
      anon_sym_while,
    ACTIONS(67), 1,
      anon_sym_repeat,
    ACTIONS(69), 1,
      anon_sym_QMARK,
    ACTIONS(71), 1,
      anon_sym_TILDE,
    ACTIONS(79), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(81), 1,
      sym__number_literal,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE,
    ACTIONS(95), 1,
      sym__raw_string_literal,
    ACTIONS(97), 1,
      sym__external_open_parenthesis,
    ACTIONS(99), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8831), 1,
      anon_sym_BANG,
    ACTIONS(8859), 1,
      sym_dot_dot_i,
    STATE(4), 1,
      sym__open_brace,
    STATE(19), 1,
      sym__open_parenthesis,
    STATE(1982), 1,
      sym_string,
    STATE(1985), 1,
      sym__single_quoted_string,
    STATE(1990), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5151), 1,
      sym__string_or_identifier,
    ACTIONS(75), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1984), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(89), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8857), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(549), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [27090] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      sym_identifier,
    ACTIONS(55), 1,
      anon_sym_BSLASH,
    ACTIONS(57), 1,
      anon_sym_function,
    ACTIONS(61), 1,
      anon_sym_if,
    ACTIONS(63), 1,
      anon_sym_for,
    ACTIONS(65), 1,
      anon_sym_while,
    ACTIONS(67), 1,
      anon_sym_repeat,
    ACTIONS(69), 1,
      anon_sym_QMARK,
    ACTIONS(71), 1,
      anon_sym_TILDE,
    ACTIONS(79), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(81), 1,
      sym__number_literal,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE,
    ACTIONS(95), 1,
      sym__raw_string_literal,
    ACTIONS(97), 1,
      sym__external_open_parenthesis,
    ACTIONS(99), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8831), 1,
      anon_sym_BANG,
    ACTIONS(8863), 1,
      sym_dot_dot_i,
    STATE(4), 1,
      sym__open_brace,
    STATE(19), 1,
      sym__open_parenthesis,
    STATE(1982), 1,
      sym_string,
    STATE(1985), 1,
      sym__single_quoted_string,
    STATE(1990), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5151), 1,
      sym__string_or_identifier,
    ACTIONS(75), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1984), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(89), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8861), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(548), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [27219] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      sym_identifier,
    ACTIONS(55), 1,
      anon_sym_BSLASH,
    ACTIONS(57), 1,
      anon_sym_function,
    ACTIONS(61), 1,
      anon_sym_if,
    ACTIONS(63), 1,
      anon_sym_for,
    ACTIONS(65), 1,
      anon_sym_while,
    ACTIONS(67), 1,
      anon_sym_repeat,
    ACTIONS(69), 1,
      anon_sym_QMARK,
    ACTIONS(71), 1,
      anon_sym_TILDE,
    ACTIONS(79), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(81), 1,
      sym__number_literal,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE,
    ACTIONS(95), 1,
      sym__raw_string_literal,
    ACTIONS(97), 1,
      sym__external_open_parenthesis,
    ACTIONS(99), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8831), 1,
      anon_sym_BANG,
    ACTIONS(8867), 1,
      sym_dot_dot_i,
    STATE(4), 1,
      sym__open_brace,
    STATE(19), 1,
      sym__open_parenthesis,
    STATE(1982), 1,
      sym_string,
    STATE(1985), 1,
      sym__single_quoted_string,
    STATE(1990), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5151), 1,
      sym__string_or_identifier,
    ACTIONS(75), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1984), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(89), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8865), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(547), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [27348] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      sym_identifier,
    ACTIONS(55), 1,
      anon_sym_BSLASH,
    ACTIONS(57), 1,
      anon_sym_function,
    ACTIONS(61), 1,
      anon_sym_if,
    ACTIONS(63), 1,
      anon_sym_for,
    ACTIONS(65), 1,
      anon_sym_while,
    ACTIONS(67), 1,
      anon_sym_repeat,
    ACTIONS(69), 1,
      anon_sym_QMARK,
    ACTIONS(71), 1,
      anon_sym_TILDE,
    ACTIONS(79), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(81), 1,
      sym__number_literal,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE,
    ACTIONS(95), 1,
      sym__raw_string_literal,
    ACTIONS(97), 1,
      sym__external_open_parenthesis,
    ACTIONS(99), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8831), 1,
      anon_sym_BANG,
    ACTIONS(8871), 1,
      sym_dot_dot_i,
    STATE(4), 1,
      sym__open_brace,
    STATE(19), 1,
      sym__open_parenthesis,
    STATE(1982), 1,
      sym_string,
    STATE(1985), 1,
      sym__single_quoted_string,
    STATE(1990), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5151), 1,
      sym__string_or_identifier,
    ACTIONS(75), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1984), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(89), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8869), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(546), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [27477] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      sym_identifier,
    ACTIONS(55), 1,
      anon_sym_BSLASH,
    ACTIONS(57), 1,
      anon_sym_function,
    ACTIONS(61), 1,
      anon_sym_if,
    ACTIONS(63), 1,
      anon_sym_for,
    ACTIONS(65), 1,
      anon_sym_while,
    ACTIONS(67), 1,
      anon_sym_repeat,
    ACTIONS(69), 1,
      anon_sym_QMARK,
    ACTIONS(71), 1,
      anon_sym_TILDE,
    ACTIONS(79), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(81), 1,
      sym__number_literal,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE,
    ACTIONS(95), 1,
      sym__raw_string_literal,
    ACTIONS(97), 1,
      sym__external_open_parenthesis,
    ACTIONS(99), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8831), 1,
      anon_sym_BANG,
    ACTIONS(8875), 1,
      sym_dot_dot_i,
    STATE(4), 1,
      sym__open_brace,
    STATE(19), 1,
      sym__open_parenthesis,
    STATE(1982), 1,
      sym_string,
    STATE(1985), 1,
      sym__single_quoted_string,
    STATE(1990), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5151), 1,
      sym__string_or_identifier,
    ACTIONS(75), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1984), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(89), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8873), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(545), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [27606] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      sym_identifier,
    ACTIONS(55), 1,
      anon_sym_BSLASH,
    ACTIONS(57), 1,
      anon_sym_function,
    ACTIONS(61), 1,
      anon_sym_if,
    ACTIONS(63), 1,
      anon_sym_for,
    ACTIONS(65), 1,
      anon_sym_while,
    ACTIONS(67), 1,
      anon_sym_repeat,
    ACTIONS(69), 1,
      anon_sym_QMARK,
    ACTIONS(71), 1,
      anon_sym_TILDE,
    ACTIONS(79), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(81), 1,
      sym__number_literal,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE,
    ACTIONS(95), 1,
      sym__raw_string_literal,
    ACTIONS(97), 1,
      sym__external_open_parenthesis,
    ACTIONS(99), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8831), 1,
      anon_sym_BANG,
    ACTIONS(8879), 1,
      sym_dot_dot_i,
    STATE(4), 1,
      sym__open_brace,
    STATE(19), 1,
      sym__open_parenthesis,
    STATE(1982), 1,
      sym_string,
    STATE(1985), 1,
      sym__single_quoted_string,
    STATE(1990), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5151), 1,
      sym__string_or_identifier,
    ACTIONS(75), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1984), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(89), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8877), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(508), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [27735] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1433), 1,
      sym_identifier,
    ACTIONS(1435), 1,
      anon_sym_BSLASH,
    ACTIONS(1437), 1,
      anon_sym_function,
    ACTIONS(1439), 1,
      anon_sym_if,
    ACTIONS(1441), 1,
      anon_sym_for,
    ACTIONS(1443), 1,
      anon_sym_while,
    ACTIONS(1445), 1,
      anon_sym_repeat,
    ACTIONS(1447), 1,
      anon_sym_QMARK,
    ACTIONS(1449), 1,
      anon_sym_TILDE,
    ACTIONS(1457), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1459), 1,
      sym__number_literal,
    ACTIONS(1461), 1,
      anon_sym_SQUOTE,
    ACTIONS(1463), 1,
      anon_sym_DQUOTE,
    ACTIONS(1473), 1,
      sym__raw_string_literal,
    ACTIONS(1475), 1,
      sym__external_open_parenthesis,
    ACTIONS(1477), 1,
      sym__external_open_brace,
    ACTIONS(8097), 1,
      anon_sym_BANG,
    ACTIONS(8883), 1,
      sym_dot_dot_i,
    ACTIONS(8885), 1,
      sym__newline,
    STATE(76), 1,
      sym__open_parenthesis,
    STATE(188), 1,
      sym__open_brace,
    STATE(2234), 1,
      sym_string,
    STATE(2236), 1,
      sym__single_quoted_string,
    STATE(2237), 1,
      sym__double_quoted_string,
    STATE(3156), 1,
      aux_sym_function_definition_repeat1,
    STATE(5150), 1,
      sym__string_or_identifier,
    ACTIONS(1453), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2235), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1467), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8881), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1136), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [27864] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3678), 1,
      sym_identifier,
    ACTIONS(3680), 1,
      anon_sym_BSLASH,
    ACTIONS(3682), 1,
      anon_sym_function,
    ACTIONS(3684), 1,
      anon_sym_if,
    ACTIONS(3686), 1,
      anon_sym_for,
    ACTIONS(3688), 1,
      anon_sym_while,
    ACTIONS(3690), 1,
      anon_sym_repeat,
    ACTIONS(3692), 1,
      anon_sym_QMARK,
    ACTIONS(3694), 1,
      anon_sym_TILDE,
    ACTIONS(3702), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3704), 1,
      sym__number_literal,
    ACTIONS(3706), 1,
      anon_sym_SQUOTE,
    ACTIONS(3708), 1,
      anon_sym_DQUOTE,
    ACTIONS(3718), 1,
      sym__raw_string_literal,
    ACTIONS(3720), 1,
      sym__external_open_parenthesis,
    ACTIONS(3722), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8593), 1,
      anon_sym_BANG,
    ACTIONS(8889), 1,
      sym_dot_dot_i,
    STATE(29), 1,
      sym__open_brace,
    STATE(191), 1,
      sym__open_parenthesis,
    STATE(2378), 1,
      sym_string,
    STATE(2382), 1,
      sym__single_quoted_string,
    STATE(2383), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5153), 1,
      sym__string_or_identifier,
    ACTIONS(3698), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2381), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3712), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8887), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1500), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [27993] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      sym_identifier,
    ACTIONS(55), 1,
      anon_sym_BSLASH,
    ACTIONS(57), 1,
      anon_sym_function,
    ACTIONS(61), 1,
      anon_sym_if,
    ACTIONS(63), 1,
      anon_sym_for,
    ACTIONS(65), 1,
      anon_sym_while,
    ACTIONS(67), 1,
      anon_sym_repeat,
    ACTIONS(69), 1,
      anon_sym_QMARK,
    ACTIONS(71), 1,
      anon_sym_TILDE,
    ACTIONS(79), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(81), 1,
      sym__number_literal,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE,
    ACTIONS(95), 1,
      sym__raw_string_literal,
    ACTIONS(97), 1,
      sym__external_open_parenthesis,
    ACTIONS(99), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8831), 1,
      anon_sym_BANG,
    ACTIONS(8893), 1,
      sym_dot_dot_i,
    STATE(4), 1,
      sym__open_brace,
    STATE(19), 1,
      sym__open_parenthesis,
    STATE(1982), 1,
      sym_string,
    STATE(1985), 1,
      sym__single_quoted_string,
    STATE(1990), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5151), 1,
      sym__string_or_identifier,
    ACTIONS(75), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1984), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(89), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8891), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(543), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [28122] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3678), 1,
      sym_identifier,
    ACTIONS(3680), 1,
      anon_sym_BSLASH,
    ACTIONS(3682), 1,
      anon_sym_function,
    ACTIONS(3684), 1,
      anon_sym_if,
    ACTIONS(3686), 1,
      anon_sym_for,
    ACTIONS(3688), 1,
      anon_sym_while,
    ACTIONS(3690), 1,
      anon_sym_repeat,
    ACTIONS(3692), 1,
      anon_sym_QMARK,
    ACTIONS(3694), 1,
      anon_sym_TILDE,
    ACTIONS(3702), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3704), 1,
      sym__number_literal,
    ACTIONS(3706), 1,
      anon_sym_SQUOTE,
    ACTIONS(3708), 1,
      anon_sym_DQUOTE,
    ACTIONS(3718), 1,
      sym__raw_string_literal,
    ACTIONS(3720), 1,
      sym__external_open_parenthesis,
    ACTIONS(3722), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8593), 1,
      anon_sym_BANG,
    ACTIONS(8897), 1,
      sym_dot_dot_i,
    STATE(29), 1,
      sym__open_brace,
    STATE(191), 1,
      sym__open_parenthesis,
    STATE(2378), 1,
      sym_string,
    STATE(2382), 1,
      sym__single_quoted_string,
    STATE(2383), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5153), 1,
      sym__string_or_identifier,
    ACTIONS(3698), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2381), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3712), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8895), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1499), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [28251] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      sym_identifier,
    ACTIONS(55), 1,
      anon_sym_BSLASH,
    ACTIONS(57), 1,
      anon_sym_function,
    ACTIONS(61), 1,
      anon_sym_if,
    ACTIONS(63), 1,
      anon_sym_for,
    ACTIONS(65), 1,
      anon_sym_while,
    ACTIONS(67), 1,
      anon_sym_repeat,
    ACTIONS(69), 1,
      anon_sym_QMARK,
    ACTIONS(71), 1,
      anon_sym_TILDE,
    ACTIONS(79), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(81), 1,
      sym__number_literal,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE,
    ACTIONS(95), 1,
      sym__raw_string_literal,
    ACTIONS(97), 1,
      sym__external_open_parenthesis,
    ACTIONS(99), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8831), 1,
      anon_sym_BANG,
    ACTIONS(8901), 1,
      sym_dot_dot_i,
    STATE(4), 1,
      sym__open_brace,
    STATE(19), 1,
      sym__open_parenthesis,
    STATE(1982), 1,
      sym_string,
    STATE(1985), 1,
      sym__single_quoted_string,
    STATE(1990), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5151), 1,
      sym__string_or_identifier,
    ACTIONS(75), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1984), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(89), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8899), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(541), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [28380] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3678), 1,
      sym_identifier,
    ACTIONS(3680), 1,
      anon_sym_BSLASH,
    ACTIONS(3682), 1,
      anon_sym_function,
    ACTIONS(3684), 1,
      anon_sym_if,
    ACTIONS(3686), 1,
      anon_sym_for,
    ACTIONS(3688), 1,
      anon_sym_while,
    ACTIONS(3690), 1,
      anon_sym_repeat,
    ACTIONS(3692), 1,
      anon_sym_QMARK,
    ACTIONS(3694), 1,
      anon_sym_TILDE,
    ACTIONS(3702), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3704), 1,
      sym__number_literal,
    ACTIONS(3706), 1,
      anon_sym_SQUOTE,
    ACTIONS(3708), 1,
      anon_sym_DQUOTE,
    ACTIONS(3718), 1,
      sym__raw_string_literal,
    ACTIONS(3720), 1,
      sym__external_open_parenthesis,
    ACTIONS(3722), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8593), 1,
      anon_sym_BANG,
    ACTIONS(8905), 1,
      sym_dot_dot_i,
    STATE(29), 1,
      sym__open_brace,
    STATE(191), 1,
      sym__open_parenthesis,
    STATE(2378), 1,
      sym_string,
    STATE(2382), 1,
      sym__single_quoted_string,
    STATE(2383), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5153), 1,
      sym__string_or_identifier,
    ACTIONS(3698), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2381), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3712), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8903), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1498), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [28509] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      sym_identifier,
    ACTIONS(55), 1,
      anon_sym_BSLASH,
    ACTIONS(57), 1,
      anon_sym_function,
    ACTIONS(61), 1,
      anon_sym_if,
    ACTIONS(63), 1,
      anon_sym_for,
    ACTIONS(65), 1,
      anon_sym_while,
    ACTIONS(67), 1,
      anon_sym_repeat,
    ACTIONS(69), 1,
      anon_sym_QMARK,
    ACTIONS(71), 1,
      anon_sym_TILDE,
    ACTIONS(79), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(81), 1,
      sym__number_literal,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE,
    ACTIONS(95), 1,
      sym__raw_string_literal,
    ACTIONS(97), 1,
      sym__external_open_parenthesis,
    ACTIONS(99), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8831), 1,
      anon_sym_BANG,
    ACTIONS(8909), 1,
      sym_dot_dot_i,
    STATE(4), 1,
      sym__open_brace,
    STATE(19), 1,
      sym__open_parenthesis,
    STATE(1982), 1,
      sym_string,
    STATE(1985), 1,
      sym__single_quoted_string,
    STATE(1990), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5151), 1,
      sym__string_or_identifier,
    ACTIONS(75), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1984), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(89), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8907), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(540), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [28638] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3678), 1,
      sym_identifier,
    ACTIONS(3680), 1,
      anon_sym_BSLASH,
    ACTIONS(3682), 1,
      anon_sym_function,
    ACTIONS(3684), 1,
      anon_sym_if,
    ACTIONS(3686), 1,
      anon_sym_for,
    ACTIONS(3688), 1,
      anon_sym_while,
    ACTIONS(3690), 1,
      anon_sym_repeat,
    ACTIONS(3692), 1,
      anon_sym_QMARK,
    ACTIONS(3694), 1,
      anon_sym_TILDE,
    ACTIONS(3702), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3704), 1,
      sym__number_literal,
    ACTIONS(3706), 1,
      anon_sym_SQUOTE,
    ACTIONS(3708), 1,
      anon_sym_DQUOTE,
    ACTIONS(3718), 1,
      sym__raw_string_literal,
    ACTIONS(3720), 1,
      sym__external_open_parenthesis,
    ACTIONS(3722), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8593), 1,
      anon_sym_BANG,
    ACTIONS(8913), 1,
      sym_dot_dot_i,
    STATE(29), 1,
      sym__open_brace,
    STATE(191), 1,
      sym__open_parenthesis,
    STATE(2378), 1,
      sym_string,
    STATE(2382), 1,
      sym__single_quoted_string,
    STATE(2383), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5153), 1,
      sym__string_or_identifier,
    ACTIONS(3698), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2381), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3712), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8911), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1497), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [28767] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      sym_identifier,
    ACTIONS(55), 1,
      anon_sym_BSLASH,
    ACTIONS(57), 1,
      anon_sym_function,
    ACTIONS(61), 1,
      anon_sym_if,
    ACTIONS(63), 1,
      anon_sym_for,
    ACTIONS(65), 1,
      anon_sym_while,
    ACTIONS(67), 1,
      anon_sym_repeat,
    ACTIONS(69), 1,
      anon_sym_QMARK,
    ACTIONS(71), 1,
      anon_sym_TILDE,
    ACTIONS(79), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(81), 1,
      sym__number_literal,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE,
    ACTIONS(95), 1,
      sym__raw_string_literal,
    ACTIONS(97), 1,
      sym__external_open_parenthesis,
    ACTIONS(99), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8831), 1,
      anon_sym_BANG,
    ACTIONS(8917), 1,
      sym_dot_dot_i,
    STATE(4), 1,
      sym__open_brace,
    STATE(19), 1,
      sym__open_parenthesis,
    STATE(1982), 1,
      sym_string,
    STATE(1985), 1,
      sym__single_quoted_string,
    STATE(1990), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5151), 1,
      sym__string_or_identifier,
    ACTIONS(75), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1984), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(89), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8915), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(539), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [28896] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3678), 1,
      sym_identifier,
    ACTIONS(3680), 1,
      anon_sym_BSLASH,
    ACTIONS(3682), 1,
      anon_sym_function,
    ACTIONS(3684), 1,
      anon_sym_if,
    ACTIONS(3686), 1,
      anon_sym_for,
    ACTIONS(3688), 1,
      anon_sym_while,
    ACTIONS(3690), 1,
      anon_sym_repeat,
    ACTIONS(3692), 1,
      anon_sym_QMARK,
    ACTIONS(3694), 1,
      anon_sym_TILDE,
    ACTIONS(3702), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3704), 1,
      sym__number_literal,
    ACTIONS(3706), 1,
      anon_sym_SQUOTE,
    ACTIONS(3708), 1,
      anon_sym_DQUOTE,
    ACTIONS(3718), 1,
      sym__raw_string_literal,
    ACTIONS(3720), 1,
      sym__external_open_parenthesis,
    ACTIONS(3722), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8593), 1,
      anon_sym_BANG,
    ACTIONS(8921), 1,
      sym_dot_dot_i,
    STATE(29), 1,
      sym__open_brace,
    STATE(191), 1,
      sym__open_parenthesis,
    STATE(2378), 1,
      sym_string,
    STATE(2382), 1,
      sym__single_quoted_string,
    STATE(2383), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5153), 1,
      sym__string_or_identifier,
    ACTIONS(3698), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2381), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3712), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8919), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1495), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [29025] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1289), 1,
      sym_identifier,
    ACTIONS(1291), 1,
      anon_sym_BSLASH,
    ACTIONS(1293), 1,
      anon_sym_function,
    ACTIONS(1295), 1,
      anon_sym_if,
    ACTIONS(1297), 1,
      anon_sym_for,
    ACTIONS(1299), 1,
      anon_sym_while,
    ACTIONS(1301), 1,
      anon_sym_repeat,
    ACTIONS(1303), 1,
      anon_sym_QMARK,
    ACTIONS(1305), 1,
      anon_sym_TILDE,
    ACTIONS(1313), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1315), 1,
      sym__number_literal,
    ACTIONS(1317), 1,
      anon_sym_SQUOTE,
    ACTIONS(1319), 1,
      anon_sym_DQUOTE,
    ACTIONS(1329), 1,
      sym__raw_string_literal,
    ACTIONS(1331), 1,
      sym__external_open_parenthesis,
    ACTIONS(1333), 1,
      sym__external_open_brace,
    ACTIONS(8531), 1,
      anon_sym_BANG,
    ACTIONS(8925), 1,
      sym_dot_dot_i,
    ACTIONS(8927), 1,
      sym__newline,
    STATE(23), 1,
      sym__open_parenthesis,
    STATE(180), 1,
      sym__open_brace,
    STATE(2264), 1,
      sym__double_quoted_string,
    STATE(2265), 1,
      sym__single_quoted_string,
    STATE(2284), 1,
      sym_string,
    STATE(3179), 1,
      aux_sym_function_definition_repeat1,
    STATE(5147), 1,
      sym__string_or_identifier,
    ACTIONS(1309), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2266), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1323), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8923), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1197), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [29154] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3678), 1,
      sym_identifier,
    ACTIONS(3680), 1,
      anon_sym_BSLASH,
    ACTIONS(3682), 1,
      anon_sym_function,
    ACTIONS(3684), 1,
      anon_sym_if,
    ACTIONS(3686), 1,
      anon_sym_for,
    ACTIONS(3688), 1,
      anon_sym_while,
    ACTIONS(3690), 1,
      anon_sym_repeat,
    ACTIONS(3692), 1,
      anon_sym_QMARK,
    ACTIONS(3694), 1,
      anon_sym_TILDE,
    ACTIONS(3702), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3704), 1,
      sym__number_literal,
    ACTIONS(3706), 1,
      anon_sym_SQUOTE,
    ACTIONS(3708), 1,
      anon_sym_DQUOTE,
    ACTIONS(3718), 1,
      sym__raw_string_literal,
    ACTIONS(3720), 1,
      sym__external_open_parenthesis,
    ACTIONS(3722), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8593), 1,
      anon_sym_BANG,
    ACTIONS(8931), 1,
      sym_dot_dot_i,
    STATE(29), 1,
      sym__open_brace,
    STATE(191), 1,
      sym__open_parenthesis,
    STATE(2378), 1,
      sym_string,
    STATE(2382), 1,
      sym__single_quoted_string,
    STATE(2383), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5153), 1,
      sym__string_or_identifier,
    ACTIONS(3698), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2381), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3712), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8929), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1493), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [29283] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1289), 1,
      sym_identifier,
    ACTIONS(1291), 1,
      anon_sym_BSLASH,
    ACTIONS(1293), 1,
      anon_sym_function,
    ACTIONS(1295), 1,
      anon_sym_if,
    ACTIONS(1297), 1,
      anon_sym_for,
    ACTIONS(1299), 1,
      anon_sym_while,
    ACTIONS(1301), 1,
      anon_sym_repeat,
    ACTIONS(1303), 1,
      anon_sym_QMARK,
    ACTIONS(1305), 1,
      anon_sym_TILDE,
    ACTIONS(1313), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1315), 1,
      sym__number_literal,
    ACTIONS(1317), 1,
      anon_sym_SQUOTE,
    ACTIONS(1319), 1,
      anon_sym_DQUOTE,
    ACTIONS(1329), 1,
      sym__raw_string_literal,
    ACTIONS(1331), 1,
      sym__external_open_parenthesis,
    ACTIONS(1333), 1,
      sym__external_open_brace,
    ACTIONS(8531), 1,
      anon_sym_BANG,
    ACTIONS(8935), 1,
      sym_dot_dot_i,
    ACTIONS(8937), 1,
      sym__newline,
    STATE(23), 1,
      sym__open_parenthesis,
    STATE(180), 1,
      sym__open_brace,
    STATE(2264), 1,
      sym__double_quoted_string,
    STATE(2265), 1,
      sym__single_quoted_string,
    STATE(2284), 1,
      sym_string,
    STATE(3181), 1,
      aux_sym_function_definition_repeat1,
    STATE(5147), 1,
      sym__string_or_identifier,
    ACTIONS(1309), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2266), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1323), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8933), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1217), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [29412] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3678), 1,
      sym_identifier,
    ACTIONS(3680), 1,
      anon_sym_BSLASH,
    ACTIONS(3682), 1,
      anon_sym_function,
    ACTIONS(3684), 1,
      anon_sym_if,
    ACTIONS(3686), 1,
      anon_sym_for,
    ACTIONS(3688), 1,
      anon_sym_while,
    ACTIONS(3690), 1,
      anon_sym_repeat,
    ACTIONS(3692), 1,
      anon_sym_QMARK,
    ACTIONS(3694), 1,
      anon_sym_TILDE,
    ACTIONS(3702), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3704), 1,
      sym__number_literal,
    ACTIONS(3706), 1,
      anon_sym_SQUOTE,
    ACTIONS(3708), 1,
      anon_sym_DQUOTE,
    ACTIONS(3718), 1,
      sym__raw_string_literal,
    ACTIONS(3720), 1,
      sym__external_open_parenthesis,
    ACTIONS(3722), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8593), 1,
      anon_sym_BANG,
    ACTIONS(8941), 1,
      sym_dot_dot_i,
    STATE(29), 1,
      sym__open_brace,
    STATE(191), 1,
      sym__open_parenthesis,
    STATE(2378), 1,
      sym_string,
    STATE(2382), 1,
      sym__single_quoted_string,
    STATE(2383), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5153), 1,
      sym__string_or_identifier,
    ACTIONS(3698), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2381), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3712), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8939), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1491), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [29541] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1289), 1,
      sym_identifier,
    ACTIONS(1291), 1,
      anon_sym_BSLASH,
    ACTIONS(1293), 1,
      anon_sym_function,
    ACTIONS(1295), 1,
      anon_sym_if,
    ACTIONS(1297), 1,
      anon_sym_for,
    ACTIONS(1299), 1,
      anon_sym_while,
    ACTIONS(1301), 1,
      anon_sym_repeat,
    ACTIONS(1303), 1,
      anon_sym_QMARK,
    ACTIONS(1305), 1,
      anon_sym_TILDE,
    ACTIONS(1313), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1315), 1,
      sym__number_literal,
    ACTIONS(1317), 1,
      anon_sym_SQUOTE,
    ACTIONS(1319), 1,
      anon_sym_DQUOTE,
    ACTIONS(1329), 1,
      sym__raw_string_literal,
    ACTIONS(1331), 1,
      sym__external_open_parenthesis,
    ACTIONS(1333), 1,
      sym__external_open_brace,
    ACTIONS(8531), 1,
      anon_sym_BANG,
    ACTIONS(8945), 1,
      sym_dot_dot_i,
    ACTIONS(8947), 1,
      sym__newline,
    STATE(23), 1,
      sym__open_parenthesis,
    STATE(180), 1,
      sym__open_brace,
    STATE(2264), 1,
      sym__double_quoted_string,
    STATE(2265), 1,
      sym__single_quoted_string,
    STATE(2284), 1,
      sym_string,
    STATE(3182), 1,
      aux_sym_function_definition_repeat1,
    STATE(5147), 1,
      sym__string_or_identifier,
    ACTIONS(1309), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2266), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1323), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8943), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1220), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [29670] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3678), 1,
      sym_identifier,
    ACTIONS(3680), 1,
      anon_sym_BSLASH,
    ACTIONS(3682), 1,
      anon_sym_function,
    ACTIONS(3684), 1,
      anon_sym_if,
    ACTIONS(3686), 1,
      anon_sym_for,
    ACTIONS(3688), 1,
      anon_sym_while,
    ACTIONS(3690), 1,
      anon_sym_repeat,
    ACTIONS(3692), 1,
      anon_sym_QMARK,
    ACTIONS(3694), 1,
      anon_sym_TILDE,
    ACTIONS(3702), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3704), 1,
      sym__number_literal,
    ACTIONS(3706), 1,
      anon_sym_SQUOTE,
    ACTIONS(3708), 1,
      anon_sym_DQUOTE,
    ACTIONS(3718), 1,
      sym__raw_string_literal,
    ACTIONS(3720), 1,
      sym__external_open_parenthesis,
    ACTIONS(3722), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8593), 1,
      anon_sym_BANG,
    ACTIONS(8951), 1,
      sym_dot_dot_i,
    STATE(29), 1,
      sym__open_brace,
    STATE(191), 1,
      sym__open_parenthesis,
    STATE(2378), 1,
      sym_string,
    STATE(2382), 1,
      sym__single_quoted_string,
    STATE(2383), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5153), 1,
      sym__string_or_identifier,
    ACTIONS(3698), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2381), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3712), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8949), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1486), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [29799] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1289), 1,
      sym_identifier,
    ACTIONS(1291), 1,
      anon_sym_BSLASH,
    ACTIONS(1293), 1,
      anon_sym_function,
    ACTIONS(1295), 1,
      anon_sym_if,
    ACTIONS(1297), 1,
      anon_sym_for,
    ACTIONS(1299), 1,
      anon_sym_while,
    ACTIONS(1301), 1,
      anon_sym_repeat,
    ACTIONS(1303), 1,
      anon_sym_QMARK,
    ACTIONS(1305), 1,
      anon_sym_TILDE,
    ACTIONS(1313), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1315), 1,
      sym__number_literal,
    ACTIONS(1317), 1,
      anon_sym_SQUOTE,
    ACTIONS(1319), 1,
      anon_sym_DQUOTE,
    ACTIONS(1329), 1,
      sym__raw_string_literal,
    ACTIONS(1331), 1,
      sym__external_open_parenthesis,
    ACTIONS(1333), 1,
      sym__external_open_brace,
    ACTIONS(8531), 1,
      anon_sym_BANG,
    ACTIONS(8955), 1,
      sym_dot_dot_i,
    ACTIONS(8957), 1,
      sym__newline,
    STATE(23), 1,
      sym__open_parenthesis,
    STATE(180), 1,
      sym__open_brace,
    STATE(2264), 1,
      sym__double_quoted_string,
    STATE(2265), 1,
      sym__single_quoted_string,
    STATE(2284), 1,
      sym_string,
    STATE(3183), 1,
      aux_sym_function_definition_repeat1,
    STATE(5147), 1,
      sym__string_or_identifier,
    ACTIONS(1309), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2266), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1323), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8953), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1221), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [29928] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3678), 1,
      sym_identifier,
    ACTIONS(3680), 1,
      anon_sym_BSLASH,
    ACTIONS(3682), 1,
      anon_sym_function,
    ACTIONS(3684), 1,
      anon_sym_if,
    ACTIONS(3686), 1,
      anon_sym_for,
    ACTIONS(3688), 1,
      anon_sym_while,
    ACTIONS(3690), 1,
      anon_sym_repeat,
    ACTIONS(3692), 1,
      anon_sym_QMARK,
    ACTIONS(3694), 1,
      anon_sym_TILDE,
    ACTIONS(3702), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3704), 1,
      sym__number_literal,
    ACTIONS(3706), 1,
      anon_sym_SQUOTE,
    ACTIONS(3708), 1,
      anon_sym_DQUOTE,
    ACTIONS(3718), 1,
      sym__raw_string_literal,
    ACTIONS(3720), 1,
      sym__external_open_parenthesis,
    ACTIONS(3722), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8593), 1,
      anon_sym_BANG,
    ACTIONS(8961), 1,
      sym_dot_dot_i,
    STATE(29), 1,
      sym__open_brace,
    STATE(191), 1,
      sym__open_parenthesis,
    STATE(2378), 1,
      sym_string,
    STATE(2382), 1,
      sym__single_quoted_string,
    STATE(2383), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5153), 1,
      sym__string_or_identifier,
    ACTIONS(3698), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2381), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3712), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8959), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1484), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [30057] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1289), 1,
      sym_identifier,
    ACTIONS(1291), 1,
      anon_sym_BSLASH,
    ACTIONS(1293), 1,
      anon_sym_function,
    ACTIONS(1295), 1,
      anon_sym_if,
    ACTIONS(1297), 1,
      anon_sym_for,
    ACTIONS(1299), 1,
      anon_sym_while,
    ACTIONS(1301), 1,
      anon_sym_repeat,
    ACTIONS(1303), 1,
      anon_sym_QMARK,
    ACTIONS(1305), 1,
      anon_sym_TILDE,
    ACTIONS(1313), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1315), 1,
      sym__number_literal,
    ACTIONS(1317), 1,
      anon_sym_SQUOTE,
    ACTIONS(1319), 1,
      anon_sym_DQUOTE,
    ACTIONS(1329), 1,
      sym__raw_string_literal,
    ACTIONS(1331), 1,
      sym__external_open_parenthesis,
    ACTIONS(1333), 1,
      sym__external_open_brace,
    ACTIONS(8531), 1,
      anon_sym_BANG,
    ACTIONS(8965), 1,
      sym_dot_dot_i,
    ACTIONS(8967), 1,
      sym__newline,
    STATE(23), 1,
      sym__open_parenthesis,
    STATE(180), 1,
      sym__open_brace,
    STATE(2264), 1,
      sym__double_quoted_string,
    STATE(2265), 1,
      sym__single_quoted_string,
    STATE(2284), 1,
      sym_string,
    STATE(3184), 1,
      aux_sym_function_definition_repeat1,
    STATE(5147), 1,
      sym__string_or_identifier,
    ACTIONS(1309), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2266), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1323), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8963), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1222), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [30186] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3678), 1,
      sym_identifier,
    ACTIONS(3680), 1,
      anon_sym_BSLASH,
    ACTIONS(3682), 1,
      anon_sym_function,
    ACTIONS(3684), 1,
      anon_sym_if,
    ACTIONS(3686), 1,
      anon_sym_for,
    ACTIONS(3688), 1,
      anon_sym_while,
    ACTIONS(3690), 1,
      anon_sym_repeat,
    ACTIONS(3692), 1,
      anon_sym_QMARK,
    ACTIONS(3694), 1,
      anon_sym_TILDE,
    ACTIONS(3702), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3704), 1,
      sym__number_literal,
    ACTIONS(3706), 1,
      anon_sym_SQUOTE,
    ACTIONS(3708), 1,
      anon_sym_DQUOTE,
    ACTIONS(3718), 1,
      sym__raw_string_literal,
    ACTIONS(3720), 1,
      sym__external_open_parenthesis,
    ACTIONS(3722), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8593), 1,
      anon_sym_BANG,
    ACTIONS(8971), 1,
      sym_dot_dot_i,
    STATE(29), 1,
      sym__open_brace,
    STATE(191), 1,
      sym__open_parenthesis,
    STATE(2378), 1,
      sym_string,
    STATE(2382), 1,
      sym__single_quoted_string,
    STATE(2383), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5153), 1,
      sym__string_or_identifier,
    ACTIONS(3698), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2381), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3712), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8969), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1483), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [30315] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1289), 1,
      sym_identifier,
    ACTIONS(1291), 1,
      anon_sym_BSLASH,
    ACTIONS(1293), 1,
      anon_sym_function,
    ACTIONS(1295), 1,
      anon_sym_if,
    ACTIONS(1297), 1,
      anon_sym_for,
    ACTIONS(1299), 1,
      anon_sym_while,
    ACTIONS(1301), 1,
      anon_sym_repeat,
    ACTIONS(1303), 1,
      anon_sym_QMARK,
    ACTIONS(1305), 1,
      anon_sym_TILDE,
    ACTIONS(1313), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1315), 1,
      sym__number_literal,
    ACTIONS(1317), 1,
      anon_sym_SQUOTE,
    ACTIONS(1319), 1,
      anon_sym_DQUOTE,
    ACTIONS(1329), 1,
      sym__raw_string_literal,
    ACTIONS(1331), 1,
      sym__external_open_parenthesis,
    ACTIONS(1333), 1,
      sym__external_open_brace,
    ACTIONS(8531), 1,
      anon_sym_BANG,
    ACTIONS(8975), 1,
      sym_dot_dot_i,
    ACTIONS(8977), 1,
      sym__newline,
    STATE(23), 1,
      sym__open_parenthesis,
    STATE(180), 1,
      sym__open_brace,
    STATE(2264), 1,
      sym__double_quoted_string,
    STATE(2265), 1,
      sym__single_quoted_string,
    STATE(2284), 1,
      sym_string,
    STATE(3185), 1,
      aux_sym_function_definition_repeat1,
    STATE(5147), 1,
      sym__string_or_identifier,
    ACTIONS(1309), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2266), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1323), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8973), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1226), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [30444] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3678), 1,
      sym_identifier,
    ACTIONS(3680), 1,
      anon_sym_BSLASH,
    ACTIONS(3682), 1,
      anon_sym_function,
    ACTIONS(3684), 1,
      anon_sym_if,
    ACTIONS(3686), 1,
      anon_sym_for,
    ACTIONS(3688), 1,
      anon_sym_while,
    ACTIONS(3690), 1,
      anon_sym_repeat,
    ACTIONS(3692), 1,
      anon_sym_QMARK,
    ACTIONS(3694), 1,
      anon_sym_TILDE,
    ACTIONS(3702), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3704), 1,
      sym__number_literal,
    ACTIONS(3706), 1,
      anon_sym_SQUOTE,
    ACTIONS(3708), 1,
      anon_sym_DQUOTE,
    ACTIONS(3718), 1,
      sym__raw_string_literal,
    ACTIONS(3720), 1,
      sym__external_open_parenthesis,
    ACTIONS(3722), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8593), 1,
      anon_sym_BANG,
    ACTIONS(8981), 1,
      sym_dot_dot_i,
    STATE(29), 1,
      sym__open_brace,
    STATE(191), 1,
      sym__open_parenthesis,
    STATE(2378), 1,
      sym_string,
    STATE(2382), 1,
      sym__single_quoted_string,
    STATE(2383), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5153), 1,
      sym__string_or_identifier,
    ACTIONS(3698), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2381), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3712), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8979), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1482), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [30573] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1289), 1,
      sym_identifier,
    ACTIONS(1291), 1,
      anon_sym_BSLASH,
    ACTIONS(1293), 1,
      anon_sym_function,
    ACTIONS(1295), 1,
      anon_sym_if,
    ACTIONS(1297), 1,
      anon_sym_for,
    ACTIONS(1299), 1,
      anon_sym_while,
    ACTIONS(1301), 1,
      anon_sym_repeat,
    ACTIONS(1303), 1,
      anon_sym_QMARK,
    ACTIONS(1305), 1,
      anon_sym_TILDE,
    ACTIONS(1313), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1315), 1,
      sym__number_literal,
    ACTIONS(1317), 1,
      anon_sym_SQUOTE,
    ACTIONS(1319), 1,
      anon_sym_DQUOTE,
    ACTIONS(1329), 1,
      sym__raw_string_literal,
    ACTIONS(1331), 1,
      sym__external_open_parenthesis,
    ACTIONS(1333), 1,
      sym__external_open_brace,
    ACTIONS(8531), 1,
      anon_sym_BANG,
    ACTIONS(8985), 1,
      sym_dot_dot_i,
    ACTIONS(8987), 1,
      sym__newline,
    STATE(23), 1,
      sym__open_parenthesis,
    STATE(180), 1,
      sym__open_brace,
    STATE(2264), 1,
      sym__double_quoted_string,
    STATE(2265), 1,
      sym__single_quoted_string,
    STATE(2284), 1,
      sym_string,
    STATE(3187), 1,
      aux_sym_function_definition_repeat1,
    STATE(5147), 1,
      sym__string_or_identifier,
    ACTIONS(1309), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2266), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1323), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8983), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1228), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [30702] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3678), 1,
      sym_identifier,
    ACTIONS(3680), 1,
      anon_sym_BSLASH,
    ACTIONS(3682), 1,
      anon_sym_function,
    ACTIONS(3684), 1,
      anon_sym_if,
    ACTIONS(3686), 1,
      anon_sym_for,
    ACTIONS(3688), 1,
      anon_sym_while,
    ACTIONS(3690), 1,
      anon_sym_repeat,
    ACTIONS(3692), 1,
      anon_sym_QMARK,
    ACTIONS(3694), 1,
      anon_sym_TILDE,
    ACTIONS(3702), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3704), 1,
      sym__number_literal,
    ACTIONS(3706), 1,
      anon_sym_SQUOTE,
    ACTIONS(3708), 1,
      anon_sym_DQUOTE,
    ACTIONS(3718), 1,
      sym__raw_string_literal,
    ACTIONS(3720), 1,
      sym__external_open_parenthesis,
    ACTIONS(3722), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8593), 1,
      anon_sym_BANG,
    ACTIONS(8991), 1,
      sym_dot_dot_i,
    STATE(29), 1,
      sym__open_brace,
    STATE(191), 1,
      sym__open_parenthesis,
    STATE(2378), 1,
      sym_string,
    STATE(2382), 1,
      sym__single_quoted_string,
    STATE(2383), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5153), 1,
      sym__string_or_identifier,
    ACTIONS(3698), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2381), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3712), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8989), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1481), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [30831] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1289), 1,
      sym_identifier,
    ACTIONS(1291), 1,
      anon_sym_BSLASH,
    ACTIONS(1293), 1,
      anon_sym_function,
    ACTIONS(1295), 1,
      anon_sym_if,
    ACTIONS(1297), 1,
      anon_sym_for,
    ACTIONS(1299), 1,
      anon_sym_while,
    ACTIONS(1301), 1,
      anon_sym_repeat,
    ACTIONS(1303), 1,
      anon_sym_QMARK,
    ACTIONS(1305), 1,
      anon_sym_TILDE,
    ACTIONS(1313), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1315), 1,
      sym__number_literal,
    ACTIONS(1317), 1,
      anon_sym_SQUOTE,
    ACTIONS(1319), 1,
      anon_sym_DQUOTE,
    ACTIONS(1329), 1,
      sym__raw_string_literal,
    ACTIONS(1331), 1,
      sym__external_open_parenthesis,
    ACTIONS(1333), 1,
      sym__external_open_brace,
    ACTIONS(8531), 1,
      anon_sym_BANG,
    ACTIONS(8995), 1,
      sym_dot_dot_i,
    ACTIONS(8997), 1,
      sym__newline,
    STATE(23), 1,
      sym__open_parenthesis,
    STATE(180), 1,
      sym__open_brace,
    STATE(2264), 1,
      sym__double_quoted_string,
    STATE(2265), 1,
      sym__single_quoted_string,
    STATE(2284), 1,
      sym_string,
    STATE(3198), 1,
      aux_sym_function_definition_repeat1,
    STATE(5147), 1,
      sym__string_or_identifier,
    ACTIONS(1309), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2266), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1323), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8993), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1230), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [30960] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3678), 1,
      sym_identifier,
    ACTIONS(3680), 1,
      anon_sym_BSLASH,
    ACTIONS(3682), 1,
      anon_sym_function,
    ACTIONS(3684), 1,
      anon_sym_if,
    ACTIONS(3686), 1,
      anon_sym_for,
    ACTIONS(3688), 1,
      anon_sym_while,
    ACTIONS(3690), 1,
      anon_sym_repeat,
    ACTIONS(3692), 1,
      anon_sym_QMARK,
    ACTIONS(3694), 1,
      anon_sym_TILDE,
    ACTIONS(3702), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3704), 1,
      sym__number_literal,
    ACTIONS(3706), 1,
      anon_sym_SQUOTE,
    ACTIONS(3708), 1,
      anon_sym_DQUOTE,
    ACTIONS(3718), 1,
      sym__raw_string_literal,
    ACTIONS(3720), 1,
      sym__external_open_parenthesis,
    ACTIONS(3722), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8593), 1,
      anon_sym_BANG,
    ACTIONS(9001), 1,
      sym_dot_dot_i,
    STATE(29), 1,
      sym__open_brace,
    STATE(191), 1,
      sym__open_parenthesis,
    STATE(2378), 1,
      sym_string,
    STATE(2382), 1,
      sym__single_quoted_string,
    STATE(2383), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5153), 1,
      sym__string_or_identifier,
    ACTIONS(3698), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2381), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3712), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(8999), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1480), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [31089] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      sym_identifier,
    ACTIONS(55), 1,
      anon_sym_BSLASH,
    ACTIONS(57), 1,
      anon_sym_function,
    ACTIONS(61), 1,
      anon_sym_if,
    ACTIONS(63), 1,
      anon_sym_for,
    ACTIONS(65), 1,
      anon_sym_while,
    ACTIONS(67), 1,
      anon_sym_repeat,
    ACTIONS(69), 1,
      anon_sym_QMARK,
    ACTIONS(71), 1,
      anon_sym_TILDE,
    ACTIONS(79), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(81), 1,
      sym__number_literal,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE,
    ACTIONS(95), 1,
      sym__raw_string_literal,
    ACTIONS(97), 1,
      sym__external_open_parenthesis,
    ACTIONS(99), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8831), 1,
      anon_sym_BANG,
    ACTIONS(9005), 1,
      sym_dot_dot_i,
    STATE(4), 1,
      sym__open_brace,
    STATE(19), 1,
      sym__open_parenthesis,
    STATE(1982), 1,
      sym_string,
    STATE(1985), 1,
      sym__single_quoted_string,
    STATE(1990), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5151), 1,
      sym__string_or_identifier,
    ACTIONS(75), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1984), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(89), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9003), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(536), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [31218] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1289), 1,
      sym_identifier,
    ACTIONS(1291), 1,
      anon_sym_BSLASH,
    ACTIONS(1293), 1,
      anon_sym_function,
    ACTIONS(1295), 1,
      anon_sym_if,
    ACTIONS(1297), 1,
      anon_sym_for,
    ACTIONS(1299), 1,
      anon_sym_while,
    ACTIONS(1301), 1,
      anon_sym_repeat,
    ACTIONS(1303), 1,
      anon_sym_QMARK,
    ACTIONS(1305), 1,
      anon_sym_TILDE,
    ACTIONS(1313), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1315), 1,
      sym__number_literal,
    ACTIONS(1317), 1,
      anon_sym_SQUOTE,
    ACTIONS(1319), 1,
      anon_sym_DQUOTE,
    ACTIONS(1329), 1,
      sym__raw_string_literal,
    ACTIONS(1331), 1,
      sym__external_open_parenthesis,
    ACTIONS(1333), 1,
      sym__external_open_brace,
    ACTIONS(8531), 1,
      anon_sym_BANG,
    ACTIONS(9009), 1,
      sym_dot_dot_i,
    ACTIONS(9011), 1,
      sym__newline,
    STATE(23), 1,
      sym__open_parenthesis,
    STATE(180), 1,
      sym__open_brace,
    STATE(2264), 1,
      sym__double_quoted_string,
    STATE(2265), 1,
      sym__single_quoted_string,
    STATE(2284), 1,
      sym_string,
    STATE(3200), 1,
      aux_sym_function_definition_repeat1,
    STATE(5147), 1,
      sym__string_or_identifier,
    ACTIONS(1309), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2266), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1323), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9007), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1231), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [31347] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2425), 1,
      sym_identifier,
    ACTIONS(2427), 1,
      anon_sym_BSLASH,
    ACTIONS(2429), 1,
      anon_sym_function,
    ACTIONS(2431), 1,
      anon_sym_if,
    ACTIONS(2433), 1,
      anon_sym_for,
    ACTIONS(2435), 1,
      anon_sym_while,
    ACTIONS(2437), 1,
      anon_sym_repeat,
    ACTIONS(2439), 1,
      anon_sym_QMARK,
    ACTIONS(2441), 1,
      anon_sym_TILDE,
    ACTIONS(2449), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2451), 1,
      sym__number_literal,
    ACTIONS(2453), 1,
      anon_sym_SQUOTE,
    ACTIONS(2455), 1,
      anon_sym_DQUOTE,
    ACTIONS(2465), 1,
      sym__raw_string_literal,
    ACTIONS(2467), 1,
      sym__external_open_parenthesis,
    ACTIONS(2471), 1,
      sym__external_open_brace,
    ACTIONS(7781), 1,
      anon_sym_BANG,
    ACTIONS(9015), 1,
      sym_dot_dot_i,
    ACTIONS(9017), 1,
      sym__newline,
    STATE(97), 1,
      sym__open_brace,
    STATE(200), 1,
      sym__open_parenthesis,
    STATE(2369), 1,
      sym__double_quoted_string,
    STATE(2370), 1,
      sym__single_quoted_string,
    STATE(2372), 1,
      sym_string,
    STATE(3236), 1,
      aux_sym_function_definition_repeat1,
    STATE(5138), 1,
      sym__string_or_identifier,
    ACTIONS(2445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2371), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9013), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1289), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [31476] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2425), 1,
      sym_identifier,
    ACTIONS(2427), 1,
      anon_sym_BSLASH,
    ACTIONS(2429), 1,
      anon_sym_function,
    ACTIONS(2431), 1,
      anon_sym_if,
    ACTIONS(2433), 1,
      anon_sym_for,
    ACTIONS(2435), 1,
      anon_sym_while,
    ACTIONS(2437), 1,
      anon_sym_repeat,
    ACTIONS(2439), 1,
      anon_sym_QMARK,
    ACTIONS(2441), 1,
      anon_sym_TILDE,
    ACTIONS(2449), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2451), 1,
      sym__number_literal,
    ACTIONS(2453), 1,
      anon_sym_SQUOTE,
    ACTIONS(2455), 1,
      anon_sym_DQUOTE,
    ACTIONS(2465), 1,
      sym__raw_string_literal,
    ACTIONS(2467), 1,
      sym__external_open_parenthesis,
    ACTIONS(2471), 1,
      sym__external_open_brace,
    ACTIONS(7781), 1,
      anon_sym_BANG,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9021), 1,
      sym_dot_dot_i,
    STATE(97), 1,
      sym__open_brace,
    STATE(200), 1,
      sym__open_parenthesis,
    STATE(2369), 1,
      sym__double_quoted_string,
    STATE(2370), 1,
      sym__single_quoted_string,
    STATE(2372), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5138), 1,
      sym__string_or_identifier,
    ACTIONS(2445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2371), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9019), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1286), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [31605] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1289), 1,
      sym_identifier,
    ACTIONS(1291), 1,
      anon_sym_BSLASH,
    ACTIONS(1293), 1,
      anon_sym_function,
    ACTIONS(1295), 1,
      anon_sym_if,
    ACTIONS(1297), 1,
      anon_sym_for,
    ACTIONS(1299), 1,
      anon_sym_while,
    ACTIONS(1301), 1,
      anon_sym_repeat,
    ACTIONS(1303), 1,
      anon_sym_QMARK,
    ACTIONS(1305), 1,
      anon_sym_TILDE,
    ACTIONS(1313), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1315), 1,
      sym__number_literal,
    ACTIONS(1317), 1,
      anon_sym_SQUOTE,
    ACTIONS(1319), 1,
      anon_sym_DQUOTE,
    ACTIONS(1329), 1,
      sym__raw_string_literal,
    ACTIONS(1331), 1,
      sym__external_open_parenthesis,
    ACTIONS(1333), 1,
      sym__external_open_brace,
    ACTIONS(8531), 1,
      anon_sym_BANG,
    ACTIONS(9025), 1,
      sym_dot_dot_i,
    ACTIONS(9027), 1,
      sym__newline,
    STATE(23), 1,
      sym__open_parenthesis,
    STATE(180), 1,
      sym__open_brace,
    STATE(2264), 1,
      sym__double_quoted_string,
    STATE(2265), 1,
      sym__single_quoted_string,
    STATE(2284), 1,
      sym_string,
    STATE(3202), 1,
      aux_sym_function_definition_repeat1,
    STATE(5147), 1,
      sym__string_or_identifier,
    ACTIONS(1309), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2266), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1323), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9023), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1232), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [31734] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2425), 1,
      sym_identifier,
    ACTIONS(2427), 1,
      anon_sym_BSLASH,
    ACTIONS(2429), 1,
      anon_sym_function,
    ACTIONS(2431), 1,
      anon_sym_if,
    ACTIONS(2433), 1,
      anon_sym_for,
    ACTIONS(2435), 1,
      anon_sym_while,
    ACTIONS(2437), 1,
      anon_sym_repeat,
    ACTIONS(2439), 1,
      anon_sym_QMARK,
    ACTIONS(2441), 1,
      anon_sym_TILDE,
    ACTIONS(2449), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2451), 1,
      sym__number_literal,
    ACTIONS(2453), 1,
      anon_sym_SQUOTE,
    ACTIONS(2455), 1,
      anon_sym_DQUOTE,
    ACTIONS(2465), 1,
      sym__raw_string_literal,
    ACTIONS(2467), 1,
      sym__external_open_parenthesis,
    ACTIONS(2471), 1,
      sym__external_open_brace,
    ACTIONS(7781), 1,
      anon_sym_BANG,
    ACTIONS(9031), 1,
      sym_dot_dot_i,
    ACTIONS(9033), 1,
      sym__newline,
    STATE(97), 1,
      sym__open_brace,
    STATE(200), 1,
      sym__open_parenthesis,
    STATE(2369), 1,
      sym__double_quoted_string,
    STATE(2370), 1,
      sym__single_quoted_string,
    STATE(2372), 1,
      sym_string,
    STATE(3272), 1,
      aux_sym_function_definition_repeat1,
    STATE(5138), 1,
      sym__string_or_identifier,
    ACTIONS(2445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2371), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9029), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1283), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [31863] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1289), 1,
      sym_identifier,
    ACTIONS(1291), 1,
      anon_sym_BSLASH,
    ACTIONS(1293), 1,
      anon_sym_function,
    ACTIONS(1295), 1,
      anon_sym_if,
    ACTIONS(1297), 1,
      anon_sym_for,
    ACTIONS(1299), 1,
      anon_sym_while,
    ACTIONS(1301), 1,
      anon_sym_repeat,
    ACTIONS(1303), 1,
      anon_sym_QMARK,
    ACTIONS(1305), 1,
      anon_sym_TILDE,
    ACTIONS(1313), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1315), 1,
      sym__number_literal,
    ACTIONS(1317), 1,
      anon_sym_SQUOTE,
    ACTIONS(1319), 1,
      anon_sym_DQUOTE,
    ACTIONS(1329), 1,
      sym__raw_string_literal,
    ACTIONS(1331), 1,
      sym__external_open_parenthesis,
    ACTIONS(1333), 1,
      sym__external_open_brace,
    ACTIONS(8531), 1,
      anon_sym_BANG,
    ACTIONS(9037), 1,
      sym_dot_dot_i,
    ACTIONS(9039), 1,
      sym__newline,
    STATE(23), 1,
      sym__open_parenthesis,
    STATE(180), 1,
      sym__open_brace,
    STATE(2264), 1,
      sym__double_quoted_string,
    STATE(2265), 1,
      sym__single_quoted_string,
    STATE(2284), 1,
      sym_string,
    STATE(3204), 1,
      aux_sym_function_definition_repeat1,
    STATE(5147), 1,
      sym__string_or_identifier,
    ACTIONS(1309), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2266), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1323), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9035), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1233), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [31992] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1433), 1,
      sym_identifier,
    ACTIONS(1435), 1,
      anon_sym_BSLASH,
    ACTIONS(1437), 1,
      anon_sym_function,
    ACTIONS(1439), 1,
      anon_sym_if,
    ACTIONS(1441), 1,
      anon_sym_for,
    ACTIONS(1443), 1,
      anon_sym_while,
    ACTIONS(1445), 1,
      anon_sym_repeat,
    ACTIONS(1447), 1,
      anon_sym_QMARK,
    ACTIONS(1449), 1,
      anon_sym_TILDE,
    ACTIONS(1457), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1459), 1,
      sym__number_literal,
    ACTIONS(1461), 1,
      anon_sym_SQUOTE,
    ACTIONS(1463), 1,
      anon_sym_DQUOTE,
    ACTIONS(1473), 1,
      sym__raw_string_literal,
    ACTIONS(1475), 1,
      sym__external_open_parenthesis,
    ACTIONS(1477), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8097), 1,
      anon_sym_BANG,
    ACTIONS(9043), 1,
      sym_dot_dot_i,
    STATE(76), 1,
      sym__open_parenthesis,
    STATE(188), 1,
      sym__open_brace,
    STATE(2234), 1,
      sym_string,
    STATE(2236), 1,
      sym__single_quoted_string,
    STATE(2237), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5150), 1,
      sym__string_or_identifier,
    ACTIONS(1453), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2235), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1467), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9041), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1112), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [32121] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      sym_identifier,
    ACTIONS(55), 1,
      anon_sym_BSLASH,
    ACTIONS(57), 1,
      anon_sym_function,
    ACTIONS(61), 1,
      anon_sym_if,
    ACTIONS(63), 1,
      anon_sym_for,
    ACTIONS(65), 1,
      anon_sym_while,
    ACTIONS(67), 1,
      anon_sym_repeat,
    ACTIONS(69), 1,
      anon_sym_QMARK,
    ACTIONS(71), 1,
      anon_sym_TILDE,
    ACTIONS(79), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(81), 1,
      sym__number_literal,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE,
    ACTIONS(95), 1,
      sym__raw_string_literal,
    ACTIONS(97), 1,
      sym__external_open_parenthesis,
    ACTIONS(99), 1,
      sym__external_open_brace,
    ACTIONS(8831), 1,
      anon_sym_BANG,
    ACTIONS(9047), 1,
      sym_dot_dot_i,
    ACTIONS(9049), 1,
      sym__newline,
    STATE(4), 1,
      sym__open_brace,
    STATE(19), 1,
      sym__open_parenthesis,
    STATE(1982), 1,
      sym_string,
    STATE(1985), 1,
      sym__single_quoted_string,
    STATE(1990), 1,
      sym__double_quoted_string,
    STATE(3232), 1,
      aux_sym_function_definition_repeat1,
    STATE(5151), 1,
      sym__string_or_identifier,
    ACTIONS(75), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1984), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(89), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9045), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(534), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [32250] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      sym_identifier,
    ACTIONS(55), 1,
      anon_sym_BSLASH,
    ACTIONS(57), 1,
      anon_sym_function,
    ACTIONS(61), 1,
      anon_sym_if,
    ACTIONS(63), 1,
      anon_sym_for,
    ACTIONS(65), 1,
      anon_sym_while,
    ACTIONS(67), 1,
      anon_sym_repeat,
    ACTIONS(69), 1,
      anon_sym_QMARK,
    ACTIONS(71), 1,
      anon_sym_TILDE,
    ACTIONS(79), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(81), 1,
      sym__number_literal,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE,
    ACTIONS(95), 1,
      sym__raw_string_literal,
    ACTIONS(97), 1,
      sym__external_open_parenthesis,
    ACTIONS(99), 1,
      sym__external_open_brace,
    ACTIONS(8831), 1,
      anon_sym_BANG,
    ACTIONS(9053), 1,
      sym_dot_dot_i,
    ACTIONS(9055), 1,
      sym__newline,
    STATE(4), 1,
      sym__open_brace,
    STATE(19), 1,
      sym__open_parenthesis,
    STATE(1982), 1,
      sym_string,
    STATE(1985), 1,
      sym__single_quoted_string,
    STATE(1990), 1,
      sym__double_quoted_string,
    STATE(3235), 1,
      aux_sym_function_definition_repeat1,
    STATE(5151), 1,
      sym__string_or_identifier,
    ACTIONS(75), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1984), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(89), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9051), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(533), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [32379] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1289), 1,
      sym_identifier,
    ACTIONS(1291), 1,
      anon_sym_BSLASH,
    ACTIONS(1293), 1,
      anon_sym_function,
    ACTIONS(1295), 1,
      anon_sym_if,
    ACTIONS(1297), 1,
      anon_sym_for,
    ACTIONS(1299), 1,
      anon_sym_while,
    ACTIONS(1301), 1,
      anon_sym_repeat,
    ACTIONS(1303), 1,
      anon_sym_QMARK,
    ACTIONS(1305), 1,
      anon_sym_TILDE,
    ACTIONS(1313), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1315), 1,
      sym__number_literal,
    ACTIONS(1317), 1,
      anon_sym_SQUOTE,
    ACTIONS(1319), 1,
      anon_sym_DQUOTE,
    ACTIONS(1329), 1,
      sym__raw_string_literal,
    ACTIONS(1331), 1,
      sym__external_open_parenthesis,
    ACTIONS(1333), 1,
      sym__external_open_brace,
    ACTIONS(8531), 1,
      anon_sym_BANG,
    ACTIONS(9059), 1,
      sym_dot_dot_i,
    ACTIONS(9061), 1,
      sym__newline,
    STATE(23), 1,
      sym__open_parenthesis,
    STATE(180), 1,
      sym__open_brace,
    STATE(2264), 1,
      sym__double_quoted_string,
    STATE(2265), 1,
      sym__single_quoted_string,
    STATE(2284), 1,
      sym_string,
    STATE(3206), 1,
      aux_sym_function_definition_repeat1,
    STATE(5147), 1,
      sym__string_or_identifier,
    ACTIONS(1309), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2266), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1323), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9057), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1234), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [32508] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      sym_identifier,
    ACTIONS(55), 1,
      anon_sym_BSLASH,
    ACTIONS(57), 1,
      anon_sym_function,
    ACTIONS(61), 1,
      anon_sym_if,
    ACTIONS(63), 1,
      anon_sym_for,
    ACTIONS(65), 1,
      anon_sym_while,
    ACTIONS(67), 1,
      anon_sym_repeat,
    ACTIONS(69), 1,
      anon_sym_QMARK,
    ACTIONS(71), 1,
      anon_sym_TILDE,
    ACTIONS(79), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(81), 1,
      sym__number_literal,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE,
    ACTIONS(95), 1,
      sym__raw_string_literal,
    ACTIONS(97), 1,
      sym__external_open_parenthesis,
    ACTIONS(99), 1,
      sym__external_open_brace,
    ACTIONS(8831), 1,
      anon_sym_BANG,
    ACTIONS(9065), 1,
      sym_dot_dot_i,
    ACTIONS(9067), 1,
      sym__newline,
    STATE(4), 1,
      sym__open_brace,
    STATE(19), 1,
      sym__open_parenthesis,
    STATE(1982), 1,
      sym_string,
    STATE(1985), 1,
      sym__single_quoted_string,
    STATE(1990), 1,
      sym__double_quoted_string,
    STATE(3237), 1,
      aux_sym_function_definition_repeat1,
    STATE(5151), 1,
      sym__string_or_identifier,
    ACTIONS(75), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1984), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(89), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9063), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(531), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [32637] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1289), 1,
      sym_identifier,
    ACTIONS(1291), 1,
      anon_sym_BSLASH,
    ACTIONS(1293), 1,
      anon_sym_function,
    ACTIONS(1295), 1,
      anon_sym_if,
    ACTIONS(1297), 1,
      anon_sym_for,
    ACTIONS(1299), 1,
      anon_sym_while,
    ACTIONS(1301), 1,
      anon_sym_repeat,
    ACTIONS(1303), 1,
      anon_sym_QMARK,
    ACTIONS(1305), 1,
      anon_sym_TILDE,
    ACTIONS(1313), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1315), 1,
      sym__number_literal,
    ACTIONS(1317), 1,
      anon_sym_SQUOTE,
    ACTIONS(1319), 1,
      anon_sym_DQUOTE,
    ACTIONS(1329), 1,
      sym__raw_string_literal,
    ACTIONS(1331), 1,
      sym__external_open_parenthesis,
    ACTIONS(1333), 1,
      sym__external_open_brace,
    ACTIONS(8531), 1,
      anon_sym_BANG,
    ACTIONS(9071), 1,
      sym_dot_dot_i,
    ACTIONS(9073), 1,
      sym__newline,
    STATE(23), 1,
      sym__open_parenthesis,
    STATE(180), 1,
      sym__open_brace,
    STATE(2264), 1,
      sym__double_quoted_string,
    STATE(2265), 1,
      sym__single_quoted_string,
    STATE(2284), 1,
      sym_string,
    STATE(3175), 1,
      aux_sym_function_definition_repeat1,
    STATE(5147), 1,
      sym__string_or_identifier,
    ACTIONS(1309), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2266), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1323), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9069), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1235), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [32766] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      sym_identifier,
    ACTIONS(55), 1,
      anon_sym_BSLASH,
    ACTIONS(57), 1,
      anon_sym_function,
    ACTIONS(61), 1,
      anon_sym_if,
    ACTIONS(63), 1,
      anon_sym_for,
    ACTIONS(65), 1,
      anon_sym_while,
    ACTIONS(67), 1,
      anon_sym_repeat,
    ACTIONS(69), 1,
      anon_sym_QMARK,
    ACTIONS(71), 1,
      anon_sym_TILDE,
    ACTIONS(79), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(81), 1,
      sym__number_literal,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE,
    ACTIONS(95), 1,
      sym__raw_string_literal,
    ACTIONS(97), 1,
      sym__external_open_parenthesis,
    ACTIONS(99), 1,
      sym__external_open_brace,
    ACTIONS(8831), 1,
      anon_sym_BANG,
    ACTIONS(9077), 1,
      sym_dot_dot_i,
    ACTIONS(9079), 1,
      sym__newline,
    STATE(4), 1,
      sym__open_brace,
    STATE(19), 1,
      sym__open_parenthesis,
    STATE(1982), 1,
      sym_string,
    STATE(1985), 1,
      sym__single_quoted_string,
    STATE(1990), 1,
      sym__double_quoted_string,
    STATE(3238), 1,
      aux_sym_function_definition_repeat1,
    STATE(5151), 1,
      sym__string_or_identifier,
    ACTIONS(75), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1984), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(89), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9075), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(530), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [32895] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      sym_identifier,
    ACTIONS(55), 1,
      anon_sym_BSLASH,
    ACTIONS(57), 1,
      anon_sym_function,
    ACTIONS(61), 1,
      anon_sym_if,
    ACTIONS(63), 1,
      anon_sym_for,
    ACTIONS(65), 1,
      anon_sym_while,
    ACTIONS(67), 1,
      anon_sym_repeat,
    ACTIONS(69), 1,
      anon_sym_QMARK,
    ACTIONS(71), 1,
      anon_sym_TILDE,
    ACTIONS(79), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(81), 1,
      sym__number_literal,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE,
    ACTIONS(95), 1,
      sym__raw_string_literal,
    ACTIONS(97), 1,
      sym__external_open_parenthesis,
    ACTIONS(99), 1,
      sym__external_open_brace,
    ACTIONS(8831), 1,
      anon_sym_BANG,
    ACTIONS(9083), 1,
      sym_dot_dot_i,
    ACTIONS(9085), 1,
      sym__newline,
    STATE(4), 1,
      sym__open_brace,
    STATE(19), 1,
      sym__open_parenthesis,
    STATE(1982), 1,
      sym_string,
    STATE(1985), 1,
      sym__single_quoted_string,
    STATE(1990), 1,
      sym__double_quoted_string,
    STATE(3239), 1,
      aux_sym_function_definition_repeat1,
    STATE(5151), 1,
      sym__string_or_identifier,
    ACTIONS(75), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1984), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(89), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9081), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(529), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [33024] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      sym_identifier,
    ACTIONS(55), 1,
      anon_sym_BSLASH,
    ACTIONS(57), 1,
      anon_sym_function,
    ACTIONS(61), 1,
      anon_sym_if,
    ACTIONS(63), 1,
      anon_sym_for,
    ACTIONS(65), 1,
      anon_sym_while,
    ACTIONS(67), 1,
      anon_sym_repeat,
    ACTIONS(69), 1,
      anon_sym_QMARK,
    ACTIONS(71), 1,
      anon_sym_TILDE,
    ACTIONS(79), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(81), 1,
      sym__number_literal,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE,
    ACTIONS(95), 1,
      sym__raw_string_literal,
    ACTIONS(97), 1,
      sym__external_open_parenthesis,
    ACTIONS(99), 1,
      sym__external_open_brace,
    ACTIONS(8831), 1,
      anon_sym_BANG,
    ACTIONS(9089), 1,
      sym_dot_dot_i,
    ACTIONS(9091), 1,
      sym__newline,
    STATE(4), 1,
      sym__open_brace,
    STATE(19), 1,
      sym__open_parenthesis,
    STATE(1982), 1,
      sym_string,
    STATE(1985), 1,
      sym__single_quoted_string,
    STATE(1990), 1,
      sym__double_quoted_string,
    STATE(3240), 1,
      aux_sym_function_definition_repeat1,
    STATE(5151), 1,
      sym__string_or_identifier,
    ACTIONS(75), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1984), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(89), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9087), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(528), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [33153] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      sym_identifier,
    ACTIONS(55), 1,
      anon_sym_BSLASH,
    ACTIONS(57), 1,
      anon_sym_function,
    ACTIONS(61), 1,
      anon_sym_if,
    ACTIONS(63), 1,
      anon_sym_for,
    ACTIONS(65), 1,
      anon_sym_while,
    ACTIONS(67), 1,
      anon_sym_repeat,
    ACTIONS(69), 1,
      anon_sym_QMARK,
    ACTIONS(71), 1,
      anon_sym_TILDE,
    ACTIONS(79), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(81), 1,
      sym__number_literal,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE,
    ACTIONS(95), 1,
      sym__raw_string_literal,
    ACTIONS(97), 1,
      sym__external_open_parenthesis,
    ACTIONS(99), 1,
      sym__external_open_brace,
    ACTIONS(8831), 1,
      anon_sym_BANG,
    ACTIONS(9095), 1,
      sym_dot_dot_i,
    ACTIONS(9097), 1,
      sym__newline,
    STATE(4), 1,
      sym__open_brace,
    STATE(19), 1,
      sym__open_parenthesis,
    STATE(1982), 1,
      sym_string,
    STATE(1985), 1,
      sym__single_quoted_string,
    STATE(1990), 1,
      sym__double_quoted_string,
    STATE(3241), 1,
      aux_sym_function_definition_repeat1,
    STATE(5151), 1,
      sym__string_or_identifier,
    ACTIONS(75), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1984), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(89), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9093), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(527), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [33282] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1289), 1,
      sym_identifier,
    ACTIONS(1291), 1,
      anon_sym_BSLASH,
    ACTIONS(1293), 1,
      anon_sym_function,
    ACTIONS(1295), 1,
      anon_sym_if,
    ACTIONS(1297), 1,
      anon_sym_for,
    ACTIONS(1299), 1,
      anon_sym_while,
    ACTIONS(1301), 1,
      anon_sym_repeat,
    ACTIONS(1303), 1,
      anon_sym_QMARK,
    ACTIONS(1305), 1,
      anon_sym_TILDE,
    ACTIONS(1313), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1315), 1,
      sym__number_literal,
    ACTIONS(1317), 1,
      anon_sym_SQUOTE,
    ACTIONS(1319), 1,
      anon_sym_DQUOTE,
    ACTIONS(1329), 1,
      sym__raw_string_literal,
    ACTIONS(1331), 1,
      sym__external_open_parenthesis,
    ACTIONS(1333), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8531), 1,
      anon_sym_BANG,
    ACTIONS(9101), 1,
      sym_dot_dot_i,
    STATE(23), 1,
      sym__open_parenthesis,
    STATE(180), 1,
      sym__open_brace,
    STATE(2264), 1,
      sym__double_quoted_string,
    STATE(2265), 1,
      sym__single_quoted_string,
    STATE(2284), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5147), 1,
      sym__string_or_identifier,
    ACTIONS(1309), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2266), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1323), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9099), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1236), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [33411] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1289), 1,
      sym_identifier,
    ACTIONS(1291), 1,
      anon_sym_BSLASH,
    ACTIONS(1293), 1,
      anon_sym_function,
    ACTIONS(1295), 1,
      anon_sym_if,
    ACTIONS(1297), 1,
      anon_sym_for,
    ACTIONS(1299), 1,
      anon_sym_while,
    ACTIONS(1301), 1,
      anon_sym_repeat,
    ACTIONS(1303), 1,
      anon_sym_QMARK,
    ACTIONS(1305), 1,
      anon_sym_TILDE,
    ACTIONS(1313), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1315), 1,
      sym__number_literal,
    ACTIONS(1317), 1,
      anon_sym_SQUOTE,
    ACTIONS(1319), 1,
      anon_sym_DQUOTE,
    ACTIONS(1329), 1,
      sym__raw_string_literal,
    ACTIONS(1331), 1,
      sym__external_open_parenthesis,
    ACTIONS(1333), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8531), 1,
      anon_sym_BANG,
    ACTIONS(9105), 1,
      sym_dot_dot_i,
    STATE(23), 1,
      sym__open_parenthesis,
    STATE(180), 1,
      sym__open_brace,
    STATE(2264), 1,
      sym__double_quoted_string,
    STATE(2265), 1,
      sym__single_quoted_string,
    STATE(2284), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5147), 1,
      sym__string_or_identifier,
    ACTIONS(1309), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2266), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1323), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9103), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1237), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [33540] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1289), 1,
      sym_identifier,
    ACTIONS(1291), 1,
      anon_sym_BSLASH,
    ACTIONS(1293), 1,
      anon_sym_function,
    ACTIONS(1295), 1,
      anon_sym_if,
    ACTIONS(1297), 1,
      anon_sym_for,
    ACTIONS(1299), 1,
      anon_sym_while,
    ACTIONS(1301), 1,
      anon_sym_repeat,
    ACTIONS(1303), 1,
      anon_sym_QMARK,
    ACTIONS(1305), 1,
      anon_sym_TILDE,
    ACTIONS(1313), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1315), 1,
      sym__number_literal,
    ACTIONS(1317), 1,
      anon_sym_SQUOTE,
    ACTIONS(1319), 1,
      anon_sym_DQUOTE,
    ACTIONS(1329), 1,
      sym__raw_string_literal,
    ACTIONS(1331), 1,
      sym__external_open_parenthesis,
    ACTIONS(1333), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8531), 1,
      anon_sym_BANG,
    ACTIONS(9109), 1,
      sym_dot_dot_i,
    STATE(23), 1,
      sym__open_parenthesis,
    STATE(180), 1,
      sym__open_brace,
    STATE(2264), 1,
      sym__double_quoted_string,
    STATE(2265), 1,
      sym__single_quoted_string,
    STATE(2284), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5147), 1,
      sym__string_or_identifier,
    ACTIONS(1309), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2266), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1323), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9107), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1238), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [33669] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1289), 1,
      sym_identifier,
    ACTIONS(1291), 1,
      anon_sym_BSLASH,
    ACTIONS(1293), 1,
      anon_sym_function,
    ACTIONS(1295), 1,
      anon_sym_if,
    ACTIONS(1297), 1,
      anon_sym_for,
    ACTIONS(1299), 1,
      anon_sym_while,
    ACTIONS(1301), 1,
      anon_sym_repeat,
    ACTIONS(1303), 1,
      anon_sym_QMARK,
    ACTIONS(1305), 1,
      anon_sym_TILDE,
    ACTIONS(1313), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1315), 1,
      sym__number_literal,
    ACTIONS(1317), 1,
      anon_sym_SQUOTE,
    ACTIONS(1319), 1,
      anon_sym_DQUOTE,
    ACTIONS(1329), 1,
      sym__raw_string_literal,
    ACTIONS(1331), 1,
      sym__external_open_parenthesis,
    ACTIONS(1333), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8531), 1,
      anon_sym_BANG,
    ACTIONS(9113), 1,
      sym_dot_dot_i,
    STATE(23), 1,
      sym__open_parenthesis,
    STATE(180), 1,
      sym__open_brace,
    STATE(2264), 1,
      sym__double_quoted_string,
    STATE(2265), 1,
      sym__single_quoted_string,
    STATE(2284), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5147), 1,
      sym__string_or_identifier,
    ACTIONS(1309), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2266), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1323), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9111), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1239), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [33798] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      sym_identifier,
    ACTIONS(55), 1,
      anon_sym_BSLASH,
    ACTIONS(57), 1,
      anon_sym_function,
    ACTIONS(61), 1,
      anon_sym_if,
    ACTIONS(63), 1,
      anon_sym_for,
    ACTIONS(65), 1,
      anon_sym_while,
    ACTIONS(67), 1,
      anon_sym_repeat,
    ACTIONS(69), 1,
      anon_sym_QMARK,
    ACTIONS(71), 1,
      anon_sym_TILDE,
    ACTIONS(79), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(81), 1,
      sym__number_literal,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE,
    ACTIONS(95), 1,
      sym__raw_string_literal,
    ACTIONS(97), 1,
      sym__external_open_parenthesis,
    ACTIONS(99), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8831), 1,
      anon_sym_BANG,
    ACTIONS(9117), 1,
      sym_dot_dot_i,
    STATE(4), 1,
      sym__open_brace,
    STATE(19), 1,
      sym__open_parenthesis,
    STATE(1982), 1,
      sym_string,
    STATE(1985), 1,
      sym__single_quoted_string,
    STATE(1990), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5151), 1,
      sym__string_or_identifier,
    ACTIONS(75), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1984), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(89), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9115), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(492), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [33927] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      sym_identifier,
    ACTIONS(55), 1,
      anon_sym_BSLASH,
    ACTIONS(57), 1,
      anon_sym_function,
    ACTIONS(61), 1,
      anon_sym_if,
    ACTIONS(63), 1,
      anon_sym_for,
    ACTIONS(65), 1,
      anon_sym_while,
    ACTIONS(67), 1,
      anon_sym_repeat,
    ACTIONS(69), 1,
      anon_sym_QMARK,
    ACTIONS(71), 1,
      anon_sym_TILDE,
    ACTIONS(79), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(81), 1,
      sym__number_literal,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE,
    ACTIONS(95), 1,
      sym__raw_string_literal,
    ACTIONS(97), 1,
      sym__external_open_parenthesis,
    ACTIONS(99), 1,
      sym__external_open_brace,
    ACTIONS(8831), 1,
      anon_sym_BANG,
    ACTIONS(9121), 1,
      sym_dot_dot_i,
    ACTIONS(9123), 1,
      sym__newline,
    STATE(4), 1,
      sym__open_brace,
    STATE(19), 1,
      sym__open_parenthesis,
    STATE(1982), 1,
      sym_string,
    STATE(1985), 1,
      sym__single_quoted_string,
    STATE(1990), 1,
      sym__double_quoted_string,
    STATE(3242), 1,
      aux_sym_function_definition_repeat1,
    STATE(5151), 1,
      sym__string_or_identifier,
    ACTIONS(75), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1984), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(89), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9119), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(526), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [34056] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      sym_identifier,
    ACTIONS(55), 1,
      anon_sym_BSLASH,
    ACTIONS(57), 1,
      anon_sym_function,
    ACTIONS(61), 1,
      anon_sym_if,
    ACTIONS(63), 1,
      anon_sym_for,
    ACTIONS(65), 1,
      anon_sym_while,
    ACTIONS(67), 1,
      anon_sym_repeat,
    ACTIONS(69), 1,
      anon_sym_QMARK,
    ACTIONS(71), 1,
      anon_sym_TILDE,
    ACTIONS(79), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(81), 1,
      sym__number_literal,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE,
    ACTIONS(95), 1,
      sym__raw_string_literal,
    ACTIONS(97), 1,
      sym__external_open_parenthesis,
    ACTIONS(99), 1,
      sym__external_open_brace,
    ACTIONS(8831), 1,
      anon_sym_BANG,
    ACTIONS(9127), 1,
      sym_dot_dot_i,
    ACTIONS(9129), 1,
      sym__newline,
    STATE(4), 1,
      sym__open_brace,
    STATE(19), 1,
      sym__open_parenthesis,
    STATE(1982), 1,
      sym_string,
    STATE(1985), 1,
      sym__single_quoted_string,
    STATE(1990), 1,
      sym__double_quoted_string,
    STATE(3245), 1,
      aux_sym_function_definition_repeat1,
    STATE(5151), 1,
      sym__string_or_identifier,
    ACTIONS(75), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1984), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(89), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9125), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(525), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [34185] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      sym_identifier,
    ACTIONS(55), 1,
      anon_sym_BSLASH,
    ACTIONS(57), 1,
      anon_sym_function,
    ACTIONS(61), 1,
      anon_sym_if,
    ACTIONS(63), 1,
      anon_sym_for,
    ACTIONS(65), 1,
      anon_sym_while,
    ACTIONS(67), 1,
      anon_sym_repeat,
    ACTIONS(69), 1,
      anon_sym_QMARK,
    ACTIONS(71), 1,
      anon_sym_TILDE,
    ACTIONS(79), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(81), 1,
      sym__number_literal,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE,
    ACTIONS(95), 1,
      sym__raw_string_literal,
    ACTIONS(97), 1,
      sym__external_open_parenthesis,
    ACTIONS(99), 1,
      sym__external_open_brace,
    ACTIONS(8831), 1,
      anon_sym_BANG,
    ACTIONS(9133), 1,
      sym_dot_dot_i,
    ACTIONS(9135), 1,
      sym__newline,
    STATE(4), 1,
      sym__open_brace,
    STATE(19), 1,
      sym__open_parenthesis,
    STATE(1982), 1,
      sym_string,
    STATE(1985), 1,
      sym__single_quoted_string,
    STATE(1990), 1,
      sym__double_quoted_string,
    STATE(3247), 1,
      aux_sym_function_definition_repeat1,
    STATE(5151), 1,
      sym__string_or_identifier,
    ACTIONS(75), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1984), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(89), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9131), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(524), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [34314] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      sym_identifier,
    ACTIONS(55), 1,
      anon_sym_BSLASH,
    ACTIONS(57), 1,
      anon_sym_function,
    ACTIONS(61), 1,
      anon_sym_if,
    ACTIONS(63), 1,
      anon_sym_for,
    ACTIONS(65), 1,
      anon_sym_while,
    ACTIONS(67), 1,
      anon_sym_repeat,
    ACTIONS(69), 1,
      anon_sym_QMARK,
    ACTIONS(71), 1,
      anon_sym_TILDE,
    ACTIONS(79), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(81), 1,
      sym__number_literal,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE,
    ACTIONS(95), 1,
      sym__raw_string_literal,
    ACTIONS(97), 1,
      sym__external_open_parenthesis,
    ACTIONS(99), 1,
      sym__external_open_brace,
    ACTIONS(8831), 1,
      anon_sym_BANG,
    ACTIONS(9139), 1,
      sym_dot_dot_i,
    ACTIONS(9141), 1,
      sym__newline,
    STATE(4), 1,
      sym__open_brace,
    STATE(19), 1,
      sym__open_parenthesis,
    STATE(1982), 1,
      sym_string,
    STATE(1985), 1,
      sym__single_quoted_string,
    STATE(1990), 1,
      sym__double_quoted_string,
    STATE(3249), 1,
      aux_sym_function_definition_repeat1,
    STATE(5151), 1,
      sym__string_or_identifier,
    ACTIONS(75), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1984), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(89), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9137), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(523), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [34443] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      sym_identifier,
    ACTIONS(55), 1,
      anon_sym_BSLASH,
    ACTIONS(57), 1,
      anon_sym_function,
    ACTIONS(61), 1,
      anon_sym_if,
    ACTIONS(63), 1,
      anon_sym_for,
    ACTIONS(65), 1,
      anon_sym_while,
    ACTIONS(67), 1,
      anon_sym_repeat,
    ACTIONS(69), 1,
      anon_sym_QMARK,
    ACTIONS(71), 1,
      anon_sym_TILDE,
    ACTIONS(79), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(81), 1,
      sym__number_literal,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE,
    ACTIONS(95), 1,
      sym__raw_string_literal,
    ACTIONS(97), 1,
      sym__external_open_parenthesis,
    ACTIONS(99), 1,
      sym__external_open_brace,
    ACTIONS(8831), 1,
      anon_sym_BANG,
    ACTIONS(9145), 1,
      sym_dot_dot_i,
    ACTIONS(9147), 1,
      sym__newline,
    STATE(4), 1,
      sym__open_brace,
    STATE(19), 1,
      sym__open_parenthesis,
    STATE(1982), 1,
      sym_string,
    STATE(1985), 1,
      sym__single_quoted_string,
    STATE(1990), 1,
      sym__double_quoted_string,
    STATE(3251), 1,
      aux_sym_function_definition_repeat1,
    STATE(5151), 1,
      sym__string_or_identifier,
    ACTIONS(75), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1984), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(89), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9143), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(521), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [34572] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      sym_identifier,
    ACTIONS(55), 1,
      anon_sym_BSLASH,
    ACTIONS(57), 1,
      anon_sym_function,
    ACTIONS(61), 1,
      anon_sym_if,
    ACTIONS(63), 1,
      anon_sym_for,
    ACTIONS(65), 1,
      anon_sym_while,
    ACTIONS(67), 1,
      anon_sym_repeat,
    ACTIONS(69), 1,
      anon_sym_QMARK,
    ACTIONS(71), 1,
      anon_sym_TILDE,
    ACTIONS(79), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(81), 1,
      sym__number_literal,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE,
    ACTIONS(95), 1,
      sym__raw_string_literal,
    ACTIONS(97), 1,
      sym__external_open_parenthesis,
    ACTIONS(99), 1,
      sym__external_open_brace,
    ACTIONS(8831), 1,
      anon_sym_BANG,
    ACTIONS(9151), 1,
      sym_dot_dot_i,
    ACTIONS(9153), 1,
      sym__newline,
    STATE(4), 1,
      sym__open_brace,
    STATE(19), 1,
      sym__open_parenthesis,
    STATE(1982), 1,
      sym_string,
    STATE(1985), 1,
      sym__single_quoted_string,
    STATE(1990), 1,
      sym__double_quoted_string,
    STATE(3269), 1,
      aux_sym_function_definition_repeat1,
    STATE(5151), 1,
      sym__string_or_identifier,
    ACTIONS(75), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1984), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(89), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9149), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(520), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [34701] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1433), 1,
      sym_identifier,
    ACTIONS(1435), 1,
      anon_sym_BSLASH,
    ACTIONS(1437), 1,
      anon_sym_function,
    ACTIONS(1439), 1,
      anon_sym_if,
    ACTIONS(1441), 1,
      anon_sym_for,
    ACTIONS(1443), 1,
      anon_sym_while,
    ACTIONS(1445), 1,
      anon_sym_repeat,
    ACTIONS(1447), 1,
      anon_sym_QMARK,
    ACTIONS(1449), 1,
      anon_sym_TILDE,
    ACTIONS(1457), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1459), 1,
      sym__number_literal,
    ACTIONS(1461), 1,
      anon_sym_SQUOTE,
    ACTIONS(1463), 1,
      anon_sym_DQUOTE,
    ACTIONS(1473), 1,
      sym__raw_string_literal,
    ACTIONS(1475), 1,
      sym__external_open_parenthesis,
    ACTIONS(1477), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8097), 1,
      anon_sym_BANG,
    ACTIONS(9157), 1,
      sym_dot_dot_i,
    STATE(76), 1,
      sym__open_parenthesis,
    STATE(188), 1,
      sym__open_brace,
    STATE(2234), 1,
      sym_string,
    STATE(2236), 1,
      sym__single_quoted_string,
    STATE(2237), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5150), 1,
      sym__string_or_identifier,
    ACTIONS(1453), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2235), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1467), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9155), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1110), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [34830] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1433), 1,
      sym_identifier,
    ACTIONS(1435), 1,
      anon_sym_BSLASH,
    ACTIONS(1437), 1,
      anon_sym_function,
    ACTIONS(1439), 1,
      anon_sym_if,
    ACTIONS(1441), 1,
      anon_sym_for,
    ACTIONS(1443), 1,
      anon_sym_while,
    ACTIONS(1445), 1,
      anon_sym_repeat,
    ACTIONS(1447), 1,
      anon_sym_QMARK,
    ACTIONS(1449), 1,
      anon_sym_TILDE,
    ACTIONS(1457), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1459), 1,
      sym__number_literal,
    ACTIONS(1461), 1,
      anon_sym_SQUOTE,
    ACTIONS(1463), 1,
      anon_sym_DQUOTE,
    ACTIONS(1473), 1,
      sym__raw_string_literal,
    ACTIONS(1475), 1,
      sym__external_open_parenthesis,
    ACTIONS(1477), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8097), 1,
      anon_sym_BANG,
    ACTIONS(9161), 1,
      sym_dot_dot_i,
    STATE(76), 1,
      sym__open_parenthesis,
    STATE(188), 1,
      sym__open_brace,
    STATE(2234), 1,
      sym_string,
    STATE(2236), 1,
      sym__single_quoted_string,
    STATE(2237), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5150), 1,
      sym__string_or_identifier,
    ACTIONS(1453), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2235), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1467), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9159), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1109), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [34959] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      sym_identifier,
    ACTIONS(55), 1,
      anon_sym_BSLASH,
    ACTIONS(57), 1,
      anon_sym_function,
    ACTIONS(61), 1,
      anon_sym_if,
    ACTIONS(63), 1,
      anon_sym_for,
    ACTIONS(65), 1,
      anon_sym_while,
    ACTIONS(67), 1,
      anon_sym_repeat,
    ACTIONS(69), 1,
      anon_sym_QMARK,
    ACTIONS(71), 1,
      anon_sym_TILDE,
    ACTIONS(79), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(81), 1,
      sym__number_literal,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE,
    ACTIONS(95), 1,
      sym__raw_string_literal,
    ACTIONS(97), 1,
      sym__external_open_parenthesis,
    ACTIONS(99), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8831), 1,
      anon_sym_BANG,
    ACTIONS(9165), 1,
      sym_dot_dot_i,
    STATE(4), 1,
      sym__open_brace,
    STATE(19), 1,
      sym__open_parenthesis,
    STATE(1982), 1,
      sym_string,
    STATE(1985), 1,
      sym__single_quoted_string,
    STATE(1990), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5151), 1,
      sym__string_or_identifier,
    ACTIONS(75), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1984), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(89), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9163), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(519), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [35088] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1433), 1,
      sym_identifier,
    ACTIONS(1435), 1,
      anon_sym_BSLASH,
    ACTIONS(1437), 1,
      anon_sym_function,
    ACTIONS(1439), 1,
      anon_sym_if,
    ACTIONS(1441), 1,
      anon_sym_for,
    ACTIONS(1443), 1,
      anon_sym_while,
    ACTIONS(1445), 1,
      anon_sym_repeat,
    ACTIONS(1447), 1,
      anon_sym_QMARK,
    ACTIONS(1449), 1,
      anon_sym_TILDE,
    ACTIONS(1457), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1459), 1,
      sym__number_literal,
    ACTIONS(1461), 1,
      anon_sym_SQUOTE,
    ACTIONS(1463), 1,
      anon_sym_DQUOTE,
    ACTIONS(1473), 1,
      sym__raw_string_literal,
    ACTIONS(1475), 1,
      sym__external_open_parenthesis,
    ACTIONS(1477), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8097), 1,
      anon_sym_BANG,
    ACTIONS(9169), 1,
      sym_dot_dot_i,
    STATE(76), 1,
      sym__open_parenthesis,
    STATE(188), 1,
      sym__open_brace,
    STATE(2234), 1,
      sym_string,
    STATE(2236), 1,
      sym__single_quoted_string,
    STATE(2237), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5150), 1,
      sym__string_or_identifier,
    ACTIONS(1453), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2235), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1467), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9167), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1108), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [35217] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2943), 1,
      sym_identifier,
    ACTIONS(2945), 1,
      anon_sym_BSLASH,
    ACTIONS(2947), 1,
      anon_sym_function,
    ACTIONS(2949), 1,
      anon_sym_if,
    ACTIONS(2951), 1,
      anon_sym_for,
    ACTIONS(2953), 1,
      anon_sym_while,
    ACTIONS(2955), 1,
      anon_sym_repeat,
    ACTIONS(2957), 1,
      anon_sym_QMARK,
    ACTIONS(2959), 1,
      anon_sym_TILDE,
    ACTIONS(2967), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2969), 1,
      sym__number_literal,
    ACTIONS(2971), 1,
      anon_sym_SQUOTE,
    ACTIONS(2973), 1,
      anon_sym_DQUOTE,
    ACTIONS(2983), 1,
      sym__raw_string_literal,
    ACTIONS(2985), 1,
      sym__external_open_parenthesis,
    ACTIONS(2989), 1,
      sym__external_open_brace,
    ACTIONS(7797), 1,
      anon_sym_BANG,
    ACTIONS(9173), 1,
      sym_dot_dot_i,
    ACTIONS(9175), 1,
      sym__newline,
    STATE(173), 1,
      sym__open_brace,
    STATE(246), 1,
      sym__open_parenthesis,
    STATE(2462), 1,
      sym__single_quoted_string,
    STATE(2494), 1,
      sym__double_quoted_string,
    STATE(2541), 1,
      sym_string,
    STATE(3167), 1,
      aux_sym_function_definition_repeat1,
    STATE(5128), 1,
      sym__string_or_identifier,
    ACTIONS(2963), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2540), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2977), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9171), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1799), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [35346] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1289), 1,
      sym_identifier,
    ACTIONS(1291), 1,
      anon_sym_BSLASH,
    ACTIONS(1293), 1,
      anon_sym_function,
    ACTIONS(1295), 1,
      anon_sym_if,
    ACTIONS(1297), 1,
      anon_sym_for,
    ACTIONS(1299), 1,
      anon_sym_while,
    ACTIONS(1301), 1,
      anon_sym_repeat,
    ACTIONS(1303), 1,
      anon_sym_QMARK,
    ACTIONS(1305), 1,
      anon_sym_TILDE,
    ACTIONS(1313), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1315), 1,
      sym__number_literal,
    ACTIONS(1317), 1,
      anon_sym_SQUOTE,
    ACTIONS(1319), 1,
      anon_sym_DQUOTE,
    ACTIONS(1329), 1,
      sym__raw_string_literal,
    ACTIONS(1331), 1,
      sym__external_open_parenthesis,
    ACTIONS(1333), 1,
      sym__external_open_brace,
    ACTIONS(8531), 1,
      anon_sym_BANG,
    ACTIONS(9179), 1,
      sym_dot_dot_i,
    ACTIONS(9181), 1,
      sym__newline,
    STATE(23), 1,
      sym__open_parenthesis,
    STATE(180), 1,
      sym__open_brace,
    STATE(2264), 1,
      sym__double_quoted_string,
    STATE(2265), 1,
      sym__single_quoted_string,
    STATE(2284), 1,
      sym_string,
    STATE(3286), 1,
      aux_sym_function_definition_repeat1,
    STATE(5147), 1,
      sym__string_or_identifier,
    ACTIONS(1309), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2266), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1323), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9177), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1242), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [35475] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      sym_identifier,
    ACTIONS(55), 1,
      anon_sym_BSLASH,
    ACTIONS(57), 1,
      anon_sym_function,
    ACTIONS(61), 1,
      anon_sym_if,
    ACTIONS(63), 1,
      anon_sym_for,
    ACTIONS(65), 1,
      anon_sym_while,
    ACTIONS(67), 1,
      anon_sym_repeat,
    ACTIONS(69), 1,
      anon_sym_QMARK,
    ACTIONS(71), 1,
      anon_sym_TILDE,
    ACTIONS(79), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(81), 1,
      sym__number_literal,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE,
    ACTIONS(95), 1,
      sym__raw_string_literal,
    ACTIONS(97), 1,
      sym__external_open_parenthesis,
    ACTIONS(99), 1,
      sym__external_open_brace,
    ACTIONS(8831), 1,
      anon_sym_BANG,
    ACTIONS(9185), 1,
      sym_dot_dot_i,
    ACTIONS(9187), 1,
      sym__newline,
    STATE(4), 1,
      sym__open_brace,
    STATE(19), 1,
      sym__open_parenthesis,
    STATE(1982), 1,
      sym_string,
    STATE(1985), 1,
      sym__single_quoted_string,
    STATE(1990), 1,
      sym__double_quoted_string,
    STATE(3290), 1,
      aux_sym_function_definition_repeat1,
    STATE(5151), 1,
      sym__string_or_identifier,
    ACTIONS(75), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1984), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(89), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9183), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(496), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [35604] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      sym_identifier,
    ACTIONS(55), 1,
      anon_sym_BSLASH,
    ACTIONS(57), 1,
      anon_sym_function,
    ACTIONS(61), 1,
      anon_sym_if,
    ACTIONS(63), 1,
      anon_sym_for,
    ACTIONS(65), 1,
      anon_sym_while,
    ACTIONS(67), 1,
      anon_sym_repeat,
    ACTIONS(69), 1,
      anon_sym_QMARK,
    ACTIONS(71), 1,
      anon_sym_TILDE,
    ACTIONS(79), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(81), 1,
      sym__number_literal,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE,
    ACTIONS(95), 1,
      sym__raw_string_literal,
    ACTIONS(97), 1,
      sym__external_open_parenthesis,
    ACTIONS(99), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8831), 1,
      anon_sym_BANG,
    ACTIONS(9191), 1,
      sym_dot_dot_i,
    STATE(4), 1,
      sym__open_brace,
    STATE(19), 1,
      sym__open_parenthesis,
    STATE(1982), 1,
      sym_string,
    STATE(1985), 1,
      sym__single_quoted_string,
    STATE(1990), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5151), 1,
      sym__string_or_identifier,
    ACTIONS(75), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1984), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(89), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9189), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(518), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [35733] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1289), 1,
      sym_identifier,
    ACTIONS(1291), 1,
      anon_sym_BSLASH,
    ACTIONS(1293), 1,
      anon_sym_function,
    ACTIONS(1295), 1,
      anon_sym_if,
    ACTIONS(1297), 1,
      anon_sym_for,
    ACTIONS(1299), 1,
      anon_sym_while,
    ACTIONS(1301), 1,
      anon_sym_repeat,
    ACTIONS(1303), 1,
      anon_sym_QMARK,
    ACTIONS(1305), 1,
      anon_sym_TILDE,
    ACTIONS(1313), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1315), 1,
      sym__number_literal,
    ACTIONS(1317), 1,
      anon_sym_SQUOTE,
    ACTIONS(1319), 1,
      anon_sym_DQUOTE,
    ACTIONS(1329), 1,
      sym__raw_string_literal,
    ACTIONS(1331), 1,
      sym__external_open_parenthesis,
    ACTIONS(1333), 1,
      sym__external_open_brace,
    ACTIONS(8531), 1,
      anon_sym_BANG,
    ACTIONS(9195), 1,
      sym_dot_dot_i,
    ACTIONS(9197), 1,
      sym__newline,
    STATE(23), 1,
      sym__open_parenthesis,
    STATE(180), 1,
      sym__open_brace,
    STATE(2264), 1,
      sym__double_quoted_string,
    STATE(2265), 1,
      sym__single_quoted_string,
    STATE(2284), 1,
      sym_string,
    STATE(3287), 1,
      aux_sym_function_definition_repeat1,
    STATE(5147), 1,
      sym__string_or_identifier,
    ACTIONS(1309), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2266), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1323), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9193), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1243), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [35862] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1289), 1,
      sym_identifier,
    ACTIONS(1291), 1,
      anon_sym_BSLASH,
    ACTIONS(1293), 1,
      anon_sym_function,
    ACTIONS(1295), 1,
      anon_sym_if,
    ACTIONS(1297), 1,
      anon_sym_for,
    ACTIONS(1299), 1,
      anon_sym_while,
    ACTIONS(1301), 1,
      anon_sym_repeat,
    ACTIONS(1303), 1,
      anon_sym_QMARK,
    ACTIONS(1305), 1,
      anon_sym_TILDE,
    ACTIONS(1313), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1315), 1,
      sym__number_literal,
    ACTIONS(1317), 1,
      anon_sym_SQUOTE,
    ACTIONS(1319), 1,
      anon_sym_DQUOTE,
    ACTIONS(1329), 1,
      sym__raw_string_literal,
    ACTIONS(1331), 1,
      sym__external_open_parenthesis,
    ACTIONS(1333), 1,
      sym__external_open_brace,
    ACTIONS(8531), 1,
      anon_sym_BANG,
    ACTIONS(9201), 1,
      sym_dot_dot_i,
    ACTIONS(9203), 1,
      sym__newline,
    STATE(23), 1,
      sym__open_parenthesis,
    STATE(180), 1,
      sym__open_brace,
    STATE(2264), 1,
      sym__double_quoted_string,
    STATE(2265), 1,
      sym__single_quoted_string,
    STATE(2284), 1,
      sym_string,
    STATE(3288), 1,
      aux_sym_function_definition_repeat1,
    STATE(5147), 1,
      sym__string_or_identifier,
    ACTIONS(1309), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2266), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1323), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9199), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1244), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [35991] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1433), 1,
      sym_identifier,
    ACTIONS(1435), 1,
      anon_sym_BSLASH,
    ACTIONS(1437), 1,
      anon_sym_function,
    ACTIONS(1439), 1,
      anon_sym_if,
    ACTIONS(1441), 1,
      anon_sym_for,
    ACTIONS(1443), 1,
      anon_sym_while,
    ACTIONS(1445), 1,
      anon_sym_repeat,
    ACTIONS(1447), 1,
      anon_sym_QMARK,
    ACTIONS(1449), 1,
      anon_sym_TILDE,
    ACTIONS(1457), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1459), 1,
      sym__number_literal,
    ACTIONS(1461), 1,
      anon_sym_SQUOTE,
    ACTIONS(1463), 1,
      anon_sym_DQUOTE,
    ACTIONS(1473), 1,
      sym__raw_string_literal,
    ACTIONS(1475), 1,
      sym__external_open_parenthesis,
    ACTIONS(1477), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8097), 1,
      anon_sym_BANG,
    ACTIONS(9207), 1,
      sym_dot_dot_i,
    STATE(76), 1,
      sym__open_parenthesis,
    STATE(188), 1,
      sym__open_brace,
    STATE(2234), 1,
      sym_string,
    STATE(2236), 1,
      sym__single_quoted_string,
    STATE(2237), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5150), 1,
      sym__string_or_identifier,
    ACTIONS(1453), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2235), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1467), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9205), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1107), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [36120] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1289), 1,
      sym_identifier,
    ACTIONS(1291), 1,
      anon_sym_BSLASH,
    ACTIONS(1293), 1,
      anon_sym_function,
    ACTIONS(1295), 1,
      anon_sym_if,
    ACTIONS(1297), 1,
      anon_sym_for,
    ACTIONS(1299), 1,
      anon_sym_while,
    ACTIONS(1301), 1,
      anon_sym_repeat,
    ACTIONS(1303), 1,
      anon_sym_QMARK,
    ACTIONS(1305), 1,
      anon_sym_TILDE,
    ACTIONS(1313), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1315), 1,
      sym__number_literal,
    ACTIONS(1317), 1,
      anon_sym_SQUOTE,
    ACTIONS(1319), 1,
      anon_sym_DQUOTE,
    ACTIONS(1329), 1,
      sym__raw_string_literal,
    ACTIONS(1331), 1,
      sym__external_open_parenthesis,
    ACTIONS(1333), 1,
      sym__external_open_brace,
    ACTIONS(8531), 1,
      anon_sym_BANG,
    ACTIONS(9211), 1,
      sym_dot_dot_i,
    ACTIONS(9213), 1,
      sym__newline,
    STATE(23), 1,
      sym__open_parenthesis,
    STATE(180), 1,
      sym__open_brace,
    STATE(2264), 1,
      sym__double_quoted_string,
    STATE(2265), 1,
      sym__single_quoted_string,
    STATE(2284), 1,
      sym_string,
    STATE(3289), 1,
      aux_sym_function_definition_repeat1,
    STATE(5147), 1,
      sym__string_or_identifier,
    ACTIONS(1309), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2266), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1323), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9209), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1245), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [36249] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      sym_identifier,
    ACTIONS(55), 1,
      anon_sym_BSLASH,
    ACTIONS(57), 1,
      anon_sym_function,
    ACTIONS(61), 1,
      anon_sym_if,
    ACTIONS(63), 1,
      anon_sym_for,
    ACTIONS(65), 1,
      anon_sym_while,
    ACTIONS(67), 1,
      anon_sym_repeat,
    ACTIONS(69), 1,
      anon_sym_QMARK,
    ACTIONS(71), 1,
      anon_sym_TILDE,
    ACTIONS(79), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(81), 1,
      sym__number_literal,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE,
    ACTIONS(95), 1,
      sym__raw_string_literal,
    ACTIONS(97), 1,
      sym__external_open_parenthesis,
    ACTIONS(99), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8831), 1,
      anon_sym_BANG,
    ACTIONS(9217), 1,
      sym_dot_dot_i,
    STATE(4), 1,
      sym__open_brace,
    STATE(19), 1,
      sym__open_parenthesis,
    STATE(1982), 1,
      sym_string,
    STATE(1985), 1,
      sym__single_quoted_string,
    STATE(1990), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5151), 1,
      sym__string_or_identifier,
    ACTIONS(75), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1984), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(89), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9215), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(489), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [36378] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      sym_identifier,
    ACTIONS(55), 1,
      anon_sym_BSLASH,
    ACTIONS(57), 1,
      anon_sym_function,
    ACTIONS(61), 1,
      anon_sym_if,
    ACTIONS(63), 1,
      anon_sym_for,
    ACTIONS(65), 1,
      anon_sym_while,
    ACTIONS(67), 1,
      anon_sym_repeat,
    ACTIONS(69), 1,
      anon_sym_QMARK,
    ACTIONS(71), 1,
      anon_sym_TILDE,
    ACTIONS(79), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(81), 1,
      sym__number_literal,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE,
    ACTIONS(95), 1,
      sym__raw_string_literal,
    ACTIONS(97), 1,
      sym__external_open_parenthesis,
    ACTIONS(99), 1,
      sym__external_open_brace,
    ACTIONS(8831), 1,
      anon_sym_BANG,
    ACTIONS(9221), 1,
      sym_dot_dot_i,
    ACTIONS(9223), 1,
      sym__newline,
    STATE(4), 1,
      sym__open_brace,
    STATE(19), 1,
      sym__open_parenthesis,
    STATE(1982), 1,
      sym_string,
    STATE(1985), 1,
      sym__single_quoted_string,
    STATE(1990), 1,
      sym__double_quoted_string,
    STATE(3309), 1,
      aux_sym_function_definition_repeat1,
    STATE(5151), 1,
      sym__string_or_identifier,
    ACTIONS(75), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1984), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(89), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9219), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(487), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [36507] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      sym_identifier,
    ACTIONS(55), 1,
      anon_sym_BSLASH,
    ACTIONS(57), 1,
      anon_sym_function,
    ACTIONS(61), 1,
      anon_sym_if,
    ACTIONS(63), 1,
      anon_sym_for,
    ACTIONS(65), 1,
      anon_sym_while,
    ACTIONS(67), 1,
      anon_sym_repeat,
    ACTIONS(69), 1,
      anon_sym_QMARK,
    ACTIONS(71), 1,
      anon_sym_TILDE,
    ACTIONS(79), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(81), 1,
      sym__number_literal,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE,
    ACTIONS(95), 1,
      sym__raw_string_literal,
    ACTIONS(97), 1,
      sym__external_open_parenthesis,
    ACTIONS(99), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8831), 1,
      anon_sym_BANG,
    ACTIONS(9227), 1,
      sym_dot_dot_i,
    STATE(4), 1,
      sym__open_brace,
    STATE(19), 1,
      sym__open_parenthesis,
    STATE(1982), 1,
      sym_string,
    STATE(1985), 1,
      sym__single_quoted_string,
    STATE(1990), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5151), 1,
      sym__string_or_identifier,
    ACTIONS(75), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1984), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(89), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9225), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(517), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [36636] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4214), 1,
      sym_identifier,
    ACTIONS(4216), 1,
      anon_sym_BSLASH,
    ACTIONS(4218), 1,
      anon_sym_function,
    ACTIONS(4220), 1,
      anon_sym_if,
    ACTIONS(4222), 1,
      anon_sym_for,
    ACTIONS(4224), 1,
      anon_sym_while,
    ACTIONS(4226), 1,
      anon_sym_repeat,
    ACTIONS(4228), 1,
      anon_sym_QMARK,
    ACTIONS(4230), 1,
      anon_sym_TILDE,
    ACTIONS(4238), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4240), 1,
      sym__number_literal,
    ACTIONS(4242), 1,
      anon_sym_SQUOTE,
    ACTIONS(4244), 1,
      anon_sym_DQUOTE,
    ACTIONS(4254), 1,
      sym__raw_string_literal,
    ACTIONS(4256), 1,
      sym__external_open_parenthesis,
    ACTIONS(4258), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9229), 1,
      anon_sym_BANG,
    ACTIONS(9233), 1,
      sym_dot_dot_i,
    STATE(51), 1,
      sym__open_brace,
    STATE(287), 1,
      sym__open_parenthesis,
    STATE(4674), 1,
      sym__single_quoted_string,
    STATE(4678), 1,
      sym__double_quoted_string,
    STATE(4681), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5129), 1,
      sym__string_or_identifier,
    ACTIONS(4234), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4680), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4248), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9231), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4378), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [36765] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4214), 1,
      sym_identifier,
    ACTIONS(4216), 1,
      anon_sym_BSLASH,
    ACTIONS(4218), 1,
      anon_sym_function,
    ACTIONS(4220), 1,
      anon_sym_if,
    ACTIONS(4222), 1,
      anon_sym_for,
    ACTIONS(4224), 1,
      anon_sym_while,
    ACTIONS(4226), 1,
      anon_sym_repeat,
    ACTIONS(4228), 1,
      anon_sym_QMARK,
    ACTIONS(4230), 1,
      anon_sym_TILDE,
    ACTIONS(4238), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4240), 1,
      sym__number_literal,
    ACTIONS(4242), 1,
      anon_sym_SQUOTE,
    ACTIONS(4244), 1,
      anon_sym_DQUOTE,
    ACTIONS(4254), 1,
      sym__raw_string_literal,
    ACTIONS(4256), 1,
      sym__external_open_parenthesis,
    ACTIONS(4258), 1,
      sym__external_open_brace,
    ACTIONS(9229), 1,
      anon_sym_BANG,
    ACTIONS(9237), 1,
      sym_dot_dot_i,
    ACTIONS(9239), 1,
      sym__newline,
    STATE(51), 1,
      sym__open_brace,
    STATE(287), 1,
      sym__open_parenthesis,
    STATE(3312), 1,
      aux_sym_function_definition_repeat1,
    STATE(4674), 1,
      sym__single_quoted_string,
    STATE(4678), 1,
      sym__double_quoted_string,
    STATE(4681), 1,
      sym_string,
    STATE(5129), 1,
      sym__string_or_identifier,
    ACTIONS(4234), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4680), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4248), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9235), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4377), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [36894] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4214), 1,
      sym_identifier,
    ACTIONS(4216), 1,
      anon_sym_BSLASH,
    ACTIONS(4218), 1,
      anon_sym_function,
    ACTIONS(4220), 1,
      anon_sym_if,
    ACTIONS(4222), 1,
      anon_sym_for,
    ACTIONS(4224), 1,
      anon_sym_while,
    ACTIONS(4226), 1,
      anon_sym_repeat,
    ACTIONS(4228), 1,
      anon_sym_QMARK,
    ACTIONS(4230), 1,
      anon_sym_TILDE,
    ACTIONS(4238), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4240), 1,
      sym__number_literal,
    ACTIONS(4242), 1,
      anon_sym_SQUOTE,
    ACTIONS(4244), 1,
      anon_sym_DQUOTE,
    ACTIONS(4254), 1,
      sym__raw_string_literal,
    ACTIONS(4256), 1,
      sym__external_open_parenthesis,
    ACTIONS(4258), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9229), 1,
      anon_sym_BANG,
    ACTIONS(9243), 1,
      sym_dot_dot_i,
    STATE(51), 1,
      sym__open_brace,
    STATE(287), 1,
      sym__open_parenthesis,
    STATE(4674), 1,
      sym__single_quoted_string,
    STATE(4678), 1,
      sym__double_quoted_string,
    STATE(4681), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5129), 1,
      sym__string_or_identifier,
    ACTIONS(4234), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4680), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4248), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9241), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4376), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [37023] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4214), 1,
      sym_identifier,
    ACTIONS(4216), 1,
      anon_sym_BSLASH,
    ACTIONS(4218), 1,
      anon_sym_function,
    ACTIONS(4220), 1,
      anon_sym_if,
    ACTIONS(4222), 1,
      anon_sym_for,
    ACTIONS(4224), 1,
      anon_sym_while,
    ACTIONS(4226), 1,
      anon_sym_repeat,
    ACTIONS(4228), 1,
      anon_sym_QMARK,
    ACTIONS(4230), 1,
      anon_sym_TILDE,
    ACTIONS(4238), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4240), 1,
      sym__number_literal,
    ACTIONS(4242), 1,
      anon_sym_SQUOTE,
    ACTIONS(4244), 1,
      anon_sym_DQUOTE,
    ACTIONS(4254), 1,
      sym__raw_string_literal,
    ACTIONS(4256), 1,
      sym__external_open_parenthesis,
    ACTIONS(4258), 1,
      sym__external_open_brace,
    ACTIONS(9229), 1,
      anon_sym_BANG,
    ACTIONS(9247), 1,
      sym_dot_dot_i,
    ACTIONS(9249), 1,
      sym__newline,
    STATE(51), 1,
      sym__open_brace,
    STATE(287), 1,
      sym__open_parenthesis,
    STATE(3314), 1,
      aux_sym_function_definition_repeat1,
    STATE(4674), 1,
      sym__single_quoted_string,
    STATE(4678), 1,
      sym__double_quoted_string,
    STATE(4681), 1,
      sym_string,
    STATE(5129), 1,
      sym__string_or_identifier,
    ACTIONS(4234), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4680), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4248), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9245), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4375), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [37152] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1385), 1,
      sym_identifier,
    ACTIONS(1387), 1,
      anon_sym_BSLASH,
    ACTIONS(1389), 1,
      anon_sym_function,
    ACTIONS(1391), 1,
      anon_sym_if,
    ACTIONS(1393), 1,
      anon_sym_for,
    ACTIONS(1395), 1,
      anon_sym_while,
    ACTIONS(1397), 1,
      anon_sym_repeat,
    ACTIONS(1399), 1,
      anon_sym_QMARK,
    ACTIONS(1401), 1,
      anon_sym_TILDE,
    ACTIONS(1409), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1411), 1,
      sym__number_literal,
    ACTIONS(1413), 1,
      anon_sym_SQUOTE,
    ACTIONS(1415), 1,
      anon_sym_DQUOTE,
    ACTIONS(1425), 1,
      sym__raw_string_literal,
    ACTIONS(1427), 1,
      sym__external_open_parenthesis,
    ACTIONS(1429), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9251), 1,
      anon_sym_BANG,
    ACTIONS(9255), 1,
      sym_dot_dot_i,
    STATE(64), 1,
      sym__open_parenthesis,
    STATE(199), 1,
      sym__open_brace,
    STATE(2309), 1,
      sym__double_quoted_string,
    STATE(2310), 1,
      sym__single_quoted_string,
    STATE(2312), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5134), 1,
      sym__string_or_identifier,
    ACTIONS(1405), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2311), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1419), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9253), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(856), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [37281] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1385), 1,
      sym_identifier,
    ACTIONS(1387), 1,
      anon_sym_BSLASH,
    ACTIONS(1389), 1,
      anon_sym_function,
    ACTIONS(1391), 1,
      anon_sym_if,
    ACTIONS(1393), 1,
      anon_sym_for,
    ACTIONS(1395), 1,
      anon_sym_while,
    ACTIONS(1397), 1,
      anon_sym_repeat,
    ACTIONS(1399), 1,
      anon_sym_QMARK,
    ACTIONS(1401), 1,
      anon_sym_TILDE,
    ACTIONS(1409), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1411), 1,
      sym__number_literal,
    ACTIONS(1413), 1,
      anon_sym_SQUOTE,
    ACTIONS(1415), 1,
      anon_sym_DQUOTE,
    ACTIONS(1425), 1,
      sym__raw_string_literal,
    ACTIONS(1427), 1,
      sym__external_open_parenthesis,
    ACTIONS(1429), 1,
      sym__external_open_brace,
    ACTIONS(9251), 1,
      anon_sym_BANG,
    ACTIONS(9259), 1,
      sym_dot_dot_i,
    ACTIONS(9261), 1,
      sym__newline,
    STATE(64), 1,
      sym__open_parenthesis,
    STATE(199), 1,
      sym__open_brace,
    STATE(2309), 1,
      sym__double_quoted_string,
    STATE(2310), 1,
      sym__single_quoted_string,
    STATE(2312), 1,
      sym_string,
    STATE(3316), 1,
      aux_sym_function_definition_repeat1,
    STATE(5134), 1,
      sym__string_or_identifier,
    ACTIONS(1405), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2311), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1419), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9257), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(859), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [37410] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(9267), 1,
      sym_dot_dot_i,
    ACTIONS(9269), 1,
      sym__newline,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(3362), 1,
      aux_sym_function_definition_repeat1,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9265), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4465), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [37539] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(9273), 1,
      sym_dot_dot_i,
    ACTIONS(9275), 1,
      sym__newline,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(3483), 1,
      aux_sym_function_definition_repeat1,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9271), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4485), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [37668] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1385), 1,
      sym_identifier,
    ACTIONS(1387), 1,
      anon_sym_BSLASH,
    ACTIONS(1389), 1,
      anon_sym_function,
    ACTIONS(1391), 1,
      anon_sym_if,
    ACTIONS(1393), 1,
      anon_sym_for,
    ACTIONS(1395), 1,
      anon_sym_while,
    ACTIONS(1397), 1,
      anon_sym_repeat,
    ACTIONS(1399), 1,
      anon_sym_QMARK,
    ACTIONS(1401), 1,
      anon_sym_TILDE,
    ACTIONS(1409), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1411), 1,
      sym__number_literal,
    ACTIONS(1413), 1,
      anon_sym_SQUOTE,
    ACTIONS(1415), 1,
      anon_sym_DQUOTE,
    ACTIONS(1425), 1,
      sym__raw_string_literal,
    ACTIONS(1427), 1,
      sym__external_open_parenthesis,
    ACTIONS(1429), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9251), 1,
      anon_sym_BANG,
    ACTIONS(9279), 1,
      sym_dot_dot_i,
    STATE(64), 1,
      sym__open_parenthesis,
    STATE(199), 1,
      sym__open_brace,
    STATE(2309), 1,
      sym__double_quoted_string,
    STATE(2310), 1,
      sym__single_quoted_string,
    STATE(2312), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5134), 1,
      sym__string_or_identifier,
    ACTIONS(1405), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2311), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1419), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9277), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(860), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [37797] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(9283), 1,
      sym_dot_dot_i,
    ACTIONS(9285), 1,
      sym__newline,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(3518), 1,
      aux_sym_function_definition_repeat1,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9281), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4486), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [37926] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(9289), 1,
      sym_dot_dot_i,
    ACTIONS(9291), 1,
      sym__newline,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(3523), 1,
      aux_sym_function_definition_repeat1,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9287), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4531), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [38055] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      sym_identifier,
    ACTIONS(55), 1,
      anon_sym_BSLASH,
    ACTIONS(57), 1,
      anon_sym_function,
    ACTIONS(61), 1,
      anon_sym_if,
    ACTIONS(63), 1,
      anon_sym_for,
    ACTIONS(65), 1,
      anon_sym_while,
    ACTIONS(67), 1,
      anon_sym_repeat,
    ACTIONS(69), 1,
      anon_sym_QMARK,
    ACTIONS(71), 1,
      anon_sym_TILDE,
    ACTIONS(79), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(81), 1,
      sym__number_literal,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE,
    ACTIONS(95), 1,
      sym__raw_string_literal,
    ACTIONS(97), 1,
      sym__external_open_parenthesis,
    ACTIONS(99), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8831), 1,
      anon_sym_BANG,
    ACTIONS(9295), 1,
      sym_dot_dot_i,
    STATE(4), 1,
      sym__open_brace,
    STATE(19), 1,
      sym__open_parenthesis,
    STATE(1982), 1,
      sym_string,
    STATE(1985), 1,
      sym__single_quoted_string,
    STATE(1990), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5151), 1,
      sym__string_or_identifier,
    ACTIONS(75), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1984), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(89), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9293), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(516), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [38184] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1433), 1,
      sym_identifier,
    ACTIONS(1435), 1,
      anon_sym_BSLASH,
    ACTIONS(1437), 1,
      anon_sym_function,
    ACTIONS(1439), 1,
      anon_sym_if,
    ACTIONS(1441), 1,
      anon_sym_for,
    ACTIONS(1443), 1,
      anon_sym_while,
    ACTIONS(1445), 1,
      anon_sym_repeat,
    ACTIONS(1447), 1,
      anon_sym_QMARK,
    ACTIONS(1449), 1,
      anon_sym_TILDE,
    ACTIONS(1457), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1459), 1,
      sym__number_literal,
    ACTIONS(1461), 1,
      anon_sym_SQUOTE,
    ACTIONS(1463), 1,
      anon_sym_DQUOTE,
    ACTIONS(1473), 1,
      sym__raw_string_literal,
    ACTIONS(1475), 1,
      sym__external_open_parenthesis,
    ACTIONS(1477), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8097), 1,
      anon_sym_BANG,
    ACTIONS(9299), 1,
      sym_dot_dot_i,
    STATE(76), 1,
      sym__open_parenthesis,
    STATE(188), 1,
      sym__open_brace,
    STATE(2234), 1,
      sym_string,
    STATE(2236), 1,
      sym__single_quoted_string,
    STATE(2237), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5150), 1,
      sym__string_or_identifier,
    ACTIONS(1453), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2235), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1467), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9297), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1106), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [38313] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1241), 1,
      sym_identifier,
    ACTIONS(1243), 1,
      anon_sym_BSLASH,
    ACTIONS(1245), 1,
      anon_sym_function,
    ACTIONS(1247), 1,
      anon_sym_if,
    ACTIONS(1249), 1,
      anon_sym_for,
    ACTIONS(1251), 1,
      anon_sym_while,
    ACTIONS(1253), 1,
      anon_sym_repeat,
    ACTIONS(1255), 1,
      anon_sym_QMARK,
    ACTIONS(1257), 1,
      anon_sym_TILDE,
    ACTIONS(1265), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1267), 1,
      sym__number_literal,
    ACTIONS(1269), 1,
      anon_sym_SQUOTE,
    ACTIONS(1271), 1,
      anon_sym_DQUOTE,
    ACTIONS(1281), 1,
      sym__raw_string_literal,
    ACTIONS(1283), 1,
      sym__external_open_parenthesis,
    ACTIONS(1287), 1,
      sym__external_open_brace,
    ACTIONS(8543), 1,
      anon_sym_BANG,
    ACTIONS(9303), 1,
      sym_dot_dot_i,
    ACTIONS(9305), 1,
      sym__newline,
    STATE(11), 1,
      sym__open_brace,
    STATE(120), 1,
      sym__open_parenthesis,
    STATE(2271), 1,
      sym_string,
    STATE(2273), 1,
      sym__single_quoted_string,
    STATE(2274), 1,
      sym__double_quoted_string,
    STATE(3338), 1,
      aux_sym_function_definition_repeat1,
    STATE(5157), 1,
      sym__string_or_identifier,
    ACTIONS(1261), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2272), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1275), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9301), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1248), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [38442] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1241), 1,
      sym_identifier,
    ACTIONS(1243), 1,
      anon_sym_BSLASH,
    ACTIONS(1245), 1,
      anon_sym_function,
    ACTIONS(1247), 1,
      anon_sym_if,
    ACTIONS(1249), 1,
      anon_sym_for,
    ACTIONS(1251), 1,
      anon_sym_while,
    ACTIONS(1253), 1,
      anon_sym_repeat,
    ACTIONS(1255), 1,
      anon_sym_QMARK,
    ACTIONS(1257), 1,
      anon_sym_TILDE,
    ACTIONS(1265), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1267), 1,
      sym__number_literal,
    ACTIONS(1269), 1,
      anon_sym_SQUOTE,
    ACTIONS(1271), 1,
      anon_sym_DQUOTE,
    ACTIONS(1281), 1,
      sym__raw_string_literal,
    ACTIONS(1283), 1,
      sym__external_open_parenthesis,
    ACTIONS(1287), 1,
      sym__external_open_brace,
    ACTIONS(8543), 1,
      anon_sym_BANG,
    ACTIONS(9309), 1,
      sym_dot_dot_i,
    ACTIONS(9311), 1,
      sym__newline,
    STATE(11), 1,
      sym__open_brace,
    STATE(120), 1,
      sym__open_parenthesis,
    STATE(2271), 1,
      sym_string,
    STATE(2273), 1,
      sym__single_quoted_string,
    STATE(2274), 1,
      sym__double_quoted_string,
    STATE(3340), 1,
      aux_sym_function_definition_repeat1,
    STATE(5157), 1,
      sym__string_or_identifier,
    ACTIONS(1261), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2272), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1275), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9307), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1249), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [38571] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1241), 1,
      sym_identifier,
    ACTIONS(1243), 1,
      anon_sym_BSLASH,
    ACTIONS(1245), 1,
      anon_sym_function,
    ACTIONS(1247), 1,
      anon_sym_if,
    ACTIONS(1249), 1,
      anon_sym_for,
    ACTIONS(1251), 1,
      anon_sym_while,
    ACTIONS(1253), 1,
      anon_sym_repeat,
    ACTIONS(1255), 1,
      anon_sym_QMARK,
    ACTIONS(1257), 1,
      anon_sym_TILDE,
    ACTIONS(1265), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1267), 1,
      sym__number_literal,
    ACTIONS(1269), 1,
      anon_sym_SQUOTE,
    ACTIONS(1271), 1,
      anon_sym_DQUOTE,
    ACTIONS(1281), 1,
      sym__raw_string_literal,
    ACTIONS(1283), 1,
      sym__external_open_parenthesis,
    ACTIONS(1287), 1,
      sym__external_open_brace,
    ACTIONS(8543), 1,
      anon_sym_BANG,
    ACTIONS(9315), 1,
      sym_dot_dot_i,
    ACTIONS(9317), 1,
      sym__newline,
    STATE(11), 1,
      sym__open_brace,
    STATE(120), 1,
      sym__open_parenthesis,
    STATE(2271), 1,
      sym_string,
    STATE(2273), 1,
      sym__single_quoted_string,
    STATE(2274), 1,
      sym__double_quoted_string,
    STATE(3342), 1,
      aux_sym_function_definition_repeat1,
    STATE(5157), 1,
      sym__string_or_identifier,
    ACTIONS(1261), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2272), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1275), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9313), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1250), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [38700] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1241), 1,
      sym_identifier,
    ACTIONS(1243), 1,
      anon_sym_BSLASH,
    ACTIONS(1245), 1,
      anon_sym_function,
    ACTIONS(1247), 1,
      anon_sym_if,
    ACTIONS(1249), 1,
      anon_sym_for,
    ACTIONS(1251), 1,
      anon_sym_while,
    ACTIONS(1253), 1,
      anon_sym_repeat,
    ACTIONS(1255), 1,
      anon_sym_QMARK,
    ACTIONS(1257), 1,
      anon_sym_TILDE,
    ACTIONS(1265), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1267), 1,
      sym__number_literal,
    ACTIONS(1269), 1,
      anon_sym_SQUOTE,
    ACTIONS(1271), 1,
      anon_sym_DQUOTE,
    ACTIONS(1281), 1,
      sym__raw_string_literal,
    ACTIONS(1283), 1,
      sym__external_open_parenthesis,
    ACTIONS(1287), 1,
      sym__external_open_brace,
    ACTIONS(8543), 1,
      anon_sym_BANG,
    ACTIONS(9321), 1,
      sym_dot_dot_i,
    ACTIONS(9323), 1,
      sym__newline,
    STATE(11), 1,
      sym__open_brace,
    STATE(120), 1,
      sym__open_parenthesis,
    STATE(2271), 1,
      sym_string,
    STATE(2273), 1,
      sym__single_quoted_string,
    STATE(2274), 1,
      sym__double_quoted_string,
    STATE(3344), 1,
      aux_sym_function_definition_repeat1,
    STATE(5157), 1,
      sym__string_or_identifier,
    ACTIONS(1261), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2272), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1275), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9319), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1251), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [38829] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1433), 1,
      sym_identifier,
    ACTIONS(1435), 1,
      anon_sym_BSLASH,
    ACTIONS(1437), 1,
      anon_sym_function,
    ACTIONS(1439), 1,
      anon_sym_if,
    ACTIONS(1441), 1,
      anon_sym_for,
    ACTIONS(1443), 1,
      anon_sym_while,
    ACTIONS(1445), 1,
      anon_sym_repeat,
    ACTIONS(1447), 1,
      anon_sym_QMARK,
    ACTIONS(1449), 1,
      anon_sym_TILDE,
    ACTIONS(1457), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1459), 1,
      sym__number_literal,
    ACTIONS(1461), 1,
      anon_sym_SQUOTE,
    ACTIONS(1463), 1,
      anon_sym_DQUOTE,
    ACTIONS(1473), 1,
      sym__raw_string_literal,
    ACTIONS(1475), 1,
      sym__external_open_parenthesis,
    ACTIONS(1477), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8097), 1,
      anon_sym_BANG,
    ACTIONS(9327), 1,
      sym_dot_dot_i,
    STATE(76), 1,
      sym__open_parenthesis,
    STATE(188), 1,
      sym__open_brace,
    STATE(2234), 1,
      sym_string,
    STATE(2236), 1,
      sym__single_quoted_string,
    STATE(2237), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5150), 1,
      sym__string_or_identifier,
    ACTIONS(1453), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2235), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1467), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9325), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1104), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [38958] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1433), 1,
      sym_identifier,
    ACTIONS(1435), 1,
      anon_sym_BSLASH,
    ACTIONS(1437), 1,
      anon_sym_function,
    ACTIONS(1439), 1,
      anon_sym_if,
    ACTIONS(1441), 1,
      anon_sym_for,
    ACTIONS(1443), 1,
      anon_sym_while,
    ACTIONS(1445), 1,
      anon_sym_repeat,
    ACTIONS(1447), 1,
      anon_sym_QMARK,
    ACTIONS(1449), 1,
      anon_sym_TILDE,
    ACTIONS(1457), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1459), 1,
      sym__number_literal,
    ACTIONS(1461), 1,
      anon_sym_SQUOTE,
    ACTIONS(1463), 1,
      anon_sym_DQUOTE,
    ACTIONS(1473), 1,
      sym__raw_string_literal,
    ACTIONS(1475), 1,
      sym__external_open_parenthesis,
    ACTIONS(1477), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8097), 1,
      anon_sym_BANG,
    ACTIONS(9331), 1,
      sym_dot_dot_i,
    STATE(76), 1,
      sym__open_parenthesis,
    STATE(188), 1,
      sym__open_brace,
    STATE(2234), 1,
      sym_string,
    STATE(2236), 1,
      sym__single_quoted_string,
    STATE(2237), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5150), 1,
      sym__string_or_identifier,
    ACTIONS(1453), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2235), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1467), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9329), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1103), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [39087] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1385), 1,
      sym_identifier,
    ACTIONS(1387), 1,
      anon_sym_BSLASH,
    ACTIONS(1389), 1,
      anon_sym_function,
    ACTIONS(1391), 1,
      anon_sym_if,
    ACTIONS(1393), 1,
      anon_sym_for,
    ACTIONS(1395), 1,
      anon_sym_while,
    ACTIONS(1397), 1,
      anon_sym_repeat,
    ACTIONS(1399), 1,
      anon_sym_QMARK,
    ACTIONS(1401), 1,
      anon_sym_TILDE,
    ACTIONS(1409), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1411), 1,
      sym__number_literal,
    ACTIONS(1413), 1,
      anon_sym_SQUOTE,
    ACTIONS(1415), 1,
      anon_sym_DQUOTE,
    ACTIONS(1425), 1,
      sym__raw_string_literal,
    ACTIONS(1427), 1,
      sym__external_open_parenthesis,
    ACTIONS(1429), 1,
      sym__external_open_brace,
    ACTIONS(9251), 1,
      anon_sym_BANG,
    ACTIONS(9335), 1,
      sym_dot_dot_i,
    ACTIONS(9337), 1,
      sym__newline,
    STATE(64), 1,
      sym__open_parenthesis,
    STATE(199), 1,
      sym__open_brace,
    STATE(2309), 1,
      sym__double_quoted_string,
    STATE(2310), 1,
      sym__single_quoted_string,
    STATE(2312), 1,
      sym_string,
    STATE(3320), 1,
      aux_sym_function_definition_repeat1,
    STATE(5134), 1,
      sym__string_or_identifier,
    ACTIONS(1405), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2311), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1419), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9333), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(864), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [39216] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1433), 1,
      sym_identifier,
    ACTIONS(1435), 1,
      anon_sym_BSLASH,
    ACTIONS(1437), 1,
      anon_sym_function,
    ACTIONS(1439), 1,
      anon_sym_if,
    ACTIONS(1441), 1,
      anon_sym_for,
    ACTIONS(1443), 1,
      anon_sym_while,
    ACTIONS(1445), 1,
      anon_sym_repeat,
    ACTIONS(1447), 1,
      anon_sym_QMARK,
    ACTIONS(1449), 1,
      anon_sym_TILDE,
    ACTIONS(1457), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1459), 1,
      sym__number_literal,
    ACTIONS(1461), 1,
      anon_sym_SQUOTE,
    ACTIONS(1463), 1,
      anon_sym_DQUOTE,
    ACTIONS(1473), 1,
      sym__raw_string_literal,
    ACTIONS(1475), 1,
      sym__external_open_parenthesis,
    ACTIONS(1477), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8097), 1,
      anon_sym_BANG,
    ACTIONS(9341), 1,
      sym_dot_dot_i,
    STATE(76), 1,
      sym__open_parenthesis,
    STATE(188), 1,
      sym__open_brace,
    STATE(2234), 1,
      sym_string,
    STATE(2236), 1,
      sym__single_quoted_string,
    STATE(2237), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5150), 1,
      sym__string_or_identifier,
    ACTIONS(1453), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2235), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1467), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9339), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1102), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [39345] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1433), 1,
      sym_identifier,
    ACTIONS(1435), 1,
      anon_sym_BSLASH,
    ACTIONS(1437), 1,
      anon_sym_function,
    ACTIONS(1439), 1,
      anon_sym_if,
    ACTIONS(1441), 1,
      anon_sym_for,
    ACTIONS(1443), 1,
      anon_sym_while,
    ACTIONS(1445), 1,
      anon_sym_repeat,
    ACTIONS(1447), 1,
      anon_sym_QMARK,
    ACTIONS(1449), 1,
      anon_sym_TILDE,
    ACTIONS(1457), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1459), 1,
      sym__number_literal,
    ACTIONS(1461), 1,
      anon_sym_SQUOTE,
    ACTIONS(1463), 1,
      anon_sym_DQUOTE,
    ACTIONS(1473), 1,
      sym__raw_string_literal,
    ACTIONS(1475), 1,
      sym__external_open_parenthesis,
    ACTIONS(1477), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8097), 1,
      anon_sym_BANG,
    ACTIONS(9345), 1,
      sym_dot_dot_i,
    STATE(76), 1,
      sym__open_parenthesis,
    STATE(188), 1,
      sym__open_brace,
    STATE(2234), 1,
      sym_string,
    STATE(2236), 1,
      sym__single_quoted_string,
    STATE(2237), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5150), 1,
      sym__string_or_identifier,
    ACTIONS(1453), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2235), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1467), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9343), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1101), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [39474] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1433), 1,
      sym_identifier,
    ACTIONS(1435), 1,
      anon_sym_BSLASH,
    ACTIONS(1437), 1,
      anon_sym_function,
    ACTIONS(1439), 1,
      anon_sym_if,
    ACTIONS(1441), 1,
      anon_sym_for,
    ACTIONS(1443), 1,
      anon_sym_while,
    ACTIONS(1445), 1,
      anon_sym_repeat,
    ACTIONS(1447), 1,
      anon_sym_QMARK,
    ACTIONS(1449), 1,
      anon_sym_TILDE,
    ACTIONS(1457), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1459), 1,
      sym__number_literal,
    ACTIONS(1461), 1,
      anon_sym_SQUOTE,
    ACTIONS(1463), 1,
      anon_sym_DQUOTE,
    ACTIONS(1473), 1,
      sym__raw_string_literal,
    ACTIONS(1475), 1,
      sym__external_open_parenthesis,
    ACTIONS(1477), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8097), 1,
      anon_sym_BANG,
    ACTIONS(9349), 1,
      sym_dot_dot_i,
    STATE(76), 1,
      sym__open_parenthesis,
    STATE(188), 1,
      sym__open_brace,
    STATE(2234), 1,
      sym_string,
    STATE(2236), 1,
      sym__single_quoted_string,
    STATE(2237), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5150), 1,
      sym__string_or_identifier,
    ACTIONS(1453), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2235), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1467), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9347), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1100), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [39603] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1433), 1,
      sym_identifier,
    ACTIONS(1435), 1,
      anon_sym_BSLASH,
    ACTIONS(1437), 1,
      anon_sym_function,
    ACTIONS(1439), 1,
      anon_sym_if,
    ACTIONS(1441), 1,
      anon_sym_for,
    ACTIONS(1443), 1,
      anon_sym_while,
    ACTIONS(1445), 1,
      anon_sym_repeat,
    ACTIONS(1447), 1,
      anon_sym_QMARK,
    ACTIONS(1449), 1,
      anon_sym_TILDE,
    ACTIONS(1457), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1459), 1,
      sym__number_literal,
    ACTIONS(1461), 1,
      anon_sym_SQUOTE,
    ACTIONS(1463), 1,
      anon_sym_DQUOTE,
    ACTIONS(1473), 1,
      sym__raw_string_literal,
    ACTIONS(1475), 1,
      sym__external_open_parenthesis,
    ACTIONS(1477), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8097), 1,
      anon_sym_BANG,
    ACTIONS(9353), 1,
      sym_dot_dot_i,
    STATE(76), 1,
      sym__open_parenthesis,
    STATE(188), 1,
      sym__open_brace,
    STATE(2234), 1,
      sym_string,
    STATE(2236), 1,
      sym__single_quoted_string,
    STATE(2237), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5150), 1,
      sym__string_or_identifier,
    ACTIONS(1453), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2235), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1467), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9351), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1099), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [39732] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      sym_identifier,
    ACTIONS(55), 1,
      anon_sym_BSLASH,
    ACTIONS(57), 1,
      anon_sym_function,
    ACTIONS(61), 1,
      anon_sym_if,
    ACTIONS(63), 1,
      anon_sym_for,
    ACTIONS(65), 1,
      anon_sym_while,
    ACTIONS(67), 1,
      anon_sym_repeat,
    ACTIONS(69), 1,
      anon_sym_QMARK,
    ACTIONS(71), 1,
      anon_sym_TILDE,
    ACTIONS(79), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(81), 1,
      sym__number_literal,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE,
    ACTIONS(95), 1,
      sym__raw_string_literal,
    ACTIONS(97), 1,
      sym__external_open_parenthesis,
    ACTIONS(99), 1,
      sym__external_open_brace,
    ACTIONS(8831), 1,
      anon_sym_BANG,
    ACTIONS(9357), 1,
      sym_dot_dot_i,
    ACTIONS(9359), 1,
      sym__newline,
    STATE(4), 1,
      sym__open_brace,
    STATE(19), 1,
      sym__open_parenthesis,
    STATE(1982), 1,
      sym_string,
    STATE(1985), 1,
      sym__single_quoted_string,
    STATE(1990), 1,
      sym__double_quoted_string,
    STATE(3299), 1,
      aux_sym_function_definition_repeat1,
    STATE(5151), 1,
      sym__string_or_identifier,
    ACTIONS(75), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1984), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(89), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9355), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(513), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [39861] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      sym_identifier,
    ACTIONS(55), 1,
      anon_sym_BSLASH,
    ACTIONS(57), 1,
      anon_sym_function,
    ACTIONS(61), 1,
      anon_sym_if,
    ACTIONS(63), 1,
      anon_sym_for,
    ACTIONS(65), 1,
      anon_sym_while,
    ACTIONS(67), 1,
      anon_sym_repeat,
    ACTIONS(69), 1,
      anon_sym_QMARK,
    ACTIONS(71), 1,
      anon_sym_TILDE,
    ACTIONS(79), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(81), 1,
      sym__number_literal,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE,
    ACTIONS(95), 1,
      sym__raw_string_literal,
    ACTIONS(97), 1,
      sym__external_open_parenthesis,
    ACTIONS(99), 1,
      sym__external_open_brace,
    ACTIONS(8831), 1,
      anon_sym_BANG,
    ACTIONS(9363), 1,
      sym_dot_dot_i,
    ACTIONS(9365), 1,
      sym__newline,
    STATE(4), 1,
      sym__open_brace,
    STATE(19), 1,
      sym__open_parenthesis,
    STATE(1982), 1,
      sym_string,
    STATE(1985), 1,
      sym__single_quoted_string,
    STATE(1990), 1,
      sym__double_quoted_string,
    STATE(3304), 1,
      aux_sym_function_definition_repeat1,
    STATE(5151), 1,
      sym__string_or_identifier,
    ACTIONS(75), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1984), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(89), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9361), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(512), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [39990] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1241), 1,
      sym_identifier,
    ACTIONS(1243), 1,
      anon_sym_BSLASH,
    ACTIONS(1245), 1,
      anon_sym_function,
    ACTIONS(1247), 1,
      anon_sym_if,
    ACTIONS(1249), 1,
      anon_sym_for,
    ACTIONS(1251), 1,
      anon_sym_while,
    ACTIONS(1253), 1,
      anon_sym_repeat,
    ACTIONS(1255), 1,
      anon_sym_QMARK,
    ACTIONS(1257), 1,
      anon_sym_TILDE,
    ACTIONS(1265), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1267), 1,
      sym__number_literal,
    ACTIONS(1269), 1,
      anon_sym_SQUOTE,
    ACTIONS(1271), 1,
      anon_sym_DQUOTE,
    ACTIONS(1281), 1,
      sym__raw_string_literal,
    ACTIONS(1283), 1,
      sym__external_open_parenthesis,
    ACTIONS(1287), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8543), 1,
      anon_sym_BANG,
    ACTIONS(9369), 1,
      sym_dot_dot_i,
    STATE(11), 1,
      sym__open_brace,
    STATE(120), 1,
      sym__open_parenthesis,
    STATE(2271), 1,
      sym_string,
    STATE(2273), 1,
      sym__single_quoted_string,
    STATE(2274), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5157), 1,
      sym__string_or_identifier,
    ACTIONS(1261), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2272), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1275), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9367), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1254), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [40119] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      sym_identifier,
    ACTIONS(55), 1,
      anon_sym_BSLASH,
    ACTIONS(57), 1,
      anon_sym_function,
    ACTIONS(61), 1,
      anon_sym_if,
    ACTIONS(63), 1,
      anon_sym_for,
    ACTIONS(65), 1,
      anon_sym_while,
    ACTIONS(67), 1,
      anon_sym_repeat,
    ACTIONS(69), 1,
      anon_sym_QMARK,
    ACTIONS(71), 1,
      anon_sym_TILDE,
    ACTIONS(79), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(81), 1,
      sym__number_literal,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE,
    ACTIONS(95), 1,
      sym__raw_string_literal,
    ACTIONS(97), 1,
      sym__external_open_parenthesis,
    ACTIONS(99), 1,
      sym__external_open_brace,
    ACTIONS(8831), 1,
      anon_sym_BANG,
    ACTIONS(9373), 1,
      sym_dot_dot_i,
    ACTIONS(9375), 1,
      sym__newline,
    STATE(4), 1,
      sym__open_brace,
    STATE(19), 1,
      sym__open_parenthesis,
    STATE(1982), 1,
      sym_string,
    STATE(1985), 1,
      sym__single_quoted_string,
    STATE(1990), 1,
      sym__double_quoted_string,
    STATE(3311), 1,
      aux_sym_function_definition_repeat1,
    STATE(5151), 1,
      sym__string_or_identifier,
    ACTIONS(75), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1984), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(89), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9371), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(511), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [40248] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1241), 1,
      sym_identifier,
    ACTIONS(1243), 1,
      anon_sym_BSLASH,
    ACTIONS(1245), 1,
      anon_sym_function,
    ACTIONS(1247), 1,
      anon_sym_if,
    ACTIONS(1249), 1,
      anon_sym_for,
    ACTIONS(1251), 1,
      anon_sym_while,
    ACTIONS(1253), 1,
      anon_sym_repeat,
    ACTIONS(1255), 1,
      anon_sym_QMARK,
    ACTIONS(1257), 1,
      anon_sym_TILDE,
    ACTIONS(1265), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1267), 1,
      sym__number_literal,
    ACTIONS(1269), 1,
      anon_sym_SQUOTE,
    ACTIONS(1271), 1,
      anon_sym_DQUOTE,
    ACTIONS(1281), 1,
      sym__raw_string_literal,
    ACTIONS(1283), 1,
      sym__external_open_parenthesis,
    ACTIONS(1287), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8543), 1,
      anon_sym_BANG,
    ACTIONS(9379), 1,
      sym_dot_dot_i,
    STATE(11), 1,
      sym__open_brace,
    STATE(120), 1,
      sym__open_parenthesis,
    STATE(2271), 1,
      sym_string,
    STATE(2273), 1,
      sym__single_quoted_string,
    STATE(2274), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5157), 1,
      sym__string_or_identifier,
    ACTIONS(1261), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2272), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1275), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9377), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1255), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [40377] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      sym_identifier,
    ACTIONS(55), 1,
      anon_sym_BSLASH,
    ACTIONS(57), 1,
      anon_sym_function,
    ACTIONS(61), 1,
      anon_sym_if,
    ACTIONS(63), 1,
      anon_sym_for,
    ACTIONS(65), 1,
      anon_sym_while,
    ACTIONS(67), 1,
      anon_sym_repeat,
    ACTIONS(69), 1,
      anon_sym_QMARK,
    ACTIONS(71), 1,
      anon_sym_TILDE,
    ACTIONS(79), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(81), 1,
      sym__number_literal,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE,
    ACTIONS(95), 1,
      sym__raw_string_literal,
    ACTIONS(97), 1,
      sym__external_open_parenthesis,
    ACTIONS(99), 1,
      sym__external_open_brace,
    ACTIONS(8831), 1,
      anon_sym_BANG,
    ACTIONS(9383), 1,
      sym_dot_dot_i,
    ACTIONS(9385), 1,
      sym__newline,
    STATE(4), 1,
      sym__open_brace,
    STATE(19), 1,
      sym__open_parenthesis,
    STATE(1982), 1,
      sym_string,
    STATE(1985), 1,
      sym__single_quoted_string,
    STATE(1990), 1,
      sym__double_quoted_string,
    STATE(3323), 1,
      aux_sym_function_definition_repeat1,
    STATE(5151), 1,
      sym__string_or_identifier,
    ACTIONS(75), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1984), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(89), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9381), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(510), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [40506] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1241), 1,
      sym_identifier,
    ACTIONS(1243), 1,
      anon_sym_BSLASH,
    ACTIONS(1245), 1,
      anon_sym_function,
    ACTIONS(1247), 1,
      anon_sym_if,
    ACTIONS(1249), 1,
      anon_sym_for,
    ACTIONS(1251), 1,
      anon_sym_while,
    ACTIONS(1253), 1,
      anon_sym_repeat,
    ACTIONS(1255), 1,
      anon_sym_QMARK,
    ACTIONS(1257), 1,
      anon_sym_TILDE,
    ACTIONS(1265), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1267), 1,
      sym__number_literal,
    ACTIONS(1269), 1,
      anon_sym_SQUOTE,
    ACTIONS(1271), 1,
      anon_sym_DQUOTE,
    ACTIONS(1281), 1,
      sym__raw_string_literal,
    ACTIONS(1283), 1,
      sym__external_open_parenthesis,
    ACTIONS(1287), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8543), 1,
      anon_sym_BANG,
    ACTIONS(9389), 1,
      sym_dot_dot_i,
    STATE(11), 1,
      sym__open_brace,
    STATE(120), 1,
      sym__open_parenthesis,
    STATE(2271), 1,
      sym_string,
    STATE(2273), 1,
      sym__single_quoted_string,
    STATE(2274), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5157), 1,
      sym__string_or_identifier,
    ACTIONS(1261), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2272), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1275), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9387), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1256), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [40635] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(626), 1,
      sym_identifier,
    ACTIONS(628), 1,
      anon_sym_BSLASH,
    ACTIONS(630), 1,
      anon_sym_function,
    ACTIONS(632), 1,
      anon_sym_if,
    ACTIONS(634), 1,
      anon_sym_for,
    ACTIONS(636), 1,
      anon_sym_while,
    ACTIONS(638), 1,
      anon_sym_repeat,
    ACTIONS(640), 1,
      anon_sym_QMARK,
    ACTIONS(642), 1,
      anon_sym_TILDE,
    ACTIONS(650), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(652), 1,
      sym__number_literal,
    ACTIONS(654), 1,
      anon_sym_SQUOTE,
    ACTIONS(656), 1,
      anon_sym_DQUOTE,
    ACTIONS(666), 1,
      sym__raw_string_literal,
    ACTIONS(668), 1,
      sym__external_open_parenthesis,
    ACTIONS(670), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7933), 1,
      anon_sym_BANG,
    ACTIONS(9393), 1,
      sym_dot_dot_i,
    STATE(54), 1,
      sym__open_parenthesis,
    STATE(56), 1,
      sym__open_brace,
    STATE(2219), 1,
      sym_string,
    STATE(2221), 1,
      sym__single_quoted_string,
    STATE(2222), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5140), 1,
      sym__string_or_identifier,
    ACTIONS(646), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2220), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(660), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9391), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(693), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [40764] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1241), 1,
      sym_identifier,
    ACTIONS(1243), 1,
      anon_sym_BSLASH,
    ACTIONS(1245), 1,
      anon_sym_function,
    ACTIONS(1247), 1,
      anon_sym_if,
    ACTIONS(1249), 1,
      anon_sym_for,
    ACTIONS(1251), 1,
      anon_sym_while,
    ACTIONS(1253), 1,
      anon_sym_repeat,
    ACTIONS(1255), 1,
      anon_sym_QMARK,
    ACTIONS(1257), 1,
      anon_sym_TILDE,
    ACTIONS(1265), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1267), 1,
      sym__number_literal,
    ACTIONS(1269), 1,
      anon_sym_SQUOTE,
    ACTIONS(1271), 1,
      anon_sym_DQUOTE,
    ACTIONS(1281), 1,
      sym__raw_string_literal,
    ACTIONS(1283), 1,
      sym__external_open_parenthesis,
    ACTIONS(1287), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8543), 1,
      anon_sym_BANG,
    ACTIONS(9397), 1,
      sym_dot_dot_i,
    STATE(11), 1,
      sym__open_brace,
    STATE(120), 1,
      sym__open_parenthesis,
    STATE(2271), 1,
      sym_string,
    STATE(2273), 1,
      sym__single_quoted_string,
    STATE(2274), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5157), 1,
      sym__string_or_identifier,
    ACTIONS(1261), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2272), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1275), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9395), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1257), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [40893] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3845), 1,
      sym_identifier,
    ACTIONS(3847), 1,
      anon_sym_BSLASH,
    ACTIONS(3849), 1,
      anon_sym_function,
    ACTIONS(3851), 1,
      anon_sym_if,
    ACTIONS(3853), 1,
      anon_sym_for,
    ACTIONS(3855), 1,
      anon_sym_while,
    ACTIONS(3857), 1,
      anon_sym_repeat,
    ACTIONS(3859), 1,
      anon_sym_QMARK,
    ACTIONS(3861), 1,
      anon_sym_TILDE,
    ACTIONS(3869), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3871), 1,
      sym__number_literal,
    ACTIONS(3873), 1,
      anon_sym_SQUOTE,
    ACTIONS(3875), 1,
      anon_sym_DQUOTE,
    ACTIONS(3885), 1,
      sym__raw_string_literal,
    ACTIONS(3887), 1,
      sym__external_open_parenthesis,
    ACTIONS(3891), 1,
      sym__external_open_brace,
    ACTIONS(6389), 1,
      anon_sym_BANG,
    ACTIONS(9401), 1,
      sym_dot_dot_i,
    ACTIONS(9403), 1,
      sym__newline,
    STATE(154), 1,
      sym__open_brace,
    STATE(350), 1,
      sym__open_parenthesis,
    STATE(2620), 1,
      sym__double_quoted_string,
    STATE(2673), 1,
      sym_string,
    STATE(2735), 1,
      sym__single_quoted_string,
    STATE(3376), 1,
      aux_sym_function_definition_repeat1,
    STATE(5135), 1,
      sym__string_or_identifier,
    ACTIONS(3865), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2578), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3879), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9399), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2144), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [41022] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1433), 1,
      sym_identifier,
    ACTIONS(1435), 1,
      anon_sym_BSLASH,
    ACTIONS(1437), 1,
      anon_sym_function,
    ACTIONS(1439), 1,
      anon_sym_if,
    ACTIONS(1441), 1,
      anon_sym_for,
    ACTIONS(1443), 1,
      anon_sym_while,
    ACTIONS(1445), 1,
      anon_sym_repeat,
    ACTIONS(1447), 1,
      anon_sym_QMARK,
    ACTIONS(1449), 1,
      anon_sym_TILDE,
    ACTIONS(1457), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1459), 1,
      sym__number_literal,
    ACTIONS(1461), 1,
      anon_sym_SQUOTE,
    ACTIONS(1463), 1,
      anon_sym_DQUOTE,
    ACTIONS(1473), 1,
      sym__raw_string_literal,
    ACTIONS(1475), 1,
      sym__external_open_parenthesis,
    ACTIONS(1477), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8097), 1,
      anon_sym_BANG,
    ACTIONS(9407), 1,
      sym_dot_dot_i,
    STATE(76), 1,
      sym__open_parenthesis,
    STATE(188), 1,
      sym__open_brace,
    STATE(2234), 1,
      sym_string,
    STATE(2236), 1,
      sym__single_quoted_string,
    STATE(2237), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5150), 1,
      sym__string_or_identifier,
    ACTIONS(1453), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2235), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1467), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9405), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1098), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [41151] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1337), 1,
      sym_identifier,
    ACTIONS(1339), 1,
      anon_sym_BSLASH,
    ACTIONS(1341), 1,
      anon_sym_function,
    ACTIONS(1343), 1,
      anon_sym_if,
    ACTIONS(1345), 1,
      anon_sym_for,
    ACTIONS(1347), 1,
      anon_sym_while,
    ACTIONS(1349), 1,
      anon_sym_repeat,
    ACTIONS(1351), 1,
      anon_sym_QMARK,
    ACTIONS(1353), 1,
      anon_sym_TILDE,
    ACTIONS(1361), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1363), 1,
      sym__number_literal,
    ACTIONS(1365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1367), 1,
      anon_sym_DQUOTE,
    ACTIONS(1377), 1,
      sym__raw_string_literal,
    ACTIONS(1379), 1,
      sym__external_open_parenthesis,
    ACTIONS(1383), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9409), 1,
      anon_sym_BANG,
    ACTIONS(9413), 1,
      sym_dot_dot_i,
    STATE(94), 1,
      sym__open_brace,
    STATE(190), 1,
      sym__open_parenthesis,
    STATE(2231), 1,
      sym_string,
    STATE(2354), 1,
      sym__double_quoted_string,
    STATE(2355), 1,
      sym__single_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5156), 1,
      sym__string_or_identifier,
    ACTIONS(1357), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2356), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1371), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9411), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(870), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [41280] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1337), 1,
      sym_identifier,
    ACTIONS(1339), 1,
      anon_sym_BSLASH,
    ACTIONS(1341), 1,
      anon_sym_function,
    ACTIONS(1343), 1,
      anon_sym_if,
    ACTIONS(1345), 1,
      anon_sym_for,
    ACTIONS(1347), 1,
      anon_sym_while,
    ACTIONS(1349), 1,
      anon_sym_repeat,
    ACTIONS(1351), 1,
      anon_sym_QMARK,
    ACTIONS(1353), 1,
      anon_sym_TILDE,
    ACTIONS(1361), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1363), 1,
      sym__number_literal,
    ACTIONS(1365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1367), 1,
      anon_sym_DQUOTE,
    ACTIONS(1377), 1,
      sym__raw_string_literal,
    ACTIONS(1379), 1,
      sym__external_open_parenthesis,
    ACTIONS(1383), 1,
      sym__external_open_brace,
    ACTIONS(9409), 1,
      anon_sym_BANG,
    ACTIONS(9417), 1,
      sym_dot_dot_i,
    ACTIONS(9419), 1,
      sym__newline,
    STATE(94), 1,
      sym__open_brace,
    STATE(190), 1,
      sym__open_parenthesis,
    STATE(2231), 1,
      sym_string,
    STATE(2354), 1,
      sym__double_quoted_string,
    STATE(2355), 1,
      sym__single_quoted_string,
    STATE(3347), 1,
      aux_sym_function_definition_repeat1,
    STATE(5156), 1,
      sym__string_or_identifier,
    ACTIONS(1357), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2356), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1371), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9415), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(871), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [41409] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1241), 1,
      sym_identifier,
    ACTIONS(1243), 1,
      anon_sym_BSLASH,
    ACTIONS(1245), 1,
      anon_sym_function,
    ACTIONS(1247), 1,
      anon_sym_if,
    ACTIONS(1249), 1,
      anon_sym_for,
    ACTIONS(1251), 1,
      anon_sym_while,
    ACTIONS(1253), 1,
      anon_sym_repeat,
    ACTIONS(1255), 1,
      anon_sym_QMARK,
    ACTIONS(1257), 1,
      anon_sym_TILDE,
    ACTIONS(1265), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1267), 1,
      sym__number_literal,
    ACTIONS(1269), 1,
      anon_sym_SQUOTE,
    ACTIONS(1271), 1,
      anon_sym_DQUOTE,
    ACTIONS(1281), 1,
      sym__raw_string_literal,
    ACTIONS(1283), 1,
      sym__external_open_parenthesis,
    ACTIONS(1287), 1,
      sym__external_open_brace,
    ACTIONS(8543), 1,
      anon_sym_BANG,
    ACTIONS(9423), 1,
      sym_dot_dot_i,
    ACTIONS(9425), 1,
      sym__newline,
    STATE(11), 1,
      sym__open_brace,
    STATE(120), 1,
      sym__open_parenthesis,
    STATE(2271), 1,
      sym_string,
    STATE(2273), 1,
      sym__single_quoted_string,
    STATE(2274), 1,
      sym__double_quoted_string,
    STATE(3382), 1,
      aux_sym_function_definition_repeat1,
    STATE(5157), 1,
      sym__string_or_identifier,
    ACTIONS(1261), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2272), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1275), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9421), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1258), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [41538] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1241), 1,
      sym_identifier,
    ACTIONS(1243), 1,
      anon_sym_BSLASH,
    ACTIONS(1245), 1,
      anon_sym_function,
    ACTIONS(1247), 1,
      anon_sym_if,
    ACTIONS(1249), 1,
      anon_sym_for,
    ACTIONS(1251), 1,
      anon_sym_while,
    ACTIONS(1253), 1,
      anon_sym_repeat,
    ACTIONS(1255), 1,
      anon_sym_QMARK,
    ACTIONS(1257), 1,
      anon_sym_TILDE,
    ACTIONS(1265), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1267), 1,
      sym__number_literal,
    ACTIONS(1269), 1,
      anon_sym_SQUOTE,
    ACTIONS(1271), 1,
      anon_sym_DQUOTE,
    ACTIONS(1281), 1,
      sym__raw_string_literal,
    ACTIONS(1283), 1,
      sym__external_open_parenthesis,
    ACTIONS(1287), 1,
      sym__external_open_brace,
    ACTIONS(8543), 1,
      anon_sym_BANG,
    ACTIONS(9429), 1,
      sym_dot_dot_i,
    ACTIONS(9431), 1,
      sym__newline,
    STATE(11), 1,
      sym__open_brace,
    STATE(120), 1,
      sym__open_parenthesis,
    STATE(2271), 1,
      sym_string,
    STATE(2273), 1,
      sym__single_quoted_string,
    STATE(2274), 1,
      sym__double_quoted_string,
    STATE(3384), 1,
      aux_sym_function_definition_repeat1,
    STATE(5157), 1,
      sym__string_or_identifier,
    ACTIONS(1261), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2272), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1275), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9427), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1259), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [41667] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1241), 1,
      sym_identifier,
    ACTIONS(1243), 1,
      anon_sym_BSLASH,
    ACTIONS(1245), 1,
      anon_sym_function,
    ACTIONS(1247), 1,
      anon_sym_if,
    ACTIONS(1249), 1,
      anon_sym_for,
    ACTIONS(1251), 1,
      anon_sym_while,
    ACTIONS(1253), 1,
      anon_sym_repeat,
    ACTIONS(1255), 1,
      anon_sym_QMARK,
    ACTIONS(1257), 1,
      anon_sym_TILDE,
    ACTIONS(1265), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1267), 1,
      sym__number_literal,
    ACTIONS(1269), 1,
      anon_sym_SQUOTE,
    ACTIONS(1271), 1,
      anon_sym_DQUOTE,
    ACTIONS(1281), 1,
      sym__raw_string_literal,
    ACTIONS(1283), 1,
      sym__external_open_parenthesis,
    ACTIONS(1287), 1,
      sym__external_open_brace,
    ACTIONS(8543), 1,
      anon_sym_BANG,
    ACTIONS(9435), 1,
      sym_dot_dot_i,
    ACTIONS(9437), 1,
      sym__newline,
    STATE(11), 1,
      sym__open_brace,
    STATE(120), 1,
      sym__open_parenthesis,
    STATE(2271), 1,
      sym_string,
    STATE(2273), 1,
      sym__single_quoted_string,
    STATE(2274), 1,
      sym__double_quoted_string,
    STATE(3386), 1,
      aux_sym_function_definition_repeat1,
    STATE(5157), 1,
      sym__string_or_identifier,
    ACTIONS(1261), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2272), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1275), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9433), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1260), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [41796] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1241), 1,
      sym_identifier,
    ACTIONS(1243), 1,
      anon_sym_BSLASH,
    ACTIONS(1245), 1,
      anon_sym_function,
    ACTIONS(1247), 1,
      anon_sym_if,
    ACTIONS(1249), 1,
      anon_sym_for,
    ACTIONS(1251), 1,
      anon_sym_while,
    ACTIONS(1253), 1,
      anon_sym_repeat,
    ACTIONS(1255), 1,
      anon_sym_QMARK,
    ACTIONS(1257), 1,
      anon_sym_TILDE,
    ACTIONS(1265), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1267), 1,
      sym__number_literal,
    ACTIONS(1269), 1,
      anon_sym_SQUOTE,
    ACTIONS(1271), 1,
      anon_sym_DQUOTE,
    ACTIONS(1281), 1,
      sym__raw_string_literal,
    ACTIONS(1283), 1,
      sym__external_open_parenthesis,
    ACTIONS(1287), 1,
      sym__external_open_brace,
    ACTIONS(8543), 1,
      anon_sym_BANG,
    ACTIONS(9441), 1,
      sym_dot_dot_i,
    ACTIONS(9443), 1,
      sym__newline,
    STATE(11), 1,
      sym__open_brace,
    STATE(120), 1,
      sym__open_parenthesis,
    STATE(2271), 1,
      sym_string,
    STATE(2273), 1,
      sym__single_quoted_string,
    STATE(2274), 1,
      sym__double_quoted_string,
    STATE(3388), 1,
      aux_sym_function_definition_repeat1,
    STATE(5157), 1,
      sym__string_or_identifier,
    ACTIONS(1261), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2272), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1275), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9439), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1261), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [41925] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1241), 1,
      sym_identifier,
    ACTIONS(1243), 1,
      anon_sym_BSLASH,
    ACTIONS(1245), 1,
      anon_sym_function,
    ACTIONS(1247), 1,
      anon_sym_if,
    ACTIONS(1249), 1,
      anon_sym_for,
    ACTIONS(1251), 1,
      anon_sym_while,
    ACTIONS(1253), 1,
      anon_sym_repeat,
    ACTIONS(1255), 1,
      anon_sym_QMARK,
    ACTIONS(1257), 1,
      anon_sym_TILDE,
    ACTIONS(1265), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1267), 1,
      sym__number_literal,
    ACTIONS(1269), 1,
      anon_sym_SQUOTE,
    ACTIONS(1271), 1,
      anon_sym_DQUOTE,
    ACTIONS(1281), 1,
      sym__raw_string_literal,
    ACTIONS(1283), 1,
      sym__external_open_parenthesis,
    ACTIONS(1287), 1,
      sym__external_open_brace,
    ACTIONS(8543), 1,
      anon_sym_BANG,
    ACTIONS(9447), 1,
      sym_dot_dot_i,
    ACTIONS(9449), 1,
      sym__newline,
    STATE(11), 1,
      sym__open_brace,
    STATE(120), 1,
      sym__open_parenthesis,
    STATE(2271), 1,
      sym_string,
    STATE(2273), 1,
      sym__single_quoted_string,
    STATE(2274), 1,
      sym__double_quoted_string,
    STATE(3390), 1,
      aux_sym_function_definition_repeat1,
    STATE(5157), 1,
      sym__string_or_identifier,
    ACTIONS(1261), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2272), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1275), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9445), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1262), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [42054] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1241), 1,
      sym_identifier,
    ACTIONS(1243), 1,
      anon_sym_BSLASH,
    ACTIONS(1245), 1,
      anon_sym_function,
    ACTIONS(1247), 1,
      anon_sym_if,
    ACTIONS(1249), 1,
      anon_sym_for,
    ACTIONS(1251), 1,
      anon_sym_while,
    ACTIONS(1253), 1,
      anon_sym_repeat,
    ACTIONS(1255), 1,
      anon_sym_QMARK,
    ACTIONS(1257), 1,
      anon_sym_TILDE,
    ACTIONS(1265), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1267), 1,
      sym__number_literal,
    ACTIONS(1269), 1,
      anon_sym_SQUOTE,
    ACTIONS(1271), 1,
      anon_sym_DQUOTE,
    ACTIONS(1281), 1,
      sym__raw_string_literal,
    ACTIONS(1283), 1,
      sym__external_open_parenthesis,
    ACTIONS(1287), 1,
      sym__external_open_brace,
    ACTIONS(8543), 1,
      anon_sym_BANG,
    ACTIONS(9453), 1,
      sym_dot_dot_i,
    ACTIONS(9455), 1,
      sym__newline,
    STATE(11), 1,
      sym__open_brace,
    STATE(120), 1,
      sym__open_parenthesis,
    STATE(2271), 1,
      sym_string,
    STATE(2273), 1,
      sym__single_quoted_string,
    STATE(2274), 1,
      sym__double_quoted_string,
    STATE(3392), 1,
      aux_sym_function_definition_repeat1,
    STATE(5157), 1,
      sym__string_or_identifier,
    ACTIONS(1261), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2272), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1275), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9451), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1263), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [42183] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1241), 1,
      sym_identifier,
    ACTIONS(1243), 1,
      anon_sym_BSLASH,
    ACTIONS(1245), 1,
      anon_sym_function,
    ACTIONS(1247), 1,
      anon_sym_if,
    ACTIONS(1249), 1,
      anon_sym_for,
    ACTIONS(1251), 1,
      anon_sym_while,
    ACTIONS(1253), 1,
      anon_sym_repeat,
    ACTIONS(1255), 1,
      anon_sym_QMARK,
    ACTIONS(1257), 1,
      anon_sym_TILDE,
    ACTIONS(1265), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1267), 1,
      sym__number_literal,
    ACTIONS(1269), 1,
      anon_sym_SQUOTE,
    ACTIONS(1271), 1,
      anon_sym_DQUOTE,
    ACTIONS(1281), 1,
      sym__raw_string_literal,
    ACTIONS(1283), 1,
      sym__external_open_parenthesis,
    ACTIONS(1287), 1,
      sym__external_open_brace,
    ACTIONS(8543), 1,
      anon_sym_BANG,
    ACTIONS(9459), 1,
      sym_dot_dot_i,
    ACTIONS(9461), 1,
      sym__newline,
    STATE(11), 1,
      sym__open_brace,
    STATE(120), 1,
      sym__open_parenthesis,
    STATE(2271), 1,
      sym_string,
    STATE(2273), 1,
      sym__single_quoted_string,
    STATE(2274), 1,
      sym__double_quoted_string,
    STATE(3394), 1,
      aux_sym_function_definition_repeat1,
    STATE(5157), 1,
      sym__string_or_identifier,
    ACTIONS(1261), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2272), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1275), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9457), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1267), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [42312] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1241), 1,
      sym_identifier,
    ACTIONS(1243), 1,
      anon_sym_BSLASH,
    ACTIONS(1245), 1,
      anon_sym_function,
    ACTIONS(1247), 1,
      anon_sym_if,
    ACTIONS(1249), 1,
      anon_sym_for,
    ACTIONS(1251), 1,
      anon_sym_while,
    ACTIONS(1253), 1,
      anon_sym_repeat,
    ACTIONS(1255), 1,
      anon_sym_QMARK,
    ACTIONS(1257), 1,
      anon_sym_TILDE,
    ACTIONS(1265), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1267), 1,
      sym__number_literal,
    ACTIONS(1269), 1,
      anon_sym_SQUOTE,
    ACTIONS(1271), 1,
      anon_sym_DQUOTE,
    ACTIONS(1281), 1,
      sym__raw_string_literal,
    ACTIONS(1283), 1,
      sym__external_open_parenthesis,
    ACTIONS(1287), 1,
      sym__external_open_brace,
    ACTIONS(8543), 1,
      anon_sym_BANG,
    ACTIONS(9465), 1,
      sym_dot_dot_i,
    ACTIONS(9467), 1,
      sym__newline,
    STATE(11), 1,
      sym__open_brace,
    STATE(120), 1,
      sym__open_parenthesis,
    STATE(2271), 1,
      sym_string,
    STATE(2273), 1,
      sym__single_quoted_string,
    STATE(2274), 1,
      sym__double_quoted_string,
    STATE(3396), 1,
      aux_sym_function_definition_repeat1,
    STATE(5157), 1,
      sym__string_or_identifier,
    ACTIONS(1261), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2272), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1275), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9463), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1269), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [42441] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1241), 1,
      sym_identifier,
    ACTIONS(1243), 1,
      anon_sym_BSLASH,
    ACTIONS(1245), 1,
      anon_sym_function,
    ACTIONS(1247), 1,
      anon_sym_if,
    ACTIONS(1249), 1,
      anon_sym_for,
    ACTIONS(1251), 1,
      anon_sym_while,
    ACTIONS(1253), 1,
      anon_sym_repeat,
    ACTIONS(1255), 1,
      anon_sym_QMARK,
    ACTIONS(1257), 1,
      anon_sym_TILDE,
    ACTIONS(1265), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1267), 1,
      sym__number_literal,
    ACTIONS(1269), 1,
      anon_sym_SQUOTE,
    ACTIONS(1271), 1,
      anon_sym_DQUOTE,
    ACTIONS(1281), 1,
      sym__raw_string_literal,
    ACTIONS(1283), 1,
      sym__external_open_parenthesis,
    ACTIONS(1287), 1,
      sym__external_open_brace,
    ACTIONS(8543), 1,
      anon_sym_BANG,
    ACTIONS(9471), 1,
      sym_dot_dot_i,
    ACTIONS(9473), 1,
      sym__newline,
    STATE(11), 1,
      sym__open_brace,
    STATE(120), 1,
      sym__open_parenthesis,
    STATE(2271), 1,
      sym_string,
    STATE(2273), 1,
      sym__single_quoted_string,
    STATE(2274), 1,
      sym__double_quoted_string,
    STATE(3398), 1,
      aux_sym_function_definition_repeat1,
    STATE(5157), 1,
      sym__string_or_identifier,
    ACTIONS(1261), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2272), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1275), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9469), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1271), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [42570] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1241), 1,
      sym_identifier,
    ACTIONS(1243), 1,
      anon_sym_BSLASH,
    ACTIONS(1245), 1,
      anon_sym_function,
    ACTIONS(1247), 1,
      anon_sym_if,
    ACTIONS(1249), 1,
      anon_sym_for,
    ACTIONS(1251), 1,
      anon_sym_while,
    ACTIONS(1253), 1,
      anon_sym_repeat,
    ACTIONS(1255), 1,
      anon_sym_QMARK,
    ACTIONS(1257), 1,
      anon_sym_TILDE,
    ACTIONS(1265), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1267), 1,
      sym__number_literal,
    ACTIONS(1269), 1,
      anon_sym_SQUOTE,
    ACTIONS(1271), 1,
      anon_sym_DQUOTE,
    ACTIONS(1281), 1,
      sym__raw_string_literal,
    ACTIONS(1283), 1,
      sym__external_open_parenthesis,
    ACTIONS(1287), 1,
      sym__external_open_brace,
    ACTIONS(8543), 1,
      anon_sym_BANG,
    ACTIONS(9477), 1,
      sym_dot_dot_i,
    ACTIONS(9479), 1,
      sym__newline,
    STATE(11), 1,
      sym__open_brace,
    STATE(120), 1,
      sym__open_parenthesis,
    STATE(2271), 1,
      sym_string,
    STATE(2273), 1,
      sym__single_quoted_string,
    STATE(2274), 1,
      sym__double_quoted_string,
    STATE(3400), 1,
      aux_sym_function_definition_repeat1,
    STATE(5157), 1,
      sym__string_or_identifier,
    ACTIONS(1261), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2272), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1275), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9475), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1272), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [42699] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1241), 1,
      sym_identifier,
    ACTIONS(1243), 1,
      anon_sym_BSLASH,
    ACTIONS(1245), 1,
      anon_sym_function,
    ACTIONS(1247), 1,
      anon_sym_if,
    ACTIONS(1249), 1,
      anon_sym_for,
    ACTIONS(1251), 1,
      anon_sym_while,
    ACTIONS(1253), 1,
      anon_sym_repeat,
    ACTIONS(1255), 1,
      anon_sym_QMARK,
    ACTIONS(1257), 1,
      anon_sym_TILDE,
    ACTIONS(1265), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1267), 1,
      sym__number_literal,
    ACTIONS(1269), 1,
      anon_sym_SQUOTE,
    ACTIONS(1271), 1,
      anon_sym_DQUOTE,
    ACTIONS(1281), 1,
      sym__raw_string_literal,
    ACTIONS(1283), 1,
      sym__external_open_parenthesis,
    ACTIONS(1287), 1,
      sym__external_open_brace,
    ACTIONS(8543), 1,
      anon_sym_BANG,
    ACTIONS(9483), 1,
      sym_dot_dot_i,
    ACTIONS(9485), 1,
      sym__newline,
    STATE(11), 1,
      sym__open_brace,
    STATE(120), 1,
      sym__open_parenthesis,
    STATE(2271), 1,
      sym_string,
    STATE(2273), 1,
      sym__single_quoted_string,
    STATE(2274), 1,
      sym__double_quoted_string,
    STATE(3402), 1,
      aux_sym_function_definition_repeat1,
    STATE(5157), 1,
      sym__string_or_identifier,
    ACTIONS(1261), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2272), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1275), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9481), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1273), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [42828] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1241), 1,
      sym_identifier,
    ACTIONS(1243), 1,
      anon_sym_BSLASH,
    ACTIONS(1245), 1,
      anon_sym_function,
    ACTIONS(1247), 1,
      anon_sym_if,
    ACTIONS(1249), 1,
      anon_sym_for,
    ACTIONS(1251), 1,
      anon_sym_while,
    ACTIONS(1253), 1,
      anon_sym_repeat,
    ACTIONS(1255), 1,
      anon_sym_QMARK,
    ACTIONS(1257), 1,
      anon_sym_TILDE,
    ACTIONS(1265), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1267), 1,
      sym__number_literal,
    ACTIONS(1269), 1,
      anon_sym_SQUOTE,
    ACTIONS(1271), 1,
      anon_sym_DQUOTE,
    ACTIONS(1281), 1,
      sym__raw_string_literal,
    ACTIONS(1283), 1,
      sym__external_open_parenthesis,
    ACTIONS(1287), 1,
      sym__external_open_brace,
    ACTIONS(8543), 1,
      anon_sym_BANG,
    ACTIONS(9489), 1,
      sym_dot_dot_i,
    ACTIONS(9491), 1,
      sym__newline,
    STATE(11), 1,
      sym__open_brace,
    STATE(120), 1,
      sym__open_parenthesis,
    STATE(2271), 1,
      sym_string,
    STATE(2273), 1,
      sym__single_quoted_string,
    STATE(2274), 1,
      sym__double_quoted_string,
    STATE(3404), 1,
      aux_sym_function_definition_repeat1,
    STATE(5157), 1,
      sym__string_or_identifier,
    ACTIONS(1261), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2272), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1275), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9487), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1274), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [42957] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1241), 1,
      sym_identifier,
    ACTIONS(1243), 1,
      anon_sym_BSLASH,
    ACTIONS(1245), 1,
      anon_sym_function,
    ACTIONS(1247), 1,
      anon_sym_if,
    ACTIONS(1249), 1,
      anon_sym_for,
    ACTIONS(1251), 1,
      anon_sym_while,
    ACTIONS(1253), 1,
      anon_sym_repeat,
    ACTIONS(1255), 1,
      anon_sym_QMARK,
    ACTIONS(1257), 1,
      anon_sym_TILDE,
    ACTIONS(1265), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1267), 1,
      sym__number_literal,
    ACTIONS(1269), 1,
      anon_sym_SQUOTE,
    ACTIONS(1271), 1,
      anon_sym_DQUOTE,
    ACTIONS(1281), 1,
      sym__raw_string_literal,
    ACTIONS(1283), 1,
      sym__external_open_parenthesis,
    ACTIONS(1287), 1,
      sym__external_open_brace,
    ACTIONS(8543), 1,
      anon_sym_BANG,
    ACTIONS(9495), 1,
      sym_dot_dot_i,
    ACTIONS(9497), 1,
      sym__newline,
    STATE(11), 1,
      sym__open_brace,
    STATE(120), 1,
      sym__open_parenthesis,
    STATE(2271), 1,
      sym_string,
    STATE(2273), 1,
      sym__single_quoted_string,
    STATE(2274), 1,
      sym__double_quoted_string,
    STATE(3406), 1,
      aux_sym_function_definition_repeat1,
    STATE(5157), 1,
      sym__string_or_identifier,
    ACTIONS(1261), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2272), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1275), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9493), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1275), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [43086] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(9501), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9499), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4456), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [43215] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1337), 1,
      sym_identifier,
    ACTIONS(1339), 1,
      anon_sym_BSLASH,
    ACTIONS(1341), 1,
      anon_sym_function,
    ACTIONS(1343), 1,
      anon_sym_if,
    ACTIONS(1345), 1,
      anon_sym_for,
    ACTIONS(1347), 1,
      anon_sym_while,
    ACTIONS(1349), 1,
      anon_sym_repeat,
    ACTIONS(1351), 1,
      anon_sym_QMARK,
    ACTIONS(1353), 1,
      anon_sym_TILDE,
    ACTIONS(1361), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1363), 1,
      sym__number_literal,
    ACTIONS(1365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1367), 1,
      anon_sym_DQUOTE,
    ACTIONS(1377), 1,
      sym__raw_string_literal,
    ACTIONS(1379), 1,
      sym__external_open_parenthesis,
    ACTIONS(1383), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9409), 1,
      anon_sym_BANG,
    ACTIONS(9505), 1,
      sym_dot_dot_i,
    STATE(94), 1,
      sym__open_brace,
    STATE(190), 1,
      sym__open_parenthesis,
    STATE(2231), 1,
      sym_string,
    STATE(2354), 1,
      sym__double_quoted_string,
    STATE(2355), 1,
      sym__single_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5156), 1,
      sym__string_or_identifier,
    ACTIONS(1357), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2356), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1371), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9503), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(872), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [43344] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1337), 1,
      sym_identifier,
    ACTIONS(1339), 1,
      anon_sym_BSLASH,
    ACTIONS(1341), 1,
      anon_sym_function,
    ACTIONS(1343), 1,
      anon_sym_if,
    ACTIONS(1345), 1,
      anon_sym_for,
    ACTIONS(1347), 1,
      anon_sym_while,
    ACTIONS(1349), 1,
      anon_sym_repeat,
    ACTIONS(1351), 1,
      anon_sym_QMARK,
    ACTIONS(1353), 1,
      anon_sym_TILDE,
    ACTIONS(1361), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1363), 1,
      sym__number_literal,
    ACTIONS(1365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1367), 1,
      anon_sym_DQUOTE,
    ACTIONS(1377), 1,
      sym__raw_string_literal,
    ACTIONS(1379), 1,
      sym__external_open_parenthesis,
    ACTIONS(1383), 1,
      sym__external_open_brace,
    ACTIONS(9409), 1,
      anon_sym_BANG,
    ACTIONS(9509), 1,
      sym_dot_dot_i,
    ACTIONS(9511), 1,
      sym__newline,
    STATE(94), 1,
      sym__open_brace,
    STATE(190), 1,
      sym__open_parenthesis,
    STATE(2231), 1,
      sym_string,
    STATE(2354), 1,
      sym__double_quoted_string,
    STATE(2355), 1,
      sym__single_quoted_string,
    STATE(3363), 1,
      aux_sym_function_definition_repeat1,
    STATE(5156), 1,
      sym__string_or_identifier,
    ACTIONS(1357), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2356), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1371), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9507), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(873), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [43473] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3845), 1,
      sym_identifier,
    ACTIONS(3847), 1,
      anon_sym_BSLASH,
    ACTIONS(3849), 1,
      anon_sym_function,
    ACTIONS(3851), 1,
      anon_sym_if,
    ACTIONS(3853), 1,
      anon_sym_for,
    ACTIONS(3855), 1,
      anon_sym_while,
    ACTIONS(3857), 1,
      anon_sym_repeat,
    ACTIONS(3859), 1,
      anon_sym_QMARK,
    ACTIONS(3861), 1,
      anon_sym_TILDE,
    ACTIONS(3869), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3871), 1,
      sym__number_literal,
    ACTIONS(3873), 1,
      anon_sym_SQUOTE,
    ACTIONS(3875), 1,
      anon_sym_DQUOTE,
    ACTIONS(3885), 1,
      sym__raw_string_literal,
    ACTIONS(3887), 1,
      sym__external_open_parenthesis,
    ACTIONS(3891), 1,
      sym__external_open_brace,
    ACTIONS(6389), 1,
      anon_sym_BANG,
    ACTIONS(9515), 1,
      sym_dot_dot_i,
    ACTIONS(9517), 1,
      sym__newline,
    STATE(154), 1,
      sym__open_brace,
    STATE(350), 1,
      sym__open_parenthesis,
    STATE(2620), 1,
      sym__double_quoted_string,
    STATE(2673), 1,
      sym_string,
    STATE(2735), 1,
      sym__single_quoted_string,
    STATE(3381), 1,
      aux_sym_function_definition_repeat1,
    STATE(5135), 1,
      sym__string_or_identifier,
    ACTIONS(3865), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2578), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3879), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9513), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2142), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [43602] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3845), 1,
      sym_identifier,
    ACTIONS(3847), 1,
      anon_sym_BSLASH,
    ACTIONS(3849), 1,
      anon_sym_function,
    ACTIONS(3851), 1,
      anon_sym_if,
    ACTIONS(3853), 1,
      anon_sym_for,
    ACTIONS(3855), 1,
      anon_sym_while,
    ACTIONS(3857), 1,
      anon_sym_repeat,
    ACTIONS(3859), 1,
      anon_sym_QMARK,
    ACTIONS(3861), 1,
      anon_sym_TILDE,
    ACTIONS(3869), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3871), 1,
      sym__number_literal,
    ACTIONS(3873), 1,
      anon_sym_SQUOTE,
    ACTIONS(3875), 1,
      anon_sym_DQUOTE,
    ACTIONS(3885), 1,
      sym__raw_string_literal,
    ACTIONS(3887), 1,
      sym__external_open_parenthesis,
    ACTIONS(3891), 1,
      sym__external_open_brace,
    ACTIONS(6389), 1,
      anon_sym_BANG,
    ACTIONS(9521), 1,
      sym_dot_dot_i,
    ACTIONS(9523), 1,
      sym__newline,
    STATE(154), 1,
      sym__open_brace,
    STATE(350), 1,
      sym__open_parenthesis,
    STATE(2620), 1,
      sym__double_quoted_string,
    STATE(2673), 1,
      sym_string,
    STATE(2735), 1,
      sym__single_quoted_string,
    STATE(3383), 1,
      aux_sym_function_definition_repeat1,
    STATE(5135), 1,
      sym__string_or_identifier,
    ACTIONS(3865), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2578), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3879), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9519), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2140), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [43731] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3845), 1,
      sym_identifier,
    ACTIONS(3847), 1,
      anon_sym_BSLASH,
    ACTIONS(3849), 1,
      anon_sym_function,
    ACTIONS(3851), 1,
      anon_sym_if,
    ACTIONS(3853), 1,
      anon_sym_for,
    ACTIONS(3855), 1,
      anon_sym_while,
    ACTIONS(3857), 1,
      anon_sym_repeat,
    ACTIONS(3859), 1,
      anon_sym_QMARK,
    ACTIONS(3861), 1,
      anon_sym_TILDE,
    ACTIONS(3869), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3871), 1,
      sym__number_literal,
    ACTIONS(3873), 1,
      anon_sym_SQUOTE,
    ACTIONS(3875), 1,
      anon_sym_DQUOTE,
    ACTIONS(3885), 1,
      sym__raw_string_literal,
    ACTIONS(3887), 1,
      sym__external_open_parenthesis,
    ACTIONS(3891), 1,
      sym__external_open_brace,
    ACTIONS(6389), 1,
      anon_sym_BANG,
    ACTIONS(9527), 1,
      sym_dot_dot_i,
    ACTIONS(9529), 1,
      sym__newline,
    STATE(154), 1,
      sym__open_brace,
    STATE(350), 1,
      sym__open_parenthesis,
    STATE(2620), 1,
      sym__double_quoted_string,
    STATE(2673), 1,
      sym_string,
    STATE(2735), 1,
      sym__single_quoted_string,
    STATE(3407), 1,
      aux_sym_function_definition_repeat1,
    STATE(5135), 1,
      sym__string_or_identifier,
    ACTIONS(3865), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2578), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3879), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9525), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2138), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [43860] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(626), 1,
      sym_identifier,
    ACTIONS(628), 1,
      anon_sym_BSLASH,
    ACTIONS(630), 1,
      anon_sym_function,
    ACTIONS(632), 1,
      anon_sym_if,
    ACTIONS(634), 1,
      anon_sym_for,
    ACTIONS(636), 1,
      anon_sym_while,
    ACTIONS(638), 1,
      anon_sym_repeat,
    ACTIONS(640), 1,
      anon_sym_QMARK,
    ACTIONS(642), 1,
      anon_sym_TILDE,
    ACTIONS(650), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(652), 1,
      sym__number_literal,
    ACTIONS(654), 1,
      anon_sym_SQUOTE,
    ACTIONS(656), 1,
      anon_sym_DQUOTE,
    ACTIONS(666), 1,
      sym__raw_string_literal,
    ACTIONS(668), 1,
      sym__external_open_parenthesis,
    ACTIONS(670), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7933), 1,
      anon_sym_BANG,
    ACTIONS(9533), 1,
      sym_dot_dot_i,
    STATE(54), 1,
      sym__open_parenthesis,
    STATE(56), 1,
      sym__open_brace,
    STATE(2219), 1,
      sym_string,
    STATE(2221), 1,
      sym__single_quoted_string,
    STATE(2222), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5140), 1,
      sym__string_or_identifier,
    ACTIONS(646), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2220), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(660), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9531), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(694), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [43989] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(161), 1,
      sym_identifier,
    ACTIONS(163), 1,
      anon_sym_BSLASH,
    ACTIONS(165), 1,
      anon_sym_function,
    ACTIONS(167), 1,
      anon_sym_if,
    ACTIONS(169), 1,
      anon_sym_for,
    ACTIONS(171), 1,
      anon_sym_while,
    ACTIONS(173), 1,
      anon_sym_repeat,
    ACTIONS(175), 1,
      anon_sym_QMARK,
    ACTIONS(177), 1,
      anon_sym_TILDE,
    ACTIONS(185), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(187), 1,
      sym__number_literal,
    ACTIONS(189), 1,
      anon_sym_SQUOTE,
    ACTIONS(191), 1,
      anon_sym_DQUOTE,
    ACTIONS(201), 1,
      sym__raw_string_literal,
    ACTIONS(203), 1,
      sym__external_open_parenthesis,
    ACTIONS(207), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8009), 1,
      anon_sym_BANG,
    ACTIONS(9537), 1,
      sym_dot_dot_i,
    STATE(14), 1,
      sym__open_parenthesis,
    STATE(18), 1,
      sym__open_brace,
    STATE(1923), 1,
      sym__single_quoted_string,
    STATE(1927), 1,
      sym_string,
    STATE(1934), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5137), 1,
      sym__string_or_identifier,
    ACTIONS(181), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1925), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(195), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9535), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(476), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [44118] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(161), 1,
      sym_identifier,
    ACTIONS(163), 1,
      anon_sym_BSLASH,
    ACTIONS(165), 1,
      anon_sym_function,
    ACTIONS(167), 1,
      anon_sym_if,
    ACTIONS(169), 1,
      anon_sym_for,
    ACTIONS(171), 1,
      anon_sym_while,
    ACTIONS(173), 1,
      anon_sym_repeat,
    ACTIONS(175), 1,
      anon_sym_QMARK,
    ACTIONS(177), 1,
      anon_sym_TILDE,
    ACTIONS(185), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(187), 1,
      sym__number_literal,
    ACTIONS(189), 1,
      anon_sym_SQUOTE,
    ACTIONS(191), 1,
      anon_sym_DQUOTE,
    ACTIONS(201), 1,
      sym__raw_string_literal,
    ACTIONS(203), 1,
      sym__external_open_parenthesis,
    ACTIONS(207), 1,
      sym__external_open_brace,
    ACTIONS(8009), 1,
      anon_sym_BANG,
    ACTIONS(9541), 1,
      sym_dot_dot_i,
    ACTIONS(9543), 1,
      sym__newline,
    STATE(14), 1,
      sym__open_parenthesis,
    STATE(18), 1,
      sym__open_brace,
    STATE(1923), 1,
      sym__single_quoted_string,
    STATE(1927), 1,
      sym_string,
    STATE(1934), 1,
      sym__double_quoted_string,
    STATE(3369), 1,
      aux_sym_function_definition_repeat1,
    STATE(5137), 1,
      sym__string_or_identifier,
    ACTIONS(181), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1925), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(195), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9539), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(491), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [44247] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2943), 1,
      sym_identifier,
    ACTIONS(2945), 1,
      anon_sym_BSLASH,
    ACTIONS(2947), 1,
      anon_sym_function,
    ACTIONS(2949), 1,
      anon_sym_if,
    ACTIONS(2951), 1,
      anon_sym_for,
    ACTIONS(2953), 1,
      anon_sym_while,
    ACTIONS(2955), 1,
      anon_sym_repeat,
    ACTIONS(2957), 1,
      anon_sym_QMARK,
    ACTIONS(2959), 1,
      anon_sym_TILDE,
    ACTIONS(2967), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2969), 1,
      sym__number_literal,
    ACTIONS(2971), 1,
      anon_sym_SQUOTE,
    ACTIONS(2973), 1,
      anon_sym_DQUOTE,
    ACTIONS(2983), 1,
      sym__raw_string_literal,
    ACTIONS(2985), 1,
      sym__external_open_parenthesis,
    ACTIONS(2989), 1,
      sym__external_open_brace,
    ACTIONS(7797), 1,
      anon_sym_BANG,
    ACTIONS(9547), 1,
      sym_dot_dot_i,
    ACTIONS(9549), 1,
      sym__newline,
    STATE(173), 1,
      sym__open_brace,
    STATE(246), 1,
      sym__open_parenthesis,
    STATE(2462), 1,
      sym__single_quoted_string,
    STATE(2494), 1,
      sym__double_quoted_string,
    STATE(2541), 1,
      sym_string,
    STATE(3171), 1,
      aux_sym_function_definition_repeat1,
    STATE(5128), 1,
      sym__string_or_identifier,
    ACTIONS(2963), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2540), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2977), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9545), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1801), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [44376] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(161), 1,
      sym_identifier,
    ACTIONS(163), 1,
      anon_sym_BSLASH,
    ACTIONS(165), 1,
      anon_sym_function,
    ACTIONS(167), 1,
      anon_sym_if,
    ACTIONS(169), 1,
      anon_sym_for,
    ACTIONS(171), 1,
      anon_sym_while,
    ACTIONS(173), 1,
      anon_sym_repeat,
    ACTIONS(175), 1,
      anon_sym_QMARK,
    ACTIONS(177), 1,
      anon_sym_TILDE,
    ACTIONS(185), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(187), 1,
      sym__number_literal,
    ACTIONS(189), 1,
      anon_sym_SQUOTE,
    ACTIONS(191), 1,
      anon_sym_DQUOTE,
    ACTIONS(201), 1,
      sym__raw_string_literal,
    ACTIONS(203), 1,
      sym__external_open_parenthesis,
    ACTIONS(207), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8009), 1,
      anon_sym_BANG,
    ACTIONS(9553), 1,
      sym_dot_dot_i,
    STATE(14), 1,
      sym__open_parenthesis,
    STATE(18), 1,
      sym__open_brace,
    STATE(1923), 1,
      sym__single_quoted_string,
    STATE(1927), 1,
      sym_string,
    STATE(1934), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5137), 1,
      sym__string_or_identifier,
    ACTIONS(181), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1925), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(195), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9551), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(494), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [44505] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(161), 1,
      sym_identifier,
    ACTIONS(163), 1,
      anon_sym_BSLASH,
    ACTIONS(165), 1,
      anon_sym_function,
    ACTIONS(167), 1,
      anon_sym_if,
    ACTIONS(169), 1,
      anon_sym_for,
    ACTIONS(171), 1,
      anon_sym_while,
    ACTIONS(173), 1,
      anon_sym_repeat,
    ACTIONS(175), 1,
      anon_sym_QMARK,
    ACTIONS(177), 1,
      anon_sym_TILDE,
    ACTIONS(185), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(187), 1,
      sym__number_literal,
    ACTIONS(189), 1,
      anon_sym_SQUOTE,
    ACTIONS(191), 1,
      anon_sym_DQUOTE,
    ACTIONS(201), 1,
      sym__raw_string_literal,
    ACTIONS(203), 1,
      sym__external_open_parenthesis,
    ACTIONS(207), 1,
      sym__external_open_brace,
    ACTIONS(8009), 1,
      anon_sym_BANG,
    ACTIONS(9557), 1,
      sym_dot_dot_i,
    ACTIONS(9559), 1,
      sym__newline,
    STATE(14), 1,
      sym__open_parenthesis,
    STATE(18), 1,
      sym__open_brace,
    STATE(1923), 1,
      sym__single_quoted_string,
    STATE(1927), 1,
      sym_string,
    STATE(1934), 1,
      sym__double_quoted_string,
    STATE(3372), 1,
      aux_sym_function_definition_repeat1,
    STATE(5137), 1,
      sym__string_or_identifier,
    ACTIONS(181), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1925), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(195), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9555), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(493), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [44634] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(626), 1,
      sym_identifier,
    ACTIONS(628), 1,
      anon_sym_BSLASH,
    ACTIONS(630), 1,
      anon_sym_function,
    ACTIONS(632), 1,
      anon_sym_if,
    ACTIONS(634), 1,
      anon_sym_for,
    ACTIONS(636), 1,
      anon_sym_while,
    ACTIONS(638), 1,
      anon_sym_repeat,
    ACTIONS(640), 1,
      anon_sym_QMARK,
    ACTIONS(642), 1,
      anon_sym_TILDE,
    ACTIONS(650), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(652), 1,
      sym__number_literal,
    ACTIONS(654), 1,
      anon_sym_SQUOTE,
    ACTIONS(656), 1,
      anon_sym_DQUOTE,
    ACTIONS(666), 1,
      sym__raw_string_literal,
    ACTIONS(668), 1,
      sym__external_open_parenthesis,
    ACTIONS(670), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7933), 1,
      anon_sym_BANG,
    ACTIONS(9563), 1,
      sym_dot_dot_i,
    STATE(54), 1,
      sym__open_parenthesis,
    STATE(56), 1,
      sym__open_brace,
    STATE(2219), 1,
      sym_string,
    STATE(2221), 1,
      sym__single_quoted_string,
    STATE(2222), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5140), 1,
      sym__string_or_identifier,
    ACTIONS(646), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2220), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(660), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9561), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(696), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [44763] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(626), 1,
      sym_identifier,
    ACTIONS(628), 1,
      anon_sym_BSLASH,
    ACTIONS(630), 1,
      anon_sym_function,
    ACTIONS(632), 1,
      anon_sym_if,
    ACTIONS(634), 1,
      anon_sym_for,
    ACTIONS(636), 1,
      anon_sym_while,
    ACTIONS(638), 1,
      anon_sym_repeat,
    ACTIONS(640), 1,
      anon_sym_QMARK,
    ACTIONS(642), 1,
      anon_sym_TILDE,
    ACTIONS(650), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(652), 1,
      sym__number_literal,
    ACTIONS(654), 1,
      anon_sym_SQUOTE,
    ACTIONS(656), 1,
      anon_sym_DQUOTE,
    ACTIONS(666), 1,
      sym__raw_string_literal,
    ACTIONS(668), 1,
      sym__external_open_parenthesis,
    ACTIONS(670), 1,
      sym__external_open_brace,
    ACTIONS(7933), 1,
      anon_sym_BANG,
    ACTIONS(9567), 1,
      sym_dot_dot_i,
    ACTIONS(9569), 1,
      sym__newline,
    STATE(54), 1,
      sym__open_parenthesis,
    STATE(56), 1,
      sym__open_brace,
    STATE(2219), 1,
      sym_string,
    STATE(2221), 1,
      sym__single_quoted_string,
    STATE(2222), 1,
      sym__double_quoted_string,
    STATE(3417), 1,
      aux_sym_function_definition_repeat1,
    STATE(5140), 1,
      sym__string_or_identifier,
    ACTIONS(646), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2220), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(660), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9565), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(677), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [44892] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3845), 1,
      sym_identifier,
    ACTIONS(3847), 1,
      anon_sym_BSLASH,
    ACTIONS(3849), 1,
      anon_sym_function,
    ACTIONS(3851), 1,
      anon_sym_if,
    ACTIONS(3853), 1,
      anon_sym_for,
    ACTIONS(3855), 1,
      anon_sym_while,
    ACTIONS(3857), 1,
      anon_sym_repeat,
    ACTIONS(3859), 1,
      anon_sym_QMARK,
    ACTIONS(3861), 1,
      anon_sym_TILDE,
    ACTIONS(3869), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3871), 1,
      sym__number_literal,
    ACTIONS(3873), 1,
      anon_sym_SQUOTE,
    ACTIONS(3875), 1,
      anon_sym_DQUOTE,
    ACTIONS(3885), 1,
      sym__raw_string_literal,
    ACTIONS(3887), 1,
      sym__external_open_parenthesis,
    ACTIONS(3891), 1,
      sym__external_open_brace,
    ACTIONS(6389), 1,
      anon_sym_BANG,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9573), 1,
      sym_dot_dot_i,
    STATE(154), 1,
      sym__open_brace,
    STATE(350), 1,
      sym__open_parenthesis,
    STATE(2620), 1,
      sym__double_quoted_string,
    STATE(2673), 1,
      sym_string,
    STATE(2735), 1,
      sym__single_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5135), 1,
      sym__string_or_identifier,
    ACTIONS(3865), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2578), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3879), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9571), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2055), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [45021] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      sym_identifier,
    ACTIONS(105), 1,
      anon_sym_BSLASH,
    ACTIONS(107), 1,
      anon_sym_function,
    ACTIONS(111), 1,
      anon_sym_if,
    ACTIONS(113), 1,
      anon_sym_for,
    ACTIONS(115), 1,
      anon_sym_while,
    ACTIONS(117), 1,
      anon_sym_repeat,
    ACTIONS(119), 1,
      anon_sym_QMARK,
    ACTIONS(121), 1,
      anon_sym_TILDE,
    ACTIONS(131), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(133), 1,
      sym__number_literal,
    ACTIONS(135), 1,
      anon_sym_SQUOTE,
    ACTIONS(137), 1,
      anon_sym_DQUOTE,
    ACTIONS(147), 1,
      sym__raw_string_literal,
    ACTIONS(149), 1,
      sym__external_open_parenthesis,
    ACTIONS(153), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8381), 1,
      anon_sym_BANG,
    ACTIONS(9577), 1,
      sym_dot_dot_i,
    STATE(10), 1,
      sym__open_brace,
    STATE(20), 1,
      sym__open_parenthesis,
    STATE(2016), 1,
      sym_string,
    STATE(2027), 1,
      sym__single_quoted_string,
    STATE(2041), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5131), 1,
      sym__string_or_identifier,
    ACTIONS(125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2021), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(141), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9575), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(483), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [45150] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      sym_identifier,
    ACTIONS(105), 1,
      anon_sym_BSLASH,
    ACTIONS(107), 1,
      anon_sym_function,
    ACTIONS(111), 1,
      anon_sym_if,
    ACTIONS(113), 1,
      anon_sym_for,
    ACTIONS(115), 1,
      anon_sym_while,
    ACTIONS(117), 1,
      anon_sym_repeat,
    ACTIONS(119), 1,
      anon_sym_QMARK,
    ACTIONS(121), 1,
      anon_sym_TILDE,
    ACTIONS(131), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(133), 1,
      sym__number_literal,
    ACTIONS(135), 1,
      anon_sym_SQUOTE,
    ACTIONS(137), 1,
      anon_sym_DQUOTE,
    ACTIONS(147), 1,
      sym__raw_string_literal,
    ACTIONS(149), 1,
      sym__external_open_parenthesis,
    ACTIONS(153), 1,
      sym__external_open_brace,
    ACTIONS(8381), 1,
      anon_sym_BANG,
    ACTIONS(9581), 1,
      sym_dot_dot_i,
    ACTIONS(9583), 1,
      sym__newline,
    STATE(10), 1,
      sym__open_brace,
    STATE(20), 1,
      sym__open_parenthesis,
    STATE(2016), 1,
      sym_string,
    STATE(2027), 1,
      sym__single_quoted_string,
    STATE(2041), 1,
      sym__double_quoted_string,
    STATE(3377), 1,
      aux_sym_function_definition_repeat1,
    STATE(5131), 1,
      sym__string_or_identifier,
    ACTIONS(125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2021), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(141), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9579), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(477), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [45279] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      sym_identifier,
    ACTIONS(105), 1,
      anon_sym_BSLASH,
    ACTIONS(107), 1,
      anon_sym_function,
    ACTIONS(111), 1,
      anon_sym_if,
    ACTIONS(113), 1,
      anon_sym_for,
    ACTIONS(115), 1,
      anon_sym_while,
    ACTIONS(117), 1,
      anon_sym_repeat,
    ACTIONS(119), 1,
      anon_sym_QMARK,
    ACTIONS(121), 1,
      anon_sym_TILDE,
    ACTIONS(131), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(133), 1,
      sym__number_literal,
    ACTIONS(135), 1,
      anon_sym_SQUOTE,
    ACTIONS(137), 1,
      anon_sym_DQUOTE,
    ACTIONS(147), 1,
      sym__raw_string_literal,
    ACTIONS(149), 1,
      sym__external_open_parenthesis,
    ACTIONS(153), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8381), 1,
      anon_sym_BANG,
    ACTIONS(9587), 1,
      sym_dot_dot_i,
    STATE(10), 1,
      sym__open_brace,
    STATE(20), 1,
      sym__open_parenthesis,
    STATE(2016), 1,
      sym_string,
    STATE(2027), 1,
      sym__single_quoted_string,
    STATE(2041), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5131), 1,
      sym__string_or_identifier,
    ACTIONS(125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2021), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(141), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9585), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(480), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [45408] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      sym_identifier,
    ACTIONS(105), 1,
      anon_sym_BSLASH,
    ACTIONS(107), 1,
      anon_sym_function,
    ACTIONS(111), 1,
      anon_sym_if,
    ACTIONS(113), 1,
      anon_sym_for,
    ACTIONS(115), 1,
      anon_sym_while,
    ACTIONS(117), 1,
      anon_sym_repeat,
    ACTIONS(119), 1,
      anon_sym_QMARK,
    ACTIONS(121), 1,
      anon_sym_TILDE,
    ACTIONS(131), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(133), 1,
      sym__number_literal,
    ACTIONS(135), 1,
      anon_sym_SQUOTE,
    ACTIONS(137), 1,
      anon_sym_DQUOTE,
    ACTIONS(147), 1,
      sym__raw_string_literal,
    ACTIONS(149), 1,
      sym__external_open_parenthesis,
    ACTIONS(153), 1,
      sym__external_open_brace,
    ACTIONS(8381), 1,
      anon_sym_BANG,
    ACTIONS(9591), 1,
      sym_dot_dot_i,
    ACTIONS(9593), 1,
      sym__newline,
    STATE(10), 1,
      sym__open_brace,
    STATE(20), 1,
      sym__open_parenthesis,
    STATE(2016), 1,
      sym_string,
    STATE(2027), 1,
      sym__single_quoted_string,
    STATE(2041), 1,
      sym__double_quoted_string,
    STATE(3379), 1,
      aux_sym_function_definition_repeat1,
    STATE(5131), 1,
      sym__string_or_identifier,
    ACTIONS(125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2021), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(141), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9589), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(486), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [45537] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3845), 1,
      sym_identifier,
    ACTIONS(3847), 1,
      anon_sym_BSLASH,
    ACTIONS(3849), 1,
      anon_sym_function,
    ACTIONS(3851), 1,
      anon_sym_if,
    ACTIONS(3853), 1,
      anon_sym_for,
    ACTIONS(3855), 1,
      anon_sym_while,
    ACTIONS(3857), 1,
      anon_sym_repeat,
    ACTIONS(3859), 1,
      anon_sym_QMARK,
    ACTIONS(3861), 1,
      anon_sym_TILDE,
    ACTIONS(3869), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3871), 1,
      sym__number_literal,
    ACTIONS(3873), 1,
      anon_sym_SQUOTE,
    ACTIONS(3875), 1,
      anon_sym_DQUOTE,
    ACTIONS(3885), 1,
      sym__raw_string_literal,
    ACTIONS(3887), 1,
      sym__external_open_parenthesis,
    ACTIONS(3891), 1,
      sym__external_open_brace,
    ACTIONS(6389), 1,
      anon_sym_BANG,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9597), 1,
      sym_dot_dot_i,
    STATE(154), 1,
      sym__open_brace,
    STATE(350), 1,
      sym__open_parenthesis,
    STATE(2620), 1,
      sym__double_quoted_string,
    STATE(2673), 1,
      sym_string,
    STATE(2735), 1,
      sym__single_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5135), 1,
      sym__string_or_identifier,
    ACTIONS(3865), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2578), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3879), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9595), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2012), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [45666] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1241), 1,
      sym_identifier,
    ACTIONS(1243), 1,
      anon_sym_BSLASH,
    ACTIONS(1245), 1,
      anon_sym_function,
    ACTIONS(1247), 1,
      anon_sym_if,
    ACTIONS(1249), 1,
      anon_sym_for,
    ACTIONS(1251), 1,
      anon_sym_while,
    ACTIONS(1253), 1,
      anon_sym_repeat,
    ACTIONS(1255), 1,
      anon_sym_QMARK,
    ACTIONS(1257), 1,
      anon_sym_TILDE,
    ACTIONS(1265), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1267), 1,
      sym__number_literal,
    ACTIONS(1269), 1,
      anon_sym_SQUOTE,
    ACTIONS(1271), 1,
      anon_sym_DQUOTE,
    ACTIONS(1281), 1,
      sym__raw_string_literal,
    ACTIONS(1283), 1,
      sym__external_open_parenthesis,
    ACTIONS(1287), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8543), 1,
      anon_sym_BANG,
    ACTIONS(9601), 1,
      sym_dot_dot_i,
    STATE(11), 1,
      sym__open_brace,
    STATE(120), 1,
      sym__open_parenthesis,
    STATE(2271), 1,
      sym_string,
    STATE(2273), 1,
      sym__single_quoted_string,
    STATE(2274), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5157), 1,
      sym__string_or_identifier,
    ACTIONS(1261), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2272), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1275), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9599), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1277), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [45795] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3845), 1,
      sym_identifier,
    ACTIONS(3847), 1,
      anon_sym_BSLASH,
    ACTIONS(3849), 1,
      anon_sym_function,
    ACTIONS(3851), 1,
      anon_sym_if,
    ACTIONS(3853), 1,
      anon_sym_for,
    ACTIONS(3855), 1,
      anon_sym_while,
    ACTIONS(3857), 1,
      anon_sym_repeat,
    ACTIONS(3859), 1,
      anon_sym_QMARK,
    ACTIONS(3861), 1,
      anon_sym_TILDE,
    ACTIONS(3869), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3871), 1,
      sym__number_literal,
    ACTIONS(3873), 1,
      anon_sym_SQUOTE,
    ACTIONS(3875), 1,
      anon_sym_DQUOTE,
    ACTIONS(3885), 1,
      sym__raw_string_literal,
    ACTIONS(3887), 1,
      sym__external_open_parenthesis,
    ACTIONS(3891), 1,
      sym__external_open_brace,
    ACTIONS(6389), 1,
      anon_sym_BANG,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9605), 1,
      sym_dot_dot_i,
    STATE(154), 1,
      sym__open_brace,
    STATE(350), 1,
      sym__open_parenthesis,
    STATE(2620), 1,
      sym__double_quoted_string,
    STATE(2673), 1,
      sym_string,
    STATE(2735), 1,
      sym__single_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5135), 1,
      sym__string_or_identifier,
    ACTIONS(3865), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2578), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3879), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9603), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2030), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [45924] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1241), 1,
      sym_identifier,
    ACTIONS(1243), 1,
      anon_sym_BSLASH,
    ACTIONS(1245), 1,
      anon_sym_function,
    ACTIONS(1247), 1,
      anon_sym_if,
    ACTIONS(1249), 1,
      anon_sym_for,
    ACTIONS(1251), 1,
      anon_sym_while,
    ACTIONS(1253), 1,
      anon_sym_repeat,
    ACTIONS(1255), 1,
      anon_sym_QMARK,
    ACTIONS(1257), 1,
      anon_sym_TILDE,
    ACTIONS(1265), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1267), 1,
      sym__number_literal,
    ACTIONS(1269), 1,
      anon_sym_SQUOTE,
    ACTIONS(1271), 1,
      anon_sym_DQUOTE,
    ACTIONS(1281), 1,
      sym__raw_string_literal,
    ACTIONS(1283), 1,
      sym__external_open_parenthesis,
    ACTIONS(1287), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8543), 1,
      anon_sym_BANG,
    ACTIONS(9609), 1,
      sym_dot_dot_i,
    STATE(11), 1,
      sym__open_brace,
    STATE(120), 1,
      sym__open_parenthesis,
    STATE(2271), 1,
      sym_string,
    STATE(2273), 1,
      sym__single_quoted_string,
    STATE(2274), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5157), 1,
      sym__string_or_identifier,
    ACTIONS(1261), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2272), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1275), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9607), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1278), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [46053] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2531), 1,
      sym_identifier,
    ACTIONS(2533), 1,
      anon_sym_BSLASH,
    ACTIONS(2535), 1,
      anon_sym_function,
    ACTIONS(2537), 1,
      anon_sym_if,
    ACTIONS(2539), 1,
      anon_sym_for,
    ACTIONS(2541), 1,
      anon_sym_while,
    ACTIONS(2543), 1,
      anon_sym_repeat,
    ACTIONS(2545), 1,
      anon_sym_QMARK,
    ACTIONS(2547), 1,
      anon_sym_TILDE,
    ACTIONS(2555), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2557), 1,
      sym__number_literal,
    ACTIONS(2559), 1,
      anon_sym_SQUOTE,
    ACTIONS(2561), 1,
      anon_sym_DQUOTE,
    ACTIONS(2571), 1,
      sym__raw_string_literal,
    ACTIONS(2573), 1,
      sym__external_open_parenthesis,
    ACTIONS(2577), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9611), 1,
      anon_sym_BANG,
    ACTIONS(9615), 1,
      sym_dot_dot_i,
    STATE(70), 1,
      sym__open_brace,
    STATE(213), 1,
      sym__open_parenthesis,
    STATE(2437), 1,
      sym__double_quoted_string,
    STATE(2442), 1,
      sym__single_quoted_string,
    STATE(2530), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5133), 1,
      sym__string_or_identifier,
    ACTIONS(2551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2445), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2565), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9613), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1441), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [46182] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1241), 1,
      sym_identifier,
    ACTIONS(1243), 1,
      anon_sym_BSLASH,
    ACTIONS(1245), 1,
      anon_sym_function,
    ACTIONS(1247), 1,
      anon_sym_if,
    ACTIONS(1249), 1,
      anon_sym_for,
    ACTIONS(1251), 1,
      anon_sym_while,
    ACTIONS(1253), 1,
      anon_sym_repeat,
    ACTIONS(1255), 1,
      anon_sym_QMARK,
    ACTIONS(1257), 1,
      anon_sym_TILDE,
    ACTIONS(1265), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1267), 1,
      sym__number_literal,
    ACTIONS(1269), 1,
      anon_sym_SQUOTE,
    ACTIONS(1271), 1,
      anon_sym_DQUOTE,
    ACTIONS(1281), 1,
      sym__raw_string_literal,
    ACTIONS(1283), 1,
      sym__external_open_parenthesis,
    ACTIONS(1287), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8543), 1,
      anon_sym_BANG,
    ACTIONS(9619), 1,
      sym_dot_dot_i,
    STATE(11), 1,
      sym__open_brace,
    STATE(120), 1,
      sym__open_parenthesis,
    STATE(2271), 1,
      sym_string,
    STATE(2273), 1,
      sym__single_quoted_string,
    STATE(2274), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5157), 1,
      sym__string_or_identifier,
    ACTIONS(1261), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2272), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1275), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9617), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1279), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [46311] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2531), 1,
      sym_identifier,
    ACTIONS(2533), 1,
      anon_sym_BSLASH,
    ACTIONS(2535), 1,
      anon_sym_function,
    ACTIONS(2537), 1,
      anon_sym_if,
    ACTIONS(2539), 1,
      anon_sym_for,
    ACTIONS(2541), 1,
      anon_sym_while,
    ACTIONS(2543), 1,
      anon_sym_repeat,
    ACTIONS(2545), 1,
      anon_sym_QMARK,
    ACTIONS(2547), 1,
      anon_sym_TILDE,
    ACTIONS(2555), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2557), 1,
      sym__number_literal,
    ACTIONS(2559), 1,
      anon_sym_SQUOTE,
    ACTIONS(2561), 1,
      anon_sym_DQUOTE,
    ACTIONS(2571), 1,
      sym__raw_string_literal,
    ACTIONS(2573), 1,
      sym__external_open_parenthesis,
    ACTIONS(2577), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9611), 1,
      anon_sym_BANG,
    ACTIONS(9623), 1,
      sym_dot_dot_i,
    STATE(70), 1,
      sym__open_brace,
    STATE(213), 1,
      sym__open_parenthesis,
    STATE(2437), 1,
      sym__double_quoted_string,
    STATE(2442), 1,
      sym__single_quoted_string,
    STATE(2530), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5133), 1,
      sym__string_or_identifier,
    ACTIONS(2551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2445), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2565), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9621), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1440), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [46440] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1241), 1,
      sym_identifier,
    ACTIONS(1243), 1,
      anon_sym_BSLASH,
    ACTIONS(1245), 1,
      anon_sym_function,
    ACTIONS(1247), 1,
      anon_sym_if,
    ACTIONS(1249), 1,
      anon_sym_for,
    ACTIONS(1251), 1,
      anon_sym_while,
    ACTIONS(1253), 1,
      anon_sym_repeat,
    ACTIONS(1255), 1,
      anon_sym_QMARK,
    ACTIONS(1257), 1,
      anon_sym_TILDE,
    ACTIONS(1265), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1267), 1,
      sym__number_literal,
    ACTIONS(1269), 1,
      anon_sym_SQUOTE,
    ACTIONS(1271), 1,
      anon_sym_DQUOTE,
    ACTIONS(1281), 1,
      sym__raw_string_literal,
    ACTIONS(1283), 1,
      sym__external_open_parenthesis,
    ACTIONS(1287), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8543), 1,
      anon_sym_BANG,
    ACTIONS(9627), 1,
      sym_dot_dot_i,
    STATE(11), 1,
      sym__open_brace,
    STATE(120), 1,
      sym__open_parenthesis,
    STATE(2271), 1,
      sym_string,
    STATE(2273), 1,
      sym__single_quoted_string,
    STATE(2274), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5157), 1,
      sym__string_or_identifier,
    ACTIONS(1261), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2272), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1275), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9625), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1281), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [46569] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2531), 1,
      sym_identifier,
    ACTIONS(2533), 1,
      anon_sym_BSLASH,
    ACTIONS(2535), 1,
      anon_sym_function,
    ACTIONS(2537), 1,
      anon_sym_if,
    ACTIONS(2539), 1,
      anon_sym_for,
    ACTIONS(2541), 1,
      anon_sym_while,
    ACTIONS(2543), 1,
      anon_sym_repeat,
    ACTIONS(2545), 1,
      anon_sym_QMARK,
    ACTIONS(2547), 1,
      anon_sym_TILDE,
    ACTIONS(2555), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2557), 1,
      sym__number_literal,
    ACTIONS(2559), 1,
      anon_sym_SQUOTE,
    ACTIONS(2561), 1,
      anon_sym_DQUOTE,
    ACTIONS(2571), 1,
      sym__raw_string_literal,
    ACTIONS(2573), 1,
      sym__external_open_parenthesis,
    ACTIONS(2577), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9611), 1,
      anon_sym_BANG,
    ACTIONS(9631), 1,
      sym_dot_dot_i,
    STATE(70), 1,
      sym__open_brace,
    STATE(213), 1,
      sym__open_parenthesis,
    STATE(2437), 1,
      sym__double_quoted_string,
    STATE(2442), 1,
      sym__single_quoted_string,
    STATE(2530), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5133), 1,
      sym__string_or_identifier,
    ACTIONS(2551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2445), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2565), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9629), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1439), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [46698] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1241), 1,
      sym_identifier,
    ACTIONS(1243), 1,
      anon_sym_BSLASH,
    ACTIONS(1245), 1,
      anon_sym_function,
    ACTIONS(1247), 1,
      anon_sym_if,
    ACTIONS(1249), 1,
      anon_sym_for,
    ACTIONS(1251), 1,
      anon_sym_while,
    ACTIONS(1253), 1,
      anon_sym_repeat,
    ACTIONS(1255), 1,
      anon_sym_QMARK,
    ACTIONS(1257), 1,
      anon_sym_TILDE,
    ACTIONS(1265), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1267), 1,
      sym__number_literal,
    ACTIONS(1269), 1,
      anon_sym_SQUOTE,
    ACTIONS(1271), 1,
      anon_sym_DQUOTE,
    ACTIONS(1281), 1,
      sym__raw_string_literal,
    ACTIONS(1283), 1,
      sym__external_open_parenthesis,
    ACTIONS(1287), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8543), 1,
      anon_sym_BANG,
    ACTIONS(9635), 1,
      sym_dot_dot_i,
    STATE(11), 1,
      sym__open_brace,
    STATE(120), 1,
      sym__open_parenthesis,
    STATE(2271), 1,
      sym_string,
    STATE(2273), 1,
      sym__single_quoted_string,
    STATE(2274), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5157), 1,
      sym__string_or_identifier,
    ACTIONS(1261), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2272), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1275), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9633), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1282), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [46827] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2531), 1,
      sym_identifier,
    ACTIONS(2533), 1,
      anon_sym_BSLASH,
    ACTIONS(2535), 1,
      anon_sym_function,
    ACTIONS(2537), 1,
      anon_sym_if,
    ACTIONS(2539), 1,
      anon_sym_for,
    ACTIONS(2541), 1,
      anon_sym_while,
    ACTIONS(2543), 1,
      anon_sym_repeat,
    ACTIONS(2545), 1,
      anon_sym_QMARK,
    ACTIONS(2547), 1,
      anon_sym_TILDE,
    ACTIONS(2555), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2557), 1,
      sym__number_literal,
    ACTIONS(2559), 1,
      anon_sym_SQUOTE,
    ACTIONS(2561), 1,
      anon_sym_DQUOTE,
    ACTIONS(2571), 1,
      sym__raw_string_literal,
    ACTIONS(2573), 1,
      sym__external_open_parenthesis,
    ACTIONS(2577), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9611), 1,
      anon_sym_BANG,
    ACTIONS(9639), 1,
      sym_dot_dot_i,
    STATE(70), 1,
      sym__open_brace,
    STATE(213), 1,
      sym__open_parenthesis,
    STATE(2437), 1,
      sym__double_quoted_string,
    STATE(2442), 1,
      sym__single_quoted_string,
    STATE(2530), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5133), 1,
      sym__string_or_identifier,
    ACTIONS(2551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2445), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2565), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9637), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1438), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [46956] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1241), 1,
      sym_identifier,
    ACTIONS(1243), 1,
      anon_sym_BSLASH,
    ACTIONS(1245), 1,
      anon_sym_function,
    ACTIONS(1247), 1,
      anon_sym_if,
    ACTIONS(1249), 1,
      anon_sym_for,
    ACTIONS(1251), 1,
      anon_sym_while,
    ACTIONS(1253), 1,
      anon_sym_repeat,
    ACTIONS(1255), 1,
      anon_sym_QMARK,
    ACTIONS(1257), 1,
      anon_sym_TILDE,
    ACTIONS(1265), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1267), 1,
      sym__number_literal,
    ACTIONS(1269), 1,
      anon_sym_SQUOTE,
    ACTIONS(1271), 1,
      anon_sym_DQUOTE,
    ACTIONS(1281), 1,
      sym__raw_string_literal,
    ACTIONS(1283), 1,
      sym__external_open_parenthesis,
    ACTIONS(1287), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8543), 1,
      anon_sym_BANG,
    ACTIONS(9643), 1,
      sym_dot_dot_i,
    STATE(11), 1,
      sym__open_brace,
    STATE(120), 1,
      sym__open_parenthesis,
    STATE(2271), 1,
      sym_string,
    STATE(2273), 1,
      sym__single_quoted_string,
    STATE(2274), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5157), 1,
      sym__string_or_identifier,
    ACTIONS(1261), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2272), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1275), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9641), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1284), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [47085] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2531), 1,
      sym_identifier,
    ACTIONS(2533), 1,
      anon_sym_BSLASH,
    ACTIONS(2535), 1,
      anon_sym_function,
    ACTIONS(2537), 1,
      anon_sym_if,
    ACTIONS(2539), 1,
      anon_sym_for,
    ACTIONS(2541), 1,
      anon_sym_while,
    ACTIONS(2543), 1,
      anon_sym_repeat,
    ACTIONS(2545), 1,
      anon_sym_QMARK,
    ACTIONS(2547), 1,
      anon_sym_TILDE,
    ACTIONS(2555), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2557), 1,
      sym__number_literal,
    ACTIONS(2559), 1,
      anon_sym_SQUOTE,
    ACTIONS(2561), 1,
      anon_sym_DQUOTE,
    ACTIONS(2571), 1,
      sym__raw_string_literal,
    ACTIONS(2573), 1,
      sym__external_open_parenthesis,
    ACTIONS(2577), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9611), 1,
      anon_sym_BANG,
    ACTIONS(9647), 1,
      sym_dot_dot_i,
    STATE(70), 1,
      sym__open_brace,
    STATE(213), 1,
      sym__open_parenthesis,
    STATE(2437), 1,
      sym__double_quoted_string,
    STATE(2442), 1,
      sym__single_quoted_string,
    STATE(2530), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5133), 1,
      sym__string_or_identifier,
    ACTIONS(2551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2445), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2565), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9645), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1437), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [47214] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1241), 1,
      sym_identifier,
    ACTIONS(1243), 1,
      anon_sym_BSLASH,
    ACTIONS(1245), 1,
      anon_sym_function,
    ACTIONS(1247), 1,
      anon_sym_if,
    ACTIONS(1249), 1,
      anon_sym_for,
    ACTIONS(1251), 1,
      anon_sym_while,
    ACTIONS(1253), 1,
      anon_sym_repeat,
    ACTIONS(1255), 1,
      anon_sym_QMARK,
    ACTIONS(1257), 1,
      anon_sym_TILDE,
    ACTIONS(1265), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1267), 1,
      sym__number_literal,
    ACTIONS(1269), 1,
      anon_sym_SQUOTE,
    ACTIONS(1271), 1,
      anon_sym_DQUOTE,
    ACTIONS(1281), 1,
      sym__raw_string_literal,
    ACTIONS(1283), 1,
      sym__external_open_parenthesis,
    ACTIONS(1287), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8543), 1,
      anon_sym_BANG,
    ACTIONS(9651), 1,
      sym_dot_dot_i,
    STATE(11), 1,
      sym__open_brace,
    STATE(120), 1,
      sym__open_parenthesis,
    STATE(2271), 1,
      sym_string,
    STATE(2273), 1,
      sym__single_quoted_string,
    STATE(2274), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5157), 1,
      sym__string_or_identifier,
    ACTIONS(1261), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2272), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1275), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9649), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1285), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [47343] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2531), 1,
      sym_identifier,
    ACTIONS(2533), 1,
      anon_sym_BSLASH,
    ACTIONS(2535), 1,
      anon_sym_function,
    ACTIONS(2537), 1,
      anon_sym_if,
    ACTIONS(2539), 1,
      anon_sym_for,
    ACTIONS(2541), 1,
      anon_sym_while,
    ACTIONS(2543), 1,
      anon_sym_repeat,
    ACTIONS(2545), 1,
      anon_sym_QMARK,
    ACTIONS(2547), 1,
      anon_sym_TILDE,
    ACTIONS(2555), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2557), 1,
      sym__number_literal,
    ACTIONS(2559), 1,
      anon_sym_SQUOTE,
    ACTIONS(2561), 1,
      anon_sym_DQUOTE,
    ACTIONS(2571), 1,
      sym__raw_string_literal,
    ACTIONS(2573), 1,
      sym__external_open_parenthesis,
    ACTIONS(2577), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9611), 1,
      anon_sym_BANG,
    ACTIONS(9655), 1,
      sym_dot_dot_i,
    STATE(70), 1,
      sym__open_brace,
    STATE(213), 1,
      sym__open_parenthesis,
    STATE(2437), 1,
      sym__double_quoted_string,
    STATE(2442), 1,
      sym__single_quoted_string,
    STATE(2530), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5133), 1,
      sym__string_or_identifier,
    ACTIONS(2551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2445), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2565), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9653), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1436), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [47472] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1241), 1,
      sym_identifier,
    ACTIONS(1243), 1,
      anon_sym_BSLASH,
    ACTIONS(1245), 1,
      anon_sym_function,
    ACTIONS(1247), 1,
      anon_sym_if,
    ACTIONS(1249), 1,
      anon_sym_for,
    ACTIONS(1251), 1,
      anon_sym_while,
    ACTIONS(1253), 1,
      anon_sym_repeat,
    ACTIONS(1255), 1,
      anon_sym_QMARK,
    ACTIONS(1257), 1,
      anon_sym_TILDE,
    ACTIONS(1265), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1267), 1,
      sym__number_literal,
    ACTIONS(1269), 1,
      anon_sym_SQUOTE,
    ACTIONS(1271), 1,
      anon_sym_DQUOTE,
    ACTIONS(1281), 1,
      sym__raw_string_literal,
    ACTIONS(1283), 1,
      sym__external_open_parenthesis,
    ACTIONS(1287), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8543), 1,
      anon_sym_BANG,
    ACTIONS(9659), 1,
      sym_dot_dot_i,
    STATE(11), 1,
      sym__open_brace,
    STATE(120), 1,
      sym__open_parenthesis,
    STATE(2271), 1,
      sym_string,
    STATE(2273), 1,
      sym__single_quoted_string,
    STATE(2274), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5157), 1,
      sym__string_or_identifier,
    ACTIONS(1261), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2272), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1275), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9657), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1292), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [47601] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2531), 1,
      sym_identifier,
    ACTIONS(2533), 1,
      anon_sym_BSLASH,
    ACTIONS(2535), 1,
      anon_sym_function,
    ACTIONS(2537), 1,
      anon_sym_if,
    ACTIONS(2539), 1,
      anon_sym_for,
    ACTIONS(2541), 1,
      anon_sym_while,
    ACTIONS(2543), 1,
      anon_sym_repeat,
    ACTIONS(2545), 1,
      anon_sym_QMARK,
    ACTIONS(2547), 1,
      anon_sym_TILDE,
    ACTIONS(2555), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2557), 1,
      sym__number_literal,
    ACTIONS(2559), 1,
      anon_sym_SQUOTE,
    ACTIONS(2561), 1,
      anon_sym_DQUOTE,
    ACTIONS(2571), 1,
      sym__raw_string_literal,
    ACTIONS(2573), 1,
      sym__external_open_parenthesis,
    ACTIONS(2577), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9611), 1,
      anon_sym_BANG,
    ACTIONS(9663), 1,
      sym_dot_dot_i,
    STATE(70), 1,
      sym__open_brace,
    STATE(213), 1,
      sym__open_parenthesis,
    STATE(2437), 1,
      sym__double_quoted_string,
    STATE(2442), 1,
      sym__single_quoted_string,
    STATE(2530), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5133), 1,
      sym__string_or_identifier,
    ACTIONS(2551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2445), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2565), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9661), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1435), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [47730] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1241), 1,
      sym_identifier,
    ACTIONS(1243), 1,
      anon_sym_BSLASH,
    ACTIONS(1245), 1,
      anon_sym_function,
    ACTIONS(1247), 1,
      anon_sym_if,
    ACTIONS(1249), 1,
      anon_sym_for,
    ACTIONS(1251), 1,
      anon_sym_while,
    ACTIONS(1253), 1,
      anon_sym_repeat,
    ACTIONS(1255), 1,
      anon_sym_QMARK,
    ACTIONS(1257), 1,
      anon_sym_TILDE,
    ACTIONS(1265), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1267), 1,
      sym__number_literal,
    ACTIONS(1269), 1,
      anon_sym_SQUOTE,
    ACTIONS(1271), 1,
      anon_sym_DQUOTE,
    ACTIONS(1281), 1,
      sym__raw_string_literal,
    ACTIONS(1283), 1,
      sym__external_open_parenthesis,
    ACTIONS(1287), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8543), 1,
      anon_sym_BANG,
    ACTIONS(9667), 1,
      sym_dot_dot_i,
    STATE(11), 1,
      sym__open_brace,
    STATE(120), 1,
      sym__open_parenthesis,
    STATE(2271), 1,
      sym_string,
    STATE(2273), 1,
      sym__single_quoted_string,
    STATE(2274), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5157), 1,
      sym__string_or_identifier,
    ACTIONS(1261), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2272), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1275), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9665), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1296), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [47859] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2531), 1,
      sym_identifier,
    ACTIONS(2533), 1,
      anon_sym_BSLASH,
    ACTIONS(2535), 1,
      anon_sym_function,
    ACTIONS(2537), 1,
      anon_sym_if,
    ACTIONS(2539), 1,
      anon_sym_for,
    ACTIONS(2541), 1,
      anon_sym_while,
    ACTIONS(2543), 1,
      anon_sym_repeat,
    ACTIONS(2545), 1,
      anon_sym_QMARK,
    ACTIONS(2547), 1,
      anon_sym_TILDE,
    ACTIONS(2555), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2557), 1,
      sym__number_literal,
    ACTIONS(2559), 1,
      anon_sym_SQUOTE,
    ACTIONS(2561), 1,
      anon_sym_DQUOTE,
    ACTIONS(2571), 1,
      sym__raw_string_literal,
    ACTIONS(2573), 1,
      sym__external_open_parenthesis,
    ACTIONS(2577), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9611), 1,
      anon_sym_BANG,
    ACTIONS(9671), 1,
      sym_dot_dot_i,
    STATE(70), 1,
      sym__open_brace,
    STATE(213), 1,
      sym__open_parenthesis,
    STATE(2437), 1,
      sym__double_quoted_string,
    STATE(2442), 1,
      sym__single_quoted_string,
    STATE(2530), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5133), 1,
      sym__string_or_identifier,
    ACTIONS(2551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2445), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2565), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9669), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1434), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [47988] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1241), 1,
      sym_identifier,
    ACTIONS(1243), 1,
      anon_sym_BSLASH,
    ACTIONS(1245), 1,
      anon_sym_function,
    ACTIONS(1247), 1,
      anon_sym_if,
    ACTIONS(1249), 1,
      anon_sym_for,
    ACTIONS(1251), 1,
      anon_sym_while,
    ACTIONS(1253), 1,
      anon_sym_repeat,
    ACTIONS(1255), 1,
      anon_sym_QMARK,
    ACTIONS(1257), 1,
      anon_sym_TILDE,
    ACTIONS(1265), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1267), 1,
      sym__number_literal,
    ACTIONS(1269), 1,
      anon_sym_SQUOTE,
    ACTIONS(1271), 1,
      anon_sym_DQUOTE,
    ACTIONS(1281), 1,
      sym__raw_string_literal,
    ACTIONS(1283), 1,
      sym__external_open_parenthesis,
    ACTIONS(1287), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8543), 1,
      anon_sym_BANG,
    ACTIONS(9675), 1,
      sym_dot_dot_i,
    STATE(11), 1,
      sym__open_brace,
    STATE(120), 1,
      sym__open_parenthesis,
    STATE(2271), 1,
      sym_string,
    STATE(2273), 1,
      sym__single_quoted_string,
    STATE(2274), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5157), 1,
      sym__string_or_identifier,
    ACTIONS(1261), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2272), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1275), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9673), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1298), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [48117] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2531), 1,
      sym_identifier,
    ACTIONS(2533), 1,
      anon_sym_BSLASH,
    ACTIONS(2535), 1,
      anon_sym_function,
    ACTIONS(2537), 1,
      anon_sym_if,
    ACTIONS(2539), 1,
      anon_sym_for,
    ACTIONS(2541), 1,
      anon_sym_while,
    ACTIONS(2543), 1,
      anon_sym_repeat,
    ACTIONS(2545), 1,
      anon_sym_QMARK,
    ACTIONS(2547), 1,
      anon_sym_TILDE,
    ACTIONS(2555), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2557), 1,
      sym__number_literal,
    ACTIONS(2559), 1,
      anon_sym_SQUOTE,
    ACTIONS(2561), 1,
      anon_sym_DQUOTE,
    ACTIONS(2571), 1,
      sym__raw_string_literal,
    ACTIONS(2573), 1,
      sym__external_open_parenthesis,
    ACTIONS(2577), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9611), 1,
      anon_sym_BANG,
    ACTIONS(9679), 1,
      sym_dot_dot_i,
    STATE(70), 1,
      sym__open_brace,
    STATE(213), 1,
      sym__open_parenthesis,
    STATE(2437), 1,
      sym__double_quoted_string,
    STATE(2442), 1,
      sym__single_quoted_string,
    STATE(2530), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5133), 1,
      sym__string_or_identifier,
    ACTIONS(2551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2445), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2565), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9677), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1433), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [48246] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1241), 1,
      sym_identifier,
    ACTIONS(1243), 1,
      anon_sym_BSLASH,
    ACTIONS(1245), 1,
      anon_sym_function,
    ACTIONS(1247), 1,
      anon_sym_if,
    ACTIONS(1249), 1,
      anon_sym_for,
    ACTIONS(1251), 1,
      anon_sym_while,
    ACTIONS(1253), 1,
      anon_sym_repeat,
    ACTIONS(1255), 1,
      anon_sym_QMARK,
    ACTIONS(1257), 1,
      anon_sym_TILDE,
    ACTIONS(1265), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1267), 1,
      sym__number_literal,
    ACTIONS(1269), 1,
      anon_sym_SQUOTE,
    ACTIONS(1271), 1,
      anon_sym_DQUOTE,
    ACTIONS(1281), 1,
      sym__raw_string_literal,
    ACTIONS(1283), 1,
      sym__external_open_parenthesis,
    ACTIONS(1287), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8543), 1,
      anon_sym_BANG,
    ACTIONS(9683), 1,
      sym_dot_dot_i,
    STATE(11), 1,
      sym__open_brace,
    STATE(120), 1,
      sym__open_parenthesis,
    STATE(2271), 1,
      sym_string,
    STATE(2273), 1,
      sym__single_quoted_string,
    STATE(2274), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5157), 1,
      sym__string_or_identifier,
    ACTIONS(1261), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2272), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1275), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9681), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1302), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [48375] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2531), 1,
      sym_identifier,
    ACTIONS(2533), 1,
      anon_sym_BSLASH,
    ACTIONS(2535), 1,
      anon_sym_function,
    ACTIONS(2537), 1,
      anon_sym_if,
    ACTIONS(2539), 1,
      anon_sym_for,
    ACTIONS(2541), 1,
      anon_sym_while,
    ACTIONS(2543), 1,
      anon_sym_repeat,
    ACTIONS(2545), 1,
      anon_sym_QMARK,
    ACTIONS(2547), 1,
      anon_sym_TILDE,
    ACTIONS(2555), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2557), 1,
      sym__number_literal,
    ACTIONS(2559), 1,
      anon_sym_SQUOTE,
    ACTIONS(2561), 1,
      anon_sym_DQUOTE,
    ACTIONS(2571), 1,
      sym__raw_string_literal,
    ACTIONS(2573), 1,
      sym__external_open_parenthesis,
    ACTIONS(2577), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9611), 1,
      anon_sym_BANG,
    ACTIONS(9687), 1,
      sym_dot_dot_i,
    STATE(70), 1,
      sym__open_brace,
    STATE(213), 1,
      sym__open_parenthesis,
    STATE(2437), 1,
      sym__double_quoted_string,
    STATE(2442), 1,
      sym__single_quoted_string,
    STATE(2530), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5133), 1,
      sym__string_or_identifier,
    ACTIONS(2551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2445), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2565), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9685), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1432), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [48504] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1241), 1,
      sym_identifier,
    ACTIONS(1243), 1,
      anon_sym_BSLASH,
    ACTIONS(1245), 1,
      anon_sym_function,
    ACTIONS(1247), 1,
      anon_sym_if,
    ACTIONS(1249), 1,
      anon_sym_for,
    ACTIONS(1251), 1,
      anon_sym_while,
    ACTIONS(1253), 1,
      anon_sym_repeat,
    ACTIONS(1255), 1,
      anon_sym_QMARK,
    ACTIONS(1257), 1,
      anon_sym_TILDE,
    ACTIONS(1265), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1267), 1,
      sym__number_literal,
    ACTIONS(1269), 1,
      anon_sym_SQUOTE,
    ACTIONS(1271), 1,
      anon_sym_DQUOTE,
    ACTIONS(1281), 1,
      sym__raw_string_literal,
    ACTIONS(1283), 1,
      sym__external_open_parenthesis,
    ACTIONS(1287), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8543), 1,
      anon_sym_BANG,
    ACTIONS(9691), 1,
      sym_dot_dot_i,
    STATE(11), 1,
      sym__open_brace,
    STATE(120), 1,
      sym__open_parenthesis,
    STATE(2271), 1,
      sym_string,
    STATE(2273), 1,
      sym__single_quoted_string,
    STATE(2274), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5157), 1,
      sym__string_or_identifier,
    ACTIONS(1261), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2272), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1275), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9689), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1303), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [48633] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2531), 1,
      sym_identifier,
    ACTIONS(2533), 1,
      anon_sym_BSLASH,
    ACTIONS(2535), 1,
      anon_sym_function,
    ACTIONS(2537), 1,
      anon_sym_if,
    ACTIONS(2539), 1,
      anon_sym_for,
    ACTIONS(2541), 1,
      anon_sym_while,
    ACTIONS(2543), 1,
      anon_sym_repeat,
    ACTIONS(2545), 1,
      anon_sym_QMARK,
    ACTIONS(2547), 1,
      anon_sym_TILDE,
    ACTIONS(2555), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2557), 1,
      sym__number_literal,
    ACTIONS(2559), 1,
      anon_sym_SQUOTE,
    ACTIONS(2561), 1,
      anon_sym_DQUOTE,
    ACTIONS(2571), 1,
      sym__raw_string_literal,
    ACTIONS(2573), 1,
      sym__external_open_parenthesis,
    ACTIONS(2577), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9611), 1,
      anon_sym_BANG,
    ACTIONS(9695), 1,
      sym_dot_dot_i,
    STATE(70), 1,
      sym__open_brace,
    STATE(213), 1,
      sym__open_parenthesis,
    STATE(2437), 1,
      sym__double_quoted_string,
    STATE(2442), 1,
      sym__single_quoted_string,
    STATE(2530), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5133), 1,
      sym__string_or_identifier,
    ACTIONS(2551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2445), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2565), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9693), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1431), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [48762] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1241), 1,
      sym_identifier,
    ACTIONS(1243), 1,
      anon_sym_BSLASH,
    ACTIONS(1245), 1,
      anon_sym_function,
    ACTIONS(1247), 1,
      anon_sym_if,
    ACTIONS(1249), 1,
      anon_sym_for,
    ACTIONS(1251), 1,
      anon_sym_while,
    ACTIONS(1253), 1,
      anon_sym_repeat,
    ACTIONS(1255), 1,
      anon_sym_QMARK,
    ACTIONS(1257), 1,
      anon_sym_TILDE,
    ACTIONS(1265), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1267), 1,
      sym__number_literal,
    ACTIONS(1269), 1,
      anon_sym_SQUOTE,
    ACTIONS(1271), 1,
      anon_sym_DQUOTE,
    ACTIONS(1281), 1,
      sym__raw_string_literal,
    ACTIONS(1283), 1,
      sym__external_open_parenthesis,
    ACTIONS(1287), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8543), 1,
      anon_sym_BANG,
    ACTIONS(9699), 1,
      sym_dot_dot_i,
    STATE(11), 1,
      sym__open_brace,
    STATE(120), 1,
      sym__open_parenthesis,
    STATE(2271), 1,
      sym_string,
    STATE(2273), 1,
      sym__single_quoted_string,
    STATE(2274), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5157), 1,
      sym__string_or_identifier,
    ACTIONS(1261), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2272), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1275), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9697), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1304), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [48891] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3845), 1,
      sym_identifier,
    ACTIONS(3847), 1,
      anon_sym_BSLASH,
    ACTIONS(3849), 1,
      anon_sym_function,
    ACTIONS(3851), 1,
      anon_sym_if,
    ACTIONS(3853), 1,
      anon_sym_for,
    ACTIONS(3855), 1,
      anon_sym_while,
    ACTIONS(3857), 1,
      anon_sym_repeat,
    ACTIONS(3859), 1,
      anon_sym_QMARK,
    ACTIONS(3861), 1,
      anon_sym_TILDE,
    ACTIONS(3869), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3871), 1,
      sym__number_literal,
    ACTIONS(3873), 1,
      anon_sym_SQUOTE,
    ACTIONS(3875), 1,
      anon_sym_DQUOTE,
    ACTIONS(3885), 1,
      sym__raw_string_literal,
    ACTIONS(3887), 1,
      sym__external_open_parenthesis,
    ACTIONS(3891), 1,
      sym__external_open_brace,
    ACTIONS(6389), 1,
      anon_sym_BANG,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9703), 1,
      sym_dot_dot_i,
    STATE(154), 1,
      sym__open_brace,
    STATE(350), 1,
      sym__open_parenthesis,
    STATE(2620), 1,
      sym__double_quoted_string,
    STATE(2673), 1,
      sym_string,
    STATE(2735), 1,
      sym__single_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5135), 1,
      sym__string_or_identifier,
    ACTIONS(3865), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2578), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3879), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9701), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2037), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [49020] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2531), 1,
      sym_identifier,
    ACTIONS(2533), 1,
      anon_sym_BSLASH,
    ACTIONS(2535), 1,
      anon_sym_function,
    ACTIONS(2537), 1,
      anon_sym_if,
    ACTIONS(2539), 1,
      anon_sym_for,
    ACTIONS(2541), 1,
      anon_sym_while,
    ACTIONS(2543), 1,
      anon_sym_repeat,
    ACTIONS(2545), 1,
      anon_sym_QMARK,
    ACTIONS(2547), 1,
      anon_sym_TILDE,
    ACTIONS(2555), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2557), 1,
      sym__number_literal,
    ACTIONS(2559), 1,
      anon_sym_SQUOTE,
    ACTIONS(2561), 1,
      anon_sym_DQUOTE,
    ACTIONS(2571), 1,
      sym__raw_string_literal,
    ACTIONS(2573), 1,
      sym__external_open_parenthesis,
    ACTIONS(2577), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9611), 1,
      anon_sym_BANG,
    ACTIONS(9707), 1,
      sym_dot_dot_i,
    STATE(70), 1,
      sym__open_brace,
    STATE(213), 1,
      sym__open_parenthesis,
    STATE(2437), 1,
      sym__double_quoted_string,
    STATE(2442), 1,
      sym__single_quoted_string,
    STATE(2530), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5133), 1,
      sym__string_or_identifier,
    ACTIONS(2551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2445), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2565), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9705), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1430), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [49149] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(626), 1,
      sym_identifier,
    ACTIONS(628), 1,
      anon_sym_BSLASH,
    ACTIONS(630), 1,
      anon_sym_function,
    ACTIONS(632), 1,
      anon_sym_if,
    ACTIONS(634), 1,
      anon_sym_for,
    ACTIONS(636), 1,
      anon_sym_while,
    ACTIONS(638), 1,
      anon_sym_repeat,
    ACTIONS(640), 1,
      anon_sym_QMARK,
    ACTIONS(642), 1,
      anon_sym_TILDE,
    ACTIONS(650), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(652), 1,
      sym__number_literal,
    ACTIONS(654), 1,
      anon_sym_SQUOTE,
    ACTIONS(656), 1,
      anon_sym_DQUOTE,
    ACTIONS(666), 1,
      sym__raw_string_literal,
    ACTIONS(668), 1,
      sym__external_open_parenthesis,
    ACTIONS(670), 1,
      sym__external_open_brace,
    ACTIONS(7933), 1,
      anon_sym_BANG,
    ACTIONS(9711), 1,
      sym_dot_dot_i,
    ACTIONS(9713), 1,
      sym__newline,
    STATE(54), 1,
      sym__open_parenthesis,
    STATE(56), 1,
      sym__open_brace,
    STATE(2219), 1,
      sym_string,
    STATE(2221), 1,
      sym__single_quoted_string,
    STATE(2222), 1,
      sym__double_quoted_string,
    STATE(3612), 1,
      aux_sym_function_definition_repeat1,
    STATE(5140), 1,
      sym__string_or_identifier,
    ACTIONS(646), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2220), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(660), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9709), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(697), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [49278] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(405), 1,
      sym_identifier,
    ACTIONS(407), 1,
      anon_sym_BSLASH,
    ACTIONS(409), 1,
      anon_sym_function,
    ACTIONS(411), 1,
      anon_sym_if,
    ACTIONS(413), 1,
      anon_sym_for,
    ACTIONS(415), 1,
      anon_sym_while,
    ACTIONS(417), 1,
      anon_sym_repeat,
    ACTIONS(419), 1,
      anon_sym_QMARK,
    ACTIONS(421), 1,
      anon_sym_TILDE,
    ACTIONS(429), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(431), 1,
      sym__number_literal,
    ACTIONS(433), 1,
      anon_sym_SQUOTE,
    ACTIONS(435), 1,
      anon_sym_DQUOTE,
    ACTIONS(445), 1,
      sym__raw_string_literal,
    ACTIONS(447), 1,
      sym__external_open_parenthesis,
    ACTIONS(449), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8403), 1,
      anon_sym_BANG,
    ACTIONS(9717), 1,
      sym_dot_dot_i,
    STATE(5), 1,
      sym__open_parenthesis,
    STATE(42), 1,
      sym__open_brace,
    STATE(2209), 1,
      sym_string,
    STATE(2211), 1,
      sym__single_quoted_string,
    STATE(2212), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5127), 1,
      sym__string_or_identifier,
    ACTIONS(425), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2210), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(439), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9715), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(505), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [49407] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2531), 1,
      sym_identifier,
    ACTIONS(2533), 1,
      anon_sym_BSLASH,
    ACTIONS(2535), 1,
      anon_sym_function,
    ACTIONS(2537), 1,
      anon_sym_if,
    ACTIONS(2539), 1,
      anon_sym_for,
    ACTIONS(2541), 1,
      anon_sym_while,
    ACTIONS(2543), 1,
      anon_sym_repeat,
    ACTIONS(2545), 1,
      anon_sym_QMARK,
    ACTIONS(2547), 1,
      anon_sym_TILDE,
    ACTIONS(2555), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2557), 1,
      sym__number_literal,
    ACTIONS(2559), 1,
      anon_sym_SQUOTE,
    ACTIONS(2561), 1,
      anon_sym_DQUOTE,
    ACTIONS(2571), 1,
      sym__raw_string_literal,
    ACTIONS(2573), 1,
      sym__external_open_parenthesis,
    ACTIONS(2577), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9611), 1,
      anon_sym_BANG,
    ACTIONS(9721), 1,
      sym_dot_dot_i,
    STATE(70), 1,
      sym__open_brace,
    STATE(213), 1,
      sym__open_parenthesis,
    STATE(2437), 1,
      sym__double_quoted_string,
    STATE(2442), 1,
      sym__single_quoted_string,
    STATE(2530), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5133), 1,
      sym__string_or_identifier,
    ACTIONS(2551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2445), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2565), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9719), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1429), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [49536] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4214), 1,
      sym_identifier,
    ACTIONS(4216), 1,
      anon_sym_BSLASH,
    ACTIONS(4218), 1,
      anon_sym_function,
    ACTIONS(4220), 1,
      anon_sym_if,
    ACTIONS(4222), 1,
      anon_sym_for,
    ACTIONS(4224), 1,
      anon_sym_while,
    ACTIONS(4226), 1,
      anon_sym_repeat,
    ACTIONS(4228), 1,
      anon_sym_QMARK,
    ACTIONS(4230), 1,
      anon_sym_TILDE,
    ACTIONS(4238), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4240), 1,
      sym__number_literal,
    ACTIONS(4242), 1,
      anon_sym_SQUOTE,
    ACTIONS(4244), 1,
      anon_sym_DQUOTE,
    ACTIONS(4254), 1,
      sym__raw_string_literal,
    ACTIONS(4256), 1,
      sym__external_open_parenthesis,
    ACTIONS(4258), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9229), 1,
      anon_sym_BANG,
    ACTIONS(9725), 1,
      sym_dot_dot_i,
    STATE(51), 1,
      sym__open_brace,
    STATE(287), 1,
      sym__open_parenthesis,
    STATE(4674), 1,
      sym__single_quoted_string,
    STATE(4678), 1,
      sym__double_quoted_string,
    STATE(4681), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5129), 1,
      sym__string_or_identifier,
    ACTIONS(4234), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4680), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4248), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9723), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4389), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [49665] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(405), 1,
      sym_identifier,
    ACTIONS(407), 1,
      anon_sym_BSLASH,
    ACTIONS(409), 1,
      anon_sym_function,
    ACTIONS(411), 1,
      anon_sym_if,
    ACTIONS(413), 1,
      anon_sym_for,
    ACTIONS(415), 1,
      anon_sym_while,
    ACTIONS(417), 1,
      anon_sym_repeat,
    ACTIONS(419), 1,
      anon_sym_QMARK,
    ACTIONS(421), 1,
      anon_sym_TILDE,
    ACTIONS(429), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(431), 1,
      sym__number_literal,
    ACTIONS(433), 1,
      anon_sym_SQUOTE,
    ACTIONS(435), 1,
      anon_sym_DQUOTE,
    ACTIONS(445), 1,
      sym__raw_string_literal,
    ACTIONS(447), 1,
      sym__external_open_parenthesis,
    ACTIONS(449), 1,
      sym__external_open_brace,
    ACTIONS(8403), 1,
      anon_sym_BANG,
    ACTIONS(9729), 1,
      sym_dot_dot_i,
    ACTIONS(9731), 1,
      sym__newline,
    STATE(5), 1,
      sym__open_parenthesis,
    STATE(42), 1,
      sym__open_brace,
    STATE(2209), 1,
      sym_string,
    STATE(2211), 1,
      sym__single_quoted_string,
    STATE(2212), 1,
      sym__double_quoted_string,
    STATE(3410), 1,
      aux_sym_function_definition_repeat1,
    STATE(5127), 1,
      sym__string_or_identifier,
    ACTIONS(425), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2210), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(439), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9727), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(503), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [49794] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(405), 1,
      sym_identifier,
    ACTIONS(407), 1,
      anon_sym_BSLASH,
    ACTIONS(409), 1,
      anon_sym_function,
    ACTIONS(411), 1,
      anon_sym_if,
    ACTIONS(413), 1,
      anon_sym_for,
    ACTIONS(415), 1,
      anon_sym_while,
    ACTIONS(417), 1,
      anon_sym_repeat,
    ACTIONS(419), 1,
      anon_sym_QMARK,
    ACTIONS(421), 1,
      anon_sym_TILDE,
    ACTIONS(429), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(431), 1,
      sym__number_literal,
    ACTIONS(433), 1,
      anon_sym_SQUOTE,
    ACTIONS(435), 1,
      anon_sym_DQUOTE,
    ACTIONS(445), 1,
      sym__raw_string_literal,
    ACTIONS(447), 1,
      sym__external_open_parenthesis,
    ACTIONS(449), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8403), 1,
      anon_sym_BANG,
    ACTIONS(9735), 1,
      sym_dot_dot_i,
    STATE(5), 1,
      sym__open_parenthesis,
    STATE(42), 1,
      sym__open_brace,
    STATE(2209), 1,
      sym_string,
    STATE(2211), 1,
      sym__single_quoted_string,
    STATE(2212), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5127), 1,
      sym__string_or_identifier,
    ACTIONS(425), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2210), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(439), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9733), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(504), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [49923] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(405), 1,
      sym_identifier,
    ACTIONS(407), 1,
      anon_sym_BSLASH,
    ACTIONS(409), 1,
      anon_sym_function,
    ACTIONS(411), 1,
      anon_sym_if,
    ACTIONS(413), 1,
      anon_sym_for,
    ACTIONS(415), 1,
      anon_sym_while,
    ACTIONS(417), 1,
      anon_sym_repeat,
    ACTIONS(419), 1,
      anon_sym_QMARK,
    ACTIONS(421), 1,
      anon_sym_TILDE,
    ACTIONS(429), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(431), 1,
      sym__number_literal,
    ACTIONS(433), 1,
      anon_sym_SQUOTE,
    ACTIONS(435), 1,
      anon_sym_DQUOTE,
    ACTIONS(445), 1,
      sym__raw_string_literal,
    ACTIONS(447), 1,
      sym__external_open_parenthesis,
    ACTIONS(449), 1,
      sym__external_open_brace,
    ACTIONS(8403), 1,
      anon_sym_BANG,
    ACTIONS(9739), 1,
      sym_dot_dot_i,
    ACTIONS(9741), 1,
      sym__newline,
    STATE(5), 1,
      sym__open_parenthesis,
    STATE(42), 1,
      sym__open_brace,
    STATE(2209), 1,
      sym_string,
    STATE(2211), 1,
      sym__single_quoted_string,
    STATE(2212), 1,
      sym__double_quoted_string,
    STATE(3414), 1,
      aux_sym_function_definition_repeat1,
    STATE(5127), 1,
      sym__string_or_identifier,
    ACTIONS(425), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2210), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(439), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9737), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(501), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [50052] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(626), 1,
      sym_identifier,
    ACTIONS(628), 1,
      anon_sym_BSLASH,
    ACTIONS(630), 1,
      anon_sym_function,
    ACTIONS(632), 1,
      anon_sym_if,
    ACTIONS(634), 1,
      anon_sym_for,
    ACTIONS(636), 1,
      anon_sym_while,
    ACTIONS(638), 1,
      anon_sym_repeat,
    ACTIONS(640), 1,
      anon_sym_QMARK,
    ACTIONS(642), 1,
      anon_sym_TILDE,
    ACTIONS(650), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(652), 1,
      sym__number_literal,
    ACTIONS(654), 1,
      anon_sym_SQUOTE,
    ACTIONS(656), 1,
      anon_sym_DQUOTE,
    ACTIONS(666), 1,
      sym__raw_string_literal,
    ACTIONS(668), 1,
      sym__external_open_parenthesis,
    ACTIONS(670), 1,
      sym__external_open_brace,
    ACTIONS(7933), 1,
      anon_sym_BANG,
    ACTIONS(9745), 1,
      sym_dot_dot_i,
    ACTIONS(9747), 1,
      sym__newline,
    STATE(54), 1,
      sym__open_parenthesis,
    STATE(56), 1,
      sym__open_brace,
    STATE(2219), 1,
      sym_string,
    STATE(2221), 1,
      sym__single_quoted_string,
    STATE(2222), 1,
      sym__double_quoted_string,
    STATE(3613), 1,
      aux_sym_function_definition_repeat1,
    STATE(5140), 1,
      sym__string_or_identifier,
    ACTIONS(646), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2220), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(660), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9743), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(698), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [50181] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(626), 1,
      sym_identifier,
    ACTIONS(628), 1,
      anon_sym_BSLASH,
    ACTIONS(630), 1,
      anon_sym_function,
    ACTIONS(632), 1,
      anon_sym_if,
    ACTIONS(634), 1,
      anon_sym_for,
    ACTIONS(636), 1,
      anon_sym_while,
    ACTIONS(638), 1,
      anon_sym_repeat,
    ACTIONS(640), 1,
      anon_sym_QMARK,
    ACTIONS(642), 1,
      anon_sym_TILDE,
    ACTIONS(650), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(652), 1,
      sym__number_literal,
    ACTIONS(654), 1,
      anon_sym_SQUOTE,
    ACTIONS(656), 1,
      anon_sym_DQUOTE,
    ACTIONS(666), 1,
      sym__raw_string_literal,
    ACTIONS(668), 1,
      sym__external_open_parenthesis,
    ACTIONS(670), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7933), 1,
      anon_sym_BANG,
    ACTIONS(9751), 1,
      sym_dot_dot_i,
    STATE(54), 1,
      sym__open_parenthesis,
    STATE(56), 1,
      sym__open_brace,
    STATE(2219), 1,
      sym_string,
    STATE(2221), 1,
      sym__single_quoted_string,
    STATE(2222), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5140), 1,
      sym__string_or_identifier,
    ACTIONS(646), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2220), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(660), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9749), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(692), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [50310] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3845), 1,
      sym_identifier,
    ACTIONS(3847), 1,
      anon_sym_BSLASH,
    ACTIONS(3849), 1,
      anon_sym_function,
    ACTIONS(3851), 1,
      anon_sym_if,
    ACTIONS(3853), 1,
      anon_sym_for,
    ACTIONS(3855), 1,
      anon_sym_while,
    ACTIONS(3857), 1,
      anon_sym_repeat,
    ACTIONS(3859), 1,
      anon_sym_QMARK,
    ACTIONS(3861), 1,
      anon_sym_TILDE,
    ACTIONS(3869), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3871), 1,
      sym__number_literal,
    ACTIONS(3873), 1,
      anon_sym_SQUOTE,
    ACTIONS(3875), 1,
      anon_sym_DQUOTE,
    ACTIONS(3885), 1,
      sym__raw_string_literal,
    ACTIONS(3887), 1,
      sym__external_open_parenthesis,
    ACTIONS(3891), 1,
      sym__external_open_brace,
    ACTIONS(6389), 1,
      anon_sym_BANG,
    ACTIONS(9755), 1,
      sym_dot_dot_i,
    ACTIONS(9757), 1,
      sym__newline,
    STATE(154), 1,
      sym__open_brace,
    STATE(350), 1,
      sym__open_parenthesis,
    STATE(2620), 1,
      sym__double_quoted_string,
    STATE(2673), 1,
      sym_string,
    STATE(2735), 1,
      sym__single_quoted_string,
    STATE(3558), 1,
      aux_sym_function_definition_repeat1,
    STATE(5135), 1,
      sym__string_or_identifier,
    ACTIONS(3865), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2578), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3879), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9753), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2054), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [50439] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2943), 1,
      sym_identifier,
    ACTIONS(2945), 1,
      anon_sym_BSLASH,
    ACTIONS(2947), 1,
      anon_sym_function,
    ACTIONS(2949), 1,
      anon_sym_if,
    ACTIONS(2951), 1,
      anon_sym_for,
    ACTIONS(2953), 1,
      anon_sym_while,
    ACTIONS(2955), 1,
      anon_sym_repeat,
    ACTIONS(2957), 1,
      anon_sym_QMARK,
    ACTIONS(2959), 1,
      anon_sym_TILDE,
    ACTIONS(2967), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2969), 1,
      sym__number_literal,
    ACTIONS(2971), 1,
      anon_sym_SQUOTE,
    ACTIONS(2973), 1,
      anon_sym_DQUOTE,
    ACTIONS(2983), 1,
      sym__raw_string_literal,
    ACTIONS(2985), 1,
      sym__external_open_parenthesis,
    ACTIONS(2989), 1,
      sym__external_open_brace,
    ACTIONS(7797), 1,
      anon_sym_BANG,
    ACTIONS(9761), 1,
      sym_dot_dot_i,
    ACTIONS(9763), 1,
      sym__newline,
    STATE(173), 1,
      sym__open_brace,
    STATE(246), 1,
      sym__open_parenthesis,
    STATE(2462), 1,
      sym__single_quoted_string,
    STATE(2494), 1,
      sym__double_quoted_string,
    STATE(2541), 1,
      sym_string,
    STATE(3168), 1,
      aux_sym_function_definition_repeat1,
    STATE(5128), 1,
      sym__string_or_identifier,
    ACTIONS(2963), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2540), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2977), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9759), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1800), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [50568] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1568), 1,
      sym_identifier,
    ACTIONS(1570), 1,
      anon_sym_BSLASH,
    ACTIONS(1572), 1,
      anon_sym_function,
    ACTIONS(1574), 1,
      anon_sym_if,
    ACTIONS(1576), 1,
      anon_sym_for,
    ACTIONS(1578), 1,
      anon_sym_while,
    ACTIONS(1580), 1,
      anon_sym_repeat,
    ACTIONS(1582), 1,
      anon_sym_QMARK,
    ACTIONS(1584), 1,
      anon_sym_TILDE,
    ACTIONS(1592), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1594), 1,
      sym__number_literal,
    ACTIONS(1596), 1,
      anon_sym_SQUOTE,
    ACTIONS(1598), 1,
      anon_sym_DQUOTE,
    ACTIONS(1608), 1,
      sym__raw_string_literal,
    ACTIONS(1610), 1,
      sym__external_open_parenthesis,
    ACTIONS(1614), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8477), 1,
      anon_sym_BANG,
    ACTIONS(9767), 1,
      sym_dot_dot_i,
    STATE(16), 1,
      sym__open_brace,
    STATE(119), 1,
      sym__open_parenthesis,
    STATE(2287), 1,
      sym_string,
    STATE(2289), 1,
      sym__single_quoted_string,
    STATE(2290), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5144), 1,
      sym__string_or_identifier,
    ACTIONS(1588), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2288), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1602), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9765), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(781), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [50697] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1568), 1,
      sym_identifier,
    ACTIONS(1570), 1,
      anon_sym_BSLASH,
    ACTIONS(1572), 1,
      anon_sym_function,
    ACTIONS(1574), 1,
      anon_sym_if,
    ACTIONS(1576), 1,
      anon_sym_for,
    ACTIONS(1578), 1,
      anon_sym_while,
    ACTIONS(1580), 1,
      anon_sym_repeat,
    ACTIONS(1582), 1,
      anon_sym_QMARK,
    ACTIONS(1584), 1,
      anon_sym_TILDE,
    ACTIONS(1592), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1594), 1,
      sym__number_literal,
    ACTIONS(1596), 1,
      anon_sym_SQUOTE,
    ACTIONS(1598), 1,
      anon_sym_DQUOTE,
    ACTIONS(1608), 1,
      sym__raw_string_literal,
    ACTIONS(1610), 1,
      sym__external_open_parenthesis,
    ACTIONS(1614), 1,
      sym__external_open_brace,
    ACTIONS(8477), 1,
      anon_sym_BANG,
    ACTIONS(9771), 1,
      sym_dot_dot_i,
    ACTIONS(9773), 1,
      sym__newline,
    STATE(16), 1,
      sym__open_brace,
    STATE(119), 1,
      sym__open_parenthesis,
    STATE(2287), 1,
      sym_string,
    STATE(2289), 1,
      sym__single_quoted_string,
    STATE(2290), 1,
      sym__double_quoted_string,
    STATE(3420), 1,
      aux_sym_function_definition_repeat1,
    STATE(5144), 1,
      sym__string_or_identifier,
    ACTIONS(1588), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2288), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1602), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9769), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(782), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [50826] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1568), 1,
      sym_identifier,
    ACTIONS(1570), 1,
      anon_sym_BSLASH,
    ACTIONS(1572), 1,
      anon_sym_function,
    ACTIONS(1574), 1,
      anon_sym_if,
    ACTIONS(1576), 1,
      anon_sym_for,
    ACTIONS(1578), 1,
      anon_sym_while,
    ACTIONS(1580), 1,
      anon_sym_repeat,
    ACTIONS(1582), 1,
      anon_sym_QMARK,
    ACTIONS(1584), 1,
      anon_sym_TILDE,
    ACTIONS(1592), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1594), 1,
      sym__number_literal,
    ACTIONS(1596), 1,
      anon_sym_SQUOTE,
    ACTIONS(1598), 1,
      anon_sym_DQUOTE,
    ACTIONS(1608), 1,
      sym__raw_string_literal,
    ACTIONS(1610), 1,
      sym__external_open_parenthesis,
    ACTIONS(1614), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8477), 1,
      anon_sym_BANG,
    ACTIONS(9777), 1,
      sym_dot_dot_i,
    STATE(16), 1,
      sym__open_brace,
    STATE(119), 1,
      sym__open_parenthesis,
    STATE(2287), 1,
      sym_string,
    STATE(2289), 1,
      sym__single_quoted_string,
    STATE(2290), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5144), 1,
      sym__string_or_identifier,
    ACTIONS(1588), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2288), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1602), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9775), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(783), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [50955] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1568), 1,
      sym_identifier,
    ACTIONS(1570), 1,
      anon_sym_BSLASH,
    ACTIONS(1572), 1,
      anon_sym_function,
    ACTIONS(1574), 1,
      anon_sym_if,
    ACTIONS(1576), 1,
      anon_sym_for,
    ACTIONS(1578), 1,
      anon_sym_while,
    ACTIONS(1580), 1,
      anon_sym_repeat,
    ACTIONS(1582), 1,
      anon_sym_QMARK,
    ACTIONS(1584), 1,
      anon_sym_TILDE,
    ACTIONS(1592), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1594), 1,
      sym__number_literal,
    ACTIONS(1596), 1,
      anon_sym_SQUOTE,
    ACTIONS(1598), 1,
      anon_sym_DQUOTE,
    ACTIONS(1608), 1,
      sym__raw_string_literal,
    ACTIONS(1610), 1,
      sym__external_open_parenthesis,
    ACTIONS(1614), 1,
      sym__external_open_brace,
    ACTIONS(8477), 1,
      anon_sym_BANG,
    ACTIONS(9781), 1,
      sym_dot_dot_i,
    ACTIONS(9783), 1,
      sym__newline,
    STATE(16), 1,
      sym__open_brace,
    STATE(119), 1,
      sym__open_parenthesis,
    STATE(2287), 1,
      sym_string,
    STATE(2289), 1,
      sym__single_quoted_string,
    STATE(2290), 1,
      sym__double_quoted_string,
    STATE(3422), 1,
      aux_sym_function_definition_repeat1,
    STATE(5144), 1,
      sym__string_or_identifier,
    ACTIONS(1588), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2288), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1602), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9779), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(784), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [51084] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3845), 1,
      sym_identifier,
    ACTIONS(3847), 1,
      anon_sym_BSLASH,
    ACTIONS(3849), 1,
      anon_sym_function,
    ACTIONS(3851), 1,
      anon_sym_if,
    ACTIONS(3853), 1,
      anon_sym_for,
    ACTIONS(3855), 1,
      anon_sym_while,
    ACTIONS(3857), 1,
      anon_sym_repeat,
    ACTIONS(3859), 1,
      anon_sym_QMARK,
    ACTIONS(3861), 1,
      anon_sym_TILDE,
    ACTIONS(3869), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3871), 1,
      sym__number_literal,
    ACTIONS(3873), 1,
      anon_sym_SQUOTE,
    ACTIONS(3875), 1,
      anon_sym_DQUOTE,
    ACTIONS(3885), 1,
      sym__raw_string_literal,
    ACTIONS(3887), 1,
      sym__external_open_parenthesis,
    ACTIONS(3891), 1,
      sym__external_open_brace,
    ACTIONS(6389), 1,
      anon_sym_BANG,
    ACTIONS(9787), 1,
      sym_dot_dot_i,
    ACTIONS(9789), 1,
      sym__newline,
    STATE(154), 1,
      sym__open_brace,
    STATE(350), 1,
      sym__open_parenthesis,
    STATE(2620), 1,
      sym__double_quoted_string,
    STATE(2673), 1,
      sym_string,
    STATE(2735), 1,
      sym__single_quoted_string,
    STATE(3559), 1,
      aux_sym_function_definition_repeat1,
    STATE(5135), 1,
      sym__string_or_identifier,
    ACTIONS(3865), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2578), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3879), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9785), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2092), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [51213] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3845), 1,
      sym_identifier,
    ACTIONS(3847), 1,
      anon_sym_BSLASH,
    ACTIONS(3849), 1,
      anon_sym_function,
    ACTIONS(3851), 1,
      anon_sym_if,
    ACTIONS(3853), 1,
      anon_sym_for,
    ACTIONS(3855), 1,
      anon_sym_while,
    ACTIONS(3857), 1,
      anon_sym_repeat,
    ACTIONS(3859), 1,
      anon_sym_QMARK,
    ACTIONS(3861), 1,
      anon_sym_TILDE,
    ACTIONS(3869), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3871), 1,
      sym__number_literal,
    ACTIONS(3873), 1,
      anon_sym_SQUOTE,
    ACTIONS(3875), 1,
      anon_sym_DQUOTE,
    ACTIONS(3885), 1,
      sym__raw_string_literal,
    ACTIONS(3887), 1,
      sym__external_open_parenthesis,
    ACTIONS(3891), 1,
      sym__external_open_brace,
    ACTIONS(6389), 1,
      anon_sym_BANG,
    ACTIONS(9793), 1,
      sym_dot_dot_i,
    ACTIONS(9795), 1,
      sym__newline,
    STATE(154), 1,
      sym__open_brace,
    STATE(350), 1,
      sym__open_parenthesis,
    STATE(2620), 1,
      sym__double_quoted_string,
    STATE(2673), 1,
      sym_string,
    STATE(2735), 1,
      sym__single_quoted_string,
    STATE(3566), 1,
      aux_sym_function_definition_repeat1,
    STATE(5135), 1,
      sym__string_or_identifier,
    ACTIONS(3865), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2578), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3879), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9791), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2153), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [51342] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3845), 1,
      sym_identifier,
    ACTIONS(3847), 1,
      anon_sym_BSLASH,
    ACTIONS(3849), 1,
      anon_sym_function,
    ACTIONS(3851), 1,
      anon_sym_if,
    ACTIONS(3853), 1,
      anon_sym_for,
    ACTIONS(3855), 1,
      anon_sym_while,
    ACTIONS(3857), 1,
      anon_sym_repeat,
    ACTIONS(3859), 1,
      anon_sym_QMARK,
    ACTIONS(3861), 1,
      anon_sym_TILDE,
    ACTIONS(3869), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3871), 1,
      sym__number_literal,
    ACTIONS(3873), 1,
      anon_sym_SQUOTE,
    ACTIONS(3875), 1,
      anon_sym_DQUOTE,
    ACTIONS(3885), 1,
      sym__raw_string_literal,
    ACTIONS(3887), 1,
      sym__external_open_parenthesis,
    ACTIONS(3891), 1,
      sym__external_open_brace,
    ACTIONS(6389), 1,
      anon_sym_BANG,
    ACTIONS(9799), 1,
      sym_dot_dot_i,
    ACTIONS(9801), 1,
      sym__newline,
    STATE(154), 1,
      sym__open_brace,
    STATE(350), 1,
      sym__open_parenthesis,
    STATE(2620), 1,
      sym__double_quoted_string,
    STATE(2673), 1,
      sym_string,
    STATE(2735), 1,
      sym__single_quoted_string,
    STATE(3567), 1,
      aux_sym_function_definition_repeat1,
    STATE(5135), 1,
      sym__string_or_identifier,
    ACTIONS(3865), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2578), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3879), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9797), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2141), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [51471] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3845), 1,
      sym_identifier,
    ACTIONS(3847), 1,
      anon_sym_BSLASH,
    ACTIONS(3849), 1,
      anon_sym_function,
    ACTIONS(3851), 1,
      anon_sym_if,
    ACTIONS(3853), 1,
      anon_sym_for,
    ACTIONS(3855), 1,
      anon_sym_while,
    ACTIONS(3857), 1,
      anon_sym_repeat,
    ACTIONS(3859), 1,
      anon_sym_QMARK,
    ACTIONS(3861), 1,
      anon_sym_TILDE,
    ACTIONS(3869), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3871), 1,
      sym__number_literal,
    ACTIONS(3873), 1,
      anon_sym_SQUOTE,
    ACTIONS(3875), 1,
      anon_sym_DQUOTE,
    ACTIONS(3885), 1,
      sym__raw_string_literal,
    ACTIONS(3887), 1,
      sym__external_open_parenthesis,
    ACTIONS(3891), 1,
      sym__external_open_brace,
    ACTIONS(6389), 1,
      anon_sym_BANG,
    ACTIONS(9805), 1,
      sym_dot_dot_i,
    ACTIONS(9807), 1,
      sym__newline,
    STATE(154), 1,
      sym__open_brace,
    STATE(350), 1,
      sym__open_parenthesis,
    STATE(2620), 1,
      sym__double_quoted_string,
    STATE(2673), 1,
      sym_string,
    STATE(2735), 1,
      sym__single_quoted_string,
    STATE(3568), 1,
      aux_sym_function_definition_repeat1,
    STATE(5135), 1,
      sym__string_or_identifier,
    ACTIONS(3865), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2578), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3879), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9803), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2152), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [51600] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      sym_identifier,
    ACTIONS(483), 1,
      anon_sym_BSLASH,
    ACTIONS(485), 1,
      anon_sym_function,
    ACTIONS(487), 1,
      anon_sym_if,
    ACTIONS(489), 1,
      anon_sym_for,
    ACTIONS(491), 1,
      anon_sym_while,
    ACTIONS(493), 1,
      anon_sym_repeat,
    ACTIONS(495), 1,
      anon_sym_QMARK,
    ACTIONS(497), 1,
      anon_sym_TILDE,
    ACTIONS(505), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(507), 1,
      sym__number_literal,
    ACTIONS(509), 1,
      anon_sym_SQUOTE,
    ACTIONS(511), 1,
      anon_sym_DQUOTE,
    ACTIONS(521), 1,
      sym__raw_string_literal,
    ACTIONS(523), 1,
      sym__external_open_parenthesis,
    ACTIONS(525), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8515), 1,
      anon_sym_BANG,
    ACTIONS(9811), 1,
      sym_dot_dot_i,
    STATE(3), 1,
      sym__open_parenthesis,
    STATE(45), 1,
      sym__open_brace,
    STATE(2166), 1,
      sym_string,
    STATE(2200), 1,
      sym__single_quoted_string,
    STATE(2201), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5154), 1,
      sym__string_or_identifier,
    ACTIONS(501), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2206), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(515), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9809), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(532), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [51729] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      sym_identifier,
    ACTIONS(483), 1,
      anon_sym_BSLASH,
    ACTIONS(485), 1,
      anon_sym_function,
    ACTIONS(487), 1,
      anon_sym_if,
    ACTIONS(489), 1,
      anon_sym_for,
    ACTIONS(491), 1,
      anon_sym_while,
    ACTIONS(493), 1,
      anon_sym_repeat,
    ACTIONS(495), 1,
      anon_sym_QMARK,
    ACTIONS(497), 1,
      anon_sym_TILDE,
    ACTIONS(505), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(507), 1,
      sym__number_literal,
    ACTIONS(509), 1,
      anon_sym_SQUOTE,
    ACTIONS(511), 1,
      anon_sym_DQUOTE,
    ACTIONS(521), 1,
      sym__raw_string_literal,
    ACTIONS(523), 1,
      sym__external_open_parenthesis,
    ACTIONS(525), 1,
      sym__external_open_brace,
    ACTIONS(8515), 1,
      anon_sym_BANG,
    ACTIONS(9815), 1,
      sym_dot_dot_i,
    ACTIONS(9817), 1,
      sym__newline,
    STATE(3), 1,
      sym__open_parenthesis,
    STATE(45), 1,
      sym__open_brace,
    STATE(2166), 1,
      sym_string,
    STATE(2200), 1,
      sym__single_quoted_string,
    STATE(2201), 1,
      sym__double_quoted_string,
    STATE(3428), 1,
      aux_sym_function_definition_repeat1,
    STATE(5154), 1,
      sym__string_or_identifier,
    ACTIONS(501), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2206), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(515), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9813), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(537), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [51858] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      sym_identifier,
    ACTIONS(483), 1,
      anon_sym_BSLASH,
    ACTIONS(485), 1,
      anon_sym_function,
    ACTIONS(487), 1,
      anon_sym_if,
    ACTIONS(489), 1,
      anon_sym_for,
    ACTIONS(491), 1,
      anon_sym_while,
    ACTIONS(493), 1,
      anon_sym_repeat,
    ACTIONS(495), 1,
      anon_sym_QMARK,
    ACTIONS(497), 1,
      anon_sym_TILDE,
    ACTIONS(505), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(507), 1,
      sym__number_literal,
    ACTIONS(509), 1,
      anon_sym_SQUOTE,
    ACTIONS(511), 1,
      anon_sym_DQUOTE,
    ACTIONS(521), 1,
      sym__raw_string_literal,
    ACTIONS(523), 1,
      sym__external_open_parenthesis,
    ACTIONS(525), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8515), 1,
      anon_sym_BANG,
    ACTIONS(9821), 1,
      sym_dot_dot_i,
    STATE(3), 1,
      sym__open_parenthesis,
    STATE(45), 1,
      sym__open_brace,
    STATE(2166), 1,
      sym_string,
    STATE(2200), 1,
      sym__single_quoted_string,
    STATE(2201), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5154), 1,
      sym__string_or_identifier,
    ACTIONS(501), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2206), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(515), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9819), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(538), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [51987] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      sym_identifier,
    ACTIONS(483), 1,
      anon_sym_BSLASH,
    ACTIONS(485), 1,
      anon_sym_function,
    ACTIONS(487), 1,
      anon_sym_if,
    ACTIONS(489), 1,
      anon_sym_for,
    ACTIONS(491), 1,
      anon_sym_while,
    ACTIONS(493), 1,
      anon_sym_repeat,
    ACTIONS(495), 1,
      anon_sym_QMARK,
    ACTIONS(497), 1,
      anon_sym_TILDE,
    ACTIONS(505), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(507), 1,
      sym__number_literal,
    ACTIONS(509), 1,
      anon_sym_SQUOTE,
    ACTIONS(511), 1,
      anon_sym_DQUOTE,
    ACTIONS(521), 1,
      sym__raw_string_literal,
    ACTIONS(523), 1,
      sym__external_open_parenthesis,
    ACTIONS(525), 1,
      sym__external_open_brace,
    ACTIONS(8515), 1,
      anon_sym_BANG,
    ACTIONS(9825), 1,
      sym_dot_dot_i,
    ACTIONS(9827), 1,
      sym__newline,
    STATE(3), 1,
      sym__open_parenthesis,
    STATE(45), 1,
      sym__open_brace,
    STATE(2166), 1,
      sym_string,
    STATE(2200), 1,
      sym__single_quoted_string,
    STATE(2201), 1,
      sym__double_quoted_string,
    STATE(3430), 1,
      aux_sym_function_definition_repeat1,
    STATE(5154), 1,
      sym__string_or_identifier,
    ACTIONS(501), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2206), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(515), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9823), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(542), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [52116] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2531), 1,
      sym_identifier,
    ACTIONS(2533), 1,
      anon_sym_BSLASH,
    ACTIONS(2535), 1,
      anon_sym_function,
    ACTIONS(2537), 1,
      anon_sym_if,
    ACTIONS(2539), 1,
      anon_sym_for,
    ACTIONS(2541), 1,
      anon_sym_while,
    ACTIONS(2543), 1,
      anon_sym_repeat,
    ACTIONS(2545), 1,
      anon_sym_QMARK,
    ACTIONS(2547), 1,
      anon_sym_TILDE,
    ACTIONS(2555), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2557), 1,
      sym__number_literal,
    ACTIONS(2559), 1,
      anon_sym_SQUOTE,
    ACTIONS(2561), 1,
      anon_sym_DQUOTE,
    ACTIONS(2571), 1,
      sym__raw_string_literal,
    ACTIONS(2573), 1,
      sym__external_open_parenthesis,
    ACTIONS(2577), 1,
      sym__external_open_brace,
    ACTIONS(9611), 1,
      anon_sym_BANG,
    ACTIONS(9831), 1,
      sym_dot_dot_i,
    ACTIONS(9833), 1,
      sym__newline,
    STATE(70), 1,
      sym__open_brace,
    STATE(213), 1,
      sym__open_parenthesis,
    STATE(2437), 1,
      sym__double_quoted_string,
    STATE(2442), 1,
      sym__single_quoted_string,
    STATE(2530), 1,
      sym_string,
    STATE(3385), 1,
      aux_sym_function_definition_repeat1,
    STATE(5133), 1,
      sym__string_or_identifier,
    ACTIONS(2551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2445), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2565), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9829), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1412), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [52245] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3845), 1,
      sym_identifier,
    ACTIONS(3847), 1,
      anon_sym_BSLASH,
    ACTIONS(3849), 1,
      anon_sym_function,
    ACTIONS(3851), 1,
      anon_sym_if,
    ACTIONS(3853), 1,
      anon_sym_for,
    ACTIONS(3855), 1,
      anon_sym_while,
    ACTIONS(3857), 1,
      anon_sym_repeat,
    ACTIONS(3859), 1,
      anon_sym_QMARK,
    ACTIONS(3861), 1,
      anon_sym_TILDE,
    ACTIONS(3869), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3871), 1,
      sym__number_literal,
    ACTIONS(3873), 1,
      anon_sym_SQUOTE,
    ACTIONS(3875), 1,
      anon_sym_DQUOTE,
    ACTIONS(3885), 1,
      sym__raw_string_literal,
    ACTIONS(3887), 1,
      sym__external_open_parenthesis,
    ACTIONS(3891), 1,
      sym__external_open_brace,
    ACTIONS(6389), 1,
      anon_sym_BANG,
    ACTIONS(9837), 1,
      sym_dot_dot_i,
    ACTIONS(9839), 1,
      sym__newline,
    STATE(154), 1,
      sym__open_brace,
    STATE(350), 1,
      sym__open_parenthesis,
    STATE(2620), 1,
      sym__double_quoted_string,
    STATE(2673), 1,
      sym_string,
    STATE(2735), 1,
      sym__single_quoted_string,
    STATE(3569), 1,
      aux_sym_function_definition_repeat1,
    STATE(5135), 1,
      sym__string_or_identifier,
    ACTIONS(3865), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2578), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3879), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9835), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2154), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [52374] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3845), 1,
      sym_identifier,
    ACTIONS(3847), 1,
      anon_sym_BSLASH,
    ACTIONS(3849), 1,
      anon_sym_function,
    ACTIONS(3851), 1,
      anon_sym_if,
    ACTIONS(3853), 1,
      anon_sym_for,
    ACTIONS(3855), 1,
      anon_sym_while,
    ACTIONS(3857), 1,
      anon_sym_repeat,
    ACTIONS(3859), 1,
      anon_sym_QMARK,
    ACTIONS(3861), 1,
      anon_sym_TILDE,
    ACTIONS(3869), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3871), 1,
      sym__number_literal,
    ACTIONS(3873), 1,
      anon_sym_SQUOTE,
    ACTIONS(3875), 1,
      anon_sym_DQUOTE,
    ACTIONS(3885), 1,
      sym__raw_string_literal,
    ACTIONS(3887), 1,
      sym__external_open_parenthesis,
    ACTIONS(3891), 1,
      sym__external_open_brace,
    ACTIONS(6389), 1,
      anon_sym_BANG,
    ACTIONS(9843), 1,
      sym_dot_dot_i,
    ACTIONS(9845), 1,
      sym__newline,
    STATE(154), 1,
      sym__open_brace,
    STATE(350), 1,
      sym__open_parenthesis,
    STATE(2620), 1,
      sym__double_quoted_string,
    STATE(2673), 1,
      sym_string,
    STATE(2735), 1,
      sym__single_quoted_string,
    STATE(3585), 1,
      aux_sym_function_definition_repeat1,
    STATE(5135), 1,
      sym__string_or_identifier,
    ACTIONS(3865), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2578), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3879), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9841), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2157), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [52503] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3845), 1,
      sym_identifier,
    ACTIONS(3847), 1,
      anon_sym_BSLASH,
    ACTIONS(3849), 1,
      anon_sym_function,
    ACTIONS(3851), 1,
      anon_sym_if,
    ACTIONS(3853), 1,
      anon_sym_for,
    ACTIONS(3855), 1,
      anon_sym_while,
    ACTIONS(3857), 1,
      anon_sym_repeat,
    ACTIONS(3859), 1,
      anon_sym_QMARK,
    ACTIONS(3861), 1,
      anon_sym_TILDE,
    ACTIONS(3869), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3871), 1,
      sym__number_literal,
    ACTIONS(3873), 1,
      anon_sym_SQUOTE,
    ACTIONS(3875), 1,
      anon_sym_DQUOTE,
    ACTIONS(3885), 1,
      sym__raw_string_literal,
    ACTIONS(3887), 1,
      sym__external_open_parenthesis,
    ACTIONS(3891), 1,
      sym__external_open_brace,
    ACTIONS(6389), 1,
      anon_sym_BANG,
    ACTIONS(9849), 1,
      sym_dot_dot_i,
    ACTIONS(9851), 1,
      sym__newline,
    STATE(154), 1,
      sym__open_brace,
    STATE(350), 1,
      sym__open_parenthesis,
    STATE(2620), 1,
      sym__double_quoted_string,
    STATE(2673), 1,
      sym_string,
    STATE(2735), 1,
      sym__single_quoted_string,
    STATE(3586), 1,
      aux_sym_function_definition_repeat1,
    STATE(5135), 1,
      sym__string_or_identifier,
    ACTIONS(3865), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2578), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3879), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9847), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2062), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [52632] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3845), 1,
      sym_identifier,
    ACTIONS(3847), 1,
      anon_sym_BSLASH,
    ACTIONS(3849), 1,
      anon_sym_function,
    ACTIONS(3851), 1,
      anon_sym_if,
    ACTIONS(3853), 1,
      anon_sym_for,
    ACTIONS(3855), 1,
      anon_sym_while,
    ACTIONS(3857), 1,
      anon_sym_repeat,
    ACTIONS(3859), 1,
      anon_sym_QMARK,
    ACTIONS(3861), 1,
      anon_sym_TILDE,
    ACTIONS(3869), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3871), 1,
      sym__number_literal,
    ACTIONS(3873), 1,
      anon_sym_SQUOTE,
    ACTIONS(3875), 1,
      anon_sym_DQUOTE,
    ACTIONS(3885), 1,
      sym__raw_string_literal,
    ACTIONS(3887), 1,
      sym__external_open_parenthesis,
    ACTIONS(3891), 1,
      sym__external_open_brace,
    ACTIONS(6389), 1,
      anon_sym_BANG,
    ACTIONS(9855), 1,
      sym_dot_dot_i,
    ACTIONS(9857), 1,
      sym__newline,
    STATE(154), 1,
      sym__open_brace,
    STATE(350), 1,
      sym__open_parenthesis,
    STATE(2620), 1,
      sym__double_quoted_string,
    STATE(2673), 1,
      sym_string,
    STATE(2735), 1,
      sym__single_quoted_string,
    STATE(3593), 1,
      aux_sym_function_definition_repeat1,
    STATE(5135), 1,
      sym__string_or_identifier,
    ACTIONS(3865), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2578), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3879), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9853), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2049), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [52761] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1241), 1,
      sym_identifier,
    ACTIONS(1243), 1,
      anon_sym_BSLASH,
    ACTIONS(1245), 1,
      anon_sym_function,
    ACTIONS(1247), 1,
      anon_sym_if,
    ACTIONS(1249), 1,
      anon_sym_for,
    ACTIONS(1251), 1,
      anon_sym_while,
    ACTIONS(1253), 1,
      anon_sym_repeat,
    ACTIONS(1255), 1,
      anon_sym_QMARK,
    ACTIONS(1257), 1,
      anon_sym_TILDE,
    ACTIONS(1265), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1267), 1,
      sym__number_literal,
    ACTIONS(1269), 1,
      anon_sym_SQUOTE,
    ACTIONS(1271), 1,
      anon_sym_DQUOTE,
    ACTIONS(1281), 1,
      sym__raw_string_literal,
    ACTIONS(1283), 1,
      sym__external_open_parenthesis,
    ACTIONS(1287), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8543), 1,
      anon_sym_BANG,
    ACTIONS(9861), 1,
      sym_dot_dot_i,
    STATE(11), 1,
      sym__open_brace,
    STATE(120), 1,
      sym__open_parenthesis,
    STATE(2271), 1,
      sym_string,
    STATE(2273), 1,
      sym__single_quoted_string,
    STATE(2274), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5157), 1,
      sym__string_or_identifier,
    ACTIONS(1261), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2272), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1275), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9859), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(792), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [52890] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2531), 1,
      sym_identifier,
    ACTIONS(2533), 1,
      anon_sym_BSLASH,
    ACTIONS(2535), 1,
      anon_sym_function,
    ACTIONS(2537), 1,
      anon_sym_if,
    ACTIONS(2539), 1,
      anon_sym_for,
    ACTIONS(2541), 1,
      anon_sym_while,
    ACTIONS(2543), 1,
      anon_sym_repeat,
    ACTIONS(2545), 1,
      anon_sym_QMARK,
    ACTIONS(2547), 1,
      anon_sym_TILDE,
    ACTIONS(2555), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2557), 1,
      sym__number_literal,
    ACTIONS(2559), 1,
      anon_sym_SQUOTE,
    ACTIONS(2561), 1,
      anon_sym_DQUOTE,
    ACTIONS(2571), 1,
      sym__raw_string_literal,
    ACTIONS(2573), 1,
      sym__external_open_parenthesis,
    ACTIONS(2577), 1,
      sym__external_open_brace,
    ACTIONS(9611), 1,
      anon_sym_BANG,
    ACTIONS(9865), 1,
      sym_dot_dot_i,
    ACTIONS(9867), 1,
      sym__newline,
    STATE(70), 1,
      sym__open_brace,
    STATE(213), 1,
      sym__open_parenthesis,
    STATE(2437), 1,
      sym__double_quoted_string,
    STATE(2442), 1,
      sym__single_quoted_string,
    STATE(2530), 1,
      sym_string,
    STATE(3387), 1,
      aux_sym_function_definition_repeat1,
    STATE(5133), 1,
      sym__string_or_identifier,
    ACTIONS(2551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2445), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2565), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9863), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1410), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [53019] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2943), 1,
      sym_identifier,
    ACTIONS(2945), 1,
      anon_sym_BSLASH,
    ACTIONS(2947), 1,
      anon_sym_function,
    ACTIONS(2949), 1,
      anon_sym_if,
    ACTIONS(2951), 1,
      anon_sym_for,
    ACTIONS(2953), 1,
      anon_sym_while,
    ACTIONS(2955), 1,
      anon_sym_repeat,
    ACTIONS(2957), 1,
      anon_sym_QMARK,
    ACTIONS(2959), 1,
      anon_sym_TILDE,
    ACTIONS(2967), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2969), 1,
      sym__number_literal,
    ACTIONS(2971), 1,
      anon_sym_SQUOTE,
    ACTIONS(2973), 1,
      anon_sym_DQUOTE,
    ACTIONS(2983), 1,
      sym__raw_string_literal,
    ACTIONS(2985), 1,
      sym__external_open_parenthesis,
    ACTIONS(2989), 1,
      sym__external_open_brace,
    ACTIONS(7797), 1,
      anon_sym_BANG,
    ACTIONS(9871), 1,
      sym_dot_dot_i,
    ACTIONS(9873), 1,
      sym__newline,
    STATE(173), 1,
      sym__open_brace,
    STATE(246), 1,
      sym__open_parenthesis,
    STATE(2462), 1,
      sym__single_quoted_string,
    STATE(2494), 1,
      sym__double_quoted_string,
    STATE(2541), 1,
      sym_string,
    STATE(3224), 1,
      aux_sym_function_definition_repeat1,
    STATE(5128), 1,
      sym__string_or_identifier,
    ACTIONS(2963), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2540), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2977), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9869), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1797), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [53148] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1241), 1,
      sym_identifier,
    ACTIONS(1243), 1,
      anon_sym_BSLASH,
    ACTIONS(1245), 1,
      anon_sym_function,
    ACTIONS(1247), 1,
      anon_sym_if,
    ACTIONS(1249), 1,
      anon_sym_for,
    ACTIONS(1251), 1,
      anon_sym_while,
    ACTIONS(1253), 1,
      anon_sym_repeat,
    ACTIONS(1255), 1,
      anon_sym_QMARK,
    ACTIONS(1257), 1,
      anon_sym_TILDE,
    ACTIONS(1265), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1267), 1,
      sym__number_literal,
    ACTIONS(1269), 1,
      anon_sym_SQUOTE,
    ACTIONS(1271), 1,
      anon_sym_DQUOTE,
    ACTIONS(1281), 1,
      sym__raw_string_literal,
    ACTIONS(1283), 1,
      sym__external_open_parenthesis,
    ACTIONS(1287), 1,
      sym__external_open_brace,
    ACTIONS(8543), 1,
      anon_sym_BANG,
    ACTIONS(9877), 1,
      sym_dot_dot_i,
    ACTIONS(9879), 1,
      sym__newline,
    STATE(11), 1,
      sym__open_brace,
    STATE(120), 1,
      sym__open_parenthesis,
    STATE(2271), 1,
      sym_string,
    STATE(2273), 1,
      sym__single_quoted_string,
    STATE(2274), 1,
      sym__double_quoted_string,
    STATE(3437), 1,
      aux_sym_function_definition_repeat1,
    STATE(5157), 1,
      sym__string_or_identifier,
    ACTIONS(1261), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2272), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1275), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9875), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(793), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [53277] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1241), 1,
      sym_identifier,
    ACTIONS(1243), 1,
      anon_sym_BSLASH,
    ACTIONS(1245), 1,
      anon_sym_function,
    ACTIONS(1247), 1,
      anon_sym_if,
    ACTIONS(1249), 1,
      anon_sym_for,
    ACTIONS(1251), 1,
      anon_sym_while,
    ACTIONS(1253), 1,
      anon_sym_repeat,
    ACTIONS(1255), 1,
      anon_sym_QMARK,
    ACTIONS(1257), 1,
      anon_sym_TILDE,
    ACTIONS(1265), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1267), 1,
      sym__number_literal,
    ACTIONS(1269), 1,
      anon_sym_SQUOTE,
    ACTIONS(1271), 1,
      anon_sym_DQUOTE,
    ACTIONS(1281), 1,
      sym__raw_string_literal,
    ACTIONS(1283), 1,
      sym__external_open_parenthesis,
    ACTIONS(1287), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8543), 1,
      anon_sym_BANG,
    ACTIONS(9883), 1,
      sym_dot_dot_i,
    STATE(11), 1,
      sym__open_brace,
    STATE(120), 1,
      sym__open_parenthesis,
    STATE(2271), 1,
      sym_string,
    STATE(2273), 1,
      sym__single_quoted_string,
    STATE(2274), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5157), 1,
      sym__string_or_identifier,
    ACTIONS(1261), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2272), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1275), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9881), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(794), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [53406] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2943), 1,
      sym_identifier,
    ACTIONS(2945), 1,
      anon_sym_BSLASH,
    ACTIONS(2947), 1,
      anon_sym_function,
    ACTIONS(2949), 1,
      anon_sym_if,
    ACTIONS(2951), 1,
      anon_sym_for,
    ACTIONS(2953), 1,
      anon_sym_while,
    ACTIONS(2955), 1,
      anon_sym_repeat,
    ACTIONS(2957), 1,
      anon_sym_QMARK,
    ACTIONS(2959), 1,
      anon_sym_TILDE,
    ACTIONS(2967), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2969), 1,
      sym__number_literal,
    ACTIONS(2971), 1,
      anon_sym_SQUOTE,
    ACTIONS(2973), 1,
      anon_sym_DQUOTE,
    ACTIONS(2983), 1,
      sym__raw_string_literal,
    ACTIONS(2985), 1,
      sym__external_open_parenthesis,
    ACTIONS(2989), 1,
      sym__external_open_brace,
    ACTIONS(7797), 1,
      anon_sym_BANG,
    ACTIONS(9887), 1,
      sym_dot_dot_i,
    ACTIONS(9889), 1,
      sym__newline,
    STATE(173), 1,
      sym__open_brace,
    STATE(246), 1,
      sym__open_parenthesis,
    STATE(2462), 1,
      sym__single_quoted_string,
    STATE(2494), 1,
      sym__double_quoted_string,
    STATE(2541), 1,
      sym_string,
    STATE(3157), 1,
      aux_sym_function_definition_repeat1,
    STATE(5128), 1,
      sym__string_or_identifier,
    ACTIONS(2963), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2540), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2977), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9885), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1784), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [53535] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2531), 1,
      sym_identifier,
    ACTIONS(2533), 1,
      anon_sym_BSLASH,
    ACTIONS(2535), 1,
      anon_sym_function,
    ACTIONS(2537), 1,
      anon_sym_if,
    ACTIONS(2539), 1,
      anon_sym_for,
    ACTIONS(2541), 1,
      anon_sym_while,
    ACTIONS(2543), 1,
      anon_sym_repeat,
    ACTIONS(2545), 1,
      anon_sym_QMARK,
    ACTIONS(2547), 1,
      anon_sym_TILDE,
    ACTIONS(2555), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2557), 1,
      sym__number_literal,
    ACTIONS(2559), 1,
      anon_sym_SQUOTE,
    ACTIONS(2561), 1,
      anon_sym_DQUOTE,
    ACTIONS(2571), 1,
      sym__raw_string_literal,
    ACTIONS(2573), 1,
      sym__external_open_parenthesis,
    ACTIONS(2577), 1,
      sym__external_open_brace,
    ACTIONS(9611), 1,
      anon_sym_BANG,
    ACTIONS(9893), 1,
      sym_dot_dot_i,
    ACTIONS(9895), 1,
      sym__newline,
    STATE(70), 1,
      sym__open_brace,
    STATE(213), 1,
      sym__open_parenthesis,
    STATE(2437), 1,
      sym__double_quoted_string,
    STATE(2442), 1,
      sym__single_quoted_string,
    STATE(2530), 1,
      sym_string,
    STATE(3389), 1,
      aux_sym_function_definition_repeat1,
    STATE(5133), 1,
      sym__string_or_identifier,
    ACTIONS(2551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2445), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2565), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9891), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1408), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [53664] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2531), 1,
      sym_identifier,
    ACTIONS(2533), 1,
      anon_sym_BSLASH,
    ACTIONS(2535), 1,
      anon_sym_function,
    ACTIONS(2537), 1,
      anon_sym_if,
    ACTIONS(2539), 1,
      anon_sym_for,
    ACTIONS(2541), 1,
      anon_sym_while,
    ACTIONS(2543), 1,
      anon_sym_repeat,
    ACTIONS(2545), 1,
      anon_sym_QMARK,
    ACTIONS(2547), 1,
      anon_sym_TILDE,
    ACTIONS(2555), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2557), 1,
      sym__number_literal,
    ACTIONS(2559), 1,
      anon_sym_SQUOTE,
    ACTIONS(2561), 1,
      anon_sym_DQUOTE,
    ACTIONS(2571), 1,
      sym__raw_string_literal,
    ACTIONS(2573), 1,
      sym__external_open_parenthesis,
    ACTIONS(2577), 1,
      sym__external_open_brace,
    ACTIONS(9611), 1,
      anon_sym_BANG,
    ACTIONS(9899), 1,
      sym_dot_dot_i,
    ACTIONS(9901), 1,
      sym__newline,
    STATE(70), 1,
      sym__open_brace,
    STATE(213), 1,
      sym__open_parenthesis,
    STATE(2437), 1,
      sym__double_quoted_string,
    STATE(2442), 1,
      sym__single_quoted_string,
    STATE(2530), 1,
      sym_string,
    STATE(3391), 1,
      aux_sym_function_definition_repeat1,
    STATE(5133), 1,
      sym__string_or_identifier,
    ACTIONS(2551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2445), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2565), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9897), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1406), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [53793] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2943), 1,
      sym_identifier,
    ACTIONS(2945), 1,
      anon_sym_BSLASH,
    ACTIONS(2947), 1,
      anon_sym_function,
    ACTIONS(2949), 1,
      anon_sym_if,
    ACTIONS(2951), 1,
      anon_sym_for,
    ACTIONS(2953), 1,
      anon_sym_while,
    ACTIONS(2955), 1,
      anon_sym_repeat,
    ACTIONS(2957), 1,
      anon_sym_QMARK,
    ACTIONS(2959), 1,
      anon_sym_TILDE,
    ACTIONS(2967), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2969), 1,
      sym__number_literal,
    ACTIONS(2971), 1,
      anon_sym_SQUOTE,
    ACTIONS(2973), 1,
      anon_sym_DQUOTE,
    ACTIONS(2983), 1,
      sym__raw_string_literal,
    ACTIONS(2985), 1,
      sym__external_open_parenthesis,
    ACTIONS(2989), 1,
      sym__external_open_brace,
    ACTIONS(7797), 1,
      anon_sym_BANG,
    ACTIONS(9905), 1,
      sym_dot_dot_i,
    ACTIONS(9907), 1,
      sym__newline,
    STATE(173), 1,
      sym__open_brace,
    STATE(246), 1,
      sym__open_parenthesis,
    STATE(2462), 1,
      sym__single_quoted_string,
    STATE(2494), 1,
      sym__double_quoted_string,
    STATE(2541), 1,
      sym_string,
    STATE(3114), 1,
      aux_sym_function_definition_repeat1,
    STATE(5128), 1,
      sym__string_or_identifier,
    ACTIONS(2963), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2540), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2977), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9903), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1719), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [53922] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2531), 1,
      sym_identifier,
    ACTIONS(2533), 1,
      anon_sym_BSLASH,
    ACTIONS(2535), 1,
      anon_sym_function,
    ACTIONS(2537), 1,
      anon_sym_if,
    ACTIONS(2539), 1,
      anon_sym_for,
    ACTIONS(2541), 1,
      anon_sym_while,
    ACTIONS(2543), 1,
      anon_sym_repeat,
    ACTIONS(2545), 1,
      anon_sym_QMARK,
    ACTIONS(2547), 1,
      anon_sym_TILDE,
    ACTIONS(2555), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2557), 1,
      sym__number_literal,
    ACTIONS(2559), 1,
      anon_sym_SQUOTE,
    ACTIONS(2561), 1,
      anon_sym_DQUOTE,
    ACTIONS(2571), 1,
      sym__raw_string_literal,
    ACTIONS(2573), 1,
      sym__external_open_parenthesis,
    ACTIONS(2577), 1,
      sym__external_open_brace,
    ACTIONS(9611), 1,
      anon_sym_BANG,
    ACTIONS(9911), 1,
      sym_dot_dot_i,
    ACTIONS(9913), 1,
      sym__newline,
    STATE(70), 1,
      sym__open_brace,
    STATE(213), 1,
      sym__open_parenthesis,
    STATE(2437), 1,
      sym__double_quoted_string,
    STATE(2442), 1,
      sym__single_quoted_string,
    STATE(2530), 1,
      sym_string,
    STATE(3393), 1,
      aux_sym_function_definition_repeat1,
    STATE(5133), 1,
      sym__string_or_identifier,
    ACTIONS(2551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2445), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2565), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9909), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1404), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [54051] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1241), 1,
      sym_identifier,
    ACTIONS(1243), 1,
      anon_sym_BSLASH,
    ACTIONS(1245), 1,
      anon_sym_function,
    ACTIONS(1247), 1,
      anon_sym_if,
    ACTIONS(1249), 1,
      anon_sym_for,
    ACTIONS(1251), 1,
      anon_sym_while,
    ACTIONS(1253), 1,
      anon_sym_repeat,
    ACTIONS(1255), 1,
      anon_sym_QMARK,
    ACTIONS(1257), 1,
      anon_sym_TILDE,
    ACTIONS(1265), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1267), 1,
      sym__number_literal,
    ACTIONS(1269), 1,
      anon_sym_SQUOTE,
    ACTIONS(1271), 1,
      anon_sym_DQUOTE,
    ACTIONS(1281), 1,
      sym__raw_string_literal,
    ACTIONS(1283), 1,
      sym__external_open_parenthesis,
    ACTIONS(1287), 1,
      sym__external_open_brace,
    ACTIONS(8543), 1,
      anon_sym_BANG,
    ACTIONS(9917), 1,
      sym_dot_dot_i,
    ACTIONS(9919), 1,
      sym__newline,
    STATE(11), 1,
      sym__open_brace,
    STATE(120), 1,
      sym__open_parenthesis,
    STATE(2271), 1,
      sym_string,
    STATE(2273), 1,
      sym__single_quoted_string,
    STATE(2274), 1,
      sym__double_quoted_string,
    STATE(3441), 1,
      aux_sym_function_definition_repeat1,
    STATE(5157), 1,
      sym__string_or_identifier,
    ACTIONS(1261), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2272), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1275), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9915), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(795), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [54180] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3845), 1,
      sym_identifier,
    ACTIONS(3847), 1,
      anon_sym_BSLASH,
    ACTIONS(3849), 1,
      anon_sym_function,
    ACTIONS(3851), 1,
      anon_sym_if,
    ACTIONS(3853), 1,
      anon_sym_for,
    ACTIONS(3855), 1,
      anon_sym_while,
    ACTIONS(3857), 1,
      anon_sym_repeat,
    ACTIONS(3859), 1,
      anon_sym_QMARK,
    ACTIONS(3861), 1,
      anon_sym_TILDE,
    ACTIONS(3869), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3871), 1,
      sym__number_literal,
    ACTIONS(3873), 1,
      anon_sym_SQUOTE,
    ACTIONS(3875), 1,
      anon_sym_DQUOTE,
    ACTIONS(3885), 1,
      sym__raw_string_literal,
    ACTIONS(3887), 1,
      sym__external_open_parenthesis,
    ACTIONS(3891), 1,
      sym__external_open_brace,
    ACTIONS(6389), 1,
      anon_sym_BANG,
    ACTIONS(9923), 1,
      sym_dot_dot_i,
    ACTIONS(9925), 1,
      sym__newline,
    STATE(154), 1,
      sym__open_brace,
    STATE(350), 1,
      sym__open_parenthesis,
    STATE(2620), 1,
      sym__double_quoted_string,
    STATE(2673), 1,
      sym_string,
    STATE(2735), 1,
      sym__single_quoted_string,
    STATE(3929), 1,
      aux_sym_function_definition_repeat1,
    STATE(5135), 1,
      sym__string_or_identifier,
    ACTIONS(3865), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2578), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3879), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9921), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2159), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [54309] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2531), 1,
      sym_identifier,
    ACTIONS(2533), 1,
      anon_sym_BSLASH,
    ACTIONS(2535), 1,
      anon_sym_function,
    ACTIONS(2537), 1,
      anon_sym_if,
    ACTIONS(2539), 1,
      anon_sym_for,
    ACTIONS(2541), 1,
      anon_sym_while,
    ACTIONS(2543), 1,
      anon_sym_repeat,
    ACTIONS(2545), 1,
      anon_sym_QMARK,
    ACTIONS(2547), 1,
      anon_sym_TILDE,
    ACTIONS(2555), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2557), 1,
      sym__number_literal,
    ACTIONS(2559), 1,
      anon_sym_SQUOTE,
    ACTIONS(2561), 1,
      anon_sym_DQUOTE,
    ACTIONS(2571), 1,
      sym__raw_string_literal,
    ACTIONS(2573), 1,
      sym__external_open_parenthesis,
    ACTIONS(2577), 1,
      sym__external_open_brace,
    ACTIONS(9611), 1,
      anon_sym_BANG,
    ACTIONS(9929), 1,
      sym_dot_dot_i,
    ACTIONS(9931), 1,
      sym__newline,
    STATE(70), 1,
      sym__open_brace,
    STATE(213), 1,
      sym__open_parenthesis,
    STATE(2437), 1,
      sym__double_quoted_string,
    STATE(2442), 1,
      sym__single_quoted_string,
    STATE(2530), 1,
      sym_string,
    STATE(3395), 1,
      aux_sym_function_definition_repeat1,
    STATE(5133), 1,
      sym__string_or_identifier,
    ACTIONS(2551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2445), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2565), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9927), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1402), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [54438] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2943), 1,
      sym_identifier,
    ACTIONS(2945), 1,
      anon_sym_BSLASH,
    ACTIONS(2947), 1,
      anon_sym_function,
    ACTIONS(2949), 1,
      anon_sym_if,
    ACTIONS(2951), 1,
      anon_sym_for,
    ACTIONS(2953), 1,
      anon_sym_while,
    ACTIONS(2955), 1,
      anon_sym_repeat,
    ACTIONS(2957), 1,
      anon_sym_QMARK,
    ACTIONS(2959), 1,
      anon_sym_TILDE,
    ACTIONS(2967), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2969), 1,
      sym__number_literal,
    ACTIONS(2971), 1,
      anon_sym_SQUOTE,
    ACTIONS(2973), 1,
      anon_sym_DQUOTE,
    ACTIONS(2983), 1,
      sym__raw_string_literal,
    ACTIONS(2985), 1,
      sym__external_open_parenthesis,
    ACTIONS(2989), 1,
      sym__external_open_brace,
    ACTIONS(7797), 1,
      anon_sym_BANG,
    ACTIONS(9935), 1,
      sym_dot_dot_i,
    ACTIONS(9937), 1,
      sym__newline,
    STATE(173), 1,
      sym__open_brace,
    STATE(246), 1,
      sym__open_parenthesis,
    STATE(2462), 1,
      sym__single_quoted_string,
    STATE(2494), 1,
      sym__double_quoted_string,
    STATE(2541), 1,
      sym_string,
    STATE(3047), 1,
      aux_sym_function_definition_repeat1,
    STATE(5128), 1,
      sym__string_or_identifier,
    ACTIONS(2963), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2540), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2977), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9933), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1691), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [54567] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2943), 1,
      sym_identifier,
    ACTIONS(2945), 1,
      anon_sym_BSLASH,
    ACTIONS(2947), 1,
      anon_sym_function,
    ACTIONS(2949), 1,
      anon_sym_if,
    ACTIONS(2951), 1,
      anon_sym_for,
    ACTIONS(2953), 1,
      anon_sym_while,
    ACTIONS(2955), 1,
      anon_sym_repeat,
    ACTIONS(2957), 1,
      anon_sym_QMARK,
    ACTIONS(2959), 1,
      anon_sym_TILDE,
    ACTIONS(2967), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2969), 1,
      sym__number_literal,
    ACTIONS(2971), 1,
      anon_sym_SQUOTE,
    ACTIONS(2973), 1,
      anon_sym_DQUOTE,
    ACTIONS(2983), 1,
      sym__raw_string_literal,
    ACTIONS(2985), 1,
      sym__external_open_parenthesis,
    ACTIONS(2989), 1,
      sym__external_open_brace,
    ACTIONS(7797), 1,
      anon_sym_BANG,
    ACTIONS(9941), 1,
      sym_dot_dot_i,
    ACTIONS(9943), 1,
      sym__newline,
    STATE(173), 1,
      sym__open_brace,
    STATE(246), 1,
      sym__open_parenthesis,
    STATE(2462), 1,
      sym__single_quoted_string,
    STATE(2494), 1,
      sym__double_quoted_string,
    STATE(2541), 1,
      sym_string,
    STATE(3030), 1,
      aux_sym_function_definition_repeat1,
    STATE(5128), 1,
      sym__string_or_identifier,
    ACTIONS(2963), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2540), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2977), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9939), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1682), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [54696] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2531), 1,
      sym_identifier,
    ACTIONS(2533), 1,
      anon_sym_BSLASH,
    ACTIONS(2535), 1,
      anon_sym_function,
    ACTIONS(2537), 1,
      anon_sym_if,
    ACTIONS(2539), 1,
      anon_sym_for,
    ACTIONS(2541), 1,
      anon_sym_while,
    ACTIONS(2543), 1,
      anon_sym_repeat,
    ACTIONS(2545), 1,
      anon_sym_QMARK,
    ACTIONS(2547), 1,
      anon_sym_TILDE,
    ACTIONS(2555), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2557), 1,
      sym__number_literal,
    ACTIONS(2559), 1,
      anon_sym_SQUOTE,
    ACTIONS(2561), 1,
      anon_sym_DQUOTE,
    ACTIONS(2571), 1,
      sym__raw_string_literal,
    ACTIONS(2573), 1,
      sym__external_open_parenthesis,
    ACTIONS(2577), 1,
      sym__external_open_brace,
    ACTIONS(9611), 1,
      anon_sym_BANG,
    ACTIONS(9947), 1,
      sym_dot_dot_i,
    ACTIONS(9949), 1,
      sym__newline,
    STATE(70), 1,
      sym__open_brace,
    STATE(213), 1,
      sym__open_parenthesis,
    STATE(2437), 1,
      sym__double_quoted_string,
    STATE(2442), 1,
      sym__single_quoted_string,
    STATE(2530), 1,
      sym_string,
    STATE(3397), 1,
      aux_sym_function_definition_repeat1,
    STATE(5133), 1,
      sym__string_or_identifier,
    ACTIONS(2551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2445), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2565), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9945), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1400), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [54825] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2531), 1,
      sym_identifier,
    ACTIONS(2533), 1,
      anon_sym_BSLASH,
    ACTIONS(2535), 1,
      anon_sym_function,
    ACTIONS(2537), 1,
      anon_sym_if,
    ACTIONS(2539), 1,
      anon_sym_for,
    ACTIONS(2541), 1,
      anon_sym_while,
    ACTIONS(2543), 1,
      anon_sym_repeat,
    ACTIONS(2545), 1,
      anon_sym_QMARK,
    ACTIONS(2547), 1,
      anon_sym_TILDE,
    ACTIONS(2555), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2557), 1,
      sym__number_literal,
    ACTIONS(2559), 1,
      anon_sym_SQUOTE,
    ACTIONS(2561), 1,
      anon_sym_DQUOTE,
    ACTIONS(2571), 1,
      sym__raw_string_literal,
    ACTIONS(2573), 1,
      sym__external_open_parenthesis,
    ACTIONS(2577), 1,
      sym__external_open_brace,
    ACTIONS(9611), 1,
      anon_sym_BANG,
    ACTIONS(9953), 1,
      sym_dot_dot_i,
    ACTIONS(9955), 1,
      sym__newline,
    STATE(70), 1,
      sym__open_brace,
    STATE(213), 1,
      sym__open_parenthesis,
    STATE(2437), 1,
      sym__double_quoted_string,
    STATE(2442), 1,
      sym__single_quoted_string,
    STATE(2530), 1,
      sym_string,
    STATE(3399), 1,
      aux_sym_function_definition_repeat1,
    STATE(5133), 1,
      sym__string_or_identifier,
    ACTIONS(2551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2445), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2565), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9951), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1398), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [54954] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2531), 1,
      sym_identifier,
    ACTIONS(2533), 1,
      anon_sym_BSLASH,
    ACTIONS(2535), 1,
      anon_sym_function,
    ACTIONS(2537), 1,
      anon_sym_if,
    ACTIONS(2539), 1,
      anon_sym_for,
    ACTIONS(2541), 1,
      anon_sym_while,
    ACTIONS(2543), 1,
      anon_sym_repeat,
    ACTIONS(2545), 1,
      anon_sym_QMARK,
    ACTIONS(2547), 1,
      anon_sym_TILDE,
    ACTIONS(2555), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2557), 1,
      sym__number_literal,
    ACTIONS(2559), 1,
      anon_sym_SQUOTE,
    ACTIONS(2561), 1,
      anon_sym_DQUOTE,
    ACTIONS(2571), 1,
      sym__raw_string_literal,
    ACTIONS(2573), 1,
      sym__external_open_parenthesis,
    ACTIONS(2577), 1,
      sym__external_open_brace,
    ACTIONS(9611), 1,
      anon_sym_BANG,
    ACTIONS(9959), 1,
      sym_dot_dot_i,
    ACTIONS(9961), 1,
      sym__newline,
    STATE(70), 1,
      sym__open_brace,
    STATE(213), 1,
      sym__open_parenthesis,
    STATE(2437), 1,
      sym__double_quoted_string,
    STATE(2442), 1,
      sym__single_quoted_string,
    STATE(2530), 1,
      sym_string,
    STATE(3401), 1,
      aux_sym_function_definition_repeat1,
    STATE(5133), 1,
      sym__string_or_identifier,
    ACTIONS(2551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2445), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2565), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9957), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1396), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [55083] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3845), 1,
      sym_identifier,
    ACTIONS(3847), 1,
      anon_sym_BSLASH,
    ACTIONS(3849), 1,
      anon_sym_function,
    ACTIONS(3851), 1,
      anon_sym_if,
    ACTIONS(3853), 1,
      anon_sym_for,
    ACTIONS(3855), 1,
      anon_sym_while,
    ACTIONS(3857), 1,
      anon_sym_repeat,
    ACTIONS(3859), 1,
      anon_sym_QMARK,
    ACTIONS(3861), 1,
      anon_sym_TILDE,
    ACTIONS(3869), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3871), 1,
      sym__number_literal,
    ACTIONS(3873), 1,
      anon_sym_SQUOTE,
    ACTIONS(3875), 1,
      anon_sym_DQUOTE,
    ACTIONS(3885), 1,
      sym__raw_string_literal,
    ACTIONS(3887), 1,
      sym__external_open_parenthesis,
    ACTIONS(3891), 1,
      sym__external_open_brace,
    ACTIONS(6389), 1,
      anon_sym_BANG,
    ACTIONS(9965), 1,
      sym_dot_dot_i,
    ACTIONS(9967), 1,
      sym__newline,
    STATE(154), 1,
      sym__open_brace,
    STATE(350), 1,
      sym__open_parenthesis,
    STATE(2620), 1,
      sym__double_quoted_string,
    STATE(2673), 1,
      sym_string,
    STATE(2735), 1,
      sym__single_quoted_string,
    STATE(3623), 1,
      aux_sym_function_definition_repeat1,
    STATE(5135), 1,
      sym__string_or_identifier,
    ACTIONS(3865), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2578), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3879), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9963), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2006), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [55212] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2531), 1,
      sym_identifier,
    ACTIONS(2533), 1,
      anon_sym_BSLASH,
    ACTIONS(2535), 1,
      anon_sym_function,
    ACTIONS(2537), 1,
      anon_sym_if,
    ACTIONS(2539), 1,
      anon_sym_for,
    ACTIONS(2541), 1,
      anon_sym_while,
    ACTIONS(2543), 1,
      anon_sym_repeat,
    ACTIONS(2545), 1,
      anon_sym_QMARK,
    ACTIONS(2547), 1,
      anon_sym_TILDE,
    ACTIONS(2555), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2557), 1,
      sym__number_literal,
    ACTIONS(2559), 1,
      anon_sym_SQUOTE,
    ACTIONS(2561), 1,
      anon_sym_DQUOTE,
    ACTIONS(2571), 1,
      sym__raw_string_literal,
    ACTIONS(2573), 1,
      sym__external_open_parenthesis,
    ACTIONS(2577), 1,
      sym__external_open_brace,
    ACTIONS(9611), 1,
      anon_sym_BANG,
    ACTIONS(9971), 1,
      sym_dot_dot_i,
    ACTIONS(9973), 1,
      sym__newline,
    STATE(70), 1,
      sym__open_brace,
    STATE(213), 1,
      sym__open_parenthesis,
    STATE(2437), 1,
      sym__double_quoted_string,
    STATE(2442), 1,
      sym__single_quoted_string,
    STATE(2530), 1,
      sym_string,
    STATE(3403), 1,
      aux_sym_function_definition_repeat1,
    STATE(5133), 1,
      sym__string_or_identifier,
    ACTIONS(2551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2445), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2565), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9969), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1394), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [55341] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2531), 1,
      sym_identifier,
    ACTIONS(2533), 1,
      anon_sym_BSLASH,
    ACTIONS(2535), 1,
      anon_sym_function,
    ACTIONS(2537), 1,
      anon_sym_if,
    ACTIONS(2539), 1,
      anon_sym_for,
    ACTIONS(2541), 1,
      anon_sym_while,
    ACTIONS(2543), 1,
      anon_sym_repeat,
    ACTIONS(2545), 1,
      anon_sym_QMARK,
    ACTIONS(2547), 1,
      anon_sym_TILDE,
    ACTIONS(2555), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2557), 1,
      sym__number_literal,
    ACTIONS(2559), 1,
      anon_sym_SQUOTE,
    ACTIONS(2561), 1,
      anon_sym_DQUOTE,
    ACTIONS(2571), 1,
      sym__raw_string_literal,
    ACTIONS(2573), 1,
      sym__external_open_parenthesis,
    ACTIONS(2577), 1,
      sym__external_open_brace,
    ACTIONS(9611), 1,
      anon_sym_BANG,
    ACTIONS(9977), 1,
      sym_dot_dot_i,
    ACTIONS(9979), 1,
      sym__newline,
    STATE(70), 1,
      sym__open_brace,
    STATE(213), 1,
      sym__open_parenthesis,
    STATE(2437), 1,
      sym__double_quoted_string,
    STATE(2442), 1,
      sym__single_quoted_string,
    STATE(2530), 1,
      sym_string,
    STATE(3405), 1,
      aux_sym_function_definition_repeat1,
    STATE(5133), 1,
      sym__string_or_identifier,
    ACTIONS(2551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2445), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2565), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9975), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1392), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [55470] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2943), 1,
      sym_identifier,
    ACTIONS(2945), 1,
      anon_sym_BSLASH,
    ACTIONS(2947), 1,
      anon_sym_function,
    ACTIONS(2949), 1,
      anon_sym_if,
    ACTIONS(2951), 1,
      anon_sym_for,
    ACTIONS(2953), 1,
      anon_sym_while,
    ACTIONS(2955), 1,
      anon_sym_repeat,
    ACTIONS(2957), 1,
      anon_sym_QMARK,
    ACTIONS(2959), 1,
      anon_sym_TILDE,
    ACTIONS(2967), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2969), 1,
      sym__number_literal,
    ACTIONS(2971), 1,
      anon_sym_SQUOTE,
    ACTIONS(2973), 1,
      anon_sym_DQUOTE,
    ACTIONS(2983), 1,
      sym__raw_string_literal,
    ACTIONS(2985), 1,
      sym__external_open_parenthesis,
    ACTIONS(2989), 1,
      sym__external_open_brace,
    ACTIONS(7797), 1,
      anon_sym_BANG,
    ACTIONS(9983), 1,
      sym_dot_dot_i,
    ACTIONS(9985), 1,
      sym__newline,
    STATE(173), 1,
      sym__open_brace,
    STATE(246), 1,
      sym__open_parenthesis,
    STATE(2462), 1,
      sym__single_quoted_string,
    STATE(2494), 1,
      sym__double_quoted_string,
    STATE(2541), 1,
      sym_string,
    STATE(3038), 1,
      aux_sym_function_definition_repeat1,
    STATE(5128), 1,
      sym__string_or_identifier,
    ACTIONS(2963), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2540), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2977), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9981), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1675), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [55599] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2531), 1,
      sym_identifier,
    ACTIONS(2533), 1,
      anon_sym_BSLASH,
    ACTIONS(2535), 1,
      anon_sym_function,
    ACTIONS(2537), 1,
      anon_sym_if,
    ACTIONS(2539), 1,
      anon_sym_for,
    ACTIONS(2541), 1,
      anon_sym_while,
    ACTIONS(2543), 1,
      anon_sym_repeat,
    ACTIONS(2545), 1,
      anon_sym_QMARK,
    ACTIONS(2547), 1,
      anon_sym_TILDE,
    ACTIONS(2555), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2557), 1,
      sym__number_literal,
    ACTIONS(2559), 1,
      anon_sym_SQUOTE,
    ACTIONS(2561), 1,
      anon_sym_DQUOTE,
    ACTIONS(2571), 1,
      sym__raw_string_literal,
    ACTIONS(2573), 1,
      sym__external_open_parenthesis,
    ACTIONS(2577), 1,
      sym__external_open_brace,
    ACTIONS(9611), 1,
      anon_sym_BANG,
    ACTIONS(9989), 1,
      sym_dot_dot_i,
    ACTIONS(9991), 1,
      sym__newline,
    STATE(70), 1,
      sym__open_brace,
    STATE(213), 1,
      sym__open_parenthesis,
    STATE(2437), 1,
      sym__double_quoted_string,
    STATE(2442), 1,
      sym__single_quoted_string,
    STATE(2530), 1,
      sym_string,
    STATE(3408), 1,
      aux_sym_function_definition_repeat1,
    STATE(5133), 1,
      sym__string_or_identifier,
    ACTIONS(2551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2445), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2565), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9987), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1390), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [55728] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2531), 1,
      sym_identifier,
    ACTIONS(2533), 1,
      anon_sym_BSLASH,
    ACTIONS(2535), 1,
      anon_sym_function,
    ACTIONS(2537), 1,
      anon_sym_if,
    ACTIONS(2539), 1,
      anon_sym_for,
    ACTIONS(2541), 1,
      anon_sym_while,
    ACTIONS(2543), 1,
      anon_sym_repeat,
    ACTIONS(2545), 1,
      anon_sym_QMARK,
    ACTIONS(2547), 1,
      anon_sym_TILDE,
    ACTIONS(2555), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2557), 1,
      sym__number_literal,
    ACTIONS(2559), 1,
      anon_sym_SQUOTE,
    ACTIONS(2561), 1,
      anon_sym_DQUOTE,
    ACTIONS(2571), 1,
      sym__raw_string_literal,
    ACTIONS(2573), 1,
      sym__external_open_parenthesis,
    ACTIONS(2577), 1,
      sym__external_open_brace,
    ACTIONS(9611), 1,
      anon_sym_BANG,
    ACTIONS(9995), 1,
      sym_dot_dot_i,
    ACTIONS(9997), 1,
      sym__newline,
    STATE(70), 1,
      sym__open_brace,
    STATE(213), 1,
      sym__open_parenthesis,
    STATE(2437), 1,
      sym__double_quoted_string,
    STATE(2442), 1,
      sym__single_quoted_string,
    STATE(2530), 1,
      sym_string,
    STATE(3411), 1,
      aux_sym_function_definition_repeat1,
    STATE(5133), 1,
      sym__string_or_identifier,
    ACTIONS(2551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2445), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2565), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9993), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1388), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [55857] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4214), 1,
      sym_identifier,
    ACTIONS(4216), 1,
      anon_sym_BSLASH,
    ACTIONS(4218), 1,
      anon_sym_function,
    ACTIONS(4220), 1,
      anon_sym_if,
    ACTIONS(4222), 1,
      anon_sym_for,
    ACTIONS(4224), 1,
      anon_sym_while,
    ACTIONS(4226), 1,
      anon_sym_repeat,
    ACTIONS(4228), 1,
      anon_sym_QMARK,
    ACTIONS(4230), 1,
      anon_sym_TILDE,
    ACTIONS(4238), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4240), 1,
      sym__number_literal,
    ACTIONS(4242), 1,
      anon_sym_SQUOTE,
    ACTIONS(4244), 1,
      anon_sym_DQUOTE,
    ACTIONS(4254), 1,
      sym__raw_string_literal,
    ACTIONS(4256), 1,
      sym__external_open_parenthesis,
    ACTIONS(4258), 1,
      sym__external_open_brace,
    ACTIONS(9229), 1,
      anon_sym_BANG,
    ACTIONS(10001), 1,
      sym_dot_dot_i,
    ACTIONS(10003), 1,
      sym__newline,
    STATE(51), 1,
      sym__open_brace,
    STATE(287), 1,
      sym__open_parenthesis,
    STATE(3510), 1,
      aux_sym_function_definition_repeat1,
    STATE(4674), 1,
      sym__single_quoted_string,
    STATE(4678), 1,
      sym__double_quoted_string,
    STATE(4681), 1,
      sym_string,
    STATE(5129), 1,
      sym__string_or_identifier,
    ACTIONS(4234), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4680), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4248), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(9999), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4385), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [55986] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2943), 1,
      sym_identifier,
    ACTIONS(2945), 1,
      anon_sym_BSLASH,
    ACTIONS(2947), 1,
      anon_sym_function,
    ACTIONS(2949), 1,
      anon_sym_if,
    ACTIONS(2951), 1,
      anon_sym_for,
    ACTIONS(2953), 1,
      anon_sym_while,
    ACTIONS(2955), 1,
      anon_sym_repeat,
    ACTIONS(2957), 1,
      anon_sym_QMARK,
    ACTIONS(2959), 1,
      anon_sym_TILDE,
    ACTIONS(2967), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2969), 1,
      sym__number_literal,
    ACTIONS(2971), 1,
      anon_sym_SQUOTE,
    ACTIONS(2973), 1,
      anon_sym_DQUOTE,
    ACTIONS(2983), 1,
      sym__raw_string_literal,
    ACTIONS(2985), 1,
      sym__external_open_parenthesis,
    ACTIONS(2989), 1,
      sym__external_open_brace,
    ACTIONS(7797), 1,
      anon_sym_BANG,
    ACTIONS(10007), 1,
      sym_dot_dot_i,
    ACTIONS(10009), 1,
      sym__newline,
    STATE(173), 1,
      sym__open_brace,
    STATE(246), 1,
      sym__open_parenthesis,
    STATE(2462), 1,
      sym__single_quoted_string,
    STATE(2494), 1,
      sym__double_quoted_string,
    STATE(2541), 1,
      sym_string,
    STATE(3165), 1,
      aux_sym_function_definition_repeat1,
    STATE(5128), 1,
      sym__string_or_identifier,
    ACTIONS(2963), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2540), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2977), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10005), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1663), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [56115] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      sym_identifier,
    ACTIONS(483), 1,
      anon_sym_BSLASH,
    ACTIONS(485), 1,
      anon_sym_function,
    ACTIONS(487), 1,
      anon_sym_if,
    ACTIONS(489), 1,
      anon_sym_for,
    ACTIONS(491), 1,
      anon_sym_while,
    ACTIONS(493), 1,
      anon_sym_repeat,
    ACTIONS(495), 1,
      anon_sym_QMARK,
    ACTIONS(497), 1,
      anon_sym_TILDE,
    ACTIONS(505), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(507), 1,
      sym__number_literal,
    ACTIONS(509), 1,
      anon_sym_SQUOTE,
    ACTIONS(511), 1,
      anon_sym_DQUOTE,
    ACTIONS(521), 1,
      sym__raw_string_literal,
    ACTIONS(523), 1,
      sym__external_open_parenthesis,
    ACTIONS(525), 1,
      sym__external_open_brace,
    ACTIONS(8515), 1,
      anon_sym_BANG,
    ACTIONS(10013), 1,
      sym_dot_dot_i,
    ACTIONS(10015), 1,
      sym__newline,
    STATE(3), 1,
      sym__open_parenthesis,
    STATE(45), 1,
      sym__open_brace,
    STATE(2166), 1,
      sym_string,
    STATE(2200), 1,
      sym__single_quoted_string,
    STATE(2201), 1,
      sym__double_quoted_string,
    STATE(3476), 1,
      aux_sym_function_definition_repeat1,
    STATE(5154), 1,
      sym__string_or_identifier,
    ACTIONS(501), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2206), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(515), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10011), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(798), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [56244] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      sym_identifier,
    ACTIONS(483), 1,
      anon_sym_BSLASH,
    ACTIONS(485), 1,
      anon_sym_function,
    ACTIONS(487), 1,
      anon_sym_if,
    ACTIONS(489), 1,
      anon_sym_for,
    ACTIONS(491), 1,
      anon_sym_while,
    ACTIONS(493), 1,
      anon_sym_repeat,
    ACTIONS(495), 1,
      anon_sym_QMARK,
    ACTIONS(497), 1,
      anon_sym_TILDE,
    ACTIONS(505), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(507), 1,
      sym__number_literal,
    ACTIONS(509), 1,
      anon_sym_SQUOTE,
    ACTIONS(511), 1,
      anon_sym_DQUOTE,
    ACTIONS(521), 1,
      sym__raw_string_literal,
    ACTIONS(523), 1,
      sym__external_open_parenthesis,
    ACTIONS(525), 1,
      sym__external_open_brace,
    ACTIONS(8515), 1,
      anon_sym_BANG,
    ACTIONS(10019), 1,
      sym_dot_dot_i,
    ACTIONS(10021), 1,
      sym__newline,
    STATE(3), 1,
      sym__open_parenthesis,
    STATE(45), 1,
      sym__open_brace,
    STATE(2166), 1,
      sym_string,
    STATE(2200), 1,
      sym__single_quoted_string,
    STATE(2201), 1,
      sym__double_quoted_string,
    STATE(3478), 1,
      aux_sym_function_definition_repeat1,
    STATE(5154), 1,
      sym__string_or_identifier,
    ACTIONS(501), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2206), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(515), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10017), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(799), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [56373] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      sym_identifier,
    ACTIONS(483), 1,
      anon_sym_BSLASH,
    ACTIONS(485), 1,
      anon_sym_function,
    ACTIONS(487), 1,
      anon_sym_if,
    ACTIONS(489), 1,
      anon_sym_for,
    ACTIONS(491), 1,
      anon_sym_while,
    ACTIONS(493), 1,
      anon_sym_repeat,
    ACTIONS(495), 1,
      anon_sym_QMARK,
    ACTIONS(497), 1,
      anon_sym_TILDE,
    ACTIONS(505), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(507), 1,
      sym__number_literal,
    ACTIONS(509), 1,
      anon_sym_SQUOTE,
    ACTIONS(511), 1,
      anon_sym_DQUOTE,
    ACTIONS(521), 1,
      sym__raw_string_literal,
    ACTIONS(523), 1,
      sym__external_open_parenthesis,
    ACTIONS(525), 1,
      sym__external_open_brace,
    ACTIONS(8515), 1,
      anon_sym_BANG,
    ACTIONS(10025), 1,
      sym_dot_dot_i,
    ACTIONS(10027), 1,
      sym__newline,
    STATE(3), 1,
      sym__open_parenthesis,
    STATE(45), 1,
      sym__open_brace,
    STATE(2166), 1,
      sym_string,
    STATE(2200), 1,
      sym__single_quoted_string,
    STATE(2201), 1,
      sym__double_quoted_string,
    STATE(3480), 1,
      aux_sym_function_definition_repeat1,
    STATE(5154), 1,
      sym__string_or_identifier,
    ACTIONS(501), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2206), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(515), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10023), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(800), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [56502] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      sym_identifier,
    ACTIONS(483), 1,
      anon_sym_BSLASH,
    ACTIONS(485), 1,
      anon_sym_function,
    ACTIONS(487), 1,
      anon_sym_if,
    ACTIONS(489), 1,
      anon_sym_for,
    ACTIONS(491), 1,
      anon_sym_while,
    ACTIONS(493), 1,
      anon_sym_repeat,
    ACTIONS(495), 1,
      anon_sym_QMARK,
    ACTIONS(497), 1,
      anon_sym_TILDE,
    ACTIONS(505), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(507), 1,
      sym__number_literal,
    ACTIONS(509), 1,
      anon_sym_SQUOTE,
    ACTIONS(511), 1,
      anon_sym_DQUOTE,
    ACTIONS(521), 1,
      sym__raw_string_literal,
    ACTIONS(523), 1,
      sym__external_open_parenthesis,
    ACTIONS(525), 1,
      sym__external_open_brace,
    ACTIONS(8515), 1,
      anon_sym_BANG,
    ACTIONS(10031), 1,
      sym_dot_dot_i,
    ACTIONS(10033), 1,
      sym__newline,
    STATE(3), 1,
      sym__open_parenthesis,
    STATE(45), 1,
      sym__open_brace,
    STATE(2166), 1,
      sym_string,
    STATE(2200), 1,
      sym__single_quoted_string,
    STATE(2201), 1,
      sym__double_quoted_string,
    STATE(3482), 1,
      aux_sym_function_definition_repeat1,
    STATE(5154), 1,
      sym__string_or_identifier,
    ACTIONS(501), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2206), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(515), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10029), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(801), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [56631] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3845), 1,
      sym_identifier,
    ACTIONS(3847), 1,
      anon_sym_BSLASH,
    ACTIONS(3849), 1,
      anon_sym_function,
    ACTIONS(3851), 1,
      anon_sym_if,
    ACTIONS(3853), 1,
      anon_sym_for,
    ACTIONS(3855), 1,
      anon_sym_while,
    ACTIONS(3857), 1,
      anon_sym_repeat,
    ACTIONS(3859), 1,
      anon_sym_QMARK,
    ACTIONS(3861), 1,
      anon_sym_TILDE,
    ACTIONS(3869), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3871), 1,
      sym__number_literal,
    ACTIONS(3873), 1,
      anon_sym_SQUOTE,
    ACTIONS(3875), 1,
      anon_sym_DQUOTE,
    ACTIONS(3885), 1,
      sym__raw_string_literal,
    ACTIONS(3887), 1,
      sym__external_open_parenthesis,
    ACTIONS(3891), 1,
      sym__external_open_brace,
    ACTIONS(6389), 1,
      anon_sym_BANG,
    ACTIONS(10037), 1,
      sym_dot_dot_i,
    ACTIONS(10039), 1,
      sym__newline,
    STATE(154), 1,
      sym__open_brace,
    STATE(350), 1,
      sym__open_parenthesis,
    STATE(2620), 1,
      sym__double_quoted_string,
    STATE(2673), 1,
      sym_string,
    STATE(2735), 1,
      sym__single_quoted_string,
    STATE(3639), 1,
      aux_sym_function_definition_repeat1,
    STATE(5135), 1,
      sym__string_or_identifier,
    ACTIONS(3865), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2578), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3879), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10035), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1996), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [56760] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4214), 1,
      sym_identifier,
    ACTIONS(4216), 1,
      anon_sym_BSLASH,
    ACTIONS(4218), 1,
      anon_sym_function,
    ACTIONS(4220), 1,
      anon_sym_if,
    ACTIONS(4222), 1,
      anon_sym_for,
    ACTIONS(4224), 1,
      anon_sym_while,
    ACTIONS(4226), 1,
      anon_sym_repeat,
    ACTIONS(4228), 1,
      anon_sym_QMARK,
    ACTIONS(4230), 1,
      anon_sym_TILDE,
    ACTIONS(4238), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4240), 1,
      sym__number_literal,
    ACTIONS(4242), 1,
      anon_sym_SQUOTE,
    ACTIONS(4244), 1,
      anon_sym_DQUOTE,
    ACTIONS(4254), 1,
      sym__raw_string_literal,
    ACTIONS(4256), 1,
      sym__external_open_parenthesis,
    ACTIONS(4258), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9229), 1,
      anon_sym_BANG,
    ACTIONS(10043), 1,
      sym_dot_dot_i,
    STATE(51), 1,
      sym__open_brace,
    STATE(287), 1,
      sym__open_parenthesis,
    STATE(4674), 1,
      sym__single_quoted_string,
    STATE(4678), 1,
      sym__double_quoted_string,
    STATE(4681), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5129), 1,
      sym__string_or_identifier,
    ACTIONS(4234), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4680), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4248), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10041), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4392), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [56889] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3845), 1,
      sym_identifier,
    ACTIONS(3847), 1,
      anon_sym_BSLASH,
    ACTIONS(3849), 1,
      anon_sym_function,
    ACTIONS(3851), 1,
      anon_sym_if,
    ACTIONS(3853), 1,
      anon_sym_for,
    ACTIONS(3855), 1,
      anon_sym_while,
    ACTIONS(3857), 1,
      anon_sym_repeat,
    ACTIONS(3859), 1,
      anon_sym_QMARK,
    ACTIONS(3861), 1,
      anon_sym_TILDE,
    ACTIONS(3869), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3871), 1,
      sym__number_literal,
    ACTIONS(3873), 1,
      anon_sym_SQUOTE,
    ACTIONS(3875), 1,
      anon_sym_DQUOTE,
    ACTIONS(3885), 1,
      sym__raw_string_literal,
    ACTIONS(3887), 1,
      sym__external_open_parenthesis,
    ACTIONS(3891), 1,
      sym__external_open_brace,
    ACTIONS(6389), 1,
      anon_sym_BANG,
    ACTIONS(10047), 1,
      sym_dot_dot_i,
    ACTIONS(10049), 1,
      sym__newline,
    STATE(154), 1,
      sym__open_brace,
    STATE(350), 1,
      sym__open_parenthesis,
    STATE(2620), 1,
      sym__double_quoted_string,
    STATE(2673), 1,
      sym_string,
    STATE(2735), 1,
      sym__single_quoted_string,
    STATE(3641), 1,
      aux_sym_function_definition_repeat1,
    STATE(5135), 1,
      sym__string_or_identifier,
    ACTIONS(3865), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2578), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3879), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10045), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1994), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [57018] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4214), 1,
      sym_identifier,
    ACTIONS(4216), 1,
      anon_sym_BSLASH,
    ACTIONS(4218), 1,
      anon_sym_function,
    ACTIONS(4220), 1,
      anon_sym_if,
    ACTIONS(4222), 1,
      anon_sym_for,
    ACTIONS(4224), 1,
      anon_sym_while,
    ACTIONS(4226), 1,
      anon_sym_repeat,
    ACTIONS(4228), 1,
      anon_sym_QMARK,
    ACTIONS(4230), 1,
      anon_sym_TILDE,
    ACTIONS(4238), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4240), 1,
      sym__number_literal,
    ACTIONS(4242), 1,
      anon_sym_SQUOTE,
    ACTIONS(4244), 1,
      anon_sym_DQUOTE,
    ACTIONS(4254), 1,
      sym__raw_string_literal,
    ACTIONS(4256), 1,
      sym__external_open_parenthesis,
    ACTIONS(4258), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9229), 1,
      anon_sym_BANG,
    ACTIONS(10053), 1,
      sym_dot_dot_i,
    STATE(51), 1,
      sym__open_brace,
    STATE(287), 1,
      sym__open_parenthesis,
    STATE(4674), 1,
      sym__single_quoted_string,
    STATE(4678), 1,
      sym__double_quoted_string,
    STATE(4681), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5129), 1,
      sym__string_or_identifier,
    ACTIONS(4234), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4680), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4248), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10051), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4393), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [57147] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2531), 1,
      sym_identifier,
    ACTIONS(2533), 1,
      anon_sym_BSLASH,
    ACTIONS(2535), 1,
      anon_sym_function,
    ACTIONS(2537), 1,
      anon_sym_if,
    ACTIONS(2539), 1,
      anon_sym_for,
    ACTIONS(2541), 1,
      anon_sym_while,
    ACTIONS(2543), 1,
      anon_sym_repeat,
    ACTIONS(2545), 1,
      anon_sym_QMARK,
    ACTIONS(2547), 1,
      anon_sym_TILDE,
    ACTIONS(2555), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2557), 1,
      sym__number_literal,
    ACTIONS(2559), 1,
      anon_sym_SQUOTE,
    ACTIONS(2561), 1,
      anon_sym_DQUOTE,
    ACTIONS(2571), 1,
      sym__raw_string_literal,
    ACTIONS(2573), 1,
      sym__external_open_parenthesis,
    ACTIONS(2577), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9611), 1,
      anon_sym_BANG,
    ACTIONS(10057), 1,
      sym_dot_dot_i,
    STATE(70), 1,
      sym__open_brace,
    STATE(213), 1,
      sym__open_parenthesis,
    STATE(2437), 1,
      sym__double_quoted_string,
    STATE(2442), 1,
      sym__single_quoted_string,
    STATE(2530), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5133), 1,
      sym__string_or_identifier,
    ACTIONS(2551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2445), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2565), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10055), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1385), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [57276] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2943), 1,
      sym_identifier,
    ACTIONS(2945), 1,
      anon_sym_BSLASH,
    ACTIONS(2947), 1,
      anon_sym_function,
    ACTIONS(2949), 1,
      anon_sym_if,
    ACTIONS(2951), 1,
      anon_sym_for,
    ACTIONS(2953), 1,
      anon_sym_while,
    ACTIONS(2955), 1,
      anon_sym_repeat,
    ACTIONS(2957), 1,
      anon_sym_QMARK,
    ACTIONS(2959), 1,
      anon_sym_TILDE,
    ACTIONS(2967), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2969), 1,
      sym__number_literal,
    ACTIONS(2971), 1,
      anon_sym_SQUOTE,
    ACTIONS(2973), 1,
      anon_sym_DQUOTE,
    ACTIONS(2983), 1,
      sym__raw_string_literal,
    ACTIONS(2985), 1,
      sym__external_open_parenthesis,
    ACTIONS(2989), 1,
      sym__external_open_brace,
    ACTIONS(7797), 1,
      anon_sym_BANG,
    ACTIONS(10061), 1,
      sym_dot_dot_i,
    ACTIONS(10063), 1,
      sym__newline,
    STATE(173), 1,
      sym__open_brace,
    STATE(246), 1,
      sym__open_parenthesis,
    STATE(2462), 1,
      sym__single_quoted_string,
    STATE(2494), 1,
      sym__double_quoted_string,
    STATE(2541), 1,
      sym_string,
    STATE(3060), 1,
      aux_sym_function_definition_repeat1,
    STATE(5128), 1,
      sym__string_or_identifier,
    ACTIONS(2963), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2540), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2977), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10059), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1661), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [57405] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2531), 1,
      sym_identifier,
    ACTIONS(2533), 1,
      anon_sym_BSLASH,
    ACTIONS(2535), 1,
      anon_sym_function,
    ACTIONS(2537), 1,
      anon_sym_if,
    ACTIONS(2539), 1,
      anon_sym_for,
    ACTIONS(2541), 1,
      anon_sym_while,
    ACTIONS(2543), 1,
      anon_sym_repeat,
    ACTIONS(2545), 1,
      anon_sym_QMARK,
    ACTIONS(2547), 1,
      anon_sym_TILDE,
    ACTIONS(2555), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2557), 1,
      sym__number_literal,
    ACTIONS(2559), 1,
      anon_sym_SQUOTE,
    ACTIONS(2561), 1,
      anon_sym_DQUOTE,
    ACTIONS(2571), 1,
      sym__raw_string_literal,
    ACTIONS(2573), 1,
      sym__external_open_parenthesis,
    ACTIONS(2577), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9611), 1,
      anon_sym_BANG,
    ACTIONS(10067), 1,
      sym_dot_dot_i,
    STATE(70), 1,
      sym__open_brace,
    STATE(213), 1,
      sym__open_parenthesis,
    STATE(2437), 1,
      sym__double_quoted_string,
    STATE(2442), 1,
      sym__single_quoted_string,
    STATE(2530), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5133), 1,
      sym__string_or_identifier,
    ACTIONS(2551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2445), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2565), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10065), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1384), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [57534] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2943), 1,
      sym_identifier,
    ACTIONS(2945), 1,
      anon_sym_BSLASH,
    ACTIONS(2947), 1,
      anon_sym_function,
    ACTIONS(2949), 1,
      anon_sym_if,
    ACTIONS(2951), 1,
      anon_sym_for,
    ACTIONS(2953), 1,
      anon_sym_while,
    ACTIONS(2955), 1,
      anon_sym_repeat,
    ACTIONS(2957), 1,
      anon_sym_QMARK,
    ACTIONS(2959), 1,
      anon_sym_TILDE,
    ACTIONS(2967), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2969), 1,
      sym__number_literal,
    ACTIONS(2971), 1,
      anon_sym_SQUOTE,
    ACTIONS(2973), 1,
      anon_sym_DQUOTE,
    ACTIONS(2983), 1,
      sym__raw_string_literal,
    ACTIONS(2985), 1,
      sym__external_open_parenthesis,
    ACTIONS(2989), 1,
      sym__external_open_brace,
    ACTIONS(7797), 1,
      anon_sym_BANG,
    ACTIONS(10071), 1,
      sym_dot_dot_i,
    ACTIONS(10073), 1,
      sym__newline,
    STATE(173), 1,
      sym__open_brace,
    STATE(246), 1,
      sym__open_parenthesis,
    STATE(2462), 1,
      sym__single_quoted_string,
    STATE(2494), 1,
      sym__double_quoted_string,
    STATE(2541), 1,
      sym_string,
    STATE(3094), 1,
      aux_sym_function_definition_repeat1,
    STATE(5128), 1,
      sym__string_or_identifier,
    ACTIONS(2963), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2540), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2977), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10069), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1653), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [57663] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2531), 1,
      sym_identifier,
    ACTIONS(2533), 1,
      anon_sym_BSLASH,
    ACTIONS(2535), 1,
      anon_sym_function,
    ACTIONS(2537), 1,
      anon_sym_if,
    ACTIONS(2539), 1,
      anon_sym_for,
    ACTIONS(2541), 1,
      anon_sym_while,
    ACTIONS(2543), 1,
      anon_sym_repeat,
    ACTIONS(2545), 1,
      anon_sym_QMARK,
    ACTIONS(2547), 1,
      anon_sym_TILDE,
    ACTIONS(2555), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2557), 1,
      sym__number_literal,
    ACTIONS(2559), 1,
      anon_sym_SQUOTE,
    ACTIONS(2561), 1,
      anon_sym_DQUOTE,
    ACTIONS(2571), 1,
      sym__raw_string_literal,
    ACTIONS(2573), 1,
      sym__external_open_parenthesis,
    ACTIONS(2577), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9611), 1,
      anon_sym_BANG,
    ACTIONS(10077), 1,
      sym_dot_dot_i,
    STATE(70), 1,
      sym__open_brace,
    STATE(213), 1,
      sym__open_parenthesis,
    STATE(2437), 1,
      sym__double_quoted_string,
    STATE(2442), 1,
      sym__single_quoted_string,
    STATE(2530), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5133), 1,
      sym__string_or_identifier,
    ACTIONS(2551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2445), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2565), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10075), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1383), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [57792] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      sym_identifier,
    ACTIONS(483), 1,
      anon_sym_BSLASH,
    ACTIONS(485), 1,
      anon_sym_function,
    ACTIONS(487), 1,
      anon_sym_if,
    ACTIONS(489), 1,
      anon_sym_for,
    ACTIONS(491), 1,
      anon_sym_while,
    ACTIONS(493), 1,
      anon_sym_repeat,
    ACTIONS(495), 1,
      anon_sym_QMARK,
    ACTIONS(497), 1,
      anon_sym_TILDE,
    ACTIONS(505), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(507), 1,
      sym__number_literal,
    ACTIONS(509), 1,
      anon_sym_SQUOTE,
    ACTIONS(511), 1,
      anon_sym_DQUOTE,
    ACTIONS(521), 1,
      sym__raw_string_literal,
    ACTIONS(523), 1,
      sym__external_open_parenthesis,
    ACTIONS(525), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8515), 1,
      anon_sym_BANG,
    ACTIONS(10081), 1,
      sym_dot_dot_i,
    STATE(3), 1,
      sym__open_parenthesis,
    STATE(45), 1,
      sym__open_brace,
    STATE(2166), 1,
      sym_string,
    STATE(2200), 1,
      sym__single_quoted_string,
    STATE(2201), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5154), 1,
      sym__string_or_identifier,
    ACTIONS(501), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2206), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(515), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10079), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(806), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [57921] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2531), 1,
      sym_identifier,
    ACTIONS(2533), 1,
      anon_sym_BSLASH,
    ACTIONS(2535), 1,
      anon_sym_function,
    ACTIONS(2537), 1,
      anon_sym_if,
    ACTIONS(2539), 1,
      anon_sym_for,
    ACTIONS(2541), 1,
      anon_sym_while,
    ACTIONS(2543), 1,
      anon_sym_repeat,
    ACTIONS(2545), 1,
      anon_sym_QMARK,
    ACTIONS(2547), 1,
      anon_sym_TILDE,
    ACTIONS(2555), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2557), 1,
      sym__number_literal,
    ACTIONS(2559), 1,
      anon_sym_SQUOTE,
    ACTIONS(2561), 1,
      anon_sym_DQUOTE,
    ACTIONS(2571), 1,
      sym__raw_string_literal,
    ACTIONS(2573), 1,
      sym__external_open_parenthesis,
    ACTIONS(2577), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9611), 1,
      anon_sym_BANG,
    ACTIONS(10085), 1,
      sym_dot_dot_i,
    STATE(70), 1,
      sym__open_brace,
    STATE(213), 1,
      sym__open_parenthesis,
    STATE(2437), 1,
      sym__double_quoted_string,
    STATE(2442), 1,
      sym__single_quoted_string,
    STATE(2530), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5133), 1,
      sym__string_or_identifier,
    ACTIONS(2551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2445), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2565), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10083), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1382), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [58050] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      sym_identifier,
    ACTIONS(483), 1,
      anon_sym_BSLASH,
    ACTIONS(485), 1,
      anon_sym_function,
    ACTIONS(487), 1,
      anon_sym_if,
    ACTIONS(489), 1,
      anon_sym_for,
    ACTIONS(491), 1,
      anon_sym_while,
    ACTIONS(493), 1,
      anon_sym_repeat,
    ACTIONS(495), 1,
      anon_sym_QMARK,
    ACTIONS(497), 1,
      anon_sym_TILDE,
    ACTIONS(505), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(507), 1,
      sym__number_literal,
    ACTIONS(509), 1,
      anon_sym_SQUOTE,
    ACTIONS(511), 1,
      anon_sym_DQUOTE,
    ACTIONS(521), 1,
      sym__raw_string_literal,
    ACTIONS(523), 1,
      sym__external_open_parenthesis,
    ACTIONS(525), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8515), 1,
      anon_sym_BANG,
    ACTIONS(10089), 1,
      sym_dot_dot_i,
    STATE(3), 1,
      sym__open_parenthesis,
    STATE(45), 1,
      sym__open_brace,
    STATE(2166), 1,
      sym_string,
    STATE(2200), 1,
      sym__single_quoted_string,
    STATE(2201), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5154), 1,
      sym__string_or_identifier,
    ACTIONS(501), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2206), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(515), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10087), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(808), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [58179] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      sym_identifier,
    ACTIONS(55), 1,
      anon_sym_BSLASH,
    ACTIONS(57), 1,
      anon_sym_function,
    ACTIONS(61), 1,
      anon_sym_if,
    ACTIONS(63), 1,
      anon_sym_for,
    ACTIONS(65), 1,
      anon_sym_while,
    ACTIONS(67), 1,
      anon_sym_repeat,
    ACTIONS(69), 1,
      anon_sym_QMARK,
    ACTIONS(71), 1,
      anon_sym_TILDE,
    ACTIONS(79), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(81), 1,
      sym__number_literal,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE,
    ACTIONS(95), 1,
      sym__raw_string_literal,
    ACTIONS(97), 1,
      sym__external_open_parenthesis,
    ACTIONS(99), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8831), 1,
      anon_sym_BANG,
    ACTIONS(10093), 1,
      sym_dot_dot_i,
    STATE(4), 1,
      sym__open_brace,
    STATE(19), 1,
      sym__open_parenthesis,
    STATE(1982), 1,
      sym_string,
    STATE(1985), 1,
      sym__single_quoted_string,
    STATE(1990), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5151), 1,
      sym__string_or_identifier,
    ACTIONS(75), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1984), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(89), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10091), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(495), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [58308] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      sym_identifier,
    ACTIONS(483), 1,
      anon_sym_BSLASH,
    ACTIONS(485), 1,
      anon_sym_function,
    ACTIONS(487), 1,
      anon_sym_if,
    ACTIONS(489), 1,
      anon_sym_for,
    ACTIONS(491), 1,
      anon_sym_while,
    ACTIONS(493), 1,
      anon_sym_repeat,
    ACTIONS(495), 1,
      anon_sym_QMARK,
    ACTIONS(497), 1,
      anon_sym_TILDE,
    ACTIONS(505), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(507), 1,
      sym__number_literal,
    ACTIONS(509), 1,
      anon_sym_SQUOTE,
    ACTIONS(511), 1,
      anon_sym_DQUOTE,
    ACTIONS(521), 1,
      sym__raw_string_literal,
    ACTIONS(523), 1,
      sym__external_open_parenthesis,
    ACTIONS(525), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8515), 1,
      anon_sym_BANG,
    ACTIONS(10097), 1,
      sym_dot_dot_i,
    STATE(3), 1,
      sym__open_parenthesis,
    STATE(45), 1,
      sym__open_brace,
    STATE(2166), 1,
      sym_string,
    STATE(2200), 1,
      sym__single_quoted_string,
    STATE(2201), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5154), 1,
      sym__string_or_identifier,
    ACTIONS(501), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2206), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(515), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10095), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(810), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [58437] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      sym_identifier,
    ACTIONS(55), 1,
      anon_sym_BSLASH,
    ACTIONS(57), 1,
      anon_sym_function,
    ACTIONS(61), 1,
      anon_sym_if,
    ACTIONS(63), 1,
      anon_sym_for,
    ACTIONS(65), 1,
      anon_sym_while,
    ACTIONS(67), 1,
      anon_sym_repeat,
    ACTIONS(69), 1,
      anon_sym_QMARK,
    ACTIONS(71), 1,
      anon_sym_TILDE,
    ACTIONS(79), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(81), 1,
      sym__number_literal,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE,
    ACTIONS(95), 1,
      sym__raw_string_literal,
    ACTIONS(97), 1,
      sym__external_open_parenthesis,
    ACTIONS(99), 1,
      sym__external_open_brace,
    ACTIONS(8831), 1,
      anon_sym_BANG,
    ACTIONS(10101), 1,
      sym_dot_dot_i,
    ACTIONS(10103), 1,
      sym__newline,
    STATE(4), 1,
      sym__open_brace,
    STATE(19), 1,
      sym__open_parenthesis,
    STATE(1982), 1,
      sym_string,
    STATE(1985), 1,
      sym__single_quoted_string,
    STATE(1990), 1,
      sym__double_quoted_string,
    STATE(3479), 1,
      aux_sym_function_definition_repeat1,
    STATE(5151), 1,
      sym__string_or_identifier,
    ACTIONS(75), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1984), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(89), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10099), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(498), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [58566] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      sym_identifier,
    ACTIONS(483), 1,
      anon_sym_BSLASH,
    ACTIONS(485), 1,
      anon_sym_function,
    ACTIONS(487), 1,
      anon_sym_if,
    ACTIONS(489), 1,
      anon_sym_for,
    ACTIONS(491), 1,
      anon_sym_while,
    ACTIONS(493), 1,
      anon_sym_repeat,
    ACTIONS(495), 1,
      anon_sym_QMARK,
    ACTIONS(497), 1,
      anon_sym_TILDE,
    ACTIONS(505), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(507), 1,
      sym__number_literal,
    ACTIONS(509), 1,
      anon_sym_SQUOTE,
    ACTIONS(511), 1,
      anon_sym_DQUOTE,
    ACTIONS(521), 1,
      sym__raw_string_literal,
    ACTIONS(523), 1,
      sym__external_open_parenthesis,
    ACTIONS(525), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8515), 1,
      anon_sym_BANG,
    ACTIONS(10107), 1,
      sym_dot_dot_i,
    STATE(3), 1,
      sym__open_parenthesis,
    STATE(45), 1,
      sym__open_brace,
    STATE(2166), 1,
      sym_string,
    STATE(2200), 1,
      sym__single_quoted_string,
    STATE(2201), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5154), 1,
      sym__string_or_identifier,
    ACTIONS(501), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2206), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(515), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10105), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(811), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [58695] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(10111), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10109), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4454), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [58824] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      sym_identifier,
    ACTIONS(55), 1,
      anon_sym_BSLASH,
    ACTIONS(57), 1,
      anon_sym_function,
    ACTIONS(61), 1,
      anon_sym_if,
    ACTIONS(63), 1,
      anon_sym_for,
    ACTIONS(65), 1,
      anon_sym_while,
    ACTIONS(67), 1,
      anon_sym_repeat,
    ACTIONS(69), 1,
      anon_sym_QMARK,
    ACTIONS(71), 1,
      anon_sym_TILDE,
    ACTIONS(79), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(81), 1,
      sym__number_literal,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE,
    ACTIONS(95), 1,
      sym__raw_string_literal,
    ACTIONS(97), 1,
      sym__external_open_parenthesis,
    ACTIONS(99), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8831), 1,
      anon_sym_BANG,
    ACTIONS(10115), 1,
      sym_dot_dot_i,
    STATE(4), 1,
      sym__open_brace,
    STATE(19), 1,
      sym__open_parenthesis,
    STATE(1982), 1,
      sym_string,
    STATE(1985), 1,
      sym__single_quoted_string,
    STATE(1990), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5151), 1,
      sym__string_or_identifier,
    ACTIONS(75), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1984), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(89), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10113), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(479), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [58953] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      sym_identifier,
    ACTIONS(55), 1,
      anon_sym_BSLASH,
    ACTIONS(57), 1,
      anon_sym_function,
    ACTIONS(61), 1,
      anon_sym_if,
    ACTIONS(63), 1,
      anon_sym_for,
    ACTIONS(65), 1,
      anon_sym_while,
    ACTIONS(67), 1,
      anon_sym_repeat,
    ACTIONS(69), 1,
      anon_sym_QMARK,
    ACTIONS(71), 1,
      anon_sym_TILDE,
    ACTIONS(79), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(81), 1,
      sym__number_literal,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE,
    ACTIONS(95), 1,
      sym__raw_string_literal,
    ACTIONS(97), 1,
      sym__external_open_parenthesis,
    ACTIONS(99), 1,
      sym__external_open_brace,
    ACTIONS(8831), 1,
      anon_sym_BANG,
    ACTIONS(10119), 1,
      sym_dot_dot_i,
    ACTIONS(10121), 1,
      sym__newline,
    STATE(4), 1,
      sym__open_brace,
    STATE(19), 1,
      sym__open_parenthesis,
    STATE(1982), 1,
      sym_string,
    STATE(1985), 1,
      sym__single_quoted_string,
    STATE(1990), 1,
      sym__double_quoted_string,
    STATE(3484), 1,
      aux_sym_function_definition_repeat1,
    STATE(5151), 1,
      sym__string_or_identifier,
    ACTIONS(75), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1984), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(89), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10117), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(488), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [59082] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4214), 1,
      sym_identifier,
    ACTIONS(4216), 1,
      anon_sym_BSLASH,
    ACTIONS(4218), 1,
      anon_sym_function,
    ACTIONS(4220), 1,
      anon_sym_if,
    ACTIONS(4222), 1,
      anon_sym_for,
    ACTIONS(4224), 1,
      anon_sym_while,
    ACTIONS(4226), 1,
      anon_sym_repeat,
    ACTIONS(4228), 1,
      anon_sym_QMARK,
    ACTIONS(4230), 1,
      anon_sym_TILDE,
    ACTIONS(4238), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4240), 1,
      sym__number_literal,
    ACTIONS(4242), 1,
      anon_sym_SQUOTE,
    ACTIONS(4244), 1,
      anon_sym_DQUOTE,
    ACTIONS(4254), 1,
      sym__raw_string_literal,
    ACTIONS(4256), 1,
      sym__external_open_parenthesis,
    ACTIONS(4258), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9229), 1,
      anon_sym_BANG,
    ACTIONS(10125), 1,
      sym_dot_dot_i,
    STATE(51), 1,
      sym__open_brace,
    STATE(287), 1,
      sym__open_parenthesis,
    STATE(4674), 1,
      sym__single_quoted_string,
    STATE(4678), 1,
      sym__double_quoted_string,
    STATE(4681), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5129), 1,
      sym__string_or_identifier,
    ACTIONS(4234), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4680), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4248), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10123), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4395), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [59211] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      sym_identifier,
    ACTIONS(483), 1,
      anon_sym_BSLASH,
    ACTIONS(485), 1,
      anon_sym_function,
    ACTIONS(487), 1,
      anon_sym_if,
    ACTIONS(489), 1,
      anon_sym_for,
    ACTIONS(491), 1,
      anon_sym_while,
    ACTIONS(493), 1,
      anon_sym_repeat,
    ACTIONS(495), 1,
      anon_sym_QMARK,
    ACTIONS(497), 1,
      anon_sym_TILDE,
    ACTIONS(505), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(507), 1,
      sym__number_literal,
    ACTIONS(509), 1,
      anon_sym_SQUOTE,
    ACTIONS(511), 1,
      anon_sym_DQUOTE,
    ACTIONS(521), 1,
      sym__raw_string_literal,
    ACTIONS(523), 1,
      sym__external_open_parenthesis,
    ACTIONS(525), 1,
      sym__external_open_brace,
    ACTIONS(8515), 1,
      anon_sym_BANG,
    ACTIONS(10129), 1,
      sym_dot_dot_i,
    ACTIONS(10131), 1,
      sym__newline,
    STATE(3), 1,
      sym__open_parenthesis,
    STATE(45), 1,
      sym__open_brace,
    STATE(2166), 1,
      sym_string,
    STATE(2200), 1,
      sym__single_quoted_string,
    STATE(2201), 1,
      sym__double_quoted_string,
    STATE(3520), 1,
      aux_sym_function_definition_repeat1,
    STATE(5154), 1,
      sym__string_or_identifier,
    ACTIONS(501), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2206), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(515), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10127), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(814), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [59340] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      sym_identifier,
    ACTIONS(483), 1,
      anon_sym_BSLASH,
    ACTIONS(485), 1,
      anon_sym_function,
    ACTIONS(487), 1,
      anon_sym_if,
    ACTIONS(489), 1,
      anon_sym_for,
    ACTIONS(491), 1,
      anon_sym_while,
    ACTIONS(493), 1,
      anon_sym_repeat,
    ACTIONS(495), 1,
      anon_sym_QMARK,
    ACTIONS(497), 1,
      anon_sym_TILDE,
    ACTIONS(505), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(507), 1,
      sym__number_literal,
    ACTIONS(509), 1,
      anon_sym_SQUOTE,
    ACTIONS(511), 1,
      anon_sym_DQUOTE,
    ACTIONS(521), 1,
      sym__raw_string_literal,
    ACTIONS(523), 1,
      sym__external_open_parenthesis,
    ACTIONS(525), 1,
      sym__external_open_brace,
    ACTIONS(8515), 1,
      anon_sym_BANG,
    ACTIONS(10135), 1,
      sym_dot_dot_i,
    ACTIONS(10137), 1,
      sym__newline,
    STATE(3), 1,
      sym__open_parenthesis,
    STATE(45), 1,
      sym__open_brace,
    STATE(2166), 1,
      sym_string,
    STATE(2200), 1,
      sym__single_quoted_string,
    STATE(2201), 1,
      sym__double_quoted_string,
    STATE(3522), 1,
      aux_sym_function_definition_repeat1,
    STATE(5154), 1,
      sym__string_or_identifier,
    ACTIONS(501), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2206), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(515), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10133), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(816), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [59469] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      sym_identifier,
    ACTIONS(483), 1,
      anon_sym_BSLASH,
    ACTIONS(485), 1,
      anon_sym_function,
    ACTIONS(487), 1,
      anon_sym_if,
    ACTIONS(489), 1,
      anon_sym_for,
    ACTIONS(491), 1,
      anon_sym_while,
    ACTIONS(493), 1,
      anon_sym_repeat,
    ACTIONS(495), 1,
      anon_sym_QMARK,
    ACTIONS(497), 1,
      anon_sym_TILDE,
    ACTIONS(505), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(507), 1,
      sym__number_literal,
    ACTIONS(509), 1,
      anon_sym_SQUOTE,
    ACTIONS(511), 1,
      anon_sym_DQUOTE,
    ACTIONS(521), 1,
      sym__raw_string_literal,
    ACTIONS(523), 1,
      sym__external_open_parenthesis,
    ACTIONS(525), 1,
      sym__external_open_brace,
    ACTIONS(8515), 1,
      anon_sym_BANG,
    ACTIONS(10141), 1,
      sym_dot_dot_i,
    ACTIONS(10143), 1,
      sym__newline,
    STATE(3), 1,
      sym__open_parenthesis,
    STATE(45), 1,
      sym__open_brace,
    STATE(2166), 1,
      sym_string,
    STATE(2200), 1,
      sym__single_quoted_string,
    STATE(2201), 1,
      sym__double_quoted_string,
    STATE(3524), 1,
      aux_sym_function_definition_repeat1,
    STATE(5154), 1,
      sym__string_or_identifier,
    ACTIONS(501), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2206), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(515), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10139), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(817), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [59598] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      sym_identifier,
    ACTIONS(483), 1,
      anon_sym_BSLASH,
    ACTIONS(485), 1,
      anon_sym_function,
    ACTIONS(487), 1,
      anon_sym_if,
    ACTIONS(489), 1,
      anon_sym_for,
    ACTIONS(491), 1,
      anon_sym_while,
    ACTIONS(493), 1,
      anon_sym_repeat,
    ACTIONS(495), 1,
      anon_sym_QMARK,
    ACTIONS(497), 1,
      anon_sym_TILDE,
    ACTIONS(505), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(507), 1,
      sym__number_literal,
    ACTIONS(509), 1,
      anon_sym_SQUOTE,
    ACTIONS(511), 1,
      anon_sym_DQUOTE,
    ACTIONS(521), 1,
      sym__raw_string_literal,
    ACTIONS(523), 1,
      sym__external_open_parenthesis,
    ACTIONS(525), 1,
      sym__external_open_brace,
    ACTIONS(8515), 1,
      anon_sym_BANG,
    ACTIONS(10147), 1,
      sym_dot_dot_i,
    ACTIONS(10149), 1,
      sym__newline,
    STATE(3), 1,
      sym__open_parenthesis,
    STATE(45), 1,
      sym__open_brace,
    STATE(2166), 1,
      sym_string,
    STATE(2200), 1,
      sym__single_quoted_string,
    STATE(2201), 1,
      sym__double_quoted_string,
    STATE(3526), 1,
      aux_sym_function_definition_repeat1,
    STATE(5154), 1,
      sym__string_or_identifier,
    ACTIONS(501), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2206), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(515), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10145), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(825), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [59727] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      sym_identifier,
    ACTIONS(483), 1,
      anon_sym_BSLASH,
    ACTIONS(485), 1,
      anon_sym_function,
    ACTIONS(487), 1,
      anon_sym_if,
    ACTIONS(489), 1,
      anon_sym_for,
    ACTIONS(491), 1,
      anon_sym_while,
    ACTIONS(493), 1,
      anon_sym_repeat,
    ACTIONS(495), 1,
      anon_sym_QMARK,
    ACTIONS(497), 1,
      anon_sym_TILDE,
    ACTIONS(505), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(507), 1,
      sym__number_literal,
    ACTIONS(509), 1,
      anon_sym_SQUOTE,
    ACTIONS(511), 1,
      anon_sym_DQUOTE,
    ACTIONS(521), 1,
      sym__raw_string_literal,
    ACTIONS(523), 1,
      sym__external_open_parenthesis,
    ACTIONS(525), 1,
      sym__external_open_brace,
    ACTIONS(8515), 1,
      anon_sym_BANG,
    ACTIONS(10153), 1,
      sym_dot_dot_i,
    ACTIONS(10155), 1,
      sym__newline,
    STATE(3), 1,
      sym__open_parenthesis,
    STATE(45), 1,
      sym__open_brace,
    STATE(2166), 1,
      sym_string,
    STATE(2200), 1,
      sym__single_quoted_string,
    STATE(2201), 1,
      sym__double_quoted_string,
    STATE(3528), 1,
      aux_sym_function_definition_repeat1,
    STATE(5154), 1,
      sym__string_or_identifier,
    ACTIONS(501), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2206), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(515), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10151), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(826), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [59856] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      sym_identifier,
    ACTIONS(483), 1,
      anon_sym_BSLASH,
    ACTIONS(485), 1,
      anon_sym_function,
    ACTIONS(487), 1,
      anon_sym_if,
    ACTIONS(489), 1,
      anon_sym_for,
    ACTIONS(491), 1,
      anon_sym_while,
    ACTIONS(493), 1,
      anon_sym_repeat,
    ACTIONS(495), 1,
      anon_sym_QMARK,
    ACTIONS(497), 1,
      anon_sym_TILDE,
    ACTIONS(505), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(507), 1,
      sym__number_literal,
    ACTIONS(509), 1,
      anon_sym_SQUOTE,
    ACTIONS(511), 1,
      anon_sym_DQUOTE,
    ACTIONS(521), 1,
      sym__raw_string_literal,
    ACTIONS(523), 1,
      sym__external_open_parenthesis,
    ACTIONS(525), 1,
      sym__external_open_brace,
    ACTIONS(8515), 1,
      anon_sym_BANG,
    ACTIONS(10159), 1,
      sym_dot_dot_i,
    ACTIONS(10161), 1,
      sym__newline,
    STATE(3), 1,
      sym__open_parenthesis,
    STATE(45), 1,
      sym__open_brace,
    STATE(2166), 1,
      sym_string,
    STATE(2200), 1,
      sym__single_quoted_string,
    STATE(2201), 1,
      sym__double_quoted_string,
    STATE(3530), 1,
      aux_sym_function_definition_repeat1,
    STATE(5154), 1,
      sym__string_or_identifier,
    ACTIONS(501), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2206), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(515), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10157), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(828), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [59985] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      sym_identifier,
    ACTIONS(483), 1,
      anon_sym_BSLASH,
    ACTIONS(485), 1,
      anon_sym_function,
    ACTIONS(487), 1,
      anon_sym_if,
    ACTIONS(489), 1,
      anon_sym_for,
    ACTIONS(491), 1,
      anon_sym_while,
    ACTIONS(493), 1,
      anon_sym_repeat,
    ACTIONS(495), 1,
      anon_sym_QMARK,
    ACTIONS(497), 1,
      anon_sym_TILDE,
    ACTIONS(505), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(507), 1,
      sym__number_literal,
    ACTIONS(509), 1,
      anon_sym_SQUOTE,
    ACTIONS(511), 1,
      anon_sym_DQUOTE,
    ACTIONS(521), 1,
      sym__raw_string_literal,
    ACTIONS(523), 1,
      sym__external_open_parenthesis,
    ACTIONS(525), 1,
      sym__external_open_brace,
    ACTIONS(8515), 1,
      anon_sym_BANG,
    ACTIONS(10165), 1,
      sym_dot_dot_i,
    ACTIONS(10167), 1,
      sym__newline,
    STATE(3), 1,
      sym__open_parenthesis,
    STATE(45), 1,
      sym__open_brace,
    STATE(2166), 1,
      sym_string,
    STATE(2200), 1,
      sym__single_quoted_string,
    STATE(2201), 1,
      sym__double_quoted_string,
    STATE(3532), 1,
      aux_sym_function_definition_repeat1,
    STATE(5154), 1,
      sym__string_or_identifier,
    ACTIONS(501), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2206), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(515), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10163), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(829), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [60114] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      sym_identifier,
    ACTIONS(483), 1,
      anon_sym_BSLASH,
    ACTIONS(485), 1,
      anon_sym_function,
    ACTIONS(487), 1,
      anon_sym_if,
    ACTIONS(489), 1,
      anon_sym_for,
    ACTIONS(491), 1,
      anon_sym_while,
    ACTIONS(493), 1,
      anon_sym_repeat,
    ACTIONS(495), 1,
      anon_sym_QMARK,
    ACTIONS(497), 1,
      anon_sym_TILDE,
    ACTIONS(505), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(507), 1,
      sym__number_literal,
    ACTIONS(509), 1,
      anon_sym_SQUOTE,
    ACTIONS(511), 1,
      anon_sym_DQUOTE,
    ACTIONS(521), 1,
      sym__raw_string_literal,
    ACTIONS(523), 1,
      sym__external_open_parenthesis,
    ACTIONS(525), 1,
      sym__external_open_brace,
    ACTIONS(8515), 1,
      anon_sym_BANG,
    ACTIONS(10171), 1,
      sym_dot_dot_i,
    ACTIONS(10173), 1,
      sym__newline,
    STATE(3), 1,
      sym__open_parenthesis,
    STATE(45), 1,
      sym__open_brace,
    STATE(2166), 1,
      sym_string,
    STATE(2200), 1,
      sym__single_quoted_string,
    STATE(2201), 1,
      sym__double_quoted_string,
    STATE(3534), 1,
      aux_sym_function_definition_repeat1,
    STATE(5154), 1,
      sym__string_or_identifier,
    ACTIONS(501), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2206), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(515), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10169), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(830), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [60243] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      sym_identifier,
    ACTIONS(483), 1,
      anon_sym_BSLASH,
    ACTIONS(485), 1,
      anon_sym_function,
    ACTIONS(487), 1,
      anon_sym_if,
    ACTIONS(489), 1,
      anon_sym_for,
    ACTIONS(491), 1,
      anon_sym_while,
    ACTIONS(493), 1,
      anon_sym_repeat,
    ACTIONS(495), 1,
      anon_sym_QMARK,
    ACTIONS(497), 1,
      anon_sym_TILDE,
    ACTIONS(505), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(507), 1,
      sym__number_literal,
    ACTIONS(509), 1,
      anon_sym_SQUOTE,
    ACTIONS(511), 1,
      anon_sym_DQUOTE,
    ACTIONS(521), 1,
      sym__raw_string_literal,
    ACTIONS(523), 1,
      sym__external_open_parenthesis,
    ACTIONS(525), 1,
      sym__external_open_brace,
    ACTIONS(8515), 1,
      anon_sym_BANG,
    ACTIONS(10177), 1,
      sym_dot_dot_i,
    ACTIONS(10179), 1,
      sym__newline,
    STATE(3), 1,
      sym__open_parenthesis,
    STATE(45), 1,
      sym__open_brace,
    STATE(2166), 1,
      sym_string,
    STATE(2200), 1,
      sym__single_quoted_string,
    STATE(2201), 1,
      sym__double_quoted_string,
    STATE(3536), 1,
      aux_sym_function_definition_repeat1,
    STATE(5154), 1,
      sym__string_or_identifier,
    ACTIONS(501), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2206), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(515), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10175), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(832), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [60372] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      sym_identifier,
    ACTIONS(483), 1,
      anon_sym_BSLASH,
    ACTIONS(485), 1,
      anon_sym_function,
    ACTIONS(487), 1,
      anon_sym_if,
    ACTIONS(489), 1,
      anon_sym_for,
    ACTIONS(491), 1,
      anon_sym_while,
    ACTIONS(493), 1,
      anon_sym_repeat,
    ACTIONS(495), 1,
      anon_sym_QMARK,
    ACTIONS(497), 1,
      anon_sym_TILDE,
    ACTIONS(505), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(507), 1,
      sym__number_literal,
    ACTIONS(509), 1,
      anon_sym_SQUOTE,
    ACTIONS(511), 1,
      anon_sym_DQUOTE,
    ACTIONS(521), 1,
      sym__raw_string_literal,
    ACTIONS(523), 1,
      sym__external_open_parenthesis,
    ACTIONS(525), 1,
      sym__external_open_brace,
    ACTIONS(8515), 1,
      anon_sym_BANG,
    ACTIONS(10183), 1,
      sym_dot_dot_i,
    ACTIONS(10185), 1,
      sym__newline,
    STATE(3), 1,
      sym__open_parenthesis,
    STATE(45), 1,
      sym__open_brace,
    STATE(2166), 1,
      sym_string,
    STATE(2200), 1,
      sym__single_quoted_string,
    STATE(2201), 1,
      sym__double_quoted_string,
    STATE(3538), 1,
      aux_sym_function_definition_repeat1,
    STATE(5154), 1,
      sym__string_or_identifier,
    ACTIONS(501), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2206), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(515), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10181), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(835), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [60501] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      sym_identifier,
    ACTIONS(483), 1,
      anon_sym_BSLASH,
    ACTIONS(485), 1,
      anon_sym_function,
    ACTIONS(487), 1,
      anon_sym_if,
    ACTIONS(489), 1,
      anon_sym_for,
    ACTIONS(491), 1,
      anon_sym_while,
    ACTIONS(493), 1,
      anon_sym_repeat,
    ACTIONS(495), 1,
      anon_sym_QMARK,
    ACTIONS(497), 1,
      anon_sym_TILDE,
    ACTIONS(505), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(507), 1,
      sym__number_literal,
    ACTIONS(509), 1,
      anon_sym_SQUOTE,
    ACTIONS(511), 1,
      anon_sym_DQUOTE,
    ACTIONS(521), 1,
      sym__raw_string_literal,
    ACTIONS(523), 1,
      sym__external_open_parenthesis,
    ACTIONS(525), 1,
      sym__external_open_brace,
    ACTIONS(8515), 1,
      anon_sym_BANG,
    ACTIONS(10189), 1,
      sym_dot_dot_i,
    ACTIONS(10191), 1,
      sym__newline,
    STATE(3), 1,
      sym__open_parenthesis,
    STATE(45), 1,
      sym__open_brace,
    STATE(2166), 1,
      sym_string,
    STATE(2200), 1,
      sym__single_quoted_string,
    STATE(2201), 1,
      sym__double_quoted_string,
    STATE(3540), 1,
      aux_sym_function_definition_repeat1,
    STATE(5154), 1,
      sym__string_or_identifier,
    ACTIONS(501), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2206), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(515), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10187), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(836), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [60630] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      sym_identifier,
    ACTIONS(483), 1,
      anon_sym_BSLASH,
    ACTIONS(485), 1,
      anon_sym_function,
    ACTIONS(487), 1,
      anon_sym_if,
    ACTIONS(489), 1,
      anon_sym_for,
    ACTIONS(491), 1,
      anon_sym_while,
    ACTIONS(493), 1,
      anon_sym_repeat,
    ACTIONS(495), 1,
      anon_sym_QMARK,
    ACTIONS(497), 1,
      anon_sym_TILDE,
    ACTIONS(505), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(507), 1,
      sym__number_literal,
    ACTIONS(509), 1,
      anon_sym_SQUOTE,
    ACTIONS(511), 1,
      anon_sym_DQUOTE,
    ACTIONS(521), 1,
      sym__raw_string_literal,
    ACTIONS(523), 1,
      sym__external_open_parenthesis,
    ACTIONS(525), 1,
      sym__external_open_brace,
    ACTIONS(8515), 1,
      anon_sym_BANG,
    ACTIONS(10195), 1,
      sym_dot_dot_i,
    ACTIONS(10197), 1,
      sym__newline,
    STATE(3), 1,
      sym__open_parenthesis,
    STATE(45), 1,
      sym__open_brace,
    STATE(2166), 1,
      sym_string,
    STATE(2200), 1,
      sym__single_quoted_string,
    STATE(2201), 1,
      sym__double_quoted_string,
    STATE(3542), 1,
      aux_sym_function_definition_repeat1,
    STATE(5154), 1,
      sym__string_or_identifier,
    ACTIONS(501), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2206), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(515), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10193), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(837), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [60759] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      sym_identifier,
    ACTIONS(483), 1,
      anon_sym_BSLASH,
    ACTIONS(485), 1,
      anon_sym_function,
    ACTIONS(487), 1,
      anon_sym_if,
    ACTIONS(489), 1,
      anon_sym_for,
    ACTIONS(491), 1,
      anon_sym_while,
    ACTIONS(493), 1,
      anon_sym_repeat,
    ACTIONS(495), 1,
      anon_sym_QMARK,
    ACTIONS(497), 1,
      anon_sym_TILDE,
    ACTIONS(505), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(507), 1,
      sym__number_literal,
    ACTIONS(509), 1,
      anon_sym_SQUOTE,
    ACTIONS(511), 1,
      anon_sym_DQUOTE,
    ACTIONS(521), 1,
      sym__raw_string_literal,
    ACTIONS(523), 1,
      sym__external_open_parenthesis,
    ACTIONS(525), 1,
      sym__external_open_brace,
    ACTIONS(8515), 1,
      anon_sym_BANG,
    ACTIONS(10201), 1,
      sym_dot_dot_i,
    ACTIONS(10203), 1,
      sym__newline,
    STATE(3), 1,
      sym__open_parenthesis,
    STATE(45), 1,
      sym__open_brace,
    STATE(2166), 1,
      sym_string,
    STATE(2200), 1,
      sym__single_quoted_string,
    STATE(2201), 1,
      sym__double_quoted_string,
    STATE(3544), 1,
      aux_sym_function_definition_repeat1,
    STATE(5154), 1,
      sym__string_or_identifier,
    ACTIONS(501), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2206), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(515), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10199), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(838), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [60888] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(626), 1,
      sym_identifier,
    ACTIONS(628), 1,
      anon_sym_BSLASH,
    ACTIONS(630), 1,
      anon_sym_function,
    ACTIONS(632), 1,
      anon_sym_if,
    ACTIONS(634), 1,
      anon_sym_for,
    ACTIONS(636), 1,
      anon_sym_while,
    ACTIONS(638), 1,
      anon_sym_repeat,
    ACTIONS(640), 1,
      anon_sym_QMARK,
    ACTIONS(642), 1,
      anon_sym_TILDE,
    ACTIONS(650), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(652), 1,
      sym__number_literal,
    ACTIONS(654), 1,
      anon_sym_SQUOTE,
    ACTIONS(656), 1,
      anon_sym_DQUOTE,
    ACTIONS(666), 1,
      sym__raw_string_literal,
    ACTIONS(668), 1,
      sym__external_open_parenthesis,
    ACTIONS(670), 1,
      sym__external_open_brace,
    ACTIONS(7933), 1,
      anon_sym_BANG,
    ACTIONS(10207), 1,
      sym_dot_dot_i,
    ACTIONS(10209), 1,
      sym__newline,
    STATE(54), 1,
      sym__open_parenthesis,
    STATE(56), 1,
      sym__open_brace,
    STATE(2219), 1,
      sym_string,
    STATE(2221), 1,
      sym__single_quoted_string,
    STATE(2222), 1,
      sym__double_quoted_string,
    STATE(3642), 1,
      aux_sym_function_definition_repeat1,
    STATE(5140), 1,
      sym__string_or_identifier,
    ACTIONS(646), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2220), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(660), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10205), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(714), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [61017] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4214), 1,
      sym_identifier,
    ACTIONS(4216), 1,
      anon_sym_BSLASH,
    ACTIONS(4218), 1,
      anon_sym_function,
    ACTIONS(4220), 1,
      anon_sym_if,
    ACTIONS(4222), 1,
      anon_sym_for,
    ACTIONS(4224), 1,
      anon_sym_while,
    ACTIONS(4226), 1,
      anon_sym_repeat,
    ACTIONS(4228), 1,
      anon_sym_QMARK,
    ACTIONS(4230), 1,
      anon_sym_TILDE,
    ACTIONS(4238), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4240), 1,
      sym__number_literal,
    ACTIONS(4242), 1,
      anon_sym_SQUOTE,
    ACTIONS(4244), 1,
      anon_sym_DQUOTE,
    ACTIONS(4254), 1,
      sym__raw_string_literal,
    ACTIONS(4256), 1,
      sym__external_open_parenthesis,
    ACTIONS(4258), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9229), 1,
      anon_sym_BANG,
    ACTIONS(10213), 1,
      sym_dot_dot_i,
    STATE(51), 1,
      sym__open_brace,
    STATE(287), 1,
      sym__open_parenthesis,
    STATE(4674), 1,
      sym__single_quoted_string,
    STATE(4678), 1,
      sym__double_quoted_string,
    STATE(4681), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5129), 1,
      sym__string_or_identifier,
    ACTIONS(4234), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4680), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4248), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10211), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4397), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [61146] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(626), 1,
      sym_identifier,
    ACTIONS(628), 1,
      anon_sym_BSLASH,
    ACTIONS(630), 1,
      anon_sym_function,
    ACTIONS(632), 1,
      anon_sym_if,
    ACTIONS(634), 1,
      anon_sym_for,
    ACTIONS(636), 1,
      anon_sym_while,
    ACTIONS(638), 1,
      anon_sym_repeat,
    ACTIONS(640), 1,
      anon_sym_QMARK,
    ACTIONS(642), 1,
      anon_sym_TILDE,
    ACTIONS(650), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(652), 1,
      sym__number_literal,
    ACTIONS(654), 1,
      anon_sym_SQUOTE,
    ACTIONS(656), 1,
      anon_sym_DQUOTE,
    ACTIONS(666), 1,
      sym__raw_string_literal,
    ACTIONS(668), 1,
      sym__external_open_parenthesis,
    ACTIONS(670), 1,
      sym__external_open_brace,
    ACTIONS(7933), 1,
      anon_sym_BANG,
    ACTIONS(10217), 1,
      sym_dot_dot_i,
    ACTIONS(10219), 1,
      sym__newline,
    STATE(54), 1,
      sym__open_parenthesis,
    STATE(56), 1,
      sym__open_brace,
    STATE(2219), 1,
      sym_string,
    STATE(2221), 1,
      sym__single_quoted_string,
    STATE(2222), 1,
      sym__double_quoted_string,
    STATE(3644), 1,
      aux_sym_function_definition_repeat1,
    STATE(5140), 1,
      sym__string_or_identifier,
    ACTIONS(646), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2220), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(660), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10215), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(715), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [61275] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4214), 1,
      sym_identifier,
    ACTIONS(4216), 1,
      anon_sym_BSLASH,
    ACTIONS(4218), 1,
      anon_sym_function,
    ACTIONS(4220), 1,
      anon_sym_if,
    ACTIONS(4222), 1,
      anon_sym_for,
    ACTIONS(4224), 1,
      anon_sym_while,
    ACTIONS(4226), 1,
      anon_sym_repeat,
    ACTIONS(4228), 1,
      anon_sym_QMARK,
    ACTIONS(4230), 1,
      anon_sym_TILDE,
    ACTIONS(4238), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4240), 1,
      sym__number_literal,
    ACTIONS(4242), 1,
      anon_sym_SQUOTE,
    ACTIONS(4244), 1,
      anon_sym_DQUOTE,
    ACTIONS(4254), 1,
      sym__raw_string_literal,
    ACTIONS(4256), 1,
      sym__external_open_parenthesis,
    ACTIONS(4258), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9229), 1,
      anon_sym_BANG,
    ACTIONS(10223), 1,
      sym_dot_dot_i,
    STATE(51), 1,
      sym__open_brace,
    STATE(287), 1,
      sym__open_parenthesis,
    STATE(4674), 1,
      sym__single_quoted_string,
    STATE(4678), 1,
      sym__double_quoted_string,
    STATE(4681), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5129), 1,
      sym__string_or_identifier,
    ACTIONS(4234), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4680), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4248), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10221), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4398), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [61404] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(626), 1,
      sym_identifier,
    ACTIONS(628), 1,
      anon_sym_BSLASH,
    ACTIONS(630), 1,
      anon_sym_function,
    ACTIONS(632), 1,
      anon_sym_if,
    ACTIONS(634), 1,
      anon_sym_for,
    ACTIONS(636), 1,
      anon_sym_while,
    ACTIONS(638), 1,
      anon_sym_repeat,
    ACTIONS(640), 1,
      anon_sym_QMARK,
    ACTIONS(642), 1,
      anon_sym_TILDE,
    ACTIONS(650), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(652), 1,
      sym__number_literal,
    ACTIONS(654), 1,
      anon_sym_SQUOTE,
    ACTIONS(656), 1,
      anon_sym_DQUOTE,
    ACTIONS(666), 1,
      sym__raw_string_literal,
    ACTIONS(668), 1,
      sym__external_open_parenthesis,
    ACTIONS(670), 1,
      sym__external_open_brace,
    ACTIONS(7933), 1,
      anon_sym_BANG,
    ACTIONS(10227), 1,
      sym_dot_dot_i,
    ACTIONS(10229), 1,
      sym__newline,
    STATE(54), 1,
      sym__open_parenthesis,
    STATE(56), 1,
      sym__open_brace,
    STATE(2219), 1,
      sym_string,
    STATE(2221), 1,
      sym__single_quoted_string,
    STATE(2222), 1,
      sym__double_quoted_string,
    STATE(3646), 1,
      aux_sym_function_definition_repeat1,
    STATE(5140), 1,
      sym__string_or_identifier,
    ACTIONS(646), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2220), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(660), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10225), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(716), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [61533] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4214), 1,
      sym_identifier,
    ACTIONS(4216), 1,
      anon_sym_BSLASH,
    ACTIONS(4218), 1,
      anon_sym_function,
    ACTIONS(4220), 1,
      anon_sym_if,
    ACTIONS(4222), 1,
      anon_sym_for,
    ACTIONS(4224), 1,
      anon_sym_while,
    ACTIONS(4226), 1,
      anon_sym_repeat,
    ACTIONS(4228), 1,
      anon_sym_QMARK,
    ACTIONS(4230), 1,
      anon_sym_TILDE,
    ACTIONS(4238), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4240), 1,
      sym__number_literal,
    ACTIONS(4242), 1,
      anon_sym_SQUOTE,
    ACTIONS(4244), 1,
      anon_sym_DQUOTE,
    ACTIONS(4254), 1,
      sym__raw_string_literal,
    ACTIONS(4256), 1,
      sym__external_open_parenthesis,
    ACTIONS(4258), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9229), 1,
      anon_sym_BANG,
    ACTIONS(10233), 1,
      sym_dot_dot_i,
    STATE(51), 1,
      sym__open_brace,
    STATE(287), 1,
      sym__open_parenthesis,
    STATE(4674), 1,
      sym__single_quoted_string,
    STATE(4678), 1,
      sym__double_quoted_string,
    STATE(4681), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5129), 1,
      sym__string_or_identifier,
    ACTIONS(4234), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4680), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4248), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10231), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4399), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [61662] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(626), 1,
      sym_identifier,
    ACTIONS(628), 1,
      anon_sym_BSLASH,
    ACTIONS(630), 1,
      anon_sym_function,
    ACTIONS(632), 1,
      anon_sym_if,
    ACTIONS(634), 1,
      anon_sym_for,
    ACTIONS(636), 1,
      anon_sym_while,
    ACTIONS(638), 1,
      anon_sym_repeat,
    ACTIONS(640), 1,
      anon_sym_QMARK,
    ACTIONS(642), 1,
      anon_sym_TILDE,
    ACTIONS(650), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(652), 1,
      sym__number_literal,
    ACTIONS(654), 1,
      anon_sym_SQUOTE,
    ACTIONS(656), 1,
      anon_sym_DQUOTE,
    ACTIONS(666), 1,
      sym__raw_string_literal,
    ACTIONS(668), 1,
      sym__external_open_parenthesis,
    ACTIONS(670), 1,
      sym__external_open_brace,
    ACTIONS(7933), 1,
      anon_sym_BANG,
    ACTIONS(10237), 1,
      sym_dot_dot_i,
    ACTIONS(10239), 1,
      sym__newline,
    STATE(54), 1,
      sym__open_parenthesis,
    STATE(56), 1,
      sym__open_brace,
    STATE(2219), 1,
      sym_string,
    STATE(2221), 1,
      sym__single_quoted_string,
    STATE(2222), 1,
      sym__double_quoted_string,
    STATE(3648), 1,
      aux_sym_function_definition_repeat1,
    STATE(5140), 1,
      sym__string_or_identifier,
    ACTIONS(646), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2220), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(660), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10235), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(717), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [61791] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2943), 1,
      sym_identifier,
    ACTIONS(2945), 1,
      anon_sym_BSLASH,
    ACTIONS(2947), 1,
      anon_sym_function,
    ACTIONS(2949), 1,
      anon_sym_if,
    ACTIONS(2951), 1,
      anon_sym_for,
    ACTIONS(2953), 1,
      anon_sym_while,
    ACTIONS(2955), 1,
      anon_sym_repeat,
    ACTIONS(2957), 1,
      anon_sym_QMARK,
    ACTIONS(2959), 1,
      anon_sym_TILDE,
    ACTIONS(2967), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2969), 1,
      sym__number_literal,
    ACTIONS(2971), 1,
      anon_sym_SQUOTE,
    ACTIONS(2973), 1,
      anon_sym_DQUOTE,
    ACTIONS(2983), 1,
      sym__raw_string_literal,
    ACTIONS(2985), 1,
      sym__external_open_parenthesis,
    ACTIONS(2989), 1,
      sym__external_open_brace,
    ACTIONS(7797), 1,
      anon_sym_BANG,
    ACTIONS(10243), 1,
      sym_dot_dot_i,
    ACTIONS(10245), 1,
      sym__newline,
    STATE(173), 1,
      sym__open_brace,
    STATE(246), 1,
      sym__open_parenthesis,
    STATE(2462), 1,
      sym__single_quoted_string,
    STATE(2494), 1,
      sym__double_quoted_string,
    STATE(2541), 1,
      sym_string,
    STATE(3144), 1,
      aux_sym_function_definition_repeat1,
    STATE(5128), 1,
      sym__string_or_identifier,
    ACTIONS(2963), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2540), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2977), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10241), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1575), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [61920] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4214), 1,
      sym_identifier,
    ACTIONS(4216), 1,
      anon_sym_BSLASH,
    ACTIONS(4218), 1,
      anon_sym_function,
    ACTIONS(4220), 1,
      anon_sym_if,
    ACTIONS(4222), 1,
      anon_sym_for,
    ACTIONS(4224), 1,
      anon_sym_while,
    ACTIONS(4226), 1,
      anon_sym_repeat,
    ACTIONS(4228), 1,
      anon_sym_QMARK,
    ACTIONS(4230), 1,
      anon_sym_TILDE,
    ACTIONS(4238), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4240), 1,
      sym__number_literal,
    ACTIONS(4242), 1,
      anon_sym_SQUOTE,
    ACTIONS(4244), 1,
      anon_sym_DQUOTE,
    ACTIONS(4254), 1,
      sym__raw_string_literal,
    ACTIONS(4256), 1,
      sym__external_open_parenthesis,
    ACTIONS(4258), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9229), 1,
      anon_sym_BANG,
    ACTIONS(10249), 1,
      sym_dot_dot_i,
    STATE(51), 1,
      sym__open_brace,
    STATE(287), 1,
      sym__open_parenthesis,
    STATE(4674), 1,
      sym__single_quoted_string,
    STATE(4678), 1,
      sym__double_quoted_string,
    STATE(4681), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5129), 1,
      sym__string_or_identifier,
    ACTIONS(4234), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4680), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4248), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10247), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4409), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [62049] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3678), 1,
      sym_identifier,
    ACTIONS(3680), 1,
      anon_sym_BSLASH,
    ACTIONS(3682), 1,
      anon_sym_function,
    ACTIONS(3684), 1,
      anon_sym_if,
    ACTIONS(3686), 1,
      anon_sym_for,
    ACTIONS(3688), 1,
      anon_sym_while,
    ACTIONS(3690), 1,
      anon_sym_repeat,
    ACTIONS(3692), 1,
      anon_sym_QMARK,
    ACTIONS(3694), 1,
      anon_sym_TILDE,
    ACTIONS(3702), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3704), 1,
      sym__number_literal,
    ACTIONS(3706), 1,
      anon_sym_SQUOTE,
    ACTIONS(3708), 1,
      anon_sym_DQUOTE,
    ACTIONS(3718), 1,
      sym__raw_string_literal,
    ACTIONS(3720), 1,
      sym__external_open_parenthesis,
    ACTIONS(3722), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8593), 1,
      anon_sym_BANG,
    ACTIONS(10253), 1,
      sym_dot_dot_i,
    STATE(29), 1,
      sym__open_brace,
    STATE(191), 1,
      sym__open_parenthesis,
    STATE(2378), 1,
      sym_string,
    STATE(2382), 1,
      sym__single_quoted_string,
    STATE(2383), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5153), 1,
      sym__string_or_identifier,
    ACTIONS(3698), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2381), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3712), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10251), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1159), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [62178] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4214), 1,
      sym_identifier,
    ACTIONS(4216), 1,
      anon_sym_BSLASH,
    ACTIONS(4218), 1,
      anon_sym_function,
    ACTIONS(4220), 1,
      anon_sym_if,
    ACTIONS(4222), 1,
      anon_sym_for,
    ACTIONS(4224), 1,
      anon_sym_while,
    ACTIONS(4226), 1,
      anon_sym_repeat,
    ACTIONS(4228), 1,
      anon_sym_QMARK,
    ACTIONS(4230), 1,
      anon_sym_TILDE,
    ACTIONS(4238), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4240), 1,
      sym__number_literal,
    ACTIONS(4242), 1,
      anon_sym_SQUOTE,
    ACTIONS(4244), 1,
      anon_sym_DQUOTE,
    ACTIONS(4254), 1,
      sym__raw_string_literal,
    ACTIONS(4256), 1,
      sym__external_open_parenthesis,
    ACTIONS(4258), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9229), 1,
      anon_sym_BANG,
    ACTIONS(10257), 1,
      sym_dot_dot_i,
    STATE(51), 1,
      sym__open_brace,
    STATE(287), 1,
      sym__open_parenthesis,
    STATE(4674), 1,
      sym__single_quoted_string,
    STATE(4678), 1,
      sym__double_quoted_string,
    STATE(4681), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5129), 1,
      sym__string_or_identifier,
    ACTIONS(4234), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4680), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4248), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10255), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4402), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [62307] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3678), 1,
      sym_identifier,
    ACTIONS(3680), 1,
      anon_sym_BSLASH,
    ACTIONS(3682), 1,
      anon_sym_function,
    ACTIONS(3684), 1,
      anon_sym_if,
    ACTIONS(3686), 1,
      anon_sym_for,
    ACTIONS(3688), 1,
      anon_sym_while,
    ACTIONS(3690), 1,
      anon_sym_repeat,
    ACTIONS(3692), 1,
      anon_sym_QMARK,
    ACTIONS(3694), 1,
      anon_sym_TILDE,
    ACTIONS(3702), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3704), 1,
      sym__number_literal,
    ACTIONS(3706), 1,
      anon_sym_SQUOTE,
    ACTIONS(3708), 1,
      anon_sym_DQUOTE,
    ACTIONS(3718), 1,
      sym__raw_string_literal,
    ACTIONS(3720), 1,
      sym__external_open_parenthesis,
    ACTIONS(3722), 1,
      sym__external_open_brace,
    ACTIONS(8593), 1,
      anon_sym_BANG,
    ACTIONS(10261), 1,
      sym_dot_dot_i,
    ACTIONS(10263), 1,
      sym__newline,
    STATE(29), 1,
      sym__open_brace,
    STATE(191), 1,
      sym__open_parenthesis,
    STATE(2378), 1,
      sym_string,
    STATE(2382), 1,
      sym__single_quoted_string,
    STATE(2383), 1,
      sym__double_quoted_string,
    STATE(3509), 1,
      aux_sym_function_definition_repeat1,
    STATE(5153), 1,
      sym__string_or_identifier,
    ACTIONS(3698), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2381), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3712), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10259), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1151), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [62436] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3678), 1,
      sym_identifier,
    ACTIONS(3680), 1,
      anon_sym_BSLASH,
    ACTIONS(3682), 1,
      anon_sym_function,
    ACTIONS(3684), 1,
      anon_sym_if,
    ACTIONS(3686), 1,
      anon_sym_for,
    ACTIONS(3688), 1,
      anon_sym_while,
    ACTIONS(3690), 1,
      anon_sym_repeat,
    ACTIONS(3692), 1,
      anon_sym_QMARK,
    ACTIONS(3694), 1,
      anon_sym_TILDE,
    ACTIONS(3702), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3704), 1,
      sym__number_literal,
    ACTIONS(3706), 1,
      anon_sym_SQUOTE,
    ACTIONS(3708), 1,
      anon_sym_DQUOTE,
    ACTIONS(3718), 1,
      sym__raw_string_literal,
    ACTIONS(3720), 1,
      sym__external_open_parenthesis,
    ACTIONS(3722), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8593), 1,
      anon_sym_BANG,
    ACTIONS(10267), 1,
      sym_dot_dot_i,
    STATE(29), 1,
      sym__open_brace,
    STATE(191), 1,
      sym__open_parenthesis,
    STATE(2378), 1,
      sym_string,
    STATE(2382), 1,
      sym__single_quoted_string,
    STATE(2383), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5153), 1,
      sym__string_or_identifier,
    ACTIONS(3698), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2381), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3712), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10265), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1150), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [62565] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4214), 1,
      sym_identifier,
    ACTIONS(4216), 1,
      anon_sym_BSLASH,
    ACTIONS(4218), 1,
      anon_sym_function,
    ACTIONS(4220), 1,
      anon_sym_if,
    ACTIONS(4222), 1,
      anon_sym_for,
    ACTIONS(4224), 1,
      anon_sym_while,
    ACTIONS(4226), 1,
      anon_sym_repeat,
    ACTIONS(4228), 1,
      anon_sym_QMARK,
    ACTIONS(4230), 1,
      anon_sym_TILDE,
    ACTIONS(4238), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4240), 1,
      sym__number_literal,
    ACTIONS(4242), 1,
      anon_sym_SQUOTE,
    ACTIONS(4244), 1,
      anon_sym_DQUOTE,
    ACTIONS(4254), 1,
      sym__raw_string_literal,
    ACTIONS(4256), 1,
      sym__external_open_parenthesis,
    ACTIONS(4258), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9229), 1,
      anon_sym_BANG,
    ACTIONS(10271), 1,
      sym_dot_dot_i,
    STATE(51), 1,
      sym__open_brace,
    STATE(287), 1,
      sym__open_parenthesis,
    STATE(4674), 1,
      sym__single_quoted_string,
    STATE(4678), 1,
      sym__double_quoted_string,
    STATE(4681), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5129), 1,
      sym__string_or_identifier,
    ACTIONS(4234), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4680), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4248), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10269), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4413), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [62694] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2531), 1,
      sym_identifier,
    ACTIONS(2533), 1,
      anon_sym_BSLASH,
    ACTIONS(2535), 1,
      anon_sym_function,
    ACTIONS(2537), 1,
      anon_sym_if,
    ACTIONS(2539), 1,
      anon_sym_for,
    ACTIONS(2541), 1,
      anon_sym_while,
    ACTIONS(2543), 1,
      anon_sym_repeat,
    ACTIONS(2545), 1,
      anon_sym_QMARK,
    ACTIONS(2547), 1,
      anon_sym_TILDE,
    ACTIONS(2555), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2557), 1,
      sym__number_literal,
    ACTIONS(2559), 1,
      anon_sym_SQUOTE,
    ACTIONS(2561), 1,
      anon_sym_DQUOTE,
    ACTIONS(2571), 1,
      sym__raw_string_literal,
    ACTIONS(2573), 1,
      sym__external_open_parenthesis,
    ACTIONS(2577), 1,
      sym__external_open_brace,
    ACTIONS(9611), 1,
      anon_sym_BANG,
    ACTIONS(10275), 1,
      sym_dot_dot_i,
    ACTIONS(10277), 1,
      sym__newline,
    STATE(70), 1,
      sym__open_brace,
    STATE(213), 1,
      sym__open_parenthesis,
    STATE(2437), 1,
      sym__double_quoted_string,
    STATE(2442), 1,
      sym__single_quoted_string,
    STATE(2530), 1,
      sym_string,
    STATE(3471), 1,
      aux_sym_function_definition_repeat1,
    STATE(5133), 1,
      sym__string_or_identifier,
    ACTIONS(2551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2445), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2565), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10273), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1349), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [62823] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2531), 1,
      sym_identifier,
    ACTIONS(2533), 1,
      anon_sym_BSLASH,
    ACTIONS(2535), 1,
      anon_sym_function,
    ACTIONS(2537), 1,
      anon_sym_if,
    ACTIONS(2539), 1,
      anon_sym_for,
    ACTIONS(2541), 1,
      anon_sym_while,
    ACTIONS(2543), 1,
      anon_sym_repeat,
    ACTIONS(2545), 1,
      anon_sym_QMARK,
    ACTIONS(2547), 1,
      anon_sym_TILDE,
    ACTIONS(2555), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2557), 1,
      sym__number_literal,
    ACTIONS(2559), 1,
      anon_sym_SQUOTE,
    ACTIONS(2561), 1,
      anon_sym_DQUOTE,
    ACTIONS(2571), 1,
      sym__raw_string_literal,
    ACTIONS(2573), 1,
      sym__external_open_parenthesis,
    ACTIONS(2577), 1,
      sym__external_open_brace,
    ACTIONS(9611), 1,
      anon_sym_BANG,
    ACTIONS(10281), 1,
      sym_dot_dot_i,
    ACTIONS(10283), 1,
      sym__newline,
    STATE(70), 1,
      sym__open_brace,
    STATE(213), 1,
      sym__open_parenthesis,
    STATE(2437), 1,
      sym__double_quoted_string,
    STATE(2442), 1,
      sym__single_quoted_string,
    STATE(2530), 1,
      sym_string,
    STATE(3473), 1,
      aux_sym_function_definition_repeat1,
    STATE(5133), 1,
      sym__string_or_identifier,
    ACTIONS(2551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2445), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2565), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10279), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1347), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [62952] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2531), 1,
      sym_identifier,
    ACTIONS(2533), 1,
      anon_sym_BSLASH,
    ACTIONS(2535), 1,
      anon_sym_function,
    ACTIONS(2537), 1,
      anon_sym_if,
    ACTIONS(2539), 1,
      anon_sym_for,
    ACTIONS(2541), 1,
      anon_sym_while,
    ACTIONS(2543), 1,
      anon_sym_repeat,
    ACTIONS(2545), 1,
      anon_sym_QMARK,
    ACTIONS(2547), 1,
      anon_sym_TILDE,
    ACTIONS(2555), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2557), 1,
      sym__number_literal,
    ACTIONS(2559), 1,
      anon_sym_SQUOTE,
    ACTIONS(2561), 1,
      anon_sym_DQUOTE,
    ACTIONS(2571), 1,
      sym__raw_string_literal,
    ACTIONS(2573), 1,
      sym__external_open_parenthesis,
    ACTIONS(2577), 1,
      sym__external_open_brace,
    ACTIONS(9611), 1,
      anon_sym_BANG,
    ACTIONS(10287), 1,
      sym_dot_dot_i,
    ACTIONS(10289), 1,
      sym__newline,
    STATE(70), 1,
      sym__open_brace,
    STATE(213), 1,
      sym__open_parenthesis,
    STATE(2437), 1,
      sym__double_quoted_string,
    STATE(2442), 1,
      sym__single_quoted_string,
    STATE(2530), 1,
      sym_string,
    STATE(3475), 1,
      aux_sym_function_definition_repeat1,
    STATE(5133), 1,
      sym__string_or_identifier,
    ACTIONS(2551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2445), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2565), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10285), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1345), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [63081] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2531), 1,
      sym_identifier,
    ACTIONS(2533), 1,
      anon_sym_BSLASH,
    ACTIONS(2535), 1,
      anon_sym_function,
    ACTIONS(2537), 1,
      anon_sym_if,
    ACTIONS(2539), 1,
      anon_sym_for,
    ACTIONS(2541), 1,
      anon_sym_while,
    ACTIONS(2543), 1,
      anon_sym_repeat,
    ACTIONS(2545), 1,
      anon_sym_QMARK,
    ACTIONS(2547), 1,
      anon_sym_TILDE,
    ACTIONS(2555), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2557), 1,
      sym__number_literal,
    ACTIONS(2559), 1,
      anon_sym_SQUOTE,
    ACTIONS(2561), 1,
      anon_sym_DQUOTE,
    ACTIONS(2571), 1,
      sym__raw_string_literal,
    ACTIONS(2573), 1,
      sym__external_open_parenthesis,
    ACTIONS(2577), 1,
      sym__external_open_brace,
    ACTIONS(9611), 1,
      anon_sym_BANG,
    ACTIONS(10293), 1,
      sym_dot_dot_i,
    ACTIONS(10295), 1,
      sym__newline,
    STATE(70), 1,
      sym__open_brace,
    STATE(213), 1,
      sym__open_parenthesis,
    STATE(2437), 1,
      sym__double_quoted_string,
    STATE(2442), 1,
      sym__single_quoted_string,
    STATE(2530), 1,
      sym_string,
    STATE(3477), 1,
      aux_sym_function_definition_repeat1,
    STATE(5133), 1,
      sym__string_or_identifier,
    ACTIONS(2551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2445), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2565), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10291), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1343), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [63210] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(10299), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10297), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4453), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [63339] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3678), 1,
      sym_identifier,
    ACTIONS(3680), 1,
      anon_sym_BSLASH,
    ACTIONS(3682), 1,
      anon_sym_function,
    ACTIONS(3684), 1,
      anon_sym_if,
    ACTIONS(3686), 1,
      anon_sym_for,
    ACTIONS(3688), 1,
      anon_sym_while,
    ACTIONS(3690), 1,
      anon_sym_repeat,
    ACTIONS(3692), 1,
      anon_sym_QMARK,
    ACTIONS(3694), 1,
      anon_sym_TILDE,
    ACTIONS(3702), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3704), 1,
      sym__number_literal,
    ACTIONS(3706), 1,
      anon_sym_SQUOTE,
    ACTIONS(3708), 1,
      anon_sym_DQUOTE,
    ACTIONS(3718), 1,
      sym__raw_string_literal,
    ACTIONS(3720), 1,
      sym__external_open_parenthesis,
    ACTIONS(3722), 1,
      sym__external_open_brace,
    ACTIONS(8593), 1,
      anon_sym_BANG,
    ACTIONS(10303), 1,
      sym_dot_dot_i,
    ACTIONS(10305), 1,
      sym__newline,
    STATE(29), 1,
      sym__open_brace,
    STATE(191), 1,
      sym__open_parenthesis,
    STATE(2378), 1,
      sym_string,
    STATE(2382), 1,
      sym__single_quoted_string,
    STATE(2383), 1,
      sym__double_quoted_string,
    STATE(3512), 1,
      aux_sym_function_definition_repeat1,
    STATE(5153), 1,
      sym__string_or_identifier,
    ACTIONS(3698), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2381), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3712), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10301), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1145), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [63468] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      sym_identifier,
    ACTIONS(483), 1,
      anon_sym_BSLASH,
    ACTIONS(485), 1,
      anon_sym_function,
    ACTIONS(487), 1,
      anon_sym_if,
    ACTIONS(489), 1,
      anon_sym_for,
    ACTIONS(491), 1,
      anon_sym_while,
    ACTIONS(493), 1,
      anon_sym_repeat,
    ACTIONS(495), 1,
      anon_sym_QMARK,
    ACTIONS(497), 1,
      anon_sym_TILDE,
    ACTIONS(505), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(507), 1,
      sym__number_literal,
    ACTIONS(509), 1,
      anon_sym_SQUOTE,
    ACTIONS(511), 1,
      anon_sym_DQUOTE,
    ACTIONS(521), 1,
      sym__raw_string_literal,
    ACTIONS(523), 1,
      sym__external_open_parenthesis,
    ACTIONS(525), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8515), 1,
      anon_sym_BANG,
    ACTIONS(10309), 1,
      sym_dot_dot_i,
    STATE(3), 1,
      sym__open_parenthesis,
    STATE(45), 1,
      sym__open_brace,
    STATE(2166), 1,
      sym_string,
    STATE(2200), 1,
      sym__single_quoted_string,
    STATE(2201), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5154), 1,
      sym__string_or_identifier,
    ACTIONS(501), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2206), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(515), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10307), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(841), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [63597] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(626), 1,
      sym_identifier,
    ACTIONS(628), 1,
      anon_sym_BSLASH,
    ACTIONS(630), 1,
      anon_sym_function,
    ACTIONS(632), 1,
      anon_sym_if,
    ACTIONS(634), 1,
      anon_sym_for,
    ACTIONS(636), 1,
      anon_sym_while,
    ACTIONS(638), 1,
      anon_sym_repeat,
    ACTIONS(640), 1,
      anon_sym_QMARK,
    ACTIONS(642), 1,
      anon_sym_TILDE,
    ACTIONS(650), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(652), 1,
      sym__number_literal,
    ACTIONS(654), 1,
      anon_sym_SQUOTE,
    ACTIONS(656), 1,
      anon_sym_DQUOTE,
    ACTIONS(666), 1,
      sym__raw_string_literal,
    ACTIONS(668), 1,
      sym__external_open_parenthesis,
    ACTIONS(670), 1,
      sym__external_open_brace,
    ACTIONS(7933), 1,
      anon_sym_BANG,
    ACTIONS(10313), 1,
      sym_dot_dot_i,
    ACTIONS(10315), 1,
      sym__newline,
    STATE(54), 1,
      sym__open_parenthesis,
    STATE(56), 1,
      sym__open_brace,
    STATE(2219), 1,
      sym_string,
    STATE(2221), 1,
      sym__single_quoted_string,
    STATE(2222), 1,
      sym__double_quoted_string,
    STATE(3656), 1,
      aux_sym_function_definition_repeat1,
    STATE(5140), 1,
      sym__string_or_identifier,
    ACTIONS(646), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2220), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(660), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10311), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(718), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [63726] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      sym_identifier,
    ACTIONS(483), 1,
      anon_sym_BSLASH,
    ACTIONS(485), 1,
      anon_sym_function,
    ACTIONS(487), 1,
      anon_sym_if,
    ACTIONS(489), 1,
      anon_sym_for,
    ACTIONS(491), 1,
      anon_sym_while,
    ACTIONS(493), 1,
      anon_sym_repeat,
    ACTIONS(495), 1,
      anon_sym_QMARK,
    ACTIONS(497), 1,
      anon_sym_TILDE,
    ACTIONS(505), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(507), 1,
      sym__number_literal,
    ACTIONS(509), 1,
      anon_sym_SQUOTE,
    ACTIONS(511), 1,
      anon_sym_DQUOTE,
    ACTIONS(521), 1,
      sym__raw_string_literal,
    ACTIONS(523), 1,
      sym__external_open_parenthesis,
    ACTIONS(525), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8515), 1,
      anon_sym_BANG,
    ACTIONS(10319), 1,
      sym_dot_dot_i,
    STATE(3), 1,
      sym__open_parenthesis,
    STATE(45), 1,
      sym__open_brace,
    STATE(2166), 1,
      sym_string,
    STATE(2200), 1,
      sym__single_quoted_string,
    STATE(2201), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5154), 1,
      sym__string_or_identifier,
    ACTIONS(501), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2206), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(515), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10317), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(842), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [63855] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(10323), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10321), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4452), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [63984] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      sym_identifier,
    ACTIONS(483), 1,
      anon_sym_BSLASH,
    ACTIONS(485), 1,
      anon_sym_function,
    ACTIONS(487), 1,
      anon_sym_if,
    ACTIONS(489), 1,
      anon_sym_for,
    ACTIONS(491), 1,
      anon_sym_while,
    ACTIONS(493), 1,
      anon_sym_repeat,
    ACTIONS(495), 1,
      anon_sym_QMARK,
    ACTIONS(497), 1,
      anon_sym_TILDE,
    ACTIONS(505), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(507), 1,
      sym__number_literal,
    ACTIONS(509), 1,
      anon_sym_SQUOTE,
    ACTIONS(511), 1,
      anon_sym_DQUOTE,
    ACTIONS(521), 1,
      sym__raw_string_literal,
    ACTIONS(523), 1,
      sym__external_open_parenthesis,
    ACTIONS(525), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8515), 1,
      anon_sym_BANG,
    ACTIONS(10327), 1,
      sym_dot_dot_i,
    STATE(3), 1,
      sym__open_parenthesis,
    STATE(45), 1,
      sym__open_brace,
    STATE(2166), 1,
      sym_string,
    STATE(2200), 1,
      sym__single_quoted_string,
    STATE(2201), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5154), 1,
      sym__string_or_identifier,
    ACTIONS(501), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2206), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(515), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10325), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(843), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [64113] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(321), 1,
      sym_identifier,
    ACTIONS(323), 1,
      anon_sym_BSLASH,
    ACTIONS(325), 1,
      anon_sym_function,
    ACTIONS(327), 1,
      anon_sym_if,
    ACTIONS(329), 1,
      anon_sym_for,
    ACTIONS(331), 1,
      anon_sym_while,
    ACTIONS(333), 1,
      anon_sym_repeat,
    ACTIONS(335), 1,
      anon_sym_QMARK,
    ACTIONS(337), 1,
      anon_sym_TILDE,
    ACTIONS(345), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(347), 1,
      sym__number_literal,
    ACTIONS(349), 1,
      anon_sym_SQUOTE,
    ACTIONS(351), 1,
      anon_sym_DQUOTE,
    ACTIONS(361), 1,
      sym__raw_string_literal,
    ACTIONS(363), 1,
      sym__external_open_parenthesis,
    ACTIONS(365), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(10329), 1,
      anon_sym_BANG,
    ACTIONS(10333), 1,
      sym_dot_dot_i,
    STATE(24), 1,
      sym__open_brace,
    STATE(67), 1,
      sym__open_parenthesis,
    STATE(2169), 1,
      sym_string,
    STATE(2180), 1,
      sym__double_quoted_string,
    STATE(2181), 1,
      sym__single_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5149), 1,
      sym__string_or_identifier,
    ACTIONS(341), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2183), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(355), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10331), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(858), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [64242] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      sym_identifier,
    ACTIONS(483), 1,
      anon_sym_BSLASH,
    ACTIONS(485), 1,
      anon_sym_function,
    ACTIONS(487), 1,
      anon_sym_if,
    ACTIONS(489), 1,
      anon_sym_for,
    ACTIONS(491), 1,
      anon_sym_while,
    ACTIONS(493), 1,
      anon_sym_repeat,
    ACTIONS(495), 1,
      anon_sym_QMARK,
    ACTIONS(497), 1,
      anon_sym_TILDE,
    ACTIONS(505), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(507), 1,
      sym__number_literal,
    ACTIONS(509), 1,
      anon_sym_SQUOTE,
    ACTIONS(511), 1,
      anon_sym_DQUOTE,
    ACTIONS(521), 1,
      sym__raw_string_literal,
    ACTIONS(523), 1,
      sym__external_open_parenthesis,
    ACTIONS(525), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8515), 1,
      anon_sym_BANG,
    ACTIONS(10337), 1,
      sym_dot_dot_i,
    STATE(3), 1,
      sym__open_parenthesis,
    STATE(45), 1,
      sym__open_brace,
    STATE(2166), 1,
      sym_string,
    STATE(2200), 1,
      sym__single_quoted_string,
    STATE(2201), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5154), 1,
      sym__string_or_identifier,
    ACTIONS(501), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2206), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(515), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10335), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(844), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [64371] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(626), 1,
      sym_identifier,
    ACTIONS(628), 1,
      anon_sym_BSLASH,
    ACTIONS(630), 1,
      anon_sym_function,
    ACTIONS(632), 1,
      anon_sym_if,
    ACTIONS(634), 1,
      anon_sym_for,
    ACTIONS(636), 1,
      anon_sym_while,
    ACTIONS(638), 1,
      anon_sym_repeat,
    ACTIONS(640), 1,
      anon_sym_QMARK,
    ACTIONS(642), 1,
      anon_sym_TILDE,
    ACTIONS(650), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(652), 1,
      sym__number_literal,
    ACTIONS(654), 1,
      anon_sym_SQUOTE,
    ACTIONS(656), 1,
      anon_sym_DQUOTE,
    ACTIONS(666), 1,
      sym__raw_string_literal,
    ACTIONS(668), 1,
      sym__external_open_parenthesis,
    ACTIONS(670), 1,
      sym__external_open_brace,
    ACTIONS(7933), 1,
      anon_sym_BANG,
    ACTIONS(10341), 1,
      sym_dot_dot_i,
    ACTIONS(10343), 1,
      sym__newline,
    STATE(54), 1,
      sym__open_parenthesis,
    STATE(56), 1,
      sym__open_brace,
    STATE(2219), 1,
      sym_string,
    STATE(2221), 1,
      sym__single_quoted_string,
    STATE(2222), 1,
      sym__double_quoted_string,
    STATE(3684), 1,
      aux_sym_function_definition_repeat1,
    STATE(5140), 1,
      sym__string_or_identifier,
    ACTIONS(646), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2220), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(660), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10339), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(719), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [64500] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      sym_identifier,
    ACTIONS(483), 1,
      anon_sym_BSLASH,
    ACTIONS(485), 1,
      anon_sym_function,
    ACTIONS(487), 1,
      anon_sym_if,
    ACTIONS(489), 1,
      anon_sym_for,
    ACTIONS(491), 1,
      anon_sym_while,
    ACTIONS(493), 1,
      anon_sym_repeat,
    ACTIONS(495), 1,
      anon_sym_QMARK,
    ACTIONS(497), 1,
      anon_sym_TILDE,
    ACTIONS(505), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(507), 1,
      sym__number_literal,
    ACTIONS(509), 1,
      anon_sym_SQUOTE,
    ACTIONS(511), 1,
      anon_sym_DQUOTE,
    ACTIONS(521), 1,
      sym__raw_string_literal,
    ACTIONS(523), 1,
      sym__external_open_parenthesis,
    ACTIONS(525), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8515), 1,
      anon_sym_BANG,
    ACTIONS(10347), 1,
      sym_dot_dot_i,
    STATE(3), 1,
      sym__open_parenthesis,
    STATE(45), 1,
      sym__open_brace,
    STATE(2166), 1,
      sym_string,
    STATE(2200), 1,
      sym__single_quoted_string,
    STATE(2201), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5154), 1,
      sym__string_or_identifier,
    ACTIONS(501), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2206), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(515), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10345), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(861), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [64629] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(626), 1,
      sym_identifier,
    ACTIONS(628), 1,
      anon_sym_BSLASH,
    ACTIONS(630), 1,
      anon_sym_function,
    ACTIONS(632), 1,
      anon_sym_if,
    ACTIONS(634), 1,
      anon_sym_for,
    ACTIONS(636), 1,
      anon_sym_while,
    ACTIONS(638), 1,
      anon_sym_repeat,
    ACTIONS(640), 1,
      anon_sym_QMARK,
    ACTIONS(642), 1,
      anon_sym_TILDE,
    ACTIONS(650), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(652), 1,
      sym__number_literal,
    ACTIONS(654), 1,
      anon_sym_SQUOTE,
    ACTIONS(656), 1,
      anon_sym_DQUOTE,
    ACTIONS(666), 1,
      sym__raw_string_literal,
    ACTIONS(668), 1,
      sym__external_open_parenthesis,
    ACTIONS(670), 1,
      sym__external_open_brace,
    ACTIONS(7933), 1,
      anon_sym_BANG,
    ACTIONS(10351), 1,
      sym_dot_dot_i,
    ACTIONS(10353), 1,
      sym__newline,
    STATE(54), 1,
      sym__open_parenthesis,
    STATE(56), 1,
      sym__open_brace,
    STATE(2219), 1,
      sym_string,
    STATE(2221), 1,
      sym__single_quoted_string,
    STATE(2222), 1,
      sym__double_quoted_string,
    STATE(3686), 1,
      aux_sym_function_definition_repeat1,
    STATE(5140), 1,
      sym__string_or_identifier,
    ACTIONS(646), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2220), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(660), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10349), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(720), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [64758] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      sym_identifier,
    ACTIONS(483), 1,
      anon_sym_BSLASH,
    ACTIONS(485), 1,
      anon_sym_function,
    ACTIONS(487), 1,
      anon_sym_if,
    ACTIONS(489), 1,
      anon_sym_for,
    ACTIONS(491), 1,
      anon_sym_while,
    ACTIONS(493), 1,
      anon_sym_repeat,
    ACTIONS(495), 1,
      anon_sym_QMARK,
    ACTIONS(497), 1,
      anon_sym_TILDE,
    ACTIONS(505), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(507), 1,
      sym__number_literal,
    ACTIONS(509), 1,
      anon_sym_SQUOTE,
    ACTIONS(511), 1,
      anon_sym_DQUOTE,
    ACTIONS(521), 1,
      sym__raw_string_literal,
    ACTIONS(523), 1,
      sym__external_open_parenthesis,
    ACTIONS(525), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8515), 1,
      anon_sym_BANG,
    ACTIONS(10357), 1,
      sym_dot_dot_i,
    STATE(3), 1,
      sym__open_parenthesis,
    STATE(45), 1,
      sym__open_brace,
    STATE(2166), 1,
      sym_string,
    STATE(2200), 1,
      sym__single_quoted_string,
    STATE(2201), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5154), 1,
      sym__string_or_identifier,
    ACTIONS(501), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2206), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(515), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10355), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(862), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [64887] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(626), 1,
      sym_identifier,
    ACTIONS(628), 1,
      anon_sym_BSLASH,
    ACTIONS(630), 1,
      anon_sym_function,
    ACTIONS(632), 1,
      anon_sym_if,
    ACTIONS(634), 1,
      anon_sym_for,
    ACTIONS(636), 1,
      anon_sym_while,
    ACTIONS(638), 1,
      anon_sym_repeat,
    ACTIONS(640), 1,
      anon_sym_QMARK,
    ACTIONS(642), 1,
      anon_sym_TILDE,
    ACTIONS(650), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(652), 1,
      sym__number_literal,
    ACTIONS(654), 1,
      anon_sym_SQUOTE,
    ACTIONS(656), 1,
      anon_sym_DQUOTE,
    ACTIONS(666), 1,
      sym__raw_string_literal,
    ACTIONS(668), 1,
      sym__external_open_parenthesis,
    ACTIONS(670), 1,
      sym__external_open_brace,
    ACTIONS(7933), 1,
      anon_sym_BANG,
    ACTIONS(10361), 1,
      sym_dot_dot_i,
    ACTIONS(10363), 1,
      sym__newline,
    STATE(54), 1,
      sym__open_parenthesis,
    STATE(56), 1,
      sym__open_brace,
    STATE(2219), 1,
      sym_string,
    STATE(2221), 1,
      sym__single_quoted_string,
    STATE(2222), 1,
      sym__double_quoted_string,
    STATE(3621), 1,
      aux_sym_function_definition_repeat1,
    STATE(5140), 1,
      sym__string_or_identifier,
    ACTIONS(646), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2220), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(660), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10359), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(712), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [65016] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      sym_identifier,
    ACTIONS(483), 1,
      anon_sym_BSLASH,
    ACTIONS(485), 1,
      anon_sym_function,
    ACTIONS(487), 1,
      anon_sym_if,
    ACTIONS(489), 1,
      anon_sym_for,
    ACTIONS(491), 1,
      anon_sym_while,
    ACTIONS(493), 1,
      anon_sym_repeat,
    ACTIONS(495), 1,
      anon_sym_QMARK,
    ACTIONS(497), 1,
      anon_sym_TILDE,
    ACTIONS(505), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(507), 1,
      sym__number_literal,
    ACTIONS(509), 1,
      anon_sym_SQUOTE,
    ACTIONS(511), 1,
      anon_sym_DQUOTE,
    ACTIONS(521), 1,
      sym__raw_string_literal,
    ACTIONS(523), 1,
      sym__external_open_parenthesis,
    ACTIONS(525), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8515), 1,
      anon_sym_BANG,
    ACTIONS(10367), 1,
      sym_dot_dot_i,
    STATE(3), 1,
      sym__open_parenthesis,
    STATE(45), 1,
      sym__open_brace,
    STATE(2166), 1,
      sym_string,
    STATE(2200), 1,
      sym__single_quoted_string,
    STATE(2201), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5154), 1,
      sym__string_or_identifier,
    ACTIONS(501), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2206), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(515), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10365), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(865), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [65145] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3491), 1,
      sym_identifier,
    ACTIONS(3493), 1,
      anon_sym_BSLASH,
    ACTIONS(3495), 1,
      anon_sym_function,
    ACTIONS(3497), 1,
      anon_sym_if,
    ACTIONS(3499), 1,
      anon_sym_for,
    ACTIONS(3501), 1,
      anon_sym_while,
    ACTIONS(3503), 1,
      anon_sym_repeat,
    ACTIONS(3505), 1,
      anon_sym_QMARK,
    ACTIONS(3507), 1,
      anon_sym_TILDE,
    ACTIONS(3515), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3517), 1,
      sym__number_literal,
    ACTIONS(3519), 1,
      anon_sym_SQUOTE,
    ACTIONS(3521), 1,
      anon_sym_DQUOTE,
    ACTIONS(3531), 1,
      sym__raw_string_literal,
    ACTIONS(3533), 1,
      sym__external_open_parenthesis,
    ACTIONS(3535), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7789), 1,
      anon_sym_BANG,
    ACTIONS(10371), 1,
      sym_dot_dot_i,
    STATE(63), 1,
      sym__open_brace,
    STATE(147), 1,
      sym__open_parenthesis,
    STATE(2441), 1,
      sym_string,
    STATE(2456), 1,
      sym__single_quoted_string,
    STATE(2478), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5130), 1,
      sym__string_or_identifier,
    ACTIONS(3511), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2448), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3525), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10369), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1008), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [65274] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      sym_identifier,
    ACTIONS(483), 1,
      anon_sym_BSLASH,
    ACTIONS(485), 1,
      anon_sym_function,
    ACTIONS(487), 1,
      anon_sym_if,
    ACTIONS(489), 1,
      anon_sym_for,
    ACTIONS(491), 1,
      anon_sym_while,
    ACTIONS(493), 1,
      anon_sym_repeat,
    ACTIONS(495), 1,
      anon_sym_QMARK,
    ACTIONS(497), 1,
      anon_sym_TILDE,
    ACTIONS(505), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(507), 1,
      sym__number_literal,
    ACTIONS(509), 1,
      anon_sym_SQUOTE,
    ACTIONS(511), 1,
      anon_sym_DQUOTE,
    ACTIONS(521), 1,
      sym__raw_string_literal,
    ACTIONS(523), 1,
      sym__external_open_parenthesis,
    ACTIONS(525), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8515), 1,
      anon_sym_BANG,
    ACTIONS(10375), 1,
      sym_dot_dot_i,
    STATE(3), 1,
      sym__open_parenthesis,
    STATE(45), 1,
      sym__open_brace,
    STATE(2166), 1,
      sym_string,
    STATE(2200), 1,
      sym__single_quoted_string,
    STATE(2201), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5154), 1,
      sym__string_or_identifier,
    ACTIONS(501), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2206), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(515), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10373), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(866), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [65403] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3491), 1,
      sym_identifier,
    ACTIONS(3493), 1,
      anon_sym_BSLASH,
    ACTIONS(3495), 1,
      anon_sym_function,
    ACTIONS(3497), 1,
      anon_sym_if,
    ACTIONS(3499), 1,
      anon_sym_for,
    ACTIONS(3501), 1,
      anon_sym_while,
    ACTIONS(3503), 1,
      anon_sym_repeat,
    ACTIONS(3505), 1,
      anon_sym_QMARK,
    ACTIONS(3507), 1,
      anon_sym_TILDE,
    ACTIONS(3515), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3517), 1,
      sym__number_literal,
    ACTIONS(3519), 1,
      anon_sym_SQUOTE,
    ACTIONS(3521), 1,
      anon_sym_DQUOTE,
    ACTIONS(3531), 1,
      sym__raw_string_literal,
    ACTIONS(3533), 1,
      sym__external_open_parenthesis,
    ACTIONS(3535), 1,
      sym__external_open_brace,
    ACTIONS(7789), 1,
      anon_sym_BANG,
    ACTIONS(10379), 1,
      sym_dot_dot_i,
    ACTIONS(10381), 1,
      sym__newline,
    STATE(63), 1,
      sym__open_brace,
    STATE(147), 1,
      sym__open_parenthesis,
    STATE(2441), 1,
      sym_string,
    STATE(2456), 1,
      sym__single_quoted_string,
    STATE(2478), 1,
      sym__double_quoted_string,
    STATE(3533), 1,
      aux_sym_function_definition_repeat1,
    STATE(5130), 1,
      sym__string_or_identifier,
    ACTIONS(3511), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2448), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3525), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10377), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1000), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [65532] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      sym_identifier,
    ACTIONS(483), 1,
      anon_sym_BSLASH,
    ACTIONS(485), 1,
      anon_sym_function,
    ACTIONS(487), 1,
      anon_sym_if,
    ACTIONS(489), 1,
      anon_sym_for,
    ACTIONS(491), 1,
      anon_sym_while,
    ACTIONS(493), 1,
      anon_sym_repeat,
    ACTIONS(495), 1,
      anon_sym_QMARK,
    ACTIONS(497), 1,
      anon_sym_TILDE,
    ACTIONS(505), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(507), 1,
      sym__number_literal,
    ACTIONS(509), 1,
      anon_sym_SQUOTE,
    ACTIONS(511), 1,
      anon_sym_DQUOTE,
    ACTIONS(521), 1,
      sym__raw_string_literal,
    ACTIONS(523), 1,
      sym__external_open_parenthesis,
    ACTIONS(525), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8515), 1,
      anon_sym_BANG,
    ACTIONS(10385), 1,
      sym_dot_dot_i,
    STATE(3), 1,
      sym__open_parenthesis,
    STATE(45), 1,
      sym__open_brace,
    STATE(2166), 1,
      sym_string,
    STATE(2200), 1,
      sym__single_quoted_string,
    STATE(2201), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5154), 1,
      sym__string_or_identifier,
    ACTIONS(501), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2206), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(515), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10383), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(867), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [65661] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3491), 1,
      sym_identifier,
    ACTIONS(3493), 1,
      anon_sym_BSLASH,
    ACTIONS(3495), 1,
      anon_sym_function,
    ACTIONS(3497), 1,
      anon_sym_if,
    ACTIONS(3499), 1,
      anon_sym_for,
    ACTIONS(3501), 1,
      anon_sym_while,
    ACTIONS(3503), 1,
      anon_sym_repeat,
    ACTIONS(3505), 1,
      anon_sym_QMARK,
    ACTIONS(3507), 1,
      anon_sym_TILDE,
    ACTIONS(3515), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3517), 1,
      sym__number_literal,
    ACTIONS(3519), 1,
      anon_sym_SQUOTE,
    ACTIONS(3521), 1,
      anon_sym_DQUOTE,
    ACTIONS(3531), 1,
      sym__raw_string_literal,
    ACTIONS(3533), 1,
      sym__external_open_parenthesis,
    ACTIONS(3535), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7789), 1,
      anon_sym_BANG,
    ACTIONS(10389), 1,
      sym_dot_dot_i,
    STATE(63), 1,
      sym__open_brace,
    STATE(147), 1,
      sym__open_parenthesis,
    STATE(2441), 1,
      sym_string,
    STATE(2456), 1,
      sym__single_quoted_string,
    STATE(2478), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5130), 1,
      sym__string_or_identifier,
    ACTIONS(3511), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2448), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3525), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10387), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(999), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [65790] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      sym_identifier,
    ACTIONS(483), 1,
      anon_sym_BSLASH,
    ACTIONS(485), 1,
      anon_sym_function,
    ACTIONS(487), 1,
      anon_sym_if,
    ACTIONS(489), 1,
      anon_sym_for,
    ACTIONS(491), 1,
      anon_sym_while,
    ACTIONS(493), 1,
      anon_sym_repeat,
    ACTIONS(495), 1,
      anon_sym_QMARK,
    ACTIONS(497), 1,
      anon_sym_TILDE,
    ACTIONS(505), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(507), 1,
      sym__number_literal,
    ACTIONS(509), 1,
      anon_sym_SQUOTE,
    ACTIONS(511), 1,
      anon_sym_DQUOTE,
    ACTIONS(521), 1,
      sym__raw_string_literal,
    ACTIONS(523), 1,
      sym__external_open_parenthesis,
    ACTIONS(525), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8515), 1,
      anon_sym_BANG,
    ACTIONS(10393), 1,
      sym_dot_dot_i,
    STATE(3), 1,
      sym__open_parenthesis,
    STATE(45), 1,
      sym__open_brace,
    STATE(2166), 1,
      sym_string,
    STATE(2200), 1,
      sym__single_quoted_string,
    STATE(2201), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5154), 1,
      sym__string_or_identifier,
    ACTIONS(501), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2206), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(515), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10391), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(868), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [65919] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(10397), 1,
      sym_dot_dot_i,
    ACTIONS(10399), 1,
      sym__newline,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(3885), 1,
      aux_sym_function_definition_repeat1,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10395), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4451), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [66048] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      sym_identifier,
    ACTIONS(483), 1,
      anon_sym_BSLASH,
    ACTIONS(485), 1,
      anon_sym_function,
    ACTIONS(487), 1,
      anon_sym_if,
    ACTIONS(489), 1,
      anon_sym_for,
    ACTIONS(491), 1,
      anon_sym_while,
    ACTIONS(493), 1,
      anon_sym_repeat,
    ACTIONS(495), 1,
      anon_sym_QMARK,
    ACTIONS(497), 1,
      anon_sym_TILDE,
    ACTIONS(505), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(507), 1,
      sym__number_literal,
    ACTIONS(509), 1,
      anon_sym_SQUOTE,
    ACTIONS(511), 1,
      anon_sym_DQUOTE,
    ACTIONS(521), 1,
      sym__raw_string_literal,
    ACTIONS(523), 1,
      sym__external_open_parenthesis,
    ACTIONS(525), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8515), 1,
      anon_sym_BANG,
    ACTIONS(10403), 1,
      sym_dot_dot_i,
    STATE(3), 1,
      sym__open_parenthesis,
    STATE(45), 1,
      sym__open_brace,
    STATE(2166), 1,
      sym_string,
    STATE(2200), 1,
      sym__single_quoted_string,
    STATE(2201), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5154), 1,
      sym__string_or_identifier,
    ACTIONS(501), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2206), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(515), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10401), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(869), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [66177] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(10407), 1,
      sym_dot_dot_i,
    ACTIONS(10409), 1,
      sym__newline,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(3893), 1,
      aux_sym_function_definition_repeat1,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10405), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4447), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [66306] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      sym_identifier,
    ACTIONS(483), 1,
      anon_sym_BSLASH,
    ACTIONS(485), 1,
      anon_sym_function,
    ACTIONS(487), 1,
      anon_sym_if,
    ACTIONS(489), 1,
      anon_sym_for,
    ACTIONS(491), 1,
      anon_sym_while,
    ACTIONS(493), 1,
      anon_sym_repeat,
    ACTIONS(495), 1,
      anon_sym_QMARK,
    ACTIONS(497), 1,
      anon_sym_TILDE,
    ACTIONS(505), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(507), 1,
      sym__number_literal,
    ACTIONS(509), 1,
      anon_sym_SQUOTE,
    ACTIONS(511), 1,
      anon_sym_DQUOTE,
    ACTIONS(521), 1,
      sym__raw_string_literal,
    ACTIONS(523), 1,
      sym__external_open_parenthesis,
    ACTIONS(525), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8515), 1,
      anon_sym_BANG,
    ACTIONS(10413), 1,
      sym_dot_dot_i,
    STATE(3), 1,
      sym__open_parenthesis,
    STATE(45), 1,
      sym__open_brace,
    STATE(2166), 1,
      sym_string,
    STATE(2200), 1,
      sym__single_quoted_string,
    STATE(2201), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5154), 1,
      sym__string_or_identifier,
    ACTIONS(501), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2206), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(515), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10411), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(874), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [66435] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(10417), 1,
      sym_dot_dot_i,
    ACTIONS(10419), 1,
      sym__newline,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(3914), 1,
      aux_sym_function_definition_repeat1,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10415), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4442), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [66564] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      sym_identifier,
    ACTIONS(483), 1,
      anon_sym_BSLASH,
    ACTIONS(485), 1,
      anon_sym_function,
    ACTIONS(487), 1,
      anon_sym_if,
    ACTIONS(489), 1,
      anon_sym_for,
    ACTIONS(491), 1,
      anon_sym_while,
    ACTIONS(493), 1,
      anon_sym_repeat,
    ACTIONS(495), 1,
      anon_sym_QMARK,
    ACTIONS(497), 1,
      anon_sym_TILDE,
    ACTIONS(505), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(507), 1,
      sym__number_literal,
    ACTIONS(509), 1,
      anon_sym_SQUOTE,
    ACTIONS(511), 1,
      anon_sym_DQUOTE,
    ACTIONS(521), 1,
      sym__raw_string_literal,
    ACTIONS(523), 1,
      sym__external_open_parenthesis,
    ACTIONS(525), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8515), 1,
      anon_sym_BANG,
    ACTIONS(10423), 1,
      sym_dot_dot_i,
    STATE(3), 1,
      sym__open_parenthesis,
    STATE(45), 1,
      sym__open_brace,
    STATE(2166), 1,
      sym_string,
    STATE(2200), 1,
      sym__single_quoted_string,
    STATE(2201), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5154), 1,
      sym__string_or_identifier,
    ACTIONS(501), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2206), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(515), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10421), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(875), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [66693] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4214), 1,
      sym_identifier,
    ACTIONS(4216), 1,
      anon_sym_BSLASH,
    ACTIONS(4218), 1,
      anon_sym_function,
    ACTIONS(4220), 1,
      anon_sym_if,
    ACTIONS(4222), 1,
      anon_sym_for,
    ACTIONS(4224), 1,
      anon_sym_while,
    ACTIONS(4226), 1,
      anon_sym_repeat,
    ACTIONS(4228), 1,
      anon_sym_QMARK,
    ACTIONS(4230), 1,
      anon_sym_TILDE,
    ACTIONS(4238), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4240), 1,
      sym__number_literal,
    ACTIONS(4242), 1,
      anon_sym_SQUOTE,
    ACTIONS(4244), 1,
      anon_sym_DQUOTE,
    ACTIONS(4254), 1,
      sym__raw_string_literal,
    ACTIONS(4256), 1,
      sym__external_open_parenthesis,
    ACTIONS(4258), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9229), 1,
      anon_sym_BANG,
    ACTIONS(10427), 1,
      sym_dot_dot_i,
    STATE(51), 1,
      sym__open_brace,
    STATE(287), 1,
      sym__open_parenthesis,
    STATE(4674), 1,
      sym__single_quoted_string,
    STATE(4678), 1,
      sym__double_quoted_string,
    STATE(4681), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5129), 1,
      sym__string_or_identifier,
    ACTIONS(4234), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4680), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4248), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10425), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4416), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [66822] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3491), 1,
      sym_identifier,
    ACTIONS(3493), 1,
      anon_sym_BSLASH,
    ACTIONS(3495), 1,
      anon_sym_function,
    ACTIONS(3497), 1,
      anon_sym_if,
    ACTIONS(3499), 1,
      anon_sym_for,
    ACTIONS(3501), 1,
      anon_sym_while,
    ACTIONS(3503), 1,
      anon_sym_repeat,
    ACTIONS(3505), 1,
      anon_sym_QMARK,
    ACTIONS(3507), 1,
      anon_sym_TILDE,
    ACTIONS(3515), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3517), 1,
      sym__number_literal,
    ACTIONS(3519), 1,
      anon_sym_SQUOTE,
    ACTIONS(3521), 1,
      anon_sym_DQUOTE,
    ACTIONS(3531), 1,
      sym__raw_string_literal,
    ACTIONS(3533), 1,
      sym__external_open_parenthesis,
    ACTIONS(3535), 1,
      sym__external_open_brace,
    ACTIONS(7789), 1,
      anon_sym_BANG,
    ACTIONS(10431), 1,
      sym_dot_dot_i,
    ACTIONS(10433), 1,
      sym__newline,
    STATE(63), 1,
      sym__open_brace,
    STATE(147), 1,
      sym__open_parenthesis,
    STATE(2441), 1,
      sym_string,
    STATE(2456), 1,
      sym__single_quoted_string,
    STATE(2478), 1,
      sym__double_quoted_string,
    STATE(3537), 1,
      aux_sym_function_definition_repeat1,
    STATE(5130), 1,
      sym__string_or_identifier,
    ACTIONS(3511), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2448), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3525), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10429), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(994), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [66951] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(626), 1,
      sym_identifier,
    ACTIONS(628), 1,
      anon_sym_BSLASH,
    ACTIONS(630), 1,
      anon_sym_function,
    ACTIONS(632), 1,
      anon_sym_if,
    ACTIONS(634), 1,
      anon_sym_for,
    ACTIONS(636), 1,
      anon_sym_while,
    ACTIONS(638), 1,
      anon_sym_repeat,
    ACTIONS(640), 1,
      anon_sym_QMARK,
    ACTIONS(642), 1,
      anon_sym_TILDE,
    ACTIONS(650), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(652), 1,
      sym__number_literal,
    ACTIONS(654), 1,
      anon_sym_SQUOTE,
    ACTIONS(656), 1,
      anon_sym_DQUOTE,
    ACTIONS(666), 1,
      sym__raw_string_literal,
    ACTIONS(668), 1,
      sym__external_open_parenthesis,
    ACTIONS(670), 1,
      sym__external_open_brace,
    ACTIONS(7933), 1,
      anon_sym_BANG,
    ACTIONS(10437), 1,
      sym_dot_dot_i,
    ACTIONS(10439), 1,
      sym__newline,
    STATE(54), 1,
      sym__open_parenthesis,
    STATE(56), 1,
      sym__open_brace,
    STATE(2219), 1,
      sym_string,
    STATE(2221), 1,
      sym__single_quoted_string,
    STATE(2222), 1,
      sym__double_quoted_string,
    STATE(3691), 1,
      aux_sym_function_definition_repeat1,
    STATE(5140), 1,
      sym__string_or_identifier,
    ACTIONS(646), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2220), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(660), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10435), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(722), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [67080] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4214), 1,
      sym_identifier,
    ACTIONS(4216), 1,
      anon_sym_BSLASH,
    ACTIONS(4218), 1,
      anon_sym_function,
    ACTIONS(4220), 1,
      anon_sym_if,
    ACTIONS(4222), 1,
      anon_sym_for,
    ACTIONS(4224), 1,
      anon_sym_while,
    ACTIONS(4226), 1,
      anon_sym_repeat,
    ACTIONS(4228), 1,
      anon_sym_QMARK,
    ACTIONS(4230), 1,
      anon_sym_TILDE,
    ACTIONS(4238), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4240), 1,
      sym__number_literal,
    ACTIONS(4242), 1,
      anon_sym_SQUOTE,
    ACTIONS(4244), 1,
      anon_sym_DQUOTE,
    ACTIONS(4254), 1,
      sym__raw_string_literal,
    ACTIONS(4256), 1,
      sym__external_open_parenthesis,
    ACTIONS(4258), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9229), 1,
      anon_sym_BANG,
    ACTIONS(10443), 1,
      sym_dot_dot_i,
    STATE(51), 1,
      sym__open_brace,
    STATE(287), 1,
      sym__open_parenthesis,
    STATE(4674), 1,
      sym__single_quoted_string,
    STATE(4678), 1,
      sym__double_quoted_string,
    STATE(4681), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5129), 1,
      sym__string_or_identifier,
    ACTIONS(4234), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4680), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4248), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10441), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4417), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [67209] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(10447), 1,
      sym_dot_dot_i,
    ACTIONS(10449), 1,
      sym__newline,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(3950), 1,
      aux_sym_function_definition_repeat1,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10445), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4444), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [67338] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(626), 1,
      sym_identifier,
    ACTIONS(628), 1,
      anon_sym_BSLASH,
    ACTIONS(630), 1,
      anon_sym_function,
    ACTIONS(632), 1,
      anon_sym_if,
    ACTIONS(634), 1,
      anon_sym_for,
    ACTIONS(636), 1,
      anon_sym_while,
    ACTIONS(638), 1,
      anon_sym_repeat,
    ACTIONS(640), 1,
      anon_sym_QMARK,
    ACTIONS(642), 1,
      anon_sym_TILDE,
    ACTIONS(650), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(652), 1,
      sym__number_literal,
    ACTIONS(654), 1,
      anon_sym_SQUOTE,
    ACTIONS(656), 1,
      anon_sym_DQUOTE,
    ACTIONS(666), 1,
      sym__raw_string_literal,
    ACTIONS(668), 1,
      sym__external_open_parenthesis,
    ACTIONS(670), 1,
      sym__external_open_brace,
    ACTIONS(7933), 1,
      anon_sym_BANG,
    ACTIONS(10453), 1,
      sym_dot_dot_i,
    ACTIONS(10455), 1,
      sym__newline,
    STATE(54), 1,
      sym__open_parenthesis,
    STATE(56), 1,
      sym__open_brace,
    STATE(2219), 1,
      sym_string,
    STATE(2221), 1,
      sym__single_quoted_string,
    STATE(2222), 1,
      sym__double_quoted_string,
    STATE(3694), 1,
      aux_sym_function_definition_repeat1,
    STATE(5140), 1,
      sym__string_or_identifier,
    ACTIONS(646), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2220), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(660), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10451), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(724), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [67467] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(10459), 1,
      sym_dot_dot_i,
    ACTIONS(10461), 1,
      sym__newline,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(3959), 1,
      aux_sym_function_definition_repeat1,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10457), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4438), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [67596] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4214), 1,
      sym_identifier,
    ACTIONS(4216), 1,
      anon_sym_BSLASH,
    ACTIONS(4218), 1,
      anon_sym_function,
    ACTIONS(4220), 1,
      anon_sym_if,
    ACTIONS(4222), 1,
      anon_sym_for,
    ACTIONS(4224), 1,
      anon_sym_while,
    ACTIONS(4226), 1,
      anon_sym_repeat,
    ACTIONS(4228), 1,
      anon_sym_QMARK,
    ACTIONS(4230), 1,
      anon_sym_TILDE,
    ACTIONS(4238), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4240), 1,
      sym__number_literal,
    ACTIONS(4242), 1,
      anon_sym_SQUOTE,
    ACTIONS(4244), 1,
      anon_sym_DQUOTE,
    ACTIONS(4254), 1,
      sym__raw_string_literal,
    ACTIONS(4256), 1,
      sym__external_open_parenthesis,
    ACTIONS(4258), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9229), 1,
      anon_sym_BANG,
    ACTIONS(10465), 1,
      sym_dot_dot_i,
    STATE(51), 1,
      sym__open_brace,
    STATE(287), 1,
      sym__open_parenthesis,
    STATE(4674), 1,
      sym__single_quoted_string,
    STATE(4678), 1,
      sym__double_quoted_string,
    STATE(4681), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5129), 1,
      sym__string_or_identifier,
    ACTIONS(4234), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4680), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4248), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10463), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4427), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [67725] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2425), 1,
      sym_identifier,
    ACTIONS(2427), 1,
      anon_sym_BSLASH,
    ACTIONS(2429), 1,
      anon_sym_function,
    ACTIONS(2431), 1,
      anon_sym_if,
    ACTIONS(2433), 1,
      anon_sym_for,
    ACTIONS(2435), 1,
      anon_sym_while,
    ACTIONS(2437), 1,
      anon_sym_repeat,
    ACTIONS(2439), 1,
      anon_sym_QMARK,
    ACTIONS(2441), 1,
      anon_sym_TILDE,
    ACTIONS(2449), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2451), 1,
      sym__number_literal,
    ACTIONS(2453), 1,
      anon_sym_SQUOTE,
    ACTIONS(2455), 1,
      anon_sym_DQUOTE,
    ACTIONS(2465), 1,
      sym__raw_string_literal,
    ACTIONS(2467), 1,
      sym__external_open_parenthesis,
    ACTIONS(2471), 1,
      sym__external_open_brace,
    ACTIONS(7781), 1,
      anon_sym_BANG,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(10469), 1,
      sym_dot_dot_i,
    STATE(97), 1,
      sym__open_brace,
    STATE(200), 1,
      sym__open_parenthesis,
    STATE(2369), 1,
      sym__double_quoted_string,
    STATE(2370), 1,
      sym__single_quoted_string,
    STATE(2372), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5138), 1,
      sym__string_or_identifier,
    ACTIONS(2445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2371), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10467), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1280), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [67854] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2425), 1,
      sym_identifier,
    ACTIONS(2427), 1,
      anon_sym_BSLASH,
    ACTIONS(2429), 1,
      anon_sym_function,
    ACTIONS(2431), 1,
      anon_sym_if,
    ACTIONS(2433), 1,
      anon_sym_for,
    ACTIONS(2435), 1,
      anon_sym_while,
    ACTIONS(2437), 1,
      anon_sym_repeat,
    ACTIONS(2439), 1,
      anon_sym_QMARK,
    ACTIONS(2441), 1,
      anon_sym_TILDE,
    ACTIONS(2449), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2451), 1,
      sym__number_literal,
    ACTIONS(2453), 1,
      anon_sym_SQUOTE,
    ACTIONS(2455), 1,
      anon_sym_DQUOTE,
    ACTIONS(2465), 1,
      sym__raw_string_literal,
    ACTIONS(2467), 1,
      sym__external_open_parenthesis,
    ACTIONS(2471), 1,
      sym__external_open_brace,
    ACTIONS(7781), 1,
      anon_sym_BANG,
    ACTIONS(10473), 1,
      sym_dot_dot_i,
    ACTIONS(10475), 1,
      sym__newline,
    STATE(97), 1,
      sym__open_brace,
    STATE(200), 1,
      sym__open_parenthesis,
    STATE(2369), 1,
      sym__double_quoted_string,
    STATE(2370), 1,
      sym__single_quoted_string,
    STATE(2372), 1,
      sym_string,
    STATE(3553), 1,
      aux_sym_function_definition_repeat1,
    STATE(5138), 1,
      sym__string_or_identifier,
    ACTIONS(2445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2371), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10471), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1287), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [67983] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(10479), 1,
      sym_dot_dot_i,
    ACTIONS(10481), 1,
      sym__newline,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4033), 1,
      aux_sym_function_definition_repeat1,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10477), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4463), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [68112] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2425), 1,
      sym_identifier,
    ACTIONS(2427), 1,
      anon_sym_BSLASH,
    ACTIONS(2429), 1,
      anon_sym_function,
    ACTIONS(2431), 1,
      anon_sym_if,
    ACTIONS(2433), 1,
      anon_sym_for,
    ACTIONS(2435), 1,
      anon_sym_while,
    ACTIONS(2437), 1,
      anon_sym_repeat,
    ACTIONS(2439), 1,
      anon_sym_QMARK,
    ACTIONS(2441), 1,
      anon_sym_TILDE,
    ACTIONS(2449), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2451), 1,
      sym__number_literal,
    ACTIONS(2453), 1,
      anon_sym_SQUOTE,
    ACTIONS(2455), 1,
      anon_sym_DQUOTE,
    ACTIONS(2465), 1,
      sym__raw_string_literal,
    ACTIONS(2467), 1,
      sym__external_open_parenthesis,
    ACTIONS(2471), 1,
      sym__external_open_brace,
    ACTIONS(7781), 1,
      anon_sym_BANG,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(10485), 1,
      sym_dot_dot_i,
    STATE(97), 1,
      sym__open_brace,
    STATE(200), 1,
      sym__open_parenthesis,
    STATE(2369), 1,
      sym__double_quoted_string,
    STATE(2370), 1,
      sym__single_quoted_string,
    STATE(2372), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5138), 1,
      sym__string_or_identifier,
    ACTIONS(2445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2371), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10483), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1288), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [68241] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2425), 1,
      sym_identifier,
    ACTIONS(2427), 1,
      anon_sym_BSLASH,
    ACTIONS(2429), 1,
      anon_sym_function,
    ACTIONS(2431), 1,
      anon_sym_if,
    ACTIONS(2433), 1,
      anon_sym_for,
    ACTIONS(2435), 1,
      anon_sym_while,
    ACTIONS(2437), 1,
      anon_sym_repeat,
    ACTIONS(2439), 1,
      anon_sym_QMARK,
    ACTIONS(2441), 1,
      anon_sym_TILDE,
    ACTIONS(2449), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2451), 1,
      sym__number_literal,
    ACTIONS(2453), 1,
      anon_sym_SQUOTE,
    ACTIONS(2455), 1,
      anon_sym_DQUOTE,
    ACTIONS(2465), 1,
      sym__raw_string_literal,
    ACTIONS(2467), 1,
      sym__external_open_parenthesis,
    ACTIONS(2471), 1,
      sym__external_open_brace,
    ACTIONS(7781), 1,
      anon_sym_BANG,
    ACTIONS(10489), 1,
      sym_dot_dot_i,
    ACTIONS(10491), 1,
      sym__newline,
    STATE(97), 1,
      sym__open_brace,
    STATE(200), 1,
      sym__open_parenthesis,
    STATE(2369), 1,
      sym__double_quoted_string,
    STATE(2370), 1,
      sym__single_quoted_string,
    STATE(2372), 1,
      sym_string,
    STATE(3556), 1,
      aux_sym_function_definition_repeat1,
    STATE(5138), 1,
      sym__string_or_identifier,
    ACTIONS(2445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2371), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10487), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1293), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [68370] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3845), 1,
      sym_identifier,
    ACTIONS(3847), 1,
      anon_sym_BSLASH,
    ACTIONS(3849), 1,
      anon_sym_function,
    ACTIONS(3851), 1,
      anon_sym_if,
    ACTIONS(3853), 1,
      anon_sym_for,
    ACTIONS(3855), 1,
      anon_sym_while,
    ACTIONS(3857), 1,
      anon_sym_repeat,
    ACTIONS(3859), 1,
      anon_sym_QMARK,
    ACTIONS(3861), 1,
      anon_sym_TILDE,
    ACTIONS(3869), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3871), 1,
      sym__number_literal,
    ACTIONS(3873), 1,
      anon_sym_SQUOTE,
    ACTIONS(3875), 1,
      anon_sym_DQUOTE,
    ACTIONS(3885), 1,
      sym__raw_string_literal,
    ACTIONS(3887), 1,
      sym__external_open_parenthesis,
    ACTIONS(3891), 1,
      sym__external_open_brace,
    ACTIONS(6389), 1,
      anon_sym_BANG,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(10495), 1,
      sym_dot_dot_i,
    STATE(154), 1,
      sym__open_brace,
    STATE(350), 1,
      sym__open_parenthesis,
    STATE(2620), 1,
      sym__double_quoted_string,
    STATE(2673), 1,
      sym_string,
    STATE(2735), 1,
      sym__single_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5135), 1,
      sym__string_or_identifier,
    ACTIONS(3865), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2578), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3879), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10493), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1911), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [68499] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3845), 1,
      sym_identifier,
    ACTIONS(3847), 1,
      anon_sym_BSLASH,
    ACTIONS(3849), 1,
      anon_sym_function,
    ACTIONS(3851), 1,
      anon_sym_if,
    ACTIONS(3853), 1,
      anon_sym_for,
    ACTIONS(3855), 1,
      anon_sym_while,
    ACTIONS(3857), 1,
      anon_sym_repeat,
    ACTIONS(3859), 1,
      anon_sym_QMARK,
    ACTIONS(3861), 1,
      anon_sym_TILDE,
    ACTIONS(3869), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3871), 1,
      sym__number_literal,
    ACTIONS(3873), 1,
      anon_sym_SQUOTE,
    ACTIONS(3875), 1,
      anon_sym_DQUOTE,
    ACTIONS(3885), 1,
      sym__raw_string_literal,
    ACTIONS(3887), 1,
      sym__external_open_parenthesis,
    ACTIONS(3891), 1,
      sym__external_open_brace,
    ACTIONS(6389), 1,
      anon_sym_BANG,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(10499), 1,
      sym_dot_dot_i,
    STATE(154), 1,
      sym__open_brace,
    STATE(350), 1,
      sym__open_parenthesis,
    STATE(2620), 1,
      sym__double_quoted_string,
    STATE(2673), 1,
      sym_string,
    STATE(2735), 1,
      sym__single_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5135), 1,
      sym__string_or_identifier,
    ACTIONS(3865), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2578), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3879), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10497), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2052), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [68628] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4214), 1,
      sym_identifier,
    ACTIONS(4216), 1,
      anon_sym_BSLASH,
    ACTIONS(4218), 1,
      anon_sym_function,
    ACTIONS(4220), 1,
      anon_sym_if,
    ACTIONS(4222), 1,
      anon_sym_for,
    ACTIONS(4224), 1,
      anon_sym_while,
    ACTIONS(4226), 1,
      anon_sym_repeat,
    ACTIONS(4228), 1,
      anon_sym_QMARK,
    ACTIONS(4230), 1,
      anon_sym_TILDE,
    ACTIONS(4238), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4240), 1,
      sym__number_literal,
    ACTIONS(4242), 1,
      anon_sym_SQUOTE,
    ACTIONS(4244), 1,
      anon_sym_DQUOTE,
    ACTIONS(4254), 1,
      sym__raw_string_literal,
    ACTIONS(4256), 1,
      sym__external_open_parenthesis,
    ACTIONS(4258), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9229), 1,
      anon_sym_BANG,
    ACTIONS(10503), 1,
      sym_dot_dot_i,
    STATE(51), 1,
      sym__open_brace,
    STATE(287), 1,
      sym__open_parenthesis,
    STATE(4674), 1,
      sym__single_quoted_string,
    STATE(4678), 1,
      sym__double_quoted_string,
    STATE(4681), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5129), 1,
      sym__string_or_identifier,
    ACTIONS(4234), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4680), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4248), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10501), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4374), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [68757] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4214), 1,
      sym_identifier,
    ACTIONS(4216), 1,
      anon_sym_BSLASH,
    ACTIONS(4218), 1,
      anon_sym_function,
    ACTIONS(4220), 1,
      anon_sym_if,
    ACTIONS(4222), 1,
      anon_sym_for,
    ACTIONS(4224), 1,
      anon_sym_while,
    ACTIONS(4226), 1,
      anon_sym_repeat,
    ACTIONS(4228), 1,
      anon_sym_QMARK,
    ACTIONS(4230), 1,
      anon_sym_TILDE,
    ACTIONS(4238), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4240), 1,
      sym__number_literal,
    ACTIONS(4242), 1,
      anon_sym_SQUOTE,
    ACTIONS(4244), 1,
      anon_sym_DQUOTE,
    ACTIONS(4254), 1,
      sym__raw_string_literal,
    ACTIONS(4256), 1,
      sym__external_open_parenthesis,
    ACTIONS(4258), 1,
      sym__external_open_brace,
    ACTIONS(9229), 1,
      anon_sym_BANG,
    ACTIONS(10507), 1,
      sym_dot_dot_i,
    ACTIONS(10509), 1,
      sym__newline,
    STATE(51), 1,
      sym__open_brace,
    STATE(287), 1,
      sym__open_parenthesis,
    STATE(3560), 1,
      aux_sym_function_definition_repeat1,
    STATE(4674), 1,
      sym__single_quoted_string,
    STATE(4678), 1,
      sym__double_quoted_string,
    STATE(4681), 1,
      sym_string,
    STATE(5129), 1,
      sym__string_or_identifier,
    ACTIONS(4234), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4680), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4248), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10505), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4382), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [68886] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4214), 1,
      sym_identifier,
    ACTIONS(4216), 1,
      anon_sym_BSLASH,
    ACTIONS(4218), 1,
      anon_sym_function,
    ACTIONS(4220), 1,
      anon_sym_if,
    ACTIONS(4222), 1,
      anon_sym_for,
    ACTIONS(4224), 1,
      anon_sym_while,
    ACTIONS(4226), 1,
      anon_sym_repeat,
    ACTIONS(4228), 1,
      anon_sym_QMARK,
    ACTIONS(4230), 1,
      anon_sym_TILDE,
    ACTIONS(4238), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4240), 1,
      sym__number_literal,
    ACTIONS(4242), 1,
      anon_sym_SQUOTE,
    ACTIONS(4244), 1,
      anon_sym_DQUOTE,
    ACTIONS(4254), 1,
      sym__raw_string_literal,
    ACTIONS(4256), 1,
      sym__external_open_parenthesis,
    ACTIONS(4258), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9229), 1,
      anon_sym_BANG,
    ACTIONS(10513), 1,
      sym_dot_dot_i,
    STATE(51), 1,
      sym__open_brace,
    STATE(287), 1,
      sym__open_parenthesis,
    STATE(4674), 1,
      sym__single_quoted_string,
    STATE(4678), 1,
      sym__double_quoted_string,
    STATE(4681), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5129), 1,
      sym__string_or_identifier,
    ACTIONS(4234), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4680), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4248), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10511), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4381), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [69015] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(10517), 1,
      sym_dot_dot_i,
    ACTIONS(10519), 1,
      sym__newline,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(3888), 1,
      aux_sym_function_definition_repeat1,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10515), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4645), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [69144] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4214), 1,
      sym_identifier,
    ACTIONS(4216), 1,
      anon_sym_BSLASH,
    ACTIONS(4218), 1,
      anon_sym_function,
    ACTIONS(4220), 1,
      anon_sym_if,
    ACTIONS(4222), 1,
      anon_sym_for,
    ACTIONS(4224), 1,
      anon_sym_while,
    ACTIONS(4226), 1,
      anon_sym_repeat,
    ACTIONS(4228), 1,
      anon_sym_QMARK,
    ACTIONS(4230), 1,
      anon_sym_TILDE,
    ACTIONS(4238), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4240), 1,
      sym__number_literal,
    ACTIONS(4242), 1,
      anon_sym_SQUOTE,
    ACTIONS(4244), 1,
      anon_sym_DQUOTE,
    ACTIONS(4254), 1,
      sym__raw_string_literal,
    ACTIONS(4256), 1,
      sym__external_open_parenthesis,
    ACTIONS(4258), 1,
      sym__external_open_brace,
    ACTIONS(9229), 1,
      anon_sym_BANG,
    ACTIONS(10523), 1,
      sym_dot_dot_i,
    ACTIONS(10525), 1,
      sym__newline,
    STATE(51), 1,
      sym__open_brace,
    STATE(287), 1,
      sym__open_parenthesis,
    STATE(3562), 1,
      aux_sym_function_definition_repeat1,
    STATE(4674), 1,
      sym__single_quoted_string,
    STATE(4678), 1,
      sym__double_quoted_string,
    STATE(4681), 1,
      sym_string,
    STATE(5129), 1,
      sym__string_or_identifier,
    ACTIONS(4234), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4680), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4248), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10521), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4380), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [69273] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(10529), 1,
      sym_dot_dot_i,
    ACTIONS(10531), 1,
      sym__newline,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(3887), 1,
      aux_sym_function_definition_repeat1,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10527), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4435), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [69402] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3845), 1,
      sym_identifier,
    ACTIONS(3847), 1,
      anon_sym_BSLASH,
    ACTIONS(3849), 1,
      anon_sym_function,
    ACTIONS(3851), 1,
      anon_sym_if,
    ACTIONS(3853), 1,
      anon_sym_for,
    ACTIONS(3855), 1,
      anon_sym_while,
    ACTIONS(3857), 1,
      anon_sym_repeat,
    ACTIONS(3859), 1,
      anon_sym_QMARK,
    ACTIONS(3861), 1,
      anon_sym_TILDE,
    ACTIONS(3869), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3871), 1,
      sym__number_literal,
    ACTIONS(3873), 1,
      anon_sym_SQUOTE,
    ACTIONS(3875), 1,
      anon_sym_DQUOTE,
    ACTIONS(3885), 1,
      sym__raw_string_literal,
    ACTIONS(3887), 1,
      sym__external_open_parenthesis,
    ACTIONS(3891), 1,
      sym__external_open_brace,
    ACTIONS(6389), 1,
      anon_sym_BANG,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(10535), 1,
      sym_dot_dot_i,
    STATE(154), 1,
      sym__open_brace,
    STATE(350), 1,
      sym__open_parenthesis,
    STATE(2620), 1,
      sym__double_quoted_string,
    STATE(2673), 1,
      sym_string,
    STATE(2735), 1,
      sym__single_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5135), 1,
      sym__string_or_identifier,
    ACTIONS(3865), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2578), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3879), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10533), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2066), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [69531] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3845), 1,
      sym_identifier,
    ACTIONS(3847), 1,
      anon_sym_BSLASH,
    ACTIONS(3849), 1,
      anon_sym_function,
    ACTIONS(3851), 1,
      anon_sym_if,
    ACTIONS(3853), 1,
      anon_sym_for,
    ACTIONS(3855), 1,
      anon_sym_while,
    ACTIONS(3857), 1,
      anon_sym_repeat,
    ACTIONS(3859), 1,
      anon_sym_QMARK,
    ACTIONS(3861), 1,
      anon_sym_TILDE,
    ACTIONS(3869), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3871), 1,
      sym__number_literal,
    ACTIONS(3873), 1,
      anon_sym_SQUOTE,
    ACTIONS(3875), 1,
      anon_sym_DQUOTE,
    ACTIONS(3885), 1,
      sym__raw_string_literal,
    ACTIONS(3887), 1,
      sym__external_open_parenthesis,
    ACTIONS(3891), 1,
      sym__external_open_brace,
    ACTIONS(6389), 1,
      anon_sym_BANG,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(10539), 1,
      sym_dot_dot_i,
    STATE(154), 1,
      sym__open_brace,
    STATE(350), 1,
      sym__open_parenthesis,
    STATE(2620), 1,
      sym__double_quoted_string,
    STATE(2673), 1,
      sym_string,
    STATE(2735), 1,
      sym__single_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5135), 1,
      sym__string_or_identifier,
    ACTIONS(3865), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2578), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3879), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10537), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2068), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [69660] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3845), 1,
      sym_identifier,
    ACTIONS(3847), 1,
      anon_sym_BSLASH,
    ACTIONS(3849), 1,
      anon_sym_function,
    ACTIONS(3851), 1,
      anon_sym_if,
    ACTIONS(3853), 1,
      anon_sym_for,
    ACTIONS(3855), 1,
      anon_sym_while,
    ACTIONS(3857), 1,
      anon_sym_repeat,
    ACTIONS(3859), 1,
      anon_sym_QMARK,
    ACTIONS(3861), 1,
      anon_sym_TILDE,
    ACTIONS(3869), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3871), 1,
      sym__number_literal,
    ACTIONS(3873), 1,
      anon_sym_SQUOTE,
    ACTIONS(3875), 1,
      anon_sym_DQUOTE,
    ACTIONS(3885), 1,
      sym__raw_string_literal,
    ACTIONS(3887), 1,
      sym__external_open_parenthesis,
    ACTIONS(3891), 1,
      sym__external_open_brace,
    ACTIONS(6389), 1,
      anon_sym_BANG,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(10543), 1,
      sym_dot_dot_i,
    STATE(154), 1,
      sym__open_brace,
    STATE(350), 1,
      sym__open_parenthesis,
    STATE(2620), 1,
      sym__double_quoted_string,
    STATE(2673), 1,
      sym_string,
    STATE(2735), 1,
      sym__single_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5135), 1,
      sym__string_or_identifier,
    ACTIONS(3865), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2578), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3879), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10541), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2070), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [69789] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3845), 1,
      sym_identifier,
    ACTIONS(3847), 1,
      anon_sym_BSLASH,
    ACTIONS(3849), 1,
      anon_sym_function,
    ACTIONS(3851), 1,
      anon_sym_if,
    ACTIONS(3853), 1,
      anon_sym_for,
    ACTIONS(3855), 1,
      anon_sym_while,
    ACTIONS(3857), 1,
      anon_sym_repeat,
    ACTIONS(3859), 1,
      anon_sym_QMARK,
    ACTIONS(3861), 1,
      anon_sym_TILDE,
    ACTIONS(3869), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3871), 1,
      sym__number_literal,
    ACTIONS(3873), 1,
      anon_sym_SQUOTE,
    ACTIONS(3875), 1,
      anon_sym_DQUOTE,
    ACTIONS(3885), 1,
      sym__raw_string_literal,
    ACTIONS(3887), 1,
      sym__external_open_parenthesis,
    ACTIONS(3891), 1,
      sym__external_open_brace,
    ACTIONS(6389), 1,
      anon_sym_BANG,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(10547), 1,
      sym_dot_dot_i,
    STATE(154), 1,
      sym__open_brace,
    STATE(350), 1,
      sym__open_parenthesis,
    STATE(2620), 1,
      sym__double_quoted_string,
    STATE(2673), 1,
      sym_string,
    STATE(2735), 1,
      sym__single_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5135), 1,
      sym__string_or_identifier,
    ACTIONS(3865), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2578), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3879), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10545), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2073), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [69918] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1385), 1,
      sym_identifier,
    ACTIONS(1387), 1,
      anon_sym_BSLASH,
    ACTIONS(1389), 1,
      anon_sym_function,
    ACTIONS(1391), 1,
      anon_sym_if,
    ACTIONS(1393), 1,
      anon_sym_for,
    ACTIONS(1395), 1,
      anon_sym_while,
    ACTIONS(1397), 1,
      anon_sym_repeat,
    ACTIONS(1399), 1,
      anon_sym_QMARK,
    ACTIONS(1401), 1,
      anon_sym_TILDE,
    ACTIONS(1409), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1411), 1,
      sym__number_literal,
    ACTIONS(1413), 1,
      anon_sym_SQUOTE,
    ACTIONS(1415), 1,
      anon_sym_DQUOTE,
    ACTIONS(1425), 1,
      sym__raw_string_literal,
    ACTIONS(1427), 1,
      sym__external_open_parenthesis,
    ACTIONS(1429), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9251), 1,
      anon_sym_BANG,
    ACTIONS(10551), 1,
      sym_dot_dot_i,
    STATE(64), 1,
      sym__open_parenthesis,
    STATE(199), 1,
      sym__open_brace,
    STATE(2309), 1,
      sym__double_quoted_string,
    STATE(2310), 1,
      sym__single_quoted_string,
    STATE(2312), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5134), 1,
      sym__string_or_identifier,
    ACTIONS(1405), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2311), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1419), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10549), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(788), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [70047] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1385), 1,
      sym_identifier,
    ACTIONS(1387), 1,
      anon_sym_BSLASH,
    ACTIONS(1389), 1,
      anon_sym_function,
    ACTIONS(1391), 1,
      anon_sym_if,
    ACTIONS(1393), 1,
      anon_sym_for,
    ACTIONS(1395), 1,
      anon_sym_while,
    ACTIONS(1397), 1,
      anon_sym_repeat,
    ACTIONS(1399), 1,
      anon_sym_QMARK,
    ACTIONS(1401), 1,
      anon_sym_TILDE,
    ACTIONS(1409), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1411), 1,
      sym__number_literal,
    ACTIONS(1413), 1,
      anon_sym_SQUOTE,
    ACTIONS(1415), 1,
      anon_sym_DQUOTE,
    ACTIONS(1425), 1,
      sym__raw_string_literal,
    ACTIONS(1427), 1,
      sym__external_open_parenthesis,
    ACTIONS(1429), 1,
      sym__external_open_brace,
    ACTIONS(9251), 1,
      anon_sym_BANG,
    ACTIONS(10555), 1,
      sym_dot_dot_i,
    ACTIONS(10557), 1,
      sym__newline,
    STATE(64), 1,
      sym__open_parenthesis,
    STATE(199), 1,
      sym__open_brace,
    STATE(2309), 1,
      sym__double_quoted_string,
    STATE(2310), 1,
      sym__single_quoted_string,
    STATE(2312), 1,
      sym_string,
    STATE(3570), 1,
      aux_sym_function_definition_repeat1,
    STATE(5134), 1,
      sym__string_or_identifier,
    ACTIONS(1405), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2311), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1419), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10553), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(787), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [70176] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1385), 1,
      sym_identifier,
    ACTIONS(1387), 1,
      anon_sym_BSLASH,
    ACTIONS(1389), 1,
      anon_sym_function,
    ACTIONS(1391), 1,
      anon_sym_if,
    ACTIONS(1393), 1,
      anon_sym_for,
    ACTIONS(1395), 1,
      anon_sym_while,
    ACTIONS(1397), 1,
      anon_sym_repeat,
    ACTIONS(1399), 1,
      anon_sym_QMARK,
    ACTIONS(1401), 1,
      anon_sym_TILDE,
    ACTIONS(1409), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1411), 1,
      sym__number_literal,
    ACTIONS(1413), 1,
      anon_sym_SQUOTE,
    ACTIONS(1415), 1,
      anon_sym_DQUOTE,
    ACTIONS(1425), 1,
      sym__raw_string_literal,
    ACTIONS(1427), 1,
      sym__external_open_parenthesis,
    ACTIONS(1429), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9251), 1,
      anon_sym_BANG,
    ACTIONS(10561), 1,
      sym_dot_dot_i,
    STATE(64), 1,
      sym__open_parenthesis,
    STATE(199), 1,
      sym__open_brace,
    STATE(2309), 1,
      sym__double_quoted_string,
    STATE(2310), 1,
      sym__single_quoted_string,
    STATE(2312), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5134), 1,
      sym__string_or_identifier,
    ACTIONS(1405), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2311), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1419), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10559), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(786), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [70305] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4214), 1,
      sym_identifier,
    ACTIONS(4216), 1,
      anon_sym_BSLASH,
    ACTIONS(4218), 1,
      anon_sym_function,
    ACTIONS(4220), 1,
      anon_sym_if,
    ACTIONS(4222), 1,
      anon_sym_for,
    ACTIONS(4224), 1,
      anon_sym_while,
    ACTIONS(4226), 1,
      anon_sym_repeat,
    ACTIONS(4228), 1,
      anon_sym_QMARK,
    ACTIONS(4230), 1,
      anon_sym_TILDE,
    ACTIONS(4238), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4240), 1,
      sym__number_literal,
    ACTIONS(4242), 1,
      anon_sym_SQUOTE,
    ACTIONS(4244), 1,
      anon_sym_DQUOTE,
    ACTIONS(4254), 1,
      sym__raw_string_literal,
    ACTIONS(4256), 1,
      sym__external_open_parenthesis,
    ACTIONS(4258), 1,
      sym__external_open_brace,
    ACTIONS(9229), 1,
      anon_sym_BANG,
    ACTIONS(10565), 1,
      sym_dot_dot_i,
    ACTIONS(10567), 1,
      sym__newline,
    STATE(51), 1,
      sym__open_brace,
    STATE(287), 1,
      sym__open_parenthesis,
    STATE(3412), 1,
      aux_sym_function_definition_repeat1,
    STATE(4674), 1,
      sym__single_quoted_string,
    STATE(4678), 1,
      sym__double_quoted_string,
    STATE(4681), 1,
      sym_string,
    STATE(5129), 1,
      sym__string_or_identifier,
    ACTIONS(4234), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4680), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4248), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10563), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4428), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [70434] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4214), 1,
      sym_identifier,
    ACTIONS(4216), 1,
      anon_sym_BSLASH,
    ACTIONS(4218), 1,
      anon_sym_function,
    ACTIONS(4220), 1,
      anon_sym_if,
    ACTIONS(4222), 1,
      anon_sym_for,
    ACTIONS(4224), 1,
      anon_sym_while,
    ACTIONS(4226), 1,
      anon_sym_repeat,
    ACTIONS(4228), 1,
      anon_sym_QMARK,
    ACTIONS(4230), 1,
      anon_sym_TILDE,
    ACTIONS(4238), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4240), 1,
      sym__number_literal,
    ACTIONS(4242), 1,
      anon_sym_SQUOTE,
    ACTIONS(4244), 1,
      anon_sym_DQUOTE,
    ACTIONS(4254), 1,
      sym__raw_string_literal,
    ACTIONS(4256), 1,
      sym__external_open_parenthesis,
    ACTIONS(4258), 1,
      sym__external_open_brace,
    ACTIONS(9229), 1,
      anon_sym_BANG,
    ACTIONS(10571), 1,
      sym_dot_dot_i,
    ACTIONS(10573), 1,
      sym__newline,
    STATE(51), 1,
      sym__open_brace,
    STATE(287), 1,
      sym__open_parenthesis,
    STATE(3468), 1,
      aux_sym_function_definition_repeat1,
    STATE(4674), 1,
      sym__single_quoted_string,
    STATE(4678), 1,
      sym__double_quoted_string,
    STATE(4681), 1,
      sym_string,
    STATE(5129), 1,
      sym__string_or_identifier,
    ACTIONS(4234), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4680), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4248), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10569), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4415), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [70563] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4214), 1,
      sym_identifier,
    ACTIONS(4216), 1,
      anon_sym_BSLASH,
    ACTIONS(4218), 1,
      anon_sym_function,
    ACTIONS(4220), 1,
      anon_sym_if,
    ACTIONS(4222), 1,
      anon_sym_for,
    ACTIONS(4224), 1,
      anon_sym_while,
    ACTIONS(4226), 1,
      anon_sym_repeat,
    ACTIONS(4228), 1,
      anon_sym_QMARK,
    ACTIONS(4230), 1,
      anon_sym_TILDE,
    ACTIONS(4238), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4240), 1,
      sym__number_literal,
    ACTIONS(4242), 1,
      anon_sym_SQUOTE,
    ACTIONS(4244), 1,
      anon_sym_DQUOTE,
    ACTIONS(4254), 1,
      sym__raw_string_literal,
    ACTIONS(4256), 1,
      sym__external_open_parenthesis,
    ACTIONS(4258), 1,
      sym__external_open_brace,
    ACTIONS(9229), 1,
      anon_sym_BANG,
    ACTIONS(10577), 1,
      sym_dot_dot_i,
    ACTIONS(10579), 1,
      sym__newline,
    STATE(51), 1,
      sym__open_brace,
    STATE(287), 1,
      sym__open_parenthesis,
    STATE(3470), 1,
      aux_sym_function_definition_repeat1,
    STATE(4674), 1,
      sym__single_quoted_string,
    STATE(4678), 1,
      sym__double_quoted_string,
    STATE(4681), 1,
      sym_string,
    STATE(5129), 1,
      sym__string_or_identifier,
    ACTIONS(4234), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4680), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4248), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10575), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4407), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [70692] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4214), 1,
      sym_identifier,
    ACTIONS(4216), 1,
      anon_sym_BSLASH,
    ACTIONS(4218), 1,
      anon_sym_function,
    ACTIONS(4220), 1,
      anon_sym_if,
    ACTIONS(4222), 1,
      anon_sym_for,
    ACTIONS(4224), 1,
      anon_sym_while,
    ACTIONS(4226), 1,
      anon_sym_repeat,
    ACTIONS(4228), 1,
      anon_sym_QMARK,
    ACTIONS(4230), 1,
      anon_sym_TILDE,
    ACTIONS(4238), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4240), 1,
      sym__number_literal,
    ACTIONS(4242), 1,
      anon_sym_SQUOTE,
    ACTIONS(4244), 1,
      anon_sym_DQUOTE,
    ACTIONS(4254), 1,
      sym__raw_string_literal,
    ACTIONS(4256), 1,
      sym__external_open_parenthesis,
    ACTIONS(4258), 1,
      sym__external_open_brace,
    ACTIONS(9229), 1,
      anon_sym_BANG,
    ACTIONS(10583), 1,
      sym_dot_dot_i,
    ACTIONS(10585), 1,
      sym__newline,
    STATE(51), 1,
      sym__open_brace,
    STATE(287), 1,
      sym__open_parenthesis,
    STATE(3486), 1,
      aux_sym_function_definition_repeat1,
    STATE(4674), 1,
      sym__single_quoted_string,
    STATE(4678), 1,
      sym__double_quoted_string,
    STATE(4681), 1,
      sym_string,
    STATE(5129), 1,
      sym__string_or_identifier,
    ACTIONS(4234), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4680), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4248), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10581), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4405), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [70821] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4214), 1,
      sym_identifier,
    ACTIONS(4216), 1,
      anon_sym_BSLASH,
    ACTIONS(4218), 1,
      anon_sym_function,
    ACTIONS(4220), 1,
      anon_sym_if,
    ACTIONS(4222), 1,
      anon_sym_for,
    ACTIONS(4224), 1,
      anon_sym_while,
    ACTIONS(4226), 1,
      anon_sym_repeat,
    ACTIONS(4228), 1,
      anon_sym_QMARK,
    ACTIONS(4230), 1,
      anon_sym_TILDE,
    ACTIONS(4238), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4240), 1,
      sym__number_literal,
    ACTIONS(4242), 1,
      anon_sym_SQUOTE,
    ACTIONS(4244), 1,
      anon_sym_DQUOTE,
    ACTIONS(4254), 1,
      sym__raw_string_literal,
    ACTIONS(4256), 1,
      sym__external_open_parenthesis,
    ACTIONS(4258), 1,
      sym__external_open_brace,
    ACTIONS(9229), 1,
      anon_sym_BANG,
    ACTIONS(10589), 1,
      sym_dot_dot_i,
    ACTIONS(10591), 1,
      sym__newline,
    STATE(51), 1,
      sym__open_brace,
    STATE(287), 1,
      sym__open_parenthesis,
    STATE(3501), 1,
      aux_sym_function_definition_repeat1,
    STATE(4674), 1,
      sym__single_quoted_string,
    STATE(4678), 1,
      sym__double_quoted_string,
    STATE(4681), 1,
      sym_string,
    STATE(5129), 1,
      sym__string_or_identifier,
    ACTIONS(4234), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4680), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4248), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10587), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4404), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [70950] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4214), 1,
      sym_identifier,
    ACTIONS(4216), 1,
      anon_sym_BSLASH,
    ACTIONS(4218), 1,
      anon_sym_function,
    ACTIONS(4220), 1,
      anon_sym_if,
    ACTIONS(4222), 1,
      anon_sym_for,
    ACTIONS(4224), 1,
      anon_sym_while,
    ACTIONS(4226), 1,
      anon_sym_repeat,
    ACTIONS(4228), 1,
      anon_sym_QMARK,
    ACTIONS(4230), 1,
      anon_sym_TILDE,
    ACTIONS(4238), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4240), 1,
      sym__number_literal,
    ACTIONS(4242), 1,
      anon_sym_SQUOTE,
    ACTIONS(4244), 1,
      anon_sym_DQUOTE,
    ACTIONS(4254), 1,
      sym__raw_string_literal,
    ACTIONS(4256), 1,
      sym__external_open_parenthesis,
    ACTIONS(4258), 1,
      sym__external_open_brace,
    ACTIONS(9229), 1,
      anon_sym_BANG,
    ACTIONS(10595), 1,
      sym_dot_dot_i,
    ACTIONS(10597), 1,
      sym__newline,
    STATE(51), 1,
      sym__open_brace,
    STATE(287), 1,
      sym__open_parenthesis,
    STATE(3503), 1,
      aux_sym_function_definition_repeat1,
    STATE(4674), 1,
      sym__single_quoted_string,
    STATE(4678), 1,
      sym__double_quoted_string,
    STATE(4681), 1,
      sym_string,
    STATE(5129), 1,
      sym__string_or_identifier,
    ACTIONS(4234), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4680), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4248), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10593), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4403), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [71079] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1385), 1,
      sym_identifier,
    ACTIONS(1387), 1,
      anon_sym_BSLASH,
    ACTIONS(1389), 1,
      anon_sym_function,
    ACTIONS(1391), 1,
      anon_sym_if,
    ACTIONS(1393), 1,
      anon_sym_for,
    ACTIONS(1395), 1,
      anon_sym_while,
    ACTIONS(1397), 1,
      anon_sym_repeat,
    ACTIONS(1399), 1,
      anon_sym_QMARK,
    ACTIONS(1401), 1,
      anon_sym_TILDE,
    ACTIONS(1409), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1411), 1,
      sym__number_literal,
    ACTIONS(1413), 1,
      anon_sym_SQUOTE,
    ACTIONS(1415), 1,
      anon_sym_DQUOTE,
    ACTIONS(1425), 1,
      sym__raw_string_literal,
    ACTIONS(1427), 1,
      sym__external_open_parenthesis,
    ACTIONS(1429), 1,
      sym__external_open_brace,
    ACTIONS(9251), 1,
      anon_sym_BANG,
    ACTIONS(10601), 1,
      sym_dot_dot_i,
    ACTIONS(10603), 1,
      sym__newline,
    STATE(64), 1,
      sym__open_parenthesis,
    STATE(199), 1,
      sym__open_brace,
    STATE(2309), 1,
      sym__double_quoted_string,
    STATE(2310), 1,
      sym__single_quoted_string,
    STATE(2312), 1,
      sym_string,
    STATE(3572), 1,
      aux_sym_function_definition_repeat1,
    STATE(5134), 1,
      sym__string_or_identifier,
    ACTIONS(1405), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2311), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1419), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10599), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(785), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [71208] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2943), 1,
      sym_identifier,
    ACTIONS(2945), 1,
      anon_sym_BSLASH,
    ACTIONS(2947), 1,
      anon_sym_function,
    ACTIONS(2949), 1,
      anon_sym_if,
    ACTIONS(2951), 1,
      anon_sym_for,
    ACTIONS(2953), 1,
      anon_sym_while,
    ACTIONS(2955), 1,
      anon_sym_repeat,
    ACTIONS(2957), 1,
      anon_sym_QMARK,
    ACTIONS(2959), 1,
      anon_sym_TILDE,
    ACTIONS(2967), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2969), 1,
      sym__number_literal,
    ACTIONS(2971), 1,
      anon_sym_SQUOTE,
    ACTIONS(2973), 1,
      anon_sym_DQUOTE,
    ACTIONS(2983), 1,
      sym__raw_string_literal,
    ACTIONS(2985), 1,
      sym__external_open_parenthesis,
    ACTIONS(2989), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7797), 1,
      anon_sym_BANG,
    ACTIONS(10607), 1,
      sym_dot_dot_i,
    STATE(173), 1,
      sym__open_brace,
    STATE(246), 1,
      sym__open_parenthesis,
    STATE(2462), 1,
      sym__single_quoted_string,
    STATE(2494), 1,
      sym__double_quoted_string,
    STATE(2541), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5128), 1,
      sym__string_or_identifier,
    ACTIONS(2963), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2540), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2977), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10605), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1667), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [71337] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4214), 1,
      sym_identifier,
    ACTIONS(4216), 1,
      anon_sym_BSLASH,
    ACTIONS(4218), 1,
      anon_sym_function,
    ACTIONS(4220), 1,
      anon_sym_if,
    ACTIONS(4222), 1,
      anon_sym_for,
    ACTIONS(4224), 1,
      anon_sym_while,
    ACTIONS(4226), 1,
      anon_sym_repeat,
    ACTIONS(4228), 1,
      anon_sym_QMARK,
    ACTIONS(4230), 1,
      anon_sym_TILDE,
    ACTIONS(4238), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4240), 1,
      sym__number_literal,
    ACTIONS(4242), 1,
      anon_sym_SQUOTE,
    ACTIONS(4244), 1,
      anon_sym_DQUOTE,
    ACTIONS(4254), 1,
      sym__raw_string_literal,
    ACTIONS(4256), 1,
      sym__external_open_parenthesis,
    ACTIONS(4258), 1,
      sym__external_open_brace,
    ACTIONS(9229), 1,
      anon_sym_BANG,
    ACTIONS(10611), 1,
      sym_dot_dot_i,
    ACTIONS(10613), 1,
      sym__newline,
    STATE(51), 1,
      sym__open_brace,
    STATE(287), 1,
      sym__open_parenthesis,
    STATE(3505), 1,
      aux_sym_function_definition_repeat1,
    STATE(4674), 1,
      sym__single_quoted_string,
    STATE(4678), 1,
      sym__double_quoted_string,
    STATE(4681), 1,
      sym_string,
    STATE(5129), 1,
      sym__string_or_identifier,
    ACTIONS(4234), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4680), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4248), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10609), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4391), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [71466] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4214), 1,
      sym_identifier,
    ACTIONS(4216), 1,
      anon_sym_BSLASH,
    ACTIONS(4218), 1,
      anon_sym_function,
    ACTIONS(4220), 1,
      anon_sym_if,
    ACTIONS(4222), 1,
      anon_sym_for,
    ACTIONS(4224), 1,
      anon_sym_while,
    ACTIONS(4226), 1,
      anon_sym_repeat,
    ACTIONS(4228), 1,
      anon_sym_QMARK,
    ACTIONS(4230), 1,
      anon_sym_TILDE,
    ACTIONS(4238), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4240), 1,
      sym__number_literal,
    ACTIONS(4242), 1,
      anon_sym_SQUOTE,
    ACTIONS(4244), 1,
      anon_sym_DQUOTE,
    ACTIONS(4254), 1,
      sym__raw_string_literal,
    ACTIONS(4256), 1,
      sym__external_open_parenthesis,
    ACTIONS(4258), 1,
      sym__external_open_brace,
    ACTIONS(9229), 1,
      anon_sym_BANG,
    ACTIONS(10617), 1,
      sym_dot_dot_i,
    ACTIONS(10619), 1,
      sym__newline,
    STATE(51), 1,
      sym__open_brace,
    STATE(287), 1,
      sym__open_parenthesis,
    STATE(3508), 1,
      aux_sym_function_definition_repeat1,
    STATE(4674), 1,
      sym__single_quoted_string,
    STATE(4678), 1,
      sym__double_quoted_string,
    STATE(4681), 1,
      sym_string,
    STATE(5129), 1,
      sym__string_or_identifier,
    ACTIONS(4234), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4680), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4248), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10615), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4388), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [71595] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(321), 1,
      sym_identifier,
    ACTIONS(323), 1,
      anon_sym_BSLASH,
    ACTIONS(325), 1,
      anon_sym_function,
    ACTIONS(327), 1,
      anon_sym_if,
    ACTIONS(329), 1,
      anon_sym_for,
    ACTIONS(331), 1,
      anon_sym_while,
    ACTIONS(333), 1,
      anon_sym_repeat,
    ACTIONS(335), 1,
      anon_sym_QMARK,
    ACTIONS(337), 1,
      anon_sym_TILDE,
    ACTIONS(345), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(347), 1,
      sym__number_literal,
    ACTIONS(349), 1,
      anon_sym_SQUOTE,
    ACTIONS(351), 1,
      anon_sym_DQUOTE,
    ACTIONS(361), 1,
      sym__raw_string_literal,
    ACTIONS(363), 1,
      sym__external_open_parenthesis,
    ACTIONS(365), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(10329), 1,
      anon_sym_BANG,
    ACTIONS(10623), 1,
      sym_dot_dot_i,
    STATE(24), 1,
      sym__open_brace,
    STATE(67), 1,
      sym__open_parenthesis,
    STATE(2169), 1,
      sym_string,
    STATE(2180), 1,
      sym__double_quoted_string,
    STATE(2181), 1,
      sym__single_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5149), 1,
      sym__string_or_identifier,
    ACTIONS(341), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2183), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(355), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10621), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(845), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [71724] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(321), 1,
      sym_identifier,
    ACTIONS(323), 1,
      anon_sym_BSLASH,
    ACTIONS(325), 1,
      anon_sym_function,
    ACTIONS(327), 1,
      anon_sym_if,
    ACTIONS(329), 1,
      anon_sym_for,
    ACTIONS(331), 1,
      anon_sym_while,
    ACTIONS(333), 1,
      anon_sym_repeat,
    ACTIONS(335), 1,
      anon_sym_QMARK,
    ACTIONS(337), 1,
      anon_sym_TILDE,
    ACTIONS(345), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(347), 1,
      sym__number_literal,
    ACTIONS(349), 1,
      anon_sym_SQUOTE,
    ACTIONS(351), 1,
      anon_sym_DQUOTE,
    ACTIONS(361), 1,
      sym__raw_string_literal,
    ACTIONS(363), 1,
      sym__external_open_parenthesis,
    ACTIONS(365), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(10329), 1,
      anon_sym_BANG,
    ACTIONS(10627), 1,
      sym_dot_dot_i,
    STATE(24), 1,
      sym__open_brace,
    STATE(67), 1,
      sym__open_parenthesis,
    STATE(2169), 1,
      sym_string,
    STATE(2180), 1,
      sym__double_quoted_string,
    STATE(2181), 1,
      sym__single_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5149), 1,
      sym__string_or_identifier,
    ACTIONS(341), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2183), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(355), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10625), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(846), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [71853] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3845), 1,
      sym_identifier,
    ACTIONS(3847), 1,
      anon_sym_BSLASH,
    ACTIONS(3849), 1,
      anon_sym_function,
    ACTIONS(3851), 1,
      anon_sym_if,
    ACTIONS(3853), 1,
      anon_sym_for,
    ACTIONS(3855), 1,
      anon_sym_while,
    ACTIONS(3857), 1,
      anon_sym_repeat,
    ACTIONS(3859), 1,
      anon_sym_QMARK,
    ACTIONS(3861), 1,
      anon_sym_TILDE,
    ACTIONS(3869), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3871), 1,
      sym__number_literal,
    ACTIONS(3873), 1,
      anon_sym_SQUOTE,
    ACTIONS(3875), 1,
      anon_sym_DQUOTE,
    ACTIONS(3885), 1,
      sym__raw_string_literal,
    ACTIONS(3887), 1,
      sym__external_open_parenthesis,
    ACTIONS(3891), 1,
      sym__external_open_brace,
    ACTIONS(6389), 1,
      anon_sym_BANG,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(10631), 1,
      sym_dot_dot_i,
    STATE(154), 1,
      sym__open_brace,
    STATE(350), 1,
      sym__open_parenthesis,
    STATE(2620), 1,
      sym__double_quoted_string,
    STATE(2673), 1,
      sym_string,
    STATE(2735), 1,
      sym__single_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5135), 1,
      sym__string_or_identifier,
    ACTIONS(3865), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2578), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3879), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10629), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2079), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [71982] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3845), 1,
      sym_identifier,
    ACTIONS(3847), 1,
      anon_sym_BSLASH,
    ACTIONS(3849), 1,
      anon_sym_function,
    ACTIONS(3851), 1,
      anon_sym_if,
    ACTIONS(3853), 1,
      anon_sym_for,
    ACTIONS(3855), 1,
      anon_sym_while,
    ACTIONS(3857), 1,
      anon_sym_repeat,
    ACTIONS(3859), 1,
      anon_sym_QMARK,
    ACTIONS(3861), 1,
      anon_sym_TILDE,
    ACTIONS(3869), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3871), 1,
      sym__number_literal,
    ACTIONS(3873), 1,
      anon_sym_SQUOTE,
    ACTIONS(3875), 1,
      anon_sym_DQUOTE,
    ACTIONS(3885), 1,
      sym__raw_string_literal,
    ACTIONS(3887), 1,
      sym__external_open_parenthesis,
    ACTIONS(3891), 1,
      sym__external_open_brace,
    ACTIONS(6389), 1,
      anon_sym_BANG,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(10635), 1,
      sym_dot_dot_i,
    STATE(154), 1,
      sym__open_brace,
    STATE(350), 1,
      sym__open_parenthesis,
    STATE(2620), 1,
      sym__double_quoted_string,
    STATE(2673), 1,
      sym_string,
    STATE(2735), 1,
      sym__single_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5135), 1,
      sym__string_or_identifier,
    ACTIONS(3865), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2578), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3879), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10633), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2081), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [72111] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(321), 1,
      sym_identifier,
    ACTIONS(323), 1,
      anon_sym_BSLASH,
    ACTIONS(325), 1,
      anon_sym_function,
    ACTIONS(327), 1,
      anon_sym_if,
    ACTIONS(329), 1,
      anon_sym_for,
    ACTIONS(331), 1,
      anon_sym_while,
    ACTIONS(333), 1,
      anon_sym_repeat,
    ACTIONS(335), 1,
      anon_sym_QMARK,
    ACTIONS(337), 1,
      anon_sym_TILDE,
    ACTIONS(345), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(347), 1,
      sym__number_literal,
    ACTIONS(349), 1,
      anon_sym_SQUOTE,
    ACTIONS(351), 1,
      anon_sym_DQUOTE,
    ACTIONS(361), 1,
      sym__raw_string_literal,
    ACTIONS(363), 1,
      sym__external_open_parenthesis,
    ACTIONS(365), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(10329), 1,
      anon_sym_BANG,
    ACTIONS(10639), 1,
      sym_dot_dot_i,
    STATE(24), 1,
      sym__open_brace,
    STATE(67), 1,
      sym__open_parenthesis,
    STATE(2169), 1,
      sym_string,
    STATE(2180), 1,
      sym__double_quoted_string,
    STATE(2181), 1,
      sym__single_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5149), 1,
      sym__string_or_identifier,
    ACTIONS(341), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2183), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(355), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10637), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(847), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [72240] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2943), 1,
      sym_identifier,
    ACTIONS(2945), 1,
      anon_sym_BSLASH,
    ACTIONS(2947), 1,
      anon_sym_function,
    ACTIONS(2949), 1,
      anon_sym_if,
    ACTIONS(2951), 1,
      anon_sym_for,
    ACTIONS(2953), 1,
      anon_sym_while,
    ACTIONS(2955), 1,
      anon_sym_repeat,
    ACTIONS(2957), 1,
      anon_sym_QMARK,
    ACTIONS(2959), 1,
      anon_sym_TILDE,
    ACTIONS(2967), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2969), 1,
      sym__number_literal,
    ACTIONS(2971), 1,
      anon_sym_SQUOTE,
    ACTIONS(2973), 1,
      anon_sym_DQUOTE,
    ACTIONS(2983), 1,
      sym__raw_string_literal,
    ACTIONS(2985), 1,
      sym__external_open_parenthesis,
    ACTIONS(2989), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7797), 1,
      anon_sym_BANG,
    ACTIONS(10643), 1,
      sym_dot_dot_i,
    STATE(173), 1,
      sym__open_brace,
    STATE(246), 1,
      sym__open_parenthesis,
    STATE(2462), 1,
      sym__single_quoted_string,
    STATE(2494), 1,
      sym__double_quoted_string,
    STATE(2541), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5128), 1,
      sym__string_or_identifier,
    ACTIONS(2963), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2540), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2977), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10641), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1568), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [72369] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(321), 1,
      sym_identifier,
    ACTIONS(323), 1,
      anon_sym_BSLASH,
    ACTIONS(325), 1,
      anon_sym_function,
    ACTIONS(327), 1,
      anon_sym_if,
    ACTIONS(329), 1,
      anon_sym_for,
    ACTIONS(331), 1,
      anon_sym_while,
    ACTIONS(333), 1,
      anon_sym_repeat,
    ACTIONS(335), 1,
      anon_sym_QMARK,
    ACTIONS(337), 1,
      anon_sym_TILDE,
    ACTIONS(345), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(347), 1,
      sym__number_literal,
    ACTIONS(349), 1,
      anon_sym_SQUOTE,
    ACTIONS(351), 1,
      anon_sym_DQUOTE,
    ACTIONS(361), 1,
      sym__raw_string_literal,
    ACTIONS(363), 1,
      sym__external_open_parenthesis,
    ACTIONS(365), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(10329), 1,
      anon_sym_BANG,
    ACTIONS(10647), 1,
      sym_dot_dot_i,
    STATE(24), 1,
      sym__open_brace,
    STATE(67), 1,
      sym__open_parenthesis,
    STATE(2169), 1,
      sym_string,
    STATE(2180), 1,
      sym__double_quoted_string,
    STATE(2181), 1,
      sym__single_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5149), 1,
      sym__string_or_identifier,
    ACTIONS(341), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2183), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(355), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10645), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(848), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [72498] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(321), 1,
      sym_identifier,
    ACTIONS(323), 1,
      anon_sym_BSLASH,
    ACTIONS(325), 1,
      anon_sym_function,
    ACTIONS(327), 1,
      anon_sym_if,
    ACTIONS(329), 1,
      anon_sym_for,
    ACTIONS(331), 1,
      anon_sym_while,
    ACTIONS(333), 1,
      anon_sym_repeat,
    ACTIONS(335), 1,
      anon_sym_QMARK,
    ACTIONS(337), 1,
      anon_sym_TILDE,
    ACTIONS(345), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(347), 1,
      sym__number_literal,
    ACTIONS(349), 1,
      anon_sym_SQUOTE,
    ACTIONS(351), 1,
      anon_sym_DQUOTE,
    ACTIONS(361), 1,
      sym__raw_string_literal,
    ACTIONS(363), 1,
      sym__external_open_parenthesis,
    ACTIONS(365), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(10329), 1,
      anon_sym_BANG,
    ACTIONS(10651), 1,
      sym_dot_dot_i,
    STATE(24), 1,
      sym__open_brace,
    STATE(67), 1,
      sym__open_parenthesis,
    STATE(2169), 1,
      sym_string,
    STATE(2180), 1,
      sym__double_quoted_string,
    STATE(2181), 1,
      sym__single_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5149), 1,
      sym__string_or_identifier,
    ACTIONS(341), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2183), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(355), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10649), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(849), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [72627] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(321), 1,
      sym_identifier,
    ACTIONS(323), 1,
      anon_sym_BSLASH,
    ACTIONS(325), 1,
      anon_sym_function,
    ACTIONS(327), 1,
      anon_sym_if,
    ACTIONS(329), 1,
      anon_sym_for,
    ACTIONS(331), 1,
      anon_sym_while,
    ACTIONS(333), 1,
      anon_sym_repeat,
    ACTIONS(335), 1,
      anon_sym_QMARK,
    ACTIONS(337), 1,
      anon_sym_TILDE,
    ACTIONS(345), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(347), 1,
      sym__number_literal,
    ACTIONS(349), 1,
      anon_sym_SQUOTE,
    ACTIONS(351), 1,
      anon_sym_DQUOTE,
    ACTIONS(361), 1,
      sym__raw_string_literal,
    ACTIONS(363), 1,
      sym__external_open_parenthesis,
    ACTIONS(365), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(10329), 1,
      anon_sym_BANG,
    ACTIONS(10655), 1,
      sym_dot_dot_i,
    STATE(24), 1,
      sym__open_brace,
    STATE(67), 1,
      sym__open_parenthesis,
    STATE(2169), 1,
      sym_string,
    STATE(2180), 1,
      sym__double_quoted_string,
    STATE(2181), 1,
      sym__single_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5149), 1,
      sym__string_or_identifier,
    ACTIONS(341), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2183), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(355), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10653), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(850), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [72756] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(321), 1,
      sym_identifier,
    ACTIONS(323), 1,
      anon_sym_BSLASH,
    ACTIONS(325), 1,
      anon_sym_function,
    ACTIONS(327), 1,
      anon_sym_if,
    ACTIONS(329), 1,
      anon_sym_for,
    ACTIONS(331), 1,
      anon_sym_while,
    ACTIONS(333), 1,
      anon_sym_repeat,
    ACTIONS(335), 1,
      anon_sym_QMARK,
    ACTIONS(337), 1,
      anon_sym_TILDE,
    ACTIONS(345), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(347), 1,
      sym__number_literal,
    ACTIONS(349), 1,
      anon_sym_SQUOTE,
    ACTIONS(351), 1,
      anon_sym_DQUOTE,
    ACTIONS(361), 1,
      sym__raw_string_literal,
    ACTIONS(363), 1,
      sym__external_open_parenthesis,
    ACTIONS(365), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(10329), 1,
      anon_sym_BANG,
    ACTIONS(10659), 1,
      sym_dot_dot_i,
    STATE(24), 1,
      sym__open_brace,
    STATE(67), 1,
      sym__open_parenthesis,
    STATE(2169), 1,
      sym_string,
    STATE(2180), 1,
      sym__double_quoted_string,
    STATE(2181), 1,
      sym__single_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5149), 1,
      sym__string_or_identifier,
    ACTIONS(341), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2183), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(355), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10657), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(851), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [72885] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3845), 1,
      sym_identifier,
    ACTIONS(3847), 1,
      anon_sym_BSLASH,
    ACTIONS(3849), 1,
      anon_sym_function,
    ACTIONS(3851), 1,
      anon_sym_if,
    ACTIONS(3853), 1,
      anon_sym_for,
    ACTIONS(3855), 1,
      anon_sym_while,
    ACTIONS(3857), 1,
      anon_sym_repeat,
    ACTIONS(3859), 1,
      anon_sym_QMARK,
    ACTIONS(3861), 1,
      anon_sym_TILDE,
    ACTIONS(3869), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3871), 1,
      sym__number_literal,
    ACTIONS(3873), 1,
      anon_sym_SQUOTE,
    ACTIONS(3875), 1,
      anon_sym_DQUOTE,
    ACTIONS(3885), 1,
      sym__raw_string_literal,
    ACTIONS(3887), 1,
      sym__external_open_parenthesis,
    ACTIONS(3891), 1,
      sym__external_open_brace,
    ACTIONS(6389), 1,
      anon_sym_BANG,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(10663), 1,
      sym_dot_dot_i,
    STATE(154), 1,
      sym__open_brace,
    STATE(350), 1,
      sym__open_parenthesis,
    STATE(2620), 1,
      sym__double_quoted_string,
    STATE(2673), 1,
      sym_string,
    STATE(2735), 1,
      sym__single_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5135), 1,
      sym__string_or_identifier,
    ACTIONS(3865), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2578), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3879), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10661), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2082), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [73014] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(321), 1,
      sym_identifier,
    ACTIONS(323), 1,
      anon_sym_BSLASH,
    ACTIONS(325), 1,
      anon_sym_function,
    ACTIONS(327), 1,
      anon_sym_if,
    ACTIONS(329), 1,
      anon_sym_for,
    ACTIONS(331), 1,
      anon_sym_while,
    ACTIONS(333), 1,
      anon_sym_repeat,
    ACTIONS(335), 1,
      anon_sym_QMARK,
    ACTIONS(337), 1,
      anon_sym_TILDE,
    ACTIONS(345), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(347), 1,
      sym__number_literal,
    ACTIONS(349), 1,
      anon_sym_SQUOTE,
    ACTIONS(351), 1,
      anon_sym_DQUOTE,
    ACTIONS(361), 1,
      sym__raw_string_literal,
    ACTIONS(363), 1,
      sym__external_open_parenthesis,
    ACTIONS(365), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(10329), 1,
      anon_sym_BANG,
    ACTIONS(10667), 1,
      sym_dot_dot_i,
    STATE(24), 1,
      sym__open_brace,
    STATE(67), 1,
      sym__open_parenthesis,
    STATE(2169), 1,
      sym_string,
    STATE(2180), 1,
      sym__double_quoted_string,
    STATE(2181), 1,
      sym__single_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5149), 1,
      sym__string_or_identifier,
    ACTIONS(341), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2183), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(355), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10665), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(852), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [73143] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(321), 1,
      sym_identifier,
    ACTIONS(323), 1,
      anon_sym_BSLASH,
    ACTIONS(325), 1,
      anon_sym_function,
    ACTIONS(327), 1,
      anon_sym_if,
    ACTIONS(329), 1,
      anon_sym_for,
    ACTIONS(331), 1,
      anon_sym_while,
    ACTIONS(333), 1,
      anon_sym_repeat,
    ACTIONS(335), 1,
      anon_sym_QMARK,
    ACTIONS(337), 1,
      anon_sym_TILDE,
    ACTIONS(345), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(347), 1,
      sym__number_literal,
    ACTIONS(349), 1,
      anon_sym_SQUOTE,
    ACTIONS(351), 1,
      anon_sym_DQUOTE,
    ACTIONS(361), 1,
      sym__raw_string_literal,
    ACTIONS(363), 1,
      sym__external_open_parenthesis,
    ACTIONS(365), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(10329), 1,
      anon_sym_BANG,
    ACTIONS(10671), 1,
      sym_dot_dot_i,
    STATE(24), 1,
      sym__open_brace,
    STATE(67), 1,
      sym__open_parenthesis,
    STATE(2169), 1,
      sym_string,
    STATE(2180), 1,
      sym__double_quoted_string,
    STATE(2181), 1,
      sym__single_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5149), 1,
      sym__string_or_identifier,
    ACTIONS(341), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2183), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(355), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10669), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(853), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [73272] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2943), 1,
      sym_identifier,
    ACTIONS(2945), 1,
      anon_sym_BSLASH,
    ACTIONS(2947), 1,
      anon_sym_function,
    ACTIONS(2949), 1,
      anon_sym_if,
    ACTIONS(2951), 1,
      anon_sym_for,
    ACTIONS(2953), 1,
      anon_sym_while,
    ACTIONS(2955), 1,
      anon_sym_repeat,
    ACTIONS(2957), 1,
      anon_sym_QMARK,
    ACTIONS(2959), 1,
      anon_sym_TILDE,
    ACTIONS(2967), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2969), 1,
      sym__number_literal,
    ACTIONS(2971), 1,
      anon_sym_SQUOTE,
    ACTIONS(2973), 1,
      anon_sym_DQUOTE,
    ACTIONS(2983), 1,
      sym__raw_string_literal,
    ACTIONS(2985), 1,
      sym__external_open_parenthesis,
    ACTIONS(2989), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7797), 1,
      anon_sym_BANG,
    ACTIONS(10675), 1,
      sym_dot_dot_i,
    STATE(173), 1,
      sym__open_brace,
    STATE(246), 1,
      sym__open_parenthesis,
    STATE(2462), 1,
      sym__single_quoted_string,
    STATE(2494), 1,
      sym__double_quoted_string,
    STATE(2541), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5128), 1,
      sym__string_or_identifier,
    ACTIONS(2963), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2540), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2977), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10673), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1567), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [73401] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(321), 1,
      sym_identifier,
    ACTIONS(323), 1,
      anon_sym_BSLASH,
    ACTIONS(325), 1,
      anon_sym_function,
    ACTIONS(327), 1,
      anon_sym_if,
    ACTIONS(329), 1,
      anon_sym_for,
    ACTIONS(331), 1,
      anon_sym_while,
    ACTIONS(333), 1,
      anon_sym_repeat,
    ACTIONS(335), 1,
      anon_sym_QMARK,
    ACTIONS(337), 1,
      anon_sym_TILDE,
    ACTIONS(345), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(347), 1,
      sym__number_literal,
    ACTIONS(349), 1,
      anon_sym_SQUOTE,
    ACTIONS(351), 1,
      anon_sym_DQUOTE,
    ACTIONS(361), 1,
      sym__raw_string_literal,
    ACTIONS(363), 1,
      sym__external_open_parenthesis,
    ACTIONS(365), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(10329), 1,
      anon_sym_BANG,
    ACTIONS(10679), 1,
      sym_dot_dot_i,
    STATE(24), 1,
      sym__open_brace,
    STATE(67), 1,
      sym__open_parenthesis,
    STATE(2169), 1,
      sym_string,
    STATE(2180), 1,
      sym__double_quoted_string,
    STATE(2181), 1,
      sym__single_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5149), 1,
      sym__string_or_identifier,
    ACTIONS(341), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2183), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(355), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10677), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(854), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [73530] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(321), 1,
      sym_identifier,
    ACTIONS(323), 1,
      anon_sym_BSLASH,
    ACTIONS(325), 1,
      anon_sym_function,
    ACTIONS(327), 1,
      anon_sym_if,
    ACTIONS(329), 1,
      anon_sym_for,
    ACTIONS(331), 1,
      anon_sym_while,
    ACTIONS(333), 1,
      anon_sym_repeat,
    ACTIONS(335), 1,
      anon_sym_QMARK,
    ACTIONS(337), 1,
      anon_sym_TILDE,
    ACTIONS(345), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(347), 1,
      sym__number_literal,
    ACTIONS(349), 1,
      anon_sym_SQUOTE,
    ACTIONS(351), 1,
      anon_sym_DQUOTE,
    ACTIONS(361), 1,
      sym__raw_string_literal,
    ACTIONS(363), 1,
      sym__external_open_parenthesis,
    ACTIONS(365), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(10329), 1,
      anon_sym_BANG,
    ACTIONS(10683), 1,
      sym_dot_dot_i,
    STATE(24), 1,
      sym__open_brace,
    STATE(67), 1,
      sym__open_parenthesis,
    STATE(2169), 1,
      sym_string,
    STATE(2180), 1,
      sym__double_quoted_string,
    STATE(2181), 1,
      sym__single_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5149), 1,
      sym__string_or_identifier,
    ACTIONS(341), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2183), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(355), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10681), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(855), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [73659] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(10687), 1,
      sym_dot_dot_i,
    ACTIONS(10689), 1,
      sym__newline,
    STATE(292), 1,
      sym__open_brace,
    STATE(293), 1,
      sym__open_parenthesis,
    STATE(2562), 1,
      sym_string,
    STATE(2737), 1,
      sym__double_quoted_string,
    STATE(2738), 1,
      sym__single_quoted_string,
    STATE(3647), 1,
      aux_sym_function_definition_repeat1,
    STATE(5152), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2739), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10685), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1970), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [73788] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(321), 1,
      sym_identifier,
    ACTIONS(323), 1,
      anon_sym_BSLASH,
    ACTIONS(325), 1,
      anon_sym_function,
    ACTIONS(327), 1,
      anon_sym_if,
    ACTIONS(329), 1,
      anon_sym_for,
    ACTIONS(331), 1,
      anon_sym_while,
    ACTIONS(333), 1,
      anon_sym_repeat,
    ACTIONS(335), 1,
      anon_sym_QMARK,
    ACTIONS(337), 1,
      anon_sym_TILDE,
    ACTIONS(345), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(347), 1,
      sym__number_literal,
    ACTIONS(349), 1,
      anon_sym_SQUOTE,
    ACTIONS(351), 1,
      anon_sym_DQUOTE,
    ACTIONS(361), 1,
      sym__raw_string_literal,
    ACTIONS(363), 1,
      sym__external_open_parenthesis,
    ACTIONS(365), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(10329), 1,
      anon_sym_BANG,
    ACTIONS(10693), 1,
      sym_dot_dot_i,
    STATE(24), 1,
      sym__open_brace,
    STATE(67), 1,
      sym__open_parenthesis,
    STATE(2169), 1,
      sym_string,
    STATE(2180), 1,
      sym__double_quoted_string,
    STATE(2181), 1,
      sym__single_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5149), 1,
      sym__string_or_identifier,
    ACTIONS(341), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2183), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(355), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10691), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(857), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [73917] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1568), 1,
      sym_identifier,
    ACTIONS(1570), 1,
      anon_sym_BSLASH,
    ACTIONS(1572), 1,
      anon_sym_function,
    ACTIONS(1574), 1,
      anon_sym_if,
    ACTIONS(1576), 1,
      anon_sym_for,
    ACTIONS(1578), 1,
      anon_sym_while,
    ACTIONS(1580), 1,
      anon_sym_repeat,
    ACTIONS(1582), 1,
      anon_sym_QMARK,
    ACTIONS(1584), 1,
      anon_sym_TILDE,
    ACTIONS(1592), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1594), 1,
      sym__number_literal,
    ACTIONS(1596), 1,
      anon_sym_SQUOTE,
    ACTIONS(1598), 1,
      anon_sym_DQUOTE,
    ACTIONS(1608), 1,
      sym__raw_string_literal,
    ACTIONS(1610), 1,
      sym__external_open_parenthesis,
    ACTIONS(1614), 1,
      sym__external_open_brace,
    ACTIONS(8477), 1,
      anon_sym_BANG,
    ACTIONS(10697), 1,
      sym_dot_dot_i,
    ACTIONS(10699), 1,
      sym__newline,
    STATE(16), 1,
      sym__open_brace,
    STATE(119), 1,
      sym__open_parenthesis,
    STATE(2287), 1,
      sym_string,
    STATE(2289), 1,
      sym__single_quoted_string,
    STATE(2290), 1,
      sym__double_quoted_string,
    STATE(3614), 1,
      aux_sym_function_definition_repeat1,
    STATE(5144), 1,
      sym__string_or_identifier,
    ACTIONS(1588), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2288), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1602), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10695), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1227), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [74046] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1568), 1,
      sym_identifier,
    ACTIONS(1570), 1,
      anon_sym_BSLASH,
    ACTIONS(1572), 1,
      anon_sym_function,
    ACTIONS(1574), 1,
      anon_sym_if,
    ACTIONS(1576), 1,
      anon_sym_for,
    ACTIONS(1578), 1,
      anon_sym_while,
    ACTIONS(1580), 1,
      anon_sym_repeat,
    ACTIONS(1582), 1,
      anon_sym_QMARK,
    ACTIONS(1584), 1,
      anon_sym_TILDE,
    ACTIONS(1592), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1594), 1,
      sym__number_literal,
    ACTIONS(1596), 1,
      anon_sym_SQUOTE,
    ACTIONS(1598), 1,
      anon_sym_DQUOTE,
    ACTIONS(1608), 1,
      sym__raw_string_literal,
    ACTIONS(1610), 1,
      sym__external_open_parenthesis,
    ACTIONS(1614), 1,
      sym__external_open_brace,
    ACTIONS(8477), 1,
      anon_sym_BANG,
    ACTIONS(10703), 1,
      sym_dot_dot_i,
    ACTIONS(10705), 1,
      sym__newline,
    STATE(16), 1,
      sym__open_brace,
    STATE(119), 1,
      sym__open_parenthesis,
    STATE(2287), 1,
      sym_string,
    STATE(2289), 1,
      sym__single_quoted_string,
    STATE(2290), 1,
      sym__double_quoted_string,
    STATE(3616), 1,
      aux_sym_function_definition_repeat1,
    STATE(5144), 1,
      sym__string_or_identifier,
    ACTIONS(1588), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2288), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1602), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10701), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1225), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [74175] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1568), 1,
      sym_identifier,
    ACTIONS(1570), 1,
      anon_sym_BSLASH,
    ACTIONS(1572), 1,
      anon_sym_function,
    ACTIONS(1574), 1,
      anon_sym_if,
    ACTIONS(1576), 1,
      anon_sym_for,
    ACTIONS(1578), 1,
      anon_sym_while,
    ACTIONS(1580), 1,
      anon_sym_repeat,
    ACTIONS(1582), 1,
      anon_sym_QMARK,
    ACTIONS(1584), 1,
      anon_sym_TILDE,
    ACTIONS(1592), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1594), 1,
      sym__number_literal,
    ACTIONS(1596), 1,
      anon_sym_SQUOTE,
    ACTIONS(1598), 1,
      anon_sym_DQUOTE,
    ACTIONS(1608), 1,
      sym__raw_string_literal,
    ACTIONS(1610), 1,
      sym__external_open_parenthesis,
    ACTIONS(1614), 1,
      sym__external_open_brace,
    ACTIONS(8477), 1,
      anon_sym_BANG,
    ACTIONS(10709), 1,
      sym_dot_dot_i,
    ACTIONS(10711), 1,
      sym__newline,
    STATE(16), 1,
      sym__open_brace,
    STATE(119), 1,
      sym__open_parenthesis,
    STATE(2287), 1,
      sym_string,
    STATE(2289), 1,
      sym__single_quoted_string,
    STATE(2290), 1,
      sym__double_quoted_string,
    STATE(3618), 1,
      aux_sym_function_definition_repeat1,
    STATE(5144), 1,
      sym__string_or_identifier,
    ACTIONS(1588), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2288), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1602), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10707), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1224), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [74304] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1568), 1,
      sym_identifier,
    ACTIONS(1570), 1,
      anon_sym_BSLASH,
    ACTIONS(1572), 1,
      anon_sym_function,
    ACTIONS(1574), 1,
      anon_sym_if,
    ACTIONS(1576), 1,
      anon_sym_for,
    ACTIONS(1578), 1,
      anon_sym_while,
    ACTIONS(1580), 1,
      anon_sym_repeat,
    ACTIONS(1582), 1,
      anon_sym_QMARK,
    ACTIONS(1584), 1,
      anon_sym_TILDE,
    ACTIONS(1592), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1594), 1,
      sym__number_literal,
    ACTIONS(1596), 1,
      anon_sym_SQUOTE,
    ACTIONS(1598), 1,
      anon_sym_DQUOTE,
    ACTIONS(1608), 1,
      sym__raw_string_literal,
    ACTIONS(1610), 1,
      sym__external_open_parenthesis,
    ACTIONS(1614), 1,
      sym__external_open_brace,
    ACTIONS(8477), 1,
      anon_sym_BANG,
    ACTIONS(10715), 1,
      sym_dot_dot_i,
    ACTIONS(10717), 1,
      sym__newline,
    STATE(16), 1,
      sym__open_brace,
    STATE(119), 1,
      sym__open_parenthesis,
    STATE(2287), 1,
      sym_string,
    STATE(2289), 1,
      sym__single_quoted_string,
    STATE(2290), 1,
      sym__double_quoted_string,
    STATE(3620), 1,
      aux_sym_function_definition_repeat1,
    STATE(5144), 1,
      sym__string_or_identifier,
    ACTIONS(1588), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2288), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1602), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10713), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1223), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [74433] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4214), 1,
      sym_identifier,
    ACTIONS(4216), 1,
      anon_sym_BSLASH,
    ACTIONS(4218), 1,
      anon_sym_function,
    ACTIONS(4220), 1,
      anon_sym_if,
    ACTIONS(4222), 1,
      anon_sym_for,
    ACTIONS(4224), 1,
      anon_sym_while,
    ACTIONS(4226), 1,
      anon_sym_repeat,
    ACTIONS(4228), 1,
      anon_sym_QMARK,
    ACTIONS(4230), 1,
      anon_sym_TILDE,
    ACTIONS(4238), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4240), 1,
      sym__number_literal,
    ACTIONS(4242), 1,
      anon_sym_SQUOTE,
    ACTIONS(4244), 1,
      anon_sym_DQUOTE,
    ACTIONS(4254), 1,
      sym__raw_string_literal,
    ACTIONS(4256), 1,
      sym__external_open_parenthesis,
    ACTIONS(4258), 1,
      sym__external_open_brace,
    ACTIONS(9229), 1,
      anon_sym_BANG,
    ACTIONS(10721), 1,
      sym_dot_dot_i,
    ACTIONS(10723), 1,
      sym__newline,
    STATE(51), 1,
      sym__open_brace,
    STATE(287), 1,
      sym__open_parenthesis,
    STATE(3513), 1,
      aux_sym_function_definition_repeat1,
    STATE(4674), 1,
      sym__single_quoted_string,
    STATE(4678), 1,
      sym__double_quoted_string,
    STATE(4681), 1,
      sym_string,
    STATE(5129), 1,
      sym__string_or_identifier,
    ACTIONS(4234), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4680), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4248), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10719), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4410), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [74562] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4214), 1,
      sym_identifier,
    ACTIONS(4216), 1,
      anon_sym_BSLASH,
    ACTIONS(4218), 1,
      anon_sym_function,
    ACTIONS(4220), 1,
      anon_sym_if,
    ACTIONS(4222), 1,
      anon_sym_for,
    ACTIONS(4224), 1,
      anon_sym_while,
    ACTIONS(4226), 1,
      anon_sym_repeat,
    ACTIONS(4228), 1,
      anon_sym_QMARK,
    ACTIONS(4230), 1,
      anon_sym_TILDE,
    ACTIONS(4238), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4240), 1,
      sym__number_literal,
    ACTIONS(4242), 1,
      anon_sym_SQUOTE,
    ACTIONS(4244), 1,
      anon_sym_DQUOTE,
    ACTIONS(4254), 1,
      sym__raw_string_literal,
    ACTIONS(4256), 1,
      sym__external_open_parenthesis,
    ACTIONS(4258), 1,
      sym__external_open_brace,
    ACTIONS(9229), 1,
      anon_sym_BANG,
    ACTIONS(10727), 1,
      sym_dot_dot_i,
    ACTIONS(10729), 1,
      sym__newline,
    STATE(51), 1,
      sym__open_brace,
    STATE(287), 1,
      sym__open_parenthesis,
    STATE(3545), 1,
      aux_sym_function_definition_repeat1,
    STATE(4674), 1,
      sym__single_quoted_string,
    STATE(4678), 1,
      sym__double_quoted_string,
    STATE(4681), 1,
      sym_string,
    STATE(5129), 1,
      sym__string_or_identifier,
    ACTIONS(4234), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4680), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4248), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10725), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4430), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [74691] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4214), 1,
      sym_identifier,
    ACTIONS(4216), 1,
      anon_sym_BSLASH,
    ACTIONS(4218), 1,
      anon_sym_function,
    ACTIONS(4220), 1,
      anon_sym_if,
    ACTIONS(4222), 1,
      anon_sym_for,
    ACTIONS(4224), 1,
      anon_sym_while,
    ACTIONS(4226), 1,
      anon_sym_repeat,
    ACTIONS(4228), 1,
      anon_sym_QMARK,
    ACTIONS(4230), 1,
      anon_sym_TILDE,
    ACTIONS(4238), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4240), 1,
      sym__number_literal,
    ACTIONS(4242), 1,
      anon_sym_SQUOTE,
    ACTIONS(4244), 1,
      anon_sym_DQUOTE,
    ACTIONS(4254), 1,
      sym__raw_string_literal,
    ACTIONS(4256), 1,
      sym__external_open_parenthesis,
    ACTIONS(4258), 1,
      sym__external_open_brace,
    ACTIONS(9229), 1,
      anon_sym_BANG,
    ACTIONS(10733), 1,
      sym_dot_dot_i,
    ACTIONS(10735), 1,
      sym__newline,
    STATE(51), 1,
      sym__open_brace,
    STATE(287), 1,
      sym__open_parenthesis,
    STATE(3552), 1,
      aux_sym_function_definition_repeat1,
    STATE(4674), 1,
      sym__single_quoted_string,
    STATE(4678), 1,
      sym__double_quoted_string,
    STATE(4681), 1,
      sym_string,
    STATE(5129), 1,
      sym__string_or_identifier,
    ACTIONS(4234), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4680), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4248), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10731), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4387), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [74820] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(10739), 1,
      sym_dot_dot_i,
    ACTIONS(10741), 1,
      sym__newline,
    STATE(292), 1,
      sym__open_brace,
    STATE(293), 1,
      sym__open_parenthesis,
    STATE(2562), 1,
      sym_string,
    STATE(2737), 1,
      sym__double_quoted_string,
    STATE(2738), 1,
      sym__single_quoted_string,
    STATE(3649), 1,
      aux_sym_function_definition_repeat1,
    STATE(5152), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2739), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10737), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1964), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [74949] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(10745), 1,
      sym_dot_dot_i,
    ACTIONS(10747), 1,
      sym__newline,
    STATE(292), 1,
      sym__open_brace,
    STATE(293), 1,
      sym__open_parenthesis,
    STATE(2562), 1,
      sym_string,
    STATE(2737), 1,
      sym__double_quoted_string,
    STATE(2738), 1,
      sym__single_quoted_string,
    STATE(3683), 1,
      aux_sym_function_definition_repeat1,
    STATE(5152), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2739), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10743), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1960), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [75078] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2943), 1,
      sym_identifier,
    ACTIONS(2945), 1,
      anon_sym_BSLASH,
    ACTIONS(2947), 1,
      anon_sym_function,
    ACTIONS(2949), 1,
      anon_sym_if,
    ACTIONS(2951), 1,
      anon_sym_for,
    ACTIONS(2953), 1,
      anon_sym_while,
    ACTIONS(2955), 1,
      anon_sym_repeat,
    ACTIONS(2957), 1,
      anon_sym_QMARK,
    ACTIONS(2959), 1,
      anon_sym_TILDE,
    ACTIONS(2967), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2969), 1,
      sym__number_literal,
    ACTIONS(2971), 1,
      anon_sym_SQUOTE,
    ACTIONS(2973), 1,
      anon_sym_DQUOTE,
    ACTIONS(2983), 1,
      sym__raw_string_literal,
    ACTIONS(2985), 1,
      sym__external_open_parenthesis,
    ACTIONS(2989), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7797), 1,
      anon_sym_BANG,
    ACTIONS(10751), 1,
      sym_dot_dot_i,
    STATE(173), 1,
      sym__open_brace,
    STATE(246), 1,
      sym__open_parenthesis,
    STATE(2462), 1,
      sym__single_quoted_string,
    STATE(2494), 1,
      sym__double_quoted_string,
    STATE(2541), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5128), 1,
      sym__string_or_identifier,
    ACTIONS(2963), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2540), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2977), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10749), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1556), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [75207] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(10755), 1,
      sym_dot_dot_i,
    ACTIONS(10757), 1,
      sym__newline,
    STATE(292), 1,
      sym__open_brace,
    STATE(293), 1,
      sym__open_parenthesis,
    STATE(2562), 1,
      sym_string,
    STATE(2737), 1,
      sym__double_quoted_string,
    STATE(2738), 1,
      sym__single_quoted_string,
    STATE(3685), 1,
      aux_sym_function_definition_repeat1,
    STATE(5152), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2739), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10753), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1936), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [75336] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(626), 1,
      sym_identifier,
    ACTIONS(628), 1,
      anon_sym_BSLASH,
    ACTIONS(630), 1,
      anon_sym_function,
    ACTIONS(632), 1,
      anon_sym_if,
    ACTIONS(634), 1,
      anon_sym_for,
    ACTIONS(636), 1,
      anon_sym_while,
    ACTIONS(638), 1,
      anon_sym_repeat,
    ACTIONS(640), 1,
      anon_sym_QMARK,
    ACTIONS(642), 1,
      anon_sym_TILDE,
    ACTIONS(650), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(652), 1,
      sym__number_literal,
    ACTIONS(654), 1,
      anon_sym_SQUOTE,
    ACTIONS(656), 1,
      anon_sym_DQUOTE,
    ACTIONS(666), 1,
      sym__raw_string_literal,
    ACTIONS(668), 1,
      sym__external_open_parenthesis,
    ACTIONS(670), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7933), 1,
      anon_sym_BANG,
    ACTIONS(10761), 1,
      sym_dot_dot_i,
    STATE(54), 1,
      sym__open_parenthesis,
    STATE(56), 1,
      sym__open_brace,
    STATE(2219), 1,
      sym_string,
    STATE(2221), 1,
      sym__single_quoted_string,
    STATE(2222), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5140), 1,
      sym__string_or_identifier,
    ACTIONS(646), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2220), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(660), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10759), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(731), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [75465] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(626), 1,
      sym_identifier,
    ACTIONS(628), 1,
      anon_sym_BSLASH,
    ACTIONS(630), 1,
      anon_sym_function,
    ACTIONS(632), 1,
      anon_sym_if,
    ACTIONS(634), 1,
      anon_sym_for,
    ACTIONS(636), 1,
      anon_sym_while,
    ACTIONS(638), 1,
      anon_sym_repeat,
    ACTIONS(640), 1,
      anon_sym_QMARK,
    ACTIONS(642), 1,
      anon_sym_TILDE,
    ACTIONS(650), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(652), 1,
      sym__number_literal,
    ACTIONS(654), 1,
      anon_sym_SQUOTE,
    ACTIONS(656), 1,
      anon_sym_DQUOTE,
    ACTIONS(666), 1,
      sym__raw_string_literal,
    ACTIONS(668), 1,
      sym__external_open_parenthesis,
    ACTIONS(670), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7933), 1,
      anon_sym_BANG,
    ACTIONS(10765), 1,
      sym_dot_dot_i,
    STATE(54), 1,
      sym__open_parenthesis,
    STATE(56), 1,
      sym__open_brace,
    STATE(2219), 1,
      sym_string,
    STATE(2221), 1,
      sym__single_quoted_string,
    STATE(2222), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5140), 1,
      sym__string_or_identifier,
    ACTIONS(646), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2220), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(660), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10763), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(733), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [75594] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1568), 1,
      sym_identifier,
    ACTIONS(1570), 1,
      anon_sym_BSLASH,
    ACTIONS(1572), 1,
      anon_sym_function,
    ACTIONS(1574), 1,
      anon_sym_if,
    ACTIONS(1576), 1,
      anon_sym_for,
    ACTIONS(1578), 1,
      anon_sym_while,
    ACTIONS(1580), 1,
      anon_sym_repeat,
    ACTIONS(1582), 1,
      anon_sym_QMARK,
    ACTIONS(1584), 1,
      anon_sym_TILDE,
    ACTIONS(1592), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1594), 1,
      sym__number_literal,
    ACTIONS(1596), 1,
      anon_sym_SQUOTE,
    ACTIONS(1598), 1,
      anon_sym_DQUOTE,
    ACTIONS(1608), 1,
      sym__raw_string_literal,
    ACTIONS(1610), 1,
      sym__external_open_parenthesis,
    ACTIONS(1614), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8477), 1,
      anon_sym_BANG,
    ACTIONS(10769), 1,
      sym_dot_dot_i,
    STATE(16), 1,
      sym__open_brace,
    STATE(119), 1,
      sym__open_parenthesis,
    STATE(2287), 1,
      sym_string,
    STATE(2289), 1,
      sym__single_quoted_string,
    STATE(2290), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5144), 1,
      sym__string_or_identifier,
    ACTIONS(1588), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2288), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1602), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10767), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1215), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [75723] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(10773), 1,
      sym_dot_dot_i,
    ACTIONS(10775), 1,
      sym__newline,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(3801), 1,
      aux_sym_function_definition_repeat1,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10771), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4575), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [75852] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1568), 1,
      sym_identifier,
    ACTIONS(1570), 1,
      anon_sym_BSLASH,
    ACTIONS(1572), 1,
      anon_sym_function,
    ACTIONS(1574), 1,
      anon_sym_if,
    ACTIONS(1576), 1,
      anon_sym_for,
    ACTIONS(1578), 1,
      anon_sym_while,
    ACTIONS(1580), 1,
      anon_sym_repeat,
    ACTIONS(1582), 1,
      anon_sym_QMARK,
    ACTIONS(1584), 1,
      anon_sym_TILDE,
    ACTIONS(1592), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1594), 1,
      sym__number_literal,
    ACTIONS(1596), 1,
      anon_sym_SQUOTE,
    ACTIONS(1598), 1,
      anon_sym_DQUOTE,
    ACTIONS(1608), 1,
      sym__raw_string_literal,
    ACTIONS(1610), 1,
      sym__external_open_parenthesis,
    ACTIONS(1614), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8477), 1,
      anon_sym_BANG,
    ACTIONS(10779), 1,
      sym_dot_dot_i,
    STATE(16), 1,
      sym__open_brace,
    STATE(119), 1,
      sym__open_parenthesis,
    STATE(2287), 1,
      sym_string,
    STATE(2289), 1,
      sym__single_quoted_string,
    STATE(2290), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5144), 1,
      sym__string_or_identifier,
    ACTIONS(1588), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2288), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1602), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10777), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1214), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [75981] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(10783), 1,
      sym_dot_dot_i,
    ACTIONS(10785), 1,
      sym__newline,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(3723), 1,
      aux_sym_function_definition_repeat1,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10781), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4460), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [76110] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1568), 1,
      sym_identifier,
    ACTIONS(1570), 1,
      anon_sym_BSLASH,
    ACTIONS(1572), 1,
      anon_sym_function,
    ACTIONS(1574), 1,
      anon_sym_if,
    ACTIONS(1576), 1,
      anon_sym_for,
    ACTIONS(1578), 1,
      anon_sym_while,
    ACTIONS(1580), 1,
      anon_sym_repeat,
    ACTIONS(1582), 1,
      anon_sym_QMARK,
    ACTIONS(1584), 1,
      anon_sym_TILDE,
    ACTIONS(1592), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1594), 1,
      sym__number_literal,
    ACTIONS(1596), 1,
      anon_sym_SQUOTE,
    ACTIONS(1598), 1,
      anon_sym_DQUOTE,
    ACTIONS(1608), 1,
      sym__raw_string_literal,
    ACTIONS(1610), 1,
      sym__external_open_parenthesis,
    ACTIONS(1614), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8477), 1,
      anon_sym_BANG,
    ACTIONS(10789), 1,
      sym_dot_dot_i,
    STATE(16), 1,
      sym__open_brace,
    STATE(119), 1,
      sym__open_parenthesis,
    STATE(2287), 1,
      sym_string,
    STATE(2289), 1,
      sym__single_quoted_string,
    STATE(2290), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5144), 1,
      sym__string_or_identifier,
    ACTIONS(1588), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2288), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1602), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10787), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1212), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [76239] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4214), 1,
      sym_identifier,
    ACTIONS(4216), 1,
      anon_sym_BSLASH,
    ACTIONS(4218), 1,
      anon_sym_function,
    ACTIONS(4220), 1,
      anon_sym_if,
    ACTIONS(4222), 1,
      anon_sym_for,
    ACTIONS(4224), 1,
      anon_sym_while,
    ACTIONS(4226), 1,
      anon_sym_repeat,
    ACTIONS(4228), 1,
      anon_sym_QMARK,
    ACTIONS(4230), 1,
      anon_sym_TILDE,
    ACTIONS(4238), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4240), 1,
      sym__number_literal,
    ACTIONS(4242), 1,
      anon_sym_SQUOTE,
    ACTIONS(4244), 1,
      anon_sym_DQUOTE,
    ACTIONS(4254), 1,
      sym__raw_string_literal,
    ACTIONS(4256), 1,
      sym__external_open_parenthesis,
    ACTIONS(4258), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9229), 1,
      anon_sym_BANG,
    ACTIONS(10793), 1,
      sym_dot_dot_i,
    STATE(51), 1,
      sym__open_brace,
    STATE(287), 1,
      sym__open_parenthesis,
    STATE(4674), 1,
      sym__single_quoted_string,
    STATE(4678), 1,
      sym__double_quoted_string,
    STATE(4681), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5129), 1,
      sym__string_or_identifier,
    ACTIONS(4234), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4680), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4248), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10791), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4390), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [76368] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1568), 1,
      sym_identifier,
    ACTIONS(1570), 1,
      anon_sym_BSLASH,
    ACTIONS(1572), 1,
      anon_sym_function,
    ACTIONS(1574), 1,
      anon_sym_if,
    ACTIONS(1576), 1,
      anon_sym_for,
    ACTIONS(1578), 1,
      anon_sym_while,
    ACTIONS(1580), 1,
      anon_sym_repeat,
    ACTIONS(1582), 1,
      anon_sym_QMARK,
    ACTIONS(1584), 1,
      anon_sym_TILDE,
    ACTIONS(1592), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1594), 1,
      sym__number_literal,
    ACTIONS(1596), 1,
      anon_sym_SQUOTE,
    ACTIONS(1598), 1,
      anon_sym_DQUOTE,
    ACTIONS(1608), 1,
      sym__raw_string_literal,
    ACTIONS(1610), 1,
      sym__external_open_parenthesis,
    ACTIONS(1614), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8477), 1,
      anon_sym_BANG,
    ACTIONS(10797), 1,
      sym_dot_dot_i,
    STATE(16), 1,
      sym__open_brace,
    STATE(119), 1,
      sym__open_parenthesis,
    STATE(2287), 1,
      sym_string,
    STATE(2289), 1,
      sym__single_quoted_string,
    STATE(2290), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5144), 1,
      sym__string_or_identifier,
    ACTIONS(1588), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2288), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1602), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10795), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1211), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [76497] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(626), 1,
      sym_identifier,
    ACTIONS(628), 1,
      anon_sym_BSLASH,
    ACTIONS(630), 1,
      anon_sym_function,
    ACTIONS(632), 1,
      anon_sym_if,
    ACTIONS(634), 1,
      anon_sym_for,
    ACTIONS(636), 1,
      anon_sym_while,
    ACTIONS(638), 1,
      anon_sym_repeat,
    ACTIONS(640), 1,
      anon_sym_QMARK,
    ACTIONS(642), 1,
      anon_sym_TILDE,
    ACTIONS(650), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(652), 1,
      sym__number_literal,
    ACTIONS(654), 1,
      anon_sym_SQUOTE,
    ACTIONS(656), 1,
      anon_sym_DQUOTE,
    ACTIONS(666), 1,
      sym__raw_string_literal,
    ACTIONS(668), 1,
      sym__external_open_parenthesis,
    ACTIONS(670), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7933), 1,
      anon_sym_BANG,
    ACTIONS(10801), 1,
      sym_dot_dot_i,
    STATE(54), 1,
      sym__open_parenthesis,
    STATE(56), 1,
      sym__open_brace,
    STATE(2219), 1,
      sym_string,
    STATE(2221), 1,
      sym__single_quoted_string,
    STATE(2222), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5140), 1,
      sym__string_or_identifier,
    ACTIONS(646), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2220), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(660), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10799), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(735), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [76626] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4214), 1,
      sym_identifier,
    ACTIONS(4216), 1,
      anon_sym_BSLASH,
    ACTIONS(4218), 1,
      anon_sym_function,
    ACTIONS(4220), 1,
      anon_sym_if,
    ACTIONS(4222), 1,
      anon_sym_for,
    ACTIONS(4224), 1,
      anon_sym_while,
    ACTIONS(4226), 1,
      anon_sym_repeat,
    ACTIONS(4228), 1,
      anon_sym_QMARK,
    ACTIONS(4230), 1,
      anon_sym_TILDE,
    ACTIONS(4238), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4240), 1,
      sym__number_literal,
    ACTIONS(4242), 1,
      anon_sym_SQUOTE,
    ACTIONS(4244), 1,
      anon_sym_DQUOTE,
    ACTIONS(4254), 1,
      sym__raw_string_literal,
    ACTIONS(4256), 1,
      sym__external_open_parenthesis,
    ACTIONS(4258), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9229), 1,
      anon_sym_BANG,
    ACTIONS(10805), 1,
      sym_dot_dot_i,
    STATE(51), 1,
      sym__open_brace,
    STATE(287), 1,
      sym__open_parenthesis,
    STATE(4674), 1,
      sym__single_quoted_string,
    STATE(4678), 1,
      sym__double_quoted_string,
    STATE(4681), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5129), 1,
      sym__string_or_identifier,
    ACTIONS(4234), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4680), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4248), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10803), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4394), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [76755] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3845), 1,
      sym_identifier,
    ACTIONS(3847), 1,
      anon_sym_BSLASH,
    ACTIONS(3849), 1,
      anon_sym_function,
    ACTIONS(3851), 1,
      anon_sym_if,
    ACTIONS(3853), 1,
      anon_sym_for,
    ACTIONS(3855), 1,
      anon_sym_while,
    ACTIONS(3857), 1,
      anon_sym_repeat,
    ACTIONS(3859), 1,
      anon_sym_QMARK,
    ACTIONS(3861), 1,
      anon_sym_TILDE,
    ACTIONS(3869), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3871), 1,
      sym__number_literal,
    ACTIONS(3873), 1,
      anon_sym_SQUOTE,
    ACTIONS(3875), 1,
      anon_sym_DQUOTE,
    ACTIONS(3885), 1,
      sym__raw_string_literal,
    ACTIONS(3887), 1,
      sym__external_open_parenthesis,
    ACTIONS(3891), 1,
      sym__external_open_brace,
    ACTIONS(6389), 1,
      anon_sym_BANG,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(10809), 1,
      sym_dot_dot_i,
    STATE(154), 1,
      sym__open_brace,
    STATE(350), 1,
      sym__open_parenthesis,
    STATE(2620), 1,
      sym__double_quoted_string,
    STATE(2673), 1,
      sym_string,
    STATE(2735), 1,
      sym__single_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5135), 1,
      sym__string_or_identifier,
    ACTIONS(3865), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2578), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3879), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10807), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2096), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [76884] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4214), 1,
      sym_identifier,
    ACTIONS(4216), 1,
      anon_sym_BSLASH,
    ACTIONS(4218), 1,
      anon_sym_function,
    ACTIONS(4220), 1,
      anon_sym_if,
    ACTIONS(4222), 1,
      anon_sym_for,
    ACTIONS(4224), 1,
      anon_sym_while,
    ACTIONS(4226), 1,
      anon_sym_repeat,
    ACTIONS(4228), 1,
      anon_sym_QMARK,
    ACTIONS(4230), 1,
      anon_sym_TILDE,
    ACTIONS(4238), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4240), 1,
      sym__number_literal,
    ACTIONS(4242), 1,
      anon_sym_SQUOTE,
    ACTIONS(4244), 1,
      anon_sym_DQUOTE,
    ACTIONS(4254), 1,
      sym__raw_string_literal,
    ACTIONS(4256), 1,
      sym__external_open_parenthesis,
    ACTIONS(4258), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9229), 1,
      anon_sym_BANG,
    ACTIONS(10813), 1,
      sym_dot_dot_i,
    STATE(51), 1,
      sym__open_brace,
    STATE(287), 1,
      sym__open_parenthesis,
    STATE(4674), 1,
      sym__single_quoted_string,
    STATE(4678), 1,
      sym__double_quoted_string,
    STATE(4681), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5129), 1,
      sym__string_or_identifier,
    ACTIONS(4234), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4680), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4248), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10811), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4396), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [77013] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1568), 1,
      sym_identifier,
    ACTIONS(1570), 1,
      anon_sym_BSLASH,
    ACTIONS(1572), 1,
      anon_sym_function,
    ACTIONS(1574), 1,
      anon_sym_if,
    ACTIONS(1576), 1,
      anon_sym_for,
    ACTIONS(1578), 1,
      anon_sym_while,
    ACTIONS(1580), 1,
      anon_sym_repeat,
    ACTIONS(1582), 1,
      anon_sym_QMARK,
    ACTIONS(1584), 1,
      anon_sym_TILDE,
    ACTIONS(1592), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1594), 1,
      sym__number_literal,
    ACTIONS(1596), 1,
      anon_sym_SQUOTE,
    ACTIONS(1598), 1,
      anon_sym_DQUOTE,
    ACTIONS(1608), 1,
      sym__raw_string_literal,
    ACTIONS(1610), 1,
      sym__external_open_parenthesis,
    ACTIONS(1614), 1,
      sym__external_open_brace,
    ACTIONS(8477), 1,
      anon_sym_BANG,
    ACTIONS(10817), 1,
      sym_dot_dot_i,
    ACTIONS(10819), 1,
      sym__newline,
    STATE(16), 1,
      sym__open_brace,
    STATE(119), 1,
      sym__open_parenthesis,
    STATE(2287), 1,
      sym_string,
    STATE(2289), 1,
      sym__single_quoted_string,
    STATE(2290), 1,
      sym__double_quoted_string,
    STATE(3658), 1,
      aux_sym_function_definition_repeat1,
    STATE(5144), 1,
      sym__string_or_identifier,
    ACTIONS(1588), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2288), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1602), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10815), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1210), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [77142] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1568), 1,
      sym_identifier,
    ACTIONS(1570), 1,
      anon_sym_BSLASH,
    ACTIONS(1572), 1,
      anon_sym_function,
    ACTIONS(1574), 1,
      anon_sym_if,
    ACTIONS(1576), 1,
      anon_sym_for,
    ACTIONS(1578), 1,
      anon_sym_while,
    ACTIONS(1580), 1,
      anon_sym_repeat,
    ACTIONS(1582), 1,
      anon_sym_QMARK,
    ACTIONS(1584), 1,
      anon_sym_TILDE,
    ACTIONS(1592), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1594), 1,
      sym__number_literal,
    ACTIONS(1596), 1,
      anon_sym_SQUOTE,
    ACTIONS(1598), 1,
      anon_sym_DQUOTE,
    ACTIONS(1608), 1,
      sym__raw_string_literal,
    ACTIONS(1610), 1,
      sym__external_open_parenthesis,
    ACTIONS(1614), 1,
      sym__external_open_brace,
    ACTIONS(8477), 1,
      anon_sym_BANG,
    ACTIONS(10823), 1,
      sym_dot_dot_i,
    ACTIONS(10825), 1,
      sym__newline,
    STATE(16), 1,
      sym__open_brace,
    STATE(119), 1,
      sym__open_parenthesis,
    STATE(2287), 1,
      sym_string,
    STATE(2289), 1,
      sym__single_quoted_string,
    STATE(2290), 1,
      sym__double_quoted_string,
    STATE(3660), 1,
      aux_sym_function_definition_repeat1,
    STATE(5144), 1,
      sym__string_or_identifier,
    ACTIONS(1588), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2288), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1602), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10821), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1209), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [77271] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1568), 1,
      sym_identifier,
    ACTIONS(1570), 1,
      anon_sym_BSLASH,
    ACTIONS(1572), 1,
      anon_sym_function,
    ACTIONS(1574), 1,
      anon_sym_if,
    ACTIONS(1576), 1,
      anon_sym_for,
    ACTIONS(1578), 1,
      anon_sym_while,
    ACTIONS(1580), 1,
      anon_sym_repeat,
    ACTIONS(1582), 1,
      anon_sym_QMARK,
    ACTIONS(1584), 1,
      anon_sym_TILDE,
    ACTIONS(1592), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1594), 1,
      sym__number_literal,
    ACTIONS(1596), 1,
      anon_sym_SQUOTE,
    ACTIONS(1598), 1,
      anon_sym_DQUOTE,
    ACTIONS(1608), 1,
      sym__raw_string_literal,
    ACTIONS(1610), 1,
      sym__external_open_parenthesis,
    ACTIONS(1614), 1,
      sym__external_open_brace,
    ACTIONS(8477), 1,
      anon_sym_BANG,
    ACTIONS(10829), 1,
      sym_dot_dot_i,
    ACTIONS(10831), 1,
      sym__newline,
    STATE(16), 1,
      sym__open_brace,
    STATE(119), 1,
      sym__open_parenthesis,
    STATE(2287), 1,
      sym_string,
    STATE(2289), 1,
      sym__single_quoted_string,
    STATE(2290), 1,
      sym__double_quoted_string,
    STATE(3662), 1,
      aux_sym_function_definition_repeat1,
    STATE(5144), 1,
      sym__string_or_identifier,
    ACTIONS(1588), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2288), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1602), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10827), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1208), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [77400] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1568), 1,
      sym_identifier,
    ACTIONS(1570), 1,
      anon_sym_BSLASH,
    ACTIONS(1572), 1,
      anon_sym_function,
    ACTIONS(1574), 1,
      anon_sym_if,
    ACTIONS(1576), 1,
      anon_sym_for,
    ACTIONS(1578), 1,
      anon_sym_while,
    ACTIONS(1580), 1,
      anon_sym_repeat,
    ACTIONS(1582), 1,
      anon_sym_QMARK,
    ACTIONS(1584), 1,
      anon_sym_TILDE,
    ACTIONS(1592), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1594), 1,
      sym__number_literal,
    ACTIONS(1596), 1,
      anon_sym_SQUOTE,
    ACTIONS(1598), 1,
      anon_sym_DQUOTE,
    ACTIONS(1608), 1,
      sym__raw_string_literal,
    ACTIONS(1610), 1,
      sym__external_open_parenthesis,
    ACTIONS(1614), 1,
      sym__external_open_brace,
    ACTIONS(8477), 1,
      anon_sym_BANG,
    ACTIONS(10835), 1,
      sym_dot_dot_i,
    ACTIONS(10837), 1,
      sym__newline,
    STATE(16), 1,
      sym__open_brace,
    STATE(119), 1,
      sym__open_parenthesis,
    STATE(2287), 1,
      sym_string,
    STATE(2289), 1,
      sym__single_quoted_string,
    STATE(2290), 1,
      sym__double_quoted_string,
    STATE(3664), 1,
      aux_sym_function_definition_repeat1,
    STATE(5144), 1,
      sym__string_or_identifier,
    ACTIONS(1588), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2288), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1602), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10833), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1207), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [77529] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1568), 1,
      sym_identifier,
    ACTIONS(1570), 1,
      anon_sym_BSLASH,
    ACTIONS(1572), 1,
      anon_sym_function,
    ACTIONS(1574), 1,
      anon_sym_if,
    ACTIONS(1576), 1,
      anon_sym_for,
    ACTIONS(1578), 1,
      anon_sym_while,
    ACTIONS(1580), 1,
      anon_sym_repeat,
    ACTIONS(1582), 1,
      anon_sym_QMARK,
    ACTIONS(1584), 1,
      anon_sym_TILDE,
    ACTIONS(1592), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1594), 1,
      sym__number_literal,
    ACTIONS(1596), 1,
      anon_sym_SQUOTE,
    ACTIONS(1598), 1,
      anon_sym_DQUOTE,
    ACTIONS(1608), 1,
      sym__raw_string_literal,
    ACTIONS(1610), 1,
      sym__external_open_parenthesis,
    ACTIONS(1614), 1,
      sym__external_open_brace,
    ACTIONS(8477), 1,
      anon_sym_BANG,
    ACTIONS(10841), 1,
      sym_dot_dot_i,
    ACTIONS(10843), 1,
      sym__newline,
    STATE(16), 1,
      sym__open_brace,
    STATE(119), 1,
      sym__open_parenthesis,
    STATE(2287), 1,
      sym_string,
    STATE(2289), 1,
      sym__single_quoted_string,
    STATE(2290), 1,
      sym__double_quoted_string,
    STATE(3666), 1,
      aux_sym_function_definition_repeat1,
    STATE(5144), 1,
      sym__string_or_identifier,
    ACTIONS(1588), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2288), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1602), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10839), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1206), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [77658] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1568), 1,
      sym_identifier,
    ACTIONS(1570), 1,
      anon_sym_BSLASH,
    ACTIONS(1572), 1,
      anon_sym_function,
    ACTIONS(1574), 1,
      anon_sym_if,
    ACTIONS(1576), 1,
      anon_sym_for,
    ACTIONS(1578), 1,
      anon_sym_while,
    ACTIONS(1580), 1,
      anon_sym_repeat,
    ACTIONS(1582), 1,
      anon_sym_QMARK,
    ACTIONS(1584), 1,
      anon_sym_TILDE,
    ACTIONS(1592), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1594), 1,
      sym__number_literal,
    ACTIONS(1596), 1,
      anon_sym_SQUOTE,
    ACTIONS(1598), 1,
      anon_sym_DQUOTE,
    ACTIONS(1608), 1,
      sym__raw_string_literal,
    ACTIONS(1610), 1,
      sym__external_open_parenthesis,
    ACTIONS(1614), 1,
      sym__external_open_brace,
    ACTIONS(8477), 1,
      anon_sym_BANG,
    ACTIONS(10847), 1,
      sym_dot_dot_i,
    ACTIONS(10849), 1,
      sym__newline,
    STATE(16), 1,
      sym__open_brace,
    STATE(119), 1,
      sym__open_parenthesis,
    STATE(2287), 1,
      sym_string,
    STATE(2289), 1,
      sym__single_quoted_string,
    STATE(2290), 1,
      sym__double_quoted_string,
    STATE(3668), 1,
      aux_sym_function_definition_repeat1,
    STATE(5144), 1,
      sym__string_or_identifier,
    ACTIONS(1588), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2288), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1602), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10845), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1205), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [77787] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1568), 1,
      sym_identifier,
    ACTIONS(1570), 1,
      anon_sym_BSLASH,
    ACTIONS(1572), 1,
      anon_sym_function,
    ACTIONS(1574), 1,
      anon_sym_if,
    ACTIONS(1576), 1,
      anon_sym_for,
    ACTIONS(1578), 1,
      anon_sym_while,
    ACTIONS(1580), 1,
      anon_sym_repeat,
    ACTIONS(1582), 1,
      anon_sym_QMARK,
    ACTIONS(1584), 1,
      anon_sym_TILDE,
    ACTIONS(1592), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1594), 1,
      sym__number_literal,
    ACTIONS(1596), 1,
      anon_sym_SQUOTE,
    ACTIONS(1598), 1,
      anon_sym_DQUOTE,
    ACTIONS(1608), 1,
      sym__raw_string_literal,
    ACTIONS(1610), 1,
      sym__external_open_parenthesis,
    ACTIONS(1614), 1,
      sym__external_open_brace,
    ACTIONS(8477), 1,
      anon_sym_BANG,
    ACTIONS(10853), 1,
      sym_dot_dot_i,
    ACTIONS(10855), 1,
      sym__newline,
    STATE(16), 1,
      sym__open_brace,
    STATE(119), 1,
      sym__open_parenthesis,
    STATE(2287), 1,
      sym_string,
    STATE(2289), 1,
      sym__single_quoted_string,
    STATE(2290), 1,
      sym__double_quoted_string,
    STATE(3670), 1,
      aux_sym_function_definition_repeat1,
    STATE(5144), 1,
      sym__string_or_identifier,
    ACTIONS(1588), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2288), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1602), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10851), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1204), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [77916] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1568), 1,
      sym_identifier,
    ACTIONS(1570), 1,
      anon_sym_BSLASH,
    ACTIONS(1572), 1,
      anon_sym_function,
    ACTIONS(1574), 1,
      anon_sym_if,
    ACTIONS(1576), 1,
      anon_sym_for,
    ACTIONS(1578), 1,
      anon_sym_while,
    ACTIONS(1580), 1,
      anon_sym_repeat,
    ACTIONS(1582), 1,
      anon_sym_QMARK,
    ACTIONS(1584), 1,
      anon_sym_TILDE,
    ACTIONS(1592), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1594), 1,
      sym__number_literal,
    ACTIONS(1596), 1,
      anon_sym_SQUOTE,
    ACTIONS(1598), 1,
      anon_sym_DQUOTE,
    ACTIONS(1608), 1,
      sym__raw_string_literal,
    ACTIONS(1610), 1,
      sym__external_open_parenthesis,
    ACTIONS(1614), 1,
      sym__external_open_brace,
    ACTIONS(8477), 1,
      anon_sym_BANG,
    ACTIONS(10859), 1,
      sym_dot_dot_i,
    ACTIONS(10861), 1,
      sym__newline,
    STATE(16), 1,
      sym__open_brace,
    STATE(119), 1,
      sym__open_parenthesis,
    STATE(2287), 1,
      sym_string,
    STATE(2289), 1,
      sym__single_quoted_string,
    STATE(2290), 1,
      sym__double_quoted_string,
    STATE(3672), 1,
      aux_sym_function_definition_repeat1,
    STATE(5144), 1,
      sym__string_or_identifier,
    ACTIONS(1588), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2288), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1602), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10857), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1203), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [78045] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1568), 1,
      sym_identifier,
    ACTIONS(1570), 1,
      anon_sym_BSLASH,
    ACTIONS(1572), 1,
      anon_sym_function,
    ACTIONS(1574), 1,
      anon_sym_if,
    ACTIONS(1576), 1,
      anon_sym_for,
    ACTIONS(1578), 1,
      anon_sym_while,
    ACTIONS(1580), 1,
      anon_sym_repeat,
    ACTIONS(1582), 1,
      anon_sym_QMARK,
    ACTIONS(1584), 1,
      anon_sym_TILDE,
    ACTIONS(1592), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1594), 1,
      sym__number_literal,
    ACTIONS(1596), 1,
      anon_sym_SQUOTE,
    ACTIONS(1598), 1,
      anon_sym_DQUOTE,
    ACTIONS(1608), 1,
      sym__raw_string_literal,
    ACTIONS(1610), 1,
      sym__external_open_parenthesis,
    ACTIONS(1614), 1,
      sym__external_open_brace,
    ACTIONS(8477), 1,
      anon_sym_BANG,
    ACTIONS(10865), 1,
      sym_dot_dot_i,
    ACTIONS(10867), 1,
      sym__newline,
    STATE(16), 1,
      sym__open_brace,
    STATE(119), 1,
      sym__open_parenthesis,
    STATE(2287), 1,
      sym_string,
    STATE(2289), 1,
      sym__single_quoted_string,
    STATE(2290), 1,
      sym__double_quoted_string,
    STATE(3674), 1,
      aux_sym_function_definition_repeat1,
    STATE(5144), 1,
      sym__string_or_identifier,
    ACTIONS(1588), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2288), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1602), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10863), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1202), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [78174] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1568), 1,
      sym_identifier,
    ACTIONS(1570), 1,
      anon_sym_BSLASH,
    ACTIONS(1572), 1,
      anon_sym_function,
    ACTIONS(1574), 1,
      anon_sym_if,
    ACTIONS(1576), 1,
      anon_sym_for,
    ACTIONS(1578), 1,
      anon_sym_while,
    ACTIONS(1580), 1,
      anon_sym_repeat,
    ACTIONS(1582), 1,
      anon_sym_QMARK,
    ACTIONS(1584), 1,
      anon_sym_TILDE,
    ACTIONS(1592), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1594), 1,
      sym__number_literal,
    ACTIONS(1596), 1,
      anon_sym_SQUOTE,
    ACTIONS(1598), 1,
      anon_sym_DQUOTE,
    ACTIONS(1608), 1,
      sym__raw_string_literal,
    ACTIONS(1610), 1,
      sym__external_open_parenthesis,
    ACTIONS(1614), 1,
      sym__external_open_brace,
    ACTIONS(8477), 1,
      anon_sym_BANG,
    ACTIONS(10871), 1,
      sym_dot_dot_i,
    ACTIONS(10873), 1,
      sym__newline,
    STATE(16), 1,
      sym__open_brace,
    STATE(119), 1,
      sym__open_parenthesis,
    STATE(2287), 1,
      sym_string,
    STATE(2289), 1,
      sym__single_quoted_string,
    STATE(2290), 1,
      sym__double_quoted_string,
    STATE(3676), 1,
      aux_sym_function_definition_repeat1,
    STATE(5144), 1,
      sym__string_or_identifier,
    ACTIONS(1588), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2288), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1602), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10869), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1201), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [78303] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1568), 1,
      sym_identifier,
    ACTIONS(1570), 1,
      anon_sym_BSLASH,
    ACTIONS(1572), 1,
      anon_sym_function,
    ACTIONS(1574), 1,
      anon_sym_if,
    ACTIONS(1576), 1,
      anon_sym_for,
    ACTIONS(1578), 1,
      anon_sym_while,
    ACTIONS(1580), 1,
      anon_sym_repeat,
    ACTIONS(1582), 1,
      anon_sym_QMARK,
    ACTIONS(1584), 1,
      anon_sym_TILDE,
    ACTIONS(1592), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1594), 1,
      sym__number_literal,
    ACTIONS(1596), 1,
      anon_sym_SQUOTE,
    ACTIONS(1598), 1,
      anon_sym_DQUOTE,
    ACTIONS(1608), 1,
      sym__raw_string_literal,
    ACTIONS(1610), 1,
      sym__external_open_parenthesis,
    ACTIONS(1614), 1,
      sym__external_open_brace,
    ACTIONS(8477), 1,
      anon_sym_BANG,
    ACTIONS(10877), 1,
      sym_dot_dot_i,
    ACTIONS(10879), 1,
      sym__newline,
    STATE(16), 1,
      sym__open_brace,
    STATE(119), 1,
      sym__open_parenthesis,
    STATE(2287), 1,
      sym_string,
    STATE(2289), 1,
      sym__single_quoted_string,
    STATE(2290), 1,
      sym__double_quoted_string,
    STATE(3678), 1,
      aux_sym_function_definition_repeat1,
    STATE(5144), 1,
      sym__string_or_identifier,
    ACTIONS(1588), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2288), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1602), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10875), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1200), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [78432] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1568), 1,
      sym_identifier,
    ACTIONS(1570), 1,
      anon_sym_BSLASH,
    ACTIONS(1572), 1,
      anon_sym_function,
    ACTIONS(1574), 1,
      anon_sym_if,
    ACTIONS(1576), 1,
      anon_sym_for,
    ACTIONS(1578), 1,
      anon_sym_while,
    ACTIONS(1580), 1,
      anon_sym_repeat,
    ACTIONS(1582), 1,
      anon_sym_QMARK,
    ACTIONS(1584), 1,
      anon_sym_TILDE,
    ACTIONS(1592), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1594), 1,
      sym__number_literal,
    ACTIONS(1596), 1,
      anon_sym_SQUOTE,
    ACTIONS(1598), 1,
      anon_sym_DQUOTE,
    ACTIONS(1608), 1,
      sym__raw_string_literal,
    ACTIONS(1610), 1,
      sym__external_open_parenthesis,
    ACTIONS(1614), 1,
      sym__external_open_brace,
    ACTIONS(8477), 1,
      anon_sym_BANG,
    ACTIONS(10883), 1,
      sym_dot_dot_i,
    ACTIONS(10885), 1,
      sym__newline,
    STATE(16), 1,
      sym__open_brace,
    STATE(119), 1,
      sym__open_parenthesis,
    STATE(2287), 1,
      sym_string,
    STATE(2289), 1,
      sym__single_quoted_string,
    STATE(2290), 1,
      sym__double_quoted_string,
    STATE(3680), 1,
      aux_sym_function_definition_repeat1,
    STATE(5144), 1,
      sym__string_or_identifier,
    ACTIONS(1588), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2288), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1602), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10881), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1199), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [78561] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1568), 1,
      sym_identifier,
    ACTIONS(1570), 1,
      anon_sym_BSLASH,
    ACTIONS(1572), 1,
      anon_sym_function,
    ACTIONS(1574), 1,
      anon_sym_if,
    ACTIONS(1576), 1,
      anon_sym_for,
    ACTIONS(1578), 1,
      anon_sym_while,
    ACTIONS(1580), 1,
      anon_sym_repeat,
    ACTIONS(1582), 1,
      anon_sym_QMARK,
    ACTIONS(1584), 1,
      anon_sym_TILDE,
    ACTIONS(1592), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1594), 1,
      sym__number_literal,
    ACTIONS(1596), 1,
      anon_sym_SQUOTE,
    ACTIONS(1598), 1,
      anon_sym_DQUOTE,
    ACTIONS(1608), 1,
      sym__raw_string_literal,
    ACTIONS(1610), 1,
      sym__external_open_parenthesis,
    ACTIONS(1614), 1,
      sym__external_open_brace,
    ACTIONS(8477), 1,
      anon_sym_BANG,
    ACTIONS(10889), 1,
      sym_dot_dot_i,
    ACTIONS(10891), 1,
      sym__newline,
    STATE(16), 1,
      sym__open_brace,
    STATE(119), 1,
      sym__open_parenthesis,
    STATE(2287), 1,
      sym_string,
    STATE(2289), 1,
      sym__single_quoted_string,
    STATE(2290), 1,
      sym__double_quoted_string,
    STATE(3682), 1,
      aux_sym_function_definition_repeat1,
    STATE(5144), 1,
      sym__string_or_identifier,
    ACTIONS(1588), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2288), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1602), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10887), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1198), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [78690] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(10895), 1,
      sym_dot_dot_i,
    ACTIONS(10897), 1,
      sym__newline,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(3717), 1,
      aux_sym_function_definition_repeat1,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10893), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4549), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [78819] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3845), 1,
      sym_identifier,
    ACTIONS(3847), 1,
      anon_sym_BSLASH,
    ACTIONS(3849), 1,
      anon_sym_function,
    ACTIONS(3851), 1,
      anon_sym_if,
    ACTIONS(3853), 1,
      anon_sym_for,
    ACTIONS(3855), 1,
      anon_sym_while,
    ACTIONS(3857), 1,
      anon_sym_repeat,
    ACTIONS(3859), 1,
      anon_sym_QMARK,
    ACTIONS(3861), 1,
      anon_sym_TILDE,
    ACTIONS(3869), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3871), 1,
      sym__number_literal,
    ACTIONS(3873), 1,
      anon_sym_SQUOTE,
    ACTIONS(3875), 1,
      anon_sym_DQUOTE,
    ACTIONS(3885), 1,
      sym__raw_string_literal,
    ACTIONS(3887), 1,
      sym__external_open_parenthesis,
    ACTIONS(3891), 1,
      sym__external_open_brace,
    ACTIONS(6389), 1,
      anon_sym_BANG,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(10901), 1,
      sym_dot_dot_i,
    STATE(154), 1,
      sym__open_brace,
    STATE(350), 1,
      sym__open_parenthesis,
    STATE(2620), 1,
      sym__double_quoted_string,
    STATE(2673), 1,
      sym_string,
    STATE(2735), 1,
      sym__single_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5135), 1,
      sym__string_or_identifier,
    ACTIONS(3865), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2578), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3879), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10899), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2109), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [78948] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4214), 1,
      sym_identifier,
    ACTIONS(4216), 1,
      anon_sym_BSLASH,
    ACTIONS(4218), 1,
      anon_sym_function,
    ACTIONS(4220), 1,
      anon_sym_if,
    ACTIONS(4222), 1,
      anon_sym_for,
    ACTIONS(4224), 1,
      anon_sym_while,
    ACTIONS(4226), 1,
      anon_sym_repeat,
    ACTIONS(4228), 1,
      anon_sym_QMARK,
    ACTIONS(4230), 1,
      anon_sym_TILDE,
    ACTIONS(4238), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4240), 1,
      sym__number_literal,
    ACTIONS(4242), 1,
      anon_sym_SQUOTE,
    ACTIONS(4244), 1,
      anon_sym_DQUOTE,
    ACTIONS(4254), 1,
      sym__raw_string_literal,
    ACTIONS(4256), 1,
      sym__external_open_parenthesis,
    ACTIONS(4258), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9229), 1,
      anon_sym_BANG,
    ACTIONS(10905), 1,
      sym_dot_dot_i,
    STATE(51), 1,
      sym__open_brace,
    STATE(287), 1,
      sym__open_parenthesis,
    STATE(4674), 1,
      sym__single_quoted_string,
    STATE(4678), 1,
      sym__double_quoted_string,
    STATE(4681), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5129), 1,
      sym__string_or_identifier,
    ACTIONS(4234), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4680), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4248), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10903), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4384), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [79077] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3845), 1,
      sym_identifier,
    ACTIONS(3847), 1,
      anon_sym_BSLASH,
    ACTIONS(3849), 1,
      anon_sym_function,
    ACTIONS(3851), 1,
      anon_sym_if,
    ACTIONS(3853), 1,
      anon_sym_for,
    ACTIONS(3855), 1,
      anon_sym_while,
    ACTIONS(3857), 1,
      anon_sym_repeat,
    ACTIONS(3859), 1,
      anon_sym_QMARK,
    ACTIONS(3861), 1,
      anon_sym_TILDE,
    ACTIONS(3869), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3871), 1,
      sym__number_literal,
    ACTIONS(3873), 1,
      anon_sym_SQUOTE,
    ACTIONS(3875), 1,
      anon_sym_DQUOTE,
    ACTIONS(3885), 1,
      sym__raw_string_literal,
    ACTIONS(3887), 1,
      sym__external_open_parenthesis,
    ACTIONS(3891), 1,
      sym__external_open_brace,
    ACTIONS(6389), 1,
      anon_sym_BANG,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(10909), 1,
      sym_dot_dot_i,
    STATE(154), 1,
      sym__open_brace,
    STATE(350), 1,
      sym__open_parenthesis,
    STATE(2620), 1,
      sym__double_quoted_string,
    STATE(2673), 1,
      sym_string,
    STATE(2735), 1,
      sym__single_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5135), 1,
      sym__string_or_identifier,
    ACTIONS(3865), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2578), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3879), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10907), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2110), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [79206] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(626), 1,
      sym_identifier,
    ACTIONS(628), 1,
      anon_sym_BSLASH,
    ACTIONS(630), 1,
      anon_sym_function,
    ACTIONS(632), 1,
      anon_sym_if,
    ACTIONS(634), 1,
      anon_sym_for,
    ACTIONS(636), 1,
      anon_sym_while,
    ACTIONS(638), 1,
      anon_sym_repeat,
    ACTIONS(640), 1,
      anon_sym_QMARK,
    ACTIONS(642), 1,
      anon_sym_TILDE,
    ACTIONS(650), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(652), 1,
      sym__number_literal,
    ACTIONS(654), 1,
      anon_sym_SQUOTE,
    ACTIONS(656), 1,
      anon_sym_DQUOTE,
    ACTIONS(666), 1,
      sym__raw_string_literal,
    ACTIONS(668), 1,
      sym__external_open_parenthesis,
    ACTIONS(670), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7933), 1,
      anon_sym_BANG,
    ACTIONS(10913), 1,
      sym_dot_dot_i,
    STATE(54), 1,
      sym__open_parenthesis,
    STATE(56), 1,
      sym__open_brace,
    STATE(2219), 1,
      sym_string,
    STATE(2221), 1,
      sym__single_quoted_string,
    STATE(2222), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5140), 1,
      sym__string_or_identifier,
    ACTIONS(646), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2220), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(660), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10911), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(737), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [79335] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2826), 1,
      sym_identifier,
    ACTIONS(2828), 1,
      anon_sym_BSLASH,
    ACTIONS(2830), 1,
      anon_sym_function,
    ACTIONS(2832), 1,
      anon_sym_if,
    ACTIONS(2834), 1,
      anon_sym_for,
    ACTIONS(2836), 1,
      anon_sym_while,
    ACTIONS(2838), 1,
      anon_sym_repeat,
    ACTIONS(2840), 1,
      anon_sym_QMARK,
    ACTIONS(2842), 1,
      anon_sym_TILDE,
    ACTIONS(2850), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2852), 1,
      sym__number_literal,
    ACTIONS(2854), 1,
      anon_sym_SQUOTE,
    ACTIONS(2856), 1,
      anon_sym_DQUOTE,
    ACTIONS(2866), 1,
      sym__raw_string_literal,
    ACTIONS(2868), 1,
      sym__external_open_parenthesis,
    ACTIONS(2870), 1,
      sym__external_open_brace,
    ACTIONS(10915), 1,
      anon_sym_BANG,
    ACTIONS(10919), 1,
      sym_dot_dot_i,
    ACTIONS(10921), 1,
      sym__newline,
    STATE(178), 1,
      sym__open_parenthesis,
    STATE(244), 1,
      sym__open_brace,
    STATE(2522), 1,
      sym_string,
    STATE(2528), 1,
      sym__single_quoted_string,
    STATE(2529), 1,
      sym__double_quoted_string,
    STATE(4002), 1,
      aux_sym_function_definition_repeat1,
    STATE(5126), 1,
      sym__string_or_identifier,
    ACTIONS(2846), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2523), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2860), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10917), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1887), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [79464] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(626), 1,
      sym_identifier,
    ACTIONS(628), 1,
      anon_sym_BSLASH,
    ACTIONS(630), 1,
      anon_sym_function,
    ACTIONS(632), 1,
      anon_sym_if,
    ACTIONS(634), 1,
      anon_sym_for,
    ACTIONS(636), 1,
      anon_sym_while,
    ACTIONS(638), 1,
      anon_sym_repeat,
    ACTIONS(640), 1,
      anon_sym_QMARK,
    ACTIONS(642), 1,
      anon_sym_TILDE,
    ACTIONS(650), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(652), 1,
      sym__number_literal,
    ACTIONS(654), 1,
      anon_sym_SQUOTE,
    ACTIONS(656), 1,
      anon_sym_DQUOTE,
    ACTIONS(666), 1,
      sym__raw_string_literal,
    ACTIONS(668), 1,
      sym__external_open_parenthesis,
    ACTIONS(670), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7933), 1,
      anon_sym_BANG,
    ACTIONS(10925), 1,
      sym_dot_dot_i,
    STATE(54), 1,
      sym__open_parenthesis,
    STATE(56), 1,
      sym__open_brace,
    STATE(2219), 1,
      sym_string,
    STATE(2221), 1,
      sym__single_quoted_string,
    STATE(2222), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5140), 1,
      sym__string_or_identifier,
    ACTIONS(646), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2220), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(660), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10923), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(739), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [79593] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(10929), 1,
      sym_dot_dot_i,
    ACTIONS(10931), 1,
      sym__newline,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(3699), 1,
      aux_sym_function_definition_repeat1,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10927), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4550), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [79722] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(626), 1,
      sym_identifier,
    ACTIONS(628), 1,
      anon_sym_BSLASH,
    ACTIONS(630), 1,
      anon_sym_function,
    ACTIONS(632), 1,
      anon_sym_if,
    ACTIONS(634), 1,
      anon_sym_for,
    ACTIONS(636), 1,
      anon_sym_while,
    ACTIONS(638), 1,
      anon_sym_repeat,
    ACTIONS(640), 1,
      anon_sym_QMARK,
    ACTIONS(642), 1,
      anon_sym_TILDE,
    ACTIONS(650), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(652), 1,
      sym__number_literal,
    ACTIONS(654), 1,
      anon_sym_SQUOTE,
    ACTIONS(656), 1,
      anon_sym_DQUOTE,
    ACTIONS(666), 1,
      sym__raw_string_literal,
    ACTIONS(668), 1,
      sym__external_open_parenthesis,
    ACTIONS(670), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7933), 1,
      anon_sym_BANG,
    ACTIONS(10935), 1,
      sym_dot_dot_i,
    STATE(54), 1,
      sym__open_parenthesis,
    STATE(56), 1,
      sym__open_brace,
    STATE(2219), 1,
      sym_string,
    STATE(2221), 1,
      sym__single_quoted_string,
    STATE(2222), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5140), 1,
      sym__string_or_identifier,
    ACTIONS(646), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2220), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(660), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10933), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(741), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [79851] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(10939), 1,
      sym_dot_dot_i,
    STATE(292), 1,
      sym__open_brace,
    STATE(293), 1,
      sym__open_parenthesis,
    STATE(2562), 1,
      sym_string,
    STATE(2737), 1,
      sym__double_quoted_string,
    STATE(2738), 1,
      sym__single_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5152), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2739), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10937), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2147), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [79980] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(626), 1,
      sym_identifier,
    ACTIONS(628), 1,
      anon_sym_BSLASH,
    ACTIONS(630), 1,
      anon_sym_function,
    ACTIONS(632), 1,
      anon_sym_if,
    ACTIONS(634), 1,
      anon_sym_for,
    ACTIONS(636), 1,
      anon_sym_while,
    ACTIONS(638), 1,
      anon_sym_repeat,
    ACTIONS(640), 1,
      anon_sym_QMARK,
    ACTIONS(642), 1,
      anon_sym_TILDE,
    ACTIONS(650), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(652), 1,
      sym__number_literal,
    ACTIONS(654), 1,
      anon_sym_SQUOTE,
    ACTIONS(656), 1,
      anon_sym_DQUOTE,
    ACTIONS(666), 1,
      sym__raw_string_literal,
    ACTIONS(668), 1,
      sym__external_open_parenthesis,
    ACTIONS(670), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7933), 1,
      anon_sym_BANG,
    ACTIONS(10943), 1,
      sym_dot_dot_i,
    STATE(54), 1,
      sym__open_parenthesis,
    STATE(56), 1,
      sym__open_brace,
    STATE(2219), 1,
      sym_string,
    STATE(2221), 1,
      sym__single_quoted_string,
    STATE(2222), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5140), 1,
      sym__string_or_identifier,
    ACTIONS(646), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2220), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(660), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10941), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(743), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [80109] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(10947), 1,
      sym_dot_dot_i,
    STATE(292), 1,
      sym__open_brace,
    STATE(293), 1,
      sym__open_parenthesis,
    STATE(2562), 1,
      sym_string,
    STATE(2737), 1,
      sym__double_quoted_string,
    STATE(2738), 1,
      sym__single_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5152), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2739), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10945), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2139), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [80238] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4214), 1,
      sym_identifier,
    ACTIONS(4216), 1,
      anon_sym_BSLASH,
    ACTIONS(4218), 1,
      anon_sym_function,
    ACTIONS(4220), 1,
      anon_sym_if,
    ACTIONS(4222), 1,
      anon_sym_for,
    ACTIONS(4224), 1,
      anon_sym_while,
    ACTIONS(4226), 1,
      anon_sym_repeat,
    ACTIONS(4228), 1,
      anon_sym_QMARK,
    ACTIONS(4230), 1,
      anon_sym_TILDE,
    ACTIONS(4238), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4240), 1,
      sym__number_literal,
    ACTIONS(4242), 1,
      anon_sym_SQUOTE,
    ACTIONS(4244), 1,
      anon_sym_DQUOTE,
    ACTIONS(4254), 1,
      sym__raw_string_literal,
    ACTIONS(4256), 1,
      sym__external_open_parenthesis,
    ACTIONS(4258), 1,
      sym__external_open_brace,
    ACTIONS(9229), 1,
      anon_sym_BANG,
    ACTIONS(10951), 1,
      sym_dot_dot_i,
    ACTIONS(10953), 1,
      sym__newline,
    STATE(51), 1,
      sym__open_brace,
    STATE(287), 1,
      sym__open_parenthesis,
    STATE(3619), 1,
      aux_sym_function_definition_repeat1,
    STATE(4674), 1,
      sym__single_quoted_string,
    STATE(4678), 1,
      sym__double_quoted_string,
    STATE(4681), 1,
      sym_string,
    STATE(5129), 1,
      sym__string_or_identifier,
    ACTIONS(4234), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4680), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4248), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10949), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4418), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [80367] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4214), 1,
      sym_identifier,
    ACTIONS(4216), 1,
      anon_sym_BSLASH,
    ACTIONS(4218), 1,
      anon_sym_function,
    ACTIONS(4220), 1,
      anon_sym_if,
    ACTIONS(4222), 1,
      anon_sym_for,
    ACTIONS(4224), 1,
      anon_sym_while,
    ACTIONS(4226), 1,
      anon_sym_repeat,
    ACTIONS(4228), 1,
      anon_sym_QMARK,
    ACTIONS(4230), 1,
      anon_sym_TILDE,
    ACTIONS(4238), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4240), 1,
      sym__number_literal,
    ACTIONS(4242), 1,
      anon_sym_SQUOTE,
    ACTIONS(4244), 1,
      anon_sym_DQUOTE,
    ACTIONS(4254), 1,
      sym__raw_string_literal,
    ACTIONS(4256), 1,
      sym__external_open_parenthesis,
    ACTIONS(4258), 1,
      sym__external_open_brace,
    ACTIONS(9229), 1,
      anon_sym_BANG,
    ACTIONS(10957), 1,
      sym_dot_dot_i,
    ACTIONS(10959), 1,
      sym__newline,
    STATE(51), 1,
      sym__open_brace,
    STATE(287), 1,
      sym__open_parenthesis,
    STATE(3622), 1,
      aux_sym_function_definition_repeat1,
    STATE(4674), 1,
      sym__single_quoted_string,
    STATE(4678), 1,
      sym__double_quoted_string,
    STATE(4681), 1,
      sym_string,
    STATE(5129), 1,
      sym__string_or_identifier,
    ACTIONS(4234), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4680), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4248), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10955), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4420), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [80496] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4214), 1,
      sym_identifier,
    ACTIONS(4216), 1,
      anon_sym_BSLASH,
    ACTIONS(4218), 1,
      anon_sym_function,
    ACTIONS(4220), 1,
      anon_sym_if,
    ACTIONS(4222), 1,
      anon_sym_for,
    ACTIONS(4224), 1,
      anon_sym_while,
    ACTIONS(4226), 1,
      anon_sym_repeat,
    ACTIONS(4228), 1,
      anon_sym_QMARK,
    ACTIONS(4230), 1,
      anon_sym_TILDE,
    ACTIONS(4238), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4240), 1,
      sym__number_literal,
    ACTIONS(4242), 1,
      anon_sym_SQUOTE,
    ACTIONS(4244), 1,
      anon_sym_DQUOTE,
    ACTIONS(4254), 1,
      sym__raw_string_literal,
    ACTIONS(4256), 1,
      sym__external_open_parenthesis,
    ACTIONS(4258), 1,
      sym__external_open_brace,
    ACTIONS(9229), 1,
      anon_sym_BANG,
    ACTIONS(10963), 1,
      sym_dot_dot_i,
    ACTIONS(10965), 1,
      sym__newline,
    STATE(51), 1,
      sym__open_brace,
    STATE(287), 1,
      sym__open_parenthesis,
    STATE(3624), 1,
      aux_sym_function_definition_repeat1,
    STATE(4674), 1,
      sym__single_quoted_string,
    STATE(4678), 1,
      sym__double_quoted_string,
    STATE(4681), 1,
      sym_string,
    STATE(5129), 1,
      sym__string_or_identifier,
    ACTIONS(4234), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4680), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4248), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10961), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4422), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [80625] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4214), 1,
      sym_identifier,
    ACTIONS(4216), 1,
      anon_sym_BSLASH,
    ACTIONS(4218), 1,
      anon_sym_function,
    ACTIONS(4220), 1,
      anon_sym_if,
    ACTIONS(4222), 1,
      anon_sym_for,
    ACTIONS(4224), 1,
      anon_sym_while,
    ACTIONS(4226), 1,
      anon_sym_repeat,
    ACTIONS(4228), 1,
      anon_sym_QMARK,
    ACTIONS(4230), 1,
      anon_sym_TILDE,
    ACTIONS(4238), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4240), 1,
      sym__number_literal,
    ACTIONS(4242), 1,
      anon_sym_SQUOTE,
    ACTIONS(4244), 1,
      anon_sym_DQUOTE,
    ACTIONS(4254), 1,
      sym__raw_string_literal,
    ACTIONS(4256), 1,
      sym__external_open_parenthesis,
    ACTIONS(4258), 1,
      sym__external_open_brace,
    ACTIONS(9229), 1,
      anon_sym_BANG,
    ACTIONS(10969), 1,
      sym_dot_dot_i,
    ACTIONS(10971), 1,
      sym__newline,
    STATE(51), 1,
      sym__open_brace,
    STATE(287), 1,
      sym__open_parenthesis,
    STATE(3640), 1,
      aux_sym_function_definition_repeat1,
    STATE(4674), 1,
      sym__single_quoted_string,
    STATE(4678), 1,
      sym__double_quoted_string,
    STATE(4681), 1,
      sym_string,
    STATE(5129), 1,
      sym__string_or_identifier,
    ACTIONS(4234), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4680), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4248), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10967), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4423), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [80754] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(321), 1,
      sym_identifier,
    ACTIONS(323), 1,
      anon_sym_BSLASH,
    ACTIONS(325), 1,
      anon_sym_function,
    ACTIONS(327), 1,
      anon_sym_if,
    ACTIONS(329), 1,
      anon_sym_for,
    ACTIONS(331), 1,
      anon_sym_while,
    ACTIONS(333), 1,
      anon_sym_repeat,
    ACTIONS(335), 1,
      anon_sym_QMARK,
    ACTIONS(337), 1,
      anon_sym_TILDE,
    ACTIONS(345), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(347), 1,
      sym__number_literal,
    ACTIONS(349), 1,
      anon_sym_SQUOTE,
    ACTIONS(351), 1,
      anon_sym_DQUOTE,
    ACTIONS(361), 1,
      sym__raw_string_literal,
    ACTIONS(363), 1,
      sym__external_open_parenthesis,
    ACTIONS(365), 1,
      sym__external_open_brace,
    ACTIONS(10329), 1,
      anon_sym_BANG,
    ACTIONS(10975), 1,
      sym_dot_dot_i,
    ACTIONS(10977), 1,
      sym__newline,
    STATE(24), 1,
      sym__open_brace,
    STATE(67), 1,
      sym__open_parenthesis,
    STATE(2169), 1,
      sym_string,
    STATE(2180), 1,
      sym__double_quoted_string,
    STATE(2181), 1,
      sym__single_quoted_string,
    STATE(3583), 1,
      aux_sym_function_definition_repeat1,
    STATE(5149), 1,
      sym__string_or_identifier,
    ACTIONS(341), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2183), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(355), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10973), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(879), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [80883] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2826), 1,
      sym_identifier,
    ACTIONS(2828), 1,
      anon_sym_BSLASH,
    ACTIONS(2830), 1,
      anon_sym_function,
    ACTIONS(2832), 1,
      anon_sym_if,
    ACTIONS(2834), 1,
      anon_sym_for,
    ACTIONS(2836), 1,
      anon_sym_while,
    ACTIONS(2838), 1,
      anon_sym_repeat,
    ACTIONS(2840), 1,
      anon_sym_QMARK,
    ACTIONS(2842), 1,
      anon_sym_TILDE,
    ACTIONS(2850), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2852), 1,
      sym__number_literal,
    ACTIONS(2854), 1,
      anon_sym_SQUOTE,
    ACTIONS(2856), 1,
      anon_sym_DQUOTE,
    ACTIONS(2866), 1,
      sym__raw_string_literal,
    ACTIONS(2868), 1,
      sym__external_open_parenthesis,
    ACTIONS(2870), 1,
      sym__external_open_brace,
    ACTIONS(10915), 1,
      anon_sym_BANG,
    ACTIONS(10981), 1,
      sym_dot_dot_i,
    ACTIONS(10983), 1,
      sym__newline,
    STATE(178), 1,
      sym__open_parenthesis,
    STATE(244), 1,
      sym__open_brace,
    STATE(2522), 1,
      sym_string,
    STATE(2528), 1,
      sym__single_quoted_string,
    STATE(2529), 1,
      sym__double_quoted_string,
    STATE(3846), 1,
      aux_sym_function_definition_repeat1,
    STATE(5126), 1,
      sym__string_or_identifier,
    ACTIONS(2846), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2523), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2860), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10979), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1879), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [81012] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(626), 1,
      sym_identifier,
    ACTIONS(628), 1,
      anon_sym_BSLASH,
    ACTIONS(630), 1,
      anon_sym_function,
    ACTIONS(632), 1,
      anon_sym_if,
    ACTIONS(634), 1,
      anon_sym_for,
    ACTIONS(636), 1,
      anon_sym_while,
    ACTIONS(638), 1,
      anon_sym_repeat,
    ACTIONS(640), 1,
      anon_sym_QMARK,
    ACTIONS(642), 1,
      anon_sym_TILDE,
    ACTIONS(650), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(652), 1,
      sym__number_literal,
    ACTIONS(654), 1,
      anon_sym_SQUOTE,
    ACTIONS(656), 1,
      anon_sym_DQUOTE,
    ACTIONS(666), 1,
      sym__raw_string_literal,
    ACTIONS(668), 1,
      sym__external_open_parenthesis,
    ACTIONS(670), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7933), 1,
      anon_sym_BANG,
    ACTIONS(10987), 1,
      sym_dot_dot_i,
    STATE(54), 1,
      sym__open_parenthesis,
    STATE(56), 1,
      sym__open_brace,
    STATE(2219), 1,
      sym_string,
    STATE(2221), 1,
      sym__single_quoted_string,
    STATE(2222), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5140), 1,
      sym__string_or_identifier,
    ACTIONS(646), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2220), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(660), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10985), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(750), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [81141] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(321), 1,
      sym_identifier,
    ACTIONS(323), 1,
      anon_sym_BSLASH,
    ACTIONS(325), 1,
      anon_sym_function,
    ACTIONS(327), 1,
      anon_sym_if,
    ACTIONS(329), 1,
      anon_sym_for,
    ACTIONS(331), 1,
      anon_sym_while,
    ACTIONS(333), 1,
      anon_sym_repeat,
    ACTIONS(335), 1,
      anon_sym_QMARK,
    ACTIONS(337), 1,
      anon_sym_TILDE,
    ACTIONS(345), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(347), 1,
      sym__number_literal,
    ACTIONS(349), 1,
      anon_sym_SQUOTE,
    ACTIONS(351), 1,
      anon_sym_DQUOTE,
    ACTIONS(361), 1,
      sym__raw_string_literal,
    ACTIONS(363), 1,
      sym__external_open_parenthesis,
    ACTIONS(365), 1,
      sym__external_open_brace,
    ACTIONS(10329), 1,
      anon_sym_BANG,
    ACTIONS(10991), 1,
      sym_dot_dot_i,
    ACTIONS(10993), 1,
      sym__newline,
    STATE(24), 1,
      sym__open_brace,
    STATE(67), 1,
      sym__open_parenthesis,
    STATE(2169), 1,
      sym_string,
    STATE(2180), 1,
      sym__double_quoted_string,
    STATE(2181), 1,
      sym__single_quoted_string,
    STATE(3584), 1,
      aux_sym_function_definition_repeat1,
    STATE(5149), 1,
      sym__string_or_identifier,
    ACTIONS(341), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2183), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(355), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10989), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(880), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [81270] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1568), 1,
      sym_identifier,
    ACTIONS(1570), 1,
      anon_sym_BSLASH,
    ACTIONS(1572), 1,
      anon_sym_function,
    ACTIONS(1574), 1,
      anon_sym_if,
    ACTIONS(1576), 1,
      anon_sym_for,
    ACTIONS(1578), 1,
      anon_sym_while,
    ACTIONS(1580), 1,
      anon_sym_repeat,
    ACTIONS(1582), 1,
      anon_sym_QMARK,
    ACTIONS(1584), 1,
      anon_sym_TILDE,
    ACTIONS(1592), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1594), 1,
      sym__number_literal,
    ACTIONS(1596), 1,
      anon_sym_SQUOTE,
    ACTIONS(1598), 1,
      anon_sym_DQUOTE,
    ACTIONS(1608), 1,
      sym__raw_string_literal,
    ACTIONS(1610), 1,
      sym__external_open_parenthesis,
    ACTIONS(1614), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8477), 1,
      anon_sym_BANG,
    ACTIONS(10997), 1,
      sym_dot_dot_i,
    STATE(16), 1,
      sym__open_brace,
    STATE(119), 1,
      sym__open_parenthesis,
    STATE(2287), 1,
      sym_string,
    STATE(2289), 1,
      sym__single_quoted_string,
    STATE(2290), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5144), 1,
      sym__string_or_identifier,
    ACTIONS(1588), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2288), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1602), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10995), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1187), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [81399] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(321), 1,
      sym_identifier,
    ACTIONS(323), 1,
      anon_sym_BSLASH,
    ACTIONS(325), 1,
      anon_sym_function,
    ACTIONS(327), 1,
      anon_sym_if,
    ACTIONS(329), 1,
      anon_sym_for,
    ACTIONS(331), 1,
      anon_sym_while,
    ACTIONS(333), 1,
      anon_sym_repeat,
    ACTIONS(335), 1,
      anon_sym_QMARK,
    ACTIONS(337), 1,
      anon_sym_TILDE,
    ACTIONS(345), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(347), 1,
      sym__number_literal,
    ACTIONS(349), 1,
      anon_sym_SQUOTE,
    ACTIONS(351), 1,
      anon_sym_DQUOTE,
    ACTIONS(361), 1,
      sym__raw_string_literal,
    ACTIONS(363), 1,
      sym__external_open_parenthesis,
    ACTIONS(365), 1,
      sym__external_open_brace,
    ACTIONS(10329), 1,
      anon_sym_BANG,
    ACTIONS(11001), 1,
      sym_dot_dot_i,
    ACTIONS(11003), 1,
      sym__newline,
    STATE(24), 1,
      sym__open_brace,
    STATE(67), 1,
      sym__open_parenthesis,
    STATE(2169), 1,
      sym_string,
    STATE(2180), 1,
      sym__double_quoted_string,
    STATE(2181), 1,
      sym__single_quoted_string,
    STATE(3587), 1,
      aux_sym_function_definition_repeat1,
    STATE(5149), 1,
      sym__string_or_identifier,
    ACTIONS(341), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2183), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(355), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(10999), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(882), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [81528] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1568), 1,
      sym_identifier,
    ACTIONS(1570), 1,
      anon_sym_BSLASH,
    ACTIONS(1572), 1,
      anon_sym_function,
    ACTIONS(1574), 1,
      anon_sym_if,
    ACTIONS(1576), 1,
      anon_sym_for,
    ACTIONS(1578), 1,
      anon_sym_while,
    ACTIONS(1580), 1,
      anon_sym_repeat,
    ACTIONS(1582), 1,
      anon_sym_QMARK,
    ACTIONS(1584), 1,
      anon_sym_TILDE,
    ACTIONS(1592), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1594), 1,
      sym__number_literal,
    ACTIONS(1596), 1,
      anon_sym_SQUOTE,
    ACTIONS(1598), 1,
      anon_sym_DQUOTE,
    ACTIONS(1608), 1,
      sym__raw_string_literal,
    ACTIONS(1610), 1,
      sym__external_open_parenthesis,
    ACTIONS(1614), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8477), 1,
      anon_sym_BANG,
    ACTIONS(11007), 1,
      sym_dot_dot_i,
    STATE(16), 1,
      sym__open_brace,
    STATE(119), 1,
      sym__open_parenthesis,
    STATE(2287), 1,
      sym_string,
    STATE(2289), 1,
      sym__single_quoted_string,
    STATE(2290), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5144), 1,
      sym__string_or_identifier,
    ACTIONS(1588), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2288), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1602), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11005), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1185), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [81657] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(321), 1,
      sym_identifier,
    ACTIONS(323), 1,
      anon_sym_BSLASH,
    ACTIONS(325), 1,
      anon_sym_function,
    ACTIONS(327), 1,
      anon_sym_if,
    ACTIONS(329), 1,
      anon_sym_for,
    ACTIONS(331), 1,
      anon_sym_while,
    ACTIONS(333), 1,
      anon_sym_repeat,
    ACTIONS(335), 1,
      anon_sym_QMARK,
    ACTIONS(337), 1,
      anon_sym_TILDE,
    ACTIONS(345), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(347), 1,
      sym__number_literal,
    ACTIONS(349), 1,
      anon_sym_SQUOTE,
    ACTIONS(351), 1,
      anon_sym_DQUOTE,
    ACTIONS(361), 1,
      sym__raw_string_literal,
    ACTIONS(363), 1,
      sym__external_open_parenthesis,
    ACTIONS(365), 1,
      sym__external_open_brace,
    ACTIONS(10329), 1,
      anon_sym_BANG,
    ACTIONS(11011), 1,
      sym_dot_dot_i,
    ACTIONS(11013), 1,
      sym__newline,
    STATE(24), 1,
      sym__open_brace,
    STATE(67), 1,
      sym__open_parenthesis,
    STATE(2169), 1,
      sym_string,
    STATE(2180), 1,
      sym__double_quoted_string,
    STATE(2181), 1,
      sym__single_quoted_string,
    STATE(3589), 1,
      aux_sym_function_definition_repeat1,
    STATE(5149), 1,
      sym__string_or_identifier,
    ACTIONS(341), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2183), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(355), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11009), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(884), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [81786] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1568), 1,
      sym_identifier,
    ACTIONS(1570), 1,
      anon_sym_BSLASH,
    ACTIONS(1572), 1,
      anon_sym_function,
    ACTIONS(1574), 1,
      anon_sym_if,
    ACTIONS(1576), 1,
      anon_sym_for,
    ACTIONS(1578), 1,
      anon_sym_while,
    ACTIONS(1580), 1,
      anon_sym_repeat,
    ACTIONS(1582), 1,
      anon_sym_QMARK,
    ACTIONS(1584), 1,
      anon_sym_TILDE,
    ACTIONS(1592), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1594), 1,
      sym__number_literal,
    ACTIONS(1596), 1,
      anon_sym_SQUOTE,
    ACTIONS(1598), 1,
      anon_sym_DQUOTE,
    ACTIONS(1608), 1,
      sym__raw_string_literal,
    ACTIONS(1610), 1,
      sym__external_open_parenthesis,
    ACTIONS(1614), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8477), 1,
      anon_sym_BANG,
    ACTIONS(11017), 1,
      sym_dot_dot_i,
    STATE(16), 1,
      sym__open_brace,
    STATE(119), 1,
      sym__open_parenthesis,
    STATE(2287), 1,
      sym_string,
    STATE(2289), 1,
      sym__single_quoted_string,
    STATE(2290), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5144), 1,
      sym__string_or_identifier,
    ACTIONS(1588), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2288), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1602), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11015), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1184), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [81915] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(321), 1,
      sym_identifier,
    ACTIONS(323), 1,
      anon_sym_BSLASH,
    ACTIONS(325), 1,
      anon_sym_function,
    ACTIONS(327), 1,
      anon_sym_if,
    ACTIONS(329), 1,
      anon_sym_for,
    ACTIONS(331), 1,
      anon_sym_while,
    ACTIONS(333), 1,
      anon_sym_repeat,
    ACTIONS(335), 1,
      anon_sym_QMARK,
    ACTIONS(337), 1,
      anon_sym_TILDE,
    ACTIONS(345), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(347), 1,
      sym__number_literal,
    ACTIONS(349), 1,
      anon_sym_SQUOTE,
    ACTIONS(351), 1,
      anon_sym_DQUOTE,
    ACTIONS(361), 1,
      sym__raw_string_literal,
    ACTIONS(363), 1,
      sym__external_open_parenthesis,
    ACTIONS(365), 1,
      sym__external_open_brace,
    ACTIONS(10329), 1,
      anon_sym_BANG,
    ACTIONS(11021), 1,
      sym_dot_dot_i,
    ACTIONS(11023), 1,
      sym__newline,
    STATE(24), 1,
      sym__open_brace,
    STATE(67), 1,
      sym__open_parenthesis,
    STATE(2169), 1,
      sym_string,
    STATE(2180), 1,
      sym__double_quoted_string,
    STATE(2181), 1,
      sym__single_quoted_string,
    STATE(3590), 1,
      aux_sym_function_definition_repeat1,
    STATE(5149), 1,
      sym__string_or_identifier,
    ACTIONS(341), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2183), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(355), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11019), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(885), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [82044] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1568), 1,
      sym_identifier,
    ACTIONS(1570), 1,
      anon_sym_BSLASH,
    ACTIONS(1572), 1,
      anon_sym_function,
    ACTIONS(1574), 1,
      anon_sym_if,
    ACTIONS(1576), 1,
      anon_sym_for,
    ACTIONS(1578), 1,
      anon_sym_while,
    ACTIONS(1580), 1,
      anon_sym_repeat,
    ACTIONS(1582), 1,
      anon_sym_QMARK,
    ACTIONS(1584), 1,
      anon_sym_TILDE,
    ACTIONS(1592), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1594), 1,
      sym__number_literal,
    ACTIONS(1596), 1,
      anon_sym_SQUOTE,
    ACTIONS(1598), 1,
      anon_sym_DQUOTE,
    ACTIONS(1608), 1,
      sym__raw_string_literal,
    ACTIONS(1610), 1,
      sym__external_open_parenthesis,
    ACTIONS(1614), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8477), 1,
      anon_sym_BANG,
    ACTIONS(11027), 1,
      sym_dot_dot_i,
    STATE(16), 1,
      sym__open_brace,
    STATE(119), 1,
      sym__open_parenthesis,
    STATE(2287), 1,
      sym_string,
    STATE(2289), 1,
      sym__single_quoted_string,
    STATE(2290), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5144), 1,
      sym__string_or_identifier,
    ACTIONS(1588), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2288), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1602), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11025), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1183), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [82173] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(321), 1,
      sym_identifier,
    ACTIONS(323), 1,
      anon_sym_BSLASH,
    ACTIONS(325), 1,
      anon_sym_function,
    ACTIONS(327), 1,
      anon_sym_if,
    ACTIONS(329), 1,
      anon_sym_for,
    ACTIONS(331), 1,
      anon_sym_while,
    ACTIONS(333), 1,
      anon_sym_repeat,
    ACTIONS(335), 1,
      anon_sym_QMARK,
    ACTIONS(337), 1,
      anon_sym_TILDE,
    ACTIONS(345), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(347), 1,
      sym__number_literal,
    ACTIONS(349), 1,
      anon_sym_SQUOTE,
    ACTIONS(351), 1,
      anon_sym_DQUOTE,
    ACTIONS(361), 1,
      sym__raw_string_literal,
    ACTIONS(363), 1,
      sym__external_open_parenthesis,
    ACTIONS(365), 1,
      sym__external_open_brace,
    ACTIONS(10329), 1,
      anon_sym_BANG,
    ACTIONS(11031), 1,
      sym_dot_dot_i,
    ACTIONS(11033), 1,
      sym__newline,
    STATE(24), 1,
      sym__open_brace,
    STATE(67), 1,
      sym__open_parenthesis,
    STATE(2169), 1,
      sym_string,
    STATE(2180), 1,
      sym__double_quoted_string,
    STATE(2181), 1,
      sym__single_quoted_string,
    STATE(3591), 1,
      aux_sym_function_definition_repeat1,
    STATE(5149), 1,
      sym__string_or_identifier,
    ACTIONS(341), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2183), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(355), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11029), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(887), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [82302] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1568), 1,
      sym_identifier,
    ACTIONS(1570), 1,
      anon_sym_BSLASH,
    ACTIONS(1572), 1,
      anon_sym_function,
    ACTIONS(1574), 1,
      anon_sym_if,
    ACTIONS(1576), 1,
      anon_sym_for,
    ACTIONS(1578), 1,
      anon_sym_while,
    ACTIONS(1580), 1,
      anon_sym_repeat,
    ACTIONS(1582), 1,
      anon_sym_QMARK,
    ACTIONS(1584), 1,
      anon_sym_TILDE,
    ACTIONS(1592), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1594), 1,
      sym__number_literal,
    ACTIONS(1596), 1,
      anon_sym_SQUOTE,
    ACTIONS(1598), 1,
      anon_sym_DQUOTE,
    ACTIONS(1608), 1,
      sym__raw_string_literal,
    ACTIONS(1610), 1,
      sym__external_open_parenthesis,
    ACTIONS(1614), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8477), 1,
      anon_sym_BANG,
    ACTIONS(11037), 1,
      sym_dot_dot_i,
    STATE(16), 1,
      sym__open_brace,
    STATE(119), 1,
      sym__open_parenthesis,
    STATE(2287), 1,
      sym_string,
    STATE(2289), 1,
      sym__single_quoted_string,
    STATE(2290), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5144), 1,
      sym__string_or_identifier,
    ACTIONS(1588), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2288), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1602), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11035), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1179), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [82431] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(321), 1,
      sym_identifier,
    ACTIONS(323), 1,
      anon_sym_BSLASH,
    ACTIONS(325), 1,
      anon_sym_function,
    ACTIONS(327), 1,
      anon_sym_if,
    ACTIONS(329), 1,
      anon_sym_for,
    ACTIONS(331), 1,
      anon_sym_while,
    ACTIONS(333), 1,
      anon_sym_repeat,
    ACTIONS(335), 1,
      anon_sym_QMARK,
    ACTIONS(337), 1,
      anon_sym_TILDE,
    ACTIONS(345), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(347), 1,
      sym__number_literal,
    ACTIONS(349), 1,
      anon_sym_SQUOTE,
    ACTIONS(351), 1,
      anon_sym_DQUOTE,
    ACTIONS(361), 1,
      sym__raw_string_literal,
    ACTIONS(363), 1,
      sym__external_open_parenthesis,
    ACTIONS(365), 1,
      sym__external_open_brace,
    ACTIONS(10329), 1,
      anon_sym_BANG,
    ACTIONS(11041), 1,
      sym_dot_dot_i,
    ACTIONS(11043), 1,
      sym__newline,
    STATE(24), 1,
      sym__open_brace,
    STATE(67), 1,
      sym__open_parenthesis,
    STATE(2169), 1,
      sym_string,
    STATE(2180), 1,
      sym__double_quoted_string,
    STATE(2181), 1,
      sym__single_quoted_string,
    STATE(3592), 1,
      aux_sym_function_definition_repeat1,
    STATE(5149), 1,
      sym__string_or_identifier,
    ACTIONS(341), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2183), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(355), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11039), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(889), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [82560] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1568), 1,
      sym_identifier,
    ACTIONS(1570), 1,
      anon_sym_BSLASH,
    ACTIONS(1572), 1,
      anon_sym_function,
    ACTIONS(1574), 1,
      anon_sym_if,
    ACTIONS(1576), 1,
      anon_sym_for,
    ACTIONS(1578), 1,
      anon_sym_while,
    ACTIONS(1580), 1,
      anon_sym_repeat,
    ACTIONS(1582), 1,
      anon_sym_QMARK,
    ACTIONS(1584), 1,
      anon_sym_TILDE,
    ACTIONS(1592), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1594), 1,
      sym__number_literal,
    ACTIONS(1596), 1,
      anon_sym_SQUOTE,
    ACTIONS(1598), 1,
      anon_sym_DQUOTE,
    ACTIONS(1608), 1,
      sym__raw_string_literal,
    ACTIONS(1610), 1,
      sym__external_open_parenthesis,
    ACTIONS(1614), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8477), 1,
      anon_sym_BANG,
    ACTIONS(11047), 1,
      sym_dot_dot_i,
    STATE(16), 1,
      sym__open_brace,
    STATE(119), 1,
      sym__open_parenthesis,
    STATE(2287), 1,
      sym_string,
    STATE(2289), 1,
      sym__single_quoted_string,
    STATE(2290), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5144), 1,
      sym__string_or_identifier,
    ACTIONS(1588), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2288), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1602), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11045), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1178), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [82689] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(321), 1,
      sym_identifier,
    ACTIONS(323), 1,
      anon_sym_BSLASH,
    ACTIONS(325), 1,
      anon_sym_function,
    ACTIONS(327), 1,
      anon_sym_if,
    ACTIONS(329), 1,
      anon_sym_for,
    ACTIONS(331), 1,
      anon_sym_while,
    ACTIONS(333), 1,
      anon_sym_repeat,
    ACTIONS(335), 1,
      anon_sym_QMARK,
    ACTIONS(337), 1,
      anon_sym_TILDE,
    ACTIONS(345), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(347), 1,
      sym__number_literal,
    ACTIONS(349), 1,
      anon_sym_SQUOTE,
    ACTIONS(351), 1,
      anon_sym_DQUOTE,
    ACTIONS(361), 1,
      sym__raw_string_literal,
    ACTIONS(363), 1,
      sym__external_open_parenthesis,
    ACTIONS(365), 1,
      sym__external_open_brace,
    ACTIONS(10329), 1,
      anon_sym_BANG,
    ACTIONS(11051), 1,
      sym_dot_dot_i,
    ACTIONS(11053), 1,
      sym__newline,
    STATE(24), 1,
      sym__open_brace,
    STATE(67), 1,
      sym__open_parenthesis,
    STATE(2169), 1,
      sym_string,
    STATE(2180), 1,
      sym__double_quoted_string,
    STATE(2181), 1,
      sym__single_quoted_string,
    STATE(3594), 1,
      aux_sym_function_definition_repeat1,
    STATE(5149), 1,
      sym__string_or_identifier,
    ACTIONS(341), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2183), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(355), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11049), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(891), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [82818] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1568), 1,
      sym_identifier,
    ACTIONS(1570), 1,
      anon_sym_BSLASH,
    ACTIONS(1572), 1,
      anon_sym_function,
    ACTIONS(1574), 1,
      anon_sym_if,
    ACTIONS(1576), 1,
      anon_sym_for,
    ACTIONS(1578), 1,
      anon_sym_while,
    ACTIONS(1580), 1,
      anon_sym_repeat,
    ACTIONS(1582), 1,
      anon_sym_QMARK,
    ACTIONS(1584), 1,
      anon_sym_TILDE,
    ACTIONS(1592), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1594), 1,
      sym__number_literal,
    ACTIONS(1596), 1,
      anon_sym_SQUOTE,
    ACTIONS(1598), 1,
      anon_sym_DQUOTE,
    ACTIONS(1608), 1,
      sym__raw_string_literal,
    ACTIONS(1610), 1,
      sym__external_open_parenthesis,
    ACTIONS(1614), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8477), 1,
      anon_sym_BANG,
    ACTIONS(11057), 1,
      sym_dot_dot_i,
    STATE(16), 1,
      sym__open_brace,
    STATE(119), 1,
      sym__open_parenthesis,
    STATE(2287), 1,
      sym_string,
    STATE(2289), 1,
      sym__single_quoted_string,
    STATE(2290), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5144), 1,
      sym__string_or_identifier,
    ACTIONS(1588), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2288), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1602), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11055), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1177), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [82947] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(321), 1,
      sym_identifier,
    ACTIONS(323), 1,
      anon_sym_BSLASH,
    ACTIONS(325), 1,
      anon_sym_function,
    ACTIONS(327), 1,
      anon_sym_if,
    ACTIONS(329), 1,
      anon_sym_for,
    ACTIONS(331), 1,
      anon_sym_while,
    ACTIONS(333), 1,
      anon_sym_repeat,
    ACTIONS(335), 1,
      anon_sym_QMARK,
    ACTIONS(337), 1,
      anon_sym_TILDE,
    ACTIONS(345), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(347), 1,
      sym__number_literal,
    ACTIONS(349), 1,
      anon_sym_SQUOTE,
    ACTIONS(351), 1,
      anon_sym_DQUOTE,
    ACTIONS(361), 1,
      sym__raw_string_literal,
    ACTIONS(363), 1,
      sym__external_open_parenthesis,
    ACTIONS(365), 1,
      sym__external_open_brace,
    ACTIONS(10329), 1,
      anon_sym_BANG,
    ACTIONS(11061), 1,
      sym_dot_dot_i,
    ACTIONS(11063), 1,
      sym__newline,
    STATE(24), 1,
      sym__open_brace,
    STATE(67), 1,
      sym__open_parenthesis,
    STATE(2169), 1,
      sym_string,
    STATE(2180), 1,
      sym__double_quoted_string,
    STATE(2181), 1,
      sym__single_quoted_string,
    STATE(3595), 1,
      aux_sym_function_definition_repeat1,
    STATE(5149), 1,
      sym__string_or_identifier,
    ACTIONS(341), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2183), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(355), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11059), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(893), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [83076] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1568), 1,
      sym_identifier,
    ACTIONS(1570), 1,
      anon_sym_BSLASH,
    ACTIONS(1572), 1,
      anon_sym_function,
    ACTIONS(1574), 1,
      anon_sym_if,
    ACTIONS(1576), 1,
      anon_sym_for,
    ACTIONS(1578), 1,
      anon_sym_while,
    ACTIONS(1580), 1,
      anon_sym_repeat,
    ACTIONS(1582), 1,
      anon_sym_QMARK,
    ACTIONS(1584), 1,
      anon_sym_TILDE,
    ACTIONS(1592), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1594), 1,
      sym__number_literal,
    ACTIONS(1596), 1,
      anon_sym_SQUOTE,
    ACTIONS(1598), 1,
      anon_sym_DQUOTE,
    ACTIONS(1608), 1,
      sym__raw_string_literal,
    ACTIONS(1610), 1,
      sym__external_open_parenthesis,
    ACTIONS(1614), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8477), 1,
      anon_sym_BANG,
    ACTIONS(11067), 1,
      sym_dot_dot_i,
    STATE(16), 1,
      sym__open_brace,
    STATE(119), 1,
      sym__open_parenthesis,
    STATE(2287), 1,
      sym_string,
    STATE(2289), 1,
      sym__single_quoted_string,
    STATE(2290), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5144), 1,
      sym__string_or_identifier,
    ACTIONS(1588), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2288), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1602), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11065), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1176), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [83205] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(321), 1,
      sym_identifier,
    ACTIONS(323), 1,
      anon_sym_BSLASH,
    ACTIONS(325), 1,
      anon_sym_function,
    ACTIONS(327), 1,
      anon_sym_if,
    ACTIONS(329), 1,
      anon_sym_for,
    ACTIONS(331), 1,
      anon_sym_while,
    ACTIONS(333), 1,
      anon_sym_repeat,
    ACTIONS(335), 1,
      anon_sym_QMARK,
    ACTIONS(337), 1,
      anon_sym_TILDE,
    ACTIONS(345), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(347), 1,
      sym__number_literal,
    ACTIONS(349), 1,
      anon_sym_SQUOTE,
    ACTIONS(351), 1,
      anon_sym_DQUOTE,
    ACTIONS(361), 1,
      sym__raw_string_literal,
    ACTIONS(363), 1,
      sym__external_open_parenthesis,
    ACTIONS(365), 1,
      sym__external_open_brace,
    ACTIONS(10329), 1,
      anon_sym_BANG,
    ACTIONS(11071), 1,
      sym_dot_dot_i,
    ACTIONS(11073), 1,
      sym__newline,
    STATE(24), 1,
      sym__open_brace,
    STATE(67), 1,
      sym__open_parenthesis,
    STATE(2169), 1,
      sym_string,
    STATE(2180), 1,
      sym__double_quoted_string,
    STATE(2181), 1,
      sym__single_quoted_string,
    STATE(3597), 1,
      aux_sym_function_definition_repeat1,
    STATE(5149), 1,
      sym__string_or_identifier,
    ACTIONS(341), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2183), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(355), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11069), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(895), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [83334] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1568), 1,
      sym_identifier,
    ACTIONS(1570), 1,
      anon_sym_BSLASH,
    ACTIONS(1572), 1,
      anon_sym_function,
    ACTIONS(1574), 1,
      anon_sym_if,
    ACTIONS(1576), 1,
      anon_sym_for,
    ACTIONS(1578), 1,
      anon_sym_while,
    ACTIONS(1580), 1,
      anon_sym_repeat,
    ACTIONS(1582), 1,
      anon_sym_QMARK,
    ACTIONS(1584), 1,
      anon_sym_TILDE,
    ACTIONS(1592), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1594), 1,
      sym__number_literal,
    ACTIONS(1596), 1,
      anon_sym_SQUOTE,
    ACTIONS(1598), 1,
      anon_sym_DQUOTE,
    ACTIONS(1608), 1,
      sym__raw_string_literal,
    ACTIONS(1610), 1,
      sym__external_open_parenthesis,
    ACTIONS(1614), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8477), 1,
      anon_sym_BANG,
    ACTIONS(11077), 1,
      sym_dot_dot_i,
    STATE(16), 1,
      sym__open_brace,
    STATE(119), 1,
      sym__open_parenthesis,
    STATE(2287), 1,
      sym_string,
    STATE(2289), 1,
      sym__single_quoted_string,
    STATE(2290), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5144), 1,
      sym__string_or_identifier,
    ACTIONS(1588), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2288), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1602), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11075), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1175), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [83463] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(321), 1,
      sym_identifier,
    ACTIONS(323), 1,
      anon_sym_BSLASH,
    ACTIONS(325), 1,
      anon_sym_function,
    ACTIONS(327), 1,
      anon_sym_if,
    ACTIONS(329), 1,
      anon_sym_for,
    ACTIONS(331), 1,
      anon_sym_while,
    ACTIONS(333), 1,
      anon_sym_repeat,
    ACTIONS(335), 1,
      anon_sym_QMARK,
    ACTIONS(337), 1,
      anon_sym_TILDE,
    ACTIONS(345), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(347), 1,
      sym__number_literal,
    ACTIONS(349), 1,
      anon_sym_SQUOTE,
    ACTIONS(351), 1,
      anon_sym_DQUOTE,
    ACTIONS(361), 1,
      sym__raw_string_literal,
    ACTIONS(363), 1,
      sym__external_open_parenthesis,
    ACTIONS(365), 1,
      sym__external_open_brace,
    ACTIONS(10329), 1,
      anon_sym_BANG,
    ACTIONS(11081), 1,
      sym_dot_dot_i,
    ACTIONS(11083), 1,
      sym__newline,
    STATE(24), 1,
      sym__open_brace,
    STATE(67), 1,
      sym__open_parenthesis,
    STATE(2169), 1,
      sym_string,
    STATE(2180), 1,
      sym__double_quoted_string,
    STATE(2181), 1,
      sym__single_quoted_string,
    STATE(3598), 1,
      aux_sym_function_definition_repeat1,
    STATE(5149), 1,
      sym__string_or_identifier,
    ACTIONS(341), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2183), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(355), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11079), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(897), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [83592] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1568), 1,
      sym_identifier,
    ACTIONS(1570), 1,
      anon_sym_BSLASH,
    ACTIONS(1572), 1,
      anon_sym_function,
    ACTIONS(1574), 1,
      anon_sym_if,
    ACTIONS(1576), 1,
      anon_sym_for,
    ACTIONS(1578), 1,
      anon_sym_while,
    ACTIONS(1580), 1,
      anon_sym_repeat,
    ACTIONS(1582), 1,
      anon_sym_QMARK,
    ACTIONS(1584), 1,
      anon_sym_TILDE,
    ACTIONS(1592), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1594), 1,
      sym__number_literal,
    ACTIONS(1596), 1,
      anon_sym_SQUOTE,
    ACTIONS(1598), 1,
      anon_sym_DQUOTE,
    ACTIONS(1608), 1,
      sym__raw_string_literal,
    ACTIONS(1610), 1,
      sym__external_open_parenthesis,
    ACTIONS(1614), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8477), 1,
      anon_sym_BANG,
    ACTIONS(11087), 1,
      sym_dot_dot_i,
    STATE(16), 1,
      sym__open_brace,
    STATE(119), 1,
      sym__open_parenthesis,
    STATE(2287), 1,
      sym_string,
    STATE(2289), 1,
      sym__single_quoted_string,
    STATE(2290), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5144), 1,
      sym__string_or_identifier,
    ACTIONS(1588), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2288), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1602), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11085), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1174), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [83721] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(321), 1,
      sym_identifier,
    ACTIONS(323), 1,
      anon_sym_BSLASH,
    ACTIONS(325), 1,
      anon_sym_function,
    ACTIONS(327), 1,
      anon_sym_if,
    ACTIONS(329), 1,
      anon_sym_for,
    ACTIONS(331), 1,
      anon_sym_while,
    ACTIONS(333), 1,
      anon_sym_repeat,
    ACTIONS(335), 1,
      anon_sym_QMARK,
    ACTIONS(337), 1,
      anon_sym_TILDE,
    ACTIONS(345), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(347), 1,
      sym__number_literal,
    ACTIONS(349), 1,
      anon_sym_SQUOTE,
    ACTIONS(351), 1,
      anon_sym_DQUOTE,
    ACTIONS(361), 1,
      sym__raw_string_literal,
    ACTIONS(363), 1,
      sym__external_open_parenthesis,
    ACTIONS(365), 1,
      sym__external_open_brace,
    ACTIONS(10329), 1,
      anon_sym_BANG,
    ACTIONS(11091), 1,
      sym_dot_dot_i,
    ACTIONS(11093), 1,
      sym__newline,
    STATE(24), 1,
      sym__open_brace,
    STATE(67), 1,
      sym__open_parenthesis,
    STATE(2169), 1,
      sym_string,
    STATE(2180), 1,
      sym__double_quoted_string,
    STATE(2181), 1,
      sym__single_quoted_string,
    STATE(3600), 1,
      aux_sym_function_definition_repeat1,
    STATE(5149), 1,
      sym__string_or_identifier,
    ACTIONS(341), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2183), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(355), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11089), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(899), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [83850] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1568), 1,
      sym_identifier,
    ACTIONS(1570), 1,
      anon_sym_BSLASH,
    ACTIONS(1572), 1,
      anon_sym_function,
    ACTIONS(1574), 1,
      anon_sym_if,
    ACTIONS(1576), 1,
      anon_sym_for,
    ACTIONS(1578), 1,
      anon_sym_while,
    ACTIONS(1580), 1,
      anon_sym_repeat,
    ACTIONS(1582), 1,
      anon_sym_QMARK,
    ACTIONS(1584), 1,
      anon_sym_TILDE,
    ACTIONS(1592), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1594), 1,
      sym__number_literal,
    ACTIONS(1596), 1,
      anon_sym_SQUOTE,
    ACTIONS(1598), 1,
      anon_sym_DQUOTE,
    ACTIONS(1608), 1,
      sym__raw_string_literal,
    ACTIONS(1610), 1,
      sym__external_open_parenthesis,
    ACTIONS(1614), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8477), 1,
      anon_sym_BANG,
    ACTIONS(11097), 1,
      sym_dot_dot_i,
    STATE(16), 1,
      sym__open_brace,
    STATE(119), 1,
      sym__open_parenthesis,
    STATE(2287), 1,
      sym_string,
    STATE(2289), 1,
      sym__single_quoted_string,
    STATE(2290), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5144), 1,
      sym__string_or_identifier,
    ACTIONS(1588), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2288), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1602), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11095), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1173), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [83979] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(321), 1,
      sym_identifier,
    ACTIONS(323), 1,
      anon_sym_BSLASH,
    ACTIONS(325), 1,
      anon_sym_function,
    ACTIONS(327), 1,
      anon_sym_if,
    ACTIONS(329), 1,
      anon_sym_for,
    ACTIONS(331), 1,
      anon_sym_while,
    ACTIONS(333), 1,
      anon_sym_repeat,
    ACTIONS(335), 1,
      anon_sym_QMARK,
    ACTIONS(337), 1,
      anon_sym_TILDE,
    ACTIONS(345), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(347), 1,
      sym__number_literal,
    ACTIONS(349), 1,
      anon_sym_SQUOTE,
    ACTIONS(351), 1,
      anon_sym_DQUOTE,
    ACTIONS(361), 1,
      sym__raw_string_literal,
    ACTIONS(363), 1,
      sym__external_open_parenthesis,
    ACTIONS(365), 1,
      sym__external_open_brace,
    ACTIONS(10329), 1,
      anon_sym_BANG,
    ACTIONS(11101), 1,
      sym_dot_dot_i,
    ACTIONS(11103), 1,
      sym__newline,
    STATE(24), 1,
      sym__open_brace,
    STATE(67), 1,
      sym__open_parenthesis,
    STATE(2169), 1,
      sym_string,
    STATE(2180), 1,
      sym__double_quoted_string,
    STATE(2181), 1,
      sym__single_quoted_string,
    STATE(3525), 1,
      aux_sym_function_definition_repeat1,
    STATE(5149), 1,
      sym__string_or_identifier,
    ACTIONS(341), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2183), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(355), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11099), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(900), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [84108] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1568), 1,
      sym_identifier,
    ACTIONS(1570), 1,
      anon_sym_BSLASH,
    ACTIONS(1572), 1,
      anon_sym_function,
    ACTIONS(1574), 1,
      anon_sym_if,
    ACTIONS(1576), 1,
      anon_sym_for,
    ACTIONS(1578), 1,
      anon_sym_while,
    ACTIONS(1580), 1,
      anon_sym_repeat,
    ACTIONS(1582), 1,
      anon_sym_QMARK,
    ACTIONS(1584), 1,
      anon_sym_TILDE,
    ACTIONS(1592), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1594), 1,
      sym__number_literal,
    ACTIONS(1596), 1,
      anon_sym_SQUOTE,
    ACTIONS(1598), 1,
      anon_sym_DQUOTE,
    ACTIONS(1608), 1,
      sym__raw_string_literal,
    ACTIONS(1610), 1,
      sym__external_open_parenthesis,
    ACTIONS(1614), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8477), 1,
      anon_sym_BANG,
    ACTIONS(11107), 1,
      sym_dot_dot_i,
    STATE(16), 1,
      sym__open_brace,
    STATE(119), 1,
      sym__open_parenthesis,
    STATE(2287), 1,
      sym_string,
    STATE(2289), 1,
      sym__single_quoted_string,
    STATE(2290), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5144), 1,
      sym__string_or_identifier,
    ACTIONS(1588), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2288), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1602), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11105), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1169), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [84237] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2826), 1,
      sym_identifier,
    ACTIONS(2828), 1,
      anon_sym_BSLASH,
    ACTIONS(2830), 1,
      anon_sym_function,
    ACTIONS(2832), 1,
      anon_sym_if,
    ACTIONS(2834), 1,
      anon_sym_for,
    ACTIONS(2836), 1,
      anon_sym_while,
    ACTIONS(2838), 1,
      anon_sym_repeat,
    ACTIONS(2840), 1,
      anon_sym_QMARK,
    ACTIONS(2842), 1,
      anon_sym_TILDE,
    ACTIONS(2850), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2852), 1,
      sym__number_literal,
    ACTIONS(2854), 1,
      anon_sym_SQUOTE,
    ACTIONS(2856), 1,
      anon_sym_DQUOTE,
    ACTIONS(2866), 1,
      sym__raw_string_literal,
    ACTIONS(2868), 1,
      sym__external_open_parenthesis,
    ACTIONS(2870), 1,
      sym__external_open_brace,
    ACTIONS(10915), 1,
      anon_sym_BANG,
    ACTIONS(11111), 1,
      sym_dot_dot_i,
    ACTIONS(11113), 1,
      sym__newline,
    STATE(178), 1,
      sym__open_parenthesis,
    STATE(244), 1,
      sym__open_brace,
    STATE(2522), 1,
      sym_string,
    STATE(2528), 1,
      sym__single_quoted_string,
    STATE(2529), 1,
      sym__double_quoted_string,
    STATE(3852), 1,
      aux_sym_function_definition_repeat1,
    STATE(5126), 1,
      sym__string_or_identifier,
    ACTIONS(2846), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2523), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2860), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11109), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1865), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [84366] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1568), 1,
      sym_identifier,
    ACTIONS(1570), 1,
      anon_sym_BSLASH,
    ACTIONS(1572), 1,
      anon_sym_function,
    ACTIONS(1574), 1,
      anon_sym_if,
    ACTIONS(1576), 1,
      anon_sym_for,
    ACTIONS(1578), 1,
      anon_sym_while,
    ACTIONS(1580), 1,
      anon_sym_repeat,
    ACTIONS(1582), 1,
      anon_sym_QMARK,
    ACTIONS(1584), 1,
      anon_sym_TILDE,
    ACTIONS(1592), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1594), 1,
      sym__number_literal,
    ACTIONS(1596), 1,
      anon_sym_SQUOTE,
    ACTIONS(1598), 1,
      anon_sym_DQUOTE,
    ACTIONS(1608), 1,
      sym__raw_string_literal,
    ACTIONS(1610), 1,
      sym__external_open_parenthesis,
    ACTIONS(1614), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8477), 1,
      anon_sym_BANG,
    ACTIONS(11117), 1,
      sym_dot_dot_i,
    STATE(16), 1,
      sym__open_brace,
    STATE(119), 1,
      sym__open_parenthesis,
    STATE(2287), 1,
      sym_string,
    STATE(2289), 1,
      sym__single_quoted_string,
    STATE(2290), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5144), 1,
      sym__string_or_identifier,
    ACTIONS(1588), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2288), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1602), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11115), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1166), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [84495] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(11121), 1,
      sym_dot_dot_i,
    STATE(292), 1,
      sym__open_brace,
    STATE(293), 1,
      sym__open_parenthesis,
    STATE(2562), 1,
      sym_string,
    STATE(2737), 1,
      sym__double_quoted_string,
    STATE(2738), 1,
      sym__single_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5152), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2739), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11119), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2137), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [84624] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(626), 1,
      sym_identifier,
    ACTIONS(628), 1,
      anon_sym_BSLASH,
    ACTIONS(630), 1,
      anon_sym_function,
    ACTIONS(632), 1,
      anon_sym_if,
    ACTIONS(634), 1,
      anon_sym_for,
    ACTIONS(636), 1,
      anon_sym_while,
    ACTIONS(638), 1,
      anon_sym_repeat,
    ACTIONS(640), 1,
      anon_sym_QMARK,
    ACTIONS(642), 1,
      anon_sym_TILDE,
    ACTIONS(650), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(652), 1,
      sym__number_literal,
    ACTIONS(654), 1,
      anon_sym_SQUOTE,
    ACTIONS(656), 1,
      anon_sym_DQUOTE,
    ACTIONS(666), 1,
      sym__raw_string_literal,
    ACTIONS(668), 1,
      sym__external_open_parenthesis,
    ACTIONS(670), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7933), 1,
      anon_sym_BANG,
    ACTIONS(11125), 1,
      sym_dot_dot_i,
    STATE(54), 1,
      sym__open_parenthesis,
    STATE(56), 1,
      sym__open_brace,
    STATE(2219), 1,
      sym_string,
    STATE(2221), 1,
      sym__single_quoted_string,
    STATE(2222), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5140), 1,
      sym__string_or_identifier,
    ACTIONS(646), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2220), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(660), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11123), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(751), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [84753] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(11129), 1,
      sym_dot_dot_i,
    STATE(292), 1,
      sym__open_brace,
    STATE(293), 1,
      sym__open_parenthesis,
    STATE(2562), 1,
      sym_string,
    STATE(2737), 1,
      sym__double_quoted_string,
    STATE(2738), 1,
      sym__single_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5152), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2739), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11127), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2136), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [84882] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(626), 1,
      sym_identifier,
    ACTIONS(628), 1,
      anon_sym_BSLASH,
    ACTIONS(630), 1,
      anon_sym_function,
    ACTIONS(632), 1,
      anon_sym_if,
    ACTIONS(634), 1,
      anon_sym_for,
    ACTIONS(636), 1,
      anon_sym_while,
    ACTIONS(638), 1,
      anon_sym_repeat,
    ACTIONS(640), 1,
      anon_sym_QMARK,
    ACTIONS(642), 1,
      anon_sym_TILDE,
    ACTIONS(650), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(652), 1,
      sym__number_literal,
    ACTIONS(654), 1,
      anon_sym_SQUOTE,
    ACTIONS(656), 1,
      anon_sym_DQUOTE,
    ACTIONS(666), 1,
      sym__raw_string_literal,
    ACTIONS(668), 1,
      sym__external_open_parenthesis,
    ACTIONS(670), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7933), 1,
      anon_sym_BANG,
    ACTIONS(11133), 1,
      sym_dot_dot_i,
    STATE(54), 1,
      sym__open_parenthesis,
    STATE(56), 1,
      sym__open_brace,
    STATE(2219), 1,
      sym_string,
    STATE(2221), 1,
      sym__single_quoted_string,
    STATE(2222), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5140), 1,
      sym__string_or_identifier,
    ACTIONS(646), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2220), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(660), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11131), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(752), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [85011] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(321), 1,
      sym_identifier,
    ACTIONS(323), 1,
      anon_sym_BSLASH,
    ACTIONS(325), 1,
      anon_sym_function,
    ACTIONS(327), 1,
      anon_sym_if,
    ACTIONS(329), 1,
      anon_sym_for,
    ACTIONS(331), 1,
      anon_sym_while,
    ACTIONS(333), 1,
      anon_sym_repeat,
    ACTIONS(335), 1,
      anon_sym_QMARK,
    ACTIONS(337), 1,
      anon_sym_TILDE,
    ACTIONS(345), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(347), 1,
      sym__number_literal,
    ACTIONS(349), 1,
      anon_sym_SQUOTE,
    ACTIONS(351), 1,
      anon_sym_DQUOTE,
    ACTIONS(361), 1,
      sym__raw_string_literal,
    ACTIONS(363), 1,
      sym__external_open_parenthesis,
    ACTIONS(365), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(10329), 1,
      anon_sym_BANG,
    ACTIONS(11137), 1,
      sym_dot_dot_i,
    STATE(24), 1,
      sym__open_brace,
    STATE(67), 1,
      sym__open_parenthesis,
    STATE(2169), 1,
      sym_string,
    STATE(2180), 1,
      sym__double_quoted_string,
    STATE(2181), 1,
      sym__single_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5149), 1,
      sym__string_or_identifier,
    ACTIONS(341), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2183), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(355), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11135), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(901), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [85140] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2826), 1,
      sym_identifier,
    ACTIONS(2828), 1,
      anon_sym_BSLASH,
    ACTIONS(2830), 1,
      anon_sym_function,
    ACTIONS(2832), 1,
      anon_sym_if,
    ACTIONS(2834), 1,
      anon_sym_for,
    ACTIONS(2836), 1,
      anon_sym_while,
    ACTIONS(2838), 1,
      anon_sym_repeat,
    ACTIONS(2840), 1,
      anon_sym_QMARK,
    ACTIONS(2842), 1,
      anon_sym_TILDE,
    ACTIONS(2850), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2852), 1,
      sym__number_literal,
    ACTIONS(2854), 1,
      anon_sym_SQUOTE,
    ACTIONS(2856), 1,
      anon_sym_DQUOTE,
    ACTIONS(2866), 1,
      sym__raw_string_literal,
    ACTIONS(2868), 1,
      sym__external_open_parenthesis,
    ACTIONS(2870), 1,
      sym__external_open_brace,
    ACTIONS(10915), 1,
      anon_sym_BANG,
    ACTIONS(11141), 1,
      sym_dot_dot_i,
    ACTIONS(11143), 1,
      sym__newline,
    STATE(178), 1,
      sym__open_parenthesis,
    STATE(244), 1,
      sym__open_brace,
    STATE(2522), 1,
      sym_string,
    STATE(2528), 1,
      sym__single_quoted_string,
    STATE(2529), 1,
      sym__double_quoted_string,
    STATE(3899), 1,
      aux_sym_function_definition_repeat1,
    STATE(5126), 1,
      sym__string_or_identifier,
    ACTIONS(2846), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2523), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2860), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11139), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1848), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [85269] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(321), 1,
      sym_identifier,
    ACTIONS(323), 1,
      anon_sym_BSLASH,
    ACTIONS(325), 1,
      anon_sym_function,
    ACTIONS(327), 1,
      anon_sym_if,
    ACTIONS(329), 1,
      anon_sym_for,
    ACTIONS(331), 1,
      anon_sym_while,
    ACTIONS(333), 1,
      anon_sym_repeat,
    ACTIONS(335), 1,
      anon_sym_QMARK,
    ACTIONS(337), 1,
      anon_sym_TILDE,
    ACTIONS(345), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(347), 1,
      sym__number_literal,
    ACTIONS(349), 1,
      anon_sym_SQUOTE,
    ACTIONS(351), 1,
      anon_sym_DQUOTE,
    ACTIONS(361), 1,
      sym__raw_string_literal,
    ACTIONS(363), 1,
      sym__external_open_parenthesis,
    ACTIONS(365), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(10329), 1,
      anon_sym_BANG,
    ACTIONS(11147), 1,
      sym_dot_dot_i,
    STATE(24), 1,
      sym__open_brace,
    STATE(67), 1,
      sym__open_parenthesis,
    STATE(2169), 1,
      sym_string,
    STATE(2180), 1,
      sym__double_quoted_string,
    STATE(2181), 1,
      sym__single_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5149), 1,
      sym__string_or_identifier,
    ACTIONS(341), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2183), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(355), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11145), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(902), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [85398] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(626), 1,
      sym_identifier,
    ACTIONS(628), 1,
      anon_sym_BSLASH,
    ACTIONS(630), 1,
      anon_sym_function,
    ACTIONS(632), 1,
      anon_sym_if,
    ACTIONS(634), 1,
      anon_sym_for,
    ACTIONS(636), 1,
      anon_sym_while,
    ACTIONS(638), 1,
      anon_sym_repeat,
    ACTIONS(640), 1,
      anon_sym_QMARK,
    ACTIONS(642), 1,
      anon_sym_TILDE,
    ACTIONS(650), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(652), 1,
      sym__number_literal,
    ACTIONS(654), 1,
      anon_sym_SQUOTE,
    ACTIONS(656), 1,
      anon_sym_DQUOTE,
    ACTIONS(666), 1,
      sym__raw_string_literal,
    ACTIONS(668), 1,
      sym__external_open_parenthesis,
    ACTIONS(670), 1,
      sym__external_open_brace,
    ACTIONS(7933), 1,
      anon_sym_BANG,
    ACTIONS(11151), 1,
      sym_dot_dot_i,
    ACTIONS(11153), 1,
      sym__newline,
    STATE(54), 1,
      sym__open_parenthesis,
    STATE(56), 1,
      sym__open_brace,
    STATE(2219), 1,
      sym_string,
    STATE(2221), 1,
      sym__single_quoted_string,
    STATE(2222), 1,
      sym__double_quoted_string,
    STATE(3988), 1,
      aux_sym_function_definition_repeat1,
    STATE(5140), 1,
      sym__string_or_identifier,
    ACTIONS(646), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2220), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(660), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11149), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(721), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [85527] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(626), 1,
      sym_identifier,
    ACTIONS(628), 1,
      anon_sym_BSLASH,
    ACTIONS(630), 1,
      anon_sym_function,
    ACTIONS(632), 1,
      anon_sym_if,
    ACTIONS(634), 1,
      anon_sym_for,
    ACTIONS(636), 1,
      anon_sym_while,
    ACTIONS(638), 1,
      anon_sym_repeat,
    ACTIONS(640), 1,
      anon_sym_QMARK,
    ACTIONS(642), 1,
      anon_sym_TILDE,
    ACTIONS(650), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(652), 1,
      sym__number_literal,
    ACTIONS(654), 1,
      anon_sym_SQUOTE,
    ACTIONS(656), 1,
      anon_sym_DQUOTE,
    ACTIONS(666), 1,
      sym__raw_string_literal,
    ACTIONS(668), 1,
      sym__external_open_parenthesis,
    ACTIONS(670), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7933), 1,
      anon_sym_BANG,
    ACTIONS(11157), 1,
      sym_dot_dot_i,
    STATE(54), 1,
      sym__open_parenthesis,
    STATE(56), 1,
      sym__open_brace,
    STATE(2219), 1,
      sym_string,
    STATE(2221), 1,
      sym__single_quoted_string,
    STATE(2222), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5140), 1,
      sym__string_or_identifier,
    ACTIONS(646), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2220), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(660), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11155), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(755), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [85656] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(273), 1,
      sym_identifier,
    ACTIONS(275), 1,
      anon_sym_BSLASH,
    ACTIONS(277), 1,
      anon_sym_function,
    ACTIONS(279), 1,
      anon_sym_if,
    ACTIONS(281), 1,
      anon_sym_for,
    ACTIONS(283), 1,
      anon_sym_while,
    ACTIONS(285), 1,
      anon_sym_repeat,
    ACTIONS(287), 1,
      anon_sym_QMARK,
    ACTIONS(289), 1,
      anon_sym_TILDE,
    ACTIONS(297), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(299), 1,
      sym__number_literal,
    ACTIONS(301), 1,
      anon_sym_SQUOTE,
    ACTIONS(303), 1,
      anon_sym_DQUOTE,
    ACTIONS(313), 1,
      sym__raw_string_literal,
    ACTIONS(315), 1,
      sym__external_open_parenthesis,
    ACTIONS(319), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(11159), 1,
      anon_sym_BANG,
    ACTIONS(11163), 1,
      sym_dot_dot_i,
    STATE(57), 1,
      sym__open_parenthesis,
    STATE(59), 1,
      sym__open_brace,
    STATE(2187), 1,
      sym__double_quoted_string,
    STATE(2188), 1,
      sym__single_quoted_string,
    STATE(2192), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5139), 1,
      sym__string_or_identifier,
    ACTIONS(293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2189), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(307), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11161), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(699), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [85785] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(321), 1,
      sym_identifier,
    ACTIONS(323), 1,
      anon_sym_BSLASH,
    ACTIONS(325), 1,
      anon_sym_function,
    ACTIONS(327), 1,
      anon_sym_if,
    ACTIONS(329), 1,
      anon_sym_for,
    ACTIONS(331), 1,
      anon_sym_while,
    ACTIONS(333), 1,
      anon_sym_repeat,
    ACTIONS(335), 1,
      anon_sym_QMARK,
    ACTIONS(337), 1,
      anon_sym_TILDE,
    ACTIONS(345), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(347), 1,
      sym__number_literal,
    ACTIONS(349), 1,
      anon_sym_SQUOTE,
    ACTIONS(351), 1,
      anon_sym_DQUOTE,
    ACTIONS(361), 1,
      sym__raw_string_literal,
    ACTIONS(363), 1,
      sym__external_open_parenthesis,
    ACTIONS(365), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(10329), 1,
      anon_sym_BANG,
    ACTIONS(11167), 1,
      sym_dot_dot_i,
    STATE(24), 1,
      sym__open_brace,
    STATE(67), 1,
      sym__open_parenthesis,
    STATE(2169), 1,
      sym_string,
    STATE(2180), 1,
      sym__double_quoted_string,
    STATE(2181), 1,
      sym__single_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5149), 1,
      sym__string_or_identifier,
    ACTIONS(341), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2183), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(355), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11165), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(904), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [85914] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(626), 1,
      sym_identifier,
    ACTIONS(628), 1,
      anon_sym_BSLASH,
    ACTIONS(630), 1,
      anon_sym_function,
    ACTIONS(632), 1,
      anon_sym_if,
    ACTIONS(634), 1,
      anon_sym_for,
    ACTIONS(636), 1,
      anon_sym_while,
    ACTIONS(638), 1,
      anon_sym_repeat,
    ACTIONS(640), 1,
      anon_sym_QMARK,
    ACTIONS(642), 1,
      anon_sym_TILDE,
    ACTIONS(650), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(652), 1,
      sym__number_literal,
    ACTIONS(654), 1,
      anon_sym_SQUOTE,
    ACTIONS(656), 1,
      anon_sym_DQUOTE,
    ACTIONS(666), 1,
      sym__raw_string_literal,
    ACTIONS(668), 1,
      sym__external_open_parenthesis,
    ACTIONS(670), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7933), 1,
      anon_sym_BANG,
    ACTIONS(11171), 1,
      sym_dot_dot_i,
    STATE(54), 1,
      sym__open_parenthesis,
    STATE(56), 1,
      sym__open_brace,
    STATE(2219), 1,
      sym_string,
    STATE(2221), 1,
      sym__single_quoted_string,
    STATE(2222), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5140), 1,
      sym__string_or_identifier,
    ACTIONS(646), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2220), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(660), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11169), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(756), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [86043] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(273), 1,
      sym_identifier,
    ACTIONS(275), 1,
      anon_sym_BSLASH,
    ACTIONS(277), 1,
      anon_sym_function,
    ACTIONS(279), 1,
      anon_sym_if,
    ACTIONS(281), 1,
      anon_sym_for,
    ACTIONS(283), 1,
      anon_sym_while,
    ACTIONS(285), 1,
      anon_sym_repeat,
    ACTIONS(287), 1,
      anon_sym_QMARK,
    ACTIONS(289), 1,
      anon_sym_TILDE,
    ACTIONS(297), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(299), 1,
      sym__number_literal,
    ACTIONS(301), 1,
      anon_sym_SQUOTE,
    ACTIONS(303), 1,
      anon_sym_DQUOTE,
    ACTIONS(313), 1,
      sym__raw_string_literal,
    ACTIONS(315), 1,
      sym__external_open_parenthesis,
    ACTIONS(319), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(11159), 1,
      anon_sym_BANG,
    ACTIONS(11175), 1,
      sym_dot_dot_i,
    STATE(57), 1,
      sym__open_parenthesis,
    STATE(59), 1,
      sym__open_brace,
    STATE(2187), 1,
      sym__double_quoted_string,
    STATE(2188), 1,
      sym__single_quoted_string,
    STATE(2192), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5139), 1,
      sym__string_or_identifier,
    ACTIONS(293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2189), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(307), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11173), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(700), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [86172] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(321), 1,
      sym_identifier,
    ACTIONS(323), 1,
      anon_sym_BSLASH,
    ACTIONS(325), 1,
      anon_sym_function,
    ACTIONS(327), 1,
      anon_sym_if,
    ACTIONS(329), 1,
      anon_sym_for,
    ACTIONS(331), 1,
      anon_sym_while,
    ACTIONS(333), 1,
      anon_sym_repeat,
    ACTIONS(335), 1,
      anon_sym_QMARK,
    ACTIONS(337), 1,
      anon_sym_TILDE,
    ACTIONS(345), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(347), 1,
      sym__number_literal,
    ACTIONS(349), 1,
      anon_sym_SQUOTE,
    ACTIONS(351), 1,
      anon_sym_DQUOTE,
    ACTIONS(361), 1,
      sym__raw_string_literal,
    ACTIONS(363), 1,
      sym__external_open_parenthesis,
    ACTIONS(365), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(10329), 1,
      anon_sym_BANG,
    ACTIONS(11179), 1,
      sym_dot_dot_i,
    STATE(24), 1,
      sym__open_brace,
    STATE(67), 1,
      sym__open_parenthesis,
    STATE(2169), 1,
      sym_string,
    STATE(2180), 1,
      sym__double_quoted_string,
    STATE(2181), 1,
      sym__single_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5149), 1,
      sym__string_or_identifier,
    ACTIONS(341), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2183), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(355), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11177), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(905), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [86301] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(11183), 1,
      sym_dot_dot_i,
    ACTIONS(11185), 1,
      sym__newline,
    STATE(292), 1,
      sym__open_brace,
    STATE(293), 1,
      sym__open_parenthesis,
    STATE(2562), 1,
      sym_string,
    STATE(2737), 1,
      sym__double_quoted_string,
    STATE(2738), 1,
      sym__single_quoted_string,
    STATE(3980), 1,
      aux_sym_function_definition_repeat1,
    STATE(5152), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2739), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11181), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2135), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [86430] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(11189), 1,
      sym_dot_dot_i,
    ACTIONS(11191), 1,
      sym__newline,
    STATE(292), 1,
      sym__open_brace,
    STATE(293), 1,
      sym__open_parenthesis,
    STATE(2562), 1,
      sym_string,
    STATE(2737), 1,
      sym__double_quoted_string,
    STATE(2738), 1,
      sym__single_quoted_string,
    STATE(4056), 1,
      aux_sym_function_definition_repeat1,
    STATE(5152), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2739), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11187), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2128), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [86559] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(11195), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11193), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4598), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [86688] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(273), 1,
      sym_identifier,
    ACTIONS(275), 1,
      anon_sym_BSLASH,
    ACTIONS(277), 1,
      anon_sym_function,
    ACTIONS(279), 1,
      anon_sym_if,
    ACTIONS(281), 1,
      anon_sym_for,
    ACTIONS(283), 1,
      anon_sym_while,
    ACTIONS(285), 1,
      anon_sym_repeat,
    ACTIONS(287), 1,
      anon_sym_QMARK,
    ACTIONS(289), 1,
      anon_sym_TILDE,
    ACTIONS(297), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(299), 1,
      sym__number_literal,
    ACTIONS(301), 1,
      anon_sym_SQUOTE,
    ACTIONS(303), 1,
      anon_sym_DQUOTE,
    ACTIONS(313), 1,
      sym__raw_string_literal,
    ACTIONS(315), 1,
      sym__external_open_parenthesis,
    ACTIONS(319), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(11159), 1,
      anon_sym_BANG,
    ACTIONS(11199), 1,
      sym_dot_dot_i,
    STATE(57), 1,
      sym__open_parenthesis,
    STATE(59), 1,
      sym__open_brace,
    STATE(2187), 1,
      sym__double_quoted_string,
    STATE(2188), 1,
      sym__single_quoted_string,
    STATE(2192), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5139), 1,
      sym__string_or_identifier,
    ACTIONS(293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2189), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(307), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11197), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(701), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [86817] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(273), 1,
      sym_identifier,
    ACTIONS(275), 1,
      anon_sym_BSLASH,
    ACTIONS(277), 1,
      anon_sym_function,
    ACTIONS(279), 1,
      anon_sym_if,
    ACTIONS(281), 1,
      anon_sym_for,
    ACTIONS(283), 1,
      anon_sym_while,
    ACTIONS(285), 1,
      anon_sym_repeat,
    ACTIONS(287), 1,
      anon_sym_QMARK,
    ACTIONS(289), 1,
      anon_sym_TILDE,
    ACTIONS(297), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(299), 1,
      sym__number_literal,
    ACTIONS(301), 1,
      anon_sym_SQUOTE,
    ACTIONS(303), 1,
      anon_sym_DQUOTE,
    ACTIONS(313), 1,
      sym__raw_string_literal,
    ACTIONS(315), 1,
      sym__external_open_parenthesis,
    ACTIONS(319), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(11159), 1,
      anon_sym_BANG,
    ACTIONS(11203), 1,
      sym_dot_dot_i,
    STATE(57), 1,
      sym__open_parenthesis,
    STATE(59), 1,
      sym__open_brace,
    STATE(2187), 1,
      sym__double_quoted_string,
    STATE(2188), 1,
      sym__single_quoted_string,
    STATE(2192), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5139), 1,
      sym__string_or_identifier,
    ACTIONS(293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2189), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(307), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11201), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(702), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [86946] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4053), 1,
      sym_identifier,
    ACTIONS(4055), 1,
      anon_sym_BSLASH,
    ACTIONS(4057), 1,
      anon_sym_function,
    ACTIONS(4059), 1,
      anon_sym_if,
    ACTIONS(4061), 1,
      anon_sym_for,
    ACTIONS(4063), 1,
      anon_sym_while,
    ACTIONS(4065), 1,
      anon_sym_repeat,
    ACTIONS(4067), 1,
      anon_sym_QMARK,
    ACTIONS(4069), 1,
      anon_sym_TILDE,
    ACTIONS(4077), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4079), 1,
      sym__number_literal,
    ACTIONS(4081), 1,
      anon_sym_SQUOTE,
    ACTIONS(4083), 1,
      anon_sym_DQUOTE,
    ACTIONS(4093), 1,
      sym__raw_string_literal,
    ACTIONS(4095), 1,
      sym__external_open_parenthesis,
    ACTIONS(4097), 1,
      sym__external_open_brace,
    ACTIONS(7821), 1,
      anon_sym_BANG,
    ACTIONS(11207), 1,
      sym_dot_dot_i,
    ACTIONS(11209), 1,
      sym__newline,
    STATE(133), 1,
      sym__open_brace,
    STATE(150), 1,
      sym__open_parenthesis,
    STATE(2534), 1,
      sym_string,
    STATE(2538), 1,
      sym__single_quoted_string,
    STATE(2539), 1,
      sym__double_quoted_string,
    STATE(3738), 1,
      aux_sym_function_definition_repeat1,
    STATE(5143), 1,
      sym__string_or_identifier,
    ACTIONS(4073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2536), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4087), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11205), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1893), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [87075] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(321), 1,
      sym_identifier,
    ACTIONS(323), 1,
      anon_sym_BSLASH,
    ACTIONS(325), 1,
      anon_sym_function,
    ACTIONS(327), 1,
      anon_sym_if,
    ACTIONS(329), 1,
      anon_sym_for,
    ACTIONS(331), 1,
      anon_sym_while,
    ACTIONS(333), 1,
      anon_sym_repeat,
    ACTIONS(335), 1,
      anon_sym_QMARK,
    ACTIONS(337), 1,
      anon_sym_TILDE,
    ACTIONS(345), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(347), 1,
      sym__number_literal,
    ACTIONS(349), 1,
      anon_sym_SQUOTE,
    ACTIONS(351), 1,
      anon_sym_DQUOTE,
    ACTIONS(361), 1,
      sym__raw_string_literal,
    ACTIONS(363), 1,
      sym__external_open_parenthesis,
    ACTIONS(365), 1,
      sym__external_open_brace,
    ACTIONS(10329), 1,
      anon_sym_BANG,
    ACTIONS(11213), 1,
      sym_dot_dot_i,
    ACTIONS(11215), 1,
      sym__newline,
    STATE(24), 1,
      sym__open_brace,
    STATE(67), 1,
      sym__open_parenthesis,
    STATE(2169), 1,
      sym_string,
    STATE(2180), 1,
      sym__double_quoted_string,
    STATE(2181), 1,
      sym__single_quoted_string,
    STATE(3687), 1,
      aux_sym_function_definition_repeat1,
    STATE(5149), 1,
      sym__string_or_identifier,
    ACTIONS(341), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2183), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(355), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11211), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(908), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [87204] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(321), 1,
      sym_identifier,
    ACTIONS(323), 1,
      anon_sym_BSLASH,
    ACTIONS(325), 1,
      anon_sym_function,
    ACTIONS(327), 1,
      anon_sym_if,
    ACTIONS(329), 1,
      anon_sym_for,
    ACTIONS(331), 1,
      anon_sym_while,
    ACTIONS(333), 1,
      anon_sym_repeat,
    ACTIONS(335), 1,
      anon_sym_QMARK,
    ACTIONS(337), 1,
      anon_sym_TILDE,
    ACTIONS(345), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(347), 1,
      sym__number_literal,
    ACTIONS(349), 1,
      anon_sym_SQUOTE,
    ACTIONS(351), 1,
      anon_sym_DQUOTE,
    ACTIONS(361), 1,
      sym__raw_string_literal,
    ACTIONS(363), 1,
      sym__external_open_parenthesis,
    ACTIONS(365), 1,
      sym__external_open_brace,
    ACTIONS(10329), 1,
      anon_sym_BANG,
    ACTIONS(11219), 1,
      sym_dot_dot_i,
    ACTIONS(11221), 1,
      sym__newline,
    STATE(24), 1,
      sym__open_brace,
    STATE(67), 1,
      sym__open_parenthesis,
    STATE(2169), 1,
      sym_string,
    STATE(2180), 1,
      sym__double_quoted_string,
    STATE(2181), 1,
      sym__single_quoted_string,
    STATE(3689), 1,
      aux_sym_function_definition_repeat1,
    STATE(5149), 1,
      sym__string_or_identifier,
    ACTIONS(341), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2183), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(355), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11217), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(909), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [87333] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(321), 1,
      sym_identifier,
    ACTIONS(323), 1,
      anon_sym_BSLASH,
    ACTIONS(325), 1,
      anon_sym_function,
    ACTIONS(327), 1,
      anon_sym_if,
    ACTIONS(329), 1,
      anon_sym_for,
    ACTIONS(331), 1,
      anon_sym_while,
    ACTIONS(333), 1,
      anon_sym_repeat,
    ACTIONS(335), 1,
      anon_sym_QMARK,
    ACTIONS(337), 1,
      anon_sym_TILDE,
    ACTIONS(345), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(347), 1,
      sym__number_literal,
    ACTIONS(349), 1,
      anon_sym_SQUOTE,
    ACTIONS(351), 1,
      anon_sym_DQUOTE,
    ACTIONS(361), 1,
      sym__raw_string_literal,
    ACTIONS(363), 1,
      sym__external_open_parenthesis,
    ACTIONS(365), 1,
      sym__external_open_brace,
    ACTIONS(10329), 1,
      anon_sym_BANG,
    ACTIONS(11225), 1,
      sym_dot_dot_i,
    ACTIONS(11227), 1,
      sym__newline,
    STATE(24), 1,
      sym__open_brace,
    STATE(67), 1,
      sym__open_parenthesis,
    STATE(2169), 1,
      sym_string,
    STATE(2180), 1,
      sym__double_quoted_string,
    STATE(2181), 1,
      sym__single_quoted_string,
    STATE(3693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5149), 1,
      sym__string_or_identifier,
    ACTIONS(341), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2183), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(355), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11223), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(910), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [87462] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(321), 1,
      sym_identifier,
    ACTIONS(323), 1,
      anon_sym_BSLASH,
    ACTIONS(325), 1,
      anon_sym_function,
    ACTIONS(327), 1,
      anon_sym_if,
    ACTIONS(329), 1,
      anon_sym_for,
    ACTIONS(331), 1,
      anon_sym_while,
    ACTIONS(333), 1,
      anon_sym_repeat,
    ACTIONS(335), 1,
      anon_sym_QMARK,
    ACTIONS(337), 1,
      anon_sym_TILDE,
    ACTIONS(345), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(347), 1,
      sym__number_literal,
    ACTIONS(349), 1,
      anon_sym_SQUOTE,
    ACTIONS(351), 1,
      anon_sym_DQUOTE,
    ACTIONS(361), 1,
      sym__raw_string_literal,
    ACTIONS(363), 1,
      sym__external_open_parenthesis,
    ACTIONS(365), 1,
      sym__external_open_brace,
    ACTIONS(10329), 1,
      anon_sym_BANG,
    ACTIONS(11231), 1,
      sym_dot_dot_i,
    ACTIONS(11233), 1,
      sym__newline,
    STATE(24), 1,
      sym__open_brace,
    STATE(67), 1,
      sym__open_parenthesis,
    STATE(2169), 1,
      sym_string,
    STATE(2180), 1,
      sym__double_quoted_string,
    STATE(2181), 1,
      sym__single_quoted_string,
    STATE(3696), 1,
      aux_sym_function_definition_repeat1,
    STATE(5149), 1,
      sym__string_or_identifier,
    ACTIONS(341), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2183), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(355), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11229), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(911), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [87591] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(273), 1,
      sym_identifier,
    ACTIONS(275), 1,
      anon_sym_BSLASH,
    ACTIONS(277), 1,
      anon_sym_function,
    ACTIONS(279), 1,
      anon_sym_if,
    ACTIONS(281), 1,
      anon_sym_for,
    ACTIONS(283), 1,
      anon_sym_while,
    ACTIONS(285), 1,
      anon_sym_repeat,
    ACTIONS(287), 1,
      anon_sym_QMARK,
    ACTIONS(289), 1,
      anon_sym_TILDE,
    ACTIONS(297), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(299), 1,
      sym__number_literal,
    ACTIONS(301), 1,
      anon_sym_SQUOTE,
    ACTIONS(303), 1,
      anon_sym_DQUOTE,
    ACTIONS(313), 1,
      sym__raw_string_literal,
    ACTIONS(315), 1,
      sym__external_open_parenthesis,
    ACTIONS(319), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(11159), 1,
      anon_sym_BANG,
    ACTIONS(11237), 1,
      sym_dot_dot_i,
    STATE(57), 1,
      sym__open_parenthesis,
    STATE(59), 1,
      sym__open_brace,
    STATE(2187), 1,
      sym__double_quoted_string,
    STATE(2188), 1,
      sym__single_quoted_string,
    STATE(2192), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5139), 1,
      sym__string_or_identifier,
    ACTIONS(293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2189), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(307), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11235), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(703), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [87720] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(11241), 1,
      sym_dot_dot_i,
    ACTIONS(11243), 1,
      sym__newline,
    STATE(292), 1,
      sym__open_brace,
    STATE(293), 1,
      sym__open_parenthesis,
    STATE(2562), 1,
      sym_string,
    STATE(2737), 1,
      sym__double_quoted_string,
    STATE(2738), 1,
      sym__single_quoted_string,
    STATE(4085), 1,
      aux_sym_function_definition_repeat1,
    STATE(5152), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2739), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11239), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2127), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [87849] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(11247), 1,
      sym_dot_dot_i,
    ACTIONS(11249), 1,
      sym__newline,
    STATE(292), 1,
      sym__open_brace,
    STATE(293), 1,
      sym__open_parenthesis,
    STATE(2562), 1,
      sym_string,
    STATE(2737), 1,
      sym__double_quoted_string,
    STATE(2738), 1,
      sym__single_quoted_string,
    STATE(4081), 1,
      aux_sym_function_definition_repeat1,
    STATE(5152), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2739), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11245), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2126), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [87978] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2826), 1,
      sym_identifier,
    ACTIONS(2828), 1,
      anon_sym_BSLASH,
    ACTIONS(2830), 1,
      anon_sym_function,
    ACTIONS(2832), 1,
      anon_sym_if,
    ACTIONS(2834), 1,
      anon_sym_for,
    ACTIONS(2836), 1,
      anon_sym_while,
    ACTIONS(2838), 1,
      anon_sym_repeat,
    ACTIONS(2840), 1,
      anon_sym_QMARK,
    ACTIONS(2842), 1,
      anon_sym_TILDE,
    ACTIONS(2850), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2852), 1,
      sym__number_literal,
    ACTIONS(2854), 1,
      anon_sym_SQUOTE,
    ACTIONS(2856), 1,
      anon_sym_DQUOTE,
    ACTIONS(2866), 1,
      sym__raw_string_literal,
    ACTIONS(2868), 1,
      sym__external_open_parenthesis,
    ACTIONS(2870), 1,
      sym__external_open_brace,
    ACTIONS(10915), 1,
      anon_sym_BANG,
    ACTIONS(11253), 1,
      sym_dot_dot_i,
    ACTIONS(11255), 1,
      sym__newline,
    STATE(178), 1,
      sym__open_parenthesis,
    STATE(244), 1,
      sym__open_brace,
    STATE(2522), 1,
      sym_string,
    STATE(2528), 1,
      sym__single_quoted_string,
    STATE(2529), 1,
      sym__double_quoted_string,
    STATE(3963), 1,
      aux_sym_function_definition_repeat1,
    STATE(5126), 1,
      sym__string_or_identifier,
    ACTIONS(2846), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2523), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2860), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11251), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1626), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [88107] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4053), 1,
      sym_identifier,
    ACTIONS(4055), 1,
      anon_sym_BSLASH,
    ACTIONS(4057), 1,
      anon_sym_function,
    ACTIONS(4059), 1,
      anon_sym_if,
    ACTIONS(4061), 1,
      anon_sym_for,
    ACTIONS(4063), 1,
      anon_sym_while,
    ACTIONS(4065), 1,
      anon_sym_repeat,
    ACTIONS(4067), 1,
      anon_sym_QMARK,
    ACTIONS(4069), 1,
      anon_sym_TILDE,
    ACTIONS(4077), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4079), 1,
      sym__number_literal,
    ACTIONS(4081), 1,
      anon_sym_SQUOTE,
    ACTIONS(4083), 1,
      anon_sym_DQUOTE,
    ACTIONS(4093), 1,
      sym__raw_string_literal,
    ACTIONS(4095), 1,
      sym__external_open_parenthesis,
    ACTIONS(4097), 1,
      sym__external_open_brace,
    ACTIONS(7821), 1,
      anon_sym_BANG,
    ACTIONS(11259), 1,
      sym_dot_dot_i,
    ACTIONS(11261), 1,
      sym__newline,
    STATE(133), 1,
      sym__open_brace,
    STATE(150), 1,
      sym__open_parenthesis,
    STATE(2534), 1,
      sym_string,
    STATE(2538), 1,
      sym__single_quoted_string,
    STATE(2539), 1,
      sym__double_quoted_string,
    STATE(3750), 1,
      aux_sym_function_definition_repeat1,
    STATE(5143), 1,
      sym__string_or_identifier,
    ACTIONS(4073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2536), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4087), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11257), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1899), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [88236] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4053), 1,
      sym_identifier,
    ACTIONS(4055), 1,
      anon_sym_BSLASH,
    ACTIONS(4057), 1,
      anon_sym_function,
    ACTIONS(4059), 1,
      anon_sym_if,
    ACTIONS(4061), 1,
      anon_sym_for,
    ACTIONS(4063), 1,
      anon_sym_while,
    ACTIONS(4065), 1,
      anon_sym_repeat,
    ACTIONS(4067), 1,
      anon_sym_QMARK,
    ACTIONS(4069), 1,
      anon_sym_TILDE,
    ACTIONS(4077), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4079), 1,
      sym__number_literal,
    ACTIONS(4081), 1,
      anon_sym_SQUOTE,
    ACTIONS(4083), 1,
      anon_sym_DQUOTE,
    ACTIONS(4093), 1,
      sym__raw_string_literal,
    ACTIONS(4095), 1,
      sym__external_open_parenthesis,
    ACTIONS(4097), 1,
      sym__external_open_brace,
    ACTIONS(7821), 1,
      anon_sym_BANG,
    ACTIONS(11265), 1,
      sym_dot_dot_i,
    ACTIONS(11267), 1,
      sym__newline,
    STATE(133), 1,
      sym__open_brace,
    STATE(150), 1,
      sym__open_parenthesis,
    STATE(2534), 1,
      sym_string,
    STATE(2538), 1,
      sym__single_quoted_string,
    STATE(2539), 1,
      sym__double_quoted_string,
    STATE(3732), 1,
      aux_sym_function_definition_repeat1,
    STATE(5143), 1,
      sym__string_or_identifier,
    ACTIONS(4073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2536), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4087), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11263), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1897), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [88365] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4053), 1,
      sym_identifier,
    ACTIONS(4055), 1,
      anon_sym_BSLASH,
    ACTIONS(4057), 1,
      anon_sym_function,
    ACTIONS(4059), 1,
      anon_sym_if,
    ACTIONS(4061), 1,
      anon_sym_for,
    ACTIONS(4063), 1,
      anon_sym_while,
    ACTIONS(4065), 1,
      anon_sym_repeat,
    ACTIONS(4067), 1,
      anon_sym_QMARK,
    ACTIONS(4069), 1,
      anon_sym_TILDE,
    ACTIONS(4077), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4079), 1,
      sym__number_literal,
    ACTIONS(4081), 1,
      anon_sym_SQUOTE,
    ACTIONS(4083), 1,
      anon_sym_DQUOTE,
    ACTIONS(4093), 1,
      sym__raw_string_literal,
    ACTIONS(4095), 1,
      sym__external_open_parenthesis,
    ACTIONS(4097), 1,
      sym__external_open_brace,
    ACTIONS(7821), 1,
      anon_sym_BANG,
    ACTIONS(11271), 1,
      sym_dot_dot_i,
    ACTIONS(11273), 1,
      sym__newline,
    STATE(133), 1,
      sym__open_brace,
    STATE(150), 1,
      sym__open_parenthesis,
    STATE(2534), 1,
      sym_string,
    STATE(2538), 1,
      sym__single_quoted_string,
    STATE(2539), 1,
      sym__double_quoted_string,
    STATE(3736), 1,
      aux_sym_function_definition_repeat1,
    STATE(5143), 1,
      sym__string_or_identifier,
    ACTIONS(4073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2536), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4087), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11269), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1896), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [88494] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(273), 1,
      sym_identifier,
    ACTIONS(275), 1,
      anon_sym_BSLASH,
    ACTIONS(277), 1,
      anon_sym_function,
    ACTIONS(279), 1,
      anon_sym_if,
    ACTIONS(281), 1,
      anon_sym_for,
    ACTIONS(283), 1,
      anon_sym_while,
    ACTIONS(285), 1,
      anon_sym_repeat,
    ACTIONS(287), 1,
      anon_sym_QMARK,
    ACTIONS(289), 1,
      anon_sym_TILDE,
    ACTIONS(297), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(299), 1,
      sym__number_literal,
    ACTIONS(301), 1,
      anon_sym_SQUOTE,
    ACTIONS(303), 1,
      anon_sym_DQUOTE,
    ACTIONS(313), 1,
      sym__raw_string_literal,
    ACTIONS(315), 1,
      sym__external_open_parenthesis,
    ACTIONS(319), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(11159), 1,
      anon_sym_BANG,
    ACTIONS(11277), 1,
      sym_dot_dot_i,
    STATE(57), 1,
      sym__open_parenthesis,
    STATE(59), 1,
      sym__open_brace,
    STATE(2187), 1,
      sym__double_quoted_string,
    STATE(2188), 1,
      sym__single_quoted_string,
    STATE(2192), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5139), 1,
      sym__string_or_identifier,
    ACTIONS(293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2189), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(307), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11275), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(704), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [88623] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1385), 1,
      sym_identifier,
    ACTIONS(1387), 1,
      anon_sym_BSLASH,
    ACTIONS(1389), 1,
      anon_sym_function,
    ACTIONS(1391), 1,
      anon_sym_if,
    ACTIONS(1393), 1,
      anon_sym_for,
    ACTIONS(1395), 1,
      anon_sym_while,
    ACTIONS(1397), 1,
      anon_sym_repeat,
    ACTIONS(1399), 1,
      anon_sym_QMARK,
    ACTIONS(1401), 1,
      anon_sym_TILDE,
    ACTIONS(1409), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1411), 1,
      sym__number_literal,
    ACTIONS(1413), 1,
      anon_sym_SQUOTE,
    ACTIONS(1415), 1,
      anon_sym_DQUOTE,
    ACTIONS(1425), 1,
      sym__raw_string_literal,
    ACTIONS(1427), 1,
      sym__external_open_parenthesis,
    ACTIONS(1429), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9251), 1,
      anon_sym_BANG,
    ACTIONS(11281), 1,
      sym_dot_dot_i,
    STATE(64), 1,
      sym__open_parenthesis,
    STATE(199), 1,
      sym__open_brace,
    STATE(2309), 1,
      sym__double_quoted_string,
    STATE(2310), 1,
      sym__single_quoted_string,
    STATE(2312), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5134), 1,
      sym__string_or_identifier,
    ACTIONS(1405), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2311), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1419), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11279), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1041), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [88752] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2826), 1,
      sym_identifier,
    ACTIONS(2828), 1,
      anon_sym_BSLASH,
    ACTIONS(2830), 1,
      anon_sym_function,
    ACTIONS(2832), 1,
      anon_sym_if,
    ACTIONS(2834), 1,
      anon_sym_for,
    ACTIONS(2836), 1,
      anon_sym_while,
    ACTIONS(2838), 1,
      anon_sym_repeat,
    ACTIONS(2840), 1,
      anon_sym_QMARK,
    ACTIONS(2842), 1,
      anon_sym_TILDE,
    ACTIONS(2850), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2852), 1,
      sym__number_literal,
    ACTIONS(2854), 1,
      anon_sym_SQUOTE,
    ACTIONS(2856), 1,
      anon_sym_DQUOTE,
    ACTIONS(2866), 1,
      sym__raw_string_literal,
    ACTIONS(2868), 1,
      sym__external_open_parenthesis,
    ACTIONS(2870), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(10915), 1,
      anon_sym_BANG,
    ACTIONS(11285), 1,
      sym_dot_dot_i,
    STATE(178), 1,
      sym__open_parenthesis,
    STATE(244), 1,
      sym__open_brace,
    STATE(2522), 1,
      sym_string,
    STATE(2528), 1,
      sym__single_quoted_string,
    STATE(2529), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5126), 1,
      sym__string_or_identifier,
    ACTIONS(2846), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2523), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2860), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11283), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1676), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [88881] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(11289), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11287), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4597), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [89010] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2826), 1,
      sym_identifier,
    ACTIONS(2828), 1,
      anon_sym_BSLASH,
    ACTIONS(2830), 1,
      anon_sym_function,
    ACTIONS(2832), 1,
      anon_sym_if,
    ACTIONS(2834), 1,
      anon_sym_for,
    ACTIONS(2836), 1,
      anon_sym_while,
    ACTIONS(2838), 1,
      anon_sym_repeat,
    ACTIONS(2840), 1,
      anon_sym_QMARK,
    ACTIONS(2842), 1,
      anon_sym_TILDE,
    ACTIONS(2850), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2852), 1,
      sym__number_literal,
    ACTIONS(2854), 1,
      anon_sym_SQUOTE,
    ACTIONS(2856), 1,
      anon_sym_DQUOTE,
    ACTIONS(2866), 1,
      sym__raw_string_literal,
    ACTIONS(2868), 1,
      sym__external_open_parenthesis,
    ACTIONS(2870), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(10915), 1,
      anon_sym_BANG,
    ACTIONS(11293), 1,
      sym_dot_dot_i,
    STATE(178), 1,
      sym__open_parenthesis,
    STATE(244), 1,
      sym__open_brace,
    STATE(2522), 1,
      sym_string,
    STATE(2528), 1,
      sym__single_quoted_string,
    STATE(2529), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5126), 1,
      sym__string_or_identifier,
    ACTIONS(2846), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2523), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2860), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11291), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1678), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [89139] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(11297), 1,
      sym_dot_dot_i,
    ACTIONS(11299), 1,
      sym__newline,
    STATE(292), 1,
      sym__open_brace,
    STATE(293), 1,
      sym__open_parenthesis,
    STATE(2562), 1,
      sym_string,
    STATE(2737), 1,
      sym__double_quoted_string,
    STATE(2738), 1,
      sym__single_quoted_string,
    STATE(4077), 1,
      aux_sym_function_definition_repeat1,
    STATE(5152), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2739), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11295), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2125), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [89268] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(11303), 1,
      sym_dot_dot_i,
    ACTIONS(11305), 1,
      sym__newline,
    STATE(292), 1,
      sym__open_brace,
    STATE(293), 1,
      sym__open_parenthesis,
    STATE(2562), 1,
      sym_string,
    STATE(2737), 1,
      sym__double_quoted_string,
    STATE(2738), 1,
      sym__single_quoted_string,
    STATE(4073), 1,
      aux_sym_function_definition_repeat1,
    STATE(5152), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2739), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11301), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1918), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [89397] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2943), 1,
      sym_identifier,
    ACTIONS(2945), 1,
      anon_sym_BSLASH,
    ACTIONS(2947), 1,
      anon_sym_function,
    ACTIONS(2949), 1,
      anon_sym_if,
    ACTIONS(2951), 1,
      anon_sym_for,
    ACTIONS(2953), 1,
      anon_sym_while,
    ACTIONS(2955), 1,
      anon_sym_repeat,
    ACTIONS(2957), 1,
      anon_sym_QMARK,
    ACTIONS(2959), 1,
      anon_sym_TILDE,
    ACTIONS(2967), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2969), 1,
      sym__number_literal,
    ACTIONS(2971), 1,
      anon_sym_SQUOTE,
    ACTIONS(2973), 1,
      anon_sym_DQUOTE,
    ACTIONS(2983), 1,
      sym__raw_string_literal,
    ACTIONS(2985), 1,
      sym__external_open_parenthesis,
    ACTIONS(2989), 1,
      sym__external_open_brace,
    ACTIONS(7797), 1,
      anon_sym_BANG,
    ACTIONS(11309), 1,
      sym_dot_dot_i,
    ACTIONS(11311), 1,
      sym__newline,
    STATE(173), 1,
      sym__open_brace,
    STATE(246), 1,
      sym__open_parenthesis,
    STATE(2462), 1,
      sym__single_quoted_string,
    STATE(2494), 1,
      sym__double_quoted_string,
    STATE(2541), 1,
      sym_string,
    STATE(3580), 1,
      aux_sym_function_definition_repeat1,
    STATE(5128), 1,
      sym__string_or_identifier,
    ACTIONS(2963), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2540), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2977), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11307), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1413), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [89526] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(11315), 1,
      sym_dot_dot_i,
    ACTIONS(11317), 1,
      sym__newline,
    STATE(292), 1,
      sym__open_brace,
    STATE(293), 1,
      sym__open_parenthesis,
    STATE(2562), 1,
      sym_string,
    STATE(2737), 1,
      sym__double_quoted_string,
    STATE(2738), 1,
      sym__single_quoted_string,
    STATE(4069), 1,
      aux_sym_function_definition_repeat1,
    STATE(5152), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2739), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11313), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2120), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [89655] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(11321), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11319), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4596), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [89784] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(11325), 1,
      sym_dot_dot_i,
    ACTIONS(11327), 1,
      sym__newline,
    STATE(292), 1,
      sym__open_brace,
    STATE(293), 1,
      sym__open_parenthesis,
    STATE(2562), 1,
      sym_string,
    STATE(2737), 1,
      sym__double_quoted_string,
    STATE(2738), 1,
      sym__single_quoted_string,
    STATE(4026), 1,
      aux_sym_function_definition_repeat1,
    STATE(5152), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2739), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11323), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2119), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [89913] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1385), 1,
      sym_identifier,
    ACTIONS(1387), 1,
      anon_sym_BSLASH,
    ACTIONS(1389), 1,
      anon_sym_function,
    ACTIONS(1391), 1,
      anon_sym_if,
    ACTIONS(1393), 1,
      anon_sym_for,
    ACTIONS(1395), 1,
      anon_sym_while,
    ACTIONS(1397), 1,
      anon_sym_repeat,
    ACTIONS(1399), 1,
      anon_sym_QMARK,
    ACTIONS(1401), 1,
      anon_sym_TILDE,
    ACTIONS(1409), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1411), 1,
      sym__number_literal,
    ACTIONS(1413), 1,
      anon_sym_SQUOTE,
    ACTIONS(1415), 1,
      anon_sym_DQUOTE,
    ACTIONS(1425), 1,
      sym__raw_string_literal,
    ACTIONS(1427), 1,
      sym__external_open_parenthesis,
    ACTIONS(1429), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9251), 1,
      anon_sym_BANG,
    ACTIONS(11331), 1,
      sym_dot_dot_i,
    STATE(64), 1,
      sym__open_parenthesis,
    STATE(199), 1,
      sym__open_brace,
    STATE(2309), 1,
      sym__double_quoted_string,
    STATE(2310), 1,
      sym__single_quoted_string,
    STATE(2312), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5134), 1,
      sym__string_or_identifier,
    ACTIONS(1405), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2311), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1419), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11329), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1081), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [90042] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2943), 1,
      sym_identifier,
    ACTIONS(2945), 1,
      anon_sym_BSLASH,
    ACTIONS(2947), 1,
      anon_sym_function,
    ACTIONS(2949), 1,
      anon_sym_if,
    ACTIONS(2951), 1,
      anon_sym_for,
    ACTIONS(2953), 1,
      anon_sym_while,
    ACTIONS(2955), 1,
      anon_sym_repeat,
    ACTIONS(2957), 1,
      anon_sym_QMARK,
    ACTIONS(2959), 1,
      anon_sym_TILDE,
    ACTIONS(2967), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2969), 1,
      sym__number_literal,
    ACTIONS(2971), 1,
      anon_sym_SQUOTE,
    ACTIONS(2973), 1,
      anon_sym_DQUOTE,
    ACTIONS(2983), 1,
      sym__raw_string_literal,
    ACTIONS(2985), 1,
      sym__external_open_parenthesis,
    ACTIONS(2989), 1,
      sym__external_open_brace,
    ACTIONS(7797), 1,
      anon_sym_BANG,
    ACTIONS(11335), 1,
      sym_dot_dot_i,
    ACTIONS(11337), 1,
      sym__newline,
    STATE(173), 1,
      sym__open_brace,
    STATE(246), 1,
      sym__open_parenthesis,
    STATE(2462), 1,
      sym__single_quoted_string,
    STATE(2494), 1,
      sym__double_quoted_string,
    STATE(2541), 1,
      sym_string,
    STATE(3588), 1,
      aux_sym_function_definition_repeat1,
    STATE(5128), 1,
      sym__string_or_identifier,
    ACTIONS(2963), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2540), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2977), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11333), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1422), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [90171] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2943), 1,
      sym_identifier,
    ACTIONS(2945), 1,
      anon_sym_BSLASH,
    ACTIONS(2947), 1,
      anon_sym_function,
    ACTIONS(2949), 1,
      anon_sym_if,
    ACTIONS(2951), 1,
      anon_sym_for,
    ACTIONS(2953), 1,
      anon_sym_while,
    ACTIONS(2955), 1,
      anon_sym_repeat,
    ACTIONS(2957), 1,
      anon_sym_QMARK,
    ACTIONS(2959), 1,
      anon_sym_TILDE,
    ACTIONS(2967), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2969), 1,
      sym__number_literal,
    ACTIONS(2971), 1,
      anon_sym_SQUOTE,
    ACTIONS(2973), 1,
      anon_sym_DQUOTE,
    ACTIONS(2983), 1,
      sym__raw_string_literal,
    ACTIONS(2985), 1,
      sym__external_open_parenthesis,
    ACTIONS(2989), 1,
      sym__external_open_brace,
    ACTIONS(7797), 1,
      anon_sym_BANG,
    ACTIONS(11341), 1,
      sym_dot_dot_i,
    ACTIONS(11343), 1,
      sym__newline,
    STATE(173), 1,
      sym__open_brace,
    STATE(246), 1,
      sym__open_parenthesis,
    STATE(2462), 1,
      sym__single_quoted_string,
    STATE(2494), 1,
      sym__double_quoted_string,
    STATE(2541), 1,
      sym_string,
    STATE(3596), 1,
      aux_sym_function_definition_repeat1,
    STATE(5128), 1,
      sym__string_or_identifier,
    ACTIONS(2963), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2540), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2977), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11339), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1535), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [90300] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(11347), 1,
      sym_dot_dot_i,
    ACTIONS(11349), 1,
      sym__newline,
    STATE(292), 1,
      sym__open_brace,
    STATE(293), 1,
      sym__open_parenthesis,
    STATE(2562), 1,
      sym_string,
    STATE(2737), 1,
      sym__double_quoted_string,
    STATE(2738), 1,
      sym__single_quoted_string,
    STATE(4062), 1,
      aux_sym_function_definition_repeat1,
    STATE(5152), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2739), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11345), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1988), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [90429] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(273), 1,
      sym_identifier,
    ACTIONS(275), 1,
      anon_sym_BSLASH,
    ACTIONS(277), 1,
      anon_sym_function,
    ACTIONS(279), 1,
      anon_sym_if,
    ACTIONS(281), 1,
      anon_sym_for,
    ACTIONS(283), 1,
      anon_sym_while,
    ACTIONS(285), 1,
      anon_sym_repeat,
    ACTIONS(287), 1,
      anon_sym_QMARK,
    ACTIONS(289), 1,
      anon_sym_TILDE,
    ACTIONS(297), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(299), 1,
      sym__number_literal,
    ACTIONS(301), 1,
      anon_sym_SQUOTE,
    ACTIONS(303), 1,
      anon_sym_DQUOTE,
    ACTIONS(313), 1,
      sym__raw_string_literal,
    ACTIONS(315), 1,
      sym__external_open_parenthesis,
    ACTIONS(319), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(11159), 1,
      anon_sym_BANG,
    ACTIONS(11353), 1,
      sym_dot_dot_i,
    STATE(57), 1,
      sym__open_parenthesis,
    STATE(59), 1,
      sym__open_brace,
    STATE(2187), 1,
      sym__double_quoted_string,
    STATE(2188), 1,
      sym__single_quoted_string,
    STATE(2192), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5139), 1,
      sym__string_or_identifier,
    ACTIONS(293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2189), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(307), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11351), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(705), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [90558] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(11357), 1,
      sym_dot_dot_i,
    ACTIONS(11359), 1,
      sym__newline,
    STATE(292), 1,
      sym__open_brace,
    STATE(293), 1,
      sym__open_parenthesis,
    STATE(2562), 1,
      sym_string,
    STATE(2737), 1,
      sym__double_quoted_string,
    STATE(2738), 1,
      sym__single_quoted_string,
    STATE(4057), 1,
      aux_sym_function_definition_repeat1,
    STATE(5152), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2739), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11355), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1978), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [90687] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(11363), 1,
      sym_dot_dot_i,
    ACTIONS(11365), 1,
      sym__newline,
    STATE(292), 1,
      sym__open_brace,
    STATE(293), 1,
      sym__open_parenthesis,
    STATE(2562), 1,
      sym_string,
    STATE(2737), 1,
      sym__double_quoted_string,
    STATE(2738), 1,
      sym__single_quoted_string,
    STATE(4030), 1,
      aux_sym_function_definition_repeat1,
    STATE(5152), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2739), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11361), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1976), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [90816] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4053), 1,
      sym_identifier,
    ACTIONS(4055), 1,
      anon_sym_BSLASH,
    ACTIONS(4057), 1,
      anon_sym_function,
    ACTIONS(4059), 1,
      anon_sym_if,
    ACTIONS(4061), 1,
      anon_sym_for,
    ACTIONS(4063), 1,
      anon_sym_while,
    ACTIONS(4065), 1,
      anon_sym_repeat,
    ACTIONS(4067), 1,
      anon_sym_QMARK,
    ACTIONS(4069), 1,
      anon_sym_TILDE,
    ACTIONS(4077), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4079), 1,
      sym__number_literal,
    ACTIONS(4081), 1,
      anon_sym_SQUOTE,
    ACTIONS(4083), 1,
      anon_sym_DQUOTE,
    ACTIONS(4093), 1,
      sym__raw_string_literal,
    ACTIONS(4095), 1,
      sym__external_open_parenthesis,
    ACTIONS(4097), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7821), 1,
      anon_sym_BANG,
    ACTIONS(11369), 1,
      sym_dot_dot_i,
    STATE(133), 1,
      sym__open_brace,
    STATE(150), 1,
      sym__open_parenthesis,
    STATE(2534), 1,
      sym_string,
    STATE(2538), 1,
      sym__single_quoted_string,
    STATE(2539), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5143), 1,
      sym__string_or_identifier,
    ACTIONS(4073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2536), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4087), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11367), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1861), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [90945] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1385), 1,
      sym_identifier,
    ACTIONS(1387), 1,
      anon_sym_BSLASH,
    ACTIONS(1389), 1,
      anon_sym_function,
    ACTIONS(1391), 1,
      anon_sym_if,
    ACTIONS(1393), 1,
      anon_sym_for,
    ACTIONS(1395), 1,
      anon_sym_while,
    ACTIONS(1397), 1,
      anon_sym_repeat,
    ACTIONS(1399), 1,
      anon_sym_QMARK,
    ACTIONS(1401), 1,
      anon_sym_TILDE,
    ACTIONS(1409), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1411), 1,
      sym__number_literal,
    ACTIONS(1413), 1,
      anon_sym_SQUOTE,
    ACTIONS(1415), 1,
      anon_sym_DQUOTE,
    ACTIONS(1425), 1,
      sym__raw_string_literal,
    ACTIONS(1427), 1,
      sym__external_open_parenthesis,
    ACTIONS(1429), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9251), 1,
      anon_sym_BANG,
    ACTIONS(11373), 1,
      sym_dot_dot_i,
    STATE(64), 1,
      sym__open_parenthesis,
    STATE(199), 1,
      sym__open_brace,
    STATE(2309), 1,
      sym__double_quoted_string,
    STATE(2310), 1,
      sym__single_quoted_string,
    STATE(2312), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5134), 1,
      sym__string_or_identifier,
    ACTIONS(1405), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2311), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1419), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11371), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1080), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [91074] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2943), 1,
      sym_identifier,
    ACTIONS(2945), 1,
      anon_sym_BSLASH,
    ACTIONS(2947), 1,
      anon_sym_function,
    ACTIONS(2949), 1,
      anon_sym_if,
    ACTIONS(2951), 1,
      anon_sym_for,
    ACTIONS(2953), 1,
      anon_sym_while,
    ACTIONS(2955), 1,
      anon_sym_repeat,
    ACTIONS(2957), 1,
      anon_sym_QMARK,
    ACTIONS(2959), 1,
      anon_sym_TILDE,
    ACTIONS(2967), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2969), 1,
      sym__number_literal,
    ACTIONS(2971), 1,
      anon_sym_SQUOTE,
    ACTIONS(2973), 1,
      anon_sym_DQUOTE,
    ACTIONS(2983), 1,
      sym__raw_string_literal,
    ACTIONS(2985), 1,
      sym__external_open_parenthesis,
    ACTIONS(2989), 1,
      sym__external_open_brace,
    ACTIONS(7797), 1,
      anon_sym_BANG,
    ACTIONS(11377), 1,
      sym_dot_dot_i,
    ACTIONS(11379), 1,
      sym__newline,
    STATE(173), 1,
      sym__open_brace,
    STATE(246), 1,
      sym__open_parenthesis,
    STATE(2462), 1,
      sym__single_quoted_string,
    STATE(2494), 1,
      sym__double_quoted_string,
    STATE(2541), 1,
      sym_string,
    STATE(3610), 1,
      aux_sym_function_definition_repeat1,
    STATE(5128), 1,
      sym__string_or_identifier,
    ACTIONS(2963), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2540), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2977), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11375), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1553), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [91203] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4642), 1,
      sym_identifier,
    ACTIONS(4644), 1,
      anon_sym_BSLASH,
    ACTIONS(4646), 1,
      anon_sym_function,
    ACTIONS(4648), 1,
      anon_sym_if,
    ACTIONS(4650), 1,
      anon_sym_for,
    ACTIONS(4652), 1,
      anon_sym_while,
    ACTIONS(4654), 1,
      anon_sym_repeat,
    ACTIONS(4656), 1,
      anon_sym_QMARK,
    ACTIONS(4658), 1,
      anon_sym_TILDE,
    ACTIONS(4666), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4668), 1,
      sym__number_literal,
    ACTIONS(4670), 1,
      anon_sym_SQUOTE,
    ACTIONS(4672), 1,
      anon_sym_DQUOTE,
    ACTIONS(4680), 1,
      sym__raw_string_literal,
    ACTIONS(4682), 1,
      sym__external_open_parenthesis,
    ACTIONS(4684), 1,
      sym__external_open_brace,
    ACTIONS(6371), 1,
      anon_sym_BANG,
    ACTIONS(11383), 1,
      sym_dot_dot_i,
    ACTIONS(11385), 1,
      sym__newline,
    STATE(185), 1,
      sym__open_brace,
    STATE(218), 1,
      sym__open_parenthesis,
    STATE(2649), 1,
      sym__double_quoted_string,
    STATE(2654), 1,
      sym__single_quoted_string,
    STATE(2744), 1,
      sym_string,
    STATE(3780), 1,
      aux_sym_function_definition_repeat1,
    STATE(5141), 1,
      sym__string_or_identifier,
    ACTIONS(4662), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2656), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4676), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11381), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1956), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [91332] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4053), 1,
      sym_identifier,
    ACTIONS(4055), 1,
      anon_sym_BSLASH,
    ACTIONS(4057), 1,
      anon_sym_function,
    ACTIONS(4059), 1,
      anon_sym_if,
    ACTIONS(4061), 1,
      anon_sym_for,
    ACTIONS(4063), 1,
      anon_sym_while,
    ACTIONS(4065), 1,
      anon_sym_repeat,
    ACTIONS(4067), 1,
      anon_sym_QMARK,
    ACTIONS(4069), 1,
      anon_sym_TILDE,
    ACTIONS(4077), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4079), 1,
      sym__number_literal,
    ACTIONS(4081), 1,
      anon_sym_SQUOTE,
    ACTIONS(4083), 1,
      anon_sym_DQUOTE,
    ACTIONS(4093), 1,
      sym__raw_string_literal,
    ACTIONS(4095), 1,
      sym__external_open_parenthesis,
    ACTIONS(4097), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7821), 1,
      anon_sym_BANG,
    ACTIONS(11389), 1,
      sym_dot_dot_i,
    STATE(133), 1,
      sym__open_brace,
    STATE(150), 1,
      sym__open_parenthesis,
    STATE(2534), 1,
      sym_string,
    STATE(2538), 1,
      sym__single_quoted_string,
    STATE(2539), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5143), 1,
      sym__string_or_identifier,
    ACTIONS(4073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2536), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4087), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11387), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1860), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [91461] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1385), 1,
      sym_identifier,
    ACTIONS(1387), 1,
      anon_sym_BSLASH,
    ACTIONS(1389), 1,
      anon_sym_function,
    ACTIONS(1391), 1,
      anon_sym_if,
    ACTIONS(1393), 1,
      anon_sym_for,
    ACTIONS(1395), 1,
      anon_sym_while,
    ACTIONS(1397), 1,
      anon_sym_repeat,
    ACTIONS(1399), 1,
      anon_sym_QMARK,
    ACTIONS(1401), 1,
      anon_sym_TILDE,
    ACTIONS(1409), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1411), 1,
      sym__number_literal,
    ACTIONS(1413), 1,
      anon_sym_SQUOTE,
    ACTIONS(1415), 1,
      anon_sym_DQUOTE,
    ACTIONS(1425), 1,
      sym__raw_string_literal,
    ACTIONS(1427), 1,
      sym__external_open_parenthesis,
    ACTIONS(1429), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9251), 1,
      anon_sym_BANG,
    ACTIONS(11393), 1,
      sym_dot_dot_i,
    STATE(64), 1,
      sym__open_parenthesis,
    STATE(199), 1,
      sym__open_brace,
    STATE(2309), 1,
      sym__double_quoted_string,
    STATE(2310), 1,
      sym__single_quoted_string,
    STATE(2312), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5134), 1,
      sym__string_or_identifier,
    ACTIONS(1405), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2311), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1419), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11391), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1078), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [91590] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4053), 1,
      sym_identifier,
    ACTIONS(4055), 1,
      anon_sym_BSLASH,
    ACTIONS(4057), 1,
      anon_sym_function,
    ACTIONS(4059), 1,
      anon_sym_if,
    ACTIONS(4061), 1,
      anon_sym_for,
    ACTIONS(4063), 1,
      anon_sym_while,
    ACTIONS(4065), 1,
      anon_sym_repeat,
    ACTIONS(4067), 1,
      anon_sym_QMARK,
    ACTIONS(4069), 1,
      anon_sym_TILDE,
    ACTIONS(4077), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4079), 1,
      sym__number_literal,
    ACTIONS(4081), 1,
      anon_sym_SQUOTE,
    ACTIONS(4083), 1,
      anon_sym_DQUOTE,
    ACTIONS(4093), 1,
      sym__raw_string_literal,
    ACTIONS(4095), 1,
      sym__external_open_parenthesis,
    ACTIONS(4097), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7821), 1,
      anon_sym_BANG,
    ACTIONS(11397), 1,
      sym_dot_dot_i,
    STATE(133), 1,
      sym__open_brace,
    STATE(150), 1,
      sym__open_parenthesis,
    STATE(2534), 1,
      sym_string,
    STATE(2538), 1,
      sym__single_quoted_string,
    STATE(2539), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5143), 1,
      sym__string_or_identifier,
    ACTIONS(4073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2536), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4087), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11395), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1858), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [91719] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(405), 1,
      sym_identifier,
    ACTIONS(407), 1,
      anon_sym_BSLASH,
    ACTIONS(409), 1,
      anon_sym_function,
    ACTIONS(411), 1,
      anon_sym_if,
    ACTIONS(413), 1,
      anon_sym_for,
    ACTIONS(415), 1,
      anon_sym_while,
    ACTIONS(417), 1,
      anon_sym_repeat,
    ACTIONS(419), 1,
      anon_sym_QMARK,
    ACTIONS(421), 1,
      anon_sym_TILDE,
    ACTIONS(429), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(431), 1,
      sym__number_literal,
    ACTIONS(433), 1,
      anon_sym_SQUOTE,
    ACTIONS(435), 1,
      anon_sym_DQUOTE,
    ACTIONS(445), 1,
      sym__raw_string_literal,
    ACTIONS(447), 1,
      sym__external_open_parenthesis,
    ACTIONS(449), 1,
      sym__external_open_brace,
    ACTIONS(8403), 1,
      anon_sym_BANG,
    ACTIONS(11401), 1,
      sym_dot_dot_i,
    ACTIONS(11403), 1,
      sym__newline,
    STATE(5), 1,
      sym__open_parenthesis,
    STATE(42), 1,
      sym__open_brace,
    STATE(2209), 1,
      sym_string,
    STATE(2211), 1,
      sym__single_quoted_string,
    STATE(2212), 1,
      sym__double_quoted_string,
    STATE(3752), 1,
      aux_sym_function_definition_repeat1,
    STATE(5127), 1,
      sym__string_or_identifier,
    ACTIONS(425), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2210), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(439), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11399), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(914), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [91848] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(405), 1,
      sym_identifier,
    ACTIONS(407), 1,
      anon_sym_BSLASH,
    ACTIONS(409), 1,
      anon_sym_function,
    ACTIONS(411), 1,
      anon_sym_if,
    ACTIONS(413), 1,
      anon_sym_for,
    ACTIONS(415), 1,
      anon_sym_while,
    ACTIONS(417), 1,
      anon_sym_repeat,
    ACTIONS(419), 1,
      anon_sym_QMARK,
    ACTIONS(421), 1,
      anon_sym_TILDE,
    ACTIONS(429), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(431), 1,
      sym__number_literal,
    ACTIONS(433), 1,
      anon_sym_SQUOTE,
    ACTIONS(435), 1,
      anon_sym_DQUOTE,
    ACTIONS(445), 1,
      sym__raw_string_literal,
    ACTIONS(447), 1,
      sym__external_open_parenthesis,
    ACTIONS(449), 1,
      sym__external_open_brace,
    ACTIONS(8403), 1,
      anon_sym_BANG,
    ACTIONS(11407), 1,
      sym_dot_dot_i,
    ACTIONS(11409), 1,
      sym__newline,
    STATE(5), 1,
      sym__open_parenthesis,
    STATE(42), 1,
      sym__open_brace,
    STATE(2209), 1,
      sym_string,
    STATE(2211), 1,
      sym__single_quoted_string,
    STATE(2212), 1,
      sym__double_quoted_string,
    STATE(3754), 1,
      aux_sym_function_definition_repeat1,
    STATE(5127), 1,
      sym__string_or_identifier,
    ACTIONS(425), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2210), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(439), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11405), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(915), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [91977] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(405), 1,
      sym_identifier,
    ACTIONS(407), 1,
      anon_sym_BSLASH,
    ACTIONS(409), 1,
      anon_sym_function,
    ACTIONS(411), 1,
      anon_sym_if,
    ACTIONS(413), 1,
      anon_sym_for,
    ACTIONS(415), 1,
      anon_sym_while,
    ACTIONS(417), 1,
      anon_sym_repeat,
    ACTIONS(419), 1,
      anon_sym_QMARK,
    ACTIONS(421), 1,
      anon_sym_TILDE,
    ACTIONS(429), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(431), 1,
      sym__number_literal,
    ACTIONS(433), 1,
      anon_sym_SQUOTE,
    ACTIONS(435), 1,
      anon_sym_DQUOTE,
    ACTIONS(445), 1,
      sym__raw_string_literal,
    ACTIONS(447), 1,
      sym__external_open_parenthesis,
    ACTIONS(449), 1,
      sym__external_open_brace,
    ACTIONS(8403), 1,
      anon_sym_BANG,
    ACTIONS(11413), 1,
      sym_dot_dot_i,
    ACTIONS(11415), 1,
      sym__newline,
    STATE(5), 1,
      sym__open_parenthesis,
    STATE(42), 1,
      sym__open_brace,
    STATE(2209), 1,
      sym_string,
    STATE(2211), 1,
      sym__single_quoted_string,
    STATE(2212), 1,
      sym__double_quoted_string,
    STATE(3756), 1,
      aux_sym_function_definition_repeat1,
    STATE(5127), 1,
      sym__string_or_identifier,
    ACTIONS(425), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2210), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(439), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11411), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(916), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [92106] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(405), 1,
      sym_identifier,
    ACTIONS(407), 1,
      anon_sym_BSLASH,
    ACTIONS(409), 1,
      anon_sym_function,
    ACTIONS(411), 1,
      anon_sym_if,
    ACTIONS(413), 1,
      anon_sym_for,
    ACTIONS(415), 1,
      anon_sym_while,
    ACTIONS(417), 1,
      anon_sym_repeat,
    ACTIONS(419), 1,
      anon_sym_QMARK,
    ACTIONS(421), 1,
      anon_sym_TILDE,
    ACTIONS(429), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(431), 1,
      sym__number_literal,
    ACTIONS(433), 1,
      anon_sym_SQUOTE,
    ACTIONS(435), 1,
      anon_sym_DQUOTE,
    ACTIONS(445), 1,
      sym__raw_string_literal,
    ACTIONS(447), 1,
      sym__external_open_parenthesis,
    ACTIONS(449), 1,
      sym__external_open_brace,
    ACTIONS(8403), 1,
      anon_sym_BANG,
    ACTIONS(11419), 1,
      sym_dot_dot_i,
    ACTIONS(11421), 1,
      sym__newline,
    STATE(5), 1,
      sym__open_parenthesis,
    STATE(42), 1,
      sym__open_brace,
    STATE(2209), 1,
      sym_string,
    STATE(2211), 1,
      sym__single_quoted_string,
    STATE(2212), 1,
      sym__double_quoted_string,
    STATE(3758), 1,
      aux_sym_function_definition_repeat1,
    STATE(5127), 1,
      sym__string_or_identifier,
    ACTIONS(425), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2210), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(439), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11417), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(918), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [92235] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(11425), 1,
      sym_dot_dot_i,
    ACTIONS(11427), 1,
      sym__newline,
    STATE(292), 1,
      sym__open_brace,
    STATE(293), 1,
      sym__open_parenthesis,
    STATE(2562), 1,
      sym_string,
    STATE(2737), 1,
      sym__double_quoted_string,
    STATE(2738), 1,
      sym__single_quoted_string,
    STATE(3936), 1,
      aux_sym_function_definition_repeat1,
    STATE(5152), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2739), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11423), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1938), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [92364] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1385), 1,
      sym_identifier,
    ACTIONS(1387), 1,
      anon_sym_BSLASH,
    ACTIONS(1389), 1,
      anon_sym_function,
    ACTIONS(1391), 1,
      anon_sym_if,
    ACTIONS(1393), 1,
      anon_sym_for,
    ACTIONS(1395), 1,
      anon_sym_while,
    ACTIONS(1397), 1,
      anon_sym_repeat,
    ACTIONS(1399), 1,
      anon_sym_QMARK,
    ACTIONS(1401), 1,
      anon_sym_TILDE,
    ACTIONS(1409), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1411), 1,
      sym__number_literal,
    ACTIONS(1413), 1,
      anon_sym_SQUOTE,
    ACTIONS(1415), 1,
      anon_sym_DQUOTE,
    ACTIONS(1425), 1,
      sym__raw_string_literal,
    ACTIONS(1427), 1,
      sym__external_open_parenthesis,
    ACTIONS(1429), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9251), 1,
      anon_sym_BANG,
    ACTIONS(11431), 1,
      sym_dot_dot_i,
    STATE(64), 1,
      sym__open_parenthesis,
    STATE(199), 1,
      sym__open_brace,
    STATE(2309), 1,
      sym__double_quoted_string,
    STATE(2310), 1,
      sym__single_quoted_string,
    STATE(2312), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5134), 1,
      sym__string_or_identifier,
    ACTIONS(1405), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2311), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1419), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11429), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1077), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [92493] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1385), 1,
      sym_identifier,
    ACTIONS(1387), 1,
      anon_sym_BSLASH,
    ACTIONS(1389), 1,
      anon_sym_function,
    ACTIONS(1391), 1,
      anon_sym_if,
    ACTIONS(1393), 1,
      anon_sym_for,
    ACTIONS(1395), 1,
      anon_sym_while,
    ACTIONS(1397), 1,
      anon_sym_repeat,
    ACTIONS(1399), 1,
      anon_sym_QMARK,
    ACTIONS(1401), 1,
      anon_sym_TILDE,
    ACTIONS(1409), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1411), 1,
      sym__number_literal,
    ACTIONS(1413), 1,
      anon_sym_SQUOTE,
    ACTIONS(1415), 1,
      anon_sym_DQUOTE,
    ACTIONS(1425), 1,
      sym__raw_string_literal,
    ACTIONS(1427), 1,
      sym__external_open_parenthesis,
    ACTIONS(1429), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9251), 1,
      anon_sym_BANG,
    ACTIONS(11435), 1,
      sym_dot_dot_i,
    STATE(64), 1,
      sym__open_parenthesis,
    STATE(199), 1,
      sym__open_brace,
    STATE(2309), 1,
      sym__double_quoted_string,
    STATE(2310), 1,
      sym__single_quoted_string,
    STATE(2312), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5134), 1,
      sym__string_or_identifier,
    ACTIONS(1405), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2311), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1419), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11433), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1073), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [92622] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1385), 1,
      sym_identifier,
    ACTIONS(1387), 1,
      anon_sym_BSLASH,
    ACTIONS(1389), 1,
      anon_sym_function,
    ACTIONS(1391), 1,
      anon_sym_if,
    ACTIONS(1393), 1,
      anon_sym_for,
    ACTIONS(1395), 1,
      anon_sym_while,
    ACTIONS(1397), 1,
      anon_sym_repeat,
    ACTIONS(1399), 1,
      anon_sym_QMARK,
    ACTIONS(1401), 1,
      anon_sym_TILDE,
    ACTIONS(1409), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1411), 1,
      sym__number_literal,
    ACTIONS(1413), 1,
      anon_sym_SQUOTE,
    ACTIONS(1415), 1,
      anon_sym_DQUOTE,
    ACTIONS(1425), 1,
      sym__raw_string_literal,
    ACTIONS(1427), 1,
      sym__external_open_parenthesis,
    ACTIONS(1429), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9251), 1,
      anon_sym_BANG,
    ACTIONS(11439), 1,
      sym_dot_dot_i,
    STATE(64), 1,
      sym__open_parenthesis,
    STATE(199), 1,
      sym__open_brace,
    STATE(2309), 1,
      sym__double_quoted_string,
    STATE(2310), 1,
      sym__single_quoted_string,
    STATE(2312), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5134), 1,
      sym__string_or_identifier,
    ACTIONS(1405), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2311), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1419), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11437), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1067), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [92751] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1385), 1,
      sym_identifier,
    ACTIONS(1387), 1,
      anon_sym_BSLASH,
    ACTIONS(1389), 1,
      anon_sym_function,
    ACTIONS(1391), 1,
      anon_sym_if,
    ACTIONS(1393), 1,
      anon_sym_for,
    ACTIONS(1395), 1,
      anon_sym_while,
    ACTIONS(1397), 1,
      anon_sym_repeat,
    ACTIONS(1399), 1,
      anon_sym_QMARK,
    ACTIONS(1401), 1,
      anon_sym_TILDE,
    ACTIONS(1409), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1411), 1,
      sym__number_literal,
    ACTIONS(1413), 1,
      anon_sym_SQUOTE,
    ACTIONS(1415), 1,
      anon_sym_DQUOTE,
    ACTIONS(1425), 1,
      sym__raw_string_literal,
    ACTIONS(1427), 1,
      sym__external_open_parenthesis,
    ACTIONS(1429), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9251), 1,
      anon_sym_BANG,
    ACTIONS(11443), 1,
      sym_dot_dot_i,
    STATE(64), 1,
      sym__open_parenthesis,
    STATE(199), 1,
      sym__open_brace,
    STATE(2309), 1,
      sym__double_quoted_string,
    STATE(2310), 1,
      sym__single_quoted_string,
    STATE(2312), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5134), 1,
      sym__string_or_identifier,
    ACTIONS(1405), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2311), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1419), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11441), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1066), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [92880] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(11447), 1,
      sym_dot_dot_i,
    ACTIONS(11449), 1,
      sym__newline,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(3833), 1,
      aux_sym_function_definition_repeat1,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11445), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4446), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [93009] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1385), 1,
      sym_identifier,
    ACTIONS(1387), 1,
      anon_sym_BSLASH,
    ACTIONS(1389), 1,
      anon_sym_function,
    ACTIONS(1391), 1,
      anon_sym_if,
    ACTIONS(1393), 1,
      anon_sym_for,
    ACTIONS(1395), 1,
      anon_sym_while,
    ACTIONS(1397), 1,
      anon_sym_repeat,
    ACTIONS(1399), 1,
      anon_sym_QMARK,
    ACTIONS(1401), 1,
      anon_sym_TILDE,
    ACTIONS(1409), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1411), 1,
      sym__number_literal,
    ACTIONS(1413), 1,
      anon_sym_SQUOTE,
    ACTIONS(1415), 1,
      anon_sym_DQUOTE,
    ACTIONS(1425), 1,
      sym__raw_string_literal,
    ACTIONS(1427), 1,
      sym__external_open_parenthesis,
    ACTIONS(1429), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9251), 1,
      anon_sym_BANG,
    ACTIONS(11453), 1,
      sym_dot_dot_i,
    STATE(64), 1,
      sym__open_parenthesis,
    STATE(199), 1,
      sym__open_brace,
    STATE(2309), 1,
      sym__double_quoted_string,
    STATE(2310), 1,
      sym__single_quoted_string,
    STATE(2312), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5134), 1,
      sym__string_or_identifier,
    ACTIONS(1405), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2311), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1419), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11451), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1065), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [93138] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4053), 1,
      sym_identifier,
    ACTIONS(4055), 1,
      anon_sym_BSLASH,
    ACTIONS(4057), 1,
      anon_sym_function,
    ACTIONS(4059), 1,
      anon_sym_if,
    ACTIONS(4061), 1,
      anon_sym_for,
    ACTIONS(4063), 1,
      anon_sym_while,
    ACTIONS(4065), 1,
      anon_sym_repeat,
    ACTIONS(4067), 1,
      anon_sym_QMARK,
    ACTIONS(4069), 1,
      anon_sym_TILDE,
    ACTIONS(4077), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4079), 1,
      sym__number_literal,
    ACTIONS(4081), 1,
      anon_sym_SQUOTE,
    ACTIONS(4083), 1,
      anon_sym_DQUOTE,
    ACTIONS(4093), 1,
      sym__raw_string_literal,
    ACTIONS(4095), 1,
      sym__external_open_parenthesis,
    ACTIONS(4097), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7821), 1,
      anon_sym_BANG,
    ACTIONS(11457), 1,
      sym_dot_dot_i,
    STATE(133), 1,
      sym__open_brace,
    STATE(150), 1,
      sym__open_parenthesis,
    STATE(2534), 1,
      sym_string,
    STATE(2538), 1,
      sym__single_quoted_string,
    STATE(2539), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5143), 1,
      sym__string_or_identifier,
    ACTIONS(4073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2536), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4087), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11455), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1862), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [93267] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1385), 1,
      sym_identifier,
    ACTIONS(1387), 1,
      anon_sym_BSLASH,
    ACTIONS(1389), 1,
      anon_sym_function,
    ACTIONS(1391), 1,
      anon_sym_if,
    ACTIONS(1393), 1,
      anon_sym_for,
    ACTIONS(1395), 1,
      anon_sym_while,
    ACTIONS(1397), 1,
      anon_sym_repeat,
    ACTIONS(1399), 1,
      anon_sym_QMARK,
    ACTIONS(1401), 1,
      anon_sym_TILDE,
    ACTIONS(1409), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1411), 1,
      sym__number_literal,
    ACTIONS(1413), 1,
      anon_sym_SQUOTE,
    ACTIONS(1415), 1,
      anon_sym_DQUOTE,
    ACTIONS(1425), 1,
      sym__raw_string_literal,
    ACTIONS(1427), 1,
      sym__external_open_parenthesis,
    ACTIONS(1429), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9251), 1,
      anon_sym_BANG,
    ACTIONS(11461), 1,
      sym_dot_dot_i,
    STATE(64), 1,
      sym__open_parenthesis,
    STATE(199), 1,
      sym__open_brace,
    STATE(2309), 1,
      sym__double_quoted_string,
    STATE(2310), 1,
      sym__single_quoted_string,
    STATE(2312), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5134), 1,
      sym__string_or_identifier,
    ACTIONS(1405), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2311), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1419), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11459), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1064), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [93396] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(405), 1,
      sym_identifier,
    ACTIONS(407), 1,
      anon_sym_BSLASH,
    ACTIONS(409), 1,
      anon_sym_function,
    ACTIONS(411), 1,
      anon_sym_if,
    ACTIONS(413), 1,
      anon_sym_for,
    ACTIONS(415), 1,
      anon_sym_while,
    ACTIONS(417), 1,
      anon_sym_repeat,
    ACTIONS(419), 1,
      anon_sym_QMARK,
    ACTIONS(421), 1,
      anon_sym_TILDE,
    ACTIONS(429), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(431), 1,
      sym__number_literal,
    ACTIONS(433), 1,
      anon_sym_SQUOTE,
    ACTIONS(435), 1,
      anon_sym_DQUOTE,
    ACTIONS(445), 1,
      sym__raw_string_literal,
    ACTIONS(447), 1,
      sym__external_open_parenthesis,
    ACTIONS(449), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8403), 1,
      anon_sym_BANG,
    ACTIONS(11465), 1,
      sym_dot_dot_i,
    STATE(5), 1,
      sym__open_parenthesis,
    STATE(42), 1,
      sym__open_brace,
    STATE(2209), 1,
      sym_string,
    STATE(2211), 1,
      sym__single_quoted_string,
    STATE(2212), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5127), 1,
      sym__string_or_identifier,
    ACTIONS(425), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2210), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(439), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11463), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(923), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [93525] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4053), 1,
      sym_identifier,
    ACTIONS(4055), 1,
      anon_sym_BSLASH,
    ACTIONS(4057), 1,
      anon_sym_function,
    ACTIONS(4059), 1,
      anon_sym_if,
    ACTIONS(4061), 1,
      anon_sym_for,
    ACTIONS(4063), 1,
      anon_sym_while,
    ACTIONS(4065), 1,
      anon_sym_repeat,
    ACTIONS(4067), 1,
      anon_sym_QMARK,
    ACTIONS(4069), 1,
      anon_sym_TILDE,
    ACTIONS(4077), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4079), 1,
      sym__number_literal,
    ACTIONS(4081), 1,
      anon_sym_SQUOTE,
    ACTIONS(4083), 1,
      anon_sym_DQUOTE,
    ACTIONS(4093), 1,
      sym__raw_string_literal,
    ACTIONS(4095), 1,
      sym__external_open_parenthesis,
    ACTIONS(4097), 1,
      sym__external_open_brace,
    ACTIONS(7821), 1,
      anon_sym_BANG,
    ACTIONS(11469), 1,
      sym_dot_dot_i,
    ACTIONS(11471), 1,
      sym__newline,
    STATE(133), 1,
      sym__open_brace,
    STATE(150), 1,
      sym__open_parenthesis,
    STATE(2534), 1,
      sym_string,
    STATE(2538), 1,
      sym__single_quoted_string,
    STATE(2539), 1,
      sym__double_quoted_string,
    STATE(3866), 1,
      aux_sym_function_definition_repeat1,
    STATE(5143), 1,
      sym__string_or_identifier,
    ACTIONS(4073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2536), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4087), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11467), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1855), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [93654] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(405), 1,
      sym_identifier,
    ACTIONS(407), 1,
      anon_sym_BSLASH,
    ACTIONS(409), 1,
      anon_sym_function,
    ACTIONS(411), 1,
      anon_sym_if,
    ACTIONS(413), 1,
      anon_sym_for,
    ACTIONS(415), 1,
      anon_sym_while,
    ACTIONS(417), 1,
      anon_sym_repeat,
    ACTIONS(419), 1,
      anon_sym_QMARK,
    ACTIONS(421), 1,
      anon_sym_TILDE,
    ACTIONS(429), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(431), 1,
      sym__number_literal,
    ACTIONS(433), 1,
      anon_sym_SQUOTE,
    ACTIONS(435), 1,
      anon_sym_DQUOTE,
    ACTIONS(445), 1,
      sym__raw_string_literal,
    ACTIONS(447), 1,
      sym__external_open_parenthesis,
    ACTIONS(449), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8403), 1,
      anon_sym_BANG,
    ACTIONS(11475), 1,
      sym_dot_dot_i,
    STATE(5), 1,
      sym__open_parenthesis,
    STATE(42), 1,
      sym__open_brace,
    STATE(2209), 1,
      sym_string,
    STATE(2211), 1,
      sym__single_quoted_string,
    STATE(2212), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5127), 1,
      sym__string_or_identifier,
    ACTIONS(425), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2210), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(439), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11473), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(924), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [93783] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1385), 1,
      sym_identifier,
    ACTIONS(1387), 1,
      anon_sym_BSLASH,
    ACTIONS(1389), 1,
      anon_sym_function,
    ACTIONS(1391), 1,
      anon_sym_if,
    ACTIONS(1393), 1,
      anon_sym_for,
    ACTIONS(1395), 1,
      anon_sym_while,
    ACTIONS(1397), 1,
      anon_sym_repeat,
    ACTIONS(1399), 1,
      anon_sym_QMARK,
    ACTIONS(1401), 1,
      anon_sym_TILDE,
    ACTIONS(1409), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1411), 1,
      sym__number_literal,
    ACTIONS(1413), 1,
      anon_sym_SQUOTE,
    ACTIONS(1415), 1,
      anon_sym_DQUOTE,
    ACTIONS(1425), 1,
      sym__raw_string_literal,
    ACTIONS(1427), 1,
      sym__external_open_parenthesis,
    ACTIONS(1429), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9251), 1,
      anon_sym_BANG,
    ACTIONS(11479), 1,
      sym_dot_dot_i,
    STATE(64), 1,
      sym__open_parenthesis,
    STATE(199), 1,
      sym__open_brace,
    STATE(2309), 1,
      sym__double_quoted_string,
    STATE(2310), 1,
      sym__single_quoted_string,
    STATE(2312), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5134), 1,
      sym__string_or_identifier,
    ACTIONS(1405), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2311), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1419), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11477), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1063), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [93912] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(405), 1,
      sym_identifier,
    ACTIONS(407), 1,
      anon_sym_BSLASH,
    ACTIONS(409), 1,
      anon_sym_function,
    ACTIONS(411), 1,
      anon_sym_if,
    ACTIONS(413), 1,
      anon_sym_for,
    ACTIONS(415), 1,
      anon_sym_while,
    ACTIONS(417), 1,
      anon_sym_repeat,
    ACTIONS(419), 1,
      anon_sym_QMARK,
    ACTIONS(421), 1,
      anon_sym_TILDE,
    ACTIONS(429), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(431), 1,
      sym__number_literal,
    ACTIONS(433), 1,
      anon_sym_SQUOTE,
    ACTIONS(435), 1,
      anon_sym_DQUOTE,
    ACTIONS(445), 1,
      sym__raw_string_literal,
    ACTIONS(447), 1,
      sym__external_open_parenthesis,
    ACTIONS(449), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8403), 1,
      anon_sym_BANG,
    ACTIONS(11483), 1,
      sym_dot_dot_i,
    STATE(5), 1,
      sym__open_parenthesis,
    STATE(42), 1,
      sym__open_brace,
    STATE(2209), 1,
      sym_string,
    STATE(2211), 1,
      sym__single_quoted_string,
    STATE(2212), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5127), 1,
      sym__string_or_identifier,
    ACTIONS(425), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2210), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(439), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11481), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(925), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [94041] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4053), 1,
      sym_identifier,
    ACTIONS(4055), 1,
      anon_sym_BSLASH,
    ACTIONS(4057), 1,
      anon_sym_function,
    ACTIONS(4059), 1,
      anon_sym_if,
    ACTIONS(4061), 1,
      anon_sym_for,
    ACTIONS(4063), 1,
      anon_sym_while,
    ACTIONS(4065), 1,
      anon_sym_repeat,
    ACTIONS(4067), 1,
      anon_sym_QMARK,
    ACTIONS(4069), 1,
      anon_sym_TILDE,
    ACTIONS(4077), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4079), 1,
      sym__number_literal,
    ACTIONS(4081), 1,
      anon_sym_SQUOTE,
    ACTIONS(4083), 1,
      anon_sym_DQUOTE,
    ACTIONS(4093), 1,
      sym__raw_string_literal,
    ACTIONS(4095), 1,
      sym__external_open_parenthesis,
    ACTIONS(4097), 1,
      sym__external_open_brace,
    ACTIONS(7821), 1,
      anon_sym_BANG,
    ACTIONS(11487), 1,
      sym_dot_dot_i,
    ACTIONS(11489), 1,
      sym__newline,
    STATE(133), 1,
      sym__open_brace,
    STATE(150), 1,
      sym__open_parenthesis,
    STATE(2534), 1,
      sym_string,
    STATE(2538), 1,
      sym__single_quoted_string,
    STATE(2539), 1,
      sym__double_quoted_string,
    STATE(3868), 1,
      aux_sym_function_definition_repeat1,
    STATE(5143), 1,
      sym__string_or_identifier,
    ACTIONS(4073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2536), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4087), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11485), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1853), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [94170] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(405), 1,
      sym_identifier,
    ACTIONS(407), 1,
      anon_sym_BSLASH,
    ACTIONS(409), 1,
      anon_sym_function,
    ACTIONS(411), 1,
      anon_sym_if,
    ACTIONS(413), 1,
      anon_sym_for,
    ACTIONS(415), 1,
      anon_sym_while,
    ACTIONS(417), 1,
      anon_sym_repeat,
    ACTIONS(419), 1,
      anon_sym_QMARK,
    ACTIONS(421), 1,
      anon_sym_TILDE,
    ACTIONS(429), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(431), 1,
      sym__number_literal,
    ACTIONS(433), 1,
      anon_sym_SQUOTE,
    ACTIONS(435), 1,
      anon_sym_DQUOTE,
    ACTIONS(445), 1,
      sym__raw_string_literal,
    ACTIONS(447), 1,
      sym__external_open_parenthesis,
    ACTIONS(449), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8403), 1,
      anon_sym_BANG,
    ACTIONS(11493), 1,
      sym_dot_dot_i,
    STATE(5), 1,
      sym__open_parenthesis,
    STATE(42), 1,
      sym__open_brace,
    STATE(2209), 1,
      sym_string,
    STATE(2211), 1,
      sym__single_quoted_string,
    STATE(2212), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5127), 1,
      sym__string_or_identifier,
    ACTIONS(425), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2210), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(439), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11491), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(926), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [94299] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4642), 1,
      sym_identifier,
    ACTIONS(4644), 1,
      anon_sym_BSLASH,
    ACTIONS(4646), 1,
      anon_sym_function,
    ACTIONS(4648), 1,
      anon_sym_if,
    ACTIONS(4650), 1,
      anon_sym_for,
    ACTIONS(4652), 1,
      anon_sym_while,
    ACTIONS(4654), 1,
      anon_sym_repeat,
    ACTIONS(4656), 1,
      anon_sym_QMARK,
    ACTIONS(4658), 1,
      anon_sym_TILDE,
    ACTIONS(4666), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4668), 1,
      sym__number_literal,
    ACTIONS(4670), 1,
      anon_sym_SQUOTE,
    ACTIONS(4672), 1,
      anon_sym_DQUOTE,
    ACTIONS(4680), 1,
      sym__raw_string_literal,
    ACTIONS(4682), 1,
      sym__external_open_parenthesis,
    ACTIONS(4684), 1,
      sym__external_open_brace,
    ACTIONS(6371), 1,
      anon_sym_BANG,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(11497), 1,
      sym_dot_dot_i,
    STATE(185), 1,
      sym__open_brace,
    STATE(218), 1,
      sym__open_parenthesis,
    STATE(2649), 1,
      sym__double_quoted_string,
    STATE(2654), 1,
      sym__single_quoted_string,
    STATE(2744), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5141), 1,
      sym__string_or_identifier,
    ACTIONS(4662), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2656), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4676), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11495), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2122), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [94428] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4642), 1,
      sym_identifier,
    ACTIONS(4644), 1,
      anon_sym_BSLASH,
    ACTIONS(4646), 1,
      anon_sym_function,
    ACTIONS(4648), 1,
      anon_sym_if,
    ACTIONS(4650), 1,
      anon_sym_for,
    ACTIONS(4652), 1,
      anon_sym_while,
    ACTIONS(4654), 1,
      anon_sym_repeat,
    ACTIONS(4656), 1,
      anon_sym_QMARK,
    ACTIONS(4658), 1,
      anon_sym_TILDE,
    ACTIONS(4666), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4668), 1,
      sym__number_literal,
    ACTIONS(4670), 1,
      anon_sym_SQUOTE,
    ACTIONS(4672), 1,
      anon_sym_DQUOTE,
    ACTIONS(4680), 1,
      sym__raw_string_literal,
    ACTIONS(4682), 1,
      sym__external_open_parenthesis,
    ACTIONS(4684), 1,
      sym__external_open_brace,
    ACTIONS(6371), 1,
      anon_sym_BANG,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(11501), 1,
      sym_dot_dot_i,
    STATE(185), 1,
      sym__open_brace,
    STATE(218), 1,
      sym__open_parenthesis,
    STATE(2649), 1,
      sym__double_quoted_string,
    STATE(2654), 1,
      sym__single_quoted_string,
    STATE(2744), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5141), 1,
      sym__string_or_identifier,
    ACTIONS(4662), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2656), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4676), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11499), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2046), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [94557] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1385), 1,
      sym_identifier,
    ACTIONS(1387), 1,
      anon_sym_BSLASH,
    ACTIONS(1389), 1,
      anon_sym_function,
    ACTIONS(1391), 1,
      anon_sym_if,
    ACTIONS(1393), 1,
      anon_sym_for,
    ACTIONS(1395), 1,
      anon_sym_while,
    ACTIONS(1397), 1,
      anon_sym_repeat,
    ACTIONS(1399), 1,
      anon_sym_QMARK,
    ACTIONS(1401), 1,
      anon_sym_TILDE,
    ACTIONS(1409), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1411), 1,
      sym__number_literal,
    ACTIONS(1413), 1,
      anon_sym_SQUOTE,
    ACTIONS(1415), 1,
      anon_sym_DQUOTE,
    ACTIONS(1425), 1,
      sym__raw_string_literal,
    ACTIONS(1427), 1,
      sym__external_open_parenthesis,
    ACTIONS(1429), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9251), 1,
      anon_sym_BANG,
    ACTIONS(11505), 1,
      sym_dot_dot_i,
    STATE(64), 1,
      sym__open_parenthesis,
    STATE(199), 1,
      sym__open_brace,
    STATE(2309), 1,
      sym__double_quoted_string,
    STATE(2310), 1,
      sym__single_quoted_string,
    STATE(2312), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5134), 1,
      sym__string_or_identifier,
    ACTIONS(1405), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2311), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1419), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11503), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1062), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [94686] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4053), 1,
      sym_identifier,
    ACTIONS(4055), 1,
      anon_sym_BSLASH,
    ACTIONS(4057), 1,
      anon_sym_function,
    ACTIONS(4059), 1,
      anon_sym_if,
    ACTIONS(4061), 1,
      anon_sym_for,
    ACTIONS(4063), 1,
      anon_sym_while,
    ACTIONS(4065), 1,
      anon_sym_repeat,
    ACTIONS(4067), 1,
      anon_sym_QMARK,
    ACTIONS(4069), 1,
      anon_sym_TILDE,
    ACTIONS(4077), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4079), 1,
      sym__number_literal,
    ACTIONS(4081), 1,
      anon_sym_SQUOTE,
    ACTIONS(4083), 1,
      anon_sym_DQUOTE,
    ACTIONS(4093), 1,
      sym__raw_string_literal,
    ACTIONS(4095), 1,
      sym__external_open_parenthesis,
    ACTIONS(4097), 1,
      sym__external_open_brace,
    ACTIONS(7821), 1,
      anon_sym_BANG,
    ACTIONS(11509), 1,
      sym_dot_dot_i,
    ACTIONS(11511), 1,
      sym__newline,
    STATE(133), 1,
      sym__open_brace,
    STATE(150), 1,
      sym__open_parenthesis,
    STATE(2534), 1,
      sym_string,
    STATE(2538), 1,
      sym__single_quoted_string,
    STATE(2539), 1,
      sym__double_quoted_string,
    STATE(3870), 1,
      aux_sym_function_definition_repeat1,
    STATE(5143), 1,
      sym__string_or_identifier,
    ACTIONS(4073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2536), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4087), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11507), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1851), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [94815] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(405), 1,
      sym_identifier,
    ACTIONS(407), 1,
      anon_sym_BSLASH,
    ACTIONS(409), 1,
      anon_sym_function,
    ACTIONS(411), 1,
      anon_sym_if,
    ACTIONS(413), 1,
      anon_sym_for,
    ACTIONS(415), 1,
      anon_sym_while,
    ACTIONS(417), 1,
      anon_sym_repeat,
    ACTIONS(419), 1,
      anon_sym_QMARK,
    ACTIONS(421), 1,
      anon_sym_TILDE,
    ACTIONS(429), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(431), 1,
      sym__number_literal,
    ACTIONS(433), 1,
      anon_sym_SQUOTE,
    ACTIONS(435), 1,
      anon_sym_DQUOTE,
    ACTIONS(445), 1,
      sym__raw_string_literal,
    ACTIONS(447), 1,
      sym__external_open_parenthesis,
    ACTIONS(449), 1,
      sym__external_open_brace,
    ACTIONS(8403), 1,
      anon_sym_BANG,
    ACTIONS(11515), 1,
      sym_dot_dot_i,
    ACTIONS(11517), 1,
      sym__newline,
    STATE(5), 1,
      sym__open_parenthesis,
    STATE(42), 1,
      sym__open_brace,
    STATE(2209), 1,
      sym_string,
    STATE(2211), 1,
      sym__single_quoted_string,
    STATE(2212), 1,
      sym__double_quoted_string,
    STATE(3796), 1,
      aux_sym_function_definition_repeat1,
    STATE(5127), 1,
      sym__string_or_identifier,
    ACTIONS(425), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2210), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(439), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11513), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(927), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [94944] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(405), 1,
      sym_identifier,
    ACTIONS(407), 1,
      anon_sym_BSLASH,
    ACTIONS(409), 1,
      anon_sym_function,
    ACTIONS(411), 1,
      anon_sym_if,
    ACTIONS(413), 1,
      anon_sym_for,
    ACTIONS(415), 1,
      anon_sym_while,
    ACTIONS(417), 1,
      anon_sym_repeat,
    ACTIONS(419), 1,
      anon_sym_QMARK,
    ACTIONS(421), 1,
      anon_sym_TILDE,
    ACTIONS(429), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(431), 1,
      sym__number_literal,
    ACTIONS(433), 1,
      anon_sym_SQUOTE,
    ACTIONS(435), 1,
      anon_sym_DQUOTE,
    ACTIONS(445), 1,
      sym__raw_string_literal,
    ACTIONS(447), 1,
      sym__external_open_parenthesis,
    ACTIONS(449), 1,
      sym__external_open_brace,
    ACTIONS(8403), 1,
      anon_sym_BANG,
    ACTIONS(11521), 1,
      sym_dot_dot_i,
    ACTIONS(11523), 1,
      sym__newline,
    STATE(5), 1,
      sym__open_parenthesis,
    STATE(42), 1,
      sym__open_brace,
    STATE(2209), 1,
      sym_string,
    STATE(2211), 1,
      sym__single_quoted_string,
    STATE(2212), 1,
      sym__double_quoted_string,
    STATE(3798), 1,
      aux_sym_function_definition_repeat1,
    STATE(5127), 1,
      sym__string_or_identifier,
    ACTIONS(425), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2210), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(439), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11519), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(928), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [95073] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(405), 1,
      sym_identifier,
    ACTIONS(407), 1,
      anon_sym_BSLASH,
    ACTIONS(409), 1,
      anon_sym_function,
    ACTIONS(411), 1,
      anon_sym_if,
    ACTIONS(413), 1,
      anon_sym_for,
    ACTIONS(415), 1,
      anon_sym_while,
    ACTIONS(417), 1,
      anon_sym_repeat,
    ACTIONS(419), 1,
      anon_sym_QMARK,
    ACTIONS(421), 1,
      anon_sym_TILDE,
    ACTIONS(429), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(431), 1,
      sym__number_literal,
    ACTIONS(433), 1,
      anon_sym_SQUOTE,
    ACTIONS(435), 1,
      anon_sym_DQUOTE,
    ACTIONS(445), 1,
      sym__raw_string_literal,
    ACTIONS(447), 1,
      sym__external_open_parenthesis,
    ACTIONS(449), 1,
      sym__external_open_brace,
    ACTIONS(8403), 1,
      anon_sym_BANG,
    ACTIONS(11527), 1,
      sym_dot_dot_i,
    ACTIONS(11529), 1,
      sym__newline,
    STATE(5), 1,
      sym__open_parenthesis,
    STATE(42), 1,
      sym__open_brace,
    STATE(2209), 1,
      sym_string,
    STATE(2211), 1,
      sym__single_quoted_string,
    STATE(2212), 1,
      sym__double_quoted_string,
    STATE(3800), 1,
      aux_sym_function_definition_repeat1,
    STATE(5127), 1,
      sym__string_or_identifier,
    ACTIONS(425), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2210), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(439), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11525), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(929), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [95202] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(405), 1,
      sym_identifier,
    ACTIONS(407), 1,
      anon_sym_BSLASH,
    ACTIONS(409), 1,
      anon_sym_function,
    ACTIONS(411), 1,
      anon_sym_if,
    ACTIONS(413), 1,
      anon_sym_for,
    ACTIONS(415), 1,
      anon_sym_while,
    ACTIONS(417), 1,
      anon_sym_repeat,
    ACTIONS(419), 1,
      anon_sym_QMARK,
    ACTIONS(421), 1,
      anon_sym_TILDE,
    ACTIONS(429), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(431), 1,
      sym__number_literal,
    ACTIONS(433), 1,
      anon_sym_SQUOTE,
    ACTIONS(435), 1,
      anon_sym_DQUOTE,
    ACTIONS(445), 1,
      sym__raw_string_literal,
    ACTIONS(447), 1,
      sym__external_open_parenthesis,
    ACTIONS(449), 1,
      sym__external_open_brace,
    ACTIONS(8403), 1,
      anon_sym_BANG,
    ACTIONS(11533), 1,
      sym_dot_dot_i,
    ACTIONS(11535), 1,
      sym__newline,
    STATE(5), 1,
      sym__open_parenthesis,
    STATE(42), 1,
      sym__open_brace,
    STATE(2209), 1,
      sym_string,
    STATE(2211), 1,
      sym__single_quoted_string,
    STATE(2212), 1,
      sym__double_quoted_string,
    STATE(3802), 1,
      aux_sym_function_definition_repeat1,
    STATE(5127), 1,
      sym__string_or_identifier,
    ACTIONS(425), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2210), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(439), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11531), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(930), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [95331] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(405), 1,
      sym_identifier,
    ACTIONS(407), 1,
      anon_sym_BSLASH,
    ACTIONS(409), 1,
      anon_sym_function,
    ACTIONS(411), 1,
      anon_sym_if,
    ACTIONS(413), 1,
      anon_sym_for,
    ACTIONS(415), 1,
      anon_sym_while,
    ACTIONS(417), 1,
      anon_sym_repeat,
    ACTIONS(419), 1,
      anon_sym_QMARK,
    ACTIONS(421), 1,
      anon_sym_TILDE,
    ACTIONS(429), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(431), 1,
      sym__number_literal,
    ACTIONS(433), 1,
      anon_sym_SQUOTE,
    ACTIONS(435), 1,
      anon_sym_DQUOTE,
    ACTIONS(445), 1,
      sym__raw_string_literal,
    ACTIONS(447), 1,
      sym__external_open_parenthesis,
    ACTIONS(449), 1,
      sym__external_open_brace,
    ACTIONS(8403), 1,
      anon_sym_BANG,
    ACTIONS(11539), 1,
      sym_dot_dot_i,
    ACTIONS(11541), 1,
      sym__newline,
    STATE(5), 1,
      sym__open_parenthesis,
    STATE(42), 1,
      sym__open_brace,
    STATE(2209), 1,
      sym_string,
    STATE(2211), 1,
      sym__single_quoted_string,
    STATE(2212), 1,
      sym__double_quoted_string,
    STATE(3804), 1,
      aux_sym_function_definition_repeat1,
    STATE(5127), 1,
      sym__string_or_identifier,
    ACTIONS(425), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2210), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(439), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11537), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(931), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [95460] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(405), 1,
      sym_identifier,
    ACTIONS(407), 1,
      anon_sym_BSLASH,
    ACTIONS(409), 1,
      anon_sym_function,
    ACTIONS(411), 1,
      anon_sym_if,
    ACTIONS(413), 1,
      anon_sym_for,
    ACTIONS(415), 1,
      anon_sym_while,
    ACTIONS(417), 1,
      anon_sym_repeat,
    ACTIONS(419), 1,
      anon_sym_QMARK,
    ACTIONS(421), 1,
      anon_sym_TILDE,
    ACTIONS(429), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(431), 1,
      sym__number_literal,
    ACTIONS(433), 1,
      anon_sym_SQUOTE,
    ACTIONS(435), 1,
      anon_sym_DQUOTE,
    ACTIONS(445), 1,
      sym__raw_string_literal,
    ACTIONS(447), 1,
      sym__external_open_parenthesis,
    ACTIONS(449), 1,
      sym__external_open_brace,
    ACTIONS(8403), 1,
      anon_sym_BANG,
    ACTIONS(11545), 1,
      sym_dot_dot_i,
    ACTIONS(11547), 1,
      sym__newline,
    STATE(5), 1,
      sym__open_parenthesis,
    STATE(42), 1,
      sym__open_brace,
    STATE(2209), 1,
      sym_string,
    STATE(2211), 1,
      sym__single_quoted_string,
    STATE(2212), 1,
      sym__double_quoted_string,
    STATE(3806), 1,
      aux_sym_function_definition_repeat1,
    STATE(5127), 1,
      sym__string_or_identifier,
    ACTIONS(425), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2210), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(439), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11543), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(932), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [95589] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(405), 1,
      sym_identifier,
    ACTIONS(407), 1,
      anon_sym_BSLASH,
    ACTIONS(409), 1,
      anon_sym_function,
    ACTIONS(411), 1,
      anon_sym_if,
    ACTIONS(413), 1,
      anon_sym_for,
    ACTIONS(415), 1,
      anon_sym_while,
    ACTIONS(417), 1,
      anon_sym_repeat,
    ACTIONS(419), 1,
      anon_sym_QMARK,
    ACTIONS(421), 1,
      anon_sym_TILDE,
    ACTIONS(429), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(431), 1,
      sym__number_literal,
    ACTIONS(433), 1,
      anon_sym_SQUOTE,
    ACTIONS(435), 1,
      anon_sym_DQUOTE,
    ACTIONS(445), 1,
      sym__raw_string_literal,
    ACTIONS(447), 1,
      sym__external_open_parenthesis,
    ACTIONS(449), 1,
      sym__external_open_brace,
    ACTIONS(8403), 1,
      anon_sym_BANG,
    ACTIONS(11551), 1,
      sym_dot_dot_i,
    ACTIONS(11553), 1,
      sym__newline,
    STATE(5), 1,
      sym__open_parenthesis,
    STATE(42), 1,
      sym__open_brace,
    STATE(2209), 1,
      sym_string,
    STATE(2211), 1,
      sym__single_quoted_string,
    STATE(2212), 1,
      sym__double_quoted_string,
    STATE(3808), 1,
      aux_sym_function_definition_repeat1,
    STATE(5127), 1,
      sym__string_or_identifier,
    ACTIONS(425), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2210), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(439), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11549), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(933), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [95718] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(405), 1,
      sym_identifier,
    ACTIONS(407), 1,
      anon_sym_BSLASH,
    ACTIONS(409), 1,
      anon_sym_function,
    ACTIONS(411), 1,
      anon_sym_if,
    ACTIONS(413), 1,
      anon_sym_for,
    ACTIONS(415), 1,
      anon_sym_while,
    ACTIONS(417), 1,
      anon_sym_repeat,
    ACTIONS(419), 1,
      anon_sym_QMARK,
    ACTIONS(421), 1,
      anon_sym_TILDE,
    ACTIONS(429), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(431), 1,
      sym__number_literal,
    ACTIONS(433), 1,
      anon_sym_SQUOTE,
    ACTIONS(435), 1,
      anon_sym_DQUOTE,
    ACTIONS(445), 1,
      sym__raw_string_literal,
    ACTIONS(447), 1,
      sym__external_open_parenthesis,
    ACTIONS(449), 1,
      sym__external_open_brace,
    ACTIONS(8403), 1,
      anon_sym_BANG,
    ACTIONS(11557), 1,
      sym_dot_dot_i,
    ACTIONS(11559), 1,
      sym__newline,
    STATE(5), 1,
      sym__open_parenthesis,
    STATE(42), 1,
      sym__open_brace,
    STATE(2209), 1,
      sym_string,
    STATE(2211), 1,
      sym__single_quoted_string,
    STATE(2212), 1,
      sym__double_quoted_string,
    STATE(3810), 1,
      aux_sym_function_definition_repeat1,
    STATE(5127), 1,
      sym__string_or_identifier,
    ACTIONS(425), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2210), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(439), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11555), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(934), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [95847] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(405), 1,
      sym_identifier,
    ACTIONS(407), 1,
      anon_sym_BSLASH,
    ACTIONS(409), 1,
      anon_sym_function,
    ACTIONS(411), 1,
      anon_sym_if,
    ACTIONS(413), 1,
      anon_sym_for,
    ACTIONS(415), 1,
      anon_sym_while,
    ACTIONS(417), 1,
      anon_sym_repeat,
    ACTIONS(419), 1,
      anon_sym_QMARK,
    ACTIONS(421), 1,
      anon_sym_TILDE,
    ACTIONS(429), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(431), 1,
      sym__number_literal,
    ACTIONS(433), 1,
      anon_sym_SQUOTE,
    ACTIONS(435), 1,
      anon_sym_DQUOTE,
    ACTIONS(445), 1,
      sym__raw_string_literal,
    ACTIONS(447), 1,
      sym__external_open_parenthesis,
    ACTIONS(449), 1,
      sym__external_open_brace,
    ACTIONS(8403), 1,
      anon_sym_BANG,
    ACTIONS(11563), 1,
      sym_dot_dot_i,
    ACTIONS(11565), 1,
      sym__newline,
    STATE(5), 1,
      sym__open_parenthesis,
    STATE(42), 1,
      sym__open_brace,
    STATE(2209), 1,
      sym_string,
    STATE(2211), 1,
      sym__single_quoted_string,
    STATE(2212), 1,
      sym__double_quoted_string,
    STATE(3812), 1,
      aux_sym_function_definition_repeat1,
    STATE(5127), 1,
      sym__string_or_identifier,
    ACTIONS(425), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2210), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(439), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11561), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(936), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [95976] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(405), 1,
      sym_identifier,
    ACTIONS(407), 1,
      anon_sym_BSLASH,
    ACTIONS(409), 1,
      anon_sym_function,
    ACTIONS(411), 1,
      anon_sym_if,
    ACTIONS(413), 1,
      anon_sym_for,
    ACTIONS(415), 1,
      anon_sym_while,
    ACTIONS(417), 1,
      anon_sym_repeat,
    ACTIONS(419), 1,
      anon_sym_QMARK,
    ACTIONS(421), 1,
      anon_sym_TILDE,
    ACTIONS(429), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(431), 1,
      sym__number_literal,
    ACTIONS(433), 1,
      anon_sym_SQUOTE,
    ACTIONS(435), 1,
      anon_sym_DQUOTE,
    ACTIONS(445), 1,
      sym__raw_string_literal,
    ACTIONS(447), 1,
      sym__external_open_parenthesis,
    ACTIONS(449), 1,
      sym__external_open_brace,
    ACTIONS(8403), 1,
      anon_sym_BANG,
    ACTIONS(11569), 1,
      sym_dot_dot_i,
    ACTIONS(11571), 1,
      sym__newline,
    STATE(5), 1,
      sym__open_parenthesis,
    STATE(42), 1,
      sym__open_brace,
    STATE(2209), 1,
      sym_string,
    STATE(2211), 1,
      sym__single_quoted_string,
    STATE(2212), 1,
      sym__double_quoted_string,
    STATE(3814), 1,
      aux_sym_function_definition_repeat1,
    STATE(5127), 1,
      sym__string_or_identifier,
    ACTIONS(425), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2210), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(439), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11567), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(937), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [96105] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(405), 1,
      sym_identifier,
    ACTIONS(407), 1,
      anon_sym_BSLASH,
    ACTIONS(409), 1,
      anon_sym_function,
    ACTIONS(411), 1,
      anon_sym_if,
    ACTIONS(413), 1,
      anon_sym_for,
    ACTIONS(415), 1,
      anon_sym_while,
    ACTIONS(417), 1,
      anon_sym_repeat,
    ACTIONS(419), 1,
      anon_sym_QMARK,
    ACTIONS(421), 1,
      anon_sym_TILDE,
    ACTIONS(429), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(431), 1,
      sym__number_literal,
    ACTIONS(433), 1,
      anon_sym_SQUOTE,
    ACTIONS(435), 1,
      anon_sym_DQUOTE,
    ACTIONS(445), 1,
      sym__raw_string_literal,
    ACTIONS(447), 1,
      sym__external_open_parenthesis,
    ACTIONS(449), 1,
      sym__external_open_brace,
    ACTIONS(8403), 1,
      anon_sym_BANG,
    ACTIONS(11575), 1,
      sym_dot_dot_i,
    ACTIONS(11577), 1,
      sym__newline,
    STATE(5), 1,
      sym__open_parenthesis,
    STATE(42), 1,
      sym__open_brace,
    STATE(2209), 1,
      sym_string,
    STATE(2211), 1,
      sym__single_quoted_string,
    STATE(2212), 1,
      sym__double_quoted_string,
    STATE(3816), 1,
      aux_sym_function_definition_repeat1,
    STATE(5127), 1,
      sym__string_or_identifier,
    ACTIONS(425), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2210), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(439), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11573), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(938), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [96234] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(405), 1,
      sym_identifier,
    ACTIONS(407), 1,
      anon_sym_BSLASH,
    ACTIONS(409), 1,
      anon_sym_function,
    ACTIONS(411), 1,
      anon_sym_if,
    ACTIONS(413), 1,
      anon_sym_for,
    ACTIONS(415), 1,
      anon_sym_while,
    ACTIONS(417), 1,
      anon_sym_repeat,
    ACTIONS(419), 1,
      anon_sym_QMARK,
    ACTIONS(421), 1,
      anon_sym_TILDE,
    ACTIONS(429), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(431), 1,
      sym__number_literal,
    ACTIONS(433), 1,
      anon_sym_SQUOTE,
    ACTIONS(435), 1,
      anon_sym_DQUOTE,
    ACTIONS(445), 1,
      sym__raw_string_literal,
    ACTIONS(447), 1,
      sym__external_open_parenthesis,
    ACTIONS(449), 1,
      sym__external_open_brace,
    ACTIONS(8403), 1,
      anon_sym_BANG,
    ACTIONS(11581), 1,
      sym_dot_dot_i,
    ACTIONS(11583), 1,
      sym__newline,
    STATE(5), 1,
      sym__open_parenthesis,
    STATE(42), 1,
      sym__open_brace,
    STATE(2209), 1,
      sym_string,
    STATE(2211), 1,
      sym__single_quoted_string,
    STATE(2212), 1,
      sym__double_quoted_string,
    STATE(3818), 1,
      aux_sym_function_definition_repeat1,
    STATE(5127), 1,
      sym__string_or_identifier,
    ACTIONS(425), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2210), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(439), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11579), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(939), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [96363] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(405), 1,
      sym_identifier,
    ACTIONS(407), 1,
      anon_sym_BSLASH,
    ACTIONS(409), 1,
      anon_sym_function,
    ACTIONS(411), 1,
      anon_sym_if,
    ACTIONS(413), 1,
      anon_sym_for,
    ACTIONS(415), 1,
      anon_sym_while,
    ACTIONS(417), 1,
      anon_sym_repeat,
    ACTIONS(419), 1,
      anon_sym_QMARK,
    ACTIONS(421), 1,
      anon_sym_TILDE,
    ACTIONS(429), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(431), 1,
      sym__number_literal,
    ACTIONS(433), 1,
      anon_sym_SQUOTE,
    ACTIONS(435), 1,
      anon_sym_DQUOTE,
    ACTIONS(445), 1,
      sym__raw_string_literal,
    ACTIONS(447), 1,
      sym__external_open_parenthesis,
    ACTIONS(449), 1,
      sym__external_open_brace,
    ACTIONS(8403), 1,
      anon_sym_BANG,
    ACTIONS(11587), 1,
      sym_dot_dot_i,
    ACTIONS(11589), 1,
      sym__newline,
    STATE(5), 1,
      sym__open_parenthesis,
    STATE(42), 1,
      sym__open_brace,
    STATE(2209), 1,
      sym_string,
    STATE(2211), 1,
      sym__single_quoted_string,
    STATE(2212), 1,
      sym__double_quoted_string,
    STATE(3820), 1,
      aux_sym_function_definition_repeat1,
    STATE(5127), 1,
      sym__string_or_identifier,
    ACTIONS(425), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2210), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(439), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11585), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(940), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [96492] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4642), 1,
      sym_identifier,
    ACTIONS(4644), 1,
      anon_sym_BSLASH,
    ACTIONS(4646), 1,
      anon_sym_function,
    ACTIONS(4648), 1,
      anon_sym_if,
    ACTIONS(4650), 1,
      anon_sym_for,
    ACTIONS(4652), 1,
      anon_sym_while,
    ACTIONS(4654), 1,
      anon_sym_repeat,
    ACTIONS(4656), 1,
      anon_sym_QMARK,
    ACTIONS(4658), 1,
      anon_sym_TILDE,
    ACTIONS(4666), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4668), 1,
      sym__number_literal,
    ACTIONS(4670), 1,
      anon_sym_SQUOTE,
    ACTIONS(4672), 1,
      anon_sym_DQUOTE,
    ACTIONS(4680), 1,
      sym__raw_string_literal,
    ACTIONS(4682), 1,
      sym__external_open_parenthesis,
    ACTIONS(4684), 1,
      sym__external_open_brace,
    ACTIONS(6371), 1,
      anon_sym_BANG,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(11593), 1,
      sym_dot_dot_i,
    STATE(185), 1,
      sym__open_brace,
    STATE(218), 1,
      sym__open_parenthesis,
    STATE(2649), 1,
      sym__double_quoted_string,
    STATE(2654), 1,
      sym__single_quoted_string,
    STATE(2744), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5141), 1,
      sym__string_or_identifier,
    ACTIONS(4662), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2656), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4676), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11591), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2045), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [96621] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1385), 1,
      sym_identifier,
    ACTIONS(1387), 1,
      anon_sym_BSLASH,
    ACTIONS(1389), 1,
      anon_sym_function,
    ACTIONS(1391), 1,
      anon_sym_if,
    ACTIONS(1393), 1,
      anon_sym_for,
    ACTIONS(1395), 1,
      anon_sym_while,
    ACTIONS(1397), 1,
      anon_sym_repeat,
    ACTIONS(1399), 1,
      anon_sym_QMARK,
    ACTIONS(1401), 1,
      anon_sym_TILDE,
    ACTIONS(1409), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1411), 1,
      sym__number_literal,
    ACTIONS(1413), 1,
      anon_sym_SQUOTE,
    ACTIONS(1415), 1,
      anon_sym_DQUOTE,
    ACTIONS(1425), 1,
      sym__raw_string_literal,
    ACTIONS(1427), 1,
      sym__external_open_parenthesis,
    ACTIONS(1429), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9251), 1,
      anon_sym_BANG,
    ACTIONS(11597), 1,
      sym_dot_dot_i,
    STATE(64), 1,
      sym__open_parenthesis,
    STATE(199), 1,
      sym__open_brace,
    STATE(2309), 1,
      sym__double_quoted_string,
    STATE(2310), 1,
      sym__single_quoted_string,
    STATE(2312), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5134), 1,
      sym__string_or_identifier,
    ACTIONS(1405), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2311), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1419), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11595), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1060), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [96750] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4053), 1,
      sym_identifier,
    ACTIONS(4055), 1,
      anon_sym_BSLASH,
    ACTIONS(4057), 1,
      anon_sym_function,
    ACTIONS(4059), 1,
      anon_sym_if,
    ACTIONS(4061), 1,
      anon_sym_for,
    ACTIONS(4063), 1,
      anon_sym_while,
    ACTIONS(4065), 1,
      anon_sym_repeat,
    ACTIONS(4067), 1,
      anon_sym_QMARK,
    ACTIONS(4069), 1,
      anon_sym_TILDE,
    ACTIONS(4077), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4079), 1,
      sym__number_literal,
    ACTIONS(4081), 1,
      anon_sym_SQUOTE,
    ACTIONS(4083), 1,
      anon_sym_DQUOTE,
    ACTIONS(4093), 1,
      sym__raw_string_literal,
    ACTIONS(4095), 1,
      sym__external_open_parenthesis,
    ACTIONS(4097), 1,
      sym__external_open_brace,
    ACTIONS(7821), 1,
      anon_sym_BANG,
    ACTIONS(11601), 1,
      sym_dot_dot_i,
    ACTIONS(11603), 1,
      sym__newline,
    STATE(133), 1,
      sym__open_brace,
    STATE(150), 1,
      sym__open_parenthesis,
    STATE(2534), 1,
      sym_string,
    STATE(2538), 1,
      sym__single_quoted_string,
    STATE(2539), 1,
      sym__double_quoted_string,
    STATE(3881), 1,
      aux_sym_function_definition_repeat1,
    STATE(5143), 1,
      sym__string_or_identifier,
    ACTIONS(4073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2536), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4087), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11599), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1849), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [96879] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1385), 1,
      sym_identifier,
    ACTIONS(1387), 1,
      anon_sym_BSLASH,
    ACTIONS(1389), 1,
      anon_sym_function,
    ACTIONS(1391), 1,
      anon_sym_if,
    ACTIONS(1393), 1,
      anon_sym_for,
    ACTIONS(1395), 1,
      anon_sym_while,
    ACTIONS(1397), 1,
      anon_sym_repeat,
    ACTIONS(1399), 1,
      anon_sym_QMARK,
    ACTIONS(1401), 1,
      anon_sym_TILDE,
    ACTIONS(1409), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1411), 1,
      sym__number_literal,
    ACTIONS(1413), 1,
      anon_sym_SQUOTE,
    ACTIONS(1415), 1,
      anon_sym_DQUOTE,
    ACTIONS(1425), 1,
      sym__raw_string_literal,
    ACTIONS(1427), 1,
      sym__external_open_parenthesis,
    ACTIONS(1429), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9251), 1,
      anon_sym_BANG,
    ACTIONS(11607), 1,
      sym_dot_dot_i,
    STATE(64), 1,
      sym__open_parenthesis,
    STATE(199), 1,
      sym__open_brace,
    STATE(2309), 1,
      sym__double_quoted_string,
    STATE(2310), 1,
      sym__single_quoted_string,
    STATE(2312), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5134), 1,
      sym__string_or_identifier,
    ACTIONS(1405), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2311), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1419), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11605), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1059), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [97008] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4642), 1,
      sym_identifier,
    ACTIONS(4644), 1,
      anon_sym_BSLASH,
    ACTIONS(4646), 1,
      anon_sym_function,
    ACTIONS(4648), 1,
      anon_sym_if,
    ACTIONS(4650), 1,
      anon_sym_for,
    ACTIONS(4652), 1,
      anon_sym_while,
    ACTIONS(4654), 1,
      anon_sym_repeat,
    ACTIONS(4656), 1,
      anon_sym_QMARK,
    ACTIONS(4658), 1,
      anon_sym_TILDE,
    ACTIONS(4666), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4668), 1,
      sym__number_literal,
    ACTIONS(4670), 1,
      anon_sym_SQUOTE,
    ACTIONS(4672), 1,
      anon_sym_DQUOTE,
    ACTIONS(4680), 1,
      sym__raw_string_literal,
    ACTIONS(4682), 1,
      sym__external_open_parenthesis,
    ACTIONS(4684), 1,
      sym__external_open_brace,
    ACTIONS(6371), 1,
      anon_sym_BANG,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(11611), 1,
      sym_dot_dot_i,
    STATE(185), 1,
      sym__open_brace,
    STATE(218), 1,
      sym__open_parenthesis,
    STATE(2649), 1,
      sym__double_quoted_string,
    STATE(2654), 1,
      sym__single_quoted_string,
    STATE(2744), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5141), 1,
      sym__string_or_identifier,
    ACTIONS(4662), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2656), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4676), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11609), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2044), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [97137] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4053), 1,
      sym_identifier,
    ACTIONS(4055), 1,
      anon_sym_BSLASH,
    ACTIONS(4057), 1,
      anon_sym_function,
    ACTIONS(4059), 1,
      anon_sym_if,
    ACTIONS(4061), 1,
      anon_sym_for,
    ACTIONS(4063), 1,
      anon_sym_while,
    ACTIONS(4065), 1,
      anon_sym_repeat,
    ACTIONS(4067), 1,
      anon_sym_QMARK,
    ACTIONS(4069), 1,
      anon_sym_TILDE,
    ACTIONS(4077), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4079), 1,
      sym__number_literal,
    ACTIONS(4081), 1,
      anon_sym_SQUOTE,
    ACTIONS(4083), 1,
      anon_sym_DQUOTE,
    ACTIONS(4093), 1,
      sym__raw_string_literal,
    ACTIONS(4095), 1,
      sym__external_open_parenthesis,
    ACTIONS(4097), 1,
      sym__external_open_brace,
    ACTIONS(7821), 1,
      anon_sym_BANG,
    ACTIONS(11615), 1,
      sym_dot_dot_i,
    ACTIONS(11617), 1,
      sym__newline,
    STATE(133), 1,
      sym__open_brace,
    STATE(150), 1,
      sym__open_parenthesis,
    STATE(2534), 1,
      sym_string,
    STATE(2538), 1,
      sym__single_quoted_string,
    STATE(2539), 1,
      sym__double_quoted_string,
    STATE(3844), 1,
      aux_sym_function_definition_repeat1,
    STATE(5143), 1,
      sym__string_or_identifier,
    ACTIONS(4073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2536), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4087), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11613), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1847), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [97266] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4053), 1,
      sym_identifier,
    ACTIONS(4055), 1,
      anon_sym_BSLASH,
    ACTIONS(4057), 1,
      anon_sym_function,
    ACTIONS(4059), 1,
      anon_sym_if,
    ACTIONS(4061), 1,
      anon_sym_for,
    ACTIONS(4063), 1,
      anon_sym_while,
    ACTIONS(4065), 1,
      anon_sym_repeat,
    ACTIONS(4067), 1,
      anon_sym_QMARK,
    ACTIONS(4069), 1,
      anon_sym_TILDE,
    ACTIONS(4077), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4079), 1,
      sym__number_literal,
    ACTIONS(4081), 1,
      anon_sym_SQUOTE,
    ACTIONS(4083), 1,
      anon_sym_DQUOTE,
    ACTIONS(4093), 1,
      sym__raw_string_literal,
    ACTIONS(4095), 1,
      sym__external_open_parenthesis,
    ACTIONS(4097), 1,
      sym__external_open_brace,
    ACTIONS(7821), 1,
      anon_sym_BANG,
    ACTIONS(11621), 1,
      sym_dot_dot_i,
    ACTIONS(11623), 1,
      sym__newline,
    STATE(133), 1,
      sym__open_brace,
    STATE(150), 1,
      sym__open_parenthesis,
    STATE(2534), 1,
      sym_string,
    STATE(2538), 1,
      sym__single_quoted_string,
    STATE(2539), 1,
      sym__double_quoted_string,
    STATE(3900), 1,
      aux_sym_function_definition_repeat1,
    STATE(5143), 1,
      sym__string_or_identifier,
    ACTIONS(4073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2536), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4087), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11619), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1845), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [97395] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4642), 1,
      sym_identifier,
    ACTIONS(4644), 1,
      anon_sym_BSLASH,
    ACTIONS(4646), 1,
      anon_sym_function,
    ACTIONS(4648), 1,
      anon_sym_if,
    ACTIONS(4650), 1,
      anon_sym_for,
    ACTIONS(4652), 1,
      anon_sym_while,
    ACTIONS(4654), 1,
      anon_sym_repeat,
    ACTIONS(4656), 1,
      anon_sym_QMARK,
    ACTIONS(4658), 1,
      anon_sym_TILDE,
    ACTIONS(4666), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4668), 1,
      sym__number_literal,
    ACTIONS(4670), 1,
      anon_sym_SQUOTE,
    ACTIONS(4672), 1,
      anon_sym_DQUOTE,
    ACTIONS(4680), 1,
      sym__raw_string_literal,
    ACTIONS(4682), 1,
      sym__external_open_parenthesis,
    ACTIONS(4684), 1,
      sym__external_open_brace,
    ACTIONS(6371), 1,
      anon_sym_BANG,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(11627), 1,
      sym_dot_dot_i,
    STATE(185), 1,
      sym__open_brace,
    STATE(218), 1,
      sym__open_parenthesis,
    STATE(2649), 1,
      sym__double_quoted_string,
    STATE(2654), 1,
      sym__single_quoted_string,
    STATE(2744), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5141), 1,
      sym__string_or_identifier,
    ACTIONS(4662), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2656), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4676), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11625), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2040), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [97524] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4642), 1,
      sym_identifier,
    ACTIONS(4644), 1,
      anon_sym_BSLASH,
    ACTIONS(4646), 1,
      anon_sym_function,
    ACTIONS(4648), 1,
      anon_sym_if,
    ACTIONS(4650), 1,
      anon_sym_for,
    ACTIONS(4652), 1,
      anon_sym_while,
    ACTIONS(4654), 1,
      anon_sym_repeat,
    ACTIONS(4656), 1,
      anon_sym_QMARK,
    ACTIONS(4658), 1,
      anon_sym_TILDE,
    ACTIONS(4666), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4668), 1,
      sym__number_literal,
    ACTIONS(4670), 1,
      anon_sym_SQUOTE,
    ACTIONS(4672), 1,
      anon_sym_DQUOTE,
    ACTIONS(4680), 1,
      sym__raw_string_literal,
    ACTIONS(4682), 1,
      sym__external_open_parenthesis,
    ACTIONS(4684), 1,
      sym__external_open_brace,
    ACTIONS(6371), 1,
      anon_sym_BANG,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(11631), 1,
      sym_dot_dot_i,
    STATE(185), 1,
      sym__open_brace,
    STATE(218), 1,
      sym__open_parenthesis,
    STATE(2649), 1,
      sym__double_quoted_string,
    STATE(2654), 1,
      sym__single_quoted_string,
    STATE(2744), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5141), 1,
      sym__string_or_identifier,
    ACTIONS(4662), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2656), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4676), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11629), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2035), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [97653] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4642), 1,
      sym_identifier,
    ACTIONS(4644), 1,
      anon_sym_BSLASH,
    ACTIONS(4646), 1,
      anon_sym_function,
    ACTIONS(4648), 1,
      anon_sym_if,
    ACTIONS(4650), 1,
      anon_sym_for,
    ACTIONS(4652), 1,
      anon_sym_while,
    ACTIONS(4654), 1,
      anon_sym_repeat,
    ACTIONS(4656), 1,
      anon_sym_QMARK,
    ACTIONS(4658), 1,
      anon_sym_TILDE,
    ACTIONS(4666), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4668), 1,
      sym__number_literal,
    ACTIONS(4670), 1,
      anon_sym_SQUOTE,
    ACTIONS(4672), 1,
      anon_sym_DQUOTE,
    ACTIONS(4680), 1,
      sym__raw_string_literal,
    ACTIONS(4682), 1,
      sym__external_open_parenthesis,
    ACTIONS(4684), 1,
      sym__external_open_brace,
    ACTIONS(6371), 1,
      anon_sym_BANG,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(11635), 1,
      sym_dot_dot_i,
    STATE(185), 1,
      sym__open_brace,
    STATE(218), 1,
      sym__open_parenthesis,
    STATE(2649), 1,
      sym__double_quoted_string,
    STATE(2654), 1,
      sym__single_quoted_string,
    STATE(2744), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5141), 1,
      sym__string_or_identifier,
    ACTIONS(4662), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2656), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4676), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11633), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2047), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [97782] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4053), 1,
      sym_identifier,
    ACTIONS(4055), 1,
      anon_sym_BSLASH,
    ACTIONS(4057), 1,
      anon_sym_function,
    ACTIONS(4059), 1,
      anon_sym_if,
    ACTIONS(4061), 1,
      anon_sym_for,
    ACTIONS(4063), 1,
      anon_sym_while,
    ACTIONS(4065), 1,
      anon_sym_repeat,
    ACTIONS(4067), 1,
      anon_sym_QMARK,
    ACTIONS(4069), 1,
      anon_sym_TILDE,
    ACTIONS(4077), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4079), 1,
      sym__number_literal,
    ACTIONS(4081), 1,
      anon_sym_SQUOTE,
    ACTIONS(4083), 1,
      anon_sym_DQUOTE,
    ACTIONS(4093), 1,
      sym__raw_string_literal,
    ACTIONS(4095), 1,
      sym__external_open_parenthesis,
    ACTIONS(4097), 1,
      sym__external_open_brace,
    ACTIONS(7821), 1,
      anon_sym_BANG,
    ACTIONS(11639), 1,
      sym_dot_dot_i,
    ACTIONS(11641), 1,
      sym__newline,
    STATE(133), 1,
      sym__open_brace,
    STATE(150), 1,
      sym__open_parenthesis,
    STATE(2534), 1,
      sym_string,
    STATE(2538), 1,
      sym__single_quoted_string,
    STATE(2539), 1,
      sym__double_quoted_string,
    STATE(3917), 1,
      aux_sym_function_definition_repeat1,
    STATE(5143), 1,
      sym__string_or_identifier,
    ACTIONS(4073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2536), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4087), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11637), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1844), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [97911] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4053), 1,
      sym_identifier,
    ACTIONS(4055), 1,
      anon_sym_BSLASH,
    ACTIONS(4057), 1,
      anon_sym_function,
    ACTIONS(4059), 1,
      anon_sym_if,
    ACTIONS(4061), 1,
      anon_sym_for,
    ACTIONS(4063), 1,
      anon_sym_while,
    ACTIONS(4065), 1,
      anon_sym_repeat,
    ACTIONS(4067), 1,
      anon_sym_QMARK,
    ACTIONS(4069), 1,
      anon_sym_TILDE,
    ACTIONS(4077), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4079), 1,
      sym__number_literal,
    ACTIONS(4081), 1,
      anon_sym_SQUOTE,
    ACTIONS(4083), 1,
      anon_sym_DQUOTE,
    ACTIONS(4093), 1,
      sym__raw_string_literal,
    ACTIONS(4095), 1,
      sym__external_open_parenthesis,
    ACTIONS(4097), 1,
      sym__external_open_brace,
    ACTIONS(7821), 1,
      anon_sym_BANG,
    ACTIONS(11645), 1,
      sym_dot_dot_i,
    ACTIONS(11647), 1,
      sym__newline,
    STATE(133), 1,
      sym__open_brace,
    STATE(150), 1,
      sym__open_parenthesis,
    STATE(2534), 1,
      sym_string,
    STATE(2538), 1,
      sym__single_quoted_string,
    STATE(2539), 1,
      sym__double_quoted_string,
    STATE(3918), 1,
      aux_sym_function_definition_repeat1,
    STATE(5143), 1,
      sym__string_or_identifier,
    ACTIONS(4073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2536), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4087), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11643), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1843), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [98040] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4642), 1,
      sym_identifier,
    ACTIONS(4644), 1,
      anon_sym_BSLASH,
    ACTIONS(4646), 1,
      anon_sym_function,
    ACTIONS(4648), 1,
      anon_sym_if,
    ACTIONS(4650), 1,
      anon_sym_for,
    ACTIONS(4652), 1,
      anon_sym_while,
    ACTIONS(4654), 1,
      anon_sym_repeat,
    ACTIONS(4656), 1,
      anon_sym_QMARK,
    ACTIONS(4658), 1,
      anon_sym_TILDE,
    ACTIONS(4666), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4668), 1,
      sym__number_literal,
    ACTIONS(4670), 1,
      anon_sym_SQUOTE,
    ACTIONS(4672), 1,
      anon_sym_DQUOTE,
    ACTIONS(4680), 1,
      sym__raw_string_literal,
    ACTIONS(4682), 1,
      sym__external_open_parenthesis,
    ACTIONS(4684), 1,
      sym__external_open_brace,
    ACTIONS(6371), 1,
      anon_sym_BANG,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(11651), 1,
      sym_dot_dot_i,
    STATE(185), 1,
      sym__open_brace,
    STATE(218), 1,
      sym__open_parenthesis,
    STATE(2649), 1,
      sym__double_quoted_string,
    STATE(2654), 1,
      sym__single_quoted_string,
    STATE(2744), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5141), 1,
      sym__string_or_identifier,
    ACTIONS(4662), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2656), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4676), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11649), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2029), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [98169] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4642), 1,
      sym_identifier,
    ACTIONS(4644), 1,
      anon_sym_BSLASH,
    ACTIONS(4646), 1,
      anon_sym_function,
    ACTIONS(4648), 1,
      anon_sym_if,
    ACTIONS(4650), 1,
      anon_sym_for,
    ACTIONS(4652), 1,
      anon_sym_while,
    ACTIONS(4654), 1,
      anon_sym_repeat,
    ACTIONS(4656), 1,
      anon_sym_QMARK,
    ACTIONS(4658), 1,
      anon_sym_TILDE,
    ACTIONS(4666), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4668), 1,
      sym__number_literal,
    ACTIONS(4670), 1,
      anon_sym_SQUOTE,
    ACTIONS(4672), 1,
      anon_sym_DQUOTE,
    ACTIONS(4680), 1,
      sym__raw_string_literal,
    ACTIONS(4682), 1,
      sym__external_open_parenthesis,
    ACTIONS(4684), 1,
      sym__external_open_brace,
    ACTIONS(6371), 1,
      anon_sym_BANG,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(11655), 1,
      sym_dot_dot_i,
    STATE(185), 1,
      sym__open_brace,
    STATE(218), 1,
      sym__open_parenthesis,
    STATE(2649), 1,
      sym__double_quoted_string,
    STATE(2654), 1,
      sym__single_quoted_string,
    STATE(2744), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5141), 1,
      sym__string_or_identifier,
    ACTIONS(4662), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2656), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4676), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11653), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2028), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [98298] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4642), 1,
      sym_identifier,
    ACTIONS(4644), 1,
      anon_sym_BSLASH,
    ACTIONS(4646), 1,
      anon_sym_function,
    ACTIONS(4648), 1,
      anon_sym_if,
    ACTIONS(4650), 1,
      anon_sym_for,
    ACTIONS(4652), 1,
      anon_sym_while,
    ACTIONS(4654), 1,
      anon_sym_repeat,
    ACTIONS(4656), 1,
      anon_sym_QMARK,
    ACTIONS(4658), 1,
      anon_sym_TILDE,
    ACTIONS(4666), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4668), 1,
      sym__number_literal,
    ACTIONS(4670), 1,
      anon_sym_SQUOTE,
    ACTIONS(4672), 1,
      anon_sym_DQUOTE,
    ACTIONS(4680), 1,
      sym__raw_string_literal,
    ACTIONS(4682), 1,
      sym__external_open_parenthesis,
    ACTIONS(4684), 1,
      sym__external_open_brace,
    ACTIONS(6371), 1,
      anon_sym_BANG,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(11659), 1,
      sym_dot_dot_i,
    STATE(185), 1,
      sym__open_brace,
    STATE(218), 1,
      sym__open_parenthesis,
    STATE(2649), 1,
      sym__double_quoted_string,
    STATE(2654), 1,
      sym__single_quoted_string,
    STATE(2744), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5141), 1,
      sym__string_or_identifier,
    ACTIONS(4662), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2656), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4676), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11657), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2025), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [98427] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4642), 1,
      sym_identifier,
    ACTIONS(4644), 1,
      anon_sym_BSLASH,
    ACTIONS(4646), 1,
      anon_sym_function,
    ACTIONS(4648), 1,
      anon_sym_if,
    ACTIONS(4650), 1,
      anon_sym_for,
    ACTIONS(4652), 1,
      anon_sym_while,
    ACTIONS(4654), 1,
      anon_sym_repeat,
    ACTIONS(4656), 1,
      anon_sym_QMARK,
    ACTIONS(4658), 1,
      anon_sym_TILDE,
    ACTIONS(4666), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4668), 1,
      sym__number_literal,
    ACTIONS(4670), 1,
      anon_sym_SQUOTE,
    ACTIONS(4672), 1,
      anon_sym_DQUOTE,
    ACTIONS(4680), 1,
      sym__raw_string_literal,
    ACTIONS(4682), 1,
      sym__external_open_parenthesis,
    ACTIONS(4684), 1,
      sym__external_open_brace,
    ACTIONS(6371), 1,
      anon_sym_BANG,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(11663), 1,
      sym_dot_dot_i,
    STATE(185), 1,
      sym__open_brace,
    STATE(218), 1,
      sym__open_parenthesis,
    STATE(2649), 1,
      sym__double_quoted_string,
    STATE(2654), 1,
      sym__single_quoted_string,
    STATE(2744), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5141), 1,
      sym__string_or_identifier,
    ACTIONS(4662), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2656), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4676), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11661), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2023), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [98556] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4642), 1,
      sym_identifier,
    ACTIONS(4644), 1,
      anon_sym_BSLASH,
    ACTIONS(4646), 1,
      anon_sym_function,
    ACTIONS(4648), 1,
      anon_sym_if,
    ACTIONS(4650), 1,
      anon_sym_for,
    ACTIONS(4652), 1,
      anon_sym_while,
    ACTIONS(4654), 1,
      anon_sym_repeat,
    ACTIONS(4656), 1,
      anon_sym_QMARK,
    ACTIONS(4658), 1,
      anon_sym_TILDE,
    ACTIONS(4666), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4668), 1,
      sym__number_literal,
    ACTIONS(4670), 1,
      anon_sym_SQUOTE,
    ACTIONS(4672), 1,
      anon_sym_DQUOTE,
    ACTIONS(4680), 1,
      sym__raw_string_literal,
    ACTIONS(4682), 1,
      sym__external_open_parenthesis,
    ACTIONS(4684), 1,
      sym__external_open_brace,
    ACTIONS(6371), 1,
      anon_sym_BANG,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(11667), 1,
      sym_dot_dot_i,
    STATE(185), 1,
      sym__open_brace,
    STATE(218), 1,
      sym__open_parenthesis,
    STATE(2649), 1,
      sym__double_quoted_string,
    STATE(2654), 1,
      sym__single_quoted_string,
    STATE(2744), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5141), 1,
      sym__string_or_identifier,
    ACTIONS(4662), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2656), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4676), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11665), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2020), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [98685] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4642), 1,
      sym_identifier,
    ACTIONS(4644), 1,
      anon_sym_BSLASH,
    ACTIONS(4646), 1,
      anon_sym_function,
    ACTIONS(4648), 1,
      anon_sym_if,
    ACTIONS(4650), 1,
      anon_sym_for,
    ACTIONS(4652), 1,
      anon_sym_while,
    ACTIONS(4654), 1,
      anon_sym_repeat,
    ACTIONS(4656), 1,
      anon_sym_QMARK,
    ACTIONS(4658), 1,
      anon_sym_TILDE,
    ACTIONS(4666), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4668), 1,
      sym__number_literal,
    ACTIONS(4670), 1,
      anon_sym_SQUOTE,
    ACTIONS(4672), 1,
      anon_sym_DQUOTE,
    ACTIONS(4680), 1,
      sym__raw_string_literal,
    ACTIONS(4682), 1,
      sym__external_open_parenthesis,
    ACTIONS(4684), 1,
      sym__external_open_brace,
    ACTIONS(6371), 1,
      anon_sym_BANG,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(11671), 1,
      sym_dot_dot_i,
    STATE(185), 1,
      sym__open_brace,
    STATE(218), 1,
      sym__open_parenthesis,
    STATE(2649), 1,
      sym__double_quoted_string,
    STATE(2654), 1,
      sym__single_quoted_string,
    STATE(2744), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5141), 1,
      sym__string_or_identifier,
    ACTIONS(4662), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2656), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4676), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11669), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2010), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [98814] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4053), 1,
      sym_identifier,
    ACTIONS(4055), 1,
      anon_sym_BSLASH,
    ACTIONS(4057), 1,
      anon_sym_function,
    ACTIONS(4059), 1,
      anon_sym_if,
    ACTIONS(4061), 1,
      anon_sym_for,
    ACTIONS(4063), 1,
      anon_sym_while,
    ACTIONS(4065), 1,
      anon_sym_repeat,
    ACTIONS(4067), 1,
      anon_sym_QMARK,
    ACTIONS(4069), 1,
      anon_sym_TILDE,
    ACTIONS(4077), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4079), 1,
      sym__number_literal,
    ACTIONS(4081), 1,
      anon_sym_SQUOTE,
    ACTIONS(4083), 1,
      anon_sym_DQUOTE,
    ACTIONS(4093), 1,
      sym__raw_string_literal,
    ACTIONS(4095), 1,
      sym__external_open_parenthesis,
    ACTIONS(4097), 1,
      sym__external_open_brace,
    ACTIONS(7821), 1,
      anon_sym_BANG,
    ACTIONS(11675), 1,
      sym_dot_dot_i,
    ACTIONS(11677), 1,
      sym__newline,
    STATE(133), 1,
      sym__open_brace,
    STATE(150), 1,
      sym__open_parenthesis,
    STATE(2534), 1,
      sym_string,
    STATE(2538), 1,
      sym__single_quoted_string,
    STATE(2539), 1,
      sym__double_quoted_string,
    STATE(3919), 1,
      aux_sym_function_definition_repeat1,
    STATE(5143), 1,
      sym__string_or_identifier,
    ACTIONS(4073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2536), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4087), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11673), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1842), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [98943] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4053), 1,
      sym_identifier,
    ACTIONS(4055), 1,
      anon_sym_BSLASH,
    ACTIONS(4057), 1,
      anon_sym_function,
    ACTIONS(4059), 1,
      anon_sym_if,
    ACTIONS(4061), 1,
      anon_sym_for,
    ACTIONS(4063), 1,
      anon_sym_while,
    ACTIONS(4065), 1,
      anon_sym_repeat,
    ACTIONS(4067), 1,
      anon_sym_QMARK,
    ACTIONS(4069), 1,
      anon_sym_TILDE,
    ACTIONS(4077), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4079), 1,
      sym__number_literal,
    ACTIONS(4081), 1,
      anon_sym_SQUOTE,
    ACTIONS(4083), 1,
      anon_sym_DQUOTE,
    ACTIONS(4093), 1,
      sym__raw_string_literal,
    ACTIONS(4095), 1,
      sym__external_open_parenthesis,
    ACTIONS(4097), 1,
      sym__external_open_brace,
    ACTIONS(7821), 1,
      anon_sym_BANG,
    ACTIONS(11681), 1,
      sym_dot_dot_i,
    ACTIONS(11683), 1,
      sym__newline,
    STATE(133), 1,
      sym__open_brace,
    STATE(150), 1,
      sym__open_parenthesis,
    STATE(2534), 1,
      sym_string,
    STATE(2538), 1,
      sym__single_quoted_string,
    STATE(2539), 1,
      sym__double_quoted_string,
    STATE(3922), 1,
      aux_sym_function_definition_repeat1,
    STATE(5143), 1,
      sym__string_or_identifier,
    ACTIONS(4073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2536), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4087), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11679), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1841), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [99072] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(405), 1,
      sym_identifier,
    ACTIONS(407), 1,
      anon_sym_BSLASH,
    ACTIONS(409), 1,
      anon_sym_function,
    ACTIONS(411), 1,
      anon_sym_if,
    ACTIONS(413), 1,
      anon_sym_for,
    ACTIONS(415), 1,
      anon_sym_while,
    ACTIONS(417), 1,
      anon_sym_repeat,
    ACTIONS(419), 1,
      anon_sym_QMARK,
    ACTIONS(421), 1,
      anon_sym_TILDE,
    ACTIONS(429), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(431), 1,
      sym__number_literal,
    ACTIONS(433), 1,
      anon_sym_SQUOTE,
    ACTIONS(435), 1,
      anon_sym_DQUOTE,
    ACTIONS(445), 1,
      sym__raw_string_literal,
    ACTIONS(447), 1,
      sym__external_open_parenthesis,
    ACTIONS(449), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8403), 1,
      anon_sym_BANG,
    ACTIONS(11687), 1,
      sym_dot_dot_i,
    STATE(5), 1,
      sym__open_parenthesis,
    STATE(42), 1,
      sym__open_brace,
    STATE(2209), 1,
      sym_string,
    STATE(2211), 1,
      sym__single_quoted_string,
    STATE(2212), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5127), 1,
      sym__string_or_identifier,
    ACTIONS(425), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2210), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(439), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11685), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(942), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [99201] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4053), 1,
      sym_identifier,
    ACTIONS(4055), 1,
      anon_sym_BSLASH,
    ACTIONS(4057), 1,
      anon_sym_function,
    ACTIONS(4059), 1,
      anon_sym_if,
    ACTIONS(4061), 1,
      anon_sym_for,
    ACTIONS(4063), 1,
      anon_sym_while,
    ACTIONS(4065), 1,
      anon_sym_repeat,
    ACTIONS(4067), 1,
      anon_sym_QMARK,
    ACTIONS(4069), 1,
      anon_sym_TILDE,
    ACTIONS(4077), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4079), 1,
      sym__number_literal,
    ACTIONS(4081), 1,
      anon_sym_SQUOTE,
    ACTIONS(4083), 1,
      anon_sym_DQUOTE,
    ACTIONS(4093), 1,
      sym__raw_string_literal,
    ACTIONS(4095), 1,
      sym__external_open_parenthesis,
    ACTIONS(4097), 1,
      sym__external_open_brace,
    ACTIONS(7821), 1,
      anon_sym_BANG,
    ACTIONS(11691), 1,
      sym_dot_dot_i,
    ACTIONS(11693), 1,
      sym__newline,
    STATE(133), 1,
      sym__open_brace,
    STATE(150), 1,
      sym__open_parenthesis,
    STATE(2534), 1,
      sym_string,
    STATE(2538), 1,
      sym__single_quoted_string,
    STATE(2539), 1,
      sym__double_quoted_string,
    STATE(3924), 1,
      aux_sym_function_definition_repeat1,
    STATE(5143), 1,
      sym__string_or_identifier,
    ACTIONS(4073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2536), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4087), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11689), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1840), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [99330] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(405), 1,
      sym_identifier,
    ACTIONS(407), 1,
      anon_sym_BSLASH,
    ACTIONS(409), 1,
      anon_sym_function,
    ACTIONS(411), 1,
      anon_sym_if,
    ACTIONS(413), 1,
      anon_sym_for,
    ACTIONS(415), 1,
      anon_sym_while,
    ACTIONS(417), 1,
      anon_sym_repeat,
    ACTIONS(419), 1,
      anon_sym_QMARK,
    ACTIONS(421), 1,
      anon_sym_TILDE,
    ACTIONS(429), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(431), 1,
      sym__number_literal,
    ACTIONS(433), 1,
      anon_sym_SQUOTE,
    ACTIONS(435), 1,
      anon_sym_DQUOTE,
    ACTIONS(445), 1,
      sym__raw_string_literal,
    ACTIONS(447), 1,
      sym__external_open_parenthesis,
    ACTIONS(449), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8403), 1,
      anon_sym_BANG,
    ACTIONS(11697), 1,
      sym_dot_dot_i,
    STATE(5), 1,
      sym__open_parenthesis,
    STATE(42), 1,
      sym__open_brace,
    STATE(2209), 1,
      sym_string,
    STATE(2211), 1,
      sym__single_quoted_string,
    STATE(2212), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5127), 1,
      sym__string_or_identifier,
    ACTIONS(425), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2210), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(439), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11695), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(943), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [99459] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1385), 1,
      sym_identifier,
    ACTIONS(1387), 1,
      anon_sym_BSLASH,
    ACTIONS(1389), 1,
      anon_sym_function,
    ACTIONS(1391), 1,
      anon_sym_if,
    ACTIONS(1393), 1,
      anon_sym_for,
    ACTIONS(1395), 1,
      anon_sym_while,
    ACTIONS(1397), 1,
      anon_sym_repeat,
    ACTIONS(1399), 1,
      anon_sym_QMARK,
    ACTIONS(1401), 1,
      anon_sym_TILDE,
    ACTIONS(1409), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1411), 1,
      sym__number_literal,
    ACTIONS(1413), 1,
      anon_sym_SQUOTE,
    ACTIONS(1415), 1,
      anon_sym_DQUOTE,
    ACTIONS(1425), 1,
      sym__raw_string_literal,
    ACTIONS(1427), 1,
      sym__external_open_parenthesis,
    ACTIONS(1429), 1,
      sym__external_open_brace,
    ACTIONS(9251), 1,
      anon_sym_BANG,
    ACTIONS(11701), 1,
      sym_dot_dot_i,
    ACTIONS(11703), 1,
      sym__newline,
    STATE(64), 1,
      sym__open_parenthesis,
    STATE(199), 1,
      sym__open_brace,
    STATE(2309), 1,
      sym__double_quoted_string,
    STATE(2310), 1,
      sym__single_quoted_string,
    STATE(2312), 1,
      sym_string,
    STATE(3725), 1,
      aux_sym_function_definition_repeat1,
    STATE(5134), 1,
      sym__string_or_identifier,
    ACTIONS(1405), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2311), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1419), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11699), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1057), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [99588] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(405), 1,
      sym_identifier,
    ACTIONS(407), 1,
      anon_sym_BSLASH,
    ACTIONS(409), 1,
      anon_sym_function,
    ACTIONS(411), 1,
      anon_sym_if,
    ACTIONS(413), 1,
      anon_sym_for,
    ACTIONS(415), 1,
      anon_sym_while,
    ACTIONS(417), 1,
      anon_sym_repeat,
    ACTIONS(419), 1,
      anon_sym_QMARK,
    ACTIONS(421), 1,
      anon_sym_TILDE,
    ACTIONS(429), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(431), 1,
      sym__number_literal,
    ACTIONS(433), 1,
      anon_sym_SQUOTE,
    ACTIONS(435), 1,
      anon_sym_DQUOTE,
    ACTIONS(445), 1,
      sym__raw_string_literal,
    ACTIONS(447), 1,
      sym__external_open_parenthesis,
    ACTIONS(449), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8403), 1,
      anon_sym_BANG,
    ACTIONS(11707), 1,
      sym_dot_dot_i,
    STATE(5), 1,
      sym__open_parenthesis,
    STATE(42), 1,
      sym__open_brace,
    STATE(2209), 1,
      sym_string,
    STATE(2211), 1,
      sym__single_quoted_string,
    STATE(2212), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5127), 1,
      sym__string_or_identifier,
    ACTIONS(425), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2210), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(439), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11705), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(944), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [99717] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(11711), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11709), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4588), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [99846] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(405), 1,
      sym_identifier,
    ACTIONS(407), 1,
      anon_sym_BSLASH,
    ACTIONS(409), 1,
      anon_sym_function,
    ACTIONS(411), 1,
      anon_sym_if,
    ACTIONS(413), 1,
      anon_sym_for,
    ACTIONS(415), 1,
      anon_sym_while,
    ACTIONS(417), 1,
      anon_sym_repeat,
    ACTIONS(419), 1,
      anon_sym_QMARK,
    ACTIONS(421), 1,
      anon_sym_TILDE,
    ACTIONS(429), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(431), 1,
      sym__number_literal,
    ACTIONS(433), 1,
      anon_sym_SQUOTE,
    ACTIONS(435), 1,
      anon_sym_DQUOTE,
    ACTIONS(445), 1,
      sym__raw_string_literal,
    ACTIONS(447), 1,
      sym__external_open_parenthesis,
    ACTIONS(449), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8403), 1,
      anon_sym_BANG,
    ACTIONS(11715), 1,
      sym_dot_dot_i,
    STATE(5), 1,
      sym__open_parenthesis,
    STATE(42), 1,
      sym__open_brace,
    STATE(2209), 1,
      sym_string,
    STATE(2211), 1,
      sym__single_quoted_string,
    STATE(2212), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5127), 1,
      sym__string_or_identifier,
    ACTIONS(425), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2210), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(439), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11713), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(945), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [99975] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(273), 1,
      sym_identifier,
    ACTIONS(275), 1,
      anon_sym_BSLASH,
    ACTIONS(277), 1,
      anon_sym_function,
    ACTIONS(279), 1,
      anon_sym_if,
    ACTIONS(281), 1,
      anon_sym_for,
    ACTIONS(283), 1,
      anon_sym_while,
    ACTIONS(285), 1,
      anon_sym_repeat,
    ACTIONS(287), 1,
      anon_sym_QMARK,
    ACTIONS(289), 1,
      anon_sym_TILDE,
    ACTIONS(297), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(299), 1,
      sym__number_literal,
    ACTIONS(301), 1,
      anon_sym_SQUOTE,
    ACTIONS(303), 1,
      anon_sym_DQUOTE,
    ACTIONS(313), 1,
      sym__raw_string_literal,
    ACTIONS(315), 1,
      sym__external_open_parenthesis,
    ACTIONS(319), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(11159), 1,
      anon_sym_BANG,
    ACTIONS(11719), 1,
      sym_dot_dot_i,
    STATE(57), 1,
      sym__open_parenthesis,
    STATE(59), 1,
      sym__open_brace,
    STATE(2187), 1,
      sym__double_quoted_string,
    STATE(2188), 1,
      sym__single_quoted_string,
    STATE(2192), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5139), 1,
      sym__string_or_identifier,
    ACTIONS(293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2189), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(307), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11717), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(706), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [100104] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(405), 1,
      sym_identifier,
    ACTIONS(407), 1,
      anon_sym_BSLASH,
    ACTIONS(409), 1,
      anon_sym_function,
    ACTIONS(411), 1,
      anon_sym_if,
    ACTIONS(413), 1,
      anon_sym_for,
    ACTIONS(415), 1,
      anon_sym_while,
    ACTIONS(417), 1,
      anon_sym_repeat,
    ACTIONS(419), 1,
      anon_sym_QMARK,
    ACTIONS(421), 1,
      anon_sym_TILDE,
    ACTIONS(429), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(431), 1,
      sym__number_literal,
    ACTIONS(433), 1,
      anon_sym_SQUOTE,
    ACTIONS(435), 1,
      anon_sym_DQUOTE,
    ACTIONS(445), 1,
      sym__raw_string_literal,
    ACTIONS(447), 1,
      sym__external_open_parenthesis,
    ACTIONS(449), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8403), 1,
      anon_sym_BANG,
    ACTIONS(11723), 1,
      sym_dot_dot_i,
    STATE(5), 1,
      sym__open_parenthesis,
    STATE(42), 1,
      sym__open_brace,
    STATE(2209), 1,
      sym_string,
    STATE(2211), 1,
      sym__single_quoted_string,
    STATE(2212), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5127), 1,
      sym__string_or_identifier,
    ACTIONS(425), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2210), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(439), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11721), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(946), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [100233] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1385), 1,
      sym_identifier,
    ACTIONS(1387), 1,
      anon_sym_BSLASH,
    ACTIONS(1389), 1,
      anon_sym_function,
    ACTIONS(1391), 1,
      anon_sym_if,
    ACTIONS(1393), 1,
      anon_sym_for,
    ACTIONS(1395), 1,
      anon_sym_while,
    ACTIONS(1397), 1,
      anon_sym_repeat,
    ACTIONS(1399), 1,
      anon_sym_QMARK,
    ACTIONS(1401), 1,
      anon_sym_TILDE,
    ACTIONS(1409), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1411), 1,
      sym__number_literal,
    ACTIONS(1413), 1,
      anon_sym_SQUOTE,
    ACTIONS(1415), 1,
      anon_sym_DQUOTE,
    ACTIONS(1425), 1,
      sym__raw_string_literal,
    ACTIONS(1427), 1,
      sym__external_open_parenthesis,
    ACTIONS(1429), 1,
      sym__external_open_brace,
    ACTIONS(9251), 1,
      anon_sym_BANG,
    ACTIONS(11727), 1,
      sym_dot_dot_i,
    ACTIONS(11729), 1,
      sym__newline,
    STATE(64), 1,
      sym__open_parenthesis,
    STATE(199), 1,
      sym__open_brace,
    STATE(2309), 1,
      sym__double_quoted_string,
    STATE(2310), 1,
      sym__single_quoted_string,
    STATE(2312), 1,
      sym_string,
    STATE(3733), 1,
      aux_sym_function_definition_repeat1,
    STATE(5134), 1,
      sym__string_or_identifier,
    ACTIONS(1405), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2311), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1419), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11725), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1056), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [100362] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(405), 1,
      sym_identifier,
    ACTIONS(407), 1,
      anon_sym_BSLASH,
    ACTIONS(409), 1,
      anon_sym_function,
    ACTIONS(411), 1,
      anon_sym_if,
    ACTIONS(413), 1,
      anon_sym_for,
    ACTIONS(415), 1,
      anon_sym_while,
    ACTIONS(417), 1,
      anon_sym_repeat,
    ACTIONS(419), 1,
      anon_sym_QMARK,
    ACTIONS(421), 1,
      anon_sym_TILDE,
    ACTIONS(429), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(431), 1,
      sym__number_literal,
    ACTIONS(433), 1,
      anon_sym_SQUOTE,
    ACTIONS(435), 1,
      anon_sym_DQUOTE,
    ACTIONS(445), 1,
      sym__raw_string_literal,
    ACTIONS(447), 1,
      sym__external_open_parenthesis,
    ACTIONS(449), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8403), 1,
      anon_sym_BANG,
    ACTIONS(11733), 1,
      sym_dot_dot_i,
    STATE(5), 1,
      sym__open_parenthesis,
    STATE(42), 1,
      sym__open_brace,
    STATE(2209), 1,
      sym_string,
    STATE(2211), 1,
      sym__single_quoted_string,
    STATE(2212), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5127), 1,
      sym__string_or_identifier,
    ACTIONS(425), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2210), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(439), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11731), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(947), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [100491] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1385), 1,
      sym_identifier,
    ACTIONS(1387), 1,
      anon_sym_BSLASH,
    ACTIONS(1389), 1,
      anon_sym_function,
    ACTIONS(1391), 1,
      anon_sym_if,
    ACTIONS(1393), 1,
      anon_sym_for,
    ACTIONS(1395), 1,
      anon_sym_while,
    ACTIONS(1397), 1,
      anon_sym_repeat,
    ACTIONS(1399), 1,
      anon_sym_QMARK,
    ACTIONS(1401), 1,
      anon_sym_TILDE,
    ACTIONS(1409), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1411), 1,
      sym__number_literal,
    ACTIONS(1413), 1,
      anon_sym_SQUOTE,
    ACTIONS(1415), 1,
      anon_sym_DQUOTE,
    ACTIONS(1425), 1,
      sym__raw_string_literal,
    ACTIONS(1427), 1,
      sym__external_open_parenthesis,
    ACTIONS(1429), 1,
      sym__external_open_brace,
    ACTIONS(9251), 1,
      anon_sym_BANG,
    ACTIONS(11737), 1,
      sym_dot_dot_i,
    ACTIONS(11739), 1,
      sym__newline,
    STATE(64), 1,
      sym__open_parenthesis,
    STATE(199), 1,
      sym__open_brace,
    STATE(2309), 1,
      sym__double_quoted_string,
    STATE(2310), 1,
      sym__single_quoted_string,
    STATE(2312), 1,
      sym_string,
    STATE(3737), 1,
      aux_sym_function_definition_repeat1,
    STATE(5134), 1,
      sym__string_or_identifier,
    ACTIONS(1405), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2311), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1419), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11735), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1055), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [100620] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(405), 1,
      sym_identifier,
    ACTIONS(407), 1,
      anon_sym_BSLASH,
    ACTIONS(409), 1,
      anon_sym_function,
    ACTIONS(411), 1,
      anon_sym_if,
    ACTIONS(413), 1,
      anon_sym_for,
    ACTIONS(415), 1,
      anon_sym_while,
    ACTIONS(417), 1,
      anon_sym_repeat,
    ACTIONS(419), 1,
      anon_sym_QMARK,
    ACTIONS(421), 1,
      anon_sym_TILDE,
    ACTIONS(429), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(431), 1,
      sym__number_literal,
    ACTIONS(433), 1,
      anon_sym_SQUOTE,
    ACTIONS(435), 1,
      anon_sym_DQUOTE,
    ACTIONS(445), 1,
      sym__raw_string_literal,
    ACTIONS(447), 1,
      sym__external_open_parenthesis,
    ACTIONS(449), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8403), 1,
      anon_sym_BANG,
    ACTIONS(11743), 1,
      sym_dot_dot_i,
    STATE(5), 1,
      sym__open_parenthesis,
    STATE(42), 1,
      sym__open_brace,
    STATE(2209), 1,
      sym_string,
    STATE(2211), 1,
      sym__single_quoted_string,
    STATE(2212), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5127), 1,
      sym__string_or_identifier,
    ACTIONS(425), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2210), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(439), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11741), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(948), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [100749] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(273), 1,
      sym_identifier,
    ACTIONS(275), 1,
      anon_sym_BSLASH,
    ACTIONS(277), 1,
      anon_sym_function,
    ACTIONS(279), 1,
      anon_sym_if,
    ACTIONS(281), 1,
      anon_sym_for,
    ACTIONS(283), 1,
      anon_sym_while,
    ACTIONS(285), 1,
      anon_sym_repeat,
    ACTIONS(287), 1,
      anon_sym_QMARK,
    ACTIONS(289), 1,
      anon_sym_TILDE,
    ACTIONS(297), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(299), 1,
      sym__number_literal,
    ACTIONS(301), 1,
      anon_sym_SQUOTE,
    ACTIONS(303), 1,
      anon_sym_DQUOTE,
    ACTIONS(313), 1,
      sym__raw_string_literal,
    ACTIONS(315), 1,
      sym__external_open_parenthesis,
    ACTIONS(319), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(11159), 1,
      anon_sym_BANG,
    ACTIONS(11747), 1,
      sym_dot_dot_i,
    STATE(57), 1,
      sym__open_parenthesis,
    STATE(59), 1,
      sym__open_brace,
    STATE(2187), 1,
      sym__double_quoted_string,
    STATE(2188), 1,
      sym__single_quoted_string,
    STATE(2192), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5139), 1,
      sym__string_or_identifier,
    ACTIONS(293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2189), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(307), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11745), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(707), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [100878] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(405), 1,
      sym_identifier,
    ACTIONS(407), 1,
      anon_sym_BSLASH,
    ACTIONS(409), 1,
      anon_sym_function,
    ACTIONS(411), 1,
      anon_sym_if,
    ACTIONS(413), 1,
      anon_sym_for,
    ACTIONS(415), 1,
      anon_sym_while,
    ACTIONS(417), 1,
      anon_sym_repeat,
    ACTIONS(419), 1,
      anon_sym_QMARK,
    ACTIONS(421), 1,
      anon_sym_TILDE,
    ACTIONS(429), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(431), 1,
      sym__number_literal,
    ACTIONS(433), 1,
      anon_sym_SQUOTE,
    ACTIONS(435), 1,
      anon_sym_DQUOTE,
    ACTIONS(445), 1,
      sym__raw_string_literal,
    ACTIONS(447), 1,
      sym__external_open_parenthesis,
    ACTIONS(449), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8403), 1,
      anon_sym_BANG,
    ACTIONS(11751), 1,
      sym_dot_dot_i,
    STATE(5), 1,
      sym__open_parenthesis,
    STATE(42), 1,
      sym__open_brace,
    STATE(2209), 1,
      sym_string,
    STATE(2211), 1,
      sym__single_quoted_string,
    STATE(2212), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5127), 1,
      sym__string_or_identifier,
    ACTIONS(425), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2210), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(439), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11749), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(673), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [101007] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1385), 1,
      sym_identifier,
    ACTIONS(1387), 1,
      anon_sym_BSLASH,
    ACTIONS(1389), 1,
      anon_sym_function,
    ACTIONS(1391), 1,
      anon_sym_if,
    ACTIONS(1393), 1,
      anon_sym_for,
    ACTIONS(1395), 1,
      anon_sym_while,
    ACTIONS(1397), 1,
      anon_sym_repeat,
    ACTIONS(1399), 1,
      anon_sym_QMARK,
    ACTIONS(1401), 1,
      anon_sym_TILDE,
    ACTIONS(1409), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1411), 1,
      sym__number_literal,
    ACTIONS(1413), 1,
      anon_sym_SQUOTE,
    ACTIONS(1415), 1,
      anon_sym_DQUOTE,
    ACTIONS(1425), 1,
      sym__raw_string_literal,
    ACTIONS(1427), 1,
      sym__external_open_parenthesis,
    ACTIONS(1429), 1,
      sym__external_open_brace,
    ACTIONS(9251), 1,
      anon_sym_BANG,
    ACTIONS(11755), 1,
      sym_dot_dot_i,
    ACTIONS(11757), 1,
      sym__newline,
    STATE(64), 1,
      sym__open_parenthesis,
    STATE(199), 1,
      sym__open_brace,
    STATE(2309), 1,
      sym__double_quoted_string,
    STATE(2310), 1,
      sym__single_quoted_string,
    STATE(2312), 1,
      sym_string,
    STATE(3744), 1,
      aux_sym_function_definition_repeat1,
    STATE(5134), 1,
      sym__string_or_identifier,
    ACTIONS(1405), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2311), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1419), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11753), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1054), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [101136] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(405), 1,
      sym_identifier,
    ACTIONS(407), 1,
      anon_sym_BSLASH,
    ACTIONS(409), 1,
      anon_sym_function,
    ACTIONS(411), 1,
      anon_sym_if,
    ACTIONS(413), 1,
      anon_sym_for,
    ACTIONS(415), 1,
      anon_sym_while,
    ACTIONS(417), 1,
      anon_sym_repeat,
    ACTIONS(419), 1,
      anon_sym_QMARK,
    ACTIONS(421), 1,
      anon_sym_TILDE,
    ACTIONS(429), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(431), 1,
      sym__number_literal,
    ACTIONS(433), 1,
      anon_sym_SQUOTE,
    ACTIONS(435), 1,
      anon_sym_DQUOTE,
    ACTIONS(445), 1,
      sym__raw_string_literal,
    ACTIONS(447), 1,
      sym__external_open_parenthesis,
    ACTIONS(449), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8403), 1,
      anon_sym_BANG,
    ACTIONS(11761), 1,
      sym_dot_dot_i,
    STATE(5), 1,
      sym__open_parenthesis,
    STATE(42), 1,
      sym__open_brace,
    STATE(2209), 1,
      sym_string,
    STATE(2211), 1,
      sym__single_quoted_string,
    STATE(2212), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5127), 1,
      sym__string_or_identifier,
    ACTIONS(425), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2210), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(439), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11759), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(967), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [101265] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1385), 1,
      sym_identifier,
    ACTIONS(1387), 1,
      anon_sym_BSLASH,
    ACTIONS(1389), 1,
      anon_sym_function,
    ACTIONS(1391), 1,
      anon_sym_if,
    ACTIONS(1393), 1,
      anon_sym_for,
    ACTIONS(1395), 1,
      anon_sym_while,
    ACTIONS(1397), 1,
      anon_sym_repeat,
    ACTIONS(1399), 1,
      anon_sym_QMARK,
    ACTIONS(1401), 1,
      anon_sym_TILDE,
    ACTIONS(1409), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1411), 1,
      sym__number_literal,
    ACTIONS(1413), 1,
      anon_sym_SQUOTE,
    ACTIONS(1415), 1,
      anon_sym_DQUOTE,
    ACTIONS(1425), 1,
      sym__raw_string_literal,
    ACTIONS(1427), 1,
      sym__external_open_parenthesis,
    ACTIONS(1429), 1,
      sym__external_open_brace,
    ACTIONS(9251), 1,
      anon_sym_BANG,
    ACTIONS(11765), 1,
      sym_dot_dot_i,
    ACTIONS(11767), 1,
      sym__newline,
    STATE(64), 1,
      sym__open_parenthesis,
    STATE(199), 1,
      sym__open_brace,
    STATE(2309), 1,
      sym__double_quoted_string,
    STATE(2310), 1,
      sym__single_quoted_string,
    STATE(2312), 1,
      sym_string,
    STATE(3745), 1,
      aux_sym_function_definition_repeat1,
    STATE(5134), 1,
      sym__string_or_identifier,
    ACTIONS(1405), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2311), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1419), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11763), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1053), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [101394] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(405), 1,
      sym_identifier,
    ACTIONS(407), 1,
      anon_sym_BSLASH,
    ACTIONS(409), 1,
      anon_sym_function,
    ACTIONS(411), 1,
      anon_sym_if,
    ACTIONS(413), 1,
      anon_sym_for,
    ACTIONS(415), 1,
      anon_sym_while,
    ACTIONS(417), 1,
      anon_sym_repeat,
    ACTIONS(419), 1,
      anon_sym_QMARK,
    ACTIONS(421), 1,
      anon_sym_TILDE,
    ACTIONS(429), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(431), 1,
      sym__number_literal,
    ACTIONS(433), 1,
      anon_sym_SQUOTE,
    ACTIONS(435), 1,
      anon_sym_DQUOTE,
    ACTIONS(445), 1,
      sym__raw_string_literal,
    ACTIONS(447), 1,
      sym__external_open_parenthesis,
    ACTIONS(449), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8403), 1,
      anon_sym_BANG,
    ACTIONS(11771), 1,
      sym_dot_dot_i,
    STATE(5), 1,
      sym__open_parenthesis,
    STATE(42), 1,
      sym__open_brace,
    STATE(2209), 1,
      sym_string,
    STATE(2211), 1,
      sym__single_quoted_string,
    STATE(2212), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5127), 1,
      sym__string_or_identifier,
    ACTIONS(425), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2210), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(439), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11769), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(966), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [101523] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1385), 1,
      sym_identifier,
    ACTIONS(1387), 1,
      anon_sym_BSLASH,
    ACTIONS(1389), 1,
      anon_sym_function,
    ACTIONS(1391), 1,
      anon_sym_if,
    ACTIONS(1393), 1,
      anon_sym_for,
    ACTIONS(1395), 1,
      anon_sym_while,
    ACTIONS(1397), 1,
      anon_sym_repeat,
    ACTIONS(1399), 1,
      anon_sym_QMARK,
    ACTIONS(1401), 1,
      anon_sym_TILDE,
    ACTIONS(1409), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1411), 1,
      sym__number_literal,
    ACTIONS(1413), 1,
      anon_sym_SQUOTE,
    ACTIONS(1415), 1,
      anon_sym_DQUOTE,
    ACTIONS(1425), 1,
      sym__raw_string_literal,
    ACTIONS(1427), 1,
      sym__external_open_parenthesis,
    ACTIONS(1429), 1,
      sym__external_open_brace,
    ACTIONS(9251), 1,
      anon_sym_BANG,
    ACTIONS(11775), 1,
      sym_dot_dot_i,
    ACTIONS(11777), 1,
      sym__newline,
    STATE(64), 1,
      sym__open_parenthesis,
    STATE(199), 1,
      sym__open_brace,
    STATE(2309), 1,
      sym__double_quoted_string,
    STATE(2310), 1,
      sym__single_quoted_string,
    STATE(2312), 1,
      sym_string,
    STATE(3746), 1,
      aux_sym_function_definition_repeat1,
    STATE(5134), 1,
      sym__string_or_identifier,
    ACTIONS(1405), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2311), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1419), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11773), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1052), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [101652] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(405), 1,
      sym_identifier,
    ACTIONS(407), 1,
      anon_sym_BSLASH,
    ACTIONS(409), 1,
      anon_sym_function,
    ACTIONS(411), 1,
      anon_sym_if,
    ACTIONS(413), 1,
      anon_sym_for,
    ACTIONS(415), 1,
      anon_sym_while,
    ACTIONS(417), 1,
      anon_sym_repeat,
    ACTIONS(419), 1,
      anon_sym_QMARK,
    ACTIONS(421), 1,
      anon_sym_TILDE,
    ACTIONS(429), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(431), 1,
      sym__number_literal,
    ACTIONS(433), 1,
      anon_sym_SQUOTE,
    ACTIONS(435), 1,
      anon_sym_DQUOTE,
    ACTIONS(445), 1,
      sym__raw_string_literal,
    ACTIONS(447), 1,
      sym__external_open_parenthesis,
    ACTIONS(449), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8403), 1,
      anon_sym_BANG,
    ACTIONS(11781), 1,
      sym_dot_dot_i,
    STATE(5), 1,
      sym__open_parenthesis,
    STATE(42), 1,
      sym__open_brace,
    STATE(2209), 1,
      sym_string,
    STATE(2211), 1,
      sym__single_quoted_string,
    STATE(2212), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5127), 1,
      sym__string_or_identifier,
    ACTIONS(425), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2210), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(439), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11779), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(965), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [101781] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1385), 1,
      sym_identifier,
    ACTIONS(1387), 1,
      anon_sym_BSLASH,
    ACTIONS(1389), 1,
      anon_sym_function,
    ACTIONS(1391), 1,
      anon_sym_if,
    ACTIONS(1393), 1,
      anon_sym_for,
    ACTIONS(1395), 1,
      anon_sym_while,
    ACTIONS(1397), 1,
      anon_sym_repeat,
    ACTIONS(1399), 1,
      anon_sym_QMARK,
    ACTIONS(1401), 1,
      anon_sym_TILDE,
    ACTIONS(1409), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1411), 1,
      sym__number_literal,
    ACTIONS(1413), 1,
      anon_sym_SQUOTE,
    ACTIONS(1415), 1,
      anon_sym_DQUOTE,
    ACTIONS(1425), 1,
      sym__raw_string_literal,
    ACTIONS(1427), 1,
      sym__external_open_parenthesis,
    ACTIONS(1429), 1,
      sym__external_open_brace,
    ACTIONS(9251), 1,
      anon_sym_BANG,
    ACTIONS(11785), 1,
      sym_dot_dot_i,
    ACTIONS(11787), 1,
      sym__newline,
    STATE(64), 1,
      sym__open_parenthesis,
    STATE(199), 1,
      sym__open_brace,
    STATE(2309), 1,
      sym__double_quoted_string,
    STATE(2310), 1,
      sym__single_quoted_string,
    STATE(2312), 1,
      sym_string,
    STATE(3747), 1,
      aux_sym_function_definition_repeat1,
    STATE(5134), 1,
      sym__string_or_identifier,
    ACTIONS(1405), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2311), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1419), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11783), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1051), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [101910] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(405), 1,
      sym_identifier,
    ACTIONS(407), 1,
      anon_sym_BSLASH,
    ACTIONS(409), 1,
      anon_sym_function,
    ACTIONS(411), 1,
      anon_sym_if,
    ACTIONS(413), 1,
      anon_sym_for,
    ACTIONS(415), 1,
      anon_sym_while,
    ACTIONS(417), 1,
      anon_sym_repeat,
    ACTIONS(419), 1,
      anon_sym_QMARK,
    ACTIONS(421), 1,
      anon_sym_TILDE,
    ACTIONS(429), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(431), 1,
      sym__number_literal,
    ACTIONS(433), 1,
      anon_sym_SQUOTE,
    ACTIONS(435), 1,
      anon_sym_DQUOTE,
    ACTIONS(445), 1,
      sym__raw_string_literal,
    ACTIONS(447), 1,
      sym__external_open_parenthesis,
    ACTIONS(449), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8403), 1,
      anon_sym_BANG,
    ACTIONS(11791), 1,
      sym_dot_dot_i,
    STATE(5), 1,
      sym__open_parenthesis,
    STATE(42), 1,
      sym__open_brace,
    STATE(2209), 1,
      sym_string,
    STATE(2211), 1,
      sym__single_quoted_string,
    STATE(2212), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5127), 1,
      sym__string_or_identifier,
    ACTIONS(425), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2210), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(439), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11789), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(964), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [102039] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1385), 1,
      sym_identifier,
    ACTIONS(1387), 1,
      anon_sym_BSLASH,
    ACTIONS(1389), 1,
      anon_sym_function,
    ACTIONS(1391), 1,
      anon_sym_if,
    ACTIONS(1393), 1,
      anon_sym_for,
    ACTIONS(1395), 1,
      anon_sym_while,
    ACTIONS(1397), 1,
      anon_sym_repeat,
    ACTIONS(1399), 1,
      anon_sym_QMARK,
    ACTIONS(1401), 1,
      anon_sym_TILDE,
    ACTIONS(1409), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1411), 1,
      sym__number_literal,
    ACTIONS(1413), 1,
      anon_sym_SQUOTE,
    ACTIONS(1415), 1,
      anon_sym_DQUOTE,
    ACTIONS(1425), 1,
      sym__raw_string_literal,
    ACTIONS(1427), 1,
      sym__external_open_parenthesis,
    ACTIONS(1429), 1,
      sym__external_open_brace,
    ACTIONS(9251), 1,
      anon_sym_BANG,
    ACTIONS(11795), 1,
      sym_dot_dot_i,
    ACTIONS(11797), 1,
      sym__newline,
    STATE(64), 1,
      sym__open_parenthesis,
    STATE(199), 1,
      sym__open_brace,
    STATE(2309), 1,
      sym__double_quoted_string,
    STATE(2310), 1,
      sym__single_quoted_string,
    STATE(2312), 1,
      sym_string,
    STATE(3749), 1,
      aux_sym_function_definition_repeat1,
    STATE(5134), 1,
      sym__string_or_identifier,
    ACTIONS(1405), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2311), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1419), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11793), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1050), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [102168] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(405), 1,
      sym_identifier,
    ACTIONS(407), 1,
      anon_sym_BSLASH,
    ACTIONS(409), 1,
      anon_sym_function,
    ACTIONS(411), 1,
      anon_sym_if,
    ACTIONS(413), 1,
      anon_sym_for,
    ACTIONS(415), 1,
      anon_sym_while,
    ACTIONS(417), 1,
      anon_sym_repeat,
    ACTIONS(419), 1,
      anon_sym_QMARK,
    ACTIONS(421), 1,
      anon_sym_TILDE,
    ACTIONS(429), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(431), 1,
      sym__number_literal,
    ACTIONS(433), 1,
      anon_sym_SQUOTE,
    ACTIONS(435), 1,
      anon_sym_DQUOTE,
    ACTIONS(445), 1,
      sym__raw_string_literal,
    ACTIONS(447), 1,
      sym__external_open_parenthesis,
    ACTIONS(449), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8403), 1,
      anon_sym_BANG,
    ACTIONS(11801), 1,
      sym_dot_dot_i,
    STATE(5), 1,
      sym__open_parenthesis,
    STATE(42), 1,
      sym__open_brace,
    STATE(2209), 1,
      sym_string,
    STATE(2211), 1,
      sym__single_quoted_string,
    STATE(2212), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5127), 1,
      sym__string_or_identifier,
    ACTIONS(425), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2210), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(439), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11799), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(963), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [102297] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1385), 1,
      sym_identifier,
    ACTIONS(1387), 1,
      anon_sym_BSLASH,
    ACTIONS(1389), 1,
      anon_sym_function,
    ACTIONS(1391), 1,
      anon_sym_if,
    ACTIONS(1393), 1,
      anon_sym_for,
    ACTIONS(1395), 1,
      anon_sym_while,
    ACTIONS(1397), 1,
      anon_sym_repeat,
    ACTIONS(1399), 1,
      anon_sym_QMARK,
    ACTIONS(1401), 1,
      anon_sym_TILDE,
    ACTIONS(1409), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1411), 1,
      sym__number_literal,
    ACTIONS(1413), 1,
      anon_sym_SQUOTE,
    ACTIONS(1415), 1,
      anon_sym_DQUOTE,
    ACTIONS(1425), 1,
      sym__raw_string_literal,
    ACTIONS(1427), 1,
      sym__external_open_parenthesis,
    ACTIONS(1429), 1,
      sym__external_open_brace,
    ACTIONS(9251), 1,
      anon_sym_BANG,
    ACTIONS(11805), 1,
      sym_dot_dot_i,
    ACTIONS(11807), 1,
      sym__newline,
    STATE(64), 1,
      sym__open_parenthesis,
    STATE(199), 1,
      sym__open_brace,
    STATE(2309), 1,
      sym__double_quoted_string,
    STATE(2310), 1,
      sym__single_quoted_string,
    STATE(2312), 1,
      sym_string,
    STATE(3751), 1,
      aux_sym_function_definition_repeat1,
    STATE(5134), 1,
      sym__string_or_identifier,
    ACTIONS(1405), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2311), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1419), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11803), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1049), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [102426] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1385), 1,
      sym_identifier,
    ACTIONS(1387), 1,
      anon_sym_BSLASH,
    ACTIONS(1389), 1,
      anon_sym_function,
    ACTIONS(1391), 1,
      anon_sym_if,
    ACTIONS(1393), 1,
      anon_sym_for,
    ACTIONS(1395), 1,
      anon_sym_while,
    ACTIONS(1397), 1,
      anon_sym_repeat,
    ACTIONS(1399), 1,
      anon_sym_QMARK,
    ACTIONS(1401), 1,
      anon_sym_TILDE,
    ACTIONS(1409), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1411), 1,
      sym__number_literal,
    ACTIONS(1413), 1,
      anon_sym_SQUOTE,
    ACTIONS(1415), 1,
      anon_sym_DQUOTE,
    ACTIONS(1425), 1,
      sym__raw_string_literal,
    ACTIONS(1427), 1,
      sym__external_open_parenthesis,
    ACTIONS(1429), 1,
      sym__external_open_brace,
    ACTIONS(9251), 1,
      anon_sym_BANG,
    ACTIONS(11811), 1,
      sym_dot_dot_i,
    ACTIONS(11813), 1,
      sym__newline,
    STATE(64), 1,
      sym__open_parenthesis,
    STATE(199), 1,
      sym__open_brace,
    STATE(2309), 1,
      sym__double_quoted_string,
    STATE(2310), 1,
      sym__single_quoted_string,
    STATE(2312), 1,
      sym_string,
    STATE(3755), 1,
      aux_sym_function_definition_repeat1,
    STATE(5134), 1,
      sym__string_or_identifier,
    ACTIONS(1405), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2311), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1419), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11809), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1048), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [102555] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1385), 1,
      sym_identifier,
    ACTIONS(1387), 1,
      anon_sym_BSLASH,
    ACTIONS(1389), 1,
      anon_sym_function,
    ACTIONS(1391), 1,
      anon_sym_if,
    ACTIONS(1393), 1,
      anon_sym_for,
    ACTIONS(1395), 1,
      anon_sym_while,
    ACTIONS(1397), 1,
      anon_sym_repeat,
    ACTIONS(1399), 1,
      anon_sym_QMARK,
    ACTIONS(1401), 1,
      anon_sym_TILDE,
    ACTIONS(1409), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1411), 1,
      sym__number_literal,
    ACTIONS(1413), 1,
      anon_sym_SQUOTE,
    ACTIONS(1415), 1,
      anon_sym_DQUOTE,
    ACTIONS(1425), 1,
      sym__raw_string_literal,
    ACTIONS(1427), 1,
      sym__external_open_parenthesis,
    ACTIONS(1429), 1,
      sym__external_open_brace,
    ACTIONS(9251), 1,
      anon_sym_BANG,
    ACTIONS(11817), 1,
      sym_dot_dot_i,
    ACTIONS(11819), 1,
      sym__newline,
    STATE(64), 1,
      sym__open_parenthesis,
    STATE(199), 1,
      sym__open_brace,
    STATE(2309), 1,
      sym__double_quoted_string,
    STATE(2310), 1,
      sym__single_quoted_string,
    STATE(2312), 1,
      sym_string,
    STATE(3761), 1,
      aux_sym_function_definition_repeat1,
    STATE(5134), 1,
      sym__string_or_identifier,
    ACTIONS(1405), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2311), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1419), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11815), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1047), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [102684] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1385), 1,
      sym_identifier,
    ACTIONS(1387), 1,
      anon_sym_BSLASH,
    ACTIONS(1389), 1,
      anon_sym_function,
    ACTIONS(1391), 1,
      anon_sym_if,
    ACTIONS(1393), 1,
      anon_sym_for,
    ACTIONS(1395), 1,
      anon_sym_while,
    ACTIONS(1397), 1,
      anon_sym_repeat,
    ACTIONS(1399), 1,
      anon_sym_QMARK,
    ACTIONS(1401), 1,
      anon_sym_TILDE,
    ACTIONS(1409), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1411), 1,
      sym__number_literal,
    ACTIONS(1413), 1,
      anon_sym_SQUOTE,
    ACTIONS(1415), 1,
      anon_sym_DQUOTE,
    ACTIONS(1425), 1,
      sym__raw_string_literal,
    ACTIONS(1427), 1,
      sym__external_open_parenthesis,
    ACTIONS(1429), 1,
      sym__external_open_brace,
    ACTIONS(9251), 1,
      anon_sym_BANG,
    ACTIONS(11823), 1,
      sym_dot_dot_i,
    ACTIONS(11825), 1,
      sym__newline,
    STATE(64), 1,
      sym__open_parenthesis,
    STATE(199), 1,
      sym__open_brace,
    STATE(2309), 1,
      sym__double_quoted_string,
    STATE(2310), 1,
      sym__single_quoted_string,
    STATE(2312), 1,
      sym_string,
    STATE(3777), 1,
      aux_sym_function_definition_repeat1,
    STATE(5134), 1,
      sym__string_or_identifier,
    ACTIONS(1405), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2311), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1419), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11821), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1046), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [102813] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4642), 1,
      sym_identifier,
    ACTIONS(4644), 1,
      anon_sym_BSLASH,
    ACTIONS(4646), 1,
      anon_sym_function,
    ACTIONS(4648), 1,
      anon_sym_if,
    ACTIONS(4650), 1,
      anon_sym_for,
    ACTIONS(4652), 1,
      anon_sym_while,
    ACTIONS(4654), 1,
      anon_sym_repeat,
    ACTIONS(4656), 1,
      anon_sym_QMARK,
    ACTIONS(4658), 1,
      anon_sym_TILDE,
    ACTIONS(4666), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4668), 1,
      sym__number_literal,
    ACTIONS(4670), 1,
      anon_sym_SQUOTE,
    ACTIONS(4672), 1,
      anon_sym_DQUOTE,
    ACTIONS(4680), 1,
      sym__raw_string_literal,
    ACTIONS(4682), 1,
      sym__external_open_parenthesis,
    ACTIONS(4684), 1,
      sym__external_open_brace,
    ACTIONS(6371), 1,
      anon_sym_BANG,
    ACTIONS(11829), 1,
      sym_dot_dot_i,
    ACTIONS(11831), 1,
      sym__newline,
    STATE(185), 1,
      sym__open_brace,
    STATE(218), 1,
      sym__open_parenthesis,
    STATE(2649), 1,
      sym__double_quoted_string,
    STATE(2654), 1,
      sym__single_quoted_string,
    STATE(2744), 1,
      sym_string,
    STATE(3759), 1,
      aux_sym_function_definition_repeat1,
    STATE(5141), 1,
      sym__string_or_identifier,
    ACTIONS(4662), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2656), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4676), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11827), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1972), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [102942] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1385), 1,
      sym_identifier,
    ACTIONS(1387), 1,
      anon_sym_BSLASH,
    ACTIONS(1389), 1,
      anon_sym_function,
    ACTIONS(1391), 1,
      anon_sym_if,
    ACTIONS(1393), 1,
      anon_sym_for,
    ACTIONS(1395), 1,
      anon_sym_while,
    ACTIONS(1397), 1,
      anon_sym_repeat,
    ACTIONS(1399), 1,
      anon_sym_QMARK,
    ACTIONS(1401), 1,
      anon_sym_TILDE,
    ACTIONS(1409), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1411), 1,
      sym__number_literal,
    ACTIONS(1413), 1,
      anon_sym_SQUOTE,
    ACTIONS(1415), 1,
      anon_sym_DQUOTE,
    ACTIONS(1425), 1,
      sym__raw_string_literal,
    ACTIONS(1427), 1,
      sym__external_open_parenthesis,
    ACTIONS(1429), 1,
      sym__external_open_brace,
    ACTIONS(9251), 1,
      anon_sym_BANG,
    ACTIONS(11835), 1,
      sym_dot_dot_i,
    ACTIONS(11837), 1,
      sym__newline,
    STATE(64), 1,
      sym__open_parenthesis,
    STATE(199), 1,
      sym__open_brace,
    STATE(2309), 1,
      sym__double_quoted_string,
    STATE(2310), 1,
      sym__single_quoted_string,
    STATE(2312), 1,
      sym_string,
    STATE(3779), 1,
      aux_sym_function_definition_repeat1,
    STATE(5134), 1,
      sym__string_or_identifier,
    ACTIONS(1405), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2311), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1419), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11833), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1045), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [103071] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4642), 1,
      sym_identifier,
    ACTIONS(4644), 1,
      anon_sym_BSLASH,
    ACTIONS(4646), 1,
      anon_sym_function,
    ACTIONS(4648), 1,
      anon_sym_if,
    ACTIONS(4650), 1,
      anon_sym_for,
    ACTIONS(4652), 1,
      anon_sym_while,
    ACTIONS(4654), 1,
      anon_sym_repeat,
    ACTIONS(4656), 1,
      anon_sym_QMARK,
    ACTIONS(4658), 1,
      anon_sym_TILDE,
    ACTIONS(4666), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4668), 1,
      sym__number_literal,
    ACTIONS(4670), 1,
      anon_sym_SQUOTE,
    ACTIONS(4672), 1,
      anon_sym_DQUOTE,
    ACTIONS(4680), 1,
      sym__raw_string_literal,
    ACTIONS(4682), 1,
      sym__external_open_parenthesis,
    ACTIONS(4684), 1,
      sym__external_open_brace,
    ACTIONS(6371), 1,
      anon_sym_BANG,
    ACTIONS(11841), 1,
      sym_dot_dot_i,
    ACTIONS(11843), 1,
      sym__newline,
    STATE(185), 1,
      sym__open_brace,
    STATE(218), 1,
      sym__open_parenthesis,
    STATE(2649), 1,
      sym__double_quoted_string,
    STATE(2654), 1,
      sym__single_quoted_string,
    STATE(2744), 1,
      sym_string,
    STATE(3760), 1,
      aux_sym_function_definition_repeat1,
    STATE(5141), 1,
      sym__string_or_identifier,
    ACTIONS(4662), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2656), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4676), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11839), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1967), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [103200] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1385), 1,
      sym_identifier,
    ACTIONS(1387), 1,
      anon_sym_BSLASH,
    ACTIONS(1389), 1,
      anon_sym_function,
    ACTIONS(1391), 1,
      anon_sym_if,
    ACTIONS(1393), 1,
      anon_sym_for,
    ACTIONS(1395), 1,
      anon_sym_while,
    ACTIONS(1397), 1,
      anon_sym_repeat,
    ACTIONS(1399), 1,
      anon_sym_QMARK,
    ACTIONS(1401), 1,
      anon_sym_TILDE,
    ACTIONS(1409), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1411), 1,
      sym__number_literal,
    ACTIONS(1413), 1,
      anon_sym_SQUOTE,
    ACTIONS(1415), 1,
      anon_sym_DQUOTE,
    ACTIONS(1425), 1,
      sym__raw_string_literal,
    ACTIONS(1427), 1,
      sym__external_open_parenthesis,
    ACTIONS(1429), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9251), 1,
      anon_sym_BANG,
    ACTIONS(11847), 1,
      sym_dot_dot_i,
    STATE(64), 1,
      sym__open_parenthesis,
    STATE(199), 1,
      sym__open_brace,
    STATE(2309), 1,
      sym__double_quoted_string,
    STATE(2310), 1,
      sym__single_quoted_string,
    STATE(2312), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5134), 1,
      sym__string_or_identifier,
    ACTIONS(1405), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2311), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1419), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11845), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1044), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [103329] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1385), 1,
      sym_identifier,
    ACTIONS(1387), 1,
      anon_sym_BSLASH,
    ACTIONS(1389), 1,
      anon_sym_function,
    ACTIONS(1391), 1,
      anon_sym_if,
    ACTIONS(1393), 1,
      anon_sym_for,
    ACTIONS(1395), 1,
      anon_sym_while,
    ACTIONS(1397), 1,
      anon_sym_repeat,
    ACTIONS(1399), 1,
      anon_sym_QMARK,
    ACTIONS(1401), 1,
      anon_sym_TILDE,
    ACTIONS(1409), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1411), 1,
      sym__number_literal,
    ACTIONS(1413), 1,
      anon_sym_SQUOTE,
    ACTIONS(1415), 1,
      anon_sym_DQUOTE,
    ACTIONS(1425), 1,
      sym__raw_string_literal,
    ACTIONS(1427), 1,
      sym__external_open_parenthesis,
    ACTIONS(1429), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9251), 1,
      anon_sym_BANG,
    ACTIONS(11851), 1,
      sym_dot_dot_i,
    STATE(64), 1,
      sym__open_parenthesis,
    STATE(199), 1,
      sym__open_brace,
    STATE(2309), 1,
      sym__double_quoted_string,
    STATE(2310), 1,
      sym__single_quoted_string,
    STATE(2312), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5134), 1,
      sym__string_or_identifier,
    ACTIONS(1405), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2311), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1419), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11849), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1043), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [103458] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2826), 1,
      sym_identifier,
    ACTIONS(2828), 1,
      anon_sym_BSLASH,
    ACTIONS(2830), 1,
      anon_sym_function,
    ACTIONS(2832), 1,
      anon_sym_if,
    ACTIONS(2834), 1,
      anon_sym_for,
    ACTIONS(2836), 1,
      anon_sym_while,
    ACTIONS(2838), 1,
      anon_sym_repeat,
    ACTIONS(2840), 1,
      anon_sym_QMARK,
    ACTIONS(2842), 1,
      anon_sym_TILDE,
    ACTIONS(2850), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2852), 1,
      sym__number_literal,
    ACTIONS(2854), 1,
      anon_sym_SQUOTE,
    ACTIONS(2856), 1,
      anon_sym_DQUOTE,
    ACTIONS(2866), 1,
      sym__raw_string_literal,
    ACTIONS(2868), 1,
      sym__external_open_parenthesis,
    ACTIONS(2870), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(10915), 1,
      anon_sym_BANG,
    ACTIONS(11855), 1,
      sym_dot_dot_i,
    STATE(178), 1,
      sym__open_parenthesis,
    STATE(244), 1,
      sym__open_brace,
    STATE(2522), 1,
      sym_string,
    STATE(2528), 1,
      sym__single_quoted_string,
    STATE(2529), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5126), 1,
      sym__string_or_identifier,
    ACTIONS(2846), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2523), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2860), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11853), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1680), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [103587] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4642), 1,
      sym_identifier,
    ACTIONS(4644), 1,
      anon_sym_BSLASH,
    ACTIONS(4646), 1,
      anon_sym_function,
    ACTIONS(4648), 1,
      anon_sym_if,
    ACTIONS(4650), 1,
      anon_sym_for,
    ACTIONS(4652), 1,
      anon_sym_while,
    ACTIONS(4654), 1,
      anon_sym_repeat,
    ACTIONS(4656), 1,
      anon_sym_QMARK,
    ACTIONS(4658), 1,
      anon_sym_TILDE,
    ACTIONS(4666), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4668), 1,
      sym__number_literal,
    ACTIONS(4670), 1,
      anon_sym_SQUOTE,
    ACTIONS(4672), 1,
      anon_sym_DQUOTE,
    ACTIONS(4680), 1,
      sym__raw_string_literal,
    ACTIONS(4682), 1,
      sym__external_open_parenthesis,
    ACTIONS(4684), 1,
      sym__external_open_brace,
    ACTIONS(6371), 1,
      anon_sym_BANG,
    ACTIONS(11859), 1,
      sym_dot_dot_i,
    ACTIONS(11861), 1,
      sym__newline,
    STATE(185), 1,
      sym__open_brace,
    STATE(218), 1,
      sym__open_parenthesis,
    STATE(2649), 1,
      sym__double_quoted_string,
    STATE(2654), 1,
      sym__single_quoted_string,
    STATE(2744), 1,
      sym_string,
    STATE(3776), 1,
      aux_sym_function_definition_repeat1,
    STATE(5141), 1,
      sym__string_or_identifier,
    ACTIONS(4662), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2656), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4676), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11857), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1957), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [103716] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1385), 1,
      sym_identifier,
    ACTIONS(1387), 1,
      anon_sym_BSLASH,
    ACTIONS(1389), 1,
      anon_sym_function,
    ACTIONS(1391), 1,
      anon_sym_if,
    ACTIONS(1393), 1,
      anon_sym_for,
    ACTIONS(1395), 1,
      anon_sym_while,
    ACTIONS(1397), 1,
      anon_sym_repeat,
    ACTIONS(1399), 1,
      anon_sym_QMARK,
    ACTIONS(1401), 1,
      anon_sym_TILDE,
    ACTIONS(1409), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1411), 1,
      sym__number_literal,
    ACTIONS(1413), 1,
      anon_sym_SQUOTE,
    ACTIONS(1415), 1,
      anon_sym_DQUOTE,
    ACTIONS(1425), 1,
      sym__raw_string_literal,
    ACTIONS(1427), 1,
      sym__external_open_parenthesis,
    ACTIONS(1429), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9251), 1,
      anon_sym_BANG,
    ACTIONS(11865), 1,
      sym_dot_dot_i,
    STATE(64), 1,
      sym__open_parenthesis,
    STATE(199), 1,
      sym__open_brace,
    STATE(2309), 1,
      sym__double_quoted_string,
    STATE(2310), 1,
      sym__single_quoted_string,
    STATE(2312), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5134), 1,
      sym__string_or_identifier,
    ACTIONS(1405), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2311), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1419), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11863), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1042), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [103845] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(11869), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11867), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4582), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [103974] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4752), 1,
      sym_identifier,
    ACTIONS(4754), 1,
      anon_sym_BSLASH,
    ACTIONS(4756), 1,
      anon_sym_function,
    ACTIONS(4758), 1,
      anon_sym_if,
    ACTIONS(4760), 1,
      anon_sym_for,
    ACTIONS(4762), 1,
      anon_sym_while,
    ACTIONS(4764), 1,
      anon_sym_repeat,
    ACTIONS(4766), 1,
      anon_sym_QMARK,
    ACTIONS(4768), 1,
      anon_sym_TILDE,
    ACTIONS(4776), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4778), 1,
      sym__number_literal,
    ACTIONS(4780), 1,
      anon_sym_SQUOTE,
    ACTIONS(4782), 1,
      anon_sym_DQUOTE,
    ACTIONS(4790), 1,
      sym__raw_string_literal,
    ACTIONS(4792), 1,
      sym__external_open_parenthesis,
    ACTIONS(4794), 1,
      sym__external_open_brace,
    ACTIONS(6353), 1,
      anon_sym_BANG,
    ACTIONS(11873), 1,
      sym_dot_dot_i,
    ACTIONS(11875), 1,
      sym__newline,
    STATE(192), 1,
      sym__open_brace,
    STATE(214), 1,
      sym__open_parenthesis,
    STATE(2664), 1,
      sym_string,
    STATE(2701), 1,
      sym__single_quoted_string,
    STATE(2745), 1,
      sym__double_quoted_string,
    STATE(3891), 1,
      aux_sym_function_definition_repeat1,
    STATE(5148), 1,
      sym__string_or_identifier,
    ACTIONS(4772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2700), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4786), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11871), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2164), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [104103] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4642), 1,
      sym_identifier,
    ACTIONS(4644), 1,
      anon_sym_BSLASH,
    ACTIONS(4646), 1,
      anon_sym_function,
    ACTIONS(4648), 1,
      anon_sym_if,
    ACTIONS(4650), 1,
      anon_sym_for,
    ACTIONS(4652), 1,
      anon_sym_while,
    ACTIONS(4654), 1,
      anon_sym_repeat,
    ACTIONS(4656), 1,
      anon_sym_QMARK,
    ACTIONS(4658), 1,
      anon_sym_TILDE,
    ACTIONS(4666), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4668), 1,
      sym__number_literal,
    ACTIONS(4670), 1,
      anon_sym_SQUOTE,
    ACTIONS(4672), 1,
      anon_sym_DQUOTE,
    ACTIONS(4680), 1,
      sym__raw_string_literal,
    ACTIONS(4682), 1,
      sym__external_open_parenthesis,
    ACTIONS(4684), 1,
      sym__external_open_brace,
    ACTIONS(6371), 1,
      anon_sym_BANG,
    ACTIONS(11879), 1,
      sym_dot_dot_i,
    ACTIONS(11881), 1,
      sym__newline,
    STATE(185), 1,
      sym__open_brace,
    STATE(218), 1,
      sym__open_parenthesis,
    STATE(2649), 1,
      sym__double_quoted_string,
    STATE(2654), 1,
      sym__single_quoted_string,
    STATE(2744), 1,
      sym_string,
    STATE(3783), 1,
      aux_sym_function_definition_repeat1,
    STATE(5141), 1,
      sym__string_or_identifier,
    ACTIONS(4662), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2656), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4676), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11877), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1954), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [104232] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4642), 1,
      sym_identifier,
    ACTIONS(4644), 1,
      anon_sym_BSLASH,
    ACTIONS(4646), 1,
      anon_sym_function,
    ACTIONS(4648), 1,
      anon_sym_if,
    ACTIONS(4650), 1,
      anon_sym_for,
    ACTIONS(4652), 1,
      anon_sym_while,
    ACTIONS(4654), 1,
      anon_sym_repeat,
    ACTIONS(4656), 1,
      anon_sym_QMARK,
    ACTIONS(4658), 1,
      anon_sym_TILDE,
    ACTIONS(4666), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4668), 1,
      sym__number_literal,
    ACTIONS(4670), 1,
      anon_sym_SQUOTE,
    ACTIONS(4672), 1,
      anon_sym_DQUOTE,
    ACTIONS(4680), 1,
      sym__raw_string_literal,
    ACTIONS(4682), 1,
      sym__external_open_parenthesis,
    ACTIONS(4684), 1,
      sym__external_open_brace,
    ACTIONS(6371), 1,
      anon_sym_BANG,
    ACTIONS(11885), 1,
      sym_dot_dot_i,
    ACTIONS(11887), 1,
      sym__newline,
    STATE(185), 1,
      sym__open_brace,
    STATE(218), 1,
      sym__open_parenthesis,
    STATE(2649), 1,
      sym__double_quoted_string,
    STATE(2654), 1,
      sym__single_quoted_string,
    STATE(2744), 1,
      sym_string,
    STATE(3784), 1,
      aux_sym_function_definition_repeat1,
    STATE(5141), 1,
      sym__string_or_identifier,
    ACTIONS(4662), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2656), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4676), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11883), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1948), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [104361] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4642), 1,
      sym_identifier,
    ACTIONS(4644), 1,
      anon_sym_BSLASH,
    ACTIONS(4646), 1,
      anon_sym_function,
    ACTIONS(4648), 1,
      anon_sym_if,
    ACTIONS(4650), 1,
      anon_sym_for,
    ACTIONS(4652), 1,
      anon_sym_while,
    ACTIONS(4654), 1,
      anon_sym_repeat,
    ACTIONS(4656), 1,
      anon_sym_QMARK,
    ACTIONS(4658), 1,
      anon_sym_TILDE,
    ACTIONS(4666), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4668), 1,
      sym__number_literal,
    ACTIONS(4670), 1,
      anon_sym_SQUOTE,
    ACTIONS(4672), 1,
      anon_sym_DQUOTE,
    ACTIONS(4680), 1,
      sym__raw_string_literal,
    ACTIONS(4682), 1,
      sym__external_open_parenthesis,
    ACTIONS(4684), 1,
      sym__external_open_brace,
    ACTIONS(6371), 1,
      anon_sym_BANG,
    ACTIONS(11891), 1,
      sym_dot_dot_i,
    ACTIONS(11893), 1,
      sym__newline,
    STATE(185), 1,
      sym__open_brace,
    STATE(218), 1,
      sym__open_parenthesis,
    STATE(2649), 1,
      sym__double_quoted_string,
    STATE(2654), 1,
      sym__single_quoted_string,
    STATE(2744), 1,
      sym_string,
    STATE(3785), 1,
      aux_sym_function_definition_repeat1,
    STATE(5141), 1,
      sym__string_or_identifier,
    ACTIONS(4662), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2656), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4676), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11889), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2032), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [104490] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4642), 1,
      sym_identifier,
    ACTIONS(4644), 1,
      anon_sym_BSLASH,
    ACTIONS(4646), 1,
      anon_sym_function,
    ACTIONS(4648), 1,
      anon_sym_if,
    ACTIONS(4650), 1,
      anon_sym_for,
    ACTIONS(4652), 1,
      anon_sym_while,
    ACTIONS(4654), 1,
      anon_sym_repeat,
    ACTIONS(4656), 1,
      anon_sym_QMARK,
    ACTIONS(4658), 1,
      anon_sym_TILDE,
    ACTIONS(4666), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4668), 1,
      sym__number_literal,
    ACTIONS(4670), 1,
      anon_sym_SQUOTE,
    ACTIONS(4672), 1,
      anon_sym_DQUOTE,
    ACTIONS(4680), 1,
      sym__raw_string_literal,
    ACTIONS(4682), 1,
      sym__external_open_parenthesis,
    ACTIONS(4684), 1,
      sym__external_open_brace,
    ACTIONS(6371), 1,
      anon_sym_BANG,
    ACTIONS(11897), 1,
      sym_dot_dot_i,
    ACTIONS(11899), 1,
      sym__newline,
    STATE(185), 1,
      sym__open_brace,
    STATE(218), 1,
      sym__open_parenthesis,
    STATE(2649), 1,
      sym__double_quoted_string,
    STATE(2654), 1,
      sym__single_quoted_string,
    STATE(2744), 1,
      sym_string,
    STATE(3788), 1,
      aux_sym_function_definition_repeat1,
    STATE(5141), 1,
      sym__string_or_identifier,
    ACTIONS(4662), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2656), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4676), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11895), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1944), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [104619] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4642), 1,
      sym_identifier,
    ACTIONS(4644), 1,
      anon_sym_BSLASH,
    ACTIONS(4646), 1,
      anon_sym_function,
    ACTIONS(4648), 1,
      anon_sym_if,
    ACTIONS(4650), 1,
      anon_sym_for,
    ACTIONS(4652), 1,
      anon_sym_while,
    ACTIONS(4654), 1,
      anon_sym_repeat,
    ACTIONS(4656), 1,
      anon_sym_QMARK,
    ACTIONS(4658), 1,
      anon_sym_TILDE,
    ACTIONS(4666), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4668), 1,
      sym__number_literal,
    ACTIONS(4670), 1,
      anon_sym_SQUOTE,
    ACTIONS(4672), 1,
      anon_sym_DQUOTE,
    ACTIONS(4680), 1,
      sym__raw_string_literal,
    ACTIONS(4682), 1,
      sym__external_open_parenthesis,
    ACTIONS(4684), 1,
      sym__external_open_brace,
    ACTIONS(6371), 1,
      anon_sym_BANG,
    ACTIONS(11903), 1,
      sym_dot_dot_i,
    ACTIONS(11905), 1,
      sym__newline,
    STATE(185), 1,
      sym__open_brace,
    STATE(218), 1,
      sym__open_parenthesis,
    STATE(2649), 1,
      sym__double_quoted_string,
    STATE(2654), 1,
      sym__single_quoted_string,
    STATE(2744), 1,
      sym_string,
    STATE(3789), 1,
      aux_sym_function_definition_repeat1,
    STATE(5141), 1,
      sym__string_or_identifier,
    ACTIONS(4662), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2656), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4676), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11901), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1910), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [104748] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4642), 1,
      sym_identifier,
    ACTIONS(4644), 1,
      anon_sym_BSLASH,
    ACTIONS(4646), 1,
      anon_sym_function,
    ACTIONS(4648), 1,
      anon_sym_if,
    ACTIONS(4650), 1,
      anon_sym_for,
    ACTIONS(4652), 1,
      anon_sym_while,
    ACTIONS(4654), 1,
      anon_sym_repeat,
    ACTIONS(4656), 1,
      anon_sym_QMARK,
    ACTIONS(4658), 1,
      anon_sym_TILDE,
    ACTIONS(4666), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4668), 1,
      sym__number_literal,
    ACTIONS(4670), 1,
      anon_sym_SQUOTE,
    ACTIONS(4672), 1,
      anon_sym_DQUOTE,
    ACTIONS(4680), 1,
      sym__raw_string_literal,
    ACTIONS(4682), 1,
      sym__external_open_parenthesis,
    ACTIONS(4684), 1,
      sym__external_open_brace,
    ACTIONS(6371), 1,
      anon_sym_BANG,
    ACTIONS(11909), 1,
      sym_dot_dot_i,
    ACTIONS(11911), 1,
      sym__newline,
    STATE(185), 1,
      sym__open_brace,
    STATE(218), 1,
      sym__open_parenthesis,
    STATE(2649), 1,
      sym__double_quoted_string,
    STATE(2654), 1,
      sym__single_quoted_string,
    STATE(2744), 1,
      sym_string,
    STATE(3790), 1,
      aux_sym_function_definition_repeat1,
    STATE(5141), 1,
      sym__string_or_identifier,
    ACTIONS(4662), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2656), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4676), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11907), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1939), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [104877] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4642), 1,
      sym_identifier,
    ACTIONS(4644), 1,
      anon_sym_BSLASH,
    ACTIONS(4646), 1,
      anon_sym_function,
    ACTIONS(4648), 1,
      anon_sym_if,
    ACTIONS(4650), 1,
      anon_sym_for,
    ACTIONS(4652), 1,
      anon_sym_while,
    ACTIONS(4654), 1,
      anon_sym_repeat,
    ACTIONS(4656), 1,
      anon_sym_QMARK,
    ACTIONS(4658), 1,
      anon_sym_TILDE,
    ACTIONS(4666), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4668), 1,
      sym__number_literal,
    ACTIONS(4670), 1,
      anon_sym_SQUOTE,
    ACTIONS(4672), 1,
      anon_sym_DQUOTE,
    ACTIONS(4680), 1,
      sym__raw_string_literal,
    ACTIONS(4682), 1,
      sym__external_open_parenthesis,
    ACTIONS(4684), 1,
      sym__external_open_brace,
    ACTIONS(6371), 1,
      anon_sym_BANG,
    ACTIONS(11915), 1,
      sym_dot_dot_i,
    ACTIONS(11917), 1,
      sym__newline,
    STATE(185), 1,
      sym__open_brace,
    STATE(218), 1,
      sym__open_parenthesis,
    STATE(2649), 1,
      sym__double_quoted_string,
    STATE(2654), 1,
      sym__single_quoted_string,
    STATE(2744), 1,
      sym_string,
    STATE(3791), 1,
      aux_sym_function_definition_repeat1,
    STATE(5141), 1,
      sym__string_or_identifier,
    ACTIONS(4662), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2656), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4676), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11913), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1937), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [105006] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4642), 1,
      sym_identifier,
    ACTIONS(4644), 1,
      anon_sym_BSLASH,
    ACTIONS(4646), 1,
      anon_sym_function,
    ACTIONS(4648), 1,
      anon_sym_if,
    ACTIONS(4650), 1,
      anon_sym_for,
    ACTIONS(4652), 1,
      anon_sym_while,
    ACTIONS(4654), 1,
      anon_sym_repeat,
    ACTIONS(4656), 1,
      anon_sym_QMARK,
    ACTIONS(4658), 1,
      anon_sym_TILDE,
    ACTIONS(4666), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4668), 1,
      sym__number_literal,
    ACTIONS(4670), 1,
      anon_sym_SQUOTE,
    ACTIONS(4672), 1,
      anon_sym_DQUOTE,
    ACTIONS(4680), 1,
      sym__raw_string_literal,
    ACTIONS(4682), 1,
      sym__external_open_parenthesis,
    ACTIONS(4684), 1,
      sym__external_open_brace,
    ACTIONS(6371), 1,
      anon_sym_BANG,
    ACTIONS(11921), 1,
      sym_dot_dot_i,
    ACTIONS(11923), 1,
      sym__newline,
    STATE(185), 1,
      sym__open_brace,
    STATE(218), 1,
      sym__open_parenthesis,
    STATE(2649), 1,
      sym__double_quoted_string,
    STATE(2654), 1,
      sym__single_quoted_string,
    STATE(2744), 1,
      sym_string,
    STATE(3792), 1,
      aux_sym_function_definition_repeat1,
    STATE(5141), 1,
      sym__string_or_identifier,
    ACTIONS(4662), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2656), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4676), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11919), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1935), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [105135] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4642), 1,
      sym_identifier,
    ACTIONS(4644), 1,
      anon_sym_BSLASH,
    ACTIONS(4646), 1,
      anon_sym_function,
    ACTIONS(4648), 1,
      anon_sym_if,
    ACTIONS(4650), 1,
      anon_sym_for,
    ACTIONS(4652), 1,
      anon_sym_while,
    ACTIONS(4654), 1,
      anon_sym_repeat,
    ACTIONS(4656), 1,
      anon_sym_QMARK,
    ACTIONS(4658), 1,
      anon_sym_TILDE,
    ACTIONS(4666), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4668), 1,
      sym__number_literal,
    ACTIONS(4670), 1,
      anon_sym_SQUOTE,
    ACTIONS(4672), 1,
      anon_sym_DQUOTE,
    ACTIONS(4680), 1,
      sym__raw_string_literal,
    ACTIONS(4682), 1,
      sym__external_open_parenthesis,
    ACTIONS(4684), 1,
      sym__external_open_brace,
    ACTIONS(6371), 1,
      anon_sym_BANG,
    ACTIONS(11927), 1,
      sym_dot_dot_i,
    ACTIONS(11929), 1,
      sym__newline,
    STATE(185), 1,
      sym__open_brace,
    STATE(218), 1,
      sym__open_parenthesis,
    STATE(2649), 1,
      sym__double_quoted_string,
    STATE(2654), 1,
      sym__single_quoted_string,
    STATE(2744), 1,
      sym_string,
    STATE(3793), 1,
      aux_sym_function_definition_repeat1,
    STATE(5141), 1,
      sym__string_or_identifier,
    ACTIONS(4662), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2656), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4676), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11925), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1942), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [105264] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4053), 1,
      sym_identifier,
    ACTIONS(4055), 1,
      anon_sym_BSLASH,
    ACTIONS(4057), 1,
      anon_sym_function,
    ACTIONS(4059), 1,
      anon_sym_if,
    ACTIONS(4061), 1,
      anon_sym_for,
    ACTIONS(4063), 1,
      anon_sym_while,
    ACTIONS(4065), 1,
      anon_sym_repeat,
    ACTIONS(4067), 1,
      anon_sym_QMARK,
    ACTIONS(4069), 1,
      anon_sym_TILDE,
    ACTIONS(4077), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4079), 1,
      sym__number_literal,
    ACTIONS(4081), 1,
      anon_sym_SQUOTE,
    ACTIONS(4083), 1,
      anon_sym_DQUOTE,
    ACTIONS(4093), 1,
      sym__raw_string_literal,
    ACTIONS(4095), 1,
      sym__external_open_parenthesis,
    ACTIONS(4097), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7821), 1,
      anon_sym_BANG,
    ACTIONS(11933), 1,
      sym_dot_dot_i,
    STATE(133), 1,
      sym__open_brace,
    STATE(150), 1,
      sym__open_parenthesis,
    STATE(2534), 1,
      sym_string,
    STATE(2538), 1,
      sym__single_quoted_string,
    STATE(2539), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5143), 1,
      sym__string_or_identifier,
    ACTIONS(4073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2536), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4087), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11931), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1827), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [105393] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2826), 1,
      sym_identifier,
    ACTIONS(2828), 1,
      anon_sym_BSLASH,
    ACTIONS(2830), 1,
      anon_sym_function,
    ACTIONS(2832), 1,
      anon_sym_if,
    ACTIONS(2834), 1,
      anon_sym_for,
    ACTIONS(2836), 1,
      anon_sym_while,
    ACTIONS(2838), 1,
      anon_sym_repeat,
    ACTIONS(2840), 1,
      anon_sym_QMARK,
    ACTIONS(2842), 1,
      anon_sym_TILDE,
    ACTIONS(2850), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2852), 1,
      sym__number_literal,
    ACTIONS(2854), 1,
      anon_sym_SQUOTE,
    ACTIONS(2856), 1,
      anon_sym_DQUOTE,
    ACTIONS(2866), 1,
      sym__raw_string_literal,
    ACTIONS(2868), 1,
      sym__external_open_parenthesis,
    ACTIONS(2870), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(10915), 1,
      anon_sym_BANG,
    ACTIONS(11937), 1,
      sym_dot_dot_i,
    STATE(178), 1,
      sym__open_parenthesis,
    STATE(244), 1,
      sym__open_brace,
    STATE(2522), 1,
      sym_string,
    STATE(2528), 1,
      sym__single_quoted_string,
    STATE(2529), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5126), 1,
      sym__string_or_identifier,
    ACTIONS(2846), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2523), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2860), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11935), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1725), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [105522] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2826), 1,
      sym_identifier,
    ACTIONS(2828), 1,
      anon_sym_BSLASH,
    ACTIONS(2830), 1,
      anon_sym_function,
    ACTIONS(2832), 1,
      anon_sym_if,
    ACTIONS(2834), 1,
      anon_sym_for,
    ACTIONS(2836), 1,
      anon_sym_while,
    ACTIONS(2838), 1,
      anon_sym_repeat,
    ACTIONS(2840), 1,
      anon_sym_QMARK,
    ACTIONS(2842), 1,
      anon_sym_TILDE,
    ACTIONS(2850), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2852), 1,
      sym__number_literal,
    ACTIONS(2854), 1,
      anon_sym_SQUOTE,
    ACTIONS(2856), 1,
      anon_sym_DQUOTE,
    ACTIONS(2866), 1,
      sym__raw_string_literal,
    ACTIONS(2868), 1,
      sym__external_open_parenthesis,
    ACTIONS(2870), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(10915), 1,
      anon_sym_BANG,
    ACTIONS(11941), 1,
      sym_dot_dot_i,
    STATE(178), 1,
      sym__open_parenthesis,
    STATE(244), 1,
      sym__open_brace,
    STATE(2522), 1,
      sym_string,
    STATE(2528), 1,
      sym__single_quoted_string,
    STATE(2529), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5126), 1,
      sym__string_or_identifier,
    ACTIONS(2846), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2523), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2860), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11939), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1358), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [105651] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1385), 1,
      sym_identifier,
    ACTIONS(1387), 1,
      anon_sym_BSLASH,
    ACTIONS(1389), 1,
      anon_sym_function,
    ACTIONS(1391), 1,
      anon_sym_if,
    ACTIONS(1393), 1,
      anon_sym_for,
    ACTIONS(1395), 1,
      anon_sym_while,
    ACTIONS(1397), 1,
      anon_sym_repeat,
    ACTIONS(1399), 1,
      anon_sym_QMARK,
    ACTIONS(1401), 1,
      anon_sym_TILDE,
    ACTIONS(1409), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1411), 1,
      sym__number_literal,
    ACTIONS(1413), 1,
      anon_sym_SQUOTE,
    ACTIONS(1415), 1,
      anon_sym_DQUOTE,
    ACTIONS(1425), 1,
      sym__raw_string_literal,
    ACTIONS(1427), 1,
      sym__external_open_parenthesis,
    ACTIONS(1429), 1,
      sym__external_open_brace,
    ACTIONS(9251), 1,
      anon_sym_BANG,
    ACTIONS(11945), 1,
      sym_dot_dot_i,
    ACTIONS(11947), 1,
      sym__newline,
    STATE(64), 1,
      sym__open_parenthesis,
    STATE(199), 1,
      sym__open_brace,
    STATE(2309), 1,
      sym__double_quoted_string,
    STATE(2310), 1,
      sym__single_quoted_string,
    STATE(2312), 1,
      sym_string,
    STATE(3828), 1,
      aux_sym_function_definition_repeat1,
    STATE(5134), 1,
      sym__string_or_identifier,
    ACTIONS(1405), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2311), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1419), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11943), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1038), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [105780] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1385), 1,
      sym_identifier,
    ACTIONS(1387), 1,
      anon_sym_BSLASH,
    ACTIONS(1389), 1,
      anon_sym_function,
    ACTIONS(1391), 1,
      anon_sym_if,
    ACTIONS(1393), 1,
      anon_sym_for,
    ACTIONS(1395), 1,
      anon_sym_while,
    ACTIONS(1397), 1,
      anon_sym_repeat,
    ACTIONS(1399), 1,
      anon_sym_QMARK,
    ACTIONS(1401), 1,
      anon_sym_TILDE,
    ACTIONS(1409), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1411), 1,
      sym__number_literal,
    ACTIONS(1413), 1,
      anon_sym_SQUOTE,
    ACTIONS(1415), 1,
      anon_sym_DQUOTE,
    ACTIONS(1425), 1,
      sym__raw_string_literal,
    ACTIONS(1427), 1,
      sym__external_open_parenthesis,
    ACTIONS(1429), 1,
      sym__external_open_brace,
    ACTIONS(9251), 1,
      anon_sym_BANG,
    ACTIONS(11951), 1,
      sym_dot_dot_i,
    ACTIONS(11953), 1,
      sym__newline,
    STATE(64), 1,
      sym__open_parenthesis,
    STATE(199), 1,
      sym__open_brace,
    STATE(2309), 1,
      sym__double_quoted_string,
    STATE(2310), 1,
      sym__single_quoted_string,
    STATE(2312), 1,
      sym_string,
    STATE(3829), 1,
      aux_sym_function_definition_repeat1,
    STATE(5134), 1,
      sym__string_or_identifier,
    ACTIONS(1405), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2311), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1419), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11949), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1037), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [105909] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1385), 1,
      sym_identifier,
    ACTIONS(1387), 1,
      anon_sym_BSLASH,
    ACTIONS(1389), 1,
      anon_sym_function,
    ACTIONS(1391), 1,
      anon_sym_if,
    ACTIONS(1393), 1,
      anon_sym_for,
    ACTIONS(1395), 1,
      anon_sym_while,
    ACTIONS(1397), 1,
      anon_sym_repeat,
    ACTIONS(1399), 1,
      anon_sym_QMARK,
    ACTIONS(1401), 1,
      anon_sym_TILDE,
    ACTIONS(1409), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1411), 1,
      sym__number_literal,
    ACTIONS(1413), 1,
      anon_sym_SQUOTE,
    ACTIONS(1415), 1,
      anon_sym_DQUOTE,
    ACTIONS(1425), 1,
      sym__raw_string_literal,
    ACTIONS(1427), 1,
      sym__external_open_parenthesis,
    ACTIONS(1429), 1,
      sym__external_open_brace,
    ACTIONS(9251), 1,
      anon_sym_BANG,
    ACTIONS(11957), 1,
      sym_dot_dot_i,
    ACTIONS(11959), 1,
      sym__newline,
    STATE(64), 1,
      sym__open_parenthesis,
    STATE(199), 1,
      sym__open_brace,
    STATE(2309), 1,
      sym__double_quoted_string,
    STATE(2310), 1,
      sym__single_quoted_string,
    STATE(2312), 1,
      sym_string,
    STATE(3832), 1,
      aux_sym_function_definition_repeat1,
    STATE(5134), 1,
      sym__string_or_identifier,
    ACTIONS(1405), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2311), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1419), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11955), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1036), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [106038] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1385), 1,
      sym_identifier,
    ACTIONS(1387), 1,
      anon_sym_BSLASH,
    ACTIONS(1389), 1,
      anon_sym_function,
    ACTIONS(1391), 1,
      anon_sym_if,
    ACTIONS(1393), 1,
      anon_sym_for,
    ACTIONS(1395), 1,
      anon_sym_while,
    ACTIONS(1397), 1,
      anon_sym_repeat,
    ACTIONS(1399), 1,
      anon_sym_QMARK,
    ACTIONS(1401), 1,
      anon_sym_TILDE,
    ACTIONS(1409), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1411), 1,
      sym__number_literal,
    ACTIONS(1413), 1,
      anon_sym_SQUOTE,
    ACTIONS(1415), 1,
      anon_sym_DQUOTE,
    ACTIONS(1425), 1,
      sym__raw_string_literal,
    ACTIONS(1427), 1,
      sym__external_open_parenthesis,
    ACTIONS(1429), 1,
      sym__external_open_brace,
    ACTIONS(9251), 1,
      anon_sym_BANG,
    ACTIONS(11963), 1,
      sym_dot_dot_i,
    ACTIONS(11965), 1,
      sym__newline,
    STATE(64), 1,
      sym__open_parenthesis,
    STATE(199), 1,
      sym__open_brace,
    STATE(2309), 1,
      sym__double_quoted_string,
    STATE(2310), 1,
      sym__single_quoted_string,
    STATE(2312), 1,
      sym_string,
    STATE(3715), 1,
      aux_sym_function_definition_repeat1,
    STATE(5134), 1,
      sym__string_or_identifier,
    ACTIONS(1405), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2311), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1419), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11961), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1035), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [106167] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4053), 1,
      sym_identifier,
    ACTIONS(4055), 1,
      anon_sym_BSLASH,
    ACTIONS(4057), 1,
      anon_sym_function,
    ACTIONS(4059), 1,
      anon_sym_if,
    ACTIONS(4061), 1,
      anon_sym_for,
    ACTIONS(4063), 1,
      anon_sym_while,
    ACTIONS(4065), 1,
      anon_sym_repeat,
    ACTIONS(4067), 1,
      anon_sym_QMARK,
    ACTIONS(4069), 1,
      anon_sym_TILDE,
    ACTIONS(4077), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4079), 1,
      sym__number_literal,
    ACTIONS(4081), 1,
      anon_sym_SQUOTE,
    ACTIONS(4083), 1,
      anon_sym_DQUOTE,
    ACTIONS(4093), 1,
      sym__raw_string_literal,
    ACTIONS(4095), 1,
      sym__external_open_parenthesis,
    ACTIONS(4097), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7821), 1,
      anon_sym_BANG,
    ACTIONS(11969), 1,
      sym_dot_dot_i,
    STATE(133), 1,
      sym__open_brace,
    STATE(150), 1,
      sym__open_parenthesis,
    STATE(2534), 1,
      sym_string,
    STATE(2538), 1,
      sym__single_quoted_string,
    STATE(2539), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5143), 1,
      sym__string_or_identifier,
    ACTIONS(4073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2536), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4087), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11967), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1835), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [106296] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2826), 1,
      sym_identifier,
    ACTIONS(2828), 1,
      anon_sym_BSLASH,
    ACTIONS(2830), 1,
      anon_sym_function,
    ACTIONS(2832), 1,
      anon_sym_if,
    ACTIONS(2834), 1,
      anon_sym_for,
    ACTIONS(2836), 1,
      anon_sym_while,
    ACTIONS(2838), 1,
      anon_sym_repeat,
    ACTIONS(2840), 1,
      anon_sym_QMARK,
    ACTIONS(2842), 1,
      anon_sym_TILDE,
    ACTIONS(2850), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2852), 1,
      sym__number_literal,
    ACTIONS(2854), 1,
      anon_sym_SQUOTE,
    ACTIONS(2856), 1,
      anon_sym_DQUOTE,
    ACTIONS(2866), 1,
      sym__raw_string_literal,
    ACTIONS(2868), 1,
      sym__external_open_parenthesis,
    ACTIONS(2870), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(10915), 1,
      anon_sym_BANG,
    ACTIONS(11973), 1,
      sym_dot_dot_i,
    STATE(178), 1,
      sym__open_parenthesis,
    STATE(244), 1,
      sym__open_brace,
    STATE(2522), 1,
      sym_string,
    STATE(2528), 1,
      sym__single_quoted_string,
    STATE(2529), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5126), 1,
      sym__string_or_identifier,
    ACTIONS(2846), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2523), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2860), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11971), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1391), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [106425] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4642), 1,
      sym_identifier,
    ACTIONS(4644), 1,
      anon_sym_BSLASH,
    ACTIONS(4646), 1,
      anon_sym_function,
    ACTIONS(4648), 1,
      anon_sym_if,
    ACTIONS(4650), 1,
      anon_sym_for,
    ACTIONS(4652), 1,
      anon_sym_while,
    ACTIONS(4654), 1,
      anon_sym_repeat,
    ACTIONS(4656), 1,
      anon_sym_QMARK,
    ACTIONS(4658), 1,
      anon_sym_TILDE,
    ACTIONS(4666), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4668), 1,
      sym__number_literal,
    ACTIONS(4670), 1,
      anon_sym_SQUOTE,
    ACTIONS(4672), 1,
      anon_sym_DQUOTE,
    ACTIONS(4680), 1,
      sym__raw_string_literal,
    ACTIONS(4682), 1,
      sym__external_open_parenthesis,
    ACTIONS(4684), 1,
      sym__external_open_brace,
    ACTIONS(6371), 1,
      anon_sym_BANG,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(11977), 1,
      sym_dot_dot_i,
    STATE(185), 1,
      sym__open_brace,
    STATE(218), 1,
      sym__open_parenthesis,
    STATE(2649), 1,
      sym__double_quoted_string,
    STATE(2654), 1,
      sym__single_quoted_string,
    STATE(2744), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5141), 1,
      sym__string_or_identifier,
    ACTIONS(4662), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2656), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4676), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11975), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2069), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [106554] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4642), 1,
      sym_identifier,
    ACTIONS(4644), 1,
      anon_sym_BSLASH,
    ACTIONS(4646), 1,
      anon_sym_function,
    ACTIONS(4648), 1,
      anon_sym_if,
    ACTIONS(4650), 1,
      anon_sym_for,
    ACTIONS(4652), 1,
      anon_sym_while,
    ACTIONS(4654), 1,
      anon_sym_repeat,
    ACTIONS(4656), 1,
      anon_sym_QMARK,
    ACTIONS(4658), 1,
      anon_sym_TILDE,
    ACTIONS(4666), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4668), 1,
      sym__number_literal,
    ACTIONS(4670), 1,
      anon_sym_SQUOTE,
    ACTIONS(4672), 1,
      anon_sym_DQUOTE,
    ACTIONS(4680), 1,
      sym__raw_string_literal,
    ACTIONS(4682), 1,
      sym__external_open_parenthesis,
    ACTIONS(4684), 1,
      sym__external_open_brace,
    ACTIONS(6371), 1,
      anon_sym_BANG,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(11981), 1,
      sym_dot_dot_i,
    STATE(185), 1,
      sym__open_brace,
    STATE(218), 1,
      sym__open_parenthesis,
    STATE(2649), 1,
      sym__double_quoted_string,
    STATE(2654), 1,
      sym__single_quoted_string,
    STATE(2744), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5141), 1,
      sym__string_or_identifier,
    ACTIONS(4662), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2656), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4676), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11979), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1913), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [106683] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4752), 1,
      sym_identifier,
    ACTIONS(4754), 1,
      anon_sym_BSLASH,
    ACTIONS(4756), 1,
      anon_sym_function,
    ACTIONS(4758), 1,
      anon_sym_if,
    ACTIONS(4760), 1,
      anon_sym_for,
    ACTIONS(4762), 1,
      anon_sym_while,
    ACTIONS(4764), 1,
      anon_sym_repeat,
    ACTIONS(4766), 1,
      anon_sym_QMARK,
    ACTIONS(4768), 1,
      anon_sym_TILDE,
    ACTIONS(4776), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4778), 1,
      sym__number_literal,
    ACTIONS(4780), 1,
      anon_sym_SQUOTE,
    ACTIONS(4782), 1,
      anon_sym_DQUOTE,
    ACTIONS(4790), 1,
      sym__raw_string_literal,
    ACTIONS(4792), 1,
      sym__external_open_parenthesis,
    ACTIONS(4794), 1,
      sym__external_open_brace,
    ACTIONS(6353), 1,
      anon_sym_BANG,
    ACTIONS(11985), 1,
      sym_dot_dot_i,
    ACTIONS(11987), 1,
      sym__newline,
    STATE(192), 1,
      sym__open_brace,
    STATE(214), 1,
      sym__open_parenthesis,
    STATE(2664), 1,
      sym_string,
    STATE(2701), 1,
      sym__single_quoted_string,
    STATE(2745), 1,
      sym__double_quoted_string,
    STATE(3895), 1,
      aux_sym_function_definition_repeat1,
    STATE(5148), 1,
      sym__string_or_identifier,
    ACTIONS(4772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2700), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4786), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11983), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2160), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [106812] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4642), 1,
      sym_identifier,
    ACTIONS(4644), 1,
      anon_sym_BSLASH,
    ACTIONS(4646), 1,
      anon_sym_function,
    ACTIONS(4648), 1,
      anon_sym_if,
    ACTIONS(4650), 1,
      anon_sym_for,
    ACTIONS(4652), 1,
      anon_sym_while,
    ACTIONS(4654), 1,
      anon_sym_repeat,
    ACTIONS(4656), 1,
      anon_sym_QMARK,
    ACTIONS(4658), 1,
      anon_sym_TILDE,
    ACTIONS(4666), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4668), 1,
      sym__number_literal,
    ACTIONS(4670), 1,
      anon_sym_SQUOTE,
    ACTIONS(4672), 1,
      anon_sym_DQUOTE,
    ACTIONS(4680), 1,
      sym__raw_string_literal,
    ACTIONS(4682), 1,
      sym__external_open_parenthesis,
    ACTIONS(4684), 1,
      sym__external_open_brace,
    ACTIONS(6371), 1,
      anon_sym_BANG,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(11991), 1,
      sym_dot_dot_i,
    STATE(185), 1,
      sym__open_brace,
    STATE(218), 1,
      sym__open_parenthesis,
    STATE(2649), 1,
      sym__double_quoted_string,
    STATE(2654), 1,
      sym__single_quoted_string,
    STATE(2744), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5141), 1,
      sym__string_or_identifier,
    ACTIONS(4662), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2656), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4676), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11989), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1914), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [106941] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4642), 1,
      sym_identifier,
    ACTIONS(4644), 1,
      anon_sym_BSLASH,
    ACTIONS(4646), 1,
      anon_sym_function,
    ACTIONS(4648), 1,
      anon_sym_if,
    ACTIONS(4650), 1,
      anon_sym_for,
    ACTIONS(4652), 1,
      anon_sym_while,
    ACTIONS(4654), 1,
      anon_sym_repeat,
    ACTIONS(4656), 1,
      anon_sym_QMARK,
    ACTIONS(4658), 1,
      anon_sym_TILDE,
    ACTIONS(4666), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4668), 1,
      sym__number_literal,
    ACTIONS(4670), 1,
      anon_sym_SQUOTE,
    ACTIONS(4672), 1,
      anon_sym_DQUOTE,
    ACTIONS(4680), 1,
      sym__raw_string_literal,
    ACTIONS(4682), 1,
      sym__external_open_parenthesis,
    ACTIONS(4684), 1,
      sym__external_open_brace,
    ACTIONS(6371), 1,
      anon_sym_BANG,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(11995), 1,
      sym_dot_dot_i,
    STATE(185), 1,
      sym__open_brace,
    STATE(218), 1,
      sym__open_parenthesis,
    STATE(2649), 1,
      sym__double_quoted_string,
    STATE(2654), 1,
      sym__single_quoted_string,
    STATE(2744), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5141), 1,
      sym__string_or_identifier,
    ACTIONS(4662), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2656), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4676), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11993), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1915), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [107070] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4752), 1,
      sym_identifier,
    ACTIONS(4754), 1,
      anon_sym_BSLASH,
    ACTIONS(4756), 1,
      anon_sym_function,
    ACTIONS(4758), 1,
      anon_sym_if,
    ACTIONS(4760), 1,
      anon_sym_for,
    ACTIONS(4762), 1,
      anon_sym_while,
    ACTIONS(4764), 1,
      anon_sym_repeat,
    ACTIONS(4766), 1,
      anon_sym_QMARK,
    ACTIONS(4768), 1,
      anon_sym_TILDE,
    ACTIONS(4776), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4778), 1,
      sym__number_literal,
    ACTIONS(4780), 1,
      anon_sym_SQUOTE,
    ACTIONS(4782), 1,
      anon_sym_DQUOTE,
    ACTIONS(4790), 1,
      sym__raw_string_literal,
    ACTIONS(4792), 1,
      sym__external_open_parenthesis,
    ACTIONS(4794), 1,
      sym__external_open_brace,
    ACTIONS(6353), 1,
      anon_sym_BANG,
    ACTIONS(11999), 1,
      sym_dot_dot_i,
    ACTIONS(12001), 1,
      sym__newline,
    STATE(192), 1,
      sym__open_brace,
    STATE(214), 1,
      sym__open_parenthesis,
    STATE(2664), 1,
      sym_string,
    STATE(2701), 1,
      sym__single_quoted_string,
    STATE(2745), 1,
      sym__double_quoted_string,
    STATE(3898), 1,
      aux_sym_function_definition_repeat1,
    STATE(5148), 1,
      sym__string_or_identifier,
    ACTIONS(4772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2700), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4786), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(11997), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2158), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [107199] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(273), 1,
      sym_identifier,
    ACTIONS(275), 1,
      anon_sym_BSLASH,
    ACTIONS(277), 1,
      anon_sym_function,
    ACTIONS(279), 1,
      anon_sym_if,
    ACTIONS(281), 1,
      anon_sym_for,
    ACTIONS(283), 1,
      anon_sym_while,
    ACTIONS(285), 1,
      anon_sym_repeat,
    ACTIONS(287), 1,
      anon_sym_QMARK,
    ACTIONS(289), 1,
      anon_sym_TILDE,
    ACTIONS(297), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(299), 1,
      sym__number_literal,
    ACTIONS(301), 1,
      anon_sym_SQUOTE,
    ACTIONS(303), 1,
      anon_sym_DQUOTE,
    ACTIONS(313), 1,
      sym__raw_string_literal,
    ACTIONS(315), 1,
      sym__external_open_parenthesis,
    ACTIONS(319), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(11159), 1,
      anon_sym_BANG,
    ACTIONS(12005), 1,
      sym_dot_dot_i,
    STATE(57), 1,
      sym__open_parenthesis,
    STATE(59), 1,
      sym__open_brace,
    STATE(2187), 1,
      sym__double_quoted_string,
    STATE(2188), 1,
      sym__single_quoted_string,
    STATE(2192), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5139), 1,
      sym__string_or_identifier,
    ACTIONS(293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2189), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(307), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12003), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(708), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [107328] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(273), 1,
      sym_identifier,
    ACTIONS(275), 1,
      anon_sym_BSLASH,
    ACTIONS(277), 1,
      anon_sym_function,
    ACTIONS(279), 1,
      anon_sym_if,
    ACTIONS(281), 1,
      anon_sym_for,
    ACTIONS(283), 1,
      anon_sym_while,
    ACTIONS(285), 1,
      anon_sym_repeat,
    ACTIONS(287), 1,
      anon_sym_QMARK,
    ACTIONS(289), 1,
      anon_sym_TILDE,
    ACTIONS(297), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(299), 1,
      sym__number_literal,
    ACTIONS(301), 1,
      anon_sym_SQUOTE,
    ACTIONS(303), 1,
      anon_sym_DQUOTE,
    ACTIONS(313), 1,
      sym__raw_string_literal,
    ACTIONS(315), 1,
      sym__external_open_parenthesis,
    ACTIONS(319), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(11159), 1,
      anon_sym_BANG,
    ACTIONS(12009), 1,
      sym_dot_dot_i,
    STATE(57), 1,
      sym__open_parenthesis,
    STATE(59), 1,
      sym__open_brace,
    STATE(2187), 1,
      sym__double_quoted_string,
    STATE(2188), 1,
      sym__single_quoted_string,
    STATE(2192), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5139), 1,
      sym__string_or_identifier,
    ACTIONS(293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2189), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(307), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12007), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(709), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [107457] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4752), 1,
      sym_identifier,
    ACTIONS(4754), 1,
      anon_sym_BSLASH,
    ACTIONS(4756), 1,
      anon_sym_function,
    ACTIONS(4758), 1,
      anon_sym_if,
    ACTIONS(4760), 1,
      anon_sym_for,
    ACTIONS(4762), 1,
      anon_sym_while,
    ACTIONS(4764), 1,
      anon_sym_repeat,
    ACTIONS(4766), 1,
      anon_sym_QMARK,
    ACTIONS(4768), 1,
      anon_sym_TILDE,
    ACTIONS(4776), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4778), 1,
      sym__number_literal,
    ACTIONS(4780), 1,
      anon_sym_SQUOTE,
    ACTIONS(4782), 1,
      anon_sym_DQUOTE,
    ACTIONS(4790), 1,
      sym__raw_string_literal,
    ACTIONS(4792), 1,
      sym__external_open_parenthesis,
    ACTIONS(4794), 1,
      sym__external_open_brace,
    ACTIONS(6353), 1,
      anon_sym_BANG,
    ACTIONS(12013), 1,
      sym_dot_dot_i,
    ACTIONS(12015), 1,
      sym__newline,
    STATE(192), 1,
      sym__open_brace,
    STATE(214), 1,
      sym__open_parenthesis,
    STATE(2664), 1,
      sym_string,
    STATE(2701), 1,
      sym__single_quoted_string,
    STATE(2745), 1,
      sym__double_quoted_string,
    STATE(3916), 1,
      aux_sym_function_definition_repeat1,
    STATE(5148), 1,
      sym__string_or_identifier,
    ACTIONS(4772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2700), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4786), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12011), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2151), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [107586] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1337), 1,
      sym_identifier,
    ACTIONS(1339), 1,
      anon_sym_BSLASH,
    ACTIONS(1341), 1,
      anon_sym_function,
    ACTIONS(1343), 1,
      anon_sym_if,
    ACTIONS(1345), 1,
      anon_sym_for,
    ACTIONS(1347), 1,
      anon_sym_while,
    ACTIONS(1349), 1,
      anon_sym_repeat,
    ACTIONS(1351), 1,
      anon_sym_QMARK,
    ACTIONS(1353), 1,
      anon_sym_TILDE,
    ACTIONS(1361), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1363), 1,
      sym__number_literal,
    ACTIONS(1365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1367), 1,
      anon_sym_DQUOTE,
    ACTIONS(1377), 1,
      sym__raw_string_literal,
    ACTIONS(1379), 1,
      sym__external_open_parenthesis,
    ACTIONS(1383), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9409), 1,
      anon_sym_BANG,
    ACTIONS(12019), 1,
      sym_dot_dot_i,
    STATE(94), 1,
      sym__open_brace,
    STATE(190), 1,
      sym__open_parenthesis,
    STATE(2231), 1,
      sym_string,
    STATE(2354), 1,
      sym__double_quoted_string,
    STATE(2355), 1,
      sym__single_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5156), 1,
      sym__string_or_identifier,
    ACTIONS(1357), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2356), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1371), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12017), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(775), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [107715] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4752), 1,
      sym_identifier,
    ACTIONS(4754), 1,
      anon_sym_BSLASH,
    ACTIONS(4756), 1,
      anon_sym_function,
    ACTIONS(4758), 1,
      anon_sym_if,
    ACTIONS(4760), 1,
      anon_sym_for,
    ACTIONS(4762), 1,
      anon_sym_while,
    ACTIONS(4764), 1,
      anon_sym_repeat,
    ACTIONS(4766), 1,
      anon_sym_QMARK,
    ACTIONS(4768), 1,
      anon_sym_TILDE,
    ACTIONS(4776), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4778), 1,
      sym__number_literal,
    ACTIONS(4780), 1,
      anon_sym_SQUOTE,
    ACTIONS(4782), 1,
      anon_sym_DQUOTE,
    ACTIONS(4790), 1,
      sym__raw_string_literal,
    ACTIONS(4792), 1,
      sym__external_open_parenthesis,
    ACTIONS(4794), 1,
      sym__external_open_brace,
    ACTIONS(6353), 1,
      anon_sym_BANG,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(12023), 1,
      sym_dot_dot_i,
    STATE(192), 1,
      sym__open_brace,
    STATE(214), 1,
      sym__open_parenthesis,
    STATE(2664), 1,
      sym_string,
    STATE(2701), 1,
      sym__single_quoted_string,
    STATE(2745), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5148), 1,
      sym__string_or_identifier,
    ACTIONS(4772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2700), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4786), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12021), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2091), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [107844] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4053), 1,
      sym_identifier,
    ACTIONS(4055), 1,
      anon_sym_BSLASH,
    ACTIONS(4057), 1,
      anon_sym_function,
    ACTIONS(4059), 1,
      anon_sym_if,
    ACTIONS(4061), 1,
      anon_sym_for,
    ACTIONS(4063), 1,
      anon_sym_while,
    ACTIONS(4065), 1,
      anon_sym_repeat,
    ACTIONS(4067), 1,
      anon_sym_QMARK,
    ACTIONS(4069), 1,
      anon_sym_TILDE,
    ACTIONS(4077), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4079), 1,
      sym__number_literal,
    ACTIONS(4081), 1,
      anon_sym_SQUOTE,
    ACTIONS(4083), 1,
      anon_sym_DQUOTE,
    ACTIONS(4093), 1,
      sym__raw_string_literal,
    ACTIONS(4095), 1,
      sym__external_open_parenthesis,
    ACTIONS(4097), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7821), 1,
      anon_sym_BANG,
    ACTIONS(12027), 1,
      sym_dot_dot_i,
    STATE(133), 1,
      sym__open_brace,
    STATE(150), 1,
      sym__open_parenthesis,
    STATE(2534), 1,
      sym_string,
    STATE(2538), 1,
      sym__single_quoted_string,
    STATE(2539), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5143), 1,
      sym__string_or_identifier,
    ACTIONS(4073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2536), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4087), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12025), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1834), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [107973] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(273), 1,
      sym_identifier,
    ACTIONS(275), 1,
      anon_sym_BSLASH,
    ACTIONS(277), 1,
      anon_sym_function,
    ACTIONS(279), 1,
      anon_sym_if,
    ACTIONS(281), 1,
      anon_sym_for,
    ACTIONS(283), 1,
      anon_sym_while,
    ACTIONS(285), 1,
      anon_sym_repeat,
    ACTIONS(287), 1,
      anon_sym_QMARK,
    ACTIONS(289), 1,
      anon_sym_TILDE,
    ACTIONS(297), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(299), 1,
      sym__number_literal,
    ACTIONS(301), 1,
      anon_sym_SQUOTE,
    ACTIONS(303), 1,
      anon_sym_DQUOTE,
    ACTIONS(313), 1,
      sym__raw_string_literal,
    ACTIONS(315), 1,
      sym__external_open_parenthesis,
    ACTIONS(319), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(11159), 1,
      anon_sym_BANG,
    ACTIONS(12031), 1,
      sym_dot_dot_i,
    STATE(57), 1,
      sym__open_parenthesis,
    STATE(59), 1,
      sym__open_brace,
    STATE(2187), 1,
      sym__double_quoted_string,
    STATE(2188), 1,
      sym__single_quoted_string,
    STATE(2192), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5139), 1,
      sym__string_or_identifier,
    ACTIONS(293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2189), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(307), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12029), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(710), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [108102] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4053), 1,
      sym_identifier,
    ACTIONS(4055), 1,
      anon_sym_BSLASH,
    ACTIONS(4057), 1,
      anon_sym_function,
    ACTIONS(4059), 1,
      anon_sym_if,
    ACTIONS(4061), 1,
      anon_sym_for,
    ACTIONS(4063), 1,
      anon_sym_while,
    ACTIONS(4065), 1,
      anon_sym_repeat,
    ACTIONS(4067), 1,
      anon_sym_QMARK,
    ACTIONS(4069), 1,
      anon_sym_TILDE,
    ACTIONS(4077), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4079), 1,
      sym__number_literal,
    ACTIONS(4081), 1,
      anon_sym_SQUOTE,
    ACTIONS(4083), 1,
      anon_sym_DQUOTE,
    ACTIONS(4093), 1,
      sym__raw_string_literal,
    ACTIONS(4095), 1,
      sym__external_open_parenthesis,
    ACTIONS(4097), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7821), 1,
      anon_sym_BANG,
    ACTIONS(12035), 1,
      sym_dot_dot_i,
    STATE(133), 1,
      sym__open_brace,
    STATE(150), 1,
      sym__open_parenthesis,
    STATE(2534), 1,
      sym_string,
    STATE(2538), 1,
      sym__single_quoted_string,
    STATE(2539), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5143), 1,
      sym__string_or_identifier,
    ACTIONS(4073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2536), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4087), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12033), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1832), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [108231] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(273), 1,
      sym_identifier,
    ACTIONS(275), 1,
      anon_sym_BSLASH,
    ACTIONS(277), 1,
      anon_sym_function,
    ACTIONS(279), 1,
      anon_sym_if,
    ACTIONS(281), 1,
      anon_sym_for,
    ACTIONS(283), 1,
      anon_sym_while,
    ACTIONS(285), 1,
      anon_sym_repeat,
    ACTIONS(287), 1,
      anon_sym_QMARK,
    ACTIONS(289), 1,
      anon_sym_TILDE,
    ACTIONS(297), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(299), 1,
      sym__number_literal,
    ACTIONS(301), 1,
      anon_sym_SQUOTE,
    ACTIONS(303), 1,
      anon_sym_DQUOTE,
    ACTIONS(313), 1,
      sym__raw_string_literal,
    ACTIONS(315), 1,
      sym__external_open_parenthesis,
    ACTIONS(319), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(11159), 1,
      anon_sym_BANG,
    ACTIONS(12039), 1,
      sym_dot_dot_i,
    STATE(57), 1,
      sym__open_parenthesis,
    STATE(59), 1,
      sym__open_brace,
    STATE(2187), 1,
      sym__double_quoted_string,
    STATE(2188), 1,
      sym__single_quoted_string,
    STATE(2192), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5139), 1,
      sym__string_or_identifier,
    ACTIONS(293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2189), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(307), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12037), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(711), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [108360] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4053), 1,
      sym_identifier,
    ACTIONS(4055), 1,
      anon_sym_BSLASH,
    ACTIONS(4057), 1,
      anon_sym_function,
    ACTIONS(4059), 1,
      anon_sym_if,
    ACTIONS(4061), 1,
      anon_sym_for,
    ACTIONS(4063), 1,
      anon_sym_while,
    ACTIONS(4065), 1,
      anon_sym_repeat,
    ACTIONS(4067), 1,
      anon_sym_QMARK,
    ACTIONS(4069), 1,
      anon_sym_TILDE,
    ACTIONS(4077), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4079), 1,
      sym__number_literal,
    ACTIONS(4081), 1,
      anon_sym_SQUOTE,
    ACTIONS(4083), 1,
      anon_sym_DQUOTE,
    ACTIONS(4093), 1,
      sym__raw_string_literal,
    ACTIONS(4095), 1,
      sym__external_open_parenthesis,
    ACTIONS(4097), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7821), 1,
      anon_sym_BANG,
    ACTIONS(12043), 1,
      sym_dot_dot_i,
    STATE(133), 1,
      sym__open_brace,
    STATE(150), 1,
      sym__open_parenthesis,
    STATE(2534), 1,
      sym_string,
    STATE(2538), 1,
      sym__single_quoted_string,
    STATE(2539), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5143), 1,
      sym__string_or_identifier,
    ACTIONS(4073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2536), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4087), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12041), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1831), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [108489] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1337), 1,
      sym_identifier,
    ACTIONS(1339), 1,
      anon_sym_BSLASH,
    ACTIONS(1341), 1,
      anon_sym_function,
    ACTIONS(1343), 1,
      anon_sym_if,
    ACTIONS(1345), 1,
      anon_sym_for,
    ACTIONS(1347), 1,
      anon_sym_while,
    ACTIONS(1349), 1,
      anon_sym_repeat,
    ACTIONS(1351), 1,
      anon_sym_QMARK,
    ACTIONS(1353), 1,
      anon_sym_TILDE,
    ACTIONS(1361), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1363), 1,
      sym__number_literal,
    ACTIONS(1365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1367), 1,
      anon_sym_DQUOTE,
    ACTIONS(1377), 1,
      sym__raw_string_literal,
    ACTIONS(1379), 1,
      sym__external_open_parenthesis,
    ACTIONS(1383), 1,
      sym__external_open_brace,
    ACTIONS(9409), 1,
      anon_sym_BANG,
    ACTIONS(12047), 1,
      sym_dot_dot_i,
    ACTIONS(12049), 1,
      sym__newline,
    STATE(94), 1,
      sym__open_brace,
    STATE(190), 1,
      sym__open_parenthesis,
    STATE(2231), 1,
      sym_string,
    STATE(2354), 1,
      sym__double_quoted_string,
    STATE(2355), 1,
      sym__single_quoted_string,
    STATE(3862), 1,
      aux_sym_function_definition_repeat1,
    STATE(5156), 1,
      sym__string_or_identifier,
    ACTIONS(1357), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2356), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1371), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12045), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(776), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [108618] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4053), 1,
      sym_identifier,
    ACTIONS(4055), 1,
      anon_sym_BSLASH,
    ACTIONS(4057), 1,
      anon_sym_function,
    ACTIONS(4059), 1,
      anon_sym_if,
    ACTIONS(4061), 1,
      anon_sym_for,
    ACTIONS(4063), 1,
      anon_sym_while,
    ACTIONS(4065), 1,
      anon_sym_repeat,
    ACTIONS(4067), 1,
      anon_sym_QMARK,
    ACTIONS(4069), 1,
      anon_sym_TILDE,
    ACTIONS(4077), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4079), 1,
      sym__number_literal,
    ACTIONS(4081), 1,
      anon_sym_SQUOTE,
    ACTIONS(4083), 1,
      anon_sym_DQUOTE,
    ACTIONS(4093), 1,
      sym__raw_string_literal,
    ACTIONS(4095), 1,
      sym__external_open_parenthesis,
    ACTIONS(4097), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7821), 1,
      anon_sym_BANG,
    ACTIONS(12053), 1,
      sym_dot_dot_i,
    STATE(133), 1,
      sym__open_brace,
    STATE(150), 1,
      sym__open_parenthesis,
    STATE(2534), 1,
      sym_string,
    STATE(2538), 1,
      sym__single_quoted_string,
    STATE(2539), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5143), 1,
      sym__string_or_identifier,
    ACTIONS(4073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2536), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4087), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12051), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1830), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [108747] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4642), 1,
      sym_identifier,
    ACTIONS(4644), 1,
      anon_sym_BSLASH,
    ACTIONS(4646), 1,
      anon_sym_function,
    ACTIONS(4648), 1,
      anon_sym_if,
    ACTIONS(4650), 1,
      anon_sym_for,
    ACTIONS(4652), 1,
      anon_sym_while,
    ACTIONS(4654), 1,
      anon_sym_repeat,
    ACTIONS(4656), 1,
      anon_sym_QMARK,
    ACTIONS(4658), 1,
      anon_sym_TILDE,
    ACTIONS(4666), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4668), 1,
      sym__number_literal,
    ACTIONS(4670), 1,
      anon_sym_SQUOTE,
    ACTIONS(4672), 1,
      anon_sym_DQUOTE,
    ACTIONS(4680), 1,
      sym__raw_string_literal,
    ACTIONS(4682), 1,
      sym__external_open_parenthesis,
    ACTIONS(4684), 1,
      sym__external_open_brace,
    ACTIONS(6371), 1,
      anon_sym_BANG,
    ACTIONS(12057), 1,
      sym_dot_dot_i,
    ACTIONS(12059), 1,
      sym__newline,
    STATE(185), 1,
      sym__open_brace,
    STATE(218), 1,
      sym__open_parenthesis,
    STATE(2649), 1,
      sym__double_quoted_string,
    STATE(2654), 1,
      sym__single_quoted_string,
    STATE(2744), 1,
      sym_string,
    STATE(3853), 1,
      aux_sym_function_definition_repeat1,
    STATE(5141), 1,
      sym__string_or_identifier,
    ACTIONS(4662), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2656), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4676), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12055), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1961), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [108876] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1337), 1,
      sym_identifier,
    ACTIONS(1339), 1,
      anon_sym_BSLASH,
    ACTIONS(1341), 1,
      anon_sym_function,
    ACTIONS(1343), 1,
      anon_sym_if,
    ACTIONS(1345), 1,
      anon_sym_for,
    ACTIONS(1347), 1,
      anon_sym_while,
    ACTIONS(1349), 1,
      anon_sym_repeat,
    ACTIONS(1351), 1,
      anon_sym_QMARK,
    ACTIONS(1353), 1,
      anon_sym_TILDE,
    ACTIONS(1361), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1363), 1,
      sym__number_literal,
    ACTIONS(1365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1367), 1,
      anon_sym_DQUOTE,
    ACTIONS(1377), 1,
      sym__raw_string_literal,
    ACTIONS(1379), 1,
      sym__external_open_parenthesis,
    ACTIONS(1383), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9409), 1,
      anon_sym_BANG,
    ACTIONS(12063), 1,
      sym_dot_dot_i,
    STATE(94), 1,
      sym__open_brace,
    STATE(190), 1,
      sym__open_parenthesis,
    STATE(2231), 1,
      sym_string,
    STATE(2354), 1,
      sym__double_quoted_string,
    STATE(2355), 1,
      sym__single_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5156), 1,
      sym__string_or_identifier,
    ACTIONS(1357), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2356), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1371), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12061), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(777), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [109005] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4642), 1,
      sym_identifier,
    ACTIONS(4644), 1,
      anon_sym_BSLASH,
    ACTIONS(4646), 1,
      anon_sym_function,
    ACTIONS(4648), 1,
      anon_sym_if,
    ACTIONS(4650), 1,
      anon_sym_for,
    ACTIONS(4652), 1,
      anon_sym_while,
    ACTIONS(4654), 1,
      anon_sym_repeat,
    ACTIONS(4656), 1,
      anon_sym_QMARK,
    ACTIONS(4658), 1,
      anon_sym_TILDE,
    ACTIONS(4666), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4668), 1,
      sym__number_literal,
    ACTIONS(4670), 1,
      anon_sym_SQUOTE,
    ACTIONS(4672), 1,
      anon_sym_DQUOTE,
    ACTIONS(4680), 1,
      sym__raw_string_literal,
    ACTIONS(4682), 1,
      sym__external_open_parenthesis,
    ACTIONS(4684), 1,
      sym__external_open_brace,
    ACTIONS(6371), 1,
      anon_sym_BANG,
    ACTIONS(12067), 1,
      sym_dot_dot_i,
    ACTIONS(12069), 1,
      sym__newline,
    STATE(185), 1,
      sym__open_brace,
    STATE(218), 1,
      sym__open_parenthesis,
    STATE(2649), 1,
      sym__double_quoted_string,
    STATE(2654), 1,
      sym__single_quoted_string,
    STATE(2744), 1,
      sym_string,
    STATE(3854), 1,
      aux_sym_function_definition_repeat1,
    STATE(5141), 1,
      sym__string_or_identifier,
    ACTIONS(4662), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2656), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4676), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12065), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1963), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [109134] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4642), 1,
      sym_identifier,
    ACTIONS(4644), 1,
      anon_sym_BSLASH,
    ACTIONS(4646), 1,
      anon_sym_function,
    ACTIONS(4648), 1,
      anon_sym_if,
    ACTIONS(4650), 1,
      anon_sym_for,
    ACTIONS(4652), 1,
      anon_sym_while,
    ACTIONS(4654), 1,
      anon_sym_repeat,
    ACTIONS(4656), 1,
      anon_sym_QMARK,
    ACTIONS(4658), 1,
      anon_sym_TILDE,
    ACTIONS(4666), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4668), 1,
      sym__number_literal,
    ACTIONS(4670), 1,
      anon_sym_SQUOTE,
    ACTIONS(4672), 1,
      anon_sym_DQUOTE,
    ACTIONS(4680), 1,
      sym__raw_string_literal,
    ACTIONS(4682), 1,
      sym__external_open_parenthesis,
    ACTIONS(4684), 1,
      sym__external_open_brace,
    ACTIONS(6371), 1,
      anon_sym_BANG,
    ACTIONS(12073), 1,
      sym_dot_dot_i,
    ACTIONS(12075), 1,
      sym__newline,
    STATE(185), 1,
      sym__open_brace,
    STATE(218), 1,
      sym__open_parenthesis,
    STATE(2649), 1,
      sym__double_quoted_string,
    STATE(2654), 1,
      sym__single_quoted_string,
    STATE(2744), 1,
      sym_string,
    STATE(3856), 1,
      aux_sym_function_definition_repeat1,
    STATE(5141), 1,
      sym__string_or_identifier,
    ACTIONS(4662), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2656), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4676), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12071), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1971), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [109263] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4642), 1,
      sym_identifier,
    ACTIONS(4644), 1,
      anon_sym_BSLASH,
    ACTIONS(4646), 1,
      anon_sym_function,
    ACTIONS(4648), 1,
      anon_sym_if,
    ACTIONS(4650), 1,
      anon_sym_for,
    ACTIONS(4652), 1,
      anon_sym_while,
    ACTIONS(4654), 1,
      anon_sym_repeat,
    ACTIONS(4656), 1,
      anon_sym_QMARK,
    ACTIONS(4658), 1,
      anon_sym_TILDE,
    ACTIONS(4666), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4668), 1,
      sym__number_literal,
    ACTIONS(4670), 1,
      anon_sym_SQUOTE,
    ACTIONS(4672), 1,
      anon_sym_DQUOTE,
    ACTIONS(4680), 1,
      sym__raw_string_literal,
    ACTIONS(4682), 1,
      sym__external_open_parenthesis,
    ACTIONS(4684), 1,
      sym__external_open_brace,
    ACTIONS(6371), 1,
      anon_sym_BANG,
    ACTIONS(12079), 1,
      sym_dot_dot_i,
    ACTIONS(12081), 1,
      sym__newline,
    STATE(185), 1,
      sym__open_brace,
    STATE(218), 1,
      sym__open_parenthesis,
    STATE(2649), 1,
      sym__double_quoted_string,
    STATE(2654), 1,
      sym__single_quoted_string,
    STATE(2744), 1,
      sym_string,
    STATE(3857), 1,
      aux_sym_function_definition_repeat1,
    STATE(5141), 1,
      sym__string_or_identifier,
    ACTIONS(4662), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2656), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4676), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12077), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1974), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [109392] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2826), 1,
      sym_identifier,
    ACTIONS(2828), 1,
      anon_sym_BSLASH,
    ACTIONS(2830), 1,
      anon_sym_function,
    ACTIONS(2832), 1,
      anon_sym_if,
    ACTIONS(2834), 1,
      anon_sym_for,
    ACTIONS(2836), 1,
      anon_sym_while,
    ACTIONS(2838), 1,
      anon_sym_repeat,
    ACTIONS(2840), 1,
      anon_sym_QMARK,
    ACTIONS(2842), 1,
      anon_sym_TILDE,
    ACTIONS(2850), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2852), 1,
      sym__number_literal,
    ACTIONS(2854), 1,
      anon_sym_SQUOTE,
    ACTIONS(2856), 1,
      anon_sym_DQUOTE,
    ACTIONS(2866), 1,
      sym__raw_string_literal,
    ACTIONS(2868), 1,
      sym__external_open_parenthesis,
    ACTIONS(2870), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(10915), 1,
      anon_sym_BANG,
    ACTIONS(12085), 1,
      sym_dot_dot_i,
    STATE(178), 1,
      sym__open_parenthesis,
    STATE(244), 1,
      sym__open_brace,
    STATE(2522), 1,
      sym_string,
    STATE(2528), 1,
      sym__single_quoted_string,
    STATE(2529), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5126), 1,
      sym__string_or_identifier,
    ACTIONS(2846), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2523), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2860), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12083), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1766), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [109521] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      sym_identifier,
    ACTIONS(105), 1,
      anon_sym_BSLASH,
    ACTIONS(107), 1,
      anon_sym_function,
    ACTIONS(111), 1,
      anon_sym_if,
    ACTIONS(113), 1,
      anon_sym_for,
    ACTIONS(115), 1,
      anon_sym_while,
    ACTIONS(117), 1,
      anon_sym_repeat,
    ACTIONS(119), 1,
      anon_sym_QMARK,
    ACTIONS(121), 1,
      anon_sym_TILDE,
    ACTIONS(131), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(133), 1,
      sym__number_literal,
    ACTIONS(135), 1,
      anon_sym_SQUOTE,
    ACTIONS(137), 1,
      anon_sym_DQUOTE,
    ACTIONS(147), 1,
      sym__raw_string_literal,
    ACTIONS(149), 1,
      sym__external_open_parenthesis,
    ACTIONS(153), 1,
      sym__external_open_brace,
    ACTIONS(8381), 1,
      anon_sym_BANG,
    ACTIONS(12089), 1,
      sym_dot_dot_i,
    ACTIONS(12091), 1,
      sym__newline,
    STATE(10), 1,
      sym__open_brace,
    STATE(20), 1,
      sym__open_parenthesis,
    STATE(2016), 1,
      sym_string,
    STATE(2027), 1,
      sym__single_quoted_string,
    STATE(2041), 1,
      sym__double_quoted_string,
    STATE(3890), 1,
      aux_sym_function_definition_repeat1,
    STATE(5131), 1,
      sym__string_or_identifier,
    ACTIONS(125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2021), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(141), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12087), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(565), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [109650] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      sym_identifier,
    ACTIONS(105), 1,
      anon_sym_BSLASH,
    ACTIONS(107), 1,
      anon_sym_function,
    ACTIONS(111), 1,
      anon_sym_if,
    ACTIONS(113), 1,
      anon_sym_for,
    ACTIONS(115), 1,
      anon_sym_while,
    ACTIONS(117), 1,
      anon_sym_repeat,
    ACTIONS(119), 1,
      anon_sym_QMARK,
    ACTIONS(121), 1,
      anon_sym_TILDE,
    ACTIONS(131), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(133), 1,
      sym__number_literal,
    ACTIONS(135), 1,
      anon_sym_SQUOTE,
    ACTIONS(137), 1,
      anon_sym_DQUOTE,
    ACTIONS(147), 1,
      sym__raw_string_literal,
    ACTIONS(149), 1,
      sym__external_open_parenthesis,
    ACTIONS(153), 1,
      sym__external_open_brace,
    ACTIONS(8381), 1,
      anon_sym_BANG,
    ACTIONS(12095), 1,
      sym_dot_dot_i,
    ACTIONS(12097), 1,
      sym__newline,
    STATE(10), 1,
      sym__open_brace,
    STATE(20), 1,
      sym__open_parenthesis,
    STATE(2016), 1,
      sym_string,
    STATE(2027), 1,
      sym__single_quoted_string,
    STATE(2041), 1,
      sym__double_quoted_string,
    STATE(3892), 1,
      aux_sym_function_definition_repeat1,
    STATE(5131), 1,
      sym__string_or_identifier,
    ACTIONS(125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2021), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(141), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12093), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(566), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [109779] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      sym_identifier,
    ACTIONS(105), 1,
      anon_sym_BSLASH,
    ACTIONS(107), 1,
      anon_sym_function,
    ACTIONS(111), 1,
      anon_sym_if,
    ACTIONS(113), 1,
      anon_sym_for,
    ACTIONS(115), 1,
      anon_sym_while,
    ACTIONS(117), 1,
      anon_sym_repeat,
    ACTIONS(119), 1,
      anon_sym_QMARK,
    ACTIONS(121), 1,
      anon_sym_TILDE,
    ACTIONS(131), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(133), 1,
      sym__number_literal,
    ACTIONS(135), 1,
      anon_sym_SQUOTE,
    ACTIONS(137), 1,
      anon_sym_DQUOTE,
    ACTIONS(147), 1,
      sym__raw_string_literal,
    ACTIONS(149), 1,
      sym__external_open_parenthesis,
    ACTIONS(153), 1,
      sym__external_open_brace,
    ACTIONS(8381), 1,
      anon_sym_BANG,
    ACTIONS(12101), 1,
      sym_dot_dot_i,
    ACTIONS(12103), 1,
      sym__newline,
    STATE(10), 1,
      sym__open_brace,
    STATE(20), 1,
      sym__open_parenthesis,
    STATE(2016), 1,
      sym_string,
    STATE(2027), 1,
      sym__single_quoted_string,
    STATE(2041), 1,
      sym__double_quoted_string,
    STATE(3894), 1,
      aux_sym_function_definition_repeat1,
    STATE(5131), 1,
      sym__string_or_identifier,
    ACTIONS(125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2021), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(141), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12099), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(567), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [109908] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      sym_identifier,
    ACTIONS(105), 1,
      anon_sym_BSLASH,
    ACTIONS(107), 1,
      anon_sym_function,
    ACTIONS(111), 1,
      anon_sym_if,
    ACTIONS(113), 1,
      anon_sym_for,
    ACTIONS(115), 1,
      anon_sym_while,
    ACTIONS(117), 1,
      anon_sym_repeat,
    ACTIONS(119), 1,
      anon_sym_QMARK,
    ACTIONS(121), 1,
      anon_sym_TILDE,
    ACTIONS(131), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(133), 1,
      sym__number_literal,
    ACTIONS(135), 1,
      anon_sym_SQUOTE,
    ACTIONS(137), 1,
      anon_sym_DQUOTE,
    ACTIONS(147), 1,
      sym__raw_string_literal,
    ACTIONS(149), 1,
      sym__external_open_parenthesis,
    ACTIONS(153), 1,
      sym__external_open_brace,
    ACTIONS(8381), 1,
      anon_sym_BANG,
    ACTIONS(12107), 1,
      sym_dot_dot_i,
    ACTIONS(12109), 1,
      sym__newline,
    STATE(10), 1,
      sym__open_brace,
    STATE(20), 1,
      sym__open_parenthesis,
    STATE(2016), 1,
      sym_string,
    STATE(2027), 1,
      sym__single_quoted_string,
    STATE(2041), 1,
      sym__double_quoted_string,
    STATE(3896), 1,
      aux_sym_function_definition_repeat1,
    STATE(5131), 1,
      sym__string_or_identifier,
    ACTIONS(125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2021), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(141), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12105), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(568), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [110037] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4053), 1,
      sym_identifier,
    ACTIONS(4055), 1,
      anon_sym_BSLASH,
    ACTIONS(4057), 1,
      anon_sym_function,
    ACTIONS(4059), 1,
      anon_sym_if,
    ACTIONS(4061), 1,
      anon_sym_for,
    ACTIONS(4063), 1,
      anon_sym_while,
    ACTIONS(4065), 1,
      anon_sym_repeat,
    ACTIONS(4067), 1,
      anon_sym_QMARK,
    ACTIONS(4069), 1,
      anon_sym_TILDE,
    ACTIONS(4077), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4079), 1,
      sym__number_literal,
    ACTIONS(4081), 1,
      anon_sym_SQUOTE,
    ACTIONS(4083), 1,
      anon_sym_DQUOTE,
    ACTIONS(4093), 1,
      sym__raw_string_literal,
    ACTIONS(4095), 1,
      sym__external_open_parenthesis,
    ACTIONS(4097), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7821), 1,
      anon_sym_BANG,
    ACTIONS(12113), 1,
      sym_dot_dot_i,
    STATE(133), 1,
      sym__open_brace,
    STATE(150), 1,
      sym__open_parenthesis,
    STATE(2534), 1,
      sym_string,
    STATE(2538), 1,
      sym__single_quoted_string,
    STATE(2539), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5143), 1,
      sym__string_or_identifier,
    ACTIONS(4073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2536), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4087), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12111), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1828), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [110166] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(273), 1,
      sym_identifier,
    ACTIONS(275), 1,
      anon_sym_BSLASH,
    ACTIONS(277), 1,
      anon_sym_function,
    ACTIONS(279), 1,
      anon_sym_if,
    ACTIONS(281), 1,
      anon_sym_for,
    ACTIONS(283), 1,
      anon_sym_while,
    ACTIONS(285), 1,
      anon_sym_repeat,
    ACTIONS(287), 1,
      anon_sym_QMARK,
    ACTIONS(289), 1,
      anon_sym_TILDE,
    ACTIONS(297), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(299), 1,
      sym__number_literal,
    ACTIONS(301), 1,
      anon_sym_SQUOTE,
    ACTIONS(303), 1,
      anon_sym_DQUOTE,
    ACTIONS(313), 1,
      sym__raw_string_literal,
    ACTIONS(315), 1,
      sym__external_open_parenthesis,
    ACTIONS(319), 1,
      sym__external_open_brace,
    ACTIONS(11159), 1,
      anon_sym_BANG,
    ACTIONS(12117), 1,
      sym_dot_dot_i,
    ACTIONS(12119), 1,
      sym__newline,
    STATE(57), 1,
      sym__open_parenthesis,
    STATE(59), 1,
      sym__open_brace,
    STATE(2187), 1,
      sym__double_quoted_string,
    STATE(2188), 1,
      sym__single_quoted_string,
    STATE(2192), 1,
      sym_string,
    STATE(3992), 1,
      aux_sym_function_definition_repeat1,
    STATE(5139), 1,
      sym__string_or_identifier,
    ACTIONS(293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2189), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(307), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12115), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(772), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [110295] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1337), 1,
      sym_identifier,
    ACTIONS(1339), 1,
      anon_sym_BSLASH,
    ACTIONS(1341), 1,
      anon_sym_function,
    ACTIONS(1343), 1,
      anon_sym_if,
    ACTIONS(1345), 1,
      anon_sym_for,
    ACTIONS(1347), 1,
      anon_sym_while,
    ACTIONS(1349), 1,
      anon_sym_repeat,
    ACTIONS(1351), 1,
      anon_sym_QMARK,
    ACTIONS(1353), 1,
      anon_sym_TILDE,
    ACTIONS(1361), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1363), 1,
      sym__number_literal,
    ACTIONS(1365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1367), 1,
      anon_sym_DQUOTE,
    ACTIONS(1377), 1,
      sym__raw_string_literal,
    ACTIONS(1379), 1,
      sym__external_open_parenthesis,
    ACTIONS(1383), 1,
      sym__external_open_brace,
    ACTIONS(9409), 1,
      anon_sym_BANG,
    ACTIONS(12123), 1,
      sym_dot_dot_i,
    ACTIONS(12125), 1,
      sym__newline,
    STATE(94), 1,
      sym__open_brace,
    STATE(190), 1,
      sym__open_parenthesis,
    STATE(2231), 1,
      sym_string,
    STATE(2354), 1,
      sym__double_quoted_string,
    STATE(2355), 1,
      sym__single_quoted_string,
    STATE(3872), 1,
      aux_sym_function_definition_repeat1,
    STATE(5156), 1,
      sym__string_or_identifier,
    ACTIONS(1357), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2356), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1371), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12121), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(779), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [110424] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2826), 1,
      sym_identifier,
    ACTIONS(2828), 1,
      anon_sym_BSLASH,
    ACTIONS(2830), 1,
      anon_sym_function,
    ACTIONS(2832), 1,
      anon_sym_if,
    ACTIONS(2834), 1,
      anon_sym_for,
    ACTIONS(2836), 1,
      anon_sym_while,
    ACTIONS(2838), 1,
      anon_sym_repeat,
    ACTIONS(2840), 1,
      anon_sym_QMARK,
    ACTIONS(2842), 1,
      anon_sym_TILDE,
    ACTIONS(2850), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2852), 1,
      sym__number_literal,
    ACTIONS(2854), 1,
      anon_sym_SQUOTE,
    ACTIONS(2856), 1,
      anon_sym_DQUOTE,
    ACTIONS(2866), 1,
      sym__raw_string_literal,
    ACTIONS(2868), 1,
      sym__external_open_parenthesis,
    ACTIONS(2870), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(10915), 1,
      anon_sym_BANG,
    ACTIONS(12129), 1,
      sym_dot_dot_i,
    STATE(178), 1,
      sym__open_parenthesis,
    STATE(244), 1,
      sym__open_brace,
    STATE(2522), 1,
      sym_string,
    STATE(2528), 1,
      sym__single_quoted_string,
    STATE(2529), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5126), 1,
      sym__string_or_identifier,
    ACTIONS(2846), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2523), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2860), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12127), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1773), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [110553] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(12133), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12131), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4559), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [110682] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2826), 1,
      sym_identifier,
    ACTIONS(2828), 1,
      anon_sym_BSLASH,
    ACTIONS(2830), 1,
      anon_sym_function,
    ACTIONS(2832), 1,
      anon_sym_if,
    ACTIONS(2834), 1,
      anon_sym_for,
    ACTIONS(2836), 1,
      anon_sym_while,
    ACTIONS(2838), 1,
      anon_sym_repeat,
    ACTIONS(2840), 1,
      anon_sym_QMARK,
    ACTIONS(2842), 1,
      anon_sym_TILDE,
    ACTIONS(2850), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2852), 1,
      sym__number_literal,
    ACTIONS(2854), 1,
      anon_sym_SQUOTE,
    ACTIONS(2856), 1,
      anon_sym_DQUOTE,
    ACTIONS(2866), 1,
      sym__raw_string_literal,
    ACTIONS(2868), 1,
      sym__external_open_parenthesis,
    ACTIONS(2870), 1,
      sym__external_open_brace,
    ACTIONS(10915), 1,
      anon_sym_BANG,
    ACTIONS(12137), 1,
      sym_dot_dot_i,
    ACTIONS(12139), 1,
      sym__newline,
    STATE(178), 1,
      sym__open_parenthesis,
    STATE(244), 1,
      sym__open_brace,
    STATE(2522), 1,
      sym_string,
    STATE(2528), 1,
      sym__single_quoted_string,
    STATE(2529), 1,
      sym__double_quoted_string,
    STATE(3716), 1,
      aux_sym_function_definition_repeat1,
    STATE(5126), 1,
      sym__string_or_identifier,
    ACTIONS(2846), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2523), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2860), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12135), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1903), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [110811] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(12143), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12141), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4581), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [110940] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(12147), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12145), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4580), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [111069] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4053), 1,
      sym_identifier,
    ACTIONS(4055), 1,
      anon_sym_BSLASH,
    ACTIONS(4057), 1,
      anon_sym_function,
    ACTIONS(4059), 1,
      anon_sym_if,
    ACTIONS(4061), 1,
      anon_sym_for,
    ACTIONS(4063), 1,
      anon_sym_while,
    ACTIONS(4065), 1,
      anon_sym_repeat,
    ACTIONS(4067), 1,
      anon_sym_QMARK,
    ACTIONS(4069), 1,
      anon_sym_TILDE,
    ACTIONS(4077), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4079), 1,
      sym__number_literal,
    ACTIONS(4081), 1,
      anon_sym_SQUOTE,
    ACTIONS(4083), 1,
      anon_sym_DQUOTE,
    ACTIONS(4093), 1,
      sym__raw_string_literal,
    ACTIONS(4095), 1,
      sym__external_open_parenthesis,
    ACTIONS(4097), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7821), 1,
      anon_sym_BANG,
    ACTIONS(12151), 1,
      sym_dot_dot_i,
    STATE(133), 1,
      sym__open_brace,
    STATE(150), 1,
      sym__open_parenthesis,
    STATE(2534), 1,
      sym_string,
    STATE(2538), 1,
      sym__single_quoted_string,
    STATE(2539), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5143), 1,
      sym__string_or_identifier,
    ACTIONS(4073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2536), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4087), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12149), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1030), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [111198] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      sym_identifier,
    ACTIONS(105), 1,
      anon_sym_BSLASH,
    ACTIONS(107), 1,
      anon_sym_function,
    ACTIONS(111), 1,
      anon_sym_if,
    ACTIONS(113), 1,
      anon_sym_for,
    ACTIONS(115), 1,
      anon_sym_while,
    ACTIONS(117), 1,
      anon_sym_repeat,
    ACTIONS(119), 1,
      anon_sym_QMARK,
    ACTIONS(121), 1,
      anon_sym_TILDE,
    ACTIONS(131), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(133), 1,
      sym__number_literal,
    ACTIONS(135), 1,
      anon_sym_SQUOTE,
    ACTIONS(137), 1,
      anon_sym_DQUOTE,
    ACTIONS(147), 1,
      sym__raw_string_literal,
    ACTIONS(149), 1,
      sym__external_open_parenthesis,
    ACTIONS(153), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8381), 1,
      anon_sym_BANG,
    ACTIONS(12155), 1,
      sym_dot_dot_i,
    STATE(10), 1,
      sym__open_brace,
    STATE(20), 1,
      sym__open_parenthesis,
    STATE(2016), 1,
      sym_string,
    STATE(2027), 1,
      sym__single_quoted_string,
    STATE(2041), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5131), 1,
      sym__string_or_identifier,
    ACTIONS(125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2021), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(141), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12153), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(571), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [111327] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4752), 1,
      sym_identifier,
    ACTIONS(4754), 1,
      anon_sym_BSLASH,
    ACTIONS(4756), 1,
      anon_sym_function,
    ACTIONS(4758), 1,
      anon_sym_if,
    ACTIONS(4760), 1,
      anon_sym_for,
    ACTIONS(4762), 1,
      anon_sym_while,
    ACTIONS(4764), 1,
      anon_sym_repeat,
    ACTIONS(4766), 1,
      anon_sym_QMARK,
    ACTIONS(4768), 1,
      anon_sym_TILDE,
    ACTIONS(4776), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4778), 1,
      sym__number_literal,
    ACTIONS(4780), 1,
      anon_sym_SQUOTE,
    ACTIONS(4782), 1,
      anon_sym_DQUOTE,
    ACTIONS(4790), 1,
      sym__raw_string_literal,
    ACTIONS(4792), 1,
      sym__external_open_parenthesis,
    ACTIONS(4794), 1,
      sym__external_open_brace,
    ACTIONS(6353), 1,
      anon_sym_BANG,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(12159), 1,
      sym_dot_dot_i,
    STATE(192), 1,
      sym__open_brace,
    STATE(214), 1,
      sym__open_parenthesis,
    STATE(2664), 1,
      sym_string,
    STATE(2701), 1,
      sym__single_quoted_string,
    STATE(2745), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5148), 1,
      sym__string_or_identifier,
    ACTIONS(4772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2700), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4786), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12157), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1919), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [111456] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      sym_identifier,
    ACTIONS(105), 1,
      anon_sym_BSLASH,
    ACTIONS(107), 1,
      anon_sym_function,
    ACTIONS(111), 1,
      anon_sym_if,
    ACTIONS(113), 1,
      anon_sym_for,
    ACTIONS(115), 1,
      anon_sym_while,
    ACTIONS(117), 1,
      anon_sym_repeat,
    ACTIONS(119), 1,
      anon_sym_QMARK,
    ACTIONS(121), 1,
      anon_sym_TILDE,
    ACTIONS(131), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(133), 1,
      sym__number_literal,
    ACTIONS(135), 1,
      anon_sym_SQUOTE,
    ACTIONS(137), 1,
      anon_sym_DQUOTE,
    ACTIONS(147), 1,
      sym__raw_string_literal,
    ACTIONS(149), 1,
      sym__external_open_parenthesis,
    ACTIONS(153), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8381), 1,
      anon_sym_BANG,
    ACTIONS(12163), 1,
      sym_dot_dot_i,
    STATE(10), 1,
      sym__open_brace,
    STATE(20), 1,
      sym__open_parenthesis,
    STATE(2016), 1,
      sym_string,
    STATE(2027), 1,
      sym__single_quoted_string,
    STATE(2041), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5131), 1,
      sym__string_or_identifier,
    ACTIONS(125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2021), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(141), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12161), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(572), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [111585] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(12167), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12165), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4565), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [111714] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      sym_identifier,
    ACTIONS(105), 1,
      anon_sym_BSLASH,
    ACTIONS(107), 1,
      anon_sym_function,
    ACTIONS(111), 1,
      anon_sym_if,
    ACTIONS(113), 1,
      anon_sym_for,
    ACTIONS(115), 1,
      anon_sym_while,
    ACTIONS(117), 1,
      anon_sym_repeat,
    ACTIONS(119), 1,
      anon_sym_QMARK,
    ACTIONS(121), 1,
      anon_sym_TILDE,
    ACTIONS(131), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(133), 1,
      sym__number_literal,
    ACTIONS(135), 1,
      anon_sym_SQUOTE,
    ACTIONS(137), 1,
      anon_sym_DQUOTE,
    ACTIONS(147), 1,
      sym__raw_string_literal,
    ACTIONS(149), 1,
      sym__external_open_parenthesis,
    ACTIONS(153), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8381), 1,
      anon_sym_BANG,
    ACTIONS(12171), 1,
      sym_dot_dot_i,
    STATE(10), 1,
      sym__open_brace,
    STATE(20), 1,
      sym__open_parenthesis,
    STATE(2016), 1,
      sym_string,
    STATE(2027), 1,
      sym__single_quoted_string,
    STATE(2041), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5131), 1,
      sym__string_or_identifier,
    ACTIONS(125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2021), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(141), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12169), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(573), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [111843] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4752), 1,
      sym_identifier,
    ACTIONS(4754), 1,
      anon_sym_BSLASH,
    ACTIONS(4756), 1,
      anon_sym_function,
    ACTIONS(4758), 1,
      anon_sym_if,
    ACTIONS(4760), 1,
      anon_sym_for,
    ACTIONS(4762), 1,
      anon_sym_while,
    ACTIONS(4764), 1,
      anon_sym_repeat,
    ACTIONS(4766), 1,
      anon_sym_QMARK,
    ACTIONS(4768), 1,
      anon_sym_TILDE,
    ACTIONS(4776), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4778), 1,
      sym__number_literal,
    ACTIONS(4780), 1,
      anon_sym_SQUOTE,
    ACTIONS(4782), 1,
      anon_sym_DQUOTE,
    ACTIONS(4790), 1,
      sym__raw_string_literal,
    ACTIONS(4792), 1,
      sym__external_open_parenthesis,
    ACTIONS(4794), 1,
      sym__external_open_brace,
    ACTIONS(6353), 1,
      anon_sym_BANG,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(12175), 1,
      sym_dot_dot_i,
    STATE(192), 1,
      sym__open_brace,
    STATE(214), 1,
      sym__open_parenthesis,
    STATE(2664), 1,
      sym_string,
    STATE(2701), 1,
      sym__single_quoted_string,
    STATE(2745), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5148), 1,
      sym__string_or_identifier,
    ACTIONS(4772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2700), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4786), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12173), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1953), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [111972] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      sym_identifier,
    ACTIONS(105), 1,
      anon_sym_BSLASH,
    ACTIONS(107), 1,
      anon_sym_function,
    ACTIONS(111), 1,
      anon_sym_if,
    ACTIONS(113), 1,
      anon_sym_for,
    ACTIONS(115), 1,
      anon_sym_while,
    ACTIONS(117), 1,
      anon_sym_repeat,
    ACTIONS(119), 1,
      anon_sym_QMARK,
    ACTIONS(121), 1,
      anon_sym_TILDE,
    ACTIONS(131), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(133), 1,
      sym__number_literal,
    ACTIONS(135), 1,
      anon_sym_SQUOTE,
    ACTIONS(137), 1,
      anon_sym_DQUOTE,
    ACTIONS(147), 1,
      sym__raw_string_literal,
    ACTIONS(149), 1,
      sym__external_open_parenthesis,
    ACTIONS(153), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8381), 1,
      anon_sym_BANG,
    ACTIONS(12179), 1,
      sym_dot_dot_i,
    STATE(10), 1,
      sym__open_brace,
    STATE(20), 1,
      sym__open_parenthesis,
    STATE(2016), 1,
      sym_string,
    STATE(2027), 1,
      sym__single_quoted_string,
    STATE(2041), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5131), 1,
      sym__string_or_identifier,
    ACTIONS(125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2021), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(141), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12177), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(574), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [112101] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2826), 1,
      sym_identifier,
    ACTIONS(2828), 1,
      anon_sym_BSLASH,
    ACTIONS(2830), 1,
      anon_sym_function,
    ACTIONS(2832), 1,
      anon_sym_if,
    ACTIONS(2834), 1,
      anon_sym_for,
    ACTIONS(2836), 1,
      anon_sym_while,
    ACTIONS(2838), 1,
      anon_sym_repeat,
    ACTIONS(2840), 1,
      anon_sym_QMARK,
    ACTIONS(2842), 1,
      anon_sym_TILDE,
    ACTIONS(2850), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2852), 1,
      sym__number_literal,
    ACTIONS(2854), 1,
      anon_sym_SQUOTE,
    ACTIONS(2856), 1,
      anon_sym_DQUOTE,
    ACTIONS(2866), 1,
      sym__raw_string_literal,
    ACTIONS(2868), 1,
      sym__external_open_parenthesis,
    ACTIONS(2870), 1,
      sym__external_open_brace,
    ACTIONS(10915), 1,
      anon_sym_BANG,
    ACTIONS(12183), 1,
      sym_dot_dot_i,
    ACTIONS(12185), 1,
      sym__newline,
    STATE(178), 1,
      sym__open_parenthesis,
    STATE(244), 1,
      sym__open_brace,
    STATE(2522), 1,
      sym_string,
    STATE(2528), 1,
      sym__single_quoted_string,
    STATE(2529), 1,
      sym__double_quoted_string,
    STATE(3718), 1,
      aux_sym_function_definition_repeat1,
    STATE(5126), 1,
      sym__string_or_identifier,
    ACTIONS(2846), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2523), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2860), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12181), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1884), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [112230] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4752), 1,
      sym_identifier,
    ACTIONS(4754), 1,
      anon_sym_BSLASH,
    ACTIONS(4756), 1,
      anon_sym_function,
    ACTIONS(4758), 1,
      anon_sym_if,
    ACTIONS(4760), 1,
      anon_sym_for,
    ACTIONS(4762), 1,
      anon_sym_while,
    ACTIONS(4764), 1,
      anon_sym_repeat,
    ACTIONS(4766), 1,
      anon_sym_QMARK,
    ACTIONS(4768), 1,
      anon_sym_TILDE,
    ACTIONS(4776), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4778), 1,
      sym__number_literal,
    ACTIONS(4780), 1,
      anon_sym_SQUOTE,
    ACTIONS(4782), 1,
      anon_sym_DQUOTE,
    ACTIONS(4790), 1,
      sym__raw_string_literal,
    ACTIONS(4792), 1,
      sym__external_open_parenthesis,
    ACTIONS(4794), 1,
      sym__external_open_brace,
    ACTIONS(6353), 1,
      anon_sym_BANG,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(12189), 1,
      sym_dot_dot_i,
    STATE(192), 1,
      sym__open_brace,
    STATE(214), 1,
      sym__open_parenthesis,
    STATE(2664), 1,
      sym_string,
    STATE(2701), 1,
      sym__single_quoted_string,
    STATE(2745), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5148), 1,
      sym__string_or_identifier,
    ACTIONS(4772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2700), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4786), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12187), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1921), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [112359] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2826), 1,
      sym_identifier,
    ACTIONS(2828), 1,
      anon_sym_BSLASH,
    ACTIONS(2830), 1,
      anon_sym_function,
    ACTIONS(2832), 1,
      anon_sym_if,
    ACTIONS(2834), 1,
      anon_sym_for,
    ACTIONS(2836), 1,
      anon_sym_while,
    ACTIONS(2838), 1,
      anon_sym_repeat,
    ACTIONS(2840), 1,
      anon_sym_QMARK,
    ACTIONS(2842), 1,
      anon_sym_TILDE,
    ACTIONS(2850), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2852), 1,
      sym__number_literal,
    ACTIONS(2854), 1,
      anon_sym_SQUOTE,
    ACTIONS(2856), 1,
      anon_sym_DQUOTE,
    ACTIONS(2866), 1,
      sym__raw_string_literal,
    ACTIONS(2868), 1,
      sym__external_open_parenthesis,
    ACTIONS(2870), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(10915), 1,
      anon_sym_BANG,
    ACTIONS(12193), 1,
      sym_dot_dot_i,
    STATE(178), 1,
      sym__open_parenthesis,
    STATE(244), 1,
      sym__open_brace,
    STATE(2522), 1,
      sym_string,
    STATE(2528), 1,
      sym__single_quoted_string,
    STATE(2529), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5126), 1,
      sym__string_or_identifier,
    ACTIONS(2846), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2523), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2860), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12191), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1837), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [112488] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4053), 1,
      sym_identifier,
    ACTIONS(4055), 1,
      anon_sym_BSLASH,
    ACTIONS(4057), 1,
      anon_sym_function,
    ACTIONS(4059), 1,
      anon_sym_if,
    ACTIONS(4061), 1,
      anon_sym_for,
    ACTIONS(4063), 1,
      anon_sym_while,
    ACTIONS(4065), 1,
      anon_sym_repeat,
    ACTIONS(4067), 1,
      anon_sym_QMARK,
    ACTIONS(4069), 1,
      anon_sym_TILDE,
    ACTIONS(4077), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4079), 1,
      sym__number_literal,
    ACTIONS(4081), 1,
      anon_sym_SQUOTE,
    ACTIONS(4083), 1,
      anon_sym_DQUOTE,
    ACTIONS(4093), 1,
      sym__raw_string_literal,
    ACTIONS(4095), 1,
      sym__external_open_parenthesis,
    ACTIONS(4097), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7821), 1,
      anon_sym_BANG,
    ACTIONS(12197), 1,
      sym_dot_dot_i,
    STATE(133), 1,
      sym__open_brace,
    STATE(150), 1,
      sym__open_parenthesis,
    STATE(2534), 1,
      sym_string,
    STATE(2538), 1,
      sym__single_quoted_string,
    STATE(2539), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5143), 1,
      sym__string_or_identifier,
    ACTIONS(4073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2536), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4087), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12195), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1823), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [112617] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      sym_identifier,
    ACTIONS(105), 1,
      anon_sym_BSLASH,
    ACTIONS(107), 1,
      anon_sym_function,
    ACTIONS(111), 1,
      anon_sym_if,
    ACTIONS(113), 1,
      anon_sym_for,
    ACTIONS(115), 1,
      anon_sym_while,
    ACTIONS(117), 1,
      anon_sym_repeat,
    ACTIONS(119), 1,
      anon_sym_QMARK,
    ACTIONS(121), 1,
      anon_sym_TILDE,
    ACTIONS(131), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(133), 1,
      sym__number_literal,
    ACTIONS(135), 1,
      anon_sym_SQUOTE,
    ACTIONS(137), 1,
      anon_sym_DQUOTE,
    ACTIONS(147), 1,
      sym__raw_string_literal,
    ACTIONS(149), 1,
      sym__external_open_parenthesis,
    ACTIONS(153), 1,
      sym__external_open_brace,
    ACTIONS(8381), 1,
      anon_sym_BANG,
    ACTIONS(12201), 1,
      sym_dot_dot_i,
    ACTIONS(12203), 1,
      sym__newline,
    STATE(10), 1,
      sym__open_brace,
    STATE(20), 1,
      sym__open_parenthesis,
    STATE(2016), 1,
      sym_string,
    STATE(2027), 1,
      sym__single_quoted_string,
    STATE(2041), 1,
      sym__double_quoted_string,
    STATE(3933), 1,
      aux_sym_function_definition_repeat1,
    STATE(5131), 1,
      sym__string_or_identifier,
    ACTIONS(125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2021), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(141), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12199), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(576), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [112746] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      sym_identifier,
    ACTIONS(105), 1,
      anon_sym_BSLASH,
    ACTIONS(107), 1,
      anon_sym_function,
    ACTIONS(111), 1,
      anon_sym_if,
    ACTIONS(113), 1,
      anon_sym_for,
    ACTIONS(115), 1,
      anon_sym_while,
    ACTIONS(117), 1,
      anon_sym_repeat,
    ACTIONS(119), 1,
      anon_sym_QMARK,
    ACTIONS(121), 1,
      anon_sym_TILDE,
    ACTIONS(131), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(133), 1,
      sym__number_literal,
    ACTIONS(135), 1,
      anon_sym_SQUOTE,
    ACTIONS(137), 1,
      anon_sym_DQUOTE,
    ACTIONS(147), 1,
      sym__raw_string_literal,
    ACTIONS(149), 1,
      sym__external_open_parenthesis,
    ACTIONS(153), 1,
      sym__external_open_brace,
    ACTIONS(8381), 1,
      anon_sym_BANG,
    ACTIONS(12207), 1,
      sym_dot_dot_i,
    ACTIONS(12209), 1,
      sym__newline,
    STATE(10), 1,
      sym__open_brace,
    STATE(20), 1,
      sym__open_parenthesis,
    STATE(2016), 1,
      sym_string,
    STATE(2027), 1,
      sym__single_quoted_string,
    STATE(2041), 1,
      sym__double_quoted_string,
    STATE(3935), 1,
      aux_sym_function_definition_repeat1,
    STATE(5131), 1,
      sym__string_or_identifier,
    ACTIONS(125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2021), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(141), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12205), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(577), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [112875] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      sym_identifier,
    ACTIONS(105), 1,
      anon_sym_BSLASH,
    ACTIONS(107), 1,
      anon_sym_function,
    ACTIONS(111), 1,
      anon_sym_if,
    ACTIONS(113), 1,
      anon_sym_for,
    ACTIONS(115), 1,
      anon_sym_while,
    ACTIONS(117), 1,
      anon_sym_repeat,
    ACTIONS(119), 1,
      anon_sym_QMARK,
    ACTIONS(121), 1,
      anon_sym_TILDE,
    ACTIONS(131), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(133), 1,
      sym__number_literal,
    ACTIONS(135), 1,
      anon_sym_SQUOTE,
    ACTIONS(137), 1,
      anon_sym_DQUOTE,
    ACTIONS(147), 1,
      sym__raw_string_literal,
    ACTIONS(149), 1,
      sym__external_open_parenthesis,
    ACTIONS(153), 1,
      sym__external_open_brace,
    ACTIONS(8381), 1,
      anon_sym_BANG,
    ACTIONS(12213), 1,
      sym_dot_dot_i,
    ACTIONS(12215), 1,
      sym__newline,
    STATE(10), 1,
      sym__open_brace,
    STATE(20), 1,
      sym__open_parenthesis,
    STATE(2016), 1,
      sym_string,
    STATE(2027), 1,
      sym__single_quoted_string,
    STATE(2041), 1,
      sym__double_quoted_string,
    STATE(3937), 1,
      aux_sym_function_definition_repeat1,
    STATE(5131), 1,
      sym__string_or_identifier,
    ACTIONS(125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2021), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(141), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12211), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(578), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [113004] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      sym_identifier,
    ACTIONS(105), 1,
      anon_sym_BSLASH,
    ACTIONS(107), 1,
      anon_sym_function,
    ACTIONS(111), 1,
      anon_sym_if,
    ACTIONS(113), 1,
      anon_sym_for,
    ACTIONS(115), 1,
      anon_sym_while,
    ACTIONS(117), 1,
      anon_sym_repeat,
    ACTIONS(119), 1,
      anon_sym_QMARK,
    ACTIONS(121), 1,
      anon_sym_TILDE,
    ACTIONS(131), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(133), 1,
      sym__number_literal,
    ACTIONS(135), 1,
      anon_sym_SQUOTE,
    ACTIONS(137), 1,
      anon_sym_DQUOTE,
    ACTIONS(147), 1,
      sym__raw_string_literal,
    ACTIONS(149), 1,
      sym__external_open_parenthesis,
    ACTIONS(153), 1,
      sym__external_open_brace,
    ACTIONS(8381), 1,
      anon_sym_BANG,
    ACTIONS(12219), 1,
      sym_dot_dot_i,
    ACTIONS(12221), 1,
      sym__newline,
    STATE(10), 1,
      sym__open_brace,
    STATE(20), 1,
      sym__open_parenthesis,
    STATE(2016), 1,
      sym_string,
    STATE(2027), 1,
      sym__single_quoted_string,
    STATE(2041), 1,
      sym__double_quoted_string,
    STATE(3939), 1,
      aux_sym_function_definition_repeat1,
    STATE(5131), 1,
      sym__string_or_identifier,
    ACTIONS(125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2021), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(141), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12217), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(579), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [113133] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      sym_identifier,
    ACTIONS(105), 1,
      anon_sym_BSLASH,
    ACTIONS(107), 1,
      anon_sym_function,
    ACTIONS(111), 1,
      anon_sym_if,
    ACTIONS(113), 1,
      anon_sym_for,
    ACTIONS(115), 1,
      anon_sym_while,
    ACTIONS(117), 1,
      anon_sym_repeat,
    ACTIONS(119), 1,
      anon_sym_QMARK,
    ACTIONS(121), 1,
      anon_sym_TILDE,
    ACTIONS(131), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(133), 1,
      sym__number_literal,
    ACTIONS(135), 1,
      anon_sym_SQUOTE,
    ACTIONS(137), 1,
      anon_sym_DQUOTE,
    ACTIONS(147), 1,
      sym__raw_string_literal,
    ACTIONS(149), 1,
      sym__external_open_parenthesis,
    ACTIONS(153), 1,
      sym__external_open_brace,
    ACTIONS(8381), 1,
      anon_sym_BANG,
    ACTIONS(12225), 1,
      sym_dot_dot_i,
    ACTIONS(12227), 1,
      sym__newline,
    STATE(10), 1,
      sym__open_brace,
    STATE(20), 1,
      sym__open_parenthesis,
    STATE(2016), 1,
      sym_string,
    STATE(2027), 1,
      sym__single_quoted_string,
    STATE(2041), 1,
      sym__double_quoted_string,
    STATE(3941), 1,
      aux_sym_function_definition_repeat1,
    STATE(5131), 1,
      sym__string_or_identifier,
    ACTIONS(125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2021), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(141), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12223), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(580), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [113262] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      sym_identifier,
    ACTIONS(105), 1,
      anon_sym_BSLASH,
    ACTIONS(107), 1,
      anon_sym_function,
    ACTIONS(111), 1,
      anon_sym_if,
    ACTIONS(113), 1,
      anon_sym_for,
    ACTIONS(115), 1,
      anon_sym_while,
    ACTIONS(117), 1,
      anon_sym_repeat,
    ACTIONS(119), 1,
      anon_sym_QMARK,
    ACTIONS(121), 1,
      anon_sym_TILDE,
    ACTIONS(131), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(133), 1,
      sym__number_literal,
    ACTIONS(135), 1,
      anon_sym_SQUOTE,
    ACTIONS(137), 1,
      anon_sym_DQUOTE,
    ACTIONS(147), 1,
      sym__raw_string_literal,
    ACTIONS(149), 1,
      sym__external_open_parenthesis,
    ACTIONS(153), 1,
      sym__external_open_brace,
    ACTIONS(8381), 1,
      anon_sym_BANG,
    ACTIONS(12231), 1,
      sym_dot_dot_i,
    ACTIONS(12233), 1,
      sym__newline,
    STATE(10), 1,
      sym__open_brace,
    STATE(20), 1,
      sym__open_parenthesis,
    STATE(2016), 1,
      sym_string,
    STATE(2027), 1,
      sym__single_quoted_string,
    STATE(2041), 1,
      sym__double_quoted_string,
    STATE(3943), 1,
      aux_sym_function_definition_repeat1,
    STATE(5131), 1,
      sym__string_or_identifier,
    ACTIONS(125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2021), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(141), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12229), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(581), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [113391] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      sym_identifier,
    ACTIONS(105), 1,
      anon_sym_BSLASH,
    ACTIONS(107), 1,
      anon_sym_function,
    ACTIONS(111), 1,
      anon_sym_if,
    ACTIONS(113), 1,
      anon_sym_for,
    ACTIONS(115), 1,
      anon_sym_while,
    ACTIONS(117), 1,
      anon_sym_repeat,
    ACTIONS(119), 1,
      anon_sym_QMARK,
    ACTIONS(121), 1,
      anon_sym_TILDE,
    ACTIONS(131), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(133), 1,
      sym__number_literal,
    ACTIONS(135), 1,
      anon_sym_SQUOTE,
    ACTIONS(137), 1,
      anon_sym_DQUOTE,
    ACTIONS(147), 1,
      sym__raw_string_literal,
    ACTIONS(149), 1,
      sym__external_open_parenthesis,
    ACTIONS(153), 1,
      sym__external_open_brace,
    ACTIONS(8381), 1,
      anon_sym_BANG,
    ACTIONS(12237), 1,
      sym_dot_dot_i,
    ACTIONS(12239), 1,
      sym__newline,
    STATE(10), 1,
      sym__open_brace,
    STATE(20), 1,
      sym__open_parenthesis,
    STATE(2016), 1,
      sym_string,
    STATE(2027), 1,
      sym__single_quoted_string,
    STATE(2041), 1,
      sym__double_quoted_string,
    STATE(3945), 1,
      aux_sym_function_definition_repeat1,
    STATE(5131), 1,
      sym__string_or_identifier,
    ACTIONS(125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2021), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(141), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12235), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(582), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [113520] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      sym_identifier,
    ACTIONS(105), 1,
      anon_sym_BSLASH,
    ACTIONS(107), 1,
      anon_sym_function,
    ACTIONS(111), 1,
      anon_sym_if,
    ACTIONS(113), 1,
      anon_sym_for,
    ACTIONS(115), 1,
      anon_sym_while,
    ACTIONS(117), 1,
      anon_sym_repeat,
    ACTIONS(119), 1,
      anon_sym_QMARK,
    ACTIONS(121), 1,
      anon_sym_TILDE,
    ACTIONS(131), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(133), 1,
      sym__number_literal,
    ACTIONS(135), 1,
      anon_sym_SQUOTE,
    ACTIONS(137), 1,
      anon_sym_DQUOTE,
    ACTIONS(147), 1,
      sym__raw_string_literal,
    ACTIONS(149), 1,
      sym__external_open_parenthesis,
    ACTIONS(153), 1,
      sym__external_open_brace,
    ACTIONS(8381), 1,
      anon_sym_BANG,
    ACTIONS(12243), 1,
      sym_dot_dot_i,
    ACTIONS(12245), 1,
      sym__newline,
    STATE(10), 1,
      sym__open_brace,
    STATE(20), 1,
      sym__open_parenthesis,
    STATE(2016), 1,
      sym_string,
    STATE(2027), 1,
      sym__single_quoted_string,
    STATE(2041), 1,
      sym__double_quoted_string,
    STATE(3947), 1,
      aux_sym_function_definition_repeat1,
    STATE(5131), 1,
      sym__string_or_identifier,
    ACTIONS(125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2021), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(141), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12241), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(583), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [113649] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      sym_identifier,
    ACTIONS(105), 1,
      anon_sym_BSLASH,
    ACTIONS(107), 1,
      anon_sym_function,
    ACTIONS(111), 1,
      anon_sym_if,
    ACTIONS(113), 1,
      anon_sym_for,
    ACTIONS(115), 1,
      anon_sym_while,
    ACTIONS(117), 1,
      anon_sym_repeat,
    ACTIONS(119), 1,
      anon_sym_QMARK,
    ACTIONS(121), 1,
      anon_sym_TILDE,
    ACTIONS(131), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(133), 1,
      sym__number_literal,
    ACTIONS(135), 1,
      anon_sym_SQUOTE,
    ACTIONS(137), 1,
      anon_sym_DQUOTE,
    ACTIONS(147), 1,
      sym__raw_string_literal,
    ACTIONS(149), 1,
      sym__external_open_parenthesis,
    ACTIONS(153), 1,
      sym__external_open_brace,
    ACTIONS(8381), 1,
      anon_sym_BANG,
    ACTIONS(12249), 1,
      sym_dot_dot_i,
    ACTIONS(12251), 1,
      sym__newline,
    STATE(10), 1,
      sym__open_brace,
    STATE(20), 1,
      sym__open_parenthesis,
    STATE(2016), 1,
      sym_string,
    STATE(2027), 1,
      sym__single_quoted_string,
    STATE(2041), 1,
      sym__double_quoted_string,
    STATE(3949), 1,
      aux_sym_function_definition_repeat1,
    STATE(5131), 1,
      sym__string_or_identifier,
    ACTIONS(125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2021), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(141), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12247), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(584), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [113778] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      sym_identifier,
    ACTIONS(105), 1,
      anon_sym_BSLASH,
    ACTIONS(107), 1,
      anon_sym_function,
    ACTIONS(111), 1,
      anon_sym_if,
    ACTIONS(113), 1,
      anon_sym_for,
    ACTIONS(115), 1,
      anon_sym_while,
    ACTIONS(117), 1,
      anon_sym_repeat,
    ACTIONS(119), 1,
      anon_sym_QMARK,
    ACTIONS(121), 1,
      anon_sym_TILDE,
    ACTIONS(131), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(133), 1,
      sym__number_literal,
    ACTIONS(135), 1,
      anon_sym_SQUOTE,
    ACTIONS(137), 1,
      anon_sym_DQUOTE,
    ACTIONS(147), 1,
      sym__raw_string_literal,
    ACTIONS(149), 1,
      sym__external_open_parenthesis,
    ACTIONS(153), 1,
      sym__external_open_brace,
    ACTIONS(8381), 1,
      anon_sym_BANG,
    ACTIONS(12255), 1,
      sym_dot_dot_i,
    ACTIONS(12257), 1,
      sym__newline,
    STATE(10), 1,
      sym__open_brace,
    STATE(20), 1,
      sym__open_parenthesis,
    STATE(2016), 1,
      sym_string,
    STATE(2027), 1,
      sym__single_quoted_string,
    STATE(2041), 1,
      sym__double_quoted_string,
    STATE(3951), 1,
      aux_sym_function_definition_repeat1,
    STATE(5131), 1,
      sym__string_or_identifier,
    ACTIONS(125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2021), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(141), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12253), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(585), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [113907] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      sym_identifier,
    ACTIONS(105), 1,
      anon_sym_BSLASH,
    ACTIONS(107), 1,
      anon_sym_function,
    ACTIONS(111), 1,
      anon_sym_if,
    ACTIONS(113), 1,
      anon_sym_for,
    ACTIONS(115), 1,
      anon_sym_while,
    ACTIONS(117), 1,
      anon_sym_repeat,
    ACTIONS(119), 1,
      anon_sym_QMARK,
    ACTIONS(121), 1,
      anon_sym_TILDE,
    ACTIONS(131), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(133), 1,
      sym__number_literal,
    ACTIONS(135), 1,
      anon_sym_SQUOTE,
    ACTIONS(137), 1,
      anon_sym_DQUOTE,
    ACTIONS(147), 1,
      sym__raw_string_literal,
    ACTIONS(149), 1,
      sym__external_open_parenthesis,
    ACTIONS(153), 1,
      sym__external_open_brace,
    ACTIONS(8381), 1,
      anon_sym_BANG,
    ACTIONS(12261), 1,
      sym_dot_dot_i,
    ACTIONS(12263), 1,
      sym__newline,
    STATE(10), 1,
      sym__open_brace,
    STATE(20), 1,
      sym__open_parenthesis,
    STATE(2016), 1,
      sym_string,
    STATE(2027), 1,
      sym__single_quoted_string,
    STATE(2041), 1,
      sym__double_quoted_string,
    STATE(3953), 1,
      aux_sym_function_definition_repeat1,
    STATE(5131), 1,
      sym__string_or_identifier,
    ACTIONS(125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2021), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(141), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12259), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(586), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [114036] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      sym_identifier,
    ACTIONS(105), 1,
      anon_sym_BSLASH,
    ACTIONS(107), 1,
      anon_sym_function,
    ACTIONS(111), 1,
      anon_sym_if,
    ACTIONS(113), 1,
      anon_sym_for,
    ACTIONS(115), 1,
      anon_sym_while,
    ACTIONS(117), 1,
      anon_sym_repeat,
    ACTIONS(119), 1,
      anon_sym_QMARK,
    ACTIONS(121), 1,
      anon_sym_TILDE,
    ACTIONS(131), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(133), 1,
      sym__number_literal,
    ACTIONS(135), 1,
      anon_sym_SQUOTE,
    ACTIONS(137), 1,
      anon_sym_DQUOTE,
    ACTIONS(147), 1,
      sym__raw_string_literal,
    ACTIONS(149), 1,
      sym__external_open_parenthesis,
    ACTIONS(153), 1,
      sym__external_open_brace,
    ACTIONS(8381), 1,
      anon_sym_BANG,
    ACTIONS(12267), 1,
      sym_dot_dot_i,
    ACTIONS(12269), 1,
      sym__newline,
    STATE(10), 1,
      sym__open_brace,
    STATE(20), 1,
      sym__open_parenthesis,
    STATE(2016), 1,
      sym_string,
    STATE(2027), 1,
      sym__single_quoted_string,
    STATE(2041), 1,
      sym__double_quoted_string,
    STATE(3955), 1,
      aux_sym_function_definition_repeat1,
    STATE(5131), 1,
      sym__string_or_identifier,
    ACTIONS(125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2021), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(141), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12265), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(587), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [114165] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      sym_identifier,
    ACTIONS(105), 1,
      anon_sym_BSLASH,
    ACTIONS(107), 1,
      anon_sym_function,
    ACTIONS(111), 1,
      anon_sym_if,
    ACTIONS(113), 1,
      anon_sym_for,
    ACTIONS(115), 1,
      anon_sym_while,
    ACTIONS(117), 1,
      anon_sym_repeat,
    ACTIONS(119), 1,
      anon_sym_QMARK,
    ACTIONS(121), 1,
      anon_sym_TILDE,
    ACTIONS(131), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(133), 1,
      sym__number_literal,
    ACTIONS(135), 1,
      anon_sym_SQUOTE,
    ACTIONS(137), 1,
      anon_sym_DQUOTE,
    ACTIONS(147), 1,
      sym__raw_string_literal,
    ACTIONS(149), 1,
      sym__external_open_parenthesis,
    ACTIONS(153), 1,
      sym__external_open_brace,
    ACTIONS(8381), 1,
      anon_sym_BANG,
    ACTIONS(12273), 1,
      sym_dot_dot_i,
    ACTIONS(12275), 1,
      sym__newline,
    STATE(10), 1,
      sym__open_brace,
    STATE(20), 1,
      sym__open_parenthesis,
    STATE(2016), 1,
      sym_string,
    STATE(2027), 1,
      sym__single_quoted_string,
    STATE(2041), 1,
      sym__double_quoted_string,
    STATE(3957), 1,
      aux_sym_function_definition_repeat1,
    STATE(5131), 1,
      sym__string_or_identifier,
    ACTIONS(125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2021), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(141), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12271), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(588), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [114294] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(12279), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12277), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4571), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [114423] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2826), 1,
      sym_identifier,
    ACTIONS(2828), 1,
      anon_sym_BSLASH,
    ACTIONS(2830), 1,
      anon_sym_function,
    ACTIONS(2832), 1,
      anon_sym_if,
    ACTIONS(2834), 1,
      anon_sym_for,
    ACTIONS(2836), 1,
      anon_sym_while,
    ACTIONS(2838), 1,
      anon_sym_repeat,
    ACTIONS(2840), 1,
      anon_sym_QMARK,
    ACTIONS(2842), 1,
      anon_sym_TILDE,
    ACTIONS(2850), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2852), 1,
      sym__number_literal,
    ACTIONS(2854), 1,
      anon_sym_SQUOTE,
    ACTIONS(2856), 1,
      anon_sym_DQUOTE,
    ACTIONS(2866), 1,
      sym__raw_string_literal,
    ACTIONS(2868), 1,
      sym__external_open_parenthesis,
    ACTIONS(2870), 1,
      sym__external_open_brace,
    ACTIONS(10915), 1,
      anon_sym_BANG,
    ACTIONS(12283), 1,
      sym_dot_dot_i,
    ACTIONS(12285), 1,
      sym__newline,
    STATE(178), 1,
      sym__open_parenthesis,
    STATE(244), 1,
      sym__open_brace,
    STATE(2522), 1,
      sym_string,
    STATE(2528), 1,
      sym__single_quoted_string,
    STATE(2529), 1,
      sym__double_quoted_string,
    STATE(3830), 1,
      aux_sym_function_definition_repeat1,
    STATE(5126), 1,
      sym__string_or_identifier,
    ACTIONS(2846), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2523), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2860), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12281), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1883), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [114552] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4752), 1,
      sym_identifier,
    ACTIONS(4754), 1,
      anon_sym_BSLASH,
    ACTIONS(4756), 1,
      anon_sym_function,
    ACTIONS(4758), 1,
      anon_sym_if,
    ACTIONS(4760), 1,
      anon_sym_for,
    ACTIONS(4762), 1,
      anon_sym_while,
    ACTIONS(4764), 1,
      anon_sym_repeat,
    ACTIONS(4766), 1,
      anon_sym_QMARK,
    ACTIONS(4768), 1,
      anon_sym_TILDE,
    ACTIONS(4776), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4778), 1,
      sym__number_literal,
    ACTIONS(4780), 1,
      anon_sym_SQUOTE,
    ACTIONS(4782), 1,
      anon_sym_DQUOTE,
    ACTIONS(4790), 1,
      sym__raw_string_literal,
    ACTIONS(4792), 1,
      sym__external_open_parenthesis,
    ACTIONS(4794), 1,
      sym__external_open_brace,
    ACTIONS(6353), 1,
      anon_sym_BANG,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(12289), 1,
      sym_dot_dot_i,
    STATE(192), 1,
      sym__open_brace,
    STATE(214), 1,
      sym__open_parenthesis,
    STATE(2664), 1,
      sym_string,
    STATE(2701), 1,
      sym__single_quoted_string,
    STATE(2745), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5148), 1,
      sym__string_or_identifier,
    ACTIONS(4772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2700), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4786), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12287), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1922), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [114681] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4053), 1,
      sym_identifier,
    ACTIONS(4055), 1,
      anon_sym_BSLASH,
    ACTIONS(4057), 1,
      anon_sym_function,
    ACTIONS(4059), 1,
      anon_sym_if,
    ACTIONS(4061), 1,
      anon_sym_for,
    ACTIONS(4063), 1,
      anon_sym_while,
    ACTIONS(4065), 1,
      anon_sym_repeat,
    ACTIONS(4067), 1,
      anon_sym_QMARK,
    ACTIONS(4069), 1,
      anon_sym_TILDE,
    ACTIONS(4077), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4079), 1,
      sym__number_literal,
    ACTIONS(4081), 1,
      anon_sym_SQUOTE,
    ACTIONS(4083), 1,
      anon_sym_DQUOTE,
    ACTIONS(4093), 1,
      sym__raw_string_literal,
    ACTIONS(4095), 1,
      sym__external_open_parenthesis,
    ACTIONS(4097), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7821), 1,
      anon_sym_BANG,
    ACTIONS(12293), 1,
      sym_dot_dot_i,
    STATE(133), 1,
      sym__open_brace,
    STATE(150), 1,
      sym__open_parenthesis,
    STATE(2534), 1,
      sym_string,
    STATE(2538), 1,
      sym__single_quoted_string,
    STATE(2539), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5143), 1,
      sym__string_or_identifier,
    ACTIONS(4073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2536), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4087), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12291), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1821), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [114810] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4053), 1,
      sym_identifier,
    ACTIONS(4055), 1,
      anon_sym_BSLASH,
    ACTIONS(4057), 1,
      anon_sym_function,
    ACTIONS(4059), 1,
      anon_sym_if,
    ACTIONS(4061), 1,
      anon_sym_for,
    ACTIONS(4063), 1,
      anon_sym_while,
    ACTIONS(4065), 1,
      anon_sym_repeat,
    ACTIONS(4067), 1,
      anon_sym_QMARK,
    ACTIONS(4069), 1,
      anon_sym_TILDE,
    ACTIONS(4077), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4079), 1,
      sym__number_literal,
    ACTIONS(4081), 1,
      anon_sym_SQUOTE,
    ACTIONS(4083), 1,
      anon_sym_DQUOTE,
    ACTIONS(4093), 1,
      sym__raw_string_literal,
    ACTIONS(4095), 1,
      sym__external_open_parenthesis,
    ACTIONS(4097), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7821), 1,
      anon_sym_BANG,
    ACTIONS(12297), 1,
      sym_dot_dot_i,
    STATE(133), 1,
      sym__open_brace,
    STATE(150), 1,
      sym__open_parenthesis,
    STATE(2534), 1,
      sym_string,
    STATE(2538), 1,
      sym__single_quoted_string,
    STATE(2539), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5143), 1,
      sym__string_or_identifier,
    ACTIONS(4073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2536), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4087), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12295), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1814), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [114939] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4053), 1,
      sym_identifier,
    ACTIONS(4055), 1,
      anon_sym_BSLASH,
    ACTIONS(4057), 1,
      anon_sym_function,
    ACTIONS(4059), 1,
      anon_sym_if,
    ACTIONS(4061), 1,
      anon_sym_for,
    ACTIONS(4063), 1,
      anon_sym_while,
    ACTIONS(4065), 1,
      anon_sym_repeat,
    ACTIONS(4067), 1,
      anon_sym_QMARK,
    ACTIONS(4069), 1,
      anon_sym_TILDE,
    ACTIONS(4077), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4079), 1,
      sym__number_literal,
    ACTIONS(4081), 1,
      anon_sym_SQUOTE,
    ACTIONS(4083), 1,
      anon_sym_DQUOTE,
    ACTIONS(4093), 1,
      sym__raw_string_literal,
    ACTIONS(4095), 1,
      sym__external_open_parenthesis,
    ACTIONS(4097), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7821), 1,
      anon_sym_BANG,
    ACTIONS(12301), 1,
      sym_dot_dot_i,
    STATE(133), 1,
      sym__open_brace,
    STATE(150), 1,
      sym__open_parenthesis,
    STATE(2534), 1,
      sym_string,
    STATE(2538), 1,
      sym__single_quoted_string,
    STATE(2539), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5143), 1,
      sym__string_or_identifier,
    ACTIONS(4073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2536), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4087), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12299), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1803), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [115068] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2826), 1,
      sym_identifier,
    ACTIONS(2828), 1,
      anon_sym_BSLASH,
    ACTIONS(2830), 1,
      anon_sym_function,
    ACTIONS(2832), 1,
      anon_sym_if,
    ACTIONS(2834), 1,
      anon_sym_for,
    ACTIONS(2836), 1,
      anon_sym_while,
    ACTIONS(2838), 1,
      anon_sym_repeat,
    ACTIONS(2840), 1,
      anon_sym_QMARK,
    ACTIONS(2842), 1,
      anon_sym_TILDE,
    ACTIONS(2850), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2852), 1,
      sym__number_literal,
    ACTIONS(2854), 1,
      anon_sym_SQUOTE,
    ACTIONS(2856), 1,
      anon_sym_DQUOTE,
    ACTIONS(2866), 1,
      sym__raw_string_literal,
    ACTIONS(2868), 1,
      sym__external_open_parenthesis,
    ACTIONS(2870), 1,
      sym__external_open_brace,
    ACTIONS(10915), 1,
      anon_sym_BANG,
    ACTIONS(12305), 1,
      sym_dot_dot_i,
    ACTIONS(12307), 1,
      sym__newline,
    STATE(178), 1,
      sym__open_parenthesis,
    STATE(244), 1,
      sym__open_brace,
    STATE(2522), 1,
      sym_string,
    STATE(2528), 1,
      sym__single_quoted_string,
    STATE(2529), 1,
      sym__double_quoted_string,
    STATE(3845), 1,
      aux_sym_function_definition_repeat1,
    STATE(5126), 1,
      sym__string_or_identifier,
    ACTIONS(2846), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2523), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2860), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12303), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1900), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [115197] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2826), 1,
      sym_identifier,
    ACTIONS(2828), 1,
      anon_sym_BSLASH,
    ACTIONS(2830), 1,
      anon_sym_function,
    ACTIONS(2832), 1,
      anon_sym_if,
    ACTIONS(2834), 1,
      anon_sym_for,
    ACTIONS(2836), 1,
      anon_sym_while,
    ACTIONS(2838), 1,
      anon_sym_repeat,
    ACTIONS(2840), 1,
      anon_sym_QMARK,
    ACTIONS(2842), 1,
      anon_sym_TILDE,
    ACTIONS(2850), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2852), 1,
      sym__number_literal,
    ACTIONS(2854), 1,
      anon_sym_SQUOTE,
    ACTIONS(2856), 1,
      anon_sym_DQUOTE,
    ACTIONS(2866), 1,
      sym__raw_string_literal,
    ACTIONS(2868), 1,
      sym__external_open_parenthesis,
    ACTIONS(2870), 1,
      sym__external_open_brace,
    ACTIONS(10915), 1,
      anon_sym_BANG,
    ACTIONS(12311), 1,
      sym_dot_dot_i,
    ACTIONS(12313), 1,
      sym__newline,
    STATE(178), 1,
      sym__open_parenthesis,
    STATE(244), 1,
      sym__open_brace,
    STATE(2522), 1,
      sym_string,
    STATE(2528), 1,
      sym__single_quoted_string,
    STATE(2529), 1,
      sym__double_quoted_string,
    STATE(3928), 1,
      aux_sym_function_definition_repeat1,
    STATE(5126), 1,
      sym__string_or_identifier,
    ACTIONS(2846), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2523), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2860), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12309), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1792), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [115326] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4053), 1,
      sym_identifier,
    ACTIONS(4055), 1,
      anon_sym_BSLASH,
    ACTIONS(4057), 1,
      anon_sym_function,
    ACTIONS(4059), 1,
      anon_sym_if,
    ACTIONS(4061), 1,
      anon_sym_for,
    ACTIONS(4063), 1,
      anon_sym_while,
    ACTIONS(4065), 1,
      anon_sym_repeat,
    ACTIONS(4067), 1,
      anon_sym_QMARK,
    ACTIONS(4069), 1,
      anon_sym_TILDE,
    ACTIONS(4077), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4079), 1,
      sym__number_literal,
    ACTIONS(4081), 1,
      anon_sym_SQUOTE,
    ACTIONS(4083), 1,
      anon_sym_DQUOTE,
    ACTIONS(4093), 1,
      sym__raw_string_literal,
    ACTIONS(4095), 1,
      sym__external_open_parenthesis,
    ACTIONS(4097), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7821), 1,
      anon_sym_BANG,
    ACTIONS(12317), 1,
      sym_dot_dot_i,
    STATE(133), 1,
      sym__open_brace,
    STATE(150), 1,
      sym__open_parenthesis,
    STATE(2534), 1,
      sym_string,
    STATE(2538), 1,
      sym__single_quoted_string,
    STATE(2539), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5143), 1,
      sym__string_or_identifier,
    ACTIONS(4073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2536), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4087), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12315), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1802), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [115455] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(273), 1,
      sym_identifier,
    ACTIONS(275), 1,
      anon_sym_BSLASH,
    ACTIONS(277), 1,
      anon_sym_function,
    ACTIONS(279), 1,
      anon_sym_if,
    ACTIONS(281), 1,
      anon_sym_for,
    ACTIONS(283), 1,
      anon_sym_while,
    ACTIONS(285), 1,
      anon_sym_repeat,
    ACTIONS(287), 1,
      anon_sym_QMARK,
    ACTIONS(289), 1,
      anon_sym_TILDE,
    ACTIONS(297), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(299), 1,
      sym__number_literal,
    ACTIONS(301), 1,
      anon_sym_SQUOTE,
    ACTIONS(303), 1,
      anon_sym_DQUOTE,
    ACTIONS(313), 1,
      sym__raw_string_literal,
    ACTIONS(315), 1,
      sym__external_open_parenthesis,
    ACTIONS(319), 1,
      sym__external_open_brace,
    ACTIONS(11159), 1,
      anon_sym_BANG,
    ACTIONS(12321), 1,
      sym_dot_dot_i,
    ACTIONS(12323), 1,
      sym__newline,
    STATE(57), 1,
      sym__open_parenthesis,
    STATE(59), 1,
      sym__open_brace,
    STATE(2187), 1,
      sym__double_quoted_string,
    STATE(2188), 1,
      sym__single_quoted_string,
    STATE(2192), 1,
      sym_string,
    STATE(3692), 1,
      aux_sym_function_definition_repeat1,
    STATE(5139), 1,
      sym__string_or_identifier,
    ACTIONS(293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2189), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(307), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12319), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(723), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [115584] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4053), 1,
      sym_identifier,
    ACTIONS(4055), 1,
      anon_sym_BSLASH,
    ACTIONS(4057), 1,
      anon_sym_function,
    ACTIONS(4059), 1,
      anon_sym_if,
    ACTIONS(4061), 1,
      anon_sym_for,
    ACTIONS(4063), 1,
      anon_sym_while,
    ACTIONS(4065), 1,
      anon_sym_repeat,
    ACTIONS(4067), 1,
      anon_sym_QMARK,
    ACTIONS(4069), 1,
      anon_sym_TILDE,
    ACTIONS(4077), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4079), 1,
      sym__number_literal,
    ACTIONS(4081), 1,
      anon_sym_SQUOTE,
    ACTIONS(4083), 1,
      anon_sym_DQUOTE,
    ACTIONS(4093), 1,
      sym__raw_string_literal,
    ACTIONS(4095), 1,
      sym__external_open_parenthesis,
    ACTIONS(4097), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7821), 1,
      anon_sym_BANG,
    ACTIONS(12327), 1,
      sym_dot_dot_i,
    STATE(133), 1,
      sym__open_brace,
    STATE(150), 1,
      sym__open_parenthesis,
    STATE(2534), 1,
      sym_string,
    STATE(2538), 1,
      sym__single_quoted_string,
    STATE(2539), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5143), 1,
      sym__string_or_identifier,
    ACTIONS(4073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2536), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4087), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12325), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1798), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [115713] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(273), 1,
      sym_identifier,
    ACTIONS(275), 1,
      anon_sym_BSLASH,
    ACTIONS(277), 1,
      anon_sym_function,
    ACTIONS(279), 1,
      anon_sym_if,
    ACTIONS(281), 1,
      anon_sym_for,
    ACTIONS(283), 1,
      anon_sym_while,
    ACTIONS(285), 1,
      anon_sym_repeat,
    ACTIONS(287), 1,
      anon_sym_QMARK,
    ACTIONS(289), 1,
      anon_sym_TILDE,
    ACTIONS(297), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(299), 1,
      sym__number_literal,
    ACTIONS(301), 1,
      anon_sym_SQUOTE,
    ACTIONS(303), 1,
      anon_sym_DQUOTE,
    ACTIONS(313), 1,
      sym__raw_string_literal,
    ACTIONS(315), 1,
      sym__external_open_parenthesis,
    ACTIONS(319), 1,
      sym__external_open_brace,
    ACTIONS(11159), 1,
      anon_sym_BANG,
    ACTIONS(12331), 1,
      sym_dot_dot_i,
    ACTIONS(12333), 1,
      sym__newline,
    STATE(57), 1,
      sym__open_parenthesis,
    STATE(59), 1,
      sym__open_brace,
    STATE(2187), 1,
      sym__double_quoted_string,
    STATE(2188), 1,
      sym__single_quoted_string,
    STATE(2192), 1,
      sym_string,
    STATE(3695), 1,
      aux_sym_function_definition_repeat1,
    STATE(5139), 1,
      sym__string_or_identifier,
    ACTIONS(293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2189), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(307), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12329), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(725), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [115842] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4053), 1,
      sym_identifier,
    ACTIONS(4055), 1,
      anon_sym_BSLASH,
    ACTIONS(4057), 1,
      anon_sym_function,
    ACTIONS(4059), 1,
      anon_sym_if,
    ACTIONS(4061), 1,
      anon_sym_for,
    ACTIONS(4063), 1,
      anon_sym_while,
    ACTIONS(4065), 1,
      anon_sym_repeat,
    ACTIONS(4067), 1,
      anon_sym_QMARK,
    ACTIONS(4069), 1,
      anon_sym_TILDE,
    ACTIONS(4077), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4079), 1,
      sym__number_literal,
    ACTIONS(4081), 1,
      anon_sym_SQUOTE,
    ACTIONS(4083), 1,
      anon_sym_DQUOTE,
    ACTIONS(4093), 1,
      sym__raw_string_literal,
    ACTIONS(4095), 1,
      sym__external_open_parenthesis,
    ACTIONS(4097), 1,
      sym__external_open_brace,
    ACTIONS(7821), 1,
      anon_sym_BANG,
    ACTIONS(12337), 1,
      sym_dot_dot_i,
    ACTIONS(12339), 1,
      sym__newline,
    STATE(133), 1,
      sym__open_brace,
    STATE(150), 1,
      sym__open_parenthesis,
    STATE(2534), 1,
      sym_string,
    STATE(2538), 1,
      sym__single_quoted_string,
    STATE(2539), 1,
      sym__double_quoted_string,
    STATE(3889), 1,
      aux_sym_function_definition_repeat1,
    STATE(5143), 1,
      sym__string_or_identifier,
    ACTIONS(4073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2536), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4087), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12335), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1004), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [115971] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4053), 1,
      sym_identifier,
    ACTIONS(4055), 1,
      anon_sym_BSLASH,
    ACTIONS(4057), 1,
      anon_sym_function,
    ACTIONS(4059), 1,
      anon_sym_if,
    ACTIONS(4061), 1,
      anon_sym_for,
    ACTIONS(4063), 1,
      anon_sym_while,
    ACTIONS(4065), 1,
      anon_sym_repeat,
    ACTIONS(4067), 1,
      anon_sym_QMARK,
    ACTIONS(4069), 1,
      anon_sym_TILDE,
    ACTIONS(4077), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4079), 1,
      sym__number_literal,
    ACTIONS(4081), 1,
      anon_sym_SQUOTE,
    ACTIONS(4083), 1,
      anon_sym_DQUOTE,
    ACTIONS(4093), 1,
      sym__raw_string_literal,
    ACTIONS(4095), 1,
      sym__external_open_parenthesis,
    ACTIONS(4097), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7821), 1,
      anon_sym_BANG,
    ACTIONS(12343), 1,
      sym_dot_dot_i,
    STATE(133), 1,
      sym__open_brace,
    STATE(150), 1,
      sym__open_parenthesis,
    STATE(2534), 1,
      sym_string,
    STATE(2538), 1,
      sym__single_quoted_string,
    STATE(2539), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5143), 1,
      sym__string_or_identifier,
    ACTIONS(4073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2536), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4087), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12341), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1001), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [116100] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2826), 1,
      sym_identifier,
    ACTIONS(2828), 1,
      anon_sym_BSLASH,
    ACTIONS(2830), 1,
      anon_sym_function,
    ACTIONS(2832), 1,
      anon_sym_if,
    ACTIONS(2834), 1,
      anon_sym_for,
    ACTIONS(2836), 1,
      anon_sym_while,
    ACTIONS(2838), 1,
      anon_sym_repeat,
    ACTIONS(2840), 1,
      anon_sym_QMARK,
    ACTIONS(2842), 1,
      anon_sym_TILDE,
    ACTIONS(2850), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2852), 1,
      sym__number_literal,
    ACTIONS(2854), 1,
      anon_sym_SQUOTE,
    ACTIONS(2856), 1,
      anon_sym_DQUOTE,
    ACTIONS(2866), 1,
      sym__raw_string_literal,
    ACTIONS(2868), 1,
      sym__external_open_parenthesis,
    ACTIONS(2870), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(10915), 1,
      anon_sym_BANG,
    ACTIONS(12347), 1,
      sym_dot_dot_i,
    STATE(178), 1,
      sym__open_parenthesis,
    STATE(244), 1,
      sym__open_brace,
    STATE(2522), 1,
      sym_string,
    STATE(2528), 1,
      sym__single_quoted_string,
    STATE(2529), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5126), 1,
      sym__string_or_identifier,
    ACTIONS(2846), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2523), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2860), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12345), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1727), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [116229] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3845), 1,
      sym_identifier,
    ACTIONS(3847), 1,
      anon_sym_BSLASH,
    ACTIONS(3849), 1,
      anon_sym_function,
    ACTIONS(3851), 1,
      anon_sym_if,
    ACTIONS(3853), 1,
      anon_sym_for,
    ACTIONS(3855), 1,
      anon_sym_while,
    ACTIONS(3857), 1,
      anon_sym_repeat,
    ACTIONS(3859), 1,
      anon_sym_QMARK,
    ACTIONS(3861), 1,
      anon_sym_TILDE,
    ACTIONS(3869), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3871), 1,
      sym__number_literal,
    ACTIONS(3873), 1,
      anon_sym_SQUOTE,
    ACTIONS(3875), 1,
      anon_sym_DQUOTE,
    ACTIONS(3885), 1,
      sym__raw_string_literal,
    ACTIONS(3887), 1,
      sym__external_open_parenthesis,
    ACTIONS(3891), 1,
      sym__external_open_brace,
    ACTIONS(6389), 1,
      anon_sym_BANG,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(12351), 1,
      sym_dot_dot_i,
    STATE(154), 1,
      sym__open_brace,
    STATE(350), 1,
      sym__open_parenthesis,
    STATE(2620), 1,
      sym__double_quoted_string,
    STATE(2673), 1,
      sym_string,
    STATE(2735), 1,
      sym__single_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5135), 1,
      sym__string_or_identifier,
    ACTIONS(3865), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2578), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3879), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12349), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2083), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [116358] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2826), 1,
      sym_identifier,
    ACTIONS(2828), 1,
      anon_sym_BSLASH,
    ACTIONS(2830), 1,
      anon_sym_function,
    ACTIONS(2832), 1,
      anon_sym_if,
    ACTIONS(2834), 1,
      anon_sym_for,
    ACTIONS(2836), 1,
      anon_sym_while,
    ACTIONS(2838), 1,
      anon_sym_repeat,
    ACTIONS(2840), 1,
      anon_sym_QMARK,
    ACTIONS(2842), 1,
      anon_sym_TILDE,
    ACTIONS(2850), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2852), 1,
      sym__number_literal,
    ACTIONS(2854), 1,
      anon_sym_SQUOTE,
    ACTIONS(2856), 1,
      anon_sym_DQUOTE,
    ACTIONS(2866), 1,
      sym__raw_string_literal,
    ACTIONS(2868), 1,
      sym__external_open_parenthesis,
    ACTIONS(2870), 1,
      sym__external_open_brace,
    ACTIONS(10915), 1,
      anon_sym_BANG,
    ACTIONS(12355), 1,
      sym_dot_dot_i,
    ACTIONS(12357), 1,
      sym__newline,
    STATE(178), 1,
      sym__open_parenthesis,
    STATE(244), 1,
      sym__open_brace,
    STATE(2522), 1,
      sym_string,
    STATE(2528), 1,
      sym__single_quoted_string,
    STATE(2529), 1,
      sym__double_quoted_string,
    STATE(3884), 1,
      aux_sym_function_definition_repeat1,
    STATE(5126), 1,
      sym__string_or_identifier,
    ACTIONS(2846), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2523), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2860), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12353), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1580), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [116487] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4053), 1,
      sym_identifier,
    ACTIONS(4055), 1,
      anon_sym_BSLASH,
    ACTIONS(4057), 1,
      anon_sym_function,
    ACTIONS(4059), 1,
      anon_sym_if,
    ACTIONS(4061), 1,
      anon_sym_for,
    ACTIONS(4063), 1,
      anon_sym_while,
    ACTIONS(4065), 1,
      anon_sym_repeat,
    ACTIONS(4067), 1,
      anon_sym_QMARK,
    ACTIONS(4069), 1,
      anon_sym_TILDE,
    ACTIONS(4077), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4079), 1,
      sym__number_literal,
    ACTIONS(4081), 1,
      anon_sym_SQUOTE,
    ACTIONS(4083), 1,
      anon_sym_DQUOTE,
    ACTIONS(4093), 1,
      sym__raw_string_literal,
    ACTIONS(4095), 1,
      sym__external_open_parenthesis,
    ACTIONS(4097), 1,
      sym__external_open_brace,
    ACTIONS(7821), 1,
      anon_sym_BANG,
    ACTIONS(12361), 1,
      sym_dot_dot_i,
    ACTIONS(12363), 1,
      sym__newline,
    STATE(133), 1,
      sym__open_brace,
    STATE(150), 1,
      sym__open_parenthesis,
    STATE(2534), 1,
      sym_string,
    STATE(2538), 1,
      sym__single_quoted_string,
    STATE(2539), 1,
      sym__double_quoted_string,
    STATE(3851), 1,
      aux_sym_function_definition_repeat1,
    STATE(5143), 1,
      sym__string_or_identifier,
    ACTIONS(4073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2536), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4087), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12359), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1857), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [116616] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2826), 1,
      sym_identifier,
    ACTIONS(2828), 1,
      anon_sym_BSLASH,
    ACTIONS(2830), 1,
      anon_sym_function,
    ACTIONS(2832), 1,
      anon_sym_if,
    ACTIONS(2834), 1,
      anon_sym_for,
    ACTIONS(2836), 1,
      anon_sym_while,
    ACTIONS(2838), 1,
      anon_sym_repeat,
    ACTIONS(2840), 1,
      anon_sym_QMARK,
    ACTIONS(2842), 1,
      anon_sym_TILDE,
    ACTIONS(2850), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2852), 1,
      sym__number_literal,
    ACTIONS(2854), 1,
      anon_sym_SQUOTE,
    ACTIONS(2856), 1,
      anon_sym_DQUOTE,
    ACTIONS(2866), 1,
      sym__raw_string_literal,
    ACTIONS(2868), 1,
      sym__external_open_parenthesis,
    ACTIONS(2870), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(10915), 1,
      anon_sym_BANG,
    ACTIONS(12367), 1,
      sym_dot_dot_i,
    STATE(178), 1,
      sym__open_parenthesis,
    STATE(244), 1,
      sym__open_brace,
    STATE(2522), 1,
      sym_string,
    STATE(2528), 1,
      sym__single_quoted_string,
    STATE(2529), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5126), 1,
      sym__string_or_identifier,
    ACTIONS(2846), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2523), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2860), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12365), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1730), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [116745] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      sym_identifier,
    ACTIONS(105), 1,
      anon_sym_BSLASH,
    ACTIONS(107), 1,
      anon_sym_function,
    ACTIONS(111), 1,
      anon_sym_if,
    ACTIONS(113), 1,
      anon_sym_for,
    ACTIONS(115), 1,
      anon_sym_while,
    ACTIONS(117), 1,
      anon_sym_repeat,
    ACTIONS(119), 1,
      anon_sym_QMARK,
    ACTIONS(121), 1,
      anon_sym_TILDE,
    ACTIONS(131), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(133), 1,
      sym__number_literal,
    ACTIONS(135), 1,
      anon_sym_SQUOTE,
    ACTIONS(137), 1,
      anon_sym_DQUOTE,
    ACTIONS(147), 1,
      sym__raw_string_literal,
    ACTIONS(149), 1,
      sym__external_open_parenthesis,
    ACTIONS(153), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8381), 1,
      anon_sym_BANG,
    ACTIONS(12371), 1,
      sym_dot_dot_i,
    STATE(10), 1,
      sym__open_brace,
    STATE(20), 1,
      sym__open_parenthesis,
    STATE(2016), 1,
      sym_string,
    STATE(2027), 1,
      sym__single_quoted_string,
    STATE(2041), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5131), 1,
      sym__string_or_identifier,
    ACTIONS(125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2021), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(141), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12369), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(590), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [116874] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(273), 1,
      sym_identifier,
    ACTIONS(275), 1,
      anon_sym_BSLASH,
    ACTIONS(277), 1,
      anon_sym_function,
    ACTIONS(279), 1,
      anon_sym_if,
    ACTIONS(281), 1,
      anon_sym_for,
    ACTIONS(283), 1,
      anon_sym_while,
    ACTIONS(285), 1,
      anon_sym_repeat,
    ACTIONS(287), 1,
      anon_sym_QMARK,
    ACTIONS(289), 1,
      anon_sym_TILDE,
    ACTIONS(297), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(299), 1,
      sym__number_literal,
    ACTIONS(301), 1,
      anon_sym_SQUOTE,
    ACTIONS(303), 1,
      anon_sym_DQUOTE,
    ACTIONS(313), 1,
      sym__raw_string_literal,
    ACTIONS(315), 1,
      sym__external_open_parenthesis,
    ACTIONS(319), 1,
      sym__external_open_brace,
    ACTIONS(11159), 1,
      anon_sym_BANG,
    ACTIONS(12375), 1,
      sym_dot_dot_i,
    ACTIONS(12377), 1,
      sym__newline,
    STATE(57), 1,
      sym__open_parenthesis,
    STATE(59), 1,
      sym__open_brace,
    STATE(2187), 1,
      sym__double_quoted_string,
    STATE(2188), 1,
      sym__single_quoted_string,
    STATE(2192), 1,
      sym_string,
    STATE(3700), 1,
      aux_sym_function_definition_repeat1,
    STATE(5139), 1,
      sym__string_or_identifier,
    ACTIONS(293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2189), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(307), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12373), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(726), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [117003] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      sym_identifier,
    ACTIONS(105), 1,
      anon_sym_BSLASH,
    ACTIONS(107), 1,
      anon_sym_function,
    ACTIONS(111), 1,
      anon_sym_if,
    ACTIONS(113), 1,
      anon_sym_for,
    ACTIONS(115), 1,
      anon_sym_while,
    ACTIONS(117), 1,
      anon_sym_repeat,
    ACTIONS(119), 1,
      anon_sym_QMARK,
    ACTIONS(121), 1,
      anon_sym_TILDE,
    ACTIONS(131), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(133), 1,
      sym__number_literal,
    ACTIONS(135), 1,
      anon_sym_SQUOTE,
    ACTIONS(137), 1,
      anon_sym_DQUOTE,
    ACTIONS(147), 1,
      sym__raw_string_literal,
    ACTIONS(149), 1,
      sym__external_open_parenthesis,
    ACTIONS(153), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8381), 1,
      anon_sym_BANG,
    ACTIONS(12381), 1,
      sym_dot_dot_i,
    STATE(10), 1,
      sym__open_brace,
    STATE(20), 1,
      sym__open_parenthesis,
    STATE(2016), 1,
      sym_string,
    STATE(2027), 1,
      sym__single_quoted_string,
    STATE(2041), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5131), 1,
      sym__string_or_identifier,
    ACTIONS(125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2021), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(141), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12379), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(500), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [117132] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(12385), 1,
      sym_dot_dot_i,
    STATE(292), 1,
      sym__open_brace,
    STATE(293), 1,
      sym__open_parenthesis,
    STATE(2562), 1,
      sym_string,
    STATE(2737), 1,
      sym__double_quoted_string,
    STATE(2738), 1,
      sym__single_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5152), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2739), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12383), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2156), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [117261] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      sym_identifier,
    ACTIONS(105), 1,
      anon_sym_BSLASH,
    ACTIONS(107), 1,
      anon_sym_function,
    ACTIONS(111), 1,
      anon_sym_if,
    ACTIONS(113), 1,
      anon_sym_for,
    ACTIONS(115), 1,
      anon_sym_while,
    ACTIONS(117), 1,
      anon_sym_repeat,
    ACTIONS(119), 1,
      anon_sym_QMARK,
    ACTIONS(121), 1,
      anon_sym_TILDE,
    ACTIONS(131), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(133), 1,
      sym__number_literal,
    ACTIONS(135), 1,
      anon_sym_SQUOTE,
    ACTIONS(137), 1,
      anon_sym_DQUOTE,
    ACTIONS(147), 1,
      sym__raw_string_literal,
    ACTIONS(149), 1,
      sym__external_open_parenthesis,
    ACTIONS(153), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8381), 1,
      anon_sym_BANG,
    ACTIONS(12389), 1,
      sym_dot_dot_i,
    STATE(10), 1,
      sym__open_brace,
    STATE(20), 1,
      sym__open_parenthesis,
    STATE(2016), 1,
      sym_string,
    STATE(2027), 1,
      sym__single_quoted_string,
    STATE(2041), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5131), 1,
      sym__string_or_identifier,
    ACTIONS(125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2021), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(141), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12387), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(591), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [117390] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(273), 1,
      sym_identifier,
    ACTIONS(275), 1,
      anon_sym_BSLASH,
    ACTIONS(277), 1,
      anon_sym_function,
    ACTIONS(279), 1,
      anon_sym_if,
    ACTIONS(281), 1,
      anon_sym_for,
    ACTIONS(283), 1,
      anon_sym_while,
    ACTIONS(285), 1,
      anon_sym_repeat,
    ACTIONS(287), 1,
      anon_sym_QMARK,
    ACTIONS(289), 1,
      anon_sym_TILDE,
    ACTIONS(297), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(299), 1,
      sym__number_literal,
    ACTIONS(301), 1,
      anon_sym_SQUOTE,
    ACTIONS(303), 1,
      anon_sym_DQUOTE,
    ACTIONS(313), 1,
      sym__raw_string_literal,
    ACTIONS(315), 1,
      sym__external_open_parenthesis,
    ACTIONS(319), 1,
      sym__external_open_brace,
    ACTIONS(11159), 1,
      anon_sym_BANG,
    ACTIONS(12393), 1,
      sym_dot_dot_i,
    ACTIONS(12395), 1,
      sym__newline,
    STATE(57), 1,
      sym__open_parenthesis,
    STATE(59), 1,
      sym__open_brace,
    STATE(2187), 1,
      sym__double_quoted_string,
    STATE(2188), 1,
      sym__single_quoted_string,
    STATE(2192), 1,
      sym_string,
    STATE(3701), 1,
      aux_sym_function_definition_repeat1,
    STATE(5139), 1,
      sym__string_or_identifier,
    ACTIONS(293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2189), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(307), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12391), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(727), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [117519] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      sym_identifier,
    ACTIONS(105), 1,
      anon_sym_BSLASH,
    ACTIONS(107), 1,
      anon_sym_function,
    ACTIONS(111), 1,
      anon_sym_if,
    ACTIONS(113), 1,
      anon_sym_for,
    ACTIONS(115), 1,
      anon_sym_while,
    ACTIONS(117), 1,
      anon_sym_repeat,
    ACTIONS(119), 1,
      anon_sym_QMARK,
    ACTIONS(121), 1,
      anon_sym_TILDE,
    ACTIONS(131), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(133), 1,
      sym__number_literal,
    ACTIONS(135), 1,
      anon_sym_SQUOTE,
    ACTIONS(137), 1,
      anon_sym_DQUOTE,
    ACTIONS(147), 1,
      sym__raw_string_literal,
    ACTIONS(149), 1,
      sym__external_open_parenthesis,
    ACTIONS(153), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8381), 1,
      anon_sym_BANG,
    ACTIONS(12399), 1,
      sym_dot_dot_i,
    STATE(10), 1,
      sym__open_brace,
    STATE(20), 1,
      sym__open_parenthesis,
    STATE(2016), 1,
      sym_string,
    STATE(2027), 1,
      sym__single_quoted_string,
    STATE(2041), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5131), 1,
      sym__string_or_identifier,
    ACTIONS(125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2021), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(141), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12397), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(592), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [117648] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1337), 1,
      sym_identifier,
    ACTIONS(1339), 1,
      anon_sym_BSLASH,
    ACTIONS(1341), 1,
      anon_sym_function,
    ACTIONS(1343), 1,
      anon_sym_if,
    ACTIONS(1345), 1,
      anon_sym_for,
    ACTIONS(1347), 1,
      anon_sym_while,
    ACTIONS(1349), 1,
      anon_sym_repeat,
    ACTIONS(1351), 1,
      anon_sym_QMARK,
    ACTIONS(1353), 1,
      anon_sym_TILDE,
    ACTIONS(1361), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1363), 1,
      sym__number_literal,
    ACTIONS(1365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1367), 1,
      anon_sym_DQUOTE,
    ACTIONS(1377), 1,
      sym__raw_string_literal,
    ACTIONS(1379), 1,
      sym__external_open_parenthesis,
    ACTIONS(1383), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9409), 1,
      anon_sym_BANG,
    ACTIONS(12403), 1,
      sym_dot_dot_i,
    STATE(94), 1,
      sym__open_brace,
    STATE(190), 1,
      sym__open_parenthesis,
    STATE(2231), 1,
      sym_string,
    STATE(2354), 1,
      sym__double_quoted_string,
    STATE(2355), 1,
      sym__single_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5156), 1,
      sym__string_or_identifier,
    ACTIONS(1357), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2356), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1371), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12401), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1020), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [117777] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      sym_identifier,
    ACTIONS(105), 1,
      anon_sym_BSLASH,
    ACTIONS(107), 1,
      anon_sym_function,
    ACTIONS(111), 1,
      anon_sym_if,
    ACTIONS(113), 1,
      anon_sym_for,
    ACTIONS(115), 1,
      anon_sym_while,
    ACTIONS(117), 1,
      anon_sym_repeat,
    ACTIONS(119), 1,
      anon_sym_QMARK,
    ACTIONS(121), 1,
      anon_sym_TILDE,
    ACTIONS(131), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(133), 1,
      sym__number_literal,
    ACTIONS(135), 1,
      anon_sym_SQUOTE,
    ACTIONS(137), 1,
      anon_sym_DQUOTE,
    ACTIONS(147), 1,
      sym__raw_string_literal,
    ACTIONS(149), 1,
      sym__external_open_parenthesis,
    ACTIONS(153), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8381), 1,
      anon_sym_BANG,
    ACTIONS(12407), 1,
      sym_dot_dot_i,
    STATE(10), 1,
      sym__open_brace,
    STATE(20), 1,
      sym__open_parenthesis,
    STATE(2016), 1,
      sym_string,
    STATE(2027), 1,
      sym__single_quoted_string,
    STATE(2041), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5131), 1,
      sym__string_or_identifier,
    ACTIONS(125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2021), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(141), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12405), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(593), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [117906] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2826), 1,
      sym_identifier,
    ACTIONS(2828), 1,
      anon_sym_BSLASH,
    ACTIONS(2830), 1,
      anon_sym_function,
    ACTIONS(2832), 1,
      anon_sym_if,
    ACTIONS(2834), 1,
      anon_sym_for,
    ACTIONS(2836), 1,
      anon_sym_while,
    ACTIONS(2838), 1,
      anon_sym_repeat,
    ACTIONS(2840), 1,
      anon_sym_QMARK,
    ACTIONS(2842), 1,
      anon_sym_TILDE,
    ACTIONS(2850), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2852), 1,
      sym__number_literal,
    ACTIONS(2854), 1,
      anon_sym_SQUOTE,
    ACTIONS(2856), 1,
      anon_sym_DQUOTE,
    ACTIONS(2866), 1,
      sym__raw_string_literal,
    ACTIONS(2868), 1,
      sym__external_open_parenthesis,
    ACTIONS(2870), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(10915), 1,
      anon_sym_BANG,
    ACTIONS(12411), 1,
      sym_dot_dot_i,
    STATE(178), 1,
      sym__open_parenthesis,
    STATE(244), 1,
      sym__open_brace,
    STATE(2522), 1,
      sym_string,
    STATE(2528), 1,
      sym__single_quoted_string,
    STATE(2529), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5126), 1,
      sym__string_or_identifier,
    ACTIONS(2846), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2523), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2860), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12409), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1751), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [118035] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      sym_identifier,
    ACTIONS(105), 1,
      anon_sym_BSLASH,
    ACTIONS(107), 1,
      anon_sym_function,
    ACTIONS(111), 1,
      anon_sym_if,
    ACTIONS(113), 1,
      anon_sym_for,
    ACTIONS(115), 1,
      anon_sym_while,
    ACTIONS(117), 1,
      anon_sym_repeat,
    ACTIONS(119), 1,
      anon_sym_QMARK,
    ACTIONS(121), 1,
      anon_sym_TILDE,
    ACTIONS(131), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(133), 1,
      sym__number_literal,
    ACTIONS(135), 1,
      anon_sym_SQUOTE,
    ACTIONS(137), 1,
      anon_sym_DQUOTE,
    ACTIONS(147), 1,
      sym__raw_string_literal,
    ACTIONS(149), 1,
      sym__external_open_parenthesis,
    ACTIONS(153), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8381), 1,
      anon_sym_BANG,
    ACTIONS(12415), 1,
      sym_dot_dot_i,
    STATE(10), 1,
      sym__open_brace,
    STATE(20), 1,
      sym__open_parenthesis,
    STATE(2016), 1,
      sym_string,
    STATE(2027), 1,
      sym__single_quoted_string,
    STATE(2041), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5131), 1,
      sym__string_or_identifier,
    ACTIONS(125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2021), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(141), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12413), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(594), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [118164] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1337), 1,
      sym_identifier,
    ACTIONS(1339), 1,
      anon_sym_BSLASH,
    ACTIONS(1341), 1,
      anon_sym_function,
    ACTIONS(1343), 1,
      anon_sym_if,
    ACTIONS(1345), 1,
      anon_sym_for,
    ACTIONS(1347), 1,
      anon_sym_while,
    ACTIONS(1349), 1,
      anon_sym_repeat,
    ACTIONS(1351), 1,
      anon_sym_QMARK,
    ACTIONS(1353), 1,
      anon_sym_TILDE,
    ACTIONS(1361), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1363), 1,
      sym__number_literal,
    ACTIONS(1365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1367), 1,
      anon_sym_DQUOTE,
    ACTIONS(1377), 1,
      sym__raw_string_literal,
    ACTIONS(1379), 1,
      sym__external_open_parenthesis,
    ACTIONS(1383), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9409), 1,
      anon_sym_BANG,
    ACTIONS(12419), 1,
      sym_dot_dot_i,
    STATE(94), 1,
      sym__open_brace,
    STATE(190), 1,
      sym__open_parenthesis,
    STATE(2231), 1,
      sym_string,
    STATE(2354), 1,
      sym__double_quoted_string,
    STATE(2355), 1,
      sym__single_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5156), 1,
      sym__string_or_identifier,
    ACTIONS(1357), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2356), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1371), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12417), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1019), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [118293] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      sym_identifier,
    ACTIONS(105), 1,
      anon_sym_BSLASH,
    ACTIONS(107), 1,
      anon_sym_function,
    ACTIONS(111), 1,
      anon_sym_if,
    ACTIONS(113), 1,
      anon_sym_for,
    ACTIONS(115), 1,
      anon_sym_while,
    ACTIONS(117), 1,
      anon_sym_repeat,
    ACTIONS(119), 1,
      anon_sym_QMARK,
    ACTIONS(121), 1,
      anon_sym_TILDE,
    ACTIONS(131), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(133), 1,
      sym__number_literal,
    ACTIONS(135), 1,
      anon_sym_SQUOTE,
    ACTIONS(137), 1,
      anon_sym_DQUOTE,
    ACTIONS(147), 1,
      sym__raw_string_literal,
    ACTIONS(149), 1,
      sym__external_open_parenthesis,
    ACTIONS(153), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8381), 1,
      anon_sym_BANG,
    ACTIONS(12423), 1,
      sym_dot_dot_i,
    STATE(10), 1,
      sym__open_brace,
    STATE(20), 1,
      sym__open_parenthesis,
    STATE(2016), 1,
      sym_string,
    STATE(2027), 1,
      sym__single_quoted_string,
    STATE(2041), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5131), 1,
      sym__string_or_identifier,
    ACTIONS(125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2021), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(141), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12421), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(595), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [118422] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2826), 1,
      sym_identifier,
    ACTIONS(2828), 1,
      anon_sym_BSLASH,
    ACTIONS(2830), 1,
      anon_sym_function,
    ACTIONS(2832), 1,
      anon_sym_if,
    ACTIONS(2834), 1,
      anon_sym_for,
    ACTIONS(2836), 1,
      anon_sym_while,
    ACTIONS(2838), 1,
      anon_sym_repeat,
    ACTIONS(2840), 1,
      anon_sym_QMARK,
    ACTIONS(2842), 1,
      anon_sym_TILDE,
    ACTIONS(2850), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2852), 1,
      sym__number_literal,
    ACTIONS(2854), 1,
      anon_sym_SQUOTE,
    ACTIONS(2856), 1,
      anon_sym_DQUOTE,
    ACTIONS(2866), 1,
      sym__raw_string_literal,
    ACTIONS(2868), 1,
      sym__external_open_parenthesis,
    ACTIONS(2870), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(10915), 1,
      anon_sym_BANG,
    ACTIONS(12427), 1,
      sym_dot_dot_i,
    STATE(178), 1,
      sym__open_parenthesis,
    STATE(244), 1,
      sym__open_brace,
    STATE(2522), 1,
      sym_string,
    STATE(2528), 1,
      sym__single_quoted_string,
    STATE(2529), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5126), 1,
      sym__string_or_identifier,
    ACTIONS(2846), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2523), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2860), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12425), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1752), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [118551] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      sym_identifier,
    ACTIONS(105), 1,
      anon_sym_BSLASH,
    ACTIONS(107), 1,
      anon_sym_function,
    ACTIONS(111), 1,
      anon_sym_if,
    ACTIONS(113), 1,
      anon_sym_for,
    ACTIONS(115), 1,
      anon_sym_while,
    ACTIONS(117), 1,
      anon_sym_repeat,
    ACTIONS(119), 1,
      anon_sym_QMARK,
    ACTIONS(121), 1,
      anon_sym_TILDE,
    ACTIONS(131), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(133), 1,
      sym__number_literal,
    ACTIONS(135), 1,
      anon_sym_SQUOTE,
    ACTIONS(137), 1,
      anon_sym_DQUOTE,
    ACTIONS(147), 1,
      sym__raw_string_literal,
    ACTIONS(149), 1,
      sym__external_open_parenthesis,
    ACTIONS(153), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8381), 1,
      anon_sym_BANG,
    ACTIONS(12431), 1,
      sym_dot_dot_i,
    STATE(10), 1,
      sym__open_brace,
    STATE(20), 1,
      sym__open_parenthesis,
    STATE(2016), 1,
      sym_string,
    STATE(2027), 1,
      sym__single_quoted_string,
    STATE(2041), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5131), 1,
      sym__string_or_identifier,
    ACTIONS(125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2021), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(141), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12429), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(596), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [118680] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1337), 1,
      sym_identifier,
    ACTIONS(1339), 1,
      anon_sym_BSLASH,
    ACTIONS(1341), 1,
      anon_sym_function,
    ACTIONS(1343), 1,
      anon_sym_if,
    ACTIONS(1345), 1,
      anon_sym_for,
    ACTIONS(1347), 1,
      anon_sym_while,
    ACTIONS(1349), 1,
      anon_sym_repeat,
    ACTIONS(1351), 1,
      anon_sym_QMARK,
    ACTIONS(1353), 1,
      anon_sym_TILDE,
    ACTIONS(1361), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1363), 1,
      sym__number_literal,
    ACTIONS(1365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1367), 1,
      anon_sym_DQUOTE,
    ACTIONS(1377), 1,
      sym__raw_string_literal,
    ACTIONS(1379), 1,
      sym__external_open_parenthesis,
    ACTIONS(1383), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9409), 1,
      anon_sym_BANG,
    ACTIONS(12435), 1,
      sym_dot_dot_i,
    STATE(94), 1,
      sym__open_brace,
    STATE(190), 1,
      sym__open_parenthesis,
    STATE(2231), 1,
      sym_string,
    STATE(2354), 1,
      sym__double_quoted_string,
    STATE(2355), 1,
      sym__single_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5156), 1,
      sym__string_or_identifier,
    ACTIONS(1357), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2356), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1371), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12433), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1018), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [118809] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      sym_identifier,
    ACTIONS(105), 1,
      anon_sym_BSLASH,
    ACTIONS(107), 1,
      anon_sym_function,
    ACTIONS(111), 1,
      anon_sym_if,
    ACTIONS(113), 1,
      anon_sym_for,
    ACTIONS(115), 1,
      anon_sym_while,
    ACTIONS(117), 1,
      anon_sym_repeat,
    ACTIONS(119), 1,
      anon_sym_QMARK,
    ACTIONS(121), 1,
      anon_sym_TILDE,
    ACTIONS(131), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(133), 1,
      sym__number_literal,
    ACTIONS(135), 1,
      anon_sym_SQUOTE,
    ACTIONS(137), 1,
      anon_sym_DQUOTE,
    ACTIONS(147), 1,
      sym__raw_string_literal,
    ACTIONS(149), 1,
      sym__external_open_parenthesis,
    ACTIONS(153), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8381), 1,
      anon_sym_BANG,
    ACTIONS(12439), 1,
      sym_dot_dot_i,
    STATE(10), 1,
      sym__open_brace,
    STATE(20), 1,
      sym__open_parenthesis,
    STATE(2016), 1,
      sym_string,
    STATE(2027), 1,
      sym__single_quoted_string,
    STATE(2041), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5131), 1,
      sym__string_or_identifier,
    ACTIONS(125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2021), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(141), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12437), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(597), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [118938] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(12443), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12441), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4572), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [119067] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      sym_identifier,
    ACTIONS(105), 1,
      anon_sym_BSLASH,
    ACTIONS(107), 1,
      anon_sym_function,
    ACTIONS(111), 1,
      anon_sym_if,
    ACTIONS(113), 1,
      anon_sym_for,
    ACTIONS(115), 1,
      anon_sym_while,
    ACTIONS(117), 1,
      anon_sym_repeat,
    ACTIONS(119), 1,
      anon_sym_QMARK,
    ACTIONS(121), 1,
      anon_sym_TILDE,
    ACTIONS(131), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(133), 1,
      sym__number_literal,
    ACTIONS(135), 1,
      anon_sym_SQUOTE,
    ACTIONS(137), 1,
      anon_sym_DQUOTE,
    ACTIONS(147), 1,
      sym__raw_string_literal,
    ACTIONS(149), 1,
      sym__external_open_parenthesis,
    ACTIONS(153), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8381), 1,
      anon_sym_BANG,
    ACTIONS(12447), 1,
      sym_dot_dot_i,
    STATE(10), 1,
      sym__open_brace,
    STATE(20), 1,
      sym__open_parenthesis,
    STATE(2016), 1,
      sym_string,
    STATE(2027), 1,
      sym__single_quoted_string,
    STATE(2041), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5131), 1,
      sym__string_or_identifier,
    ACTIONS(125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2021), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(141), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12445), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(598), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [119196] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(273), 1,
      sym_identifier,
    ACTIONS(275), 1,
      anon_sym_BSLASH,
    ACTIONS(277), 1,
      anon_sym_function,
    ACTIONS(279), 1,
      anon_sym_if,
    ACTIONS(281), 1,
      anon_sym_for,
    ACTIONS(283), 1,
      anon_sym_while,
    ACTIONS(285), 1,
      anon_sym_repeat,
    ACTIONS(287), 1,
      anon_sym_QMARK,
    ACTIONS(289), 1,
      anon_sym_TILDE,
    ACTIONS(297), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(299), 1,
      sym__number_literal,
    ACTIONS(301), 1,
      anon_sym_SQUOTE,
    ACTIONS(303), 1,
      anon_sym_DQUOTE,
    ACTIONS(313), 1,
      sym__raw_string_literal,
    ACTIONS(315), 1,
      sym__external_open_parenthesis,
    ACTIONS(319), 1,
      sym__external_open_brace,
    ACTIONS(11159), 1,
      anon_sym_BANG,
    ACTIONS(12451), 1,
      sym_dot_dot_i,
    ACTIONS(12453), 1,
      sym__newline,
    STATE(57), 1,
      sym__open_parenthesis,
    STATE(59), 1,
      sym__open_brace,
    STATE(2187), 1,
      sym__double_quoted_string,
    STATE(2188), 1,
      sym__single_quoted_string,
    STATE(2192), 1,
      sym_string,
    STATE(3707), 1,
      aux_sym_function_definition_repeat1,
    STATE(5139), 1,
      sym__string_or_identifier,
    ACTIONS(293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2189), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(307), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12449), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(728), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [119325] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      sym_identifier,
    ACTIONS(105), 1,
      anon_sym_BSLASH,
    ACTIONS(107), 1,
      anon_sym_function,
    ACTIONS(111), 1,
      anon_sym_if,
    ACTIONS(113), 1,
      anon_sym_for,
    ACTIONS(115), 1,
      anon_sym_while,
    ACTIONS(117), 1,
      anon_sym_repeat,
    ACTIONS(119), 1,
      anon_sym_QMARK,
    ACTIONS(121), 1,
      anon_sym_TILDE,
    ACTIONS(131), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(133), 1,
      sym__number_literal,
    ACTIONS(135), 1,
      anon_sym_SQUOTE,
    ACTIONS(137), 1,
      anon_sym_DQUOTE,
    ACTIONS(147), 1,
      sym__raw_string_literal,
    ACTIONS(149), 1,
      sym__external_open_parenthesis,
    ACTIONS(153), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8381), 1,
      anon_sym_BANG,
    ACTIONS(12457), 1,
      sym_dot_dot_i,
    STATE(10), 1,
      sym__open_brace,
    STATE(20), 1,
      sym__open_parenthesis,
    STATE(2016), 1,
      sym_string,
    STATE(2027), 1,
      sym__single_quoted_string,
    STATE(2041), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5131), 1,
      sym__string_or_identifier,
    ACTIONS(125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2021), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(141), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12455), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(600), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [119454] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4752), 1,
      sym_identifier,
    ACTIONS(4754), 1,
      anon_sym_BSLASH,
    ACTIONS(4756), 1,
      anon_sym_function,
    ACTIONS(4758), 1,
      anon_sym_if,
    ACTIONS(4760), 1,
      anon_sym_for,
    ACTIONS(4762), 1,
      anon_sym_while,
    ACTIONS(4764), 1,
      anon_sym_repeat,
    ACTIONS(4766), 1,
      anon_sym_QMARK,
    ACTIONS(4768), 1,
      anon_sym_TILDE,
    ACTIONS(4776), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4778), 1,
      sym__number_literal,
    ACTIONS(4780), 1,
      anon_sym_SQUOTE,
    ACTIONS(4782), 1,
      anon_sym_DQUOTE,
    ACTIONS(4790), 1,
      sym__raw_string_literal,
    ACTIONS(4792), 1,
      sym__external_open_parenthesis,
    ACTIONS(4794), 1,
      sym__external_open_brace,
    ACTIONS(6353), 1,
      anon_sym_BANG,
    ACTIONS(12461), 1,
      sym_dot_dot_i,
    ACTIONS(12463), 1,
      sym__newline,
    STATE(192), 1,
      sym__open_brace,
    STATE(214), 1,
      sym__open_parenthesis,
    STATE(2664), 1,
      sym_string,
    STATE(2701), 1,
      sym__single_quoted_string,
    STATE(2745), 1,
      sym__double_quoted_string,
    STATE(4018), 1,
      aux_sym_function_definition_repeat1,
    STATE(5148), 1,
      sym__string_or_identifier,
    ACTIONS(4772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2700), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4786), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12459), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1926), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [119583] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      sym_identifier,
    ACTIONS(105), 1,
      anon_sym_BSLASH,
    ACTIONS(107), 1,
      anon_sym_function,
    ACTIONS(111), 1,
      anon_sym_if,
    ACTIONS(113), 1,
      anon_sym_for,
    ACTIONS(115), 1,
      anon_sym_while,
    ACTIONS(117), 1,
      anon_sym_repeat,
    ACTIONS(119), 1,
      anon_sym_QMARK,
    ACTIONS(121), 1,
      anon_sym_TILDE,
    ACTIONS(131), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(133), 1,
      sym__number_literal,
    ACTIONS(135), 1,
      anon_sym_SQUOTE,
    ACTIONS(137), 1,
      anon_sym_DQUOTE,
    ACTIONS(147), 1,
      sym__raw_string_literal,
    ACTIONS(149), 1,
      sym__external_open_parenthesis,
    ACTIONS(153), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8381), 1,
      anon_sym_BANG,
    ACTIONS(12467), 1,
      sym_dot_dot_i,
    STATE(10), 1,
      sym__open_brace,
    STATE(20), 1,
      sym__open_parenthesis,
    STATE(2016), 1,
      sym_string,
    STATE(2027), 1,
      sym__single_quoted_string,
    STATE(2041), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5131), 1,
      sym__string_or_identifier,
    ACTIONS(125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2021), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(141), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12465), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(601), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [119712] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1337), 1,
      sym_identifier,
    ACTIONS(1339), 1,
      anon_sym_BSLASH,
    ACTIONS(1341), 1,
      anon_sym_function,
    ACTIONS(1343), 1,
      anon_sym_if,
    ACTIONS(1345), 1,
      anon_sym_for,
    ACTIONS(1347), 1,
      anon_sym_while,
    ACTIONS(1349), 1,
      anon_sym_repeat,
    ACTIONS(1351), 1,
      anon_sym_QMARK,
    ACTIONS(1353), 1,
      anon_sym_TILDE,
    ACTIONS(1361), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1363), 1,
      sym__number_literal,
    ACTIONS(1365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1367), 1,
      anon_sym_DQUOTE,
    ACTIONS(1377), 1,
      sym__raw_string_literal,
    ACTIONS(1379), 1,
      sym__external_open_parenthesis,
    ACTIONS(1383), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9409), 1,
      anon_sym_BANG,
    ACTIONS(12471), 1,
      sym_dot_dot_i,
    STATE(94), 1,
      sym__open_brace,
    STATE(190), 1,
      sym__open_parenthesis,
    STATE(2231), 1,
      sym_string,
    STATE(2354), 1,
      sym__double_quoted_string,
    STATE(2355), 1,
      sym__single_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5156), 1,
      sym__string_or_identifier,
    ACTIONS(1357), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2356), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1371), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12469), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1017), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [119841] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      sym_identifier,
    ACTIONS(105), 1,
      anon_sym_BSLASH,
    ACTIONS(107), 1,
      anon_sym_function,
    ACTIONS(111), 1,
      anon_sym_if,
    ACTIONS(113), 1,
      anon_sym_for,
    ACTIONS(115), 1,
      anon_sym_while,
    ACTIONS(117), 1,
      anon_sym_repeat,
    ACTIONS(119), 1,
      anon_sym_QMARK,
    ACTIONS(121), 1,
      anon_sym_TILDE,
    ACTIONS(131), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(133), 1,
      sym__number_literal,
    ACTIONS(135), 1,
      anon_sym_SQUOTE,
    ACTIONS(137), 1,
      anon_sym_DQUOTE,
    ACTIONS(147), 1,
      sym__raw_string_literal,
    ACTIONS(149), 1,
      sym__external_open_parenthesis,
    ACTIONS(153), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8381), 1,
      anon_sym_BANG,
    ACTIONS(12475), 1,
      sym_dot_dot_i,
    STATE(10), 1,
      sym__open_brace,
    STATE(20), 1,
      sym__open_parenthesis,
    STATE(2016), 1,
      sym_string,
    STATE(2027), 1,
      sym__single_quoted_string,
    STATE(2041), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5131), 1,
      sym__string_or_identifier,
    ACTIONS(125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2021), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(141), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12473), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(602), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [119970] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4752), 1,
      sym_identifier,
    ACTIONS(4754), 1,
      anon_sym_BSLASH,
    ACTIONS(4756), 1,
      anon_sym_function,
    ACTIONS(4758), 1,
      anon_sym_if,
    ACTIONS(4760), 1,
      anon_sym_for,
    ACTIONS(4762), 1,
      anon_sym_while,
    ACTIONS(4764), 1,
      anon_sym_repeat,
    ACTIONS(4766), 1,
      anon_sym_QMARK,
    ACTIONS(4768), 1,
      anon_sym_TILDE,
    ACTIONS(4776), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4778), 1,
      sym__number_literal,
    ACTIONS(4780), 1,
      anon_sym_SQUOTE,
    ACTIONS(4782), 1,
      anon_sym_DQUOTE,
    ACTIONS(4790), 1,
      sym__raw_string_literal,
    ACTIONS(4792), 1,
      sym__external_open_parenthesis,
    ACTIONS(4794), 1,
      sym__external_open_brace,
    ACTIONS(6353), 1,
      anon_sym_BANG,
    ACTIONS(12479), 1,
      sym_dot_dot_i,
    ACTIONS(12481), 1,
      sym__newline,
    STATE(192), 1,
      sym__open_brace,
    STATE(214), 1,
      sym__open_parenthesis,
    STATE(2664), 1,
      sym_string,
    STATE(2701), 1,
      sym__single_quoted_string,
    STATE(2745), 1,
      sym__double_quoted_string,
    STATE(4016), 1,
      aux_sym_function_definition_repeat1,
    STATE(5148), 1,
      sym__string_or_identifier,
    ACTIONS(4772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2700), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4786), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12477), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2071), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [120099] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(12485), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12483), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4573), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [120228] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1337), 1,
      sym_identifier,
    ACTIONS(1339), 1,
      anon_sym_BSLASH,
    ACTIONS(1341), 1,
      anon_sym_function,
    ACTIONS(1343), 1,
      anon_sym_if,
    ACTIONS(1345), 1,
      anon_sym_for,
    ACTIONS(1347), 1,
      anon_sym_while,
    ACTIONS(1349), 1,
      anon_sym_repeat,
    ACTIONS(1351), 1,
      anon_sym_QMARK,
    ACTIONS(1353), 1,
      anon_sym_TILDE,
    ACTIONS(1361), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1363), 1,
      sym__number_literal,
    ACTIONS(1365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1367), 1,
      anon_sym_DQUOTE,
    ACTIONS(1377), 1,
      sym__raw_string_literal,
    ACTIONS(1379), 1,
      sym__external_open_parenthesis,
    ACTIONS(1383), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9409), 1,
      anon_sym_BANG,
    ACTIONS(12489), 1,
      sym_dot_dot_i,
    STATE(94), 1,
      sym__open_brace,
    STATE(190), 1,
      sym__open_parenthesis,
    STATE(2231), 1,
      sym_string,
    STATE(2354), 1,
      sym__double_quoted_string,
    STATE(2355), 1,
      sym__single_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5156), 1,
      sym__string_or_identifier,
    ACTIONS(1357), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2356), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1371), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12487), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1016), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [120357] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2826), 1,
      sym_identifier,
    ACTIONS(2828), 1,
      anon_sym_BSLASH,
    ACTIONS(2830), 1,
      anon_sym_function,
    ACTIONS(2832), 1,
      anon_sym_if,
    ACTIONS(2834), 1,
      anon_sym_for,
    ACTIONS(2836), 1,
      anon_sym_while,
    ACTIONS(2838), 1,
      anon_sym_repeat,
    ACTIONS(2840), 1,
      anon_sym_QMARK,
    ACTIONS(2842), 1,
      anon_sym_TILDE,
    ACTIONS(2850), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2852), 1,
      sym__number_literal,
    ACTIONS(2854), 1,
      anon_sym_SQUOTE,
    ACTIONS(2856), 1,
      anon_sym_DQUOTE,
    ACTIONS(2866), 1,
      sym__raw_string_literal,
    ACTIONS(2868), 1,
      sym__external_open_parenthesis,
    ACTIONS(2870), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(10915), 1,
      anon_sym_BANG,
    ACTIONS(12493), 1,
      sym_dot_dot_i,
    STATE(178), 1,
      sym__open_parenthesis,
    STATE(244), 1,
      sym__open_brace,
    STATE(2522), 1,
      sym_string,
    STATE(2528), 1,
      sym__single_quoted_string,
    STATE(2529), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5126), 1,
      sym__string_or_identifier,
    ACTIONS(2846), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2523), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2860), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12491), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1756), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [120486] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1337), 1,
      sym_identifier,
    ACTIONS(1339), 1,
      anon_sym_BSLASH,
    ACTIONS(1341), 1,
      anon_sym_function,
    ACTIONS(1343), 1,
      anon_sym_if,
    ACTIONS(1345), 1,
      anon_sym_for,
    ACTIONS(1347), 1,
      anon_sym_while,
    ACTIONS(1349), 1,
      anon_sym_repeat,
    ACTIONS(1351), 1,
      anon_sym_QMARK,
    ACTIONS(1353), 1,
      anon_sym_TILDE,
    ACTIONS(1361), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1363), 1,
      sym__number_literal,
    ACTIONS(1365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1367), 1,
      anon_sym_DQUOTE,
    ACTIONS(1377), 1,
      sym__raw_string_literal,
    ACTIONS(1379), 1,
      sym__external_open_parenthesis,
    ACTIONS(1383), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9409), 1,
      anon_sym_BANG,
    ACTIONS(12497), 1,
      sym_dot_dot_i,
    STATE(94), 1,
      sym__open_brace,
    STATE(190), 1,
      sym__open_parenthesis,
    STATE(2231), 1,
      sym_string,
    STATE(2354), 1,
      sym__double_quoted_string,
    STATE(2355), 1,
      sym__single_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5156), 1,
      sym__string_or_identifier,
    ACTIONS(1357), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2356), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1371), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12495), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1015), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [120615] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2826), 1,
      sym_identifier,
    ACTIONS(2828), 1,
      anon_sym_BSLASH,
    ACTIONS(2830), 1,
      anon_sym_function,
    ACTIONS(2832), 1,
      anon_sym_if,
    ACTIONS(2834), 1,
      anon_sym_for,
    ACTIONS(2836), 1,
      anon_sym_while,
    ACTIONS(2838), 1,
      anon_sym_repeat,
    ACTIONS(2840), 1,
      anon_sym_QMARK,
    ACTIONS(2842), 1,
      anon_sym_TILDE,
    ACTIONS(2850), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2852), 1,
      sym__number_literal,
    ACTIONS(2854), 1,
      anon_sym_SQUOTE,
    ACTIONS(2856), 1,
      anon_sym_DQUOTE,
    ACTIONS(2866), 1,
      sym__raw_string_literal,
    ACTIONS(2868), 1,
      sym__external_open_parenthesis,
    ACTIONS(2870), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(10915), 1,
      anon_sym_BANG,
    ACTIONS(12501), 1,
      sym_dot_dot_i,
    STATE(178), 1,
      sym__open_parenthesis,
    STATE(244), 1,
      sym__open_brace,
    STATE(2522), 1,
      sym_string,
    STATE(2528), 1,
      sym__single_quoted_string,
    STATE(2529), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5126), 1,
      sym__string_or_identifier,
    ACTIONS(2846), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2523), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2860), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12499), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1636), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [120744] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1337), 1,
      sym_identifier,
    ACTIONS(1339), 1,
      anon_sym_BSLASH,
    ACTIONS(1341), 1,
      anon_sym_function,
    ACTIONS(1343), 1,
      anon_sym_if,
    ACTIONS(1345), 1,
      anon_sym_for,
    ACTIONS(1347), 1,
      anon_sym_while,
    ACTIONS(1349), 1,
      anon_sym_repeat,
    ACTIONS(1351), 1,
      anon_sym_QMARK,
    ACTIONS(1353), 1,
      anon_sym_TILDE,
    ACTIONS(1361), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1363), 1,
      sym__number_literal,
    ACTIONS(1365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1367), 1,
      anon_sym_DQUOTE,
    ACTIONS(1377), 1,
      sym__raw_string_literal,
    ACTIONS(1379), 1,
      sym__external_open_parenthesis,
    ACTIONS(1383), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9409), 1,
      anon_sym_BANG,
    ACTIONS(12505), 1,
      sym_dot_dot_i,
    STATE(94), 1,
      sym__open_brace,
    STATE(190), 1,
      sym__open_parenthesis,
    STATE(2231), 1,
      sym_string,
    STATE(2354), 1,
      sym__double_quoted_string,
    STATE(2355), 1,
      sym__single_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5156), 1,
      sym__string_or_identifier,
    ACTIONS(1357), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2356), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1371), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12503), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1014), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [120873] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4752), 1,
      sym_identifier,
    ACTIONS(4754), 1,
      anon_sym_BSLASH,
    ACTIONS(4756), 1,
      anon_sym_function,
    ACTIONS(4758), 1,
      anon_sym_if,
    ACTIONS(4760), 1,
      anon_sym_for,
    ACTIONS(4762), 1,
      anon_sym_while,
    ACTIONS(4764), 1,
      anon_sym_repeat,
    ACTIONS(4766), 1,
      anon_sym_QMARK,
    ACTIONS(4768), 1,
      anon_sym_TILDE,
    ACTIONS(4776), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4778), 1,
      sym__number_literal,
    ACTIONS(4780), 1,
      anon_sym_SQUOTE,
    ACTIONS(4782), 1,
      anon_sym_DQUOTE,
    ACTIONS(4790), 1,
      sym__raw_string_literal,
    ACTIONS(4792), 1,
      sym__external_open_parenthesis,
    ACTIONS(4794), 1,
      sym__external_open_brace,
    ACTIONS(6353), 1,
      anon_sym_BANG,
    ACTIONS(12509), 1,
      sym_dot_dot_i,
    ACTIONS(12511), 1,
      sym__newline,
    STATE(192), 1,
      sym__open_brace,
    STATE(214), 1,
      sym__open_parenthesis,
    STATE(2664), 1,
      sym_string,
    STATE(2701), 1,
      sym__single_quoted_string,
    STATE(2745), 1,
      sym__double_quoted_string,
    STATE(4010), 1,
      aux_sym_function_definition_repeat1,
    STATE(5148), 1,
      sym__string_or_identifier,
    ACTIONS(4772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2700), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4786), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12507), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1930), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [121002] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1337), 1,
      sym_identifier,
    ACTIONS(1339), 1,
      anon_sym_BSLASH,
    ACTIONS(1341), 1,
      anon_sym_function,
    ACTIONS(1343), 1,
      anon_sym_if,
    ACTIONS(1345), 1,
      anon_sym_for,
    ACTIONS(1347), 1,
      anon_sym_while,
    ACTIONS(1349), 1,
      anon_sym_repeat,
    ACTIONS(1351), 1,
      anon_sym_QMARK,
    ACTIONS(1353), 1,
      anon_sym_TILDE,
    ACTIONS(1361), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1363), 1,
      sym__number_literal,
    ACTIONS(1365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1367), 1,
      anon_sym_DQUOTE,
    ACTIONS(1377), 1,
      sym__raw_string_literal,
    ACTIONS(1379), 1,
      sym__external_open_parenthesis,
    ACTIONS(1383), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9409), 1,
      anon_sym_BANG,
    ACTIONS(12515), 1,
      sym_dot_dot_i,
    STATE(94), 1,
      sym__open_brace,
    STATE(190), 1,
      sym__open_parenthesis,
    STATE(2231), 1,
      sym_string,
    STATE(2354), 1,
      sym__double_quoted_string,
    STATE(2355), 1,
      sym__single_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5156), 1,
      sym__string_or_identifier,
    ACTIONS(1357), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2356), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1371), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12513), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1013), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [121131] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2826), 1,
      sym_identifier,
    ACTIONS(2828), 1,
      anon_sym_BSLASH,
    ACTIONS(2830), 1,
      anon_sym_function,
    ACTIONS(2832), 1,
      anon_sym_if,
    ACTIONS(2834), 1,
      anon_sym_for,
    ACTIONS(2836), 1,
      anon_sym_while,
    ACTIONS(2838), 1,
      anon_sym_repeat,
    ACTIONS(2840), 1,
      anon_sym_QMARK,
    ACTIONS(2842), 1,
      anon_sym_TILDE,
    ACTIONS(2850), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2852), 1,
      sym__number_literal,
    ACTIONS(2854), 1,
      anon_sym_SQUOTE,
    ACTIONS(2856), 1,
      anon_sym_DQUOTE,
    ACTIONS(2866), 1,
      sym__raw_string_literal,
    ACTIONS(2868), 1,
      sym__external_open_parenthesis,
    ACTIONS(2870), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(10915), 1,
      anon_sym_BANG,
    ACTIONS(12519), 1,
      sym_dot_dot_i,
    STATE(178), 1,
      sym__open_parenthesis,
    STATE(244), 1,
      sym__open_brace,
    STATE(2522), 1,
      sym_string,
    STATE(2528), 1,
      sym__single_quoted_string,
    STATE(2529), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5126), 1,
      sym__string_or_identifier,
    ACTIONS(2846), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2523), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2860), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12517), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1759), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [121260] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1337), 1,
      sym_identifier,
    ACTIONS(1339), 1,
      anon_sym_BSLASH,
    ACTIONS(1341), 1,
      anon_sym_function,
    ACTIONS(1343), 1,
      anon_sym_if,
    ACTIONS(1345), 1,
      anon_sym_for,
    ACTIONS(1347), 1,
      anon_sym_while,
    ACTIONS(1349), 1,
      anon_sym_repeat,
    ACTIONS(1351), 1,
      anon_sym_QMARK,
    ACTIONS(1353), 1,
      anon_sym_TILDE,
    ACTIONS(1361), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1363), 1,
      sym__number_literal,
    ACTIONS(1365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1367), 1,
      anon_sym_DQUOTE,
    ACTIONS(1377), 1,
      sym__raw_string_literal,
    ACTIONS(1379), 1,
      sym__external_open_parenthesis,
    ACTIONS(1383), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9409), 1,
      anon_sym_BANG,
    ACTIONS(12523), 1,
      sym_dot_dot_i,
    STATE(94), 1,
      sym__open_brace,
    STATE(190), 1,
      sym__open_parenthesis,
    STATE(2231), 1,
      sym_string,
    STATE(2354), 1,
      sym__double_quoted_string,
    STATE(2355), 1,
      sym__single_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5156), 1,
      sym__string_or_identifier,
    ACTIONS(1357), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2356), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1371), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12521), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1012), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [121389] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(273), 1,
      sym_identifier,
    ACTIONS(275), 1,
      anon_sym_BSLASH,
    ACTIONS(277), 1,
      anon_sym_function,
    ACTIONS(279), 1,
      anon_sym_if,
    ACTIONS(281), 1,
      anon_sym_for,
    ACTIONS(283), 1,
      anon_sym_while,
    ACTIONS(285), 1,
      anon_sym_repeat,
    ACTIONS(287), 1,
      anon_sym_QMARK,
    ACTIONS(289), 1,
      anon_sym_TILDE,
    ACTIONS(297), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(299), 1,
      sym__number_literal,
    ACTIONS(301), 1,
      anon_sym_SQUOTE,
    ACTIONS(303), 1,
      anon_sym_DQUOTE,
    ACTIONS(313), 1,
      sym__raw_string_literal,
    ACTIONS(315), 1,
      sym__external_open_parenthesis,
    ACTIONS(319), 1,
      sym__external_open_brace,
    ACTIONS(11159), 1,
      anon_sym_BANG,
    ACTIONS(12527), 1,
      sym_dot_dot_i,
    ACTIONS(12529), 1,
      sym__newline,
    STATE(57), 1,
      sym__open_parenthesis,
    STATE(59), 1,
      sym__open_brace,
    STATE(2187), 1,
      sym__double_quoted_string,
    STATE(2188), 1,
      sym__single_quoted_string,
    STATE(2192), 1,
      sym_string,
    STATE(3991), 1,
      aux_sym_function_definition_repeat1,
    STATE(5139), 1,
      sym__string_or_identifier,
    ACTIONS(293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2189), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(307), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12525), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(773), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [121518] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1337), 1,
      sym_identifier,
    ACTIONS(1339), 1,
      anon_sym_BSLASH,
    ACTIONS(1341), 1,
      anon_sym_function,
    ACTIONS(1343), 1,
      anon_sym_if,
    ACTIONS(1345), 1,
      anon_sym_for,
    ACTIONS(1347), 1,
      anon_sym_while,
    ACTIONS(1349), 1,
      anon_sym_repeat,
    ACTIONS(1351), 1,
      anon_sym_QMARK,
    ACTIONS(1353), 1,
      anon_sym_TILDE,
    ACTIONS(1361), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1363), 1,
      sym__number_literal,
    ACTIONS(1365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1367), 1,
      anon_sym_DQUOTE,
    ACTIONS(1377), 1,
      sym__raw_string_literal,
    ACTIONS(1379), 1,
      sym__external_open_parenthesis,
    ACTIONS(1383), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9409), 1,
      anon_sym_BANG,
    ACTIONS(12533), 1,
      sym_dot_dot_i,
    STATE(94), 1,
      sym__open_brace,
    STATE(190), 1,
      sym__open_parenthesis,
    STATE(2231), 1,
      sym_string,
    STATE(2354), 1,
      sym__double_quoted_string,
    STATE(2355), 1,
      sym__single_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5156), 1,
      sym__string_or_identifier,
    ACTIONS(1357), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2356), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1371), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12531), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1011), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [121647] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1337), 1,
      sym_identifier,
    ACTIONS(1339), 1,
      anon_sym_BSLASH,
    ACTIONS(1341), 1,
      anon_sym_function,
    ACTIONS(1343), 1,
      anon_sym_if,
    ACTIONS(1345), 1,
      anon_sym_for,
    ACTIONS(1347), 1,
      anon_sym_while,
    ACTIONS(1349), 1,
      anon_sym_repeat,
    ACTIONS(1351), 1,
      anon_sym_QMARK,
    ACTIONS(1353), 1,
      anon_sym_TILDE,
    ACTIONS(1361), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1363), 1,
      sym__number_literal,
    ACTIONS(1365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1367), 1,
      anon_sym_DQUOTE,
    ACTIONS(1377), 1,
      sym__raw_string_literal,
    ACTIONS(1379), 1,
      sym__external_open_parenthesis,
    ACTIONS(1383), 1,
      sym__external_open_brace,
    ACTIONS(9409), 1,
      anon_sym_BANG,
    ACTIONS(12537), 1,
      sym_dot_dot_i,
    ACTIONS(12539), 1,
      sym__newline,
    STATE(94), 1,
      sym__open_brace,
    STATE(190), 1,
      sym__open_parenthesis,
    STATE(2231), 1,
      sym_string,
    STATE(2354), 1,
      sym__double_quoted_string,
    STATE(2355), 1,
      sym__single_quoted_string,
    STATE(4063), 1,
      aux_sym_function_definition_repeat1,
    STATE(5156), 1,
      sym__string_or_identifier,
    ACTIONS(1357), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2356), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1371), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12535), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(976), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [121776] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4752), 1,
      sym_identifier,
    ACTIONS(4754), 1,
      anon_sym_BSLASH,
    ACTIONS(4756), 1,
      anon_sym_function,
    ACTIONS(4758), 1,
      anon_sym_if,
    ACTIONS(4760), 1,
      anon_sym_for,
    ACTIONS(4762), 1,
      anon_sym_while,
    ACTIONS(4764), 1,
      anon_sym_repeat,
    ACTIONS(4766), 1,
      anon_sym_QMARK,
    ACTIONS(4768), 1,
      anon_sym_TILDE,
    ACTIONS(4776), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4778), 1,
      sym__number_literal,
    ACTIONS(4780), 1,
      anon_sym_SQUOTE,
    ACTIONS(4782), 1,
      anon_sym_DQUOTE,
    ACTIONS(4790), 1,
      sym__raw_string_literal,
    ACTIONS(4792), 1,
      sym__external_open_parenthesis,
    ACTIONS(4794), 1,
      sym__external_open_brace,
    ACTIONS(6353), 1,
      anon_sym_BANG,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(12543), 1,
      sym_dot_dot_i,
    STATE(192), 1,
      sym__open_brace,
    STATE(214), 1,
      sym__open_parenthesis,
    STATE(2664), 1,
      sym_string,
    STATE(2701), 1,
      sym__single_quoted_string,
    STATE(2745), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5148), 1,
      sym__string_or_identifier,
    ACTIONS(4772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2700), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4786), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12541), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2077), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [121905] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4752), 1,
      sym_identifier,
    ACTIONS(4754), 1,
      anon_sym_BSLASH,
    ACTIONS(4756), 1,
      anon_sym_function,
    ACTIONS(4758), 1,
      anon_sym_if,
    ACTIONS(4760), 1,
      anon_sym_for,
    ACTIONS(4762), 1,
      anon_sym_while,
    ACTIONS(4764), 1,
      anon_sym_repeat,
    ACTIONS(4766), 1,
      anon_sym_QMARK,
    ACTIONS(4768), 1,
      anon_sym_TILDE,
    ACTIONS(4776), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4778), 1,
      sym__number_literal,
    ACTIONS(4780), 1,
      anon_sym_SQUOTE,
    ACTIONS(4782), 1,
      anon_sym_DQUOTE,
    ACTIONS(4790), 1,
      sym__raw_string_literal,
    ACTIONS(4792), 1,
      sym__external_open_parenthesis,
    ACTIONS(4794), 1,
      sym__external_open_brace,
    ACTIONS(6353), 1,
      anon_sym_BANG,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(12547), 1,
      sym_dot_dot_i,
    STATE(192), 1,
      sym__open_brace,
    STATE(214), 1,
      sym__open_parenthesis,
    STATE(2664), 1,
      sym_string,
    STATE(2701), 1,
      sym__single_quoted_string,
    STATE(2745), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5148), 1,
      sym__string_or_identifier,
    ACTIONS(4772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2700), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4786), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12545), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2078), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [122034] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4752), 1,
      sym_identifier,
    ACTIONS(4754), 1,
      anon_sym_BSLASH,
    ACTIONS(4756), 1,
      anon_sym_function,
    ACTIONS(4758), 1,
      anon_sym_if,
    ACTIONS(4760), 1,
      anon_sym_for,
    ACTIONS(4762), 1,
      anon_sym_while,
    ACTIONS(4764), 1,
      anon_sym_repeat,
    ACTIONS(4766), 1,
      anon_sym_QMARK,
    ACTIONS(4768), 1,
      anon_sym_TILDE,
    ACTIONS(4776), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4778), 1,
      sym__number_literal,
    ACTIONS(4780), 1,
      anon_sym_SQUOTE,
    ACTIONS(4782), 1,
      anon_sym_DQUOTE,
    ACTIONS(4790), 1,
      sym__raw_string_literal,
    ACTIONS(4792), 1,
      sym__external_open_parenthesis,
    ACTIONS(4794), 1,
      sym__external_open_brace,
    ACTIONS(6353), 1,
      anon_sym_BANG,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(12551), 1,
      sym_dot_dot_i,
    STATE(192), 1,
      sym__open_brace,
    STATE(214), 1,
      sym__open_parenthesis,
    STATE(2664), 1,
      sym_string,
    STATE(2701), 1,
      sym__single_quoted_string,
    STATE(2745), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5148), 1,
      sym__string_or_identifier,
    ACTIONS(4772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2700), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4786), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12549), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2080), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [122163] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4752), 1,
      sym_identifier,
    ACTIONS(4754), 1,
      anon_sym_BSLASH,
    ACTIONS(4756), 1,
      anon_sym_function,
    ACTIONS(4758), 1,
      anon_sym_if,
    ACTIONS(4760), 1,
      anon_sym_for,
    ACTIONS(4762), 1,
      anon_sym_while,
    ACTIONS(4764), 1,
      anon_sym_repeat,
    ACTIONS(4766), 1,
      anon_sym_QMARK,
    ACTIONS(4768), 1,
      anon_sym_TILDE,
    ACTIONS(4776), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4778), 1,
      sym__number_literal,
    ACTIONS(4780), 1,
      anon_sym_SQUOTE,
    ACTIONS(4782), 1,
      anon_sym_DQUOTE,
    ACTIONS(4790), 1,
      sym__raw_string_literal,
    ACTIONS(4792), 1,
      sym__external_open_parenthesis,
    ACTIONS(4794), 1,
      sym__external_open_brace,
    ACTIONS(6353), 1,
      anon_sym_BANG,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(12555), 1,
      sym_dot_dot_i,
    STATE(192), 1,
      sym__open_brace,
    STATE(214), 1,
      sym__open_parenthesis,
    STATE(2664), 1,
      sym_string,
    STATE(2701), 1,
      sym__single_quoted_string,
    STATE(2745), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5148), 1,
      sym__string_or_identifier,
    ACTIONS(4772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2700), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4786), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12553), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1955), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [122292] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4752), 1,
      sym_identifier,
    ACTIONS(4754), 1,
      anon_sym_BSLASH,
    ACTIONS(4756), 1,
      anon_sym_function,
    ACTIONS(4758), 1,
      anon_sym_if,
    ACTIONS(4760), 1,
      anon_sym_for,
    ACTIONS(4762), 1,
      anon_sym_while,
    ACTIONS(4764), 1,
      anon_sym_repeat,
    ACTIONS(4766), 1,
      anon_sym_QMARK,
    ACTIONS(4768), 1,
      anon_sym_TILDE,
    ACTIONS(4776), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4778), 1,
      sym__number_literal,
    ACTIONS(4780), 1,
      anon_sym_SQUOTE,
    ACTIONS(4782), 1,
      anon_sym_DQUOTE,
    ACTIONS(4790), 1,
      sym__raw_string_literal,
    ACTIONS(4792), 1,
      sym__external_open_parenthesis,
    ACTIONS(4794), 1,
      sym__external_open_brace,
    ACTIONS(6353), 1,
      anon_sym_BANG,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(12559), 1,
      sym_dot_dot_i,
    STATE(192), 1,
      sym__open_brace,
    STATE(214), 1,
      sym__open_parenthesis,
    STATE(2664), 1,
      sym_string,
    STATE(2701), 1,
      sym__single_quoted_string,
    STATE(2745), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5148), 1,
      sym__string_or_identifier,
    ACTIONS(4772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2700), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4786), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12557), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2089), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [122421] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2826), 1,
      sym_identifier,
    ACTIONS(2828), 1,
      anon_sym_BSLASH,
    ACTIONS(2830), 1,
      anon_sym_function,
    ACTIONS(2832), 1,
      anon_sym_if,
    ACTIONS(2834), 1,
      anon_sym_for,
    ACTIONS(2836), 1,
      anon_sym_while,
    ACTIONS(2838), 1,
      anon_sym_repeat,
    ACTIONS(2840), 1,
      anon_sym_QMARK,
    ACTIONS(2842), 1,
      anon_sym_TILDE,
    ACTIONS(2850), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2852), 1,
      sym__number_literal,
    ACTIONS(2854), 1,
      anon_sym_SQUOTE,
    ACTIONS(2856), 1,
      anon_sym_DQUOTE,
    ACTIONS(2866), 1,
      sym__raw_string_literal,
    ACTIONS(2868), 1,
      sym__external_open_parenthesis,
    ACTIONS(2870), 1,
      sym__external_open_brace,
    ACTIONS(10915), 1,
      anon_sym_BANG,
    ACTIONS(12563), 1,
      sym_dot_dot_i,
    ACTIONS(12565), 1,
      sym__newline,
    STATE(178), 1,
      sym__open_parenthesis,
    STATE(244), 1,
      sym__open_brace,
    STATE(2522), 1,
      sym_string,
    STATE(2528), 1,
      sym__single_quoted_string,
    STATE(2529), 1,
      sym__double_quoted_string,
    STATE(3932), 1,
      aux_sym_function_definition_repeat1,
    STATE(5126), 1,
      sym__string_or_identifier,
    ACTIONS(2846), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2523), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2860), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12561), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1785), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [122550] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(273), 1,
      sym_identifier,
    ACTIONS(275), 1,
      anon_sym_BSLASH,
    ACTIONS(277), 1,
      anon_sym_function,
    ACTIONS(279), 1,
      anon_sym_if,
    ACTIONS(281), 1,
      anon_sym_for,
    ACTIONS(283), 1,
      anon_sym_while,
    ACTIONS(285), 1,
      anon_sym_repeat,
    ACTIONS(287), 1,
      anon_sym_QMARK,
    ACTIONS(289), 1,
      anon_sym_TILDE,
    ACTIONS(297), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(299), 1,
      sym__number_literal,
    ACTIONS(301), 1,
      anon_sym_SQUOTE,
    ACTIONS(303), 1,
      anon_sym_DQUOTE,
    ACTIONS(313), 1,
      sym__raw_string_literal,
    ACTIONS(315), 1,
      sym__external_open_parenthesis,
    ACTIONS(319), 1,
      sym__external_open_brace,
    ACTIONS(11159), 1,
      anon_sym_BANG,
    ACTIONS(12569), 1,
      sym_dot_dot_i,
    ACTIONS(12571), 1,
      sym__newline,
    STATE(57), 1,
      sym__open_parenthesis,
    STATE(59), 1,
      sym__open_brace,
    STATE(2187), 1,
      sym__double_quoted_string,
    STATE(2188), 1,
      sym__single_quoted_string,
    STATE(2192), 1,
      sym_string,
    STATE(3714), 1,
      aux_sym_function_definition_repeat1,
    STATE(5139), 1,
      sym__string_or_identifier,
    ACTIONS(293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2189), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(307), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12567), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(730), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [122679] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4752), 1,
      sym_identifier,
    ACTIONS(4754), 1,
      anon_sym_BSLASH,
    ACTIONS(4756), 1,
      anon_sym_function,
    ACTIONS(4758), 1,
      anon_sym_if,
    ACTIONS(4760), 1,
      anon_sym_for,
    ACTIONS(4762), 1,
      anon_sym_while,
    ACTIONS(4764), 1,
      anon_sym_repeat,
    ACTIONS(4766), 1,
      anon_sym_QMARK,
    ACTIONS(4768), 1,
      anon_sym_TILDE,
    ACTIONS(4776), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4778), 1,
      sym__number_literal,
    ACTIONS(4780), 1,
      anon_sym_SQUOTE,
    ACTIONS(4782), 1,
      anon_sym_DQUOTE,
    ACTIONS(4790), 1,
      sym__raw_string_literal,
    ACTIONS(4792), 1,
      sym__external_open_parenthesis,
    ACTIONS(4794), 1,
      sym__external_open_brace,
    ACTIONS(6353), 1,
      anon_sym_BANG,
    ACTIONS(12575), 1,
      sym_dot_dot_i,
    ACTIONS(12577), 1,
      sym__newline,
    STATE(192), 1,
      sym__open_brace,
    STATE(214), 1,
      sym__open_parenthesis,
    STATE(2664), 1,
      sym_string,
    STATE(2701), 1,
      sym__single_quoted_string,
    STATE(2745), 1,
      sym__double_quoted_string,
    STATE(4003), 1,
      aux_sym_function_definition_repeat1,
    STATE(5148), 1,
      sym__string_or_identifier,
    ACTIONS(4772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2700), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4786), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12573), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1932), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [122808] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(12581), 1,
      sym_dot_dot_i,
    STATE(292), 1,
      sym__open_brace,
    STATE(293), 1,
      sym__open_parenthesis,
    STATE(2562), 1,
      sym_string,
    STATE(2737), 1,
      sym__double_quoted_string,
    STATE(2738), 1,
      sym__single_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5152), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2739), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12579), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2063), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [122937] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4053), 1,
      sym_identifier,
    ACTIONS(4055), 1,
      anon_sym_BSLASH,
    ACTIONS(4057), 1,
      anon_sym_function,
    ACTIONS(4059), 1,
      anon_sym_if,
    ACTIONS(4061), 1,
      anon_sym_for,
    ACTIONS(4063), 1,
      anon_sym_while,
    ACTIONS(4065), 1,
      anon_sym_repeat,
    ACTIONS(4067), 1,
      anon_sym_QMARK,
    ACTIONS(4069), 1,
      anon_sym_TILDE,
    ACTIONS(4077), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4079), 1,
      sym__number_literal,
    ACTIONS(4081), 1,
      anon_sym_SQUOTE,
    ACTIONS(4083), 1,
      anon_sym_DQUOTE,
    ACTIONS(4093), 1,
      sym__raw_string_literal,
    ACTIONS(4095), 1,
      sym__external_open_parenthesis,
    ACTIONS(4097), 1,
      sym__external_open_brace,
    ACTIONS(7821), 1,
      anon_sym_BANG,
    ACTIONS(12585), 1,
      sym_dot_dot_i,
    ACTIONS(12587), 1,
      sym__newline,
    STATE(133), 1,
      sym__open_brace,
    STATE(150), 1,
      sym__open_parenthesis,
    STATE(2534), 1,
      sym_string,
    STATE(2538), 1,
      sym__single_quoted_string,
    STATE(2539), 1,
      sym__double_quoted_string,
    STATE(3927), 1,
      aux_sym_function_definition_repeat1,
    STATE(5143), 1,
      sym__string_or_identifier,
    ACTIONS(4073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2536), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4087), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12583), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(991), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [123066] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(273), 1,
      sym_identifier,
    ACTIONS(275), 1,
      anon_sym_BSLASH,
    ACTIONS(277), 1,
      anon_sym_function,
    ACTIONS(279), 1,
      anon_sym_if,
    ACTIONS(281), 1,
      anon_sym_for,
    ACTIONS(283), 1,
      anon_sym_while,
    ACTIONS(285), 1,
      anon_sym_repeat,
    ACTIONS(287), 1,
      anon_sym_QMARK,
    ACTIONS(289), 1,
      anon_sym_TILDE,
    ACTIONS(297), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(299), 1,
      sym__number_literal,
    ACTIONS(301), 1,
      anon_sym_SQUOTE,
    ACTIONS(303), 1,
      anon_sym_DQUOTE,
    ACTIONS(313), 1,
      sym__raw_string_literal,
    ACTIONS(315), 1,
      sym__external_open_parenthesis,
    ACTIONS(319), 1,
      sym__external_open_brace,
    ACTIONS(11159), 1,
      anon_sym_BANG,
    ACTIONS(12591), 1,
      sym_dot_dot_i,
    ACTIONS(12593), 1,
      sym__newline,
    STATE(57), 1,
      sym__open_parenthesis,
    STATE(59), 1,
      sym__open_brace,
    STATE(2187), 1,
      sym__double_quoted_string,
    STATE(2188), 1,
      sym__single_quoted_string,
    STATE(2192), 1,
      sym_string,
    STATE(3729), 1,
      aux_sym_function_definition_repeat1,
    STATE(5139), 1,
      sym__string_or_identifier,
    ACTIONS(293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2189), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(307), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12589), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(732), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [123195] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1337), 1,
      sym_identifier,
    ACTIONS(1339), 1,
      anon_sym_BSLASH,
    ACTIONS(1341), 1,
      anon_sym_function,
    ACTIONS(1343), 1,
      anon_sym_if,
    ACTIONS(1345), 1,
      anon_sym_for,
    ACTIONS(1347), 1,
      anon_sym_while,
    ACTIONS(1349), 1,
      anon_sym_repeat,
    ACTIONS(1351), 1,
      anon_sym_QMARK,
    ACTIONS(1353), 1,
      anon_sym_TILDE,
    ACTIONS(1361), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1363), 1,
      sym__number_literal,
    ACTIONS(1365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1367), 1,
      anon_sym_DQUOTE,
    ACTIONS(1377), 1,
      sym__raw_string_literal,
    ACTIONS(1379), 1,
      sym__external_open_parenthesis,
    ACTIONS(1383), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9409), 1,
      anon_sym_BANG,
    ACTIONS(12597), 1,
      sym_dot_dot_i,
    STATE(94), 1,
      sym__open_brace,
    STATE(190), 1,
      sym__open_parenthesis,
    STATE(2231), 1,
      sym_string,
    STATE(2354), 1,
      sym__double_quoted_string,
    STATE(2355), 1,
      sym__single_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5156), 1,
      sym__string_or_identifier,
    ACTIONS(1357), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2356), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1371), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12595), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1010), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [123324] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(273), 1,
      sym_identifier,
    ACTIONS(275), 1,
      anon_sym_BSLASH,
    ACTIONS(277), 1,
      anon_sym_function,
    ACTIONS(279), 1,
      anon_sym_if,
    ACTIONS(281), 1,
      anon_sym_for,
    ACTIONS(283), 1,
      anon_sym_while,
    ACTIONS(285), 1,
      anon_sym_repeat,
    ACTIONS(287), 1,
      anon_sym_QMARK,
    ACTIONS(289), 1,
      anon_sym_TILDE,
    ACTIONS(297), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(299), 1,
      sym__number_literal,
    ACTIONS(301), 1,
      anon_sym_SQUOTE,
    ACTIONS(303), 1,
      anon_sym_DQUOTE,
    ACTIONS(313), 1,
      sym__raw_string_literal,
    ACTIONS(315), 1,
      sym__external_open_parenthesis,
    ACTIONS(319), 1,
      sym__external_open_brace,
    ACTIONS(11159), 1,
      anon_sym_BANG,
    ACTIONS(12601), 1,
      sym_dot_dot_i,
    ACTIONS(12603), 1,
      sym__newline,
    STATE(57), 1,
      sym__open_parenthesis,
    STATE(59), 1,
      sym__open_brace,
    STATE(2187), 1,
      sym__double_quoted_string,
    STATE(2188), 1,
      sym__single_quoted_string,
    STATE(2192), 1,
      sym_string,
    STATE(3993), 1,
      aux_sym_function_definition_repeat1,
    STATE(5139), 1,
      sym__string_or_identifier,
    ACTIONS(293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2189), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(307), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12599), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(771), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [123453] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1337), 1,
      sym_identifier,
    ACTIONS(1339), 1,
      anon_sym_BSLASH,
    ACTIONS(1341), 1,
      anon_sym_function,
    ACTIONS(1343), 1,
      anon_sym_if,
    ACTIONS(1345), 1,
      anon_sym_for,
    ACTIONS(1347), 1,
      anon_sym_while,
    ACTIONS(1349), 1,
      anon_sym_repeat,
    ACTIONS(1351), 1,
      anon_sym_QMARK,
    ACTIONS(1353), 1,
      anon_sym_TILDE,
    ACTIONS(1361), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1363), 1,
      sym__number_literal,
    ACTIONS(1365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1367), 1,
      anon_sym_DQUOTE,
    ACTIONS(1377), 1,
      sym__raw_string_literal,
    ACTIONS(1379), 1,
      sym__external_open_parenthesis,
    ACTIONS(1383), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9409), 1,
      anon_sym_BANG,
    ACTIONS(12607), 1,
      sym_dot_dot_i,
    STATE(94), 1,
      sym__open_brace,
    STATE(190), 1,
      sym__open_parenthesis,
    STATE(2231), 1,
      sym_string,
    STATE(2354), 1,
      sym__double_quoted_string,
    STATE(2355), 1,
      sym__single_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5156), 1,
      sym__string_or_identifier,
    ACTIONS(1357), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2356), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1371), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12605), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1009), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [123582] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(273), 1,
      sym_identifier,
    ACTIONS(275), 1,
      anon_sym_BSLASH,
    ACTIONS(277), 1,
      anon_sym_function,
    ACTIONS(279), 1,
      anon_sym_if,
    ACTIONS(281), 1,
      anon_sym_for,
    ACTIONS(283), 1,
      anon_sym_while,
    ACTIONS(285), 1,
      anon_sym_repeat,
    ACTIONS(287), 1,
      anon_sym_QMARK,
    ACTIONS(289), 1,
      anon_sym_TILDE,
    ACTIONS(297), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(299), 1,
      sym__number_literal,
    ACTIONS(301), 1,
      anon_sym_SQUOTE,
    ACTIONS(303), 1,
      anon_sym_DQUOTE,
    ACTIONS(313), 1,
      sym__raw_string_literal,
    ACTIONS(315), 1,
      sym__external_open_parenthesis,
    ACTIONS(319), 1,
      sym__external_open_brace,
    ACTIONS(11159), 1,
      anon_sym_BANG,
    ACTIONS(12611), 1,
      sym_dot_dot_i,
    ACTIONS(12613), 1,
      sym__newline,
    STATE(57), 1,
      sym__open_parenthesis,
    STATE(59), 1,
      sym__open_brace,
    STATE(2187), 1,
      sym__double_quoted_string,
    STATE(2188), 1,
      sym__single_quoted_string,
    STATE(2192), 1,
      sym_string,
    STATE(3994), 1,
      aux_sym_function_definition_repeat1,
    STATE(5139), 1,
      sym__string_or_identifier,
    ACTIONS(293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2189), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(307), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12609), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(769), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [123711] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1337), 1,
      sym_identifier,
    ACTIONS(1339), 1,
      anon_sym_BSLASH,
    ACTIONS(1341), 1,
      anon_sym_function,
    ACTIONS(1343), 1,
      anon_sym_if,
    ACTIONS(1345), 1,
      anon_sym_for,
    ACTIONS(1347), 1,
      anon_sym_while,
    ACTIONS(1349), 1,
      anon_sym_repeat,
    ACTIONS(1351), 1,
      anon_sym_QMARK,
    ACTIONS(1353), 1,
      anon_sym_TILDE,
    ACTIONS(1361), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1363), 1,
      sym__number_literal,
    ACTIONS(1365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1367), 1,
      anon_sym_DQUOTE,
    ACTIONS(1377), 1,
      sym__raw_string_literal,
    ACTIONS(1379), 1,
      sym__external_open_parenthesis,
    ACTIONS(1383), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9409), 1,
      anon_sym_BANG,
    ACTIONS(12617), 1,
      sym_dot_dot_i,
    STATE(94), 1,
      sym__open_brace,
    STATE(190), 1,
      sym__open_parenthesis,
    STATE(2231), 1,
      sym_string,
    STATE(2354), 1,
      sym__double_quoted_string,
    STATE(2355), 1,
      sym__single_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5156), 1,
      sym__string_or_identifier,
    ACTIONS(1357), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2356), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1371), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12615), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1007), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [123840] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(626), 1,
      sym_identifier,
    ACTIONS(628), 1,
      anon_sym_BSLASH,
    ACTIONS(630), 1,
      anon_sym_function,
    ACTIONS(632), 1,
      anon_sym_if,
    ACTIONS(634), 1,
      anon_sym_for,
    ACTIONS(636), 1,
      anon_sym_while,
    ACTIONS(638), 1,
      anon_sym_repeat,
    ACTIONS(640), 1,
      anon_sym_QMARK,
    ACTIONS(642), 1,
      anon_sym_TILDE,
    ACTIONS(650), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(652), 1,
      sym__number_literal,
    ACTIONS(654), 1,
      anon_sym_SQUOTE,
    ACTIONS(656), 1,
      anon_sym_DQUOTE,
    ACTIONS(666), 1,
      sym__raw_string_literal,
    ACTIONS(668), 1,
      sym__external_open_parenthesis,
    ACTIONS(670), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(7933), 1,
      anon_sym_BANG,
    ACTIONS(12621), 1,
      sym_dot_dot_i,
    STATE(54), 1,
      sym__open_parenthesis,
    STATE(56), 1,
      sym__open_brace,
    STATE(2219), 1,
      sym_string,
    STATE(2221), 1,
      sym__single_quoted_string,
    STATE(2222), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5140), 1,
      sym__string_or_identifier,
    ACTIONS(646), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2220), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(660), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12619), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(754), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [123969] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(12625), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(12627), 2,
      sym__external_close_parenthesis,
      sym_comma,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12623), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4455), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [124096] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2826), 1,
      sym_identifier,
    ACTIONS(2828), 1,
      anon_sym_BSLASH,
    ACTIONS(2830), 1,
      anon_sym_function,
    ACTIONS(2832), 1,
      anon_sym_if,
    ACTIONS(2834), 1,
      anon_sym_for,
    ACTIONS(2836), 1,
      anon_sym_while,
    ACTIONS(2838), 1,
      anon_sym_repeat,
    ACTIONS(2840), 1,
      anon_sym_QMARK,
    ACTIONS(2842), 1,
      anon_sym_TILDE,
    ACTIONS(2850), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2852), 1,
      sym__number_literal,
    ACTIONS(2854), 1,
      anon_sym_SQUOTE,
    ACTIONS(2856), 1,
      anon_sym_DQUOTE,
    ACTIONS(2866), 1,
      sym__raw_string_literal,
    ACTIONS(2868), 1,
      sym__external_open_parenthesis,
    ACTIONS(2870), 1,
      sym__external_open_brace,
    ACTIONS(10915), 1,
      anon_sym_BANG,
    ACTIONS(12631), 1,
      sym_dot_dot_i,
    ACTIONS(12633), 1,
      sym__newline,
    STATE(178), 1,
      sym__open_parenthesis,
    STATE(244), 1,
      sym__open_brace,
    STATE(2522), 1,
      sym_string,
    STATE(2528), 1,
      sym__single_quoted_string,
    STATE(2529), 1,
      sym__double_quoted_string,
    STATE(3942), 1,
      aux_sym_function_definition_repeat1,
    STATE(5126), 1,
      sym__string_or_identifier,
    ACTIONS(2846), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2523), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2860), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12629), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1774), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [124225] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(273), 1,
      sym_identifier,
    ACTIONS(275), 1,
      anon_sym_BSLASH,
    ACTIONS(277), 1,
      anon_sym_function,
    ACTIONS(279), 1,
      anon_sym_if,
    ACTIONS(281), 1,
      anon_sym_for,
    ACTIONS(283), 1,
      anon_sym_while,
    ACTIONS(285), 1,
      anon_sym_repeat,
    ACTIONS(287), 1,
      anon_sym_QMARK,
    ACTIONS(289), 1,
      anon_sym_TILDE,
    ACTIONS(297), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(299), 1,
      sym__number_literal,
    ACTIONS(301), 1,
      anon_sym_SQUOTE,
    ACTIONS(303), 1,
      anon_sym_DQUOTE,
    ACTIONS(313), 1,
      sym__raw_string_literal,
    ACTIONS(315), 1,
      sym__external_open_parenthesis,
    ACTIONS(319), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(11159), 1,
      anon_sym_BANG,
    ACTIONS(12637), 1,
      sym_dot_dot_i,
    STATE(57), 1,
      sym__open_parenthesis,
    STATE(59), 1,
      sym__open_brace,
    STATE(2187), 1,
      sym__double_quoted_string,
    STATE(2188), 1,
      sym__single_quoted_string,
    STATE(2192), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5139), 1,
      sym__string_or_identifier,
    ACTIONS(293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2189), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(307), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12635), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(748), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [124354] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(273), 1,
      sym_identifier,
    ACTIONS(275), 1,
      anon_sym_BSLASH,
    ACTIONS(277), 1,
      anon_sym_function,
    ACTIONS(279), 1,
      anon_sym_if,
    ACTIONS(281), 1,
      anon_sym_for,
    ACTIONS(283), 1,
      anon_sym_while,
    ACTIONS(285), 1,
      anon_sym_repeat,
    ACTIONS(287), 1,
      anon_sym_QMARK,
    ACTIONS(289), 1,
      anon_sym_TILDE,
    ACTIONS(297), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(299), 1,
      sym__number_literal,
    ACTIONS(301), 1,
      anon_sym_SQUOTE,
    ACTIONS(303), 1,
      anon_sym_DQUOTE,
    ACTIONS(313), 1,
      sym__raw_string_literal,
    ACTIONS(315), 1,
      sym__external_open_parenthesis,
    ACTIONS(319), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(11159), 1,
      anon_sym_BANG,
    ACTIONS(12641), 1,
      sym_dot_dot_i,
    STATE(57), 1,
      sym__open_parenthesis,
    STATE(59), 1,
      sym__open_brace,
    STATE(2187), 1,
      sym__double_quoted_string,
    STATE(2188), 1,
      sym__single_quoted_string,
    STATE(2192), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5139), 1,
      sym__string_or_identifier,
    ACTIONS(293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2189), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(307), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12639), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(747), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [124483] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(273), 1,
      sym_identifier,
    ACTIONS(275), 1,
      anon_sym_BSLASH,
    ACTIONS(277), 1,
      anon_sym_function,
    ACTIONS(279), 1,
      anon_sym_if,
    ACTIONS(281), 1,
      anon_sym_for,
    ACTIONS(283), 1,
      anon_sym_while,
    ACTIONS(285), 1,
      anon_sym_repeat,
    ACTIONS(287), 1,
      anon_sym_QMARK,
    ACTIONS(289), 1,
      anon_sym_TILDE,
    ACTIONS(297), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(299), 1,
      sym__number_literal,
    ACTIONS(301), 1,
      anon_sym_SQUOTE,
    ACTIONS(303), 1,
      anon_sym_DQUOTE,
    ACTIONS(313), 1,
      sym__raw_string_literal,
    ACTIONS(315), 1,
      sym__external_open_parenthesis,
    ACTIONS(319), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(11159), 1,
      anon_sym_BANG,
    ACTIONS(12645), 1,
      sym_dot_dot_i,
    STATE(57), 1,
      sym__open_parenthesis,
    STATE(59), 1,
      sym__open_brace,
    STATE(2187), 1,
      sym__double_quoted_string,
    STATE(2188), 1,
      sym__single_quoted_string,
    STATE(2192), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5139), 1,
      sym__string_or_identifier,
    ACTIONS(293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2189), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(307), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12643), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(746), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [124612] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(273), 1,
      sym_identifier,
    ACTIONS(275), 1,
      anon_sym_BSLASH,
    ACTIONS(277), 1,
      anon_sym_function,
    ACTIONS(279), 1,
      anon_sym_if,
    ACTIONS(281), 1,
      anon_sym_for,
    ACTIONS(283), 1,
      anon_sym_while,
    ACTIONS(285), 1,
      anon_sym_repeat,
    ACTIONS(287), 1,
      anon_sym_QMARK,
    ACTIONS(289), 1,
      anon_sym_TILDE,
    ACTIONS(297), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(299), 1,
      sym__number_literal,
    ACTIONS(301), 1,
      anon_sym_SQUOTE,
    ACTIONS(303), 1,
      anon_sym_DQUOTE,
    ACTIONS(313), 1,
      sym__raw_string_literal,
    ACTIONS(315), 1,
      sym__external_open_parenthesis,
    ACTIONS(319), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(11159), 1,
      anon_sym_BANG,
    ACTIONS(12649), 1,
      sym_dot_dot_i,
    STATE(57), 1,
      sym__open_parenthesis,
    STATE(59), 1,
      sym__open_brace,
    STATE(2187), 1,
      sym__double_quoted_string,
    STATE(2188), 1,
      sym__single_quoted_string,
    STATE(2192), 1,
      sym_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5139), 1,
      sym__string_or_identifier,
    ACTIONS(293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2189), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(307), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12647), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(745), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [124741] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4752), 1,
      sym_identifier,
    ACTIONS(4754), 1,
      anon_sym_BSLASH,
    ACTIONS(4756), 1,
      anon_sym_function,
    ACTIONS(4758), 1,
      anon_sym_if,
    ACTIONS(4760), 1,
      anon_sym_for,
    ACTIONS(4762), 1,
      anon_sym_while,
    ACTIONS(4764), 1,
      anon_sym_repeat,
    ACTIONS(4766), 1,
      anon_sym_QMARK,
    ACTIONS(4768), 1,
      anon_sym_TILDE,
    ACTIONS(4776), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4778), 1,
      sym__number_literal,
    ACTIONS(4780), 1,
      anon_sym_SQUOTE,
    ACTIONS(4782), 1,
      anon_sym_DQUOTE,
    ACTIONS(4790), 1,
      sym__raw_string_literal,
    ACTIONS(4792), 1,
      sym__external_open_parenthesis,
    ACTIONS(4794), 1,
      sym__external_open_brace,
    ACTIONS(6353), 1,
      anon_sym_BANG,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(12653), 1,
      sym_dot_dot_i,
    STATE(192), 1,
      sym__open_brace,
    STATE(214), 1,
      sym__open_parenthesis,
    STATE(2664), 1,
      sym_string,
    STATE(2701), 1,
      sym__single_quoted_string,
    STATE(2745), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5148), 1,
      sym__string_or_identifier,
    ACTIONS(4772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2700), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4786), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12651), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2093), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [124870] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4752), 1,
      sym_identifier,
    ACTIONS(4754), 1,
      anon_sym_BSLASH,
    ACTIONS(4756), 1,
      anon_sym_function,
    ACTIONS(4758), 1,
      anon_sym_if,
    ACTIONS(4760), 1,
      anon_sym_for,
    ACTIONS(4762), 1,
      anon_sym_while,
    ACTIONS(4764), 1,
      anon_sym_repeat,
    ACTIONS(4766), 1,
      anon_sym_QMARK,
    ACTIONS(4768), 1,
      anon_sym_TILDE,
    ACTIONS(4776), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4778), 1,
      sym__number_literal,
    ACTIONS(4780), 1,
      anon_sym_SQUOTE,
    ACTIONS(4782), 1,
      anon_sym_DQUOTE,
    ACTIONS(4790), 1,
      sym__raw_string_literal,
    ACTIONS(4792), 1,
      sym__external_open_parenthesis,
    ACTIONS(4794), 1,
      sym__external_open_brace,
    ACTIONS(6353), 1,
      anon_sym_BANG,
    ACTIONS(12657), 1,
      sym_dot_dot_i,
    ACTIONS(12659), 1,
      sym__newline,
    STATE(192), 1,
      sym__open_brace,
    STATE(214), 1,
      sym__open_parenthesis,
    STATE(2664), 1,
      sym_string,
    STATE(2701), 1,
      sym__single_quoted_string,
    STATE(2745), 1,
      sym__double_quoted_string,
    STATE(4001), 1,
      aux_sym_function_definition_repeat1,
    STATE(5148), 1,
      sym__string_or_identifier,
    ACTIONS(4772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2700), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4786), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12655), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1945), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [124999] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1337), 1,
      sym_identifier,
    ACTIONS(1339), 1,
      anon_sym_BSLASH,
    ACTIONS(1341), 1,
      anon_sym_function,
    ACTIONS(1343), 1,
      anon_sym_if,
    ACTIONS(1345), 1,
      anon_sym_for,
    ACTIONS(1347), 1,
      anon_sym_while,
    ACTIONS(1349), 1,
      anon_sym_repeat,
    ACTIONS(1351), 1,
      anon_sym_QMARK,
    ACTIONS(1353), 1,
      anon_sym_TILDE,
    ACTIONS(1361), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1363), 1,
      sym__number_literal,
    ACTIONS(1365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1367), 1,
      anon_sym_DQUOTE,
    ACTIONS(1377), 1,
      sym__raw_string_literal,
    ACTIONS(1379), 1,
      sym__external_open_parenthesis,
    ACTIONS(1383), 1,
      sym__external_open_brace,
    ACTIONS(9409), 1,
      anon_sym_BANG,
    ACTIONS(12663), 1,
      sym_dot_dot_i,
    ACTIONS(12665), 1,
      sym__newline,
    STATE(94), 1,
      sym__open_brace,
    STATE(190), 1,
      sym__open_parenthesis,
    STATE(2231), 1,
      sym_string,
    STATE(2354), 1,
      sym__double_quoted_string,
    STATE(2355), 1,
      sym__single_quoted_string,
    STATE(4059), 1,
      aux_sym_function_definition_repeat1,
    STATE(5156), 1,
      sym__string_or_identifier,
    ACTIONS(1357), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2356), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1371), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12661), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(977), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [125128] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2826), 1,
      sym_identifier,
    ACTIONS(2828), 1,
      anon_sym_BSLASH,
    ACTIONS(2830), 1,
      anon_sym_function,
    ACTIONS(2832), 1,
      anon_sym_if,
    ACTIONS(2834), 1,
      anon_sym_for,
    ACTIONS(2836), 1,
      anon_sym_while,
    ACTIONS(2838), 1,
      anon_sym_repeat,
    ACTIONS(2840), 1,
      anon_sym_QMARK,
    ACTIONS(2842), 1,
      anon_sym_TILDE,
    ACTIONS(2850), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2852), 1,
      sym__number_literal,
    ACTIONS(2854), 1,
      anon_sym_SQUOTE,
    ACTIONS(2856), 1,
      anon_sym_DQUOTE,
    ACTIONS(2866), 1,
      sym__raw_string_literal,
    ACTIONS(2868), 1,
      sym__external_open_parenthesis,
    ACTIONS(2870), 1,
      sym__external_open_brace,
    ACTIONS(10915), 1,
      anon_sym_BANG,
    ACTIONS(12669), 1,
      sym_dot_dot_i,
    ACTIONS(12671), 1,
      sym__newline,
    STATE(178), 1,
      sym__open_parenthesis,
    STATE(244), 1,
      sym__open_brace,
    STATE(2522), 1,
      sym_string,
    STATE(2528), 1,
      sym__single_quoted_string,
    STATE(2529), 1,
      sym__double_quoted_string,
    STATE(3876), 1,
      aux_sym_function_definition_repeat1,
    STATE(5126), 1,
      sym__string_or_identifier,
    ACTIONS(2846), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2523), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2860), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12667), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1617), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [125257] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4752), 1,
      sym_identifier,
    ACTIONS(4754), 1,
      anon_sym_BSLASH,
    ACTIONS(4756), 1,
      anon_sym_function,
    ACTIONS(4758), 1,
      anon_sym_if,
    ACTIONS(4760), 1,
      anon_sym_for,
    ACTIONS(4762), 1,
      anon_sym_while,
    ACTIONS(4764), 1,
      anon_sym_repeat,
    ACTIONS(4766), 1,
      anon_sym_QMARK,
    ACTIONS(4768), 1,
      anon_sym_TILDE,
    ACTIONS(4776), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4778), 1,
      sym__number_literal,
    ACTIONS(4780), 1,
      anon_sym_SQUOTE,
    ACTIONS(4782), 1,
      anon_sym_DQUOTE,
    ACTIONS(4790), 1,
      sym__raw_string_literal,
    ACTIONS(4792), 1,
      sym__external_open_parenthesis,
    ACTIONS(4794), 1,
      sym__external_open_brace,
    ACTIONS(6353), 1,
      anon_sym_BANG,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(12675), 1,
      sym_dot_dot_i,
    STATE(192), 1,
      sym__open_brace,
    STATE(214), 1,
      sym__open_parenthesis,
    STATE(2664), 1,
      sym_string,
    STATE(2701), 1,
      sym__single_quoted_string,
    STATE(2745), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5148), 1,
      sym__string_or_identifier,
    ACTIONS(4772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2700), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4786), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12673), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2095), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [125386] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2826), 1,
      sym_identifier,
    ACTIONS(2828), 1,
      anon_sym_BSLASH,
    ACTIONS(2830), 1,
      anon_sym_function,
    ACTIONS(2832), 1,
      anon_sym_if,
    ACTIONS(2834), 1,
      anon_sym_for,
    ACTIONS(2836), 1,
      anon_sym_while,
    ACTIONS(2838), 1,
      anon_sym_repeat,
    ACTIONS(2840), 1,
      anon_sym_QMARK,
    ACTIONS(2842), 1,
      anon_sym_TILDE,
    ACTIONS(2850), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2852), 1,
      sym__number_literal,
    ACTIONS(2854), 1,
      anon_sym_SQUOTE,
    ACTIONS(2856), 1,
      anon_sym_DQUOTE,
    ACTIONS(2866), 1,
      sym__raw_string_literal,
    ACTIONS(2868), 1,
      sym__external_open_parenthesis,
    ACTIONS(2870), 1,
      sym__external_open_brace,
    ACTIONS(10915), 1,
      anon_sym_BANG,
    ACTIONS(12679), 1,
      sym_dot_dot_i,
    ACTIONS(12681), 1,
      sym__newline,
    STATE(178), 1,
      sym__open_parenthesis,
    STATE(244), 1,
      sym__open_brace,
    STATE(2522), 1,
      sym_string,
    STATE(2528), 1,
      sym__single_quoted_string,
    STATE(2529), 1,
      sym__double_quoted_string,
    STATE(3967), 1,
      aux_sym_function_definition_repeat1,
    STATE(5126), 1,
      sym__string_or_identifier,
    ACTIONS(2846), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2523), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2860), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12677), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1621), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [125515] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4752), 1,
      sym_identifier,
    ACTIONS(4754), 1,
      anon_sym_BSLASH,
    ACTIONS(4756), 1,
      anon_sym_function,
    ACTIONS(4758), 1,
      anon_sym_if,
    ACTIONS(4760), 1,
      anon_sym_for,
    ACTIONS(4762), 1,
      anon_sym_while,
    ACTIONS(4764), 1,
      anon_sym_repeat,
    ACTIONS(4766), 1,
      anon_sym_QMARK,
    ACTIONS(4768), 1,
      anon_sym_TILDE,
    ACTIONS(4776), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4778), 1,
      sym__number_literal,
    ACTIONS(4780), 1,
      anon_sym_SQUOTE,
    ACTIONS(4782), 1,
      anon_sym_DQUOTE,
    ACTIONS(4790), 1,
      sym__raw_string_literal,
    ACTIONS(4792), 1,
      sym__external_open_parenthesis,
    ACTIONS(4794), 1,
      sym__external_open_brace,
    ACTIONS(6353), 1,
      anon_sym_BANG,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(12685), 1,
      sym_dot_dot_i,
    STATE(192), 1,
      sym__open_brace,
    STATE(214), 1,
      sym__open_parenthesis,
    STATE(2664), 1,
      sym_string,
    STATE(2701), 1,
      sym__single_quoted_string,
    STATE(2745), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5148), 1,
      sym__string_or_identifier,
    ACTIONS(4772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2700), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4786), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12683), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2100), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [125644] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2826), 1,
      sym_identifier,
    ACTIONS(2828), 1,
      anon_sym_BSLASH,
    ACTIONS(2830), 1,
      anon_sym_function,
    ACTIONS(2832), 1,
      anon_sym_if,
    ACTIONS(2834), 1,
      anon_sym_for,
    ACTIONS(2836), 1,
      anon_sym_while,
    ACTIONS(2838), 1,
      anon_sym_repeat,
    ACTIONS(2840), 1,
      anon_sym_QMARK,
    ACTIONS(2842), 1,
      anon_sym_TILDE,
    ACTIONS(2850), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2852), 1,
      sym__number_literal,
    ACTIONS(2854), 1,
      anon_sym_SQUOTE,
    ACTIONS(2856), 1,
      anon_sym_DQUOTE,
    ACTIONS(2866), 1,
      sym__raw_string_literal,
    ACTIONS(2868), 1,
      sym__external_open_parenthesis,
    ACTIONS(2870), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(10915), 1,
      anon_sym_BANG,
    ACTIONS(12689), 1,
      sym_dot_dot_i,
    STATE(178), 1,
      sym__open_parenthesis,
    STATE(244), 1,
      sym__open_brace,
    STATE(2522), 1,
      sym_string,
    STATE(2528), 1,
      sym__single_quoted_string,
    STATE(2529), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5126), 1,
      sym__string_or_identifier,
    ACTIONS(2846), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2523), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2860), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12687), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1356), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [125773] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4752), 1,
      sym_identifier,
    ACTIONS(4754), 1,
      anon_sym_BSLASH,
    ACTIONS(4756), 1,
      anon_sym_function,
    ACTIONS(4758), 1,
      anon_sym_if,
    ACTIONS(4760), 1,
      anon_sym_for,
    ACTIONS(4762), 1,
      anon_sym_while,
    ACTIONS(4764), 1,
      anon_sym_repeat,
    ACTIONS(4766), 1,
      anon_sym_QMARK,
    ACTIONS(4768), 1,
      anon_sym_TILDE,
    ACTIONS(4776), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4778), 1,
      sym__number_literal,
    ACTIONS(4780), 1,
      anon_sym_SQUOTE,
    ACTIONS(4782), 1,
      anon_sym_DQUOTE,
    ACTIONS(4790), 1,
      sym__raw_string_literal,
    ACTIONS(4792), 1,
      sym__external_open_parenthesis,
    ACTIONS(4794), 1,
      sym__external_open_brace,
    ACTIONS(6353), 1,
      anon_sym_BANG,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(12693), 1,
      sym_dot_dot_i,
    STATE(192), 1,
      sym__open_brace,
    STATE(214), 1,
      sym__open_parenthesis,
    STATE(2664), 1,
      sym_string,
    STATE(2701), 1,
      sym__single_quoted_string,
    STATE(2745), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5148), 1,
      sym__string_or_identifier,
    ACTIONS(4772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2700), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4786), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12691), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2101), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [125902] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4752), 1,
      sym_identifier,
    ACTIONS(4754), 1,
      anon_sym_BSLASH,
    ACTIONS(4756), 1,
      anon_sym_function,
    ACTIONS(4758), 1,
      anon_sym_if,
    ACTIONS(4760), 1,
      anon_sym_for,
    ACTIONS(4762), 1,
      anon_sym_while,
    ACTIONS(4764), 1,
      anon_sym_repeat,
    ACTIONS(4766), 1,
      anon_sym_QMARK,
    ACTIONS(4768), 1,
      anon_sym_TILDE,
    ACTIONS(4776), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4778), 1,
      sym__number_literal,
    ACTIONS(4780), 1,
      anon_sym_SQUOTE,
    ACTIONS(4782), 1,
      anon_sym_DQUOTE,
    ACTIONS(4790), 1,
      sym__raw_string_literal,
    ACTIONS(4792), 1,
      sym__external_open_parenthesis,
    ACTIONS(4794), 1,
      sym__external_open_brace,
    ACTIONS(6353), 1,
      anon_sym_BANG,
    ACTIONS(12697), 1,
      sym_dot_dot_i,
    ACTIONS(12699), 1,
      sym__newline,
    STATE(192), 1,
      sym__open_brace,
    STATE(214), 1,
      sym__open_parenthesis,
    STATE(2664), 1,
      sym_string,
    STATE(2701), 1,
      sym__single_quoted_string,
    STATE(2745), 1,
      sym__double_quoted_string,
    STATE(3999), 1,
      aux_sym_function_definition_repeat1,
    STATE(5148), 1,
      sym__string_or_identifier,
    ACTIONS(4772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2700), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4786), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12695), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1949), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [126031] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1337), 1,
      sym_identifier,
    ACTIONS(1339), 1,
      anon_sym_BSLASH,
    ACTIONS(1341), 1,
      anon_sym_function,
    ACTIONS(1343), 1,
      anon_sym_if,
    ACTIONS(1345), 1,
      anon_sym_for,
    ACTIONS(1347), 1,
      anon_sym_while,
    ACTIONS(1349), 1,
      anon_sym_repeat,
    ACTIONS(1351), 1,
      anon_sym_QMARK,
    ACTIONS(1353), 1,
      anon_sym_TILDE,
    ACTIONS(1361), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1363), 1,
      sym__number_literal,
    ACTIONS(1365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1367), 1,
      anon_sym_DQUOTE,
    ACTIONS(1377), 1,
      sym__raw_string_literal,
    ACTIONS(1379), 1,
      sym__external_open_parenthesis,
    ACTIONS(1383), 1,
      sym__external_open_brace,
    ACTIONS(9409), 1,
      anon_sym_BANG,
    ACTIONS(12703), 1,
      sym_dot_dot_i,
    ACTIONS(12705), 1,
      sym__newline,
    STATE(94), 1,
      sym__open_brace,
    STATE(190), 1,
      sym__open_parenthesis,
    STATE(2231), 1,
      sym_string,
    STATE(2354), 1,
      sym__double_quoted_string,
    STATE(2355), 1,
      sym__single_quoted_string,
    STATE(4055), 1,
      aux_sym_function_definition_repeat1,
    STATE(5156), 1,
      sym__string_or_identifier,
    ACTIONS(1357), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2356), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1371), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12701), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(978), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [126160] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1337), 1,
      sym_identifier,
    ACTIONS(1339), 1,
      anon_sym_BSLASH,
    ACTIONS(1341), 1,
      anon_sym_function,
    ACTIONS(1343), 1,
      anon_sym_if,
    ACTIONS(1345), 1,
      anon_sym_for,
    ACTIONS(1347), 1,
      anon_sym_while,
    ACTIONS(1349), 1,
      anon_sym_repeat,
    ACTIONS(1351), 1,
      anon_sym_QMARK,
    ACTIONS(1353), 1,
      anon_sym_TILDE,
    ACTIONS(1361), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1363), 1,
      sym__number_literal,
    ACTIONS(1365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1367), 1,
      anon_sym_DQUOTE,
    ACTIONS(1377), 1,
      sym__raw_string_literal,
    ACTIONS(1379), 1,
      sym__external_open_parenthesis,
    ACTIONS(1383), 1,
      sym__external_open_brace,
    ACTIONS(9409), 1,
      anon_sym_BANG,
    ACTIONS(12709), 1,
      sym_dot_dot_i,
    ACTIONS(12711), 1,
      sym__newline,
    STATE(94), 1,
      sym__open_brace,
    STATE(190), 1,
      sym__open_parenthesis,
    STATE(2231), 1,
      sym_string,
    STATE(2354), 1,
      sym__double_quoted_string,
    STATE(2355), 1,
      sym__single_quoted_string,
    STATE(4053), 1,
      aux_sym_function_definition_repeat1,
    STATE(5156), 1,
      sym__string_or_identifier,
    ACTIONS(1357), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2356), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1371), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12707), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(979), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [126289] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4752), 1,
      sym_identifier,
    ACTIONS(4754), 1,
      anon_sym_BSLASH,
    ACTIONS(4756), 1,
      anon_sym_function,
    ACTIONS(4758), 1,
      anon_sym_if,
    ACTIONS(4760), 1,
      anon_sym_for,
    ACTIONS(4762), 1,
      anon_sym_while,
    ACTIONS(4764), 1,
      anon_sym_repeat,
    ACTIONS(4766), 1,
      anon_sym_QMARK,
    ACTIONS(4768), 1,
      anon_sym_TILDE,
    ACTIONS(4776), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4778), 1,
      sym__number_literal,
    ACTIONS(4780), 1,
      anon_sym_SQUOTE,
    ACTIONS(4782), 1,
      anon_sym_DQUOTE,
    ACTIONS(4790), 1,
      sym__raw_string_literal,
    ACTIONS(4792), 1,
      sym__external_open_parenthesis,
    ACTIONS(4794), 1,
      sym__external_open_brace,
    ACTIONS(6353), 1,
      anon_sym_BANG,
    ACTIONS(12715), 1,
      sym_dot_dot_i,
    ACTIONS(12717), 1,
      sym__newline,
    STATE(192), 1,
      sym__open_brace,
    STATE(214), 1,
      sym__open_parenthesis,
    STATE(2664), 1,
      sym_string,
    STATE(2701), 1,
      sym__single_quoted_string,
    STATE(2745), 1,
      sym__double_quoted_string,
    STATE(3995), 1,
      aux_sym_function_definition_repeat1,
    STATE(5148), 1,
      sym__string_or_identifier,
    ACTIONS(4772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2700), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4786), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12713), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1951), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [126418] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2826), 1,
      sym_identifier,
    ACTIONS(2828), 1,
      anon_sym_BSLASH,
    ACTIONS(2830), 1,
      anon_sym_function,
    ACTIONS(2832), 1,
      anon_sym_if,
    ACTIONS(2834), 1,
      anon_sym_for,
    ACTIONS(2836), 1,
      anon_sym_while,
    ACTIONS(2838), 1,
      anon_sym_repeat,
    ACTIONS(2840), 1,
      anon_sym_QMARK,
    ACTIONS(2842), 1,
      anon_sym_TILDE,
    ACTIONS(2850), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2852), 1,
      sym__number_literal,
    ACTIONS(2854), 1,
      anon_sym_SQUOTE,
    ACTIONS(2856), 1,
      anon_sym_DQUOTE,
    ACTIONS(2866), 1,
      sym__raw_string_literal,
    ACTIONS(2868), 1,
      sym__external_open_parenthesis,
    ACTIONS(2870), 1,
      sym__external_open_brace,
    ACTIONS(10915), 1,
      anon_sym_BANG,
    ACTIONS(12721), 1,
      sym_dot_dot_i,
    ACTIONS(12723), 1,
      sym__newline,
    STATE(178), 1,
      sym__open_parenthesis,
    STATE(244), 1,
      sym__open_brace,
    STATE(2522), 1,
      sym_string,
    STATE(2528), 1,
      sym__single_quoted_string,
    STATE(2529), 1,
      sym__double_quoted_string,
    STATE(3946), 1,
      aux_sym_function_definition_repeat1,
    STATE(5126), 1,
      sym__string_or_identifier,
    ACTIONS(2846), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2523), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2860), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12719), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1726), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [126547] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(161), 1,
      sym_identifier,
    ACTIONS(163), 1,
      anon_sym_BSLASH,
    ACTIONS(165), 1,
      anon_sym_function,
    ACTIONS(167), 1,
      anon_sym_if,
    ACTIONS(169), 1,
      anon_sym_for,
    ACTIONS(171), 1,
      anon_sym_while,
    ACTIONS(173), 1,
      anon_sym_repeat,
    ACTIONS(175), 1,
      anon_sym_QMARK,
    ACTIONS(177), 1,
      anon_sym_TILDE,
    ACTIONS(185), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(187), 1,
      sym__number_literal,
    ACTIONS(189), 1,
      anon_sym_SQUOTE,
    ACTIONS(191), 1,
      anon_sym_DQUOTE,
    ACTIONS(201), 1,
      sym__raw_string_literal,
    ACTIONS(203), 1,
      sym__external_open_parenthesis,
    ACTIONS(207), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8009), 1,
      anon_sym_BANG,
    ACTIONS(12727), 1,
      sym_dot_dot_i,
    STATE(14), 1,
      sym__open_parenthesis,
    STATE(18), 1,
      sym__open_brace,
    STATE(1923), 1,
      sym__single_quoted_string,
    STATE(1927), 1,
      sym_string,
    STATE(1934), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5137), 1,
      sym__string_or_identifier,
    ACTIONS(181), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1925), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(195), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12725), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(652), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [126676] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4752), 1,
      sym_identifier,
    ACTIONS(4754), 1,
      anon_sym_BSLASH,
    ACTIONS(4756), 1,
      anon_sym_function,
    ACTIONS(4758), 1,
      anon_sym_if,
    ACTIONS(4760), 1,
      anon_sym_for,
    ACTIONS(4762), 1,
      anon_sym_while,
    ACTIONS(4764), 1,
      anon_sym_repeat,
    ACTIONS(4766), 1,
      anon_sym_QMARK,
    ACTIONS(4768), 1,
      anon_sym_TILDE,
    ACTIONS(4776), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4778), 1,
      sym__number_literal,
    ACTIONS(4780), 1,
      anon_sym_SQUOTE,
    ACTIONS(4782), 1,
      anon_sym_DQUOTE,
    ACTIONS(4790), 1,
      sym__raw_string_literal,
    ACTIONS(4792), 1,
      sym__external_open_parenthesis,
    ACTIONS(4794), 1,
      sym__external_open_brace,
    ACTIONS(6353), 1,
      anon_sym_BANG,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(12731), 1,
      sym_dot_dot_i,
    STATE(192), 1,
      sym__open_brace,
    STATE(214), 1,
      sym__open_parenthesis,
    STATE(2664), 1,
      sym_string,
    STATE(2701), 1,
      sym__single_quoted_string,
    STATE(2745), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5148), 1,
      sym__string_or_identifier,
    ACTIONS(4772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2700), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4786), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12729), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2102), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [126805] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(273), 1,
      sym_identifier,
    ACTIONS(275), 1,
      anon_sym_BSLASH,
    ACTIONS(277), 1,
      anon_sym_function,
    ACTIONS(279), 1,
      anon_sym_if,
    ACTIONS(281), 1,
      anon_sym_for,
    ACTIONS(283), 1,
      anon_sym_while,
    ACTIONS(285), 1,
      anon_sym_repeat,
    ACTIONS(287), 1,
      anon_sym_QMARK,
    ACTIONS(289), 1,
      anon_sym_TILDE,
    ACTIONS(297), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(299), 1,
      sym__number_literal,
    ACTIONS(301), 1,
      anon_sym_SQUOTE,
    ACTIONS(303), 1,
      anon_sym_DQUOTE,
    ACTIONS(313), 1,
      sym__raw_string_literal,
    ACTIONS(315), 1,
      sym__external_open_parenthesis,
    ACTIONS(319), 1,
      sym__external_open_brace,
    ACTIONS(11159), 1,
      anon_sym_BANG,
    ACTIONS(12735), 1,
      sym_dot_dot_i,
    ACTIONS(12737), 1,
      sym__newline,
    STATE(57), 1,
      sym__open_parenthesis,
    STATE(59), 1,
      sym__open_brace,
    STATE(2187), 1,
      sym__double_quoted_string,
    STATE(2188), 1,
      sym__single_quoted_string,
    STATE(2192), 1,
      sym_string,
    STATE(3867), 1,
      aux_sym_function_definition_repeat1,
    STATE(5139), 1,
      sym__string_or_identifier,
    ACTIONS(293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2189), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(307), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12733), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(744), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [126934] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(161), 1,
      sym_identifier,
    ACTIONS(163), 1,
      anon_sym_BSLASH,
    ACTIONS(165), 1,
      anon_sym_function,
    ACTIONS(167), 1,
      anon_sym_if,
    ACTIONS(169), 1,
      anon_sym_for,
    ACTIONS(171), 1,
      anon_sym_while,
    ACTIONS(173), 1,
      anon_sym_repeat,
    ACTIONS(175), 1,
      anon_sym_QMARK,
    ACTIONS(177), 1,
      anon_sym_TILDE,
    ACTIONS(185), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(187), 1,
      sym__number_literal,
    ACTIONS(189), 1,
      anon_sym_SQUOTE,
    ACTIONS(191), 1,
      anon_sym_DQUOTE,
    ACTIONS(201), 1,
      sym__raw_string_literal,
    ACTIONS(203), 1,
      sym__external_open_parenthesis,
    ACTIONS(207), 1,
      sym__external_open_brace,
    ACTIONS(8009), 1,
      anon_sym_BANG,
    ACTIONS(12741), 1,
      sym_dot_dot_i,
    ACTIONS(12743), 1,
      sym__newline,
    STATE(14), 1,
      sym__open_parenthesis,
    STATE(18), 1,
      sym__open_brace,
    STATE(1923), 1,
      sym__single_quoted_string,
    STATE(1927), 1,
      sym_string,
    STATE(1934), 1,
      sym__double_quoted_string,
    STATE(4025), 1,
      aux_sym_function_definition_repeat1,
    STATE(5137), 1,
      sym__string_or_identifier,
    ACTIONS(181), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1925), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(195), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12739), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(616), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [127063] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(161), 1,
      sym_identifier,
    ACTIONS(163), 1,
      anon_sym_BSLASH,
    ACTIONS(165), 1,
      anon_sym_function,
    ACTIONS(167), 1,
      anon_sym_if,
    ACTIONS(169), 1,
      anon_sym_for,
    ACTIONS(171), 1,
      anon_sym_while,
    ACTIONS(173), 1,
      anon_sym_repeat,
    ACTIONS(175), 1,
      anon_sym_QMARK,
    ACTIONS(177), 1,
      anon_sym_TILDE,
    ACTIONS(185), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(187), 1,
      sym__number_literal,
    ACTIONS(189), 1,
      anon_sym_SQUOTE,
    ACTIONS(191), 1,
      anon_sym_DQUOTE,
    ACTIONS(201), 1,
      sym__raw_string_literal,
    ACTIONS(203), 1,
      sym__external_open_parenthesis,
    ACTIONS(207), 1,
      sym__external_open_brace,
    ACTIONS(8009), 1,
      anon_sym_BANG,
    ACTIONS(12747), 1,
      sym_dot_dot_i,
    ACTIONS(12749), 1,
      sym__newline,
    STATE(14), 1,
      sym__open_parenthesis,
    STATE(18), 1,
      sym__open_brace,
    STATE(1923), 1,
      sym__single_quoted_string,
    STATE(1927), 1,
      sym_string,
    STATE(1934), 1,
      sym__double_quoted_string,
    STATE(4027), 1,
      aux_sym_function_definition_repeat1,
    STATE(5137), 1,
      sym__string_or_identifier,
    ACTIONS(181), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1925), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(195), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12745), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(617), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [127192] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(161), 1,
      sym_identifier,
    ACTIONS(163), 1,
      anon_sym_BSLASH,
    ACTIONS(165), 1,
      anon_sym_function,
    ACTIONS(167), 1,
      anon_sym_if,
    ACTIONS(169), 1,
      anon_sym_for,
    ACTIONS(171), 1,
      anon_sym_while,
    ACTIONS(173), 1,
      anon_sym_repeat,
    ACTIONS(175), 1,
      anon_sym_QMARK,
    ACTIONS(177), 1,
      anon_sym_TILDE,
    ACTIONS(185), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(187), 1,
      sym__number_literal,
    ACTIONS(189), 1,
      anon_sym_SQUOTE,
    ACTIONS(191), 1,
      anon_sym_DQUOTE,
    ACTIONS(201), 1,
      sym__raw_string_literal,
    ACTIONS(203), 1,
      sym__external_open_parenthesis,
    ACTIONS(207), 1,
      sym__external_open_brace,
    ACTIONS(8009), 1,
      anon_sym_BANG,
    ACTIONS(12753), 1,
      sym_dot_dot_i,
    ACTIONS(12755), 1,
      sym__newline,
    STATE(14), 1,
      sym__open_parenthesis,
    STATE(18), 1,
      sym__open_brace,
    STATE(1923), 1,
      sym__single_quoted_string,
    STATE(1927), 1,
      sym_string,
    STATE(1934), 1,
      sym__double_quoted_string,
    STATE(4029), 1,
      aux_sym_function_definition_repeat1,
    STATE(5137), 1,
      sym__string_or_identifier,
    ACTIONS(181), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1925), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(195), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12751), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(618), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [127321] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(161), 1,
      sym_identifier,
    ACTIONS(163), 1,
      anon_sym_BSLASH,
    ACTIONS(165), 1,
      anon_sym_function,
    ACTIONS(167), 1,
      anon_sym_if,
    ACTIONS(169), 1,
      anon_sym_for,
    ACTIONS(171), 1,
      anon_sym_while,
    ACTIONS(173), 1,
      anon_sym_repeat,
    ACTIONS(175), 1,
      anon_sym_QMARK,
    ACTIONS(177), 1,
      anon_sym_TILDE,
    ACTIONS(185), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(187), 1,
      sym__number_literal,
    ACTIONS(189), 1,
      anon_sym_SQUOTE,
    ACTIONS(191), 1,
      anon_sym_DQUOTE,
    ACTIONS(201), 1,
      sym__raw_string_literal,
    ACTIONS(203), 1,
      sym__external_open_parenthesis,
    ACTIONS(207), 1,
      sym__external_open_brace,
    ACTIONS(8009), 1,
      anon_sym_BANG,
    ACTIONS(12759), 1,
      sym_dot_dot_i,
    ACTIONS(12761), 1,
      sym__newline,
    STATE(14), 1,
      sym__open_parenthesis,
    STATE(18), 1,
      sym__open_brace,
    STATE(1923), 1,
      sym__single_quoted_string,
    STATE(1927), 1,
      sym_string,
    STATE(1934), 1,
      sym__double_quoted_string,
    STATE(4031), 1,
      aux_sym_function_definition_repeat1,
    STATE(5137), 1,
      sym__string_or_identifier,
    ACTIONS(181), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1925), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(195), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12757), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(619), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [127450] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4752), 1,
      sym_identifier,
    ACTIONS(4754), 1,
      anon_sym_BSLASH,
    ACTIONS(4756), 1,
      anon_sym_function,
    ACTIONS(4758), 1,
      anon_sym_if,
    ACTIONS(4760), 1,
      anon_sym_for,
    ACTIONS(4762), 1,
      anon_sym_while,
    ACTIONS(4764), 1,
      anon_sym_repeat,
    ACTIONS(4766), 1,
      anon_sym_QMARK,
    ACTIONS(4768), 1,
      anon_sym_TILDE,
    ACTIONS(4776), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4778), 1,
      sym__number_literal,
    ACTIONS(4780), 1,
      anon_sym_SQUOTE,
    ACTIONS(4782), 1,
      anon_sym_DQUOTE,
    ACTIONS(4790), 1,
      sym__raw_string_literal,
    ACTIONS(4792), 1,
      sym__external_open_parenthesis,
    ACTIONS(4794), 1,
      sym__external_open_brace,
    ACTIONS(6353), 1,
      anon_sym_BANG,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(12765), 1,
      sym_dot_dot_i,
    STATE(192), 1,
      sym__open_brace,
    STATE(214), 1,
      sym__open_parenthesis,
    STATE(2664), 1,
      sym_string,
    STATE(2701), 1,
      sym__single_quoted_string,
    STATE(2745), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5148), 1,
      sym__string_or_identifier,
    ACTIONS(4772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2700), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4786), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12763), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2103), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [127579] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1337), 1,
      sym_identifier,
    ACTIONS(1339), 1,
      anon_sym_BSLASH,
    ACTIONS(1341), 1,
      anon_sym_function,
    ACTIONS(1343), 1,
      anon_sym_if,
    ACTIONS(1345), 1,
      anon_sym_for,
    ACTIONS(1347), 1,
      anon_sym_while,
    ACTIONS(1349), 1,
      anon_sym_repeat,
    ACTIONS(1351), 1,
      anon_sym_QMARK,
    ACTIONS(1353), 1,
      anon_sym_TILDE,
    ACTIONS(1361), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1363), 1,
      sym__number_literal,
    ACTIONS(1365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1367), 1,
      anon_sym_DQUOTE,
    ACTIONS(1377), 1,
      sym__raw_string_literal,
    ACTIONS(1379), 1,
      sym__external_open_parenthesis,
    ACTIONS(1383), 1,
      sym__external_open_brace,
    ACTIONS(9409), 1,
      anon_sym_BANG,
    ACTIONS(12769), 1,
      sym_dot_dot_i,
    ACTIONS(12771), 1,
      sym__newline,
    STATE(94), 1,
      sym__open_brace,
    STATE(190), 1,
      sym__open_parenthesis,
    STATE(2231), 1,
      sym_string,
    STATE(2354), 1,
      sym__double_quoted_string,
    STATE(2355), 1,
      sym__single_quoted_string,
    STATE(3940), 1,
      aux_sym_function_definition_repeat1,
    STATE(5156), 1,
      sym__string_or_identifier,
    ACTIONS(1357), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2356), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1371), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12767), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1005), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [127708] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4752), 1,
      sym_identifier,
    ACTIONS(4754), 1,
      anon_sym_BSLASH,
    ACTIONS(4756), 1,
      anon_sym_function,
    ACTIONS(4758), 1,
      anon_sym_if,
    ACTIONS(4760), 1,
      anon_sym_for,
    ACTIONS(4762), 1,
      anon_sym_while,
    ACTIONS(4764), 1,
      anon_sym_repeat,
    ACTIONS(4766), 1,
      anon_sym_QMARK,
    ACTIONS(4768), 1,
      anon_sym_TILDE,
    ACTIONS(4776), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4778), 1,
      sym__number_literal,
    ACTIONS(4780), 1,
      anon_sym_SQUOTE,
    ACTIONS(4782), 1,
      anon_sym_DQUOTE,
    ACTIONS(4790), 1,
      sym__raw_string_literal,
    ACTIONS(4792), 1,
      sym__external_open_parenthesis,
    ACTIONS(4794), 1,
      sym__external_open_brace,
    ACTIONS(6353), 1,
      anon_sym_BANG,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(12775), 1,
      sym_dot_dot_i,
    STATE(192), 1,
      sym__open_brace,
    STATE(214), 1,
      sym__open_parenthesis,
    STATE(2664), 1,
      sym_string,
    STATE(2701), 1,
      sym__single_quoted_string,
    STATE(2745), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5148), 1,
      sym__string_or_identifier,
    ACTIONS(4772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2700), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4786), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12773), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2104), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [127837] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1337), 1,
      sym_identifier,
    ACTIONS(1339), 1,
      anon_sym_BSLASH,
    ACTIONS(1341), 1,
      anon_sym_function,
    ACTIONS(1343), 1,
      anon_sym_if,
    ACTIONS(1345), 1,
      anon_sym_for,
    ACTIONS(1347), 1,
      anon_sym_while,
    ACTIONS(1349), 1,
      anon_sym_repeat,
    ACTIONS(1351), 1,
      anon_sym_QMARK,
    ACTIONS(1353), 1,
      anon_sym_TILDE,
    ACTIONS(1361), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1363), 1,
      sym__number_literal,
    ACTIONS(1365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1367), 1,
      anon_sym_DQUOTE,
    ACTIONS(1377), 1,
      sym__raw_string_literal,
    ACTIONS(1379), 1,
      sym__external_open_parenthesis,
    ACTIONS(1383), 1,
      sym__external_open_brace,
    ACTIONS(9409), 1,
      anon_sym_BANG,
    ACTIONS(12779), 1,
      sym_dot_dot_i,
    ACTIONS(12781), 1,
      sym__newline,
    STATE(94), 1,
      sym__open_brace,
    STATE(190), 1,
      sym__open_parenthesis,
    STATE(2231), 1,
      sym_string,
    STATE(2354), 1,
      sym__double_quoted_string,
    STATE(2355), 1,
      sym__single_quoted_string,
    STATE(3944), 1,
      aux_sym_function_definition_repeat1,
    STATE(5156), 1,
      sym__string_or_identifier,
    ACTIONS(1357), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2356), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1371), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12777), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1003), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [127966] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1337), 1,
      sym_identifier,
    ACTIONS(1339), 1,
      anon_sym_BSLASH,
    ACTIONS(1341), 1,
      anon_sym_function,
    ACTIONS(1343), 1,
      anon_sym_if,
    ACTIONS(1345), 1,
      anon_sym_for,
    ACTIONS(1347), 1,
      anon_sym_while,
    ACTIONS(1349), 1,
      anon_sym_repeat,
    ACTIONS(1351), 1,
      anon_sym_QMARK,
    ACTIONS(1353), 1,
      anon_sym_TILDE,
    ACTIONS(1361), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1363), 1,
      sym__number_literal,
    ACTIONS(1365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1367), 1,
      anon_sym_DQUOTE,
    ACTIONS(1377), 1,
      sym__raw_string_literal,
    ACTIONS(1379), 1,
      sym__external_open_parenthesis,
    ACTIONS(1383), 1,
      sym__external_open_brace,
    ACTIONS(9409), 1,
      anon_sym_BANG,
    ACTIONS(12785), 1,
      sym_dot_dot_i,
    ACTIONS(12787), 1,
      sym__newline,
    STATE(94), 1,
      sym__open_brace,
    STATE(190), 1,
      sym__open_parenthesis,
    STATE(2231), 1,
      sym_string,
    STATE(2354), 1,
      sym__double_quoted_string,
    STATE(2355), 1,
      sym__single_quoted_string,
    STATE(3948), 1,
      aux_sym_function_definition_repeat1,
    STATE(5156), 1,
      sym__string_or_identifier,
    ACTIONS(1357), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2356), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1371), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12783), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1002), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [128095] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1337), 1,
      sym_identifier,
    ACTIONS(1339), 1,
      anon_sym_BSLASH,
    ACTIONS(1341), 1,
      anon_sym_function,
    ACTIONS(1343), 1,
      anon_sym_if,
    ACTIONS(1345), 1,
      anon_sym_for,
    ACTIONS(1347), 1,
      anon_sym_while,
    ACTIONS(1349), 1,
      anon_sym_repeat,
    ACTIONS(1351), 1,
      anon_sym_QMARK,
    ACTIONS(1353), 1,
      anon_sym_TILDE,
    ACTIONS(1361), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1363), 1,
      sym__number_literal,
    ACTIONS(1365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1367), 1,
      anon_sym_DQUOTE,
    ACTIONS(1377), 1,
      sym__raw_string_literal,
    ACTIONS(1379), 1,
      sym__external_open_parenthesis,
    ACTIONS(1383), 1,
      sym__external_open_brace,
    ACTIONS(9409), 1,
      anon_sym_BANG,
    ACTIONS(12791), 1,
      sym_dot_dot_i,
    ACTIONS(12793), 1,
      sym__newline,
    STATE(94), 1,
      sym__open_brace,
    STATE(190), 1,
      sym__open_parenthesis,
    STATE(2231), 1,
      sym_string,
    STATE(2354), 1,
      sym__double_quoted_string,
    STATE(2355), 1,
      sym__single_quoted_string,
    STATE(3956), 1,
      aux_sym_function_definition_repeat1,
    STATE(5156), 1,
      sym__string_or_identifier,
    ACTIONS(1357), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2356), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1371), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12789), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(998), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [128224] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4752), 1,
      sym_identifier,
    ACTIONS(4754), 1,
      anon_sym_BSLASH,
    ACTIONS(4756), 1,
      anon_sym_function,
    ACTIONS(4758), 1,
      anon_sym_if,
    ACTIONS(4760), 1,
      anon_sym_for,
    ACTIONS(4762), 1,
      anon_sym_while,
    ACTIONS(4764), 1,
      anon_sym_repeat,
    ACTIONS(4766), 1,
      anon_sym_QMARK,
    ACTIONS(4768), 1,
      anon_sym_TILDE,
    ACTIONS(4776), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4778), 1,
      sym__number_literal,
    ACTIONS(4780), 1,
      anon_sym_SQUOTE,
    ACTIONS(4782), 1,
      anon_sym_DQUOTE,
    ACTIONS(4790), 1,
      sym__raw_string_literal,
    ACTIONS(4792), 1,
      sym__external_open_parenthesis,
    ACTIONS(4794), 1,
      sym__external_open_brace,
    ACTIONS(6353), 1,
      anon_sym_BANG,
    ACTIONS(12797), 1,
      sym_dot_dot_i,
    ACTIONS(12799), 1,
      sym__newline,
    STATE(192), 1,
      sym__open_brace,
    STATE(214), 1,
      sym__open_parenthesis,
    STATE(2664), 1,
      sym_string,
    STATE(2701), 1,
      sym__single_quoted_string,
    STATE(2745), 1,
      sym__double_quoted_string,
    STATE(3863), 1,
      aux_sym_function_definition_repeat1,
    STATE(5148), 1,
      sym__string_or_identifier,
    ACTIONS(4772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2700), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4786), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12795), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2108), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [128353] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1337), 1,
      sym_identifier,
    ACTIONS(1339), 1,
      anon_sym_BSLASH,
    ACTIONS(1341), 1,
      anon_sym_function,
    ACTIONS(1343), 1,
      anon_sym_if,
    ACTIONS(1345), 1,
      anon_sym_for,
    ACTIONS(1347), 1,
      anon_sym_while,
    ACTIONS(1349), 1,
      anon_sym_repeat,
    ACTIONS(1351), 1,
      anon_sym_QMARK,
    ACTIONS(1353), 1,
      anon_sym_TILDE,
    ACTIONS(1361), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1363), 1,
      sym__number_literal,
    ACTIONS(1365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1367), 1,
      anon_sym_DQUOTE,
    ACTIONS(1377), 1,
      sym__raw_string_literal,
    ACTIONS(1379), 1,
      sym__external_open_parenthesis,
    ACTIONS(1383), 1,
      sym__external_open_brace,
    ACTIONS(9409), 1,
      anon_sym_BANG,
    ACTIONS(12803), 1,
      sym_dot_dot_i,
    ACTIONS(12805), 1,
      sym__newline,
    STATE(94), 1,
      sym__open_brace,
    STATE(190), 1,
      sym__open_parenthesis,
    STATE(2231), 1,
      sym_string,
    STATE(2354), 1,
      sym__double_quoted_string,
    STATE(2355), 1,
      sym__single_quoted_string,
    STATE(3960), 1,
      aux_sym_function_definition_repeat1,
    STATE(5156), 1,
      sym__string_or_identifier,
    ACTIONS(1357), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2356), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1371), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12801), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(997), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [128482] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1337), 1,
      sym_identifier,
    ACTIONS(1339), 1,
      anon_sym_BSLASH,
    ACTIONS(1341), 1,
      anon_sym_function,
    ACTIONS(1343), 1,
      anon_sym_if,
    ACTIONS(1345), 1,
      anon_sym_for,
    ACTIONS(1347), 1,
      anon_sym_while,
    ACTIONS(1349), 1,
      anon_sym_repeat,
    ACTIONS(1351), 1,
      anon_sym_QMARK,
    ACTIONS(1353), 1,
      anon_sym_TILDE,
    ACTIONS(1361), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1363), 1,
      sym__number_literal,
    ACTIONS(1365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1367), 1,
      anon_sym_DQUOTE,
    ACTIONS(1377), 1,
      sym__raw_string_literal,
    ACTIONS(1379), 1,
      sym__external_open_parenthesis,
    ACTIONS(1383), 1,
      sym__external_open_brace,
    ACTIONS(9409), 1,
      anon_sym_BANG,
    ACTIONS(12809), 1,
      sym_dot_dot_i,
    ACTIONS(12811), 1,
      sym__newline,
    STATE(94), 1,
      sym__open_brace,
    STATE(190), 1,
      sym__open_parenthesis,
    STATE(2231), 1,
      sym_string,
    STATE(2354), 1,
      sym__double_quoted_string,
    STATE(2355), 1,
      sym__single_quoted_string,
    STATE(3962), 1,
      aux_sym_function_definition_repeat1,
    STATE(5156), 1,
      sym__string_or_identifier,
    ACTIONS(1357), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2356), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1371), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12807), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(996), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [128611] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(161), 1,
      sym_identifier,
    ACTIONS(163), 1,
      anon_sym_BSLASH,
    ACTIONS(165), 1,
      anon_sym_function,
    ACTIONS(167), 1,
      anon_sym_if,
    ACTIONS(169), 1,
      anon_sym_for,
    ACTIONS(171), 1,
      anon_sym_while,
    ACTIONS(173), 1,
      anon_sym_repeat,
    ACTIONS(175), 1,
      anon_sym_QMARK,
    ACTIONS(177), 1,
      anon_sym_TILDE,
    ACTIONS(185), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(187), 1,
      sym__number_literal,
    ACTIONS(189), 1,
      anon_sym_SQUOTE,
    ACTIONS(191), 1,
      anon_sym_DQUOTE,
    ACTIONS(201), 1,
      sym__raw_string_literal,
    ACTIONS(203), 1,
      sym__external_open_parenthesis,
    ACTIONS(207), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8009), 1,
      anon_sym_BANG,
    ACTIONS(12815), 1,
      sym_dot_dot_i,
    STATE(14), 1,
      sym__open_parenthesis,
    STATE(18), 1,
      sym__open_brace,
    STATE(1923), 1,
      sym__single_quoted_string,
    STATE(1927), 1,
      sym_string,
    STATE(1934), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5137), 1,
      sym__string_or_identifier,
    ACTIONS(181), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1925), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(195), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12813), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(622), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [128740] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(12819), 1,
      sym_dot_dot_i,
    STATE(292), 1,
      sym__open_brace,
    STATE(293), 1,
      sym__open_parenthesis,
    STATE(2562), 1,
      sym_string,
    STATE(2737), 1,
      sym__double_quoted_string,
    STATE(2738), 1,
      sym__single_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5152), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2739), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12817), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1959), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [128869] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(161), 1,
      sym_identifier,
    ACTIONS(163), 1,
      anon_sym_BSLASH,
    ACTIONS(165), 1,
      anon_sym_function,
    ACTIONS(167), 1,
      anon_sym_if,
    ACTIONS(169), 1,
      anon_sym_for,
    ACTIONS(171), 1,
      anon_sym_while,
    ACTIONS(173), 1,
      anon_sym_repeat,
    ACTIONS(175), 1,
      anon_sym_QMARK,
    ACTIONS(177), 1,
      anon_sym_TILDE,
    ACTIONS(185), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(187), 1,
      sym__number_literal,
    ACTIONS(189), 1,
      anon_sym_SQUOTE,
    ACTIONS(191), 1,
      anon_sym_DQUOTE,
    ACTIONS(201), 1,
      sym__raw_string_literal,
    ACTIONS(203), 1,
      sym__external_open_parenthesis,
    ACTIONS(207), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8009), 1,
      anon_sym_BANG,
    ACTIONS(12823), 1,
      sym_dot_dot_i,
    STATE(14), 1,
      sym__open_parenthesis,
    STATE(18), 1,
      sym__open_brace,
    STATE(1923), 1,
      sym__single_quoted_string,
    STATE(1927), 1,
      sym_string,
    STATE(1934), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5137), 1,
      sym__string_or_identifier,
    ACTIONS(181), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1925), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(195), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12821), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(623), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [128998] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1337), 1,
      sym_identifier,
    ACTIONS(1339), 1,
      anon_sym_BSLASH,
    ACTIONS(1341), 1,
      anon_sym_function,
    ACTIONS(1343), 1,
      anon_sym_if,
    ACTIONS(1345), 1,
      anon_sym_for,
    ACTIONS(1347), 1,
      anon_sym_while,
    ACTIONS(1349), 1,
      anon_sym_repeat,
    ACTIONS(1351), 1,
      anon_sym_QMARK,
    ACTIONS(1353), 1,
      anon_sym_TILDE,
    ACTIONS(1361), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1363), 1,
      sym__number_literal,
    ACTIONS(1365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1367), 1,
      anon_sym_DQUOTE,
    ACTIONS(1377), 1,
      sym__raw_string_literal,
    ACTIONS(1379), 1,
      sym__external_open_parenthesis,
    ACTIONS(1383), 1,
      sym__external_open_brace,
    ACTIONS(9409), 1,
      anon_sym_BANG,
    ACTIONS(12827), 1,
      sym_dot_dot_i,
    ACTIONS(12829), 1,
      sym__newline,
    STATE(94), 1,
      sym__open_brace,
    STATE(190), 1,
      sym__open_parenthesis,
    STATE(2231), 1,
      sym_string,
    STATE(2354), 1,
      sym__double_quoted_string,
    STATE(2355), 1,
      sym__single_quoted_string,
    STATE(3964), 1,
      aux_sym_function_definition_repeat1,
    STATE(5156), 1,
      sym__string_or_identifier,
    ACTIONS(1357), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2356), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1371), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12825), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(995), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [129127] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(161), 1,
      sym_identifier,
    ACTIONS(163), 1,
      anon_sym_BSLASH,
    ACTIONS(165), 1,
      anon_sym_function,
    ACTIONS(167), 1,
      anon_sym_if,
    ACTIONS(169), 1,
      anon_sym_for,
    ACTIONS(171), 1,
      anon_sym_while,
    ACTIONS(173), 1,
      anon_sym_repeat,
    ACTIONS(175), 1,
      anon_sym_QMARK,
    ACTIONS(177), 1,
      anon_sym_TILDE,
    ACTIONS(185), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(187), 1,
      sym__number_literal,
    ACTIONS(189), 1,
      anon_sym_SQUOTE,
    ACTIONS(191), 1,
      anon_sym_DQUOTE,
    ACTIONS(201), 1,
      sym__raw_string_literal,
    ACTIONS(203), 1,
      sym__external_open_parenthesis,
    ACTIONS(207), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8009), 1,
      anon_sym_BANG,
    ACTIONS(12833), 1,
      sym_dot_dot_i,
    STATE(14), 1,
      sym__open_parenthesis,
    STATE(18), 1,
      sym__open_brace,
    STATE(1923), 1,
      sym__single_quoted_string,
    STATE(1927), 1,
      sym_string,
    STATE(1934), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5137), 1,
      sym__string_or_identifier,
    ACTIONS(181), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1925), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(195), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12831), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(624), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [129256] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(12837), 1,
      sym_dot_dot_i,
    STATE(292), 1,
      sym__open_brace,
    STATE(293), 1,
      sym__open_parenthesis,
    STATE(2562), 1,
      sym_string,
    STATE(2737), 1,
      sym__double_quoted_string,
    STATE(2738), 1,
      sym__single_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5152), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2739), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12835), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2002), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [129385] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(161), 1,
      sym_identifier,
    ACTIONS(163), 1,
      anon_sym_BSLASH,
    ACTIONS(165), 1,
      anon_sym_function,
    ACTIONS(167), 1,
      anon_sym_if,
    ACTIONS(169), 1,
      anon_sym_for,
    ACTIONS(171), 1,
      anon_sym_while,
    ACTIONS(173), 1,
      anon_sym_repeat,
    ACTIONS(175), 1,
      anon_sym_QMARK,
    ACTIONS(177), 1,
      anon_sym_TILDE,
    ACTIONS(185), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(187), 1,
      sym__number_literal,
    ACTIONS(189), 1,
      anon_sym_SQUOTE,
    ACTIONS(191), 1,
      anon_sym_DQUOTE,
    ACTIONS(201), 1,
      sym__raw_string_literal,
    ACTIONS(203), 1,
      sym__external_open_parenthesis,
    ACTIONS(207), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8009), 1,
      anon_sym_BANG,
    ACTIONS(12841), 1,
      sym_dot_dot_i,
    STATE(14), 1,
      sym__open_parenthesis,
    STATE(18), 1,
      sym__open_brace,
    STATE(1923), 1,
      sym__single_quoted_string,
    STATE(1927), 1,
      sym_string,
    STATE(1934), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5137), 1,
      sym__string_or_identifier,
    ACTIONS(181), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1925), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(195), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12839), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(625), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [129514] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(161), 1,
      sym_identifier,
    ACTIONS(163), 1,
      anon_sym_BSLASH,
    ACTIONS(165), 1,
      anon_sym_function,
    ACTIONS(167), 1,
      anon_sym_if,
    ACTIONS(169), 1,
      anon_sym_for,
    ACTIONS(171), 1,
      anon_sym_while,
    ACTIONS(173), 1,
      anon_sym_repeat,
    ACTIONS(175), 1,
      anon_sym_QMARK,
    ACTIONS(177), 1,
      anon_sym_TILDE,
    ACTIONS(185), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(187), 1,
      sym__number_literal,
    ACTIONS(189), 1,
      anon_sym_SQUOTE,
    ACTIONS(191), 1,
      anon_sym_DQUOTE,
    ACTIONS(201), 1,
      sym__raw_string_literal,
    ACTIONS(203), 1,
      sym__external_open_parenthesis,
    ACTIONS(207), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8009), 1,
      anon_sym_BANG,
    ACTIONS(12845), 1,
      sym_dot_dot_i,
    STATE(14), 1,
      sym__open_parenthesis,
    STATE(18), 1,
      sym__open_brace,
    STATE(1923), 1,
      sym__single_quoted_string,
    STATE(1927), 1,
      sym_string,
    STATE(1934), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5137), 1,
      sym__string_or_identifier,
    ACTIONS(181), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1925), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(195), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12843), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(651), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [129643] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(12849), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12847), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4578), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [129772] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1337), 1,
      sym_identifier,
    ACTIONS(1339), 1,
      anon_sym_BSLASH,
    ACTIONS(1341), 1,
      anon_sym_function,
    ACTIONS(1343), 1,
      anon_sym_if,
    ACTIONS(1345), 1,
      anon_sym_for,
    ACTIONS(1347), 1,
      anon_sym_while,
    ACTIONS(1349), 1,
      anon_sym_repeat,
    ACTIONS(1351), 1,
      anon_sym_QMARK,
    ACTIONS(1353), 1,
      anon_sym_TILDE,
    ACTIONS(1361), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1363), 1,
      sym__number_literal,
    ACTIONS(1365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1367), 1,
      anon_sym_DQUOTE,
    ACTIONS(1377), 1,
      sym__raw_string_literal,
    ACTIONS(1379), 1,
      sym__external_open_parenthesis,
    ACTIONS(1383), 1,
      sym__external_open_brace,
    ACTIONS(9409), 1,
      anon_sym_BANG,
    ACTIONS(12853), 1,
      sym_dot_dot_i,
    ACTIONS(12855), 1,
      sym__newline,
    STATE(94), 1,
      sym__open_brace,
    STATE(190), 1,
      sym__open_parenthesis,
    STATE(2231), 1,
      sym_string,
    STATE(2354), 1,
      sym__double_quoted_string,
    STATE(2355), 1,
      sym__single_quoted_string,
    STATE(3966), 1,
      aux_sym_function_definition_repeat1,
    STATE(5156), 1,
      sym__string_or_identifier,
    ACTIONS(1357), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2356), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1371), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12851), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(992), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [129901] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1337), 1,
      sym_identifier,
    ACTIONS(1339), 1,
      anon_sym_BSLASH,
    ACTIONS(1341), 1,
      anon_sym_function,
    ACTIONS(1343), 1,
      anon_sym_if,
    ACTIONS(1345), 1,
      anon_sym_for,
    ACTIONS(1347), 1,
      anon_sym_while,
    ACTIONS(1349), 1,
      anon_sym_repeat,
    ACTIONS(1351), 1,
      anon_sym_QMARK,
    ACTIONS(1353), 1,
      anon_sym_TILDE,
    ACTIONS(1361), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1363), 1,
      sym__number_literal,
    ACTIONS(1365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1367), 1,
      anon_sym_DQUOTE,
    ACTIONS(1377), 1,
      sym__raw_string_literal,
    ACTIONS(1379), 1,
      sym__external_open_parenthesis,
    ACTIONS(1383), 1,
      sym__external_open_brace,
    ACTIONS(9409), 1,
      anon_sym_BANG,
    ACTIONS(12859), 1,
      sym_dot_dot_i,
    ACTIONS(12861), 1,
      sym__newline,
    STATE(94), 1,
      sym__open_brace,
    STATE(190), 1,
      sym__open_parenthesis,
    STATE(2231), 1,
      sym_string,
    STATE(2354), 1,
      sym__double_quoted_string,
    STATE(2355), 1,
      sym__single_quoted_string,
    STATE(3968), 1,
      aux_sym_function_definition_repeat1,
    STATE(5156), 1,
      sym__string_or_identifier,
    ACTIONS(1357), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2356), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1371), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12857), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(990), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [130030] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(161), 1,
      sym_identifier,
    ACTIONS(163), 1,
      anon_sym_BSLASH,
    ACTIONS(165), 1,
      anon_sym_function,
    ACTIONS(167), 1,
      anon_sym_if,
    ACTIONS(169), 1,
      anon_sym_for,
    ACTIONS(171), 1,
      anon_sym_while,
    ACTIONS(173), 1,
      anon_sym_repeat,
    ACTIONS(175), 1,
      anon_sym_QMARK,
    ACTIONS(177), 1,
      anon_sym_TILDE,
    ACTIONS(185), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(187), 1,
      sym__number_literal,
    ACTIONS(189), 1,
      anon_sym_SQUOTE,
    ACTIONS(191), 1,
      anon_sym_DQUOTE,
    ACTIONS(201), 1,
      sym__raw_string_literal,
    ACTIONS(203), 1,
      sym__external_open_parenthesis,
    ACTIONS(207), 1,
      sym__external_open_brace,
    ACTIONS(8009), 1,
      anon_sym_BANG,
    ACTIONS(12865), 1,
      sym_dot_dot_i,
    ACTIONS(12867), 1,
      sym__newline,
    STATE(14), 1,
      sym__open_parenthesis,
    STATE(18), 1,
      sym__open_brace,
    STATE(1923), 1,
      sym__single_quoted_string,
    STATE(1927), 1,
      sym_string,
    STATE(1934), 1,
      sym__double_quoted_string,
    STATE(4068), 1,
      aux_sym_function_definition_repeat1,
    STATE(5137), 1,
      sym__string_or_identifier,
    ACTIONS(181), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1925), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(195), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12863), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(626), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [130159] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(161), 1,
      sym_identifier,
    ACTIONS(163), 1,
      anon_sym_BSLASH,
    ACTIONS(165), 1,
      anon_sym_function,
    ACTIONS(167), 1,
      anon_sym_if,
    ACTIONS(169), 1,
      anon_sym_for,
    ACTIONS(171), 1,
      anon_sym_while,
    ACTIONS(173), 1,
      anon_sym_repeat,
    ACTIONS(175), 1,
      anon_sym_QMARK,
    ACTIONS(177), 1,
      anon_sym_TILDE,
    ACTIONS(185), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(187), 1,
      sym__number_literal,
    ACTIONS(189), 1,
      anon_sym_SQUOTE,
    ACTIONS(191), 1,
      anon_sym_DQUOTE,
    ACTIONS(201), 1,
      sym__raw_string_literal,
    ACTIONS(203), 1,
      sym__external_open_parenthesis,
    ACTIONS(207), 1,
      sym__external_open_brace,
    ACTIONS(8009), 1,
      anon_sym_BANG,
    ACTIONS(12871), 1,
      sym_dot_dot_i,
    ACTIONS(12873), 1,
      sym__newline,
    STATE(14), 1,
      sym__open_parenthesis,
    STATE(18), 1,
      sym__open_brace,
    STATE(1923), 1,
      sym__single_quoted_string,
    STATE(1927), 1,
      sym_string,
    STATE(1934), 1,
      sym__double_quoted_string,
    STATE(4070), 1,
      aux_sym_function_definition_repeat1,
    STATE(5137), 1,
      sym__string_or_identifier,
    ACTIONS(181), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1925), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(195), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12869), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(627), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [130288] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(161), 1,
      sym_identifier,
    ACTIONS(163), 1,
      anon_sym_BSLASH,
    ACTIONS(165), 1,
      anon_sym_function,
    ACTIONS(167), 1,
      anon_sym_if,
    ACTIONS(169), 1,
      anon_sym_for,
    ACTIONS(171), 1,
      anon_sym_while,
    ACTIONS(173), 1,
      anon_sym_repeat,
    ACTIONS(175), 1,
      anon_sym_QMARK,
    ACTIONS(177), 1,
      anon_sym_TILDE,
    ACTIONS(185), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(187), 1,
      sym__number_literal,
    ACTIONS(189), 1,
      anon_sym_SQUOTE,
    ACTIONS(191), 1,
      anon_sym_DQUOTE,
    ACTIONS(201), 1,
      sym__raw_string_literal,
    ACTIONS(203), 1,
      sym__external_open_parenthesis,
    ACTIONS(207), 1,
      sym__external_open_brace,
    ACTIONS(8009), 1,
      anon_sym_BANG,
    ACTIONS(12877), 1,
      sym_dot_dot_i,
    ACTIONS(12879), 1,
      sym__newline,
    STATE(14), 1,
      sym__open_parenthesis,
    STATE(18), 1,
      sym__open_brace,
    STATE(1923), 1,
      sym__single_quoted_string,
    STATE(1927), 1,
      sym_string,
    STATE(1934), 1,
      sym__double_quoted_string,
    STATE(4072), 1,
      aux_sym_function_definition_repeat1,
    STATE(5137), 1,
      sym__string_or_identifier,
    ACTIONS(181), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1925), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(195), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12875), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(628), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [130417] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(161), 1,
      sym_identifier,
    ACTIONS(163), 1,
      anon_sym_BSLASH,
    ACTIONS(165), 1,
      anon_sym_function,
    ACTIONS(167), 1,
      anon_sym_if,
    ACTIONS(169), 1,
      anon_sym_for,
    ACTIONS(171), 1,
      anon_sym_while,
    ACTIONS(173), 1,
      anon_sym_repeat,
    ACTIONS(175), 1,
      anon_sym_QMARK,
    ACTIONS(177), 1,
      anon_sym_TILDE,
    ACTIONS(185), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(187), 1,
      sym__number_literal,
    ACTIONS(189), 1,
      anon_sym_SQUOTE,
    ACTIONS(191), 1,
      anon_sym_DQUOTE,
    ACTIONS(201), 1,
      sym__raw_string_literal,
    ACTIONS(203), 1,
      sym__external_open_parenthesis,
    ACTIONS(207), 1,
      sym__external_open_brace,
    ACTIONS(8009), 1,
      anon_sym_BANG,
    ACTIONS(12883), 1,
      sym_dot_dot_i,
    ACTIONS(12885), 1,
      sym__newline,
    STATE(14), 1,
      sym__open_parenthesis,
    STATE(18), 1,
      sym__open_brace,
    STATE(1923), 1,
      sym__single_quoted_string,
    STATE(1927), 1,
      sym_string,
    STATE(1934), 1,
      sym__double_quoted_string,
    STATE(4074), 1,
      aux_sym_function_definition_repeat1,
    STATE(5137), 1,
      sym__string_or_identifier,
    ACTIONS(181), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1925), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(195), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12881), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(629), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [130546] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(161), 1,
      sym_identifier,
    ACTIONS(163), 1,
      anon_sym_BSLASH,
    ACTIONS(165), 1,
      anon_sym_function,
    ACTIONS(167), 1,
      anon_sym_if,
    ACTIONS(169), 1,
      anon_sym_for,
    ACTIONS(171), 1,
      anon_sym_while,
    ACTIONS(173), 1,
      anon_sym_repeat,
    ACTIONS(175), 1,
      anon_sym_QMARK,
    ACTIONS(177), 1,
      anon_sym_TILDE,
    ACTIONS(185), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(187), 1,
      sym__number_literal,
    ACTIONS(189), 1,
      anon_sym_SQUOTE,
    ACTIONS(191), 1,
      anon_sym_DQUOTE,
    ACTIONS(201), 1,
      sym__raw_string_literal,
    ACTIONS(203), 1,
      sym__external_open_parenthesis,
    ACTIONS(207), 1,
      sym__external_open_brace,
    ACTIONS(8009), 1,
      anon_sym_BANG,
    ACTIONS(12889), 1,
      sym_dot_dot_i,
    ACTIONS(12891), 1,
      sym__newline,
    STATE(14), 1,
      sym__open_parenthesis,
    STATE(18), 1,
      sym__open_brace,
    STATE(1923), 1,
      sym__single_quoted_string,
    STATE(1927), 1,
      sym_string,
    STATE(1934), 1,
      sym__double_quoted_string,
    STATE(4076), 1,
      aux_sym_function_definition_repeat1,
    STATE(5137), 1,
      sym__string_or_identifier,
    ACTIONS(181), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1925), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(195), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12887), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(630), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [130675] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(161), 1,
      sym_identifier,
    ACTIONS(163), 1,
      anon_sym_BSLASH,
    ACTIONS(165), 1,
      anon_sym_function,
    ACTIONS(167), 1,
      anon_sym_if,
    ACTIONS(169), 1,
      anon_sym_for,
    ACTIONS(171), 1,
      anon_sym_while,
    ACTIONS(173), 1,
      anon_sym_repeat,
    ACTIONS(175), 1,
      anon_sym_QMARK,
    ACTIONS(177), 1,
      anon_sym_TILDE,
    ACTIONS(185), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(187), 1,
      sym__number_literal,
    ACTIONS(189), 1,
      anon_sym_SQUOTE,
    ACTIONS(191), 1,
      anon_sym_DQUOTE,
    ACTIONS(201), 1,
      sym__raw_string_literal,
    ACTIONS(203), 1,
      sym__external_open_parenthesis,
    ACTIONS(207), 1,
      sym__external_open_brace,
    ACTIONS(8009), 1,
      anon_sym_BANG,
    ACTIONS(12895), 1,
      sym_dot_dot_i,
    ACTIONS(12897), 1,
      sym__newline,
    STATE(14), 1,
      sym__open_parenthesis,
    STATE(18), 1,
      sym__open_brace,
    STATE(1923), 1,
      sym__single_quoted_string,
    STATE(1927), 1,
      sym_string,
    STATE(1934), 1,
      sym__double_quoted_string,
    STATE(4078), 1,
      aux_sym_function_definition_repeat1,
    STATE(5137), 1,
      sym__string_or_identifier,
    ACTIONS(181), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1925), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(195), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12893), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(631), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [130804] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(161), 1,
      sym_identifier,
    ACTIONS(163), 1,
      anon_sym_BSLASH,
    ACTIONS(165), 1,
      anon_sym_function,
    ACTIONS(167), 1,
      anon_sym_if,
    ACTIONS(169), 1,
      anon_sym_for,
    ACTIONS(171), 1,
      anon_sym_while,
    ACTIONS(173), 1,
      anon_sym_repeat,
    ACTIONS(175), 1,
      anon_sym_QMARK,
    ACTIONS(177), 1,
      anon_sym_TILDE,
    ACTIONS(185), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(187), 1,
      sym__number_literal,
    ACTIONS(189), 1,
      anon_sym_SQUOTE,
    ACTIONS(191), 1,
      anon_sym_DQUOTE,
    ACTIONS(201), 1,
      sym__raw_string_literal,
    ACTIONS(203), 1,
      sym__external_open_parenthesis,
    ACTIONS(207), 1,
      sym__external_open_brace,
    ACTIONS(8009), 1,
      anon_sym_BANG,
    ACTIONS(12901), 1,
      sym_dot_dot_i,
    ACTIONS(12903), 1,
      sym__newline,
    STATE(14), 1,
      sym__open_parenthesis,
    STATE(18), 1,
      sym__open_brace,
    STATE(1923), 1,
      sym__single_quoted_string,
    STATE(1927), 1,
      sym_string,
    STATE(1934), 1,
      sym__double_quoted_string,
    STATE(4080), 1,
      aux_sym_function_definition_repeat1,
    STATE(5137), 1,
      sym__string_or_identifier,
    ACTIONS(181), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1925), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(195), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12899), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(632), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [130933] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(161), 1,
      sym_identifier,
    ACTIONS(163), 1,
      anon_sym_BSLASH,
    ACTIONS(165), 1,
      anon_sym_function,
    ACTIONS(167), 1,
      anon_sym_if,
    ACTIONS(169), 1,
      anon_sym_for,
    ACTIONS(171), 1,
      anon_sym_while,
    ACTIONS(173), 1,
      anon_sym_repeat,
    ACTIONS(175), 1,
      anon_sym_QMARK,
    ACTIONS(177), 1,
      anon_sym_TILDE,
    ACTIONS(185), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(187), 1,
      sym__number_literal,
    ACTIONS(189), 1,
      anon_sym_SQUOTE,
    ACTIONS(191), 1,
      anon_sym_DQUOTE,
    ACTIONS(201), 1,
      sym__raw_string_literal,
    ACTIONS(203), 1,
      sym__external_open_parenthesis,
    ACTIONS(207), 1,
      sym__external_open_brace,
    ACTIONS(8009), 1,
      anon_sym_BANG,
    ACTIONS(12907), 1,
      sym_dot_dot_i,
    ACTIONS(12909), 1,
      sym__newline,
    STATE(14), 1,
      sym__open_parenthesis,
    STATE(18), 1,
      sym__open_brace,
    STATE(1923), 1,
      sym__single_quoted_string,
    STATE(1927), 1,
      sym_string,
    STATE(1934), 1,
      sym__double_quoted_string,
    STATE(4082), 1,
      aux_sym_function_definition_repeat1,
    STATE(5137), 1,
      sym__string_or_identifier,
    ACTIONS(181), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1925), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(195), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12905), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(633), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [131062] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(161), 1,
      sym_identifier,
    ACTIONS(163), 1,
      anon_sym_BSLASH,
    ACTIONS(165), 1,
      anon_sym_function,
    ACTIONS(167), 1,
      anon_sym_if,
    ACTIONS(169), 1,
      anon_sym_for,
    ACTIONS(171), 1,
      anon_sym_while,
    ACTIONS(173), 1,
      anon_sym_repeat,
    ACTIONS(175), 1,
      anon_sym_QMARK,
    ACTIONS(177), 1,
      anon_sym_TILDE,
    ACTIONS(185), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(187), 1,
      sym__number_literal,
    ACTIONS(189), 1,
      anon_sym_SQUOTE,
    ACTIONS(191), 1,
      anon_sym_DQUOTE,
    ACTIONS(201), 1,
      sym__raw_string_literal,
    ACTIONS(203), 1,
      sym__external_open_parenthesis,
    ACTIONS(207), 1,
      sym__external_open_brace,
    ACTIONS(8009), 1,
      anon_sym_BANG,
    ACTIONS(12913), 1,
      sym_dot_dot_i,
    ACTIONS(12915), 1,
      sym__newline,
    STATE(14), 1,
      sym__open_parenthesis,
    STATE(18), 1,
      sym__open_brace,
    STATE(1923), 1,
      sym__single_quoted_string,
    STATE(1927), 1,
      sym_string,
    STATE(1934), 1,
      sym__double_quoted_string,
    STATE(4084), 1,
      aux_sym_function_definition_repeat1,
    STATE(5137), 1,
      sym__string_or_identifier,
    ACTIONS(181), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1925), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(195), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12911), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(634), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [131191] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(161), 1,
      sym_identifier,
    ACTIONS(163), 1,
      anon_sym_BSLASH,
    ACTIONS(165), 1,
      anon_sym_function,
    ACTIONS(167), 1,
      anon_sym_if,
    ACTIONS(169), 1,
      anon_sym_for,
    ACTIONS(171), 1,
      anon_sym_while,
    ACTIONS(173), 1,
      anon_sym_repeat,
    ACTIONS(175), 1,
      anon_sym_QMARK,
    ACTIONS(177), 1,
      anon_sym_TILDE,
    ACTIONS(185), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(187), 1,
      sym__number_literal,
    ACTIONS(189), 1,
      anon_sym_SQUOTE,
    ACTIONS(191), 1,
      anon_sym_DQUOTE,
    ACTIONS(201), 1,
      sym__raw_string_literal,
    ACTIONS(203), 1,
      sym__external_open_parenthesis,
    ACTIONS(207), 1,
      sym__external_open_brace,
    ACTIONS(8009), 1,
      anon_sym_BANG,
    ACTIONS(12919), 1,
      sym_dot_dot_i,
    ACTIONS(12921), 1,
      sym__newline,
    STATE(14), 1,
      sym__open_parenthesis,
    STATE(18), 1,
      sym__open_brace,
    STATE(1923), 1,
      sym__single_quoted_string,
    STATE(1927), 1,
      sym_string,
    STATE(1934), 1,
      sym__double_quoted_string,
    STATE(4086), 1,
      aux_sym_function_definition_repeat1,
    STATE(5137), 1,
      sym__string_or_identifier,
    ACTIONS(181), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1925), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(195), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12917), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(635), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [131320] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(161), 1,
      sym_identifier,
    ACTIONS(163), 1,
      anon_sym_BSLASH,
    ACTIONS(165), 1,
      anon_sym_function,
    ACTIONS(167), 1,
      anon_sym_if,
    ACTIONS(169), 1,
      anon_sym_for,
    ACTIONS(171), 1,
      anon_sym_while,
    ACTIONS(173), 1,
      anon_sym_repeat,
    ACTIONS(175), 1,
      anon_sym_QMARK,
    ACTIONS(177), 1,
      anon_sym_TILDE,
    ACTIONS(185), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(187), 1,
      sym__number_literal,
    ACTIONS(189), 1,
      anon_sym_SQUOTE,
    ACTIONS(191), 1,
      anon_sym_DQUOTE,
    ACTIONS(201), 1,
      sym__raw_string_literal,
    ACTIONS(203), 1,
      sym__external_open_parenthesis,
    ACTIONS(207), 1,
      sym__external_open_brace,
    ACTIONS(8009), 1,
      anon_sym_BANG,
    ACTIONS(12925), 1,
      sym_dot_dot_i,
    ACTIONS(12927), 1,
      sym__newline,
    STATE(14), 1,
      sym__open_parenthesis,
    STATE(18), 1,
      sym__open_brace,
    STATE(1923), 1,
      sym__single_quoted_string,
    STATE(1927), 1,
      sym_string,
    STATE(1934), 1,
      sym__double_quoted_string,
    STATE(4088), 1,
      aux_sym_function_definition_repeat1,
    STATE(5137), 1,
      sym__string_or_identifier,
    ACTIONS(181), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1925), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(195), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12923), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(636), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [131449] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(161), 1,
      sym_identifier,
    ACTIONS(163), 1,
      anon_sym_BSLASH,
    ACTIONS(165), 1,
      anon_sym_function,
    ACTIONS(167), 1,
      anon_sym_if,
    ACTIONS(169), 1,
      anon_sym_for,
    ACTIONS(171), 1,
      anon_sym_while,
    ACTIONS(173), 1,
      anon_sym_repeat,
    ACTIONS(175), 1,
      anon_sym_QMARK,
    ACTIONS(177), 1,
      anon_sym_TILDE,
    ACTIONS(185), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(187), 1,
      sym__number_literal,
    ACTIONS(189), 1,
      anon_sym_SQUOTE,
    ACTIONS(191), 1,
      anon_sym_DQUOTE,
    ACTIONS(201), 1,
      sym__raw_string_literal,
    ACTIONS(203), 1,
      sym__external_open_parenthesis,
    ACTIONS(207), 1,
      sym__external_open_brace,
    ACTIONS(8009), 1,
      anon_sym_BANG,
    ACTIONS(12931), 1,
      sym_dot_dot_i,
    ACTIONS(12933), 1,
      sym__newline,
    STATE(14), 1,
      sym__open_parenthesis,
    STATE(18), 1,
      sym__open_brace,
    STATE(1923), 1,
      sym__single_quoted_string,
    STATE(1927), 1,
      sym_string,
    STATE(1934), 1,
      sym__double_quoted_string,
    STATE(4032), 1,
      aux_sym_function_definition_repeat1,
    STATE(5137), 1,
      sym__string_or_identifier,
    ACTIONS(181), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1925), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(195), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12929), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(637), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [131578] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(161), 1,
      sym_identifier,
    ACTIONS(163), 1,
      anon_sym_BSLASH,
    ACTIONS(165), 1,
      anon_sym_function,
    ACTIONS(167), 1,
      anon_sym_if,
    ACTIONS(169), 1,
      anon_sym_for,
    ACTIONS(171), 1,
      anon_sym_while,
    ACTIONS(173), 1,
      anon_sym_repeat,
    ACTIONS(175), 1,
      anon_sym_QMARK,
    ACTIONS(177), 1,
      anon_sym_TILDE,
    ACTIONS(185), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(187), 1,
      sym__number_literal,
    ACTIONS(189), 1,
      anon_sym_SQUOTE,
    ACTIONS(191), 1,
      anon_sym_DQUOTE,
    ACTIONS(201), 1,
      sym__raw_string_literal,
    ACTIONS(203), 1,
      sym__external_open_parenthesis,
    ACTIONS(207), 1,
      sym__external_open_brace,
    ACTIONS(8009), 1,
      anon_sym_BANG,
    ACTIONS(12937), 1,
      sym_dot_dot_i,
    ACTIONS(12939), 1,
      sym__newline,
    STATE(14), 1,
      sym__open_parenthesis,
    STATE(18), 1,
      sym__open_brace,
    STATE(1923), 1,
      sym__single_quoted_string,
    STATE(1927), 1,
      sym_string,
    STATE(1934), 1,
      sym__double_quoted_string,
    STATE(4009), 1,
      aux_sym_function_definition_repeat1,
    STATE(5137), 1,
      sym__string_or_identifier,
    ACTIONS(181), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1925), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(195), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12935), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(638), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [131707] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1337), 1,
      sym_identifier,
    ACTIONS(1339), 1,
      anon_sym_BSLASH,
    ACTIONS(1341), 1,
      anon_sym_function,
    ACTIONS(1343), 1,
      anon_sym_if,
    ACTIONS(1345), 1,
      anon_sym_for,
    ACTIONS(1347), 1,
      anon_sym_while,
    ACTIONS(1349), 1,
      anon_sym_repeat,
    ACTIONS(1351), 1,
      anon_sym_QMARK,
    ACTIONS(1353), 1,
      anon_sym_TILDE,
    ACTIONS(1361), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1363), 1,
      sym__number_literal,
    ACTIONS(1365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1367), 1,
      anon_sym_DQUOTE,
    ACTIONS(1377), 1,
      sym__raw_string_literal,
    ACTIONS(1379), 1,
      sym__external_open_parenthesis,
    ACTIONS(1383), 1,
      sym__external_open_brace,
    ACTIONS(9409), 1,
      anon_sym_BANG,
    ACTIONS(12943), 1,
      sym_dot_dot_i,
    ACTIONS(12945), 1,
      sym__newline,
    STATE(94), 1,
      sym__open_brace,
    STATE(190), 1,
      sym__open_parenthesis,
    STATE(2231), 1,
      sym_string,
    STATE(2354), 1,
      sym__double_quoted_string,
    STATE(2355), 1,
      sym__single_quoted_string,
    STATE(3970), 1,
      aux_sym_function_definition_repeat1,
    STATE(5156), 1,
      sym__string_or_identifier,
    ACTIONS(1357), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2356), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1371), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12941), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(989), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [131836] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1337), 1,
      sym_identifier,
    ACTIONS(1339), 1,
      anon_sym_BSLASH,
    ACTIONS(1341), 1,
      anon_sym_function,
    ACTIONS(1343), 1,
      anon_sym_if,
    ACTIONS(1345), 1,
      anon_sym_for,
    ACTIONS(1347), 1,
      anon_sym_while,
    ACTIONS(1349), 1,
      anon_sym_repeat,
    ACTIONS(1351), 1,
      anon_sym_QMARK,
    ACTIONS(1353), 1,
      anon_sym_TILDE,
    ACTIONS(1361), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1363), 1,
      sym__number_literal,
    ACTIONS(1365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1367), 1,
      anon_sym_DQUOTE,
    ACTIONS(1377), 1,
      sym__raw_string_literal,
    ACTIONS(1379), 1,
      sym__external_open_parenthesis,
    ACTIONS(1383), 1,
      sym__external_open_brace,
    ACTIONS(9409), 1,
      anon_sym_BANG,
    ACTIONS(12949), 1,
      sym_dot_dot_i,
    ACTIONS(12951), 1,
      sym__newline,
    STATE(94), 1,
      sym__open_brace,
    STATE(190), 1,
      sym__open_parenthesis,
    STATE(2231), 1,
      sym_string,
    STATE(2354), 1,
      sym__double_quoted_string,
    STATE(2355), 1,
      sym__single_quoted_string,
    STATE(3983), 1,
      aux_sym_function_definition_repeat1,
    STATE(5156), 1,
      sym__string_or_identifier,
    ACTIONS(1357), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2356), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1371), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12947), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(988), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [131965] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1337), 1,
      sym_identifier,
    ACTIONS(1339), 1,
      anon_sym_BSLASH,
    ACTIONS(1341), 1,
      anon_sym_function,
    ACTIONS(1343), 1,
      anon_sym_if,
    ACTIONS(1345), 1,
      anon_sym_for,
    ACTIONS(1347), 1,
      anon_sym_while,
    ACTIONS(1349), 1,
      anon_sym_repeat,
    ACTIONS(1351), 1,
      anon_sym_QMARK,
    ACTIONS(1353), 1,
      anon_sym_TILDE,
    ACTIONS(1361), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1363), 1,
      sym__number_literal,
    ACTIONS(1365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1367), 1,
      anon_sym_DQUOTE,
    ACTIONS(1377), 1,
      sym__raw_string_literal,
    ACTIONS(1379), 1,
      sym__external_open_parenthesis,
    ACTIONS(1383), 1,
      sym__external_open_brace,
    ACTIONS(9409), 1,
      anon_sym_BANG,
    ACTIONS(12955), 1,
      sym_dot_dot_i,
    ACTIONS(12957), 1,
      sym__newline,
    STATE(94), 1,
      sym__open_brace,
    STATE(190), 1,
      sym__open_parenthesis,
    STATE(2231), 1,
      sym_string,
    STATE(2354), 1,
      sym__double_quoted_string,
    STATE(2355), 1,
      sym__single_quoted_string,
    STATE(3985), 1,
      aux_sym_function_definition_repeat1,
    STATE(5156), 1,
      sym__string_or_identifier,
    ACTIONS(1357), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2356), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1371), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12953), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(987), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [132094] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1337), 1,
      sym_identifier,
    ACTIONS(1339), 1,
      anon_sym_BSLASH,
    ACTIONS(1341), 1,
      anon_sym_function,
    ACTIONS(1343), 1,
      anon_sym_if,
    ACTIONS(1345), 1,
      anon_sym_for,
    ACTIONS(1347), 1,
      anon_sym_while,
    ACTIONS(1349), 1,
      anon_sym_repeat,
    ACTIONS(1351), 1,
      anon_sym_QMARK,
    ACTIONS(1353), 1,
      anon_sym_TILDE,
    ACTIONS(1361), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1363), 1,
      sym__number_literal,
    ACTIONS(1365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1367), 1,
      anon_sym_DQUOTE,
    ACTIONS(1377), 1,
      sym__raw_string_literal,
    ACTIONS(1379), 1,
      sym__external_open_parenthesis,
    ACTIONS(1383), 1,
      sym__external_open_brace,
    ACTIONS(9409), 1,
      anon_sym_BANG,
    ACTIONS(12961), 1,
      sym_dot_dot_i,
    ACTIONS(12963), 1,
      sym__newline,
    STATE(94), 1,
      sym__open_brace,
    STATE(190), 1,
      sym__open_parenthesis,
    STATE(2231), 1,
      sym_string,
    STATE(2354), 1,
      sym__double_quoted_string,
    STATE(2355), 1,
      sym__single_quoted_string,
    STATE(3987), 1,
      aux_sym_function_definition_repeat1,
    STATE(5156), 1,
      sym__string_or_identifier,
    ACTIONS(1357), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2356), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1371), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12959), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(986), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [132223] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1337), 1,
      sym_identifier,
    ACTIONS(1339), 1,
      anon_sym_BSLASH,
    ACTIONS(1341), 1,
      anon_sym_function,
    ACTIONS(1343), 1,
      anon_sym_if,
    ACTIONS(1345), 1,
      anon_sym_for,
    ACTIONS(1347), 1,
      anon_sym_while,
    ACTIONS(1349), 1,
      anon_sym_repeat,
    ACTIONS(1351), 1,
      anon_sym_QMARK,
    ACTIONS(1353), 1,
      anon_sym_TILDE,
    ACTIONS(1361), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1363), 1,
      sym__number_literal,
    ACTIONS(1365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1367), 1,
      anon_sym_DQUOTE,
    ACTIONS(1377), 1,
      sym__raw_string_literal,
    ACTIONS(1379), 1,
      sym__external_open_parenthesis,
    ACTIONS(1383), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9409), 1,
      anon_sym_BANG,
    ACTIONS(12967), 1,
      sym_dot_dot_i,
    STATE(94), 1,
      sym__open_brace,
    STATE(190), 1,
      sym__open_parenthesis,
    STATE(2231), 1,
      sym_string,
    STATE(2354), 1,
      sym__double_quoted_string,
    STATE(2355), 1,
      sym__single_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5156), 1,
      sym__string_or_identifier,
    ACTIONS(1357), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2356), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1371), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12965), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(985), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [132352] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(273), 1,
      sym_identifier,
    ACTIONS(275), 1,
      anon_sym_BSLASH,
    ACTIONS(277), 1,
      anon_sym_function,
    ACTIONS(279), 1,
      anon_sym_if,
    ACTIONS(281), 1,
      anon_sym_for,
    ACTIONS(283), 1,
      anon_sym_while,
    ACTIONS(285), 1,
      anon_sym_repeat,
    ACTIONS(287), 1,
      anon_sym_QMARK,
    ACTIONS(289), 1,
      anon_sym_TILDE,
    ACTIONS(297), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(299), 1,
      sym__number_literal,
    ACTIONS(301), 1,
      anon_sym_SQUOTE,
    ACTIONS(303), 1,
      anon_sym_DQUOTE,
    ACTIONS(313), 1,
      sym__raw_string_literal,
    ACTIONS(315), 1,
      sym__external_open_parenthesis,
    ACTIONS(319), 1,
      sym__external_open_brace,
    ACTIONS(11159), 1,
      anon_sym_BANG,
    ACTIONS(12971), 1,
      sym_dot_dot_i,
    ACTIONS(12973), 1,
      sym__newline,
    STATE(57), 1,
      sym__open_parenthesis,
    STATE(59), 1,
      sym__open_brace,
    STATE(2187), 1,
      sym__double_quoted_string,
    STATE(2188), 1,
      sym__single_quoted_string,
    STATE(2192), 1,
      sym_string,
    STATE(3865), 1,
      aux_sym_function_definition_repeat1,
    STATE(5139), 1,
      sym__string_or_identifier,
    ACTIONS(293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2189), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(307), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12969), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(742), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [132481] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1337), 1,
      sym_identifier,
    ACTIONS(1339), 1,
      anon_sym_BSLASH,
    ACTIONS(1341), 1,
      anon_sym_function,
    ACTIONS(1343), 1,
      anon_sym_if,
    ACTIONS(1345), 1,
      anon_sym_for,
    ACTIONS(1347), 1,
      anon_sym_while,
    ACTIONS(1349), 1,
      anon_sym_repeat,
    ACTIONS(1351), 1,
      anon_sym_QMARK,
    ACTIONS(1353), 1,
      anon_sym_TILDE,
    ACTIONS(1361), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1363), 1,
      sym__number_literal,
    ACTIONS(1365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1367), 1,
      anon_sym_DQUOTE,
    ACTIONS(1377), 1,
      sym__raw_string_literal,
    ACTIONS(1379), 1,
      sym__external_open_parenthesis,
    ACTIONS(1383), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9409), 1,
      anon_sym_BANG,
    ACTIONS(12977), 1,
      sym_dot_dot_i,
    STATE(94), 1,
      sym__open_brace,
    STATE(190), 1,
      sym__open_parenthesis,
    STATE(2231), 1,
      sym_string,
    STATE(2354), 1,
      sym__double_quoted_string,
    STATE(2355), 1,
      sym__single_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5156), 1,
      sym__string_or_identifier,
    ACTIONS(1357), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2356), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1371), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12975), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(984), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [132610] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(12981), 1,
      sym_dot_dot_i,
    STATE(292), 1,
      sym__open_brace,
    STATE(293), 1,
      sym__open_parenthesis,
    STATE(2562), 1,
      sym_string,
    STATE(2737), 1,
      sym__double_quoted_string,
    STATE(2738), 1,
      sym__single_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5152), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2739), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12979), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2005), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [132739] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(12985), 1,
      sym_dot_dot_i,
    STATE(292), 1,
      sym__open_brace,
    STATE(293), 1,
      sym__open_parenthesis,
    STATE(2562), 1,
      sym_string,
    STATE(2737), 1,
      sym__double_quoted_string,
    STATE(2738), 1,
      sym__single_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5152), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2739), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12983), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1998), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [132868] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(273), 1,
      sym_identifier,
    ACTIONS(275), 1,
      anon_sym_BSLASH,
    ACTIONS(277), 1,
      anon_sym_function,
    ACTIONS(279), 1,
      anon_sym_if,
    ACTIONS(281), 1,
      anon_sym_for,
    ACTIONS(283), 1,
      anon_sym_while,
    ACTIONS(285), 1,
      anon_sym_repeat,
    ACTIONS(287), 1,
      anon_sym_QMARK,
    ACTIONS(289), 1,
      anon_sym_TILDE,
    ACTIONS(297), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(299), 1,
      sym__number_literal,
    ACTIONS(301), 1,
      anon_sym_SQUOTE,
    ACTIONS(303), 1,
      anon_sym_DQUOTE,
    ACTIONS(313), 1,
      sym__raw_string_literal,
    ACTIONS(315), 1,
      sym__external_open_parenthesis,
    ACTIONS(319), 1,
      sym__external_open_brace,
    ACTIONS(11159), 1,
      anon_sym_BANG,
    ACTIONS(12989), 1,
      sym_dot_dot_i,
    ACTIONS(12991), 1,
      sym__newline,
    STATE(57), 1,
      sym__open_parenthesis,
    STATE(59), 1,
      sym__open_brace,
    STATE(2187), 1,
      sym__double_quoted_string,
    STATE(2188), 1,
      sym__single_quoted_string,
    STATE(2192), 1,
      sym_string,
    STATE(3860), 1,
      aux_sym_function_definition_repeat1,
    STATE(5139), 1,
      sym__string_or_identifier,
    ACTIONS(293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2189), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(307), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12987), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(740), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [132997] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1337), 1,
      sym_identifier,
    ACTIONS(1339), 1,
      anon_sym_BSLASH,
    ACTIONS(1341), 1,
      anon_sym_function,
    ACTIONS(1343), 1,
      anon_sym_if,
    ACTIONS(1345), 1,
      anon_sym_for,
    ACTIONS(1347), 1,
      anon_sym_while,
    ACTIONS(1349), 1,
      anon_sym_repeat,
    ACTIONS(1351), 1,
      anon_sym_QMARK,
    ACTIONS(1353), 1,
      anon_sym_TILDE,
    ACTIONS(1361), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1363), 1,
      sym__number_literal,
    ACTIONS(1365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1367), 1,
      anon_sym_DQUOTE,
    ACTIONS(1377), 1,
      sym__raw_string_literal,
    ACTIONS(1379), 1,
      sym__external_open_parenthesis,
    ACTIONS(1383), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9409), 1,
      anon_sym_BANG,
    ACTIONS(12995), 1,
      sym_dot_dot_i,
    STATE(94), 1,
      sym__open_brace,
    STATE(190), 1,
      sym__open_parenthesis,
    STATE(2231), 1,
      sym_string,
    STATE(2354), 1,
      sym__double_quoted_string,
    STATE(2355), 1,
      sym__single_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5156), 1,
      sym__string_or_identifier,
    ACTIONS(1357), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2356), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1371), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12993), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(983), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [133126] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(12999), 1,
      sym_dot_dot_i,
    STATE(292), 1,
      sym__open_brace,
    STATE(293), 1,
      sym__open_parenthesis,
    STATE(2562), 1,
      sym_string,
    STATE(2737), 1,
      sym__double_quoted_string,
    STATE(2738), 1,
      sym__single_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5152), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2739), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(12997), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2085), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [133255] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(273), 1,
      sym_identifier,
    ACTIONS(275), 1,
      anon_sym_BSLASH,
    ACTIONS(277), 1,
      anon_sym_function,
    ACTIONS(279), 1,
      anon_sym_if,
    ACTIONS(281), 1,
      anon_sym_for,
    ACTIONS(283), 1,
      anon_sym_while,
    ACTIONS(285), 1,
      anon_sym_repeat,
    ACTIONS(287), 1,
      anon_sym_QMARK,
    ACTIONS(289), 1,
      anon_sym_TILDE,
    ACTIONS(297), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(299), 1,
      sym__number_literal,
    ACTIONS(301), 1,
      anon_sym_SQUOTE,
    ACTIONS(303), 1,
      anon_sym_DQUOTE,
    ACTIONS(313), 1,
      sym__raw_string_literal,
    ACTIONS(315), 1,
      sym__external_open_parenthesis,
    ACTIONS(319), 1,
      sym__external_open_brace,
    ACTIONS(11159), 1,
      anon_sym_BANG,
    ACTIONS(13003), 1,
      sym_dot_dot_i,
    ACTIONS(13005), 1,
      sym__newline,
    STATE(57), 1,
      sym__open_parenthesis,
    STATE(59), 1,
      sym__open_brace,
    STATE(2187), 1,
      sym__double_quoted_string,
    STATE(2188), 1,
      sym__single_quoted_string,
    STATE(2192), 1,
      sym_string,
    STATE(3859), 1,
      aux_sym_function_definition_repeat1,
    STATE(5139), 1,
      sym__string_or_identifier,
    ACTIONS(293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2189), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(307), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13001), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(738), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [133384] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(13009), 1,
      sym_dot_dot_i,
    STATE(292), 1,
      sym__open_brace,
    STATE(293), 1,
      sym__open_parenthesis,
    STATE(2562), 1,
      sym_string,
    STATE(2737), 1,
      sym__double_quoted_string,
    STATE(2738), 1,
      sym__single_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5152), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2739), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13007), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1958), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [133513] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1337), 1,
      sym_identifier,
    ACTIONS(1339), 1,
      anon_sym_BSLASH,
    ACTIONS(1341), 1,
      anon_sym_function,
    ACTIONS(1343), 1,
      anon_sym_if,
    ACTIONS(1345), 1,
      anon_sym_for,
    ACTIONS(1347), 1,
      anon_sym_while,
    ACTIONS(1349), 1,
      anon_sym_repeat,
    ACTIONS(1351), 1,
      anon_sym_QMARK,
    ACTIONS(1353), 1,
      anon_sym_TILDE,
    ACTIONS(1361), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1363), 1,
      sym__number_literal,
    ACTIONS(1365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1367), 1,
      anon_sym_DQUOTE,
    ACTIONS(1377), 1,
      sym__raw_string_literal,
    ACTIONS(1379), 1,
      sym__external_open_parenthesis,
    ACTIONS(1383), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(9409), 1,
      anon_sym_BANG,
    ACTIONS(13013), 1,
      sym_dot_dot_i,
    STATE(94), 1,
      sym__open_brace,
    STATE(190), 1,
      sym__open_parenthesis,
    STATE(2231), 1,
      sym_string,
    STATE(2354), 1,
      sym__double_quoted_string,
    STATE(2355), 1,
      sym__single_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5156), 1,
      sym__string_or_identifier,
    ACTIONS(1357), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2356), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1371), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13011), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(982), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [133642] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(13017), 1,
      sym_dot_dot_i,
    ACTIONS(13019), 1,
      sym__newline,
    STATE(292), 1,
      sym__open_brace,
    STATE(293), 1,
      sym__open_parenthesis,
    STATE(2562), 1,
      sym_string,
    STATE(2737), 1,
      sym__double_quoted_string,
    STATE(2738), 1,
      sym__single_quoted_string,
    STATE(4060), 1,
      aux_sym_function_definition_repeat1,
    STATE(5152), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2739), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13015), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1980), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [133771] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(273), 1,
      sym_identifier,
    ACTIONS(275), 1,
      anon_sym_BSLASH,
    ACTIONS(277), 1,
      anon_sym_function,
    ACTIONS(279), 1,
      anon_sym_if,
    ACTIONS(281), 1,
      anon_sym_for,
    ACTIONS(283), 1,
      anon_sym_while,
    ACTIONS(285), 1,
      anon_sym_repeat,
    ACTIONS(287), 1,
      anon_sym_QMARK,
    ACTIONS(289), 1,
      anon_sym_TILDE,
    ACTIONS(297), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(299), 1,
      sym__number_literal,
    ACTIONS(301), 1,
      anon_sym_SQUOTE,
    ACTIONS(303), 1,
      anon_sym_DQUOTE,
    ACTIONS(313), 1,
      sym__raw_string_literal,
    ACTIONS(315), 1,
      sym__external_open_parenthesis,
    ACTIONS(319), 1,
      sym__external_open_brace,
    ACTIONS(11159), 1,
      anon_sym_BANG,
    ACTIONS(13023), 1,
      sym_dot_dot_i,
    ACTIONS(13025), 1,
      sym__newline,
    STATE(57), 1,
      sym__open_parenthesis,
    STATE(59), 1,
      sym__open_brace,
    STATE(2187), 1,
      sym__double_quoted_string,
    STATE(2188), 1,
      sym__single_quoted_string,
    STATE(2192), 1,
      sym_string,
    STATE(3809), 1,
      aux_sym_function_definition_repeat1,
    STATE(5139), 1,
      sym__string_or_identifier,
    ACTIONS(293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2189), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(307), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13021), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(736), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [133900] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2826), 1,
      sym_identifier,
    ACTIONS(2828), 1,
      anon_sym_BSLASH,
    ACTIONS(2830), 1,
      anon_sym_function,
    ACTIONS(2832), 1,
      anon_sym_if,
    ACTIONS(2834), 1,
      anon_sym_for,
    ACTIONS(2836), 1,
      anon_sym_while,
    ACTIONS(2838), 1,
      anon_sym_repeat,
    ACTIONS(2840), 1,
      anon_sym_QMARK,
    ACTIONS(2842), 1,
      anon_sym_TILDE,
    ACTIONS(2850), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2852), 1,
      sym__number_literal,
    ACTIONS(2854), 1,
      anon_sym_SQUOTE,
    ACTIONS(2856), 1,
      anon_sym_DQUOTE,
    ACTIONS(2866), 1,
      sym__raw_string_literal,
    ACTIONS(2868), 1,
      sym__external_open_parenthesis,
    ACTIONS(2870), 1,
      sym__external_open_brace,
    ACTIONS(10915), 1,
      anon_sym_BANG,
    ACTIONS(13029), 1,
      sym_dot_dot_i,
    ACTIONS(13031), 1,
      sym__newline,
    STATE(178), 1,
      sym__open_parenthesis,
    STATE(244), 1,
      sym__open_brace,
    STATE(2522), 1,
      sym_string,
    STATE(2528), 1,
      sym__single_quoted_string,
    STATE(2529), 1,
      sym__double_quoted_string,
    STATE(3961), 1,
      aux_sym_function_definition_repeat1,
    STATE(5126), 1,
      sym__string_or_identifier,
    ACTIONS(2846), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2523), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2860), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13027), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1670), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [134029] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(273), 1,
      sym_identifier,
    ACTIONS(275), 1,
      anon_sym_BSLASH,
    ACTIONS(277), 1,
      anon_sym_function,
    ACTIONS(279), 1,
      anon_sym_if,
    ACTIONS(281), 1,
      anon_sym_for,
    ACTIONS(283), 1,
      anon_sym_while,
    ACTIONS(285), 1,
      anon_sym_repeat,
    ACTIONS(287), 1,
      anon_sym_QMARK,
    ACTIONS(289), 1,
      anon_sym_TILDE,
    ACTIONS(297), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(299), 1,
      sym__number_literal,
    ACTIONS(301), 1,
      anon_sym_SQUOTE,
    ACTIONS(303), 1,
      anon_sym_DQUOTE,
    ACTIONS(313), 1,
      sym__raw_string_literal,
    ACTIONS(315), 1,
      sym__external_open_parenthesis,
    ACTIONS(319), 1,
      sym__external_open_brace,
    ACTIONS(11159), 1,
      anon_sym_BANG,
    ACTIONS(13035), 1,
      sym_dot_dot_i,
    ACTIONS(13037), 1,
      sym__newline,
    STATE(57), 1,
      sym__open_parenthesis,
    STATE(59), 1,
      sym__open_brace,
    STATE(2187), 1,
      sym__double_quoted_string,
    STATE(2188), 1,
      sym__single_quoted_string,
    STATE(2192), 1,
      sym_string,
    STATE(3803), 1,
      aux_sym_function_definition_repeat1,
    STATE(5139), 1,
      sym__string_or_identifier,
    ACTIONS(293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2189), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(307), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13033), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(734), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [134158] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(161), 1,
      sym_identifier,
    ACTIONS(163), 1,
      anon_sym_BSLASH,
    ACTIONS(165), 1,
      anon_sym_function,
    ACTIONS(167), 1,
      anon_sym_if,
    ACTIONS(169), 1,
      anon_sym_for,
    ACTIONS(171), 1,
      anon_sym_while,
    ACTIONS(173), 1,
      anon_sym_repeat,
    ACTIONS(175), 1,
      anon_sym_QMARK,
    ACTIONS(177), 1,
      anon_sym_TILDE,
    ACTIONS(185), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(187), 1,
      sym__number_literal,
    ACTIONS(189), 1,
      anon_sym_SQUOTE,
    ACTIONS(191), 1,
      anon_sym_DQUOTE,
    ACTIONS(201), 1,
      sym__raw_string_literal,
    ACTIONS(203), 1,
      sym__external_open_parenthesis,
    ACTIONS(207), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8009), 1,
      anon_sym_BANG,
    ACTIONS(13041), 1,
      sym_dot_dot_i,
    STATE(14), 1,
      sym__open_parenthesis,
    STATE(18), 1,
      sym__open_brace,
    STATE(1923), 1,
      sym__single_quoted_string,
    STATE(1927), 1,
      sym_string,
    STATE(1934), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5137), 1,
      sym__string_or_identifier,
    ACTIONS(181), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1925), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(195), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13039), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(640), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [134287] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(13045), 1,
      sym_dot_dot_i,
    STATE(292), 1,
      sym__open_brace,
    STATE(293), 1,
      sym__open_parenthesis,
    STATE(2562), 1,
      sym_string,
    STATE(2737), 1,
      sym__double_quoted_string,
    STATE(2738), 1,
      sym__single_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5152), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2739), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13043), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1975), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [134416] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(161), 1,
      sym_identifier,
    ACTIONS(163), 1,
      anon_sym_BSLASH,
    ACTIONS(165), 1,
      anon_sym_function,
    ACTIONS(167), 1,
      anon_sym_if,
    ACTIONS(169), 1,
      anon_sym_for,
    ACTIONS(171), 1,
      anon_sym_while,
    ACTIONS(173), 1,
      anon_sym_repeat,
    ACTIONS(175), 1,
      anon_sym_QMARK,
    ACTIONS(177), 1,
      anon_sym_TILDE,
    ACTIONS(185), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(187), 1,
      sym__number_literal,
    ACTIONS(189), 1,
      anon_sym_SQUOTE,
    ACTIONS(191), 1,
      anon_sym_DQUOTE,
    ACTIONS(201), 1,
      sym__raw_string_literal,
    ACTIONS(203), 1,
      sym__external_open_parenthesis,
    ACTIONS(207), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8009), 1,
      anon_sym_BANG,
    ACTIONS(13049), 1,
      sym_dot_dot_i,
    STATE(14), 1,
      sym__open_parenthesis,
    STATE(18), 1,
      sym__open_brace,
    STATE(1923), 1,
      sym__single_quoted_string,
    STATE(1927), 1,
      sym_string,
    STATE(1934), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5137), 1,
      sym__string_or_identifier,
    ACTIONS(181), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1925), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(195), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13047), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(641), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [134545] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4752), 1,
      sym_identifier,
    ACTIONS(4754), 1,
      anon_sym_BSLASH,
    ACTIONS(4756), 1,
      anon_sym_function,
    ACTIONS(4758), 1,
      anon_sym_if,
    ACTIONS(4760), 1,
      anon_sym_for,
    ACTIONS(4762), 1,
      anon_sym_while,
    ACTIONS(4764), 1,
      anon_sym_repeat,
    ACTIONS(4766), 1,
      anon_sym_QMARK,
    ACTIONS(4768), 1,
      anon_sym_TILDE,
    ACTIONS(4776), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4778), 1,
      sym__number_literal,
    ACTIONS(4780), 1,
      anon_sym_SQUOTE,
    ACTIONS(4782), 1,
      anon_sym_DQUOTE,
    ACTIONS(4790), 1,
      sym__raw_string_literal,
    ACTIONS(4792), 1,
      sym__external_open_parenthesis,
    ACTIONS(4794), 1,
      sym__external_open_brace,
    ACTIONS(6353), 1,
      anon_sym_BANG,
    ACTIONS(13053), 1,
      sym_dot_dot_i,
    ACTIONS(13055), 1,
      sym__newline,
    STATE(192), 1,
      sym__open_brace,
    STATE(214), 1,
      sym__open_parenthesis,
    STATE(2664), 1,
      sym_string,
    STATE(2701), 1,
      sym__single_quoted_string,
    STATE(2745), 1,
      sym__double_quoted_string,
    STATE(3972), 1,
      aux_sym_function_definition_repeat1,
    STATE(5148), 1,
      sym__string_or_identifier,
    ACTIONS(4772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2700), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4786), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13051), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1989), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [134674] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(161), 1,
      sym_identifier,
    ACTIONS(163), 1,
      anon_sym_BSLASH,
    ACTIONS(165), 1,
      anon_sym_function,
    ACTIONS(167), 1,
      anon_sym_if,
    ACTIONS(169), 1,
      anon_sym_for,
    ACTIONS(171), 1,
      anon_sym_while,
    ACTIONS(173), 1,
      anon_sym_repeat,
    ACTIONS(175), 1,
      anon_sym_QMARK,
    ACTIONS(177), 1,
      anon_sym_TILDE,
    ACTIONS(185), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(187), 1,
      sym__number_literal,
    ACTIONS(189), 1,
      anon_sym_SQUOTE,
    ACTIONS(191), 1,
      anon_sym_DQUOTE,
    ACTIONS(201), 1,
      sym__raw_string_literal,
    ACTIONS(203), 1,
      sym__external_open_parenthesis,
    ACTIONS(207), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8009), 1,
      anon_sym_BANG,
    ACTIONS(13059), 1,
      sym_dot_dot_i,
    STATE(14), 1,
      sym__open_parenthesis,
    STATE(18), 1,
      sym__open_brace,
    STATE(1923), 1,
      sym__single_quoted_string,
    STATE(1927), 1,
      sym_string,
    STATE(1934), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5137), 1,
      sym__string_or_identifier,
    ACTIONS(181), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1925), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(195), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13057), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(642), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [134803] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(13063), 1,
      sym_dot_dot_i,
    STATE(292), 1,
      sym__open_brace,
    STATE(293), 1,
      sym__open_parenthesis,
    STATE(2562), 1,
      sym_string,
    STATE(2737), 1,
      sym__double_quoted_string,
    STATE(2738), 1,
      sym__single_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5152), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2739), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13061), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1986), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [134932] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(161), 1,
      sym_identifier,
    ACTIONS(163), 1,
      anon_sym_BSLASH,
    ACTIONS(165), 1,
      anon_sym_function,
    ACTIONS(167), 1,
      anon_sym_if,
    ACTIONS(169), 1,
      anon_sym_for,
    ACTIONS(171), 1,
      anon_sym_while,
    ACTIONS(173), 1,
      anon_sym_repeat,
    ACTIONS(175), 1,
      anon_sym_QMARK,
    ACTIONS(177), 1,
      anon_sym_TILDE,
    ACTIONS(185), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(187), 1,
      sym__number_literal,
    ACTIONS(189), 1,
      anon_sym_SQUOTE,
    ACTIONS(191), 1,
      anon_sym_DQUOTE,
    ACTIONS(201), 1,
      sym__raw_string_literal,
    ACTIONS(203), 1,
      sym__external_open_parenthesis,
    ACTIONS(207), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8009), 1,
      anon_sym_BANG,
    ACTIONS(13067), 1,
      sym_dot_dot_i,
    STATE(14), 1,
      sym__open_parenthesis,
    STATE(18), 1,
      sym__open_brace,
    STATE(1923), 1,
      sym__single_quoted_string,
    STATE(1927), 1,
      sym_string,
    STATE(1934), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5137), 1,
      sym__string_or_identifier,
    ACTIONS(181), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1925), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(195), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13065), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(643), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [135061] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4752), 1,
      sym_identifier,
    ACTIONS(4754), 1,
      anon_sym_BSLASH,
    ACTIONS(4756), 1,
      anon_sym_function,
    ACTIONS(4758), 1,
      anon_sym_if,
    ACTIONS(4760), 1,
      anon_sym_for,
    ACTIONS(4762), 1,
      anon_sym_while,
    ACTIONS(4764), 1,
      anon_sym_repeat,
    ACTIONS(4766), 1,
      anon_sym_QMARK,
    ACTIONS(4768), 1,
      anon_sym_TILDE,
    ACTIONS(4776), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4778), 1,
      sym__number_literal,
    ACTIONS(4780), 1,
      anon_sym_SQUOTE,
    ACTIONS(4782), 1,
      anon_sym_DQUOTE,
    ACTIONS(4790), 1,
      sym__raw_string_literal,
    ACTIONS(4792), 1,
      sym__external_open_parenthesis,
    ACTIONS(4794), 1,
      sym__external_open_brace,
    ACTIONS(6353), 1,
      anon_sym_BANG,
    ACTIONS(13071), 1,
      sym_dot_dot_i,
    ACTIONS(13073), 1,
      sym__newline,
    STATE(192), 1,
      sym__open_brace,
    STATE(214), 1,
      sym__open_parenthesis,
    STATE(2664), 1,
      sym_string,
    STATE(2701), 1,
      sym__single_quoted_string,
    STATE(2745), 1,
      sym__double_quoted_string,
    STATE(3973), 1,
      aux_sym_function_definition_repeat1,
    STATE(5148), 1,
      sym__string_or_identifier,
    ACTIONS(4772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2700), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4786), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13069), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1993), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [135190] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(161), 1,
      sym_identifier,
    ACTIONS(163), 1,
      anon_sym_BSLASH,
    ACTIONS(165), 1,
      anon_sym_function,
    ACTIONS(167), 1,
      anon_sym_if,
    ACTIONS(169), 1,
      anon_sym_for,
    ACTIONS(171), 1,
      anon_sym_while,
    ACTIONS(173), 1,
      anon_sym_repeat,
    ACTIONS(175), 1,
      anon_sym_QMARK,
    ACTIONS(177), 1,
      anon_sym_TILDE,
    ACTIONS(185), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(187), 1,
      sym__number_literal,
    ACTIONS(189), 1,
      anon_sym_SQUOTE,
    ACTIONS(191), 1,
      anon_sym_DQUOTE,
    ACTIONS(201), 1,
      sym__raw_string_literal,
    ACTIONS(203), 1,
      sym__external_open_parenthesis,
    ACTIONS(207), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8009), 1,
      anon_sym_BANG,
    ACTIONS(13077), 1,
      sym_dot_dot_i,
    STATE(14), 1,
      sym__open_parenthesis,
    STATE(18), 1,
      sym__open_brace,
    STATE(1923), 1,
      sym__single_quoted_string,
    STATE(1927), 1,
      sym_string,
    STATE(1934), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5137), 1,
      sym__string_or_identifier,
    ACTIONS(181), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1925), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(195), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13075), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(644), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [135319] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(13081), 1,
      sym_dot_dot_i,
    STATE(292), 1,
      sym__open_brace,
    STATE(293), 1,
      sym__open_parenthesis,
    STATE(2562), 1,
      sym_string,
    STATE(2737), 1,
      sym__double_quoted_string,
    STATE(2738), 1,
      sym__single_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5152), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2739), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13079), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1991), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [135448] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(161), 1,
      sym_identifier,
    ACTIONS(163), 1,
      anon_sym_BSLASH,
    ACTIONS(165), 1,
      anon_sym_function,
    ACTIONS(167), 1,
      anon_sym_if,
    ACTIONS(169), 1,
      anon_sym_for,
    ACTIONS(171), 1,
      anon_sym_while,
    ACTIONS(173), 1,
      anon_sym_repeat,
    ACTIONS(175), 1,
      anon_sym_QMARK,
    ACTIONS(177), 1,
      anon_sym_TILDE,
    ACTIONS(185), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(187), 1,
      sym__number_literal,
    ACTIONS(189), 1,
      anon_sym_SQUOTE,
    ACTIONS(191), 1,
      anon_sym_DQUOTE,
    ACTIONS(201), 1,
      sym__raw_string_literal,
    ACTIONS(203), 1,
      sym__external_open_parenthesis,
    ACTIONS(207), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8009), 1,
      anon_sym_BANG,
    ACTIONS(13085), 1,
      sym_dot_dot_i,
    STATE(14), 1,
      sym__open_parenthesis,
    STATE(18), 1,
      sym__open_brace,
    STATE(1923), 1,
      sym__single_quoted_string,
    STATE(1927), 1,
      sym_string,
    STATE(1934), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5137), 1,
      sym__string_or_identifier,
    ACTIONS(181), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1925), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(195), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13083), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(645), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [135577] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4752), 1,
      sym_identifier,
    ACTIONS(4754), 1,
      anon_sym_BSLASH,
    ACTIONS(4756), 1,
      anon_sym_function,
    ACTIONS(4758), 1,
      anon_sym_if,
    ACTIONS(4760), 1,
      anon_sym_for,
    ACTIONS(4762), 1,
      anon_sym_while,
    ACTIONS(4764), 1,
      anon_sym_repeat,
    ACTIONS(4766), 1,
      anon_sym_QMARK,
    ACTIONS(4768), 1,
      anon_sym_TILDE,
    ACTIONS(4776), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4778), 1,
      sym__number_literal,
    ACTIONS(4780), 1,
      anon_sym_SQUOTE,
    ACTIONS(4782), 1,
      anon_sym_DQUOTE,
    ACTIONS(4790), 1,
      sym__raw_string_literal,
    ACTIONS(4792), 1,
      sym__external_open_parenthesis,
    ACTIONS(4794), 1,
      sym__external_open_brace,
    ACTIONS(6353), 1,
      anon_sym_BANG,
    ACTIONS(13089), 1,
      sym_dot_dot_i,
    ACTIONS(13091), 1,
      sym__newline,
    STATE(192), 1,
      sym__open_brace,
    STATE(214), 1,
      sym__open_parenthesis,
    STATE(2664), 1,
      sym_string,
    STATE(2701), 1,
      sym__single_quoted_string,
    STATE(2745), 1,
      sym__double_quoted_string,
    STATE(3974), 1,
      aux_sym_function_definition_repeat1,
    STATE(5148), 1,
      sym__string_or_identifier,
    ACTIONS(4772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2700), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4786), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13087), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1997), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [135706] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(161), 1,
      sym_identifier,
    ACTIONS(163), 1,
      anon_sym_BSLASH,
    ACTIONS(165), 1,
      anon_sym_function,
    ACTIONS(167), 1,
      anon_sym_if,
    ACTIONS(169), 1,
      anon_sym_for,
    ACTIONS(171), 1,
      anon_sym_while,
    ACTIONS(173), 1,
      anon_sym_repeat,
    ACTIONS(175), 1,
      anon_sym_QMARK,
    ACTIONS(177), 1,
      anon_sym_TILDE,
    ACTIONS(185), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(187), 1,
      sym__number_literal,
    ACTIONS(189), 1,
      anon_sym_SQUOTE,
    ACTIONS(191), 1,
      anon_sym_DQUOTE,
    ACTIONS(201), 1,
      sym__raw_string_literal,
    ACTIONS(203), 1,
      sym__external_open_parenthesis,
    ACTIONS(207), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8009), 1,
      anon_sym_BANG,
    ACTIONS(13095), 1,
      sym_dot_dot_i,
    STATE(14), 1,
      sym__open_parenthesis,
    STATE(18), 1,
      sym__open_brace,
    STATE(1923), 1,
      sym__single_quoted_string,
    STATE(1927), 1,
      sym_string,
    STATE(1934), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5137), 1,
      sym__string_or_identifier,
    ACTIONS(181), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1925), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(195), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13093), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(646), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [135835] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(13099), 1,
      sym_dot_dot_i,
    STATE(292), 1,
      sym__open_brace,
    STATE(293), 1,
      sym__open_parenthesis,
    STATE(2562), 1,
      sym_string,
    STATE(2737), 1,
      sym__double_quoted_string,
    STATE(2738), 1,
      sym__single_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5152), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2739), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13097), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1995), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [135964] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(161), 1,
      sym_identifier,
    ACTIONS(163), 1,
      anon_sym_BSLASH,
    ACTIONS(165), 1,
      anon_sym_function,
    ACTIONS(167), 1,
      anon_sym_if,
    ACTIONS(169), 1,
      anon_sym_for,
    ACTIONS(171), 1,
      anon_sym_while,
    ACTIONS(173), 1,
      anon_sym_repeat,
    ACTIONS(175), 1,
      anon_sym_QMARK,
    ACTIONS(177), 1,
      anon_sym_TILDE,
    ACTIONS(185), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(187), 1,
      sym__number_literal,
    ACTIONS(189), 1,
      anon_sym_SQUOTE,
    ACTIONS(191), 1,
      anon_sym_DQUOTE,
    ACTIONS(201), 1,
      sym__raw_string_literal,
    ACTIONS(203), 1,
      sym__external_open_parenthesis,
    ACTIONS(207), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8009), 1,
      anon_sym_BANG,
    ACTIONS(13103), 1,
      sym_dot_dot_i,
    STATE(14), 1,
      sym__open_parenthesis,
    STATE(18), 1,
      sym__open_brace,
    STATE(1923), 1,
      sym__single_quoted_string,
    STATE(1927), 1,
      sym_string,
    STATE(1934), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5137), 1,
      sym__string_or_identifier,
    ACTIONS(181), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1925), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(195), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13101), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(647), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [136093] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4752), 1,
      sym_identifier,
    ACTIONS(4754), 1,
      anon_sym_BSLASH,
    ACTIONS(4756), 1,
      anon_sym_function,
    ACTIONS(4758), 1,
      anon_sym_if,
    ACTIONS(4760), 1,
      anon_sym_for,
    ACTIONS(4762), 1,
      anon_sym_while,
    ACTIONS(4764), 1,
      anon_sym_repeat,
    ACTIONS(4766), 1,
      anon_sym_QMARK,
    ACTIONS(4768), 1,
      anon_sym_TILDE,
    ACTIONS(4776), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4778), 1,
      sym__number_literal,
    ACTIONS(4780), 1,
      anon_sym_SQUOTE,
    ACTIONS(4782), 1,
      anon_sym_DQUOTE,
    ACTIONS(4790), 1,
      sym__raw_string_literal,
    ACTIONS(4792), 1,
      sym__external_open_parenthesis,
    ACTIONS(4794), 1,
      sym__external_open_brace,
    ACTIONS(6353), 1,
      anon_sym_BANG,
    ACTIONS(13107), 1,
      sym_dot_dot_i,
    ACTIONS(13109), 1,
      sym__newline,
    STATE(192), 1,
      sym__open_brace,
    STATE(214), 1,
      sym__open_parenthesis,
    STATE(2664), 1,
      sym_string,
    STATE(2701), 1,
      sym__single_quoted_string,
    STATE(2745), 1,
      sym__double_quoted_string,
    STATE(3975), 1,
      aux_sym_function_definition_repeat1,
    STATE(5148), 1,
      sym__string_or_identifier,
    ACTIONS(4772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2700), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4786), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13105), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2003), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [136222] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(161), 1,
      sym_identifier,
    ACTIONS(163), 1,
      anon_sym_BSLASH,
    ACTIONS(165), 1,
      anon_sym_function,
    ACTIONS(167), 1,
      anon_sym_if,
    ACTIONS(169), 1,
      anon_sym_for,
    ACTIONS(171), 1,
      anon_sym_while,
    ACTIONS(173), 1,
      anon_sym_repeat,
    ACTIONS(175), 1,
      anon_sym_QMARK,
    ACTIONS(177), 1,
      anon_sym_TILDE,
    ACTIONS(185), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(187), 1,
      sym__number_literal,
    ACTIONS(189), 1,
      anon_sym_SQUOTE,
    ACTIONS(191), 1,
      anon_sym_DQUOTE,
    ACTIONS(201), 1,
      sym__raw_string_literal,
    ACTIONS(203), 1,
      sym__external_open_parenthesis,
    ACTIONS(207), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8009), 1,
      anon_sym_BANG,
    ACTIONS(13113), 1,
      sym_dot_dot_i,
    STATE(14), 1,
      sym__open_parenthesis,
    STATE(18), 1,
      sym__open_brace,
    STATE(1923), 1,
      sym__single_quoted_string,
    STATE(1927), 1,
      sym_string,
    STATE(1934), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5137), 1,
      sym__string_or_identifier,
    ACTIONS(181), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1925), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(195), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13111), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(648), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [136351] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(13117), 1,
      sym_dot_dot_i,
    STATE(292), 1,
      sym__open_brace,
    STATE(293), 1,
      sym__open_parenthesis,
    STATE(2562), 1,
      sym_string,
    STATE(2737), 1,
      sym__double_quoted_string,
    STATE(2738), 1,
      sym__single_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5152), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2739), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13115), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2001), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [136480] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(161), 1,
      sym_identifier,
    ACTIONS(163), 1,
      anon_sym_BSLASH,
    ACTIONS(165), 1,
      anon_sym_function,
    ACTIONS(167), 1,
      anon_sym_if,
    ACTIONS(169), 1,
      anon_sym_for,
    ACTIONS(171), 1,
      anon_sym_while,
    ACTIONS(173), 1,
      anon_sym_repeat,
    ACTIONS(175), 1,
      anon_sym_QMARK,
    ACTIONS(177), 1,
      anon_sym_TILDE,
    ACTIONS(185), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(187), 1,
      sym__number_literal,
    ACTIONS(189), 1,
      anon_sym_SQUOTE,
    ACTIONS(191), 1,
      anon_sym_DQUOTE,
    ACTIONS(201), 1,
      sym__raw_string_literal,
    ACTIONS(203), 1,
      sym__external_open_parenthesis,
    ACTIONS(207), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8009), 1,
      anon_sym_BANG,
    ACTIONS(13121), 1,
      sym_dot_dot_i,
    STATE(14), 1,
      sym__open_parenthesis,
    STATE(18), 1,
      sym__open_brace,
    STATE(1923), 1,
      sym__single_quoted_string,
    STATE(1927), 1,
      sym_string,
    STATE(1934), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5137), 1,
      sym__string_or_identifier,
    ACTIONS(181), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1925), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(195), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13119), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(649), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [136609] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4752), 1,
      sym_identifier,
    ACTIONS(4754), 1,
      anon_sym_BSLASH,
    ACTIONS(4756), 1,
      anon_sym_function,
    ACTIONS(4758), 1,
      anon_sym_if,
    ACTIONS(4760), 1,
      anon_sym_for,
    ACTIONS(4762), 1,
      anon_sym_while,
    ACTIONS(4764), 1,
      anon_sym_repeat,
    ACTIONS(4766), 1,
      anon_sym_QMARK,
    ACTIONS(4768), 1,
      anon_sym_TILDE,
    ACTIONS(4776), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4778), 1,
      sym__number_literal,
    ACTIONS(4780), 1,
      anon_sym_SQUOTE,
    ACTIONS(4782), 1,
      anon_sym_DQUOTE,
    ACTIONS(4790), 1,
      sym__raw_string_literal,
    ACTIONS(4792), 1,
      sym__external_open_parenthesis,
    ACTIONS(4794), 1,
      sym__external_open_brace,
    ACTIONS(6353), 1,
      anon_sym_BANG,
    ACTIONS(13125), 1,
      sym_dot_dot_i,
    ACTIONS(13127), 1,
      sym__newline,
    STATE(192), 1,
      sym__open_brace,
    STATE(214), 1,
      sym__open_parenthesis,
    STATE(2664), 1,
      sym_string,
    STATE(2701), 1,
      sym__single_quoted_string,
    STATE(2745), 1,
      sym__double_quoted_string,
    STATE(3976), 1,
      aux_sym_function_definition_repeat1,
    STATE(5148), 1,
      sym__string_or_identifier,
    ACTIONS(4772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2700), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4786), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13123), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2007), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [136738] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(161), 1,
      sym_identifier,
    ACTIONS(163), 1,
      anon_sym_BSLASH,
    ACTIONS(165), 1,
      anon_sym_function,
    ACTIONS(167), 1,
      anon_sym_if,
    ACTIONS(169), 1,
      anon_sym_for,
    ACTIONS(171), 1,
      anon_sym_while,
    ACTIONS(173), 1,
      anon_sym_repeat,
    ACTIONS(175), 1,
      anon_sym_QMARK,
    ACTIONS(177), 1,
      anon_sym_TILDE,
    ACTIONS(185), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(187), 1,
      sym__number_literal,
    ACTIONS(189), 1,
      anon_sym_SQUOTE,
    ACTIONS(191), 1,
      anon_sym_DQUOTE,
    ACTIONS(201), 1,
      sym__raw_string_literal,
    ACTIONS(203), 1,
      sym__external_open_parenthesis,
    ACTIONS(207), 1,
      sym__external_open_brace,
    ACTIONS(7787), 1,
      sym__newline,
    ACTIONS(8009), 1,
      anon_sym_BANG,
    ACTIONS(13131), 1,
      sym_dot_dot_i,
    STATE(14), 1,
      sym__open_parenthesis,
    STATE(18), 1,
      sym__open_brace,
    STATE(1923), 1,
      sym__single_quoted_string,
    STATE(1927), 1,
      sym_string,
    STATE(1934), 1,
      sym__double_quoted_string,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    STATE(5137), 1,
      sym__string_or_identifier,
    ACTIONS(181), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1925), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(195), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13129), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(650), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [136867] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13135), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13133), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4629), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [136990] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(626), 1,
      sym_identifier,
    ACTIONS(628), 1,
      anon_sym_BSLASH,
    ACTIONS(630), 1,
      anon_sym_function,
    ACTIONS(632), 1,
      anon_sym_if,
    ACTIONS(634), 1,
      anon_sym_for,
    ACTIONS(636), 1,
      anon_sym_while,
    ACTIONS(638), 1,
      anon_sym_repeat,
    ACTIONS(640), 1,
      anon_sym_QMARK,
    ACTIONS(642), 1,
      anon_sym_TILDE,
    ACTIONS(650), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(652), 1,
      sym__number_literal,
    ACTIONS(654), 1,
      anon_sym_SQUOTE,
    ACTIONS(656), 1,
      anon_sym_DQUOTE,
    ACTIONS(666), 1,
      sym__raw_string_literal,
    ACTIONS(668), 1,
      sym__external_open_parenthesis,
    ACTIONS(670), 1,
      sym__external_open_brace,
    ACTIONS(7933), 1,
      anon_sym_BANG,
    ACTIONS(13139), 1,
      sym_dot_dot_i,
    STATE(54), 1,
      sym__open_parenthesis,
    STATE(56), 1,
      sym__open_brace,
    STATE(2219), 1,
      sym_string,
    STATE(2221), 1,
      sym__single_quoted_string,
    STATE(2222), 1,
      sym__double_quoted_string,
    STATE(5140), 1,
      sym__string_or_identifier,
    ACTIONS(646), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2220), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(660), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13137), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(767), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [137113] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13143), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13141), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4462), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [137236] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1241), 1,
      sym_identifier,
    ACTIONS(1243), 1,
      anon_sym_BSLASH,
    ACTIONS(1245), 1,
      anon_sym_function,
    ACTIONS(1247), 1,
      anon_sym_if,
    ACTIONS(1249), 1,
      anon_sym_for,
    ACTIONS(1251), 1,
      anon_sym_while,
    ACTIONS(1253), 1,
      anon_sym_repeat,
    ACTIONS(1255), 1,
      anon_sym_QMARK,
    ACTIONS(1257), 1,
      anon_sym_TILDE,
    ACTIONS(1265), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1267), 1,
      sym__number_literal,
    ACTIONS(1269), 1,
      anon_sym_SQUOTE,
    ACTIONS(1271), 1,
      anon_sym_DQUOTE,
    ACTIONS(1281), 1,
      sym__raw_string_literal,
    ACTIONS(1283), 1,
      sym__external_open_parenthesis,
    ACTIONS(1287), 1,
      sym__external_open_brace,
    ACTIONS(8543), 1,
      anon_sym_BANG,
    ACTIONS(13147), 1,
      sym_dot_dot_i,
    STATE(11), 1,
      sym__open_brace,
    STATE(120), 1,
      sym__open_parenthesis,
    STATE(2271), 1,
      sym_string,
    STATE(2273), 1,
      sym__single_quoted_string,
    STATE(2274), 1,
      sym__double_quoted_string,
    STATE(5157), 1,
      sym__string_or_identifier,
    ACTIONS(1261), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2272), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1275), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13145), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1308), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [137359] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13151), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13149), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4470), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [137482] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13155), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13153), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4471), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [137605] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13159), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13157), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4472), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [137728] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13163), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13161), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4473), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [137851] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      sym_identifier,
    ACTIONS(105), 1,
      anon_sym_BSLASH,
    ACTIONS(107), 1,
      anon_sym_function,
    ACTIONS(111), 1,
      anon_sym_if,
    ACTIONS(113), 1,
      anon_sym_for,
    ACTIONS(115), 1,
      anon_sym_while,
    ACTIONS(117), 1,
      anon_sym_repeat,
    ACTIONS(119), 1,
      anon_sym_QMARK,
    ACTIONS(121), 1,
      anon_sym_TILDE,
    ACTIONS(131), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(133), 1,
      sym__number_literal,
    ACTIONS(135), 1,
      anon_sym_SQUOTE,
    ACTIONS(137), 1,
      anon_sym_DQUOTE,
    ACTIONS(147), 1,
      sym__raw_string_literal,
    ACTIONS(149), 1,
      sym__external_open_parenthesis,
    ACTIONS(153), 1,
      sym__external_open_brace,
    ACTIONS(8381), 1,
      anon_sym_BANG,
    ACTIONS(13167), 1,
      sym_dot_dot_i,
    STATE(10), 1,
      sym__open_brace,
    STATE(20), 1,
      sym__open_parenthesis,
    STATE(2016), 1,
      sym_string,
    STATE(2027), 1,
      sym__single_quoted_string,
    STATE(2041), 1,
      sym__double_quoted_string,
    STATE(5131), 1,
      sym__string_or_identifier,
    ACTIONS(125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2021), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(141), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13165), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(613), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [137974] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      sym_identifier,
    ACTIONS(105), 1,
      anon_sym_BSLASH,
    ACTIONS(107), 1,
      anon_sym_function,
    ACTIONS(111), 1,
      anon_sym_if,
    ACTIONS(113), 1,
      anon_sym_for,
    ACTIONS(115), 1,
      anon_sym_while,
    ACTIONS(117), 1,
      anon_sym_repeat,
    ACTIONS(119), 1,
      anon_sym_QMARK,
    ACTIONS(121), 1,
      anon_sym_TILDE,
    ACTIONS(131), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(133), 1,
      sym__number_literal,
    ACTIONS(135), 1,
      anon_sym_SQUOTE,
    ACTIONS(137), 1,
      anon_sym_DQUOTE,
    ACTIONS(147), 1,
      sym__raw_string_literal,
    ACTIONS(149), 1,
      sym__external_open_parenthesis,
    ACTIONS(153), 1,
      sym__external_open_brace,
    ACTIONS(8381), 1,
      anon_sym_BANG,
    ACTIONS(13171), 1,
      sym_dot_dot_i,
    STATE(10), 1,
      sym__open_brace,
    STATE(20), 1,
      sym__open_parenthesis,
    STATE(2016), 1,
      sym_string,
    STATE(2027), 1,
      sym__single_quoted_string,
    STATE(2041), 1,
      sym__double_quoted_string,
    STATE(5131), 1,
      sym__string_or_identifier,
    ACTIONS(125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2021), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(141), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13169), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(610), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [138097] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      sym_identifier,
    ACTIONS(105), 1,
      anon_sym_BSLASH,
    ACTIONS(107), 1,
      anon_sym_function,
    ACTIONS(111), 1,
      anon_sym_if,
    ACTIONS(113), 1,
      anon_sym_for,
    ACTIONS(115), 1,
      anon_sym_while,
    ACTIONS(117), 1,
      anon_sym_repeat,
    ACTIONS(119), 1,
      anon_sym_QMARK,
    ACTIONS(121), 1,
      anon_sym_TILDE,
    ACTIONS(131), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(133), 1,
      sym__number_literal,
    ACTIONS(135), 1,
      anon_sym_SQUOTE,
    ACTIONS(137), 1,
      anon_sym_DQUOTE,
    ACTIONS(147), 1,
      sym__raw_string_literal,
    ACTIONS(149), 1,
      sym__external_open_parenthesis,
    ACTIONS(153), 1,
      sym__external_open_brace,
    ACTIONS(8381), 1,
      anon_sym_BANG,
    ACTIONS(13175), 1,
      sym_dot_dot_i,
    STATE(10), 1,
      sym__open_brace,
    STATE(20), 1,
      sym__open_parenthesis,
    STATE(2016), 1,
      sym_string,
    STATE(2027), 1,
      sym__single_quoted_string,
    STATE(2041), 1,
      sym__double_quoted_string,
    STATE(5131), 1,
      sym__string_or_identifier,
    ACTIONS(125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2021), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(141), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13173), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(609), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [138220] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      sym_identifier,
    ACTIONS(105), 1,
      anon_sym_BSLASH,
    ACTIONS(107), 1,
      anon_sym_function,
    ACTIONS(111), 1,
      anon_sym_if,
    ACTIONS(113), 1,
      anon_sym_for,
    ACTIONS(115), 1,
      anon_sym_while,
    ACTIONS(117), 1,
      anon_sym_repeat,
    ACTIONS(119), 1,
      anon_sym_QMARK,
    ACTIONS(121), 1,
      anon_sym_TILDE,
    ACTIONS(131), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(133), 1,
      sym__number_literal,
    ACTIONS(135), 1,
      anon_sym_SQUOTE,
    ACTIONS(137), 1,
      anon_sym_DQUOTE,
    ACTIONS(147), 1,
      sym__raw_string_literal,
    ACTIONS(149), 1,
      sym__external_open_parenthesis,
    ACTIONS(153), 1,
      sym__external_open_brace,
    ACTIONS(8381), 1,
      anon_sym_BANG,
    ACTIONS(13179), 1,
      sym_dot_dot_i,
    STATE(10), 1,
      sym__open_brace,
    STATE(20), 1,
      sym__open_parenthesis,
    STATE(2016), 1,
      sym_string,
    STATE(2027), 1,
      sym__single_quoted_string,
    STATE(2041), 1,
      sym__double_quoted_string,
    STATE(5131), 1,
      sym__string_or_identifier,
    ACTIONS(125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2021), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(141), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13177), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(606), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [138343] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13183), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13181), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4474), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [138466] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13187), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13185), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4475), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [138589] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13191), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13189), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4476), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [138712] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13195), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13193), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4440), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [138835] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13199), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13197), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4477), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [138958] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13203), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13201), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4481), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [139081] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13207), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13205), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4483), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [139204] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13211), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13209), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4484), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [139327] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4053), 1,
      sym_identifier,
    ACTIONS(4055), 1,
      anon_sym_BSLASH,
    ACTIONS(4057), 1,
      anon_sym_function,
    ACTIONS(4059), 1,
      anon_sym_if,
    ACTIONS(4061), 1,
      anon_sym_for,
    ACTIONS(4063), 1,
      anon_sym_while,
    ACTIONS(4065), 1,
      anon_sym_repeat,
    ACTIONS(4067), 1,
      anon_sym_QMARK,
    ACTIONS(4069), 1,
      anon_sym_TILDE,
    ACTIONS(4077), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4079), 1,
      sym__number_literal,
    ACTIONS(4081), 1,
      anon_sym_SQUOTE,
    ACTIONS(4083), 1,
      anon_sym_DQUOTE,
    ACTIONS(4093), 1,
      sym__raw_string_literal,
    ACTIONS(4095), 1,
      sym__external_open_parenthesis,
    ACTIONS(4097), 1,
      sym__external_open_brace,
    ACTIONS(7821), 1,
      anon_sym_BANG,
    ACTIONS(13215), 1,
      sym_dot_dot_i,
    STATE(133), 1,
      sym__open_brace,
    STATE(150), 1,
      sym__open_parenthesis,
    STATE(2534), 1,
      sym_string,
    STATE(2538), 1,
      sym__single_quoted_string,
    STATE(2539), 1,
      sym__double_quoted_string,
    STATE(5143), 1,
      sym__string_or_identifier,
    ACTIONS(4073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2536), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4087), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13213), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1624), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [139450] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4053), 1,
      sym_identifier,
    ACTIONS(4055), 1,
      anon_sym_BSLASH,
    ACTIONS(4057), 1,
      anon_sym_function,
    ACTIONS(4059), 1,
      anon_sym_if,
    ACTIONS(4061), 1,
      anon_sym_for,
    ACTIONS(4063), 1,
      anon_sym_while,
    ACTIONS(4065), 1,
      anon_sym_repeat,
    ACTIONS(4067), 1,
      anon_sym_QMARK,
    ACTIONS(4069), 1,
      anon_sym_TILDE,
    ACTIONS(4077), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4079), 1,
      sym__number_literal,
    ACTIONS(4081), 1,
      anon_sym_SQUOTE,
    ACTIONS(4083), 1,
      anon_sym_DQUOTE,
    ACTIONS(4093), 1,
      sym__raw_string_literal,
    ACTIONS(4095), 1,
      sym__external_open_parenthesis,
    ACTIONS(4097), 1,
      sym__external_open_brace,
    ACTIONS(7821), 1,
      anon_sym_BANG,
    ACTIONS(13219), 1,
      sym_dot_dot_i,
    STATE(133), 1,
      sym__open_brace,
    STATE(150), 1,
      sym__open_parenthesis,
    STATE(2534), 1,
      sym_string,
    STATE(2538), 1,
      sym__single_quoted_string,
    STATE(2539), 1,
      sym__double_quoted_string,
    STATE(5143), 1,
      sym__string_or_identifier,
    ACTIONS(4073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2536), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4087), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13217), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1655), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [139573] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13223), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13221), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4487), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [139696] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4053), 1,
      sym_identifier,
    ACTIONS(4055), 1,
      anon_sym_BSLASH,
    ACTIONS(4057), 1,
      anon_sym_function,
    ACTIONS(4059), 1,
      anon_sym_if,
    ACTIONS(4061), 1,
      anon_sym_for,
    ACTIONS(4063), 1,
      anon_sym_while,
    ACTIONS(4065), 1,
      anon_sym_repeat,
    ACTIONS(4067), 1,
      anon_sym_QMARK,
    ACTIONS(4069), 1,
      anon_sym_TILDE,
    ACTIONS(4077), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4079), 1,
      sym__number_literal,
    ACTIONS(4081), 1,
      anon_sym_SQUOTE,
    ACTIONS(4083), 1,
      anon_sym_DQUOTE,
    ACTIONS(4093), 1,
      sym__raw_string_literal,
    ACTIONS(4095), 1,
      sym__external_open_parenthesis,
    ACTIONS(4097), 1,
      sym__external_open_brace,
    ACTIONS(7821), 1,
      anon_sym_BANG,
    ACTIONS(13227), 1,
      sym_dot_dot_i,
    STATE(133), 1,
      sym__open_brace,
    STATE(150), 1,
      sym__open_parenthesis,
    STATE(2534), 1,
      sym_string,
    STATE(2538), 1,
      sym__single_quoted_string,
    STATE(2539), 1,
      sym__double_quoted_string,
    STATE(5143), 1,
      sym__string_or_identifier,
    ACTIONS(4073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2536), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4087), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13225), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1656), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [139819] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4053), 1,
      sym_identifier,
    ACTIONS(4055), 1,
      anon_sym_BSLASH,
    ACTIONS(4057), 1,
      anon_sym_function,
    ACTIONS(4059), 1,
      anon_sym_if,
    ACTIONS(4061), 1,
      anon_sym_for,
    ACTIONS(4063), 1,
      anon_sym_while,
    ACTIONS(4065), 1,
      anon_sym_repeat,
    ACTIONS(4067), 1,
      anon_sym_QMARK,
    ACTIONS(4069), 1,
      anon_sym_TILDE,
    ACTIONS(4077), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4079), 1,
      sym__number_literal,
    ACTIONS(4081), 1,
      anon_sym_SQUOTE,
    ACTIONS(4083), 1,
      anon_sym_DQUOTE,
    ACTIONS(4093), 1,
      sym__raw_string_literal,
    ACTIONS(4095), 1,
      sym__external_open_parenthesis,
    ACTIONS(4097), 1,
      sym__external_open_brace,
    ACTIONS(7821), 1,
      anon_sym_BANG,
    ACTIONS(13231), 1,
      sym_dot_dot_i,
    STATE(133), 1,
      sym__open_brace,
    STATE(150), 1,
      sym__open_parenthesis,
    STATE(2534), 1,
      sym_string,
    STATE(2538), 1,
      sym__single_quoted_string,
    STATE(2539), 1,
      sym__double_quoted_string,
    STATE(5143), 1,
      sym__string_or_identifier,
    ACTIONS(4073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2536), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4087), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13229), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1717), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [139942] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13235), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13233), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4437), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [140065] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13239), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13237), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4488), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [140188] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13243), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13241), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4490), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [140311] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13247), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13245), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4491), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [140434] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13251), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13249), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4556), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [140557] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13255), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13253), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4495), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [140680] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13259), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13257), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4496), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [140803] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13263), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13261), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4497), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [140926] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13267), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13265), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4498), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [141049] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13271), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13269), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4436), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [141172] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13275), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13273), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4499), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [141295] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(161), 1,
      sym_identifier,
    ACTIONS(163), 1,
      anon_sym_BSLASH,
    ACTIONS(165), 1,
      anon_sym_function,
    ACTIONS(167), 1,
      anon_sym_if,
    ACTIONS(169), 1,
      anon_sym_for,
    ACTIONS(171), 1,
      anon_sym_while,
    ACTIONS(173), 1,
      anon_sym_repeat,
    ACTIONS(175), 1,
      anon_sym_QMARK,
    ACTIONS(177), 1,
      anon_sym_TILDE,
    ACTIONS(185), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(187), 1,
      sym__number_literal,
    ACTIONS(189), 1,
      anon_sym_SQUOTE,
    ACTIONS(191), 1,
      anon_sym_DQUOTE,
    ACTIONS(201), 1,
      sym__raw_string_literal,
    ACTIONS(203), 1,
      sym__external_open_parenthesis,
    ACTIONS(207), 1,
      sym__external_open_brace,
    ACTIONS(8009), 1,
      anon_sym_BANG,
    ACTIONS(13279), 1,
      sym_dot_dot_i,
    STATE(14), 1,
      sym__open_parenthesis,
    STATE(18), 1,
      sym__open_brace,
    STATE(1923), 1,
      sym__single_quoted_string,
    STATE(1927), 1,
      sym_string,
    STATE(1934), 1,
      sym__double_quoted_string,
    STATE(5137), 1,
      sym__string_or_identifier,
    ACTIONS(181), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1925), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(195), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13277), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(656), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [141418] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13283), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13281), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4443), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [141541] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13287), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13285), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4500), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [141664] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13291), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13289), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4501), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [141787] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13295), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13293), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4502), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [141910] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13299), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13297), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4504), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [142033] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(161), 1,
      sym_identifier,
    ACTIONS(163), 1,
      anon_sym_BSLASH,
    ACTIONS(165), 1,
      anon_sym_function,
    ACTIONS(167), 1,
      anon_sym_if,
    ACTIONS(169), 1,
      anon_sym_for,
    ACTIONS(171), 1,
      anon_sym_while,
    ACTIONS(173), 1,
      anon_sym_repeat,
    ACTIONS(175), 1,
      anon_sym_QMARK,
    ACTIONS(177), 1,
      anon_sym_TILDE,
    ACTIONS(185), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(187), 1,
      sym__number_literal,
    ACTIONS(189), 1,
      anon_sym_SQUOTE,
    ACTIONS(191), 1,
      anon_sym_DQUOTE,
    ACTIONS(201), 1,
      sym__raw_string_literal,
    ACTIONS(203), 1,
      sym__external_open_parenthesis,
    ACTIONS(207), 1,
      sym__external_open_brace,
    ACTIONS(8009), 1,
      anon_sym_BANG,
    ACTIONS(13303), 1,
      sym_dot_dot_i,
    STATE(14), 1,
      sym__open_parenthesis,
    STATE(18), 1,
      sym__open_brace,
    STATE(1923), 1,
      sym__single_quoted_string,
    STATE(1927), 1,
      sym_string,
    STATE(1934), 1,
      sym__double_quoted_string,
    STATE(5137), 1,
      sym__string_or_identifier,
    ACTIONS(181), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1925), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(195), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13301), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(659), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [142156] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(161), 1,
      sym_identifier,
    ACTIONS(163), 1,
      anon_sym_BSLASH,
    ACTIONS(165), 1,
      anon_sym_function,
    ACTIONS(167), 1,
      anon_sym_if,
    ACTIONS(169), 1,
      anon_sym_for,
    ACTIONS(171), 1,
      anon_sym_while,
    ACTIONS(173), 1,
      anon_sym_repeat,
    ACTIONS(175), 1,
      anon_sym_QMARK,
    ACTIONS(177), 1,
      anon_sym_TILDE,
    ACTIONS(185), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(187), 1,
      sym__number_literal,
    ACTIONS(189), 1,
      anon_sym_SQUOTE,
    ACTIONS(191), 1,
      anon_sym_DQUOTE,
    ACTIONS(201), 1,
      sym__raw_string_literal,
    ACTIONS(203), 1,
      sym__external_open_parenthesis,
    ACTIONS(207), 1,
      sym__external_open_brace,
    ACTIONS(8009), 1,
      anon_sym_BANG,
    ACTIONS(13307), 1,
      sym_dot_dot_i,
    STATE(14), 1,
      sym__open_parenthesis,
    STATE(18), 1,
      sym__open_brace,
    STATE(1923), 1,
      sym__single_quoted_string,
    STATE(1927), 1,
      sym_string,
    STATE(1934), 1,
      sym__double_quoted_string,
    STATE(5137), 1,
      sym__string_or_identifier,
    ACTIONS(181), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1925), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(195), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13305), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(660), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [142279] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13311), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13309), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4505), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [142402] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13315), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13313), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4506), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [142525] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1337), 1,
      sym_identifier,
    ACTIONS(1339), 1,
      anon_sym_BSLASH,
    ACTIONS(1341), 1,
      anon_sym_function,
    ACTIONS(1343), 1,
      anon_sym_if,
    ACTIONS(1345), 1,
      anon_sym_for,
    ACTIONS(1347), 1,
      anon_sym_while,
    ACTIONS(1349), 1,
      anon_sym_repeat,
    ACTIONS(1351), 1,
      anon_sym_QMARK,
    ACTIONS(1353), 1,
      anon_sym_TILDE,
    ACTIONS(1361), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1363), 1,
      sym__number_literal,
    ACTIONS(1365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1367), 1,
      anon_sym_DQUOTE,
    ACTIONS(1377), 1,
      sym__raw_string_literal,
    ACTIONS(1379), 1,
      sym__external_open_parenthesis,
    ACTIONS(1383), 1,
      sym__external_open_brace,
    ACTIONS(9409), 1,
      anon_sym_BANG,
    ACTIONS(13319), 1,
      sym_dot_dot_i,
    STATE(94), 1,
      sym__open_brace,
    STATE(190), 1,
      sym__open_parenthesis,
    STATE(2231), 1,
      sym_string,
    STATE(2354), 1,
      sym__double_quoted_string,
    STATE(2355), 1,
      sym__single_quoted_string,
    STATE(5156), 1,
      sym__string_or_identifier,
    ACTIONS(1357), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2356), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1371), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13317), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1024), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [142648] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(626), 1,
      sym_identifier,
    ACTIONS(628), 1,
      anon_sym_BSLASH,
    ACTIONS(630), 1,
      anon_sym_function,
    ACTIONS(632), 1,
      anon_sym_if,
    ACTIONS(634), 1,
      anon_sym_for,
    ACTIONS(636), 1,
      anon_sym_while,
    ACTIONS(638), 1,
      anon_sym_repeat,
    ACTIONS(640), 1,
      anon_sym_QMARK,
    ACTIONS(642), 1,
      anon_sym_TILDE,
    ACTIONS(650), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(652), 1,
      sym__number_literal,
    ACTIONS(654), 1,
      anon_sym_SQUOTE,
    ACTIONS(656), 1,
      anon_sym_DQUOTE,
    ACTIONS(666), 1,
      sym__raw_string_literal,
    ACTIONS(668), 1,
      sym__external_open_parenthesis,
    ACTIONS(670), 1,
      sym__external_open_brace,
    ACTIONS(7933), 1,
      anon_sym_BANG,
    ACTIONS(13323), 1,
      sym_dot_dot_i,
    STATE(54), 1,
      sym__open_parenthesis,
    STATE(56), 1,
      sym__open_brace,
    STATE(2219), 1,
      sym_string,
    STATE(2221), 1,
      sym__single_quoted_string,
    STATE(2222), 1,
      sym__double_quoted_string,
    STATE(5140), 1,
      sym__string_or_identifier,
    ACTIONS(646), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2220), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(660), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13321), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(764), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [142771] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1337), 1,
      sym_identifier,
    ACTIONS(1339), 1,
      anon_sym_BSLASH,
    ACTIONS(1341), 1,
      anon_sym_function,
    ACTIONS(1343), 1,
      anon_sym_if,
    ACTIONS(1345), 1,
      anon_sym_for,
    ACTIONS(1347), 1,
      anon_sym_while,
    ACTIONS(1349), 1,
      anon_sym_repeat,
    ACTIONS(1351), 1,
      anon_sym_QMARK,
    ACTIONS(1353), 1,
      anon_sym_TILDE,
    ACTIONS(1361), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1363), 1,
      sym__number_literal,
    ACTIONS(1365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1367), 1,
      anon_sym_DQUOTE,
    ACTIONS(1377), 1,
      sym__raw_string_literal,
    ACTIONS(1379), 1,
      sym__external_open_parenthesis,
    ACTIONS(1383), 1,
      sym__external_open_brace,
    ACTIONS(9409), 1,
      anon_sym_BANG,
    ACTIONS(13327), 1,
      sym_dot_dot_i,
    STATE(94), 1,
      sym__open_brace,
    STATE(190), 1,
      sym__open_parenthesis,
    STATE(2231), 1,
      sym_string,
    STATE(2354), 1,
      sym__double_quoted_string,
    STATE(2355), 1,
      sym__single_quoted_string,
    STATE(5156), 1,
      sym__string_or_identifier,
    ACTIONS(1357), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2356), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1371), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13325), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1027), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [142894] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(626), 1,
      sym_identifier,
    ACTIONS(628), 1,
      anon_sym_BSLASH,
    ACTIONS(630), 1,
      anon_sym_function,
    ACTIONS(632), 1,
      anon_sym_if,
    ACTIONS(634), 1,
      anon_sym_for,
    ACTIONS(636), 1,
      anon_sym_while,
    ACTIONS(638), 1,
      anon_sym_repeat,
    ACTIONS(640), 1,
      anon_sym_QMARK,
    ACTIONS(642), 1,
      anon_sym_TILDE,
    ACTIONS(650), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(652), 1,
      sym__number_literal,
    ACTIONS(654), 1,
      anon_sym_SQUOTE,
    ACTIONS(656), 1,
      anon_sym_DQUOTE,
    ACTIONS(666), 1,
      sym__raw_string_literal,
    ACTIONS(668), 1,
      sym__external_open_parenthesis,
    ACTIONS(670), 1,
      sym__external_open_brace,
    ACTIONS(7933), 1,
      anon_sym_BANG,
    ACTIONS(13331), 1,
      sym_dot_dot_i,
    STATE(54), 1,
      sym__open_parenthesis,
    STATE(56), 1,
      sym__open_brace,
    STATE(2219), 1,
      sym_string,
    STATE(2221), 1,
      sym__single_quoted_string,
    STATE(2222), 1,
      sym__double_quoted_string,
    STATE(5140), 1,
      sym__string_or_identifier,
    ACTIONS(646), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2220), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(660), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13329), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(763), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [143017] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(161), 1,
      sym_identifier,
    ACTIONS(163), 1,
      anon_sym_BSLASH,
    ACTIONS(165), 1,
      anon_sym_function,
    ACTIONS(167), 1,
      anon_sym_if,
    ACTIONS(169), 1,
      anon_sym_for,
    ACTIONS(171), 1,
      anon_sym_while,
    ACTIONS(173), 1,
      anon_sym_repeat,
    ACTIONS(175), 1,
      anon_sym_QMARK,
    ACTIONS(177), 1,
      anon_sym_TILDE,
    ACTIONS(185), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(187), 1,
      sym__number_literal,
    ACTIONS(189), 1,
      anon_sym_SQUOTE,
    ACTIONS(191), 1,
      anon_sym_DQUOTE,
    ACTIONS(201), 1,
      sym__raw_string_literal,
    ACTIONS(203), 1,
      sym__external_open_parenthesis,
    ACTIONS(207), 1,
      sym__external_open_brace,
    ACTIONS(8009), 1,
      anon_sym_BANG,
    ACTIONS(13335), 1,
      sym_dot_dot_i,
    STATE(14), 1,
      sym__open_parenthesis,
    STATE(18), 1,
      sym__open_brace,
    STATE(1923), 1,
      sym__single_quoted_string,
    STATE(1927), 1,
      sym_string,
    STATE(1934), 1,
      sym__double_quoted_string,
    STATE(5137), 1,
      sym__string_or_identifier,
    ACTIONS(181), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1925), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(195), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13333), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(663), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [143140] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3491), 1,
      sym_identifier,
    ACTIONS(3493), 1,
      anon_sym_BSLASH,
    ACTIONS(3495), 1,
      anon_sym_function,
    ACTIONS(3497), 1,
      anon_sym_if,
    ACTIONS(3499), 1,
      anon_sym_for,
    ACTIONS(3501), 1,
      anon_sym_while,
    ACTIONS(3503), 1,
      anon_sym_repeat,
    ACTIONS(3505), 1,
      anon_sym_QMARK,
    ACTIONS(3507), 1,
      anon_sym_TILDE,
    ACTIONS(3515), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3517), 1,
      sym__number_literal,
    ACTIONS(3519), 1,
      anon_sym_SQUOTE,
    ACTIONS(3521), 1,
      anon_sym_DQUOTE,
    ACTIONS(3531), 1,
      sym__raw_string_literal,
    ACTIONS(3533), 1,
      sym__external_open_parenthesis,
    ACTIONS(3535), 1,
      sym__external_open_brace,
    ACTIONS(7789), 1,
      anon_sym_BANG,
    ACTIONS(13339), 1,
      sym_dot_dot_i,
    STATE(63), 1,
      sym__open_brace,
    STATE(147), 1,
      sym__open_parenthesis,
    STATE(2441), 1,
      sym_string,
    STATE(2456), 1,
      sym__single_quoted_string,
    STATE(2478), 1,
      sym__double_quoted_string,
    STATE(5130), 1,
      sym__string_or_identifier,
    ACTIONS(3511), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2448), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3525), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13337), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1554), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [143263] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4752), 1,
      sym_identifier,
    ACTIONS(4754), 1,
      anon_sym_BSLASH,
    ACTIONS(4756), 1,
      anon_sym_function,
    ACTIONS(4758), 1,
      anon_sym_if,
    ACTIONS(4760), 1,
      anon_sym_for,
    ACTIONS(4762), 1,
      anon_sym_while,
    ACTIONS(4764), 1,
      anon_sym_repeat,
    ACTIONS(4766), 1,
      anon_sym_QMARK,
    ACTIONS(4768), 1,
      anon_sym_TILDE,
    ACTIONS(4776), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4778), 1,
      sym__number_literal,
    ACTIONS(4780), 1,
      anon_sym_SQUOTE,
    ACTIONS(4782), 1,
      anon_sym_DQUOTE,
    ACTIONS(4790), 1,
      sym__raw_string_literal,
    ACTIONS(4792), 1,
      sym__external_open_parenthesis,
    ACTIONS(4794), 1,
      sym__external_open_brace,
    ACTIONS(6353), 1,
      anon_sym_BANG,
    ACTIONS(13343), 1,
      sym_dot_dot_i,
    STATE(192), 1,
      sym__open_brace,
    STATE(214), 1,
      sym__open_parenthesis,
    STATE(2664), 1,
      sym_string,
    STATE(2701), 1,
      sym__single_quoted_string,
    STATE(2745), 1,
      sym__double_quoted_string,
    STATE(5148), 1,
      sym__string_or_identifier,
    ACTIONS(4772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2700), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4786), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13341), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2051), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [143386] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13347), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13345), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4507), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [143509] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(626), 1,
      sym_identifier,
    ACTIONS(628), 1,
      anon_sym_BSLASH,
    ACTIONS(630), 1,
      anon_sym_function,
    ACTIONS(632), 1,
      anon_sym_if,
    ACTIONS(634), 1,
      anon_sym_for,
    ACTIONS(636), 1,
      anon_sym_while,
    ACTIONS(638), 1,
      anon_sym_repeat,
    ACTIONS(640), 1,
      anon_sym_QMARK,
    ACTIONS(642), 1,
      anon_sym_TILDE,
    ACTIONS(650), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(652), 1,
      sym__number_literal,
    ACTIONS(654), 1,
      anon_sym_SQUOTE,
    ACTIONS(656), 1,
      anon_sym_DQUOTE,
    ACTIONS(666), 1,
      sym__raw_string_literal,
    ACTIONS(668), 1,
      sym__external_open_parenthesis,
    ACTIONS(670), 1,
      sym__external_open_brace,
    ACTIONS(7933), 1,
      anon_sym_BANG,
    ACTIONS(13351), 1,
      sym_dot_dot_i,
    STATE(54), 1,
      sym__open_parenthesis,
    STATE(56), 1,
      sym__open_brace,
    STATE(2219), 1,
      sym_string,
    STATE(2221), 1,
      sym__single_quoted_string,
    STATE(2222), 1,
      sym__double_quoted_string,
    STATE(5140), 1,
      sym__string_or_identifier,
    ACTIONS(646), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2220), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(660), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13349), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(760), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [143632] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(13355), 1,
      sym_dot_dot_i,
    STATE(292), 1,
      sym__open_brace,
    STATE(293), 1,
      sym__open_parenthesis,
    STATE(2562), 1,
      sym_string,
    STATE(2737), 1,
      sym__double_quoted_string,
    STATE(2738), 1,
      sym__single_quoted_string,
    STATE(5152), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2739), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13353), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2011), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [143755] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4752), 1,
      sym_identifier,
    ACTIONS(4754), 1,
      anon_sym_BSLASH,
    ACTIONS(4756), 1,
      anon_sym_function,
    ACTIONS(4758), 1,
      anon_sym_if,
    ACTIONS(4760), 1,
      anon_sym_for,
    ACTIONS(4762), 1,
      anon_sym_while,
    ACTIONS(4764), 1,
      anon_sym_repeat,
    ACTIONS(4766), 1,
      anon_sym_QMARK,
    ACTIONS(4768), 1,
      anon_sym_TILDE,
    ACTIONS(4776), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4778), 1,
      sym__number_literal,
    ACTIONS(4780), 1,
      anon_sym_SQUOTE,
    ACTIONS(4782), 1,
      anon_sym_DQUOTE,
    ACTIONS(4790), 1,
      sym__raw_string_literal,
    ACTIONS(4792), 1,
      sym__external_open_parenthesis,
    ACTIONS(4794), 1,
      sym__external_open_brace,
    ACTIONS(6353), 1,
      anon_sym_BANG,
    ACTIONS(13359), 1,
      sym_dot_dot_i,
    STATE(192), 1,
      sym__open_brace,
    STATE(214), 1,
      sym__open_parenthesis,
    STATE(2664), 1,
      sym_string,
    STATE(2701), 1,
      sym__single_quoted_string,
    STATE(2745), 1,
      sym__double_quoted_string,
    STATE(5148), 1,
      sym__string_or_identifier,
    ACTIONS(4772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2700), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4786), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13357), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2024), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [143878] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13363), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13361), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4511), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [144001] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13367), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13365), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4512), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [144124] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13371), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13369), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4513), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [144247] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13375), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13373), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4515), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [144370] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13379), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13377), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4516), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [144493] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13383), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13381), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4520), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [144616] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4752), 1,
      sym_identifier,
    ACTIONS(4754), 1,
      anon_sym_BSLASH,
    ACTIONS(4756), 1,
      anon_sym_function,
    ACTIONS(4758), 1,
      anon_sym_if,
    ACTIONS(4760), 1,
      anon_sym_for,
    ACTIONS(4762), 1,
      anon_sym_while,
    ACTIONS(4764), 1,
      anon_sym_repeat,
    ACTIONS(4766), 1,
      anon_sym_QMARK,
    ACTIONS(4768), 1,
      anon_sym_TILDE,
    ACTIONS(4776), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4778), 1,
      sym__number_literal,
    ACTIONS(4780), 1,
      anon_sym_SQUOTE,
    ACTIONS(4782), 1,
      anon_sym_DQUOTE,
    ACTIONS(4790), 1,
      sym__raw_string_literal,
    ACTIONS(4792), 1,
      sym__external_open_parenthesis,
    ACTIONS(4794), 1,
      sym__external_open_brace,
    ACTIONS(6353), 1,
      anon_sym_BANG,
    ACTIONS(13387), 1,
      sym_dot_dot_i,
    STATE(192), 1,
      sym__open_brace,
    STATE(214), 1,
      sym__open_parenthesis,
    STATE(2664), 1,
      sym_string,
    STATE(2701), 1,
      sym__single_quoted_string,
    STATE(2745), 1,
      sym__double_quoted_string,
    STATE(5148), 1,
      sym__string_or_identifier,
    ACTIONS(4772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2700), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4786), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13385), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2022), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [144739] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13391), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13389), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4521), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [144862] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13395), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13393), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4610), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [144985] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13399), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13397), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4522), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [145108] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13403), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13401), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4523), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [145231] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13407), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13405), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4524), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [145354] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13411), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13409), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4526), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [145477] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4752), 1,
      sym_identifier,
    ACTIONS(4754), 1,
      anon_sym_BSLASH,
    ACTIONS(4756), 1,
      anon_sym_function,
    ACTIONS(4758), 1,
      anon_sym_if,
    ACTIONS(4760), 1,
      anon_sym_for,
    ACTIONS(4762), 1,
      anon_sym_while,
    ACTIONS(4764), 1,
      anon_sym_repeat,
    ACTIONS(4766), 1,
      anon_sym_QMARK,
    ACTIONS(4768), 1,
      anon_sym_TILDE,
    ACTIONS(4776), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4778), 1,
      sym__number_literal,
    ACTIONS(4780), 1,
      anon_sym_SQUOTE,
    ACTIONS(4782), 1,
      anon_sym_DQUOTE,
    ACTIONS(4790), 1,
      sym__raw_string_literal,
    ACTIONS(4792), 1,
      sym__external_open_parenthesis,
    ACTIONS(4794), 1,
      sym__external_open_brace,
    ACTIONS(6353), 1,
      anon_sym_BANG,
    ACTIONS(13415), 1,
      sym_dot_dot_i,
    STATE(192), 1,
      sym__open_brace,
    STATE(214), 1,
      sym__open_parenthesis,
    STATE(2664), 1,
      sym_string,
    STATE(2701), 1,
      sym__single_quoted_string,
    STATE(2745), 1,
      sym__double_quoted_string,
    STATE(5148), 1,
      sym__string_or_identifier,
    ACTIONS(4772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2700), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4786), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13413), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2014), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [145600] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13419), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13417), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4622), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [145723] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13423), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13421), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4527), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [145846] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13427), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13425), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4638), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [145969] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13431), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13429), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4528), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [146092] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(13435), 1,
      sym_dot_dot_i,
    STATE(292), 1,
      sym__open_brace,
    STATE(293), 1,
      sym__open_parenthesis,
    STATE(2562), 1,
      sym_string,
    STATE(2737), 1,
      sym__double_quoted_string,
    STATE(2738), 1,
      sym__single_quoted_string,
    STATE(5152), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2739), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13433), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1965), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [146215] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(405), 1,
      sym_identifier,
    ACTIONS(407), 1,
      anon_sym_BSLASH,
    ACTIONS(409), 1,
      anon_sym_function,
    ACTIONS(411), 1,
      anon_sym_if,
    ACTIONS(413), 1,
      anon_sym_for,
    ACTIONS(415), 1,
      anon_sym_while,
    ACTIONS(417), 1,
      anon_sym_repeat,
    ACTIONS(419), 1,
      anon_sym_QMARK,
    ACTIONS(421), 1,
      anon_sym_TILDE,
    ACTIONS(429), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(431), 1,
      sym__number_literal,
    ACTIONS(433), 1,
      anon_sym_SQUOTE,
    ACTIONS(435), 1,
      anon_sym_DQUOTE,
    ACTIONS(445), 1,
      sym__raw_string_literal,
    ACTIONS(447), 1,
      sym__external_open_parenthesis,
    ACTIONS(449), 1,
      sym__external_open_brace,
    ACTIONS(8403), 1,
      anon_sym_BANG,
    ACTIONS(13439), 1,
      sym_dot_dot_i,
    STATE(5), 1,
      sym__open_parenthesis,
    STATE(42), 1,
      sym__open_brace,
    STATE(2209), 1,
      sym_string,
    STATE(2211), 1,
      sym__single_quoted_string,
    STATE(2212), 1,
      sym__double_quoted_string,
    STATE(5127), 1,
      sym__string_or_identifier,
    ACTIONS(425), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2210), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(439), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13437), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(952), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [146338] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13443), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13441), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4635), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [146461] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1337), 1,
      sym_identifier,
    ACTIONS(1339), 1,
      anon_sym_BSLASH,
    ACTIONS(1341), 1,
      anon_sym_function,
    ACTIONS(1343), 1,
      anon_sym_if,
    ACTIONS(1345), 1,
      anon_sym_for,
    ACTIONS(1347), 1,
      anon_sym_while,
    ACTIONS(1349), 1,
      anon_sym_repeat,
    ACTIONS(1351), 1,
      anon_sym_QMARK,
    ACTIONS(1353), 1,
      anon_sym_TILDE,
    ACTIONS(1361), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1363), 1,
      sym__number_literal,
    ACTIONS(1365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1367), 1,
      anon_sym_DQUOTE,
    ACTIONS(1377), 1,
      sym__raw_string_literal,
    ACTIONS(1379), 1,
      sym__external_open_parenthesis,
    ACTIONS(1383), 1,
      sym__external_open_brace,
    ACTIONS(9409), 1,
      anon_sym_BANG,
    ACTIONS(13447), 1,
      sym_dot_dot_i,
    STATE(94), 1,
      sym__open_brace,
    STATE(190), 1,
      sym__open_parenthesis,
    STATE(2231), 1,
      sym_string,
    STATE(2354), 1,
      sym__double_quoted_string,
    STATE(2355), 1,
      sym__single_quoted_string,
    STATE(5156), 1,
      sym__string_or_identifier,
    ACTIONS(1357), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2356), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1371), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13445), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1032), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [146584] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(13451), 1,
      sym_dot_dot_i,
    STATE(292), 1,
      sym__open_brace,
    STATE(293), 1,
      sym__open_parenthesis,
    STATE(2562), 1,
      sym_string,
    STATE(2737), 1,
      sym__double_quoted_string,
    STATE(2738), 1,
      sym__single_quoted_string,
    STATE(5152), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2739), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13449), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1962), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [146707] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(405), 1,
      sym_identifier,
    ACTIONS(407), 1,
      anon_sym_BSLASH,
    ACTIONS(409), 1,
      anon_sym_function,
    ACTIONS(411), 1,
      anon_sym_if,
    ACTIONS(413), 1,
      anon_sym_for,
    ACTIONS(415), 1,
      anon_sym_while,
    ACTIONS(417), 1,
      anon_sym_repeat,
    ACTIONS(419), 1,
      anon_sym_QMARK,
    ACTIONS(421), 1,
      anon_sym_TILDE,
    ACTIONS(429), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(431), 1,
      sym__number_literal,
    ACTIONS(433), 1,
      anon_sym_SQUOTE,
    ACTIONS(435), 1,
      anon_sym_DQUOTE,
    ACTIONS(445), 1,
      sym__raw_string_literal,
    ACTIONS(447), 1,
      sym__external_open_parenthesis,
    ACTIONS(449), 1,
      sym__external_open_brace,
    ACTIONS(8403), 1,
      anon_sym_BANG,
    ACTIONS(13455), 1,
      sym_dot_dot_i,
    STATE(5), 1,
      sym__open_parenthesis,
    STATE(42), 1,
      sym__open_brace,
    STATE(2209), 1,
      sym_string,
    STATE(2211), 1,
      sym__single_quoted_string,
    STATE(2212), 1,
      sym__double_quoted_string,
    STATE(5127), 1,
      sym__string_or_identifier,
    ACTIONS(425), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2210), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(439), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13453), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(955), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [146830] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(405), 1,
      sym_identifier,
    ACTIONS(407), 1,
      anon_sym_BSLASH,
    ACTIONS(409), 1,
      anon_sym_function,
    ACTIONS(411), 1,
      anon_sym_if,
    ACTIONS(413), 1,
      anon_sym_for,
    ACTIONS(415), 1,
      anon_sym_while,
    ACTIONS(417), 1,
      anon_sym_repeat,
    ACTIONS(419), 1,
      anon_sym_QMARK,
    ACTIONS(421), 1,
      anon_sym_TILDE,
    ACTIONS(429), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(431), 1,
      sym__number_literal,
    ACTIONS(433), 1,
      anon_sym_SQUOTE,
    ACTIONS(435), 1,
      anon_sym_DQUOTE,
    ACTIONS(445), 1,
      sym__raw_string_literal,
    ACTIONS(447), 1,
      sym__external_open_parenthesis,
    ACTIONS(449), 1,
      sym__external_open_brace,
    ACTIONS(8403), 1,
      anon_sym_BANG,
    ACTIONS(13459), 1,
      sym_dot_dot_i,
    STATE(5), 1,
      sym__open_parenthesis,
    STATE(42), 1,
      sym__open_brace,
    STATE(2209), 1,
      sym_string,
    STATE(2211), 1,
      sym__single_quoted_string,
    STATE(2212), 1,
      sym__double_quoted_string,
    STATE(5127), 1,
      sym__string_or_identifier,
    ACTIONS(425), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2210), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(439), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13457), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(956), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [146953] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13463), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13461), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4529), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [147076] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13467), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13465), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4530), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [147199] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13471), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13469), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4532), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [147322] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(405), 1,
      sym_identifier,
    ACTIONS(407), 1,
      anon_sym_BSLASH,
    ACTIONS(409), 1,
      anon_sym_function,
    ACTIONS(411), 1,
      anon_sym_if,
    ACTIONS(413), 1,
      anon_sym_for,
    ACTIONS(415), 1,
      anon_sym_while,
    ACTIONS(417), 1,
      anon_sym_repeat,
    ACTIONS(419), 1,
      anon_sym_QMARK,
    ACTIONS(421), 1,
      anon_sym_TILDE,
    ACTIONS(429), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(431), 1,
      sym__number_literal,
    ACTIONS(433), 1,
      anon_sym_SQUOTE,
    ACTIONS(435), 1,
      anon_sym_DQUOTE,
    ACTIONS(445), 1,
      sym__raw_string_literal,
    ACTIONS(447), 1,
      sym__external_open_parenthesis,
    ACTIONS(449), 1,
      sym__external_open_brace,
    ACTIONS(8403), 1,
      anon_sym_BANG,
    ACTIONS(13475), 1,
      sym_dot_dot_i,
    STATE(5), 1,
      sym__open_parenthesis,
    STATE(42), 1,
      sym__open_brace,
    STATE(2209), 1,
      sym_string,
    STATE(2211), 1,
      sym__single_quoted_string,
    STATE(2212), 1,
      sym__double_quoted_string,
    STATE(5127), 1,
      sym__string_or_identifier,
    ACTIONS(425), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2210), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(439), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13473), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(959), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [147445] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13479), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13477), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4533), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [147568] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13483), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13481), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4534), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [147691] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13487), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13485), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4535), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [147814] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13491), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13489), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4536), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [147937] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13495), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13493), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4537), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [148060] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3845), 1,
      sym_identifier,
    ACTIONS(3847), 1,
      anon_sym_BSLASH,
    ACTIONS(3849), 1,
      anon_sym_function,
    ACTIONS(3851), 1,
      anon_sym_if,
    ACTIONS(3853), 1,
      anon_sym_for,
    ACTIONS(3855), 1,
      anon_sym_while,
    ACTIONS(3857), 1,
      anon_sym_repeat,
    ACTIONS(3859), 1,
      anon_sym_QMARK,
    ACTIONS(3861), 1,
      anon_sym_TILDE,
    ACTIONS(3869), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3871), 1,
      sym__number_literal,
    ACTIONS(3873), 1,
      anon_sym_SQUOTE,
    ACTIONS(3875), 1,
      anon_sym_DQUOTE,
    ACTIONS(3885), 1,
      sym__raw_string_literal,
    ACTIONS(3887), 1,
      sym__external_open_parenthesis,
    ACTIONS(3891), 1,
      sym__external_open_brace,
    ACTIONS(6389), 1,
      anon_sym_BANG,
    ACTIONS(13499), 1,
      sym_dot_dot_i,
    STATE(154), 1,
      sym__open_brace,
    STATE(350), 1,
      sym__open_parenthesis,
    STATE(2620), 1,
      sym__double_quoted_string,
    STATE(2673), 1,
      sym_string,
    STATE(2735), 1,
      sym__single_quoted_string,
    STATE(5135), 1,
      sym__string_or_identifier,
    ACTIONS(3865), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2578), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3879), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13497), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2134), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [148183] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13503), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13501), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4538), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [148306] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13507), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13505), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4541), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [148429] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13511), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13509), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4546), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [148552] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1568), 1,
      sym_identifier,
    ACTIONS(1570), 1,
      anon_sym_BSLASH,
    ACTIONS(1572), 1,
      anon_sym_function,
    ACTIONS(1574), 1,
      anon_sym_if,
    ACTIONS(1576), 1,
      anon_sym_for,
    ACTIONS(1578), 1,
      anon_sym_while,
    ACTIONS(1580), 1,
      anon_sym_repeat,
    ACTIONS(1582), 1,
      anon_sym_QMARK,
    ACTIONS(1584), 1,
      anon_sym_TILDE,
    ACTIONS(1592), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1594), 1,
      sym__number_literal,
    ACTIONS(1596), 1,
      anon_sym_SQUOTE,
    ACTIONS(1598), 1,
      anon_sym_DQUOTE,
    ACTIONS(1608), 1,
      sym__raw_string_literal,
    ACTIONS(1610), 1,
      sym__external_open_parenthesis,
    ACTIONS(1614), 1,
      sym__external_open_brace,
    ACTIONS(8477), 1,
      anon_sym_BANG,
    ACTIONS(13515), 1,
      sym_dot_dot_i,
    STATE(16), 1,
      sym__open_brace,
    STATE(119), 1,
      sym__open_parenthesis,
    STATE(2287), 1,
      sym_string,
    STATE(2289), 1,
      sym__single_quoted_string,
    STATE(2290), 1,
      sym__double_quoted_string,
    STATE(5144), 1,
      sym__string_or_identifier,
    ACTIONS(1588), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2288), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1602), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13513), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1141), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [148675] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2425), 1,
      sym_identifier,
    ACTIONS(2427), 1,
      anon_sym_BSLASH,
    ACTIONS(2429), 1,
      anon_sym_function,
    ACTIONS(2431), 1,
      anon_sym_if,
    ACTIONS(2433), 1,
      anon_sym_for,
    ACTIONS(2435), 1,
      anon_sym_while,
    ACTIONS(2437), 1,
      anon_sym_repeat,
    ACTIONS(2439), 1,
      anon_sym_QMARK,
    ACTIONS(2441), 1,
      anon_sym_TILDE,
    ACTIONS(2449), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2451), 1,
      sym__number_literal,
    ACTIONS(2453), 1,
      anon_sym_SQUOTE,
    ACTIONS(2455), 1,
      anon_sym_DQUOTE,
    ACTIONS(2465), 1,
      sym__raw_string_literal,
    ACTIONS(2467), 1,
      sym__external_open_parenthesis,
    ACTIONS(2471), 1,
      sym__external_open_brace,
    ACTIONS(7781), 1,
      anon_sym_BANG,
    ACTIONS(13519), 1,
      sym_dot_dot_i,
    STATE(97), 1,
      sym__open_brace,
    STATE(200), 1,
      sym__open_parenthesis,
    STATE(2369), 1,
      sym__double_quoted_string,
    STATE(2370), 1,
      sym__single_quoted_string,
    STATE(2372), 1,
      sym_string,
    STATE(5138), 1,
      sym__string_or_identifier,
    ACTIONS(2445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2371), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13517), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1673), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [148798] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2425), 1,
      sym_identifier,
    ACTIONS(2427), 1,
      anon_sym_BSLASH,
    ACTIONS(2429), 1,
      anon_sym_function,
    ACTIONS(2431), 1,
      anon_sym_if,
    ACTIONS(2433), 1,
      anon_sym_for,
    ACTIONS(2435), 1,
      anon_sym_while,
    ACTIONS(2437), 1,
      anon_sym_repeat,
    ACTIONS(2439), 1,
      anon_sym_QMARK,
    ACTIONS(2441), 1,
      anon_sym_TILDE,
    ACTIONS(2449), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2451), 1,
      sym__number_literal,
    ACTIONS(2453), 1,
      anon_sym_SQUOTE,
    ACTIONS(2455), 1,
      anon_sym_DQUOTE,
    ACTIONS(2465), 1,
      sym__raw_string_literal,
    ACTIONS(2467), 1,
      sym__external_open_parenthesis,
    ACTIONS(2471), 1,
      sym__external_open_brace,
    ACTIONS(7781), 1,
      anon_sym_BANG,
    ACTIONS(13523), 1,
      sym_dot_dot_i,
    STATE(97), 1,
      sym__open_brace,
    STATE(200), 1,
      sym__open_parenthesis,
    STATE(2369), 1,
      sym__double_quoted_string,
    STATE(2370), 1,
      sym__single_quoted_string,
    STATE(2372), 1,
      sym_string,
    STATE(5138), 1,
      sym__string_or_identifier,
    ACTIONS(2445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2371), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13521), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1671), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [148921] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2425), 1,
      sym_identifier,
    ACTIONS(2427), 1,
      anon_sym_BSLASH,
    ACTIONS(2429), 1,
      anon_sym_function,
    ACTIONS(2431), 1,
      anon_sym_if,
    ACTIONS(2433), 1,
      anon_sym_for,
    ACTIONS(2435), 1,
      anon_sym_while,
    ACTIONS(2437), 1,
      anon_sym_repeat,
    ACTIONS(2439), 1,
      anon_sym_QMARK,
    ACTIONS(2441), 1,
      anon_sym_TILDE,
    ACTIONS(2449), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2451), 1,
      sym__number_literal,
    ACTIONS(2453), 1,
      anon_sym_SQUOTE,
    ACTIONS(2455), 1,
      anon_sym_DQUOTE,
    ACTIONS(2465), 1,
      sym__raw_string_literal,
    ACTIONS(2467), 1,
      sym__external_open_parenthesis,
    ACTIONS(2471), 1,
      sym__external_open_brace,
    ACTIONS(7781), 1,
      anon_sym_BANG,
    ACTIONS(13527), 1,
      sym_dot_dot_i,
    STATE(97), 1,
      sym__open_brace,
    STATE(200), 1,
      sym__open_parenthesis,
    STATE(2369), 1,
      sym__double_quoted_string,
    STATE(2370), 1,
      sym__single_quoted_string,
    STATE(2372), 1,
      sym_string,
    STATE(5138), 1,
      sym__string_or_identifier,
    ACTIONS(2445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2371), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13525), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1665), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [149044] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3845), 1,
      sym_identifier,
    ACTIONS(3847), 1,
      anon_sym_BSLASH,
    ACTIONS(3849), 1,
      anon_sym_function,
    ACTIONS(3851), 1,
      anon_sym_if,
    ACTIONS(3853), 1,
      anon_sym_for,
    ACTIONS(3855), 1,
      anon_sym_while,
    ACTIONS(3857), 1,
      anon_sym_repeat,
    ACTIONS(3859), 1,
      anon_sym_QMARK,
    ACTIONS(3861), 1,
      anon_sym_TILDE,
    ACTIONS(3869), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3871), 1,
      sym__number_literal,
    ACTIONS(3873), 1,
      anon_sym_SQUOTE,
    ACTIONS(3875), 1,
      anon_sym_DQUOTE,
    ACTIONS(3885), 1,
      sym__raw_string_literal,
    ACTIONS(3887), 1,
      sym__external_open_parenthesis,
    ACTIONS(3891), 1,
      sym__external_open_brace,
    ACTIONS(6389), 1,
      anon_sym_BANG,
    ACTIONS(13531), 1,
      sym_dot_dot_i,
    STATE(154), 1,
      sym__open_brace,
    STATE(350), 1,
      sym__open_parenthesis,
    STATE(2620), 1,
      sym__double_quoted_string,
    STATE(2673), 1,
      sym_string,
    STATE(2735), 1,
      sym__single_quoted_string,
    STATE(5135), 1,
      sym__string_or_identifier,
    ACTIONS(3865), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2578), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3879), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13529), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2130), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [149167] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2483), 1,
      sym_identifier,
    ACTIONS(2485), 1,
      anon_sym_BSLASH,
    ACTIONS(2487), 1,
      anon_sym_function,
    ACTIONS(2489), 1,
      anon_sym_if,
    ACTIONS(2491), 1,
      anon_sym_for,
    ACTIONS(2493), 1,
      anon_sym_while,
    ACTIONS(2495), 1,
      anon_sym_repeat,
    ACTIONS(2497), 1,
      anon_sym_QMARK,
    ACTIONS(2499), 1,
      anon_sym_TILDE,
    ACTIONS(2507), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2509), 1,
      sym__number_literal,
    ACTIONS(2511), 1,
      anon_sym_SQUOTE,
    ACTIONS(2513), 1,
      anon_sym_DQUOTE,
    ACTIONS(2523), 1,
      sym__raw_string_literal,
    ACTIONS(2525), 1,
      sym__external_open_parenthesis,
    ACTIONS(2529), 1,
      sym__external_open_brace,
    ACTIONS(7803), 1,
      anon_sym_BANG,
    ACTIONS(13535), 1,
      sym_dot_dot_i,
    STATE(74), 1,
      sym__open_brace,
    STATE(210), 1,
      sym__open_parenthesis,
    STATE(2397), 1,
      sym_string,
    STATE(2430), 1,
      sym__single_quoted_string,
    STATE(2466), 1,
      sym__double_quoted_string,
    STATE(5142), 1,
      sym__string_or_identifier,
    ACTIONS(2503), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2412), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2517), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13533), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1768), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [149290] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13539), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13537), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4561), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [149413] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1241), 1,
      sym_identifier,
    ACTIONS(1243), 1,
      anon_sym_BSLASH,
    ACTIONS(1245), 1,
      anon_sym_function,
    ACTIONS(1247), 1,
      anon_sym_if,
    ACTIONS(1249), 1,
      anon_sym_for,
    ACTIONS(1251), 1,
      anon_sym_while,
    ACTIONS(1253), 1,
      anon_sym_repeat,
    ACTIONS(1255), 1,
      anon_sym_QMARK,
    ACTIONS(1257), 1,
      anon_sym_TILDE,
    ACTIONS(1265), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1267), 1,
      sym__number_literal,
    ACTIONS(1269), 1,
      anon_sym_SQUOTE,
    ACTIONS(1271), 1,
      anon_sym_DQUOTE,
    ACTIONS(1281), 1,
      sym__raw_string_literal,
    ACTIONS(1283), 1,
      sym__external_open_parenthesis,
    ACTIONS(1287), 1,
      sym__external_open_brace,
    ACTIONS(8543), 1,
      anon_sym_BANG,
    ACTIONS(13543), 1,
      sym_dot_dot_i,
    STATE(11), 1,
      sym__open_brace,
    STATE(120), 1,
      sym__open_parenthesis,
    STATE(2271), 1,
      sym_string,
    STATE(2273), 1,
      sym__single_quoted_string,
    STATE(2274), 1,
      sym__double_quoted_string,
    STATE(5157), 1,
      sym__string_or_identifier,
    ACTIONS(1261), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2272), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1275), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13541), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1311), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [149536] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13547), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13545), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4562), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [149659] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13551), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13549), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4557), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [149782] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1241), 1,
      sym_identifier,
    ACTIONS(1243), 1,
      anon_sym_BSLASH,
    ACTIONS(1245), 1,
      anon_sym_function,
    ACTIONS(1247), 1,
      anon_sym_if,
    ACTIONS(1249), 1,
      anon_sym_for,
    ACTIONS(1251), 1,
      anon_sym_while,
    ACTIONS(1253), 1,
      anon_sym_repeat,
    ACTIONS(1255), 1,
      anon_sym_QMARK,
    ACTIONS(1257), 1,
      anon_sym_TILDE,
    ACTIONS(1265), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1267), 1,
      sym__number_literal,
    ACTIONS(1269), 1,
      anon_sym_SQUOTE,
    ACTIONS(1271), 1,
      anon_sym_DQUOTE,
    ACTIONS(1281), 1,
      sym__raw_string_literal,
    ACTIONS(1283), 1,
      sym__external_open_parenthesis,
    ACTIONS(1287), 1,
      sym__external_open_brace,
    ACTIONS(8543), 1,
      anon_sym_BANG,
    ACTIONS(13555), 1,
      sym_dot_dot_i,
    STATE(11), 1,
      sym__open_brace,
    STATE(120), 1,
      sym__open_parenthesis,
    STATE(2271), 1,
      sym_string,
    STATE(2273), 1,
      sym__single_quoted_string,
    STATE(2274), 1,
      sym__double_quoted_string,
    STATE(5157), 1,
      sym__string_or_identifier,
    ACTIONS(1261), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2272), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1275), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13553), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1312), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [149905] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13559), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13557), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4563), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [150028] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1241), 1,
      sym_identifier,
    ACTIONS(1243), 1,
      anon_sym_BSLASH,
    ACTIONS(1245), 1,
      anon_sym_function,
    ACTIONS(1247), 1,
      anon_sym_if,
    ACTIONS(1249), 1,
      anon_sym_for,
    ACTIONS(1251), 1,
      anon_sym_while,
    ACTIONS(1253), 1,
      anon_sym_repeat,
    ACTIONS(1255), 1,
      anon_sym_QMARK,
    ACTIONS(1257), 1,
      anon_sym_TILDE,
    ACTIONS(1265), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1267), 1,
      sym__number_literal,
    ACTIONS(1269), 1,
      anon_sym_SQUOTE,
    ACTIONS(1271), 1,
      anon_sym_DQUOTE,
    ACTIONS(1281), 1,
      sym__raw_string_literal,
    ACTIONS(1283), 1,
      sym__external_open_parenthesis,
    ACTIONS(1287), 1,
      sym__external_open_brace,
    ACTIONS(8543), 1,
      anon_sym_BANG,
    ACTIONS(13563), 1,
      sym_dot_dot_i,
    STATE(11), 1,
      sym__open_brace,
    STATE(120), 1,
      sym__open_parenthesis,
    STATE(2271), 1,
      sym_string,
    STATE(2273), 1,
      sym__single_quoted_string,
    STATE(2274), 1,
      sym__double_quoted_string,
    STATE(5157), 1,
      sym__string_or_identifier,
    ACTIONS(1261), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2272), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1275), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13561), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1313), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [150151] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13567), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13565), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4566), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [150274] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4642), 1,
      sym_identifier,
    ACTIONS(4644), 1,
      anon_sym_BSLASH,
    ACTIONS(4646), 1,
      anon_sym_function,
    ACTIONS(4648), 1,
      anon_sym_if,
    ACTIONS(4650), 1,
      anon_sym_for,
    ACTIONS(4652), 1,
      anon_sym_while,
    ACTIONS(4654), 1,
      anon_sym_repeat,
    ACTIONS(4656), 1,
      anon_sym_QMARK,
    ACTIONS(4658), 1,
      anon_sym_TILDE,
    ACTIONS(4666), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4668), 1,
      sym__number_literal,
    ACTIONS(4670), 1,
      anon_sym_SQUOTE,
    ACTIONS(4672), 1,
      anon_sym_DQUOTE,
    ACTIONS(4680), 1,
      sym__raw_string_literal,
    ACTIONS(4682), 1,
      sym__external_open_parenthesis,
    ACTIONS(4684), 1,
      sym__external_open_brace,
    ACTIONS(6371), 1,
      anon_sym_BANG,
    ACTIONS(13571), 1,
      sym_dot_dot_i,
    STATE(185), 1,
      sym__open_brace,
    STATE(218), 1,
      sym__open_parenthesis,
    STATE(2649), 1,
      sym__double_quoted_string,
    STATE(2654), 1,
      sym__single_quoted_string,
    STATE(2744), 1,
      sym_string,
    STATE(5141), 1,
      sym__string_or_identifier,
    ACTIONS(4662), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2656), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4676), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13569), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2084), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [150397] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1568), 1,
      sym_identifier,
    ACTIONS(1570), 1,
      anon_sym_BSLASH,
    ACTIONS(1572), 1,
      anon_sym_function,
    ACTIONS(1574), 1,
      anon_sym_if,
    ACTIONS(1576), 1,
      anon_sym_for,
    ACTIONS(1578), 1,
      anon_sym_while,
    ACTIONS(1580), 1,
      anon_sym_repeat,
    ACTIONS(1582), 1,
      anon_sym_QMARK,
    ACTIONS(1584), 1,
      anon_sym_TILDE,
    ACTIONS(1592), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1594), 1,
      sym__number_literal,
    ACTIONS(1596), 1,
      anon_sym_SQUOTE,
    ACTIONS(1598), 1,
      anon_sym_DQUOTE,
    ACTIONS(1608), 1,
      sym__raw_string_literal,
    ACTIONS(1610), 1,
      sym__external_open_parenthesis,
    ACTIONS(1614), 1,
      sym__external_open_brace,
    ACTIONS(8477), 1,
      anon_sym_BANG,
    ACTIONS(13575), 1,
      sym_dot_dot_i,
    STATE(16), 1,
      sym__open_brace,
    STATE(119), 1,
      sym__open_parenthesis,
    STATE(2287), 1,
      sym_string,
    STATE(2289), 1,
      sym__single_quoted_string,
    STATE(2290), 1,
      sym__double_quoted_string,
    STATE(5144), 1,
      sym__string_or_identifier,
    ACTIONS(1588), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2288), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1602), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13573), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1144), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [150520] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3845), 1,
      sym_identifier,
    ACTIONS(3847), 1,
      anon_sym_BSLASH,
    ACTIONS(3849), 1,
      anon_sym_function,
    ACTIONS(3851), 1,
      anon_sym_if,
    ACTIONS(3853), 1,
      anon_sym_for,
    ACTIONS(3855), 1,
      anon_sym_while,
    ACTIONS(3857), 1,
      anon_sym_repeat,
    ACTIONS(3859), 1,
      anon_sym_QMARK,
    ACTIONS(3861), 1,
      anon_sym_TILDE,
    ACTIONS(3869), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3871), 1,
      sym__number_literal,
    ACTIONS(3873), 1,
      anon_sym_SQUOTE,
    ACTIONS(3875), 1,
      anon_sym_DQUOTE,
    ACTIONS(3885), 1,
      sym__raw_string_literal,
    ACTIONS(3887), 1,
      sym__external_open_parenthesis,
    ACTIONS(3891), 1,
      sym__external_open_brace,
    ACTIONS(6389), 1,
      anon_sym_BANG,
    ACTIONS(13579), 1,
      sym_dot_dot_i,
    STATE(154), 1,
      sym__open_brace,
    STATE(350), 1,
      sym__open_parenthesis,
    STATE(2620), 1,
      sym__double_quoted_string,
    STATE(2673), 1,
      sym_string,
    STATE(2735), 1,
      sym__single_quoted_string,
    STATE(5135), 1,
      sym__string_or_identifier,
    ACTIONS(3865), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2578), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3879), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13577), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2129), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [150643] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1568), 1,
      sym_identifier,
    ACTIONS(1570), 1,
      anon_sym_BSLASH,
    ACTIONS(1572), 1,
      anon_sym_function,
    ACTIONS(1574), 1,
      anon_sym_if,
    ACTIONS(1576), 1,
      anon_sym_for,
    ACTIONS(1578), 1,
      anon_sym_while,
    ACTIONS(1580), 1,
      anon_sym_repeat,
    ACTIONS(1582), 1,
      anon_sym_QMARK,
    ACTIONS(1584), 1,
      anon_sym_TILDE,
    ACTIONS(1592), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1594), 1,
      sym__number_literal,
    ACTIONS(1596), 1,
      anon_sym_SQUOTE,
    ACTIONS(1598), 1,
      anon_sym_DQUOTE,
    ACTIONS(1608), 1,
      sym__raw_string_literal,
    ACTIONS(1610), 1,
      sym__external_open_parenthesis,
    ACTIONS(1614), 1,
      sym__external_open_brace,
    ACTIONS(8477), 1,
      anon_sym_BANG,
    ACTIONS(13583), 1,
      sym_dot_dot_i,
    STATE(16), 1,
      sym__open_brace,
    STATE(119), 1,
      sym__open_parenthesis,
    STATE(2287), 1,
      sym_string,
    STATE(2289), 1,
      sym__single_quoted_string,
    STATE(2290), 1,
      sym__double_quoted_string,
    STATE(5144), 1,
      sym__string_or_identifier,
    ACTIONS(1588), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2288), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1602), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13581), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1147), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [150766] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2483), 1,
      sym_identifier,
    ACTIONS(2485), 1,
      anon_sym_BSLASH,
    ACTIONS(2487), 1,
      anon_sym_function,
    ACTIONS(2489), 1,
      anon_sym_if,
    ACTIONS(2491), 1,
      anon_sym_for,
    ACTIONS(2493), 1,
      anon_sym_while,
    ACTIONS(2495), 1,
      anon_sym_repeat,
    ACTIONS(2497), 1,
      anon_sym_QMARK,
    ACTIONS(2499), 1,
      anon_sym_TILDE,
    ACTIONS(2507), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2509), 1,
      sym__number_literal,
    ACTIONS(2511), 1,
      anon_sym_SQUOTE,
    ACTIONS(2513), 1,
      anon_sym_DQUOTE,
    ACTIONS(2523), 1,
      sym__raw_string_literal,
    ACTIONS(2525), 1,
      sym__external_open_parenthesis,
    ACTIONS(2529), 1,
      sym__external_open_brace,
    ACTIONS(7803), 1,
      anon_sym_BANG,
    ACTIONS(13587), 1,
      sym_dot_dot_i,
    STATE(74), 1,
      sym__open_brace,
    STATE(210), 1,
      sym__open_parenthesis,
    STATE(2397), 1,
      sym_string,
    STATE(2430), 1,
      sym__single_quoted_string,
    STATE(2466), 1,
      sym__double_quoted_string,
    STATE(5142), 1,
      sym__string_or_identifier,
    ACTIONS(2503), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2412), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2517), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13585), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1760), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [150889] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3845), 1,
      sym_identifier,
    ACTIONS(3847), 1,
      anon_sym_BSLASH,
    ACTIONS(3849), 1,
      anon_sym_function,
    ACTIONS(3851), 1,
      anon_sym_if,
    ACTIONS(3853), 1,
      anon_sym_for,
    ACTIONS(3855), 1,
      anon_sym_while,
    ACTIONS(3857), 1,
      anon_sym_repeat,
    ACTIONS(3859), 1,
      anon_sym_QMARK,
    ACTIONS(3861), 1,
      anon_sym_TILDE,
    ACTIONS(3869), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3871), 1,
      sym__number_literal,
    ACTIONS(3873), 1,
      anon_sym_SQUOTE,
    ACTIONS(3875), 1,
      anon_sym_DQUOTE,
    ACTIONS(3885), 1,
      sym__raw_string_literal,
    ACTIONS(3887), 1,
      sym__external_open_parenthesis,
    ACTIONS(3891), 1,
      sym__external_open_brace,
    ACTIONS(6389), 1,
      anon_sym_BANG,
    ACTIONS(13591), 1,
      sym_dot_dot_i,
    STATE(154), 1,
      sym__open_brace,
    STATE(350), 1,
      sym__open_parenthesis,
    STATE(2620), 1,
      sym__double_quoted_string,
    STATE(2673), 1,
      sym_string,
    STATE(2735), 1,
      sym__single_quoted_string,
    STATE(5135), 1,
      sym__string_or_identifier,
    ACTIONS(3865), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2578), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3879), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13589), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2117), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [151012] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4642), 1,
      sym_identifier,
    ACTIONS(4644), 1,
      anon_sym_BSLASH,
    ACTIONS(4646), 1,
      anon_sym_function,
    ACTIONS(4648), 1,
      anon_sym_if,
    ACTIONS(4650), 1,
      anon_sym_for,
    ACTIONS(4652), 1,
      anon_sym_while,
    ACTIONS(4654), 1,
      anon_sym_repeat,
    ACTIONS(4656), 1,
      anon_sym_QMARK,
    ACTIONS(4658), 1,
      anon_sym_TILDE,
    ACTIONS(4666), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4668), 1,
      sym__number_literal,
    ACTIONS(4670), 1,
      anon_sym_SQUOTE,
    ACTIONS(4672), 1,
      anon_sym_DQUOTE,
    ACTIONS(4680), 1,
      sym__raw_string_literal,
    ACTIONS(4682), 1,
      sym__external_open_parenthesis,
    ACTIONS(4684), 1,
      sym__external_open_brace,
    ACTIONS(6371), 1,
      anon_sym_BANG,
    ACTIONS(13595), 1,
      sym_dot_dot_i,
    STATE(185), 1,
      sym__open_brace,
    STATE(218), 1,
      sym__open_parenthesis,
    STATE(2649), 1,
      sym__double_quoted_string,
    STATE(2654), 1,
      sym__single_quoted_string,
    STATE(2744), 1,
      sym_string,
    STATE(5141), 1,
      sym__string_or_identifier,
    ACTIONS(4662), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2656), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4676), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13593), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2088), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [151135] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4642), 1,
      sym_identifier,
    ACTIONS(4644), 1,
      anon_sym_BSLASH,
    ACTIONS(4646), 1,
      anon_sym_function,
    ACTIONS(4648), 1,
      anon_sym_if,
    ACTIONS(4650), 1,
      anon_sym_for,
    ACTIONS(4652), 1,
      anon_sym_while,
    ACTIONS(4654), 1,
      anon_sym_repeat,
    ACTIONS(4656), 1,
      anon_sym_QMARK,
    ACTIONS(4658), 1,
      anon_sym_TILDE,
    ACTIONS(4666), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4668), 1,
      sym__number_literal,
    ACTIONS(4670), 1,
      anon_sym_SQUOTE,
    ACTIONS(4672), 1,
      anon_sym_DQUOTE,
    ACTIONS(4680), 1,
      sym__raw_string_literal,
    ACTIONS(4682), 1,
      sym__external_open_parenthesis,
    ACTIONS(4684), 1,
      sym__external_open_brace,
    ACTIONS(6371), 1,
      anon_sym_BANG,
    ACTIONS(13599), 1,
      sym_dot_dot_i,
    STATE(185), 1,
      sym__open_brace,
    STATE(218), 1,
      sym__open_parenthesis,
    STATE(2649), 1,
      sym__double_quoted_string,
    STATE(2654), 1,
      sym__single_quoted_string,
    STATE(2744), 1,
      sym_string,
    STATE(5141), 1,
      sym__string_or_identifier,
    ACTIONS(4662), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2656), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4676), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13597), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2094), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [151258] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13603), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13601), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4574), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [151381] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1568), 1,
      sym_identifier,
    ACTIONS(1570), 1,
      anon_sym_BSLASH,
    ACTIONS(1572), 1,
      anon_sym_function,
    ACTIONS(1574), 1,
      anon_sym_if,
    ACTIONS(1576), 1,
      anon_sym_for,
    ACTIONS(1578), 1,
      anon_sym_while,
    ACTIONS(1580), 1,
      anon_sym_repeat,
    ACTIONS(1582), 1,
      anon_sym_QMARK,
    ACTIONS(1584), 1,
      anon_sym_TILDE,
    ACTIONS(1592), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1594), 1,
      sym__number_literal,
    ACTIONS(1596), 1,
      anon_sym_SQUOTE,
    ACTIONS(1598), 1,
      anon_sym_DQUOTE,
    ACTIONS(1608), 1,
      sym__raw_string_literal,
    ACTIONS(1610), 1,
      sym__external_open_parenthesis,
    ACTIONS(1614), 1,
      sym__external_open_brace,
    ACTIONS(8477), 1,
      anon_sym_BANG,
    ACTIONS(13607), 1,
      sym_dot_dot_i,
    STATE(16), 1,
      sym__open_brace,
    STATE(119), 1,
      sym__open_parenthesis,
    STATE(2287), 1,
      sym_string,
    STATE(2289), 1,
      sym__single_quoted_string,
    STATE(2290), 1,
      sym__double_quoted_string,
    STATE(5144), 1,
      sym__string_or_identifier,
    ACTIONS(1588), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2288), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1602), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13605), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1155), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [151504] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2483), 1,
      sym_identifier,
    ACTIONS(2485), 1,
      anon_sym_BSLASH,
    ACTIONS(2487), 1,
      anon_sym_function,
    ACTIONS(2489), 1,
      anon_sym_if,
    ACTIONS(2491), 1,
      anon_sym_for,
    ACTIONS(2493), 1,
      anon_sym_while,
    ACTIONS(2495), 1,
      anon_sym_repeat,
    ACTIONS(2497), 1,
      anon_sym_QMARK,
    ACTIONS(2499), 1,
      anon_sym_TILDE,
    ACTIONS(2507), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2509), 1,
      sym__number_literal,
    ACTIONS(2511), 1,
      anon_sym_SQUOTE,
    ACTIONS(2513), 1,
      anon_sym_DQUOTE,
    ACTIONS(2523), 1,
      sym__raw_string_literal,
    ACTIONS(2525), 1,
      sym__external_open_parenthesis,
    ACTIONS(2529), 1,
      sym__external_open_brace,
    ACTIONS(7803), 1,
      anon_sym_BANG,
    ACTIONS(13611), 1,
      sym_dot_dot_i,
    STATE(74), 1,
      sym__open_brace,
    STATE(210), 1,
      sym__open_parenthesis,
    STATE(2397), 1,
      sym_string,
    STATE(2430), 1,
      sym__single_quoted_string,
    STATE(2466), 1,
      sym__double_quoted_string,
    STATE(5142), 1,
      sym__string_or_identifier,
    ACTIONS(2503), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2412), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2517), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13609), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1769), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [151627] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4642), 1,
      sym_identifier,
    ACTIONS(4644), 1,
      anon_sym_BSLASH,
    ACTIONS(4646), 1,
      anon_sym_function,
    ACTIONS(4648), 1,
      anon_sym_if,
    ACTIONS(4650), 1,
      anon_sym_for,
    ACTIONS(4652), 1,
      anon_sym_while,
    ACTIONS(4654), 1,
      anon_sym_repeat,
    ACTIONS(4656), 1,
      anon_sym_QMARK,
    ACTIONS(4658), 1,
      anon_sym_TILDE,
    ACTIONS(4666), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4668), 1,
      sym__number_literal,
    ACTIONS(4670), 1,
      anon_sym_SQUOTE,
    ACTIONS(4672), 1,
      anon_sym_DQUOTE,
    ACTIONS(4680), 1,
      sym__raw_string_literal,
    ACTIONS(4682), 1,
      sym__external_open_parenthesis,
    ACTIONS(4684), 1,
      sym__external_open_brace,
    ACTIONS(6371), 1,
      anon_sym_BANG,
    ACTIONS(13615), 1,
      sym_dot_dot_i,
    STATE(185), 1,
      sym__open_brace,
    STATE(218), 1,
      sym__open_parenthesis,
    STATE(2649), 1,
      sym__double_quoted_string,
    STATE(2654), 1,
      sym__single_quoted_string,
    STATE(2744), 1,
      sym_string,
    STATE(5141), 1,
      sym__string_or_identifier,
    ACTIONS(4662), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2656), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4676), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13613), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2106), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [151750] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1433), 1,
      sym_identifier,
    ACTIONS(1435), 1,
      anon_sym_BSLASH,
    ACTIONS(1437), 1,
      anon_sym_function,
    ACTIONS(1439), 1,
      anon_sym_if,
    ACTIONS(1441), 1,
      anon_sym_for,
    ACTIONS(1443), 1,
      anon_sym_while,
    ACTIONS(1445), 1,
      anon_sym_repeat,
    ACTIONS(1447), 1,
      anon_sym_QMARK,
    ACTIONS(1449), 1,
      anon_sym_TILDE,
    ACTIONS(1457), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1459), 1,
      sym__number_literal,
    ACTIONS(1461), 1,
      anon_sym_SQUOTE,
    ACTIONS(1463), 1,
      anon_sym_DQUOTE,
    ACTIONS(1473), 1,
      sym__raw_string_literal,
    ACTIONS(1475), 1,
      sym__external_open_parenthesis,
    ACTIONS(1477), 1,
      sym__external_open_brace,
    ACTIONS(8097), 1,
      anon_sym_BANG,
    ACTIONS(13619), 1,
      sym_dot_dot_i,
    STATE(76), 1,
      sym__open_parenthesis,
    STATE(188), 1,
      sym__open_brace,
    STATE(2234), 1,
      sym_string,
    STATE(2236), 1,
      sym__single_quoted_string,
    STATE(2237), 1,
      sym__double_quoted_string,
    STATE(5150), 1,
      sym__string_or_identifier,
    ACTIONS(1453), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2235), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1467), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13617), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1069), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [151873] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2483), 1,
      sym_identifier,
    ACTIONS(2485), 1,
      anon_sym_BSLASH,
    ACTIONS(2487), 1,
      anon_sym_function,
    ACTIONS(2489), 1,
      anon_sym_if,
    ACTIONS(2491), 1,
      anon_sym_for,
    ACTIONS(2493), 1,
      anon_sym_while,
    ACTIONS(2495), 1,
      anon_sym_repeat,
    ACTIONS(2497), 1,
      anon_sym_QMARK,
    ACTIONS(2499), 1,
      anon_sym_TILDE,
    ACTIONS(2507), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2509), 1,
      sym__number_literal,
    ACTIONS(2511), 1,
      anon_sym_SQUOTE,
    ACTIONS(2513), 1,
      anon_sym_DQUOTE,
    ACTIONS(2523), 1,
      sym__raw_string_literal,
    ACTIONS(2525), 1,
      sym__external_open_parenthesis,
    ACTIONS(2529), 1,
      sym__external_open_brace,
    ACTIONS(7803), 1,
      anon_sym_BANG,
    ACTIONS(13623), 1,
      sym_dot_dot_i,
    STATE(74), 1,
      sym__open_brace,
    STATE(210), 1,
      sym__open_parenthesis,
    STATE(2397), 1,
      sym_string,
    STATE(2430), 1,
      sym__single_quoted_string,
    STATE(2466), 1,
      sym__double_quoted_string,
    STATE(5142), 1,
      sym__string_or_identifier,
    ACTIONS(2503), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2412), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2517), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13621), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1320), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [151996] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1433), 1,
      sym_identifier,
    ACTIONS(1435), 1,
      anon_sym_BSLASH,
    ACTIONS(1437), 1,
      anon_sym_function,
    ACTIONS(1439), 1,
      anon_sym_if,
    ACTIONS(1441), 1,
      anon_sym_for,
    ACTIONS(1443), 1,
      anon_sym_while,
    ACTIONS(1445), 1,
      anon_sym_repeat,
    ACTIONS(1447), 1,
      anon_sym_QMARK,
    ACTIONS(1449), 1,
      anon_sym_TILDE,
    ACTIONS(1457), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1459), 1,
      sym__number_literal,
    ACTIONS(1461), 1,
      anon_sym_SQUOTE,
    ACTIONS(1463), 1,
      anon_sym_DQUOTE,
    ACTIONS(1473), 1,
      sym__raw_string_literal,
    ACTIONS(1475), 1,
      sym__external_open_parenthesis,
    ACTIONS(1477), 1,
      sym__external_open_brace,
    ACTIONS(8097), 1,
      anon_sym_BANG,
    ACTIONS(13627), 1,
      sym_dot_dot_i,
    STATE(76), 1,
      sym__open_parenthesis,
    STATE(188), 1,
      sym__open_brace,
    STATE(2234), 1,
      sym_string,
    STATE(2236), 1,
      sym__single_quoted_string,
    STATE(2237), 1,
      sym__double_quoted_string,
    STATE(5150), 1,
      sym__string_or_identifier,
    ACTIONS(1453), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2235), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1467), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13625), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1074), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [152119] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13631), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13629), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4509), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [152242] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1433), 1,
      sym_identifier,
    ACTIONS(1435), 1,
      anon_sym_BSLASH,
    ACTIONS(1437), 1,
      anon_sym_function,
    ACTIONS(1439), 1,
      anon_sym_if,
    ACTIONS(1441), 1,
      anon_sym_for,
    ACTIONS(1443), 1,
      anon_sym_while,
    ACTIONS(1445), 1,
      anon_sym_repeat,
    ACTIONS(1447), 1,
      anon_sym_QMARK,
    ACTIONS(1449), 1,
      anon_sym_TILDE,
    ACTIONS(1457), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1459), 1,
      sym__number_literal,
    ACTIONS(1461), 1,
      anon_sym_SQUOTE,
    ACTIONS(1463), 1,
      anon_sym_DQUOTE,
    ACTIONS(1473), 1,
      sym__raw_string_literal,
    ACTIONS(1475), 1,
      sym__external_open_parenthesis,
    ACTIONS(1477), 1,
      sym__external_open_brace,
    ACTIONS(8097), 1,
      anon_sym_BANG,
    ACTIONS(13635), 1,
      sym_dot_dot_i,
    STATE(76), 1,
      sym__open_parenthesis,
    STATE(188), 1,
      sym__open_brace,
    STATE(2234), 1,
      sym_string,
    STATE(2236), 1,
      sym__single_quoted_string,
    STATE(2237), 1,
      sym__double_quoted_string,
    STATE(5150), 1,
      sym__string_or_identifier,
    ACTIONS(1453), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2235), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1467), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13633), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1075), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [152365] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13639), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13637), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4576), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [152488] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13643), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13641), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4577), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [152611] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13647), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13645), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4579), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [152734] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1289), 1,
      sym_identifier,
    ACTIONS(1291), 1,
      anon_sym_BSLASH,
    ACTIONS(1293), 1,
      anon_sym_function,
    ACTIONS(1295), 1,
      anon_sym_if,
    ACTIONS(1297), 1,
      anon_sym_for,
    ACTIONS(1299), 1,
      anon_sym_while,
    ACTIONS(1301), 1,
      anon_sym_repeat,
    ACTIONS(1303), 1,
      anon_sym_QMARK,
    ACTIONS(1305), 1,
      anon_sym_TILDE,
    ACTIONS(1313), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1315), 1,
      sym__number_literal,
    ACTIONS(1317), 1,
      anon_sym_SQUOTE,
    ACTIONS(1319), 1,
      anon_sym_DQUOTE,
    ACTIONS(1329), 1,
      sym__raw_string_literal,
    ACTIONS(1331), 1,
      sym__external_open_parenthesis,
    ACTIONS(1333), 1,
      sym__external_open_brace,
    ACTIONS(8531), 1,
      anon_sym_BANG,
    ACTIONS(13651), 1,
      sym_dot_dot_i,
    STATE(23), 1,
      sym__open_parenthesis,
    STATE(180), 1,
      sym__open_brace,
    STATE(2264), 1,
      sym__double_quoted_string,
    STATE(2265), 1,
      sym__single_quoted_string,
    STATE(2284), 1,
      sym_string,
    STATE(5147), 1,
      sym__string_or_identifier,
    ACTIONS(1309), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2266), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1323), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13649), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1153), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [152857] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(13655), 1,
      sym_dot_dot_i,
    STATE(292), 1,
      sym__open_brace,
    STATE(293), 1,
      sym__open_parenthesis,
    STATE(2562), 1,
      sym_string,
    STATE(2737), 1,
      sym__double_quoted_string,
    STATE(2738), 1,
      sym__single_quoted_string,
    STATE(5152), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2739), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13653), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1983), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [152980] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13659), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13657), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4583), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [153103] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1289), 1,
      sym_identifier,
    ACTIONS(1291), 1,
      anon_sym_BSLASH,
    ACTIONS(1293), 1,
      anon_sym_function,
    ACTIONS(1295), 1,
      anon_sym_if,
    ACTIONS(1297), 1,
      anon_sym_for,
    ACTIONS(1299), 1,
      anon_sym_while,
    ACTIONS(1301), 1,
      anon_sym_repeat,
    ACTIONS(1303), 1,
      anon_sym_QMARK,
    ACTIONS(1305), 1,
      anon_sym_TILDE,
    ACTIONS(1313), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1315), 1,
      sym__number_literal,
    ACTIONS(1317), 1,
      anon_sym_SQUOTE,
    ACTIONS(1319), 1,
      anon_sym_DQUOTE,
    ACTIONS(1329), 1,
      sym__raw_string_literal,
    ACTIONS(1331), 1,
      sym__external_open_parenthesis,
    ACTIONS(1333), 1,
      sym__external_open_brace,
    ACTIONS(8531), 1,
      anon_sym_BANG,
    ACTIONS(13663), 1,
      sym_dot_dot_i,
    STATE(23), 1,
      sym__open_parenthesis,
    STATE(180), 1,
      sym__open_brace,
    STATE(2264), 1,
      sym__double_quoted_string,
    STATE(2265), 1,
      sym__single_quoted_string,
    STATE(2284), 1,
      sym_string,
    STATE(5147), 1,
      sym__string_or_identifier,
    ACTIONS(1309), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2266), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1323), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13661), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1160), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [153226] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13667), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13665), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4584), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [153349] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1385), 1,
      sym_identifier,
    ACTIONS(1387), 1,
      anon_sym_BSLASH,
    ACTIONS(1389), 1,
      anon_sym_function,
    ACTIONS(1391), 1,
      anon_sym_if,
    ACTIONS(1393), 1,
      anon_sym_for,
    ACTIONS(1395), 1,
      anon_sym_while,
    ACTIONS(1397), 1,
      anon_sym_repeat,
    ACTIONS(1399), 1,
      anon_sym_QMARK,
    ACTIONS(1401), 1,
      anon_sym_TILDE,
    ACTIONS(1409), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1411), 1,
      sym__number_literal,
    ACTIONS(1413), 1,
      anon_sym_SQUOTE,
    ACTIONS(1415), 1,
      anon_sym_DQUOTE,
    ACTIONS(1425), 1,
      sym__raw_string_literal,
    ACTIONS(1427), 1,
      sym__external_open_parenthesis,
    ACTIONS(1429), 1,
      sym__external_open_brace,
    ACTIONS(9251), 1,
      anon_sym_BANG,
    ACTIONS(13671), 1,
      sym_dot_dot_i,
    STATE(64), 1,
      sym__open_parenthesis,
    STATE(199), 1,
      sym__open_brace,
    STATE(2309), 1,
      sym__double_quoted_string,
    STATE(2310), 1,
      sym__single_quoted_string,
    STATE(2312), 1,
      sym_string,
    STATE(5134), 1,
      sym__string_or_identifier,
    ACTIONS(1405), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2311), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1419), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13669), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1091), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [153472] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1289), 1,
      sym_identifier,
    ACTIONS(1291), 1,
      anon_sym_BSLASH,
    ACTIONS(1293), 1,
      anon_sym_function,
    ACTIONS(1295), 1,
      anon_sym_if,
    ACTIONS(1297), 1,
      anon_sym_for,
    ACTIONS(1299), 1,
      anon_sym_while,
    ACTIONS(1301), 1,
      anon_sym_repeat,
    ACTIONS(1303), 1,
      anon_sym_QMARK,
    ACTIONS(1305), 1,
      anon_sym_TILDE,
    ACTIONS(1313), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1315), 1,
      sym__number_literal,
    ACTIONS(1317), 1,
      anon_sym_SQUOTE,
    ACTIONS(1319), 1,
      anon_sym_DQUOTE,
    ACTIONS(1329), 1,
      sym__raw_string_literal,
    ACTIONS(1331), 1,
      sym__external_open_parenthesis,
    ACTIONS(1333), 1,
      sym__external_open_brace,
    ACTIONS(8531), 1,
      anon_sym_BANG,
    ACTIONS(13675), 1,
      sym_dot_dot_i,
    STATE(23), 1,
      sym__open_parenthesis,
    STATE(180), 1,
      sym__open_brace,
    STATE(2264), 1,
      sym__double_quoted_string,
    STATE(2265), 1,
      sym__single_quoted_string,
    STATE(2284), 1,
      sym_string,
    STATE(5147), 1,
      sym__string_or_identifier,
    ACTIONS(1309), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2266), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1323), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13673), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1162), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [153595] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13679), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13677), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4585), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [153718] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1385), 1,
      sym_identifier,
    ACTIONS(1387), 1,
      anon_sym_BSLASH,
    ACTIONS(1389), 1,
      anon_sym_function,
    ACTIONS(1391), 1,
      anon_sym_if,
    ACTIONS(1393), 1,
      anon_sym_for,
    ACTIONS(1395), 1,
      anon_sym_while,
    ACTIONS(1397), 1,
      anon_sym_repeat,
    ACTIONS(1399), 1,
      anon_sym_QMARK,
    ACTIONS(1401), 1,
      anon_sym_TILDE,
    ACTIONS(1409), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1411), 1,
      sym__number_literal,
    ACTIONS(1413), 1,
      anon_sym_SQUOTE,
    ACTIONS(1415), 1,
      anon_sym_DQUOTE,
    ACTIONS(1425), 1,
      sym__raw_string_literal,
    ACTIONS(1427), 1,
      sym__external_open_parenthesis,
    ACTIONS(1429), 1,
      sym__external_open_brace,
    ACTIONS(9251), 1,
      anon_sym_BANG,
    ACTIONS(13683), 1,
      sym_dot_dot_i,
    STATE(64), 1,
      sym__open_parenthesis,
    STATE(199), 1,
      sym__open_brace,
    STATE(2309), 1,
      sym__double_quoted_string,
    STATE(2310), 1,
      sym__single_quoted_string,
    STATE(2312), 1,
      sym_string,
    STATE(5134), 1,
      sym__string_or_identifier,
    ACTIONS(1405), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2311), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1419), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13681), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1093), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [153841] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13687), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13685), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4591), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [153964] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13691), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13689), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4599), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [154087] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2826), 1,
      sym_identifier,
    ACTIONS(2828), 1,
      anon_sym_BSLASH,
    ACTIONS(2830), 1,
      anon_sym_function,
    ACTIONS(2832), 1,
      anon_sym_if,
    ACTIONS(2834), 1,
      anon_sym_for,
    ACTIONS(2836), 1,
      anon_sym_while,
    ACTIONS(2838), 1,
      anon_sym_repeat,
    ACTIONS(2840), 1,
      anon_sym_QMARK,
    ACTIONS(2842), 1,
      anon_sym_TILDE,
    ACTIONS(2850), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2852), 1,
      sym__number_literal,
    ACTIONS(2854), 1,
      anon_sym_SQUOTE,
    ACTIONS(2856), 1,
      anon_sym_DQUOTE,
    ACTIONS(2866), 1,
      sym__raw_string_literal,
    ACTIONS(2868), 1,
      sym__external_open_parenthesis,
    ACTIONS(2870), 1,
      sym__external_open_brace,
    ACTIONS(10915), 1,
      anon_sym_BANG,
    ACTIONS(13695), 1,
      sym_dot_dot_i,
    STATE(178), 1,
      sym__open_parenthesis,
    STATE(244), 1,
      sym__open_brace,
    STATE(2522), 1,
      sym_string,
    STATE(2528), 1,
      sym__single_quoted_string,
    STATE(2529), 1,
      sym__double_quoted_string,
    STATE(5126), 1,
      sym__string_or_identifier,
    ACTIONS(2846), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2523), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2860), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13693), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1579), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [154210] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13699), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13697), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4560), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [154333] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1433), 1,
      sym_identifier,
    ACTIONS(1435), 1,
      anon_sym_BSLASH,
    ACTIONS(1437), 1,
      anon_sym_function,
    ACTIONS(1439), 1,
      anon_sym_if,
    ACTIONS(1441), 1,
      anon_sym_for,
    ACTIONS(1443), 1,
      anon_sym_while,
    ACTIONS(1445), 1,
      anon_sym_repeat,
    ACTIONS(1447), 1,
      anon_sym_QMARK,
    ACTIONS(1449), 1,
      anon_sym_TILDE,
    ACTIONS(1457), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1459), 1,
      sym__number_literal,
    ACTIONS(1461), 1,
      anon_sym_SQUOTE,
    ACTIONS(1463), 1,
      anon_sym_DQUOTE,
    ACTIONS(1473), 1,
      sym__raw_string_literal,
    ACTIONS(1475), 1,
      sym__external_open_parenthesis,
    ACTIONS(1477), 1,
      sym__external_open_brace,
    ACTIONS(8097), 1,
      anon_sym_BANG,
    ACTIONS(13703), 1,
      sym_dot_dot_i,
    STATE(76), 1,
      sym__open_parenthesis,
    STATE(188), 1,
      sym__open_brace,
    STATE(2234), 1,
      sym_string,
    STATE(2236), 1,
      sym__single_quoted_string,
    STATE(2237), 1,
      sym__double_quoted_string,
    STATE(5150), 1,
      sym__string_or_identifier,
    ACTIONS(1453), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2235), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1467), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13701), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1083), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [154456] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1289), 1,
      sym_identifier,
    ACTIONS(1291), 1,
      anon_sym_BSLASH,
    ACTIONS(1293), 1,
      anon_sym_function,
    ACTIONS(1295), 1,
      anon_sym_if,
    ACTIONS(1297), 1,
      anon_sym_for,
    ACTIONS(1299), 1,
      anon_sym_while,
    ACTIONS(1301), 1,
      anon_sym_repeat,
    ACTIONS(1303), 1,
      anon_sym_QMARK,
    ACTIONS(1305), 1,
      anon_sym_TILDE,
    ACTIONS(1313), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1315), 1,
      sym__number_literal,
    ACTIONS(1317), 1,
      anon_sym_SQUOTE,
    ACTIONS(1319), 1,
      anon_sym_DQUOTE,
    ACTIONS(1329), 1,
      sym__raw_string_literal,
    ACTIONS(1331), 1,
      sym__external_open_parenthesis,
    ACTIONS(1333), 1,
      sym__external_open_brace,
    ACTIONS(8531), 1,
      anon_sym_BANG,
    ACTIONS(13707), 1,
      sym_dot_dot_i,
    STATE(23), 1,
      sym__open_parenthesis,
    STATE(180), 1,
      sym__open_brace,
    STATE(2264), 1,
      sym__double_quoted_string,
    STATE(2265), 1,
      sym__single_quoted_string,
    STATE(2284), 1,
      sym_string,
    STATE(5147), 1,
      sym__string_or_identifier,
    ACTIONS(1309), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2266), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1323), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13705), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1165), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [154579] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1385), 1,
      sym_identifier,
    ACTIONS(1387), 1,
      anon_sym_BSLASH,
    ACTIONS(1389), 1,
      anon_sym_function,
    ACTIONS(1391), 1,
      anon_sym_if,
    ACTIONS(1393), 1,
      anon_sym_for,
    ACTIONS(1395), 1,
      anon_sym_while,
    ACTIONS(1397), 1,
      anon_sym_repeat,
    ACTIONS(1399), 1,
      anon_sym_QMARK,
    ACTIONS(1401), 1,
      anon_sym_TILDE,
    ACTIONS(1409), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1411), 1,
      sym__number_literal,
    ACTIONS(1413), 1,
      anon_sym_SQUOTE,
    ACTIONS(1415), 1,
      anon_sym_DQUOTE,
    ACTIONS(1425), 1,
      sym__raw_string_literal,
    ACTIONS(1427), 1,
      sym__external_open_parenthesis,
    ACTIONS(1429), 1,
      sym__external_open_brace,
    ACTIONS(9251), 1,
      anon_sym_BANG,
    ACTIONS(13711), 1,
      sym_dot_dot_i,
    STATE(64), 1,
      sym__open_parenthesis,
    STATE(199), 1,
      sym__open_brace,
    STATE(2309), 1,
      sym__double_quoted_string,
    STATE(2310), 1,
      sym__single_quoted_string,
    STATE(2312), 1,
      sym_string,
    STATE(5134), 1,
      sym__string_or_identifier,
    ACTIONS(1405), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2311), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1419), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13709), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1096), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [154702] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13715), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13713), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4600), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [154825] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13719), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13717), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4601), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [154948] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13723), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13721), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4602), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [155071] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2826), 1,
      sym_identifier,
    ACTIONS(2828), 1,
      anon_sym_BSLASH,
    ACTIONS(2830), 1,
      anon_sym_function,
    ACTIONS(2832), 1,
      anon_sym_if,
    ACTIONS(2834), 1,
      anon_sym_for,
    ACTIONS(2836), 1,
      anon_sym_while,
    ACTIONS(2838), 1,
      anon_sym_repeat,
    ACTIONS(2840), 1,
      anon_sym_QMARK,
    ACTIONS(2842), 1,
      anon_sym_TILDE,
    ACTIONS(2850), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2852), 1,
      sym__number_literal,
    ACTIONS(2854), 1,
      anon_sym_SQUOTE,
    ACTIONS(2856), 1,
      anon_sym_DQUOTE,
    ACTIONS(2866), 1,
      sym__raw_string_literal,
    ACTIONS(2868), 1,
      sym__external_open_parenthesis,
    ACTIONS(2870), 1,
      sym__external_open_brace,
    ACTIONS(10915), 1,
      anon_sym_BANG,
    ACTIONS(13727), 1,
      sym_dot_dot_i,
    STATE(178), 1,
      sym__open_parenthesis,
    STATE(244), 1,
      sym__open_brace,
    STATE(2522), 1,
      sym_string,
    STATE(2528), 1,
      sym__single_quoted_string,
    STATE(2529), 1,
      sym__double_quoted_string,
    STATE(5126), 1,
      sym__string_or_identifier,
    ACTIONS(2846), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2523), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2860), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13725), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1489), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [155194] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13731), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13729), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4603), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [155317] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3491), 1,
      sym_identifier,
    ACTIONS(3493), 1,
      anon_sym_BSLASH,
    ACTIONS(3495), 1,
      anon_sym_function,
    ACTIONS(3497), 1,
      anon_sym_if,
    ACTIONS(3499), 1,
      anon_sym_for,
    ACTIONS(3501), 1,
      anon_sym_while,
    ACTIONS(3503), 1,
      anon_sym_repeat,
    ACTIONS(3505), 1,
      anon_sym_QMARK,
    ACTIONS(3507), 1,
      anon_sym_TILDE,
    ACTIONS(3515), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3517), 1,
      sym__number_literal,
    ACTIONS(3519), 1,
      anon_sym_SQUOTE,
    ACTIONS(3521), 1,
      anon_sym_DQUOTE,
    ACTIONS(3531), 1,
      sym__raw_string_literal,
    ACTIONS(3533), 1,
      sym__external_open_parenthesis,
    ACTIONS(3535), 1,
      sym__external_open_brace,
    ACTIONS(7789), 1,
      anon_sym_BANG,
    ACTIONS(13735), 1,
      sym_dot_dot_i,
    STATE(63), 1,
      sym__open_brace,
    STATE(147), 1,
      sym__open_parenthesis,
    STATE(2441), 1,
      sym_string,
    STATE(2456), 1,
      sym__single_quoted_string,
    STATE(2478), 1,
      sym__double_quoted_string,
    STATE(5130), 1,
      sym__string_or_identifier,
    ACTIONS(3511), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2448), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3525), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13733), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1572), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [155440] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2826), 1,
      sym_identifier,
    ACTIONS(2828), 1,
      anon_sym_BSLASH,
    ACTIONS(2830), 1,
      anon_sym_function,
    ACTIONS(2832), 1,
      anon_sym_if,
    ACTIONS(2834), 1,
      anon_sym_for,
    ACTIONS(2836), 1,
      anon_sym_while,
    ACTIONS(2838), 1,
      anon_sym_repeat,
    ACTIONS(2840), 1,
      anon_sym_QMARK,
    ACTIONS(2842), 1,
      anon_sym_TILDE,
    ACTIONS(2850), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2852), 1,
      sym__number_literal,
    ACTIONS(2854), 1,
      anon_sym_SQUOTE,
    ACTIONS(2856), 1,
      anon_sym_DQUOTE,
    ACTIONS(2866), 1,
      sym__raw_string_literal,
    ACTIONS(2868), 1,
      sym__external_open_parenthesis,
    ACTIONS(2870), 1,
      sym__external_open_brace,
    ACTIONS(10915), 1,
      anon_sym_BANG,
    ACTIONS(13739), 1,
      sym_dot_dot_i,
    STATE(178), 1,
      sym__open_parenthesis,
    STATE(244), 1,
      sym__open_brace,
    STATE(2522), 1,
      sym_string,
    STATE(2528), 1,
      sym__single_quoted_string,
    STATE(2529), 1,
      sym__double_quoted_string,
    STATE(5126), 1,
      sym__string_or_identifier,
    ACTIONS(2846), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2523), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2860), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13737), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1487), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [155563] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13743), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13741), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4508), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [155686] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13747), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13745), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4510), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [155809] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13751), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13749), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4525), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [155932] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13755), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13753), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4555), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [156055] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13759), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13757), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4439), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [156178] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13763), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13761), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4607), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [156301] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      sym_identifier,
    ACTIONS(55), 1,
      anon_sym_BSLASH,
    ACTIONS(57), 1,
      anon_sym_function,
    ACTIONS(61), 1,
      anon_sym_if,
    ACTIONS(63), 1,
      anon_sym_for,
    ACTIONS(65), 1,
      anon_sym_while,
    ACTIONS(67), 1,
      anon_sym_repeat,
    ACTIONS(69), 1,
      anon_sym_QMARK,
    ACTIONS(71), 1,
      anon_sym_TILDE,
    ACTIONS(79), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(81), 1,
      sym__number_literal,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE,
    ACTIONS(95), 1,
      sym__raw_string_literal,
    ACTIONS(97), 1,
      sym__external_open_parenthesis,
    ACTIONS(99), 1,
      sym__external_open_brace,
    ACTIONS(8831), 1,
      anon_sym_BANG,
    ACTIONS(13767), 1,
      sym_dot_dot_i,
    STATE(4), 1,
      sym__open_brace,
    STATE(19), 1,
      sym__open_parenthesis,
    STATE(1982), 1,
      sym_string,
    STATE(1985), 1,
      sym__single_quoted_string,
    STATE(1990), 1,
      sym__double_quoted_string,
    STATE(5151), 1,
      sym__string_or_identifier,
    ACTIONS(75), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1984), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(89), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13765), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(562), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [156424] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13771), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13769), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4608), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [156547] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13775), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13773), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4441), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [156670] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13779), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13777), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4609), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [156793] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13783), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13781), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4482), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [156916] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3491), 1,
      sym_identifier,
    ACTIONS(3493), 1,
      anon_sym_BSLASH,
    ACTIONS(3495), 1,
      anon_sym_function,
    ACTIONS(3497), 1,
      anon_sym_if,
    ACTIONS(3499), 1,
      anon_sym_for,
    ACTIONS(3501), 1,
      anon_sym_while,
    ACTIONS(3503), 1,
      anon_sym_repeat,
    ACTIONS(3505), 1,
      anon_sym_QMARK,
    ACTIONS(3507), 1,
      anon_sym_TILDE,
    ACTIONS(3515), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3517), 1,
      sym__number_literal,
    ACTIONS(3519), 1,
      anon_sym_SQUOTE,
    ACTIONS(3521), 1,
      anon_sym_DQUOTE,
    ACTIONS(3531), 1,
      sym__raw_string_literal,
    ACTIONS(3533), 1,
      sym__external_open_parenthesis,
    ACTIONS(3535), 1,
      sym__external_open_brace,
    ACTIONS(7789), 1,
      anon_sym_BANG,
    ACTIONS(13787), 1,
      sym_dot_dot_i,
    STATE(63), 1,
      sym__open_brace,
    STATE(147), 1,
      sym__open_parenthesis,
    STATE(2441), 1,
      sym_string,
    STATE(2456), 1,
      sym__single_quoted_string,
    STATE(2478), 1,
      sym__double_quoted_string,
    STATE(5130), 1,
      sym__string_or_identifier,
    ACTIONS(3511), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2448), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3525), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13785), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1564), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [157039] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13791), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13789), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4613), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [157162] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3491), 1,
      sym_identifier,
    ACTIONS(3493), 1,
      anon_sym_BSLASH,
    ACTIONS(3495), 1,
      anon_sym_function,
    ACTIONS(3497), 1,
      anon_sym_if,
    ACTIONS(3499), 1,
      anon_sym_for,
    ACTIONS(3501), 1,
      anon_sym_while,
    ACTIONS(3503), 1,
      anon_sym_repeat,
    ACTIONS(3505), 1,
      anon_sym_QMARK,
    ACTIONS(3507), 1,
      anon_sym_TILDE,
    ACTIONS(3515), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3517), 1,
      sym__number_literal,
    ACTIONS(3519), 1,
      anon_sym_SQUOTE,
    ACTIONS(3521), 1,
      anon_sym_DQUOTE,
    ACTIONS(3531), 1,
      sym__raw_string_literal,
    ACTIONS(3533), 1,
      sym__external_open_parenthesis,
    ACTIONS(3535), 1,
      sym__external_open_brace,
    ACTIONS(7789), 1,
      anon_sym_BANG,
    ACTIONS(13795), 1,
      sym_dot_dot_i,
    STATE(63), 1,
      sym__open_brace,
    STATE(147), 1,
      sym__open_parenthesis,
    STATE(2441), 1,
      sym_string,
    STATE(2456), 1,
      sym__single_quoted_string,
    STATE(2478), 1,
      sym__double_quoted_string,
    STATE(5130), 1,
      sym__string_or_identifier,
    ACTIONS(3511), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2448), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3525), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13793), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1562), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [157285] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(273), 1,
      sym_identifier,
    ACTIONS(275), 1,
      anon_sym_BSLASH,
    ACTIONS(277), 1,
      anon_sym_function,
    ACTIONS(279), 1,
      anon_sym_if,
    ACTIONS(281), 1,
      anon_sym_for,
    ACTIONS(283), 1,
      anon_sym_while,
    ACTIONS(285), 1,
      anon_sym_repeat,
    ACTIONS(287), 1,
      anon_sym_QMARK,
    ACTIONS(289), 1,
      anon_sym_TILDE,
    ACTIONS(297), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(299), 1,
      sym__number_literal,
    ACTIONS(301), 1,
      anon_sym_SQUOTE,
    ACTIONS(303), 1,
      anon_sym_DQUOTE,
    ACTIONS(313), 1,
      sym__raw_string_literal,
    ACTIONS(315), 1,
      sym__external_open_parenthesis,
    ACTIONS(319), 1,
      sym__external_open_brace,
    ACTIONS(11159), 1,
      anon_sym_BANG,
    ACTIONS(13799), 1,
      sym_dot_dot_i,
    STATE(57), 1,
      sym__open_parenthesis,
    STATE(59), 1,
      sym__open_brace,
    STATE(2187), 1,
      sym__double_quoted_string,
    STATE(2188), 1,
      sym__single_quoted_string,
    STATE(2192), 1,
      sym_string,
    STATE(5139), 1,
      sym__string_or_identifier,
    ACTIONS(293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2189), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(307), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13797), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(687), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [157408] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13803), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13801), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4616), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [157531] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      sym_identifier,
    ACTIONS(55), 1,
      anon_sym_BSLASH,
    ACTIONS(57), 1,
      anon_sym_function,
    ACTIONS(61), 1,
      anon_sym_if,
    ACTIONS(63), 1,
      anon_sym_for,
    ACTIONS(65), 1,
      anon_sym_while,
    ACTIONS(67), 1,
      anon_sym_repeat,
    ACTIONS(69), 1,
      anon_sym_QMARK,
    ACTIONS(71), 1,
      anon_sym_TILDE,
    ACTIONS(79), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(81), 1,
      sym__number_literal,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE,
    ACTIONS(95), 1,
      sym__raw_string_literal,
    ACTIONS(97), 1,
      sym__external_open_parenthesis,
    ACTIONS(99), 1,
      sym__external_open_brace,
    ACTIONS(8831), 1,
      anon_sym_BANG,
    ACTIONS(13807), 1,
      sym_dot_dot_i,
    STATE(4), 1,
      sym__open_brace,
    STATE(19), 1,
      sym__open_parenthesis,
    STATE(1982), 1,
      sym_string,
    STATE(1985), 1,
      sym__single_quoted_string,
    STATE(1990), 1,
      sym__double_quoted_string,
    STATE(5151), 1,
      sym__string_or_identifier,
    ACTIONS(75), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1984), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(89), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13805), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(559), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [157654] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13811), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13809), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4620), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [157777] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13815), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13813), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4621), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [157900] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      sym_identifier,
    ACTIONS(55), 1,
      anon_sym_BSLASH,
    ACTIONS(57), 1,
      anon_sym_function,
    ACTIONS(61), 1,
      anon_sym_if,
    ACTIONS(63), 1,
      anon_sym_for,
    ACTIONS(65), 1,
      anon_sym_while,
    ACTIONS(67), 1,
      anon_sym_repeat,
    ACTIONS(69), 1,
      anon_sym_QMARK,
    ACTIONS(71), 1,
      anon_sym_TILDE,
    ACTIONS(79), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(81), 1,
      sym__number_literal,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE,
    ACTIONS(95), 1,
      sym__raw_string_literal,
    ACTIONS(97), 1,
      sym__external_open_parenthesis,
    ACTIONS(99), 1,
      sym__external_open_brace,
    ACTIONS(8831), 1,
      anon_sym_BANG,
    ACTIONS(13819), 1,
      sym_dot_dot_i,
    STATE(4), 1,
      sym__open_brace,
    STATE(19), 1,
      sym__open_parenthesis,
    STATE(1982), 1,
      sym_string,
    STATE(1985), 1,
      sym__single_quoted_string,
    STATE(1990), 1,
      sym__double_quoted_string,
    STATE(5151), 1,
      sym__string_or_identifier,
    ACTIONS(75), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1984), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(89), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13817), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(558), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [158023] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13823), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13821), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4466), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [158146] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13827), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13825), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4461), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [158269] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1337), 1,
      sym_identifier,
    ACTIONS(1339), 1,
      anon_sym_BSLASH,
    ACTIONS(1341), 1,
      anon_sym_function,
    ACTIONS(1343), 1,
      anon_sym_if,
    ACTIONS(1345), 1,
      anon_sym_for,
    ACTIONS(1347), 1,
      anon_sym_while,
    ACTIONS(1349), 1,
      anon_sym_repeat,
    ACTIONS(1351), 1,
      anon_sym_QMARK,
    ACTIONS(1353), 1,
      anon_sym_TILDE,
    ACTIONS(1361), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1363), 1,
      sym__number_literal,
    ACTIONS(1365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1367), 1,
      anon_sym_DQUOTE,
    ACTIONS(1377), 1,
      sym__raw_string_literal,
    ACTIONS(1379), 1,
      sym__external_open_parenthesis,
    ACTIONS(1383), 1,
      sym__external_open_brace,
    ACTIONS(9409), 1,
      anon_sym_BANG,
    ACTIONS(13831), 1,
      sym_dot_dot_i,
    STATE(94), 1,
      sym__open_brace,
    STATE(190), 1,
      sym__open_parenthesis,
    STATE(2231), 1,
      sym_string,
    STATE(2354), 1,
      sym__double_quoted_string,
    STATE(2355), 1,
      sym__single_quoted_string,
    STATE(5156), 1,
      sym__string_or_identifier,
    ACTIONS(1357), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2356), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1371), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13829), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1028), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [158392] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13835), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13833), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4630), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [158515] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1385), 1,
      sym_identifier,
    ACTIONS(1387), 1,
      anon_sym_BSLASH,
    ACTIONS(1389), 1,
      anon_sym_function,
    ACTIONS(1391), 1,
      anon_sym_if,
    ACTIONS(1393), 1,
      anon_sym_for,
    ACTIONS(1395), 1,
      anon_sym_while,
    ACTIONS(1397), 1,
      anon_sym_repeat,
    ACTIONS(1399), 1,
      anon_sym_QMARK,
    ACTIONS(1401), 1,
      anon_sym_TILDE,
    ACTIONS(1409), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(1411), 1,
      sym__number_literal,
    ACTIONS(1413), 1,
      anon_sym_SQUOTE,
    ACTIONS(1415), 1,
      anon_sym_DQUOTE,
    ACTIONS(1425), 1,
      sym__raw_string_literal,
    ACTIONS(1427), 1,
      sym__external_open_parenthesis,
    ACTIONS(1429), 1,
      sym__external_open_brace,
    ACTIONS(9251), 1,
      anon_sym_BANG,
    ACTIONS(13839), 1,
      sym_dot_dot_i,
    STATE(64), 1,
      sym__open_parenthesis,
    STATE(199), 1,
      sym__open_brace,
    STATE(2309), 1,
      sym__double_quoted_string,
    STATE(2310), 1,
      sym__single_quoted_string,
    STATE(2312), 1,
      sym_string,
    STATE(5134), 1,
      sym__string_or_identifier,
    ACTIONS(1405), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2311), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(1419), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13837), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1088), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [158638] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13843), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13841), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4631), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [158761] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13847), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13845), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4633), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [158884] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13851), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13849), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4646), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [159007] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      sym_identifier,
    ACTIONS(55), 1,
      anon_sym_BSLASH,
    ACTIONS(57), 1,
      anon_sym_function,
    ACTIONS(61), 1,
      anon_sym_if,
    ACTIONS(63), 1,
      anon_sym_for,
    ACTIONS(65), 1,
      anon_sym_while,
    ACTIONS(67), 1,
      anon_sym_repeat,
    ACTIONS(69), 1,
      anon_sym_QMARK,
    ACTIONS(71), 1,
      anon_sym_TILDE,
    ACTIONS(79), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(81), 1,
      sym__number_literal,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE,
    ACTIONS(95), 1,
      sym__raw_string_literal,
    ACTIONS(97), 1,
      sym__external_open_parenthesis,
    ACTIONS(99), 1,
      sym__external_open_brace,
    ACTIONS(8831), 1,
      anon_sym_BANG,
    ACTIONS(13855), 1,
      sym_dot_dot_i,
    STATE(4), 1,
      sym__open_brace,
    STATE(19), 1,
      sym__open_parenthesis,
    STATE(1982), 1,
      sym_string,
    STATE(1985), 1,
      sym__single_quoted_string,
    STATE(1990), 1,
      sym__double_quoted_string,
    STATE(5151), 1,
      sym__string_or_identifier,
    ACTIONS(75), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1984), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(89), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13853), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(555), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [159130] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13859), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13857), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4647), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [159253] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13863), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13861), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4595), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [159376] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13867), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13865), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4648), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [159499] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13871), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13869), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4480), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [159622] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      sym_identifier,
    ACTIONS(483), 1,
      anon_sym_BSLASH,
    ACTIONS(485), 1,
      anon_sym_function,
    ACTIONS(487), 1,
      anon_sym_if,
    ACTIONS(489), 1,
      anon_sym_for,
    ACTIONS(491), 1,
      anon_sym_while,
    ACTIONS(493), 1,
      anon_sym_repeat,
    ACTIONS(495), 1,
      anon_sym_QMARK,
    ACTIONS(497), 1,
      anon_sym_TILDE,
    ACTIONS(505), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(507), 1,
      sym__number_literal,
    ACTIONS(509), 1,
      anon_sym_SQUOTE,
    ACTIONS(511), 1,
      anon_sym_DQUOTE,
    ACTIONS(521), 1,
      sym__raw_string_literal,
    ACTIONS(523), 1,
      sym__external_open_parenthesis,
    ACTIONS(525), 1,
      sym__external_open_brace,
    ACTIONS(8515), 1,
      anon_sym_BANG,
    ACTIONS(13875), 1,
      sym_dot_dot_i,
    STATE(3), 1,
      sym__open_parenthesis,
    STATE(45), 1,
      sym__open_brace,
    STATE(2166), 1,
      sym_string,
    STATE(2200), 1,
      sym__single_quoted_string,
    STATE(2201), 1,
      sym__double_quoted_string,
    STATE(5154), 1,
      sym__string_or_identifier,
    ACTIONS(501), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2206), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(515), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13873), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(896), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [159745] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      sym_identifier,
    ACTIONS(483), 1,
      anon_sym_BSLASH,
    ACTIONS(485), 1,
      anon_sym_function,
    ACTIONS(487), 1,
      anon_sym_if,
    ACTIONS(489), 1,
      anon_sym_for,
    ACTIONS(491), 1,
      anon_sym_while,
    ACTIONS(493), 1,
      anon_sym_repeat,
    ACTIONS(495), 1,
      anon_sym_QMARK,
    ACTIONS(497), 1,
      anon_sym_TILDE,
    ACTIONS(505), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(507), 1,
      sym__number_literal,
    ACTIONS(509), 1,
      anon_sym_SQUOTE,
    ACTIONS(511), 1,
      anon_sym_DQUOTE,
    ACTIONS(521), 1,
      sym__raw_string_literal,
    ACTIONS(523), 1,
      sym__external_open_parenthesis,
    ACTIONS(525), 1,
      sym__external_open_brace,
    ACTIONS(8515), 1,
      anon_sym_BANG,
    ACTIONS(13879), 1,
      sym_dot_dot_i,
    STATE(3), 1,
      sym__open_parenthesis,
    STATE(45), 1,
      sym__open_brace,
    STATE(2166), 1,
      sym_string,
    STATE(2200), 1,
      sym__single_quoted_string,
    STATE(2201), 1,
      sym__double_quoted_string,
    STATE(5154), 1,
      sym__string_or_identifier,
    ACTIONS(501), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2206), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(515), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13877), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(890), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [159868] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      sym_identifier,
    ACTIONS(483), 1,
      anon_sym_BSLASH,
    ACTIONS(485), 1,
      anon_sym_function,
    ACTIONS(487), 1,
      anon_sym_if,
    ACTIONS(489), 1,
      anon_sym_for,
    ACTIONS(491), 1,
      anon_sym_while,
    ACTIONS(493), 1,
      anon_sym_repeat,
    ACTIONS(495), 1,
      anon_sym_QMARK,
    ACTIONS(497), 1,
      anon_sym_TILDE,
    ACTIONS(505), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(507), 1,
      sym__number_literal,
    ACTIONS(509), 1,
      anon_sym_SQUOTE,
    ACTIONS(511), 1,
      anon_sym_DQUOTE,
    ACTIONS(521), 1,
      sym__raw_string_literal,
    ACTIONS(523), 1,
      sym__external_open_parenthesis,
    ACTIONS(525), 1,
      sym__external_open_brace,
    ACTIONS(8515), 1,
      anon_sym_BANG,
    ACTIONS(13883), 1,
      sym_dot_dot_i,
    STATE(3), 1,
      sym__open_parenthesis,
    STATE(45), 1,
      sym__open_brace,
    STATE(2166), 1,
      sym_string,
    STATE(2200), 1,
      sym__single_quoted_string,
    STATE(2201), 1,
      sym__double_quoted_string,
    STATE(5154), 1,
      sym__string_or_identifier,
    ACTIONS(501), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2206), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(515), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13881), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(888), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [159991] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13887), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13885), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4551), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [160114] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      sym_identifier,
    ACTIONS(483), 1,
      anon_sym_BSLASH,
    ACTIONS(485), 1,
      anon_sym_function,
    ACTIONS(487), 1,
      anon_sym_if,
    ACTIONS(489), 1,
      anon_sym_for,
    ACTIONS(491), 1,
      anon_sym_while,
    ACTIONS(493), 1,
      anon_sym_repeat,
    ACTIONS(495), 1,
      anon_sym_QMARK,
    ACTIONS(497), 1,
      anon_sym_TILDE,
    ACTIONS(505), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(507), 1,
      sym__number_literal,
    ACTIONS(509), 1,
      anon_sym_SQUOTE,
    ACTIONS(511), 1,
      anon_sym_DQUOTE,
    ACTIONS(521), 1,
      sym__raw_string_literal,
    ACTIONS(523), 1,
      sym__external_open_parenthesis,
    ACTIONS(525), 1,
      sym__external_open_brace,
    ACTIONS(8515), 1,
      anon_sym_BANG,
    ACTIONS(13891), 1,
      sym_dot_dot_i,
    STATE(3), 1,
      sym__open_parenthesis,
    STATE(45), 1,
      sym__open_brace,
    STATE(2166), 1,
      sym_string,
    STATE(2200), 1,
      sym__single_quoted_string,
    STATE(2201), 1,
      sym__double_quoted_string,
    STATE(5154), 1,
      sym__string_or_identifier,
    ACTIONS(501), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2206), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(515), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13889), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(881), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [160237] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13895), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13893), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4554), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [160360] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(321), 1,
      sym_identifier,
    ACTIONS(323), 1,
      anon_sym_BSLASH,
    ACTIONS(325), 1,
      anon_sym_function,
    ACTIONS(327), 1,
      anon_sym_if,
    ACTIONS(329), 1,
      anon_sym_for,
    ACTIONS(331), 1,
      anon_sym_while,
    ACTIONS(333), 1,
      anon_sym_repeat,
    ACTIONS(335), 1,
      anon_sym_QMARK,
    ACTIONS(337), 1,
      anon_sym_TILDE,
    ACTIONS(345), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(347), 1,
      sym__number_literal,
    ACTIONS(349), 1,
      anon_sym_SQUOTE,
    ACTIONS(351), 1,
      anon_sym_DQUOTE,
    ACTIONS(361), 1,
      sym__raw_string_literal,
    ACTIONS(363), 1,
      sym__external_open_parenthesis,
    ACTIONS(365), 1,
      sym__external_open_brace,
    ACTIONS(10329), 1,
      anon_sym_BANG,
    ACTIONS(13899), 1,
      sym_dot_dot_i,
    STATE(24), 1,
      sym__open_brace,
    STATE(67), 1,
      sym__open_parenthesis,
    STATE(2169), 1,
      sym_string,
    STATE(2180), 1,
      sym__double_quoted_string,
    STATE(2181), 1,
      sym__single_quoted_string,
    STATE(5149), 1,
      sym__string_or_identifier,
    ACTIONS(341), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2183), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(355), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13897), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(813), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [160483] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13903), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13901), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4649), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [160606] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13907), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13905), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4570), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [160729] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13911), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13909), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4434), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [160852] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13915), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13913), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4644), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [160975] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2425), 1,
      sym_identifier,
    ACTIONS(2427), 1,
      anon_sym_BSLASH,
    ACTIONS(2429), 1,
      anon_sym_function,
    ACTIONS(2431), 1,
      anon_sym_if,
    ACTIONS(2433), 1,
      anon_sym_for,
    ACTIONS(2435), 1,
      anon_sym_while,
    ACTIONS(2437), 1,
      anon_sym_repeat,
    ACTIONS(2439), 1,
      anon_sym_QMARK,
    ACTIONS(2441), 1,
      anon_sym_TILDE,
    ACTIONS(2449), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2451), 1,
      sym__number_literal,
    ACTIONS(2453), 1,
      anon_sym_SQUOTE,
    ACTIONS(2455), 1,
      anon_sym_DQUOTE,
    ACTIONS(2465), 1,
      sym__raw_string_literal,
    ACTIONS(2467), 1,
      sym__external_open_parenthesis,
    ACTIONS(2471), 1,
      sym__external_open_brace,
    ACTIONS(7781), 1,
      anon_sym_BANG,
    ACTIONS(13919), 1,
      sym_dot_dot_i,
    STATE(97), 1,
      sym__open_brace,
    STATE(200), 1,
      sym__open_parenthesis,
    STATE(2369), 1,
      sym__double_quoted_string,
    STATE(2370), 1,
      sym__single_quoted_string,
    STATE(2372), 1,
      sym_string,
    STATE(5138), 1,
      sym__string_or_identifier,
    ACTIONS(2445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2371), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2459), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13917), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1681), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [161098] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13923), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13921), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4643), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [161221] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13927), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13925), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4642), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [161344] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13931), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13929), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4586), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [161467] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13935), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13933), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4478), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [161590] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13939), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13937), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4639), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [161713] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13943), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13941), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4619), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [161836] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13947), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13945), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4618), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [161959] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2943), 1,
      sym_identifier,
    ACTIONS(2945), 1,
      anon_sym_BSLASH,
    ACTIONS(2947), 1,
      anon_sym_function,
    ACTIONS(2949), 1,
      anon_sym_if,
    ACTIONS(2951), 1,
      anon_sym_for,
    ACTIONS(2953), 1,
      anon_sym_while,
    ACTIONS(2955), 1,
      anon_sym_repeat,
    ACTIONS(2957), 1,
      anon_sym_QMARK,
    ACTIONS(2959), 1,
      anon_sym_TILDE,
    ACTIONS(2967), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2969), 1,
      sym__number_literal,
    ACTIONS(2971), 1,
      anon_sym_SQUOTE,
    ACTIONS(2973), 1,
      anon_sym_DQUOTE,
    ACTIONS(2983), 1,
      sym__raw_string_literal,
    ACTIONS(2985), 1,
      sym__external_open_parenthesis,
    ACTIONS(2989), 1,
      sym__external_open_brace,
    ACTIONS(7797), 1,
      anon_sym_BANG,
    ACTIONS(13951), 1,
      sym_dot_dot_i,
    STATE(173), 1,
      sym__open_brace,
    STATE(246), 1,
      sym__open_parenthesis,
    STATE(2462), 1,
      sym__single_quoted_string,
    STATE(2494), 1,
      sym__double_quoted_string,
    STATE(2541), 1,
      sym_string,
    STATE(5128), 1,
      sym__string_or_identifier,
    ACTIONS(2963), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2540), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2977), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13949), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1854), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [162082] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13955), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13953), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4617), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [162205] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13959), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13957), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4640), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [162328] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13963), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13961), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4614), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [162451] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13967), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13965), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4503), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [162574] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13971), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13969), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4459), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [162697] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2826), 1,
      sym_identifier,
    ACTIONS(2828), 1,
      anon_sym_BSLASH,
    ACTIONS(2830), 1,
      anon_sym_function,
    ACTIONS(2832), 1,
      anon_sym_if,
    ACTIONS(2834), 1,
      anon_sym_for,
    ACTIONS(2836), 1,
      anon_sym_while,
    ACTIONS(2838), 1,
      anon_sym_repeat,
    ACTIONS(2840), 1,
      anon_sym_QMARK,
    ACTIONS(2842), 1,
      anon_sym_TILDE,
    ACTIONS(2850), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2852), 1,
      sym__number_literal,
    ACTIONS(2854), 1,
      anon_sym_SQUOTE,
    ACTIONS(2856), 1,
      anon_sym_DQUOTE,
    ACTIONS(2866), 1,
      sym__raw_string_literal,
    ACTIONS(2868), 1,
      sym__external_open_parenthesis,
    ACTIONS(2870), 1,
      sym__external_open_brace,
    ACTIONS(10915), 1,
      anon_sym_BANG,
    ACTIONS(13975), 1,
      sym_dot_dot_i,
    STATE(178), 1,
      sym__open_parenthesis,
    STATE(244), 1,
      sym__open_brace,
    STATE(2522), 1,
      sym_string,
    STATE(2528), 1,
      sym__single_quoted_string,
    STATE(2529), 1,
      sym__double_quoted_string,
    STATE(5126), 1,
      sym__string_or_identifier,
    ACTIONS(2846), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2523), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2860), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13973), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1471), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [162820] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13979), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13977), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4594), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [162943] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13983), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13981), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4587), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [163066] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3678), 1,
      sym_identifier,
    ACTIONS(3680), 1,
      anon_sym_BSLASH,
    ACTIONS(3682), 1,
      anon_sym_function,
    ACTIONS(3684), 1,
      anon_sym_if,
    ACTIONS(3686), 1,
      anon_sym_for,
    ACTIONS(3688), 1,
      anon_sym_while,
    ACTIONS(3690), 1,
      anon_sym_repeat,
    ACTIONS(3692), 1,
      anon_sym_QMARK,
    ACTIONS(3694), 1,
      anon_sym_TILDE,
    ACTIONS(3702), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3704), 1,
      sym__number_literal,
    ACTIONS(3706), 1,
      anon_sym_SQUOTE,
    ACTIONS(3708), 1,
      anon_sym_DQUOTE,
    ACTIONS(3718), 1,
      sym__raw_string_literal,
    ACTIONS(3720), 1,
      sym__external_open_parenthesis,
    ACTIONS(3722), 1,
      sym__external_open_brace,
    ACTIONS(8593), 1,
      anon_sym_BANG,
    ACTIONS(13987), 1,
      sym_dot_dot_i,
    STATE(29), 1,
      sym__open_brace,
    STATE(191), 1,
      sym__open_parenthesis,
    STATE(2378), 1,
      sym_string,
    STATE(2382), 1,
      sym__single_quoted_string,
    STATE(2383), 1,
      sym__double_quoted_string,
    STATE(5153), 1,
      sym__string_or_identifier,
    ACTIONS(3698), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2381), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3712), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13985), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1474), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [163189] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3678), 1,
      sym_identifier,
    ACTIONS(3680), 1,
      anon_sym_BSLASH,
    ACTIONS(3682), 1,
      anon_sym_function,
    ACTIONS(3684), 1,
      anon_sym_if,
    ACTIONS(3686), 1,
      anon_sym_for,
    ACTIONS(3688), 1,
      anon_sym_while,
    ACTIONS(3690), 1,
      anon_sym_repeat,
    ACTIONS(3692), 1,
      anon_sym_QMARK,
    ACTIONS(3694), 1,
      anon_sym_TILDE,
    ACTIONS(3702), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3704), 1,
      sym__number_literal,
    ACTIONS(3706), 1,
      anon_sym_SQUOTE,
    ACTIONS(3708), 1,
      anon_sym_DQUOTE,
    ACTIONS(3718), 1,
      sym__raw_string_literal,
    ACTIONS(3720), 1,
      sym__external_open_parenthesis,
    ACTIONS(3722), 1,
      sym__external_open_brace,
    ACTIONS(8593), 1,
      anon_sym_BANG,
    ACTIONS(13991), 1,
      sym_dot_dot_i,
    STATE(29), 1,
      sym__open_brace,
    STATE(191), 1,
      sym__open_parenthesis,
    STATE(2378), 1,
      sym_string,
    STATE(2382), 1,
      sym__single_quoted_string,
    STATE(2383), 1,
      sym__double_quoted_string,
    STATE(5153), 1,
      sym__string_or_identifier,
    ACTIONS(3698), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2381), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3712), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13989), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1459), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [163312] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13995), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13993), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4558), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [163435] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(13999), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(13997), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4593), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [163558] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(14003), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(14001), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4611), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [163681] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(14007), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(14005), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4590), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [163804] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(14011), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(14009), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4458), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [163927] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(14015), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(14013), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4626), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [164050] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(14019), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(14017), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4606), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [164173] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3678), 1,
      sym_identifier,
    ACTIONS(3680), 1,
      anon_sym_BSLASH,
    ACTIONS(3682), 1,
      anon_sym_function,
    ACTIONS(3684), 1,
      anon_sym_if,
    ACTIONS(3686), 1,
      anon_sym_for,
    ACTIONS(3688), 1,
      anon_sym_while,
    ACTIONS(3690), 1,
      anon_sym_repeat,
    ACTIONS(3692), 1,
      anon_sym_QMARK,
    ACTIONS(3694), 1,
      anon_sym_TILDE,
    ACTIONS(3702), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3704), 1,
      sym__number_literal,
    ACTIONS(3706), 1,
      anon_sym_SQUOTE,
    ACTIONS(3708), 1,
      anon_sym_DQUOTE,
    ACTIONS(3718), 1,
      sym__raw_string_literal,
    ACTIONS(3720), 1,
      sym__external_open_parenthesis,
    ACTIONS(3722), 1,
      sym__external_open_brace,
    ACTIONS(8593), 1,
      anon_sym_BANG,
    ACTIONS(14023), 1,
      sym_dot_dot_i,
    STATE(29), 1,
      sym__open_brace,
    STATE(191), 1,
      sym__open_parenthesis,
    STATE(2378), 1,
      sym_string,
    STATE(2382), 1,
      sym__single_quoted_string,
    STATE(2383), 1,
      sym__double_quoted_string,
    STATE(5153), 1,
      sym__string_or_identifier,
    ACTIONS(3698), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2381), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3712), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(14021), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1457), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [164296] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(14027), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(14025), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4592), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [164419] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(14031), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(14029), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4445), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [164542] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(14035), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(14033), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4448), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [164665] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(14039), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(14037), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4589), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [164788] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2531), 1,
      sym_identifier,
    ACTIONS(2533), 1,
      anon_sym_BSLASH,
    ACTIONS(2535), 1,
      anon_sym_function,
    ACTIONS(2537), 1,
      anon_sym_if,
    ACTIONS(2539), 1,
      anon_sym_for,
    ACTIONS(2541), 1,
      anon_sym_while,
    ACTIONS(2543), 1,
      anon_sym_repeat,
    ACTIONS(2545), 1,
      anon_sym_QMARK,
    ACTIONS(2547), 1,
      anon_sym_TILDE,
    ACTIONS(2555), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2557), 1,
      sym__number_literal,
    ACTIONS(2559), 1,
      anon_sym_SQUOTE,
    ACTIONS(2561), 1,
      anon_sym_DQUOTE,
    ACTIONS(2571), 1,
      sym__raw_string_literal,
    ACTIONS(2573), 1,
      sym__external_open_parenthesis,
    ACTIONS(2577), 1,
      sym__external_open_brace,
    ACTIONS(9611), 1,
      anon_sym_BANG,
    ACTIONS(14043), 1,
      sym_dot_dot_i,
    STATE(70), 1,
      sym__open_brace,
    STATE(213), 1,
      sym__open_parenthesis,
    STATE(2437), 1,
      sym__double_quoted_string,
    STATE(2442), 1,
      sym__single_quoted_string,
    STATE(2530), 1,
      sym_string,
    STATE(5133), 1,
      sym__string_or_identifier,
    ACTIONS(2551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2445), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2565), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(14041), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1472), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [164911] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(14047), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(14045), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4569), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [165034] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(14051), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(14049), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4568), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [165157] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2531), 1,
      sym_identifier,
    ACTIONS(2533), 1,
      anon_sym_BSLASH,
    ACTIONS(2535), 1,
      anon_sym_function,
    ACTIONS(2537), 1,
      anon_sym_if,
    ACTIONS(2539), 1,
      anon_sym_for,
    ACTIONS(2541), 1,
      anon_sym_while,
    ACTIONS(2543), 1,
      anon_sym_repeat,
    ACTIONS(2545), 1,
      anon_sym_QMARK,
    ACTIONS(2547), 1,
      anon_sym_TILDE,
    ACTIONS(2555), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2557), 1,
      sym__number_literal,
    ACTIONS(2559), 1,
      anon_sym_SQUOTE,
    ACTIONS(2561), 1,
      anon_sym_DQUOTE,
    ACTIONS(2571), 1,
      sym__raw_string_literal,
    ACTIONS(2573), 1,
      sym__external_open_parenthesis,
    ACTIONS(2577), 1,
      sym__external_open_brace,
    ACTIONS(9611), 1,
      anon_sym_BANG,
    ACTIONS(14055), 1,
      sym_dot_dot_i,
    STATE(70), 1,
      sym__open_brace,
    STATE(213), 1,
      sym__open_parenthesis,
    STATE(2437), 1,
      sym__double_quoted_string,
    STATE(2442), 1,
      sym__single_quoted_string,
    STATE(2530), 1,
      sym_string,
    STATE(5133), 1,
      sym__string_or_identifier,
    ACTIONS(2551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2445), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2565), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(14053), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1467), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [165280] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(14059), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(14057), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4567), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [165403] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(14063), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(14061), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4605), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [165526] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(14067), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(14065), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4564), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [165649] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2531), 1,
      sym_identifier,
    ACTIONS(2533), 1,
      anon_sym_BSLASH,
    ACTIONS(2535), 1,
      anon_sym_function,
    ACTIONS(2537), 1,
      anon_sym_if,
    ACTIONS(2539), 1,
      anon_sym_for,
    ACTIONS(2541), 1,
      anon_sym_while,
    ACTIONS(2543), 1,
      anon_sym_repeat,
    ACTIONS(2545), 1,
      anon_sym_QMARK,
    ACTIONS(2547), 1,
      anon_sym_TILDE,
    ACTIONS(2555), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2557), 1,
      sym__number_literal,
    ACTIONS(2559), 1,
      anon_sym_SQUOTE,
    ACTIONS(2561), 1,
      anon_sym_DQUOTE,
    ACTIONS(2571), 1,
      sym__raw_string_literal,
    ACTIONS(2573), 1,
      sym__external_open_parenthesis,
    ACTIONS(2577), 1,
      sym__external_open_brace,
    ACTIONS(9611), 1,
      anon_sym_BANG,
    ACTIONS(14071), 1,
      sym_dot_dot_i,
    STATE(70), 1,
      sym__open_brace,
    STATE(213), 1,
      sym__open_parenthesis,
    STATE(2437), 1,
      sym__double_quoted_string,
    STATE(2442), 1,
      sym__single_quoted_string,
    STATE(2530), 1,
      sym_string,
    STATE(5133), 1,
      sym__string_or_identifier,
    ACTIONS(2551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2445), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2565), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(14069), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1466), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [165772] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(14075), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(14073), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4544), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [165895] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(14079), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(14077), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4540), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [166018] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3678), 1,
      sym_identifier,
    ACTIONS(3680), 1,
      anon_sym_BSLASH,
    ACTIONS(3682), 1,
      anon_sym_function,
    ACTIONS(3684), 1,
      anon_sym_if,
    ACTIONS(3686), 1,
      anon_sym_for,
    ACTIONS(3688), 1,
      anon_sym_while,
    ACTIONS(3690), 1,
      anon_sym_repeat,
    ACTIONS(3692), 1,
      anon_sym_QMARK,
    ACTIONS(3694), 1,
      anon_sym_TILDE,
    ACTIONS(3702), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(3704), 1,
      sym__number_literal,
    ACTIONS(3706), 1,
      anon_sym_SQUOTE,
    ACTIONS(3708), 1,
      anon_sym_DQUOTE,
    ACTIONS(3718), 1,
      sym__raw_string_literal,
    ACTIONS(3720), 1,
      sym__external_open_parenthesis,
    ACTIONS(3722), 1,
      sym__external_open_brace,
    ACTIONS(8593), 1,
      anon_sym_BANG,
    ACTIONS(14083), 1,
      sym_dot_dot_i,
    STATE(29), 1,
      sym__open_brace,
    STATE(191), 1,
      sym__open_parenthesis,
    STATE(2378), 1,
      sym_string,
    STATE(2382), 1,
      sym__single_quoted_string,
    STATE(2383), 1,
      sym__double_quoted_string,
    STATE(5153), 1,
      sym__string_or_identifier,
    ACTIONS(3698), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2381), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(3712), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(14081), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1449), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [166141] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2531), 1,
      sym_identifier,
    ACTIONS(2533), 1,
      anon_sym_BSLASH,
    ACTIONS(2535), 1,
      anon_sym_function,
    ACTIONS(2537), 1,
      anon_sym_if,
    ACTIONS(2539), 1,
      anon_sym_for,
    ACTIONS(2541), 1,
      anon_sym_while,
    ACTIONS(2543), 1,
      anon_sym_repeat,
    ACTIONS(2545), 1,
      anon_sym_QMARK,
    ACTIONS(2547), 1,
      anon_sym_TILDE,
    ACTIONS(2555), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2557), 1,
      sym__number_literal,
    ACTIONS(2559), 1,
      anon_sym_SQUOTE,
    ACTIONS(2561), 1,
      anon_sym_DQUOTE,
    ACTIONS(2571), 1,
      sym__raw_string_literal,
    ACTIONS(2573), 1,
      sym__external_open_parenthesis,
    ACTIONS(2577), 1,
      sym__external_open_brace,
    ACTIONS(9611), 1,
      anon_sym_BANG,
    ACTIONS(14087), 1,
      sym_dot_dot_i,
    STATE(70), 1,
      sym__open_brace,
    STATE(213), 1,
      sym__open_parenthesis,
    STATE(2437), 1,
      sym__double_quoted_string,
    STATE(2442), 1,
      sym__single_quoted_string,
    STATE(2530), 1,
      sym_string,
    STATE(5133), 1,
      sym__string_or_identifier,
    ACTIONS(2551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2445), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2565), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(14085), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1458), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [166264] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(14091), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(14089), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4449), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [166387] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(273), 1,
      sym_identifier,
    ACTIONS(275), 1,
      anon_sym_BSLASH,
    ACTIONS(277), 1,
      anon_sym_function,
    ACTIONS(279), 1,
      anon_sym_if,
    ACTIONS(281), 1,
      anon_sym_for,
    ACTIONS(283), 1,
      anon_sym_while,
    ACTIONS(285), 1,
      anon_sym_repeat,
    ACTIONS(287), 1,
      anon_sym_QMARK,
    ACTIONS(289), 1,
      anon_sym_TILDE,
    ACTIONS(297), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(299), 1,
      sym__number_literal,
    ACTIONS(301), 1,
      anon_sym_SQUOTE,
    ACTIONS(303), 1,
      anon_sym_DQUOTE,
    ACTIONS(313), 1,
      sym__raw_string_literal,
    ACTIONS(315), 1,
      sym__external_open_parenthesis,
    ACTIONS(319), 1,
      sym__external_open_brace,
    ACTIONS(11159), 1,
      anon_sym_BANG,
    ACTIONS(14095), 1,
      sym_dot_dot_i,
    STATE(57), 1,
      sym__open_parenthesis,
    STATE(59), 1,
      sym__open_brace,
    STATE(2187), 1,
      sym__double_quoted_string,
    STATE(2188), 1,
      sym__single_quoted_string,
    STATE(2192), 1,
      sym_string,
    STATE(5139), 1,
      sym__string_or_identifier,
    ACTIONS(293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2189), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(307), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(14093), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(684), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [166510] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(273), 1,
      sym_identifier,
    ACTIONS(275), 1,
      anon_sym_BSLASH,
    ACTIONS(277), 1,
      anon_sym_function,
    ACTIONS(279), 1,
      anon_sym_if,
    ACTIONS(281), 1,
      anon_sym_for,
    ACTIONS(283), 1,
      anon_sym_while,
    ACTIONS(285), 1,
      anon_sym_repeat,
    ACTIONS(287), 1,
      anon_sym_QMARK,
    ACTIONS(289), 1,
      anon_sym_TILDE,
    ACTIONS(297), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(299), 1,
      sym__number_literal,
    ACTIONS(301), 1,
      anon_sym_SQUOTE,
    ACTIONS(303), 1,
      anon_sym_DQUOTE,
    ACTIONS(313), 1,
      sym__raw_string_literal,
    ACTIONS(315), 1,
      sym__external_open_parenthesis,
    ACTIONS(319), 1,
      sym__external_open_brace,
    ACTIONS(11159), 1,
      anon_sym_BANG,
    ACTIONS(14099), 1,
      sym_dot_dot_i,
    STATE(57), 1,
      sym__open_parenthesis,
    STATE(59), 1,
      sym__open_brace,
    STATE(2187), 1,
      sym__double_quoted_string,
    STATE(2188), 1,
      sym__single_quoted_string,
    STATE(2192), 1,
      sym_string,
    STATE(5139), 1,
      sym__string_or_identifier,
    ACTIONS(293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2189), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(307), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(14097), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(683), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [166633] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(14103), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(14101), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4545), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [166756] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(14107), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(14105), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4450), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [166879] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(14111), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(14109), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4547), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [167002] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(14115), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(14113), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4543), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [167125] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(14119), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(14117), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4464), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [167248] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(14123), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(14121), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4548), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [167371] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(14127), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(14125), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4636), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [167494] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(14131), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(14129), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4542), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [167617] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(14135), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(14133), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4539), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [167740] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(14139), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(14137), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4637), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [167863] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2943), 1,
      sym_identifier,
    ACTIONS(2945), 1,
      anon_sym_BSLASH,
    ACTIONS(2947), 1,
      anon_sym_function,
    ACTIONS(2949), 1,
      anon_sym_if,
    ACTIONS(2951), 1,
      anon_sym_for,
    ACTIONS(2953), 1,
      anon_sym_while,
    ACTIONS(2955), 1,
      anon_sym_repeat,
    ACTIONS(2957), 1,
      anon_sym_QMARK,
    ACTIONS(2959), 1,
      anon_sym_TILDE,
    ACTIONS(2967), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2969), 1,
      sym__number_literal,
    ACTIONS(2971), 1,
      anon_sym_SQUOTE,
    ACTIONS(2973), 1,
      anon_sym_DQUOTE,
    ACTIONS(2983), 1,
      sym__raw_string_literal,
    ACTIONS(2985), 1,
      sym__external_open_parenthesis,
    ACTIONS(2989), 1,
      sym__external_open_brace,
    ACTIONS(7797), 1,
      anon_sym_BANG,
    ACTIONS(14143), 1,
      sym_dot_dot_i,
    STATE(173), 1,
      sym__open_brace,
    STATE(246), 1,
      sym__open_parenthesis,
    STATE(2462), 1,
      sym__single_quoted_string,
    STATE(2494), 1,
      sym__double_quoted_string,
    STATE(2541), 1,
      sym_string,
    STATE(5128), 1,
      sym__string_or_identifier,
    ACTIONS(2963), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2540), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2977), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(14141), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1872), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [167986] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(14147), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(14145), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4650), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [168109] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(14151), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(14149), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4519), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [168232] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(14155), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(14153), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4467), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [168355] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2943), 1,
      sym_identifier,
    ACTIONS(2945), 1,
      anon_sym_BSLASH,
    ACTIONS(2947), 1,
      anon_sym_function,
    ACTIONS(2949), 1,
      anon_sym_if,
    ACTIONS(2951), 1,
      anon_sym_for,
    ACTIONS(2953), 1,
      anon_sym_while,
    ACTIONS(2955), 1,
      anon_sym_repeat,
    ACTIONS(2957), 1,
      anon_sym_QMARK,
    ACTIONS(2959), 1,
      anon_sym_TILDE,
    ACTIONS(2967), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2969), 1,
      sym__number_literal,
    ACTIONS(2971), 1,
      anon_sym_SQUOTE,
    ACTIONS(2973), 1,
      anon_sym_DQUOTE,
    ACTIONS(2983), 1,
      sym__raw_string_literal,
    ACTIONS(2985), 1,
      sym__external_open_parenthesis,
    ACTIONS(2989), 1,
      sym__external_open_brace,
    ACTIONS(7797), 1,
      anon_sym_BANG,
    ACTIONS(14159), 1,
      sym_dot_dot_i,
    STATE(173), 1,
      sym__open_brace,
    STATE(246), 1,
      sym__open_parenthesis,
    STATE(2462), 1,
      sym__single_quoted_string,
    STATE(2494), 1,
      sym__double_quoted_string,
    STATE(2541), 1,
      sym_string,
    STATE(5128), 1,
      sym__string_or_identifier,
    ACTIONS(2963), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2540), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2977), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(14157), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1870), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [168478] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(14163), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(14161), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4518), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [168601] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(14167), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(14165), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4468), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [168724] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(14171), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(14169), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4517), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [168847] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4214), 1,
      sym_identifier,
    ACTIONS(4216), 1,
      anon_sym_BSLASH,
    ACTIONS(4218), 1,
      anon_sym_function,
    ACTIONS(4220), 1,
      anon_sym_if,
    ACTIONS(4222), 1,
      anon_sym_for,
    ACTIONS(4224), 1,
      anon_sym_while,
    ACTIONS(4226), 1,
      anon_sym_repeat,
    ACTIONS(4228), 1,
      anon_sym_QMARK,
    ACTIONS(4230), 1,
      anon_sym_TILDE,
    ACTIONS(4238), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4240), 1,
      sym__number_literal,
    ACTIONS(4242), 1,
      anon_sym_SQUOTE,
    ACTIONS(4244), 1,
      anon_sym_DQUOTE,
    ACTIONS(4254), 1,
      sym__raw_string_literal,
    ACTIONS(4256), 1,
      sym__external_open_parenthesis,
    ACTIONS(4258), 1,
      sym__external_open_brace,
    ACTIONS(9229), 1,
      anon_sym_BANG,
    ACTIONS(14175), 1,
      sym_dot_dot_i,
    STATE(51), 1,
      sym__open_brace,
    STATE(287), 1,
      sym__open_parenthesis,
    STATE(4674), 1,
      sym__single_quoted_string,
    STATE(4678), 1,
      sym__double_quoted_string,
    STATE(4681), 1,
      sym_string,
    STATE(5129), 1,
      sym__string_or_identifier,
    ACTIONS(4234), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4680), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4248), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(14173), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4414), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [168970] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(14179), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(14177), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4623), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [169093] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2943), 1,
      sym_identifier,
    ACTIONS(2945), 1,
      anon_sym_BSLASH,
    ACTIONS(2947), 1,
      anon_sym_function,
    ACTIONS(2949), 1,
      anon_sym_if,
    ACTIONS(2951), 1,
      anon_sym_for,
    ACTIONS(2953), 1,
      anon_sym_while,
    ACTIONS(2955), 1,
      anon_sym_repeat,
    ACTIONS(2957), 1,
      anon_sym_QMARK,
    ACTIONS(2959), 1,
      anon_sym_TILDE,
    ACTIONS(2967), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(2969), 1,
      sym__number_literal,
    ACTIONS(2971), 1,
      anon_sym_SQUOTE,
    ACTIONS(2973), 1,
      anon_sym_DQUOTE,
    ACTIONS(2983), 1,
      sym__raw_string_literal,
    ACTIONS(2985), 1,
      sym__external_open_parenthesis,
    ACTIONS(2989), 1,
      sym__external_open_brace,
    ACTIONS(7797), 1,
      anon_sym_BANG,
    ACTIONS(14183), 1,
      sym_dot_dot_i,
    STATE(173), 1,
      sym__open_brace,
    STATE(246), 1,
      sym__open_parenthesis,
    STATE(2462), 1,
      sym__single_quoted_string,
    STATE(2494), 1,
      sym__double_quoted_string,
    STATE(2541), 1,
      sym_string,
    STATE(5128), 1,
      sym__string_or_identifier,
    ACTIONS(2963), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2540), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(2977), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(14181), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1878), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [169216] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(14187), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(14185), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4651), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [169339] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4214), 1,
      sym_identifier,
    ACTIONS(4216), 1,
      anon_sym_BSLASH,
    ACTIONS(4218), 1,
      anon_sym_function,
    ACTIONS(4220), 1,
      anon_sym_if,
    ACTIONS(4222), 1,
      anon_sym_for,
    ACTIONS(4224), 1,
      anon_sym_while,
    ACTIONS(4226), 1,
      anon_sym_repeat,
    ACTIONS(4228), 1,
      anon_sym_QMARK,
    ACTIONS(4230), 1,
      anon_sym_TILDE,
    ACTIONS(4238), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4240), 1,
      sym__number_literal,
    ACTIONS(4242), 1,
      anon_sym_SQUOTE,
    ACTIONS(4244), 1,
      anon_sym_DQUOTE,
    ACTIONS(4254), 1,
      sym__raw_string_literal,
    ACTIONS(4256), 1,
      sym__external_open_parenthesis,
    ACTIONS(4258), 1,
      sym__external_open_brace,
    ACTIONS(9229), 1,
      anon_sym_BANG,
    ACTIONS(14191), 1,
      sym_dot_dot_i,
    STATE(51), 1,
      sym__open_brace,
    STATE(287), 1,
      sym__open_parenthesis,
    STATE(4674), 1,
      sym__single_quoted_string,
    STATE(4678), 1,
      sym__double_quoted_string,
    STATE(4681), 1,
      sym_string,
    STATE(5129), 1,
      sym__string_or_identifier,
    ACTIONS(4234), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4680), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4248), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(14189), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4401), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [169462] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(14195), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(14193), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4514), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [169585] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(14199), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(14197), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4469), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [169708] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(14203), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(14201), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4624), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [169831] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(321), 1,
      sym_identifier,
    ACTIONS(323), 1,
      anon_sym_BSLASH,
    ACTIONS(325), 1,
      anon_sym_function,
    ACTIONS(327), 1,
      anon_sym_if,
    ACTIONS(329), 1,
      anon_sym_for,
    ACTIONS(331), 1,
      anon_sym_while,
    ACTIONS(333), 1,
      anon_sym_repeat,
    ACTIONS(335), 1,
      anon_sym_QMARK,
    ACTIONS(337), 1,
      anon_sym_TILDE,
    ACTIONS(345), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(347), 1,
      sym__number_literal,
    ACTIONS(349), 1,
      anon_sym_SQUOTE,
    ACTIONS(351), 1,
      anon_sym_DQUOTE,
    ACTIONS(361), 1,
      sym__raw_string_literal,
    ACTIONS(363), 1,
      sym__external_open_parenthesis,
    ACTIONS(365), 1,
      sym__external_open_brace,
    ACTIONS(10329), 1,
      anon_sym_BANG,
    ACTIONS(14207), 1,
      sym_dot_dot_i,
    STATE(24), 1,
      sym__open_brace,
    STATE(67), 1,
      sym__open_parenthesis,
    STATE(2169), 1,
      sym_string,
    STATE(2180), 1,
      sym__double_quoted_string,
    STATE(2181), 1,
      sym__single_quoted_string,
    STATE(5149), 1,
      sym__string_or_identifier,
    ACTIONS(341), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2183), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(355), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(14205), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(831), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [169954] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(14211), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(14209), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4625), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [170077] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(14215), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(14213), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4494), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [170200] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(321), 1,
      sym_identifier,
    ACTIONS(323), 1,
      anon_sym_BSLASH,
    ACTIONS(325), 1,
      anon_sym_function,
    ACTIONS(327), 1,
      anon_sym_if,
    ACTIONS(329), 1,
      anon_sym_for,
    ACTIONS(331), 1,
      anon_sym_while,
    ACTIONS(333), 1,
      anon_sym_repeat,
    ACTIONS(335), 1,
      anon_sym_QMARK,
    ACTIONS(337), 1,
      anon_sym_TILDE,
    ACTIONS(345), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(347), 1,
      sym__number_literal,
    ACTIONS(349), 1,
      anon_sym_SQUOTE,
    ACTIONS(351), 1,
      anon_sym_DQUOTE,
    ACTIONS(361), 1,
      sym__raw_string_literal,
    ACTIONS(363), 1,
      sym__external_open_parenthesis,
    ACTIONS(365), 1,
      sym__external_open_brace,
    ACTIONS(10329), 1,
      anon_sym_BANG,
    ACTIONS(14219), 1,
      sym_dot_dot_i,
    STATE(24), 1,
      sym__open_brace,
    STATE(67), 1,
      sym__open_parenthesis,
    STATE(2169), 1,
      sym_string,
    STATE(2180), 1,
      sym__double_quoted_string,
    STATE(2181), 1,
      sym__single_quoted_string,
    STATE(5149), 1,
      sym__string_or_identifier,
    ACTIONS(341), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2183), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(355), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(14217), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(823), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [170323] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(14223), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(14221), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4627), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [170446] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(321), 1,
      sym_identifier,
    ACTIONS(323), 1,
      anon_sym_BSLASH,
    ACTIONS(325), 1,
      anon_sym_function,
    ACTIONS(327), 1,
      anon_sym_if,
    ACTIONS(329), 1,
      anon_sym_for,
    ACTIONS(331), 1,
      anon_sym_while,
    ACTIONS(333), 1,
      anon_sym_repeat,
    ACTIONS(335), 1,
      anon_sym_QMARK,
    ACTIONS(337), 1,
      anon_sym_TILDE,
    ACTIONS(345), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(347), 1,
      sym__number_literal,
    ACTIONS(349), 1,
      anon_sym_SQUOTE,
    ACTIONS(351), 1,
      anon_sym_DQUOTE,
    ACTIONS(361), 1,
      sym__raw_string_literal,
    ACTIONS(363), 1,
      sym__external_open_parenthesis,
    ACTIONS(365), 1,
      sym__external_open_brace,
    ACTIONS(10329), 1,
      anon_sym_BANG,
    ACTIONS(14227), 1,
      sym_dot_dot_i,
    STATE(24), 1,
      sym__open_brace,
    STATE(67), 1,
      sym__open_parenthesis,
    STATE(2169), 1,
      sym_string,
    STATE(2180), 1,
      sym__double_quoted_string,
    STATE(2181), 1,
      sym__single_quoted_string,
    STATE(5149), 1,
      sym__string_or_identifier,
    ACTIONS(341), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2183), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(355), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(14225), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(822), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [170569] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(14231), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(14229), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4489), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [170692] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4214), 1,
      sym_identifier,
    ACTIONS(4216), 1,
      anon_sym_BSLASH,
    ACTIONS(4218), 1,
      anon_sym_function,
    ACTIONS(4220), 1,
      anon_sym_if,
    ACTIONS(4222), 1,
      anon_sym_for,
    ACTIONS(4224), 1,
      anon_sym_while,
    ACTIONS(4226), 1,
      anon_sym_repeat,
    ACTIONS(4228), 1,
      anon_sym_QMARK,
    ACTIONS(4230), 1,
      anon_sym_TILDE,
    ACTIONS(4238), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4240), 1,
      sym__number_literal,
    ACTIONS(4242), 1,
      anon_sym_SQUOTE,
    ACTIONS(4244), 1,
      anon_sym_DQUOTE,
    ACTIONS(4254), 1,
      sym__raw_string_literal,
    ACTIONS(4256), 1,
      sym__external_open_parenthesis,
    ACTIONS(4258), 1,
      sym__external_open_brace,
    ACTIONS(9229), 1,
      anon_sym_BANG,
    ACTIONS(14235), 1,
      sym_dot_dot_i,
    STATE(51), 1,
      sym__open_brace,
    STATE(287), 1,
      sym__open_parenthesis,
    STATE(4674), 1,
      sym__single_quoted_string,
    STATE(4678), 1,
      sym__double_quoted_string,
    STATE(4681), 1,
      sym_string,
    STATE(5129), 1,
      sym__string_or_identifier,
    ACTIONS(4234), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4680), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4248), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(14233), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4426), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [170815] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(14239), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(14237), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4493), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [170938] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4214), 1,
      sym_identifier,
    ACTIONS(4216), 1,
      anon_sym_BSLASH,
    ACTIONS(4218), 1,
      anon_sym_function,
    ACTIONS(4220), 1,
      anon_sym_if,
    ACTIONS(4222), 1,
      anon_sym_for,
    ACTIONS(4224), 1,
      anon_sym_while,
    ACTIONS(4226), 1,
      anon_sym_repeat,
    ACTIONS(4228), 1,
      anon_sym_QMARK,
    ACTIONS(4230), 1,
      anon_sym_TILDE,
    ACTIONS(4238), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4240), 1,
      sym__number_literal,
    ACTIONS(4242), 1,
      anon_sym_SQUOTE,
    ACTIONS(4244), 1,
      anon_sym_DQUOTE,
    ACTIONS(4254), 1,
      sym__raw_string_literal,
    ACTIONS(4256), 1,
      sym__external_open_parenthesis,
    ACTIONS(4258), 1,
      sym__external_open_brace,
    ACTIONS(9229), 1,
      anon_sym_BANG,
    ACTIONS(14243), 1,
      sym_dot_dot_i,
    STATE(51), 1,
      sym__open_brace,
    STATE(287), 1,
      sym__open_parenthesis,
    STATE(4674), 1,
      sym__single_quoted_string,
    STATE(4678), 1,
      sym__double_quoted_string,
    STATE(4681), 1,
      sym_string,
    STATE(5129), 1,
      sym__string_or_identifier,
    ACTIONS(4234), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4680), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4248), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(14241), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4429), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [171061] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_BSLASH,
    ACTIONS(4594), 1,
      anon_sym_function,
    ACTIONS(4596), 1,
      anon_sym_if,
    ACTIONS(4598), 1,
      anon_sym_for,
    ACTIONS(4600), 1,
      anon_sym_while,
    ACTIONS(4602), 1,
      anon_sym_repeat,
    ACTIONS(4604), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_TILDE,
    ACTIONS(4614), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(4616), 1,
      sym__number_literal,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(4632), 1,
      sym__external_open_parenthesis,
    ACTIONS(4634), 1,
      sym__external_open_brace,
    ACTIONS(9263), 1,
      anon_sym_BANG,
    ACTIONS(14247), 1,
      sym_dot_dot_i,
    STATE(153), 1,
      sym__open_brace,
    STATE(402), 1,
      sym__open_parenthesis,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4689), 1,
      sym_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(5155), 1,
      sym__string_or_identifier,
    ACTIONS(4610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(4690), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(4624), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(14245), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4492), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [171184] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(273), 1,
      sym_identifier,
    ACTIONS(275), 1,
      anon_sym_BSLASH,
    ACTIONS(277), 1,
      anon_sym_function,
    ACTIONS(279), 1,
      anon_sym_if,
    ACTIONS(281), 1,
      anon_sym_for,
    ACTIONS(283), 1,
      anon_sym_while,
    ACTIONS(285), 1,
      anon_sym_repeat,
    ACTIONS(287), 1,
      anon_sym_QMARK,
    ACTIONS(289), 1,
      anon_sym_TILDE,
    ACTIONS(297), 1,
      aux_sym__hex_literal_token1,
    ACTIONS(299), 1,
      sym__number_literal,
    ACTIONS(301), 1,
      anon_sym_SQUOTE,
    ACTIONS(303), 1,
      anon_sym_DQUOTE,
    ACTIONS(313), 1,
      sym__raw_string_literal,
    ACTIONS(315), 1,
      sym__external_open_parenthesis,
    ACTIONS(319), 1,
      sym__external_open_brace,
    ACTIONS(11159), 1,
      anon_sym_BANG,
    ACTIONS(14251), 1,
      sym_dot_dot_i,
    STATE(57), 1,
      sym__open_parenthesis,
    STATE(59), 1,
      sym__open_brace,
    STATE(2187), 1,
      sym__double_quoted_string,
    STATE(2188), 1,
      sym__single_quoted_string,
    STATE(2192), 1,
      sym_string,
    STATE(5139), 1,
      sym__string_or_identifier,
    ACTIONS(293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2189), 2,
      sym__hex_literal,
      sym__float_literal,
    ACTIONS(307), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(14249), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(680), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [171307] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4242), 1,
      anon_sym_SQUOTE,
    ACTIONS(4244), 1,
      anon_sym_DQUOTE,
    ACTIONS(4254), 1,
      sym__raw_string_literal,
    ACTIONS(14253), 1,
      sym_identifier,
    ACTIONS(14255), 1,
      sym__newline,
    STATE(4386), 1,
      aux_sym_function_definition_repeat1,
    STATE(4674), 1,
      sym__single_quoted_string,
    STATE(4678), 1,
      sym__double_quoted_string,
    STATE(4707), 2,
      sym_string,
      sym__string_or_identifier,
    ACTIONS(5673), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(5669), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [171378] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4242), 1,
      anon_sym_SQUOTE,
    ACTIONS(4244), 1,
      anon_sym_DQUOTE,
    ACTIONS(4254), 1,
      sym__raw_string_literal,
    ACTIONS(14257), 1,
      sym_identifier,
    ACTIONS(14259), 1,
      sym__newline,
    STATE(4369), 1,
      aux_sym_function_definition_repeat1,
    STATE(4674), 1,
      sym__single_quoted_string,
    STATE(4678), 1,
      sym__double_quoted_string,
    STATE(4706), 2,
      sym_string,
      sym__string_or_identifier,
    ACTIONS(5663), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(5659), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [171449] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(14261), 1,
      sym_identifier,
    ACTIONS(14263), 1,
      sym__newline,
    STATE(4372), 1,
      aux_sym_function_definition_repeat1,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(4714), 2,
      sym_string,
      sym__string_or_identifier,
    ACTIONS(5663), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(5659), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [171519] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(14265), 1,
      sym_identifier,
    ACTIONS(14267), 1,
      sym__newline,
    STATE(4634), 1,
      aux_sym_function_definition_repeat1,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(4727), 2,
      sym_string,
      sym__string_or_identifier,
    ACTIONS(5673), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(5669), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [171589] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4242), 1,
      anon_sym_SQUOTE,
    ACTIONS(4244), 1,
      anon_sym_DQUOTE,
    ACTIONS(4254), 1,
      sym__raw_string_literal,
    ACTIONS(14269), 1,
      sym_identifier,
    STATE(4674), 1,
      sym__single_quoted_string,
    STATE(4678), 1,
      sym__double_quoted_string,
    STATE(4704), 2,
      sym_string,
      sym__string_or_identifier,
    ACTIONS(5887), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(5883), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [171654] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14271), 1,
      anon_sym_EQ,
    ACTIONS(14273), 1,
      anon_sym_TILDE,
    ACTIONS(14275), 1,
      anon_sym_PLUS,
    ACTIONS(14277), 1,
      anon_sym_DASH,
    ACTIONS(14281), 1,
      anon_sym_DASH_GT,
    ACTIONS(14283), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14285), 1,
      anon_sym_PIPE,
    ACTIONS(14287), 1,
      anon_sym_AMP,
    ACTIONS(14289), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14291), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14297), 1,
      anon_sym_STAR,
    ACTIONS(14299), 1,
      anon_sym_SLASH,
    ACTIONS(14305), 1,
      anon_sym_COLON,
    ACTIONS(14309), 1,
      sym__external_else,
    ACTIONS(14311), 1,
      sym__external_open_parenthesis,
    ACTIONS(14313), 1,
      sym__external_open_bracket,
    ACTIONS(14315), 1,
      sym__external_open_bracket2,
    STATE(1395), 1,
      sym__open_bracket2,
    STATE(1397), 1,
      sym__open_bracket,
    STATE(1399), 1,
      sym__open_parenthesis,
    STATE(4321), 1,
      sym__else,
    STATE(4698), 1,
      sym_call_arguments,
    STATE(4701), 1,
      sym_subset_arguments,
    STATE(4708), 1,
      sym_subset2_arguments,
    ACTIONS(14293), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14301), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14303), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14307), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5067), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(14279), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14295), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [171762] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14271), 1,
      anon_sym_EQ,
    ACTIONS(14273), 1,
      anon_sym_TILDE,
    ACTIONS(14275), 1,
      anon_sym_PLUS,
    ACTIONS(14277), 1,
      anon_sym_DASH,
    ACTIONS(14281), 1,
      anon_sym_DASH_GT,
    ACTIONS(14283), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14285), 1,
      anon_sym_PIPE,
    ACTIONS(14287), 1,
      anon_sym_AMP,
    ACTIONS(14289), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14291), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14297), 1,
      anon_sym_STAR,
    ACTIONS(14299), 1,
      anon_sym_SLASH,
    ACTIONS(14305), 1,
      anon_sym_COLON,
    ACTIONS(14311), 1,
      sym__external_open_parenthesis,
    ACTIONS(14313), 1,
      sym__external_open_bracket,
    ACTIONS(14315), 1,
      sym__external_open_bracket2,
    ACTIONS(14317), 1,
      sym__external_else,
    STATE(1395), 1,
      sym__open_bracket2,
    STATE(1397), 1,
      sym__open_bracket,
    STATE(1399), 1,
      sym__open_parenthesis,
    STATE(4353), 1,
      sym__else,
    STATE(4698), 1,
      sym_call_arguments,
    STATE(4701), 1,
      sym_subset_arguments,
    STATE(4708), 1,
      sym_subset2_arguments,
    ACTIONS(14293), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14301), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14303), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14307), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5227), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(14279), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14295), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [171870] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14271), 1,
      anon_sym_EQ,
    ACTIONS(14273), 1,
      anon_sym_TILDE,
    ACTIONS(14275), 1,
      anon_sym_PLUS,
    ACTIONS(14277), 1,
      anon_sym_DASH,
    ACTIONS(14281), 1,
      anon_sym_DASH_GT,
    ACTIONS(14283), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14285), 1,
      anon_sym_PIPE,
    ACTIONS(14287), 1,
      anon_sym_AMP,
    ACTIONS(14289), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14291), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14297), 1,
      anon_sym_STAR,
    ACTIONS(14299), 1,
      anon_sym_SLASH,
    ACTIONS(14305), 1,
      anon_sym_COLON,
    ACTIONS(14311), 1,
      sym__external_open_parenthesis,
    ACTIONS(14313), 1,
      sym__external_open_bracket,
    ACTIONS(14315), 1,
      sym__external_open_bracket2,
    ACTIONS(14319), 1,
      sym__external_else,
    STATE(1395), 1,
      sym__open_bracket2,
    STATE(1397), 1,
      sym__open_bracket,
    STATE(1399), 1,
      sym__open_parenthesis,
    STATE(4366), 1,
      sym__else,
    STATE(4698), 1,
      sym_call_arguments,
    STATE(4701), 1,
      sym_subset_arguments,
    STATE(4708), 1,
      sym_subset2_arguments,
    ACTIONS(14293), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14301), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14303), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14307), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5167), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(14279), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14295), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [171978] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14271), 1,
      anon_sym_EQ,
    ACTIONS(14273), 1,
      anon_sym_TILDE,
    ACTIONS(14275), 1,
      anon_sym_PLUS,
    ACTIONS(14277), 1,
      anon_sym_DASH,
    ACTIONS(14281), 1,
      anon_sym_DASH_GT,
    ACTIONS(14283), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14285), 1,
      anon_sym_PIPE,
    ACTIONS(14287), 1,
      anon_sym_AMP,
    ACTIONS(14289), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14291), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14297), 1,
      anon_sym_STAR,
    ACTIONS(14299), 1,
      anon_sym_SLASH,
    ACTIONS(14305), 1,
      anon_sym_COLON,
    ACTIONS(14311), 1,
      sym__external_open_parenthesis,
    ACTIONS(14313), 1,
      sym__external_open_bracket,
    ACTIONS(14315), 1,
      sym__external_open_bracket2,
    ACTIONS(14321), 1,
      sym__external_else,
    STATE(1395), 1,
      sym__open_bracket2,
    STATE(1397), 1,
      sym__open_bracket,
    STATE(1399), 1,
      sym__open_parenthesis,
    STATE(4364), 1,
      sym__else,
    STATE(4698), 1,
      sym_call_arguments,
    STATE(4701), 1,
      sym_subset_arguments,
    STATE(4708), 1,
      sym_subset2_arguments,
    ACTIONS(14293), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14301), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14303), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14307), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5117), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(14279), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14295), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [172086] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14271), 1,
      anon_sym_EQ,
    ACTIONS(14273), 1,
      anon_sym_TILDE,
    ACTIONS(14275), 1,
      anon_sym_PLUS,
    ACTIONS(14277), 1,
      anon_sym_DASH,
    ACTIONS(14281), 1,
      anon_sym_DASH_GT,
    ACTIONS(14283), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14285), 1,
      anon_sym_PIPE,
    ACTIONS(14287), 1,
      anon_sym_AMP,
    ACTIONS(14289), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14291), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14297), 1,
      anon_sym_STAR,
    ACTIONS(14299), 1,
      anon_sym_SLASH,
    ACTIONS(14305), 1,
      anon_sym_COLON,
    ACTIONS(14311), 1,
      sym__external_open_parenthesis,
    ACTIONS(14313), 1,
      sym__external_open_bracket,
    ACTIONS(14315), 1,
      sym__external_open_bracket2,
    ACTIONS(14323), 1,
      sym__external_else,
    STATE(1395), 1,
      sym__open_bracket2,
    STATE(1397), 1,
      sym__open_bracket,
    STATE(1399), 1,
      sym__open_parenthesis,
    STATE(4349), 1,
      sym__else,
    STATE(4698), 1,
      sym_call_arguments,
    STATE(4701), 1,
      sym_subset_arguments,
    STATE(4708), 1,
      sym_subset2_arguments,
    ACTIONS(14293), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14301), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14303), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14307), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5067), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(14279), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14295), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [172194] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4618), 1,
      anon_sym_SQUOTE,
    ACTIONS(4620), 1,
      anon_sym_DQUOTE,
    ACTIONS(4630), 1,
      sym__raw_string_literal,
    ACTIONS(14325), 1,
      sym_identifier,
    STATE(4684), 1,
      sym__single_quoted_string,
    STATE(4691), 1,
      sym__double_quoted_string,
    STATE(4728), 2,
      sym_string,
      sym__string_or_identifier,
    ACTIONS(5887), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(5883), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [172258] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14271), 1,
      anon_sym_EQ,
    ACTIONS(14273), 1,
      anon_sym_TILDE,
    ACTIONS(14275), 1,
      anon_sym_PLUS,
    ACTIONS(14277), 1,
      anon_sym_DASH,
    ACTIONS(14281), 1,
      anon_sym_DASH_GT,
    ACTIONS(14283), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14285), 1,
      anon_sym_PIPE,
    ACTIONS(14287), 1,
      anon_sym_AMP,
    ACTIONS(14289), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14291), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14297), 1,
      anon_sym_STAR,
    ACTIONS(14299), 1,
      anon_sym_SLASH,
    ACTIONS(14305), 1,
      anon_sym_COLON,
    ACTIONS(14311), 1,
      sym__external_open_parenthesis,
    ACTIONS(14313), 1,
      sym__external_open_bracket,
    ACTIONS(14315), 1,
      sym__external_open_bracket2,
    ACTIONS(14327), 1,
      sym__external_else,
    STATE(1395), 1,
      sym__open_bracket2,
    STATE(1397), 1,
      sym__open_bracket,
    STATE(1399), 1,
      sym__open_parenthesis,
    STATE(4283), 1,
      sym__else,
    STATE(4698), 1,
      sym_call_arguments,
    STATE(4701), 1,
      sym_subset_arguments,
    STATE(4708), 1,
      sym_subset2_arguments,
    ACTIONS(14293), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14301), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14303), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14307), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5227), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(14279), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14295), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [172366] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14271), 1,
      anon_sym_EQ,
    ACTIONS(14273), 1,
      anon_sym_TILDE,
    ACTIONS(14275), 1,
      anon_sym_PLUS,
    ACTIONS(14277), 1,
      anon_sym_DASH,
    ACTIONS(14281), 1,
      anon_sym_DASH_GT,
    ACTIONS(14283), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14285), 1,
      anon_sym_PIPE,
    ACTIONS(14287), 1,
      anon_sym_AMP,
    ACTIONS(14289), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14291), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14297), 1,
      anon_sym_STAR,
    ACTIONS(14299), 1,
      anon_sym_SLASH,
    ACTIONS(14305), 1,
      anon_sym_COLON,
    ACTIONS(14311), 1,
      sym__external_open_parenthesis,
    ACTIONS(14313), 1,
      sym__external_open_bracket,
    ACTIONS(14315), 1,
      sym__external_open_bracket2,
    ACTIONS(14329), 1,
      sym__external_else,
    STATE(1395), 1,
      sym__open_bracket2,
    STATE(1397), 1,
      sym__open_bracket,
    STATE(1399), 1,
      sym__open_parenthesis,
    STATE(4295), 1,
      sym__else,
    STATE(4698), 1,
      sym_call_arguments,
    STATE(4701), 1,
      sym_subset_arguments,
    STATE(4708), 1,
      sym_subset2_arguments,
    ACTIONS(14293), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14301), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14303), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14307), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5167), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(14279), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14295), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [172474] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14271), 1,
      anon_sym_EQ,
    ACTIONS(14273), 1,
      anon_sym_TILDE,
    ACTIONS(14275), 1,
      anon_sym_PLUS,
    ACTIONS(14277), 1,
      anon_sym_DASH,
    ACTIONS(14281), 1,
      anon_sym_DASH_GT,
    ACTIONS(14283), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14285), 1,
      anon_sym_PIPE,
    ACTIONS(14287), 1,
      anon_sym_AMP,
    ACTIONS(14289), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14291), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14297), 1,
      anon_sym_STAR,
    ACTIONS(14299), 1,
      anon_sym_SLASH,
    ACTIONS(14305), 1,
      anon_sym_COLON,
    ACTIONS(14311), 1,
      sym__external_open_parenthesis,
    ACTIONS(14313), 1,
      sym__external_open_bracket,
    ACTIONS(14315), 1,
      sym__external_open_bracket2,
    ACTIONS(14331), 1,
      sym__external_else,
    STATE(1395), 1,
      sym__open_bracket2,
    STATE(1397), 1,
      sym__open_bracket,
    STATE(1399), 1,
      sym__open_parenthesis,
    STATE(4297), 1,
      sym__else,
    STATE(4698), 1,
      sym_call_arguments,
    STATE(4701), 1,
      sym_subset_arguments,
    STATE(4708), 1,
      sym_subset2_arguments,
    ACTIONS(14293), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14301), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14303), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14307), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5117), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(14279), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14295), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [172582] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14271), 1,
      anon_sym_EQ,
    ACTIONS(14273), 1,
      anon_sym_TILDE,
    ACTIONS(14275), 1,
      anon_sym_PLUS,
    ACTIONS(14277), 1,
      anon_sym_DASH,
    ACTIONS(14281), 1,
      anon_sym_DASH_GT,
    ACTIONS(14283), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14285), 1,
      anon_sym_PIPE,
    ACTIONS(14287), 1,
      anon_sym_AMP,
    ACTIONS(14289), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14291), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14297), 1,
      anon_sym_STAR,
    ACTIONS(14299), 1,
      anon_sym_SLASH,
    ACTIONS(14305), 1,
      anon_sym_COLON,
    ACTIONS(14311), 1,
      sym__external_open_parenthesis,
    ACTIONS(14313), 1,
      sym__external_open_bracket,
    ACTIONS(14315), 1,
      sym__external_open_bracket2,
    STATE(1395), 1,
      sym__open_bracket2,
    STATE(1397), 1,
      sym__open_bracket,
    STATE(1399), 1,
      sym__open_parenthesis,
    STATE(4698), 1,
      sym_call_arguments,
    STATE(4701), 1,
      sym_subset_arguments,
    STATE(4708), 1,
      sym_subset2_arguments,
    ACTIONS(14293), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14301), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14303), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14307), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14279), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5341), 4,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(14295), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [172685] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14271), 1,
      anon_sym_EQ,
    ACTIONS(14273), 1,
      anon_sym_TILDE,
    ACTIONS(14275), 1,
      anon_sym_PLUS,
    ACTIONS(14277), 1,
      anon_sym_DASH,
    ACTIONS(14281), 1,
      anon_sym_DASH_GT,
    ACTIONS(14283), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14285), 1,
      anon_sym_PIPE,
    ACTIONS(14287), 1,
      anon_sym_AMP,
    ACTIONS(14289), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14291), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14297), 1,
      anon_sym_STAR,
    ACTIONS(14299), 1,
      anon_sym_SLASH,
    ACTIONS(14305), 1,
      anon_sym_COLON,
    ACTIONS(14311), 1,
      sym__external_open_parenthesis,
    ACTIONS(14313), 1,
      sym__external_open_bracket,
    ACTIONS(14315), 1,
      sym__external_open_bracket2,
    STATE(1395), 1,
      sym__open_bracket2,
    STATE(1397), 1,
      sym__open_bracket,
    STATE(1399), 1,
      sym__open_parenthesis,
    STATE(4698), 1,
      sym_call_arguments,
    STATE(4701), 1,
      sym_subset_arguments,
    STATE(4708), 1,
      sym_subset2_arguments,
    ACTIONS(14293), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14301), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14303), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14307), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14279), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5345), 4,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(14295), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [172788] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14271), 1,
      anon_sym_EQ,
    ACTIONS(14273), 1,
      anon_sym_TILDE,
    ACTIONS(14275), 1,
      anon_sym_PLUS,
    ACTIONS(14277), 1,
      anon_sym_DASH,
    ACTIONS(14281), 1,
      anon_sym_DASH_GT,
    ACTIONS(14283), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14285), 1,
      anon_sym_PIPE,
    ACTIONS(14287), 1,
      anon_sym_AMP,
    ACTIONS(14289), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14291), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14297), 1,
      anon_sym_STAR,
    ACTIONS(14299), 1,
      anon_sym_SLASH,
    ACTIONS(14305), 1,
      anon_sym_COLON,
    ACTIONS(14311), 1,
      sym__external_open_parenthesis,
    ACTIONS(14313), 1,
      sym__external_open_bracket,
    ACTIONS(14315), 1,
      sym__external_open_bracket2,
    STATE(1395), 1,
      sym__open_bracket2,
    STATE(1397), 1,
      sym__open_bracket,
    STATE(1399), 1,
      sym__open_parenthesis,
    STATE(4698), 1,
      sym_call_arguments,
    STATE(4701), 1,
      sym_subset_arguments,
    STATE(4708), 1,
      sym_subset2_arguments,
    ACTIONS(14293), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14301), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14303), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14307), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14279), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5349), 4,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(14295), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [172891] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14333), 1,
      sym__newline,
    STATE(4386), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(7419), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(7417), 30,
      sym__raw_string_literal,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      sym_identifier,
      sym_comma,
  [172944] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14271), 1,
      anon_sym_EQ,
    ACTIONS(14273), 1,
      anon_sym_TILDE,
    ACTIONS(14275), 1,
      anon_sym_PLUS,
    ACTIONS(14277), 1,
      anon_sym_DASH,
    ACTIONS(14281), 1,
      anon_sym_DASH_GT,
    ACTIONS(14283), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14285), 1,
      anon_sym_PIPE,
    ACTIONS(14287), 1,
      anon_sym_AMP,
    ACTIONS(14289), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14291), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14297), 1,
      anon_sym_STAR,
    ACTIONS(14299), 1,
      anon_sym_SLASH,
    ACTIONS(14305), 1,
      anon_sym_COLON,
    ACTIONS(14311), 1,
      sym__external_open_parenthesis,
    ACTIONS(14313), 1,
      sym__external_open_bracket,
    ACTIONS(14315), 1,
      sym__external_open_bracket2,
    STATE(1395), 1,
      sym__open_bracket2,
    STATE(1397), 1,
      sym__open_bracket,
    STATE(1399), 1,
      sym__open_parenthesis,
    STATE(4698), 1,
      sym_call_arguments,
    STATE(4701), 1,
      sym_subset_arguments,
    STATE(4708), 1,
      sym_subset2_arguments,
    ACTIONS(14293), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14301), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14303), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14307), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14295), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5349), 7,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      sym_comma,
  [173045] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14273), 1,
      anon_sym_TILDE,
    ACTIONS(14275), 1,
      anon_sym_PLUS,
    ACTIONS(14277), 1,
      anon_sym_DASH,
    ACTIONS(14285), 1,
      anon_sym_PIPE,
    ACTIONS(14287), 1,
      anon_sym_AMP,
    ACTIONS(14289), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14291), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14297), 1,
      anon_sym_STAR,
    ACTIONS(14299), 1,
      anon_sym_SLASH,
    ACTIONS(14305), 1,
      anon_sym_COLON,
    ACTIONS(14311), 1,
      sym__external_open_parenthesis,
    ACTIONS(14313), 1,
      sym__external_open_bracket,
    ACTIONS(14315), 1,
      sym__external_open_bracket2,
    STATE(1395), 1,
      sym__open_bracket2,
    STATE(1397), 1,
      sym__open_bracket,
    STATE(1399), 1,
      sym__open_parenthesis,
    STATE(4698), 1,
      sym_call_arguments,
    STATE(4701), 1,
      sym_subset_arguments,
    STATE(4708), 1,
      sym_subset2_arguments,
    ACTIONS(5351), 2,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(14293), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14301), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14303), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14307), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14295), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5349), 8,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      sym_comma,
  [173142] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14311), 1,
      sym__external_open_parenthesis,
    ACTIONS(14313), 1,
      sym__external_open_bracket,
    ACTIONS(14315), 1,
      sym__external_open_bracket2,
    STATE(1395), 1,
      sym__open_bracket2,
    STATE(1397), 1,
      sym__open_bracket,
    STATE(1399), 1,
      sym__open_parenthesis,
    STATE(4698), 1,
      sym_call_arguments,
    STATE(4701), 1,
      sym_subset_arguments,
    STATE(4708), 1,
      sym_subset2_arguments,
    ACTIONS(14301), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14307), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5261), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(5263), 19,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [173213] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14311), 1,
      sym__external_open_parenthesis,
    ACTIONS(14313), 1,
      sym__external_open_bracket,
    ACTIONS(14315), 1,
      sym__external_open_bracket2,
    STATE(1395), 1,
      sym__open_bracket2,
    STATE(1397), 1,
      sym__open_bracket,
    STATE(1399), 1,
      sym__open_parenthesis,
    STATE(4698), 1,
      sym_call_arguments,
    STATE(4701), 1,
      sym_subset_arguments,
    STATE(4708), 1,
      sym_subset2_arguments,
    ACTIONS(14301), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14307), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5347), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(5345), 19,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [173284] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14275), 1,
      anon_sym_PLUS,
    ACTIONS(14277), 1,
      anon_sym_DASH,
    ACTIONS(14287), 1,
      anon_sym_AMP,
    ACTIONS(14291), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14297), 1,
      anon_sym_STAR,
    ACTIONS(14299), 1,
      anon_sym_SLASH,
    ACTIONS(14305), 1,
      anon_sym_COLON,
    ACTIONS(14311), 1,
      sym__external_open_parenthesis,
    ACTIONS(14313), 1,
      sym__external_open_bracket,
    ACTIONS(14315), 1,
      sym__external_open_bracket2,
    STATE(1395), 1,
      sym__open_bracket2,
    STATE(1397), 1,
      sym__open_bracket,
    STATE(1399), 1,
      sym__open_parenthesis,
    STATE(4698), 1,
      sym_call_arguments,
    STATE(4701), 1,
      sym_subset_arguments,
    STATE(4708), 1,
      sym_subset2_arguments,
    ACTIONS(14293), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14301), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14303), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14307), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5351), 3,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
    ACTIONS(14295), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5349), 10,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      sym_comma,
  [173375] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14305), 1,
      anon_sym_COLON,
    ACTIONS(14311), 1,
      sym__external_open_parenthesis,
    ACTIONS(14313), 1,
      sym__external_open_bracket,
    ACTIONS(14315), 1,
      sym__external_open_bracket2,
    STATE(1395), 1,
      sym__open_bracket2,
    STATE(1397), 1,
      sym__open_bracket,
    STATE(1399), 1,
      sym__open_parenthesis,
    STATE(4698), 1,
      sym_call_arguments,
    STATE(4701), 1,
      sym_subset_arguments,
    STATE(4708), 1,
      sym_subset2_arguments,
    ACTIONS(14301), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14307), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5261), 8,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
    ACTIONS(5263), 19,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [173448] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14311), 1,
      sym__external_open_parenthesis,
    ACTIONS(14313), 1,
      sym__external_open_bracket,
    ACTIONS(14315), 1,
      sym__external_open_bracket2,
    STATE(1395), 1,
      sym__open_bracket2,
    STATE(1397), 1,
      sym__open_bracket,
    STATE(1399), 1,
      sym__open_parenthesis,
    STATE(4698), 1,
      sym_call_arguments,
    STATE(4701), 1,
      sym_subset_arguments,
    STATE(4708), 1,
      sym_subset2_arguments,
    ACTIONS(14301), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14307), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5261), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(5263), 19,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [173519] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14275), 1,
      anon_sym_PLUS,
    ACTIONS(14277), 1,
      anon_sym_DASH,
    ACTIONS(14297), 1,
      anon_sym_STAR,
    ACTIONS(14299), 1,
      anon_sym_SLASH,
    ACTIONS(14305), 1,
      anon_sym_COLON,
    ACTIONS(14311), 1,
      sym__external_open_parenthesis,
    ACTIONS(14313), 1,
      sym__external_open_bracket,
    ACTIONS(14315), 1,
      sym__external_open_bracket2,
    STATE(1395), 1,
      sym__open_bracket2,
    STATE(1397), 1,
      sym__open_bracket,
    STATE(1399), 1,
      sym__open_parenthesis,
    STATE(4698), 1,
      sym_call_arguments,
    STATE(4701), 1,
      sym_subset_arguments,
    STATE(4708), 1,
      sym_subset2_arguments,
    ACTIONS(14293), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14301), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14303), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14307), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5347), 4,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(14295), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5345), 11,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_comma,
  [173606] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14305), 1,
      anon_sym_COLON,
    ACTIONS(14311), 1,
      sym__external_open_parenthesis,
    ACTIONS(14313), 1,
      sym__external_open_bracket,
    ACTIONS(14315), 1,
      sym__external_open_bracket2,
    STATE(1395), 1,
      sym__open_bracket2,
    STATE(1397), 1,
      sym__open_bracket,
    STATE(1399), 1,
      sym__open_parenthesis,
    STATE(4698), 1,
      sym_call_arguments,
    STATE(4701), 1,
      sym_subset_arguments,
    STATE(4708), 1,
      sym_subset2_arguments,
    ACTIONS(14301), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14303), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14307), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5261), 8,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
    ACTIONS(5263), 17,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      sym_comma,
  [173681] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14275), 1,
      anon_sym_PLUS,
    ACTIONS(14277), 1,
      anon_sym_DASH,
    ACTIONS(14285), 1,
      anon_sym_PIPE,
    ACTIONS(14287), 1,
      anon_sym_AMP,
    ACTIONS(14289), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14291), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14297), 1,
      anon_sym_STAR,
    ACTIONS(14299), 1,
      anon_sym_SLASH,
    ACTIONS(14305), 1,
      anon_sym_COLON,
    ACTIONS(14311), 1,
      sym__external_open_parenthesis,
    ACTIONS(14313), 1,
      sym__external_open_bracket,
    ACTIONS(14315), 1,
      sym__external_open_bracket2,
    STATE(1395), 1,
      sym__open_bracket2,
    STATE(1397), 1,
      sym__open_bracket,
    STATE(1399), 1,
      sym__open_parenthesis,
    STATE(4698), 1,
      sym_call_arguments,
    STATE(4701), 1,
      sym_subset_arguments,
    STATE(4708), 1,
      sym_subset2_arguments,
    ACTIONS(5347), 2,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(14293), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14301), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14303), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14307), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14295), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5345), 9,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      sym_comma,
  [173776] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14275), 1,
      anon_sym_PLUS,
    ACTIONS(14277), 1,
      anon_sym_DASH,
    ACTIONS(14297), 1,
      anon_sym_STAR,
    ACTIONS(14299), 1,
      anon_sym_SLASH,
    ACTIONS(14305), 1,
      anon_sym_COLON,
    ACTIONS(14311), 1,
      sym__external_open_parenthesis,
    ACTIONS(14313), 1,
      sym__external_open_bracket,
    ACTIONS(14315), 1,
      sym__external_open_bracket2,
    STATE(1395), 1,
      sym__open_bracket2,
    STATE(1397), 1,
      sym__open_bracket,
    STATE(1399), 1,
      sym__open_parenthesis,
    STATE(4698), 1,
      sym_call_arguments,
    STATE(4701), 1,
      sym_subset_arguments,
    STATE(4708), 1,
      sym_subset2_arguments,
    ACTIONS(14301), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14303), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14307), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5261), 6,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5263), 15,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      sym_comma,
  [173859] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14275), 1,
      anon_sym_PLUS,
    ACTIONS(14277), 1,
      anon_sym_DASH,
    ACTIONS(14297), 1,
      anon_sym_STAR,
    ACTIONS(14299), 1,
      anon_sym_SLASH,
    ACTIONS(14305), 1,
      anon_sym_COLON,
    ACTIONS(14311), 1,
      sym__external_open_parenthesis,
    ACTIONS(14313), 1,
      sym__external_open_bracket,
    ACTIONS(14315), 1,
      sym__external_open_bracket2,
    STATE(1395), 1,
      sym__open_bracket2,
    STATE(1397), 1,
      sym__open_bracket,
    STATE(1399), 1,
      sym__open_parenthesis,
    STATE(4698), 1,
      sym_call_arguments,
    STATE(4701), 1,
      sym_subset_arguments,
    STATE(4708), 1,
      sym_subset2_arguments,
    ACTIONS(14293), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14301), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14303), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14307), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5261), 4,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(14295), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5263), 11,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_comma,
  [173946] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14275), 1,
      anon_sym_PLUS,
    ACTIONS(14277), 1,
      anon_sym_DASH,
    ACTIONS(14287), 1,
      anon_sym_AMP,
    ACTIONS(14291), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14297), 1,
      anon_sym_STAR,
    ACTIONS(14299), 1,
      anon_sym_SLASH,
    ACTIONS(14305), 1,
      anon_sym_COLON,
    ACTIONS(14311), 1,
      sym__external_open_parenthesis,
    ACTIONS(14313), 1,
      sym__external_open_bracket,
    ACTIONS(14315), 1,
      sym__external_open_bracket2,
    STATE(1395), 1,
      sym__open_bracket2,
    STATE(1397), 1,
      sym__open_bracket,
    STATE(1399), 1,
      sym__open_parenthesis,
    STATE(4698), 1,
      sym_call_arguments,
    STATE(4701), 1,
      sym_subset_arguments,
    STATE(4708), 1,
      sym_subset2_arguments,
    ACTIONS(14293), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14301), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14303), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14307), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5261), 3,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
    ACTIONS(14295), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5263), 10,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      sym_comma,
  [174037] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14271), 1,
      anon_sym_EQ,
    ACTIONS(14273), 1,
      anon_sym_TILDE,
    ACTIONS(14275), 1,
      anon_sym_PLUS,
    ACTIONS(14277), 1,
      anon_sym_DASH,
    ACTIONS(14281), 1,
      anon_sym_DASH_GT,
    ACTIONS(14283), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14285), 1,
      anon_sym_PIPE,
    ACTIONS(14287), 1,
      anon_sym_AMP,
    ACTIONS(14289), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14291), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14297), 1,
      anon_sym_STAR,
    ACTIONS(14299), 1,
      anon_sym_SLASH,
    ACTIONS(14305), 1,
      anon_sym_COLON,
    ACTIONS(14311), 1,
      sym__external_open_parenthesis,
    ACTIONS(14313), 1,
      sym__external_open_bracket,
    ACTIONS(14315), 1,
      sym__external_open_bracket2,
    STATE(1395), 1,
      sym__open_bracket2,
    STATE(1397), 1,
      sym__open_bracket,
    STATE(1399), 1,
      sym__open_parenthesis,
    STATE(4698), 1,
      sym_call_arguments,
    STATE(4701), 1,
      sym_subset_arguments,
    STATE(4708), 1,
      sym_subset2_arguments,
    ACTIONS(14293), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14301), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14303), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14307), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14279), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5429), 4,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(14295), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [174140] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14271), 1,
      anon_sym_EQ,
    ACTIONS(14273), 1,
      anon_sym_TILDE,
    ACTIONS(14275), 1,
      anon_sym_PLUS,
    ACTIONS(14277), 1,
      anon_sym_DASH,
    ACTIONS(14281), 1,
      anon_sym_DASH_GT,
    ACTIONS(14283), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14285), 1,
      anon_sym_PIPE,
    ACTIONS(14287), 1,
      anon_sym_AMP,
    ACTIONS(14289), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14291), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14297), 1,
      anon_sym_STAR,
    ACTIONS(14299), 1,
      anon_sym_SLASH,
    ACTIONS(14305), 1,
      anon_sym_COLON,
    ACTIONS(14311), 1,
      sym__external_open_parenthesis,
    ACTIONS(14313), 1,
      sym__external_open_bracket,
    ACTIONS(14315), 1,
      sym__external_open_bracket2,
    STATE(1395), 1,
      sym__open_bracket2,
    STATE(1397), 1,
      sym__open_bracket,
    STATE(1399), 1,
      sym__open_parenthesis,
    STATE(4698), 1,
      sym_call_arguments,
    STATE(4701), 1,
      sym_subset_arguments,
    STATE(4708), 1,
      sym_subset2_arguments,
    ACTIONS(14293), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14301), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14303), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14307), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14279), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5425), 4,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(14295), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [174243] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14271), 1,
      anon_sym_EQ,
    ACTIONS(14273), 1,
      anon_sym_TILDE,
    ACTIONS(14275), 1,
      anon_sym_PLUS,
    ACTIONS(14277), 1,
      anon_sym_DASH,
    ACTIONS(14281), 1,
      anon_sym_DASH_GT,
    ACTIONS(14283), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14285), 1,
      anon_sym_PIPE,
    ACTIONS(14287), 1,
      anon_sym_AMP,
    ACTIONS(14289), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14291), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14297), 1,
      anon_sym_STAR,
    ACTIONS(14299), 1,
      anon_sym_SLASH,
    ACTIONS(14305), 1,
      anon_sym_COLON,
    ACTIONS(14311), 1,
      sym__external_open_parenthesis,
    ACTIONS(14313), 1,
      sym__external_open_bracket,
    ACTIONS(14315), 1,
      sym__external_open_bracket2,
    STATE(1395), 1,
      sym__open_bracket2,
    STATE(1397), 1,
      sym__open_bracket,
    STATE(1399), 1,
      sym__open_parenthesis,
    STATE(4698), 1,
      sym_call_arguments,
    STATE(4701), 1,
      sym_subset_arguments,
    STATE(4708), 1,
      sym_subset2_arguments,
    ACTIONS(14293), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14301), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14303), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14307), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14279), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5263), 4,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(14295), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [174346] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14275), 1,
      anon_sym_PLUS,
    ACTIONS(14277), 1,
      anon_sym_DASH,
    ACTIONS(14297), 1,
      anon_sym_STAR,
    ACTIONS(14299), 1,
      anon_sym_SLASH,
    ACTIONS(14305), 1,
      anon_sym_COLON,
    ACTIONS(14311), 1,
      sym__external_open_parenthesis,
    ACTIONS(14313), 1,
      sym__external_open_bracket,
    ACTIONS(14315), 1,
      sym__external_open_bracket2,
    STATE(1395), 1,
      sym__open_bracket2,
    STATE(1397), 1,
      sym__open_bracket,
    STATE(1399), 1,
      sym__open_parenthesis,
    STATE(4698), 1,
      sym_call_arguments,
    STATE(4701), 1,
      sym_subset_arguments,
    STATE(4708), 1,
      sym_subset2_arguments,
    ACTIONS(14293), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14301), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14303), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14307), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5351), 4,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(14295), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5349), 11,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_comma,
  [174433] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14275), 1,
      anon_sym_PLUS,
    ACTIONS(14277), 1,
      anon_sym_DASH,
    ACTIONS(14297), 1,
      anon_sym_STAR,
    ACTIONS(14299), 1,
      anon_sym_SLASH,
    ACTIONS(14305), 1,
      anon_sym_COLON,
    ACTIONS(14311), 1,
      sym__external_open_parenthesis,
    ACTIONS(14313), 1,
      sym__external_open_bracket,
    ACTIONS(14315), 1,
      sym__external_open_bracket2,
    STATE(1395), 1,
      sym__open_bracket2,
    STATE(1397), 1,
      sym__open_bracket,
    STATE(1399), 1,
      sym__open_parenthesis,
    STATE(4698), 1,
      sym_call_arguments,
    STATE(4701), 1,
      sym_subset_arguments,
    STATE(4708), 1,
      sym_subset2_arguments,
    ACTIONS(14301), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14303), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14307), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5351), 6,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5349), 15,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      sym_comma,
  [174516] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14305), 1,
      anon_sym_COLON,
    ACTIONS(14311), 1,
      sym__external_open_parenthesis,
    ACTIONS(14313), 1,
      sym__external_open_bracket,
    ACTIONS(14315), 1,
      sym__external_open_bracket2,
    STATE(1395), 1,
      sym__open_bracket2,
    STATE(1397), 1,
      sym__open_bracket,
    STATE(1399), 1,
      sym__open_parenthesis,
    STATE(4698), 1,
      sym_call_arguments,
    STATE(4701), 1,
      sym_subset_arguments,
    STATE(4708), 1,
      sym_subset2_arguments,
    ACTIONS(14301), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14303), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14307), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5351), 8,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
    ACTIONS(5349), 17,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      sym_comma,
  [174591] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14271), 1,
      anon_sym_EQ,
    ACTIONS(14273), 1,
      anon_sym_TILDE,
    ACTIONS(14275), 1,
      anon_sym_PLUS,
    ACTIONS(14277), 1,
      anon_sym_DASH,
    ACTIONS(14281), 1,
      anon_sym_DASH_GT,
    ACTIONS(14283), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14285), 1,
      anon_sym_PIPE,
    ACTIONS(14287), 1,
      anon_sym_AMP,
    ACTIONS(14289), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14291), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14297), 1,
      anon_sym_STAR,
    ACTIONS(14299), 1,
      anon_sym_SLASH,
    ACTIONS(14305), 1,
      anon_sym_COLON,
    ACTIONS(14311), 1,
      sym__external_open_parenthesis,
    ACTIONS(14313), 1,
      sym__external_open_bracket,
    ACTIONS(14315), 1,
      sym__external_open_bracket2,
    STATE(1395), 1,
      sym__open_bracket2,
    STATE(1397), 1,
      sym__open_bracket,
    STATE(1399), 1,
      sym__open_parenthesis,
    STATE(4698), 1,
      sym_call_arguments,
    STATE(4701), 1,
      sym_subset_arguments,
    STATE(4708), 1,
      sym_subset2_arguments,
    ACTIONS(14293), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14301), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14303), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14307), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14279), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5337), 4,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(14295), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [174694] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14311), 1,
      sym__external_open_parenthesis,
    ACTIONS(14313), 1,
      sym__external_open_bracket,
    ACTIONS(14315), 1,
      sym__external_open_bracket2,
    STATE(1395), 1,
      sym__open_bracket2,
    STATE(1397), 1,
      sym__open_bracket,
    STATE(1399), 1,
      sym__open_parenthesis,
    STATE(4698), 1,
      sym_call_arguments,
    STATE(4701), 1,
      sym_subset_arguments,
    STATE(4708), 1,
      sym_subset2_arguments,
    ACTIONS(14301), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14307), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5351), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(5349), 19,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [174765] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14271), 1,
      anon_sym_EQ,
    ACTIONS(14273), 1,
      anon_sym_TILDE,
    ACTIONS(14275), 1,
      anon_sym_PLUS,
    ACTIONS(14277), 1,
      anon_sym_DASH,
    ACTIONS(14281), 1,
      anon_sym_DASH_GT,
    ACTIONS(14283), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14285), 1,
      anon_sym_PIPE,
    ACTIONS(14287), 1,
      anon_sym_AMP,
    ACTIONS(14289), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14291), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14297), 1,
      anon_sym_STAR,
    ACTIONS(14299), 1,
      anon_sym_SLASH,
    ACTIONS(14305), 1,
      anon_sym_COLON,
    ACTIONS(14311), 1,
      sym__external_open_parenthesis,
    ACTIONS(14313), 1,
      sym__external_open_bracket,
    ACTIONS(14315), 1,
      sym__external_open_bracket2,
    STATE(1395), 1,
      sym__open_bracket2,
    STATE(1397), 1,
      sym__open_bracket,
    STATE(1399), 1,
      sym__open_parenthesis,
    STATE(4698), 1,
      sym_call_arguments,
    STATE(4701), 1,
      sym_subset_arguments,
    STATE(4708), 1,
      sym_subset2_arguments,
    ACTIONS(14293), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14301), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14303), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14307), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14279), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5349), 4,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(14295), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [174868] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14273), 1,
      anon_sym_TILDE,
    ACTIONS(14275), 1,
      anon_sym_PLUS,
    ACTIONS(14277), 1,
      anon_sym_DASH,
    ACTIONS(14285), 1,
      anon_sym_PIPE,
    ACTIONS(14287), 1,
      anon_sym_AMP,
    ACTIONS(14289), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14291), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14297), 1,
      anon_sym_STAR,
    ACTIONS(14299), 1,
      anon_sym_SLASH,
    ACTIONS(14305), 1,
      anon_sym_COLON,
    ACTIONS(14311), 1,
      sym__external_open_parenthesis,
    ACTIONS(14313), 1,
      sym__external_open_bracket,
    ACTIONS(14315), 1,
      sym__external_open_bracket2,
    STATE(1395), 1,
      sym__open_bracket2,
    STATE(1397), 1,
      sym__open_bracket,
    STATE(1399), 1,
      sym__open_parenthesis,
    STATE(4698), 1,
      sym_call_arguments,
    STATE(4701), 1,
      sym_subset_arguments,
    STATE(4708), 1,
      sym_subset2_arguments,
    ACTIONS(5261), 2,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(14293), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14301), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14303), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14307), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14295), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5263), 8,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      sym_comma,
  [174965] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14297), 1,
      anon_sym_STAR,
    ACTIONS(14299), 1,
      anon_sym_SLASH,
    ACTIONS(14305), 1,
      anon_sym_COLON,
    ACTIONS(14311), 1,
      sym__external_open_parenthesis,
    ACTIONS(14313), 1,
      sym__external_open_bracket,
    ACTIONS(14315), 1,
      sym__external_open_bracket2,
    STATE(1395), 1,
      sym__open_bracket2,
    STATE(1397), 1,
      sym__open_bracket,
    STATE(1399), 1,
      sym__open_parenthesis,
    STATE(4698), 1,
      sym_call_arguments,
    STATE(4701), 1,
      sym_subset_arguments,
    STATE(4708), 1,
      sym_subset2_arguments,
    ACTIONS(14301), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14303), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14307), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5351), 7,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5349), 16,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      sym_comma,
  [175044] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14271), 1,
      anon_sym_EQ,
    ACTIONS(14273), 1,
      anon_sym_TILDE,
    ACTIONS(14275), 1,
      anon_sym_PLUS,
    ACTIONS(14277), 1,
      anon_sym_DASH,
    ACTIONS(14281), 1,
      anon_sym_DASH_GT,
    ACTIONS(14283), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14285), 1,
      anon_sym_PIPE,
    ACTIONS(14287), 1,
      anon_sym_AMP,
    ACTIONS(14289), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14291), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14297), 1,
      anon_sym_STAR,
    ACTIONS(14299), 1,
      anon_sym_SLASH,
    ACTIONS(14305), 1,
      anon_sym_COLON,
    ACTIONS(14311), 1,
      sym__external_open_parenthesis,
    ACTIONS(14313), 1,
      sym__external_open_bracket,
    ACTIONS(14315), 1,
      sym__external_open_bracket2,
    STATE(1395), 1,
      sym__open_bracket2,
    STATE(1397), 1,
      sym__open_bracket,
    STATE(1399), 1,
      sym__open_parenthesis,
    STATE(4698), 1,
      sym_call_arguments,
    STATE(4701), 1,
      sym_subset_arguments,
    STATE(4708), 1,
      sym_subset2_arguments,
    ACTIONS(14293), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14301), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14303), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14307), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14279), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5409), 4,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(14295), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [175147] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14271), 1,
      anon_sym_EQ,
    ACTIONS(14273), 1,
      anon_sym_TILDE,
    ACTIONS(14275), 1,
      anon_sym_PLUS,
    ACTIONS(14277), 1,
      anon_sym_DASH,
    ACTIONS(14281), 1,
      anon_sym_DASH_GT,
    ACTIONS(14283), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14285), 1,
      anon_sym_PIPE,
    ACTIONS(14287), 1,
      anon_sym_AMP,
    ACTIONS(14289), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14291), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14297), 1,
      anon_sym_STAR,
    ACTIONS(14299), 1,
      anon_sym_SLASH,
    ACTIONS(14305), 1,
      anon_sym_COLON,
    ACTIONS(14311), 1,
      sym__external_open_parenthesis,
    ACTIONS(14313), 1,
      sym__external_open_bracket,
    ACTIONS(14315), 1,
      sym__external_open_bracket2,
    STATE(1395), 1,
      sym__open_bracket2,
    STATE(1397), 1,
      sym__open_bracket,
    STATE(1399), 1,
      sym__open_parenthesis,
    STATE(4698), 1,
      sym_call_arguments,
    STATE(4701), 1,
      sym_subset_arguments,
    STATE(4708), 1,
      sym_subset2_arguments,
    ACTIONS(14293), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14301), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14303), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14307), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14279), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5413), 4,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(14295), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [175250] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14297), 1,
      anon_sym_STAR,
    ACTIONS(14299), 1,
      anon_sym_SLASH,
    ACTIONS(14305), 1,
      anon_sym_COLON,
    ACTIONS(14311), 1,
      sym__external_open_parenthesis,
    ACTIONS(14313), 1,
      sym__external_open_bracket,
    ACTIONS(14315), 1,
      sym__external_open_bracket2,
    STATE(1395), 1,
      sym__open_bracket2,
    STATE(1397), 1,
      sym__open_bracket,
    STATE(1399), 1,
      sym__open_parenthesis,
    STATE(4698), 1,
      sym_call_arguments,
    STATE(4701), 1,
      sym_subset_arguments,
    STATE(4708), 1,
      sym_subset2_arguments,
    ACTIONS(14301), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14303), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14307), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5261), 7,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5263), 16,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      sym_comma,
  [175329] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14271), 1,
      anon_sym_EQ,
    ACTIONS(14273), 1,
      anon_sym_TILDE,
    ACTIONS(14275), 1,
      anon_sym_PLUS,
    ACTIONS(14277), 1,
      anon_sym_DASH,
    ACTIONS(14281), 1,
      anon_sym_DASH_GT,
    ACTIONS(14283), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14285), 1,
      anon_sym_PIPE,
    ACTIONS(14287), 1,
      anon_sym_AMP,
    ACTIONS(14289), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14291), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14297), 1,
      anon_sym_STAR,
    ACTIONS(14299), 1,
      anon_sym_SLASH,
    ACTIONS(14305), 1,
      anon_sym_COLON,
    ACTIONS(14311), 1,
      sym__external_open_parenthesis,
    ACTIONS(14313), 1,
      sym__external_open_bracket,
    ACTIONS(14315), 1,
      sym__external_open_bracket2,
    STATE(1395), 1,
      sym__open_bracket2,
    STATE(1397), 1,
      sym__open_bracket,
    STATE(1399), 1,
      sym__open_parenthesis,
    STATE(4698), 1,
      sym_call_arguments,
    STATE(4701), 1,
      sym_subset_arguments,
    STATE(4708), 1,
      sym_subset2_arguments,
    ACTIONS(14293), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14301), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14303), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14307), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14279), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5453), 4,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(14295), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [175432] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14305), 1,
      anon_sym_COLON,
    ACTIONS(14311), 1,
      sym__external_open_parenthesis,
    ACTIONS(14313), 1,
      sym__external_open_bracket,
    ACTIONS(14315), 1,
      sym__external_open_bracket2,
    STATE(1395), 1,
      sym__open_bracket2,
    STATE(1397), 1,
      sym__open_bracket,
    STATE(1399), 1,
      sym__open_parenthesis,
    STATE(4698), 1,
      sym_call_arguments,
    STATE(4701), 1,
      sym_subset_arguments,
    STATE(4708), 1,
      sym_subset2_arguments,
    ACTIONS(14301), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14307), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5351), 8,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
    ACTIONS(5349), 19,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [175505] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14275), 1,
      anon_sym_PLUS,
    ACTIONS(14277), 1,
      anon_sym_DASH,
    ACTIONS(14285), 1,
      anon_sym_PIPE,
    ACTIONS(14287), 1,
      anon_sym_AMP,
    ACTIONS(14289), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14291), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14297), 1,
      anon_sym_STAR,
    ACTIONS(14299), 1,
      anon_sym_SLASH,
    ACTIONS(14305), 1,
      anon_sym_COLON,
    ACTIONS(14311), 1,
      sym__external_open_parenthesis,
    ACTIONS(14313), 1,
      sym__external_open_bracket,
    ACTIONS(14315), 1,
      sym__external_open_bracket2,
    STATE(1395), 1,
      sym__open_bracket2,
    STATE(1397), 1,
      sym__open_bracket,
    STATE(1399), 1,
      sym__open_parenthesis,
    STATE(4698), 1,
      sym_call_arguments,
    STATE(4701), 1,
      sym_subset_arguments,
    STATE(4708), 1,
      sym_subset2_arguments,
    ACTIONS(5261), 2,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(14293), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14301), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14303), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14307), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14295), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5263), 9,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      sym_comma,
  [175600] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14271), 1,
      anon_sym_EQ,
    ACTIONS(14273), 1,
      anon_sym_TILDE,
    ACTIONS(14275), 1,
      anon_sym_PLUS,
    ACTIONS(14277), 1,
      anon_sym_DASH,
    ACTIONS(14281), 1,
      anon_sym_DASH_GT,
    ACTIONS(14283), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14285), 1,
      anon_sym_PIPE,
    ACTIONS(14287), 1,
      anon_sym_AMP,
    ACTIONS(14289), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14291), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14297), 1,
      anon_sym_STAR,
    ACTIONS(14299), 1,
      anon_sym_SLASH,
    ACTIONS(14305), 1,
      anon_sym_COLON,
    ACTIONS(14311), 1,
      sym__external_open_parenthesis,
    ACTIONS(14313), 1,
      sym__external_open_bracket,
    ACTIONS(14315), 1,
      sym__external_open_bracket2,
    STATE(1395), 1,
      sym__open_bracket2,
    STATE(1397), 1,
      sym__open_bracket,
    STATE(1399), 1,
      sym__open_parenthesis,
    STATE(4698), 1,
      sym_call_arguments,
    STATE(4701), 1,
      sym_subset_arguments,
    STATE(4708), 1,
      sym_subset2_arguments,
    ACTIONS(14293), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14301), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14303), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14307), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14279), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5263), 4,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(14295), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [175703] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14311), 1,
      sym__external_open_parenthesis,
    ACTIONS(14313), 1,
      sym__external_open_bracket,
    ACTIONS(14315), 1,
      sym__external_open_bracket2,
    STATE(1395), 1,
      sym__open_bracket2,
    STATE(1397), 1,
      sym__open_bracket,
    STATE(1399), 1,
      sym__open_parenthesis,
    STATE(4698), 1,
      sym_call_arguments,
    STATE(4701), 1,
      sym_subset_arguments,
    STATE(4708), 1,
      sym_subset2_arguments,
    ACTIONS(14301), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14307), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5335), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(5333), 19,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [175774] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14271), 1,
      anon_sym_EQ,
    ACTIONS(14273), 1,
      anon_sym_TILDE,
    ACTIONS(14275), 1,
      anon_sym_PLUS,
    ACTIONS(14277), 1,
      anon_sym_DASH,
    ACTIONS(14281), 1,
      anon_sym_DASH_GT,
    ACTIONS(14283), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14285), 1,
      anon_sym_PIPE,
    ACTIONS(14287), 1,
      anon_sym_AMP,
    ACTIONS(14289), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14291), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14297), 1,
      anon_sym_STAR,
    ACTIONS(14299), 1,
      anon_sym_SLASH,
    ACTIONS(14305), 1,
      anon_sym_COLON,
    ACTIONS(14311), 1,
      sym__external_open_parenthesis,
    ACTIONS(14313), 1,
      sym__external_open_bracket,
    ACTIONS(14315), 1,
      sym__external_open_bracket2,
    STATE(1395), 1,
      sym__open_bracket2,
    STATE(1397), 1,
      sym__open_bracket,
    STATE(1399), 1,
      sym__open_parenthesis,
    STATE(4698), 1,
      sym_call_arguments,
    STATE(4701), 1,
      sym_subset_arguments,
    STATE(4708), 1,
      sym_subset2_arguments,
    ACTIONS(14293), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14301), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14303), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14307), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14279), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5399), 4,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(14295), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [175877] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14275), 1,
      anon_sym_PLUS,
    ACTIONS(14277), 1,
      anon_sym_DASH,
    ACTIONS(14297), 1,
      anon_sym_STAR,
    ACTIONS(14299), 1,
      anon_sym_SLASH,
    ACTIONS(14305), 1,
      anon_sym_COLON,
    ACTIONS(14311), 1,
      sym__external_open_parenthesis,
    ACTIONS(14313), 1,
      sym__external_open_bracket,
    ACTIONS(14315), 1,
      sym__external_open_bracket2,
    STATE(1395), 1,
      sym__open_bracket2,
    STATE(1397), 1,
      sym__open_bracket,
    STATE(1399), 1,
      sym__open_parenthesis,
    STATE(4698), 1,
      sym_call_arguments,
    STATE(4701), 1,
      sym_subset_arguments,
    STATE(4708), 1,
      sym_subset2_arguments,
    ACTIONS(14293), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14301), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14303), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14307), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5335), 4,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(14295), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5333), 11,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_comma,
  [175964] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14271), 1,
      anon_sym_EQ,
    ACTIONS(14273), 1,
      anon_sym_TILDE,
    ACTIONS(14275), 1,
      anon_sym_PLUS,
    ACTIONS(14277), 1,
      anon_sym_DASH,
    ACTIONS(14281), 1,
      anon_sym_DASH_GT,
    ACTIONS(14283), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14285), 1,
      anon_sym_PIPE,
    ACTIONS(14287), 1,
      anon_sym_AMP,
    ACTIONS(14289), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14291), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14297), 1,
      anon_sym_STAR,
    ACTIONS(14299), 1,
      anon_sym_SLASH,
    ACTIONS(14305), 1,
      anon_sym_COLON,
    ACTIONS(14311), 1,
      sym__external_open_parenthesis,
    ACTIONS(14313), 1,
      sym__external_open_bracket,
    ACTIONS(14315), 1,
      sym__external_open_bracket2,
    STATE(1395), 1,
      sym__open_bracket2,
    STATE(1397), 1,
      sym__open_bracket,
    STATE(1399), 1,
      sym__open_parenthesis,
    STATE(4698), 1,
      sym_call_arguments,
    STATE(4701), 1,
      sym_subset_arguments,
    STATE(4708), 1,
      sym_subset2_arguments,
    ACTIONS(14293), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14301), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14303), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14307), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14279), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5449), 4,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(14295), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [176067] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14275), 1,
      anon_sym_PLUS,
    ACTIONS(14277), 1,
      anon_sym_DASH,
    ACTIONS(14285), 1,
      anon_sym_PIPE,
    ACTIONS(14287), 1,
      anon_sym_AMP,
    ACTIONS(14289), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14291), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14297), 1,
      anon_sym_STAR,
    ACTIONS(14299), 1,
      anon_sym_SLASH,
    ACTIONS(14305), 1,
      anon_sym_COLON,
    ACTIONS(14311), 1,
      sym__external_open_parenthesis,
    ACTIONS(14313), 1,
      sym__external_open_bracket,
    ACTIONS(14315), 1,
      sym__external_open_bracket2,
    STATE(1395), 1,
      sym__open_bracket2,
    STATE(1397), 1,
      sym__open_bracket,
    STATE(1399), 1,
      sym__open_parenthesis,
    STATE(4698), 1,
      sym_call_arguments,
    STATE(4701), 1,
      sym_subset_arguments,
    STATE(4708), 1,
      sym_subset2_arguments,
    ACTIONS(5335), 2,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(14293), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14301), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14303), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14307), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14295), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5333), 9,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      sym_comma,
  [176162] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14271), 1,
      anon_sym_EQ,
    ACTIONS(14273), 1,
      anon_sym_TILDE,
    ACTIONS(14275), 1,
      anon_sym_PLUS,
    ACTIONS(14277), 1,
      anon_sym_DASH,
    ACTIONS(14281), 1,
      anon_sym_DASH_GT,
    ACTIONS(14283), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14285), 1,
      anon_sym_PIPE,
    ACTIONS(14287), 1,
      anon_sym_AMP,
    ACTIONS(14289), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14291), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14297), 1,
      anon_sym_STAR,
    ACTIONS(14299), 1,
      anon_sym_SLASH,
    ACTIONS(14305), 1,
      anon_sym_COLON,
    ACTIONS(14311), 1,
      sym__external_open_parenthesis,
    ACTIONS(14313), 1,
      sym__external_open_bracket,
    ACTIONS(14315), 1,
      sym__external_open_bracket2,
    STATE(1395), 1,
      sym__open_bracket2,
    STATE(1397), 1,
      sym__open_bracket,
    STATE(1399), 1,
      sym__open_parenthesis,
    STATE(4698), 1,
      sym_call_arguments,
    STATE(4701), 1,
      sym_subset_arguments,
    STATE(4708), 1,
      sym_subset2_arguments,
    ACTIONS(14293), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14301), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14303), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14307), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14279), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5333), 4,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(14295), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [176265] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14271), 1,
      anon_sym_EQ,
    ACTIONS(14273), 1,
      anon_sym_TILDE,
    ACTIONS(14275), 1,
      anon_sym_PLUS,
    ACTIONS(14277), 1,
      anon_sym_DASH,
    ACTIONS(14281), 1,
      anon_sym_DASH_GT,
    ACTIONS(14283), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14285), 1,
      anon_sym_PIPE,
    ACTIONS(14287), 1,
      anon_sym_AMP,
    ACTIONS(14289), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14291), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14297), 1,
      anon_sym_STAR,
    ACTIONS(14299), 1,
      anon_sym_SLASH,
    ACTIONS(14305), 1,
      anon_sym_COLON,
    ACTIONS(14311), 1,
      sym__external_open_parenthesis,
    ACTIONS(14313), 1,
      sym__external_open_bracket,
    ACTIONS(14315), 1,
      sym__external_open_bracket2,
    STATE(1395), 1,
      sym__open_bracket2,
    STATE(1397), 1,
      sym__open_bracket,
    STATE(1399), 1,
      sym__open_parenthesis,
    STATE(4698), 1,
      sym_call_arguments,
    STATE(4701), 1,
      sym_subset_arguments,
    STATE(4708), 1,
      sym_subset2_arguments,
    ACTIONS(14293), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14301), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14303), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14307), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14279), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5329), 4,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(14295), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [176368] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14271), 1,
      anon_sym_EQ,
    ACTIONS(14273), 1,
      anon_sym_TILDE,
    ACTIONS(14275), 1,
      anon_sym_PLUS,
    ACTIONS(14277), 1,
      anon_sym_DASH,
    ACTIONS(14281), 1,
      anon_sym_DASH_GT,
    ACTIONS(14283), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14285), 1,
      anon_sym_PIPE,
    ACTIONS(14287), 1,
      anon_sym_AMP,
    ACTIONS(14289), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14291), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14297), 1,
      anon_sym_STAR,
    ACTIONS(14299), 1,
      anon_sym_SLASH,
    ACTIONS(14305), 1,
      anon_sym_COLON,
    ACTIONS(14311), 1,
      sym__external_open_parenthesis,
    ACTIONS(14313), 1,
      sym__external_open_bracket,
    ACTIONS(14315), 1,
      sym__external_open_bracket2,
    STATE(1395), 1,
      sym__open_bracket2,
    STATE(1397), 1,
      sym__open_bracket,
    STATE(1399), 1,
      sym__open_parenthesis,
    STATE(4698), 1,
      sym_call_arguments,
    STATE(4701), 1,
      sym_subset_arguments,
    STATE(4708), 1,
      sym_subset2_arguments,
    ACTIONS(14293), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14301), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14303), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14307), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14279), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5445), 4,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(14295), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [176471] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14271), 1,
      anon_sym_EQ,
    ACTIONS(14273), 1,
      anon_sym_TILDE,
    ACTIONS(14275), 1,
      anon_sym_PLUS,
    ACTIONS(14277), 1,
      anon_sym_DASH,
    ACTIONS(14281), 1,
      anon_sym_DASH_GT,
    ACTIONS(14283), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14285), 1,
      anon_sym_PIPE,
    ACTIONS(14287), 1,
      anon_sym_AMP,
    ACTIONS(14289), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14291), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14297), 1,
      anon_sym_STAR,
    ACTIONS(14299), 1,
      anon_sym_SLASH,
    ACTIONS(14305), 1,
      anon_sym_COLON,
    ACTIONS(14311), 1,
      sym__external_open_parenthesis,
    ACTIONS(14313), 1,
      sym__external_open_bracket,
    ACTIONS(14315), 1,
      sym__external_open_bracket2,
    STATE(1395), 1,
      sym__open_bracket2,
    STATE(1397), 1,
      sym__open_bracket,
    STATE(1399), 1,
      sym__open_parenthesis,
    STATE(4698), 1,
      sym_call_arguments,
    STATE(4701), 1,
      sym_subset_arguments,
    STATE(4708), 1,
      sym_subset2_arguments,
    ACTIONS(14293), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14301), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14303), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14307), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14279), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5441), 4,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(14295), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [176574] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14271), 1,
      anon_sym_EQ,
    ACTIONS(14273), 1,
      anon_sym_TILDE,
    ACTIONS(14275), 1,
      anon_sym_PLUS,
    ACTIONS(14277), 1,
      anon_sym_DASH,
    ACTIONS(14281), 1,
      anon_sym_DASH_GT,
    ACTIONS(14283), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14285), 1,
      anon_sym_PIPE,
    ACTIONS(14287), 1,
      anon_sym_AMP,
    ACTIONS(14289), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14291), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14297), 1,
      anon_sym_STAR,
    ACTIONS(14299), 1,
      anon_sym_SLASH,
    ACTIONS(14305), 1,
      anon_sym_COLON,
    ACTIONS(14311), 1,
      sym__external_open_parenthesis,
    ACTIONS(14313), 1,
      sym__external_open_bracket,
    ACTIONS(14315), 1,
      sym__external_open_bracket2,
    STATE(1395), 1,
      sym__open_bracket2,
    STATE(1397), 1,
      sym__open_bracket,
    STATE(1399), 1,
      sym__open_parenthesis,
    STATE(4698), 1,
      sym_call_arguments,
    STATE(4701), 1,
      sym_subset_arguments,
    STATE(4708), 1,
      sym_subset2_arguments,
    ACTIONS(14293), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14301), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14303), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14307), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14295), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5263), 7,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      sym_comma,
  [176675] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14311), 1,
      sym__external_open_parenthesis,
    ACTIONS(14313), 1,
      sym__external_open_bracket,
    ACTIONS(14315), 1,
      sym__external_open_bracket2,
    STATE(1395), 1,
      sym__open_bracket2,
    STATE(1397), 1,
      sym__open_bracket,
    STATE(1399), 1,
      sym__open_parenthesis,
    STATE(4698), 1,
      sym_call_arguments,
    STATE(4701), 1,
      sym_subset_arguments,
    STATE(4708), 1,
      sym_subset2_arguments,
    ACTIONS(14301), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14307), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5351), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(5349), 19,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [176746] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14271), 1,
      anon_sym_EQ,
    ACTIONS(14273), 1,
      anon_sym_TILDE,
    ACTIONS(14275), 1,
      anon_sym_PLUS,
    ACTIONS(14277), 1,
      anon_sym_DASH,
    ACTIONS(14281), 1,
      anon_sym_DASH_GT,
    ACTIONS(14283), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14285), 1,
      anon_sym_PIPE,
    ACTIONS(14287), 1,
      anon_sym_AMP,
    ACTIONS(14289), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14291), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14297), 1,
      anon_sym_STAR,
    ACTIONS(14299), 1,
      anon_sym_SLASH,
    ACTIONS(14305), 1,
      anon_sym_COLON,
    ACTIONS(14311), 1,
      sym__external_open_parenthesis,
    ACTIONS(14313), 1,
      sym__external_open_bracket,
    ACTIONS(14315), 1,
      sym__external_open_bracket2,
    STATE(1395), 1,
      sym__open_bracket2,
    STATE(1397), 1,
      sym__open_bracket,
    STATE(1399), 1,
      sym__open_parenthesis,
    STATE(4698), 1,
      sym_call_arguments,
    STATE(4701), 1,
      sym_subset_arguments,
    STATE(4708), 1,
      sym_subset2_arguments,
    ACTIONS(14293), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14301), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14303), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14307), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14279), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5437), 4,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(14295), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [176849] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14275), 1,
      anon_sym_PLUS,
    ACTIONS(14277), 1,
      anon_sym_DASH,
    ACTIONS(14285), 1,
      anon_sym_PIPE,
    ACTIONS(14287), 1,
      anon_sym_AMP,
    ACTIONS(14289), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14291), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14297), 1,
      anon_sym_STAR,
    ACTIONS(14299), 1,
      anon_sym_SLASH,
    ACTIONS(14305), 1,
      anon_sym_COLON,
    ACTIONS(14311), 1,
      sym__external_open_parenthesis,
    ACTIONS(14313), 1,
      sym__external_open_bracket,
    ACTIONS(14315), 1,
      sym__external_open_bracket2,
    STATE(1395), 1,
      sym__open_bracket2,
    STATE(1397), 1,
      sym__open_bracket,
    STATE(1399), 1,
      sym__open_parenthesis,
    STATE(4698), 1,
      sym_call_arguments,
    STATE(4701), 1,
      sym_subset_arguments,
    STATE(4708), 1,
      sym_subset2_arguments,
    ACTIONS(5351), 2,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(14293), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14301), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14303), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14307), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14295), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5349), 9,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      sym_comma,
  [176944] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14271), 1,
      anon_sym_EQ,
    ACTIONS(14273), 1,
      anon_sym_TILDE,
    ACTIONS(14275), 1,
      anon_sym_PLUS,
    ACTIONS(14277), 1,
      anon_sym_DASH,
    ACTIONS(14281), 1,
      anon_sym_DASH_GT,
    ACTIONS(14283), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14285), 1,
      anon_sym_PIPE,
    ACTIONS(14287), 1,
      anon_sym_AMP,
    ACTIONS(14289), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14291), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14297), 1,
      anon_sym_STAR,
    ACTIONS(14299), 1,
      anon_sym_SLASH,
    ACTIONS(14305), 1,
      anon_sym_COLON,
    ACTIONS(14311), 1,
      sym__external_open_parenthesis,
    ACTIONS(14313), 1,
      sym__external_open_bracket,
    ACTIONS(14315), 1,
      sym__external_open_bracket2,
    STATE(1395), 1,
      sym__open_bracket2,
    STATE(1397), 1,
      sym__open_bracket,
    STATE(1399), 1,
      sym__open_parenthesis,
    STATE(4698), 1,
      sym_call_arguments,
    STATE(4701), 1,
      sym_subset_arguments,
    STATE(4708), 1,
      sym_subset2_arguments,
    ACTIONS(14293), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14301), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14303), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14307), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14279), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5433), 4,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(14295), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [177047] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14271), 1,
      anon_sym_EQ,
    ACTIONS(14273), 1,
      anon_sym_TILDE,
    ACTIONS(14275), 1,
      anon_sym_PLUS,
    ACTIONS(14277), 1,
      anon_sym_DASH,
    ACTIONS(14281), 1,
      anon_sym_DASH_GT,
    ACTIONS(14283), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14285), 1,
      anon_sym_PIPE,
    ACTIONS(14287), 1,
      anon_sym_AMP,
    ACTIONS(14289), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14291), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14297), 1,
      anon_sym_STAR,
    ACTIONS(14299), 1,
      anon_sym_SLASH,
    ACTIONS(14305), 1,
      anon_sym_COLON,
    ACTIONS(14311), 1,
      sym__external_open_parenthesis,
    ACTIONS(14313), 1,
      sym__external_open_bracket,
    ACTIONS(14315), 1,
      sym__external_open_bracket2,
    STATE(1395), 1,
      sym__open_bracket2,
    STATE(1397), 1,
      sym__open_bracket,
    STATE(1399), 1,
      sym__open_parenthesis,
    STATE(4698), 1,
      sym_call_arguments,
    STATE(4701), 1,
      sym_subset_arguments,
    STATE(4708), 1,
      sym_subset2_arguments,
    ACTIONS(14293), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14301), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14303), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14307), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14279), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5417), 4,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(14295), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [177150] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14271), 1,
      anon_sym_EQ,
    ACTIONS(14273), 1,
      anon_sym_TILDE,
    ACTIONS(14275), 1,
      anon_sym_PLUS,
    ACTIONS(14277), 1,
      anon_sym_DASH,
    ACTIONS(14281), 1,
      anon_sym_DASH_GT,
    ACTIONS(14283), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14285), 1,
      anon_sym_PIPE,
    ACTIONS(14287), 1,
      anon_sym_AMP,
    ACTIONS(14289), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14291), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14297), 1,
      anon_sym_STAR,
    ACTIONS(14299), 1,
      anon_sym_SLASH,
    ACTIONS(14305), 1,
      anon_sym_COLON,
    ACTIONS(14311), 1,
      sym__external_open_parenthesis,
    ACTIONS(14313), 1,
      sym__external_open_bracket,
    ACTIONS(14315), 1,
      sym__external_open_bracket2,
    STATE(1395), 1,
      sym__open_bracket2,
    STATE(1397), 1,
      sym__open_bracket,
    STATE(1399), 1,
      sym__open_parenthesis,
    STATE(4698), 1,
      sym_call_arguments,
    STATE(4701), 1,
      sym_subset_arguments,
    STATE(4708), 1,
      sym_subset2_arguments,
    ACTIONS(14293), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14301), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14303), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14307), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14279), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5421), 4,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(14295), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [177253] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5425), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [177355] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5351), 4,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5349), 10,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_comma,
  [177441] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14382), 1,
      sym__external_close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(3926), 1,
      sym__close_parenthesis,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [177547] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14384), 1,
      sym__external_close_parenthesis,
    STATE(466), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [177653] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5349), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [177755] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14386), 1,
      sym__external_close_parenthesis,
    STATE(417), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [177861] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14388), 1,
      sym__external_close_parenthesis,
    STATE(467), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [177967] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14390), 1,
      sym__external_close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(3981), 1,
      sym__close_parenthesis,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [178073] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(5351), 2,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5349), 8,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      sym_comma,
  [178167] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14392), 1,
      sym__external_close_parenthesis,
    STATE(470), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [178273] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5351), 7,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5349), 15,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      sym_comma,
  [178351] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14394), 1,
      sym__external_close_parenthesis,
    STATE(261), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [178457] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5351), 6,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5349), 14,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      sym_comma,
  [178539] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5349), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [178641] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14396), 1,
      sym__external_close_parenthesis,
    STATE(231), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [178747] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14398), 1,
      sym__external_close_parenthesis,
    STATE(222), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [178853] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14400), 1,
      sym__external_close_parenthesis,
    STATE(220), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [178959] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5349), 6,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      sym_comma,
  [179059] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5347), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(5345), 18,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [179129] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5347), 4,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5345), 10,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_comma,
  [179215] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(5347), 2,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5345), 8,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      sym_comma,
  [179309] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14402), 2,
      sym__external_close_parenthesis,
      sym_comma,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [179413] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5345), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [179515] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5341), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [179617] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14404), 1,
      sym__external_close_parenthesis,
    STATE(368), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [179723] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14406), 1,
      sym__external_close_parenthesis,
    STATE(424), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [179829] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5351), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(5349), 18,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [179899] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14408), 1,
      sym__external_close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(3036), 1,
      sym__close_parenthesis,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [180005] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14410), 1,
      sym__external_close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(3055), 1,
      sym__close_parenthesis,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [180111] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(5351), 2,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5349), 7,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      sym_comma,
  [180207] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14412), 1,
      sym__external_close_parenthesis,
    STATE(389), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [180313] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5333), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [180415] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14414), 1,
      sym__external_close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(3090), 1,
      sym__close_parenthesis,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [180521] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14416), 1,
      sym__external_close_parenthesis,
    STATE(395), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [180627] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14418), 1,
      sym__external_close_parenthesis,
    STATE(397), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [180733] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14420), 1,
      sym__external_close_parenthesis,
    STATE(405), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [180839] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14422), 1,
      sym__external_close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(3100), 1,
      sym__close_parenthesis,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [180945] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14424), 1,
      sym__external_close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(3146), 1,
      sym__close_parenthesis,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [181051] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14426), 1,
      sym__external_close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(3148), 1,
      sym__close_parenthesis,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [181157] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14428), 1,
      sym__external_close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(3150), 1,
      sym__close_parenthesis,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [181263] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14430), 1,
      sym__external_close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(3152), 1,
      sym__close_parenthesis,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [181369] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14432), 1,
      sym__external_close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(3166), 1,
      sym__close_parenthesis,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [181475] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14434), 1,
      sym__external_close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(3170), 1,
      sym__close_parenthesis,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [181581] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14436), 1,
      sym__external_close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(3173), 1,
      sym__close_parenthesis,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [181687] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14438), 1,
      sym__external_close_parenthesis,
    STATE(361), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [181793] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5329), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [181895] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14440), 1,
      sym__external_close_parenthesis,
    STATE(360), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [182001] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14442), 1,
      sym__external_close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(3176), 1,
      sym__close_parenthesis,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [182107] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14444), 1,
      sym__external_close_parenthesis,
    STATE(358), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [182213] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14446), 1,
      sym__external_close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(3178), 1,
      sym__close_parenthesis,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [182319] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14448), 1,
      sym__external_close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(3186), 1,
      sym__close_parenthesis,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [182425] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(5335), 2,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5333), 8,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      sym_comma,
  [182519] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5335), 4,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5333), 10,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_comma,
  [182605] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14450), 1,
      sym__external_close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(3194), 1,
      sym__close_parenthesis,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [182711] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14452), 1,
      sym__external_close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(3197), 1,
      sym__close_parenthesis,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [182817] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14454), 1,
      sym__external_close_parenthesis,
    STATE(114), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [182923] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14456), 1,
      sym__external_close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(3029), 1,
      sym__close_parenthesis,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [183029] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14458), 1,
      sym__external_close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(3233), 1,
      sym__close_parenthesis,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [183135] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14460), 1,
      sym__external_close_parenthesis,
    STATE(116), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [183241] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14462), 1,
      sym__external_close_parenthesis,
    STATE(117), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [183347] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14464), 1,
      sym__external_close_parenthesis,
    STATE(125), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [183453] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14466), 1,
      sym__external_close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(3271), 1,
      sym__close_parenthesis,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [183559] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14468), 1,
      sym__external_close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(3274), 1,
      sym__close_parenthesis,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [183665] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14470), 1,
      sym__external_close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(3303), 1,
      sym__close_parenthesis,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [183771] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14472), 1,
      sym__external_close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(3310), 1,
      sym__close_parenthesis,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [183877] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14474), 1,
      sym__external_close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(3313), 1,
      sym__close_parenthesis,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [183983] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14476), 1,
      sym__external_close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(3315), 1,
      sym__close_parenthesis,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [184089] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14478), 1,
      sym__external_close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(3317), 1,
      sym__close_parenthesis,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [184195] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14480), 1,
      sym__external_close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(3331), 1,
      sym__close_parenthesis,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [184301] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5441), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [184403] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14482), 1,
      sym__external_close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(3348), 1,
      sym__close_parenthesis,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [184509] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14484), 1,
      sym__external_close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(3364), 1,
      sym__close_parenthesis,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [184615] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14486), 1,
      sym__external_close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(3370), 1,
      sym__close_parenthesis,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [184721] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14488), 1,
      sym__external_close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(3373), 1,
      sym__close_parenthesis,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [184827] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14490), 1,
      sym__external_close_parenthesis,
    STATE(267), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [184933] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14492), 1,
      sym__external_close_parenthesis,
    STATE(272), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [185039] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14494), 1,
      sym__external_close_parenthesis,
    STATE(273), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [185145] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14496), 1,
      sym__external_close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(3378), 1,
      sym__close_parenthesis,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [185251] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14498), 1,
      sym__external_close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(3380), 1,
      sym__close_parenthesis,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [185357] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14500), 1,
      sym__external_close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(3413), 1,
      sym__close_parenthesis,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [185463] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14502), 1,
      sym__external_close_parenthesis,
    STATE(132), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [185569] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14504), 1,
      sym__external_close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(3415), 1,
      sym__close_parenthesis,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [185675] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14506), 1,
      sym__external_close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(3421), 1,
      sym__close_parenthesis,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [185781] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14508), 1,
      sym__external_close_parenthesis,
    STATE(135), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [185887] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14510), 1,
      sym__external_close_parenthesis,
    STATE(137), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [185993] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14512), 1,
      sym__external_close_parenthesis,
    STATE(143), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [186099] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14514), 1,
      sym__external_close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(3423), 1,
      sym__close_parenthesis,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [186205] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14516), 1,
      sym__external_close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(3429), 1,
      sym__close_parenthesis,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [186311] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14518), 1,
      sym__external_close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(3431), 1,
      sym__close_parenthesis,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [186417] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14520), 1,
      sym__external_close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(3440), 1,
      sym__close_parenthesis,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [186523] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14522), 1,
      sym__external_close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(3447), 1,
      sym__close_parenthesis,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [186629] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14524), 1,
      sym__external_close_parenthesis,
    STATE(278), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [186735] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14526), 1,
      sym__external_close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(3481), 1,
      sym__close_parenthesis,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [186841] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14528), 1,
      sym__external_close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(3485), 1,
      sym__close_parenthesis,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [186947] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14530), 1,
      sym__external_close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(3511), 1,
      sym__close_parenthesis,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [187053] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14532), 1,
      sym__external_close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(3519), 1,
      sym__close_parenthesis,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [187159] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14534), 1,
      sym__external_close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(3535), 1,
      sym__close_parenthesis,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [187265] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5335), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(5333), 18,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [187335] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14536), 1,
      sym__external_close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(3546), 1,
      sym__close_parenthesis,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [187441] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14538), 1,
      sym__external_close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(3554), 1,
      sym__close_parenthesis,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [187547] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14540), 1,
      sym__external_close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(3557), 1,
      sym__close_parenthesis,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [187653] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14542), 1,
      sym__external_close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(3561), 1,
      sym__close_parenthesis,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [187759] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14544), 1,
      sym__external_close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(3564), 1,
      sym__close_parenthesis,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [187865] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14546), 1,
      sym__external_close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(3571), 1,
      sym__close_parenthesis,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [187971] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14548), 1,
      sym__external_close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(3579), 1,
      sym__close_parenthesis,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [188077] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14550), 1,
      sym__external_close_parenthesis,
    STATE(251), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [188183] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14552), 1,
      sym__external_close_parenthesis,
    STATE(448), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [188289] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14554), 1,
      sym__external_close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(3869), 1,
      sym__close_parenthesis,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [188395] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14556), 1,
      sym__external_close_parenthesis,
    STATE(243), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [188501] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14558), 1,
      sym__external_close_parenthesis,
    STATE(242), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [188607] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14560), 1,
      sym__external_close_parenthesis,
    STATE(239), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [188713] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14562), 1,
      sym__external_close_parenthesis,
    STATE(415), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [188819] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14564), 1,
      sym__external_close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(3883), 1,
      sym__close_parenthesis,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [188925] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14566), 1,
      sym__external_close_parenthesis,
    STATE(456), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [189031] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14568), 1,
      sym__external_close_parenthesis,
    STATE(453), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [189137] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5351), 8,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
    ACTIONS(5349), 18,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [189209] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5351), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(5349), 18,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [189279] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14570), 1,
      sym__external_close_parenthesis,
    STATE(341), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [189385] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5399), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [189487] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5337), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [189589] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14572), 1,
      sym__external_close_parenthesis,
    STATE(337), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [189695] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14574), 1,
      sym__external_close_parenthesis,
    STATE(311), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [189801] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14576), 1,
      sym__external_close_parenthesis,
    STATE(396), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [189907] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14578), 1,
      sym__external_close_parenthesis,
    STATE(398), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [190013] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14580), 1,
      sym__external_close_parenthesis,
    STATE(457), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [190119] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5263), 6,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      sym_comma,
  [190219] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14582), 1,
      sym__external_close_parenthesis,
    STATE(400), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [190325] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14584), 1,
      sym__external_close_parenthesis,
    STATE(79), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [190431] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14586), 1,
      sym__external_close_parenthesis,
    STATE(88), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [190537] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14588), 1,
      sym__external_close_parenthesis,
    STATE(89), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [190643] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14590), 1,
      sym__external_close_parenthesis,
    STATE(209), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [190749] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5263), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [190851] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14592), 1,
      sym__external_close_parenthesis,
    STATE(78), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [190957] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14594), 1,
      sym__external_close_parenthesis,
    STATE(207), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [191063] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14596), 1,
      sym__external_close_parenthesis,
    STATE(206), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [191169] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14598), 1,
      sym__external_close_parenthesis,
    STATE(249), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [191275] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14600), 1,
      sym__external_close_parenthesis,
    STATE(325), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [191381] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(5261), 2,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5263), 8,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      sym_comma,
  [191475] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5261), 7,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5263), 15,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      sym_comma,
  [191553] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5263), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [191655] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14602), 1,
      sym__external_close_parenthesis,
    STATE(82), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [191761] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5351), 8,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
    ACTIONS(5349), 16,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      sym_comma,
  [191835] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14604), 1,
      sym__external_close_parenthesis,
    STATE(92), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [191941] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14606), 1,
      sym__external_close_parenthesis,
    STATE(73), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [192047] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(5261), 2,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5263), 7,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      sym_comma,
  [192143] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14608), 1,
      sym__external_close_parenthesis,
    STATE(65), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [192249] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5261), 3,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5263), 9,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      sym_comma,
  [192339] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5261), 4,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5263), 10,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_comma,
  [192425] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5261), 6,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5263), 14,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      sym_comma,
  [192507] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14610), 1,
      sym__external_close_parenthesis,
    STATE(197), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [192613] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14612), 1,
      sym__external_close_parenthesis,
    STATE(193), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [192719] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14614), 1,
      sym__external_close_parenthesis,
    STATE(189), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [192825] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14616), 1,
      sym__external_close_parenthesis,
    STATE(175), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [192931] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14618), 1,
      sym__external_close_parenthesis,
    STATE(171), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [193037] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5261), 8,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
    ACTIONS(5263), 16,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      sym_comma,
  [193111] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14620), 1,
      sym__external_close_parenthesis,
    STATE(386), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [193217] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14622), 1,
      sym__external_close_parenthesis,
    STATE(166), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [193323] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14624), 1,
      sym__external_close_parenthesis,
    STATE(186), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [193429] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14626), 1,
      sym__external_close_parenthesis,
    STATE(384), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [193535] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14628), 1,
      sym__external_close_parenthesis,
    STATE(383), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [193641] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14630), 1,
      sym__external_close_parenthesis,
    STATE(378), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [193747] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14632), 1,
      sym__external_close_parenthesis,
    STATE(371), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [193853] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5261), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(5263), 18,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [193923] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5261), 8,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
    ACTIONS(5263), 18,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [193995] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5261), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(5263), 18,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [194065] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14634), 1,
      sym__external_close_parenthesis,
    STATE(223), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [194171] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14636), 1,
      sym__external_close_parenthesis,
    STATE(226), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [194277] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14638), 1,
      sym__external_close_parenthesis,
    STATE(227), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [194383] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14640), 1,
      sym__external_close_parenthesis,
    STATE(229), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [194489] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14642), 1,
      sym__external_close_parenthesis,
    STATE(168), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [194595] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5409), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [194697] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5453), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [194799] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14644), 1,
      sym__external_close_parenthesis,
    STATE(163), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [194905] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14646), 1,
      sym__external_close_parenthesis,
    STATE(162), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [195011] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14648), 1,
      sym__external_close_parenthesis,
    STATE(161), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [195117] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14650), 1,
      sym__external_close_parenthesis,
    STATE(158), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [195223] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14652), 1,
      sym__external_close_parenthesis,
    STATE(339), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [195329] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14654), 1,
      sym__external_close_parenthesis,
    STATE(419), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [195435] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5413), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [195537] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14656), 1,
      sym__external_close_parenthesis,
    STATE(253), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [195643] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14658), 1,
      sym__external_close_parenthesis,
    STATE(36), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [195749] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5449), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [195851] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14660), 1,
      sym__external_close_parenthesis,
    STATE(256), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [195957] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14662), 1,
      sym__external_close_parenthesis,
    STATE(26), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [196063] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14664), 1,
      sym__external_close_parenthesis,
    STATE(27), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [196169] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14666), 1,
      sym__external_close_parenthesis,
    STATE(31), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [196275] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14668), 1,
      sym__external_close_parenthesis,
    STATE(257), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [196381] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14670), 1,
      sym__external_close_parenthesis,
    STATE(259), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [196487] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14672), 1,
      sym__external_close_parenthesis,
    STATE(365), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [196593] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14674), 1,
      sym__external_close_parenthesis,
    STATE(442), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [196699] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14676), 1,
      sym__external_close_parenthesis,
    STATE(440), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [196805] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14678), 1,
      sym__external_close_parenthesis,
    STATE(439), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [196911] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14680), 1,
      sym__external_close_parenthesis,
    STATE(472), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [197017] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14682), 1,
      sym__external_close_parenthesis,
    STATE(436), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [197123] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5445), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [197225] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14684), 1,
      sym__external_close_parenthesis,
    STATE(349), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [197331] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14686), 1,
      sym__external_close_parenthesis,
    STATE(345), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [197437] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14688), 1,
      sym__external_close_parenthesis,
    STATE(344), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [197543] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5417), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [197645] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14690), 1,
      sym__external_close_parenthesis,
    STATE(340), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [197751] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14692), 1,
      sym__newline,
    STATE(4634), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(7419), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(7417), 29,
      sym__raw_string_literal,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      sym_identifier,
      sym_comma,
  [197803] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14695), 1,
      sym__external_close_parenthesis,
    STATE(381), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [197909] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14697), 1,
      sym__external_close_parenthesis,
    STATE(421), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [198015] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14699), 1,
      sym__external_close_parenthesis,
    STATE(425), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [198121] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14701), 1,
      sym__external_close_parenthesis,
    STATE(370), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [198227] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14703), 1,
      sym__external_close_parenthesis,
    STATE(301), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [198333] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5437), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [198435] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5421), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [198537] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14705), 1,
      sym__external_close_parenthesis,
    STATE(399), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [198643] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14707), 1,
      sym__external_close_parenthesis,
    STATE(331), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [198749] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14709), 1,
      sym__external_close_parenthesis,
    STATE(327), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [198855] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5351), 3,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5349), 9,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      sym_comma,
  [198945] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14711), 1,
      sym__external_close_parenthesis,
    STATE(303), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [199051] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14713), 1,
      sym__external_close_parenthesis,
    STATE(315), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [199157] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14715), 1,
      sym__external_close_parenthesis,
    STATE(316), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [199263] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14717), 1,
      sym__external_close_parenthesis,
    STATE(318), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [199369] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14719), 1,
      sym__external_close_parenthesis,
    STATE(426), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [199475] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    ACTIONS(14380), 1,
      anon_sym_QMARK,
    ACTIONS(14721), 1,
      sym__external_close_parenthesis,
    STATE(428), 1,
      sym__close_parenthesis,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [199581] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5429), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [199683] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_EQ,
    ACTIONS(14338), 1,
      anon_sym_TILDE,
    ACTIONS(14340), 1,
      anon_sym_PLUS,
    ACTIONS(14342), 1,
      anon_sym_DASH,
    ACTIONS(14346), 1,
      anon_sym_DASH_GT,
    ACTIONS(14348), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(14350), 1,
      anon_sym_PIPE,
    ACTIONS(14352), 1,
      anon_sym_AMP,
    ACTIONS(14354), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(14356), 1,
      anon_sym_AMP_AMP,
    ACTIONS(14362), 1,
      anon_sym_STAR,
    ACTIONS(14364), 1,
      anon_sym_SLASH,
    ACTIONS(14370), 1,
      anon_sym_COLON,
    ACTIONS(14374), 1,
      sym__external_open_parenthesis,
    ACTIONS(14376), 1,
      sym__external_open_bracket,
    ACTIONS(14378), 1,
      sym__external_open_bracket2,
    STATE(1478), 1,
      sym__open_parenthesis,
    STATE(1529), 1,
      sym__open_bracket,
    STATE(1604), 1,
      sym__open_bracket2,
    STATE(4713), 1,
      sym_subset2_arguments,
    STATE(4721), 1,
      sym_call_arguments,
    STATE(4722), 1,
      sym_subset_arguments,
    ACTIONS(14358), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(14366), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(14368), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(14372), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5433), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(14344), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(14360), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [199785] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14725), 16,
      sym__newline,
      sym__raw_string_literal,
      sym__external_open_parenthesis,
      sym__external_open_brace,
      sym__external_close_bracket,
      anon_sym_BSLASH,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym__hex_literal_token1,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      sym_dot_dot_i,
      sym_comma,
    ACTIONS(14723), 21,
      anon_sym_function,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_repeat,
      sym__number_literal,
      sym_identifier,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
      sym_dots,
  [199830] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7163), 10,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_COLON_COLON,
    ACTIONS(7165), 27,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      sym_comma,
  [199875] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14729), 16,
      sym__newline,
      sym__raw_string_literal,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_brace,
      anon_sym_BSLASH,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym__hex_literal_token1,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      sym_dot_dot_i,
      sym_comma,
    ACTIONS(14727), 21,
      anon_sym_function,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_repeat,
      sym__number_literal,
      sym_identifier,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
      sym_dots,
  [199920] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14733), 16,
      sym__newline,
      sym__raw_string_literal,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_brace,
      anon_sym_BSLASH,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym__hex_literal_token1,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      sym_dot_dot_i,
      sym_comma,
    ACTIONS(14731), 21,
      anon_sym_function,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_repeat,
      sym__number_literal,
      sym_identifier,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
      sym_dots,
  [199965] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14725), 16,
      sym__newline,
      sym__raw_string_literal,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_brace,
      anon_sym_BSLASH,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym__hex_literal_token1,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      sym_dot_dot_i,
      sym_comma,
    ACTIONS(14723), 21,
      anon_sym_function,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_repeat,
      sym__number_literal,
      sym_identifier,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
      sym_dots,
  [200010] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14733), 16,
      sym__newline,
      sym__raw_string_literal,
      sym__external_open_parenthesis,
      sym__external_open_brace,
      sym__external_close_bracket,
      anon_sym_BSLASH,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym__hex_literal_token1,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      sym_dot_dot_i,
      sym_comma,
    ACTIONS(14731), 21,
      anon_sym_function,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_repeat,
      sym__number_literal,
      sym_identifier,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
      sym_dots,
  [200055] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7143), 16,
      sym__newline,
      sym__raw_string_literal,
      sym__external_open_parenthesis,
      sym__external_open_brace,
      sym__external_close_bracket2,
      anon_sym_BSLASH,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym__hex_literal_token1,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      sym_dot_dot_i,
      sym_comma,
    ACTIONS(7141), 21,
      anon_sym_function,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_repeat,
      sym__number_literal,
      sym_identifier,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
      sym_dots,
  [200100] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14733), 16,
      sym__newline,
      sym__raw_string_literal,
      sym__external_open_parenthesis,
      sym__external_open_brace,
      sym__external_close_bracket2,
      anon_sym_BSLASH,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym__hex_literal_token1,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      sym_dot_dot_i,
      sym_comma,
    ACTIONS(14731), 21,
      anon_sym_function,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_repeat,
      sym__number_literal,
      sym_identifier,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
      sym_dots,
  [200145] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14737), 16,
      sym__newline,
      sym__raw_string_literal,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_brace,
      anon_sym_BSLASH,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym__hex_literal_token1,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      sym_dot_dot_i,
      sym_comma,
    ACTIONS(14735), 21,
      anon_sym_function,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_repeat,
      sym__number_literal,
      sym_identifier,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
      sym_dots,
  [200190] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14741), 16,
      sym__newline,
      sym__raw_string_literal,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_brace,
      anon_sym_BSLASH,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym__hex_literal_token1,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      sym_dot_dot_i,
      sym_comma,
    ACTIONS(14739), 21,
      anon_sym_function,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_repeat,
      sym__number_literal,
      sym_identifier,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
      sym_dots,
  [200235] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14729), 16,
      sym__newline,
      sym__raw_string_literal,
      sym__external_open_parenthesis,
      sym__external_open_brace,
      sym__external_close_bracket,
      anon_sym_BSLASH,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym__hex_literal_token1,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      sym_dot_dot_i,
      sym_comma,
    ACTIONS(14727), 21,
      anon_sym_function,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_repeat,
      sym__number_literal,
      sym_identifier,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
      sym_dots,
  [200280] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14729), 16,
      sym__newline,
      sym__raw_string_literal,
      sym__external_open_parenthesis,
      sym__external_open_brace,
      sym__external_close_bracket2,
      anon_sym_BSLASH,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym__hex_literal_token1,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      sym_dot_dot_i,
      sym_comma,
    ACTIONS(14727), 21,
      anon_sym_function,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_repeat,
      sym__number_literal,
      sym_identifier,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
      sym_dots,
  [200325] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7143), 16,
      sym__newline,
      sym__raw_string_literal,
      sym__external_open_parenthesis,
      sym__external_open_brace,
      sym__external_close_bracket,
      anon_sym_BSLASH,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym__hex_literal_token1,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      sym_dot_dot_i,
      sym_comma,
    ACTIONS(7141), 21,
      anon_sym_function,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_repeat,
      sym__number_literal,
      sym_identifier,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
      sym_dots,
  [200370] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14745), 16,
      sym__newline,
      sym__raw_string_literal,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_brace,
      anon_sym_BSLASH,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym__hex_literal_token1,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      sym_dot_dot_i,
      sym_comma,
    ACTIONS(14743), 21,
      anon_sym_function,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_repeat,
      sym__number_literal,
      sym_identifier,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
      sym_dots,
  [200415] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7195), 10,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_COLON_COLON,
    ACTIONS(7193), 27,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      sym_comma,
  [200460] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14725), 16,
      sym__newline,
      sym__raw_string_literal,
      sym__external_open_parenthesis,
      sym__external_open_brace,
      sym__external_close_bracket2,
      anon_sym_BSLASH,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym__hex_literal_token1,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      sym_dot_dot_i,
      sym_comma,
    ACTIONS(14723), 21,
      anon_sym_function,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_repeat,
      sym__number_literal,
      sym_identifier,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
      sym_dots,
  [200505] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7151), 10,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_COLON_COLON,
    ACTIONS(7153), 27,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      sym_comma,
  [200550] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14745), 16,
      sym__newline,
      sym__raw_string_literal,
      sym__external_open_parenthesis,
      sym__external_open_brace,
      sym__external_close_bracket2,
      anon_sym_BSLASH,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym__hex_literal_token1,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      sym_dot_dot_i,
      sym_comma,
    ACTIONS(14743), 21,
      anon_sym_function,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_repeat,
      sym__number_literal,
      sym_identifier,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
      sym_dots,
  [200595] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7143), 16,
      sym__newline,
      sym__raw_string_literal,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_brace,
      anon_sym_BSLASH,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym__hex_literal_token1,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      sym_dot_dot_i,
      sym_comma,
    ACTIONS(7141), 21,
      anon_sym_function,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_repeat,
      sym__number_literal,
      sym_identifier,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
      sym_dots,
  [200640] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14737), 16,
      sym__newline,
      sym__raw_string_literal,
      sym__external_open_parenthesis,
      sym__external_open_brace,
      sym__external_close_bracket2,
      anon_sym_BSLASH,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym__hex_literal_token1,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      sym_dot_dot_i,
      sym_comma,
    ACTIONS(14735), 21,
      anon_sym_function,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_repeat,
      sym__number_literal,
      sym_identifier,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
      sym_dots,
  [200685] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7115), 10,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_COLON_COLON,
    ACTIONS(7117), 27,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      sym_comma,
  [200730] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7191), 10,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_COLON_COLON,
    ACTIONS(7189), 27,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      sym_comma,
  [200775] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14737), 16,
      sym__newline,
      sym__raw_string_literal,
      sym__external_open_parenthesis,
      sym__external_open_brace,
      sym__external_close_bracket,
      anon_sym_BSLASH,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym__hex_literal_token1,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      sym_dot_dot_i,
      sym_comma,
    ACTIONS(14735), 21,
      anon_sym_function,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_repeat,
      sym__number_literal,
      sym_identifier,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
      sym_dots,
  [200820] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14741), 16,
      sym__newline,
      sym__raw_string_literal,
      sym__external_open_parenthesis,
      sym__external_open_brace,
      sym__external_close_bracket,
      anon_sym_BSLASH,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym__hex_literal_token1,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      sym_dot_dot_i,
      sym_comma,
    ACTIONS(14739), 21,
      anon_sym_function,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_repeat,
      sym__number_literal,
      sym_identifier,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
      sym_dots,
  [200865] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7115), 10,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_COLON_COLON,
    ACTIONS(7117), 27,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      sym_comma,
  [200910] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14741), 16,
      sym__newline,
      sym__raw_string_literal,
      sym__external_open_parenthesis,
      sym__external_open_brace,
      sym__external_close_bracket2,
      anon_sym_BSLASH,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym__hex_literal_token1,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      sym_dot_dot_i,
      sym_comma,
    ACTIONS(14739), 21,
      anon_sym_function,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_repeat,
      sym__number_literal,
      sym_identifier,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
      sym_dots,
  [200955] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14747), 1,
      anon_sym_L,
    ACTIONS(14749), 1,
      anon_sym_i,
    ACTIONS(7121), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(7123), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [201004] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7133), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7135), 1,
      anon_sym_COLON_COLON_COLON,
    ACTIONS(7129), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(7131), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [201053] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14745), 16,
      sym__newline,
      sym__raw_string_literal,
      sym__external_open_parenthesis,
      sym__external_open_brace,
      sym__external_close_bracket,
      anon_sym_BSLASH,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym__hex_literal_token1,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      sym_dot_dot_i,
      sym_comma,
    ACTIONS(14743), 21,
      anon_sym_function,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_repeat,
      sym__number_literal,
      sym_identifier,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
      sym_dots,
  [201098] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7137), 10,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_COLON_COLON,
    ACTIONS(7139), 27,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      sym_comma,
  [201143] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7115), 10,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_COLON_COLON,
    ACTIONS(7117), 26,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      sym_comma,
  [201187] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7163), 10,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_COLON_COLON,
    ACTIONS(7165), 26,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      sym_comma,
  [201231] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7191), 10,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_COLON_COLON,
    ACTIONS(7189), 26,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      sym_comma,
  [201275] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7137), 10,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_COLON_COLON,
    ACTIONS(7139), 26,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      sym_comma,
  [201319] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7195), 10,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_COLON_COLON,
    ACTIONS(7193), 26,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      sym_comma,
  [201363] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7133), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7135), 1,
      anon_sym_COLON_COLON_COLON,
    ACTIONS(7129), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(7131), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [201411] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14751), 1,
      anon_sym_L,
    ACTIONS(14753), 1,
      anon_sym_i,
    ACTIONS(7121), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(7123), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [201459] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7115), 10,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_COLON_COLON,
    ACTIONS(7117), 26,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      sym_comma,
  [201503] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7151), 10,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_COLON_COLON,
    ACTIONS(7153), 26,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      sym_comma,
  [201547] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14755), 1,
      sym__newline,
    STATE(4693), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(7417), 13,
      sym__raw_string_literal,
      sym__external_open_parenthesis,
      sym__external_open_brace,
      anon_sym_BSLASH,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym__hex_literal_token1,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      sym_dot_dot_i,
    ACTIONS(7419), 21,
      anon_sym_function,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_repeat,
      sym__number_literal,
      sym_identifier,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
      sym_dots,
  [201595] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7486), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(7484), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [201638] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7544), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(7542), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [201681] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7490), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(7488), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [201724] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7540), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(7538), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [201767] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7532), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(7530), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [201810] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7498), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(7496), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [201853] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7520), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(7518), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [201896] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7528), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(7526), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [201939] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7502), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(7500), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [201982] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7552), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(7550), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [202025] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7494), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(7492), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [202068] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7506), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(7504), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [202111] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7512), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(7510), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [202154] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7482), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(7480), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [202197] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7524), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(7522), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [202240] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7478), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(7476), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [202283] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7516), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(7514), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [202326] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7474), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(7472), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [202369] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7464), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(7466), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [202412] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7524), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(7522), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [202454] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7512), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(7510), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [202496] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7474), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(7472), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [202538] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7552), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(7550), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [202580] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7540), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(7538), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [202622] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7502), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(7500), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [202664] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7544), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(7542), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [202706] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7486), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(7484), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [202748] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7532), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(7530), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [202790] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7528), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(7526), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [202832] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7464), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(7466), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [202874] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7520), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(7518), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [202916] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7478), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(7476), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [202958] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7490), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(7488), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [203000] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7482), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(7480), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [203042] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7494), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(7492), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [203084] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7506), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(7504), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [203126] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7498), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(7496), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [203168] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7516), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(7514), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [203210] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14758), 1,
      sym_identifier,
    ACTIONS(14760), 1,
      sym_dots,
    ACTIONS(14762), 1,
      sym__external_close_parenthesis,
    STATE(2294), 1,
      sym__close_parenthesis,
    STATE(4767), 1,
      sym_parameter,
    STATE(5132), 1,
      sym__parameter_without_default,
    STATE(5136), 1,
      sym__parameter_with_default,
  [203235] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14758), 1,
      sym_identifier,
    ACTIONS(14760), 1,
      sym_dots,
    ACTIONS(14764), 1,
      sym__external_close_parenthesis,
    STATE(2856), 1,
      sym__close_parenthesis,
    STATE(4871), 1,
      sym_parameter,
    STATE(5132), 1,
      sym__parameter_without_default,
    STATE(5136), 1,
      sym__parameter_with_default,
  [203260] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14758), 1,
      sym_identifier,
    ACTIONS(14760), 1,
      sym_dots,
    ACTIONS(14766), 1,
      sym__external_close_parenthesis,
    STATE(2783), 1,
      sym__close_parenthesis,
    STATE(4782), 1,
      sym_parameter,
    STATE(5132), 1,
      sym__parameter_without_default,
    STATE(5136), 1,
      sym__parameter_with_default,
  [203285] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14758), 1,
      sym_identifier,
    ACTIONS(14760), 1,
      sym_dots,
    ACTIONS(14768), 1,
      sym__external_close_parenthesis,
    STATE(2947), 1,
      sym__close_parenthesis,
    STATE(4898), 1,
      sym_parameter,
    STATE(5132), 1,
      sym__parameter_without_default,
    STATE(5136), 1,
      sym__parameter_with_default,
  [203310] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14758), 1,
      sym_identifier,
    ACTIONS(14760), 1,
      sym_dots,
    ACTIONS(14770), 1,
      sym__external_close_parenthesis,
    STATE(3020), 1,
      sym__close_parenthesis,
    STATE(5082), 1,
      sym_parameter,
    STATE(5132), 1,
      sym__parameter_without_default,
    STATE(5136), 1,
      sym__parameter_with_default,
  [203335] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14758), 1,
      sym_identifier,
    ACTIONS(14760), 1,
      sym_dots,
    ACTIONS(14772), 1,
      sym__external_close_parenthesis,
    STATE(2535), 1,
      sym__close_parenthesis,
    STATE(5061), 1,
      sym_parameter,
    STATE(5132), 1,
      sym__parameter_without_default,
    STATE(5136), 1,
      sym__parameter_with_default,
  [203360] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14758), 1,
      sym_identifier,
    ACTIONS(14760), 1,
      sym_dots,
    ACTIONS(14774), 1,
      sym__external_close_parenthesis,
    STATE(3016), 1,
      sym__close_parenthesis,
    STATE(4858), 1,
      sym_parameter,
    STATE(5132), 1,
      sym__parameter_without_default,
    STATE(5136), 1,
      sym__parameter_with_default,
  [203385] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14758), 1,
      sym_identifier,
    ACTIONS(14760), 1,
      sym_dots,
    ACTIONS(14776), 1,
      sym__external_close_parenthesis,
    STATE(2583), 1,
      sym__close_parenthesis,
    STATE(5017), 1,
      sym_parameter,
    STATE(5132), 1,
      sym__parameter_without_default,
    STATE(5136), 1,
      sym__parameter_with_default,
  [203410] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14758), 1,
      sym_identifier,
    ACTIONS(14760), 1,
      sym_dots,
    ACTIONS(14778), 1,
      sym__external_close_parenthesis,
    STATE(2963), 1,
      sym__close_parenthesis,
    STATE(5056), 1,
      sym_parameter,
    STATE(5132), 1,
      sym__parameter_without_default,
    STATE(5136), 1,
      sym__parameter_with_default,
  [203435] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14758), 1,
      sym_identifier,
    ACTIONS(14760), 1,
      sym_dots,
    ACTIONS(14780), 1,
      sym__external_close_parenthesis,
    STATE(2446), 1,
      sym__close_parenthesis,
    STATE(4806), 1,
      sym_parameter,
    STATE(5132), 1,
      sym__parameter_without_default,
    STATE(5136), 1,
      sym__parameter_with_default,
  [203460] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14758), 1,
      sym_identifier,
    ACTIONS(14760), 1,
      sym_dots,
    ACTIONS(14782), 1,
      sym__external_close_parenthesis,
    STATE(2822), 1,
      sym__close_parenthesis,
    STATE(4835), 1,
      sym_parameter,
    STATE(5132), 1,
      sym__parameter_without_default,
    STATE(5136), 1,
      sym__parameter_with_default,
  [203485] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14758), 1,
      sym_identifier,
    ACTIONS(14760), 1,
      sym_dots,
    ACTIONS(14784), 1,
      sym__external_close_parenthesis,
    STATE(2850), 1,
      sym__close_parenthesis,
    STATE(5029), 1,
      sym_parameter,
    STATE(5132), 1,
      sym__parameter_without_default,
    STATE(5136), 1,
      sym__parameter_with_default,
  [203510] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14758), 1,
      sym_identifier,
    ACTIONS(14760), 1,
      sym_dots,
    ACTIONS(14786), 1,
      sym__external_close_parenthesis,
    STATE(2598), 1,
      sym__close_parenthesis,
    STATE(5070), 1,
      sym_parameter,
    STATE(5132), 1,
      sym__parameter_without_default,
    STATE(5136), 1,
      sym__parameter_with_default,
  [203535] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14758), 1,
      sym_identifier,
    ACTIONS(14760), 1,
      sym_dots,
    ACTIONS(14788), 1,
      sym__external_close_parenthesis,
    STATE(2743), 1,
      sym__close_parenthesis,
    STATE(4957), 1,
      sym_parameter,
    STATE(5132), 1,
      sym__parameter_without_default,
    STATE(5136), 1,
      sym__parameter_with_default,
  [203560] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14758), 1,
      sym_identifier,
    ACTIONS(14760), 1,
      sym_dots,
    ACTIONS(14790), 1,
      sym__external_close_parenthesis,
    STATE(2829), 1,
      sym__close_parenthesis,
    STATE(5092), 1,
      sym_parameter,
    STATE(5132), 1,
      sym__parameter_without_default,
    STATE(5136), 1,
      sym__parameter_with_default,
  [203585] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14758), 1,
      sym_identifier,
    ACTIONS(14760), 1,
      sym_dots,
    ACTIONS(14792), 1,
      sym__external_close_parenthesis,
    STATE(2709), 1,
      sym__close_parenthesis,
    STATE(4840), 1,
      sym_parameter,
    STATE(5132), 1,
      sym__parameter_without_default,
    STATE(5136), 1,
      sym__parameter_with_default,
  [203610] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14758), 1,
      sym_identifier,
    ACTIONS(14760), 1,
      sym_dots,
    ACTIONS(14794), 1,
      sym__external_close_parenthesis,
    STATE(2918), 1,
      sym__close_parenthesis,
    STATE(4987), 1,
      sym_parameter,
    STATE(5132), 1,
      sym__parameter_without_default,
    STATE(5136), 1,
      sym__parameter_with_default,
  [203635] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14758), 1,
      sym_identifier,
    ACTIONS(14760), 1,
      sym_dots,
    ACTIONS(14796), 1,
      sym__external_close_parenthesis,
    STATE(2393), 1,
      sym__close_parenthesis,
    STATE(4961), 1,
      sym_parameter,
    STATE(5132), 1,
      sym__parameter_without_default,
    STATE(5136), 1,
      sym__parameter_with_default,
  [203660] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14758), 1,
      sym_identifier,
    ACTIONS(14760), 1,
      sym_dots,
    ACTIONS(14798), 1,
      sym__external_close_parenthesis,
    STATE(2848), 1,
      sym__close_parenthesis,
    STATE(4799), 1,
      sym_parameter,
    STATE(5132), 1,
      sym__parameter_without_default,
    STATE(5136), 1,
      sym__parameter_with_default,
  [203685] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14758), 1,
      sym_identifier,
    ACTIONS(14760), 1,
      sym_dots,
    ACTIONS(14800), 1,
      sym__external_close_parenthesis,
    STATE(2689), 1,
      sym__close_parenthesis,
    STATE(4901), 1,
      sym_parameter,
    STATE(5132), 1,
      sym__parameter_without_default,
    STATE(5136), 1,
      sym__parameter_with_default,
  [203710] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14758), 1,
      sym_identifier,
    ACTIONS(14760), 1,
      sym_dots,
    ACTIONS(14802), 1,
      sym__external_close_parenthesis,
    STATE(2723), 1,
      sym__close_parenthesis,
    STATE(4852), 1,
      sym_parameter,
    STATE(5132), 1,
      sym__parameter_without_default,
    STATE(5136), 1,
      sym__parameter_with_default,
  [203735] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14758), 1,
      sym_identifier,
    ACTIONS(14760), 1,
      sym_dots,
    ACTIONS(14804), 1,
      sym__external_close_parenthesis,
    STATE(2511), 1,
      sym__close_parenthesis,
    STATE(5053), 1,
      sym_parameter,
    STATE(5132), 1,
      sym__parameter_without_default,
    STATE(5136), 1,
      sym__parameter_with_default,
  [203760] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14758), 1,
      sym_identifier,
    ACTIONS(14760), 1,
      sym_dots,
    ACTIONS(14806), 1,
      sym__external_close_parenthesis,
    STATE(2301), 1,
      sym__close_parenthesis,
    STATE(4788), 1,
      sym_parameter,
    STATE(5132), 1,
      sym__parameter_without_default,
    STATE(5136), 1,
      sym__parameter_with_default,
  [203785] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14758), 1,
      sym_identifier,
    ACTIONS(14760), 1,
      sym_dots,
    ACTIONS(14808), 1,
      sym__external_close_parenthesis,
    STATE(2924), 1,
      sym__close_parenthesis,
    STATE(4838), 1,
      sym_parameter,
    STATE(5132), 1,
      sym__parameter_without_default,
    STATE(5136), 1,
      sym__parameter_with_default,
  [203810] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14758), 1,
      sym_identifier,
    ACTIONS(14760), 1,
      sym_dots,
    ACTIONS(14810), 1,
      sym__external_close_parenthesis,
    STATE(2285), 1,
      sym__close_parenthesis,
    STATE(4790), 1,
      sym_parameter,
    STATE(5132), 1,
      sym__parameter_without_default,
    STATE(5136), 1,
      sym__parameter_with_default,
  [203835] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14758), 1,
      sym_identifier,
    ACTIONS(14760), 1,
      sym_dots,
    ACTIONS(14812), 1,
      sym__external_close_parenthesis,
    STATE(2431), 1,
      sym__close_parenthesis,
    STATE(5009), 1,
      sym_parameter,
    STATE(5132), 1,
      sym__parameter_without_default,
    STATE(5136), 1,
      sym__parameter_with_default,
  [203860] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14758), 1,
      sym_identifier,
    ACTIONS(14760), 1,
      sym_dots,
    STATE(5132), 1,
      sym__parameter_without_default,
    STATE(5136), 1,
      sym__parameter_with_default,
    STATE(5146), 1,
      sym_parameter,
  [203879] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14814), 1,
      sym_comma,
    ACTIONS(14816), 1,
      sym__external_close_parenthesis,
    STATE(2926), 1,
      sym__close_parenthesis,
    STATE(5110), 1,
      aux_sym_parameters_repeat1,
  [203895] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(14820), 1,
      sym__external_open_parenthesis,
    STATE(4266), 1,
      sym__open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
  [203911] = 4,
    ACTIONS(14822), 1,
      anon_sym_DQUOTE,
    ACTIONS(14826), 1,
      sym_comment,
    STATE(4817), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(14824), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [203925] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(14828), 1,
      anon_sym_SQUOTE,
    STATE(5076), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(14830), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [203939] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(14832), 1,
      anon_sym_DQUOTE,
    STATE(5074), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(14824), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [203953] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(14834), 1,
      anon_sym_SQUOTE,
    STATE(4812), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(14830), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [203967] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(14836), 1,
      sym__external_open_parenthesis,
    STATE(4262), 1,
      sym__open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
  [203983] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(14838), 1,
      anon_sym_SQUOTE,
    STATE(4854), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(14830), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [203997] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14814), 1,
      sym_comma,
    ACTIONS(14840), 1,
      sym__external_close_parenthesis,
    STATE(2297), 1,
      sym__close_parenthesis,
    STATE(4769), 1,
      aux_sym_parameters_repeat1,
  [204013] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(14842), 1,
      anon_sym_DQUOTE,
    STATE(5074), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(14824), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [204027] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14814), 1,
      sym_comma,
    ACTIONS(14844), 1,
      sym__external_close_parenthesis,
    STATE(2298), 1,
      sym__close_parenthesis,
    STATE(5110), 1,
      aux_sym_parameters_repeat1,
  [204043] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(14846), 1,
      anon_sym_SQUOTE,
    STATE(5076), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(14830), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [204057] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14814), 1,
      sym_comma,
    ACTIONS(14848), 1,
      sym__external_close_parenthesis,
    STATE(2800), 1,
      sym__close_parenthesis,
    STATE(5110), 1,
      aux_sym_parameters_repeat1,
  [204073] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14850), 1,
      sym__newline,
    ACTIONS(14852), 1,
      sym__external_open_parenthesis,
    STATE(4091), 1,
      sym__open_parenthesis,
    STATE(4765), 1,
      aux_sym_function_definition_repeat1,
  [204089] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(14854), 1,
      anon_sym_SQUOTE,
    STATE(4777), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(14830), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [204103] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(14856), 1,
      anon_sym_DQUOTE,
    STATE(4778), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(14824), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [204117] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(14858), 1,
      sym__external_open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
    STATE(5164), 1,
      sym__open_parenthesis,
  [204133] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(14860), 1,
      anon_sym_DQUOTE,
    STATE(4857), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(14824), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [204147] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(14862), 1,
      anon_sym_SQUOTE,
    STATE(5076), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(14830), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [204161] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(14864), 1,
      anon_sym_DQUOTE,
    STATE(5074), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(14824), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [204175] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14866), 1,
      sym__newline,
    ACTIONS(14868), 1,
      sym__external_open_parenthesis,
    STATE(4775), 1,
      aux_sym_function_definition_repeat1,
    STATE(5163), 1,
      sym__open_parenthesis,
  [204191] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(14870), 1,
      anon_sym_DQUOTE,
    STATE(4768), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(14824), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [204205] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(14872), 1,
      anon_sym_SQUOTE,
    STATE(4770), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(14830), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [204219] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14814), 1,
      sym_comma,
    ACTIONS(14874), 1,
      sym__external_close_parenthesis,
    STATE(2930), 1,
      sym__close_parenthesis,
    STATE(4866), 1,
      aux_sym_parameters_repeat1,
  [204235] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(14876), 1,
      sym__external_open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
    STATE(5162), 1,
      sym__open_parenthesis,
  [204251] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(14878), 1,
      anon_sym_DQUOTE,
    STATE(4763), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(14824), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [204265] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(14880), 1,
      sym__external_open_parenthesis,
    STATE(4261), 1,
      sym__open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
  [204281] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(14882), 1,
      anon_sym_SQUOTE,
    STATE(4762), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(14830), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [204295] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14884), 1,
      sym__newline,
    ACTIONS(14886), 1,
      sym__external_open_parenthesis,
    STATE(4783), 1,
      aux_sym_function_definition_repeat1,
    STATE(5160), 1,
      sym__open_parenthesis,
  [204311] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14814), 1,
      sym_comma,
    ACTIONS(14888), 1,
      sym__external_close_parenthesis,
    STATE(2308), 1,
      sym__close_parenthesis,
    STATE(4791), 1,
      aux_sym_parameters_repeat1,
  [204327] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14814), 1,
      sym_comma,
    ACTIONS(14890), 1,
      sym__external_close_parenthesis,
    STATE(2280), 1,
      sym__close_parenthesis,
    STATE(5110), 1,
      aux_sym_parameters_repeat1,
  [204343] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14814), 1,
      sym_comma,
    ACTIONS(14892), 1,
      sym__external_close_parenthesis,
    STATE(2282), 1,
      sym__close_parenthesis,
    STATE(4789), 1,
      aux_sym_parameters_repeat1,
  [204359] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14814), 1,
      sym_comma,
    ACTIONS(14894), 1,
      sym__external_close_parenthesis,
    STATE(2314), 1,
      sym__close_parenthesis,
    STATE(5110), 1,
      aux_sym_parameters_repeat1,
  [204375] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14896), 1,
      sym__newline,
    ACTIONS(14898), 1,
      sym__external_open_parenthesis,
    STATE(4093), 1,
      sym__open_parenthesis,
    STATE(4785), 1,
      aux_sym_function_definition_repeat1,
  [204391] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14814), 1,
      sym_comma,
    ACTIONS(14900), 1,
      sym__external_close_parenthesis,
    STATE(2542), 1,
      sym__close_parenthesis,
    STATE(5110), 1,
      aux_sym_parameters_repeat1,
  [204407] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(14902), 1,
      anon_sym_DQUOTE,
    STATE(4813), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(14824), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [204421] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(14904), 1,
      sym__external_open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
    STATE(5186), 1,
      sym__open_parenthesis,
  [204437] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(14906), 1,
      anon_sym_SQUOTE,
    STATE(4801), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(14830), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [204451] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(14908), 1,
      anon_sym_DQUOTE,
    STATE(4802), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(14824), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [204465] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(14910), 1,
      sym__external_open_parenthesis,
    STATE(4094), 1,
      sym__open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
  [204481] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14814), 1,
      sym_comma,
    ACTIONS(14912), 1,
      sym__external_close_parenthesis,
    STATE(2825), 1,
      sym__close_parenthesis,
    STATE(4771), 1,
      aux_sym_parameters_repeat1,
  [204497] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14914), 1,
      sym__newline,
    ACTIONS(14916), 1,
      sym__external_open_parenthesis,
    STATE(4795), 1,
      aux_sym_function_definition_repeat1,
    STATE(5196), 1,
      sym__open_parenthesis,
  [204513] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(14918), 1,
      anon_sym_SQUOTE,
    STATE(5076), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(14830), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [204527] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(14920), 1,
      anon_sym_DQUOTE,
    STATE(5074), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(14824), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [204541] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14922), 1,
      sym__newline,
    ACTIONS(14924), 1,
      sym__external_open_parenthesis,
    STATE(4095), 1,
      sym__open_parenthesis,
    STATE(4798), 1,
      aux_sym_function_definition_repeat1,
  [204557] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14814), 1,
      sym_comma,
    ACTIONS(14926), 1,
      sym__external_close_parenthesis,
    STATE(2477), 1,
      sym__close_parenthesis,
    STATE(5110), 1,
      aux_sym_parameters_repeat1,
  [204573] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(14928), 1,
      anon_sym_SQUOTE,
    STATE(5076), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(14830), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [204587] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14814), 1,
      sym_comma,
    ACTIONS(14930), 1,
      sym__external_close_parenthesis,
    STATE(2459), 1,
      sym__close_parenthesis,
    STATE(4804), 1,
      aux_sym_parameters_repeat1,
  [204603] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(14932), 1,
      sym__external_open_parenthesis,
    STATE(4123), 1,
      sym__open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
  [204619] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(14934), 1,
      sym__external_open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
    STATE(5202), 1,
      sym__open_parenthesis,
  [204635] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(14936), 1,
      sym__external_open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
    STATE(5245), 1,
      sym__open_parenthesis,
  [204651] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(14938), 1,
      sym__external_open_parenthesis,
    STATE(4114), 1,
      sym__open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
  [204667] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(14940), 1,
      sym__external_open_parenthesis,
    STATE(4096), 1,
      sym__open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
  [204683] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(14942), 1,
      anon_sym_SQUOTE,
    STATE(5076), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(14830), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [204697] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(14944), 1,
      anon_sym_DQUOTE,
    STATE(5074), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(14824), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [204711] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(14946), 1,
      anon_sym_DQUOTE,
    STATE(5074), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(14824), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [204725] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(14948), 1,
      anon_sym_DQUOTE,
    STATE(5074), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(14824), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [204739] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(14950), 1,
      anon_sym_SQUOTE,
    STATE(5076), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(14830), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [204753] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(14952), 1,
      anon_sym_DQUOTE,
    STATE(5074), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(14824), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [204767] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14954), 1,
      sym__newline,
    ACTIONS(14956), 1,
      sym__external_open_parenthesis,
    STATE(4808), 1,
      aux_sym_function_definition_repeat1,
    STATE(5211), 1,
      sym__open_parenthesis,
  [204783] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(14958), 1,
      anon_sym_SQUOTE,
    STATE(4824), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(14830), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [204797] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(14960), 1,
      anon_sym_DQUOTE,
    STATE(4825), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(14824), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [204811] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14962), 1,
      sym__newline,
    ACTIONS(14964), 1,
      sym__external_open_parenthesis,
    STATE(4101), 1,
      sym__open_parenthesis,
    STATE(4811), 1,
      aux_sym_function_definition_repeat1,
  [204827] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(14966), 1,
      anon_sym_SQUOTE,
    STATE(5076), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(14830), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [204841] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(14968), 1,
      anon_sym_DQUOTE,
    STATE(5074), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(14824), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [204855] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(14970), 1,
      anon_sym_SQUOTE,
    STATE(5076), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(14830), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [204869] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(14972), 1,
      anon_sym_DQUOTE,
    STATE(5074), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(14824), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [204883] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(14974), 1,
      sym__external_open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
    STATE(5214), 1,
      sym__open_parenthesis,
  [204899] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(14976), 1,
      anon_sym_DQUOTE,
    STATE(4815), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(14824), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [204913] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(14978), 1,
      anon_sym_SQUOTE,
    STATE(4816), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(14830), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [204927] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(14980), 1,
      anon_sym_SQUOTE,
    STATE(5076), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(14830), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [204941] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(14982), 1,
      sym__external_open_parenthesis,
    STATE(4102), 1,
      sym__open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
  [204957] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14984), 1,
      sym__newline,
    ACTIONS(14986), 1,
      sym__external_open_parenthesis,
    STATE(4826), 1,
      aux_sym_function_definition_repeat1,
    STATE(5218), 1,
      sym__open_parenthesis,
  [204973] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(14988), 1,
      anon_sym_DQUOTE,
    STATE(4823), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(14824), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [204987] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(14990), 1,
      anon_sym_SQUOTE,
    STATE(4829), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(14830), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [205001] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14992), 1,
      sym__newline,
    ACTIONS(14994), 1,
      sym__external_open_parenthesis,
    STATE(4103), 1,
      sym__open_parenthesis,
    STATE(4830), 1,
      aux_sym_function_definition_repeat1,
  [205017] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14814), 1,
      sym_comma,
    ACTIONS(14996), 1,
      sym__external_close_parenthesis,
    STATE(2868), 1,
      sym__close_parenthesis,
    STATE(4837), 1,
      aux_sym_parameters_repeat1,
  [205033] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14814), 1,
      sym_comma,
    ACTIONS(14998), 1,
      sym__external_close_parenthesis,
    STATE(2897), 1,
      sym__close_parenthesis,
    STATE(5110), 1,
      aux_sym_parameters_repeat1,
  [205049] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14814), 1,
      sym_comma,
    ACTIONS(15000), 1,
      sym__external_close_parenthesis,
    STATE(2887), 1,
      sym__close_parenthesis,
    STATE(5110), 1,
      aux_sym_parameters_repeat1,
  [205065] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14814), 1,
      sym_comma,
    ACTIONS(15002), 1,
      sym__external_close_parenthesis,
    STATE(2905), 1,
      sym__close_parenthesis,
    STATE(4836), 1,
      aux_sym_parameters_repeat1,
  [205081] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(15004), 1,
      sym__external_open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
    STATE(5232), 1,
      sym__open_parenthesis,
  [205097] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14814), 1,
      sym_comma,
    ACTIONS(15006), 1,
      sym__external_close_parenthesis,
    STATE(2728), 1,
      sym__close_parenthesis,
    STATE(4850), 1,
      aux_sym_parameters_repeat1,
  [205113] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(15008), 1,
      sym__external_open_parenthesis,
    STATE(4105), 1,
      sym__open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
  [205129] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15010), 1,
      anon_sym_SQUOTE,
    STATE(4847), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(14830), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [205143] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15012), 1,
      anon_sym_DQUOTE,
    STATE(4848), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(14824), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [205157] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15014), 1,
      sym__newline,
    ACTIONS(15016), 1,
      sym__external_open_parenthesis,
    STATE(4839), 1,
      aux_sym_function_definition_repeat1,
    STATE(5237), 1,
      sym__open_parenthesis,
  [205173] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14814), 1,
      sym_comma,
    ACTIONS(15018), 1,
      sym__external_close_parenthesis,
    STATE(2702), 1,
      sym__close_parenthesis,
    STATE(5110), 1,
      aux_sym_parameters_repeat1,
  [205189] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15020), 1,
      sym__newline,
    ACTIONS(15022), 1,
      sym__external_open_parenthesis,
    STATE(4245), 1,
      sym__open_parenthesis,
    STATE(4810), 1,
      aux_sym_function_definition_repeat1,
  [205205] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15024), 1,
      anon_sym_SQUOTE,
    STATE(5076), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(14830), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [205219] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15026), 1,
      anon_sym_DQUOTE,
    STATE(5074), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(14824), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [205233] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15028), 1,
      anon_sym_SQUOTE,
    STATE(4875), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(14830), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [205247] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14814), 1,
      sym_comma,
    ACTIONS(15030), 1,
      sym__external_close_parenthesis,
    STATE(2736), 1,
      sym__close_parenthesis,
    STATE(5110), 1,
      aux_sym_parameters_repeat1,
  [205263] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14814), 1,
      sym_comma,
    ACTIONS(15032), 1,
      sym__external_close_parenthesis,
    STATE(2973), 1,
      sym__close_parenthesis,
    STATE(5110), 1,
      aux_sym_parameters_repeat1,
  [205279] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14814), 1,
      sym_comma,
    ACTIONS(15034), 1,
      sym__external_close_parenthesis,
    STATE(2710), 1,
      sym__close_parenthesis,
    STATE(4845), 1,
      aux_sym_parameters_repeat1,
  [205295] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15036), 1,
      sym__newline,
    ACTIONS(15038), 1,
      sym__external_open_parenthesis,
    STATE(4106), 1,
      sym__open_parenthesis,
    STATE(4841), 1,
      aux_sym_function_definition_repeat1,
  [205311] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15040), 1,
      anon_sym_SQUOTE,
    STATE(5076), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(14830), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [205325] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(15042), 1,
      sym__external_open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
    STATE(5239), 1,
      sym__open_parenthesis,
  [205341] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15044), 1,
      anon_sym_DQUOTE,
    STATE(4884), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(14824), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [205355] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15046), 1,
      anon_sym_DQUOTE,
    STATE(5074), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(14824), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [205369] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14814), 1,
      sym_comma,
    ACTIONS(15048), 1,
      sym__external_close_parenthesis,
    STATE(2998), 1,
      sym__close_parenthesis,
    STATE(4872), 1,
      aux_sym_parameters_repeat1,
  [205385] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(15050), 1,
      sym__external_open_parenthesis,
    STATE(4107), 1,
      sym__open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
  [205401] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15052), 1,
      anon_sym_SQUOTE,
    STATE(4864), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(14830), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [205415] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15054), 1,
      anon_sym_DQUOTE,
    STATE(4865), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(14824), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [205429] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15056), 1,
      sym__newline,
    ACTIONS(15058), 1,
      sym__external_open_parenthesis,
    STATE(4855), 1,
      aux_sym_function_definition_repeat1,
    STATE(5241), 1,
      sym__open_parenthesis,
  [205445] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15060), 1,
      sym__newline,
    ACTIONS(15062), 1,
      sym__external_open_parenthesis,
    STATE(4108), 1,
      sym__open_parenthesis,
    STATE(4859), 1,
      aux_sym_function_definition_repeat1,
  [205461] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15064), 1,
      anon_sym_SQUOTE,
    STATE(5076), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(14830), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [205475] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15066), 1,
      anon_sym_DQUOTE,
    STATE(5074), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(14824), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [205489] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14814), 1,
      sym_comma,
    ACTIONS(15068), 1,
      sym__external_close_parenthesis,
    STATE(2929), 1,
      sym__close_parenthesis,
    STATE(5110), 1,
      aux_sym_parameters_repeat1,
  [205505] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15070), 1,
      anon_sym_DQUOTE,
    STATE(5074), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(14824), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [205519] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(15072), 1,
      sym__external_open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
    STATE(5243), 1,
      sym__open_parenthesis,
  [205535] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14814), 1,
      sym_comma,
    ACTIONS(15074), 1,
      sym__external_close_parenthesis,
    STATE(2826), 1,
      sym__close_parenthesis,
    STATE(5110), 1,
      aux_sym_parameters_repeat1,
  [205551] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15076), 1,
      anon_sym_SQUOTE,
    STATE(5076), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(14830), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [205565] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14814), 1,
      sym_comma,
    ACTIONS(15078), 1,
      sym__external_close_parenthesis,
    STATE(2874), 1,
      sym__close_parenthesis,
    STATE(4869), 1,
      aux_sym_parameters_repeat1,
  [205581] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14814), 1,
      sym_comma,
    ACTIONS(15080), 1,
      sym__external_close_parenthesis,
    STATE(2988), 1,
      sym__close_parenthesis,
    STATE(5110), 1,
      aux_sym_parameters_repeat1,
  [205597] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(15082), 1,
      sym__external_open_parenthesis,
    STATE(4111), 1,
      sym__open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
  [205613] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15084), 1,
      anon_sym_SQUOTE,
    STATE(4909), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(14830), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [205627] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15086), 1,
      anon_sym_SQUOTE,
    STATE(5076), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(14830), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [205641] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15088), 1,
      sym__newline,
    ACTIONS(15090), 1,
      sym__external_open_parenthesis,
    STATE(4868), 1,
      aux_sym_function_definition_repeat1,
    STATE(5244), 1,
      sym__open_parenthesis,
  [205657] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15092), 1,
      anon_sym_SQUOTE,
    STATE(4881), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(14830), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [205671] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15094), 1,
      anon_sym_DQUOTE,
    STATE(4882), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(14824), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [205685] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15096), 1,
      sym__newline,
    ACTIONS(15098), 1,
      sym__external_open_parenthesis,
    STATE(4115), 1,
      sym__open_parenthesis,
    STATE(4873), 1,
      aux_sym_function_definition_repeat1,
  [205701] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15100), 1,
      anon_sym_DQUOTE,
    STATE(5074), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(14824), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [205715] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15102), 1,
      anon_sym_SQUOTE,
    STATE(5076), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(14830), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [205729] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15104), 1,
      anon_sym_DQUOTE,
    STATE(5074), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(14824), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [205743] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15106), 1,
      anon_sym_SQUOTE,
    STATE(5076), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(14830), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [205757] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15108), 1,
      anon_sym_DQUOTE,
    STATE(5074), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(14824), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [205771] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(15110), 1,
      sym__external_open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
    STATE(5246), 1,
      sym__open_parenthesis,
  [205787] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15112), 1,
      anon_sym_DQUOTE,
    STATE(4880), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(14824), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [205801] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(15114), 1,
      sym__external_open_parenthesis,
    STATE(4116), 1,
      sym__open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
  [205817] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15116), 1,
      anon_sym_DQUOTE,
    STATE(4867), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(14824), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [205831] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15118), 1,
      sym__newline,
    ACTIONS(15120), 1,
      sym__external_open_parenthesis,
    STATE(4154), 1,
      sym__open_parenthesis,
    STATE(4890), 1,
      aux_sym_function_definition_repeat1,
  [205847] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(15122), 1,
      sym__external_open_parenthesis,
    STATE(4160), 1,
      sym__open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
  [205863] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15124), 1,
      anon_sym_SQUOTE,
    STATE(4870), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(14830), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [205877] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15126), 1,
      sym__newline,
    ACTIONS(15128), 1,
      sym__external_open_parenthesis,
    STATE(4885), 1,
      aux_sym_function_definition_repeat1,
    STATE(5248), 1,
      sym__open_parenthesis,
  [205893] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15130), 1,
      sym__newline,
    ACTIONS(15132), 1,
      sym__external_open_parenthesis,
    STATE(4117), 1,
      sym__open_parenthesis,
    STATE(4887), 1,
      aux_sym_function_definition_repeat1,
  [205909] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14814), 1,
      sym_comma,
    ACTIONS(15134), 1,
      sym__external_close_parenthesis,
    STATE(2674), 1,
      sym__close_parenthesis,
    STATE(5110), 1,
      aux_sym_parameters_repeat1,
  [205925] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(15136), 1,
      sym__external_open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
    STATE(5249), 1,
      sym__open_parenthesis,
  [205941] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14814), 1,
      sym_comma,
    ACTIONS(15138), 1,
      sym__external_close_parenthesis,
    STATE(2984), 1,
      sym__close_parenthesis,
    STATE(5110), 1,
      aux_sym_parameters_repeat1,
  [205957] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15140), 1,
      anon_sym_DQUOTE,
    STATE(4913), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(14824), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [205971] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14814), 1,
      sym_comma,
    ACTIONS(15142), 1,
      sym__external_close_parenthesis,
    STATE(2956), 1,
      sym__close_parenthesis,
    STATE(4896), 1,
      aux_sym_parameters_repeat1,
  [205987] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15144), 1,
      sym__newline,
    ACTIONS(15146), 1,
      sym__external_open_parenthesis,
    STATE(4271), 1,
      sym__open_parenthesis,
    STATE(4900), 1,
      aux_sym_function_definition_repeat1,
  [206003] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(15148), 1,
      sym__external_open_parenthesis,
    STATE(4277), 1,
      sym__open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
  [206019] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14814), 1,
      sym_comma,
    ACTIONS(15150), 1,
      sym__external_close_parenthesis,
    STATE(2691), 1,
      sym__close_parenthesis,
    STATE(4894), 1,
      aux_sym_parameters_repeat1,
  [206035] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(15152), 1,
      sym__external_open_parenthesis,
    STATE(4119), 1,
      sym__open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
  [206051] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15154), 1,
      sym__newline,
    ACTIONS(15156), 1,
      sym__external_open_parenthesis,
    STATE(4895), 1,
      aux_sym_function_definition_repeat1,
    STATE(5250), 1,
      sym__open_parenthesis,
  [206067] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15158), 1,
      sym__newline,
    ACTIONS(15160), 1,
      sym__external_open_parenthesis,
    STATE(4120), 1,
      sym__open_parenthesis,
    STATE(4902), 1,
      aux_sym_function_definition_repeat1,
  [206083] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15162), 1,
      sym__newline,
    ACTIONS(15164), 1,
      sym__external_open_parenthesis,
    STATE(4298), 1,
      sym__open_parenthesis,
    STATE(4906), 1,
      aux_sym_function_definition_repeat1,
  [206099] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(15166), 1,
      sym__external_open_parenthesis,
    STATE(4304), 1,
      sym__open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
  [206115] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15168), 1,
      anon_sym_SQUOTE,
    STATE(4883), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(14830), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [206129] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(15170), 1,
      sym__external_open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
    STATE(5251), 1,
      sym__open_parenthesis,
  [206145] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15172), 1,
      anon_sym_SQUOTE,
    STATE(5076), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(14830), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [206159] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(15174), 1,
      sym__external_open_parenthesis,
    STATE(4121), 1,
      sym__open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
  [206175] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15176), 1,
      sym__newline,
    ACTIONS(15178), 1,
      sym__external_open_parenthesis,
    STATE(4325), 1,
      sym__open_parenthesis,
    STATE(4912), 1,
      aux_sym_function_definition_repeat1,
  [206191] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(15180), 1,
      sym__external_open_parenthesis,
    STATE(4331), 1,
      sym__open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
  [206207] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15182), 1,
      anon_sym_DQUOTE,
    STATE(5074), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(14824), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [206221] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15184), 1,
      sym__newline,
    ACTIONS(15186), 1,
      sym__external_open_parenthesis,
    STATE(4908), 1,
      aux_sym_function_definition_repeat1,
    STATE(5252), 1,
      sym__open_parenthesis,
  [206237] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15188), 1,
      anon_sym_DQUOTE,
    STATE(5068), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(14824), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [206251] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15190), 1,
      sym__newline,
    ACTIONS(15192), 1,
      sym__external_open_parenthesis,
    STATE(4122), 1,
      sym__open_parenthesis,
    STATE(4910), 1,
      aux_sym_function_definition_repeat1,
  [206267] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15194), 1,
      sym__newline,
    ACTIONS(15196), 1,
      sym__external_open_parenthesis,
    STATE(4350), 1,
      sym__open_parenthesis,
    STATE(4918), 1,
      aux_sym_function_definition_repeat1,
  [206283] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(15198), 1,
      sym__external_open_parenthesis,
    STATE(4356), 1,
      sym__open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
  [206299] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15200), 1,
      anon_sym_DQUOTE,
    STATE(4814), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(14824), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [206313] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(15202), 1,
      sym__external_open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
    STATE(5253), 1,
      sym__open_parenthesis,
  [206329] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15204), 1,
      anon_sym_SQUOTE,
    STATE(4805), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(14830), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [206343] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(15206), 1,
      sym__external_open_parenthesis,
    STATE(4124), 1,
      sym__open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
  [206359] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15208), 1,
      sym__newline,
    ACTIONS(15210), 1,
      sym__external_open_parenthesis,
    STATE(4352), 1,
      sym__open_parenthesis,
    STATE(4924), 1,
      aux_sym_function_definition_repeat1,
  [206375] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(15212), 1,
      sym__external_open_parenthesis,
    STATE(4342), 1,
      sym__open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
  [206391] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15214), 1,
      anon_sym_SQUOTE,
    STATE(4822), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(14830), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [206405] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15216), 1,
      sym__newline,
    ACTIONS(15218), 1,
      sym__external_open_parenthesis,
    STATE(4920), 1,
      aux_sym_function_definition_repeat1,
    STATE(5254), 1,
      sym__open_parenthesis,
  [206421] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14814), 1,
      sym_comma,
    ACTIONS(15220), 1,
      sym__external_close_parenthesis,
    STATE(2409), 1,
      sym__close_parenthesis,
    STATE(5110), 1,
      aux_sym_parameters_repeat1,
  [206437] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15222), 1,
      sym__newline,
    ACTIONS(15224), 1,
      sym__external_open_parenthesis,
    STATE(4127), 1,
      sym__open_parenthesis,
    STATE(4922), 1,
      aux_sym_function_definition_repeat1,
  [206453] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15226), 1,
      sym__newline,
    ACTIONS(15228), 1,
      sym__external_open_parenthesis,
    STATE(4310), 1,
      sym__open_parenthesis,
    STATE(4930), 1,
      aux_sym_function_definition_repeat1,
  [206469] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(15230), 1,
      sym__external_open_parenthesis,
    STATE(4307), 1,
      sym__open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
  [206485] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15232), 1,
      anon_sym_DQUOTE,
    STATE(5074), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(14824), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [206499] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(15234), 1,
      sym__external_open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
    STATE(5255), 1,
      sym__open_parenthesis,
  [206515] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15236), 1,
      anon_sym_SQUOTE,
    STATE(5076), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(14830), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [206529] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(15238), 1,
      sym__external_open_parenthesis,
    STATE(4128), 1,
      sym__open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
  [206545] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15240), 1,
      sym__newline,
    ACTIONS(15242), 1,
      sym__external_open_parenthesis,
    STATE(4230), 1,
      sym__open_parenthesis,
    STATE(4936), 1,
      aux_sym_function_definition_repeat1,
  [206561] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(15244), 1,
      sym__external_open_parenthesis,
    STATE(4193), 1,
      sym__open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
  [206577] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15246), 1,
      sym__newline,
    ACTIONS(15248), 1,
      sym__external_open_parenthesis,
    STATE(4932), 1,
      aux_sym_function_definition_repeat1,
    STATE(5257), 1,
      sym__open_parenthesis,
  [206593] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15250), 1,
      sym__newline,
    ACTIONS(15252), 1,
      sym__external_open_parenthesis,
    STATE(4129), 1,
      sym__open_parenthesis,
    STATE(4934), 1,
      aux_sym_function_definition_repeat1,
  [206609] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(15254), 1,
      sym__external_open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
    STATE(5259), 1,
      sym__open_parenthesis,
  [206625] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(15256), 1,
      sym__external_open_parenthesis,
    STATE(4130), 1,
      sym__open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
  [206641] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15258), 1,
      sym__newline,
    ACTIONS(15260), 1,
      sym__external_open_parenthesis,
    STATE(4243), 1,
      sym__open_parenthesis,
    STATE(4942), 1,
      aux_sym_function_definition_repeat1,
  [206657] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(15262), 1,
      sym__external_open_parenthesis,
    STATE(4242), 1,
      sym__open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
  [206673] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15264), 1,
      anon_sym_DQUOTE,
    STATE(4931), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(14824), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [206687] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15266), 1,
      sym__newline,
    ACTIONS(15268), 1,
      sym__external_open_parenthesis,
    STATE(4939), 1,
      aux_sym_function_definition_repeat1,
    STATE(5260), 1,
      sym__open_parenthesis,
  [206703] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15270), 1,
      anon_sym_SQUOTE,
    STATE(4933), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(14830), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [206717] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15272), 1,
      sym__newline,
    ACTIONS(15274), 1,
      sym__external_open_parenthesis,
    STATE(4133), 1,
      sym__open_parenthesis,
    STATE(4940), 1,
      aux_sym_function_definition_repeat1,
  [206733] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15276), 1,
      sym__newline,
    ACTIONS(15278), 1,
      sym__external_open_parenthesis,
    STATE(4251), 1,
      sym__open_parenthesis,
    STATE(4948), 1,
      aux_sym_function_definition_repeat1,
  [206749] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(15280), 1,
      sym__external_open_parenthesis,
    STATE(4273), 1,
      sym__open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
  [206765] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(15282), 1,
      sym__external_open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
    STATE(5262), 1,
      sym__open_parenthesis,
  [206781] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(15284), 1,
      sym__external_open_parenthesis,
    STATE(4134), 1,
      sym__open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
  [206797] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14814), 1,
      sym_comma,
    ACTIONS(15286), 1,
      sym__external_close_parenthesis,
    STATE(2719), 1,
      sym__close_parenthesis,
    STATE(5110), 1,
      aux_sym_parameters_repeat1,
  [206813] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15288), 1,
      sym__newline,
    ACTIONS(15290), 1,
      sym__external_open_parenthesis,
    STATE(4949), 1,
      aux_sym_function_definition_repeat1,
    STATE(5264), 1,
      sym__open_parenthesis,
  [206829] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15292), 1,
      sym__newline,
    ACTIONS(15294), 1,
      sym__external_open_parenthesis,
    STATE(4313), 1,
      sym__open_parenthesis,
    STATE(4954), 1,
      aux_sym_function_definition_repeat1,
  [206845] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(15296), 1,
      sym__external_open_parenthesis,
    STATE(4314), 1,
      sym__open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
  [206861] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15298), 1,
      sym__newline,
    ACTIONS(15300), 1,
      sym__external_open_parenthesis,
    STATE(4142), 1,
      sym__open_parenthesis,
    STATE(4950), 1,
      aux_sym_function_definition_repeat1,
  [206877] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(15302), 1,
      sym__external_open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
    STATE(5266), 1,
      sym__open_parenthesis,
  [206893] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14814), 1,
      sym_comma,
    ACTIONS(15304), 1,
      sym__external_close_parenthesis,
    STATE(2666), 1,
      sym__close_parenthesis,
    STATE(4951), 1,
      aux_sym_parameters_repeat1,
  [206909] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(15306), 1,
      sym__external_open_parenthesis,
    STATE(4146), 1,
      sym__open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
  [206925] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15308), 1,
      sym__newline,
    ACTIONS(15310), 1,
      sym__external_open_parenthesis,
    STATE(4335), 1,
      sym__open_parenthesis,
    STATE(4960), 1,
      aux_sym_function_definition_repeat1,
  [206941] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(15312), 1,
      sym__external_open_parenthesis,
    STATE(4344), 1,
      sym__open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
  [206957] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14814), 1,
      sym_comma,
    ACTIONS(15314), 1,
      sym__external_close_parenthesis,
    STATE(2405), 1,
      sym__close_parenthesis,
    STATE(4927), 1,
      aux_sym_parameters_repeat1,
  [206973] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15316), 1,
      sym__newline,
    ACTIONS(15318), 1,
      sym__external_open_parenthesis,
    STATE(4956), 1,
      aux_sym_function_definition_repeat1,
    STATE(5267), 1,
      sym__open_parenthesis,
  [206989] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15320), 1,
      anon_sym_DQUOTE,
    STATE(5074), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(14824), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [207003] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15322), 1,
      sym__newline,
    ACTIONS(15324), 1,
      sym__external_open_parenthesis,
    STATE(4147), 1,
      sym__open_parenthesis,
    STATE(4958), 1,
      aux_sym_function_definition_repeat1,
  [207019] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15326), 1,
      sym__newline,
    ACTIONS(15328), 1,
      sym__external_open_parenthesis,
    STATE(4363), 1,
      sym__open_parenthesis,
    STATE(4966), 1,
      aux_sym_function_definition_repeat1,
  [207035] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(15330), 1,
      sym__external_open_parenthesis,
    STATE(4367), 1,
      sym__open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
  [207051] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(15332), 1,
      sym__external_open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
    STATE(5269), 1,
      sym__open_parenthesis,
  [207067] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(15334), 1,
      sym__external_open_parenthesis,
    STATE(4148), 1,
      sym__open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
  [207083] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15336), 1,
      anon_sym_SQUOTE,
    STATE(5005), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(14830), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [207097] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15338), 1,
      sym__newline,
    ACTIONS(15340), 1,
      sym__external_open_parenthesis,
    STATE(4967), 1,
      aux_sym_function_definition_repeat1,
    STATE(5270), 1,
      sym__open_parenthesis,
  [207113] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15342), 1,
      sym__newline,
    ACTIONS(15344), 1,
      sym__external_open_parenthesis,
    STATE(4354), 1,
      sym__open_parenthesis,
    STATE(4972), 1,
      aux_sym_function_definition_repeat1,
  [207129] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(15346), 1,
      sym__external_open_parenthesis,
    STATE(4348), 1,
      sym__open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
  [207145] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15348), 1,
      anon_sym_DQUOTE,
    STATE(5011), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(14824), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [207159] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15350), 1,
      sym__newline,
    ACTIONS(15352), 1,
      sym__external_open_parenthesis,
    STATE(4149), 1,
      sym__open_parenthesis,
    STATE(4968), 1,
      aux_sym_function_definition_repeat1,
  [207175] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(15354), 1,
      sym__external_open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
    STATE(5185), 1,
      sym__open_parenthesis,
  [207191] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(15356), 1,
      sym__external_open_parenthesis,
    STATE(4150), 1,
      sym__open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
  [207207] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15358), 1,
      sym__newline,
    ACTIONS(15360), 1,
      sym__external_open_parenthesis,
    STATE(4339), 1,
      sym__open_parenthesis,
    STATE(4978), 1,
      aux_sym_function_definition_repeat1,
  [207223] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(15362), 1,
      sym__external_open_parenthesis,
    STATE(4338), 1,
      sym__open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
  [207239] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15364), 1,
      anon_sym_DQUOTE,
    STATE(5074), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(14824), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [207253] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15366), 1,
      sym__newline,
    ACTIONS(15368), 1,
      sym__external_open_parenthesis,
    STATE(4975), 1,
      aux_sym_function_definition_repeat1,
    STATE(5181), 1,
      sym__open_parenthesis,
  [207269] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15370), 1,
      anon_sym_SQUOTE,
    STATE(5076), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(14830), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [207283] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15372), 1,
      sym__newline,
    ACTIONS(15374), 1,
      sym__external_open_parenthesis,
    STATE(4151), 1,
      sym__open_parenthesis,
    STATE(4976), 1,
      aux_sym_function_definition_repeat1,
  [207299] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15376), 1,
      sym__newline,
    ACTIONS(15378), 1,
      sym__external_open_parenthesis,
    STATE(4322), 1,
      sym__open_parenthesis,
    STATE(4984), 1,
      aux_sym_function_definition_repeat1,
  [207315] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(15380), 1,
      sym__external_open_parenthesis,
    STATE(4320), 1,
      sym__open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
  [207331] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15382), 1,
      sym__newline,
    ACTIONS(15384), 1,
      sym__external_open_parenthesis,
    STATE(4809), 1,
      aux_sym_function_definition_repeat1,
    STATE(5258), 1,
      sym__open_parenthesis,
  [207347] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(15386), 1,
      sym__external_open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
    STATE(5268), 1,
      sym__open_parenthesis,
  [207363] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14814), 1,
      sym_comma,
    ACTIONS(15388), 1,
      sym__external_close_parenthesis,
    STATE(2773), 1,
      sym__close_parenthesis,
    STATE(5058), 1,
      aux_sym_parameters_repeat1,
  [207379] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(15390), 1,
      sym__external_open_parenthesis,
    STATE(4153), 1,
      sym__open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
  [207395] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15392), 1,
      sym__newline,
    ACTIONS(15394), 1,
      sym__external_open_parenthesis,
    STATE(4315), 1,
      sym__open_parenthesis,
    STATE(4990), 1,
      aux_sym_function_definition_repeat1,
  [207411] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(15396), 1,
      sym__external_open_parenthesis,
    STATE(4312), 1,
      sym__open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
  [207427] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15398), 1,
      sym__newline,
    ACTIONS(15400), 1,
      sym__external_open_parenthesis,
    STATE(4986), 1,
      aux_sym_function_definition_repeat1,
    STATE(5265), 1,
      sym__open_parenthesis,
  [207443] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15402), 1,
      sym__newline,
    ACTIONS(15404), 1,
      sym__external_open_parenthesis,
    STATE(4155), 1,
      sym__open_parenthesis,
    STATE(4988), 1,
      aux_sym_function_definition_repeat1,
  [207459] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15406), 1,
      anon_sym_DQUOTE,
    STATE(4979), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(14824), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [207473] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(15408), 1,
      sym__external_open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
    STATE(5263), 1,
      sym__open_parenthesis,
  [207489] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15410), 1,
      sym__newline,
    ACTIONS(15412), 1,
      sym__external_open_parenthesis,
    STATE(4296), 1,
      sym__open_parenthesis,
    STATE(4996), 1,
      aux_sym_function_definition_repeat1,
  [207505] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(15414), 1,
      sym__external_open_parenthesis,
    STATE(4294), 1,
      sym__open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
  [207521] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15416), 1,
      anon_sym_SQUOTE,
    STATE(4981), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(14830), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [207535] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(15418), 1,
      sym__external_open_parenthesis,
    STATE(4156), 1,
      sym__open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
  [207551] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15420), 1,
      sym__newline,
    ACTIONS(15422), 1,
      sym__external_open_parenthesis,
    STATE(4994), 1,
      aux_sym_function_definition_repeat1,
    STATE(5261), 1,
      sym__open_parenthesis,
  [207567] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15424), 1,
      sym__newline,
    ACTIONS(15426), 1,
      sym__external_open_parenthesis,
    STATE(4157), 1,
      sym__open_parenthesis,
    STATE(4998), 1,
      aux_sym_function_definition_repeat1,
  [207583] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15428), 1,
      sym__newline,
    ACTIONS(15430), 1,
      sym__external_open_parenthesis,
    STATE(4290), 1,
      sym__open_parenthesis,
    STATE(5002), 1,
      aux_sym_function_definition_repeat1,
  [207599] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(15432), 1,
      sym__external_open_parenthesis,
    STATE(4287), 1,
      sym__open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
  [207615] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14814), 1,
      sym_comma,
    ACTIONS(15434), 1,
      sym__external_close_parenthesis,
    STATE(2413), 1,
      sym__close_parenthesis,
    STATE(5110), 1,
      aux_sym_parameters_repeat1,
  [207631] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(15436), 1,
      sym__external_open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
    STATE(5256), 1,
      sym__open_parenthesis,
  [207647] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15438), 1,
      anon_sym_SQUOTE,
    STATE(5076), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(14830), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [207661] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(15440), 1,
      sym__external_open_parenthesis,
    STATE(4158), 1,
      sym__open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
  [207677] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15442), 1,
      sym__newline,
    ACTIONS(15444), 1,
      sym__external_open_parenthesis,
    STATE(4281), 1,
      sym__open_parenthesis,
    STATE(5008), 1,
      aux_sym_function_definition_repeat1,
  [207693] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(15446), 1,
      sym__external_open_parenthesis,
    STATE(4272), 1,
      sym__open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
  [207709] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14814), 1,
      sym_comma,
    ACTIONS(15448), 1,
      sym__external_close_parenthesis,
    STATE(2447), 1,
      sym__close_parenthesis,
    STATE(5003), 1,
      aux_sym_parameters_repeat1,
  [207725] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15450), 1,
      sym__newline,
    ACTIONS(15452), 1,
      sym__external_open_parenthesis,
    STATE(5004), 1,
      aux_sym_function_definition_repeat1,
    STATE(5242), 1,
      sym__open_parenthesis,
  [207741] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15454), 1,
      anon_sym_DQUOTE,
    STATE(5074), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(14824), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [207755] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15456), 1,
      sym__newline,
    ACTIONS(15458), 1,
      sym__external_open_parenthesis,
    STATE(4161), 1,
      sym__open_parenthesis,
    STATE(5006), 1,
      aux_sym_function_definition_repeat1,
  [207771] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15460), 1,
      sym__newline,
    ACTIONS(15462), 1,
      sym__external_open_parenthesis,
    STATE(4267), 1,
      sym__open_parenthesis,
    STATE(4760), 1,
      aux_sym_function_definition_repeat1,
  [207787] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(15464), 1,
      sym__external_open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
    STATE(5240), 1,
      sym__open_parenthesis,
  [207803] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(15466), 1,
      sym__external_open_parenthesis,
    STATE(4163), 1,
      sym__open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
  [207819] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15468), 1,
      sym__newline,
    ACTIONS(15470), 1,
      sym__external_open_parenthesis,
    STATE(5014), 1,
      aux_sym_function_definition_repeat1,
    STATE(5238), 1,
      sym__open_parenthesis,
  [207835] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14814), 1,
      sym_comma,
    ACTIONS(15472), 1,
      sym__external_close_parenthesis,
    STATE(2699), 1,
      sym__close_parenthesis,
    STATE(5021), 1,
      aux_sym_parameters_repeat1,
  [207851] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15474), 1,
      sym__newline,
    ACTIONS(15476), 1,
      sym__external_open_parenthesis,
    STATE(4171), 1,
      sym__open_parenthesis,
    STATE(5015), 1,
      aux_sym_function_definition_repeat1,
  [207867] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15478), 1,
      sym__newline,
    ACTIONS(15480), 1,
      sym__external_open_parenthesis,
    STATE(4259), 1,
      sym__open_parenthesis,
    STATE(5020), 1,
      aux_sym_function_definition_repeat1,
  [207883] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(15482), 1,
      sym__external_open_parenthesis,
    STATE(4258), 1,
      sym__open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
  [207899] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14814), 1,
      sym_comma,
    ACTIONS(15484), 1,
      sym__external_close_parenthesis,
    STATE(2669), 1,
      sym__close_parenthesis,
    STATE(5110), 1,
      aux_sym_parameters_repeat1,
  [207915] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(15486), 1,
      sym__external_open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
    STATE(5220), 1,
      sym__open_parenthesis,
  [207931] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15488), 1,
      anon_sym_DQUOTE,
    STATE(5074), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(14824), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [207945] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(15490), 1,
      sym__external_open_parenthesis,
    STATE(4172), 1,
      sym__open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
  [207961] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15492), 1,
      sym__newline,
    ACTIONS(15494), 1,
      sym__external_open_parenthesis,
    STATE(4250), 1,
      sym__open_parenthesis,
    STATE(5026), 1,
      aux_sym_function_definition_repeat1,
  [207977] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(15496), 1,
      sym__external_open_parenthesis,
    STATE(4248), 1,
      sym__open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
  [207993] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15498), 1,
      anon_sym_SQUOTE,
    STATE(5076), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(14830), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [208007] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15500), 1,
      sym__newline,
    ACTIONS(15502), 1,
      sym__external_open_parenthesis,
    STATE(5022), 1,
      aux_sym_function_definition_repeat1,
    STATE(5206), 1,
      sym__open_parenthesis,
  [208023] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14814), 1,
      sym_comma,
    ACTIONS(15504), 1,
      sym__external_close_parenthesis,
    STATE(2911), 1,
      sym__close_parenthesis,
    STATE(4759), 1,
      aux_sym_parameters_repeat1,
  [208039] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15506), 1,
      sym__newline,
    ACTIONS(15508), 1,
      sym__external_open_parenthesis,
    STATE(4173), 1,
      sym__open_parenthesis,
    STATE(5024), 1,
      aux_sym_function_definition_repeat1,
  [208055] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15510), 1,
      sym__newline,
    ACTIONS(15512), 1,
      sym__external_open_parenthesis,
    STATE(4236), 1,
      sym__open_parenthesis,
    STATE(5032), 1,
      aux_sym_function_definition_repeat1,
  [208071] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(15514), 1,
      sym__external_open_parenthesis,
    STATE(4235), 1,
      sym__open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
  [208087] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15516), 1,
      anon_sym_SQUOTE,
    STATE(5071), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(14830), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [208101] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(15518), 1,
      sym__external_open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
    STATE(5192), 1,
      sym__open_parenthesis,
  [208117] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(15520), 1,
      sym__external_open_parenthesis,
    STATE(4175), 1,
      sym__open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
  [208133] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15522), 1,
      sym__newline,
    ACTIONS(15524), 1,
      sym__external_open_parenthesis,
    STATE(5034), 1,
      aux_sym_function_definition_repeat1,
    STATE(5215), 1,
      sym__open_parenthesis,
  [208149] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15526), 1,
      sym__newline,
    ACTIONS(15528), 1,
      sym__external_open_parenthesis,
    STATE(4227), 1,
      sym__open_parenthesis,
    STATE(5038), 1,
      aux_sym_function_definition_repeat1,
  [208165] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(15530), 1,
      sym__external_open_parenthesis,
    STATE(4225), 1,
      sym__open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
  [208181] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15532), 1,
      anon_sym_DQUOTE,
    STATE(5023), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(14824), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [208195] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15534), 1,
      sym__newline,
    ACTIONS(15536), 1,
      sym__external_open_parenthesis,
    STATE(4176), 1,
      sym__open_parenthesis,
    STATE(5035), 1,
      aux_sym_function_definition_repeat1,
  [208211] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15538), 1,
      anon_sym_SQUOTE,
    STATE(5027), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(14830), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [208225] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(15540), 1,
      sym__external_open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
    STATE(5161), 1,
      sym__open_parenthesis,
  [208241] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15542), 1,
      sym__newline,
    ACTIONS(15544), 1,
      sym__external_open_parenthesis,
    STATE(4217), 1,
      sym__open_parenthesis,
    STATE(5044), 1,
      aux_sym_function_definition_repeat1,
  [208257] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(15546), 1,
      sym__external_open_parenthesis,
    STATE(4216), 1,
      sym__open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
  [208273] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(15548), 1,
      sym__external_open_parenthesis,
    STATE(4177), 1,
      sym__open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
  [208289] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15550), 1,
      sym__newline,
    ACTIONS(15552), 1,
      sym__external_open_parenthesis,
    STATE(5042), 1,
      aux_sym_function_definition_repeat1,
    STATE(5165), 1,
      sym__open_parenthesis,
  [208305] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14814), 1,
      sym_comma,
    ACTIONS(15554), 1,
      sym__external_close_parenthesis,
    STATE(2450), 1,
      sym__close_parenthesis,
    STATE(5110), 1,
      aux_sym_parameters_repeat1,
  [208321] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15556), 1,
      sym__newline,
    ACTIONS(15558), 1,
      sym__external_open_parenthesis,
    STATE(4178), 1,
      sym__open_parenthesis,
    STATE(5045), 1,
      aux_sym_function_definition_repeat1,
  [208337] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15560), 1,
      sym__newline,
    ACTIONS(15562), 1,
      sym__external_open_parenthesis,
    STATE(4197), 1,
      sym__open_parenthesis,
    STATE(5050), 1,
      aux_sym_function_definition_repeat1,
  [208353] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(15564), 1,
      sym__external_open_parenthesis,
    STATE(4195), 1,
      sym__open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
  [208369] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(15566), 1,
      sym__external_open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
    STATE(5166), 1,
      sym__open_parenthesis,
  [208385] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(15568), 1,
      sym__external_open_parenthesis,
    STATE(4179), 1,
      sym__open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
  [208401] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14814), 1,
      sym_comma,
    ACTIONS(15570), 1,
      sym__external_close_parenthesis,
    STATE(2461), 1,
      sym__close_parenthesis,
    STATE(5047), 1,
      aux_sym_parameters_repeat1,
  [208417] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15572), 1,
      sym__newline,
    ACTIONS(15574), 1,
      sym__external_open_parenthesis,
    STATE(5051), 1,
      aux_sym_function_definition_repeat1,
    STATE(5167), 1,
      sym__open_parenthesis,
  [208433] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15576), 1,
      sym__newline,
    ACTIONS(15578), 1,
      sym__external_open_parenthesis,
    STATE(4181), 1,
      sym__open_parenthesis,
    STATE(5052), 1,
      aux_sym_function_definition_repeat1,
  [208449] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14814), 1,
      sym_comma,
    ACTIONS(15580), 1,
      sym__external_close_parenthesis,
    STATE(2937), 1,
      sym__close_parenthesis,
    STATE(4851), 1,
      aux_sym_parameters_repeat1,
  [208465] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15582), 1,
      anon_sym_SQUOTE,
    STATE(5076), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(14830), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [208479] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14814), 1,
      sym_comma,
    ACTIONS(15584), 1,
      sym__external_close_parenthesis,
    STATE(2879), 1,
      sym__close_parenthesis,
    STATE(5110), 1,
      aux_sym_parameters_repeat1,
  [208495] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(15586), 1,
      sym__external_open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
    STATE(5168), 1,
      sym__open_parenthesis,
  [208511] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      sym__newline,
    ACTIONS(15588), 1,
      sym__external_open_parenthesis,
    STATE(4182), 1,
      sym__open_parenthesis,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
  [208527] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14814), 1,
      sym_comma,
    ACTIONS(15590), 1,
      sym__external_close_parenthesis,
    STATE(2547), 1,
      sym__close_parenthesis,
    STATE(4793), 1,
      aux_sym_parameters_repeat1,
  [208543] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15592), 1,
      sym__newline,
    ACTIONS(15594), 1,
      sym__external_open_parenthesis,
    STATE(5059), 1,
      aux_sym_function_definition_repeat1,
    STATE(5170), 1,
      sym__open_parenthesis,
  [208559] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15596), 1,
      anon_sym_DQUOTE,
    STATE(5074), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(14824), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [208573] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15598), 1,
      sym__newline,
    ACTIONS(15600), 1,
      sym__external_open_parenthesis,
    STATE(4183), 1,
      sym__open_parenthesis,
    STATE(5060), 1,
      aux_sym_function_definition_repeat1,
  [208589] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15602), 1,
      anon_sym_DQUOTE,
    STATE(5074), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(14824), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [208603] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15604), 1,
      sym__newline,
    ACTIONS(15606), 1,
      sym__external_open_parenthesis,
    STATE(4249), 1,
      sym__open_parenthesis,
    STATE(4807), 1,
      aux_sym_function_definition_repeat1,
  [208619] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15608), 1,
      anon_sym_SQUOTE,
    STATE(5076), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(14830), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [208633] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15610), 1,
      anon_sym_DQUOTE,
    STATE(5074), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(14824), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [208647] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15612), 1,
      anon_sym_SQUOTE,
    STATE(5076), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(14830), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [208661] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14814), 1,
      sym_comma,
    ACTIONS(15614), 1,
      sym__external_close_parenthesis,
    STATE(2568), 1,
      sym__close_parenthesis,
    STATE(5072), 1,
      aux_sym_parameters_repeat1,
  [208677] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15616), 1,
      anon_sym_SQUOTE,
    STATE(5076), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(14830), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [208691] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14814), 1,
      sym_comma,
    ACTIONS(15618), 1,
      sym__external_close_parenthesis,
    STATE(2577), 1,
      sym__close_parenthesis,
    STATE(5110), 1,
      aux_sym_parameters_repeat1,
  [208707] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14814), 1,
      sym_comma,
    ACTIONS(15620), 1,
      sym__external_close_parenthesis,
    STATE(2992), 1,
      sym__close_parenthesis,
    STATE(5110), 1,
      aux_sym_parameters_repeat1,
  [208723] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15622), 1,
      anon_sym_DQUOTE,
    STATE(5074), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(15624), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [208737] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15627), 1,
      anon_sym_DQUOTE,
    STATE(5065), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(14824), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [208751] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15629), 1,
      anon_sym_SQUOTE,
    STATE(5076), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(15631), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [208765] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15634), 1,
      anon_sym_SQUOTE,
    STATE(5067), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(14830), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [208779] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15636), 1,
      anon_sym_SQUOTE,
    STATE(5081), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(14830), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [208793] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15638), 1,
      anon_sym_DQUOTE,
    STATE(5063), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(14824), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [208807] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15640), 1,
      anon_sym_DQUOTE,
    STATE(5086), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(14824), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [208821] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15642), 1,
      anon_sym_SQUOTE,
    STATE(5076), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(14830), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [208835] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14814), 1,
      sym_comma,
    ACTIONS(15644), 1,
      sym__external_close_parenthesis,
    STATE(3007), 1,
      sym__close_parenthesis,
    STATE(5073), 1,
      aux_sym_parameters_repeat1,
  [208851] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14814), 1,
      sym_comma,
    ACTIONS(15646), 1,
      sym__external_close_parenthesis,
    STATE(2884), 1,
      sym__close_parenthesis,
    STATE(5110), 1,
      aux_sym_parameters_repeat1,
  [208867] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15648), 1,
      anon_sym_DQUOTE,
    STATE(4963), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(14824), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [208881] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15650), 1,
      anon_sym_SQUOTE,
    STATE(5069), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(14830), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [208895] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15652), 1,
      anon_sym_DQUOTE,
    STATE(5074), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(14824), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [208909] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15654), 1,
      anon_sym_DQUOTE,
    STATE(5074), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(14824), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [208923] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15656), 1,
      anon_sym_SQUOTE,
    STATE(5057), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(14830), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [208937] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15658), 1,
      anon_sym_SQUOTE,
    STATE(5076), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(14830), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [208951] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15660), 1,
      anon_sym_SQUOTE,
    STATE(5089), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(14830), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [208965] = 4,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15662), 1,
      anon_sym_DQUOTE,
    STATE(5087), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(14824), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [208979] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14814), 1,
      sym_comma,
    ACTIONS(15664), 1,
      sym__external_close_parenthesis,
    STATE(2817), 1,
      sym__close_parenthesis,
    STATE(5083), 1,
      aux_sym_parameters_repeat1,
  [208995] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15666), 1,
      sym__external_open_parenthesis,
    STATE(449), 1,
      sym_parameters,
    STATE(4740), 1,
      sym__open_parenthesis,
  [209008] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15668), 1,
      sym__external_open_parenthesis,
    STATE(356), 1,
      sym_parameters,
    STATE(4750), 1,
      sym__open_parenthesis,
  [209021] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15670), 1,
      sym__external_open_parenthesis,
    STATE(391), 1,
      sym_parameters,
    STATE(4755), 1,
      sym__open_parenthesis,
  [209034] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15672), 1,
      sym__external_open_parenthesis,
    STATE(263), 1,
      sym_parameters,
    STATE(4744), 1,
      sym__open_parenthesis,
  [209047] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15674), 1,
      sym__external_open_parenthesis,
    STATE(49), 1,
      sym_parameters,
    STATE(4756), 1,
      sym__open_parenthesis,
  [209060] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15676), 1,
      sym__external_open_parenthesis,
    STATE(351), 1,
      sym_parameters,
    STATE(4743), 1,
      sym__open_parenthesis,
  [209073] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15666), 1,
      sym__external_open_parenthesis,
    STATE(462), 1,
      sym_parameters,
    STATE(4740), 1,
      sym__open_parenthesis,
  [209086] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15670), 1,
      sym__external_open_parenthesis,
    STATE(305), 1,
      sym_parameters,
    STATE(4755), 1,
      sym__open_parenthesis,
  [209099] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15678), 1,
      sym__external_open_parenthesis,
    STATE(362), 1,
      sym_parameters,
    STATE(4733), 1,
      sym__open_parenthesis,
  [209112] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15680), 1,
      sym__external_open_parenthesis,
    STATE(250), 1,
      sym_parameters,
    STATE(4745), 1,
      sym__open_parenthesis,
  [209125] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15682), 1,
      sym__external_open_parenthesis,
    STATE(334), 1,
      sym_parameters,
    STATE(4748), 1,
      sym__open_parenthesis,
  [209138] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15684), 1,
      sym__external_open_parenthesis,
    STATE(447), 1,
      sym_parameters,
    STATE(4735), 1,
      sym__open_parenthesis,
  [209151] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15686), 1,
      sym__external_open_parenthesis,
    STATE(152), 1,
      sym_parameters,
    STATE(4749), 1,
      sym__open_parenthesis,
  [209164] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15688), 1,
      sym__external_open_parenthesis,
    STATE(289), 1,
      sym_parameters,
    STATE(4739), 1,
      sym__open_parenthesis,
  [209177] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15690), 1,
      sym__external_open_parenthesis,
    STATE(155), 1,
      sym_parameters,
    STATE(4737), 1,
      sym__open_parenthesis,
  [209190] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15692), 1,
      sym__external_open_parenthesis,
    STATE(435), 1,
      sym_parameters,
    STATE(4736), 1,
      sym__open_parenthesis,
  [209203] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15694), 1,
      anon_sym_EQ,
    ACTIONS(15696), 2,
      sym__external_close_parenthesis,
      sym_comma,
  [209214] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15698), 1,
      sym_comma,
    ACTIONS(15701), 1,
      sym__external_close_parenthesis,
    STATE(5110), 1,
      aux_sym_parameters_repeat1,
  [209227] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15703), 1,
      sym__external_open_parenthesis,
    STATE(375), 1,
      sym_parameters,
    STATE(4746), 1,
      sym__open_parenthesis,
  [209240] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15705), 1,
      sym__external_open_parenthesis,
    STATE(237), 1,
      sym_parameters,
    STATE(4752), 1,
      sym__open_parenthesis,
  [209253] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15707), 1,
      sym__external_open_parenthesis,
    STATE(109), 1,
      sym_parameters,
    STATE(4753), 1,
      sym__open_parenthesis,
  [209266] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15709), 1,
      sym__external_open_parenthesis,
    STATE(77), 1,
      sym_parameters,
    STATE(4754), 1,
      sym__open_parenthesis,
  [209279] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15711), 1,
      sym__external_open_parenthesis,
    STATE(432), 1,
      sym_parameters,
    STATE(4738), 1,
      sym__open_parenthesis,
  [209292] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15713), 1,
      sym__external_open_parenthesis,
    STATE(129), 1,
      sym_parameters,
    STATE(4757), 1,
      sym__open_parenthesis,
  [209305] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15715), 1,
      sym__external_open_parenthesis,
    STATE(38), 1,
      sym_parameters,
    STATE(4732), 1,
      sym__open_parenthesis,
  [209318] = 3,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15717), 1,
      anon_sym_DQUOTE,
    ACTIONS(15719), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [209329] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15721), 1,
      sym__external_open_parenthesis,
    STATE(290), 1,
      sym_parameters,
    STATE(4747), 1,
      sym__open_parenthesis,
  [209342] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15723), 1,
      sym__external_open_parenthesis,
    STATE(322), 1,
      sym_parameters,
    STATE(4742), 1,
      sym__open_parenthesis,
  [209355] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7417), 1,
      sym__external_open_parenthesis,
    ACTIONS(15725), 1,
      sym__newline,
    STATE(5121), 1,
      aux_sym_function_definition_repeat1,
  [209368] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15728), 1,
      sym__external_open_parenthesis,
    STATE(217), 1,
      sym_parameters,
    STATE(4751), 1,
      sym__open_parenthesis,
  [209381] = 3,
    ACTIONS(14826), 1,
      sym_comment,
    ACTIONS(15730), 1,
      anon_sym_SQUOTE,
    ACTIONS(15732), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [209392] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15734), 1,
      sym__external_open_parenthesis,
    STATE(181), 1,
      sym_parameters,
    STATE(4741), 1,
      sym__open_parenthesis,
  [209405] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15736), 1,
      sym__external_open_parenthesis,
    STATE(404), 1,
      sym_parameters,
    STATE(4734), 1,
      sym__open_parenthesis,
  [209418] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15738), 1,
      anon_sym_COLON_COLON,
    ACTIONS(15740), 1,
      anon_sym_COLON_COLON_COLON,
  [209428] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15742), 1,
      anon_sym_COLON_COLON,
    ACTIONS(15744), 1,
      anon_sym_COLON_COLON_COLON,
  [209438] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15746), 1,
      anon_sym_COLON_COLON,
    ACTIONS(15748), 1,
      anon_sym_COLON_COLON_COLON,
  [209448] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15750), 1,
      anon_sym_COLON_COLON,
    ACTIONS(15752), 1,
      anon_sym_COLON_COLON_COLON,
  [209458] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15754), 1,
      anon_sym_COLON_COLON,
    ACTIONS(15756), 1,
      anon_sym_COLON_COLON_COLON,
  [209468] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15758), 1,
      anon_sym_COLON_COLON,
    ACTIONS(15760), 1,
      anon_sym_COLON_COLON_COLON,
  [209478] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15762), 2,
      sym__external_close_parenthesis,
      sym_comma,
  [209486] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15764), 1,
      anon_sym_COLON_COLON,
    ACTIONS(15766), 1,
      anon_sym_COLON_COLON_COLON,
  [209496] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15768), 1,
      anon_sym_COLON_COLON,
    ACTIONS(15770), 1,
      anon_sym_COLON_COLON_COLON,
  [209506] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15772), 1,
      anon_sym_COLON_COLON,
    ACTIONS(15774), 1,
      anon_sym_COLON_COLON_COLON,
  [209516] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15776), 2,
      sym__external_close_parenthesis,
      sym_comma,
  [209524] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15778), 1,
      anon_sym_COLON_COLON,
    ACTIONS(15780), 1,
      anon_sym_COLON_COLON_COLON,
  [209534] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15782), 1,
      anon_sym_COLON_COLON,
    ACTIONS(15784), 1,
      anon_sym_COLON_COLON_COLON,
  [209544] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15786), 1,
      anon_sym_COLON_COLON,
    ACTIONS(15788), 1,
      anon_sym_COLON_COLON_COLON,
  [209554] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15790), 1,
      anon_sym_COLON_COLON,
    ACTIONS(15792), 1,
      anon_sym_COLON_COLON_COLON,
  [209564] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15794), 1,
      anon_sym_COLON_COLON,
    ACTIONS(15796), 1,
      anon_sym_COLON_COLON_COLON,
  [209574] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15798), 1,
      anon_sym_COLON_COLON,
    ACTIONS(15800), 1,
      anon_sym_COLON_COLON_COLON,
  [209584] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15802), 1,
      anon_sym_COLON_COLON,
    ACTIONS(15804), 1,
      anon_sym_COLON_COLON_COLON,
  [209594] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15806), 1,
      anon_sym_COLON_COLON,
    ACTIONS(15808), 1,
      anon_sym_COLON_COLON_COLON,
  [209604] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15696), 2,
      sym__external_close_parenthesis,
      sym_comma,
  [209612] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15810), 2,
      sym__external_close_parenthesis,
      sym_comma,
  [209620] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15812), 1,
      anon_sym_COLON_COLON,
    ACTIONS(15814), 1,
      anon_sym_COLON_COLON_COLON,
  [209630] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15816), 1,
      anon_sym_COLON_COLON,
    ACTIONS(15818), 1,
      anon_sym_COLON_COLON_COLON,
  [209640] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15820), 1,
      anon_sym_COLON_COLON,
    ACTIONS(15822), 1,
      anon_sym_COLON_COLON_COLON,
  [209650] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15824), 1,
      anon_sym_COLON_COLON,
    ACTIONS(15826), 1,
      anon_sym_COLON_COLON_COLON,
  [209660] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15828), 1,
      anon_sym_COLON_COLON,
    ACTIONS(15830), 1,
      anon_sym_COLON_COLON_COLON,
  [209670] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15832), 1,
      anon_sym_COLON_COLON,
    ACTIONS(15834), 1,
      anon_sym_COLON_COLON_COLON,
  [209680] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15836), 1,
      anon_sym_COLON_COLON,
    ACTIONS(15838), 1,
      anon_sym_COLON_COLON_COLON,
  [209690] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15840), 1,
      anon_sym_COLON_COLON,
    ACTIONS(15842), 1,
      anon_sym_COLON_COLON_COLON,
  [209700] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15844), 1,
      anon_sym_COLON_COLON,
    ACTIONS(15846), 1,
      anon_sym_COLON_COLON_COLON,
  [209710] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15848), 1,
      anon_sym_COLON_COLON,
    ACTIONS(15850), 1,
      anon_sym_COLON_COLON_COLON,
  [209720] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15852), 1,
      anon_sym_COLON_COLON,
    ACTIONS(15854), 1,
      anon_sym_COLON_COLON_COLON,
  [209730] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15856), 1,
      anon_sym_in,
  [209737] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15858), 1,
      anon_sym_in,
  [209744] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15860), 1,
      sym_identifier,
  [209751] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15862), 1,
      sym_identifier,
  [209758] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15864), 1,
      sym_identifier,
  [209765] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15866), 1,
      sym_identifier,
  [209772] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15868), 1,
      sym_identifier,
  [209779] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15870), 1,
      sym_identifier,
  [209786] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15872), 1,
      sym_identifier,
  [209793] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15874), 1,
      sym_identifier,
  [209800] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15876), 1,
      sym_identifier,
  [209807] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15878), 1,
      ts_builtin_sym_end,
  [209814] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15880), 1,
      sym_identifier,
  [209821] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15882), 1,
      anon_sym_in,
  [209828] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15884), 1,
      anon_sym_in,
  [209835] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15886), 1,
      anon_sym_in,
  [209842] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15888), 1,
      anon_sym_in,
  [209849] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15890), 1,
      anon_sym_in,
  [209856] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15892), 1,
      anon_sym_in,
  [209863] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15894), 1,
      anon_sym_in,
  [209870] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15896), 1,
      anon_sym_in,
  [209877] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15898), 1,
      anon_sym_in,
  [209884] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15900), 1,
      anon_sym_in,
  [209891] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15902), 1,
      sym_identifier,
  [209898] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15904), 1,
      anon_sym_in,
  [209905] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15906), 1,
      anon_sym_in,
  [209912] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15908), 1,
      anon_sym_in,
  [209919] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15910), 1,
      sym_identifier,
  [209926] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15912), 1,
      sym_identifier,
  [209933] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15914), 1,
      anon_sym_in,
  [209940] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15916), 1,
      anon_sym_in,
  [209947] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15918), 1,
      anon_sym_in,
  [209954] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15920), 1,
      anon_sym_in,
  [209961] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15922), 1,
      anon_sym_in,
  [209968] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15924), 1,
      sym_identifier,
  [209975] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15926), 1,
      anon_sym_in,
  [209982] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15928), 1,
      anon_sym_in,
  [209989] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15930), 1,
      anon_sym_in,
  [209996] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15932), 1,
      sym_identifier,
  [210003] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15934), 1,
      anon_sym_in,
  [210010] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15936), 1,
      anon_sym_in,
  [210017] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15938), 1,
      anon_sym_in,
  [210024] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15940), 1,
      anon_sym_in,
  [210031] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15942), 1,
      anon_sym_in,
  [210038] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15944), 1,
      sym_identifier,
  [210045] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15946), 1,
      anon_sym_in,
  [210052] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15948), 1,
      anon_sym_in,
  [210059] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15950), 1,
      anon_sym_in,
  [210066] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15952), 1,
      sym_identifier,
  [210073] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15954), 1,
      anon_sym_in,
  [210080] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15956), 1,
      anon_sym_in,
  [210087] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15958), 1,
      anon_sym_in,
  [210094] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15960), 1,
      anon_sym_in,
  [210101] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15962), 1,
      sym_identifier,
  [210108] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15964), 1,
      anon_sym_in,
  [210115] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15966), 1,
      anon_sym_in,
  [210122] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15968), 1,
      sym_identifier,
  [210129] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15970), 1,
      sym_identifier,
  [210136] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15972), 1,
      anon_sym_in,
  [210143] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15974), 1,
      anon_sym_in,
  [210150] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15976), 1,
      sym_identifier,
  [210157] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15978), 1,
      anon_sym_in,
  [210164] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15980), 1,
      sym_identifier,
  [210171] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15982), 1,
      anon_sym_in,
  [210178] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15984), 1,
      anon_sym_in,
  [210185] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15986), 1,
      anon_sym_in,
  [210192] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15988), 1,
      anon_sym_in,
  [210199] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15990), 1,
      anon_sym_in,
  [210206] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15992), 1,
      anon_sym_in,
  [210213] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15994), 1,
      anon_sym_in,
  [210220] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15996), 1,
      anon_sym_in,
  [210227] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15998), 1,
      anon_sym_in,
  [210234] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16000), 1,
      anon_sym_in,
  [210241] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16002), 1,
      anon_sym_in,
  [210248] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16004), 1,
      sym_identifier,
  [210255] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16006), 1,
      anon_sym_in,
  [210262] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16008), 1,
      anon_sym_in,
  [210269] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16010), 1,
      anon_sym_in,
  [210276] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16012), 1,
      anon_sym_in,
  [210283] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16014), 1,
      sym_identifier,
  [210290] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16016), 1,
      sym_identifier,
  [210297] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16018), 1,
      sym_identifier,
  [210304] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16020), 1,
      sym_identifier,
  [210311] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16022), 1,
      sym_identifier,
  [210318] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16024), 1,
      sym_identifier,
  [210325] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16026), 1,
      sym_identifier,
  [210332] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16028), 1,
      sym_identifier,
  [210339] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16030), 1,
      sym_identifier,
  [210346] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16032), 1,
      sym_identifier,
  [210353] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16034), 1,
      anon_sym_in,
  [210360] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16036), 1,
      sym_identifier,
  [210367] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16038), 1,
      sym_identifier,
  [210374] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16040), 1,
      sym_identifier,
  [210381] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16042), 1,
      sym_identifier,
  [210388] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16044), 1,
      sym_identifier,
  [210395] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16046), 1,
      sym_identifier,
  [210402] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16048), 1,
      sym_identifier,
  [210409] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16050), 1,
      sym_identifier,
  [210416] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16052), 1,
      sym_identifier,
  [210423] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16054), 1,
      sym_identifier,
  [210430] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16056), 1,
      sym_identifier,
  [210437] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16058), 1,
      sym_identifier,
  [210444] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16060), 1,
      sym_identifier,
  [210451] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16062), 1,
      sym_identifier,
  [210458] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16064), 1,
      sym_identifier,
  [210465] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16066), 1,
      sym_identifier,
  [210472] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16068), 1,
      sym_identifier,
  [210479] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16070), 1,
      sym_identifier,
  [210486] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16072), 1,
      sym_identifier,
  [210493] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16074), 1,
      sym_identifier,
  [210500] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16076), 1,
      sym_identifier,
  [210507] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16078), 1,
      sym_identifier,
  [210514] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16080), 1,
      sym_identifier,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(3028)] = 0,
  [SMALL_STATE(3029)] = 129,
  [SMALL_STATE(3030)] = 258,
  [SMALL_STATE(3031)] = 387,
  [SMALL_STATE(3032)] = 516,
  [SMALL_STATE(3033)] = 645,
  [SMALL_STATE(3034)] = 774,
  [SMALL_STATE(3035)] = 903,
  [SMALL_STATE(3036)] = 1032,
  [SMALL_STATE(3037)] = 1161,
  [SMALL_STATE(3038)] = 1290,
  [SMALL_STATE(3039)] = 1419,
  [SMALL_STATE(3040)] = 1548,
  [SMALL_STATE(3041)] = 1677,
  [SMALL_STATE(3042)] = 1806,
  [SMALL_STATE(3043)] = 1935,
  [SMALL_STATE(3044)] = 2064,
  [SMALL_STATE(3045)] = 2193,
  [SMALL_STATE(3046)] = 2322,
  [SMALL_STATE(3047)] = 2451,
  [SMALL_STATE(3048)] = 2580,
  [SMALL_STATE(3049)] = 2709,
  [SMALL_STATE(3050)] = 2838,
  [SMALL_STATE(3051)] = 2967,
  [SMALL_STATE(3052)] = 3096,
  [SMALL_STATE(3053)] = 3225,
  [SMALL_STATE(3054)] = 3354,
  [SMALL_STATE(3055)] = 3483,
  [SMALL_STATE(3056)] = 3612,
  [SMALL_STATE(3057)] = 3741,
  [SMALL_STATE(3058)] = 3870,
  [SMALL_STATE(3059)] = 3999,
  [SMALL_STATE(3060)] = 4128,
  [SMALL_STATE(3061)] = 4257,
  [SMALL_STATE(3062)] = 4386,
  [SMALL_STATE(3063)] = 4515,
  [SMALL_STATE(3064)] = 4644,
  [SMALL_STATE(3065)] = 4773,
  [SMALL_STATE(3066)] = 4902,
  [SMALL_STATE(3067)] = 5031,
  [SMALL_STATE(3068)] = 5160,
  [SMALL_STATE(3069)] = 5289,
  [SMALL_STATE(3070)] = 5418,
  [SMALL_STATE(3071)] = 5547,
  [SMALL_STATE(3072)] = 5676,
  [SMALL_STATE(3073)] = 5805,
  [SMALL_STATE(3074)] = 5934,
  [SMALL_STATE(3075)] = 6063,
  [SMALL_STATE(3076)] = 6192,
  [SMALL_STATE(3077)] = 6321,
  [SMALL_STATE(3078)] = 6450,
  [SMALL_STATE(3079)] = 6579,
  [SMALL_STATE(3080)] = 6708,
  [SMALL_STATE(3081)] = 6837,
  [SMALL_STATE(3082)] = 6966,
  [SMALL_STATE(3083)] = 7095,
  [SMALL_STATE(3084)] = 7224,
  [SMALL_STATE(3085)] = 7353,
  [SMALL_STATE(3086)] = 7482,
  [SMALL_STATE(3087)] = 7611,
  [SMALL_STATE(3088)] = 7740,
  [SMALL_STATE(3089)] = 7869,
  [SMALL_STATE(3090)] = 7998,
  [SMALL_STATE(3091)] = 8127,
  [SMALL_STATE(3092)] = 8256,
  [SMALL_STATE(3093)] = 8385,
  [SMALL_STATE(3094)] = 8514,
  [SMALL_STATE(3095)] = 8643,
  [SMALL_STATE(3096)] = 8772,
  [SMALL_STATE(3097)] = 8901,
  [SMALL_STATE(3098)] = 9030,
  [SMALL_STATE(3099)] = 9159,
  [SMALL_STATE(3100)] = 9288,
  [SMALL_STATE(3101)] = 9417,
  [SMALL_STATE(3102)] = 9546,
  [SMALL_STATE(3103)] = 9675,
  [SMALL_STATE(3104)] = 9804,
  [SMALL_STATE(3105)] = 9933,
  [SMALL_STATE(3106)] = 10062,
  [SMALL_STATE(3107)] = 10191,
  [SMALL_STATE(3108)] = 10320,
  [SMALL_STATE(3109)] = 10449,
  [SMALL_STATE(3110)] = 10578,
  [SMALL_STATE(3111)] = 10707,
  [SMALL_STATE(3112)] = 10836,
  [SMALL_STATE(3113)] = 10965,
  [SMALL_STATE(3114)] = 11094,
  [SMALL_STATE(3115)] = 11223,
  [SMALL_STATE(3116)] = 11352,
  [SMALL_STATE(3117)] = 11481,
  [SMALL_STATE(3118)] = 11610,
  [SMALL_STATE(3119)] = 11739,
  [SMALL_STATE(3120)] = 11868,
  [SMALL_STATE(3121)] = 11997,
  [SMALL_STATE(3122)] = 12126,
  [SMALL_STATE(3123)] = 12255,
  [SMALL_STATE(3124)] = 12384,
  [SMALL_STATE(3125)] = 12513,
  [SMALL_STATE(3126)] = 12642,
  [SMALL_STATE(3127)] = 12771,
  [SMALL_STATE(3128)] = 12900,
  [SMALL_STATE(3129)] = 13029,
  [SMALL_STATE(3130)] = 13158,
  [SMALL_STATE(3131)] = 13287,
  [SMALL_STATE(3132)] = 13416,
  [SMALL_STATE(3133)] = 13545,
  [SMALL_STATE(3134)] = 13674,
  [SMALL_STATE(3135)] = 13803,
  [SMALL_STATE(3136)] = 13932,
  [SMALL_STATE(3137)] = 14061,
  [SMALL_STATE(3138)] = 14190,
  [SMALL_STATE(3139)] = 14319,
  [SMALL_STATE(3140)] = 14448,
  [SMALL_STATE(3141)] = 14577,
  [SMALL_STATE(3142)] = 14706,
  [SMALL_STATE(3143)] = 14835,
  [SMALL_STATE(3144)] = 14964,
  [SMALL_STATE(3145)] = 15093,
  [SMALL_STATE(3146)] = 15222,
  [SMALL_STATE(3147)] = 15351,
  [SMALL_STATE(3148)] = 15480,
  [SMALL_STATE(3149)] = 15609,
  [SMALL_STATE(3150)] = 15738,
  [SMALL_STATE(3151)] = 15867,
  [SMALL_STATE(3152)] = 15996,
  [SMALL_STATE(3153)] = 16125,
  [SMALL_STATE(3154)] = 16254,
  [SMALL_STATE(3155)] = 16383,
  [SMALL_STATE(3156)] = 16512,
  [SMALL_STATE(3157)] = 16641,
  [SMALL_STATE(3158)] = 16770,
  [SMALL_STATE(3159)] = 16899,
  [SMALL_STATE(3160)] = 17028,
  [SMALL_STATE(3161)] = 17157,
  [SMALL_STATE(3162)] = 17286,
  [SMALL_STATE(3163)] = 17415,
  [SMALL_STATE(3164)] = 17544,
  [SMALL_STATE(3165)] = 17673,
  [SMALL_STATE(3166)] = 17802,
  [SMALL_STATE(3167)] = 17931,
  [SMALL_STATE(3168)] = 18060,
  [SMALL_STATE(3169)] = 18189,
  [SMALL_STATE(3170)] = 18318,
  [SMALL_STATE(3171)] = 18447,
  [SMALL_STATE(3172)] = 18576,
  [SMALL_STATE(3173)] = 18705,
  [SMALL_STATE(3174)] = 18834,
  [SMALL_STATE(3175)] = 18963,
  [SMALL_STATE(3176)] = 19092,
  [SMALL_STATE(3177)] = 19221,
  [SMALL_STATE(3178)] = 19350,
  [SMALL_STATE(3179)] = 19479,
  [SMALL_STATE(3180)] = 19608,
  [SMALL_STATE(3181)] = 19737,
  [SMALL_STATE(3182)] = 19866,
  [SMALL_STATE(3183)] = 19995,
  [SMALL_STATE(3184)] = 20124,
  [SMALL_STATE(3185)] = 20253,
  [SMALL_STATE(3186)] = 20382,
  [SMALL_STATE(3187)] = 20511,
  [SMALL_STATE(3188)] = 20640,
  [SMALL_STATE(3189)] = 20769,
  [SMALL_STATE(3190)] = 20898,
  [SMALL_STATE(3191)] = 21027,
  [SMALL_STATE(3192)] = 21156,
  [SMALL_STATE(3193)] = 21285,
  [SMALL_STATE(3194)] = 21414,
  [SMALL_STATE(3195)] = 21543,
  [SMALL_STATE(3196)] = 21672,
  [SMALL_STATE(3197)] = 21801,
  [SMALL_STATE(3198)] = 21930,
  [SMALL_STATE(3199)] = 22059,
  [SMALL_STATE(3200)] = 22188,
  [SMALL_STATE(3201)] = 22317,
  [SMALL_STATE(3202)] = 22446,
  [SMALL_STATE(3203)] = 22575,
  [SMALL_STATE(3204)] = 22704,
  [SMALL_STATE(3205)] = 22833,
  [SMALL_STATE(3206)] = 22962,
  [SMALL_STATE(3207)] = 23091,
  [SMALL_STATE(3208)] = 23220,
  [SMALL_STATE(3209)] = 23349,
  [SMALL_STATE(3210)] = 23478,
  [SMALL_STATE(3211)] = 23607,
  [SMALL_STATE(3212)] = 23736,
  [SMALL_STATE(3213)] = 23865,
  [SMALL_STATE(3214)] = 23994,
  [SMALL_STATE(3215)] = 24123,
  [SMALL_STATE(3216)] = 24252,
  [SMALL_STATE(3217)] = 24381,
  [SMALL_STATE(3218)] = 24510,
  [SMALL_STATE(3219)] = 24639,
  [SMALL_STATE(3220)] = 24768,
  [SMALL_STATE(3221)] = 24897,
  [SMALL_STATE(3222)] = 25026,
  [SMALL_STATE(3223)] = 25155,
  [SMALL_STATE(3224)] = 25284,
  [SMALL_STATE(3225)] = 25413,
  [SMALL_STATE(3226)] = 25542,
  [SMALL_STATE(3227)] = 25671,
  [SMALL_STATE(3228)] = 25800,
  [SMALL_STATE(3229)] = 25929,
  [SMALL_STATE(3230)] = 26058,
  [SMALL_STATE(3231)] = 26187,
  [SMALL_STATE(3232)] = 26316,
  [SMALL_STATE(3233)] = 26445,
  [SMALL_STATE(3234)] = 26574,
  [SMALL_STATE(3235)] = 26703,
  [SMALL_STATE(3236)] = 26832,
  [SMALL_STATE(3237)] = 26961,
  [SMALL_STATE(3238)] = 27090,
  [SMALL_STATE(3239)] = 27219,
  [SMALL_STATE(3240)] = 27348,
  [SMALL_STATE(3241)] = 27477,
  [SMALL_STATE(3242)] = 27606,
  [SMALL_STATE(3243)] = 27735,
  [SMALL_STATE(3244)] = 27864,
  [SMALL_STATE(3245)] = 27993,
  [SMALL_STATE(3246)] = 28122,
  [SMALL_STATE(3247)] = 28251,
  [SMALL_STATE(3248)] = 28380,
  [SMALL_STATE(3249)] = 28509,
  [SMALL_STATE(3250)] = 28638,
  [SMALL_STATE(3251)] = 28767,
  [SMALL_STATE(3252)] = 28896,
  [SMALL_STATE(3253)] = 29025,
  [SMALL_STATE(3254)] = 29154,
  [SMALL_STATE(3255)] = 29283,
  [SMALL_STATE(3256)] = 29412,
  [SMALL_STATE(3257)] = 29541,
  [SMALL_STATE(3258)] = 29670,
  [SMALL_STATE(3259)] = 29799,
  [SMALL_STATE(3260)] = 29928,
  [SMALL_STATE(3261)] = 30057,
  [SMALL_STATE(3262)] = 30186,
  [SMALL_STATE(3263)] = 30315,
  [SMALL_STATE(3264)] = 30444,
  [SMALL_STATE(3265)] = 30573,
  [SMALL_STATE(3266)] = 30702,
  [SMALL_STATE(3267)] = 30831,
  [SMALL_STATE(3268)] = 30960,
  [SMALL_STATE(3269)] = 31089,
  [SMALL_STATE(3270)] = 31218,
  [SMALL_STATE(3271)] = 31347,
  [SMALL_STATE(3272)] = 31476,
  [SMALL_STATE(3273)] = 31605,
  [SMALL_STATE(3274)] = 31734,
  [SMALL_STATE(3275)] = 31863,
  [SMALL_STATE(3276)] = 31992,
  [SMALL_STATE(3277)] = 32121,
  [SMALL_STATE(3278)] = 32250,
  [SMALL_STATE(3279)] = 32379,
  [SMALL_STATE(3280)] = 32508,
  [SMALL_STATE(3281)] = 32637,
  [SMALL_STATE(3282)] = 32766,
  [SMALL_STATE(3283)] = 32895,
  [SMALL_STATE(3284)] = 33024,
  [SMALL_STATE(3285)] = 33153,
  [SMALL_STATE(3286)] = 33282,
  [SMALL_STATE(3287)] = 33411,
  [SMALL_STATE(3288)] = 33540,
  [SMALL_STATE(3289)] = 33669,
  [SMALL_STATE(3290)] = 33798,
  [SMALL_STATE(3291)] = 33927,
  [SMALL_STATE(3292)] = 34056,
  [SMALL_STATE(3293)] = 34185,
  [SMALL_STATE(3294)] = 34314,
  [SMALL_STATE(3295)] = 34443,
  [SMALL_STATE(3296)] = 34572,
  [SMALL_STATE(3297)] = 34701,
  [SMALL_STATE(3298)] = 34830,
  [SMALL_STATE(3299)] = 34959,
  [SMALL_STATE(3300)] = 35088,
  [SMALL_STATE(3301)] = 35217,
  [SMALL_STATE(3302)] = 35346,
  [SMALL_STATE(3303)] = 35475,
  [SMALL_STATE(3304)] = 35604,
  [SMALL_STATE(3305)] = 35733,
  [SMALL_STATE(3306)] = 35862,
  [SMALL_STATE(3307)] = 35991,
  [SMALL_STATE(3308)] = 36120,
  [SMALL_STATE(3309)] = 36249,
  [SMALL_STATE(3310)] = 36378,
  [SMALL_STATE(3311)] = 36507,
  [SMALL_STATE(3312)] = 36636,
  [SMALL_STATE(3313)] = 36765,
  [SMALL_STATE(3314)] = 36894,
  [SMALL_STATE(3315)] = 37023,
  [SMALL_STATE(3316)] = 37152,
  [SMALL_STATE(3317)] = 37281,
  [SMALL_STATE(3318)] = 37410,
  [SMALL_STATE(3319)] = 37539,
  [SMALL_STATE(3320)] = 37668,
  [SMALL_STATE(3321)] = 37797,
  [SMALL_STATE(3322)] = 37926,
  [SMALL_STATE(3323)] = 38055,
  [SMALL_STATE(3324)] = 38184,
  [SMALL_STATE(3325)] = 38313,
  [SMALL_STATE(3326)] = 38442,
  [SMALL_STATE(3327)] = 38571,
  [SMALL_STATE(3328)] = 38700,
  [SMALL_STATE(3329)] = 38829,
  [SMALL_STATE(3330)] = 38958,
  [SMALL_STATE(3331)] = 39087,
  [SMALL_STATE(3332)] = 39216,
  [SMALL_STATE(3333)] = 39345,
  [SMALL_STATE(3334)] = 39474,
  [SMALL_STATE(3335)] = 39603,
  [SMALL_STATE(3336)] = 39732,
  [SMALL_STATE(3337)] = 39861,
  [SMALL_STATE(3338)] = 39990,
  [SMALL_STATE(3339)] = 40119,
  [SMALL_STATE(3340)] = 40248,
  [SMALL_STATE(3341)] = 40377,
  [SMALL_STATE(3342)] = 40506,
  [SMALL_STATE(3343)] = 40635,
  [SMALL_STATE(3344)] = 40764,
  [SMALL_STATE(3345)] = 40893,
  [SMALL_STATE(3346)] = 41022,
  [SMALL_STATE(3347)] = 41151,
  [SMALL_STATE(3348)] = 41280,
  [SMALL_STATE(3349)] = 41409,
  [SMALL_STATE(3350)] = 41538,
  [SMALL_STATE(3351)] = 41667,
  [SMALL_STATE(3352)] = 41796,
  [SMALL_STATE(3353)] = 41925,
  [SMALL_STATE(3354)] = 42054,
  [SMALL_STATE(3355)] = 42183,
  [SMALL_STATE(3356)] = 42312,
  [SMALL_STATE(3357)] = 42441,
  [SMALL_STATE(3358)] = 42570,
  [SMALL_STATE(3359)] = 42699,
  [SMALL_STATE(3360)] = 42828,
  [SMALL_STATE(3361)] = 42957,
  [SMALL_STATE(3362)] = 43086,
  [SMALL_STATE(3363)] = 43215,
  [SMALL_STATE(3364)] = 43344,
  [SMALL_STATE(3365)] = 43473,
  [SMALL_STATE(3366)] = 43602,
  [SMALL_STATE(3367)] = 43731,
  [SMALL_STATE(3368)] = 43860,
  [SMALL_STATE(3369)] = 43989,
  [SMALL_STATE(3370)] = 44118,
  [SMALL_STATE(3371)] = 44247,
  [SMALL_STATE(3372)] = 44376,
  [SMALL_STATE(3373)] = 44505,
  [SMALL_STATE(3374)] = 44634,
  [SMALL_STATE(3375)] = 44763,
  [SMALL_STATE(3376)] = 44892,
  [SMALL_STATE(3377)] = 45021,
  [SMALL_STATE(3378)] = 45150,
  [SMALL_STATE(3379)] = 45279,
  [SMALL_STATE(3380)] = 45408,
  [SMALL_STATE(3381)] = 45537,
  [SMALL_STATE(3382)] = 45666,
  [SMALL_STATE(3383)] = 45795,
  [SMALL_STATE(3384)] = 45924,
  [SMALL_STATE(3385)] = 46053,
  [SMALL_STATE(3386)] = 46182,
  [SMALL_STATE(3387)] = 46311,
  [SMALL_STATE(3388)] = 46440,
  [SMALL_STATE(3389)] = 46569,
  [SMALL_STATE(3390)] = 46698,
  [SMALL_STATE(3391)] = 46827,
  [SMALL_STATE(3392)] = 46956,
  [SMALL_STATE(3393)] = 47085,
  [SMALL_STATE(3394)] = 47214,
  [SMALL_STATE(3395)] = 47343,
  [SMALL_STATE(3396)] = 47472,
  [SMALL_STATE(3397)] = 47601,
  [SMALL_STATE(3398)] = 47730,
  [SMALL_STATE(3399)] = 47859,
  [SMALL_STATE(3400)] = 47988,
  [SMALL_STATE(3401)] = 48117,
  [SMALL_STATE(3402)] = 48246,
  [SMALL_STATE(3403)] = 48375,
  [SMALL_STATE(3404)] = 48504,
  [SMALL_STATE(3405)] = 48633,
  [SMALL_STATE(3406)] = 48762,
  [SMALL_STATE(3407)] = 48891,
  [SMALL_STATE(3408)] = 49020,
  [SMALL_STATE(3409)] = 49149,
  [SMALL_STATE(3410)] = 49278,
  [SMALL_STATE(3411)] = 49407,
  [SMALL_STATE(3412)] = 49536,
  [SMALL_STATE(3413)] = 49665,
  [SMALL_STATE(3414)] = 49794,
  [SMALL_STATE(3415)] = 49923,
  [SMALL_STATE(3416)] = 50052,
  [SMALL_STATE(3417)] = 50181,
  [SMALL_STATE(3418)] = 50310,
  [SMALL_STATE(3419)] = 50439,
  [SMALL_STATE(3420)] = 50568,
  [SMALL_STATE(3421)] = 50697,
  [SMALL_STATE(3422)] = 50826,
  [SMALL_STATE(3423)] = 50955,
  [SMALL_STATE(3424)] = 51084,
  [SMALL_STATE(3425)] = 51213,
  [SMALL_STATE(3426)] = 51342,
  [SMALL_STATE(3427)] = 51471,
  [SMALL_STATE(3428)] = 51600,
  [SMALL_STATE(3429)] = 51729,
  [SMALL_STATE(3430)] = 51858,
  [SMALL_STATE(3431)] = 51987,
  [SMALL_STATE(3432)] = 52116,
  [SMALL_STATE(3433)] = 52245,
  [SMALL_STATE(3434)] = 52374,
  [SMALL_STATE(3435)] = 52503,
  [SMALL_STATE(3436)] = 52632,
  [SMALL_STATE(3437)] = 52761,
  [SMALL_STATE(3438)] = 52890,
  [SMALL_STATE(3439)] = 53019,
  [SMALL_STATE(3440)] = 53148,
  [SMALL_STATE(3441)] = 53277,
  [SMALL_STATE(3442)] = 53406,
  [SMALL_STATE(3443)] = 53535,
  [SMALL_STATE(3444)] = 53664,
  [SMALL_STATE(3445)] = 53793,
  [SMALL_STATE(3446)] = 53922,
  [SMALL_STATE(3447)] = 54051,
  [SMALL_STATE(3448)] = 54180,
  [SMALL_STATE(3449)] = 54309,
  [SMALL_STATE(3450)] = 54438,
  [SMALL_STATE(3451)] = 54567,
  [SMALL_STATE(3452)] = 54696,
  [SMALL_STATE(3453)] = 54825,
  [SMALL_STATE(3454)] = 54954,
  [SMALL_STATE(3455)] = 55083,
  [SMALL_STATE(3456)] = 55212,
  [SMALL_STATE(3457)] = 55341,
  [SMALL_STATE(3458)] = 55470,
  [SMALL_STATE(3459)] = 55599,
  [SMALL_STATE(3460)] = 55728,
  [SMALL_STATE(3461)] = 55857,
  [SMALL_STATE(3462)] = 55986,
  [SMALL_STATE(3463)] = 56115,
  [SMALL_STATE(3464)] = 56244,
  [SMALL_STATE(3465)] = 56373,
  [SMALL_STATE(3466)] = 56502,
  [SMALL_STATE(3467)] = 56631,
  [SMALL_STATE(3468)] = 56760,
  [SMALL_STATE(3469)] = 56889,
  [SMALL_STATE(3470)] = 57018,
  [SMALL_STATE(3471)] = 57147,
  [SMALL_STATE(3472)] = 57276,
  [SMALL_STATE(3473)] = 57405,
  [SMALL_STATE(3474)] = 57534,
  [SMALL_STATE(3475)] = 57663,
  [SMALL_STATE(3476)] = 57792,
  [SMALL_STATE(3477)] = 57921,
  [SMALL_STATE(3478)] = 58050,
  [SMALL_STATE(3479)] = 58179,
  [SMALL_STATE(3480)] = 58308,
  [SMALL_STATE(3481)] = 58437,
  [SMALL_STATE(3482)] = 58566,
  [SMALL_STATE(3483)] = 58695,
  [SMALL_STATE(3484)] = 58824,
  [SMALL_STATE(3485)] = 58953,
  [SMALL_STATE(3486)] = 59082,
  [SMALL_STATE(3487)] = 59211,
  [SMALL_STATE(3488)] = 59340,
  [SMALL_STATE(3489)] = 59469,
  [SMALL_STATE(3490)] = 59598,
  [SMALL_STATE(3491)] = 59727,
  [SMALL_STATE(3492)] = 59856,
  [SMALL_STATE(3493)] = 59985,
  [SMALL_STATE(3494)] = 60114,
  [SMALL_STATE(3495)] = 60243,
  [SMALL_STATE(3496)] = 60372,
  [SMALL_STATE(3497)] = 60501,
  [SMALL_STATE(3498)] = 60630,
  [SMALL_STATE(3499)] = 60759,
  [SMALL_STATE(3500)] = 60888,
  [SMALL_STATE(3501)] = 61017,
  [SMALL_STATE(3502)] = 61146,
  [SMALL_STATE(3503)] = 61275,
  [SMALL_STATE(3504)] = 61404,
  [SMALL_STATE(3505)] = 61533,
  [SMALL_STATE(3506)] = 61662,
  [SMALL_STATE(3507)] = 61791,
  [SMALL_STATE(3508)] = 61920,
  [SMALL_STATE(3509)] = 62049,
  [SMALL_STATE(3510)] = 62178,
  [SMALL_STATE(3511)] = 62307,
  [SMALL_STATE(3512)] = 62436,
  [SMALL_STATE(3513)] = 62565,
  [SMALL_STATE(3514)] = 62694,
  [SMALL_STATE(3515)] = 62823,
  [SMALL_STATE(3516)] = 62952,
  [SMALL_STATE(3517)] = 63081,
  [SMALL_STATE(3518)] = 63210,
  [SMALL_STATE(3519)] = 63339,
  [SMALL_STATE(3520)] = 63468,
  [SMALL_STATE(3521)] = 63597,
  [SMALL_STATE(3522)] = 63726,
  [SMALL_STATE(3523)] = 63855,
  [SMALL_STATE(3524)] = 63984,
  [SMALL_STATE(3525)] = 64113,
  [SMALL_STATE(3526)] = 64242,
  [SMALL_STATE(3527)] = 64371,
  [SMALL_STATE(3528)] = 64500,
  [SMALL_STATE(3529)] = 64629,
  [SMALL_STATE(3530)] = 64758,
  [SMALL_STATE(3531)] = 64887,
  [SMALL_STATE(3532)] = 65016,
  [SMALL_STATE(3533)] = 65145,
  [SMALL_STATE(3534)] = 65274,
  [SMALL_STATE(3535)] = 65403,
  [SMALL_STATE(3536)] = 65532,
  [SMALL_STATE(3537)] = 65661,
  [SMALL_STATE(3538)] = 65790,
  [SMALL_STATE(3539)] = 65919,
  [SMALL_STATE(3540)] = 66048,
  [SMALL_STATE(3541)] = 66177,
  [SMALL_STATE(3542)] = 66306,
  [SMALL_STATE(3543)] = 66435,
  [SMALL_STATE(3544)] = 66564,
  [SMALL_STATE(3545)] = 66693,
  [SMALL_STATE(3546)] = 66822,
  [SMALL_STATE(3547)] = 66951,
  [SMALL_STATE(3548)] = 67080,
  [SMALL_STATE(3549)] = 67209,
  [SMALL_STATE(3550)] = 67338,
  [SMALL_STATE(3551)] = 67467,
  [SMALL_STATE(3552)] = 67596,
  [SMALL_STATE(3553)] = 67725,
  [SMALL_STATE(3554)] = 67854,
  [SMALL_STATE(3555)] = 67983,
  [SMALL_STATE(3556)] = 68112,
  [SMALL_STATE(3557)] = 68241,
  [SMALL_STATE(3558)] = 68370,
  [SMALL_STATE(3559)] = 68499,
  [SMALL_STATE(3560)] = 68628,
  [SMALL_STATE(3561)] = 68757,
  [SMALL_STATE(3562)] = 68886,
  [SMALL_STATE(3563)] = 69015,
  [SMALL_STATE(3564)] = 69144,
  [SMALL_STATE(3565)] = 69273,
  [SMALL_STATE(3566)] = 69402,
  [SMALL_STATE(3567)] = 69531,
  [SMALL_STATE(3568)] = 69660,
  [SMALL_STATE(3569)] = 69789,
  [SMALL_STATE(3570)] = 69918,
  [SMALL_STATE(3571)] = 70047,
  [SMALL_STATE(3572)] = 70176,
  [SMALL_STATE(3573)] = 70305,
  [SMALL_STATE(3574)] = 70434,
  [SMALL_STATE(3575)] = 70563,
  [SMALL_STATE(3576)] = 70692,
  [SMALL_STATE(3577)] = 70821,
  [SMALL_STATE(3578)] = 70950,
  [SMALL_STATE(3579)] = 71079,
  [SMALL_STATE(3580)] = 71208,
  [SMALL_STATE(3581)] = 71337,
  [SMALL_STATE(3582)] = 71466,
  [SMALL_STATE(3583)] = 71595,
  [SMALL_STATE(3584)] = 71724,
  [SMALL_STATE(3585)] = 71853,
  [SMALL_STATE(3586)] = 71982,
  [SMALL_STATE(3587)] = 72111,
  [SMALL_STATE(3588)] = 72240,
  [SMALL_STATE(3589)] = 72369,
  [SMALL_STATE(3590)] = 72498,
  [SMALL_STATE(3591)] = 72627,
  [SMALL_STATE(3592)] = 72756,
  [SMALL_STATE(3593)] = 72885,
  [SMALL_STATE(3594)] = 73014,
  [SMALL_STATE(3595)] = 73143,
  [SMALL_STATE(3596)] = 73272,
  [SMALL_STATE(3597)] = 73401,
  [SMALL_STATE(3598)] = 73530,
  [SMALL_STATE(3599)] = 73659,
  [SMALL_STATE(3600)] = 73788,
  [SMALL_STATE(3601)] = 73917,
  [SMALL_STATE(3602)] = 74046,
  [SMALL_STATE(3603)] = 74175,
  [SMALL_STATE(3604)] = 74304,
  [SMALL_STATE(3605)] = 74433,
  [SMALL_STATE(3606)] = 74562,
  [SMALL_STATE(3607)] = 74691,
  [SMALL_STATE(3608)] = 74820,
  [SMALL_STATE(3609)] = 74949,
  [SMALL_STATE(3610)] = 75078,
  [SMALL_STATE(3611)] = 75207,
  [SMALL_STATE(3612)] = 75336,
  [SMALL_STATE(3613)] = 75465,
  [SMALL_STATE(3614)] = 75594,
  [SMALL_STATE(3615)] = 75723,
  [SMALL_STATE(3616)] = 75852,
  [SMALL_STATE(3617)] = 75981,
  [SMALL_STATE(3618)] = 76110,
  [SMALL_STATE(3619)] = 76239,
  [SMALL_STATE(3620)] = 76368,
  [SMALL_STATE(3621)] = 76497,
  [SMALL_STATE(3622)] = 76626,
  [SMALL_STATE(3623)] = 76755,
  [SMALL_STATE(3624)] = 76884,
  [SMALL_STATE(3625)] = 77013,
  [SMALL_STATE(3626)] = 77142,
  [SMALL_STATE(3627)] = 77271,
  [SMALL_STATE(3628)] = 77400,
  [SMALL_STATE(3629)] = 77529,
  [SMALL_STATE(3630)] = 77658,
  [SMALL_STATE(3631)] = 77787,
  [SMALL_STATE(3632)] = 77916,
  [SMALL_STATE(3633)] = 78045,
  [SMALL_STATE(3634)] = 78174,
  [SMALL_STATE(3635)] = 78303,
  [SMALL_STATE(3636)] = 78432,
  [SMALL_STATE(3637)] = 78561,
  [SMALL_STATE(3638)] = 78690,
  [SMALL_STATE(3639)] = 78819,
  [SMALL_STATE(3640)] = 78948,
  [SMALL_STATE(3641)] = 79077,
  [SMALL_STATE(3642)] = 79206,
  [SMALL_STATE(3643)] = 79335,
  [SMALL_STATE(3644)] = 79464,
  [SMALL_STATE(3645)] = 79593,
  [SMALL_STATE(3646)] = 79722,
  [SMALL_STATE(3647)] = 79851,
  [SMALL_STATE(3648)] = 79980,
  [SMALL_STATE(3649)] = 80109,
  [SMALL_STATE(3650)] = 80238,
  [SMALL_STATE(3651)] = 80367,
  [SMALL_STATE(3652)] = 80496,
  [SMALL_STATE(3653)] = 80625,
  [SMALL_STATE(3654)] = 80754,
  [SMALL_STATE(3655)] = 80883,
  [SMALL_STATE(3656)] = 81012,
  [SMALL_STATE(3657)] = 81141,
  [SMALL_STATE(3658)] = 81270,
  [SMALL_STATE(3659)] = 81399,
  [SMALL_STATE(3660)] = 81528,
  [SMALL_STATE(3661)] = 81657,
  [SMALL_STATE(3662)] = 81786,
  [SMALL_STATE(3663)] = 81915,
  [SMALL_STATE(3664)] = 82044,
  [SMALL_STATE(3665)] = 82173,
  [SMALL_STATE(3666)] = 82302,
  [SMALL_STATE(3667)] = 82431,
  [SMALL_STATE(3668)] = 82560,
  [SMALL_STATE(3669)] = 82689,
  [SMALL_STATE(3670)] = 82818,
  [SMALL_STATE(3671)] = 82947,
  [SMALL_STATE(3672)] = 83076,
  [SMALL_STATE(3673)] = 83205,
  [SMALL_STATE(3674)] = 83334,
  [SMALL_STATE(3675)] = 83463,
  [SMALL_STATE(3676)] = 83592,
  [SMALL_STATE(3677)] = 83721,
  [SMALL_STATE(3678)] = 83850,
  [SMALL_STATE(3679)] = 83979,
  [SMALL_STATE(3680)] = 84108,
  [SMALL_STATE(3681)] = 84237,
  [SMALL_STATE(3682)] = 84366,
  [SMALL_STATE(3683)] = 84495,
  [SMALL_STATE(3684)] = 84624,
  [SMALL_STATE(3685)] = 84753,
  [SMALL_STATE(3686)] = 84882,
  [SMALL_STATE(3687)] = 85011,
  [SMALL_STATE(3688)] = 85140,
  [SMALL_STATE(3689)] = 85269,
  [SMALL_STATE(3690)] = 85398,
  [SMALL_STATE(3691)] = 85527,
  [SMALL_STATE(3692)] = 85656,
  [SMALL_STATE(3693)] = 85785,
  [SMALL_STATE(3694)] = 85914,
  [SMALL_STATE(3695)] = 86043,
  [SMALL_STATE(3696)] = 86172,
  [SMALL_STATE(3697)] = 86301,
  [SMALL_STATE(3698)] = 86430,
  [SMALL_STATE(3699)] = 86559,
  [SMALL_STATE(3700)] = 86688,
  [SMALL_STATE(3701)] = 86817,
  [SMALL_STATE(3702)] = 86946,
  [SMALL_STATE(3703)] = 87075,
  [SMALL_STATE(3704)] = 87204,
  [SMALL_STATE(3705)] = 87333,
  [SMALL_STATE(3706)] = 87462,
  [SMALL_STATE(3707)] = 87591,
  [SMALL_STATE(3708)] = 87720,
  [SMALL_STATE(3709)] = 87849,
  [SMALL_STATE(3710)] = 87978,
  [SMALL_STATE(3711)] = 88107,
  [SMALL_STATE(3712)] = 88236,
  [SMALL_STATE(3713)] = 88365,
  [SMALL_STATE(3714)] = 88494,
  [SMALL_STATE(3715)] = 88623,
  [SMALL_STATE(3716)] = 88752,
  [SMALL_STATE(3717)] = 88881,
  [SMALL_STATE(3718)] = 89010,
  [SMALL_STATE(3719)] = 89139,
  [SMALL_STATE(3720)] = 89268,
  [SMALL_STATE(3721)] = 89397,
  [SMALL_STATE(3722)] = 89526,
  [SMALL_STATE(3723)] = 89655,
  [SMALL_STATE(3724)] = 89784,
  [SMALL_STATE(3725)] = 89913,
  [SMALL_STATE(3726)] = 90042,
  [SMALL_STATE(3727)] = 90171,
  [SMALL_STATE(3728)] = 90300,
  [SMALL_STATE(3729)] = 90429,
  [SMALL_STATE(3730)] = 90558,
  [SMALL_STATE(3731)] = 90687,
  [SMALL_STATE(3732)] = 90816,
  [SMALL_STATE(3733)] = 90945,
  [SMALL_STATE(3734)] = 91074,
  [SMALL_STATE(3735)] = 91203,
  [SMALL_STATE(3736)] = 91332,
  [SMALL_STATE(3737)] = 91461,
  [SMALL_STATE(3738)] = 91590,
  [SMALL_STATE(3739)] = 91719,
  [SMALL_STATE(3740)] = 91848,
  [SMALL_STATE(3741)] = 91977,
  [SMALL_STATE(3742)] = 92106,
  [SMALL_STATE(3743)] = 92235,
  [SMALL_STATE(3744)] = 92364,
  [SMALL_STATE(3745)] = 92493,
  [SMALL_STATE(3746)] = 92622,
  [SMALL_STATE(3747)] = 92751,
  [SMALL_STATE(3748)] = 92880,
  [SMALL_STATE(3749)] = 93009,
  [SMALL_STATE(3750)] = 93138,
  [SMALL_STATE(3751)] = 93267,
  [SMALL_STATE(3752)] = 93396,
  [SMALL_STATE(3753)] = 93525,
  [SMALL_STATE(3754)] = 93654,
  [SMALL_STATE(3755)] = 93783,
  [SMALL_STATE(3756)] = 93912,
  [SMALL_STATE(3757)] = 94041,
  [SMALL_STATE(3758)] = 94170,
  [SMALL_STATE(3759)] = 94299,
  [SMALL_STATE(3760)] = 94428,
  [SMALL_STATE(3761)] = 94557,
  [SMALL_STATE(3762)] = 94686,
  [SMALL_STATE(3763)] = 94815,
  [SMALL_STATE(3764)] = 94944,
  [SMALL_STATE(3765)] = 95073,
  [SMALL_STATE(3766)] = 95202,
  [SMALL_STATE(3767)] = 95331,
  [SMALL_STATE(3768)] = 95460,
  [SMALL_STATE(3769)] = 95589,
  [SMALL_STATE(3770)] = 95718,
  [SMALL_STATE(3771)] = 95847,
  [SMALL_STATE(3772)] = 95976,
  [SMALL_STATE(3773)] = 96105,
  [SMALL_STATE(3774)] = 96234,
  [SMALL_STATE(3775)] = 96363,
  [SMALL_STATE(3776)] = 96492,
  [SMALL_STATE(3777)] = 96621,
  [SMALL_STATE(3778)] = 96750,
  [SMALL_STATE(3779)] = 96879,
  [SMALL_STATE(3780)] = 97008,
  [SMALL_STATE(3781)] = 97137,
  [SMALL_STATE(3782)] = 97266,
  [SMALL_STATE(3783)] = 97395,
  [SMALL_STATE(3784)] = 97524,
  [SMALL_STATE(3785)] = 97653,
  [SMALL_STATE(3786)] = 97782,
  [SMALL_STATE(3787)] = 97911,
  [SMALL_STATE(3788)] = 98040,
  [SMALL_STATE(3789)] = 98169,
  [SMALL_STATE(3790)] = 98298,
  [SMALL_STATE(3791)] = 98427,
  [SMALL_STATE(3792)] = 98556,
  [SMALL_STATE(3793)] = 98685,
  [SMALL_STATE(3794)] = 98814,
  [SMALL_STATE(3795)] = 98943,
  [SMALL_STATE(3796)] = 99072,
  [SMALL_STATE(3797)] = 99201,
  [SMALL_STATE(3798)] = 99330,
  [SMALL_STATE(3799)] = 99459,
  [SMALL_STATE(3800)] = 99588,
  [SMALL_STATE(3801)] = 99717,
  [SMALL_STATE(3802)] = 99846,
  [SMALL_STATE(3803)] = 99975,
  [SMALL_STATE(3804)] = 100104,
  [SMALL_STATE(3805)] = 100233,
  [SMALL_STATE(3806)] = 100362,
  [SMALL_STATE(3807)] = 100491,
  [SMALL_STATE(3808)] = 100620,
  [SMALL_STATE(3809)] = 100749,
  [SMALL_STATE(3810)] = 100878,
  [SMALL_STATE(3811)] = 101007,
  [SMALL_STATE(3812)] = 101136,
  [SMALL_STATE(3813)] = 101265,
  [SMALL_STATE(3814)] = 101394,
  [SMALL_STATE(3815)] = 101523,
  [SMALL_STATE(3816)] = 101652,
  [SMALL_STATE(3817)] = 101781,
  [SMALL_STATE(3818)] = 101910,
  [SMALL_STATE(3819)] = 102039,
  [SMALL_STATE(3820)] = 102168,
  [SMALL_STATE(3821)] = 102297,
  [SMALL_STATE(3822)] = 102426,
  [SMALL_STATE(3823)] = 102555,
  [SMALL_STATE(3824)] = 102684,
  [SMALL_STATE(3825)] = 102813,
  [SMALL_STATE(3826)] = 102942,
  [SMALL_STATE(3827)] = 103071,
  [SMALL_STATE(3828)] = 103200,
  [SMALL_STATE(3829)] = 103329,
  [SMALL_STATE(3830)] = 103458,
  [SMALL_STATE(3831)] = 103587,
  [SMALL_STATE(3832)] = 103716,
  [SMALL_STATE(3833)] = 103845,
  [SMALL_STATE(3834)] = 103974,
  [SMALL_STATE(3835)] = 104103,
  [SMALL_STATE(3836)] = 104232,
  [SMALL_STATE(3837)] = 104361,
  [SMALL_STATE(3838)] = 104490,
  [SMALL_STATE(3839)] = 104619,
  [SMALL_STATE(3840)] = 104748,
  [SMALL_STATE(3841)] = 104877,
  [SMALL_STATE(3842)] = 105006,
  [SMALL_STATE(3843)] = 105135,
  [SMALL_STATE(3844)] = 105264,
  [SMALL_STATE(3845)] = 105393,
  [SMALL_STATE(3846)] = 105522,
  [SMALL_STATE(3847)] = 105651,
  [SMALL_STATE(3848)] = 105780,
  [SMALL_STATE(3849)] = 105909,
  [SMALL_STATE(3850)] = 106038,
  [SMALL_STATE(3851)] = 106167,
  [SMALL_STATE(3852)] = 106296,
  [SMALL_STATE(3853)] = 106425,
  [SMALL_STATE(3854)] = 106554,
  [SMALL_STATE(3855)] = 106683,
  [SMALL_STATE(3856)] = 106812,
  [SMALL_STATE(3857)] = 106941,
  [SMALL_STATE(3858)] = 107070,
  [SMALL_STATE(3859)] = 107199,
  [SMALL_STATE(3860)] = 107328,
  [SMALL_STATE(3861)] = 107457,
  [SMALL_STATE(3862)] = 107586,
  [SMALL_STATE(3863)] = 107715,
  [SMALL_STATE(3864)] = 107844,
  [SMALL_STATE(3865)] = 107973,
  [SMALL_STATE(3866)] = 108102,
  [SMALL_STATE(3867)] = 108231,
  [SMALL_STATE(3868)] = 108360,
  [SMALL_STATE(3869)] = 108489,
  [SMALL_STATE(3870)] = 108618,
  [SMALL_STATE(3871)] = 108747,
  [SMALL_STATE(3872)] = 108876,
  [SMALL_STATE(3873)] = 109005,
  [SMALL_STATE(3874)] = 109134,
  [SMALL_STATE(3875)] = 109263,
  [SMALL_STATE(3876)] = 109392,
  [SMALL_STATE(3877)] = 109521,
  [SMALL_STATE(3878)] = 109650,
  [SMALL_STATE(3879)] = 109779,
  [SMALL_STATE(3880)] = 109908,
  [SMALL_STATE(3881)] = 110037,
  [SMALL_STATE(3882)] = 110166,
  [SMALL_STATE(3883)] = 110295,
  [SMALL_STATE(3884)] = 110424,
  [SMALL_STATE(3885)] = 110553,
  [SMALL_STATE(3886)] = 110682,
  [SMALL_STATE(3887)] = 110811,
  [SMALL_STATE(3888)] = 110940,
  [SMALL_STATE(3889)] = 111069,
  [SMALL_STATE(3890)] = 111198,
  [SMALL_STATE(3891)] = 111327,
  [SMALL_STATE(3892)] = 111456,
  [SMALL_STATE(3893)] = 111585,
  [SMALL_STATE(3894)] = 111714,
  [SMALL_STATE(3895)] = 111843,
  [SMALL_STATE(3896)] = 111972,
  [SMALL_STATE(3897)] = 112101,
  [SMALL_STATE(3898)] = 112230,
  [SMALL_STATE(3899)] = 112359,
  [SMALL_STATE(3900)] = 112488,
  [SMALL_STATE(3901)] = 112617,
  [SMALL_STATE(3902)] = 112746,
  [SMALL_STATE(3903)] = 112875,
  [SMALL_STATE(3904)] = 113004,
  [SMALL_STATE(3905)] = 113133,
  [SMALL_STATE(3906)] = 113262,
  [SMALL_STATE(3907)] = 113391,
  [SMALL_STATE(3908)] = 113520,
  [SMALL_STATE(3909)] = 113649,
  [SMALL_STATE(3910)] = 113778,
  [SMALL_STATE(3911)] = 113907,
  [SMALL_STATE(3912)] = 114036,
  [SMALL_STATE(3913)] = 114165,
  [SMALL_STATE(3914)] = 114294,
  [SMALL_STATE(3915)] = 114423,
  [SMALL_STATE(3916)] = 114552,
  [SMALL_STATE(3917)] = 114681,
  [SMALL_STATE(3918)] = 114810,
  [SMALL_STATE(3919)] = 114939,
  [SMALL_STATE(3920)] = 115068,
  [SMALL_STATE(3921)] = 115197,
  [SMALL_STATE(3922)] = 115326,
  [SMALL_STATE(3923)] = 115455,
  [SMALL_STATE(3924)] = 115584,
  [SMALL_STATE(3925)] = 115713,
  [SMALL_STATE(3926)] = 115842,
  [SMALL_STATE(3927)] = 115971,
  [SMALL_STATE(3928)] = 116100,
  [SMALL_STATE(3929)] = 116229,
  [SMALL_STATE(3930)] = 116358,
  [SMALL_STATE(3931)] = 116487,
  [SMALL_STATE(3932)] = 116616,
  [SMALL_STATE(3933)] = 116745,
  [SMALL_STATE(3934)] = 116874,
  [SMALL_STATE(3935)] = 117003,
  [SMALL_STATE(3936)] = 117132,
  [SMALL_STATE(3937)] = 117261,
  [SMALL_STATE(3938)] = 117390,
  [SMALL_STATE(3939)] = 117519,
  [SMALL_STATE(3940)] = 117648,
  [SMALL_STATE(3941)] = 117777,
  [SMALL_STATE(3942)] = 117906,
  [SMALL_STATE(3943)] = 118035,
  [SMALL_STATE(3944)] = 118164,
  [SMALL_STATE(3945)] = 118293,
  [SMALL_STATE(3946)] = 118422,
  [SMALL_STATE(3947)] = 118551,
  [SMALL_STATE(3948)] = 118680,
  [SMALL_STATE(3949)] = 118809,
  [SMALL_STATE(3950)] = 118938,
  [SMALL_STATE(3951)] = 119067,
  [SMALL_STATE(3952)] = 119196,
  [SMALL_STATE(3953)] = 119325,
  [SMALL_STATE(3954)] = 119454,
  [SMALL_STATE(3955)] = 119583,
  [SMALL_STATE(3956)] = 119712,
  [SMALL_STATE(3957)] = 119841,
  [SMALL_STATE(3958)] = 119970,
  [SMALL_STATE(3959)] = 120099,
  [SMALL_STATE(3960)] = 120228,
  [SMALL_STATE(3961)] = 120357,
  [SMALL_STATE(3962)] = 120486,
  [SMALL_STATE(3963)] = 120615,
  [SMALL_STATE(3964)] = 120744,
  [SMALL_STATE(3965)] = 120873,
  [SMALL_STATE(3966)] = 121002,
  [SMALL_STATE(3967)] = 121131,
  [SMALL_STATE(3968)] = 121260,
  [SMALL_STATE(3969)] = 121389,
  [SMALL_STATE(3970)] = 121518,
  [SMALL_STATE(3971)] = 121647,
  [SMALL_STATE(3972)] = 121776,
  [SMALL_STATE(3973)] = 121905,
  [SMALL_STATE(3974)] = 122034,
  [SMALL_STATE(3975)] = 122163,
  [SMALL_STATE(3976)] = 122292,
  [SMALL_STATE(3977)] = 122421,
  [SMALL_STATE(3978)] = 122550,
  [SMALL_STATE(3979)] = 122679,
  [SMALL_STATE(3980)] = 122808,
  [SMALL_STATE(3981)] = 122937,
  [SMALL_STATE(3982)] = 123066,
  [SMALL_STATE(3983)] = 123195,
  [SMALL_STATE(3984)] = 123324,
  [SMALL_STATE(3985)] = 123453,
  [SMALL_STATE(3986)] = 123582,
  [SMALL_STATE(3987)] = 123711,
  [SMALL_STATE(3988)] = 123840,
  [SMALL_STATE(3989)] = 123969,
  [SMALL_STATE(3990)] = 124096,
  [SMALL_STATE(3991)] = 124225,
  [SMALL_STATE(3992)] = 124354,
  [SMALL_STATE(3993)] = 124483,
  [SMALL_STATE(3994)] = 124612,
  [SMALL_STATE(3995)] = 124741,
  [SMALL_STATE(3996)] = 124870,
  [SMALL_STATE(3997)] = 124999,
  [SMALL_STATE(3998)] = 125128,
  [SMALL_STATE(3999)] = 125257,
  [SMALL_STATE(4000)] = 125386,
  [SMALL_STATE(4001)] = 125515,
  [SMALL_STATE(4002)] = 125644,
  [SMALL_STATE(4003)] = 125773,
  [SMALL_STATE(4004)] = 125902,
  [SMALL_STATE(4005)] = 126031,
  [SMALL_STATE(4006)] = 126160,
  [SMALL_STATE(4007)] = 126289,
  [SMALL_STATE(4008)] = 126418,
  [SMALL_STATE(4009)] = 126547,
  [SMALL_STATE(4010)] = 126676,
  [SMALL_STATE(4011)] = 126805,
  [SMALL_STATE(4012)] = 126934,
  [SMALL_STATE(4013)] = 127063,
  [SMALL_STATE(4014)] = 127192,
  [SMALL_STATE(4015)] = 127321,
  [SMALL_STATE(4016)] = 127450,
  [SMALL_STATE(4017)] = 127579,
  [SMALL_STATE(4018)] = 127708,
  [SMALL_STATE(4019)] = 127837,
  [SMALL_STATE(4020)] = 127966,
  [SMALL_STATE(4021)] = 128095,
  [SMALL_STATE(4022)] = 128224,
  [SMALL_STATE(4023)] = 128353,
  [SMALL_STATE(4024)] = 128482,
  [SMALL_STATE(4025)] = 128611,
  [SMALL_STATE(4026)] = 128740,
  [SMALL_STATE(4027)] = 128869,
  [SMALL_STATE(4028)] = 128998,
  [SMALL_STATE(4029)] = 129127,
  [SMALL_STATE(4030)] = 129256,
  [SMALL_STATE(4031)] = 129385,
  [SMALL_STATE(4032)] = 129514,
  [SMALL_STATE(4033)] = 129643,
  [SMALL_STATE(4034)] = 129772,
  [SMALL_STATE(4035)] = 129901,
  [SMALL_STATE(4036)] = 130030,
  [SMALL_STATE(4037)] = 130159,
  [SMALL_STATE(4038)] = 130288,
  [SMALL_STATE(4039)] = 130417,
  [SMALL_STATE(4040)] = 130546,
  [SMALL_STATE(4041)] = 130675,
  [SMALL_STATE(4042)] = 130804,
  [SMALL_STATE(4043)] = 130933,
  [SMALL_STATE(4044)] = 131062,
  [SMALL_STATE(4045)] = 131191,
  [SMALL_STATE(4046)] = 131320,
  [SMALL_STATE(4047)] = 131449,
  [SMALL_STATE(4048)] = 131578,
  [SMALL_STATE(4049)] = 131707,
  [SMALL_STATE(4050)] = 131836,
  [SMALL_STATE(4051)] = 131965,
  [SMALL_STATE(4052)] = 132094,
  [SMALL_STATE(4053)] = 132223,
  [SMALL_STATE(4054)] = 132352,
  [SMALL_STATE(4055)] = 132481,
  [SMALL_STATE(4056)] = 132610,
  [SMALL_STATE(4057)] = 132739,
  [SMALL_STATE(4058)] = 132868,
  [SMALL_STATE(4059)] = 132997,
  [SMALL_STATE(4060)] = 133126,
  [SMALL_STATE(4061)] = 133255,
  [SMALL_STATE(4062)] = 133384,
  [SMALL_STATE(4063)] = 133513,
  [SMALL_STATE(4064)] = 133642,
  [SMALL_STATE(4065)] = 133771,
  [SMALL_STATE(4066)] = 133900,
  [SMALL_STATE(4067)] = 134029,
  [SMALL_STATE(4068)] = 134158,
  [SMALL_STATE(4069)] = 134287,
  [SMALL_STATE(4070)] = 134416,
  [SMALL_STATE(4071)] = 134545,
  [SMALL_STATE(4072)] = 134674,
  [SMALL_STATE(4073)] = 134803,
  [SMALL_STATE(4074)] = 134932,
  [SMALL_STATE(4075)] = 135061,
  [SMALL_STATE(4076)] = 135190,
  [SMALL_STATE(4077)] = 135319,
  [SMALL_STATE(4078)] = 135448,
  [SMALL_STATE(4079)] = 135577,
  [SMALL_STATE(4080)] = 135706,
  [SMALL_STATE(4081)] = 135835,
  [SMALL_STATE(4082)] = 135964,
  [SMALL_STATE(4083)] = 136093,
  [SMALL_STATE(4084)] = 136222,
  [SMALL_STATE(4085)] = 136351,
  [SMALL_STATE(4086)] = 136480,
  [SMALL_STATE(4087)] = 136609,
  [SMALL_STATE(4088)] = 136738,
  [SMALL_STATE(4089)] = 136867,
  [SMALL_STATE(4090)] = 136990,
  [SMALL_STATE(4091)] = 137113,
  [SMALL_STATE(4092)] = 137236,
  [SMALL_STATE(4093)] = 137359,
  [SMALL_STATE(4094)] = 137482,
  [SMALL_STATE(4095)] = 137605,
  [SMALL_STATE(4096)] = 137728,
  [SMALL_STATE(4097)] = 137851,
  [SMALL_STATE(4098)] = 137974,
  [SMALL_STATE(4099)] = 138097,
  [SMALL_STATE(4100)] = 138220,
  [SMALL_STATE(4101)] = 138343,
  [SMALL_STATE(4102)] = 138466,
  [SMALL_STATE(4103)] = 138589,
  [SMALL_STATE(4104)] = 138712,
  [SMALL_STATE(4105)] = 138835,
  [SMALL_STATE(4106)] = 138958,
  [SMALL_STATE(4107)] = 139081,
  [SMALL_STATE(4108)] = 139204,
  [SMALL_STATE(4109)] = 139327,
  [SMALL_STATE(4110)] = 139450,
  [SMALL_STATE(4111)] = 139573,
  [SMALL_STATE(4112)] = 139696,
  [SMALL_STATE(4113)] = 139819,
  [SMALL_STATE(4114)] = 139942,
  [SMALL_STATE(4115)] = 140065,
  [SMALL_STATE(4116)] = 140188,
  [SMALL_STATE(4117)] = 140311,
  [SMALL_STATE(4118)] = 140434,
  [SMALL_STATE(4119)] = 140557,
  [SMALL_STATE(4120)] = 140680,
  [SMALL_STATE(4121)] = 140803,
  [SMALL_STATE(4122)] = 140926,
  [SMALL_STATE(4123)] = 141049,
  [SMALL_STATE(4124)] = 141172,
  [SMALL_STATE(4125)] = 141295,
  [SMALL_STATE(4126)] = 141418,
  [SMALL_STATE(4127)] = 141541,
  [SMALL_STATE(4128)] = 141664,
  [SMALL_STATE(4129)] = 141787,
  [SMALL_STATE(4130)] = 141910,
  [SMALL_STATE(4131)] = 142033,
  [SMALL_STATE(4132)] = 142156,
  [SMALL_STATE(4133)] = 142279,
  [SMALL_STATE(4134)] = 142402,
  [SMALL_STATE(4135)] = 142525,
  [SMALL_STATE(4136)] = 142648,
  [SMALL_STATE(4137)] = 142771,
  [SMALL_STATE(4138)] = 142894,
  [SMALL_STATE(4139)] = 143017,
  [SMALL_STATE(4140)] = 143140,
  [SMALL_STATE(4141)] = 143263,
  [SMALL_STATE(4142)] = 143386,
  [SMALL_STATE(4143)] = 143509,
  [SMALL_STATE(4144)] = 143632,
  [SMALL_STATE(4145)] = 143755,
  [SMALL_STATE(4146)] = 143878,
  [SMALL_STATE(4147)] = 144001,
  [SMALL_STATE(4148)] = 144124,
  [SMALL_STATE(4149)] = 144247,
  [SMALL_STATE(4150)] = 144370,
  [SMALL_STATE(4151)] = 144493,
  [SMALL_STATE(4152)] = 144616,
  [SMALL_STATE(4153)] = 144739,
  [SMALL_STATE(4154)] = 144862,
  [SMALL_STATE(4155)] = 144985,
  [SMALL_STATE(4156)] = 145108,
  [SMALL_STATE(4157)] = 145231,
  [SMALL_STATE(4158)] = 145354,
  [SMALL_STATE(4159)] = 145477,
  [SMALL_STATE(4160)] = 145600,
  [SMALL_STATE(4161)] = 145723,
  [SMALL_STATE(4162)] = 145846,
  [SMALL_STATE(4163)] = 145969,
  [SMALL_STATE(4164)] = 146092,
  [SMALL_STATE(4165)] = 146215,
  [SMALL_STATE(4166)] = 146338,
  [SMALL_STATE(4167)] = 146461,
  [SMALL_STATE(4168)] = 146584,
  [SMALL_STATE(4169)] = 146707,
  [SMALL_STATE(4170)] = 146830,
  [SMALL_STATE(4171)] = 146953,
  [SMALL_STATE(4172)] = 147076,
  [SMALL_STATE(4173)] = 147199,
  [SMALL_STATE(4174)] = 147322,
  [SMALL_STATE(4175)] = 147445,
  [SMALL_STATE(4176)] = 147568,
  [SMALL_STATE(4177)] = 147691,
  [SMALL_STATE(4178)] = 147814,
  [SMALL_STATE(4179)] = 147937,
  [SMALL_STATE(4180)] = 148060,
  [SMALL_STATE(4181)] = 148183,
  [SMALL_STATE(4182)] = 148306,
  [SMALL_STATE(4183)] = 148429,
  [SMALL_STATE(4184)] = 148552,
  [SMALL_STATE(4185)] = 148675,
  [SMALL_STATE(4186)] = 148798,
  [SMALL_STATE(4187)] = 148921,
  [SMALL_STATE(4188)] = 149044,
  [SMALL_STATE(4189)] = 149167,
  [SMALL_STATE(4190)] = 149290,
  [SMALL_STATE(4191)] = 149413,
  [SMALL_STATE(4192)] = 149536,
  [SMALL_STATE(4193)] = 149659,
  [SMALL_STATE(4194)] = 149782,
  [SMALL_STATE(4195)] = 149905,
  [SMALL_STATE(4196)] = 150028,
  [SMALL_STATE(4197)] = 150151,
  [SMALL_STATE(4198)] = 150274,
  [SMALL_STATE(4199)] = 150397,
  [SMALL_STATE(4200)] = 150520,
  [SMALL_STATE(4201)] = 150643,
  [SMALL_STATE(4202)] = 150766,
  [SMALL_STATE(4203)] = 150889,
  [SMALL_STATE(4204)] = 151012,
  [SMALL_STATE(4205)] = 151135,
  [SMALL_STATE(4206)] = 151258,
  [SMALL_STATE(4207)] = 151381,
  [SMALL_STATE(4208)] = 151504,
  [SMALL_STATE(4209)] = 151627,
  [SMALL_STATE(4210)] = 151750,
  [SMALL_STATE(4211)] = 151873,
  [SMALL_STATE(4212)] = 151996,
  [SMALL_STATE(4213)] = 152119,
  [SMALL_STATE(4214)] = 152242,
  [SMALL_STATE(4215)] = 152365,
  [SMALL_STATE(4216)] = 152488,
  [SMALL_STATE(4217)] = 152611,
  [SMALL_STATE(4218)] = 152734,
  [SMALL_STATE(4219)] = 152857,
  [SMALL_STATE(4220)] = 152980,
  [SMALL_STATE(4221)] = 153103,
  [SMALL_STATE(4222)] = 153226,
  [SMALL_STATE(4223)] = 153349,
  [SMALL_STATE(4224)] = 153472,
  [SMALL_STATE(4225)] = 153595,
  [SMALL_STATE(4226)] = 153718,
  [SMALL_STATE(4227)] = 153841,
  [SMALL_STATE(4228)] = 153964,
  [SMALL_STATE(4229)] = 154087,
  [SMALL_STATE(4230)] = 154210,
  [SMALL_STATE(4231)] = 154333,
  [SMALL_STATE(4232)] = 154456,
  [SMALL_STATE(4233)] = 154579,
  [SMALL_STATE(4234)] = 154702,
  [SMALL_STATE(4235)] = 154825,
  [SMALL_STATE(4236)] = 154948,
  [SMALL_STATE(4237)] = 155071,
  [SMALL_STATE(4238)] = 155194,
  [SMALL_STATE(4239)] = 155317,
  [SMALL_STATE(4240)] = 155440,
  [SMALL_STATE(4241)] = 155563,
  [SMALL_STATE(4242)] = 155686,
  [SMALL_STATE(4243)] = 155809,
  [SMALL_STATE(4244)] = 155932,
  [SMALL_STATE(4245)] = 156055,
  [SMALL_STATE(4246)] = 156178,
  [SMALL_STATE(4247)] = 156301,
  [SMALL_STATE(4248)] = 156424,
  [SMALL_STATE(4249)] = 156547,
  [SMALL_STATE(4250)] = 156670,
  [SMALL_STATE(4251)] = 156793,
  [SMALL_STATE(4252)] = 156916,
  [SMALL_STATE(4253)] = 157039,
  [SMALL_STATE(4254)] = 157162,
  [SMALL_STATE(4255)] = 157285,
  [SMALL_STATE(4256)] = 157408,
  [SMALL_STATE(4257)] = 157531,
  [SMALL_STATE(4258)] = 157654,
  [SMALL_STATE(4259)] = 157777,
  [SMALL_STATE(4260)] = 157900,
  [SMALL_STATE(4261)] = 158023,
  [SMALL_STATE(4262)] = 158146,
  [SMALL_STATE(4263)] = 158269,
  [SMALL_STATE(4264)] = 158392,
  [SMALL_STATE(4265)] = 158515,
  [SMALL_STATE(4266)] = 158638,
  [SMALL_STATE(4267)] = 158761,
  [SMALL_STATE(4268)] = 158884,
  [SMALL_STATE(4269)] = 159007,
  [SMALL_STATE(4270)] = 159130,
  [SMALL_STATE(4271)] = 159253,
  [SMALL_STATE(4272)] = 159376,
  [SMALL_STATE(4273)] = 159499,
  [SMALL_STATE(4274)] = 159622,
  [SMALL_STATE(4275)] = 159745,
  [SMALL_STATE(4276)] = 159868,
  [SMALL_STATE(4277)] = 159991,
  [SMALL_STATE(4278)] = 160114,
  [SMALL_STATE(4279)] = 160237,
  [SMALL_STATE(4280)] = 160360,
  [SMALL_STATE(4281)] = 160483,
  [SMALL_STATE(4282)] = 160606,
  [SMALL_STATE(4283)] = 160729,
  [SMALL_STATE(4284)] = 160852,
  [SMALL_STATE(4285)] = 160975,
  [SMALL_STATE(4286)] = 161098,
  [SMALL_STATE(4287)] = 161221,
  [SMALL_STATE(4288)] = 161344,
  [SMALL_STATE(4289)] = 161467,
  [SMALL_STATE(4290)] = 161590,
  [SMALL_STATE(4291)] = 161713,
  [SMALL_STATE(4292)] = 161836,
  [SMALL_STATE(4293)] = 161959,
  [SMALL_STATE(4294)] = 162082,
  [SMALL_STATE(4295)] = 162205,
  [SMALL_STATE(4296)] = 162328,
  [SMALL_STATE(4297)] = 162451,
  [SMALL_STATE(4298)] = 162574,
  [SMALL_STATE(4299)] = 162697,
  [SMALL_STATE(4300)] = 162820,
  [SMALL_STATE(4301)] = 162943,
  [SMALL_STATE(4302)] = 163066,
  [SMALL_STATE(4303)] = 163189,
  [SMALL_STATE(4304)] = 163312,
  [SMALL_STATE(4305)] = 163435,
  [SMALL_STATE(4306)] = 163558,
  [SMALL_STATE(4307)] = 163681,
  [SMALL_STATE(4308)] = 163804,
  [SMALL_STATE(4309)] = 163927,
  [SMALL_STATE(4310)] = 164050,
  [SMALL_STATE(4311)] = 164173,
  [SMALL_STATE(4312)] = 164296,
  [SMALL_STATE(4313)] = 164419,
  [SMALL_STATE(4314)] = 164542,
  [SMALL_STATE(4315)] = 164665,
  [SMALL_STATE(4316)] = 164788,
  [SMALL_STATE(4317)] = 164911,
  [SMALL_STATE(4318)] = 165034,
  [SMALL_STATE(4319)] = 165157,
  [SMALL_STATE(4320)] = 165280,
  [SMALL_STATE(4321)] = 165403,
  [SMALL_STATE(4322)] = 165526,
  [SMALL_STATE(4323)] = 165649,
  [SMALL_STATE(4324)] = 165772,
  [SMALL_STATE(4325)] = 165895,
  [SMALL_STATE(4326)] = 166018,
  [SMALL_STATE(4327)] = 166141,
  [SMALL_STATE(4328)] = 166264,
  [SMALL_STATE(4329)] = 166387,
  [SMALL_STATE(4330)] = 166510,
  [SMALL_STATE(4331)] = 166633,
  [SMALL_STATE(4332)] = 166756,
  [SMALL_STATE(4333)] = 166879,
  [SMALL_STATE(4334)] = 167002,
  [SMALL_STATE(4335)] = 167125,
  [SMALL_STATE(4336)] = 167248,
  [SMALL_STATE(4337)] = 167371,
  [SMALL_STATE(4338)] = 167494,
  [SMALL_STATE(4339)] = 167617,
  [SMALL_STATE(4340)] = 167740,
  [SMALL_STATE(4341)] = 167863,
  [SMALL_STATE(4342)] = 167986,
  [SMALL_STATE(4343)] = 168109,
  [SMALL_STATE(4344)] = 168232,
  [SMALL_STATE(4345)] = 168355,
  [SMALL_STATE(4346)] = 168478,
  [SMALL_STATE(4347)] = 168601,
  [SMALL_STATE(4348)] = 168724,
  [SMALL_STATE(4349)] = 168847,
  [SMALL_STATE(4350)] = 168970,
  [SMALL_STATE(4351)] = 169093,
  [SMALL_STATE(4352)] = 169216,
  [SMALL_STATE(4353)] = 169339,
  [SMALL_STATE(4354)] = 169462,
  [SMALL_STATE(4355)] = 169585,
  [SMALL_STATE(4356)] = 169708,
  [SMALL_STATE(4357)] = 169831,
  [SMALL_STATE(4358)] = 169954,
  [SMALL_STATE(4359)] = 170077,
  [SMALL_STATE(4360)] = 170200,
  [SMALL_STATE(4361)] = 170323,
  [SMALL_STATE(4362)] = 170446,
  [SMALL_STATE(4363)] = 170569,
  [SMALL_STATE(4364)] = 170692,
  [SMALL_STATE(4365)] = 170815,
  [SMALL_STATE(4366)] = 170938,
  [SMALL_STATE(4367)] = 171061,
  [SMALL_STATE(4368)] = 171184,
  [SMALL_STATE(4369)] = 171307,
  [SMALL_STATE(4370)] = 171378,
  [SMALL_STATE(4371)] = 171449,
  [SMALL_STATE(4372)] = 171519,
  [SMALL_STATE(4373)] = 171589,
  [SMALL_STATE(4374)] = 171654,
  [SMALL_STATE(4375)] = 171762,
  [SMALL_STATE(4376)] = 171870,
  [SMALL_STATE(4377)] = 171978,
  [SMALL_STATE(4378)] = 172086,
  [SMALL_STATE(4379)] = 172194,
  [SMALL_STATE(4380)] = 172258,
  [SMALL_STATE(4381)] = 172366,
  [SMALL_STATE(4382)] = 172474,
  [SMALL_STATE(4383)] = 172582,
  [SMALL_STATE(4384)] = 172685,
  [SMALL_STATE(4385)] = 172788,
  [SMALL_STATE(4386)] = 172891,
  [SMALL_STATE(4387)] = 172944,
  [SMALL_STATE(4388)] = 173045,
  [SMALL_STATE(4389)] = 173142,
  [SMALL_STATE(4390)] = 173213,
  [SMALL_STATE(4391)] = 173284,
  [SMALL_STATE(4392)] = 173375,
  [SMALL_STATE(4393)] = 173448,
  [SMALL_STATE(4394)] = 173519,
  [SMALL_STATE(4395)] = 173606,
  [SMALL_STATE(4396)] = 173681,
  [SMALL_STATE(4397)] = 173776,
  [SMALL_STATE(4398)] = 173859,
  [SMALL_STATE(4399)] = 173946,
  [SMALL_STATE(4400)] = 174037,
  [SMALL_STATE(4401)] = 174140,
  [SMALL_STATE(4402)] = 174243,
  [SMALL_STATE(4403)] = 174346,
  [SMALL_STATE(4404)] = 174433,
  [SMALL_STATE(4405)] = 174516,
  [SMALL_STATE(4406)] = 174591,
  [SMALL_STATE(4407)] = 174694,
  [SMALL_STATE(4408)] = 174765,
  [SMALL_STATE(4409)] = 174868,
  [SMALL_STATE(4410)] = 174965,
  [SMALL_STATE(4411)] = 175044,
  [SMALL_STATE(4412)] = 175147,
  [SMALL_STATE(4413)] = 175250,
  [SMALL_STATE(4414)] = 175329,
  [SMALL_STATE(4415)] = 175432,
  [SMALL_STATE(4416)] = 175505,
  [SMALL_STATE(4417)] = 175600,
  [SMALL_STATE(4418)] = 175703,
  [SMALL_STATE(4419)] = 175774,
  [SMALL_STATE(4420)] = 175877,
  [SMALL_STATE(4421)] = 175964,
  [SMALL_STATE(4422)] = 176067,
  [SMALL_STATE(4423)] = 176162,
  [SMALL_STATE(4424)] = 176265,
  [SMALL_STATE(4425)] = 176368,
  [SMALL_STATE(4426)] = 176471,
  [SMALL_STATE(4427)] = 176574,
  [SMALL_STATE(4428)] = 176675,
  [SMALL_STATE(4429)] = 176746,
  [SMALL_STATE(4430)] = 176849,
  [SMALL_STATE(4431)] = 176944,
  [SMALL_STATE(4432)] = 177047,
  [SMALL_STATE(4433)] = 177150,
  [SMALL_STATE(4434)] = 177253,
  [SMALL_STATE(4435)] = 177355,
  [SMALL_STATE(4436)] = 177441,
  [SMALL_STATE(4437)] = 177547,
  [SMALL_STATE(4438)] = 177653,
  [SMALL_STATE(4439)] = 177755,
  [SMALL_STATE(4440)] = 177861,
  [SMALL_STATE(4441)] = 177967,
  [SMALL_STATE(4442)] = 178073,
  [SMALL_STATE(4443)] = 178167,
  [SMALL_STATE(4444)] = 178273,
  [SMALL_STATE(4445)] = 178351,
  [SMALL_STATE(4446)] = 178457,
  [SMALL_STATE(4447)] = 178539,
  [SMALL_STATE(4448)] = 178641,
  [SMALL_STATE(4449)] = 178747,
  [SMALL_STATE(4450)] = 178853,
  [SMALL_STATE(4451)] = 178959,
  [SMALL_STATE(4452)] = 179059,
  [SMALL_STATE(4453)] = 179129,
  [SMALL_STATE(4454)] = 179215,
  [SMALL_STATE(4455)] = 179309,
  [SMALL_STATE(4456)] = 179413,
  [SMALL_STATE(4457)] = 179515,
  [SMALL_STATE(4458)] = 179617,
  [SMALL_STATE(4459)] = 179723,
  [SMALL_STATE(4460)] = 179829,
  [SMALL_STATE(4461)] = 179899,
  [SMALL_STATE(4462)] = 180005,
  [SMALL_STATE(4463)] = 180111,
  [SMALL_STATE(4464)] = 180207,
  [SMALL_STATE(4465)] = 180313,
  [SMALL_STATE(4466)] = 180415,
  [SMALL_STATE(4467)] = 180521,
  [SMALL_STATE(4468)] = 180627,
  [SMALL_STATE(4469)] = 180733,
  [SMALL_STATE(4470)] = 180839,
  [SMALL_STATE(4471)] = 180945,
  [SMALL_STATE(4472)] = 181051,
  [SMALL_STATE(4473)] = 181157,
  [SMALL_STATE(4474)] = 181263,
  [SMALL_STATE(4475)] = 181369,
  [SMALL_STATE(4476)] = 181475,
  [SMALL_STATE(4477)] = 181581,
  [SMALL_STATE(4478)] = 181687,
  [SMALL_STATE(4479)] = 181793,
  [SMALL_STATE(4480)] = 181895,
  [SMALL_STATE(4481)] = 182001,
  [SMALL_STATE(4482)] = 182107,
  [SMALL_STATE(4483)] = 182213,
  [SMALL_STATE(4484)] = 182319,
  [SMALL_STATE(4485)] = 182425,
  [SMALL_STATE(4486)] = 182519,
  [SMALL_STATE(4487)] = 182605,
  [SMALL_STATE(4488)] = 182711,
  [SMALL_STATE(4489)] = 182817,
  [SMALL_STATE(4490)] = 182923,
  [SMALL_STATE(4491)] = 183029,
  [SMALL_STATE(4492)] = 183135,
  [SMALL_STATE(4493)] = 183241,
  [SMALL_STATE(4494)] = 183347,
  [SMALL_STATE(4495)] = 183453,
  [SMALL_STATE(4496)] = 183559,
  [SMALL_STATE(4497)] = 183665,
  [SMALL_STATE(4498)] = 183771,
  [SMALL_STATE(4499)] = 183877,
  [SMALL_STATE(4500)] = 183983,
  [SMALL_STATE(4501)] = 184089,
  [SMALL_STATE(4502)] = 184195,
  [SMALL_STATE(4503)] = 184301,
  [SMALL_STATE(4504)] = 184403,
  [SMALL_STATE(4505)] = 184509,
  [SMALL_STATE(4506)] = 184615,
  [SMALL_STATE(4507)] = 184721,
  [SMALL_STATE(4508)] = 184827,
  [SMALL_STATE(4509)] = 184933,
  [SMALL_STATE(4510)] = 185039,
  [SMALL_STATE(4511)] = 185145,
  [SMALL_STATE(4512)] = 185251,
  [SMALL_STATE(4513)] = 185357,
  [SMALL_STATE(4514)] = 185463,
  [SMALL_STATE(4515)] = 185569,
  [SMALL_STATE(4516)] = 185675,
  [SMALL_STATE(4517)] = 185781,
  [SMALL_STATE(4518)] = 185887,
  [SMALL_STATE(4519)] = 185993,
  [SMALL_STATE(4520)] = 186099,
  [SMALL_STATE(4521)] = 186205,
  [SMALL_STATE(4522)] = 186311,
  [SMALL_STATE(4523)] = 186417,
  [SMALL_STATE(4524)] = 186523,
  [SMALL_STATE(4525)] = 186629,
  [SMALL_STATE(4526)] = 186735,
  [SMALL_STATE(4527)] = 186841,
  [SMALL_STATE(4528)] = 186947,
  [SMALL_STATE(4529)] = 187053,
  [SMALL_STATE(4530)] = 187159,
  [SMALL_STATE(4531)] = 187265,
  [SMALL_STATE(4532)] = 187335,
  [SMALL_STATE(4533)] = 187441,
  [SMALL_STATE(4534)] = 187547,
  [SMALL_STATE(4535)] = 187653,
  [SMALL_STATE(4536)] = 187759,
  [SMALL_STATE(4537)] = 187865,
  [SMALL_STATE(4538)] = 187971,
  [SMALL_STATE(4539)] = 188077,
  [SMALL_STATE(4540)] = 188183,
  [SMALL_STATE(4541)] = 188289,
  [SMALL_STATE(4542)] = 188395,
  [SMALL_STATE(4543)] = 188501,
  [SMALL_STATE(4544)] = 188607,
  [SMALL_STATE(4545)] = 188713,
  [SMALL_STATE(4546)] = 188819,
  [SMALL_STATE(4547)] = 188925,
  [SMALL_STATE(4548)] = 189031,
  [SMALL_STATE(4549)] = 189137,
  [SMALL_STATE(4550)] = 189209,
  [SMALL_STATE(4551)] = 189279,
  [SMALL_STATE(4552)] = 189385,
  [SMALL_STATE(4553)] = 189487,
  [SMALL_STATE(4554)] = 189589,
  [SMALL_STATE(4555)] = 189695,
  [SMALL_STATE(4556)] = 189801,
  [SMALL_STATE(4557)] = 189907,
  [SMALL_STATE(4558)] = 190013,
  [SMALL_STATE(4559)] = 190119,
  [SMALL_STATE(4560)] = 190219,
  [SMALL_STATE(4561)] = 190325,
  [SMALL_STATE(4562)] = 190431,
  [SMALL_STATE(4563)] = 190537,
  [SMALL_STATE(4564)] = 190643,
  [SMALL_STATE(4565)] = 190749,
  [SMALL_STATE(4566)] = 190851,
  [SMALL_STATE(4567)] = 190957,
  [SMALL_STATE(4568)] = 191063,
  [SMALL_STATE(4569)] = 191169,
  [SMALL_STATE(4570)] = 191275,
  [SMALL_STATE(4571)] = 191381,
  [SMALL_STATE(4572)] = 191475,
  [SMALL_STATE(4573)] = 191553,
  [SMALL_STATE(4574)] = 191655,
  [SMALL_STATE(4575)] = 191761,
  [SMALL_STATE(4576)] = 191835,
  [SMALL_STATE(4577)] = 191941,
  [SMALL_STATE(4578)] = 192047,
  [SMALL_STATE(4579)] = 192143,
  [SMALL_STATE(4580)] = 192249,
  [SMALL_STATE(4581)] = 192339,
  [SMALL_STATE(4582)] = 192425,
  [SMALL_STATE(4583)] = 192507,
  [SMALL_STATE(4584)] = 192613,
  [SMALL_STATE(4585)] = 192719,
  [SMALL_STATE(4586)] = 192825,
  [SMALL_STATE(4587)] = 192931,
  [SMALL_STATE(4588)] = 193037,
  [SMALL_STATE(4589)] = 193111,
  [SMALL_STATE(4590)] = 193217,
  [SMALL_STATE(4591)] = 193323,
  [SMALL_STATE(4592)] = 193429,
  [SMALL_STATE(4593)] = 193535,
  [SMALL_STATE(4594)] = 193641,
  [SMALL_STATE(4595)] = 193747,
  [SMALL_STATE(4596)] = 193853,
  [SMALL_STATE(4597)] = 193923,
  [SMALL_STATE(4598)] = 193995,
  [SMALL_STATE(4599)] = 194065,
  [SMALL_STATE(4600)] = 194171,
  [SMALL_STATE(4601)] = 194277,
  [SMALL_STATE(4602)] = 194383,
  [SMALL_STATE(4603)] = 194489,
  [SMALL_STATE(4604)] = 194595,
  [SMALL_STATE(4605)] = 194697,
  [SMALL_STATE(4606)] = 194799,
  [SMALL_STATE(4607)] = 194905,
  [SMALL_STATE(4608)] = 195011,
  [SMALL_STATE(4609)] = 195117,
  [SMALL_STATE(4610)] = 195223,
  [SMALL_STATE(4611)] = 195329,
  [SMALL_STATE(4612)] = 195435,
  [SMALL_STATE(4613)] = 195537,
  [SMALL_STATE(4614)] = 195643,
  [SMALL_STATE(4615)] = 195749,
  [SMALL_STATE(4616)] = 195851,
  [SMALL_STATE(4617)] = 195957,
  [SMALL_STATE(4618)] = 196063,
  [SMALL_STATE(4619)] = 196169,
  [SMALL_STATE(4620)] = 196275,
  [SMALL_STATE(4621)] = 196381,
  [SMALL_STATE(4622)] = 196487,
  [SMALL_STATE(4623)] = 196593,
  [SMALL_STATE(4624)] = 196699,
  [SMALL_STATE(4625)] = 196805,
  [SMALL_STATE(4626)] = 196911,
  [SMALL_STATE(4627)] = 197017,
  [SMALL_STATE(4628)] = 197123,
  [SMALL_STATE(4629)] = 197225,
  [SMALL_STATE(4630)] = 197331,
  [SMALL_STATE(4631)] = 197437,
  [SMALL_STATE(4632)] = 197543,
  [SMALL_STATE(4633)] = 197645,
  [SMALL_STATE(4634)] = 197751,
  [SMALL_STATE(4635)] = 197803,
  [SMALL_STATE(4636)] = 197909,
  [SMALL_STATE(4637)] = 198015,
  [SMALL_STATE(4638)] = 198121,
  [SMALL_STATE(4639)] = 198227,
  [SMALL_STATE(4640)] = 198333,
  [SMALL_STATE(4641)] = 198435,
  [SMALL_STATE(4642)] = 198537,
  [SMALL_STATE(4643)] = 198643,
  [SMALL_STATE(4644)] = 198749,
  [SMALL_STATE(4645)] = 198855,
  [SMALL_STATE(4646)] = 198945,
  [SMALL_STATE(4647)] = 199051,
  [SMALL_STATE(4648)] = 199157,
  [SMALL_STATE(4649)] = 199263,
  [SMALL_STATE(4650)] = 199369,
  [SMALL_STATE(4651)] = 199475,
  [SMALL_STATE(4652)] = 199581,
  [SMALL_STATE(4653)] = 199683,
  [SMALL_STATE(4654)] = 199785,
  [SMALL_STATE(4655)] = 199830,
  [SMALL_STATE(4656)] = 199875,
  [SMALL_STATE(4657)] = 199920,
  [SMALL_STATE(4658)] = 199965,
  [SMALL_STATE(4659)] = 200010,
  [SMALL_STATE(4660)] = 200055,
  [SMALL_STATE(4661)] = 200100,
  [SMALL_STATE(4662)] = 200145,
  [SMALL_STATE(4663)] = 200190,
  [SMALL_STATE(4664)] = 200235,
  [SMALL_STATE(4665)] = 200280,
  [SMALL_STATE(4666)] = 200325,
  [SMALL_STATE(4667)] = 200370,
  [SMALL_STATE(4668)] = 200415,
  [SMALL_STATE(4669)] = 200460,
  [SMALL_STATE(4670)] = 200505,
  [SMALL_STATE(4671)] = 200550,
  [SMALL_STATE(4672)] = 200595,
  [SMALL_STATE(4673)] = 200640,
  [SMALL_STATE(4674)] = 200685,
  [SMALL_STATE(4675)] = 200730,
  [SMALL_STATE(4676)] = 200775,
  [SMALL_STATE(4677)] = 200820,
  [SMALL_STATE(4678)] = 200865,
  [SMALL_STATE(4679)] = 200910,
  [SMALL_STATE(4680)] = 200955,
  [SMALL_STATE(4681)] = 201004,
  [SMALL_STATE(4682)] = 201053,
  [SMALL_STATE(4683)] = 201098,
  [SMALL_STATE(4684)] = 201143,
  [SMALL_STATE(4685)] = 201187,
  [SMALL_STATE(4686)] = 201231,
  [SMALL_STATE(4687)] = 201275,
  [SMALL_STATE(4688)] = 201319,
  [SMALL_STATE(4689)] = 201363,
  [SMALL_STATE(4690)] = 201411,
  [SMALL_STATE(4691)] = 201459,
  [SMALL_STATE(4692)] = 201503,
  [SMALL_STATE(4693)] = 201547,
  [SMALL_STATE(4694)] = 201595,
  [SMALL_STATE(4695)] = 201638,
  [SMALL_STATE(4696)] = 201681,
  [SMALL_STATE(4697)] = 201724,
  [SMALL_STATE(4698)] = 201767,
  [SMALL_STATE(4699)] = 201810,
  [SMALL_STATE(4700)] = 201853,
  [SMALL_STATE(4701)] = 201896,
  [SMALL_STATE(4702)] = 201939,
  [SMALL_STATE(4703)] = 201982,
  [SMALL_STATE(4704)] = 202025,
  [SMALL_STATE(4705)] = 202068,
  [SMALL_STATE(4706)] = 202111,
  [SMALL_STATE(4707)] = 202154,
  [SMALL_STATE(4708)] = 202197,
  [SMALL_STATE(4709)] = 202240,
  [SMALL_STATE(4710)] = 202283,
  [SMALL_STATE(4711)] = 202326,
  [SMALL_STATE(4712)] = 202369,
  [SMALL_STATE(4713)] = 202412,
  [SMALL_STATE(4714)] = 202454,
  [SMALL_STATE(4715)] = 202496,
  [SMALL_STATE(4716)] = 202538,
  [SMALL_STATE(4717)] = 202580,
  [SMALL_STATE(4718)] = 202622,
  [SMALL_STATE(4719)] = 202664,
  [SMALL_STATE(4720)] = 202706,
  [SMALL_STATE(4721)] = 202748,
  [SMALL_STATE(4722)] = 202790,
  [SMALL_STATE(4723)] = 202832,
  [SMALL_STATE(4724)] = 202874,
  [SMALL_STATE(4725)] = 202916,
  [SMALL_STATE(4726)] = 202958,
  [SMALL_STATE(4727)] = 203000,
  [SMALL_STATE(4728)] = 203042,
  [SMALL_STATE(4729)] = 203084,
  [SMALL_STATE(4730)] = 203126,
  [SMALL_STATE(4731)] = 203168,
  [SMALL_STATE(4732)] = 203210,
  [SMALL_STATE(4733)] = 203235,
  [SMALL_STATE(4734)] = 203260,
  [SMALL_STATE(4735)] = 203285,
  [SMALL_STATE(4736)] = 203310,
  [SMALL_STATE(4737)] = 203335,
  [SMALL_STATE(4738)] = 203360,
  [SMALL_STATE(4739)] = 203385,
  [SMALL_STATE(4740)] = 203410,
  [SMALL_STATE(4741)] = 203435,
  [SMALL_STATE(4742)] = 203460,
  [SMALL_STATE(4743)] = 203485,
  [SMALL_STATE(4744)] = 203510,
  [SMALL_STATE(4745)] = 203535,
  [SMALL_STATE(4746)] = 203560,
  [SMALL_STATE(4747)] = 203585,
  [SMALL_STATE(4748)] = 203610,
  [SMALL_STATE(4749)] = 203635,
  [SMALL_STATE(4750)] = 203660,
  [SMALL_STATE(4751)] = 203685,
  [SMALL_STATE(4752)] = 203710,
  [SMALL_STATE(4753)] = 203735,
  [SMALL_STATE(4754)] = 203760,
  [SMALL_STATE(4755)] = 203785,
  [SMALL_STATE(4756)] = 203810,
  [SMALL_STATE(4757)] = 203835,
  [SMALL_STATE(4758)] = 203860,
  [SMALL_STATE(4759)] = 203879,
  [SMALL_STATE(4760)] = 203895,
  [SMALL_STATE(4761)] = 203911,
  [SMALL_STATE(4762)] = 203925,
  [SMALL_STATE(4763)] = 203939,
  [SMALL_STATE(4764)] = 203953,
  [SMALL_STATE(4765)] = 203967,
  [SMALL_STATE(4766)] = 203983,
  [SMALL_STATE(4767)] = 203997,
  [SMALL_STATE(4768)] = 204013,
  [SMALL_STATE(4769)] = 204027,
  [SMALL_STATE(4770)] = 204043,
  [SMALL_STATE(4771)] = 204057,
  [SMALL_STATE(4772)] = 204073,
  [SMALL_STATE(4773)] = 204089,
  [SMALL_STATE(4774)] = 204103,
  [SMALL_STATE(4775)] = 204117,
  [SMALL_STATE(4776)] = 204133,
  [SMALL_STATE(4777)] = 204147,
  [SMALL_STATE(4778)] = 204161,
  [SMALL_STATE(4779)] = 204175,
  [SMALL_STATE(4780)] = 204191,
  [SMALL_STATE(4781)] = 204205,
  [SMALL_STATE(4782)] = 204219,
  [SMALL_STATE(4783)] = 204235,
  [SMALL_STATE(4784)] = 204251,
  [SMALL_STATE(4785)] = 204265,
  [SMALL_STATE(4786)] = 204281,
  [SMALL_STATE(4787)] = 204295,
  [SMALL_STATE(4788)] = 204311,
  [SMALL_STATE(4789)] = 204327,
  [SMALL_STATE(4790)] = 204343,
  [SMALL_STATE(4791)] = 204359,
  [SMALL_STATE(4792)] = 204375,
  [SMALL_STATE(4793)] = 204391,
  [SMALL_STATE(4794)] = 204407,
  [SMALL_STATE(4795)] = 204421,
  [SMALL_STATE(4796)] = 204437,
  [SMALL_STATE(4797)] = 204451,
  [SMALL_STATE(4798)] = 204465,
  [SMALL_STATE(4799)] = 204481,
  [SMALL_STATE(4800)] = 204497,
  [SMALL_STATE(4801)] = 204513,
  [SMALL_STATE(4802)] = 204527,
  [SMALL_STATE(4803)] = 204541,
  [SMALL_STATE(4804)] = 204557,
  [SMALL_STATE(4805)] = 204573,
  [SMALL_STATE(4806)] = 204587,
  [SMALL_STATE(4807)] = 204603,
  [SMALL_STATE(4808)] = 204619,
  [SMALL_STATE(4809)] = 204635,
  [SMALL_STATE(4810)] = 204651,
  [SMALL_STATE(4811)] = 204667,
  [SMALL_STATE(4812)] = 204683,
  [SMALL_STATE(4813)] = 204697,
  [SMALL_STATE(4814)] = 204711,
  [SMALL_STATE(4815)] = 204725,
  [SMALL_STATE(4816)] = 204739,
  [SMALL_STATE(4817)] = 204753,
  [SMALL_STATE(4818)] = 204767,
  [SMALL_STATE(4819)] = 204783,
  [SMALL_STATE(4820)] = 204797,
  [SMALL_STATE(4821)] = 204811,
  [SMALL_STATE(4822)] = 204827,
  [SMALL_STATE(4823)] = 204841,
  [SMALL_STATE(4824)] = 204855,
  [SMALL_STATE(4825)] = 204869,
  [SMALL_STATE(4826)] = 204883,
  [SMALL_STATE(4827)] = 204899,
  [SMALL_STATE(4828)] = 204913,
  [SMALL_STATE(4829)] = 204927,
  [SMALL_STATE(4830)] = 204941,
  [SMALL_STATE(4831)] = 204957,
  [SMALL_STATE(4832)] = 204973,
  [SMALL_STATE(4833)] = 204987,
  [SMALL_STATE(4834)] = 205001,
  [SMALL_STATE(4835)] = 205017,
  [SMALL_STATE(4836)] = 205033,
  [SMALL_STATE(4837)] = 205049,
  [SMALL_STATE(4838)] = 205065,
  [SMALL_STATE(4839)] = 205081,
  [SMALL_STATE(4840)] = 205097,
  [SMALL_STATE(4841)] = 205113,
  [SMALL_STATE(4842)] = 205129,
  [SMALL_STATE(4843)] = 205143,
  [SMALL_STATE(4844)] = 205157,
  [SMALL_STATE(4845)] = 205173,
  [SMALL_STATE(4846)] = 205189,
  [SMALL_STATE(4847)] = 205205,
  [SMALL_STATE(4848)] = 205219,
  [SMALL_STATE(4849)] = 205233,
  [SMALL_STATE(4850)] = 205247,
  [SMALL_STATE(4851)] = 205263,
  [SMALL_STATE(4852)] = 205279,
  [SMALL_STATE(4853)] = 205295,
  [SMALL_STATE(4854)] = 205311,
  [SMALL_STATE(4855)] = 205325,
  [SMALL_STATE(4856)] = 205341,
  [SMALL_STATE(4857)] = 205355,
  [SMALL_STATE(4858)] = 205369,
  [SMALL_STATE(4859)] = 205385,
  [SMALL_STATE(4860)] = 205401,
  [SMALL_STATE(4861)] = 205415,
  [SMALL_STATE(4862)] = 205429,
  [SMALL_STATE(4863)] = 205445,
  [SMALL_STATE(4864)] = 205461,
  [SMALL_STATE(4865)] = 205475,
  [SMALL_STATE(4866)] = 205489,
  [SMALL_STATE(4867)] = 205505,
  [SMALL_STATE(4868)] = 205519,
  [SMALL_STATE(4869)] = 205535,
  [SMALL_STATE(4870)] = 205551,
  [SMALL_STATE(4871)] = 205565,
  [SMALL_STATE(4872)] = 205581,
  [SMALL_STATE(4873)] = 205597,
  [SMALL_STATE(4874)] = 205613,
  [SMALL_STATE(4875)] = 205627,
  [SMALL_STATE(4876)] = 205641,
  [SMALL_STATE(4877)] = 205657,
  [SMALL_STATE(4878)] = 205671,
  [SMALL_STATE(4879)] = 205685,
  [SMALL_STATE(4880)] = 205701,
  [SMALL_STATE(4881)] = 205715,
  [SMALL_STATE(4882)] = 205729,
  [SMALL_STATE(4883)] = 205743,
  [SMALL_STATE(4884)] = 205757,
  [SMALL_STATE(4885)] = 205771,
  [SMALL_STATE(4886)] = 205787,
  [SMALL_STATE(4887)] = 205801,
  [SMALL_STATE(4888)] = 205817,
  [SMALL_STATE(4889)] = 205831,
  [SMALL_STATE(4890)] = 205847,
  [SMALL_STATE(4891)] = 205863,
  [SMALL_STATE(4892)] = 205877,
  [SMALL_STATE(4893)] = 205893,
  [SMALL_STATE(4894)] = 205909,
  [SMALL_STATE(4895)] = 205925,
  [SMALL_STATE(4896)] = 205941,
  [SMALL_STATE(4897)] = 205957,
  [SMALL_STATE(4898)] = 205971,
  [SMALL_STATE(4899)] = 205987,
  [SMALL_STATE(4900)] = 206003,
  [SMALL_STATE(4901)] = 206019,
  [SMALL_STATE(4902)] = 206035,
  [SMALL_STATE(4903)] = 206051,
  [SMALL_STATE(4904)] = 206067,
  [SMALL_STATE(4905)] = 206083,
  [SMALL_STATE(4906)] = 206099,
  [SMALL_STATE(4907)] = 206115,
  [SMALL_STATE(4908)] = 206129,
  [SMALL_STATE(4909)] = 206145,
  [SMALL_STATE(4910)] = 206159,
  [SMALL_STATE(4911)] = 206175,
  [SMALL_STATE(4912)] = 206191,
  [SMALL_STATE(4913)] = 206207,
  [SMALL_STATE(4914)] = 206221,
  [SMALL_STATE(4915)] = 206237,
  [SMALL_STATE(4916)] = 206251,
  [SMALL_STATE(4917)] = 206267,
  [SMALL_STATE(4918)] = 206283,
  [SMALL_STATE(4919)] = 206299,
  [SMALL_STATE(4920)] = 206313,
  [SMALL_STATE(4921)] = 206329,
  [SMALL_STATE(4922)] = 206343,
  [SMALL_STATE(4923)] = 206359,
  [SMALL_STATE(4924)] = 206375,
  [SMALL_STATE(4925)] = 206391,
  [SMALL_STATE(4926)] = 206405,
  [SMALL_STATE(4927)] = 206421,
  [SMALL_STATE(4928)] = 206437,
  [SMALL_STATE(4929)] = 206453,
  [SMALL_STATE(4930)] = 206469,
  [SMALL_STATE(4931)] = 206485,
  [SMALL_STATE(4932)] = 206499,
  [SMALL_STATE(4933)] = 206515,
  [SMALL_STATE(4934)] = 206529,
  [SMALL_STATE(4935)] = 206545,
  [SMALL_STATE(4936)] = 206561,
  [SMALL_STATE(4937)] = 206577,
  [SMALL_STATE(4938)] = 206593,
  [SMALL_STATE(4939)] = 206609,
  [SMALL_STATE(4940)] = 206625,
  [SMALL_STATE(4941)] = 206641,
  [SMALL_STATE(4942)] = 206657,
  [SMALL_STATE(4943)] = 206673,
  [SMALL_STATE(4944)] = 206687,
  [SMALL_STATE(4945)] = 206703,
  [SMALL_STATE(4946)] = 206717,
  [SMALL_STATE(4947)] = 206733,
  [SMALL_STATE(4948)] = 206749,
  [SMALL_STATE(4949)] = 206765,
  [SMALL_STATE(4950)] = 206781,
  [SMALL_STATE(4951)] = 206797,
  [SMALL_STATE(4952)] = 206813,
  [SMALL_STATE(4953)] = 206829,
  [SMALL_STATE(4954)] = 206845,
  [SMALL_STATE(4955)] = 206861,
  [SMALL_STATE(4956)] = 206877,
  [SMALL_STATE(4957)] = 206893,
  [SMALL_STATE(4958)] = 206909,
  [SMALL_STATE(4959)] = 206925,
  [SMALL_STATE(4960)] = 206941,
  [SMALL_STATE(4961)] = 206957,
  [SMALL_STATE(4962)] = 206973,
  [SMALL_STATE(4963)] = 206989,
  [SMALL_STATE(4964)] = 207003,
  [SMALL_STATE(4965)] = 207019,
  [SMALL_STATE(4966)] = 207035,
  [SMALL_STATE(4967)] = 207051,
  [SMALL_STATE(4968)] = 207067,
  [SMALL_STATE(4969)] = 207083,
  [SMALL_STATE(4970)] = 207097,
  [SMALL_STATE(4971)] = 207113,
  [SMALL_STATE(4972)] = 207129,
  [SMALL_STATE(4973)] = 207145,
  [SMALL_STATE(4974)] = 207159,
  [SMALL_STATE(4975)] = 207175,
  [SMALL_STATE(4976)] = 207191,
  [SMALL_STATE(4977)] = 207207,
  [SMALL_STATE(4978)] = 207223,
  [SMALL_STATE(4979)] = 207239,
  [SMALL_STATE(4980)] = 207253,
  [SMALL_STATE(4981)] = 207269,
  [SMALL_STATE(4982)] = 207283,
  [SMALL_STATE(4983)] = 207299,
  [SMALL_STATE(4984)] = 207315,
  [SMALL_STATE(4985)] = 207331,
  [SMALL_STATE(4986)] = 207347,
  [SMALL_STATE(4987)] = 207363,
  [SMALL_STATE(4988)] = 207379,
  [SMALL_STATE(4989)] = 207395,
  [SMALL_STATE(4990)] = 207411,
  [SMALL_STATE(4991)] = 207427,
  [SMALL_STATE(4992)] = 207443,
  [SMALL_STATE(4993)] = 207459,
  [SMALL_STATE(4994)] = 207473,
  [SMALL_STATE(4995)] = 207489,
  [SMALL_STATE(4996)] = 207505,
  [SMALL_STATE(4997)] = 207521,
  [SMALL_STATE(4998)] = 207535,
  [SMALL_STATE(4999)] = 207551,
  [SMALL_STATE(5000)] = 207567,
  [SMALL_STATE(5001)] = 207583,
  [SMALL_STATE(5002)] = 207599,
  [SMALL_STATE(5003)] = 207615,
  [SMALL_STATE(5004)] = 207631,
  [SMALL_STATE(5005)] = 207647,
  [SMALL_STATE(5006)] = 207661,
  [SMALL_STATE(5007)] = 207677,
  [SMALL_STATE(5008)] = 207693,
  [SMALL_STATE(5009)] = 207709,
  [SMALL_STATE(5010)] = 207725,
  [SMALL_STATE(5011)] = 207741,
  [SMALL_STATE(5012)] = 207755,
  [SMALL_STATE(5013)] = 207771,
  [SMALL_STATE(5014)] = 207787,
  [SMALL_STATE(5015)] = 207803,
  [SMALL_STATE(5016)] = 207819,
  [SMALL_STATE(5017)] = 207835,
  [SMALL_STATE(5018)] = 207851,
  [SMALL_STATE(5019)] = 207867,
  [SMALL_STATE(5020)] = 207883,
  [SMALL_STATE(5021)] = 207899,
  [SMALL_STATE(5022)] = 207915,
  [SMALL_STATE(5023)] = 207931,
  [SMALL_STATE(5024)] = 207945,
  [SMALL_STATE(5025)] = 207961,
  [SMALL_STATE(5026)] = 207977,
  [SMALL_STATE(5027)] = 207993,
  [SMALL_STATE(5028)] = 208007,
  [SMALL_STATE(5029)] = 208023,
  [SMALL_STATE(5030)] = 208039,
  [SMALL_STATE(5031)] = 208055,
  [SMALL_STATE(5032)] = 208071,
  [SMALL_STATE(5033)] = 208087,
  [SMALL_STATE(5034)] = 208101,
  [SMALL_STATE(5035)] = 208117,
  [SMALL_STATE(5036)] = 208133,
  [SMALL_STATE(5037)] = 208149,
  [SMALL_STATE(5038)] = 208165,
  [SMALL_STATE(5039)] = 208181,
  [SMALL_STATE(5040)] = 208195,
  [SMALL_STATE(5041)] = 208211,
  [SMALL_STATE(5042)] = 208225,
  [SMALL_STATE(5043)] = 208241,
  [SMALL_STATE(5044)] = 208257,
  [SMALL_STATE(5045)] = 208273,
  [SMALL_STATE(5046)] = 208289,
  [SMALL_STATE(5047)] = 208305,
  [SMALL_STATE(5048)] = 208321,
  [SMALL_STATE(5049)] = 208337,
  [SMALL_STATE(5050)] = 208353,
  [SMALL_STATE(5051)] = 208369,
  [SMALL_STATE(5052)] = 208385,
  [SMALL_STATE(5053)] = 208401,
  [SMALL_STATE(5054)] = 208417,
  [SMALL_STATE(5055)] = 208433,
  [SMALL_STATE(5056)] = 208449,
  [SMALL_STATE(5057)] = 208465,
  [SMALL_STATE(5058)] = 208479,
  [SMALL_STATE(5059)] = 208495,
  [SMALL_STATE(5060)] = 208511,
  [SMALL_STATE(5061)] = 208527,
  [SMALL_STATE(5062)] = 208543,
  [SMALL_STATE(5063)] = 208559,
  [SMALL_STATE(5064)] = 208573,
  [SMALL_STATE(5065)] = 208589,
  [SMALL_STATE(5066)] = 208603,
  [SMALL_STATE(5067)] = 208619,
  [SMALL_STATE(5068)] = 208633,
  [SMALL_STATE(5069)] = 208647,
  [SMALL_STATE(5070)] = 208661,
  [SMALL_STATE(5071)] = 208677,
  [SMALL_STATE(5072)] = 208691,
  [SMALL_STATE(5073)] = 208707,
  [SMALL_STATE(5074)] = 208723,
  [SMALL_STATE(5075)] = 208737,
  [SMALL_STATE(5076)] = 208751,
  [SMALL_STATE(5077)] = 208765,
  [SMALL_STATE(5078)] = 208779,
  [SMALL_STATE(5079)] = 208793,
  [SMALL_STATE(5080)] = 208807,
  [SMALL_STATE(5081)] = 208821,
  [SMALL_STATE(5082)] = 208835,
  [SMALL_STATE(5083)] = 208851,
  [SMALL_STATE(5084)] = 208867,
  [SMALL_STATE(5085)] = 208881,
  [SMALL_STATE(5086)] = 208895,
  [SMALL_STATE(5087)] = 208909,
  [SMALL_STATE(5088)] = 208923,
  [SMALL_STATE(5089)] = 208937,
  [SMALL_STATE(5090)] = 208951,
  [SMALL_STATE(5091)] = 208965,
  [SMALL_STATE(5092)] = 208979,
  [SMALL_STATE(5093)] = 208995,
  [SMALL_STATE(5094)] = 209008,
  [SMALL_STATE(5095)] = 209021,
  [SMALL_STATE(5096)] = 209034,
  [SMALL_STATE(5097)] = 209047,
  [SMALL_STATE(5098)] = 209060,
  [SMALL_STATE(5099)] = 209073,
  [SMALL_STATE(5100)] = 209086,
  [SMALL_STATE(5101)] = 209099,
  [SMALL_STATE(5102)] = 209112,
  [SMALL_STATE(5103)] = 209125,
  [SMALL_STATE(5104)] = 209138,
  [SMALL_STATE(5105)] = 209151,
  [SMALL_STATE(5106)] = 209164,
  [SMALL_STATE(5107)] = 209177,
  [SMALL_STATE(5108)] = 209190,
  [SMALL_STATE(5109)] = 209203,
  [SMALL_STATE(5110)] = 209214,
  [SMALL_STATE(5111)] = 209227,
  [SMALL_STATE(5112)] = 209240,
  [SMALL_STATE(5113)] = 209253,
  [SMALL_STATE(5114)] = 209266,
  [SMALL_STATE(5115)] = 209279,
  [SMALL_STATE(5116)] = 209292,
  [SMALL_STATE(5117)] = 209305,
  [SMALL_STATE(5118)] = 209318,
  [SMALL_STATE(5119)] = 209329,
  [SMALL_STATE(5120)] = 209342,
  [SMALL_STATE(5121)] = 209355,
  [SMALL_STATE(5122)] = 209368,
  [SMALL_STATE(5123)] = 209381,
  [SMALL_STATE(5124)] = 209392,
  [SMALL_STATE(5125)] = 209405,
  [SMALL_STATE(5126)] = 209418,
  [SMALL_STATE(5127)] = 209428,
  [SMALL_STATE(5128)] = 209438,
  [SMALL_STATE(5129)] = 209448,
  [SMALL_STATE(5130)] = 209458,
  [SMALL_STATE(5131)] = 209468,
  [SMALL_STATE(5132)] = 209478,
  [SMALL_STATE(5133)] = 209486,
  [SMALL_STATE(5134)] = 209496,
  [SMALL_STATE(5135)] = 209506,
  [SMALL_STATE(5136)] = 209516,
  [SMALL_STATE(5137)] = 209524,
  [SMALL_STATE(5138)] = 209534,
  [SMALL_STATE(5139)] = 209544,
  [SMALL_STATE(5140)] = 209554,
  [SMALL_STATE(5141)] = 209564,
  [SMALL_STATE(5142)] = 209574,
  [SMALL_STATE(5143)] = 209584,
  [SMALL_STATE(5144)] = 209594,
  [SMALL_STATE(5145)] = 209604,
  [SMALL_STATE(5146)] = 209612,
  [SMALL_STATE(5147)] = 209620,
  [SMALL_STATE(5148)] = 209630,
  [SMALL_STATE(5149)] = 209640,
  [SMALL_STATE(5150)] = 209650,
  [SMALL_STATE(5151)] = 209660,
  [SMALL_STATE(5152)] = 209670,
  [SMALL_STATE(5153)] = 209680,
  [SMALL_STATE(5154)] = 209690,
  [SMALL_STATE(5155)] = 209700,
  [SMALL_STATE(5156)] = 209710,
  [SMALL_STATE(5157)] = 209720,
  [SMALL_STATE(5158)] = 209730,
  [SMALL_STATE(5159)] = 209737,
  [SMALL_STATE(5160)] = 209744,
  [SMALL_STATE(5161)] = 209751,
  [SMALL_STATE(5162)] = 209758,
  [SMALL_STATE(5163)] = 209765,
  [SMALL_STATE(5164)] = 209772,
  [SMALL_STATE(5165)] = 209779,
  [SMALL_STATE(5166)] = 209786,
  [SMALL_STATE(5167)] = 209793,
  [SMALL_STATE(5168)] = 209800,
  [SMALL_STATE(5169)] = 209807,
  [SMALL_STATE(5170)] = 209814,
  [SMALL_STATE(5171)] = 209821,
  [SMALL_STATE(5172)] = 209828,
  [SMALL_STATE(5173)] = 209835,
  [SMALL_STATE(5174)] = 209842,
  [SMALL_STATE(5175)] = 209849,
  [SMALL_STATE(5176)] = 209856,
  [SMALL_STATE(5177)] = 209863,
  [SMALL_STATE(5178)] = 209870,
  [SMALL_STATE(5179)] = 209877,
  [SMALL_STATE(5180)] = 209884,
  [SMALL_STATE(5181)] = 209891,
  [SMALL_STATE(5182)] = 209898,
  [SMALL_STATE(5183)] = 209905,
  [SMALL_STATE(5184)] = 209912,
  [SMALL_STATE(5185)] = 209919,
  [SMALL_STATE(5186)] = 209926,
  [SMALL_STATE(5187)] = 209933,
  [SMALL_STATE(5188)] = 209940,
  [SMALL_STATE(5189)] = 209947,
  [SMALL_STATE(5190)] = 209954,
  [SMALL_STATE(5191)] = 209961,
  [SMALL_STATE(5192)] = 209968,
  [SMALL_STATE(5193)] = 209975,
  [SMALL_STATE(5194)] = 209982,
  [SMALL_STATE(5195)] = 209989,
  [SMALL_STATE(5196)] = 209996,
  [SMALL_STATE(5197)] = 210003,
  [SMALL_STATE(5198)] = 210010,
  [SMALL_STATE(5199)] = 210017,
  [SMALL_STATE(5200)] = 210024,
  [SMALL_STATE(5201)] = 210031,
  [SMALL_STATE(5202)] = 210038,
  [SMALL_STATE(5203)] = 210045,
  [SMALL_STATE(5204)] = 210052,
  [SMALL_STATE(5205)] = 210059,
  [SMALL_STATE(5206)] = 210066,
  [SMALL_STATE(5207)] = 210073,
  [SMALL_STATE(5208)] = 210080,
  [SMALL_STATE(5209)] = 210087,
  [SMALL_STATE(5210)] = 210094,
  [SMALL_STATE(5211)] = 210101,
  [SMALL_STATE(5212)] = 210108,
  [SMALL_STATE(5213)] = 210115,
  [SMALL_STATE(5214)] = 210122,
  [SMALL_STATE(5215)] = 210129,
  [SMALL_STATE(5216)] = 210136,
  [SMALL_STATE(5217)] = 210143,
  [SMALL_STATE(5218)] = 210150,
  [SMALL_STATE(5219)] = 210157,
  [SMALL_STATE(5220)] = 210164,
  [SMALL_STATE(5221)] = 210171,
  [SMALL_STATE(5222)] = 210178,
  [SMALL_STATE(5223)] = 210185,
  [SMALL_STATE(5224)] = 210192,
  [SMALL_STATE(5225)] = 210199,
  [SMALL_STATE(5226)] = 210206,
  [SMALL_STATE(5227)] = 210213,
  [SMALL_STATE(5228)] = 210220,
  [SMALL_STATE(5229)] = 210227,
  [SMALL_STATE(5230)] = 210234,
  [SMALL_STATE(5231)] = 210241,
  [SMALL_STATE(5232)] = 210248,
  [SMALL_STATE(5233)] = 210255,
  [SMALL_STATE(5234)] = 210262,
  [SMALL_STATE(5235)] = 210269,
  [SMALL_STATE(5236)] = 210276,
  [SMALL_STATE(5237)] = 210283,
  [SMALL_STATE(5238)] = 210290,
  [SMALL_STATE(5239)] = 210297,
  [SMALL_STATE(5240)] = 210304,
  [SMALL_STATE(5241)] = 210311,
  [SMALL_STATE(5242)] = 210318,
  [SMALL_STATE(5243)] = 210325,
  [SMALL_STATE(5244)] = 210332,
  [SMALL_STATE(5245)] = 210339,
  [SMALL_STATE(5246)] = 210346,
  [SMALL_STATE(5247)] = 210353,
  [SMALL_STATE(5248)] = 210360,
  [SMALL_STATE(5249)] = 210367,
  [SMALL_STATE(5250)] = 210374,
  [SMALL_STATE(5251)] = 210381,
  [SMALL_STATE(5252)] = 210388,
  [SMALL_STATE(5253)] = 210395,
  [SMALL_STATE(5254)] = 210402,
  [SMALL_STATE(5255)] = 210409,
  [SMALL_STATE(5256)] = 210416,
  [SMALL_STATE(5257)] = 210423,
  [SMALL_STATE(5258)] = 210430,
  [SMALL_STATE(5259)] = 210437,
  [SMALL_STATE(5260)] = 210444,
  [SMALL_STATE(5261)] = 210451,
  [SMALL_STATE(5262)] = 210458,
  [SMALL_STATE(5263)] = 210465,
  [SMALL_STATE(5264)] = 210472,
  [SMALL_STATE(5265)] = 210479,
  [SMALL_STATE(5266)] = 210486,
  [SMALL_STATE(5267)] = 210493,
  [SMALL_STATE(5268)] = 210500,
  [SMALL_STATE(5269)] = 210507,
  [SMALL_STATE(5270)] = 210514,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 0, 0, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2562),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5108),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5108),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5066),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4985),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4846),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(460),
  [21] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3599),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3608),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3609),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3611),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2739),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2739),
  [33] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4766),
  [35] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4776),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2018),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2939),
  [41] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2018),
  [43] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2778),
  [45] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2667),
  [47] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [49] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [51] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_braced_expression, 2, 0, 10),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1982),
  [55] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5097),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5097),
  [59] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_braced_expression, 2, 0, 10),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4916),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4903),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4995),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(22),
  [69] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3341),
  [71] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3339),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3337),
  [75] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3336),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3336),
  [79] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1984),
  [81] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1984),
  [83] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5085),
  [85] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5079),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(599),
  [89] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2275),
  [91] = {.entry = {.count = 1, .reusable = true}}, SHIFT(599),
  [93] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2293),
  [95] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1981),
  [97] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [99] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2244),
  [103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2016),
  [105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5117),
  [107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5117),
  [109] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 1, 0, 2),
  [111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4803),
  [113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4787),
  [115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5043),
  [117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(53),
  [119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3877),
  [121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3878),
  [123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3879),
  [125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3880),
  [127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3880),
  [129] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 1, 0, 2),
  [131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2021),
  [133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2021),
  [135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4860),
  [137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4861),
  [139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(506),
  [141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2315),
  [143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(506),
  [145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2304),
  [147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2009),
  [149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2443),
  [153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [155] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_braced_expression, 1, 0, 2),
  [157] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_braced_expression, 1, 0, 2),
  [159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2256),
  [161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1927),
  [163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5114),
  [165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5114),
  [167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4792),
  [169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4779),
  [171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5049),
  [173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(80),
  [175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4012),
  [177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4013),
  [179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4014),
  [181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4015),
  [183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4015),
  [185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1925),
  [187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1925),
  [189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4877),
  [191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4878),
  [193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(502),
  [195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2337),
  [197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(502),
  [199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2341),
  [201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1929),
  [203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2551),
  [207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [209] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 2, 0, 10),
  [211] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 2, 0, 10),
  [213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2358),
  [215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2457),
  [217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2328),
  [219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2516),
  [221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(522),
  [223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2232),
  [227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2322),
  [229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2724),
  [231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2711),
  [233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(507),
  [235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2254),
  [239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2621),
  [241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2347),
  [243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2329),
  [245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2645),
  [247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2357),
  [249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2348),
  [251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(575),
  [253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2283),
  [257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2257),
  [259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2321),
  [261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2245),
  [263] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_repeat_statement, 1, 0, 0),
  [265] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_repeat_statement, 1, 0, 0),
  [267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(509),
  [269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2192),
  [275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5113),
  [277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5113),
  [279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4964),
  [281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4952),
  [283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4965),
  [285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(108),
  [287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3969),
  [289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3882),
  [291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3984),
  [293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3986),
  [295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3986),
  [297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2189),
  [299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2189),
  [301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4891),
  [303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4888),
  [305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(917),
  [307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2418),
  [309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(917),
  [311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2374),
  [313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2193),
  [315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2660),
  [319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2169),
  [323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5107),
  [325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5107),
  [327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5012),
  [329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5010),
  [331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4929),
  [333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(149),
  [335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3706),
  [337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3705),
  [339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3704),
  [341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3703),
  [343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3703),
  [345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2183),
  [347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2183),
  [349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4969),
  [351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4973),
  [353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(790),
  [355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2526),
  [357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(790),
  [359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2410),
  [361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2184),
  [363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2490),
  [369] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 5, 0, 28),
  [371] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 5, 0, 28),
  [373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(553),
  [375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(553),
  [377] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 5, 0, 38),
  [379] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 5, 0, 38),
  [381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(554),
  [383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(554),
  [385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [387] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6, 0, 42),
  [389] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 6, 0, 42),
  [391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(556),
  [393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [397] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 6, 0, 38),
  [399] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 6, 0, 38),
  [401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(557),
  [403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2209),
  [407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5124),
  [409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5124),
  [411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4821),
  [413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4800),
  [415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5037),
  [417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(179),
  [419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3739),
  [421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3740),
  [423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3741),
  [425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3742),
  [427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3742),
  [429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2210),
  [431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2210),
  [433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4842),
  [435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4843),
  [437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(789),
  [439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2545),
  [441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(789),
  [443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2394),
  [445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2208),
  [447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2858),
  [453] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, 0, 42),
  [455] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, 0, 42),
  [457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(560),
  [459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [461] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, 0, 48),
  [463] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, 0, 48),
  [465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(561),
  [467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(561),
  [469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [471] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, 0, 48),
  [473] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, 0, 48),
  [475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(544),
  [477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2787),
  [481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2166),
  [483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5105),
  [485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5105),
  [487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4853),
  [489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4831),
  [491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5025),
  [493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(151),
  [495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3463),
  [497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3464),
  [499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3465),
  [501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3466),
  [503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3466),
  [505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2206),
  [507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2206),
  [509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4796),
  [511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4797),
  [513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(796),
  [515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2432),
  [517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2425),
  [521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2167),
  [523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2931),
  [529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2809),
  [531] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 4, 0, 28),
  [533] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 4, 0, 28),
  [535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(552),
  [537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2590),
  [543] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 2, 0, 3),
  [545] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 2, 0, 3),
  [547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(569),
  [549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [553] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(1927),
  [556] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5114),
  [559] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5114),
  [562] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25),
  [564] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4792),
  [567] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4779),
  [570] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5049),
  [573] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(80),
  [576] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4012),
  [579] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4013),
  [582] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4014),
  [585] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4015),
  [588] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4015),
  [591] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25),
  [593] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(1925),
  [596] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(1925),
  [599] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4877),
  [602] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4878),
  [605] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(507),
  [608] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2337),
  [611] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(507),
  [614] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2254),
  [617] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(1929),
  [620] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(14),
  [623] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(18),
  [626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2219),
  [628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5116),
  [630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5116),
  [632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4955),
  [634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4944),
  [636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4971),
  [638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(128),
  [640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3375),
  [642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3058),
  [644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3192),
  [646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3116),
  [648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3116),
  [650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2220),
  [652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2220),
  [654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4828),
  [656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4827),
  [658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(921),
  [660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2510),
  [662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(921),
  [664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2379),
  [666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2218),
  [668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2785),
  [674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2458),
  [676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2550),
  [678] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2016),
  [681] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5117),
  [684] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5117),
  [687] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4803),
  [690] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4787),
  [693] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5043),
  [696] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(53),
  [699] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3877),
  [702] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3878),
  [705] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3879),
  [708] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3880),
  [711] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3880),
  [714] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2021),
  [717] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2021),
  [720] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4860),
  [723] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4861),
  [726] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(522),
  [729] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2315),
  [732] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(522),
  [735] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2232),
  [738] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2009),
  [741] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(20),
  [744] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(10),
  [747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(935),
  [749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(935),
  [751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2531),
  [753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2504),
  [755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2444),
  [757] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 3, 0, 3),
  [759] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 3, 0, 3),
  [761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(535),
  [763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(535),
  [765] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_repeat_statement, 2, 0, 0),
  [767] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_repeat_statement, 2, 0, 0),
  [769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(515),
  [771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2515),
  [775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(514),
  [777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2489),
  [783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4710),
  [785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4694),
  [787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(564),
  [789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2406),
  [795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(570),
  [797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(570),
  [799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2408),
  [801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2416),
  [803] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25),
  [805] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(1982),
  [808] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5097),
  [811] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5097),
  [814] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25),
  [816] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4916),
  [819] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4903),
  [822] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4995),
  [825] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(22),
  [828] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3341),
  [831] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3339),
  [834] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3337),
  [837] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3336),
  [840] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3336),
  [843] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(1984),
  [846] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(1984),
  [849] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5085),
  [852] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5079),
  [855] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(575),
  [858] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2275),
  [861] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(575),
  [864] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2283),
  [867] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(1981),
  [870] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(19),
  [873] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4),
  [876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(770),
  [878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(770),
  [880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2415),
  [882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2427),
  [884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(589),
  [886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2760),
  [890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2708),
  [892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2896),
  [894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2581),
  [896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(603),
  [898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(603),
  [900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [902] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(1982),
  [905] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5097),
  [908] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5097),
  [911] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4916),
  [914] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4903),
  [917] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4995),
  [920] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(22),
  [923] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3341),
  [926] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3339),
  [929] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3337),
  [932] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3336),
  [935] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3336),
  [938] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(1984),
  [941] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(1984),
  [944] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5085),
  [947] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5079),
  [950] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(599),
  [953] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2275),
  [956] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(599),
  [959] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2293),
  [962] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(1981),
  [965] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(19),
  [968] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4),
  [971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(791),
  [973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2411),
  [977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2493),
  [979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2469),
  [981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2596),
  [983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2771),
  [985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(563),
  [987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(664),
  [991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(664),
  [993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(605),
  [995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(605),
  [997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2908),
  [1001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2692),
  [1003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2659),
  [1005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(620),
  [1007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(620),
  [1009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [1011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(653),
  [1013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(653),
  [1015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [1017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(662),
  [1019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(662),
  [1021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [1023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(615),
  [1025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(615),
  [1027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [1029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(661),
  [1031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(661),
  [1033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(612),
  [1035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(612),
  [1037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [1039] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2016),
  [1042] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5117),
  [1045] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5117),
  [1048] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4803),
  [1051] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4787),
  [1054] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5043),
  [1057] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(53),
  [1060] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3877),
  [1063] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3878),
  [1066] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3879),
  [1069] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3880),
  [1072] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3880),
  [1075] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2021),
  [1078] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2021),
  [1081] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4860),
  [1084] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4861),
  [1087] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(506),
  [1090] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2315),
  [1093] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(506),
  [1096] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2304),
  [1099] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2009),
  [1102] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(20),
  [1105] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(10),
  [1108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2470),
  [1110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(658),
  [1112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(658),
  [1114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(611),
  [1116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(611),
  [1118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(639),
  [1120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [1122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(657),
  [1124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [1126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [1128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(655),
  [1130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(655),
  [1132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [1134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(654),
  [1136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(654),
  [1138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(614),
  [1140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(614),
  [1142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(607),
  [1144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(607),
  [1146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [1148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2488),
  [1150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2685),
  [1152] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(1927),
  [1155] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5114),
  [1158] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5114),
  [1161] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4792),
  [1164] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4779),
  [1167] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5049),
  [1170] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(80),
  [1173] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4012),
  [1176] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4013),
  [1179] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4014),
  [1182] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4015),
  [1185] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4015),
  [1188] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(1925),
  [1191] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(1925),
  [1194] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4877),
  [1197] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4878),
  [1200] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(502),
  [1203] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2337),
  [1206] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(502),
  [1209] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2341),
  [1212] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(1929),
  [1215] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(14),
  [1218] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(18),
  [1221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(608),
  [1223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(608),
  [1225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2891),
  [1227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2498),
  [1229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(621),
  [1231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(621),
  [1233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(863),
  [1235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [1237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(804),
  [1239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(804),
  [1241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2271),
  [1243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5096),
  [1245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5096),
  [1247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4863),
  [1249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4844),
  [1251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5019),
  [1253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(264),
  [1255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3325),
  [1257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3326),
  [1259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3327),
  [1261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3328),
  [1263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3328),
  [1265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2272),
  [1267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2272),
  [1269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4773),
  [1271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4774),
  [1273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1139),
  [1275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2740),
  [1277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1139),
  [1279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2575),
  [1281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2270),
  [1283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [1285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2851),
  [1287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [1289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2284),
  [1291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5119),
  [1293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5119),
  [1295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4992),
  [1297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4991),
  [1299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4941),
  [1301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(284),
  [1303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3308),
  [1305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3306),
  [1307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3305),
  [1309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3302),
  [1311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3302),
  [1313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2266),
  [1315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2266),
  [1317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5077),
  [1319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5075),
  [1321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(970),
  [1323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2690),
  [1325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(970),
  [1327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2607),
  [1329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2269),
  [1331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [1333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [1335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2588),
  [1337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2231),
  [1339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5102),
  [1341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5102),
  [1343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4946),
  [1345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4937),
  [1347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4977),
  [1349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(276),
  [1351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3971),
  [1353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3997),
  [1355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4005),
  [1357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4006),
  [1359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4006),
  [1361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2356),
  [1363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2356),
  [1365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4781),
  [1367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4780),
  [1369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1219),
  [1371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2614),
  [1373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1219),
  [1375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2640),
  [1377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2359),
  [1379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [1381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2803),
  [1383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [1385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2312),
  [1387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5122),
  [1389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5122),
  [1391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4938),
  [1393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4926),
  [1395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4983),
  [1397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(232),
  [1399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3850),
  [1401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3849),
  [1403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3848),
  [1405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3847),
  [1407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3847),
  [1409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2311),
  [1411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2311),
  [1413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4849),
  [1415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4856),
  [1417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1072),
  [1419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2641),
  [1421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1072),
  [1423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2603),
  [1425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2313),
  [1427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [1429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [1431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2802),
  [1433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2234),
  [1435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5106),
  [1437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5106),
  [1439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4974),
  [1441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4970),
  [1443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4953),
  [1445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(201),
  [1447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3102),
  [1449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3243),
  [1451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3105),
  [1453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3112),
  [1455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3112),
  [1457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2235),
  [1459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2235),
  [1461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4997),
  [1463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4993),
  [1465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1152),
  [1467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2569),
  [1469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1152),
  [1471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2580),
  [1473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2233),
  [1475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [1477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [1479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2707),
  [1481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2948),
  [1483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(774),
  [1485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(774),
  [1487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [1489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(753),
  [1491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(753),
  [1493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [1495] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2192),
  [1498] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5113),
  [1501] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5113),
  [1504] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4964),
  [1507] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4952),
  [1510] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4965),
  [1513] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(108),
  [1516] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3969),
  [1519] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3882),
  [1522] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3984),
  [1525] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3986),
  [1528] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3986),
  [1531] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2189),
  [1534] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2189),
  [1537] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4891),
  [1540] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4888),
  [1543] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(770),
  [1546] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2418),
  [1549] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(770),
  [1552] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2415),
  [1555] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2193),
  [1558] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(57),
  [1561] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(59),
  [1564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(749),
  [1566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [1568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2287),
  [1570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5112),
  [1572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5112),
  [1574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4834),
  [1576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4818),
  [1578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5031),
  [1580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(238),
  [1582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3601),
  [1584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3602),
  [1586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3603),
  [1588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3604),
  [1590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3604),
  [1592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2288),
  [1594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2288),
  [1596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4819),
  [1598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4820),
  [1600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1133),
  [1602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2662),
  [1604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1133),
  [1606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2657),
  [1608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2286),
  [1610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [1612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2810),
  [1614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [1616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(713),
  [1618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(713),
  [1620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(695),
  [1622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(695),
  [1624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [1626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(690),
  [1628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(690),
  [1630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(689),
  [1632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(689),
  [1634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [1636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(686),
  [1638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(686),
  [1640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [1642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(685),
  [1644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(685),
  [1646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2646),
  [1648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2727),
  [1650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2999),
  [1652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(682),
  [1654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [1656] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2192),
  [1659] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5113),
  [1662] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5113),
  [1665] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4964),
  [1668] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4952),
  [1671] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4965),
  [1674] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(108),
  [1677] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3969),
  [1680] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3882),
  [1683] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3984),
  [1686] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3986),
  [1689] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3986),
  [1692] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2189),
  [1695] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2189),
  [1698] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4891),
  [1701] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4888),
  [1704] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(917),
  [1707] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2418),
  [1710] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(917),
  [1713] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2374),
  [1716] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2193),
  [1719] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(57),
  [1722] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(59),
  [1725] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2219),
  [1728] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5116),
  [1731] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5116),
  [1734] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4955),
  [1737] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4944),
  [1740] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4971),
  [1743] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(128),
  [1746] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3375),
  [1749] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3058),
  [1752] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3192),
  [1755] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3116),
  [1758] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3116),
  [1761] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2220),
  [1764] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2220),
  [1767] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4828),
  [1770] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4827),
  [1773] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(921),
  [1776] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2510),
  [1779] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(921),
  [1782] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2379),
  [1785] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2218),
  [1788] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(54),
  [1791] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(56),
  [1794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(681),
  [1796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(681),
  [1798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [1800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2843),
  [1802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(679),
  [1804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [1806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(678),
  [1808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(678),
  [1810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [1812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(688),
  [1814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(688),
  [1816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [1818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(691),
  [1820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(691),
  [1822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(729),
  [1824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(729),
  [1826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(757),
  [1828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(757),
  [1830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [1832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2865),
  [1834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(758),
  [1836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(758),
  [1838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(759),
  [1840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(759),
  [1842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [1844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2964),
  [1846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(761),
  [1848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(761),
  [1850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [1852] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2219),
  [1855] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5116),
  [1858] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5116),
  [1861] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4955),
  [1864] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4944),
  [1867] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4971),
  [1870] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(128),
  [1873] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3375),
  [1876] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3058),
  [1879] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3192),
  [1882] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3116),
  [1885] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3116),
  [1888] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2220),
  [1891] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2220),
  [1894] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4828),
  [1897] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4827),
  [1900] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(935),
  [1903] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2510),
  [1906] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(935),
  [1909] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2531),
  [1912] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2218),
  [1915] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(54),
  [1918] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(56),
  [1921] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2169),
  [1924] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5107),
  [1927] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5107),
  [1930] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5012),
  [1933] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5010),
  [1936] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4929),
  [1939] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(149),
  [1942] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3706),
  [1945] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3705),
  [1948] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3704),
  [1951] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3703),
  [1954] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3703),
  [1957] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2183),
  [1960] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2183),
  [1963] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4969),
  [1966] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4973),
  [1969] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(791),
  [1972] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2526),
  [1975] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(791),
  [1978] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2411),
  [1981] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2184),
  [1984] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(67),
  [1987] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(24),
  [1990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(762),
  [1992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(762),
  [1994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(765),
  [1996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(765),
  [1998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4720),
  [2000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(766),
  [2002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(766),
  [2004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [2006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(768),
  [2008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(768),
  [2010] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2169),
  [2013] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5107),
  [2016] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5107),
  [2019] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5012),
  [2022] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5010),
  [2025] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4929),
  [2028] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(149),
  [2031] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3706),
  [2034] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3705),
  [2037] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3704),
  [2040] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3703),
  [2043] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3703),
  [2046] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2183),
  [2049] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2183),
  [2052] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4969),
  [2055] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4973),
  [2058] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(790),
  [2061] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2526),
  [2064] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(790),
  [2067] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2410),
  [2070] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2184),
  [2073] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(67),
  [2076] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(24),
  [2079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2876),
  [2081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2895),
  [2083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2693),
  [2085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(912),
  [2087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(912),
  [2089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [2091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2886),
  [2093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(797),
  [2095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(797),
  [2097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [2099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(802),
  [2101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(802),
  [2103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [2105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4731),
  [2107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2946),
  [2109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(907),
  [2111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(907),
  [2113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [2115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(906),
  [2117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(906),
  [2119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(840),
  [2121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(840),
  [2123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(876),
  [2125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [2127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [2129] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2209),
  [2132] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5124),
  [2135] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5124),
  [2138] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4821),
  [2141] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4800),
  [2144] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5037),
  [2147] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(179),
  [2150] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3739),
  [2153] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3740),
  [2156] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3741),
  [2159] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3742),
  [2162] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3742),
  [2165] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2210),
  [2168] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2210),
  [2171] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4842),
  [2174] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4843),
  [2177] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(789),
  [2180] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2545),
  [2183] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(789),
  [2186] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2394),
  [2189] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2208),
  [2192] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5),
  [2195] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(42),
  [2198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(877),
  [2200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(877),
  [2202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(878),
  [2204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(878),
  [2206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [2208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(883),
  [2210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(883),
  [2212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [2214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(839),
  [2216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(839),
  [2218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [2220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(886),
  [2222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(886),
  [2224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(834),
  [2226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(834),
  [2228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(833),
  [2230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(833),
  [2232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [2234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(892),
  [2236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(892),
  [2238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(894),
  [2240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(894),
  [2242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [2244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(898),
  [2246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(898),
  [2248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2712),
  [2250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(827),
  [2252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(827),
  [2254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [2256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(824),
  [2258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(824),
  [2260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2904),
  [2262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(672),
  [2264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(672),
  [2266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(815),
  [2268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(815),
  [2270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [2272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2622),
  [2274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(812),
  [2276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [2278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2885),
  [2280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(913),
  [2282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [2284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [2286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2655),
  [2288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(919),
  [2290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(919),
  [2292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [2294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(922),
  [2296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(922),
  [2298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(941),
  [2300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(941),
  [2302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2591),
  [2304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2974),
  [2306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(962),
  [2308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(962),
  [2310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [2312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(961),
  [2314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(961),
  [2316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2672),
  [2318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(960),
  [2320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(960),
  [2322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [2324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2684),
  [2326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2861),
  [2328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3018),
  [2330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(958),
  [2332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(958),
  [2334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(196),
  [2336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(957),
  [2338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(957),
  [2340] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2166),
  [2343] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5105),
  [2346] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5105),
  [2349] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4853),
  [2352] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4831),
  [2355] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5025),
  [2358] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(151),
  [2361] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3463),
  [2364] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3464),
  [2367] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3465),
  [2370] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3466),
  [2373] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3466),
  [2376] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2206),
  [2379] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2206),
  [2382] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4796),
  [2385] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4797),
  [2388] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(796),
  [2391] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2432),
  [2394] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(796),
  [2397] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2425),
  [2400] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2167),
  [2403] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3),
  [2406] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(45),
  [2409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(954),
  [2411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(954),
  [2413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(953),
  [2415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(953),
  [2417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [2419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(951),
  [2421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(951),
  [2423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2579),
  [2425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2372),
  [2427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5100),
  [2429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5100),
  [2431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4904),
  [2433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4892),
  [2435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5001),
  [2437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(306),
  [2439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3163),
  [2441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3162),
  [2443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3161),
  [2445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3160),
  [2447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3160),
  [2449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2371),
  [2451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2371),
  [2453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4907),
  [2455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4886),
  [2457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1521),
  [2459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2917),
  [2461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1521),
  [2463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2838),
  [2465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2373),
  [2467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [2469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2890),
  [2471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [2473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1138),
  [2475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1138),
  [2477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [2479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1097),
  [2481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1097),
  [2483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2397),
  [2485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5098),
  [2487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5098),
  [2489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4982),
  [2491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4980),
  [2493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4947),
  [2495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(348),
  [2497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3133),
  [2499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3130),
  [2501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3128),
  [2503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3126),
  [2505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3126),
  [2507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2412),
  [2509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2412),
  [2511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5041),
  [2513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5039),
  [2515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1599),
  [2517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2821),
  [2519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1599),
  [2521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2859),
  [2523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2392),
  [2525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [2527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2767),
  [2529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [2531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2530),
  [2533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5094),
  [2535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5094),
  [2537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5000),
  [2539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4999),
  [2541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4935),
  [2543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(411),
  [2545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3517),
  [2547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3516),
  [2549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3515),
  [2551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3514),
  [2553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3514),
  [2555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2445),
  [2557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2445),
  [2559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5078),
  [2561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5080),
  [2563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1618),
  [2565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2789),
  [2567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1618),
  [2569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2898),
  [2571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2449),
  [2573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [2575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2756),
  [2577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [2579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1090),
  [2581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1090),
  [2583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1089),
  [2585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1089),
  [2587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [2589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1087),
  [2591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1087),
  [2593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [2595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1084),
  [2597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1084),
  [2599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1082),
  [2601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1082),
  [2603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [2605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2916),
  [2607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1071),
  [2609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1071),
  [2611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1058),
  [2613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1058),
  [2615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2769),
  [2617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3022),
  [2619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1040),
  [2621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1040),
  [2623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1076),
  [2625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1076),
  [2627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1039),
  [2629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1039),
  [2631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [2633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2975),
  [2635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1276),
  [2637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1276),
  [2639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1070),
  [2641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1070),
  [2643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [2645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1140),
  [2647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1140),
  [2649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1079),
  [2651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1079),
  [2653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [2655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1142),
  [2657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1142),
  [2659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [2661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1143),
  [2663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1143),
  [2665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1148),
  [2667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1148),
  [2669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1149),
  [2671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1149),
  [2673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [2675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1157),
  [2677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1157),
  [2679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [2681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1158),
  [2683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1158),
  [2685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1161),
  [2687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1161),
  [2689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [2691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1189),
  [2693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1189),
  [2695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1085),
  [2697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1085),
  [2699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [2701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1034),
  [2703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1034),
  [2705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [2707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1033),
  [2709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1033),
  [2711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1094),
  [2713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1094),
  [2715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1216),
  [2717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1216),
  [2719] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2271),
  [2722] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5096),
  [2725] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5096),
  [2728] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4863),
  [2731] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4844),
  [2734] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5019),
  [2737] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(264),
  [2740] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3325),
  [2743] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3326),
  [2746] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3327),
  [2749] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3328),
  [2752] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3328),
  [2755] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2272),
  [2758] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2272),
  [2761] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4773),
  [2764] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4774),
  [2767] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(1139),
  [2770] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2740),
  [2773] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(1139),
  [2776] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2575),
  [2779] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2270),
  [2782] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(120),
  [2785] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(11),
  [2788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1218),
  [2790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1218),
  [2792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [2794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1229),
  [2796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1229),
  [2798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [2800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1031),
  [2802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1031),
  [2804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [2806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1029),
  [2808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1029),
  [2810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1026),
  [2812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1026),
  [2814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1025),
  [2816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1025),
  [2818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [2820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1023),
  [2822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1023),
  [2824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [2826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2522),
  [2828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5125),
  [2830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5125),
  [2832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5055),
  [2834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5054),
  [2836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4899),
  [2838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(392),
  [2840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3643),
  [2842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3655),
  [2844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3681),
  [2846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3688),
  [2848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3688),
  [2850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2523),
  [2852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2523),
  [2854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4764),
  [2856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4761),
  [2858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1445),
  [2860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2888),
  [2862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1445),
  [2864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2883),
  [2866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2492),
  [2868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [2870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [2872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2805),
  [2874] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2231),
  [2877] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5102),
  [2880] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5102),
  [2883] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4946),
  [2886] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4937),
  [2889] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4977),
  [2892] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(276),
  [2895] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3971),
  [2898] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3997),
  [2901] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4005),
  [2904] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4006),
  [2907] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4006),
  [2910] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2356),
  [2913] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2356),
  [2916] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4781),
  [2919] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4780),
  [2922] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(1219),
  [2925] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2614),
  [2928] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(1219),
  [2931] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2640),
  [2934] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2359),
  [2937] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(190),
  [2940] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(94),
  [2943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2541),
  [2945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5101),
  [2947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5101),
  [2949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5064),
  [2951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5062),
  [2953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4889),
  [2955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(373),
  [2957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3734),
  [2959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3727),
  [2961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3726),
  [2963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3721),
  [2965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3721),
  [2967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2540),
  [2969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2540),
  [2971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5090),
  [2973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5091),
  [2975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1354),
  [2977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2907),
  [2979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1354),
  [2981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2842),
  [2983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2543),
  [2985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [2987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2790),
  [2989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [2991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1068),
  [2993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1068),
  [2995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1086),
  [2997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1086),
  [2999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1095),
  [3001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1095),
  [3003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [3005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(980),
  [3007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(980),
  [3009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [3011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1021),
  [3013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1021),
  [3015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [3017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(969),
  [3019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(969),
  [3021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1314),
  [3023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1314),
  [3025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [3027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1318),
  [3029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1318),
  [3031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1310),
  [3033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1310),
  [3035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1309),
  [3037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1309),
  [3039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [3041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1307),
  [3043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1307),
  [3045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [3047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1306),
  [3049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1306),
  [3051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1305),
  [3053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1305),
  [3055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [3057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1006),
  [3059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1006),
  [3061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1092),
  [3063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1092),
  [3065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [3067] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2234),
  [3070] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5106),
  [3073] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5106),
  [3076] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4974),
  [3079] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4970),
  [3082] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4953),
  [3085] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(201),
  [3088] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3102),
  [3091] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3243),
  [3094] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3105),
  [3097] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3112),
  [3100] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3112),
  [3103] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2235),
  [3106] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2235),
  [3109] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4997),
  [3112] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4993),
  [3115] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(1152),
  [3118] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2569),
  [3121] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(1152),
  [3124] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2580),
  [3127] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2233),
  [3130] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(76),
  [3133] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(188),
  [3136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1252),
  [3138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1252),
  [3140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [3142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1247),
  [3144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1247),
  [3146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [3148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(981),
  [3150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(981),
  [3152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1146),
  [3154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1146),
  [3156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1154),
  [3158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1154),
  [3160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [3162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1156),
  [3164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1156),
  [3166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1163),
  [3168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1163),
  [3170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2877),
  [3172] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2287),
  [3175] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5112),
  [3178] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5112),
  [3181] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4834),
  [3184] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4818),
  [3187] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5031),
  [3190] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(238),
  [3193] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3601),
  [3196] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3602),
  [3199] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3603),
  [3202] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3604),
  [3205] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3604),
  [3208] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2288),
  [3211] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2288),
  [3214] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4819),
  [3217] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4820),
  [3220] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(1133),
  [3223] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2662),
  [3226] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(1133),
  [3229] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2657),
  [3232] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2286),
  [3235] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(119),
  [3238] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(16),
  [3241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1164),
  [3243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1164),
  [3245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [3247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1167),
  [3249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1167),
  [3251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [3253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1022),
  [3255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1022),
  [3257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1168),
  [3259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1168),
  [3261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(975),
  [3263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(975),
  [3265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [3267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1113),
  [3269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1113),
  [3271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1170),
  [3273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1170),
  [3275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [3277] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2312),
  [3280] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5122),
  [3283] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5122),
  [3286] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4938),
  [3289] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4926),
  [3292] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4983),
  [3295] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(232),
  [3298] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3850),
  [3301] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3849),
  [3304] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3848),
  [3307] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3847),
  [3310] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3847),
  [3313] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2311),
  [3316] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2311),
  [3319] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4849),
  [3322] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4856),
  [3325] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(1072),
  [3328] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2641),
  [3331] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(1072),
  [3334] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2603),
  [3337] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2313),
  [3340] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(64),
  [3343] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(199),
  [3346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2965),
  [3348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1253),
  [3350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1253),
  [3352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2928),
  [3354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2781),
  [3356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1246),
  [3358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1246),
  [3360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [3362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3008),
  [3364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4696),
  [3366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4700),
  [3368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1131),
  [3370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1131),
  [3372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1132),
  [3374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1132),
  [3376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [3378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1241),
  [3380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1241),
  [3382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [3384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1240),
  [3386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1240),
  [3388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2982),
  [3390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3017),
  [3392] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2284),
  [3395] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5119),
  [3398] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5119),
  [3401] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4992),
  [3404] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4991),
  [3407] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4941),
  [3410] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(284),
  [3413] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3308),
  [3416] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3306),
  [3419] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3305),
  [3422] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3302),
  [3425] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3302),
  [3428] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2266),
  [3431] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2266),
  [3434] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5077),
  [3437] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5075),
  [3440] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(970),
  [3443] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2690),
  [3446] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(970),
  [3449] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2607),
  [3452] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2269),
  [3455] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(23),
  [3458] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(180),
  [3461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3001),
  [3463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3009),
  [3465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1196),
  [3467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1196),
  [3469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1880),
  [3471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1880),
  [3473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1455),
  [3475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1455),
  [3477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1689),
  [3479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1689),
  [3481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1693),
  [3483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1693),
  [3485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [3487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1721),
  [3489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1721),
  [3491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2441),
  [3493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5120),
  [3495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5120),
  [3497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4893),
  [3499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4876),
  [3501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5007),
  [3503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(354),
  [3505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3051),
  [3507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3052),
  [3509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3053),
  [3511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3054),
  [3513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3054),
  [3515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2448),
  [3517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2448),
  [3519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4833),
  [3521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4832),
  [3523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1558),
  [3525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2761),
  [3527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1558),
  [3529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [3531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2514),
  [3533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [3535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [3537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1782),
  [3539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1782),
  [3541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1783),
  [3543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1783),
  [3545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [3547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1795),
  [3549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1795),
  [3551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [3553] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2530),
  [3556] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5094),
  [3559] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5094),
  [3562] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5000),
  [3565] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4999),
  [3568] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4935),
  [3571] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(411),
  [3574] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3517),
  [3577] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3516),
  [3580] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3515),
  [3583] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3514),
  [3586] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3514),
  [3589] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2445),
  [3592] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2445),
  [3595] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5078),
  [3598] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5080),
  [3601] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(1618),
  [3604] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2789),
  [3607] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(1618),
  [3610] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2898),
  [3613] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2449),
  [3616] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(213),
  [3619] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(70),
  [3622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1465),
  [3624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1465),
  [3626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1560),
  [3628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1560),
  [3630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1469),
  [3632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1469),
  [3634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1470),
  [3636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1470),
  [3638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [3640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1464),
  [3642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1464),
  [3644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1473),
  [3646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1473),
  [3648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1565),
  [3650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1565),
  [3652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1570),
  [3654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1570),
  [3656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [3658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1573),
  [3660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1573),
  [3662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [3664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1574),
  [3666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1574),
  [3668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1576),
  [3670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1576),
  [3672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [3674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1619),
  [3676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1619),
  [3678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2378),
  [3680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5103),
  [3682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5103),
  [3684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4879),
  [3686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4862),
  [3688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5013),
  [3690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(320),
  [3692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3188),
  [3694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3189),
  [3696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3190),
  [3698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3191),
  [3700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3191),
  [3702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2381),
  [3704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2381),
  [3706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4786),
  [3708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4784),
  [3710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1548),
  [3712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2892),
  [3714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1548),
  [3716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [3718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2377),
  [3720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [3722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [3724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1651),
  [3726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1651),
  [3728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1654),
  [3730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1654),
  [3732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [3734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1552),
  [3736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1552),
  [3738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1664),
  [3740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1664),
  [3742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1475),
  [3744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1475),
  [3746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [3748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1485),
  [3750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1485),
  [3752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1668),
  [3754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1668),
  [3756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [3758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1669),
  [3760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1669),
  [3762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1674),
  [3764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1674),
  [3766] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2372),
  [3769] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5100),
  [3772] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5100),
  [3775] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4904),
  [3778] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4892),
  [3781] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5001),
  [3784] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(306),
  [3787] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3163),
  [3790] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3162),
  [3793] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3161),
  [3796] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3160),
  [3799] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3160),
  [3802] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2371),
  [3805] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2371),
  [3808] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4907),
  [3811] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4886),
  [3814] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(1521),
  [3817] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2917),
  [3820] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(1521),
  [3823] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2838),
  [3826] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2373),
  [3829] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(200),
  [3832] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(97),
  [3835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1677),
  [3837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1677),
  [3839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [3841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1376),
  [3843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1376),
  [3845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2673),
  [3847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5093),
  [3849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5093),
  [3851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5040),
  [3853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5036),
  [3855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4911),
  [3857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(465),
  [3859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3345),
  [3861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3365),
  [3863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3366),
  [3865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3367),
  [3867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3367),
  [3869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2578),
  [3871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2578),
  [3873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4925),
  [3875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4919),
  [3877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1969),
  [3879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2957),
  [3881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1969),
  [3883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3021),
  [3885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2567),
  [3887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [3889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2954),
  [3891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [3893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1531),
  [3895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1531),
  [3897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [3899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1530),
  [3901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1530),
  [3903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1807),
  [3905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1807),
  [3907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1527),
  [3909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1527),
  [3911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [3913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1502),
  [3915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1502),
  [3917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1833),
  [3919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1833),
  [3921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [3923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1479),
  [3925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1479),
  [3927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [3929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1319),
  [3931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1319),
  [3933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [3935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1477),
  [3937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1477),
  [3939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1600),
  [3941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1600),
  [3943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1476),
  [3945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1476),
  [3947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [3949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1468),
  [3951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1468),
  [3953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [3955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1460),
  [3957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1460),
  [3959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1454),
  [3961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1454),
  [3963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1639),
  [3965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1639),
  [3967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [3969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1451),
  [3971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1451),
  [3973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [3975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2944),
  [3977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1679),
  [3979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1679),
  [3981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [3983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1683),
  [3985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1683),
  [3987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1446),
  [3989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1446),
  [3991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1662),
  [3993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1662),
  [3995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [3997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1728),
  [3999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1728),
  [4001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1377),
  [4003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1377),
  [4005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [4007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1550),
  [4009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1550),
  [4011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1750),
  [4013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1750),
  [4015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [4017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1757),
  [4019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1757),
  [4021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1758),
  [4023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1758),
  [4025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [4027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1764),
  [4029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1764),
  [4031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [4033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1501),
  [4035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1501),
  [4037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [4039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1767),
  [4041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1767),
  [4043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1850),
  [4045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1850),
  [4047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1852),
  [4049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1852),
  [4051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [4053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2534),
  [4055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5111),
  [4057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5111),
  [4059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4772),
  [4061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4962),
  [4063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4959),
  [4065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(366),
  [4067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3711),
  [4069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3712),
  [4071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3713),
  [4073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3702),
  [4075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3702),
  [4077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2536),
  [4079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2536),
  [4081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4945),
  [4083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4943),
  [4085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1902),
  [4087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2902),
  [4089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1902),
  [4091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [4093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2532),
  [4095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [4097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [4099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1771),
  [4101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1771),
  [4103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1772),
  [4105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1772),
  [4107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [4109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1775),
  [4111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1775),
  [4113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1867),
  [4115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1867),
  [4117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [4119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1612),
  [4121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1612),
  [4123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [4125] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2522),
  [4128] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5125),
  [4131] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5125),
  [4134] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5055),
  [4137] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5054),
  [4140] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4899),
  [4143] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(392),
  [4146] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3643),
  [4149] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3655),
  [4152] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3681),
  [4155] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3688),
  [4158] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3688),
  [4161] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2523),
  [4164] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2523),
  [4167] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4764),
  [4170] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4761),
  [4173] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(1445),
  [4176] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2888),
  [4179] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(1445),
  [4182] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2883),
  [4185] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2492),
  [4188] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(178),
  [4191] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(244),
  [4194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1561),
  [4196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1561),
  [4198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [4200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1869),
  [4202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1869),
  [4204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1882),
  [4206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1882),
  [4208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [4210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1864),
  [4212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1864),
  [4214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4681),
  [4216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5095),
  [4218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5095),
  [4220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4928),
  [4222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4914),
  [4224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4989),
  [4226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(393),
  [4228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3653),
  [4230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3652),
  [4232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3651),
  [4234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3650),
  [4236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3650),
  [4238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4680),
  [4240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4680),
  [4242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5088),
  [4244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5084),
  [4246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4411),
  [4248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4703),
  [4250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4411),
  [4252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2576),
  [4254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4683),
  [4256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [4258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [4260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4421),
  [4262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4421),
  [4264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [4266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4425),
  [4268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4425),
  [4270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1836),
  [4272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1836),
  [4274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1874),
  [4276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1874),
  [4278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [4280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4431),
  [4282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4431),
  [4284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4400),
  [4286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4400),
  [4288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [4290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4433),
  [4292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4433),
  [4294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [4296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4432),
  [4298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4432),
  [4300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4412),
  [4302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4412),
  [4304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [4306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4419),
  [4308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4419),
  [4310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1886),
  [4312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1886),
  [4314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1790),
  [4316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1790),
  [4318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [4320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4383),
  [4322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4383),
  [4324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4406),
  [4326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4406),
  [4328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [4330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1907),
  [4332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1907),
  [4334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [4336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4424),
  [4338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4424),
  [4340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [4342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1754),
  [4344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1754),
  [4346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1749),
  [4348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1749),
  [4350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [4352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1462),
  [4354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1462),
  [4356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [4358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1672),
  [4360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1672),
  [4362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [4364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1456),
  [4366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1456),
  [4368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [4370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1688),
  [4372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1688),
  [4374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [4376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1448),
  [4378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1448),
  [4380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [4382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1666),
  [4384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1666),
  [4386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4724),
  [4388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1652),
  [4390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1652),
  [4392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1337),
  [4394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1337),
  [4396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [4398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1637),
  [4400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1637),
  [4402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [4404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1355),
  [4406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1355),
  [4408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1426),
  [4410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1426),
  [4412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1623),
  [4414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1623),
  [4416] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2397),
  [4419] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5098),
  [4422] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5098),
  [4425] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4982),
  [4428] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4980),
  [4431] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4947),
  [4434] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(348),
  [4437] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3133),
  [4440] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3130),
  [4443] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3128),
  [4446] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3126),
  [4449] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3126),
  [4452] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2412),
  [4455] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2412),
  [4458] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5041),
  [4461] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5039),
  [4464] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(1599),
  [4467] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2821),
  [4470] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(1599),
  [4473] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2859),
  [4476] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2392),
  [4479] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(210),
  [4482] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(74),
  [4485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1381),
  [4487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1381),
  [4489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1341),
  [4491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1341),
  [4493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [4495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1789),
  [4497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1789),
  [4499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4726),
  [4501] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2541),
  [4504] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5101),
  [4507] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5101),
  [4510] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5064),
  [4513] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5062),
  [4516] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4889),
  [4519] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(373),
  [4522] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3734),
  [4525] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3727),
  [4528] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3726),
  [4531] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3721),
  [4534] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3721),
  [4537] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2540),
  [4540] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2540),
  [4543] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5090),
  [4546] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5091),
  [4549] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(1354),
  [4552] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2907),
  [4555] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(1354),
  [4558] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2842),
  [4561] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2543),
  [4564] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(246),
  [4567] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(173),
  [4570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2114),
  [4572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2114),
  [4574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [4576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3609),
  [4578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3611),
  [4580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1992),
  [4582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1992),
  [4584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2074),
  [4586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2074),
  [4588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [4590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4689),
  [4592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5099),
  [4594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5099),
  [4596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5048),
  [4598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5046),
  [4600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4905),
  [4602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(463),
  [4604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3318),
  [4606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3319),
  [4608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3321),
  [4610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3322),
  [4612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3322),
  [4614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4690),
  [4616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4690),
  [4618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5033),
  [4620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4915),
  [4622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4628),
  [4624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4716),
  [4626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4628),
  [4628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2866),
  [4630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4687),
  [4632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [4634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [4636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4652),
  [4638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4652),
  [4640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [4642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2744),
  [4644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5115),
  [4646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5115),
  [4648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5018),
  [4650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5016),
  [4652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4923),
  [4654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(433),
  [4656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3875),
  [4658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3874),
  [4660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3873),
  [4662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3871),
  [4664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3871),
  [4666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2656),
  [4668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2656),
  [4670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4874),
  [4672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4897),
  [4674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2107),
  [4676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2983),
  [4678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2107),
  [4680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2665),
  [4682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [4684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [4686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2105),
  [4688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2105),
  [4690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [4692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2099),
  [4694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2099),
  [4696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2087),
  [4698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2087),
  [4700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4612),
  [4702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4612),
  [4704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [4706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2086),
  [4708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2086),
  [4710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [4712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2072),
  [4714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2072),
  [4716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [4718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1928),
  [4720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1928),
  [4722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2061),
  [4724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2061),
  [4726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [4728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4552),
  [4730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4552),
  [4732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2000),
  [4734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2000),
  [4736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1916),
  [4738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1916),
  [4740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1920),
  [4742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1920),
  [4744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [4746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1979),
  [4748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1979),
  [4750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [4752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2664),
  [4754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5104),
  [4756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5104),
  [4758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5030),
  [4760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5028),
  [4762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4917),
  [4764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(450),
  [4766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3834),
  [4768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3855),
  [4770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3858),
  [4772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3861),
  [4774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3861),
  [4776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2700),
  [4778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2700),
  [4780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4921),
  [4782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4794),
  [4784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2013),
  [4786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3000),
  [4788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2013),
  [4790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2668),
  [4792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [4794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [4796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2149),
  [4798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2149),
  [4800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(475),
  [4802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2017),
  [4804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2017),
  [4806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [4808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2019),
  [4810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2019),
  [4812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2026),
  [4814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2026),
  [4816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2042),
  [4818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2042),
  [4820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [4822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2053),
  [4824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2053),
  [4826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [4828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2058),
  [4830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2058),
  [4832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2067),
  [4834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2067),
  [4836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [4838] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2673),
  [4841] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5093),
  [4844] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5093),
  [4847] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5040),
  [4850] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(5036),
  [4853] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4911),
  [4856] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(465),
  [4859] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3345),
  [4862] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3365),
  [4865] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3366),
  [4868] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3367),
  [4871] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3367),
  [4874] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2578),
  [4877] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2578),
  [4880] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4925),
  [4883] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(4919),
  [4886] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(1969),
  [4889] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2957),
  [4892] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(1969),
  [4895] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(3021),
  [4898] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(2567),
  [4901] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(350),
  [4904] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 25), SHIFT_REPEAT(154),
  [4907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2162),
  [4909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2162),
  [4911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1917),
  [4913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1917),
  [4915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4604),
  [4917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4604),
  [4919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1941),
  [4921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1941),
  [4923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [4925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2111),
  [4927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2111),
  [4929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [4931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2090),
  [4933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2090),
  [4935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [4937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2165),
  [4939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2165),
  [4941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [4943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2150),
  [4945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2150),
  [4947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2148),
  [4949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2148),
  [4951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2133),
  [4953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2133),
  [4955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [4957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2132),
  [4959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2132),
  [4961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2124),
  [4963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2124),
  [4965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2121),
  [4967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2121),
  [4969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [4971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4641),
  [4973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4641),
  [4975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [4977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2112),
  [4979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2112),
  [4981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4632),
  [4983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4632),
  [4985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1977),
  [4987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1977),
  [4989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [4991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4457),
  [4993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4457),
  [4995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4553),
  [4997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4553),
  [4999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [5001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4479),
  [5003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4479),
  [5005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(461),
  [5007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2050),
  [5009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2050),
  [5011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2145),
  [5013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2145),
  [5015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [5017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2043),
  [5019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2043),
  [5021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(471),
  [5023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1987),
  [5025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1987),
  [5027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [5029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4653),
  [5031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4653),
  [5033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1999),
  [5035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1999),
  [5037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1950),
  [5039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1950),
  [5041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [5043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1973),
  [5045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1973),
  [5047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4615),
  [5049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4615),
  [5051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [5053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1946),
  [5055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1946),
  [5057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1933),
  [5059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1933),
  [5061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1952),
  [5063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1952),
  [5065] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 7, 0, 46),
  [5067] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 7, 0, 46),
  [5069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4036),
  [5071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4038),
  [5073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4039),
  [5075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4039),
  [5077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4040),
  [5079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4041),
  [5081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4041),
  [5083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4042),
  [5085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4043),
  [5087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4042),
  [5089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4043),
  [5091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4044),
  [5093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4044),
  [5095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4045),
  [5097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4045),
  [5099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4046),
  [5101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4047),
  [5103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4048),
  [5105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(920),
  [5107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4090),
  [5109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1325),
  [5111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1322),
  [5113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1607),
  [5115] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 6, 0, 41),
  [5117] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, 0, 41),
  [5119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3901),
  [5121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3903),
  [5123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3904),
  [5125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3904),
  [5127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3905),
  [5129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3906),
  [5131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3906),
  [5133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3907),
  [5135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3908),
  [5137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3907),
  [5139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3908),
  [5141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3909),
  [5143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3909),
  [5145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3910),
  [5147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3910),
  [5149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3911),
  [5151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3912),
  [5153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3913),
  [5155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(950),
  [5157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4330),
  [5159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1329),
  [5161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1328),
  [5163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1327),
  [5165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4132),
  [5167] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, 0, 40),
  [5169] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 6, 0, 40),
  [5171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3296),
  [5173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3294),
  [5175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3293),
  [5177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3293),
  [5179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3292),
  [5181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3291),
  [5183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3291),
  [5185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3285),
  [5187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3284),
  [5189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3285),
  [5191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3284),
  [5193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3283),
  [5195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3283),
  [5197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3282),
  [5199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3282),
  [5201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3280),
  [5203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3278),
  [5205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3277),
  [5207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(778),
  [5209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4360),
  [5211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1380),
  [5213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1379),
  [5215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1378),
  [5217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4329),
  [5219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4131),
  [5221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4099),
  [5223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4368),
  [5225] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, 0, 36),
  [5227] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, 0, 36),
  [5229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4125),
  [5231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4097),
  [5233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4255),
  [5235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4269),
  [5237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4357),
  [5239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4260),
  [5241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4098),
  [5243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4136),
  [5245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4247),
  [5247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4143),
  [5249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4138),
  [5251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4280),
  [5253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4257),
  [5255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4139),
  [5257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4362),
  [5259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4100),
  [5261] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_operator, 4, 0, 29),
  [5263] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_operator, 4, 0, 29),
  [5265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3763),
  [5267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3765),
  [5269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3766),
  [5271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3766),
  [5273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3767),
  [5275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3768),
  [5277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3768),
  [5279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3769),
  [5281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3770),
  [5283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3769),
  [5285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3770),
  [5287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3771),
  [5289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3771),
  [5291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3772),
  [5293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3772),
  [5295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3773),
  [5297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3774),
  [5299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3775),
  [5301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1105),
  [5303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4231),
  [5305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1332),
  [5307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1331),
  [5309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1330),
  [5311] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 1, 0, 8),
  [5313] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 1, 0, 8),
  [5315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4037),
  [5317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4212),
  [5319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4214),
  [5321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4210),
  [5323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3902),
  [5325] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 1, 0, 8),
  [5327] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 1, 0, 8),
  [5329] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_repeat_statement, 2, 0, 4),
  [5331] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_repeat_statement, 2, 0, 4),
  [5333] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_operator, 2, 0, 5),
  [5335] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_operator, 2, 0, 5),
  [5337] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 3, 0, 11),
  [5339] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 3, 0, 11),
  [5341] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_repeat_statement, 3, 0, 15),
  [5343] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_repeat_statement, 3, 0, 15),
  [5345] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_operator, 3, 0, 16),
  [5347] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_operator, 3, 0, 16),
  [5349] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_operator, 3, 0, 18),
  [5351] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_operator, 3, 0, 18),
  [5353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3487),
  [5355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3489),
  [5357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3490),
  [5359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3490),
  [5361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3491),
  [5363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3492),
  [5365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3492),
  [5367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3493),
  [5369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3494),
  [5371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3493),
  [5373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3494),
  [5375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3495),
  [5377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3495),
  [5379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3496),
  [5381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3496),
  [5383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3497),
  [5385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3498),
  [5387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3499),
  [5389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1317),
  [5391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4218),
  [5393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1350),
  [5395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1348),
  [5397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1346),
  [5399] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 4, 0, 26),
  [5401] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 4, 0, 26),
  [5403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4221),
  [5405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4224),
  [5407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4232),
  [5409] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 9, 0, 55),
  [5411] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 9, 0, 55),
  [5413] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 5, 0, 37),
  [5415] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 5, 0, 37),
  [5417] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 6, 0, 43),
  [5419] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 6, 0, 43),
  [5421] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 6, 0, 44),
  [5423] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 6, 0, 44),
  [5425] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 7, 0, 45),
  [5427] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 7, 0, 45),
  [5429] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, 0, 47),
  [5431] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, 0, 47),
  [5433] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 7, 0, 49),
  [5435] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 7, 0, 49),
  [5437] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 8, 0, 50),
  [5439] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 8, 0, 50),
  [5441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 8, 0, 51),
  [5443] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 8, 0, 51),
  [5445] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, 0, 52),
  [5447] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, 0, 52),
  [5449] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, 0, 53),
  [5451] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, 0, 53),
  [5453] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 9, 0, 54),
  [5455] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 9, 0, 54),
  [5457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3295),
  [5459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4165),
  [5461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4278),
  [5463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4276),
  [5465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4275),
  [5467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4274),
  [5469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4174),
  [5471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4170),
  [5473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4169),
  [5475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3679),
  [5477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3675),
  [5479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3673),
  [5481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3673),
  [5483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3671),
  [5485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3669),
  [5487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3669),
  [5489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3667),
  [5491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3665),
  [5493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3667),
  [5495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3665),
  [5497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3663),
  [5499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3663),
  [5501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3661),
  [5503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3661),
  [5505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3659),
  [5507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3657),
  [5509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3654),
  [5511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1213),
  [5513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1590),
  [5515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1589),
  [5517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1588),
  [5519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3690),
  [5521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(971),
  [5523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1461),
  [5525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1450),
  [5527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1447),
  [5529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3500),
  [5531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3500),
  [5533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3527),
  [5535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3527),
  [5537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3529),
  [5539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3529),
  [5541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3547),
  [5543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3550),
  [5545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3506),
  [5547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3521),
  [5549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3506),
  [5551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3521),
  [5553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3409),
  [5555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3531),
  [5557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3502),
  [5559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3504),
  [5561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3504),
  [5563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4011),
  [5565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4058),
  [5567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4061),
  [5569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4061),
  [5571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4065),
  [5573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4067),
  [5575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4067),
  [5577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3982),
  [5579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3978),
  [5581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3982),
  [5583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3978),
  [5585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3952),
  [5587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3952),
  [5589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3938),
  [5591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3938),
  [5593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3934),
  [5595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3925),
  [5597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3923),
  [5599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(974),
  [5601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1496),
  [5603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1494),
  [5605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1490),
  [5607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4054),
  [5609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4052),
  [5611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4050),
  [5613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4049),
  [5615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4049),
  [5617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4035),
  [5619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4034),
  [5621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4034),
  [5623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4028),
  [5625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4024),
  [5627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4028),
  [5629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4024),
  [5631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4023),
  [5633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4023),
  [5635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4021),
  [5637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4021),
  [5639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4020),
  [5641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4019),
  [5643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4017),
  [5645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1609),
  [5647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4351),
  [5649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1443),
  [5651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1442),
  [5653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1425),
  [5655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4341),
  [5657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4345),
  [5659] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extract_operator, 2, 0, 6),
  [5661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2252),
  [5663] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extract_operator, 2, 0, 6),
  [5665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(780),
  [5667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4293),
  [5669] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extract_operator, 3, 0, 6),
  [5671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2243),
  [5673] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extract_operator, 3, 0, 6),
  [5675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3625),
  [5677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3627),
  [5679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3628),
  [5681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3628),
  [5683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3629),
  [5685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3630),
  [5687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3630),
  [5689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3631),
  [5691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3632),
  [5693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3631),
  [5695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3632),
  [5697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3633),
  [5699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3633),
  [5701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3634),
  [5703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3634),
  [5705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3635),
  [5707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3636),
  [5709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3637),
  [5711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1557),
  [5713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4211),
  [5715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1340),
  [5717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1335),
  [5719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1334),
  [5721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4208),
  [5723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4189),
  [5725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4202),
  [5727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3826),
  [5729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3823),
  [5731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3822),
  [5733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3822),
  [5735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3821),
  [5737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3819),
  [5739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3819),
  [5741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3817),
  [5743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3815),
  [5745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3817),
  [5747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3815),
  [5749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3813),
  [5751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3813),
  [5753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3811),
  [5755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3811),
  [5757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3807),
  [5759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3805),
  [5761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3799),
  [5763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1885),
  [5765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4229),
  [5767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1423),
  [5769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1419),
  [5771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1415),
  [5773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4237),
  [5775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4240),
  [5777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4299),
  [5779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3764),
  [5781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3677),
  [5783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3349),
  [5785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3351),
  [5787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3352),
  [5789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3352),
  [5791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3353),
  [5793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3354),
  [5795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3354),
  [5797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3355),
  [5799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3356),
  [5801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3355),
  [5803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3356),
  [5805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3357),
  [5807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3357),
  [5809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3358),
  [5811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3358),
  [5813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3359),
  [5815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3360),
  [5817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3361),
  [5819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1427),
  [5821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4316),
  [5823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1357),
  [5825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1353),
  [5827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1352),
  [5829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4319),
  [5831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4323),
  [5833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4327),
  [5835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3488),
  [5837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4184),
  [5839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4199),
  [5841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4201),
  [5843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4207),
  [5845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4196),
  [5847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4194),
  [5849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4191),
  [5851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4092),
  [5853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4233),
  [5855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4226),
  [5857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4223),
  [5859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4265),
  [5861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4167),
  [5863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4263),
  [5865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4137),
  [5867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4135),
  [5869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2352),
  [5871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2364),
  [5873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(903),
  [5875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3416),
  [5877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2330),
  [5879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2323),
  [5881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(949),
  [5883] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_operator, 2, 0, 6),
  [5885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2246),
  [5887] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_operator, 2, 0, 6),
  [5889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3281),
  [5891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3279),
  [5893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3275),
  [5895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3273),
  [5897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3273),
  [5899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3270),
  [5901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3267),
  [5903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3267),
  [5905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3265),
  [5907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3263),
  [5909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3265),
  [5911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3263),
  [5913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3261),
  [5915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3261),
  [5917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3259),
  [5919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3259),
  [5921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3257),
  [5923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3255),
  [5925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3253),
  [5927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1515),
  [5929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1555),
  [5931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1551),
  [5933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1549),
  [5935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2537),
  [5937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(973),
  [5939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2426),
  [5941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2422),
  [5943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2552),
  [5945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(972),
  [5947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3931),
  [5949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3753),
  [5951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3757),
  [5953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3757),
  [5955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3762),
  [5957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3778),
  [5959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3778),
  [5961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3781),
  [5963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3782),
  [5965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3781),
  [5967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3782),
  [5969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3786),
  [5971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3786),
  [5973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3787),
  [5975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3787),
  [5977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3794),
  [5979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3795),
  [5981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3797),
  [5983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1966),
  [5985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4144),
  [5987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1528),
  [5989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1525),
  [5991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1519),
  [5993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2327),
  [5995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3075),
  [5997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3076),
  [5999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3077),
  [6001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3077),
  [6003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3078),
  [6005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3079),
  [6007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3079),
  [6009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3080),
  [6011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3081),
  [6013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3080),
  [6015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3081),
  [6017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3082),
  [6019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3082),
  [6021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3083),
  [6023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3083),
  [6025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3084),
  [6027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3085),
  [6029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3086),
  [6031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2065),
  [6033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4141),
  [6035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1366),
  [6037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1365),
  [6039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1364),
  [6041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4145),
  [6043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4152),
  [6045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4164),
  [6047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4168),
  [6049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4159),
  [6051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4219),
  [6053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2502),
  [6055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3196),
  [6057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3088),
  [6059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3209),
  [6061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3209),
  [6063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3210),
  [6065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3225),
  [6067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3225),
  [6069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3226),
  [6071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3227),
  [6073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3226),
  [6075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3227),
  [6077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3228),
  [6079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3228),
  [6081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3229),
  [6083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3229),
  [6085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3230),
  [6087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3231),
  [6089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3234),
  [6091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1817),
  [6093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1537),
  [6095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1534),
  [6097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1533),
  [6099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3824),
  [6101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2527),
  [6103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1061),
  [6105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2360),
  [6107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3626),
  [6109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3350),
  [6111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3212),
  [6113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3213),
  [6115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3214),
  [6117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3214),
  [6119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3215),
  [6121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3216),
  [6123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3216),
  [6125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3217),
  [6127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3218),
  [6129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3217),
  [6131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3218),
  [6133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3219),
  [6135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3219),
  [6137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3220),
  [6139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3220),
  [6141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3221),
  [6143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3222),
  [6145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3223),
  [6147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2131),
  [6149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4198),
  [6151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1362),
  [6153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1361),
  [6155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1360),
  [6157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4204),
  [6159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4205),
  [6161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3199),
  [6163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4209),
  [6165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2487),
  [6167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1264),
  [6169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4051),
  [6171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2468),
  [6173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4113),
  [6175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4112),
  [6177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4110),
  [6179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4109),
  [6181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3141),
  [6183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3139),
  [6185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3138),
  [6187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3138),
  [6189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3137),
  [6191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3136),
  [6193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3136),
  [6195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3135),
  [6197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3134),
  [6199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3135),
  [6201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3134),
  [6203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3132),
  [6205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3132),
  [6207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3124),
  [6209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3124),
  [6211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3122),
  [6213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3120),
  [6215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3118),
  [6217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2048),
  [6219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4180),
  [6221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1372),
  [6223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1371),
  [6225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1370),
  [6227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4285),
  [6229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4185),
  [6231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4188),
  [6233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4200),
  [6235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4186),
  [6237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4187),
  [6239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4239),
  [6241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4203),
  [6243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4252),
  [6245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4254),
  [6247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4140),
  [6249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2473),
  [6251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4302),
  [6253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4303),
  [6255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4311),
  [6257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4326),
  [6259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2451),
  [6261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1299),
  [6263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3930),
  [6265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4000),
  [6267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3710),
  [6269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3710),
  [6271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4066),
  [6273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4008),
  [6275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4008),
  [6277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3990),
  [6279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3977),
  [6281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3990),
  [6283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3977),
  [6285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3921),
  [6287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3921),
  [6289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3920),
  [6291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3920),
  [6293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3915),
  [6295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3897),
  [6297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3886),
  [6299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2118),
  [6301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1344),
  [6303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1374),
  [6305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1452),
  [6307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3098),
  [6309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3037),
  [6311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3091),
  [6313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3091),
  [6315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3087),
  [6317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3069),
  [6319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3069),
  [6321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3067),
  [6323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3065),
  [6325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3067),
  [6327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3065),
  [6329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3063),
  [6331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3063),
  [6333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3062),
  [6335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3062),
  [6337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3061),
  [6339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3050),
  [6341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3048),
  [6343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2064),
  [6345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1545),
  [6347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1541),
  [6349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1539),
  [6351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2597),
  [6353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3858),
  [6355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2038),
  [6357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2938),
  [6359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2038),
  [6361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4664),
  [6363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4666),
  [6365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4723),
  [6367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2362),
  [6369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2606),
  [6371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3873),
  [6373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1940),
  [6375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2959),
  [6377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1940),
  [6379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4665),
  [6381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4660),
  [6383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4715),
  [6385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2955),
  [6387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2633),
  [6389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3366),
  [6391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1931),
  [6393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3014),
  [6395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1931),
  [6397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4656),
  [6399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4672),
  [6401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2363),
  [6403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2981),
  [6405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2326),
  [6407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2325),
  [6409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2324),
  [6411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2519),
  [6413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2524),
  [6415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2525),
  [6417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2351),
  [6419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2624),
  [6421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2626),
  [6423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2455),
  [6425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2506),
  [6427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2991),
  [6429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2627),
  [6431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3460),
  [6433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3457),
  [6435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3456),
  [6437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3456),
  [6439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3454),
  [6441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3453),
  [6443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3453),
  [6445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3452),
  [6447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3449),
  [6449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3452),
  [6451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3449),
  [6453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3446),
  [6455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3446),
  [6457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3444),
  [6459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3444),
  [6461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3443),
  [6463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3438),
  [6465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3432),
  [6467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2097),
  [6469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1584),
  [6471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1582),
  [6473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1577),
  [6475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2331),
  [6477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2894),
  [6479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2454),
  [6481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2453),
  [6483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2452),
  [6485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2501),
  [6487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2714),
  [6489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2715),
  [6491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3507),
  [6493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3474),
  [6495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3472),
  [6497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3462),
  [6499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3462),
  [6501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3458),
  [6503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3451),
  [6505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3451),
  [6507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3450),
  [6509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3445),
  [6511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3450),
  [6513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3445),
  [6515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3442),
  [6517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3442),
  [6519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3439),
  [6521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3439),
  [6523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3301),
  [6525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3419),
  [6527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3371),
  [6529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2163),
  [6531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1411),
  [6533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1409),
  [6535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1407),
  [6537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2716),
  [6539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2601),
  [6541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2812),
  [6543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2819),
  [6545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2820),
  [6547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2474),
  [6549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2863),
  [6551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2860),
  [6553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2857),
  [6555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2475),
  [6557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2705),
  [6559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2476),
  [6561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2766),
  [6563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2784),
  [6565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2782),
  [6567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2796),
  [6569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2909),
  [6571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3019),
  [6573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2248),
  [6575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2249),
  [6577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2250),
  [6579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2703),
  [6581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2704),
  [6583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2706),
  [6585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2915),
  [6587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4699),
  [6589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4702),
  [6591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4705),
  [6593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2839),
  [6595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2463),
  [6597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2464),
  [6599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2880),
  [6601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2882),
  [6603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2889),
  [6605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3013),
  [6607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2587),
  [6609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3012),
  [6611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2495),
  [6613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2775),
  [6615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2585),
  [6617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2776),
  [6619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2414),
  [6621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2584),
  [6623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2242),
  [6625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2695),
  [6627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2717),
  [6629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1389),
  [6631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3011),
  [6633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2696),
  [6635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2697),
  [6637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4709),
  [6639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3998),
  [6641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2508),
  [6643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2520),
  [6645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2830),
  [6647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2420),
  [6649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2521),
  [6651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2419),
  [6653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4729),
  [6655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2609),
  [6657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2513),
  [6659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4725),
  [6661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2512),
  [6663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2533),
  [6665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2794),
  [6667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2795),
  [6669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2677),
  [6671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2615),
  [6673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1566),
  [6675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2813),
  [6677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3140),
  [6679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2815),
  [6681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2816),
  [6683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4718),
  [6685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2421),
  [6687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2721),
  [6689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2725),
  [6691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2350),
  [6693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2726),
  [6695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2417),
  [6697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2788),
  [6699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2791),
  [6701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2230),
  [6703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2804),
  [6705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2792),
  [6707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2613),
  [6709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2605),
  [6711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2612),
  [6713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2629),
  [6715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1581),
  [6717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2635),
  [6719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2471),
  [6721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2574),
  [6723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2571),
  [6725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2570),
  [6727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2753),
  [6729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2604),
  [6731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2752),
  [6733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2600),
  [6735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2746),
  [6737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2599),
  [6739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2491),
  [6741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2757),
  [6743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2472),
  [6745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2480),
  [6747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2485),
  [6749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2572),
  [6751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2967),
  [6753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2968),
  [6755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3096),
  [6757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2961),
  [6759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4730),
  [6761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2969),
  [6763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2361),
  [6765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2698),
  [6767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1786),
  [6769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3003),
  [6771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3004),
  [6773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3005),
  [6775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3459),
  [6777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2774),
  [6779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2913),
  [6781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2914),
  [6783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2780),
  [6785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2823),
  [6787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2875),
  [6789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2747),
  [6791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2950),
  [6793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2951),
  [6795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2643),
  [6797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2676),
  [6799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2675),
  [6801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2833),
  [6803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2828),
  [6805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2827),
  [6807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2240),
  [6809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2241),
  [6811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2733),
  [6813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1868),
  [6815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2862),
  [6817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2751),
  [6819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2754),
  [6821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2467),
  [6823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2960),
  [6825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2958),
  [6827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2952),
  [6829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2681),
  [6831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2634),
  [6833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2632),
  [6835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4711),
  [6837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2844),
  [6839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4712),
  [6841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2836),
  [6843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2582),
  [6845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1901),
  [6847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2990),
  [6849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2333),
  [6851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2517),
  [6853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2332),
  [6855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2993),
  [6857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2994),
  [6859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2989),
  [6861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2996),
  [6863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2608),
  [6865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2610),
  [6867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2611),
  [6869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2496),
  [6871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2500),
  [6873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2921),
  [6875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3843),
  [6877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3841),
  [6879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3840),
  [6881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3840),
  [6883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3839),
  [6885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3838),
  [6887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3838),
  [6889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3837),
  [6891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3836),
  [6893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3837),
  [6895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3836),
  [6897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3835),
  [6899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3835),
  [6901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3735),
  [6903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3735),
  [6905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3831),
  [6907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3827),
  [6909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3825),
  [6911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2227),
  [6913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1606),
  [6915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1598),
  [6917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1592),
  [6919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3418),
  [6921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3425),
  [6923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3426),
  [6925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3426),
  [6927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3433),
  [6929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3433),
  [6931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3434),
  [6933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3435),
  [6935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3434),
  [6937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3435),
  [6939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3436),
  [6941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3436),
  [6943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3448),
  [6945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3448),
  [6947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3455),
  [6949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3467),
  [6951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3469),
  [6953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2179),
  [6955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1755),
  [6957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1763),
  [6959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1866),
  [6961] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31), SHIFT_REPEAT(2606),
  [6964] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31), SHIFT_REPEAT(5115),
  [6967] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31), SHIFT_REPEAT(5115),
  [6970] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31), SHIFT_REPEAT(5018),
  [6973] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31), SHIFT_REPEAT(5016),
  [6976] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31), SHIFT_REPEAT(4923),
  [6979] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31), SHIFT_REPEAT(433),
  [6982] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31), SHIFT_REPEAT(3875),
  [6985] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31), SHIFT_REPEAT(3874),
  [6988] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31), SHIFT_REPEAT(3873),
  [6991] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31), SHIFT_REPEAT(3871),
  [6994] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31), SHIFT_REPEAT(2656),
  [6997] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31), SHIFT_REPEAT(2656),
  [7000] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31), SHIFT_REPEAT(4874),
  [7003] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31), SHIFT_REPEAT(4897),
  [7006] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31), SHIFT_REPEAT(1940),
  [7009] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31), SHIFT_REPEAT(2983),
  [7012] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31), SHIFT_REPEAT(2959),
  [7015] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31), SHIFT_REPEAT(1940),
  [7018] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31), SHIFT_REPEAT(4665),
  [7021] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31), SHIFT_REPEAT(4660),
  [7024] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31), SHIFT_REPEAT(2665),
  [7027] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31), SHIFT_REPEAT(218),
  [7030] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31), SHIFT_REPEAT(185),
  [7033] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31),
  [7035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3954),
  [7037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3965),
  [7039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3979),
  [7041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3979),
  [7043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3996),
  [7045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4004),
  [7047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4004),
  [7049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4007),
  [7051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4022),
  [7053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4007),
  [7055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4022),
  [7057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4087),
  [7059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4087),
  [7061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4083),
  [7063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4083),
  [7065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4079),
  [7067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4075),
  [7069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4071),
  [7071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2178),
  [7073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1616),
  [7075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1615),
  [7077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1613),
  [7079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3708),
  [7081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3709),
  [7083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3709),
  [7085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3722),
  [7087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3724),
  [7089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3722),
  [7091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3724),
  [7093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3728),
  [7095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3728),
  [7097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4064),
  [7099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4064),
  [7101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3730),
  [7103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3731),
  [7105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3743),
  [7107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2171),
  [7109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1414),
  [7111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1416),
  [7113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1428),
  [7115] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 1, 0, 1),
  [7117] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 1, 0, 1),
  [7119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2910),
  [7121] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_float, 1, 0, 0),
  [7123] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_float, 1, 0, 0),
  [7125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2339),
  [7127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2340),
  [7129] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0),
  [7131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1, 0, 0),
  [7133] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__string_or_identifier, 1, 0, 0),
  [7135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__string_or_identifier, 1, 0, 0),
  [7137] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 1, 0, 0),
  [7139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 1, 0, 0),
  [7141] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__argument_value, 1, 0, 19),
  [7143] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__argument_value, 1, 0, 19),
  [7145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3424),
  [7147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3427),
  [7149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3842),
  [7151] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__single_quoted_string, 2, 0, 0),
  [7153] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__single_quoted_string, 2, 0, 0),
  [7155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3697),
  [7157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3719),
  [7159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3720),
  [7161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3720),
  [7163] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__double_quoted_string, 2, 0, 0),
  [7165] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__double_quoted_string, 2, 0, 0),
  [7167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2818),
  [7169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2015),
  [7171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2589),
  [7173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2268),
  [7175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2267),
  [7177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2758),
  [7179] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 1, 0, 0),
  [7181] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 1, 0, 0),
  [7183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3698),
  [7185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2316),
  [7187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2317),
  [7189] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__single_quoted_string, 3, 0, 17),
  [7191] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__single_quoted_string, 3, 0, 17),
  [7193] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__double_quoted_string, 3, 0, 17),
  [7195] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__double_quoted_string, 3, 0, 17),
  [7197] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31), SHIFT_REPEAT(2597),
  [7200] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31), SHIFT_REPEAT(5104),
  [7203] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31), SHIFT_REPEAT(5104),
  [7206] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31), SHIFT_REPEAT(5030),
  [7209] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31), SHIFT_REPEAT(5028),
  [7212] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31), SHIFT_REPEAT(4917),
  [7215] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31), SHIFT_REPEAT(450),
  [7218] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31), SHIFT_REPEAT(3834),
  [7221] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31), SHIFT_REPEAT(3855),
  [7224] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31), SHIFT_REPEAT(3858),
  [7227] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31), SHIFT_REPEAT(3861),
  [7230] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31), SHIFT_REPEAT(2700),
  [7233] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31), SHIFT_REPEAT(2700),
  [7236] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31), SHIFT_REPEAT(4921),
  [7239] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31), SHIFT_REPEAT(4794),
  [7242] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31), SHIFT_REPEAT(2038),
  [7245] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31), SHIFT_REPEAT(3000),
  [7248] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31), SHIFT_REPEAT(2938),
  [7251] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31), SHIFT_REPEAT(2038),
  [7254] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31), SHIFT_REPEAT(4664),
  [7257] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31), SHIFT_REPEAT(4666),
  [7260] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31), SHIFT_REPEAT(2668),
  [7263] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31), SHIFT_REPEAT(214),
  [7266] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31), SHIFT_REPEAT(192),
  [7269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2720),
  [7271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3958),
  [7273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2837),
  [7275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2768),
  [7277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2056),
  [7279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2814),
  [7281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2762),
  [7283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2831),
  [7285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2057),
  [7287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2855),
  [7289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1909),
  [7291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2841),
  [7293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2155),
  [7295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2694),
  [7297] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31), SHIFT_REPEAT(2633),
  [7300] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31), SHIFT_REPEAT(5093),
  [7303] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31), SHIFT_REPEAT(5093),
  [7306] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31), SHIFT_REPEAT(5040),
  [7309] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31), SHIFT_REPEAT(5036),
  [7312] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31), SHIFT_REPEAT(4911),
  [7315] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31), SHIFT_REPEAT(465),
  [7318] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31), SHIFT_REPEAT(3345),
  [7321] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31), SHIFT_REPEAT(3365),
  [7324] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31), SHIFT_REPEAT(3366),
  [7327] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31), SHIFT_REPEAT(3367),
  [7330] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31), SHIFT_REPEAT(2578),
  [7333] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31), SHIFT_REPEAT(2578),
  [7336] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31), SHIFT_REPEAT(4925),
  [7339] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31), SHIFT_REPEAT(4919),
  [7342] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31), SHIFT_REPEAT(1931),
  [7345] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31), SHIFT_REPEAT(2957),
  [7348] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31), SHIFT_REPEAT(3014),
  [7351] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31), SHIFT_REPEAT(1931),
  [7354] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31), SHIFT_REPEAT(4656),
  [7357] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31), SHIFT_REPEAT(4672),
  [7360] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31), SHIFT_REPEAT(2567),
  [7363] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31), SHIFT_REPEAT(350),
  [7366] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 31), SHIFT_REPEAT(154),
  [7369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2900),
  [7371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1924),
  [7373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2623),
  [7375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2824),
  [7377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2146),
  [7379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2602),
  [7381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2799),
  [7383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2871),
  [7385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2713),
  [7387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2903),
  [7389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2039),
  [7391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2878),
  [7393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3015),
  [7395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2226),
  [7397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2811),
  [7399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3006),
  [7401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2225),
  [7403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2949),
  [7405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2214),
  [7407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2755),
  [7409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2518),
  [7411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2365),
  [7413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2407),
  [7415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2402),
  [7417] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0),
  [7419] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0),
  [7421] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(2195),
  [7424] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(2196),
  [7427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2899),
  [7429] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(2199),
  [7432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2749),
  [7434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2770),
  [7436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2759),
  [7438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2435),
  [7440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2436),
  [7442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2557),
  [7444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2556),
  [7446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2962),
  [7448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2936),
  [7450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2807),
  [7452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2384),
  [7454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2391),
  [7456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2995),
  [7458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2997),
  [7460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2970),
  [7462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2213),
  [7464] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subset_arguments, 3, 0, 30),
  [7466] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subset_arguments, 3, 0, 30),
  [7468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2586),
  [7470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2593),
  [7472] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subset2_arguments, 3, 0, 30),
  [7474] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subset2_arguments, 3, 0, 30),
  [7476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_arguments, 3, 0, 30),
  [7478] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_arguments, 3, 0, 30),
  [7480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extract_operator, 4, 0, 29),
  [7482] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extract_operator, 4, 0, 29),
  [7484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_braced_expression, 3, 0, 24),
  [7486] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_braced_expression, 3, 0, 24),
  [7488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3, 0, 24),
  [7490] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3, 0, 24),
  [7492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_operator, 3, 0, 18),
  [7494] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_operator, 3, 0, 18),
  [7496] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subset2_arguments, 2, 0, 9),
  [7498] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subset2_arguments, 2, 0, 9),
  [7500] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subset_arguments, 2, 0, 9),
  [7502] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subset_arguments, 2, 0, 9),
  [7504] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_arguments, 2, 0, 9),
  [7506] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_arguments, 2, 0, 9),
  [7508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2953),
  [7510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extract_operator, 3, 0, 18),
  [7512] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extract_operator, 3, 0, 18),
  [7514] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_braced_expression, 2, 0, 9),
  [7516] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_braced_expression, 2, 0, 9),
  [7518] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 2, 0, 9),
  [7520] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 2, 0, 9),
  [7522] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subset2, 2, 0, 7),
  [7524] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subset2, 2, 0, 7),
  [7526] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subset, 2, 0, 7),
  [7528] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subset, 2, 0, 7),
  [7530] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call, 2, 0, 7),
  [7532] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call, 2, 0, 7),
  [7534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2687),
  [7536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2686),
  [7538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_complex, 2, 0, 0),
  [7540] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_complex, 2, 0, 0),
  [7542] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_integer, 2, 0, 0),
  [7544] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_integer, 2, 0, 0),
  [7546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2734),
  [7548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2732),
  [7550] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_na, 1, 0, 0),
  [7552] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_na, 1, 0, 0),
  [7554] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 4, 0, 34),
  [7556] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 4, 0, 34),
  [7558] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(2281),
  [7561] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 3, 0, 27),
  [7563] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 3, 0, 27),
  [7565] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 2, 0, 9),
  [7567] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 2, 0, 9),
  [7569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2653),
  [7571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2652),
  [7573] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(2302),
  [7576] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(2303),
  [7579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2966),
  [7581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2628),
  [7583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2625),
  [7585] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(2336),
  [7588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3010),
  [7590] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(2349),
  [7593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3002),
  [7595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2618),
  [7597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2619),
  [7599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2934),
  [7601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2935),
  [7603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2873),
  [7605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2872),
  [7607] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(2398),
  [7610] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(2399),
  [7613] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(2400),
  [7616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2806),
  [7618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2925),
  [7620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2793),
  [7622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2798),
  [7624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2846),
  [7626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2933),
  [7628] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(2460),
  [7631] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(2465),
  [7634] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(2503),
  [7637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2834),
  [7639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2832),
  [7641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2927),
  [7643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2932),
  [7645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2748),
  [7647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2750),
  [7649] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(2576),
  [7652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2940),
  [7654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2945),
  [7656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2835),
  [7658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2912),
  [7660] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(2617),
  [7663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2772),
  [7665] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(2637),
  [7668] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(2639),
  [7671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2980),
  [7673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2979),
  [7675] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(2670),
  [7678] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(2680),
  [7681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3023),
  [7683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3024),
  [7685] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(2722),
  [7688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2971),
  [7690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2972),
  [7692] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(2742),
  [7695] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__argument_named, 2, 0, 12),
  [7697] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 1, 0, 0),
  [7699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2893),
  [7701] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(2847),
  [7704] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(2866),
  [7707] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(2881),
  [7710] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0),
  [7712] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(2562),
  [7715] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(5108),
  [7718] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(5108),
  [7721] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(5066),
  [7724] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(4985),
  [7727] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(4846),
  [7730] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(460),
  [7733] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(3599),
  [7736] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(3608),
  [7739] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(3609),
  [7742] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(3611),
  [7745] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(2739),
  [7748] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(2739),
  [7751] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(4766),
  [7754] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(4776),
  [7757] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(2018),
  [7760] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(2939),
  [7763] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(2018),
  [7766] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(2893),
  [7769] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(2667),
  [7772] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(293),
  [7775] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(292),
  [7778] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(2901),
  [7781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3161),
  [7783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1699),
  [7785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1699),
  [7787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4693),
  [7789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3053),
  [7791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1295),
  [7793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1295),
  [7795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3208),
  [7797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3726),
  [7799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1816),
  [7801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1816),
  [7803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3128),
  [7805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1731),
  [7807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1731),
  [7809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1738),
  [7811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1738),
  [7813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1737),
  [7815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1737),
  [7817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1736),
  [7819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1736),
  [7821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3713),
  [7823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1270),
  [7825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1270),
  [7827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1268),
  [7829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1268),
  [7831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3035),
  [7833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1694),
  [7835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1694),
  [7837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3046),
  [7839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1815),
  [7841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1815),
  [7843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1734),
  [7845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1734),
  [7847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1743),
  [7849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1743),
  [7851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1742),
  [7853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1742),
  [7855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1741),
  [7857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1741),
  [7859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1266),
  [7861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1266),
  [7863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1740),
  [7865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1740),
  [7867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1739),
  [7869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1739),
  [7871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1733),
  [7873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1733),
  [7875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1818),
  [7877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1818),
  [7879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1714),
  [7881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1714),
  [7883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3040),
  [7885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1732),
  [7887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1732),
  [7889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1712),
  [7891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1712),
  [7893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3041),
  [7895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1660),
  [7897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1660),
  [7899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3064),
  [7901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1659),
  [7903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1659),
  [7905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3066),
  [7907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1658),
  [7909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1658),
  [7911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3068),
  [7913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1657),
  [7915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1657),
  [7917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3070),
  [7919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1265),
  [7921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1265),
  [7923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3043),
  [7925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1695),
  [7927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1695),
  [7929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1697),
  [7931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1697),
  [7933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3192),
  [7935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(676),
  [7937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [7939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3343),
  [7941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1701),
  [7943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1701),
  [7945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1810),
  [7947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1810),
  [7949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1710),
  [7951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1710),
  [7953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3042),
  [7955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1708),
  [7957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1708),
  [7959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3044),
  [7961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1706),
  [7963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1706),
  [7965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3045),
  [7967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1650),
  [7969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1650),
  [7971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1704),
  [7973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1704),
  [7975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3032),
  [7977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1649),
  [7979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1649),
  [7981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1702),
  [7983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1702),
  [7985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3033),
  [7987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1648),
  [7989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1648),
  [7991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1700),
  [7993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1700),
  [7995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3034),
  [7997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1646),
  [7999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1646),
  [8001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1703),
  [8003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1703),
  [8005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1705),
  [8007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1705),
  [8009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4014),
  [8011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(497),
  [8013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [8015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1707),
  [8017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1707),
  [8019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1644),
  [8021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1644),
  [8023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3107),
  [8025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1640),
  [8027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1640),
  [8029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3111),
  [8031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1638),
  [8033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1638),
  [8035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3113),
  [8037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1635),
  [8039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1635),
  [8041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3115),
  [8043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1634),
  [8045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1634),
  [8047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3117),
  [8049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1633),
  [8051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1633),
  [8053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3119),
  [8055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1632),
  [8057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1632),
  [8059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3121),
  [8061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1631),
  [8063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1631),
  [8065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3123),
  [8067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1630),
  [8069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1630),
  [8071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3125),
  [8073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1629),
  [8075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1629),
  [8077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3127),
  [8079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1628),
  [8081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1628),
  [8083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3129),
  [8085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1627),
  [8087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1627),
  [8089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3131),
  [8091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1698),
  [8093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1698),
  [8095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3104),
  [8097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3105),
  [8099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1124),
  [8101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1124),
  [8103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3298),
  [8105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1709),
  [8107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1709),
  [8109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(478),
  [8111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [8113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3073),
  [8115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1696),
  [8117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1696),
  [8119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3039),
  [8121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1711),
  [8123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1711),
  [8125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1713),
  [8127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1713),
  [8129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1809),
  [8131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1809),
  [8133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(481),
  [8135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [8137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1692),
  [8139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1692),
  [8141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3049),
  [8143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1715),
  [8145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1715),
  [8147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1690),
  [8149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1690),
  [8151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3031),
  [8153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1716),
  [8155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1716),
  [8157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(484),
  [8159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [8161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3095),
  [8163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1718),
  [8165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1718),
  [8167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1137),
  [8169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1137),
  [8171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3154),
  [8173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1687),
  [8175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1687),
  [8177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1735),
  [8179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1735),
  [8181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1135),
  [8183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1135),
  [8185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3158),
  [8187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1686),
  [8189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1686),
  [8191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1614),
  [8193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1614),
  [8195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1685),
  [8197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1685),
  [8199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1611),
  [8201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1611),
  [8203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1684),
  [8205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1684),
  [8207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1610),
  [8209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1610),
  [8211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1134),
  [8213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1134),
  [8215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3159),
  [8217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1608),
  [8219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1608),
  [8221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1819),
  [8223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1819),
  [8225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1605),
  [8227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1605),
  [8229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(674),
  [8231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [8233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3374),
  [8235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1602),
  [8237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1602),
  [8239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1729),
  [8241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1729),
  [8243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3056),
  [8245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1601),
  [8247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1601),
  [8249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1744),
  [8251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1744),
  [8253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3057),
  [8255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1597),
  [8257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1597),
  [8259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1745),
  [8261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1745),
  [8263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3028),
  [8265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1596),
  [8267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1596),
  [8269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1746),
  [8271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1746),
  [8273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3059),
  [8275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1595),
  [8277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1595),
  [8279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1647),
  [8281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1647),
  [8283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3103),
  [8285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1594),
  [8287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1594),
  [8289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1645),
  [8291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1645),
  [8293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3106),
  [8295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1593),
  [8297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1593),
  [8299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1643),
  [8301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1643),
  [8303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3108),
  [8305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1578),
  [8307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1578),
  [8309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1747),
  [8311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1747),
  [8313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3071),
  [8315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1641),
  [8317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1641),
  [8319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3110),
  [8321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1748),
  [8323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1748),
  [8325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3072),
  [8327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1753),
  [8329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1753),
  [8331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3074),
  [8333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1761),
  [8335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1761),
  [8337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3089),
  [8339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1762),
  [8341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1762),
  [8343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3092),
  [8345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1765),
  [8347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1765),
  [8349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3093),
  [8351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1770),
  [8353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1770),
  [8355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3097),
  [8357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1776),
  [8359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1776),
  [8361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3099),
  [8363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1777),
  [8365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1777),
  [8367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3101),
  [8369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1778),
  [8371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1778),
  [8373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1779),
  [8375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1779),
  [8377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1808),
  [8379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1808),
  [8381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3879),
  [8383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(485),
  [8385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [8387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(490),
  [8389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(490),
  [8391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3145),
  [8393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(482),
  [8395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [8397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(499),
  [8399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [8401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3147),
  [8403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3741),
  [8405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(604),
  [8407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(604),
  [8409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(671),
  [8411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [8413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3149),
  [8415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(670),
  [8417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [8419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(669),
  [8421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [8423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3151),
  [8425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1780),
  [8427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1780),
  [8429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1130),
  [8431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1130),
  [8433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1781),
  [8435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1781),
  [8437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1129),
  [8439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1129),
  [8441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1820),
  [8443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1820),
  [8445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1128),
  [8447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1128),
  [8449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1127),
  [8451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1127),
  [8453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1787),
  [8455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1787),
  [8457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3142),
  [8459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1788),
  [8461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1788),
  [8463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3143),
  [8465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1791),
  [8467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1791),
  [8469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3153),
  [8471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1793),
  [8473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1793),
  [8475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3155),
  [8477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3603),
  [8479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(803),
  [8481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(803),
  [8483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1811),
  [8485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1811),
  [8487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(805),
  [8489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(805),
  [8491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3164),
  [8493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1824),
  [8495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1824),
  [8497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1825),
  [8499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1825),
  [8501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(807),
  [8503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(807),
  [8505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(809),
  [8507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(809),
  [8509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3169),
  [8511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1826),
  [8513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1826),
  [8515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3465),
  [8517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(668),
  [8519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(668),
  [8521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(667),
  [8523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(667),
  [8525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3172),
  [8527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(666),
  [8529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [8531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3305),
  [8533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1195),
  [8535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1195),
  [8537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(665),
  [8539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(665),
  [8541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3174),
  [8543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3327),
  [8545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(818),
  [8547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(818),
  [8549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(819),
  [8551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [8553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3177),
  [8555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1171),
  [8557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1171),
  [8559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(820),
  [8561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(820),
  [8563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1172),
  [8565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1172),
  [8567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1180),
  [8569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1180),
  [8571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1181),
  [8573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1181),
  [8575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1182),
  [8577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1182),
  [8579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1186),
  [8581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1186),
  [8583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(821),
  [8585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(821),
  [8587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3180),
  [8589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1188),
  [8591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1188),
  [8593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3190),
  [8595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1546),
  [8597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1546),
  [8599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3201),
  [8601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1544),
  [8603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1544),
  [8605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3203),
  [8607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1542),
  [8609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1542),
  [8611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3205),
  [8613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1540),
  [8615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1540),
  [8617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3207),
  [8619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(675),
  [8621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [8623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3368),
  [8625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1316),
  [8627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1316),
  [8629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1315),
  [8631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1315),
  [8633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3193),
  [8635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1301),
  [8637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1301),
  [8639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1126),
  [8641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1126),
  [8643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3276),
  [8645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1300),
  [8647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1300),
  [8649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3195),
  [8651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1190),
  [8653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1190),
  [8655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1125),
  [8657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1125),
  [8659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3297),
  [8661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1191),
  [8663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1191),
  [8665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1526),
  [8667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1526),
  [8669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1192),
  [8671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1192),
  [8673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1524),
  [8675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1524),
  [8677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1193),
  [8679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1193),
  [8681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1523),
  [8683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1523),
  [8685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1194),
  [8687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1194),
  [8689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1522),
  [8691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1522),
  [8693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1297),
  [8695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1297),
  [8697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1123),
  [8699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1123),
  [8701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3300),
  [8703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1122),
  [8705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1122),
  [8707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3307),
  [8709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1294),
  [8711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1294),
  [8713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1520),
  [8715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1520),
  [8717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3244),
  [8719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1517),
  [8721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1517),
  [8723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3248),
  [8725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1516),
  [8727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1516),
  [8729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3250),
  [8731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1514),
  [8733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1514),
  [8735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3252),
  [8737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1513),
  [8739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1513),
  [8741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3254),
  [8743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1512),
  [8745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1512),
  [8747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3256),
  [8749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1511),
  [8751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1511),
  [8753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3258),
  [8755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1510),
  [8757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1510),
  [8759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3260),
  [8761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1509),
  [8763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1509),
  [8765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3262),
  [8767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1508),
  [8769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1508),
  [8771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3264),
  [8773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1507),
  [8775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1507),
  [8777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3266),
  [8779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1506),
  [8781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1506),
  [8783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3268),
  [8785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1822),
  [8787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1822),
  [8789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1121),
  [8791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1121),
  [8793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3324),
  [8795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1120),
  [8797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1120),
  [8799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3329),
  [8801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1119),
  [8803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1119),
  [8805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3330),
  [8807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1118),
  [8809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1118),
  [8811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3332),
  [8813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1117),
  [8815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1117),
  [8817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3333),
  [8819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1116),
  [8821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1116),
  [8823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3334),
  [8825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1115),
  [8827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1115),
  [8829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3335),
  [8831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3337),
  [8833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(551),
  [8835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [8837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1291),
  [8839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1291),
  [8841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3211),
  [8843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1114),
  [8845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1114),
  [8847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3346),
  [8849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(550),
  [8851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [8853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1290),
  [8855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1290),
  [8857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(549),
  [8859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [8861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(548),
  [8863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [8865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(547),
  [8867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(547),
  [8869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(546),
  [8871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
  [8873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(545),
  [8875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [8877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(508),
  [8879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [8881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1136),
  [8883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1136),
  [8885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3156),
  [8887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1500),
  [8889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1500),
  [8891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(543),
  [8893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(543),
  [8895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1499),
  [8897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1499),
  [8899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(541),
  [8901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(541),
  [8903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1498),
  [8905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1498),
  [8907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(540),
  [8909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [8911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1497),
  [8913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1497),
  [8915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(539),
  [8917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [8919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1495),
  [8921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1495),
  [8923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1197),
  [8925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1197),
  [8927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3179),
  [8929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1493),
  [8931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1493),
  [8933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1217),
  [8935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1217),
  [8937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3181),
  [8939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1491),
  [8941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1491),
  [8943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1220),
  [8945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1220),
  [8947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3182),
  [8949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1486),
  [8951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1486),
  [8953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1221),
  [8955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1221),
  [8957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3183),
  [8959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1484),
  [8961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1484),
  [8963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1222),
  [8965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1222),
  [8967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3184),
  [8969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1483),
  [8971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1483),
  [8973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1226),
  [8975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1226),
  [8977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3185),
  [8979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1482),
  [8981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1482),
  [8983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1228),
  [8985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1228),
  [8987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3187),
  [8989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1481),
  [8991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1481),
  [8993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1230),
  [8995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1230),
  [8997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3198),
  [8999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1480),
  [9001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1480),
  [9003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(536),
  [9005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [9007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1231),
  [9009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1231),
  [9011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3200),
  [9013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1289),
  [9015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1289),
  [9017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3236),
  [9019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1286),
  [9021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1286),
  [9023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1232),
  [9025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1232),
  [9027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3202),
  [9029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1283),
  [9031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1283),
  [9033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3272),
  [9035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1233),
  [9037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1233),
  [9039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3204),
  [9041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1112),
  [9043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1112),
  [9045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(534),
  [9047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [9049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3232),
  [9051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(533),
  [9053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(533),
  [9055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3235),
  [9057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1234),
  [9059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1234),
  [9061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3206),
  [9063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(531),
  [9065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [9067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3237),
  [9069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1235),
  [9071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1235),
  [9073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3175),
  [9075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(530),
  [9077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [9079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3238),
  [9081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(529),
  [9083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [9085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3239),
  [9087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(528),
  [9089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [9091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3240),
  [9093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(527),
  [9095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [9097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3241),
  [9099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1236),
  [9101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1236),
  [9103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1237),
  [9105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1237),
  [9107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1238),
  [9109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1238),
  [9111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1239),
  [9113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1239),
  [9115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(492),
  [9117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [9119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(526),
  [9121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [9123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3242),
  [9125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(525),
  [9127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [9129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3245),
  [9131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(524),
  [9133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [9135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3247),
  [9137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(523),
  [9139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [9141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3249),
  [9143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(521),
  [9145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [9147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3251),
  [9149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(520),
  [9151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [9153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3269),
  [9155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1110),
  [9157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1110),
  [9159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1109),
  [9161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1109),
  [9163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(519),
  [9165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [9167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1108),
  [9169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1108),
  [9171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1799),
  [9173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1799),
  [9175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3167),
  [9177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1242),
  [9179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1242),
  [9181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3286),
  [9183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(496),
  [9185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [9187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3290),
  [9189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(518),
  [9191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [9193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1243),
  [9195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1243),
  [9197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3287),
  [9199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1244),
  [9201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1244),
  [9203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3288),
  [9205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1107),
  [9207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1107),
  [9209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1245),
  [9211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1245),
  [9213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3289),
  [9215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(489),
  [9217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [9219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(487),
  [9221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(487),
  [9223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3309),
  [9225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(517),
  [9227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [9229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3651),
  [9231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4378),
  [9233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4378),
  [9235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4377),
  [9237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4377),
  [9239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3312),
  [9241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4376),
  [9243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4376),
  [9245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4375),
  [9247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4375),
  [9249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3314),
  [9251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3848),
  [9253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(856),
  [9255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [9257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(859),
  [9259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(859),
  [9261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3316),
  [9263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3321),
  [9265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4465),
  [9267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4465),
  [9269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3362),
  [9271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4485),
  [9273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4485),
  [9275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3483),
  [9277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(860),
  [9279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [9281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4486),
  [9283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4486),
  [9285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3518),
  [9287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4531),
  [9289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4531),
  [9291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3523),
  [9293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(516),
  [9295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [9297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1106),
  [9299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1106),
  [9301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1248),
  [9303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1248),
  [9305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3338),
  [9307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1249),
  [9309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1249),
  [9311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3340),
  [9313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1250),
  [9315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1250),
  [9317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3342),
  [9319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1251),
  [9321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1251),
  [9323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3344),
  [9325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1104),
  [9327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1104),
  [9329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1103),
  [9331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1103),
  [9333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(864),
  [9335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(864),
  [9337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3320),
  [9339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1102),
  [9341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1102),
  [9343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1101),
  [9345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1101),
  [9347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1100),
  [9349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1100),
  [9351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1099),
  [9353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1099),
  [9355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(513),
  [9357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [9359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3299),
  [9361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(512),
  [9363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [9365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3304),
  [9367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1254),
  [9369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1254),
  [9371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(511),
  [9373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [9375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3311),
  [9377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1255),
  [9379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1255),
  [9381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(510),
  [9383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(510),
  [9385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3323),
  [9387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1256),
  [9389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1256),
  [9391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(693),
  [9393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(693),
  [9395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1257),
  [9397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1257),
  [9399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2144),
  [9401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2144),
  [9403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3376),
  [9405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1098),
  [9407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1098),
  [9409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4005),
  [9411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(870),
  [9413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(870),
  [9415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(871),
  [9417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(871),
  [9419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3347),
  [9421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1258),
  [9423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1258),
  [9425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3382),
  [9427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1259),
  [9429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1259),
  [9431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3384),
  [9433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1260),
  [9435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1260),
  [9437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3386),
  [9439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1261),
  [9441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1261),
  [9443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3388),
  [9445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1262),
  [9447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1262),
  [9449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3390),
  [9451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1263),
  [9453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1263),
  [9455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3392),
  [9457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1267),
  [9459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1267),
  [9461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3394),
  [9463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1269),
  [9465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1269),
  [9467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3396),
  [9469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1271),
  [9471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1271),
  [9473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3398),
  [9475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1272),
  [9477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1272),
  [9479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3400),
  [9481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1273),
  [9483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1273),
  [9485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3402),
  [9487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1274),
  [9489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1274),
  [9491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3404),
  [9493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1275),
  [9495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1275),
  [9497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3406),
  [9499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4456),
  [9501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4456),
  [9503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(872),
  [9505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(872),
  [9507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(873),
  [9509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(873),
  [9511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3363),
  [9513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2142),
  [9515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2142),
  [9517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3381),
  [9519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2140),
  [9521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2140),
  [9523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3383),
  [9525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2138),
  [9527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2138),
  [9529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3407),
  [9531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(694),
  [9533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(694),
  [9535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(476),
  [9537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [9539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(491),
  [9541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [9543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3369),
  [9545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1801),
  [9547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1801),
  [9549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3171),
  [9551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(494),
  [9553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [9555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(493),
  [9557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [9559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3372),
  [9561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(696),
  [9563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(696),
  [9565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(677),
  [9567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [9569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3417),
  [9571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2055),
  [9573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2055),
  [9575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(483),
  [9577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [9579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(477),
  [9581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [9583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3377),
  [9585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(480),
  [9587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [9589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(486),
  [9591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [9593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3379),
  [9595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2012),
  [9597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2012),
  [9599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1277),
  [9601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1277),
  [9603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2030),
  [9605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2030),
  [9607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1278),
  [9609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1278),
  [9611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3515),
  [9613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1441),
  [9615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1441),
  [9617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1279),
  [9619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1279),
  [9621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1440),
  [9623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1440),
  [9625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1281),
  [9627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1281),
  [9629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1439),
  [9631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1439),
  [9633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1282),
  [9635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1282),
  [9637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1438),
  [9639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1438),
  [9641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1284),
  [9643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1284),
  [9645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1437),
  [9647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1437),
  [9649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1285),
  [9651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1285),
  [9653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1436),
  [9655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1436),
  [9657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1292),
  [9659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1292),
  [9661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1435),
  [9663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1435),
  [9665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1296),
  [9667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1296),
  [9669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1434),
  [9671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1434),
  [9673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1298),
  [9675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1298),
  [9677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1433),
  [9679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1433),
  [9681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1302),
  [9683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1302),
  [9685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1432),
  [9687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1432),
  [9689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1303),
  [9691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1303),
  [9693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1431),
  [9695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1431),
  [9697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1304),
  [9699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1304),
  [9701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2037),
  [9703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2037),
  [9705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1430),
  [9707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1430),
  [9709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(697),
  [9711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [9713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3612),
  [9715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(505),
  [9717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [9719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1429),
  [9721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1429),
  [9723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4389),
  [9725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4389),
  [9727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(503),
  [9729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [9731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3410),
  [9733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(504),
  [9735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [9737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(501),
  [9739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [9741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3414),
  [9743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(698),
  [9745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [9747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3613),
  [9749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(692),
  [9751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(692),
  [9753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2054),
  [9755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2054),
  [9757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3558),
  [9759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1800),
  [9761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1800),
  [9763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3168),
  [9765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(781),
  [9767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [9769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(782),
  [9771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(782),
  [9773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3420),
  [9775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(783),
  [9777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [9779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(784),
  [9781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [9783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3422),
  [9785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2092),
  [9787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2092),
  [9789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3559),
  [9791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2153),
  [9793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2153),
  [9795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3566),
  [9797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2141),
  [9799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2141),
  [9801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3567),
  [9803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2152),
  [9805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2152),
  [9807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3568),
  [9809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(532),
  [9811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [9813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(537),
  [9815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [9817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3428),
  [9819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(538),
  [9821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [9823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(542),
  [9825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [9827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3430),
  [9829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1412),
  [9831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1412),
  [9833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3385),
  [9835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2154),
  [9837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2154),
  [9839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3569),
  [9841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2157),
  [9843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2157),
  [9845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3585),
  [9847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2062),
  [9849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2062),
  [9851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3586),
  [9853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2049),
  [9855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2049),
  [9857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3593),
  [9859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(792),
  [9861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [9863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1410),
  [9865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1410),
  [9867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3387),
  [9869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1797),
  [9871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1797),
  [9873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3224),
  [9875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(793),
  [9877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(793),
  [9879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3437),
  [9881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(794),
  [9883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(794),
  [9885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1784),
  [9887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1784),
  [9889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3157),
  [9891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1408),
  [9893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1408),
  [9895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3389),
  [9897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1406),
  [9899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1406),
  [9901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3391),
  [9903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1719),
  [9905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1719),
  [9907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3114),
  [9909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1404),
  [9911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1404),
  [9913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3393),
  [9915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(795),
  [9917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(795),
  [9919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3441),
  [9921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2159),
  [9923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2159),
  [9925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3929),
  [9927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1402),
  [9929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1402),
  [9931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3395),
  [9933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1691),
  [9935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1691),
  [9937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3047),
  [9939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1682),
  [9941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1682),
  [9943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3030),
  [9945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1400),
  [9947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1400),
  [9949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3397),
  [9951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1398),
  [9953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1398),
  [9955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3399),
  [9957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1396),
  [9959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1396),
  [9961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3401),
  [9963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2006),
  [9965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2006),
  [9967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3623),
  [9969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1394),
  [9971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1394),
  [9973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3403),
  [9975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1392),
  [9977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1392),
  [9979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3405),
  [9981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1675),
  [9983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1675),
  [9985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3038),
  [9987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1390),
  [9989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1390),
  [9991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3408),
  [9993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1388),
  [9995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1388),
  [9997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3411),
  [9999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4385),
  [10001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4385),
  [10003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3510),
  [10005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1663),
  [10007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1663),
  [10009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3165),
  [10011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(798),
  [10013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(798),
  [10015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3476),
  [10017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(799),
  [10019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(799),
  [10021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3478),
  [10023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(800),
  [10025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(800),
  [10027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3480),
  [10029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(801),
  [10031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(801),
  [10033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3482),
  [10035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1996),
  [10037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1996),
  [10039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3639),
  [10041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4392),
  [10043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4392),
  [10045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1994),
  [10047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1994),
  [10049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3641),
  [10051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4393),
  [10053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4393),
  [10055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1385),
  [10057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1385),
  [10059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1661),
  [10061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1661),
  [10063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3060),
  [10065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1384),
  [10067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1384),
  [10069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1653),
  [10071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1653),
  [10073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3094),
  [10075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1383),
  [10077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1383),
  [10079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(806),
  [10081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(806),
  [10083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1382),
  [10085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1382),
  [10087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(808),
  [10089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(808),
  [10091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(495),
  [10093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [10095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(810),
  [10097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(810),
  [10099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(498),
  [10101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [10103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3479),
  [10105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(811),
  [10107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(811),
  [10109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4454),
  [10111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4454),
  [10113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(479),
  [10115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [10117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(488),
  [10119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [10121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3484),
  [10123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4395),
  [10125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4395),
  [10127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(814),
  [10129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(814),
  [10131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3520),
  [10133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(816),
  [10135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(816),
  [10137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3522),
  [10139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(817),
  [10141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(817),
  [10143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3524),
  [10145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(825),
  [10147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(825),
  [10149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3526),
  [10151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(826),
  [10153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(826),
  [10155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3528),
  [10157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(828),
  [10159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(828),
  [10161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3530),
  [10163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(829),
  [10165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(829),
  [10167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3532),
  [10169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(830),
  [10171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(830),
  [10173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3534),
  [10175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(832),
  [10177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(832),
  [10179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3536),
  [10181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(835),
  [10183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(835),
  [10185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3538),
  [10187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(836),
  [10189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(836),
  [10191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3540),
  [10193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(837),
  [10195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(837),
  [10197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3542),
  [10199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(838),
  [10201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(838),
  [10203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3544),
  [10205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(714),
  [10207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(714),
  [10209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3642),
  [10211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4397),
  [10213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4397),
  [10215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(715),
  [10217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(715),
  [10219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3644),
  [10221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4398),
  [10223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4398),
  [10225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(716),
  [10227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(716),
  [10229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3646),
  [10231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4399),
  [10233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4399),
  [10235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(717),
  [10237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(717),
  [10239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3648),
  [10241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1575),
  [10243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1575),
  [10245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3144),
  [10247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4409),
  [10249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4409),
  [10251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1159),
  [10253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1159),
  [10255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4402),
  [10257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4402),
  [10259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1151),
  [10261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1151),
  [10263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3509),
  [10265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1150),
  [10267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1150),
  [10269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4413),
  [10271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4413),
  [10273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1349),
  [10275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1349),
  [10277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3471),
  [10279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1347),
  [10281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1347),
  [10283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3473),
  [10285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1345),
  [10287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1345),
  [10289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3475),
  [10291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1343),
  [10293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1343),
  [10295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3477),
  [10297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4453),
  [10299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4453),
  [10301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1145),
  [10303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1145),
  [10305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3512),
  [10307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(841),
  [10309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(841),
  [10311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(718),
  [10313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(718),
  [10315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3656),
  [10317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(842),
  [10319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(842),
  [10321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4452),
  [10323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4452),
  [10325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(843),
  [10327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(843),
  [10329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3704),
  [10331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(858),
  [10333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [10335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(844),
  [10337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(844),
  [10339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(719),
  [10341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(719),
  [10343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3684),
  [10345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(861),
  [10347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [10349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(720),
  [10351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [10353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3686),
  [10355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(862),
  [10357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [10359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(712),
  [10361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(712),
  [10363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3621),
  [10365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(865),
  [10367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(865),
  [10369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1008),
  [10371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1008),
  [10373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(866),
  [10375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [10377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1000),
  [10379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1000),
  [10381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3533),
  [10383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(867),
  [10385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(867),
  [10387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(999),
  [10389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(999),
  [10391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(868),
  [10393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(868),
  [10395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4451),
  [10397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4451),
  [10399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3885),
  [10401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(869),
  [10403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(869),
  [10405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4447),
  [10407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4447),
  [10409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3893),
  [10411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(874),
  [10413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(874),
  [10415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4442),
  [10417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4442),
  [10419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3914),
  [10421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(875),
  [10423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(875),
  [10425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4416),
  [10427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4416),
  [10429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(994),
  [10431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(994),
  [10433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3537),
  [10435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(722),
  [10437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(722),
  [10439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3691),
  [10441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4417),
  [10443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4417),
  [10445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4444),
  [10447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4444),
  [10449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3950),
  [10451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(724),
  [10453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(724),
  [10455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3694),
  [10457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4438),
  [10459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4438),
  [10461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3959),
  [10463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4427),
  [10465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4427),
  [10467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1280),
  [10469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1280),
  [10471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1287),
  [10473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1287),
  [10475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3553),
  [10477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4463),
  [10479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4463),
  [10481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4033),
  [10483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1288),
  [10485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1288),
  [10487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1293),
  [10489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1293),
  [10491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3556),
  [10493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1911),
  [10495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1911),
  [10497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2052),
  [10499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2052),
  [10501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4374),
  [10503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4374),
  [10505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4382),
  [10507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4382),
  [10509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3560),
  [10511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4381),
  [10513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4381),
  [10515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4645),
  [10517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4645),
  [10519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3888),
  [10521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4380),
  [10523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4380),
  [10525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3562),
  [10527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4435),
  [10529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4435),
  [10531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3887),
  [10533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2066),
  [10535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2066),
  [10537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2068),
  [10539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2068),
  [10541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2070),
  [10543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2070),
  [10545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2073),
  [10547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2073),
  [10549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(788),
  [10551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(788),
  [10553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(787),
  [10555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(787),
  [10557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3570),
  [10559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(786),
  [10561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [10563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4428),
  [10565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4428),
  [10567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3412),
  [10569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4415),
  [10571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4415),
  [10573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3468),
  [10575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4407),
  [10577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4407),
  [10579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3470),
  [10581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4405),
  [10583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4405),
  [10585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3486),
  [10587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4404),
  [10589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4404),
  [10591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3501),
  [10593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4403),
  [10595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4403),
  [10597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3503),
  [10599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(785),
  [10601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(785),
  [10603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3572),
  [10605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1667),
  [10607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1667),
  [10609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4391),
  [10611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4391),
  [10613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3505),
  [10615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4388),
  [10617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4388),
  [10619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3508),
  [10621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(845),
  [10623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [10625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(846),
  [10627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [10629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2079),
  [10631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2079),
  [10633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2081),
  [10635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2081),
  [10637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(847),
  [10639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(847),
  [10641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1568),
  [10643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1568),
  [10645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(848),
  [10647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(848),
  [10649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(849),
  [10651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(849),
  [10653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(850),
  [10655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(850),
  [10657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(851),
  [10659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(851),
  [10661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2082),
  [10663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2082),
  [10665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(852),
  [10667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(852),
  [10669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(853),
  [10671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [10673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1567),
  [10675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1567),
  [10677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(854),
  [10679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(854),
  [10681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(855),
  [10683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(855),
  [10685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1970),
  [10687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1970),
  [10689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3647),
  [10691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(857),
  [10693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(857),
  [10695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1227),
  [10697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1227),
  [10699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3614),
  [10701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1225),
  [10703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1225),
  [10705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3616),
  [10707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1224),
  [10709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1224),
  [10711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3618),
  [10713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1223),
  [10715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1223),
  [10717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3620),
  [10719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4410),
  [10721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4410),
  [10723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3513),
  [10725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4430),
  [10727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4430),
  [10729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3545),
  [10731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4387),
  [10733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4387),
  [10735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3552),
  [10737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1964),
  [10739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1964),
  [10741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3649),
  [10743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1960),
  [10745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1960),
  [10747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3683),
  [10749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1556),
  [10751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1556),
  [10753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1936),
  [10755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1936),
  [10757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3685),
  [10759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(731),
  [10761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [10763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(733),
  [10765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(733),
  [10767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1215),
  [10769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1215),
  [10771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4575),
  [10773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4575),
  [10775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3801),
  [10777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1214),
  [10779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1214),
  [10781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4460),
  [10783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4460),
  [10785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3723),
  [10787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1212),
  [10789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1212),
  [10791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4390),
  [10793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4390),
  [10795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1211),
  [10797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1211),
  [10799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(735),
  [10801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(735),
  [10803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4394),
  [10805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4394),
  [10807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2096),
  [10809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2096),
  [10811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4396),
  [10813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4396),
  [10815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1210),
  [10817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1210),
  [10819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3658),
  [10821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1209),
  [10823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1209),
  [10825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3660),
  [10827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1208),
  [10829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1208),
  [10831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3662),
  [10833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1207),
  [10835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1207),
  [10837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3664),
  [10839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1206),
  [10841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1206),
  [10843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3666),
  [10845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1205),
  [10847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1205),
  [10849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3668),
  [10851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1204),
  [10853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1204),
  [10855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3670),
  [10857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1203),
  [10859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1203),
  [10861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3672),
  [10863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1202),
  [10865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1202),
  [10867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3674),
  [10869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1201),
  [10871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1201),
  [10873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3676),
  [10875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1200),
  [10877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1200),
  [10879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3678),
  [10881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1199),
  [10883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1199),
  [10885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3680),
  [10887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1198),
  [10889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1198),
  [10891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3682),
  [10893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4549),
  [10895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4549),
  [10897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3717),
  [10899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2109),
  [10901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2109),
  [10903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4384),
  [10905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4384),
  [10907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2110),
  [10909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2110),
  [10911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(737),
  [10913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(737),
  [10915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3681),
  [10917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1887),
  [10919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1887),
  [10921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4002),
  [10923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(739),
  [10925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(739),
  [10927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4550),
  [10929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4550),
  [10931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3699),
  [10933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(741),
  [10935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(741),
  [10937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2147),
  [10939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2147),
  [10941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(743),
  [10943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(743),
  [10945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2139),
  [10947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2139),
  [10949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4418),
  [10951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4418),
  [10953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3619),
  [10955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4420),
  [10957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4420),
  [10959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3622),
  [10961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4422),
  [10963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4422),
  [10965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3624),
  [10967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4423),
  [10969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4423),
  [10971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3640),
  [10973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(879),
  [10975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(879),
  [10977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3583),
  [10979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1879),
  [10981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1879),
  [10983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3846),
  [10985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(750),
  [10987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [10989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(880),
  [10991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(880),
  [10993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3584),
  [10995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1187),
  [10997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1187),
  [10999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(882),
  [11001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [11003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3587),
  [11005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1185),
  [11007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1185),
  [11009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(884),
  [11011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(884),
  [11013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3589),
  [11015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1184),
  [11017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1184),
  [11019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(885),
  [11021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(885),
  [11023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3590),
  [11025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1183),
  [11027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1183),
  [11029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(887),
  [11031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(887),
  [11033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3591),
  [11035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1179),
  [11037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1179),
  [11039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(889),
  [11041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(889),
  [11043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3592),
  [11045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1178),
  [11047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1178),
  [11049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(891),
  [11051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(891),
  [11053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3594),
  [11055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1177),
  [11057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1177),
  [11059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(893),
  [11061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [11063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3595),
  [11065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1176),
  [11067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1176),
  [11069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(895),
  [11071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(895),
  [11073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3597),
  [11075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1175),
  [11077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1175),
  [11079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(897),
  [11081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(897),
  [11083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3598),
  [11085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1174),
  [11087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1174),
  [11089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(899),
  [11091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(899),
  [11093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3600),
  [11095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1173),
  [11097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1173),
  [11099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(900),
  [11101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(900),
  [11103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3525),
  [11105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1169),
  [11107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1169),
  [11109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1865),
  [11111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1865),
  [11113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3852),
  [11115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1166),
  [11117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1166),
  [11119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2137),
  [11121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2137),
  [11123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(751),
  [11125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(751),
  [11127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2136),
  [11129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2136),
  [11131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(752),
  [11133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(752),
  [11135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(901),
  [11137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(901),
  [11139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1848),
  [11141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1848),
  [11143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3899),
  [11145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(902),
  [11147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(902),
  [11149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(721),
  [11151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [11153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3988),
  [11155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(755),
  [11157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [11159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3984),
  [11161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(699),
  [11163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(699),
  [11165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(904),
  [11167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(904),
  [11169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(756),
  [11171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(756),
  [11173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(700),
  [11175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [11177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(905),
  [11179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(905),
  [11181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2135),
  [11183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2135),
  [11185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3980),
  [11187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2128),
  [11189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2128),
  [11191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4056),
  [11193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4598),
  [11195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4598),
  [11197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(701),
  [11199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(701),
  [11201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(702),
  [11203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(702),
  [11205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1893),
  [11207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1893),
  [11209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3738),
  [11211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(908),
  [11213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(908),
  [11215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3687),
  [11217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(909),
  [11219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(909),
  [11221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3689),
  [11223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(910),
  [11225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(910),
  [11227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3693),
  [11229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(911),
  [11231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(911),
  [11233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3696),
  [11235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(703),
  [11237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(703),
  [11239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2127),
  [11241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2127),
  [11243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4085),
  [11245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2126),
  [11247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2126),
  [11249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4081),
  [11251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1626),
  [11253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1626),
  [11255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3963),
  [11257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1899),
  [11259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1899),
  [11261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3750),
  [11263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1897),
  [11265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1897),
  [11267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3732),
  [11269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1896),
  [11271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1896),
  [11273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3736),
  [11275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(704),
  [11277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(704),
  [11279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1041),
  [11281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1041),
  [11283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1676),
  [11285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1676),
  [11287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4597),
  [11289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4597),
  [11291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1678),
  [11293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1678),
  [11295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2125),
  [11297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2125),
  [11299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4077),
  [11301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1918),
  [11303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1918),
  [11305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4073),
  [11307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1413),
  [11309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1413),
  [11311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3580),
  [11313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2120),
  [11315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2120),
  [11317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4069),
  [11319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4596),
  [11321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4596),
  [11323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2119),
  [11325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2119),
  [11327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4026),
  [11329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1081),
  [11331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1081),
  [11333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1422),
  [11335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1422),
  [11337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3588),
  [11339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1535),
  [11341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1535),
  [11343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3596),
  [11345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1988),
  [11347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1988),
  [11349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4062),
  [11351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(705),
  [11353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(705),
  [11355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1978),
  [11357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1978),
  [11359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4057),
  [11361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1976),
  [11363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1976),
  [11365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4030),
  [11367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1861),
  [11369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1861),
  [11371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1080),
  [11373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1080),
  [11375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1553),
  [11377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1553),
  [11379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3610),
  [11381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1956),
  [11383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1956),
  [11385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3780),
  [11387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1860),
  [11389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1860),
  [11391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1078),
  [11393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1078),
  [11395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1858),
  [11397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1858),
  [11399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(914),
  [11401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(914),
  [11403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3752),
  [11405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(915),
  [11407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(915),
  [11409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3754),
  [11411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(916),
  [11413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(916),
  [11415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3756),
  [11417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(918),
  [11419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(918),
  [11421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3758),
  [11423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1938),
  [11425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1938),
  [11427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3936),
  [11429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1077),
  [11431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1077),
  [11433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1073),
  [11435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1073),
  [11437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1067),
  [11439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1067),
  [11441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1066),
  [11443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1066),
  [11445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4446),
  [11447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4446),
  [11449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3833),
  [11451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1065),
  [11453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1065),
  [11455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1862),
  [11457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1862),
  [11459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1064),
  [11461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1064),
  [11463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(923),
  [11465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(923),
  [11467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1855),
  [11469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1855),
  [11471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3866),
  [11473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(924),
  [11475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(924),
  [11477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1063),
  [11479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1063),
  [11481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(925),
  [11483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(925),
  [11485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1853),
  [11487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1853),
  [11489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3868),
  [11491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(926),
  [11493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(926),
  [11495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2122),
  [11497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2122),
  [11499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2046),
  [11501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2046),
  [11503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1062),
  [11505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1062),
  [11507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1851),
  [11509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1851),
  [11511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3870),
  [11513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(927),
  [11515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(927),
  [11517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3796),
  [11519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(928),
  [11521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(928),
  [11523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3798),
  [11525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(929),
  [11527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(929),
  [11529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3800),
  [11531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(930),
  [11533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(930),
  [11535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3802),
  [11537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(931),
  [11539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(931),
  [11541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3804),
  [11543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(932),
  [11545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(932),
  [11547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3806),
  [11549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(933),
  [11551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(933),
  [11553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3808),
  [11555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(934),
  [11557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(934),
  [11559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3810),
  [11561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(936),
  [11563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(936),
  [11565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3812),
  [11567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(937),
  [11569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(937),
  [11571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3814),
  [11573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(938),
  [11575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(938),
  [11577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3816),
  [11579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(939),
  [11581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(939),
  [11583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3818),
  [11585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(940),
  [11587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(940),
  [11589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3820),
  [11591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2045),
  [11593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2045),
  [11595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1060),
  [11597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1060),
  [11599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1849),
  [11601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1849),
  [11603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3881),
  [11605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1059),
  [11607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1059),
  [11609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2044),
  [11611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2044),
  [11613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1847),
  [11615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1847),
  [11617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3844),
  [11619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1845),
  [11621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1845),
  [11623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3900),
  [11625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2040),
  [11627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2040),
  [11629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2035),
  [11631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2035),
  [11633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2047),
  [11635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2047),
  [11637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1844),
  [11639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1844),
  [11641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3917),
  [11643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1843),
  [11645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1843),
  [11647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3918),
  [11649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2029),
  [11651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2029),
  [11653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2028),
  [11655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2028),
  [11657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2025),
  [11659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2025),
  [11661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2023),
  [11663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2023),
  [11665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2020),
  [11667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2020),
  [11669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2010),
  [11671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2010),
  [11673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1842),
  [11675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1842),
  [11677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3919),
  [11679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1841),
  [11681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1841),
  [11683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3922),
  [11685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(942),
  [11687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(942),
  [11689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1840),
  [11691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1840),
  [11693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3924),
  [11695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(943),
  [11697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(943),
  [11699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1057),
  [11701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1057),
  [11703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3725),
  [11705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(944),
  [11707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(944),
  [11709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4588),
  [11711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4588),
  [11713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(945),
  [11715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(945),
  [11717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(706),
  [11719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(706),
  [11721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(946),
  [11723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(946),
  [11725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1056),
  [11727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1056),
  [11729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3733),
  [11731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(947),
  [11733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(947),
  [11735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1055),
  [11737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1055),
  [11739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3737),
  [11741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(948),
  [11743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(948),
  [11745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(707),
  [11747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(707),
  [11749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(673),
  [11751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(673),
  [11753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1054),
  [11755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1054),
  [11757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3744),
  [11759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(967),
  [11761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(967),
  [11763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1053),
  [11765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1053),
  [11767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3745),
  [11769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(966),
  [11771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(966),
  [11773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1052),
  [11775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1052),
  [11777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3746),
  [11779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(965),
  [11781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(965),
  [11783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1051),
  [11785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1051),
  [11787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3747),
  [11789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(964),
  [11791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(964),
  [11793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1050),
  [11795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1050),
  [11797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3749),
  [11799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(963),
  [11801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(963),
  [11803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1049),
  [11805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1049),
  [11807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3751),
  [11809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1048),
  [11811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1048),
  [11813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3755),
  [11815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1047),
  [11817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1047),
  [11819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3761),
  [11821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1046),
  [11823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1046),
  [11825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3777),
  [11827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1972),
  [11829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1972),
  [11831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3759),
  [11833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1045),
  [11835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1045),
  [11837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3779),
  [11839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1967),
  [11841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1967),
  [11843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3760),
  [11845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1044),
  [11847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1044),
  [11849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1043),
  [11851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1043),
  [11853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1680),
  [11855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1680),
  [11857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1957),
  [11859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1957),
  [11861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3776),
  [11863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1042),
  [11865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1042),
  [11867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4582),
  [11869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4582),
  [11871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2164),
  [11873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2164),
  [11875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3891),
  [11877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1954),
  [11879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1954),
  [11881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3783),
  [11883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1948),
  [11885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1948),
  [11887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3784),
  [11889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2032),
  [11891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2032),
  [11893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3785),
  [11895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1944),
  [11897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1944),
  [11899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3788),
  [11901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1910),
  [11903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1910),
  [11905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3789),
  [11907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1939),
  [11909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1939),
  [11911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3790),
  [11913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1937),
  [11915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1937),
  [11917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3791),
  [11919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1935),
  [11921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1935),
  [11923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3792),
  [11925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1942),
  [11927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1942),
  [11929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3793),
  [11931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1827),
  [11933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1827),
  [11935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1725),
  [11937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1725),
  [11939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1358),
  [11941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1358),
  [11943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1038),
  [11945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1038),
  [11947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3828),
  [11949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1037),
  [11951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1037),
  [11953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3829),
  [11955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1036),
  [11957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1036),
  [11959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3832),
  [11961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1035),
  [11963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1035),
  [11965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3715),
  [11967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1835),
  [11969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1835),
  [11971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1391),
  [11973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1391),
  [11975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2069),
  [11977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2069),
  [11979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1913),
  [11981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1913),
  [11983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2160),
  [11985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2160),
  [11987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3895),
  [11989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1914),
  [11991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1914),
  [11993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1915),
  [11995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1915),
  [11997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2158),
  [11999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2158),
  [12001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3898),
  [12003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(708),
  [12005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(708),
  [12007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(709),
  [12009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(709),
  [12011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2151),
  [12013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2151),
  [12015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3916),
  [12017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(775),
  [12019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(775),
  [12021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2091),
  [12023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2091),
  [12025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1834),
  [12027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1834),
  [12029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(710),
  [12031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [12033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1832),
  [12035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1832),
  [12037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(711),
  [12039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(711),
  [12041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1831),
  [12043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1831),
  [12045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(776),
  [12047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [12049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3862),
  [12051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1830),
  [12053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1830),
  [12055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1961),
  [12057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1961),
  [12059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3853),
  [12061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(777),
  [12063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(777),
  [12065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1963),
  [12067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1963),
  [12069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3854),
  [12071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1971),
  [12073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1971),
  [12075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3856),
  [12077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1974),
  [12079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1974),
  [12081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3857),
  [12083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1766),
  [12085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1766),
  [12087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(565),
  [12089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(565),
  [12091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3890),
  [12093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(566),
  [12095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [12097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3892),
  [12099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(567),
  [12101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [12103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3894),
  [12105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(568),
  [12107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(568),
  [12109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3896),
  [12111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1828),
  [12113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1828),
  [12115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(772),
  [12117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(772),
  [12119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3992),
  [12121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(779),
  [12123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(779),
  [12125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3872),
  [12127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1773),
  [12129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1773),
  [12131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4559),
  [12133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4559),
  [12135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1903),
  [12137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1903),
  [12139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3716),
  [12141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4581),
  [12143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4581),
  [12145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4580),
  [12147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4580),
  [12149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1030),
  [12151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1030),
  [12153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(571),
  [12155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [12157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1919),
  [12159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1919),
  [12161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(572),
  [12163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [12165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4565),
  [12167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4565),
  [12169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(573),
  [12171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(573),
  [12173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1953),
  [12175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1953),
  [12177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(574),
  [12179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [12181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1884),
  [12183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1884),
  [12185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3718),
  [12187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1921),
  [12189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1921),
  [12191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1837),
  [12193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1837),
  [12195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1823),
  [12197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1823),
  [12199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(576),
  [12201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(576),
  [12203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3933),
  [12205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(577),
  [12207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [12209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3935),
  [12211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(578),
  [12213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(578),
  [12215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3937),
  [12217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(579),
  [12219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [12221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3939),
  [12223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(580),
  [12225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [12227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3941),
  [12229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(581),
  [12231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(581),
  [12233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3943),
  [12235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(582),
  [12237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(582),
  [12239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3945),
  [12241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(583),
  [12243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [12245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3947),
  [12247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(584),
  [12249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(584),
  [12251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3949),
  [12253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(585),
  [12255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(585),
  [12257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3951),
  [12259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(586),
  [12261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(586),
  [12263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3953),
  [12265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(587),
  [12267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(587),
  [12269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3955),
  [12271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(588),
  [12273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(588),
  [12275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3957),
  [12277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4571),
  [12279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4571),
  [12281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1883),
  [12283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1883),
  [12285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3830),
  [12287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1922),
  [12289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1922),
  [12291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1821),
  [12293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1821),
  [12295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1814),
  [12297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1814),
  [12299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1803),
  [12301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1803),
  [12303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1900),
  [12305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1900),
  [12307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3845),
  [12309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1792),
  [12311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1792),
  [12313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3928),
  [12315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1802),
  [12317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1802),
  [12319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(723),
  [12321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(723),
  [12323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3692),
  [12325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1798),
  [12327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1798),
  [12329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(725),
  [12331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(725),
  [12333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3695),
  [12335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1004),
  [12337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1004),
  [12339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3889),
  [12341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1001),
  [12343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1001),
  [12345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1727),
  [12347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1727),
  [12349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2083),
  [12351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2083),
  [12353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1580),
  [12355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1580),
  [12357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3884),
  [12359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1857),
  [12361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1857),
  [12363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3851),
  [12365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1730),
  [12367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1730),
  [12369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(590),
  [12371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [12373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(726),
  [12375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(726),
  [12377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3700),
  [12379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(500),
  [12381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [12383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2156),
  [12385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2156),
  [12387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(591),
  [12389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(591),
  [12391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(727),
  [12393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(727),
  [12395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3701),
  [12397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(592),
  [12399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(592),
  [12401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1020),
  [12403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1020),
  [12405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(593),
  [12407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(593),
  [12409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1751),
  [12411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1751),
  [12413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(594),
  [12415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(594),
  [12417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1019),
  [12419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1019),
  [12421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(595),
  [12423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(595),
  [12425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1752),
  [12427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1752),
  [12429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(596),
  [12431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(596),
  [12433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1018),
  [12435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1018),
  [12437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(597),
  [12439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(597),
  [12441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4572),
  [12443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4572),
  [12445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(598),
  [12447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(598),
  [12449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(728),
  [12451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [12453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3707),
  [12455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(600),
  [12457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(600),
  [12459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1926),
  [12461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1926),
  [12463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4018),
  [12465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(601),
  [12467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(601),
  [12469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1017),
  [12471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1017),
  [12473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(602),
  [12475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(602),
  [12477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2071),
  [12479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2071),
  [12481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4016),
  [12483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4573),
  [12485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4573),
  [12487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1016),
  [12489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1016),
  [12491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1756),
  [12493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1756),
  [12495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1015),
  [12497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1015),
  [12499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1636),
  [12501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1636),
  [12503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1014),
  [12505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1014),
  [12507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1930),
  [12509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1930),
  [12511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4010),
  [12513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1013),
  [12515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1013),
  [12517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1759),
  [12519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1759),
  [12521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1012),
  [12523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1012),
  [12525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(773),
  [12527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(773),
  [12529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3991),
  [12531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1011),
  [12533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1011),
  [12535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(976),
  [12537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(976),
  [12539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4063),
  [12541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2077),
  [12543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2077),
  [12545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2078),
  [12547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2078),
  [12549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2080),
  [12551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2080),
  [12553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1955),
  [12555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1955),
  [12557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2089),
  [12559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2089),
  [12561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1785),
  [12563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1785),
  [12565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3932),
  [12567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(730),
  [12569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [12571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3714),
  [12573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1932),
  [12575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1932),
  [12577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4003),
  [12579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2063),
  [12581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2063),
  [12583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(991),
  [12585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(991),
  [12587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3927),
  [12589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(732),
  [12591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(732),
  [12593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3729),
  [12595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1010),
  [12597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1010),
  [12599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(771),
  [12601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(771),
  [12603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3993),
  [12605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1009),
  [12607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1009),
  [12609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(769),
  [12611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(769),
  [12613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3994),
  [12615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1007),
  [12617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1007),
  [12619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(754),
  [12621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(754),
  [12623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4455),
  [12625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4455),
  [12627] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_with_default, 2, 0, 12),
  [12629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1774),
  [12631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1774),
  [12633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3942),
  [12635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(748),
  [12637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(748),
  [12639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(747),
  [12641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(747),
  [12643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(746),
  [12645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(746),
  [12647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(745),
  [12649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [12651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2093),
  [12653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2093),
  [12655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1945),
  [12657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1945),
  [12659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4001),
  [12661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(977),
  [12663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(977),
  [12665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4059),
  [12667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1617),
  [12669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1617),
  [12671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3876),
  [12673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2095),
  [12675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2095),
  [12677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1621),
  [12679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1621),
  [12681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3967),
  [12683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2100),
  [12685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2100),
  [12687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1356),
  [12689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1356),
  [12691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2101),
  [12693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2101),
  [12695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1949),
  [12697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1949),
  [12699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3999),
  [12701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(978),
  [12703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(978),
  [12705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4055),
  [12707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(979),
  [12709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(979),
  [12711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4053),
  [12713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1951),
  [12715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1951),
  [12717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3995),
  [12719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1726),
  [12721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1726),
  [12723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3946),
  [12725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(652),
  [12727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(652),
  [12729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2102),
  [12731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2102),
  [12733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(744),
  [12735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [12737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3867),
  [12739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(616),
  [12741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(616),
  [12743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4025),
  [12745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(617),
  [12747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(617),
  [12749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4027),
  [12751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(618),
  [12753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(618),
  [12755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4029),
  [12757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(619),
  [12759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(619),
  [12761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4031),
  [12763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2103),
  [12765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2103),
  [12767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1005),
  [12769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1005),
  [12771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3940),
  [12773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2104),
  [12775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2104),
  [12777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1003),
  [12779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1003),
  [12781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3944),
  [12783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1002),
  [12785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1002),
  [12787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3948),
  [12789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(998),
  [12791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(998),
  [12793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3956),
  [12795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2108),
  [12797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2108),
  [12799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3863),
  [12801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(997),
  [12803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(997),
  [12805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3960),
  [12807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(996),
  [12809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(996),
  [12811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3962),
  [12813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(622),
  [12815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(622),
  [12817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1959),
  [12819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1959),
  [12821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(623),
  [12823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(623),
  [12825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(995),
  [12827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(995),
  [12829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3964),
  [12831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(624),
  [12833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(624),
  [12835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2002),
  [12837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2002),
  [12839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(625),
  [12841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(625),
  [12843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(651),
  [12845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(651),
  [12847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4578),
  [12849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4578),
  [12851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(992),
  [12853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(992),
  [12855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3966),
  [12857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(990),
  [12859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(990),
  [12861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3968),
  [12863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(626),
  [12865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(626),
  [12867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4068),
  [12869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(627),
  [12871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(627),
  [12873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4070),
  [12875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(628),
  [12877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(628),
  [12879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4072),
  [12881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(629),
  [12883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(629),
  [12885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4074),
  [12887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(630),
  [12889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(630),
  [12891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4076),
  [12893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(631),
  [12895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(631),
  [12897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4078),
  [12899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(632),
  [12901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(632),
  [12903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4080),
  [12905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(633),
  [12907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(633),
  [12909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4082),
  [12911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(634),
  [12913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(634),
  [12915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4084),
  [12917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(635),
  [12919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(635),
  [12921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4086),
  [12923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(636),
  [12925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(636),
  [12927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4088),
  [12929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(637),
  [12931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(637),
  [12933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4032),
  [12935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(638),
  [12937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(638),
  [12939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4009),
  [12941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(989),
  [12943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(989),
  [12945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3970),
  [12947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(988),
  [12949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(988),
  [12951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3983),
  [12953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(987),
  [12955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(987),
  [12957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3985),
  [12959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(986),
  [12961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(986),
  [12963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3987),
  [12965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(985),
  [12967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(985),
  [12969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(742),
  [12971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [12973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3865),
  [12975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(984),
  [12977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(984),
  [12979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2005),
  [12981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2005),
  [12983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1998),
  [12985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1998),
  [12987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(740),
  [12989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(740),
  [12991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3860),
  [12993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(983),
  [12995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(983),
  [12997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2085),
  [12999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2085),
  [13001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(738),
  [13003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(738),
  [13005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3859),
  [13007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1958),
  [13009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1958),
  [13011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(982),
  [13013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(982),
  [13015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1980),
  [13017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1980),
  [13019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4060),
  [13021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(736),
  [13023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(736),
  [13025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3809),
  [13027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1670),
  [13029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1670),
  [13031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3961),
  [13033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(734),
  [13035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [13037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3803),
  [13039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(640),
  [13041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [13043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1975),
  [13045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1975),
  [13047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(641),
  [13049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [13051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1989),
  [13053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1989),
  [13055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3972),
  [13057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(642),
  [13059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [13061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1986),
  [13063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1986),
  [13065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(643),
  [13067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(643),
  [13069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1993),
  [13071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1993),
  [13073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3973),
  [13075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(644),
  [13077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(644),
  [13079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1991),
  [13081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1991),
  [13083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(645),
  [13085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [13087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1997),
  [13089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1997),
  [13091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3974),
  [13093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(646),
  [13095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [13097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1995),
  [13099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1995),
  [13101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(647),
  [13103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(647),
  [13105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2003),
  [13107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2003),
  [13109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3975),
  [13111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(648),
  [13113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(648),
  [13115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2001),
  [13117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2001),
  [13119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(649),
  [13121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(649),
  [13123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2007),
  [13125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2007),
  [13127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3976),
  [13129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(650),
  [13131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(650),
  [13133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4629),
  [13135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4629),
  [13137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(767),
  [13139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(767),
  [13141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4462),
  [13143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4462),
  [13145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1308),
  [13147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1308),
  [13149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4470),
  [13151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4470),
  [13153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4471),
  [13155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4471),
  [13157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4472),
  [13159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4472),
  [13161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4473),
  [13163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4473),
  [13165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(613),
  [13167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [13169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(610),
  [13171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(610),
  [13173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(609),
  [13175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(609),
  [13177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(606),
  [13179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(606),
  [13181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4474),
  [13183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4474),
  [13185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4475),
  [13187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4475),
  [13189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4476),
  [13191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4476),
  [13193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4440),
  [13195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4440),
  [13197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4477),
  [13199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4477),
  [13201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4481),
  [13203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4481),
  [13205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4483),
  [13207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4483),
  [13209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4484),
  [13211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4484),
  [13213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1624),
  [13215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1624),
  [13217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1655),
  [13219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1655),
  [13221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4487),
  [13223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4487),
  [13225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1656),
  [13227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1656),
  [13229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1717),
  [13231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1717),
  [13233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4437),
  [13235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4437),
  [13237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4488),
  [13239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4488),
  [13241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4490),
  [13243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4490),
  [13245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4491),
  [13247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4491),
  [13249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4556),
  [13251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4556),
  [13253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4495),
  [13255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4495),
  [13257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4496),
  [13259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4496),
  [13261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4497),
  [13263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4497),
  [13265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4498),
  [13267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4498),
  [13269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4436),
  [13271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4436),
  [13273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4499),
  [13275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4499),
  [13277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(656),
  [13279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(656),
  [13281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4443),
  [13283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4443),
  [13285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4500),
  [13287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4500),
  [13289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4501),
  [13291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4501),
  [13293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4502),
  [13295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4502),
  [13297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4504),
  [13299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4504),
  [13301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(659),
  [13303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(659),
  [13305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(660),
  [13307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(660),
  [13309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4505),
  [13311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4505),
  [13313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4506),
  [13315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4506),
  [13317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1024),
  [13319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1024),
  [13321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(764),
  [13323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(764),
  [13325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1027),
  [13327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1027),
  [13329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(763),
  [13331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(763),
  [13333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(663),
  [13335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(663),
  [13337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1554),
  [13339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1554),
  [13341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2051),
  [13343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2051),
  [13345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4507),
  [13347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4507),
  [13349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(760),
  [13351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(760),
  [13353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2011),
  [13355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2011),
  [13357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2024),
  [13359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2024),
  [13361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4511),
  [13363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4511),
  [13365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4512),
  [13367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4512),
  [13369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4513),
  [13371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4513),
  [13373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4515),
  [13375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4515),
  [13377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4516),
  [13379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4516),
  [13381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4520),
  [13383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4520),
  [13385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2022),
  [13387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2022),
  [13389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4521),
  [13391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4521),
  [13393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4610),
  [13395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4610),
  [13397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4522),
  [13399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4522),
  [13401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4523),
  [13403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4523),
  [13405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4524),
  [13407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4524),
  [13409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4526),
  [13411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4526),
  [13413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2014),
  [13415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2014),
  [13417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4622),
  [13419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4622),
  [13421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4527),
  [13423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4527),
  [13425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4638),
  [13427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4638),
  [13429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4528),
  [13431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4528),
  [13433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1965),
  [13435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1965),
  [13437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(952),
  [13439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(952),
  [13441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4635),
  [13443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4635),
  [13445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1032),
  [13447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1032),
  [13449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1962),
  [13451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1962),
  [13453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(955),
  [13455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(955),
  [13457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(956),
  [13459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(956),
  [13461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4529),
  [13463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4529),
  [13465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4530),
  [13467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4530),
  [13469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4532),
  [13471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4532),
  [13473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(959),
  [13475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(959),
  [13477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4533),
  [13479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4533),
  [13481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4534),
  [13483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4534),
  [13485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4535),
  [13487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4535),
  [13489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4536),
  [13491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4536),
  [13493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4537),
  [13495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4537),
  [13497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2134),
  [13499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2134),
  [13501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4538),
  [13503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4538),
  [13505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4541),
  [13507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4541),
  [13509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4546),
  [13511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4546),
  [13513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1141),
  [13515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1141),
  [13517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1673),
  [13519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1673),
  [13521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1671),
  [13523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1671),
  [13525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1665),
  [13527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1665),
  [13529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2130),
  [13531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2130),
  [13533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1768),
  [13535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1768),
  [13537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4561),
  [13539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4561),
  [13541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1311),
  [13543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1311),
  [13545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4562),
  [13547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4562),
  [13549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4557),
  [13551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4557),
  [13553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1312),
  [13555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1312),
  [13557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4563),
  [13559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4563),
  [13561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1313),
  [13563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1313),
  [13565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4566),
  [13567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4566),
  [13569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2084),
  [13571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2084),
  [13573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1144),
  [13575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1144),
  [13577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2129),
  [13579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2129),
  [13581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1147),
  [13583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1147),
  [13585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1760),
  [13587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1760),
  [13589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2117),
  [13591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2117),
  [13593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2088),
  [13595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2088),
  [13597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2094),
  [13599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2094),
  [13601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4574),
  [13603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4574),
  [13605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1155),
  [13607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1155),
  [13609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1769),
  [13611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1769),
  [13613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2106),
  [13615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2106),
  [13617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1069),
  [13619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1069),
  [13621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1320),
  [13623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1320),
  [13625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1074),
  [13627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1074),
  [13629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4509),
  [13631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4509),
  [13633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1075),
  [13635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1075),
  [13637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4576),
  [13639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4576),
  [13641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4577),
  [13643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4577),
  [13645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4579),
  [13647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4579),
  [13649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1153),
  [13651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1153),
  [13653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1983),
  [13655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1983),
  [13657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4583),
  [13659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4583),
  [13661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1160),
  [13663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1160),
  [13665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4584),
  [13667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4584),
  [13669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1091),
  [13671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1091),
  [13673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1162),
  [13675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1162),
  [13677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4585),
  [13679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4585),
  [13681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1093),
  [13683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1093),
  [13685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4591),
  [13687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4591),
  [13689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4599),
  [13691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4599),
  [13693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1579),
  [13695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1579),
  [13697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4560),
  [13699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4560),
  [13701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1083),
  [13703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1083),
  [13705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1165),
  [13707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1165),
  [13709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1096),
  [13711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1096),
  [13713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4600),
  [13715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4600),
  [13717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4601),
  [13719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4601),
  [13721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4602),
  [13723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4602),
  [13725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1489),
  [13727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1489),
  [13729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4603),
  [13731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4603),
  [13733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1572),
  [13735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1572),
  [13737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1487),
  [13739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1487),
  [13741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4508),
  [13743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4508),
  [13745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4510),
  [13747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4510),
  [13749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4525),
  [13751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4525),
  [13753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4555),
  [13755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4555),
  [13757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4439),
  [13759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4439),
  [13761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4607),
  [13763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4607),
  [13765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(562),
  [13767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(562),
  [13769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4608),
  [13771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4608),
  [13773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4441),
  [13775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4441),
  [13777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4609),
  [13779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4609),
  [13781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4482),
  [13783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4482),
  [13785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1564),
  [13787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1564),
  [13789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4613),
  [13791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4613),
  [13793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1562),
  [13795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1562),
  [13797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(687),
  [13799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(687),
  [13801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4616),
  [13803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4616),
  [13805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(559),
  [13807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(559),
  [13809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4620),
  [13811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4620),
  [13813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4621),
  [13815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4621),
  [13817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(558),
  [13819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [13821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4466),
  [13823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4466),
  [13825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4461),
  [13827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4461),
  [13829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1028),
  [13831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1028),
  [13833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4630),
  [13835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4630),
  [13837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1088),
  [13839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1088),
  [13841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4631),
  [13843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4631),
  [13845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4633),
  [13847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4633),
  [13849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4646),
  [13851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4646),
  [13853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(555),
  [13855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [13857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4647),
  [13859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4647),
  [13861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4595),
  [13863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4595),
  [13865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4648),
  [13867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4648),
  [13869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4480),
  [13871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4480),
  [13873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(896),
  [13875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(896),
  [13877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(890),
  [13879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(890),
  [13881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(888),
  [13883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(888),
  [13885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4551),
  [13887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4551),
  [13889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(881),
  [13891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(881),
  [13893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4554),
  [13895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4554),
  [13897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(813),
  [13899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(813),
  [13901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4649),
  [13903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4649),
  [13905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4570),
  [13907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4570),
  [13909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4434),
  [13911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4434),
  [13913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4644),
  [13915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4644),
  [13917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1681),
  [13919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1681),
  [13921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4643),
  [13923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4643),
  [13925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4642),
  [13927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4642),
  [13929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4586),
  [13931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4586),
  [13933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4478),
  [13935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4478),
  [13937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4639),
  [13939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4639),
  [13941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4619),
  [13943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4619),
  [13945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4618),
  [13947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4618),
  [13949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1854),
  [13951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1854),
  [13953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4617),
  [13955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4617),
  [13957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4640),
  [13959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4640),
  [13961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4614),
  [13963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4614),
  [13965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4503),
  [13967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4503),
  [13969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4459),
  [13971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4459),
  [13973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1471),
  [13975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1471),
  [13977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4594),
  [13979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4594),
  [13981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4587),
  [13983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4587),
  [13985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1474),
  [13987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1474),
  [13989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1459),
  [13991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1459),
  [13993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4558),
  [13995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4558),
  [13997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4593),
  [13999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4593),
  [14001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4611),
  [14003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4611),
  [14005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4590),
  [14007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4590),
  [14009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4458),
  [14011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4458),
  [14013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4626),
  [14015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4626),
  [14017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4606),
  [14019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4606),
  [14021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1457),
  [14023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1457),
  [14025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4592),
  [14027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4592),
  [14029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4445),
  [14031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4445),
  [14033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4448),
  [14035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4448),
  [14037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4589),
  [14039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4589),
  [14041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1472),
  [14043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1472),
  [14045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4569),
  [14047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4569),
  [14049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4568),
  [14051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4568),
  [14053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1467),
  [14055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1467),
  [14057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4567),
  [14059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4567),
  [14061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4605),
  [14063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4605),
  [14065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4564),
  [14067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4564),
  [14069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1466),
  [14071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1466),
  [14073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4544),
  [14075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4544),
  [14077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4540),
  [14079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4540),
  [14081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1449),
  [14083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1449),
  [14085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1458),
  [14087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1458),
  [14089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4449),
  [14091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4449),
  [14093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(684),
  [14095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [14097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(683),
  [14099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [14101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4545),
  [14103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4545),
  [14105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4450),
  [14107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4450),
  [14109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4547),
  [14111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4547),
  [14113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4543),
  [14115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4543),
  [14117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4464),
  [14119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4464),
  [14121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4548),
  [14123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4548),
  [14125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4636),
  [14127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4636),
  [14129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4542),
  [14131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4542),
  [14133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4539),
  [14135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4539),
  [14137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4637),
  [14139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4637),
  [14141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1872),
  [14143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1872),
  [14145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4650),
  [14147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4650),
  [14149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4519),
  [14151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4519),
  [14153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4467),
  [14155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4467),
  [14157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1870),
  [14159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1870),
  [14161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4518),
  [14163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4518),
  [14165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4468),
  [14167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4468),
  [14169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4517),
  [14171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4517),
  [14173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4414),
  [14175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4414),
  [14177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4623),
  [14179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4623),
  [14181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1878),
  [14183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1878),
  [14185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4651),
  [14187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4651),
  [14189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4401),
  [14191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4401),
  [14193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4514),
  [14195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4514),
  [14197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4469),
  [14199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4469),
  [14201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4624),
  [14203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4624),
  [14205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(831),
  [14207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(831),
  [14209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4625),
  [14211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4625),
  [14213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4494),
  [14215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4494),
  [14217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(823),
  [14219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(823),
  [14221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4627),
  [14223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4627),
  [14225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(822),
  [14227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
  [14229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4489),
  [14231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4489),
  [14233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4426),
  [14235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4426),
  [14237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4493),
  [14239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4493),
  [14241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4429),
  [14243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4429),
  [14245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4492),
  [14247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4492),
  [14249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(680),
  [14251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [14253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4707),
  [14255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4386),
  [14257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4706),
  [14259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4369),
  [14261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4714),
  [14263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4372),
  [14265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4727),
  [14267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4634),
  [14269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4704),
  [14271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3607),
  [14273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3606),
  [14275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3605),
  [14277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3605),
  [14279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3461),
  [14281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3582),
  [14283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3582),
  [14285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3581),
  [14287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3578),
  [14289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3581),
  [14291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3578),
  [14293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3577),
  [14295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3577),
  [14297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3576),
  [14299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3576),
  [14301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3575),
  [14303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3574),
  [14305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3573),
  [14307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4370),
  [14309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4321),
  [14311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1399),
  [14313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1397),
  [14315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1395),
  [14317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4353),
  [14319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4366),
  [14321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4364),
  [14323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4349),
  [14325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4728),
  [14327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4283),
  [14329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4295),
  [14331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4297),
  [14333] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(4386),
  [14336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3539),
  [14338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3543),
  [14340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3549),
  [14342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3549),
  [14344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3551),
  [14346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3555),
  [14348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3555),
  [14350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3563),
  [14352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3565),
  [14354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3563),
  [14356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3565),
  [14358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3748),
  [14360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3748),
  [14362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3615),
  [14364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3615),
  [14366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3617),
  [14368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3638),
  [14370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3645),
  [14372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4371),
  [14374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1478),
  [14376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1529),
  [14378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1604),
  [14380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3541),
  [14382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3926),
  [14384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [14386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [14388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(467),
  [14390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3981),
  [14392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [14394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [14396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [14398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [14400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [14402] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_with_default, 3, 0, 32),
  [14404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [14406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [14408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3036),
  [14410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3055),
  [14412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [14414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3090),
  [14416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [14418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [14420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [14422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3100),
  [14424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3146),
  [14426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3148),
  [14428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3150),
  [14430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3152),
  [14432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3166),
  [14434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3170),
  [14436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3173),
  [14438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [14440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [14442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3176),
  [14444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [14446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3178),
  [14448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3186),
  [14450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3194),
  [14452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3197),
  [14454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [14456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3029),
  [14458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3233),
  [14460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [14462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [14464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [14466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3271),
  [14468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3274),
  [14470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3303),
  [14472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3310),
  [14474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3313),
  [14476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3315),
  [14478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3317),
  [14480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3331),
  [14482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3348),
  [14484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3364),
  [14486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3370),
  [14488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3373),
  [14490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [14492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [14494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [14496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3378),
  [14498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3380),
  [14500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3413),
  [14502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [14504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3415),
  [14506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3421),
  [14508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [14510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [14512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [14514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3423),
  [14516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3429),
  [14518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3431),
  [14520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3440),
  [14522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3447),
  [14524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [14526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3481),
  [14528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3485),
  [14530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3511),
  [14532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3519),
  [14534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3535),
  [14536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3546),
  [14538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3554),
  [14540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3557),
  [14542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3561),
  [14544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3564),
  [14546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3571),
  [14548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3579),
  [14550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [14552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [14554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3869),
  [14556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [14558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [14560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [14562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [14564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3883),
  [14566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [14568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [14570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [14572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [14574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [14576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [14578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [14580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [14582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [14584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [14586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [14588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [14590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [14592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [14594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [14596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [14598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [14600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [14602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [14604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [14606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [14608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [14610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [14612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [14614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [14616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [14618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [14620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [14622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [14624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [14626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [14628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [14630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [14632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [14634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [14636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [14638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [14640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [14642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [14644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [14646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [14648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [14650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [14652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [14654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [14656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [14658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [14660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [14662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [14664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [14666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [14668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [14670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [14672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [14674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(442),
  [14676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [14678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [14680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [14682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [14684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [14686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [14688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [14690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [14692] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(4634),
  [14695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [14697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [14699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [14701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [14703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [14705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [14707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [14709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [14711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [14713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [14715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [14717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [14719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [14721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [14723] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument, 1, 0, 22),
  [14725] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument, 1, 0, 22),
  [14727] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_call_arguments_repeat1, 1, 0, 20),
  [14729] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 1, 0, 20),
  [14731] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__argument, 1, 0, 21),
  [14733] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__argument, 1, 0, 21),
  [14735] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument, 1, 0, 23),
  [14737] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument, 1, 0, 23),
  [14739] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__argument_unnamed, 1, 0, 23),
  [14741] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__argument_unnamed, 1, 0, 23),
  [14743] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__argument_named, 3, 0, 39),
  [14745] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__argument_named, 3, 0, 39),
  [14747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4695),
  [14749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4697),
  [14751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4719),
  [14753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4717),
  [14755] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(4693),
  [14758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5109),
  [14760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5145),
  [14762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2294),
  [14764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2856),
  [14766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2783),
  [14768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2947),
  [14770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3020),
  [14772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2535),
  [14774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3016),
  [14776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2583),
  [14778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2963),
  [14780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2446),
  [14782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2822),
  [14784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2850),
  [14786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2598),
  [14788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2743),
  [14790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2829),
  [14792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2709),
  [14794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2918),
  [14796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2393),
  [14798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2848),
  [14800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2689),
  [14802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2723),
  [14804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2511),
  [14806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2301),
  [14808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2924),
  [14810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2285),
  [14812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2431),
  [14814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4758),
  [14816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2926),
  [14818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5121),
  [14820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4266),
  [14822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2479),
  [14824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5118),
  [14826] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [14828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2395),
  [14830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5123),
  [14832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2396),
  [14834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2482),
  [14836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4262),
  [14838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2564),
  [14840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2297),
  [14842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2334),
  [14844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2298),
  [14846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2335),
  [14848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2800),
  [14850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4765),
  [14852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4091),
  [14854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2276),
  [14856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2277),
  [14858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5164),
  [14860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2718),
  [14862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2278),
  [14864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2279),
  [14866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4775),
  [14868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5163),
  [14870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2344),
  [14872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2345),
  [14874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2930),
  [14876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5162),
  [14878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2390),
  [14880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4261),
  [14882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2386),
  [14884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4783),
  [14886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5160),
  [14888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2308),
  [14890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2280),
  [14892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2282),
  [14894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2314),
  [14896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4785),
  [14898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4093),
  [14900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2542),
  [14902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2636),
  [14904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5186),
  [14906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2198),
  [14908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2207),
  [14910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4094),
  [14912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2825),
  [14914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4795),
  [14916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5196),
  [14918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2216),
  [14920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2217),
  [14922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4798),
  [14924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4095),
  [14926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2477),
  [14928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2741),
  [14930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2459),
  [14932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4123),
  [14934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5202),
  [14936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5245),
  [14938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4114),
  [14940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4096),
  [14942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2429),
  [14944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2658),
  [14946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2688),
  [14948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2190),
  [14950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2191),
  [14952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2428),
  [14954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4808),
  [14956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5211),
  [14958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2291),
  [14960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2292),
  [14962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4811),
  [14964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4101),
  [14966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2682),
  [14968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2548),
  [14970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2295),
  [14972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2296),
  [14974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5214),
  [14976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2204),
  [14978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2229),
  [14980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2549),
  [14982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4102),
  [14984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4826),
  [14986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5218),
  [14988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2486),
  [14990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2483),
  [14992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4830),
  [14994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4103),
  [14996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2868),
  [14998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2897),
  [15000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2887),
  [15002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2905),
  [15004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5232),
  [15006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2728),
  [15008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4105),
  [15010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2223),
  [15012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2224),
  [15014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4839),
  [15016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5237),
  [15018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2702),
  [15020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4810),
  [15022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4245),
  [15024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2194),
  [15026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2228),
  [15028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2307),
  [15030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2736),
  [15032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2973),
  [15034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2710),
  [15036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4841),
  [15038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4106),
  [15040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2565),
  [15042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5239),
  [15044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2306),
  [15046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2563),
  [15048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2998),
  [15050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4107),
  [15052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2059),
  [15054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2060),
  [15056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4855),
  [15058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5241),
  [15060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4859),
  [15062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4108),
  [15064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2075),
  [15066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2076),
  [15068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2929),
  [15070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2170),
  [15072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5243),
  [15074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2826),
  [15076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2172),
  [15078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2874),
  [15080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2988),
  [15082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4111),
  [15084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2644),
  [15086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2300),
  [15088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4868),
  [15090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5244),
  [15092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1943),
  [15094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1947),
  [15096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4873),
  [15098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4115),
  [15100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2559),
  [15102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2115),
  [15104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2116),
  [15106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2560),
  [15108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2299),
  [15110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5246),
  [15112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2367),
  [15114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4116),
  [15116] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2185),
  [15118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4890),
  [15120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4154),
  [15122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4160),
  [15124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2186),
  [15126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4885),
  [15128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5248),
  [15130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4887),
  [15132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4117),
  [15134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2674),
  [15136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5249),
  [15138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2984),
  [15140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2642),
  [15142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2956),
  [15144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4900),
  [15146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4271),
  [15148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4277),
  [15150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2691),
  [15152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4119),
  [15154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4895),
  [15156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5250),
  [15158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4902),
  [15160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4120),
  [15162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4906),
  [15164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4298),
  [15166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4304),
  [15168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2368),
  [15170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5251),
  [15172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2573),
  [15174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4121),
  [15176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4912),
  [15178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4325),
  [15180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4331),
  [15182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2566),
  [15184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4908),
  [15186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5252),
  [15188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4685),
  [15190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4910),
  [15192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4122),
  [15194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4918),
  [15196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4350),
  [15198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4356),
  [15200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2631),
  [15202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5253),
  [15204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2616),
  [15206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4124),
  [15208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4924),
  [15210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4352),
  [15212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4342),
  [15214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2630),
  [15216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4920),
  [15218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5254),
  [15220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2409),
  [15222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4922),
  [15224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4127),
  [15226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4930),
  [15228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4310),
  [15230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4307),
  [15232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2497),
  [15234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5255),
  [15236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2499),
  [15238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4128),
  [15240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4936),
  [15242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4230),
  [15244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4193),
  [15246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4932),
  [15248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5257),
  [15250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4934),
  [15252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4129),
  [15254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5259),
  [15256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4130),
  [15258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4942),
  [15260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4243),
  [15262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4242),
  [15264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2546),
  [15266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4939),
  [15268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5260),
  [15270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2544),
  [15272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4940),
  [15274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4133),
  [15276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4948),
  [15278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4251),
  [15280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4273),
  [15282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5262),
  [15284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4134),
  [15286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2719),
  [15288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4949),
  [15290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5264),
  [15292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4954),
  [15294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4313),
  [15296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4314),
  [15298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4950),
  [15300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4142),
  [15302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5266),
  [15304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2666),
  [15306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4146),
  [15308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4960),
  [15310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4335),
  [15312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4344),
  [15314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2405),
  [15316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4956),
  [15318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5267),
  [15320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4668),
  [15322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4958),
  [15324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4147),
  [15326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4966),
  [15328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4363),
  [15330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4367),
  [15332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5269),
  [15334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4148),
  [15336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2177),
  [15338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4967),
  [15340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5270),
  [15342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4972),
  [15344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4354),
  [15346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4348),
  [15348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2176),
  [15350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4968),
  [15352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4149),
  [15354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5185),
  [15356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4150),
  [15358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4978),
  [15360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4339),
  [15362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4338),
  [15364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2258),
  [15366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4975),
  [15368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5181),
  [15370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2255),
  [15372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4976),
  [15374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4151),
  [15376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4984),
  [15378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4322),
  [15380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4320),
  [15382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4809),
  [15384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5258),
  [15386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5268),
  [15388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2773),
  [15390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4153),
  [15392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4990),
  [15394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4315),
  [15396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4312),
  [15398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4986),
  [15400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5265),
  [15402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4988),
  [15404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4155),
  [15406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2239),
  [15408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5263),
  [15410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4996),
  [15412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4296),
  [15414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4294),
  [15416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2238),
  [15418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4156),
  [15420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4994),
  [15422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5261),
  [15424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4998),
  [15426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4157),
  [15428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5002),
  [15430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4290),
  [15432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4287),
  [15434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2413),
  [15436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5256),
  [15438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2175),
  [15440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4158),
  [15442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5008),
  [15444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4281),
  [15446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4272),
  [15448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2447),
  [15450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5004),
  [15452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5242),
  [15454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2174),
  [15456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5006),
  [15458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4161),
  [15460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4760),
  [15462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4267),
  [15464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5240),
  [15466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4163),
  [15468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5014),
  [15470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5238),
  [15472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2699),
  [15474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5015),
  [15476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4171),
  [15478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5020),
  [15480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4259),
  [15482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4258),
  [15484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2669),
  [15486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5220),
  [15488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2389),
  [15490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4172),
  [15492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5026),
  [15494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4250),
  [15496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4248),
  [15498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2387),
  [15500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5022),
  [15502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5206),
  [15504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2911),
  [15506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5024),
  [15508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4173),
  [15510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5032),
  [15512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4236),
  [15514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4235),
  [15516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4692),
  [15518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5192),
  [15520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4175),
  [15522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5034),
  [15524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5215),
  [15526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5038),
  [15528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4227),
  [15530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4225),
  [15532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2558),
  [15534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5035),
  [15536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4176),
  [15538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2366),
  [15540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5161),
  [15542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5044),
  [15544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4217),
  [15546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4216),
  [15548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4177),
  [15550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5042),
  [15552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5165),
  [15554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2450),
  [15556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5045),
  [15558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4178),
  [15560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5050),
  [15562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4197),
  [15564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4195),
  [15566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5166),
  [15568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4179),
  [15570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2461),
  [15572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5051),
  [15574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5167),
  [15576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5052),
  [15578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4181),
  [15580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2937),
  [15582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4675),
  [15584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2879),
  [15586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5168),
  [15588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4182),
  [15590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2547),
  [15592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5059),
  [15594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5170),
  [15596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2033),
  [15598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5060),
  [15600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4183),
  [15602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2247),
  [15604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4807),
  [15606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4249),
  [15608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2253),
  [15610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4688),
  [15612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2031),
  [15614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2568),
  [15616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4686),
  [15618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2577),
  [15620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2992),
  [15622] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__double_quoted_string_content, 2, 0, 0),
  [15624] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__double_quoted_string_content, 2, 0, 0), SHIFT_REPEAT(5118),
  [15627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2262),
  [15629] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__single_quoted_string_content, 2, 0, 0),
  [15631] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__single_quoted_string_content, 2, 0, 0), SHIFT_REPEAT(5123),
  [15634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2263),
  [15636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2434),
  [15638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2008),
  [15640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2433),
  [15642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2424),
  [15644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3007),
  [15646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2884),
  [15648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4655),
  [15650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2004),
  [15652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2423),
  [15654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2375),
  [15656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4670),
  [15658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2376),
  [15660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2484),
  [15662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2481),
  [15664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2817),
  [15666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4740),
  [15668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4750),
  [15670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4755),
  [15672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4744),
  [15674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4756),
  [15676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4743),
  [15678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4733),
  [15680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4745),
  [15682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4748),
  [15684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4735),
  [15686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4749),
  [15688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4739),
  [15690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4737),
  [15692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4736),
  [15694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3989),
  [15696] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_without_default, 1, 0, 12),
  [15698] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, 0, 35), SHIFT_REPEAT(4758),
  [15701] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, 0, 35),
  [15703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4746),
  [15705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4752),
  [15707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4753),
  [15709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4754),
  [15711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4738),
  [15713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4757),
  [15715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4732),
  [15717] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__double_quoted_string_content, 1, 0, 0),
  [15719] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__double_quoted_string_content, 1, 0, 0),
  [15721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4747),
  [15723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4742),
  [15725] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(5121),
  [15728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4751),
  [15730] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__single_quoted_string_content, 1, 0, 0),
  [15732] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__single_quoted_string_content, 1, 0, 0),
  [15734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4741),
  [15736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4734),
  [15738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2205),
  [15740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2205),
  [15742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1890),
  [15744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1890),
  [15746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2168),
  [15748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2168),
  [15750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4373),
  [15752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4373),
  [15754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2197),
  [15756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2197),
  [15758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(993),
  [15760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(993),
  [15762] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 1, 0, 14),
  [15764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2182),
  [15766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2182),
  [15768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1968),
  [15770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1968),
  [15772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2251),
  [15774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2251),
  [15776] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 1, 0, 13),
  [15778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1111),
  [15780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1111),
  [15782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2203),
  [15784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2203),
  [15786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1586),
  [15788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1586),
  [15790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1338),
  [15792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1338),
  [15794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2305),
  [15796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2305),
  [15798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2202),
  [15800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2202),
  [15802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2215),
  [15804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2215),
  [15806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2123),
  [15808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2123),
  [15810] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, 0, 33),
  [15812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2143),
  [15814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2143),
  [15816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2353),
  [15818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2353),
  [15820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1563),
  [15822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1563),
  [15824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2036),
  [15826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2036),
  [15828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(968),
  [15830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(968),
  [15832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2338),
  [15834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2338),
  [15836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2173),
  [15838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2173),
  [15840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1336),
  [15842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1336),
  [15844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4379),
  [15846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4379),
  [15848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2098),
  [15850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2098),
  [15852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2161),
  [15854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2161),
  [15856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4253),
  [15858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4241),
  [15860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5174),
  [15862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5229),
  [15864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5173),
  [15866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5172),
  [15868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5171),
  [15870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5230),
  [15872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5231),
  [15874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5233),
  [15876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5234),
  [15878] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [15880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5236),
  [15882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4190),
  [15884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4192),
  [15886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4206),
  [15888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4215),
  [15890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4220),
  [15892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4222),
  [15894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4228),
  [15896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4234),
  [15898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4238),
  [15900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4246),
  [15902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5213),
  [15904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4256),
  [15906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4089),
  [15908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4264),
  [15910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5212),
  [15912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5175),
  [15914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4268),
  [15916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4270),
  [15918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4284),
  [15920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4286),
  [15922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4291),
  [15924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5227),
  [15926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4292),
  [15928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4300),
  [15930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4305),
  [15932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5176),
  [15934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4317),
  [15936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4318),
  [15938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4324),
  [15940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4334),
  [15942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4343),
  [15944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5177),
  [15946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4346),
  [15948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4359),
  [15950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4365),
  [15952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5226),
  [15954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4355),
  [15956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4347),
  [15958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4332),
  [15960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4328),
  [15962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5178),
  [15964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4308),
  [15966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4289),
  [15968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5179),
  [15970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5228),
  [15972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4213),
  [15974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4244),
  [15976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5180),
  [15978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4118),
  [15980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5225),
  [15982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4288),
  [15984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4301),
  [15986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4337),
  [15988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4340),
  [15990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4361),
  [15992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4358),
  [15994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4336),
  [15996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4333),
  [15998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4309),
  [16000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4306),
  [16002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4282),
  [16004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5158),
  [16006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4279),
  [16008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4166),
  [16010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4126),
  [16012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4162),
  [16014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5182),
  [16016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5224),
  [16018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5183),
  [16020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5223),
  [16022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5184),
  [16024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5222),
  [16026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5187),
  [16028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5188),
  [16030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5235),
  [16032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5189),
  [16034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4104),
  [16036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5190),
  [16038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5191),
  [16040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5193),
  [16042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5194),
  [16044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5195),
  [16046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5197),
  [16048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5198),
  [16050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5199),
  [16052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5221),
  [16054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5200),
  [16056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5247),
  [16058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5201),
  [16060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5203),
  [16062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5219),
  [16064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5204),
  [16066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5217),
  [16068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5205),
  [16070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5216),
  [16072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5207),
  [16074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5208),
  [16076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5159),
  [16078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5209),
  [16080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5210),
};

enum ts_external_scanner_symbol_identifiers {
  ts_external_token__newline = 0,
  ts_external_token__semicolon = 1,
  ts_external_token__raw_string_literal = 2,
  ts_external_token__external_else = 3,
  ts_external_token__external_open_parenthesis = 4,
  ts_external_token__external_close_parenthesis = 5,
  ts_external_token__external_open_brace = 6,
  ts_external_token__external_close_brace = 7,
  ts_external_token__external_open_bracket = 8,
  ts_external_token__external_close_bracket = 9,
  ts_external_token__external_open_bracket2 = 10,
  ts_external_token__external_close_bracket2 = 11,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__newline] = sym__newline,
  [ts_external_token__semicolon] = sym__semicolon,
  [ts_external_token__raw_string_literal] = sym__raw_string_literal,
  [ts_external_token__external_else] = sym__external_else,
  [ts_external_token__external_open_parenthesis] = sym__external_open_parenthesis,
  [ts_external_token__external_close_parenthesis] = sym__external_close_parenthesis,
  [ts_external_token__external_open_brace] = sym__external_open_brace,
  [ts_external_token__external_close_brace] = sym__external_close_brace,
  [ts_external_token__external_open_bracket] = sym__external_open_bracket,
  [ts_external_token__external_close_bracket] = sym__external_close_bracket,
  [ts_external_token__external_open_bracket2] = sym__external_open_bracket2,
  [ts_external_token__external_close_bracket2] = sym__external_close_bracket2,
};

static const bool ts_external_scanner_states[44][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__newline] = true,
    [ts_external_token__semicolon] = true,
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_else] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_close_parenthesis] = true,
    [ts_external_token__external_open_brace] = true,
    [ts_external_token__external_close_brace] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_close_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
    [ts_external_token__external_close_bracket2] = true,
  },
  [2] = {
    [ts_external_token__newline] = true,
    [ts_external_token__semicolon] = true,
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_open_brace] = true,
  },
  [3] = {
    [ts_external_token__newline] = true,
    [ts_external_token__semicolon] = true,
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_else] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_close_parenthesis] = true,
    [ts_external_token__external_open_brace] = true,
    [ts_external_token__external_close_brace] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
  },
  [4] = {
    [ts_external_token__newline] = true,
    [ts_external_token__semicolon] = true,
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_else] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_close_parenthesis] = true,
    [ts_external_token__external_open_brace] = true,
    [ts_external_token__external_close_brace] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_close_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
  },
  [5] = {
    [ts_external_token__newline] = true,
    [ts_external_token__semicolon] = true,
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_else] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_close_parenthesis] = true,
    [ts_external_token__external_open_brace] = true,
    [ts_external_token__external_close_brace] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
    [ts_external_token__external_close_bracket2] = true,
  },
  [6] = {
    [ts_external_token__newline] = true,
    [ts_external_token__semicolon] = true,
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_close_parenthesis] = true,
    [ts_external_token__external_open_brace] = true,
    [ts_external_token__external_close_brace] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_close_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
  },
  [7] = {
    [ts_external_token__newline] = true,
    [ts_external_token__semicolon] = true,
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_close_parenthesis] = true,
    [ts_external_token__external_open_brace] = true,
    [ts_external_token__external_close_brace] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
  },
  [8] = {
    [ts_external_token__newline] = true,
    [ts_external_token__semicolon] = true,
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_else] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_open_brace] = true,
    [ts_external_token__external_close_brace] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
    [ts_external_token__external_close_bracket2] = true,
  },
  [9] = {
    [ts_external_token__newline] = true,
    [ts_external_token__semicolon] = true,
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_else] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_open_brace] = true,
    [ts_external_token__external_close_brace] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_close_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
  },
  [10] = {
    [ts_external_token__newline] = true,
    [ts_external_token__semicolon] = true,
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_close_parenthesis] = true,
    [ts_external_token__external_open_brace] = true,
    [ts_external_token__external_close_brace] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
    [ts_external_token__external_close_bracket2] = true,
  },
  [11] = {
    [ts_external_token__newline] = true,
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_else] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_close_parenthesis] = true,
    [ts_external_token__external_open_brace] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_close_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
  },
  [12] = {
    [ts_external_token__newline] = true,
    [ts_external_token__semicolon] = true,
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_open_brace] = true,
    [ts_external_token__external_close_brace] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_close_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
  },
  [13] = {
    [ts_external_token__newline] = true,
    [ts_external_token__semicolon] = true,
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_else] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_close_parenthesis] = true,
    [ts_external_token__external_open_brace] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
  },
  [14] = {
    [ts_external_token__newline] = true,
    [ts_external_token__semicolon] = true,
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_else] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_open_brace] = true,
    [ts_external_token__external_close_brace] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
  },
  [15] = {
    [ts_external_token__newline] = true,
    [ts_external_token__semicolon] = true,
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_open_brace] = true,
    [ts_external_token__external_close_brace] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
    [ts_external_token__external_close_bracket2] = true,
  },
  [16] = {
    [ts_external_token__newline] = true,
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_else] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_close_parenthesis] = true,
    [ts_external_token__external_open_brace] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
    [ts_external_token__external_close_bracket2] = true,
  },
  [17] = {
    [ts_external_token__newline] = true,
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_else] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_close_parenthesis] = true,
    [ts_external_token__external_open_brace] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
  },
  [18] = {
    [ts_external_token__newline] = true,
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_close_parenthesis] = true,
    [ts_external_token__external_open_brace] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
    [ts_external_token__external_close_bracket2] = true,
  },
  [19] = {
    [ts_external_token__newline] = true,
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_close_parenthesis] = true,
    [ts_external_token__external_open_brace] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_close_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
  },
  [20] = {
    [ts_external_token__newline] = true,
    [ts_external_token__semicolon] = true,
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_open_brace] = true,
    [ts_external_token__external_close_brace] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
  },
  [21] = {
    [ts_external_token__newline] = true,
    [ts_external_token__semicolon] = true,
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_close_parenthesis] = true,
    [ts_external_token__external_open_brace] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
  },
  [22] = {
    [ts_external_token__newline] = true,
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_else] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_open_brace] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_close_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
  },
  [23] = {
    [ts_external_token__newline] = true,
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_else] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_open_brace] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
    [ts_external_token__external_close_bracket2] = true,
  },
  [24] = {
    [ts_external_token__newline] = true,
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_close_parenthesis] = true,
    [ts_external_token__external_open_brace] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
  },
  [25] = {
    [ts_external_token__newline] = true,
    [ts_external_token__semicolon] = true,
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_else] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_open_brace] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
  },
  [26] = {
    [ts_external_token__newline] = true,
    [ts_external_token__semicolon] = true,
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_open_brace] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
  },
  [27] = {
    [ts_external_token__newline] = true,
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_open_brace] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
    [ts_external_token__external_close_bracket2] = true,
  },
  [28] = {
    [ts_external_token__newline] = true,
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_open_brace] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_close_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
  },
  [29] = {
    [ts_external_token__newline] = true,
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_open_brace] = true,
    [ts_external_token__external_close_bracket] = true,
  },
  [30] = {
    [ts_external_token__newline] = true,
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_open_brace] = true,
    [ts_external_token__external_close_bracket2] = true,
  },
  [31] = {
    [ts_external_token__newline] = true,
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_close_parenthesis] = true,
    [ts_external_token__external_open_brace] = true,
  },
  [32] = {
    [ts_external_token__newline] = true,
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_open_brace] = true,
  },
  [33] = {
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_close_parenthesis] = true,
    [ts_external_token__external_open_brace] = true,
  },
  [34] = {
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_open_brace] = true,
  },
  [35] = {
    [ts_external_token__newline] = true,
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_else] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_close_parenthesis] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
  },
  [36] = {
    [ts_external_token__newline] = true,
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_close_parenthesis] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
  },
  [37] = {
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_else] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_close_parenthesis] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
  },
  [38] = {
    [ts_external_token__external_else] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_close_parenthesis] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
  },
  [39] = {
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_close_parenthesis] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
  },
  [40] = {
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_close_parenthesis] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
  },
  [41] = {
    [ts_external_token__external_close_parenthesis] = true,
  },
  [42] = {
    [ts_external_token__newline] = true,
    [ts_external_token__external_open_parenthesis] = true,
  },
  [43] = {
    [ts_external_token__external_open_parenthesis] = true,
  },
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_r_external_scanner_create(void);
void tree_sitter_r_external_scanner_destroy(void *);
bool tree_sitter_r_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_r_external_scanner_serialize(void *, char *);
void tree_sitter_r_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_r(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_r_external_scanner_create,
      tree_sitter_r_external_scanner_destroy,
      tree_sitter_r_external_scanner_scan,
      tree_sitter_r_external_scanner_serialize,
      tree_sitter_r_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
